(* ::Package:: *)

ClearAll[data,Consts,Kinds,DataNames];

Consts = {"big", "big_flat"};
Kinds = {"CanonicalStructuresFlatHOAS", "CanonicalStructuresFlatPHOAS", "CanonicalStructuresHOAS", "CanonicalStructuresPHOAS", "Ltac2", "Ltac2LowLevel", "LtacPrimUncurry", "LtacTCExplicitCtx", "LtacTCGallinaCtx", "LtacTCPrimPair", "LtacTacInTermExplicitCtx", "LtacTacInTermGallinaCtx", "LtacTacInTermPrimPair", "Mtac2", "OCaml", "Parametricity; beta", "Parsing", "ParsingElaborated", "QuoteFlat", "TemplateCoq", "TypeClasses", "TypeClassesBodyFlatPHOAS", "TypeClassesBodyHOAS", "beta; Parametricity", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing elaborated", "parsing", "printing", "refine let", "simpl Denote", "transitivity"};
DataNames = {"Aggregate", "Stats", "actual reif", "cbv", "eval lazy", "intros _", "lazy beta iota", "norm reif", "post", "postprocess", "pre", "reif"};

KindsSortedFor["big"]["Aggregate"] = {"CanonicalStructuresPHOAS", "CanonicalStructuresHOAS", "TypeClasses", "Mtac2", "LtacPrimUncurry", "Ltac2", "LtacTCGallinaCtx", "LtacTacInTermPrimPair", "LtacTacInTermGallinaCtx", "LtacTacInTermExplicitCtx", "LtacTCPrimPair", "TypeClassesBodyHOAS", "LtacTCExplicitCtx", "TemplateCoq", "beta; Parametricity", "Ltac2LowLevel", "OCaml", "Parametricity; beta", "Parsing", "ParsingElaborated", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};
KindsSortedFor["big"]["Stats"] = {"parsing", "printing", "identity native_compute", "parsing elaborated", "simpl Denote", "cbn Denote", "cbv Denote", "lazy Denote", "identity simpl", "identity cbn", "transitivity", "identity vm_compute", "identity lazy", "identity cbv", "refine let", "CanonicalStructuresHOAS", "CanonicalStructuresPHOAS", "Ltac2", "Ltac2LowLevel", "LtacPrimUncurry", "LtacTCExplicitCtx", "LtacTCGallinaCtx", "LtacTCPrimPair", "LtacTacInTermExplicitCtx", "LtacTacInTermGallinaCtx", "LtacTacInTermPrimPair", "Mtac2", "OCaml", "Parametricity; beta", "Parsing", "ParsingElaborated", "TemplateCoq", "TypeClasses", "TypeClassesBodyHOAS", "beta; Parametricity"};
KindsSortedFor["big"]["actual reif"] = {"CanonicalStructuresPHOAS", "CanonicalStructuresHOAS", "TypeClasses", "Mtac2", "LtacPrimUncurry", "Ltac2", "LtacTCGallinaCtx", "LtacTacInTermPrimPair", "LtacTacInTermGallinaCtx", "LtacTacInTermExplicitCtx", "LtacTCPrimPair", "TypeClassesBodyHOAS", "LtacTCExplicitCtx", "Parsing", "ParsingElaborated", "TemplateCoq", "beta; Parametricity", "Ltac2LowLevel", "Parametricity; beta", "OCaml", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};
KindsSortedFor["big"]["cbv"] = {"Mtac2", "TypeClasses", "LtacPrimUncurry", "CanonicalStructuresHOAS", "CanonicalStructuresPHOAS", "TemplateCoq", "Ltac2", "LtacTCPrimPair", "LtacTacInTermPrimPair", "LtacTacInTermExplicitCtx", "TypeClassesBodyHOAS", "LtacTacInTermGallinaCtx", "LtacTCExplicitCtx", "LtacTCGallinaCtx", "beta; Parametricity", "OCaml", "Ltac2LowLevel", "Parametricity; beta", "Parsing", "ParsingElaborated", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};
KindsSortedFor["big"]["eval lazy"] = {"CanonicalStructuresPHOAS", "TypeClasses", "LtacPrimUncurry", "CanonicalStructuresHOAS", "Mtac2", "TypeClassesBodyHOAS", "TemplateCoq", "LtacTCPrimPair", "Ltac2", "LtacTCExplicitCtx", "LtacTacInTermExplicitCtx", "LtacTCGallinaCtx", "LtacTacInTermGallinaCtx", "LtacTacInTermPrimPair", "beta; Parametricity", "Ltac2LowLevel", "Parametricity; beta", "OCaml", "Parsing", "ParsingElaborated", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};
KindsSortedFor["big"]["intros _"] = {"CanonicalStructuresPHOAS", "CanonicalStructuresHOAS", "Ltac2", "Ltac2LowLevel", "LtacPrimUncurry", "LtacTCExplicitCtx", "LtacTCGallinaCtx", "LtacTCPrimPair", "LtacTacInTermExplicitCtx", "LtacTacInTermGallinaCtx", "LtacTacInTermPrimPair", "Mtac2", "OCaml", "Parametricity; beta", "Parsing", "ParsingElaborated", "TemplateCoq", "TypeClasses", "TypeClassesBodyHOAS", "beta; Parametricity", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};
KindsSortedFor["big"]["lazy beta iota"] = {"CanonicalStructuresHOAS", "Mtac2", "LtacPrimUncurry", "CanonicalStructuresPHOAS", "TypeClasses", "TemplateCoq", "LtacTCGallinaCtx", "Ltac2", "LtacTCPrimPair", "LtacTacInTermGallinaCtx", "LtacTCExplicitCtx", "TypeClassesBodyHOAS", "LtacTacInTermPrimPair", "LtacTacInTermExplicitCtx", "OCaml", "Parametricity; beta", "beta; Parametricity", "Ltac2LowLevel", "Parsing", "ParsingElaborated", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};
KindsSortedFor["big"]["norm reif"] = {"CanonicalStructuresPHOAS", "CanonicalStructuresHOAS", "TypeClasses", "Mtac2", "LtacPrimUncurry", "Ltac2", "LtacTCGallinaCtx", "LtacTacInTermPrimPair", "LtacTacInTermGallinaCtx", "LtacTacInTermExplicitCtx", "LtacTCPrimPair", "TypeClassesBodyHOAS", "LtacTCExplicitCtx", "Parsing", "ParsingElaborated", "TemplateCoq", "beta; Parametricity", "Parametricity; beta", "OCaml", "Ltac2LowLevel", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};
KindsSortedFor["big"]["post"] = {"TypeClasses", "LtacPrimUncurry", "CanonicalStructuresHOAS", "CanonicalStructuresPHOAS", "Mtac2", "TypeClassesBodyHOAS", "LtacTacInTermExplicitCtx", "TemplateCoq", "Ltac2", "LtacTCExplicitCtx", "LtacTCGallinaCtx", "LtacTCPrimPair", "LtacTacInTermGallinaCtx", "LtacTacInTermPrimPair", "Parametricity; beta", "Ltac2LowLevel", "OCaml", "beta; Parametricity", "Parsing", "ParsingElaborated", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};
KindsSortedFor["big"]["postprocess"] = {"CanonicalStructuresHOAS", "CanonicalStructuresPHOAS", "Ltac2", "Ltac2LowLevel", "LtacPrimUncurry", "LtacTCExplicitCtx", "LtacTCGallinaCtx", "LtacTCPrimPair", "LtacTacInTermExplicitCtx", "LtacTacInTermGallinaCtx", "LtacTacInTermPrimPair", "Mtac2", "OCaml", "Parametricity; beta", "Parsing", "ParsingElaborated", "TemplateCoq", "TypeClasses", "TypeClassesBodyHOAS", "beta; Parametricity", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};
KindsSortedFor["big"]["pre"] = {"CanonicalStructuresPHOAS", "CanonicalStructuresHOAS", "LtacPrimUncurry", "Mtac2", "TypeClasses", "Ltac2", "LtacTCExplicitCtx", "LtacTCGallinaCtx", "LtacTCPrimPair", "LtacTacInTermExplicitCtx", "LtacTacInTermGallinaCtx", "LtacTacInTermPrimPair", "TemplateCoq", "TypeClassesBodyHOAS", "Ltac2LowLevel", "OCaml", "Parametricity; beta", "beta; Parametricity", "Parsing", "ParsingElaborated", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};
KindsSortedFor["big"]["reif"] = {"CanonicalStructuresPHOAS", "CanonicalStructuresHOAS", "TypeClasses", "Mtac2", "LtacPrimUncurry", "Ltac2", "LtacTCGallinaCtx", "LtacTacInTermPrimPair", "LtacTacInTermGallinaCtx", "LtacTacInTermExplicitCtx", "LtacTCPrimPair", "TypeClassesBodyHOAS", "LtacTCExplicitCtx", "Parsing", "ParsingElaborated", "TemplateCoq", "beta; Parametricity", "Ltac2LowLevel", "Parametricity; beta", "OCaml", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};

data["big"]["CanonicalStructuresHOAS"]["Aggregate"]["real"] = {{1,0.00200909}, {2,0.00200909}, {3,0.00300000}, {4,0.00398182}, {5,0.00490909}, {6,0.00600000}, {7,0.00716364}, {8,0.00907273}, {9,0.01050000}, {10,0.01301818}, {11,0.01623636}, {12,0.01819091}, {13,0.02230000}, {14,0.02513636}, {15,0.02933636}, {16,0.03384545}, {17,0.03909091}, {18,0.04451818}, {19,0.05082727}, {20,0.05773636}, {21,0.06878182}, {22,0.07679091}, {23,0.08575455}, {24,0.09366364}, {25,0.10324545}, {26,0.11447273}, {27,0.12786364}, {28,0.13957273}, {29,0.15457273}, {30,0.16720909}, {31,0.18466364}, {32,0.19942727}, {33,0.21696364}, {34,0.23667273}, {35,0.25223636}, {36,0.27604545}, {37,0.29532727}, {38,0.31854545}, {39,0.34230909}, {40,0.36201818}, {41,0.38918182}, {42,0.41826364}, {43,0.44256364}, {44,0.47114545}, {45,0.50233636}, {46,0.53494545}, {47,0.56933636}, {48,0.60513636}, {49,0.64226364}, {50,0.67848182}, {51,0.71805455}, {52,0.75788182}, {53,0.80189091}, {54,0.84686364}, {55,0.89373636}, {56,0.93760909}, {57,1.00338182}, {58,1.04961818}, {59,1.10368182}, {60,1.14344545}, {61,1.24625}, {62,1.29150}, {63,1.33550}, {64,1.40325}, {65,1.46900}, {66,1.52875}, {67,1.59125}, {68,1.66775}, {69,1.72800}, {70,1.80775}, {71,1.89150}, {72,1.94825}, {73,2.02925}, {74,2.12100}, {75,2.21125}, {76,2.29325}, {77,2.40550}, {78,2.47675}, {79,2.57600}, {80,2.65975}, {81,2.77300}, {82,2.87975}, {83,2.97075}, {84,3.11150}, {85,3.18900}, {86,3.32425}, {87,3.44875}, {88,3.54025}, {89,3.70925}, {90,3.77550}, {91,3.92450}, {92,4.08800}, {93,4.14925}, {94,4.35525}, {95,4.47200}, {96,4.56275}, {97,4.71150}, {98,4.94975}, {99,5.08625}, {100,5.26500}, {101,5.39550}, {102,5.57325}, {103,5.99550}, {104,5.92075}, {105,6.06725}, {106,6.24100}, {107,6.44500}, {108,6.61575}, {109,6.81400}, {110,7.08000}, {111,7.27950}, {112,7.54275}, {113,7.69600}, {114,7.95325}, {115,8.10000}, {116,8.34700}, {117,8.59250}, {118,8.79225}, {119,9.01475}, {120,9.26400}, {121,9.43125}, {122,9.71325}, {123,9.99600}, {124,10.24675}, {125,10.31825}, {126,10.66300}, {127,10.88075}, {128,11.33425}, {129,11.31875}, {130,11.57950}, {131,12.07525}, {132,12.26225}, {133,12.66375}, {134,12.97000}, {135,13.28975}, {136,13.62925}, {137,13.90650}, {138,14.16300}, {139,14.46900}, {140,14.63975}, {141,15.03525}, {142,15.55700}, {143,15.77425}, {144,16.30200}, {145,16.56000}, {146,16.89150}, {147,17.23200}, {148,17.66275}, {149,18.25525}, {150,18.59625}, {151,18.79875}, {152,19.14100}, {153,19.68500}, {154,19.81275}, {155,20.36825}, {156,20.82875}, {157,21.06600}, {158,21.69150}, {159,21.95900}, {160,22.47275}, {161,22.62675}, {162,23.28325}, {163,23.94900}, {164,24.42725}, {165,24.49575}, {166,25.37450}, {167,25.41275}, {168,26.13700}, {169,26.37150}, {170,27.20475}, {171,27.57025}, {172,28.09800}, {173,28.72800}, {174,29.05050}, {175,29.45175}, {176,30.19625}, {177,30.87775}, {178,31.09050}, {179,32.21600}, {180,32.80100}, {181,33.42475}, {182,33.70850}, {183,34.35975}, {184,35.15775}, {185,35.67750}, {186,36.12850}, {187,36.93600}, {188,37.70750}, {189,38.52850}, {190,38.54850}, {191,39.16125}, {192,39.94400}, {193,40.09100}, {194,41.15550}, {195,41.87425}, {196,42.53150}, {197,42.78200}, {198,43.50825}, {199,44.86725}, {200,44.63033}, {201,47.3120}, {202,47.5385}, {203,50.317}, {204,49.879}, {205,50.659}, {206,52.932}, {207,52.231}, {208,53.016}, {209,55.233}, {210,54.771}, {211,55.938}, {212,56.384}, {213,57.29}, {214,58.295}, {215,59.222}, {216,58.592}, {217,60.383}, {218,60.43}, {219,62.162}, {220,62.061}, {221,64.032}, {222,63.943}, {223,65.084}, {224,67.561}, {225,67.018}, {226,68.946}, {227,68.498}, {228,69.73}, {229,72.769}, {230,71.888}, {231,73.227}, {232,74.767}, {233,75.22}, {234,77.103}, {235,78.47}, {236,79.5}, {237,78.927}, {238,79.981}, {239,80.303}, {240,82.338}, {241,83.448}, {242,83.437}, {243,86.237}, {244,83.222}, {245,82.499}, {246,85.67}, {247,86.071}, {248,87.141}, {249,87.527}, {250,87.651}, {251,90.595}, {252,91.751}, {253,91.683}, {254,92.967}, {255,98.685}, {256,100.943}, {257,101.998}, {258,102.616}, {259,105.072}, {260,105.963}, {261,103.075}, {262,108.541}, {263,108.442}, {264,109.495}, {265,112.034}, {266,112.409}, {267,114.084}, {268,115.218}, {269,117.431}, {270,120.1}, {271,120.051}, {272,123.044}, {273,121.992}, {274,124.045}, {275,125.015}, {276,126.396}, {277,127.628}, {278,131.171}, {279,132.593}, {280,132.899}};
data["big"]["CanonicalStructuresHOAS"]["Aggregate"]["user"] = {{1,0.00199091}, {2,0.00248182}, {3,0.00306364}, {4,0.00389091}, {5,0.00474545}, {6,0.00613636}, {7,0.00705455}, {8,0.00905455}, {9,0.01066364}, {10,0.01290909}, {11,0.01620909}, {12,0.01785455}, {13,0.02231818}, {14,0.02536364}, {15,0.02929091}, {16,0.03344545}, {17,0.03894545}, {18,0.04455455}, {19,0.05083636}, {20,0.05786364}, {21,0.06875455}, {22,0.07710000}, {23,0.08595455}, {24,0.09388182}, {25,0.10311818}, {26,0.11398182}, {27,0.12775455}, {28,0.13937273}, {29,0.15457273}, {30,0.16729091}, {31,0.18410000}, {32,0.19942727}, {33,0.21718182}, {34,0.23639091}, {35,0.25237273}, {36,0.27607273}, {37,0.29523636}, {38,0.31858182}, {39,0.34207273}, {40,0.36200000}, {41,0.38917273}, {42,0.41803636}, {43,0.44250000}, {44,0.47110909}, {45,0.50245455}, {46,0.53442727}, {47,0.56936364}, {48,0.60505455}, {49,0.64241818}, {50,0.67798182}, {51,0.71826364}, {52,0.75795455}, {53,0.80177273}, {54,0.84669091}, {55,0.89333636}, {56,0.93736364}, {57,1.00306364}, {58,1.04972727}, {59,1.10312727}, {60,1.14339091}, {61,1.24650}, {62,1.29125}, {63,1.33450}, {64,1.40200}, {65,1.46725}, {66,1.52950}, {67,1.59200}, {68,1.66800}, {69,1.72775}, {70,1.80775}, {71,1.89125}, {72,1.94750}, {73,2.02925}, {74,2.12150}, {75,2.21075}, {76,2.29350}, {77,2.40575}, {78,2.47750}, {79,2.57450}, {80,2.65950}, {81,2.77225}, {82,2.87975}, {83,2.97100}, {84,3.11225}, {85,3.18775}, {86,3.32250}, {87,3.45050}, {88,3.53875}, {89,3.70925}, {90,3.77525}, {91,3.92425}, {92,4.08875}, {93,4.14900}, {94,4.35625}, {95,4.47125}, {96,4.56250}, {97,4.71275}, {98,4.94975}, {99,5.08575}, {100,5.26425}, {101,5.39325}, {102,5.56875}, {103,5.99100}, {104,5.91850}, {105,6.06450}, {106,6.23900}, {107,6.44075}, {108,6.61100}, {109,6.80950}, {110,7.07550}, {111,7.27650}, {112,7.53800}, {113,7.69250}, {114,7.95175}, {115,8.09725}, {116,8.34475}, {117,8.58975}, {118,8.78925}, {119,9.01350}, {120,9.26050}, {121,9.42925}, {122,9.71400}, {123,9.99550}, {124,10.24525}, {125,10.31525}, {126,10.66225}, {127,10.88175}, {128,11.33450}, {129,11.31850}, {130,11.57875}, {131,12.07325}, {132,12.26250}, {133,12.65950}, {134,12.96750}, {135,13.28675}, {136,13.62500}, {137,13.90075}, {138,14.15850}, {139,14.46950}, {140,14.63925}, {141,15.03550}, {142,15.55550}, {143,15.77575}, {144,16.30125}, {145,16.56050}, {146,16.88775}, {147,17.23050}, {148,17.66400}, {149,18.25450}, {150,18.59625}, {151,18.79875}, {152,19.14150}, {153,19.65675}, {154,19.81125}, {155,20.36575}, {156,20.82725}, {157,21.06275}, {158,21.69150}, {159,21.95850}, {160,22.47250}, {161,22.62750}, {162,23.28150}, {163,23.94625}, {164,24.09125}, {165,24.49475}, {166,25.37450}, {167,25.41225}, {168,26.13500}, {169,26.37250}, {170,27.20500}, {171,27.56925}, {172,28.09725}, {173,28.72675}, {174,29.04950}, {175,29.45175}, {176,30.19725}, {177,30.87650}, {178,31.08875}, {179,32.21375}, {180,32.80175}, {181,33.42425}, {182,33.71050}, {183,34.35725}, {184,35.15850}, {185,35.67775}, {186,36.12950}, {187,36.93125}, {188,37.70525}, {189,38.52950}, {190,38.54875}, {191,39.16100}, {192,39.94250}, {193,40.09200}, {194,41.15375}, {195,41.87325}, {196,42.53050}, {197,42.78150}, {198,43.50175}, {199,44.86400}, {200,44.62900}, {201,47.0280}, {202,47.4295}, {203,50.307}, {204,49.823}, {205,50.66}, {206,52.931}, {207,52.228}, {208,53.015}, {209,55.231}, {210,54.771}, {211,55.94}, {212,56.384}, {213,57.291}, {214,58.295}, {215,59.224}, {216,58.592}, {217,60.384}, {218,60.431}, {219,62.163}, {220,62.059}, {221,64.032}, {222,63.943}, {223,65.083}, {224,67.563}, {225,67.015}, {226,68.947}, {227,68.5}, {228,69.728}, {229,72.768}, {230,71.887}, {231,73.224}, {232,74.768}, {233,75.219}, {234,77.103}, {235,78.471}, {236,79.5}, {237,78.927}, {238,79.979}, {239,80.304}, {240,82.335}, {241,83.448}, {242,83.424}, {243,86.236}, {244,83.224}, {245,82.5}, {246,85.667}, {247,86.072}, {248,87.139}, {249,87.507}, {250,87.639}, {251,90.595}, {252,91.752}, {253,91.68}, {254,92.963}, {255,98.688}, {256,100.943}, {257,101.996}, {258,102.615}, {259,105.072}, {260,105.963}, {261,103.076}, {262,108.54}, {263,108.435}, {264,109.495}, {265,112.031}, {266,112.412}, {267,114.084}, {268,115.219}, {269,117.432}, {270,120.099}, {271,120.051}, {272,123.043}, {273,121.991}, {274,124.048}, {275,125.015}, {276,126.396}, {277,125.955}, {278,131.172}, {279,132.592}, {280,132.9}};
data["big"]["CanonicalStructuresHOAS"]["Aggregate"]["system"] = {{1,0.00000000}, {2,0.00003636}, {3,0.00003636}, {4,0.00007273}, {5,0.00003636}, {6,0.00000000}, {7,0.00010909}, {8,0.00000000}, {9,0.00000000}, {10,0.00014545}, {11,0.00002727}, {12,0.00010909}, {13,0.00010909}, {14,0.00007273}, {15,0.00003636}, {16,0.00007273}, {17,0.00003636}, {18,0.00014545}, {19,0.00003636}, {20,0.00003636}, {21,0.00003636}, {22,0.00003636}, {23,0.00003636}, {24,0.00000000}, {25,0.00007273}, {26,0.00003636}, {27,0.00007273}, {28,0.00003636}, {29,0.00014545}, {30,0.00010909}, {31,0.00021818}, {32,0.00007273}, {33,0.00003636}, {34,0.00003636}, {35,0.00010909}, {36,0.00007273}, {37,0.00003636}, {38,0.00000000}, {39,0.00010909}, {40,0.00014545}, {41,0.00010909}, {42,0.00010909}, {43,0.00007273}, {44,0.00007273}, {45,0.00003636}, {46,0.00020909}, {47,0.00010909}, {48,0.00007273}, {49,0.00010909}, {50,0.00014545}, {51,0.00007273}, {52,0.00003636}, {53,0.00020909}, {54,0.00010909}, {55,0.00000000}, {56,0.00007273}, {57,0.00025455}, {58,0.00007273}, {59,0.00007273}, {60,0.00018182}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00100}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00100}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00100}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00100}, {100,0.00000}, {101,0.00100}, {102,0.00100}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00175}, {110,0.00100}, {111,0.00000}, {112,0.00100}, {113,0.00000}, {114,0.00000}, {115,0.00100}, {116,0.00100}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00100}, {121,0.00100}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00300}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00100}, {134,0.00000}, {135,0.00100}, {136,0.00000}, {137,0.00175}, {138,0.00100}, {139,0.00000}, {140,0.00100}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00100}, {146,0.00300}, {147,0.00000}, {148,0.00000}, {149,0.00100}, {150,0.00000}, {151,0.00100}, {152,0.00000}, {153,0.00100}, {154,0.00000}, {155,0.00300}, {156,0.00100}, {157,0.00300}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00100}, {163,0.00100}, {164,0.00100}, {165,0.00100}, {166,0.00000}, {167,0.00000}, {168,0.00100}, {169,0.00000}, {170,0.00100}, {171,0.00100}, {172,0.00100}, {173,0.00000}, {174,0.00000}, {175,0.00100}, {176,0.00000}, {177,0.00100}, {178,0.00100}, {179,0.00100}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00200}, {184,0.00100}, {185,0.00000}, {186,0.00000}, {187,0.00500}, {188,0.00175}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00100}, {193,0.00100}, {194,0.00200}, {195,0.00000}, {196,0.00100}, {197,0.00100}, {198,0.00500}, {199,0.00375}, {200,0.00000}, {201,0.0175}, {202,0.0020}, {203,0}, {204,0.011}, {205,0}, {206,0}, {207,0.004}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0.004}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0.012}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0.019}, {250,0.012}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00100000}, {4,0.00200000}, {5,0.00300000}, {6,0.00400000}, {7,0.00501818}, {8,0.00667273}, {9,0.00820000}, {10,0.01047273}, {11,0.01408182}, {12,0.01595455}, {13,0.02000000}, {14,0.02280000}, {15,0.02704545}, {16,0.03124545}, {17,0.03649091}, {18,0.04210909}, {19,0.04823636}, {20,0.05480909}, {21,0.06610909}, {22,0.07411818}, {23,0.08303636}, {24,0.09089091}, {25,0.10038182}, {26,0.11155455}, {27,0.12496364}, {28,0.13662727}, {29,0.15158182}, {30,0.16420000}, {31,0.18147273}, {32,0.19630909}, {33,0.21381818}, {34,0.23347273}, {35,0.24894545}, {36,0.27268182}, {37,0.29195455}, {38,0.31524545}, {39,0.33890909}, {40,0.35862727}, {41,0.38570000}, {42,0.41479091}, {43,0.43901818}, {44,0.46753636}, {45,0.49862727}, {46,0.53124545}, {47,0.56565455}, {48,0.60143636}, {49,0.63840000}, {50,0.67460000}, {51,0.71409091}, {52,0.75389091}, {53,0.79786364}, {54,0.84280909}, {55,0.88957273}, {56,0.93346364}, {57,0.99920909}, {58,1.04534545}, {59,1.09942727}, {60,1.13917273}, {61,1.24125}, {62,1.28725}, {63,1.33150}, {64,1.39850}, {65,1.46450}, {66,1.52400}, {67,1.58625}, {68,1.66100}, {69,1.72300}, {70,1.80350}, {71,1.88625}, {72,1.94325}, {73,2.02400}, {74,2.11550}, {75,2.20625}, {76,2.28825}, {77,2.40050}, {78,2.47100}, {79,2.57050}, {80,2.65450}, {81,2.76700}, {82,2.87400}, {83,2.96525}, {84,3.10625}, {85,3.18300}, {86,3.31875}, {87,3.44300}, {88,3.53400}, {89,3.70400}, {90,3.76975}, {91,3.91875}, {92,4.08175}, {93,4.14300}, {94,4.34750}, {95,4.46575}, {96,4.55675}, {97,4.70325}, {98,4.94275}, {99,5.07975}, {100,5.25825}, {101,5.38925}, {102,5.56650}, {103,5.98925}, {104,5.91450}, {105,6.06075}, {106,6.23475}, {107,6.43850}, {108,6.60900}, {109,6.80700}, {110,7.07300}, {111,7.27225}, {112,7.53575}, {113,7.68900}, {114,7.94625}, {115,8.09300}, {116,8.34000}, {117,8.58525}, {118,8.78475}, {119,9.00750}, {120,9.25575}, {121,9.42425}, {122,9.70550}, {123,9.98800}, {124,10.23875}, {125,10.31050}, {126,10.65525}, {127,10.87275}, {128,11.32625}, {129,11.31100}, {130,11.57075}, {131,12.06750}, {132,12.25400}, {133,12.65575}, {134,12.96175}, {135,13.28150}, {136,13.62100}, {137,13.89700}, {138,14.15400}, {139,14.46050}, {140,14.63075}, {141,15.02725}, {142,15.54825}, {143,15.76550}, {144,16.29300}, {145,16.55150}, {146,16.88225}, {147,17.22275}, {148,17.65425}, {149,18.24600}, {150,18.58625}, {151,18.78975}, {152,19.13175}, {153,19.67575}, {154,19.80350}, {155,20.35900}, {156,20.81950}, {157,21.05675}, {158,21.68175}, {159,21.94950}, {160,22.46175}, {161,22.61750}, {162,23.27325}, {163,23.93950}, {164,24.41625}, {165,24.48650}, {166,25.36475}, {167,25.40175}, {168,26.12725}, {169,26.36050}, {170,27.19475}, {171,27.56025}, {172,28.08800}, {173,28.71600}, {174,29.04000}, {175,29.44100}, {176,30.18575}, {177,30.86575}, {178,31.07900}, {179,32.20400}, {180,32.79050}, {181,33.41400}, {182,33.69700}, {183,34.34875}, {184,35.14700}, {185,35.66650}, {186,36.11750}, {187,36.92500}, {188,37.69625}, {189,38.51750}, {190,38.53725}, {191,39.14900}, {192,39.93125}, {193,40.08000}, {194,41.14425}, {195,41.86275}, {196,42.51975}, {197,42.76850}, {198,43.49650}, {199,44.85525}, {200,44.61800}, {201,47.2610}, {202,47.5255}, {203,50.305}, {204,49.867}, {205,50.646}, {206,52.915}, {207,52.219}, {208,53.003}, {209,55.22}, {210,54.758}, {211,55.925}, {212,56.371}, {213,57.277}, {214,58.281}, {215,59.209}, {216,58.579}, {217,60.37}, {218,60.416}, {219,62.149}, {220,62.047}, {221,64.018}, {222,63.929}, {223,65.07}, {224,67.547}, {225,67.004}, {226,68.931}, {227,68.484}, {228,69.716}, {229,72.755}, {230,71.873}, {231,73.204}, {232,74.752}, {233,75.205}, {234,77.088}, {235,78.455}, {236,79.479}, {237,78.912}, {238,79.966}, {239,80.288}, {240,82.323}, {241,83.426}, {242,83.422}, {243,86.222}, {244,83.207}, {245,82.48}, {246,85.65}, {247,86.056}, {248,87.125}, {249,87.512}, {250,87.635}, {251,90.58}, {252,91.735}, {253,91.667}, {254,92.951}, {255,98.668}, {256,100.927}, {257,101.981}, {258,102.6}, {259,105.056}, {260,105.947}, {261,103.052}, {262,108.524}, {263,108.412}, {264,109.478}, {265,112.012}, {266,112.392}, {267,114.067}, {268,115.2}, {269,117.414}, {270,120.083}, {271,120.034}, {272,123.027}, {273,121.974}, {274,124.027}, {275,124.998}, {276,126.378}, {277,127.61}, {278,131.152}, {279,132.575}, {280,132.881}};
data["big"]["CanonicalStructuresHOAS"]["actual reif"]["user"] = {{1,0.00040909}, {2,0.00076364}, {3,0.00170000}, {4,0.00220000}, {5,0.00307273}, {6,0.00405455}, {7,0.00492727}, {8,0.00659091}, {9,0.00832727}, {10,0.01086364}, {11,0.01395455}, {12,0.01585455}, {13,0.01974545}, {14,0.02315455}, {15,0.02704545}, {16,0.03137273}, {17,0.03687273}, {18,0.04170909}, {19,0.04862727}, {20,0.05515455}, {21,0.06598182}, {22,0.07424545}, {23,0.08327273}, {24,0.09079091}, {25,0.10040909}, {26,0.11161818}, {27,0.12508182}, {28,0.13661818}, {29,0.15143636}, {30,0.16398182}, {31,0.18127273}, {32,0.19656364}, {33,0.21370909}, {34,0.23346364}, {35,0.24883636}, {36,0.27242727}, {37,0.29209091}, {38,0.31542727}, {39,0.33913636}, {40,0.35843636}, {41,0.38584545}, {42,0.41448182}, {43,0.43870000}, {44,0.46733636}, {45,0.49894545}, {46,0.53071818}, {47,0.56580000}, {48,0.60108182}, {49,0.63846364}, {50,0.67442727}, {51,0.71415455}, {52,0.75350909}, {53,0.79768182}, {54,0.84261818}, {55,0.88945455}, {56,0.93350000}, {57,0.99891818}, {58,1.04532727}, {59,1.09950909}, {60,1.13900909}, {61,1.24050}, {62,1.28550}, {63,1.33125}, {64,1.39950}, {65,1.46225}, {66,1.52450}, {67,1.58675}, {68,1.66025}, {69,1.72175}, {70,1.80450}, {71,1.88625}, {72,1.94375}, {73,2.02500}, {74,2.11725}, {75,2.20650}, {76,2.28925}, {77,2.40050}, {78,2.47300}, {79,2.57025}, {80,2.65425}, {81,2.76925}, {82,2.87300}, {83,2.96525}, {84,3.10675}, {85,3.18150}, {86,3.31750}, {87,3.44250}, {88,3.53350}, {89,3.70225}, {90,3.76975}, {91,3.91850}, {92,4.08150}, {93,4.14275}, {94,4.34750}, {95,4.46650}, {96,4.55600}, {97,4.70350}, {98,4.94025}, {99,5.08050}, {100,5.25775}, {101,5.38650}, {102,5.56375}, {103,5.98625}, {104,5.91225}, {105,6.05750}, {106,6.23250}, {107,6.43550}, {108,6.60550}, {109,6.80175}, {110,7.06975}, {111,7.26950}, {112,7.53150}, {113,7.68525}, {114,7.94350}, {115,8.09175}, {116,8.33625}, {117,8.58425}, {118,8.78450}, {119,9.00550}, {120,9.25250}, {121,9.42050}, {122,9.70525}, {123,9.98750}, {124,10.23875}, {125,10.30825}, {126,10.65450}, {127,10.87250}, {128,11.32650}, {129,11.31075}, {130,11.57275}, {131,12.06775}, {132,12.25550}, {133,12.65250}, {134,12.95850}, {135,13.27725}, {136,13.61875}, {137,13.89150}, {138,14.14875}, {139,14.46050}, {140,14.62900}, {141,15.02650}, {142,15.54950}, {143,15.76575}, {144,16.29250}, {145,16.54825}, {146,16.87950}, {147,17.22375}, {148,17.65450}, {149,18.24525}, {150,18.58525}, {151,18.78875}, {152,19.13175}, {153,19.64675}, {154,19.80450}, {155,20.35650}, {156,20.81775}, {157,21.05375}, {158,21.68150}, {159,21.94925}, {160,22.46050}, {161,22.61750}, {162,23.27125}, {163,23.93825}, {164,24.08100}, {165,24.48575}, {166,25.36525}, {167,25.40125}, {168,26.12700}, {169,26.35925}, {170,27.19375}, {171,27.55950}, {172,28.08750}, {173,28.71675}, {174,29.04050}, {175,29.43975}, {176,30.18675}, {177,30.86400}, {178,31.07850}, {179,32.20225}, {180,32.79050}, {181,33.41350}, {182,33.69775}, {183,34.34850}, {184,35.14475}, {185,35.66550}, {186,36.11950}, {187,36.91925}, {188,37.69425}, {189,38.51875}, {190,38.53875}, {191,39.14850}, {192,39.92950}, {193,40.07750}, {194,41.14375}, {195,41.86250}, {196,42.51725}, {197,42.76650}, {198,43.49025}, {199,44.85050}, {200,44.61933}, {201,46.9760}, {202,47.4160}, {203,50.292}, {204,49.812}, {205,50.644}, {206,52.915}, {207,52.216}, {208,53.004}, {209,55.22}, {210,54.759}, {211,55.923}, {212,56.371}, {213,57.275}, {214,58.28}, {215,59.207}, {216,58.579}, {217,60.372}, {218,60.416}, {219,62.148}, {220,62.047}, {221,64.019}, {222,63.931}, {223,65.072}, {224,67.547}, {225,67.003}, {226,68.931}, {227,68.484}, {228,69.716}, {229,72.752}, {230,71.876}, {231,73.208}, {232,74.752}, {233,75.203}, {234,77.087}, {235,78.456}, {236,79.476}, {237,78.912}, {238,79.967}, {239,80.287}, {240,82.324}, {241,83.427}, {242,83.407}, {243,86.219}, {244,83.207}, {245,82.479}, {246,85.648}, {247,86.056}, {248,87.128}, {249,87.492}, {250,87.623}, {251,90.579}, {252,91.736}, {253,91.664}, {254,92.951}, {255,98.668}, {256,100.927}, {257,101.979}, {258,102.599}, {259,105.056}, {260,105.943}, {261,103.051}, {262,108.523}, {263,108.407}, {264,109.48}, {265,112.011}, {266,112.391}, {267,114.067}, {268,115.2}, {269,117.416}, {270,120.083}, {271,120.036}, {272,123.027}, {273,121.976}, {274,124.028}, {275,125.}, {276,126.376}, {277,125.939}, {278,131.152}, {279,132.576}, {280,132.879}};
data["big"]["CanonicalStructuresHOAS"]["actual reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00003636}, {5,0.00000000}, {6,0.00000000}, {7,0.00007273}, {8,0.00000000}, {9,0.00000000}, {10,0.00010909}, {11,0.00002727}, {12,0.00010909}, {13,0.00003636}, {14,0.00000000}, {15,0.00003636}, {16,0.00007273}, {17,0.00003636}, {18,0.00010909}, {19,0.00000000}, {20,0.00003636}, {21,0.00000000}, {22,0.00003636}, {23,0.00000000}, {24,0.00000000}, {25,0.00003636}, {26,0.00003636}, {27,0.00000000}, {28,0.00000000}, {29,0.00010909}, {30,0.00003636}, {31,0.00010909}, {32,0.00003636}, {33,0.00003636}, {34,0.00000000}, {35,0.00007273}, {36,0.00003636}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00007273}, {41,0.00007273}, {42,0.00010909}, {43,0.00003636}, {44,0.00003636}, {45,0.00000000}, {46,0.00014545}, {47,0.00007273}, {48,0.00007273}, {49,0.00003636}, {50,0.00003636}, {51,0.00003636}, {52,0.00000000}, {53,0.00003636}, {54,0.00010909}, {55,0.00000000}, {56,0.00003636}, {57,0.00014545}, {58,0.00003636}, {59,0.00003636}, {60,0.00007273}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00100}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00100}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00100}, {100,0.00000}, {101,0.00100}, {102,0.00100}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00075}, {110,0.00100}, {111,0.00000}, {112,0.00100}, {113,0.00000}, {114,0.00000}, {115,0.00100}, {116,0.00100}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00100}, {121,0.00100}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00200}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00100}, {134,0.00000}, {135,0.00100}, {136,0.00000}, {137,0.00175}, {138,0.00100}, {139,0.00000}, {140,0.00100}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00100}, {146,0.00300}, {147,0.00000}, {148,0.00000}, {149,0.00100}, {150,0.00000}, {151,0.00100}, {152,0.00000}, {153,0.00100}, {154,0.00000}, {155,0.00300}, {156,0.00100}, {157,0.00300}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00100}, {163,0.00100}, {164,0.00100}, {165,0.00100}, {166,0.00000}, {167,0.00000}, {168,0.00100}, {169,0.00000}, {170,0.00100}, {171,0.00000}, {172,0.00100}, {173,0.00000}, {174,0.00000}, {175,0.00100}, {176,0.00000}, {177,0.00100}, {178,0.00100}, {179,0.00100}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00200}, {184,0.00100}, {185,0.00000}, {186,0.00000}, {187,0.00500}, {188,0.00175}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00100}, {193,0.00100}, {194,0.00200}, {195,0.00000}, {196,0.00100}, {197,0.00100}, {198,0.00500}, {199,0.00375}, {200,0.00000}, {201,0.0175}, {202,0.0020}, {203,0}, {204,0.011}, {205,0}, {206,0}, {207,0.004}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0.012}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0.019}, {250,0.012}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00100}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0.006}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0.005}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00003636}, {3,0.00000000}, {4,0.00003636}, {5,0.00002727}, {6,0.00003636}, {7,0.00002727}, {8,0.00000000}, {9,0.00014545}, {10,0.00000000}, {11,0.00010000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00007273}, {18,0.00000000}, {19,0.00007273}, {20,0.00002727}, {21,0.00007273}, {22,0.00007273}, {23,0.00000000}, {24,0.00003636}, {25,0.00003636}, {26,0.00007273}, {27,0.00003636}, {28,0.00018182}, {29,0.00007273}, {30,0.00010909}, {31,0.00000000}, {32,0.00017273}, {33,0.00024545}, {34,0.00000000}, {35,0.00010000}, {36,0.00010000}, {37,0.00007273}, {38,0.00010909}, {39,0.00005455}, {40,0.00010909}, {41,0.00003636}, {42,0.00010000}, {43,0.00014545}, {44,0.00016364}, {45,0.00013636}, {46,0.00003636}, {47,0.00014545}, {48,0.00003636}, {49,0.00010909}, {50,0.00009091}, {51,0.00010000}, {52,0.00007273}, {53,0.00010000}, {54,0.00018182}, {55,0.00009091}, {56,0.00024545}, {57,0.00002727}, {58,0.00006364}, {59,0.00003636}, {60,0.00014545}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00075}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00075}, {77,0.00000}, {78,0.00075}, {79,0.00000}, {80,0.00000}, {81,0.00075}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00100}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00150}, {95,0.00000}, {96,0.00000}, {97,0.00075}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00075}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00075}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00075}, {111,0.00000}, {112,0.00000}, {113,0.00100}, {114,0.00000}, {115,0.00000}, {116,0.00075}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00075}, {126,0.00000}, {127,0.00075}, {128,0.00075}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00075}, {140,0.00000}, {141,0.00000}, {142,0.00075}, {143,0.00150}, {144,0.00000}, {145,0.00075}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00075}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00075}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00075}, {167,0.00075}, {168,0.00075}, {169,0.00075}, {170,0.00075}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00075}, {176,0.00000}, {177,0.00075}, {178,0.00075}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00075}, {184,0.00000}, {185,0.00075}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00175}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00100}, {195,0.00000}, {196,0.00075}, {197,0.00000}, {198,0.00000}, {199,0.00100}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0.004}, {204,0}, {205,0.004}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0.003}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0.004}, {235,0}, {236,0.007}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0.003}, {250,0}, {251,0.004}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0.007}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0.003}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0.004}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00002727}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00100}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["eval lazy"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003636}, {4,0.00003636}, {5,0.00006364}, {6,0.00020909}, {7,0.00003636}, {8,0.00006364}, {9,0.00003636}, {10,0.00000000}, {11,0.00007273}, {12,0.00000000}, {13,0.00003636}, {14,0.00017273}, {15,0.00000000}, {16,0.00006364}, {17,0.00014545}, {18,0.00010909}, {19,0.00013636}, {20,0.00010909}, {21,0.00014545}, {22,0.00014545}, {23,0.00003636}, {24,0.00015455}, {25,0.00010000}, {26,0.00010000}, {27,0.00005455}, {28,0.00000000}, {29,0.00010909}, {30,0.00017273}, {31,0.00010000}, {32,0.00017273}, {33,0.00016364}, {34,0.00009091}, {35,0.00024545}, {36,0.00024545}, {37,0.00006364}, {38,0.00013636}, {39,0.00010000}, {40,0.00020000}, {41,0.00003636}, {42,0.00039091}, {43,0.00026364}, {44,0.00021818}, {45,0.00019091}, {46,0.00010909}, {47,0.00006364}, {48,0.00020909}, {49,0.00028182}, {50,0.00014545}, {51,0.00028182}, {52,0.00031818}, {53,0.00010909}, {54,0.00021818}, {55,0.00027273}, {56,0.00020909}, {57,0.00014545}, {58,0.00014545}, {59,0.00021818}, {60,0.00010909}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00100}, {69,0.00100}, {70,0.00000}, {71,0.00100}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00100}, {89,0.00150}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00075}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00100}, {110,0.00000}, {111,0.00075}, {112,0.00075}, {113,0.00000}, {114,0.00075}, {115,0.00000}, {116,0.00075}, {117,0.00100}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00075}, {124,0.00000}, {125,0.00000}, {126,0.00100}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00075}, {135,0.00000}, {136,0.00000}, {137,0.00100}, {138,0.00150}, {139,0.00000}, {140,0.00000}, {141,0.00175}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00150}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00075}, {151,0.00075}, {152,0.00000}, {153,0.00150}, {154,0.00150}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00075}, {161,0.00000}, {162,0.00000}, {163,0.00150}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00075}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00075}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00075}, {191,0.00100}, {192,0.00175}, {193,0.00100}, {194,0.00000}, {195,0.00075}, {196,0.00000}, {197,0.00000}, {198,0.00100}, {199,0.00000}, {200,0.00000}, {201,0.0020}, {202,0.0015}, {203,0.003}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0.003}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0.003}, {230,0}, {231,0}, {232,0.003}, {233,0.003}, {234,0}, {235,0}, {236,0.003}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0.003}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0.003}, {252,0.004}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0.004}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0.004}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0.004}, {277,0.004}, {278,0.004}, {279,0}, {280,0.004}};
data["big"]["CanonicalStructuresHOAS"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00007273}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00100}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["intros _"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["intros _"]["user"] = {{1,0.00003636}, {2,0.00000000}, {3,0.00003636}, {4,0.00000000}, {5,0.00002727}, {6,0.00003636}, {7,0.00000000}, {8,0.00000000}, {9,0.00003636}, {10,0.00021818}, {11,0.00000000}, {12,0.00007273}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00003636}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00003636}, {21,0.00000000}, {22,0.00003636}, {23,0.00000000}, {24,0.00003636}, {25,0.00007273}, {26,0.00006364}, {27,0.00003636}, {28,0.00003636}, {29,0.00003636}, {30,0.00014545}, {31,0.00003636}, {32,0.00003636}, {33,0.00003636}, {34,0.00000000}, {35,0.00007273}, {36,0.00000000}, {37,0.00003636}, {38,0.00003636}, {39,0.00003636}, {40,0.00010909}, {41,0.00000000}, {42,0.00003636}, {43,0.00010909}, {44,0.00003636}, {45,0.00003636}, {46,0.00003636}, {47,0.00003636}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00003636}, {52,0.00000000}, {53,0.00003636}, {54,0.00000000}, {55,0.00000000}, {56,0.00006364}, {57,0.00010000}, {58,0.00000000}, {59,0.00003636}, {60,0.00007273}, {61,0.00000}, {62,0.00000}, {63,0.00100}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00075}, {83,0.00000}, {84,0.00000}, {85,0.00075}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00075}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00075}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00075}, {127,0.00000}, {128,0.00000}, {129,0.00075}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00150}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00075}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00100}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00075}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00200}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00100}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00100}, {201,0.0000}, {202,0.0000}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0.003}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0.004}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["intros _"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00003636}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["lazy beta iota"]["user"] = {{1,0.00003636}, {2,0.00000000}, {3,0.00000000}, {4,0.00007273}, {5,0.00000000}, {6,0.00000000}, {7,0.00003636}, {8,0.00000000}, {9,0.00000000}, {10,0.00003636}, {11,0.00002727}, {12,0.00003636}, {13,0.00000000}, {14,0.00000000}, {15,0.00007273}, {16,0.00003636}, {17,0.00000000}, {18,0.00000000}, {19,0.00007273}, {20,0.00002727}, {21,0.00000000}, {22,0.00000000}, {23,0.00006364}, {24,0.00003636}, {25,0.00005455}, {26,0.00003636}, {27,0.00007273}, {28,0.00000000}, {29,0.00003636}, {30,0.00003636}, {31,0.00002727}, {32,0.00002727}, {33,0.00003636}, {34,0.00006364}, {35,0.00006364}, {36,0.00003636}, {37,0.00007273}, {38,0.00000000}, {39,0.00003636}, {40,0.00000000}, {41,0.00000000}, {42,0.00003636}, {43,0.00000000}, {44,0.00000000}, {45,0.00010000}, {46,0.00007273}, {47,0.00010000}, {48,0.00013636}, {49,0.00007273}, {50,0.00003636}, {51,0.00003636}, {52,0.00002727}, {53,0.00003636}, {54,0.00000000}, {55,0.00000000}, {56,0.00010909}, {57,0.00000000}, {58,0.00014545}, {59,0.00010000}, {60,0.00014545}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00100}, {97,0.00000}, {98,0.00075}, {99,0.00075}, {100,0.00075}, {101,0.00100}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00075}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00100}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00075}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00100}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00075}, {156,0.00075}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00075}, {165,0.00075}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00175}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0.003}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0.004}, {250,0.003}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0.004}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0.004}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0.004}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00100000}, {3,0.00100000}, {4,0.00200000}, {5,0.00300000}, {6,0.00400000}, {7,0.00522727}, {8,0.00719091}, {9,0.00879091}, {10,0.01105455}, {11,0.01420909}, {12,0.01615455}, {13,0.02024545}, {14,0.02306364}, {15,0.02713636}, {16,0.03169091}, {17,0.03685455}, {18,0.04229091}, {19,0.04850909}, {20,0.05513636}, {21,0.06638182}, {22,0.07440000}, {23,0.08325455}, {24,0.09122727}, {25,0.10067273}, {26,0.11188182}, {27,0.12521818}, {28,0.13692727}, {29,0.15188182}, {30,0.16448182}, {31,0.18185455}, {32,0.19660909}, {33,0.21413636}, {34,0.23386364}, {35,0.24929091}, {36,0.27310000}, {37,0.29235455}, {38,0.31555455}, {39,0.33928182}, {40,0.35892727}, {41,0.38606364}, {42,0.41510909}, {43,0.43937273}, {44,0.46793636}, {45,0.49899091}, {46,0.53149091}, {47,0.56600000}, {48,0.60182727}, {49,0.63881818}, {50,0.67500000}, {51,0.71450000}, {52,0.75429091}, {53,0.79829091}, {54,0.84315455}, {55,0.88996364}, {56,0.93390000}, {57,0.99958182}, {58,1.04583636}, {59,1.09986364}, {60,1.13962727}, {61,1.24200}, {62,1.28750}, {63,1.33150}, {64,1.39925}, {65,1.46475}, {66,1.52425}, {67,1.58725}, {68,1.66150}, {69,1.72350}, {70,1.80350}, {71,1.88700}, {72,1.94375}, {73,2.02450}, {74,2.11625}, {75,2.20650}, {76,2.28850}, {77,2.40100}, {78,2.47175}, {79,2.57100}, {80,2.65525}, {81,2.76800}, {82,2.87425}, {83,2.96550}, {84,3.10675}, {85,3.18350}, {86,3.31925}, {87,3.44350}, {88,3.53525}, {89,3.70425}, {90,3.77025}, {91,3.91900}, {92,4.08250}, {93,4.14375}, {94,4.34825}, {95,4.46625}, {96,4.55725}, {97,4.70325}, {98,4.94400}, {99,5.08025}, {100,5.25900}, {101,5.38950}, {102,5.56725}, {103,5.98950}, {104,5.91500}, {105,6.06125}, {106,6.23500}, {107,6.43875}, {108,6.60975}, {109,6.80800}, {110,7.07400}, {111,7.27275}, {112,7.53650}, {113,7.68950}, {114,7.94700}, {115,8.09375}, {116,8.34050}, {117,8.58625}, {118,8.78475}, {119,9.00825}, {120,9.25650}, {121,9.42425}, {122,9.70650}, {123,9.98825}, {124,10.24000}, {125,10.31125}, {126,10.65575}, {127,10.87325}, {128,11.32725}, {129,11.31150}, {130,11.57175}, {131,12.06800}, {132,12.25500}, {133,12.65650}, {134,12.96250}, {135,13.28250}, {136,13.62175}, {137,13.89775}, {138,14.15525}, {139,14.46150}, {140,14.63150}, {141,15.02775}, {142,15.54900}, {143,15.76625}, {144,16.29375}, {145,16.55175}, {146,16.88325}, {147,17.22350}, {148,17.65475}, {149,18.24650}, {150,18.58750}, {151,18.79025}, {152,19.13250}, {153,19.67625}, {154,19.80425}, {155,20.35975}, {156,20.82000}, {157,21.05725}, {158,21.68250}, {159,21.95050}, {160,22.46275}, {161,22.61775}, {162,23.27425}, {163,23.93975}, {164,24.41700}, {165,24.48675}, {166,25.36550}, {167,25.40225}, {168,26.12775}, {169,26.36150}, {170,27.19550}, {171,27.56125}, {172,28.08875}, {173,28.71700}, {174,29.04075}, {175,29.44175}, {176,30.18625}, {177,30.86675}, {178,31.08000}, {179,32.20475}, {180,32.79100}, {181,33.41475}, {182,33.69750}, {183,34.34950}, {184,35.14725}, {185,35.66675}, {186,36.11800}, {187,36.92600}, {188,37.69725}, {189,38.51850}, {190,38.53750}, {191,39.15025}, {192,39.93175}, {193,40.08050}, {194,41.14500}, {195,41.86375}, {196,42.52075}, {197,42.76975}, {198,43.49725}, {199,44.85625}, {200,44.61900}, {201,47.2620}, {202,47.5265}, {203,50.306}, {204,49.867}, {205,50.647}, {206,52.916}, {207,52.219}, {208,53.003}, {209,55.221}, {210,54.759}, {211,55.926}, {212,56.372}, {213,57.277}, {214,58.282}, {215,59.209}, {216,58.58}, {217,60.371}, {218,60.417}, {219,62.15}, {220,62.048}, {221,64.019}, {222,63.93}, {223,65.071}, {224,67.548}, {225,67.005}, {226,68.932}, {227,68.485}, {228,69.717}, {229,72.756}, {230,71.874}, {231,73.205}, {232,74.753}, {233,75.206}, {234,77.089}, {235,78.456}, {236,79.48}, {237,78.913}, {238,79.967}, {239,80.289}, {240,82.324}, {241,83.427}, {242,83.422}, {243,86.223}, {244,83.208}, {245,82.481}, {246,85.65}, {247,86.057}, {248,87.126}, {249,87.513}, {250,87.636}, {251,90.581}, {252,91.736}, {253,91.668}, {254,92.952}, {255,98.669}, {256,100.928}, {257,101.982}, {258,102.601}, {259,105.057}, {260,105.948}, {261,103.053}, {262,108.525}, {263,108.413}, {264,109.479}, {265,112.013}, {266,112.393}, {267,114.068}, {268,115.201}, {269,117.415}, {270,120.084}, {271,120.035}, {272,123.028}, {273,121.975}, {274,124.028}, {275,124.999}, {276,126.38}, {277,127.611}, {278,131.153}, {279,132.576}, {280,132.882}};
data["big"]["CanonicalStructuresHOAS"]["norm reif"]["user"] = {{1,0.00056364}, {2,0.00087273}, {3,0.00187273}, {4,0.00238182}, {5,0.00333636}, {6,0.00442727}, {7,0.00502727}, {8,0.00679091}, {9,0.00858182}, {10,0.01098182}, {11,0.01423636}, {12,0.01585455}, {13,0.02000000}, {14,0.02342727}, {15,0.02724545}, {16,0.03164545}, {17,0.03720909}, {18,0.04190909}, {19,0.04890000}, {20,0.05537273}, {21,0.06640909}, {22,0.07477273}, {23,0.08350000}, {24,0.09119091}, {25,0.10066364}, {26,0.11174545}, {27,0.12531818}, {28,0.13673636}, {29,0.15193636}, {30,0.16434545}, {31,0.18162727}, {32,0.19680909}, {33,0.21419091}, {34,0.23368182}, {35,0.24943636}, {36,0.27292727}, {37,0.29233636}, {38,0.31562727}, {39,0.33933636}, {40,0.35896364}, {41,0.38610000}, {42,0.41504545}, {43,0.43914545}, {44,0.46789091}, {45,0.49926364}, {46,0.53098182}, {47,0.56610000}, {48,0.60152727}, {49,0.63890909}, {50,0.67469091}, {51,0.71458182}, {52,0.75410909}, {53,0.79791818}, {54,0.84287273}, {55,0.88982727}, {56,0.93375455}, {57,0.99928182}, {58,1.04563636}, {59,1.09983636}, {60,1.13932727}, {61,1.24050}, {62,1.28675}, {63,1.33125}, {64,1.39950}, {65,1.46225}, {66,1.52450}, {67,1.58675}, {68,1.66150}, {69,1.72300}, {70,1.80450}, {71,1.88750}, {72,1.94375}, {73,2.02500}, {74,2.11725}, {75,2.20650}, {76,2.28925}, {77,2.40150}, {78,2.47300}, {79,2.57025}, {80,2.65425}, {81,2.76925}, {82,2.87475}, {83,2.96525}, {84,3.10675}, {85,3.18250}, {86,3.31750}, {87,3.44325}, {88,3.53475}, {89,3.70425}, {90,3.76975}, {91,3.91850}, {92,4.08150}, {93,4.14275}, {94,4.34750}, {95,4.46650}, {96,4.55600}, {97,4.70350}, {98,4.94125}, {99,5.08050}, {100,5.25775}, {101,5.38650}, {102,5.56475}, {103,5.98625}, {104,5.91225}, {105,6.05850}, {106,6.23250}, {107,6.43550}, {108,6.60550}, {109,6.80300}, {110,7.06975}, {111,7.27050}, {112,7.53250}, {113,7.68525}, {114,7.94450}, {115,8.09175}, {116,8.33725}, {117,8.58550}, {118,8.78450}, {119,9.00550}, {120,9.25250}, {121,9.42050}, {122,9.70625}, {123,9.98850}, {124,10.23875}, {125,10.30825}, {126,10.65575}, {127,10.87250}, {128,11.32650}, {129,11.31075}, {130,11.57275}, {131,12.06775}, {132,12.25550}, {133,12.65250}, {134,12.95925}, {135,13.27725}, {136,13.61875}, {137,13.89275}, {138,14.15075}, {139,14.46125}, {140,14.62900}, {141,15.02850}, {142,15.55050}, {143,15.76575}, {144,16.29250}, {145,16.54825}, {146,16.88150}, {147,17.22375}, {148,17.65450}, {149,18.24525}, {150,18.58625}, {151,18.78975}, {152,19.13175}, {153,19.64875}, {154,19.80625}, {155,20.35650}, {156,20.81900}, {157,21.05475}, {158,21.68250}, {159,21.94925}, {160,22.46150}, {161,22.61750}, {162,23.27125}, {163,23.94025}, {164,24.08200}, {165,24.48575}, {166,25.36525}, {167,25.40125}, {168,26.12700}, {169,26.35925}, {170,27.19375}, {171,27.55950}, {172,28.08825}, {173,28.71675}, {174,29.04050}, {175,29.43975}, {176,30.18675}, {177,30.86400}, {178,31.07950}, {179,32.20325}, {180,32.79150}, {181,33.41350}, {182,33.69775}, {183,34.34850}, {184,35.14475}, {185,35.66675}, {186,36.11950}, {187,36.91925}, {188,37.69425}, {189,38.51875}, {190,38.53975}, {191,39.14950}, {192,39.93150}, {193,40.07875}, {194,41.14375}, {195,41.86350}, {196,42.51725}, {197,42.76650}, {198,43.49125}, {199,44.85050}, {200,44.61933}, {201,46.9780}, {202,47.4175}, {203,50.295}, {204,49.812}, {205,50.644}, {206,52.915}, {207,52.216}, {208,53.004}, {209,55.224}, {210,54.759}, {211,55.923}, {212,56.371}, {213,57.275}, {214,58.284}, {215,59.207}, {216,58.579}, {217,60.372}, {218,60.416}, {219,62.148}, {220,62.047}, {221,64.019}, {222,63.931}, {223,65.072}, {224,67.547}, {225,67.003}, {226,68.931}, {227,68.484}, {228,69.716}, {229,72.756}, {230,71.876}, {231,73.208}, {232,74.755}, {233,75.207}, {234,77.087}, {235,78.456}, {236,79.479}, {237,78.912}, {238,79.967}, {239,80.291}, {240,82.324}, {241,83.427}, {242,83.407}, {243,86.219}, {244,83.207}, {245,82.479}, {246,85.652}, {247,86.056}, {248,87.128}, {249,87.492}, {250,87.623}, {251,90.583}, {252,91.74}, {253,91.664}, {254,92.951}, {255,98.668}, {256,100.927}, {257,101.984}, {258,102.599}, {259,105.056}, {260,105.948}, {261,103.051}, {262,108.523}, {263,108.407}, {264,109.48}, {265,112.015}, {266,112.391}, {267,114.067}, {268,115.2}, {269,117.416}, {270,120.083}, {271,120.036}, {272,123.027}, {273,121.976}, {274,124.028}, {275,125.}, {276,126.38}, {277,125.943}, {278,131.156}, {279,132.576}, {280,132.883}};
data["big"]["CanonicalStructuresHOAS"]["norm reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00003636}, {5,0.00000000}, {6,0.00000000}, {7,0.00007273}, {8,0.00000000}, {9,0.00000000}, {10,0.00010909}, {11,0.00002727}, {12,0.00010909}, {13,0.00003636}, {14,0.00000000}, {15,0.00003636}, {16,0.00007273}, {17,0.00003636}, {18,0.00010909}, {19,0.00000000}, {20,0.00003636}, {21,0.00000000}, {22,0.00003636}, {23,0.00000000}, {24,0.00000000}, {25,0.00003636}, {26,0.00003636}, {27,0.00000000}, {28,0.00000000}, {29,0.00010909}, {30,0.00003636}, {31,0.00010909}, {32,0.00003636}, {33,0.00003636}, {34,0.00000000}, {35,0.00007273}, {36,0.00003636}, {37,0.00000000}, {38,0.00000000}, {39,0.00003636}, {40,0.00007273}, {41,0.00007273}, {42,0.00010909}, {43,0.00003636}, {44,0.00003636}, {45,0.00000000}, {46,0.00014545}, {47,0.00007273}, {48,0.00007273}, {49,0.00003636}, {50,0.00003636}, {51,0.00003636}, {52,0.00000000}, {53,0.00003636}, {54,0.00010909}, {55,0.00000000}, {56,0.00003636}, {57,0.00021818}, {58,0.00003636}, {59,0.00003636}, {60,0.00007273}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00100}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00100}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00100}, {100,0.00000}, {101,0.00100}, {102,0.00100}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00075}, {110,0.00100}, {111,0.00000}, {112,0.00100}, {113,0.00000}, {114,0.00000}, {115,0.00100}, {116,0.00100}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00100}, {121,0.00100}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00200}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00100}, {134,0.00000}, {135,0.00100}, {136,0.00000}, {137,0.00175}, {138,0.00100}, {139,0.00000}, {140,0.00100}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00100}, {146,0.00300}, {147,0.00000}, {148,0.00000}, {149,0.00100}, {150,0.00000}, {151,0.00100}, {152,0.00000}, {153,0.00100}, {154,0.00000}, {155,0.00300}, {156,0.00100}, {157,0.00300}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00100}, {163,0.00100}, {164,0.00100}, {165,0.00100}, {166,0.00000}, {167,0.00000}, {168,0.00100}, {169,0.00000}, {170,0.00100}, {171,0.00100}, {172,0.00100}, {173,0.00000}, {174,0.00000}, {175,0.00100}, {176,0.00000}, {177,0.00100}, {178,0.00100}, {179,0.00100}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00200}, {184,0.00100}, {185,0.00000}, {186,0.00000}, {187,0.00500}, {188,0.00175}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00100}, {193,0.00100}, {194,0.00200}, {195,0.00000}, {196,0.00100}, {197,0.00100}, {198,0.00500}, {199,0.00375}, {200,0.00000}, {201,0.0175}, {202,0.0020}, {203,0}, {204,0.011}, {205,0}, {206,0}, {207,0.004}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0.012}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0.019}, {250,0.012}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["post"]["user"] = {{1,0.00003636}, {2,0.00005455}, {3,0.00006364}, {4,0.00002727}, {5,0.00002727}, {6,0.00000000}, {7,0.00003636}, {8,0.00000000}, {9,0.00000000}, {10,0.00007273}, {11,0.00006364}, {12,0.00000000}, {13,0.00000000}, {14,0.00003636}, {15,0.00010000}, {16,0.00000000}, {17,0.00006364}, {18,0.00000000}, {19,0.00000000}, {20,0.00003636}, {21,0.00000000}, {22,0.00003636}, {23,0.00003636}, {24,0.00003636}, {25,0.00002727}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00007273}, {30,0.00003636}, {31,0.00010000}, {32,0.00007273}, {33,0.00003636}, {34,0.00000000}, {35,0.00003636}, {36,0.00006364}, {37,0.00002727}, {38,0.00000000}, {39,0.00002727}, {40,0.00003636}, {41,0.00000000}, {42,0.00003636}, {43,0.00006364}, {44,0.00003636}, {45,0.00002727}, {46,0.00003636}, {47,0.00002727}, {48,0.00000000}, {49,0.00003636}, {50,0.00003636}, {51,0.00003636}, {52,0.00006364}, {53,0.00000000}, {54,0.00000000}, {55,0.00003636}, {56,0.00000000}, {57,0.00007273}, {58,0.00014545}, {59,0.00000000}, {60,0.00003636}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00075}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00100}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00100}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00075}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00100}, {194,0.00000}, {195,0.00075}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["postprocess"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["postprocess"]["user"] = {{1,0.00002727}, {2,0.00000000}, {3,0.00003636}, {4,0.00003636}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00003636}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00003636}, {16,0.00000000}, {17,0.00003636}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00003636}, {22,0.00003636}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00003636}, {33,0.00000000}, {34,0.00000000}, {35,0.00007273}, {36,0.00000000}, {37,0.00002727}, {38,0.00000000}, {39,0.00000000}, {40,0.00003636}, {41,0.00000000}, {42,0.00000000}, {43,0.00003636}, {44,0.00003636}, {45,0.00003636}, {46,0.00003636}, {47,0.00000000}, {48,0.00003636}, {49,0.00000000}, {50,0.00003636}, {51,0.00003636}, {52,0.00003636}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00002727}, {58,0.00003636}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["postprocess"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000909}, {13,0.00000909}, {14,0.00006364}, {15,0.00012727}, {16,0.00043636}, {17,0.00093636}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00100000}, {23,0.00100000}, {24,0.00100000}, {25,0.00100000}, {26,0.00100000}, {27,0.00100000}, {28,0.00100000}, {29,0.00100000}, {30,0.00100000}, {31,0.00100000}, {32,0.00100000}, {33,0.00100000}, {34,0.00100000}, {35,0.00100000}, {36,0.00100000}, {37,0.00100000}, {38,0.00100000}, {39,0.00100000}, {40,0.00100000}, {41,0.00100000}, {42,0.00100000}, {43,0.00100000}, {44,0.00100000}, {45,0.00100000}, {46,0.00101818}, {47,0.00101818}, {48,0.00101818}, {49,0.00103636}, {50,0.00105455}, {51,0.00105455}, {52,0.00105455}, {53,0.00116364}, {54,0.00131818}, {55,0.00180909}, {56,0.00200000}, {57,0.00200000}, {58,0.00200000}, {59,0.00200000}, {60,0.00200000}, {61,0.00200}, {62,0.00200}, {63,0.00200}, {64,0.00200}, {65,0.00200}, {66,0.00200}, {67,0.00200}, {68,0.00400}, {69,0.00200}, {70,0.00200}, {71,0.00200}, {72,0.00200}, {73,0.00200}, {74,0.00200}, {75,0.00200}, {76,0.00200}, {77,0.00200}, {78,0.00200}, {79,0.00200}, {80,0.00200}, {81,0.00225}, {82,0.00250}, {83,0.00200}, {84,0.00225}, {85,0.00275}, {86,0.00275}, {87,0.00250}, {88,0.00275}, {89,0.00300}, {90,0.00300}, {91,0.00300}, {92,0.00300}, {93,0.00300}, {94,0.00450}, {95,0.00300}, {96,0.00300}, {97,0.00525}, {98,0.00300}, {99,0.00300}, {100,0.00300}, {101,0.00300}, {102,0.00300}, {103,0.00300}, {104,0.00300}, {105,0.00300}, {106,0.00300}, {107,0.00300}, {108,0.00300}, {109,0.00300}, {110,0.00300}, {111,0.00300}, {112,0.00300}, {113,0.00325}, {114,0.00350}, {115,0.00375}, {116,0.00350}, {117,0.00400}, {118,0.00400}, {119,0.00400}, {120,0.00450}, {121,0.00400}, {122,0.00400}, {123,0.00450}, {124,0.00400}, {125,0.00400}, {126,0.00400}, {127,0.00450}, {128,0.00400}, {129,0.00400}, {130,0.00450}, {131,0.00400}, {132,0.00400}, {133,0.00400}, {134,0.00400}, {135,0.00400}, {136,0.00400}, {137,0.00500}, {138,0.00400}, {139,0.00400}, {140,0.00475}, {141,0.00450}, {142,0.00475}, {143,0.00500}, {144,0.00500}, {145,0.00500}, {146,0.00500}, {147,0.00500}, {148,0.00500}, {149,0.00500}, {150,0.00500}, {151,0.00500}, {152,0.00525}, {153,0.00500}, {154,0.00500}, {155,0.00500}, {156,0.00500}, {157,0.00500}, {158,0.00500}, {159,0.00500}, {160,0.00625}, {161,0.00500}, {162,0.00525}, {163,0.00525}, {164,0.00675}, {165,0.00525}, {166,0.00575}, {167,0.00600}, {168,0.00600}, {169,0.00675}, {170,0.00600}, {171,0.00600}, {172,0.00600}, {173,0.00750}, {174,0.00625}, {175,0.00600}, {176,0.00600}, {177,0.00725}, {178,0.00725}, {179,0.00600}, {180,0.00600}, {181,0.00600}, {182,0.00750}, {183,0.00600}, {184,0.00600}, {185,0.00625}, {186,0.00625}, {187,0.00675}, {188,0.00700}, {189,0.00700}, {190,0.00700}, {191,0.00700}, {192,0.00825}, {193,0.00700}, {194,0.00700}, {195,0.00700}, {196,0.00700}, {197,0.00850}, {198,0.00700}, {199,0.00700}, {200,0.00767}, {201,0.0460}, {202,0.0075}, {203,0.007}, {204,0.008}, {205,0.008}, {206,0.011}, {207,0.008}, {208,0.008}, {209,0.008}, {210,0.008}, {211,0.008}, {212,0.008}, {213,0.008}, {214,0.008}, {215,0.008}, {216,0.008}, {217,0.008}, {218,0.008}, {219,0.008}, {220,0.009}, {221,0.008}, {222,0.009}, {223,0.008}, {224,0.009}, {225,0.009}, {226,0.009}, {227,0.009}, {228,0.009}, {229,0.009}, {230,0.009}, {231,0.017}, {232,0.009}, {233,0.009}, {234,0.01}, {235,0.009}, {236,0.01}, {237,0.01}, {238,0.009}, {239,0.009}, {240,0.009}, {241,0.016}, {242,0.01}, {243,0.01}, {244,0.01}, {245,0.014}, {246,0.015}, {247,0.01}, {248,0.01}, {249,0.01}, {250,0.01}, {251,0.01}, {252,0.01}, {253,0.01}, {254,0.01}, {255,0.01}, {256,0.01}, {257,0.01}, {258,0.011}, {259,0.011}, {260,0.011}, {261,0.011}, {262,0.011}, {263,0.024}, {264,0.011}, {265,0.016}, {266,0.011}, {267,0.011}, {268,0.012}, {269,0.011}, {270,0.011}, {271,0.011}, {272,0.011}, {273,0.011}, {274,0.012}, {275,0.011}, {276,0.012}, {277,0.012}, {278,0.012}, {279,0.012}, {280,0.012}};
data["big"]["CanonicalStructuresHOAS"]["pre"]["user"] = {{1,0.00042727}, {2,0.00050000}, {3,0.00044545}, {4,0.00072727}, {5,0.00060909}, {6,0.00072727}, {7,0.00093636}, {8,0.00087273}, {9,0.00083636}, {10,0.00084545}, {11,0.00061818}, {12,0.00088182}, {13,0.00096364}, {14,0.00094545}, {15,0.00099091}, {16,0.00080909}, {17,0.00085455}, {18,0.00115455}, {19,0.00076364}, {20,0.00063636}, {21,0.00118182}, {22,0.00134545}, {23,0.00098182}, {24,0.00106364}, {25,0.00100000}, {26,0.00118182}, {27,0.00111818}, {28,0.00122727}, {29,0.00114545}, {30,0.00150909}, {31,0.00115455}, {32,0.00135455}, {33,0.00140000}, {34,0.00134545}, {35,0.00157273}, {36,0.00164545}, {37,0.00144545}, {38,0.00128182}, {39,0.00118182}, {40,0.00136364}, {41,0.00180000}, {42,0.00158182}, {43,0.00170909}, {44,0.00118182}, {45,0.00170909}, {46,0.00194545}, {47,0.00172727}, {48,0.00188182}, {49,0.00198182}, {50,0.00203636}, {51,0.00183636}, {52,0.00183636}, {53,0.00197273}, {54,0.00197273}, {55,0.00238182}, {56,0.00174545}, {57,0.00203636}, {58,0.00209091}, {59,0.00205455}, {60,0.00230000}, {61,0.00150}, {62,0.00300}, {63,0.00100}, {64,0.00225}, {65,0.00100}, {66,0.00250}, {67,0.00250}, {68,0.00500}, {69,0.00250}, {70,0.00175}, {71,0.00225}, {72,0.00075}, {73,0.00100}, {74,0.00200}, {75,0.00200}, {76,0.00275}, {77,0.00200}, {78,0.00225}, {79,0.00175}, {80,0.00150}, {81,0.00150}, {82,0.00300}, {83,0.00275}, {84,0.00225}, {85,0.00325}, {86,0.00250}, {87,0.00225}, {88,0.00325}, {89,0.00225}, {90,0.00300}, {91,0.00325}, {92,0.00250}, {93,0.00225}, {94,0.00325}, {95,0.00225}, {96,0.00325}, {97,0.00475}, {98,0.00375}, {99,0.00250}, {100,0.00150}, {101,0.00150}, {102,0.00350}, {103,0.00300}, {104,0.00350}, {105,0.00225}, {106,0.00150}, {107,0.00325}, {108,0.00300}, {109,0.00325}, {110,0.00300}, {111,0.00325}, {112,0.00350}, {113,0.00325}, {114,0.00300}, {115,0.00300}, {116,0.00350}, {117,0.00350}, {118,0.00300}, {119,0.00350}, {120,0.00425}, {121,0.00325}, {122,0.00475}, {123,0.00350}, {124,0.00300}, {125,0.00300}, {126,0.00400}, {127,0.00300}, {128,0.00325}, {129,0.00525}, {130,0.00525}, {131,0.00400}, {132,0.00325}, {133,0.00300}, {134,0.00525}, {135,0.00425}, {136,0.00400}, {137,0.00525}, {138,0.00525}, {139,0.00450}, {140,0.00675}, {141,0.00425}, {142,0.00300}, {143,0.00425}, {144,0.00400}, {145,0.00550}, {146,0.00425}, {147,0.00300}, {148,0.00400}, {149,0.00400}, {150,0.00500}, {151,0.00400}, {152,0.00600}, {153,0.00400}, {154,0.00425}, {155,0.00525}, {156,0.00500}, {157,0.00525}, {158,0.00425}, {159,0.00450}, {160,0.00725}, {161,0.00500}, {162,0.00625}, {163,0.00425}, {164,0.00700}, {165,0.00625}, {166,0.00550}, {167,0.00625}, {168,0.00500}, {169,0.00750}, {170,0.00600}, {171,0.00625}, {172,0.00500}, {173,0.00825}, {174,0.00725}, {175,0.00600}, {176,0.00300}, {177,0.00525}, {178,0.00725}, {179,0.00750}, {180,0.00725}, {181,0.00700}, {182,0.00700}, {183,0.00625}, {184,0.00550}, {185,0.00625}, {186,0.00400}, {187,0.00625}, {188,0.00600}, {189,0.00425}, {190,0.00550}, {191,0.00750}, {192,0.00850}, {193,0.00725}, {194,0.00600}, {195,0.00725}, {196,0.00625}, {197,0.00800}, {198,0.00750}, {199,0.00625}, {200,0.00733}, {201,0.0475}, {202,0.0055}, {203,0.007}, {204,0.008}, {205,0.008}, {206,0.011}, {207,0.007}, {208,0.007}, {209,0.007}, {210,0.007}, {211,0.007}, {212,0.012}, {213,0.007}, {214,0.007}, {215,0.007}, {216,0.007}, {217,0.007}, {218,0.011}, {219,0.011}, {220,0.007}, {221,0.008}, {222,0.007}, {223,0.007}, {224,0.007}, {225,0.007}, {226,0.007}, {227,0.007}, {228,0.007}, {229,0.011}, {230,0.007}, {231,0.015}, {232,0.007}, {233,0.012}, {234,0.007}, {235,0.012}, {236,0.012}, {237,0.012}, {238,0.012}, {239,0.008}, {240,0.011}, {241,0.015}, {242,0.007}, {243,0.012}, {244,0.012}, {245,0.015}, {246,0.015}, {247,0.011}, {248,0.011}, {249,0.007}, {250,0.007}, {251,0.007}, {252,0.007}, {253,0.011}, {254,0.012}, {255,0.011}, {256,0.011}, {257,0.012}, {258,0.011}, {259,0.011}, {260,0.011}, {261,0.012}, {262,0.012}, {263,0.023}, {264,0.011}, {265,0.015}, {266,0.011}, {267,0.012}, {268,0.012}, {269,0.011}, {270,0.012}, {271,0.012}, {272,0.011}, {273,0.011}, {274,0.011}, {275,0.011}, {276,0.011}, {277,0.011}, {278,0.011}, {279,0.011}, {280,0.012}};
data["big"]["CanonicalStructuresHOAS"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003636}, {4,0.00003636}, {5,0.00000000}, {6,0.00000000}, {7,0.00003636}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00003636}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00003636}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00003636}, {28,0.00000000}, {29,0.00003636}, {30,0.00007273}, {31,0.00007273}, {32,0.00003636}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00003636}, {37,0.00003636}, {38,0.00000000}, {39,0.00003636}, {40,0.00007273}, {41,0.00000000}, {42,0.00000000}, {43,0.00003636}, {44,0.00003636}, {45,0.00000000}, {46,0.00003636}, {47,0.00000000}, {48,0.00000000}, {49,0.00003636}, {50,0.00003636}, {51,0.00003636}, {52,0.00000000}, {53,0.00010909}, {54,0.00000000}, {55,0.00000000}, {56,0.00003636}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00007273}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresHOAS"]["reif"]["real"] = {{1,0.00000000}, {2,0.00100000}, {3,0.00102727}, {4,0.00200000}, {5,0.00300000}, {6,0.00400000}, {7,0.00531818}, {8,0.00720000}, {9,0.00902727}, {10,0.01111818}, {11,0.01434545}, {12,0.01620909}, {13,0.02035455}, {14,0.02317273}, {15,0.02731818}, {16,0.03182727}, {17,0.03705455}, {18,0.04244545}, {19,0.04866364}, {20,0.05529091}, {21,0.06657273}, {22,0.07458182}, {23,0.08347273}, {24,0.09144545}, {25,0.10085455}, {26,0.11209091}, {27,0.12549091}, {28,0.13715455}, {29,0.15210909}, {30,0.16465455}, {31,0.18200000}, {32,0.19682727}, {33,0.21430909}, {34,0.23401818}, {35,0.24947273}, {36,0.27329091}, {37,0.29252727}, {38,0.31573636}, {39,0.33946364}, {40,0.35911818}, {41,0.38632727}, {42,0.41528182}, {43,0.43954545}, {44,0.46807273}, {45,0.49924545}, {46,0.53178182}, {47,0.56620909}, {48,0.60197273}, {49,0.63904545}, {50,0.67522727}, {51,0.71477273}, {52,0.75453636}, {53,0.79843636}, {54,0.84340000}, {55,0.89022727}, {56,0.93414545}, {57,0.99986364}, {58,1.04604545}, {59,1.10012727}, {60,1.13987273}, {61,1.24225}, {62,1.28775}, {63,1.33150}, {64,1.39925}, {65,1.46500}, {66,1.52475}, {67,1.58725}, {68,1.66175}, {69,1.72375}, {70,1.80375}, {71,1.88700}, {72,1.94400}, {73,2.02500}, {74,2.11625}, {75,2.20675}, {76,2.28875}, {77,2.40125}, {78,2.47175}, {79,2.57125}, {80,2.65525}, {81,2.76800}, {82,2.87500}, {83,2.96625}, {84,3.10675}, {85,3.18375}, {86,3.31925}, {87,3.44400}, {88,3.53525}, {89,3.70425}, {90,3.77050}, {91,3.91950}, {92,4.08300}, {93,4.14425}, {94,4.34825}, {95,4.46650}, {96,4.55750}, {97,4.70350}, {98,4.94400}, {99,5.08075}, {100,5.25950}, {101,5.38975}, {102,5.56725}, {103,5.98975}, {104,5.91550}, {105,6.06150}, {106,6.23525}, {107,6.43900}, {108,6.61000}, {109,6.80800}, {110,7.07400}, {111,7.27325}, {112,7.53675}, {113,7.68975}, {114,7.94725}, {115,8.09375}, {116,8.34100}, {117,8.58625}, {118,8.78575}, {119,9.00850}, {120,9.25675}, {121,9.42475}, {122,9.70675}, {123,9.98900}, {124,10.24000}, {125,10.31150}, {126,10.65625}, {127,10.87375}, {128,11.32725}, {129,11.31175}, {130,11.57200}, {131,12.06850}, {132,12.25525}, {133,12.65675}, {134,12.96250}, {135,13.28250}, {136,13.62175}, {137,13.89800}, {138,14.15525}, {139,14.46175}, {140,14.63200}, {141,15.02825}, {142,15.54950}, {143,15.76650}, {144,16.29425}, {145,16.55225}, {146,16.88350}, {147,17.22400}, {148,17.65525}, {149,18.24700}, {150,18.58750}, {151,18.79075}, {152,19.13275}, {153,19.67675}, {154,19.80450}, {155,20.36000}, {156,20.82050}, {157,21.05775}, {158,21.68275}, {159,21.95075}, {160,22.46325}, {161,22.61850}, {162,23.27450}, {163,23.94050}, {164,24.41725}, {165,24.48750}, {166,25.36600}, {167,25.40275}, {168,26.12825}, {169,26.36150}, {170,27.19600}, {171,27.56125}, {172,28.08900}, {173,28.71700}, {174,29.04100}, {175,29.44225}, {176,30.18675}, {177,30.86675}, {178,31.08025}, {179,32.20500}, {180,32.79150}, {181,33.41500}, {182,33.69800}, {183,34.35025}, {184,35.14825}, {185,35.66750}, {186,36.11850}, {187,36.92625}, {188,37.69750}, {189,38.51850}, {190,38.53850}, {191,39.15050}, {192,39.93250}, {193,40.08100}, {194,41.14525}, {195,41.86375}, {196,42.52100}, {197,42.76975}, {198,43.49750}, {199,44.85625}, {200,44.61933}, {201,47.2625}, {202,47.5265}, {203,50.306}, {204,49.868}, {205,50.647}, {206,52.917}, {207,52.22}, {208,53.004}, {209,55.221}, {210,54.76}, {211,55.926}, {212,56.372}, {213,57.278}, {214,58.283}, {215,59.21}, {216,58.58}, {217,60.371}, {218,60.417}, {219,62.15}, {220,62.048}, {221,64.019}, {222,63.93}, {223,65.071}, {224,67.549}, {225,67.005}, {226,68.933}, {227,68.486}, {228,69.717}, {229,72.756}, {230,71.874}, {231,73.206}, {232,74.754}, {233,75.206}, {234,77.089}, {235,78.456}, {236,79.48}, {237,78.913}, {238,79.967}, {239,80.29}, {240,82.324}, {241,83.428}, {242,83.423}, {243,86.223}, {244,83.209}, {245,82.481}, {246,85.651}, {247,86.058}, {248,87.127}, {249,87.513}, {250,87.637}, {251,90.581}, {252,91.737}, {253,91.669}, {254,92.952}, {255,98.67}, {256,100.929}, {257,101.983}, {258,102.601}, {259,105.057}, {260,105.948}, {261,103.054}, {262,108.526}, {263,108.414}, {264,109.48}, {265,112.013}, {266,112.394}, {267,114.069}, {268,115.202}, {269,117.416}, {270,120.084}, {271,120.035}, {272,123.029}, {273,121.976}, {274,124.028}, {275,124.999}, {276,126.38}, {277,127.612}, {278,131.154}, {279,132.576}, {280,132.883}};
data["big"]["CanonicalStructuresHOAS"]["reif"]["user"] = {{1,0.00080000}, {2,0.00100909}, {3,0.00194545}, {4,0.00251818}, {5,0.00342727}, {6,0.00456364}, {7,0.00528182}, {8,0.00686364}, {9,0.00870000}, {10,0.01140000}, {11,0.01445455}, {12,0.01610000}, {13,0.02009091}, {14,0.02358182}, {15,0.02742727}, {16,0.03175455}, {17,0.03730000}, {18,0.04211818}, {19,0.04897273}, {20,0.05547273}, {21,0.06650909}, {22,0.07486364}, {23,0.08370909}, {24,0.09136364}, {25,0.10089091}, {26,0.11191818}, {27,0.12557273}, {28,0.13699091}, {29,0.15213636}, {30,0.16474545}, {31,0.18186364}, {32,0.19694545}, {33,0.21428182}, {34,0.23381818}, {35,0.24960909}, {36,0.27307273}, {37,0.29257273}, {38,0.31581818}, {39,0.33955455}, {40,0.35917273}, {41,0.38617273}, {42,0.41529091}, {43,0.43930000}, {44,0.46803636}, {45,0.49943636}, {46,0.53120000}, {47,0.56649091}, {48,0.60182727}, {49,0.63906364}, {50,0.67476364}, {51,0.71479091}, {52,0.75433636}, {53,0.79810000}, {54,0.84298182}, {55,0.88982727}, {56,0.93403636}, {57,0.99944545}, {58,1.04592727}, {59,1.10008182}, {60,1.13962727}, {61,1.24050}, {62,1.28675}, {63,1.33250}, {64,1.39950}, {65,1.46225}, {66,1.52450}, {67,1.58675}, {68,1.66150}, {69,1.72300}, {70,1.80450}, {71,1.88750}, {72,1.94375}, {73,2.02500}, {74,2.11725}, {75,2.20650}, {76,2.28925}, {77,2.40150}, {78,2.47300}, {79,2.57025}, {80,2.65425}, {81,2.76925}, {82,2.87575}, {83,2.96525}, {84,3.10675}, {85,3.18350}, {86,3.31750}, {87,3.44325}, {88,3.53475}, {89,3.70425}, {90,3.77075}, {91,3.91850}, {92,4.08150}, {93,4.14475}, {94,4.34875}, {95,4.46650}, {96,4.55725}, {97,4.70350}, {98,4.94225}, {99,5.08150}, {100,5.25975}, {101,5.38850}, {102,5.56475}, {103,5.98625}, {104,5.91225}, {105,6.05850}, {106,6.23250}, {107,6.43550}, {108,6.60650}, {109,6.80300}, {110,7.06975}, {111,7.27050}, {112,7.53250}, {113,7.68525}, {114,7.94450}, {115,8.09250}, {116,8.33725}, {117,8.58550}, {118,8.78450}, {119,9.00625}, {120,9.25250}, {121,9.42050}, {122,9.70750}, {123,9.98850}, {124,10.24100}, {125,10.30825}, {126,10.65650}, {127,10.87250}, {128,11.32650}, {129,11.31250}, {130,11.57275}, {131,12.06775}, {132,12.25550}, {133,12.65350}, {134,12.95925}, {135,13.27725}, {136,13.61875}, {137,13.89375}, {138,14.15075}, {139,14.46125}, {140,14.63000}, {141,15.02850}, {142,15.55050}, {143,15.76575}, {144,16.29350}, {145,16.55025}, {146,16.88150}, {147,17.22375}, {148,17.65450}, {149,18.24525}, {150,18.58750}, {151,18.78975}, {152,19.13175}, {153,19.64875}, {154,19.80625}, {155,20.35750}, {156,20.82000}, {157,21.05575}, {158,21.68250}, {159,21.95025}, {160,22.46250}, {161,22.61750}, {162,23.27250}, {163,23.94025}, {164,24.08300}, {165,24.48675}, {166,25.36525}, {167,25.40125}, {168,26.12700}, {169,26.36025}, {170,27.19375}, {171,27.56025}, {172,28.08825}, {173,28.71675}, {174,29.04050}, {175,29.43975}, {176,30.18675}, {177,30.86400}, {178,31.07950}, {179,32.20325}, {180,32.79150}, {181,33.41350}, {182,33.69775}, {183,34.34925}, {184,35.14650}, {185,35.66675}, {186,36.11950}, {187,36.92150}, {188,37.69425}, {189,38.51875}, {190,38.53975}, {191,39.14950}, {192,39.93150}, {193,40.07975}, {194,41.14375}, {195,41.86350}, {196,42.52025}, {197,42.76650}, {198,43.49225}, {199,44.85150}, {200,44.62067}, {201,46.9780}, {202,47.4175}, {203,50.295}, {204,49.812}, {205,50.648}, {206,52.915}, {207,52.216}, {208,53.004}, {209,55.224}, {210,54.759}, {211,55.923}, {212,56.371}, {213,57.275}, {214,58.284}, {215,59.207}, {216,58.579}, {217,60.372}, {218,60.416}, {219,62.148}, {220,62.051}, {221,64.019}, {222,63.931}, {223,65.072}, {224,67.547}, {225,67.003}, {226,68.931}, {227,68.488}, {228,69.716}, {229,72.756}, {230,71.876}, {231,73.208}, {232,74.755}, {233,75.207}, {234,77.091}, {235,78.456}, {236,79.479}, {237,78.912}, {238,79.967}, {239,80.291}, {240,82.324}, {241,83.432}, {242,83.407}, {243,86.224}, {244,83.207}, {245,82.479}, {246,85.652}, {247,86.06}, {248,87.128}, {249,87.496}, {250,87.627}, {251,90.583}, {252,91.74}, {253,91.664}, {254,92.951}, {255,98.668}, {256,100.927}, {257,101.984}, {258,102.599}, {259,105.056}, {260,105.948}, {261,103.051}, {262,108.527}, {263,108.407}, {264,109.48}, {265,112.015}, {266,112.391}, {267,114.072}, {268,115.2}, {269,117.416}, {270,120.083}, {271,120.036}, {272,123.027}, {273,121.976}, {274,124.028}, {275,125.}, {276,126.38}, {277,125.943}, {278,131.156}, {279,132.576}, {280,132.883}};
data["big"]["CanonicalStructuresHOAS"]["reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00003636}, {5,0.00000000}, {6,0.00000000}, {7,0.00007273}, {8,0.00000000}, {9,0.00000000}, {10,0.00010909}, {11,0.00002727}, {12,0.00010909}, {13,0.00003636}, {14,0.00000000}, {15,0.00003636}, {16,0.00007273}, {17,0.00003636}, {18,0.00010909}, {19,0.00000000}, {20,0.00003636}, {21,0.00000000}, {22,0.00003636}, {23,0.00000000}, {24,0.00000000}, {25,0.00003636}, {26,0.00003636}, {27,0.00003636}, {28,0.00000000}, {29,0.00010909}, {30,0.00003636}, {31,0.00010909}, {32,0.00003636}, {33,0.00003636}, {34,0.00000000}, {35,0.00007273}, {36,0.00003636}, {37,0.00000000}, {38,0.00000000}, {39,0.00007273}, {40,0.00007273}, {41,0.00007273}, {42,0.00010909}, {43,0.00003636}, {44,0.00003636}, {45,0.00000000}, {46,0.00014545}, {47,0.00007273}, {48,0.00007273}, {49,0.00007273}, {50,0.00003636}, {51,0.00003636}, {52,0.00000000}, {53,0.00003636}, {54,0.00010909}, {55,0.00000000}, {56,0.00003636}, {57,0.00021818}, {58,0.00003636}, {59,0.00003636}, {60,0.00007273}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00100}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00100}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00100}, {100,0.00000}, {101,0.00100}, {102,0.00100}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00175}, {110,0.00100}, {111,0.00000}, {112,0.00100}, {113,0.00000}, {114,0.00000}, {115,0.00100}, {116,0.00100}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00100}, {121,0.00100}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00200}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00100}, {134,0.00000}, {135,0.00100}, {136,0.00000}, {137,0.00175}, {138,0.00100}, {139,0.00000}, {140,0.00100}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00100}, {146,0.00300}, {147,0.00000}, {148,0.00000}, {149,0.00100}, {150,0.00000}, {151,0.00100}, {152,0.00000}, {153,0.00100}, {154,0.00000}, {155,0.00300}, {156,0.00100}, {157,0.00300}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00100}, {163,0.00100}, {164,0.00100}, {165,0.00100}, {166,0.00000}, {167,0.00000}, {168,0.00100}, {169,0.00000}, {170,0.00100}, {171,0.00100}, {172,0.00100}, {173,0.00000}, {174,0.00000}, {175,0.00100}, {176,0.00000}, {177,0.00100}, {178,0.00100}, {179,0.00100}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00200}, {184,0.00100}, {185,0.00000}, {186,0.00000}, {187,0.00500}, {188,0.00175}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00100}, {193,0.00100}, {194,0.00200}, {195,0.00000}, {196,0.00100}, {197,0.00100}, {198,0.00500}, {199,0.00375}, {200,0.00000}, {201,0.0175}, {202,0.0020}, {203,0}, {204,0.011}, {205,0}, {206,0}, {207,0.004}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0.004}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0.012}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0.019}, {250,0.012}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresPHOAS"]["Aggregate"]["real"] = {{1,0.00200000}, {2,0.00300000}, {3,0.00399091}, {4,0.00505455}, {5,0.00700909}, {6,0.00920909}, {7,0.02714545}, {8,0.01530000}, {9,0.01964545}, {10,0.02454545}, {11,0.03029091}, {12,0.03730000}, {13,0.04463636}, {14,0.05560909}, {15,0.06743636}, {16,0.07800909}, {17,0.09046364}, {18,0.10432727}, {19,0.11999091}, {20,0.13685455}, {21,0.15672727}, {22,0.17733636}, {23,0.20267273}, {24,0.22873636}, {25,0.25468182}, {26,0.28315455}, {27,0.31518182}, {28,0.34853636}, {29,0.38508182}, {30,0.42442727}, {31,0.47126364}, {32,0.51443636}, {33,0.55859091}, {34,0.60882727}, {35,0.65720000}, {36,0.71532727}, {37,0.77485455}, {38,0.83610000}, {39,0.90958182}, {40,0.97183636}, {41,1.04350909}, {42,1.12284545}, {43,1.20077273}, {44,1.28759091}, {45,1.37659091}, {46,1.46960909}, {47,1.56658182}, {48,1.66645455}, {49,1.77253636}, {50,1.88520000}, {51,2.00271818}, {52,2.12163636}, {53,2.25189091}, {54,2.38191818}, {55,2.51108182}, {56,3.25664545}, {57,2.81172727}, {58,2.95883636}, {59,3.10720000}, {60,3.25742727}, {61,3.64200}, {62,3.76675}, {63,3.90025}, {64,4.12675}, {65,4.39200}, {66,4.67850}, {67,4.82850}, {68,5.00300}, {69,5.30075}, {70,5.62325}, {71,5.80900}, {72,5.90000}, {73,6.23600}, {74,6.52950}, {75,6.80850}, {76,7.10575}, {77,7.43450}, {78,7.73500}, {79,8.06975}, {80,8.23900}, {81,8.76850}, {82,9.02875}, {83,9.69925}, {84,10.14775}, {85,10.07050}, {86,10.46825}, {87,10.87450}, {88,11.19900}, {89,11.72275}, {90,12.03950}, {91,12.50950}, {92,12.82125}, {93,13.32175}, {94,13.72850}, {95,14.22000}, {96,14.71950}, {97,15.16200}, {98,15.83575}, {99,16.46825}, {100,17.15025}, {101,17.39925}, {102,17.89375}, {103,18.37150}, {104,18.89325}, {105,19.60875}, {106,20.21075}, {107,20.76725}, {108,21.42200}, {109,22.29500}, {110,22.99200}, {111,23.75175}, {112,24.41875}, {113,25.33875}, {114,25.84175}, {115,26.51675}, {116,27.26100}, {117,28.07350}, {118,28.82050}, {119,29.61475}, {120,30.34325}, {121,31.08675}, {122,32.02000}, {123,32.86250}, {124,33.58000}, {125,34.42300}, {126,35.14175}, {127,36.19875}, {128,37.29675}, {129,37.91300}, {130,39.51750}, {131,40.01900}, {132,41.50200}, {133,42.67550}, {134,43.74500}, {135,44.51975}, {136,45.44500}, {137,46.64375}, {138,47.78125}, {139,48.79125}, {140,50.23050}, {141,51.55425}, {142,52.35750}, {143,53.66900}, {144,54.96875}, {145,56.59875}, {146,58.17825}, {147,59.29825}, {148,60.48975}, {149,62.17725}, {150,63.49225}, {151,64.40325}, {152,65.33300}, {153,67.18050}, {154,68.45925}, {155,70.18950}, {156,71.72825}, {157,73.04750}, {158,74.60500}, {159,76.06825}, {160,77.22750}, {161,78.70600}, {162,80.82375}, {163,83.22150}, {164,83.61625}, {165,85.30875}, {166,88.29875}, {167,88.54175}, {168,90.49675}, {169,92.44425}, {170,94.64300}, {171,95.68800}, {172,98.07825}, {173,100.16725}, {174,101.86200}, {175,103.48050}, {176,105.73500}, {177,108.34275}, {178,109.56300}, {179,112.42875}, {180,114.76875}, {181,117.21500}, {182,118.60825}, {183,120.83550}, {184,123.50250}, {185,126.01600}, {186,127.56975}, {187,130.68400}, {188,133.11225}, {189,136.36425}, {190,137.26100}, {191,138.19725}, {192,141.10575}, {193,143.34800}, {194,146.24575}, {195,148.92300}, {196,151.20825}, {197,153.50875}, {198,156.22400}, {199,159.28533}, {200,160.77133}, {201,169.0775}, {202,167.894}, {203,176.962}, {204,177.827}, {205,180.988}, {206,185.541}, {207,186.577}, {208,191.222}, {209,193.932}, {210,196.331}, {211,200.688}, {212,202.796}, {213,206.861}, {214,209.972}, {215,219.234}, {216,215.795}, {217,221.011}, {218,222.148}, {219,226.666}, {220,230.615}, {221,233.439}, {222,237.55}, {223,242.036}, {224,245.245}, {225,248.253}, {226,253.968}, {227,256.847}, {228,259.345}, {229,265.159}, {230,269.126}, {231,272.446}, {232,277.313}, {233,280.742}, {234,284.561}, {235,289.455}, {236,293.532}, {237,299.451}, {238,298.962}, {239,307.434}, {240,308.597}, {241,313.448}, {242,320.606}, {243,333.131}, {244,316.142}, {245,323.79}, {246,325.586}, {247,329.97}, {248,336.825}, {249,343.287}, {250,346.751}, {251,349.79}, {252,353.561}, {253,363.065}, {254,377.934}, {255,382.505}, {256,394.82}, {257,398.385}, {258,399.845}, {259,413.673}, {260,403.959}, {261,424.099}, {262,415.112}, {263,426.985}, {264,430.817}, {265,442.123}, {266,440.726}, {267,448.155}, {268,453.914}, {269,459.476}, {270,471.963}, {271,473.122}, {272,480.393}, {273,482.036}, {274,490.102}, {275,494.309}, {276,500.488}, {277,511.802}, {278,513.68}, {279,528.458}};
data["big"]["CanonicalStructuresPHOAS"]["Aggregate"]["user"] = {{1,0.00212727}, {2,0.00297273}, {3,0.00401818}, {4,0.00554545}, {5,0.00700909}, {6,0.00903636}, {7,0.02733636}, {8,0.01561818}, {9,0.01950909}, {10,0.02501818}, {11,0.03026364}, {12,0.03749091}, {13,0.04450909}, {14,0.05545455}, {15,0.06712727}, {16,0.07852727}, {17,0.09023636}, {18,0.10410909}, {19,0.12050000}, {20,0.13664545}, {21,0.15658182}, {22,0.17758182}, {23,0.20260000}, {24,0.22851818}, {25,0.25440000}, {26,0.28310000}, {27,0.31543636}, {28,0.34812727}, {29,0.38508182}, {30,0.42424545}, {31,0.47073636}, {32,0.51417273}, {33,0.55831818}, {34,0.60848182}, {35,0.65676364}, {36,0.71540000}, {37,0.77461818}, {38,0.83570000}, {39,0.90930000}, {40,0.97186364}, {41,1.04351818}, {42,1.12247273}, {43,1.20035455}, {44,1.28719091}, {45,1.37625455}, {46,1.46924545}, {47,1.56635455}, {48,1.66610909}, {49,1.77234545}, {50,1.88483636}, {51,2.00232727}, {52,2.12079091}, {53,2.25163636}, {54,2.38144545}, {55,2.51098182}, {56,3.25446364}, {57,2.81146364}, {58,2.95852727}, {59,3.10680909}, {60,3.25682727}, {61,3.64075}, {62,3.76450}, {63,3.89625}, {64,4.12675}, {65,4.39075}, {66,4.67950}, {67,4.82850}, {68,5.00325}, {69,5.30100}, {70,5.62375}, {71,5.80850}, {72,5.89800}, {73,6.23550}, {74,6.52775}, {75,6.80925}, {76,7.10475}, {77,7.43250}, {78,7.73450}, {79,8.06725}, {80,8.23700}, {81,8.77000}, {82,9.02900}, {83,9.69575}, {84,10.14550}, {85,10.07050}, {86,10.46850}, {87,10.87350}, {88,11.19825}, {89,11.72250}, {90,12.03850}, {91,12.50925}, {92,12.82100}, {93,13.32200}, {94,13.72725}, {95,14.22075}, {96,14.71850}, {97,15.16125}, {98,15.83375}, {99,16.46450}, {100,17.14150}, {101,17.39125}, {102,17.88650}, {103,18.36250}, {104,18.88350}, {105,19.60025}, {106,20.20150}, {107,20.75575}, {108,21.41050}, {109,22.28575}, {110,22.98075}, {111,23.73725}, {112,24.40725}, {113,25.32450}, {114,25.83550}, {115,26.50800}, {116,27.25650}, {117,28.06750}, {118,28.81225}, {119,29.60625}, {120,30.33275}, {121,31.08125}, {122,32.01925}, {123,32.86175}, {124,33.57700}, {125,34.42375}, {126,35.13950}, {127,36.19700}, {128,37.29475}, {129,37.90850}, {130,39.51525}, {131,40.01750}, {132,41.48650}, {133,42.66550}, {134,43.73050}, {135,44.50275}, {136,45.42675}, {137,46.63025}, {138,47.76750}, {139,48.78725}, {140,50.22750}, {141,51.54950}, {142,52.35150}, {143,53.66500}, {144,54.95625}, {145,56.59650}, {146,58.17075}, {147,59.29700}, {148,60.48200}, {149,62.16575}, {150,63.46425}, {151,64.40025}, {152,65.28275}, {153,67.17350}, {154,68.44825}, {155,70.16375}, {156,71.71850}, {157,73.03825}, {158,74.58450}, {159,76.05675}, {160,77.20975}, {161,78.70175}, {162,80.80775}, {163,83.20525}, {164,83.48050}, {165,85.29925}, {166,88.27275}, {167,88.53825}, {168,90.48125}, {169,92.42650}, {170,94.63325}, {171,95.67975}, {172,98.06375}, {173,100.15625}, {174,101.85150}, {175,103.45700}, {176,105.71150}, {177,108.32825}, {178,109.55350}, {179,112.40550}, {180,114.75150}, {181,117.19425}, {182,118.58550}, {183,120.82250}, {184,123.47650}, {185,125.99200}, {186,127.55675}, {187,130.64500}, {188,133.09425}, {189,136.32975}, {190,137.24750}, {191,138.17725}, {192,141.08125}, {193,143.32050}, {194,146.22525}, {195,148.89500}, {196,151.18175}, {197,153.48675}, {198,156.20400}, {199,159.26433}, {200,160.75733}, {201,168.2415}, {202,167.716}, {203,176.74}, {204,177.784}, {205,180.987}, {206,185.516}, {207,186.556}, {208,191.224}, {209,193.936}, {210,196.327}, {211,200.687}, {212,202.795}, {213,206.86}, {214,209.972}, {215,219.228}, {216,215.795}, {217,220.943}, {218,222.148}, {219,226.668}, {220,230.616}, {221,233.44}, {222,237.552}, {223,242.036}, {224,245.248}, {225,248.252}, {226,253.968}, {227,256.847}, {228,259.347}, {229,265.159}, {230,269.123}, {231,272.443}, {232,277.316}, {233,280.744}, {234,284.564}, {235,289.456}, {236,293.536}, {237,299.448}, {238,298.847}, {239,307.396}, {240,308.468}, {241,313.368}, {242,320.539}, {243,332.971}, {244,316.139}, {245,323.791}, {246,325.54}, {247,329.971}, {248,336.763}, {249,343.219}, {250,346.716}, {251,349.74}, {252,353.563}, {253,361.24}, {254,377.835}, {255,382.5}, {256,394.683}, {257,398.336}, {258,399.848}, {259,413.599}, {260,400.984}, {261,421.111}, {262,415.116}, {263,426.984}, {264,430.816}, {265,439.327}, {266,440.727}, {267,448.072}, {268,453.828}, {269,459.432}, {270,471.899}, {271,473.124}, {272,480.324}, {273,482.036}, {274,490.051}, {275,494.243}, {276,500.427}, {277,509.975}, {278,513.615}, {279,528.307}};
data["big"]["CanonicalStructuresPHOAS"]["Aggregate"]["system"] = {{1,0.00003636}, {2,0.00007273}, {3,0.00003636}, {4,0.00000000}, {5,0.00003636}, {6,0.00010909}, {7,0.00007273}, {8,0.00003636}, {9,0.00007273}, {10,0.00010909}, {11,0.00000000}, {12,0.00007273}, {13,0.00007273}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00007273}, {18,0.00003636}, {19,0.00003636}, {20,0.00010909}, {21,0.00003636}, {22,0.00000000}, {23,0.00010909}, {24,0.00007273}, {25,0.00003636}, {26,0.00000000}, {27,0.00000000}, {28,0.00010909}, {29,0.00013636}, {30,0.00000000}, {31,0.00010000}, {32,0.00007273}, {33,0.00010000}, {34,0.00014545}, {35,0.00003636}, {36,0.00010909}, {37,0.00007273}, {38,0.00010909}, {39,0.00003636}, {40,0.00018182}, {41,0.00018182}, {42,0.00032727}, {43,0.00021818}, {44,0.00010909}, {45,0.00021818}, {46,0.00010909}, {47,0.00024545}, {48,0.00021818}, {49,0.00018182}, {50,0.00018182}, {51,0.00021818}, {52,0.00057273}, {53,0.00014545}, {54,0.00040000}, {55,0.00014545}, {56,0.00230000}, {57,0.00021818}, {58,0.00021818}, {59,0.00032727}, {60,0.00040000}, {61,0.00000}, {62,0.00000}, {63,0.00100}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00100}, {73,0.00000}, {74,0.00200}, {75,0.00000}, {76,0.00200}, {77,0.00100}, {78,0.00000}, {79,0.00200}, {80,0.00200}, {81,0.00100}, {82,0.00000}, {83,0.00175}, {84,0.00300}, {85,0.00000}, {86,0.00000}, {87,0.00100}, {88,0.00100}, {89,0.00000}, {90,0.00100}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00100}, {101,0.00000}, {102,0.00000}, {103,0.00100}, {104,0.00100}, {105,0.00100}, {106,0.00100}, {107,0.00100}, {108,0.00200}, {109,0.00100}, {110,0.00175}, {111,0.00375}, {112,0.00100}, {113,0.00300}, {114,0.00100}, {115,0.00400}, {116,0.00000}, {117,0.00200}, {118,0.00300}, {119,0.00000}, {120,0.00300}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00200}, {125,0.00000}, {126,0.00300}, {127,0.00100}, {128,0.00000}, {129,0.00300}, {130,0.00200}, {131,0.00100}, {132,0.00500}, {133,0.00100}, {134,0.00500}, {135,0.00800}, {136,0.01000}, {137,0.00300}, {138,0.00700}, {139,0.00400}, {140,0.00300}, {141,0.00600}, {142,0.00675}, {143,0.00400}, {144,0.00875}, {145,0.00300}, {146,0.00700}, {147,0.00200}, {148,0.00575}, {149,0.01075}, {150,0.02675}, {151,0.00300}, {152,0.00200}, {153,0.00700}, {154,0.01000}, {155,0.02275}, {156,0.00800}, {157,0.00800}, {158,0.01975}, {159,0.01100}, {160,0.01675}, {161,0.00300}, {162,0.01600}, {163,0.01500}, {164,0.00800}, {165,0.00850}, {166,0.02600}, {167,0.00200}, {168,0.01400}, {169,0.01775}, {170,0.00800}, {171,0.00800}, {172,0.01400}, {173,0.01075}, {174,0.00800}, {175,0.02100}, {176,0.02275}, {177,0.01475}, {178,0.00900}, {179,0.02375}, {180,0.01675}, {181,0.01900}, {182,0.02100}, {183,0.01400}, {184,0.02600}, {185,0.02300}, {186,0.01300}, {187,0.03900}, {188,0.01800}, {189,0.03350}, {190,0.01400}, {191,0.02000}, {192,0.02400}, {193,0.02775}, {194,0.02200}, {195,0.02875}, {196,0.02600}, {197,0.02200}, {198,0.01775}, {199,0.01867}, {200,0.01733}, {201,0.0835}, {202,0.036}, {203,0.072}, {204,0.004}, {205,0}, {206,0.024}, {207,0.024}, {208,0}, {209,0}, {210,0.004}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0.004}, {216,0}, {217,0.067}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0.004}, {238,0.111}, {239,0.04}, {240,0.128}, {241,0.079}, {242,0.068}, {243,0.159}, {244,0}, {245,0}, {246,0.048}, {247,0}, {248,0.06}, {249,0.068}, {250,0.036}, {251,0.052}, {252,0}, {253,0.004}, {254,0.052}, {255,0.004}, {256,0.135}, {257,0.004}, {258,0}, {259,0.072}, {260,0}, {261,0.035}, {262,0}, {263,0.004}, {264,0.004}, {265,0.072}, {266,0}, {267,0.084}, {268,0.088}, {269,0.044}, {270,0.064}, {271,0}, {272,0.072}, {273,0}, {274,0.047}, {275,0.064}, {276,0.06}, {277,0.076}, {278,0.064}, {279,0.148}};
data["big"]["CanonicalStructuresPHOAS"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00100000}, {3,0.00200000}, {4,0.00300000}, {5,0.00500000}, {6,0.00718182}, {7,0.02491818}, {8,0.01313636}, {9,0.01737273}, {10,0.02220000}, {11,0.02801818}, {12,0.03476364}, {13,0.04220909}, {14,0.05309091}, {15,0.06482727}, {16,0.07537273}, {17,0.08775455}, {18,0.10164545}, {19,0.11452727}, {20,0.13400000}, {21,0.15389091}, {22,0.17441818}, {23,0.19969091}, {24,0.22564545}, {25,0.25159091}, {26,0.28004545}, {27,0.31201818}, {28,0.34537273}, {29,0.38183636}, {30,0.42104545}, {31,0.46773636}, {32,0.51102727}, {33,0.55499091}, {34,0.60524545}, {35,0.65358182}, {36,0.71168182}, {37,0.77110000}, {38,0.83226364}, {39,0.90572727}, {40,0.96807273}, {41,1.03960909}, {42,1.11885455}, {43,1.19671818}, {44,1.28354545}, {45,1.37238182}, {46,1.46530000}, {47,1.56230909}, {48,1.66210909}, {49,1.76806364}, {50,1.88060909}, {51,1.99820909}, {52,2.11704545}, {53,2.24724545}, {54,2.37724545}, {55,2.50630909}, {56,3.25189091}, {57,2.80690000}, {58,2.95388182}, {59,3.10215455}, {60,3.25171818}, {61,3.63650}, {62,3.76100}, {63,3.89425}, {64,4.12125}, {65,4.38625}, {66,4.67050}, {67,4.82225}, {68,4.99675}, {69,5.29450}, {70,5.61700}, {71,5.80275}, {72,5.89375}, {73,6.23000}, {74,6.52250}, {75,6.80175}, {76,7.09950}, {77,7.42725}, {78,7.72800}, {79,8.06300}, {80,8.23200}, {81,8.76125}, {82,9.02150}, {83,9.69225}, {84,10.13900}, {85,10.06300}, {86,10.46050}, {87,10.86625}, {88,11.19125}, {89,11.71475}, {90,12.03100}, {91,12.50125}, {92,12.81325}, {93,13.31325}, {94,13.72000}, {95,14.21100}, {96,14.71075}, {97,15.15275}, {98,15.82625}, {99,16.45850}, {100,17.14075}, {101,17.38975}, {102,17.88425}, {103,18.36150}, {104,18.88300}, {105,19.59875}, {106,20.20075}, {107,20.75700}, {108,21.41175}, {109,22.28375}, {110,22.98075}, {111,23.74075}, {112,24.40775}, {113,25.32775}, {114,25.83025}, {115,26.50525}, {116,27.24975}, {117,28.06175}, {118,28.80875}, {119,29.60275}, {120,30.33175}, {121,31.07500}, {122,32.00700}, {123,32.84900}, {124,33.56700}, {125,34.41025}, {126,35.12900}, {127,36.18575}, {128,37.28425}, {129,37.90075}, {130,39.50475}, {131,40.00600}, {132,41.48800}, {133,42.66150}, {134,43.73075}, {135,44.50600}, {136,45.43075}, {137,46.62950}, {138,47.76725}, {139,48.77650}, {140,50.21600}, {141,51.53975}, {142,52.34175}, {143,53.65425}, {144,54.95325}, {145,56.58350}, {146,58.16350}, {147,59.28275}, {148,60.47375}, {149,62.16150}, {150,63.47650}, {151,64.38775}, {152,65.31650}, {153,67.16350}, {154,68.44350}, {155,70.17350}, {156,71.71175}, {157,73.03050}, {158,74.58825}, {159,76.05150}, {160,77.21075}, {161,78.68875}, {162,80.80650}, {163,83.20400}, {164,83.59900}, {165,85.29125}, {166,88.28100}, {167,88.52375}, {168,90.47900}, {169,92.42650}, {170,94.62525}, {171,95.66900}, {172,98.06000}, {173,100.14900}, {174,101.84150}, {175,103.46200}, {176,105.71550}, {177,108.32375}, {178,109.54175}, {179,112.40925}, {180,114.74850}, {181,117.19475}, {182,118.58775}, {183,120.81350}, {184,123.48150}, {185,125.99400}, {186,127.54575}, {187,130.66200}, {188,133.09025}, {189,136.34350}, {190,137.23625}, {191,138.17550}, {192,141.08425}, {193,143.32575}, {194,146.22425}, {195,148.90050}, {196,151.18550}, {197,153.48525}, {198,156.20075}, {199,159.26167}, {200,160.74867}, {201,169.0510}, {202,167.868}, {203,176.935}, {204,177.799}, {205,180.961}, {206,185.514}, {207,186.548}, {208,191.192}, {209,193.904}, {210,196.302}, {211,200.657}, {212,202.767}, {213,206.83}, {214,209.942}, {215,219.207}, {216,215.765}, {217,220.979}, {218,222.118}, {219,226.635}, {220,230.585}, {221,233.407}, {222,237.516}, {223,242.003}, {224,245.209}, {225,248.22}, {226,253.936}, {227,256.815}, {228,259.311}, {229,265.121}, {230,269.091}, {231,272.412}, {232,277.279}, {233,280.703}, {234,284.52}, {235,289.42}, {236,293.493}, {237,299.419}, {238,298.928}, {239,307.399}, {240,308.562}, {241,313.409}, {242,320.57}, {243,333.1}, {244,316.107}, {245,323.758}, {246,325.551}, {247,329.93}, {248,336.789}, {249,343.252}, {250,346.718}, {251,349.753}, {252,353.525}, {253,363.031}, {254,377.895}, {255,382.469}, {256,394.786}, {257,398.345}, {258,399.801}, {259,413.639}, {260,403.92}, {261,424.064}, {262,415.072}, {263,426.948}, {264,430.778}, {265,442.086}, {266,440.682}, {267,448.115}, {268,453.874}, {269,459.437}, {270,471.926}, {271,473.083}, {272,480.349}, {273,481.994}, {274,490.059}, {275,494.268}, {276,500.447}, {277,511.759}, {278,513.637}, {279,528.418}};
data["big"]["CanonicalStructuresPHOAS"]["actual reif"]["user"] = {{1,0.00063636}, {2,0.00120000}, {3,0.00239091}, {4,0.00333636}, {5,0.00504545}, {6,0.00702727}, {7,0.02520000}, {8,0.01315455}, {9,0.01717273}, {10,0.02230909}, {11,0.02812727}, {12,0.03461818}, {13,0.04203636}, {14,0.05327273}, {15,0.06463636}, {16,0.07544545}, {17,0.08758182}, {18,0.10163636}, {19,0.11419091}, {20,0.13370909}, {21,0.15386364}, {22,0.17432727}, {23,0.19975455}, {24,0.22551818}, {25,0.25167273}, {26,0.27988182}, {27,0.31178182}, {28,0.34530000}, {29,0.38185455}, {30,0.42108182}, {31,0.46752727}, {32,0.51084545}, {33,0.55513636}, {34,0.60493636}, {35,0.65356364}, {36,0.71186364}, {37,0.77064545}, {38,0.83213636}, {39,0.90558182}, {40,0.96784545}, {41,1.03917273}, {42,1.11878182}, {43,1.19643636}, {44,1.28354545}, {45,1.37201818}, {46,1.46520909}, {47,1.56197273}, {48,1.66160909}, {49,1.76781818}, {50,1.88031818}, {51,1.99774545}, {52,2.11658182}, {53,2.24721818}, {54,2.37684545}, {55,2.50612727}, {56,3.24943636}, {57,2.80617273}, {58,2.95344545}, {59,3.10186364}, {60,3.25125455}, {61,3.63400}, {62,3.76075}, {63,3.89425}, {64,4.12075}, {65,4.38625}, {66,4.67000}, {67,4.82175}, {68,4.99675}, {69,5.29475}, {70,5.61650}, {71,5.80325}, {72,5.89275}, {73,6.23150}, {74,6.52150}, {75,6.80275}, {76,7.09875}, {77,7.42600}, {78,7.72875}, {79,8.06050}, {80,8.23250}, {81,8.76100}, {82,9.02175}, {83,9.68900}, {84,10.13550}, {85,10.06325}, {86,10.45975}, {87,10.86550}, {88,11.18900}, {89,11.71500}, {90,12.03050}, {91,12.50150}, {92,12.81275}, {93,13.31225}, {94,13.71925}, {95,14.21125}, {96,14.70925}, {97,15.15325}, {98,15.82425}, {99,16.45650}, {100,17.13350}, {101,17.38250}, {102,17.87625}, {103,18.35150}, {104,18.87375}, {105,19.58950}, {106,20.18950}, {107,20.74575}, {108,21.39900}, {109,22.27525}, {110,22.96750}, {111,23.72800}, {112,24.39650}, {113,25.31350}, {114,25.82350}, {115,26.49425}, {116,27.24325}, {117,28.05550}, {118,28.79825}, {119,29.59650}, {120,30.32050}, {121,31.07000}, {122,32.00775}, {123,32.84950}, {124,33.56450}, {125,34.41025}, {126,35.12575}, {127,36.18475}, {128,37.28325}, {129,37.89550}, {130,39.50150}, {131,40.00600}, {132,41.47425}, {133,42.65150}, {134,43.71625}, {135,44.48825}, {136,45.41250}, {137,46.61775}, {138,47.75225}, {139,48.77300}, {140,50.21225}, {141,51.53350}, {142,52.33475}, {143,53.65075}, {144,54.94275}, {145,56.57925}, {146,58.15550}, {147,59.27925}, {148,60.46725}, {149,62.15075}, {150,63.44875}, {151,64.38550}, {152,65.27000}, {153,67.15625}, {154,68.43325}, {155,70.14650}, {156,71.70250}, {157,73.02200}, {158,74.56725}, {159,76.04025}, {160,77.19225}, {161,78.68400}, {162,80.78875}, {163,83.18900}, {164,83.46250}, {165,85.28250}, {166,88.25450}, {167,88.52200}, {168,90.46625}, {169,92.40725}, {170,94.61625}, {171,95.66075}, {172,98.04450}, {173,100.13950}, {174,101.83250}, {175,103.43975}, {176,105.69150}, {177,108.30875}, {178,109.53275}, {179,112.38575}, {180,114.72925}, {181,117.17450}, {182,118.56550}, {183,120.79950}, {184,123.45625}, {185,125.97075}, {186,127.53350}, {187,130.62350}, {188,133.07075}, {189,136.30975}, {190,137.22350}, {191,138.15400}, {192,141.06075}, {193,143.29825}, {194,146.20125}, {195,148.87050}, {196,151.16025}, {197,153.46450}, {198,156.18150}, {199,159.24367}, {200,160.73033}, {201,168.2160}, {202,167.692}, {203,176.712}, {204,177.76}, {205,180.959}, {206,185.491}, {207,186.524}, {208,191.192}, {209,193.903}, {210,196.3}, {211,200.659}, {212,202.768}, {213,206.831}, {214,209.943}, {215,219.204}, {216,215.764}, {217,220.911}, {218,222.12}, {219,226.631}, {220,230.583}, {221,233.408}, {222,237.52}, {223,242.003}, {224,245.207}, {225,248.224}, {226,253.935}, {227,256.815}, {228,259.311}, {229,265.123}, {230,269.095}, {231,272.412}, {232,277.28}, {233,280.703}, {234,284.52}, {235,289.42}, {236,293.495}, {237,299.415}, {238,298.816}, {239,307.363}, {240,308.432}, {241,313.327}, {242,320.504}, {243,332.94}, {244,316.107}, {245,323.756}, {246,325.503}, {247,329.932}, {248,336.728}, {249,343.184}, {250,346.683}, {251,349.699}, {252,353.527}, {253,361.208}, {254,377.8}, {255,382.468}, {256,394.648}, {257,398.295}, {258,399.804}, {259,413.567}, {260,400.939}, {261,421.076}, {262,415.072}, {263,426.943}, {264,430.775}, {265,439.292}, {266,440.683}, {267,448.027}, {268,453.788}, {269,459.396}, {270,471.864}, {271,473.083}, {272,480.276}, {273,481.992}, {274,490.011}, {275,494.204}, {276,500.387}, {277,509.936}, {278,513.572}, {279,528.268}};
data["big"]["CanonicalStructuresPHOAS"]["actual reif"]["system"] = {{1,0.00000000}, {2,0.00003636}, {3,0.00000000}, {4,0.00000000}, {5,0.00003636}, {6,0.00003636}, {7,0.00003636}, {8,0.00000000}, {9,0.00007273}, {10,0.00003636}, {11,0.00000000}, {12,0.00007273}, {13,0.00007273}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00003636}, {18,0.00003636}, {19,0.00003636}, {20,0.00007273}, {21,0.00003636}, {22,0.00000000}, {23,0.00003636}, {24,0.00000000}, {25,0.00003636}, {26,0.00000000}, {27,0.00000000}, {28,0.00003636}, {29,0.00006364}, {30,0.00000000}, {31,0.00006364}, {32,0.00003636}, {33,0.00002727}, {34,0.00003636}, {35,0.00003636}, {36,0.00003636}, {37,0.00007273}, {38,0.00003636}, {39,0.00003636}, {40,0.00007273}, {41,0.00010909}, {42,0.00025455}, {43,0.00007273}, {44,0.00007273}, {45,0.00014545}, {46,0.00010909}, {47,0.00020909}, {48,0.00014545}, {49,0.00014545}, {50,0.00007273}, {51,0.00018182}, {52,0.00047273}, {53,0.00010909}, {54,0.00032727}, {55,0.00014545}, {56,0.00215455}, {57,0.00021818}, {58,0.00014545}, {59,0.00029091}, {60,0.00032727}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00100}, {73,0.00000}, {74,0.00100}, {75,0.00000}, {76,0.00200}, {77,0.00100}, {78,0.00000}, {79,0.00200}, {80,0.00100}, {81,0.00100}, {82,0.00000}, {83,0.00175}, {84,0.00200}, {85,0.00000}, {86,0.00000}, {87,0.00100}, {88,0.00100}, {89,0.00000}, {90,0.00100}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00100}, {101,0.00000}, {102,0.00000}, {103,0.00100}, {104,0.00100}, {105,0.00100}, {106,0.00100}, {107,0.00100}, {108,0.00200}, {109,0.00100}, {110,0.00175}, {111,0.00375}, {112,0.00100}, {113,0.00300}, {114,0.00100}, {115,0.00400}, {116,0.00000}, {117,0.00100}, {118,0.00300}, {119,0.00000}, {120,0.00300}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00200}, {125,0.00000}, {126,0.00300}, {127,0.00100}, {128,0.00000}, {129,0.00300}, {130,0.00200}, {131,0.00100}, {132,0.00500}, {133,0.00100}, {134,0.00500}, {135,0.00800}, {136,0.00900}, {137,0.00300}, {138,0.00700}, {139,0.00400}, {140,0.00300}, {141,0.00600}, {142,0.00675}, {143,0.00400}, {144,0.00875}, {145,0.00300}, {146,0.00700}, {147,0.00200}, {148,0.00575}, {149,0.01075}, {150,0.02675}, {151,0.00300}, {152,0.00100}, {153,0.00600}, {154,0.01000}, {155,0.02275}, {156,0.00800}, {157,0.00800}, {158,0.01875}, {159,0.01100}, {160,0.01675}, {161,0.00300}, {162,0.01600}, {163,0.01500}, {164,0.00800}, {165,0.00850}, {166,0.02600}, {167,0.00200}, {168,0.01400}, {169,0.01775}, {170,0.00800}, {171,0.00800}, {172,0.01400}, {173,0.01075}, {174,0.00800}, {175,0.02100}, {176,0.02275}, {177,0.01475}, {178,0.00800}, {179,0.02375}, {180,0.01675}, {181,0.01900}, {182,0.02100}, {183,0.01400}, {184,0.02500}, {185,0.02300}, {186,0.01300}, {187,0.03800}, {188,0.01800}, {189,0.03350}, {190,0.01400}, {191,0.02000}, {192,0.02400}, {193,0.02775}, {194,0.02200}, {195,0.02875}, {196,0.02600}, {197,0.02100}, {198,0.01775}, {199,0.01867}, {200,0.01733}, {201,0.0835}, {202,0.036}, {203,0.072}, {204,0.004}, {205,0}, {206,0.024}, {207,0.024}, {208,0}, {209,0}, {210,0.004}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0.004}, {216,0}, {217,0.067}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0.004}, {238,0.111}, {239,0.036}, {240,0.128}, {241,0.079}, {242,0.068}, {243,0.159}, {244,0}, {245,0}, {246,0.048}, {247,0}, {248,0.06}, {249,0.068}, {250,0.036}, {251,0.052}, {252,0}, {253,0.004}, {254,0.052}, {255,0.004}, {256,0.135}, {257,0.004}, {258,0}, {259,0.072}, {260,0}, {261,0.035}, {262,0}, {263,0.004}, {264,0.004}, {265,0.072}, {266,0}, {267,0.084}, {268,0.088}, {269,0.044}, {270,0.064}, {271,0}, {272,0.072}, {273,0}, {274,0.047}, {275,0.064}, {276,0.06}, {277,0.076}, {278,0.064}, {279,0.148}};
data["big"]["CanonicalStructuresPHOAS"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0.001}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0.001}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresPHOAS"]["cbv"]["user"] = {{1,0.00007273}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00003636}, {6,0.00000000}, {7,0.00007273}, {8,0.00000000}, {9,0.00002727}, {10,0.00007273}, {11,0.00000000}, {12,0.00000000}, {13,0.00003636}, {14,0.00000000}, {15,0.00003636}, {16,0.00003636}, {17,0.00000000}, {18,0.00006364}, {19,0.00013636}, {20,0.00007273}, {21,0.00003636}, {22,0.00007273}, {23,0.00000000}, {24,0.00010909}, {25,0.00003636}, {26,0.00007273}, {27,0.00007273}, {28,0.00007273}, {29,0.00013636}, {30,0.00007273}, {31,0.00003636}, {32,0.00002727}, {33,0.00000000}, {34,0.00003636}, {35,0.00003636}, {36,0.00002727}, {37,0.00014545}, {38,0.00006364}, {39,0.00012727}, {40,0.00007273}, {41,0.00010000}, {42,0.00002727}, {43,0.00007273}, {44,0.00007273}, {45,0.00013636}, {46,0.00021818}, {47,0.00010000}, {48,0.00010909}, {49,0.00007273}, {50,0.00018182}, {51,0.00005455}, {52,0.00010000}, {53,0.00013636}, {54,0.00018182}, {55,0.00023636}, {56,0.00016364}, {57,0.00017273}, {58,0.00013636}, {59,0.00010000}, {60,0.00003636}, {61,0.00000}, {62,0.00100}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00075}, {71,0.00100}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00075}, {76,0.00000}, {77,0.00000}, {78,0.00075}, {79,0.00075}, {80,0.00000}, {81,0.00175}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00100}, {95,0.00000}, {96,0.00100}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00075}, {101,0.00000}, {102,0.00000}, {103,0.00075}, {104,0.00000}, {105,0.00075}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00075}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00075}, {118,0.00075}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00075}, {128,0.00000}, {129,0.00075}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00075}, {134,0.00000}, {135,0.00075}, {136,0.00075}, {137,0.00000}, {138,0.00000}, {139,0.00075}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00075}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00075}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00075}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00075}, {161,0.00000}, {162,0.00000}, {163,0.00075}, {164,0.00000}, {165,0.00075}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00075}, {174,0.00000}, {175,0.00000}, {176,0.00075}, {177,0.00075}, {178,0.00000}, {179,0.00075}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00100}, {191,0.00075}, {192,0.00175}, {193,0.00075}, {194,0.00000}, {195,0.00100}, {196,0.00000}, {197,0.00000}, {198,0.00075}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0.004}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0.003}, {221,0}, {222,0}, {223,0.003}, {224,0}, {225,0}, {226,0}, {227,0.003}, {228,0.003}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0.003}, {242,0}, {243,0.003}, {244,0}, {245,0}, {246,0}, {247,0.003}, {248,0}, {249,0.003}, {250,0.004}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0.004}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0.004}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0.004}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0.003}, {280,0}};
data["big"]["CanonicalStructuresPHOAS"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00003636}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00003636}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00100}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresPHOAS"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00025}, {66,0.00050}, {67,0.00025}, {68,0.00000}, {69,0.00025}, {70,0.00025}, {71,0.00025}, {72,0.00025}, {73,0.00025}, {74,0.00050}, {75,0.00075}, {76,0.00050}, {77,0.00075}, {78,0.00075}, {79,0.00100}, {80,0.00100}, {81,0.00125}, {82,0.00100}, {83,0.00125}, {84,0.00200}, {85,0.00125}, {86,0.00150}, {87,0.00150}, {88,0.00125}, {89,0.00125}, {90,0.00150}, {91,0.00150}, {92,0.00125}, {93,0.00150}, {94,0.00150}, {95,0.00150}, {96,0.00150}, {97,0.00150}, {98,0.00150}, {99,0.00175}, {100,0.00150}, {101,0.00150}, {102,0.00175}, {103,0.00175}, {104,0.00200}, {105,0.00200}, {106,0.00200}, {107,0.00225}, {108,0.00200}, {109,0.00225}, {110,0.00275}, {111,0.00225}, {112,0.00250}, {113,0.00225}, {114,0.00275}, {115,0.00250}, {116,0.00250}, {117,0.00250}, {118,0.00250}, {119,0.00275}, {120,0.00250}, {121,0.00275}, {122,0.00350}, {123,0.00400}, {124,0.00300}, {125,0.00325}, {126,0.00300}, {127,0.00350}, {128,0.00275}, {129,0.00275}, {130,0.00325}, {131,0.00300}, {132,0.00375}, {133,0.00350}, {134,0.00350}, {135,0.00350}, {136,0.00375}, {137,0.00350}, {138,0.00350}, {139,0.00425}, {140,0.00325}, {141,0.00350}, {142,0.00400}, {143,0.00375}, {144,0.00425}, {145,0.00425}, {146,0.00375}, {147,0.00425}, {148,0.00450}, {149,0.00425}, {150,0.00400}, {151,0.00400}, {152,0.00425}, {153,0.00525}, {154,0.00425}, {155,0.00400}, {156,0.00450}, {157,0.00450}, {158,0.00425}, {159,0.00450}, {160,0.00425}, {161,0.00500}, {162,0.00500}, {163,0.00500}, {164,0.00500}, {165,0.00500}, {166,0.00525}, {167,0.00475}, {168,0.00500}, {169,0.00550}, {170,0.00550}, {171,0.00500}, {172,0.00475}, {173,0.00525}, {174,0.00600}, {175,0.00525}, {176,0.00625}, {177,0.00525}, {178,0.00700}, {179,0.00575}, {180,0.00575}, {181,0.00600}, {182,0.00600}, {183,0.00650}, {184,0.00650}, {185,0.00625}, {186,0.00700}, {187,0.00725}, {188,0.00675}, {189,0.00625}, {190,0.00850}, {191,0.00650}, {192,0.00625}, {193,0.00675}, {194,0.00650}, {195,0.00700}, {196,0.00700}, {197,0.00700}, {198,0.00725}, {199,0.00700}, {200,0.00733}, {201,0.0090}, {202,0.009}, {203,0.01}, {204,0.01}, {205,0.01}, {206,0.01}, {207,0.01}, {208,0.01}, {209,0.01}, {210,0.01}, {211,0.011}, {212,0.011}, {213,0.011}, {214,0.011}, {215,0.009}, {216,0.011}, {217,0.011}, {218,0.011}, {219,0.011}, {220,0.011}, {221,0.012}, {222,0.014}, {223,0.012}, {224,0.015}, {225,0.012}, {226,0.012}, {227,0.012}, {228,0.012}, {229,0.016}, {230,0.013}, {231,0.013}, {232,0.013}, {233,0.017}, {234,0.02}, {235,0.013}, {236,0.017}, {237,0.011}, {238,0.013}, {239,0.013}, {240,0.013}, {241,0.013}, {242,0.013}, {243,0.01}, {244,0.013}, {245,0.012}, {246,0.013}, {247,0.018}, {248,0.014}, {249,0.014}, {250,0.011}, {251,0.014}, {252,0.014}, {253,0.012}, {254,0.017}, {255,0.013}, {256,0.012}, {257,0.017}, {258,0.02}, {259,0.011}, {260,0.015}, {261,0.012}, {262,0.016}, {263,0.013}, {264,0.014}, {265,0.013}, {266,0.019}, {267,0.015}, {268,0.015}, {269,0.014}, {270,0.013}, {271,0.014}, {272,0.019}, {273,0.015}, {274,0.015}, {275,0.015}, {276,0.016}, {277,0.016}, {278,0.016}, {279,0.014}};
data["big"]["CanonicalStructuresPHOAS"]["eval lazy"]["user"] = {{1,0.00003636}, {2,0.00000000}, {3,0.00010909}, {4,0.00007273}, {5,0.00010000}, {6,0.00010000}, {7,0.00013636}, {8,0.00011818}, {9,0.00007273}, {10,0.00010909}, {11,0.00020000}, {12,0.00014545}, {13,0.00010909}, {14,0.00015455}, {15,0.00017273}, {16,0.00006364}, {17,0.00017273}, {18,0.00018182}, {19,0.00007273}, {20,0.00031818}, {21,0.00003636}, {22,0.00014545}, {23,0.00023636}, {24,0.00020000}, {25,0.00030909}, {26,0.00024545}, {27,0.00025455}, {28,0.00017273}, {29,0.00017273}, {30,0.00034545}, {31,0.00027273}, {32,0.00028182}, {33,0.00040000}, {34,0.00028182}, {35,0.00034545}, {36,0.00056364}, {37,0.00043636}, {38,0.00061818}, {39,0.00041818}, {40,0.00036364}, {41,0.00029091}, {42,0.00049091}, {43,0.00034545}, {44,0.00041818}, {45,0.00049091}, {46,0.00038182}, {47,0.00046364}, {48,0.00070000}, {49,0.00058182}, {50,0.00068182}, {51,0.00060909}, {52,0.00043636}, {53,0.00057273}, {54,0.00070909}, {55,0.00046364}, {56,0.00074545}, {57,0.00086364}, {58,0.00068182}, {59,0.00089091}, {60,0.00049091}, {61,0.00200}, {62,0.00075}, {63,0.00000}, {64,0.00000}, {65,0.00075}, {66,0.00100}, {67,0.00150}, {68,0.00075}, {69,0.00000}, {70,0.00100}, {71,0.00100}, {72,0.00000}, {73,0.00075}, {74,0.00100}, {75,0.00175}, {76,0.00075}, {77,0.00275}, {78,0.00100}, {79,0.00175}, {80,0.00100}, {81,0.00075}, {82,0.00075}, {83,0.00225}, {84,0.00175}, {85,0.00075}, {86,0.00150}, {87,0.00000}, {88,0.00075}, {89,0.00150}, {90,0.00075}, {91,0.00150}, {92,0.00250}, {93,0.00250}, {94,0.00225}, {95,0.00150}, {96,0.00225}, {97,0.00175}, {98,0.00275}, {99,0.00075}, {100,0.00075}, {101,0.00150}, {102,0.00225}, {103,0.00250}, {104,0.00225}, {105,0.00225}, {106,0.00250}, {107,0.00225}, {108,0.00250}, {109,0.00250}, {110,0.00300}, {111,0.00225}, {112,0.00325}, {113,0.00250}, {114,0.00250}, {115,0.00300}, {116,0.00350}, {117,0.00250}, {118,0.00225}, {119,0.00250}, {120,0.00325}, {121,0.00150}, {122,0.00300}, {123,0.00425}, {124,0.00325}, {125,0.00250}, {126,0.00225}, {127,0.00300}, {128,0.00250}, {129,0.00275}, {130,0.00350}, {131,0.00250}, {132,0.00325}, {133,0.00300}, {134,0.00350}, {135,0.00450}, {136,0.00425}, {137,0.00225}, {138,0.00325}, {139,0.00425}, {140,0.00325}, {141,0.00325}, {142,0.00300}, {143,0.00400}, {144,0.00300}, {145,0.00425}, {146,0.00400}, {147,0.00450}, {148,0.00325}, {149,0.00400}, {150,0.00300}, {151,0.00300}, {152,0.00300}, {153,0.00400}, {154,0.00325}, {155,0.00300}, {156,0.00525}, {157,0.00300}, {158,0.00325}, {159,0.00450}, {160,0.00350}, {161,0.00450}, {162,0.00400}, {163,0.00400}, {164,0.00400}, {165,0.00525}, {166,0.00325}, {167,0.00425}, {168,0.00400}, {169,0.00600}, {170,0.00425}, {171,0.00425}, {172,0.00525}, {173,0.00425}, {174,0.00525}, {175,0.00525}, {176,0.00625}, {177,0.00425}, {178,0.00700}, {179,0.00625}, {180,0.00650}, {181,0.00600}, {182,0.00700}, {183,0.00525}, {184,0.00625}, {185,0.00525}, {186,0.00625}, {187,0.00650}, {188,0.00825}, {189,0.00600}, {190,0.00825}, {191,0.00700}, {192,0.00600}, {193,0.00625}, {194,0.00550}, {195,0.00700}, {196,0.00625}, {197,0.00700}, {198,0.00700}, {199,0.00700}, {200,0.00700}, {201,0.0080}, {202,0.007}, {203,0.011}, {204,0.008}, {205,0.012}, {206,0.008}, {207,0.011}, {208,0.011}, {209,0.012}, {210,0.011}, {211,0.012}, {212,0.012}, {213,0.011}, {214,0.012}, {215,0.011}, {216,0.011}, {217,0.012}, {218,0.011}, {219,0.011}, {220,0.011}, {221,0.011}, {222,0.011}, {223,0.011}, {224,0.015}, {225,0.012}, {226,0.011}, {227,0.011}, {228,0.011}, {229,0.016}, {230,0.012}, {231,0.015}, {232,0.015}, {233,0.02}, {234,0.02}, {235,0.012}, {236,0.016}, {237,0.012}, {238,0.015}, {239,0.007}, {240,0.011}, {241,0.015}, {242,0.012}, {243,0.012}, {244,0.012}, {245,0.011}, {246,0.016}, {247,0.02}, {248,0.015}, {249,0.015}, {250,0.012}, {251,0.015}, {252,0.016}, {253,0.011}, {254,0.015}, {255,0.011}, {256,0.011}, {257,0.015}, {258,0.02}, {259,0.011}, {260,0.016}, {261,0.011}, {262,0.015}, {263,0.012}, {264,0.015}, {265,0.015}, {266,0.02}, {267,0.015}, {268,0.015}, {269,0.011}, {270,0.011}, {271,0.015}, {272,0.02}, {273,0.015}, {274,0.015}, {275,0.015}, {276,0.015}, {277,0.015}, {278,0.02}, {279,0.015}};
data["big"]["CanonicalStructuresPHOAS"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00003636}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00003636}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00003636}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00003636}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00100}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00100}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00100}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0.004}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}};
data["big"]["CanonicalStructuresPHOAS"]["intros _"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00025}, {82,0.00000}, {83,0.00025}, {84,0.00000}, {85,0.00000}, {86,0.00025}, {87,0.00025}, {88,0.00025}, {89,0.00000}, {90,0.00025}, {91,0.00025}, {92,0.00025}, {93,0.00050}, {94,0.00050}, {95,0.00050}, {96,0.00050}, {97,0.00075}, {98,0.00075}, {99,0.00100}, {100,0.00075}, {101,0.00050}, {102,0.00100}, {103,0.00050}, {104,0.00100}, {105,0.00075}, {106,0.00050}, {107,0.00100}, {108,0.00075}, {109,0.00100}, {110,0.00100}, {111,0.00075}, {112,0.00100}, {113,0.00100}, {114,0.00075}, {115,0.00100}, {116,0.00100}, {117,0.00075}, {118,0.00100}, {119,0.00100}, {120,0.00100}, {121,0.00125}, {122,0.00150}, {123,0.00150}, {124,0.00100}, {125,0.00100}, {126,0.00125}, {127,0.00150}, {128,0.00100}, {129,0.00125}, {130,0.00150}, {131,0.00150}, {132,0.00150}, {133,0.00175}, {134,0.00175}, {135,0.00150}, {136,0.00175}, {137,0.00175}, {138,0.00175}, {139,0.00175}, {140,0.00150}, {141,0.00250}, {142,0.00200}, {143,0.00200}, {144,0.00200}, {145,0.00175}, {146,0.00175}, {147,0.00175}, {148,0.00200}, {149,0.00200}, {150,0.00150}, {151,0.00175}, {152,0.00200}, {153,0.00200}, {154,0.00175}, {155,0.00200}, {156,0.00200}, {157,0.00200}, {158,0.00175}, {159,0.00200}, {160,0.00200}, {161,0.00200}, {162,0.00200}, {163,0.00225}, {164,0.00200}, {165,0.00225}, {166,0.00225}, {167,0.00250}, {168,0.00225}, {169,0.00225}, {170,0.00225}, {171,0.00250}, {172,0.00250}, {173,0.00225}, {174,0.00275}, {175,0.00250}, {176,0.00275}, {177,0.00250}, {178,0.00300}, {179,0.00250}, {180,0.00300}, {181,0.00250}, {182,0.00300}, {183,0.00300}, {184,0.00275}, {185,0.00300}, {186,0.00375}, {187,0.00300}, {188,0.00325}, {189,0.00300}, {190,0.00375}, {191,0.00325}, {192,0.00300}, {193,0.00325}, {194,0.00300}, {195,0.00300}, {196,0.00325}, {197,0.00350}, {198,0.00325}, {199,0.00333}, {200,0.00367}, {201,0.0045}, {202,0.004}, {203,0.005}, {204,0.005}, {205,0.005}, {206,0.005}, {207,0.005}, {208,0.005}, {209,0.005}, {210,0.005}, {211,0.006}, {212,0.005}, {213,0.005}, {214,0.005}, {215,0.004}, {216,0.005}, {217,0.006}, {218,0.005}, {219,0.006}, {220,0.005}, {221,0.006}, {222,0.006}, {223,0.006}, {224,0.006}, {225,0.006}, {226,0.006}, {227,0.006}, {228,0.006}, {229,0.007}, {230,0.006}, {231,0.006}, {232,0.006}, {233,0.007}, {234,0.007}, {235,0.007}, {236,0.007}, {237,0.005}, {238,0.006}, {239,0.006}, {240,0.006}, {241,0.007}, {242,0.007}, {243,0.005}, {244,0.006}, {245,0.005}, {246,0.006}, {247,0.006}, {248,0.006}, {249,0.006}, {250,0.005}, {251,0.006}, {252,0.006}, {253,0.005}, {254,0.006}, {255,0.006}, {256,0.005}, {257,0.006}, {258,0.006}, {259,0.005}, {260,0.007}, {261,0.006}, {262,0.008}, {263,0.006}, {264,0.007}, {265,0.006}, {266,0.007}, {267,0.007}, {268,0.007}, {269,0.007}, {270,0.006}, {271,0.007}, {272,0.007}, {273,0.008}, {274,0.009}, {275,0.008}, {276,0.008}, {277,0.008}, {278,0.008}, {279,0.007}};
data["big"]["CanonicalStructuresPHOAS"]["intros _"]["user"] = {{1,0.00003636}, {2,0.00000000}, {3,0.00000000}, {4,0.00010909}, {5,0.00003636}, {6,0.00003636}, {7,0.00007273}, {8,0.00002727}, {9,0.00002727}, {10,0.00002727}, {11,0.00007273}, {12,0.00002727}, {13,0.00006364}, {14,0.00002727}, {15,0.00000000}, {16,0.00000000}, {17,0.00007273}, {18,0.00003636}, {19,0.00010909}, {20,0.00000000}, {21,0.00000000}, {22,0.00016364}, {23,0.00007273}, {24,0.00000000}, {25,0.00006364}, {26,0.00006364}, {27,0.00000000}, {28,0.00002727}, {29,0.00006364}, {30,0.00006364}, {31,0.00014545}, {32,0.00010909}, {33,0.00003636}, {34,0.00010000}, {35,0.00007273}, {36,0.00010909}, {37,0.00014545}, {38,0.00009091}, {39,0.00006364}, {40,0.00020000}, {41,0.00028182}, {42,0.00018182}, {43,0.00014545}, {44,0.00007273}, {45,0.00010909}, {46,0.00009091}, {47,0.00010909}, {48,0.00010000}, {49,0.00007273}, {50,0.00013636}, {51,0.00009091}, {52,0.00024545}, {53,0.00012727}, {54,0.00035455}, {55,0.00034545}, {56,0.00028182}, {57,0.00014545}, {58,0.00020000}, {59,0.00010000}, {60,0.00014545}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00100}, {66,0.00100}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00200}, {71,0.00000}, {72,0.00075}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00075}, {77,0.00000}, {78,0.00000}, {79,0.00100}, {80,0.00100}, {81,0.00075}, {82,0.00000}, {83,0.00000}, {84,0.00100}, {85,0.00000}, {86,0.00075}, {87,0.00100}, {88,0.00150}, {89,0.00075}, {90,0.00175}, {91,0.00000}, {92,0.00000}, {93,0.00075}, {94,0.00075}, {95,0.00150}, {96,0.00075}, {97,0.00000}, {98,0.00075}, {99,0.00225}, {100,0.00075}, {101,0.00075}, {102,0.00075}, {103,0.00175}, {104,0.00175}, {105,0.00075}, {106,0.00075}, {107,0.00075}, {108,0.00100}, {109,0.00175}, {110,0.00200}, {111,0.00075}, {112,0.00075}, {113,0.00075}, {114,0.00150}, {115,0.00100}, {116,0.00075}, {117,0.00075}, {118,0.00075}, {119,0.00225}, {120,0.00175}, {121,0.00225}, {122,0.00075}, {123,0.00150}, {124,0.00150}, {125,0.00100}, {126,0.00000}, {127,0.00150}, {128,0.00275}, {129,0.00225}, {130,0.00075}, {131,0.00075}, {132,0.00250}, {133,0.00250}, {134,0.00225}, {135,0.00200}, {136,0.00100}, {137,0.00300}, {138,0.00150}, {139,0.00225}, {140,0.00075}, {141,0.00150}, {142,0.00300}, {143,0.00150}, {144,0.00150}, {145,0.00075}, {146,0.00150}, {147,0.00150}, {148,0.00300}, {149,0.00175}, {150,0.00225}, {151,0.00325}, {152,0.00225}, {153,0.00175}, {154,0.00300}, {155,0.00225}, {156,0.00300}, {157,0.00225}, {158,0.00150}, {159,0.00150}, {160,0.00150}, {161,0.00150}, {162,0.00200}, {163,0.00225}, {164,0.00250}, {165,0.00225}, {166,0.00250}, {167,0.00225}, {168,0.00225}, {169,0.00075}, {170,0.00325}, {171,0.00350}, {172,0.00150}, {173,0.00150}, {174,0.00225}, {175,0.00300}, {176,0.00300}, {177,0.00225}, {178,0.00250}, {179,0.00000}, {180,0.00350}, {181,0.00375}, {182,0.00275}, {183,0.00275}, {184,0.00375}, {185,0.00350}, {186,0.00350}, {187,0.00325}, {188,0.00325}, {189,0.00200}, {190,0.00375}, {191,0.00300}, {192,0.00275}, {193,0.00275}, {194,0.00250}, {195,0.00350}, {196,0.00375}, {197,0.00300}, {198,0.00350}, {199,0.00233}, {200,0.00367}, {201,0.0030}, {202,0.007}, {203,0.004}, {204,0.007}, {205,0.003}, {206,0.008}, {207,0.003}, {208,0.003}, {209,0.003}, {210,0.004}, {211,0.003}, {212,0.003}, {213,0.008}, {214,0.003}, {215,0.004}, {216,0.004}, {217,0.003}, {218,0.003}, {219,0.008}, {220,0.007}, {221,0.008}, {222,0.007}, {223,0.008}, {224,0.008}, {225,0.003}, {226,0.008}, {227,0.008}, {228,0.008}, {229,0.007}, {230,0.007}, {231,0.007}, {232,0.003}, {233,0.003}, {234,0.007}, {235,0.007}, {236,0.007}, {237,0.004}, {238,0.007}, {239,0.007}, {240,0.007}, {241,0.007}, {242,0.007}, {243,0.003}, {244,0.007}, {245,0.003}, {246,0.003}, {247,0.003}, {248,0.004}, {249,0.007}, {250,0.004}, {251,0.008}, {252,0.003}, {253,0.008}, {254,0.007}, {255,0.008}, {256,0.004}, {257,0.008}, {258,0.008}, {259,0.008}, {260,0.007}, {261,0.008}, {262,0.008}, {263,0.007}, {264,0.008}, {265,0.003}, {266,0.008}, {267,0.008}, {268,0.007}, {269,0.004}, {270,0.008}, {271,0.008}, {272,0.007}, {273,0.008}, {274,0.012}, {275,0.007}, {276,0.008}, {277,0.011}, {278,0.007}, {279,0.007}};
data["big"]["CanonicalStructuresPHOAS"]["intros _"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00003636}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00007273}, {57,0.00000000}, {58,0.00003636}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00100}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}};
data["big"]["CanonicalStructuresPHOAS"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00004545}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0.004}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}};
data["big"]["CanonicalStructuresPHOAS"]["lazy beta iota"]["user"] = {{1,0.00003636}, {2,0.00000000}, {3,0.00003636}, {4,0.00003636}, {5,0.00000000}, {6,0.00002727}, {7,0.00002727}, {8,0.00003636}, {9,0.00000000}, {10,0.00002727}, {11,0.00003636}, {12,0.00000000}, {13,0.00003636}, {14,0.00007273}, {15,0.00000000}, {16,0.00007273}, {17,0.00003636}, {18,0.00003636}, {19,0.00002727}, {20,0.00003636}, {21,0.00010000}, {22,0.00000000}, {23,0.00003636}, {24,0.00007273}, {25,0.00000000}, {26,0.00002727}, {27,0.00000000}, {28,0.00000000}, {29,0.00003636}, {30,0.00003636}, {31,0.00003636}, {32,0.00007273}, {33,0.00003636}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00003636}, {39,0.00010909}, {40,0.00000000}, {41,0.00000000}, {42,0.00002727}, {43,0.00003636}, {44,0.00000000}, {45,0.00003636}, {46,0.00003636}, {47,0.00003636}, {48,0.00003636}, {49,0.00003636}, {50,0.00000000}, {51,0.00003636}, {52,0.00002727}, {53,0.00002727}, {54,0.00000000}, {55,0.00003636}, {56,0.00000000}, {57,0.00010909}, {58,0.00006364}, {59,0.00012727}, {60,0.00007273}, {61,0.00000}, {62,0.00000}, {63,0.00075}, {64,0.00000}, {65,0.00000}, {66,0.00100}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00100}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00100}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00075}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00075}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00075}, {145,0.00075}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00075}, {150,0.00000}, {151,0.00000}, {152,0.00075}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00075}, {160,0.00100}, {161,0.00000}, {162,0.00000}, {163,0.00075}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00075}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00075}, {174,0.00075}, {175,0.00000}, {176,0.00000}, {177,0.00075}, {178,0.00000}, {179,0.00150}, {180,0.00000}, {181,0.00000}, {182,0.00100}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00075}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00100}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0.004}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0.003}, {249,0}, {250,0.003}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0.004}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0.003}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}};
data["big"]["CanonicalStructuresPHOAS"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003636}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00100}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}};
data["big"]["CanonicalStructuresPHOAS"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00100000}, {3,0.00200000}, {4,0.00318182}, {5,0.00501818}, {6,0.00720000}, {7,0.02521818}, {8,0.01328182}, {9,0.01757273}, {10,0.02240000}, {11,0.02822727}, {12,0.03510909}, {13,0.04245455}, {14,0.05343636}, {15,0.06525455}, {16,0.07570000}, {17,0.08817273}, {18,0.10201818}, {19,0.11489091}, {20,0.13438182}, {21,0.15430909}, {22,0.17486364}, {23,0.20013636}, {24,0.22616364}, {25,0.25203636}, {26,0.28049091}, {27,0.31256364}, {28,0.34578182}, {29,0.38231818}, {30,0.42159091}, {31,0.46823636}, {32,0.51155455}, {33,0.55562727}, {34,0.60580909}, {35,0.65416364}, {36,0.71221818}, {37,0.77171818}, {38,0.83295455}, {39,0.90637273}, {40,0.96859091}, {41,1.04013636}, {42,1.11952727}, {43,1.19739091}, {44,1.28426364}, {45,1.37310000}, {46,1.46607273}, {47,1.56305455}, {48,1.66290000}, {49,1.76888182}, {50,1.88140909}, {51,1.99897273}, {52,2.11790000}, {53,2.24807273}, {54,2.37810909}, {55,2.50716364}, {56,3.25269091}, {57,2.80772727}, {58,2.95476364}, {59,3.10310909}, {60,3.25268182}, {61,3.63750}, {62,3.76225}, {63,3.89550}, {64,4.12250}, {65,4.38725}, {66,4.67175}, {67,4.82325}, {68,4.99775}, {69,5.29575}, {70,5.61800}, {71,5.80400}, {72,5.89500}, {73,6.23125}, {74,6.52400}, {75,6.80325}, {76,7.10075}, {77,7.42925}, {78,7.72975}, {79,8.06450}, {80,8.23375}, {81,8.76300}, {82,9.02325}, {83,9.69375}, {84,10.14175}, {85,10.06475}, {86,10.46225}, {87,10.86850}, {88,11.19300}, {89,11.71650}, {90,12.03325}, {91,12.50325}, {92,12.81525}, {93,13.31525}, {94,13.72225}, {95,14.21350}, {96,14.71300}, {97,15.15525}, {98,15.82875}, {99,16.46125}, {100,17.14325}, {101,17.39200}, {102,17.88700}, {103,18.36425}, {104,18.88575}, {105,19.60175}, {106,20.20325}, {107,20.76000}, {108,21.41475}, {109,22.28700}, {110,22.98425}, {111,23.74400}, {112,24.41075}, {113,25.33075}, {114,25.83350}, {115,26.50875}, {116,27.25300}, {117,28.06525}, {118,28.81175}, {119,29.60625}, {120,30.33500}, {121,31.07825}, {122,32.01125}, {123,32.85400}, {124,33.57100}, {125,34.41425}, {126,35.13275}, {127,36.18950}, {128,37.28800}, {129,37.90400}, {130,39.50875}, {131,40.00975}, {132,41.49275}, {133,42.66575}, {134,43.73500}, {135,44.51000}, {136,45.43525}, {137,46.63375}, {138,47.77175}, {139,48.78125}, {140,50.22000}, {141,51.54400}, {142,52.34625}, {143,53.65900}, {144,54.95850}, {145,56.58825}, {146,58.16800}, {147,59.28775}, {148,60.47900}, {149,62.16650}, {150,63.48125}, {151,64.39250}, {152,65.32200}, {153,67.16925}, {154,68.44850}, {155,70.17825}, {156,71.71700}, {157,73.03600}, {158,74.59400}, {159,76.05675}, {160,77.21575}, {161,78.69400}, {162,80.81225}, {163,83.20950}, {164,83.60450}, {165,85.29700}, {166,88.28700}, {167,88.52925}, {168,90.48500}, {169,92.43225}, {170,94.63075}, {171,95.67500}, {172,98.06575}, {173,100.15475}, {174,101.84850}, {175,103.46775}, {176,105.72250}, {177,108.33000}, {178,109.54900}, {179,112.41575}, {180,114.75500}, {181,117.20150}, {182,118.59475}, {183,120.82075}, {184,123.48875}, {185,126.00125}, {186,127.55375}, {187,130.66950}, {188,133.09800}, {189,136.35025}, {190,137.24575}, {191,138.18300}, {192,141.09150}, {193,143.33350}, {194,146.23125}, {195,148.90850}, {196,151.19325}, {197,153.49325}, {198,156.20875}, {199,159.26967}, {200,160.75667}, {201,169.0610}, {202,167.878}, {203,176.945}, {204,177.81}, {205,180.971}, {206,185.524}, {207,186.559}, {208,191.204}, {209,193.914}, {210,196.313}, {211,200.669}, {212,202.778}, {213,206.842}, {214,209.953}, {215,219.217}, {216,215.776}, {217,220.992}, {218,222.13}, {219,226.647}, {220,230.597}, {221,233.42}, {222,237.532}, {223,242.016}, {224,245.225}, {225,248.233}, {226,253.949}, {227,256.827}, {228,259.324}, {229,265.138}, {230,269.105}, {231,272.425}, {232,277.293}, {233,280.721}, {234,284.54}, {235,289.434}, {236,293.511}, {237,299.431}, {238,298.941}, {239,307.413}, {240,308.576}, {241,313.423}, {242,320.584}, {243,333.111}, {244,316.121}, {245,323.771}, {246,325.565}, {247,329.949}, {248,336.804}, {249,343.266}, {250,346.731}, {251,349.768}, {252,353.54}, {253,363.044}, {254,377.912}, {255,382.483}, {256,394.798}, {257,398.363}, {258,399.822}, {259,413.651}, {260,403.936}, {261,424.077}, {262,415.088}, {263,426.962}, {264,430.793}, {265,442.1}, {266,440.703}, {267,448.131}, {268,453.89}, {269,459.453}, {270,471.94}, {271,473.098}, {272,480.369}, {273,482.01}, {274,490.076}, {275,494.284}, {276,500.464}, {277,511.776}, {278,513.654}, {279,528.433}};
data["big"]["CanonicalStructuresPHOAS"]["norm reif"]["user"] = {{1,0.00080909}, {2,0.00140000}, {3,0.00252727}, {4,0.00356364}, {5,0.00525455}, {6,0.00722727}, {7,0.02541818}, {8,0.01341818}, {9,0.01746364}, {10,0.02279091}, {11,0.02842727}, {12,0.03497273}, {13,0.04236364}, {14,0.05353636}, {15,0.06489091}, {16,0.07570000}, {17,0.08786364}, {18,0.10205455}, {19,0.11464545}, {20,0.13416364}, {21,0.15421818}, {22,0.17475455}, {23,0.20008182}, {24,0.22582727}, {25,0.25202727}, {26,0.28040000}, {27,0.31246364}, {28,0.34559091}, {29,0.38237273}, {30,0.42179091}, {31,0.46800000}, {32,0.51122727}, {33,0.55560909}, {34,0.60556364}, {35,0.65398182}, {36,0.71270909}, {37,0.77137273}, {38,0.83284545}, {39,0.90620909}, {40,0.96845455}, {41,1.03959091}, {42,1.11959091}, {43,1.19703636}, {44,1.28420000}, {45,1.37287273}, {46,1.46588182}, {47,1.56286364}, {48,1.66268182}, {49,1.76871818}, {50,1.88126364}, {51,1.99871818}, {52,2.11740909}, {53,2.24810000}, {54,2.37781818}, {55,2.50671818}, {56,3.25030909}, {57,2.80731818}, {58,2.95421818}, {59,3.10302727}, {60,3.25210909}, {61,3.63625}, {62,3.76150}, {63,3.89425}, {64,4.12075}, {65,4.38725}, {66,4.67125}, {67,4.82450}, {68,4.99875}, {69,5.29475}, {70,5.61750}, {71,5.80450}, {72,5.89275}, {73,6.23250}, {74,6.52375}, {75,6.80525}, {76,7.09950}, {77,7.42875}, {78,7.73000}, {79,8.06250}, {80,8.23375}, {81,8.76175}, {82,9.02250}, {83,9.69200}, {84,10.13750}, {85,10.06425}, {86,10.46175}, {87,10.86550}, {88,11.18975}, {89,11.71700}, {90,12.03150}, {91,12.50325}, {92,12.81575}, {93,13.31550}, {94,13.72200}, {95,14.21325}, {96,14.71225}, {97,15.15550}, {98,15.82750}, {99,16.45750}, {100,17.13575}, {101,17.38525}, {102,17.87925}, {103,18.35475}, {104,18.87675}, {105,19.59250}, {106,20.19275}, {107,20.74950}, {108,21.40225}, {109,22.27850}, {110,22.97125}, {111,23.73050}, {112,24.40025}, {113,25.31775}, {114,25.82650}, {115,26.49825}, {116,27.24750}, {117,28.05850}, {118,28.80200}, {119,29.59950}, {120,30.32475}, {121,31.07300}, {122,32.01150}, {123,32.85425}, {124,33.56875}, {125,34.41450}, {126,35.13075}, {127,36.18850}, {128,37.28625}, {129,37.89900}, {130,39.50675}, {131,40.01000}, {132,41.47825}, {133,42.65550}, {134,43.72075}, {135,44.49350}, {136,45.41750}, {137,46.62050}, {138,47.75650}, {139,48.77800}, {140,50.21725}, {141,51.53775}, {142,52.33825}, {143,53.65550}, {144,54.94650}, {145,56.58450}, {146,58.16050}, {147,59.28475}, {148,60.47150}, {149,62.15525}, {150,63.45250}, {151,64.38925}, {152,65.27400}, {153,67.16125}, {154,68.43725}, {155,70.15150}, {156,71.70825}, {157,73.02725}, {158,74.57225}, {159,76.04575}, {160,77.19775}, {161,78.68950}, {162,80.79550}, {163,83.19400}, {164,83.46725}, {165,85.28850}, {166,88.26050}, {167,88.52700}, {168,90.47125}, {169,92.41425}, {170,94.62150}, {171,95.66550}, {172,98.05175}, {173,100.14525}, {174,101.83875}, {175,103.44600}, {176,105.69850}, {177,108.31475}, {178,109.54050}, {179,112.39275}, {180,114.73750}, {181,117.18125}, {182,118.57350}, {183,120.80550}, {184,123.46300}, {185,125.97675}, {186,127.54075}, {187,130.63075}, {188,133.07975}, {189,136.31750}, {190,137.23250}, {191,138.16200}, {192,141.06750}, {193,143.30650}, {194,146.20850}, {195,148.87850}, {196,151.16725}, {197,153.47250}, {198,156.18950}, {199,159.25167}, {200,160.73833}, {201,168.2240}, {202,167.7}, {203,176.724}, {204,177.768}, {205,180.972}, {206,185.5}, {207,186.536}, {208,191.203}, {209,193.915}, {210,196.311}, {211,200.672}, {212,202.78}, {213,206.843}, {214,209.956}, {215,219.215}, {216,215.775}, {217,220.924}, {218,222.132}, {219,226.643}, {220,230.595}, {221,233.42}, {222,237.532}, {223,242.015}, {224,245.223}, {225,248.236}, {226,253.947}, {227,256.827}, {228,259.323}, {229,265.14}, {230,269.108}, {231,272.427}, {232,277.296}, {233,280.724}, {234,284.54}, {235,289.432}, {236,293.512}, {237,299.427}, {238,298.832}, {239,307.371}, {240,308.443}, {241,313.343}, {242,320.516}, {243,332.952}, {244,316.119}, {245,323.772}, {246,325.52}, {247,329.952}, {248,336.744}, {249,343.2}, {250,346.695}, {251,349.715}, {252,353.544}, {253,361.22}, {254,377.816}, {255,382.479}, {256,394.664}, {257,398.311}, {258,399.824}, {259,413.579}, {260,400.956}, {261,421.087}, {262,415.087}, {263,426.956}, {264,430.791}, {265,439.308}, {266,440.703}, {267,448.043}, {268,453.804}, {269,459.412}, {270,471.876}, {271,473.099}, {272,480.296}, {273,482.008}, {274,490.027}, {275,494.22}, {276,500.403}, {277,509.952}, {278,513.592}, {279,528.283}};
data["big"]["CanonicalStructuresPHOAS"]["norm reif"]["system"] = {{1,0.00000000}, {2,0.00007273}, {3,0.00000000}, {4,0.00000000}, {5,0.00003636}, {6,0.00003636}, {7,0.00003636}, {8,0.00000000}, {9,0.00007273}, {10,0.00003636}, {11,0.00000000}, {12,0.00007273}, {13,0.00007273}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00003636}, {18,0.00003636}, {19,0.00003636}, {20,0.00007273}, {21,0.00003636}, {22,0.00000000}, {23,0.00003636}, {24,0.00000000}, {25,0.00003636}, {26,0.00000000}, {27,0.00000000}, {28,0.00003636}, {29,0.00006364}, {30,0.00000000}, {31,0.00006364}, {32,0.00003636}, {33,0.00002727}, {34,0.00007273}, {35,0.00003636}, {36,0.00003636}, {37,0.00007273}, {38,0.00003636}, {39,0.00003636}, {40,0.00010909}, {41,0.00010909}, {42,0.00025455}, {43,0.00007273}, {44,0.00007273}, {45,0.00014545}, {46,0.00010909}, {47,0.00020909}, {48,0.00014545}, {49,0.00014545}, {50,0.00010909}, {51,0.00018182}, {52,0.00047273}, {53,0.00010909}, {54,0.00032727}, {55,0.00014545}, {56,0.00219091}, {57,0.00021818}, {58,0.00014545}, {59,0.00029091}, {60,0.00036364}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00100}, {73,0.00000}, {74,0.00100}, {75,0.00000}, {76,0.00200}, {77,0.00100}, {78,0.00000}, {79,0.00200}, {80,0.00100}, {81,0.00100}, {82,0.00000}, {83,0.00175}, {84,0.00200}, {85,0.00000}, {86,0.00000}, {87,0.00100}, {88,0.00100}, {89,0.00000}, {90,0.00100}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00100}, {101,0.00000}, {102,0.00000}, {103,0.00100}, {104,0.00100}, {105,0.00100}, {106,0.00100}, {107,0.00100}, {108,0.00200}, {109,0.00100}, {110,0.00175}, {111,0.00375}, {112,0.00100}, {113,0.00300}, {114,0.00100}, {115,0.00400}, {116,0.00000}, {117,0.00100}, {118,0.00300}, {119,0.00000}, {120,0.00300}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00200}, {125,0.00000}, {126,0.00300}, {127,0.00100}, {128,0.00000}, {129,0.00300}, {130,0.00200}, {131,0.00100}, {132,0.00500}, {133,0.00100}, {134,0.00500}, {135,0.00800}, {136,0.00900}, {137,0.00300}, {138,0.00700}, {139,0.00400}, {140,0.00300}, {141,0.00600}, {142,0.00675}, {143,0.00400}, {144,0.00875}, {145,0.00300}, {146,0.00700}, {147,0.00200}, {148,0.00575}, {149,0.01075}, {150,0.02675}, {151,0.00300}, {152,0.00100}, {153,0.00700}, {154,0.01000}, {155,0.02275}, {156,0.00800}, {157,0.00800}, {158,0.01975}, {159,0.01100}, {160,0.01675}, {161,0.00300}, {162,0.01600}, {163,0.01500}, {164,0.00800}, {165,0.00850}, {166,0.02600}, {167,0.00200}, {168,0.01400}, {169,0.01775}, {170,0.00800}, {171,0.00800}, {172,0.01400}, {173,0.01075}, {174,0.00800}, {175,0.02100}, {176,0.02275}, {177,0.01475}, {178,0.00800}, {179,0.02375}, {180,0.01675}, {181,0.01900}, {182,0.02100}, {183,0.01400}, {184,0.02500}, {185,0.02300}, {186,0.01300}, {187,0.03900}, {188,0.01800}, {189,0.03350}, {190,0.01400}, {191,0.02000}, {192,0.02400}, {193,0.02775}, {194,0.02200}, {195,0.02875}, {196,0.02600}, {197,0.02100}, {198,0.01775}, {199,0.01867}, {200,0.01733}, {201,0.0835}, {202,0.036}, {203,0.072}, {204,0.004}, {205,0}, {206,0.024}, {207,0.024}, {208,0}, {209,0}, {210,0.004}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0.004}, {216,0}, {217,0.067}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0.004}, {238,0.111}, {239,0.04}, {240,0.128}, {241,0.079}, {242,0.068}, {243,0.159}, {244,0}, {245,0}, {246,0.048}, {247,0}, {248,0.06}, {249,0.068}, {250,0.036}, {251,0.052}, {252,0}, {253,0.004}, {254,0.052}, {255,0.004}, {256,0.135}, {257,0.004}, {258,0}, {259,0.072}, {260,0}, {261,0.035}, {262,0}, {263,0.004}, {264,0.004}, {265,0.072}, {266,0}, {267,0.084}, {268,0.088}, {269,0.044}, {270,0.064}, {271,0}, {272,0.072}, {273,0}, {274,0.047}, {275,0.064}, {276,0.06}, {277,0.076}, {278,0.064}, {279,0.148}};
data["big"]["CanonicalStructuresPHOAS"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}};
data["big"]["CanonicalStructuresPHOAS"]["post"]["user"] = {{1,0.00006364}, {2,0.00007273}, {3,0.00007273}, {4,0.00003636}, {5,0.00002727}, {6,0.00003636}, {7,0.00003636}, {8,0.00010909}, {9,0.00006364}, {10,0.00000000}, {11,0.00003636}, {12,0.00010909}, {13,0.00000000}, {14,0.00002727}, {15,0.00000000}, {16,0.00000000}, {17,0.00006364}, {18,0.00002727}, {19,0.00007273}, {20,0.00007273}, {21,0.00003636}, {22,0.00006364}, {23,0.00007273}, {24,0.00006364}, {25,0.00002727}, {26,0.00003636}, {27,0.00007273}, {28,0.00000000}, {29,0.00000000}, {30,0.00002727}, {31,0.00005455}, {32,0.00003636}, {33,0.00000000}, {34,0.00003636}, {35,0.00003636}, {36,0.00002727}, {37,0.00000000}, {38,0.00007273}, {39,0.00006364}, {40,0.00006364}, {41,0.00000000}, {42,0.00010909}, {43,0.00003636}, {44,0.00003636}, {45,0.00002727}, {46,0.00006364}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00007273}, {51,0.00003636}, {52,0.00003636}, {53,0.00010000}, {54,0.00003636}, {55,0.00003636}, {56,0.00007273}, {57,0.00000000}, {58,0.00007273}, {59,0.00003636}, {60,0.00003636}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00075}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00075}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00100}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}};
data["big"]["CanonicalStructuresPHOAS"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}};
data["big"]["CanonicalStructuresPHOAS"]["postprocess"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00025}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}};
data["big"]["CanonicalStructuresPHOAS"]["postprocess"]["user"] = {{1,0.00003636}, {2,0.00003636}, {3,0.00002727}, {4,0.00002727}, {5,0.00007273}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00003636}, {10,0.00003636}, {11,0.00000000}, {12,0.00000000}, {13,0.00002727}, {14,0.00002727}, {15,0.00007273}, {16,0.00006364}, {17,0.00003636}, {18,0.00009091}, {19,0.00000000}, {20,0.00000000}, {21,0.00010000}, {22,0.00003636}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00014545}, {27,0.00010000}, {28,0.00000000}, {29,0.00003636}, {30,0.00003636}, {31,0.00007273}, {32,0.00000000}, {33,0.00000000}, {34,0.00003636}, {35,0.00000000}, {36,0.00007273}, {37,0.00003636}, {38,0.00003636}, {39,0.00007273}, {40,0.00010000}, {41,0.00000000}, {42,0.00000000}, {43,0.00007273}, {44,0.00003636}, {45,0.00003636}, {46,0.00000000}, {47,0.00013636}, {48,0.00000000}, {49,0.00006364}, {50,0.00007273}, {51,0.00003636}, {52,0.00010909}, {53,0.00003636}, {54,0.00002727}, {55,0.00003636}, {56,0.00007273}, {57,0.00007273}, {58,0.00000000}, {59,0.00006364}, {60,0.00003636}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00100}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00100}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00100}, {126,0.00175}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00100}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00075}, {156,0.00000}, {157,0.00000}, {158,0.00075}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00100}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00075}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00100}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00075}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0.004}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0.004}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0.004}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}};
data["big"]["CanonicalStructuresPHOAS"]["postprocess"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00000}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}};
data["big"]["CanonicalStructuresPHOAS"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000909}, {10,0.00003636}, {11,0.00011818}, {12,0.00038182}, {13,0.00077273}, {14,0.00100000}, {15,0.00100000}, {16,0.00100000}, {17,0.00100000}, {18,0.00100000}, {19,0.00324545}, {20,0.00100000}, {21,0.00100000}, {22,0.00100000}, {23,0.00100000}, {24,0.00100000}, {25,0.00100000}, {26,0.00100000}, {27,0.00100000}, {28,0.00100000}, {29,0.00100000}, {30,0.00100000}, {31,0.00100000}, {32,0.00100000}, {33,0.00100000}, {34,0.00100000}, {35,0.00100000}, {36,0.00100000}, {37,0.00100909}, {38,0.00100000}, {39,0.00100000}, {40,0.00100000}, {41,0.00100000}, {42,0.00100000}, {43,0.00100000}, {44,0.00100909}, {45,0.00100000}, {46,0.00104545}, {47,0.00103636}, {48,0.00101818}, {49,0.00109091}, {50,0.00111818}, {51,0.00127273}, {52,0.00183636}, {53,0.00199091}, {54,0.00200000}, {55,0.00200000}, {56,0.00200000}, {57,0.00200000}, {58,0.00200000}, {59,0.00200000}, {60,0.00205455}, {61,0.00200}, {62,0.00200}, {63,0.00200}, {64,0.00200}, {65,0.00200}, {66,0.00250}, {67,0.00200}, {68,0.00250}, {69,0.00250}, {70,0.00200}, {71,0.00200}, {72,0.00200}, {73,0.00200}, {74,0.00200}, {75,0.00200}, {76,0.00200}, {77,0.00200}, {78,0.00200}, {79,0.00250}, {80,0.00200}, {81,0.00225}, {82,0.00225}, {83,0.00250}, {84,0.00250}, {85,0.00275}, {86,0.00300}, {87,0.00300}, {88,0.00300}, {89,0.00300}, {90,0.00300}, {91,0.00300}, {92,0.00300}, {93,0.00300}, {94,0.00300}, {95,0.00300}, {96,0.00300}, {97,0.00300}, {98,0.00300}, {99,0.00300}, {100,0.00300}, {101,0.00300}, {102,0.00300}, {103,0.00300}, {104,0.00300}, {105,0.00300}, {106,0.00300}, {107,0.00300}, {108,0.00300}, {109,0.00325}, {110,0.00325}, {111,0.00325}, {112,0.00350}, {113,0.00375}, {114,0.00400}, {115,0.00400}, {116,0.00400}, {117,0.00400}, {118,0.00400}, {119,0.00400}, {120,0.00400}, {121,0.00400}, {122,0.00400}, {123,0.00400}, {124,0.00400}, {125,0.00400}, {126,0.00400}, {127,0.00400}, {128,0.00400}, {129,0.00425}, {130,0.00400}, {131,0.00400}, {132,0.00400}, {133,0.00400}, {134,0.00400}, {135,0.00400}, {136,0.00400}, {137,0.00400}, {138,0.00475}, {139,0.00450}, {140,0.00475}, {141,0.00500}, {142,0.00500}, {143,0.00500}, {144,0.00500}, {145,0.00500}, {146,0.00500}, {147,0.00500}, {148,0.00500}, {149,0.00500}, {150,0.00550}, {151,0.00500}, {152,0.00500}, {153,0.00500}, {154,0.00500}, {155,0.00500}, {156,0.00500}, {157,0.00500}, {158,0.00500}, {159,0.00500}, {160,0.00500}, {161,0.00550}, {162,0.00550}, {163,0.00550}, {164,0.00575}, {165,0.00600}, {166,0.00600}, {167,0.00625}, {168,0.00600}, {169,0.00600}, {170,0.00600}, {171,0.00600}, {172,0.00600}, {173,0.00600}, {174,0.00650}, {175,0.00625}, {176,0.00600}, {177,0.00600}, {178,0.00650}, {179,0.00625}, {180,0.00600}, {181,0.00600}, {182,0.00600}, {183,0.00600}, {184,0.00650}, {185,0.00625}, {186,0.00700}, {187,0.00725}, {188,0.00700}, {189,0.00700}, {190,0.00775}, {191,0.00700}, {192,0.00750}, {193,0.00700}, {194,0.00700}, {195,0.00700}, {196,0.00700}, {197,0.00775}, {198,0.00750}, {199,0.00700}, {200,0.00700}, {201,0.0080}, {202,0.0075}, {203,0.007}, {204,0.008}, {205,0.008}, {206,0.008}, {207,0.008}, {208,0.008}, {209,0.008}, {210,0.008}, {211,0.008}, {212,0.008}, {213,0.008}, {214,0.009}, {215,0.008}, {216,0.008}, {217,0.009}, {218,0.008}, {219,0.009}, {220,0.009}, {221,0.009}, {222,0.009}, {223,0.009}, {224,0.009}, {225,0.009}, {226,0.009}, {227,0.009}, {228,0.009}, {229,0.009}, {230,0.009}, {231,0.009}, {232,0.009}, {233,0.009}, {234,0.009}, {235,0.009}, {236,0.009}, {237,0.01}, {238,0.009}, {239,0.009}, {240,0.01}, {241,0.01}, {242,0.01}, {243,0.011}, {244,0.01}, {245,0.01}, {246,0.01}, {247,0.01}, {248,0.01}, {249,0.01}, {250,0.01}, {251,0.01}, {252,0.01}, {253,0.01}, {254,0.01}, {255,0.01}, {256,0.011}, {257,0.01}, {258,0.011}, {259,0.011}, {260,0.011}, {261,0.011}, {262,0.011}, {263,0.011}, {264,0.012}, {265,0.011}, {266,0.011}, {267,0.011}, {268,0.011}, {269,0.011}, {270,0.011}, {271,0.011}, {272,0.011}, {273,0.012}, {274,0.012}, {275,0.012}, {276,0.012}, {277,0.012}, {278,0.012}, {279,0.012}, {280,0.012}};
data["big"]["CanonicalStructuresPHOAS"]["pre"]["user"] = {{1,0.00056364}, {2,0.00084545}, {3,0.00049091}, {4,0.00098182}, {5,0.00090909}, {6,0.00061818}, {7,0.00093636}, {8,0.00092727}, {9,0.00085455}, {10,0.00098182}, {11,0.00082727}, {12,0.00124545}, {13,0.00087273}, {14,0.00100909}, {15,0.00108182}, {16,0.00130000}, {17,0.00116364}, {18,0.00100909}, {19,0.00359091}, {20,0.00145455}, {21,0.00138182}, {22,0.00133636}, {23,0.00114545}, {24,0.00122727}, {25,0.00112727}, {26,0.00118182}, {27,0.00166364}, {28,0.00127273}, {29,0.00122727}, {30,0.00121818}, {31,0.00151818}, {32,0.00157273}, {33,0.00125455}, {34,0.00153636}, {35,0.00132727}, {36,0.00140000}, {37,0.00173636}, {38,0.00154545}, {39,0.00176364}, {40,0.00164545}, {41,0.00197273}, {42,0.00135455}, {43,0.00174545}, {44,0.00151818}, {45,0.00160000}, {46,0.00153636}, {47,0.00210909}, {48,0.00192727}, {49,0.00199091}, {50,0.00173636}, {51,0.00185455}, {52,0.00163636}, {53,0.00199091}, {54,0.00193636}, {55,0.00228182}, {56,0.00204545}, {57,0.00205455}, {58,0.00210909}, {59,0.00220909}, {60,0.00273636}, {61,0.00075}, {62,0.00150}, {63,0.00100}, {64,0.00375}, {65,0.00200}, {66,0.00175}, {67,0.00175}, {68,0.00225}, {69,0.00250}, {70,0.00075}, {71,0.00175}, {72,0.00375}, {73,0.00150}, {74,0.00175}, {75,0.00075}, {76,0.00175}, {77,0.00150}, {78,0.00150}, {79,0.00075}, {80,0.00100}, {81,0.00150}, {82,0.00300}, {83,0.00225}, {84,0.00225}, {85,0.00250}, {86,0.00300}, {87,0.00325}, {88,0.00225}, {89,0.00300}, {90,0.00300}, {91,0.00325}, {92,0.00225}, {93,0.00350}, {94,0.00250}, {95,0.00250}, {96,0.00250}, {97,0.00325}, {98,0.00325}, {99,0.00325}, {100,0.00225}, {101,0.00350}, {102,0.00300}, {103,0.00150}, {104,0.00300}, {105,0.00225}, {106,0.00225}, {107,0.00300}, {108,0.00325}, {109,0.00300}, {110,0.00325}, {111,0.00325}, {112,0.00325}, {113,0.00325}, {114,0.00350}, {115,0.00550}, {116,0.00325}, {117,0.00300}, {118,0.00425}, {119,0.00325}, {120,0.00300}, {121,0.00350}, {122,0.00425}, {123,0.00350}, {124,0.00450}, {125,0.00450}, {126,0.00325}, {127,0.00325}, {128,0.00450}, {129,0.00525}, {130,0.00525}, {131,0.00300}, {132,0.00325}, {133,0.00425}, {134,0.00325}, {135,0.00300}, {136,0.00325}, {137,0.00400}, {138,0.00650}, {139,0.00400}, {140,0.00575}, {141,0.00525}, {142,0.00425}, {143,0.00400}, {144,0.00400}, {145,0.00575}, {146,0.00525}, {147,0.00425}, {148,0.00400}, {149,0.00325}, {150,0.00625}, {151,0.00400}, {152,0.00350}, {153,0.00525}, {154,0.00500}, {155,0.00425}, {156,0.00550}, {157,0.00400}, {158,0.00625}, {159,0.00550}, {160,0.00600}, {161,0.00550}, {162,0.00600}, {163,0.00500}, {164,0.00525}, {165,0.00400}, {166,0.00525}, {167,0.00500}, {168,0.00300}, {169,0.00650}, {170,0.00600}, {171,0.00600}, {172,0.00525}, {173,0.00325}, {174,0.00650}, {175,0.00700}, {176,0.00625}, {177,0.00525}, {178,0.00625}, {179,0.00600}, {180,0.00700}, {181,0.00700}, {182,0.00700}, {183,0.00475}, {184,0.00700}, {185,0.00625}, {186,0.00600}, {187,0.00700}, {188,0.00600}, {189,0.00725}, {190,0.00650}, {191,0.00525}, {192,0.00650}, {193,0.00650}, {194,0.00725}, {195,0.00625}, {196,0.00700}, {197,0.00850}, {198,0.00725}, {199,0.00700}, {200,0.00733}, {201,0.0070}, {202,0.0075}, {203,0.007}, {204,0.008}, {205,0.007}, {206,0.008}, {207,0.008}, {208,0.012}, {209,0.008}, {210,0.007}, {211,0.007}, {212,0.007}, {213,0.008}, {214,0.008}, {215,0.007}, {216,0.007}, {217,0.011}, {218,0.007}, {219,0.012}, {220,0.008}, {221,0.007}, {222,0.007}, {223,0.007}, {224,0.012}, {225,0.007}, {226,0.012}, {227,0.007}, {228,0.007}, {229,0.007}, {230,0.007}, {231,0.007}, {232,0.007}, {233,0.007}, {234,0.007}, {235,0.012}, {236,0.007}, {237,0.012}, {238,0.007}, {239,0.008}, {240,0.012}, {241,0.008}, {242,0.011}, {243,0.007}, {244,0.012}, {245,0.011}, {246,0.007}, {247,0.007}, {248,0.011}, {249,0.007}, {250,0.007}, {251,0.012}, {252,0.008}, {253,0.011}, {254,0.011}, {255,0.011}, {256,0.011}, {257,0.012}, {258,0.007}, {259,0.011}, {260,0.011}, {261,0.011}, {262,0.011}, {263,0.011}, {264,0.012}, {265,0.011}, {266,0.012}, {267,0.012}, {268,0.012}, {269,0.011}, {270,0.011}, {271,0.012}, {272,0.011}, {273,0.015}, {274,0.011}, {275,0.011}, {276,0.011}, {277,0.011}, {278,0.012}, {279,0.012}, {280,0.011}};
data["big"]["CanonicalStructuresPHOAS"]["pre"]["system"] = {{1,0.00003636}, {2,0.00000000}, {3,0.00003636}, {4,0.00000000}, {5,0.00000000}, {6,0.00007273}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00003636}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00003636}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00003636}, {24,0.00003636}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00003636}, {29,0.00003636}, {30,0.00000000}, {31,0.00000000}, {32,0.00003636}, {33,0.00007273}, {34,0.00007273}, {35,0.00000000}, {36,0.00007273}, {37,0.00000000}, {38,0.00003636}, {39,0.00000000}, {40,0.00003636}, {41,0.00003636}, {42,0.00007273}, {43,0.00007273}, {44,0.00000000}, {45,0.00007273}, {46,0.00000000}, {47,0.00003636}, {48,0.00003636}, {49,0.00003636}, {50,0.00003636}, {51,0.00003636}, {52,0.00003636}, {53,0.00000000}, {54,0.00003636}, {55,0.00000000}, {56,0.00003636}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000}, {62,0.00000}, {63,0.00100}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00000}, {73,0.00000}, {74,0.00000}, {75,0.00000}, {76,0.00000}, {77,0.00000}, {78,0.00000}, {79,0.00000}, {80,0.00000}, {81,0.00000}, {82,0.00000}, {83,0.00000}, {84,0.00000}, {85,0.00000}, {86,0.00000}, {87,0.00000}, {88,0.00000}, {89,0.00000}, {90,0.00000}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00000}, {101,0.00000}, {102,0.00000}, {103,0.00000}, {104,0.00000}, {105,0.00000}, {106,0.00000}, {107,0.00000}, {108,0.00000}, {109,0.00000}, {110,0.00000}, {111,0.00000}, {112,0.00000}, {113,0.00000}, {114,0.00000}, {115,0.00000}, {116,0.00000}, {117,0.00000}, {118,0.00000}, {119,0.00000}, {120,0.00000}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00000}, {125,0.00000}, {126,0.00000}, {127,0.00000}, {128,0.00000}, {129,0.00000}, {130,0.00000}, {131,0.00000}, {132,0.00000}, {133,0.00000}, {134,0.00000}, {135,0.00000}, {136,0.00000}, {137,0.00000}, {138,0.00000}, {139,0.00000}, {140,0.00000}, {141,0.00000}, {142,0.00000}, {143,0.00000}, {144,0.00000}, {145,0.00000}, {146,0.00000}, {147,0.00000}, {148,0.00000}, {149,0.00000}, {150,0.00000}, {151,0.00000}, {152,0.00100}, {153,0.00000}, {154,0.00000}, {155,0.00000}, {156,0.00000}, {157,0.00000}, {158,0.00000}, {159,0.00000}, {160,0.00000}, {161,0.00000}, {162,0.00000}, {163,0.00000}, {164,0.00000}, {165,0.00000}, {166,0.00000}, {167,0.00000}, {168,0.00000}, {169,0.00000}, {170,0.00000}, {171,0.00000}, {172,0.00000}, {173,0.00000}, {174,0.00000}, {175,0.00000}, {176,0.00000}, {177,0.00000}, {178,0.00000}, {179,0.00000}, {180,0.00000}, {181,0.00000}, {182,0.00000}, {183,0.00000}, {184,0.00000}, {185,0.00000}, {186,0.00000}, {187,0.00000}, {188,0.00000}, {189,0.00000}, {190,0.00000}, {191,0.00000}, {192,0.00000}, {193,0.00000}, {194,0.00000}, {195,0.00000}, {196,0.00000}, {197,0.00000}, {198,0.00000}, {199,0.00000}, {200,0.00000}, {201,0.0000}, {202,0.0000}, {203,0}, {204,0}, {205,0}, {206,0}, {207,0}, {208,0}, {209,0}, {210,0}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0}, {216,0}, {217,0}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0}, {238,0}, {239,0}, {240,0}, {241,0}, {242,0}, {243,0}, {244,0}, {245,0}, {246,0}, {247,0}, {248,0}, {249,0}, {250,0}, {251,0}, {252,0}, {253,0}, {254,0}, {255,0}, {256,0}, {257,0}, {258,0}, {259,0}, {260,0}, {261,0}, {262,0}, {263,0}, {264,0}, {265,0}, {266,0}, {267,0}, {268,0}, {269,0}, {270,0}, {271,0}, {272,0}, {273,0}, {274,0}, {275,0}, {276,0}, {277,0}, {278,0}, {279,0}, {280,0}};
data["big"]["CanonicalStructuresPHOAS"]["reif"]["real"] = {{1,0.00021818}, {2,0.00100000}, {3,0.00200000}, {4,0.00323636}, {5,0.00521818}, {6,0.00724545}, {7,0.02536364}, {8,0.01360000}, {9,0.01800909}, {10,0.02270000}, {11,0.02833636}, {12,0.03535455}, {13,0.04265455}, {14,0.05360000}, {15,0.06542727}, {16,0.07590909}, {17,0.08834545}, {18,0.10218182}, {19,0.11506364}, {20,0.13454545}, {21,0.15445455}, {22,0.17502727}, {23,0.20038182}, {24,0.22631818}, {25,0.25222727}, {26,0.28063636}, {27,0.31272727}, {28,0.34602727}, {29,0.38255455}, {30,0.42179091}, {31,0.46839091}, {32,0.51179091}, {33,0.55581818}, {34,0.60600000}, {35,0.65441818}, {36,0.71250909}, {37,0.77200909}, {38,0.83316364}, {39,0.90660909}, {40,0.96886364}, {41,1.04046364}, {42,1.11977273}, {43,1.19767273}, {44,1.28449091}, {45,1.37340909}, {46,1.46631818}, {47,1.56334545}, {48,1.66318182}, {49,1.76918182}, {50,1.88170909}, {51,1.99930000}, {52,2.11817273}, {53,2.24842727}, {54,2.37847273}, {55,2.50747273}, {56,3.25313636}, {57,2.80814545}, {58,2.95513636}, {59,3.10341818}, {60,3.25300000}, {61,3.63800}, {62,3.76275}, {63,3.89625}, {64,4.12250}, {65,4.38800}, {66,4.67250}, {67,4.82425}, {68,4.99850}, {69,5.29625}, {70,5.61875}, {71,5.80475}, {72,5.89550}, {73,6.23200}, {74,6.52450}, {75,6.80375}, {76,7.10150}, {77,7.42975}, {78,7.73050}, {79,8.06525}, {80,8.23450}, {81,8.76350}, {82,9.02400}, {83,9.69450}, {84,10.14275}, {85,10.06575}, {86,10.46325}, {87,10.86925}, {88,11.19375}, {89,11.71750}, {90,12.03400}, {91,12.50425}, {92,12.81625}, {93,13.31650}, {94,13.72325}, {95,14.21475}, {96,14.71400}, {97,15.15600}, {98,15.83000}, {99,16.46250}, {100,17.14450}, {101,17.39350}, {102,17.88875}, {103,18.36550}, {104,18.88725}, {105,19.60275}, {106,20.20475}, {107,20.76150}, {108,21.41575}, {109,22.28875}, {110,22.98575}, {111,23.74550}, {112,24.41250}, {113,25.33200}, {114,25.83525}, {115,26.51025}, {116,27.25475}, {117,28.06700}, {118,28.81400}, {119,29.60800}, {120,30.33675}, {121,31.08025}, {122,32.01350}, {123,32.85600}, {124,33.57325}, {125,34.41625}, {126,35.13475}, {127,36.19175}, {128,37.29000}, {129,37.90575}, {130,39.51025}, {131,40.01200}, {132,41.49500}, {133,42.66850}, {134,43.73725}, {135,44.51275}, {136,45.43750}, {137,46.63625}, {138,47.77375}, {139,48.78350}, {140,50.22225}, {141,51.54725}, {142,52.34875}, {143,53.66150}, {144,54.96075}, {145,56.59100}, {146,58.17050}, {147,59.29025}, {148,60.48175}, {149,62.16925}, {150,63.48375}, {151,64.39525}, {152,65.32450}, {153,67.17200}, {154,68.45125}, {155,70.18100}, {156,71.71975}, {157,73.03900}, {158,74.59675}, {159,76.05950}, {160,77.21875}, {161,78.69725}, {162,80.81475}, {163,83.21250}, {164,83.60750}, {165,85.30000}, {166,88.28975}, {167,88.53250}, {168,90.48775}, {169,92.43525}, {170,94.63400}, {171,95.67800}, {172,98.06875}, {173,100.15825}, {174,101.85200}, {175,103.47100}, {176,105.72550}, {177,108.33300}, {178,109.55300}, {179,112.41925}, {180,114.75875}, {181,117.20525}, {182,118.59850}, {183,120.82475}, {184,123.49275}, {185,126.00550}, {186,127.55825}, {187,130.67350}, {188,133.10175}, {189,136.35400}, {190,137.25000}, {191,138.18700}, {192,141.09500}, {193,143.33750}, {194,146.23525}, {195,148.91250}, {196,151.19725}, {197,153.49725}, {198,156.21275}, {199,159.27367}, {200,160.76100}, {201,169.0660}, {202,167.883}, {203,176.951}, {204,177.815}, {205,180.977}, {206,185.53}, {207,186.565}, {208,191.21}, {209,193.92}, {210,196.319}, {211,200.676}, {212,202.785}, {213,206.848}, {214,209.959}, {215,219.222}, {216,215.782}, {217,220.998}, {218,222.136}, {219,226.653}, {220,230.603}, {221,233.426}, {222,237.538}, {223,242.022}, {224,245.232}, {225,248.24}, {226,253.955}, {227,256.834}, {228,259.331}, {229,265.145}, {230,269.112}, {231,272.432}, {232,277.3}, {233,280.729}, {234,284.548}, {235,289.442}, {236,293.518}, {237,299.438}, {238,298.949}, {239,307.42}, {240,308.583}, {241,313.435}, {242,320.591}, {243,333.116}, {244,316.128}, {245,323.777}, {246,325.572}, {247,329.956}, {248,336.811}, {249,343.273}, {250,346.737}, {251,349.776}, {252,353.547}, {253,363.05}, {254,377.919}, {255,382.49}, {256,394.805}, {257,398.37}, {258,399.829}, {259,413.658}, {260,403.944}, {261,424.084}, {262,415.097}, {263,426.969}, {264,430.801}, {265,442.107}, {266,440.711}, {267,448.14}, {268,453.898}, {269,459.46}, {270,471.947}, {271,473.106}, {272,480.377}, {273,482.019}, {274,490.085}, {275,494.292}, {276,500.472}, {277,511.785}, {278,513.663}, {279,528.44}};
data["big"]["CanonicalStructuresPHOAS"]["reif"]["user"] = {{1,0.00088182}, {2,0.00150909}, {3,0.00263636}, {4,0.00381818}, {5,0.00539091}, {6,0.00740000}, {7,0.02568182}, {8,0.01369091}, {9,0.01752727}, {10,0.02289091}, {11,0.02864545}, {12,0.03500909}, {13,0.04250909}, {14,0.05363636}, {15,0.06498182}, {16,0.07598182}, {17,0.08812727}, {18,0.10220000}, {19,0.11482727}, {20,0.13427273}, {21,0.15443636}, {22,0.17514545}, {23,0.20035455}, {24,0.22600909}, {25,0.25212727}, {26,0.28053636}, {27,0.31260909}, {28,0.34584545}, {29,0.38250909}, {30,0.42196364}, {31,0.46821818}, {32,0.51164545}, {33,0.55585455}, {34,0.60573636}, {35,0.65407273}, {36,0.71285455}, {37,0.77156364}, {38,0.83309091}, {39,0.90642727}, {40,0.96880000}, {41,1.03991818}, {42,1.11990000}, {43,1.19729091}, {44,1.28428182}, {45,1.37311818}, {46,1.46614545}, {47,1.56313636}, {48,1.66289091}, {49,1.76886364}, {50,1.88148182}, {51,1.99904545}, {52,2.11784545}, {53,2.24826364}, {54,2.37828182}, {55,2.50733636}, {56,3.25072727}, {57,2.80772727}, {58,2.95459091}, {59,3.10332727}, {60,3.25242727}, {61,3.63750}, {62,3.76150}, {63,3.89500}, {64,4.12075}, {65,4.38850}, {66,4.67375}, {67,4.82450}, {68,4.99875}, {69,5.29575}, {70,5.61975}, {71,5.80450}, {72,5.89375}, {73,6.23250}, {74,6.52375}, {75,6.80525}, {76,7.10025}, {77,7.42875}, {78,7.73100}, {79,8.06375}, {80,8.23475}, {81,8.76375}, {82,9.02350}, {83,9.69200}, {84,10.13875}, {85,10.06425}, {86,10.46400}, {87,10.86675}, {88,11.19275}, {89,11.71775}, {90,12.03375}, {91,12.50325}, {92,12.81575}, {93,13.31650}, {94,13.72300}, {95,14.21650}, {96,14.71325}, {97,15.15550}, {98,15.82850}, {99,16.46050}, {100,17.13675}, {101,17.38625}, {102,17.88150}, {103,18.35700}, {104,18.87900}, {105,19.59350}, {106,20.19375}, {107,20.75050}, {108,21.40350}, {109,22.28075}, {110,22.97375}, {111,23.73125}, {112,24.40125}, {113,25.31875}, {114,25.82850}, {115,26.49950}, {116,27.24850}, {117,28.05925}, {118,28.80550}, {119,29.60250}, {120,30.32650}, {121,31.07600}, {122,32.01225}, {123,32.85725}, {124,33.57050}, {125,34.41550}, {126,35.13075}, {127,36.19050}, {128,37.28950}, {129,37.90150}, {130,39.50775}, {131,40.01175}, {132,41.48150}, {133,42.65850}, {134,43.72350}, {135,44.49700}, {136,45.41975}, {137,46.62425}, {138,47.75825}, {139,48.78050}, {140,50.21800}, {141,51.53975}, {142,52.34225}, {143,53.65750}, {144,54.95025}, {145,56.58650}, {146,58.16250}, {147,59.28775}, {148,60.47550}, {149,62.15925}, {150,63.45550}, {151,64.39350}, {152,65.27750}, {153,67.16350}, {154,68.44125}, {155,70.15450}, {156,71.71225}, {157,73.03025}, {158,74.57425}, {159,76.04850}, {160,77.20200}, {161,78.69150}, {162,80.79800}, {163,83.19750}, {164,83.47025}, {165,85.29150}, {166,88.26350}, {167,88.53075}, {168,90.47525}, {169,92.41525}, {170,94.62550}, {171,95.67000}, {172,98.05350}, {173,100.14825}, {174,101.84250}, {175,103.44975}, {176,105.70250}, {177,108.31850}, {178,109.54350}, {179,112.39575}, {180,114.74200}, {181,117.18550}, {182,118.57775}, {183,120.81025}, {184,123.46750}, {185,125.98150}, {186,127.54450}, {187,130.63575}, {188,133.08350}, {189,136.32150}, {190,137.23650}, {191,138.16650}, {192,141.07050}, {193,143.31050}, {194,146.21100}, {195,148.88250}, {196,151.17275}, {197,153.47550}, {198,156.19425}, {199,159.25533}, {200,160.74233}, {201,168.2300}, {202,167.707}, {203,176.728}, {204,177.775}, {205,180.976}, {206,185.508}, {207,186.539}, {208,191.207}, {209,193.919}, {210,196.316}, {211,200.675}, {212,202.784}, {213,206.851}, {214,209.96}, {215,219.22}, {216,215.784}, {217,220.928}, {218,222.136}, {219,226.652}, {220,230.603}, {221,233.428}, {222,237.539}, {223,242.024}, {224,245.231}, {225,248.244}, {226,253.956}, {227,256.836}, {228,259.332}, {229,265.148}, {230,269.116}, {231,272.435}, {232,277.299}, {233,280.727}, {234,284.548}, {235,289.44}, {236,293.52}, {237,299.432}, {238,298.84}, {239,307.379}, {240,308.451}, {241,313.355}, {242,320.524}, {243,332.956}, {244,316.127}, {245,323.775}, {246,325.523}, {247,329.956}, {248,336.752}, {249,343.208}, {250,346.703}, {251,349.724}, {252,353.547}, {253,361.228}, {254,377.824}, {255,382.488}, {256,394.668}, {257,398.319}, {258,399.832}, {259,413.587}, {260,400.963}, {261,421.096}, {262,415.096}, {263,426.963}, {264,430.799}, {265,439.315}, {266,440.711}, {267,448.056}, {268,453.811}, {269,459.42}, {270,471.884}, {271,473.108}, {272,480.304}, {273,482.02}, {274,490.04}, {275,494.227}, {276,500.412}, {277,509.963}, {278,513.599}, {279,528.291}};
data["big"]["CanonicalStructuresPHOAS"]["reif"]["system"] = {{1,0.00000000}, {2,0.00007273}, {3,0.00000000}, {4,0.00000000}, {5,0.00003636}, {6,0.00003636}, {7,0.00003636}, {8,0.00000000}, {9,0.00007273}, {10,0.00003636}, {11,0.00000000}, {12,0.00007273}, {13,0.00007273}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00003636}, {18,0.00003636}, {19,0.00003636}, {20,0.00007273}, {21,0.00003636}, {22,0.00000000}, {23,0.00003636}, {24,0.00003636}, {25,0.00003636}, {26,0.00000000}, {27,0.00000000}, {28,0.00007273}, {29,0.00006364}, {30,0.00000000}, {31,0.00006364}, {32,0.00003636}, {33,0.00002727}, {34,0.00007273}, {35,0.00003636}, {36,0.00003636}, {37,0.00007273}, {38,0.00003636}, {39,0.00003636}, {40,0.00010909}, {41,0.00014545}, {42,0.00025455}, {43,0.00007273}, {44,0.00007273}, {45,0.00014545}, {46,0.00010909}, {47,0.00020909}, {48,0.00014545}, {49,0.00014545}, {50,0.00010909}, {51,0.00018182}, {52,0.00047273}, {53,0.00010909}, {54,0.00036364}, {55,0.00014545}, {56,0.00226364}, {57,0.00021818}, {58,0.00018182}, {59,0.00029091}, {60,0.00036364}, {61,0.00000}, {62,0.00000}, {63,0.00000}, {64,0.00000}, {65,0.00000}, {66,0.00000}, {67,0.00000}, {68,0.00000}, {69,0.00000}, {70,0.00000}, {71,0.00000}, {72,0.00100}, {73,0.00000}, {74,0.00100}, {75,0.00000}, {76,0.00200}, {77,0.00100}, {78,0.00000}, {79,0.00200}, {80,0.00100}, {81,0.00100}, {82,0.00000}, {83,0.00175}, {84,0.00300}, {85,0.00000}, {86,0.00000}, {87,0.00100}, {88,0.00100}, {89,0.00000}, {90,0.00100}, {91,0.00000}, {92,0.00000}, {93,0.00000}, {94,0.00000}, {95,0.00000}, {96,0.00000}, {97,0.00000}, {98,0.00000}, {99,0.00000}, {100,0.00100}, {101,0.00000}, {102,0.00000}, {103,0.00100}, {104,0.00100}, {105,0.00100}, {106,0.00100}, {107,0.00100}, {108,0.00200}, {109,0.00100}, {110,0.00175}, {111,0.00375}, {112,0.00100}, {113,0.00300}, {114,0.00100}, {115,0.00400}, {116,0.00000}, {117,0.00100}, {118,0.00300}, {119,0.00000}, {120,0.00300}, {121,0.00000}, {122,0.00000}, {123,0.00000}, {124,0.00200}, {125,0.00000}, {126,0.00300}, {127,0.00100}, {128,0.00000}, {129,0.00300}, {130,0.00200}, {131,0.00100}, {132,0.00500}, {133,0.00100}, {134,0.00500}, {135,0.00800}, {136,0.00900}, {137,0.00300}, {138,0.00700}, {139,0.00400}, {140,0.00300}, {141,0.00600}, {142,0.00675}, {143,0.00400}, {144,0.00875}, {145,0.00300}, {146,0.00700}, {147,0.00200}, {148,0.00575}, {149,0.01075}, {150,0.02675}, {151,0.00300}, {152,0.00100}, {153,0.00700}, {154,0.01000}, {155,0.02275}, {156,0.00800}, {157,0.00800}, {158,0.01975}, {159,0.01100}, {160,0.01675}, {161,0.00300}, {162,0.01600}, {163,0.01500}, {164,0.00800}, {165,0.00850}, {166,0.02600}, {167,0.00200}, {168,0.01400}, {169,0.01775}, {170,0.00800}, {171,0.00800}, {172,0.01400}, {173,0.01075}, {174,0.00800}, {175,0.02100}, {176,0.02275}, {177,0.01475}, {178,0.00800}, {179,0.02375}, {180,0.01675}, {181,0.01900}, {182,0.02100}, {183,0.01400}, {184,0.02500}, {185,0.02300}, {186,0.01300}, {187,0.03900}, {188,0.01800}, {189,0.03350}, {190,0.01400}, {191,0.02000}, {192,0.02400}, {193,0.02775}, {194,0.02200}, {195,0.02875}, {196,0.02600}, {197,0.02200}, {198,0.01775}, {199,0.01867}, {200,0.01733}, {201,0.0835}, {202,0.036}, {203,0.072}, {204,0.004}, {205,0}, {206,0.024}, {207,0.024}, {208,0}, {209,0}, {210,0.004}, {211,0}, {212,0}, {213,0}, {214,0}, {215,0.004}, {216,0}, {217,0.067}, {218,0}, {219,0}, {220,0}, {221,0}, {222,0}, {223,0}, {224,0}, {225,0}, {226,0}, {227,0}, {228,0}, {229,0}, {230,0}, {231,0}, {232,0}, {233,0}, {234,0}, {235,0}, {236,0}, {237,0.004}, {238,0.111}, {239,0.04}, {240,0.128}, {241,0.079}, {242,0.068}, {243,0.159}, {244,0}, {245,0}, {246,0.048}, {247,0}, {248,0.06}, {249,0.068}, {250,0.036}, {251,0.052}, {252,0}, {253,0.004}, {254,0.052}, {255,0.004}, {256,0.135}, {257,0.004}, {258,0}, {259,0.072}, {260,0}, {261,0.035}, {262,0}, {263,0.004}, {264,0.004}, {265,0.072}, {266,0}, {267,0.084}, {268,0.088}, {269,0.044}, {270,0.064}, {271,0}, {272,0.072}, {273,0}, {274,0.047}, {275,0.064}, {276,0.06}, {277,0.076}, {278,0.064}, {279,0.148}};
data["big"]["Ltac2"]["Aggregate"]["real"] = {{1,0.00103922}, {2,0.00110784}, {3,0.00200000}, {4,0.00200980}, {5,0.00300000}, {6,0.00302941}, {7,0.00400000}, {8,0.00411765}, {9,0.00502941}, {10,0.00578431}, {11,0.00611765}, {12,0.00707843}, {13,0.00807843}, {14,0.00905882}, {15,0.00976471}, {16,0.01041176}, {17,0.01751961}, {18,0.01225490}, {19,0.01341176}, {20,0.01465686}, {21,0.01591176}, {22,0.01710784}, {23,0.01819608}, {24,0.02160784}, {25,0.02086275}, {26,0.02221569}, {27,0.02347059}, {28,0.02494118}, {29,0.02867647}, {30,0.02784314}, {31,0.02922549}, {32,0.03103922}, {33,0.03426471}, {34,0.03428431}, {35,0.03598039}, {36,0.04085294}, {37,0.03960784}, {38,0.04142157}, {39,0.04325490}, {40,0.04519608}, {41,0.05008824}, {42,0.04928431}, {43,0.05480392}, {44,0.05333333}, {45,0.05926471}, {46,0.05793137}, {47,0.06377451}, {48,0.06256863}, {49,0.06760784}, {50,0.07179412}, {51,0.06950000}, {52,0.07551961}, {53,0.07883333}, {54,0.07724510}, {55,0.08338235}, {56,0.08713725}, {57,0.08968627}, {58,0.08801961}, {59,0.09229412}, {60,0.09852941}, {61,0.10100980}, {62,0.10411765}, {63,0.10713725}, {64,0.11048039}, {65,0.11323529}, {66,0.11638235}, {67,0.11964706}, {68,0.12342157}, {69,0.12624510}, {70,0.12988235}, {71,0.13458824}, {72,0.13712745}, {73,0.14053922}, {74,0.14386275}, {75,0.14828431}, {76,0.15238235}, {77,0.15440196}, {78,0.15923529}, {79,0.16188235}, {80,0.16655882}, {81,0.16989216}, {82,0.17449020}, {83,0.17820588}, {84,0.18251961}, {85,0.18621569}, {86,0.19039216}, {87,0.19509804}, {88,0.19978431}, {89,0.20358824}, {90,0.20741176}, {91,0.21188235}, {92,0.21699020}, {93,0.22136275}, {94,0.22575490}, {95,0.22979412}, {96,0.23385294}, {97,0.23846078}, {98,0.24341176}, {99,0.24808824}, {100,0.25237255}, {101,0.25742157}, {102,0.26271569}, {103,0.26830392}, {104,0.27308824}, {105,0.27749020}, {106,0.28218627}, {107,0.28714706}, {108,0.29253922}, {109,0.29683333}, {110,0.30214706}, {111,0.30790196}, {112,0.31291176}, {113,0.31806863}, {114,0.32296078}, {115,0.32903922}, {116,0.33400980}, {117,0.33994118}, {118,0.34501961}, {119,0.35041176}, {120,0.35637255}, {121,0.36186275}, {122,0.37101961}, {123,0.37432353}, {124,0.37994118}, {125,0.38504902}, {126,0.39062745}, {127,0.39674510}, {128,0.40296078}, {129,0.40999020}, {130,0.41750000}, {131,0.42317647}, {132,0.42952941}, {133,0.43611765}, {134,0.44129412}, {135,0.44876471}, {136,0.45647059}, {137,0.46255882}, {138,0.47003922}, {139,0.47613725}, {140,0.48257843}, {141,0.48899020}, {142,0.49356863}, {143,0.50402941}, {144,0.51180392}, {145,0.51857843}, {146,0.52757843}, {147,0.53028431}, {148,0.53752941}, {149,0.54537255}, {150,0.55592157}, {151,0.56800980}, {152,0.57613725}, {153,0.58350980}, {154,0.58700000}, {155,0.58934314}, {156,0.59665686}, {157,0.60488235}, {158,0.61261765}, {159,0.62108824}, {160,0.62760784}, {161,0.63573529}, {162,0.64287255}, {163,0.66278431}, {164,0.66040196}, {165,0.66900000}, {166,0.67566667}, {167,0.68524510}, {168,0.69286275}, {169,0.69817647}, {170,0.71322549}, {171,0.71520588}, {172,0.72357843}, {173,0.73369608}, {174,0.74439216}, {175,0.74878431}, {176,0.76175490}, {177,0.76446078}, {178,0.77311765}, {179,0.78185294}, {180,0.79163725}, {181,0.80073529}, {182,0.80798039}, {183,0.81581373}, {184,0.82735294}, {185,0.83591176}, {186,0.84419608}, {187,0.85264706}, {188,0.86140196}, {189,0.87145098}, {190,0.87439216}, {191,0.88816667}, {192,0.90000000}, {193,0.90916667}, {194,0.91505882}, {195,0.92392157}, {196,0.93231373}, {197,0.94106863}, {198,0.95267647}, {199,0.96362745}, {200,0.97227451}, {201,0.98097059}, {202,0.99060784}, {203,0.99882353}, {204,1.00475490}, {205,1.02244118}, {206,1.03175490}, {207,1.04104902}, {208,1.05134314}, {209,1.05275490}, {210,1.06980392}, {211,1.09185294}, {212,1.09184314}, {213,1.10132353}, {214,1.11241176}, {215,1.12170588}, {216,1.13093137}, {217,1.13356863}, {218,1.15156863}, {219,1.16190196}, {220,1.17154902}, {221,1.18200980}, {222,1.19321569}, {223,1.20515686}, {224,1.21385294}, {225,1.22858824}, {226,1.23810784}, {227,1.25046078}, {228,1.26114706}, {229,1.27060784}, {230,1.28207843}, {231,1.29405882}, {232,1.30091176}, {233,1.31627451}, {234,1.32649020}, {235,1.33779412}, {236,1.34812745}, {237,1.37815686}, {238,1.38999020}, {239,1.38592157}, {240,1.39600000}, {241,1.40824510}, {242,1.43179412}, {243,1.43798039}, {244,1.44978431}, {245,1.45698039}, {246,1.46699020}, {247,1.48445098}, {248,1.49479412}, {249,1.50871569}, {250,1.52087255}, {251,1.53340196}, {252,1.54609804}, {253,1.54842157}, {254,1.57101961}, {255,1.58103922}, {256,1.59556863}, {257,1.62191176}, {258,1.61203922}, {259,1.62459804}, {260,1.63916667}, {261,1.65023529}, {262,1.66532353}, {263,1.67721569}, {264,1.69403922}, {265,1.70762745}, {266,1.70456863}, {267,1.72100980}, {268,1.73641176}, {269,1.75089216}, {270,1.76593137}, {271,1.77584314}, {272,1.78959804}, {273,1.80157843}, {274,1.81340196}, {275,1.82838235}, {276,1.84207843}, {277,1.85390196}, {278,1.86777451}, {279,1.87785294}, {280,1.89478431}, {281,1.90673529}, {282,1.92255882}, {283,1.93895098}, {284,1.95372549}, {285,1.96422549}, {286,2.00885294}, {287,2.00616667}, {288,2.01441176}, {289,2.03541176}, {290,2.05502941}, {291,2.06505882}, {292,2.07470588}, {293,2.09117647}, {294,2.10106863}, {295,2.11472549}, {296,2.13297059}, {297,2.14892157}, {298,2.16050980}, {299,2.17491176}, {300,2.19485294}, {301,2.24800}, {302,2.58650}, {303,2.23725}, {304,2.25700}, {305,2.30250}, {306,2.28350}, {307,2.29700}, {308,2.32725}, {309,2.34200}, {310,2.34700}, {311,2.36325}, {312,2.55650}, {313,2.71500}, {314,2.37450}, {315,2.39375}, {316,2.39375}, {317,2.43300}, {318,2.42700}, {319,2.43400}, {320,2.43650}, {321,2.46125}, {322,2.52400}, {323,2.51275}, {324,2.52100}, {325,2.54400}, {326,2.57950}, {327,2.62325}, {328,2.60550}, {329,2.62750}, {330,2.63375}, {331,2.67200}, {332,2.70225}, {333,2.70025}, {334,2.71075}, {335,2.74400}, {336,2.75250}, {337,2.84200}, {338,2.78375}, {339,2.81500}, {340,2.81250}, {341,2.83450}, {342,2.87925}, {343,2.87800}, {344,2.86800}, {345,2.87250}, {346,2.92025}, {347,2.97475}, {348,2.98225}, {349,2.97825}, {350,2.99475}, {351,3.05000}, {352,3.02400}, {353,3.04475}, {354,3.05875}, {355,3.08200}, {356,3.12050}, {357,3.13075}, {358,3.14325}, {359,3.15150}, {360,3.20700}, {361,3.21275}, {362,3.19975}, {363,3.20075}, {364,3.23825}, {365,3.23600}, {366,3.26625}, {367,3.30300}, {368,3.34775}, {369,3.35700}, {370,3.34725}, {371,3.37425}, {372,3.42875}, {373,3.40925}, {374,3.38200}, {375,3.40425}, {376,3.46000}, {377,3.46925}, {378,3.48350}, {379,3.49325}, {380,3.53450}, {381,3.50975}, {382,3.58450}, {383,3.60500}, {384,3.64075}, {385,3.66425}, {386,3.67000}, {387,3.67425}, {388,3.72250}, {389,3.70550}, {390,3.70325}, {391,3.70600}, {392,3.74900}, {393,3.74575}, {394,3.76300}, {395,3.83825}, {396,3.85200}, {397,3.84850}, {398,3.88350}, {399,3.91550}, {400,3.90750}, {401,3.89250}, {402,3.97175}, {403,4.00475}, {404,4.00725}, {405,4.02450}, {406,4.08050}, {407,4.06600}, {408,4.07875}, {409,4.13800}, {410,4.15875}, {411,4.17650}, {412,4.20925}, {413,4.22525}, {414,4.18300}, {415,4.19625}, {416,4.27050}, {417,4.24375}, {418,4.24725}, {419,4.34275}, {420,4.32900}, {421,4.32950}, {422,4.42100}, {423,4.41400}, {424,4.40750}, {425,4.53200}, {426,4.52375}, {427,4.51625}, {428,4.55700}, {429,4.54425}, {430,4.54900}, {431,4.56925}, {432,4.60800}, {433,4.64500}, {434,4.67075}, {435,4.72775}, {436,4.69675}, {437,4.73175}, {438,4.79425}, {439,4.73675}, {440,4.78525}, {441,4.83700}, {442,4.82150}, {443,4.81075}, {444,4.82875}, {445,4.82425}, {446,4.86225}, {447,4.95050}, {448,4.95900}, {449,5.03100}, {450,4.99850}, {451,5.00450}, {452,5.03925}, {453,5.10025}, {454,5.09600}, {455,5.18950}, {456,5.13225}, {457,5.12800}, {458,5.15050}, {459,5.12925}, {460,5.19800}, {461,5.24650}, {462,5.22875}, {463,5.30275}, {464,5.27475}, {465,5.33325}, {466,5.37675}, {467,5.39575}, {468,5.41425}, {469,5.38425}, {470,5.43325}, {471,5.51700}, {472,5.47050}, {473,5.52150}, {474,5.51425}, {475,5.57025}, {476,5.62075}, {477,5.61475}, {478,5.62800}, {479,5.69050}, {480,5.72050}, {481,5.75850}, {482,5.74475}, {483,5.81850}, {484,5.84175}, {485,5.88400}, {486,5.96075}, {487,5.82475}, {488,5.90000}, {489,5.96950}, {490,6.06875}, {491,6.04025}, {492,5.98375}, {493,6.04575}, {494,5.99825}, {495,6.11300}, {496,6.11625}, {497,6.15475}, {498,6.13875}, {499,6.16100}, {500,6.23625}, {505,6.37175}, {510,6.61600}, {515,6.59225}, {520,6.74750}, {525,6.93500}, {530,7.06550}, {535,7.16375}, {540,7.30325}, {545,7.38675}, {550,7.67100}, {555,7.77550}, {560,7.91125}, {565,8.04975}, {570,8.22550}, {575,8.38375}, {580,8.48100}, {585,8.60875}, {590,8.86175}, {595,8.96350}, {600,8.99125}, {605,9.16200}, {610,9.41650}, {615,9.59025}, {620,9.63150}, {625,9.89900}, {630,10.17175}, {635,10.25250}, {640,10.39125}, {645,10.66875}, {650,10.74725}, {655,10.73250}, {660,11.07075}, {665,11.23575}, {670,11.25125}, {675,11.65275}, {680,11.78600}, {685,11.95850}, {690,12.23900}, {695,12.38425}, {700,12.56975}, {705,12.85875}, {710,12.91550}, {715,13.15150}, {720,13.31250}, {725,13.34950}, {730,13.64375}, {735,13.70050}, {740,13.90200}, {745,14.14800}, {750,14.41400}, {755,14.60750}, {760,15.12475}, {765,15.05625}, {770,15.31350}, {775,15.29275}, {780,15.50775}, {785,16.14550}, {790,15.76075}, {795,16.38675}, {800,16.28325}, {805,16.71200}, {810,16.85250}, {815,17.20975}, {820,17.02450}, {825,17.20625}, {830,17.68650}, {835,17.64600}, {840,18.12875}, {845,18.30850}, {850,18.57225}, {855,18.62750}, {860,18.85400}, {865,18.92500}, {870,19.13900}, {875,19.48725}, {880,19.78000}, {885,20.06250}, {890,20.22150}, {895,20.52225}, {900,20.61750}, {905,21.04950}, {910,21.12675}, {915,21.63350}, {920,21.55575}, {925,22.02650}, {930,22.22725}, {935,22.68775}, {940,22.76500}, {945,22.82125}, {950,23.35175}, {955,23.46775}, {960,23.66575}, {965,24.65575}, {970,24.26225}, {975,24.63200}, {980,24.79375}, {985,25.02250}, {990,25.52725}, {995,25.91175}, {1000,26.37650}, {1010,26.69500}, {1020,27.02775}, {1030,27.45925}, {1040,28.02350}, {1050,28.23725}, {1060,29.45500}, {1070,30.37200}, {1080,30.24475}, {1090,30.93350}, {1100,31.22275}, {1110,32.79725}, {1120,33.41800}, {1130,33.72225}, {1140,34.42225}, {1150,34.75475}, {1160,35.63150}, {1170,36.77350}, {1180,37.15700}, {1190,37.41500}, {1200,38.48400}, {1210,39.29125}, {1220,39.43350}, {1230,40.48800}, {1240,42.13900}, {1250,41.31125}, {1260,43.40950}, {1270,43.64350}, {1280,43.59950}, {1290,45.13675}, {1300,46.11075}, {1310,46.15700}, {1320,46.86825}, {1330,47.71550}, {1340,48.20425}, {1350,49.70700}, {1360,49.39600}, {1370,50.80200}, {1380,50.81200}, {1390,52.33475}, {1400,53.73800}, {1410,54.29750}, {1420,54.55950}, {1430,55.76900}, {1440,56.07600}, {1450,57.81525}, {1460,61.103}, {1470,61.797}, {1480,63.281}, {1490,63.82}, {1500,64.738}, {1510,65.545}, {1520,66.515}, {1530,67.919}, {1540,68.149}, {1550,70.254}, {1560,69.911}, {1570,71.731}, {1580,70.807}, {1590,74.408}, {1600,73.069}, {1610,74.338}, {1620,74.076}, {1630,75.118}, {1640,76.471}, {1650,78.108}, {1660,78.917}, {1670,79.602}, {1680,82.898}, {1690,82.275}, {1700,85.257}, {1710,84.131}, {1720,84.89}, {1730,87.896}, {1740,87.855}, {1750,86.976}, {1760,88.333}, {1770,89.822}, {1780,90.204}, {1790,91.212}, {1800,93.616}, {1810,92.576}, {1820,91.627}, {1830,95.076}, {1840,96.994}, {1850,94.852}, {1860,95.631}, {1870,100.494}, {1880,100.845}, {1890,98.93}, {1900,100.176}, {1910,104.543}, {1920,105.704}, {1930,102.226}, {1940,104.087}, {1950,105.024}, {1960,109.135}, {1970,110.871}, {1980,108.296}, {1990,109.042}, {2000,114.875}, {2050,119.791}, {2100,121.553}, {2150,128.192}, {2200,131.537}, {2250,142.083}, {2300,145.607}, {2350,152.868}, {2400,156.942}, {2450,166.966}, {2500,173.094}, {2550,177.351}, {2600,189.153}, {2650,192.363}, {2700,205.182}, {2750,212.159}, {2800,218.363}, {2850,229.332}, {2900,236.681}, {2950,242.812}, {3000,253.332}, {3050,263.097}, {3100,270.665}, {3150,276.864}, {3200,290.7}, {3250,300.137}, {3300,308.061}, {3350,321.379}, {3400,328.847}, {3450,339.292}, {3500,352.956}, {3550,359.013}, {3600,370.894}, {3650,384.668}, {3700,389.906}, {3750,412.902}, {3800,422.014}, {3850,424.243}, {3900,432.444}, {3950,451.946}, {4000,464.158}, {4050,473.572}, {4100,483.788}, {4150,488.953}, {4200,495.029}, {4250,509.773}, {4300,521.458}, {4350,544.802}, {4400,547.195}, {4450,559.422}, {4500,578.133}, {4550,593.713}, {4600,609.238}, {4650,620.247}, {4700,654.16}, {4750,667.941}, {4800,683.83}, {4850,692.861}, {4900,705.472}, {4950,716.724}, {5000,739.077}, {5050,751.191}, {5100,776.149}, {5150,788.172}, {5200,808.297}, {5250,821.762}, {5300,839.162}, {5350,857.733}, {5400,857.323}, {5450,878.705}, {5500,903.979}, {5550,934.684}, {5600,944.38}, {5650,955.142}, {5700,978.902}, {5750,997.497}, {5800,1009.058}, {5850,1028.298}, {5900,1039.068}, {5950,1059.558}, {6000,1087.549}};
data["big"]["Ltac2"]["Aggregate"]["user"] = {{1,0.00157843}, {2,0.00211765}, {3,0.00208824}, {4,0.00249020}, {5,0.00306863}, {6,0.00344118}, {7,0.00402941}, {8,0.00452941}, {9,0.00562745}, {10,0.00555882}, {11,0.00659804}, {12,0.00740196}, {13,0.00785294}, {14,0.00881373}, {15,0.00993137}, {16,0.01047059}, {17,0.01707843}, {18,0.01228431}, {19,0.01349020}, {20,0.01453922}, {21,0.01536275}, {22,0.01678431}, {23,0.01779412}, {24,0.02170588}, {25,0.02053922}, {26,0.02259804}, {27,0.02392157}, {28,0.02504902}, {29,0.02863725}, {30,0.02796078}, {31,0.02956863}, {32,0.03100000}, {33,0.03417647}, {34,0.03455882}, {35,0.03584314}, {36,0.04024510}, {37,0.03945098}, {38,0.04091176}, {39,0.04254902}, {40,0.04526471}, {41,0.05055882}, {42,0.04954902}, {43,0.05480392}, {44,0.05347059}, {45,0.05927451}, {46,0.05739216}, {47,0.06330392}, {48,0.06242157}, {49,0.06714706}, {50,0.07196078}, {51,0.06957843}, {52,0.07577451}, {53,0.07880392}, {54,0.07738235}, {55,0.08303922}, {56,0.08670588}, {57,0.08935294}, {58,0.08752941}, {59,0.09196078}, {60,0.09865686}, {61,0.10135294}, {62,0.10372549}, {63,0.10693137}, {64,0.10991176}, {65,0.11259804}, {66,0.11594118}, {67,0.11979412}, {68,0.12337255}, {69,0.12635294}, {70,0.12969608}, {71,0.13416667}, {72,0.13672549}, {73,0.14032353}, {74,0.14396078}, {75,0.14810784}, {76,0.15207843}, {77,0.15417647}, {78,0.15845098}, {79,0.16165686}, {80,0.16639216}, {81,0.16984314}, {82,0.17407843}, {83,0.17790196}, {84,0.18206863}, {85,0.18550980}, {86,0.19025490}, {87,0.19456863}, {88,0.19953922}, {89,0.20312745}, {90,0.20690196}, {91,0.21132353}, {92,0.21693137}, {93,0.22101961}, {94,0.22537255}, {95,0.22927451}, {96,0.23326471}, {97,0.23802941}, {98,0.24316667}, {99,0.24790196}, {100,0.25184314}, {101,0.25648039}, {102,0.26258824}, {103,0.26790196}, {104,0.27234314}, {105,0.27698039}, {106,0.28159804}, {107,0.28620588}, {108,0.29163725}, {109,0.29616667}, {110,0.30143137}, {111,0.30739216}, {112,0.31247059}, {113,0.31737255}, {114,0.32202941}, {115,0.32830392}, {116,0.33324510}, {117,0.33950980}, {118,0.34383333}, {119,0.34960784}, {120,0.35528431}, {121,0.36124510}, {122,0.37017647}, {123,0.37358824}, {124,0.37843137}, {125,0.38441176}, {126,0.38998039}, {127,0.39563725}, {128,0.40192157}, {129,0.40955882}, {130,0.41651961}, {131,0.42222549}, {132,0.42846078}, {133,0.43502941}, {134,0.44055882}, {135,0.44756863}, {136,0.45551961}, {137,0.46167647}, {138,0.46878431}, {139,0.47497059}, {140,0.48170588}, {141,0.48814706}, {142,0.49234314}, {143,0.50281373}, {144,0.51116667}, {145,0.51781373}, {146,0.52680392}, {147,0.52935294}, {148,0.53624510}, {149,0.54453922}, {150,0.55506863}, {151,0.56684314}, {152,0.57500000}, {153,0.58255882}, {154,0.58591176}, {155,0.58834314}, {156,0.59579412}, {157,0.60344118}, {158,0.61163725}, {159,0.62024510}, {160,0.62662745}, {161,0.63453922}, {162,0.64167647}, {163,0.66150980}, {164,0.65911765}, {165,0.66830392}, {166,0.67466667}, {167,0.68419608}, {168,0.69172549}, {169,0.69764706}, {170,0.70509804}, {171,0.71406863}, {172,0.72252941}, {173,0.73252941}, {174,0.74329412}, {175,0.74804902}, {176,0.76037255}, {177,0.76299020}, {178,0.77172549}, {179,0.78037255}, {180,0.79031373}, {181,0.79921569}, {182,0.80650980}, {183,0.81437255}, {184,0.82583333}, {185,0.83467647}, {186,0.84263725}, {187,0.85087255}, {188,0.86003922}, {189,0.86978431}, {190,0.87277451}, {191,0.88652941}, {192,0.89847059}, {193,0.90781373}, {194,0.91311765}, {195,0.92260784}, {196,0.93133333}, {197,0.93958824}, {198,0.95105882}, {199,0.96239216}, {200,0.97048039}, {201,0.97960784}, {202,0.98919608}, {203,0.99743137}, {204,1.00326471}, {205,1.02098039}, {206,1.03048039}, {207,1.03922549}, {208,1.05015686}, {209,1.05132353}, {210,1.06799020}, {211,1.09003922}, {212,1.09013725}, {213,1.09984314}, {214,1.11036275}, {215,1.11996078}, {216,1.12906863}, {217,1.13151961}, {218,1.14941176}, {219,1.16015686}, {220,1.16932353}, {221,1.18007843}, {222,1.19138235}, {223,1.20319608}, {224,1.21198039}, {225,1.22683333}, {226,1.23616667}, {227,1.24840196}, {228,1.25950980}, {229,1.26891176}, {230,1.28018627}, {231,1.29201961}, {232,1.29873529}, {233,1.31416667}, {234,1.32443137}, {235,1.33600000}, {236,1.34593137}, {237,1.37615686}, {238,1.38767647}, {239,1.38334314}, {240,1.39353922}, {241,1.40557843}, {242,1.42940196}, {243,1.43512745}, {244,1.44719608}, {245,1.45430392}, {246,1.46424510}, {247,1.48154902}, {248,1.49223529}, {249,1.50561765}, {250,1.51857843}, {251,1.53038235}, {252,1.54370588}, {253,1.54565686}, {254,1.56825490}, {255,1.57865686}, {256,1.59246078}, {257,1.61937255}, {258,1.60910784}, {259,1.62133333}, {260,1.63634314}, {261,1.64735294}, {262,1.66249020}, {263,1.67432353}, {264,1.69038235}, {265,1.70463725}, {266,1.70135294}, {267,1.71785294}, {268,1.73318627}, {269,1.74774510}, {270,1.76325490}, {271,1.77309804}, {272,1.78648039}, {273,1.79833333}, {274,1.81090196}, {275,1.82511765}, {276,1.83843137}, {277,1.85088235}, {278,1.86368627}, {279,1.87414706}, {280,1.89177451}, {281,1.90309804}, {282,1.91888235}, {283,1.93551961}, {284,1.95009804}, {285,1.96068627}, {286,2.00527451}, {287,2.00252941}, {288,2.01100980}, {289,2.03180392}, {290,2.05167647}, {291,2.06200980}, {292,2.07114706}, {293,2.08792157}, {294,2.09766667}, {295,2.11169608}, {296,2.12940196}, {297,2.14576471}, {298,2.15715686}, {299,2.17176471}, {300,2.19155882}, {301,2.24450}, {302,2.58175}, {303,2.23425}, {304,2.25475}, {305,2.29825}, {306,2.28050}, {307,2.29250}, {308,2.32450}, {309,2.33825}, {310,2.34325}, {311,2.35825}, {312,2.55250}, {313,2.70950}, {314,2.37350}, {315,2.39125}, {316,2.39350}, {317,2.43225}, {318,2.42600}, {319,2.43400}, {320,2.43625}, {321,2.46025}, {322,2.52425}, {323,2.51400}, {324,2.52050}, {325,2.54250}, {326,2.57950}, {327,2.62250}, {328,2.60750}, {329,2.62675}, {330,2.63550}, {331,2.67175}, {332,2.69950}, {333,2.69575}, {334,2.70625}, {335,2.71825}, {336,2.74650}, {337,2.80125}, {338,2.78175}, {339,2.80625}, {340,2.81275}, {341,2.83325}, {342,2.87850}, {343,2.87675}, {344,2.86875}, {345,2.87125}, {346,2.91975}, {347,2.97450}, {348,2.98075}, {349,2.97725}, {350,2.99475}, {351,3.04925}, {352,3.02350}, {353,3.04550}, {354,3.05875}, {355,3.08200}, {356,3.11800}, {357,3.13025}, {358,3.13775}, {359,3.15100}, {360,3.20675}, {361,3.21125}, {362,3.19725}, {363,3.19900}, {364,3.23775}, {365,3.23650}, {366,3.26425}, {367,3.30050}, {368,3.34650}, {369,3.35775}, {370,3.34750}, {371,3.37325}, {372,3.42775}, {373,3.40775}, {374,3.38025}, {375,3.40350}, {376,3.45975}, {377,3.46825}, {378,3.48050}, {379,3.49075}, {380,3.53350}, {381,3.50925}, {382,3.58275}, {383,3.60250}, {384,3.63950}, {385,3.66450}, {386,3.66850}, {387,3.67350}, {388,3.71950}, {389,3.70250}, {390,3.70225}, {391,3.70600}, {392,3.74900}, {393,3.74575}, {394,3.76025}, {395,3.83875}, {396,3.85125}, {397,3.84800}, {398,3.88375}, {399,3.91525}, {400,3.90675}, {401,3.89125}, {402,3.97025}, {403,4.00550}, {404,4.00750}, {405,4.02425}, {406,4.08150}, {407,4.06575}, {408,4.07850}, {409,4.13850}, {410,4.15900}, {411,4.17725}, {412,4.20750}, {413,4.22525}, {414,4.18350}, {415,4.19675}, {416,4.26900}, {417,4.24275}, {418,4.24725}, {419,4.34275}, {420,4.32775}, {421,4.33050}, {422,4.42100}, {423,4.41250}, {424,4.40875}, {425,4.53250}, {426,4.52325}, {427,4.51550}, {428,4.55725}, {429,4.54400}, {430,4.54850}, {431,4.56825}, {432,4.60875}, {433,4.64500}, {434,4.66925}, {435,4.72775}, {436,4.69425}, {437,4.73275}, {438,4.79325}, {439,4.73525}, {440,4.78450}, {441,4.83650}, {442,4.82275}, {443,4.81150}, {444,4.82750}, {445,4.82550}, {446,4.86250}, {447,4.94925}, {448,4.95750}, {449,5.03025}, {450,4.99950}, {451,5.00450}, {452,5.03750}, {453,5.09850}, {454,5.09375}, {455,5.18800}, {456,5.13050}, {457,5.12650}, {458,5.14775}, {459,5.12725}, {460,5.19225}, {461,5.24675}, {462,5.22850}, {463,5.30250}, {464,5.27450}, {465,5.33275}, {466,5.37625}, {467,5.39475}, {468,5.41425}, {469,5.38125}, {470,5.43200}, {471,5.51675}, {472,5.47000}, {473,5.52200}, {474,5.51325}, {475,5.56975}, {476,5.61875}, {477,5.61450}, {478,5.62775}, {479,5.68950}, {480,5.71975}, {481,5.75875}, {482,5.74575}, {483,5.81550}, {484,5.83975}, {485,5.88225}, {486,5.95975}, {487,5.82350}, {488,5.89650}, {489,5.96775}, {490,6.06750}, {491,6.04000}, {492,5.98100}, {493,6.04675}, {494,5.99425}, {495,6.11150}, {496,6.11350}, {497,6.15125}, {498,6.13650}, {499,6.16050}, {500,6.23425}, {505,6.36925}, {510,6.61525}, {515,6.58850}, {520,6.74525}, {525,6.93450}, {530,7.06275}, {535,7.16250}, {540,7.30025}, {545,7.38350}, {550,7.66850}, {555,7.77300}, {560,7.91000}, {565,8.04650}, {570,8.22500}, {575,8.38100}, {580,8.44425}, {585,8.60300}, {590,8.85525}, {595,8.96050}, {600,8.98625}, {605,9.16050}, {610,9.41450}, {615,9.58750}, {620,9.63000}, {625,9.89650}, {630,10.16850}, {635,10.24850}, {640,10.39200}, {645,10.66825}, {650,10.74650}, {655,10.73325}, {660,11.07050}, {665,11.23575}, {670,11.25175}, {675,11.65150}, {680,11.78450}, {685,11.95850}, {690,12.23975}, {695,12.38450}, {700,12.56900}, {705,12.85950}, {710,12.91550}, {715,13.15150}, {720,13.31250}, {725,13.34950}, {730,13.64225}, {735,13.69950}, {740,13.90025}, {745,14.14750}, {750,14.41350}, {755,14.60375}, {760,15.12425}, {765,15.05675}, {770,15.30850}, {775,15.29050}, {780,15.50650}, {785,16.13900}, {790,15.73625}, {795,16.38375}, {800,16.27725}, {805,16.70975}, {810,16.85325}, {815,17.20875}, {820,17.01950}, {825,17.20025}, {830,17.68350}, {835,17.64475}, {840,18.12750}, {845,18.30675}, {850,18.57125}, {855,18.62550}, {860,18.85400}, {865,18.92550}, {870,19.13725}, {875,19.48650}, {880,19.77875}, {885,20.06075}, {890,20.22225}, {895,20.52175}, {900,20.61850}, {905,21.04775}, {910,21.12625}, {915,21.63400}, {920,21.55550}, {925,22.02725}, {930,22.22750}, {935,22.68725}, {940,22.76425}, {945,22.81950}, {950,23.34775}, {955,23.46625}, {960,23.66650}, {965,24.65075}, {970,24.26225}, {975,24.63225}, {980,24.79450}, {985,25.02000}, {990,25.52525}, {995,25.90750}, {1000,26.37450}, {1010,26.69375}, {1020,27.02800}, {1030,27.45875}, {1040,28.01275}, {1050,28.23625}, {1060,29.45425}, {1070,30.37350}, {1080,30.24575}, {1090,30.93075}, {1100,31.21625}, {1110,32.77550}, {1120,33.36325}, {1130,33.67475}, {1140,34.37550}, {1150,34.70250}, {1160,35.57675}, {1170,36.71450}, {1180,37.09725}, {1190,37.35875}, {1200,38.43450}, {1210,39.18975}, {1220,39.38350}, {1230,40.43250}, {1240,42.08150}, {1250,41.24525}, {1260,43.26825}, {1270,43.58725}, {1280,43.53575}, {1290,45.07425}, {1300,46.03450}, {1310,46.09700}, {1320,46.77725}, {1330,47.31950}, {1340,48.14500}, {1350,49.53050}, {1360,49.33075}, {1370,50.73350}, {1380,50.74600}, {1390,52.23000}, {1400,53.65150}, {1410,54.17275}, {1420,54.48350}, {1430,55.69000}, {1440,56.05550}, {1450,57.81125}, {1460,61.096}, {1470,61.792}, {1480,63.279}, {1490,63.807}, {1500,64.688}, {1510,65.536}, {1520,66.488}, {1530,67.867}, {1540,68.127}, {1550,70.192}, {1560,69.903}, {1570,71.659}, {1580,70.804}, {1590,74.408}, {1600,72.884}, {1610,74.328}, {1620,74.059}, {1630,75.112}, {1640,76.463}, {1650,78.104}, {1660,78.895}, {1670,79.596}, {1680,82.887}, {1690,82.264}, {1700,85.224}, {1710,83.979}, {1720,84.884}, {1730,87.891}, {1740,87.844}, {1750,86.975}, {1760,88.328}, {1770,89.731}, {1780,89.96}, {1790,91.195}, {1800,93.604}, {1810,92.571}, {1820,91.512}, {1830,94.967}, {1840,96.695}, {1850,94.372}, {1860,95.38}, {1870,100.492}, {1880,100.844}, {1890,98.924}, {1900,99.963}, {1910,104.543}, {1920,105.644}, {1930,102.223}, {1940,103.92}, {1950,105.023}, {1960,109.128}, {1970,110.844}, {1980,108.296}, {1990,109.043}, {2000,114.283}, {2050,119.768}, {2100,121.448}, {2150,128.131}, {2200,131.264}, {2250,141.863}, {2300,145.603}, {2350,152.856}, {2400,156.895}, {2450,166.951}, {2500,173.091}, {2550,177.316}, {2600,188.608}, {2650,192.111}, {2700,205.147}, {2750,212.019}, {2800,217.768}, {2850,228.899}, {2900,236.619}, {2950,242.796}, {3000,253.268}, {3050,263.036}, {3100,270.627}, {3150,276.832}, {3200,290.688}, {3250,299.815}, {3300,307.971}, {3350,321.307}, {3400,328.8}, {3450,339.292}, {3500,352.899}, {3550,358.975}, {3600,370.152}, {3650,383.664}, {3700,389.907}, {3750,412.804}, {3800,421.967}, {3850,424.191}, {3900,432.056}, {3950,449.779}, {4000,462.56}, {4050,473.136}, {4100,483.351}, {4150,488.703}, {4200,494.779}, {4250,509.58}, {4300,521.024}, {4350,543.471}, {4400,546.112}, {4450,558.743}, {4500,577.867}, {4550,593.123}, {4600,608.716}, {4650,619.783}, {4700,651.344}, {4750,664.987}, {4800,681.148}, {4850,692.711}, {4900,705.396}, {4950,716.628}, {5000,738.135}, {5050,750.272}, {5100,772.572}, {5150,785.251}, {5200,808.}, {5250,817.792}, {5300,834.783}, {5350,856.495}, {5400,855.855}, {5450,873.22}, {5500,900.576}, {5550,930.459}, {5600,939.}, {5650,952.987}, {5700,975.171}, {5750,994.659}, {5800,1008.599}, {5850,1026.088}, {5900,1036.959}, {5950,1055.868}, {6000,1084.391}};
data["big"]["Ltac2"]["Aggregate"]["system"] = {{1,0.00000000}, {2,0.00003922}, {3,0.00003922}, {4,0.00007843}, {5,0.00000000}, {6,0.00003922}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00003922}, {11,0.00003922}, {12,0.00003922}, {13,0.00007843}, {14,0.00007843}, {15,0.00007843}, {16,0.00003922}, {17,0.00003922}, {18,0.00003922}, {19,0.00000000}, {20,0.00000000}, {21,0.00007843}, {22,0.00003922}, {23,0.00003922}, {24,0.00003922}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00007843}, {29,0.00011765}, {30,0.00007843}, {31,0.00011765}, {32,0.00003922}, {33,0.00010784}, {34,0.00000000}, {35,0.00015686}, {36,0.00007843}, {37,0.00003922}, {38,0.00011765}, {39,0.00003922}, {40,0.00000000}, {41,0.00003922}, {42,0.00000000}, {43,0.00007843}, {44,0.00003922}, {45,0.00007843}, {46,0.00003922}, {47,0.00003922}, {48,0.00000000}, {49,0.00000000}, {50,0.00003922}, {51,0.00003922}, {52,0.00000000}, {53,0.00003922}, {54,0.00015686}, {55,0.00015686}, {56,0.00003922}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00003922}, {61,0.00002941}, {62,0.00003922}, {63,0.00003922}, {64,0.00003922}, {65,0.00015686}, {66,0.00007843}, {67,0.00011765}, {68,0.00000000}, {69,0.00011765}, {70,0.00003922}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00011765}, {76,0.00000000}, {77,0.00011765}, {78,0.00003922}, {79,0.00000000}, {80,0.00000000}, {81,0.00007843}, {82,0.00011765}, {83,0.00007843}, {84,0.00003922}, {85,0.00000000}, {86,0.00007843}, {87,0.00011765}, {88,0.00000000}, {89,0.00007843}, {90,0.00000000}, {91,0.00003922}, {92,0.00000000}, {93,0.00011765}, {94,0.00000000}, {95,0.00015686}, {96,0.00015686}, {97,0.00003922}, {98,0.00002941}, {99,0.00011765}, {100,0.00003922}, {101,0.00002941}, {102,0.00007843}, {103,0.00003922}, {104,0.00007843}, {105,0.00003922}, {106,0.00007843}, {107,0.00003922}, {108,0.00010784}, {109,0.00027451}, {110,0.00017647}, {111,0.00007843}, {112,0.00006863}, {113,0.00003922}, {114,0.00003922}, {115,0.00006863}, {116,0.00007843}, {117,0.00007843}, {118,0.00014706}, {119,0.00007843}, {120,0.00022549}, {121,0.00007843}, {122,0.00003922}, {123,0.00011765}, {124,0.00011765}, {125,0.00015686}, {126,0.00007843}, {127,0.00011765}, {128,0.00000000}, {129,0.00011765}, {130,0.00011765}, {131,0.00015686}, {132,0.00007843}, {133,0.00007843}, {134,0.00003922}, {135,0.00015686}, {136,0.00019608}, {137,0.00007843}, {138,0.00007843}, {139,0.00013725}, {140,0.00011765}, {141,0.00000000}, {142,0.00011765}, {143,0.00015686}, {144,0.00007843}, {145,0.00019608}, {146,0.00003922}, {147,0.00003922}, {148,0.00011765}, {149,0.00007843}, {150,0.00006863}, {151,0.00011765}, {152,0.00019608}, {153,0.00006863}, {154,0.00011765}, {155,0.00011765}, {156,0.00003922}, {157,0.00019608}, {158,0.00007843}, {159,0.00003922}, {160,0.00007843}, {161,0.00007843}, {162,0.00023529}, {163,0.00027451}, {164,0.00011765}, {165,0.00007843}, {166,0.00011765}, {167,0.00015686}, {168,0.00003922}, {169,0.00000000}, {170,0.00003922}, {171,0.00003922}, {172,0.00003922}, {173,0.00014706}, {174,0.00010784}, {175,0.00007843}, {176,0.00011765}, {177,0.00027451}, {178,0.00019608}, {179,0.00007843}, {180,0.00007843}, {181,0.00019608}, {182,0.00007843}, {183,0.00014706}, {184,0.00015686}, {185,0.00019608}, {186,0.00015686}, {187,0.00018627}, {188,0.00000000}, {189,0.00019608}, {190,0.00019608}, {191,0.00007843}, {192,0.00000000}, {193,0.00011765}, {194,0.00031373}, {195,0.00000000}, {196,0.00003922}, {197,0.00015686}, {198,0.00022549}, {199,0.00000000}, {200,0.00014706}, {201,0.00023529}, {202,0.00023529}, {203,0.00007843}, {204,0.00006863}, {205,0.00006863}, {206,0.00023529}, {207,0.00010784}, {208,0.00007843}, {209,0.00007843}, {210,0.00011765}, {211,0.00019608}, {212,0.00019608}, {213,0.00015686}, {214,0.00019608}, {215,0.00019608}, {216,0.00011765}, {217,0.00011765}, {218,0.00031373}, {219,0.00007843}, {220,0.00043137}, {221,0.00023529}, {222,0.00011765}, {223,0.00022549}, {224,0.00027451}, {225,0.00003922}, {226,0.00019608}, {227,0.00027451}, {228,0.00007843}, {229,0.00007843}, {230,0.00022549}, {231,0.00003922}, {232,0.00019608}, {233,0.00026471}, {234,0.00019608}, {235,0.00011765}, {236,0.00019608}, {237,0.00015686}, {238,0.00023529}, {239,0.00011765}, {240,0.00030392}, {241,0.00011765}, {242,0.00023529}, {243,0.00023529}, {244,0.00023529}, {245,0.00018627}, {246,0.00027451}, {247,0.00025490}, {248,0.00026471}, {249,0.00026471}, {250,0.00011765}, {251,0.00023529}, {252,0.00019608}, {253,0.00009804}, {254,0.00011765}, {255,0.00015686}, {256,0.00023529}, {257,0.00003922}, {258,0.00027451}, {259,0.00027451}, {260,0.00015686}, {261,0.00027451}, {262,0.00030392}, {263,0.00015686}, {264,0.00023529}, {265,0.00023529}, {266,0.00023529}, {267,0.00019608}, {268,0.00019608}, {269,0.00011765}, {270,0.00023529}, {271,0.00023529}, {272,0.00011765}, {273,0.00034314}, {274,0.00003922}, {275,0.00015686}, {276,0.00027451}, {277,0.00007843}, {278,0.00035294}, {279,0.00027451}, {280,0.00031373}, {281,0.00042157}, {282,0.00015686}, {283,0.00031373}, {284,0.00023529}, {285,0.00042157}, {286,0.00035294}, {287,0.00035294}, {288,0.00030392}, {289,0.00039216}, {290,0.00023529}, {291,0.00023529}, {292,0.00043137}, {293,0.00027451}, {294,0.00050000}, {295,0.00007843}, {296,0.00053922}, {297,0.00023529}, {298,0.00039216}, {299,0.00019608}, {300,0.00023529}, {301,0.00100}, {302,0.00200}, {303,0.00000}, {304,0.00000}, {305,0.00000}, {306,0.00000}, {307,0.00000}, {308,0.00000}, {309,0.00000}, {310,0.00000}, {311,0.00000}, {312,0.00100}, {313,0.00300}, {314,0.00000}, {315,0.00000}, {316,0.00100}, {317,0.00000}, {318,0.00000}, {319,0.00000}, {320,0.00000}, {321,0.00000}, {322,0.00000}, {323,0.00000}, {324,0.00000}, {325,0.00000}, {326,0.00100}, {327,0.00000}, {328,0.00000}, {329,0.00000}, {330,0.00000}, {331,0.00000}, {332,0.00200}, {333,0.00000}, {334,0.00100}, {335,0.00000}, {336,0.00000}, {337,0.00000}, {338,0.00000}, {339,0.00000}, {340,0.00000}, {341,0.00100}, {342,0.00000}, {343,0.00000}, {344,0.00000}, {345,0.00000}, {346,0.00000}, {347,0.00000}, {348,0.00000}, {349,0.00000}, {350,0.00000}, {351,0.00000}, {352,0.00000}, {353,0.00000}, {354,0.00000}, {355,0.00000}, {356,0.00100}, {357,0.00000}, {358,0.00300}, {359,0.00000}, {360,0.00000}, {361,0.00100}, {362,0.00100}, {363,0.00000}, {364,0.00000}, {365,0.00000}, {366,0.00000}, {367,0.00000}, {368,0.00000}, {369,0.00000}, {370,0.00000}, {371,0.00000}, {372,0.00000}, {373,0.00100}, {374,0.00000}, {375,0.00100}, {376,0.00000}, {377,0.00000}, {378,0.00100}, {379,0.00100}, {380,0.00000}, {381,0.00000}, {382,0.00000}, {383,0.00100}, {384,0.00100}, {385,0.00100}, {386,0.00000}, {387,0.00000}, {388,0.00100}, {389,0.00075}, {390,0.00000}, {391,0.00000}, {392,0.00000}, {393,0.00000}, {394,0.00100}, {395,0.00000}, {396,0.00000}, {397,0.00000}, {398,0.00000}, {399,0.00000}, {400,0.00000}, {401,0.00000}, {402,0.00000}, {403,0.00000}, {404,0.00000}, {405,0.00000}, {406,0.00000}, {407,0.00000}, {408,0.00000}, {409,0.00000}, {410,0.00000}, {411,0.00000}, {412,0.00000}, {413,0.00000}, {414,0.00000}, {415,0.00000}, {416,0.00000}, {417,0.00000}, {418,0.00000}, {419,0.00000}, {420,0.00100}, {421,0.00000}, {422,0.00000}, {423,0.00000}, {424,0.00000}, {425,0.00000}, {426,0.00000}, {427,0.00000}, {428,0.00000}, {429,0.00000}, {430,0.00000}, {431,0.00000}, {432,0.00000}, {433,0.00000}, {434,0.00000}, {435,0.00000}, {436,0.00000}, {437,0.00000}, {438,0.00000}, {439,0.00000}, {440,0.00000}, {441,0.00000}, {442,0.00000}, {443,0.00000}, {444,0.00000}, {445,0.00000}, {446,0.00000}, {447,0.00000}, {448,0.00000}, {449,0.00000}, {450,0.00000}, {451,0.00000}, {452,0.00100}, {453,0.00000}, {454,0.00000}, {455,0.00000}, {456,0.00000}, {457,0.00000}, {458,0.00075}, {459,0.00000}, {460,0.00675}, {461,0.00000}, {462,0.00000}, {463,0.00000}, {464,0.00000}, {465,0.00000}, {466,0.00000}, {467,0.00000}, {468,0.00000}, {469,0.00100}, {470,0.00000}, {471,0.00000}, {472,0.00000}, {473,0.00000}, {474,0.00000}, {475,0.00000}, {476,0.00100}, {477,0.00000}, {478,0.00000}, {479,0.00000}, {480,0.00000}, {481,0.00000}, {482,0.00000}, {483,0.00000}, {484,0.00000}, {485,0.00100}, {486,0.00000}, {487,0.00000}, {488,0.00100}, {489,0.00000}, {490,0.00000}, {491,0.00000}, {492,0.00000}, {493,0.00000}, {494,0.00175}, {495,0.00000}, {496,0.00100}, {497,0.00000}, {498,0.00000}, {499,0.00000}, {500,0.00100}, {505,0.00000}, {510,0.00000}, {515,0.00100}, {520,0.00000}, {525,0.00000}, {530,0.00100}, {535,0.00000}, {540,0.00100}, {545,0.00100}, {550,0.00000}, {555,0.00100}, {560,0.00000}, {565,0.00100}, {570,0.00100}, {575,0.00000}, {580,0.03350}, {585,0.00375}, {590,0.00300}, {595,0.00000}, {600,0.00400}, {605,0.00100}, {610,0.00000}, {615,0.00000}, {620,0.00000}, {625,0.00000}, {630,0.00000}, {635,0.00100}, {640,0.00000}, {645,0.00000}, {650,0.00000}, {655,0.00000}, {660,0.00000}, {665,0.00000}, {670,0.00000}, {675,0.00000}, {680,0.00000}, {685,0.00000}, {690,0.00000}, {695,0.00000}, {700,0.00000}, {705,0.00000}, {710,0.00000}, {715,0.00000}, {720,0.00000}, {725,0.00000}, {730,0.00000}, {735,0.00000}, {740,0.00200}, {745,0.00000}, {750,0.00000}, {755,0.00300}, {760,0.00000}, {765,0.00000}, {770,0.00400}, {775,0.00100}, {780,0.00000}, {785,0.00700}, {790,0.02475}, {795,0.00400}, {800,0.00600}, {805,0.00075}, {810,0.00000}, {815,0.00175}, {820,0.00300}, {825,0.00500}, {830,0.00175}, {835,0.00000}, {840,0.00000}, {845,0.00100}, {850,0.00000}, {855,0.00300}, {860,0.00000}, {865,0.00000}, {870,0.00100}, {875,0.00000}, {880,0.00100}, {885,0.00000}, {890,0.00000}, {895,0.00000}, {900,0.00000}, {905,0.00000}, {910,0.00000}, {915,0.00000}, {920,0.00100}, {925,0.00000}, {930,0.00000}, {935,0.00100}, {940,0.00000}, {945,0.00100}, {950,0.00400}, {955,0.00200}, {960,0.00000}, {965,0.00300}, {970,0.00000}, {975,0.00000}, {980,0.00000}, {985,0.00300}, {990,0.00100}, {995,0.00300}, {1000,0.00100}, {1010,0.00100}, {1020,0.00000}, {1030,0.00200}, {1040,0.00700}, {1050,0.00000}, {1060,0.00000}, {1070,0.00000}, {1080,0.00000}, {1090,0.00300}, {1100,0.00675}, {1110,0.00675}, {1120,0.01200}, {1130,0.00675}, {1140,0.00500}, {1150,0.00700}, {1160,0.00900}, {1170,0.00775}, {1180,0.01175}, {1190,0.01100}, {1200,0.00300}, {1210,0.00600}, {1220,0.00700}, {1230,0.00775}, {1240,0.00700}, {1250,0.01100}, {1260,0.08775}, {1270,0.00400}, {1280,0.00900}, {1290,0.00775}, {1300,0.00500}, {1310,0.00475}, {1320,0.01000}, {1330,0.00300}, {1340,0.00300}, {1350,0.11675}, {1360,0.00500}, {1370,0.00450}, {1380,0.00500}, {1390,0.01100}, {1400,0.01000}, {1410,0.01900}, {1420,0.00900}, {1430,0.01200}, {1440,0.00200}, {1450,0.00200}, {1460,0}, {1470,0}, {1480,0}, {1490,0.012}, {1500,0.044}, {1510,0}, {1520,0.008}, {1530,0.044}, {1540,0.02}, {1550,0.056}, {1560,0}, {1570,0.06}, {1580,0}, {1590,0}, {1600,0.032}, {1610,0.012}, {1620,0.004}, {1630,0}, {1640,0.004}, {1650,0}, {1660,0}, {1670,0}, {1680,0}, {1690,0.004}, {1700,0.02}, {1710,0.143}, {1720,0}, {1730,0}, {1740,0}, {1750,0}, {1760,0.004}, {1770,0.02}, {1780,0.244}, {1790,0.004}, {1800,0}, {1810,0}, {1820,0.096}, {1830,0}, {1840,0.003}, {1850,0.008}, {1860,0.008}, {1870,0}, {1880,0}, {1890,0.004}, {1900,0.199}, {1910,0}, {1920,0.06}, {1930,0}, {1940,0.163}, {1950,0}, {1960,0.008}, {1970,0.028}, {1980,0}, {1990,0}, {2000,0.511}, {2050,0}, {2100,0.088}, {2150,0.056}, {2200,0.275}, {2250,0.22}, {2300,0}, {2350,0.011}, {2400,0.048}, {2450,0.012}, {2500,0}, {2550,0.035}, {2600,0.544}, {2650,0.251}, {2700,0.032}, {2750,0.139}, {2800,0.596}, {2850,0.432}, {2900,0.064}, {2950,0.016}, {3000,0.063}, {3050,0.06}, {3100,0.035}, {3150,0.032}, {3200,0.012}, {3250,0.323}, {3300,0.092}, {3350,0.072}, {3400,0.048}, {3450,0}, {3500,0.055}, {3550,0.04}, {3600,0.739}, {3650,1.004}, {3700,0}, {3750,0.096}, {3800,0.048}, {3850,0.051}, {3900,0.048}, {3950,0.295}, {4000,0.108}, {4050,0.071}, {4100,0.128}, {4150,0.024}, {4200,0.247}, {4250,0.192}, {4300,0.435}, {4350,1.327}, {4400,1.084}, {4450,0.679}, {4500,0.263}, {4550,0.588}, {4600,0.523}, {4650,0.167}, {4700,0.16}, {4750,0.224}, {4800,0.251}, {4850,0.152}, {4900,0.076}, {4950,0.1}, {5000,0.939}, {5050,0.352}, {5100,0.347}, {5150,1.124}, {5200,0.295}, {5250,1.696}, {5300,3.811}, {5350,0.312}, {5400,0.248}, {5450,5.327}, {5500,2.003}, {5550,1.972}, {5600,2.244}, {5650,0.572}, {5700,1.927}, {5750,2.192}, {5800,0.456}, {5850,2.207}, {5900,2.107}, {5950,3.688}, {6000,3.155}};
data["big"]["Ltac2"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00100000}, {3,0.00100000}, {4,0.00108824}, {5,0.00200000}, {6,0.00211765}, {7,0.00300000}, {8,0.00311765}, {9,0.00400980}, {10,0.00491176}, {11,0.00509804}, {12,0.00607843}, {13,0.00706863}, {14,0.00791176}, {15,0.00825490}, {16,0.00915686}, {17,0.01639216}, {18,0.01107843}, {19,0.01214706}, {20,0.01327451}, {21,0.01446078}, {22,0.01593137}, {23,0.01715686}, {24,0.02035294}, {25,0.01934314}, {26,0.02101961}, {27,0.02232353}, {28,0.02349020}, {29,0.02731373}, {30,0.02639216}, {31,0.02800000}, {32,0.02972549}, {33,0.03303922}, {34,0.03300980}, {35,0.03471569}, {36,0.03939216}, {37,0.03821569}, {38,0.04004902}, {39,0.04190196}, {40,0.04388235}, {41,0.04878431}, {42,0.04797059}, {43,0.05320588}, {44,0.05196078}, {45,0.05787255}, {46,0.05627451}, {47,0.06204902}, {48,0.06108824}, {49,0.06605882}, {50,0.07025490}, {51,0.06807843}, {52,0.07393137}, {53,0.07716667}, {54,0.07559804}, {55,0.08189216}, {56,0.08549020}, {57,0.08811765}, {58,0.08635294}, {59,0.09059804}, {60,0.09694118}, {61,0.09925490}, {62,0.10237255}, {63,0.10538235}, {64,0.10850000}, {65,0.11141176}, {66,0.11467647}, {67,0.11783333}, {68,0.12161765}, {69,0.12444118}, {70,0.12811765}, {71,0.13278431}, {72,0.13535294}, {73,0.13865686}, {74,0.14208824}, {75,0.14640196}, {76,0.15033333}, {77,0.15252941}, {78,0.15732353}, {79,0.15998039}, {80,0.16472549}, {81,0.16786275}, {82,0.17243137}, {83,0.17626471}, {84,0.18056863}, {85,0.18425490}, {86,0.18837255}, {87,0.19296078}, {88,0.19763725}, {89,0.20157843}, {90,0.20542157}, {91,0.20983333}, {92,0.21489216}, {93,0.21927451}, {94,0.22355882}, {95,0.22758824}, {96,0.23174510}, {97,0.23637255}, {98,0.24121569}, {99,0.24594118}, {100,0.25025490}, {101,0.25507843}, {102,0.26050000}, {103,0.26611765}, {104,0.27012745}, {105,0.27522549}, {106,0.27994118}, {107,0.28415686}, {108,0.29014706}, {109,0.29444118}, {110,0.29989216}, {111,0.30560784}, {112,0.31056863}, {113,0.31554902}, {114,0.32052941}, {115,0.32672549}, {116,0.33171569}, {117,0.33750980}, {118,0.34246078}, {119,0.34786275}, {120,0.35322549}, {121,0.35924510}, {122,0.36864706}, {123,0.37173529}, {124,0.37727451}, {125,0.38267647}, {126,0.38806863}, {127,0.39415686}, {128,0.40034314}, {129,0.40676471}, {130,0.41498039}, {131,0.42054902}, {132,0.42691176}, {133,0.43355882}, {134,0.43872549}, {135,0.44616667}, {136,0.45380392}, {137,0.45994118}, {138,0.46754902}, {139,0.47340196}, {140,0.47989216}, {141,0.48630392}, {142,0.49089216}, {143,0.50126471}, {144,0.50913725}, {145,0.51584314}, {146,0.52480392}, {147,0.52738235}, {148,0.53477451}, {149,0.54190196}, {150,0.55304902}, {151,0.56524510}, {152,0.57332353}, {153,0.58061765}, {154,0.58408824}, {155,0.58653922}, {156,0.59356863}, {157,0.60193137}, {158,0.60971569}, {159,0.61809804}, {160,0.62473529}, {161,0.63285294}, {162,0.64000980}, {163,0.65980392}, {164,0.65724510}, {165,0.66608824}, {166,0.67260784}, {167,0.68215686}, {168,0.68991176}, {169,0.69514706}, {170,0.70351961}, {171,0.71211765}, {172,0.72048039}, {173,0.73065686}, {174,0.74124510}, {175,0.74568627}, {176,0.75858824}, {177,0.76131373}, {178,0.76992157}, {179,0.77856863}, {180,0.78851961}, {181,0.79747059}, {182,0.80477451}, {183,0.81264706}, {184,0.82416667}, {185,0.83259804}, {186,0.84093137}, {187,0.84941176}, {188,0.85805882}, {189,0.86816667}, {190,0.87109804}, {191,0.88467647}, {192,0.89658824}, {193,0.90581373}, {194,0.91164706}, {195,0.92059804}, {196,0.92893137}, {197,0.93761765}, {198,0.94865686}, {199,0.96023529}, {200,0.96883333}, {201,0.97761765}, {202,0.98708824}, {203,0.99550980}, {204,1.00135294}, {205,1.01888235}, {206,1.02825490}, {207,1.03746078}, {208,1.04780392}, {209,1.04912745}, {210,1.06624510}, {211,1.08780392}, {212,1.08822549}, {213,1.09770588}, {214,1.10870588}, {215,1.11802941}, {216,1.12729412}, {217,1.12995098}, {218,1.14798039}, {219,1.15822549}, {220,1.16798039}, {221,1.17827451}, {222,1.18956863}, {223,1.20150980}, {224,1.21031373}, {225,1.22489216}, {226,1.23437255}, {227,1.24679412}, {228,1.25753922}, {229,1.26679412}, {230,1.27825490}, {231,1.29025490}, {232,1.29684314}, {233,1.31228431}, {234,1.32257843}, {235,1.33383333}, {236,1.34341176}, {237,1.37414706}, {238,1.38605882}, {239,1.38200980}, {240,1.39203922}, {241,1.40435294}, {242,1.42786275}, {243,1.43406863}, {244,1.44589216}, {245,1.45297059}, {246,1.46307843}, {247,1.48056863}, {248,1.49080392}, {249,1.50483333}, {250,1.51695098}, {251,1.52940196}, {252,1.54208824}, {253,1.54448039}, {254,1.56702941}, {255,1.57698039}, {256,1.59150980}, {257,1.61787255}, {258,1.60800000}, {259,1.62055882}, {260,1.63505882}, {261,1.64610784}, {262,1.66119608}, {263,1.67293137}, {264,1.68983333}, {265,1.70339216}, {266,1.70019608}, {267,1.71658824}, {268,1.73203922}, {269,1.74561765}, {270,1.76144118}, {271,1.77154902}, {272,1.78517647}, {273,1.79713725}, {274,1.80907843}, {275,1.82397059}, {276,1.83767647}, {277,1.84949020}, {278,1.86318627}, {279,1.87338235}, {280,1.88992157}, {281,1.90236275}, {282,1.91812745}, {283,1.93453922}, {284,1.94923529}, {285,1.95977451}, {286,2.00444118}, {287,2.00175490}, {288,2.01003922}, {289,2.02929412}, {290,2.05057843}, {291,2.06055882}, {292,2.07018627}, {293,2.08669608}, {294,2.09650000}, {295,2.11031373}, {296,2.12845098}, {297,2.14442157}, {298,2.15591176}, {299,2.17034314}, {300,2.19031373}, {301,2.24325}, {302,2.58200}, {303,2.23250}, {304,2.25225}, {305,2.29800}, {306,2.27875}, {307,2.29250}, {308,2.32275}, {309,2.33700}, {310,2.34250}, {311,2.35850}, {312,2.55225}, {313,2.70975}, {314,2.36975}, {315,2.38900}, {316,2.38900}, {317,2.42825}, {318,2.42200}, {319,2.42950}, {320,2.43150}, {321,2.45650}, {322,2.51875}, {323,2.50800}, {324,2.51625}, {325,2.53900}, {326,2.57425}, {327,2.61825}, {328,2.60075}, {329,2.62225}, {330,2.62850}, {331,2.66675}, {332,2.69650}, {333,2.69550}, {334,2.70575}, {335,2.73900}, {336,2.74700}, {337,2.83700}, {338,2.77875}, {339,2.80975}, {340,2.80725}, {341,2.82950}, {342,2.87325}, {343,2.87300}, {344,2.86300}, {345,2.86725}, {346,2.91500}, {347,2.96975}, {348,2.97725}, {349,2.97325}, {350,2.98900}, {351,3.04500}, {352,3.01875}, {353,3.03975}, {354,3.05350}, {355,3.07675}, {356,3.11525}, {357,3.12525}, {358,3.13675}, {359,3.14625}, {360,3.20175}, {361,3.20750}, {362,3.19425}, {363,3.19550}, {364,3.23300}, {365,3.23100}, {366,3.26100}, {367,3.29725}, {368,3.34225}, {369,3.35150}, {370,3.34200}, {371,3.36900}, {372,3.42325}, {373,3.40350}, {374,3.37650}, {375,3.39900}, {376,3.45475}, {377,3.46350}, {378,3.47800}, {379,3.48775}, {380,3.52900}, {381,3.50400}, {382,3.57900}, {383,3.59900}, {384,3.63550}, {385,3.65850}, {386,3.66425}, {387,3.66875}, {388,3.71625}, {389,3.70025}, {390,3.69725}, {391,3.70050}, {392,3.74325}, {393,3.74025}, {394,3.75775}, {395,3.83275}, {396,3.84625}, {397,3.84250}, {398,3.87750}, {399,3.90975}, {400,3.90175}, {401,3.88700}, {402,3.96600}, {403,3.99875}, {404,4.00150}, {405,4.01875}, {406,4.07450}, {407,4.06025}, {408,4.07250}, {409,4.13200}, {410,4.15300}, {411,4.17050}, {412,4.20300}, {413,4.21950}, {414,4.17725}, {415,4.19025}, {416,4.26350}, {417,4.23750}, {418,4.24150}, {419,4.33675}, {420,4.32300}, {421,4.32350}, {422,4.41350}, {423,4.40800}, {424,4.40125}, {425,4.52600}, {426,4.51750}, {427,4.51000}, {428,4.55075}, {429,4.53825}, {430,4.54275}, {431,4.56275}, {432,4.60175}, {433,4.63900}, {434,4.66450}, {435,4.72050}, {436,4.69050}, {437,4.72550}, {438,4.78750}, {439,4.73050}, {440,4.77875}, {441,4.83050}, {442,4.81375}, {443,4.80450}, {444,4.82225}, {445,4.81800}, {446,4.85550}, {447,4.94400}, {448,4.95250}, {449,5.02425}, {450,4.99225}, {451,4.99775}, {452,5.03250}, {453,5.09325}, {454,5.08875}, {455,5.18275}, {456,5.12550}, {457,5.12150}, {458,5.14375}, {459,5.12250}, {460,5.19150}, {461,5.24000}, {462,5.22150}, {463,5.29625}, {464,5.26750}, {465,5.32625}, {466,5.36950}, {467,5.38925}, {468,5.40675}, {469,5.37725}, {470,5.42600}, {471,5.51000}, {472,5.46400}, {473,5.51525}, {474,5.50725}, {475,5.56350}, {476,5.61425}, {477,5.60800}, {478,5.62100}, {479,5.68375}, {480,5.71325}, {481,5.75225}, {482,5.73750}, {483,5.81175}, {484,5.83500}, {485,5.87675}, {486,5.95425}, {487,5.81775}, {488,5.89350}, {489,5.96175}, {490,6.06225}, {491,6.03325}, {492,5.97700}, {493,6.03875}, {494,5.99100}, {495,6.10600}, {496,6.10925}, {497,6.14750}, {498,6.13175}, {499,6.15400}, {500,6.22825}, {505,6.36425}, {510,6.60900}, {515,6.58475}, {520,6.74000}, {525,6.92725}, {530,7.05775}, {535,7.15625}, {540,7.29575}, {545,7.37950}, {550,7.66300}, {555,7.76775}, {560,7.90375}, {565,8.04175}, {570,8.21750}, {575,8.37575}, {580,8.47275}, {585,8.60075}, {590,8.85325}, {595,8.95525}, {600,8.98275}, {605,9.15375}, {610,9.40800}, {615,9.58225}, {620,9.62275}, {625,9.89025}, {630,10.16300}, {635,10.24400}, {640,10.38225}, {645,10.65950}, {650,10.73825}, {655,10.72350}, {660,11.06200}, {665,11.22700}, {670,11.24250}, {675,11.64300}, {680,11.77650}, {685,11.94925}, {690,12.22950}, {695,12.37500}, {700,12.56050}, {705,12.84950}, {710,12.90625}, {715,13.14025}, {720,13.30275}, {725,13.34000}, {730,13.63400}, {735,13.69075}, {740,13.89225}, {745,14.13800}, {750,14.40400}, {755,14.59750}, {760,15.11475}, {765,15.04625}, {770,15.30125}, {775,15.28200}, {780,15.49750}, {785,16.13525}, {790,15.75050}, {795,16.37625}, {800,16.27300}, {805,16.69750}, {810,16.84200}, {815,17.19625}, {820,17.01375}, {825,17.19500}, {830,17.67575}, {835,17.63350}, {840,18.11800}, {845,18.29475}, {850,18.56125}, {855,18.61625}, {860,18.84300}, {865,18.91400}, {870,19.12800}, {875,19.47625}, {880,19.76725}, {885,20.05100}, {890,20.21050}, {895,20.51100}, {900,20.60625}, {905,21.03800}, {910,21.11500}, {915,21.62125}, {920,21.54400}, {925,22.01475}, {930,22.21525}, {935,22.67550}, {940,22.75275}, {945,22.80950}, {950,23.33975}, {955,23.45225}, {960,23.65350}, {965,24.64300}, {970,24.24975}, {975,24.61900}, {980,24.78075}, {985,25.01000}, {990,25.51475}, {995,25.89925}, {1000,26.36150}, {1010,26.68175}, {1020,27.01475}, {1030,27.44550}, {1040,28.01025}, {1050,28.22250}, {1060,29.44150}, {1070,30.35825}, {1080,30.23125}, {1090,30.91950}, {1100,31.20850}, {1110,32.78300}, {1120,33.40375}, {1130,33.70750}, {1140,34.40700}, {1150,34.74000}, {1160,35.61350}, {1170,36.75825}, {1180,37.14175}, {1190,37.39950}, {1200,38.46850}, {1210,39.27575}, {1220,39.41425}, {1230,40.47250}, {1240,42.12350}, {1250,41.29525}, {1260,43.38800}, {1270,43.62725}, {1280,43.58300}, {1290,45.11850}, {1300,46.09375}, {1310,46.13975}, {1320,46.85175}, {1330,47.69825}, {1340,48.18375}, {1350,49.69025}, {1360,49.37275}, {1370,50.78475}, {1380,50.79450}, {1390,52.31700}, {1400,53.71575}, {1410,54.27500}, {1420,54.54125}, {1430,55.75050}, {1440,56.05775}, {1450,57.79675}, {1460,61.081}, {1470,61.778}, {1480,63.257}, {1490,63.8}, {1500,64.718}, {1510,65.525}, {1520,66.494}, {1530,67.899}, {1540,68.127}, {1550,70.233}, {1560,69.891}, {1570,71.71}, {1580,70.787}, {1590,74.385}, {1600,73.048}, {1610,74.317}, {1620,74.055}, {1630,75.096}, {1640,76.45}, {1650,78.087}, {1660,78.896}, {1670,79.58}, {1680,82.875}, {1690,82.252}, {1700,85.222}, {1710,84.108}, {1720,84.866}, {1730,87.872}, {1740,87.834}, {1750,86.954}, {1760,88.31}, {1770,89.799}, {1780,90.177}, {1790,91.189}, {1800,93.593}, {1810,92.552}, {1820,91.601}, {1830,95.052}, {1840,96.965}, {1850,94.828}, {1860,95.607}, {1870,100.47}, {1880,100.82}, {1890,98.904}, {1900,100.151}, {1910,104.513}, {1920,105.678}, {1930,102.201}, {1940,104.061}, {1950,104.998}, {1960,109.11}, {1970,110.845}, {1980,108.261}, {1990,109.016}, {2000,114.849}, {2050,119.765}, {2100,121.521}, {2150,128.161}, {2200,131.503}, {2250,142.055}, {2300,145.573}, {2350,152.838}, {2400,156.906}, {2450,166.934}, {2500,173.055}, {2550,177.319}, {2600,189.12}, {2650,192.329}, {2700,205.143}, {2750,212.114}, {2800,218.32}, {2850,229.29}, {2900,236.636}, {2950,242.773}, {3000,253.286}, {3050,263.051}, {3100,270.624}, {3150,276.817}, {3200,290.657}, {3250,300.09}, {3300,308.017}, {3350,321.324}, {3400,328.801}, {3450,339.246}, {3500,352.898}, {3550,358.96}, {3600,370.84}, {3650,384.618}, {3700,389.854}, {3750,412.833}, {3800,421.954}, {3850,424.193}, {3900,432.388}, {3950,451.884}, {4000,464.105}, {4050,473.488}, {4100,483.733}, {4150,488.898}, {4200,494.965}, {4250,509.717}, {4300,521.402}, {4350,544.745}, {4400,547.137}, {4450,559.363}, {4500,578.072}, {4550,593.644}, {4600,609.177}, {4650,620.185}, {4700,654.09}, {4750,667.875}, {4800,683.739}, {4850,692.794}, {4900,705.404}, {4950,716.638}, {5000,739.003}, {5050,751.109}, {5100,776.076}, {5150,788.098}, {5200,808.224}, {5250,821.674}, {5300,839.08}, {5350,857.643}, {5400,857.247}, {5450,878.607}, {5500,903.884}, {5550,934.598}, {5600,944.3}, {5650,955.061}, {5700,978.819}, {5750,997.393}, {5800,1008.953}, {5850,1028.2}, {5900,1038.97}, {5950,1059.458}, {6000,1087.466}};
data["big"]["Ltac2"]["actual reif"]["user"] = {{1,0.00086275}, {2,0.00139216}, {3,0.00122549}, {4,0.00164706}, {5,0.00239216}, {6,0.00275490}, {7,0.00316667}, {8,0.00374510}, {9,0.00450000}, {10,0.00478431}, {11,0.00567647}, {12,0.00639216}, {13,0.00676471}, {14,0.00785294}, {15,0.00851961}, {16,0.00970588}, {17,0.01608824}, {18,0.01135294}, {19,0.01248039}, {20,0.01302941}, {21,0.01439216}, {22,0.01545098}, {23,0.01674510}, {24,0.02026471}, {25,0.01921569}, {26,0.02098039}, {27,0.02233333}, {28,0.02388235}, {29,0.02738235}, {30,0.02693137}, {31,0.02821569}, {32,0.02953922}, {33,0.03286275}, {34,0.03322549}, {35,0.03462745}, {36,0.03928431}, {37,0.03810784}, {38,0.03979412}, {39,0.04153922}, {40,0.04362745}, {41,0.04935294}, {42,0.04823529}, {43,0.05335294}, {44,0.05197059}, {45,0.05784314}, {46,0.05614706}, {47,0.06192157}, {48,0.06074510}, {49,0.06564706}, {50,0.07044118}, {51,0.06778431}, {52,0.07450980}, {53,0.07739216}, {54,0.07584314}, {55,0.08171569}, {56,0.08517647}, {57,0.08759804}, {58,0.08587255}, {59,0.09013725}, {60,0.09692157}, {61,0.09937255}, {62,0.10272549}, {63,0.10528431}, {64,0.10808824}, {65,0.11093137}, {66,0.11417647}, {67,0.11780392}, {68,0.12190196}, {69,0.12484314}, {70,0.12834314}, {71,0.13242157}, {72,0.13500000}, {73,0.13814706}, {74,0.14223529}, {75,0.14645098}, {76,0.15015686}, {77,0.15223529}, {78,0.15711765}, {79,0.15940196}, {80,0.16432353}, {81,0.16771569}, {82,0.17234314}, {83,0.17650980}, {84,0.17995098}, {85,0.18376471}, {86,0.18799020}, {87,0.19299020}, {88,0.19749020}, {89,0.20147059}, {90,0.20484314}, {91,0.20922549}, {92,0.21479412}, {93,0.21900980}, {94,0.22343137}, {95,0.22724510}, {96,0.23108824}, {97,0.23596078}, {98,0.24133333}, {99,0.24547059}, {100,0.25018627}, {101,0.25494118}, {102,0.25979412}, {103,0.26588235}, {104,0.26975490}, {105,0.27474510}, {106,0.27910784}, {107,0.28339216}, {108,0.28971569}, {109,0.29405882}, {110,0.29909804}, {111,0.30469608}, {112,0.30988235}, {113,0.31521569}, {114,0.32013725}, {115,0.32604902}, {116,0.33100980}, {117,0.33706863}, {118,0.34201961}, {119,0.34737255}, {120,0.35219608}, {121,0.35866667}, {122,0.36803922}, {123,0.37070588}, {124,0.37650980}, {125,0.38179412}, {126,0.38725490}, {127,0.39345098}, {128,0.39984314}, {129,0.40566667}, {130,0.41426471}, {131,0.41958824}, {132,0.42600980}, {133,0.43287255}, {134,0.43771569}, {135,0.44493137}, {136,0.45264706}, {137,0.45907843}, {138,0.46655882}, {139,0.47225490}, {140,0.47911765}, {141,0.48553922}, {142,0.49013725}, {143,0.50084314}, {144,0.50803922}, {145,0.51497059}, {146,0.52403922}, {147,0.52674510}, {148,0.53368627}, {149,0.54089216}, {150,0.55232353}, {151,0.56430392}, {152,0.57249020}, {153,0.57966667}, {154,0.58310784}, {155,0.58560784}, {156,0.59269608}, {157,0.60126471}, {158,0.60849020}, {159,0.61701961}, {160,0.62378431}, {161,0.63194118}, {162,0.63874510}, {163,0.65850000}, {164,0.65637255}, {165,0.66498039}, {166,0.67168627}, {167,0.68105882}, {168,0.68924510}, {169,0.69411765}, {170,0.70250000}, {171,0.71085294}, {172,0.71954902}, {173,0.72969608}, {174,0.74010784}, {175,0.74479412}, {176,0.75754902}, {177,0.75997059}, {178,0.76856863}, {179,0.77723529}, {180,0.78753922}, {181,0.79598039}, {182,0.80375490}, {183,0.81106863}, {184,0.82293137}, {185,0.83108824}, {186,0.83996078}, {187,0.84807843}, {188,0.85679412}, {189,0.86667647}, {190,0.86987255}, {191,0.88345098}, {192,0.89527451}, {193,0.90447059}, {194,0.91067647}, {195,0.91930392}, {196,0.92732353}, {197,0.93621569}, {198,0.94716667}, {199,0.95930392}, {200,0.96750000}, {201,0.97629412}, {202,0.98600000}, {203,0.99450000}, {204,0.99982353}, {205,1.01755882}, {206,1.02681373}, {207,1.03622549}, {208,1.04633333}, {209,1.04752941}, {210,1.06466667}, {211,1.08599020}, {212,1.08676471}, {213,1.09597059}, {214,1.10713725}, {215,1.11624510}, {216,1.12589216}, {217,1.12812745}, {218,1.14585294}, {219,1.15623529}, {220,1.16621569}, {221,1.17649020}, {222,1.18780392}, {223,1.20008824}, {224,1.20831373}, {225,1.22324510}, {226,1.23254902}, {227,1.24505882}, {228,1.25568627}, {229,1.26542157}, {230,1.27650000}, {231,1.28861765}, {232,1.29494118}, {233,1.31034314}, {234,1.32088235}, {235,1.33199020}, {236,1.34186275}, {237,1.37231373}, {238,1.38375490}, {239,1.37982353}, {240,1.38964706}, {241,1.40177451}, {242,1.42515686}, {243,1.43181373}, {244,1.44319608}, {245,1.45046078}, {246,1.46052941}, {247,1.47744118}, {248,1.48813725}, {249,1.50182353}, {250,1.51426471}, {251,1.52668627}, {252,1.53936275}, {253,1.54196078}, {254,1.56439216}, {255,1.57413725}, {256,1.58930392}, {257,1.61511765}, {258,1.60519608}, {259,1.61752941}, {260,1.63228431}, {261,1.64321569}, {262,1.65850000}, {263,1.67029412}, {264,1.68664706}, {265,1.70066667}, {266,1.69746078}, {267,1.71379412}, {268,1.72925490}, {269,1.74275490}, {270,1.75884314}, {271,1.76909804}, {272,1.78300000}, {273,1.79450980}, {274,1.80607843}, {275,1.82139216}, {276,1.83436275}, {277,1.84671569}, {278,1.85968627}, {279,1.87002941}, {280,1.88668627}, {281,1.89877451}, {282,1.91498039}, {283,1.93092157}, {284,1.94579412}, {285,1.95631373}, {286,2.00111765}, {287,1.99815686}, {288,2.00654902}, {289,2.02580392}, {290,2.04735294}, {291,2.05704902}, {292,2.06690196}, {293,2.08366667}, {294,2.09319608}, {295,2.10727451}, {296,2.12478431}, {297,2.14078431}, {298,2.15252941}, {299,2.16722549}, {300,2.18723529}, {301,2.23950}, {302,2.57750}, {303,2.23025}, {304,2.25075}, {305,2.29325}, {306,2.27500}, {307,2.28950}, {308,2.31950}, {309,2.33425}, {310,2.34050}, {311,2.35550}, {312,2.54750}, {313,2.70325}, {314,2.37075}, {315,2.39025}, {316,2.38975}, {317,2.42800}, {318,2.42100}, {319,2.42850}, {320,2.43150}, {321,2.45525}, {322,2.51775}, {323,2.50850}, {324,2.51750}, {325,2.53850}, {326,2.57350}, {327,2.61675}, {328,2.60025}, {329,2.62275}, {330,2.62850}, {331,2.66675}, {332,2.69550}, {333,2.69075}, {334,2.70050}, {335,2.71425}, {336,2.74125}, {337,2.79550}, {338,2.77600}, {339,2.80225}, {340,2.80525}, {341,2.82825}, {342,2.87375}, {343,2.87275}, {344,2.86225}, {345,2.86700}, {346,2.91350}, {347,2.96950}, {348,2.97825}, {349,2.97225}, {350,2.98775}, {351,3.04325}, {352,3.01775}, {353,3.03850}, {354,3.05400}, {355,3.07675}, {356,3.11400}, {357,3.12575}, {358,3.13400}, {359,3.14575}, {360,3.20050}, {361,3.20525}, {362,3.19350}, {363,3.19475}, {364,3.23200}, {365,3.23100}, {366,3.26225}, {367,3.29750}, {368,3.34025}, {369,3.35050}, {370,3.34150}, {371,3.36950}, {372,3.42350}, {373,3.40250}, {374,3.37675}, {375,3.39650}, {376,3.45425}, {377,3.46225}, {378,3.47675}, {379,3.48425}, {380,3.52725}, {381,3.50350}, {382,3.57975}, {383,3.59600}, {384,3.63325}, {385,3.65850}, {386,3.66450}, {387,3.66850}, {388,3.71675}, {389,3.69850}, {390,3.69650}, {391,3.69925}, {392,3.74275}, {393,3.74100}, {394,3.75425}, {395,3.83050}, {396,3.84675}, {397,3.84275}, {398,3.87825}, {399,3.90975}, {400,3.90225}, {401,3.88650}, {402,3.96450}, {403,3.99825}, {404,4.00200}, {405,4.01825}, {406,4.07575}, {407,4.05900}, {408,4.07225}, {409,4.13225}, {410,4.15300}, {411,4.16925}, {412,4.20325}, {413,4.21925}, {414,4.17650}, {415,4.19275}, {416,4.26250}, {417,4.23700}, {418,4.24200}, {419,4.33750}, {420,4.32225}, {421,4.32350}, {422,4.41350}, {423,4.40850}, {424,4.40150}, {425,4.52550}, {426,4.51650}, {427,4.50850}, {428,4.55150}, {429,4.53775}, {430,4.54250}, {431,4.56275}, {432,4.60275}, {433,4.63850}, {434,4.66350}, {435,4.72050}, {436,4.69075}, {437,4.72475}, {438,4.78750}, {439,4.73050}, {440,4.77875}, {441,4.82925}, {442,4.81575}, {443,4.80525}, {444,4.82200}, {445,4.81850}, {446,4.85500}, {447,4.94325}, {448,4.95125}, {449,5.02450}, {450,4.99150}, {451,4.99900}, {452,5.03250}, {453,5.09125}, {454,5.08950}, {455,5.18150}, {456,5.12325}, {457,5.12200}, {458,5.14225}, {459,5.12225}, {460,5.18400}, {461,5.24050}, {462,5.22125}, {463,5.29525}, {464,5.26625}, {465,5.32550}, {466,5.36900}, {467,5.38850}, {468,5.40800}, {469,5.37775}, {470,5.42575}, {471,5.50950}, {472,5.46375}, {473,5.51425}, {474,5.50725}, {475,5.56250}, {476,5.61375}, {477,5.60700}, {478,5.62025}, {479,5.68350}, {480,5.71250}, {481,5.75125}, {482,5.73625}, {483,5.80900}, {484,5.83550}, {485,5.87350}, {486,5.95200}, {487,5.81650}, {488,5.89050}, {489,5.96150}, {490,6.06025}, {491,6.03050}, {492,5.97650}, {493,6.03800}, {494,5.98825}, {495,6.10450}, {496,6.10750}, {497,6.14550}, {498,6.13050}, {499,6.15275}, {500,6.22550}, {505,6.36250}, {510,6.60650}, {515,6.58225}, {520,6.73850}, {525,6.92575}, {530,7.05525}, {535,7.15500}, {540,7.29325}, {545,7.37600}, {550,7.66175}, {555,7.76550}, {560,7.90300}, {565,8.04000}, {570,8.21575}, {575,8.37375}, {580,8.43850}, {585,8.59200}, {590,8.84875}, {595,8.95400}, {600,8.97575}, {605,9.15400}, {610,9.40650}, {615,9.58050}, {620,9.61925}, {625,9.88625}, {630,10.16050}, {635,10.24100}, {640,10.38250}, {645,10.65825}, {650,10.73950}, {655,10.72350}, {660,11.06250}, {665,11.22650}, {670,11.24250}, {675,11.64125}, {680,11.77700}, {685,11.94900}, {690,12.22950}, {695,12.37475}, {700,12.56075}, {705,12.84950}, {710,12.90625}, {715,13.13975}, {720,13.30150}, {725,13.33975}, {730,13.63275}, {735,13.69050}, {740,13.88950}, {745,14.13825}, {750,14.40450}, {755,14.59350}, {760,15.11450}, {765,15.04525}, {770,15.29625}, {775,15.28125}, {780,15.49675}, {785,16.12750}, {790,15.72425}, {795,16.37125}, {800,16.26650}, {805,16.69425}, {810,16.84150}, {815,17.19425}, {820,17.00975}, {825,17.19075}, {830,17.67250}, {835,17.63225}, {840,18.11750}, {845,18.29500}, {850,18.55950}, {855,18.61550}, {860,18.84150}, {865,18.91450}, {870,19.12675}, {875,19.47600}, {880,19.76525}, {885,20.04975}, {890,20.21075}, {895,20.51075}, {900,20.60625}, {905,21.03750}, {910,21.11450}, {915,21.62200}, {920,21.54350}, {925,22.01575}, {930,22.21575}, {935,22.67575}, {940,22.75275}, {945,22.80750}, {950,23.33725}, {955,23.45025}, {960,23.65350}, {965,24.63825}, {970,24.24950}, {975,24.61975}, {980,24.78125}, {985,25.00725}, {990,25.51350}, {995,25.89525}, {1000,26.35900}, {1010,26.68025}, {1020,27.01300}, {1030,27.44425}, {1040,27.99950}, {1050,28.22125}, {1060,29.44300}, {1070,30.35750}, {1080,30.23125}, {1090,30.91800}, {1100,31.20225}, {1110,32.76000}, {1120,33.34950}, {1130,33.65800}, {1140,34.36125}, {1150,34.68775}, {1160,35.56075}, {1170,36.69975}, {1180,37.08150}, {1190,37.34250}, {1200,38.41900}, {1210,39.17425}, {1220,39.36425}, {1230,40.41650}, {1240,42.06650}, {1250,41.22850}, {1260,43.24575}, {1270,43.57275}, {1280,43.51825}, {1290,45.05575}, {1300,46.01625}, {1310,46.07975}, {1320,46.75975}, {1330,47.30225}, {1340,48.12325}, {1350,49.51400}, {1360,49.30650}, {1370,50.71625}, {1380,50.72950}, {1390,52.21225}, {1400,53.62950}, {1410,54.15250}, {1420,54.46450}, {1430,55.66900}, {1440,56.03725}, {1450,57.79425}, {1460,61.076}, {1470,61.775}, {1480,63.255}, {1490,63.788}, {1500,64.667}, {1510,65.515}, {1520,66.467}, {1530,67.847}, {1540,68.104}, {1550,70.171}, {1560,69.884}, {1570,71.644}, {1580,70.787}, {1590,74.384}, {1600,72.86}, {1610,74.304}, {1620,74.036}, {1630,75.092}, {1640,76.444}, {1650,78.079}, {1660,78.876}, {1670,79.576}, {1680,82.864}, {1690,82.244}, {1700,85.195}, {1710,83.956}, {1720,84.859}, {1730,87.867}, {1740,87.819}, {1750,86.952}, {1760,88.304}, {1770,89.707}, {1780,89.931}, {1790,91.171}, {1800,93.579}, {1810,92.547}, {1820,91.483}, {1830,94.939}, {1840,96.663}, {1850,94.347}, {1860,95.355}, {1870,100.467}, {1880,100.82}, {1890,98.9}, {1900,99.939}, {1910,104.512}, {1920,105.62}, {1930,102.199}, {1940,103.896}, {1950,105.}, {1960,109.1}, {1970,110.819}, {1980,108.26}, {1990,109.02}, {2000,114.251}, {2050,119.744}, {2100,121.415}, {2150,128.1}, {2200,131.228}, {2250,141.835}, {2300,145.572}, {2350,152.827}, {2400,156.855}, {2450,166.923}, {2500,173.056}, {2550,177.279}, {2600,188.576}, {2650,192.079}, {2700,205.111}, {2750,211.971}, {2800,217.724}, {2850,228.86}, {2900,236.572}, {2950,242.76}, {3000,253.22}, {3050,262.992}, {3100,270.587}, {3150,276.788}, {3200,290.647}, {3250,299.768}, {3300,307.924}, {3350,321.251}, {3400,328.751}, {3450,339.247}, {3500,352.84}, {3550,358.92}, {3600,370.1}, {3650,383.612}, {3700,389.855}, {3750,412.74}, {3800,421.903}, {3850,424.139}, {3900,432.}, {3950,449.72}, {4000,462.508}, {4050,473.051}, {4100,483.292}, {4150,488.647}, {4200,494.716}, {4250,509.524}, {4300,520.968}, {4350,543.416}, {4400,546.056}, {4450,558.683}, {4500,577.808}, {4550,593.056}, {4600,608.651}, {4650,619.72}, {4700,651.272}, {4750,664.92}, {4800,681.056}, {4850,692.644}, {4900,705.328}, {4950,716.54}, {5000,738.063}, {5050,750.191}, {5100,772.5}, {5150,785.18}, {5200,807.927}, {5250,817.707}, {5300,834.696}, {5350,856.408}, {5400,855.776}, {5450,873.124}, {5500,900.483}, {5550,930.379}, {5600,938.92}, {5650,952.908}, {5700,975.092}, {5750,994.555}, {5800,1008.495}, {5850,1025.992}, {5900,1036.86}, {5950,1055.767}, {6000,1084.308}};
data["big"]["Ltac2"]["actual reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003922}, {4,0.00003922}, {5,0.00000000}, {6,0.00003922}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00003922}, {12,0.00000000}, {13,0.00007843}, {14,0.00003922}, {15,0.00007843}, {16,0.00003922}, {17,0.00003922}, {18,0.00003922}, {19,0.00000000}, {20,0.00000000}, {21,0.00003922}, {22,0.00003922}, {23,0.00003922}, {24,0.00003922}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00003922}, {29,0.00007843}, {30,0.00007843}, {31,0.00007843}, {32,0.00003922}, {33,0.00010784}, {34,0.00000000}, {35,0.00015686}, {36,0.00000000}, {37,0.00003922}, {38,0.00011765}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00003922}, {45,0.00000000}, {46,0.00003922}, {47,0.00003922}, {48,0.00000000}, {49,0.00000000}, {50,0.00003922}, {51,0.00003922}, {52,0.00000000}, {53,0.00003922}, {54,0.00003922}, {55,0.00011765}, {56,0.00003922}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00003922}, {63,0.00003922}, {64,0.00000000}, {65,0.00015686}, {66,0.00007843}, {67,0.00011765}, {68,0.00000000}, {69,0.00007843}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00007843}, {76,0.00000000}, {77,0.00007843}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00007843}, {82,0.00007843}, {83,0.00007843}, {84,0.00003922}, {85,0.00000000}, {86,0.00003922}, {87,0.00007843}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00003922}, {92,0.00000000}, {93,0.00011765}, {94,0.00000000}, {95,0.00007843}, {96,0.00011765}, {97,0.00003922}, {98,0.00000000}, {99,0.00011765}, {100,0.00003922}, {101,0.00000000}, {102,0.00003922}, {103,0.00000000}, {104,0.00003922}, {105,0.00003922}, {106,0.00003922}, {107,0.00003922}, {108,0.00010784}, {109,0.00027451}, {110,0.00014706}, {111,0.00007843}, {112,0.00006863}, {113,0.00003922}, {114,0.00003922}, {115,0.00006863}, {116,0.00007843}, {117,0.00000000}, {118,0.00014706}, {119,0.00003922}, {120,0.00010784}, {121,0.00003922}, {122,0.00000000}, {123,0.00011765}, {124,0.00011765}, {125,0.00011765}, {126,0.00000000}, {127,0.00003922}, {128,0.00000000}, {129,0.00007843}, {130,0.00011765}, {131,0.00007843}, {132,0.00000000}, {133,0.00003922}, {134,0.00003922}, {135,0.00015686}, {136,0.00015686}, {137,0.00007843}, {138,0.00007843}, {139,0.00010784}, {140,0.00007843}, {141,0.00000000}, {142,0.00003922}, {143,0.00011765}, {144,0.00003922}, {145,0.00019608}, {146,0.00003922}, {147,0.00003922}, {148,0.00007843}, {149,0.00007843}, {150,0.00003922}, {151,0.00011765}, {152,0.00007843}, {153,0.00006863}, {154,0.00007843}, {155,0.00003922}, {156,0.00003922}, {157,0.00019608}, {158,0.00007843}, {159,0.00003922}, {160,0.00007843}, {161,0.00003922}, {162,0.00023529}, {163,0.00023529}, {164,0.00011765}, {165,0.00003922}, {166,0.00011765}, {167,0.00007843}, {168,0.00003922}, {169,0.00000000}, {170,0.00000000}, {171,0.00003922}, {172,0.00000000}, {173,0.00003922}, {174,0.00007843}, {175,0.00003922}, {176,0.00007843}, {177,0.00015686}, {178,0.00015686}, {179,0.00007843}, {180,0.00007843}, {181,0.00015686}, {182,0.00003922}, {183,0.00010784}, {184,0.00011765}, {185,0.00011765}, {186,0.00011765}, {187,0.00010784}, {188,0.00000000}, {189,0.00019608}, {190,0.00011765}, {191,0.00007843}, {192,0.00000000}, {193,0.00007843}, {194,0.00019608}, {195,0.00000000}, {196,0.00003922}, {197,0.00007843}, {198,0.00014706}, {199,0.00000000}, {200,0.00010784}, {201,0.00019608}, {202,0.00015686}, {203,0.00007843}, {204,0.00006863}, {205,0.00006863}, {206,0.00023529}, {207,0.00006863}, {208,0.00003922}, {209,0.00003922}, {210,0.00011765}, {211,0.00011765}, {212,0.00015686}, {213,0.00007843}, {214,0.00015686}, {215,0.00015686}, {216,0.00011765}, {217,0.00011765}, {218,0.00031373}, {219,0.00003922}, {220,0.00035294}, {221,0.00023529}, {222,0.00007843}, {223,0.00011765}, {224,0.00027451}, {225,0.00003922}, {226,0.00015686}, {227,0.00011765}, {228,0.00007843}, {229,0.00000000}, {230,0.00010784}, {231,0.00000000}, {232,0.00007843}, {233,0.00022549}, {234,0.00015686}, {235,0.00011765}, {236,0.00015686}, {237,0.00011765}, {238,0.00015686}, {239,0.00011765}, {240,0.00026471}, {241,0.00011765}, {242,0.00019608}, {243,0.00023529}, {244,0.00023529}, {245,0.00011765}, {246,0.00019608}, {247,0.00025490}, {248,0.00026471}, {249,0.00015686}, {250,0.00011765}, {251,0.00023529}, {252,0.00011765}, {253,0.00009804}, {254,0.00011765}, {255,0.00015686}, {256,0.00019608}, {257,0.00003922}, {258,0.00027451}, {259,0.00023529}, {260,0.00011765}, {261,0.00023529}, {262,0.00022549}, {263,0.00011765}, {264,0.00023529}, {265,0.00015686}, {266,0.00019608}, {267,0.00011765}, {268,0.00015686}, {269,0.00007843}, {270,0.00019608}, {271,0.00019608}, {272,0.00011765}, {273,0.00023529}, {274,0.00003922}, {275,0.00015686}, {276,0.00023529}, {277,0.00003922}, {278,0.00035294}, {279,0.00027451}, {280,0.00027451}, {281,0.00034314}, {282,0.00011765}, {283,0.00023529}, {284,0.00019608}, {285,0.00042157}, {286,0.00023529}, {287,0.00035294}, {288,0.00026471}, {289,0.00035294}, {290,0.00023529}, {291,0.00019608}, {292,0.00039216}, {293,0.00019608}, {294,0.00042157}, {295,0.00007843}, {296,0.00039216}, {297,0.00023529}, {298,0.00031373}, {299,0.00015686}, {300,0.00019608}, {301,0.00100}, {302,0.00200}, {303,0.00000}, {304,0.00000}, {305,0.00000}, {306,0.00000}, {307,0.00000}, {308,0.00000}, {309,0.00000}, {310,0.00000}, {311,0.00000}, {312,0.00100}, {313,0.00300}, {314,0.00000}, {315,0.00000}, {316,0.00000}, {317,0.00000}, {318,0.00000}, {319,0.00000}, {320,0.00000}, {321,0.00000}, {322,0.00000}, {323,0.00000}, {324,0.00000}, {325,0.00000}, {326,0.00000}, {327,0.00000}, {328,0.00000}, {329,0.00000}, {330,0.00000}, {331,0.00000}, {332,0.00200}, {333,0.00000}, {334,0.00100}, {335,0.00000}, {336,0.00000}, {337,0.00000}, {338,0.00000}, {339,0.00000}, {340,0.00000}, {341,0.00000}, {342,0.00000}, {343,0.00000}, {344,0.00000}, {345,0.00000}, {346,0.00000}, {347,0.00000}, {348,0.00000}, {349,0.00000}, {350,0.00000}, {351,0.00000}, {352,0.00000}, {353,0.00000}, {354,0.00000}, {355,0.00000}, {356,0.00100}, {357,0.00000}, {358,0.00200}, {359,0.00000}, {360,0.00000}, {361,0.00100}, {362,0.00100}, {363,0.00000}, {364,0.00000}, {365,0.00000}, {366,0.00000}, {367,0.00000}, {368,0.00000}, {369,0.00000}, {370,0.00000}, {371,0.00000}, {372,0.00000}, {373,0.00100}, {374,0.00000}, {375,0.00100}, {376,0.00000}, {377,0.00000}, {378,0.00100}, {379,0.00000}, {380,0.00000}, {381,0.00000}, {382,0.00000}, {383,0.00100}, {384,0.00100}, {385,0.00000}, {386,0.00000}, {387,0.00000}, {388,0.00100}, {389,0.00000}, {390,0.00000}, {391,0.00000}, {392,0.00000}, {393,0.00000}, {394,0.00100}, {395,0.00000}, {396,0.00000}, {397,0.00000}, {398,0.00000}, {399,0.00000}, {400,0.00000}, {401,0.00000}, {402,0.00000}, {403,0.00000}, {404,0.00000}, {405,0.00000}, {406,0.00000}, {407,0.00000}, {408,0.00000}, {409,0.00000}, {410,0.00000}, {411,0.00000}, {412,0.00000}, {413,0.00000}, {414,0.00000}, {415,0.00000}, {416,0.00000}, {417,0.00000}, {418,0.00000}, {419,0.00000}, {420,0.00100}, {421,0.00000}, {422,0.00000}, {423,0.00000}, {424,0.00000}, {425,0.00000}, {426,0.00000}, {427,0.00000}, {428,0.00000}, {429,0.00000}, {430,0.00000}, {431,0.00000}, {432,0.00000}, {433,0.00000}, {434,0.00000}, {435,0.00000}, {436,0.00000}, {437,0.00000}, {438,0.00000}, {439,0.00000}, {440,0.00000}, {441,0.00000}, {442,0.00000}, {443,0.00000}, {444,0.00000}, {445,0.00000}, {446,0.00000}, {447,0.00000}, {448,0.00000}, {449,0.00000}, {450,0.00000}, {451,0.00000}, {452,0.00000}, {453,0.00000}, {454,0.00000}, {455,0.00000}, {456,0.00000}, {457,0.00000}, {458,0.00075}, {459,0.00000}, {460,0.00500}, {461,0.00000}, {462,0.00000}, {463,0.00000}, {464,0.00000}, {465,0.00000}, {466,0.00000}, {467,0.00000}, {468,0.00000}, {469,0.00000}, {470,0.00000}, {471,0.00000}, {472,0.00000}, {473,0.00000}, {474,0.00000}, {475,0.00000}, {476,0.00000}, {477,0.00000}, {478,0.00000}, {479,0.00000}, {480,0.00000}, {481,0.00000}, {482,0.00000}, {483,0.00000}, {484,0.00000}, {485,0.00100}, {486,0.00000}, {487,0.00000}, {488,0.00100}, {489,0.00000}, {490,0.00000}, {491,0.00000}, {492,0.00000}, {493,0.00000}, {494,0.00075}, {495,0.00000}, {496,0.00000}, {497,0.00000}, {498,0.00000}, {499,0.00000}, {500,0.00100}, {505,0.00000}, {510,0.00000}, {515,0.00100}, {520,0.00000}, {525,0.00000}, {530,0.00100}, {535,0.00000}, {540,0.00100}, {545,0.00000}, {550,0.00000}, {555,0.00100}, {560,0.00000}, {565,0.00100}, {570,0.00000}, {575,0.00000}, {580,0.03250}, {585,0.00375}, {590,0.00300}, {595,0.00000}, {600,0.00400}, {605,0.00000}, {610,0.00000}, {615,0.00000}, {620,0.00000}, {625,0.00000}, {630,0.00000}, {635,0.00000}, {640,0.00000}, {645,0.00000}, {650,0.00000}, {655,0.00000}, {660,0.00000}, {665,0.00000}, {670,0.00000}, {675,0.00000}, {680,0.00000}, {685,0.00000}, {690,0.00000}, {695,0.00000}, {700,0.00000}, {705,0.00000}, {710,0.00000}, {715,0.00000}, {720,0.00000}, {725,0.00000}, {730,0.00000}, {735,0.00000}, {740,0.00200}, {745,0.00000}, {750,0.00000}, {755,0.00300}, {760,0.00000}, {765,0.00000}, {770,0.00400}, {775,0.00100}, {780,0.00000}, {785,0.00700}, {790,0.02475}, {795,0.00400}, {800,0.00600}, {805,0.00075}, {810,0.00000}, {815,0.00175}, {820,0.00300}, {825,0.00500}, {830,0.00175}, {835,0.00000}, {840,0.00000}, {845,0.00000}, {850,0.00000}, {855,0.00300}, {860,0.00000}, {865,0.00000}, {870,0.00000}, {875,0.00000}, {880,0.00100}, {885,0.00000}, {890,0.00000}, {895,0.00000}, {900,0.00000}, {905,0.00000}, {910,0.00000}, {915,0.00000}, {920,0.00000}, {925,0.00000}, {930,0.00000}, {935,0.00100}, {940,0.00000}, {945,0.00100}, {950,0.00300}, {955,0.00200}, {960,0.00000}, {965,0.00300}, {970,0.00000}, {975,0.00000}, {980,0.00000}, {985,0.00300}, {990,0.00100}, {995,0.00300}, {1000,0.00100}, {1010,0.00000}, {1020,0.00000}, {1030,0.00200}, {1040,0.00700}, {1050,0.00000}, {1060,0.00000}, {1070,0.00000}, {1080,0.00000}, {1090,0.00300}, {1100,0.00675}, {1110,0.00675}, {1120,0.01200}, {1130,0.00675}, {1140,0.00500}, {1150,0.00700}, {1160,0.00900}, {1170,0.00775}, {1180,0.01175}, {1190,0.01100}, {1200,0.00300}, {1210,0.00600}, {1220,0.00700}, {1230,0.00675}, {1240,0.00700}, {1250,0.01100}, {1260,0.08775}, {1270,0.00400}, {1280,0.00900}, {1290,0.00675}, {1300,0.00500}, {1310,0.00475}, {1320,0.01000}, {1330,0.00300}, {1340,0.00300}, {1350,0.11675}, {1360,0.00500}, {1370,0.00450}, {1380,0.00500}, {1390,0.01100}, {1400,0.01000}, {1410,0.01900}, {1420,0.00900}, {1430,0.01200}, {1440,0.00200}, {1450,0.00200}, {1460,0}, {1470,0}, {1480,0}, {1490,0.012}, {1500,0.044}, {1510,0}, {1520,0.008}, {1530,0.044}, {1540,0.02}, {1550,0.056}, {1560,0}, {1570,0.06}, {1580,0}, {1590,0}, {1600,0.032}, {1610,0.012}, {1620,0.004}, {1630,0}, {1640,0.004}, {1650,0}, {1660,0}, {1670,0}, {1680,0}, {1690,0}, {1700,0.02}, {1710,0.143}, {1720,0}, {1730,0}, {1740,0}, {1750,0}, {1760,0.004}, {1770,0.02}, {1780,0.244}, {1790,0.004}, {1800,0}, {1810,0}, {1820,0.096}, {1830,0}, {1840,0.003}, {1850,0.008}, {1860,0.008}, {1870,0}, {1880,0}, {1890,0.004}, {1900,0.199}, {1910,0}, {1920,0.06}, {1930,0}, {1940,0.163}, {1950,0}, {1960,0.008}, {1970,0.028}, {1980,0}, {1990,0}, {2000,0.511}, {2050,0}, {2100,0.088}, {2150,0.056}, {2200,0.275}, {2250,0.22}, {2300,0}, {2350,0.011}, {2400,0.048}, {2450,0.012}, {2500,0}, {2550,0.035}, {2600,0.544}, {2650,0.251}, {2700,0.032}, {2750,0.139}, {2800,0.596}, {2850,0.432}, {2900,0.064}, {2950,0.016}, {3000,0.063}, {3050,0.06}, {3100,0.035}, {3150,0.032}, {3200,0.012}, {3250,0.323}, {3300,0.092}, {3350,0.072}, {3400,0.048}, {3450,0}, {3500,0.055}, {3550,0.04}, {3600,0.739}, {3650,1.004}, {3700,0}, {3750,0.096}, {3800,0.048}, {3850,0.051}, {3900,0.048}, {3950,0.295}, {4000,0.108}, {4050,0.071}, {4100,0.128}, {4150,0.024}, {4200,0.247}, {4250,0.192}, {4300,0.435}, {4350,1.327}, {4400,1.084}, {4450,0.679}, {4500,0.263}, {4550,0.588}, {4600,0.523}, {4650,0.167}, {4700,0.16}, {4750,0.224}, {4800,0.251}, {4850,0.152}, {4900,0.076}, {4950,0.1}, {5000,0.939}, {5050,0.352}, {5100,0.347}, {5150,1.124}, {5200,0.295}, {5250,1.692}, {5300,3.811}, {5350,0.312}, {5400,0.248}, {5450,5.327}, {5500,2.003}, {5550,1.972}, {5600,2.244}, {5650,0.572}, {5700,1.927}, {5750,2.192}, {5800,0.456}, {5850,2.207}, {5900,2.107}, {5950,3.688}, {6000,3.155}};
data["big"]["Ltac2"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00072549}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000}, {302,0.00000}, {303,0.00000}, {304,0.00000}, {305,0.00000}, {306,0.00000}, {307,0.00000}, {308,0.00000}, {309,0.00000}, {310,0.00000}, {311,0.00000}, {312,0.00000}, {313,0.00000}, {314,0.00000}, {315,0.00000}, {316,0.00000}, {317,0.00000}, {318,0.00000}, {319,0.00000}, {320,0.00000}, {321,0.00000}, {322,0.00000}, {323,0.00000}, {324,0.00000}, {325,0.00000}, {326,0.00100}, {327,0.00000}, {328,0.00000}, {329,0.00000}, {330,0.00000}, {331,0.00000}, {332,0.00000}, {333,0.00000}, {334,0.00000}, {335,0.00000}, {336,0.00000}, {337,0.00000}, {338,0.00000}, {339,0.00000}, {340,0.00000}, {341,0.00000}, {342,0.00000}, {343,0.00000}, {344,0.00000}, {345,0.00000}, {346,0.00000}, {347,0.00000}, {348,0.00000}, {349,0.00000}, {350,0.00000}, {351,0.00000}, {352,0.00000}, {353,0.00000}, {354,0.00000}, {355,0.00000}, {356,0.00000}, {357,0.00000}, {358,0.00000}, {359,0.00000}, {360,0.00000}, {361,0.00000}, {362,0.00000}, {363,0.00000}, {364,0.00000}, {365,0.00000}, {366,0.00000}, {367,0.00000}, {368,0.00000}, {369,0.00000}, {370,0.00000}, {371,0.00000}, {372,0.00000}, {373,0.00000}, {374,0.00000}, {375,0.00000}, {376,0.00000}, {377,0.00000}, {378,0.00000}, {379,0.00000}, {380,0.00000}, {381,0.00000}, {382,0.00000}, {383,0.00000}, {384,0.00000}, {385,0.00000}, {386,0.00000}, {387,0.00000}, {388,0.00000}, {389,0.00000}, {390,0.00000}, {391,0.00000}, {392,0.00000}, {393,0.00000}, {394,0.00000}, {395,0.00000}, {396,0.00000}, {397,0.00000}, {398,0.00000}, {399,0.00000}, {400,0.00000}, {401,0.00000}, {402,0.00000}, {403,0.00000}, {404,0.00000}, {405,0.00000}, {406,0.00000}, {407,0.00000}, {408,0.00000}, {409,0.00000}, {410,0.00000}, {411,0.00000}, {412,0.00000}, {413,0.00000}, {414,0.00000}, {415,0.00000}, {416,0.00000}, {417,0.00000}, {418,0.00000}, {419,0.00000}, {420,0.00000}, {421,0.00000}, {422,0.00000}, {423,0.00000}, {424,0.00000}, {425,0.00000}, {426,0.00000}, {427,0.00000}, {428,0.00000}, {429,0.00000}, {430,0.00000}, {431,0.00000}, {432,0.00000}, {433,0.00000}, {434,0.00000}, {435,0.00000}, {436,0.00000}, {437,0.00000}, {438,0.00000}, {439,0.00000}, {440,0.00000}, {441,0.00000}, {442,0.00000}, {443,0.00000}, {444,0.00000}, {445,0.00000}, {446,0.00000}, {447,0.00000}, {448,0.00000}, {449,0.00000}, {450,0.00000}, {451,0.00000}, {452,0.00000}, {453,0.00000}, {454,0.00000}, {455,0.00000}, {456,0.00000}, {457,0.00000}, {458,0.00000}, {459,0.00000}, {460,0.00000}, {461,0.00000}, {462,0.00000}, {463,0.00000}, {464,0.00000}, {465,0.00000}, {466,0.00000}, {467,0.00000}, {468,0.00000}, {469,0.00000}, {470,0.00000}, {471,0.00000}, {472,0.00000}, {473,0.00000}, {474,0.00000}, {475,0.00000}, {476,0.00000}, {477,0.00000}, {478,0.00000}, {479,0.00000}, {480,0.00000}, {481,0.00000}, {482,0.00000}, {483,0.00000}, {484,0.00000}, {485,0.00000}, {486,0.00000}, {487,0.00000}, {488,0.00000}, {489,0.00000}, {490,0.00000}, {491,0.00000}, {492,0.00000}, {493,0.00000}, {494,0.00000}, {495,0.00000}, {496,0.00000}, {497,0.00000}, {498,0.00000}, {499,0.00000}, {500,0.00000}, {505,0.00000}, {510,0.00000}, {515,0.00000}, {520,0.00000}, {525,0.00000}, {530,0.00000}, {535,0.00000}, {540,0.00000}, {545,0.00000}, {550,0.00000}, {555,0.00000}, {560,0.00000}, {565,0.00000}, {570,0.00000}, {575,0.00000}, {580,0.00025}, {585,0.00000}, {590,0.00050}, {595,0.00050}, {600,0.00075}, {605,0.00075}, {610,0.00100}, {615,0.00100}, {620,0.00100}, {625,0.00075}, {630,0.00075}, {635,0.00100}, {640,0.00100}, {645,0.00100}, {650,0.00100}, {655,0.00100}, {660,0.00100}, {665,0.00100}, {670,0.00100}, {675,0.00100}, {680,0.00100}, {685,0.00100}, {690,0.00100}, {695,0.00100}, {700,0.00100}, {705,0.00100}, {710,0.00100}, {715,0.00100}, {720,0.00100}, {725,0.00100}, {730,0.00100}, {735,0.00100}, {740,0.00100}, {745,0.00100}, {750,0.00100}, {755,0.00100}, {760,0.00100}, {765,0.00100}, {770,0.00100}, {775,0.00100}, {780,0.00100}, {785,0.00100}, {790,0.00100}, {795,0.00100}, {800,0.00100}, {805,0.00100}, {810,0.00100}, {815,0.00100}, {820,0.00100}, {825,0.00100}, {830,0.00100}, {835,0.00100}, {840,0.00100}, {845,0.00100}, {850,0.00100}, {855,0.00100}, {860,0.00100}, {865,0.00100}, {870,0.00100}, {875,0.00100}, {880,0.00100}, {885,0.00100}, {890,0.00100}, {895,0.00100}, {900,0.00100}, {905,0.00100}, {910,0.00100}, {915,0.00100}, {920,0.00100}, {925,0.00100}, {930,0.00100}, {935,0.00100}, {940,0.00100}, {945,0.00100}, {950,0.00100}, {955,0.00100}, {960,0.00100}, {965,0.00100}, {970,0.00100}, {975,0.00100}, {980,0.00100}, {985,0.00100}, {990,0.00100}, {995,0.00100}, {1000,0.00100}, {1010,0.00100}, {1020,0.00100}, {1030,0.00100}, {1040,0.00100}, {1050,0.00275}, {1060,0.00100}, {1070,0.00100}, {1080,0.00100}, {1090,0.00100}, {1100,0.00100}, {1110,0.00100}, {1120,0.00100}, {1130,0.00100}, {1140,0.00100}, {1150,0.00150}, {1160,0.00100}, {1170,0.00150}, {1180,0.00150}, {1190,0.00150}, {1200,0.00150}, {1210,0.00150}, {1220,0.00175}, {1230,0.00150}, {1240,0.00175}, {1250,0.00200}, {1260,0.00200}, {1270,0.00200}, {1280,0.00200}, {1290,0.00200}, {1300,0.00200}, {1310,0.00200}, {1320,0.00200}, {1330,0.00200}, {1340,0.00200}, {1350,0.00200}, {1360,0.00775}, {1370,0.00200}, {1380,0.00200}, {1390,0.00200}, {1400,0.00200}, {1410,0.00200}, {1420,0.00200}, {1430,0.00200}, {1440,0.00200}, {1450,0.00200}, {1460,0.002}, {1470,0.002}, {1480,0.002}, {1490,0.002}, {1500,0.002}, {1510,0.002}, {1520,0.002}, {1530,0.002}, {1540,0.002}, {1550,0.002}, {1560,0.002}, {1570,0.002}, {1580,0.002}, {1590,0.002}, {1600,0.002}, {1610,0.002}, {1620,0.002}, {1630,0.002}, {1640,0.002}, {1650,0.002}, {1660,0.002}, {1670,0.002}, {1680,0.003}, {1690,0.003}, {1700,0.01}, {1710,0.002}, {1720,0.003}, {1730,0.002}, {1740,0.002}, {1750,0.002}, {1760,0.003}, {1770,0.002}, {1780,0.003}, {1790,0.003}, {1800,0.003}, {1810,0.003}, {1820,0.003}, {1830,0.002}, {1840,0.003}, {1850,0.003}, {1860,0.003}, {1870,0.003}, {1880,0.003}, {1890,0.003}, {1900,0.003}, {1910,0.003}, {1920,0.003}, {1930,0.003}, {1940,0.003}, {1950,0.003}, {1960,0.003}, {1970,0.003}, {1980,0.003}, {1990,0.003}, {2000,0.003}, {2050,0.003}, {2100,0.003}, {2150,0.003}, {2200,0.003}, {2250,0.003}, {2300,0.008}, {2350,0.003}, {2400,0.003}, {2450,0.004}, {2500,0.004}, {2550,0.004}, {2600,0.004}, {2650,0.004}, {2700,0.004}, {2750,0.004}, {2800,0.004}, {2850,0.004}, {2900,0.004}, {2950,0.004}, {3000,0.011}, {3050,0.005}, {3100,0.005}, {3150,0.005}, {3200,0.005}, {3250,0.005}, {3300,0.005}, {3350,0.005}, {3400,0.005}, {3450,0.005}, {3500,0.005}, {3550,0.005}, {3600,0.006}, {3650,0.006}, {3700,0.006}, {3750,0.006}, {3800,0.006}, {3850,0.006}, {3900,0.006}, {3950,0.006}, {4000,0.006}, {4050,0.029}, {4100,0.007}, {4150,0.007}, {4200,0.006}, {4250,0.006}, {4300,0.007}, {4350,0.007}, {4400,0.007}, {4450,0.007}, {4500,0.007}, {4550,0.007}, {4600,0.007}, {4650,0.007}, {4700,0.008}, {4750,0.008}, {4800,0.028}, {4850,0.008}, {4900,0.008}, {4950,0.008}, {5000,0.008}, {5050,0.008}, {5100,0.009}, {5150,0.009}, {5200,0.009}, {5250,0.009}, {5300,0.009}, {5350,0.009}, {5400,0.009}, {5450,0.009}, {5500,0.009}, {5550,0.009}, {5600,0.009}, {5650,0.01}, {5700,0.01}, {5750,0.032}, {5800,0.01}, {5850,0.01}, {5900,0.01}, {5950,0.01}, {6000,0.009}};
data["big"]["Ltac2"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00007843}, {3,0.00011765}, {4,0.00007843}, {5,0.00003922}, {6,0.00003922}, {7,0.00007843}, {8,0.00000000}, {9,0.00007843}, {10,0.00003922}, {11,0.00003922}, {12,0.00000000}, {13,0.00015686}, {14,0.00007843}, {15,0.00007843}, {16,0.00003922}, {17,0.00007843}, {18,0.00003922}, {19,0.00007843}, {20,0.00007843}, {21,0.00007843}, {22,0.00015686}, {23,0.00011765}, {24,0.00000000}, {25,0.00002941}, {26,0.00006863}, {27,0.00007843}, {28,0.00007843}, {29,0.00011765}, {30,0.00007843}, {31,0.00000000}, {32,0.00002941}, {33,0.00003922}, {34,0.00010784}, {35,0.00002941}, {36,0.00000000}, {37,0.00015686}, {38,0.00014706}, {39,0.00003922}, {40,0.00007843}, {41,0.00003922}, {42,0.00010784}, {43,0.00015686}, {44,0.00003922}, {45,0.00018627}, {46,0.00007843}, {47,0.00009804}, {48,0.00015686}, {49,0.00003922}, {50,0.00006863}, {51,0.00003922}, {52,0.00015686}, {53,0.00000000}, {54,0.00011765}, {55,0.00003922}, {56,0.00019608}, {57,0.00023529}, {58,0.00003922}, {59,0.00006863}, {60,0.00010784}, {61,0.00031373}, {62,0.00003922}, {63,0.00009804}, {64,0.00003922}, {65,0.00011765}, {66,0.00022549}, {67,0.00007843}, {68,0.00014706}, {69,0.00014706}, {70,0.00007843}, {71,0.00015686}, {72,0.00014706}, {73,0.00015686}, {74,0.00006863}, {75,0.00007843}, {76,0.00034314}, {77,0.00010784}, {78,0.00030392}, {79,0.00018627}, {80,0.00011765}, {81,0.00011765}, {82,0.00003922}, {83,0.00018627}, {84,0.00010784}, {85,0.00003922}, {86,0.00007843}, {87,0.00015686}, {88,0.00031373}, {89,0.00018627}, {90,0.00029412}, {91,0.00011765}, {92,0.00007843}, {93,0.00014706}, {94,0.00027451}, {95,0.00019608}, {96,0.00010784}, {97,0.00007843}, {98,0.00022549}, {99,0.00003922}, {100,0.00017647}, {101,0.00010784}, {102,0.00015686}, {103,0.00022549}, {104,0.00023529}, {105,0.00019608}, {106,0.00019608}, {107,0.00006863}, {108,0.00010784}, {109,0.00030392}, {110,0.00018627}, {111,0.00026471}, {112,0.00028431}, {113,0.00003922}, {114,0.00027451}, {115,0.00042157}, {116,0.00026471}, {117,0.00015686}, {118,0.00022549}, {119,0.00014706}, {120,0.00019608}, {121,0.00014706}, {122,0.00018627}, {123,0.00021569}, {124,0.00015686}, {125,0.00037255}, {126,0.00016667}, {127,0.00015686}, {128,0.00021569}, {129,0.00043137}, {130,0.00022549}, {131,0.00023529}, {132,0.00030392}, {133,0.00016667}, {134,0.00007843}, {135,0.00026471}, {136,0.00018627}, {137,0.00014706}, {138,0.00029412}, {139,0.00026471}, {140,0.00029412}, {141,0.00024510}, {142,0.00012745}, {143,0.00011765}, {144,0.00035294}, {145,0.00015686}, {146,0.00027451}, {147,0.00033333}, {148,0.00034314}, {149,0.00019608}, {150,0.00022549}, {151,0.00028431}, {152,0.00023529}, {153,0.00018627}, {154,0.00038235}, {155,0.00033333}, {156,0.00027451}, {157,0.00018627}, {158,0.00034314}, {159,0.00011765}, {160,0.00013725}, {161,0.00022549}, {162,0.00049020}, {163,0.00030392}, {164,0.00031373}, {165,0.00033333}, {166,0.00021569}, {167,0.00030392}, {168,0.00015686}, {169,0.00025490}, {170,0.00014706}, {171,0.00046078}, {172,0.00032353}, {173,0.00038235}, {174,0.00015686}, {175,0.00030392}, {176,0.00029412}, {177,0.00039216}, {178,0.00032353}, {179,0.00040196}, {180,0.00023529}, {181,0.00041176}, {182,0.00015686}, {183,0.00037255}, {184,0.00027451}, {185,0.00044118}, {186,0.00033333}, {187,0.00054902}, {188,0.00039216}, {189,0.00023529}, {190,0.00028431}, {191,0.00042157}, {192,0.00027451}, {193,0.00038235}, {194,0.00023529}, {195,0.00044118}, {196,0.00054902}, {197,0.00025490}, {198,0.00085294}, {199,0.00041176}, {200,0.00028431}, {201,0.00023529}, {202,0.00038235}, {203,0.00034314}, {204,0.00051961}, {205,0.00038235}, {206,0.00022549}, {207,0.00040196}, {208,0.00035294}, {209,0.00035294}, {210,0.00023529}, {211,0.00030392}, {212,0.00034314}, {213,0.00037255}, {214,0.00033333}, {215,0.00025490}, {216,0.00030392}, {217,0.00045098}, {218,0.00052941}, {219,0.00043137}, {220,0.00015686}, {221,0.00037255}, {222,0.00035294}, {223,0.00052941}, {224,0.00049020}, {225,0.00029412}, {226,0.00043137}, {227,0.00034314}, {228,0.00042157}, {229,0.00048039}, {230,0.00030392}, {231,0.00041176}, {232,0.00038235}, {233,0.00026471}, {234,0.00051961}, {235,0.00048039}, {236,0.00037255}, {237,0.00028431}, {238,0.00049020}, {239,0.00040196}, {240,0.00029412}, {241,0.00050000}, {242,0.00046078}, {243,0.00046078}, {244,0.00045098}, {245,0.00038235}, {246,0.00015686}, {247,0.00048039}, {248,0.00037255}, {249,0.00026471}, {250,0.00050980}, {251,0.00049020}, {252,0.00049020}, {253,0.00050980}, {254,0.00042157}, {255,0.00053922}, {256,0.00027451}, {257,0.00044118}, {258,0.00058824}, {259,0.00032353}, {260,0.00027451}, {261,0.00043137}, {262,0.00044118}, {263,0.00052941}, {264,0.00042157}, {265,0.00055882}, {266,0.00041176}, {267,0.00033333}, {268,0.00046078}, {269,0.00048039}, {270,0.00056863}, {271,0.00029412}, {272,0.00022549}, {273,0.00035294}, {274,0.00049020}, {275,0.00019608}, {276,0.00042157}, {277,0.00046078}, {278,0.00036275}, {279,0.00037255}, {280,0.00042157}, {281,0.00044118}, {282,0.00053922}, {283,0.00044118}, {284,0.00041176}, {285,0.00028431}, {286,0.00035294}, {287,0.00053922}, {288,0.00057843}, {289,0.00057843}, {290,0.00032353}, {291,0.00082353}, {292,0.00035294}, {293,0.00053922}, {294,0.00045098}, {295,0.00029412}, {296,0.00057843}, {297,0.00058824}, {298,0.00053922}, {299,0.00045098}, {300,0.00051961}, {301,0.00075}, {302,0.00000}, {303,0.00000}, {304,0.00000}, {305,0.00100}, {306,0.00300}, {307,0.00100}, {308,0.00200}, {309,0.00000}, {310,0.00175}, {311,0.00000}, {312,0.00000}, {313,0.00000}, {314,0.00100}, {315,0.00000}, {316,0.00000}, {317,0.00000}, {318,0.00100}, {319,0.00100}, {320,0.00075}, {321,0.00100}, {322,0.00075}, {323,0.00100}, {324,0.00000}, {325,0.00000}, {326,0.00300}, {327,0.00100}, {328,0.00000}, {329,0.00000}, {330,0.00100}, {331,0.00000}, {332,0.00000}, {333,0.00000}, {334,0.00100}, {335,0.00000}, {336,0.00000}, {337,0.00075}, {338,0.00000}, {339,0.00000}, {340,0.00000}, {341,0.00000}, {342,0.00100}, {343,0.00100}, {344,0.00000}, {345,0.00100}, {346,0.00000}, {347,0.00000}, {348,0.00000}, {349,0.00000}, {350,0.00100}, {351,0.00000}, {352,0.00100}, {353,0.00200}, {354,0.00075}, {355,0.00075}, {356,0.00200}, {357,0.00100}, {358,0.00000}, {359,0.00000}, {360,0.00000}, {361,0.00100}, {362,0.00100}, {363,0.00000}, {364,0.00000}, {365,0.00075}, {366,0.00000}, {367,0.00000}, {368,0.00000}, {369,0.00000}, {370,0.00000}, {371,0.00000}, {372,0.00100}, {373,0.00000}, {374,0.00000}, {375,0.00200}, {376,0.00100}, {377,0.00000}, {378,0.00000}, {379,0.00300}, {380,0.00100}, {381,0.00200}, {382,0.00000}, {383,0.00000}, {384,0.00000}, {385,0.00100}, {386,0.00100}, {387,0.00100}, {388,0.00000}, {389,0.00000}, {390,0.00000}, {391,0.00100}, {392,0.00175}, {393,0.00000}, {394,0.00100}, {395,0.00200}, {396,0.00075}, {397,0.00000}, {398,0.00000}, {399,0.00175}, {400,0.00100}, {401,0.00100}, {402,0.00100}, {403,0.00100}, {404,0.00100}, {405,0.00000}, {406,0.00000}, {407,0.00200}, {408,0.00000}, {409,0.00100}, {410,0.00000}, {411,0.00100}, {412,0.00000}, {413,0.00100}, {414,0.00200}, {415,0.00000}, {416,0.00000}, {417,0.00000}, {418,0.00075}, {419,0.00000}, {420,0.00000}, {421,0.00175}, {422,0.00100}, {423,0.00000}, {424,0.00100}, {425,0.00000}, {426,0.00200}, {427,0.00000}, {428,0.00100}, {429,0.00000}, {430,0.00100}, {431,0.00000}, {432,0.00000}, {433,0.00000}, {434,0.00000}, {435,0.00000}, {436,0.00000}, {437,0.00100}, {438,0.00000}, {439,0.00000}, {440,0.00100}, {441,0.00000}, {442,0.00000}, {443,0.00000}, {444,0.00100}, {445,0.00100}, {446,0.00100}, {447,0.00100}, {448,0.00000}, {449,0.00000}, {450,0.00000}, {451,0.00000}, {452,0.00000}, {453,0.00000}, {454,0.00000}, {455,0.00075}, {456,0.00150}, {457,0.00000}, {458,0.00100}, {459,0.00075}, {460,0.00175}, {461,0.00100}, {462,0.00175}, {463,0.00000}, {464,0.00100}, {465,0.00000}, {466,0.00075}, {467,0.00175}, {468,0.00000}, {469,0.00000}, {470,0.00075}, {471,0.00175}, {472,0.00175}, {473,0.00100}, {474,0.00000}, {475,0.00100}, {476,0.00000}, {477,0.00100}, {478,0.00150}, {479,0.00100}, {480,0.00075}, {481,0.00075}, {482,0.00075}, {483,0.00075}, {484,0.00000}, {485,0.00150}, {486,0.00200}, {487,0.00150}, {488,0.00075}, {489,0.00000}, {490,0.00100}, {491,0.00250}, {492,0.00000}, {493,0.00000}, {494,0.00175}, {495,0.00100}, {496,0.00100}, {497,0.00100}, {498,0.00000}, {499,0.00100}, {500,0.00075}, {505,0.00075}, {510,0.00000}, {515,0.00100}, {520,0.00000}, {525,0.00000}, {530,0.00000}, {535,0.00100}, {540,0.00075}, {545,0.00200}, {550,0.00000}, {555,0.00075}, {560,0.00100}, {565,0.00075}, {570,0.00000}, {575,0.00075}, {580,0.00000}, {585,0.00200}, {590,0.00150}, {595,0.00000}, {600,0.00075}, {605,0.00100}, {610,0.00100}, {615,0.00000}, {620,0.00075}, {625,0.00200}, {630,0.00100}, {635,0.00075}, {640,0.00100}, {645,0.00150}, {650,0.00100}, {655,0.00000}, {660,0.00075}, {665,0.00100}, {670,0.00000}, {675,0.00275}, {680,0.00175}, {685,0.00000}, {690,0.00175}, {695,0.00150}, {700,0.00075}, {705,0.00000}, {710,0.00100}, {715,0.00100}, {720,0.00175}, {725,0.00175}, {730,0.00275}, {735,0.00175}, {740,0.00100}, {745,0.00325}, {750,0.00100}, {755,0.00175}, {760,0.00100}, {765,0.00100}, {770,0.00000}, {775,0.00075}, {780,0.00150}, {785,0.00000}, {790,0.00150}, {795,0.00250}, {800,0.00150}, {805,0.00275}, {810,0.00100}, {815,0.00100}, {820,0.00075}, {825,0.00000}, {830,0.00250}, {835,0.00075}, {840,0.00075}, {845,0.00100}, {850,0.00150}, {855,0.00000}, {860,0.00175}, {865,0.00150}, {870,0.00000}, {875,0.00225}, {880,0.00075}, {885,0.00250}, {890,0.00075}, {895,0.00175}, {900,0.00000}, {905,0.00150}, {910,0.00225}, {915,0.00150}, {920,0.00150}, {925,0.00075}, {930,0.00225}, {935,0.00075}, {940,0.00175}, {945,0.00150}, {950,0.00225}, {955,0.00075}, {960,0.00000}, {965,0.00075}, {970,0.00225}, {975,0.00075}, {980,0.00175}, {985,0.00075}, {990,0.00075}, {995,0.00250}, {1000,0.00275}, {1010,0.00150}, {1020,0.00300}, {1030,0.00075}, {1040,0.00150}, {1050,0.00250}, {1060,0.00150}, {1070,0.00000}, {1080,0.00100}, {1090,0.00225}, {1100,0.00075}, {1110,0.00175}, {1120,0.00150}, {1130,0.00150}, {1140,0.00075}, {1150,0.00250}, {1160,0.00075}, {1170,0.00150}, {1180,0.00225}, {1190,0.00250}, {1200,0.00075}, {1210,0.00175}, {1220,0.00175}, {1230,0.00225}, {1240,0.00000}, {1250,0.00225}, {1260,0.00150}, {1270,0.00000}, {1280,0.00325}, {1290,0.00150}, {1300,0.00225}, {1310,0.00075}, {1320,0.00075}, {1330,0.00150}, {1340,0.00150}, {1350,0.00300}, {1360,0.00625}, {1370,0.00150}, {1380,0.00150}, {1390,0.00075}, {1400,0.00175}, {1410,0.00225}, {1420,0.00075}, {1430,0.00300}, {1440,0.00225}, {1450,0.00250}, {1460,0.004}, {1470,0.003}, {1480,0.003}, {1490,0.003}, {1500,0.003}, {1510,0.003}, {1520,0}, {1530,0.003}, {1540,0.003}, {1550,0}, {1560,0.003}, {1570,0}, {1580,0.004}, {1590,0.003}, {1600,0.003}, {1610,0.003}, {1620,0.003}, {1630,0.003}, {1640,0.003}, {1650,0}, {1660,0.003}, {1670,0}, {1680,0}, {1690,0.003}, {1700,0.007}, {1710,0.003}, {1720,0.003}, {1730,0}, {1740,0.003}, {1750,0.003}, {1760,0.003}, {1770,0.003}, {1780,0}, {1790,0.003}, {1800,0.003}, {1810,0.003}, {1820,0.003}, {1830,0.003}, {1840,0.003}, {1850,0.003}, {1860,0}, {1870,0.003}, {1880,0.003}, {1890,0.003}, {1900,0.004}, {1910,0.003}, {1920,0.003}, {1930,0}, {1940,0.003}, {1950,0.004}, {1960,0.003}, {1970,0.003}, {1980,0.003}, {1990,0.004}, {2000,0.003}, {2050,0.003}, {2100,0.004}, {2150,0.003}, {2200,0.003}, {2250,0.004}, {2300,0.007}, {2350,0.004}, {2400,0.003}, {2450,0.004}, {2500,0.004}, {2550,0.004}, {2600,0.003}, {2650,0.004}, {2700,0.004}, {2750,0.004}, {2800,0.004}, {2850,0.003}, {2900,0.003}, {2950,0.004}, {3000,0.011}, {3050,0.007}, {3100,0.003}, {3150,0.004}, {3200,0.004}, {3250,0.003}, {3300,0.004}, {3350,0.007}, {3400,0.003}, {3450,0.003}, {3500,0.004}, {3550,0.004}, {3600,0.007}, {3650,0.004}, {3700,0.003}, {3750,0.007}, {3800,0.008}, {3850,0.004}, {3900,0.007}, {3950,0.008}, {4000,0.007}, {4050,0.031}, {4100,0.004}, {4150,0.008}, {4200,0.007}, {4250,0.007}, {4300,0.007}, {4350,0.008}, {4400,0.007}, {4450,0.008}, {4500,0.008}, {4550,0.008}, {4600,0.008}, {4650,0.007}, {4700,0.007}, {4750,0.011}, {4800,0.031}, {4850,0.008}, {4900,0.008}, {4950,0.007}, {5000,0.008}, {5050,0.008}, {5100,0.008}, {5150,0.008}, {5200,0.008}, {5250,0.008}, {5300,0.007}, {5350,0.007}, {5400,0.007}, {5450,0.008}, {5500,0.012}, {5550,0.008}, {5600,0.011}, {5650,0.008}, {5700,0.011}, {5750,0.032}, {5800,0.011}, {5850,0.007}, {5900,0.008}, {5950,0.012}, {6000,0.011}};
data["big"]["Ltac2"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00003922}, {29,0.00003922}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00003922}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00003922}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003922}, {105,0.00000000}, {106,0.00003922}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00003922}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00007843}, {153,0.00000000}, {154,0.00000000}, {155,0.00003922}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00003922}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00003922}, {173,0.00000000}, {174,0.00000000}, {175,0.00003922}, {176,0.00003922}, {177,0.00003922}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00003922}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00003922}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00003922}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00003922}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00003922}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003922}, {266,0.00000000}, {267,0.00000000}, {268,0.00003922}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000}, {302,0.00000}, {303,0.00000}, {304,0.00000}, {305,0.00000}, {306,0.00000}, {307,0.00000}, {308,0.00000}, {309,0.00000}, {310,0.00000}, {311,0.00000}, {312,0.00000}, {313,0.00000}, {314,0.00000}, {315,0.00000}, {316,0.00000}, {317,0.00000}, {318,0.00000}, {319,0.00000}, {320,0.00000}, {321,0.00000}, {322,0.00000}, {323,0.00000}, {324,0.00000}, {325,0.00000}, {326,0.00000}, {327,0.00000}, {328,0.00000}, {329,0.00000}, {330,0.00000}, {331,0.00000}, {332,0.00000}, {333,0.00000}, {334,0.00000}, {335,0.00000}, {336,0.00000}, {337,0.00000}, {338,0.00000}, {339,0.00000}, {340,0.00000}, {341,0.00000}, {342,0.00000}, {343,0.00000}, {344,0.00000}, {345,0.00000}, {346,0.00000}, {347,0.00000}, {348,0.00000}, {349,0.00000}, {350,0.00000}, {351,0.00000}, {352,0.00000}, {353,0.00000}, {354,0.00000}, {355,0.00000}, {356,0.00000}, {357,0.00000}, {358,0.00000}, {359,0.00000}, {360,0.00000}, {361,0.00000}, {362,0.00000}, {363,0.00000}, {364,0.00000}, {365,0.00000}, {366,0.00000}, {367,0.00000}, {368,0.00000}, {369,0.00000}, {370,0.00000}, {371,0.00000}, {372,0.00000}, {373,0.00000}, {374,0.00000}, {375,0.00000}, {376,0.00000}, {377,0.00000}, {378,0.00000}, {379,0.00000}, {380,0.00000}, {381,0.00000}, {382,0.00000}, {383,0.00000}, {384,0.00000}, {385,0.00000}, {386,0.00000}, {387,0.00000}, {388,0.00000}, {389,0.00000}, {390,0.00000}, {391,0.00000}, {392,0.00000}, {393,0.00000}, {394,0.00000}, {395,0.00000}, {396,0.00000}, {397,0.00000}, {398,0.00000}, {399,0.00000}, {400,0.00000}, {401,0.00000}, {402,0.00000}, {403,0.00000}, {404,0.00000}, {405,0.00000}, {406,0.00000}, {407,0.00000}, {408,0.00000}, {409,0.00000}, {410,0.00000}, {411,0.00000}, {412,0.00000}, {413,0.00000}, {414,0.00000}, {415,0.00000}, {416,0.00000}, {417,0.00000}, {418,0.00000}, {419,0.00000}, {420,0.00000}, {421,0.00000}, {422,0.00000}, {423,0.00000}, {424,0.00000}, {425,0.00000}, {426,0.00000}, {427,0.00000}, {428,0.00000}, {429,0.00000}, {430,0.00000}, {431,0.00000}, {432,0.00000}, {433,0.00000}, {434,0.00000}, {435,0.00000}, {436,0.00000}, {437,0.00000}, {438,0.00000}, {439,0.00000}, {440,0.00000}, {441,0.00000}, {442,0.00000}, {443,0.00000}, {444,0.00000}, {445,0.00000}, {446,0.00000}, {447,0.00000}, {448,0.00000}, {449,0.00000}, {450,0.00000}, {451,0.00000}, {452,0.00000}, {453,0.00000}, {454,0.00000}, {455,0.00000}, {456,0.00000}, {457,0.00000}, {458,0.00000}, {459,0.00000}, {460,0.00000}, {461,0.00000}, {462,0.00000}, {463,0.00000}, {464,0.00000}, {465,0.00000}, {466,0.00000}, {467,0.00000}, {468,0.00000}, {469,0.00000}, {470,0.00000}, {471,0.00000}, {472,0.00000}, {473,0.00000}, {474,0.00000}, {475,0.00000}, {476,0.00000}, {477,0.00000}, {478,0.00000}, {479,0.00000}, {480,0.00000}, {481,0.00000}, {482,0.00000}, {483,0.00000}, {484,0.00000}, {485,0.00000}, {486,0.00000}, {487,0.00000}, {488,0.00000}, {489,0.00000}, {490,0.00000}, {491,0.00000}, {492,0.00000}, {493,0.00000}, {494,0.00000}, {495,0.00000}, {496,0.00000}, {497,0.00000}, {498,0.00000}, {499,0.00000}, {500,0.00000}, {505,0.00000}, {510,0.00000}, {515,0.00000}, {520,0.00000}, {525,0.00000}, {530,0.00000}, {535,0.00000}, {540,0.00000}, {545,0.00000}, {550,0.00000}, {555,0.00000}, {560,0.00000}, {565,0.00000}, {570,0.00000}, {575,0.00000}, {580,0.00000}, {585,0.00000}, {590,0.00000}, {595,0.00000}, {600,0.00000}, {605,0.00000}, {610,0.00000}, {615,0.00000}, {620,0.00000}, {625,0.00000}, {630,0.00000}, {635,0.00000}, {640,0.00000}, {645,0.00000}, {650,0.00000}, {655,0.00000}, {660,0.00000}, {665,0.00000}, {670,0.00000}, {675,0.00000}, {680,0.00000}, {685,0.00000}, {690,0.00000}, {695,0.00000}, {700,0.00000}, {705,0.00000}, {710,0.00000}, {715,0.00000}, {720,0.00000}, {725,0.00000}, {730,0.00000}, {735,0.00000}, {740,0.00000}, {745,0.00000}, {750,0.00000}, {755,0.00000}, {760,0.00000}, {765,0.00000}, {770,0.00000}, {775,0.00000}, {780,0.00000}, {785,0.00000}, {790,0.00000}, {795,0.00000}, {800,0.00000}, {805,0.00000}, {810,0.00000}, {815,0.00000}, {820,0.00000}, {825,0.00000}, {830,0.00000}, {835,0.00000}, {840,0.00000}, {845,0.00000}, {850,0.00000}, {855,0.00000}, {860,0.00000}, {865,0.00000}, {870,0.00100}, {875,0.00000}, {880,0.00000}, {885,0.00000}, {890,0.00000}, {895,0.00000}, {900,0.00000}, {905,0.00000}, {910,0.00000}, {915,0.00000}, {920,0.00000}, {925,0.00000}, {930,0.00000}, {935,0.00000}, {940,0.00000}, {945,0.00000}, {950,0.00000}, {955,0.00000}, {960,0.00000}, {965,0.00000}, {970,0.00000}, {975,0.00000}, {980,0.00000}, {985,0.00000}, {990,0.00000}, {995,0.00000}, {1000,0.00000}, {1010,0.00000}, {1020,0.00000}, {1030,0.00000}, {1040,0.00000}, {1050,0.00000}, {1060,0.00000}, {1070,0.00000}, {1080,0.00000}, {1090,0.00000}, {1100,0.00000}, {1110,0.00000}, {1120,0.00000}, {1130,0.00000}, {1140,0.00000}, {1150,0.00000}, {1160,0.00000}, {1170,0.00000}, {1180,0.00000}, {1190,0.00000}, {1200,0.00000}, {1210,0.00000}, {1220,0.00000}, {1230,0.00000}, {1240,0.00000}, {1250,0.00000}, {1260,0.00000}, {1270,0.00000}, {1280,0.00000}, {1290,0.00000}, {1300,0.00000}, {1310,0.00000}, {1320,0.00000}, {1330,0.00000}, {1340,0.00000}, {1350,0.00000}, {1360,0.00000}, {1370,0.00000}, {1380,0.00000}, {1390,0.00000}, {1400,0.00000}, {1410,0.00000}, {1420,0.00000}, {1430,0.00000}, {1440,0.00000}, {1450,0.00000}, {1460,0}, {1470,0}, {1480,0}, {1490,0}, {1500,0}, {1510,0}, {1520,0}, {1530,0}, {1540,0}, {1550,0}, {1560,0}, {1570,0}, {1580,0}, {1590,0}, {1600,0}, {1610,0}, {1620,0}, {1630,0}, {1640,0}, {1650,0}, {1660,0}, {1670,0}, {1680,0}, {1690,0}, {1700,0}, {1710,0}, {1720,0}, {1730,0}, {1740,0}, {1750,0}, {1760,0}, {1770,0}, {1780,0}, {1790,0}, {1800,0}, {1810,0}, {1820,0}, {1830,0}, {1840,0}, {1850,0}, {1860,0}, {1870,0}, {1880,0}, {1890,0}, {1900,0}, {1910,0}, {1920,0}, {1930,0}, {1940,0}, {1950,0}, {1960,0}, {1970,0}, {1980,0}, {1990,0}, {2000,0}, {2050,0}, {2100,0}, {2150,0}, {2200,0}, {2250,0}, {2300,0}, {2350,0}, {2400,0}, {2450,0}, {2500,0}, {2550,0}, {2600,0}, {2650,0}, {2700,0}, {2750,0}, {2800,0}, {2850,0}, {2900,0}, {2950,0}, {3000,0}, {3050,0}, {3100,0}, {3150,0}, {3200,0}, {3250,0}, {3300,0}, {3350,0}, {3400,0}, {3450,0}, {3500,0}, {3550,0}, {3600,0}, {3650,0}, {3700,0}, {3750,0}, {3800,0}, {3850,0}, {3900,0}, {3950,0}, {4000,0}, {4050,0}, {4100,0}, {4150,0}, {4200,0}, {4250,0}, {4300,0}, {4350,0}, {4400,0}, {4450,0}, {4500,0}, {4550,0}, {4600,0}, {4650,0}, {4700,0}, {4750,0}, {4800,0}, {4850,0}, {4900,0}, {4950,0}, {5000,0}, {5050,0}, {5100,0}, {5150,0}, {5200,0}, {5250,0}, {5300,0}, {5350,0}, {5400,0}, {5450,0}, {5500,0}, {5550,0}, {5600,0}, {5650,0}, {5700,0}, {5750,0}, {5800,0}, {5850,0}, {5900,0}, {5950,0}, {6000,0}};
data["big"]["Ltac2"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000}, {302,0.00000}, {303,0.00000}, {304,0.00000}, {305,0.00000}, {306,0.00000}, {307,0.00000}, {308,0.00000}, {309,0.00000}, {310,0.00000}, {311,0.00000}, {312,0.00000}, {313,0.00000}, {314,0.00000}, {315,0.00000}, {316,0.00000}, {317,0.00000}, {318,0.00000}, {319,0.00000}, {320,0.00000}, {321,0.00000}, {322,0.00000}, {323,0.00000}, {324,0.00000}, {325,0.00000}, {326,0.00000}, {327,0.00000}, {328,0.00000}, {329,0.00000}, {330,0.00000}, {331,0.00000}, {332,0.00000}, {333,0.00000}, {334,0.00000}, {335,0.00000}, {336,0.00000}, {337,0.00000}, {338,0.00000}, {339,0.00000}, {340,0.00000}, {341,0.00000}, {342,0.00000}, {343,0.00000}, {344,0.00000}, {345,0.00000}, {346,0.00000}, {347,0.00000}, {348,0.00000}, {349,0.00000}, {350,0.00000}, {351,0.00000}, {352,0.00000}, {353,0.00000}, {354,0.00000}, {355,0.00000}, {356,0.00000}, {357,0.00000}, {358,0.00000}, {359,0.00000}, {360,0.00000}, {361,0.00000}, {362,0.00000}, {363,0.00000}, {364,0.00000}, {365,0.00000}, {366,0.00000}, {367,0.00000}, {368,0.00000}, {369,0.00000}, {370,0.00000}, {371,0.00000}, {372,0.00000}, {373,0.00000}, {374,0.00000}, {375,0.00000}, {376,0.00000}, {377,0.00000}, {378,0.00000}, {379,0.00000}, {380,0.00000}, {381,0.00000}, {382,0.00000}, {383,0.00000}, {384,0.00000}, {385,0.00000}, {386,0.00000}, {387,0.00000}, {388,0.00000}, {389,0.00000}, {390,0.00000}, {391,0.00000}, {392,0.00000}, {393,0.00000}, {394,0.00000}, {395,0.00000}, {396,0.00000}, {397,0.00000}, {398,0.00000}, {399,0.00000}, {400,0.00000}, {401,0.00000}, {402,0.00000}, {403,0.00000}, {404,0.00000}, {405,0.00000}, {406,0.00000}, {407,0.00000}, {408,0.00000}, {409,0.00000}, {410,0.00000}, {411,0.00000}, {412,0.00000}, {413,0.00000}, {414,0.00000}, {415,0.00000}, {416,0.00000}, {417,0.00000}, {418,0.00000}, {419,0.00000}, {420,0.00000}, {421,0.00000}, {422,0.00000}, {423,0.00000}, {424,0.00000}, {425,0.00000}, {426,0.00000}, {427,0.00000}, {428,0.00000}, {429,0.00000}, {430,0.00000}, {431,0.00000}, {432,0.00000}, {433,0.00000}, {434,0.00000}, {435,0.00000}, {436,0.00000}, {437,0.00000}, {438,0.00000}, {439,0.00000}, {440,0.00000}, {441,0.00000}, {442,0.00000}, {443,0.00000}, {444,0.00000}, {445,0.00000}, {446,0.00000}, {447,0.00000}, {448,0.00000}, {449,0.00000}, {450,0.00000}, {451,0.00000}, {452,0.00000}, {453,0.00000}, {454,0.00000}, {455,0.00000}, {456,0.00000}, {457,0.00000}, {458,0.00000}, {459,0.00000}, {460,0.00000}, {461,0.00000}, {462,0.00000}, {463,0.00000}, {464,0.00000}, {465,0.00000}, {466,0.00000}, {467,0.00000}, {468,0.00000}, {469,0.00000}, {470,0.00000}, {471,0.00000}, {472,0.00000}, {473,0.00000}, {474,0.00000}, {475,0.00000}, {476,0.00000}, {477,0.00000}, {478,0.00000}, {479,0.00000}, {480,0.00000}, {481,0.00000}, {482,0.00000}, {483,0.00000}, {484,0.00000}, {485,0.00000}, {486,0.00000}, {487,0.00000}, {488,0.00000}, {489,0.00100}, {490,0.00000}, {491,0.00000}, {492,0.00000}, {493,0.00000}, {494,0.00000}, {495,0.00000}, {496,0.00000}, {497,0.00000}, {498,0.00000}, {499,0.00000}, {500,0.00000}, {505,0.00000}, {510,0.00000}, {515,0.00000}, {520,0.00000}, {525,0.00000}, {530,0.00000}, {535,0.00000}, {540,0.00000}, {545,0.00000}, {550,0.00000}, {555,0.00000}, {560,0.00000}, {565,0.00000}, {570,0.00000}, {575,0.00000}, {580,0.00000}, {585,0.00000}, {590,0.00000}, {595,0.00000}, {600,0.00000}, {605,0.00000}, {610,0.00000}, {615,0.00000}, {620,0.00000}, {625,0.00000}, {630,0.00000}, {635,0.00000}, {640,0.00000}, {645,0.00000}, {650,0.00000}, {655,0.00000}, {660,0.00025}, {665,0.00000}, {670,0.00000}, {675,0.00000}, {680,0.00050}, {685,0.00000}, {690,0.00025}, {695,0.00075}, {700,0.00075}, {705,0.00075}, {710,0.00100}, {715,0.00100}, {720,0.00100}, {725,0.00100}, {730,0.00100}, {735,0.00100}, {740,0.00100}, {745,0.00100}, {750,0.00100}, {755,0.00100}, {760,0.00100}, {765,0.00100}, {770,0.00100}, {775,0.00100}, {780,0.00100}, {785,0.00100}, {790,0.00100}, {795,0.00100}, {800,0.00100}, {805,0.00100}, {810,0.00100}, {815,0.00100}, {820,0.00100}, {825,0.00100}, {830,0.00100}, {835,0.00100}, {840,0.00100}, {845,0.00100}, {850,0.00100}, {855,0.00100}, {860,0.00100}, {865,0.00100}, {870,0.00100}, {875,0.00100}, {880,0.00100}, {885,0.00100}, {890,0.00100}, {895,0.00100}, {900,0.00100}, {905,0.00100}, {910,0.00100}, {915,0.00100}, {920,0.00100}, {925,0.00100}, {930,0.00100}, {935,0.00100}, {940,0.00100}, {945,0.00100}, {950,0.00100}, {955,0.00400}, {960,0.00100}, {965,0.00100}, {970,0.00100}, {975,0.00100}, {980,0.00100}, {985,0.00100}, {990,0.00100}, {995,0.00100}, {1000,0.00300}, {1010,0.00100}, {1020,0.00100}, {1030,0.00100}, {1040,0.00100}, {1050,0.00100}, {1060,0.00100}, {1070,0.00100}, {1080,0.00100}, {1090,0.00100}, {1100,0.00100}, {1110,0.00100}, {1120,0.00100}, {1130,0.00100}, {1140,0.00100}, {1150,0.00100}, {1160,0.00100}, {1170,0.00100}, {1180,0.00100}, {1190,0.00100}, {1200,0.00100}, {1210,0.00100}, {1220,0.00100}, {1230,0.00100}, {1240,0.00100}, {1250,0.00100}, {1260,0.00675}, {1270,0.00100}, {1280,0.00100}, {1290,0.00100}, {1300,0.00125}, {1310,0.00125}, {1320,0.00100}, {1330,0.00125}, {1340,0.00100}, {1350,0.00125}, {1360,0.00125}, {1370,0.00150}, {1380,0.00125}, {1390,0.00150}, {1400,0.00150}, {1410,0.00175}, {1420,0.00175}, {1430,0.00175}, {1440,0.00200}, {1450,0.00200}, {1460,0.002}, {1470,0.002}, {1480,0.002}, {1490,0.002}, {1500,0.002}, {1510,0.002}, {1520,0.002}, {1530,0.002}, {1540,0.002}, {1550,0.002}, {1560,0.002}, {1570,0.002}, {1580,0.002}, {1590,0.002}, {1600,0.002}, {1610,0.002}, {1620,0.002}, {1630,0.002}, {1640,0.002}, {1650,0.002}, {1660,0.002}, {1670,0.002}, {1680,0.003}, {1690,0.002}, {1700,0.002}, {1710,0.002}, {1720,0.003}, {1730,0.002}, {1740,0.002}, {1750,0.002}, {1760,0.002}, {1770,0.002}, {1780,0.006}, {1790,0.002}, {1800,0.002}, {1810,0.002}, {1820,0.002}, {1830,0.002}, {1840,0.002}, {1850,0.002}, {1860,0.002}, {1870,0.003}, {1880,0.002}, {1890,0.003}, {1900,0.002}, {1910,0.007}, {1920,0.002}, {1930,0.002}, {1940,0.003}, {1950,0.003}, {1960,0.002}, {1970,0.002}, {1980,0.01}, {1990,0.002}, {2000,0.003}, {2050,0.003}, {2100,0.003}, {2150,0.003}, {2200,0.003}, {2250,0.003}, {2300,0.003}, {2350,0.003}, {2400,0.003}, {2450,0.003}, {2500,0.004}, {2550,0.004}, {2600,0.004}, {2650,0.004}, {2700,0.004}, {2750,0.013}, {2800,0.011}, {2850,0.004}, {2900,0.005}, {2950,0.005}, {3000,0.005}, {3050,0.005}, {3100,0.005}, {3150,0.005}, {3200,0.005}, {3250,0.005}, {3300,0.006}, {3350,0.006}, {3400,0.006}, {3450,0.006}, {3500,0.006}, {3550,0.006}, {3600,0.011}, {3650,0.007}, {3700,0.007}, {3750,0.007}, {3800,0.007}, {3850,0.006}, {3900,0.006}, {3950,0.007}, {4000,0.006}, {4050,0.006}, {4100,0.007}, {4150,0.007}, {4200,0.007}, {4250,0.007}, {4300,0.007}, {4350,0.007}, {4400,0.007}, {4450,0.008}, {4500,0.008}, {4550,0.008}, {4600,0.008}, {4650,0.008}, {4700,0.008}, {4750,0.008}, {4800,0.009}, {4850,0.009}, {4900,0.009}, {4950,0.009}, {5000,0.009}, {5050,0.02}, {5100,0.01}, {5150,0.009}, {5200,0.01}, {5250,0.023}, {5300,0.01}, {5350,0.01}, {5400,0.01}, {5450,0.025}, {5500,0.01}, {5550,0.018}, {5600,0.011}, {5650,0.011}, {5700,0.011}, {5750,0.011}, {5800,0.011}, {5850,0.011}, {5900,0.011}, {5950,0.012}, {6000,0.012}};
data["big"]["Ltac2"]["eval lazy"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00007843}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00006863}, {10,0.00007843}, {11,0.00000000}, {12,0.00011765}, {13,0.00007843}, {14,0.00000000}, {15,0.00013725}, {16,0.00010784}, {17,0.00000000}, {18,0.00006863}, {19,0.00006863}, {20,0.00007843}, {21,0.00013725}, {22,0.00007843}, {23,0.00003922}, {24,0.00002941}, {25,0.00000000}, {26,0.00011765}, {27,0.00015686}, {28,0.00015686}, {29,0.00002941}, {30,0.00007843}, {31,0.00002941}, {32,0.00000000}, {33,0.00003922}, {34,0.00011765}, {35,0.00006863}, {36,0.00003922}, {37,0.00003922}, {38,0.00007843}, {39,0.00007843}, {40,0.00003922}, {41,0.00010784}, {42,0.00019608}, {43,0.00011765}, {44,0.00011765}, {45,0.00007843}, {46,0.00002941}, {47,0.00007843}, {48,0.00007843}, {49,0.00005882}, {50,0.00011765}, {51,0.00011765}, {52,0.00007843}, {53,0.00006863}, {54,0.00006863}, {55,0.00013725}, {56,0.00003922}, {57,0.00007843}, {58,0.00019608}, {59,0.00003922}, {60,0.00011765}, {61,0.00018627}, {62,0.00003922}, {63,0.00018627}, {64,0.00007843}, {65,0.00007843}, {66,0.00011765}, {67,0.00023529}, {68,0.00006863}, {69,0.00007843}, {70,0.00006863}, {71,0.00007843}, {72,0.00019608}, {73,0.00027451}, {74,0.00027451}, {75,0.00019608}, {76,0.00014706}, {77,0.00003922}, {78,0.00000000}, {79,0.00019608}, {80,0.00019608}, {81,0.00011765}, {82,0.00015686}, {83,0.00003922}, {84,0.00015686}, {85,0.00011765}, {86,0.00003922}, {87,0.00007843}, {88,0.00014706}, {89,0.00011765}, {90,0.00014706}, {91,0.00019608}, {92,0.00023529}, {93,0.00019608}, {94,0.00022549}, {95,0.00006863}, {96,0.00003922}, {97,0.00014706}, {98,0.00029412}, {99,0.00022549}, {100,0.00013725}, {101,0.00003922}, {102,0.00010784}, {103,0.00010784}, {104,0.00020588}, {105,0.00014706}, {106,0.00009804}, {107,0.00029412}, {108,0.00023529}, {109,0.00018627}, {110,0.00019608}, {111,0.00015686}, {112,0.00011765}, {113,0.00015686}, {114,0.00033333}, {115,0.00007843}, {116,0.00025490}, {117,0.00010784}, {118,0.00018627}, {119,0.00011765}, {120,0.00025490}, {121,0.00027451}, {122,0.00017647}, {123,0.00023529}, {124,0.00015686}, {125,0.00013725}, {126,0.00011765}, {127,0.00026471}, {128,0.00028431}, {129,0.00018627}, {130,0.00014706}, {131,0.00025490}, {132,0.00015686}, {133,0.00018627}, {134,0.00033333}, {135,0.00019608}, {136,0.00027451}, {137,0.00010784}, {138,0.00000000}, {139,0.00025490}, {140,0.00013725}, {141,0.00031373}, {142,0.00015686}, {143,0.00018627}, {144,0.00043137}, {145,0.00034314}, {146,0.00035294}, {147,0.00027451}, {148,0.00030392}, {149,0.00018627}, {150,0.00025490}, {151,0.00007843}, {152,0.00026471}, {153,0.00025490}, {154,0.00015686}, {155,0.00024510}, {156,0.00018627}, {157,0.00014706}, {158,0.00035294}, {159,0.00027451}, {160,0.00018627}, {161,0.00014706}, {162,0.00027451}, {163,0.00034314}, {164,0.00034314}, {165,0.00034314}, {166,0.00042157}, {167,0.00030392}, {168,0.00011765}, {169,0.00039216}, {170,0.00019608}, {171,0.00029412}, {172,0.00021569}, {173,0.00015686}, {174,0.00028431}, {175,0.00011765}, {176,0.00033333}, {177,0.00016667}, {178,0.00019608}, {179,0.00026471}, {180,0.00010784}, {181,0.00026471}, {182,0.00023529}, {183,0.00030392}, {184,0.00023529}, {185,0.00057843}, {186,0.00014706}, {187,0.00026471}, {188,0.00013725}, {189,0.00046078}, {190,0.00019608}, {191,0.00036275}, {192,0.00036275}, {193,0.00042157}, {194,0.00007843}, {195,0.00022549}, {196,0.00032353}, {197,0.00049020}, {198,0.00011765}, {199,0.00029412}, {200,0.00039216}, {201,0.00045098}, {202,0.00031373}, {203,0.00021569}, {204,0.00011765}, {205,0.00022549}, {206,0.00039216}, {207,0.00026471}, {208,0.00031373}, {209,0.00026471}, {210,0.00035294}, {211,0.00027451}, {212,0.00014706}, {213,0.00029412}, {214,0.00022549}, {215,0.00057843}, {216,0.00037255}, {217,0.00034314}, {218,0.00048039}, {219,0.00037255}, {220,0.00031373}, {221,0.00036275}, {222,0.00049020}, {223,0.00031373}, {224,0.00035294}, {225,0.00034314}, {226,0.00025490}, {227,0.00049020}, {228,0.00042157}, {229,0.00044118}, {230,0.00041176}, {231,0.00019608}, {232,0.00049020}, {233,0.00031373}, {234,0.00044118}, {235,0.00030392}, {236,0.00047059}, {237,0.00007843}, {238,0.00028431}, {239,0.00042157}, {240,0.00027451}, {241,0.00025490}, {242,0.00044118}, {243,0.00006863}, {244,0.00036275}, {245,0.00038235}, {246,0.00050000}, {247,0.00030392}, {248,0.00034314}, {249,0.00059804}, {250,0.00034314}, {251,0.00052941}, {252,0.00028431}, {253,0.00037255}, {254,0.00038235}, {255,0.00024510}, {256,0.00019608}, {257,0.00047059}, {258,0.00039216}, {259,0.00042157}, {260,0.00026471}, {261,0.00045098}, {262,0.00030392}, {263,0.00037255}, {264,0.00041176}, {265,0.00041176}, {266,0.00027451}, {267,0.00034314}, {268,0.00027451}, {269,0.00035294}, {270,0.00038235}, {271,0.00037255}, {272,0.00021569}, {273,0.00042157}, {274,0.00019608}, {275,0.00027451}, {276,0.00047059}, {277,0.00030392}, {278,0.00030392}, {279,0.00064706}, {280,0.00042157}, {281,0.00046078}, {282,0.00030392}, {283,0.00042157}, {284,0.00047059}, {285,0.00029412}, {286,0.00044118}, {287,0.00034314}, {288,0.00046078}, {289,0.00038235}, {290,0.00044118}, {291,0.00036275}, {292,0.00034314}, {293,0.00055882}, {294,0.00038235}, {295,0.00043137}, {296,0.00056863}, {297,0.00038235}, {298,0.00035294}, {299,0.00043137}, {300,0.00033333}, {301,0.00000}, {302,0.00100}, {303,0.00000}, {304,0.00000}, {305,0.00275}, {306,0.00000}, {307,0.00000}, {308,0.00000}, {309,0.00000}, {310,0.00000}, {311,0.00100}, {312,0.00000}, {313,0.00000}, {314,0.00000}, {315,0.00000}, {316,0.00000}, {317,0.00000}, {318,0.00000}, {319,0.00000}, {320,0.00100}, {321,0.00100}, {322,0.00175}, {323,0.00000}, {324,0.00000}, {325,0.00000}, {326,0.00000}, {327,0.00075}, {328,0.00000}, {329,0.00000}, {330,0.00100}, {331,0.00000}, {332,0.00075}, {333,0.00000}, {334,0.00000}, {335,0.00100}, {336,0.00075}, {337,0.00175}, {338,0.00000}, {339,0.00100}, {340,0.00100}, {341,0.00000}, {342,0.00000}, {343,0.00000}, {344,0.00000}, {345,0.00000}, {346,0.00000}, {347,0.00000}, {348,0.00000}, {349,0.00100}, {350,0.00000}, {351,0.00075}, {352,0.00100}, {353,0.00000}, {354,0.00100}, {355,0.00000}, {356,0.00000}, {357,0.00000}, {358,0.00075}, {359,0.00100}, {360,0.00100}, {361,0.00000}, {362,0.00000}, {363,0.00100}, {364,0.00100}, {365,0.00000}, {366,0.00000}, {367,0.00000}, {368,0.00075}, {369,0.00100}, {370,0.00000}, {371,0.00000}, {372,0.00000}, {373,0.00000}, {374,0.00000}, {375,0.00000}, {376,0.00000}, {377,0.00100}, {378,0.00000}, {379,0.00200}, {380,0.00100}, {381,0.00000}, {382,0.00000}, {383,0.00175}, {384,0.00100}, {385,0.00000}, {386,0.00000}, {387,0.00000}, {388,0.00000}, {389,0.00100}, {390,0.00000}, {391,0.00000}, {392,0.00000}, {393,0.00000}, {394,0.00000}, {395,0.00200}, {396,0.00000}, {397,0.00100}, {398,0.00000}, {399,0.00000}, {400,0.00100}, {401,0.00100}, {402,0.00200}, {403,0.00100}, {404,0.00075}, {405,0.00000}, {406,0.00000}, {407,0.00075}, {408,0.00000}, {409,0.00100}, {410,0.00100}, {411,0.00175}, {412,0.00200}, {413,0.00000}, {414,0.00100}, {415,0.00000}, {416,0.00200}, {417,0.00200}, {418,0.00000}, {419,0.00100}, {420,0.00100}, {421,0.00000}, {422,0.00200}, {423,0.00100}, {424,0.00000}, {425,0.00100}, {426,0.00100}, {427,0.00200}, {428,0.00000}, {429,0.00200}, {430,0.00100}, {431,0.00075}, {432,0.00100}, {433,0.00000}, {434,0.00200}, {435,0.00000}, {436,0.00000}, {437,0.00100}, {438,0.00200}, {439,0.00100}, {440,0.00000}, {441,0.00100}, {442,0.00000}, {443,0.00000}, {444,0.00100}, {445,0.00000}, {446,0.00000}, {447,0.00200}, {448,0.00175}, {449,0.00000}, {450,0.00000}, {451,0.00000}, {452,0.00000}, {453,0.00175}, {454,0.00000}, {455,0.00100}, {456,0.00075}, {457,0.00000}, {458,0.00000}, {459,0.00000}, {460,0.00075}, {461,0.00075}, {462,0.00100}, {463,0.00000}, {464,0.00100}, {465,0.00100}, {466,0.00150}, {467,0.00000}, {468,0.00000}, {469,0.00000}, {470,0.00075}, {471,0.00000}, {472,0.00000}, {473,0.00200}, {474,0.00100}, {475,0.00000}, {476,0.00075}, {477,0.00100}, {478,0.00000}, {479,0.00000}, {480,0.00000}, {481,0.00075}, {482,0.00300}, {483,0.00200}, {484,0.00000}, {485,0.00200}, {486,0.00100}, {487,0.00000}, {488,0.00100}, {489,0.00100}, {490,0.00100}, {491,0.00000}, {492,0.00000}, {493,0.00000}, {494,0.00000}, {495,0.00075}, {496,0.00075}, {497,0.00000}, {498,0.00100}, {499,0.00075}, {500,0.00000}, {505,0.00175}, {510,0.00275}, {515,0.00100}, {520,0.00100}, {525,0.00000}, {530,0.00075}, {535,0.00000}, {540,0.00000}, {545,0.00000}, {550,0.00075}, {555,0.00000}, {560,0.00000}, {565,0.00000}, {570,0.00175}, {575,0.00075}, {580,0.00075}, {585,0.00175}, {590,0.00000}, {595,0.00000}, {600,0.00100}, {605,0.00075}, {610,0.00000}, {615,0.00075}, {620,0.00000}, {625,0.00000}, {630,0.00075}, {635,0.00100}, {640,0.00075}, {645,0.00100}, {650,0.00000}, {655,0.00075}, {660,0.00075}, {665,0.00075}, {670,0.00075}, {675,0.00075}, {680,0.00075}, {685,0.00150}, {690,0.00000}, {695,0.00075}, {700,0.00000}, {705,0.00175}, {710,0.00100}, {715,0.00075}, {720,0.00075}, {725,0.00000}, {730,0.00075}, {735,0.00000}, {740,0.00000}, {745,0.00000}, {750,0.00075}, {755,0.00075}, {760,0.00150}, {765,0.00075}, {770,0.00075}, {775,0.00000}, {780,0.00100}, {785,0.00075}, {790,0.00000}, {795,0.00000}, {800,0.00000}, {805,0.00175}, {810,0.00075}, {815,0.00075}, {820,0.00175}, {825,0.00075}, {830,0.00075}, {835,0.00100}, {840,0.00075}, {845,0.00000}, {850,0.00175}, {855,0.00000}, {860,0.00150}, {865,0.00075}, {870,0.00150}, {875,0.00075}, {880,0.00150}, {885,0.00075}, {890,0.00075}, {895,0.00175}, {900,0.00250}, {905,0.00100}, {910,0.00100}, {915,0.00075}, {920,0.00175}, {925,0.00000}, {930,0.00075}, {935,0.00000}, {940,0.00150}, {945,0.00275}, {950,0.00000}, {955,0.00350}, {960,0.00175}, {965,0.00275}, {970,0.00100}, {975,0.00075}, {980,0.00075}, {985,0.00100}, {990,0.00250}, {995,0.00175}, {1000,0.00250}, {1010,0.00250}, {1020,0.00075}, {1030,0.00175}, {1040,0.00075}, {1050,0.00100}, {1060,0.00000}, {1070,0.00175}, {1080,0.00075}, {1090,0.00075}, {1100,0.00150}, {1110,0.00250}, {1120,0.00175}, {1130,0.00250}, {1140,0.00100}, {1150,0.00225}, {1160,0.00075}, {1170,0.00000}, {1180,0.00150}, {1190,0.00150}, {1200,0.00075}, {1210,0.00250}, {1220,0.00100}, {1230,0.00325}, {1240,0.00150}, {1250,0.00175}, {1260,0.00500}, {1270,0.00225}, {1280,0.00150}, {1290,0.00075}, {1300,0.00000}, {1310,0.00175}, {1320,0.00150}, {1330,0.00150}, {1340,0.00250}, {1350,0.00150}, {1360,0.00150}, {1370,0.00175}, {1380,0.00075}, {1390,0.00075}, {1400,0.00075}, {1410,0.00075}, {1420,0.00150}, {1430,0.00225}, {1440,0.00225}, {1450,0.00225}, {1460,0.003}, {1470,0}, {1480,0}, {1490,0}, {1500,0.004}, {1510,0.004}, {1520,0.003}, {1530,0}, {1540,0.003}, {1550,0.003}, {1560,0}, {1570,0}, {1580,0}, {1590,0.003}, {1600,0.003}, {1610,0.003}, {1620,0.003}, {1630,0}, {1640,0}, {1650,0.003}, {1660,0}, {1670,0}, {1680,0.003}, {1690,0.003}, {1700,0}, {1710,0}, {1720,0.003}, {1730,0.003}, {1740,0.004}, {1750,0}, {1760,0.003}, {1770,0.003}, {1780,0.003}, {1790,0}, {1800,0}, {1810,0.003}, {1820,0.003}, {1830,0.004}, {1840,0.004}, {1850,0.003}, {1860,0.003}, {1870,0.003}, {1880,0.003}, {1890,0.003}, {1900,0.004}, {1910,0.007}, {1920,0}, {1930,0.004}, {1940,0.003}, {1950,0.003}, {1960,0.004}, {1970,0}, {1980,0.007}, {1990,0}, {2000,0.004}, {2050,0.003}, {2100,0.004}, {2150,0.004}, {2200,0.003}, {2250,0.004}, {2300,0.004}, {2350,0.003}, {2400,0.004}, {2450,0.004}, {2500,0.003}, {2550,0.004}, {2600,0.003}, {2650,0.003}, {2700,0.004}, {2750,0.016}, {2800,0.012}, {2850,0.004}, {2900,0.004}, {2950,0.003}, {3000,0.007}, {3050,0.003}, {3100,0.007}, {3150,0.003}, {3200,0.004}, {3250,0.004}, {3300,0.004}, {3350,0.007}, {3400,0.008}, {3450,0.007}, {3500,0.007}, {3550,0.007}, {3600,0.011}, {3650,0.008}, {3700,0.008}, {3750,0.007}, {3800,0.008}, {3850,0.008}, {3900,0.008}, {3950,0.003}, {4000,0.007}, {4050,0.008}, {4100,0.008}, {4150,0.008}, {4200,0.008}, {4250,0.007}, {4300,0.008}, {4350,0.007}, {4400,0.008}, {4450,0.008}, {4500,0.007}, {4550,0.007}, {4600,0.008}, {4650,0.007}, {4700,0.011}, {4750,0.008}, {4800,0.007}, {4850,0.008}, {4900,0.008}, {4950,0.008}, {5000,0.008}, {5050,0.02}, {5100,0.008}, {5150,0.008}, {5200,0.012}, {5250,0.015}, {5300,0.011}, {5350,0.008}, {5400,0.011}, {5450,0.023}, {5500,0.008}, {5550,0.015}, {5600,0.011}, {5650,0.011}, {5700,0.011}, {5750,0.008}, {5800,0.012}, {5850,0.011}, {5900,0.011}, {5950,0.012}, {6000,0.011}};
data["big"]["Ltac2"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00002941}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00003922}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00003922}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00003922}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00003922}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000}, {302,0.00000}, {303,0.00000}, {304,0.00000}, {305,0.00000}, {306,0.00000}, {307,0.00000}, {308,0.00000}, {309,0.00000}, {310,0.00000}, {311,0.00000}, {312,0.00000}, {313,0.00000}, {314,0.00000}, {315,0.00000}, {316,0.00000}, {317,0.00000}, {318,0.00000}, {319,0.00000}, {320,0.00000}, {321,0.00000}, {322,0.00000}, {323,0.00000}, {324,0.00000}, {325,0.00000}, {326,0.00000}, {327,0.00000}, {328,0.00000}, {329,0.00000}, {330,0.00000}, {331,0.00000}, {332,0.00000}, {333,0.00000}, {334,0.00000}, {335,0.00000}, {336,0.00000}, {337,0.00000}, {338,0.00000}, {339,0.00000}, {340,0.00000}, {341,0.00000}, {342,0.00000}, {343,0.00000}, {344,0.00000}, {345,0.00000}, {346,0.00000}, {347,0.00000}, {348,0.00000}, {349,0.00000}, {350,0.00000}, {351,0.00000}, {352,0.00000}, {353,0.00000}, {354,0.00000}, {355,0.00000}, {356,0.00000}, {357,0.00000}, {358,0.00000}, {359,0.00000}, {360,0.00000}, {361,0.00000}, {362,0.00000}, {363,0.00000}, {364,0.00000}, {365,0.00000}, {366,0.00000}, {367,0.00000}, {368,0.00000}, {369,0.00000}, {370,0.00000}, {371,0.00000}, {372,0.00000}, {373,0.00000}, {374,0.00000}, {375,0.00000}, {376,0.00000}, {377,0.00000}, {378,0.00000}, {379,0.00100}, {380,0.00000}, {381,0.00000}, {382,0.00000}, {383,0.00000}, {384,0.00000}, {385,0.00000}, {386,0.00000}, {387,0.00000}, {388,0.00000}, {389,0.00075}, {390,0.00000}, {391,0.00000}, {392,0.00000}, {393,0.00000}, {394,0.00000}, {395,0.00000}, {396,0.00000}, {397,0.00000}, {398,0.00000}, {399,0.00000}, {400,0.00000}, {401,0.00000}, {402,0.00000}, {403,0.00000}, {404,0.00000}, {405,0.00000}, {406,0.00000}, {407,0.00000}, {408,0.00000}, {409,0.00000}, {410,0.00000}, {411,0.00000}, {412,0.00000}, {413,0.00000}, {414,0.00000}, {415,0.00000}, {416,0.00000}, {417,0.00000}, {418,0.00000}, {419,0.00000}, {420,0.00000}, {421,0.00000}, {422,0.00000}, {423,0.00000}, {424,0.00000}, {425,0.00000}, {426,0.00000}, {427,0.00000}, {428,0.00000}, {429,0.00000}, {430,0.00000}, {431,0.00000}, {432,0.00000}, {433,0.00000}, {434,0.00000}, {435,0.00000}, {436,0.00000}, {437,0.00000}, {438,0.00000}, {439,0.00000}, {440,0.00000}, {441,0.00000}, {442,0.00000}, {443,0.00000}, {444,0.00000}, {445,0.00000}, {446,0.00000}, {447,0.00000}, {448,0.00000}, {449,0.00000}, {450,0.00000}, {451,0.00000}, {452,0.00000}, {453,0.00000}, {454,0.00000}, {455,0.00000}, {456,0.00000}, {457,0.00000}, {458,0.00000}, {459,0.00000}, {460,0.00000}, {461,0.00000}, {462,0.00000}, {463,0.00000}, {464,0.00000}, {465,0.00000}, {466,0.00000}, {467,0.00000}, {468,0.00000}, {469,0.00000}, {470,0.00000}, {471,0.00000}, {472,0.00000}, {473,0.00000}, {474,0.00000}, {475,0.00000}, {476,0.00000}, {477,0.00000}, {478,0.00000}, {479,0.00000}, {480,0.00000}, {481,0.00000}, {482,0.00000}, {483,0.00000}, {484,0.00000}, {485,0.00000}, {486,0.00000}, {487,0.00000}, {488,0.00000}, {489,0.00000}, {490,0.00000}, {491,0.00000}, {492,0.00000}, {493,0.00000}, {494,0.00000}, {495,0.00000}, {496,0.00000}, {497,0.00000}, {498,0.00000}, {499,0.00000}, {500,0.00000}, {505,0.00000}, {510,0.00000}, {515,0.00000}, {520,0.00000}, {525,0.00000}, {530,0.00000}, {535,0.00000}, {540,0.00000}, {545,0.00000}, {550,0.00000}, {555,0.00000}, {560,0.00000}, {565,0.00000}, {570,0.00000}, {575,0.00000}, {580,0.00000}, {585,0.00000}, {590,0.00000}, {595,0.00000}, {600,0.00000}, {605,0.00000}, {610,0.00000}, {615,0.00000}, {620,0.00000}, {625,0.00000}, {630,0.00000}, {635,0.00000}, {640,0.00000}, {645,0.00000}, {650,0.00000}, {655,0.00000}, {660,0.00000}, {665,0.00000}, {670,0.00000}, {675,0.00000}, {680,0.00000}, {685,0.00000}, {690,0.00000}, {695,0.00000}, {700,0.00000}, {705,0.00000}, {710,0.00000}, {715,0.00000}, {720,0.00000}, {725,0.00000}, {730,0.00000}, {735,0.00000}, {740,0.00000}, {745,0.00000}, {750,0.00000}, {755,0.00000}, {760,0.00000}, {765,0.00000}, {770,0.00000}, {775,0.00000}, {780,0.00000}, {785,0.00000}, {790,0.00000}, {795,0.00000}, {800,0.00000}, {805,0.00000}, {810,0.00000}, {815,0.00000}, {820,0.00000}, {825,0.00000}, {830,0.00000}, {835,0.00000}, {840,0.00000}, {845,0.00000}, {850,0.00000}, {855,0.00000}, {860,0.00000}, {865,0.00000}, {870,0.00000}, {875,0.00000}, {880,0.00000}, {885,0.00000}, {890,0.00000}, {895,0.00000}, {900,0.00000}, {905,0.00000}, {910,0.00000}, {915,0.00000}, {920,0.00100}, {925,0.00000}, {930,0.00000}, {935,0.00000}, {940,0.00000}, {945,0.00000}, {950,0.00000}, {955,0.00000}, {960,0.00000}, {965,0.00000}, {970,0.00000}, {975,0.00000}, {980,0.00000}, {985,0.00000}, {990,0.00000}, {995,0.00000}, {1000,0.00000}, {1010,0.00100}, {1020,0.00000}, {1030,0.00000}, {1040,0.00000}, {1050,0.00000}, {1060,0.00000}, {1070,0.00000}, {1080,0.00000}, {1090,0.00000}, {1100,0.00000}, {1110,0.00000}, {1120,0.00000}, {1130,0.00000}, {1140,0.00000}, {1150,0.00000}, {1160,0.00000}, {1170,0.00000}, {1180,0.00000}, {1190,0.00000}, {1200,0.00000}, {1210,0.00000}, {1220,0.00000}, {1230,0.00000}, {1240,0.00000}, {1250,0.00000}, {1260,0.00000}, {1270,0.00000}, {1280,0.00000}, {1290,0.00000}, {1300,0.00000}, {1310,0.00000}, {1320,0.00000}, {1330,0.00000}, {1340,0.00000}, {1350,0.00000}, {1360,0.00000}, {1370,0.00000}, {1380,0.00000}, {1390,0.00000}, {1400,0.00000}, {1410,0.00000}, {1420,0.00000}, {1430,0.00000}, {1440,0.00000}, {1450,0.00000}, {1460,0}, {1470,0}, {1480,0}, {1490,0}, {1500,0}, {1510,0}, {1520,0}, {1530,0}, {1540,0}, {1550,0}, {1560,0}, {1570,0}, {1580,0}, {1590,0}, {1600,0}, {1610,0}, {1620,0}, {1630,0}, {1640,0}, {1650,0}, {1660,0}, {1670,0}, {1680,0}, {1690,0}, {1700,0}, {1710,0}, {1720,0}, {1730,0}, {1740,0}, {1750,0}, {1760,0}, {1770,0}, {1780,0}, {1790,0}, {1800,0}, {1810,0}, {1820,0}, {1830,0}, {1840,0}, {1850,0}, {1860,0}, {1870,0}, {1880,0}, {1890,0}, {1900,0}, {1910,0}, {1920,0}, {1930,0}, {1940,0}, {1950,0}, {1960,0}, {1970,0}, {1980,0}, {1990,0}, {2000,0}, {2050,0}, {2100,0}, {2150,0}, {2200,0}, {2250,0}, {2300,0}, {2350,0}, {2400,0}, {2450,0}, {2500,0}, {2550,0}, {2600,0}, {2650,0}, {2700,0}, {2750,0}, {2800,0}, {2850,0}, {2900,0}, {2950,0}, {3000,0}, {3050,0}, {3100,0}, {3150,0}, {3200,0}, {3250,0}, {3300,0}, {3350,0}, {3400,0}, {3450,0}, {3500,0}, {3550,0}, {3600,0}, {3650,0}, {3700,0}, {3750,0}, {3800,0}, {3850,0}, {3900,0}, {3950,0}, {4000,0}, {4050,0}, {4100,0}, {4150,0}, {4200,0}, {4250,0}, {4300,0}, {4350,0}, {4400,0}, {4450,0}, {4500,0}, {4550,0}, {4600,0}, {4650,0}, {4700,0}, {4750,0}, {4800,0}, {4850,0}, {4900,0}, {4950,0}, {5000,0}, {5050,0}, {5100,0}, {5150,0}, {5200,0}, {5250,0.004}, {5300,0}, {5350,0}, {5400,0}, {5450,0}, {5500,0}, {5550,0}, {5600,0}, {5650,0}, {5700,0}, {5750,0}, {5800,0}, {5850,0}, {5900,0}, {5950,0}, {6000,0}};
data["big"]["Ltac2"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000}, {302,0.00000}, {303,0.00000}, {304,0.00000}, {305,0.00000}, {306,0.00000}, {307,0.00000}, {308,0.00000}, {309,0.00000}, {310,0.00000}, {311,0.00000}, {312,0.00000}, {313,0.00000}, {314,0.00000}, {315,0.00000}, {316,0.00000}, {317,0.00000}, {318,0.00000}, {319,0.00000}, {320,0.00000}, {321,0.00000}, {322,0.00000}, {323,0.00000}, {324,0.00000}, {325,0.00000}, {326,0.00000}, {327,0.00000}, {328,0.00000}, {329,0.00000}, {330,0.00000}, {331,0.00000}, {332,0.00000}, {333,0.00000}, {334,0.00000}, {335,0.00000}, {336,0.00000}, {337,0.00000}, {338,0.00000}, {339,0.00000}, {340,0.00000}, {341,0.00000}, {342,0.00000}, {343,0.00000}, {344,0.00000}, {345,0.00000}, {346,0.00000}, {347,0.00000}, {348,0.00000}, {349,0.00000}, {350,0.00000}, {351,0.00000}, {352,0.00000}, {353,0.00000}, {354,0.00000}, {355,0.00000}, {356,0.00000}, {357,0.00000}, {358,0.00100}, {359,0.00000}, {360,0.00000}, {361,0.00000}, {362,0.00000}, {363,0.00000}, {364,0.00000}, {365,0.00000}, {366,0.00000}, {367,0.00000}, {368,0.00000}, {369,0.00000}, {370,0.00000}, {371,0.00000}, {372,0.00000}, {373,0.00000}, {374,0.00000}, {375,0.00000}, {376,0.00000}, {377,0.00000}, {378,0.00000}, {379,0.00000}, {380,0.00000}, {381,0.00000}, {382,0.00000}, {383,0.00000}, {384,0.00000}, {385,0.00000}, {386,0.00000}, {387,0.00000}, {388,0.00000}, {389,0.00000}, {390,0.00000}, {391,0.00000}, {392,0.00000}, {393,0.00000}, {394,0.00000}, {395,0.00000}, {396,0.00000}, {397,0.00000}, {398,0.00000}, {399,0.00000}, {400,0.00000}, {401,0.00000}, {402,0.00000}, {403,0.00000}, {404,0.00000}, {405,0.00000}, {406,0.00000}, {407,0.00000}, {408,0.00000}, {409,0.00000}, {410,0.00000}, {411,0.00000}, {412,0.00000}, {413,0.00000}, {414,0.00000}, {415,0.00000}, {416,0.00000}, {417,0.00000}, {418,0.00000}, {419,0.00000}, {420,0.00000}, {421,0.00000}, {422,0.00000}, {423,0.00000}, {424,0.00000}, {425,0.00000}, {426,0.00000}, {427,0.00000}, {428,0.00000}, {429,0.00000}, {430,0.00000}, {431,0.00000}, {432,0.00000}, {433,0.00000}, {434,0.00000}, {435,0.00000}, {436,0.00000}, {437,0.00000}, {438,0.00000}, {439,0.00000}, {440,0.00000}, {441,0.00000}, {442,0.00000}, {443,0.00000}, {444,0.00000}, {445,0.00000}, {446,0.00000}, {447,0.00000}, {448,0.00000}, {449,0.00000}, {450,0.00000}, {451,0.00000}, {452,0.00000}, {453,0.00000}, {454,0.00000}, {455,0.00000}, {456,0.00000}, {457,0.00000}, {458,0.00000}, {459,0.00000}, {460,0.00000}, {461,0.00000}, {462,0.00000}, {463,0.00000}, {464,0.00000}, {465,0.00000}, {466,0.00000}, {467,0.00000}, {468,0.00000}, {469,0.00000}, {470,0.00000}, {471,0.00000}, {472,0.00000}, {473,0.00000}, {474,0.00000}, {475,0.00000}, {476,0.00000}, {477,0.00000}, {478,0.00000}, {479,0.00000}, {480,0.00000}, {481,0.00000}, {482,0.00000}, {483,0.00000}, {484,0.00000}, {485,0.00000}, {486,0.00000}, {487,0.00000}, {488,0.00000}, {489,0.00000}, {490,0.00000}, {491,0.00000}, {492,0.00000}, {493,0.00000}, {494,0.00000}, {495,0.00000}, {496,0.00000}, {497,0.00000}, {498,0.00000}, {499,0.00000}, {500,0.00000}, {505,0.00000}, {510,0.00000}, {515,0.00000}, {520,0.00000}, {525,0.00000}, {530,0.00000}, {535,0.00000}, {540,0.00000}, {545,0.00000}, {550,0.00000}, {555,0.00000}, {560,0.00000}, {565,0.00000}, {570,0.00000}, {575,0.00000}, {580,0.00000}, {585,0.00000}, {590,0.00000}, {595,0.00000}, {600,0.00000}, {605,0.00000}, {610,0.00000}, {615,0.00000}, {620,0.00000}, {625,0.00000}, {630,0.00000}, {635,0.00000}, {640,0.00000}, {645,0.00000}, {650,0.00000}, {655,0.00000}, {660,0.00000}, {665,0.00000}, {670,0.00000}, {675,0.00000}, {680,0.00000}, {685,0.00000}, {690,0.00000}, {695,0.00000}, {700,0.00000}, {705,0.00000}, {710,0.00000}, {715,0.00000}, {720,0.00000}, {725,0.00000}, {730,0.00000}, {735,0.00000}, {740,0.00000}, {745,0.00000}, {750,0.00000}, {755,0.00000}, {760,0.00000}, {765,0.00000}, {770,0.00000}, {775,0.00000}, {780,0.00000}, {785,0.00000}, {790,0.00000}, {795,0.00000}, {800,0.00000}, {805,0.00375}, {810,0.00000}, {815,0.00000}, {820,0.00000}, {825,0.00000}, {830,0.00000}, {835,0.00000}, {840,0.00000}, {845,0.00300}, {850,0.00000}, {855,0.00000}, {860,0.00000}, {865,0.00000}, {870,0.00000}, {875,0.00000}, {880,0.00000}, {885,0.00000}, {890,0.00000}, {895,0.00000}, {900,0.00000}, {905,0.00000}, {910,0.00000}, {915,0.00000}, {920,0.00000}, {925,0.00000}, {930,0.00000}, {935,0.00000}, {940,0.00000}, {945,0.00000}, {950,0.00000}, {955,0.00000}, {960,0.00000}, {965,0.00000}, {970,0.00000}, {975,0.00000}, {980,0.00000}, {985,0.00000}, {990,0.00000}, {995,0.00000}, {1000,0.00000}, {1010,0.00000}, {1020,0.00000}, {1030,0.00000}, {1040,0.00000}, {1050,0.00000}, {1060,0.00000}, {1070,0.00000}, {1080,0.00000}, {1090,0.00000}, {1100,0.00000}, {1110,0.00000}, {1120,0.00000}, {1130,0.00000}, {1140,0.00000}, {1150,0.00000}, {1160,0.00000}, {1170,0.00000}, {1180,0.00000}, {1190,0.00000}, {1200,0.00000}, {1210,0.00000}, {1220,0.00000}, {1230,0.00000}, {1240,0.00000}, {1250,0.00000}, {1260,0.00000}, {1270,0.00000}, {1280,0.00000}, {1290,0.00000}, {1300,0.00000}, {1310,0.00000}, {1320,0.00000}, {1330,0.00000}, {1340,0.00000}, {1350,0.00000}, {1360,0.00000}, {1370,0.00000}, {1380,0.00000}, {1390,0.00025}, {1400,0.00025}, {1410,0.00475}, {1420,0.00000}, {1430,0.00000}, {1440,0.00025}, {1450,0.00000}, {1460,0}, {1470,0}, {1480,0}, {1490,0}, {1500,0}, {1510,0.001}, {1520,0.001}, {1530,0}, {1540,0}, {1550,0}, {1560,0}, {1570,0.001}, {1580,0.001}, {1590,0.001}, {1600,0.001}, {1610,0.001}, {1620,0.001}, {1630,0.001}, {1640,0.001}, {1650,0.001}, {1660,0.001}, {1670,0.001}, {1680,0.001}, {1690,0.001}, {1700,0.001}, {1710,0.001}, {1720,0.001}, {1730,0.001}, {1740,0.001}, {1750,0.001}, {1760,0.001}, {1770,0.001}, {1780,0.001}, {1790,0.001}, {1800,0.001}, {1810,0.001}, {1820,0.001}, {1830,0.001}, {1840,0.001}, {1850,0.001}, {1860,0.001}, {1870,0.001}, {1880,0.001}, {1890,0.001}, {1900,0.001}, {1910,0.001}, {1920,0.001}, {1930,0.001}, {1940,0.001}, {1950,0.001}, {1960,0.001}, {1970,0.001}, {1980,0.001}, {1990,0.001}, {2000,0.001}, {2050,0.001}, {2100,0.001}, {2150,0.001}, {2200,0.001}, {2250,0.001}, {2300,0.001}, {2350,0.001}, {2400,0.001}, {2450,0.001}, {2500,0.001}, {2550,0.001}, {2600,0.001}, {2650,0.001}, {2700,0.001}, {2750,0.002}, {2800,0.001}, {2850,0.002}, {2900,0.002}, {2950,0.002}, {3000,0.002}, {3050,0.002}, {3100,0.002}, {3150,0.002}, {3200,0.002}, {3250,0.002}, {3300,0.002}, {3350,0.002}, {3400,0.002}, {3450,0.002}, {3500,0.002}, {3550,0.002}, {3600,0.002}, {3650,0.002}, {3700,0.002}, {3750,0.018}, {3800,0.002}, {3850,0.002}, {3900,0.002}, {3950,0.002}, {4000,0.002}, {4050,0.002}, {4100,0.002}, {4150,0.002}, {4200,0.002}, {4250,0.002}, {4300,0.002}, {4350,0.003}, {4400,0.003}, {4450,0.003}, {4500,0.003}, {4550,0.003}, {4600,0.003}, {4650,0.002}, {4700,0.002}, {4750,0.002}, {4800,0.002}, {4850,0.003}, {4900,0.003}, {4950,0.003}, {5000,0.003}, {5050,0.003}, {5100,0.003}, {5150,0.003}, {5200,0.003}, {5250,0.003}, {5300,0.003}, {5350,0.003}, {5400,0.003}, {5450,0.003}, {5500,0.003}, {5550,0.003}, {5600,0.003}, {5650,0.003}, {5700,0.003}, {5750,0.003}, {5800,0.003}, {5850,0.003}, {5900,0.003}, {5950,0.004}, {6000,0.004}};
data["big"]["Ltac2"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00003922}, {8,0.00003922}, {9,0.00003922}, {10,0.00000000}, {11,0.00003922}, {12,0.00003922}, {13,0.00007843}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00003922}, {18,0.00000000}, {19,0.00006863}, {20,0.00007843}, {21,0.00000000}, {22,0.00006863}, {23,0.00000000}, {24,0.00000000}, {25,0.00003922}, {26,0.00003922}, {27,0.00000000}, {28,0.00003922}, {29,0.00000000}, {30,0.00003922}, {31,0.00007843}, {32,0.00000000}, {33,0.00003922}, {34,0.00000000}, {35,0.00003922}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00006863}, {40,0.00007843}, {41,0.00000000}, {42,0.00000000}, {43,0.00007843}, {44,0.00007843}, {45,0.00003922}, {46,0.00000000}, {47,0.00000000}, {48,0.00006863}, {49,0.00003922}, {50,0.00007843}, {51,0.00003922}, {52,0.00000000}, {53,0.00003922}, {54,0.00014706}, {55,0.00003922}, {56,0.00007843}, {57,0.00000000}, {58,0.00011765}, {59,0.00011765}, {60,0.00003922}, {61,0.00011765}, {62,0.00000000}, {63,0.00007843}, {64,0.00007843}, {65,0.00003922}, {66,0.00007843}, {67,0.00003922}, {68,0.00007843}, {69,0.00002941}, {70,0.00010784}, {71,0.00007843}, {72,0.00007843}, {73,0.00000000}, {74,0.00006863}, {75,0.00002941}, {76,0.00003922}, {77,0.00000000}, {78,0.00000000}, {79,0.00015686}, {80,0.00015686}, {81,0.00007843}, {82,0.00003922}, {83,0.00007843}, {84,0.00007843}, {85,0.00012745}, {86,0.00007843}, {87,0.00010784}, {88,0.00011765}, {89,0.00018627}, {90,0.00011765}, {91,0.00006863}, {92,0.00014706}, {93,0.00015686}, {94,0.00003922}, {95,0.00011765}, {96,0.00011765}, {97,0.00014706}, {98,0.00003922}, {99,0.00013725}, {100,0.00003922}, {101,0.00000000}, {102,0.00027451}, {103,0.00021569}, {104,0.00000000}, {105,0.00006863}, {106,0.00007843}, {107,0.00015686}, {108,0.00006863}, {109,0.00014706}, {110,0.00014706}, {111,0.00003922}, {112,0.00015686}, {113,0.00003922}, {114,0.00000000}, {115,0.00006863}, {116,0.00006863}, {117,0.00006863}, {118,0.00002941}, {119,0.00007843}, {120,0.00005882}, {121,0.00005882}, {122,0.00007843}, {123,0.00019608}, {124,0.00007843}, {125,0.00011765}, {126,0.00011765}, {127,0.00003922}, {128,0.00010784}, {129,0.00010784}, {130,0.00003922}, {131,0.00014706}, {132,0.00003922}, {133,0.00007843}, {134,0.00011765}, {135,0.00010784}, {136,0.00011765}, {137,0.00003922}, {138,0.00003922}, {139,0.00006863}, {140,0.00021569}, {141,0.00010784}, {142,0.00002941}, {143,0.00011765}, {144,0.00027451}, {145,0.00006863}, {146,0.00011765}, {147,0.00018627}, {148,0.00011765}, {149,0.00006863}, {150,0.00007843}, {151,0.00010784}, {152,0.00006863}, {153,0.00015686}, {154,0.00011765}, {155,0.00006863}, {156,0.00003922}, {157,0.00014706}, {158,0.00018627}, {159,0.00007843}, {160,0.00011765}, {161,0.00007843}, {162,0.00019608}, {163,0.00011765}, {164,0.00011765}, {165,0.00011765}, {166,0.00023529}, {167,0.00018627}, {168,0.00010784}, {169,0.00010784}, {170,0.00007843}, {171,0.00011765}, {172,0.00012745}, {173,0.00009804}, {174,0.00022549}, {175,0.00014706}, {176,0.00010784}, {177,0.00007843}, {178,0.00007843}, {179,0.00009804}, {180,0.00000000}, {181,0.00010784}, {182,0.00011765}, {183,0.00031373}, {184,0.00009804}, {185,0.00003922}, {186,0.00011765}, {187,0.00027451}, {188,0.00022549}, {189,0.00014706}, {190,0.00003922}, {191,0.00011765}, {192,0.00016667}, {193,0.00006863}, {194,0.00017647}, {195,0.00010784}, {196,0.00003922}, {197,0.00007843}, {198,0.00023529}, {199,0.00003922}, {200,0.00032353}, {201,0.00018627}, {202,0.00003922}, {203,0.00011765}, {204,0.00018627}, {205,0.00006863}, {206,0.00019608}, {207,0.00015686}, {208,0.00015686}, {209,0.00029412}, {210,0.00022549}, {211,0.00018627}, {212,0.00023529}, {213,0.00018627}, {214,0.00003922}, {215,0.00011765}, {216,0.00007843}, {217,0.00015686}, {218,0.00003922}, {219,0.00011765}, {220,0.00011765}, {221,0.00027451}, {222,0.00023529}, {223,0.00022549}, {224,0.00026471}, {225,0.00018627}, {226,0.00010784}, {227,0.00019608}, {228,0.00030392}, {229,0.00003922}, {230,0.00014706}, {231,0.00020588}, {232,0.00025490}, {233,0.00027451}, {234,0.00011765}, {235,0.00026471}, {236,0.00007843}, {237,0.00021569}, {238,0.00023529}, {239,0.00019608}, {240,0.00014706}, {241,0.00014706}, {242,0.00019608}, {243,0.00019608}, {244,0.00007843}, {245,0.00011765}, {246,0.00019608}, {247,0.00010784}, {248,0.00007843}, {249,0.00010784}, {250,0.00019608}, {251,0.00009804}, {252,0.00027451}, {253,0.00014706}, {254,0.00019608}, {255,0.00014706}, {256,0.00034314}, {257,0.00015686}, {258,0.00021569}, {259,0.00018627}, {260,0.00029412}, {261,0.00019608}, {262,0.00019608}, {263,0.00007843}, {264,0.00025490}, {265,0.00025490}, {266,0.00027451}, {267,0.00018627}, {268,0.00038235}, {269,0.00022549}, {270,0.00017647}, {271,0.00006863}, {272,0.00022549}, {273,0.00014706}, {274,0.00041176}, {275,0.00037255}, {276,0.00010784}, {277,0.00006863}, {278,0.00026471}, {279,0.00022549}, {280,0.00014706}, {281,0.00010784}, {282,0.00031373}, {283,0.00031373}, {284,0.00022549}, {285,0.00019608}, {286,0.00011765}, {287,0.00018627}, {288,0.00010784}, {289,0.00030392}, {290,0.00043137}, {291,0.00022549}, {292,0.00011765}, {293,0.00021569}, {294,0.00023529}, {295,0.00020588}, {296,0.00022549}, {297,0.00028431}, {298,0.00025490}, {299,0.00025490}, {300,0.00015686}, {301,0.00000}, {302,0.00000}, {303,0.00000}, {304,0.00100}, {305,0.00000}, {306,0.00100}, {307,0.00200}, {308,0.00000}, {309,0.00100}, {310,0.00000}, {311,0.00000}, {312,0.00000}, {313,0.00100}, {314,0.00000}, {315,0.00000}, {316,0.00000}, {317,0.00100}, {318,0.00100}, {319,0.00000}, {320,0.00100}, {321,0.00100}, {322,0.00075}, {323,0.00000}, {324,0.00000}, {325,0.00000}, {326,0.00100}, {327,0.00100}, {328,0.00000}, {329,0.00200}, {330,0.00000}, {331,0.00000}, {332,0.00000}, {333,0.00100}, {334,0.00000}, {335,0.00000}, {336,0.00000}, {337,0.00000}, {338,0.00000}, {339,0.00100}, {340,0.00000}, {341,0.00000}, {342,0.00000}, {343,0.00075}, {344,0.00100}, {345,0.00000}, {346,0.00200}, {347,0.00000}, {348,0.00000}, {349,0.00100}, {350,0.00000}, {351,0.00000}, {352,0.00000}, {353,0.00000}, {354,0.00000}, {355,0.00000}, {356,0.00000}, {357,0.00000}, {358,0.00275}, {359,0.00000}, {360,0.00000}, {361,0.00000}, {362,0.00000}, {363,0.00000}, {364,0.00100}, {365,0.00000}, {366,0.00000}, {367,0.00000}, {368,0.00000}, {369,0.00000}, {370,0.00000}, {371,0.00000}, {372,0.00000}, {373,0.00100}, {374,0.00075}, {375,0.00000}, {376,0.00075}, {377,0.00100}, {378,0.00000}, {379,0.00000}, {380,0.00000}, {381,0.00000}, {382,0.00000}, {383,0.00000}, {384,0.00000}, {385,0.00000}, {386,0.00000}, {387,0.00000}, {388,0.00000}, {389,0.00100}, {390,0.00000}, {391,0.00100}, {392,0.00000}, {393,0.00000}, {394,0.00000}, {395,0.00000}, {396,0.00000}, {397,0.00000}, {398,0.00000}, {399,0.00000}, {400,0.00000}, {401,0.00000}, {402,0.00000}, {403,0.00000}, {404,0.00000}, {405,0.00100}, {406,0.00000}, {407,0.00000}, {408,0.00000}, {409,0.00000}, {410,0.00000}, {411,0.00000}, {412,0.00000}, {413,0.00000}, {414,0.00000}, {415,0.00000}, {416,0.00000}, {417,0.00000}, {418,0.00150}, {419,0.00100}, {420,0.00000}, {421,0.00000}, {422,0.00000}, {423,0.00000}, {424,0.00000}, {425,0.00000}, {426,0.00100}, {427,0.00000}, {428,0.00000}, {429,0.00000}, {430,0.00000}, {431,0.00100}, {432,0.00000}, {433,0.00000}, {434,0.00075}, {435,0.00000}, {436,0.00075}, {437,0.00000}, {438,0.00000}, {439,0.00000}, {440,0.00000}, {441,0.00000}, {442,0.00000}, {443,0.00000}, {444,0.00100}, {445,0.00000}, {446,0.00000}, {447,0.00000}, {448,0.00000}, {449,0.00075}, {450,0.00000}, {451,0.00150}, {452,0.00000}, {453,0.00100}, {454,0.00000}, {455,0.00000}, {456,0.00200}, {457,0.00075}, {458,0.00075}, {459,0.00000}, {460,0.00000}, {461,0.00000}, {462,0.00000}, {463,0.00000}, {464,0.00100}, {465,0.00100}, {466,0.00000}, {467,0.00075}, {468,0.00075}, {469,0.00075}, {470,0.00000}, {471,0.00000}, {472,0.00150}, {473,0.00000}, {474,0.00000}, {475,0.00250}, {476,0.00000}, {477,0.00000}, {478,0.00000}, {479,0.00075}, {480,0.00075}, {481,0.00000}, {482,0.00000}, {483,0.00000}, {484,0.00000}, {485,0.00000}, {486,0.00000}, {487,0.00075}, {488,0.00000}, {489,0.00000}, {490,0.00000}, {491,0.00100}, {492,0.00000}, {493,0.00000}, {494,0.00100}, {495,0.00000}, {496,0.00100}, {497,0.00175}, {498,0.00000}, {499,0.00000}, {500,0.00075}, {505,0.00000}, {510,0.00000}, {515,0.00000}, {520,0.00000}, {525,0.00075}, {530,0.00000}, {535,0.00075}, {540,0.00000}, {545,0.00075}, {550,0.00000}, {555,0.00100}, {560,0.00000}, {565,0.00000}, {570,0.00000}, {575,0.00100}, {580,0.00075}, {585,0.00000}, {590,0.00000}, {595,0.00000}, {600,0.00100}, {605,0.00000}, {610,0.00075}, {615,0.00000}, {620,0.00100}, {625,0.00000}, {630,0.00000}, {635,0.00000}, {640,0.00000}, {645,0.00000}, {650,0.00000}, {655,0.00100}, {660,0.00000}, {665,0.00000}, {670,0.00000}, {675,0.00100}, {680,0.00000}, {685,0.00075}, {690,0.00000}, {695,0.00000}, {700,0.00000}, {705,0.00000}, {710,0.00075}, {715,0.00000}, {720,0.00075}, {725,0.00075}, {730,0.00075}, {735,0.00000}, {740,0.00250}, {745,0.00000}, {750,0.00000}, {755,0.00000}, {760,0.00075}, {765,0.00175}, {770,0.00075}, {775,0.00000}, {780,0.00100}, {785,0.00100}, {790,0.00100}, {795,0.00275}, {800,0.00000}, {805,0.00325}, {810,0.00000}, {815,0.00000}, {820,0.00000}, {825,0.00000}, {830,0.00000}, {835,0.00100}, {840,0.00000}, {845,0.00250}, {850,0.00150}, {855,0.00000}, {860,0.00000}, {865,0.00075}, {870,0.00000}, {875,0.00000}, {880,0.00200}, {885,0.00000}, {890,0.00075}, {895,0.00000}, {900,0.00000}, {905,0.00000}, {910,0.00000}, {915,0.00075}, {920,0.00075}, {925,0.00000}, {930,0.00075}, {935,0.00075}, {940,0.00075}, {945,0.00000}, {950,0.00075}, {955,0.00075}, {960,0.00000}, {965,0.00075}, {970,0.00000}, {975,0.00075}, {980,0.00000}, {985,0.00100}, {990,0.00000}, {995,0.00075}, {1000,0.00075}, {1010,0.00000}, {1020,0.00075}, {1030,0.00000}, {1040,0.00150}, {1050,0.00075}, {1060,0.00000}, {1070,0.00075}, {1080,0.00200}, {1090,0.00000}, {1100,0.00075}, {1110,0.00075}, {1120,0.00075}, {1130,0.00000}, {1140,0.00075}, {1150,0.00075}, {1160,0.00000}, {1170,0.00075}, {1180,0.00075}, {1190,0.00075}, {1200,0.00150}, {1210,0.00000}, {1220,0.00075}, {1230,0.00000}, {1240,0.00000}, {1250,0.00075}, {1260,0.00175}, {1270,0.00000}, {1280,0.00075}, {1290,0.00175}, {1300,0.00250}, {1310,0.00000}, {1320,0.00075}, {1330,0.00075}, {1340,0.00000}, {1350,0.00075}, {1360,0.00100}, {1370,0.00075}, {1380,0.00075}, {1390,0.00250}, {1400,0.00250}, {1410,0.00550}, {1420,0.00150}, {1430,0.00000}, {1440,0.00000}, {1450,0.00075}, {1460,0}, {1470,0}, {1480,0}, {1490,0.003}, {1500,0}, {1510,0}, {1520,0}, {1530,0}, {1540,0}, {1550,0}, {1560,0.003}, {1570,0}, {1580,0.003}, {1590,0}, {1600,0}, {1610,0}, {1620,0}, {1630,0.003}, {1640,0.003}, {1650,0}, {1660,0.003}, {1670,0.003}, {1680,0}, {1690,0}, {1700,0.004}, {1710,0.003}, {1720,0}, {1730,0}, {1740,0}, {1750,0.003}, {1760,0}, {1770,0}, {1780,0.004}, {1790,0.004}, {1800,0.003}, {1810,0}, {1820,0}, {1830,0}, {1840,0}, {1850,0}, {1860,0}, {1870,0}, {1880,0}, {1890,0}, {1900,0}, {1910,0}, {1920,0.003}, {1930,0}, {1940,0}, {1950,0}, {1960,0}, {1970,0}, {1980,0}, {1990,0.003}, {2000,0}, {2050,0}, {2100,0.003}, {2150,0}, {2200,0}, {2250,0}, {2300,0}, {2350,0}, {2400,0.003}, {2450,0}, {2500,0.004}, {2550,0.003}, {2600,0.004}, {2650,0}, {2700,0.003}, {2750,0}, {2800,0.003}, {2850,0}, {2900,0.003}, {2950,0}, {3000,0}, {3050,0.004}, {3100,0}, {3150,0.004}, {3200,0.003}, {3250,0.003}, {3300,0.003}, {3350,0}, {3400,0}, {3450,0}, {3500,0.004}, {3550,0}, {3600,0.004}, {3650,0}, {3700,0.004}, {3750,0.015}, {3800,0.003}, {3850,0}, {3900,0.003}, {3950,0.004}, {4000,0}, {4050,0.004}, {4100,0.003}, {4150,0.004}, {4200,0}, {4250,0.004}, {4300,0.004}, {4350,0.004}, {4400,0}, {4450,0.004}, {4500,0.004}, {4550,0.004}, {4600,0.003}, {4650,0}, {4700,0}, {4750,0}, {4800,0.004}, {4850,0.004}, {4900,0.003}, {4950,0.004}, {5000,0.003}, {5050,0}, {5100,0.004}, {5150,0.004}, {5200,0}, {5250,0.004}, {5300,0.004}, {5350,0.004}, {5400,0.004}, {5450,0.004}, {5500,0.004}, {5550,0.004}, {5600,0.004}, {5650,0.004}, {5700,0.004}, {5750,0.003}, {5800,0.004}, {5850,0.004}, {5900,0.004}, {5950,0.004}, {6000,0.004}};
data["big"]["Ltac2"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00003922}, {44,0.00000000}, {45,0.00003922}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00003922}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00003922}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00003922}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00003922}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00003922}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00003922}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00003922}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000}, {302,0.00000}, {303,0.00000}, {304,0.00000}, {305,0.00000}, {306,0.00000}, {307,0.00000}, {308,0.00000}, {309,0.00000}, {310,0.00000}, {311,0.00000}, {312,0.00000}, {313,0.00000}, {314,0.00000}, {315,0.00000}, {316,0.00000}, {317,0.00000}, {318,0.00000}, {319,0.00000}, {320,0.00000}, {321,0.00000}, {322,0.00000}, {323,0.00000}, {324,0.00000}, {325,0.00000}, {326,0.00000}, {327,0.00000}, {328,0.00000}, {329,0.00000}, {330,0.00000}, {331,0.00000}, {332,0.00000}, {333,0.00000}, {334,0.00000}, {335,0.00000}, {336,0.00000}, {337,0.00000}, {338,0.00000}, {339,0.00000}, {340,0.00000}, {341,0.00000}, {342,0.00000}, {343,0.00000}, {344,0.00000}, {345,0.00000}, {346,0.00000}, {347,0.00000}, {348,0.00000}, {349,0.00000}, {350,0.00000}, {351,0.00000}, {352,0.00000}, {353,0.00000}, {354,0.00000}, {355,0.00000}, {356,0.00000}, {357,0.00000}, {358,0.00000}, {359,0.00000}, {360,0.00000}, {361,0.00000}, {362,0.00000}, {363,0.00000}, {364,0.00000}, {365,0.00000}, {366,0.00000}, {367,0.00000}, {368,0.00000}, {369,0.00000}, {370,0.00000}, {371,0.00000}, {372,0.00000}, {373,0.00000}, {374,0.00000}, {375,0.00000}, {376,0.00000}, {377,0.00000}, {378,0.00000}, {379,0.00000}, {380,0.00000}, {381,0.00000}, {382,0.00000}, {383,0.00000}, {384,0.00000}, {385,0.00000}, {386,0.00000}, {387,0.00000}, {388,0.00000}, {389,0.00000}, {390,0.00000}, {391,0.00000}, {392,0.00000}, {393,0.00000}, {394,0.00000}, {395,0.00000}, {396,0.00000}, {397,0.00000}, {398,0.00000}, {399,0.00000}, {400,0.00000}, {401,0.00000}, {402,0.00000}, {403,0.00000}, {404,0.00000}, {405,0.00000}, {406,0.00000}, {407,0.00000}, {408,0.00000}, {409,0.00000}, {410,0.00000}, {411,0.00000}, {412,0.00000}, {413,0.00000}, {414,0.00000}, {415,0.00000}, {416,0.00000}, {417,0.00000}, {418,0.00000}, {419,0.00000}, {420,0.00000}, {421,0.00000}, {422,0.00000}, {423,0.00000}, {424,0.00000}, {425,0.00000}, {426,0.00000}, {427,0.00000}, {428,0.00000}, {429,0.00000}, {430,0.00000}, {431,0.00000}, {432,0.00000}, {433,0.00000}, {434,0.00000}, {435,0.00000}, {436,0.00000}, {437,0.00000}, {438,0.00000}, {439,0.00000}, {440,0.00000}, {441,0.00000}, {442,0.00000}, {443,0.00000}, {444,0.00000}, {445,0.00000}, {446,0.00000}, {447,0.00000}, {448,0.00000}, {449,0.00000}, {450,0.00000}, {451,0.00000}, {452,0.00000}, {453,0.00000}, {454,0.00000}, {455,0.00000}, {456,0.00000}, {457,0.00000}, {458,0.00000}, {459,0.00000}, {460,0.00000}, {461,0.00000}, {462,0.00000}, {463,0.00000}, {464,0.00000}, {465,0.00000}, {466,0.00000}, {467,0.00000}, {468,0.00000}, {469,0.00000}, {470,0.00000}, {471,0.00000}, {472,0.00000}, {473,0.00000}, {474,0.00000}, {475,0.00000}, {476,0.00000}, {477,0.00000}, {478,0.00000}, {479,0.00000}, {480,0.00000}, {481,0.00000}, {482,0.00000}, {483,0.00000}, {484,0.00000}, {485,0.00000}, {486,0.00000}, {487,0.00000}, {488,0.00000}, {489,0.00000}, {490,0.00000}, {491,0.00000}, {492,0.00000}, {493,0.00000}, {494,0.00000}, {495,0.00000}, {496,0.00000}, {497,0.00000}, {498,0.00000}, {499,0.00000}, {500,0.00000}, {505,0.00000}, {510,0.00000}, {515,0.00000}, {520,0.00000}, {525,0.00000}, {530,0.00000}, {535,0.00000}, {540,0.00000}, {545,0.00000}, {550,0.00000}, {555,0.00000}, {560,0.00000}, {565,0.00000}, {570,0.00000}, {575,0.00000}, {580,0.00000}, {585,0.00000}, {590,0.00000}, {595,0.00000}, {600,0.00000}, {605,0.00000}, {610,0.00000}, {615,0.00000}, {620,0.00000}, {625,0.00000}, {630,0.00000}, {635,0.00000}, {640,0.00000}, {645,0.00000}, {650,0.00000}, {655,0.00000}, {660,0.00000}, {665,0.00000}, {670,0.00000}, {675,0.00000}, {680,0.00000}, {685,0.00000}, {690,0.00000}, {695,0.00000}, {700,0.00000}, {705,0.00000}, {710,0.00000}, {715,0.00000}, {720,0.00000}, {725,0.00000}, {730,0.00000}, {735,0.00000}, {740,0.00000}, {745,0.00000}, {750,0.00000}, {755,0.00000}, {760,0.00000}, {765,0.00000}, {770,0.00000}, {775,0.00000}, {780,0.00000}, {785,0.00000}, {790,0.00000}, {795,0.00000}, {800,0.00000}, {805,0.00000}, {810,0.00000}, {815,0.00000}, {820,0.00000}, {825,0.00000}, {830,0.00000}, {835,0.00000}, {840,0.00000}, {845,0.00100}, {850,0.00000}, {855,0.00000}, {860,0.00000}, {865,0.00000}, {870,0.00000}, {875,0.00000}, {880,0.00000}, {885,0.00000}, {890,0.00000}, {895,0.00000}, {900,0.00000}, {905,0.00000}, {910,0.00000}, {915,0.00000}, {920,0.00000}, {925,0.00000}, {930,0.00000}, {935,0.00000}, {940,0.00000}, {945,0.00000}, {950,0.00000}, {955,0.00000}, {960,0.00000}, {965,0.00000}, {970,0.00000}, {975,0.00000}, {980,0.00000}, {985,0.00000}, {990,0.00000}, {995,0.00000}, {1000,0.00000}, {1010,0.00000}, {1020,0.00000}, {1030,0.00000}, {1040,0.00000}, {1050,0.00000}, {1060,0.00000}, {1070,0.00000}, {1080,0.00000}, {1090,0.00000}, {1100,0.00000}, {1110,0.00000}, {1120,0.00000}, {1130,0.00000}, {1140,0.00000}, {1150,0.00000}, {1160,0.00000}, {1170,0.00000}, {1180,0.00000}, {1190,0.00000}, {1200,0.00000}, {1210,0.00000}, {1220,0.00000}, {1230,0.00000}, {1240,0.00000}, {1250,0.00000}, {1260,0.00000}, {1270,0.00000}, {1280,0.00000}, {1290,0.00000}, {1300,0.00000}, {1310,0.00000}, {1320,0.00000}, {1330,0.00000}, {1340,0.00000}, {1350,0.00000}, {1360,0.00000}, {1370,0.00000}, {1380,0.00000}, {1390,0.00000}, {1400,0.00000}, {1410,0.00000}, {1420,0.00000}, {1430,0.00000}, {1440,0.00000}, {1450,0.00000}, {1460,0}, {1470,0}, {1480,0}, {1490,0}, {1500,0}, {1510,0}, {1520,0}, {1530,0}, {1540,0}, {1550,0}, {1560,0}, {1570,0}, {1580,0}, {1590,0}, {1600,0}, {1610,0}, {1620,0}, {1630,0}, {1640,0}, {1650,0}, {1660,0}, {1670,0}, {1680,0}, {1690,0}, {1700,0}, {1710,0}, {1720,0}, {1730,0}, {1740,0}, {1750,0}, {1760,0}, {1770,0}, {1780,0}, {1790,0}, {1800,0}, {1810,0}, {1820,0}, {1830,0}, {1840,0}, {1850,0}, {1860,0}, {1870,0}, {1880,0}, {1890,0}, {1900,0}, {1910,0}, {1920,0}, {1930,0}, {1940,0}, {1950,0}, {1960,0}, {1970,0}, {1980,0}, {1990,0}, {2000,0}, {2050,0}, {2100,0}, {2150,0}, {2200,0}, {2250,0}, {2300,0}, {2350,0}, {2400,0}, {2450,0}, {2500,0}, {2550,0}, {2600,0}, {2650,0}, {2700,0}, {2750,0}, {2800,0}, {2850,0}, {2900,0}, {2950,0}, {3000,0}, {3050,0}, {3100,0}, {3150,0}, {3200,0}, {3250,0}, {3300,0}, {3350,0}, {3400,0}, {3450,0}, {3500,0}, {3550,0}, {3600,0}, {3650,0}, {3700,0}, {3750,0}, {3800,0}, {3850,0}, {3900,0}, {3950,0}, {4000,0}, {4050,0}, {4100,0}, {4150,0}, {4200,0}, {4250,0}, {4300,0}, {4350,0}, {4400,0}, {4450,0}, {4500,0}, {4550,0}, {4600,0}, {4650,0}, {4700,0}, {4750,0}, {4800,0}, {4850,0}, {4900,0}, {4950,0}, {5000,0}, {5050,0}, {5100,0}, {5150,0}, {5200,0}, {5250,0}, {5300,0}, {5350,0}, {5400,0}, {5450,0}, {5500,0}, {5550,0}, {5600,0}, {5650,0}, {5700,0}, {5750,0}, {5800,0}, {5850,0}, {5900,0}, {5950,0}, {6000,0}};
data["big"]["Ltac2"]["norm reif"]["real"] = {{1,0.00001961}, {2,0.00100000}, {3,0.00100000}, {4,0.00116667}, {5,0.00200000}, {6,0.00213725}, {7,0.00300000}, {8,0.00325490}, {9,0.00410784}, {10,0.00500000}, {11,0.00513725}, {12,0.00607843}, {13,0.00707843}, {14,0.00807843}, {15,0.00878431}, {16,0.00946078}, {17,0.01653922}, {18,0.01123529}, {19,0.01238235}, {20,0.01359804}, {21,0.01488235}, {22,0.01608824}, {23,0.01716667}, {24,0.02052941}, {25,0.01964706}, {26,0.02116667}, {27,0.02236275}, {28,0.02384314}, {29,0.02751961}, {30,0.02670588}, {31,0.02809804}, {32,0.02998039}, {33,0.03313725}, {34,0.03312745}, {35,0.03490196}, {36,0.03956863}, {37,0.03837255}, {38,0.04013725}, {39,0.04196078}, {40,0.04400000}, {41,0.04884314}, {42,0.04807843}, {43,0.05350000}, {44,0.05209804}, {45,0.05800980}, {46,0.05648039}, {47,0.06236275}, {48,0.06127451}, {49,0.06621569}, {50,0.07041176}, {51,0.06826471}, {52,0.07407843}, {53,0.07735294}, {54,0.07577451}, {55,0.08215686}, {56,0.08571569}, {57,0.08825490}, {58,0.08646078}, {59,0.09085294}, {60,0.09709804}, {61,0.09947059}, {62,0.10256863}, {63,0.10560784}, {64,0.10893137}, {65,0.11174510}, {66,0.11493137}, {67,0.11808824}, {68,0.12184314}, {69,0.12464706}, {70,0.12836275}, {71,0.13306863}, {72,0.13553922}, {73,0.13893137}, {74,0.14237255}, {75,0.14663725}, {76,0.15075490}, {77,0.15281373}, {78,0.15759804}, {79,0.16024510}, {80,0.16492157}, {81,0.16819608}, {82,0.17281373}, {83,0.17644118}, {84,0.18075490}, {85,0.18449020}, {86,0.18862745}, {87,0.19332353}, {88,0.19807843}, {89,0.20180392}, {90,0.20559804}, {91,0.21009804}, {92,0.21514706}, {93,0.21950980}, {94,0.22394118}, {95,0.22800000}, {96,0.23200980}, {97,0.23654902}, {98,0.24152941}, {99,0.24619608}, {100,0.25051961}, {101,0.25551961}, {102,0.26084314}, {103,0.26645098}, {104,0.27050980}, {105,0.27558824}, {106,0.28019608}, {107,0.28446078}, {108,0.29057843}, {109,0.29481373}, {110,0.30015686}, {111,0.30590196}, {112,0.31090196}, {113,0.31604902}, {114,0.32094118}, {115,0.32697059}, {116,0.33197059}, {117,0.33793137}, {118,0.34297059}, {119,0.34832353}, {120,0.35356863}, {121,0.35973529}, {122,0.36890196}, {123,0.37218627}, {124,0.37772549}, {125,0.38295098}, {126,0.38843137}, {127,0.39459804}, {128,0.40081373}, {129,0.40705882}, {130,0.41528431}, {131,0.42097059}, {132,0.42729412}, {133,0.43395098}, {134,0.43912745}, {135,0.44650000}, {136,0.45425490}, {137,0.46024510}, {138,0.46777451}, {139,0.47381373}, {140,0.48021569}, {141,0.48657843}, {142,0.49125490}, {143,0.50172549}, {144,0.50945098}, {145,0.51627451}, {146,0.52521569}, {147,0.52786275}, {148,0.53505882}, {149,0.54233333}, {150,0.55347059}, {151,0.56556863}, {152,0.57370588}, {153,0.58103922}, {154,0.58454902}, {155,0.58699020}, {156,0.59419608}, {157,0.60228431}, {158,0.61020588}, {159,0.61861765}, {160,0.62507843}, {161,0.63318627}, {162,0.64037255}, {163,0.66019608}, {164,0.65777451}, {165,0.66652941}, {166,0.67303922}, {167,0.68258824}, {168,0.69025490}, {169,0.69561765}, {170,0.71065686}, {171,0.71253922}, {172,0.72089216}, {173,0.73102941}, {174,0.74175490}, {175,0.74601961}, {176,0.75905882}, {177,0.76182353}, {178,0.77037255}, {179,0.77911765}, {180,0.78888235}, {181,0.79798039}, {182,0.80518627}, {183,0.81309804}, {184,0.82450980}, {185,0.83319608}, {186,0.84134314}, {187,0.84988235}, {188,0.85859804}, {189,0.86865686}, {190,0.87158824}, {191,0.88529412}, {192,0.89710784}, {193,0.90629412}, {194,0.91224510}, {195,0.92101961}, {196,0.92945098}, {197,0.93813725}, {198,0.94915686}, {199,0.96069608}, {200,0.96930392}, {201,0.97802941}, {202,0.98764706}, {203,0.99589216}, {204,1.00179412}, {205,1.01940196}, {206,1.02872549}, {207,1.03803922}, {208,1.04834314}, {209,1.04970588}, {210,1.06676471}, {211,1.08837255}, {212,1.08877451}, {213,1.09826471}, {214,1.10927451}, {215,1.11860784}, {216,1.12782353}, {217,1.13044118}, {218,1.14838235}, {219,1.15874510}, {220,1.16846078}, {221,1.17883333}, {222,1.19002941}, {223,1.20199020}, {224,1.21070588}, {225,1.22535294}, {226,1.23491176}, {227,1.24731373}, {228,1.25794118}, {229,1.26733333}, {230,1.27878431}, {231,1.29078431}, {232,1.29753922}, {233,1.31295098}, {234,1.32311765}, {235,1.33442157}, {236,1.34401961}, {237,1.37477451}, {238,1.38663725}, {239,1.38250980}, {240,1.39261765}, {241,1.40485294}, {242,1.42842157}, {243,1.43459804}, {244,1.44637255}, {245,1.45352941}, {246,1.46357843}, {247,1.48102941}, {248,1.49134314}, {249,1.50532353}, {250,1.51743137}, {251,1.52992157}, {252,1.54266667}, {253,1.54495098}, {254,1.56747059}, {255,1.57741176}, {256,1.59198039}, {257,1.61838235}, {258,1.60847059}, {259,1.62104902}, {260,1.63550980}, {261,1.64657843}, {262,1.66169608}, {263,1.67350980}, {264,1.69049020}, {265,1.70401961}, {266,1.70088235}, {267,1.71740196}, {268,1.73268627}, {269,1.74648039}, {270,1.76227451}, {271,1.77221569}, {272,1.78591176}, {273,1.79782353}, {274,1.80970588}, {275,1.82465686}, {276,1.83829412}, {277,1.85015686}, {278,1.86390196}, {279,1.87403922}, {280,1.89055882}, {281,1.90288235}, {282,1.91877451}, {283,1.93508824}, {284,1.94991176}, {285,1.96043137}, {286,2.00496078}, {287,2.00230392}, {288,2.01054902}, {289,2.02984314}, {290,2.05112745}, {291,2.06112745}, {292,2.07071569}, {293,2.08723529}, {294,2.09713725}, {295,2.11077451}, {296,2.12898039}, {297,2.14492157}, {298,2.15647059}, {299,2.17095098}, {300,2.19082353}, {301,2.24400}, {302,2.58225}, {303,2.23300}, {304,2.25300}, {305,2.29850}, {306,2.27950}, {307,2.29275}, {308,2.32325}, {309,2.33775}, {310,2.34275}, {311,2.35925}, {312,2.55250}, {313,2.71100}, {314,2.37050}, {315,2.38975}, {316,2.38925}, {317,2.42900}, {318,2.42275}, {319,2.43000}, {320,2.43225}, {321,2.45700}, {322,2.52000}, {323,2.50825}, {324,2.51700}, {325,2.53950}, {326,2.57475}, {327,2.61850}, {328,2.60150}, {329,2.62325}, {330,2.62975}, {331,2.66725}, {332,2.69775}, {333,2.69625}, {334,2.70625}, {335,2.73975}, {336,2.74825}, {337,2.83775}, {338,2.77900}, {339,2.81100}, {340,2.80800}, {341,2.83000}, {342,2.87375}, {343,2.87375}, {344,2.86350}, {345,2.86800}, {346,2.91575}, {347,2.97025}, {348,2.97775}, {349,2.97350}, {350,2.98975}, {351,3.04525}, {352,3.01900}, {353,3.04025}, {354,3.05425}, {355,3.07775}, {356,3.11600}, {357,3.12625}, {358,3.13750}, {359,3.14700}, {360,3.20250}, {361,3.20825}, {362,3.19500}, {363,3.19600}, {364,3.23375}, {365,3.23125}, {366,3.26175}, {367,3.29800}, {368,3.34300}, {369,3.35225}, {370,3.34275}, {371,3.36925}, {372,3.42400}, {373,3.40425}, {374,3.37750}, {375,3.39925}, {376,3.45525}, {377,3.46425}, {378,3.47875}, {379,3.48850}, {380,3.52975}, {381,3.50475}, {382,3.57950}, {383,3.60000}, {384,3.63600}, {385,3.65925}, {386,3.66500}, {387,3.66925}, {388,3.71750}, {389,3.70075}, {390,3.69800}, {391,3.70125}, {392,3.74375}, {393,3.74075}, {394,3.75800}, {395,3.83325}, {396,3.84700}, {397,3.84350}, {398,3.87825}, {399,3.91050}, {400,3.90250}, {401,3.88725}, {402,3.96675}, {403,3.99925}, {404,4.00225}, {405,4.01900}, {406,4.07525}, {407,4.06075}, {408,4.07300}, {409,4.13250}, {410,4.15325}, {411,4.17125}, {412,4.20375}, {413,4.22025}, {414,4.17800}, {415,4.19075}, {416,4.26400}, {417,4.23850}, {418,4.24225}, {419,4.33775}, {420,4.32400}, {421,4.32425}, {422,4.41450}, {423,4.40825}, {424,4.40225}, {425,4.52675}, {426,4.51850}, {427,4.51100}, {428,4.55150}, {429,4.53900}, {430,4.54350}, {431,4.56350}, {432,4.60250}, {433,4.63950}, {434,4.66500}, {435,4.72125}, {436,4.69100}, {437,4.72650}, {438,4.78875}, {439,4.73075}, {440,4.77975}, {441,4.83125}, {442,4.81475}, {443,4.80525}, {444,4.82300}, {445,4.81900}, {446,4.85650}, {447,4.94500}, {448,4.95375}, {449,5.02525}, {450,4.99325}, {451,4.99900}, {452,5.03400}, {453,5.09500}, {454,5.09025}, {455,5.18400}, {456,5.12675}, {457,5.12275}, {458,5.14500}, {459,5.12400}, {460,5.19250}, {461,5.24100}, {462,5.22325}, {463,5.29725}, {464,5.26875}, {465,5.32775}, {466,5.37075}, {467,5.39025}, {468,5.40825}, {469,5.37825}, {470,5.42725}, {471,5.51125}, {472,5.46450}, {473,5.51600}, {474,5.50850}, {475,5.56425}, {476,5.61475}, {477,5.60900}, {478,5.62200}, {479,5.68475}, {480,5.71425}, {481,5.75275}, {482,5.73850}, {483,5.81250}, {484,5.83575}, {485,5.87800}, {486,5.95475}, {487,5.81875}, {488,5.89400}, {489,5.96350}, {490,6.06275}, {491,6.03400}, {492,5.97775}, {493,6.03975}, {494,5.99200}, {495,6.10650}, {496,6.11000}, {497,6.14825}, {498,6.13275}, {499,6.15450}, {500,6.22925}, {505,6.36500}, {510,6.61000}, {515,6.58550}, {520,6.74075}, {525,6.92825}, {530,7.05875}, {535,7.15725}, {540,7.29675}, {545,7.38000}, {550,7.66400}, {555,7.76850}, {560,7.90450}, {565,8.04275}, {570,8.21850}, {575,8.37675}, {580,8.47375}, {585,8.60175}, {590,8.85450}, {595,8.95625}, {600,8.98375}, {605,9.15500}, {610,9.40900}, {615,9.58325}, {620,9.62375}, {625,9.89125}, {630,10.16425}, {635,10.24525}, {640,10.38325}, {645,10.66050}, {650,10.73925}, {655,10.72450}, {660,11.06300}, {665,11.22800}, {670,11.24350}, {675,11.64400}, {680,11.77800}, {685,11.95025}, {690,12.23100}, {695,12.37600}, {700,12.56175}, {705,12.85050}, {710,12.90750}, {715,13.14150}, {720,13.30400}, {725,13.34100}, {730,13.63525}, {735,13.69200}, {740,13.89350}, {745,14.13950}, {750,14.40500}, {755,14.59875}, {760,15.11575}, {765,15.04750}, {770,15.30225}, {775,15.28350}, {780,15.49875}, {785,16.13675}, {790,15.75150}, {795,16.37750}, {800,16.27400}, {805,16.69900}, {810,16.84350}, {815,17.19750}, {820,17.01525}, {825,17.19675}, {830,17.67675}, {835,17.63475}, {840,18.11950}, {845,18.29600}, {850,18.56225}, {855,18.61775}, {860,18.84450}, {865,18.91550}, {870,19.12900}, {875,19.47750}, {880,19.76825}, {885,20.05250}, {890,20.21150}, {895,20.51200}, {900,20.60750}, {905,21.03925}, {910,21.11650}, {915,21.62300}, {920,21.54550}, {925,22.01575}, {930,22.21675}, {935,22.67725}, {940,22.75425}, {945,22.81075}, {950,23.34100}, {955,23.45700}, {960,23.65450}, {965,24.64475}, {970,24.25150}, {975,24.62100}, {980,24.78200}, {985,25.01150}, {990,25.51575}, {995,25.90075}, {1000,26.36500}, {1010,26.68350}, {1020,27.01625}, {1030,27.44725}, {1040,28.01175}, {1050,28.22375}, {1060,29.44300}, {1070,30.35950}, {1080,30.23250}, {1090,30.92150}, {1100,31.21050}, {1110,32.78475}, {1120,33.40525}, {1130,33.70925}, {1140,34.40875}, {1150,34.74200}, {1160,35.61550}, {1170,36.76025}, {1180,37.14350}, {1190,37.40150}, {1200,38.47025}, {1210,39.27775}, {1220,39.41625}, {1230,40.47425}, {1240,42.12525}, {1250,41.29725}, {1260,43.39525}, {1270,43.62925}, {1280,43.58500}, {1290,45.12050}, {1300,46.09575}, {1310,46.14175}, {1320,46.85375}, {1330,47.70025}, {1340,48.18575}, {1350,49.69225}, {1360,49.37475}, {1370,50.78675}, {1380,50.79650}, {1390,52.31900}, {1400,53.71825}, {1410,54.27725}, {1420,54.54350}, {1430,55.75250}, {1440,56.06000}, {1450,57.79900}, {1460,61.084}, {1470,61.78}, {1480,63.259}, {1490,63.802}, {1500,64.72}, {1510,65.528}, {1520,66.497}, {1530,67.901}, {1540,68.13}, {1550,70.236}, {1560,69.893}, {1570,71.712}, {1580,70.789}, {1590,74.388}, {1600,73.051}, {1610,74.319}, {1620,74.058}, {1630,75.099}, {1640,76.452}, {1650,78.089}, {1660,78.898}, {1670,79.583}, {1680,82.878}, {1690,82.255}, {1700,85.225}, {1710,84.111}, {1720,84.87}, {1730,87.875}, {1740,87.836}, {1750,86.957}, {1760,88.313}, {1770,89.801}, {1780,90.184}, {1790,91.192}, {1800,93.595}, {1810,92.555}, {1820,91.604}, {1830,95.055}, {1840,96.968}, {1850,94.831}, {1860,95.61}, {1870,100.473}, {1880,100.823}, {1890,98.908}, {1900,100.154}, {1910,104.521}, {1920,105.681}, {1930,102.204}, {1940,104.065}, {1950,105.002}, {1960,109.113}, {1970,110.848}, {1980,108.272}, {1990,109.019}, {2000,114.852}, {2050,119.768}, {2100,121.524}, {2150,128.165}, {2200,131.506}, {2250,142.058}, {2300,145.576}, {2350,152.842}, {2400,156.91}, {2450,166.938}, {2500,173.059}, {2550,177.323}, {2600,189.124}, {2650,192.333}, {2700,205.148}, {2750,212.128}, {2800,218.331}, {2850,229.295}, {2900,236.641}, {2950,242.778}, {3000,253.291}, {3050,263.057}, {3100,270.629}, {3150,276.823}, {3200,290.663}, {3250,300.096}, {3300,308.023}, {3350,321.331}, {3400,328.808}, {3450,339.252}, {3500,352.905}, {3550,358.967}, {3600,370.851}, {3650,384.625}, {3700,389.861}, {3750,412.841}, {3800,421.961}, {3850,424.2}, {3900,432.395}, {3950,451.892}, {4000,464.112}, {4050,473.495}, {4100,483.741}, {4150,488.905}, {4200,494.972}, {4250,509.725}, {4300,521.409}, {4350,544.753}, {4400,547.145}, {4450,559.371}, {4500,578.081}, {4550,593.653}, {4600,609.186}, {4650,620.194}, {4700,654.099}, {4750,667.884}, {4800,683.748}, {4850,692.804}, {4900,705.414}, {4950,716.647}, {5000,739.013}, {5050,751.129}, {5100,776.086}, {5150,788.109}, {5200,808.234}, {5250,821.698}, {5300,839.09}, {5350,857.654}, {5400,857.257}, {5450,878.633}, {5500,903.895}, {5550,934.616}, {5600,944.311}, {5650,955.072}, {5700,978.831}, {5750,997.405}, {5800,1008.965}, {5850,1028.212}, {5900,1038.982}, {5950,1059.47}, {6000,1087.478}};
data["big"]["Ltac2"]["norm reif"]["user"] = {{1,0.00094118}, {2,0.00147059}, {3,0.00126471}, {4,0.00172549}, {5,0.00242157}, {6,0.00287255}, {7,0.00320588}, {8,0.00378431}, {9,0.00463725}, {10,0.00486275}, {11,0.00571569}, {12,0.00650980}, {13,0.00687255}, {14,0.00793137}, {15,0.00865686}, {16,0.00981373}, {17,0.01612745}, {18,0.01146078}, {19,0.01261765}, {20,0.01325490}, {21,0.01452941}, {22,0.01560784}, {23,0.01682353}, {24,0.02030392}, {25,0.01925490}, {26,0.02116667}, {27,0.02266667}, {28,0.02419608}, {29,0.02757843}, {30,0.02701961}, {31,0.02828431}, {32,0.02965686}, {33,0.03293137}, {34,0.03341176}, {35,0.03473529}, {36,0.03936275}, {37,0.03814706}, {38,0.03995098}, {39,0.04173529}, {40,0.04379412}, {41,0.04950000}, {42,0.04850980}, {43,0.05358824}, {44,0.05208824}, {45,0.05796078}, {46,0.05624510}, {47,0.06214706}, {48,0.06103922}, {49,0.06578431}, {50,0.07070588}, {51,0.06805882}, {52,0.07466667}, {53,0.07749020}, {54,0.07599020}, {55,0.08193137}, {56,0.08525490}, {57,0.08775490}, {58,0.08612745}, {59,0.09017647}, {60,0.09710784}, {61,0.09963725}, {62,0.10280392}, {63,0.10550980}, {64,0.10830392}, {65,0.11108824}, {66,0.11430392}, {67,0.11811765}, {68,0.12216667}, {69,0.12503922}, {70,0.12848039}, {71,0.13260784}, {72,0.13519608}, {73,0.13851961}, {74,0.14266667}, {75,0.14672549}, {76,0.15041176}, {77,0.15239216}, {78,0.15726471}, {79,0.15971569}, {80,0.16462745}, {81,0.16789216}, {82,0.17269608}, {83,0.17654902}, {84,0.18018627}, {85,0.18398039}, {86,0.18802941}, {87,0.19311765}, {88,0.19770588}, {89,0.20166667}, {90,0.20517647}, {91,0.20946078}, {92,0.21505882}, {93,0.21934314}, {94,0.22365686}, {95,0.22731373}, {96,0.23119608}, {97,0.23631373}, {98,0.24162745}, {99,0.24580392}, {100,0.25036275}, {101,0.25500980}, {102,0.26002941}, {103,0.26599020}, {104,0.27000980}, {105,0.27493137}, {106,0.27921569}, {107,0.28369608}, {108,0.29002941}, {109,0.29429412}, {110,0.29937255}, {111,0.30497059}, {112,0.31010784}, {113,0.31550000}, {114,0.32050980}, {115,0.32620588}, {116,0.33136275}, {117,0.33717647}, {118,0.34233333}, {119,0.34752941}, {120,0.35245098}, {121,0.35907843}, {122,0.36834314}, {123,0.37105882}, {124,0.37669608}, {125,0.38205882}, {126,0.38746078}, {127,0.39390196}, {128,0.40021569}, {129,0.40591176}, {130,0.41463725}, {131,0.41989216}, {132,0.42628431}, {133,0.43309804}, {134,0.43816667}, {135,0.44516667}, {136,0.45306863}, {137,0.45939216}, {138,0.46659804}, {139,0.47258824}, {140,0.47937255}, {141,0.48593137}, {142,0.49037255}, {143,0.50108824}, {144,0.50855882}, {145,0.51539216}, {146,0.52449020}, {147,0.52705882}, {148,0.53399020}, {149,0.54111765}, {150,0.55265686}, {151,0.56450980}, {152,0.57287255}, {153,0.58000000}, {154,0.58350000}, {155,0.58594118}, {156,0.59300980}, {157,0.60148039}, {158,0.60894118}, {159,0.61735294}, {160,0.62405882}, {161,0.63214706}, {162,0.63907843}, {163,0.65892157}, {164,0.65680392}, {165,0.66546078}, {166,0.67219608}, {167,0.68144118}, {168,0.68946078}, {169,0.69467647}, {170,0.70284314}, {171,0.71121569}, {172,0.71981373}, {173,0.72994118}, {174,0.74052941}, {175,0.74507843}, {176,0.75799020}, {177,0.76024510}, {178,0.76889216}, {179,0.77757843}, {180,0.78772549}, {181,0.79640196}, {182,0.80401961}, {183,0.81141176}, {184,0.82329412}, {185,0.83178431}, {186,0.84021569}, {187,0.84839216}, {188,0.85693137}, {189,0.86716667}, {190,0.87007843}, {191,0.88387255}, {192,0.89571569}, {193,0.90509804}, {194,0.91084314}, {195,0.91958824}, {196,0.92771569}, {197,0.93700000}, {198,0.94752941}, {199,0.95972549}, {200,0.96790196}, {201,0.97679412}, {202,0.98633333}, {203,0.99483333}, {204,1.00006863}, {205,1.01796078}, {206,1.02735294}, {207,1.03657843}, {208,1.04665686}, {209,1.04798039}, {210,1.06514706}, {211,1.08656863}, {212,1.08700000}, {213,1.09638235}, {214,1.10765686}, {215,1.11689216}, {216,1.12642157}, {217,1.12847059}, {218,1.14653922}, {219,1.15665686}, {220,1.16660784}, {221,1.17692157}, {222,1.18834314}, {223,1.20040196}, {224,1.20874510}, {225,1.22380392}, {226,1.23296078}, {227,1.24570588}, {228,1.25622549}, {229,1.26596078}, {230,1.27700980}, {231,1.28892157}, {232,1.29548039}, {233,1.31073529}, {234,1.32137255}, {235,1.33234314}, {236,1.34258824}, {237,1.37243137}, {238,1.38421569}, {239,1.38041176}, {240,1.38996078}, {241,1.40212745}, {242,1.42563725}, {243,1.43200000}, {244,1.44365686}, {245,1.45086275}, {246,1.46107843}, {247,1.47784314}, {248,1.48861765}, {249,1.50248039}, {250,1.51473529}, {251,1.52728431}, {252,1.53979412}, {253,1.54239216}, {254,1.56496078}, {255,1.57451961}, {256,1.58956863}, {257,1.61576471}, {258,1.60564706}, {259,1.61798039}, {260,1.63262745}, {261,1.64375490}, {262,1.65894118}, {263,1.67075490}, {264,1.68713725}, {265,1.70111765}, {266,1.69784314}, {267,1.71417647}, {268,1.72961765}, {269,1.74318627}, {270,1.75925490}, {271,1.76951961}, {272,1.78325490}, {273,1.79503922}, {274,1.80643137}, {275,1.82174510}, {276,1.83490196}, {277,1.84704902}, {278,1.86006863}, {279,1.87077451}, {280,1.88716667}, {281,1.89926471}, {282,1.91536275}, {283,1.93146078}, {284,1.94629412}, {285,1.95665686}, {286,2.00175490}, {287,1.99864706}, {288,2.00707843}, {289,2.02621569}, {290,2.04798039}, {291,2.05746078}, {292,2.06727451}, {293,2.08437255}, {294,2.09367647}, {295,2.10786275}, {296,2.12543137}, {297,2.14142157}, {298,2.15299020}, {299,2.16770588}, {300,2.18768627}, {301,2.23950}, {302,2.57850}, {303,2.23025}, {304,2.25075}, {305,2.29625}, {306,2.27500}, {307,2.28950}, {308,2.31950}, {309,2.33425}, {310,2.34050}, {311,2.35650}, {312,2.54850}, {313,2.70325}, {314,2.37075}, {315,2.39025}, {316,2.38975}, {317,2.42925}, {318,2.42100}, {319,2.42850}, {320,2.43250}, {321,2.45625}, {322,2.51950}, {323,2.50850}, {324,2.51750}, {325,2.53850}, {326,2.57350}, {327,2.61750}, {328,2.60025}, {329,2.62275}, {330,2.62975}, {331,2.66675}, {332,2.69650}, {333,2.69075}, {334,2.70050}, {335,2.71625}, {336,2.74225}, {337,2.79725}, {338,2.77700}, {339,2.80325}, {340,2.80625}, {341,2.82825}, {342,2.87375}, {343,2.87350}, {344,2.86225}, {345,2.86700}, {346,2.91350}, {347,2.96950}, {348,2.97825}, {349,2.97325}, {350,2.98875}, {351,3.04400}, {352,3.01875}, {353,3.03850}, {354,3.05500}, {355,3.07675}, {356,3.11400}, {357,3.12575}, {358,3.13500}, {359,3.14700}, {360,3.20175}, {361,3.20525}, {362,3.19350}, {363,3.19700}, {364,3.23300}, {365,3.23100}, {366,3.26225}, {367,3.29750}, {368,3.34100}, {369,3.35150}, {370,3.34150}, {371,3.36950}, {372,3.42350}, {373,3.40250}, {374,3.37675}, {375,3.39650}, {376,3.45425}, {377,3.46325}, {378,3.47675}, {379,3.48625}, {380,3.52850}, {381,3.50350}, {382,3.57975}, {383,3.59825}, {384,3.63425}, {385,3.65850}, {386,3.66450}, {387,3.66925}, {388,3.71675}, {389,3.69950}, {390,3.69750}, {391,3.69925}, {392,3.74275}, {393,3.74100}, {394,3.75550}, {395,3.83250}, {396,3.84675}, {397,3.84375}, {398,3.87825}, {399,3.90975}, {400,3.90325}, {401,3.88750}, {402,3.96725}, {403,3.99925}, {404,4.00275}, {405,4.01825}, {406,4.07575}, {407,4.05975}, {408,4.07225}, {409,4.13350}, {410,4.15400}, {411,4.17125}, {412,4.20525}, {413,4.21925}, {414,4.17775}, {415,4.19275}, {416,4.26475}, {417,4.23925}, {418,4.24200}, {419,4.33850}, {420,4.32325}, {421,4.32475}, {422,4.41550}, {423,4.40975}, {424,4.40150}, {425,4.52650}, {426,4.51750}, {427,4.51050}, {428,4.55150}, {429,4.54000}, {430,4.54350}, {431,4.56350}, {432,4.60375}, {433,4.63950}, {434,4.66550}, {435,4.72050}, {436,4.69075}, {437,4.72575}, {438,4.78950}, {439,4.73150}, {440,4.77875}, {441,4.83050}, {442,4.81575}, {443,4.80625}, {444,4.82300}, {445,4.81850}, {446,4.85600}, {447,4.94575}, {448,4.95350}, {449,5.02450}, {450,4.99150}, {451,4.99900}, {452,5.03250}, {453,5.09350}, {454,5.08950}, {455,5.18275}, {456,5.12425}, {457,5.12200}, {458,5.14225}, {459,5.12225}, {460,5.18725}, {461,5.24150}, {462,5.22250}, {463,5.29525}, {464,5.26750}, {465,5.32650}, {466,5.37050}, {467,5.38850}, {468,5.40800}, {469,5.37775}, {470,5.42675}, {471,5.50950}, {472,5.46375}, {473,5.51650}, {474,5.50850}, {475,5.56250}, {476,5.61600}, {477,5.60825}, {478,5.62150}, {479,5.68350}, {480,5.71350}, {481,5.75225}, {482,5.73975}, {483,5.81150}, {484,5.83550}, {485,5.87600}, {486,5.95325}, {487,5.81650}, {488,5.89150}, {489,5.96275}, {490,6.06150}, {491,6.03150}, {492,5.97650}, {493,6.03800}, {494,5.98825}, {495,6.10525}, {496,6.10825}, {497,6.14550}, {498,6.13150}, {499,6.15375}, {500,6.22550}, {505,6.36450}, {510,6.61000}, {515,6.58350}, {520,6.73975}, {525,6.92650}, {530,7.05625}, {535,7.15575}, {540,7.29325}, {545,7.37725}, {550,7.66250}, {555,7.76550}, {560,7.90300}, {565,8.04000}, {570,8.21775}, {575,8.37475}, {580,8.43950}, {585,8.59425}, {590,8.84875}, {595,8.95400}, {600,8.97700}, {605,9.15475}, {610,9.40650}, {615,9.58150}, {620,9.61925}, {625,9.88700}, {630,10.16150}, {635,10.24225}, {640,10.38325}, {645,10.65950}, {650,10.73950}, {655,10.72425}, {660,11.06325}, {665,11.22750}, {670,11.24325}, {675,11.64225}, {680,11.77800}, {685,11.95125}, {690,12.22950}, {695,12.37550}, {700,12.56175}, {705,12.85175}, {710,12.90750}, {715,13.14050}, {720,13.30250}, {725,13.33975}, {730,13.63350}, {735,13.69050}, {740,13.88950}, {745,14.13825}, {750,14.40550}, {755,14.59450}, {760,15.11650}, {765,15.04750}, {770,15.29850}, {775,15.28125}, {780,15.49775}, {785,16.12850}, {790,15.72550}, {795,16.37125}, {800,16.26650}, {805,16.69650}, {810,16.84250}, {815,17.19525}, {820,17.01200}, {825,17.19175}, {830,17.67350}, {835,17.63325}, {840,18.11950}, {845,18.29500}, {850,18.56175}, {855,18.61550}, {860,18.84350}, {865,18.91550}, {870,19.12875}, {875,19.47700}, {880,19.76725}, {885,20.05050}, {890,20.21150}, {895,20.51275}, {900,20.60950}, {905,21.03875}, {910,21.11575}, {915,21.62300}, {920,21.54575}, {925,22.01675}, {930,22.21650}, {935,22.67575}, {940,22.75450}, {945,22.81075}, {950,23.33725}, {955,23.45475}, {960,23.65650}, {965,24.64175}, {970,24.25075}, {975,24.62075}, {980,24.78225}, {985,25.00825}, {990,25.51675}, {995,25.89750}, {1000,26.36225}, {1010,26.68350}, {1020,27.01500}, {1030,27.44625}, {1040,28.00025}, {1050,28.22350}, {1060,29.44300}, {1070,30.35950}, {1080,30.23225}, {1090,30.91900}, {1100,31.20425}, {1110,32.76325}, {1120,33.35175}, {1130,33.66100}, {1140,34.36250}, {1150,34.69050}, {1160,35.56150}, {1170,36.69975}, {1180,37.08350}, {1190,37.34450}, {1200,38.42075}, {1210,39.17750}, {1220,39.36550}, {1230,40.42050}, {1240,42.06850}, {1250,41.23075}, {1260,43.25250}, {1270,43.57525}, {1280,43.52025}, {1290,45.05675}, {1300,46.01625}, {1310,46.08175}, {1320,46.76150}, {1330,47.30425}, {1340,48.12650}, {1350,49.51600}, {1360,49.30850}, {1370,50.71850}, {1380,50.73050}, {1390,52.21325}, {1400,53.63050}, {1410,54.15350}, {1420,54.46650}, {1430,55.67200}, {1440,56.04025}, {1450,57.79725}, {1460,61.079}, {1470,61.775}, {1480,63.255}, {1490,63.788}, {1500,64.672}, {1510,65.52}, {1520,66.471}, {1530,67.847}, {1540,68.108}, {1550,70.175}, {1560,69.884}, {1570,71.644}, {1580,70.787}, {1590,74.387}, {1600,72.864}, {1610,74.308}, {1620,74.039}, {1630,75.092}, {1640,76.444}, {1650,78.083}, {1660,78.876}, {1670,79.576}, {1680,82.868}, {1690,82.248}, {1700,85.195}, {1710,83.956}, {1720,84.863}, {1730,87.871}, {1740,87.824}, {1750,86.952}, {1760,88.308}, {1770,89.711}, {1780,89.935}, {1790,91.171}, {1800,93.579}, {1810,92.551}, {1820,91.487}, {1830,94.944}, {1840,96.668}, {1850,94.351}, {1860,95.359}, {1870,100.471}, {1880,100.823}, {1890,98.904}, {1900,99.943}, {1910,104.52}, {1920,105.62}, {1930,102.203}, {1940,103.899}, {1950,105.003}, {1960,109.104}, {1970,110.824}, {1980,108.272}, {1990,109.02}, {2000,114.26}, {2050,119.747}, {2100,121.42}, {2150,128.104}, {2200,131.231}, {2250,141.84}, {2300,145.576}, {2350,152.831}, {2400,156.86}, {2450,166.927}, {2500,173.059}, {2550,177.283}, {2600,188.579}, {2650,192.083}, {2700,205.116}, {2750,211.988}, {2800,217.736}, {2850,228.864}, {2900,236.576}, {2950,242.763}, {3000,253.228}, {3050,262.995}, {3100,270.595}, {3150,276.791}, {3200,290.652}, {3250,299.772}, {3300,307.928}, {3350,321.259}, {3400,328.76}, {3450,339.255}, {3500,352.847}, {3550,358.927}, {3600,370.112}, {3650,383.62}, {3700,389.864}, {3750,412.747}, {3800,421.912}, {3850,424.148}, {3900,432.008}, {3950,449.723}, {4000,462.515}, {4050,473.06}, {4100,483.3}, {4150,488.655}, {4200,494.724}, {4250,509.531}, {4300,520.976}, {4350,543.423}, {4400,546.064}, {4450,558.691}, {4500,577.815}, {4550,593.063}, {4600,608.659}, {4650,619.727}, {4700,651.283}, {4750,664.928}, {4800,681.063}, {4850,692.652}, {4900,705.336}, {4950,716.548}, {5000,738.072}, {5050,750.211}, {5100,772.508}, {5150,785.188}, {5200,807.94}, {5250,817.723}, {5300,834.707}, {5350,856.416}, {5400,855.788}, {5450,873.148}, {5500,900.495}, {5550,930.395}, {5600,938.932}, {5650,952.919}, {5700,975.103}, {5750,994.567}, {5800,1008.508}, {5850,1026.004}, {5900,1036.871}, {5950,1055.779}, {6000,1084.319}};
data["big"]["Ltac2"]["norm reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003922}, {4,0.00003922}, {5,0.00000000}, {6,0.00003922}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00003922}, {12,0.00000000}, {13,0.00007843}, {14,0.00003922}, {15,0.00007843}, {16,0.00003922}, {17,0.00003922}, {18,0.00003922}, {19,0.00000000}, {20,0.00000000}, {21,0.00003922}, {22,0.00003922}, {23,0.00003922}, {24,0.00003922}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00003922}, {29,0.00007843}, {30,0.00007843}, {31,0.00007843}, {32,0.00003922}, {33,0.00010784}, {34,0.00000000}, {35,0.00015686}, {36,0.00000000}, {37,0.00003922}, {38,0.00011765}, {39,0.00003922}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00003922}, {45,0.00000000}, {46,0.00003922}, {47,0.00003922}, {48,0.00000000}, {49,0.00000000}, {50,0.00003922}, {51,0.00003922}, {52,0.00000000}, {53,0.00003922}, {54,0.00003922}, {55,0.00011765}, {56,0.00003922}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00003922}, {63,0.00003922}, {64,0.00000000}, {65,0.00015686}, {66,0.00007843}, {67,0.00011765}, {68,0.00000000}, {69,0.00007843}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00007843}, {76,0.00000000}, {77,0.00007843}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00007843}, {82,0.00007843}, {83,0.00007843}, {84,0.00003922}, {85,0.00000000}, {86,0.00003922}, {87,0.00007843}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00003922}, {92,0.00000000}, {93,0.00011765}, {94,0.00000000}, {95,0.00007843}, {96,0.00011765}, {97,0.00003922}, {98,0.00002941}, {99,0.00011765}, {100,0.00003922}, {101,0.00000000}, {102,0.00003922}, {103,0.00000000}, {104,0.00003922}, {105,0.00003922}, {106,0.00003922}, {107,0.00003922}, {108,0.00010784}, {109,0.00027451}, {110,0.00014706}, {111,0.00007843}, {112,0.00006863}, {113,0.00003922}, {114,0.00003922}, {115,0.00006863}, {116,0.00007843}, {117,0.00000000}, {118,0.00014706}, {119,0.00003922}, {120,0.00014706}, {121,0.00003922}, {122,0.00000000}, {123,0.00011765}, {124,0.00011765}, {125,0.00011765}, {126,0.00003922}, {127,0.00003922}, {128,0.00000000}, {129,0.00007843}, {130,0.00011765}, {131,0.00007843}, {132,0.00000000}, {133,0.00003922}, {134,0.00003922}, {135,0.00015686}, {136,0.00015686}, {137,0.00007843}, {138,0.00007843}, {139,0.00010784}, {140,0.00007843}, {141,0.00000000}, {142,0.00003922}, {143,0.00011765}, {144,0.00003922}, {145,0.00019608}, {146,0.00003922}, {147,0.00003922}, {148,0.00007843}, {149,0.00007843}, {150,0.00003922}, {151,0.00011765}, {152,0.00007843}, {153,0.00006863}, {154,0.00007843}, {155,0.00003922}, {156,0.00003922}, {157,0.00019608}, {158,0.00007843}, {159,0.00003922}, {160,0.00007843}, {161,0.00003922}, {162,0.00023529}, {163,0.00023529}, {164,0.00011765}, {165,0.00003922}, {166,0.00011765}, {167,0.00007843}, {168,0.00003922}, {169,0.00000000}, {170,0.00000000}, {171,0.00003922}, {172,0.00000000}, {173,0.00003922}, {174,0.00007843}, {175,0.00003922}, {176,0.00007843}, {177,0.00015686}, {178,0.00015686}, {179,0.00007843}, {180,0.00007843}, {181,0.00015686}, {182,0.00003922}, {183,0.00014706}, {184,0.00011765}, {185,0.00011765}, {186,0.00011765}, {187,0.00010784}, {188,0.00000000}, {189,0.00019608}, {190,0.00019608}, {191,0.00007843}, {192,0.00000000}, {193,0.00007843}, {194,0.00023529}, {195,0.00000000}, {196,0.00003922}, {197,0.00007843}, {198,0.00014706}, {199,0.00000000}, {200,0.00010784}, {201,0.00019608}, {202,0.00015686}, {203,0.00007843}, {204,0.00006863}, {205,0.00006863}, {206,0.00023529}, {207,0.00006863}, {208,0.00003922}, {209,0.00003922}, {210,0.00011765}, {211,0.00011765}, {212,0.00015686}, {213,0.00011765}, {214,0.00015686}, {215,0.00015686}, {216,0.00011765}, {217,0.00011765}, {218,0.00031373}, {219,0.00003922}, {220,0.00035294}, {221,0.00023529}, {222,0.00007843}, {223,0.00011765}, {224,0.00027451}, {225,0.00003922}, {226,0.00015686}, {227,0.00011765}, {228,0.00007843}, {229,0.00000000}, {230,0.00010784}, {231,0.00000000}, {232,0.00007843}, {233,0.00022549}, {234,0.00015686}, {235,0.00011765}, {236,0.00015686}, {237,0.00011765}, {238,0.00015686}, {239,0.00011765}, {240,0.00026471}, {241,0.00011765}, {242,0.00019608}, {243,0.00023529}, {244,0.00023529}, {245,0.00011765}, {246,0.00019608}, {247,0.00025490}, {248,0.00026471}, {249,0.00015686}, {250,0.00011765}, {251,0.00023529}, {252,0.00011765}, {253,0.00009804}, {254,0.00011765}, {255,0.00015686}, {256,0.00019608}, {257,0.00003922}, {258,0.00027451}, {259,0.00023529}, {260,0.00011765}, {261,0.00023529}, {262,0.00022549}, {263,0.00011765}, {264,0.00023529}, {265,0.00015686}, {266,0.00019608}, {267,0.00011765}, {268,0.00015686}, {269,0.00007843}, {270,0.00019608}, {271,0.00019608}, {272,0.00011765}, {273,0.00023529}, {274,0.00003922}, {275,0.00015686}, {276,0.00023529}, {277,0.00003922}, {278,0.00035294}, {279,0.00027451}, {280,0.00027451}, {281,0.00034314}, {282,0.00011765}, {283,0.00023529}, {284,0.00019608}, {285,0.00042157}, {286,0.00027451}, {287,0.00035294}, {288,0.00026471}, {289,0.00035294}, {290,0.00023529}, {291,0.00019608}, {292,0.00039216}, {293,0.00019608}, {294,0.00042157}, {295,0.00007843}, {296,0.00039216}, {297,0.00023529}, {298,0.00031373}, {299,0.00015686}, {300,0.00019608}, {301,0.00100}, {302,0.00200}, {303,0.00000}, {304,0.00000}, {305,0.00000}, {306,0.00000}, {307,0.00000}, {308,0.00000}, {309,0.00000}, {310,0.00000}, {311,0.00000}, {312,0.00100}, {313,0.00300}, {314,0.00000}, {315,0.00000}, {316,0.00000}, {317,0.00000}, {318,0.00000}, {319,0.00000}, {320,0.00000}, {321,0.00000}, {322,0.00000}, {323,0.00000}, {324,0.00000}, {325,0.00000}, {326,0.00000}, {327,0.00000}, {328,0.00000}, {329,0.00000}, {330,0.00000}, {331,0.00000}, {332,0.00200}, {333,0.00000}, {334,0.00100}, {335,0.00000}, {336,0.00000}, {337,0.00000}, {338,0.00000}, {339,0.00000}, {340,0.00000}, {341,0.00000}, {342,0.00000}, {343,0.00000}, {344,0.00000}, {345,0.00000}, {346,0.00000}, {347,0.00000}, {348,0.00000}, {349,0.00000}, {350,0.00000}, {351,0.00000}, {352,0.00000}, {353,0.00000}, {354,0.00000}, {355,0.00000}, {356,0.00100}, {357,0.00000}, {358,0.00200}, {359,0.00000}, {360,0.00000}, {361,0.00100}, {362,0.00100}, {363,0.00000}, {364,0.00000}, {365,0.00000}, {366,0.00000}, {367,0.00000}, {368,0.00000}, {369,0.00000}, {370,0.00000}, {371,0.00000}, {372,0.00000}, {373,0.00100}, {374,0.00000}, {375,0.00100}, {376,0.00000}, {377,0.00000}, {378,0.00100}, {379,0.00100}, {380,0.00000}, {381,0.00000}, {382,0.00000}, {383,0.00100}, {384,0.00100}, {385,0.00000}, {386,0.00000}, {387,0.00000}, {388,0.00100}, {389,0.00075}, {390,0.00000}, {391,0.00000}, {392,0.00000}, {393,0.00000}, {394,0.00100}, {395,0.00000}, {396,0.00000}, {397,0.00000}, {398,0.00000}, {399,0.00000}, {400,0.00000}, {401,0.00000}, {402,0.00000}, {403,0.00000}, {404,0.00000}, {405,0.00000}, {406,0.00000}, {407,0.00000}, {408,0.00000}, {409,0.00000}, {410,0.00000}, {411,0.00000}, {412,0.00000}, {413,0.00000}, {414,0.00000}, {415,0.00000}, {416,0.00000}, {417,0.00000}, {418,0.00000}, {419,0.00000}, {420,0.00100}, {421,0.00000}, {422,0.00000}, {423,0.00000}, {424,0.00000}, {425,0.00000}, {426,0.00000}, {427,0.00000}, {428,0.00000}, {429,0.00000}, {430,0.00000}, {431,0.00000}, {432,0.00000}, {433,0.00000}, {434,0.00000}, {435,0.00000}, {436,0.00000}, {437,0.00000}, {438,0.00000}, {439,0.00000}, {440,0.00000}, {441,0.00000}, {442,0.00000}, {443,0.00000}, {444,0.00000}, {445,0.00000}, {446,0.00000}, {447,0.00000}, {448,0.00000}, {449,0.00000}, {450,0.00000}, {451,0.00000}, {452,0.00000}, {453,0.00000}, {454,0.00000}, {455,0.00000}, {456,0.00000}, {457,0.00000}, {458,0.00075}, {459,0.00000}, {460,0.00500}, {461,0.00000}, {462,0.00000}, {463,0.00000}, {464,0.00000}, {465,0.00000}, {466,0.00000}, {467,0.00000}, {468,0.00000}, {469,0.00000}, {470,0.00000}, {471,0.00000}, {472,0.00000}, {473,0.00000}, {474,0.00000}, {475,0.00000}, {476,0.00000}, {477,0.00000}, {478,0.00000}, {479,0.00000}, {480,0.00000}, {481,0.00000}, {482,0.00000}, {483,0.00000}, {484,0.00000}, {485,0.00100}, {486,0.00000}, {487,0.00000}, {488,0.00100}, {489,0.00000}, {490,0.00000}, {491,0.00000}, {492,0.00000}, {493,0.00000}, {494,0.00075}, {495,0.00000}, {496,0.00000}, {497,0.00000}, {498,0.00000}, {499,0.00000}, {500,0.00100}, {505,0.00000}, {510,0.00000}, {515,0.00100}, {520,0.00000}, {525,0.00000}, {530,0.00100}, {535,0.00000}, {540,0.00100}, {545,0.00000}, {550,0.00000}, {555,0.00100}, {560,0.00000}, {565,0.00100}, {570,0.00000}, {575,0.00000}, {580,0.03250}, {585,0.00375}, {590,0.00300}, {595,0.00000}, {600,0.00400}, {605,0.00000}, {610,0.00000}, {615,0.00000}, {620,0.00000}, {625,0.00000}, {630,0.00000}, {635,0.00000}, {640,0.00000}, {645,0.00000}, {650,0.00000}, {655,0.00000}, {660,0.00000}, {665,0.00000}, {670,0.00000}, {675,0.00000}, {680,0.00000}, {685,0.00000}, {690,0.00000}, {695,0.00000}, {700,0.00000}, {705,0.00000}, {710,0.00000}, {715,0.00000}, {720,0.00000}, {725,0.00000}, {730,0.00000}, {735,0.00000}, {740,0.00200}, {745,0.00000}, {750,0.00000}, {755,0.00300}, {760,0.00000}, {765,0.00000}, {770,0.00400}, {775,0.00100}, {780,0.00000}, {785,0.00700}, {790,0.02475}, {795,0.00400}, {800,0.00600}, {805,0.00075}, {810,0.00000}, {815,0.00175}, {820,0.00300}, {825,0.00500}, {830,0.00175}, {835,0.00000}, {840,0.00000}, {845,0.00000}, {850,0.00000}, {855,0.00300}, {860,0.00000}, {865,0.00000}, {870,0.00000}, {875,0.00000}, {880,0.00100}, {885,0.00000}, {890,0.00000}, {895,0.00000}, {900,0.00000}, {905,0.00000}, {910,0.00000}, {915,0.00000}, {920,0.00100}, {925,0.00000}, {930,0.00000}, {935,0.00100}, {940,0.00000}, {945,0.00100}, {950,0.00300}, {955,0.00200}, {960,0.00000}, {965,0.00300}, {970,0.00000}, {975,0.00000}, {980,0.00000}, {985,0.00300}, {990,0.00100}, {995,0.00300}, {1000,0.00100}, {1010,0.00100}, {1020,0.00000}, {1030,0.00200}, {1040,0.00700}, {1050,0.00000}, {1060,0.00000}, {1070,0.00000}, {1080,0.00000}, {1090,0.00300}, {1100,0.00675}, {1110,0.00675}, {1120,0.01200}, {1130,0.00675}, {1140,0.00500}, {1150,0.00700}, {1160,0.00900}, {1170,0.00775}, {1180,0.01175}, {1190,0.01100}, {1200,0.00300}, {1210,0.00600}, {1220,0.00700}, {1230,0.00675}, {1240,0.00700}, {1250,0.01100}, {1260,0.08775}, {1270,0.00400}, {1280,0.00900}, {1290,0.00675}, {1300,0.00500}, {1310,0.00475}, {1320,0.01000}, {1330,0.00300}, {1340,0.00300}, {1350,0.11675}, {1360,0.00500}, {1370,0.00450}, {1380,0.00500}, {1390,0.01100}, {1400,0.01000}, {1410,0.01900}, {1420,0.00900}, {1430,0.01200}, {1440,0.00200}, {1450,0.00200}, {1460,0}, {1470,0}, {1480,0}, {1490,0.012}, {1500,0.044}, {1510,0}, {1520,0.008}, {1530,0.044}, {1540,0.02}, {1550,0.056}, {1560,0}, {1570,0.06}, {1580,0}, {1590,0}, {1600,0.032}, {1610,0.012}, {1620,0.004}, {1630,0}, {1640,0.004}, {1650,0}, {1660,0}, {1670,0}, {1680,0}, {1690,0}, {1700,0.02}, {1710,0.143}, {1720,0}, {1730,0}, {1740,0}, {1750,0}, {1760,0.004}, {1770,0.02}, {1780,0.244}, {1790,0.004}, {1800,0}, {1810,0}, {1820,0.096}, {1830,0}, {1840,0.003}, {1850,0.008}, {1860,0.008}, {1870,0}, {1880,0}, {1890,0.004}, {1900,0.199}, {1910,0}, {1920,0.06}, {1930,0}, {1940,0.163}, {1950,0}, {1960,0.008}, {1970,0.028}, {1980,0}, {1990,0}, {2000,0.511}, {2050,0}, {2100,0.088}, {2150,0.056}, {2200,0.275}, {2250,0.22}, {2300,0}, {2350,0.011}, {2400,0.048}, {2450,0.012}, {2500,0}, {2550,0.035}, {2600,0.544}, {2650,0.251}, {2700,0.032}, {2750,0.139}, {2800,0.596}, {2850,0.432}, {2900,0.064}, {2950,0.016}, {3000,0.063}, {3050,0.06}, {3100,0.035}, {3150,0.032}, {3200,0.012}, {3250,0.323}, {3300,0.092}, {3350,0.072}, {3400,0.048}, {3450,0}, {3500,0.055}, {3550,0.04}, {3600,0.739}, {3650,1.004}, {3700,0}, {3750,0.096}, {3800,0.048}, {3850,0.051}, {3900,0.048}, {3950,0.295}, {4000,0.108}, {4050,0.071}, {4100,0.128}, {4150,0.024}, {4200,0.247}, {4250,0.192}, {4300,0.435}, {4350,1.327}, {4400,1.084}, {4450,0.679}, {4500,0.263}, {4550,0.588}, {4600,0.523}, {4650,0.167}, {4700,0.16}, {4750,0.224}, {4800,0.251}, {4850,0.152}, {4900,0.076}, {4950,0.1}, {5000,0.939}, {5050,0.352}, {5100,0.347}, {5150,1.124}, {5200,0.295}, {5250,1.696}, {5300,3.811}, {5350,0.312}, {5400,0.248}, {5450,5.327}, {5500,2.003}, {5550,1.972}, {5600,2.244}, {5650,0.572}, {5700,1.927}, {5750,2.192}, {5800,0.456}, {5850,2.207}, {5900,2.107}, {5950,3.688}, {6000,3.155}};
data["big"]["Ltac2"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000}, {302,0.00000}, {303,0.00000}, {304,0.00000}, {305,0.00000}, {306,0.00000}, {307,0.00000}, {308,0.00000}, {309,0.00000}, {310,0.00000}, {311,0.00000}, {312,0.00000}, {313,0.00000}, {314,0.00000}, {315,0.00000}, {316,0.00000}, {317,0.00000}, {318,0.00000}, {319,0.00000}, {320,0.00000}, {321,0.00000}, {322,0.00000}, {323,0.00000}, {324,0.00000}, {325,0.00000}, {326,0.00000}, {327,0.00000}, {328,0.00000}, {329,0.00000}, {330,0.00000}, {331,0.00000}, {332,0.00000}, {333,0.00000}, {334,0.00000}, {335,0.00000}, {336,0.00000}, {337,0.00000}, {338,0.00000}, {339,0.00000}, {340,0.00000}, {341,0.00000}, {342,0.00000}, {343,0.00000}, {344,0.00000}, {345,0.00000}, {346,0.00000}, {347,0.00000}, {348,0.00000}, {349,0.00000}, {350,0.00000}, {351,0.00000}, {352,0.00000}, {353,0.00000}, {354,0.00000}, {355,0.00000}, {356,0.00000}, {357,0.00000}, {358,0.00000}, {359,0.00000}, {360,0.00000}, {361,0.00000}, {362,0.00000}, {363,0.00000}, {364,0.00000}, {365,0.00000}, {366,0.00000}, {367,0.00000}, {368,0.00000}, {369,0.00000}, {370,0.00000}, {371,0.00000}, {372,0.00000}, {373,0.00000}, {374,0.00000}, {375,0.00000}, {376,0.00000}, {377,0.00000}, {378,0.00000}, {379,0.00000}, {380,0.00000}, {381,0.00000}, {382,0.00000}, {383,0.00000}, {384,0.00000}, {385,0.00000}, {386,0.00000}, {387,0.00000}, {388,0.00000}, {389,0.00000}, {390,0.00000}, {391,0.00000}, {392,0.00000}, {393,0.00000}, {394,0.00000}, {395,0.00000}, {396,0.00000}, {397,0.00000}, {398,0.00000}, {399,0.00000}, {400,0.00000}, {401,0.00000}, {402,0.00000}, {403,0.00000}, {404,0.00000}, {405,0.00000}, {406,0.00000}, {407,0.00000}, {408,0.00000}, {409,0.00000}, {410,0.00000}, {411,0.00000}, {412,0.00000}, {413,0.00000}, {414,0.00000}, {415,0.00000}, {416,0.00000}, {417,0.00000}, {418,0.00000}, {419,0.00000}, {420,0.00000}, {421,0.00000}, {422,0.00000}, {423,0.00000}, {424,0.00000}, {425,0.00000}, {426,0.00000}, {427,0.00000}, {428,0.00000}, {429,0.00000}, {430,0.00000}, {431,0.00000}, {432,0.00000}, {433,0.00000}, {434,0.00000}, {435,0.00000}, {436,0.00000}, {437,0.00000}, {438,0.00000}, {439,0.00000}, {440,0.00000}, {441,0.00000}, {442,0.00000}, {443,0.00000}, {444,0.00000}, {445,0.00000}, {446,0.00000}, {447,0.00000}, {448,0.00000}, {449,0.00000}, {450,0.00000}, {451,0.00000}, {452,0.00000}, {453,0.00000}, {454,0.00000}, {455,0.00000}, {456,0.00000}, {457,0.00000}, {458,0.00000}, {459,0.00000}, {460,0.00000}, {461,0.00000}, {462,0.00000}, {463,0.00000}, {464,0.00000}, {465,0.00000}, {466,0.00000}, {467,0.00000}, {468,0.00000}, {469,0.00000}, {470,0.00000}, {471,0.00000}, {472,0.00000}, {473,0.00000}, {474,0.00000}, {475,0.00000}, {476,0.00000}, {477,0.00000}, {478,0.00000}, {479,0.00000}, {480,0.00000}, {481,0.00000}, {482,0.00000}, {483,0.00000}, {484,0.00000}, {485,0.00000}, {486,0.00000}, {487,0.00000}, {488,0.00000}, {489,0.00000}, {490,0.00000}, {491,0.00000}, {492,0.00000}, {493,0.00000}, {494,0.00000}, {495,0.00000}, {496,0.00000}, {497,0.00000}, {498,0.00000}, {499,0.00000}, {500,0.00000}, {505,0.00000}, {510,0.00000}, {515,0.00000}, {520,0.00000}, {525,0.00000}, {530,0.00000}, {535,0.00000}, {540,0.00000}, {545,0.00000}, {550,0.00000}, {555,0.00000}, {560,0.00000}, {565,0.00000}, {570,0.00000}, {575,0.00000}, {580,0.00000}, {585,0.00000}, {590,0.00000}, {595,0.00000}, {600,0.00000}, {605,0.00000}, {610,0.00000}, {615,0.00000}, {620,0.00000}, {625,0.00000}, {630,0.00000}, {635,0.00000}, {640,0.00000}, {645,0.00000}, {650,0.00000}, {655,0.00000}, {660,0.00000}, {665,0.00000}, {670,0.00000}, {675,0.00000}, {680,0.00000}, {685,0.00000}, {690,0.00000}, {695,0.00000}, {700,0.00000}, {705,0.00000}, {710,0.00000}, {715,0.00000}, {720,0.00000}, {725,0.00000}, {730,0.00000}, {735,0.00000}, {740,0.00000}, {745,0.00000}, {750,0.00000}, {755,0.00000}, {760,0.00000}, {765,0.00000}, {770,0.00000}, {775,0.00000}, {780,0.00000}, {785,0.00000}, {790,0.00000}, {795,0.00000}, {800,0.00000}, {805,0.00000}, {810,0.00000}, {815,0.00000}, {820,0.00000}, {825,0.00000}, {830,0.00000}, {835,0.00000}, {840,0.00000}, {845,0.00000}, {850,0.00000}, {855,0.00000}, {860,0.00000}, {865,0.00000}, {870,0.00000}, {875,0.00000}, {880,0.00000}, {885,0.00000}, {890,0.00000}, {895,0.00000}, {900,0.00000}, {905,0.00000}, {910,0.00000}, {915,0.00000}, {920,0.00000}, {925,0.00000}, {930,0.00000}, {935,0.00000}, {940,0.00000}, {945,0.00000}, {950,0.00000}, {955,0.00000}, {960,0.00000}, {965,0.00000}, {970,0.00000}, {975,0.00000}, {980,0.00000}, {985,0.00000}, {990,0.00000}, {995,0.00000}, {1000,0.00000}, {1010,0.00000}, {1020,0.00000}, {1030,0.00000}, {1040,0.00000}, {1050,0.00000}, {1060,0.00000}, {1070,0.00000}, {1080,0.00000}, {1090,0.00000}, {1100,0.00000}, {1110,0.00000}, {1120,0.00000}, {1130,0.00000}, {1140,0.00000}, {1150,0.00000}, {1160,0.00000}, {1170,0.00000}, {1180,0.00000}, {1190,0.00000}, {1200,0.00000}, {1210,0.00000}, {1220,0.00000}, {1230,0.00000}, {1240,0.00000}, {1250,0.00000}, {1260,0.00000}, {1270,0.00000}, {1280,0.00000}, {1290,0.00000}, {1300,0.00000}, {1310,0.00000}, {1320,0.00000}, {1330,0.00000}, {1340,0.00000}, {1350,0.00000}, {1360,0.00000}, {1370,0.00000}, {1380,0.00000}, {1390,0.00000}, {1400,0.00000}, {1410,0.00000}, {1420,0.00000}, {1430,0.00000}, {1440,0.00000}, {1450,0.00000}, {1460,0}, {1470,0}, {1480,0}, {1490,0}, {1500,0}, {1510,0}, {1520,0}, {1530,0}, {1540,0}, {1550,0}, {1560,0}, {1570,0}, {1580,0}, {1590,0}, {1600,0}, {1610,0}, {1620,0}, {1630,0}, {1640,0}, {1650,0}, {1660,0}, {1670,0}, {1680,0}, {1690,0}, {1700,0}, {1710,0}, {1720,0}, {1730,0}, {1740,0}, {1750,0}, {1760,0}, {1770,0}, {1780,0}, {1790,0}, {1800,0}, {1810,0}, {1820,0}, {1830,0}, {1840,0}, {1850,0}, {1860,0}, {1870,0}, {1880,0}, {1890,0}, {1900,0}, {1910,0}, {1920,0}, {1930,0}, {1940,0}, {1950,0}, {1960,0}, {1970,0}, {1980,0}, {1990,0}, {2000,0}, {2050,0}, {2100,0}, {2150,0}, {2200,0}, {2250,0}, {2300,0}, {2350,0}, {2400,0}, {2450,0}, {2500,0}, {2550,0}, {2600,0}, {2650,0}, {2700,0}, {2750,0}, {2800,0}, {2850,0}, {2900,0}, {2950,0}, {3000,0}, {3050,0}, {3100,0}, {3150,0}, {3200,0}, {3250,0}, {3300,0}, {3350,0}, {3400,0}, {3450,0}, {3500,0}, {3550,0}, {3600,0}, {3650,0}, {3700,0}, {3750,0}, {3800,0}, {3850,0}, {3900,0}, {3950,0}, {4000,0}, {4050,0}, {4100,0}, {4150,0}, {4200,0}, {4250,0}, {4300,0}, {4350,0}, {4400,0}, {4450,0}, {4500,0}, {4550,0}, {4600,0}, {4650,0}, {4700,0}, {4750,0}, {4800,0}, {4850,0}, {4900,0}, {4950,0}, {5000,0}, {5050,0}, {5100,0}, {5150,0}, {5200,0}, {5250,0}, {5300,0}, {5350,0}, {5400,0}, {5450,0}, {5500,0}, {5550,0}, {5600,0}, {5650,0}, {5700,0}, {5750,0}, {5800,0}, {5850,0}, {5900,0}, {5950,0}, {6000,0}};
data["big"]["Ltac2"]["post"]["user"] = {{1,0.00003922}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00003922}, {6,0.00000000}, {7,0.00000000}, {8,0.00007843}, {9,0.00007843}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00003922}, {14,0.00003922}, {15,0.00003922}, {16,0.00003922}, {17,0.00002941}, {18,0.00000000}, {19,0.00006863}, {20,0.00011765}, {21,0.00003922}, {22,0.00003922}, {23,0.00002941}, {24,0.00007843}, {25,0.00000000}, {26,0.00006863}, {27,0.00003922}, {28,0.00002941}, {29,0.00000000}, {30,0.00003922}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00003922}, {35,0.00006863}, {36,0.00003922}, {37,0.00007843}, {38,0.00003922}, {39,0.00000000}, {40,0.00009804}, {41,0.00011765}, {42,0.00007843}, {43,0.00003922}, {44,0.00003922}, {45,0.00003922}, {46,0.00010784}, {47,0.00003922}, {48,0.00007843}, {49,0.00003922}, {50,0.00003922}, {51,0.00007843}, {52,0.00006863}, {53,0.00000000}, {54,0.00002941}, {55,0.00003922}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00002941}, {60,0.00003922}, {61,0.00000000}, {62,0.00003922}, {63,0.00007843}, {64,0.00000000}, {65,0.00003922}, {66,0.00000000}, {67,0.00000000}, {68,0.00003922}, {69,0.00000000}, {70,0.00000000}, {71,0.00003922}, {72,0.00000000}, {73,0.00003922}, {74,0.00003922}, {75,0.00000000}, {76,0.00007843}, {77,0.00000000}, {78,0.00000000}, {79,0.00003922}, {80,0.00007843}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00003922}, {86,0.00000000}, {87,0.00003922}, {88,0.00003922}, {89,0.00003922}, {90,0.00000000}, {91,0.00003922}, {92,0.00003922}, {93,0.00003922}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00007843}, {98,0.00003922}, {99,0.00003922}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003922}, {105,0.00000000}, {106,0.00010784}, {107,0.00003922}, {108,0.00003922}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00003922}, {113,0.00000000}, {114,0.00003922}, {115,0.00000000}, {116,0.00003922}, {117,0.00003922}, {118,0.00003922}, {119,0.00000000}, {120,0.00003922}, {121,0.00003922}, {122,0.00003922}, {123,0.00011765}, {124,0.00003922}, {125,0.00007843}, {126,0.00006863}, {127,0.00003922}, {128,0.00000000}, {129,0.00011765}, {130,0.00003922}, {131,0.00003922}, {132,0.00003922}, {133,0.00000000}, {134,0.00003922}, {135,0.00000000}, {136,0.00000000}, {137,0.00003922}, {138,0.00000000}, {139,0.00003922}, {140,0.00007843}, {141,0.00000000}, {142,0.00003922}, {143,0.00006863}, {144,0.00000000}, {145,0.00000000}, {146,0.00003922}, {147,0.00006863}, {148,0.00000000}, {149,0.00000000}, {150,0.00005882}, {151,0.00003922}, {152,0.00003922}, {153,0.00003922}, {154,0.00003922}, {155,0.00003922}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00003922}, {160,0.00011765}, {161,0.00007843}, {162,0.00000000}, {163,0.00003922}, {164,0.00003922}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00003922}, {169,0.00003922}, {170,0.00003922}, {171,0.00000000}, {172,0.00003922}, {173,0.00000000}, {174,0.00000000}, {175,0.00003922}, {176,0.00003922}, {177,0.00002941}, {178,0.00003922}, {179,0.00003922}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00010784}, {184,0.00007843}, {185,0.00000000}, {186,0.00010784}, {187,0.00000000}, {188,0.00003922}, {189,0.00010784}, {190,0.00011765}, {191,0.00003922}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00003922}, {196,0.00003922}, {197,0.00003922}, {198,0.00000000}, {199,0.00010784}, {200,0.00007843}, {201,0.00000000}, {202,0.00000000}, {203,0.00003922}, {204,0.00011765}, {205,0.00000000}, {206,0.00006863}, {207,0.00003922}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00007843}, {212,0.00006863}, {213,0.00003922}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00007843}, {220,0.00003922}, {221,0.00000000}, {222,0.00000000}, {223,0.00003922}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00003922}, {231,0.00000000}, {232,0.00002941}, {233,0.00010784}, {234,0.00014706}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00007843}, {241,0.00003922}, {242,0.00003922}, {243,0.00003922}, {244,0.00003922}, {245,0.00003922}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00003922}, {251,0.00007843}, {252,0.00003922}, {253,0.00003922}, {254,0.00003922}, {255,0.00003922}, {256,0.00007843}, {257,0.00007843}, {258,0.00000000}, {259,0.00002941}, {260,0.00002941}, {261,0.00003922}, {262,0.00000000}, {263,0.00000000}, {264,0.00011765}, {265,0.00000000}, {266,0.00003922}, {267,0.00003922}, {268,0.00003922}, {269,0.00003922}, {270,0.00000000}, {271,0.00003922}, {272,0.00002941}, {273,0.00000000}, {274,0.00006863}, {275,0.00006863}, {276,0.00000000}, {277,0.00007843}, {278,0.00000000}, {279,0.00000000}, {280,0.00003922}, {281,0.00011765}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00007843}, {287,0.00007843}, {288,0.00003922}, {289,0.00002941}, {290,0.00000000}, {291,0.00002941}, {292,0.00000000}, {293,0.00003922}, {294,0.00003922}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000}, {302,0.00000}, {303,0.00000}, {304,0.00000}, {305,0.00000}, {306,0.00000}, {307,0.00000}, {308,0.00000}, {309,0.00000}, {310,0.00000}, {311,0.00000}, {312,0.00000}, {313,0.00000}, {314,0.00000}, {315,0.00000}, {316,0.00000}, {317,0.00000}, {318,0.00000}, {319,0.00000}, {320,0.00000}, {321,0.00000}, {322,0.00000}, {323,0.00000}, {324,0.00000}, {325,0.00075}, {326,0.00000}, {327,0.00000}, {328,0.00000}, {329,0.00000}, {330,0.00000}, {331,0.00000}, {332,0.00000}, {333,0.00100}, {334,0.00000}, {335,0.00000}, {336,0.00000}, {337,0.00000}, {338,0.00000}, {339,0.00000}, {340,0.00000}, {341,0.00000}, {342,0.00000}, {343,0.00000}, {344,0.00000}, {345,0.00000}, {346,0.00000}, {347,0.00000}, {348,0.00000}, {349,0.00000}, {350,0.00000}, {351,0.00000}, {352,0.00000}, {353,0.00000}, {354,0.00000}, {355,0.00000}, {356,0.00000}, {357,0.00000}, {358,0.00000}, {359,0.00000}, {360,0.00000}, {361,0.00000}, {362,0.00000}, {363,0.00000}, {364,0.00000}, {365,0.00000}, {366,0.00000}, {367,0.00000}, {368,0.00075}, {369,0.00000}, {370,0.00000}, {371,0.00000}, {372,0.00000}, {373,0.00000}, {374,0.00000}, {375,0.00000}, {376,0.00000}, {377,0.00000}, {378,0.00000}, {379,0.00000}, {380,0.00000}, {381,0.00000}, {382,0.00000}, {383,0.00000}, {384,0.00000}, {385,0.00000}, {386,0.00000}, {387,0.00000}, {388,0.00000}, {389,0.00000}, {390,0.00000}, {391,0.00000}, {392,0.00000}, {393,0.00000}, {394,0.00000}, {395,0.00000}, {396,0.00000}, {397,0.00000}, {398,0.00000}, {399,0.00000}, {400,0.00000}, {401,0.00000}, {402,0.00000}, {403,0.00000}, {404,0.00000}, {405,0.00000}, {406,0.00000}, {407,0.00000}, {408,0.00000}, {409,0.00000}, {410,0.00000}, {411,0.00000}, {412,0.00000}, {413,0.00000}, {414,0.00000}, {415,0.00000}, {416,0.00000}, {417,0.00000}, {418,0.00000}, {419,0.00000}, {420,0.00000}, {421,0.00000}, {422,0.00000}, {423,0.00075}, {424,0.00000}, {425,0.00000}, {426,0.00000}, {427,0.00000}, {428,0.00000}, {429,0.00000}, {430,0.00000}, {431,0.00000}, {432,0.00000}, {433,0.00000}, {434,0.00000}, {435,0.00000}, {436,0.00000}, {437,0.00000}, {438,0.00000}, {439,0.00000}, {440,0.00000}, {441,0.00000}, {442,0.00000}, {443,0.00000}, {444,0.00000}, {445,0.00000}, {446,0.00000}, {447,0.00000}, {448,0.00000}, {449,0.00000}, {450,0.00000}, {451,0.00000}, {452,0.00000}, {453,0.00000}, {454,0.00000}, {455,0.00000}, {456,0.00000}, {457,0.00000}, {458,0.00000}, {459,0.00000}, {460,0.00000}, {461,0.00000}, {462,0.00000}, {463,0.00000}, {464,0.00075}, {465,0.00000}, {466,0.00000}, {467,0.00000}, {468,0.00075}, {469,0.00000}, {470,0.00000}, {471,0.00000}, {472,0.00000}, {473,0.00000}, {474,0.00000}, {475,0.00000}, {476,0.00000}, {477,0.00000}, {478,0.00000}, {479,0.00000}, {480,0.00000}, {481,0.00000}, {482,0.00000}, {483,0.00000}, {484,0.00000}, {485,0.00000}, {486,0.00000}, {487,0.00000}, {488,0.00000}, {489,0.00000}, {490,0.00000}, {491,0.00000}, {492,0.00000}, {493,0.00000}, {494,0.00000}, {495,0.00000}, {496,0.00000}, {497,0.00000}, {498,0.00000}, {499,0.00000}, {500,0.00000}, {505,0.00000}, {510,0.00000}, {515,0.00000}, {520,0.00000}, {525,0.00000}, {530,0.00000}, {535,0.00000}, {540,0.00000}, {545,0.00000}, {550,0.00000}, {555,0.00000}, {560,0.00000}, {565,0.00000}, {570,0.00000}, {575,0.00100}, {580,0.00000}, {585,0.00000}, {590,0.00000}, {595,0.00000}, {600,0.00000}, {605,0.00000}, {610,0.00000}, {615,0.00000}, {620,0.00000}, {625,0.00000}, {630,0.00000}, {635,0.00000}, {640,0.00000}, {645,0.00000}, {650,0.00000}, {655,0.00000}, {660,0.00000}, {665,0.00000}, {670,0.00000}, {675,0.00000}, {680,0.00000}, {685,0.00000}, {690,0.00000}, {695,0.00000}, {700,0.00000}, {705,0.00000}, {710,0.00000}, {715,0.00000}, {720,0.00000}, {725,0.00000}, {730,0.00000}, {735,0.00000}, {740,0.00000}, {745,0.00000}, {750,0.00000}, {755,0.00000}, {760,0.00000}, {765,0.00000}, {770,0.00000}, {775,0.00000}, {780,0.00000}, {785,0.00000}, {790,0.00000}, {795,0.00000}, {800,0.00000}, {805,0.00000}, {810,0.00000}, {815,0.00000}, {820,0.00000}, {825,0.00000}, {830,0.00075}, {835,0.00000}, {840,0.00000}, {845,0.00000}, {850,0.00000}, {855,0.00000}, {860,0.00000}, {865,0.00000}, {870,0.00000}, {875,0.00000}, {880,0.00000}, {885,0.00000}, {890,0.00000}, {895,0.00000}, {900,0.00000}, {905,0.00000}, {910,0.00000}, {915,0.00000}, {920,0.00000}, {925,0.00000}, {930,0.00000}, {935,0.00000}, {940,0.00000}, {945,0.00000}, {950,0.00000}, {955,0.00000}, {960,0.00000}, {965,0.00000}, {970,0.00000}, {975,0.00000}, {980,0.00000}, {985,0.00000}, {990,0.00000}, {995,0.00000}, {1000,0.00000}, {1010,0.00000}, {1020,0.00000}, {1030,0.00000}, {1040,0.00000}, {1050,0.00000}, {1060,0.00000}, {1070,0.00000}, {1080,0.00000}, {1090,0.00000}, {1100,0.00000}, {1110,0.00000}, {1120,0.00000}, {1130,0.00000}, {1140,0.00000}, {1150,0.00000}, {1160,0.00000}, {1170,0.00000}, {1180,0.00000}, {1190,0.00000}, {1200,0.00000}, {1210,0.00000}, {1220,0.00000}, {1230,0.00000}, {1240,0.00000}, {1250,0.00000}, {1260,0.00000}, {1270,0.00000}, {1280,0.00075}, {1290,0.00000}, {1300,0.00000}, {1310,0.00000}, {1320,0.00000}, {1330,0.00000}, {1340,0.00000}, {1350,0.00000}, {1360,0.00000}, {1370,0.00000}, {1380,0.00000}, {1390,0.00000}, {1400,0.00000}, {1410,0.00000}, {1420,0.00000}, {1430,0.00000}, {1440,0.00000}, {1450,0.00000}, {1460,0}, {1470,0}, {1480,0}, {1490,0}, {1500,0}, {1510,0}, {1520,0}, {1530,0}, {1540,0}, {1550,0}, {1560,0}, {1570,0}, {1580,0}, {1590,0}, {1600,0}, {1610,0}, {1620,0}, {1630,0}, {1640,0}, {1650,0}, {1660,0}, {1670,0}, {1680,0}, {1690,0}, {1700,0}, {1710,0}, {1720,0}, {1730,0}, {1740,0}, {1750,0}, {1760,0}, {1770,0}, {1780,0}, {1790,0}, {1800,0}, {1810,0}, {1820,0}, {1830,0}, {1840,0}, {1850,0}, {1860,0}, {1870,0}, {1880,0}, {1890,0}, {1900,0}, {1910,0}, {1920,0}, {1930,0}, {1940,0}, {1950,0}, {1960,0}, {1970,0}, {1980,0}, {1990,0}, {2000,0}, {2050,0}, {2100,0}, {2150,0}, {2200,0}, {2250,0}, {2300,0}, {2350,0}, {2400,0}, {2450,0}, {2500,0}, {2550,0}, {2600,0}, {2650,0}, {2700,0}, {2750,0}, {2800,0}, {2850,0}, {2900,0}, {2950,0}, {3000,0}, {3050,0}, {3100,0}, {3150,0}, {3200,0}, {3250,0}, {3300,0}, {3350,0}, {3400,0}, {3450,0}, {3500,0}, {3550,0}, {3600,0}, {3650,0}, {3700,0}, {3750,0}, {3800,0}, {3850,0}, {3900,0}, {3950,0}, {4000,0}, {4050,0}, {4100,0}, {4150,0}, {4200,0}, {4250,0}, {4300,0}, {4350,0}, {4400,0}, {4450,0}, {4500,0}, {4550,0}, {4600,0}, {4650,0}, {4700,0}, {4750,0}, {4800,0}, {4850,0}, {4900,0}, {4950,0}, {5000,0}, {5050,0}, {5100,0}, {5150,0}, {5200,0}, {5250,0}, {5300,0}, {5350,0}, {5400,0}, {5450,0}, {5500,0}, {5550,0}, {5600,0}, {5650,0}, {5700,0}, {5750,0}, {5800,0}, {5850,0}, {5900,0}, {5950,0}, {6000,0}};
data["big"]["Ltac2"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00003922}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000}, {302,0.00000}, {303,0.00000}, {304,0.00000}, {305,0.00000}, {306,0.00000}, {307,0.00000}, {308,0.00000}, {309,0.00000}, {310,0.00000}, {311,0.00000}, {312,0.00000}, {313,0.00000}, {314,0.00000}, {315,0.00000}, {316,0.00000}, {317,0.00000}, {318,0.00000}, {319,0.00000}, {320,0.00000}, {321,0.00000}, {322,0.00000}, {323,0.00000}, {324,0.00000}, {325,0.00000}, {326,0.00000}, {327,0.00000}, {328,0.00000}, {329,0.00000}, {330,0.00000}, {331,0.00000}, {332,0.00000}, {333,0.00000}, {334,0.00000}, {335,0.00000}, {336,0.00000}, {337,0.00000}, {338,0.00000}, {339,0.00000}, {340,0.00000}, {341,0.00000}, {342,0.00000}, {343,0.00000}, {344,0.00000}, {345,0.00000}, {346,0.00000}, {347,0.00000}, {348,0.00000}, {349,0.00000}, {350,0.00000}, {351,0.00000}, {352,0.00000}, {353,0.00000}, {354,0.00000}, {355,0.00000}, {356,0.00000}, {357,0.00000}, {358,0.00000}, {359,0.00000}, {360,0.00000}, {361,0.00000}, {362,0.00000}, {363,0.00000}, {364,0.00000}, {365,0.00000}, {366,0.00000}, {367,0.00000}, {368,0.00000}, {369,0.00000}, {370,0.00000}, {371,0.00000}, {372,0.00000}, {373,0.00000}, {374,0.00000}, {375,0.00000}, {376,0.00000}, {377,0.00000}, {378,0.00000}, {379,0.00000}, {380,0.00000}, {381,0.00000}, {382,0.00000}, {383,0.00000}, {384,0.00000}, {385,0.00000}, {386,0.00000}, {387,0.00000}, {388,0.00000}, {389,0.00000}, {390,0.00000}, {391,0.00000}, {392,0.00000}, {393,0.00000}, {394,0.00000}, {395,0.00000}, {396,0.00000}, {397,0.00000}, {398,0.00000}, {399,0.00000}, {400,0.00000}, {401,0.00000}, {402,0.00000}, {403,0.00000}, {404,0.00000}, {405,0.00000}, {406,0.00000}, {407,0.00000}, {408,0.00000}, {409,0.00000}, {410,0.00000}, {411,0.00000}, {412,0.00000}, {413,0.00000}, {414,0.00000}, {415,0.00000}, {416,0.00000}, {417,0.00000}, {418,0.00000}, {419,0.00000}, {420,0.00000}, {421,0.00000}, {422,0.00000}, {423,0.00000}, {424,0.00000}, {425,0.00000}, {426,0.00000}, {427,0.00000}, {428,0.00000}, {429,0.00000}, {430,0.00000}, {431,0.00000}, {432,0.00000}, {433,0.00000}, {434,0.00000}, {435,0.00000}, {436,0.00000}, {437,0.00000}, {438,0.00000}, {439,0.00000}, {440,0.00000}, {441,0.00000}, {442,0.00000}, {443,0.00000}, {444,0.00000}, {445,0.00000}, {446,0.00000}, {447,0.00000}, {448,0.00000}, {449,0.00000}, {450,0.00000}, {451,0.00000}, {452,0.00000}, {453,0.00000}, {454,0.00000}, {455,0.00000}, {456,0.00000}, {457,0.00000}, {458,0.00000}, {459,0.00000}, {460,0.00000}, {461,0.00000}, {462,0.00000}, {463,0.00000}, {464,0.00000}, {465,0.00000}, {466,0.00000}, {467,0.00000}, {468,0.00000}, {469,0.00000}, {470,0.00000}, {471,0.00000}, {472,0.00000}, {473,0.00000}, {474,0.00000}, {475,0.00000}, {476,0.00000}, {477,0.00000}, {478,0.00000}, {479,0.00000}, {480,0.00000}, {481,0.00000}, {482,0.00000}, {483,0.00000}, {484,0.00000}, {485,0.00000}, {486,0.00000}, {487,0.00000}, {488,0.00000}, {489,0.00000}, {490,0.00000}, {491,0.00000}, {492,0.00000}, {493,0.00000}, {494,0.00000}, {495,0.00000}, {496,0.00000}, {497,0.00000}, {498,0.00000}, {499,0.00000}, {500,0.00000}, {505,0.00000}, {510,0.00000}, {515,0.00000}, {520,0.00000}, {525,0.00000}, {530,0.00000}, {535,0.00000}, {540,0.00000}, {545,0.00000}, {550,0.00000}, {555,0.00000}, {560,0.00000}, {565,0.00000}, {570,0.00000}, {575,0.00000}, {580,0.00000}, {585,0.00000}, {590,0.00000}, {595,0.00000}, {600,0.00000}, {605,0.00000}, {610,0.00000}, {615,0.00000}, {620,0.00000}, {625,0.00000}, {630,0.00000}, {635,0.00000}, {640,0.00000}, {645,0.00000}, {650,0.00000}, {655,0.00000}, {660,0.00000}, {665,0.00000}, {670,0.00000}, {675,0.00000}, {680,0.00000}, {685,0.00000}, {690,0.00000}, {695,0.00000}, {700,0.00000}, {705,0.00000}, {710,0.00000}, {715,0.00000}, {720,0.00000}, {725,0.00000}, {730,0.00000}, {735,0.00000}, {740,0.00000}, {745,0.00000}, {750,0.00000}, {755,0.00000}, {760,0.00000}, {765,0.00000}, {770,0.00000}, {775,0.00000}, {780,0.00000}, {785,0.00000}, {790,0.00000}, {795,0.00000}, {800,0.00000}, {805,0.00000}, {810,0.00000}, {815,0.00000}, {820,0.00000}, {825,0.00000}, {830,0.00000}, {835,0.00000}, {840,0.00000}, {845,0.00000}, {850,0.00000}, {855,0.00000}, {860,0.00000}, {865,0.00000}, {870,0.00000}, {875,0.00000}, {880,0.00000}, {885,0.00000}, {890,0.00000}, {895,0.00000}, {900,0.00000}, {905,0.00000}, {910,0.00000}, {915,0.00000}, {920,0.00000}, {925,0.00000}, {930,0.00000}, {935,0.00000}, {940,0.00000}, {945,0.00000}, {950,0.00000}, {955,0.00000}, {960,0.00000}, {965,0.00000}, {970,0.00000}, {975,0.00000}, {980,0.00000}, {985,0.00000}, {990,0.00000}, {995,0.00000}, {1000,0.00000}, {1010,0.00000}, {1020,0.00000}, {1030,0.00000}, {1040,0.00000}, {1050,0.00000}, {1060,0.00000}, {1070,0.00000}, {1080,0.00000}, {1090,0.00000}, {1100,0.00000}, {1110,0.00000}, {1120,0.00000}, {1130,0.00000}, {1140,0.00000}, {1150,0.00000}, {1160,0.00000}, {1170,0.00000}, {1180,0.00000}, {1190,0.00000}, {1200,0.00000}, {1210,0.00000}, {1220,0.00000}, {1230,0.00000}, {1240,0.00000}, {1250,0.00000}, {1260,0.00000}, {1270,0.00000}, {1280,0.00000}, {1290,0.00000}, {1300,0.00000}, {1310,0.00000}, {1320,0.00000}, {1330,0.00000}, {1340,0.00000}, {1350,0.00000}, {1360,0.00000}, {1370,0.00000}, {1380,0.00000}, {1390,0.00000}, {1400,0.00000}, {1410,0.00000}, {1420,0.00000}, {1430,0.00000}, {1440,0.00000}, {1450,0.00000}, {1460,0}, {1470,0}, {1480,0}, {1490,0}, {1500,0}, {1510,0}, {1520,0}, {1530,0}, {1540,0}, {1550,0}, {1560,0}, {1570,0}, {1580,0}, {1590,0}, {1600,0}, {1610,0}, {1620,0}, {1630,0}, {1640,0}, {1650,0}, {1660,0}, {1670,0}, {1680,0}, {1690,0}, {1700,0}, {1710,0}, {1720,0}, {1730,0}, {1740,0}, {1750,0}, {1760,0}, {1770,0}, {1780,0}, {1790,0}, {1800,0}, {1810,0}, {1820,0}, {1830,0}, {1840,0}, {1850,0}, {1860,0}, {1870,0}, {1880,0}, {1890,0}, {1900,0}, {1910,0}, {1920,0}, {1930,0}, {1940,0}, {1950,0}, {1960,0}, {1970,0}, {1980,0}, {1990,0}, {2000,0}, {2050,0}, {2100,0}, {2150,0}, {2200,0}, {2250,0}, {2300,0}, {2350,0}, {2400,0}, {2450,0}, {2500,0}, {2550,0}, {2600,0}, {2650,0}, {2700,0}, {2750,0}, {2800,0}, {2850,0}, {2900,0}, {2950,0}, {3000,0}, {3050,0}, {3100,0}, {3150,0}, {3200,0}, {3250,0}, {3300,0}, {3350,0}, {3400,0}, {3450,0}, {3500,0}, {3550,0}, {3600,0}, {3650,0}, {3700,0}, {3750,0}, {3800,0}, {3850,0}, {3900,0}, {3950,0}, {4000,0}, {4050,0}, {4100,0}, {4150,0}, {4200,0}, {4250,0}, {4300,0}, {4350,0}, {4400,0}, {4450,0}, {4500,0}, {4550,0}, {4600,0}, {4650,0}, {4700,0}, {4750,0}, {4800,0}, {4850,0}, {4900,0}, {4950,0}, {5000,0}, {5050,0}, {5100,0}, {5150,0}, {5200,0}, {5250,0}, {5300,0}, {5350,0}, {5400,0}, {5450,0}, {5500,0}, {5550,0}, {5600,0}, {5650,0}, {5700,0}, {5750,0}, {5800,0}, {5850,0}, {5900,0}, {5950,0}, {6000,0}};
data["big"]["Ltac2"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000}, {302,0.00000}, {303,0.00000}, {304,0.00000}, {305,0.00000}, {306,0.00000}, {307,0.00000}, {308,0.00000}, {309,0.00000}, {310,0.00000}, {311,0.00000}, {312,0.00000}, {313,0.00000}, {314,0.00000}, {315,0.00000}, {316,0.00000}, {317,0.00000}, {318,0.00000}, {319,0.00000}, {320,0.00000}, {321,0.00000}, {322,0.00000}, {323,0.00000}, {324,0.00000}, {325,0.00000}, {326,0.00000}, {327,0.00000}, {328,0.00000}, {329,0.00000}, {330,0.00000}, {331,0.00000}, {332,0.00000}, {333,0.00000}, {334,0.00000}, {335,0.00000}, {336,0.00000}, {337,0.00000}, {338,0.00000}, {339,0.00000}, {340,0.00000}, {341,0.00000}, {342,0.00000}, {343,0.00000}, {344,0.00000}, {345,0.00000}, {346,0.00000}, {347,0.00000}, {348,0.00000}, {349,0.00000}, {350,0.00000}, {351,0.00000}, {352,0.00000}, {353,0.00000}, {354,0.00000}, {355,0.00000}, {356,0.00000}, {357,0.00000}, {358,0.00000}, {359,0.00000}, {360,0.00000}, {361,0.00000}, {362,0.00000}, {363,0.00000}, {364,0.00000}, {365,0.00000}, {366,0.00000}, {367,0.00000}, {368,0.00000}, {369,0.00000}, {370,0.00000}, {371,0.00000}, {372,0.00000}, {373,0.00000}, {374,0.00000}, {375,0.00000}, {376,0.00000}, {377,0.00000}, {378,0.00000}, {379,0.00000}, {380,0.00000}, {381,0.00000}, {382,0.00000}, {383,0.00000}, {384,0.00000}, {385,0.00000}, {386,0.00000}, {387,0.00000}, {388,0.00000}, {389,0.00000}, {390,0.00000}, {391,0.00000}, {392,0.00000}, {393,0.00000}, {394,0.00000}, {395,0.00000}, {396,0.00000}, {397,0.00000}, {398,0.00000}, {399,0.00000}, {400,0.00000}, {401,0.00000}, {402,0.00000}, {403,0.00000}, {404,0.00000}, {405,0.00000}, {406,0.00000}, {407,0.00000}, {408,0.00000}, {409,0.00000}, {410,0.00000}, {411,0.00000}, {412,0.00000}, {413,0.00000}, {414,0.00000}, {415,0.00000}, {416,0.00000}, {417,0.00000}, {418,0.00000}, {419,0.00000}, {420,0.00000}, {421,0.00000}, {422,0.00000}, {423,0.00000}, {424,0.00000}, {425,0.00000}, {426,0.00000}, {427,0.00000}, {428,0.00000}, {429,0.00000}, {430,0.00000}, {431,0.00000}, {432,0.00000}, {433,0.00000}, {434,0.00000}, {435,0.00000}, {436,0.00000}, {437,0.00000}, {438,0.00000}, {439,0.00000}, {440,0.00000}, {441,0.00000}, {442,0.00000}, {443,0.00000}, {444,0.00000}, {445,0.00000}, {446,0.00000}, {447,0.00000}, {448,0.00000}, {449,0.00000}, {450,0.00000}, {451,0.00000}, {452,0.00000}, {453,0.00000}, {454,0.00000}, {455,0.00000}, {456,0.00000}, {457,0.00000}, {458,0.00000}, {459,0.00000}, {460,0.00000}, {461,0.00000}, {462,0.00000}, {463,0.00000}, {464,0.00000}, {465,0.00000}, {466,0.00000}, {467,0.00000}, {468,0.00000}, {469,0.00000}, {470,0.00000}, {471,0.00000}, {472,0.00000}, {473,0.00000}, {474,0.00000}, {475,0.00000}, {476,0.00000}, {477,0.00000}, {478,0.00000}, {479,0.00000}, {480,0.00000}, {481,0.00000}, {482,0.00000}, {483,0.00000}, {484,0.00000}, {485,0.00000}, {486,0.00000}, {487,0.00000}, {488,0.00000}, {489,0.00000}, {490,0.00000}, {491,0.00000}, {492,0.00000}, {493,0.00000}, {494,0.00000}, {495,0.00000}, {496,0.00000}, {497,0.00000}, {498,0.00000}, {499,0.00000}, {500,0.00000}, {505,0.00000}, {510,0.00000}, {515,0.00000}, {520,0.00000}, {525,0.00000}, {530,0.00000}, {535,0.00000}, {540,0.00000}, {545,0.00000}, {550,0.00000}, {555,0.00000}, {560,0.00000}, {565,0.00000}, {570,0.00000}, {575,0.00000}, {580,0.00000}, {585,0.00000}, {590,0.00000}, {595,0.00000}, {600,0.00000}, {605,0.00000}, {610,0.00000}, {615,0.00000}, {620,0.00000}, {625,0.00000}, {630,0.00000}, {635,0.00000}, {640,0.00000}, {645,0.00000}, {650,0.00000}, {655,0.00000}, {660,0.00000}, {665,0.00000}, {670,0.00000}, {675,0.00000}, {680,0.00000}, {685,0.00000}, {690,0.00000}, {695,0.00000}, {700,0.00000}, {705,0.00000}, {710,0.00000}, {715,0.00000}, {720,0.00000}, {725,0.00000}, {730,0.00000}, {735,0.00000}, {740,0.00000}, {745,0.00000}, {750,0.00000}, {755,0.00000}, {760,0.00000}, {765,0.00000}, {770,0.00000}, {775,0.00000}, {780,0.00000}, {785,0.00000}, {790,0.00000}, {795,0.00000}, {800,0.00000}, {805,0.00000}, {810,0.00000}, {815,0.00000}, {820,0.00000}, {825,0.00000}, {830,0.00000}, {835,0.00000}, {840,0.00000}, {845,0.00000}, {850,0.00000}, {855,0.00000}, {860,0.00000}, {865,0.00000}, {870,0.00000}, {875,0.00000}, {880,0.00000}, {885,0.00000}, {890,0.00000}, {895,0.00000}, {900,0.00000}, {905,0.00000}, {910,0.00000}, {915,0.00000}, {920,0.00000}, {925,0.00000}, {930,0.00000}, {935,0.00000}, {940,0.00000}, {945,0.00000}, {950,0.00000}, {955,0.00000}, {960,0.00000}, {965,0.00000}, {970,0.00000}, {975,0.00000}, {980,0.00000}, {985,0.00000}, {990,0.00000}, {995,0.00000}, {1000,0.00000}, {1010,0.00000}, {1020,0.00000}, {1030,0.00000}, {1040,0.00000}, {1050,0.00000}, {1060,0.00000}, {1070,0.00000}, {1080,0.00000}, {1090,0.00000}, {1100,0.00000}, {1110,0.00000}, {1120,0.00000}, {1130,0.00000}, {1140,0.00000}, {1150,0.00000}, {1160,0.00000}, {1170,0.00000}, {1180,0.00000}, {1190,0.00000}, {1200,0.00000}, {1210,0.00000}, {1220,0.00000}, {1230,0.00000}, {1240,0.00000}, {1250,0.00000}, {1260,0.00000}, {1270,0.00000}, {1280,0.00000}, {1290,0.00000}, {1300,0.00000}, {1310,0.00000}, {1320,0.00000}, {1330,0.00000}, {1340,0.00000}, {1350,0.00000}, {1360,0.00000}, {1370,0.00000}, {1380,0.00000}, {1390,0.00000}, {1400,0.00000}, {1410,0.00000}, {1420,0.00000}, {1430,0.00000}, {1440,0.00000}, {1450,0.00000}, {1460,0}, {1470,0}, {1480,0}, {1490,0}, {1500,0}, {1510,0}, {1520,0}, {1530,0}, {1540,0}, {1550,0}, {1560,0}, {1570,0}, {1580,0}, {1590,0}, {1600,0}, {1610,0}, {1620,0}, {1630,0}, {1640,0}, {1650,0}, {1660,0}, {1670,0}, {1680,0}, {1690,0}, {1700,0}, {1710,0}, {1720,0}, {1730,0}, {1740,0}, {1750,0}, {1760,0}, {1770,0}, {1780,0}, {1790,0}, {1800,0}, {1810,0}, {1820,0}, {1830,0}, {1840,0}, {1850,0}, {1860,0}, {1870,0}, {1880,0}, {1890,0}, {1900,0}, {1910,0}, {1920,0}, {1930,0}, {1940,0}, {1950,0}, {1960,0}, {1970,0}, {1980,0}, {1990,0}, {2000,0}, {2050,0}, {2100,0}, {2150,0}, {2200,0}, {2250,0}, {2300,0}, {2350,0}, {2400,0}, {2450,0}, {2500,0}, {2550,0}, {2600,0}, {2650,0}, {2700,0}, {2750,0}, {2800,0}, {2850,0}, {2900,0}, {2950,0}, {3000,0}, {3050,0}, {3100,0}, {3150,0}, {3200,0}, {3250,0}, {3300,0}, {3350,0}, {3400,0}, {3450,0}, {3500,0}, {3550,0}, {3600,0}, {3650,0}, {3700,0}, {3750,0}, {3800,0}, {3850,0}, {3900,0}, {3950,0}, {4000,0}, {4050,0}, {4100,0}, {4150,0}, {4200,0}, {4250,0}, {4300,0}, {4350,0}, {4400,0}, {4450,0}, {4500,0}, {4550,0}, {4600,0}, {4650,0}, {4700,0}, {4750,0}, {4800,0}, {4850,0}, {4900,0}, {4950,0}, {5000,0}, {5050,0}, {5100,0}, {5150,0}, {5200,0}, {5250,0}, {5300,0}, {5350,0}, {5400,0}, {5450,0}, {5500,0}, {5550,0}, {5600,0}, {5650,0}, {5700,0}, {5750,0}, {5800,0}, {5850,0}, {5900,0}, {5950,0}, {6000,0}};
data["big"]["Ltac2"]["pre"]["user"] = {{1,0.00002941}, {2,0.00002941}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00003922}, {49,0.00003922}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00003922}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00003922}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00002941}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00003922}, {84,0.00000000}, {85,0.00003922}, {86,0.00000000}, {87,0.00000000}, {88,0.00003922}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00003922}, {95,0.00002941}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00006863}, {107,0.00000000}, {108,0.00003922}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00002941}, {117,0.00000000}, {118,0.00000000}, {119,0.00003922}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00003922}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00003922}, {141,0.00000000}, {142,0.00003922}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00003922}, {148,0.00003922}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00003922}, {161,0.00000000}, {162,0.00000000}, {163,0.00003922}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00003922}, {174,0.00000000}, {175,0.00003922}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00003922}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00003922}, {218,0.00007843}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00003922}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00003922}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00003922}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00007843}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00003922}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00003922}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00003922}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00003922}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000}, {302,0.00000}, {303,0.00000}, {304,0.00000}, {305,0.00000}, {306,0.00000}, {307,0.00000}, {308,0.00000}, {309,0.00000}, {310,0.00000}, {311,0.00000}, {312,0.00000}, {313,0.00000}, {314,0.00000}, {315,0.00000}, {316,0.00000}, {317,0.00000}, {318,0.00000}, {319,0.00000}, {320,0.00000}, {321,0.00000}, {322,0.00000}, {323,0.00000}, {324,0.00000}, {325,0.00000}, {326,0.00000}, {327,0.00000}, {328,0.00000}, {329,0.00000}, {330,0.00000}, {331,0.00000}, {332,0.00000}, {333,0.00000}, {334,0.00000}, {335,0.00000}, {336,0.00000}, {337,0.00000}, {338,0.00000}, {339,0.00000}, {340,0.00000}, {341,0.00000}, {342,0.00000}, {343,0.00000}, {344,0.00000}, {345,0.00000}, {346,0.00000}, {347,0.00000}, {348,0.00000}, {349,0.00000}, {350,0.00000}, {351,0.00000}, {352,0.00000}, {353,0.00000}, {354,0.00000}, {355,0.00000}, {356,0.00000}, {357,0.00000}, {358,0.00000}, {359,0.00000}, {360,0.00000}, {361,0.00000}, {362,0.00000}, {363,0.00000}, {364,0.00000}, {365,0.00000}, {366,0.00000}, {367,0.00000}, {368,0.00000}, {369,0.00000}, {370,0.00000}, {371,0.00000}, {372,0.00000}, {373,0.00000}, {374,0.00000}, {375,0.00000}, {376,0.00000}, {377,0.00000}, {378,0.00000}, {379,0.00000}, {380,0.00000}, {381,0.00000}, {382,0.00000}, {383,0.00000}, {384,0.00000}, {385,0.00000}, {386,0.00000}, {387,0.00000}, {388,0.00000}, {389,0.00000}, {390,0.00000}, {391,0.00000}, {392,0.00000}, {393,0.00000}, {394,0.00000}, {395,0.00000}, {396,0.00000}, {397,0.00000}, {398,0.00000}, {399,0.00000}, {400,0.00000}, {401,0.00000}, {402,0.00000}, {403,0.00000}, {404,0.00000}, {405,0.00000}, {406,0.00000}, {407,0.00000}, {408,0.00000}, {409,0.00000}, {410,0.00000}, {411,0.00000}, {412,0.00000}, {413,0.00000}, {414,0.00000}, {415,0.00000}, {416,0.00000}, {417,0.00000}, {418,0.00000}, {419,0.00000}, {420,0.00000}, {421,0.00000}, {422,0.00000}, {423,0.00000}, {424,0.00000}, {425,0.00000}, {426,0.00000}, {427,0.00000}, {428,0.00000}, {429,0.00000}, {430,0.00000}, {431,0.00000}, {432,0.00000}, {433,0.00000}, {434,0.00000}, {435,0.00000}, {436,0.00000}, {437,0.00000}, {438,0.00000}, {439,0.00000}, {440,0.00000}, {441,0.00000}, {442,0.00000}, {443,0.00000}, {444,0.00000}, {445,0.00000}, {446,0.00000}, {447,0.00000}, {448,0.00000}, {449,0.00000}, {450,0.00000}, {451,0.00000}, {452,0.00000}, {453,0.00000}, {454,0.00000}, {455,0.00000}, {456,0.00000}, {457,0.00000}, {458,0.00000}, {459,0.00000}, {460,0.00000}, {461,0.00000}, {462,0.00000}, {463,0.00000}, {464,0.00000}, {465,0.00000}, {466,0.00000}, {467,0.00000}, {468,0.00000}, {469,0.00000}, {470,0.00000}, {471,0.00000}, {472,0.00000}, {473,0.00000}, {474,0.00000}, {475,0.00000}, {476,0.00000}, {477,0.00000}, {478,0.00000}, {479,0.00000}, {480,0.00000}, {481,0.00000}, {482,0.00000}, {483,0.00000}, {484,0.00000}, {485,0.00000}, {486,0.00000}, {487,0.00000}, {488,0.00000}, {489,0.00000}, {490,0.00000}, {491,0.00000}, {492,0.00000}, {493,0.00000}, {494,0.00000}, {495,0.00000}, {496,0.00000}, {497,0.00000}, {498,0.00000}, {499,0.00000}, {500,0.00000}, {505,0.00000}, {510,0.00000}, {515,0.00000}, {520,0.00000}, {525,0.00000}, {530,0.00000}, {535,0.00000}, {540,0.00000}, {545,0.00000}, {550,0.00000}, {555,0.00000}, {560,0.00000}, {565,0.00000}, {570,0.00000}, {575,0.00000}, {580,0.00000}, {585,0.00000}, {590,0.00000}, {595,0.00000}, {600,0.00000}, {605,0.00000}, {610,0.00000}, {615,0.00000}, {620,0.00000}, {625,0.00000}, {630,0.00000}, {635,0.00000}, {640,0.00000}, {645,0.00000}, {650,0.00000}, {655,0.00000}, {660,0.00000}, {665,0.00000}, {670,0.00000}, {675,0.00000}, {680,0.00000}, {685,0.00000}, {690,0.00000}, {695,0.00000}, {700,0.00000}, {705,0.00000}, {710,0.00000}, {715,0.00000}, {720,0.00000}, {725,0.00000}, {730,0.00000}, {735,0.00000}, {740,0.00000}, {745,0.00000}, {750,0.00000}, {755,0.00000}, {760,0.00000}, {765,0.00000}, {770,0.00000}, {775,0.00000}, {780,0.00000}, {785,0.00000}, {790,0.00000}, {795,0.00000}, {800,0.00000}, {805,0.00000}, {810,0.00000}, {815,0.00000}, {820,0.00000}, {825,0.00000}, {830,0.00000}, {835,0.00000}, {840,0.00000}, {845,0.00000}, {850,0.00000}, {855,0.00000}, {860,0.00000}, {865,0.00000}, {870,0.00000}, {875,0.00000}, {880,0.00000}, {885,0.00000}, {890,0.00000}, {895,0.00000}, {900,0.00000}, {905,0.00000}, {910,0.00000}, {915,0.00000}, {920,0.00000}, {925,0.00000}, {930,0.00000}, {935,0.00000}, {940,0.00000}, {945,0.00000}, {950,0.00000}, {955,0.00000}, {960,0.00000}, {965,0.00000}, {970,0.00000}, {975,0.00000}, {980,0.00000}, {985,0.00000}, {990,0.00000}, {995,0.00000}, {1000,0.00000}, {1010,0.00000}, {1020,0.00000}, {1030,0.00000}, {1040,0.00000}, {1050,0.00000}, {1060,0.00000}, {1070,0.00000}, {1080,0.00000}, {1090,0.00000}, {1100,0.00000}, {1110,0.00000}, {1120,0.00000}, {1130,0.00000}, {1140,0.00000}, {1150,0.00000}, {1160,0.00000}, {1170,0.00000}, {1180,0.00000}, {1190,0.00000}, {1200,0.00000}, {1210,0.00000}, {1220,0.00000}, {1230,0.00000}, {1240,0.00000}, {1250,0.00000}, {1260,0.00000}, {1270,0.00000}, {1280,0.00000}, {1290,0.00000}, {1300,0.00000}, {1310,0.00000}, {1320,0.00000}, {1330,0.00000}, {1340,0.00000}, {1350,0.00000}, {1360,0.00000}, {1370,0.00000}, {1380,0.00000}, {1390,0.00000}, {1400,0.00000}, {1410,0.00000}, {1420,0.00000}, {1430,0.00000}, {1440,0.00000}, {1450,0.00000}, {1460,0}, {1470,0}, {1480,0}, {1490,0}, {1500,0}, {1510,0}, {1520,0}, {1530,0}, {1540,0}, {1550,0}, {1560,0}, {1570,0}, {1580,0}, {1590,0}, {1600,0}, {1610,0}, {1620,0}, {1630,0}, {1640,0}, {1650,0}, {1660,0}, {1670,0}, {1680,0}, {1690,0}, {1700,0}, {1710,0}, {1720,0}, {1730,0}, {1740,0}, {1750,0}, {1760,0}, {1770,0}, {1780,0}, {1790,0}, {1800,0}, {1810,0}, {1820,0}, {1830,0}, {1840,0}, {1850,0}, {1860,0}, {1870,0}, {1880,0}, {1890,0}, {1900,0}, {1910,0}, {1920,0}, {1930,0}, {1940,0}, {1950,0}, {1960,0}, {1970,0}, {1980,0}, {1990,0}, {2000,0}, {2050,0}, {2100,0}, {2150,0}, {2200,0}, {2250,0}, {2300,0}, {2350,0}, {2400,0}, {2450,0}, {2500,0}, {2550,0}, {2600,0}, {2650,0}, {2700,0}, {2750,0}, {2800,0}, {2850,0}, {2900,0}, {2950,0}, {3000,0}, {3050,0}, {3100,0}, {3150,0}, {3200,0}, {3250,0}, {3300,0}, {3350,0}, {3400,0}, {3450,0}, {3500,0}, {3550,0}, {3600,0}, {3650,0}, {3700,0}, {3750,0}, {3800,0}, {3850,0}, {3900,0}, {3950,0}, {4000,0}, {4050,0}, {4100,0}, {4150,0}, {4200,0}, {4250,0}, {4300,0}, {4350,0}, {4400,0}, {4450,0}, {4500,0}, {4550,0}, {4600,0}, {4650,0}, {4700,0}, {4750,0}, {4800,0}, {4850,0}, {4900,0}, {4950,0}, {5000,0}, {5050,0}, {5100,0}, {5150,0}, {5200,0}, {5250,0}, {5300,0}, {5350,0}, {5400,0}, {5450,0}, {5500,0}, {5550,0}, {5600,0}, {5650,0}, {5700,0}, {5750,0}, {5800,0}, {5850,0}, {5900,0}, {5950,0}, {6000,0}};
data["big"]["Ltac2"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003922}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000}, {302,0.00000}, {303,0.00000}, {304,0.00000}, {305,0.00000}, {306,0.00000}, {307,0.00000}, {308,0.00000}, {309,0.00000}, {310,0.00000}, {311,0.00000}, {312,0.00000}, {313,0.00000}, {314,0.00000}, {315,0.00000}, {316,0.00000}, {317,0.00000}, {318,0.00000}, {319,0.00000}, {320,0.00000}, {321,0.00000}, {322,0.00000}, {323,0.00000}, {324,0.00000}, {325,0.00000}, {326,0.00000}, {327,0.00000}, {328,0.00000}, {329,0.00000}, {330,0.00000}, {331,0.00000}, {332,0.00000}, {333,0.00000}, {334,0.00000}, {335,0.00000}, {336,0.00000}, {337,0.00000}, {338,0.00000}, {339,0.00000}, {340,0.00000}, {341,0.00000}, {342,0.00000}, {343,0.00000}, {344,0.00000}, {345,0.00000}, {346,0.00000}, {347,0.00000}, {348,0.00000}, {349,0.00000}, {350,0.00000}, {351,0.00000}, {352,0.00000}, {353,0.00000}, {354,0.00000}, {355,0.00000}, {356,0.00000}, {357,0.00000}, {358,0.00000}, {359,0.00000}, {360,0.00000}, {361,0.00000}, {362,0.00000}, {363,0.00000}, {364,0.00000}, {365,0.00000}, {366,0.00000}, {367,0.00000}, {368,0.00000}, {369,0.00000}, {370,0.00000}, {371,0.00000}, {372,0.00000}, {373,0.00000}, {374,0.00000}, {375,0.00000}, {376,0.00000}, {377,0.00000}, {378,0.00000}, {379,0.00000}, {380,0.00000}, {381,0.00000}, {382,0.00000}, {383,0.00000}, {384,0.00000}, {385,0.00000}, {386,0.00000}, {387,0.00000}, {388,0.00000}, {389,0.00000}, {390,0.00000}, {391,0.00000}, {392,0.00000}, {393,0.00000}, {394,0.00000}, {395,0.00000}, {396,0.00000}, {397,0.00000}, {398,0.00000}, {399,0.00000}, {400,0.00000}, {401,0.00000}, {402,0.00000}, {403,0.00000}, {404,0.00000}, {405,0.00000}, {406,0.00000}, {407,0.00000}, {408,0.00000}, {409,0.00000}, {410,0.00000}, {411,0.00000}, {412,0.00000}, {413,0.00000}, {414,0.00000}, {415,0.00000}, {416,0.00000}, {417,0.00000}, {418,0.00000}, {419,0.00000}, {420,0.00000}, {421,0.00000}, {422,0.00000}, {423,0.00000}, {424,0.00000}, {425,0.00000}, {426,0.00000}, {427,0.00000}, {428,0.00000}, {429,0.00000}, {430,0.00000}, {431,0.00000}, {432,0.00000}, {433,0.00000}, {434,0.00000}, {435,0.00000}, {436,0.00000}, {437,0.00000}, {438,0.00000}, {439,0.00000}, {440,0.00000}, {441,0.00000}, {442,0.00000}, {443,0.00000}, {444,0.00000}, {445,0.00000}, {446,0.00000}, {447,0.00000}, {448,0.00000}, {449,0.00000}, {450,0.00000}, {451,0.00000}, {452,0.00000}, {453,0.00000}, {454,0.00000}, {455,0.00000}, {456,0.00000}, {457,0.00000}, {458,0.00000}, {459,0.00000}, {460,0.00000}, {461,0.00000}, {462,0.00000}, {463,0.00000}, {464,0.00000}, {465,0.00000}, {466,0.00000}, {467,0.00000}, {468,0.00000}, {469,0.00000}, {470,0.00000}, {471,0.00000}, {472,0.00000}, {473,0.00000}, {474,0.00000}, {475,0.00000}, {476,0.00000}, {477,0.00000}, {478,0.00000}, {479,0.00000}, {480,0.00000}, {481,0.00000}, {482,0.00000}, {483,0.00000}, {484,0.00000}, {485,0.00000}, {486,0.00000}, {487,0.00000}, {488,0.00000}, {489,0.00000}, {490,0.00000}, {491,0.00000}, {492,0.00000}, {493,0.00000}, {494,0.00000}, {495,0.00000}, {496,0.00000}, {497,0.00000}, {498,0.00000}, {499,0.00000}, {500,0.00000}, {505,0.00000}, {510,0.00000}, {515,0.00000}, {520,0.00000}, {525,0.00000}, {530,0.00000}, {535,0.00000}, {540,0.00000}, {545,0.00000}, {550,0.00000}, {555,0.00000}, {560,0.00000}, {565,0.00000}, {570,0.00000}, {575,0.00000}, {580,0.00000}, {585,0.00000}, {590,0.00000}, {595,0.00000}, {600,0.00000}, {605,0.00000}, {610,0.00000}, {615,0.00000}, {620,0.00000}, {625,0.00000}, {630,0.00000}, {635,0.00000}, {640,0.00000}, {645,0.00000}, {650,0.00000}, {655,0.00000}, {660,0.00000}, {665,0.00000}, {670,0.00000}, {675,0.00000}, {680,0.00000}, {685,0.00000}, {690,0.00000}, {695,0.00000}, {700,0.00000}, {705,0.00000}, {710,0.00000}, {715,0.00000}, {720,0.00000}, {725,0.00000}, {730,0.00000}, {735,0.00000}, {740,0.00000}, {745,0.00000}, {750,0.00000}, {755,0.00000}, {760,0.00000}, {765,0.00000}, {770,0.00000}, {775,0.00000}, {780,0.00000}, {785,0.00000}, {790,0.00000}, {795,0.00000}, {800,0.00000}, {805,0.00000}, {810,0.00000}, {815,0.00000}, {820,0.00000}, {825,0.00000}, {830,0.00000}, {835,0.00000}, {840,0.00000}, {845,0.00000}, {850,0.00000}, {855,0.00000}, {860,0.00000}, {865,0.00000}, {870,0.00000}, {875,0.00000}, {880,0.00000}, {885,0.00000}, {890,0.00000}, {895,0.00000}, {900,0.00000}, {905,0.00000}, {910,0.00000}, {915,0.00000}, {920,0.00000}, {925,0.00000}, {930,0.00000}, {935,0.00000}, {940,0.00000}, {945,0.00000}, {950,0.00000}, {955,0.00000}, {960,0.00000}, {965,0.00000}, {970,0.00000}, {975,0.00000}, {980,0.00000}, {985,0.00000}, {990,0.00000}, {995,0.00000}, {1000,0.00000}, {1010,0.00000}, {1020,0.00000}, {1030,0.00000}, {1040,0.00000}, {1050,0.00000}, {1060,0.00000}, {1070,0.00000}, {1080,0.00000}, {1090,0.00000}, {1100,0.00000}, {1110,0.00000}, {1120,0.00000}, {1130,0.00000}, {1140,0.00000}, {1150,0.00000}, {1160,0.00000}, {1170,0.00000}, {1180,0.00000}, {1190,0.00000}, {1200,0.00000}, {1210,0.00000}, {1220,0.00000}, {1230,0.00000}, {1240,0.00000}, {1250,0.00000}, {1260,0.00000}, {1270,0.00000}, {1280,0.00000}, {1290,0.00000}, {1300,0.00000}, {1310,0.00000}, {1320,0.00000}, {1330,0.00000}, {1340,0.00000}, {1350,0.00000}, {1360,0.00000}, {1370,0.00000}, {1380,0.00000}, {1390,0.00000}, {1400,0.00000}, {1410,0.00000}, {1420,0.00000}, {1430,0.00000}, {1440,0.00000}, {1450,0.00000}, {1460,0}, {1470,0}, {1480,0}, {1490,0}, {1500,0}, {1510,0}, {1520,0}, {1530,0}, {1540,0}, {1550,0}, {1560,0}, {1570,0}, {1580,0}, {1590,0}, {1600,0}, {1610,0}, {1620,0}, {1630,0}, {1640,0}, {1650,0}, {1660,0}, {1670,0}, {1680,0}, {1690,0}, {1700,0}, {1710,0}, {1720,0}, {1730,0}, {1740,0}, {1750,0}, {1760,0}, {1770,0}, {1780,0}, {1790,0}, {1800,0}, {1810,0}, {1820,0}, {1830,0}, {1840,0}, {1850,0}, {1860,0}, {1870,0}, {1880,0}, {1890,0}, {1900,0}, {1910,0}, {1920,0}, {1930,0}, {1940,0}, {1950,0}, {1960,0}, {1970,0}, {1980,0}, {1990,0}, {2000,0}, {2050,0}, {2100,0}, {2150,0}, {2200,0}, {2250,0}, {2300,0}, {2350,0}, {2400,0}, {2450,0}, {2500,0}, {2550,0}, {2600,0}, {2650,0}, {2700,0}, {2750,0}, {2800,0}, {2850,0}, {2900,0}, {2950,0}, {3000,0}, {3050,0}, {3100,0}, {3150,0}, {3200,0}, {3250,0}, {3300,0}, {3350,0}, {3400,0}, {3450,0}, {3500,0}, {3550,0}, {3600,0}, {3650,0}, {3700,0}, {3750,0}, {3800,0}, {3850,0}, {3900,0}, {3950,0}, {4000,0}, {4050,0}, {4100,0}, {4150,0}, {4200,0}, {4250,0}, {4300,0}, {4350,0}, {4400,0}, {4450,0}, {4500,0}, {4550,0}, {4600,0}, {4650,0}, {4700,0}, {4750,0}, {4800,0}, {4850,0}, {4900,0}, {4950,0}, {5000,0}, {5050,0}, {5100,0}, {5150,0}, {5200,0}, {5250,0}, {5300,0}, {5350,0}, {5400,0}, {5450,0}, {5500,0}, {5550,0}, {5600,0}, {5650,0}, {5700,0}, {5750,0}, {5800,0}, {5850,0}, {5900,0}, {5950,0}, {6000,0}};
data["big"]["Ltac2"]["reif"]["real"] = {{1,0.00100000}, {2,0.00100000}, {3,0.00100000}, {4,0.00196078}, {5,0.00200000}, {6,0.00236275}, {7,0.00300000}, {8,0.00375490}, {9,0.00412745}, {10,0.00500000}, {11,0.00554902}, {12,0.00607843}, {13,0.00710784}, {14,0.00807843}, {15,0.00905882}, {16,0.00996078}, {17,0.01663725}, {18,0.01167647}, {19,0.01280392}, {20,0.01396078}, {21,0.01500980}, {22,0.01612745}, {23,0.01720588}, {24,0.02068627}, {25,0.01996078}, {26,0.02123529}, {27,0.02249020}, {28,0.02397059}, {29,0.02769608}, {30,0.02686275}, {31,0.02822549}, {32,0.03003922}, {33,0.03325490}, {34,0.03327451}, {35,0.03498039}, {36,0.03978431}, {37,0.03852941}, {38,0.04036275}, {39,0.04214706}, {40,0.04411765}, {41,0.04899020}, {42,0.04816667}, {43,0.05372549}, {44,0.05228431}, {45,0.05811765}, {46,0.05668627}, {47,0.06257843}, {48,0.06143137}, {49,0.06639216}, {50,0.07059804}, {51,0.06835294}, {52,0.07431373}, {53,0.07757843}, {54,0.07603922}, {55,0.08228431}, {56,0.08589216}, {57,0.08839216}, {58,0.08661765}, {59,0.09109804}, {60,0.09725490}, {61,0.09967647}, {62,0.10276471}, {63,0.10584314}, {64,0.10909804}, {65,0.11199020}, {66,0.11512745}, {67,0.11825490}, {68,0.12204902}, {69,0.12487255}, {70,0.12850000}, {71,0.13326471}, {72,0.13567647}, {73,0.13910784}, {74,0.14248039}, {75,0.14680392}, {76,0.15097059}, {77,0.15300980}, {78,0.15778431}, {79,0.16035294}, {80,0.16503922}, {81,0.16841176}, {82,0.17303922}, {83,0.17664706}, {84,0.18092157}, {85,0.18465686}, {86,0.18878431}, {87,0.19355882}, {88,0.19827451}, {89,0.20198039}, {90,0.20571569}, {91,0.21023529}, {92,0.21531373}, {93,0.21966667}, {94,0.22412745}, {95,0.22824510}, {96,0.23232353}, {97,0.23672549}, {98,0.24167647}, {99,0.24632353}, {100,0.25073529}, {101,0.25569608}, {102,0.26098039}, {103,0.26662745}, {104,0.27075490}, {105,0.27585294}, {106,0.28045098}, {107,0.28463725}, {108,0.29076471}, {109,0.29507843}, {110,0.30037255}, {111,0.30607843}, {112,0.31108824}, {113,0.31624510}, {114,0.32113725}, {115,0.32717647}, {116,0.33215686}, {117,0.33803922}, {118,0.34314706}, {119,0.34848039}, {120,0.35378431}, {121,0.35995098}, {122,0.36912745}, {123,0.37238235}, {124,0.37800000}, {125,0.38312745}, {126,0.38869608}, {127,0.39478431}, {128,0.40102941}, {129,0.40801961}, {130,0.41549020}, {131,0.42118627}, {132,0.42752941}, {133,0.43410784}, {134,0.43930392}, {135,0.44669608}, {136,0.45447059}, {137,0.46048039}, {138,0.46798039}, {139,0.47401961}, {140,0.48047059}, {141,0.48689216}, {142,0.49145098}, {143,0.50192157}, {144,0.50968627}, {145,0.51640196}, {146,0.52543137}, {147,0.52805882}, {148,0.53527451}, {149,0.54266667}, {150,0.55373529}, {151,0.56579412}, {152,0.57392157}, {153,0.58127451}, {154,0.58478431}, {155,0.58719608}, {156,0.59439216}, {157,0.60254902}, {158,0.61038235}, {159,0.61883333}, {160,0.62527451}, {161,0.63344118}, {162,0.64055882}, {163,0.66049020}, {164,0.65806863}, {165,0.66667647}, {166,0.67326471}, {167,0.68285294}, {168,0.69047059}, {169,0.69577451}, {170,0.71087255}, {171,0.71274510}, {172,0.72112745}, {173,0.73123529}, {174,0.74203922}, {175,0.74634314}, {176,0.75931373}, {177,0.76204902}, {178,0.77062745}, {179,0.77938235}, {180,0.78917647}, {181,0.79822549}, {182,0.80544118}, {183,0.81332353}, {184,0.82479412}, {185,0.83351961}, {186,0.84166667}, {187,0.85018627}, {188,0.85881373}, {189,0.86895098}, {190,0.87185294}, {191,0.88556863}, {192,0.89741176}, {193,0.90656863}, {194,0.91251961}, {195,0.92129412}, {196,0.92972549}, {197,0.93837255}, {198,0.94943137}, {199,0.96093137}, {200,0.96955882}, {201,0.97824510}, {202,0.98791176}, {203,0.99617647}, {204,1.00203922}, {205,1.01969608}, {206,1.02895098}, {207,1.03823529}, {208,1.04860784}, {209,1.04997059}, {210,1.06711765}, {211,1.08860784}, {212,1.08901961}, {213,1.09854902}, {214,1.10958824}, {215,1.11888235}, {216,1.12809804}, {217,1.13078431}, {218,1.14872549}, {219,1.15900000}, {220,1.16871569}, {221,1.17906863}, {222,1.19032353}, {223,1.20226471}, {224,1.21100000}, {225,1.22564706}, {226,1.23519608}, {227,1.24753922}, {228,1.25820588}, {229,1.26760784}, {230,1.27914706}, {231,1.29112745}, {232,1.29788235}, {233,1.31321569}, {234,1.32349020}, {235,1.33478431}, {236,1.34431373}, {237,1.37512745}, {238,1.38692157}, {239,1.38287255}, {240,1.39291176}, {241,1.40514706}, {242,1.42869608}, {243,1.43487255}, {244,1.44666667}, {245,1.45381373}, {246,1.46380392}, {247,1.48128431}, {248,1.49165686}, {249,1.50554902}, {250,1.51771569}, {251,1.53019608}, {252,1.54299020}, {253,1.54523529}, {254,1.56776471}, {255,1.57769608}, {256,1.59225490}, {257,1.61872549}, {258,1.60883333}, {259,1.62136275}, {260,1.63583333}, {261,1.64693137}, {262,1.66204902}, {263,1.67377451}, {264,1.69081373}, {265,1.70434314}, {266,1.70118627}, {267,1.71763725}, {268,1.73297059}, {269,1.74675490}, {270,1.76261765}, {271,1.77250000}, {272,1.78624510}, {273,1.79820588}, {274,1.81005882}, {275,1.82493137}, {276,1.83862745}, {277,1.85043137}, {278,1.86426471}, {279,1.87433333}, {280,1.89087255}, {281,1.90323529}, {282,1.91910784}, {283,1.93540196}, {284,1.95019608}, {285,1.96067647}, {286,2.00533333}, {287,2.00262745}, {288,2.01090196}, {289,2.03015686}, {290,2.05145098}, {291,2.06139216}, {292,2.07099020}, {293,2.08750980}, {294,2.09740196}, {295,2.11113725}, {296,2.12929412}, {297,2.14522549}, {298,2.15683333}, {299,2.17127451}, {300,2.19116667}, {301,2.24425}, {302,2.58300}, {303,2.23350}, {304,2.25300}, {305,2.29875}, {306,2.27975}, {307,2.29350}, {308,2.32350}, {309,2.33800}, {310,2.34325}, {311,2.35950}, {312,2.55275}, {313,2.71100}, {314,2.37050}, {315,2.39000}, {316,2.39000}, {317,2.42925}, {318,2.42300}, {319,2.43025}, {320,2.43275}, {321,2.45750}, {322,2.52000}, {323,2.50900}, {324,2.51725}, {325,2.54000}, {326,2.57500}, {327,2.61925}, {328,2.60175}, {329,2.62350}, {330,2.62975}, {331,2.66800}, {332,2.69800}, {333,2.69650}, {334,2.70650}, {335,2.74000}, {336,2.74850}, {337,2.83800}, {338,2.77975}, {339,2.81100}, {340,2.80850}, {341,2.83025}, {342,2.87425}, {343,2.87400}, {344,2.86375}, {345,2.86800}, {346,2.91600}, {347,2.97075}, {348,2.97825}, {349,2.97425}, {350,2.98975}, {351,3.04600}, {352,3.01975}, {353,3.04075}, {354,3.05425}, {355,3.07775}, {356,3.11600}, {357,3.12625}, {358,3.13900}, {359,3.14725}, {360,3.20275}, {361,3.20850}, {362,3.19525}, {363,3.19650}, {364,3.23400}, {365,3.23200}, {366,3.26200}, {367,3.29825}, {368,3.34325}, {369,3.35250}, {370,3.34300}, {371,3.37000}, {372,3.42425}, {373,3.40475}, {374,3.37750}, {375,3.40000}, {376,3.45575}, {377,3.46450}, {378,3.47875}, {379,3.48875}, {380,3.53000}, {381,3.50525}, {382,3.58000}, {383,3.60025}, {384,3.63650}, {385,3.65950}, {386,3.66525}, {387,3.66975}, {388,3.71750}, {389,3.70125}, {390,3.69825}, {391,3.70150}, {392,3.74425}, {393,3.74125}, {394,3.75875}, {395,3.83400}, {396,3.84750}, {397,3.84375}, {398,3.87850}, {399,3.91075}, {400,3.90275}, {401,3.88800}, {402,3.96725}, {403,4.00000}, {404,4.00250}, {405,4.01975}, {406,4.07575}, {407,4.06125}, {408,4.07375}, {409,4.13325}, {410,4.15400}, {411,4.17150}, {412,4.20450}, {413,4.22050}, {414,4.17825}, {415,4.19125}, {416,4.26575}, {417,4.23875}, {418,4.24250}, {419,4.33800}, {420,4.32400}, {421,4.32450}, {422,4.41475}, {423,4.40900}, {424,4.40250}, {425,4.52700}, {426,4.51875}, {427,4.51125}, {428,4.55200}, {429,4.53925}, {430,4.54400}, {431,4.56375}, {432,4.60300}, {433,4.64000}, {434,4.66575}, {435,4.72250}, {436,4.69150}, {437,4.72650}, {438,4.78900}, {439,4.73150}, {440,4.77975}, {441,4.83175}, {442,4.81525}, {443,4.80575}, {444,4.82350}, {445,4.81900}, {446,4.85650}, {447,4.94550}, {448,4.95400}, {449,5.02575}, {450,4.99350}, {451,4.99925}, {452,5.03425}, {453,5.09500}, {454,5.09050}, {455,5.18400}, {456,5.12700}, {457,5.12300}, {458,5.14550}, {459,5.12400}, {460,5.19300}, {461,5.24150}, {462,5.22325}, {463,5.29750}, {464,5.26950}, {465,5.32800}, {466,5.37125}, {467,5.39050}, {468,5.40825}, {469,5.37900}, {470,5.42775}, {471,5.51175}, {472,5.46525}, {473,5.51650}, {474,5.50925}, {475,5.56500}, {476,5.61550}, {477,5.60925}, {478,5.62250}, {479,5.68500}, {480,5.71475}, {481,5.75350}, {482,5.73900}, {483,5.81350}, {484,5.83625}, {485,5.87900}, {486,5.95525}, {487,5.81925}, {488,5.89500}, {489,5.96375}, {490,6.06325}, {491,6.03450}, {492,5.97800}, {493,6.04000}, {494,5.99250}, {495,6.10725}, {496,6.11050}, {497,6.14875}, {498,6.13300}, {499,6.15500}, {500,6.22950}, {505,6.36575}, {510,6.61025}, {515,6.58625}, {520,6.74150}, {525,6.92850}, {530,7.05925}, {535,7.15750}, {540,7.29725}, {545,7.38050}, {550,7.66425}, {555,7.76950}, {560,7.90500}, {565,8.04300}, {570,8.21900}, {575,8.37725}, {580,8.47450}, {585,8.60175}, {590,8.85500}, {595,8.95675}, {600,8.98450}, {605,9.15550}, {610,9.40950}, {615,9.58350}, {620,9.62425}, {625,9.89175}, {630,10.16450}, {635,10.24550}, {640,10.38400}, {645,10.66075}, {650,10.73975}, {655,10.72500}, {660,11.06350}, {665,11.22825}, {670,11.24375}, {675,11.64450}, {680,11.77850}, {685,11.95050}, {690,12.23125}, {695,12.37650}, {700,12.56200}, {705,12.85075}, {710,12.90775}, {715,13.14200}, {720,13.30450}, {725,13.34175}, {730,13.63575}, {735,13.69250}, {740,13.89400}, {745,14.14000}, {750,14.40575}, {755,14.59900}, {760,15.11650}, {765,15.04825}, {770,15.30325}, {775,15.28425}, {780,15.49925}, {785,16.13725}, {790,15.75250}, {795,16.37825}, {800,16.27475}, {805,16.70350}, {810,16.84400}, {815,17.19825}, {820,17.01550}, {825,17.19700}, {830,17.67750}, {835,17.63550}, {840,18.12000}, {845,18.29950}, {850,18.56325}, {855,18.61850}, {860,18.84500}, {865,18.91600}, {870,19.13000}, {875,19.47825}, {880,19.76925}, {885,20.05300}, {890,20.21250}, {895,20.51300}, {900,20.60825}, {905,21.04025}, {910,21.11700}, {915,21.62325}, {920,21.54600}, {925,22.01675}, {930,22.21750}, {935,22.67800}, {940,22.75500}, {945,22.81175}, {950,23.34175}, {955,23.45775}, {960,23.65550}, {965,24.64525}, {970,24.25200}, {975,24.62175}, {980,24.78300}, {985,25.01225}, {990,25.51675}, {995,25.90150}, {1000,26.36600}, {1010,26.68425}, {1020,27.01700}, {1030,27.44825}, {1040,28.01275}, {1050,28.22450}, {1060,29.44400}, {1070,30.36050}, {1080,30.23350}, {1090,30.92225}, {1100,31.21125}, {1110,32.78575}, {1120,33.40625}, {1130,33.71025}, {1140,34.40975}, {1150,34.74300}, {1160,35.61650}, {1170,36.76075}, {1180,37.14450}, {1190,37.40250}, {1200,38.47100}, {1210,39.27850}, {1220,39.41725}, {1230,40.47525}, {1240,42.12625}, {1250,41.29825}, {1260,43.39625}, {1270,43.63025}, {1280,43.58600}, {1290,45.12150}, {1300,46.09650}, {1310,46.14250}, {1320,46.85475}, {1330,47.70125}, {1340,48.18675}, {1350,49.69325}, {1360,49.37575}, {1370,50.78800}, {1380,50.79750}, {1390,52.32000}, {1400,53.71925}, {1410,54.28300}, {1420,54.54450}, {1430,55.75350}, {1440,56.06125}, {1450,57.80000}, {1460,61.085}, {1470,61.781}, {1480,63.26}, {1490,63.804}, {1500,64.721}, {1510,65.529}, {1520,66.498}, {1530,67.902}, {1540,68.131}, {1550,70.237}, {1560,69.895}, {1570,71.714}, {1580,70.79}, {1590,74.389}, {1600,73.052}, {1610,74.321}, {1620,74.059}, {1630,75.1}, {1640,76.454}, {1650,78.091}, {1660,78.899}, {1670,79.584}, {1680,82.879}, {1690,82.256}, {1700,85.226}, {1710,84.112}, {1720,84.871}, {1730,87.877}, {1740,87.838}, {1750,86.958}, {1760,88.315}, {1770,89.803}, {1780,90.185}, {1790,91.193}, {1800,93.597}, {1810,92.557}, {1820,91.606}, {1830,95.056}, {1840,96.969}, {1850,94.832}, {1860,95.611}, {1870,100.474}, {1880,100.825}, {1890,98.909}, {1900,100.155}, {1910,104.522}, {1920,105.682}, {1930,102.205}, {1940,104.066}, {1950,105.003}, {1960,109.114}, {1970,110.85}, {1980,108.273}, {1990,109.021}, {2000,114.854}, {2050,119.77}, {2100,121.526}, {2150,128.166}, {2200,131.508}, {2250,142.06}, {2300,145.578}, {2350,152.844}, {2400,156.912}, {2450,166.94}, {2500,173.061}, {2550,177.325}, {2600,189.126}, {2650,192.335}, {2700,205.15}, {2750,212.13}, {2800,218.333}, {2850,229.297}, {2900,236.643}, {2950,242.78}, {3000,253.293}, {3050,263.059}, {3100,270.632}, {3150,276.825}, {3200,290.666}, {3250,300.098}, {3300,308.025}, {3350,321.334}, {3400,328.81}, {3450,339.255}, {3500,352.908}, {3550,358.97}, {3600,370.854}, {3650,384.628}, {3700,389.864}, {3750,412.859}, {3800,421.964}, {3850,424.203}, {3900,432.397}, {3950,451.894}, {4000,464.114}, {4050,473.498}, {4100,483.743}, {4150,488.908}, {4200,494.975}, {4250,509.728}, {4300,521.412}, {4350,544.756}, {4400,547.148}, {4450,559.374}, {4500,578.085}, {4550,593.656}, {4600,609.189}, {4650,620.197}, {4700,654.102}, {4750,667.887}, {4800,683.751}, {4850,692.807}, {4900,705.417}, {4950,716.65}, {5000,739.016}, {5050,751.132}, {5100,776.089}, {5150,788.112}, {5200,808.237}, {5250,821.701}, {5300,839.094}, {5350,857.657}, {5400,857.261}, {5450,878.636}, {5500,903.899}, {5550,934.62}, {5600,944.315}, {5650,955.076}, {5700,978.835}, {5750,997.409}, {5800,1008.969}, {5850,1028.216}, {5900,1038.986}, {5950,1059.474}, {6000,1087.482}};
data["big"]["Ltac2"]["reif"]["user"] = {{1,0.00105882}, {2,0.00162745}, {3,0.00136275}, {4,0.00179412}, {5,0.00250000}, {6,0.00291176}, {7,0.00336275}, {8,0.00386275}, {9,0.00478431}, {10,0.00500000}, {11,0.00579412}, {12,0.00666667}, {13,0.00714706}, {14,0.00807843}, {15,0.00873529}, {16,0.00992157}, {17,0.01628431}, {18,0.01156863}, {19,0.01283333}, {20,0.01350980}, {21,0.01456863}, {22,0.01575490}, {23,0.01682353}, {24,0.02044118}, {25,0.01956863}, {26,0.02134314}, {27,0.02281373}, {28,0.02440196}, {29,0.02772549}, {30,0.02717647}, {31,0.02858824}, {32,0.02988235}, {33,0.03297059}, {34,0.03352941}, {35,0.03485294}, {36,0.03936275}, {37,0.03826471}, {38,0.04014706}, {39,0.04184314}, {40,0.04402941}, {41,0.04965686}, {42,0.04850980}, {43,0.05366667}, {44,0.05236275}, {45,0.05807843}, {46,0.05624510}, {47,0.06222549}, {48,0.06122549}, {49,0.06594118}, {50,0.07090196}, {51,0.06828431}, {52,0.07486275}, {53,0.07766667}, {54,0.07632353}, {55,0.08203922}, {56,0.08540196}, {57,0.08783333}, {58,0.08648039}, {59,0.09038235}, {60,0.09728431}, {61,0.09975490}, {62,0.10292157}, {63,0.10570588}, {64,0.10849020}, {65,0.11127451}, {66,0.11446078}, {67,0.11829412}, {68,0.12228431}, {69,0.12517647}, {70,0.12882353}, {71,0.13279412}, {72,0.13535294}, {73,0.13860784}, {74,0.14278431}, {75,0.14686275}, {76,0.15064706}, {77,0.15243137}, {78,0.15738235}, {79,0.15992157}, {80,0.16495098}, {81,0.16801961}, {82,0.17273529}, {83,0.17670588}, {84,0.18038235}, {85,0.18414706}, {86,0.18840196}, {87,0.19329412}, {88,0.19788235}, {89,0.20203922}, {90,0.20533333}, {91,0.20966667}, {92,0.21545098}, {93,0.21959804}, {94,0.22381373}, {95,0.22750980}, {96,0.23143137}, {97,0.23657843}, {98,0.24183333}, {99,0.24601961}, {100,0.25048039}, {101,0.25504902}, {102,0.26053922}, {103,0.26633333}, {104,0.27016667}, {105,0.27506863}, {106,0.27944118}, {107,0.28400000}, {108,0.29016667}, {109,0.29460784}, {110,0.29963725}, {111,0.30509804}, {112,0.31038235}, {113,0.31557843}, {114,0.32066667}, {115,0.32631373}, {116,0.33153922}, {117,0.33736275}, {118,0.34247059}, {119,0.34773529}, {120,0.35267647}, {121,0.35927451}, {122,0.36850000}, {123,0.37140196}, {124,0.37694118}, {125,0.38232353}, {126,0.38779412}, {127,0.39405882}, {128,0.40036275}, {129,0.40700980}, {130,0.41483333}, {131,0.42030392}, {132,0.42648039}, {133,0.43331373}, {134,0.43840196}, {135,0.44534314}, {136,0.45322549}, {137,0.45947059}, {138,0.46666667}, {139,0.47279412}, {140,0.47974510}, {141,0.48623529}, {142,0.49044118}, {143,0.50126471}, {144,0.50903922}, {145,0.51555882}, {146,0.52474510}, {147,0.52728431}, {148,0.53435294}, {149,0.54137255}, {150,0.55296078}, {151,0.56473529}, {152,0.57305882}, {153,0.58024510}, {154,0.58365686}, {155,0.58608824}, {156,0.59325490}, {157,0.60184314}, {158,0.60933333}, {159,0.61764706}, {160,0.62440196}, {161,0.63230392}, {162,0.63935294}, {163,0.65916667}, {164,0.65702941}, {165,0.66592157}, {166,0.67246078}, {167,0.68166667}, {168,0.68967647}, {169,0.69484314}, {170,0.70303922}, {171,0.71148039}, {172,0.72019608}, {173,0.73014706}, {174,0.74091176}, {175,0.74526471}, {176,0.75822549}, {177,0.76032353}, {178,0.76908824}, {179,0.77775490}, {180,0.78791176}, {181,0.79675490}, {182,0.80434314}, {183,0.81183333}, {184,0.82347059}, {185,0.83207843}, {186,0.84034314}, {187,0.84878431}, {188,0.85721569}, {189,0.86734314}, {190,0.87026471}, {191,0.88406863}, {192,0.89592157}, {193,0.90524510}, {194,0.91121569}, {195,0.91996078}, {196,0.92788235}, {197,0.93720588}, {198,0.94781373}, {199,0.95976471}, {200,0.96838235}, {201,0.97721569}, {202,0.98637255}, {203,0.99506863}, {204,1.00050000}, {205,1.01802941}, {206,1.02780392}, {207,1.03682353}, {208,1.04685294}, {209,1.04859804}, {210,1.06546078}, {211,1.08693137}, {212,1.08727451}, {213,1.09669608}, {214,1.10784314}, {215,1.11705882}, {216,1.12664706}, {217,1.12873529}, {218,1.14661765}, {219,1.15707843}, {220,1.16682353}, {221,1.17733333}, {222,1.18868627}, {223,1.20067647}, {224,1.20909804}, {225,1.22411765}, {226,1.23326471}, {227,1.24602941}, {228,1.25669608}, {229,1.26607843}, {230,1.27724510}, {231,1.28926471}, {232,1.29583333}, {233,1.31105882}, {234,1.32160784}, {235,1.33274510}, {236,1.34266667}, {237,1.37277451}, {238,1.38449020}, {239,1.38070588}, {240,1.39019608}, {241,1.40244118}, {242,1.42588235}, {243,1.43233333}, {244,1.44381373}, {245,1.45106863}, {246,1.46127451}, {247,1.47806863}, {248,1.48884314}, {249,1.50279412}, {250,1.51500980}, {251,1.52745098}, {252,1.54022549}, {253,1.54266667}, {254,1.56532353}, {255,1.57495098}, {256,1.59002941}, {257,1.61592157}, {258,1.60586275}, {259,1.61825490}, {260,1.63305882}, {261,1.64406863}, {262,1.65929412}, {263,1.67095098}, {264,1.68750980}, {265,1.70138235}, {266,1.69819608}, {267,1.71460784}, {268,1.73026471}, {269,1.74358824}, {270,1.75962745}, {271,1.76975490}, {272,1.78351961}, {273,1.79535294}, {274,1.80696078}, {275,1.82212745}, {276,1.83521569}, {277,1.84721569}, {278,1.86042157}, {279,1.87104902}, {280,1.88748039}, {281,1.89952941}, {282,1.91588235}, {283,1.93186275}, {284,1.94668627}, {285,1.95692157}, {286,2.00196078}, {287,1.99900000}, {288,2.00733333}, {289,2.02660784}, {290,2.04854902}, {291,2.05782353}, {292,2.06755882}, {293,2.08467647}, {294,2.09403922}, {295,2.10815686}, {296,2.12575490}, {297,2.14181373}, {298,2.15337255}, {299,2.16811765}, {300,2.18795098}, {301,2.23950}, {302,2.57850}, {303,2.23025}, {304,2.25175}, {305,2.29625}, {306,2.27625}, {307,2.29150}, {308,2.31950}, {309,2.33625}, {310,2.34050}, {311,2.35650}, {312,2.54850}, {313,2.70425}, {314,2.37075}, {315,2.39025}, {316,2.38975}, {317,2.43025}, {318,2.42200}, {319,2.42850}, {320,2.43350}, {321,2.45725}, {322,2.52025}, {323,2.50850}, {324,2.51750}, {325,2.53850}, {326,2.57450}, {327,2.61850}, {328,2.60025}, {329,2.62475}, {330,2.62975}, {331,2.66675}, {332,2.69650}, {333,2.69175}, {334,2.70050}, {335,2.71625}, {336,2.74225}, {337,2.79725}, {338,2.77700}, {339,2.80425}, {340,2.80625}, {341,2.82825}, {342,2.87375}, {343,2.87450}, {344,2.86325}, {345,2.86700}, {346,2.91600}, {347,2.96950}, {348,2.97825}, {349,2.97425}, {350,2.98875}, {351,3.04400}, {352,3.01875}, {353,3.03850}, {354,3.05500}, {355,3.07675}, {356,3.11500}, {357,3.12575}, {358,3.13775}, {359,3.14700}, {360,3.20175}, {361,3.20525}, {362,3.19350}, {363,3.19700}, {364,3.23400}, {365,3.23100}, {366,3.26225}, {367,3.29750}, {368,3.34100}, {369,3.35150}, {370,3.34150}, {371,3.36950}, {372,3.42350}, {373,3.40375}, {374,3.37750}, {375,3.39650}, {376,3.45525}, {377,3.46425}, {378,3.47675}, {379,3.48625}, {380,3.52850}, {381,3.50350}, {382,3.57975}, {383,3.59825}, {384,3.63425}, {385,3.65850}, {386,3.66450}, {387,3.66925}, {388,3.71675}, {389,3.70050}, {390,3.69750}, {391,3.70025}, {392,3.74275}, {393,3.74100}, {394,3.75650}, {395,3.83250}, {396,3.84675}, {397,3.84375}, {398,3.87825}, {399,3.91050}, {400,3.90325}, {401,3.88750}, {402,3.96725}, {403,3.99925}, {404,4.00375}, {405,4.01925}, {406,4.07575}, {407,4.05975}, {408,4.07225}, {409,4.13425}, {410,4.15400}, {411,4.17125}, {412,4.20525}, {413,4.21925}, {414,4.17875}, {415,4.19275}, {416,4.26700}, {417,4.23925}, {418,4.24350}, {419,4.33975}, {420,4.32325}, {421,4.32475}, {422,4.41650}, {423,4.40975}, {424,4.40150}, {425,4.52650}, {426,4.51850}, {427,4.51050}, {428,4.55150}, {429,4.54000}, {430,4.54350}, {431,4.56450}, {432,4.60375}, {433,4.63950}, {434,4.66625}, {435,4.72450}, {436,4.69250}, {437,4.72575}, {438,4.78950}, {439,4.73150}, {440,4.77875}, {441,4.83050}, {442,4.81700}, {443,4.80625}, {444,4.82400}, {445,4.81850}, {446,4.85700}, {447,4.94575}, {448,4.95350}, {449,5.02550}, {450,4.99275}, {451,5.00075}, {452,5.03250}, {453,5.09475}, {454,5.08950}, {455,5.18275}, {456,5.12675}, {457,5.12300}, {458,5.14325}, {459,5.12225}, {460,5.18725}, {461,5.24150}, {462,5.22250}, {463,5.29525}, {464,5.26850}, {465,5.32775}, {466,5.37150}, {467,5.38950}, {468,5.40900}, {469,5.37850}, {470,5.42675}, {471,5.50950}, {472,5.46550}, {473,5.51650}, {474,5.50850}, {475,5.56550}, {476,5.61600}, {477,5.60950}, {478,5.62150}, {479,5.68450}, {480,5.71425}, {481,5.75225}, {482,5.73975}, {483,5.81375}, {484,5.83550}, {485,5.87600}, {486,5.95325}, {487,5.81750}, {488,5.89275}, {489,5.96275}, {490,6.06150}, {491,6.03250}, {492,5.97650}, {493,6.03800}, {494,5.99025}, {495,6.10525}, {496,6.10925}, {497,6.14750}, {498,6.13150}, {499,6.15375}, {500,6.22800}, {505,6.36550}, {510,6.61000}, {515,6.58350}, {520,6.73975}, {525,6.92725}, {530,7.05750}, {535,7.15650}, {540,7.29325}, {545,7.37825}, {550,7.66250}, {555,7.76650}, {560,7.90300}, {565,8.04000}, {570,8.21775}, {575,8.37575}, {580,8.44025}, {585,8.59525}, {590,8.84875}, {595,8.95400}, {600,8.97800}, {605,9.15475}, {610,9.40750}, {615,9.58150}, {620,9.62150}, {625,9.88700}, {630,10.16250}, {635,10.24225}, {640,10.38425}, {645,10.65950}, {650,10.73950}, {655,10.72525}, {660,11.06325}, {665,11.22750}, {670,11.24325}, {675,11.64325}, {680,11.77800}, {685,11.95225}, {690,12.22950}, {695,12.37675}, {700,12.56175}, {705,12.85175}, {710,12.90850}, {715,13.14050}, {720,13.30350}, {725,13.34050}, {730,13.63425}, {735,13.69050}, {740,13.89250}, {745,14.13825}, {750,14.40550}, {755,14.59450}, {760,15.11725}, {765,15.04975}, {770,15.29950}, {775,15.28125}, {780,15.49875}, {785,16.12950}, {790,15.72675}, {795,16.37450}, {800,16.26650}, {805,16.70050}, {810,16.84350}, {815,17.19525}, {820,17.01200}, {825,17.19175}, {830,17.67350}, {835,17.63550}, {840,18.11950}, {845,18.29825}, {850,18.56325}, {855,18.61550}, {860,18.84350}, {865,18.91650}, {870,19.12875}, {875,19.47775}, {880,19.76975}, {885,20.05150}, {890,20.21250}, {895,20.51375}, {900,20.60950}, {905,21.03975}, {910,21.11675}, {915,21.62400}, {920,21.54675}, {925,22.01675}, {930,22.21750}, {935,22.67650}, {940,22.75525}, {945,22.81075}, {950,23.33825}, {955,23.45575}, {960,23.65650}, {965,24.64275}, {970,24.25075}, {975,24.62150}, {980,24.78225}, {985,25.00950}, {990,25.51675}, {995,25.89850}, {1000,26.36325}, {1010,26.68350}, {1020,27.01600}, {1030,27.44625}, {1040,28.00325}, {1050,28.22425}, {1060,29.44400}, {1070,30.36050}, {1080,30.23475}, {1090,30.91900}, {1100,31.20525}, {1110,32.76425}, {1120,33.35250}, {1130,33.66100}, {1140,34.36450}, {1150,34.69150}, {1160,35.56150}, {1170,36.70075}, {1180,37.08450}, {1190,37.34550}, {1200,38.42375}, {1210,39.17750}, {1220,39.36650}, {1230,40.42050}, {1240,42.06850}, {1250,41.23175}, {1260,43.25450}, {1270,43.57525}, {1280,43.52100}, {1290,45.05975}, {1300,46.01950}, {1310,46.08175}, {1320,46.76250}, {1330,47.30525}, {1340,48.12650}, {1350,49.51700}, {1360,49.31075}, {1370,50.71950}, {1380,50.73150}, {1390,52.21650}, {1400,53.63375}, {1410,54.15975}, {1420,54.46850}, {1430,55.67200}, {1440,56.04025}, {1450,57.79825}, {1460,61.079}, {1470,61.775}, {1480,63.255}, {1490,63.792}, {1500,64.672}, {1510,65.52}, {1520,66.471}, {1530,67.851}, {1540,68.108}, {1550,70.175}, {1560,69.887}, {1570,71.644}, {1580,70.791}, {1590,74.387}, {1600,72.864}, {1610,74.308}, {1620,74.039}, {1630,75.096}, {1640,76.448}, {1650,78.083}, {1660,78.88}, {1670,79.579}, {1680,82.868}, {1690,82.248}, {1700,85.2}, {1710,83.96}, {1720,84.863}, {1730,87.871}, {1740,87.824}, {1750,86.956}, {1760,88.308}, {1770,89.711}, {1780,89.94}, {1790,91.176}, {1800,93.583}, {1810,92.551}, {1820,91.487}, {1830,94.944}, {1840,96.668}, {1850,94.351}, {1860,95.359}, {1870,100.471}, {1880,100.823}, {1890,98.904}, {1900,99.943}, {1910,104.52}, {1920,105.623}, {1930,102.203}, {1940,103.899}, {1950,105.003}, {1960,109.104}, {1970,110.824}, {1980,108.272}, {1990,109.023}, {2000,114.26}, {2050,119.747}, {2100,121.423}, {2150,128.104}, {2200,131.231}, {2250,141.84}, {2300,145.576}, {2350,152.831}, {2400,156.863}, {2450,166.927}, {2500,173.064}, {2550,177.291}, {2600,188.584}, {2650,192.083}, {2700,205.119}, {2750,211.988}, {2800,217.739}, {2850,228.864}, {2900,236.579}, {2950,242.763}, {3000,253.228}, {3050,263.}, {3100,270.595}, {3150,276.796}, {3200,290.655}, {3250,299.775}, {3300,307.932}, {3350,321.259}, {3400,328.76}, {3450,339.255}, {3500,352.852}, {3550,358.927}, {3600,370.116}, {3650,383.62}, {3700,389.868}, {3750,412.763}, {3800,421.915}, {3850,424.148}, {3900,432.011}, {3950,449.727}, {4000,462.52}, {4050,473.064}, {4100,483.304}, {4150,488.659}, {4200,494.727}, {4250,509.536}, {4300,520.98}, {4350,543.427}, {4400,546.064}, {4450,558.695}, {4500,577.819}, {4550,593.067}, {4600,608.663}, {4650,619.727}, {4700,651.283}, {4750,664.932}, {4800,681.067}, {4850,692.656}, {4900,705.34}, {4950,716.552}, {5000,738.075}, {5050,750.211}, {5100,772.512}, {5150,785.192}, {5200,807.94}, {5250,817.727}, {5300,834.711}, {5350,856.42}, {5400,855.792}, {5450,873.152}, {5500,900.5}, {5550,930.399}, {5600,938.936}, {5650,952.923}, {5700,975.108}, {5750,994.571}, {5800,1008.512}, {5850,1026.008}, {5900,1036.875}, {5950,1055.783}, {6000,1084.324}};
data["big"]["Ltac2"]["reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003922}, {4,0.00003922}, {5,0.00000000}, {6,0.00003922}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00003922}, {12,0.00003922}, {13,0.00007843}, {14,0.00003922}, {15,0.00007843}, {16,0.00003922}, {17,0.00003922}, {18,0.00003922}, {19,0.00000000}, {20,0.00000000}, {21,0.00003922}, {22,0.00003922}, {23,0.00003922}, {24,0.00003922}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00003922}, {29,0.00007843}, {30,0.00007843}, {31,0.00007843}, {32,0.00003922}, {33,0.00010784}, {34,0.00000000}, {35,0.00015686}, {36,0.00000000}, {37,0.00003922}, {38,0.00011765}, {39,0.00003922}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00003922}, {44,0.00003922}, {45,0.00003922}, {46,0.00003922}, {47,0.00003922}, {48,0.00000000}, {49,0.00000000}, {50,0.00003922}, {51,0.00003922}, {52,0.00000000}, {53,0.00003922}, {54,0.00007843}, {55,0.00011765}, {56,0.00003922}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00003922}, {63,0.00003922}, {64,0.00003922}, {65,0.00015686}, {66,0.00007843}, {67,0.00011765}, {68,0.00000000}, {69,0.00007843}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00007843}, {76,0.00000000}, {77,0.00007843}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00007843}, {82,0.00007843}, {83,0.00007843}, {84,0.00003922}, {85,0.00000000}, {86,0.00003922}, {87,0.00007843}, {88,0.00000000}, {89,0.00003922}, {90,0.00000000}, {91,0.00003922}, {92,0.00000000}, {93,0.00011765}, {94,0.00000000}, {95,0.00007843}, {96,0.00011765}, {97,0.00003922}, {98,0.00002941}, {99,0.00011765}, {100,0.00003922}, {101,0.00000000}, {102,0.00003922}, {103,0.00000000}, {104,0.00003922}, {105,0.00003922}, {106,0.00003922}, {107,0.00003922}, {108,0.00010784}, {109,0.00027451}, {110,0.00014706}, {111,0.00007843}, {112,0.00006863}, {113,0.00003922}, {114,0.00003922}, {115,0.00006863}, {116,0.00007843}, {117,0.00000000}, {118,0.00014706}, {119,0.00003922}, {120,0.00014706}, {121,0.00007843}, {122,0.00000000}, {123,0.00011765}, {124,0.00011765}, {125,0.00011765}, {126,0.00007843}, {127,0.00003922}, {128,0.00000000}, {129,0.00007843}, {130,0.00011765}, {131,0.00007843}, {132,0.00000000}, {133,0.00003922}, {134,0.00003922}, {135,0.00015686}, {136,0.00015686}, {137,0.00007843}, {138,0.00007843}, {139,0.00010784}, {140,0.00007843}, {141,0.00000000}, {142,0.00003922}, {143,0.00011765}, {144,0.00003922}, {145,0.00019608}, {146,0.00003922}, {147,0.00003922}, {148,0.00011765}, {149,0.00007843}, {150,0.00003922}, {151,0.00011765}, {152,0.00007843}, {153,0.00006863}, {154,0.00007843}, {155,0.00003922}, {156,0.00003922}, {157,0.00019608}, {158,0.00007843}, {159,0.00003922}, {160,0.00007843}, {161,0.00003922}, {162,0.00023529}, {163,0.00023529}, {164,0.00011765}, {165,0.00003922}, {166,0.00011765}, {167,0.00007843}, {168,0.00003922}, {169,0.00000000}, {170,0.00000000}, {171,0.00003922}, {172,0.00000000}, {173,0.00003922}, {174,0.00007843}, {175,0.00003922}, {176,0.00007843}, {177,0.00015686}, {178,0.00015686}, {179,0.00007843}, {180,0.00007843}, {181,0.00015686}, {182,0.00003922}, {183,0.00014706}, {184,0.00011765}, {185,0.00011765}, {186,0.00011765}, {187,0.00014706}, {188,0.00000000}, {189,0.00019608}, {190,0.00019608}, {191,0.00007843}, {192,0.00000000}, {193,0.00007843}, {194,0.00023529}, {195,0.00000000}, {196,0.00003922}, {197,0.00011765}, {198,0.00014706}, {199,0.00000000}, {200,0.00010784}, {201,0.00019608}, {202,0.00015686}, {203,0.00007843}, {204,0.00006863}, {205,0.00006863}, {206,0.00023529}, {207,0.00006863}, {208,0.00003922}, {209,0.00003922}, {210,0.00011765}, {211,0.00011765}, {212,0.00015686}, {213,0.00011765}, {214,0.00015686}, {215,0.00015686}, {216,0.00011765}, {217,0.00011765}, {218,0.00031373}, {219,0.00003922}, {220,0.00035294}, {221,0.00023529}, {222,0.00007843}, {223,0.00011765}, {224,0.00027451}, {225,0.00003922}, {226,0.00019608}, {227,0.00011765}, {228,0.00007843}, {229,0.00000000}, {230,0.00010784}, {231,0.00000000}, {232,0.00007843}, {233,0.00022549}, {234,0.00015686}, {235,0.00011765}, {236,0.00019608}, {237,0.00011765}, {238,0.00019608}, {239,0.00011765}, {240,0.00026471}, {241,0.00011765}, {242,0.00019608}, {243,0.00023529}, {244,0.00023529}, {245,0.00011765}, {246,0.00019608}, {247,0.00025490}, {248,0.00026471}, {249,0.00015686}, {250,0.00011765}, {251,0.00023529}, {252,0.00011765}, {253,0.00009804}, {254,0.00011765}, {255,0.00015686}, {256,0.00019608}, {257,0.00003922}, {258,0.00027451}, {259,0.00023529}, {260,0.00011765}, {261,0.00023529}, {262,0.00022549}, {263,0.00011765}, {264,0.00023529}, {265,0.00015686}, {266,0.00019608}, {267,0.00011765}, {268,0.00015686}, {269,0.00007843}, {270,0.00019608}, {271,0.00019608}, {272,0.00011765}, {273,0.00023529}, {274,0.00003922}, {275,0.00015686}, {276,0.00023529}, {277,0.00003922}, {278,0.00035294}, {279,0.00027451}, {280,0.00027451}, {281,0.00034314}, {282,0.00011765}, {283,0.00023529}, {284,0.00019608}, {285,0.00042157}, {286,0.00027451}, {287,0.00035294}, {288,0.00026471}, {289,0.00035294}, {290,0.00023529}, {291,0.00019608}, {292,0.00039216}, {293,0.00023529}, {294,0.00042157}, {295,0.00007843}, {296,0.00039216}, {297,0.00023529}, {298,0.00031373}, {299,0.00015686}, {300,0.00019608}, {301,0.00100}, {302,0.00200}, {303,0.00000}, {304,0.00000}, {305,0.00000}, {306,0.00000}, {307,0.00000}, {308,0.00000}, {309,0.00000}, {310,0.00000}, {311,0.00000}, {312,0.00100}, {313,0.00300}, {314,0.00000}, {315,0.00000}, {316,0.00000}, {317,0.00000}, {318,0.00000}, {319,0.00000}, {320,0.00000}, {321,0.00000}, {322,0.00000}, {323,0.00000}, {324,0.00000}, {325,0.00000}, {326,0.00000}, {327,0.00000}, {328,0.00000}, {329,0.00000}, {330,0.00000}, {331,0.00000}, {332,0.00200}, {333,0.00000}, {334,0.00100}, {335,0.00000}, {336,0.00000}, {337,0.00000}, {338,0.00000}, {339,0.00000}, {340,0.00000}, {341,0.00000}, {342,0.00000}, {343,0.00000}, {344,0.00000}, {345,0.00000}, {346,0.00000}, {347,0.00000}, {348,0.00000}, {349,0.00000}, {350,0.00000}, {351,0.00000}, {352,0.00000}, {353,0.00000}, {354,0.00000}, {355,0.00000}, {356,0.00100}, {357,0.00000}, {358,0.00200}, {359,0.00000}, {360,0.00000}, {361,0.00100}, {362,0.00100}, {363,0.00000}, {364,0.00000}, {365,0.00000}, {366,0.00000}, {367,0.00000}, {368,0.00000}, {369,0.00000}, {370,0.00000}, {371,0.00000}, {372,0.00000}, {373,0.00100}, {374,0.00000}, {375,0.00100}, {376,0.00000}, {377,0.00000}, {378,0.00100}, {379,0.00100}, {380,0.00000}, {381,0.00000}, {382,0.00000}, {383,0.00100}, {384,0.00100}, {385,0.00000}, {386,0.00000}, {387,0.00000}, {388,0.00100}, {389,0.00075}, {390,0.00000}, {391,0.00000}, {392,0.00000}, {393,0.00000}, {394,0.00100}, {395,0.00000}, {396,0.00000}, {397,0.00000}, {398,0.00000}, {399,0.00000}, {400,0.00000}, {401,0.00000}, {402,0.00000}, {403,0.00000}, {404,0.00000}, {405,0.00000}, {406,0.00000}, {407,0.00000}, {408,0.00000}, {409,0.00000}, {410,0.00000}, {411,0.00000}, {412,0.00000}, {413,0.00000}, {414,0.00000}, {415,0.00000}, {416,0.00000}, {417,0.00000}, {418,0.00000}, {419,0.00000}, {420,0.00100}, {421,0.00000}, {422,0.00000}, {423,0.00000}, {424,0.00000}, {425,0.00000}, {426,0.00000}, {427,0.00000}, {428,0.00000}, {429,0.00000}, {430,0.00000}, {431,0.00000}, {432,0.00000}, {433,0.00000}, {434,0.00000}, {435,0.00000}, {436,0.00000}, {437,0.00000}, {438,0.00000}, {439,0.00000}, {440,0.00000}, {441,0.00000}, {442,0.00000}, {443,0.00000}, {444,0.00000}, {445,0.00000}, {446,0.00000}, {447,0.00000}, {448,0.00000}, {449,0.00000}, {450,0.00000}, {451,0.00000}, {452,0.00000}, {453,0.00000}, {454,0.00000}, {455,0.00000}, {456,0.00000}, {457,0.00000}, {458,0.00075}, {459,0.00000}, {460,0.00500}, {461,0.00000}, {462,0.00000}, {463,0.00000}, {464,0.00000}, {465,0.00000}, {466,0.00000}, {467,0.00000}, {468,0.00000}, {469,0.00000}, {470,0.00000}, {471,0.00000}, {472,0.00000}, {473,0.00000}, {474,0.00000}, {475,0.00000}, {476,0.00000}, {477,0.00000}, {478,0.00000}, {479,0.00000}, {480,0.00000}, {481,0.00000}, {482,0.00000}, {483,0.00000}, {484,0.00000}, {485,0.00100}, {486,0.00000}, {487,0.00000}, {488,0.00100}, {489,0.00000}, {490,0.00000}, {491,0.00000}, {492,0.00000}, {493,0.00000}, {494,0.00075}, {495,0.00000}, {496,0.00000}, {497,0.00000}, {498,0.00000}, {499,0.00000}, {500,0.00100}, {505,0.00000}, {510,0.00000}, {515,0.00100}, {520,0.00000}, {525,0.00000}, {530,0.00100}, {535,0.00000}, {540,0.00100}, {545,0.00000}, {550,0.00000}, {555,0.00100}, {560,0.00000}, {565,0.00100}, {570,0.00000}, {575,0.00000}, {580,0.03250}, {585,0.00375}, {590,0.00300}, {595,0.00000}, {600,0.00400}, {605,0.00000}, {610,0.00000}, {615,0.00000}, {620,0.00000}, {625,0.00000}, {630,0.00000}, {635,0.00100}, {640,0.00000}, {645,0.00000}, {650,0.00000}, {655,0.00000}, {660,0.00000}, {665,0.00000}, {670,0.00000}, {675,0.00000}, {680,0.00000}, {685,0.00000}, {690,0.00000}, {695,0.00000}, {700,0.00000}, {705,0.00000}, {710,0.00000}, {715,0.00000}, {720,0.00000}, {725,0.00000}, {730,0.00000}, {735,0.00000}, {740,0.00200}, {745,0.00000}, {750,0.00000}, {755,0.00300}, {760,0.00000}, {765,0.00000}, {770,0.00400}, {775,0.00100}, {780,0.00000}, {785,0.00700}, {790,0.02475}, {795,0.00400}, {800,0.00600}, {805,0.00075}, {810,0.00000}, {815,0.00175}, {820,0.00300}, {825,0.00500}, {830,0.00175}, {835,0.00000}, {840,0.00000}, {845,0.00100}, {850,0.00000}, {855,0.00300}, {860,0.00000}, {865,0.00000}, {870,0.00000}, {875,0.00000}, {880,0.00100}, {885,0.00000}, {890,0.00000}, {895,0.00000}, {900,0.00000}, {905,0.00000}, {910,0.00000}, {915,0.00000}, {920,0.00100}, {925,0.00000}, {930,0.00000}, {935,0.00100}, {940,0.00000}, {945,0.00100}, {950,0.00300}, {955,0.00200}, {960,0.00000}, {965,0.00300}, {970,0.00000}, {975,0.00000}, {980,0.00000}, {985,0.00300}, {990,0.00100}, {995,0.00300}, {1000,0.00100}, {1010,0.00100}, {1020,0.00000}, {1030,0.00200}, {1040,0.00700}, {1050,0.00000}, {1060,0.00000}, {1070,0.00000}, {1080,0.00000}, {1090,0.00300}, {1100,0.00675}, {1110,0.00675}, {1120,0.01200}, {1130,0.00675}, {1140,0.00500}, {1150,0.00700}, {1160,0.00900}, {1170,0.00775}, {1180,0.01175}, {1190,0.01100}, {1200,0.00300}, {1210,0.00600}, {1220,0.00700}, {1230,0.00675}, {1240,0.00700}, {1250,0.01100}, {1260,0.08775}, {1270,0.00400}, {1280,0.00900}, {1290,0.00675}, {1300,0.00500}, {1310,0.00475}, {1320,0.01000}, {1330,0.00300}, {1340,0.00300}, {1350,0.11675}, {1360,0.00500}, {1370,0.00450}, {1380,0.00500}, {1390,0.01100}, {1400,0.01000}, {1410,0.01900}, {1420,0.00900}, {1430,0.01200}, {1440,0.00200}, {1450,0.00200}, {1460,0}, {1470,0}, {1480,0}, {1490,0.012}, {1500,0.044}, {1510,0}, {1520,0.008}, {1530,0.044}, {1540,0.02}, {1550,0.056}, {1560,0}, {1570,0.06}, {1580,0}, {1590,0}, {1600,0.032}, {1610,0.012}, {1620,0.004}, {1630,0}, {1640,0.004}, {1650,0}, {1660,0}, {1670,0}, {1680,0}, {1690,0}, {1700,0.02}, {1710,0.143}, {1720,0}, {1730,0}, {1740,0}, {1750,0}, {1760,0.004}, {1770,0.02}, {1780,0.244}, {1790,0.004}, {1800,0}, {1810,0}, {1820,0.096}, {1830,0}, {1840,0.003}, {1850,0.008}, {1860,0.008}, {1870,0}, {1880,0}, {1890,0.004}, {1900,0.199}, {1910,0}, {1920,0.06}, {1930,0}, {1940,0.163}, {1950,0}, {1960,0.008}, {1970,0.028}, {1980,0}, {1990,0}, {2000,0.511}, {2050,0}, {2100,0.088}, {2150,0.056}, {2200,0.275}, {2250,0.22}, {2300,0}, {2350,0.011}, {2400,0.048}, {2450,0.012}, {2500,0}, {2550,0.035}, {2600,0.544}, {2650,0.251}, {2700,0.032}, {2750,0.139}, {2800,0.596}, {2850,0.432}, {2900,0.064}, {2950,0.016}, {3000,0.063}, {3050,0.06}, {3100,0.035}, {3150,0.032}, {3200,0.012}, {3250,0.323}, {3300,0.092}, {3350,0.072}, {3400,0.048}, {3450,0}, {3500,0.055}, {3550,0.04}, {3600,0.739}, {3650,1.004}, {3700,0}, {3750,0.096}, {3800,0.048}, {3850,0.051}, {3900,0.048}, {3950,0.295}, {4000,0.108}, {4050,0.071}, {4100,0.128}, {4150,0.024}, {4200,0.247}, {4250,0.192}, {4300,0.435}, {4350,1.327}, {4400,1.084}, {4450,0.679}, {4500,0.263}, {4550,0.588}, {4600,0.523}, {4650,0.167}, {4700,0.16}, {4750,0.224}, {4800,0.251}, {4850,0.152}, {4900,0.076}, {4950,0.1}, {5000,0.939}, {5050,0.352}, {5100,0.347}, {5150,1.124}, {5200,0.295}, {5250,1.696}, {5300,3.811}, {5350,0.312}, {5400,0.248}, {5450,5.327}, {5500,2.003}, {5550,1.972}, {5600,2.244}, {5650,0.572}, {5700,1.927}, {5750,2.192}, {5800,0.456}, {5850,2.207}, {5900,2.107}, {5950,3.688}, {6000,3.155}};
data["big"]["Ltac2LowLevel"]["Aggregate"]["real"] = {{1,0.04757843}, {2,0.00047059}, {3,0.00100000}, {4,0.00161765}, {5,0.00100000}, {6,0.00100000}, {7,0.00100000}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100980}, {14,0.00114706}, {15,0.00113725}, {16,0.00122549}, {17,0.00166667}, {18,0.00200000}, {19,0.00200000}, {20,0.00200000}, {21,0.00200000}, {22,0.00200000}, {23,0.00200980}, {24,0.00200980}, {25,0.00200980}, {26,0.00208824}, {27,0.00211765}, {28,0.00210784}, {29,0.00217647}, {30,0.00216667}, {31,0.00250980}, {32,0.00290196}, {33,0.00300000}, {34,0.00300000}, {35,0.00300000}, {36,0.00300980}, {37,0.00300980}, {38,0.00303922}, {39,0.00303922}, {40,0.00308824}, {41,0.00307843}, {42,0.00310784}, {43,0.00319608}, {44,0.00327451}, {45,0.00340196}, {46,0.00379412}, {47,0.00397059}, {48,0.00400000}, {49,0.00400000}, {50,0.00400980}, {51,0.00401961}, {52,0.00411765}, {53,0.00407843}, {54,0.00410784}, {55,0.00412745}, {56,0.00412745}, {57,0.00410784}, {58,0.00422549}, {59,0.00535294}, {60,0.00478431}, {61,0.00493137}, {62,0.00505882}, {63,0.00505882}, {64,0.00504902}, {65,0.00509804}, {66,0.00509804}, {67,0.00505882}, {68,0.00507843}, {69,0.00508824}, {70,0.00512745}, {71,0.00516667}, {72,0.00531373}, {73,0.00540196}, {74,0.00610784}, {75,0.00601961}, {76,0.00604902}, {77,0.00609804}, {78,0.00607843}, {79,0.00605882}, {80,0.00606863}, {81,0.00604902}, {82,0.00607843}, {83,0.00609804}, {84,0.00617647}, {85,0.00613725}, {86,0.00629412}, {87,0.00706863}, {88,0.00657843}, {89,0.00690196}, {90,0.00696078}, {91,0.00700980}, {92,0.00704902}, {93,0.00710784}, {94,0.00708824}, {95,0.00712745}, {96,0.00714706}, {97,0.00715686}, {98,0.00724510}, {99,0.00806863}, {100,0.00727451}, {101,0.00743137}, {102,0.00750980}, {103,0.00777451}, {104,0.00793137}, {105,0.00800000}, {106,0.00808824}, {107,0.00810784}, {108,0.00812745}, {109,0.00907843}, {110,0.00813725}, {111,0.00813725}, {112,0.00815686}, {113,0.00812745}, {114,0.00827451}, {115,0.00836275}, {116,0.00843137}, {117,0.00868627}, {118,0.00939216}, {119,0.00900980}, {120,0.00901961}, {121,0.00909804}, {122,0.00908824}, {123,0.00909804}, {124,0.00919608}, {125,0.00919608}, {126,0.00916667}, {127,0.01076471}, {128,0.00917647}, {129,0.00932353}, {130,0.00951961}, {131,0.00966667}, {132,0.00984314}, {133,0.00985294}, {134,0.01000000}, {135,0.01003922}, {136,0.01034314}, {137,0.01012745}, {138,0.01020588}, {139,0.01022549}, {140,0.01021569}, {141,0.01016667}, {142,0.01022549}, {143,0.01138235}, {144,0.01040196}, {145,0.01055882}, {146,0.01067647}, {147,0.01081373}, {148,0.01095098}, {149,0.01100000}, {150,0.01109804}, {151,0.01198039}, {152,0.01115686}, {153,0.01113725}, {154,0.01115686}, {155,0.01125490}, {156,0.01127451}, {157,0.01143137}, {158,0.01261765}, {159,0.01152941}, {160,0.01167647}, {161,0.01187255}, {162,0.01194118}, {163,0.01191176}, {164,0.01205882}, {165,0.01292157}, {166,0.01206863}, {167,0.01211765}, {168,0.01224510}, {169,0.01227451}, {170,0.01226471}, {171,0.01312745}, {172,0.01239216}, {173,0.01260784}, {174,0.01256863}, {175,0.01275490}, {176,0.01281373}, {177,0.01294118}, {178,0.01394118}, {179,0.01311765}, {180,0.01319608}, {181,0.01321569}, {182,0.01315686}, {183,0.01338235}, {184,0.01435294}, {185,0.01325490}, {186,0.01336275}, {187,0.01343137}, {188,0.01357843}, {189,0.01378431}, {190,0.01467647}, {191,0.01385294}, {192,0.01397059}, {193,0.01403922}, {194,0.01400980}, {195,0.01419608}, {196,0.01518627}, {197,0.01432353}, {198,0.01414706}, {199,0.01431373}, {200,0.01436275}, {201,0.01629412}, {202,0.01446078}, {203,0.01466667}, {204,0.01481373}, {205,0.01485294}, {206,0.01503922}, {207,0.01563725}, {208,0.01502941}, {209,0.01513725}, {210,0.01517647}, {211,0.01520588}, {212,0.01687255}, {213,0.01530392}, {214,0.01530392}, {215,0.01543137}, {216,0.01558824}, {217,0.01773529}, {218,0.01575490}, {219,0.01586275}, {220,0.01594118}, {221,0.01600000}, {222,0.01713725}, {223,0.01594118}, {224,0.01616667}, {225,0.01623529}, {226,0.01627451}, {227,0.01770588}, {228,0.01620588}, {229,0.01652941}, {230,0.01659804}, {231,0.01666667}, {232,0.01892157}, {233,0.01675490}, {234,0.01690196}, {235,0.01691176}, {236,0.01701961}, {237,0.01876471}, {238,0.01725490}, {239,0.01722549}, {240,0.01730392}, {241,0.01740196}, {242,0.01813725}, {243,0.01739216}, {244,0.01751961}, {245,0.01757843}, {246,0.01920588}, {247,0.01769608}, {248,0.01797059}, {249,0.01792157}, {250,0.01796078}, {251,0.01914706}, {252,0.01822549}, {253,0.01816667}, {254,0.01834314}, {255,0.02008824}, {256,0.01824510}, {257,0.01853922}, {258,0.01862745}, {259,0.01871569}, {260,0.01943137}, {261,0.01865686}, {262,0.01872549}, {263,0.01887255}, {264,0.02057843}, {265,0.01901961}, {266,0.01903922}, {267,0.01916667}, {268,0.02165686}, {269,0.01928431}, {270,0.01939216}, {271,0.01949020}, {272,0.02029412}, {273,0.01959804}, {274,0.01970588}, {275,0.01979412}, {276,0.01977451}, {277,0.02021569}, {278,0.01989216}, {279,0.02010784}, {280,0.02009804}, {281,0.02138235}, {282,0.02023529}, {283,0.02028431}, {284,0.02037255}, {285,0.02102941}, {286,0.02050000}, {287,0.02054902}, {288,0.02076471}, {289,0.02123529}, {290,0.02080392}, {291,0.02085294}, {292,0.02182353}, {293,0.02100000}, {294,0.02102941}, {295,0.02108824}, {296,0.02330392}, {297,0.02110784}, {298,0.02117647}, {299,0.02137255}, {300,0.02363725}, {301,0.02148039}, {302,0.02156863}, {303,0.02168627}, {304,0.02319608}, {305,0.02184314}, {306,0.02191176}, {307,0.02217647}, {308,0.02250000}, {309,0.02220588}, {310,0.02216667}, {311,0.02533333}, {312,0.02233333}, {313,0.02241176}, {314,0.02261765}, {315,0.02403922}, {316,0.02271569}, {317,0.02272549}, {318,0.02378431}, {319,0.02283333}, {320,0.02285294}, {321,0.02296078}, {322,0.02505882}, {323,0.02308824}, {324,0.02312745}, {325,0.02311765}, {326,0.02330392}, {327,0.02330392}, {328,0.02349020}, {329,0.02539216}, {330,0.02355882}, {331,0.02372549}, {332,0.02457843}, {333,0.02384314}, {334,0.02391176}, {335,0.02399020}, {336,0.02533333}, {337,0.02411765}, {338,0.02415686}, {339,0.02695098}, {340,0.02420588}, {341,0.02418627}, {342,0.02444118}, {343,0.02487255}, {344,0.02450000}, {345,0.02471569}, {346,0.02633333}, {347,0.02480392}, {348,0.02488235}, {349,0.02752941}, {350,0.02509804}, {351,0.02504902}, {352,0.02620588}, {353,0.02499020}, {354,0.02519608}, {355,0.02507843}, {356,0.02660784}, {357,0.02547059}, {358,0.02550980}, {359,0.02695098}, {360,0.02555882}, {361,0.02558824}, {362,0.02775490}, {363,0.02577451}, {364,0.02587255}, {365,0.02851961}, {366,0.02599020}, {367,0.02603922}, {368,0.02902941}, {369,0.02626471}, {370,0.02627451}, {371,0.02936275}, {372,0.02645098}, {373,0.02651961}, {374,0.02843137}, {375,0.02650980}, {376,0.02677451}, {377,0.02798039}, {378,0.02664706}, {379,0.02687255}, {380,0.02787255}, {381,0.02682353}, {382,0.02718627}, {383,0.02825490}, {384,0.02700980}, {385,0.02729412}, {386,0.02906863}, {387,0.02733333}, {388,0.02761765}, {389,0.03043137}, {390,0.02766667}, {391,0.02770588}, {392,0.03111765}, {393,0.02803922}, {394,0.02802941}, {395,0.03079412}, {396,0.02801961}, {397,0.02813725}, {398,0.03062745}, {399,0.02835294}, {400,0.02850000}, {401,0.03030392}, {402,0.02855882}, {403,0.02847059}, {404,0.02968627}, {405,0.02864706}, {406,0.02880392}, {407,0.02889216}, {408,0.02900000}, {409,0.03128431}, {410,0.02900000}, {411,0.02923529}, {412,0.03223529}, {413,0.02939216}, {414,0.02939216}, {415,0.03140196}, {416,0.02953922}, {417,0.02960784}, {418,0.03035294}, {419,0.02987255}, {420,0.03134314}, {421,0.02966667}, {422,0.02984314}, {423,0.03285294}, {424,0.03010784}, {425,0.03025490}, {426,0.03152941}, {427,0.03019608}, {428,0.03158824}, {429,0.03049020}, {430,0.03047059}, {431,0.03385294}, {432,0.03067647}, {433,0.03073529}, {434,0.03223529}, {435,0.03081373}, {436,0.03246078}, {437,0.03099020}, {438,0.03100000}, {439,0.03398039}, {440,0.03110784}, {441,0.03116667}, {442,0.03196078}, {443,0.03141176}, {444,0.03501961}, {445,0.03150980}, {446,0.03154902}, {447,0.03323529}, {448,0.03169608}, {449,0.03397059}, {450,0.03170588}, {451,0.03205882}, {452,0.03406863}, {453,0.03198039}, {454,0.03367647}, {455,0.03221569}, {456,0.03233333}, {457,0.03487255}, {458,0.03245098}, {459,0.03423529}, {460,0.03254902}, {461,0.03269608}, {462,0.03506863}, {463,0.03273529}, {464,0.03413725}, {465,0.03300980}, {466,0.03296078}, {467,0.03537255}, {468,0.03306863}, {469,0.03616667}, {470,0.03320588}, {471,0.03342157}, {472,0.03477451}, {473,0.03344118}, {474,0.03729412}, {475,0.03360784}, {476,0.03364706}, {477,0.03549020}, {478,0.03382353}, {479,0.03696078}, {480,0.03404902}, {481,0.03523529}, {482,0.03390196}, {483,0.03406863}, {484,0.03576471}, {485,0.03436275}, {486,0.03785294}, {487,0.03452941}, {488,0.03602941}, {489,0.03445098}, {490,0.03463725}, {491,0.03690196}, {492,0.03478431}, {493,0.03878431}, {494,0.03500980}, {495,0.03666667}, {496,0.03501961}, {497,0.03508824}, {498,0.03720588}, {499,0.03534314}, {500,0.03894118}, {505,0.03577451}, {510,0.03747059}, {515,0.03615686}, {520,0.03677451}, {525,0.03792157}, {530,0.03740196}, {535,0.03951961}, {540,0.03814706}, {545,0.04097059}, {550,0.03890196}, {555,0.04247059}, {560,0.03954902}, {565,0.04355882}, {570,0.04020588}, {575,0.04437255}, {580,0.04097059}, {585,0.04501961}, {590,0.04168627}, {595,0.04570588}, {600,0.04235294}, {605,0.04560784}, {610,0.04304902}, {615,0.04566667}, {620,0.04370588}, {625,0.04542157}, {630,0.04431373}, {635,0.04473529}, {640,0.04819608}, {645,0.04534314}, {650,0.05053922}, {655,0.04620588}, {660,0.04939216}, {665,0.04660784}, {670,0.04805882}, {675,0.05030392}, {680,0.04765686}, {685,0.05241176}, {690,0.04854902}, {695,0.05060784}, {700,0.05120588}, {705,0.04937255}, {710,0.05398039}, {715,0.05017647}, {720,0.05149020}, {725,0.05685294}, {730,0.05130392}, {735,0.05426471}, {740,0.05379412}, {745,0.05211765}, {750,0.05878431}, {755,0.05523529}, {760,0.05323529}, {765,0.05818627}, {770,0.05627451}, {775,0.05426471}, {780,0.05920588}, {785,0.05707843}, {790,0.05521569}, {795,0.05982353}, {800,0.05865686}, {805,0.05635294}, {810,0.05952941}, {815,0.06383333}, {820,0.05736275}, {825,0.05904902}, {830,0.06315686}, {835,0.06108824}, {840,0.05871569}, {845,0.06239216}, {850,0.06593137}, {855,0.05964706}, {860,0.06060784}, {865,0.06458824}, {870,0.06783333}, {875,0.06117647}, {880,0.06200000}, {885,0.06539216}, {890,0.06872549}, {895,0.06473529}, {900,0.06263725}, {905,0.06625490}, {910,0.06866667}, {915,0.07016667}, {920,0.06411765}, {925,0.06502941}, {930,0.06795098}, {935,0.07052941}, {940,0.07234314}, {945,0.06583333}, {950,0.06613725}, {955,0.06905882}, {960,0.07122549}, {965,0.07383333}, {970,0.07149020}, {975,0.06787255}, {980,0.06874510}, {985,0.07108824}, {990,0.07325490}, {995,0.07451961}, {1000,0.08175490}, {1010,0.07408824}, {1020,0.07107843}, {1030,0.07173529}, {1040,0.07587255}, {1050,0.07748039}, {1060,0.07987255}, {1070,0.08188235}, {1080,0.08402941}, {1090,0.08613725}, {1100,0.08782353}, {1110,0.08894118}, {1120,0.09101961}, {1130,0.09030392}, {1140,0.08795098}, {1150,0.08928431}, {1160,0.08746078}, {1170,0.08847059}, {1180,0.09012745}, {1190,0.09239216}, {1200,0.09319608}, {1210,0.09318627}, {1220,0.09335294}, {1230,0.09366667}, {1240,0.09358824}, {1250,0.09337255}, {1260,0.09304902}, {1270,0.09266667}, {1280,0.09253922}, {1290,0.09160784}, {1300,0.09362745}, {1310,0.09694118}, {1320,0.10153922}, {1330,0.10093137}, {1340,0.09976471}, {1350,0.09840196}, {1360,0.09716667}, {1370,0.09798039}, {1380,0.10802941}, {1390,0.10495098}, {1400,0.10338235}, {1410,0.10320588}, {1420,0.10760784}, {1430,0.11474510}, {1440,0.10925490}, {1450,0.10572549}, {1460,0.10710784}, {1470,0.11333333}, {1480,0.11034314}, {1490,0.10767647}, {1500,0.11624510}, {1510,0.11531373}, {1520,0.11129412}, {1530,0.11196078}, {1540,0.12020588}, {1550,0.11550000}, {1560,0.11364706}, {1570,0.11993137}, {1580,0.11797059}, {1590,0.11444118}, {1600,0.12064706}, {1610,0.11719608}, {1620,0.12486275}, {1630,0.12150000}, {1640,0.11926471}, {1650,0.12641176}, {1660,0.12021569}, {1670,0.12897059}, {1680,0.12355882}, {1690,0.12758824}, {1700,0.12609804}, {1710,0.12562745}, {1720,0.12940196}, {1730,0.12517647}, {1740,0.13280392}, {1750,0.12693137}, {1760,0.13161765}, {1770,0.12847059}, {1780,0.13247059}, {1790,0.13326471}, {1800,0.13316667}, {1810,0.13868627}, {1820,0.13336275}, {1830,0.13924510}, {1840,0.13468627}, {1850,0.13901961}, {1860,0.13778431}, {1870,0.14147059}, {1880,0.14792157}, {1890,0.13799020}, {1900,0.14259804}, {1910,0.14733333}, {1920,0.14274510}, {1930,0.14721569}, {1940,0.14764706}, {1950,0.14652941}, {1960,0.14811765}, {1970,0.15095098}, {1980,0.14653922}, {1990,0.14875490}, {2000,0.15240196}, {2050,0.14983333}, {2100,0.15731373}, {2150,0.16092157}, {2200,0.16608824}, {2250,0.17021569}, {2300,0.17414706}, {2350,0.17787255}, {2400,0.18137255}, {2450,0.18445098}, {2500,0.19590196}, {2550,0.19660784}, {2600,0.19554902}, {2650,0.20246078}, {2700,0.20690196}, {2750,0.20600000}, {2800,0.21222549}, {2850,0.21398039}, {2900,0.22287255}, {2950,0.22181373}, {3000,0.23005882}, {3050,0.22608824}, {3100,0.23741176}, {3150,0.24153922}, {3200,0.23776471}, {3250,0.25013725}, {3300,0.25613725}, {3350,0.25655882}, {3400,0.26354902}, {3450,0.27050980}, {3500,0.27949020}, {3550,0.28362745}, {3600,0.28239216}, {3650,0.28628431}, {3700,0.28566667}, {3750,0.28618627}, {3800,0.29076471}, {3850,0.29789216}, {3900,0.31079412}, {3950,0.30289216}, {4000,0.31549020}, {4050,0.31014706}, {4100,0.32219608}, {4150,0.31805882}, {4200,0.32669608}, {4250,0.33212745}, {4300,0.33093137}, {4350,0.33739216}, {4400,0.35075490}, {4450,0.34150980}, {4500,0.34666667}, {4550,0.35061765}, {4600,0.35558824}, {4650,0.36088235}, {4700,0.36440196}, {4750,0.36749020}, {4800,0.37081373}, {4850,0.37277451}, {4900,0.38945098}, {4950,0.39307843}, {5000,0.39109804}, {5050,0.38959804}, {5100,0.40558824}, {5150,0.40555882}, {5200,0.43221569}, {5250,0.41876471}, {5300,0.42473529}, {5350,0.41784314}, {5400,0.42669608}, {5450,0.43210784}, {5500,0.43480392}, {5550,0.43825490}, {5600,0.45256863}, {5650,0.44150980}, {5700,0.44703922}, {5750,0.45324510}, {5800,0.46666667}, {5850,0.47246078}, {5900,0.47363725}, {5950,0.47316667}, {6000,0.46863725}, {6050,0.47650000}, {6100,0.48273529}, {6150,0.49100980}, {6200,0.48595098}, {6250,0.49448039}, {6300,0.49633333}, {6350,0.52425490}, {6400,0.51764706}, {6450,0.51331373}, {6500,0.52405882}, {6550,0.51977451}, {6600,0.51688235}, {6650,0.54997059}, {6700,0.52968627}, {6750,0.52965686}, {6800,0.53997059}, {6850,0.54470588}, {6900,0.58254902}, {6950,0.55562745}, {7000,0.56547059}, {7050,0.56365686}, {7100,0.58244118}, {7150,0.59561765}, {7200,0.58487255}, {7250,0.57050980}, {7300,0.57763725}, {7350,0.58938235}, {7400,0.58793137}, {7450,0.58970588}, {7500,0.65149020}, {7550,0.62356863}, {7600,0.63309804}, {7650,0.64914706}, {7700,0.63729412}, {7750,0.62830392}, {7800,0.62861765}, {7850,0.65273529}, {7900,0.63226471}, {7950,0.64362745}, {8000,0.65200980}, {8050,0.64184314}, {8100,0.64592157}, {8150,0.68708824}, {8200,0.65146078}, {8250,0.65801961}, {8300,0.66017647}, {8350,0.67810784}, {8400,0.67630392}, {8450,0.65939216}, {8500,0.73109804}, {8550,0.70317647}, {8600,0.68489216}, {8650,0.71438235}, {8700,0.71432353}, {8750,0.72251961}, {8800,0.72439216}, {8850,0.73338235}, {8900,0.71725490}, {8950,0.71931373}, {9000,0.74168627}, {9050,0.72757843}, {9100,0.75671569}, {9150,0.77059804}, {9200,0.74956863}, {9250,0.78869608}, {9300,0.78129412}, {9350,0.78259804}, {9400,0.78210784}, {9450,0.78860784}, {9500,0.77535294}, {9550,0.78322549}, {9600,0.78524510}, {9650,0.77104902}, {9700,0.82510784}, {9750,0.79741176}, {9800,0.78496078}, {9850,0.81788235}, {9900,0.79750980}, {9950,0.81552941}, {10000,0.81158824}, {10100,0.86046078}, {10200,0.82079412}, {10300,0.82236275}, {10400,0.85247059}, {10500,0.87531373}, {10600,0.88352941}, {10700,0.87498039}, {10800,0.90966667}, {10900,0.89088235}, {11000,0.88249020}, {11100,0.96381373}, {11200,0.90134314}, {11300,0.94443137}, {11400,0.97068627}, {11500,0.94626471}, {11600,0.92213725}, {11700,0.93746078}, {11800,0.92502941}, {11900,1.00167647}, {12000,0.99854902}, {12100,0.98434314}, {12200,1.00396078}, {12300,1.00394118}, {12400,1.04899020}, {12500,1.00784314}, {12600,1.03932353}, {12700,1.05481373}, {12800,1.11210784}, {12900,1.12509804}, {13000,1.11547059}, {13100,1.09531373}, {13200,1.07847059}, {13300,1.16859804}, {13400,1.10121569}, {13500,1.15971569}, {13600,1.10855882}, {13700,1.12698039}, {13800,1.21105882}, {13900,1.22748039}, {14000,1.15062745}, {14100,1.21512745}, {14200,1.22108824}, {14300,1.23320588}, {14400,1.19048039}, {14500,1.20938235}, {14600,1.19154902}, {14700,1.21807843}, {14800,1.24564706}, {14900,1.24287255}, {15000,1.30077451}, {15100,1.35182353}, {15200,1.32931373}, {15300,1.36539216}, {15400,1.36543137}, {15500,1.30351961}, {15600,1.25394118}, {15700,1.32384314}, {15800,1.31623529}, {15900,1.36511765}, {16000,1.29488235}, {16100,1.36513725}, {16200,1.35914706}, {16300,1.39627451}, {16400,1.41165686}, {16500,1.40531373}, {16600,1.37643137}, {16700,1.35329412}, {16800,1.47999020}, {16900,1.40876471}, {17000,1.46687255}, {17100,1.42493137}, {17200,1.47695098}, {17300,1.46400980}, {17400,1.44901961}, {17500,1.42551961}, {17600,1.50136275}, {17700,1.49493137}, {17800,1.56618627}, {17900,1.49100980}, {18000,1.47471569}, {18100,1.61312745}, {18200,1.47677451}, {18300,1.59073529}, {18400,1.58415686}, {18500,1.54333333}, {18600,1.52656863}, {18700,1.54462745}, {18800,1.60913725}, {18900,1.60637255}, {19000,1.65063725}, {19100,1.61809804}, {19200,1.52960784}, {19300,1.72172549}, {19400,1.56215686}, {19500,1.67668627}, {19600,1.73213725}, {19700,1.64382353}, {19800,1.68731373}, {19900,1.58861765}, {20000,1.66238235}};
data["big"]["Ltac2LowLevel"]["Aggregate"]["user"] = {{1,0.04787255}, {2,0.00094118}, {3,0.00080392}, {4,0.00162745}, {5,0.00119608}, {6,0.00109804}, {7,0.00125490}, {8,0.00139216}, {9,0.00127451}, {10,0.00158824}, {11,0.00135294}, {12,0.00139216}, {13,0.00150980}, {14,0.00168627}, {15,0.00145098}, {16,0.00208824}, {17,0.00130392}, {18,0.00225490}, {19,0.00206863}, {20,0.00168627}, {21,0.00224510}, {22,0.00193137}, {23,0.00204902}, {24,0.00273529}, {25,0.00240196}, {26,0.00232353}, {27,0.00266667}, {28,0.00274510}, {29,0.00277451}, {30,0.00262745}, {31,0.00260784}, {32,0.00280392}, {33,0.00294118}, {34,0.00319608}, {35,0.00292157}, {36,0.00322549}, {37,0.00308824}, {38,0.00300000}, {39,0.00313725}, {40,0.00327451}, {41,0.00336275}, {42,0.00351961}, {43,0.00344118}, {44,0.00372549}, {45,0.00362745}, {46,0.00355882}, {47,0.00396078}, {48,0.00363725}, {49,0.00392157}, {50,0.00404902}, {51,0.00388235}, {52,0.00415686}, {53,0.00444118}, {54,0.00409804}, {55,0.00453922}, {56,0.00441176}, {57,0.00446078}, {58,0.00446078}, {59,0.00542157}, {60,0.00474510}, {61,0.00472549}, {62,0.00496078}, {63,0.00479412}, {64,0.00510784}, {65,0.00479412}, {66,0.00520588}, {67,0.00474510}, {68,0.00506863}, {69,0.00515686}, {70,0.00529412}, {71,0.00551961}, {72,0.00533333}, {73,0.00564706}, {74,0.00613725}, {75,0.00555882}, {76,0.00571569}, {77,0.00558824}, {78,0.00609804}, {79,0.00579412}, {80,0.00570588}, {81,0.00623529}, {82,0.00642157}, {83,0.00582353}, {84,0.00593137}, {85,0.00634314}, {86,0.00655882}, {87,0.00710784}, {88,0.00653922}, {89,0.00673529}, {90,0.00635294}, {91,0.00609804}, {92,0.00657843}, {93,0.00674510}, {94,0.00670588}, {95,0.00703922}, {96,0.00709804}, {97,0.00702941}, {98,0.00716667}, {99,0.00766667}, {100,0.00748039}, {101,0.00716667}, {102,0.00733333}, {103,0.00748039}, {104,0.00766667}, {105,0.00770588}, {106,0.00767647}, {107,0.00793137}, {108,0.00797059}, {109,0.00942157}, {110,0.00821569}, {111,0.00791176}, {112,0.00829412}, {113,0.00825490}, {114,0.00824510}, {115,0.00848039}, {116,0.00859804}, {117,0.00859804}, {118,0.00996078}, {119,0.00823529}, {120,0.00893137}, {121,0.00911765}, {122,0.00926471}, {123,0.00883333}, {124,0.00934314}, {125,0.00888235}, {126,0.00928431}, {127,0.01100980}, {128,0.00961765}, {129,0.00928431}, {130,0.00965686}, {131,0.00998039}, {132,0.00955882}, {133,0.00997059}, {134,0.01000000}, {135,0.01019608}, {136,0.01084314}, {137,0.00997059}, {138,0.01022549}, {139,0.01060784}, {140,0.01026471}, {141,0.01026471}, {142,0.01055882}, {143,0.01196078}, {144,0.01086275}, {145,0.01093137}, {146,0.01059804}, {147,0.01096078}, {148,0.01105882}, {149,0.01119608}, {150,0.01152941}, {151,0.01242157}, {152,0.01155882}, {153,0.01165686}, {154,0.01179412}, {155,0.01169608}, {156,0.01172549}, {157,0.01173529}, {158,0.01300000}, {159,0.01191176}, {160,0.01218627}, {161,0.01220588}, {162,0.01218627}, {163,0.01229412}, {164,0.01243137}, {165,0.01320588}, {166,0.01231373}, {167,0.01261765}, {168,0.01266667}, {169,0.01266667}, {170,0.01283333}, {171,0.01304902}, {172,0.01308824}, {173,0.01303922}, {174,0.01292157}, {175,0.01298039}, {176,0.01334314}, {177,0.01289216}, {178,0.01414706}, {179,0.01336275}, {180,0.01344118}, {181,0.01362745}, {182,0.01317647}, {183,0.01401961}, {184,0.01439216}, {185,0.01344118}, {186,0.01395098}, {187,0.01377451}, {188,0.01370588}, {189,0.01406863}, {190,0.01514706}, {191,0.01418627}, {192,0.01382353}, {193,0.01425490}, {194,0.01443137}, {195,0.01439216}, {196,0.01536275}, {197,0.01464706}, {198,0.01456863}, {199,0.01448039}, {200,0.01480392}, {201,0.01650980}, {202,0.01498039}, {203,0.01515686}, {204,0.01485294}, {205,0.01476471}, {206,0.01516667}, {207,0.01557843}, {208,0.01510784}, {209,0.01522549}, {210,0.01550000}, {211,0.01550980}, {212,0.01652941}, {213,0.01536275}, {214,0.01532353}, {215,0.01555882}, {216,0.01569608}, {217,0.01768627}, {218,0.01590196}, {219,0.01600980}, {220,0.01602941}, {221,0.01590196}, {222,0.01701961}, {223,0.01622549}, {224,0.01598039}, {225,0.01623529}, {226,0.01654902}, {227,0.01744118}, {228,0.01637255}, {229,0.01665686}, {230,0.01643137}, {231,0.01691176}, {232,0.01842157}, {233,0.01688235}, {234,0.01671569}, {235,0.01695098}, {236,0.01676471}, {237,0.01864706}, {238,0.01703922}, {239,0.01710784}, {240,0.01725490}, {241,0.01730392}, {242,0.01796078}, {243,0.01725490}, {244,0.01742157}, {245,0.01761765}, {246,0.01893137}, {247,0.01758824}, {248,0.01797059}, {249,0.01802941}, {250,0.01789216}, {251,0.01886275}, {252,0.01795098}, {253,0.01805882}, {254,0.01821569}, {255,0.02003922}, {256,0.01805882}, {257,0.01850980}, {258,0.01821569}, {259,0.01851961}, {260,0.01924510}, {261,0.01845098}, {262,0.01885294}, {263,0.01877451}, {264,0.02027451}, {265,0.01900000}, {266,0.01897059}, {267,0.01885294}, {268,0.02191176}, {269,0.01891176}, {270,0.01902941}, {271,0.01935294}, {272,0.02050980}, {273,0.01942157}, {274,0.01940196}, {275,0.01950980}, {276,0.01963725}, {277,0.02016667}, {278,0.01951961}, {279,0.01978431}, {280,0.01994118}, {281,0.02126471}, {282,0.02006863}, {283,0.01986275}, {284,0.02016667}, {285,0.02118627}, {286,0.02042157}, {287,0.02037255}, {288,0.02057843}, {289,0.02130392}, {290,0.02016667}, {291,0.02102941}, {292,0.02170588}, {293,0.02096078}, {294,0.02100980}, {295,0.02110784}, {296,0.02371569}, {297,0.02163725}, {298,0.02109804}, {299,0.02153922}, {300,0.02376471}, {301,0.02147059}, {302,0.02190196}, {303,0.02182353}, {304,0.02359804}, {305,0.02197059}, {306,0.02196078}, {307,0.02210784}, {308,0.02286275}, {309,0.02256863}, {310,0.02232353}, {311,0.02539216}, {312,0.02251961}, {313,0.02239216}, {314,0.02300000}, {315,0.02412745}, {316,0.02260784}, {317,0.02287255}, {318,0.02410784}, {319,0.02285294}, {320,0.02306863}, {321,0.02329412}, {322,0.02520588}, {323,0.02360784}, {324,0.02347059}, {325,0.02350980}, {326,0.02370588}, {327,0.02351961}, {328,0.02356863}, {329,0.02576471}, {330,0.02401961}, {331,0.02418627}, {332,0.02503922}, {333,0.02423529}, {334,0.02418627}, {335,0.02448039}, {336,0.02552941}, {337,0.02457843}, {338,0.02450000}, {339,0.02707843}, {340,0.02450000}, {341,0.02434314}, {342,0.02493137}, {343,0.02500980}, {344,0.02475490}, {345,0.02501961}, {346,0.02665686}, {347,0.02507843}, {348,0.02506863}, {349,0.02765686}, {350,0.02515686}, {351,0.02549020}, {352,0.02673529}, {353,0.02509804}, {354,0.02532353}, {355,0.02559804}, {356,0.02682353}, {357,0.02570588}, {358,0.02568627}, {359,0.02701961}, {360,0.02557843}, {361,0.02581373}, {362,0.02768627}, {363,0.02638235}, {364,0.02632353}, {365,0.02833333}, {366,0.02624510}, {367,0.02624510}, {368,0.02865686}, {369,0.02618627}, {370,0.02649020}, {371,0.02923529}, {372,0.02691176}, {373,0.02642157}, {374,0.02832353}, {375,0.02661765}, {376,0.02706863}, {377,0.02792157}, {378,0.02684314}, {379,0.02719608}, {380,0.02779412}, {381,0.02684314}, {382,0.02692157}, {383,0.02831373}, {384,0.02692157}, {385,0.02723529}, {386,0.02931373}, {387,0.02750980}, {388,0.02760784}, {389,0.03024510}, {390,0.02780392}, {391,0.02803922}, {392,0.03078431}, {393,0.02802941}, {394,0.02785294}, {395,0.03061765}, {396,0.02793137}, {397,0.02815686}, {398,0.03046078}, {399,0.02856863}, {400,0.02859804}, {401,0.02997059}, {402,0.02866667}, {403,0.02843137}, {404,0.02940196}, {405,0.02859804}, {406,0.02879412}, {407,0.02858824}, {408,0.02909804}, {409,0.03100980}, {410,0.02900000}, {411,0.02928431}, {412,0.03206863}, {413,0.02923529}, {414,0.02934314}, {415,0.03110784}, {416,0.02925490}, {417,0.02955882}, {418,0.03003922}, {419,0.02981373}, {420,0.03130392}, {421,0.02963725}, {422,0.02986275}, {423,0.03313725}, {424,0.02977451}, {425,0.02971569}, {426,0.03142157}, {427,0.03028431}, {428,0.03127451}, {429,0.03059804}, {430,0.03008824}, {431,0.03358824}, {432,0.03036275}, {433,0.03067647}, {434,0.03219608}, {435,0.03057843}, {436,0.03227451}, {437,0.03060784}, {438,0.03084314}, {439,0.03397059}, {440,0.03078431}, {441,0.03073529}, {442,0.03185294}, {443,0.03090196}, {444,0.03523529}, {445,0.03106863}, {446,0.03136275}, {447,0.03306863}, {448,0.03169608}, {449,0.03359804}, {450,0.03133333}, {451,0.03162745}, {452,0.03455882}, {453,0.03199020}, {454,0.03357843}, {455,0.03232353}, {456,0.03226471}, {457,0.03500980}, {458,0.03243137}, {459,0.03427451}, {460,0.03244118}, {461,0.03263725}, {462,0.03532353}, {463,0.03275490}, {464,0.03459804}, {465,0.03289216}, {466,0.03302941}, {467,0.03547059}, {468,0.03291176}, {469,0.03657843}, {470,0.03324510}, {471,0.03336275}, {472,0.03503922}, {473,0.03362745}, {474,0.03763725}, {475,0.03346078}, {476,0.03377451}, {477,0.03563725}, {478,0.03412745}, {479,0.03700980}, {480,0.03396078}, {481,0.03561765}, {482,0.03368627}, {483,0.03452941}, {484,0.03608824}, {485,0.03451961}, {486,0.03795098}, {487,0.03484314}, {488,0.03616667}, {489,0.03473529}, {490,0.03484314}, {491,0.03686275}, {492,0.03520588}, {493,0.03874510}, {494,0.03529412}, {495,0.03704902}, {496,0.03530392}, {497,0.03527451}, {498,0.03752941}, {499,0.03576471}, {500,0.03891176}, {505,0.03608824}, {510,0.03740196}, {515,0.03623529}, {520,0.03707843}, {525,0.03807843}, {530,0.03746078}, {535,0.03949020}, {540,0.03798039}, {545,0.04121569}, {550,0.03923529}, {555,0.04215686}, {560,0.03978431}, {565,0.04351961}, {570,0.04052941}, {575,0.04403922}, {580,0.04109804}, {585,0.04492157}, {590,0.04140196}, {595,0.04556863}, {600,0.04224510}, {605,0.04559804}, {610,0.04278431}, {615,0.04554902}, {620,0.04340196}, {625,0.04509804}, {630,0.04413725}, {635,0.04429412}, {640,0.04840196}, {645,0.04500000}, {650,0.05066667}, {655,0.04659804}, {660,0.04955882}, {665,0.04673529}, {670,0.04815686}, {675,0.05060784}, {680,0.04794118}, {685,0.05210784}, {690,0.04871569}, {695,0.05043137}, {700,0.05134314}, {705,0.04967647}, {710,0.05365686}, {715,0.05033333}, {720,0.05150000}, {725,0.05675490}, {730,0.05134314}, {735,0.05419608}, {740,0.05375490}, {745,0.05210784}, {750,0.05900980}, {755,0.05491176}, {760,0.05317647}, {765,0.05842157}, {770,0.05602941}, {775,0.05433333}, {780,0.05915686}, {785,0.05695098}, {790,0.05498039}, {795,0.05961765}, {800,0.05856863}, {805,0.05633333}, {810,0.05978431}, {815,0.06347059}, {820,0.05720588}, {825,0.05931373}, {830,0.06314706}, {835,0.06094118}, {840,0.05871569}, {845,0.06248039}, {850,0.06543137}, {855,0.05989216}, {860,0.06091176}, {865,0.06400000}, {870,0.06738235}, {875,0.06151961}, {880,0.06207843}, {885,0.06488235}, {890,0.06832353}, {895,0.06463725}, {900,0.06277451}, {905,0.06554902}, {910,0.06830392}, {915,0.06979412}, {920,0.06400000}, {925,0.06457843}, {930,0.06782353}, {935,0.07054902}, {940,0.07200000}, {945,0.06546078}, {950,0.06593137}, {955,0.06888235}, {960,0.07132353}, {965,0.07349020}, {970,0.07137255}, {975,0.06748039}, {980,0.06822549}, {985,0.07124510}, {990,0.07325490}, {995,0.07444118}, {1000,0.08167647}, {1010,0.07422549}, {1020,0.07145098}, {1030,0.07241176}, {1040,0.07578431}, {1050,0.07705882}, {1060,0.07959804}, {1070,0.08182353}, {1080,0.08386275}, {1090,0.08579412}, {1100,0.08761765}, {1110,0.08839216}, {1120,0.09059804}, {1130,0.08981373}, {1140,0.08760784}, {1150,0.08891176}, {1160,0.08742157}, {1170,0.08786275}, {1180,0.08936275}, {1190,0.09167647}, {1200,0.09259804}, {1210,0.09265686}, {1220,0.09279412}, {1230,0.09370588}, {1240,0.09332353}, {1250,0.09301961}, {1260,0.09267647}, {1270,0.09253922}, {1280,0.09190196}, {1290,0.09135294}, {1300,0.09306863}, {1310,0.09665686}, {1320,0.10087255}, {1330,0.10062745}, {1340,0.09933333}, {1350,0.09799020}, {1360,0.09709804}, {1370,0.09788235}, {1380,0.10769608}, {1390,0.10436275}, {1400,0.10290196}, {1410,0.10303922}, {1420,0.10755882}, {1430,0.11413725}, {1440,0.10940196}, {1450,0.10576471}, {1460,0.10703922}, {1470,0.11250980}, {1480,0.11002941}, {1490,0.10740196}, {1500,0.11562745}, {1510,0.11439216}, {1520,0.11100980}, {1530,0.11149020}, {1540,0.11999020}, {1550,0.11516667}, {1560,0.11315686}, {1570,0.11925490}, {1580,0.11753922}, {1590,0.11400980}, {1600,0.11995098}, {1610,0.11677451}, {1620,0.12406863}, {1630,0.12123529}, {1640,0.11865686}, {1650,0.12580392}, {1660,0.12031373}, {1670,0.12828431}, {1680,0.12321569}, {1690,0.12747059}, {1700,0.12551961}, {1710,0.12524510}, {1720,0.12897059}, {1730,0.12456863}, {1740,0.13234314}, {1750,0.12633333}, {1760,0.13063725}, {1770,0.12808824}, {1780,0.13196078}, {1790,0.13290196}, {1800,0.13260784}, {1810,0.13819608}, {1820,0.13279412}, {1830,0.13859804}, {1840,0.13451961}, {1850,0.13859804}, {1860,0.13736275}, {1870,0.14055882}, {1880,0.14705882}, {1890,0.13738235}, {1900,0.14186275}, {1910,0.14643137}, {1920,0.14218627}, {1930,0.14667647}, {1940,0.14684314}, {1950,0.14596078}, {1960,0.14752941}, {1970,0.15070588}, {1980,0.14608824}, {1990,0.14809804}, {2000,0.15183333}, {2050,0.14932353}, {2100,0.15691176}, {2150,0.16055882}, {2200,0.16527451}, {2250,0.16915686}, {2300,0.17335294}, {2350,0.17701961}, {2400,0.18044118}, {2450,0.18371569}, {2500,0.19491176}, {2550,0.19553922}, {2600,0.19509804}, {2650,0.20167647}, {2700,0.20596078}, {2750,0.20515686}, {2800,0.21123529}, {2850,0.21334314}, {2900,0.22155882}, {2950,0.22055882}, {3000,0.22915686}, {3050,0.22540196}, {3100,0.23644118}, {3150,0.24006863}, {3200,0.23678431}, {3250,0.24859804}, {3300,0.25472549}, {3350,0.25549020}, {3400,0.26190196}, {3450,0.26951961}, {3500,0.27839216}, {3550,0.28238235}, {3600,0.28044118}, {3650,0.28493137}, {3700,0.28394118}, {3750,0.28518627}, {3800,0.28991176}, {3850,0.29765686}, {3900,0.31037255}, {3950,0.30221569}, {4000,0.31496078}, {4050,0.30983333}, {4100,0.32205882}, {4150,0.31716667}, {4200,0.32616667}, {4250,0.33150000}, {4300,0.33034314}, {4350,0.33668627}, {4400,0.35008824}, {4450,0.34086275}, {4500,0.34591176}, {4550,0.35000000}, {4600,0.35489216}, {4650,0.36003922}, {4700,0.36353922}, {4750,0.36666667}, {4800,0.37039216}, {4850,0.37252941}, {4900,0.38864706}, {4950,0.39223529}, {5000,0.39046078}, {5050,0.38867647}, {5100,0.40449020}, {5150,0.40436275}, {5200,0.43153922}, {5250,0.41824510}, {5300,0.42414706}, {5350,0.41729412}, {5400,0.42598039}, {5450,0.43139216}, {5500,0.43389216}, {5550,0.43717647}, {5600,0.45161765}, {5650,0.44055882}, {5700,0.44597059}, {5750,0.45217647}, {5800,0.46577451}, {5850,0.47151961}, {5900,0.47274510}, {5950,0.47246078}, {6000,0.46803922}, {6050,0.47592157}, {6100,0.48208824}, {6150,0.49065686}, {6200,0.48514706}, {6250,0.49370588}, {6300,0.49548039}, {6350,0.52333333}, {6400,0.51719608}, {6450,0.51252941}, {6500,0.52342157}, {6550,0.51912745}, {6600,0.51616667}, {6650,0.54920588}, {6700,0.52892157}, {6750,0.52872549}, {6800,0.53918627}, {6850,0.54392157}, {6900,0.58153922}, {6950,0.55468627}, {7000,0.56493137}, {7050,0.56276471}, {7100,0.58167647}, {7150,0.59511765}, {7200,0.58400980}, {7250,0.56928431}, {7300,0.57700980}, {7350,0.58882353}, {7400,0.58712745}, {7450,0.58918627}, {7500,0.65062745}, {7550,0.62256863}, {7600,0.63225490}, {7650,0.64838235}, {7700,0.63634314}, {7750,0.62731373}, {7800,0.62771569}, {7850,0.65191176}, {7900,0.63153922}, {7950,0.64279412}, {8000,0.65140196}, {8050,0.64072549}, {8100,0.64484314}, {8150,0.68527451}, {8200,0.64814706}, {8250,0.65511765}, {8300,0.65716667}, {8350,0.67544118}, {8400,0.67312745}, {8450,0.65635294}, {8500,0.72662745}, {8550,0.69955882}, {8600,0.68222549}, {8650,0.71130392}, {8700,0.71112745}, {8750,0.71900000}, {8800,0.72154902}, {8850,0.73239216}, {8900,0.71604902}, {8950,0.71803922}, {9000,0.74037255}, {9050,0.72670588}, {9100,0.75538235}, {9150,0.76921569}, {9200,0.74841176}, {9250,0.78703922}, {9300,0.77987255}, {9350,0.78145098}, {9400,0.78122549}, {9450,0.78744118}, {9500,0.77425490}, {9550,0.78205882}, {9600,0.78362745}, {9650,0.76943137}, {9700,0.82357843}, {9750,0.79648039}, {9800,0.78395098}, {9850,0.81664706}, {9900,0.79628431}, {9950,0.81469608}, {10000,0.81038235}, {10100,0.85923529}, {10200,0.81948039}, {10300,0.82105882}, {10400,0.85095098}, {10500,0.87366667}, {10600,0.88207843}, {10700,0.87340196}, {10800,0.90815686}, {10900,0.88964706}, {11000,0.88105882}, {11100,0.96251961}, {11200,0.89962745}, {11300,0.94258824}, {11400,0.96872549}, {11500,0.94468627}, {11600,0.92046078}, {11700,0.93604902}, {11800,0.92359804}, {11900,1.00026471}, {12000,0.99701961}, {12100,0.98281373}, {12200,1.00233333}, {12300,1.00261765}, {12400,1.04754902}, {12500,1.00649020}, {12600,1.03776471}, {12700,1.05301961}, {12800,1.11063725}, {12900,1.12348039}, {13000,1.11380392}, {13100,1.09350980}, {13200,1.07712745}, {13300,1.16672549}, {13400,1.09957843}, {13500,1.15800000}, {13600,1.10728431}, {13700,1.12523529}, {13800,1.20933333}, {13900,1.22565686}, {14000,1.14899020}, {14100,1.21313725}, {14200,1.21963725}, {14300,1.23132353}, {14400,1.18876471}, {14500,1.20761765}, {14600,1.18966667}, {14700,1.21634314}, {14800,1.24365686}, {14900,1.24094118}, {15000,1.29863725}, {15100,1.34970588}, {15200,1.32704902}, {15300,1.36322549}, {15400,1.36339216}, {15500,1.30147059}, {15600,1.25228431}, {15700,1.32239216}, {15800,1.31413725}, {15900,1.36332353}, {16000,1.29248039}, {16100,1.36317647}, {16200,1.35693137}, {16300,1.39431373}, {16400,1.40919608}, {16500,1.40325490}, {16600,1.37457843}, {16700,1.35132353}, {16800,1.47768627}, {16900,1.40696078}, {17000,1.46483333}, {17100,1.42319608}, {17200,1.47483333}, {17300,1.46192157}, {17400,1.44728431}, {17500,1.42358824}, {17600,1.49951961}, {17700,1.49296078}, {17800,1.56406863}, {17900,1.48891176}, {18000,1.47277451}, {18100,1.61121569}, {18200,1.47508824}, {18300,1.58895098}, {18400,1.58209804}, {18500,1.54155882}, {18600,1.52427451}, {18700,1.54257843}, {18800,1.60706863}, {18900,1.60433333}, {19000,1.64853922}, {19100,1.61624510}, {19200,1.52782353}, {19300,1.71966667}, {19400,1.56021569}, {19500,1.67445098}, {19600,1.72999020}, {19700,1.64202941}, {19800,1.68529412}, {19900,1.58633333}, {20000,1.66061765}};
data["big"]["Ltac2LowLevel"]["Aggregate"]["system"] = {{1,0.00003922}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00003922}, {10,0.00000000}, {11,0.00000000}, {12,0.00011765}, {13,0.00000000}, {14,0.00015686}, {15,0.00003922}, {16,0.00000000}, {17,0.00003922}, {18,0.00003922}, {19,0.00003922}, {20,0.00000000}, {21,0.00007843}, {22,0.00000000}, {23,0.00003922}, {24,0.00003922}, {25,0.00003922}, {26,0.00000000}, {27,0.00000000}, {28,0.00006863}, {29,0.00003922}, {30,0.00000000}, {31,0.00000000}, {32,0.00003922}, {33,0.00007843}, {34,0.00000000}, {35,0.00003922}, {36,0.00003922}, {37,0.00000000}, {38,0.00003922}, {39,0.00003922}, {40,0.00000000}, {41,0.00003922}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00003922}, {46,0.00000000}, {47,0.00000000}, {48,0.00003922}, {49,0.00000000}, {50,0.00000000}, {51,0.00007843}, {52,0.00003922}, {53,0.00003922}, {54,0.00003922}, {55,0.00003922}, {56,0.00000000}, {57,0.00000000}, {58,0.00003922}, {59,0.00007843}, {60,0.00000000}, {61,0.00003922}, {62,0.00000000}, {63,0.00007843}, {64,0.00003922}, {65,0.00007843}, {66,0.00003922}, {67,0.00007843}, {68,0.00011765}, {69,0.00003922}, {70,0.00010784}, {71,0.00000000}, {72,0.00000000}, {73,0.00003922}, {74,0.00000000}, {75,0.00000000}, {76,0.00007843}, {77,0.00000000}, {78,0.00003922}, {79,0.00011765}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00003922}, {85,0.00003922}, {86,0.00003922}, {87,0.00003922}, {88,0.00003922}, {89,0.00000000}, {90,0.00000000}, {91,0.00007843}, {92,0.00007843}, {93,0.00000000}, {94,0.00003922}, {95,0.00003922}, {96,0.00003922}, {97,0.00003922}, {98,0.00000000}, {99,0.00003922}, {100,0.00003922}, {101,0.00003922}, {102,0.00003922}, {103,0.00011765}, {104,0.00000000}, {105,0.00003922}, {106,0.00003922}, {107,0.00003922}, {108,0.00002941}, {109,0.00000000}, {110,0.00003922}, {111,0.00002941}, {112,0.00007843}, {113,0.00003922}, {114,0.00000000}, {115,0.00003922}, {116,0.00003922}, {117,0.00003922}, {118,0.00003922}, {119,0.00003922}, {120,0.00007843}, {121,0.00000000}, {122,0.00007843}, {123,0.00000000}, {124,0.00007843}, {125,0.00003922}, {126,0.00007843}, {127,0.00003922}, {128,0.00000000}, {129,0.00007843}, {130,0.00003922}, {131,0.00000000}, {132,0.00003922}, {133,0.00000000}, {134,0.00002941}, {135,0.00000000}, {136,0.00000000}, {137,0.00011765}, {138,0.00003922}, {139,0.00000000}, {140,0.00003922}, {141,0.00010784}, {142,0.00000000}, {143,0.00000000}, {144,0.00003922}, {145,0.00000000}, {146,0.00007843}, {147,0.00003922}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00002941}, {156,0.00007843}, {157,0.00007843}, {158,0.00000000}, {159,0.00000000}, {160,0.00007843}, {161,0.00003922}, {162,0.00000000}, {163,0.00000000}, {164,0.00011765}, {165,0.00000000}, {166,0.00006863}, {167,0.00007843}, {168,0.00003922}, {169,0.00003922}, {170,0.00000000}, {171,0.00000000}, {172,0.00003922}, {173,0.00007843}, {174,0.00011765}, {175,0.00007843}, {176,0.00000000}, {177,0.00003922}, {178,0.00003922}, {179,0.00003922}, {180,0.00003922}, {181,0.00000000}, {182,0.00003922}, {183,0.00000000}, {184,0.00007843}, {185,0.00000000}, {186,0.00007843}, {187,0.00003922}, {188,0.00007843}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00003922}, {193,0.00003922}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00003922}, {198,0.00003922}, {199,0.00011765}, {200,0.00003922}, {201,0.00003922}, {202,0.00000000}, {203,0.00007843}, {204,0.00000000}, {205,0.00007843}, {206,0.00003922}, {207,0.00000000}, {208,0.00007843}, {209,0.00007843}, {210,0.00003922}, {211,0.00003922}, {212,0.00011765}, {213,0.00007843}, {214,0.00007843}, {215,0.00000000}, {216,0.00003922}, {217,0.00000000}, {218,0.00003922}, {219,0.00007843}, {220,0.00007843}, {221,0.00007843}, {222,0.00000000}, {223,0.00007843}, {224,0.00003922}, {225,0.00000000}, {226,0.00000000}, {227,0.00007843}, {228,0.00000000}, {229,0.00007843}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00003922}, {234,0.00011765}, {235,0.00006863}, {236,0.00007843}, {237,0.00011765}, {238,0.00003922}, {239,0.00002941}, {240,0.00000000}, {241,0.00003922}, {242,0.00000000}, {243,0.00003922}, {244,0.00003922}, {245,0.00007843}, {246,0.00003922}, {247,0.00003922}, {248,0.00007843}, {249,0.00003922}, {250,0.00000000}, {251,0.00002941}, {252,0.00015686}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00007843}, {258,0.00015686}, {259,0.00003922}, {260,0.00003922}, {261,0.00003922}, {262,0.00000000}, {263,0.00000000}, {264,0.00003922}, {265,0.00003922}, {266,0.00000000}, {267,0.00003922}, {268,0.00000000}, {269,0.00003922}, {270,0.00003922}, {271,0.00011765}, {272,0.00000000}, {273,0.00003922}, {274,0.00002941}, {275,0.00010784}, {276,0.00000000}, {277,0.00003922}, {278,0.00003922}, {279,0.00007843}, {280,0.00000000}, {281,0.00003922}, {282,0.00007843}, {283,0.00015686}, {284,0.00003922}, {285,0.00000000}, {286,0.00003922}, {287,0.00000000}, {288,0.00003922}, {289,0.00007843}, {290,0.00007843}, {291,0.00007843}, {292,0.00003922}, {293,0.00007843}, {294,0.00000000}, {295,0.00000000}, {296,0.00011765}, {297,0.00000000}, {298,0.00003922}, {299,0.00000000}, {300,0.00000000}, {301,0.00011765}, {302,0.00003922}, {303,0.00003922}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00003922}, {310,0.00003922}, {311,0.00011765}, {312,0.00011765}, {313,0.00000000}, {314,0.00000000}, {315,0.00003922}, {316,0.00003922}, {317,0.00003922}, {318,0.00000000}, {319,0.00007843}, {320,0.00007843}, {321,0.00011765}, {322,0.00007843}, {323,0.00003922}, {324,0.00000000}, {325,0.00007843}, {326,0.00000000}, {327,0.00007843}, {328,0.00011765}, {329,0.00000000}, {330,0.00000000}, {331,0.00007843}, {332,0.00003922}, {333,0.00000000}, {334,0.00011765}, {335,0.00003922}, {336,0.00006863}, {337,0.00000000}, {338,0.00003922}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00003922}, {343,0.00003922}, {344,0.00007843}, {345,0.00003922}, {346,0.00019608}, {347,0.00003922}, {348,0.00003922}, {349,0.00000000}, {350,0.00007843}, {351,0.00000000}, {352,0.00007843}, {353,0.00000000}, {354,0.00007843}, {355,0.00003922}, {356,0.00000000}, {357,0.00000000}, {358,0.00011765}, {359,0.00011765}, {360,0.00003922}, {361,0.00000000}, {362,0.00003922}, {363,0.00000000}, {364,0.00007843}, {365,0.00000000}, {366,0.00002941}, {367,0.00003922}, {368,0.00003922}, {369,0.00011765}, {370,0.00000000}, {371,0.00003922}, {372,0.00000000}, {373,0.00003922}, {374,0.00002941}, {375,0.00000000}, {376,0.00003922}, {377,0.00006863}, {378,0.00015686}, {379,0.00000000}, {380,0.00002941}, {381,0.00003922}, {382,0.00000000}, {383,0.00011765}, {384,0.00011765}, {385,0.00007843}, {386,0.00003922}, {387,0.00007843}, {388,0.00003922}, {389,0.00000000}, {390,0.00003922}, {391,0.00000000}, {392,0.00011765}, {393,0.00003922}, {394,0.00003922}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00003922}, {399,0.00007843}, {400,0.00000000}, {401,0.00003922}, {402,0.00003922}, {403,0.00007843}, {404,0.00003922}, {405,0.00003922}, {406,0.00006863}, {407,0.00007843}, {408,0.00000000}, {409,0.00011765}, {410,0.00003922}, {411,0.00000000}, {412,0.00003922}, {413,0.00000000}, {414,0.00000000}, {415,0.00003922}, {416,0.00002941}, {417,0.00007843}, {418,0.00000000}, {419,0.00000000}, {420,0.00003922}, {421,0.00003922}, {422,0.00000000}, {423,0.00003922}, {424,0.00000000}, {425,0.00006863}, {426,0.00003922}, {427,0.00003922}, {428,0.00003922}, {429,0.00003922}, {430,0.00006863}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00006863}, {435,0.00003922}, {436,0.00003922}, {437,0.00000000}, {438,0.00000000}, {439,0.00007843}, {440,0.00003922}, {441,0.00000000}, {442,0.00000000}, {443,0.00007843}, {444,0.00007843}, {445,0.00003922}, {446,0.00000000}, {447,0.00003922}, {448,0.00007843}, {449,0.00000000}, {450,0.00003922}, {451,0.00003922}, {452,0.00003922}, {453,0.00000000}, {454,0.00000000}, {455,0.00002941}, {456,0.00003922}, {457,0.00011765}, {458,0.00000000}, {459,0.00006863}, {460,0.00003922}, {461,0.00015686}, {462,0.00007843}, {463,0.00003922}, {464,0.00007843}, {465,0.00000000}, {466,0.00007843}, {467,0.00002941}, {468,0.00003922}, {469,0.00007843}, {470,0.00007843}, {471,0.00000000}, {472,0.00007843}, {473,0.00010784}, {474,0.00011765}, {475,0.00007843}, {476,0.00003922}, {477,0.00003922}, {478,0.00003922}, {479,0.00003922}, {480,0.00007843}, {481,0.00007843}, {482,0.00014706}, {483,0.00000000}, {484,0.00003922}, {485,0.00003922}, {486,0.00003922}, {487,0.00003922}, {488,0.00015686}, {489,0.00003922}, {490,0.00011765}, {491,0.00000000}, {492,0.00000000}, {493,0.00019608}, {494,0.00011765}, {495,0.00007843}, {496,0.00000000}, {497,0.00003922}, {498,0.00003922}, {499,0.00003922}, {500,0.00007843}, {505,0.00003922}, {510,0.00011765}, {515,0.00007843}, {520,0.00007843}, {525,0.00010784}, {530,0.00000000}, {535,0.00003922}, {540,0.00010784}, {545,0.00003922}, {550,0.00003922}, {555,0.00007843}, {560,0.00007843}, {565,0.00000000}, {570,0.00003922}, {575,0.00006863}, {580,0.00011765}, {585,0.00007843}, {590,0.00003922}, {595,0.00006863}, {600,0.00006863}, {605,0.00000000}, {610,0.00000000}, {615,0.00003922}, {620,0.00000000}, {625,0.00011765}, {630,0.00000000}, {635,0.00000000}, {640,0.00003922}, {645,0.00003922}, {650,0.00003922}, {655,0.00000000}, {660,0.00000000}, {665,0.00007843}, {670,0.00010784}, {675,0.00007843}, {680,0.00007843}, {685,0.00003922}, {690,0.00003922}, {695,0.00015686}, {700,0.00003922}, {705,0.00000000}, {710,0.00007843}, {715,0.00010784}, {720,0.00007843}, {725,0.00003922}, {730,0.00003922}, {735,0.00003922}, {740,0.00011765}, {745,0.00015686}, {750,0.00019608}, {755,0.00011765}, {760,0.00003922}, {765,0.00003922}, {770,0.00015686}, {775,0.00011765}, {780,0.00015686}, {785,0.00003922}, {790,0.00003922}, {795,0.00007843}, {800,0.00015686}, {805,0.00003922}, {810,0.00003922}, {815,0.00026471}, {820,0.00007843}, {825,0.00011765}, {830,0.00011765}, {835,0.00022549}, {840,0.00007843}, {845,0.00011765}, {850,0.00031373}, {855,0.00007843}, {860,0.00007843}, {865,0.00018627}, {870,0.00031373}, {875,0.00003922}, {880,0.00000000}, {885,0.00010784}, {890,0.00031373}, {895,0.00007843}, {900,0.00007843}, {905,0.00023529}, {910,0.00031373}, {915,0.00023529}, {920,0.00003922}, {925,0.00007843}, {930,0.00006863}, {935,0.00009804}, {940,0.00039216}, {945,0.00007843}, {950,0.00015686}, {955,0.00003922}, {960,0.00019608}, {965,0.00034314}, {970,0.00019608}, {975,0.00003922}, {980,0.00011765}, {985,0.00003922}, {990,0.00019608}, {995,0.00015686}, {1000,0.00027451}, {1010,0.00019608}, {1020,0.00003922}, {1030,0.00000000}, {1040,0.00019608}, {1050,0.00015686}, {1060,0.00023529}, {1070,0.00022549}, {1080,0.00014706}, {1090,0.00023529}, {1100,0.00027451}, {1110,0.00029412}, {1120,0.00023529}, {1130,0.00035294}, {1140,0.00047059}, {1150,0.00010784}, {1160,0.00011765}, {1170,0.00052941}, {1180,0.00031373}, {1190,0.00019608}, {1200,0.00027451}, {1210,0.00031373}, {1220,0.00047059}, {1230,0.00026471}, {1240,0.00015686}, {1250,0.00026471}, {1260,0.00026471}, {1270,0.00015686}, {1280,0.00011765}, {1290,0.00019608}, {1300,0.00015686}, {1310,0.00027451}, {1320,0.00026471}, {1330,0.00038235}, {1340,0.00023529}, {1350,0.00027451}, {1360,0.00025490}, {1370,0.00010784}, {1380,0.00050980}, {1390,0.00039216}, {1400,0.00035294}, {1410,0.00014706}, {1420,0.00019608}, {1430,0.00031373}, {1440,0.00019608}, {1450,0.00022549}, {1460,0.00011765}, {1470,0.00055882}, {1480,0.00017647}, {1490,0.00023529}, {1500,0.00043137}, {1510,0.00038235}, {1520,0.00019608}, {1530,0.00027451}, {1540,0.00018627}, {1550,0.00019608}, {1560,0.00038235}, {1570,0.00066667}, {1580,0.00026471}, {1590,0.00030392}, {1600,0.00050000}, {1610,0.00027451}, {1620,0.00068627}, {1630,0.00023529}, {1640,0.00037255}, {1650,0.00026471}, {1660,0.00019608}, {1670,0.00065686}, {1680,0.00035294}, {1690,0.00024510}, {1700,0.00030392}, {1710,0.00019608}, {1720,0.00035294}, {1730,0.00023529}, {1740,0.00019608}, {1750,0.00015686}, {1760,0.00058824}, {1770,0.00030392}, {1780,0.00047059}, {1790,0.00058824}, {1800,0.00035294}, {1810,0.00025490}, {1820,0.00035294}, {1830,0.00032353}, {1840,0.00003922}, {1850,0.00023529}, {1860,0.00046078}, {1870,0.00069608}, {1880,0.00077451}, {1890,0.00025490}, {1900,0.00043137}, {1910,0.00062745}, {1920,0.00030392}, {1930,0.00039216}, {1940,0.00050000}, {1950,0.00035294}, {1960,0.00039216}, {1970,0.00034314}, {1980,0.00047059}, {1990,0.00034314}, {2000,0.00039216}, {2050,0.00041176}, {2100,0.00050000}, {2150,0.00031373}, {2200,0.00052941}, {2250,0.00051961}, {2300,0.00050000}, {2350,0.00053922}, {2400,0.00066667}, {2450,0.00046078}, {2500,0.00087255}, {2550,0.00070588}, {2600,0.00043137}, {2650,0.00035294}, {2700,0.00043137}, {2750,0.00042157}, {2800,0.00074510}, {2850,0.00043137}, {2900,0.00092157}, {2950,0.00086275}, {3000,0.00053922}, {3050,0.00050000}, {3100,0.00069608}, {3150,0.00086275}, {3200,0.00061765}, {3250,0.00120588}, {3300,0.00117647}, {3350,0.00086275}, {3400,0.00099020}, {3450,0.00085294}, {3500,0.00072549}, {3550,0.00103922}, {3600,0.00129412}, {3650,0.00119608}, {3700,0.00114706}, {3750,0.00083333}, {3800,0.00043137}, {3850,0.00011765}, {3900,0.00015686}, {3950,0.00023529}, {4000,0.00019608}, {4050,0.00007843}, {4100,0.00007843}, {4150,0.00010784}, {4200,0.00007843}, {4250,0.00006863}, {4300,0.00027451}, {4350,0.00003922}, {4400,0.00000000}, {4450,0.00007843}, {4500,0.00015686}, {4550,0.00019608}, {4600,0.00019608}, {4650,0.00030392}, {4700,0.00011765}, {4750,0.00007843}, {4800,0.00007843}, {4850,0.00003922}, {4900,0.00027451}, {4950,0.00019608}, {5000,0.00007843}, {5050,0.00019608}, {5100,0.00019608}, {5150,0.00023529}, {5200,0.00011765}, {5250,0.00023529}, {5300,0.00011765}, {5350,0.00011765}, {5400,0.00019608}, {5450,0.00018627}, {5500,0.00039216}, {5550,0.00019608}, {5600,0.00015686}, {5650,0.00018627}, {5700,0.00027451}, {5750,0.00019608}, {5800,0.00007843}, {5850,0.00011765}, {5900,0.00003922}, {5950,0.00015686}, {6000,0.00003922}, {6050,0.00011765}, {6100,0.00011765}, {6150,0.00007843}, {6200,0.00007843}, {6250,0.00007843}, {6300,0.00010784}, {6350,0.00015686}, {6400,0.00019608}, {6450,0.00011765}, {6500,0.00003922}, {6550,0.00014706}, {6600,0.00003922}, {6650,0.00015686}, {6700,0.00011765}, {6750,0.00003922}, {6800,0.00015686}, {6850,0.00003922}, {6900,0.00007843}, {6950,0.00019608}, {7000,0.00006863}, {7050,0.00019608}, {7100,0.00007843}, {7150,0.00007843}, {7200,0.00000000}, {7250,0.00015686}, {7300,0.00010784}, {7350,0.00000000}, {7400,0.00007843}, {7450,0.00022549}, {7500,0.00015686}, {7550,0.00007843}, {7600,0.00015686}, {7650,0.00011765}, {7700,0.00023529}, {7750,0.00011765}, {7800,0.00027451}, {7850,0.00007843}, {7900,0.00015686}, {7950,0.00011765}, {8000,0.00011765}, {8050,0.00011765}, {8100,0.00031373}, {8150,0.00078431}, {8200,0.00264706}, {8250,0.00190196}, {8300,0.00226471}, {8350,0.00210784}, {8400,0.00212745}, {8450,0.00248039}, {8500,0.00376471}, {8550,0.00256863}, {8600,0.00186275}, {8650,0.00246078}, {8700,0.00204902}, {8750,0.00245098}, {8800,0.00187255}, {8850,0.00019608}, {8900,0.00011765}, {8950,0.00019608}, {9000,0.00010784}, {9050,0.00015686}, {9100,0.00007843}, {9150,0.00018627}, {9200,0.00019608}, {9250,0.00035294}, {9300,0.00007843}, {9350,0.00011765}, {9400,0.00000000}, {9450,0.00019608}, {9500,0.00025490}, {9550,0.00015686}, {9600,0.00034314}, {9650,0.00015686}, {9700,0.00019608}, {9750,0.00000000}, {9800,0.00031373}, {9850,0.00007843}, {9900,0.00010784}, {9950,0.00019608}, {10000,0.00006863}, {10100,0.00011765}, {10200,0.00023529}, {10300,0.00026471}, {10400,0.00015686}, {10500,0.00023529}, {10600,0.00010784}, {10700,0.00034314}, {10800,0.00015686}, {10900,0.00007843}, {11000,0.00027451}, {11100,0.00003922}, {11200,0.00015686}, {11300,0.00027451}, {11400,0.00011765}, {11500,0.00007843}, {11600,0.00022549}, {11700,0.00019608}, {11800,0.00000000}, {11900,0.00011765}, {12000,0.00027451}, {12100,0.00019608}, {12200,0.00026471}, {12300,0.00011765}, {12400,0.00023529}, {12500,0.00011765}, {12600,0.00011765}, {12700,0.00023529}, {12800,0.00010784}, {12900,0.00015686}, {13000,0.00003922}, {13100,0.00027451}, {13200,0.00027451}, {13300,0.00026471}, {13400,0.00014706}, {13500,0.00011765}, {13600,0.00011765}, {13700,0.00018627}, {13800,0.00023529}, {13900,0.00023529}, {14000,0.00027451}, {14100,0.00035294}, {14200,0.00010784}, {14300,0.00023529}, {14400,0.00007843}, {14500,0.00031373}, {14600,0.00031373}, {14700,0.00011765}, {14800,0.00011765}, {14900,0.00015686}, {15000,0.00023529}, {15100,0.00011765}, {15200,0.00031373}, {15300,0.00022549}, {15400,0.00019608}, {15500,0.00026471}, {15600,0.00035294}, {15700,0.00019608}, {15800,0.00017647}, {15900,0.00003922}, {16000,0.00027451}, {16100,0.00015686}, {16200,0.00031373}, {16300,0.00003922}, {16400,0.00031373}, {16500,0.00007843}, {16600,0.00010784}, {16700,0.00019608}, {16800,0.00023529}, {16900,0.00007843}, {17000,0.00015686}, {17100,0.00007843}, {17200,0.00030392}, {17300,0.00023529}, {17400,0.00011765}, {17500,0.00023529}, {17600,0.00019608}, {17700,0.00015686}, {17800,0.00037255}, {17900,0.00019608}, {18000,0.00007843}, {18100,0.00023529}, {18200,0.00015686}, {18300,0.00030392}, {18400,0.00031373}, {18500,0.00014706}, {18600,0.00019608}, {18700,0.00015686}, {18800,0.00031373}, {18900,0.00027451}, {19000,0.00011765}, {19100,0.00019608}, {19200,0.00019608}, {19300,0.00019608}, {19400,0.00019608}, {19500,0.00023529}, {19600,0.00034314}, {19700,0.00002941}, {19800,0.00003922}, {19900,0.00014706}, {20000,0.00023529}};
data["big"]["Ltac2LowLevel"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000980}, {13,0.00011765}, {14,0.00015686}, {15,0.00015686}, {16,0.00081373}, {17,0.00100000}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00100000}, {23,0.00100000}, {24,0.00100000}, {25,0.00100000}, {26,0.00100000}, {27,0.00103922}, {28,0.00107843}, {29,0.00109804}, {30,0.00105882}, {31,0.00110784}, {32,0.00110784}, {33,0.00122549}, {34,0.00183333}, {35,0.00200000}, {36,0.00200000}, {37,0.00200000}, {38,0.00200000}, {39,0.00200000}, {40,0.00200980}, {41,0.00200980}, {42,0.00202941}, {43,0.00208824}, {44,0.00209804}, {45,0.00204902}, {46,0.00204902}, {47,0.00205882}, {48,0.00205882}, {49,0.00212745}, {50,0.00213725}, {51,0.00238235}, {52,0.00288235}, {53,0.00300000}, {54,0.00300000}, {55,0.00300000}, {56,0.00302941}, {57,0.00302941}, {58,0.00302941}, {59,0.00404902}, {60,0.00316667}, {61,0.00309804}, {62,0.00310784}, {63,0.00311765}, {64,0.00308824}, {65,0.00314706}, {66,0.00314706}, {67,0.00310784}, {68,0.00326471}, {69,0.00364706}, {70,0.00391176}, {71,0.00401961}, {72,0.00402941}, {73,0.00405882}, {74,0.00401961}, {75,0.00408824}, {76,0.00409804}, {77,0.00409804}, {78,0.00407843}, {79,0.00406863}, {80,0.00410784}, {81,0.00406863}, {82,0.00406863}, {83,0.00409804}, {84,0.00419608}, {85,0.00421569}, {86,0.00450980}, {87,0.00511765}, {88,0.00491176}, {89,0.00500980}, {90,0.00503922}, {91,0.00503922}, {92,0.00503922}, {93,0.00509804}, {94,0.00508824}, {95,0.00511765}, {96,0.00513725}, {97,0.00509804}, {98,0.00517647}, {99,0.00605882}, {100,0.00517647}, {101,0.00524510}, {102,0.00516667}, {103,0.00535294}, {104,0.00563725}, {105,0.00582353}, {106,0.00598039}, {107,0.00607843}, {108,0.00608824}, {109,0.00695098}, {110,0.00609804}, {111,0.00609804}, {112,0.00609804}, {113,0.00605882}, {114,0.00607843}, {115,0.00615686}, {116,0.00613725}, {117,0.00616667}, {118,0.00623529}, {119,0.00623529}, {120,0.00629412}, {121,0.00650980}, {122,0.00675490}, {123,0.00690196}, {124,0.00700980}, {125,0.00700980}, {126,0.00706863}, {127,0.00821569}, {128,0.00705882}, {129,0.00706863}, {130,0.00711765}, {131,0.00715686}, {132,0.00719608}, {133,0.00712745}, {134,0.00714706}, {135,0.00722549}, {136,0.00728431}, {137,0.00727451}, {138,0.00748039}, {139,0.00769608}, {140,0.00775490}, {141,0.00789216}, {142,0.00797059}, {143,0.00809804}, {144,0.00803922}, {145,0.00809804}, {146,0.00805882}, {147,0.00808824}, {148,0.00810784}, {149,0.00813725}, {150,0.00816667}, {151,0.00917647}, {152,0.00821569}, {153,0.00817647}, {154,0.00825490}, {155,0.00838235}, {156,0.00847059}, {157,0.00872549}, {158,0.00997059}, {159,0.00893137}, {160,0.00900980}, {161,0.00908824}, {162,0.00913725}, {163,0.00906863}, {164,0.00912745}, {165,0.01003922}, {166,0.00907843}, {167,0.00916667}, {168,0.00924510}, {169,0.00926471}, {170,0.00922549}, {171,0.00924510}, {172,0.00924510}, {173,0.00956863}, {174,0.00957843}, {175,0.00977451}, {176,0.00983333}, {177,0.00997059}, {178,0.01093137}, {179,0.01011765}, {180,0.01016667}, {181,0.01017647}, {182,0.01008824}, {183,0.01024510}, {184,0.01130392}, {185,0.01012745}, {186,0.01024510}, {187,0.01024510}, {188,0.01032353}, {189,0.01032353}, {190,0.01145098}, {191,0.01049020}, {192,0.01069608}, {193,0.01082353}, {194,0.01087255}, {195,0.01097059}, {196,0.01105882}, {197,0.01113725}, {198,0.01104902}, {199,0.01107843}, {200,0.01111765}, {201,0.01310784}, {202,0.01111765}, {203,0.01128431}, {204,0.01135294}, {205,0.01123529}, {206,0.01139216}, {207,0.01229412}, {208,0.01143137}, {209,0.01158824}, {210,0.01180392}, {211,0.01192157}, {212,0.01336275}, {213,0.01199020}, {214,0.01195098}, {215,0.01212745}, {216,0.01219608}, {217,0.01408824}, {218,0.01217647}, {219,0.01221569}, {220,0.01225490}, {221,0.01225490}, {222,0.01370588}, {223,0.01212745}, {224,0.01235294}, {225,0.01248039}, {226,0.01260784}, {227,0.01410784}, {228,0.01269608}, {229,0.01292157}, {230,0.01296078}, {231,0.01299020}, {232,0.01518627}, {233,0.01304902}, {234,0.01321569}, {235,0.01315686}, {236,0.01319608}, {237,0.01500000}, {238,0.01337255}, {239,0.01333333}, {240,0.01335294}, {241,0.01336275}, {242,0.01428431}, {243,0.01353922}, {244,0.01361765}, {245,0.01384314}, {246,0.01540196}, {247,0.01377451}, {248,0.01408824}, {249,0.01401961}, {250,0.01407843}, {251,0.01525490}, {252,0.01425490}, {253,0.01423529}, {254,0.01429412}, {255,0.01612745}, {256,0.01414706}, {257,0.01442157}, {258,0.01435294}, {259,0.01449020}, {260,0.01540196}, {261,0.01452941}, {262,0.01456863}, {263,0.01475490}, {264,0.01650980}, {265,0.01499020}, {266,0.01496078}, {267,0.01501961}, {268,0.01749020}, {269,0.01517647}, {270,0.01526471}, {271,0.01526471}, {272,0.01527451}, {273,0.01524510}, {274,0.01531373}, {275,0.01537255}, {276,0.01540196}, {277,0.01551961}, {278,0.01545098}, {279,0.01576471}, {280,0.01572549}, {281,0.01579412}, {282,0.01597059}, {283,0.01597059}, {284,0.01602941}, {285,0.01607843}, {286,0.01609804}, {287,0.01617647}, {288,0.01622549}, {289,0.01638235}, {290,0.01624510}, {291,0.01629412}, {292,0.01643137}, {293,0.01637255}, {294,0.01648039}, {295,0.01650980}, {296,0.01901961}, {297,0.01658824}, {298,0.01671569}, {299,0.01677451}, {300,0.01913725}, {301,0.01690196}, {302,0.01699020}, {303,0.01707843}, {304,0.01861765}, {305,0.01718627}, {306,0.01723529}, {307,0.01740196}, {308,0.01724510}, {309,0.01741176}, {310,0.01735294}, {311,0.02074510}, {312,0.01754902}, {313,0.01758824}, {314,0.01774510}, {315,0.01927451}, {316,0.01791176}, {317,0.01787255}, {318,0.01798039}, {319,0.01802941}, {320,0.01803922}, {321,0.01819608}, {322,0.02025490}, {323,0.01817647}, {324,0.01833333}, {325,0.01816667}, {326,0.01839216}, {327,0.01833333}, {328,0.01846078}, {329,0.02058824}, {330,0.01850980}, {331,0.01865686}, {332,0.01860784}, {333,0.01878431}, {334,0.01888235}, {335,0.01900000}, {336,0.02034314}, {337,0.01900980}, {338,0.01907843}, {339,0.02199020}, {340,0.01915686}, {341,0.01915686}, {342,0.01932353}, {343,0.01931373}, {344,0.01938235}, {345,0.01941176}, {346,0.02125490}, {347,0.01953922}, {348,0.01950980}, {349,0.02229412}, {350,0.01979412}, {351,0.01982353}, {352,0.02112745}, {353,0.01971569}, {354,0.02001961}, {355,0.01983333}, {356,0.01995098}, {357,0.02013725}, {358,0.02020588}, {359,0.02175490}, {360,0.02025490}, {361,0.02019608}, {362,0.02243137}, {363,0.02036275}, {364,0.02043137}, {365,0.02311765}, {366,0.02054902}, {367,0.02058824}, {368,0.02371569}, {369,0.02085294}, {370,0.02079412}, {371,0.02409804}, {372,0.02102941}, {373,0.02098039}, {374,0.02315686}, {375,0.02099020}, {376,0.02125490}, {377,0.02268627}, {378,0.02102941}, {379,0.02135294}, {380,0.02247059}, {381,0.02116667}, {382,0.02150000}, {383,0.02299020}, {384,0.02140196}, {385,0.02166667}, {386,0.02378431}, {387,0.02174510}, {388,0.02194118}, {389,0.02500000}, {390,0.02196078}, {391,0.02198039}, {392,0.02551961}, {393,0.02217647}, {394,0.02217647}, {395,0.02510784}, {396,0.02222549}, {397,0.02231373}, {398,0.02507843}, {399,0.02244118}, {400,0.02255882}, {401,0.02454902}, {402,0.02271569}, {403,0.02264706}, {404,0.02401961}, {405,0.02277451}, {406,0.02289216}, {407,0.02298039}, {408,0.02304902}, {409,0.02556863}, {410,0.02296078}, {411,0.02330392}, {412,0.02631373}, {413,0.02337255}, {414,0.02340196}, {415,0.02542157}, {416,0.02343137}, {417,0.02353922}, {418,0.02435294}, {419,0.02374510}, {420,0.02554902}, {421,0.02355882}, {422,0.02379412}, {423,0.02688235}, {424,0.02397059}, {425,0.02407843}, {426,0.02554902}, {427,0.02406863}, {428,0.02417647}, {429,0.02420588}, {430,0.02424510}, {431,0.02778431}, {432,0.02435294}, {433,0.02447059}, {434,0.02612745}, {435,0.02457843}, {436,0.02460784}, {437,0.02467647}, {438,0.02474510}, {439,0.02787255}, {440,0.02488235}, {441,0.02489216}, {442,0.02578431}, {443,0.02497059}, {444,0.02882353}, {445,0.02513725}, {446,0.02512745}, {447,0.02697059}, {448,0.02523529}, {449,0.02790196}, {450,0.02512745}, {451,0.02551961}, {452,0.02779412}, {453,0.02551961}, {454,0.02567647}, {455,0.02563725}, {456,0.02581373}, {457,0.02846078}, {458,0.02594118}, {459,0.02602941}, {460,0.02598039}, {461,0.02604902}, {462,0.02868627}, {463,0.02605882}, {464,0.02614706}, {465,0.02625490}, {466,0.02628431}, {467,0.02894118}, {468,0.02624510}, {469,0.02978431}, {470,0.02641176}, {471,0.02663725}, {472,0.02826471}, {473,0.02676471}, {474,0.03071569}, {475,0.02690196}, {476,0.02690196}, {477,0.02697059}, {478,0.02699020}, {479,0.03022549}, {480,0.02720588}, {481,0.02884314}, {482,0.02698039}, {483,0.02720588}, {484,0.02907843}, {485,0.02736275}, {486,0.03110784}, {487,0.02760784}, {488,0.02763725}, {489,0.02750980}, {490,0.02770588}, {491,0.03003922}, {492,0.02788235}, {493,0.03190196}, {494,0.02803922}, {495,0.02805882}, {496,0.02803922}, {497,0.02805882}, {498,0.03027451}, {499,0.02819608}, {500,0.03195098}, {505,0.02864706}, {510,0.03070588}, {515,0.02889216}, {520,0.02934314}, {525,0.02968627}, {530,0.02992157}, {535,0.03213725}, {540,0.03052941}, {545,0.03354902}, {550,0.03117647}, {555,0.03489216}, {560,0.03164706}, {565,0.03580392}, {570,0.03231373}, {575,0.03651961}, {580,0.03291176}, {585,0.03704902}, {590,0.03341176}, {595,0.03744118}, {600,0.03406863}, {605,0.03741176}, {610,0.03457843}, {615,0.03737255}, {620,0.03510784}, {625,0.03702941}, {630,0.03557843}, {635,0.03602941}, {640,0.03978431}, {645,0.03632353}, {650,0.04175490}, {655,0.03714706}, {660,0.04039216}, {665,0.03760784}, {670,0.03899020}, {675,0.04162745}, {680,0.03833333}, {685,0.04322549}, {690,0.03912745}, {695,0.04120588}, {700,0.04215686}, {705,0.03978431}, {710,0.04456863}, {715,0.04046078}, {720,0.04193137}, {725,0.04720588}, {730,0.04137255}, {735,0.04451961}, {740,0.04424510}, {745,0.04200980}, {750,0.04891176}, {755,0.04268627}, {760,0.04294118}, {765,0.04805882}, {770,0.04362745}, {775,0.04379412}, {780,0.04903922}, {785,0.04452941}, {790,0.04456863}, {795,0.04938235}, {800,0.04846078}, {805,0.04543137}, {810,0.04907843}, {815,0.05320588}, {820,0.04630392}, {825,0.04830392}, {830,0.05230392}, {835,0.04720588}, {840,0.04735294}, {845,0.05128431}, {850,0.05490196}, {855,0.04820588}, {860,0.04854902}, {865,0.05330392}, {870,0.05653922}, {875,0.04951961}, {880,0.04967647}, {885,0.05397059}, {890,0.05723529}, {895,0.05059804}, {900,0.05080392}, {905,0.05442157}, {910,0.05693137}, {915,0.05842157}, {920,0.05200000}, {925,0.05221569}, {930,0.05605882}, {935,0.05854902}, {940,0.06035294}, {945,0.05337255}, {950,0.05356863}, {955,0.05672549}, {960,0.05898039}, {965,0.06145098}, {970,0.05922549}, {975,0.05506863}, {980,0.05539216}, {985,0.05833333}, {990,0.06046078}, {995,0.06172549}, {1000,0.06879412}, {1010,0.06148039}, {1020,0.05767647}, {1030,0.05820588}, {1040,0.06264706}, {1050,0.06407843}, {1060,0.06640196}, {1070,0.06835294}, {1080,0.07020588}, {1090,0.07232353}, {1100,0.07385294}, {1110,0.07483333}, {1120,0.07684314}, {1130,0.07600980}, {1140,0.07371569}, {1150,0.07490196}, {1160,0.07302941}, {1170,0.07396078}, {1180,0.07543137}, {1190,0.07731373}, {1200,0.07812745}, {1210,0.07804902}, {1220,0.07808824}, {1230,0.07811765}, {1240,0.07806863}, {1250,0.07771569}, {1260,0.07727451}, {1270,0.07680392}, {1280,0.07647059}, {1290,0.07552941}, {1300,0.07342157}, {1310,0.08076471}, {1320,0.08501961}, {1330,0.08433333}, {1340,0.08299020}, {1350,0.08160784}, {1360,0.08032353}, {1370,0.07743137}, {1380,0.09082353}, {1390,0.08769608}, {1400,0.08597059}, {1410,0.08569608}, {1420,0.08453922}, {1430,0.09705882}, {1440,0.09144118}, {1450,0.08775490}, {1460,0.08480392}, {1470,0.09511765}, {1480,0.09196078}, {1490,0.08930392}, {1500,0.09421569}, {1510,0.09679412}, {1520,0.09255882}, {1530,0.08924510}, {1540,0.10112745}, {1550,0.09634314}, {1560,0.09136275}, {1570,0.10066667}, {1580,0.09850000}, {1590,0.09514706}, {1600,0.10079412}, {1610,0.09739216}, {1620,0.10406863}, {1630,0.10135294}, {1640,0.09667647}, {1650,0.10607843}, {1660,0.09982353}, {1670,0.10855882}, {1680,0.10290196}, {1690,0.10700980}, {1700,0.10526471}, {1710,0.10482353}, {1720,0.10822549}, {1730,0.10402941}, {1740,0.11146078}, {1750,0.10556863}, {1760,0.10994118}, {1770,0.10685294}, {1780,0.11069608}, {1790,0.11143137}, {1800,0.11111765}, {1810,0.11646078}, {1820,0.11106863}, {1830,0.11603922}, {1840,0.11073529}, {1850,0.11617647}, {1860,0.11504902}, {1870,0.11842157}, {1880,0.11831373}, {1890,0.11404902}, {1900,0.11928431}, {1910,0.12377451}, {1920,0.11688235}, {1930,0.12344118}, {1940,0.12390196}, {1950,0.12004902}, {1960,0.12413725}, {1970,0.12686275}, {1980,0.12014706}, {1990,0.12424510}, {2000,0.12784314}, {2050,0.12461765}, {2100,0.12849020}, {2150,0.13435294}, {2200,0.13754902}, {2250,0.14251961}, {2300,0.14568627}, {2350,0.14888235}, {2400,0.15162745}, {2450,0.15411765}, {2500,0.15459804}, {2550,0.15778431}, {2600,0.16311765}, {2650,0.16934314}, {2700,0.16909804}, {2750,0.17138235}, {2800,0.17680392}, {2850,0.17569608}, {2900,0.18620588}, {2950,0.18221569}, {3000,0.19198039}, {3050,0.18736275}, {3100,0.19416667}, {3150,0.20145098}, {3200,0.19689216}, {3250,0.20196078}, {3300,0.20854902}, {3350,0.21347059}, {3400,0.21890196}, {3450,0.22340196}, {3500,0.22406863}, {3550,0.22676471}, {3600,0.23148039}, {3650,0.23240196}, {3700,0.23514706}, {3750,0.23709804}, {3800,0.24074510}, {3850,0.24739216}, {3900,0.24801961}, {3950,0.25073529}, {4000,0.25609804}, {4050,0.25643137}, {4100,0.26315686}, {4150,0.26255882}, {4200,0.26860784}, {4250,0.27510784}, {4300,0.27078431}, {4350,0.27822549}, {4400,0.28439216}, {4450,0.28164706}, {4500,0.28263725}, {4550,0.28874510}, {4600,0.29347059}, {4650,0.29759804}, {4700,0.30038235}, {4750,0.30294118}, {4800,0.30520588}, {4850,0.30605882}, {4900,0.31771569}, {4950,0.32269608}, {5000,0.32186275}, {5050,0.31963725}, {5100,0.32531373}, {5150,0.33385294}, {5200,0.34868627}, {5250,0.34518627}, {5300,0.34196078}, {5350,0.34276471}, {5400,0.34767647}, {5450,0.35507843}, {5500,0.35321569}, {5550,0.36079412}, {5600,0.36866667}, {5650,0.36081373}, {5700,0.36538235}, {5750,0.36802941}, {5800,0.37114706}, {5850,0.37124510}, {5900,0.37302941}, {5950,0.37869608}, {6000,0.38071569}, {6050,0.38475490}, {6100,0.39549020}, {6150,0.40149020}, {6200,0.38578431}, {6250,0.39822549}, {6300,0.40523529}, {6350,0.39356863}, {6400,0.40961765}, {6450,0.40961765}, {6500,0.41450000}, {6550,0.40321569}, {6600,0.42127451}, {6650,0.42507843}, {6700,0.42496078}, {6750,0.43087255}, {6800,0.44062745}, {6850,0.43657843}, {6900,0.43973529}, {6950,0.43744118}, {7000,0.45382353}, {7050,0.45481373}, {7100,0.45944118}, {7150,0.44945098}, {7200,0.45878431}, {7250,0.45908824}, {7300,0.46295098}, {7350,0.47583333}, {7400,0.46419608}, {7450,0.46861765}, {7500,0.50300980}, {7550,0.47831373}, {7600,0.49199020}, {7650,0.48722549}, {7700,0.50088235}, {7750,0.49417647}, {7800,0.51056863}, {7850,0.51055882}, {7900,0.50247059}, {7950,0.51202941}, {8000,0.51564706}, {8050,0.51920588}, {8100,0.52339216}, {8150,0.56100000}, {8200,0.52178431}, {8250,0.52853922}, {8300,0.52980392}, {8350,0.53925490}, {8400,0.53913725}, {8450,0.53577451}, {8500,0.53997059}, {8550,0.54804902}, {8600,0.55085294}, {8650,0.56239216}, {8700,0.55554902}, {8750,0.56223529}, {8800,0.56329412}, {8850,0.56947059}, {8900,0.56673529}, {8950,0.57928431}, {9000,0.57408824}, {9050,0.57682353}, {9100,0.57244118}, {9150,0.62438235}, {9200,0.59740196}, {9250,0.59034314}, {9300,0.59531373}, {9350,0.59464706}, {9400,0.60136275}, {9450,0.60014706}, {9500,0.61839216}, {9550,0.61881373}, {9600,0.62231373}, {9650,0.62227451}, {9700,0.61250980}, {9750,0.62562745}, {9800,0.63126471}, {9850,0.62334314}, {9900,0.63546078}, {9950,0.61413725}, {10000,0.64202941}, {10100,0.64354902}, {10200,0.65316667}, {10300,0.65805882}, {10400,0.66715686}, {10500,0.66621569}, {10600,0.66963725}, {10700,0.67855882}, {10800,0.69013725}, {10900,0.69491176}, {11000,0.70793137}, {11100,0.72900980}, {11200,0.72125490}, {11300,0.73760784}, {11400,0.73930392}, {11500,0.75098039}, {11600,0.74171569}, {11700,0.75243137}, {11800,0.75544118}, {11900,0.75999020}, {12000,0.76728431}, {12100,0.78161765}, {12200,0.77654902}, {12300,0.78891176}, {12400,0.78707843}, {12500,0.80796078}, {12600,0.81323529}, {12700,0.81098039}, {12800,0.80804902}, {12900,0.81250980}, {13000,0.82100980}, {13100,0.83176471}, {13200,0.85410784}, {13300,0.87258824}, {13400,0.85025490}, {13500,0.87547059}, {13600,0.88711765}, {13700,0.87832353}, {13800,0.88820588}, {13900,0.88582353}, {14000,0.90700980}, {14100,0.91300980}, {14200,0.91151961}, {14300,0.91544118}, {14400,0.92418627}, {14500,0.93420588}, {14600,0.91842157}, {14700,0.94502941}, {14800,0.93094118}, {14900,0.96421569}, {15000,0.96848039}, {15100,0.97255882}, {15200,0.97985294}, {15300,0.98165686}, {15400,0.98771569}, {15500,0.99812745}, {15600,0.99523529}, {15700,1.01564706}, {15800,1.01229412}, {15900,1.02266667}, {16000,1.03824510}, {16100,1.01927451}, {16200,1.05206863}, {16300,1.05107843}, {16400,1.05588235}, {16500,1.08394118}, {16600,1.07733333}, {16700,1.09167647}, {16800,1.07261765}, {16900,1.09950000}, {17000,1.09683333}, {17100,1.11193137}, {17200,1.08926471}, {17300,1.10627451}, {17400,1.10944118}, {17500,1.12526471}, {17600,1.12778431}, {17700,1.13462745}, {17800,1.14430392}, {17900,1.15558824}, {18000,1.19123529}, {18100,1.16998039}, {18200,1.17705882}, {18300,1.18016667}, {18400,1.18583333}, {18500,1.19053922}, {18600,1.19898039}, {18700,1.20237255}, {18800,1.20863725}, {18900,1.21667647}, {19000,1.22743137}, {19100,1.22685294}, {19200,1.21605882}, {19300,1.26294118}, {19400,1.26125490}, {19500,1.26261765}, {19600,1.24889216}, {19700,1.27012745}, {19800,1.28024510}, {19900,1.28080392}, {20000,1.28370588}};
data["big"]["Ltac2LowLevel"]["actual reif"]["user"] = {{1,0.00019608}, {2,0.00029412}, {3,0.00009804}, {4,0.00021569}, {5,0.00049020}, {6,0.00028431}, {7,0.00048039}, {8,0.00062745}, {9,0.00050000}, {10,0.00066667}, {11,0.00063725}, {12,0.00077451}, {13,0.00067647}, {14,0.00081373}, {15,0.00053922}, {16,0.00139216}, {17,0.00063725}, {18,0.00131373}, {19,0.00125490}, {20,0.00086275}, {21,0.00135294}, {22,0.00125490}, {23,0.00124510}, {24,0.00152941}, {25,0.00138235}, {26,0.00108824}, {27,0.00138235}, {28,0.00164706}, {29,0.00192157}, {30,0.00147059}, {31,0.00159804}, {32,0.00163725}, {33,0.00179412}, {34,0.00205882}, {35,0.00202941}, {36,0.00195098}, {37,0.00196078}, {38,0.00201961}, {39,0.00222549}, {40,0.00202941}, {41,0.00211765}, {42,0.00233333}, {43,0.00228431}, {44,0.00243137}, {45,0.00254902}, {46,0.00254902}, {47,0.00241176}, {48,0.00276471}, {49,0.00278431}, {50,0.00271569}, {51,0.00272549}, {52,0.00285294}, {53,0.00284314}, {54,0.00287255}, {55,0.00293137}, {56,0.00290196}, {57,0.00309804}, {58,0.00329412}, {59,0.00407843}, {60,0.00346078}, {61,0.00342157}, {62,0.00347059}, {63,0.00344118}, {64,0.00346078}, {65,0.00356863}, {66,0.00350000}, {67,0.00354902}, {68,0.00346078}, {69,0.00365686}, {70,0.00379412}, {71,0.00390196}, {72,0.00387255}, {73,0.00378431}, {74,0.00402941}, {75,0.00403922}, {76,0.00400980}, {77,0.00422549}, {78,0.00436275}, {79,0.00402941}, {80,0.00415686}, {81,0.00457843}, {82,0.00439216}, {83,0.00419608}, {84,0.00441176}, {85,0.00449020}, {86,0.00482353}, {87,0.00584314}, {88,0.00458824}, {89,0.00460784}, {90,0.00464706}, {91,0.00468627}, {92,0.00470588}, {93,0.00490196}, {94,0.00500980}, {95,0.00498039}, {96,0.00510784}, {97,0.00525490}, {98,0.00538235}, {99,0.00606863}, {100,0.00532353}, {101,0.00534314}, {102,0.00562745}, {103,0.00570588}, {104,0.00567647}, {105,0.00532353}, {106,0.00557843}, {107,0.00579412}, {108,0.00566667}, {109,0.00644118}, {110,0.00610784}, {111,0.00609804}, {112,0.00566667}, {113,0.00594118}, {114,0.00620588}, {115,0.00626471}, {116,0.00584314}, {117,0.00628431}, {118,0.00623529}, {119,0.00649020}, {120,0.00642157}, {121,0.00634314}, {122,0.00652941}, {123,0.00651961}, {124,0.00662745}, {125,0.00673529}, {126,0.00675490}, {127,0.00852941}, {128,0.00676471}, {129,0.00701961}, {130,0.00686275}, {131,0.00719608}, {132,0.00716667}, {133,0.00693137}, {134,0.00724510}, {135,0.00718627}, {136,0.00727451}, {137,0.00733333}, {138,0.00736275}, {139,0.00756863}, {140,0.00745098}, {141,0.00744118}, {142,0.00757843}, {143,0.00768627}, {144,0.00780392}, {145,0.00781373}, {146,0.00766667}, {147,0.00768627}, {148,0.00804902}, {149,0.00819608}, {150,0.00817647}, {151,0.00915686}, {152,0.00815686}, {153,0.00807843}, {154,0.00833333}, {155,0.00856863}, {156,0.00850980}, {157,0.00853922}, {158,0.01007843}, {159,0.00862745}, {160,0.00856863}, {161,0.00887255}, {162,0.00940196}, {163,0.00920588}, {164,0.00900980}, {165,0.01004902}, {166,0.00933333}, {167,0.00909804}, {168,0.00951961}, {169,0.00968627}, {170,0.00911765}, {171,0.00976471}, {172,0.00949020}, {173,0.00959804}, {174,0.00990196}, {175,0.00995098}, {176,0.00982353}, {177,0.01029412}, {178,0.01115686}, {179,0.01029412}, {180,0.01001961}, {181,0.01047059}, {182,0.01062745}, {183,0.01027451}, {184,0.01172549}, {185,0.01081373}, {186,0.01023529}, {187,0.01055882}, {188,0.01072549}, {189,0.01067647}, {190,0.01185294}, {191,0.01065686}, {192,0.01102941}, {193,0.01114706}, {194,0.01096078}, {195,0.01117647}, {196,0.01098039}, {197,0.01142157}, {198,0.01127451}, {199,0.01156863}, {200,0.01146078}, {201,0.01379412}, {202,0.01136275}, {203,0.01161765}, {204,0.01205882}, {205,0.01162745}, {206,0.01200000}, {207,0.01279412}, {208,0.01195098}, {209,0.01197059}, {210,0.01225490}, {211,0.01219608}, {212,0.01365686}, {213,0.01242157}, {214,0.01224510}, {215,0.01231373}, {216,0.01255882}, {217,0.01448039}, {218,0.01257843}, {219,0.01266667}, {220,0.01257843}, {221,0.01264706}, {222,0.01431373}, {223,0.01247059}, {224,0.01266667}, {225,0.01318627}, {226,0.01269608}, {227,0.01454902}, {228,0.01300000}, {229,0.01321569}, {230,0.01337255}, {231,0.01304902}, {232,0.01530392}, {233,0.01326471}, {234,0.01355882}, {235,0.01330392}, {236,0.01365686}, {237,0.01501961}, {238,0.01402941}, {239,0.01362745}, {240,0.01352941}, {241,0.01380392}, {242,0.01465686}, {243,0.01399020}, {244,0.01370588}, {245,0.01409804}, {246,0.01555882}, {247,0.01418627}, {248,0.01412745}, {249,0.01423529}, {250,0.01441176}, {251,0.01547059}, {252,0.01460784}, {253,0.01430392}, {254,0.01448039}, {255,0.01622549}, {256,0.01465686}, {257,0.01474510}, {258,0.01475490}, {259,0.01502941}, {260,0.01553922}, {261,0.01473529}, {262,0.01502941}, {263,0.01487255}, {264,0.01658824}, {265,0.01486275}, {266,0.01496078}, {267,0.01513725}, {268,0.01719608}, {269,0.01533333}, {270,0.01531373}, {271,0.01549020}, {272,0.01544118}, {273,0.01549020}, {274,0.01555882}, {275,0.01564706}, {276,0.01553922}, {277,0.01583333}, {278,0.01560784}, {279,0.01591176}, {280,0.01598039}, {281,0.01576471}, {282,0.01604902}, {283,0.01603922}, {284,0.01636275}, {285,0.01619608}, {286,0.01602941}, {287,0.01650000}, {288,0.01639216}, {289,0.01648039}, {290,0.01637255}, {291,0.01656863}, {292,0.01652941}, {293,0.01649020}, {294,0.01644118}, {295,0.01673529}, {296,0.01875490}, {297,0.01669608}, {298,0.01690196}, {299,0.01678431}, {300,0.01917647}, {301,0.01660784}, {302,0.01686275}, {303,0.01719608}, {304,0.01868627}, {305,0.01720588}, {306,0.01727451}, {307,0.01730392}, {308,0.01708824}, {309,0.01730392}, {310,0.01751961}, {311,0.02052941}, {312,0.01770588}, {313,0.01776471}, {314,0.01777451}, {315,0.01915686}, {316,0.01780392}, {317,0.01765686}, {318,0.01782353}, {319,0.01800000}, {320,0.01778431}, {321,0.01805882}, {322,0.02013725}, {323,0.01821569}, {324,0.01816667}, {325,0.01815686}, {326,0.01850000}, {327,0.01845098}, {328,0.01845098}, {329,0.02059804}, {330,0.01833333}, {331,0.01837255}, {332,0.01844118}, {333,0.01850000}, {334,0.01883333}, {335,0.01880392}, {336,0.02032353}, {337,0.01874510}, {338,0.01884314}, {339,0.02200980}, {340,0.01898039}, {341,0.01894118}, {342,0.01921569}, {343,0.01933333}, {344,0.01909804}, {345,0.01921569}, {346,0.02144118}, {347,0.01925490}, {348,0.01932353}, {349,0.02269608}, {350,0.01949020}, {351,0.01964706}, {352,0.02131373}, {353,0.01952941}, {354,0.01965686}, {355,0.01950000}, {356,0.01996078}, {357,0.01993137}, {358,0.02014706}, {359,0.02174510}, {360,0.02009804}, {361,0.02001961}, {362,0.02250980}, {363,0.02022549}, {364,0.02085294}, {365,0.02347059}, {366,0.02072549}, {367,0.02075490}, {368,0.02410784}, {369,0.02103922}, {370,0.02089216}, {371,0.02434314}, {372,0.02109804}, {373,0.02110784}, {374,0.02364706}, {375,0.02055882}, {376,0.02108824}, {377,0.02283333}, {378,0.02063725}, {379,0.02139216}, {380,0.02240196}, {381,0.02117647}, {382,0.02154902}, {383,0.02334314}, {384,0.02176471}, {385,0.02171569}, {386,0.02410784}, {387,0.02176471}, {388,0.02189216}, {389,0.02541176}, {390,0.02181373}, {391,0.02178431}, {392,0.02591176}, {393,0.02294118}, {394,0.02278431}, {395,0.02542157}, {396,0.02259804}, {397,0.02250980}, {398,0.02500980}, {399,0.02279412}, {400,0.02291176}, {401,0.02476471}, {402,0.02284314}, {403,0.02301961}, {404,0.02426471}, {405,0.02283333}, {406,0.02334314}, {407,0.02319608}, {408,0.02345098}, {409,0.02600980}, {410,0.02323529}, {411,0.02376471}, {412,0.02651961}, {413,0.02371569}, {414,0.02393137}, {415,0.02579412}, {416,0.02403922}, {417,0.02377451}, {418,0.02461765}, {419,0.02397059}, {420,0.02580392}, {421,0.02410784}, {422,0.02436275}, {423,0.02722549}, {424,0.02456863}, {425,0.02457843}, {426,0.02568627}, {427,0.02463725}, {428,0.02453922}, {429,0.02436275}, {430,0.02482353}, {431,0.02769608}, {432,0.02459804}, {433,0.02495098}, {434,0.02655882}, {435,0.02468627}, {436,0.02483333}, {437,0.02502941}, {438,0.02531373}, {439,0.02792157}, {440,0.02505882}, {441,0.02510784}, {442,0.02625490}, {443,0.02515686}, {444,0.02857843}, {445,0.02552941}, {446,0.02548039}, {447,0.02717647}, {448,0.02572549}, {449,0.02793137}, {450,0.02569608}, {451,0.02572549}, {452,0.02783333}, {453,0.02560784}, {454,0.02625490}, {455,0.02607843}, {456,0.02644118}, {457,0.02816667}, {458,0.02604902}, {459,0.02580392}, {460,0.02633333}, {461,0.02596078}, {462,0.02864706}, {463,0.02631373}, {464,0.02598039}, {465,0.02638235}, {466,0.02663725}, {467,0.02884314}, {468,0.02644118}, {469,0.02984314}, {470,0.02646078}, {471,0.02704902}, {472,0.02812745}, {473,0.02666667}, {474,0.03079412}, {475,0.02675490}, {476,0.02689216}, {477,0.02711765}, {478,0.02726471}, {479,0.02980392}, {480,0.02738235}, {481,0.02896078}, {482,0.02710784}, {483,0.02739216}, {484,0.02915686}, {485,0.02754902}, {486,0.03080392}, {487,0.02766667}, {488,0.02747059}, {489,0.02759804}, {490,0.02784314}, {491,0.02979412}, {492,0.02750980}, {493,0.03162745}, {494,0.02802941}, {495,0.02804902}, {496,0.02832353}, {497,0.02826471}, {498,0.03004902}, {499,0.02813725}, {500,0.03186275}, {505,0.02873529}, {510,0.03047059}, {515,0.02885294}, {520,0.02949020}, {525,0.02932353}, {530,0.02992157}, {535,0.03197059}, {540,0.03056863}, {545,0.03405882}, {550,0.03100980}, {555,0.03514706}, {560,0.03146078}, {565,0.03625490}, {570,0.03208824}, {575,0.03671569}, {580,0.03285294}, {585,0.03711765}, {590,0.03366667}, {595,0.03775490}, {600,0.03421569}, {605,0.03776471}, {610,0.03476471}, {615,0.03768627}, {620,0.03548039}, {625,0.03724510}, {630,0.03589216}, {635,0.03647059}, {640,0.03992157}, {645,0.03655882}, {650,0.04188235}, {655,0.03757843}, {660,0.04012745}, {665,0.03753922}, {670,0.03914706}, {675,0.04124510}, {680,0.03841176}, {685,0.04292157}, {690,0.03937255}, {695,0.04127451}, {700,0.04220588}, {705,0.03966667}, {710,0.04442157}, {715,0.04034314}, {720,0.04189216}, {725,0.04759804}, {730,0.04133333}, {735,0.04450980}, {740,0.04407843}, {745,0.04191176}, {750,0.04909804}, {755,0.04256863}, {760,0.04270588}, {765,0.04830392}, {770,0.04345098}, {775,0.04356863}, {780,0.04898039}, {785,0.04453922}, {790,0.04453922}, {795,0.04964706}, {800,0.04857843}, {805,0.04525490}, {810,0.04959804}, {815,0.05267647}, {820,0.04661765}, {825,0.04847059}, {830,0.05225490}, {835,0.04764706}, {840,0.04757843}, {845,0.05134314}, {850,0.05432353}, {855,0.04865686}, {860,0.04885294}, {865,0.05324510}, {870,0.05616667}, {875,0.04979412}, {880,0.04998039}, {885,0.05355882}, {890,0.05673529}, {895,0.05094118}, {900,0.05090196}, {905,0.05418627}, {910,0.05653922}, {915,0.05811765}, {920,0.05205882}, {925,0.05220588}, {930,0.05576471}, {935,0.05856863}, {940,0.06005882}, {945,0.05321569}, {950,0.05337255}, {955,0.05651961}, {960,0.05917647}, {965,0.06125490}, {970,0.05945098}, {975,0.05508824}, {980,0.05493137}, {985,0.05851961}, {990,0.06044118}, {995,0.06195098}, {1000,0.06895098}, {1010,0.06158824}, {1020,0.05769608}, {1030,0.05865686}, {1040,0.06243137}, {1050,0.06360784}, {1060,0.06626471}, {1070,0.06808824}, {1080,0.07059804}, {1090,0.07220588}, {1100,0.07369608}, {1110,0.07495098}, {1120,0.07658824}, {1130,0.07572549}, {1140,0.07326471}, {1150,0.07490196}, {1160,0.07303922}, {1170,0.07383333}, {1180,0.07500980}, {1190,0.07708824}, {1200,0.07781373}, {1210,0.07771569}, {1220,0.07754902}, {1230,0.07759804}, {1240,0.07786275}, {1250,0.07738235}, {1260,0.07703922}, {1270,0.07657843}, {1280,0.07647059}, {1290,0.07538235}, {1300,0.07371569}, {1310,0.08096078}, {1320,0.08527451}, {1330,0.08384314}, {1340,0.08308824}, {1350,0.08154902}, {1360,0.08001961}, {1370,0.07738235}, {1380,0.09000000}, {1390,0.08734314}, {1400,0.08563725}, {1410,0.08567647}, {1420,0.08469608}, {1430,0.09697059}, {1440,0.09121569}, {1450,0.08752941}, {1460,0.08468627}, {1470,0.09472549}, {1480,0.09151961}, {1490,0.08904902}, {1500,0.09393137}, {1510,0.09619608}, {1520,0.09227451}, {1530,0.08922549}, {1540,0.10104902}, {1550,0.09639216}, {1560,0.09116667}, {1570,0.09992157}, {1580,0.09830392}, {1590,0.09512745}, {1600,0.10039216}, {1610,0.09693137}, {1620,0.10359804}, {1630,0.10120588}, {1640,0.09658824}, {1650,0.10573529}, {1660,0.09974510}, {1670,0.10802941}, {1680,0.10256863}, {1690,0.10689216}, {1700,0.10530392}, {1710,0.10474510}, {1720,0.10782353}, {1730,0.10361765}, {1740,0.11085294}, {1750,0.10532353}, {1760,0.10940196}, {1770,0.10659804}, {1780,0.11020588}, {1790,0.11107843}, {1800,0.11074510}, {1810,0.11602941}, {1820,0.11068627}, {1830,0.11564706}, {1840,0.11065686}, {1850,0.11561765}, {1860,0.11458824}, {1870,0.11809804}, {1880,0.11780392}, {1890,0.11372549}, {1900,0.11887255}, {1910,0.12336275}, {1920,0.11692157}, {1930,0.12288235}, {1940,0.12367647}, {1950,0.11988235}, {1960,0.12369608}, {1970,0.12672549}, {1980,0.11991176}, {1990,0.12381373}, {2000,0.12751961}, {2050,0.12424510}, {2100,0.12809804}, {2150,0.13399020}, {2200,0.13714706}, {2250,0.14196078}, {2300,0.14507843}, {2350,0.14851961}, {2400,0.15081373}, {2450,0.15355882}, {2500,0.15418627}, {2550,0.15733333}, {2600,0.16256863}, {2650,0.16886275}, {2700,0.16841176}, {2750,0.17085294}, {2800,0.17587255}, {2850,0.17535294}, {2900,0.18517647}, {2950,0.18114706}, {3000,0.19126471}, {3050,0.18649020}, {3100,0.19342157}, {3150,0.20064706}, {3200,0.19629412}, {3250,0.20115686}, {3300,0.20713725}, {3350,0.21270588}, {3400,0.21715686}, {3450,0.22218627}, {3500,0.22346078}, {3550,0.22588235}, {3600,0.22983333}, {3650,0.23100980}, {3700,0.23435294}, {3750,0.23595098}, {3800,0.24016667}, {3850,0.24700000}, {3900,0.24792157}, {3950,0.25054902}, {4000,0.25544118}, {4050,0.25572549}, {4100,0.26295098}, {4150,0.26218627}, {4200,0.26798039}, {4250,0.27492157}, {4300,0.27021569}, {4350,0.27797059}, {4400,0.28390196}, {4450,0.28124510}, {4500,0.28223529}, {4550,0.28819608}, {4600,0.29281373}, {4650,0.29716667}, {4700,0.30008824}, {4750,0.30216667}, {4800,0.30475490}, {4850,0.30566667}, {4900,0.31723529}, {4950,0.32228431}, {5000,0.32153922}, {5050,0.31925490}, {5100,0.32473529}, {5150,0.33351961}, {5200,0.34782353}, {5250,0.34478431}, {5300,0.34150000}, {5350,0.34245098}, {5400,0.34724510}, {5450,0.35431373}, {5500,0.35263725}, {5550,0.35987255}, {5600,0.36787255}, {5650,0.36008824}, {5700,0.36458824}, {5750,0.36746078}, {5800,0.37059804}, {5850,0.37060784}, {5900,0.37260784}, {5950,0.37828431}, {6000,0.37998039}, {6050,0.38426471}, {6100,0.39480392}, {6150,0.40092157}, {6200,0.38508824}, {6250,0.39759804}, {6300,0.40444118}, {6350,0.39275490}, {6400,0.40902941}, {6450,0.40882353}, {6500,0.41373529}, {6550,0.40260784}, {6600,0.42042157}, {6650,0.42408824}, {6700,0.42436275}, {6750,0.43021569}, {6800,0.44003922}, {6850,0.43596078}, {6900,0.43902941}, {6950,0.43692157}, {7000,0.45277451}, {7050,0.45423529}, {7100,0.45858824}, {7150,0.44916667}, {7200,0.45815686}, {7250,0.45795098}, {7300,0.46252941}, {7350,0.47537255}, {7400,0.46354902}, {7450,0.46801961}, {7500,0.50242157}, {7550,0.47757843}, {7600,0.49143137}, {7650,0.48643137}, {7700,0.50021569}, {7750,0.49368627}, {7800,0.51012745}, {7850,0.50987255}, {7900,0.50187255}, {7950,0.51140196}, {8000,0.51542157}, {8050,0.51861765}, {8100,0.52302941}, {8150,0.55977451}, {8200,0.51909804}, {8250,0.52606863}, {8300,0.52731373}, {8350,0.53697059}, {8400,0.53710784}, {8450,0.53315686}, {8500,0.53735294}, {8550,0.54614706}, {8600,0.54861765}, {8650,0.55972549}, {8700,0.55360784}, {8750,0.55975490}, {8800,0.56143137}, {8850,0.56888235}, {8900,0.56634314}, {8950,0.57853922}, {9000,0.57339216}, {9050,0.57638235}, {9100,0.57151961}, {9150,0.62378431}, {9200,0.59679412}, {9250,0.58959804}, {9300,0.59491176}, {9350,0.59395098}, {9400,0.60107843}, {9450,0.59962745}, {9500,0.61750980}, {9550,0.61805882}, {9600,0.62146078}, {9650,0.62122549}, {9700,0.61181373}, {9750,0.62485294}, {9800,0.63024510}, {9850,0.62253922}, {9900,0.63493137}, {9950,0.61321569}, {10000,0.64142157}, {10100,0.64290196}, {10200,0.65225490}, {10300,0.65720588}, {10400,0.66654902}, {10500,0.66532353}, {10600,0.66846078}, {10700,0.67755882}, {10800,0.68924510}, {10900,0.69396078}, {11000,0.70650980}, {11100,0.72799020}, {11200,0.72022549}, {11300,0.73675490}, {11400,0.73828431}, {11500,0.74976471}, {11600,0.74060784}, {11700,0.75127451}, {11800,0.75429412}, {11900,0.75869608}, {12000,0.76634314}, {12100,0.78065686}, {12200,0.77530392}, {12300,0.78776471}, {12400,0.78602941}, {12500,0.80660784}, {12600,0.81186275}, {12700,0.80970588}, {12800,0.80691176}, {12900,0.81124510}, {13000,0.82022549}, {13100,0.83084314}, {13200,0.85305882}, {13300,0.87110784}, {13400,0.84907843}, {13500,0.87429412}, {13600,0.88577451}, {13700,0.87725490}, {13800,0.88692157}, {13900,0.88461765}, {14000,0.90555882}, {14100,0.91136275}, {14200,0.91020588}, {14300,0.91426471}, {14400,0.92291176}, {14500,0.93284314}, {14600,0.91705882}, {14700,0.94365686}, {14800,0.92955882}, {14900,0.96267647}, {15000,0.96692157}, {15100,0.97106863}, {15200,0.97841176}, {15300,0.98039216}, {15400,0.98659804}, {15500,0.99693137}, {15600,0.99346078}, {15700,1.01443137}, {15800,1.01107843}, {15900,1.02144118}, {16000,1.03710784}, {16100,1.01806863}, {16200,1.05050980}, {16300,1.04983333}, {16400,1.05449020}, {16500,1.08279412}, {16600,1.07653922}, {16700,1.09039216}, {16800,1.07125490}, {16900,1.09849020}, {17000,1.09556863}, {17100,1.11086275}, {17200,1.08769608}, {17300,1.10507843}, {17400,1.10769608}, {17500,1.12369608}, {17600,1.12651961}, {17700,1.13324510}, {17800,1.14305882}, {17900,1.15431373}, {18000,1.18977451}, {18100,1.16872549}, {18200,1.17578431}, {18300,1.17837255}, {18400,1.18452941}, {18500,1.18944118}, {18600,1.19765686}, {18700,1.20133333}, {18800,1.20736275}, {18900,1.21532353}, {19000,1.22612745}, {19100,1.22552941}, {19200,1.21476471}, {19300,1.26189216}, {19400,1.25974510}, {19500,1.26106863}, {19600,1.24758824}, {19700,1.26850980}, {19800,1.27900000}, {19900,1.27943137}, {20000,1.28209804}};
data["big"]["Ltac2LowLevel"]["actual reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003922}, {13,0.00000000}, {14,0.00007843}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00003922}, {22,0.00000000}, {23,0.00000000}, {24,0.00003922}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00003922}, {29,0.00003922}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00003922}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00003922}, {39,0.00000000}, {40,0.00000000}, {41,0.00003922}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00003922}, {46,0.00000000}, {47,0.00000000}, {48,0.00003922}, {49,0.00000000}, {50,0.00000000}, {51,0.00003922}, {52,0.00000000}, {53,0.00003922}, {54,0.00000000}, {55,0.00003922}, {56,0.00000000}, {57,0.00000000}, {58,0.00003922}, {59,0.00007843}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00003922}, {64,0.00003922}, {65,0.00007843}, {66,0.00003922}, {67,0.00000000}, {68,0.00003922}, {69,0.00003922}, {70,0.00006863}, {71,0.00000000}, {72,0.00000000}, {73,0.00003922}, {74,0.00000000}, {75,0.00000000}, {76,0.00007843}, {77,0.00000000}, {78,0.00000000}, {79,0.00011765}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00003922}, {85,0.00000000}, {86,0.00003922}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00003922}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00003922}, {97,0.00003922}, {98,0.00000000}, {99,0.00003922}, {100,0.00003922}, {101,0.00000000}, {102,0.00003922}, {103,0.00007843}, {104,0.00000000}, {105,0.00003922}, {106,0.00003922}, {107,0.00000000}, {108,0.00002941}, {109,0.00000000}, {110,0.00000000}, {111,0.00002941}, {112,0.00007843}, {113,0.00003922}, {114,0.00000000}, {115,0.00000000}, {116,0.00003922}, {117,0.00003922}, {118,0.00000000}, {119,0.00003922}, {120,0.00007843}, {121,0.00000000}, {122,0.00007843}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00003922}, {127,0.00000000}, {128,0.00000000}, {129,0.00007843}, {130,0.00000000}, {131,0.00000000}, {132,0.00003922}, {133,0.00000000}, {134,0.00002941}, {135,0.00000000}, {136,0.00000000}, {137,0.00003922}, {138,0.00000000}, {139,0.00000000}, {140,0.00003922}, {141,0.00006863}, {142,0.00000000}, {143,0.00000000}, {144,0.00003922}, {145,0.00000000}, {146,0.00007843}, {147,0.00003922}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00002941}, {156,0.00007843}, {157,0.00003922}, {158,0.00000000}, {159,0.00000000}, {160,0.00003922}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00003922}, {165,0.00000000}, {166,0.00000000}, {167,0.00007843}, {168,0.00000000}, {169,0.00003922}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00003922}, {175,0.00000000}, {176,0.00000000}, {177,0.00003922}, {178,0.00000000}, {179,0.00003922}, {180,0.00003922}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00003922}, {185,0.00000000}, {186,0.00003922}, {187,0.00003922}, {188,0.00003922}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00003922}, {193,0.00003922}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00003922}, {200,0.00003922}, {201,0.00003922}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00007843}, {206,0.00003922}, {207,0.00000000}, {208,0.00003922}, {209,0.00003922}, {210,0.00000000}, {211,0.00003922}, {212,0.00000000}, {213,0.00000000}, {214,0.00003922}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00003922}, {219,0.00003922}, {220,0.00007843}, {221,0.00003922}, {222,0.00000000}, {223,0.00000000}, {224,0.00003922}, {225,0.00000000}, {226,0.00000000}, {227,0.00003922}, {228,0.00000000}, {229,0.00003922}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00003922}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00002941}, {240,0.00000000}, {241,0.00003922}, {242,0.00000000}, {243,0.00000000}, {244,0.00003922}, {245,0.00007843}, {246,0.00000000}, {247,0.00003922}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00007843}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00003922}, {259,0.00000000}, {260,0.00003922}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00003922}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00003922}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003922}, {282,0.00003922}, {283,0.00007843}, {284,0.00003922}, {285,0.00000000}, {286,0.00003922}, {287,0.00000000}, {288,0.00003922}, {289,0.00000000}, {290,0.00000000}, {291,0.00007843}, {292,0.00000000}, {293,0.00007843}, {294,0.00000000}, {295,0.00000000}, {296,0.00003922}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00003922}, {302,0.00003922}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00003922}, {311,0.00003922}, {312,0.00007843}, {313,0.00000000}, {314,0.00000000}, {315,0.00003922}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00003922}, {321,0.00003922}, {322,0.00007843}, {323,0.00000000}, {324,0.00000000}, {325,0.00007843}, {326,0.00000000}, {327,0.00000000}, {328,0.00007843}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00003922}, {335,0.00000000}, {336,0.00003922}, {337,0.00000000}, {338,0.00003922}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00003922}, {343,0.00003922}, {344,0.00000000}, {345,0.00000000}, {346,0.00011765}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00007843}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00003922}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00007843}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00002941}, {367,0.00000000}, {368,0.00003922}, {369,0.00003922}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00002941}, {378,0.00007843}, {379,0.00000000}, {380,0.00000000}, {381,0.00003922}, {382,0.00000000}, {383,0.00003922}, {384,0.00000000}, {385,0.00003922}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00003922}, {393,0.00003922}, {394,0.00003922}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00003922}, {405,0.00003922}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00007843}, {410,0.00003922}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00002941}, {417,0.00003922}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00003922}, {435,0.00003922}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00003922}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00003922}, {446,0.00000000}, {447,0.00000000}, {448,0.00003922}, {449,0.00000000}, {450,0.00000000}, {451,0.00003922}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00002941}, {456,0.00000000}, {457,0.00003922}, {458,0.00000000}, {459,0.00002941}, {460,0.00000000}, {461,0.00003922}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00003922}, {467,0.00000000}, {468,0.00003922}, {469,0.00003922}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00002941}, {474,0.00003922}, {475,0.00003922}, {476,0.00003922}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00003922}, {481,0.00000000}, {482,0.00007843}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00003922}, {487,0.00003922}, {488,0.00007843}, {489,0.00000000}, {490,0.00003922}, {491,0.00000000}, {492,0.00000000}, {493,0.00003922}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00003922}, {510,0.00000000}, {515,0.00003922}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00003922}, {550,0.00000000}, {555,0.00003922}, {560,0.00003922}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00003922}, {585,0.00007843}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00003922}, {620,0.00000000}, {625,0.00007843}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00003922}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00003922}, {700,0.00000000}, {705,0.00000000}, {710,0.00003922}, {715,0.00000000}, {720,0.00000000}, {725,0.00003922}, {730,0.00003922}, {735,0.00000000}, {740,0.00003922}, {745,0.00000000}, {750,0.00011765}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00003922}, {775,0.00003922}, {780,0.00011765}, {785,0.00000000}, {790,0.00003922}, {795,0.00007843}, {800,0.00003922}, {805,0.00003922}, {810,0.00003922}, {815,0.00022549}, {820,0.00003922}, {825,0.00007843}, {830,0.00007843}, {835,0.00000000}, {840,0.00000000}, {845,0.00011765}, {850,0.00027451}, {855,0.00000000}, {860,0.00000000}, {865,0.00014706}, {870,0.00027451}, {875,0.00000000}, {880,0.00000000}, {885,0.00003922}, {890,0.00027451}, {895,0.00000000}, {900,0.00000000}, {905,0.00015686}, {910,0.00031373}, {915,0.00023529}, {920,0.00003922}, {925,0.00000000}, {930,0.00000000}, {935,0.00006863}, {940,0.00031373}, {945,0.00000000}, {950,0.00000000}, {955,0.00003922}, {960,0.00015686}, {965,0.00030392}, {970,0.00007843}, {975,0.00000000}, {980,0.00003922}, {985,0.00000000}, {990,0.00019608}, {995,0.00011765}, {1000,0.00019608}, {1010,0.00003922}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00015686}, {1050,0.00015686}, {1060,0.00015686}, {1070,0.00022549}, {1080,0.00011765}, {1090,0.00019608}, {1100,0.00023529}, {1110,0.00025490}, {1120,0.00015686}, {1130,0.00031373}, {1140,0.00043137}, {1150,0.00010784}, {1160,0.00007843}, {1170,0.00033333}, {1180,0.00019608}, {1190,0.00019608}, {1200,0.00027451}, {1210,0.00023529}, {1220,0.00039216}, {1230,0.00014706}, {1240,0.00015686}, {1250,0.00023529}, {1260,0.00018627}, {1270,0.00007843}, {1280,0.00007843}, {1290,0.00011765}, {1300,0.00000000}, {1310,0.00007843}, {1320,0.00019608}, {1330,0.00034314}, {1340,0.00011765}, {1350,0.00019608}, {1360,0.00010784}, {1370,0.00000000}, {1380,0.00035294}, {1390,0.00031373}, {1400,0.00035294}, {1410,0.00010784}, {1420,0.00003922}, {1430,0.00019608}, {1440,0.00015686}, {1450,0.00011765}, {1460,0.00003922}, {1470,0.00049020}, {1480,0.00017647}, {1490,0.00015686}, {1500,0.00023529}, {1510,0.00038235}, {1520,0.00019608}, {1530,0.00015686}, {1540,0.00014706}, {1550,0.00011765}, {1560,0.00015686}, {1570,0.00058824}, {1580,0.00022549}, {1590,0.00026471}, {1600,0.00046078}, {1610,0.00027451}, {1620,0.00056863}, {1630,0.00019608}, {1640,0.00007843}, {1650,0.00014706}, {1660,0.00015686}, {1670,0.00050000}, {1680,0.00027451}, {1690,0.00021569}, {1700,0.00018627}, {1710,0.00011765}, {1720,0.00031373}, {1730,0.00015686}, {1740,0.00011765}, {1750,0.00011765}, {1760,0.00047059}, {1770,0.00019608}, {1780,0.00039216}, {1790,0.00047059}, {1800,0.00035294}, {1810,0.00014706}, {1820,0.00031373}, {1830,0.00028431}, {1840,0.00000000}, {1850,0.00019608}, {1860,0.00042157}, {1870,0.00062745}, {1880,0.00039216}, {1890,0.00014706}, {1900,0.00039216}, {1910,0.00047059}, {1920,0.00014706}, {1930,0.00035294}, {1940,0.00031373}, {1950,0.00027451}, {1960,0.00027451}, {1970,0.00030392}, {1980,0.00027451}, {1990,0.00022549}, {2000,0.00035294}, {2050,0.00025490}, {2100,0.00030392}, {2150,0.00027451}, {2200,0.00052941}, {2250,0.00051961}, {2300,0.00039216}, {2350,0.00046078}, {2400,0.00050980}, {2450,0.00046078}, {2500,0.00027451}, {2550,0.00035294}, {2600,0.00039216}, {2650,0.00031373}, {2700,0.00039216}, {2750,0.00038235}, {2800,0.00066667}, {2850,0.00039216}, {2900,0.00076471}, {2950,0.00054902}, {3000,0.00039216}, {3050,0.00042157}, {3100,0.00053922}, {3150,0.00070588}, {3200,0.00042157}, {3250,0.00071569}, {3300,0.00094118}, {3350,0.00070588}, {3400,0.00084314}, {3450,0.00077451}, {3500,0.00041176}, {3550,0.00065686}, {3600,0.00101961}, {3650,0.00092157}, {3700,0.00080392}, {3750,0.00072549}, {3800,0.00027451}, {3850,0.00003922}, {3900,0.00000000}, {3950,0.00011765}, {4000,0.00007843}, {4050,0.00000000}, {4100,0.00007843}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00002941}, {4300,0.00003922}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00003922}, {4500,0.00003922}, {4550,0.00015686}, {4600,0.00015686}, {4650,0.00018627}, {4700,0.00003922}, {4750,0.00003922}, {4800,0.00003922}, {4850,0.00000000}, {4900,0.00015686}, {4950,0.00011765}, {5000,0.00003922}, {5050,0.00007843}, {5100,0.00007843}, {5150,0.00011765}, {5200,0.00007843}, {5250,0.00007843}, {5300,0.00003922}, {5350,0.00003922}, {5400,0.00019608}, {5450,0.00014706}, {5500,0.00011765}, {5550,0.00015686}, {5600,0.00007843}, {5650,0.00003922}, {5700,0.00007843}, {5750,0.00007843}, {5800,0.00007843}, {5850,0.00003922}, {5900,0.00000000}, {5950,0.00007843}, {6000,0.00000000}, {6050,0.00003922}, {6100,0.00003922}, {6150,0.00000000}, {6200,0.00007843}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00007843}, {6450,0.00007843}, {6500,0.00003922}, {6550,0.00000000}, {6600,0.00003922}, {6650,0.00003922}, {6700,0.00007843}, {6750,0.00000000}, {6800,0.00003922}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00003922}, {7000,0.00002941}, {7050,0.00003922}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00007843}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00007843}, {7500,0.00007843}, {7550,0.00000000}, {7600,0.00007843}, {7650,0.00003922}, {7700,0.00003922}, {7750,0.00000000}, {7800,0.00003922}, {7850,0.00003922}, {7900,0.00000000}, {7950,0.00003922}, {8000,0.00003922}, {8050,0.00003922}, {8100,0.00007843}, {8150,0.00062745}, {8200,0.00230392}, {8250,0.00158824}, {8300,0.00195098}, {8350,0.00187255}, {8400,0.00178431}, {8450,0.00198039}, {8500,0.00190196}, {8550,0.00167647}, {8600,0.00143137}, {8650,0.00207843}, {8700,0.00140196}, {8750,0.00175490}, {8800,0.00142157}, {8850,0.00003922}, {8900,0.00000000}, {8950,0.00003922}, {9000,0.00000000}, {9050,0.00007843}, {9100,0.00007843}, {9150,0.00006863}, {9200,0.00003922}, {9250,0.00000000}, {9300,0.00003922}, {9350,0.00007843}, {9400,0.00000000}, {9450,0.00007843}, {9500,0.00003922}, {9550,0.00007843}, {9600,0.00010784}, {9650,0.00003922}, {9700,0.00011765}, {9750,0.00000000}, {9800,0.00011765}, {9850,0.00003922}, {9900,0.00003922}, {9950,0.00007843}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00007843}, {10400,0.00003922}, {10500,0.00007843}, {10600,0.00007843}, {10700,0.00019608}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00015686}, {11100,0.00003922}, {11200,0.00007843}, {11300,0.00003922}, {11400,0.00003922}, {11500,0.00003922}, {11600,0.00011765}, {11700,0.00007843}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00007843}, {12100,0.00007843}, {12200,0.00006863}, {12300,0.00007843}, {12400,0.00003922}, {12500,0.00000000}, {12600,0.00003922}, {12700,0.00011765}, {12800,0.00007843}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00015686}, {13200,0.00003922}, {13300,0.00015686}, {13400,0.00003922}, {13500,0.00003922}, {13600,0.00007843}, {13700,0.00006863}, {13800,0.00003922}, {13900,0.00003922}, {14000,0.00015686}, {14100,0.00019608}, {14200,0.00002941}, {14300,0.00007843}, {14400,0.00003922}, {14500,0.00011765}, {14600,0.00007843}, {14700,0.00003922}, {14800,0.00007843}, {14900,0.00011765}, {15000,0.00011765}, {15100,0.00000000}, {15200,0.00011765}, {15300,0.00000000}, {15400,0.00007843}, {15500,0.00007843}, {15600,0.00023529}, {15700,0.00000000}, {15800,0.00003922}, {15900,0.00000000}, {16000,0.00011765}, {16100,0.00003922}, {16200,0.00011765}, {16300,0.00000000}, {16400,0.00011765}, {16500,0.00000000}, {16600,0.00006863}, {16700,0.00007843}, {16800,0.00007843}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00003922}, {17200,0.00007843}, {17300,0.00007843}, {17400,0.00007843}, {17500,0.00007843}, {17600,0.00007843}, {17700,0.00000000}, {17800,0.00015686}, {17900,0.00003922}, {18000,0.00007843}, {18100,0.00003922}, {18200,0.00003922}, {18300,0.00014706}, {18400,0.00015686}, {18500,0.00000000}, {18600,0.00007843}, {18700,0.00000000}, {18800,0.00015686}, {18900,0.00000000}, {19000,0.00003922}, {19100,0.00011765}, {19200,0.00003922}, {19300,0.00011765}, {19400,0.00007843}, {19500,0.00011765}, {19600,0.00015686}, {19700,0.00002941}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00011765}};
data["big"]["Ltac2LowLevel"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00099020}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00101961}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000980}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00076471}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00150000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00201961}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000980}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000980}, {550,0.00002941}, {555,0.00000980}, {560,0.00001961}, {565,0.00000980}, {570,0.00004902}, {575,0.00005882}, {580,0.00006863}, {585,0.00023529}, {590,0.00035294}, {595,0.00046078}, {600,0.00047059}, {605,0.00059804}, {610,0.00058824}, {615,0.00066667}, {620,0.00067647}, {625,0.00072549}, {630,0.00078431}, {635,0.00081373}, {640,0.00079412}, {645,0.00094118}, {650,0.00092157}, {655,0.00092157}, {660,0.00096078}, {665,0.00098039}, {670,0.00098039}, {675,0.00099020}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00100000}, {830,0.00100000}, {835,0.00100000}, {840,0.00100000}, {845,0.00100000}, {850,0.00100000}, {855,0.00100000}, {860,0.00101961}, {865,0.00100000}, {870,0.00100000}, {875,0.00100000}, {880,0.00102941}, {885,0.00100000}, {890,0.00100000}, {895,0.00100000}, {900,0.00100000}, {905,0.00100000}, {910,0.00100000}, {915,0.00100000}, {920,0.00100000}, {925,0.00100000}, {930,0.00100000}, {935,0.00100000}, {940,0.00100000}, {945,0.00100000}, {950,0.00100000}, {955,0.00100000}, {960,0.00100000}, {965,0.00100000}, {970,0.00100000}, {975,0.00100000}, {980,0.00101961}, {985,0.00100000}, {990,0.00100000}, {995,0.00100000}, {1000,0.00100000}, {1010,0.00100000}, {1020,0.00100000}, {1030,0.00100000}, {1040,0.00100000}, {1050,0.00100000}, {1060,0.00100000}, {1070,0.00100980}, {1080,0.00100000}, {1090,0.00100000}, {1100,0.00100980}, {1110,0.00100980}, {1120,0.00102941}, {1130,0.00101961}, {1140,0.00105882}, {1150,0.00106863}, {1160,0.00115686}, {1170,0.00119608}, {1180,0.00129412}, {1190,0.00150000}, {1200,0.00165686}, {1210,0.00178431}, {1220,0.00180392}, {1230,0.00183333}, {1240,0.00181373}, {1250,0.00194118}, {1260,0.00197059}, {1270,0.00199020}, {1280,0.00199020}, {1290,0.00199020}, {1300,0.00204902}, {1310,0.00200000}, {1320,0.00200000}, {1330,0.00200000}, {1340,0.00200000}, {1350,0.00200000}, {1360,0.00200000}, {1370,0.00203922}, {1380,0.00200000}, {1390,0.00200000}, {1400,0.00200000}, {1410,0.00200000}, {1420,0.00776471}, {1430,0.00200000}, {1440,0.00200000}, {1450,0.00200000}, {1460,0.00200000}, {1470,0.00200000}, {1480,0.00200000}, {1490,0.00200000}, {1500,0.00571569}, {1510,0.00200000}, {1520,0.00200000}, {1530,0.00200000}, {1540,0.00200000}, {1550,0.00200000}, {1560,0.00200000}, {1570,0.00200000}, {1580,0.00200980}, {1590,0.00200000}, {1600,0.00200980}, {1610,0.00200000}, {1620,0.00203922}, {1630,0.00200000}, {1640,0.00200980}, {1650,0.00201961}, {1660,0.00202941}, {1670,0.00204902}, {1680,0.00206863}, {1690,0.00208824}, {1700,0.00206863}, {1710,0.00213725}, {1720,0.00212745}, {1730,0.00227451}, {1740,0.00216667}, {1750,0.00223529}, {1760,0.00233333}, {1770,0.00241176}, {1780,0.00243137}, {1790,0.00257843}, {1800,0.00260784}, {1810,0.00271569}, {1820,0.00273529}, {1830,0.00279412}, {1840,0.00282353}, {1850,0.00284314}, {1860,0.00286275}, {1870,0.00288235}, {1880,0.00920588}, {1890,0.00294118}, {1900,0.00298039}, {1910,0.00300000}, {1920,0.00300000}, {1930,0.00300000}, {1940,0.00299020}, {1950,0.00300000}, {1960,0.00300000}, {1970,0.00300000}, {1980,0.00300000}, {1990,0.00300000}, {2000,0.00300000}, {2050,0.00300000}, {2100,0.00300000}, {2150,0.00300000}, {2200,0.00311765}, {2250,0.00313725}, {2300,0.00328431}, {2350,0.00350980}, {2400,0.00371569}, {2450,0.00385294}, {2500,0.00926471}, {2550,0.00400000}, {2600,0.00400980}, {2650,0.00400980}, {2700,0.00403922}, {2750,0.00405882}, {2800,0.00415686}, {2850,0.00429412}, {2900,0.00442157}, {2950,0.00468627}, {3000,0.00478431}, {3050,0.00488235}, {3100,0.00500980}, {3150,0.00500000}, {3200,0.00500000}, {3250,0.00505882}, {3300,0.00508824}, {3350,0.00512745}, {3400,0.00525490}, {3450,0.00832353}, {3500,0.01601961}, {3550,0.01654902}, {3600,0.01018627}, {3650,0.00596078}, {3700,0.00600000}, {3750,0.00601961}, {3800,0.00605882}, {3850,0.00609804}, {3900,0.00616667}, {3950,0.00631373}, {4000,0.00650000}, {4050,0.00665686}, {4100,0.00679412}, {4150,0.00684314}, {4200,0.00689216}, {4250,0.00701961}, {4300,0.00710784}, {4350,0.00708824}, {4400,0.00708824}, {4450,0.00722549}, {4500,0.01093137}, {4550,0.00753922}, {4600,0.00770588}, {4650,0.00772549}, {4700,0.00783333}, {4750,0.00788235}, {4800,0.00795098}, {4850,0.00803922}, {4900,0.01315686}, {4950,0.00812745}, {5000,0.00820588}, {5050,0.00838235}, {5100,0.00835294}, {5150,0.00870588}, {5200,0.00875490}, {5250,0.00879412}, {5300,0.00890196}, {5350,0.00900980}, {5400,0.00901961}, {5450,0.00912745}, {5500,0.00913725}, {5550,0.00923529}, {5600,0.00947059}, {5650,0.00962745}, {5700,0.00971569}, {5750,0.00970588}, {5800,0.02238235}, {5850,0.02708824}, {5900,0.02617647}, {5950,0.01941176}, {6000,0.01008824}, {6050,0.01018627}, {6100,0.01032353}, {6150,0.01036275}, {6200,0.01058824}, {6250,0.01071569}, {6300,0.01077451}, {6350,0.03837255}, {6400,0.01086275}, {6450,0.01092157}, {6500,0.01097059}, {6550,0.01113725}, {6600,0.01113725}, {6650,0.01129412}, {6700,0.01136275}, {6750,0.01161765}, {6800,0.01168627}, {6850,0.01168627}, {6900,0.03657843}, {6950,0.01180392}, {7000,0.01197059}, {7050,0.01206863}, {7100,0.01214706}, {7150,0.04392157}, {7200,0.03216667}, {7250,0.01236275}, {7300,0.01253922}, {7350,0.01263725}, {7400,0.01277451}, {7450,0.01274510}, {7500,0.01286275}, {7550,0.03543137}, {7600,0.01310784}, {7650,0.04709804}, {7700,0.01321569}, {7750,0.02683333}, {7800,0.01348039}, {7850,0.01361765}, {7900,0.02558824}, {7950,0.01373529}, {8000,0.01388235}, {8050,0.01386275}, {8100,0.01393137}, {8150,0.01399020}, {8200,0.01409804}, {8250,0.01423529}, {8300,0.01432353}, {8350,0.01458824}, {8400,0.01462745}, {8450,0.01479412}, {8500,0.05028431}, {8550,0.01480392}, {8600,0.01491176}, {8650,0.01495098}, {8700,0.01501961}, {8750,0.01518627}, {8800,0.01504902}, {8850,0.01539216}, {8900,0.01553922}, {8950,0.01568627}, {9000,0.01573529}, {9050,0.01574510}, {9100,0.05255882}, {9150,0.01602941}, {9200,0.01594118}, {9250,0.01608824}, {9300,0.01617647}, {9350,0.01640196}, {9400,0.01638235}, {9450,0.01649020}, {9500,0.01666667}, {9550,0.01670588}, {9600,0.01682353}, {9650,0.01690196}, {9700,0.04073529}, {9750,0.01691176}, {9800,0.01694118}, {9850,0.04312745}, {9900,0.01717647}, {9950,0.01750000}, {10000,0.01758824}, {10100,0.05825490}, {10200,0.01784314}, {10300,0.01794118}, {10400,0.03414706}, {10500,0.05378431}, {10600,0.05959804}, {10700,0.05000980}, {10800,0.02685294}, {10900,0.01905882}, {11000,0.01919608}, {11100,0.04980392}, {11200,0.01966667}, {11300,0.02959804}, {11400,0.02021569}, {11500,0.02033333}, {11600,0.02035294}, {11700,0.02058824}, {11800,0.02083333}, {11900,0.02085294}, {12000,0.02124510}, {12100,0.02141176}, {12200,0.04178431}, {12300,0.02170588}, {12400,0.05147059}, {12500,0.02200980}, {12600,0.02232353}, {12700,0.04791176}, {12800,0.07391176}, {12900,0.08179412}, {13000,0.07971569}, {13100,0.06354902}, {13200,0.03783333}, {13300,0.02357843}, {13400,0.02385294}, {13500,0.02408824}, {13600,0.02403922}, {13700,0.02444118}, {13800,0.05168627}, {13900,0.08341176}, {14000,0.02487255}, {14100,0.02502941}, {14200,0.02539216}, {14300,0.08050000}, {14400,0.05033333}, {14500,0.02590196}, {14600,0.02611765}, {14700,0.02600000}, {14800,0.09304902}, {14900,0.02650980}, {15000,0.04148039}, {15100,0.08393137}, {15200,0.09680392}, {15300,0.08950000}, {15400,0.08071569}, {15500,0.05741176}, {15600,0.02800980}, {15700,0.02824510}, {15800,0.06043137}, {15900,0.02842157}, {16000,0.05298039}, {16100,0.09861765}, {16200,0.02888235}, {16300,0.02927451}, {16400,0.02922549}, {16500,0.02949020}, {16600,0.02965686}, {16700,0.02992157}, {16800,0.10049020}, {16900,0.04881373}, {17000,0.03059804}, {17100,0.05575490}, {17200,0.03084314}, {17300,0.03112745}, {17400,0.04924510}, {17500,0.06919608}, {17600,0.07763725}, {17700,0.07474510}, {17800,0.05385294}, {17900,0.03238235}, {18000,0.03229412}, {18100,0.07697059}, {18200,0.03288235}, {18300,0.07814706}, {18400,0.03323529}, {18500,0.03323529}, {18600,0.06300980}, {18700,0.07445098}, {18800,0.07642157}, {18900,0.07372549}, {19000,0.05071569}, {19100,0.03453922}, {19200,0.03465686}, {19300,0.06810784}, {19400,0.03489216}, {19500,0.06487255}, {19600,0.11533333}, {19700,0.03527451}, {19800,0.03580392}, {19900,0.03558824}, {20000,0.03547059}};
data["big"]["Ltac2LowLevel"]["cbv"]["user"] = {{1,0.00007843}, {2,0.00010784}, {3,0.00007843}, {4,0.00003922}, {5,0.00002941}, {6,0.00000000}, {7,0.00000000}, {8,0.00003922}, {9,0.00006863}, {10,0.00007843}, {11,0.00003922}, {12,0.00000000}, {13,0.00010784}, {14,0.00000000}, {15,0.00003922}, {16,0.00000000}, {17,0.00000000}, {18,0.00010784}, {19,0.00000000}, {20,0.00010784}, {21,0.00003922}, {22,0.00003922}, {23,0.00007843}, {24,0.00003922}, {25,0.00002941}, {26,0.00014706}, {27,0.00026471}, {28,0.00007843}, {29,0.00003922}, {30,0.00003922}, {31,0.00000000}, {32,0.00009804}, {33,0.00014706}, {34,0.00006863}, {35,0.00002941}, {36,0.00015686}, {37,0.00000000}, {38,0.00006863}, {39,0.00000000}, {40,0.00016667}, {41,0.00018627}, {42,0.00014706}, {43,0.00002941}, {44,0.00009804}, {45,0.00011765}, {46,0.00017647}, {47,0.00006863}, {48,0.00003922}, {49,0.00021569}, {50,0.00006863}, {51,0.00003922}, {52,0.00016667}, {53,0.00003922}, {54,0.00002941}, {55,0.00006863}, {56,0.00017647}, {57,0.00013725}, {58,0.00010784}, {59,0.00007843}, {60,0.00017647}, {61,0.00017647}, {62,0.00010784}, {63,0.00006863}, {64,0.00002941}, {65,0.00010784}, {66,0.00016667}, {67,0.00006863}, {68,0.00011765}, {69,0.00018627}, {70,0.00010784}, {71,0.00010784}, {72,0.00025490}, {73,0.00018627}, {74,0.00009804}, {75,0.00010784}, {76,0.00010784}, {77,0.00012745}, {78,0.00019608}, {79,0.00010784}, {80,0.00003922}, {81,0.00006863}, {82,0.00011765}, {83,0.00009804}, {84,0.00018627}, {85,0.00018627}, {86,0.00017647}, {87,0.00015686}, {88,0.00007843}, {89,0.00007843}, {90,0.00020588}, {91,0.00003922}, {92,0.00014706}, {93,0.00010784}, {94,0.00021569}, {95,0.00029412}, {96,0.00010784}, {97,0.00007843}, {98,0.00007843}, {99,0.00025490}, {100,0.00013725}, {101,0.00017647}, {102,0.00018627}, {103,0.00009804}, {104,0.00016667}, {105,0.00026471}, {106,0.00040196}, {107,0.00009804}, {108,0.00014706}, {109,0.00012745}, {110,0.00021569}, {111,0.00010784}, {112,0.00033333}, {113,0.00013725}, {114,0.00017647}, {115,0.00016667}, {116,0.00017647}, {117,0.00022549}, {118,0.00017647}, {119,0.00013725}, {120,0.00031373}, {121,0.00014706}, {122,0.00034314}, {123,0.00024510}, {124,0.00019608}, {125,0.00007843}, {126,0.00003922}, {127,0.00015686}, {128,0.00039216}, {129,0.00019608}, {130,0.00026471}, {131,0.00022549}, {132,0.00010784}, {133,0.00028431}, {134,0.00029412}, {135,0.00022549}, {136,0.00017647}, {137,0.00009804}, {138,0.00025490}, {139,0.00020588}, {140,0.00012745}, {141,0.00017647}, {142,0.00030392}, {143,0.00021569}, {144,0.00014706}, {145,0.00019608}, {146,0.00016667}, {147,0.00022549}, {148,0.00027451}, {149,0.00021569}, {150,0.00039216}, {151,0.00024510}, {152,0.00023529}, {153,0.00020588}, {154,0.00019608}, {155,0.00029412}, {156,0.00023529}, {157,0.00033333}, {158,0.00029412}, {159,0.00034314}, {160,0.00029412}, {161,0.00027451}, {162,0.00013725}, {163,0.00041176}, {164,0.00034314}, {165,0.00013725}, {166,0.00014706}, {167,0.00034314}, {168,0.00018627}, {169,0.00035294}, {170,0.00021569}, {171,0.00018627}, {172,0.00027451}, {173,0.00032353}, {174,0.00027451}, {175,0.00035294}, {176,0.00026471}, {177,0.00015686}, {178,0.00030392}, {179,0.00024510}, {180,0.00028431}, {181,0.00023529}, {182,0.00015686}, {183,0.00022549}, {184,0.00023529}, {185,0.00025490}, {186,0.00032353}, {187,0.00044118}, {188,0.00020588}, {189,0.00025490}, {190,0.00018627}, {191,0.00034314}, {192,0.00028431}, {193,0.00023529}, {194,0.00045098}, {195,0.00018627}, {196,0.00116667}, {197,0.00038235}, {198,0.00046078}, {199,0.00014706}, {200,0.00044118}, {201,0.00026471}, {202,0.00035294}, {203,0.00032353}, {204,0.00021569}, {205,0.00021569}, {206,0.00015686}, {207,0.00037255}, {208,0.00044118}, {209,0.00030392}, {210,0.00020588}, {211,0.00026471}, {212,0.00025490}, {213,0.00030392}, {214,0.00037255}, {215,0.00051961}, {216,0.00033333}, {217,0.00055882}, {218,0.00038235}, {219,0.00053922}, {220,0.00034314}, {221,0.00029412}, {222,0.00031373}, {223,0.00025490}, {224,0.00013725}, {225,0.00036275}, {226,0.00046078}, {227,0.00024510}, {228,0.00030392}, {229,0.00044118}, {230,0.00035294}, {231,0.00058824}, {232,0.00029412}, {233,0.00036275}, {234,0.00044118}, {235,0.00020588}, {236,0.00035294}, {237,0.00036275}, {238,0.00025490}, {239,0.00041176}, {240,0.00028431}, {241,0.00027451}, {242,0.00039216}, {243,0.00045098}, {244,0.00028431}, {245,0.00025490}, {246,0.00037255}, {247,0.00025490}, {248,0.00029412}, {249,0.00046078}, {250,0.00049020}, {251,0.00044118}, {252,0.00027451}, {253,0.00044118}, {254,0.00034314}, {255,0.00044118}, {256,0.00034314}, {257,0.00053922}, {258,0.00017647}, {259,0.00040196}, {260,0.00034314}, {261,0.00025490}, {262,0.00028431}, {263,0.00032353}, {264,0.00041176}, {265,0.00052941}, {266,0.00071569}, {267,0.00038235}, {268,0.00036275}, {269,0.00056863}, {270,0.00031373}, {271,0.00054902}, {272,0.00052941}, {273,0.00023529}, {274,0.00058824}, {275,0.00053922}, {276,0.00051961}, {277,0.00043137}, {278,0.00054902}, {279,0.00057843}, {280,0.00057843}, {281,0.00150000}, {282,0.00052941}, {283,0.00039216}, {284,0.00040196}, {285,0.00040196}, {286,0.00033333}, {287,0.00038235}, {288,0.00037255}, {289,0.00034314}, {290,0.00041176}, {291,0.00042157}, {292,0.00045098}, {293,0.00055882}, {294,0.00047059}, {295,0.00042157}, {296,0.00061765}, {297,0.00034314}, {298,0.00031373}, {299,0.00056863}, {300,0.00035294}, {301,0.00036275}, {302,0.00070588}, {303,0.00040196}, {304,0.00036275}, {305,0.00027451}, {306,0.00045098}, {307,0.00037255}, {308,0.00114706}, {309,0.00074510}, {310,0.00044118}, {311,0.00057843}, {312,0.00046078}, {313,0.00037255}, {314,0.00026471}, {315,0.00050000}, {316,0.00064706}, {317,0.00073529}, {318,0.00061765}, {319,0.00033333}, {320,0.00038235}, {321,0.00062745}, {322,0.00052941}, {323,0.00041176}, {324,0.00040196}, {325,0.00040196}, {326,0.00042157}, {327,0.00044118}, {328,0.00050000}, {329,0.00043137}, {330,0.00050980}, {331,0.00072549}, {332,0.00081373}, {333,0.00051961}, {334,0.00035294}, {335,0.00064706}, {336,0.00034314}, {337,0.00068627}, {338,0.00050980}, {339,0.00057843}, {340,0.00057843}, {341,0.00048039}, {342,0.00046078}, {343,0.00053922}, {344,0.00054902}, {345,0.00048039}, {346,0.00037255}, {347,0.00046078}, {348,0.00060784}, {349,0.00038235}, {350,0.00040196}, {351,0.00035294}, {352,0.00051961}, {353,0.00056863}, {354,0.00053922}, {355,0.00068627}, {356,0.00168627}, {357,0.00055882}, {358,0.00041176}, {359,0.00045098}, {360,0.00046078}, {361,0.00069608}, {362,0.00056863}, {363,0.00085294}, {364,0.00052941}, {365,0.00057843}, {366,0.00055882}, {367,0.00073529}, {368,0.00050980}, {369,0.00044118}, {370,0.00061765}, {371,0.00039216}, {372,0.00071569}, {373,0.00032353}, {374,0.00065686}, {375,0.00060784}, {376,0.00066667}, {377,0.00051961}, {378,0.00078431}, {379,0.00076471}, {380,0.00079412}, {381,0.00059804}, {382,0.00054902}, {383,0.00053922}, {384,0.00049020}, {385,0.00058824}, {386,0.00056863}, {387,0.00080392}, {388,0.00065686}, {389,0.00057843}, {390,0.00071569}, {391,0.00062745}, {392,0.00052941}, {393,0.00034314}, {394,0.00063725}, {395,0.00064706}, {396,0.00051961}, {397,0.00078431}, {398,0.00053922}, {399,0.00049020}, {400,0.00061765}, {401,0.00057843}, {402,0.00065686}, {403,0.00052941}, {404,0.00052941}, {405,0.00065686}, {406,0.00059804}, {407,0.00060784}, {408,0.00076471}, {409,0.00058824}, {410,0.00061765}, {411,0.00076471}, {412,0.00060784}, {413,0.00066667}, {414,0.00050980}, {415,0.00068627}, {416,0.00061765}, {417,0.00050980}, {418,0.00069608}, {419,0.00067647}, {420,0.00066667}, {421,0.00035294}, {422,0.00064706}, {423,0.00056863}, {424,0.00049020}, {425,0.00043137}, {426,0.00064706}, {427,0.00030392}, {428,0.00080392}, {429,0.00064706}, {430,0.00063725}, {431,0.00036275}, {432,0.00060784}, {433,0.00030392}, {434,0.00043137}, {435,0.00062745}, {436,0.00061765}, {437,0.00064706}, {438,0.00055882}, {439,0.00038235}, {440,0.00057843}, {441,0.00050000}, {442,0.00051961}, {443,0.00061765}, {444,0.00076471}, {445,0.00074510}, {446,0.00064706}, {447,0.00068627}, {448,0.00050980}, {449,0.00060784}, {450,0.00056863}, {451,0.00069608}, {452,0.00081373}, {453,0.00093137}, {454,0.00054902}, {455,0.00057843}, {456,0.00049020}, {457,0.00074510}, {458,0.00065686}, {459,0.00071569}, {460,0.00085294}, {461,0.00087255}, {462,0.00068627}, {463,0.00068627}, {464,0.00110784}, {465,0.00079412}, {466,0.00045098}, {467,0.00048039}, {468,0.00072549}, {469,0.00047059}, {470,0.00058824}, {471,0.00050980}, {472,0.00067647}, {473,0.00080392}, {474,0.00050980}, {475,0.00074510}, {476,0.00094118}, {477,0.00226471}, {478,0.00074510}, {479,0.00084314}, {480,0.00044118}, {481,0.00060784}, {482,0.00076471}, {483,0.00059804}, {484,0.00077451}, {485,0.00072549}, {486,0.00069608}, {487,0.00085294}, {488,0.00095098}, {489,0.00064706}, {490,0.00053922}, {491,0.00092157}, {492,0.00074510}, {493,0.00055882}, {494,0.00076471}, {495,0.00059804}, {496,0.00100000}, {497,0.00095098}, {498,0.00089216}, {499,0.00070588}, {500,0.00072549}, {505,0.00059804}, {510,0.00083333}, {515,0.00070588}, {520,0.00063725}, {525,0.00103922}, {530,0.00066667}, {535,0.00073529}, {540,0.00093137}, {545,0.00071569}, {550,0.00098039}, {555,0.00081373}, {560,0.00081373}, {565,0.00100980}, {570,0.00072549}, {575,0.00101961}, {580,0.00071569}, {585,0.00110784}, {590,0.00094118}, {595,0.00091176}, {600,0.00104902}, {605,0.00096078}, {610,0.00083333}, {615,0.00105882}, {620,0.00082353}, {625,0.00128431}, {630,0.00077451}, {635,0.00106863}, {640,0.00076471}, {645,0.00113725}, {650,0.00094118}, {655,0.00109804}, {660,0.00092157}, {665,0.00115686}, {670,0.00090196}, {675,0.00113725}, {680,0.00129412}, {685,0.00101961}, {690,0.00114706}, {695,0.00111765}, {700,0.00069608}, {705,0.00140196}, {710,0.00118627}, {715,0.00146078}, {720,0.00104902}, {725,0.00094118}, {730,0.00091176}, {735,0.00124510}, {740,0.00127451}, {745,0.00137255}, {750,0.00127451}, {755,0.00144118}, {760,0.00092157}, {765,0.00103922}, {770,0.00115686}, {775,0.00132353}, {780,0.00151961}, {785,0.00106863}, {790,0.00117647}, {795,0.00101961}, {800,0.00112745}, {805,0.00120588}, {810,0.00128431}, {815,0.00111765}, {820,0.00097059}, {825,0.00111765}, {830,0.00110784}, {835,0.00098039}, {840,0.00131373}, {845,0.00135294}, {850,0.00151961}, {855,0.00133333}, {860,0.00140196}, {865,0.00098039}, {870,0.00151961}, {875,0.00124510}, {880,0.00142157}, {885,0.00150980}, {890,0.00141176}, {895,0.00110784}, {900,0.00151961}, {905,0.00137255}, {910,0.00155882}, {915,0.00136275}, {920,0.00124510}, {925,0.00164706}, {930,0.00128431}, {935,0.00141176}, {940,0.00154902}, {945,0.00169608}, {950,0.00162745}, {955,0.00161765}, {960,0.00170588}, {965,0.00133333}, {970,0.00175490}, {975,0.00122549}, {980,0.00153922}, {985,0.00185294}, {990,0.00123529}, {995,0.00139216}, {1000,0.00138235}, {1010,0.00129412}, {1020,0.00172549}, {1030,0.00111765}, {1040,0.00161765}, {1050,0.00165686}, {1060,0.00186275}, {1070,0.00128431}, {1080,0.00157843}, {1090,0.00150000}, {1100,0.00192157}, {1110,0.00175490}, {1120,0.00183333}, {1130,0.00163725}, {1140,0.00191176}, {1150,0.00164706}, {1160,0.00191176}, {1170,0.00158824}, {1180,0.00191176}, {1190,0.00179412}, {1200,0.00222549}, {1210,0.00192157}, {1220,0.00195098}, {1230,0.00165686}, {1240,0.00175490}, {1250,0.00188235}, {1260,0.00191176}, {1270,0.00189216}, {1280,0.00163725}, {1290,0.00196078}, {1300,0.00248039}, {1310,0.00226471}, {1320,0.00226471}, {1330,0.00204902}, {1340,0.00161765}, {1350,0.00239216}, {1360,0.00181373}, {1370,0.00236275}, {1380,0.00214706}, {1390,0.00215686}, {1400,0.00209804}, {1410,0.00207843}, {1420,0.00748039}, {1430,0.00221569}, {1440,0.00198039}, {1450,0.00212745}, {1460,0.00223529}, {1470,0.00225490}, {1480,0.00226471}, {1490,0.00240196}, {1500,0.00562745}, {1510,0.00215686}, {1520,0.00227451}, {1530,0.00220588}, {1540,0.00230392}, {1550,0.00222549}, {1560,0.00223529}, {1570,0.00231373}, {1580,0.00250000}, {1590,0.00269608}, {1600,0.00250980}, {1610,0.00209804}, {1620,0.00263725}, {1630,0.00274510}, {1640,0.00228431}, {1650,0.00225490}, {1660,0.00265686}, {1670,0.00259804}, {1680,0.00259804}, {1690,0.00253922}, {1700,0.00272549}, {1710,0.00278431}, {1720,0.00237255}, {1730,0.00279412}, {1740,0.00238235}, {1750,0.00263725}, {1760,0.00237255}, {1770,0.00256863}, {1780,0.00259804}, {1790,0.00280392}, {1800,0.00287255}, {1810,0.00272549}, {1820,0.00292157}, {1830,0.00274510}, {1840,0.00291176}, {1850,0.00293137}, {1860,0.00296078}, {1870,0.00272549}, {1880,0.00867647}, {1890,0.00303922}, {1900,0.00296078}, {1910,0.00300980}, {1920,0.00314706}, {1930,0.00267647}, {1940,0.00289216}, {1950,0.00336275}, {1960,0.00304902}, {1970,0.00307843}, {1980,0.00310784}, {1990,0.00299020}, {2000,0.00317647}, {2050,0.00317647}, {2100,0.00320588}, {2150,0.00343137}, {2200,0.00346078}, {2250,0.00350980}, {2300,0.00360784}, {2350,0.00368627}, {2400,0.00367647}, {2450,0.00392157}, {2500,0.00954902}, {2550,0.00399020}, {2600,0.00398039}, {2650,0.00400980}, {2700,0.00415686}, {2750,0.00443137}, {2800,0.00431373}, {2850,0.00446078}, {2900,0.00500980}, {2950,0.00484314}, {3000,0.00480392}, {3050,0.00454902}, {3100,0.00517647}, {3150,0.00503922}, {3200,0.00503922}, {3250,0.00519608}, {3300,0.00531373}, {3350,0.00532353}, {3400,0.00504902}, {3450,0.00825490}, {3500,0.01558824}, {3550,0.01653922}, {3600,0.01032353}, {3650,0.00573529}, {3700,0.00606863}, {3750,0.00604902}, {3800,0.00626471}, {3850,0.00603922}, {3900,0.00623529}, {3950,0.00621569}, {4000,0.00614706}, {4050,0.00644118}, {4100,0.00645098}, {4150,0.00642157}, {4200,0.00675490}, {4250,0.00664706}, {4300,0.00708824}, {4350,0.00700000}, {4400,0.00699020}, {4450,0.00709804}, {4500,0.01130392}, {4550,0.00734314}, {4600,0.00739216}, {4650,0.00786275}, {4700,0.00770588}, {4750,0.00773529}, {4800,0.00803922}, {4850,0.00800980}, {4900,0.01358824}, {4950,0.00802941}, {5000,0.00844118}, {5050,0.00852941}, {5100,0.00838235}, {5150,0.00918627}, {5200,0.00900980}, {5250,0.00883333}, {5300,0.00866667}, {5350,0.00915686}, {5400,0.00889216}, {5450,0.00918627}, {5500,0.00934314}, {5550,0.00941176}, {5600,0.00983333}, {5650,0.00951961}, {5700,0.00950000}, {5750,0.00973529}, {5800,0.02282353}, {5850,0.02721569}, {5900,0.02596078}, {5950,0.01904902}, {6000,0.01019608}, {6050,0.01068627}, {6100,0.01053922}, {6150,0.01082353}, {6200,0.01088235}, {6250,0.01095098}, {6300,0.01137255}, {6350,0.03872549}, {6400,0.01140196}, {6450,0.01133333}, {6500,0.01150980}, {6550,0.01163725}, {6600,0.01158824}, {6650,0.01156863}, {6700,0.01190196}, {6750,0.01202941}, {6800,0.01194118}, {6850,0.01208824}, {6900,0.03667647}, {6950,0.01231373}, {7000,0.01259804}, {7050,0.01256863}, {7100,0.01269608}, {7150,0.04379412}, {7200,0.03202941}, {7250,0.01284314}, {7300,0.01300980}, {7350,0.01294118}, {7400,0.01326471}, {7450,0.01295098}, {7500,0.01297059}, {7550,0.03551961}, {7600,0.01354902}, {7650,0.04752941}, {7700,0.01365686}, {7750,0.02699020}, {7800,0.01367647}, {7850,0.01359804}, {7900,0.02599020}, {7950,0.01375490}, {8000,0.01407843}, {8050,0.01413725}, {8100,0.01436275}, {8150,0.01398039}, {8200,0.01417647}, {8250,0.01480392}, {8300,0.01457843}, {8350,0.01473529}, {8400,0.01461765}, {8450,0.01460784}, {8500,0.04921569}, {8550,0.01488235}, {8600,0.01489216}, {8650,0.01521569}, {8700,0.01525490}, {8750,0.01558824}, {8800,0.01514706}, {8850,0.01557843}, {8900,0.01553922}, {8950,0.01574510}, {9000,0.01575490}, {9050,0.01592157}, {9100,0.05236275}, {9150,0.01611765}, {9200,0.01596078}, {9250,0.01630392}, {9300,0.01632353}, {9350,0.01666667}, {9400,0.01645098}, {9450,0.01665686}, {9500,0.01681373}, {9550,0.01637255}, {9600,0.01665686}, {9650,0.01689216}, {9700,0.04075490}, {9750,0.01714706}, {9800,0.01693137}, {9850,0.04278431}, {9900,0.01741176}, {9950,0.01731373}, {10000,0.01760784}, {10100,0.05841176}, {10200,0.01757843}, {10300,0.01786275}, {10400,0.03471569}, {10500,0.05354902}, {10600,0.05950980}, {10700,0.05022549}, {10800,0.02684314}, {10900,0.01885294}, {11000,0.01918627}, {11100,0.04966667}, {11200,0.01926471}, {11300,0.02923529}, {11400,0.02016667}, {11500,0.02023529}, {11600,0.02043137}, {11700,0.02038235}, {11800,0.02075490}, {11900,0.02054902}, {12000,0.02144118}, {12100,0.02135294}, {12200,0.04163725}, {12300,0.02162745}, {12400,0.05150980}, {12500,0.02233333}, {12600,0.02263725}, {12700,0.04806863}, {12800,0.07386275}, {12900,0.08205882}, {13000,0.07978431}, {13100,0.06332353}, {13200,0.03815686}, {13300,0.02392157}, {13400,0.02413725}, {13500,0.02442157}, {13600,0.02439216}, {13700,0.02459804}, {13800,0.05166667}, {13900,0.08329412}, {14000,0.02487255}, {14100,0.02552941}, {14200,0.02562745}, {14300,0.08031373}, {14400,0.05049020}, {14500,0.02623529}, {14600,0.02629412}, {14700,0.02657843}, {14800,0.09288235}, {14900,0.02678431}, {15000,0.04144118}, {15100,0.08400000}, {15200,0.09682353}, {15300,0.08964706}, {15400,0.08050980}, {15500,0.05731373}, {15600,0.02806863}, {15700,0.02835294}, {15800,0.06059804}, {15900,0.02867647}, {16000,0.05315686}, {16100,0.09861765}, {16200,0.02869608}, {16300,0.02900980}, {16400,0.02927451}, {16500,0.02954902}, {16600,0.02951961}, {16700,0.02991176}, {16800,0.10053922}, {16900,0.04899020}, {17000,0.03037255}, {17100,0.05570588}, {17200,0.03090196}, {17300,0.03091176}, {17400,0.04947059}, {17500,0.06936275}, {17600,0.07782353}, {17700,0.07501961}, {17800,0.05391176}, {17900,0.03236275}, {18000,0.03217647}, {18100,0.07717647}, {18200,0.03304902}, {18300,0.07812745}, {18400,0.03320588}, {18500,0.03320588}, {18600,0.06286275}, {18700,0.07437255}, {18800,0.07646078}, {18900,0.07384314}, {19000,0.05077451}, {19100,0.03449020}, {19200,0.03490196}, {19300,0.06803922}, {19400,0.03450000}, {19500,0.06437255}, {19600,0.11508824}, {19700,0.03495098}, {19800,0.03582353}, {19900,0.03550000}, {20000,0.03529412}};
data["big"]["Ltac2LowLevel"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003922}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00003922}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00003922}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00003922}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00003922}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00003922}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00003922}, {187,0.00000000}, {188,0.00003922}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00003922}, {198,0.00003922}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00003922}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00003922}, {222,0.00000000}, {223,0.00003922}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00002941}, {236,0.00003922}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00003922}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00003922}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00003922}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00003922}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00003922}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00003922}, {321,0.00003922}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00002941}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00003922}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00003922}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00003922}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00003922}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00007843}, {491,0.00000000}, {492,0.00000000}, {493,0.00007843}, {494,0.00000000}, {495,0.00007843}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00003922}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00003922}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00003922}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00003922}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00003922}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00003922}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00003922}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00003922}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00003922}, {1000,0.00000000}, {1010,0.00003922}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00003922}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00003922}, {1180,0.00003922}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00007843}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00003922}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00002941}, {1370,0.00003922}, {1380,0.00003922}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00003922}, {1430,0.00003922}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00015686}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00003922}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00003922}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00002941}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00002941}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00023529}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00003922}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00003922}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00018627}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00003922}, {3200,0.00003922}, {3250,0.00003922}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00007843}, {3500,0.00031373}, {3550,0.00023529}, {3600,0.00015686}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00003922}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00007843}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00003922}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00003922}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00003922}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00003922}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00007843}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00003922}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00003922}, {8450,0.00000000}, {8500,0.00108824}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00007843}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00002941}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00003922}, {9200,0.00000000}, {9250,0.00003922}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00007843}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00003922}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00003922}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00002941}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00003922}, {12000,0.00003922}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00003922}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00003922}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00003922}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00003922}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00003922}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00003922}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00003922}, {18600,0.00003922}, {18700,0.00000000}, {18800,0.00007843}, {18900,0.00003922}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00003922}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big"]["Ltac2LowLevel"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00099020}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00001961}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000980}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00178431}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00117647}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00004902}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00004902}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000980}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000980}, {1100,0.00001961}, {1110,0.00000980}, {1120,0.00003922}, {1130,0.00009804}, {1140,0.00017647}, {1150,0.00027451}, {1160,0.00043137}, {1170,0.00057843}, {1180,0.00057843}, {1190,0.00068627}, {1200,0.00084314}, {1210,0.00091176}, {1220,0.00091176}, {1230,0.00089216}, {1240,0.00094118}, {1250,0.00098039}, {1260,0.00100000}, {1270,0.00100000}, {1280,0.00100000}, {1290,0.00100000}, {1300,0.00100000}, {1310,0.00100000}, {1320,0.00100000}, {1330,0.00100000}, {1340,0.00100000}, {1350,0.00100000}, {1360,0.00100000}, {1370,0.00361765}, {1380,0.00100000}, {1390,0.00100000}, {1400,0.00100000}, {1410,0.00100000}, {1420,0.00100000}, {1430,0.00100000}, {1440,0.00100000}, {1450,0.00100000}, {1460,0.00100000}, {1470,0.00100000}, {1480,0.00100000}, {1490,0.00100000}, {1500,0.00100000}, {1510,0.00100000}, {1520,0.00100000}, {1530,0.00499020}, {1540,0.00100000}, {1550,0.00100000}, {1560,0.00100000}, {1570,0.00100000}, {1580,0.00100000}, {1590,0.00100000}, {1600,0.00100000}, {1610,0.00100000}, {1620,0.00100000}, {1630,0.00100000}, {1640,0.00351961}, {1650,0.00100000}, {1660,0.00100000}, {1670,0.00100000}, {1680,0.00100000}, {1690,0.00100000}, {1700,0.00100000}, {1710,0.00100000}, {1720,0.00100000}, {1730,0.00100000}, {1740,0.00100000}, {1750,0.00100000}, {1760,0.00100000}, {1770,0.00100000}, {1780,0.00100000}, {1790,0.00100000}, {1800,0.00100000}, {1810,0.00100000}, {1820,0.00100000}, {1830,0.00100000}, {1840,0.00100000}, {1850,0.00100000}, {1860,0.00100000}, {1870,0.00100000}, {1880,0.00100000}, {1890,0.00100000}, {1900,0.00100000}, {1910,0.00100000}, {1920,0.00100000}, {1930,0.00100000}, {1940,0.00100000}, {1950,0.00100000}, {1960,0.00100000}, {1970,0.00100000}, {1980,0.00100000}, {1990,0.00100000}, {2000,0.00100000}, {2050,0.00100000}, {2100,0.00100980}, {2150,0.00104902}, {2200,0.00107843}, {2250,0.00116667}, {2300,0.00128431}, {2350,0.00148039}, {2400,0.00171569}, {2450,0.00187255}, {2500,0.00198039}, {2550,0.00200000}, {2600,0.00200000}, {2650,0.00200000}, {2700,0.00200000}, {2750,0.00200000}, {2800,0.00200000}, {2850,0.00200000}, {2900,0.00200000}, {2950,0.00200000}, {3000,0.00200980}, {3050,0.00201961}, {3100,0.00202941}, {3150,0.00207843}, {3200,0.00207843}, {3250,0.00208824}, {3300,0.00218627}, {3350,0.00224510}, {3400,0.00243137}, {3450,0.00245098}, {3500,0.00268627}, {3550,0.00277451}, {3600,0.00287255}, {3650,0.00295098}, {3700,0.00299020}, {3750,0.00300000}, {3800,0.00300000}, {3850,0.00300980}, {3900,0.00300000}, {3950,0.00300000}, {4000,0.00300980}, {4050,0.00300980}, {4100,0.00301961}, {4150,0.00303922}, {4200,0.00307843}, {4250,0.00309804}, {4300,0.00314706}, {4350,0.00320588}, {4400,0.00334314}, {4450,0.00333333}, {4500,0.00356863}, {4550,0.00371569}, {4600,0.00373529}, {4650,0.00383333}, {4700,0.00386275}, {4750,0.00399020}, {4800,0.00398039}, {4850,0.00400000}, {4900,0.00400000}, {4950,0.00400000}, {5000,0.00409804}, {5050,0.00400980}, {5100,0.00400980}, {5150,0.00400980}, {5200,0.00407843}, {5250,0.00416667}, {5300,0.00413725}, {5350,0.00416667}, {5400,0.00430392}, {5450,0.00448039}, {5500,0.00454902}, {5550,0.00458824}, {5600,0.00471569}, {5650,0.00476471}, {5700,0.00480392}, {5750,0.00481373}, {5800,0.00487255}, {5850,0.00496078}, {5900,0.00498039}, {5950,0.00500000}, {6000,0.00500000}, {6050,0.00500980}, {6100,0.00501961}, {6150,0.00511765}, {6200,0.00504902}, {6250,0.00506863}, {6300,0.00516667}, {6350,0.00514706}, {6400,0.00517647}, {6450,0.00529412}, {6500,0.02056863}, {6550,0.00544118}, {6600,0.00557843}, {6650,0.00561765}, {6700,0.00568627}, {6750,0.00573529}, {6800,0.00576471}, {6850,0.01134314}, {6900,0.00589216}, {6950,0.00590196}, {7000,0.00597059}, {7050,0.00600980}, {7100,0.00600980}, {7150,0.01439216}, {7200,0.00603922}, {7250,0.00606863}, {7300,0.00605882}, {7350,0.00608824}, {7400,0.00614706}, {7450,0.00622549}, {7500,0.04268627}, {7550,0.00633333}, {7600,0.00648039}, {7650,0.00660784}, {7700,0.02695098}, {7750,0.00669608}, {7800,0.00671569}, {7850,0.03046078}, {7900,0.00674510}, {7950,0.00679412}, {8000,0.00680392}, {8050,0.00694118}, {8100,0.00699020}, {8150,0.00708824}, {8200,0.00708824}, {8250,0.00705882}, {8300,0.00707843}, {8350,0.00709804}, {8400,0.00708824}, {8450,0.00711765}, {8500,0.03173529}, {8550,0.00738235}, {8600,0.00746078}, {8650,0.02581373}, {8700,0.00767647}, {8750,0.00770588}, {8800,0.00770588}, {8850,0.03376471}, {8900,0.00773529}, {8950,0.00774510}, {9000,0.00778431}, {9050,0.00785294}, {9100,0.00785294}, {9150,0.00793137}, {9200,0.01559804}, {9250,0.04756863}, {9300,0.00806863}, {9350,0.00808824}, {9400,0.00808824}, {9450,0.03932353}, {9500,0.00819608}, {9550,0.00823529}, {9600,0.00835294}, {9650,0.00844118}, {9700,0.04408824}, {9750,0.00867647}, {9800,0.00868627}, {9850,0.02122549}, {9900,0.00866667}, {9950,0.03596078}, {10000,0.00868627}, {10100,0.00875490}, {10200,0.00882353}, {10300,0.00898039}, {10400,0.00907843}, {10500,0.00910784}, {10600,0.00926471}, {10700,0.00942157}, {10800,0.00960784}, {10900,0.00966667}, {11000,0.00968627}, {11100,0.03462745}, {11200,0.00974510}, {11300,0.00987255}, {11400,0.05457843}, {11500,0.01009804}, {11600,0.01018627}, {11700,0.01034314}, {11800,0.01056863}, {11900,0.01062745}, {12000,0.01874510}, {12100,0.01068627}, {12200,0.01072549}, {12300,0.01078431}, {12400,0.01085294}, {12500,0.01098039}, {12600,0.01116667}, {12700,0.01122549}, {12800,0.02718627}, {12900,0.02500980}, {13000,0.01170588}, {13100,0.01170588}, {13200,0.01173529}, {13300,0.05632353}, {13400,0.01180392}, {13500,0.01194118}, {13600,0.01200980}, {13700,0.01214706}, {13800,0.05389216}, {13900,0.01258824}, {14000,0.01270588}, {14100,0.01271569}, {14200,0.06358824}, {14300,0.01282353}, {14400,0.01282353}, {14500,0.01282353}, {14600,0.01289216}, {14700,0.01304902}, {14800,0.01319608}, {14900,0.01317647}, {15000,0.05154902}, {15100,0.01368627}, {15200,0.01373529}, {15300,0.01376471}, {15400,0.06123529}, {15500,0.01384314}, {15600,0.01387255}, {15700,0.01396078}, {15800,0.01409804}, {15900,0.06901961}, {16000,0.01462745}, {16100,0.01471569}, {16200,0.01482353}, {16300,0.04107843}, {16400,0.04489216}, {16500,0.01468627}, {16600,0.01482353}, {16700,0.01492157}, {16800,0.01502941}, {16900,0.01511765}, {17000,0.01550000}, {17100,0.01561765}, {17200,0.04473529}, {17300,0.01577451}, {17400,0.01579412}, {17500,0.01581373}, {17600,0.01583333}, {17700,0.01588235}, {17800,0.08182353}, {17900,0.01606863}, {18000,0.01628431}, {18100,0.07051961}, {18200,0.01669608}, {18300,0.03399020}, {18400,0.01680392}, {18500,0.01682353}, {18600,0.01682353}, {18700,0.01688235}, {18800,0.01692157}, {18900,0.01696078}, {19000,0.01720588}, {19100,0.03908824}, {19200,0.01760784}, {19300,0.08304902}, {19400,0.01777451}, {19500,0.03378431}, {19600,0.01783333}, {19700,0.01783333}, {19800,0.01786275}, {19900,0.01793137}, {20000,0.01801961}};
data["big"]["Ltac2LowLevel"]["eval lazy"]["user"] = {{1,0.00000000}, {2,0.00003922}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00006863}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00003922}, {12,0.00006863}, {13,0.00000000}, {14,0.00003922}, {15,0.00000000}, {16,0.00002941}, {17,0.00002941}, {18,0.00000000}, {19,0.00000000}, {20,0.00002941}, {21,0.00000000}, {22,0.00003922}, {23,0.00002941}, {24,0.00003922}, {25,0.00003922}, {26,0.00000000}, {27,0.00003922}, {28,0.00003922}, {29,0.00000000}, {30,0.00003922}, {31,0.00000000}, {32,0.00002941}, {33,0.00002941}, {34,0.00003922}, {35,0.00005882}, {36,0.00002941}, {37,0.00002941}, {38,0.00005882}, {39,0.00006863}, {40,0.00010784}, {41,0.00003922}, {42,0.00003922}, {43,0.00002941}, {44,0.00007843}, {45,0.00012745}, {46,0.00000000}, {47,0.00003922}, {48,0.00002941}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00003922}, {53,0.00005882}, {54,0.00010784}, {55,0.00000000}, {56,0.00006863}, {57,0.00003922}, {58,0.00002941}, {59,0.00003922}, {60,0.00000000}, {61,0.00002941}, {62,0.00010784}, {63,0.00007843}, {64,0.00000000}, {65,0.00007843}, {66,0.00022549}, {67,0.00010784}, {68,0.00017647}, {69,0.00006863}, {70,0.00006863}, {71,0.00002941}, {72,0.00007843}, {73,0.00017647}, {74,0.00005882}, {75,0.00003922}, {76,0.00002941}, {77,0.00006863}, {78,0.00013725}, {79,0.00003922}, {80,0.00010784}, {81,0.00003922}, {82,0.00014706}, {83,0.00003922}, {84,0.00009804}, {85,0.00013725}, {86,0.00007843}, {87,0.00000000}, {88,0.00007843}, {89,0.00006863}, {90,0.00007843}, {91,0.00000000}, {92,0.00013725}, {93,0.00006863}, {94,0.00006863}, {95,0.00000000}, {96,0.00012745}, {97,0.00002941}, {98,0.00011765}, {99,0.00007843}, {100,0.00021569}, {101,0.00011765}, {102,0.00007843}, {103,0.00007843}, {104,0.00006863}, {105,0.00013725}, {106,0.00019608}, {107,0.00011765}, {108,0.00027451}, {109,0.00017647}, {110,0.00010784}, {111,0.00011765}, {112,0.00006863}, {113,0.00013725}, {114,0.00009804}, {115,0.00019608}, {116,0.00017647}, {117,0.00007843}, {118,0.00014706}, {119,0.00012745}, {120,0.00011765}, {121,0.00015686}, {122,0.00011765}, {123,0.00018627}, {124,0.00029412}, {125,0.00009804}, {126,0.00017647}, {127,0.00007843}, {128,0.00015686}, {129,0.00003922}, {130,0.00015686}, {131,0.00007843}, {132,0.00006863}, {133,0.00009804}, {134,0.00003922}, {135,0.00018627}, {136,0.00014706}, {137,0.00002941}, {138,0.00019608}, {139,0.00010784}, {140,0.00010784}, {141,0.00011765}, {142,0.00003922}, {143,0.00128431}, {144,0.00018627}, {145,0.00031373}, {146,0.00010784}, {147,0.00014706}, {148,0.00005882}, {149,0.00010784}, {150,0.00019608}, {151,0.00010784}, {152,0.00017647}, {153,0.00018627}, {154,0.00010784}, {155,0.00008824}, {156,0.00021569}, {157,0.00019608}, {158,0.00007843}, {159,0.00017647}, {160,0.00009804}, {161,0.00014706}, {162,0.00018627}, {163,0.00008824}, {164,0.00007843}, {165,0.00006863}, {166,0.00007843}, {167,0.00003922}, {168,0.00003922}, {169,0.00014706}, {170,0.00007843}, {171,0.00099020}, {172,0.00006863}, {173,0.00020588}, {174,0.00013725}, {175,0.00017647}, {176,0.00017647}, {177,0.00014706}, {178,0.00011765}, {179,0.00015686}, {180,0.00014706}, {181,0.00013725}, {182,0.00013725}, {183,0.00011765}, {184,0.00014706}, {185,0.00014706}, {186,0.00019608}, {187,0.00018627}, {188,0.00020588}, {189,0.00018627}, {190,0.00021569}, {191,0.00028431}, {192,0.00014706}, {193,0.00019608}, {194,0.00017647}, {195,0.00023529}, {196,0.00014706}, {197,0.00025490}, {198,0.00019608}, {199,0.00010784}, {200,0.00016667}, {201,0.00014706}, {202,0.00026471}, {203,0.00030392}, {204,0.00012745}, {205,0.00040196}, {206,0.00013725}, {207,0.00011765}, {208,0.00025490}, {209,0.00016667}, {210,0.00022549}, {211,0.00010784}, {212,0.00017647}, {213,0.00029412}, {214,0.00014706}, {215,0.00009804}, {216,0.00013725}, {217,0.00012745}, {218,0.00014706}, {219,0.00018627}, {220,0.00014706}, {221,0.00025490}, {222,0.00006863}, {223,0.00013725}, {224,0.00041176}, {225,0.00033333}, {226,0.00015686}, {227,0.00015686}, {228,0.00006863}, {229,0.00005882}, {230,0.00026471}, {231,0.00017647}, {232,0.00018627}, {233,0.00022549}, {234,0.00013725}, {235,0.00013725}, {236,0.00019608}, {237,0.00003922}, {238,0.00007843}, {239,0.00022549}, {240,0.00031373}, {241,0.00026471}, {242,0.00029412}, {243,0.00018627}, {244,0.00016667}, {245,0.00024510}, {246,0.00021569}, {247,0.00011765}, {248,0.00028431}, {249,0.00014706}, {250,0.00019608}, {251,0.00007843}, {252,0.00015686}, {253,0.00024510}, {254,0.00017647}, {255,0.00019608}, {256,0.00026471}, {257,0.00014706}, {258,0.00016667}, {259,0.00015686}, {260,0.00018627}, {261,0.00018627}, {262,0.00020588}, {263,0.00014706}, {264,0.00033333}, {265,0.00029412}, {266,0.00025490}, {267,0.00021569}, {268,0.00034314}, {269,0.00009804}, {270,0.00016667}, {271,0.00029412}, {272,0.00034314}, {273,0.00019608}, {274,0.00021569}, {275,0.00035294}, {276,0.00013725}, {277,0.00006863}, {278,0.00033333}, {279,0.00011765}, {280,0.00002941}, {281,0.00043137}, {282,0.00017647}, {283,0.00006863}, {284,0.00021569}, {285,0.00022549}, {286,0.00010784}, {287,0.00006863}, {288,0.00027451}, {289,0.00017647}, {290,0.00028431}, {291,0.00017647}, {292,0.00020588}, {293,0.00014706}, {294,0.00026471}, {295,0.00031373}, {296,0.00022549}, {297,0.00016667}, {298,0.00037255}, {299,0.00038235}, {300,0.00019608}, {301,0.00028431}, {302,0.00017647}, {303,0.00029412}, {304,0.00015686}, {305,0.00026471}, {306,0.00021569}, {307,0.00023529}, {308,0.00015686}, {309,0.00040196}, {310,0.00018627}, {311,0.00017647}, {312,0.00013725}, {313,0.00033333}, {314,0.00018627}, {315,0.00020588}, {316,0.00032353}, {317,0.00022549}, {318,0.00024510}, {319,0.00037255}, {320,0.00038235}, {321,0.00021569}, {322,0.00025490}, {323,0.00023529}, {324,0.00021569}, {325,0.00026471}, {326,0.00022549}, {327,0.00033333}, {328,0.00033333}, {329,0.00016667}, {330,0.00021569}, {331,0.00027451}, {332,0.00016667}, {333,0.00031373}, {334,0.00014706}, {335,0.00029412}, {336,0.00029412}, {337,0.00029412}, {338,0.00025490}, {339,0.00019608}, {340,0.00027451}, {341,0.00019608}, {342,0.00023529}, {343,0.00017647}, {344,0.00020588}, {345,0.00015686}, {346,0.00019608}, {347,0.00036275}, {348,0.00031373}, {349,0.00032353}, {350,0.00032353}, {351,0.00033333}, {352,0.00017647}, {353,0.00024510}, {354,0.00014706}, {355,0.00042157}, {356,0.00033333}, {357,0.00036275}, {358,0.00025490}, {359,0.00017647}, {360,0.00025490}, {361,0.00015686}, {362,0.00042157}, {363,0.00022549}, {364,0.00031373}, {365,0.00053922}, {366,0.00032353}, {367,0.00018627}, {368,0.00044118}, {369,0.00032353}, {370,0.00014706}, {371,0.00038235}, {372,0.00029412}, {373,0.00030392}, {374,0.00019608}, {375,0.00038235}, {376,0.00018627}, {377,0.00052941}, {378,0.00022549}, {379,0.00014706}, {380,0.00031373}, {381,0.00014706}, {382,0.00035294}, {383,0.00035294}, {384,0.00040196}, {385,0.00028431}, {386,0.00026471}, {387,0.00016667}, {388,0.00033333}, {389,0.00025490}, {390,0.00019608}, {391,0.00034314}, {392,0.00033333}, {393,0.00026471}, {394,0.00026471}, {395,0.00021569}, {396,0.00046078}, {397,0.00035294}, {398,0.00031373}, {399,0.00033333}, {400,0.00029412}, {401,0.00034314}, {402,0.00042157}, {403,0.00022549}, {404,0.00041176}, {405,0.00040196}, {406,0.00021569}, {407,0.00036275}, {408,0.00018627}, {409,0.00014706}, {410,0.00042157}, {411,0.00026471}, {412,0.00014706}, {413,0.00029412}, {414,0.00022549}, {415,0.00033333}, {416,0.00032353}, {417,0.00024510}, {418,0.00039216}, {419,0.00026471}, {420,0.00041176}, {421,0.00024510}, {422,0.00026471}, {423,0.00029412}, {424,0.00025490}, {425,0.00045098}, {426,0.00025490}, {427,0.00032353}, {428,0.00045098}, {429,0.00044118}, {430,0.00034314}, {431,0.00048039}, {432,0.00028431}, {433,0.00022549}, {434,0.00030392}, {435,0.00029412}, {436,0.00210784}, {437,0.00029412}, {438,0.00026471}, {439,0.00036275}, {440,0.00042157}, {441,0.00041176}, {442,0.00030392}, {443,0.00042157}, {444,0.00056863}, {445,0.00038235}, {446,0.00037255}, {447,0.00031373}, {448,0.00039216}, {449,0.00048039}, {450,0.00023529}, {451,0.00030392}, {452,0.00030392}, {453,0.00034314}, {454,0.00028431}, {455,0.00027451}, {456,0.00025490}, {457,0.00043137}, {458,0.00045098}, {459,0.00056863}, {460,0.00027451}, {461,0.00033333}, {462,0.00019608}, {463,0.00025490}, {464,0.00221569}, {465,0.00053922}, {466,0.00028431}, {467,0.00048039}, {468,0.00047059}, {469,0.00028431}, {470,0.00036275}, {471,0.00045098}, {472,0.00047059}, {473,0.00029412}, {474,0.00037255}, {475,0.00033333}, {476,0.00039216}, {477,0.00028431}, {478,0.00034314}, {479,0.00046078}, {480,0.00038235}, {481,0.00050000}, {482,0.00028431}, {483,0.00044118}, {484,0.00039216}, {485,0.00031373}, {486,0.00035294}, {487,0.00021569}, {488,0.00036275}, {489,0.00069608}, {490,0.00042157}, {491,0.00030392}, {492,0.00042157}, {493,0.00061765}, {494,0.00028431}, {495,0.00031373}, {496,0.00041176}, {497,0.00033333}, {498,0.00066667}, {499,0.00067647}, {500,0.00042157}, {505,0.00045098}, {510,0.00032353}, {515,0.00049020}, {520,0.00047059}, {525,0.00053922}, {530,0.00025490}, {535,0.00028431}, {540,0.00037255}, {545,0.00024510}, {550,0.00044118}, {555,0.00028431}, {560,0.00037255}, {565,0.00050000}, {570,0.00065686}, {575,0.00021569}, {580,0.00057843}, {585,0.00033333}, {590,0.00043137}, {595,0.00064706}, {600,0.00041176}, {605,0.00046078}, {610,0.00056863}, {615,0.00044118}, {620,0.00053922}, {625,0.00038235}, {630,0.00077451}, {635,0.00045098}, {640,0.00071569}, {645,0.00051961}, {650,0.00055882}, {655,0.00041176}, {660,0.00076471}, {665,0.00092157}, {670,0.00050980}, {675,0.00054902}, {680,0.00057843}, {685,0.00047059}, {690,0.00061765}, {695,0.00074510}, {700,0.00036275}, {705,0.00034314}, {710,0.00068627}, {715,0.00050980}, {720,0.00060784}, {725,0.00050000}, {730,0.00045098}, {735,0.00038235}, {740,0.00064706}, {745,0.00045098}, {750,0.00045098}, {755,0.00056863}, {760,0.00078431}, {765,0.00056863}, {770,0.00071569}, {775,0.00054902}, {780,0.00053922}, {785,0.00057843}, {790,0.00058824}, {795,0.00045098}, {800,0.00066667}, {805,0.00081373}, {810,0.00062745}, {815,0.00093137}, {820,0.00070588}, {825,0.00052941}, {830,0.00075490}, {835,0.00080392}, {840,0.00082353}, {845,0.00044118}, {850,0.00054902}, {855,0.00071569}, {860,0.00050980}, {865,0.00069608}, {870,0.00071569}, {875,0.00096078}, {880,0.00066667}, {885,0.00090196}, {890,0.00066667}, {895,0.00058824}, {900,0.00053922}, {905,0.00074510}, {910,0.00064706}, {915,0.00082353}, {920,0.00090196}, {925,0.00057843}, {930,0.00050980}, {935,0.00082353}, {940,0.00081373}, {945,0.00074510}, {950,0.00073529}, {955,0.00097059}, {960,0.00088235}, {965,0.00090196}, {970,0.00059804}, {975,0.00073529}, {980,0.00108824}, {985,0.00070588}, {990,0.00106863}, {995,0.00072549}, {1000,0.00058824}, {1010,0.00087255}, {1020,0.00091176}, {1030,0.00052941}, {1040,0.00114706}, {1050,0.00093137}, {1060,0.00058824}, {1070,0.00081373}, {1080,0.00055882}, {1090,0.00070588}, {1100,0.00107843}, {1110,0.00072549}, {1120,0.00084314}, {1130,0.00070588}, {1140,0.00083333}, {1150,0.00072549}, {1160,0.00103922}, {1170,0.00087255}, {1180,0.00107843}, {1190,0.00117647}, {1200,0.00064706}, {1210,0.00101961}, {1220,0.00113725}, {1230,0.00132353}, {1240,0.00112745}, {1250,0.00090196}, {1260,0.00105882}, {1270,0.00094118}, {1280,0.00087255}, {1290,0.00137255}, {1300,0.00098039}, {1310,0.00068627}, {1320,0.00101961}, {1330,0.00101961}, {1340,0.00097059}, {1350,0.00082353}, {1360,0.00123529}, {1370,0.00362745}, {1380,0.00118627}, {1390,0.00106863}, {1400,0.00106863}, {1410,0.00112745}, {1420,0.00111765}, {1430,0.00104902}, {1440,0.00100000}, {1450,0.00122549}, {1460,0.00118627}, {1470,0.00122549}, {1480,0.00138235}, {1490,0.00100980}, {1500,0.00107843}, {1510,0.00116667}, {1520,0.00114706}, {1530,0.00496078}, {1540,0.00108824}, {1550,0.00115686}, {1560,0.00104902}, {1570,0.00104902}, {1580,0.00113725}, {1590,0.00119608}, {1600,0.00092157}, {1610,0.00143137}, {1620,0.00091176}, {1630,0.00128431}, {1640,0.00340196}, {1650,0.00139216}, {1660,0.00148039}, {1670,0.00151961}, {1680,0.00121569}, {1690,0.00144118}, {1700,0.00113725}, {1710,0.00094118}, {1720,0.00146078}, {1730,0.00124510}, {1740,0.00132353}, {1750,0.00136275}, {1760,0.00134314}, {1770,0.00126471}, {1780,0.00142157}, {1790,0.00156863}, {1800,0.00139216}, {1810,0.00153922}, {1820,0.00160784}, {1830,0.00107843}, {1840,0.00153922}, {1850,0.00157843}, {1860,0.00142157}, {1870,0.00108824}, {1880,0.00163725}, {1890,0.00137255}, {1900,0.00135294}, {1910,0.00125490}, {1920,0.00125490}, {1930,0.00145098}, {1940,0.00128431}, {1950,0.00146078}, {1960,0.00143137}, {1970,0.00148039}, {1980,0.00162745}, {1990,0.00172549}, {2000,0.00136275}, {2050,0.00171569}, {2100,0.00144118}, {2150,0.00195098}, {2200,0.00151961}, {2250,0.00181373}, {2300,0.00173529}, {2350,0.00140196}, {2400,0.00177451}, {2450,0.00171569}, {2500,0.00200000}, {2550,0.00199020}, {2600,0.00184314}, {2650,0.00200980}, {2700,0.00196078}, {2750,0.00192157}, {2800,0.00220588}, {2850,0.00204902}, {2900,0.00250000}, {2950,0.00252941}, {3000,0.00213725}, {3050,0.00267647}, {3100,0.00234314}, {3150,0.00245098}, {3200,0.00227451}, {3250,0.00286275}, {3300,0.00252941}, {3350,0.00246078}, {3400,0.00317647}, {3450,0.00280392}, {3500,0.00276471}, {3550,0.00268627}, {3600,0.00296078}, {3650,0.00300980}, {3700,0.00284314}, {3750,0.00308824}, {3800,0.00304902}, {3850,0.00318627}, {3900,0.00334314}, {3950,0.00311765}, {4000,0.00331373}, {4050,0.00339216}, {4100,0.00327451}, {4150,0.00343137}, {4200,0.00330392}, {4250,0.00350980}, {4300,0.00360784}, {4350,0.00347059}, {4400,0.00343137}, {4450,0.00356863}, {4500,0.00368627}, {4550,0.00360784}, {4600,0.00382353}, {4650,0.00382353}, {4700,0.00382353}, {4750,0.00400980}, {4800,0.00394118}, {4850,0.00408824}, {4900,0.00401961}, {4950,0.00401961}, {5000,0.00419608}, {5050,0.00403922}, {5100,0.00400000}, {5150,0.00407843}, {5200,0.00421569}, {5250,0.00435294}, {5300,0.00412745}, {5350,0.00450000}, {5400,0.00432353}, {5450,0.00446078}, {5500,0.00441176}, {5550,0.00503922}, {5600,0.00458824}, {5650,0.00456863}, {5700,0.00485294}, {5750,0.00492157}, {5800,0.00477451}, {5850,0.00496078}, {5900,0.00494118}, {5950,0.00461765}, {6000,0.00495098}, {6050,0.00482353}, {6100,0.00541176}, {6150,0.00512745}, {6200,0.00523529}, {6250,0.00492157}, {6300,0.00542157}, {6350,0.00581373}, {6400,0.00540196}, {6450,0.00538235}, {6500,0.02057843}, {6550,0.00556863}, {6600,0.00583333}, {6650,0.00583333}, {6700,0.00553922}, {6750,0.00563725}, {6800,0.00551961}, {6850,0.01160784}, {6900,0.00576471}, {6950,0.00568627}, {7000,0.00593137}, {7050,0.00570588}, {7100,0.00582353}, {7150,0.01419608}, {7200,0.00609804}, {7250,0.00621569}, {7300,0.00610784}, {7350,0.00595098}, {7400,0.00616667}, {7450,0.00647059}, {7500,0.04294118}, {7550,0.00638235}, {7600,0.00628431}, {7650,0.00648039}, {7700,0.02700000}, {7750,0.00634314}, {7800,0.00632353}, {7850,0.03050980}, {7900,0.00648039}, {7950,0.00666667}, {8000,0.00677451}, {8050,0.00679412}, {8100,0.00666667}, {8150,0.00680392}, {8200,0.00710784}, {8250,0.00703922}, {8300,0.00700000}, {8350,0.00706863}, {8400,0.00700980}, {8450,0.00718627}, {8500,0.03105882}, {8550,0.00707843}, {8600,0.00723529}, {8650,0.02578431}, {8700,0.00748039}, {8750,0.00750000}, {8800,0.00752941}, {8850,0.03388235}, {8900,0.00749020}, {8950,0.00776471}, {9000,0.00762745}, {9050,0.00760784}, {9100,0.00791176}, {9150,0.00772549}, {9200,0.01561765}, {9250,0.04804902}, {9300,0.00782353}, {9350,0.00821569}, {9400,0.00806863}, {9450,0.03949020}, {9500,0.00827451}, {9550,0.00863725}, {9600,0.00828431}, {9650,0.00821569}, {9700,0.04401961}, {9750,0.00820588}, {9800,0.00860784}, {9850,0.02151961}, {9900,0.00837255}, {9950,0.03638235}, {10000,0.00891176}, {10100,0.00897059}, {10200,0.00882353}, {10300,0.00943137}, {10400,0.00922549}, {10500,0.00889216}, {10600,0.00973529}, {10700,0.00950000}, {10800,0.00937255}, {10900,0.00950000}, {11000,0.00971569}, {11100,0.03528431}, {11200,0.01023529}, {11300,0.01015686}, {11400,0.05442157}, {11500,0.01016667}, {11600,0.01042157}, {11700,0.01017647}, {11800,0.01089216}, {11900,0.01079412}, {12000,0.01837255}, {12100,0.01105882}, {12200,0.01098039}, {12300,0.01089216}, {12400,0.01130392}, {12500,0.01138235}, {12600,0.01173529}, {12700,0.01183333}, {12800,0.02728431}, {12900,0.02526471}, {13000,0.01185294}, {13100,0.01203922}, {13200,0.01202941}, {13300,0.05619608}, {13400,0.01234314}, {13500,0.01230392}, {13600,0.01239216}, {13700,0.01248039}, {13800,0.05388235}, {13900,0.01284314}, {14000,0.01312745}, {14100,0.01300980}, {14200,0.06321569}, {14300,0.01273529}, {14400,0.01291176}, {14500,0.01338235}, {14600,0.01350000}, {14700,0.01317647}, {14800,0.01336275}, {14900,0.01349020}, {15000,0.05161765}, {15100,0.01404902}, {15200,0.01385294}, {15300,0.01385294}, {15400,0.06136275}, {15500,0.01400980}, {15600,0.01450000}, {15700,0.01423529}, {15800,0.01440196}, {15900,0.06923529}, {16000,0.01423529}, {16100,0.01461765}, {16200,0.01498039}, {16300,0.04071569}, {16400,0.04517647}, {16500,0.01453922}, {16600,0.01513725}, {16700,0.01531373}, {16800,0.01512745}, {16900,0.01540196}, {17000,0.01531373}, {17100,0.01541176}, {17200,0.04480392}, {17300,0.01536275}, {17400,0.01571569}, {17500,0.01571569}, {17600,0.01570588}, {17700,0.01579412}, {17800,0.08181373}, {17900,0.01604902}, {18000,0.01619608}, {18100,0.07050980}, {18200,0.01621569}, {18300,0.03393137}, {18400,0.01626471}, {18500,0.01639216}, {18600,0.01675490}, {18700,0.01679412}, {18800,0.01655882}, {18900,0.01683333}, {19000,0.01703922}, {19100,0.03891176}, {19200,0.01702941}, {19300,0.08278431}, {19400,0.01714706}, {19500,0.03377451}, {19600,0.01708824}, {19700,0.01778431}, {19800,0.01746078}, {19900,0.01792157}, {20000,0.01779412}};
data["big"]["Ltac2LowLevel"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00003922}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00003922}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003922}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00003922}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00003922}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00007843}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00003922}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00003922}, {462,0.00000000}, {463,0.00000000}, {464,0.00003922}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00003922}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00003922}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00003922}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00003922}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00003922}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00003922}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00003922}, {1170,0.00003922}, {1180,0.00003922}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00003922}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00003922}, {1320,0.00000000}, {1330,0.00003922}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00002941}, {1380,0.00003922}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00007843}, {1540,0.00003922}, {1550,0.00000000}, {1560,0.00003922}, {1570,0.00003922}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00003922}, {1640,0.00014706}, {1650,0.00007843}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00003922}, {1710,0.00000000}, {1720,0.00003922}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00003922}, {1780,0.00000000}, {1790,0.00003922}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00003922}, {1870,0.00000000}, {1880,0.00003922}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00003922}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00003922}, {1950,0.00000000}, {1960,0.00003922}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00003922}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00003922}, {2550,0.00003922}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00003922}, {2750,0.00000000}, {2800,0.00003922}, {2850,0.00003922}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00007843}, {3050,0.00000000}, {3100,0.00003922}, {3150,0.00003922}, {3200,0.00003922}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00003922}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00003922}, {3600,0.00007843}, {3650,0.00003922}, {3700,0.00003922}, {3750,0.00000000}, {3800,0.00007843}, {3850,0.00000000}, {3900,0.00003922}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00002941}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00003922}, {4500,0.00003922}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00003922}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00007843}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00003922}, {5550,0.00000000}, {5600,0.00003922}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00003922}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00003922}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00003922}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00003922}, {6450,0.00003922}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00003922}, {6850,0.00003922}, {6900,0.00003922}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00011765}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00003922}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00003922}, {7650,0.00003922}, {7700,0.00003922}, {7750,0.00000000}, {7800,0.00003922}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00003922}, {8200,0.00002941}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00003922}, {8500,0.00065686}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00034314}, {8700,0.00000000}, {8750,0.00007843}, {8800,0.00006863}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00003922}, {9200,0.00007843}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00003922}, {9550,0.00003922}, {9600,0.00000000}, {9650,0.00003922}, {9700,0.00003922}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00003922}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00007843}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00011765}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00003922}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00003922}, {12600,0.00003922}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00003922}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00003922}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00003922}, {14500,0.00000000}, {14600,0.00003922}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00003922}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00003922}, {15300,0.00006863}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00003922}, {15800,0.00006863}, {15900,0.00003922}, {16000,0.00003922}, {16100,0.00003922}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00003922}, {16600,0.00000000}, {16700,0.00003922}, {16800,0.00003922}, {16900,0.00000000}, {17000,0.00011765}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00003922}, {17400,0.00003922}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00007843}, {17800,0.00006863}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00003922}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00007843}, {18800,0.00000000}, {18900,0.00003922}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00003922}, {19300,0.00000000}, {19400,0.00003922}, {19500,0.00000000}, {19600,0.00007843}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00006863}, {20000,0.00000000}};
data["big"]["Ltac2LowLevel"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00001961}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00001961}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00001961}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00170588}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00001961}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000980}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00058824}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00002941}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00449020}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00002941}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000980}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00356863}, {1570,0.00001961}, {1580,0.00000000}, {1590,0.00001961}, {1600,0.00000000}, {1610,0.00003922}, {1620,0.00005882}, {1630,0.00005882}, {1640,0.00005882}, {1650,0.00014706}, {1660,0.00012745}, {1670,0.00017647}, {1680,0.00024510}, {1690,0.00032353}, {1700,0.00031373}, {1710,0.00032353}, {1720,0.00034314}, {1730,0.00035294}, {1740,0.00035294}, {1750,0.00035294}, {1760,0.00036275}, {1770,0.00036275}, {1780,0.00035294}, {1790,0.00037255}, {1800,0.00036275}, {1810,0.00037255}, {1820,0.00037255}, {1830,0.00037255}, {1840,0.00036275}, {1850,0.00037255}, {1860,0.00037255}, {1870,0.00040196}, {1880,0.00100000}, {1890,0.00041176}, {1900,0.00042157}, {1910,0.00044118}, {1920,0.00042157}, {1930,0.00047059}, {1940,0.00049020}, {1950,0.00054902}, {1960,0.00056863}, {1970,0.00060784}, {1980,0.00075490}, {1990,0.00080392}, {2000,0.00090196}, {2050,0.00100000}, {2100,0.00100000}, {2150,0.00100000}, {2200,0.00100000}, {2250,0.00100000}, {2300,0.00100000}, {2350,0.00100000}, {2400,0.00100000}, {2450,0.00100000}, {2500,0.00100000}, {2550,0.00783333}, {2600,0.00100000}, {2650,0.00100000}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00100000}, {3150,0.00100980}, {3200,0.00101961}, {3250,0.00778431}, {3300,0.00106863}, {3350,0.00110784}, {3400,0.00120588}, {3450,0.00133333}, {3500,0.00195098}, {3550,0.00200000}, {3600,0.00144118}, {3650,0.00140196}, {3700,0.00139216}, {3750,0.00141176}, {3800,0.00146078}, {3850,0.00147059}, {3900,0.01315686}, {3950,0.00164706}, {4000,0.00180392}, {4050,0.00198039}, {4100,0.00200000}, {4150,0.00200000}, {4200,0.00200000}, {4250,0.00200000}, {4300,0.00200000}, {4350,0.00200000}, {4400,0.00200000}, {4450,0.00200980}, {4500,0.00200980}, {4550,0.00200980}, {4600,0.00201961}, {4650,0.00204902}, {4700,0.00202941}, {4750,0.00209804}, {4800,0.00215686}, {4850,0.00206863}, {4900,0.00218627}, {4950,0.00215686}, {5000,0.00217647}, {5050,0.00219608}, {5100,0.00222549}, {5150,0.00229412}, {5200,0.00233333}, {5250,0.00230392}, {5300,0.00231373}, {5350,0.00233333}, {5400,0.00299020}, {5450,0.00235294}, {5500,0.00300980}, {5550,0.00241176}, {5600,0.00240196}, {5650,0.00301961}, {5700,0.00304902}, {5750,0.00262745}, {5800,0.00304902}, {5850,0.00354902}, {5900,0.00331373}, {5950,0.00306863}, {6000,0.00295098}, {6050,0.00299020}, {6100,0.00301961}, {6150,0.00334314}, {6200,0.00304902}, {6250,0.00305882}, {6300,0.00306863}, {6350,0.00407843}, {6400,0.01863725}, {6450,0.00315686}, {6500,0.00314706}, {6550,0.00317647}, {6600,0.00318627}, {6650,0.02876471}, {6700,0.00327451}, {6750,0.00331373}, {6800,0.00334314}, {6850,0.00335294}, {6900,0.02141176}, {6950,0.00333333}, {7000,0.00335294}, {7050,0.00337255}, {7100,0.02183333}, {7150,0.00465686}, {7200,0.00406863}, {7250,0.00344118}, {7300,0.00341176}, {7350,0.00350000}, {7400,0.00350980}, {7450,0.00357843}, {7500,0.00380392}, {7550,0.00435294}, {7600,0.03147059}, {7650,0.00482353}, {7700,0.00385294}, {7750,0.00409804}, {7800,0.00400000}, {7850,0.00407843}, {7900,0.00420588}, {7950,0.00408824}, {8000,0.00408824}, {8050,0.00408824}, {8100,0.00416667}, {8150,0.00419608}, {8200,0.00416667}, {8250,0.00419608}, {8300,0.00424510}, {8350,0.00429412}, {8400,0.00429412}, {8450,0.00430392}, {8500,0.00573529}, {8550,0.00431373}, {8600,0.00431373}, {8650,0.00431373}, {8700,0.00431373}, {8750,0.02915686}, {8800,0.00433333}, {8850,0.00436275}, {8900,0.00438235}, {8950,0.00441176}, {9000,0.03178431}, {9050,0.00444118}, {9100,0.00583333}, {9150,0.00449020}, {9200,0.00459804}, {9250,0.00485294}, {9300,0.03583333}, {9350,0.03884314}, {9400,0.03201961}, {9450,0.00492157}, {9500,0.00494118}, {9550,0.00504902}, {9600,0.00511765}, {9650,0.00516667}, {9700,0.00603922}, {9750,0.00603922}, {9800,0.00524510}, {9850,0.00670588}, {9900,0.00604902}, {9950,0.00536275}, {10000,0.00536275}, {10100,0.00700980}, {10200,0.00536275}, {10300,0.00536275}, {10400,0.00604902}, {10500,0.00672549}, {10600,0.00724510}, {10700,0.00660784}, {10800,0.04511765}, {10900,0.00551961}, {11000,0.00567647}, {11100,0.00638235}, {11200,0.00596078}, {11300,0.00631373}, {11400,0.00649020}, {11500,0.00630392}, {11600,0.00633333}, {11700,0.00635294}, {11800,0.00634314}, {11900,0.04775490}, {12000,0.00635294}, {12100,0.00638235}, {12200,0.00713725}, {12300,0.00648039}, {12400,0.03604902}, {12500,0.00651961}, {12600,0.00653922}, {12700,0.00740196}, {12800,0.00851961}, {12900,0.00931373}, {13000,0.00927451}, {13100,0.00841176}, {13200,0.00729412}, {13300,0.00728431}, {13400,0.00731373}, {13500,0.03531373}, {13600,0.00731373}, {13700,0.00733333}, {13800,0.00813725}, {13900,0.04278431}, {14000,0.00820588}, {14100,0.06069608}, {14200,0.00785294}, {14300,0.00977451}, {14400,0.00835294}, {14500,0.00786275}, {14600,0.00801961}, {14700,0.00801961}, {14800,0.01051961}, {14900,0.00823529}, {15000,0.00865686}, {15100,0.06352941}, {15200,0.01042157}, {15300,0.05916667}, {15400,0.01032353}, {15500,0.00928431}, {15600,0.00841176}, {15700,0.03856863}, {15800,0.00976471}, {15900,0.00852941}, {16000,0.01232353}, {16100,0.01149020}, {16200,0.00869608}, {16300,0.00880392}, {16400,0.00888235}, {16500,0.00901961}, {16600,0.00917647}, {16700,0.00924510}, {16800,0.05067647}, {16900,0.00931373}, {17000,0.06531373}, {17100,0.01134314}, {17200,0.01015686}, {17300,0.05473529}, {17400,0.01122549}, {17500,0.01055882}, {17600,0.01115686}, {17700,0.01082353}, {17800,0.01065686}, {17900,0.00962745}, {18000,0.01099020}, {18100,0.01139216}, {18200,0.01000000}, {18300,0.01139216}, {18400,0.05932353}, {18500,0.01027451}, {18600,0.01056863}, {18700,0.01189216}, {18800,0.01189216}, {18900,0.01148039}, {19000,0.06518627}, {19100,0.01047059}, {19200,0.01054902}, {19300,0.01147059}, {19400,0.01056863}, {19500,0.01126471}, {19600,0.05115686}, {19700,0.01087255}, {19800,0.01132353}, {19900,0.01087255}, {20000,0.01108824}};
data["big"]["Ltac2LowLevel"]["lazy beta iota"]["user"] = {{1,0.00007843}, {2,0.00000000}, {3,0.00003922}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00007843}, {11,0.00003922}, {12,0.00000000}, {13,0.00003922}, {14,0.00006863}, {15,0.00000000}, {16,0.00003922}, {17,0.00000000}, {18,0.00003922}, {19,0.00002941}, {20,0.00000000}, {21,0.00009804}, {22,0.00005882}, {23,0.00006863}, {24,0.00007843}, {25,0.00003922}, {26,0.00002941}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00007843}, {33,0.00002941}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00010784}, {38,0.00000000}, {39,0.00000000}, {40,0.00003922}, {41,0.00003922}, {42,0.00002941}, {43,0.00006863}, {44,0.00000000}, {45,0.00000000}, {46,0.00003922}, {47,0.00000000}, {48,0.00000000}, {49,0.00003922}, {50,0.00007843}, {51,0.00000000}, {52,0.00000000}, {53,0.00003922}, {54,0.00007843}, {55,0.00009804}, {56,0.00000000}, {57,0.00006863}, {58,0.00000000}, {59,0.00003922}, {60,0.00006863}, {61,0.00003922}, {62,0.00003922}, {63,0.00002941}, {64,0.00011765}, {65,0.00000000}, {66,0.00007843}, {67,0.00000000}, {68,0.00007843}, {69,0.00007843}, {70,0.00014706}, {71,0.00000000}, {72,0.00010784}, {73,0.00007843}, {74,0.00011765}, {75,0.00006863}, {76,0.00003922}, {77,0.00003922}, {78,0.00003922}, {79,0.00009804}, {80,0.00007843}, {81,0.00000000}, {82,0.00000000}, {83,0.00016667}, {84,0.00003922}, {85,0.00005882}, {86,0.00003922}, {87,0.00003922}, {88,0.00009804}, {89,0.00002941}, {90,0.00006863}, {91,0.00002941}, {92,0.00000000}, {93,0.00003922}, {94,0.00015686}, {95,0.00003922}, {96,0.00002941}, {97,0.00009804}, {98,0.00010784}, {99,0.00014706}, {100,0.00014706}, {101,0.00007843}, {102,0.00000000}, {103,0.00010784}, {104,0.00011765}, {105,0.00008824}, {106,0.00000000}, {107,0.00003922}, {108,0.00005882}, {109,0.00012745}, {110,0.00000000}, {111,0.00010784}, {112,0.00003922}, {113,0.00000000}, {114,0.00000000}, {115,0.00002941}, {116,0.00017647}, {117,0.00012745}, {118,0.00014706}, {119,0.00011765}, {120,0.00013725}, {121,0.00014706}, {122,0.00006863}, {123,0.00007843}, {124,0.00009804}, {125,0.00000000}, {126,0.00018627}, {127,0.00011765}, {128,0.00018627}, {129,0.00021569}, {130,0.00012745}, {131,0.00015686}, {132,0.00000000}, {133,0.00013725}, {134,0.00000000}, {135,0.00006863}, {136,0.00005882}, {137,0.00011765}, {138,0.00006863}, {139,0.00006863}, {140,0.00007843}, {141,0.00010784}, {142,0.00010784}, {143,0.00010784}, {144,0.00015686}, {145,0.00010784}, {146,0.00020588}, {147,0.00003922}, {148,0.00017647}, {149,0.00007843}, {150,0.00011765}, {151,0.00009804}, {152,0.00005882}, {153,0.00009804}, {154,0.00015686}, {155,0.00003922}, {156,0.00010784}, {157,0.00003922}, {158,0.00002941}, {159,0.00005882}, {160,0.00022549}, {161,0.00013725}, {162,0.00006863}, {163,0.00012745}, {164,0.00010784}, {165,0.00017647}, {166,0.00027451}, {167,0.00029412}, {168,0.00033333}, {169,0.00011765}, {170,0.00027451}, {171,0.00010784}, {172,0.00003922}, {173,0.00016667}, {174,0.00016667}, {175,0.00017647}, {176,0.00010784}, {177,0.00006863}, {178,0.00003922}, {179,0.00017647}, {180,0.00021569}, {181,0.00013725}, {182,0.00002941}, {183,0.00018627}, {184,0.00009804}, {185,0.00010784}, {186,0.00037255}, {187,0.00007843}, {188,0.00007843}, {189,0.00017647}, {190,0.00003922}, {191,0.00010784}, {192,0.00018627}, {193,0.00003922}, {194,0.00006863}, {195,0.00014706}, {196,0.00010784}, {197,0.00011765}, {198,0.00020588}, {199,0.00013725}, {200,0.00023529}, {201,0.00006863}, {202,0.00009804}, {203,0.00006863}, {204,0.00000000}, {205,0.00009804}, {206,0.00016667}, {207,0.00013725}, {208,0.00013725}, {209,0.00021569}, {210,0.00022549}, {211,0.00020588}, {212,0.00024510}, {213,0.00015686}, {214,0.00003922}, {215,0.00016667}, {216,0.00023529}, {217,0.00014706}, {218,0.00029412}, {219,0.00013725}, {220,0.00016667}, {221,0.00034314}, {222,0.00010784}, {223,0.00014706}, {224,0.00027451}, {225,0.00013725}, {226,0.00006863}, {227,0.00019608}, {228,0.00009804}, {229,0.00020588}, {230,0.00027451}, {231,0.00015686}, {232,0.00014706}, {233,0.00006863}, {234,0.00011765}, {235,0.00013725}, {236,0.00030392}, {237,0.00026471}, {238,0.00022549}, {239,0.00022549}, {240,0.00023529}, {241,0.00025490}, {242,0.00009804}, {243,0.00008824}, {244,0.00027451}, {245,0.00026471}, {246,0.00011765}, {247,0.00015686}, {248,0.00019608}, {249,0.00013725}, {250,0.00014706}, {251,0.00005882}, {252,0.00020588}, {253,0.00013725}, {254,0.00029412}, {255,0.00017647}, {256,0.00006863}, {257,0.00013725}, {258,0.00022549}, {259,0.00017647}, {260,0.00023529}, {261,0.00017647}, {262,0.00018627}, {263,0.00025490}, {264,0.00020588}, {265,0.00041176}, {266,0.00011765}, {267,0.00021569}, {268,0.00022549}, {269,0.00021569}, {270,0.00033333}, {271,0.00021569}, {272,0.00010784}, {273,0.00011765}, {274,0.00032353}, {275,0.00016667}, {276,0.00022549}, {277,0.00025490}, {278,0.00022549}, {279,0.00026471}, {280,0.00007843}, {281,0.00024510}, {282,0.00009804}, {283,0.00013725}, {284,0.00021569}, {285,0.00018627}, {286,0.00015686}, {287,0.00027451}, {288,0.00025490}, {289,0.00010784}, {290,0.00021569}, {291,0.00016667}, {292,0.00029412}, {293,0.00019608}, {294,0.00024510}, {295,0.00021569}, {296,0.00012745}, {297,0.00016667}, {298,0.00025490}, {299,0.00019608}, {300,0.00013725}, {301,0.00016667}, {302,0.00026471}, {303,0.00008824}, {304,0.00006863}, {305,0.00018627}, {306,0.00015686}, {307,0.00011765}, {308,0.00025490}, {309,0.00021569}, {310,0.00025490}, {311,0.00010784}, {312,0.00023529}, {313,0.00025490}, {314,0.00022549}, {315,0.00007843}, {316,0.00015686}, {317,0.00014706}, {318,0.00021569}, {319,0.00029412}, {320,0.00029412}, {321,0.00023529}, {322,0.00003922}, {323,0.00024510}, {324,0.00029412}, {325,0.00024510}, {326,0.00029412}, {327,0.00016667}, {328,0.00029412}, {329,0.00027451}, {330,0.00033333}, {331,0.00020588}, {332,0.00026471}, {333,0.00027451}, {334,0.00038235}, {335,0.00030392}, {336,0.00014706}, {337,0.00037255}, {338,0.00035294}, {339,0.00026471}, {340,0.00033333}, {341,0.00026471}, {342,0.00024510}, {343,0.00022549}, {344,0.00034314}, {345,0.00029412}, {346,0.00006863}, {347,0.00035294}, {348,0.00028431}, {349,0.00009804}, {350,0.00028431}, {351,0.00030392}, {352,0.00013725}, {353,0.00039216}, {354,0.00036275}, {355,0.00042157}, {356,0.00013725}, {357,0.00048039}, {358,0.00027451}, {359,0.00020588}, {360,0.00031373}, {361,0.00033333}, {362,0.00019608}, {363,0.00017647}, {364,0.00006863}, {365,0.00021569}, {366,0.00025490}, {367,0.00022549}, {368,0.00013725}, {369,0.00021569}, {370,0.00053922}, {371,0.00012745}, {372,0.00028431}, {373,0.00051961}, {374,0.00025490}, {375,0.00030392}, {376,0.00031373}, {377,0.00012745}, {378,0.00031373}, {379,0.00037255}, {380,0.00011765}, {381,0.00029412}, {382,0.00042157}, {383,0.00018627}, {384,0.00026471}, {385,0.00025490}, {386,0.00014706}, {387,0.00018627}, {388,0.00033333}, {389,0.00014706}, {390,0.00046078}, {391,0.00023529}, {392,0.00025490}, {393,0.00006863}, {394,0.00030392}, {395,0.00023529}, {396,0.00032353}, {397,0.00033333}, {398,0.00031373}, {399,0.00018627}, {400,0.00022549}, {401,0.00031373}, {402,0.00028431}, {403,0.00033333}, {404,0.00027451}, {405,0.00029412}, {406,0.00043137}, {407,0.00028431}, {408,0.00030392}, {409,0.00033333}, {410,0.00026471}, {411,0.00025490}, {412,0.00034314}, {413,0.00030392}, {414,0.00045098}, {415,0.00042157}, {416,0.00036275}, {417,0.00059804}, {418,0.00022549}, {419,0.00034314}, {420,0.00030392}, {421,0.00024510}, {422,0.00029412}, {423,0.00025490}, {424,0.00039216}, {425,0.00038235}, {426,0.00035294}, {427,0.00024510}, {428,0.00036275}, {429,0.00052941}, {430,0.00028431}, {431,0.00017647}, {432,0.00044118}, {433,0.00043137}, {434,0.00015686}, {435,0.00050980}, {436,0.00028431}, {437,0.00031373}, {438,0.00025490}, {439,0.00045098}, {440,0.00037255}, {441,0.00041176}, {442,0.00029412}, {443,0.00044118}, {444,0.00014706}, {445,0.00016667}, {446,0.00045098}, {447,0.00014706}, {448,0.00025490}, {449,0.00023529}, {450,0.00042157}, {451,0.00044118}, {452,0.00009804}, {453,0.00045098}, {454,0.00166667}, {455,0.00040196}, {456,0.00006863}, {457,0.00012745}, {458,0.00019608}, {459,0.00033333}, {460,0.00033333}, {461,0.00026471}, {462,0.00037255}, {463,0.00036275}, {464,0.00018627}, {465,0.00039216}, {466,0.00035294}, {467,0.00025490}, {468,0.00028431}, {469,0.00013725}, {470,0.00056863}, {471,0.00025490}, {472,0.00015686}, {473,0.00050980}, {474,0.00010784}, {475,0.00040196}, {476,0.00037255}, {477,0.00042157}, {478,0.00022549}, {479,0.00014706}, {480,0.00038235}, {481,0.00021569}, {482,0.00046078}, {483,0.00028431}, {484,0.00037255}, {485,0.00019608}, {486,0.00027451}, {487,0.00027451}, {488,0.00034314}, {489,0.00054902}, {490,0.00033333}, {491,0.00026471}, {492,0.00037255}, {493,0.00009804}, {494,0.00025490}, {495,0.00037255}, {496,0.00043137}, {497,0.00037255}, {498,0.00013725}, {499,0.00040196}, {500,0.00031373}, {505,0.00044118}, {510,0.00022549}, {515,0.00044118}, {520,0.00027451}, {525,0.00034314}, {530,0.00032353}, {535,0.00031373}, {540,0.00041176}, {545,0.00031373}, {550,0.00045098}, {555,0.00024510}, {560,0.00050000}, {565,0.00017647}, {570,0.00052941}, {575,0.00038235}, {580,0.00048039}, {585,0.00034314}, {590,0.00049020}, {595,0.00020588}, {600,0.00052941}, {605,0.00024510}, {610,0.00048039}, {615,0.00036275}, {620,0.00051961}, {625,0.00030392}, {630,0.00045098}, {635,0.00028431}, {640,0.00029412}, {645,0.00062745}, {650,0.00038235}, {655,0.00033333}, {660,0.00036275}, {665,0.00045098}, {670,0.00036275}, {675,0.00049020}, {680,0.00052941}, {685,0.00035294}, {690,0.00032353}, {695,0.00039216}, {700,0.00031373}, {705,0.00052941}, {710,0.00050980}, {715,0.00053922}, {720,0.00018627}, {725,0.00034314}, {730,0.00065686}, {735,0.00046078}, {740,0.00045098}, {745,0.00062745}, {750,0.00018627}, {755,0.00056863}, {760,0.00050000}, {765,0.00024510}, {770,0.00038235}, {775,0.00062745}, {780,0.00030392}, {785,0.00059804}, {790,0.00061765}, {795,0.00026471}, {800,0.00031373}, {805,0.00050000}, {810,0.00048039}, {815,0.00048039}, {820,0.00056863}, {825,0.00055882}, {830,0.00044118}, {835,0.00050980}, {840,0.00066667}, {845,0.00050980}, {850,0.00042157}, {855,0.00065686}, {860,0.00073529}, {865,0.00032353}, {870,0.00036275}, {875,0.00040196}, {880,0.00058824}, {885,0.00034314}, {890,0.00053922}, {895,0.00059804}, {900,0.00067647}, {905,0.00044118}, {910,0.00048039}, {915,0.00065686}, {920,0.00063725}, {925,0.00073529}, {930,0.00069608}, {935,0.00042157}, {940,0.00043137}, {945,0.00067647}, {950,0.00075490}, {955,0.00050980}, {960,0.00043137}, {965,0.00039216}, {970,0.00041176}, {975,0.00085294}, {980,0.00059804}, {985,0.00061765}, {990,0.00030392}, {995,0.00047059}, {1000,0.00029412}, {1010,0.00056863}, {1020,0.00066667}, {1030,0.00089216}, {1040,0.00022549}, {1050,0.00089216}, {1060,0.00053922}, {1070,0.00070588}, {1080,0.00046078}, {1090,0.00077451}, {1100,0.00041176}, {1110,0.00069608}, {1120,0.00059804}, {1130,0.00050000}, {1140,0.00068627}, {1150,0.00064706}, {1160,0.00048039}, {1170,0.00045098}, {1180,0.00070588}, {1190,0.00029412}, {1200,0.00044118}, {1210,0.00042157}, {1220,0.00049020}, {1230,0.00074510}, {1240,0.00054902}, {1250,0.00064706}, {1260,0.00050000}, {1270,0.00064706}, {1280,0.00069608}, {1290,0.00050000}, {1300,0.00071569}, {1310,0.00063725}, {1320,0.00057843}, {1330,0.00073529}, {1340,0.00050000}, {1350,0.00070588}, {1360,0.00074510}, {1370,0.00060784}, {1380,0.00067647}, {1390,0.00055882}, {1400,0.00084314}, {1410,0.00061765}, {1420,0.00098039}, {1430,0.00049020}, {1440,0.00068627}, {1450,0.00068627}, {1460,0.00482353}, {1470,0.00086275}, {1480,0.00069608}, {1490,0.00098039}, {1500,0.00084314}, {1510,0.00087255}, {1520,0.00058824}, {1530,0.00063725}, {1540,0.00096078}, {1550,0.00084314}, {1560,0.00350000}, {1570,0.00109804}, {1580,0.00091176}, {1590,0.00081373}, {1600,0.00092157}, {1610,0.00079412}, {1620,0.00072549}, {1630,0.00058824}, {1640,0.00092157}, {1650,0.00074510}, {1660,0.00059804}, {1670,0.00068627}, {1680,0.00081373}, {1690,0.00074510}, {1700,0.00080392}, {1710,0.00084314}, {1720,0.00100000}, {1730,0.00081373}, {1740,0.00102941}, {1750,0.00089216}, {1760,0.00078431}, {1770,0.00082353}, {1780,0.00084314}, {1790,0.00056863}, {1800,0.00100980}, {1810,0.00090196}, {1820,0.00089216}, {1830,0.00120588}, {1840,0.00081373}, {1850,0.00089216}, {1860,0.00106863}, {1870,0.00078431}, {1880,0.00062745}, {1890,0.00097059}, {1900,0.00095098}, {1910,0.00110784}, {1920,0.00110784}, {1930,0.00102941}, {1940,0.00105882}, {1950,0.00124510}, {1960,0.00114706}, {1970,0.00082353}, {1980,0.00096078}, {1990,0.00094118}, {2000,0.00086275}, {2050,0.00097059}, {2100,0.00121569}, {2150,0.00082353}, {2200,0.00117647}, {2250,0.00086275}, {2300,0.00112745}, {2350,0.00144118}, {2400,0.00134314}, {2450,0.00136275}, {2500,0.00145098}, {2550,0.00768627}, {2600,0.00137255}, {2650,0.00142157}, {2700,0.00145098}, {2750,0.00168627}, {2800,0.00141176}, {2850,0.00166667}, {2900,0.00120588}, {2950,0.00127451}, {3000,0.00160784}, {3050,0.00158824}, {3100,0.00163725}, {3150,0.00155882}, {3200,0.00192157}, {3250,0.00735294}, {3300,0.00156863}, {3350,0.00165686}, {3400,0.00170588}, {3450,0.00203922}, {3500,0.00204902}, {3550,0.00218627}, {3600,0.00204902}, {3650,0.00187255}, {3700,0.00169608}, {3750,0.00213725}, {3800,0.00194118}, {3850,0.00182353}, {3900,0.01353922}, {3950,0.00218627}, {4000,0.00199020}, {4050,0.00195098}, {4100,0.00202941}, {4150,0.00217647}, {4200,0.00221569}, {4250,0.00206863}, {4300,0.00206863}, {4350,0.00191176}, {4400,0.00212745}, {4450,0.00220588}, {4500,0.00236275}, {4550,0.00237255}, {4600,0.00212745}, {4650,0.00228431}, {4700,0.00254902}, {4750,0.00245098}, {4800,0.00239216}, {4850,0.00238235}, {4900,0.00234314}, {4950,0.00252941}, {5000,0.00233333}, {5050,0.00245098}, {5100,0.00266667}, {5150,0.00266667}, {5200,0.00265686}, {5250,0.00283333}, {5300,0.00283333}, {5350,0.00275490}, {5400,0.00321569}, {5450,0.00272549}, {5500,0.00328431}, {5550,0.00257843}, {5600,0.00285294}, {5650,0.00319608}, {5700,0.00326471}, {5750,0.00278431}, {5800,0.00330392}, {5850,0.00369608}, {5900,0.00354902}, {5950,0.00332353}, {6000,0.00289216}, {6050,0.00311765}, {6100,0.00300980}, {6150,0.00358824}, {6200,0.00303922}, {6250,0.00302941}, {6300,0.00312745}, {6350,0.00397059}, {6400,0.01847059}, {6450,0.00338235}, {6500,0.00321569}, {6550,0.00314706}, {6600,0.00339216}, {6650,0.02865686}, {6700,0.00349020}, {6750,0.00355882}, {6800,0.00336275}, {6850,0.00336275}, {6900,0.02150980}, {6950,0.00341176}, {7000,0.00364706}, {7050,0.00348039}, {7100,0.02187255}, {7150,0.00487255}, {7200,0.00386275}, {7250,0.00372549}, {7300,0.00361765}, {7350,0.00362745}, {7400,0.00375490}, {7450,0.00381373}, {7500,0.00409804}, {7550,0.00437255}, {7600,0.03135294}, {7650,0.00473529}, {7700,0.00387255}, {7750,0.00425490}, {7800,0.00408824}, {7850,0.00408824}, {7900,0.00407843}, {7950,0.00408824}, {8000,0.00414706}, {8050,0.00411765}, {8100,0.00410784}, {8150,0.00434314}, {8200,0.00403922}, {8250,0.00416667}, {8300,0.00418627}, {8350,0.00426471}, {8400,0.00412745}, {8450,0.00400000}, {8500,0.00571569}, {8550,0.00431373}, {8600,0.00466667}, {8650,0.00450980}, {8700,0.00443137}, {8750,0.02851961}, {8800,0.00442157}, {8850,0.00440196}, {8900,0.00447059}, {8950,0.00448039}, {9000,0.03171569}, {9050,0.00446078}, {9100,0.00576471}, {9150,0.00506863}, {9200,0.00467647}, {9250,0.00500000}, {9300,0.03613725}, {9350,0.03890196}, {9400,0.03191176}, {9450,0.00479412}, {9500,0.00504902}, {9550,0.00464706}, {9600,0.00496078}, {9650,0.00506863}, {9700,0.00601961}, {9750,0.00602941}, {9800,0.00514706}, {9850,0.00662745}, {9900,0.00631373}, {9950,0.00512745}, {10000,0.00494118}, {10100,0.00660784}, {10200,0.00535294}, {10300,0.00498039}, {10400,0.00580392}, {10500,0.00682353}, {10600,0.00675490}, {10700,0.00647059}, {10800,0.04519608}, {10900,0.00588235}, {11000,0.00582353}, {11100,0.00617647}, {11200,0.00596078}, {11300,0.00599020}, {11400,0.00613725}, {11500,0.00622549}, {11600,0.00610784}, {11700,0.00641176}, {11800,0.00636275}, {11900,0.04814706}, {12000,0.00643137}, {12100,0.00609804}, {12200,0.00678431}, {12300,0.00663725}, {12400,0.03643137}, {12500,0.00667647}, {12600,0.00663725}, {12700,0.00712745}, {12800,0.00851961}, {12900,0.00940196}, {13000,0.00940196}, {13100,0.00815686}, {13200,0.00704902}, {13300,0.00690196}, {13400,0.00723529}, {13500,0.03570588}, {13600,0.00752941}, {13700,0.00716667}, {13800,0.00792157}, {13900,0.04266667}, {14000,0.00786275}, {14100,0.06071569}, {14200,0.00783333}, {14300,0.01031373}, {14400,0.00851961}, {14500,0.00748039}, {14600,0.00782353}, {14700,0.00804902}, {14800,0.01104902}, {14900,0.00808824}, {15000,0.00831373}, {15100,0.06346078}, {15200,0.01104902}, {15300,0.05935294}, {15400,0.01003922}, {15500,0.00922549}, {15600,0.00838235}, {15700,0.03880392}, {15800,0.00969608}, {15900,0.00847059}, {16000,0.01292157}, {16100,0.01199020}, {16200,0.00848039}, {16300,0.00887255}, {16400,0.00879412}, {16500,0.00922549}, {16600,0.00913725}, {16700,0.00898039}, {16800,0.05079412}, {16900,0.00931373}, {17000,0.06520588}, {17100,0.01169608}, {17200,0.01050980}, {17300,0.05479412}, {17400,0.01144118}, {17500,0.01064706}, {17600,0.01104902}, {17700,0.01089216}, {17800,0.01051961}, {17900,0.00971569}, {18000,0.01093137}, {18100,0.01140196}, {18200,0.01015686}, {18300,0.01168627}, {18400,0.05957843}, {18500,0.01018627}, {18600,0.01051961}, {18700,0.01188235}, {18800,0.01192157}, {18900,0.01167647}, {19000,0.06473529}, {19100,0.01033333}, {19200,0.01077451}, {19300,0.01150000}, {19400,0.01075490}, {19500,0.01126471}, {19600,0.05152941}, {19700,0.01087255}, {19800,0.01157843}, {19900,0.01096078}, {20000,0.01094118}};
data["big"]["Ltac2LowLevel"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00003922}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00003922}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00003922}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00003922}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00003922}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00007843}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00003922}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00003922}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00003922}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00002941}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00002941}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00002941}, {935,0.00000000}, {940,0.00003922}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00003922}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00003922}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00003922}, {1310,0.00000000}, {1320,0.00002941}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00003922}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00007843}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00003922}, {1560,0.00018627}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00003922}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003922}, {1670,0.00003922}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00007843}, {1750,0.00000000}, {1760,0.00003922}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00003922}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00002941}, {1890,0.00003922}, {1900,0.00000000}, {1910,0.00003922}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00003922}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00019608}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00003922}, {2950,0.00003922}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00037255}, {3300,0.00000000}, {3350,0.00003922}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00003922}, {3700,0.00003922}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00003922}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00003922}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00007843}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00003922}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00003922}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00003922}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00003922}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00003922}, {6150,0.00003922}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00002941}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00003922}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00003922}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00003922}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00003922}, {7850,0.00000000}, {7900,0.00003922}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00003922}, {8100,0.00003922}, {8150,0.00000000}, {8200,0.00003922}, {8250,0.00000000}, {8300,0.00007843}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00007843}, {8500,0.00003922}, {8550,0.00007843}, {8600,0.00007843}, {8650,0.00003922}, {8700,0.00000000}, {8750,0.00061765}, {8800,0.00000000}, {8850,0.00003922}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00003922}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00003922}, {9550,0.00000000}, {9600,0.00007843}, {9650,0.00003922}, {9700,0.00003922}, {9750,0.00000000}, {9800,0.00003922}, {9850,0.00003922}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00003922}, {10300,0.00000000}, {10400,0.00003922}, {10500,0.00003922}, {10600,0.00002941}, {10700,0.00000000}, {10800,0.00003922}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00003922}, {11400,0.00003922}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00003922}, {11800,0.00000000}, {11900,0.00003922}, {12000,0.00007843}, {12100,0.00007843}, {12200,0.00003922}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00003922}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00007843}, {13900,0.00011765}, {14000,0.00003922}, {14100,0.00003922}, {14200,0.00000000}, {14300,0.00007843}, {14400,0.00000000}, {14500,0.00003922}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00003922}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00003922}, {16100,0.00003922}, {16200,0.00003922}, {16300,0.00000000}, {16400,0.00007843}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00003922}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00003922}, {17300,0.00003922}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00007843}, {17700,0.00000000}, {17800,0.00003922}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00003922}, {18200,0.00000000}, {18300,0.00003922}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00003922}, {18800,0.00000000}, {18900,0.00007843}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00003922}, {19300,0.00000000}, {19400,0.00003922}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00003922}, {20000,0.00003922}};
data["big"]["Ltac2LowLevel"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000980}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big"]["Ltac2LowLevel"]["post"]["user"] = {{1,0.00007843}, {2,0.00007843}, {3,0.00003922}, {4,0.00006863}, {5,0.00003922}, {6,0.00003922}, {7,0.00000000}, {8,0.00000000}, {9,0.00007843}, {10,0.00000000}, {11,0.00003922}, {12,0.00000000}, {13,0.00000000}, {14,0.00003922}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00003922}, {20,0.00000000}, {21,0.00002941}, {22,0.00000000}, {23,0.00003922}, {24,0.00002941}, {25,0.00006863}, {26,0.00003922}, {27,0.00000000}, {28,0.00002941}, {29,0.00002941}, {30,0.00006863}, {31,0.00002941}, {32,0.00000000}, {33,0.00003922}, {34,0.00000000}, {35,0.00006863}, {36,0.00000000}, {37,0.00003922}, {38,0.00002941}, {39,0.00000000}, {40,0.00002941}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00007843}, {45,0.00010784}, {46,0.00002941}, {47,0.00003922}, {48,0.00002941}, {49,0.00002941}, {50,0.00000000}, {51,0.00002941}, {52,0.00003922}, {53,0.00002941}, {54,0.00003922}, {55,0.00006863}, {56,0.00002941}, {57,0.00003922}, {58,0.00000000}, {59,0.00007843}, {60,0.00003922}, {61,0.00009804}, {62,0.00000000}, {63,0.00003922}, {64,0.00000000}, {65,0.00002941}, {66,0.00000000}, {67,0.00002941}, {68,0.00003922}, {69,0.00000000}, {70,0.00003922}, {71,0.00007843}, {72,0.00000000}, {73,0.00014706}, {74,0.00006863}, {75,0.00003922}, {76,0.00000000}, {77,0.00003922}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00014706}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00008824}, {87,0.00006863}, {88,0.00009804}, {89,0.00000000}, {90,0.00002941}, {91,0.00000000}, {92,0.00000000}, {93,0.00006863}, {94,0.00000000}, {95,0.00003922}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00006863}, {100,0.00000000}, {101,0.00003922}, {102,0.00003922}, {103,0.00003922}, {104,0.00000000}, {105,0.00000000}, {106,0.00009804}, {107,0.00000000}, {108,0.00000000}, {109,0.00002941}, {110,0.00000000}, {111,0.00002941}, {112,0.00015686}, {113,0.00003922}, {114,0.00006863}, {115,0.00003922}, {116,0.00007843}, {117,0.00002941}, {118,0.00000000}, {119,0.00005882}, {120,0.00002941}, {121,0.00003922}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00003922}, {126,0.00000000}, {127,0.00002941}, {128,0.00000000}, {129,0.00003922}, {130,0.00007843}, {131,0.00003922}, {132,0.00000000}, {133,0.00000000}, {134,0.00002941}, {135,0.00000000}, {136,0.00005882}, {137,0.00012745}, {138,0.00000000}, {139,0.00000000}, {140,0.00002941}, {141,0.00003922}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00003922}, {146,0.00010784}, {147,0.00000000}, {148,0.00003922}, {149,0.00006863}, {150,0.00002941}, {151,0.00002941}, {152,0.00002941}, {153,0.00006863}, {154,0.00002941}, {155,0.00003922}, {156,0.00006863}, {157,0.00011765}, {158,0.00007843}, {159,0.00000000}, {160,0.00003922}, {161,0.00000000}, {162,0.00002941}, {163,0.00000000}, {164,0.00002941}, {165,0.00006863}, {166,0.00006863}, {167,0.00003922}, {168,0.00003922}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00007843}, {173,0.00007843}, {174,0.00003922}, {175,0.00000000}, {176,0.00003922}, {177,0.00006863}, {178,0.00000000}, {179,0.00003922}, {180,0.00002941}, {181,0.00007843}, {182,0.00002941}, {183,0.00003922}, {184,0.00006863}, {185,0.00002941}, {186,0.00003922}, {187,0.00000000}, {188,0.00000000}, {189,0.00003922}, {190,0.00000000}, {191,0.00002941}, {192,0.00000000}, {193,0.00003922}, {194,0.00003922}, {195,0.00003922}, {196,0.00000000}, {197,0.00002941}, {198,0.00000000}, {199,0.00005882}, {200,0.00002941}, {201,0.00003922}, {202,0.00003922}, {203,0.00011765}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00010784}, {208,0.00010784}, {209,0.00000000}, {210,0.00003922}, {211,0.00000000}, {212,0.00002941}, {213,0.00002941}, {214,0.00000000}, {215,0.00003922}, {216,0.00011765}, {217,0.00000000}, {218,0.00002941}, {219,0.00006863}, {220,0.00002941}, {221,0.00002941}, {222,0.00000000}, {223,0.00006863}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00007843}, {229,0.00000000}, {230,0.00000000}, {231,0.00015686}, {232,0.00003922}, {233,0.00000000}, {234,0.00003922}, {235,0.00000000}, {236,0.00006863}, {237,0.00007843}, {238,0.00000000}, {239,0.00003922}, {240,0.00007843}, {241,0.00006863}, {242,0.00003922}, {243,0.00000000}, {244,0.00003922}, {245,0.00007843}, {246,0.00002941}, {247,0.00010784}, {248,0.00003922}, {249,0.00003922}, {250,0.00002941}, {251,0.00003922}, {252,0.00002941}, {253,0.00003922}, {254,0.00010784}, {255,0.00002941}, {256,0.00003922}, {257,0.00003922}, {258,0.00003922}, {259,0.00002941}, {260,0.00000000}, {261,0.00003922}, {262,0.00014706}, {263,0.00005882}, {264,0.00003922}, {265,0.00003922}, {266,0.00003922}, {267,0.00003922}, {268,0.00003922}, {269,0.00002941}, {270,0.00006863}, {271,0.00000000}, {272,0.00050000}, {273,0.00009804}, {274,0.00003922}, {275,0.00000000}, {276,0.00000000}, {277,0.00002941}, {278,0.00002941}, {279,0.00003922}, {280,0.00009804}, {281,0.00000000}, {282,0.00002941}, {283,0.00003922}, {284,0.00006863}, {285,0.00000000}, {286,0.00003922}, {287,0.00003922}, {288,0.00002941}, {289,0.00003922}, {290,0.00003922}, {291,0.00005882}, {292,0.00007843}, {293,0.00000000}, {294,0.00010784}, {295,0.00000000}, {296,0.00007843}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00010784}, {302,0.00003922}, {303,0.00002941}, {304,0.00002941}, {305,0.00007843}, {306,0.00003922}, {307,0.00007843}, {308,0.00003922}, {309,0.00000000}, {310,0.00002941}, {311,0.00002941}, {312,0.00006863}, {313,0.00000000}, {314,0.00000000}, {315,0.00006863}, {316,0.00002941}, {317,0.00002941}, {318,0.00007843}, {319,0.00003922}, {320,0.00000000}, {321,0.00002941}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00006863}, {326,0.00000000}, {327,0.00003922}, {328,0.00002941}, {329,0.00002941}, {330,0.00002941}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00003922}, {335,0.00003922}, {336,0.00003922}, {337,0.00000000}, {338,0.00007843}, {339,0.00002941}, {340,0.00000000}, {341,0.00003922}, {342,0.00005882}, {343,0.00003922}, {344,0.00003922}, {345,0.00006863}, {346,0.00007843}, {347,0.00003922}, {348,0.00000000}, {349,0.00014706}, {350,0.00007843}, {351,0.00003922}, {352,0.00006863}, {353,0.00007843}, {354,0.00000000}, {355,0.00002941}, {356,0.00005882}, {357,0.00007843}, {358,0.00003922}, {359,0.00000000}, {360,0.00014706}, {361,0.00000000}, {362,0.00006863}, {363,0.00000000}, {364,0.00003922}, {365,0.00003922}, {366,0.00011765}, {367,0.00000000}, {368,0.00002941}, {369,0.00000000}, {370,0.00002941}, {371,0.00012745}, {372,0.00006863}, {373,0.00007843}, {374,0.00006863}, {375,0.00005882}, {376,0.00000000}, {377,0.00003922}, {378,0.00003922}, {379,0.00010784}, {380,0.00002941}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00003922}, {385,0.00002941}, {386,0.00003922}, {387,0.00003922}, {388,0.00003922}, {389,0.00000000}, {390,0.00003922}, {391,0.00000000}, {392,0.00003922}, {393,0.00003922}, {394,0.00000000}, {395,0.00003922}, {396,0.00000000}, {397,0.00003922}, {398,0.00002941}, {399,0.00003922}, {400,0.00000000}, {401,0.00007843}, {402,0.00006863}, {403,0.00002941}, {404,0.00011765}, {405,0.00000000}, {406,0.00002941}, {407,0.00003922}, {408,0.00007843}, {409,0.00000000}, {410,0.00009804}, {411,0.00006863}, {412,0.00007843}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00003922}, {417,0.00006863}, {418,0.00003922}, {419,0.00002941}, {420,0.00002941}, {421,0.00000000}, {422,0.00000000}, {423,0.00003922}, {424,0.00010784}, {425,0.00002941}, {426,0.00000000}, {427,0.00003922}, {428,0.00006863}, {429,0.00006863}, {430,0.00006863}, {431,0.00000000}, {432,0.00006863}, {433,0.00000000}, {434,0.00000000}, {435,0.00006863}, {436,0.00011765}, {437,0.00002941}, {438,0.00011765}, {439,0.00009804}, {440,0.00006863}, {441,0.00002941}, {442,0.00000000}, {443,0.00003922}, {444,0.00003922}, {445,0.00003922}, {446,0.00000000}, {447,0.00007843}, {448,0.00000000}, {449,0.00006863}, {450,0.00007843}, {451,0.00002941}, {452,0.00005882}, {453,0.00002941}, {454,0.00000000}, {455,0.00002941}, {456,0.00000000}, {457,0.00005882}, {458,0.00000000}, {459,0.00003922}, {460,0.00006863}, {461,0.00003922}, {462,0.00000000}, {463,0.00003922}, {464,0.00003922}, {465,0.00000000}, {466,0.00003922}, {467,0.00002941}, {468,0.00014706}, {469,0.00003922}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00003922}, {474,0.00006863}, {475,0.00003922}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00010784}, {480,0.00014706}, {481,0.00010784}, {482,0.00000000}, {483,0.00007843}, {484,0.00002941}, {485,0.00003922}, {486,0.00015686}, {487,0.00000000}, {488,0.00000000}, {489,0.00006863}, {490,0.00000000}, {491,0.00003922}, {492,0.00007843}, {493,0.00000000}, {494,0.00000000}, {495,0.00003922}, {496,0.00003922}, {497,0.00002941}, {498,0.00003922}, {499,0.00002941}, {500,0.00006863}, {505,0.00002941}, {510,0.00000000}, {515,0.00007843}, {520,0.00002941}, {525,0.00003922}, {530,0.00000000}, {535,0.00005882}, {540,0.00010784}, {545,0.00011765}, {550,0.00000000}, {555,0.00009804}, {560,0.00010784}, {565,0.00006863}, {570,0.00003922}, {575,0.00002941}, {580,0.00006863}, {585,0.00003922}, {590,0.00000000}, {595,0.00000000}, {600,0.00009804}, {605,0.00003922}, {610,0.00002941}, {615,0.00002941}, {620,0.00002941}, {625,0.00002941}, {630,0.00011765}, {635,0.00002941}, {640,0.00006863}, {645,0.00007843}, {650,0.00002941}, {655,0.00000000}, {660,0.00003922}, {665,0.00007843}, {670,0.00003922}, {675,0.00007843}, {680,0.00007843}, {685,0.00003922}, {690,0.00000000}, {695,0.00002941}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00006863}, {725,0.00003922}, {730,0.00002941}, {735,0.00003922}, {740,0.00007843}, {745,0.00000000}, {750,0.00003922}, {755,0.00010784}, {760,0.00002941}, {765,0.00003922}, {770,0.00000000}, {775,0.00000000}, {780,0.00013725}, {785,0.00000000}, {790,0.00003922}, {795,0.00010784}, {800,0.00003922}, {805,0.00000000}, {810,0.00002941}, {815,0.00000000}, {820,0.00003922}, {825,0.00006863}, {830,0.00000000}, {835,0.00002941}, {840,0.00003922}, {845,0.00007843}, {850,0.00007843}, {855,0.00003922}, {860,0.00007843}, {865,0.00003922}, {870,0.00000000}, {875,0.00000000}, {880,0.00003922}, {885,0.00003922}, {890,0.00003922}, {895,0.00006863}, {900,0.00014706}, {905,0.00007843}, {910,0.00000000}, {915,0.00003922}, {920,0.00000000}, {925,0.00007843}, {930,0.00007843}, {935,0.00002941}, {940,0.00003922}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00003922}, {970,0.00000000}, {975,0.00000000}, {980,0.00003922}, {985,0.00000000}, {990,0.00006863}, {995,0.00000000}, {1000,0.00003922}, {1010,0.00006863}, {1020,0.00000000}, {1030,0.00006863}, {1040,0.00000000}, {1050,0.00003922}, {1060,0.00005882}, {1070,0.00003922}, {1080,0.00007843}, {1090,0.00002941}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00014706}, {1130,0.00000000}, {1140,0.00003922}, {1150,0.00007843}, {1160,0.00003922}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00003922}, {1200,0.00006863}, {1210,0.00007843}, {1220,0.00002941}, {1230,0.00000000}, {1240,0.00003922}, {1250,0.00007843}, {1260,0.00000000}, {1270,0.00006863}, {1280,0.00003922}, {1290,0.00002941}, {1300,0.00003922}, {1310,0.00003922}, {1320,0.00000000}, {1330,0.00003922}, {1340,0.00002941}, {1350,0.00003922}, {1360,0.00003922}, {1370,0.00006863}, {1380,0.00003922}, {1390,0.00013725}, {1400,0.00002941}, {1410,0.00000000}, {1420,0.00003922}, {1430,0.00011765}, {1440,0.00003922}, {1450,0.00000000}, {1460,0.00003922}, {1470,0.00006863}, {1480,0.00000000}, {1490,0.00007843}, {1500,0.00007843}, {1510,0.00000000}, {1520,0.00007843}, {1530,0.00010784}, {1540,0.00002941}, {1550,0.00003922}, {1560,0.00000000}, {1570,0.00003922}, {1580,0.00002941}, {1590,0.00000000}, {1600,0.00010784}, {1610,0.00002941}, {1620,0.00000000}, {1630,0.00007843}, {1640,0.00003922}, {1650,0.00007843}, {1660,0.00003922}, {1670,0.00003922}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00006863}, {1710,0.00003922}, {1720,0.00002941}, {1730,0.00003922}, {1740,0.00006863}, {1750,0.00006863}, {1760,0.00003922}, {1770,0.00000000}, {1780,0.00003922}, {1790,0.00003922}, {1800,0.00009804}, {1810,0.00003922}, {1820,0.00002941}, {1830,0.00003922}, {1840,0.00000000}, {1850,0.00007843}, {1860,0.00000000}, {1870,0.00003922}, {1880,0.00003922}, {1890,0.00003922}, {1900,0.00003922}, {1910,0.00000000}, {1920,0.00003922}, {1930,0.00002941}, {1940,0.00000000}, {1950,0.00008824}, {1960,0.00007843}, {1970,0.00018627}, {1980,0.00003922}, {1990,0.00011765}, {2000,0.00011765}, {2050,0.00000000}, {2100,0.00006863}, {2150,0.00002941}, {2200,0.00003922}, {2250,0.00009804}, {2300,0.00006863}, {2350,0.00003922}, {2400,0.00000000}, {2450,0.00003922}, {2500,0.00000000}, {2550,0.00006863}, {2600,0.00003922}, {2650,0.00003922}, {2700,0.00003922}, {2750,0.00009804}, {2800,0.00002941}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00003922}, {3000,0.00000000}, {3050,0.00003922}, {3100,0.00006863}, {3150,0.00002941}, {3200,0.00003922}, {3250,0.00007843}, {3300,0.00007843}, {3350,0.00003922}, {3400,0.00002941}, {3450,0.00007843}, {3500,0.00006863}, {3550,0.00000000}, {3600,0.00006863}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00006863}, {3800,0.00010784}, {3850,0.00002941}, {3900,0.00002941}, {3950,0.00003922}, {4000,0.00000000}, {4050,0.00007843}, {4100,0.00000000}, {4150,0.00002941}, {4200,0.00006863}, {4250,0.00003922}, {4300,0.00007843}, {4350,0.00002941}, {4400,0.00011765}, {4450,0.00003922}, {4500,0.00006863}, {4550,0.00003922}, {4600,0.00017647}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00003922}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00002941}, {5000,0.00006863}, {5050,0.00007843}, {5100,0.00000000}, {5150,0.00006863}, {5200,0.00010784}, {5250,0.00002941}, {5300,0.00000000}, {5350,0.00003922}, {5400,0.00007843}, {5450,0.00000000}, {5500,0.00010784}, {5550,0.00003922}, {5600,0.00010784}, {5650,0.00003922}, {5700,0.00003922}, {5750,0.00000000}, {5800,0.00002941}, {5850,0.00002941}, {5900,0.00003922}, {5950,0.00003922}, {6000,0.00006863}, {6050,0.00002941}, {6100,0.00003922}, {6150,0.00011765}, {6200,0.00000000}, {6250,0.00007843}, {6300,0.00003922}, {6350,0.00003922}, {6400,0.00011765}, {6450,0.00014706}, {6500,0.00002941}, {6550,0.00007843}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00006863}, {6750,0.00002941}, {6800,0.00000000}, {6850,0.00005882}, {6900,0.00000000}, {6950,0.00013725}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00007843}, {7150,0.00000000}, {7200,0.00002941}, {7250,0.00007843}, {7300,0.00006863}, {7350,0.00002941}, {7400,0.00009804}, {7450,0.00002941}, {7500,0.00000000}, {7550,0.00007843}, {7600,0.00009804}, {7650,0.00003922}, {7700,0.00006863}, {7750,0.00000000}, {7800,0.00007843}, {7850,0.00003922}, {7900,0.00003922}, {7950,0.00003922}, {8000,0.00003922}, {8050,0.00011765}, {8100,0.00002941}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00011765}, {8300,0.00000000}, {8350,0.00006863}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00003922}, {8550,0.00003922}, {8600,0.00002941}, {8650,0.00010784}, {8700,0.00007843}, {8750,0.00003922}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00007843}, {8950,0.00002941}, {9000,0.00014706}, {9050,0.00002941}, {9100,0.00003922}, {9150,0.00000000}, {9200,0.00003922}, {9250,0.00000000}, {9300,0.00006863}, {9350,0.00000000}, {9400,0.00011765}, {9450,0.00000000}, {9500,0.00003922}, {9550,0.00009804}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00010784}, {9850,0.00003922}, {9900,0.00010784}, {9950,0.00003922}, {10000,0.00003922}, {10100,0.00007843}, {10200,0.00006863}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00006863}, {11000,0.00000000}, {11100,0.00003922}, {11200,0.00010784}, {11300,0.00000000}, {11400,0.00007843}, {11500,0.00002941}, {11600,0.00000000}, {11700,0.00005882}, {11800,0.00003922}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00002941}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00007843}, {12500,0.00010784}, {12600,0.00000000}, {12700,0.00003922}, {12800,0.00003922}, {12900,0.00000000}, {13000,0.00003922}, {13100,0.00003922}, {13200,0.00011765}, {13300,0.00000000}, {13400,0.00002941}, {13500,0.00000000}, {13600,0.00006863}, {13700,0.00006863}, {13800,0.00002941}, {13900,0.00000000}, {14000,0.00014706}, {14100,0.00000000}, {14200,0.00003922}, {14300,0.00003922}, {14400,0.00003922}, {14500,0.00000000}, {14600,0.00007843}, {14700,0.00002941}, {14800,0.00013725}, {14900,0.00006863}, {15000,0.00010784}, {15100,0.00007843}, {15200,0.00007843}, {15300,0.00010784}, {15400,0.00000000}, {15500,0.00008824}, {15600,0.00006863}, {15700,0.00003922}, {15800,0.00000000}, {15900,0.00002941}, {16000,0.00000000}, {16100,0.00002941}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00006863}, {16500,0.00002941}, {16600,0.00007843}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00007843}, {17000,0.00006863}, {17100,0.00003922}, {17200,0.00011765}, {17300,0.00000000}, {17400,0.00002941}, {17500,0.00003922}, {17600,0.00003922}, {17700,0.00007843}, {17800,0.00003922}, {17900,0.00003922}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00003922}, {18300,0.00000000}, {18400,0.00003922}, {18500,0.00007843}, {18600,0.00006863}, {18700,0.00007843}, {18800,0.00011765}, {18900,0.00003922}, {19000,0.00002941}, {19100,0.00000000}, {19200,0.00003922}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00007843}, {19600,0.00010784}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00007843}};
data["big"]["Ltac2LowLevel"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00003922}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00003922}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00003922}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00003922}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00003922}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00003922}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00003922}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big"]["Ltac2LowLevel"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big"]["Ltac2LowLevel"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00002941}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00003922}, {9,0.00000000}, {10,0.00003922}, {11,0.00000000}, {12,0.00002941}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00002941}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00003922}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00002941}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00003922}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00003922}, {81,0.00003922}, {82,0.00000000}, {83,0.00003922}, {84,0.00003922}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00003922}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00003922}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00003922}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00003922}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00003922}, {156,0.00000000}, {157,0.00003922}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00003922}, {164,0.00003922}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00002941}, {178,0.00000000}, {179,0.00000000}, {180,0.00003922}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00003922}, {187,0.00000000}, {188,0.00003922}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00003922}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00003922}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00006863}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00003922}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00002941}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00003922}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00002941}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00003922}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00003922}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00002941}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00003922}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00003922}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00003922}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00002941}, {348,0.00000000}, {349,0.00002941}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00003922}, {360,0.00003922}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00003922}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00003922}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00003922}, {394,0.00000000}, {395,0.00002941}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00003922}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00003922}, {411,0.00000000}, {412,0.00002941}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00002941}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00002941}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00003922}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00003922}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00003922}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00003922}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00003922}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00002941}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00003922}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00002941}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00003922}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00002941}, {575,0.00000000}, {580,0.00000000}, {585,0.00002941}, {590,0.00000000}, {595,0.00002941}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00002941}, {690,0.00000000}, {695,0.00003922}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00002941}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00003922}, {810,0.00000000}, {815,0.00006863}, {820,0.00000000}, {825,0.00003922}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00002941}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00002941}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00003922}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00003922}, {1080,0.00002941}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00002941}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00003922}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00002941}, {1630,0.00003922}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00003922}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00003922}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00003922}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00003922}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00002941}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00003922}, {2750,0.00000000}, {2800,0.00003922}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00007843}, {3000,0.00003922}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00003922}, {3800,0.00000000}, {3850,0.00003922}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00003922}, {4450,0.00003922}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00006863}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00003922}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00003922}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00003922}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00003922}, {6650,0.00000000}, {6700,0.00007843}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00003922}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00003922}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00003922}, {8550,0.00002941}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00002941}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00003922}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00002941}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00002941}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00002941}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00003922}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00003922}, {14500,0.00000000}, {14600,0.00003922}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00003922}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00003922}, {17400,0.00000000}, {17500,0.00003922}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00007843}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00003922}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00003922}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00003922}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big"]["Ltac2LowLevel"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00003922}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00003922}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big"]["Ltac2LowLevel"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000980}, {11,0.00006863}, {12,0.00012745}, {13,0.00022549}, {14,0.00093137}, {15,0.00100000}, {16,0.00100000}, {17,0.00100000}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00100000}, {23,0.00100000}, {24,0.00100980}, {25,0.00102941}, {26,0.00109804}, {27,0.00111765}, {28,0.00110784}, {29,0.00112745}, {30,0.00119608}, {31,0.00179412}, {32,0.00200000}, {33,0.00200000}, {34,0.00200000}, {35,0.00200000}, {36,0.00200000}, {37,0.00200000}, {38,0.00200980}, {39,0.00200980}, {40,0.00208824}, {41,0.00207843}, {42,0.00204902}, {43,0.00208824}, {44,0.00213725}, {45,0.00210784}, {46,0.00213725}, {47,0.00231373}, {48,0.00272549}, {49,0.00296078}, {50,0.00300000}, {51,0.00300000}, {52,0.00302941}, {53,0.00303922}, {54,0.00305882}, {55,0.00305882}, {56,0.00305882}, {57,0.00303922}, {58,0.00302941}, {59,0.00407843}, {60,0.00326471}, {61,0.00312745}, {62,0.00316667}, {63,0.00323529}, {64,0.00339216}, {65,0.00371569}, {66,0.00394118}, {67,0.00401961}, {68,0.00404902}, {69,0.00404902}, {70,0.00402941}, {71,0.00405882}, {72,0.00405882}, {73,0.00407843}, {74,0.00403922}, {75,0.00408824}, {76,0.00415686}, {77,0.00412745}, {78,0.00414706}, {79,0.00414706}, {80,0.00429412}, {81,0.00445098}, {82,0.00476471}, {83,0.00494118}, {84,0.00502941}, {85,0.00502941}, {86,0.00503922}, {87,0.00581373}, {88,0.00500980}, {89,0.00506863}, {90,0.00505882}, {91,0.00506863}, {92,0.00508824}, {93,0.00514706}, {94,0.00513725}, {95,0.00516667}, {96,0.00526471}, {97,0.00537255}, {98,0.00562745}, {99,0.00610784}, {100,0.00597059}, {101,0.00600980}, {102,0.00600980}, {103,0.00604902}, {104,0.00605882}, {105,0.00603922}, {106,0.00608824}, {107,0.00612745}, {108,0.00614706}, {109,0.00717647}, {110,0.00616667}, {111,0.00617647}, {112,0.00617647}, {113,0.00613725}, {114,0.00631373}, {115,0.00654902}, {116,0.00677451}, {117,0.00693137}, {118,0.00699020}, {119,0.00707843}, {120,0.00704902}, {121,0.00708824}, {122,0.00708824}, {123,0.00708824}, {124,0.00716667}, {125,0.00717647}, {126,0.00712745}, {127,0.00874510}, {128,0.00714706}, {129,0.00717647}, {130,0.00732353}, {131,0.00740196}, {132,0.00761765}, {133,0.00780392}, {134,0.00792157}, {135,0.00801961}, {136,0.00808824}, {137,0.00808824}, {138,0.00810784}, {139,0.00817647}, {140,0.00810784}, {141,0.00805882}, {142,0.00812745}, {143,0.00921569}, {144,0.00819608}, {145,0.00824510}, {146,0.00812745}, {147,0.00821569}, {148,0.00840196}, {149,0.00854902}, {150,0.00875490}, {151,0.00961765}, {152,0.00899020}, {153,0.00903922}, {154,0.00905882}, {155,0.00908824}, {156,0.00912745}, {157,0.00920588}, {158,0.01030392}, {159,0.00915686}, {160,0.00928431}, {161,0.00926471}, {162,0.00929412}, {163,0.00921569}, {164,0.00929412}, {165,0.01025490}, {166,0.00949020}, {167,0.00974510}, {168,0.00989216}, {169,0.00997059}, {170,0.01001961}, {171,0.01066667}, {172,0.01007843}, {173,0.01018627}, {174,0.01010784}, {175,0.01017647}, {176,0.01017647}, {177,0.01017647}, {178,0.01123529}, {179,0.01030392}, {180,0.01034314}, {181,0.01044118}, {182,0.01040196}, {183,0.01070588}, {184,0.01180392}, {185,0.01084314}, {186,0.01100000}, {187,0.01100980}, {188,0.01110784}, {189,0.01114706}, {190,0.01207843}, {191,0.01114706}, {192,0.01113725}, {193,0.01115686}, {194,0.01114706}, {195,0.01126471}, {196,0.01127451}, {197,0.01150980}, {198,0.01129412}, {199,0.01149020}, {200,0.01165686}, {201,0.01360784}, {202,0.01185294}, {203,0.01196078}, {204,0.01205882}, {205,0.01203922}, {206,0.01219608}, {207,0.01291176}, {208,0.01214706}, {209,0.01214706}, {210,0.01218627}, {211,0.01225490}, {212,0.01395098}, {213,0.01229412}, {214,0.01228431}, {215,0.01233333}, {216,0.01252941}, {217,0.01477451}, {218,0.01283333}, {219,0.01290196}, {220,0.01299020}, {221,0.01303922}, {222,0.01420588}, {223,0.01300980}, {224,0.01313725}, {225,0.01319608}, {226,0.01320588}, {227,0.01470588}, {228,0.01305882}, {229,0.01337255}, {230,0.01336275}, {231,0.01338235}, {232,0.01577451}, {233,0.01344118}, {234,0.01363725}, {235,0.01371569}, {236,0.01389216}, {237,0.01548039}, {238,0.01406863}, {239,0.01402941}, {240,0.01416667}, {241,0.01419608}, {242,0.01498039}, {243,0.01417647}, {244,0.01420588}, {245,0.01435294}, {246,0.01600980}, {247,0.01413725}, {248,0.01450980}, {249,0.01452941}, {250,0.01453922}, {251,0.01590196}, {252,0.01485294}, {253,0.01488235}, {254,0.01497059}, {255,0.01688235}, {256,0.01493137}, {257,0.01514706}, {258,0.01521569}, {259,0.01529412}, {260,0.01601961}, {261,0.01521569}, {262,0.01521569}, {263,0.01525490}, {264,0.01708824}, {265,0.01549020}, {266,0.01547059}, {267,0.01560784}, {268,0.01810784}, {269,0.01571569}, {270,0.01591176}, {271,0.01600000}, {272,0.01600980}, {273,0.01604902}, {274,0.01612745}, {275,0.01620588}, {276,0.01619608}, {277,0.01624510}, {278,0.01618627}, {279,0.01640196}, {280,0.01635294}, {281,0.01628431}, {282,0.01651961}, {283,0.01652941}, {284,0.01655882}, {285,0.01654902}, {286,0.01681373}, {287,0.01688235}, {288,0.01695098}, {289,0.01706863}, {290,0.01703922}, {291,0.01710784}, {292,0.01713725}, {293,0.01717647}, {294,0.01728431}, {295,0.01726471}, {296,0.01967647}, {297,0.01721569}, {298,0.01732353}, {299,0.01738235}, {300,0.01988235}, {301,0.01751961}, {302,0.01758824}, {303,0.01771569}, {304,0.01920588}, {305,0.01793137}, {306,0.01799020}, {307,0.01813725}, {308,0.01806863}, {309,0.01826471}, {310,0.01821569}, {311,0.02130392}, {312,0.01835294}, {313,0.01836275}, {314,0.01848039}, {315,0.02001961}, {316,0.01850980}, {317,0.01847059}, {318,0.01870588}, {319,0.01870588}, {320,0.01874510}, {321,0.01885294}, {322,0.02091176}, {323,0.01900000}, {324,0.01908824}, {325,0.01902941}, {326,0.01913725}, {327,0.01917647}, {328,0.01932353}, {329,0.02126471}, {330,0.01928431}, {331,0.01946078}, {332,0.01937255}, {333,0.01945098}, {334,0.01948039}, {335,0.01965686}, {336,0.02110784}, {337,0.01979412}, {338,0.01989216}, {339,0.02269608}, {340,0.02000980}, {341,0.01996078}, {342,0.02007843}, {343,0.02012745}, {344,0.02020588}, {345,0.02026471}, {346,0.02202941}, {347,0.02037255}, {348,0.02029412}, {349,0.02314706}, {350,0.02050000}, {351,0.02057843}, {352,0.02203922}, {353,0.02053922}, {354,0.02087255}, {355,0.02063725}, {356,0.02077451}, {357,0.02096078}, {358,0.02110784}, {359,0.02246078}, {360,0.02111765}, {361,0.02105882}, {362,0.02318627}, {363,0.02123529}, {364,0.02127451}, {365,0.02396078}, {366,0.02136275}, {367,0.02140196}, {368,0.02438235}, {369,0.02162745}, {370,0.02161765}, {371,0.02487255}, {372,0.02183333}, {373,0.02181373}, {374,0.02398039}, {375,0.02185294}, {376,0.02203922}, {377,0.02338235}, {378,0.02194118}, {379,0.02221569}, {380,0.02322549}, {381,0.02203922}, {382,0.02239216}, {383,0.02375490}, {384,0.02215686}, {385,0.02250980}, {386,0.02437255}, {387,0.02250000}, {388,0.02278431}, {389,0.02584314}, {390,0.02281373}, {391,0.02292157}, {392,0.02623529}, {393,0.02303922}, {394,0.02312745}, {395,0.02599020}, {396,0.02314706}, {397,0.02324510}, {398,0.02581373}, {399,0.02332353}, {400,0.02347059}, {401,0.02534314}, {402,0.02356863}, {403,0.02346078}, {404,0.02479412}, {405,0.02364706}, {406,0.02373529}, {407,0.02385294}, {408,0.02397059}, {409,0.02631373}, {410,0.02390196}, {411,0.02419608}, {412,0.02712745}, {413,0.02426471}, {414,0.02433333}, {415,0.02621569}, {416,0.02436275}, {417,0.02443137}, {418,0.02519608}, {419,0.02463725}, {420,0.02637255}, {421,0.02447059}, {422,0.02470588}, {423,0.02769608}, {424,0.02493137}, {425,0.02503922}, {426,0.02636275}, {427,0.02496078}, {428,0.02512745}, {429,0.02517647}, {430,0.02518627}, {431,0.02855882}, {432,0.02532353}, {433,0.02541176}, {434,0.02695098}, {435,0.02553922}, {436,0.02718627}, {437,0.02558824}, {438,0.02571569}, {439,0.02871569}, {440,0.02582353}, {441,0.02585294}, {442,0.02659804}, {443,0.02595098}, {444,0.02963725}, {445,0.02614706}, {446,0.02608824}, {447,0.02787255}, {448,0.02622549}, {449,0.02870588}, {450,0.02610784}, {451,0.02645098}, {452,0.02862745}, {453,0.02647059}, {454,0.02825490}, {455,0.02658824}, {456,0.02678431}, {457,0.02933333}, {458,0.02690196}, {459,0.02700980}, {460,0.02697059}, {461,0.02705882}, {462,0.02951961}, {463,0.02705882}, {464,0.02863725}, {465,0.02725490}, {466,0.02729412}, {467,0.02989216}, {468,0.02726471}, {469,0.03071569}, {470,0.02742157}, {471,0.02765686}, {472,0.02918627}, {473,0.02775490}, {474,0.03157843}, {475,0.02790196}, {476,0.02791176}, {477,0.02794118}, {478,0.02800980}, {479,0.03117647}, {480,0.02822549}, {481,0.02973529}, {482,0.02801961}, {483,0.02822549}, {484,0.03003922}, {485,0.02840196}, {486,0.03202941}, {487,0.02860784}, {488,0.02866667}, {489,0.02854902}, {490,0.02876471}, {491,0.03102941}, {492,0.02889216}, {493,0.03283333}, {494,0.02907843}, {495,0.02909804}, {496,0.02906863}, {497,0.02910784}, {498,0.03120588}, {499,0.02923529}, {500,0.03290196}, {505,0.02974510}, {510,0.03162745}, {515,0.02995098}, {520,0.03048039}, {525,0.03160784}, {530,0.03106863}, {535,0.03318627}, {540,0.03176471}, {545,0.03458824}, {550,0.03231373}, {555,0.03594118}, {560,0.03291176}, {565,0.03688235}, {570,0.03344118}, {575,0.03759804}, {580,0.03404902}, {585,0.03813725}, {590,0.03464706}, {595,0.03856863}, {600,0.03526471}, {605,0.03851961}, {610,0.03578431}, {615,0.03846078}, {620,0.03638235}, {625,0.03817647}, {630,0.03696078}, {635,0.03719608}, {640,0.04099020}, {645,0.03779412}, {650,0.04293137}, {655,0.03848039}, {660,0.04165686}, {665,0.03890196}, {670,0.04014706}, {675,0.04279412}, {680,0.03984314}, {685,0.04441176}, {690,0.04043137}, {695,0.04254902}, {700,0.04340196}, {705,0.04113725}, {710,0.04586275}, {715,0.04193137}, {720,0.04320588}, {725,0.04846078}, {730,0.04287255}, {735,0.04586275}, {740,0.04559804}, {745,0.04351961}, {750,0.05020588}, {755,0.04418627}, {760,0.04440196}, {765,0.04937255}, {770,0.04514706}, {775,0.04527451}, {780,0.05030392}, {785,0.04602941}, {790,0.04617647}, {795,0.05081373}, {800,0.04984314}, {805,0.04705882}, {810,0.05041176}, {815,0.05456863}, {820,0.04798039}, {825,0.04975490}, {830,0.05375490}, {835,0.04890196}, {840,0.04901961}, {845,0.05282353}, {850,0.05637255}, {855,0.04996078}, {860,0.05019608}, {865,0.05483333}, {870,0.05800000}, {875,0.05123529}, {880,0.05135294}, {885,0.05550980}, {890,0.05871569}, {895,0.05233333}, {900,0.05252941}, {905,0.05598039}, {910,0.05852941}, {915,0.05994118}, {920,0.05380392}, {925,0.05404902}, {930,0.05760784}, {935,0.06015686}, {940,0.06191176}, {945,0.05520588}, {950,0.05547059}, {955,0.05834314}, {960,0.06059804}, {965,0.06309804}, {970,0.06094118}, {975,0.05698039}, {980,0.05739216}, {985,0.06016667}, {990,0.06227451}, {995,0.06349020}, {1000,0.07058824}, {1010,0.06322549}, {1020,0.05964706}, {1030,0.06015686}, {1040,0.06444118}, {1050,0.06584314}, {1060,0.06818627}, {1070,0.07015686}, {1080,0.07204902}, {1090,0.07419608}, {1100,0.07572549}, {1110,0.07678431}, {1120,0.07872549}, {1130,0.07794118}, {1140,0.07560784}, {1150,0.07688235}, {1160,0.07495098}, {1170,0.07595098}, {1180,0.07743137}, {1190,0.07931373}, {1200,0.08011765}, {1210,0.08001961}, {1220,0.08011765}, {1230,0.08017647}, {1240,0.08014706}, {1250,0.07976471}, {1260,0.07942157}, {1270,0.07893137}, {1280,0.07861765}, {1290,0.07767647}, {1300,0.07596078}, {1310,0.08297059}, {1320,0.08729412}, {1330,0.08654902}, {1340,0.08526471}, {1350,0.08388235}, {1360,0.08258824}, {1370,0.08263725}, {1380,0.09313725}, {1390,0.09001961}, {1400,0.08825490}, {1410,0.08803922}, {1420,0.08684314}, {1430,0.09948039}, {1440,0.09385294}, {1450,0.09016667}, {1460,0.09165686}, {1470,0.09761765}, {1480,0.09450000}, {1490,0.09175490}, {1500,0.09684314}, {1510,0.09930392}, {1520,0.09508824}, {1530,0.09590196}, {1540,0.10380392}, {1550,0.09898039}, {1560,0.09726471}, {1570,0.10326471}, {1580,0.10117647}, {1590,0.09781373}, {1600,0.10346078}, {1610,0.10009804}, {1620,0.10680392}, {1630,0.10409804}, {1640,0.10202941}, {1650,0.10883333}, {1660,0.10261765}, {1670,0.11133333}, {1680,0.10571569}, {1690,0.10979412}, {1700,0.10808824}, {1710,0.10763725}, {1720,0.11111765}, {1730,0.10691176}, {1740,0.11437255}, {1750,0.10850980}, {1760,0.11287255}, {1770,0.10984314}, {1780,0.11366667}, {1790,0.11445098}, {1800,0.11414706}, {1810,0.11949020}, {1820,0.11410784}, {1830,0.11907843}, {1840,0.11380392}, {1850,0.11926471}, {1860,0.11819608}, {1870,0.12154902}, {1880,0.12161765}, {1890,0.11728431}, {1900,0.12249020}, {1910,0.12697059}, {1920,0.12005882}, {1930,0.12666667}, {1940,0.12717647}, {1950,0.12329412}, {1960,0.12735294}, {1970,0.13016667}, {1980,0.12338235}, {1990,0.12763725}, {2000,0.13118627}, {2050,0.12803922}, {2100,0.13202941}, {2150,0.13794118}, {2200,0.14126471}, {2250,0.14628431}, {2300,0.14950980}, {2350,0.15282353}, {2400,0.15563725}, {2450,0.15823529}, {2500,0.15892157}, {2550,0.16909804}, {2600,0.16755882}, {2650,0.17384314}, {2700,0.17368627}, {2750,0.17609804}, {2800,0.18158824}, {2850,0.18050000}, {2900,0.19114706}, {2950,0.18729412}, {3000,0.19708824}, {3050,0.19255882}, {3100,0.19941176}, {3150,0.20673529}, {3200,0.20234314}, {3250,0.21413725}, {3300,0.21415686}, {3350,0.21917647}, {3400,0.22477451}, {3450,0.22928431}, {3500,0.23026471}, {3550,0.23304902}, {3600,0.23770588}, {3650,0.23869608}, {3700,0.24157843}, {3750,0.24365686}, {3800,0.24731373}, {3850,0.25404902}, {3900,0.26626471}, {3950,0.25757843}, {4000,0.26303922}, {4050,0.26346078}, {4100,0.27031373}, {4150,0.26975490}, {4200,0.27591176}, {4250,0.28252941}, {4300,0.27826471}, {4350,0.28591176}, {4400,0.29208824}, {4450,0.28941176}, {4500,0.29060784}, {4550,0.29668627}, {4600,0.30151961}, {4650,0.30578431}, {4700,0.30856863}, {4750,0.31130392}, {4800,0.31374510}, {4850,0.31457843}, {4900,0.32629412}, {4950,0.33142157}, {5000,0.33072549}, {5050,0.32848039}, {5100,0.33424510}, {5150,0.34292157}, {5200,0.35779412}, {5250,0.35453922}, {5300,0.35133333}, {5350,0.35226471}, {5400,0.35770588}, {5450,0.36464706}, {5500,0.36341176}, {5550,0.37069608}, {5600,0.37858824}, {5650,0.37126471}, {5700,0.37601961}, {5750,0.37824510}, {5800,0.38158824}, {5850,0.38221569}, {5900,0.38376471}, {5950,0.38949020}, {6000,0.39138235}, {6050,0.39551961}, {6100,0.40628431}, {6150,0.41300980}, {6200,0.40746078}, {6250,0.40933333}, {6300,0.41655882}, {6350,0.40569608}, {6400,0.43661765}, {6450,0.42114706}, {6500,0.44134314}, {6550,0.41383333}, {6600,0.43297059}, {6650,0.46254902}, {6700,0.43695098}, {6750,0.44295098}, {6800,0.45272549}, {6850,0.45446078}, {6900,0.46993137}, {6950,0.46156863}, {7000,0.46623529}, {7050,0.46735294}, {7100,0.49042157}, {7150,0.47139216}, {7200,0.47194118}, {7250,0.47205882}, {7300,0.47593137}, {7350,0.48900980}, {7400,0.47618627}, {7450,0.48190196}, {7500,0.55300000}, {7550,0.49222549}, {7600,0.53342157}, {7650,0.50146078}, {7700,0.53509804}, {7750,0.50817647}, {7800,0.52457843}, {7850,0.54851961}, {7900,0.51680392}, {7950,0.52639216}, {8000,0.53009804}, {8050,0.53364706}, {8100,0.53796078}, {8150,0.57564706}, {8200,0.53650000}, {8250,0.54335294}, {8300,0.54468627}, {8350,0.55419608}, {8400,0.55427451}, {8450,0.55100000}, {8500,0.58051961}, {8550,0.56337255}, {8600,0.56636275}, {8650,0.59639216}, {8700,0.57123529}, {8750,0.60273529}, {8800,0.57922549}, {8850,0.61151961}, {8900,0.58286275}, {8950,0.59552941}, {9000,0.61755882}, {9050,0.59324510}, {9100,0.58898039}, {9150,0.64090196}, {9200,0.62168627}, {9250,0.64678431}, {9300,0.64317647}, {9350,0.64556863}, {9400,0.64562745}, {9450,0.64837255}, {9500,0.63556863}, {9550,0.63606863}, {9600,0.63969608}, {9650,0.63972549}, {9700,0.66640196}, {9750,0.64410784}, {9800,0.64899020}, {9850,0.65524510}, {9900,0.65427451}, {9950,0.65781373}, {10000,0.66007843}, {10100,0.66287255}, {10200,0.67172549}, {10300,0.67664706}, {10400,0.68639216}, {10500,0.68588235}, {10600,0.68970588}, {10700,0.69859804}, {10800,0.74909804}, {10900,0.71469608}, {11000,0.72788235}, {11100,0.77433333}, {11200,0.74157843}, {11300,0.75820588}, {11400,0.80488235}, {11500,0.77195098}, {11600,0.76282353}, {11700,0.77358824}, {11800,0.77685294}, {11900,0.82300980}, {12000,0.79730392}, {12100,0.80366667}, {12200,0.79903922}, {12300,0.81132353}, {12400,0.83865686}, {12500,0.83064706}, {12600,0.83612745}, {12700,0.83467647}, {12800,0.84807843}, {12900,0.85095098}, {13000,0.84574510}, {13100,0.85640196}, {13200,0.87816667}, {13300,0.94131373}, {13400,0.89851961}, {13500,0.92824510}, {13600,0.91194118}, {13700,0.90332353}, {13800,0.95522549}, {13900,0.94540196}, {14000,0.93313725}, {14100,0.99185294}, {14200,0.98854902}, {14300,0.94251961}, {14400,0.95079412}, {14500,0.96070588}, {14600,0.96362745}, {14700,0.97179412}, {14800,0.95933333}, {14900,0.99123529}, {15000,1.03428431}, {15100,1.05467647}, {15200,1.00870588}, {15300,1.05917647}, {15400,1.06404902}, {15500,1.02682353}, {15600,1.02374510}, {15700,1.07442157}, {15800,1.04196078}, {15900,1.10651961}, {16000,1.07099020}, {16100,1.05012745}, {16200,1.08177451}, {16300,1.10731373}, {16400,1.11586275}, {16500,1.11391176}, {16600,1.10779412}, {16700,1.12222549}, {16800,1.14342157}, {16900,1.13051961}, {17000,1.18408824}, {17100,1.14516667}, {17200,1.14800000}, {17300,1.18332353}, {17400,1.14290196}, {17500,1.15780392}, {17600,1.16065686}, {17700,1.16762745}, {17800,1.24324510}, {17900,1.18837255}, {18000,1.22532353}, {18100,1.25795098}, {18200,1.21042157}, {18300,1.23165686}, {18400,1.26880392}, {18500,1.22455882}, {18600,1.23341176}, {18700,1.23763725}, {18800,1.24386275}, {18900,1.25192157}, {19000,1.31689216}, {19100,1.28356863}, {19200,1.24820588}, {19300,1.36426471}, {19400,1.29687255}, {19500,1.31471569}, {19600,1.32363725}, {19700,1.30637255}, {19800,1.31689216}, {19900,1.31721569}, {20000,1.32044118}};
data["big"]["Ltac2LowLevel"]["reif"]["user"] = {{1,0.00030392}, {2,0.00039216}, {3,0.00013725}, {4,0.00032353}, {5,0.00059804}, {6,0.00046078}, {7,0.00055882}, {8,0.00070588}, {9,0.00050000}, {10,0.00082353}, {11,0.00082353}, {12,0.00084314}, {13,0.00078431}, {14,0.00092157}, {15,0.00071569}, {16,0.00146078}, {17,0.00074510}, {18,0.00148039}, {19,0.00147059}, {20,0.00093137}, {21,0.00158824}, {22,0.00138235}, {23,0.00134314}, {24,0.00175490}, {25,0.00157843}, {26,0.00111765}, {27,0.00150000}, {28,0.00182353}, {29,0.00202941}, {30,0.00160784}, {31,0.00159804}, {32,0.00186275}, {33,0.00189216}, {34,0.00213725}, {35,0.00218627}, {36,0.00201961}, {37,0.00216667}, {38,0.00218627}, {39,0.00236275}, {40,0.00231373}, {41,0.00233333}, {42,0.00240196}, {43,0.00248039}, {44,0.00261765}, {45,0.00278431}, {46,0.00262745}, {47,0.00245098}, {48,0.00302941}, {49,0.00282353}, {50,0.00290196}, {51,0.00279412}, {52,0.00306863}, {53,0.00298039}, {54,0.00312745}, {55,0.00306863}, {56,0.00304902}, {57,0.00324510}, {58,0.00332353}, {59,0.00427451}, {60,0.00359804}, {61,0.00352941}, {62,0.00382353}, {63,0.00358824}, {64,0.00364706}, {65,0.00376471}, {66,0.00387255}, {67,0.00372549}, {68,0.00397059}, {69,0.00391176}, {70,0.00407843}, {71,0.00407843}, {72,0.00416667}, {73,0.00419608}, {74,0.00424510}, {75,0.00421569}, {76,0.00419608}, {77,0.00433333}, {78,0.00461765}, {79,0.00422549}, {80,0.00434314}, {81,0.00474510}, {82,0.00483333}, {83,0.00443137}, {84,0.00465686}, {85,0.00475490}, {86,0.00511765}, {87,0.00588235}, {88,0.00502941}, {89,0.00489216}, {90,0.00490196}, {91,0.00490196}, {92,0.00492157}, {93,0.00521569}, {94,0.00533333}, {95,0.00515686}, {96,0.00546078}, {97,0.00560784}, {98,0.00571569}, {99,0.00636275}, {100,0.00580392}, {101,0.00583333}, {102,0.00582353}, {103,0.00596078}, {104,0.00590196}, {105,0.00576471}, {106,0.00577451}, {107,0.00609804}, {108,0.00611765}, {109,0.00695098}, {110,0.00647059}, {111,0.00643137}, {112,0.00584314}, {113,0.00625490}, {114,0.00650980}, {115,0.00663725}, {116,0.00629412}, {117,0.00671569}, {118,0.00674510}, {119,0.00685294}, {120,0.00672549}, {121,0.00680392}, {122,0.00674510}, {123,0.00682353}, {124,0.00707843}, {125,0.00700000}, {126,0.00723529}, {127,0.00903922}, {128,0.00722549}, {129,0.00739216}, {130,0.00730392}, {131,0.00764706}, {132,0.00749020}, {133,0.00744118}, {134,0.00749020}, {135,0.00755882}, {136,0.00763725}, {137,0.00750980}, {138,0.00776471}, {139,0.00791176}, {140,0.00795098}, {141,0.00784314}, {142,0.00800980}, {143,0.00957843}, {144,0.00833333}, {145,0.00840196}, {146,0.00816667}, {147,0.00815686}, {148,0.00857843}, {149,0.00879412}, {150,0.00865686}, {151,0.00964706}, {152,0.00869608}, {153,0.00851961}, {154,0.00879412}, {155,0.00887255}, {156,0.00910784}, {157,0.00897059}, {158,0.01030392}, {159,0.00916667}, {160,0.00917647}, {161,0.00937255}, {162,0.00996078}, {163,0.00981373}, {164,0.00937255}, {165,0.01059804}, {166,0.01001961}, {167,0.00963725}, {168,0.01007843}, {169,0.01016667}, {170,0.00974510}, {171,0.01134314}, {172,0.00991176}, {173,0.01020588}, {174,0.01046078}, {175,0.01052941}, {176,0.01042157}, {177,0.01066667}, {178,0.01174510}, {179,0.01098039}, {180,0.01075490}, {181,0.01100980}, {182,0.01098039}, {183,0.01091176}, {184,0.01202941}, {185,0.01142157}, {186,0.01095098}, {187,0.01107843}, {188,0.01121569}, {189,0.01140196}, {190,0.01238235}, {191,0.01132353}, {192,0.01168627}, {193,0.01170588}, {194,0.01153922}, {195,0.01193137}, {196,0.01168627}, {197,0.01202941}, {198,0.01187255}, {199,0.01198039}, {200,0.01214706}, {201,0.01410784}, {202,0.01203922}, {203,0.01227451}, {204,0.01252941}, {205,0.01233333}, {206,0.01255882}, {207,0.01308824}, {208,0.01244118}, {209,0.01263725}, {210,0.01282353}, {211,0.01260784}, {212,0.01426471}, {213,0.01306863}, {214,0.01247059}, {215,0.01266667}, {216,0.01312745}, {217,0.01482353}, {218,0.01312745}, {219,0.01313725}, {220,0.01302941}, {221,0.01331373}, {222,0.01456863}, {223,0.01279412}, {224,0.01359804}, {225,0.01390196}, {226,0.01305882}, {227,0.01508824}, {228,0.01344118}, {229,0.01353922}, {230,0.01395098}, {231,0.01358824}, {232,0.01596078}, {233,0.01366667}, {234,0.01391176}, {235,0.01368627}, {236,0.01426471}, {237,0.01552941}, {238,0.01448039}, {239,0.01422549}, {240,0.01428431}, {241,0.01450000}, {242,0.01523529}, {243,0.01449020}, {244,0.01437255}, {245,0.01475490}, {246,0.01597059}, {247,0.01461765}, {248,0.01478431}, {249,0.01483333}, {250,0.01482353}, {251,0.01577451}, {252,0.01500000}, {253,0.01488235}, {254,0.01517647}, {255,0.01671569}, {256,0.01524510}, {257,0.01531373}, {258,0.01524510}, {259,0.01555882}, {260,0.01602941}, {261,0.01521569}, {262,0.01552941}, {263,0.01551961}, {264,0.01740196}, {265,0.01576471}, {266,0.01543137}, {267,0.01570588}, {268,0.01787255}, {269,0.01571569}, {270,0.01595098}, {271,0.01603922}, {272,0.01606863}, {273,0.01604902}, {274,0.01619608}, {275,0.01624510}, {276,0.01616667}, {277,0.01632353}, {278,0.01631373}, {279,0.01647059}, {280,0.01615686}, {281,0.01660784}, {282,0.01644118}, {283,0.01631373}, {284,0.01694118}, {285,0.01672549}, {286,0.01649020}, {287,0.01706863}, {288,0.01713725}, {289,0.01683333}, {290,0.01714706}, {291,0.01700980}, {292,0.01711765}, {293,0.01694118}, {294,0.01718627}, {295,0.01749020}, {296,0.01930392}, {297,0.01717647}, {298,0.01763725}, {299,0.01746078}, {300,0.01963725}, {301,0.01723529}, {302,0.01761765}, {303,0.01774510}, {304,0.01905882}, {305,0.01772549}, {306,0.01768627}, {307,0.01796078}, {308,0.01775490}, {309,0.01808824}, {310,0.01819608}, {311,0.02106863}, {312,0.01823529}, {313,0.01853922}, {314,0.01837255}, {315,0.01968627}, {316,0.01851961}, {317,0.01805882}, {318,0.01849020}, {319,0.01883333}, {320,0.01849020}, {321,0.01862745}, {322,0.02081373}, {323,0.01886275}, {324,0.01894118}, {325,0.01892157}, {326,0.01926471}, {327,0.01902941}, {328,0.01925490}, {329,0.02132353}, {330,0.01909804}, {331,0.01903922}, {332,0.01900980}, {333,0.01937255}, {334,0.01951961}, {335,0.01952941}, {336,0.02097059}, {337,0.01977451}, {338,0.01978431}, {339,0.02262745}, {340,0.01975490}, {341,0.01974510}, {342,0.01992157}, {343,0.01992157}, {344,0.02031373}, {345,0.02004902}, {346,0.02195098}, {347,0.02033333}, {348,0.02017647}, {349,0.02346078}, {350,0.02042157}, {351,0.02048039}, {352,0.02194118}, {353,0.02051961}, {354,0.02050000}, {355,0.02071569}, {356,0.02069608}, {357,0.02113725}, {358,0.02096078}, {359,0.02246078}, {360,0.02124510}, {361,0.02072549}, {362,0.02345098}, {363,0.02086275}, {364,0.02157843}, {365,0.02448039}, {366,0.02158824}, {367,0.02155882}, {368,0.02501961}, {369,0.02197059}, {370,0.02194118}, {371,0.02500000}, {372,0.02214706}, {373,0.02228431}, {374,0.02424510}, {375,0.02162745}, {376,0.02191176}, {377,0.02380392}, {378,0.02147059}, {379,0.02224510}, {380,0.02341176}, {381,0.02191176}, {382,0.02275490}, {383,0.02405882}, {384,0.02275490}, {385,0.02281373}, {386,0.02477451}, {387,0.02244118}, {388,0.02302941}, {389,0.02600000}, {390,0.02283333}, {391,0.02293137}, {392,0.02672549}, {393,0.02370588}, {394,0.02370588}, {395,0.02625490}, {396,0.02367647}, {397,0.02374510}, {398,0.02587255}, {399,0.02367647}, {400,0.02373529}, {401,0.02555882}, {402,0.02384314}, {403,0.02377451}, {404,0.02517647}, {405,0.02398039}, {406,0.02425490}, {407,0.02414706}, {408,0.02418627}, {409,0.02667647}, {410,0.02435294}, {411,0.02445098}, {412,0.02733333}, {413,0.02455882}, {414,0.02475490}, {415,0.02658824}, {416,0.02485294}, {417,0.02493137}, {418,0.02544118}, {419,0.02493137}, {420,0.02672549}, {421,0.02494118}, {422,0.02507843}, {423,0.02789216}, {424,0.02546078}, {425,0.02570588}, {426,0.02647059}, {427,0.02533333}, {428,0.02548039}, {429,0.02548039}, {430,0.02563725}, {431,0.02860784}, {432,0.02556863}, {433,0.02591176}, {434,0.02712745}, {435,0.02563725}, {436,0.02738235}, {437,0.02594118}, {438,0.02598039}, {439,0.02881373}, {440,0.02610784}, {441,0.02627451}, {442,0.02689216}, {443,0.02633333}, {444,0.02953922}, {445,0.02645098}, {446,0.02646078}, {447,0.02776471}, {448,0.02662745}, {449,0.02900000}, {450,0.02649020}, {451,0.02653922}, {452,0.02823529}, {453,0.02667647}, {454,0.02839216}, {455,0.02682353}, {456,0.02693137}, {457,0.02894118}, {458,0.02695098}, {459,0.02697059}, {460,0.02704902}, {461,0.02675490}, {462,0.02944118}, {463,0.02707843}, {464,0.02856863}, {465,0.02750980}, {466,0.02752941}, {467,0.02975490}, {468,0.02751961}, {469,0.03054902}, {470,0.02765686}, {471,0.02789216}, {472,0.02890196}, {473,0.02764706}, {474,0.03140196}, {475,0.02779412}, {476,0.02777451}, {477,0.02802941}, {478,0.02794118}, {479,0.03077451}, {480,0.02826471}, {481,0.02971569}, {482,0.02800000}, {483,0.02834314}, {484,0.03012745}, {485,0.02829412}, {486,0.03184314}, {487,0.02831373}, {488,0.02827451}, {489,0.02898039}, {490,0.02889216}, {491,0.03057843}, {492,0.02856863}, {493,0.03281373}, {494,0.02889216}, {495,0.02896078}, {496,0.02947059}, {497,0.02921569}, {498,0.03105882}, {499,0.02940196}, {500,0.03320588}, {505,0.02973529}, {510,0.03142157}, {515,0.02998039}, {520,0.03044118}, {525,0.03117647}, {530,0.03075490}, {535,0.03317647}, {540,0.03151961}, {545,0.03486275}, {550,0.03223529}, {555,0.03614706}, {560,0.03275490}, {565,0.03718627}, {570,0.03374510}, {575,0.03766667}, {580,0.03461765}, {585,0.03812745}, {590,0.03508824}, {595,0.03876471}, {600,0.03558824}, {605,0.03862745}, {610,0.03622549}, {615,0.03860784}, {620,0.03684314}, {625,0.03797059}, {630,0.03744118}, {635,0.03729412}, {640,0.04103922}, {645,0.03785294}, {650,0.04307843}, {655,0.03852941}, {660,0.04157843}, {665,0.03909804}, {670,0.04033333}, {675,0.04250980}, {680,0.03970588}, {685,0.04431373}, {690,0.04047059}, {695,0.04259804}, {700,0.04337255}, {705,0.04082353}, {710,0.04638235}, {715,0.04167647}, {720,0.04306863}, {725,0.04885294}, {730,0.04290196}, {735,0.04601961}, {740,0.04558824}, {745,0.04330392}, {750,0.04999020}, {755,0.04402941}, {760,0.04443137}, {765,0.04945098}, {770,0.04500980}, {775,0.04510784}, {780,0.05022549}, {785,0.04638235}, {790,0.04639216}, {795,0.05084314}, {800,0.04987255}, {805,0.04726471}, {810,0.05077451}, {815,0.05431373}, {820,0.04838235}, {825,0.04998039}, {830,0.05357843}, {835,0.04924510}, {840,0.04938235}, {845,0.05259804}, {850,0.05560784}, {855,0.05022549}, {860,0.05033333}, {865,0.05477451}, {870,0.05765686}, {875,0.05137255}, {880,0.05131373}, {885,0.05518627}, {890,0.05852941}, {895,0.05231373}, {900,0.05245098}, {905,0.05566667}, {910,0.05827451}, {915,0.06014706}, {920,0.05396078}, {925,0.05377451}, {930,0.05783333}, {935,0.06047059}, {940,0.06181373}, {945,0.05495098}, {950,0.05521569}, {955,0.05857843}, {960,0.06075490}, {965,0.06269608}, {970,0.06080392}, {975,0.05722549}, {980,0.05719608}, {985,0.06029412}, {990,0.06214706}, {995,0.06337255}, {1000,0.07031373}, {1010,0.06329412}, {1020,0.05995098}, {1030,0.06076471}, {1040,0.06435294}, {1050,0.06566667}, {1060,0.06786275}, {1070,0.07055882}, {1080,0.07183333}, {1090,0.07404902}, {1100,0.07548039}, {1110,0.07669608}, {1120,0.07851961}, {1130,0.07731373}, {1140,0.07522549}, {1150,0.07666667}, {1160,0.07495098}, {1170,0.07561765}, {1180,0.07711765}, {1190,0.07900000}, {1200,0.07938235}, {1210,0.07942157}, {1220,0.07966667}, {1230,0.08030392}, {1240,0.08013725}, {1250,0.07940196}, {1260,0.07898039}, {1270,0.07874510}, {1280,0.07837255}, {1290,0.07750980}, {1300,0.07569608}, {1310,0.08278431}, {1320,0.08727451}, {1330,0.08619608}, {1340,0.08515686}, {1350,0.08375490}, {1360,0.08276471}, {1370,0.08258824}, {1380,0.09268627}, {1390,0.08934314}, {1400,0.08789216}, {1410,0.08793137}, {1420,0.08721569}, {1430,0.09909804}, {1440,0.09379412}, {1450,0.08974510}, {1460,0.09129412}, {1470,0.09730392}, {1480,0.09438235}, {1490,0.09147059}, {1500,0.09677451}, {1510,0.09901961}, {1520,0.09487255}, {1530,0.09607843}, {1540,0.10364706}, {1550,0.09892157}, {1560,0.09669608}, {1570,0.10277451}, {1580,0.10085294}, {1590,0.09767647}, {1600,0.10296078}, {1610,0.09989216}, {1620,0.10583333}, {1630,0.10378431}, {1640,0.10151961}, {1650,0.10860784}, {1660,0.10228431}, {1670,0.11080392}, {1680,0.10530392}, {1690,0.10954902}, {1700,0.10780392}, {1710,0.10723529}, {1720,0.11099020}, {1730,0.10657843}, {1740,0.11381373}, {1750,0.10843137}, {1760,0.11200980}, {1770,0.10960784}, {1780,0.11319608}, {1790,0.11366667}, {1800,0.11394118}, {1810,0.11947059}, {1820,0.11356863}, {1830,0.11873529}, {1840,0.11366667}, {1850,0.11893137}, {1860,0.11783333}, {1870,0.12056863}, {1880,0.12123529}, {1890,0.11699020}, {1900,0.12200000}, {1910,0.12642157}, {1920,0.12001961}, {1930,0.12589216}, {1940,0.12653922}, {1950,0.12310784}, {1960,0.12687255}, {1970,0.12981373}, {1980,0.12316667}, {1990,0.12712745}, {2000,0.13073529}, {2050,0.12760784}, {2100,0.13178431}, {2150,0.13750980}, {2200,0.14088235}, {2250,0.14547059}, {2300,0.14905882}, {2350,0.15241176}, {2400,0.15529412}, {2450,0.15750980}, {2500,0.15841176}, {2550,0.16875490}, {2600,0.16721569}, {2650,0.17360784}, {2700,0.17295098}, {2750,0.17560784}, {2800,0.18046078}, {2850,0.18002941}, {2900,0.18993137}, {2950,0.18634314}, {3000,0.19648039}, {3050,0.19216667}, {3100,0.19861765}, {3150,0.20564706}, {3200,0.20176471}, {3250,0.21258824}, {3300,0.21287255}, {3350,0.21796078}, {3400,0.22381373}, {3450,0.22830392}, {3500,0.22945098}, {3550,0.23173529}, {3600,0.23644118}, {3650,0.23773529}, {3700,0.24032353}, {3750,0.24224510}, {3800,0.24667647}, {3850,0.25332353}, {3900,0.26588235}, {3950,0.25713725}, {4000,0.26270588}, {4050,0.26295098}, {4100,0.26975490}, {4150,0.26895098}, {4200,0.27581373}, {4250,0.28190196}, {4300,0.27784314}, {4350,0.28597059}, {4400,0.29141176}, {4450,0.28896078}, {4500,0.28987255}, {4550,0.29634314}, {4600,0.30082353}, {4650,0.30485294}, {4700,0.30821569}, {4750,0.31108824}, {4800,0.31337255}, {4850,0.31411765}, {4900,0.32563725}, {4950,0.33077451}, {5000,0.33020588}, {5050,0.32784314}, {5100,0.33378431}, {5150,0.34236275}, {5200,0.35727451}, {5250,0.35377451}, {5300,0.35062745}, {5350,0.35189216}, {5400,0.35699020}, {5450,0.36383333}, {5500,0.36290196}, {5550,0.36972549}, {5600,0.37787255}, {5650,0.37083333}, {5700,0.37512745}, {5750,0.37761765}, {5800,0.38098039}, {5850,0.38160784}, {5900,0.38309804}, {5950,0.38832353}, {6000,0.39062745}, {6050,0.39488235}, {6100,0.40589216}, {6150,0.41207843}, {6200,0.40665686}, {6250,0.40858824}, {6300,0.41618627}, {6350,0.40528431}, {6400,0.43573529}, {6450,0.42051961}, {6500,0.44036275}, {6550,0.41310784}, {6600,0.43257843}, {6650,0.46179412}, {6700,0.43617647}, {6750,0.44226471}, {6800,0.45212745}, {6850,0.45352941}, {6900,0.46898039}, {6950,0.46071569}, {7000,0.46548039}, {7050,0.46631373}, {7100,0.48973529}, {7150,0.47050980}, {7200,0.47114706}, {7250,0.47139216}, {7300,0.47504902}, {7350,0.48823529}, {7400,0.47551961}, {7450,0.48108824}, {7500,0.55243137}, {7550,0.49144118}, {7600,0.53283333}, {7650,0.50069608}, {7700,0.53422549}, {7750,0.50762745}, {7800,0.52421569}, {7850,0.54782353}, {7900,0.51613725}, {7950,0.52568627}, {8000,0.52978431}, {8050,0.53338235}, {8100,0.53741176}, {8150,0.57455882}, {8200,0.53312745}, {8250,0.54119608}, {8300,0.54199020}, {8350,0.55150000}, {8400,0.55168627}, {8450,0.54839216}, {8500,0.57748039}, {8550,0.56108824}, {8600,0.56423529}, {8650,0.59343137}, {8700,0.56939216}, {8750,0.59955882}, {8800,0.57693137}, {8850,0.61069608}, {8900,0.58199020}, {8950,0.59484314}, {9000,0.61701961}, {9050,0.59219608}, {9100,0.58808824}, {9150,0.64024510}, {9200,0.62055882}, {9250,0.64595098}, {9300,0.64233333}, {9350,0.64465686}, {9400,0.64500980}, {9450,0.64728431}, {9500,0.63449020}, {9550,0.63485294}, {9600,0.63862745}, {9650,0.63887255}, {9700,0.66570588}, {9750,0.64351961}, {9800,0.64812745}, {9850,0.65439216}, {9900,0.65332353}, {9950,0.65683333}, {10000,0.65930392}, {10100,0.66175490}, {10200,0.67072549}, {10300,0.67540196}, {10400,0.68552941}, {10500,0.68452941}, {10600,0.68879412}, {10700,0.69741176}, {10800,0.74803922}, {10900,0.71381373}, {11000,0.72657843}, {11100,0.77322549}, {11200,0.74050000}, {11300,0.75705882}, {11400,0.80349020}, {11500,0.77074510}, {11600,0.76166667}, {11700,0.77238235}, {11800,0.77604902}, {11900,0.82200000}, {12000,0.79595098}, {12100,0.80229412}, {12200,0.79768627}, {12300,0.80997059}, {12400,0.83740196}, {12500,0.82950000}, {12600,0.83487255}, {12700,0.83331373}, {12800,0.84691176}, {12900,0.85000980}, {13000,0.84461765}, {13100,0.85508824}, {13200,0.87696078}, {13300,0.93964706}, {13400,0.89741176}, {13500,0.92667647}, {13600,0.91083333}, {13700,0.90188235}, {13800,0.95375490}, {13900,0.94392157}, {14000,0.93195098}, {14100,0.99012745}, {14200,0.98719608}, {14300,0.94120588}, {14400,0.94934314}, {14500,0.95908824}, {14600,0.96206863}, {14700,0.97050980}, {14800,0.95801961}, {14900,0.98996078}, {15000,1.03282353}, {15100,1.05342157}, {15200,1.00735294}, {15300,1.05778431}, {15400,1.06234314}, {15500,1.02570588}, {15600,1.02224510}, {15700,1.07309804}, {15800,1.04059804}, {15900,1.10517647}, {16000,1.06946078}, {16100,1.04848039}, {16200,1.08007843}, {16300,1.10554902}, {16400,1.11456863}, {16500,1.11231373}, {16600,1.10640196}, {16700,1.12064706}, {16800,1.14183333}, {16900,1.12916667}, {17000,1.18230392}, {17100,1.14403922}, {17200,1.14694118}, {17300,1.18172549}, {17400,1.14210784}, {17500,1.15611765}, {17600,1.15888235}, {17700,1.16638235}, {17800,1.24148039}, {17900,1.18703922}, {18000,1.22401961}, {18100,1.25640196}, {18200,1.20929412}, {18300,1.23037255}, {18400,1.26730392}, {18500,1.22313725}, {18600,1.23205882}, {18700,1.23636275}, {18800,1.24205882}, {18900,1.25041176}, {19000,1.31554902}, {19100,1.28192157}, {19200,1.24691176}, {19300,1.36227451}, {19400,1.29521569}, {19500,1.31344118}, {19600,1.32163725}, {19700,1.30496078}, {19800,1.31555882}, {19900,1.31558824}, {20000,1.31872549}};
data["big"]["Ltac2LowLevel"]["reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003922}, {13,0.00000000}, {14,0.00007843}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00003922}, {22,0.00000000}, {23,0.00000000}, {24,0.00003922}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00006863}, {29,0.00003922}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00007843}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00003922}, {39,0.00000000}, {40,0.00000000}, {41,0.00003922}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00003922}, {46,0.00000000}, {47,0.00000000}, {48,0.00003922}, {49,0.00000000}, {50,0.00000000}, {51,0.00007843}, {52,0.00000000}, {53,0.00003922}, {54,0.00000000}, {55,0.00003922}, {56,0.00000000}, {57,0.00000000}, {58,0.00003922}, {59,0.00007843}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00003922}, {64,0.00003922}, {65,0.00007843}, {66,0.00003922}, {67,0.00000000}, {68,0.00007843}, {69,0.00003922}, {70,0.00006863}, {71,0.00000000}, {72,0.00000000}, {73,0.00003922}, {74,0.00000000}, {75,0.00000000}, {76,0.00007843}, {77,0.00000000}, {78,0.00000000}, {79,0.00011765}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00003922}, {85,0.00000000}, {86,0.00003922}, {87,0.00000000}, {88,0.00003922}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00003922}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00003922}, {97,0.00003922}, {98,0.00000000}, {99,0.00003922}, {100,0.00003922}, {101,0.00000000}, {102,0.00003922}, {103,0.00007843}, {104,0.00000000}, {105,0.00003922}, {106,0.00003922}, {107,0.00000000}, {108,0.00002941}, {109,0.00000000}, {110,0.00003922}, {111,0.00002941}, {112,0.00007843}, {113,0.00003922}, {114,0.00000000}, {115,0.00000000}, {116,0.00003922}, {117,0.00003922}, {118,0.00000000}, {119,0.00003922}, {120,0.00007843}, {121,0.00000000}, {122,0.00007843}, {123,0.00000000}, {124,0.00003922}, {125,0.00000000}, {126,0.00003922}, {127,0.00000000}, {128,0.00000000}, {129,0.00007843}, {130,0.00000000}, {131,0.00000000}, {132,0.00003922}, {133,0.00000000}, {134,0.00002941}, {135,0.00000000}, {136,0.00000000}, {137,0.00003922}, {138,0.00000000}, {139,0.00000000}, {140,0.00003922}, {141,0.00006863}, {142,0.00000000}, {143,0.00000000}, {144,0.00003922}, {145,0.00000000}, {146,0.00007843}, {147,0.00003922}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00002941}, {156,0.00007843}, {157,0.00003922}, {158,0.00000000}, {159,0.00000000}, {160,0.00007843}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00003922}, {165,0.00000000}, {166,0.00003922}, {167,0.00007843}, {168,0.00003922}, {169,0.00003922}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00003922}, {174,0.00003922}, {175,0.00000000}, {176,0.00000000}, {177,0.00003922}, {178,0.00000000}, {179,0.00003922}, {180,0.00003922}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00003922}, {185,0.00000000}, {186,0.00003922}, {187,0.00003922}, {188,0.00003922}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00003922}, {193,0.00003922}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00003922}, {200,0.00003922}, {201,0.00003922}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00007843}, {206,0.00003922}, {207,0.00000000}, {208,0.00003922}, {209,0.00003922}, {210,0.00000000}, {211,0.00003922}, {212,0.00000000}, {213,0.00000000}, {214,0.00003922}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00003922}, {219,0.00003922}, {220,0.00007843}, {221,0.00003922}, {222,0.00000000}, {223,0.00000000}, {224,0.00003922}, {225,0.00000000}, {226,0.00000000}, {227,0.00003922}, {228,0.00000000}, {229,0.00003922}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00003922}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00002941}, {240,0.00000000}, {241,0.00003922}, {242,0.00000000}, {243,0.00000000}, {244,0.00003922}, {245,0.00007843}, {246,0.00000000}, {247,0.00003922}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00007843}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00007843}, {259,0.00000000}, {260,0.00003922}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003922}, {266,0.00000000}, {267,0.00003922}, {268,0.00000000}, {269,0.00003922}, {270,0.00003922}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00010784}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003922}, {282,0.00003922}, {283,0.00007843}, {284,0.00003922}, {285,0.00000000}, {286,0.00003922}, {287,0.00000000}, {288,0.00003922}, {289,0.00000000}, {290,0.00000000}, {291,0.00007843}, {292,0.00000000}, {293,0.00007843}, {294,0.00000000}, {295,0.00000000}, {296,0.00003922}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00003922}, {302,0.00003922}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00003922}, {311,0.00003922}, {312,0.00011765}, {313,0.00000000}, {314,0.00000000}, {315,0.00003922}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00003922}, {321,0.00003922}, {322,0.00007843}, {323,0.00003922}, {324,0.00000000}, {325,0.00007843}, {326,0.00000000}, {327,0.00003922}, {328,0.00007843}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00003922}, {335,0.00000000}, {336,0.00006863}, {337,0.00000000}, {338,0.00003922}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00003922}, {343,0.00003922}, {344,0.00003922}, {345,0.00000000}, {346,0.00011765}, {347,0.00003922}, {348,0.00000000}, {349,0.00000000}, {350,0.00007843}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00003922}, {356,0.00000000}, {357,0.00000000}, {358,0.00007843}, {359,0.00007843}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00002941}, {367,0.00000000}, {368,0.00003922}, {369,0.00003922}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00003922}, {377,0.00002941}, {378,0.00007843}, {379,0.00000000}, {380,0.00000000}, {381,0.00003922}, {382,0.00000000}, {383,0.00011765}, {384,0.00000000}, {385,0.00003922}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00003922}, {391,0.00000000}, {392,0.00003922}, {393,0.00003922}, {394,0.00003922}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00003922}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00003922}, {405,0.00003922}, {406,0.00003922}, {407,0.00000000}, {408,0.00000000}, {409,0.00007843}, {410,0.00003922}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00002941}, {417,0.00003922}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00003922}, {435,0.00003922}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00003922}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00003922}, {446,0.00000000}, {447,0.00000000}, {448,0.00003922}, {449,0.00000000}, {450,0.00000000}, {451,0.00003922}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00002941}, {456,0.00000000}, {457,0.00003922}, {458,0.00000000}, {459,0.00006863}, {460,0.00000000}, {461,0.00007843}, {462,0.00000000}, {463,0.00000000}, {464,0.00003922}, {465,0.00000000}, {466,0.00003922}, {467,0.00002941}, {468,0.00003922}, {469,0.00003922}, {470,0.00003922}, {471,0.00000000}, {472,0.00003922}, {473,0.00002941}, {474,0.00003922}, {475,0.00003922}, {476,0.00003922}, {477,0.00000000}, {478,0.00000000}, {479,0.00003922}, {480,0.00003922}, {481,0.00000000}, {482,0.00007843}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00003922}, {487,0.00003922}, {488,0.00007843}, {489,0.00000000}, {490,0.00003922}, {491,0.00000000}, {492,0.00000000}, {493,0.00003922}, {494,0.00003922}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00003922}, {510,0.00000000}, {515,0.00003922}, {520,0.00000000}, {525,0.00002941}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00003922}, {550,0.00000000}, {555,0.00003922}, {560,0.00003922}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00003922}, {585,0.00007843}, {590,0.00003922}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00003922}, {620,0.00000000}, {625,0.00007843}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00003922}, {670,0.00006863}, {675,0.00003922}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00011765}, {700,0.00000000}, {705,0.00000000}, {710,0.00003922}, {715,0.00003922}, {720,0.00000000}, {725,0.00003922}, {730,0.00003922}, {735,0.00000000}, {740,0.00003922}, {745,0.00000000}, {750,0.00015686}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00003922}, {775,0.00003922}, {780,0.00011765}, {785,0.00000000}, {790,0.00003922}, {795,0.00007843}, {800,0.00003922}, {805,0.00003922}, {810,0.00003922}, {815,0.00022549}, {820,0.00003922}, {825,0.00007843}, {830,0.00007843}, {835,0.00000000}, {840,0.00000000}, {845,0.00011765}, {850,0.00027451}, {855,0.00000000}, {860,0.00000000}, {865,0.00014706}, {870,0.00027451}, {875,0.00000000}, {880,0.00000000}, {885,0.00006863}, {890,0.00031373}, {895,0.00000000}, {900,0.00000000}, {905,0.00015686}, {910,0.00031373}, {915,0.00023529}, {920,0.00003922}, {925,0.00003922}, {930,0.00002941}, {935,0.00006863}, {940,0.00035294}, {945,0.00000000}, {950,0.00000000}, {955,0.00003922}, {960,0.00015686}, {965,0.00030392}, {970,0.00007843}, {975,0.00000000}, {980,0.00003922}, {985,0.00000000}, {990,0.00019608}, {995,0.00011765}, {1000,0.00019608}, {1010,0.00003922}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00015686}, {1050,0.00015686}, {1060,0.00015686}, {1070,0.00022549}, {1080,0.00011765}, {1090,0.00019608}, {1100,0.00023529}, {1110,0.00025490}, {1120,0.00015686}, {1130,0.00031373}, {1140,0.00047059}, {1150,0.00010784}, {1160,0.00011765}, {1170,0.00045098}, {1180,0.00023529}, {1190,0.00019608}, {1200,0.00027451}, {1210,0.00023529}, {1220,0.00039216}, {1230,0.00014706}, {1240,0.00015686}, {1250,0.00023529}, {1260,0.00022549}, {1270,0.00007843}, {1280,0.00007843}, {1290,0.00011765}, {1300,0.00003922}, {1310,0.00015686}, {1320,0.00022549}, {1330,0.00038235}, {1340,0.00011765}, {1350,0.00019608}, {1360,0.00014706}, {1370,0.00002941}, {1380,0.00039216}, {1390,0.00035294}, {1400,0.00035294}, {1410,0.00010784}, {1420,0.00007843}, {1430,0.00019608}, {1440,0.00015686}, {1450,0.00015686}, {1460,0.00011765}, {1470,0.00049020}, {1480,0.00017647}, {1490,0.00015686}, {1500,0.00023529}, {1510,0.00038235}, {1520,0.00019608}, {1530,0.00023529}, {1540,0.00018627}, {1550,0.00015686}, {1560,0.00038235}, {1570,0.00062745}, {1580,0.00022549}, {1590,0.00026471}, {1600,0.00050000}, {1610,0.00027451}, {1620,0.00060784}, {1630,0.00023529}, {1640,0.00022549}, {1650,0.00026471}, {1660,0.00019608}, {1670,0.00053922}, {1680,0.00027451}, {1690,0.00021569}, {1700,0.00026471}, {1710,0.00011765}, {1720,0.00035294}, {1730,0.00019608}, {1740,0.00019608}, {1750,0.00011765}, {1760,0.00050980}, {1770,0.00023529}, {1780,0.00039216}, {1790,0.00054902}, {1800,0.00035294}, {1810,0.00018627}, {1820,0.00031373}, {1830,0.00028431}, {1840,0.00000000}, {1850,0.00019608}, {1860,0.00046078}, {1870,0.00062745}, {1880,0.00046078}, {1890,0.00018627}, {1900,0.00039216}, {1910,0.00058824}, {1920,0.00018627}, {1930,0.00035294}, {1940,0.00035294}, {1950,0.00027451}, {1960,0.00031373}, {1970,0.00030392}, {1980,0.00027451}, {1990,0.00022549}, {2000,0.00035294}, {2050,0.00029412}, {2100,0.00030392}, {2150,0.00031373}, {2200,0.00052941}, {2250,0.00051961}, {2300,0.00039216}, {2350,0.00046078}, {2400,0.00050980}, {2450,0.00046078}, {2500,0.00031373}, {2550,0.00066667}, {2600,0.00039216}, {2650,0.00035294}, {2700,0.00043137}, {2750,0.00038235}, {2800,0.00070588}, {2850,0.00043137}, {2900,0.00080392}, {2950,0.00058824}, {3000,0.00050980}, {3050,0.00042157}, {3100,0.00057843}, {3150,0.00074510}, {3200,0.00046078}, {3250,0.00108824}, {3300,0.00094118}, {3350,0.00078431}, {3400,0.00088235}, {3450,0.00077451}, {3500,0.00041176}, {3550,0.00069608}, {3600,0.00109804}, {3650,0.00100000}, {3700,0.00096078}, {3750,0.00072549}, {3800,0.00035294}, {3850,0.00007843}, {3900,0.00007843}, {3950,0.00011765}, {4000,0.00007843}, {4050,0.00007843}, {4100,0.00007843}, {4150,0.00006863}, {4200,0.00000000}, {4250,0.00002941}, {4300,0.00015686}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00007843}, {4500,0.00011765}, {4550,0.00015686}, {4600,0.00015686}, {4650,0.00022549}, {4700,0.00003922}, {4750,0.00003922}, {4800,0.00003922}, {4850,0.00000000}, {4900,0.00015686}, {4950,0.00011765}, {5000,0.00003922}, {5050,0.00011765}, {5100,0.00007843}, {5150,0.00011765}, {5200,0.00007843}, {5250,0.00019608}, {5300,0.00003922}, {5350,0.00003922}, {5400,0.00019608}, {5450,0.00018627}, {5500,0.00015686}, {5550,0.00015686}, {5600,0.00011765}, {5650,0.00007843}, {5700,0.00011765}, {5750,0.00007843}, {5800,0.00007843}, {5850,0.00011765}, {5900,0.00000000}, {5950,0.00015686}, {6000,0.00003922}, {6050,0.00003922}, {6100,0.00007843}, {6150,0.00007843}, {6200,0.00007843}, {6250,0.00000000}, {6300,0.00002941}, {6350,0.00000000}, {6400,0.00011765}, {6450,0.00011765}, {6500,0.00003922}, {6550,0.00000000}, {6600,0.00003922}, {6650,0.00007843}, {6700,0.00011765}, {6750,0.00000000}, {6800,0.00011765}, {6850,0.00003922}, {6900,0.00003922}, {6950,0.00003922}, {7000,0.00002941}, {7050,0.00015686}, {7100,0.00000000}, {7150,0.00003922}, {7200,0.00000000}, {7250,0.00007843}, {7300,0.00003922}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00007843}, {7500,0.00007843}, {7550,0.00003922}, {7600,0.00011765}, {7650,0.00011765}, {7700,0.00011765}, {7750,0.00000000}, {7800,0.00015686}, {7850,0.00003922}, {7900,0.00003922}, {7950,0.00007843}, {8000,0.00003922}, {8050,0.00007843}, {8100,0.00019608}, {8150,0.00066667}, {8200,0.00237255}, {8250,0.00162745}, {8300,0.00202941}, {8350,0.00187255}, {8400,0.00178431}, {8450,0.00213725}, {8500,0.00259804}, {8550,0.00175490}, {8600,0.00150980}, {8650,0.00246078}, {8700,0.00140196}, {8750,0.00245098}, {8800,0.00152941}, {8850,0.00007843}, {8900,0.00007843}, {8950,0.00003922}, {9000,0.00000000}, {9050,0.00011765}, {9100,0.00007843}, {9150,0.00010784}, {9200,0.00019608}, {9250,0.00000000}, {9300,0.00003922}, {9350,0.00007843}, {9400,0.00000000}, {9450,0.00011765}, {9500,0.00022549}, {9550,0.00015686}, {9600,0.00018627}, {9650,0.00011765}, {9700,0.00019608}, {9750,0.00000000}, {9800,0.00015686}, {9850,0.00007843}, {9900,0.00006863}, {9950,0.00007843}, {10000,0.00000000}, {10100,0.00003922}, {10200,0.00007843}, {10300,0.00010784}, {10400,0.00007843}, {10500,0.00015686}, {10600,0.00010784}, {10700,0.00019608}, {10800,0.00007843}, {10900,0.00000000}, {11000,0.00023529}, {11100,0.00003922}, {11200,0.00007843}, {11300,0.00019608}, {11400,0.00007843}, {11500,0.00003922}, {11600,0.00015686}, {11700,0.00015686}, {11800,0.00000000}, {11900,0.00003922}, {12000,0.00015686}, {12100,0.00015686}, {12200,0.00014706}, {12300,0.00011765}, {12400,0.00003922}, {12500,0.00007843}, {12600,0.00007843}, {12700,0.00011765}, {12800,0.00007843}, {12900,0.00007843}, {13000,0.00000000}, {13100,0.00015686}, {13200,0.00007843}, {13300,0.00015686}, {13400,0.00007843}, {13500,0.00003922}, {13600,0.00007843}, {13700,0.00010784}, {13800,0.00011765}, {13900,0.00015686}, {14000,0.00019608}, {14100,0.00023529}, {14200,0.00002941}, {14300,0.00015686}, {14400,0.00007843}, {14500,0.00015686}, {14600,0.00011765}, {14700,0.00003922}, {14800,0.00007843}, {14900,0.00015686}, {15000,0.00011765}, {15100,0.00000000}, {15200,0.00015686}, {15300,0.00006863}, {15400,0.00011765}, {15500,0.00007843}, {15600,0.00023529}, {15700,0.00007843}, {15800,0.00010784}, {15900,0.00003922}, {16000,0.00019608}, {16100,0.00011765}, {16200,0.00015686}, {16300,0.00000000}, {16400,0.00019608}, {16500,0.00003922}, {16600,0.00006863}, {16700,0.00015686}, {16800,0.00015686}, {16900,0.00000000}, {17000,0.00011765}, {17100,0.00003922}, {17200,0.00011765}, {17300,0.00015686}, {17400,0.00011765}, {17500,0.00007843}, {17600,0.00015686}, {17700,0.00007843}, {17800,0.00026471}, {17900,0.00007843}, {18000,0.00007843}, {18100,0.00007843}, {18200,0.00007843}, {18300,0.00018627}, {18400,0.00015686}, {18500,0.00003922}, {18600,0.00007843}, {18700,0.00011765}, {18800,0.00019608}, {18900,0.00011765}, {19000,0.00003922}, {19100,0.00011765}, {19200,0.00011765}, {19300,0.00011765}, {19400,0.00015686}, {19500,0.00011765}, {19600,0.00027451}, {19700,0.00002941}, {19800,0.00000000}, {19900,0.00010784}, {20000,0.00015686}};
data["big"]["LtacPrimUncurry"]["Aggregate"]["real"] = {{1,0.00101980}, {2,0.00111881}, {3,0.00200000}, {4,0.00217822}, {5,0.00300000}, {6,0.00343564}, {7,0.00404950}, {8,0.00500000}, {9,0.00533663}, {10,0.00616832}, {11,0.02635644}, {12,0.00796040}, {13,0.00839604}, {14,0.00933663}, {15,0.01028713}, {16,0.01121782}, {17,0.01228713}, {18,0.01337624}, {19,0.01439604}, {20,0.01622772}, {21,0.01678218}, {22,0.01821782}, {23,0.01941584}, {24,0.02056436}, {25,0.02201980}, {26,0.02448515}, {27,0.02476238}, {28,0.02647525}, {29,0.02786139}, {30,0.03086139}, {31,0.03120792}, {32,0.03294059}, {33,0.03660396}, {34,0.03651485}, {35,0.03849505}, {36,0.04132673}, {37,0.04215842}, {38,0.04411881}, {39,0.04643564}, {40,0.04880198}, {41,0.05019802}, {42,0.05288119}, {43,0.05473267}, {44,0.05837624}, {45,0.05988119}, {46,0.06342574}, {47,0.06496040}, {48,0.06619802}, {49,0.07148515}, {50,0.07278218}, {51,0.07440594}, {52,0.07809901}, {53,0.08332673}, {54,0.08729703}, {55,0.08725743}, {56,0.09064356}, {57,0.09173267}, {58,0.09463366}, {59,0.09785149}, {60,0.10087129}, {61,0.10443564}, {62,0.11239604}, {63,0.11732673}, {64,0.11854455}, {65,0.12034653}, {66,0.12189109}, {67,0.13030693}, {68,0.13250495}, {69,0.13472277}, {70,0.14280198}, {71,0.14390099}, {72,0.15033663}, {73,0.15062376}, {74,0.15754455}, {75,0.15904950}, {76,0.16417822}, {77,0.17008911}, {78,0.17574257}, {79,0.17820792}, {80,0.18133663}, {81,0.18524752}, {82,0.19069307}, {83,0.19655446}, {84,0.20510891}, {85,0.20864356}, {86,0.21128713}, {87,0.21500990}, {88,0.22395050}, {89,0.22600990}, {90,0.23612871}, {91,0.23723762}, {92,0.24390099}, {93,0.25204950}, {94,0.25432673}, {95,0.25923762}, {96,0.26734653}, {97,0.27225743}, {98,0.27736634}, {99,0.28445545}, {100,0.28958416}, {101,0.30029703}, {102,0.30265347}, {103,0.30821782}, {104,0.31753465}, {105,0.32683168}, {106,0.33323762}, {107,0.34266337}, {108,0.34884158}, {109,0.35788119}, {110,0.36596040}, {111,0.37278218}, {112,0.37968317}, {113,0.38607921}, {114,0.39356436}, {115,0.39808911}, {116,0.40556436}, {117,0.41297030}, {118,0.42162376}, {119,0.43185149}, {120,0.43902970}, {121,0.44739604}, {122,0.45504950}, {123,0.46617822}, {124,0.47431683}, {125,0.48116832}, {126,0.49012871}, {127,0.50285149}, {128,0.50754455}, {129,0.51737624}, {130,0.53105941}, {131,0.54623762}, {132,0.54469307}, {133,0.55376238}, {134,0.56633663}, {135,0.57543564}, {136,0.57779208}, {137,0.59416832}, {138,0.60581188}, {139,0.61000990}, {140,0.62930693}, {141,0.63517822}, {142,0.64774257}, {143,0.65733663}, {144,0.68577228}, {145,0.67589109}, {146,0.69262376}, {147,0.69606931}, {148,0.71767327}, {149,0.72468317}, {150,0.73515842}, {151,0.75374257}, {152,0.76262376}, {153,0.77543564}, {154,0.78365347}, {155,0.95461386}, {156,0.87606931}, {157,0.95172277}, {158,0.83693069}, {159,0.85381188}, {160,0.87097030}, {161,0.87942574}, {162,0.88768317}, {163,0.90281188}, {164,0.91167327}, {165,0.92890099}, {166,0.94262376}, {167,0.95966337}, {168,0.97257426}, {169,0.98587129}, {170,1.00621782}, {171,1.01883168}, {172,1.03499010}, {173,1.05472277}, {174,1.06424752}, {175,1.06639604}, {176,1.1275429}, {177,1.1124286}, {178,1.1273714}, {179,1.1406286}, {180,1.1736286}, {181,1.2053143}, {182,1.2012000}, {183,1.2160857}, {184,1.2259429}, {185,1.2410286}, {186,1.2683714}, {187,1.2747714}, {188,1.2973143}, {189,1.3044000}, {190,1.3450571}, {191,1.3578571}, {192,1.3741714}, {193,1.3817714}, {194,1.4389429}, {195,1.4290571}, {196,1.4482571}, {197,1.4699429}, {198,1.4896000}, {199,1.5153143}, {200,1.5339429}, {201,1.5631143}, {202,1.5726857}, {203,1.5905714}, {204,1.6130000}, {205,1.6172857}, {206,1.6534286}, {207,1.6879714}, {208,1.6825429}, {209,1.7116000}, {210,1.7556571}, {211,1.7862000}, {212,1.7627143}, {213,1.8112286}, {214,1.8579429}, {215,1.8736286}, {216,1.8846857}, {217,1.9352286}, {218,1.9427143}, {219,1.9797143}, {220,2.0131714}, {221,2.0254571}, {222,2.0528571}, {223,2.0588571}, {224,2.0963714}, {225,2.1212286}, {226,2.1570286}, {227,2.1971143}, {228,2.1989143}, {229,2.2977429}, {230,2.2555714}, {231,2.3164857}, {232,2.2949429}, {233,2.3572000}, {234,2.3471714}, {235,2.4385143}, {236,2.4883429}, {237,2.5295714}, {238,2.4689143}, {239,2.5266571}, {240,2.5736000}, {241,2.6043143}, {242,2.6290857}, {243,2.6879714}, {244,2.7000000}, {245,2.7268000}, {246,3.3539143}, {247,2.8035714}, {248,2.8433143}, {249,2.8814000}, {250,2.9914000}, {251,2.9216286}, {252,2.9757429}, {253,3.0264000}, {254,3.0725429}, {255,3.0978571}, {256,3.1117429}, {257,3.1738286}, {258,3.1176857}, {259,3.2304000}, {260,3.2492857}, {261,3.3044857}, {262,3.3561714}, {263,3.3596000}, {264,3.3957429}, {265,3.4488857}, {266,3.4804571}, {267,3.5525429}, {268,3.5371143}, {269,3.6214571}, {270,3.6525714}, {271,3.6782286}, {272,3.7040571}, {273,3.7801429}, {274,3.8164571}, {275,3.8678857}, {276,3.8950000}, {277,3.9287714}, {278,3.9538571}, {279,4.0412857}, {280,4.0650000}, {281,4.1156857}, {282,4.0991143}, {283,4.2434000}, {284,4.2314286}, {285,4.2542000}, {286,4.3360286}, {287,4.4096000}, {288,4.4082000}, {289,4.4745143}, {290,4.5544857}, {291,4.5838286}, {292,4.5140857}, {293,4.5667429}, {294,4.6778571}, {295,4.6248857}, {296,4.8521714}, {297,4.8328000}, {298,4.9482000}, {299,4.8587429}, {300,5.0079143}, {301,5.0500857}, {302,5.1209429}, {303,5.1585429}, {304,5.2227143}, {305,5.0879429}, {306,5.3495143}, {307,5.3428857}, {308,5.4266000}, {309,5.4808286}, {310,5.5132857}, {311,5.6014286}, {312,5.6100571}, {313,5.7116286}, {314,5.7752571}, {315,5.5741714}, {316,5.7390857}, {317,5.8580571}, {318,5.9851429}, {319,6.0243143}, {320,6.1155714}, {321,6.1047143}, {322,6.1650000}, {323,6.2558571}, {324,6.2639143}, {325,6.4041714}, {326,6.4851143}, {327,6.5101429}, {328,6.5678286}, {329,6.6198857}, {330,6.6786286}, {331,6.6463143}, {332,6.8238571}, {333,6.9289714}, {334,6.7622286}, {335,7.0266571}, {336,7.0970857}, {337,7.1346286}, {338,7.2352286}, {339,7.2927714}, {340,7.3156286}, {341,7.1527714}, {342,7.2807714}, {343,7.5078571}, {344,7.5966286}, {345,7.6771429}, {346,7.7001143}, {347,7.7553429}, {348,7.8894571}, {349,7.9370000}, {350,7.9845429}, {351,8.0555714}, {352,8.1504571}, {353,8.1941429}, {354,8.2850571}, {355,8.3547714}, {356,8.4195714}, {357,8.5018857}, {358,8.5855429}, {359,8.6441429}, {360,8.7258286}, {361,8.8022000}, {362,8.8339143}, {363,8.9191714}, {364,8.9769143}, {365,9.0384571}, {366,9.1657143}, {367,9.1186857}, {368,9.3642857}, {369,9.3981429}, {370,9.4835714}, {371,9.5682286}, {372,9.5858000}, {373,9.5844286}, {374,9.7789714}, {375,9.9088571}, {376,10.0087143}, {377,10.0092571}, {378,10.1182286}, {379,10.1964286}, {380,9.7417714}, {381,10.3651143}, {382,10.2636000}, {383,10.5179714}, {384,10.6055429}, {385,10.5588571}, {386,10.7101429}, {387,10.8383429}, {388,10.9415143}, {389,10.8279143}, {390,10.9490571}, {391,11.0360571}, {392,11.2480571}, {393,11.3745714}, {394,11.4382286}, {395,11.3714857}, {396,11.5176286}, {397,11.3949143}, {398,11.6446000}, {399,11.9128000}, {400,11.9164857}, {401,12.0665143}, {402,12.1273429}, {403,12.2266857}, {404,12.3217429}, {405,12.4674286}, {406,12.5379143}, {407,12.6217429}, {408,12.6534000}, {409,12.8458000}, {410,12.7442286}, {411,12.9280571}, {412,13.0870571}, {413,12.6407714}, {414,12.9897143}, {415,13.2602857}, {416,13.4704571}, {417,13.5971714}, {418,13.6649714}, {419,13.6421429}, {420,13.8537714}, {421,13.9419714}, {422,14.1195143}, {423,14.2015429}, {424,14.2932286}, {425,14.2876571}, {426,14.4483143}, {427,14.4804857}, {428,14.6869714}, {429,14.7855429}, {430,14.8689714}, {431,14.4948000}, {432,15.1591429}, {433,15.1984571}, {434,15.3342857}, {435,15.4719143}, {436,15.5640571}, {437,15.6997143}, {438,15.7864571}, {439,15.9194857}, {440,15.9740286}, {441,16.0308286}, {442,16.3034571}, {443,16.4408286}, {444,16.5268571}, {445,16.6532286}, {446,16.7575714}, {447,16.7754000}, {448,16.9131714}, {449,17.0128857}, {450,17.0632857}, {451,17.2402000}, {452,17.2958286}, {453,17.4618571}, {454,17.5709143}, {455,17.5059429}, {456,17.2654571}, {457,17.8309429}, {458,17.9783429}, {459,18.0523429}, {460,18.2130286}, {461,18.0198000}, {462,18.3149143}, {463,18.5692857}, {464,18.5082286}, {465,18.6763714}, {466,18.8426857}, {467,19.0163714}, {468,19.0704857}, {469,19.3132857}, {470,19.1910571}, {471,19.5227143}, {472,19.6148571}, {473,19.5806286}, {474,19.8521429}, {475,19.9584857}, {476,20.0745429}, {477,20.2046571}, {478,20.3149143}, {479,20.4418857}, {480,20.5064857}, {481,20.5481143}, {482,20.8830286}, {483,20.9516571}, {484,21.1902000}, {485,21.1034571}, {486,21.3978000}, {487,21.5813714}, {488,21.5786857}, {489,21.6782000}, {490,21.7857429}, {491,21.8481429}, {492,22.2114857}, {493,22.1911714}, {494,22.2244571}, {495,22.7454857}, {496,22.6468571}, {497,22.9659429}, {498,23.1510000}, {499,23.2942571}, {500,23.4106571}, {505,23.9375429}, {510,24.7795143}, {515,25.4882571}, {520,26.2564571}, {525,26.7578857}, {530,27.0108571}, {535,28.4274571}, {540,29.0154571}, {545,30.0716000}, {550,30.8380571}, {555,31.7536000}, {560,32.4964286}, {565,33.2431143}, {570,34.2055714}, {575,35.1886571}, {580,35.9717429}, {585,37.1072857}, {590,37.9176000}, {595,38.6945714}, {600,40.0113143}, {605,40.8389714}, {610,42.0031143}, {615,42.7528286}, {620,44.0835143}, {625,45.2516571}, {630,46.1917429}, {635,47.2441429}, {640,48.0660000}, {645,49.2463143}, {650,50.6108857}, {655,51.5776286}, {660,53.2211143}, {665,54.4412286}, {670,55.4715714}, {675,56.6525429}, {680,58.2076571}, {685,58.9430571}, {690,60.4783429}, {695,61.5234857}, {700,62.9112857}};
data["big"]["LtacPrimUncurry"]["Aggregate"]["user"] = {{1,0.00120792}, {2,0.00208911}, {3,0.00183168}, {4,0.00260396}, {5,0.00302970}, {6,0.00376238}, {7,0.00435644}, {8,0.00492079}, {9,0.00567327}, {10,0.00596040}, {11,0.02647525}, {12,0.00747525}, {13,0.00825743}, {14,0.00981188}, {15,0.01063366}, {16,0.01175248}, {17,0.01271287}, {18,0.01360396}, {19,0.01480198}, {20,0.01600000}, {21,0.01697030}, {22,0.01796040}, {23,0.01900990}, {24,0.02067327}, {25,0.02198020}, {26,0.02466337}, {27,0.02508911}, {28,0.02646535}, {29,0.02808911}, {30,0.03080198}, {31,0.03066337}, {32,0.03298020}, {33,0.03677228}, {34,0.03638614}, {35,0.03878218}, {36,0.04121782}, {37,0.04200000}, {38,0.04403960}, {39,0.04680198}, {40,0.04895050}, {41,0.05000000}, {42,0.05261386}, {43,0.05427723}, {44,0.05861386}, {45,0.05994059}, {46,0.06335644}, {47,0.06454455}, {48,0.06623762}, {49,0.07133663}, {50,0.07292079}, {51,0.07421782}, {52,0.07789109}, {53,0.08284158}, {54,0.08712871}, {55,0.08678218}, {56,0.09025743}, {57,0.09153465}, {58,0.09413861}, {59,0.09754455}, {60,0.10038614}, {61,0.10409901}, {62,0.11191089}, {63,0.11677228}, {64,0.11830693}, {65,0.12023762}, {66,0.12170297}, {67,0.13055446}, {68,0.13254455}, {69,0.13432673}, {70,0.14272277}, {71,0.14393069}, {72,0.14984158}, {73,0.15007921}, {74,0.15755446}, {75,0.15865347}, {76,0.16385149}, {77,0.16980198}, {78,0.17530693}, {79,0.17787129}, {80,0.18095050}, {81,0.18472277}, {82,0.19047525}, {83,0.19606931}, {84,0.20469307}, {85,0.20824752}, {86,0.21078218}, {87,0.21478218}, {88,0.22313861}, {89,0.22565347}, {90,0.23544554}, {91,0.23689109}, {92,0.24351485}, {93,0.25166337}, {94,0.25449505}, {95,0.25896040}, {96,0.26715842}, {97,0.27198020}, {98,0.27731683}, {99,0.28410891}, {100,0.28955446}, {101,0.29997030}, {102,0.30270297}, {103,0.30764356}, {104,0.31729703}, {105,0.32640594}, {106,0.33300000}, {107,0.34205941}, {108,0.34851485}, {109,0.35719802}, {110,0.36535644}, {111,0.37207921}, {112,0.37894059}, {113,0.38554455}, {114,0.39287129}, {115,0.39791089}, {116,0.40481188}, {117,0.41229703}, {118,0.42106931}, {119,0.43101980}, {120,0.43832673}, {121,0.44676238}, {122,0.45422772}, {123,0.46542574}, {124,0.47326733}, {125,0.48011881}, {126,0.48936634}, {127,0.50205941}, {128,0.50710891}, {129,0.51658416}, {130,0.53062376}, {131,0.54530693}, {132,0.54403960}, {133,0.55307921}, {134,0.56540594}, {135,0.57477228}, {136,0.57694059}, {137,0.59363366}, {138,0.60497030}, {139,0.60910891}, {140,0.62842574}, {141,0.63410891}, {142,0.64683168}, {143,0.65664356}, {144,0.68461386}, {145,0.67507921}, {146,0.69153465}, {147,0.69503960}, {148,0.71676238}, {149,0.72380198}, {150,0.73420792}, {151,0.75286139}, {152,0.76151485}, {153,0.77454455}, {154,0.78278218}, {155,0.95316832}, {156,0.87497030}, {157,0.95006931}, {158,0.83590099}, {159,0.85286139}, {160,0.86983168}, {161,0.87834653}, {162,0.88651485}, {163,0.90174257}, {164,0.91084158}, {165,0.92736634}, {166,0.94126733}, {167,0.95839604}, {168,0.97126733}, {169,0.98434653}, {170,1.00521782}, {171,1.01758416}, {172,1.03414851}, {173,1.05335644}, {174,1.06306931}, {175,1.06501980}, {176,1.1267143}, {177,1.1114857}, {178,1.1264571}, {179,1.1393714}, {180,1.1724571}, {181,1.2049143}, {182,1.2004571}, {183,1.2147143}, {184,1.2254000}, {185,1.2405429}, {186,1.2676857}, {187,1.2740857}, {188,1.2961429}, {189,1.3035714}, {190,1.3442000}, {191,1.3566857}, {192,1.3726857}, {193,1.3798000}, {194,1.4373714}, {195,1.4283429}, {196,1.4468857}, {197,1.4668857}, {198,1.4866857}, {199,1.5126857}, {200,1.5314286}, {201,1.5616857}, {202,1.5721429}, {203,1.5898000}, {204,1.6120571}, {205,1.6167714}, {206,1.6525429}, {207,1.6874857}, {208,1.6818286}, {209,1.7104286}, {210,1.7549714}, {211,1.7849429}, {212,1.7617714}, {213,1.8097143}, {214,1.8523143}, {215,1.8693714}, {216,1.8828571}, {217,1.9341143}, {218,1.9401143}, {219,1.9784000}, {220,2.0117429}, {221,2.0234286}, {222,2.0508000}, {223,2.0573143}, {224,2.0949429}, {225,2.1200000}, {226,2.1545143}, {227,2.1955429}, {228,2.1978000}, {229,2.2955429}, {230,2.2537429}, {231,2.3149143}, {232,2.2930000}, {233,2.3553714}, {234,2.3454000}, {235,2.4363429}, {236,2.4865714}, {237,2.5275143}, {238,2.4673143}, {239,2.5232000}, {240,2.5709143}, {241,2.6017143}, {242,2.6265143}, {243,2.6858000}, {244,2.6946857}, {245,2.7192857}, {246,3.3468571}, {247,2.8006571}, {248,2.8393143}, {249,2.8752571}, {250,2.9869429}, {251,2.9156286}, {252,2.9709429}, {253,3.0131143}, {254,3.0675429}, {255,3.0960286}, {256,3.1100857}, {257,3.1719143}, {258,3.1162000}, {259,3.2288000}, {260,3.2479143}, {261,3.3018000}, {262,3.3538571}, {263,3.3576571}, {264,3.3937429}, {265,3.4465143}, {266,3.4781429}, {267,3.5496000}, {268,3.5348286}, {269,3.6190286}, {270,3.6502857}, {271,3.6762857}, {272,3.7022000}, {273,3.7777714}, {274,3.8136571}, {275,3.8653143}, {276,3.8922571}, {277,3.9259429}, {278,3.9514286}, {279,4.0372857}, {280,4.0614571}, {281,4.1127429}, {282,4.0956000}, {283,4.2401143}, {284,4.2281714}, {285,4.2509429}, {286,4.3327429}, {287,4.4065714}, {288,4.4045714}, {289,4.4711143}, {290,4.5511143}, {291,4.5802286}, {292,4.5108286}, {293,4.5634571}, {294,4.6736571}, {295,4.6217714}, {296,4.8476571}, {297,4.8285429}, {298,4.9438000}, {299,4.8537714}, {300,5.0029714}, {301,5.0444571}, {302,5.1152571}, {303,5.1539714}, {304,5.2171143}, {305,5.0823143}, {306,5.3435429}, {307,5.3366000}, {308,5.4200857}, {309,5.4748857}, {310,5.5084857}, {311,5.5952571}, {312,5.6043143}, {313,5.7055714}, {314,5.7697714}, {315,5.5694857}, {316,5.7333429}, {317,5.8533143}, {318,5.9804857}, {319,6.0196286}, {320,6.1102000}, {321,6.0994000}, {322,6.1594286}, {323,6.2502571}, {324,6.2585429}, {325,6.3989429}, {326,6.4799143}, {327,6.5048571}, {328,6.5618857}, {329,6.6135143}, {330,6.6740571}, {331,6.6423429}, {332,6.8194571}, {333,6.9249714}, {334,6.7576571}, {335,7.0220857}, {336,7.0923429}, {337,7.1305714}, {338,7.2303714}, {339,7.2878571}, {340,7.3112286}, {341,7.1484000}, {342,7.2758286}, {343,7.5034286}, {344,7.5916857}, {345,7.6723714}, {346,7.6951714}, {347,7.7497714}, {348,7.8830286}, {349,7.9305429}, {350,7.9790571}, {351,8.0481143}, {352,8.1432000}, {353,8.1876000}, {354,8.2790286}, {355,8.3484000}, {356,8.4137143}, {357,8.4963429}, {358,8.5786000}, {359,8.6375429}, {360,8.7183714}, {361,8.7963143}, {362,8.8282000}, {363,8.9137143}, {364,8.9709714}, {365,9.0324571}, {366,9.1598857}, {367,9.1120286}, {368,9.3570857}, {369,9.3834286}, {370,9.4674286}, {371,9.5588000}, {372,9.5768857}, {373,9.5738857}, {374,9.7679429}, {375,9.8969714}, {376,9.9961143}, {377,9.9990571}, {378,10.1088857}, {379,10.1852000}, {380,9.7304857}, {381,10.3534286}, {382,10.2512286}, {383,10.5060571}, {384,10.5950857}, {385,10.5488286}, {386,10.7012286}, {387,10.8292857}, {388,10.9308000}, {389,10.8175143}, {390,10.9384000}, {391,11.0253429}, {392,11.2369714}, {393,11.3639143}, {394,11.4270000}, {395,11.3612286}, {396,11.5072571}, {397,11.3832000}, {398,11.6343143}, {399,11.9016000}, {400,11.9056000}, {401,12.0558857}, {402,12.1160857}, {403,12.2164286}, {404,12.3094857}, {405,12.4564857}, {406,12.5274000}, {407,12.6101714}, {408,12.6440286}, {409,12.8358000}, {410,12.7346857}, {411,12.9183429}, {412,13.0774000}, {413,12.6319429}, {414,12.9807429}, {415,13.2493143}, {416,13.4585714}, {417,13.5872571}, {418,13.6569429}, {419,13.6346000}, {420,13.8446286}, {421,13.9336857}, {422,14.1134000}, {423,14.1945143}, {424,14.2865714}, {425,14.2797143}, {426,14.4390000}, {427,14.4705429}, {428,14.6735143}, {429,14.7721429}, {430,14.8554286}, {431,14.4810857}, {432,15.1440000}, {433,15.1848571}, {434,15.3191143}, {435,15.4545714}, {436,15.5475143}, {437,15.6814286}, {438,15.7691714}, {439,15.8943143}, {440,15.9584571}, {441,16.0168571}, {442,16.2078857}, {443,16.3254000}, {444,16.4576857}, {445,16.5793143}, {446,16.6921429}, {447,16.7498000}, {448,16.8964857}, {449,16.9954286}, {450,17.0354286}, {451,17.1542857}, {452,17.2273143}, {453,17.3599143}, {454,17.4888857}, {455,17.4120571}, {456,17.1957429}, {457,17.7951429}, {458,17.9552857}, {459,18.0315143}, {460,18.1704286}, {461,18.0002857}, {462,18.2942000}, {463,18.5468000}, {464,18.4862571}, {465,18.6543714}, {466,18.8194857}, {467,18.9823143}, {468,19.0345429}, {469,19.2820857}, {470,19.1434857}, {471,19.4544286}, {472,19.5385143}, {473,19.5401429}, {474,19.8258286}, {475,19.9325143}, {476,20.0510857}, {477,20.1772286}, {478,20.2882857}, {479,20.4174571}, {480,20.4821429}, {481,20.5239429}, {482,20.8597143}, {483,20.9298000}, {484,21.1749143}, {485,21.0895429}, {486,21.3848286}, {487,21.5684286}, {488,21.5602857}, {489,21.6598857}, {490,21.7691143}, {491,21.8306286}, {492,22.1932857}, {493,22.1670857}, {494,22.1975714}, {495,22.7223429}, {496,22.6233714}, {497,22.9387714}, {498,23.1207714}, {499,23.2170857}, {500,23.3322000}, {505,23.9055429}, {510,24.7536857}, {515,25.4638286}, {520,26.2322286}, {525,26.7282000}, {530,26.9838000}, {535,28.4029429}, {540,28.9896286}, {545,30.0433714}, {550,30.8091143}, {555,31.7249143}, {560,32.4666857}, {565,33.2137714}, {570,34.1790286}, {575,35.1610571}, {580,35.9486286}, {585,37.0850000}, {590,37.8937714}, {595,38.6689143}, {600,39.9815429}, {605,40.8070286}, {610,41.9654857}, {615,42.7132286}, {620,44.0430857}, {625,45.2150571}, {630,46.1569143}, {635,47.2058857}, {640,48.0290000}, {645,49.2138000}, {650,50.5820000}, {655,51.5433143}, {660,53.1762000}, {665,54.3900000}, {670,55.4157429}, {675,56.5970857}, {680,58.1484286}, {685,58.8836571}, {690,60.4175714}, {695,61.4626000}, {700,62.8431143}};
data["big"]["LtacPrimUncurry"]["Aggregate"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00010891}, {4,0.00003960}, {5,0.00000000}, {6,0.00003960}, {7,0.00007921}, {8,0.00003960}, {9,0.00007921}, {10,0.00006931}, {11,0.00003960}, {12,0.00000000}, {13,0.00003960}, {14,0.00000000}, {15,0.00011881}, {16,0.00011881}, {17,0.00003960}, {18,0.00007921}, {19,0.00003960}, {20,0.00003960}, {21,0.00003960}, {22,0.00003960}, {23,0.00003960}, {24,0.00007921}, {25,0.00011881}, {26,0.00003960}, {27,0.00000000}, {28,0.00003960}, {29,0.00006931}, {30,0.00000000}, {31,0.00010891}, {32,0.00003960}, {33,0.00010891}, {34,0.00011881}, {35,0.00003960}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00003960}, {41,0.00011881}, {42,0.00003960}, {43,0.00007921}, {44,0.00006931}, {45,0.00003960}, {46,0.00002970}, {47,0.00003960}, {48,0.00003960}, {49,0.00003960}, {50,0.00000000}, {51,0.00007921}, {52,0.00014851}, {53,0.00007921}, {54,0.00000000}, {55,0.00011881}, {56,0.00007921}, {57,0.00003960}, {58,0.00011881}, {59,0.00003960}, {60,0.00007921}, {61,0.00011881}, {62,0.00006931}, {63,0.00000000}, {64,0.00003960}, {65,0.00000000}, {66,0.00003960}, {67,0.00003960}, {68,0.00002970}, {69,0.00000000}, {70,0.00003960}, {71,0.00011881}, {72,0.00011881}, {73,0.00011881}, {74,0.00002970}, {75,0.00002970}, {76,0.00003960}, {77,0.00003960}, {78,0.00006931}, {79,0.00011881}, {80,0.00002970}, {81,0.00011881}, {82,0.00003960}, {83,0.00000000}, {84,0.00011881}, {85,0.00003960}, {86,0.00006931}, {87,0.00011881}, {88,0.00010891}, {89,0.00007921}, {90,0.00015842}, {91,0.00003960}, {92,0.00010891}, {93,0.00007921}, {94,0.00003960}, {95,0.00011881}, {96,0.00000000}, {97,0.00003960}, {98,0.00002970}, {99,0.00007921}, {100,0.00007921}, {101,0.00003960}, {102,0.00011881}, {103,0.00003960}, {104,0.00007921}, {105,0.00003960}, {106,0.00003960}, {107,0.00003960}, {108,0.00014851}, {109,0.00010891}, {110,0.00019802}, {111,0.00000000}, {112,0.00002970}, {113,0.00010891}, {114,0.00002970}, {115,0.00000000}, {116,0.00002970}, {117,0.00011881}, {118,0.00015842}, {119,0.00011881}, {120,0.00003960}, {121,0.00003960}, {122,0.00003960}, {123,0.00010891}, {124,0.00003960}, {125,0.00011881}, {126,0.00011881}, {127,0.00015842}, {128,0.00000000}, {129,0.00015842}, {130,0.00019802}, {131,0.00003960}, {132,0.00014851}, {133,0.00011881}, {134,0.00014851}, {135,0.00010891}, {136,0.00007921}, {137,0.00003960}, {138,0.00010891}, {139,0.00007921}, {140,0.00019802}, {141,0.00003960}, {142,0.00014851}, {143,0.00014851}, {144,0.00019802}, {145,0.00007921}, {146,0.00010891}, {147,0.00007921}, {148,0.00011881}, {149,0.00003960}, {150,0.00003960}, {151,0.00015842}, {152,0.00011881}, {153,0.00010891}, {154,0.00002970}, {155,0.00066337}, {156,0.00029703}, {157,0.00060396}, {158,0.00007921}, {159,0.00019802}, {160,0.00023762}, {161,0.00007921}, {162,0.00031683}, {163,0.00007921}, {164,0.00007921}, {165,0.00015842}, {166,0.00011881}, {167,0.00011881}, {168,0.00003960}, {169,0.00018812}, {170,0.00022772}, {171,0.00011881}, {172,0.00000000}, {173,0.00011881}, {174,0.00015842}, {175,0.00014851}, {176,0.0002286}, {177,0.0000000}, {178,0.0005429}, {179,0.0003429}, {180,0.0004571}, {181,0.0001143}, {182,0.0003429}, {183,0.0001143}, {184,0.0000000}, {185,0.0001143}, {186,0.0000000}, {187,0.0002286}, {188,0.0001143}, {189,0.0003429}, {190,0.0003429}, {191,0.0000000}, {192,0.0000000}, {193,0.0001143}, {194,0.0000000}, {195,0.0000000}, {196,0.0002286}, {197,0.0001143}, {198,0.0002286}, {199,0.0001143}, {200,0.0004571}, {201,0.0004571}, {202,0.0000857}, {203,0.0002000}, {204,0.0001143}, {205,0.0000000}, {206,0.0003429}, {207,0.0002286}, {208,0.0002286}, {209,0.0002286}, {210,0.0002286}, {211,0.0001143}, {212,0.0002286}, {213,0.0004571}, {214,0.0004571}, {215,0.0001143}, {216,0.0003429}, {217,0.0001143}, {218,0.0003429}, {219,0.0001143}, {220,0.0000857}, {221,0.0003429}, {222,0.0004571}, {223,0.0003429}, {224,0.0002286}, {225,0.0001143}, {226,0.0005714}, {227,0.0001143}, {228,0.0001143}, {229,0.0003143}, {230,0.0000000}, {231,0.0001143}, {232,0.0003429}, {233,0.0000000}, {234,0.0001143}, {235,0.0005429}, {236,0.0003143}, {237,0.0000000}, {238,0.0002286}, {239,0.0000000}, {240,0.0003429}, {241,0.0002286}, {242,0.0001714}, {243,0.0003429}, {244,0.0003143}, {245,0.0003429}, {246,0.0047714}, {247,0.0003429}, {248,0.0003429}, {249,0.0003429}, {250,0.0001143}, {251,0.0001143}, {252,0.0004571}, {253,0.0001143}, {254,0.0001143}, {255,0.0004571}, {256,0.0003143}, {257,0.0004571}, {258,0.0003429}, {259,0.0003429}, {260,0.0001143}, {261,0.0006857}, {262,0.0001143}, {263,0.0001143}, {264,0.0003143}, {265,0.0003429}, {266,0.0000000}, {267,0.0004571}, {268,0.0000000}, {269,0.0002286}, {270,0.0000000}, {271,0.0003143}, {272,0.0003429}, {273,0.0003429}, {274,0.0002286}, {275,0.0001143}, {276,0.0003429}, {277,0.0003429}, {278,0.0000000}, {279,0.0008571}, {280,0.0002286}, {281,0.0001143}, {282,0.0006857}, {283,0.0001143}, {284,0.0003429}, {285,0.0003429}, {286,0.0004286}, {287,0.0005714}, {288,0.0003429}, {289,0.0008857}, {290,0.0002286}, {291,0.0004571}, {292,0.0003429}, {293,0.0004571}, {294,0.0006571}, {295,0.0004571}, {296,0.0002286}, {297,0.0003143}, {298,0.0003429}, {299,0.0000000}, {300,0.0002286}, {301,0.0005714}, {302,0.0005429}, {303,0.0004571}, {304,0.0005714}, {305,0.0003429}, {306,0.0004571}, {307,0.0011143}, {308,0.0008000}, {309,0.0005714}, {310,0.0001143}, {311,0.0003429}, {312,0.0006857}, {313,0.0005714}, {314,0.0004286}, {315,0.0002286}, {316,0.0008000}, {317,0.0005429}, {318,0.0002286}, {319,0.0001143}, {320,0.0006857}, {321,0.0005714}, {322,0.0006571}, {323,0.0005714}, {324,0.0002286}, {325,0.0003429}, {326,0.0006571}, {327,0.0002286}, {328,0.0005714}, {329,0.0008000}, {330,0.0004286}, {331,0.0004571}, {332,0.0001143}, {333,0.0002286}, {334,0.0003429}, {335,0.0004571}, {336,0.0002286}, {337,0.0002286}, {338,0.0007714}, {339,0.0003429}, {340,0.0001143}, {341,0.0004571}, {342,0.0007714}, {343,0.0003429}, {344,0.0005714}, {345,0.0002286}, {346,0.0004571}, {347,0.0001143}, {348,0.0004571}, {349,0.0004571}, {350,0.0004286}, {351,0.0004571}, {352,0.0001143}, {353,0.0004571}, {354,0.0008000}, {355,0.0004286}, {356,0.0005714}, {357,0.0003429}, {358,0.0003429}, {359,0.0005714}, {360,0.0006857}, {361,0.0005714}, {362,0.0006286}, {363,0.0003429}, {364,0.0003429}, {365,0.0004571}, {366,0.0006857}, {367,0.0005429}, {368,0.0008000}, {369,0.0010000}, {370,0.0009143}, {371,0.0010857}, {372,0.0010286}, {373,0.0006857}, {374,0.0004571}, {375,0.0004571}, {376,0.0010000}, {377,0.0004571}, {378,0.0002286}, {379,0.0002286}, {380,0.0006571}, {381,0.0008000}, {382,0.0014857}, {383,0.0009143}, {384,0.0006857}, {385,0.0011429}, {386,0.0008000}, {387,0.0004286}, {388,0.0012571}, {389,0.0009143}, {390,0.0009714}, {391,0.0009143}, {392,0.0012571}, {393,0.0006571}, {394,0.0010000}, {395,0.0005714}, {396,0.0004571}, {397,0.0013714}, {398,0.0004286}, {399,0.0008000}, {400,0.0007714}, {401,0.0005429}, {402,0.0007714}, {403,0.0007714}, {404,0.0011429}, {405,0.0010286}, {406,0.0002286}, {407,0.0012571}, {408,0.0008000}, {409,0.0010286}, {410,0.0010286}, {411,0.0012571}, {412,0.0010286}, {413,0.0005429}, {414,0.0007714}, {415,0.0006857}, {416,0.0012000}, {417,0.0003429}, {418,0.0006857}, {419,0.0005714}, {420,0.0006857}, {421,0.0011429}, {422,0.0002286}, {423,0.0009143}, {424,0.0003429}, {425,0.0008857}, {426,0.0006571}, {427,0.0012000}, {428,0.0013429}, {429,0.0005143}, {430,0.0011429}, {431,0.0014857}, {432,0.0013429}, {433,0.0010286}, {434,0.0011429}, {435,0.0011429}, {436,0.0008571}, {437,0.0006857}, {438,0.0006571}, {439,0.0016000}, {440,0.0012571}, {441,0.0006857}, {442,0.0010286}, {443,0.0009143}, {444,0.0004571}, {445,0.0004571}, {446,0.0014857}, {447,0.0012571}, {448,0.0006857}, {449,0.0019143}, {450,0.0011429}, {451,0.0014857}, {452,0.0011429}, {453,0.0012571}, {454,0.0019143}, {455,0.0021714}, {456,0.0016000}, {457,0.0016571}, {458,0.0010000}, {459,0.0011429}, {460,0.0009143}, {461,0.0013714}, {462,0.0011429}, {463,0.0008000}, {464,0.0014857}, {465,0.0012571}, {466,0.0016857}, {467,0.0016857}, {468,0.0014000}, {469,0.0011429}, {470,0.0013429}, {471,0.0018286}, {472,0.0013714}, {473,0.0010000}, {474,0.0012286}, {475,0.0011143}, {476,0.0011429}, {477,0.0011143}, {478,0.0016857}, {479,0.0017143}, {480,0.0020571}, {481,0.0009143}, {482,0.0006571}, {483,0.0016000}, {484,0.0009143}, {485,0.0009143}, {486,0.0006857}, {487,0.0008000}, {488,0.0008000}, {489,0.0011429}, {490,0.0010286}, {491,0.0008857}, {492,0.0009143}, {493,0.0011143}, {494,0.0016000}, {495,0.0008000}, {496,0.0010286}, {497,0.0016286}, {498,0.0016000}, {499,0.0009143}, {500,0.0013429}, {505,0.0006857}, {510,0.0011429}, {515,0.0011429}, {520,0.0011429}, {525,0.0018000}, {530,0.0012571}, {535,0.0018286}, {540,0.0016000}, {545,0.0021143}, {550,0.0024000}, {555,0.0019143}, {560,0.0017143}, {565,0.0014857}, {570,0.0016000}, {575,0.0022571}, {580,0.0012571}, {585,0.0012571}, {590,0.0010000}, {595,0.0019143}, {600,0.0022571}, {605,0.0022571}, {610,0.0025143}, {615,0.0028571}, {620,0.0028286}, {625,0.0020571}, {630,0.0021429}, {635,0.0023714}, {640,0.0024000}, {645,0.0026000}, {650,0.0018000}, {655,0.0021143}, {660,0.0025714}, {665,0.0024857}, {670,0.0037714}, {675,0.0023429}, {680,0.0043429}, {685,0.0036571}, {690,0.0038286}, {695,0.0031429}, {700,0.0067429}};
data["big"]["LtacPrimUncurry"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00099010}, {3,0.00100000}, {4,0.00120792}, {5,0.00200000}, {6,0.00239604}, {7,0.00300000}, {8,0.00400000}, {9,0.00432673}, {10,0.00505941}, {11,0.02531683}, {12,0.00657426}, {13,0.00729703}, {14,0.00825743}, {15,0.00923762}, {16,0.01020792}, {17,0.01123762}, {18,0.01227723}, {19,0.01328713}, {20,0.01424752}, {21,0.01536634}, {22,0.01670297}, {23,0.01819802}, {24,0.01945545}, {25,0.02061386}, {26,0.02329703}, {27,0.02339604}, {28,0.02501980}, {29,0.02652475}, {30,0.02943564}, {31,0.02968317}, {32,0.03161386}, {33,0.03533663}, {34,0.03500990}, {35,0.03696040}, {36,0.04006931}, {37,0.04066337}, {38,0.04261386}, {39,0.04492079}, {40,0.04725743}, {41,0.04868317}, {42,0.05138614}, {43,0.05319802}, {44,0.05594059}, {45,0.05843564}, {46,0.06186139}, {47,0.06352475}, {48,0.06454455}, {49,0.06997030}, {50,0.07116832}, {51,0.07270297}, {52,0.07643564}, {53,0.08168317}, {54,0.08560396}, {55,0.08554455}, {56,0.08899010}, {57,0.09011881}, {58,0.09289109}, {59,0.09615842}, {60,0.09913861}, {61,0.10262376}, {62,0.11067327}, {63,0.11561386}, {64,0.11679208}, {65,0.11855446}, {66,0.12012871}, {67,0.12844554}, {68,0.13071287}, {69,0.13286139}, {70,0.14098020}, {71,0.14200990}, {72,0.14842574}, {73,0.14876238}, {74,0.15569307}, {75,0.15720792}, {76,0.16225743}, {77,0.16816832}, {78,0.17384158}, {79,0.17624752}, {80,0.17937624}, {81,0.18327723}, {82,0.18871287}, {83,0.19456436}, {84,0.20308911}, {85,0.20662376}, {86,0.20925743}, {87,0.21295050}, {88,0.22184158}, {89,0.22391089}, {90,0.23405941}, {91,0.23514851}, {92,0.24182178}, {93,0.24988119}, {94,0.25220792}, {95,0.25708911}, {96,0.26515842}, {97,0.27009901}, {98,0.27527723}, {99,0.28235644}, {100,0.28738614}, {101,0.29809901}, {102,0.30048515}, {103,0.30602970}, {104,0.31492079}, {105,0.32461386}, {106,0.33092079}, {107,0.34029703}, {108,0.34653465}, {109,0.35559406}, {110,0.36356436}, {111,0.37040594}, {112,0.37723762}, {113,0.38370297}, {114,0.39124752}, {115,0.39574257}, {116,0.40321782}, {117,0.41053465}, {118,0.41924752}, {119,0.42929703}, {120,0.43661386}, {121,0.44490099}, {122,0.45250495}, {123,0.46375248}, {124,0.47186139}, {125,0.47862376}, {126,0.48760396}, {127,0.49993069}, {128,0.50511881}, {129,0.51475248}, {130,0.52783168}, {131,0.54366337}, {132,0.54206931}, {133,0.55122772}, {134,0.56369307}, {135,0.57280198}, {136,0.57509901}, {137,0.59155446}, {138,0.60312871}, {139,0.60733663}, {140,0.62657426}, {141,0.63240594}, {142,0.64458416}, {143,0.65459406}, {144,0.68302970}, {145,0.67318812}, {146,0.68981188}, {147,0.69332673}, {148,0.71488119}, {149,0.72187129}, {150,0.73198020}, {151,0.75093069}, {152,0.75978218}, {153,0.77258416}, {154,0.78082178}, {155,0.95179208}, {156,0.87323762}, {157,0.94878218}, {158,0.83401980}, {159,0.85090099}, {160,0.86809901}, {161,0.87652475}, {162,0.88474257}, {163,0.89983168}, {164,0.90867327}, {165,0.92592079}, {166,0.93962376}, {167,0.95665347}, {168,0.96951485}, {169,0.98282178}, {170,1.00314851}, {171,1.01572277}, {172,1.03190099}, {173,1.05164356}, {174,1.06113861}, {175,1.06334653}, {176,1.1241429}, {177,1.1092571}, {178,1.1241429}, {179,1.1374000}, {180,1.1703429}, {181,1.2019143}, {182,1.1980857}, {183,1.2127143}, {184,1.2226857}, {185,1.2376000}, {186,1.2650286}, {187,1.2714857}, {188,1.2940000}, {189,1.3012000}, {190,1.3417429}, {191,1.3543714}, {192,1.3707143}, {193,1.3782286}, {194,1.4354857}, {195,1.4256000}, {196,1.4447429}, {197,1.4666571}, {198,1.4860857}, {199,1.5119143}, {200,1.5304571}, {201,1.5597143}, {202,1.5690286}, {203,1.5871429}, {204,1.6094571}, {205,1.6137714}, {206,1.6498571}, {207,1.6843714}, {208,1.6788286}, {209,1.7079143}, {210,1.7520571}, {211,1.7824571}, {212,1.7589429}, {213,1.8075429}, {214,1.8541714}, {215,1.8699714}, {216,1.8811429}, {217,1.9315143}, {218,1.9389143}, {219,1.9760857}, {220,2.0095429}, {221,2.0216571}, {222,2.0491143}, {223,2.0550571}, {224,2.0926000}, {225,2.1174286}, {226,2.1533429}, {227,2.1933429}, {228,2.1952571}, {229,2.2935143}, {230,2.2517714}, {231,2.3124571}, {232,2.2910857}, {233,2.3533429}, {234,2.3432571}, {235,2.4346286}, {236,2.4844000}, {237,2.5256571}, {238,2.4648857}, {239,2.5225429}, {240,2.5688000}, {241,2.6002000}, {242,2.6250571}, {243,2.6839714}, {244,2.6959143}, {245,2.7227429}, {246,3.3498000}, {247,2.7994571}, {248,2.8392857}, {249,2.8773143}, {250,2.9874000}, {251,2.9174571}, {252,2.9716286}, {253,3.0222286}, {254,3.0683143}, {255,3.0937143}, {256,3.1076000}, {257,3.1697143}, {258,3.1135143}, {259,3.2262286}, {260,3.2451429}, {261,3.3001143}, {262,3.3510286}, {263,3.3552571}, {264,3.3913429}, {265,3.4446000}, {266,3.4761429}, {267,3.5482571}, {268,3.5328000}, {269,3.6170857}, {270,3.6480571}, {271,3.6739429}, {272,3.6996286}, {273,3.7758286}, {274,3.8121143}, {275,3.8634286}, {276,3.8896571}, {277,3.9242286}, {278,3.9493143}, {279,4.0368286}, {280,4.0603143}, {281,4.1110286}, {282,4.0946286}, {283,4.2389143}, {284,4.2266286}, {285,4.2496286}, {286,4.3313714}, {287,4.4050286}, {288,4.4034857}, {289,4.4700571}, {290,4.5499714}, {291,4.5792000}, {292,4.5094857}, {293,4.5620571}, {294,4.6730857}, {295,4.6200000}, {296,4.8474571}, {297,4.8280286}, {298,4.9435143}, {299,4.8539143}, {300,5.0030571}, {301,5.0453143}, {302,5.1160571}, {303,5.1533714}, {304,5.2176857}, {305,5.0827143}, {306,5.3444286}, {307,5.3377429}, {308,5.4215143}, {309,5.4758286}, {310,5.5081143}, {311,5.5965143}, {312,5.6050000}, {313,5.7062286}, {314,5.7702571}, {315,5.5691429}, {316,5.7342000}, {317,5.8531143}, {318,5.9803429}, {319,6.0174571}, {320,6.1106857}, {321,6.0987714}, {322,6.1600000}, {323,6.2509429}, {324,6.2589143}, {325,6.3991714}, {326,6.4801714}, {327,6.5052286}, {328,6.5627714}, {329,6.6148857}, {330,6.6734857}, {331,6.6414000}, {332,6.8187429}, {333,6.9239143}, {334,6.7571143}, {335,7.0215714}, {336,7.0919143}, {337,7.1295714}, {338,7.2300571}, {339,7.2876286}, {340,7.3104286}, {341,7.1476000}, {342,7.2755143}, {343,7.5025143}, {344,7.5914286}, {345,7.6720571}, {346,7.6949714}, {347,7.7500571}, {348,7.8839143}, {349,7.9316286}, {350,7.9792286}, {351,8.0501143}, {352,8.1452000}, {353,8.1887429}, {354,8.2798000}, {355,8.3494000}, {356,8.4140857}, {357,8.4965143}, {358,8.5801714}, {359,8.6379714}, {360,8.7204286}, {361,8.7966857}, {362,8.8285143}, {363,8.9136571}, {364,8.9714000}, {365,9.0329429}, {366,9.1601714}, {367,9.1118857}, {368,9.3588286}, {369,9.3924857}, {370,9.4779714}, {371,9.5626000}, {372,9.5803143}, {373,9.5789143}, {374,9.7734000}, {375,9.9032000}, {376,10.0030857}, {377,10.0037143}, {378,10.1124286}, {379,10.1907429}, {380,9.7361714}, {381,10.3594000}, {382,10.2578286}, {383,10.5122286}, {384,10.5997143}, {385,10.5521429}, {386,10.7043714}, {387,10.8326571}, {388,10.9356000}, {389,10.8220000}, {390,10.9434000}, {391,11.0301714}, {392,11.2420571}, {393,11.3686000}, {394,11.4323429}, {395,11.3656286}, {396,11.5116571}, {397,11.3890286}, {398,11.6386857}, {399,11.9067714}, {400,11.9105714}, {401,12.0604857}, {402,12.1212571}, {403,12.2206857}, {404,12.3159429}, {405,12.4614571}, {406,12.5319429}, {407,12.6157429}, {408,12.6475714}, {409,12.8398571}, {410,12.7381429}, {411,12.9220857}, {412,13.0809143}, {413,12.6337143}, {414,12.9836571}, {415,13.2541429}, {416,13.4642857}, {417,13.5909429}, {418,13.6588000}, {419,13.6360571}, {420,13.8475714}, {421,13.9357714}, {422,14.1133429}, {423,14.1953714}, {424,14.2871143}, {425,14.2812571}, {426,14.4420571}, {427,14.4743429}, {428,14.6807429}, {429,14.7777143}, {430,14.8626286}, {431,14.4885143}, {432,15.1528286}, {433,15.1920857}, {434,15.3262000}, {435,15.4655143}, {436,15.5576571}, {437,15.6932857}, {438,15.7792571}, {439,15.9131714}, {440,15.9675429}, {441,16.0243714}, {442,16.2967714}, {443,16.4343714}, {444,16.5203714}, {445,16.6456571}, {446,16.7511143}, {447,16.7689714}, {448,16.9065143}, {449,17.0064286}, {450,17.0566571}, {451,17.2337714}, {452,17.2879429}, {453,17.4553714}, {454,17.5642857}, {455,17.4994571}, {456,17.2588571}, {457,17.8227429}, {458,17.9718000}, {459,18.0457143}, {460,18.2064571}, {461,18.0131714}, {462,18.3082571}, {463,18.5625143}, {464,18.5015714}, {465,18.6696286}, {466,18.8344000}, {467,19.0096857}, {468,19.0638000}, {469,19.3066000}, {470,19.1842571}, {471,19.5158286}, {472,19.6068000}, {473,19.5738857}, {474,19.8453143}, {475,19.9516857}, {476,20.0678000}, {477,20.1978857}, {478,20.3081429}, {479,20.4351429}, {480,20.4994571}, {481,20.5413429}, {482,20.8759714}, {483,20.9448000}, {484,21.1832000}, {485,21.0965429}, {486,21.3909143}, {487,21.5743429}, {488,21.5717714}, {489,21.6712286}, {490,21.7786571}, {491,21.8410857}, {492,22.2043429}, {493,22.1842571}, {494,22.2174857}, {495,22.7385429}, {496,22.6398286}, {497,22.9588286}, {498,23.1438857}, {499,23.2870857}, {500,23.4017714}, {505,23.9303429}, {510,24.7723714}, {515,25.4811143}, {520,26.2490857}, {525,26.7506571}, {530,27.0034857}, {535,28.4198286}, {540,29.0078857}, {545,30.0625714}, {550,30.8303429}, {555,31.7458286}, {560,32.4886571}, {565,33.2354000}, {570,34.1977143}, {575,35.1807429}, {580,35.9638571}, {585,37.0992857}, {590,37.9095143}, {595,38.6863714}, {600,40.0029714}, {605,40.8307143}, {610,41.9949143}, {615,42.7444000}, {620,44.0749143}, {625,45.2432000}, {630,46.1830857}, {635,47.2356000}, {640,48.0573143}, {645,49.2375143}, {650,50.6020286}, {655,51.5686000}, {660,53.2120000}, {665,54.4320286}, {670,55.4624286}, {675,56.6434000}, {680,58.1983143}, {685,58.9337714}, {690,60.4691143}, {695,61.5127429}, {700,62.9016857}};
data["big"]["LtacPrimUncurry"]["actual reif"]["user"] = {{1,0.00062376}, {2,0.00097030}, {3,0.00120792}, {4,0.00174257}, {5,0.00212871}, {6,0.00274257}, {7,0.00330693}, {8,0.00374257}, {9,0.00476238}, {10,0.00506931}, {11,0.02539604}, {12,0.00648515}, {13,0.00740594}, {14,0.00853465}, {15,0.00922772}, {16,0.01014851}, {17,0.01161386}, {18,0.01265347}, {19,0.01376238}, {20,0.01470297}, {21,0.01540594}, {22,0.01679208}, {23,0.01789109}, {24,0.01894059}, {25,0.02050495}, {26,0.02368317}, {27,0.02412871}, {28,0.02544554}, {29,0.02702970}, {30,0.02932673}, {31,0.02967327}, {32,0.03138614}, {33,0.03555446}, {34,0.03550495}, {35,0.03752475}, {36,0.04025743}, {37,0.04057426}, {38,0.04245545}, {39,0.04477228}, {40,0.04710891}, {41,0.04861386}, {42,0.05128713}, {43,0.05319802}, {44,0.05544554}, {45,0.05831683}, {46,0.06195050}, {47,0.06343564}, {48,0.06438614}, {49,0.07017822}, {50,0.07120792}, {51,0.07284158}, {52,0.07627723}, {53,0.08142574}, {54,0.08572277}, {55,0.08536634}, {56,0.08829703}, {57,0.08949505}, {58,0.09255446}, {59,0.09602970}, {60,0.09904950}, {61,0.10193069}, {62,0.11050495}, {63,0.11539604}, {64,0.11653465}, {65,0.11848515}, {66,0.12008911}, {67,0.12868317}, {68,0.13074257}, {69,0.13271287}, {70,0.14099010}, {71,0.14198020}, {72,0.14817822}, {73,0.14828713}, {74,0.15555446}, {75,0.15716832}, {76,0.16175248}, {77,0.16784158}, {78,0.17322772}, {79,0.17579208}, {80,0.17925743}, {81,0.18275248}, {82,0.18832673}, {83,0.19431683}, {84,0.20247525}, {85,0.20641584}, {86,0.20865347}, {87,0.21225743}, {88,0.22113861}, {89,0.22356436}, {90,0.23352475}, {91,0.23468317}, {92,0.24128713}, {93,0.24948515}, {94,0.25193069}, {95,0.25683168}, {96,0.26517822}, {97,0.26987129}, {98,0.27474257}, {99,0.28199010}, {100,0.28711881}, {101,0.29805941}, {102,0.30013861}, {103,0.30561386}, {104,0.31442574}, {105,0.32409901}, {106,0.33052475}, {107,0.34018812}, {108,0.34569307}, {109,0.35481188}, {110,0.36304950}, {111,0.37003960}, {112,0.37663366}, {113,0.38346535}, {114,0.39050495}, {115,0.39471287}, {116,0.40259406}, {117,0.40993069}, {118,0.41865347}, {119,0.42846535}, {120,0.43598020}, {121,0.44441584}, {122,0.45162376}, {123,0.46298020}, {124,0.47123762}, {125,0.47784158}, {126,0.48673267}, {127,0.49932673}, {128,0.50437624}, {129,0.51454455}, {130,0.52698020}, {131,0.54313861}, {132,0.54113861}, {133,0.55019802}, {134,0.56285149}, {135,0.57234653}, {136,0.57465347}, {137,0.59092079}, {138,0.60261386}, {139,0.60678218}, {140,0.62577228}, {141,0.63170297}, {142,0.64403960}, {143,0.65369307}, {144,0.68219802}, {145,0.67205941}, {146,0.68880198}, {147,0.69271287}, {148,0.71394059}, {149,0.72101980}, {150,0.73104950}, {151,0.74982178}, {152,0.75895050}, {153,0.77175248}, {154,0.77996040}, {155,0.95027723}, {156,0.87202970}, {157,0.94697030}, {158,0.83296040}, {159,0.84971287}, {160,0.86671287}, {161,0.87578218}, {162,0.88353465}, {163,0.89910891}, {164,0.90743564}, {165,0.92467327}, {166,0.93845545}, {167,0.95546535}, {168,0.96826733}, {169,0.98150495}, {170,1.00219802}, {171,1.01468317}, {172,1.03097030}, {173,1.05030693}, {174,1.05973267}, {175,1.06200000}, {176,1.1231429}, {177,1.1091143}, {178,1.1223429}, {179,1.1371714}, {180,1.1692857}, {181,1.2007714}, {182,1.1972571}, {183,1.2122000}, {184,1.2216571}, {185,1.2369143}, {186,1.2642000}, {187,1.2704000}, {188,1.2932286}, {189,1.2999143}, {190,1.3404000}, {191,1.3536857}, {192,1.3700286}, {193,1.3768286}, {194,1.4346286}, {195,1.4239429}, {196,1.4433429}, {197,1.4638000}, {198,1.4829429}, {199,1.5096857}, {200,1.5287143}, {201,1.5577429}, {202,1.5681143}, {203,1.5864857}, {204,1.6089143}, {205,1.6130857}, {206,1.6488000}, {207,1.6834857}, {208,1.6782000}, {209,1.7072286}, {210,1.7511143}, {211,1.7815714}, {212,1.7580000}, {213,1.8060286}, {214,1.8490286}, {215,1.8657714}, {216,1.8794571}, {217,1.9300000}, {218,1.9372571}, {219,1.9740857}, {220,2.0080000}, {221,2.0208571}, {222,2.0471429}, {223,2.0528286}, {224,2.0914000}, {225,2.1157143}, {226,2.1518000}, {227,2.1916000}, {228,2.1937429}, {229,2.2912857}, {230,2.2498286}, {231,2.3104857}, {232,2.2893714}, {233,2.3515714}, {234,2.3417143}, {235,2.4327143}, {236,2.4822571}, {237,2.5235429}, {238,2.4630286}, {239,2.5203429}, {240,2.5666571}, {241,2.5984000}, {242,2.6228286}, {243,2.6812286}, {244,2.6912000}, {245,2.7155429}, {246,3.3432857}, {247,2.7974857}, {248,2.8360857}, {249,2.8712857}, {250,2.9832000}, {251,2.9116571}, {252,2.9672857}, {253,3.0085143}, {254,3.0635143}, {255,3.0914571}, {256,3.1060286}, {257,3.1679429}, {258,3.1115143}, {259,3.2241143}, {260,3.2434571}, {261,3.2985714}, {262,3.3492571}, {263,3.3531714}, {264,3.3898571}, {265,3.4420571}, {266,3.4740571}, {267,3.5455714}, {268,3.5302857}, {269,3.6146857}, {270,3.6458571}, {271,3.6715429}, {272,3.6978000}, {273,3.7725714}, {274,3.8097714}, {275,3.8613429}, {276,3.8869143}, {277,3.9213714}, {278,3.9466857}, {279,4.0334000}, {280,4.0568571}, {281,4.1083429}, {282,4.0916286}, {283,4.2363143}, {284,4.2231714}, {285,4.2463714}, {286,4.3274000}, {287,4.4016286}, {288,4.4000000}, {289,4.4658857}, {290,4.5466286}, {291,4.5759714}, {292,4.5060857}, {293,4.5590857}, {294,4.6694286}, {295,4.6166571}, {296,4.8437714}, {297,4.8247143}, {298,4.9391714}, {299,4.8499143}, {300,4.9984000}, {301,5.0405143}, {302,5.1108000}, {303,5.1484857}, {304,5.2123429}, {305,5.0782000}, {306,5.3389143}, {307,5.3318286}, {308,5.4154286}, {309,5.4701714}, {310,5.5036571}, {311,5.5911714}, {312,5.5985714}, {313,5.7002571}, {314,5.7645429}, {315,5.5648000}, {316,5.7287143}, {317,5.8482286}, {318,5.9758286}, {319,6.0127429}, {320,6.1053143}, {321,6.0935714}, {322,6.1547714}, {323,6.2454571}, {324,6.2540286}, {325,6.3937143}, {326,6.4745714}, {327,6.5001143}, {328,6.5572000}, {329,6.6092000}, {330,6.6688286}, {331,6.6367143}, {332,6.8150000}, {333,6.9201143}, {334,6.7532571}, {335,7.0172571}, {336,7.0876571}, {337,7.1246571}, {338,7.2250286}, {339,7.2828000}, {340,7.3059714}, {341,7.1427143}, {342,7.2701143}, {343,7.4978000}, {344,7.5863143}, {345,7.6671429}, {346,7.6899429}, {347,7.7445143}, {348,7.8780286}, {349,7.9254857}, {350,7.9737714}, {351,8.0441714}, {352,8.1385429}, {353,8.1820571}, {354,8.2729714}, {355,8.3424857}, {356,8.4075143}, {357,8.4905429}, {358,8.5738286}, {359,8.6313429}, {360,8.7135429}, {361,8.7910857}, {362,8.8223429}, {363,8.9082000}, {364,8.9660000}, {365,9.0270571}, {366,9.1540286}, {367,9.1057429}, {368,9.3515143}, {369,9.3780286}, {370,9.4623714}, {371,9.5535143}, {372,9.5713714}, {373,9.5692857}, {374,9.7625143}, {375,9.8917429}, {376,9.9911714}, {377,9.9927714}, {378,10.1025429}, {379,10.1798286}, {380,9.7248286}, {381,10.3479429}, {382,10.2456857}, {383,10.5008000}, {384,10.5888000}, {385,10.5415143}, {386,10.6954286}, {387,10.8230571}, {388,10.9250286}, {389,10.8121429}, {390,10.9331143}, {391,11.0196571}, {392,11.2313143}, {393,11.3580286}, {394,11.4218286}, {395,11.3552571}, {396,11.5009429}, {397,11.3775714}, {398,11.6281714}, {399,11.8958857}, {400,11.8998286}, {401,12.0502571}, {402,12.1103143}, {403,12.2096286}, {404,12.3033714}, {405,12.4502000}, {406,12.5221429}, {407,12.6046286}, {408,12.6382857}, {409,12.8297143}, {410,12.7290857}, {411,12.9121714}, {412,13.0716286}, {413,12.6252857}, {414,12.9749429}, {415,13.2441429}, {416,13.4523143}, {417,13.5808857}, {418,13.6511143}, {419,13.6278571}, {420,13.8382286}, {421,13.9270286}, {422,14.1070571}, {423,14.1885714}, {424,14.2809429}, {425,14.2743714}, {426,14.4328286}, {427,14.4649714}, {428,14.6674571}, {429,14.7645714}, {430,14.8492000}, {431,14.4750286}, {432,15.1376857}, {433,15.1780000}, {434,15.3111429}, {435,15.4483714}, {436,15.5414571}, {437,15.6751429}, {438,15.7615714}, {439,15.8883714}, {440,15.9521429}, {441,16.0102286}, {442,16.2014000}, {443,16.3188857}, {444,16.4506286}, {445,16.5718857}, {446,16.6852286}, {447,16.7432857}, {448,16.8902571}, {449,16.9884571}, {450,17.0290000}, {451,17.1480000}, {452,17.2194286}, {453,17.3530857}, {454,17.4820000}, {455,17.4056286}, {456,17.1890000}, {457,17.7873143}, {458,17.9485714}, {459,18.0245143}, {460,18.1640000}, {461,17.9942571}, {462,18.2877429}, {463,18.5407143}, {464,18.4791143}, {465,18.6476286}, {466,18.8116000}, {467,18.9757143}, {468,19.0275714}, {469,19.2757143}, {470,19.1365429}, {471,19.4479429}, {472,19.5306286}, {473,19.5325429}, {474,19.8196857}, {475,19.9264286}, {476,20.0437714}, {477,20.1712000}, {478,20.2816571}, {479,20.4112571}, {480,20.4747429}, {481,20.5178286}, {482,20.8522286}, {483,20.9223429}, {484,21.1680000}, {485,21.0836286}, {486,21.3765143}, {487,21.5619143}, {488,21.5533143}, {489,21.6524857}, {490,21.7625714}, {491,21.8242286}, {492,22.1858000}, {493,22.1604000}, {494,22.1907714}, {495,22.7156286}, {496,22.6160571}, {497,22.9313714}, {498,23.1137143}, {499,23.2099429}, {500,23.3230857}, {505,23.8982000}, {510,24.7467714}, {515,25.4570571}, {520,26.2250857}, {525,26.7209429}, {530,26.9766571}, {535,28.3948000}, {540,28.9817429}, {545,30.0345143}, {550,30.8016000}, {555,31.7167714}, {560,32.4596857}, {565,33.2055714}, {570,34.1713429}, {575,35.1533714}, {580,35.9410571}, {585,37.0768286}, {590,37.8854000}, {595,38.6609714}, {600,39.9734000}, {605,40.7984000}, {610,41.9571429}, {615,42.7056857}, {620,44.0354857}, {625,45.2069143}, {630,46.1481429}, {635,47.1970571}, {640,48.0204571}, {645,49.2045429}, {650,50.5726286}, {655,51.5339714}, {660,53.1673714}, {665,54.3797429}, {670,55.4072000}, {675,56.5884571}, {680,58.1393714}, {685,58.8739143}, {690,60.4077714}, {695,61.4514571}, {700,62.8337714}};
data["big"]["LtacPrimUncurry"]["actual reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00010891}, {4,0.00003960}, {5,0.00000000}, {6,0.00003960}, {7,0.00007921}, {8,0.00000000}, {9,0.00003960}, {10,0.00003960}, {11,0.00003960}, {12,0.00000000}, {13,0.00003960}, {14,0.00000000}, {15,0.00011881}, {16,0.00007921}, {17,0.00000000}, {18,0.00007921}, {19,0.00003960}, {20,0.00003960}, {21,0.00000000}, {22,0.00003960}, {23,0.00003960}, {24,0.00007921}, {25,0.00011881}, {26,0.00003960}, {27,0.00000000}, {28,0.00003960}, {29,0.00006931}, {30,0.00000000}, {31,0.00003960}, {32,0.00000000}, {33,0.00002970}, {34,0.00007921}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00003960}, {41,0.00007921}, {42,0.00000000}, {43,0.00000000}, {44,0.00003960}, {45,0.00003960}, {46,0.00000000}, {47,0.00003960}, {48,0.00003960}, {49,0.00003960}, {50,0.00000000}, {51,0.00000000}, {52,0.00003960}, {53,0.00007921}, {54,0.00000000}, {55,0.00003960}, {56,0.00007921}, {57,0.00003960}, {58,0.00003960}, {59,0.00003960}, {60,0.00007921}, {61,0.00007921}, {62,0.00002970}, {63,0.00000000}, {64,0.00003960}, {65,0.00000000}, {66,0.00003960}, {67,0.00000000}, {68,0.00002970}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00003960}, {73,0.00003960}, {74,0.00002970}, {75,0.00000000}, {76,0.00003960}, {77,0.00003960}, {78,0.00002970}, {79,0.00011881}, {80,0.00000000}, {81,0.00003960}, {82,0.00003960}, {83,0.00000000}, {84,0.00003960}, {85,0.00003960}, {86,0.00003960}, {87,0.00007921}, {88,0.00002970}, {89,0.00007921}, {90,0.00011881}, {91,0.00000000}, {92,0.00010891}, {93,0.00007921}, {94,0.00003960}, {95,0.00007921}, {96,0.00000000}, {97,0.00003960}, {98,0.00002970}, {99,0.00007921}, {100,0.00003960}, {101,0.00000000}, {102,0.00007921}, {103,0.00003960}, {104,0.00003960}, {105,0.00003960}, {106,0.00003960}, {107,0.00000000}, {108,0.00007921}, {109,0.00006931}, {110,0.00015842}, {111,0.00000000}, {112,0.00002970}, {113,0.00003960}, {114,0.00002970}, {115,0.00000000}, {116,0.00002970}, {117,0.00007921}, {118,0.00011881}, {119,0.00007921}, {120,0.00003960}, {121,0.00003960}, {122,0.00003960}, {123,0.00006931}, {124,0.00003960}, {125,0.00007921}, {126,0.00007921}, {127,0.00011881}, {128,0.00000000}, {129,0.00015842}, {130,0.00007921}, {131,0.00003960}, {132,0.00003960}, {133,0.00007921}, {134,0.00014851}, {135,0.00007921}, {136,0.00007921}, {137,0.00000000}, {138,0.00003960}, {139,0.00003960}, {140,0.00015842}, {141,0.00003960}, {142,0.00014851}, {143,0.00010891}, {144,0.00019802}, {145,0.00003960}, {146,0.00006931}, {147,0.00003960}, {148,0.00003960}, {149,0.00003960}, {150,0.00003960}, {151,0.00007921}, {152,0.00011881}, {153,0.00006931}, {154,0.00000000}, {155,0.00062376}, {156,0.00022772}, {157,0.00060396}, {158,0.00003960}, {159,0.00019802}, {160,0.00011881}, {161,0.00007921}, {162,0.00023762}, {163,0.00003960}, {164,0.00003960}, {165,0.00015842}, {166,0.00007921}, {167,0.00011881}, {168,0.00003960}, {169,0.00014851}, {170,0.00022772}, {171,0.00007921}, {172,0.00000000}, {173,0.00007921}, {174,0.00015842}, {175,0.00014851}, {176,0.0001143}, {177,0.0000000}, {178,0.0005429}, {179,0.0001143}, {180,0.0004571}, {181,0.0001143}, {182,0.0002286}, {183,0.0000000}, {184,0.0000000}, {185,0.0000000}, {186,0.0000000}, {187,0.0002286}, {188,0.0001143}, {189,0.0002286}, {190,0.0003429}, {191,0.0000000}, {192,0.0000000}, {193,0.0000000}, {194,0.0000000}, {195,0.0000000}, {196,0.0001143}, {197,0.0001143}, {198,0.0002286}, {199,0.0000000}, {200,0.0003429}, {201,0.0004571}, {202,0.0000000}, {203,0.0001143}, {204,0.0001143}, {205,0.0000000}, {206,0.0002286}, {207,0.0002286}, {208,0.0002286}, {209,0.0002286}, {210,0.0001143}, {211,0.0001143}, {212,0.0002286}, {213,0.0003429}, {214,0.0004571}, {215,0.0000000}, {216,0.0002286}, {217,0.0001143}, {218,0.0003429}, {219,0.0001143}, {220,0.0000000}, {221,0.0003429}, {222,0.0004571}, {223,0.0001143}, {224,0.0001143}, {225,0.0001143}, {226,0.0004571}, {227,0.0001143}, {228,0.0001143}, {229,0.0003143}, {230,0.0000000}, {231,0.0000000}, {232,0.0003429}, {233,0.0000000}, {234,0.0001143}, {235,0.0005429}, {236,0.0003143}, {237,0.0000000}, {238,0.0002286}, {239,0.0000000}, {240,0.0002286}, {241,0.0002286}, {242,0.0000857}, {243,0.0003429}, {244,0.0002000}, {245,0.0002286}, {246,0.0045429}, {247,0.0003429}, {248,0.0003429}, {249,0.0002286}, {250,0.0001143}, {251,0.0001143}, {252,0.0002286}, {253,0.0001143}, {254,0.0000000}, {255,0.0004571}, {256,0.0003143}, {257,0.0004571}, {258,0.0003429}, {259,0.0002286}, {260,0.0001143}, {261,0.0004571}, {262,0.0001143}, {263,0.0001143}, {264,0.0001143}, {265,0.0003429}, {266,0.0000000}, {267,0.0004571}, {268,0.0000000}, {269,0.0002286}, {270,0.0000000}, {271,0.0003143}, {272,0.0002286}, {273,0.0002286}, {274,0.0002286}, {275,0.0001143}, {276,0.0002286}, {277,0.0002286}, {278,0.0000000}, {279,0.0008571}, {280,0.0002286}, {281,0.0001143}, {282,0.0003429}, {283,0.0001143}, {284,0.0003429}, {285,0.0003429}, {286,0.0003143}, {287,0.0003429}, {288,0.0003429}, {289,0.0008857}, {290,0.0001143}, {291,0.0003429}, {292,0.0003429}, {293,0.0004571}, {294,0.0006571}, {295,0.0004571}, {296,0.0002286}, {297,0.0000857}, {298,0.0003429}, {299,0.0000000}, {300,0.0002286}, {301,0.0005714}, {302,0.0004286}, {303,0.0003429}, {304,0.0004571}, {305,0.0003429}, {306,0.0004571}, {307,0.0010000}, {308,0.0008000}, {309,0.0005714}, {310,0.0001143}, {311,0.0003429}, {312,0.0006857}, {313,0.0004571}, {314,0.0004286}, {315,0.0002286}, {316,0.0008000}, {317,0.0004286}, {318,0.0001143}, {319,0.0001143}, {320,0.0006857}, {321,0.0005714}, {322,0.0005429}, {323,0.0005714}, {324,0.0002286}, {325,0.0003429}, {326,0.0006571}, {327,0.0002286}, {328,0.0004571}, {329,0.0006857}, {330,0.0004286}, {331,0.0004571}, {332,0.0001143}, {333,0.0002286}, {334,0.0002286}, {335,0.0004571}, {336,0.0002286}, {337,0.0002286}, {338,0.0006857}, {339,0.0003429}, {340,0.0001143}, {341,0.0004571}, {342,0.0007714}, {343,0.0003429}, {344,0.0005714}, {345,0.0002286}, {346,0.0003429}, {347,0.0001143}, {348,0.0004571}, {349,0.0004571}, {350,0.0004286}, {351,0.0004571}, {352,0.0001143}, {353,0.0004571}, {354,0.0008000}, {355,0.0004286}, {356,0.0004571}, {357,0.0003429}, {358,0.0003429}, {359,0.0005714}, {360,0.0006857}, {361,0.0004571}, {362,0.0005143}, {363,0.0002286}, {364,0.0003429}, {365,0.0003429}, {366,0.0006857}, {367,0.0005429}, {368,0.0006857}, {369,0.0010000}, {370,0.0009143}, {371,0.0010857}, {372,0.0005714}, {373,0.0004571}, {374,0.0004571}, {375,0.0004571}, {376,0.0010000}, {377,0.0004571}, {378,0.0002286}, {379,0.0002286}, {380,0.0006571}, {381,0.0006857}, {382,0.0014857}, {383,0.0008000}, {384,0.0006857}, {385,0.0011429}, {386,0.0008000}, {387,0.0003143}, {388,0.0012571}, {389,0.0009143}, {390,0.0008571}, {391,0.0008000}, {392,0.0011429}, {393,0.0006571}, {394,0.0009143}, {395,0.0005714}, {396,0.0004571}, {397,0.0012571}, {398,0.0004286}, {399,0.0008000}, {400,0.0007714}, {401,0.0004571}, {402,0.0007714}, {403,0.0007714}, {404,0.0011429}, {405,0.0009143}, {406,0.0002286}, {407,0.0012571}, {408,0.0006857}, {409,0.0010286}, {410,0.0010286}, {411,0.0011429}, {412,0.0009143}, {413,0.0004286}, {414,0.0007714}, {415,0.0006857}, {416,0.0012000}, {417,0.0003429}, {418,0.0006857}, {419,0.0004571}, {420,0.0006857}, {421,0.0011429}, {422,0.0002286}, {423,0.0008000}, {424,0.0003429}, {425,0.0008857}, {426,0.0006571}, {427,0.0011143}, {428,0.0012286}, {429,0.0005143}, {430,0.0011429}, {431,0.0013714}, {432,0.0013429}, {433,0.0009143}, {434,0.0011429}, {435,0.0010286}, {436,0.0008571}, {437,0.0006857}, {438,0.0006571}, {439,0.0014857}, {440,0.0011429}, {441,0.0006857}, {442,0.0009143}, {443,0.0008000}, {444,0.0004571}, {445,0.0004571}, {446,0.0013714}, {447,0.0012571}, {448,0.0006857}, {449,0.0016857}, {450,0.0011429}, {451,0.0014857}, {452,0.0010286}, {453,0.0012571}, {454,0.0019143}, {455,0.0020571}, {456,0.0014857}, {457,0.0014286}, {458,0.0010000}, {459,0.0011429}, {460,0.0009143}, {461,0.0011429}, {462,0.0011429}, {463,0.0008000}, {464,0.0014857}, {465,0.0012571}, {466,0.0016857}, {467,0.0015714}, {468,0.0013143}, {469,0.0011429}, {470,0.0013429}, {471,0.0018286}, {472,0.0012571}, {473,0.0010000}, {474,0.0012286}, {475,0.0011143}, {476,0.0011429}, {477,0.0010000}, {478,0.0016857}, {479,0.0017143}, {480,0.0020571}, {481,0.0006857}, {482,0.0006571}, {483,0.0016000}, {484,0.0009143}, {485,0.0008000}, {486,0.0006857}, {487,0.0008000}, {488,0.0008000}, {489,0.0011429}, {490,0.0009143}, {491,0.0008857}, {492,0.0009143}, {493,0.0011143}, {494,0.0016000}, {495,0.0008000}, {496,0.0010286}, {497,0.0014000}, {498,0.0014857}, {499,0.0009143}, {500,0.0012286}, {505,0.0006857}, {510,0.0010286}, {515,0.0011429}, {520,0.0010286}, {525,0.0018000}, {530,0.0012571}, {535,0.0018286}, {540,0.0016000}, {545,0.0021143}, {550,0.0024000}, {555,0.0018000}, {560,0.0017143}, {565,0.0014857}, {570,0.0016000}, {575,0.0022571}, {580,0.0012571}, {585,0.0012571}, {590,0.0008857}, {595,0.0019143}, {600,0.0021429}, {605,0.0021429}, {610,0.0025143}, {615,0.0028571}, {620,0.0028286}, {625,0.0020571}, {630,0.0020286}, {635,0.0023714}, {640,0.0024000}, {645,0.0026000}, {650,0.0016857}, {655,0.0021143}, {660,0.0023714}, {665,0.0023714}, {670,0.0034286}, {675,0.0023429}, {680,0.0043429}, {685,0.0035429}, {690,0.0038286}, {695,0.0031429}, {700,0.0066286}};
data["big"]["LtacPrimUncurry"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000990}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.0000000}, {177,0.0000000}, {178,0.0000000}, {179,0.0000000}, {180,0.0000000}, {181,0.0000000}, {182,0.0000000}, {183,0.0000000}, {184,0.0000000}, {185,0.0000000}, {186,0.0000000}, {187,0.0000000}, {188,0.0000000}, {189,0.0000000}, {190,0.0000000}, {191,0.0000000}, {192,0.0000000}, {193,0.0000000}, {194,0.0000000}, {195,0.0000000}, {196,0.0000000}, {197,0.0000000}, {198,0.0000000}, {199,0.0000000}, {200,0.0000000}, {201,0.0000000}, {202,0.0000000}, {203,0.0000000}, {204,0.0000000}, {205,0.0000000}, {206,0.0000000}, {207,0.0000000}, {208,0.0000000}, {209,0.0000000}, {210,0.0000000}, {211,0.0000000}, {212,0.0000000}, {213,0.0000000}, {214,0.0000000}, {215,0.0000000}, {216,0.0000000}, {217,0.0000000}, {218,0.0000000}, {219,0.0000000}, {220,0.0000000}, {221,0.0000000}, {222,0.0000000}, {223,0.0000000}, {224,0.0000000}, {225,0.0000000}, {226,0.0000000}, {227,0.0000000}, {228,0.0000000}, {229,0.0000000}, {230,0.0000000}, {231,0.0000000}, {232,0.0000000}, {233,0.0000000}, {234,0.0000000}, {235,0.0000000}, {236,0.0000000}, {237,0.0000000}, {238,0.0000000}, {239,0.0000000}, {240,0.0000000}, {241,0.0000000}, {242,0.0000000}, {243,0.0000000}, {244,0.0000000}, {245,0.0000000}, {246,0.0000000}, {247,0.0000000}, {248,0.0000000}, {249,0.0000000}, {250,0.0000000}, {251,0.0000000}, {252,0.0000000}, {253,0.0000000}, {254,0.0000000}, {255,0.0000000}, {256,0.0000000}, {257,0.0000000}, {258,0.0000000}, {259,0.0000000}, {260,0.0000000}, {261,0.0000000}, {262,0.0000000}, {263,0.0000000}, {264,0.0000000}, {265,0.0000000}, {266,0.0000000}, {267,0.0000000}, {268,0.0000000}, {269,0.0000000}, {270,0.0000000}, {271,0.0000000}, {272,0.0000000}, {273,0.0000000}, {274,0.0000000}, {275,0.0000000}, {276,0.0000000}, {277,0.0000000}, {278,0.0000000}, {279,0.0000000}, {280,0.0000000}, {281,0.0000000}, {282,0.0000000}, {283,0.0000000}, {284,0.0000000}, {285,0.0000000}, {286,0.0000000}, {287,0.0000000}, {288,0.0000000}, {289,0.0000000}, {290,0.0000000}, {291,0.0000000}, {292,0.0000000}, {293,0.0000000}, {294,0.0000000}, {295,0.0000000}, {296,0.0000000}, {297,0.0000000}, {298,0.0000000}, {299,0.0000000}, {300,0.0000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0020000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0020571}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000286}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0017714}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000571}, {570,0.0000571}, {575,0.0000571}, {580,0.0002286}, {585,0.0004000}, {590,0.0004286}, {595,0.0006000}, {600,0.0005429}, {605,0.0006286}, {610,0.0007429}, {615,0.0008000}, {620,0.0009429}, {625,0.0009429}, {630,0.0009143}, {635,0.0010000}, {640,0.0009714}, {645,0.0009429}, {650,0.0010000}, {655,0.0010000}, {660,0.0009714}, {665,0.0010000}, {670,0.0010000}, {675,0.0010000}, {680,0.0010000}, {685,0.0010000}, {690,0.0010000}, {695,0.0010000}, {700,0.0010000}};
data["big"]["LtacPrimUncurry"]["cbv"]["user"] = {{1,0.00009901}, {2,0.00002970}, {3,0.00011881}, {4,0.00000000}, {5,0.00000000}, {6,0.00007921}, {7,0.00003960}, {8,0.00000000}, {9,0.00003960}, {10,0.00007921}, {11,0.00003960}, {12,0.00000000}, {13,0.00000000}, {14,0.00006931}, {15,0.00000000}, {16,0.00003960}, {17,0.00002970}, {18,0.00007921}, {19,0.00000000}, {20,0.00006931}, {21,0.00014851}, {22,0.00007921}, {23,0.00003960}, {24,0.00002970}, {25,0.00003960}, {26,0.00011881}, {27,0.00000000}, {28,0.00003960}, {29,0.00007921}, {30,0.00010891}, {31,0.00007921}, {32,0.00007921}, {33,0.00003960}, {34,0.00006931}, {35,0.00003960}, {36,0.00003960}, {37,0.00005941}, {38,0.00002970}, {39,0.00007921}, {40,0.00006931}, {41,0.00002970}, {42,0.00003960}, {43,0.00000000}, {44,0.00011881}, {45,0.00003960}, {46,0.00013861}, {47,0.00002970}, {48,0.00015842}, {49,0.00006931}, {50,0.00003960}, {51,0.00018812}, {52,0.00000000}, {53,0.00008911}, {54,0.00010891}, {55,0.00002970}, {56,0.00002970}, {57,0.00007921}, {58,0.00000000}, {59,0.00019802}, {60,0.00013861}, {61,0.00006931}, {62,0.00000000}, {63,0.00011881}, {64,0.00014851}, {65,0.00014851}, {66,0.00010891}, {67,0.00006931}, {68,0.00019802}, {69,0.00015842}, {70,0.00006931}, {71,0.00017822}, {72,0.00006931}, {73,0.00003960}, {74,0.00035644}, {75,0.00006931}, {76,0.00013861}, {77,0.00021782}, {78,0.00013861}, {79,0.00002970}, {80,0.00003960}, {81,0.00009901}, {82,0.00009901}, {83,0.00021782}, {84,0.00024752}, {85,0.00013861}, {86,0.00010891}, {87,0.00009901}, {88,0.00009901}, {89,0.00020792}, {90,0.00015842}, {91,0.00012871}, {92,0.00022772}, {93,0.00008911}, {94,0.00023762}, {95,0.00019802}, {96,0.00008911}, {97,0.00017822}, {98,0.00016832}, {99,0.00015842}, {100,0.00015842}, {101,0.00018812}, {102,0.00011881}, {103,0.00007921}, {104,0.00025743}, {105,0.00017822}, {106,0.00016832}, {107,0.00015842}, {108,0.00035644}, {109,0.00022772}, {110,0.00023762}, {111,0.00009901}, {112,0.00021782}, {113,0.00007921}, {114,0.00017822}, {115,0.00030693}, {116,0.00022772}, {117,0.00034653}, {118,0.00015842}, {119,0.00024752}, {120,0.00010891}, {121,0.00012871}, {122,0.00017822}, {123,0.00010891}, {124,0.00012871}, {125,0.00002970}, {126,0.00032673}, {127,0.00012871}, {128,0.00013861}, {129,0.00015842}, {130,0.00087129}, {131,0.00017822}, {132,0.00028713}, {133,0.00028713}, {134,0.00015842}, {135,0.00024752}, {136,0.00021782}, {137,0.00020792}, {138,0.00006931}, {139,0.00014851}, {140,0.00022772}, {141,0.00020792}, {142,0.00023762}, {143,0.00025743}, {144,0.00008911}, {145,0.00021782}, {146,0.00023762}, {147,0.00030693}, {148,0.00030693}, {149,0.00019802}, {150,0.00027723}, {151,0.00027723}, {152,0.00023762}, {153,0.00024752}, {154,0.00035644}, {155,0.00018812}, {156,0.00016832}, {157,0.00015842}, {158,0.00032673}, {159,0.00012871}, {160,0.00041584}, {161,0.00016832}, {162,0.00036634}, {163,0.00027723}, {164,0.00025743}, {165,0.00037624}, {166,0.00017822}, {167,0.00024752}, {168,0.00034653}, {169,0.00021782}, {170,0.00032673}, {171,0.00032673}, {172,0.00022772}, {173,0.00023762}, {174,0.00037624}, {175,0.00028713}, {176,0.0002000}, {177,0.0000857}, {178,0.0006571}, {179,0.0001714}, {180,0.0001143}, {181,0.0002000}, {182,0.0002000}, {183,0.0002286}, {184,0.0003143}, {185,0.0003143}, {186,0.0005143}, {187,0.0002000}, {188,0.0001143}, {189,0.0002286}, {190,0.0002857}, {191,0.0001143}, {192,0.0004286}, {193,0.0004286}, {194,0.0002000}, {195,0.0004286}, {196,0.0001143}, {197,0.0001143}, {198,0.0003143}, {199,0.0000000}, {200,0.0002286}, {201,0.0004000}, {202,0.0004000}, {203,0.0001143}, {204,0.0004571}, {205,0.0001714}, {206,0.0005714}, {207,0.0000857}, {208,0.0003429}, {209,0.0003429}, {210,0.0006571}, {211,0.0002571}, {212,0.0007429}, {213,0.0002857}, {214,0.0000857}, {215,0.0000000}, {216,0.0003429}, {217,0.0004857}, {218,0.0003143}, {219,0.0006000}, {220,0.0005143}, {221,0.0001143}, {222,0.0002286}, {223,0.0005714}, {224,0.0001143}, {225,0.0004571}, {226,0.0004286}, {227,0.0004286}, {228,0.0004286}, {229,0.0009714}, {230,0.0002000}, {231,0.0003143}, {232,0.0006286}, {233,0.0002286}, {234,0.0004571}, {235,0.0002286}, {236,0.0006571}, {237,0.0003143}, {238,0.0005714}, {239,0.0001143}, {240,0.0007714}, {241,0.0001143}, {242,0.0001143}, {243,0.0007143}, {244,0.0001143}, {245,0.0006571}, {246,0.0003429}, {247,0.0002286}, {248,0.0004286}, {249,0.0004571}, {250,0.0003429}, {251,0.0003429}, {252,0.0003429}, {253,0.0007714}, {254,0.0002286}, {255,0.0005429}, {256,0.0005429}, {257,0.0002286}, {258,0.0005429}, {259,0.0004571}, {260,0.0004571}, {261,0.0002286}, {262,0.0004000}, {263,0.0008000}, {264,0.0007714}, {265,0.0003429}, {266,0.0004571}, {267,0.0003429}, {268,0.0004000}, {269,0.0004571}, {270,0.0006571}, {271,0.0002857}, {272,0.0007429}, {273,0.0004571}, {274,0.0004571}, {275,0.0001714}, {276,0.0002000}, {277,0.0013143}, {278,0.0006857}, {279,0.0001143}, {280,0.0005429}, {281,0.0005143}, {282,0.0003143}, {283,0.0004286}, {284,0.0004000}, {285,0.0008571}, {286,0.0006286}, {287,0.0005714}, {288,0.0002857}, {289,0.0007714}, {290,0.0001143}, {291,0.0008286}, {292,0.0006857}, {293,0.0004571}, {294,0.0003429}, {295,0.0004571}, {296,0.0004571}, {297,0.0003429}, {298,0.0002286}, {299,0.0004286}, {300,0.0000000}, {301,0.0005143}, {302,0.0005714}, {303,0.0005714}, {304,0.0005714}, {305,0.0004571}, {306,0.0007714}, {307,0.0005429}, {308,0.0004286}, {309,0.0004571}, {310,0.0005429}, {311,0.0003429}, {312,0.0010286}, {313,0.0008000}, {314,0.0004571}, {315,0.0006571}, {316,0.0006571}, {317,0.0004571}, {318,0.0000857}, {319,0.0023714}, {320,0.0009143}, {321,0.0004571}, {322,0.0006857}, {323,0.0006286}, {324,0.0008857}, {325,0.0004571}, {326,0.0002286}, {327,0.0002286}, {328,0.0008857}, {329,0.0004000}, {330,0.0005143}, {331,0.0014286}, {332,0.0004000}, {333,0.0005429}, {334,0.0004286}, {335,0.0005714}, {336,0.0007714}, {337,0.0008286}, {338,0.0005714}, {339,0.0008000}, {340,0.0002286}, {341,0.0006571}, {342,0.0006286}, {343,0.0008571}, {344,0.0002571}, {345,0.0003143}, {346,0.0004857}, {347,0.0005143}, {348,0.0003143}, {349,0.0004000}, {350,0.0002000}, {351,0.0003714}, {352,0.0003714}, {353,0.0004000}, {354,0.0007143}, {355,0.0006000}, {356,0.0005143}, {357,0.0005429}, {358,0.0007714}, {359,0.0002000}, {360,0.0002857}, {361,0.0005143}, {362,0.0011429}, {363,0.0007714}, {364,0.0006286}, {365,0.0004857}, {366,0.0005714}, {367,0.0004000}, {368,0.0005714}, {369,0.0009429}, {370,0.0005714}, {371,0.0004000}, {372,0.0004286}, {373,0.0007429}, {374,0.0006000}, {375,0.0006857}, {376,0.0003429}, {377,0.0004000}, {378,0.0006286}, {379,0.0005143}, {380,0.0001714}, {381,0.0006857}, {382,0.0003429}, {383,0.0003429}, {384,0.0011714}, {385,0.0008571}, {386,0.0007429}, {387,0.0006286}, {388,0.0006857}, {389,0.0002286}, {390,0.0004857}, {391,0.0006571}, {392,0.0003714}, {393,0.0003714}, {394,0.0004571}, {395,0.0005143}, {396,0.0007714}, {397,0.0005429}, {398,0.0006571}, {399,0.0006571}, {400,0.0004000}, {401,0.0005714}, {402,0.0005429}, {403,0.0007714}, {404,0.0005143}, {405,0.0007714}, {406,0.0006000}, {407,0.0004000}, {408,0.0006571}, {409,0.0007714}, {410,0.0006286}, {411,0.0007429}, {412,0.0006857}, {413,0.0002000}, {414,0.0004286}, {415,0.0002000}, {416,0.0008571}, {417,0.0002857}, {418,0.0005429}, {419,0.0008571}, {420,0.0009429}, {421,0.0006571}, {422,0.0006571}, {423,0.0006857}, {424,0.0004000}, {425,0.0004000}, {426,0.0006000}, {427,0.0000857}, {428,0.0007429}, {429,0.0003714}, {430,0.0003429}, {431,0.0004571}, {432,0.0005714}, {433,0.0010000}, {434,0.0022857}, {435,0.0004000}, {436,0.0006000}, {437,0.0008286}, {438,0.0004571}, {439,0.0008286}, {440,0.0002571}, {441,0.0008000}, {442,0.0005429}, {443,0.0006571}, {444,0.0006857}, {445,0.0002571}, {446,0.0004571}, {447,0.0008000}, {448,0.0005714}, {449,0.0006286}, {450,0.0004571}, {451,0.0005429}, {452,0.0002571}, {453,0.0006000}, {454,0.0003429}, {455,0.0007714}, {456,0.0009429}, {457,0.0005714}, {458,0.0005714}, {459,0.0006286}, {460,0.0006571}, {461,0.0009429}, {462,0.0005429}, {463,0.0005429}, {464,0.0009143}, {465,0.0003429}, {466,0.0018857}, {467,0.0008000}, {468,0.0005429}, {469,0.0003429}, {470,0.0008000}, {471,0.0006571}, {472,0.0006286}, {473,0.0012286}, {474,0.0006857}, {475,0.0005714}, {476,0.0012000}, {477,0.0002000}, {478,0.0007429}, {479,0.0006571}, {480,0.0000857}, {481,0.0006571}, {482,0.0008571}, {483,0.0008000}, {484,0.0004857}, {485,0.0006000}, {486,0.0010571}, {487,0.0003429}, {488,0.0007143}, {489,0.0006571}, {490,0.0004571}, {491,0.0005429}, {492,0.0006857}, {493,0.0006571}, {494,0.0007429}, {495,0.0007429}, {496,0.0007714}, {497,0.0007143}, {498,0.0009714}, {499,0.0004286}, {500,0.0003429}, {505,0.0009429}, {510,0.0004571}, {515,0.0005429}, {520,0.0005714}, {525,0.0011143}, {530,0.0006571}, {535,0.0008571}, {540,0.0006571}, {545,0.0007143}, {550,0.0004286}, {555,0.0010000}, {560,0.0004857}, {565,0.0010286}, {570,0.0005714}, {575,0.0007429}, {580,0.0008000}, {585,0.0007429}, {590,0.0011429}, {595,0.0008857}, {600,0.0009429}, {605,0.0007143}, {610,0.0010571}, {615,0.0006571}, {620,0.0006857}, {625,0.0010571}, {630,0.0004571}, {635,0.0008000}, {640,0.0006857}, {645,0.0010571}, {650,0.0011429}, {655,0.0007143}, {660,0.0011143}, {665,0.0009714}, {670,0.0012000}, {675,0.0008857}, {680,0.0008571}, {685,0.0009714}, {690,0.0006857}, {695,0.0010000}, {700,0.0011143}};
data["big"]["LtacPrimUncurry"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00003960}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00002970}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00003960}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00003960}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00003960}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00003960}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00003960}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00003960}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00002970}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00003960}, {144,0.00000000}, {145,0.00003960}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00003960}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.0000000}, {177,0.0000000}, {178,0.0000000}, {179,0.0000000}, {180,0.0000000}, {181,0.0000000}, {182,0.0000000}, {183,0.0000000}, {184,0.0000000}, {185,0.0000000}, {186,0.0000000}, {187,0.0000000}, {188,0.0000000}, {189,0.0000000}, {190,0.0000000}, {191,0.0000000}, {192,0.0000000}, {193,0.0000000}, {194,0.0000000}, {195,0.0000000}, {196,0.0000000}, {197,0.0000000}, {198,0.0000000}, {199,0.0001143}, {200,0.0000000}, {201,0.0000000}, {202,0.0000000}, {203,0.0000857}, {204,0.0000000}, {205,0.0000000}, {206,0.0000000}, {207,0.0000000}, {208,0.0000000}, {209,0.0000000}, {210,0.0000000}, {211,0.0000000}, {212,0.0000000}, {213,0.0000000}, {214,0.0000000}, {215,0.0000000}, {216,0.0000000}, {217,0.0000000}, {218,0.0000000}, {219,0.0000000}, {220,0.0000000}, {221,0.0000000}, {222,0.0000000}, {223,0.0000000}, {224,0.0000000}, {225,0.0000000}, {226,0.0000000}, {227,0.0000000}, {228,0.0000000}, {229,0.0000000}, {230,0.0000000}, {231,0.0000000}, {232,0.0000000}, {233,0.0000000}, {234,0.0000000}, {235,0.0000000}, {236,0.0000000}, {237,0.0000000}, {238,0.0000000}, {239,0.0000000}, {240,0.0000000}, {241,0.0000000}, {242,0.0000000}, {243,0.0000000}, {244,0.0001143}, {245,0.0000000}, {246,0.0000000}, {247,0.0000000}, {248,0.0000000}, {249,0.0000000}, {250,0.0000000}, {251,0.0000000}, {252,0.0000000}, {253,0.0000000}, {254,0.0000000}, {255,0.0000000}, {256,0.0000000}, {257,0.0000000}, {258,0.0000000}, {259,0.0000000}, {260,0.0000000}, {261,0.0001143}, {262,0.0000000}, {263,0.0000000}, {264,0.0000000}, {265,0.0000000}, {266,0.0000000}, {267,0.0000000}, {268,0.0000000}, {269,0.0000000}, {270,0.0000000}, {271,0.0000000}, {272,0.0000000}, {273,0.0000000}, {274,0.0000000}, {275,0.0000000}, {276,0.0000000}, {277,0.0000000}, {278,0.0000000}, {279,0.0000000}, {280,0.0000000}, {281,0.0000000}, {282,0.0001143}, {283,0.0000000}, {284,0.0000000}, {285,0.0000000}, {286,0.0000000}, {287,0.0001143}, {288,0.0000000}, {289,0.0000000}, {290,0.0000000}, {291,0.0000000}, {292,0.0000000}, {293,0.0000000}, {294,0.0000000}, {295,0.0000000}, {296,0.0000000}, {297,0.0000000}, {298,0.0000000}, {299,0.0000000}, {300,0.0000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0001143}, {366,0.0000000}, {367,0.0000000}, {368,0.0001143}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0001143}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0001143}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}};
data["big"]["LtacPrimUncurry"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.0000000}, {177,0.0000000}, {178,0.0000000}, {179,0.0000000}, {180,0.0000000}, {181,0.0000000}, {182,0.0000000}, {183,0.0000000}, {184,0.0000000}, {185,0.0000000}, {186,0.0000000}, {187,0.0000000}, {188,0.0000000}, {189,0.0000000}, {190,0.0000000}, {191,0.0000000}, {192,0.0000000}, {193,0.0000000}, {194,0.0000000}, {195,0.0000000}, {196,0.0000000}, {197,0.0000000}, {198,0.0000000}, {199,0.0000000}, {200,0.0000000}, {201,0.0000000}, {202,0.0000000}, {203,0.0000000}, {204,0.0000000}, {205,0.0000000}, {206,0.0000000}, {207,0.0000000}, {208,0.0000000}, {209,0.0000000}, {210,0.0000000}, {211,0.0000000}, {212,0.0000000}, {213,0.0000000}, {214,0.0000000}, {215,0.0000000}, {216,0.0000000}, {217,0.0000000}, {218,0.0000000}, {219,0.0000000}, {220,0.0000000}, {221,0.0000000}, {222,0.0000000}, {223,0.0000000}, {224,0.0000000}, {225,0.0000000}, {226,0.0000000}, {227,0.0000000}, {228,0.0000000}, {229,0.0000000}, {230,0.0000000}, {231,0.0000000}, {232,0.0000000}, {233,0.0000000}, {234,0.0000000}, {235,0.0000000}, {236,0.0000000}, {237,0.0000000}, {238,0.0000000}, {239,0.0000000}, {240,0.0000000}, {241,0.0000000}, {242,0.0000000}, {243,0.0000000}, {244,0.0000000}, {245,0.0000000}, {246,0.0000000}, {247,0.0000000}, {248,0.0000000}, {249,0.0000000}, {250,0.0000000}, {251,0.0000000}, {252,0.0000000}, {253,0.0000000}, {254,0.0000000}, {255,0.0000000}, {256,0.0000000}, {257,0.0000000}, {258,0.0000000}, {259,0.0000000}, {260,0.0000000}, {261,0.0000000}, {262,0.0010000}, {263,0.0000000}, {264,0.0000000}, {265,0.0000000}, {266,0.0000000}, {267,0.0000000}, {268,0.0000000}, {269,0.0000000}, {270,0.0000000}, {271,0.0000000}, {272,0.0000000}, {273,0.0000000}, {274,0.0000000}, {275,0.0000000}, {276,0.0000000}, {277,0.0000000}, {278,0.0000000}, {279,0.0000000}, {280,0.0000000}, {281,0.0000000}, {282,0.0000000}, {283,0.0000000}, {284,0.0000000}, {285,0.0000000}, {286,0.0000000}, {287,0.0000000}, {288,0.0000000}, {289,0.0000000}, {290,0.0000000}, {291,0.0000000}, {292,0.0000000}, {293,0.0000000}, {294,0.0000000}, {295,0.0000000}, {296,0.0000000}, {297,0.0000000}, {298,0.0000000}, {299,0.0000000}, {300,0.0000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0011429}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0019429}, {700,0.0000000}};
data["big"]["LtacPrimUncurry"]["eval lazy"]["user"] = {{1,0.00000000}, {2,0.00002970}, {3,0.00000000}, {4,0.00000000}, {5,0.00003960}, {6,0.00007921}, {7,0.00003960}, {8,0.00007921}, {9,0.00006931}, {10,0.00000000}, {11,0.00000000}, {12,0.00002970}, {13,0.00000000}, {14,0.00000000}, {15,0.00005941}, {16,0.00000000}, {17,0.00002970}, {18,0.00007921}, {19,0.00000000}, {20,0.00007921}, {21,0.00013861}, {22,0.00003960}, {23,0.00003960}, {24,0.00003960}, {25,0.00005941}, {26,0.00007921}, {27,0.00002970}, {28,0.00002970}, {29,0.00003960}, {30,0.00018812}, {31,0.00003960}, {32,0.00003960}, {33,0.00002970}, {34,0.00003960}, {35,0.00013861}, {36,0.00006931}, {37,0.00013861}, {38,0.00002970}, {39,0.00010891}, {40,0.00008911}, {41,0.00014851}, {42,0.00011881}, {43,0.00002970}, {44,0.00002970}, {45,0.00005941}, {46,0.00000000}, {47,0.00002970}, {48,0.00002970}, {49,0.00000000}, {50,0.00006931}, {51,0.00006931}, {52,0.00010891}, {53,0.00011881}, {54,0.00010891}, {55,0.00014851}, {56,0.00009901}, {57,0.00010891}, {58,0.00005941}, {59,0.00007921}, {60,0.00000000}, {61,0.00025743}, {62,0.00023762}, {63,0.00006931}, {64,0.00017822}, {65,0.00017822}, {66,0.00011881}, {67,0.00031683}, {68,0.00003960}, {69,0.00007921}, {70,0.00012871}, {71,0.00010891}, {72,0.00003960}, {73,0.00002970}, {74,0.00006931}, {75,0.00013861}, {76,0.00010891}, {77,0.00020792}, {78,0.00008911}, {79,0.00002970}, {80,0.00012871}, {81,0.00000000}, {82,0.00012871}, {83,0.00007921}, {84,0.00020792}, {85,0.00006931}, {86,0.00003960}, {87,0.00009901}, {88,0.00013861}, {89,0.00010891}, {90,0.00016832}, {91,0.00022772}, {92,0.00006931}, {93,0.00008911}, {94,0.00013861}, {95,0.00017822}, {96,0.00013861}, {97,0.00019802}, {98,0.00025743}, {99,0.00025743}, {100,0.00015842}, {101,0.00017822}, {102,0.00006931}, {103,0.00005941}, {104,0.00012871}, {105,0.00002970}, {106,0.00010891}, {107,0.00009901}, {108,0.00026733}, {109,0.00000000}, {110,0.00010891}, {111,0.00009901}, {112,0.00011881}, {113,0.00009901}, {114,0.00013861}, {115,0.00022772}, {116,0.00019802}, {117,0.00019802}, {118,0.00000000}, {119,0.00016832}, {120,0.00005941}, {121,0.00011881}, {122,0.00019802}, {123,0.00010891}, {124,0.00016832}, {125,0.00011881}, {126,0.00007921}, {127,0.00012871}, {128,0.00015842}, {129,0.00015842}, {130,0.00016832}, {131,0.00012871}, {132,0.00018812}, {133,0.00016832}, {134,0.00029703}, {135,0.00011881}, {136,0.00006931}, {137,0.00014851}, {138,0.00012871}, {139,0.00003960}, {140,0.00016832}, {141,0.00018812}, {142,0.00012871}, {143,0.00019802}, {144,0.00012871}, {145,0.00000000}, {146,0.00012871}, {147,0.00026733}, {148,0.00015842}, {149,0.00015842}, {150,0.00005941}, {151,0.00019802}, {152,0.00021782}, {153,0.00006931}, {154,0.00034653}, {155,0.00022772}, {156,0.00034653}, {157,0.00027723}, {158,0.00016832}, {159,0.00020792}, {160,0.00017822}, {161,0.00009901}, {162,0.00018812}, {163,0.00008911}, {164,0.00029703}, {165,0.00019802}, {166,0.00017822}, {167,0.00018812}, {168,0.00023762}, {169,0.00018812}, {170,0.00017822}, {171,0.00032673}, {172,0.00020792}, {173,0.00025743}, {174,0.00028713}, {175,0.00011881}, {176,0.0004286}, {177,0.0000000}, {178,0.0001143}, {179,0.0001143}, {180,0.0000000}, {181,0.0003143}, {182,0.0002286}, {183,0.0002286}, {184,0.0002000}, {185,0.0001143}, {186,0.0003143}, {187,0.0001714}, {188,0.0002286}, {189,0.0003143}, {190,0.0000000}, {191,0.0002857}, {192,0.0002000}, {193,0.0002000}, {194,0.0000857}, {195,0.0005143}, {196,0.0004286}, {197,0.0002286}, {198,0.0004286}, {199,0.0006000}, {200,0.0002286}, {201,0.0004857}, {202,0.0000857}, {203,0.0001143}, {204,0.0001143}, {205,0.0002857}, {206,0.0003143}, {207,0.0004571}, {208,0.0001143}, {209,0.0003143}, {210,0.0001143}, {211,0.0006286}, {212,0.0003143}, {213,0.0001143}, {214,0.0002000}, {215,0.0001714}, {216,0.0003429}, {217,0.0000857}, {218,0.0004286}, {219,0.0002000}, {220,0.0000857}, {221,0.0000000}, {222,0.0005714}, {223,0.0002000}, {224,0.0003143}, {225,0.0002286}, {226,0.0001143}, {227,0.0002286}, {228,0.0004286}, {229,0.0003429}, {230,0.0004286}, {231,0.0002857}, {232,0.0001143}, {233,0.0002000}, {234,0.0001143}, {235,0.0003429}, {236,0.0002286}, {237,0.0002000}, {238,0.0003429}, {239,0.0002286}, {240,0.0000000}, {241,0.0002286}, {242,0.0005429}, {243,0.0000000}, {244,0.0002000}, {245,0.0001714}, {246,0.0000000}, {247,0.0003143}, {248,0.0004571}, {249,0.0005429}, {250,0.0004286}, {251,0.0002000}, {252,0.0006571}, {253,0.0002286}, {254,0.0002857}, {255,0.0004286}, {256,0.0002000}, {257,0.0004286}, {258,0.0003429}, {259,0.0000857}, {260,0.0003143}, {261,0.0001143}, {262,0.0011143}, {263,0.0004286}, {264,0.0001143}, {265,0.0004000}, {266,0.0002286}, {267,0.0003429}, {268,0.0003143}, {269,0.0002286}, {270,0.0003429}, {271,0.0006571}, {272,0.0002286}, {273,0.0004571}, {274,0.0002000}, {275,0.0002286}, {276,0.0003143}, {277,0.0004571}, {278,0.0001143}, {279,0.0003143}, {280,0.0003143}, {281,0.0004571}, {282,0.0004286}, {283,0.0004571}, {284,0.0004286}, {285,0.0002000}, {286,0.0006571}, {287,0.0003143}, {288,0.0005714}, {289,0.0003429}, {290,0.0006571}, {291,0.0001143}, {292,0.0003429}, {293,0.0000000}, {294,0.0006857}, {295,0.0000857}, {296,0.0004571}, {297,0.0004286}, {298,0.0004571}, {299,0.0002000}, {300,0.0003429}, {301,0.0002857}, {302,0.0002000}, {303,0.0005714}, {304,0.0006286}, {305,0.0003143}, {306,0.0003143}, {307,0.0007714}, {308,0.0000000}, {309,0.0003429}, {310,0.0002000}, {311,0.0001143}, {312,0.0006286}, {313,0.0004286}, {314,0.0003429}, {315,0.0004286}, {316,0.0005429}, {317,0.0002286}, {318,0.0003429}, {319,0.0002286}, {320,0.0005143}, {321,0.0005429}, {322,0.0003429}, {323,0.0004286}, {324,0.0008000}, {325,0.0003429}, {326,0.0005714}, {327,0.0003429}, {328,0.0003143}, {329,0.0003143}, {330,0.0002000}, {331,0.0002286}, {332,0.0002000}, {333,0.0003143}, {334,0.0005714}, {335,0.0001714}, {336,0.0003143}, {337,0.0003429}, {338,0.0003429}, {339,0.0005429}, {340,0.0002857}, {341,0.0006571}, {342,0.0005143}, {343,0.0005429}, {344,0.0006000}, {345,0.0000857}, {346,0.0002286}, {347,0.0001714}, {348,0.0001143}, {349,0.0005714}, {350,0.0003429}, {351,0.0004286}, {352,0.0003143}, {353,0.0002857}, {354,0.0000000}, {355,0.0008571}, {356,0.0002286}, {357,0.0002000}, {358,0.0002857}, {359,0.0005714}, {360,0.0003714}, {361,0.0001714}, {362,0.0004000}, {363,0.0004571}, {364,0.0003714}, {365,0.0005143}, {366,0.0005143}, {367,0.0011429}, {368,0.0001714}, {369,0.0004000}, {370,0.0004571}, {371,0.0002857}, {372,0.0006000}, {373,0.0003714}, {374,0.0002286}, {375,0.0005143}, {376,0.0002000}, {377,0.0000000}, {378,0.0003143}, {379,0.0003143}, {380,0.0006571}, {381,0.0005143}, {382,0.0005143}, {383,0.0002571}, {384,0.0002286}, {385,0.0004000}, {386,0.0003714}, {387,0.0002857}, {388,0.0003429}, {389,0.0003429}, {390,0.0006000}, {391,0.0002857}, {392,0.0004571}, {393,0.0006000}, {394,0.0003143}, {395,0.0002000}, {396,0.0007714}, {397,0.0007143}, {398,0.0003714}, {399,0.0006286}, {400,0.0006000}, {401,0.0003429}, {402,0.0003429}, {403,0.0002000}, {404,0.0004571}, {405,0.0008000}, {406,0.0005143}, {407,0.0000857}, {408,0.0004857}, {409,0.0006857}, {410,0.0003429}, {411,0.0004857}, {412,0.0007714}, {413,0.0009714}, {414,0.0008000}, {415,0.0003143}, {416,0.0004286}, {417,0.0004000}, {418,0.0000857}, {419,0.0004000}, {420,0.0005143}, {421,0.0003143}, {422,0.0004571}, {423,0.0003429}, {424,0.0008571}, {425,0.0005143}, {426,0.0004000}, {427,0.0005143}, {428,0.0007714}, {429,0.0006286}, {430,0.0000857}, {431,0.0001714}, {432,0.0003143}, {433,0.0004286}, {434,0.0004857}, {435,0.0003714}, {436,0.0002857}, {437,0.0003429}, {438,0.0006857}, {439,0.0000857}, {440,0.0005143}, {441,0.0006857}, {442,0.0004000}, {443,0.0002571}, {444,0.0002571}, {445,0.0007143}, {446,0.0003714}, {447,0.0005714}, {448,0.0002857}, {449,0.0007143}, {450,0.0005429}, {451,0.0004857}, {452,0.0006857}, {453,0.0003714}, {454,0.0005143}, {455,0.0002571}, {456,0.0003429}, {457,0.0001714}, {458,0.0003714}, {459,0.0008286}, {460,0.0005143}, {461,0.0004571}, {462,0.0007429}, {463,0.0004000}, {464,0.0004571}, {465,0.0005714}, {466,0.0004571}, {467,0.0002571}, {468,0.0007429}, {469,0.0003429}, {470,0.0005143}, {471,0.0002857}, {472,0.0008571}, {473,0.0006000}, {474,0.0004000}, {475,0.0004000}, {476,0.0002000}, {477,0.0005714}, {478,0.0005429}, {479,0.0003714}, {480,0.0007714}, {481,0.0002000}, {482,0.0005143}, {483,0.0009429}, {484,0.0003714}, {485,0.0002000}, {486,0.0004571}, {487,0.0005714}, {488,0.0007429}, {489,0.0009429}, {490,0.0006000}, {491,0.0002857}, {492,0.0006000}, {493,0.0005143}, {494,0.0005429}, {495,0.0004000}, {496,0.0007429}, {497,0.0006286}, {498,0.0006286}, {499,0.0004857}, {500,0.0007714}, {505,0.0004286}, {510,0.0003714}, {515,0.0004571}, {520,0.0002571}, {525,0.0005429}, {530,0.0006571}, {535,0.0004857}, {540,0.0006286}, {545,0.0003143}, {550,0.0005714}, {555,0.0003429}, {560,0.0003429}, {565,0.0005714}, {570,0.0006857}, {575,0.0002000}, {580,0.0006286}, {585,0.0007714}, {590,0.0004571}, {595,0.0009714}, {600,0.0001714}, {605,0.0008857}, {610,0.0004571}, {615,0.0005143}, {620,0.0005429}, {625,0.0003429}, {630,0.0009714}, {635,0.0006286}, {640,0.0006000}, {645,0.0007143}, {650,0.0003714}, {655,0.0005143}, {660,0.0005429}, {665,0.0008000}, {670,0.0005143}, {675,0.0004286}, {680,0.0004571}, {685,0.0010000}, {690,0.0006571}, {695,0.0018857}, {700,0.0009429}};
data["big"]["LtacPrimUncurry"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00003960}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00003960}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00003960}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.0000000}, {177,0.0000000}, {178,0.0000000}, {179,0.0000000}, {180,0.0000000}, {181,0.0000000}, {182,0.0000000}, {183,0.0000000}, {184,0.0000000}, {185,0.0000000}, {186,0.0000000}, {187,0.0000000}, {188,0.0000000}, {189,0.0000000}, {190,0.0000000}, {191,0.0000000}, {192,0.0000000}, {193,0.0000000}, {194,0.0000000}, {195,0.0000000}, {196,0.0000000}, {197,0.0000000}, {198,0.0000000}, {199,0.0000000}, {200,0.0000000}, {201,0.0000000}, {202,0.0000000}, {203,0.0000000}, {204,0.0000000}, {205,0.0000000}, {206,0.0000000}, {207,0.0000000}, {208,0.0000000}, {209,0.0000000}, {210,0.0000000}, {211,0.0000000}, {212,0.0000000}, {213,0.0000000}, {214,0.0000000}, {215,0.0000000}, {216,0.0000000}, {217,0.0000000}, {218,0.0000000}, {219,0.0000000}, {220,0.0000000}, {221,0.0000000}, {222,0.0000000}, {223,0.0000000}, {224,0.0001143}, {225,0.0000000}, {226,0.0000000}, {227,0.0000000}, {228,0.0000000}, {229,0.0000000}, {230,0.0000000}, {231,0.0000000}, {232,0.0000000}, {233,0.0000000}, {234,0.0000000}, {235,0.0000000}, {236,0.0000000}, {237,0.0000000}, {238,0.0000000}, {239,0.0000000}, {240,0.0000000}, {241,0.0000000}, {242,0.0000857}, {243,0.0000000}, {244,0.0000000}, {245,0.0000000}, {246,0.0001143}, {247,0.0000000}, {248,0.0000000}, {249,0.0000000}, {250,0.0000000}, {251,0.0000000}, {252,0.0000000}, {253,0.0000000}, {254,0.0000000}, {255,0.0000000}, {256,0.0000000}, {257,0.0000000}, {258,0.0000000}, {259,0.0000000}, {260,0.0000000}, {261,0.0000000}, {262,0.0000000}, {263,0.0000000}, {264,0.0000000}, {265,0.0000000}, {266,0.0000000}, {267,0.0000000}, {268,0.0000000}, {269,0.0000000}, {270,0.0000000}, {271,0.0000000}, {272,0.0000000}, {273,0.0000000}, {274,0.0000000}, {275,0.0000000}, {276,0.0000000}, {277,0.0000000}, {278,0.0000000}, {279,0.0000000}, {280,0.0000000}, {281,0.0000000}, {282,0.0000000}, {283,0.0000000}, {284,0.0000000}, {285,0.0000000}, {286,0.0000000}, {287,0.0000000}, {288,0.0000000}, {289,0.0000000}, {290,0.0000000}, {291,0.0000000}, {292,0.0000000}, {293,0.0000000}, {294,0.0000000}, {295,0.0000000}, {296,0.0000000}, {297,0.0000000}, {298,0.0000000}, {299,0.0000000}, {300,0.0000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0001143}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0001143}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000857}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0001143}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000857}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}};
data["big"]["LtacPrimUncurry"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.0000000}, {177,0.0000000}, {178,0.0000000}, {179,0.0000000}, {180,0.0000000}, {181,0.0000000}, {182,0.0000000}, {183,0.0000000}, {184,0.0000000}, {185,0.0000000}, {186,0.0000000}, {187,0.0000000}, {188,0.0000000}, {189,0.0000000}, {190,0.0000000}, {191,0.0000000}, {192,0.0000000}, {193,0.0000000}, {194,0.0000000}, {195,0.0000000}, {196,0.0000000}, {197,0.0000000}, {198,0.0000000}, {199,0.0000000}, {200,0.0000000}, {201,0.0000000}, {202,0.0000000}, {203,0.0000000}, {204,0.0000000}, {205,0.0000000}, {206,0.0000000}, {207,0.0000000}, {208,0.0000000}, {209,0.0000000}, {210,0.0000000}, {211,0.0000000}, {212,0.0000000}, {213,0.0000000}, {214,0.0000000}, {215,0.0000000}, {216,0.0000000}, {217,0.0000000}, {218,0.0000000}, {219,0.0000000}, {220,0.0000000}, {221,0.0000000}, {222,0.0000000}, {223,0.0000000}, {224,0.0000000}, {225,0.0000000}, {226,0.0000000}, {227,0.0000000}, {228,0.0000000}, {229,0.0000000}, {230,0.0000000}, {231,0.0000000}, {232,0.0000000}, {233,0.0000000}, {234,0.0000000}, {235,0.0000000}, {236,0.0000000}, {237,0.0000000}, {238,0.0000000}, {239,0.0000000}, {240,0.0000000}, {241,0.0000000}, {242,0.0000000}, {243,0.0000000}, {244,0.0000000}, {245,0.0000000}, {246,0.0000000}, {247,0.0000000}, {248,0.0000000}, {249,0.0000000}, {250,0.0000000}, {251,0.0000000}, {252,0.0000000}, {253,0.0000000}, {254,0.0000000}, {255,0.0000000}, {256,0.0000000}, {257,0.0000000}, {258,0.0000000}, {259,0.0000000}, {260,0.0000000}, {261,0.0000000}, {262,0.0000000}, {263,0.0000000}, {264,0.0000000}, {265,0.0000000}, {266,0.0000000}, {267,0.0000000}, {268,0.0000000}, {269,0.0000000}, {270,0.0000000}, {271,0.0000000}, {272,0.0000000}, {273,0.0000000}, {274,0.0000000}, {275,0.0000000}, {276,0.0000000}, {277,0.0000000}, {278,0.0000000}, {279,0.0000000}, {280,0.0000000}, {281,0.0000000}, {282,0.0000000}, {283,0.0000000}, {284,0.0000000}, {285,0.0000000}, {286,0.0000000}, {287,0.0000000}, {288,0.0000000}, {289,0.0000000}, {290,0.0000000}, {291,0.0000000}, {292,0.0000000}, {293,0.0000000}, {294,0.0000000}, {295,0.0000000}, {296,0.0000000}, {297,0.0000000}, {298,0.0000000}, {299,0.0000000}, {300,0.0000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}};
data["big"]["LtacPrimUncurry"]["lazy beta iota"]["user"] = {{1,0.00003960}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00002970}, {6,0.00000000}, {7,0.00000000}, {8,0.00002970}, {9,0.00000000}, {10,0.00000000}, {11,0.00003960}, {12,0.00003960}, {13,0.00003960}, {14,0.00002970}, {15,0.00009901}, {16,0.00006931}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00003960}, {22,0.00010891}, {23,0.00007921}, {24,0.00000000}, {25,0.00000000}, {26,0.00003960}, {27,0.00003960}, {28,0.00000000}, {29,0.00000000}, {30,0.00006931}, {31,0.00000000}, {32,0.00007921}, {33,0.00003960}, {34,0.00000000}, {35,0.00002970}, {36,0.00002970}, {37,0.00000000}, {38,0.00003960}, {39,0.00003960}, {40,0.00000000}, {41,0.00003960}, {42,0.00002970}, {43,0.00003960}, {44,0.00011881}, {45,0.00002970}, {46,0.00002970}, {47,0.00011881}, {48,0.00003960}, {49,0.00006931}, {50,0.00007921}, {51,0.00003960}, {52,0.00006931}, {53,0.00003960}, {54,0.00003960}, {55,0.00000000}, {56,0.00003960}, {57,0.00000000}, {58,0.00006931}, {59,0.00009901}, {60,0.00000000}, {61,0.00009901}, {62,0.00000000}, {63,0.00006931}, {64,0.00003960}, {65,0.00000000}, {66,0.00002970}, {67,0.00005941}, {68,0.00003960}, {69,0.00013861}, {70,0.00009901}, {71,0.00006931}, {72,0.00011881}, {73,0.00007921}, {74,0.00013861}, {75,0.00005941}, {76,0.00003960}, {77,0.00006931}, {78,0.00002970}, {79,0.00010891}, {80,0.00014851}, {81,0.00009901}, {82,0.00002970}, {83,0.00015842}, {84,0.00000000}, {85,0.00011881}, {86,0.00008911}, {87,0.00002970}, {88,0.00011881}, {89,0.00005941}, {90,0.00006931}, {91,0.00013861}, {92,0.00000000}, {93,0.00009901}, {94,0.00002970}, {95,0.00000000}, {96,0.00002970}, {97,0.00002970}, {98,0.00010891}, {99,0.00003960}, {100,0.00000000}, {101,0.00009901}, {102,0.00013861}, {103,0.00015842}, {104,0.00005941}, {105,0.00013861}, {106,0.00010891}, {107,0.00006931}, {108,0.00002970}, {109,0.00019802}, {110,0.00007921}, {111,0.00000000}, {112,0.00005941}, {113,0.00009901}, {114,0.00006931}, {115,0.00007921}, {116,0.00005941}, {117,0.00008911}, {118,0.00011881}, {119,0.00010891}, {120,0.00005941}, {121,0.00011881}, {122,0.00012871}, {123,0.00013861}, {124,0.00008911}, {125,0.00012871}, {126,0.00011881}, {127,0.00021782}, {128,0.00015842}, {129,0.00008911}, {130,0.00015842}, {131,0.00002970}, {132,0.00007921}, {133,0.00005941}, {134,0.00006931}, {135,0.00006931}, {136,0.00009901}, {137,0.00016832}, {138,0.00005941}, {139,0.00008911}, {140,0.00006931}, {141,0.00021782}, {142,0.00010891}, {143,0.00002970}, {144,0.00009901}, {145,0.00015842}, {146,0.00013861}, {147,0.00010891}, {148,0.00009901}, {149,0.00006931}, {150,0.00010891}, {151,0.00012871}, {152,0.00006931}, {153,0.00013861}, {154,0.00016832}, {155,0.00017822}, {156,0.00019802}, {157,0.00009901}, {158,0.00016832}, {159,0.00006931}, {160,0.00016832}, {161,0.00021782}, {162,0.00014851}, {163,0.00015842}, {164,0.00022772}, {165,0.00003960}, {166,0.00010891}, {167,0.00002970}, {168,0.00008911}, {169,0.00014851}, {170,0.00006931}, {171,0.00015842}, {172,0.00002970}, {173,0.00021782}, {174,0.00011881}, {175,0.00014851}, {176,0.0001143}, {177,0.0002000}, {178,0.0002000}, {179,0.0000000}, {180,0.0001143}, {181,0.0000857}, {182,0.0000000}, {183,0.0002000}, {184,0.0001143}, {185,0.0001143}, {186,0.0000857}, {187,0.0001143}, {188,0.0000857}, {189,0.0002000}, {190,0.0002000}, {191,0.0000000}, {192,0.0001143}, {193,0.0002286}, {194,0.0001143}, {195,0.0002286}, {196,0.0003143}, {197,0.0002857}, {198,0.0003143}, {199,0.0002000}, {200,0.0001143}, {201,0.0000000}, {202,0.0001143}, {203,0.0003143}, {204,0.0001143}, {205,0.0002000}, {206,0.0000000}, {207,0.0003143}, {208,0.0001143}, {209,0.0002286}, {210,0.0001143}, {211,0.0002857}, {212,0.0000000}, {213,0.0004000}, {214,0.0003714}, {215,0.0000000}, {216,0.0001143}, {217,0.0000857}, {218,0.0001143}, {219,0.0001143}, {220,0.0002286}, {221,0.0001143}, {222,0.0000000}, {223,0.0003143}, {224,0.0000857}, {225,0.0000000}, {226,0.0000000}, {227,0.0003143}, {228,0.0000000}, {229,0.0000000}, {230,0.0004000}, {231,0.0001143}, {232,0.0000000}, {233,0.0003714}, {234,0.0003143}, {235,0.0000000}, {236,0.0002286}, {237,0.0003143}, {238,0.0000000}, {239,0.0000000}, {240,0.0000000}, {241,0.0000000}, {242,0.0002000}, {243,0.0001143}, {244,0.0002000}, {245,0.0002000}, {246,0.0002286}, {247,0.0002286}, {248,0.0002286}, {249,0.0002286}, {250,0.0001143}, {251,0.0000857}, {252,0.0000857}, {253,0.0001143}, {254,0.0003429}, {255,0.0003429}, {256,0.0004571}, {257,0.0001143}, {258,0.0003143}, {259,0.0002286}, {260,0.0000000}, {261,0.0001143}, {262,0.0004000}, {263,0.0003429}, {264,0.0002000}, {265,0.0001143}, {266,0.0001143}, {267,0.0001143}, {268,0.0001143}, {269,0.0003143}, {270,0.0001143}, {271,0.0004571}, {272,0.0001143}, {273,0.0003143}, {274,0.0001143}, {275,0.0001143}, {276,0.0000000}, {277,0.0003143}, {278,0.0000000}, {279,0.0003143}, {280,0.0003429}, {281,0.0003429}, {282,0.0002000}, {283,0.0000000}, {284,0.0000000}, {285,0.0003143}, {286,0.0001143}, {287,0.0002000}, {288,0.0004286}, {289,0.0001143}, {290,0.0002000}, {291,0.0004857}, {292,0.0002286}, {293,0.0002000}, {294,0.0001143}, {295,0.0001143}, {296,0.0002286}, {297,0.0000857}, {298,0.0004571}, {299,0.0001143}, {300,0.0002286}, {301,0.0002857}, {302,0.0003429}, {303,0.0005714}, {304,0.0002000}, {305,0.0002000}, {306,0.0001143}, {307,0.0001143}, {308,0.0004571}, {309,0.0003429}, {310,0.0000857}, {311,0.0003143}, {312,0.0001143}, {313,0.0003429}, {314,0.0006571}, {315,0.0002286}, {316,0.0003429}, {317,0.0002286}, {318,0.0002000}, {319,0.0001143}, {320,0.0001143}, {321,0.0000000}, {322,0.0002286}, {323,0.0003429}, {324,0.0002000}, {325,0.0002286}, {326,0.0002286}, {327,0.0003429}, {328,0.0006286}, {329,0.0002286}, {330,0.0004571}, {331,0.0002286}, {332,0.0001143}, {333,0.0001143}, {334,0.0002286}, {335,0.0000000}, {336,0.0005714}, {337,0.0004571}, {338,0.0005714}, {339,0.0004286}, {340,0.0000000}, {341,0.0002857}, {342,0.0000857}, {343,0.0000857}, {344,0.0005714}, {345,0.0004286}, {346,0.0002571}, {347,0.0004286}, {348,0.0002000}, {349,0.0002286}, {350,0.0004000}, {351,0.0004000}, {352,0.0000857}, {353,0.0006000}, {354,0.0004000}, {355,0.0000000}, {356,0.0005143}, {357,0.0000000}, {358,0.0002000}, {359,0.0002000}, {360,0.0000000}, {361,0.0000000}, {362,0.0004286}, {363,0.0003143}, {364,0.0001143}, {365,0.0002857}, {366,0.0002286}, {367,0.0001714}, {368,0.0002000}, {369,0.0001714}, {370,0.0002000}, {371,0.0001714}, {372,0.0001714}, {373,0.0003143}, {374,0.0004571}, {375,0.0002286}, {376,0.0001714}, {377,0.0007143}, {378,0.0000000}, {379,0.0002857}, {380,0.0000857}, {381,0.0001714}, {382,0.0002000}, {383,0.0002857}, {384,0.0002857}, {385,0.0001143}, {386,0.0001143}, {387,0.0000857}, {388,0.0001143}, {389,0.0003714}, {390,0.0001143}, {391,0.0004000}, {392,0.0001714}, {393,0.0000857}, {394,0.0001143}, {395,0.0000857}, {396,0.0001714}, {397,0.0000857}, {398,0.0003429}, {399,0.0002000}, {400,0.0001143}, {401,0.0003143}, {402,0.0002000}, {403,0.0000000}, {404,0.0002000}, {405,0.0000000}, {406,0.0002000}, {407,0.0003429}, {408,0.0002000}, {409,0.0003143}, {410,0.0000857}, {411,0.0001714}, {412,0.0001714}, {413,0.0000857}, {414,0.0002000}, {415,0.0001714}, {416,0.0000000}, {417,0.0004286}, {418,0.0002286}, {419,0.0002571}, {420,0.0002571}, {421,0.0002286}, {422,0.0006286}, {423,0.0003143}, {424,0.0000000}, {425,0.0002857}, {426,0.0004571}, {427,0.0002000}, {428,0.0002857}, {429,0.0003143}, {430,0.0003714}, {431,0.0001714}, {432,0.0002000}, {433,0.0002000}, {434,0.0002000}, {435,0.0002857}, {436,0.0002571}, {437,0.0004571}, {438,0.0001714}, {439,0.0001143}, {440,0.0000857}, {441,0.0000857}, {442,0.0002571}, {443,0.0001143}, {444,0.0004857}, {445,0.0002571}, {446,0.0002857}, {447,0.0002571}, {448,0.0002000}, {449,0.0000857}, {450,0.0000857}, {451,0.0002857}, {452,0.0002857}, {453,0.0000000}, {454,0.0003714}, {455,0.0002857}, {456,0.0000000}, {457,0.0000857}, {458,0.0002571}, {459,0.0002571}, {460,0.0003143}, {461,0.0002571}, {462,0.0004571}, {463,0.0002571}, {464,0.0001714}, {465,0.0001714}, {466,0.0000857}, {467,0.0001714}, {468,0.0003714}, {469,0.0002857}, {470,0.0003429}, {471,0.0004571}, {472,0.0001714}, {473,0.0003714}, {474,0.0003714}, {475,0.0002857}, {476,0.0002571}, {477,0.0002000}, {478,0.0002857}, {479,0.0001714}, {480,0.0001714}, {481,0.0001714}, {482,0.0003714}, {483,0.0002571}, {484,0.0004286}, {485,0.0001714}, {486,0.0008286}, {487,0.0000857}, {488,0.0003143}, {489,0.0000857}, {490,0.0000857}, {491,0.0001714}, {492,0.0003429}, {493,0.0004000}, {494,0.0003429}, {495,0.0001714}, {496,0.0000857}, {497,0.0003143}, {498,0.0002857}, {499,0.0003143}, {500,0.0003714}, {505,0.0002286}, {510,0.0002571}, {515,0.0002000}, {520,0.0003714}, {525,0.0004571}, {530,0.0002571}, {535,0.0002857}, {540,0.0002571}, {545,0.0002571}, {550,0.0002000}, {555,0.0005714}, {560,0.0002857}, {565,0.0003429}, {570,0.0001714}, {575,0.0002000}, {580,0.0003429}, {585,0.0000857}, {590,0.0004286}, {595,0.0000857}, {600,0.0007429}, {605,0.0004857}, {610,0.0006000}, {615,0.0000000}, {620,0.0004571}, {625,0.0002857}, {630,0.0001143}, {635,0.0005429}, {640,0.0000857}, {645,0.0002857}, {650,0.0006857}, {655,0.0002000}, {660,0.0006571}, {665,0.0006571}, {670,0.0001714}, {675,0.0004286}, {680,0.0003429}, {685,0.0002857}, {690,0.0003429}, {695,0.0000857}, {700,0.0005429}};
data["big"]["LtacPrimUncurry"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00003960}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00003960}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00003960}, {154,0.00000000}, {155,0.00000000}, {156,0.00003960}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00003960}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00003960}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.0000000}, {177,0.0000000}, {178,0.0000000}, {179,0.0001143}, {180,0.0000000}, {181,0.0000000}, {182,0.0001143}, {183,0.0000000}, {184,0.0000000}, {185,0.0000000}, {186,0.0000000}, {187,0.0000000}, {188,0.0000000}, {189,0.0000000}, {190,0.0000000}, {191,0.0000000}, {192,0.0000000}, {193,0.0000000}, {194,0.0000000}, {195,0.0000000}, {196,0.0000000}, {197,0.0000000}, {198,0.0000000}, {199,0.0000000}, {200,0.0000000}, {201,0.0000000}, {202,0.0000000}, {203,0.0000000}, {204,0.0000000}, {205,0.0000000}, {206,0.0000000}, {207,0.0000000}, {208,0.0000000}, {209,0.0000000}, {210,0.0000000}, {211,0.0000000}, {212,0.0000000}, {213,0.0001143}, {214,0.0000000}, {215,0.0000000}, {216,0.0000000}, {217,0.0000000}, {218,0.0000000}, {219,0.0000000}, {220,0.0000000}, {221,0.0000000}, {222,0.0000000}, {223,0.0000000}, {224,0.0000000}, {225,0.0000000}, {226,0.0000000}, {227,0.0000000}, {228,0.0000000}, {229,0.0000000}, {230,0.0000000}, {231,0.0000000}, {232,0.0000000}, {233,0.0000000}, {234,0.0000000}, {235,0.0000000}, {236,0.0000000}, {237,0.0000000}, {238,0.0000000}, {239,0.0000000}, {240,0.0000000}, {241,0.0000000}, {242,0.0000000}, {243,0.0000000}, {244,0.0000000}, {245,0.0000000}, {246,0.0000000}, {247,0.0000000}, {248,0.0000000}, {249,0.0000000}, {250,0.0000000}, {251,0.0000000}, {252,0.0000000}, {253,0.0000000}, {254,0.0000000}, {255,0.0000000}, {256,0.0000000}, {257,0.0000000}, {258,0.0000000}, {259,0.0000000}, {260,0.0000000}, {261,0.0000000}, {262,0.0000000}, {263,0.0000000}, {264,0.0000000}, {265,0.0000000}, {266,0.0000000}, {267,0.0000000}, {268,0.0000000}, {269,0.0000000}, {270,0.0000000}, {271,0.0000000}, {272,0.0000000}, {273,0.0000000}, {274,0.0000000}, {275,0.0000000}, {276,0.0000000}, {277,0.0000000}, {278,0.0000000}, {279,0.0000000}, {280,0.0000000}, {281,0.0000000}, {282,0.0000000}, {283,0.0000000}, {284,0.0000000}, {285,0.0000000}, {286,0.0000000}, {287,0.0000000}, {288,0.0000000}, {289,0.0000000}, {290,0.0000000}, {291,0.0000000}, {292,0.0000000}, {293,0.0000000}, {294,0.0000000}, {295,0.0000000}, {296,0.0000000}, {297,0.0000000}, {298,0.0000000}, {299,0.0000000}, {300,0.0000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0001143}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0001143}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0001143}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0001143}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0001143}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0001143}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}};
data["big"]["LtacPrimUncurry"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00100000}, {3,0.00100000}, {4,0.00162376}, {5,0.00200000}, {6,0.00299010}, {7,0.00304950}, {8,0.00400000}, {9,0.00438614}, {10,0.00516832}, {11,0.02534653}, {12,0.00699010}, {13,0.00739604}, {14,0.00831683}, {15,0.00924752}, {16,0.01021782}, {17,0.01127723}, {18,0.01232673}, {19,0.01332673}, {20,0.01432673}, {21,0.01547525}, {22,0.01702970}, {23,0.01829703}, {24,0.01952475}, {25,0.02074257}, {26,0.02335644}, {27,0.02352475}, {28,0.02523762}, {29,0.02665347}, {30,0.02962376}, {31,0.02989109}, {32,0.03173267}, {33,0.03543564}, {34,0.03527723}, {35,0.03723762}, {36,0.04017822}, {37,0.04081188}, {38,0.04279208}, {39,0.04502970}, {40,0.04744554}, {41,0.04889109}, {42,0.05156436}, {43,0.05332673}, {44,0.05613861}, {45,0.05857426}, {46,0.06206931}, {47,0.06364356}, {48,0.06479208}, {49,0.07017822}, {50,0.07141584}, {51,0.07298020}, {52,0.07665347}, {53,0.08179208}, {54,0.08573267}, {55,0.08579208}, {56,0.08918812}, {57,0.09026733}, {58,0.09308911}, {59,0.09634653}, {60,0.09936634}, {61,0.10291089}, {62,0.11085149}, {63,0.11584158}, {64,0.11702970}, {65,0.11873267}, {66,0.12037624}, {67,0.12866337}, {68,0.13093069}, {69,0.13310891}, {70,0.14112871}, {71,0.14221782}, {72,0.14862376}, {73,0.14894059}, {74,0.15587129}, {75,0.15740594}, {76,0.16243564}, {77,0.16838614}, {78,0.17402970}, {79,0.17646535}, {80,0.17964356}, {81,0.18351485}, {82,0.18894059}, {83,0.19478218}, {84,0.20333663}, {85,0.20683168}, {86,0.20951485}, {87,0.21317822}, {88,0.22216832}, {89,0.22413861}, {90,0.23430693}, {91,0.23543564}, {92,0.24207921}, {93,0.25017822}, {94,0.25246535}, {95,0.25732673}, {96,0.26543564}, {97,0.27032673}, {98,0.27546535}, {99,0.28247525}, {100,0.28757426}, {101,0.29829703}, {102,0.30069307}, {103,0.30621782}, {104,0.31512871}, {105,0.32481188}, {106,0.33125743}, {107,0.34061386}, {108,0.34680198}, {109,0.35583168}, {110,0.36383168}, {111,0.37068317}, {112,0.37753465}, {113,0.38390099}, {114,0.39153465}, {115,0.39600990}, {116,0.40348515}, {117,0.41078218}, {118,0.41948515}, {119,0.42963366}, {120,0.43686139}, {121,0.44519802}, {122,0.45278218}, {123,0.46394059}, {124,0.47211881}, {125,0.47896040}, {126,0.48791089}, {127,0.50026733}, {128,0.50535644}, {129,0.51508911}, {130,0.52816832}, {131,0.54393069}, {132,0.54232673}, {133,0.55153465}, {134,0.56395050}, {135,0.57317822}, {136,0.57533663}, {137,0.59186139}, {138,0.60340594}, {139,0.60762376}, {140,0.62689109}, {141,0.63272277}, {142,0.64480198}, {143,0.65491089}, {144,0.68334653}, {145,0.67344554}, {146,0.69015842}, {147,0.69359406}, {148,0.71518812}, {149,0.72212871}, {150,0.73227723}, {151,0.75123762}, {152,0.76004950}, {153,0.77291089}, {154,0.78114851}, {155,0.95205941}, {156,0.87354455}, {157,0.94906931}, {158,0.83428713}, {159,0.85116832}, {160,0.86847525}, {161,0.87684158}, {162,0.88507921}, {163,0.90012871}, {164,0.90899010}, {165,0.92629703}, {166,0.93994059}, {167,0.95703960}, {168,0.96981188}, {169,0.98313861}, {170,1.00346535}, {171,1.01612871}, {172,1.03228713}, {173,1.05194059}, {174,1.06145545}, {175,1.06366337}, {176,1.1246000}, {177,1.1095714}, {178,1.1246000}, {179,1.1377429}, {180,1.1707143}, {181,1.2023429}, {182,1.1983714}, {183,1.2132000}, {184,1.2230000}, {185,1.2380286}, {186,1.2654000}, {187,1.2718571}, {188,1.2942286}, {189,1.3014286}, {190,1.3421143}, {191,1.3548571}, {192,1.3711714}, {193,1.3786286}, {194,1.4359143}, {195,1.4260000}, {196,1.4452857}, {197,1.4669143}, {198,1.4864571}, {199,1.5122571}, {200,1.5308857}, {201,1.5599429}, {202,1.5695429}, {203,1.5874571}, {204,1.6099143}, {205,1.6141429}, {206,1.6502286}, {207,1.6848571}, {208,1.6792286}, {209,1.7084000}, {210,1.7525429}, {211,1.7829429}, {212,1.7594286}, {213,1.8080286}, {214,1.8546857}, {215,1.8702286}, {216,1.8814286}, {217,1.9320286}, {218,1.9392857}, {219,1.9764286}, {220,2.0099429}, {221,2.0221429}, {222,2.0495143}, {223,2.0553429}, {224,2.0930571}, {225,2.1177714}, {226,2.1536571}, {227,2.1938000}, {228,2.1956000}, {229,2.2938000}, {230,2.2521714}, {231,2.3129143}, {232,2.2915429}, {233,2.3537429}, {234,2.3437429}, {235,2.4352286}, {236,2.4848286}, {237,2.5261143}, {238,2.4653714}, {239,2.5230857}, {240,2.5693143}, {241,2.6006857}, {242,2.6256286}, {243,2.6842857}, {244,2.6964857}, {245,2.7232000}, {246,3.3502000}, {247,2.8000286}, {248,2.8398286}, {249,2.8776286}, {250,2.9878571}, {251,2.9180286}, {252,2.9721714}, {253,3.0226857}, {254,3.0688571}, {255,3.0941714}, {256,3.1079714}, {257,3.1701429}, {258,3.1139429}, {259,3.2264857}, {260,3.2454286}, {261,3.3007143}, {262,3.3523429}, {263,3.3558000}, {264,3.3918571}, {265,3.4451429}, {266,3.4766000}, {267,3.5486857}, {268,3.5332000}, {269,3.6175429}, {270,3.6486857}, {271,3.6743143}, {272,3.7002000}, {273,3.7762571}, {274,3.8125714}, {275,3.8639714}, {276,3.8901714}, {277,3.9248286}, {278,3.9498857}, {279,4.0373143}, {280,4.0610571}, {281,4.1116857}, {282,4.0951143}, {283,4.2393143}, {284,4.2272857}, {285,4.2502000}, {286,4.3319143}, {287,4.4054000}, {288,4.4040571}, {289,4.4704857}, {290,4.5503714}, {291,4.5797714}, {292,4.5100286}, {293,4.5625714}, {294,4.6736571}, {295,4.6206571}, {296,4.8478857}, {297,4.8285714}, {298,4.9440000}, {299,4.8544286}, {300,5.0036286}, {301,5.0459143}, {302,5.1166857}, {303,5.1543143}, {304,5.2185143}, {305,5.0836571}, {306,5.3452857}, {307,5.3386571}, {308,5.4223143}, {309,5.4766000}, {310,5.5089143}, {311,5.5970857}, {312,5.6056857}, {313,5.7067429}, {314,5.7707429}, {315,5.5698286}, {316,5.7347143}, {317,5.8536000}, {318,5.9807143}, {319,6.0179429}, {320,6.1112571}, {321,6.0992571}, {322,6.1604857}, {323,6.2513143}, {324,6.2594857}, {325,6.3997429}, {326,6.4806000}, {327,6.5056571}, {328,6.5632000}, {329,6.6154286}, {330,6.6740286}, {331,6.6418857}, {332,6.8192571}, {333,6.9245429}, {334,6.7576857}, {335,7.0220857}, {336,7.0924286}, {337,7.1298571}, {338,7.2306857}, {339,7.2880286}, {340,7.3110286}, {341,7.1480571}, {342,7.2762571}, {343,7.5032571}, {344,7.5919714}, {345,7.6725143}, {346,7.6955429}, {347,7.7506286}, {348,7.8847429}, {349,7.9322000}, {350,7.9797429}, {351,8.0507143}, {352,8.1457143}, {353,8.1892571}, {354,8.2803143}, {355,8.3500000}, {356,8.4146857}, {357,8.4971429}, {358,8.5806857}, {359,8.6382571}, {360,8.7209143}, {361,8.7971714}, {362,8.8290857}, {363,8.9142286}, {364,8.9720571}, {365,9.0336000}, {366,9.1608571}, {367,9.1138000}, {368,9.3592857}, {369,9.3931429}, {370,9.4786857}, {371,9.5632286}, {372,9.5809143}, {373,9.5793143}, {374,9.7739143}, {375,9.9037714}, {376,10.0035714}, {377,10.0042000}, {378,10.1131714}, {379,10.1912286}, {380,9.7367429}, {381,10.3598571}, {382,10.2584000}, {383,10.5128000}, {384,10.6003429}, {385,10.5528286}, {386,10.7050571}, {387,10.8332000}, {388,10.9362857}, {389,10.8227429}, {390,10.9439714}, {391,11.0308286}, {392,11.2429143}, {393,11.3692571}, {394,11.4330000}, {395,11.3662571}, {396,11.5124571}, {397,11.3897143}, {398,11.6393429}, {399,11.9074857}, {400,11.9112857}, {401,12.0613429}, {402,12.1219429}, {403,12.2212857}, {404,12.3164000}, {405,12.4622286}, {406,12.5326286}, {407,12.6162857}, {408,12.6481714}, {409,12.8405143}, {410,12.7388571}, {411,12.9225714}, {412,13.0816571}, {413,12.6343714}, {414,12.9844286}, {415,13.2548286}, {416,13.4650286}, {417,13.5916857}, {418,13.6594857}, {419,13.6366571}, {420,13.8482571}, {421,13.9364000}, {422,14.1140286}, {423,14.1960286}, {424,14.2877429}, {425,14.2819429}, {426,14.4426857}, {427,14.4750286}, {428,14.6813714}, {429,14.7785714}, {430,14.8634000}, {431,14.4891714}, {432,15.1534857}, {433,15.1928857}, {434,15.3269714}, {435,15.4661429}, {436,15.5583429}, {437,15.6939714}, {438,15.7799714}, {439,15.9138000}, {440,15.9682857}, {441,16.0249714}, {442,16.2975714}, {443,16.4350857}, {444,16.5210000}, {445,16.6461714}, {446,16.7518571}, {447,16.7695429}, {448,16.9072571}, {449,17.0070286}, {450,17.0574286}, {451,17.2343429}, {452,17.2886000}, {453,17.4560571}, {454,17.5650000}, {455,17.5001429}, {456,17.2594286}, {457,17.8235714}, {458,17.9724857}, {459,18.0465143}, {460,18.2070571}, {461,18.0138857}, {462,18.3088857}, {463,18.5632286}, {464,18.5022571}, {465,18.6704571}, {466,18.8351429}, {467,19.0103143}, {468,19.0644571}, {469,19.3072857}, {470,19.1851714}, {471,19.5165429}, {472,19.6074857}, {473,19.5745143}, {474,19.8460857}, {475,19.9524286}, {476,20.0684857}, {477,20.1985429}, {478,20.3088000}, {479,20.4357714}, {480,20.5002857}, {481,20.5419429}, {482,20.8768857}, {483,20.9455143}, {484,21.1840000}, {485,21.0973429}, {486,21.3916857}, {487,21.5750571}, {488,21.5724286}, {489,21.6718571}, {490,21.7794571}, {491,21.8418857}, {492,22.2052000}, {493,22.1849143}, {494,22.2180857}, {495,22.7392857}, {496,22.6407143}, {497,22.9595714}, {498,23.1447429}, {499,23.2878857}, {500,23.4025143}, {505,23.9311429}, {510,24.7730571}, {515,25.4819143}, {520,26.2497714}, {525,26.7514857}, {530,27.0043429}, {535,28.4207143}, {540,29.0086857}, {545,30.0633143}, {550,30.8312000}, {555,31.7466571}, {560,32.4894857}, {565,33.2362857}, {570,34.1984857}, {575,35.1815714}, {580,35.9645714}, {585,37.1000571}, {590,37.9102286}, {595,38.6872000}, {600,40.0039714}, {605,40.8316000}, {610,41.9956857}, {615,42.7452286}, {620,44.0757429}, {625,45.2440571}, {630,46.1840286}, {635,47.2363429}, {640,48.0581143}, {645,49.2385143}, {650,50.6028857}, {655,51.5694571}, {660,53.2130286}, {665,54.4330000}, {670,55.4634000}, {675,56.6443429}, {680,58.1993714}, {685,58.9347429}, {690,60.4701143}, {695,61.5151429}, {700,62.9027143}};
data["big"]["LtacPrimUncurry"]["norm reif"]["user"] = {{1,0.00062376}, {2,0.00110891}, {3,0.00124752}, {4,0.00178218}, {5,0.00222772}, {6,0.00289109}, {7,0.00344554}, {8,0.00390099}, {9,0.00483168}, {10,0.00517822}, {11,0.02553465}, {12,0.00663366}, {13,0.00740594}, {14,0.00861386}, {15,0.00935644}, {16,0.01029703}, {17,0.01168317}, {18,0.01277228}, {19,0.01379208}, {20,0.01478218}, {21,0.01566337}, {22,0.01687129}, {23,0.01793069}, {24,0.01906931}, {25,0.02063366}, {26,0.02387129}, {27,0.02415842}, {28,0.02555446}, {29,0.02710891}, {30,0.02963366}, {31,0.02976238}, {32,0.03159406}, {33,0.03563366}, {34,0.03565347}, {35,0.03777228}, {36,0.04036634}, {37,0.04082178}, {38,0.04252475}, {39,0.04496040}, {40,0.04735644}, {41,0.04891089}, {42,0.05147525}, {43,0.05322772}, {44,0.05551485}, {45,0.05848515}, {46,0.06201980}, {47,0.06350495}, {48,0.06445545}, {49,0.07026733}, {50,0.07138614}, {51,0.07299010}, {52,0.07655446}, {53,0.08166337}, {54,0.08587129}, {55,0.08554455}, {56,0.08846535}, {57,0.08972277}, {58,0.09267327}, {59,0.09626733}, {60,0.09908911}, {61,0.10227723}, {62,0.11076238}, {63,0.11550495}, {64,0.11689109}, {65,0.11884158}, {66,0.12022772}, {67,0.12912871}, {68,0.13082178}, {69,0.13279208}, {70,0.14127723}, {71,0.14214851}, {72,0.14835644}, {73,0.14841584}, {74,0.15574257}, {75,0.15743564}, {76,0.16192079}, {77,0.16822772}, {78,0.17338614}, {79,0.17588119}, {80,0.17948515}, {81,0.18278218}, {82,0.18857426}, {83,0.19450495}, {84,0.20290099}, {85,0.20660396}, {86,0.20886139}, {87,0.21242574}, {88,0.22139604}, {89,0.22373267}, {90,0.23374257}, {91,0.23500000}, {92,0.24151485}, {93,0.24968317}, {94,0.25210891}, {95,0.25714851}, {96,0.26541584}, {97,0.27014851}, {98,0.27514851}, {99,0.28237624}, {100,0.28749505}, {101,0.29839604}, {102,0.30039604}, {103,0.30576238}, {104,0.31459406}, {105,0.32417822}, {106,0.33065347}, {107,0.34048515}, {108,0.34606931}, {109,0.35481188}, {110,0.36321782}, {111,0.37024752}, {112,0.37687129}, {113,0.38370297}, {114,0.39071287}, {115,0.39508911}, {116,0.40286139}, {117,0.41024752}, {118,0.41865347}, {119,0.42879208}, {120,0.43611881}, {121,0.44460396}, {122,0.45195050}, {123,0.46320792}, {124,0.47141584}, {125,0.47814851}, {126,0.48682178}, {127,0.49951485}, {128,0.50459406}, {129,0.51476238}, {130,0.52723762}, {131,0.54333663}, {132,0.54157426}, {133,0.55069307}, {134,0.56337624}, {135,0.57247525}, {136,0.57478218}, {137,0.59112871}, {138,0.60280198}, {139,0.60690099}, {140,0.62612871}, {141,0.63192079}, {142,0.64417822}, {143,0.65401980}, {144,0.68250495}, {145,0.67222772}, {146,0.68900000}, {147,0.69309901}, {148,0.71423762}, {149,0.72122772}, {150,0.73124752}, {151,0.75019802}, {152,0.75934653}, {153,0.77201980}, {154,0.78040594}, {155,0.95058416}, {156,0.87244554}, {157,0.94731683}, {158,0.83321782}, {159,0.85002970}, {160,0.86708911}, {161,0.87596040}, {162,0.88384158}, {163,0.89943564}, {164,0.90785149}, {165,0.92521782}, {166,0.93871287}, {167,0.95577228}, {168,0.96866337}, {169,0.98193069}, {170,1.00247525}, {171,1.01510891}, {172,1.03124752}, {173,1.05070297}, {174,1.06012871}, {175,1.06223762}, {176,1.1236857}, {177,1.1092286}, {178,1.1226571}, {179,1.1373714}, {180,1.1694000}, {181,1.2011143}, {182,1.1976286}, {183,1.2125143}, {184,1.2219714}, {185,1.2371714}, {186,1.2647429}, {187,1.2706286}, {188,1.2937429}, {189,1.3003429}, {190,1.3404000}, {191,1.3540000}, {192,1.3702571}, {193,1.3771714}, {194,1.4347143}, {195,1.4244857}, {196,1.4438000}, {197,1.4640571}, {198,1.4834000}, {199,1.5103143}, {200,1.5289714}, {201,1.5583143}, {202,1.5686000}, {203,1.5867143}, {204,1.6090571}, {205,1.6134857}, {206,1.6492571}, {207,1.6839714}, {208,1.6783143}, {209,1.7079429}, {210,1.7512286}, {211,1.7822571}, {212,1.7583429}, {213,1.8061429}, {214,1.8494857}, {215,1.8660857}, {216,1.8799429}, {217,1.9301143}, {218,1.9378000}, {219,1.9744286}, {220,2.0081143}, {221,2.0208571}, {222,2.0480286}, {223,2.0530857}, {224,2.0919714}, {225,2.1160571}, {226,2.1520000}, {227,2.1920286}, {228,2.1943429}, {229,2.2920286}, {230,2.2504000}, {231,2.3108286}, {232,2.2896000}, {233,2.3518000}, {234,2.3418571}, {235,2.4332857}, {236,2.4826000}, {237,2.5238571}, {238,2.4634857}, {239,2.5206857}, {240,2.5666571}, {241,2.5986286}, {242,2.6235143}, {243,2.6812286}, {244,2.6916286}, {245,2.7158286}, {246,3.3432857}, {247,2.7978286}, {248,2.8365714}, {249,2.8718286}, {250,2.9837429}, {251,2.9119714}, {252,2.9680857}, {253,3.0088286}, {254,3.0638286}, {255,3.0918857}, {256,3.1064571}, {257,3.1685143}, {258,3.1120000}, {259,3.2242286}, {260,3.2438000}, {261,3.2989143}, {262,3.3505714}, {263,3.3536000}, {264,3.3901143}, {265,3.4424857}, {266,3.4742857}, {267,3.5463143}, {268,3.5309143}, {269,3.6150286}, {270,3.6462286}, {271,3.6723429}, {272,3.6980286}, {273,3.7730286}, {274,3.8100000}, {275,3.8617143}, {276,3.8872571}, {277,3.9218571}, {278,3.9469143}, {279,4.0337429}, {280,4.0571714}, {281,4.1088000}, {282,4.0920571}, {283,4.2368000}, {284,4.2236000}, {285,4.2465714}, {286,4.3281714}, {287,4.4021714}, {288,4.4005714}, {289,4.4663714}, {290,4.5475143}, {291,4.5760857}, {292,4.5065714}, {293,4.5590857}, {294,4.6701429}, {295,4.6168571}, {296,4.8442286}, {297,4.8251714}, {298,4.9397429}, {299,4.8503714}, {300,4.9988571}, {301,5.0408000}, {302,5.1112571}, {303,5.1493429}, {304,5.2130000}, {305,5.0786286}, {306,5.3392286}, {307,5.3326000}, {308,5.4157714}, {309,5.4705143}, {310,5.5038857}, {311,5.5915429}, {312,5.5992571}, {313,5.7009143}, {314,5.7649143}, {315,5.5652571}, {316,5.7293143}, {317,5.8484571}, {318,5.9762857}, {319,6.0130857}, {320,6.1058857}, {321,6.0943143}, {322,6.1552571}, {323,6.2458857}, {324,6.2549429}, {325,6.3941714}, {326,6.4752571}, {327,6.5006000}, {328,6.5575429}, {329,6.6098286}, {330,6.6691429}, {331,6.6369714}, {332,6.8152286}, {333,6.9204286}, {334,6.7540571}, {335,7.0174571}, {336,7.0880857}, {337,7.1250857}, {338,7.2254857}, {339,7.2835143}, {340,7.3065714}, {341,7.1434286}, {342,7.2708000}, {343,7.4986000}, {344,7.5871429}, {345,7.6676000}, {346,7.6902000}, {347,7.7448286}, {348,7.8783143}, {349,7.9263143}, {350,7.9742857}, {351,8.0447429}, {352,8.1393429}, {353,8.1823714}, {354,8.2729714}, {355,8.3434857}, {356,8.4078857}, {357,8.4909143}, {358,8.5743714}, {359,8.6321429}, {360,8.7142857}, {361,8.7914286}, {362,8.8228857}, {363,8.9087429}, {364,8.9664571}, {365,9.0276571}, {366,9.1546571}, {367,9.1076571}, {368,9.3518571}, {369,9.3784571}, {370,9.4629714}, {371,9.5538571}, {372,9.5722000}, {373,9.5696857}, {374,9.7627429}, {375,9.8923714}, {376,9.9915143}, {377,9.9927714}, {378,10.1030571}, {379,10.1805143}, {380,9.7256857}, {381,10.3485429}, {382,10.2462571}, {383,10.5012286}, {384,10.5893143}, {385,10.5420286}, {386,10.6958286}, {387,10.8235143}, {388,10.9256286}, {389,10.8125143}, {390,10.9338857}, {391,11.0200000}, {392,11.2322000}, {393,11.3589143}, {394,11.4222857}, {395,11.3555143}, {396,11.5018571}, {397,11.3784571}, {398,11.6286286}, {399,11.8968000}, {400,11.9005714}, {401,12.0506571}, {402,12.1108571}, {403,12.2101714}, {404,12.3038571}, {405,12.4513143}, {406,12.5227429}, {407,12.6048286}, {408,12.6391429}, {409,12.8308000}, {410,12.7294857}, {411,12.9126857}, {412,13.0725429}, {413,12.6265429}, {414,12.9760571}, {415,13.2445143}, {416,13.4530571}, {417,13.5813143}, {418,13.6512286}, {419,13.6284857}, {420,13.8388286}, {421,13.9273429}, {422,14.1076286}, {423,14.1889714}, {424,14.2821714}, {425,14.2749143}, {426,14.4333143}, {427,14.4656857}, {428,14.6684000}, {429,14.7652857}, {430,14.8493143}, {431,14.4752000}, {432,15.1380857}, {433,15.1786000}, {434,15.3117429}, {435,15.4488286}, {436,15.5419429}, {437,15.6756000}, {438,15.7625714}, {439,15.8884857}, {440,15.9528571}, {441,16.0110571}, {442,16.2020857}, {443,16.3192286}, {444,16.4509429}, {445,16.5730000}, {446,16.6858286}, {447,16.7439714}, {448,16.8905714}, {449,16.9895714}, {450,17.0297714}, {451,17.1486000}, {452,17.2203714}, {453,17.3537714}, {454,17.4827143}, {455,17.4062286}, {456,17.1896000}, {457,17.7876571}, {458,17.9491429}, {459,18.0255714}, {460,18.1647429}, {461,17.9949714}, {462,18.2886000}, {463,18.5411714}, {464,18.4798000}, {465,18.6483143}, {466,18.8122000}, {467,18.9763143}, {468,19.0285429}, {469,19.2762571}, {470,19.1373143}, {471,19.4483143}, {472,19.5316857}, {473,19.5333143}, {474,19.8201143}, {475,19.9268857}, {476,20.0445143}, {477,20.1718857}, {478,20.2823429}, {479,20.4117143}, {480,20.4759143}, {481,20.5180857}, {482,20.8528571}, {483,20.9236000}, {484,21.1686000}, {485,21.0838857}, {486,21.3772000}, {487,21.5629714}, {488,21.5543143}, {489,21.6537143}, {490,21.7634000}, {491,21.8245714}, {492,22.1865143}, {493,22.1610571}, {494,22.1914571}, {495,22.7162000}, {496,22.6169714}, {497,22.9321714}, {498,23.1147143}, {499,23.2106571}, {500,23.3241714}, {505,23.8992000}, {510,24.7473714}, {515,25.4576286}, {520,26.2253714}, {525,26.7216000}, {530,26.9775143}, {535,28.3956000}, {540,28.9826000}, {545,30.0348857}, {550,30.8023143}, {555,31.7172857}, {560,32.4602571}, {565,33.2062571}, {570,34.1722286}, {575,35.1538286}, {580,35.9418571}, {585,37.0778571}, {590,37.8862000}, {595,38.6624000}, {600,39.9738571}, {605,40.7996857}, {610,41.9577429}, {615,42.7063143}, {620,44.0362857}, {625,45.2073429}, {630,46.1495143}, {635,47.1979143}, {640,48.0216857}, {645,49.2054571}, {650,50.5731143}, {655,51.5348571}, {660,53.1682000}, {665,54.3808857}, {670,55.4078857}, {675,56.5890286}, {680,58.1401714}, {685,58.8757143}, {690,60.4087429}, {695,61.4541429}, {700,62.8349429}};
data["big"]["LtacPrimUncurry"]["norm reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00010891}, {4,0.00003960}, {5,0.00000000}, {6,0.00003960}, {7,0.00007921}, {8,0.00000000}, {9,0.00003960}, {10,0.00003960}, {11,0.00003960}, {12,0.00000000}, {13,0.00003960}, {14,0.00000000}, {15,0.00011881}, {16,0.00011881}, {17,0.00000000}, {18,0.00007921}, {19,0.00003960}, {20,0.00003960}, {21,0.00003960}, {22,0.00003960}, {23,0.00003960}, {24,0.00007921}, {25,0.00011881}, {26,0.00003960}, {27,0.00000000}, {28,0.00003960}, {29,0.00006931}, {30,0.00000000}, {31,0.00003960}, {32,0.00000000}, {33,0.00002970}, {34,0.00007921}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00003960}, {41,0.00007921}, {42,0.00000000}, {43,0.00000000}, {44,0.00003960}, {45,0.00003960}, {46,0.00000000}, {47,0.00003960}, {48,0.00003960}, {49,0.00003960}, {50,0.00000000}, {51,0.00003960}, {52,0.00003960}, {53,0.00007921}, {54,0.00000000}, {55,0.00003960}, {56,0.00007921}, {57,0.00003960}, {58,0.00003960}, {59,0.00003960}, {60,0.00007921}, {61,0.00007921}, {62,0.00002970}, {63,0.00000000}, {64,0.00003960}, {65,0.00000000}, {66,0.00003960}, {67,0.00000000}, {68,0.00002970}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00003960}, {73,0.00003960}, {74,0.00002970}, {75,0.00000000}, {76,0.00003960}, {77,0.00003960}, {78,0.00002970}, {79,0.00011881}, {80,0.00002970}, {81,0.00003960}, {82,0.00003960}, {83,0.00000000}, {84,0.00003960}, {85,0.00003960}, {86,0.00003960}, {87,0.00007921}, {88,0.00002970}, {89,0.00007921}, {90,0.00011881}, {91,0.00000000}, {92,0.00010891}, {93,0.00007921}, {94,0.00003960}, {95,0.00011881}, {96,0.00000000}, {97,0.00003960}, {98,0.00002970}, {99,0.00007921}, {100,0.00003960}, {101,0.00000000}, {102,0.00007921}, {103,0.00003960}, {104,0.00003960}, {105,0.00003960}, {106,0.00003960}, {107,0.00000000}, {108,0.00010891}, {109,0.00006931}, {110,0.00015842}, {111,0.00000000}, {112,0.00002970}, {113,0.00003960}, {114,0.00002970}, {115,0.00000000}, {116,0.00002970}, {117,0.00007921}, {118,0.00011881}, {119,0.00007921}, {120,0.00003960}, {121,0.00003960}, {122,0.00003960}, {123,0.00006931}, {124,0.00003960}, {125,0.00007921}, {126,0.00007921}, {127,0.00011881}, {128,0.00000000}, {129,0.00015842}, {130,0.00007921}, {131,0.00003960}, {132,0.00003960}, {133,0.00007921}, {134,0.00014851}, {135,0.00007921}, {136,0.00007921}, {137,0.00003960}, {138,0.00003960}, {139,0.00003960}, {140,0.00015842}, {141,0.00003960}, {142,0.00014851}, {143,0.00010891}, {144,0.00019802}, {145,0.00003960}, {146,0.00006931}, {147,0.00003960}, {148,0.00003960}, {149,0.00003960}, {150,0.00003960}, {151,0.00007921}, {152,0.00011881}, {153,0.00006931}, {154,0.00000000}, {155,0.00062376}, {156,0.00022772}, {157,0.00060396}, {158,0.00003960}, {159,0.00019802}, {160,0.00011881}, {161,0.00007921}, {162,0.00023762}, {163,0.00007921}, {164,0.00003960}, {165,0.00015842}, {166,0.00007921}, {167,0.00011881}, {168,0.00003960}, {169,0.00014851}, {170,0.00022772}, {171,0.00007921}, {172,0.00000000}, {173,0.00007921}, {174,0.00015842}, {175,0.00014851}, {176,0.0001143}, {177,0.0000000}, {178,0.0005429}, {179,0.0001143}, {180,0.0004571}, {181,0.0001143}, {182,0.0002286}, {183,0.0000000}, {184,0.0000000}, {185,0.0000000}, {186,0.0000000}, {187,0.0002286}, {188,0.0001143}, {189,0.0002286}, {190,0.0003429}, {191,0.0000000}, {192,0.0000000}, {193,0.0000000}, {194,0.0000000}, {195,0.0000000}, {196,0.0001143}, {197,0.0001143}, {198,0.0002286}, {199,0.0000000}, {200,0.0003429}, {201,0.0004571}, {202,0.0000000}, {203,0.0001143}, {204,0.0001143}, {205,0.0000000}, {206,0.0003429}, {207,0.0002286}, {208,0.0002286}, {209,0.0002286}, {210,0.0001143}, {211,0.0001143}, {212,0.0002286}, {213,0.0003429}, {214,0.0004571}, {215,0.0000000}, {216,0.0002286}, {217,0.0001143}, {218,0.0003429}, {219,0.0001143}, {220,0.0000000}, {221,0.0003429}, {222,0.0004571}, {223,0.0001143}, {224,0.0002286}, {225,0.0001143}, {226,0.0004571}, {227,0.0001143}, {228,0.0001143}, {229,0.0003143}, {230,0.0000000}, {231,0.0000000}, {232,0.0003429}, {233,0.0000000}, {234,0.0001143}, {235,0.0005429}, {236,0.0003143}, {237,0.0000000}, {238,0.0002286}, {239,0.0000000}, {240,0.0002286}, {241,0.0002286}, {242,0.0001714}, {243,0.0003429}, {244,0.0002000}, {245,0.0002286}, {246,0.0046571}, {247,0.0003429}, {248,0.0003429}, {249,0.0002286}, {250,0.0001143}, {251,0.0001143}, {252,0.0002286}, {253,0.0001143}, {254,0.0000000}, {255,0.0004571}, {256,0.0003143}, {257,0.0004571}, {258,0.0003429}, {259,0.0002286}, {260,0.0001143}, {261,0.0004571}, {262,0.0001143}, {263,0.0001143}, {264,0.0001143}, {265,0.0003429}, {266,0.0000000}, {267,0.0004571}, {268,0.0000000}, {269,0.0002286}, {270,0.0000000}, {271,0.0003143}, {272,0.0002286}, {273,0.0002286}, {274,0.0002286}, {275,0.0001143}, {276,0.0002286}, {277,0.0002286}, {278,0.0000000}, {279,0.0008571}, {280,0.0002286}, {281,0.0001143}, {282,0.0003429}, {283,0.0001143}, {284,0.0003429}, {285,0.0003429}, {286,0.0003143}, {287,0.0003429}, {288,0.0003429}, {289,0.0008857}, {290,0.0001143}, {291,0.0003429}, {292,0.0003429}, {293,0.0004571}, {294,0.0006571}, {295,0.0004571}, {296,0.0002286}, {297,0.0000857}, {298,0.0003429}, {299,0.0000000}, {300,0.0002286}, {301,0.0005714}, {302,0.0004286}, {303,0.0003429}, {304,0.0004571}, {305,0.0003429}, {306,0.0004571}, {307,0.0010000}, {308,0.0008000}, {309,0.0005714}, {310,0.0001143}, {311,0.0003429}, {312,0.0006857}, {313,0.0004571}, {314,0.0004286}, {315,0.0002286}, {316,0.0008000}, {317,0.0005429}, {318,0.0001143}, {319,0.0001143}, {320,0.0006857}, {321,0.0005714}, {322,0.0005429}, {323,0.0005714}, {324,0.0002286}, {325,0.0003429}, {326,0.0006571}, {327,0.0002286}, {328,0.0004571}, {329,0.0006857}, {330,0.0004286}, {331,0.0004571}, {332,0.0001143}, {333,0.0002286}, {334,0.0002286}, {335,0.0004571}, {336,0.0002286}, {337,0.0002286}, {338,0.0006857}, {339,0.0003429}, {340,0.0001143}, {341,0.0004571}, {342,0.0007714}, {343,0.0003429}, {344,0.0005714}, {345,0.0002286}, {346,0.0003429}, {347,0.0001143}, {348,0.0004571}, {349,0.0004571}, {350,0.0004286}, {351,0.0004571}, {352,0.0001143}, {353,0.0004571}, {354,0.0008000}, {355,0.0004286}, {356,0.0004571}, {357,0.0003429}, {358,0.0003429}, {359,0.0005714}, {360,0.0006857}, {361,0.0004571}, {362,0.0005143}, {363,0.0002286}, {364,0.0003429}, {365,0.0003429}, {366,0.0006857}, {367,0.0005429}, {368,0.0006857}, {369,0.0010000}, {370,0.0009143}, {371,0.0010857}, {372,0.0005714}, {373,0.0005714}, {374,0.0004571}, {375,0.0004571}, {376,0.0010000}, {377,0.0004571}, {378,0.0002286}, {379,0.0002286}, {380,0.0006571}, {381,0.0006857}, {382,0.0014857}, {383,0.0008000}, {384,0.0006857}, {385,0.0011429}, {386,0.0008000}, {387,0.0003143}, {388,0.0012571}, {389,0.0009143}, {390,0.0008571}, {391,0.0008000}, {392,0.0011429}, {393,0.0006571}, {394,0.0010000}, {395,0.0005714}, {396,0.0004571}, {397,0.0012571}, {398,0.0004286}, {399,0.0008000}, {400,0.0007714}, {401,0.0004571}, {402,0.0007714}, {403,0.0007714}, {404,0.0011429}, {405,0.0009143}, {406,0.0002286}, {407,0.0012571}, {408,0.0006857}, {409,0.0010286}, {410,0.0010286}, {411,0.0011429}, {412,0.0009143}, {413,0.0004286}, {414,0.0007714}, {415,0.0006857}, {416,0.0012000}, {417,0.0003429}, {418,0.0006857}, {419,0.0004571}, {420,0.0006857}, {421,0.0011429}, {422,0.0002286}, {423,0.0008000}, {424,0.0003429}, {425,0.0008857}, {426,0.0006571}, {427,0.0011143}, {428,0.0012286}, {429,0.0005143}, {430,0.0011429}, {431,0.0013714}, {432,0.0013429}, {433,0.0009143}, {434,0.0011429}, {435,0.0010286}, {436,0.0008571}, {437,0.0006857}, {438,0.0006571}, {439,0.0014857}, {440,0.0011429}, {441,0.0006857}, {442,0.0009143}, {443,0.0008000}, {444,0.0004571}, {445,0.0004571}, {446,0.0013714}, {447,0.0012571}, {448,0.0006857}, {449,0.0016857}, {450,0.0011429}, {451,0.0014857}, {452,0.0010286}, {453,0.0012571}, {454,0.0019143}, {455,0.0020571}, {456,0.0014857}, {457,0.0014286}, {458,0.0010000}, {459,0.0011429}, {460,0.0009143}, {461,0.0011429}, {462,0.0011429}, {463,0.0008000}, {464,0.0014857}, {465,0.0012571}, {466,0.0016857}, {467,0.0015714}, {468,0.0013143}, {469,0.0011429}, {470,0.0013429}, {471,0.0018286}, {472,0.0013714}, {473,0.0010000}, {474,0.0012286}, {475,0.0011143}, {476,0.0011429}, {477,0.0010000}, {478,0.0016857}, {479,0.0017143}, {480,0.0020571}, {481,0.0006857}, {482,0.0006571}, {483,0.0016000}, {484,0.0009143}, {485,0.0008000}, {486,0.0006857}, {487,0.0008000}, {488,0.0008000}, {489,0.0011429}, {490,0.0009143}, {491,0.0008857}, {492,0.0009143}, {493,0.0011143}, {494,0.0016000}, {495,0.0008000}, {496,0.0010286}, {497,0.0014000}, {498,0.0014857}, {499,0.0009143}, {500,0.0012286}, {505,0.0006857}, {510,0.0010286}, {515,0.0011429}, {520,0.0010286}, {525,0.0018000}, {530,0.0012571}, {535,0.0018286}, {540,0.0016000}, {545,0.0021143}, {550,0.0024000}, {555,0.0018000}, {560,0.0017143}, {565,0.0014857}, {570,0.0016000}, {575,0.0022571}, {580,0.0012571}, {585,0.0012571}, {590,0.0008857}, {595,0.0019143}, {600,0.0021429}, {605,0.0021429}, {610,0.0025143}, {615,0.0028571}, {620,0.0028286}, {625,0.0020571}, {630,0.0020286}, {635,0.0023714}, {640,0.0024000}, {645,0.0026000}, {650,0.0016857}, {655,0.0021143}, {660,0.0024571}, {665,0.0023714}, {670,0.0034286}, {675,0.0023429}, {680,0.0043429}, {685,0.0035429}, {690,0.0038286}, {695,0.0031429}, {700,0.0066286}};
data["big"]["LtacPrimUncurry"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.0000000}, {177,0.0000000}, {178,0.0000000}, {179,0.0000000}, {180,0.0000000}, {181,0.0000000}, {182,0.0000000}, {183,0.0000000}, {184,0.0000000}, {185,0.0000000}, {186,0.0000000}, {187,0.0000000}, {188,0.0000000}, {189,0.0000000}, {190,0.0000000}, {191,0.0000000}, {192,0.0000000}, {193,0.0000000}, {194,0.0000000}, {195,0.0000000}, {196,0.0000000}, {197,0.0000000}, {198,0.0000000}, {199,0.0000000}, {200,0.0000000}, {201,0.0000000}, {202,0.0000000}, {203,0.0000000}, {204,0.0000000}, {205,0.0000000}, {206,0.0000000}, {207,0.0000000}, {208,0.0000000}, {209,0.0000000}, {210,0.0000000}, {211,0.0000000}, {212,0.0000000}, {213,0.0000000}, {214,0.0000000}, {215,0.0000000}, {216,0.0000000}, {217,0.0000000}, {218,0.0000000}, {219,0.0000000}, {220,0.0000000}, {221,0.0000000}, {222,0.0000000}, {223,0.0000000}, {224,0.0000000}, {225,0.0000000}, {226,0.0000000}, {227,0.0000000}, {228,0.0000000}, {229,0.0000000}, {230,0.0000000}, {231,0.0000000}, {232,0.0000000}, {233,0.0000000}, {234,0.0000000}, {235,0.0000000}, {236,0.0000000}, {237,0.0000000}, {238,0.0000000}, {239,0.0000000}, {240,0.0000000}, {241,0.0000000}, {242,0.0000000}, {243,0.0000000}, {244,0.0000000}, {245,0.0000000}, {246,0.0000000}, {247,0.0000000}, {248,0.0000000}, {249,0.0000000}, {250,0.0000000}, {251,0.0000000}, {252,0.0000000}, {253,0.0000000}, {254,0.0000000}, {255,0.0000000}, {256,0.0000000}, {257,0.0000000}, {258,0.0000000}, {259,0.0000000}, {260,0.0000000}, {261,0.0000000}, {262,0.0000000}, {263,0.0000000}, {264,0.0000000}, {265,0.0000000}, {266,0.0000000}, {267,0.0000000}, {268,0.0000000}, {269,0.0000000}, {270,0.0000000}, {271,0.0000000}, {272,0.0000000}, {273,0.0000000}, {274,0.0000000}, {275,0.0000000}, {276,0.0000000}, {277,0.0000000}, {278,0.0000000}, {279,0.0000000}, {280,0.0000000}, {281,0.0000000}, {282,0.0000000}, {283,0.0000000}, {284,0.0000000}, {285,0.0000000}, {286,0.0000000}, {287,0.0000000}, {288,0.0000000}, {289,0.0000000}, {290,0.0000000}, {291,0.0000000}, {292,0.0000000}, {293,0.0000000}, {294,0.0000000}, {295,0.0000000}, {296,0.0000000}, {297,0.0000000}, {298,0.0000000}, {299,0.0000000}, {300,0.0000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}};
data["big"]["LtacPrimUncurry"]["post"]["user"] = {{1,0.00000000}, {2,0.00006931}, {3,0.00000000}, {4,0.00000000}, {5,0.00007921}, {6,0.00007921}, {7,0.00003960}, {8,0.00000000}, {9,0.00003960}, {10,0.00007921}, {11,0.00000000}, {12,0.00002970}, {13,0.00003960}, {14,0.00000000}, {15,0.00010891}, {16,0.00002970}, {17,0.00000000}, {18,0.00000000}, {19,0.00002970}, {20,0.00000000}, {21,0.00010891}, {22,0.00000000}, {23,0.00007921}, {24,0.00003960}, {25,0.00003960}, {26,0.00000000}, {27,0.00000000}, {28,0.00006931}, {29,0.00003960}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00003960}, {34,0.00000000}, {35,0.00007921}, {36,0.00007921}, {37,0.00003960}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00003960}, {49,0.00003960}, {50,0.00003960}, {51,0.00003960}, {52,0.00007921}, {53,0.00006931}, {54,0.00007921}, {55,0.00011881}, {56,0.00007921}, {57,0.00009901}, {58,0.00003960}, {59,0.00003960}, {60,0.00002970}, {61,0.00011881}, {62,0.00007921}, {63,0.00000000}, {64,0.00000000}, {65,0.00003960}, {66,0.00003960}, {67,0.00007921}, {68,0.00007921}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00006931}, {73,0.00003960}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00003960}, {78,0.00007921}, {79,0.00002970}, {80,0.00000000}, {81,0.00000000}, {82,0.00002970}, {83,0.00000000}, {84,0.00000000}, {85,0.00002970}, {86,0.00002970}, {87,0.00006931}, {88,0.00005941}, {89,0.00000000}, {90,0.00002970}, {91,0.00003960}, {92,0.00009901}, {93,0.00007921}, {94,0.00000000}, {95,0.00003960}, {96,0.00000000}, {97,0.00000000}, {98,0.00014851}, {99,0.00002970}, {100,0.00000000}, {101,0.00002970}, {102,0.00002970}, {103,0.00000000}, {104,0.00002970}, {105,0.00000000}, {106,0.00005941}, {107,0.00000000}, {108,0.00000000}, {109,0.00005941}, {110,0.00006931}, {111,0.00000000}, {112,0.00002970}, {113,0.00002970}, {114,0.00003960}, {115,0.00013861}, {116,0.00000000}, {117,0.00006931}, {118,0.00002970}, {119,0.00003960}, {120,0.00003960}, {121,0.00000000}, {122,0.00003960}, {123,0.00003960}, {124,0.00005941}, {125,0.00005941}, {126,0.00003960}, {127,0.00002970}, {128,0.00000000}, {129,0.00000000}, {130,0.00006931}, {131,0.00002970}, {132,0.00000000}, {133,0.00002970}, {134,0.00002970}, {135,0.00000000}, {136,0.00002970}, {137,0.00005941}, {138,0.00006931}, {139,0.00002970}, {140,0.00000000}, {141,0.00000000}, {142,0.00005941}, {143,0.00006931}, {144,0.00002970}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00006931}, {149,0.00002970}, {150,0.00006931}, {151,0.00003960}, {152,0.00002970}, {153,0.00008911}, {154,0.00000000}, {155,0.00003960}, {156,0.00005941}, {157,0.00000000}, {158,0.00003960}, {159,0.00005941}, {160,0.00006931}, {161,0.00002970}, {162,0.00002970}, {163,0.00005941}, {164,0.00005941}, {165,0.00000000}, {166,0.00013861}, {167,0.00003960}, {168,0.00005941}, {169,0.00000000}, {170,0.00002970}, {171,0.00002970}, {172,0.00000000}, {173,0.00003960}, {174,0.00005941}, {175,0.00000000}, {176,0.0000000}, {177,0.0000000}, {178,0.0000000}, {179,0.0000000}, {180,0.0000000}, {181,0.0000000}, {182,0.0002286}, {183,0.0000000}, {184,0.0000000}, {185,0.0000000}, {186,0.0001143}, {187,0.0000000}, {188,0.0000000}, {189,0.0000000}, {190,0.0000000}, {191,0.0002857}, {192,0.0000000}, {193,0.0000000}, {194,0.0000000}, {195,0.0002000}, {196,0.0000000}, {197,0.0000000}, {198,0.0000000}, {199,0.0000000}, {200,0.0000000}, {201,0.0000000}, {202,0.0000000}, {203,0.0000000}, {204,0.0000000}, {205,0.0000000}, {206,0.0002000}, {207,0.0000000}, {208,0.0000000}, {209,0.0000000}, {210,0.0000000}, {211,0.0000000}, {212,0.0000000}, {213,0.0000000}, {214,0.0000000}, {215,0.0000000}, {216,0.0000857}, {217,0.0000000}, {218,0.0000000}, {219,0.0000000}, {220,0.0000000}, {221,0.0000000}, {222,0.0000000}, {223,0.0000000}, {224,0.0000000}, {225,0.0000000}, {226,0.0000000}, {227,0.0000000}, {228,0.0002286}, {229,0.0000000}, {230,0.0000000}, {231,0.0000000}, {232,0.0000000}, {233,0.0000000}, {234,0.0000857}, {235,0.0000000}, {236,0.0000000}, {237,0.0001143}, {238,0.0001143}, {239,0.0000000}, {240,0.0001143}, {241,0.0000000}, {242,0.0000000}, {243,0.0000000}, {244,0.0001143}, {245,0.0000857}, {246,0.0000000}, {247,0.0001143}, {248,0.0000000}, {249,0.0001143}, {250,0.0000000}, {251,0.0001143}, {252,0.0000000}, {253,0.0000000}, {254,0.0000000}, {255,0.0003429}, {256,0.0000000}, {257,0.0000000}, {258,0.0000857}, {259,0.0000000}, {260,0.0000000}, {261,0.0000000}, {262,0.0000000}, {263,0.0000000}, {264,0.0001143}, {265,0.0000000}, {266,0.0003143}, {267,0.0000000}, {268,0.0000000}, {269,0.0001143}, {270,0.0000000}, {271,0.0000000}, {272,0.0000000}, {273,0.0001143}, {274,0.0000000}, {275,0.0000000}, {276,0.0000000}, {277,0.0001143}, {278,0.0001143}, {279,0.0000000}, {280,0.0000000}, {281,0.0000000}, {282,0.0000000}, {283,0.0000000}, {284,0.0002286}, {285,0.0000000}, {286,0.0000000}, {287,0.0000000}, {288,0.0000000}, {289,0.0000000}, {290,0.0000000}, {291,0.0000000}, {292,0.0000000}, {293,0.0000857}, {294,0.0000000}, {295,0.0001143}, {296,0.0000000}, {297,0.0000000}, {298,0.0000000}, {299,0.0000000}, {300,0.0000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0001143}, {304,0.0000000}, {305,0.0001143}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0001143}, {313,0.0000000}, {314,0.0000000}, {315,0.0001143}, {316,0.0001143}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000857}, {321,0.0000000}, {322,0.0001143}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0001143}, {332,0.0000000}, {333,0.0001143}, {334,0.0000000}, {335,0.0002286}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000857}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000857}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0002286}, {357,0.0001143}, {358,0.0000000}, {359,0.0001143}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000857}, {364,0.0001714}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000857}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0001143}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0001143}, {382,0.0000000}, {383,0.0000000}, {384,0.0000857}, {385,0.0000857}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0001143}, {390,0.0000000}, {391,0.0000000}, {392,0.0001143}, {393,0.0000000}, {394,0.0000000}, {395,0.0001143}, {396,0.0000857}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000857}, {408,0.0000000}, {409,0.0001714}, {410,0.0001143}, {411,0.0001143}, {412,0.0000000}, {413,0.0000857}, {414,0.0000857}, {415,0.0003143}, {416,0.0001143}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0001143}, {424,0.0000000}, {425,0.0000857}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0001143}, {435,0.0001143}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0002286}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0001143}, {453,0.0000857}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000857}, {458,0.0001143}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000857}, {466,0.0000000}, {467,0.0000000}, {468,0.0002571}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000857}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0003429}, {477,0.0000000}, {478,0.0002000}, {479,0.0000000}, {480,0.0000857}, {481,0.0000000}, {482,0.0000000}, {483,0.0000857}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000857}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0002000}, {495,0.0000857}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000857}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000857}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0001143}, {575,0.0000857}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0001143}, {605,0.0000857}, {610,0.0000857}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000857}, {640,0.0000000}, {645,0.0002000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000857}, {670,0.0000000}, {675,0.0000857}, {680,0.0001143}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}};
data["big"]["LtacPrimUncurry"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00003960}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00003960}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.0000000}, {177,0.0000000}, {178,0.0000000}, {179,0.0000000}, {180,0.0000000}, {181,0.0000000}, {182,0.0000000}, {183,0.0000000}, {184,0.0000000}, {185,0.0000000}, {186,0.0000000}, {187,0.0000000}, {188,0.0000000}, {189,0.0000000}, {190,0.0000000}, {191,0.0000000}, {192,0.0000000}, {193,0.0000000}, {194,0.0000000}, {195,0.0000000}, {196,0.0000000}, {197,0.0000000}, {198,0.0000000}, {199,0.0000000}, {200,0.0000000}, {201,0.0000000}, {202,0.0000000}, {203,0.0000000}, {204,0.0000000}, {205,0.0000000}, {206,0.0000000}, {207,0.0000000}, {208,0.0000000}, {209,0.0000000}, {210,0.0000000}, {211,0.0000000}, {212,0.0000000}, {213,0.0000000}, {214,0.0000000}, {215,0.0000000}, {216,0.0000000}, {217,0.0000000}, {218,0.0000000}, {219,0.0000000}, {220,0.0000000}, {221,0.0000000}, {222,0.0000000}, {223,0.0000000}, {224,0.0000000}, {225,0.0000000}, {226,0.0000000}, {227,0.0000000}, {228,0.0000000}, {229,0.0000000}, {230,0.0000000}, {231,0.0000000}, {232,0.0000000}, {233,0.0000000}, {234,0.0000000}, {235,0.0000000}, {236,0.0000000}, {237,0.0000000}, {238,0.0000000}, {239,0.0000000}, {240,0.0000000}, {241,0.0000000}, {242,0.0000000}, {243,0.0000000}, {244,0.0000000}, {245,0.0000000}, {246,0.0000000}, {247,0.0000000}, {248,0.0000000}, {249,0.0000000}, {250,0.0000000}, {251,0.0000000}, {252,0.0000000}, {253,0.0000000}, {254,0.0001143}, {255,0.0000000}, {256,0.0000000}, {257,0.0000000}, {258,0.0000000}, {259,0.0000000}, {260,0.0000000}, {261,0.0000000}, {262,0.0000000}, {263,0.0000000}, {264,0.0000000}, {265,0.0000000}, {266,0.0000000}, {267,0.0000000}, {268,0.0000000}, {269,0.0000000}, {270,0.0000000}, {271,0.0000000}, {272,0.0000000}, {273,0.0000000}, {274,0.0000000}, {275,0.0000000}, {276,0.0000000}, {277,0.0000000}, {278,0.0000000}, {279,0.0000000}, {280,0.0000000}, {281,0.0000000}, {282,0.0000000}, {283,0.0000000}, {284,0.0000000}, {285,0.0000000}, {286,0.0000000}, {287,0.0000000}, {288,0.0000000}, {289,0.0000000}, {290,0.0000000}, {291,0.0000000}, {292,0.0000000}, {293,0.0000000}, {294,0.0000000}, {295,0.0000000}, {296,0.0000000}, {297,0.0000000}, {298,0.0000000}, {299,0.0000000}, {300,0.0000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}};
data["big"]["LtacPrimUncurry"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.0000000}, {177,0.0000000}, {178,0.0000000}, {179,0.0000000}, {180,0.0000000}, {181,0.0000000}, {182,0.0000000}, {183,0.0000000}, {184,0.0000000}, {185,0.0000000}, {186,0.0000000}, {187,0.0000000}, {188,0.0000000}, {189,0.0000000}, {190,0.0000000}, {191,0.0000000}, {192,0.0000000}, {193,0.0000000}, {194,0.0000000}, {195,0.0000000}, {196,0.0000000}, {197,0.0000000}, {198,0.0000000}, {199,0.0000000}, {200,0.0000000}, {201,0.0000000}, {202,0.0000000}, {203,0.0000000}, {204,0.0000000}, {205,0.0000000}, {206,0.0000000}, {207,0.0000000}, {208,0.0000000}, {209,0.0000000}, {210,0.0000000}, {211,0.0000000}, {212,0.0000000}, {213,0.0000000}, {214,0.0000000}, {215,0.0000000}, {216,0.0000000}, {217,0.0000000}, {218,0.0000000}, {219,0.0000000}, {220,0.0000000}, {221,0.0000000}, {222,0.0000000}, {223,0.0000000}, {224,0.0000000}, {225,0.0000000}, {226,0.0000000}, {227,0.0000000}, {228,0.0000000}, {229,0.0000000}, {230,0.0000000}, {231,0.0000000}, {232,0.0000000}, {233,0.0000000}, {234,0.0000000}, {235,0.0000000}, {236,0.0000000}, {237,0.0000000}, {238,0.0000000}, {239,0.0000000}, {240,0.0000000}, {241,0.0000000}, {242,0.0000000}, {243,0.0000000}, {244,0.0000000}, {245,0.0000000}, {246,0.0000000}, {247,0.0000000}, {248,0.0000000}, {249,0.0000000}, {250,0.0000000}, {251,0.0000000}, {252,0.0000000}, {253,0.0000000}, {254,0.0000000}, {255,0.0000000}, {256,0.0000000}, {257,0.0000000}, {258,0.0000000}, {259,0.0000000}, {260,0.0000000}, {261,0.0000000}, {262,0.0000000}, {263,0.0000000}, {264,0.0000000}, {265,0.0000000}, {266,0.0000000}, {267,0.0000000}, {268,0.0000000}, {269,0.0000000}, {270,0.0000000}, {271,0.0000000}, {272,0.0000000}, {273,0.0000000}, {274,0.0000000}, {275,0.0000000}, {276,0.0000000}, {277,0.0000000}, {278,0.0000000}, {279,0.0000000}, {280,0.0000000}, {281,0.0000000}, {282,0.0000000}, {283,0.0000000}, {284,0.0000000}, {285,0.0000000}, {286,0.0000000}, {287,0.0000000}, {288,0.0000000}, {289,0.0000000}, {290,0.0000000}, {291,0.0000000}, {292,0.0000000}, {293,0.0000000}, {294,0.0000000}, {295,0.0000000}, {296,0.0000000}, {297,0.0000000}, {298,0.0000000}, {299,0.0000000}, {300,0.0000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}};
data["big"]["LtacPrimUncurry"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00003960}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003960}, {13,0.00000000}, {14,0.00002970}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00003960}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00006931}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00002970}, {38,0.00002970}, {39,0.00000000}, {40,0.00003960}, {41,0.00002970}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00003960}, {57,0.00000000}, {58,0.00000000}, {59,0.00002970}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00003960}, {81,0.00000000}, {82,0.00009901}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00003960}, {95,0.00000000}, {96,0.00003960}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00003960}, {139,0.00002970}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00002970}, {148,0.00000000}, {149,0.00003960}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00003960}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00002970}, {170,0.00000000}, {171,0.00000000}, {172,0.00002970}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.0000000}, {177,0.0000000}, {178,0.0000000}, {179,0.0000000}, {180,0.0000000}, {181,0.0000000}, {182,0.0000000}, {183,0.0000000}, {184,0.0000000}, {185,0.0000000}, {186,0.0000000}, {187,0.0000000}, {188,0.0000000}, {189,0.0000000}, {190,0.0000000}, {191,0.0000000}, {192,0.0000000}, {193,0.0000000}, {194,0.0000000}, {195,0.0001143}, {196,0.0000000}, {197,0.0000000}, {198,0.0001143}, {199,0.0000000}, {200,0.0000000}, {201,0.0000000}, {202,0.0000000}, {203,0.0000000}, {204,0.0000000}, {205,0.0000000}, {206,0.0000000}, {207,0.0000000}, {208,0.0000000}, {209,0.0000000}, {210,0.0000000}, {211,0.0000000}, {212,0.0000000}, {213,0.0000000}, {214,0.0000000}, {215,0.0000000}, {216,0.0000000}, {217,0.0000000}, {218,0.0000000}, {219,0.0000000}, {220,0.0000000}, {221,0.0000000}, {222,0.0000000}, {223,0.0000000}, {224,0.0000000}, {225,0.0000000}, {226,0.0000000}, {227,0.0000000}, {228,0.0000000}, {229,0.0000000}, {230,0.0000000}, {231,0.0000000}, {232,0.0000000}, {233,0.0000000}, {234,0.0000000}, {235,0.0000000}, {236,0.0000000}, {237,0.0000000}, {238,0.0000000}, {239,0.0000000}, {240,0.0000000}, {241,0.0000000}, {242,0.0000000}, {243,0.0000000}, {244,0.0000000}, {245,0.0000000}, {246,0.0000000}, {247,0.0000000}, {248,0.0000000}, {249,0.0000000}, {250,0.0000000}, {251,0.0000000}, {252,0.0000000}, {253,0.0000000}, {254,0.0000000}, {255,0.0000000}, {256,0.0000000}, {257,0.0000000}, {258,0.0000000}, {259,0.0000000}, {260,0.0000000}, {261,0.0000000}, {262,0.0000000}, {263,0.0000000}, {264,0.0000000}, {265,0.0000000}, {266,0.0000000}, {267,0.0000000}, {268,0.0000000}, {269,0.0000000}, {270,0.0000000}, {271,0.0000000}, {272,0.0000000}, {273,0.0000000}, {274,0.0000000}, {275,0.0000000}, {276,0.0000000}, {277,0.0000000}, {278,0.0000000}, {279,0.0000000}, {280,0.0000000}, {281,0.0000857}, {282,0.0000000}, {283,0.0000000}, {284,0.0000000}, {285,0.0000000}, {286,0.0000000}, {287,0.0000000}, {288,0.0000000}, {289,0.0000000}, {290,0.0000000}, {291,0.0000000}, {292,0.0000000}, {293,0.0000000}, {294,0.0000000}, {295,0.0000000}, {296,0.0000000}, {297,0.0000000}, {298,0.0000000}, {299,0.0000000}, {300,0.0000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000857}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000857}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0001143}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0001143}, {487,0.0000000}, {488,0.0000000}, {489,0.0000857}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000857}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0001143}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}};
data["big"]["LtacPrimUncurry"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00003960}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.0000000}, {177,0.0000000}, {178,0.0000000}, {179,0.0000000}, {180,0.0000000}, {181,0.0000000}, {182,0.0000000}, {183,0.0000000}, {184,0.0000000}, {185,0.0000000}, {186,0.0000000}, {187,0.0000000}, {188,0.0000000}, {189,0.0000000}, {190,0.0000000}, {191,0.0000000}, {192,0.0000000}, {193,0.0000000}, {194,0.0000000}, {195,0.0000000}, {196,0.0000000}, {197,0.0000000}, {198,0.0000000}, {199,0.0000000}, {200,0.0000000}, {201,0.0000000}, {202,0.0000000}, {203,0.0000000}, {204,0.0000000}, {205,0.0000000}, {206,0.0000000}, {207,0.0000000}, {208,0.0000000}, {209,0.0000000}, {210,0.0000000}, {211,0.0000000}, {212,0.0000000}, {213,0.0000000}, {214,0.0000000}, {215,0.0000000}, {216,0.0000000}, {217,0.0000000}, {218,0.0000000}, {219,0.0000000}, {220,0.0000000}, {221,0.0000000}, {222,0.0000000}, {223,0.0000000}, {224,0.0000000}, {225,0.0000000}, {226,0.0000000}, {227,0.0000000}, {228,0.0000000}, {229,0.0000000}, {230,0.0000000}, {231,0.0000000}, {232,0.0000000}, {233,0.0000000}, {234,0.0000000}, {235,0.0000000}, {236,0.0000000}, {237,0.0000000}, {238,0.0000000}, {239,0.0000000}, {240,0.0000000}, {241,0.0000000}, {242,0.0000000}, {243,0.0000000}, {244,0.0000000}, {245,0.0000000}, {246,0.0000000}, {247,0.0000000}, {248,0.0000000}, {249,0.0000000}, {250,0.0000000}, {251,0.0000000}, {252,0.0000000}, {253,0.0000000}, {254,0.0000000}, {255,0.0000000}, {256,0.0000000}, {257,0.0000000}, {258,0.0000000}, {259,0.0000000}, {260,0.0000000}, {261,0.0000000}, {262,0.0000000}, {263,0.0000000}, {264,0.0000000}, {265,0.0000000}, {266,0.0000000}, {267,0.0000000}, {268,0.0000000}, {269,0.0000000}, {270,0.0000000}, {271,0.0000000}, {272,0.0000000}, {273,0.0000000}, {274,0.0000000}, {275,0.0000000}, {276,0.0000000}, {277,0.0000000}, {278,0.0000000}, {279,0.0000000}, {280,0.0000000}, {281,0.0000000}, {282,0.0000000}, {283,0.0000000}, {284,0.0000000}, {285,0.0000000}, {286,0.0000000}, {287,0.0000000}, {288,0.0000000}, {289,0.0000000}, {290,0.0000000}, {291,0.0000000}, {292,0.0000000}, {293,0.0000000}, {294,0.0000000}, {295,0.0000000}, {296,0.0000000}, {297,0.0000000}, {298,0.0000000}, {299,0.0000000}, {300,0.0000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}};
data["big"]["LtacPrimUncurry"]["reif"]["real"] = {{1,0.00000000}, {2,0.00100000}, {3,0.00100000}, {4,0.00200000}, {5,0.00200000}, {6,0.00300000}, {7,0.00323762}, {8,0.00400000}, {9,0.00494059}, {10,0.00521782}, {11,0.02545545}, {12,0.00700000}, {13,0.00778218}, {14,0.00839604}, {15,0.00929703}, {16,0.01022772}, {17,0.01129703}, {18,0.01239604}, {19,0.01340594}, {20,0.01443564}, {21,0.01588119}, {22,0.01724752}, {23,0.01838614}, {24,0.01954455}, {25,0.02100990}, {26,0.02345545}, {27,0.02370297}, {28,0.02544554}, {29,0.02681188}, {30,0.02976238}, {31,0.03007921}, {32,0.03181188}, {33,0.03550495}, {34,0.03541584}, {35,0.03741584}, {36,0.04026733}, {37,0.04103960}, {38,0.04298020}, {39,0.04522772}, {40,0.04757426}, {41,0.04904950}, {42,0.05175248}, {43,0.05351485}, {44,0.05721782}, {45,0.05869307}, {46,0.06221782}, {47,0.06377228}, {48,0.06500000}, {49,0.07033663}, {50,0.07159406}, {51,0.07313861}, {52,0.07682178}, {53,0.08200000}, {54,0.08592079}, {55,0.08599010}, {56,0.08929703}, {57,0.09044554}, {58,0.09328713}, {59,0.09653465}, {60,0.09955446}, {61,0.10308911}, {62,0.11100000}, {63,0.11604950}, {64,0.11720792}, {65,0.11899010}, {66,0.12050495}, {67,0.12882178}, {68,0.13112871}, {69,0.13326733}, {70,0.14123762}, {71,0.14245545}, {72,0.14885149}, {73,0.14909901}, {74,0.15605941}, {75,0.15753465}, {76,0.16260396}, {77,0.16861386}, {78,0.17420792}, {79,0.17668317}, {80,0.17982178}, {81,0.18372277}, {82,0.18910891}, {83,0.19496040}, {84,0.20355446}, {85,0.20703960}, {86,0.20973267}, {87,0.21336634}, {88,0.22235644}, {89,0.22434653}, {90,0.23450495}, {91,0.23570297}, {92,0.24227723}, {93,0.25036634}, {94,0.25262376}, {95,0.25745545}, {96,0.26557426}, {97,0.27055446}, {98,0.27560396}, {99,0.28269307}, {100,0.28780198}, {101,0.29848515}, {102,0.30095050}, {103,0.30639604}, {104,0.31532673}, {105,0.32503960}, {106,0.33145545}, {107,0.34081188}, {108,0.34700990}, {109,0.35603960}, {110,0.36406931}, {111,0.37090099}, {112,0.37778218}, {113,0.38413861}, {114,0.39174257}, {115,0.39621782}, {116,0.40370297}, {117,0.41100990}, {118,0.41964356}, {119,0.42989109}, {120,0.43704950}, {121,0.44542574}, {122,0.45302970}, {123,0.46415842}, {124,0.47236634}, {125,0.47913861}, {126,0.48808911}, {127,0.50083168}, {128,0.50547525}, {129,0.51527723}, {130,0.52839604}, {131,0.54415842}, {132,0.54257426}, {133,0.55168317}, {134,0.56425743}, {135,0.57335644}, {136,0.57562376}, {137,0.59206931}, {138,0.60369307}, {139,0.60780198}, {140,0.62715842}, {141,0.63301980}, {142,0.64503960}, {143,0.65511881}, {144,0.68353465}, {145,0.67363366}, {146,0.69040594}, {147,0.69383168}, {148,0.71542574}, {149,0.72236634}, {150,0.73248515}, {151,0.75149505}, {152,0.76022772}, {153,0.77313861}, {154,0.78138614}, {155,0.95231683}, {156,0.87374257}, {157,0.94935644}, {158,0.83454455}, {159,0.85149505}, {160,0.86866337}, {161,0.87700000}, {162,0.88531683}, {163,0.90037624}, {164,0.90920792}, {165,0.92655446}, {166,0.94008911}, {167,0.95727723}, {168,0.97008911}, {169,0.98342574}, {170,1.00370297}, {171,1.01639604}, {172,1.03244554}, {173,1.05217822}, {174,1.06159406}, {175,1.06397030}, {176,1.1248571}, {177,1.1098857}, {178,1.1248857}, {179,1.1379714}, {180,1.1710000}, {181,1.2026286}, {182,1.1986857}, {183,1.2134000}, {184,1.2232286}, {185,1.2382286}, {186,1.2657429}, {187,1.2722000}, {188,1.2946000}, {189,1.3018286}, {190,1.3423714}, {191,1.3551429}, {192,1.3714571}, {193,1.3789714}, {194,1.4361714}, {195,1.4264000}, {196,1.4453714}, {197,1.4672286}, {198,1.4866857}, {199,1.5125143}, {200,1.5311143}, {201,1.5602857}, {202,1.5696857}, {203,1.5877143}, {204,1.6100286}, {205,1.6144286}, {206,1.6505429}, {207,1.6850571}, {208,1.6796286}, {209,1.7087143}, {210,1.7527143}, {211,1.7832571}, {212,1.7597429}, {213,1.8082571}, {214,1.8549429}, {215,1.8705714}, {216,1.8817143}, {217,1.9322571}, {218,1.9396286}, {219,1.9767714}, {220,2.0102000}, {221,2.0223714}, {222,2.0498857}, {223,2.0557714}, {224,2.0932571}, {225,2.1181714}, {226,2.1539714}, {227,2.1940571}, {228,2.1958000}, {229,2.2942857}, {230,2.2525143}, {231,2.3132286}, {232,2.2917429}, {233,2.3539714}, {234,2.3440286}, {235,2.4353714}, {236,2.4850571}, {237,2.5264571}, {238,2.4656857}, {239,2.5233429}, {240,2.5696571}, {241,2.6011143}, {242,2.6259143}, {243,2.6847429}, {244,2.6968000}, {245,2.7235429}, {246,3.3504857}, {247,2.8002857}, {248,2.8400000}, {249,2.8779429}, {250,2.9881714}, {251,2.9183143}, {252,2.9724286}, {253,3.0230571}, {254,3.0692000}, {255,3.0944857}, {256,3.1083714}, {257,3.1705714}, {258,3.1142571}, {259,3.2267714}, {260,3.2458000}, {261,3.3010000}, {262,3.3525714}, {263,3.3560571}, {264,3.3922286}, {265,3.4454857}, {266,3.4769429}, {267,3.5490000}, {268,3.5335714}, {269,3.6179714}, {270,3.6489143}, {271,3.6746286}, {272,3.7004571}, {273,3.7765429}, {274,3.8129143}, {275,3.8642857}, {276,3.8905143}, {277,3.9252286}, {278,3.9502000}, {279,4.0376857}, {280,4.0614000}, {281,4.1119714}, {282,4.0954286}, {283,4.2396857}, {284,4.2276571}, {285,4.2504857}, {286,4.3323143}, {287,4.4058571}, {288,4.4042857}, {289,4.4709143}, {290,4.5508000}, {291,4.5800000}, {292,4.5103714}, {293,4.5629429}, {294,4.6740286}, {295,4.6210571}, {296,4.8483429}, {297,4.8289429}, {298,4.9444286}, {299,4.8548571}, {300,5.0039429}, {301,5.0462857}, {302,5.1171429}, {303,5.1547143}, {304,5.2188000}, {305,5.0839429}, {306,5.3456286}, {307,5.3389143}, {308,5.4226000}, {309,5.4769714}, {310,5.5092857}, {311,5.5974571}, {312,5.6061143}, {313,5.7072571}, {314,5.7712286}, {315,5.5702286}, {316,5.7351714}, {317,5.8539714}, {318,5.9810857}, {319,6.0183714}, {320,6.1115714}, {321,6.0996000}, {322,6.1608857}, {323,6.2517714}, {324,6.2598000}, {325,6.4001714}, {326,6.4810000}, {327,6.5061143}, {328,6.5635714}, {329,6.6158286}, {330,6.6744286}, {331,6.6422000}, {332,6.8195429}, {333,6.9248571}, {334,6.7580857}, {335,7.0224571}, {336,7.0928000}, {337,7.1304571}, {338,7.2310000}, {339,7.2886286}, {340,7.3114571}, {341,7.1484571}, {342,7.2764571}, {343,7.5035714}, {344,7.5924000}, {345,7.6730000}, {346,7.6959143}, {347,7.7509714}, {348,7.8850571}, {349,7.9325143}, {350,7.9802000}, {351,8.0510571}, {352,8.1461143}, {353,8.1896286}, {354,8.2806857}, {355,8.3503143}, {356,8.4150000}, {357,8.4974857}, {358,8.5810571}, {359,8.6388857}, {360,8.7214000}, {361,8.7976000}, {362,8.8294857}, {363,8.9146571}, {364,8.9724000}, {365,9.0339714}, {366,9.1613143}, {367,9.1141714}, {368,9.3598000}, {369,9.3934571}, {370,9.4789143}, {371,9.5636286}, {372,9.5813429}, {373,9.5799429}, {374,9.7744000}, {375,9.9041143}, {376,10.0040857}, {377,10.0046571}, {378,10.1135143}, {379,10.1918286}, {380,9.7371429}, {381,10.3604286}, {382,10.2589714}, {383,10.5134000}, {384,10.6008571}, {385,10.5531714}, {386,10.7054571}, {387,10.8336857}, {388,10.9367143}, {389,10.8230286}, {390,10.9444286}, {391,11.0313143}, {392,11.2431714}, {393,11.3697143}, {394,11.4334286}, {395,11.3667143}, {396,11.5127714}, {397,11.3900571}, {398,11.6397143}, {399,11.9078571}, {400,11.9116571}, {401,12.0616000}, {402,12.1223429}, {403,12.2217714}, {404,12.3170000}, {405,12.4625714}, {406,12.5330000}, {407,12.6168571}, {408,12.6485429}, {409,12.8409143}, {410,12.7393143}, {411,12.9231429}, {412,13.0820000}, {413,12.6348286}, {414,12.9847429}, {415,13.2552286}, {416,13.4653429}, {417,13.5921429}, {418,13.6599143}, {419,13.6371143}, {420,13.8486000}, {421,13.9368286}, {422,14.1144000}, {423,14.1964857}, {424,14.2882286}, {425,14.2824857}, {426,14.4431429}, {427,14.4754286}, {428,14.6818857}, {429,14.7788571}, {430,14.8638000}, {431,14.4896571}, {432,15.1539714}, {433,15.1932286}, {434,15.3274286}, {435,15.4666286}, {436,15.5588286}, {437,15.6944571}, {438,15.7803714}, {439,15.9142857}, {440,15.9688286}, {441,16.0254857}, {442,16.2979429}, {443,16.4355143}, {444,16.5214286}, {445,16.6467714}, {446,16.7522571}, {447,16.7701714}, {448,16.9078000}, {449,17.0076286}, {450,17.0579143}, {451,17.2348571}, {452,17.2891429}, {453,17.4565143}, {454,17.5655143}, {455,17.5005714}, {456,17.2600000}, {457,17.8239714}, {458,17.9730286}, {459,18.0469429}, {460,18.2075143}, {461,18.0143143}, {462,18.3094000}, {463,18.5636857}, {464,18.5027429}, {465,18.6708571}, {466,18.8355143}, {467,19.0108000}, {468,19.0649714}, {469,19.3077714}, {470,19.1854286}, {471,19.5170000}, {472,19.6079429}, {473,19.5750286}, {474,19.8465714}, {475,19.9529429}, {476,20.0690571}, {477,20.1989714}, {478,20.3093143}, {479,20.4363143}, {480,20.5006857}, {481,20.5425143}, {482,20.8772571}, {483,20.9460286}, {484,21.1843714}, {485,21.0976286}, {486,21.3921143}, {487,21.5755714}, {488,21.5729429}, {489,21.6724286}, {490,21.7799143}, {491,21.8422571}, {492,22.2057143}, {493,22.1854857}, {494,22.2187429}, {495,22.7398000}, {496,22.6411429}, {497,22.9600286}, {498,23.1450571}, {499,23.2883429}, {500,23.4029714}, {505,23.9315714}, {510,24.7735714}, {515,25.4821714}, {520,26.2503714}, {525,26.7518000}, {530,27.0047143}, {535,28.4212000}, {540,29.0091714}, {545,30.0637714}, {550,30.8316286}, {555,31.7471714}, {560,32.4900571}, {565,33.2367143}, {570,34.1990571}, {575,35.1821143}, {580,35.9651143}, {585,37.1006571}, {590,37.9109714}, {595,38.6876571}, {600,40.0047143}, {605,40.8320286}, {610,41.9962571}, {615,42.7458000}, {620,44.0763143}, {625,45.2445714}, {630,46.1845714}, {635,47.2370286}, {640,48.0586857}, {645,49.2388857}, {650,50.6035429}, {655,51.5701714}, {660,53.2137714}, {665,54.4336571}, {670,55.4639714}, {675,56.6449429}, {680,58.1997143}, {685,58.9352000}, {690,60.4707429}, {695,61.5157429}, {700,62.9033143}};
data["big"]["LtacPrimUncurry"]["reif"]["user"] = {{1,0.00076238}, {2,0.00121782}, {3,0.00134653}, {4,0.00194059}, {5,0.00225743}, {6,0.00293069}, {7,0.00352475}, {8,0.00400000}, {9,0.00486139}, {10,0.00517822}, {11,0.02570297}, {12,0.00670297}, {13,0.00748515}, {14,0.00878218}, {15,0.00956436}, {16,0.01046535}, {17,0.01186139}, {18,0.01285149}, {19,0.01386139}, {20,0.01486139}, {21,0.01577228}, {22,0.01704950}, {23,0.01819802}, {24,0.01929703}, {25,0.02081188}, {26,0.02391089}, {27,0.02431683}, {28,0.02559406}, {29,0.02721782}, {30,0.02974257}, {31,0.02985149}, {32,0.03179208}, {33,0.03568317}, {34,0.03587129}, {35,0.03792079}, {36,0.04042574}, {37,0.04090099}, {38,0.04262376}, {39,0.04503960}, {40,0.04766337}, {41,0.04906931}, {42,0.05154455}, {43,0.05336634}, {44,0.05709901}, {45,0.05871287}, {46,0.06216832}, {47,0.06366337}, {48,0.06453465}, {49,0.07040594}, {50,0.07168317}, {51,0.07308911}, {52,0.07669307}, {53,0.08173267}, {54,0.08601980}, {55,0.08573267}, {56,0.08858416}, {57,0.09000990}, {58,0.09289109}, {59,0.09653465}, {60,0.09923762}, {61,0.10237624}, {62,0.11079208}, {63,0.11566337}, {64,0.11701980}, {65,0.11888119}, {66,0.12039604}, {67,0.12922772}, {68,0.13106931}, {69,0.13296040}, {70,0.14147525}, {71,0.14243564}, {72,0.14872277}, {73,0.14850495}, {74,0.15602970}, {75,0.15752475}, {76,0.16214851}, {77,0.16840594}, {78,0.17357426}, {79,0.17608911}, {80,0.17969307}, {81,0.18300990}, {82,0.18873267}, {83,0.19471287}, {84,0.20299010}, {85,0.20694059}, {86,0.20917822}, {87,0.21257426}, {88,0.22161386}, {89,0.22394059}, {90,0.23409901}, {91,0.23526733}, {92,0.24159406}, {93,0.24985149}, {94,0.25223762}, {95,0.25725743}, {96,0.26557426}, {97,0.27035644}, {98,0.27541584}, {99,0.28257426}, {100,0.28766337}, {101,0.29850495}, {102,0.30069307}, {103,0.30606931}, {104,0.31474257}, {105,0.32443564}, {106,0.33094059}, {107,0.34061386}, {108,0.34614851}, {109,0.35515842}, {110,0.36335644}, {111,0.37029703}, {112,0.37710891}, {113,0.38395050}, {114,0.39098020}, {115,0.39535644}, {116,0.40301980}, {117,0.41047525}, {118,0.41888119}, {119,0.42900990}, {120,0.43630693}, {121,0.44495050}, {122,0.45231683}, {123,0.46349505}, {124,0.47163366}, {125,0.47847525}, {126,0.48700000}, {127,0.50020792}, {128,0.50488119}, {129,0.51495050}, {130,0.52742574}, {131,0.54356436}, {132,0.54182178}, {133,0.55089109}, {134,0.56355446}, {135,0.57263366}, {136,0.57493069}, {137,0.59137624}, {138,0.60301980}, {139,0.60703960}, {140,0.62628713}, {141,0.63220792}, {142,0.64447525}, {143,0.65410891}, {144,0.68277228}, {145,0.67249505}, {146,0.68922772}, {147,0.69331683}, {148,0.71443564}, {149,0.72139604}, {150,0.73149505}, {151,0.75053465}, {152,0.75953465}, {153,0.77233663}, {154,0.78078218}, {155,0.95090099}, {156,0.87267327}, {157,0.94752475}, {158,0.83354455}, {159,0.85015842}, {160,0.86733663}, {161,0.87620792}, {162,0.88404950}, {163,0.89969307}, {164,0.90819802}, {165,0.92536634}, {166,0.93898020}, {167,0.95583168}, {168,0.96900990}, {169,0.98229703}, {170,1.00264356}, {171,1.01543564}, {172,1.03135644}, {173,1.05102970}, {174,1.06029703}, {175,1.06258416}, {176,1.1238857}, {177,1.1094571}, {178,1.1231143}, {179,1.1374857}, {180,1.1695143}, {181,1.2014000}, {182,1.1976286}, {183,1.2128857}, {184,1.2220857}, {185,1.2375143}, {186,1.2649429}, {187,1.2710000}, {188,1.2938286}, {189,1.3007714}, {190,1.3407429}, {191,1.3541429}, {192,1.3704000}, {193,1.3774571}, {194,1.4352000}, {195,1.4247143}, {196,1.4446286}, {197,1.4645714}, {198,1.4839143}, {199,1.5105429}, {200,1.5292286}, {201,1.5585714}, {202,1.5690286}, {203,1.5872000}, {204,1.6093714}, {205,1.6138286}, {206,1.6493714}, {207,1.6843429}, {208,1.6785714}, {209,1.7082286}, {210,1.7514286}, {211,1.7826571}, {212,1.7588000}, {213,1.8069429}, {214,1.8499143}, {215,1.8661714}, {216,1.8801714}, {217,1.9303143}, {218,1.9379143}, {219,1.9747714}, {220,2.0083429}, {221,2.0210000}, {222,2.0482286}, {223,2.0535429}, {224,2.0923143}, {225,2.1162857}, {226,2.1520857}, {227,2.1924571}, {228,2.1943429}, {229,2.2921714}, {230,2.2509714}, {231,2.3112571}, {232,2.2896000}, {233,2.3522286}, {234,2.3423143}, {235,2.4332857}, {236,2.4830286}, {237,2.5244286}, {238,2.4637143}, {239,2.5206857}, {240,2.5667714}, {241,2.5987429}, {242,2.6240000}, {243,2.6813429}, {244,2.6918286}, {245,2.7160286}, {246,3.3435143}, {247,2.7980857}, {248,2.8368000}, {249,2.8720571}, {250,2.9838571}, {251,2.9120857}, {252,2.9681714}, {253,3.0090571}, {254,3.0641714}, {255,3.0925429}, {256,3.1069429}, {257,3.1686286}, {258,3.1124857}, {259,3.2244571}, {260,3.2439143}, {261,3.2990286}, {262,3.3511429}, {263,3.3541714}, {264,3.3903143}, {265,3.4427143}, {266,3.4744000}, {267,3.5464286}, {268,3.5310286}, {269,3.6154857}, {270,3.6464571}, {271,3.6729714}, {272,3.6984857}, {273,3.7734857}, {274,3.8102571}, {275,3.8620000}, {276,3.8877429}, {277,3.9223143}, {278,3.9469143}, {279,4.0343143}, {280,4.0575143}, {281,4.1091429}, {282,4.0924857}, {283,4.2370571}, {284,4.2239429}, {285,4.2470571}, {286,4.3284000}, {287,4.4023714}, {288,4.4011143}, {289,4.4666000}, {290,4.5480286}, {291,4.5766857}, {292,4.5068286}, {293,4.5592857}, {294,4.6704571}, {295,4.6171143}, {296,4.8444571}, {297,4.8254857}, {298,4.9402000}, {299,4.8506000}, {300,4.9991143}, {301,5.0412857}, {302,5.1122000}, {303,5.1500000}, {304,5.2134286}, {305,5.0788571}, {306,5.3397143}, {307,5.3327143}, {308,5.4163143}, {309,5.4709429}, {310,5.5042000}, {311,5.5919714}, {312,5.5997429}, {313,5.7013714}, {314,5.7658000}, {315,5.5656286}, {316,5.7299429}, {317,5.8488857}, {318,5.9766000}, {319,6.0134286}, {320,6.1060000}, {321,6.0944286}, {322,6.1556286}, {323,6.2464857}, {324,6.2551429}, {325,6.3946286}, {326,6.4754857}, {327,6.5012000}, {328,6.5582857}, {329,6.6102000}, {330,6.6697143}, {331,6.6372286}, {332,6.8154857}, {333,6.9205429}, {334,6.7544000}, {335,7.0176000}, {336,7.0888000}, {337,7.1257429}, {338,7.2261714}, {339,7.2839714}, {340,7.3066571}, {341,7.1439429}, {342,7.2709143}, {343,7.4988286}, {344,7.5878000}, {345,7.6682286}, {346,7.6905143}, {347,7.7453143}, {348,7.8787714}, {349,7.9266857}, {350,7.9747714}, {351,8.0452571}, {352,8.1395714}, {353,8.1833714}, {354,8.2735714}, {355,8.3438571}, {356,8.4086286}, {357,8.4909143}, {358,8.5748857}, {359,8.6323714}, {360,8.7145714}, {361,8.7914286}, {362,8.8234000}, {363,8.9092857}, {364,8.9667714}, {365,9.0280857}, {366,9.1549143}, {367,9.1080571}, {368,9.3521714}, {369,9.3790000}, {370,9.4632000}, {371,9.5540857}, {372,9.5725143}, {373,9.5701429}, {374,9.7633714}, {375,9.8927429}, {376,9.9918857}, {377,9.9937714}, {378,10.1031429}, {379,10.1809714}, {380,9.7258000}, {381,10.3488571}, {382,10.2466000}, {383,10.5016857}, {384,10.5898857}, {385,10.5424000}, {386,10.6962857}, {387,10.8238286}, {388,10.9257429}, {389,10.8129429}, {390,10.9341429}, {391,11.0207143}, {392,11.2324286}, {393,11.3592857}, {394,11.4227714}, {395,11.3558286}, {396,11.5023429}, {397,11.3788286}, {398,11.6290857}, {399,11.8971143}, {400,11.9007143}, {401,12.0514000}, {402,12.1112857}, {403,12.2101714}, {404,12.3042000}, {405,12.4513143}, {406,12.5231429}, {407,12.6055143}, {408,12.6396000}, {409,12.8314571}, {410,12.7298571}, {411,12.9130857}, {412,13.0728571}, {413,12.6266286}, {414,12.9763714}, {415,13.2450000}, {416,13.4530571}, {417,13.5818857}, {418,13.6516286}, {419,13.6289143}, {420,13.8393429}, {421,13.9278000}, {422,14.1085143}, {423,14.1901429}, {424,14.2822571}, {425,14.2754857}, {426,14.4339714}, {427,14.4659143}, {428,14.6687429}, {429,14.7660857}, {430,14.8501143}, {431,14.4755429}, {432,15.1383143}, {433,15.1788571}, {434,15.3122000}, {435,15.4494857}, {436,15.5423714}, {437,15.6761714}, {438,15.7628000}, {439,15.8887143}, {440,15.9529429}, {441,16.0111714}, {442,16.2024000}, {443,16.3194571}, {444,16.4519714}, {445,16.5733429}, {446,16.6863714}, {447,16.7443143}, {448,16.8912286}, {449,16.9900000}, {450,17.0299714}, {451,17.1490857}, {452,17.2208286}, {453,17.3539429}, {454,17.4832857}, {455,17.4066857}, {456,17.1898286}, {457,17.7877714}, {458,17.9494857}, {459,18.0260000}, {460,18.1655143}, {461,17.9953143}, {462,18.2893429}, {463,18.5415143}, {464,18.4800000}, {465,18.6485143}, {466,18.8122857}, {467,18.9766571}, {468,19.0289714}, {469,19.2766000}, {470,19.1379143}, {471,19.4491143}, {472,19.5319143}, {473,19.5337714}, {474,19.8206857}, {475,19.9272571}, {476,20.0448286}, {477,20.1722571}, {478,20.2828000}, {479,20.4120571}, {480,20.4762571}, {481,20.5185143}, {482,20.8533429}, {483,20.9240571}, {484,21.1694000}, {485,21.0842000}, {486,21.3782000}, {487,21.5633143}, {488,21.5546857}, {489,21.6539143}, {490,21.7635143}, {491,21.8250571}, {492,22.1870571}, {493,22.1616286}, {494,22.1920286}, {495,22.7165143}, {496,22.6172000}, {497,22.9327143}, {498,23.1152000}, {499,23.2111143}, {500,23.3246286}, {505,23.8996000}, {510,24.7478286}, {515,25.4580000}, {520,26.2261143}, {525,26.7221714}, {530,26.9779429}, {535,28.3962857}, {540,28.9831429}, {545,30.0352286}, {550,30.8026857}, {555,31.7181143}, {560,32.4606286}, {565,33.2067143}, {570,34.1726571}, {575,35.1542000}, {580,35.9423143}, {585,37.0782286}, {590,37.8868286}, {595,38.6626286}, {600,39.9747714}, {605,40.8004000}, {610,41.9586000}, {615,42.7063143}, {620,44.0370857}, {625,45.2077714}, {630,46.1497714}, {635,47.1986000}, {640,48.0218857}, {645,49.2060286}, {650,50.5742571}, {655,51.5353429}, {660,53.1692857}, {665,54.3818571}, {670,55.4081143}, {675,56.5895714}, {680,58.1407429}, {685,58.8761714}, {690,60.4095429}, {695,61.4542571}, {700,62.8357714}};
data["big"]["LtacPrimUncurry"]["reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00010891}, {4,0.00003960}, {5,0.00000000}, {6,0.00003960}, {7,0.00007921}, {8,0.00000000}, {9,0.00007921}, {10,0.00003960}, {11,0.00003960}, {12,0.00000000}, {13,0.00003960}, {14,0.00000000}, {15,0.00011881}, {16,0.00011881}, {17,0.00000000}, {18,0.00007921}, {19,0.00003960}, {20,0.00003960}, {21,0.00003960}, {22,0.00003960}, {23,0.00003960}, {24,0.00007921}, {25,0.00011881}, {26,0.00003960}, {27,0.00000000}, {28,0.00003960}, {29,0.00006931}, {30,0.00000000}, {31,0.00003960}, {32,0.00000000}, {33,0.00002970}, {34,0.00007921}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00003960}, {41,0.00007921}, {42,0.00000000}, {43,0.00000000}, {44,0.00003960}, {45,0.00003960}, {46,0.00000000}, {47,0.00003960}, {48,0.00003960}, {49,0.00003960}, {50,0.00000000}, {51,0.00003960}, {52,0.00003960}, {53,0.00007921}, {54,0.00000000}, {55,0.00003960}, {56,0.00007921}, {57,0.00003960}, {58,0.00003960}, {59,0.00003960}, {60,0.00007921}, {61,0.00007921}, {62,0.00002970}, {63,0.00000000}, {64,0.00003960}, {65,0.00000000}, {66,0.00003960}, {67,0.00000000}, {68,0.00002970}, {69,0.00000000}, {70,0.00000000}, {71,0.00003960}, {72,0.00003960}, {73,0.00003960}, {74,0.00002970}, {75,0.00000000}, {76,0.00003960}, {77,0.00003960}, {78,0.00002970}, {79,0.00011881}, {80,0.00002970}, {81,0.00003960}, {82,0.00003960}, {83,0.00000000}, {84,0.00003960}, {85,0.00003960}, {86,0.00003960}, {87,0.00007921}, {88,0.00002970}, {89,0.00007921}, {90,0.00015842}, {91,0.00000000}, {92,0.00010891}, {93,0.00007921}, {94,0.00003960}, {95,0.00011881}, {96,0.00000000}, {97,0.00003960}, {98,0.00002970}, {99,0.00007921}, {100,0.00003960}, {101,0.00000000}, {102,0.00007921}, {103,0.00003960}, {104,0.00003960}, {105,0.00003960}, {106,0.00003960}, {107,0.00000000}, {108,0.00010891}, {109,0.00006931}, {110,0.00015842}, {111,0.00000000}, {112,0.00002970}, {113,0.00003960}, {114,0.00002970}, {115,0.00000000}, {116,0.00002970}, {117,0.00007921}, {118,0.00011881}, {119,0.00007921}, {120,0.00003960}, {121,0.00003960}, {122,0.00003960}, {123,0.00006931}, {124,0.00003960}, {125,0.00007921}, {126,0.00007921}, {127,0.00011881}, {128,0.00000000}, {129,0.00015842}, {130,0.00007921}, {131,0.00003960}, {132,0.00003960}, {133,0.00007921}, {134,0.00014851}, {135,0.00007921}, {136,0.00007921}, {137,0.00003960}, {138,0.00003960}, {139,0.00003960}, {140,0.00015842}, {141,0.00003960}, {142,0.00014851}, {143,0.00010891}, {144,0.00019802}, {145,0.00003960}, {146,0.00006931}, {147,0.00003960}, {148,0.00007921}, {149,0.00003960}, {150,0.00003960}, {151,0.00007921}, {152,0.00011881}, {153,0.00010891}, {154,0.00000000}, {155,0.00062376}, {156,0.00026733}, {157,0.00060396}, {158,0.00003960}, {159,0.00019802}, {160,0.00015842}, {161,0.00007921}, {162,0.00023762}, {163,0.00007921}, {164,0.00007921}, {165,0.00015842}, {166,0.00007921}, {167,0.00011881}, {168,0.00003960}, {169,0.00014851}, {170,0.00022772}, {171,0.00007921}, {172,0.00000000}, {173,0.00007921}, {174,0.00015842}, {175,0.00014851}, {176,0.0001143}, {177,0.0000000}, {178,0.0005429}, {179,0.0002286}, {180,0.0004571}, {181,0.0001143}, {182,0.0003429}, {183,0.0000000}, {184,0.0000000}, {185,0.0000000}, {186,0.0000000}, {187,0.0002286}, {188,0.0001143}, {189,0.0002286}, {190,0.0003429}, {191,0.0000000}, {192,0.0000000}, {193,0.0000000}, {194,0.0000000}, {195,0.0000000}, {196,0.0001143}, {197,0.0001143}, {198,0.0002286}, {199,0.0000000}, {200,0.0003429}, {201,0.0004571}, {202,0.0000000}, {203,0.0001143}, {204,0.0001143}, {205,0.0000000}, {206,0.0003429}, {207,0.0002286}, {208,0.0002286}, {209,0.0002286}, {210,0.0001143}, {211,0.0001143}, {212,0.0002286}, {213,0.0004571}, {214,0.0004571}, {215,0.0001143}, {216,0.0002286}, {217,0.0001143}, {218,0.0003429}, {219,0.0001143}, {220,0.0000000}, {221,0.0003429}, {222,0.0004571}, {223,0.0001143}, {224,0.0002286}, {225,0.0001143}, {226,0.0004571}, {227,0.0001143}, {228,0.0001143}, {229,0.0003143}, {230,0.0000000}, {231,0.0000000}, {232,0.0003429}, {233,0.0000000}, {234,0.0001143}, {235,0.0005429}, {236,0.0003143}, {237,0.0000000}, {238,0.0002286}, {239,0.0000000}, {240,0.0002286}, {241,0.0002286}, {242,0.0001714}, {243,0.0003429}, {244,0.0002000}, {245,0.0002286}, {246,0.0046571}, {247,0.0003429}, {248,0.0003429}, {249,0.0002286}, {250,0.0001143}, {251,0.0001143}, {252,0.0003429}, {253,0.0001143}, {254,0.0000000}, {255,0.0004571}, {256,0.0003143}, {257,0.0004571}, {258,0.0003429}, {259,0.0002286}, {260,0.0001143}, {261,0.0004571}, {262,0.0001143}, {263,0.0001143}, {264,0.0001143}, {265,0.0003429}, {266,0.0000000}, {267,0.0004571}, {268,0.0000000}, {269,0.0002286}, {270,0.0000000}, {271,0.0003143}, {272,0.0002286}, {273,0.0002286}, {274,0.0002286}, {275,0.0001143}, {276,0.0002286}, {277,0.0002286}, {278,0.0000000}, {279,0.0008571}, {280,0.0002286}, {281,0.0001143}, {282,0.0003429}, {283,0.0001143}, {284,0.0003429}, {285,0.0003429}, {286,0.0003143}, {287,0.0003429}, {288,0.0003429}, {289,0.0008857}, {290,0.0001143}, {291,0.0003429}, {292,0.0003429}, {293,0.0004571}, {294,0.0006571}, {295,0.0004571}, {296,0.0002286}, {297,0.0000857}, {298,0.0003429}, {299,0.0000000}, {300,0.0002286}, {301,0.0005714}, {302,0.0004286}, {303,0.0003429}, {304,0.0005714}, {305,0.0003429}, {306,0.0004571}, {307,0.0010000}, {308,0.0008000}, {309,0.0005714}, {310,0.0001143}, {311,0.0003429}, {312,0.0006857}, {313,0.0004571}, {314,0.0004286}, {315,0.0002286}, {316,0.0008000}, {317,0.0005429}, {318,0.0002286}, {319,0.0001143}, {320,0.0006857}, {321,0.0005714}, {322,0.0006571}, {323,0.0005714}, {324,0.0002286}, {325,0.0003429}, {326,0.0006571}, {327,0.0002286}, {328,0.0004571}, {329,0.0006857}, {330,0.0004286}, {331,0.0004571}, {332,0.0001143}, {333,0.0002286}, {334,0.0002286}, {335,0.0004571}, {336,0.0002286}, {337,0.0002286}, {338,0.0006857}, {339,0.0003429}, {340,0.0001143}, {341,0.0004571}, {342,0.0007714}, {343,0.0003429}, {344,0.0005714}, {345,0.0002286}, {346,0.0003429}, {347,0.0001143}, {348,0.0004571}, {349,0.0004571}, {350,0.0004286}, {351,0.0004571}, {352,0.0001143}, {353,0.0004571}, {354,0.0008000}, {355,0.0004286}, {356,0.0004571}, {357,0.0003429}, {358,0.0003429}, {359,0.0005714}, {360,0.0006857}, {361,0.0004571}, {362,0.0005143}, {363,0.0002286}, {364,0.0003429}, {365,0.0003429}, {366,0.0006857}, {367,0.0005429}, {368,0.0006857}, {369,0.0010000}, {370,0.0009143}, {371,0.0010857}, {372,0.0005714}, {373,0.0005714}, {374,0.0004571}, {375,0.0004571}, {376,0.0010000}, {377,0.0004571}, {378,0.0002286}, {379,0.0002286}, {380,0.0006571}, {381,0.0006857}, {382,0.0014857}, {383,0.0008000}, {384,0.0006857}, {385,0.0011429}, {386,0.0008000}, {387,0.0003143}, {388,0.0012571}, {389,0.0009143}, {390,0.0008571}, {391,0.0008000}, {392,0.0011429}, {393,0.0006571}, {394,0.0010000}, {395,0.0005714}, {396,0.0004571}, {397,0.0012571}, {398,0.0004286}, {399,0.0008000}, {400,0.0007714}, {401,0.0004571}, {402,0.0007714}, {403,0.0007714}, {404,0.0011429}, {405,0.0009143}, {406,0.0002286}, {407,0.0012571}, {408,0.0006857}, {409,0.0010286}, {410,0.0010286}, {411,0.0011429}, {412,0.0009143}, {413,0.0004286}, {414,0.0007714}, {415,0.0006857}, {416,0.0012000}, {417,0.0003429}, {418,0.0006857}, {419,0.0004571}, {420,0.0006857}, {421,0.0011429}, {422,0.0002286}, {423,0.0008000}, {424,0.0003429}, {425,0.0008857}, {426,0.0006571}, {427,0.0011143}, {428,0.0012286}, {429,0.0005143}, {430,0.0011429}, {431,0.0013714}, {432,0.0013429}, {433,0.0009143}, {434,0.0011429}, {435,0.0010286}, {436,0.0008571}, {437,0.0006857}, {438,0.0006571}, {439,0.0014857}, {440,0.0011429}, {441,0.0006857}, {442,0.0009143}, {443,0.0008000}, {444,0.0004571}, {445,0.0004571}, {446,0.0013714}, {447,0.0012571}, {448,0.0006857}, {449,0.0016857}, {450,0.0011429}, {451,0.0014857}, {452,0.0010286}, {453,0.0012571}, {454,0.0019143}, {455,0.0020571}, {456,0.0014857}, {457,0.0014286}, {458,0.0010000}, {459,0.0011429}, {460,0.0009143}, {461,0.0011429}, {462,0.0011429}, {463,0.0008000}, {464,0.0014857}, {465,0.0012571}, {466,0.0016857}, {467,0.0015714}, {468,0.0013143}, {469,0.0011429}, {470,0.0013429}, {471,0.0018286}, {472,0.0013714}, {473,0.0010000}, {474,0.0012286}, {475,0.0011143}, {476,0.0011429}, {477,0.0010000}, {478,0.0016857}, {479,0.0017143}, {480,0.0020571}, {481,0.0006857}, {482,0.0006571}, {483,0.0016000}, {484,0.0009143}, {485,0.0009143}, {486,0.0006857}, {487,0.0008000}, {488,0.0008000}, {489,0.0011429}, {490,0.0009143}, {491,0.0008857}, {492,0.0009143}, {493,0.0011143}, {494,0.0016000}, {495,0.0008000}, {496,0.0010286}, {497,0.0015143}, {498,0.0014857}, {499,0.0009143}, {500,0.0012286}, {505,0.0006857}, {510,0.0011429}, {515,0.0011429}, {520,0.0010286}, {525,0.0018000}, {530,0.0012571}, {535,0.0018286}, {540,0.0016000}, {545,0.0021143}, {550,0.0024000}, {555,0.0019143}, {560,0.0017143}, {565,0.0014857}, {570,0.0016000}, {575,0.0022571}, {580,0.0012571}, {585,0.0012571}, {590,0.0008857}, {595,0.0019143}, {600,0.0021429}, {605,0.0021429}, {610,0.0025143}, {615,0.0028571}, {620,0.0028286}, {625,0.0020571}, {630,0.0020286}, {635,0.0023714}, {640,0.0024000}, {645,0.0026000}, {650,0.0016857}, {655,0.0021143}, {660,0.0024571}, {665,0.0023714}, {670,0.0035429}, {675,0.0023429}, {680,0.0043429}, {685,0.0035429}, {690,0.0038286}, {695,0.0031429}, {700,0.0066286}};
data["big"]["LtacTCExplicitCtx"]["Aggregate"]["real"] = {{1,0.00100000}, {2,0.00100000}, {3,0.00200000}, {4,0.00200000}, {5,0.00203960}, {6,0.00301980}, {7,0.00301980}, {8,0.00342574}, {9,0.00400000}, {10,0.00420792}, {11,0.00500000}, {12,0.00508911}, {13,0.00559406}, {14,0.00609901}, {15,0.00677228}, {16,0.00706931}, {17,0.00786139}, {18,0.00817822}, {19,0.00889109}, {20,0.00946535}, {21,0.01000990}, {22,0.01038614}, {23,0.01101980}, {24,0.01175248}, {25,0.01233663}, {26,0.01295050}, {27,0.01356436}, {28,0.01409901}, {29,0.01760396}, {30,0.01550495}, {31,0.01607921}, {32,0.01689109}, {33,0.01747525}, {34,0.01826733}, {35,0.01906931}, {36,0.01978218}, {37,0.02042574}, {38,0.02126733}, {39,0.02214851}, {40,0.02281188}, {41,0.02338614}, {42,0.02444554}, {43,0.02838614}, {44,0.02613861}, {45,0.02688119}, {46,0.03328713}, {47,0.02853465}, {48,0.02952475}, {49,0.03018812}, {50,0.03124752}, {51,0.03216832}, {52,0.03320792}, {53,0.03405941}, {54,0.03983168}, {55,0.03599010}, {56,0.03700000}, {57,0.03791089}, {58,0.04739604}, {59,0.03994059}, {60,0.04101980}, {61,0.04201980}, {62,0.04300990}, {63,0.04408911}, {64,0.04513861}, {65,0.05077228}, {66,0.05279208}, {67,0.04819802}, {68,0.04948515}, {69,0.05063366}, {70,0.05460396}, {71,0.05308911}, {72,0.06022772}, {73,0.05527723}, {74,0.06550495}, {75,0.05719802}, {76,0.05853465}, {77,0.07567327}, {78,0.06119802}, {79,0.06267327}, {80,0.06370297}, {81,0.06576238}, {82,0.06764356}, {83,0.06900990}, {84,0.06855446}, {85,0.06963366}, {86,0.07158416}, {87,0.07287129}, {88,0.07396040}, {89,0.07534653}, {90,0.07721782}, {91,0.07848515}, {92,0.07970297}, {93,0.08083168}, {94,0.08300000}, {95,0.08429703}, {96,0.08545545}, {97,0.08741584}, {98,0.08901980}, {99,0.09001980}, {100,0.09177228}, {101,0.09289109}, {102,0.09448515}, {103,0.09641584}, {104,0.09803960}, {105,0.09945545}, {106,0.10090099}, {107,0.10204950}, {108,0.10388119}, {109,0.10543564}, {110,0.11463366}, {111,0.11583168}, {112,0.11781188}, {113,0.11989109}, {114,0.12203960}, {115,0.12444554}, {116,0.12645545}, {117,0.12894059}, {118,0.13199010}, {119,0.13259406}, {120,0.13650495}, {121,0.13827723}, {122,0.14115842}, {123,0.14507921}, {124,0.14809901}, {125,0.15136634}, {126,0.15373267}, {127,0.15469307}, {128,0.15603960}, {129,0.15852475}, {130,0.16167327}, {131,0.16268317}, {132,0.16372277}, {133,0.16745545}, {134,0.17037624}, {135,0.16996040}, {136,0.17353465}, {137,0.17536634}, {138,0.17807921}, {139,0.18095050}, {140,0.18039604}, {141,0.18577228}, {142,0.18692079}, {143,0.18901980}, {144,0.19272277}, {145,0.19443564}, {146,0.19767327}, {147,0.20066337}, {148,0.20151485}, {149,0.20417822}, {150,0.20643564}, {151,0.20767327}, {152,0.21000990}, {153,0.21051485}, {154,0.21266337}, {155,0.21542574}, {156,0.22025743}, {157,0.22219802}, {158,0.22449505}, {159,0.22496040}, {160,0.22946535}, {161,0.23040594}, {162,0.23183168}, {163,0.23305941}, {164,0.23725743}, {165,0.23728713}, {166,0.24179208}, {167,0.24425743}, {168,0.24325743}, {169,0.24722772}, {170,0.25248515}, {171,0.25450495}, {172,0.25658416}, {173,0.26003960}, {174,0.26191089}, {175,0.26612871}, {176,0.26478218}, {177,0.26712871}, {178,0.27114851}, {179,0.27422772}, {180,0.27834653}, {181,0.27969307}, {182,0.28456436}, {183,0.28614851}, {184,0.29108911}, {185,0.29321782}, {186,0.29467327}, {187,0.29682178}, {188,0.30054455}, {189,0.30301980}, {190,0.30600990}, {191,0.30672277}, {192,0.30899010}, {193,0.31109901}, {194,0.31492079}, {195,0.31376238}, {196,0.31519802}, {197,0.31997030}, {198,0.32959406}, {199,0.33491089}, {200,0.33013861}, {201,0.33056436}, {202,0.33811881}, {203,0.33752475}, {204,0.34615842}, {205,0.35387129}, {206,0.34351485}, {207,0.35043564}, {208,0.35027723}, {209,0.35535644}, {210,0.37085149}, {211,0.36108911}, {212,0.36376238}, {213,0.36589109}, {214,0.37904950}, {215,0.37465347}, {216,0.37376238}, {217,0.38791089}, {218,0.38752475}, {219,0.38519802}, {220,0.39479208}, {221,0.39603960}, {222,0.39848515}, {223,0.40693069}, {224,0.40496040}, {225,0.40675248}, {226,0.41547525}, {227,0.41320792}, {228,0.41827723}, {229,0.41798020}, {230,0.42801980}, {231,0.42631683}, {232,0.43200000}, {233,0.43447525}, {234,0.43600000}, {235,0.44249505}, {236,0.44507921}, {237,0.44599010}, {238,0.45561386}, {239,0.45200000}, {240,0.46565347}, {241,0.45937624}, {242,0.46801980}, {243,0.47077228}, {244,0.47334653}, {245,0.47991089}, {246,0.48234653}, {247,0.48066337}, {248,0.48865347}, {249,0.48789109}, {250,0.48974257}, {251,0.50458416}, {252,0.49859406}, {253,0.50216832}, {254,0.51247525}, {255,0.51041584}, {256,0.51185149}, {257,0.52648515}, {258,0.53044554}, {259,0.53015842}, {260,0.52633663}, {261,0.53322772}, {262,0.53675248}, {263,0.54049505}, {264,0.54996040}, {265,0.54914851}, {266,0.54874257}, {267,0.55185149}, {268,0.55813861}, {269,0.56226733}, {270,0.56645545}, {271,0.56975248}, {272,0.57524752}, {273,0.58105941}, {274,0.58487129}, {275,0.58882178}, {276,0.58824752}, {277,0.59172277}, {278,0.59475248}, {279,0.60060396}, {280,0.61329703}, {281,0.61748515}, {282,0.61964356}, {283,0.61883168}, {284,0.62500990}, {285,0.62655446}, {286,0.63395050}, {287,0.63354455}, {288,0.63956436}, {289,0.64201980}, {290,0.64893069}, {291,0.65217822}, {292,0.65547525}, {293,0.65907921}, {294,0.66498020}, {295,0.66928713}, {296,0.67644554}, {297,0.68222772}, {298,0.68288119}, {299,0.68774257}, {300,0.69375248}, {301,0.7285143}, {302,0.7444857}, {303,0.7998286}, {304,0.7703714}, {305,0.7478571}, {306,0.7718000}, {307,0.7606857}, {308,0.7677143}, {309,0.7786571}, {310,0.7759714}, {311,0.7801714}, {312,0.7887143}, {313,0.8018857}, {314,0.7969429}, {315,0.8049429}, {316,0.8084571}, {317,0.8105429}, {318,0.8164857}, {319,0.8276857}, {320,0.8249143}, {321,0.8491714}, {322,0.8612571}, {323,0.8325714}, {324,0.8404286}, {325,0.8495714}, {326,0.8489143}, {327,0.8616857}, {328,0.8659143}, {329,0.8678571}, {330,0.8750571}, {331,0.8817714}, {332,0.8822857}, {333,0.8827429}, {334,0.8850571}, {335,0.8975714}, {336,0.8990286}, {337,0.9072000}, {338,0.9269714}, {339,0.9180286}, {340,0.9399143}, {341,0.9352000}, {342,0.9378286}, {343,0.9470571}, {344,0.9513429}, {345,0.9581429}, {346,0.9543429}, {347,0.9631429}, {348,0.9679714}, {349,0.9734857}, {350,0.9782286}, {351,0.9944857}, {352,0.9888571}, {353,0.9911143}, {354,0.9981143}, {355,0.9955714}, {356,1.0117714}, {357,1.0127429}, {358,1.0140000}, {359,1.0133714}, {360,1.0293714}, {361,1.0237429}, {362,1.0398286}, {363,1.0454286}, {364,1.0475143}, {365,1.0584000}, {366,1.0509714}, {367,1.0638857}, {368,1.0654571}, {369,1.0739429}, {370,1.0800857}, {371,1.0862000}, {372,1.0966000}, {373,1.0990286}, {374,1.0990857}, {375,1.1129714}, {376,1.1204000}, {377,1.1201714}, {378,1.1263143}, {379,1.1255429}, {380,1.1328571}, {381,1.1437143}, {382,1.1552857}, {383,1.1604000}, {384,1.1703714}, {385,1.1798857}, {386,1.1833714}, {387,1.1895143}, {388,1.1965143}, {389,1.2022286}, {390,1.2116286}, {391,1.2134857}, {392,1.2169429}, {393,1.2318571}, {394,1.2404000}, {395,1.2479143}, {396,1.2446571}, {397,1.2451714}, {398,1.2534571}, {399,1.2632000}, {400,1.2763429}, {401,1.2747429}, {402,1.2835429}, {403,1.3014286}, {404,1.2963429}, {405,1.3119429}, {406,1.3226571}, {407,1.3170857}, {408,1.3351429}, {409,1.3405143}, {410,1.3343143}, {411,1.3428857}, {412,1.3400000}, {413,1.3492857}, {414,1.3547143}, {415,1.3714571}, {416,1.3834286}, {417,1.3890571}, {418,1.3970857}, {419,1.3873714}, {420,1.3992000}, {421,1.4080286}, {422,1.4127429}, {423,1.4233143}, {424,1.4295429}, {425,1.4440000}, {426,1.4571429}, {427,1.4866286}, {428,1.4818857}, {429,1.4791143}, {430,1.4749143}, {431,1.4989143}, {432,1.5151143}, {433,1.5172000}, {434,1.5138571}, {435,1.5188000}, {436,1.5320857}, {437,1.5353714}, {438,1.5503714}, {439,1.5675429}, {440,1.5750000}, {441,1.5681143}, {442,1.5879714}, {443,1.5919429}, {444,1.5825429}, {445,1.5936857}, {446,1.6042857}, {447,1.6110286}, {448,1.6147143}, {449,1.6231429}, {450,1.6283714}, {451,1.6306571}, {452,1.6464286}, {453,1.6540000}, {454,1.6519714}, {455,1.6710286}, {456,1.6734571}, {457,1.6824000}, {458,1.7025143}, {459,1.7035429}, {460,1.7064286}, {461,1.7149714}, {462,1.7182000}, {463,1.7276286}, {464,1.7312286}, {465,1.7432286}, {466,1.7521429}, {467,1.7575143}, {468,1.7717714}, {469,1.8015429}, {470,1.7875714}, {471,1.7890571}, {472,1.8016286}, {473,1.8223714}, {474,1.8812571}, {475,1.8103143}, {476,1.8216286}, {477,1.8546000}, {478,1.8634000}, {479,1.8649143}, {480,1.8469143}, {481,1.9229143}, {482,1.9629714}, {483,1.9086857}, {484,1.9639143}, {485,1.9460571}, {486,1.9800571}, {487,1.9482000}, {488,1.9458571}, {489,1.9514000}, {490,1.9519143}, {491,1.9440571}, {492,1.9639143}, {493,2.0306857}, {494,2.0434000}, {495,2.0042286}, {496,1.9930857}, {497,2.0479429}, {498,2.0449714}, {499,2.0459714}, {500,2.0953143}, {505,2.0997429}, {510,2.1151429}, {515,2.1418857}, {520,2.1909429}, {525,2.2895429}, {530,2.2946857}, {535,2.3131714}, {540,2.4534000}, {545,2.4962857}, {550,2.5411143}, {555,2.5568286}, {560,2.6606000}, {565,2.6581143}, {570,2.7029143}, {575,2.7312286}, {580,2.7843143}, {585,2.8450000}, {590,2.9748857}, {595,2.9818571}, {600,3.0717429}, {605,3.0904857}, {610,3.1848571}, {615,3.2393429}, {620,3.3024857}, {625,3.2924857}, {630,3.3654571}, {635,3.3851429}, {640,3.4208000}, {645,3.4801714}, {650,3.4614571}, {655,3.5438000}, {660,3.5807714}, {665,3.6376571}, {670,3.6487429}, {675,3.7460000}, {680,3.8596286}, {685,3.7944000}, {690,3.9120571}, {695,4.0023714}, {700,4.1191143}, {705,4.0930857}, {710,4.1061429}, {715,4.2108571}, {720,4.2894000}, {725,4.3408286}, {730,4.3915714}, {735,4.4989429}, {740,4.6497429}, {745,4.7014571}, {750,4.8438000}, {755,4.9718286}, {760,5.0334571}, {765,5.1156000}, {770,5.1722286}, {775,5.3140286}, {780,5.4633429}, {785,5.5398286}, {790,5.5020286}, {795,5.5941714}, {800,5.6392571}, {805,5.6781429}, {810,5.9878286}, {815,5.8969143}, {820,6.1818286}, {825,6.3800286}, {830,6.3822000}, {835,6.3946000}, {840,6.3815714}, {845,6.4133143}, {850,6.5238857}, {855,6.5665429}, {860,6.8373429}, {865,6.7347143}, {870,6.8417143}, {875,6.8900000}, {880,7.1021714}, {885,7.0228286}, {890,7.0760286}, {895,7.1626000}, {900,7.3707714}, {905,7.2943714}, {910,7.4382571}, {915,7.6089714}, {920,7.6330000}, {925,7.8354857}, {930,7.8987429}, {935,7.9352571}, {940,7.9351429}, {945,8.0952571}, {950,8.2396286}, {955,8.5201714}, {960,8.3496571}, {965,8.4294857}, {970,8.6598857}, {975,8.6381143}, {980,8.9059429}, {985,8.8287429}, {990,9.0144000}, {995,8.9998000}, {1000,9.0373143}, {1010,9.3349429}, {1020,9.4641429}, {1030,9.7064286}, {1040,10.1462857}, {1050,10.3000571}, {1060,10.5868857}, {1070,10.6664286}, {1080,10.8620286}, {1090,11.3766571}, {1100,11.5200000}, {1110,11.8060571}, {1120,11.8606571}, {1130,12.3168857}, {1140,12.4748286}, {1150,12.5358857}, {1160,12.9002286}, {1170,13.2072000}, {1180,13.4392857}, {1190,13.6743714}, {1200,14.1928571}, {1210,14.2485714}, {1220,14.8726000}, {1230,15.3039143}, {1240,15.7234857}, {1250,15.4947143}, {1260,15.8851429}, {1270,16.3636286}, {1280,16.5476000}, {1290,16.9732857}, {1300,17.1553143}, {1310,17.6250857}, {1320,17.8092857}, {1330,18.1148571}, {1340,18.3668286}, {1350,18.6580857}, {1360,19.3110857}, {1370,19.4680286}, {1380,19.8835429}, {1390,20.1044286}, {1400,20.6245143}, {1410,20.8289429}, {1420,21.4464571}, {1430,22.0963429}, {1440,22.1100000}, {1450,22.1031429}, {1460,23.3846000}, {1470,23.2605714}, {1480,23.4897714}, {1490,24.1957143}, {1500,24.4198857}, {1510,24.7786571}, {1520,25.5806857}, {1530,25.4350857}, {1540,26.3650857}, {1550,26.2326571}, {1560,27.2072857}, {1570,27.2249143}, {1580,28.1380571}, {1590,28.3836571}, {1600,29.0223714}, {1610,29.0947143}, {1620,29.7394000}, {1630,30.2719714}, {1640,30.4782857}, {1650,30.6750286}, {1660,31.4441143}, {1670,31.9602857}, {1680,32.4052857}, {1690,34.0585714}, {1700,33.7195143}, {1710,34.2740000}, {1720,34.8987429}, {1730,35.0313714}, {1740,35.5949714}, {1750,35.9874571}, {1760,36.7768286}, {1770,37.7387143}, {1780,37.1339714}, {1790,38.2608286}, {1800,38.9703429}, {1810,39.7192857}, {1820,39.8729429}, {1830,40.5547143}, {1840,41.2181429}, {1850,41.9952857}, {1860,43.0881143}, {1870,43.3314857}, {1880,44.0450000}, {1890,45.1663714}, {1900,45.0855429}, {1910,45.8001714}, {1920,46.6324571}, {1930,47.2196571}, {1940,46.9099429}, {1950,47.8184571}, {1960,48.9143714}, {1970,49.4570286}, {1980,49.7091714}, {1990,50.2649429}, {2000,51.5718000}};
data["big"]["LtacTCExplicitCtx"]["Aggregate"]["user"] = {{1,0.00126733}, {2,0.00192079}, {3,0.00179208}, {4,0.00219802}, {5,0.00266337}, {6,0.00294059}, {7,0.00363366}, {8,0.00395050}, {9,0.00422772}, {10,0.00459406}, {11,0.00513861}, {12,0.00559406}, {13,0.00620792}, {14,0.00623762}, {15,0.00681188}, {16,0.00723762}, {17,0.00798020}, {18,0.00842574}, {19,0.00902970}, {20,0.00910891}, {21,0.01013861}, {22,0.01034653}, {23,0.01103960}, {24,0.01153465}, {25,0.01231683}, {26,0.01285149}, {27,0.01334653}, {28,0.01386139}, {29,0.01737624}, {30,0.01543564}, {31,0.01577228}, {32,0.01625743}, {33,0.01700000}, {34,0.01796040}, {35,0.01882178}, {36,0.01935644}, {37,0.02011881}, {38,0.02072277}, {39,0.02189109}, {40,0.02322772}, {41,0.02368317}, {42,0.02483168}, {43,0.02851485}, {44,0.02659406}, {45,0.02709901}, {46,0.03311881}, {47,0.02857426}, {48,0.02981188}, {49,0.03012871}, {50,0.03117822}, {51,0.03204950}, {52,0.03296040}, {53,0.03406931}, {54,0.03964356}, {55,0.03556436}, {56,0.03691089}, {57,0.03753465}, {58,0.04737624}, {59,0.03957426}, {60,0.04069307}, {61,0.04191089}, {62,0.04239604}, {63,0.04357426}, {64,0.04522772}, {65,0.05095050}, {66,0.05330693}, {67,0.04846535}, {68,0.04995050}, {69,0.05070297}, {70,0.05469307}, {71,0.05331683}, {72,0.06012871}, {73,0.05527723}, {74,0.06518812}, {75,0.05713861}, {76,0.05867327}, {77,0.07544554}, {78,0.06097030}, {79,0.06240594}, {80,0.06323762}, {81,0.06544554}, {82,0.06721782}, {83,0.06891089}, {84,0.06825743}, {85,0.06947525}, {86,0.07181188}, {87,0.07301980}, {88,0.07443564}, {89,0.07523762}, {90,0.07710891}, {91,0.07856436}, {92,0.07942574}, {93,0.08053465}, {94,0.08251485}, {95,0.08384158}, {96,0.08500990}, {97,0.08688119}, {98,0.08854455}, {99,0.08920792}, {100,0.09098020}, {101,0.09261386}, {102,0.09452475}, {103,0.09626733}, {104,0.09795050}, {105,0.09941584}, {106,0.10027723}, {107,0.10215842}, {108,0.10373267}, {109,0.10515842}, {110,0.11407921}, {111,0.11524752}, {112,0.11724752}, {113,0.12016832}, {114,0.12201980}, {115,0.12425743}, {116,0.12603960}, {117,0.12869307}, {118,0.13153465}, {119,0.13209901}, {120,0.13625743}, {121,0.13777228}, {122,0.14094059}, {123,0.14495050}, {124,0.14800990}, {125,0.15098020}, {126,0.15330693}, {127,0.15472277}, {128,0.15548515}, {129,0.15798020}, {130,0.16136634}, {131,0.16232673}, {132,0.16332673}, {133,0.16710891}, {134,0.16990099}, {135,0.16935644}, {136,0.17303960}, {137,0.17489109}, {138,0.17764356}, {139,0.18081188}, {140,0.18000000}, {141,0.18529703}, {142,0.18639604}, {143,0.18852475}, {144,0.19201980}, {145,0.19390099}, {146,0.19708911}, {147,0.20027723}, {148,0.20077228}, {149,0.20386139}, {150,0.20605941}, {151,0.20717822}, {152,0.20944554}, {153,0.20976238}, {154,0.21258416}, {155,0.21484158}, {156,0.21954455}, {157,0.22170297}, {158,0.22376238}, {159,0.22370297}, {160,0.22908911}, {161,0.23011881}, {162,0.23126733}, {163,0.23251485}, {164,0.23694059}, {165,0.23647525}, {166,0.24104950}, {167,0.24349505}, {168,0.24257426}, {169,0.24656436}, {170,0.25191089}, {171,0.25363366}, {172,0.25610891}, {173,0.25918812}, {174,0.26137624}, {175,0.26555446}, {176,0.26405941}, {177,0.26618812}, {178,0.27027723}, {179,0.27368317}, {180,0.27787129}, {181,0.27908911}, {182,0.28408911}, {183,0.28551485}, {184,0.29043564}, {185,0.29265347}, {186,0.29399010}, {187,0.29593069}, {188,0.30010891}, {189,0.30240594}, {190,0.30525743}, {191,0.30602970}, {192,0.30854455}, {193,0.31052475}, {194,0.31401980}, {195,0.31296040}, {196,0.31465347}, {197,0.31912871}, {198,0.32877228}, {199,0.33407921}, {200,0.32962376}, {201,0.32985149}, {202,0.33751485}, {203,0.33685149}, {204,0.34531683}, {205,0.35305941}, {206,0.34254455}, {207,0.34960396}, {208,0.34959406}, {209,0.35472277}, {210,0.37021782}, {211,0.36041584}, {212,0.36278218}, {213,0.36474257}, {214,0.37838614}, {215,0.37376238}, {216,0.37316832}, {217,0.38723762}, {218,0.38659406}, {219,0.38433663}, {220,0.39435644}, {221,0.39531683}, {222,0.39737624}, {223,0.40599010}, {224,0.40439604}, {225,0.40632673}, {226,0.41477228}, {227,0.41207921}, {228,0.41773267}, {229,0.41704950}, {230,0.42690099}, {231,0.42547525}, {232,0.43103960}, {233,0.43372277}, {234,0.43502970}, {235,0.44131683}, {236,0.44447525}, {237,0.44455446}, {238,0.45441584}, {239,0.45099010}, {240,0.46452475}, {241,0.45834653}, {242,0.46697030}, {243,0.46977228}, {244,0.47198020}, {245,0.47895050}, {246,0.48127723}, {247,0.47965347}, {248,0.48759406}, {249,0.48668317}, {250,0.48829703}, {251,0.50359406}, {252,0.49775248}, {253,0.50112871}, {254,0.51133663}, {255,0.50889109}, {256,0.51090099}, {257,0.52537624}, {258,0.52931683}, {259,0.52873267}, {260,0.52531683}, {261,0.53225743}, {262,0.53558416}, {263,0.53939604}, {264,0.54887129}, {265,0.54818812}, {266,0.54762376}, {267,0.55063366}, {268,0.55718812}, {269,0.56144554}, {270,0.56550495}, {271,0.56864356}, {272,0.57435644}, {273,0.57981188}, {274,0.58402970}, {275,0.58778218}, {276,0.58738614}, {277,0.59072277}, {278,0.59379208}, {279,0.59955446}, {280,0.61218812}, {281,0.61615842}, {282,0.61860396}, {283,0.61766337}, {284,0.62342574}, {285,0.62518812}, {286,0.63284158}, {287,0.63218812}, {288,0.63857426}, {289,0.64074257}, {290,0.64756436}, {291,0.65121782}, {292,0.65407921}, {293,0.65776238}, {294,0.66364356}, {295,0.66802970}, {296,0.67481188}, {297,0.68090099}, {298,0.68159406}, {299,0.68643564}, {300,0.69217822}, {301,0.7270857}, {302,0.7377143}, {303,0.7987714}, {304,0.7692857}, {305,0.7474571}, {306,0.7707143}, {307,0.7600000}, {308,0.7663429}, {309,0.7770286}, {310,0.7754286}, {311,0.7794286}, {312,0.7878857}, {313,0.8010286}, {314,0.7962857}, {315,0.8041429}, {316,0.8080286}, {317,0.8097143}, {318,0.8144857}, {319,0.8266571}, {320,0.8234286}, {321,0.8478000}, {322,0.8602571}, {323,0.8308571}, {324,0.8397429}, {325,0.8453714}, {326,0.8481429}, {327,0.8607714}, {328,0.8647714}, {329,0.8654857}, {330,0.8729429}, {331,0.8751714}, {332,0.8810857}, {333,0.8811143}, {334,0.8842286}, {335,0.8936571}, {336,0.8975714}, {337,0.9057143}, {338,0.9256571}, {339,0.9168000}, {340,0.9386857}, {341,0.9337714}, {342,0.9364571}, {343,0.9456000}, {344,0.9499429}, {345,0.9569429}, {346,0.9528571}, {347,0.9620857}, {348,0.9658000}, {349,0.9726857}, {350,0.9770000}, {351,0.9933143}, {352,0.9879143}, {353,0.9896571}, {354,0.9973714}, {355,0.9936857}, {356,1.0106857}, {357,1.0116000}, {358,1.0133143}, {359,1.0128286}, {360,1.0278571}, {361,1.0228571}, {362,1.0386000}, {363,1.0440857}, {364,1.0460000}, {365,1.0564857}, {366,1.0494857}, {367,1.0618000}, {368,1.0640000}, {369,1.0728857}, {370,1.0782000}, {371,1.0846286}, {372,1.0956857}, {373,1.0970000}, {374,1.0972857}, {375,1.1110286}, {376,1.1184857}, {377,1.1178000}, {378,1.1247429}, {379,1.1232857}, {380,1.1311429}, {381,1.1422000}, {382,1.1534000}, {383,1.1590571}, {384,1.1676286}, {385,1.1769714}, {386,1.1813143}, {387,1.1872000}, {388,1.1944286}, {389,1.2001429}, {390,1.2097143}, {391,1.2110000}, {392,1.2152000}, {393,1.2300857}, {394,1.2385143}, {395,1.2457714}, {396,1.2429143}, {397,1.2433429}, {398,1.2515429}, {399,1.2610286}, {400,1.2742857}, {401,1.2728286}, {402,1.2820000}, {403,1.2947143}, {404,1.2946571}, {405,1.3096571}, {406,1.3102286}, {407,1.3137714}, {408,1.3247429}, {409,1.3382571}, {410,1.3317143}, {411,1.3405714}, {412,1.3377429}, {413,1.3463714}, {414,1.3526571}, {415,1.3688286}, {416,1.3809714}, {417,1.3868857}, {418,1.3940000}, {419,1.3854286}, {420,1.3976571}, {421,1.4055143}, {422,1.4102000}, {423,1.4218857}, {424,1.4272000}, {425,1.4410000}, {426,1.4542571}, {427,1.4829429}, {428,1.4791714}, {429,1.4758857}, {430,1.4719429}, {431,1.4958000}, {432,1.5119429}, {433,1.5144571}, {434,1.5109714}, {435,1.5157429}, {436,1.5282857}, {437,1.5329143}, {438,1.5465143}, {439,1.5644000}, {440,1.5713714}, {441,1.5639714}, {442,1.5842000}, {443,1.5888857}, {444,1.5790286}, {445,1.5894857}, {446,1.6007143}, {447,1.6075714}, {448,1.6109714}, {449,1.6200286}, {450,1.6254000}, {451,1.6272571}, {452,1.6440000}, {453,1.6511429}, {454,1.6484857}, {455,1.6678286}, {456,1.6708286}, {457,1.6793714}, {458,1.6994286}, {459,1.7008571}, {460,1.7036000}, {461,1.7122571}, {462,1.7154857}, {463,1.7253143}, {464,1.7288286}, {465,1.7405714}, {466,1.7493143}, {467,1.7551429}, {468,1.7692286}, {469,1.7989714}, {470,1.7839714}, {471,1.7844571}, {472,1.7964571}, {473,1.8188000}, {474,1.8770286}, {475,1.8060857}, {476,1.8183143}, {477,1.8510286}, {478,1.8591714}, {479,1.8618286}, {480,1.8430000}, {481,1.9169143}, {482,1.9562857}, {483,1.9030000}, {484,1.9586857}, {485,1.9415714}, {486,1.9750000}, {487,1.9433429}, {488,1.9395429}, {489,1.9461714}, {490,1.9466000}, {491,1.9390571}, {492,1.9590286}, {493,2.0257714}, {494,2.0380857}, {495,1.9980571}, {496,1.9873714}, {497,2.0432286}, {498,2.0393429}, {499,2.0418571}, {500,2.0905143}, {505,2.0945143}, {510,2.1098286}, {515,2.1358286}, {520,2.1840000}, {525,2.2826571}, {530,2.2886571}, {535,2.3068571}, {540,2.4460000}, {545,2.4874000}, {550,2.5332857}, {555,2.5474286}, {560,2.6526857}, {565,2.6492000}, {570,2.6955429}, {575,2.7236857}, {580,2.7757143}, {585,2.8367429}, {590,2.9678857}, {595,2.9739143}, {600,3.0650857}, {605,3.0831429}, {610,3.1787143}, {615,3.2324857}, {620,3.2950286}, {625,3.2854286}, {630,3.3571429}, {635,3.3776000}, {640,3.4136857}, {645,3.4735714}, {650,3.4572286}, {655,3.5384857}, {660,3.5769143}, {665,3.6320286}, {670,3.6438571}, {675,3.7405143}, {680,3.8550857}, {685,3.7877714}, {690,3.9055143}, {695,3.9965429}, {700,4.1116000}, {705,4.0884286}, {710,4.1019429}, {715,4.2046571}, {720,4.2820571}, {725,4.3328286}, {730,4.3835429}, {735,4.4932000}, {740,4.6427714}, {745,4.6956571}, {750,4.8383143}, {755,4.9644857}, {760,5.0263143}, {765,5.1084857}, {770,5.1644286}, {775,5.3064857}, {780,5.4557143}, {785,5.5328571}, {790,5.4892571}, {795,5.5886857}, {800,5.6246571}, {805,5.6607429}, {810,5.9649143}, {815,5.8850857}, {820,6.1715143}, {825,6.3711429}, {830,6.3719143}, {835,6.3796857}, {840,6.3730286}, {845,6.4041714}, {850,6.5156571}, {855,6.5571714}, {860,6.8284000}, {865,6.7255143}, {870,6.8338857}, {875,6.8835714}, {880,7.0980857}, {885,7.0203429}, {890,7.0738286}, {895,7.1557714}, {900,7.3642857}, {905,7.2848857}, {910,7.4234857}, {915,7.5958286}, {920,7.6202857}, {925,7.8230571}, {930,7.8851429}, {935,7.9213429}, {940,7.9201714}, {945,8.0830571}, {950,8.2300000}, {955,8.5131143}, {960,8.3404857}, {965,8.4142000}, {970,8.6460286}, {975,8.6222000}, {980,8.8882286}, {985,8.8101429}, {990,8.9914000}, {995,8.9732857}, {1000,9.0163429}, {1010,9.3018857}, {1020,9.4409714}, {1030,9.6759714}, {1040,10.1227429}, {1050,10.2783143}, {1060,10.5617429}, {1070,10.6508857}, {1080,10.8187143}, {1090,11.3596857}, {1100,11.5022000}, {1110,11.7833714}, {1120,11.8322571}, {1130,12.2970286}, {1140,12.4330857}, {1150,12.5141714}, {1160,12.8771714}, {1170,13.1866857}, {1180,13.4128000}, {1190,13.6541714}, {1200,14.1664000}, {1210,14.2257714}, {1220,14.8463429}, {1230,15.2768857}, {1240,15.6888000}, {1250,15.4560857}, {1260,15.8452000}, {1270,16.3240286}, {1280,16.5162571}, {1290,16.9368857}, {1300,17.1223143}, {1310,17.5940857}, {1320,17.7705429}, {1330,18.0833714}, {1340,18.3344571}, {1350,18.6225143}, {1360,19.2753143}, {1370,19.4339714}, {1380,19.8383143}, {1390,20.0589714}, {1400,20.5935429}, {1410,20.7918571}, {1420,21.4074286}, {1430,22.0514571}, {1440,22.0743714}, {1450,22.0535714}, {1460,23.3351143}, {1470,23.2099143}, {1480,23.4485714}, {1490,24.1567429}, {1500,24.3683714}, {1510,24.7281143}, {1520,25.5225143}, {1530,25.3798571}, {1540,26.3208000}, {1550,26.1841714}, {1560,27.1490000}, {1570,27.1777714}, {1580,28.0828571}, {1590,28.3142000}, {1600,28.9658571}, {1610,29.0379714}, {1620,29.6828857}, {1630,30.2112000}, {1640,30.4172857}, {1650,30.6090571}, {1660,31.3752857}, {1670,31.8988571}, {1680,32.3367143}, {1690,33.9883714}, {1700,33.6467429}, {1710,34.2166000}, {1720,34.8321143}, {1730,34.9557714}, {1740,35.5116000}, {1750,35.9068000}, {1760,36.7037143}, {1770,37.6522571}, {1780,37.0494000}, {1790,38.1851714}, {1800,38.9001714}, {1810,39.6548000}, {1820,39.7972571}, {1830,40.4843143}, {1840,41.1279714}, {1850,41.9084571}, {1860,42.9989429}, {1870,43.2206571}, {1880,43.9565714}, {1890,45.0798286}, {1900,45.0058857}, {1910,45.7343714}, {1920,46.5646000}, {1930,47.1540286}, {1940,46.8183429}, {1950,47.7489429}, {1960,48.5952000}, {1970,49.3967143}, {1980,49.6491429}, {1990,50.1985429}, {2000,51.5152286}};
data["big"]["LtacTCExplicitCtx"]["Aggregate"]["system"] = {{1,0.00002970}, {2,0.00000000}, {3,0.00002970}, {4,0.00000000}, {5,0.00003960}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00007921}, {10,0.00003960}, {11,0.00000000}, {12,0.00003960}, {13,0.00000000}, {14,0.00003960}, {15,0.00010891}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00003960}, {20,0.00006931}, {21,0.00007921}, {22,0.00003960}, {23,0.00003960}, {24,0.00011881}, {25,0.00007921}, {26,0.00015842}, {27,0.00003960}, {28,0.00003960}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00015842}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00007921}, {37,0.00000000}, {38,0.00003960}, {39,0.00003960}, {40,0.00000000}, {41,0.00003960}, {42,0.00003960}, {43,0.00003960}, {44,0.00003960}, {45,0.00003960}, {46,0.00011881}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00006931}, {51,0.00003960}, {52,0.00007921}, {53,0.00010891}, {54,0.00007921}, {55,0.00015842}, {56,0.00000000}, {57,0.00007921}, {58,0.00007921}, {59,0.00003960}, {60,0.00003960}, {61,0.00000000}, {62,0.00011881}, {63,0.00007921}, {64,0.00010891}, {65,0.00000000}, {66,0.00003960}, {67,0.00003960}, {68,0.00003960}, {69,0.00007921}, {70,0.00000000}, {71,0.00003960}, {72,0.00000000}, {73,0.00011881}, {74,0.00007921}, {75,0.00000000}, {76,0.00003960}, {77,0.00011881}, {78,0.00000000}, {79,0.00003960}, {80,0.00007921}, {81,0.00003960}, {82,0.00011881}, {83,0.00007921}, {84,0.00003960}, {85,0.00007921}, {86,0.00007921}, {87,0.00003960}, {88,0.00000000}, {89,0.00000000}, {90,0.00007921}, {91,0.00003960}, {92,0.00003960}, {93,0.00007921}, {94,0.00011881}, {95,0.00007921}, {96,0.00007921}, {97,0.00011881}, {98,0.00007921}, {99,0.00027723}, {100,0.00007921}, {101,0.00007921}, {102,0.00000000}, {103,0.00000000}, {104,0.00007921}, {105,0.00003960}, {106,0.00011881}, {107,0.00000000}, {108,0.00007921}, {109,0.00007921}, {110,0.00007921}, {111,0.00000000}, {112,0.00007921}, {113,0.00003960}, {114,0.00003960}, {115,0.00003960}, {116,0.00006931}, {117,0.00003960}, {118,0.00000000}, {119,0.00000000}, {120,0.00003960}, {121,0.00003960}, {122,0.00000000}, {123,0.00006931}, {124,0.00000000}, {125,0.00003960}, {126,0.00015842}, {127,0.00002970}, {128,0.00011881}, {129,0.00006931}, {130,0.00000000}, {131,0.00007921}, {132,0.00011881}, {133,0.00007921}, {134,0.00000000}, {135,0.00015842}, {136,0.00000000}, {137,0.00007921}, {138,0.00007921}, {139,0.00003960}, {140,0.00003960}, {141,0.00003960}, {142,0.00003960}, {143,0.00007921}, {144,0.00015842}, {145,0.00003960}, {146,0.00007921}, {147,0.00007921}, {148,0.00003960}, {149,0.00002970}, {150,0.00003960}, {151,0.00011881}, {152,0.00003960}, {153,0.00003960}, {154,0.00003960}, {155,0.00003960}, {156,0.00011881}, {157,0.00003960}, {158,0.00010891}, {159,0.00011881}, {160,0.00011881}, {161,0.00007921}, {162,0.00003960}, {163,0.00003960}, {164,0.00011881}, {165,0.00007921}, {166,0.00003960}, {167,0.00000000}, {168,0.00003960}, {169,0.00000000}, {170,0.00003960}, {171,0.00003960}, {172,0.00007921}, {173,0.00003960}, {174,0.00011881}, {175,0.00003960}, {176,0.00003960}, {177,0.00015842}, {178,0.00003960}, {179,0.00015842}, {180,0.00000000}, {181,0.00011881}, {182,0.00003960}, {183,0.00007921}, {184,0.00007921}, {185,0.00011881}, {186,0.00007921}, {187,0.00007921}, {188,0.00000000}, {189,0.00000000}, {190,0.00003960}, {191,0.00000000}, {192,0.00007921}, {193,0.00003960}, {194,0.00011881}, {195,0.00003960}, {196,0.00003960}, {197,0.00003960}, {198,0.00000000}, {199,0.00003960}, {200,0.00003960}, {201,0.00003960}, {202,0.00007921}, {203,0.00007921}, {204,0.00007921}, {205,0.00011881}, {206,0.00007921}, {207,0.00011881}, {208,0.00003960}, {209,0.00003960}, {210,0.00007921}, {211,0.00003960}, {212,0.00003960}, {213,0.00011881}, {214,0.00007921}, {215,0.00027723}, {216,0.00000000}, {217,0.00007921}, {218,0.00000000}, {219,0.00011881}, {220,0.00007921}, {221,0.00003960}, {222,0.00015842}, {223,0.00007921}, {224,0.00007921}, {225,0.00011881}, {226,0.00003960}, {227,0.00011881}, {228,0.00007921}, {229,0.00000000}, {230,0.00011881}, {231,0.00031683}, {232,0.00011881}, {233,0.00015842}, {234,0.00019802}, {235,0.00011881}, {236,0.00000000}, {237,0.00000000}, {238,0.00007921}, {239,0.00003960}, {240,0.00019802}, {241,0.00007921}, {242,0.00015842}, {243,0.00015842}, {244,0.00011881}, {245,0.00003960}, {246,0.00011881}, {247,0.00014851}, {248,0.00018812}, {249,0.00011881}, {250,0.00023762}, {251,0.00003960}, {252,0.00003960}, {253,0.00023762}, {254,0.00007921}, {255,0.00019802}, {256,0.00003960}, {257,0.00011881}, {258,0.00014851}, {259,0.00030693}, {260,0.00007921}, {261,0.00010891}, {262,0.00023762}, {263,0.00007921}, {264,0.00007921}, {265,0.00007921}, {266,0.00023762}, {267,0.00000000}, {268,0.00007921}, {269,0.00003960}, {270,0.00015842}, {271,0.00003960}, {272,0.00003960}, {273,0.00019802}, {274,0.00003960}, {275,0.00007921}, {276,0.00003960}, {277,0.00014851}, {278,0.00007921}, {279,0.00007921}, {280,0.00023762}, {281,0.00003960}, {282,0.00011881}, {283,0.00000000}, {284,0.00050495}, {285,0.00011881}, {286,0.00003960}, {287,0.00003960}, {288,0.00002970}, {289,0.00019802}, {290,0.00007921}, {291,0.00010891}, {292,0.00015842}, {293,0.00015842}, {294,0.00015842}, {295,0.00003960}, {296,0.00023762}, {297,0.00007921}, {298,0.00003960}, {299,0.00003960}, {300,0.00023762}, {301,0.0005429}, {302,0.0004571}, {303,0.0001143}, {304,0.0004571}, {305,0.0002286}, {306,0.0003429}, {307,0.0001143}, {308,0.0001143}, {309,0.0003429}, {310,0.0000000}, {311,0.0002286}, {312,0.0000000}, {313,0.0001143}, {314,0.0001143}, {315,0.0001143}, {316,0.0002286}, {317,0.0003429}, {318,0.0005714}, {319,0.0002286}, {320,0.0001143}, {321,0.0000000}, {322,0.0000000}, {323,0.0005429}, {324,0.0001143}, {325,0.0001143}, {326,0.0002286}, {327,0.0002286}, {328,0.0002286}, {329,0.0003429}, {330,0.0003429}, {331,0.0001143}, {332,0.0002286}, {333,0.0000000}, {334,0.0001143}, {335,0.0003143}, {336,0.0006857}, {337,0.0003429}, {338,0.0003143}, {339,0.0001143}, {340,0.0002286}, {341,0.0003429}, {342,0.0000000}, {343,0.0000000}, {344,0.0005714}, {345,0.0002286}, {346,0.0001143}, {347,0.0002286}, {348,0.0002286}, {349,0.0000000}, {350,0.0001143}, {351,0.0000000}, {352,0.0001143}, {353,0.0000000}, {354,0.0000000}, {355,0.0001143}, {356,0.0001143}, {357,0.0000000}, {358,0.0001143}, {359,0.0000000}, {360,0.0000000}, {361,0.0001143}, {362,0.0002286}, {363,0.0002286}, {364,0.0004571}, {365,0.0004571}, {366,0.0001143}, {367,0.0001143}, {368,0.0001143}, {369,0.0000000}, {370,0.0003429}, {371,0.0001143}, {372,0.0000000}, {373,0.0003429}, {374,0.0003429}, {375,0.0003429}, {376,0.0002286}, {377,0.0001143}, {378,0.0000000}, {379,0.0003429}, {380,0.0001143}, {381,0.0002286}, {382,0.0000000}, {383,0.0000857}, {384,0.0004571}, {385,0.0005714}, {386,0.0004571}, {387,0.0004571}, {388,0.0001143}, {389,0.0001143}, {390,0.0001143}, {391,0.0002286}, {392,0.0001143}, {393,0.0003429}, {394,0.0001143}, {395,0.0003429}, {396,0.0003143}, {397,0.0001143}, {398,0.0003429}, {399,0.0002286}, {400,0.0002000}, {401,0.0004571}, {402,0.0002286}, {403,0.0002286}, {404,0.0001143}, {405,0.0000000}, {406,0.0000000}, {407,0.0003429}, {408,0.0005714}, {409,0.0003429}, {410,0.0002286}, {411,0.0001143}, {412,0.0002286}, {413,0.0003429}, {414,0.0001143}, {415,0.0004571}, {416,0.0001143}, {417,0.0002286}, {418,0.0003429}, {419,0.0001143}, {420,0.0001143}, {421,0.0002286}, {422,0.0008000}, {423,0.0002286}, {424,0.0001143}, {425,0.0001143}, {426,0.0003429}, {427,0.0003429}, {428,0.0000000}, {429,0.0006857}, {430,0.0001143}, {431,0.0001143}, {432,0.0004571}, {433,0.0002286}, {434,0.0001143}, {435,0.0001143}, {436,0.0003429}, {437,0.0002286}, {438,0.0004571}, {439,0.0002000}, {440,0.0003429}, {441,0.0004571}, {442,0.0002286}, {443,0.0002000}, {444,0.0002000}, {445,0.0002286}, {446,0.0003429}, {447,0.0006857}, {448,0.0001143}, {449,0.0003429}, {450,0.0003429}, {451,0.0004571}, {452,0.0000000}, {453,0.0001143}, {454,0.0007714}, {455,0.0003429}, {456,0.0001143}, {457,0.0002286}, {458,0.0002286}, {459,0.0001143}, {460,0.0002286}, {461,0.0003429}, {462,0.0002286}, {463,0.0002286}, {464,0.0002286}, {465,0.0002000}, {466,0.0004571}, {467,0.0004571}, {468,0.0005714}, {469,0.0005714}, {470,0.0006857}, {471,0.0012286}, {472,0.0012571}, {473,0.0004571}, {474,0.0004571}, {475,0.0012571}, {476,0.0003429}, {477,0.0003429}, {478,0.0006857}, {479,0.0000000}, {480,0.0004571}, {481,0.0014857}, {482,0.0016000}, {483,0.0012571}, {484,0.0005714}, {485,0.0004571}, {486,0.0003429}, {487,0.0007714}, {488,0.0012571}, {489,0.0010286}, {490,0.0009143}, {491,0.0004571}, {492,0.0003429}, {493,0.0004571}, {494,0.0013714}, {495,0.0017143}, {496,0.0011429}, {497,0.0010286}, {498,0.0009143}, {499,0.0002286}, {500,0.0008000}, {505,0.0008000}, {510,0.0011143}, {515,0.0008857}, {520,0.0006857}, {525,0.0011143}, {530,0.0016000}, {535,0.0008000}, {540,0.0008000}, {545,0.0017143}, {550,0.0010286}, {555,0.0012571}, {560,0.0006857}, {565,0.0018286}, {570,0.0014857}, {575,0.0010286}, {580,0.0011429}, {585,0.0012571}, {590,0.0008000}, {595,0.0011429}, {600,0.0004571}, {605,0.0016000}, {610,0.0006857}, {615,0.0008857}, {620,0.0011429}, {625,0.0004571}, {630,0.0014857}, {635,0.0012571}, {640,0.0009143}, {645,0.0012571}, {650,0.0004571}, {655,0.0019429}, {660,0.0014857}, {665,0.0010286}, {670,0.0006857}, {675,0.0008857}, {680,0.0001143}, {685,0.0014857}, {690,0.0013714}, {695,0.0008000}, {700,0.0008857}, {705,0.0008000}, {710,0.0006857}, {715,0.0004571}, {720,0.0014857}, {725,0.0006857}, {730,0.0005714}, {735,0.0004571}, {740,0.0016000}, {745,0.0012571}, {750,0.0010286}, {755,0.0027429}, {760,0.0014571}, {765,0.0021714}, {770,0.0008000}, {775,0.0008000}, {780,0.0004571}, {785,0.0008000}, {790,0.0006571}, {795,0.0011429}, {800,0.0006857}, {805,0.0006857}, {810,0.0013429}, {815,0.0016000}, {820,0.0013429}, {825,0.0005714}, {830,0.0008857}, {835,0.0007429}, {840,0.0008000}, {845,0.0010000}, {850,0.0008000}, {855,0.0019143}, {860,0.0005714}, {865,0.0021714}, {870,0.0024857}, {875,0.0020286}, {880,0.0022857}, {885,0.0008000}, {890,0.0008857}, {895,0.0024000}, {900,0.0022571}, {905,0.0038286}, {910,0.0048571}, {915,0.0021143}, {920,0.0029429}, {925,0.0038857}, {930,0.0040000}, {935,0.0042857}, {940,0.0044286}, {945,0.0042857}, {950,0.0048000}, {955,0.0018571}, {960,0.0022286}, {965,0.0042000}, {970,0.0021429}, {975,0.0035714}, {980,0.0037143}, {985,0.0037429}, {990,0.0048857}, {995,0.0076000}, {1000,0.0022571}, {1010,0.0040857}, {1020,0.0044286}, {1030,0.0077714}, {1040,0.0078857}, {1050,0.0051143}, {1060,0.0098857}, {1070,0.0046000}, {1080,0.0050571}, {1090,0.0064286}, {1100,0.0073429}, {1110,0.0054000}, {1120,0.0094286}, {1130,0.0067429}, {1140,0.0100000}, {1150,0.0089143}, {1160,0.0087429}, {1170,0.0108000}, {1180,0.0086286}, {1190,0.0069714}, {1200,0.0108286}, {1210,0.0076857}, {1220,0.0096857}, {1230,0.0054286}, {1240,0.0098857}, {1250,0.0108286}, {1260,0.0153143}, {1270,0.0153714}, {1280,0.0091714}, {1290,0.0119429}, {1300,0.0126286}, {1310,0.0117714}, {1320,0.0189429}, {1330,0.0154571}, {1340,0.0123429}, {1350,0.0148857}, {1360,0.0130286}, {1370,0.0132000}, {1380,0.0213429}, {1390,0.0201714}, {1400,0.0140286}, {1410,0.0166000}, {1420,0.0179143}, {1430,0.0137429}, {1440,0.0173714}, {1450,0.0218286}, {1460,0.0181429}, {1470,0.0167143}, {1480,0.0189143}, {1490,0.0195143}, {1500,0.0214571}, {1510,0.0205714}, {1520,0.0190571}, {1530,0.0252857}, {1540,0.0223714}, {1550,0.0187714}, {1560,0.0255714}, {1570,0.0222857}, {1580,0.0253143}, {1590,0.0255714}, {1600,0.0246000}, {1610,0.0259714}, {1620,0.0303429}, {1630,0.0267714}, {1640,0.0314571}, {1650,0.0318571}, {1660,0.0262571}, {1670,0.0291143}, {1680,0.0318571}, {1690,0.0293143}, {1700,0.0308857}, {1710,0.0294000}, {1720,0.0325714}, {1730,0.0307714}, {1740,0.0390571}, {1750,0.0391429}, {1760,0.0349714}, {1770,0.0333429}, {1780,0.0378000}, {1790,0.0393429}, {1800,0.0432857}, {1810,0.0461714}, {1820,0.0415429}, {1830,0.0364000}, {1840,0.0383143}, {1850,0.0403714}, {1860,0.0381143}, {1870,0.0458857}, {1880,0.0392286}, {1890,0.0446571}, {1900,0.0427143}, {1910,0.0480000}, {1920,0.0442857}, {1930,0.0391714}, {1940,0.0434571}, {1950,0.0495429}, {1960,0.0416857}, {1970,0.0458857}, {1980,0.0470000}, {1990,0.0425429}, {2000,0.0371143}};
data["big"]["LtacTCExplicitCtx"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00100000}, {4,0.00100000}, {5,0.00110891}, {6,0.00200000}, {7,0.00200000}, {8,0.00243564}, {9,0.00300000}, {10,0.00308911}, {11,0.00400000}, {12,0.00403960}, {13,0.00449505}, {14,0.00501980}, {15,0.00561386}, {16,0.00600990}, {17,0.00665347}, {18,0.00700990}, {19,0.00749505}, {20,0.00804950}, {21,0.00873267}, {22,0.00912871}, {23,0.00991089}, {24,0.01047525}, {25,0.01096040}, {26,0.01149505}, {27,0.01215842}, {28,0.01288119}, {29,0.01622772}, {30,0.01410891}, {31,0.01475248}, {32,0.01548515}, {33,0.01610891}, {34,0.01686139}, {35,0.01756436}, {36,0.01827723}, {37,0.01900990}, {38,0.01979208}, {39,0.02054455}, {40,0.02138614}, {41,0.02201980}, {42,0.02286139}, {43,0.02686139}, {44,0.02455446}, {45,0.02530693}, {46,0.03180198}, {47,0.02708911}, {48,0.02788119}, {49,0.02859406}, {50,0.02958416}, {51,0.03041584}, {52,0.03149505}, {53,0.03232673}, {54,0.03814851}, {55,0.03430693}, {56,0.03529703}, {57,0.03620792}, {58,0.04570297}, {59,0.03822772}, {60,0.03916832}, {61,0.04022772}, {62,0.04125743}, {63,0.04222772}, {64,0.04332673}, {65,0.04893069}, {66,0.05097030}, {67,0.04627723}, {68,0.04758416}, {69,0.04863366}, {70,0.05268317}, {71,0.05114851}, {72,0.05830693}, {73,0.05328713}, {74,0.06352475}, {75,0.05528713}, {76,0.05656436}, {77,0.07369307}, {78,0.05914851}, {79,0.06060396}, {80,0.06162376}, {81,0.06300000}, {82,0.06558416}, {83,0.06691089}, {84,0.06635644}, {85,0.06754455}, {86,0.06938614}, {87,0.07075248}, {88,0.07181188}, {89,0.07317822}, {90,0.07502970}, {91,0.07624752}, {92,0.07745545}, {93,0.07864356}, {94,0.08065347}, {95,0.08205941}, {96,0.08318812}, {97,0.08510891}, {98,0.08670297}, {99,0.08767327}, {100,0.08939604}, {101,0.09061386}, {102,0.09214851}, {103,0.09406931}, {104,0.09554455}, {105,0.09707921}, {106,0.09840594}, {107,0.09963366}, {108,0.10140594}, {109,0.10309901}, {110,0.10482178}, {111,0.11342574}, {112,0.11554455}, {113,0.11755446}, {114,0.11962376}, {115,0.12205941}, {116,0.12402970}, {117,0.12665347}, {118,0.12965347}, {119,0.13022772}, {120,0.13403960}, {121,0.13593069}, {122,0.13865347}, {123,0.14258416}, {124,0.14564356}, {125,0.14882178}, {126,0.15112871}, {127,0.15212871}, {128,0.15335644}, {129,0.15592079}, {130,0.15906931}, {131,0.16010891}, {132,0.16108911}, {133,0.16484158}, {134,0.16775248}, {135,0.16724752}, {136,0.17089109}, {137,0.17268317}, {138,0.17528713}, {139,0.17831683}, {140,0.17770297}, {141,0.18299010}, {142,0.18420792}, {143,0.18623762}, {144,0.18994059}, {145,0.19154455}, {146,0.19492079}, {147,0.19785149}, {148,0.19864356}, {149,0.20133663}, {150,0.20362376}, {151,0.20480198}, {152,0.20712871}, {153,0.20758416}, {154,0.20989109}, {155,0.21249505}, {156,0.21729703}, {157,0.21923762}, {158,0.22149505}, {159,0.22194059}, {160,0.22650495}, {161,0.22744554}, {162,0.22888119}, {163,0.23007921}, {164,0.23426733}, {165,0.23428713}, {166,0.23870297}, {167,0.24123762}, {168,0.24026733}, {169,0.24419802}, {170,0.24946535}, {171,0.25137624}, {172,0.25339604}, {173,0.25692079}, {174,0.25878218}, {175,0.26288119}, {176,0.26161386}, {177,0.26404950}, {178,0.26789109}, {179,0.27114851}, {180,0.27511881}, {181,0.27650495}, {182,0.28144554}, {183,0.28297030}, {184,0.28786139}, {185,0.29002970}, {186,0.29141584}, {187,0.29361386}, {188,0.29727723}, {189,0.29967327}, {190,0.30270297}, {191,0.30343564}, {192,0.30576238}, {193,0.30771287}, {194,0.31148515}, {195,0.31038614}, {196,0.31188119}, {197,0.31653465}, {198,0.32622772}, {199,0.33145545}, {200,0.32673267}, {201,0.32714851}, {202,0.33472277}, {203,0.33414851}, {204,0.34265347}, {205,0.35037624}, {206,0.34010891}, {207,0.34694059}, {208,0.34673267}, {209,0.35181188}, {210,0.36726733}, {211,0.35754455}, {212,0.36007921}, {213,0.36235644}, {214,0.37542574}, {215,0.37102970}, {216,0.37013861}, {217,0.38425743}, {218,0.38378218}, {219,0.38147525}, {220,0.39108911}, {221,0.39236634}, {222,0.39487129}, {223,0.40324752}, {224,0.40127723}, {225,0.40310891}, {226,0.41174257}, {227,0.40945545}, {228,0.41453465}, {229,0.41430693}, {230,0.42430693}, {231,0.42262376}, {232,0.42814851}, {233,0.43066337}, {234,0.43218812}, {235,0.43865347}, {236,0.44119802}, {237,0.44181188}, {238,0.45169307}, {239,0.44799010}, {240,0.46166337}, {241,0.45546535}, {242,0.46409901}, {243,0.46685149}, {244,0.46937624}, {245,0.47597030}, {246,0.47849505}, {247,0.47666337}, {248,0.48461386}, {249,0.48392079}, {250,0.48572277}, {251,0.50054455}, {252,0.49456436}, {253,0.49804950}, {254,0.50836634}, {255,0.50634653}, {256,0.50764356}, {257,0.52235644}, {258,0.52632673}, {259,0.52594059}, {260,0.52223762}, {261,0.52906931}, {262,0.53260396}, {263,0.53633663}, {264,0.54571287}, {265,0.54483168}, {266,0.54453465}, {267,0.54770297}, {268,0.55389109}, {269,0.55799010}, {270,0.56218812}, {271,0.56553465}, {272,0.57097030}, {273,0.57677228}, {274,0.58048515}, {275,0.58454455}, {276,0.58395050}, {277,0.58740594}, {278,0.59036634}, {279,0.59630693}, {280,0.60438614}, {281,0.60908911}, {282,0.61132673}, {283,0.61430693}, {284,0.62057426}, {285,0.62213861}, {286,0.62942574}, {287,0.62914851}, {288,0.63505941}, {289,0.63754455}, {290,0.64435644}, {291,0.64766337}, {292,0.65085149}, {293,0.65446535}, {294,0.66041584}, {295,0.66464356}, {296,0.67184158}, {297,0.67751485}, {298,0.67830693}, {299,0.68318812}, {300,0.68911881}, {301,0.7238286}, {302,0.7396857}, {303,0.7950286}, {304,0.7655429}, {305,0.7430571}, {306,0.7669714}, {307,0.7559143}, {308,0.7627714}, {309,0.7740000}, {310,0.7712000}, {311,0.7752286}, {312,0.7839143}, {313,0.7970286}, {314,0.7920571}, {315,0.8000857}, {316,0.8036286}, {317,0.8055714}, {318,0.8113714}, {319,0.8228000}, {320,0.8199714}, {321,0.8442571}, {322,0.8562286}, {323,0.8276857}, {324,0.8355143}, {325,0.8445143}, {326,0.8439143}, {327,0.8538857}, {328,0.8580857}, {329,0.8600286}, {330,0.8673143}, {331,0.8742000}, {332,0.8745143}, {333,0.8752000}, {334,0.8800286}, {335,0.8925429}, {336,0.8940857}, {337,0.9021143}, {338,0.9218000}, {339,0.9127429}, {340,0.9347429}, {341,0.9301714}, {342,0.9328000}, {343,0.9418286}, {344,0.9461714}, {345,0.9529714}, {346,0.9490857}, {347,0.9579714}, {348,0.9626571}, {349,0.9682571}, {350,0.9729429}, {351,0.9892286}, {352,0.9834857}, {353,0.9858286}, {354,0.9929143}, {355,0.9901714}, {356,1.0064857}, {357,1.0075143}, {358,1.0087143}, {359,1.0080000}, {360,1.0239429}, {361,1.0185429}, {362,1.0343429}, {363,1.0400571}, {364,1.0420571}, {365,1.0529143}, {366,1.0456571}, {367,1.0583714}, {368,1.0599714}, {369,1.0684000}, {370,1.0744000}, {371,1.0805714}, {372,1.0908857}, {373,1.0933143}, {374,1.0931429}, {375,1.1073143}, {376,1.1146857}, {377,1.1144571}, {378,1.1207143}, {379,1.1199714}, {380,1.1271429}, {381,1.1381429}, {382,1.1495429}, {383,1.1548286}, {384,1.1647429}, {385,1.1742000}, {386,1.1776571}, {387,1.1838571}, {388,1.1908286}, {389,1.1963143}, {390,1.2058000}, {391,1.2078857}, {392,1.2112857}, {393,1.2261714}, {394,1.2346571}, {395,1.2421714}, {396,1.2388857}, {397,1.2391714}, {398,1.2476000}, {399,1.2573429}, {400,1.2705714}, {401,1.2688857}, {402,1.2777143}, {403,1.2956000}, {404,1.2905143}, {405,1.3062000}, {406,1.3168286}, {407,1.3107429}, {408,1.3292286}, {409,1.3345714}, {410,1.3283143}, {411,1.3369429}, {412,1.3340286}, {413,1.3432857}, {414,1.3487143}, {415,1.3652571}, {416,1.3753714}, {417,1.3815143}, {418,1.3896857}, {419,1.3812000}, {420,1.3929429}, {421,1.4017429}, {422,1.4065429}, {423,1.4169143}, {424,1.4231143}, {425,1.4373429}, {426,1.4504857}, {427,1.4798571}, {428,1.4754286}, {429,1.4722571}, {430,1.4681429}, {431,1.4923429}, {432,1.5084857}, {433,1.5108000}, {434,1.5075143}, {435,1.5121714}, {436,1.5255429}, {437,1.5288286}, {438,1.5439429}, {439,1.5609714}, {440,1.5686000}, {441,1.5616000}, {442,1.5814286}, {443,1.5853143}, {444,1.5760857}, {445,1.5872000}, {446,1.5977143}, {447,1.6045714}, {448,1.6082000}, {449,1.6166857}, {450,1.6218857}, {451,1.6241429}, {452,1.6398857}, {453,1.6475714}, {454,1.6455714}, {455,1.6645429}, {456,1.6670286}, {457,1.6759429}, {458,1.6960571}, {459,1.6969143}, {460,1.6998857}, {461,1.7084286}, {462,1.7117143}, {463,1.7211143}, {464,1.7247429}, {465,1.7366286}, {466,1.7454571}, {467,1.7508286}, {468,1.7652286}, {469,1.7948000}, {470,1.7808857}, {471,1.7822857}, {472,1.7949429}, {473,1.8156286}, {474,1.8746000}, {475,1.8036286}, {476,1.8150000}, {477,1.8478000}, {478,1.8568000}, {479,1.8581429}, {480,1.8402286}, {481,1.9160000}, {482,1.9560857}, {483,1.9017143}, {484,1.9571429}, {485,1.9391714}, {486,1.9731143}, {487,1.9395714}, {488,1.9372000}, {489,1.9430286}, {490,1.9437429}, {491,1.9357429}, {492,1.9547143}, {493,2.0236857}, {494,2.0364000}, {495,1.9972571}, {496,1.9860571}, {497,2.0409143}, {498,2.0378571}, {499,2.0389714}, {500,2.0882286}, {505,2.0926000}, {510,2.1080000}, {515,2.1347143}, {520,2.1814571}, {525,2.2822571}, {530,2.2875429}, {535,2.3059429}, {540,2.4458286}, {545,2.4889143}, {550,2.5335143}, {555,2.5492000}, {560,2.6528857}, {565,2.6502571}, {570,2.6951714}, {575,2.7234286}, {580,2.7764000}, {585,2.8370857}, {590,2.9668571}, {595,2.9738000}, {600,3.0634571}, {605,3.0822857}, {610,3.1740571}, {615,3.2286000}, {620,3.2938857}, {625,3.2839429}, {630,3.3569429}, {635,3.3767143}, {640,3.4122286}, {645,3.4716571}, {650,3.4525714}, {655,3.5351429}, {660,3.5717714}, {665,3.6288571}, {670,3.6396857}, {675,3.7370000}, {680,3.8505143}, {685,3.7840286}, {690,3.9027143}, {695,3.9932286}, {700,4.1097143}, {705,4.0836571}, {710,4.0967143}, {715,4.1999429}, {720,4.2798286}, {725,4.3313714}, {730,4.3820286}, {735,4.4893714}, {740,4.6400857}, {745,4.6916571}, {750,4.8340571}, {755,4.9618286}, {760,5.0233714}, {765,5.1055429}, {770,5.1621429}, {775,5.3038857}, {780,5.4530000}, {785,5.5294286}, {790,5.4914857}, {795,5.5838571}, {800,5.6286000}, {805,5.6662000}, {810,5.9745429}, {815,5.8862571}, {820,6.1682286}, {825,6.3694571}, {830,6.3714000}, {835,6.3837714}, {840,6.3707143}, {845,6.4022571}, {850,6.5128571}, {855,6.5554857}, {860,6.8261714}, {865,6.7235714}, {870,6.8304286}, {875,6.8787429}, {880,7.0868571}, {885,7.0114286}, {890,7.0634000}, {895,7.1510000}, {900,7.3592286}, {905,7.2828286}, {910,7.4265429}, {915,7.5972571}, {920,7.6212857}, {925,7.8235143}, {930,7.8867714}, {935,7.9233714}, {940,7.9230857}, {945,8.0831714}, {950,8.2273429}, {955,8.5080857}, {960,8.3374857}, {965,8.4153429}, {970,8.6476286}, {975,8.6258000}, {980,8.8933714}, {985,8.8161143}, {990,8.9985143}, {995,8.9873714}, {1000,9.0247143}, {1010,9.3220000}, {1020,9.4512857}, {1030,9.6934571}, {1040,10.0828286}, {1050,10.2866857}, {1060,10.5734857}, {1070,10.6527714}, {1080,10.8481429}, {1090,11.3615143}, {1100,11.5060571}, {1110,11.7920000}, {1120,11.8464571}, {1130,12.3027143}, {1140,12.4603429}, {1150,12.5214000}, {1160,12.8856286}, {1170,13.1911714}, {1180,13.4222571}, {1190,13.6593143}, {1200,14.1774571}, {1210,14.2334000}, {1220,14.8571429}, {1230,15.2882571}, {1240,15.7076571}, {1250,15.4788286}, {1260,15.8690571}, {1270,16.3476857}, {1280,16.5314857}, {1290,16.9570857}, {1300,17.1389714}, {1310,17.6085429}, {1320,17.7927429}, {1330,18.0982571}, {1340,18.3487143}, {1350,18.6409714}, {1360,19.2940286}, {1370,19.4507714}, {1380,19.8662000}, {1390,20.0845143}, {1400,20.6068571}, {1410,20.8113143}, {1420,21.4286286}, {1430,22.0784571}, {1440,22.0898000}, {1450,22.0849714}, {1460,23.3664571}, {1470,23.2421143}, {1480,23.4712286}, {1490,24.1740286}, {1500,24.4011143}, {1510,24.7596857}, {1520,25.5616000}, {1530,25.4160857}, {1540,26.3444857}, {1550,26.2132000}, {1560,27.1876857}, {1570,27.2052000}, {1580,28.1182286}, {1590,28.3637143}, {1600,29.0023714}, {1610,29.0745143}, {1620,29.7193714}, {1630,30.2491714}, {1640,30.4579429}, {1650,30.6545429}, {1660,31.4225714}, {1670,31.9396000}, {1680,32.3842857}, {1690,34.0310857}, {1700,33.6983143}, {1710,34.2526286}, {1720,34.8744857}, {1730,35.0099143}, {1740,35.5734000}, {1750,35.9657429}, {1760,36.7532286}, {1770,37.7163429}, {1780,37.1119429}, {1790,38.2384000}, {1800,38.9458857}, {1810,39.6877143}, {1820,39.8504857}, {1830,40.5319429}, {1840,41.1912286}, {1850,41.9719429}, {1860,43.0647143}, {1870,43.3078571}, {1880,44.0193429}, {1890,45.1421143}, {1900,45.0613714}, {1910,45.7758857}, {1920,46.6015714}, {1930,47.1951714}, {1940,46.8853143}, {1950,47.7875714}, {1960,48.8895429}, {1970,49.4327143}, {1980,49.6843143}, {1990,50.2366286}, {2000,51.5469143}};
data["big"]["LtacTCExplicitCtx"]["actual reif"]["user"] = {{1,0.00031683}, {2,0.00064356}, {3,0.00104950}, {4,0.00136634}, {5,0.00177228}, {6,0.00200000}, {7,0.00276238}, {8,0.00255446}, {9,0.00310891}, {10,0.00367327}, {11,0.00400990}, {12,0.00420792}, {13,0.00489109}, {14,0.00551485}, {15,0.00568317}, {16,0.00603960}, {17,0.00691089}, {18,0.00718812}, {19,0.00757426}, {20,0.00796040}, {21,0.00877228}, {22,0.00915842}, {23,0.00992079}, {24,0.01053465}, {25,0.01077228}, {26,0.01156436}, {27,0.01195050}, {28,0.01263366}, {29,0.01600990}, {30,0.01415842}, {31,0.01444554}, {32,0.01521782}, {33,0.01584158}, {34,0.01672277}, {35,0.01734653}, {36,0.01770297}, {37,0.01837624}, {38,0.01943564}, {39,0.02005941}, {40,0.02176238}, {41,0.02191089}, {42,0.02313861}, {43,0.02686139}, {44,0.02499010}, {45,0.02546535}, {46,0.03160396}, {47,0.02748515}, {48,0.02842574}, {49,0.02873267}, {50,0.02969307}, {51,0.03071287}, {52,0.03155446}, {53,0.03249505}, {54,0.03801980}, {55,0.03376238}, {56,0.03507921}, {57,0.03606931}, {58,0.04546535}, {59,0.03805941}, {60,0.03879208}, {61,0.03957426}, {62,0.04080198}, {63,0.04186139}, {64,0.04275248}, {65,0.04926733}, {66,0.05117822}, {67,0.04635644}, {68,0.04789109}, {69,0.04895050}, {70,0.05293069}, {71,0.05130693}, {72,0.05849505}, {73,0.05343564}, {74,0.06315842}, {75,0.05548515}, {76,0.05653465}, {77,0.07320792}, {78,0.05892079}, {79,0.06044554}, {80,0.06167327}, {81,0.06274257}, {82,0.06526733}, {83,0.06633663}, {84,0.06589109}, {85,0.06719802}, {86,0.06914851}, {87,0.07093069}, {88,0.07207921}, {89,0.07356436}, {90,0.07515842}, {91,0.07625743}, {92,0.07801980}, {93,0.07869307}, {94,0.08061386}, {95,0.08194059}, {96,0.08311881}, {97,0.08470297}, {98,0.08632673}, {99,0.08707921}, {100,0.08891089}, {101,0.09004950}, {102,0.09152475}, {103,0.09376238}, {104,0.09592079}, {105,0.09729703}, {106,0.09869307}, {107,0.09965347}, {108,0.10157426}, {109,0.10295050}, {110,0.10445545}, {111,0.11300990}, {112,0.11497030}, {113,0.11722772}, {114,0.11950495}, {115,0.12188119}, {116,0.12422772}, {117,0.12654455}, {118,0.12939604}, {119,0.13019802}, {120,0.13390099}, {121,0.13537624}, {122,0.13837624}, {123,0.14225743}, {124,0.14522772}, {125,0.14850495}, {126,0.15082178}, {127,0.15204950}, {128,0.15325743}, {129,0.15577228}, {130,0.15843564}, {131,0.15957426}, {132,0.16059406}, {133,0.16438614}, {134,0.16763366}, {135,0.16688119}, {136,0.17062376}, {137,0.17216832}, {138,0.17487129}, {139,0.17782178}, {140,0.17751485}, {141,0.18268317}, {142,0.18349505}, {143,0.18575248}, {144,0.18923762}, {145,0.19130693}, {146,0.19464356}, {147,0.19755446}, {148,0.19822772}, {149,0.20061386}, {150,0.20311881}, {151,0.20415842}, {152,0.20636634}, {153,0.20696040}, {154,0.20952475}, {155,0.21188119}, {156,0.21653465}, {157,0.21875248}, {158,0.22103960}, {159,0.22134653}, {160,0.22582178}, {161,0.22694059}, {162,0.22850495}, {163,0.22975248}, {164,0.23350495}, {165,0.23363366}, {166,0.23817822}, {167,0.24061386}, {168,0.24001980}, {169,0.24374257}, {170,0.24862376}, {171,0.25113861}, {172,0.25288119}, {173,0.25600990}, {174,0.25806931}, {175,0.26216832}, {176,0.26107921}, {177,0.26337624}, {178,0.26726733}, {179,0.27044554}, {180,0.27462376}, {181,0.27592079}, {182,0.28100000}, {183,0.28243564}, {184,0.28747525}, {185,0.28925743}, {186,0.29074257}, {187,0.29304950}, {188,0.29654455}, {189,0.29895050}, {190,0.30224752}, {191,0.30240594}, {192,0.30520792}, {193,0.30717822}, {194,0.31084158}, {195,0.30965347}, {196,0.31131683}, {197,0.31584158}, {198,0.32539604}, {199,0.33077228}, {200,0.32576238}, {201,0.32660396}, {202,0.33435644}, {203,0.33339604}, {204,0.34183168}, {205,0.34953465}, {206,0.33913861}, {207,0.34622772}, {208,0.34617822}, {209,0.35139604}, {210,0.36630693}, {211,0.35717822}, {212,0.35927723}, {213,0.36177228}, {214,0.37477228}, {215,0.37033663}, {216,0.36919802}, {217,0.38337624}, {218,0.38361386}, {219,0.38078218}, {220,0.39033663}, {221,0.39177228}, {222,0.39377228}, {223,0.40224752}, {224,0.40034653}, {225,0.40255446}, {226,0.41108911}, {227,0.40876238}, {228,0.41369307}, {229,0.41346535}, {230,0.42381188}, {231,0.42125743}, {232,0.42723762}, {233,0.42969307}, {234,0.43121782}, {235,0.43772277}, {236,0.44005941}, {237,0.44085149}, {238,0.45073267}, {239,0.44733663}, {240,0.46082178}, {241,0.45487129}, {242,0.46325743}, {243,0.46551485}, {244,0.46831683}, {245,0.47504950}, {246,0.47730693}, {247,0.47566337}, {248,0.48330693}, {249,0.48324752}, {250,0.48457426}, {251,0.49956436}, {252,0.49342574}, {253,0.49681188}, {254,0.50733663}, {255,0.50506931}, {256,0.50685149}, {257,0.52144554}, {258,0.52549505}, {259,0.52447525}, {260,0.52124752}, {261,0.52839604}, {262,0.53147525}, {263,0.53562376}, {264,0.54487129}, {265,0.54393069}, {266,0.54336634}, {267,0.54695050}, {268,0.55265347}, {269,0.55696040}, {270,0.56084158}, {271,0.56444554}, {272,0.56975248}, {273,0.57600000}, {274,0.57946535}, {275,0.58391089}, {276,0.58307921}, {277,0.58617822}, {278,0.58945545}, {279,0.59523762}, {280,0.60345545}, {281,0.60801980}, {282,0.61048515}, {283,0.61336634}, {284,0.61916832}, {285,0.62113861}, {286,0.62831683}, {287,0.62798020}, {288,0.63392079}, {289,0.63647525}, {290,0.64328713}, {291,0.64641584}, {292,0.64978218}, {293,0.65323762}, {294,0.65915842}, {295,0.66361386}, {296,0.67067327}, {297,0.67630693}, {298,0.67716832}, {299,0.68214851}, {300,0.68790099}, {301,0.7229143}, {302,0.7330000}, {303,0.7940286}, {304,0.7645143}, {305,0.7417429}, {306,0.7660286}, {307,0.7551429}, {308,0.7623429}, {309,0.7722571}, {310,0.7698571}, {311,0.7741143}, {312,0.7833143}, {313,0.7960857}, {314,0.7915143}, {315,0.7993143}, {316,0.8023714}, {317,0.8040857}, {318,0.8097429}, {319,0.8210571}, {320,0.8180571}, {321,0.8439143}, {322,0.8556571}, {323,0.8261143}, {324,0.8341714}, {325,0.8406286}, {326,0.8434000}, {327,0.8530286}, {328,0.8565714}, {329,0.8574571}, {330,0.8652286}, {331,0.8679143}, {332,0.8731429}, {333,0.8736000}, {334,0.8791714}, {335,0.8888571}, {336,0.8933143}, {337,0.9010286}, {338,0.9206857}, {339,0.9120000}, {340,0.9332857}, {341,0.9286286}, {342,0.9316857}, {343,0.9408571}, {344,0.9442000}, {345,0.9520286}, {346,0.9477143}, {347,0.9567429}, {348,0.9612286}, {349,0.9673429}, {350,0.9721143}, {351,0.9882000}, {352,0.9824571}, {353,0.9844000}, {354,0.9919714}, {355,0.9891714}, {356,1.0062571}, {357,1.0075429}, {358,1.0081714}, {359,1.0073429}, {360,1.0224857}, {361,1.0173429}, {362,1.0332286}, {363,1.0382571}, {364,1.0411714}, {365,1.0514571}, {366,1.0446857}, {367,1.0570000}, {368,1.0591429}, {369,1.0671429}, {370,1.0727714}, {371,1.0797143}, {372,1.0897714}, {373,1.0919714}, {374,1.0919714}, {375,1.1060571}, {376,1.1135143}, {377,1.1131429}, {378,1.1192857}, {379,1.1182286}, {380,1.1254286}, {381,1.1365714}, {382,1.1479714}, {383,1.1524286}, {384,1.1622571}, {385,1.1720000}, {386,1.1752000}, {387,1.1816286}, {388,1.1887429}, {389,1.1942286}, {390,1.2040571}, {391,1.2053429}, {392,1.2090857}, {393,1.2239714}, {394,1.2330000}, {395,1.2403714}, {396,1.2369143}, {397,1.2371714}, {398,1.2453143}, {399,1.2554000}, {400,1.2685429}, {401,1.2672571}, {402,1.2761143}, {403,1.2889714}, {404,1.2888000}, {405,1.3038857}, {406,1.3046857}, {407,1.3079429}, {408,1.3190857}, {409,1.3321429}, {410,1.3262000}, {411,1.3343429}, {412,1.3322286}, {413,1.3408571}, {414,1.3466000}, {415,1.3625429}, {416,1.3731429}, {417,1.3796286}, {418,1.3872286}, {419,1.3794571}, {420,1.3903429}, {421,1.3993429}, {422,1.4044857}, {423,1.4156000}, {424,1.4214286}, {425,1.4348857}, {426,1.4478286}, {427,1.4773429}, {428,1.4726286}, {429,1.4687143}, {430,1.4649429}, {431,1.4899429}, {432,1.5053714}, {433,1.5082857}, {434,1.5048286}, {435,1.5094571}, {436,1.5220286}, {437,1.5263714}, {438,1.5402000}, {439,1.5572857}, {440,1.5650571}, {441,1.5579429}, {442,1.5780571}, {443,1.5821714}, {444,1.5730000}, {445,1.5840571}, {446,1.5942286}, {447,1.6010857}, {448,1.6049429}, {449,1.6136857}, {450,1.6186000}, {451,1.6211143}, {452,1.6376286}, {453,1.6450857}, {454,1.6424571}, {455,1.6609143}, {456,1.6638286}, {457,1.6728571}, {458,1.6931143}, {459,1.6943714}, {460,1.6968286}, {461,1.7055429}, {462,1.7095714}, {463,1.7186857}, {464,1.7226571}, {465,1.7340286}, {466,1.7431429}, {467,1.7482000}, {468,1.7626571}, {469,1.7919429}, {470,1.7783143}, {471,1.7775143}, {472,1.7905714}, {473,1.8119429}, {474,1.8702571}, {475,1.7993714}, {476,1.8117429}, {477,1.8436286}, {478,1.8534857}, {479,1.8550857}, {480,1.8352571}, {481,1.9106571}, {482,1.9497143}, {483,1.8964000}, {484,1.9518857}, {485,1.9342571}, {486,1.9675143}, {487,1.9338857}, {488,1.9309429}, {489,1.9379429}, {490,1.9390000}, {491,1.9317429}, {492,1.9504857}, {493,2.0194000}, {494,2.0313429}, {495,1.9910000}, {496,1.9811714}, {497,2.0363143}, {498,2.0330000}, {499,2.0340571}, {500,2.0835714}, {505,2.0876286}, {510,2.1027143}, {515,2.1287714}, {520,2.1750286}, {525,2.2757429}, {530,2.2810286}, {535,2.2997429}, {540,2.4381714}, {545,2.4806571}, {550,2.5257429}, {555,2.5410286}, {560,2.6449429}, {565,2.6419143}, {570,2.6874571}, {575,2.7157714}, {580,2.7681714}, {585,2.8287429}, {590,2.9599429}, {595,2.9659714}, {600,3.0570000}, {605,3.0749714}, {610,3.1676000}, {615,3.2219429}, {620,3.2867714}, {625,3.2768571}, {630,3.3485429}, {635,3.3682286}, {640,3.4050000}, {645,3.4651714}, {650,3.4488000}, {655,3.5303143}, {660,3.5675429}, {665,3.6230571}, {670,3.6347429}, {675,3.7321429}, {680,3.8460000}, {685,3.7768857}, {690,3.8958571}, {695,3.9878000}, {700,4.1034000}, {705,4.0792571}, {710,4.0924571}, {715,4.1936571}, {720,4.2721714}, {725,4.3235143}, {730,4.3747143}, {735,4.4829714}, {740,4.6331429}, {745,4.6856571}, {750,4.8285143}, {755,4.9546000}, {760,5.0165429}, {765,5.0992000}, {770,5.1552857}, {775,5.2972857}, {780,5.4456571}, {785,5.5226857}, {790,5.4789429}, {795,5.5785714}, {800,5.6142286}, {805,5.6491714}, {810,5.9524000}, {815,5.8758286}, {820,6.1575714}, {825,6.3603714}, {830,6.3613429}, {835,6.3691714}, {840,6.3624286}, {845,6.3928857}, {850,6.5044000}, {855,6.5464000}, {860,6.8175143}, {865,6.7139143}, {870,6.8229429}, {875,6.8725143}, {880,7.0829714}, {885,7.0088000}, {890,7.0606000}, {895,7.1443143}, {900,7.3533714}, {905,7.2728857}, {910,7.4119143}, {915,7.5838571}, {920,7.6086857}, {925,7.8111429}, {930,7.8731429}, {935,7.9097714}, {940,7.9085714}, {945,8.0710286}, {950,8.2179143}, {955,8.5009714}, {960,8.3284000}, {965,8.3999714}, {970,8.6339429}, {975,8.6097429}, {980,8.8756286}, {985,8.7974571}, {990,8.9755143}, {995,8.9609143}, {1000,9.0040286}, {1010,9.2888571}, {1020,9.4279143}, {1030,9.6636000}, {1040,10.0596000}, {1050,10.2644857}, {1060,10.5480857}, {1070,10.6372286}, {1080,10.8049714}, {1090,11.3444571}, {1100,11.4884571}, {1110,11.7691714}, {1120,11.8179429}, {1130,12.2825429}, {1140,12.4192000}, {1150,12.4986000}, {1160,12.8631429}, {1170,13.1709143}, {1180,13.3964286}, {1190,13.6388286}, {1200,14.1522000}, {1210,14.2100000}, {1220,14.8310571}, {1230,15.2616000}, {1240,15.6727429}, {1250,15.4402857}, {1260,15.8286857}, {1270,16.3079143}, {1280,16.4998857}, {1290,16.9208857}, {1300,17.1054286}, {1310,17.5771714}, {1320,17.7535714}, {1330,18.0669714}, {1340,18.3168000}, {1350,18.6057714}, {1360,19.2588000}, {1370,19.4167714}, {1380,19.8219143}, {1390,20.0395143}, {1400,20.5751143}, {1410,20.7743429}, {1420,21.3896857}, {1430,22.0335714}, {1440,22.0546571}, {1450,22.0351429}, {1460,23.3170571}, {1470,23.1917429}, {1480,23.4300000}, {1490,24.1344571}, {1500,24.3490286}, {1510,24.7090286}, {1520,25.5034286}, {1530,25.3609714}, {1540,26.3002571}, {1550,26.1643714}, {1560,27.1298000}, {1570,27.1584000}, {1580,28.0632286}, {1590,28.2944571}, {1600,28.9464000}, {1610,29.0181429}, {1620,29.6626571}, {1630,30.1884286}, {1640,30.3967143}, {1650,30.5889714}, {1660,31.3538571}, {1670,31.8780000}, {1680,32.3164286}, {1690,33.9606571}, {1700,33.6254286}, {1710,34.1948571}, {1720,34.8076000}, {1730,34.9340571}, {1740,35.4894000}, {1750,35.8858286}, {1760,36.6800857}, {1770,37.6299714}, {1780,37.0278571}, {1790,38.1630286}, {1800,38.8759143}, {1810,39.6236286}, {1820,39.7748857}, {1830,40.4619714}, {1840,41.1004857}, {1850,41.8849429}, {1860,42.9759429}, {1870,43.1971429}, {1880,43.9316571}, {1890,45.0556857}, {1900,44.9819429}, {1910,45.7099143}, {1920,46.5339429}, {1930,47.1289714}, {1940,46.7942000}, {1950,47.7185143}, {1960,48.5700000}, {1970,49.3724571}, {1980,49.6238000}, {1990,50.1702571}, {2000,51.4898571}};
data["big"]["LtacTCExplicitCtx"]["actual reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00003960}, {11,0.00000000}, {12,0.00003960}, {13,0.00000000}, {14,0.00000000}, {15,0.00010891}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00003960}, {20,0.00002970}, {21,0.00007921}, {22,0.00000000}, {23,0.00003960}, {24,0.00011881}, {25,0.00007921}, {26,0.00011881}, {27,0.00003960}, {28,0.00003960}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00015842}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00007921}, {37,0.00000000}, {38,0.00000000}, {39,0.00003960}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00003960}, {44,0.00003960}, {45,0.00000000}, {46,0.00011881}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00006931}, {51,0.00000000}, {52,0.00007921}, {53,0.00010891}, {54,0.00003960}, {55,0.00015842}, {56,0.00000000}, {57,0.00003960}, {58,0.00003960}, {59,0.00003960}, {60,0.00003960}, {61,0.00000000}, {62,0.00003960}, {63,0.00003960}, {64,0.00007921}, {65,0.00000000}, {66,0.00003960}, {67,0.00000000}, {68,0.00000000}, {69,0.00007921}, {70,0.00000000}, {71,0.00003960}, {72,0.00000000}, {73,0.00011881}, {74,0.00003960}, {75,0.00000000}, {76,0.00000000}, {77,0.00003960}, {78,0.00000000}, {79,0.00003960}, {80,0.00003960}, {81,0.00000000}, {82,0.00007921}, {83,0.00007921}, {84,0.00003960}, {85,0.00003960}, {86,0.00003960}, {87,0.00003960}, {88,0.00000000}, {89,0.00000000}, {90,0.00007921}, {91,0.00003960}, {92,0.00003960}, {93,0.00007921}, {94,0.00011881}, {95,0.00007921}, {96,0.00003960}, {97,0.00011881}, {98,0.00007921}, {99,0.00019802}, {100,0.00000000}, {101,0.00003960}, {102,0.00000000}, {103,0.00000000}, {104,0.00003960}, {105,0.00000000}, {106,0.00011881}, {107,0.00000000}, {108,0.00003960}, {109,0.00003960}, {110,0.00000000}, {111,0.00000000}, {112,0.00007921}, {113,0.00003960}, {114,0.00003960}, {115,0.00000000}, {116,0.00006931}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00003960}, {122,0.00000000}, {123,0.00003960}, {124,0.00000000}, {125,0.00003960}, {126,0.00007921}, {127,0.00002970}, {128,0.00003960}, {129,0.00006931}, {130,0.00000000}, {131,0.00003960}, {132,0.00003960}, {133,0.00003960}, {134,0.00000000}, {135,0.00015842}, {136,0.00000000}, {137,0.00007921}, {138,0.00003960}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00003960}, {143,0.00007921}, {144,0.00011881}, {145,0.00003960}, {146,0.00007921}, {147,0.00007921}, {148,0.00000000}, {149,0.00002970}, {150,0.00003960}, {151,0.00007921}, {152,0.00003960}, {153,0.00000000}, {154,0.00000000}, {155,0.00003960}, {156,0.00011881}, {157,0.00000000}, {158,0.00010891}, {159,0.00011881}, {160,0.00011881}, {161,0.00003960}, {162,0.00003960}, {163,0.00003960}, {164,0.00011881}, {165,0.00003960}, {166,0.00003960}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00003960}, {171,0.00000000}, {172,0.00003960}, {173,0.00000000}, {174,0.00003960}, {175,0.00003960}, {176,0.00003960}, {177,0.00015842}, {178,0.00003960}, {179,0.00011881}, {180,0.00000000}, {181,0.00011881}, {182,0.00003960}, {183,0.00003960}, {184,0.00000000}, {185,0.00003960}, {186,0.00007921}, {187,0.00003960}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00007921}, {193,0.00003960}, {194,0.00003960}, {195,0.00003960}, {196,0.00003960}, {197,0.00003960}, {198,0.00000000}, {199,0.00003960}, {200,0.00003960}, {201,0.00003960}, {202,0.00007921}, {203,0.00003960}, {204,0.00003960}, {205,0.00003960}, {206,0.00003960}, {207,0.00003960}, {208,0.00003960}, {209,0.00000000}, {210,0.00003960}, {211,0.00000000}, {212,0.00000000}, {213,0.00003960}, {214,0.00003960}, {215,0.00011881}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00003960}, {220,0.00003960}, {221,0.00003960}, {222,0.00011881}, {223,0.00003960}, {224,0.00003960}, {225,0.00003960}, {226,0.00000000}, {227,0.00007921}, {228,0.00007921}, {229,0.00000000}, {230,0.00007921}, {231,0.00023762}, {232,0.00011881}, {233,0.00007921}, {234,0.00015842}, {235,0.00007921}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00003960}, {240,0.00019802}, {241,0.00007921}, {242,0.00015842}, {243,0.00015842}, {244,0.00011881}, {245,0.00003960}, {246,0.00007921}, {247,0.00011881}, {248,0.00011881}, {249,0.00011881}, {250,0.00023762}, {251,0.00003960}, {252,0.00003960}, {253,0.00019802}, {254,0.00003960}, {255,0.00015842}, {256,0.00000000}, {257,0.00003960}, {258,0.00010891}, {259,0.00026733}, {260,0.00007921}, {261,0.00006931}, {262,0.00019802}, {263,0.00003960}, {264,0.00003960}, {265,0.00007921}, {266,0.00015842}, {267,0.00000000}, {268,0.00007921}, {269,0.00003960}, {270,0.00011881}, {271,0.00003960}, {272,0.00003960}, {273,0.00003960}, {274,0.00003960}, {275,0.00007921}, {276,0.00003960}, {277,0.00010891}, {278,0.00003960}, {279,0.00007921}, {280,0.00000000}, {281,0.00003960}, {282,0.00007921}, {283,0.00000000}, {284,0.00050495}, {285,0.00011881}, {286,0.00003960}, {287,0.00003960}, {288,0.00002970}, {289,0.00011881}, {290,0.00003960}, {291,0.00003960}, {292,0.00011881}, {293,0.00011881}, {294,0.00015842}, {295,0.00003960}, {296,0.00015842}, {297,0.00000000}, {298,0.00003960}, {299,0.00003960}, {300,0.00015842}, {301,0.0005429}, {302,0.0002286}, {303,0.0001143}, {304,0.0003429}, {305,0.0000000}, {306,0.0002286}, {307,0.0000000}, {308,0.0001143}, {309,0.0003429}, {310,0.0000000}, {311,0.0002286}, {312,0.0000000}, {313,0.0001143}, {314,0.0000000}, {315,0.0001143}, {316,0.0002286}, {317,0.0002286}, {318,0.0003429}, {319,0.0001143}, {320,0.0001143}, {321,0.0000000}, {322,0.0000000}, {323,0.0004286}, {324,0.0001143}, {325,0.0001143}, {326,0.0001143}, {327,0.0001143}, {328,0.0002286}, {329,0.0001143}, {330,0.0002286}, {331,0.0001143}, {332,0.0002286}, {333,0.0000000}, {334,0.0001143}, {335,0.0001143}, {336,0.0005714}, {337,0.0003429}, {338,0.0002000}, {339,0.0001143}, {340,0.0002286}, {341,0.0002286}, {342,0.0000000}, {343,0.0000000}, {344,0.0004571}, {345,0.0001143}, {346,0.0001143}, {347,0.0002286}, {348,0.0001143}, {349,0.0000000}, {350,0.0001143}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0001143}, {356,0.0000000}, {357,0.0000000}, {358,0.0001143}, {359,0.0000000}, {360,0.0000000}, {361,0.0001143}, {362,0.0002286}, {363,0.0002286}, {364,0.0004571}, {365,0.0004571}, {366,0.0000000}, {367,0.0001143}, {368,0.0000000}, {369,0.0000000}, {370,0.0003429}, {371,0.0001143}, {372,0.0000000}, {373,0.0002286}, {374,0.0001143}, {375,0.0001143}, {376,0.0001143}, {377,0.0001143}, {378,0.0000000}, {379,0.0003429}, {380,0.0001143}, {381,0.0002286}, {382,0.0000000}, {383,0.0000857}, {384,0.0004571}, {385,0.0004571}, {386,0.0004571}, {387,0.0004571}, {388,0.0001143}, {389,0.0001143}, {390,0.0000000}, {391,0.0002286}, {392,0.0001143}, {393,0.0003429}, {394,0.0001143}, {395,0.0003429}, {396,0.0002000}, {397,0.0001143}, {398,0.0003429}, {399,0.0002286}, {400,0.0001143}, {401,0.0003429}, {402,0.0001143}, {403,0.0002286}, {404,0.0001143}, {405,0.0000000}, {406,0.0000000}, {407,0.0002286}, {408,0.0003429}, {409,0.0003429}, {410,0.0002286}, {411,0.0001143}, {412,0.0002286}, {413,0.0003429}, {414,0.0001143}, {415,0.0003429}, {416,0.0001143}, {417,0.0001143}, {418,0.0003429}, {419,0.0001143}, {420,0.0001143}, {421,0.0001143}, {422,0.0005714}, {423,0.0001143}, {424,0.0001143}, {425,0.0001143}, {426,0.0002286}, {427,0.0003429}, {428,0.0000000}, {429,0.0006857}, {430,0.0001143}, {431,0.0001143}, {432,0.0004571}, {433,0.0001143}, {434,0.0000000}, {435,0.0001143}, {436,0.0003429}, {437,0.0001143}, {438,0.0004571}, {439,0.0002000}, {440,0.0003429}, {441,0.0003429}, {442,0.0002286}, {443,0.0001143}, {444,0.0000857}, {445,0.0002286}, {446,0.0003429}, {447,0.0006857}, {448,0.0001143}, {449,0.0001143}, {450,0.0003429}, {451,0.0002286}, {452,0.0000000}, {453,0.0001143}, {454,0.0005714}, {455,0.0002286}, {456,0.0001143}, {457,0.0002286}, {458,0.0001143}, {459,0.0001143}, {460,0.0002286}, {461,0.0003429}, {462,0.0002286}, {463,0.0002286}, {464,0.0002286}, {465,0.0002000}, {466,0.0004571}, {467,0.0002286}, {468,0.0004571}, {469,0.0005714}, {470,0.0005714}, {471,0.0011143}, {472,0.0011429}, {473,0.0003429}, {474,0.0004571}, {475,0.0012571}, {476,0.0003429}, {477,0.0003429}, {478,0.0006857}, {479,0.0000000}, {480,0.0004571}, {481,0.0012571}, {482,0.0016000}, {483,0.0009143}, {484,0.0005714}, {485,0.0004571}, {486,0.0002286}, {487,0.0007714}, {488,0.0012571}, {489,0.0010286}, {490,0.0009143}, {491,0.0004571}, {492,0.0003429}, {493,0.0002286}, {494,0.0012571}, {495,0.0017143}, {496,0.0011429}, {497,0.0010286}, {498,0.0009143}, {499,0.0002286}, {500,0.0006857}, {505,0.0008000}, {510,0.0008857}, {515,0.0007714}, {520,0.0005714}, {525,0.0010000}, {530,0.0016000}, {535,0.0008000}, {540,0.0008000}, {545,0.0017143}, {550,0.0010286}, {555,0.0012571}, {560,0.0006857}, {565,0.0018286}, {570,0.0013714}, {575,0.0010286}, {580,0.0011429}, {585,0.0012571}, {590,0.0008000}, {595,0.0009143}, {600,0.0004571}, {605,0.0014857}, {610,0.0006857}, {615,0.0008857}, {620,0.0010286}, {625,0.0004571}, {630,0.0014857}, {635,0.0012571}, {640,0.0009143}, {645,0.0012571}, {650,0.0004571}, {655,0.0014857}, {660,0.0012571}, {665,0.0010286}, {670,0.0005714}, {675,0.0008857}, {680,0.0001143}, {685,0.0014857}, {690,0.0012571}, {695,0.0006857}, {700,0.0008857}, {705,0.0008000}, {710,0.0006857}, {715,0.0004571}, {720,0.0014857}, {725,0.0006857}, {730,0.0004571}, {735,0.0004571}, {740,0.0014857}, {745,0.0011429}, {750,0.0010286}, {755,0.0026286}, {760,0.0012286}, {765,0.0019429}, {770,0.0008000}, {775,0.0008000}, {780,0.0004571}, {785,0.0008000}, {790,0.0006571}, {795,0.0011429}, {800,0.0005714}, {805,0.0006857}, {810,0.0012286}, {815,0.0014857}, {820,0.0013429}, {825,0.0005714}, {830,0.0008857}, {835,0.0007429}, {840,0.0006857}, {845,0.0010000}, {850,0.0005714}, {855,0.0018000}, {860,0.0004571}, {865,0.0021714}, {870,0.0024857}, {875,0.0019429}, {880,0.0021429}, {885,0.0008000}, {890,0.0008857}, {895,0.0024000}, {900,0.0021429}, {905,0.0038286}, {910,0.0047429}, {915,0.0021143}, {920,0.0027429}, {925,0.0038857}, {930,0.0040000}, {935,0.0040571}, {940,0.0043143}, {945,0.0041714}, {950,0.0046857}, {955,0.0017429}, {960,0.0021143}, {965,0.0042000}, {970,0.0020286}, {975,0.0035714}, {980,0.0036000}, {985,0.0035429}, {990,0.0048857}, {995,0.0073429}, {1000,0.0022571}, {1010,0.0040857}, {1020,0.0044286}, {1030,0.0074286}, {1040,0.0078857}, {1050,0.0051143}, {1060,0.0098857}, {1070,0.0045143}, {1080,0.0050571}, {1090,0.0064286}, {1100,0.0072286}, {1110,0.0052857}, {1120,0.0094286}, {1130,0.0067429}, {1140,0.0100000}, {1150,0.0088000}, {1160,0.0087429}, {1170,0.0108000}, {1180,0.0085143}, {1190,0.0068857}, {1200,0.0107143}, {1210,0.0076857}, {1220,0.0096857}, {1230,0.0054286}, {1240,0.0098000}, {1250,0.0108286}, {1260,0.0152000}, {1270,0.0153714}, {1280,0.0088286}, {1290,0.0118286}, {1300,0.0126286}, {1310,0.0117714}, {1320,0.0189429}, {1330,0.0153143}, {1340,0.0121143}, {1350,0.0147714}, {1360,0.0128000}, {1370,0.0130857}, {1380,0.0212286}, {1390,0.0200857}, {1400,0.0140286}, {1410,0.0164857}, {1420,0.0179143}, {1430,0.0136286}, {1440,0.0173714}, {1450,0.0218286}, {1460,0.0180000}, {1470,0.0164286}, {1480,0.0187714}, {1490,0.0195143}, {1500,0.0214571}, {1510,0.0205714}, {1520,0.0190571}, {1530,0.0252857}, {1540,0.0221714}, {1550,0.0186857}, {1560,0.0255714}, {1570,0.0221714}, {1580,0.0253143}, {1590,0.0255714}, {1600,0.0246000}, {1610,0.0258571}, {1620,0.0303429}, {1630,0.0267714}, {1640,0.0314571}, {1650,0.0317429}, {1660,0.0262571}, {1670,0.0291143}, {1680,0.0317429}, {1690,0.0292000}, {1700,0.0308857}, {1710,0.0294000}, {1720,0.0323143}, {1730,0.0307714}, {1740,0.0390571}, {1750,0.0389143}, {1760,0.0349714}, {1770,0.0332571}, {1780,0.0378000}, {1790,0.0392286}, {1800,0.0431714}, {1810,0.0461714}, {1820,0.0415429}, {1830,0.0364000}, {1840,0.0380857}, {1850,0.0402571}, {1860,0.0379429}, {1870,0.0458857}, {1880,0.0390286}, {1890,0.0445143}, {1900,0.0427143}, {1910,0.0479143}, {1920,0.0441714}, {1930,0.0391714}, {1940,0.0434571}, {1950,0.0494286}, {1960,0.0416857}, {1970,0.0457714}, {1980,0.0470000}, {1990,0.0424286}, {2000,0.0368571}};
data["big"]["LtacTCExplicitCtx"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00002970}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00455446}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0019714}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0024571}, {525,0.0000000}, {530,0.0000286}, {535,0.0000286}, {540,0.0000571}, {545,0.0000571}, {550,0.0000000}, {555,0.0000286}, {560,0.0000000}, {565,0.0001143}, {570,0.0000286}, {575,0.0001714}, {580,0.0002571}, {585,0.0004286}, {590,0.0005429}, {595,0.0005714}, {600,0.0006000}, {605,0.0006286}, {610,0.0007143}, {615,0.0008000}, {620,0.0008571}, {625,0.0009143}, {630,0.0008571}, {635,0.0009429}, {640,0.0009714}, {645,0.0008571}, {650,0.0008857}, {655,0.0008857}, {660,0.0008857}, {665,0.0009143}, {670,0.0009429}, {675,0.0009714}, {680,0.0009714}, {685,0.0009714}, {690,0.0010000}, {695,0.0010000}, {700,0.0010000}, {705,0.0010000}, {710,0.0010000}, {715,0.0010000}, {720,0.0010000}, {725,0.0010000}, {730,0.0010000}, {735,0.0010000}, {740,0.0010000}, {745,0.0010000}, {750,0.0010000}, {755,0.0010000}, {760,0.0010000}, {765,0.0010000}, {770,0.0010000}, {775,0.0010000}, {780,0.0010000}, {785,0.0010000}, {790,0.0010000}, {795,0.0010000}, {800,0.0010000}, {805,0.0010000}, {810,0.0010000}, {815,0.0010000}, {820,0.0038571}, {825,0.0010000}, {830,0.0010000}, {835,0.0010000}, {840,0.0010000}, {845,0.0010000}, {850,0.0010000}, {855,0.0010000}, {860,0.0010000}, {865,0.0010000}, {870,0.0010000}, {875,0.0010000}, {880,0.0049429}, {885,0.0010000}, {890,0.0010000}, {895,0.0010000}, {900,0.0010000}, {905,0.0010000}, {910,0.0010000}, {915,0.0010000}, {920,0.0010000}, {925,0.0010000}, {930,0.0010000}, {935,0.0010000}, {940,0.0010000}, {945,0.0010000}, {950,0.0010000}, {955,0.0010000}, {960,0.0010000}, {965,0.0010000}, {970,0.0010000}, {975,0.0010000}, {980,0.0010000}, {985,0.0010000}, {990,0.0042286}, {995,0.0010000}, {1000,0.0010000}, {1010,0.0010000}, {1020,0.0010000}, {1030,0.0010000}, {1040,0.0010000}, {1050,0.0010286}, {1060,0.0010000}, {1070,0.0010000}, {1080,0.0010286}, {1090,0.0026000}, {1100,0.0010000}, {1110,0.0010571}, {1120,0.0010286}, {1130,0.0010286}, {1140,0.0011714}, {1150,0.0012000}, {1160,0.0012286}, {1170,0.0013429}, {1180,0.0014571}, {1190,0.0015143}, {1200,0.0016571}, {1210,0.0017714}, {1220,0.0018286}, {1230,0.0018286}, {1240,0.0018571}, {1250,0.0019143}, {1260,0.0019429}, {1270,0.0020000}, {1280,0.0020000}, {1290,0.0020000}, {1300,0.0020000}, {1310,0.0020000}, {1320,0.0020000}, {1330,0.0020000}, {1340,0.0020000}, {1350,0.0020000}, {1360,0.0020000}, {1370,0.0020000}, {1380,0.0020000}, {1390,0.0020000}, {1400,0.0020000}, {1410,0.0020000}, {1420,0.0020000}, {1430,0.0020000}, {1440,0.0020000}, {1450,0.0020000}, {1460,0.0020000}, {1470,0.0020000}, {1480,0.0020000}, {1490,0.0020000}, {1500,0.0020000}, {1510,0.0020000}, {1520,0.0020000}, {1530,0.0020000}, {1540,0.0020000}, {1550,0.0020000}, {1560,0.0020000}, {1570,0.0020000}, {1580,0.0020000}, {1590,0.0020000}, {1600,0.0020000}, {1610,0.0020000}, {1620,0.0020000}, {1630,0.0020571}, {1640,0.0020286}, {1650,0.0020000}, {1660,0.0020286}, {1670,0.0020000}, {1680,0.0020571}, {1690,0.0087429}, {1700,0.0021143}, {1710,0.0022000}, {1720,0.0021429}, {1730,0.0021714}, {1740,0.0023143}, {1750,0.0024000}, {1760,0.0023714}, {1770,0.0026000}, {1780,0.0024571}, {1790,0.0025429}, {1800,0.0026857}, {1810,0.0116857}, {1820,0.0026857}, {1830,0.0027714}, {1840,0.0044000}, {1850,0.0028571}, {1860,0.0029429}, {1870,0.0029143}, {1880,0.0030000}, {1890,0.0030000}, {1900,0.0030000}, {1910,0.0030000}, {1920,0.0030000}, {1930,0.0030000}, {1940,0.0029714}, {1950,0.0091143}, {1960,0.0030000}, {1970,0.0030000}, {1980,0.0030000}, {1990,0.0030000}, {2000,0.0030000}};
data["big"]["LtacTCExplicitCtx"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00006931}, {3,0.00003960}, {4,0.00000000}, {5,0.00007921}, {6,0.00000000}, {7,0.00000000}, {8,0.00002970}, {9,0.00003960}, {10,0.00007921}, {11,0.00003960}, {12,0.00011881}, {13,0.00007921}, {14,0.00003960}, {15,0.00000000}, {16,0.00010891}, {17,0.00003960}, {18,0.00003960}, {19,0.00019802}, {20,0.00006931}, {21,0.00007921}, {22,0.00003960}, {23,0.00003960}, {24,0.00011881}, {25,0.00007921}, {26,0.00003960}, {27,0.00011881}, {28,0.00010891}, {29,0.00011881}, {30,0.00003960}, {31,0.00002970}, {32,0.00007921}, {33,0.00003960}, {34,0.00000000}, {35,0.00011881}, {36,0.00003960}, {37,0.00007921}, {38,0.00007921}, {39,0.00006931}, {40,0.00003960}, {41,0.00000000}, {42,0.00011881}, {43,0.00018812}, {44,0.00007921}, {45,0.00002970}, {46,0.00021782}, {47,0.00000000}, {48,0.00010891}, {49,0.00014851}, {50,0.00015842}, {51,0.00010891}, {52,0.00011881}, {53,0.00006931}, {54,0.00014851}, {55,0.00010891}, {56,0.00007921}, {57,0.00007921}, {58,0.00018812}, {59,0.00007921}, {60,0.00015842}, {61,0.00011881}, {62,0.00011881}, {63,0.00011881}, {64,0.00009901}, {65,0.00022772}, {66,0.00019802}, {67,0.00011881}, {68,0.00010891}, {69,0.00007921}, {70,0.00010891}, {71,0.00014851}, {72,0.00015842}, {73,0.00006931}, {74,0.00029703}, {75,0.00006931}, {76,0.00010891}, {77,0.00007921}, {78,0.00018812}, {79,0.00014851}, {80,0.00003960}, {81,0.00025743}, {82,0.00011881}, {83,0.00023762}, {84,0.00000000}, {85,0.00019802}, {86,0.00023762}, {87,0.00006931}, {88,0.00011881}, {89,0.00022772}, {90,0.00026733}, {91,0.00018812}, {92,0.00023762}, {93,0.00016832}, {94,0.00011881}, {95,0.00019802}, {96,0.00019802}, {97,0.00014851}, {98,0.00006931}, {99,0.00011881}, {100,0.00015842}, {101,0.00012871}, {102,0.00019802}, {103,0.00017822}, {104,0.00011881}, {105,0.00015842}, {106,0.00015842}, {107,0.00026733}, {108,0.00003960}, {109,0.00030693}, {110,0.00026733}, {111,0.00015842}, {112,0.00013861}, {113,0.00025743}, {114,0.00015842}, {115,0.00015842}, {116,0.00022772}, {117,0.00017822}, {118,0.00023762}, {119,0.00018812}, {120,0.00007921}, {121,0.00015842}, {122,0.00015842}, {123,0.00026733}, {124,0.00034653}, {125,0.00010891}, {126,0.00032673}, {127,0.00045545}, {128,0.00025743}, {129,0.00032673}, {130,0.00032673}, {131,0.00029703}, {132,0.00013861}, {133,0.00031683}, {134,0.00033663}, {135,0.00011881}, {136,0.00022772}, {137,0.00023762}, {138,0.00022772}, {139,0.00044554}, {140,0.00022772}, {141,0.00021782}, {142,0.00023762}, {143,0.00034653}, {144,0.00035644}, {145,0.00009901}, {146,0.00027723}, {147,0.00037624}, {148,0.00027723}, {149,0.00014851}, {150,0.00043564}, {151,0.00014851}, {152,0.00039604}, {153,0.00022772}, {154,0.00037624}, {155,0.00015842}, {156,0.00027723}, {157,0.00014851}, {158,0.00010891}, {159,0.00020792}, {160,0.00025743}, {161,0.00015842}, {162,0.00019802}, {163,0.00014851}, {164,0.00034653}, {165,0.00007921}, {166,0.00026733}, {167,0.00039604}, {168,0.00027723}, {169,0.00030693}, {170,0.00019802}, {171,0.00015842}, {172,0.00024752}, {173,0.00026733}, {174,0.00023762}, {175,0.00035644}, {176,0.00032673}, {177,0.00003960}, {178,0.00027723}, {179,0.00021782}, {180,0.00035644}, {181,0.00041584}, {182,0.00019802}, {183,0.00019802}, {184,0.00006931}, {185,0.00031683}, {186,0.00022772}, {187,0.00029703}, {188,0.00035644}, {189,0.00038614}, {190,0.00022772}, {191,0.00034653}, {192,0.00023762}, {193,0.00029703}, {194,0.00034653}, {195,0.00034653}, {196,0.00048515}, {197,0.00035644}, {198,0.00022772}, {199,0.00034653}, {200,0.00027723}, {201,0.00025743}, {202,0.00060396}, {203,0.00036634}, {204,0.00035644}, {205,0.00048515}, {206,0.00019802}, {207,0.00021782}, {208,0.00030693}, {209,0.00034653}, {210,0.00049505}, {211,0.00023762}, {212,0.00030693}, {213,0.00026733}, {214,0.00037624}, {215,0.00021782}, {216,0.00050495}, {217,0.00029703}, {218,0.00053465}, {219,0.00033663}, {220,0.00054455}, {221,0.00033663}, {222,0.00042574}, {223,0.00038614}, {224,0.00044554}, {225,0.00031683}, {226,0.00048515}, {227,0.00042574}, {228,0.00032673}, {229,0.00011881}, {230,0.00025743}, {231,0.00041584}, {232,0.00021782}, {233,0.00045545}, {234,0.00034653}, {235,0.00061386}, {236,0.00042574}, {237,0.00045545}, {238,0.00038614}, {239,0.00038614}, {240,0.00027723}, {241,0.00042574}, {242,0.00023762}, {243,0.00050495}, {244,0.00031683}, {245,0.00041584}, {246,0.00021782}, {247,0.00043564}, {248,0.00037624}, {249,0.00027723}, {250,0.00030693}, {251,0.00019802}, {252,0.00045545}, {253,0.00033663}, {254,0.00043564}, {255,0.00058416}, {256,0.00044554}, {257,0.00033663}, {258,0.00054455}, {259,0.00042574}, {260,0.00045545}, {261,0.00038614}, {262,0.00046535}, {263,0.00016832}, {264,0.00029703}, {265,0.00052475}, {266,0.00054455}, {267,0.00037624}, {268,0.00037624}, {269,0.00034653}, {270,0.00045545}, {271,0.00035644}, {272,0.00036634}, {273,0.00020792}, {274,0.00040594}, {275,0.00026733}, {276,0.00048515}, {277,0.00044554}, {278,0.00058416}, {279,0.00024752}, {280,0.00463366}, {281,0.00038614}, {282,0.00068317}, {283,0.00039604}, {284,0.00043564}, {285,0.00055446}, {286,0.00034653}, {287,0.00052475}, {288,0.00044554}, {289,0.00025743}, {290,0.00052475}, {291,0.00033663}, {292,0.00027723}, {293,0.00050495}, {294,0.00045545}, {295,0.00057426}, {296,0.00036634}, {297,0.00046535}, {298,0.00040594}, {299,0.00016832}, {300,0.00040594}, {301,0.0002571}, {302,0.0002857}, {303,0.0004286}, {304,0.0005143}, {305,0.0005714}, {306,0.0002857}, {307,0.0004000}, {308,0.0005429}, {309,0.0002000}, {310,0.0008571}, {311,0.0007143}, {312,0.0004000}, {313,0.0002857}, {314,0.0003714}, {315,0.0002857}, {316,0.0004571}, {317,0.0004000}, {318,0.0003714}, {319,0.0006571}, {320,0.0006000}, {321,0.0002000}, {322,0.0001714}, {323,0.0004571}, {324,0.0006000}, {325,0.0004286}, {326,0.0004571}, {327,0.0003429}, {328,0.0006571}, {329,0.0003429}, {330,0.0008857}, {331,0.0005429}, {332,0.0006857}, {333,0.0004000}, {334,0.0005429}, {335,0.0003429}, {336,0.0001714}, {337,0.0009429}, {338,0.0002000}, {339,0.0005143}, {340,0.0006000}, {341,0.0006857}, {342,0.0001714}, {343,0.0008571}, {344,0.0007429}, {345,0.0004571}, {346,0.0006857}, {347,0.0004286}, {348,0.0004286}, {349,0.0007143}, {350,0.0002000}, {351,0.0003429}, {352,0.0005714}, {353,0.0007429}, {354,0.0003714}, {355,0.0006000}, {356,0.0003714}, {357,0.0002857}, {358,0.0004571}, {359,0.0003714}, {360,0.0002857}, {361,0.0004286}, {362,0.0002857}, {363,0.0002857}, {364,0.0003429}, {365,0.0004000}, {366,0.0006286}, {367,0.0000857}, {368,0.0001714}, {369,0.0006286}, {370,0.0007429}, {371,0.0002857}, {372,0.0008000}, {373,0.0001714}, {374,0.0006857}, {375,0.0007143}, {376,0.0004571}, {377,0.0004286}, {378,0.0006571}, {379,0.0004000}, {380,0.0007429}, {381,0.0005714}, {382,0.0003714}, {383,0.0008000}, {384,0.0003714}, {385,0.0001714}, {386,0.0006857}, {387,0.0007714}, {388,0.0004286}, {389,0.0006286}, {390,0.0006857}, {391,0.0005143}, {392,0.0004571}, {393,0.0006857}, {394,0.0005714}, {395,0.0002857}, {396,0.0004857}, {397,0.0006857}, {398,0.0005429}, {399,0.0005429}, {400,0.0006571}, {401,0.0003714}, {402,0.0003714}, {403,0.0002857}, {404,0.0005429}, {405,0.0004571}, {406,0.0007429}, {407,0.0007714}, {408,0.0005429}, {409,0.0004286}, {410,0.0003714}, {411,0.0006571}, {412,0.0009143}, {413,0.0001714}, {414,0.0002571}, {415,0.0003429}, {416,0.0020000}, {417,0.0000857}, {418,0.0007143}, {419,0.0003429}, {420,0.0011429}, {421,0.0006571}, {422,0.0005429}, {423,0.0006857}, {424,0.0002571}, {425,0.0005429}, {426,0.0005429}, {427,0.0003429}, {428,0.0005429}, {429,0.0006000}, {430,0.0011429}, {431,0.0003714}, {432,0.0005714}, {433,0.0005429}, {434,0.0002857}, {435,0.0010000}, {436,0.0005429}, {437,0.0008857}, {438,0.0006571}, {439,0.0007143}, {440,0.0006000}, {441,0.0005143}, {442,0.0005714}, {443,0.0005143}, {444,0.0006286}, {445,0.0003714}, {446,0.0011143}, {447,0.0006286}, {448,0.0005143}, {449,0.0004286}, {450,0.0003714}, {451,0.0005143}, {452,0.0006286}, {453,0.0005714}, {454,0.0008571}, {455,0.0002571}, {456,0.0007429}, {457,0.0005429}, {458,0.0004286}, {459,0.0006286}, {460,0.0004000}, {461,0.0007714}, {462,0.0004571}, {463,0.0006000}, {464,0.0003429}, {465,0.0008000}, {466,0.0004571}, {467,0.0004000}, {468,0.0006857}, {469,0.0005714}, {470,0.0003714}, {471,0.0007143}, {472,0.0006286}, {473,0.0007429}, {474,0.0002571}, {475,0.0006857}, {476,0.0005143}, {477,0.0010857}, {478,0.0005429}, {479,0.0004571}, {480,0.0010571}, {481,0.0005143}, {482,0.0005143}, {483,0.0010000}, {484,0.0005429}, {485,0.0008000}, {486,0.0010857}, {487,0.0006286}, {488,0.0007143}, {489,0.0008857}, {490,0.0004286}, {491,0.0008571}, {492,0.0009714}, {493,0.0006857}, {494,0.0008857}, {495,0.0007143}, {496,0.0009143}, {497,0.0006857}, {498,0.0002571}, {499,0.0006857}, {500,0.0003714}, {505,0.0002857}, {510,0.0005429}, {515,0.0006000}, {520,0.0024857}, {525,0.0004286}, {530,0.0008000}, {535,0.0005143}, {540,0.0010571}, {545,0.0009429}, {550,0.0005143}, {555,0.0007714}, {560,0.0005143}, {565,0.0010000}, {570,0.0007143}, {575,0.0010571}, {580,0.0004571}, {585,0.0008000}, {590,0.0006571}, {595,0.0007714}, {600,0.0006286}, {605,0.0005429}, {610,0.0007143}, {615,0.0006000}, {620,0.0006286}, {625,0.0006857}, {630,0.0007714}, {635,0.0013429}, {640,0.0010286}, {645,0.0008000}, {650,0.0006286}, {655,0.0007714}, {660,0.0007714}, {665,0.0008857}, {670,0.0009429}, {675,0.0009714}, {680,0.0011429}, {685,0.0010857}, {690,0.0012571}, {695,0.0008000}, {700,0.0009714}, {705,0.0008857}, {710,0.0008286}, {715,0.0006286}, {720,0.0008000}, {725,0.0008571}, {730,0.0005714}, {735,0.0008857}, {740,0.0013143}, {745,0.0008571}, {750,0.0011429}, {755,0.0012286}, {760,0.0009714}, {765,0.0007714}, {770,0.0010000}, {775,0.0008857}, {780,0.0007714}, {785,0.0012000}, {790,0.0010286}, {795,0.0009143}, {800,0.0010571}, {805,0.0011714}, {810,0.0013429}, {815,0.0009714}, {820,0.0033714}, {825,0.0007714}, {830,0.0011429}, {835,0.0010000}, {840,0.0009143}, {845,0.0012571}, {850,0.0010857}, {855,0.0010286}, {860,0.0012571}, {865,0.0011714}, {870,0.0007143}, {875,0.0011714}, {880,0.0043429}, {885,0.0008857}, {890,0.0011429}, {895,0.0014857}, {900,0.0009429}, {905,0.0014286}, {910,0.0010571}, {915,0.0009429}, {920,0.0012571}, {925,0.0013143}, {930,0.0010286}, {935,0.0008000}, {940,0.0006286}, {945,0.0009714}, {950,0.0012000}, {955,0.0011714}, {960,0.0015714}, {965,0.0013143}, {970,0.0012571}, {975,0.0013429}, {980,0.0012857}, {985,0.0013714}, {990,0.0039714}, {995,0.0012286}, {1000,0.0011714}, {1010,0.0016857}, {1020,0.0011429}, {1030,0.0017429}, {1040,0.0011714}, {1050,0.0013714}, {1060,0.0020000}, {1070,0.0017714}, {1080,0.0016857}, {1090,0.0025429}, {1100,0.0019714}, {1110,0.0016571}, {1120,0.0012571}, {1130,0.0020000}, {1140,0.0012857}, {1150,0.0016571}, {1160,0.0016286}, {1170,0.0020857}, {1180,0.0020000}, {1190,0.0020571}, {1200,0.0018000}, {1210,0.0020000}, {1220,0.0011714}, {1230,0.0015143}, {1240,0.0016286}, {1250,0.0019143}, {1260,0.0022857}, {1270,0.0016571}, {1280,0.0021429}, {1290,0.0027714}, {1300,0.0015429}, {1310,0.0021714}, {1320,0.0027429}, {1330,0.0023714}, {1340,0.0013429}, {1350,0.0015714}, {1360,0.0020000}, {1370,0.0018000}, {1380,0.0019143}, {1390,0.0017714}, {1400,0.0022857}, {1410,0.0015714}, {1420,0.0020286}, {1430,0.0025429}, {1440,0.0020286}, {1450,0.0021143}, {1460,0.0024857}, {1470,0.0022857}, {1480,0.0024571}, {1490,0.0026571}, {1500,0.0025714}, {1510,0.0023714}, {1520,0.0018286}, {1530,0.0026000}, {1540,0.0019714}, {1550,0.0026000}, {1560,0.0027714}, {1570,0.0025429}, {1580,0.0031143}, {1590,0.0023143}, {1600,0.0027429}, {1610,0.0024571}, {1620,0.0024857}, {1630,0.0028571}, {1640,0.0026857}, {1650,0.0024571}, {1660,0.0026286}, {1670,0.0024286}, {1680,0.0023143}, {1690,0.0090571}, {1700,0.0029429}, {1710,0.0030571}, {1720,0.0028286}, {1730,0.0030857}, {1740,0.0030286}, {1750,0.0031429}, {1760,0.0029143}, {1770,0.0030286}, {1780,0.0026286}, {1790,0.0022286}, {1800,0.0025143}, {1810,0.0114857}, {1820,0.0028286}, {1830,0.0029714}, {1840,0.0047429}, {1850,0.0034857}, {1860,0.0026286}, {1870,0.0022571}, {1880,0.0028286}, {1890,0.0032000}, {1900,0.0031429}, {1910,0.0034286}, {1920,0.0035143}, {1930,0.0028286}, {1940,0.0027429}, {1950,0.0089143}, {1960,0.0025143}, {1970,0.0029143}, {1980,0.0030857}, {1990,0.0031714}, {2000,0.0033143}};
data["big"]["LtacTCExplicitCtx"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00003960}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00003960}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00003960}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00003960}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00002970}, {124,0.00000000}, {125,0.00000000}, {126,0.00003960}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00003960}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00003960}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00003960}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00003960}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00003960}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00003960}, {214,0.00000000}, {215,0.00003960}, {216,0.00000000}, {217,0.00003960}, {218,0.00000000}, {219,0.00003960}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00003960}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00003960}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00003960}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0001143}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0001143}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0001143}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0001143}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0001143}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000857}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0001143}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0001143}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0001143}};
data["big"]["LtacTCExplicitCtx"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0024000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0021143}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0024000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000286}, {800,0.0000000}, {805,0.0000000}, {810,0.0031429}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000571}, {840,0.0000286}, {845,0.0000571}, {850,0.0000000}, {855,0.0000857}, {860,0.0000857}, {865,0.0000571}, {870,0.0002000}, {875,0.0001714}, {880,0.0002000}, {885,0.0003429}, {890,0.0003714}, {895,0.0003429}, {900,0.0004571}, {905,0.0005429}, {910,0.0005714}, {915,0.0006571}, {920,0.0007143}, {925,0.0007714}, {930,0.0009143}, {935,0.0008571}, {940,0.0008857}, {945,0.0009714}, {950,0.0009714}, {955,0.0010000}, {960,0.0010000}, {965,0.0010000}, {970,0.0010000}, {975,0.0010000}, {980,0.0010000}, {985,0.0010000}, {990,0.0010000}, {995,0.0010000}, {1000,0.0010000}, {1010,0.0010000}, {1020,0.0010000}, {1030,0.0010000}, {1040,0.0508857}, {1050,0.0010000}, {1060,0.0010000}, {1070,0.0010000}, {1080,0.0010000}, {1090,0.0010000}, {1100,0.0010000}, {1110,0.0010000}, {1120,0.0010000}, {1130,0.0010000}, {1140,0.0010000}, {1150,0.0010000}, {1160,0.0010000}, {1170,0.0020857}, {1180,0.0010000}, {1190,0.0010000}, {1200,0.0010000}, {1210,0.0010000}, {1220,0.0010000}, {1230,0.0010000}, {1240,0.0010000}, {1250,0.0010000}, {1260,0.0010000}, {1270,0.0010000}, {1280,0.0010000}, {1290,0.0010000}, {1300,0.0010000}, {1310,0.0010000}, {1320,0.0010000}, {1330,0.0010000}, {1340,0.0010000}, {1350,0.0010000}, {1360,0.0010000}, {1370,0.0010000}, {1380,0.0010000}, {1390,0.0010000}, {1400,0.0010000}, {1410,0.0010000}, {1420,0.0010000}, {1430,0.0010000}, {1440,0.0010000}, {1450,0.0010000}, {1460,0.0010000}, {1470,0.0010000}, {1480,0.0010000}, {1490,0.0010000}, {1500,0.0010000}, {1510,0.0010286}, {1520,0.0010000}, {1530,0.0010000}, {1540,0.0010000}, {1550,0.0010000}, {1560,0.0010000}, {1570,0.0010000}, {1580,0.0010286}, {1590,0.0010000}, {1600,0.0010000}, {1610,0.0010000}, {1620,0.0010000}, {1630,0.0010286}, {1640,0.0010000}, {1650,0.0010286}, {1660,0.0010000}, {1670,0.0010000}, {1680,0.0010571}, {1690,0.0010000}, {1700,0.0010286}, {1710,0.0010000}, {1720,0.0011143}, {1730,0.0010571}, {1740,0.0010857}, {1750,0.0011143}, {1760,0.0011714}, {1770,0.0013429}, {1780,0.0011714}, {1790,0.0013714}, {1800,0.0014571}, {1810,0.0013143}, {1820,0.0014286}, {1830,0.0015714}, {1840,0.0016857}, {1850,0.0018286}, {1860,0.0017714}, {1870,0.0019429}, {1880,0.0019429}, {1890,0.0020000}, {1900,0.0019714}, {1910,0.0019714}, {1920,0.0020000}, {1930,0.0020000}, {1940,0.0020000}, {1950,0.0020000}, {1960,0.0020000}, {1970,0.0020000}, {1980,0.0020000}, {1990,0.0020000}, {2000,0.0020000}};
data["big"]["LtacTCExplicitCtx"]["eval lazy"]["user"] = {{1,0.00000000}, {2,0.00003960}, {3,0.00003960}, {4,0.00000000}, {5,0.00003960}, {6,0.00000000}, {7,0.00007921}, {8,0.00007921}, {9,0.00003960}, {10,0.00003960}, {11,0.00010891}, {12,0.00007921}, {13,0.00018812}, {14,0.00000000}, {15,0.00007921}, {16,0.00011881}, {17,0.00007921}, {18,0.00000000}, {19,0.00011881}, {20,0.00007921}, {21,0.00011881}, {22,0.00007921}, {23,0.00003960}, {24,0.00011881}, {25,0.00014851}, {26,0.00003960}, {27,0.00011881}, {28,0.00003960}, {29,0.00006931}, {30,0.00003960}, {31,0.00003960}, {32,0.00003960}, {33,0.00003960}, {34,0.00007921}, {35,0.00014851}, {36,0.00015842}, {37,0.00011881}, {38,0.00003960}, {39,0.00006931}, {40,0.00002970}, {41,0.00003960}, {42,0.00011881}, {43,0.00003960}, {44,0.00003960}, {45,0.00006931}, {46,0.00010891}, {47,0.00003960}, {48,0.00011881}, {49,0.00000000}, {50,0.00011881}, {51,0.00010891}, {52,0.00003960}, {53,0.00015842}, {54,0.00014851}, {55,0.00007921}, {56,0.00006931}, {57,0.00003960}, {58,0.00019802}, {59,0.00027723}, {60,0.00015842}, {61,0.00015842}, {62,0.00003960}, {63,0.00015842}, {64,0.00014851}, {65,0.00007921}, {66,0.00011881}, {67,0.00011881}, {68,0.00014851}, {69,0.00010891}, {70,0.00014851}, {71,0.00019802}, {72,0.00006931}, {73,0.00019802}, {74,0.00011881}, {75,0.00010891}, {76,0.00014851}, {77,0.00014851}, {78,0.00010891}, {79,0.00007921}, {80,0.00011881}, {81,0.00010891}, {82,0.00015842}, {83,0.00015842}, {84,0.00015842}, {85,0.00011881}, {86,0.00006931}, {87,0.00007921}, {88,0.00019802}, {89,0.00007921}, {90,0.00011881}, {91,0.00022772}, {92,0.00007921}, {93,0.00026733}, {94,0.00006931}, {95,0.00019802}, {96,0.00014851}, {97,0.00018812}, {98,0.00011881}, {99,0.00019802}, {100,0.00011881}, {101,0.00010891}, {102,0.00019802}, {103,0.00025743}, {104,0.00026733}, {105,0.00014851}, {106,0.00017822}, {107,0.00014851}, {108,0.00006931}, {109,0.00019802}, {110,0.00027723}, {111,0.00007921}, {112,0.00010891}, {113,0.00011881}, {114,0.00018812}, {115,0.00011881}, {116,0.00007921}, {117,0.00017822}, {118,0.00007921}, {119,0.00010891}, {120,0.00006931}, {121,0.00015842}, {122,0.00015842}, {123,0.00026733}, {124,0.00018812}, {125,0.00011881}, {126,0.00022772}, {127,0.00007921}, {128,0.00007921}, {129,0.00011881}, {130,0.00047525}, {131,0.00017822}, {132,0.00007921}, {133,0.00002970}, {134,0.00007921}, {135,0.00003960}, {136,0.00023762}, {137,0.00009901}, {138,0.00003960}, {139,0.00010891}, {140,0.00015842}, {141,0.00025743}, {142,0.00019802}, {143,0.00020792}, {144,0.00021782}, {145,0.00015842}, {146,0.00017822}, {147,0.00007921}, {148,0.00024752}, {149,0.00026733}, {150,0.00010891}, {151,0.00030693}, {152,0.00014851}, {153,0.00026733}, {154,0.00014851}, {155,0.00026733}, {156,0.00029703}, {157,0.00019802}, {158,0.00021782}, {159,0.00007921}, {160,0.00018812}, {161,0.00023762}, {162,0.00003960}, {163,0.00019802}, {164,0.00006931}, {165,0.00017822}, {166,0.00015842}, {167,0.00014851}, {168,0.00025743}, {169,0.00022772}, {170,0.00034653}, {171,0.00022772}, {172,0.00022772}, {173,0.00023762}, {174,0.00030693}, {175,0.00040594}, {176,0.00021782}, {177,0.00027723}, {178,0.00025743}, {179,0.00022772}, {180,0.00013861}, {181,0.00022772}, {182,0.00036634}, {183,0.00006931}, {184,0.00033663}, {185,0.00034653}, {186,0.00015842}, {187,0.00003960}, {188,0.00007921}, {189,0.00022772}, {190,0.00019802}, {191,0.00042574}, {192,0.00020792}, {193,0.00022772}, {194,0.00031683}, {195,0.00034653}, {196,0.00026733}, {197,0.00018812}, {198,0.00026733}, {199,0.00033663}, {200,0.00030693}, {201,0.00018812}, {202,0.00007921}, {203,0.00030693}, {204,0.00023762}, {205,0.00027723}, {206,0.00035644}, {207,0.00035644}, {208,0.00019802}, {209,0.00021782}, {210,0.00022772}, {211,0.00014851}, {212,0.00015842}, {213,0.00023762}, {214,0.00014851}, {215,0.00015842}, {216,0.00014851}, {217,0.00034653}, {218,0.00033663}, {219,0.00021782}, {220,0.00022772}, {221,0.00023762}, {222,0.00019802}, {223,0.00034653}, {224,0.00018812}, {225,0.00026733}, {226,0.00031683}, {227,0.00026733}, {228,0.00019802}, {229,0.00038614}, {230,0.00018812}, {231,0.00034653}, {232,0.00018812}, {233,0.00026733}, {234,0.00035644}, {235,0.00022772}, {236,0.00027723}, {237,0.00022772}, {238,0.00027723}, {239,0.00018812}, {240,0.00025743}, {241,0.00042574}, {242,0.00022772}, {243,0.00035644}, {244,0.00016832}, {245,0.00022772}, {246,0.00059406}, {247,0.00019802}, {248,0.00035644}, {249,0.00014851}, {250,0.00023762}, {251,0.00032673}, {252,0.00029703}, {253,0.00026733}, {254,0.00037624}, {255,0.00048515}, {256,0.00017822}, {257,0.00021782}, {258,0.00021782}, {259,0.00044554}, {260,0.00028713}, {261,0.00017822}, {262,0.00039604}, {263,0.00029703}, {264,0.00020792}, {265,0.00006931}, {266,0.00024752}, {267,0.00022772}, {268,0.00038614}, {269,0.00031683}, {270,0.00047525}, {271,0.00029703}, {272,0.00030693}, {273,0.00028713}, {274,0.00018812}, {275,0.00037624}, {276,0.00024752}, {277,0.00034653}, {278,0.00025743}, {279,0.00050495}, {280,0.00030693}, {281,0.00041584}, {282,0.00023762}, {283,0.00012871}, {284,0.00034653}, {285,0.00043564}, {286,0.00015842}, {287,0.00034653}, {288,0.00036634}, {289,0.00038614}, {290,0.00043564}, {291,0.00036634}, {292,0.00033663}, {293,0.00036634}, {294,0.00044554}, {295,0.00038614}, {296,0.00037624}, {297,0.00023762}, {298,0.00031683}, {299,0.00016832}, {300,0.00045545}, {301,0.0004857}, {302,0.0004286}, {303,0.0002000}, {304,0.0000857}, {305,0.0002571}, {306,0.0000857}, {307,0.0001714}, {308,0.0003429}, {309,0.0006000}, {310,0.0003714}, {311,0.0002571}, {312,0.0001714}, {313,0.0001714}, {314,0.0000857}, {315,0.0006571}, {316,0.0004571}, {317,0.0006286}, {318,0.0002571}, {319,0.0001714}, {320,0.0004571}, {321,0.0004857}, {322,0.0004000}, {323,0.0005143}, {324,0.0004571}, {325,0.0003429}, {326,0.0006000}, {327,0.0001714}, {328,0.0001714}, {329,0.0003714}, {330,0.0004857}, {331,0.0001714}, {332,0.0003714}, {333,0.0024000}, {334,0.0001714}, {335,0.0002857}, {336,0.0002000}, {337,0.0004000}, {338,0.0002571}, {339,0.0002000}, {340,0.0002571}, {341,0.0004571}, {342,0.0002000}, {343,0.0004286}, {344,0.0004571}, {345,0.0002857}, {346,0.0003714}, {347,0.0004571}, {348,0.0004000}, {349,0.0003143}, {350,0.0002000}, {351,0.0004857}, {352,0.0001714}, {353,0.0005429}, {354,0.0003429}, {355,0.0004000}, {356,0.0002571}, {357,0.0001714}, {358,0.0000857}, {359,0.0000857}, {360,0.0003143}, {361,0.0003429}, {362,0.0003143}, {363,0.0007143}, {364,0.0001714}, {365,0.0004857}, {366,0.0002857}, {367,0.0003714}, {368,0.0000857}, {369,0.0004000}, {370,0.0005143}, {371,0.0002571}, {372,0.0004000}, {373,0.0002857}, {374,0.0003714}, {375,0.0006857}, {376,0.0006000}, {377,0.0002000}, {378,0.0001714}, {379,0.0002571}, {380,0.0002571}, {381,0.0002000}, {382,0.0001714}, {383,0.0004571}, {384,0.0004571}, {385,0.0006286}, {386,0.0002571}, {387,0.0004571}, {388,0.0007429}, {389,0.0005143}, {390,0.0005143}, {391,0.0001714}, {392,0.0007143}, {393,0.0004286}, {394,0.0003714}, {395,0.0005143}, {396,0.0004286}, {397,0.0003714}, {398,0.0004571}, {399,0.0001714}, {400,0.0002857}, {401,0.0002571}, {402,0.0003143}, {403,0.0001143}, {404,0.0002286}, {405,0.0006857}, {406,0.0002857}, {407,0.0006000}, {408,0.0003429}, {409,0.0000857}, {410,0.0003714}, {411,0.0006286}, {412,0.0001714}, {413,0.0004571}, {414,0.0002000}, {415,0.0004571}, {416,0.0005429}, {417,0.0003714}, {418,0.0004286}, {419,0.0003429}, {420,0.0003429}, {421,0.0002000}, {422,0.0002571}, {423,0.0000857}, {424,0.0001714}, {425,0.0004286}, {426,0.0002857}, {427,0.0004571}, {428,0.0008000}, {429,0.0003714}, {430,0.0001714}, {431,0.0003714}, {432,0.0004000}, {433,0.0002000}, {434,0.0006286}, {435,0.0000857}, {436,0.0003429}, {437,0.0000857}, {438,0.0005714}, {439,0.0004286}, {440,0.0003429}, {441,0.0004571}, {442,0.0002571}, {443,0.0006000}, {444,0.0007714}, {445,0.0006571}, {446,0.0002857}, {447,0.0003429}, {448,0.0005429}, {449,0.0004286}, {450,0.0004857}, {451,0.0005714}, {452,0.0004571}, {453,0.0004571}, {454,0.0004857}, {455,0.0006857}, {456,0.0004857}, {457,0.0006857}, {458,0.0009143}, {459,0.0007143}, {460,0.0005429}, {461,0.0006000}, {462,0.0002000}, {463,0.0006286}, {464,0.0003714}, {465,0.0007429}, {466,0.0002857}, {467,0.0004571}, {468,0.0004571}, {469,0.0006286}, {470,0.0001714}, {471,0.0002571}, {472,0.0000857}, {473,0.0006857}, {474,0.0004571}, {475,0.0003143}, {476,0.0001714}, {477,0.0006000}, {478,0.0004286}, {479,0.0003429}, {480,0.0006571}, {481,0.0003714}, {482,0.0007143}, {483,0.0003429}, {484,0.0006000}, {485,0.0006857}, {486,0.0004286}, {487,0.0007143}, {488,0.0004286}, {489,0.0002571}, {490,0.0005143}, {491,0.0003429}, {492,0.0019143}, {493,0.0002000}, {494,0.0001714}, {495,0.0005143}, {496,0.0004286}, {497,0.0003429}, {498,0.0003429}, {499,0.0010571}, {500,0.0004571}, {505,0.0006571}, {510,0.0004286}, {515,0.0002571}, {520,0.0002571}, {525,0.0004286}, {530,0.0005143}, {535,0.0005143}, {540,0.0005143}, {545,0.0002571}, {550,0.0004286}, {555,0.0003714}, {560,0.0003429}, {565,0.0001714}, {570,0.0006286}, {575,0.0006286}, {580,0.0004286}, {585,0.0004571}, {590,0.0002857}, {595,0.0005143}, {600,0.0003429}, {605,0.0006000}, {610,0.0006857}, {615,0.0021714}, {620,0.0004571}, {625,0.0006857}, {630,0.0008286}, {635,0.0006571}, {640,0.0007143}, {645,0.0003429}, {650,0.0006000}, {655,0.0006286}, {660,0.0007143}, {665,0.0006000}, {670,0.0005429}, {675,0.0004286}, {680,0.0002571}, {685,0.0008000}, {690,0.0006000}, {695,0.0004571}, {700,0.0005143}, {705,0.0010857}, {710,0.0006286}, {715,0.0005143}, {720,0.0006857}, {725,0.0005429}, {730,0.0004286}, {735,0.0003714}, {740,0.0004571}, {745,0.0004571}, {750,0.0008571}, {755,0.0008571}, {760,0.0008286}, {765,0.0005429}, {770,0.0004571}, {775,0.0008000}, {780,0.0006286}, {785,0.0008857}, {790,0.0007429}, {795,0.0006857}, {800,0.0005429}, {805,0.0003429}, {810,0.0030286}, {815,0.0002571}, {820,0.0008857}, {825,0.0008857}, {830,0.0011143}, {835,0.0006857}, {840,0.0006571}, {845,0.0006286}, {850,0.0009143}, {855,0.0002571}, {860,0.0012000}, {865,0.0008000}, {870,0.0008857}, {875,0.0005714}, {880,0.0004286}, {885,0.0007714}, {890,0.0007143}, {895,0.0005143}, {900,0.0006857}, {905,0.0011714}, {910,0.0008571}, {915,0.0009429}, {920,0.0008571}, {925,0.0005143}, {930,0.0008000}, {935,0.0005429}, {940,0.0006857}, {945,0.0007714}, {950,0.0008000}, {955,0.0007714}, {960,0.0008000}, {965,0.0011143}, {970,0.0006000}, {975,0.0010000}, {980,0.0008000}, {985,0.0009429}, {990,0.0009714}, {995,0.0015714}, {1000,0.0014286}, {1010,0.0012571}, {1020,0.0008000}, {1030,0.0008286}, {1040,0.0502857}, {1050,0.0010571}, {1060,0.0012571}, {1070,0.0011714}, {1080,0.0012286}, {1090,0.0007714}, {1100,0.0009714}, {1110,0.0013143}, {1120,0.0008571}, {1130,0.0007143}, {1140,0.0008000}, {1150,0.0009714}, {1160,0.0008857}, {1170,0.0022000}, {1180,0.0010571}, {1190,0.0012286}, {1200,0.0010286}, {1210,0.0015714}, {1220,0.0008286}, {1230,0.0017429}, {1240,0.0016286}, {1250,0.0014000}, {1260,0.0013143}, {1270,0.0008286}, {1280,0.0009429}, {1290,0.0018000}, {1300,0.0017143}, {1310,0.0012857}, {1320,0.0012000}, {1330,0.0012571}, {1340,0.0012571}, {1350,0.0009714}, {1360,0.0011429}, {1370,0.0016571}, {1380,0.0015143}, {1390,0.0010571}, {1400,0.0017143}, {1410,0.0013143}, {1420,0.0012000}, {1430,0.0016000}, {1440,0.0014857}, {1450,0.0009714}, {1460,0.0012286}, {1470,0.0016000}, {1480,0.0015714}, {1490,0.0017714}, {1500,0.0023714}, {1510,0.0017143}, {1520,0.0013143}, {1530,0.0012571}, {1540,0.0011429}, {1550,0.0020000}, {1560,0.0013714}, {1570,0.0021714}, {1580,0.0010571}, {1590,0.0015714}, {1600,0.0013429}, {1610,0.0016857}, {1620,0.0018286}, {1630,0.0016857}, {1640,0.0018286}, {1650,0.0016571}, {1660,0.0017143}, {1670,0.0018000}, {1680,0.0013143}, {1690,0.0016571}, {1700,0.0016286}, {1710,0.0017429}, {1720,0.0020857}, {1730,0.0017429}, {1740,0.0019143}, {1750,0.0016857}, {1760,0.0020000}, {1770,0.0022857}, {1780,0.0015143}, {1790,0.0020571}, {1800,0.0015714}, {1810,0.0020571}, {1820,0.0014000}, {1830,0.0012000}, {1840,0.0023143}, {1850,0.0022286}, {1860,0.0015429}, {1870,0.0018571}, {1880,0.0016857}, {1890,0.0021143}, {1900,0.0018857}, {1910,0.0027429}, {1920,0.0019143}, {1930,0.0019429}, {1940,0.0010000}, {1950,0.0016286}, {1960,0.0019429}, {1970,0.0026571}, {1980,0.0023143}, {1990,0.0019429}, {2000,0.0023714}};
data["big"]["LtacTCExplicitCtx"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00003960}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00003960}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00003960}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00003960}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00003960}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00003960}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0001143}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0001143}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0001143}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0001143}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0001143}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0001143}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0001143}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0001143}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000857}, {1350,0.0000857}, {1360,0.0000857}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0001143}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000857}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000857}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000857}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCExplicitCtx"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0023143}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000286}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0001714}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000571}, {1250,0.0000000}, {1260,0.0000857}, {1270,0.0000000}, {1280,0.0000286}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000571}, {1330,0.0000000}, {1340,0.0000571}, {1350,0.0000286}, {1360,0.0000000}, {1370,0.0000286}, {1380,0.0000571}, {1390,0.0000571}, {1400,0.0002000}, {1410,0.0000571}, {1420,0.0001429}, {1430,0.0002000}, {1440,0.0003143}, {1450,0.0002857}, {1460,0.0002000}, {1470,0.0002000}, {1480,0.0001714}, {1490,0.0007429}, {1500,0.0002286}, {1510,0.0002857}, {1520,0.0002000}, {1530,0.0002286}, {1540,0.0007429}, {1550,0.0003143}, {1560,0.0003143}, {1570,0.0003429}, {1580,0.0005429}, {1590,0.0003429}, {1600,0.0007143}, {1610,0.0006857}, {1620,0.0009429}, {1630,0.0009714}, {1640,0.0010000}, {1650,0.0010000}, {1660,0.0010000}, {1670,0.0010000}, {1680,0.0010000}, {1690,0.0010000}, {1700,0.0010000}, {1710,0.0010000}, {1720,0.0034000}, {1730,0.0010000}, {1740,0.0010000}, {1750,0.0010000}, {1760,0.0010000}, {1770,0.0010000}, {1780,0.0010000}, {1790,0.0010000}, {1800,0.0010000}, {1810,0.0010000}, {1820,0.0010000}, {1830,0.0010000}, {1840,0.0010000}, {1850,0.0010000}, {1860,0.0010000}, {1870,0.0010000}, {1880,0.0010000}, {1890,0.0010000}, {1900,0.0010000}, {1910,0.0010000}, {1920,0.0070857}, {1930,0.0010000}, {1940,0.0010000}, {1950,0.0010000}, {1960,0.0010000}, {1970,0.0010000}, {1980,0.0010000}, {1990,0.0010000}, {2000,0.0010000}};
data["big"]["LtacTCExplicitCtx"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00006931}, {8,0.00003960}, {9,0.00003960}, {10,0.00000000}, {11,0.00003960}, {12,0.00003960}, {13,0.00002970}, {14,0.00000000}, {15,0.00000000}, {16,0.00003960}, {17,0.00002970}, {18,0.00003960}, {19,0.00003960}, {20,0.00003960}, {21,0.00000000}, {22,0.00000000}, {23,0.00007921}, {24,0.00003960}, {25,0.00003960}, {26,0.00000000}, {27,0.00007921}, {28,0.00011881}, {29,0.00003960}, {30,0.00000000}, {31,0.00007921}, {32,0.00000000}, {33,0.00003960}, {34,0.00003960}, {35,0.00003960}, {36,0.00000000}, {37,0.00010891}, {38,0.00000000}, {39,0.00000000}, {40,0.00003960}, {41,0.00003960}, {42,0.00003960}, {43,0.00007921}, {44,0.00007921}, {45,0.00007921}, {46,0.00000000}, {47,0.00000000}, {48,0.00007921}, {49,0.00006931}, {50,0.00003960}, {51,0.00000000}, {52,0.00007921}, {53,0.00000000}, {54,0.00003960}, {55,0.00007921}, {56,0.00018812}, {57,0.00000000}, {58,0.00003960}, {59,0.00000000}, {60,0.00003960}, {61,0.00000000}, {62,0.00006931}, {63,0.00003960}, {64,0.00006931}, {65,0.00007921}, {66,0.00007921}, {67,0.00007921}, {68,0.00007921}, {69,0.00011881}, {70,0.00003960}, {71,0.00007921}, {72,0.00000000}, {73,0.00003960}, {74,0.00007921}, {75,0.00003960}, {76,0.00007921}, {77,0.00000000}, {78,0.00019802}, {79,0.00011881}, {80,0.00000000}, {81,0.00002970}, {82,0.00003960}, {83,0.00003960}, {84,0.00003960}, {85,0.00003960}, {86,0.00000000}, {87,0.00003960}, {88,0.00011881}, {89,0.00007921}, {90,0.00007921}, {91,0.00003960}, {92,0.00011881}, {93,0.00007921}, {94,0.00000000}, {95,0.00003960}, {96,0.00003960}, {97,0.00010891}, {98,0.00014851}, {99,0.00007921}, {100,0.00019802}, {101,0.00006931}, {102,0.00011881}, {103,0.00000000}, {104,0.00003960}, {105,0.00014851}, {106,0.00007921}, {107,0.00011881}, {108,0.00003960}, {109,0.00007921}, {110,0.00007921}, {111,0.00022772}, {112,0.00003960}, {113,0.00011881}, {114,0.00011881}, {115,0.00011881}, {116,0.00010891}, {117,0.00002970}, {118,0.00011881}, {119,0.00006931}, {120,0.00022772}, {121,0.00015842}, {122,0.00000000}, {123,0.00003960}, {124,0.00021782}, {125,0.00011881}, {126,0.00007921}, {127,0.00011881}, {128,0.00006931}, {129,0.00003960}, {130,0.00021782}, {131,0.00003960}, {132,0.00010891}, {133,0.00003960}, {134,0.00003960}, {135,0.00007921}, {136,0.00011881}, {137,0.00006931}, {138,0.00003960}, {139,0.00000000}, {140,0.00007921}, {141,0.00000000}, {142,0.00021782}, {143,0.00007921}, {144,0.00007921}, {145,0.00007921}, {146,0.00000000}, {147,0.00007921}, {148,0.00015842}, {149,0.00007921}, {150,0.00007921}, {151,0.00029703}, {152,0.00010891}, {153,0.00006931}, {154,0.00007921}, {155,0.00020792}, {156,0.00014851}, {157,0.00015842}, {158,0.00015842}, {159,0.00011881}, {160,0.00019802}, {161,0.00011881}, {162,0.00006931}, {163,0.00013861}, {164,0.00027723}, {165,0.00014851}, {166,0.00022772}, {167,0.00023762}, {168,0.00007921}, {169,0.00009901}, {170,0.00011881}, {171,0.00007921}, {172,0.00009901}, {173,0.00021782}, {174,0.00007921}, {175,0.00019802}, {176,0.00007921}, {177,0.00011881}, {178,0.00018812}, {179,0.00022772}, {180,0.00012871}, {181,0.00000000}, {182,0.00020792}, {183,0.00010891}, {184,0.00007921}, {185,0.00000000}, {186,0.00019802}, {187,0.00014851}, {188,0.00015842}, {189,0.00022772}, {190,0.00014851}, {191,0.00006931}, {192,0.00018812}, {193,0.00019802}, {194,0.00011881}, {195,0.00023762}, {196,0.00025743}, {197,0.00010891}, {198,0.00018812}, {199,0.00007921}, {200,0.00014851}, {201,0.00017822}, {202,0.00015842}, {203,0.00022772}, {204,0.00007921}, {205,0.00022772}, {206,0.00019802}, {207,0.00015842}, {208,0.00022772}, {209,0.00010891}, {210,0.00011881}, {211,0.00038614}, {212,0.00014851}, {213,0.00029703}, {214,0.00011881}, {215,0.00012871}, {216,0.00003960}, {217,0.00019802}, {218,0.00029703}, {219,0.00022772}, {220,0.00015842}, {221,0.00018812}, {222,0.00031683}, {223,0.00026733}, {224,0.00030693}, {225,0.00014851}, {226,0.00006931}, {227,0.00018812}, {228,0.00025743}, {229,0.00029703}, {230,0.00016832}, {231,0.00019802}, {232,0.00027723}, {233,0.00010891}, {234,0.00022772}, {235,0.00010891}, {236,0.00019802}, {237,0.00019802}, {238,0.00011881}, {239,0.00006931}, {240,0.00018812}, {241,0.00024752}, {242,0.00011881}, {243,0.00018812}, {244,0.00011881}, {245,0.00007921}, {246,0.00007921}, {247,0.00013861}, {248,0.00021782}, {249,0.00009901}, {250,0.00019802}, {251,0.00026733}, {252,0.00019802}, {253,0.00010891}, {254,0.00022772}, {255,0.00018812}, {256,0.00016832}, {257,0.00029703}, {258,0.00025743}, {259,0.00026733}, {260,0.00027723}, {261,0.00012871}, {262,0.00013861}, {263,0.00019802}, {264,0.00021782}, {265,0.00010891}, {266,0.00011881}, {267,0.00017822}, {268,0.00028713}, {269,0.00031683}, {270,0.00016832}, {271,0.00007921}, {272,0.00018812}, {273,0.00006931}, {274,0.00018812}, {275,0.00009901}, {276,0.00015842}, {277,0.00028713}, {278,0.00015842}, {279,0.00013861}, {280,0.00011881}, {281,0.00016832}, {282,0.00006931}, {283,0.00022772}, {284,0.00022772}, {285,0.00020792}, {286,0.00022772}, {287,0.00012871}, {288,0.00009901}, {289,0.00013861}, {290,0.00018812}, {291,0.00020792}, {292,0.00019802}, {293,0.00012871}, {294,0.00009901}, {295,0.00013861}, {296,0.00014851}, {297,0.00005941}, {298,0.00016832}, {299,0.00018812}, {300,0.00012871}, {301,0.0000857}, {302,0.0000857}, {303,0.0004000}, {304,0.0003714}, {305,0.0001143}, {306,0.0000857}, {307,0.0004000}, {308,0.0000857}, {309,0.0000857}, {310,0.0001714}, {311,0.0000000}, {312,0.0002000}, {313,0.0002857}, {314,0.0003143}, {315,0.0000857}, {316,0.0002857}, {317,0.0000857}, {318,0.0000000}, {319,0.0002571}, {320,0.0001714}, {321,0.0001714}, {322,0.0002571}, {323,0.0004286}, {324,0.0003714}, {325,0.0004000}, {326,0.0000857}, {327,0.0003429}, {328,0.0000857}, {329,0.0004000}, {330,0.0001714}, {331,0.0001714}, {332,0.0024000}, {333,0.0000857}, {334,0.0002571}, {335,0.0001714}, {336,0.0000857}, {337,0.0000000}, {338,0.0000000}, {339,0.0002286}, {340,0.0000000}, {341,0.0001714}, {342,0.0002286}, {343,0.0000857}, {344,0.0001714}, {345,0.0002000}, {346,0.0000857}, {347,0.0002857}, {348,0.0006286}, {349,0.0001714}, {350,0.0002571}, {351,0.0000857}, {352,0.0002000}, {353,0.0002857}, {354,0.0002857}, {355,0.0001714}, {356,0.0000000}, {357,0.0001143}, {358,0.0004000}, {359,0.0001143}, {360,0.0004857}, {361,0.0004286}, {362,0.0002000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000857}, {366,0.0000000}, {367,0.0001714}, {368,0.0002857}, {369,0.0000857}, {370,0.0003714}, {371,0.0002286}, {372,0.0001714}, {373,0.0004571}, {374,0.0004571}, {375,0.0002000}, {376,0.0002857}, {377,0.0002571}, {378,0.0000857}, {379,0.0001143}, {380,0.0001714}, {381,0.0003714}, {382,0.0003429}, {383,0.0002571}, {384,0.0001714}, {385,0.0000857}, {386,0.0007143}, {387,0.0003714}, {388,0.0004857}, {389,0.0002571}, {390,0.0002857}, {391,0.0001714}, {392,0.0005143}, {393,0.0004857}, {394,0.0001143}, {395,0.0000857}, {396,0.0002000}, {397,0.0002857}, {398,0.0001714}, {399,0.0001714}, {400,0.0002571}, {401,0.0001143}, {402,0.0005714}, {403,0.0004857}, {404,0.0001714}, {405,0.0002571}, {406,0.0001714}, {407,0.0002571}, {408,0.0005714}, {409,0.0002571}, {410,0.0000857}, {411,0.0000857}, {412,0.0001714}, {413,0.0002000}, {414,0.0002000}, {415,0.0004286}, {416,0.0003714}, {417,0.0000857}, {418,0.0002857}, {419,0.0000857}, {420,0.0002000}, {421,0.0008571}, {422,0.0000857}, {423,0.0000000}, {424,0.0000857}, {425,0.0003714}, {426,0.0003429}, {427,0.0002857}, {428,0.0002000}, {429,0.0004857}, {430,0.0003714}, {431,0.0000857}, {432,0.0002571}, {433,0.0004571}, {434,0.0000857}, {435,0.0004286}, {436,0.0002857}, {437,0.0000000}, {438,0.0003429}, {439,0.0003429}, {440,0.0003429}, {441,0.0004857}, {442,0.0002000}, {443,0.0003429}, {444,0.0002571}, {445,0.0001714}, {446,0.0001714}, {447,0.0001143}, {448,0.0005714}, {449,0.0000857}, {450,0.0000857}, {451,0.0002571}, {452,0.0001714}, {453,0.0000000}, {454,0.0002000}, {455,0.0001714}, {456,0.0002000}, {457,0.0002286}, {458,0.0000857}, {459,0.0000857}, {460,0.0001143}, {461,0.0002571}, {462,0.0000857}, {463,0.0002571}, {464,0.0003429}, {465,0.0004857}, {466,0.0000857}, {467,0.0001714}, {468,0.0002857}, {469,0.0001714}, {470,0.0002857}, {471,0.0004857}, {472,0.0004571}, {473,0.0003429}, {474,0.0005429}, {475,0.0000857}, {476,0.0000857}, {477,0.0002857}, {478,0.0002857}, {479,0.0003714}, {480,0.0004571}, {481,0.0001714}, {482,0.0002000}, {483,0.0001714}, {484,0.0001714}, {485,0.0000857}, {486,0.0000000}, {487,0.0003714}, {488,0.0002571}, {489,0.0000857}, {490,0.0001714}, {491,0.0002571}, {492,0.0000857}, {493,0.0005143}, {494,0.0000857}, {495,0.0003429}, {496,0.0003714}, {497,0.0002000}, {498,0.0005143}, {499,0.0000857}, {500,0.0002571}, {505,0.0003429}, {510,0.0004857}, {515,0.0000857}, {520,0.0002571}, {525,0.0002571}, {530,0.0001714}, {535,0.0001714}, {540,0.0002571}, {545,0.0004286}, {550,0.0004286}, {555,0.0002857}, {560,0.0003714}, {565,0.0004286}, {570,0.0001714}, {575,0.0002571}, {580,0.0004286}, {585,0.0005143}, {590,0.0001714}, {595,0.0004571}, {600,0.0006000}, {605,0.0000857}, {610,0.0002571}, {615,0.0004286}, {620,0.0000857}, {625,0.0002571}, {630,0.0004571}, {635,0.0004571}, {640,0.0004286}, {645,0.0004571}, {650,0.0001714}, {655,0.0001714}, {660,0.0006286}, {665,0.0003429}, {670,0.0003429}, {675,0.0004571}, {680,0.0004286}, {685,0.0005714}, {690,0.0006000}, {695,0.0003714}, {700,0.0004571}, {705,0.0000857}, {710,0.0007143}, {715,0.0003429}, {720,0.0007143}, {725,0.0005143}, {730,0.0000857}, {735,0.0005143}, {740,0.0006000}, {745,0.0006000}, {750,0.0005143}, {755,0.0000857}, {760,0.0005143}, {765,0.0004286}, {770,0.0001714}, {775,0.0001143}, {780,0.0003429}, {785,0.0001714}, {790,0.0005714}, {795,0.0002571}, {800,0.0004286}, {805,0.0003714}, {810,0.0003429}, {815,0.0002000}, {820,0.0003429}, {825,0.0002000}, {830,0.0001714}, {835,0.0002571}, {840,0.0003429}, {845,0.0007429}, {850,0.0005429}, {855,0.0006286}, {860,0.0001714}, {865,0.0003714}, {870,0.0005143}, {875,0.0004286}, {880,0.0006857}, {885,0.0006286}, {890,0.0005714}, {895,0.0006571}, {900,0.0005143}, {905,0.0006571}, {910,0.0004286}, {915,0.0003429}, {920,0.0001714}, {925,0.0006000}, {930,0.0003429}, {935,0.0005714}, {940,0.0005143}, {945,0.0009143}, {950,0.0002571}, {955,0.0003714}, {960,0.0004857}, {965,0.0003429}, {970,0.0007429}, {975,0.0006286}, {980,0.0006000}, {985,0.0004857}, {990,0.0009143}, {995,0.0005429}, {1000,0.0008571}, {1010,0.0007714}, {1020,0.0006571}, {1030,0.0004000}, {1040,0.0007714}, {1050,0.0006286}, {1060,0.0008857}, {1070,0.0003143}, {1080,0.0005714}, {1090,0.0006000}, {1100,0.0010000}, {1110,0.0007143}, {1120,0.0009429}, {1130,0.0009429}, {1140,0.0006000}, {1150,0.0012286}, {1160,0.0007143}, {1170,0.0007143}, {1180,0.0010000}, {1190,0.0005143}, {1200,0.0002857}, {1210,0.0006571}, {1220,0.0011714}, {1230,0.0006857}, {1240,0.0009429}, {1250,0.0010000}, {1260,0.0006286}, {1270,0.0006571}, {1280,0.0007429}, {1290,0.0002000}, {1300,0.0006000}, {1310,0.0007714}, {1320,0.0010571}, {1330,0.0010857}, {1340,0.0007429}, {1350,0.0010571}, {1360,0.0008857}, {1370,0.0004000}, {1380,0.0009143}, {1390,0.0010000}, {1400,0.0007429}, {1410,0.0006000}, {1420,0.0013714}, {1430,0.0006286}, {1440,0.0007143}, {1450,0.0009429}, {1460,0.0006000}, {1470,0.0007429}, {1480,0.0005143}, {1490,0.0008571}, {1500,0.0003429}, {1510,0.0008571}, {1520,0.0009143}, {1530,0.0010000}, {1540,0.0012000}, {1550,0.0008857}, {1560,0.0005143}, {1570,0.0005429}, {1580,0.0012857}, {1590,0.0010286}, {1600,0.0012000}, {1610,0.0009714}, {1620,0.0009429}, {1630,0.0009143}, {1640,0.0011143}, {1650,0.0012000}, {1660,0.0009714}, {1670,0.0009429}, {1680,0.0012286}, {1690,0.0011429}, {1700,0.0007143}, {1710,0.0009429}, {1720,0.0037143}, {1730,0.0010857}, {1740,0.0006571}, {1750,0.0015143}, {1760,0.0005429}, {1770,0.0006857}, {1780,0.0014286}, {1790,0.0011143}, {1800,0.0016000}, {1810,0.0009429}, {1820,0.0014286}, {1830,0.0010857}, {1840,0.0010857}, {1850,0.0009429}, {1860,0.0017143}, {1870,0.0014286}, {1880,0.0018571}, {1890,0.0012857}, {1900,0.0016000}, {1910,0.0008571}, {1920,0.0065714}, {1930,0.0011714}, {1940,0.0018857}, {1950,0.0016000}, {1960,0.0014857}, {1970,0.0008571}, {1980,0.0010286}, {1990,0.0013143}, {2000,0.0009714}};
data["big"]["LtacTCExplicitCtx"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00003960}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00003960}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0001143}, {376,0.0001143}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0001143}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0001143}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0001143}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0001143}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0001143}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0001143}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0001143}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0001143}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000857}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0001143}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0001143}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000857}, {1780,0.0000000}, {1790,0.0000857}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000857}, {1920,0.0001143}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCExplicitCtx"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00021782}, {3,0.00100000}, {4,0.00100000}, {5,0.00130693}, {6,0.00200990}, {7,0.00202970}, {8,0.00295050}, {9,0.00300000}, {10,0.00325743}, {11,0.00400000}, {12,0.00412871}, {13,0.00482178}, {14,0.00507921}, {15,0.00580198}, {16,0.00602970}, {17,0.00680198}, {18,0.00705941}, {19,0.00784158}, {20,0.00818812}, {21,0.00894059}, {22,0.00922772}, {23,0.00994059}, {24,0.01055446}, {25,0.01105941}, {26,0.01171287}, {27,0.01237624}, {28,0.01300000}, {29,0.01638614}, {30,0.01431683}, {31,0.01492079}, {32,0.01560396}, {33,0.01624752}, {34,0.01704950}, {35,0.01772277}, {36,0.01840594}, {37,0.01911881}, {38,0.01995050}, {39,0.02071287}, {40,0.02151485}, {41,0.02214851}, {42,0.02304950}, {43,0.02701980}, {44,0.02471287}, {45,0.02545545}, {46,0.03199010}, {47,0.02723762}, {48,0.02810891}, {49,0.02887129}, {50,0.02979208}, {51,0.03059406}, {52,0.03168317}, {53,0.03246535}, {54,0.03836634}, {55,0.03446535}, {56,0.03549505}, {57,0.03634653}, {58,0.04588119}, {59,0.03846535}, {60,0.03944554}, {61,0.04041584}, {62,0.04143564}, {63,0.04241584}, {64,0.04346535}, {65,0.04914851}, {66,0.05110891}, {67,0.04646535}, {68,0.04776238}, {69,0.04900000}, {70,0.05296040}, {71,0.05134653}, {72,0.05851485}, {73,0.05346535}, {74,0.06368317}, {75,0.05548515}, {76,0.05682178}, {77,0.07381188}, {78,0.05936634}, {79,0.06081188}, {80,0.06182178}, {81,0.06326733}, {82,0.06584158}, {83,0.06715842}, {84,0.06672277}, {85,0.06775248}, {86,0.06962376}, {87,0.07094059}, {88,0.07200990}, {89,0.07344554}, {90,0.07523762}, {91,0.07649505}, {92,0.07774257}, {93,0.07887129}, {94,0.08100000}, {95,0.08231683}, {96,0.08345545}, {97,0.08540594}, {98,0.08697030}, {99,0.08795050}, {100,0.08972277}, {101,0.09078218}, {102,0.09244554}, {103,0.09433663}, {104,0.09583168}, {105,0.09736634}, {106,0.09873267}, {107,0.09995050}, {108,0.10173267}, {109,0.10328713}, {110,0.10508911}, {111,0.11378218}, {112,0.11576238}, {113,0.11783168}, {114,0.11995050}, {115,0.12234653}, {116,0.12434653}, {117,0.12683168}, {118,0.12989109}, {119,0.13051485}, {120,0.13430693}, {121,0.13613861}, {122,0.13898020}, {123,0.14286139}, {124,0.14589109}, {125,0.14906931}, {126,0.15144554}, {127,0.15243564}, {128,0.15367327}, {129,0.15618812}, {130,0.15936634}, {131,0.16039604}, {132,0.16138614}, {133,0.16509901}, {134,0.16804950}, {135,0.16758416}, {136,0.17119802}, {137,0.17303960}, {138,0.17560396}, {139,0.17864356}, {140,0.17800990}, {141,0.18331683}, {142,0.18447525}, {143,0.18657426}, {144,0.19028713}, {145,0.19194059}, {146,0.19521782}, {147,0.19819802}, {148,0.19894059}, {149,0.20164356}, {150,0.20389109}, {151,0.20519802}, {152,0.20747525}, {153,0.20788119}, {154,0.21022772}, {155,0.21288119}, {156,0.21757426}, {157,0.21954455}, {158,0.22185149}, {159,0.22224752}, {160,0.22685149}, {161,0.22782178}, {162,0.22920792}, {163,0.23042574}, {164,0.23460396}, {165,0.23465347}, {166,0.23900990}, {167,0.24159406}, {168,0.24058416}, {169,0.24461386}, {170,0.24975248}, {171,0.25175248}, {172,0.25387129}, {173,0.25727723}, {174,0.25924752}, {175,0.26329703}, {176,0.26200000}, {177,0.26430693}, {178,0.26827723}, {179,0.27142574}, {180,0.27552475}, {181,0.27685149}, {182,0.28182178}, {183,0.28333663}, {184,0.28819802}, {185,0.29031683}, {186,0.29177228}, {187,0.29394059}, {188,0.29758416}, {189,0.30016832}, {190,0.30303960}, {191,0.30377228}, {192,0.30603960}, {193,0.30813861}, {194,0.31189109}, {195,0.31080198}, {196,0.31228713}, {197,0.31704950}, {198,0.32658416}, {199,0.33190099}, {200,0.32707921}, {201,0.32756436}, {202,0.33507921}, {203,0.33451485}, {204,0.34309901}, {205,0.35081188}, {206,0.34044554}, {207,0.34733663}, {208,0.34712871}, {209,0.35224752}, {210,0.36773267}, {211,0.35800000}, {212,0.36058416}, {213,0.36272277}, {214,0.37592079}, {215,0.37148515}, {216,0.37061386}, {217,0.38471287}, {218,0.38426733}, {219,0.38197030}, {220,0.39146535}, {221,0.39279208}, {222,0.39523762}, {223,0.40364356}, {224,0.40163366}, {225,0.40346535}, {226,0.41216832}, {227,0.40991089}, {228,0.41496040}, {229,0.41462376}, {230,0.42472277}, {231,0.42296040}, {232,0.42859406}, {233,0.43118812}, {234,0.43261386}, {235,0.43900000}, {236,0.44164356}, {237,0.44256436}, {238,0.45212871}, {239,0.44850495}, {240,0.46221782}, {241,0.45588119}, {242,0.46448515}, {243,0.46728713}, {244,0.46980198}, {245,0.47648515}, {246,0.47887129}, {247,0.47716832}, {248,0.48506931}, {249,0.48437624}, {250,0.48613861}, {251,0.50111881}, {252,0.49500990}, {253,0.49862376}, {254,0.50888119}, {255,0.50684158}, {256,0.50819802}, {257,0.52282178}, {258,0.52682178}, {259,0.52648515}, {260,0.52259406}, {261,0.52956436}, {262,0.53303960}, {263,0.53680198}, {264,0.54625743}, {265,0.54538614}, {266,0.54500990}, {267,0.54812871}, {268,0.55440594}, {269,0.55851485}, {270,0.56269307}, {271,0.56598020}, {272,0.57155446}, {273,0.57727723}, {274,0.58100990}, {275,0.58501980}, {276,0.58439604}, {277,0.58780198}, {278,0.59092079}, {279,0.59671287}, {280,0.60482178}, {281,0.60943564}, {282,0.61187129}, {283,0.61489109}, {284,0.62102970}, {285,0.62261386}, {286,0.62998020}, {287,0.62960396}, {288,0.63557426}, {289,0.63806931}, {290,0.64490099}, {291,0.64816832}, {292,0.65149505}, {293,0.65500990}, {294,0.66098020}, {295,0.66524752}, {296,0.67240594}, {297,0.67809901}, {298,0.67878218}, {299,0.68364356}, {300,0.68965347}, {301,0.7242857}, {302,0.7402571}, {303,0.7956000}, {304,0.7661429}, {305,0.7434857}, {306,0.7674571}, {307,0.7562857}, {308,0.7634000}, {309,0.7743714}, {310,0.7716286}, {311,0.7757429}, {312,0.7844571}, {313,0.7974286}, {314,0.7925143}, {315,0.8006286}, {316,0.8041429}, {317,0.8060857}, {318,0.8116857}, {319,0.8232000}, {320,0.8203143}, {321,0.8448286}, {322,0.8568000}, {323,0.8283429}, {324,0.8359429}, {325,0.8450286}, {326,0.8444571}, {327,0.8544286}, {328,0.8586000}, {329,0.8606571}, {330,0.8677714}, {331,0.8746857}, {332,0.8750571}, {333,0.8782286}, {334,0.8805143}, {335,0.8930857}, {336,0.8945143}, {337,0.9026000}, {338,0.9223143}, {339,0.9134571}, {340,0.9353714}, {341,0.9306000}, {342,0.9331429}, {343,0.9422857}, {344,0.9468000}, {345,0.9536571}, {346,0.9496571}, {347,0.9584571}, {348,0.9632286}, {349,0.9690286}, {350,0.9736857}, {351,0.9898000}, {352,0.9840857}, {353,0.9863143}, {354,0.9934857}, {355,0.9908000}, {356,1.0071143}, {357,1.0079714}, {358,1.0093429}, {359,1.0086286}, {360,1.0245714}, {361,1.0191429}, {362,1.0350286}, {363,1.0405429}, {364,1.0427429}, {365,1.0535714}, {366,1.0462571}, {367,1.0590857}, {368,1.0605714}, {369,1.0690286}, {370,1.0752000}, {371,1.0813714}, {372,1.0916286}, {373,1.0941429}, {374,1.0941429}, {375,1.1080571}, {376,1.1154857}, {377,1.1151714}, {378,1.1214000}, {379,1.1206571}, {380,1.1278857}, {381,1.1387143}, {382,1.1502286}, {383,1.1554000}, {384,1.1654000}, {385,1.1748857}, {386,1.1782286}, {387,1.1844857}, {388,1.1913714}, {389,1.1970571}, {390,1.2065429}, {391,1.2084286}, {392,1.2118286}, {393,1.2266857}, {394,1.2353143}, {395,1.2427714}, {396,1.2395714}, {397,1.2399143}, {398,1.2482857}, {399,1.2579429}, {400,1.2712857}, {401,1.2694571}, {402,1.2782857}, {403,1.2961143}, {404,1.2911143}, {405,1.3066571}, {406,1.3173429}, {407,1.3113714}, {408,1.3297429}, {409,1.3351714}, {410,1.3290000}, {411,1.3375143}, {412,1.3347143}, {413,1.3438000}, {414,1.3491714}, {415,1.3660571}, {416,1.3762000}, {417,1.3824000}, {418,1.3905143}, {419,1.3818000}, {420,1.3936857}, {421,1.4026571}, {422,1.4073429}, {423,1.4179143}, {424,1.4242571}, {425,1.4383429}, {426,1.4516000}, {427,1.4809429}, {428,1.4763429}, {429,1.4736571}, {430,1.4691714}, {431,1.4934000}, {432,1.5094571}, {433,1.5116286}, {434,1.5083714}, {435,1.5132571}, {436,1.5263714}, {437,1.5297143}, {438,1.5446857}, {439,1.5619143}, {440,1.5694000}, {441,1.5623714}, {442,1.5822571}, {443,1.5861143}, {444,1.5768286}, {445,1.5878857}, {446,1.5985143}, {447,1.6053143}, {448,1.6088857}, {449,1.6173714}, {450,1.6225714}, {451,1.6249143}, {452,1.6406286}, {453,1.6482571}, {454,1.6462000}, {455,1.6651429}, {456,1.6677429}, {457,1.6764857}, {458,1.6966286}, {459,1.6975429}, {460,1.7004571}, {461,1.7091429}, {462,1.7124000}, {463,1.7217429}, {464,1.7252571}, {465,1.7372857}, {466,1.7462857}, {467,1.7515143}, {468,1.7657429}, {469,1.7956000}, {470,1.7814571}, {471,1.7830000}, {472,1.7955714}, {473,1.8164286}, {474,1.8752000}, {475,1.8042857}, {476,1.8156286}, {477,1.8485143}, {478,1.8573714}, {479,1.8589143}, {480,1.8408857}, {481,1.9168286}, {482,1.9568571}, {483,1.9024857}, {484,1.9577143}, {485,1.9399429}, {486,1.9738857}, {487,1.9402857}, {488,1.9379143}, {489,1.9436571}, {490,1.9444286}, {491,1.9366571}, {492,1.9575429}, {493,2.0244857}, {494,2.0371714}, {495,1.9979429}, {496,1.9868857}, {497,2.0417143}, {498,2.0386000}, {499,2.0397429}, {500,2.0889429}, {505,2.0934000}, {510,2.1087714}, {515,2.1352286}, {520,2.1822286}, {525,2.2829429}, {530,2.2882000}, {535,2.3065714}, {540,2.4466000}, {545,2.4895714}, {550,2.5341714}, {555,2.5499714}, {560,2.6536000}, {565,2.6510857}, {570,2.6959429}, {575,2.7241143}, {580,2.7772571}, {585,2.8378857}, {590,2.9676000}, {595,2.9746857}, {600,3.0642857}, {605,3.0830286}, {610,3.1749143}, {615,3.2317714}, {620,3.2947429}, {625,3.2848571}, {630,3.3576857}, {635,3.3774571}, {640,3.4129429}, {645,3.4723714}, {650,3.4534857}, {655,3.5359714}, {660,3.5726857}, {665,3.6297429}, {670,3.6406000}, {675,3.7378286}, {680,3.8514286}, {685,3.7849143}, {690,3.9036000}, {695,3.9941429}, {700,4.1106857}, {705,4.0845143}, {710,4.0977429}, {715,4.2009143}, {720,4.2808286}, {725,4.3324000}, {730,4.3829714}, {735,4.4904000}, {740,4.6410286}, {745,4.6925714}, {750,4.8350000}, {755,4.9628000}, {760,5.0242857}, {765,5.1065143}, {770,5.1631143}, {775,5.3048571}, {780,5.4540571}, {785,5.5305143}, {790,5.4926857}, {795,5.5849143}, {800,5.6297429}, {805,5.6672571}, {810,5.9783429}, {815,5.8873143}, {820,6.1693429}, {825,6.3704857}, {830,6.3723714}, {835,6.3848857}, {840,6.3717714}, {845,6.4033714}, {850,6.5138571}, {855,6.5565714}, {860,6.8272286}, {865,6.7246000}, {870,6.8314857}, {875,6.8798286}, {880,7.0879143}, {885,7.0124857}, {890,7.0645714}, {895,7.1520000}, {900,7.3602571}, {905,7.2838857}, {910,7.4276000}, {915,7.5983714}, {920,7.6223429}, {925,7.8246571}, {930,7.8879429}, {935,7.9245143}, {940,7.9241429}, {945,8.0842571}, {950,8.2287429}, {955,8.5093143}, {960,8.3386571}, {965,8.4164571}, {970,8.6487429}, {975,8.6268857}, {980,8.8946286}, {985,8.8172286}, {990,8.9997429}, {995,8.9884857}, {1000,9.0258857}, {1010,9.3231714}, {1020,9.4525143}, {1030,9.6946000}, {1040,10.1343714}, {1050,10.2878286}, {1060,10.5748286}, {1070,10.6540857}, {1080,10.8494857}, {1090,11.3628286}, {1100,11.5072857}, {1110,11.7934286}, {1120,11.8477714}, {1130,12.3040000}, {1140,12.4618286}, {1150,12.5227714}, {1160,12.8869714}, {1170,13.1938857}, {1180,13.4237429}, {1190,13.6606857}, {1200,14.1790857}, {1210,14.2348000}, {1220,14.8587143}, {1230,15.2898571}, {1240,15.7091143}, {1250,15.4802857}, {1260,15.8705429}, {1270,16.3491143}, {1280,16.5329714}, {1290,16.9585143}, {1300,17.1405143}, {1310,17.6101143}, {1320,17.7941714}, {1330,18.0997714}, {1340,18.3501714}, {1350,18.6426286}, {1360,19.2956000}, {1370,19.4524000}, {1380,19.8677143}, {1390,20.0861714}, {1400,20.6085429}, {1410,20.8129143}, {1420,21.4304000}, {1430,22.0801714}, {1440,22.0914857}, {1450,22.0867429}, {1460,23.3680857}, {1470,23.2438857}, {1480,23.4730286}, {1490,24.1756286}, {1500,24.4028571}, {1510,24.7613714}, {1520,25.5633714}, {1530,25.4178571}, {1540,26.3462286}, {1550,26.2150857}, {1560,27.1895429}, {1570,27.2071143}, {1580,28.1201143}, {1590,28.3656000}, {1600,29.0043143}, {1610,29.0764571}, {1620,29.7212286}, {1630,30.2510857}, {1640,30.4598571}, {1650,30.6564000}, {1660,31.4244571}, {1670,31.9414857}, {1680,32.3862857}, {1690,34.0330286}, {1700,33.7003429}, {1710,34.2546000}, {1720,34.8764571}, {1730,35.0119143}, {1740,35.5753714}, {1750,35.9678000}, {1760,36.7553143}, {1770,37.7184857}, {1780,37.1140000}, {1790,38.2405143}, {1800,38.9479714}, {1810,39.6898000}, {1820,39.8525714}, {1830,40.5340286}, {1840,41.1934571}, {1850,41.9741143}, {1860,43.0670000}, {1870,43.3100571}, {1880,44.0215714}, {1890,45.1444857}, {1900,45.0636571}, {1910,45.7781714}, {1920,46.6038000}, {1930,47.1974000}, {1940,46.8877429}, {1950,47.7898857}, {1960,48.8918571}, {1970,49.4348571}, {1980,49.6867429}, {1990,50.2390571}, {2000,51.5492000}};
data["big"]["LtacTCExplicitCtx"]["norm reif"]["user"] = {{1,0.00039604}, {2,0.00076238}, {3,0.00108911}, {4,0.00147525}, {5,0.00181188}, {6,0.00200000}, {7,0.00302970}, {8,0.00263366}, {9,0.00318812}, {10,0.00374257}, {11,0.00415842}, {12,0.00436634}, {13,0.00519802}, {14,0.00551485}, {15,0.00579208}, {16,0.00619802}, {17,0.00706931}, {18,0.00722772}, {19,0.00785149}, {20,0.00807921}, {21,0.00895050}, {22,0.00927723}, {23,0.01000000}, {24,0.01065347}, {25,0.01092079}, {26,0.01160396}, {27,0.01206931}, {28,0.01271287}, {29,0.01611881}, {30,0.01433663}, {31,0.01460396}, {32,0.01528713}, {33,0.01588119}, {34,0.01688119}, {35,0.01752475}, {36,0.01789109}, {37,0.01856436}, {38,0.01953465}, {39,0.02019802}, {40,0.02180198}, {41,0.02205941}, {42,0.02328713}, {43,0.02698020}, {44,0.02506931}, {45,0.02567327}, {46,0.03171287}, {47,0.02756436}, {48,0.02858416}, {49,0.02877228}, {50,0.02997030}, {51,0.03085149}, {52,0.03175248}, {53,0.03279208}, {54,0.03824752}, {55,0.03400000}, {56,0.03522772}, {57,0.03618812}, {58,0.04576238}, {59,0.03833663}, {60,0.03906931}, {61,0.03985149}, {62,0.04088119}, {63,0.04216832}, {64,0.04299010}, {65,0.04941584}, {66,0.05132673}, {67,0.04650495}, {68,0.04804950}, {69,0.04908911}, {70,0.05311881}, {71,0.05154455}, {72,0.05860396}, {73,0.05367327}, {74,0.06338614}, {75,0.05567327}, {76,0.05680198}, {77,0.07336634}, {78,0.05902970}, {79,0.06062376}, {80,0.06183168}, {81,0.06285149}, {82,0.06550495}, {83,0.06662376}, {84,0.06615842}, {85,0.06732673}, {86,0.06948515}, {87,0.07115842}, {88,0.07237624}, {89,0.07374257}, {90,0.07527723}, {91,0.07655446}, {92,0.07813861}, {93,0.07896040}, {94,0.08088119}, {95,0.08224752}, {96,0.08329703}, {97,0.08497030}, {98,0.08651485}, {99,0.08727723}, {100,0.08929703}, {101,0.09019802}, {102,0.09195050}, {103,0.09422772}, {104,0.09625743}, {105,0.09744554}, {106,0.09891089}, {107,0.09988119}, {108,0.10179208}, {109,0.10330693}, {110,0.10487129}, {111,0.11312871}, {112,0.11516832}, {113,0.11744554}, {114,0.11974257}, {115,0.12204950}, {116,0.12437624}, {117,0.12679208}, {118,0.12955446}, {119,0.13041584}, {120,0.13404950}, {121,0.13561386}, {122,0.13853465}, {123,0.14255446}, {124,0.14541584}, {125,0.14875248}, {126,0.15105941}, {127,0.15225743}, {128,0.15337624}, {129,0.15589109}, {130,0.15903960}, {131,0.15983168}, {132,0.16088119}, {133,0.16447525}, {134,0.16790099}, {135,0.16693069}, {136,0.17098020}, {137,0.17242574}, {138,0.17511881}, {139,0.17803960}, {140,0.17771287}, {141,0.18308911}, {142,0.18388119}, {143,0.18597030}, {144,0.18964356}, {145,0.19166337}, {146,0.19483168}, {147,0.19767327}, {148,0.19853465}, {149,0.20102970}, {150,0.20326733}, {151,0.20454455}, {152,0.20658416}, {153,0.20728713}, {154,0.20971287}, {155,0.21232673}, {156,0.21687129}, {157,0.21899010}, {158,0.22130693}, {159,0.22154455}, {160,0.22600990}, {161,0.22734653}, {162,0.22858416}, {163,0.22996040}, {164,0.23361386}, {165,0.23390099}, {166,0.23840594}, {167,0.24081188}, {168,0.24036634}, {169,0.24402970}, {170,0.24909901}, {171,0.25144554}, {172,0.25318812}, {173,0.25636634}, {174,0.25845545}, {175,0.26265347}, {176,0.26138614}, {177,0.26373267}, {178,0.26769307}, {179,0.27085149}, {180,0.27486139}, {181,0.27623762}, {182,0.28144554}, {183,0.28254455}, {184,0.28790099}, {185,0.28966337}, {186,0.29098020}, {187,0.29324752}, {188,0.29671287}, {189,0.29917822}, {190,0.30254455}, {191,0.30295050}, {192,0.30563366}, {193,0.30746535}, {194,0.31130693}, {195,0.31004950}, {196,0.31170297}, {197,0.31607921}, {198,0.32575248}, {199,0.33116832}, {200,0.32617822}, {201,0.32689109}, {202,0.33455446}, {203,0.33374257}, {204,0.34215842}, {205,0.34990099}, {206,0.33961386}, {207,0.34674257}, {208,0.34656436}, {209,0.35163366}, {210,0.36671287}, {211,0.35740594}, {212,0.35956436}, {213,0.36200990}, {214,0.37496040}, {215,0.37069307}, {216,0.36939604}, {217,0.38380198}, {218,0.38396040}, {219,0.38108911}, {220,0.39064356}, {221,0.39208911}, {222,0.39428713}, {223,0.40278218}, {224,0.40063366}, {225,0.40283168}, {226,0.41154455}, {227,0.40902970}, {228,0.41408911}, {229,0.41397030}, {230,0.42403960}, {231,0.42178218}, {232,0.42755446}, {233,0.43009901}, {234,0.43162376}, {235,0.43804950}, {236,0.44042574}, {237,0.44111881}, {238,0.45114851}, {239,0.44767327}, {240,0.46112871}, {241,0.45537624}, {242,0.46361386}, {243,0.46588119}, {244,0.46852475}, {245,0.47527723}, {246,0.47793069}, {247,0.47587129}, {248,0.48380198}, {249,0.48347525}, {250,0.48485149}, {251,0.49989109}, {252,0.49377228}, {253,0.49720792}, {254,0.50777228}, {255,0.50575248}, {256,0.50714851}, {257,0.52180198}, {258,0.52580198}, {259,0.52512871}, {260,0.52170297}, {261,0.52867327}, {262,0.53210891}, {263,0.53609901}, {264,0.54525743}, {265,0.54408911}, {266,0.54366337}, {267,0.54728713}, {268,0.55315842}, {269,0.55740594}, {270,0.56164356}, {271,0.56482178}, {272,0.57013861}, {273,0.57639604}, {274,0.57975248}, {275,0.58437624}, {276,0.58348515}, {277,0.58664356}, {278,0.58987129}, {279,0.59598020}, {280,0.60385149}, {281,0.60863366}, {282,0.61084158}, {283,0.61361386}, {284,0.61975248}, {285,0.62174257}, {286,0.62857426}, {287,0.62844554}, {288,0.63448515}, {289,0.63698020}, {290,0.64389109}, {291,0.64693069}, {292,0.65019802}, {293,0.65372277}, {294,0.65970297}, {295,0.66409901}, {296,0.67110891}, {297,0.67666337}, {298,0.67763366}, {299,0.68247525}, {300,0.68846535}, {301,0.7235143}, {302,0.7337714}, {303,0.7944000}, {304,0.7647429}, {305,0.7422286}, {306,0.7662286}, {307,0.7553714}, {308,0.7627714}, {309,0.7734000}, {310,0.7703429}, {311,0.7744286}, {312,0.7836286}, {313,0.7965143}, {314,0.7916286}, {315,0.8000571}, {316,0.8029143}, {317,0.8049714}, {318,0.8100286}, {319,0.8212571}, {320,0.8188000}, {321,0.8447143}, {322,0.8562571}, {323,0.8268571}, {324,0.8347429}, {325,0.8412000}, {326,0.8441714}, {327,0.8533714}, {328,0.8567714}, {329,0.8578857}, {330,0.8659429}, {331,0.8681143}, {332,0.8736286}, {333,0.8767429}, {334,0.8795143}, {335,0.8892000}, {336,0.8936571}, {337,0.9016000}, {338,0.9211429}, {339,0.9123714}, {340,0.9337429}, {341,0.9293143}, {342,0.9321143}, {343,0.9414857}, {344,0.9450000}, {345,0.9524000}, {346,0.9482000}, {347,0.9573143}, {348,0.9619714}, {349,0.9677429}, {350,0.9723429}, {351,0.9888000}, {352,0.9828000}, {353,0.9854571}, {354,0.9926000}, {355,0.9897429}, {356,1.0066000}, {357,1.0077429}, {358,1.0084857}, {359,1.0074571}, {360,1.0229429}, {361,1.0178857}, {362,1.0336286}, {363,1.0392000}, {364,1.0413714}, {365,1.0519714}, {366,1.0451714}, {367,1.0574857}, {368,1.0594000}, {369,1.0678571}, {370,1.0734571}, {371,1.0800571}, {372,1.0902857}, {373,1.0923429}, {374,1.0924286}, {375,1.1070286}, {376,1.1143143}, {377,1.1135429}, {378,1.1195143}, {379,1.1185714}, {380,1.1257429}, {381,1.1369429}, {382,1.1482857}, {383,1.1531429}, {384,1.1629714}, {385,1.1729143}, {386,1.1755143}, {387,1.1823714}, {388,1.1896286}, {389,1.1950286}, {390,1.2048000}, {391,1.2058000}, {392,1.2100571}, {393,1.2245714}, {394,1.2336286}, {395,1.2411429}, {396,1.2374857}, {397,1.2376286}, {398,1.2460000}, {399,1.2556000}, {400,1.2689143}, {401,1.2676000}, {402,1.2766286}, {403,1.2892286}, {404,1.2892000}, {405,1.3048000}, {406,1.3050571}, {407,1.3088286}, {408,1.3197143}, {409,1.3322286}, {410,1.3266286}, {411,1.3353714}, {412,1.3325714}, {413,1.3414286}, {414,1.3468571}, {415,1.3632000}, {416,1.3739714}, {417,1.3802000}, {418,1.3879143}, {419,1.3798857}, {420,1.3908000}, {421,1.3997714}, {422,1.4048000}, {423,1.4156857}, {424,1.4216571}, {425,1.4355143}, {426,1.4481714}, {427,1.4781143}, {428,1.4738286}, {429,1.4692571}, {430,1.4651429}, {431,1.4904286}, {432,1.5060857}, {433,1.5085429}, {434,1.5058286}, {435,1.5095714}, {436,1.5226000}, {437,1.5264857}, {438,1.5410286}, {439,1.5578286}, {440,1.5655714}, {441,1.5587143}, {442,1.5784857}, {443,1.5829714}, {444,1.5741143}, {445,1.5848857}, {446,1.5946571}, {447,1.6017143}, {448,1.6056286}, {449,1.6143143}, {450,1.6194571}, {451,1.6219429}, {452,1.6382000}, {453,1.6456286}, {454,1.6430286}, {455,1.6619429}, {456,1.6645429}, {457,1.6737143}, {458,1.6942000}, {459,1.6952571}, {460,1.6977429}, {461,1.7064571}, {462,1.7099429}, {463,1.7194571}, {464,1.7232571}, {465,1.7351143}, {466,1.7435143}, {467,1.7488571}, {468,1.7633429}, {469,1.7928571}, {470,1.7786571}, {471,1.7779714}, {472,1.7906857}, {473,1.8128000}, {474,1.8708571}, {475,1.7997714}, {476,1.8120571}, {477,1.8444000}, {478,1.8540286}, {479,1.8557429}, {480,1.8363429}, {481,1.9111143}, {482,1.9506000}, {483,1.8969714}, {484,1.9527714}, {485,1.9352000}, {486,1.9680571}, {487,1.9348000}, {488,1.9315143}, {489,1.9384000}, {490,1.9396857}, {491,1.9321714}, {492,1.9528857}, {493,2.0198857}, {494,2.0318000}, {495,1.9917714}, {496,1.9817143}, {497,2.0367714}, {498,2.0335714}, {499,2.0354286}, {500,2.0841714}, {505,2.0887429}, {510,2.1032571}, {515,2.1297143}, {520,2.1755714}, {525,2.2765143}, {530,2.2816857}, {535,2.3005429}, {540,2.4387714}, {545,2.4810000}, {550,2.5263143}, {555,2.5415143}, {560,2.6453714}, {565,2.6421429}, {570,2.6882857}, {575,2.7165714}, {580,2.7687429}, {585,2.8294286}, {590,2.9602857}, {595,2.9668857}, {600,3.0576857}, {605,3.0759714}, {610,3.1686286}, {615,3.2249429}, {620,3.2874571}, {625,3.2778571}, {630,3.3495429}, {635,3.3690571}, {640,3.4059429}, {645,3.4658286}, {650,3.4496857}, {655,3.5312286}, {660,3.5684286}, {665,3.6238000}, {670,3.6355143}, {675,3.7328571}, {680,3.8464571}, {685,3.7780571}, {690,3.8966571}, {695,3.9886286}, {700,4.1040571}, {705,4.0806286}, {710,4.0932857}, {715,4.1943143}, {720,4.2732000}, {725,4.3242286}, {730,4.3753714}, {735,4.4836857}, {740,4.6338571}, {745,4.6862286}, {750,4.8296286}, {755,4.9557143}, {760,5.0176286}, {765,5.1001143}, {770,5.1558857}, {775,5.2982857}, {780,5.4464857}, {785,5.5238286}, {790,5.4800000}, {795,5.5795714}, {800,5.6152286}, {805,5.6497429}, {810,5.9564000}, {815,5.8762571}, {820,6.1588000}, {825,6.3616286}, {830,6.3628857}, {835,6.3700571}, {840,6.3632857}, {845,6.3936286}, {850,6.5055714}, {855,6.5468571}, {860,6.8190857}, {865,6.7152000}, {870,6.8240571}, {875,6.8733714}, {880,7.0836286}, {885,7.0099143}, {890,7.0616286}, {895,7.1450857}, {900,7.3544000}, {905,7.2746286}, {910,7.4133143}, {915,7.5855429}, {920,7.6097714}, {925,7.8121143}, {930,7.8741714}, {935,7.9105714}, {940,7.9094857}, {945,8.0720857}, {950,8.2190571}, {955,8.5022000}, {960,8.3294286}, {965,8.4014000}, {970,8.6347143}, {975,8.6109714}, {980,8.8768571}, {985,8.7987143}, {990,8.9768000}, {995,8.9626571}, {1000,9.0057714}, {1010,9.2904286}, {1020,9.4288000}, {1030,9.6646857}, {1040,10.1103714}, {1050,10.2660000}, {1060,10.5496000}, {1070,10.6385429}, {1080,10.8068286}, {1090,11.3453714}, {1100,11.4895714}, {1110,11.7708571}, {1120,11.8189143}, {1130,12.2836571}, {1140,12.4202286}, {1150,12.4999714}, {1160,12.8644000}, {1170,13.1734857}, {1180,13.3976286}, {1190,13.6404286}, {1200,14.1534857}, {1210,14.2119429}, {1220,14.8320286}, {1230,15.2636571}, {1240,15.6748857}, {1250,15.4420571}, {1260,15.8303143}, {1270,16.3089429}, {1280,16.5011143}, {1290,16.9229429}, {1300,17.1076286}, {1310,17.5787143}, {1320,17.7551714}, {1330,18.0683714}, {1340,18.3182571}, {1350,18.6070857}, {1360,19.2600857}, {1370,19.4189143}, {1380,19.8238000}, {1390,20.0409143}, {1400,20.5770857}, {1410,20.7758857}, {1420,21.3913714}, {1430,22.0355143}, {1440,22.0564857}, {1450,22.0363143}, {1460,23.3185714}, {1470,23.1937143}, {1480,23.4319143}, {1490,24.1363714}, {1500,24.3518571}, {1510,24.7112000}, {1520,25.5053429}, {1530,25.3624286}, {1540,26.3015714}, {1550,26.1664571}, {1560,27.1313143}, {1570,27.1606286}, {1580,28.0643714}, {1590,28.2960857}, {1600,28.9477714}, {1610,29.0199429}, {1620,29.6646286}, {1630,30.1902286}, {1640,30.3986857}, {1650,30.5909429}, {1660,31.3557143}, {1670,31.8799429}, {1680,32.3180286}, {1690,33.9624857}, {1700,33.6272571}, {1710,34.1968286}, {1720,34.8098286}, {1730,34.9360286}, {1740,35.4916571}, {1750,35.8876000}, {1760,36.6822857}, {1770,37.6325143}, {1780,37.0296857}, {1790,38.1652571}, {1800,38.8776286}, {1810,39.6258857}, {1820,39.7763143}, {1830,40.4634286}, {1840,41.1030000}, {1850,41.8875143}, {1860,42.9775143}, {1870,43.1992286}, {1880,43.9334571}, {1890,45.0579143}, {1900,44.9839429}, {1910,45.7127714}, {1920,46.5362571}, {1930,47.1313714}, {1940,46.7954000}, {1950,47.7203714}, {1960,48.5720571}, {1970,49.3752286}, {1980,49.6263714}, {1990,50.1723714}, {2000,51.4922857}};
data["big"]["LtacTCExplicitCtx"]["norm reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00002970}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00003960}, {11,0.00000000}, {12,0.00003960}, {13,0.00000000}, {14,0.00000000}, {15,0.00010891}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00003960}, {20,0.00002970}, {21,0.00007921}, {22,0.00000000}, {23,0.00003960}, {24,0.00011881}, {25,0.00007921}, {26,0.00011881}, {27,0.00003960}, {28,0.00003960}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00015842}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00007921}, {37,0.00000000}, {38,0.00000000}, {39,0.00003960}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00003960}, {44,0.00003960}, {45,0.00000000}, {46,0.00011881}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00006931}, {51,0.00000000}, {52,0.00007921}, {53,0.00010891}, {54,0.00003960}, {55,0.00015842}, {56,0.00000000}, {57,0.00003960}, {58,0.00003960}, {59,0.00003960}, {60,0.00003960}, {61,0.00000000}, {62,0.00003960}, {63,0.00003960}, {64,0.00007921}, {65,0.00000000}, {66,0.00003960}, {67,0.00000000}, {68,0.00000000}, {69,0.00007921}, {70,0.00000000}, {71,0.00003960}, {72,0.00000000}, {73,0.00011881}, {74,0.00003960}, {75,0.00000000}, {76,0.00000000}, {77,0.00007921}, {78,0.00000000}, {79,0.00003960}, {80,0.00003960}, {81,0.00000000}, {82,0.00007921}, {83,0.00007921}, {84,0.00003960}, {85,0.00003960}, {86,0.00003960}, {87,0.00003960}, {88,0.00000000}, {89,0.00000000}, {90,0.00007921}, {91,0.00003960}, {92,0.00003960}, {93,0.00007921}, {94,0.00011881}, {95,0.00007921}, {96,0.00003960}, {97,0.00011881}, {98,0.00007921}, {99,0.00019802}, {100,0.00003960}, {101,0.00003960}, {102,0.00000000}, {103,0.00000000}, {104,0.00003960}, {105,0.00000000}, {106,0.00011881}, {107,0.00000000}, {108,0.00003960}, {109,0.00003960}, {110,0.00000000}, {111,0.00000000}, {112,0.00007921}, {113,0.00003960}, {114,0.00003960}, {115,0.00000000}, {116,0.00006931}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00003960}, {122,0.00000000}, {123,0.00003960}, {124,0.00000000}, {125,0.00003960}, {126,0.00011881}, {127,0.00002970}, {128,0.00003960}, {129,0.00006931}, {130,0.00000000}, {131,0.00003960}, {132,0.00007921}, {133,0.00003960}, {134,0.00000000}, {135,0.00015842}, {136,0.00000000}, {137,0.00007921}, {138,0.00003960}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00003960}, {143,0.00007921}, {144,0.00015842}, {145,0.00003960}, {146,0.00007921}, {147,0.00007921}, {148,0.00000000}, {149,0.00002970}, {150,0.00003960}, {151,0.00007921}, {152,0.00003960}, {153,0.00000000}, {154,0.00000000}, {155,0.00003960}, {156,0.00011881}, {157,0.00000000}, {158,0.00010891}, {159,0.00011881}, {160,0.00011881}, {161,0.00003960}, {162,0.00003960}, {163,0.00003960}, {164,0.00011881}, {165,0.00003960}, {166,0.00003960}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00003960}, {171,0.00000000}, {172,0.00003960}, {173,0.00000000}, {174,0.00003960}, {175,0.00003960}, {176,0.00003960}, {177,0.00015842}, {178,0.00003960}, {179,0.00011881}, {180,0.00000000}, {181,0.00011881}, {182,0.00003960}, {183,0.00003960}, {184,0.00000000}, {185,0.00003960}, {186,0.00007921}, {187,0.00003960}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00007921}, {193,0.00003960}, {194,0.00003960}, {195,0.00003960}, {196,0.00003960}, {197,0.00003960}, {198,0.00000000}, {199,0.00003960}, {200,0.00003960}, {201,0.00003960}, {202,0.00007921}, {203,0.00003960}, {204,0.00003960}, {205,0.00003960}, {206,0.00007921}, {207,0.00003960}, {208,0.00003960}, {209,0.00000000}, {210,0.00003960}, {211,0.00000000}, {212,0.00000000}, {213,0.00003960}, {214,0.00003960}, {215,0.00011881}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00007921}, {220,0.00003960}, {221,0.00003960}, {222,0.00011881}, {223,0.00003960}, {224,0.00003960}, {225,0.00003960}, {226,0.00000000}, {227,0.00007921}, {228,0.00007921}, {229,0.00000000}, {230,0.00007921}, {231,0.00023762}, {232,0.00011881}, {233,0.00007921}, {234,0.00015842}, {235,0.00007921}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00003960}, {240,0.00019802}, {241,0.00007921}, {242,0.00015842}, {243,0.00015842}, {244,0.00011881}, {245,0.00003960}, {246,0.00007921}, {247,0.00011881}, {248,0.00011881}, {249,0.00011881}, {250,0.00023762}, {251,0.00003960}, {252,0.00003960}, {253,0.00019802}, {254,0.00003960}, {255,0.00015842}, {256,0.00000000}, {257,0.00003960}, {258,0.00010891}, {259,0.00026733}, {260,0.00007921}, {261,0.00006931}, {262,0.00019802}, {263,0.00003960}, {264,0.00003960}, {265,0.00007921}, {266,0.00015842}, {267,0.00000000}, {268,0.00007921}, {269,0.00003960}, {270,0.00011881}, {271,0.00003960}, {272,0.00003960}, {273,0.00007921}, {274,0.00003960}, {275,0.00007921}, {276,0.00003960}, {277,0.00010891}, {278,0.00003960}, {279,0.00007921}, {280,0.00000000}, {281,0.00003960}, {282,0.00007921}, {283,0.00000000}, {284,0.00050495}, {285,0.00011881}, {286,0.00003960}, {287,0.00003960}, {288,0.00002970}, {289,0.00011881}, {290,0.00003960}, {291,0.00003960}, {292,0.00011881}, {293,0.00015842}, {294,0.00015842}, {295,0.00003960}, {296,0.00015842}, {297,0.00000000}, {298,0.00003960}, {299,0.00003960}, {300,0.00015842}, {301,0.0005429}, {302,0.0002286}, {303,0.0001143}, {304,0.0003429}, {305,0.0000000}, {306,0.0002286}, {307,0.0000000}, {308,0.0001143}, {309,0.0003429}, {310,0.0000000}, {311,0.0002286}, {312,0.0000000}, {313,0.0001143}, {314,0.0000000}, {315,0.0001143}, {316,0.0002286}, {317,0.0002286}, {318,0.0003429}, {319,0.0001143}, {320,0.0001143}, {321,0.0000000}, {322,0.0000000}, {323,0.0004286}, {324,0.0001143}, {325,0.0001143}, {326,0.0001143}, {327,0.0001143}, {328,0.0002286}, {329,0.0001143}, {330,0.0002286}, {331,0.0001143}, {332,0.0002286}, {333,0.0000000}, {334,0.0001143}, {335,0.0001143}, {336,0.0005714}, {337,0.0003429}, {338,0.0002000}, {339,0.0001143}, {340,0.0002286}, {341,0.0002286}, {342,0.0000000}, {343,0.0000000}, {344,0.0004571}, {345,0.0001143}, {346,0.0001143}, {347,0.0002286}, {348,0.0001143}, {349,0.0000000}, {350,0.0001143}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0001143}, {356,0.0000000}, {357,0.0000000}, {358,0.0001143}, {359,0.0000000}, {360,0.0000000}, {361,0.0001143}, {362,0.0002286}, {363,0.0002286}, {364,0.0004571}, {365,0.0004571}, {366,0.0000000}, {367,0.0001143}, {368,0.0000000}, {369,0.0000000}, {370,0.0003429}, {371,0.0001143}, {372,0.0000000}, {373,0.0002286}, {374,0.0001143}, {375,0.0001143}, {376,0.0001143}, {377,0.0001143}, {378,0.0000000}, {379,0.0003429}, {380,0.0001143}, {381,0.0002286}, {382,0.0000000}, {383,0.0000857}, {384,0.0004571}, {385,0.0004571}, {386,0.0004571}, {387,0.0004571}, {388,0.0001143}, {389,0.0001143}, {390,0.0000000}, {391,0.0002286}, {392,0.0001143}, {393,0.0003429}, {394,0.0001143}, {395,0.0003429}, {396,0.0002000}, {397,0.0001143}, {398,0.0003429}, {399,0.0002286}, {400,0.0001143}, {401,0.0003429}, {402,0.0001143}, {403,0.0002286}, {404,0.0001143}, {405,0.0000000}, {406,0.0000000}, {407,0.0002286}, {408,0.0004571}, {409,0.0003429}, {410,0.0002286}, {411,0.0001143}, {412,0.0002286}, {413,0.0003429}, {414,0.0001143}, {415,0.0003429}, {416,0.0001143}, {417,0.0001143}, {418,0.0003429}, {419,0.0001143}, {420,0.0001143}, {421,0.0001143}, {422,0.0005714}, {423,0.0001143}, {424,0.0001143}, {425,0.0001143}, {426,0.0002286}, {427,0.0003429}, {428,0.0000000}, {429,0.0006857}, {430,0.0001143}, {431,0.0001143}, {432,0.0004571}, {433,0.0001143}, {434,0.0000000}, {435,0.0001143}, {436,0.0003429}, {437,0.0001143}, {438,0.0004571}, {439,0.0002000}, {440,0.0003429}, {441,0.0003429}, {442,0.0002286}, {443,0.0001143}, {444,0.0000857}, {445,0.0002286}, {446,0.0003429}, {447,0.0006857}, {448,0.0001143}, {449,0.0001143}, {450,0.0003429}, {451,0.0002286}, {452,0.0000000}, {453,0.0001143}, {454,0.0005714}, {455,0.0003429}, {456,0.0001143}, {457,0.0002286}, {458,0.0001143}, {459,0.0001143}, {460,0.0002286}, {461,0.0003429}, {462,0.0002286}, {463,0.0002286}, {464,0.0002286}, {465,0.0002000}, {466,0.0004571}, {467,0.0002286}, {468,0.0004571}, {469,0.0005714}, {470,0.0005714}, {471,0.0011143}, {472,0.0011429}, {473,0.0003429}, {474,0.0004571}, {475,0.0012571}, {476,0.0003429}, {477,0.0003429}, {478,0.0006857}, {479,0.0000000}, {480,0.0004571}, {481,0.0012571}, {482,0.0016000}, {483,0.0009143}, {484,0.0005714}, {485,0.0004571}, {486,0.0002286}, {487,0.0007714}, {488,0.0012571}, {489,0.0010286}, {490,0.0009143}, {491,0.0004571}, {492,0.0003429}, {493,0.0002286}, {494,0.0012571}, {495,0.0017143}, {496,0.0011429}, {497,0.0010286}, {498,0.0009143}, {499,0.0002286}, {500,0.0006857}, {505,0.0008000}, {510,0.0008857}, {515,0.0007714}, {520,0.0005714}, {525,0.0010000}, {530,0.0016000}, {535,0.0008000}, {540,0.0008000}, {545,0.0017143}, {550,0.0010286}, {555,0.0012571}, {560,0.0006857}, {565,0.0018286}, {570,0.0013714}, {575,0.0010286}, {580,0.0011429}, {585,0.0012571}, {590,0.0008000}, {595,0.0009143}, {600,0.0004571}, {605,0.0014857}, {610,0.0006857}, {615,0.0008857}, {620,0.0010286}, {625,0.0004571}, {630,0.0014857}, {635,0.0012571}, {640,0.0009143}, {645,0.0012571}, {650,0.0004571}, {655,0.0014857}, {660,0.0012571}, {665,0.0010286}, {670,0.0006857}, {675,0.0008857}, {680,0.0001143}, {685,0.0014857}, {690,0.0012571}, {695,0.0006857}, {700,0.0008857}, {705,0.0008000}, {710,0.0006857}, {715,0.0004571}, {720,0.0014857}, {725,0.0006857}, {730,0.0004571}, {735,0.0004571}, {740,0.0014857}, {745,0.0011429}, {750,0.0010286}, {755,0.0027429}, {760,0.0012286}, {765,0.0019429}, {770,0.0008000}, {775,0.0008000}, {780,0.0004571}, {785,0.0008000}, {790,0.0006571}, {795,0.0011429}, {800,0.0005714}, {805,0.0006857}, {810,0.0012286}, {815,0.0014857}, {820,0.0013429}, {825,0.0005714}, {830,0.0008857}, {835,0.0007429}, {840,0.0006857}, {845,0.0010000}, {850,0.0006857}, {855,0.0018000}, {860,0.0004571}, {865,0.0021714}, {870,0.0024857}, {875,0.0019429}, {880,0.0021429}, {885,0.0008000}, {890,0.0008857}, {895,0.0024000}, {900,0.0021429}, {905,0.0038286}, {910,0.0047429}, {915,0.0021143}, {920,0.0027429}, {925,0.0038857}, {930,0.0040000}, {935,0.0040571}, {940,0.0043143}, {945,0.0041714}, {950,0.0046857}, {955,0.0018571}, {960,0.0021143}, {965,0.0042000}, {970,0.0020286}, {975,0.0035714}, {980,0.0036000}, {985,0.0036571}, {990,0.0048857}, {995,0.0073429}, {1000,0.0022571}, {1010,0.0040857}, {1020,0.0044286}, {1030,0.0074286}, {1040,0.0078857}, {1050,0.0051143}, {1060,0.0098857}, {1070,0.0045143}, {1080,0.0050571}, {1090,0.0064286}, {1100,0.0072286}, {1110,0.0052857}, {1120,0.0094286}, {1130,0.0067429}, {1140,0.0100000}, {1150,0.0088000}, {1160,0.0087429}, {1170,0.0108000}, {1180,0.0086286}, {1190,0.0068857}, {1200,0.0107143}, {1210,0.0076857}, {1220,0.0096857}, {1230,0.0054286}, {1240,0.0098000}, {1250,0.0108286}, {1260,0.0152000}, {1270,0.0153714}, {1280,0.0088286}, {1290,0.0118286}, {1300,0.0126286}, {1310,0.0117714}, {1320,0.0189429}, {1330,0.0153143}, {1340,0.0122286}, {1350,0.0148857}, {1360,0.0128857}, {1370,0.0130857}, {1380,0.0212286}, {1390,0.0200857}, {1400,0.0140286}, {1410,0.0164857}, {1420,0.0179143}, {1430,0.0136286}, {1440,0.0173714}, {1450,0.0218286}, {1460,0.0180000}, {1470,0.0165714}, {1480,0.0187714}, {1490,0.0195143}, {1500,0.0214571}, {1510,0.0205714}, {1520,0.0190571}, {1530,0.0252857}, {1540,0.0222857}, {1550,0.0186857}, {1560,0.0255714}, {1570,0.0221714}, {1580,0.0253143}, {1590,0.0255714}, {1600,0.0246000}, {1610,0.0258571}, {1620,0.0303429}, {1630,0.0267714}, {1640,0.0314571}, {1650,0.0317429}, {1660,0.0262571}, {1670,0.0291143}, {1680,0.0317429}, {1690,0.0293143}, {1700,0.0308857}, {1710,0.0294000}, {1720,0.0323143}, {1730,0.0307714}, {1740,0.0390571}, {1750,0.0389143}, {1760,0.0349714}, {1770,0.0332571}, {1780,0.0378000}, {1790,0.0392286}, {1800,0.0431714}, {1810,0.0461714}, {1820,0.0415429}, {1830,0.0364000}, {1840,0.0380857}, {1850,0.0402571}, {1860,0.0380286}, {1870,0.0458857}, {1880,0.0390286}, {1890,0.0445143}, {1900,0.0427143}, {1910,0.0479143}, {1920,0.0441714}, {1930,0.0391714}, {1940,0.0434571}, {1950,0.0494286}, {1960,0.0416857}, {1970,0.0457714}, {1980,0.0470000}, {1990,0.0424286}, {2000,0.0368571}};
data["big"]["LtacTCExplicitCtx"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCExplicitCtx"]["post"]["user"] = {{1,0.00003960}, {2,0.00011881}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00003960}, {8,0.00000000}, {9,0.00003960}, {10,0.00003960}, {11,0.00003960}, {12,0.00000000}, {13,0.00007921}, {14,0.00007921}, {15,0.00003960}, {16,0.00000000}, {17,0.00000000}, {18,0.00005941}, {19,0.00002970}, {20,0.00000000}, {21,0.00019802}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00003960}, {26,0.00018812}, {27,0.00003960}, {28,0.00007921}, {29,0.00003960}, {30,0.00000000}, {31,0.00000000}, {32,0.00003960}, {33,0.00000000}, {34,0.00000000}, {35,0.00003960}, {36,0.00007921}, {37,0.00000000}, {38,0.00000000}, {39,0.00007921}, {40,0.00003960}, {41,0.00000000}, {42,0.00000000}, {43,0.00003960}, {44,0.00002970}, {45,0.00000000}, {46,0.00014851}, {47,0.00007921}, {48,0.00000000}, {49,0.00003960}, {50,0.00002970}, {51,0.00006931}, {52,0.00000000}, {53,0.00003960}, {54,0.00003960}, {55,0.00003960}, {56,0.00002970}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00003960}, {61,0.00000000}, {62,0.00002970}, {63,0.00003960}, {64,0.00003960}, {65,0.00002970}, {66,0.00007921}, {67,0.00000000}, {68,0.00000000}, {69,0.00007921}, {70,0.00003960}, {71,0.00000000}, {72,0.00000000}, {73,0.00003960}, {74,0.00003960}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00003960}, {80,0.00007921}, {81,0.00002970}, {82,0.00003960}, {83,0.00000000}, {84,0.00003960}, {85,0.00003960}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00007921}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00007921}, {94,0.00003960}, {95,0.00003960}, {96,0.00000000}, {97,0.00000000}, {98,0.00007921}, {99,0.00003960}, {100,0.00000000}, {101,0.00002970}, {102,0.00000000}, {103,0.00000000}, {104,0.00007921}, {105,0.00000000}, {106,0.00006931}, {107,0.00000000}, {108,0.00000000}, {109,0.00007921}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00003960}, {114,0.00003960}, {115,0.00003960}, {116,0.00003960}, {117,0.00000000}, {118,0.00000000}, {119,0.00006931}, {120,0.00000000}, {121,0.00003960}, {122,0.00003960}, {123,0.00000000}, {124,0.00003960}, {125,0.00000000}, {126,0.00007921}, {127,0.00000000}, {128,0.00002970}, {129,0.00002970}, {130,0.00000000}, {131,0.00000000}, {132,0.00007921}, {133,0.00000000}, {134,0.00003960}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00003960}, {140,0.00000000}, {141,0.00000000}, {142,0.00003960}, {143,0.00011881}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00007921}, {148,0.00000000}, {149,0.00003960}, {150,0.00003960}, {151,0.00006931}, {152,0.00000000}, {153,0.00006931}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00007921}, {159,0.00003960}, {160,0.00000000}, {161,0.00000000}, {162,0.00003960}, {163,0.00000000}, {164,0.00007921}, {165,0.00000000}, {166,0.00000000}, {167,0.00003960}, {168,0.00000000}, {169,0.00003960}, {170,0.00003960}, {171,0.00003960}, {172,0.00011881}, {173,0.00003960}, {174,0.00007921}, {175,0.00007921}, {176,0.00003960}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00003960}, {181,0.00002970}, {182,0.00003960}, {183,0.00000000}, {184,0.00006931}, {185,0.00003960}, {186,0.00000000}, {187,0.00003960}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00011881}, {193,0.00003960}, {194,0.00006931}, {195,0.00000000}, {196,0.00003960}, {197,0.00003960}, {198,0.00003960}, {199,0.00010891}, {200,0.00007921}, {201,0.00000000}, {202,0.00000000}, {203,0.00010891}, {204,0.00003960}, {205,0.00003960}, {206,0.00006931}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00011881}, {211,0.00000000}, {212,0.00000000}, {213,0.00006931}, {214,0.00000000}, {215,0.00010891}, {216,0.00003960}, {217,0.00000000}, {218,0.00000000}, {219,0.00010891}, {220,0.00003960}, {221,0.00000000}, {222,0.00006931}, {223,0.00002970}, {224,0.00003960}, {225,0.00007921}, {226,0.00000000}, {227,0.00007921}, {228,0.00007921}, {229,0.00007921}, {230,0.00010891}, {231,0.00003960}, {232,0.00002970}, {233,0.00000000}, {234,0.00002970}, {235,0.00007921}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00003960}, {242,0.00000000}, {243,0.00003960}, {244,0.00000000}, {245,0.00011881}, {246,0.00003960}, {247,0.00007921}, {248,0.00000000}, {249,0.00007921}, {250,0.00002970}, {251,0.00007921}, {252,0.00002970}, {253,0.00000000}, {254,0.00007921}, {255,0.00003960}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00013861}, {260,0.00002970}, {261,0.00002970}, {262,0.00009901}, {263,0.00000000}, {264,0.00006931}, {265,0.00002970}, {266,0.00009901}, {267,0.00000000}, {268,0.00003960}, {269,0.00000000}, {270,0.00006931}, {271,0.00003960}, {272,0.00000000}, {273,0.00000000}, {274,0.00014851}, {275,0.00002970}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003960}, {282,0.00000000}, {283,0.00007921}, {284,0.00005941}, {285,0.00000000}, {286,0.00007921}, {287,0.00006931}, {288,0.00002970}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00002970}, {294,0.00000000}, {295,0.00000000}, {296,0.00006931}, {297,0.00002970}, {298,0.00003960}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000857}, {305,0.0000857}, {306,0.0000000}, {307,0.0000000}, {308,0.0000857}, {309,0.0000000}, {310,0.0000000}, {311,0.0001714}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000857}, {320,0.0001143}, {321,0.0000857}, {322,0.0000000}, {323,0.0000857}, {324,0.0000000}, {325,0.0000857}, {326,0.0000000}, {327,0.0000857}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000857}, {336,0.0000000}, {337,0.0000000}, {338,0.0000857}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000857}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000857}, {351,0.0000857}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000857}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000857}, {360,0.0000000}, {361,0.0000000}, {362,0.0000857}, {363,0.0000000}, {364,0.0000000}, {365,0.0000857}, {366,0.0000000}, {367,0.0000857}, {368,0.0000000}, {369,0.0001714}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0002000}, {374,0.0000000}, {375,0.0001143}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000857}, {387,0.0000000}, {388,0.0000000}, {389,0.0000857}, {390,0.0000000}, {391,0.0002571}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000857}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0001143}, {401,0.0000000}, {402,0.0000000}, {403,0.0000857}, {404,0.0000000}, {405,0.0000857}, {406,0.0000000}, {407,0.0000000}, {408,0.0001143}, {409,0.0000000}, {410,0.0000000}, {411,0.0001143}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000857}, {419,0.0000000}, {420,0.0000857}, {421,0.0000000}, {422,0.0000000}, {423,0.0002000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000857}, {427,0.0000000}, {428,0.0000000}, {429,0.0001143}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0001143}, {446,0.0001143}, {447,0.0000000}, {448,0.0000000}, {449,0.0000857}, {450,0.0001143}, {451,0.0000857}, {452,0.0000857}, {453,0.0000000}, {454,0.0000000}, {455,0.0000857}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000857}, {461,0.0000857}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000857}, {466,0.0000000}, {467,0.0000857}, {468,0.0000857}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000857}, {475,0.0001143}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000857}, {480,0.0000857}, {481,0.0000857}, {482,0.0001714}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0001143}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000857}, {496,0.0000000}, {497,0.0000857}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0001143}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0002571}, {545,0.0000857}, {550,0.0000000}, {555,0.0000000}, {560,0.0000857}, {565,0.0000857}, {570,0.0000857}, {575,0.0000857}, {580,0.0000000}, {585,0.0000000}, {590,0.0000857}, {595,0.0000000}, {600,0.0001714}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0001714}, {630,0.0000857}, {635,0.0000000}, {640,0.0000857}, {645,0.0000857}, {650,0.0000000}, {655,0.0000000}, {660,0.0000857}, {665,0.0000000}, {670,0.0000857}, {675,0.0000000}, {680,0.0000857}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000857}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000857}, {755,0.0000000}, {760,0.0000857}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000857}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0001143}, {815,0.0000000}, {820,0.0000857}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000857}, {860,0.0000000}, {865,0.0000857}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000857}, {890,0.0000857}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000857}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000857}, {940,0.0000857}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000857}, {965,0.0001143}, {970,0.0000857}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0001143}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0001714}, {1080,0.0001143}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0002286}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000857}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000857}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0003143}, {1310,0.0001143}, {1320,0.0000000}, {1330,0.0001143}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0001143}, {1420,0.0000000}, {1430,0.0002000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0001143}, {1470,0.0000000}, {1480,0.0000857}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0001143}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0001143}, {1570,0.0000857}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0001143}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0002000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000857}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0001143}, {2000,0.0000000}};
data["big"]["LtacTCExplicitCtx"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCExplicitCtx"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCExplicitCtx"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00003960}, {6,0.00003960}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00003960}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00003960}, {27,0.00003960}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00006931}, {37,0.00003960}, {38,0.00003960}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00002970}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00003960}, {47,0.00002970}, {48,0.00000000}, {49,0.00000000}, {50,0.00003960}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00002970}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00002970}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00003960}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00003960}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00003960}, {89,0.00000000}, {90,0.00002970}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00003960}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003960}, {105,0.00000000}, {106,0.00000000}, {107,0.00003960}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00003960}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00003960}, {119,0.00003960}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00003960}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00003960}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00003960}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00003960}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00006931}, {161,0.00000000}, {162,0.00002970}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00003960}, {173,0.00000000}, {174,0.00003960}, {175,0.00000000}, {176,0.00006931}, {177,0.00000000}, {178,0.00000000}, {179,0.00003960}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00003960}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00003960}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00002970}, {229,0.00003960}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00003960}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00003960}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00002970}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00003960}, {277,0.00000000}, {278,0.00000000}, {279,0.00002970}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00002970}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000857}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000857}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000857}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0002000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0002286}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0001143}, {439,0.0000000}, {440,0.0000857}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000857}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0001143}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000857}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000857}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000857}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000857}, {775,0.0000857}, {780,0.0000000}, {785,0.0000857}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000857}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000857}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000857}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0001143}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0001143}, {1490,0.0000000}, {1500,0.0001143}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0001143}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCExplicitCtx"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00003960}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCExplicitCtx"]["reif"]["real"] = {{1,0.00000000}, {2,0.00100000}, {3,0.00100000}, {4,0.00100000}, {5,0.00200000}, {6,0.00200990}, {7,0.00213861}, {8,0.00300000}, {9,0.00300000}, {10,0.00336634}, {11,0.00400000}, {12,0.00431683}, {13,0.00500000}, {14,0.00532673}, {15,0.00593069}, {16,0.00621782}, {17,0.00691089}, {18,0.00733663}, {19,0.00793069}, {20,0.00847525}, {21,0.00898020}, {22,0.00938614}, {23,0.00999010}, {24,0.01071287}, {25,0.01124752}, {26,0.01192079}, {27,0.01251485}, {28,0.01302970}, {29,0.01654455}, {30,0.01445545}, {31,0.01502970}, {32,0.01575248}, {33,0.01638614}, {34,0.01713861}, {35,0.01788119}, {36,0.01856436}, {37,0.01931683}, {38,0.02010891}, {39,0.02091089}, {40,0.02165347}, {41,0.02225743}, {42,0.02322772}, {43,0.02720792}, {44,0.02485149}, {45,0.02563366}, {46,0.03212871}, {47,0.02734653}, {48,0.02827723}, {49,0.02900000}, {50,0.02998020}, {51,0.03080198}, {52,0.03184158}, {53,0.03267327}, {54,0.03851485}, {55,0.03459406}, {56,0.03564356}, {57,0.03641584}, {58,0.04602970}, {59,0.03855446}, {60,0.03956436}, {61,0.04055446}, {62,0.04158416}, {63,0.04260396}, {64,0.04361386}, {65,0.04931683}, {66,0.05127723}, {67,0.04665347}, {68,0.04795050}, {69,0.04916832}, {70,0.05311881}, {71,0.05152475}, {72,0.05874257}, {73,0.05366337}, {74,0.06393069}, {75,0.05566337}, {76,0.05702970}, {77,0.07407921}, {78,0.05950495}, {79,0.06101980}, {80,0.06202970}, {81,0.06342574}, {82,0.06602970}, {83,0.06736634}, {84,0.06687129}, {85,0.06799010}, {86,0.06984158}, {87,0.07110891}, {88,0.07220792}, {89,0.07365347}, {90,0.07547525}, {91,0.07670297}, {92,0.07800000}, {93,0.07913861}, {94,0.08120792}, {95,0.08247525}, {96,0.08362376}, {97,0.08563366}, {98,0.08714851}, {99,0.08815842}, {100,0.08997030}, {101,0.09100990}, {102,0.09258416}, {103,0.09454455}, {104,0.09611881}, {105,0.09756436}, {106,0.09899010}, {107,0.10018812}, {108,0.10192079}, {109,0.10353465}, {110,0.10532673}, {111,0.11397030}, {112,0.11592079}, {113,0.11802970}, {114,0.12018812}, {115,0.12251485}, {116,0.12456436}, {117,0.12704950}, {118,0.13000990}, {119,0.13069307}, {120,0.13456436}, {121,0.13635644}, {122,0.13917822}, {123,0.14311881}, {124,0.14613861}, {125,0.14930693}, {126,0.15169307}, {127,0.15264356}, {128,0.15400990}, {129,0.15646535}, {130,0.15963366}, {131,0.16062376}, {132,0.16163366}, {133,0.16528713}, {134,0.16828713}, {135,0.16778218}, {136,0.17137624}, {137,0.17323762}, {138,0.17597030}, {139,0.17883168}, {140,0.17825743}, {141,0.18354455}, {142,0.18462376}, {143,0.18684158}, {144,0.19045545}, {145,0.19216832}, {146,0.19546535}, {147,0.19841584}, {148,0.19919802}, {149,0.20187129}, {150,0.20409901}, {151,0.20538614}, {152,0.20770297}, {153,0.20818812}, {154,0.21045545}, {155,0.21313861}, {156,0.21778218}, {157,0.21984158}, {158,0.22207921}, {159,0.22248515}, {160,0.22706931}, {161,0.22799010}, {162,0.22952475}, {163,0.23064356}, {164,0.23483168}, {165,0.23487129}, {166,0.23919802}, {167,0.24178218}, {168,0.24082178}, {169,0.24482178}, {170,0.24997030}, {171,0.25200000}, {172,0.25410891}, {173,0.25751485}, {174,0.25949505}, {175,0.26349505}, {176,0.26227723}, {177,0.26450495}, {178,0.26846535}, {179,0.27166337}, {180,0.27572277}, {181,0.27716832}, {182,0.28208911}, {183,0.28362376}, {184,0.28848515}, {185,0.29067327}, {186,0.29210891}, {187,0.29423762}, {188,0.29786139}, {189,0.30036634}, {190,0.30326733}, {191,0.30401980}, {192,0.30634653}, {193,0.30841584}, {194,0.31217822}, {195,0.31109901}, {196,0.31256436}, {197,0.31725743}, {198,0.32688119}, {199,0.33219802}, {200,0.32736634}, {201,0.32783168}, {202,0.33538614}, {203,0.33473267}, {204,0.34327723}, {205,0.35109901}, {206,0.34073267}, {207,0.34756436}, {208,0.34741584}, {209,0.35250495}, {210,0.36795050}, {211,0.35829703}, {212,0.36086139}, {213,0.36305941}, {214,0.37618812}, {215,0.37170297}, {216,0.37087129}, {217,0.38502970}, {218,0.38459406}, {219,0.38220792}, {220,0.39183168}, {221,0.39309901}, {222,0.39555446}, {223,0.40397030}, {224,0.40198020}, {225,0.40378218}, {226,0.41248515}, {227,0.41021782}, {228,0.41526733}, {229,0.41490099}, {230,0.42494059}, {231,0.42324752}, {232,0.42889109}, {233,0.43138614}, {234,0.43288119}, {235,0.43935644}, {236,0.44200000}, {237,0.44283168}, {238,0.45247525}, {239,0.44884158}, {240,0.46254455}, {241,0.45623762}, {242,0.46481188}, {243,0.46758416}, {244,0.47014851}, {245,0.47677228}, {246,0.47913861}, {247,0.47747525}, {248,0.48543564}, {249,0.48472277}, {250,0.48647525}, {251,0.50135644}, {252,0.49533663}, {253,0.49893069}, {254,0.50915842}, {255,0.50714851}, {256,0.50851485}, {257,0.52318812}, {258,0.52704950}, {259,0.52684158}, {260,0.52293069}, {261,0.52989109}, {262,0.53339604}, {263,0.53704950}, {264,0.54662376}, {265,0.54567327}, {266,0.54536634}, {267,0.54849505}, {268,0.55477228}, {269,0.55886139}, {270,0.56297030}, {271,0.56630693}, {272,0.57180198}, {273,0.57753465}, {274,0.58131683}, {275,0.58535644}, {276,0.58478218}, {277,0.58809901}, {278,0.59120792}, {279,0.59698020}, {280,0.60517822}, {281,0.60984158}, {282,0.61215842}, {283,0.61517822}, {284,0.62143564}, {285,0.62290099}, {286,0.63033663}, {287,0.62994059}, {288,0.63593069}, {289,0.63839604}, {290,0.64531683}, {291,0.64855446}, {292,0.65171287}, {293,0.65538614}, {294,0.66126733}, {295,0.66555446}, {296,0.67269307}, {297,0.67845545}, {298,0.67909901}, {299,0.68396040}, {300,0.68997030}, {301,0.7246571}, {302,0.7404571}, {303,0.7959429}, {304,0.7664571}, {305,0.7439714}, {306,0.7678000}, {307,0.7568000}, {308,0.7637714}, {309,0.7747143}, {310,0.7719714}, {311,0.7761429}, {312,0.7848286}, {313,0.7976857}, {314,0.7929714}, {315,0.8009714}, {316,0.8043429}, {317,0.8064000}, {318,0.8122857}, {319,0.8236571}, {320,0.8208000}, {321,0.8451143}, {322,0.8570857}, {323,0.8284857}, {324,0.8363143}, {325,0.8454571}, {326,0.8448000}, {327,0.8548000}, {328,0.8589143}, {329,0.8609714}, {330,0.8681429}, {331,0.8751143}, {332,0.8781714}, {333,0.8786571}, {334,0.8808857}, {335,0.8933143}, {336,0.8949143}, {337,0.9030000}, {338,0.9227143}, {339,0.9138857}, {340,0.9356571}, {341,0.9310286}, {342,0.9336000}, {343,0.9427714}, {344,0.9470286}, {345,0.9539143}, {346,0.9500286}, {347,0.9589429}, {348,0.9636571}, {349,0.9694000}, {350,0.9739429}, {351,0.9902000}, {352,0.9844857}, {353,0.9865429}, {354,0.9937429}, {355,0.9910857}, {356,1.0073714}, {357,1.0083714}, {358,1.0096571}, {359,1.0090000}, {360,1.0247714}, {361,1.0194000}, {362,1.0352571}, {363,1.0410286}, {364,1.0430857}, {365,1.0540000}, {366,1.0466000}, {367,1.0593714}, {368,1.0610000}, {369,1.0694571}, {370,1.0755429}, {371,1.0815714}, {372,1.0921429}, {373,1.0945143}, {374,1.0944286}, {375,1.1084000}, {376,1.1158286}, {377,1.1155714}, {378,1.1218857}, {379,1.1210571}, {380,1.1283429}, {381,1.1392000}, {382,1.1507143}, {383,1.1559143}, {384,1.1658857}, {385,1.1752286}, {386,1.1786571}, {387,1.1848857}, {388,1.1918000}, {389,1.1974000}, {390,1.2068571}, {391,1.2088571}, {392,1.2123143}, {393,1.2271429}, {394,1.2356286}, {395,1.2431714}, {396,1.2398571}, {397,1.2402000}, {398,1.2487143}, {399,1.2583429}, {400,1.2715714}, {401,1.2698571}, {402,1.2787143}, {403,1.2965714}, {404,1.2914571}, {405,1.3071714}, {406,1.3178000}, {407,1.3118857}, {408,1.3302286}, {409,1.3355714}, {410,1.3293429}, {411,1.3380000}, {412,1.3350286}, {413,1.3443143}, {414,1.3497714}, {415,1.3664000}, {416,1.3766000}, {417,1.3827143}, {418,1.3908857}, {419,1.3824000}, {420,1.3942286}, {421,1.4030857}, {422,1.4077714}, {423,1.4182857}, {424,1.4246286}, {425,1.4388857}, {426,1.4521143}, {427,1.4815429}, {428,1.4768571}, {429,1.4739714}, {430,1.4696571}, {431,1.4937714}, {432,1.5100286}, {433,1.5121429}, {434,1.5088571}, {435,1.5136857}, {436,1.5268857}, {437,1.5302286}, {438,1.5452286}, {439,1.5623714}, {440,1.5697714}, {441,1.5628000}, {442,1.5826000}, {443,1.5865143}, {444,1.5772857}, {445,1.5883143}, {446,1.5989714}, {447,1.6057143}, {448,1.6093143}, {449,1.6177714}, {450,1.6230000}, {451,1.6252857}, {452,1.6410000}, {453,1.6486286}, {454,1.6466571}, {455,1.6656286}, {456,1.6680857}, {457,1.6769714}, {458,1.6971714}, {459,1.6979714}, {460,1.7009429}, {461,1.7095429}, {462,1.7127714}, {463,1.7222286}, {464,1.7258571}, {465,1.7376857}, {466,1.7465143}, {467,1.7519714}, {468,1.7662571}, {469,1.7959429}, {470,1.7819429}, {471,1.7833714}, {472,1.7960857}, {473,1.8167429}, {474,1.8757143}, {475,1.8049143}, {476,1.8160857}, {477,1.8490000}, {478,1.8578286}, {479,1.8592857}, {480,1.8413429}, {481,1.9172571}, {482,1.9573143}, {483,1.9028857}, {484,1.9582857}, {485,1.9404286}, {486,1.9744571}, {487,1.9408000}, {488,1.9384286}, {489,1.9442000}, {490,1.9448857}, {491,1.9370286}, {492,1.9581429}, {493,2.0250857}, {494,2.0375714}, {495,1.9985714}, {496,1.9874571}, {497,2.0421429}, {498,2.0390857}, {499,2.0402000}, {500,2.0894571}, {505,2.0938286}, {510,2.1091714}, {515,2.1358857}, {520,2.1827143}, {525,2.2834286}, {530,2.2886571}, {535,2.3071714}, {540,2.4470857}, {545,2.4900857}, {550,2.5348571}, {555,2.5504857}, {560,2.6540857}, {565,2.6515714}, {570,2.6963714}, {575,2.7246857}, {580,2.7776286}, {585,2.8383714}, {590,2.9682000}, {595,2.9752286}, {600,3.0648857}, {605,3.0835714}, {610,3.1755714}, {615,3.2324571}, {620,3.2953714}, {625,3.2854571}, {630,3.3584000}, {635,3.3779429}, {640,3.4136286}, {645,3.4729429}, {650,3.4540571}, {655,3.5366000}, {660,3.5734286}, {665,3.6302571}, {670,3.6412571}, {675,3.7384286}, {680,3.8520571}, {685,3.7868857}, {690,3.9043143}, {695,3.9945714}, {700,4.1113429}, {705,4.0850857}, {710,4.0983143}, {715,4.2016286}, {720,4.2814571}, {725,4.3330286}, {730,4.3834857}, {735,4.4908286}, {740,4.6417143}, {745,4.6931714}, {750,4.8355714}, {755,4.9634000}, {760,5.0249429}, {765,5.1072286}, {770,5.1637714}, {775,5.3055429}, {780,5.4546000}, {785,5.5312571}, {790,5.4934571}, {795,5.5855429}, {800,5.6303714}, {805,5.6678571}, {810,5.9788857}, {815,5.8879714}, {820,6.1700000}, {825,6.3710857}, {830,6.3731143}, {835,6.3855714}, {840,6.3725143}, {845,6.4039714}, {850,6.5146000}, {855,6.5572286}, {860,6.8280000}, {865,6.7253714}, {870,6.8322000}, {875,6.8805143}, {880,7.0887143}, {885,7.0132286}, {890,7.0652286}, {895,7.1528857}, {900,7.3609143}, {905,7.2846286}, {910,7.4284286}, {915,7.5991429}, {920,7.6231429}, {925,7.8253714}, {930,7.8886857}, {935,7.9252571}, {940,7.9250286}, {945,8.0850857}, {950,8.2293143}, {955,8.5100571}, {960,8.3394571}, {965,8.4172571}, {970,8.6495714}, {975,8.6278286}, {980,8.8953143}, {985,8.8181714}, {990,9.0006571}, {995,8.9893714}, {1000,9.0267143}, {1010,9.3242000}, {1020,9.4533143}, {1030,9.6955143}, {1040,10.1351714}, {1050,10.2887429}, {1060,10.5756857}, {1070,10.6549429}, {1080,10.8503429}, {1090,11.3636571}, {1100,11.5082286}, {1110,11.7943429}, {1120,11.8487143}, {1130,12.3049143}, {1140,12.4627143}, {1150,12.5236857}, {1160,12.8879429}, {1170,13.1947429}, {1180,13.4246000}, {1190,13.6616571}, {1200,14.1800286}, {1210,14.2357429}, {1220,14.8596571}, {1230,15.2908286}, {1240,15.7101143}, {1250,15.4812857}, {1260,15.8716000}, {1270,16.3500857}, {1280,16.5340000}, {1290,16.9595714}, {1300,17.1415143}, {1310,17.6111143}, {1320,17.7952000}, {1330,18.1008000}, {1340,18.3511714}, {1350,18.6436571}, {1360,19.2965714}, {1370,19.4534857}, {1380,19.8687143}, {1390,20.0871714}, {1400,20.6096000}, {1410,20.8139429}, {1420,21.4314000}, {1430,22.0812286}, {1440,22.0926286}, {1450,22.0878571}, {1460,23.3691714}, {1470,23.2449429}, {1480,23.4740571}, {1490,24.1768000}, {1500,24.4040286}, {1510,24.7625429}, {1520,25.5644286}, {1530,25.4189429}, {1540,26.3474000}, {1550,26.2162000}, {1560,27.1906286}, {1570,27.2081714}, {1580,28.1212286}, {1590,28.3667714}, {1600,29.0054000}, {1610,29.0775429}, {1620,29.7224571}, {1630,30.2522571}, {1640,30.4609714}, {1650,30.6576000}, {1660,31.4257429}, {1670,31.9428000}, {1680,32.3875143}, {1690,34.0342857}, {1700,33.7016000}, {1710,34.2558857}, {1720,34.8806571}, {1730,35.0130857}, {1740,35.5765429}, {1750,35.9690571}, {1760,36.7566286}, {1770,37.7197429}, {1780,37.1153143}, {1790,38.2419143}, {1800,38.9493714}, {1810,39.6912000}, {1820,39.8540000}, {1830,40.5355143}, {1840,41.1947429}, {1850,41.9754286}, {1860,43.0683714}, {1870,43.3114571}, {1880,44.0230000}, {1890,45.1456857}, {1900,45.0651429}, {1910,45.7795429}, {1920,46.6116286}, {1930,47.1987714}, {1940,46.8890857}, {1950,47.7913714}, {1960,48.8933429}, {1970,49.4364000}, {1980,49.6881429}, {1990,50.2404571}, {2000,51.5507429}};
data["big"]["LtacTCExplicitCtx"]["reif"]["user"] = {{1,0.00047525}, {2,0.00094059}, {3,0.00116832}, {4,0.00151485}, {5,0.00200000}, {6,0.00206931}, {7,0.00317822}, {8,0.00271287}, {9,0.00330693}, {10,0.00385149}, {11,0.00423762}, {12,0.00448515}, {13,0.00534653}, {14,0.00563366}, {15,0.00590099}, {16,0.00639604}, {17,0.00713861}, {18,0.00737624}, {19,0.00800990}, {20,0.00819802}, {21,0.00913861}, {22,0.00941584}, {23,0.01013861}, {24,0.01077228}, {25,0.01114851}, {26,0.01176238}, {27,0.01226733}, {28,0.01287129}, {29,0.01622772}, {30,0.01456436}, {31,0.01476238}, {32,0.01532673}, {33,0.01614851}, {34,0.01711881}, {35,0.01768317}, {36,0.01808911}, {37,0.01881188}, {38,0.01972277}, {39,0.02048515}, {40,0.02200000}, {41,0.02220792}, {42,0.02347525}, {43,0.02719802}, {44,0.02521782}, {45,0.02583168}, {46,0.03183168}, {47,0.02767327}, {48,0.02881188}, {49,0.02900000}, {50,0.03004950}, {51,0.03102970}, {52,0.03187129}, {53,0.03295050}, {54,0.03842574}, {55,0.03426733}, {56,0.03567327}, {57,0.03633663}, {58,0.04594059}, {59,0.03848515}, {60,0.03914851}, {61,0.03999010}, {62,0.04099010}, {63,0.04236634}, {64,0.04337624}, {65,0.04949505}, {66,0.05148515}, {67,0.04674257}, {68,0.04835644}, {69,0.04931683}, {70,0.05323762}, {71,0.05170297}, {72,0.05879208}, {73,0.05385149}, {74,0.06346535}, {75,0.05578218}, {76,0.05700000}, {77,0.07336634}, {78,0.05926733}, {79,0.06078218}, {80,0.06190099}, {81,0.06305941}, {82,0.06566337}, {83,0.06695050}, {84,0.06629703}, {85,0.06746535}, {86,0.06967327}, {87,0.07144554}, {88,0.07279208}, {89,0.07394059}, {90,0.07555446}, {91,0.07667327}, {92,0.07832673}, {93,0.07911881}, {94,0.08096040}, {95,0.08240594}, {96,0.08340594}, {97,0.08519802}, {98,0.08681188}, {99,0.08743564}, {100,0.08949505}, {101,0.09046535}, {102,0.09217822}, {103,0.09436634}, {104,0.09641584}, {105,0.09767327}, {106,0.09902970}, {107,0.10003960}, {108,0.10204950}, {109,0.10346535}, {110,0.10502970}, {111,0.11351485}, {112,0.11532673}, {113,0.11770297}, {114,0.11992079}, {115,0.12226733}, {116,0.12468317}, {117,0.12690099}, {118,0.12979208}, {119,0.13056436}, {120,0.13431683}, {121,0.13589109}, {122,0.13865347}, {123,0.14264356}, {124,0.14587129}, {125,0.14906931}, {126,0.15120792}, {127,0.15257426}, {128,0.15349505}, {129,0.15600990}, {130,0.15942574}, {131,0.15996040}, {132,0.16103960}, {133,0.16464356}, {134,0.16808911}, {135,0.16722772}, {136,0.17121782}, {137,0.17263366}, {138,0.17532673}, {139,0.17812871}, {140,0.17787129}, {141,0.18324752}, {142,0.18429703}, {143,0.18621782}, {144,0.18990099}, {145,0.19190099}, {146,0.19502970}, {147,0.19796040}, {148,0.19871287}, {149,0.20116832}, {150,0.20342574}, {151,0.20500000}, {152,0.20677228}, {153,0.20740594}, {154,0.20987129}, {155,0.21278218}, {156,0.21705941}, {157,0.21927723}, {158,0.22166337}, {159,0.22170297}, {160,0.22627723}, {161,0.22765347}, {162,0.22869307}, {163,0.23021782}, {164,0.23405941}, {165,0.23430693}, {166,0.23877228}, {167,0.24112871}, {168,0.24044554}, {169,0.24427723}, {170,0.24930693}, {171,0.25164356}, {172,0.25338614}, {173,0.25664356}, {174,0.25867327}, {175,0.26287129}, {176,0.26154455}, {177,0.26403960}, {178,0.26808911}, {179,0.27125743}, {180,0.27511881}, {181,0.27631683}, {182,0.28179208}, {183,0.28276238}, {184,0.28821782}, {185,0.28985149}, {186,0.29122772}, {187,0.29358416}, {188,0.29696040}, {189,0.29955446}, {190,0.30282178}, {191,0.30326733}, {192,0.30586139}, {193,0.30784158}, {194,0.31159406}, {195,0.31035644}, {196,0.31207921}, {197,0.31661386}, {198,0.32606931}, {199,0.33139604}, {200,0.32652475}, {201,0.32717822}, {202,0.33483168}, {203,0.33400990}, {204,0.34235644}, {205,0.35027723}, {206,0.34008911}, {207,0.34707921}, {208,0.34691089}, {209,0.35180198}, {210,0.36689109}, {211,0.35800990}, {212,0.35994059}, {213,0.36245545}, {214,0.37507921}, {215,0.37086139}, {216,0.36950495}, {217,0.38421782}, {218,0.38429703}, {219,0.38147525}, {220,0.39084158}, {221,0.39236634}, {222,0.39473267}, {223,0.40327723}, {224,0.40116832}, {225,0.40307921}, {226,0.41181188}, {227,0.40929703}, {228,0.41452475}, {229,0.41428713}, {230,0.42420792}, {231,0.42202970}, {232,0.42793069}, {233,0.43021782}, {234,0.43193069}, {235,0.43824752}, {236,0.44068317}, {237,0.44145545}, {238,0.45134653}, {239,0.44787129}, {240,0.46144554}, {241,0.45567327}, {242,0.46376238}, {243,0.46614851}, {244,0.46882178}, {245,0.47560396}, {246,0.47807921}, {247,0.47610891}, {248,0.48405941}, {249,0.48361386}, {250,0.48513861}, {251,0.50021782}, {252,0.49413861}, {253,0.49748515}, {254,0.50802970}, {255,0.50605941}, {256,0.50738614}, {257,0.52219802}, {258,0.52614851}, {259,0.52547525}, {260,0.52226733}, {261,0.52893069}, {262,0.53232673}, {263,0.53645545}, {264,0.54568317}, {265,0.54437624}, {266,0.54387129}, {267,0.54757426}, {268,0.55373267}, {269,0.55806931}, {270,0.56190099}, {271,0.56505941}, {272,0.57045545}, {273,0.57671287}, {274,0.58002970}, {275,0.58461386}, {276,0.58373267}, {277,0.58706931}, {278,0.59009901}, {279,0.59623762}, {280,0.60407921}, {281,0.60916832}, {282,0.61096040}, {283,0.61402970}, {284,0.62015842}, {285,0.62214851}, {286,0.62900000}, {287,0.62877228}, {288,0.63482178}, {289,0.63728713}, {290,0.64410891}, {291,0.64730693}, {292,0.65057426}, {293,0.65399010}, {294,0.65996040}, {295,0.66442574}, {296,0.67142574}, {297,0.67681188}, {298,0.67793069}, {299,0.68281188}, {300,0.68864356}, {301,0.7238571}, {302,0.7341143}, {303,0.7950857}, {304,0.7653143}, {305,0.7423714}, {306,0.7663429}, {307,0.7558857}, {308,0.7630000}, {309,0.7739429}, {310,0.7707714}, {311,0.7744286}, {312,0.7838857}, {313,0.7969714}, {314,0.7921143}, {315,0.8001714}, {316,0.8032857}, {317,0.8052000}, {318,0.8100286}, {319,0.8216857}, {320,0.8193143}, {321,0.8450571}, {322,0.8566000}, {323,0.8277143}, {324,0.8356000}, {325,0.8418000}, {326,0.8442857}, {327,0.8538000}, {328,0.8570286}, {329,0.8585143}, {330,0.8661714}, {331,0.8683429}, {332,0.8769143}, {333,0.8769714}, {334,0.8799714}, {335,0.8895143}, {336,0.8937714}, {337,0.9016857}, {338,0.9211429}, {339,0.9130286}, {340,0.9338571}, {341,0.9295429}, {342,0.9325714}, {343,0.9416000}, {344,0.9453429}, {345,0.9528286}, {346,0.9484000}, {347,0.9579143}, {348,0.9628286}, {349,0.9679429}, {350,0.9726857}, {351,0.9891429}, {352,0.9830571}, {353,0.9858286}, {354,0.9930857}, {355,0.9899714}, {356,1.0066000}, {357,1.0080000}, {358,1.0089714}, {359,1.0077714}, {360,1.0236571}, {361,1.0185714}, {362,1.0338857}, {363,1.0392000}, {364,1.0413714}, {365,1.0521714}, {366,1.0452857}, {367,1.0579429}, {368,1.0600000}, {369,1.0679714}, {370,1.0739714}, {371,1.0803429}, {372,1.0905143}, {373,1.0930571}, {374,1.0931429}, {375,1.1072857}, {376,1.1150857}, {377,1.1138571}, {378,1.1198286}, {379,1.1187143}, {380,1.1263429}, {381,1.1376286}, {382,1.1487143}, {383,1.1537429}, {384,1.1631714}, {385,1.1731429}, {386,1.1765714}, {387,1.1829714}, {388,1.1902286}, {389,1.1954571}, {390,1.2052857}, {391,1.2062571}, {392,1.2107714}, {393,1.2251429}, {394,1.2340857}, {395,1.2412571}, {396,1.2378286}, {397,1.2380000}, {398,1.2463714}, {399,1.2561143}, {400,1.2694571}, {401,1.2681143}, {402,1.2775429}, {403,1.2899714}, {404,1.2895429}, {405,1.3052571}, {406,1.3053714}, {407,1.3091714}, {408,1.3204000}, {409,1.3325714}, {410,1.3270286}, {411,1.3354857}, {412,1.3328000}, {413,1.3418857}, {414,1.3470857}, {415,1.3638571}, {416,1.3745714}, {417,1.3805143}, {418,1.3884000}, {419,1.3800000}, {420,1.3913429}, {421,1.4008571}, {422,1.4049143}, {423,1.4156857}, {424,1.4220000}, {425,1.4362286}, {426,1.4486286}, {427,1.4788286}, {428,1.4740571}, {429,1.4700286}, {430,1.4657429}, {431,1.4909143}, {432,1.5065143}, {433,1.5093429}, {434,1.5060571}, {435,1.5102000}, {436,1.5234286}, {437,1.5264857}, {438,1.5416000}, {439,1.5584000}, {440,1.5660000}, {441,1.5594857}, {442,1.5786857}, {443,1.5835429}, {444,1.5747143}, {445,1.5852286}, {446,1.5948857}, {447,1.6018286}, {448,1.6064286}, {449,1.6144000}, {450,1.6197714}, {451,1.6225143}, {452,1.6385429}, {453,1.6456286}, {454,1.6432571}, {455,1.6625143}, {456,1.6647714}, {457,1.6741429}, {458,1.6944000}, {459,1.6953429}, {460,1.6980000}, {461,1.7068000}, {462,1.7103143}, {463,1.7198000}, {464,1.7238857}, {465,1.7357429}, {466,1.7438286}, {467,1.7490571}, {468,1.7638000}, {469,1.7933143}, {470,1.7791429}, {471,1.7785143}, {472,1.7913429}, {473,1.8132571}, {474,1.8717714}, {475,1.7998857}, {476,1.8122857}, {477,1.8451429}, {478,1.8544857}, {479,1.8563429}, {480,1.8370286}, {481,1.9114571}, {482,1.9510571}, {483,1.8973143}, {484,1.9533143}, {485,1.9354571}, {486,1.9685143}, {487,1.9353714}, {488,1.9319429}, {489,1.9385143}, {490,1.9399143}, {491,1.9326286}, {492,1.9532000}, {493,2.0207714}, {494,2.0319143}, {495,1.9923429}, {496,1.9824571}, {497,2.0373714}, {498,2.0342286}, {499,2.0360857}, {500,2.0845143}, {505,2.0892000}, {510,2.1039714}, {515,2.1298286}, {520,2.1758857}, {525,2.2768571}, {530,2.2821429}, {535,2.3007429}, {540,2.4390857}, {545,2.4815714}, {550,2.5268286}, {555,2.5418857}, {560,2.6460857}, {565,2.6427143}, {570,2.6886286}, {575,2.7171429}, {580,2.7693714}, {585,2.8303143}, {590,2.9607429}, {595,2.9674571}, {600,3.0586286}, {605,3.0762000}, {610,3.1689714}, {615,3.2258857}, {620,3.2876857}, {625,3.2783143}, {630,3.3503429}, {635,3.3697714}, {640,3.4065143}, {645,3.4665143}, {650,3.4499143}, {655,3.5316857}, {660,3.5695143}, {665,3.6242571}, {670,3.6360857}, {675,3.7335714}, {680,3.8471429}, {685,3.7800571}, {690,3.8974286}, {695,3.9891143}, {700,4.1046571}, {705,4.0807429}, {710,4.0941429}, {715,4.1948857}, {720,4.2741429}, {725,4.3249143}, {730,4.3754857}, {735,4.4844571}, {740,4.6347714}, {745,4.6871143}, {750,4.8303143}, {755,4.9560571}, {760,5.0183143}, {765,5.1008000}, {770,5.1561143}, {775,5.2984286}, {780,5.4471143}, {785,5.5245429}, {790,5.4808571}, {795,5.5800286}, {800,5.6158000}, {805,5.6502000}, {810,5.9569429}, {815,5.8767143}, {820,6.1593714}, {825,6.3618857}, {830,6.3631143}, {835,6.3704857}, {840,6.3638857}, {845,6.3946857}, {850,6.5064286}, {855,6.5477429}, {860,6.8194571}, {865,6.7156857}, {870,6.8247429}, {875,6.8739429}, {880,7.0846286}, {885,7.0107429}, {890,7.0623429}, {895,7.1460571}, {900,7.3552000}, {905,7.2754857}, {910,7.4140000}, {915,7.5861143}, {920,7.6101429}, {925,7.8131143}, {930,7.8747143}, {935,7.9112571}, {940,7.9102857}, {945,8.0734571}, {950,8.2194000}, {955,8.5027714}, {960,8.3301714}, {965,8.4018286}, {970,8.6358000}, {975,8.6120857}, {980,8.8775714}, {985,8.7995429}, {990,8.9779429}, {995,8.9635143}, {1000,9.0067143}, {1010,9.2915143}, {1020,9.4296571}, {1030,9.6654286}, {1040,10.1113143}, {1050,10.2666857}, {1060,10.5507429}, {1070,10.6389143}, {1080,10.8075714}, {1090,11.3460286}, {1100,11.4906857}, {1110,11.7717143}, {1120,11.8201143}, {1130,12.2850000}, {1140,12.4210000}, {1150,12.5015143}, {1160,12.8652857}, {1170,13.1742000}, {1180,13.3988286}, {1190,13.6411429}, {1200,14.1540286}, {1210,14.2129143}, {1220,14.8334571}, {1230,15.2644571}, {1240,15.6759429}, {1250,15.4434286}, {1260,15.8312571}, {1270,16.3100000}, {1280,16.5018857}, {1290,16.9234286}, {1300,17.1082857}, {1310,17.5797143}, {1320,17.7566286}, {1330,18.0697429}, {1340,18.3190857}, {1350,18.6085429}, {1360,19.2612571}, {1370,19.4196286}, {1380,19.8249429}, {1390,20.0421714}, {1400,20.5781143}, {1410,20.7768286}, {1420,21.3929429}, {1430,22.0365143}, {1440,22.0574000}, {1450,22.0374571}, {1460,23.3192286}, {1470,23.1948000}, {1480,23.4324857}, {1490,24.1373714}, {1500,24.3522286}, {1510,24.7122571}, {1520,25.5063429}, {1530,25.3635143}, {1540,26.3032000}, {1550,26.1675429}, {1560,27.1318857}, {1570,27.1613143}, {1580,28.0658857}, {1590,28.2971429}, {1600,28.9491714}, {1610,29.0212000}, {1620,29.6657429}, {1630,30.1912286}, {1640,30.3999714}, {1650,30.5922857}, {1660,31.3568000}, {1670,31.8810286}, {1680,32.3194857}, {1690,33.9639429}, {1700,33.6282857}, {1710,34.1979714}, {1720,34.8138286}, {1730,34.9372857}, {1740,35.4927429}, {1750,35.8892857}, {1760,36.6830571}, {1770,37.6332857}, {1780,37.0312000}, {1790,38.1665143}, {1800,38.8795714}, {1810,39.6268571}, {1820,39.7779429}, {1830,40.4651429}, {1840,41.1043429}, {1850,41.8886571}, {1860,42.9795714}, {1870,43.2011143}, {1880,43.9355714}, {1890,45.0593429}, {1900,44.9856000}, {1910,45.7136857}, {1920,46.5438000}, {1930,47.1326571}, {1940,46.7976000}, {1950,47.7222571}, {1960,48.5739143}, {1970,49.3760857}, {1980,49.6276286}, {1990,50.1739143}, {2000,51.4935429}};
data["big"]["LtacTCExplicitCtx"]["reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00002970}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00003960}, {11,0.00000000}, {12,0.00003960}, {13,0.00000000}, {14,0.00000000}, {15,0.00010891}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00003960}, {20,0.00002970}, {21,0.00007921}, {22,0.00000000}, {23,0.00003960}, {24,0.00011881}, {25,0.00007921}, {26,0.00011881}, {27,0.00003960}, {28,0.00003960}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00015842}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00007921}, {37,0.00000000}, {38,0.00000000}, {39,0.00003960}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00003960}, {44,0.00003960}, {45,0.00000000}, {46,0.00011881}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00006931}, {51,0.00000000}, {52,0.00007921}, {53,0.00010891}, {54,0.00003960}, {55,0.00015842}, {56,0.00000000}, {57,0.00003960}, {58,0.00003960}, {59,0.00003960}, {60,0.00003960}, {61,0.00000000}, {62,0.00003960}, {63,0.00003960}, {64,0.00007921}, {65,0.00000000}, {66,0.00003960}, {67,0.00000000}, {68,0.00003960}, {69,0.00007921}, {70,0.00000000}, {71,0.00003960}, {72,0.00000000}, {73,0.00011881}, {74,0.00003960}, {75,0.00000000}, {76,0.00000000}, {77,0.00007921}, {78,0.00000000}, {79,0.00003960}, {80,0.00003960}, {81,0.00000000}, {82,0.00011881}, {83,0.00007921}, {84,0.00003960}, {85,0.00003960}, {86,0.00003960}, {87,0.00003960}, {88,0.00000000}, {89,0.00000000}, {90,0.00007921}, {91,0.00003960}, {92,0.00003960}, {93,0.00007921}, {94,0.00011881}, {95,0.00007921}, {96,0.00003960}, {97,0.00011881}, {98,0.00007921}, {99,0.00019802}, {100,0.00003960}, {101,0.00003960}, {102,0.00000000}, {103,0.00000000}, {104,0.00003960}, {105,0.00003960}, {106,0.00011881}, {107,0.00000000}, {108,0.00003960}, {109,0.00003960}, {110,0.00000000}, {111,0.00000000}, {112,0.00007921}, {113,0.00003960}, {114,0.00003960}, {115,0.00000000}, {116,0.00006931}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00003960}, {122,0.00000000}, {123,0.00003960}, {124,0.00000000}, {125,0.00003960}, {126,0.00011881}, {127,0.00002970}, {128,0.00003960}, {129,0.00006931}, {130,0.00000000}, {131,0.00007921}, {132,0.00007921}, {133,0.00003960}, {134,0.00000000}, {135,0.00015842}, {136,0.00000000}, {137,0.00007921}, {138,0.00003960}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00003960}, {143,0.00007921}, {144,0.00015842}, {145,0.00003960}, {146,0.00007921}, {147,0.00007921}, {148,0.00000000}, {149,0.00002970}, {150,0.00003960}, {151,0.00007921}, {152,0.00003960}, {153,0.00000000}, {154,0.00000000}, {155,0.00003960}, {156,0.00011881}, {157,0.00000000}, {158,0.00010891}, {159,0.00011881}, {160,0.00011881}, {161,0.00003960}, {162,0.00003960}, {163,0.00003960}, {164,0.00011881}, {165,0.00003960}, {166,0.00003960}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00003960}, {171,0.00000000}, {172,0.00003960}, {173,0.00000000}, {174,0.00003960}, {175,0.00003960}, {176,0.00003960}, {177,0.00015842}, {178,0.00003960}, {179,0.00011881}, {180,0.00000000}, {181,0.00011881}, {182,0.00003960}, {183,0.00003960}, {184,0.00000000}, {185,0.00003960}, {186,0.00007921}, {187,0.00003960}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00007921}, {193,0.00003960}, {194,0.00003960}, {195,0.00003960}, {196,0.00003960}, {197,0.00003960}, {198,0.00000000}, {199,0.00003960}, {200,0.00003960}, {201,0.00003960}, {202,0.00007921}, {203,0.00003960}, {204,0.00003960}, {205,0.00003960}, {206,0.00007921}, {207,0.00003960}, {208,0.00003960}, {209,0.00000000}, {210,0.00003960}, {211,0.00000000}, {212,0.00000000}, {213,0.00003960}, {214,0.00003960}, {215,0.00011881}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00007921}, {220,0.00003960}, {221,0.00003960}, {222,0.00011881}, {223,0.00003960}, {224,0.00003960}, {225,0.00003960}, {226,0.00000000}, {227,0.00007921}, {228,0.00007921}, {229,0.00000000}, {230,0.00007921}, {231,0.00023762}, {232,0.00011881}, {233,0.00007921}, {234,0.00015842}, {235,0.00007921}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00003960}, {240,0.00019802}, {241,0.00007921}, {242,0.00015842}, {243,0.00015842}, {244,0.00011881}, {245,0.00003960}, {246,0.00007921}, {247,0.00011881}, {248,0.00011881}, {249,0.00011881}, {250,0.00023762}, {251,0.00003960}, {252,0.00003960}, {253,0.00019802}, {254,0.00003960}, {255,0.00015842}, {256,0.00000000}, {257,0.00003960}, {258,0.00010891}, {259,0.00026733}, {260,0.00007921}, {261,0.00006931}, {262,0.00019802}, {263,0.00003960}, {264,0.00003960}, {265,0.00007921}, {266,0.00015842}, {267,0.00000000}, {268,0.00007921}, {269,0.00003960}, {270,0.00011881}, {271,0.00003960}, {272,0.00003960}, {273,0.00007921}, {274,0.00003960}, {275,0.00007921}, {276,0.00003960}, {277,0.00010891}, {278,0.00003960}, {279,0.00007921}, {280,0.00003960}, {281,0.00003960}, {282,0.00007921}, {283,0.00000000}, {284,0.00050495}, {285,0.00011881}, {286,0.00003960}, {287,0.00003960}, {288,0.00002970}, {289,0.00011881}, {290,0.00003960}, {291,0.00003960}, {292,0.00011881}, {293,0.00015842}, {294,0.00015842}, {295,0.00003960}, {296,0.00015842}, {297,0.00000000}, {298,0.00003960}, {299,0.00003960}, {300,0.00015842}, {301,0.0005429}, {302,0.0002286}, {303,0.0001143}, {304,0.0003429}, {305,0.0000000}, {306,0.0002286}, {307,0.0000000}, {308,0.0001143}, {309,0.0003429}, {310,0.0000000}, {311,0.0002286}, {312,0.0000000}, {313,0.0001143}, {314,0.0000000}, {315,0.0001143}, {316,0.0002286}, {317,0.0002286}, {318,0.0003429}, {319,0.0001143}, {320,0.0001143}, {321,0.0000000}, {322,0.0000000}, {323,0.0004286}, {324,0.0001143}, {325,0.0001143}, {326,0.0001143}, {327,0.0001143}, {328,0.0002286}, {329,0.0001143}, {330,0.0002286}, {331,0.0001143}, {332,0.0002286}, {333,0.0000000}, {334,0.0001143}, {335,0.0001143}, {336,0.0005714}, {337,0.0003429}, {338,0.0002000}, {339,0.0001143}, {340,0.0002286}, {341,0.0002286}, {342,0.0000000}, {343,0.0000000}, {344,0.0004571}, {345,0.0001143}, {346,0.0001143}, {347,0.0002286}, {348,0.0001143}, {349,0.0000000}, {350,0.0001143}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0001143}, {356,0.0000000}, {357,0.0000000}, {358,0.0001143}, {359,0.0000000}, {360,0.0000000}, {361,0.0001143}, {362,0.0002286}, {363,0.0002286}, {364,0.0004571}, {365,0.0004571}, {366,0.0000000}, {367,0.0001143}, {368,0.0000000}, {369,0.0000000}, {370,0.0003429}, {371,0.0001143}, {372,0.0000000}, {373,0.0002286}, {374,0.0001143}, {375,0.0002286}, {376,0.0002286}, {377,0.0001143}, {378,0.0000000}, {379,0.0003429}, {380,0.0001143}, {381,0.0002286}, {382,0.0000000}, {383,0.0000857}, {384,0.0004571}, {385,0.0004571}, {386,0.0004571}, {387,0.0004571}, {388,0.0001143}, {389,0.0001143}, {390,0.0000000}, {391,0.0002286}, {392,0.0001143}, {393,0.0003429}, {394,0.0001143}, {395,0.0003429}, {396,0.0002000}, {397,0.0001143}, {398,0.0003429}, {399,0.0002286}, {400,0.0001143}, {401,0.0003429}, {402,0.0001143}, {403,0.0002286}, {404,0.0001143}, {405,0.0000000}, {406,0.0000000}, {407,0.0002286}, {408,0.0004571}, {409,0.0003429}, {410,0.0002286}, {411,0.0001143}, {412,0.0002286}, {413,0.0003429}, {414,0.0001143}, {415,0.0003429}, {416,0.0001143}, {417,0.0001143}, {418,0.0003429}, {419,0.0001143}, {420,0.0001143}, {421,0.0001143}, {422,0.0005714}, {423,0.0001143}, {424,0.0001143}, {425,0.0001143}, {426,0.0002286}, {427,0.0003429}, {428,0.0000000}, {429,0.0006857}, {430,0.0001143}, {431,0.0001143}, {432,0.0004571}, {433,0.0001143}, {434,0.0000000}, {435,0.0001143}, {436,0.0003429}, {437,0.0001143}, {438,0.0004571}, {439,0.0002000}, {440,0.0003429}, {441,0.0003429}, {442,0.0002286}, {443,0.0001143}, {444,0.0000857}, {445,0.0002286}, {446,0.0003429}, {447,0.0006857}, {448,0.0001143}, {449,0.0001143}, {450,0.0003429}, {451,0.0002286}, {452,0.0000000}, {453,0.0001143}, {454,0.0005714}, {455,0.0003429}, {456,0.0001143}, {457,0.0002286}, {458,0.0001143}, {459,0.0001143}, {460,0.0002286}, {461,0.0003429}, {462,0.0002286}, {463,0.0002286}, {464,0.0002286}, {465,0.0002000}, {466,0.0004571}, {467,0.0002286}, {468,0.0004571}, {469,0.0005714}, {470,0.0005714}, {471,0.0011143}, {472,0.0011429}, {473,0.0003429}, {474,0.0004571}, {475,0.0012571}, {476,0.0003429}, {477,0.0003429}, {478,0.0006857}, {479,0.0000000}, {480,0.0004571}, {481,0.0012571}, {482,0.0016000}, {483,0.0009143}, {484,0.0005714}, {485,0.0004571}, {486,0.0002286}, {487,0.0007714}, {488,0.0012571}, {489,0.0010286}, {490,0.0009143}, {491,0.0004571}, {492,0.0003429}, {493,0.0002286}, {494,0.0012571}, {495,0.0017143}, {496,0.0011429}, {497,0.0010286}, {498,0.0009143}, {499,0.0002286}, {500,0.0006857}, {505,0.0008000}, {510,0.0008857}, {515,0.0007714}, {520,0.0005714}, {525,0.0010000}, {530,0.0016000}, {535,0.0008000}, {540,0.0008000}, {545,0.0017143}, {550,0.0010286}, {555,0.0012571}, {560,0.0006857}, {565,0.0018286}, {570,0.0014857}, {575,0.0010286}, {580,0.0011429}, {585,0.0012571}, {590,0.0008000}, {595,0.0009143}, {600,0.0004571}, {605,0.0014857}, {610,0.0006857}, {615,0.0008857}, {620,0.0011429}, {625,0.0004571}, {630,0.0014857}, {635,0.0012571}, {640,0.0009143}, {645,0.0012571}, {650,0.0004571}, {655,0.0016000}, {660,0.0012571}, {665,0.0010286}, {670,0.0006857}, {675,0.0008857}, {680,0.0001143}, {685,0.0014857}, {690,0.0012571}, {695,0.0006857}, {700,0.0008857}, {705,0.0008000}, {710,0.0006857}, {715,0.0004571}, {720,0.0014857}, {725,0.0006857}, {730,0.0004571}, {735,0.0004571}, {740,0.0014857}, {745,0.0011429}, {750,0.0010286}, {755,0.0027429}, {760,0.0012286}, {765,0.0019429}, {770,0.0008000}, {775,0.0008000}, {780,0.0004571}, {785,0.0008000}, {790,0.0006571}, {795,0.0011429}, {800,0.0005714}, {805,0.0006857}, {810,0.0012286}, {815,0.0016000}, {820,0.0013429}, {825,0.0005714}, {830,0.0008857}, {835,0.0007429}, {840,0.0006857}, {845,0.0010000}, {850,0.0006857}, {855,0.0018000}, {860,0.0004571}, {865,0.0021714}, {870,0.0024857}, {875,0.0019429}, {880,0.0021429}, {885,0.0008000}, {890,0.0008857}, {895,0.0024000}, {900,0.0021429}, {905,0.0038286}, {910,0.0047429}, {915,0.0021143}, {920,0.0027429}, {925,0.0038857}, {930,0.0040000}, {935,0.0041714}, {940,0.0043143}, {945,0.0041714}, {950,0.0046857}, {955,0.0018571}, {960,0.0022286}, {965,0.0042000}, {970,0.0020286}, {975,0.0035714}, {980,0.0036000}, {985,0.0036571}, {990,0.0048857}, {995,0.0073429}, {1000,0.0022571}, {1010,0.0040857}, {1020,0.0044286}, {1030,0.0075429}, {1040,0.0078857}, {1050,0.0051143}, {1060,0.0098857}, {1070,0.0045143}, {1080,0.0050571}, {1090,0.0064286}, {1100,0.0072286}, {1110,0.0052857}, {1120,0.0094286}, {1130,0.0067429}, {1140,0.0100000}, {1150,0.0088000}, {1160,0.0087429}, {1170,0.0108000}, {1180,0.0086286}, {1190,0.0068857}, {1200,0.0107143}, {1210,0.0076857}, {1220,0.0096857}, {1230,0.0054286}, {1240,0.0098000}, {1250,0.0108286}, {1260,0.0153143}, {1270,0.0153714}, {1280,0.0088286}, {1290,0.0118286}, {1300,0.0126286}, {1310,0.0117714}, {1320,0.0189429}, {1330,0.0153143}, {1340,0.0122286}, {1350,0.0148857}, {1360,0.0128857}, {1370,0.0130857}, {1380,0.0212286}, {1390,0.0200857}, {1400,0.0140286}, {1410,0.0164857}, {1420,0.0179143}, {1430,0.0137429}, {1440,0.0173714}, {1450,0.0218286}, {1460,0.0180000}, {1470,0.0167143}, {1480,0.0187714}, {1490,0.0195143}, {1500,0.0214571}, {1510,0.0205714}, {1520,0.0190571}, {1530,0.0252857}, {1540,0.0222857}, {1550,0.0186857}, {1560,0.0255714}, {1570,0.0221714}, {1580,0.0253143}, {1590,0.0255714}, {1600,0.0246000}, {1610,0.0258571}, {1620,0.0303429}, {1630,0.0267714}, {1640,0.0314571}, {1650,0.0317429}, {1660,0.0262571}, {1670,0.0291143}, {1680,0.0317429}, {1690,0.0293143}, {1700,0.0308857}, {1710,0.0294000}, {1720,0.0324571}, {1730,0.0307714}, {1740,0.0390571}, {1750,0.0389143}, {1760,0.0349714}, {1770,0.0333429}, {1780,0.0378000}, {1790,0.0393429}, {1800,0.0431714}, {1810,0.0461714}, {1820,0.0415429}, {1830,0.0364000}, {1840,0.0380857}, {1850,0.0402571}, {1860,0.0380286}, {1870,0.0458857}, {1880,0.0390286}, {1890,0.0445143}, {1900,0.0427143}, {1910,0.0480000}, {1920,0.0442857}, {1930,0.0391714}, {1940,0.0434571}, {1950,0.0494286}, {1960,0.0416857}, {1970,0.0457714}, {1980,0.0470000}, {1990,0.0424286}, {2000,0.0368571}};
data["big"]["LtacTCGallinaCtx"]["Aggregate"]["real"] = {{1,0.00100000}, {2,0.00100000}, {3,0.00198020}, {4,0.00200000}, {5,0.00200000}, {6,0.00300990}, {7,0.00301980}, {8,0.00339604}, {9,0.00400000}, {10,0.00415842}, {11,0.00500000}, {12,0.00506931}, {13,0.00562376}, {14,0.00625743}, {15,0.00668317}, {16,0.00730693}, {17,0.00783168}, {18,0.00850495}, {19,0.00889109}, {20,0.00956436}, {21,0.01046535}, {22,0.01070297}, {23,0.01164356}, {24,0.01216832}, {25,0.01384158}, {26,0.01348515}, {27,0.01428713}, {28,0.01442574}, {29,0.01550495}, {30,0.01601980}, {31,0.01681188}, {32,0.01757426}, {33,0.01834653}, {34,0.01868317}, {35,0.02063366}, {36,0.02331683}, {37,0.02360396}, {38,0.02206931}, {39,0.02295050}, {40,0.02400990}, {41,0.02503960}, {42,0.02586139}, {43,0.02705941}, {44,0.02954455}, {45,0.02874257}, {46,0.02963366}, {47,0.03238614}, {48,0.03195050}, {49,0.03600000}, {50,0.03300990}, {51,0.03832673}, {52,0.03583168}, {53,0.03918812}, {54,0.03800990}, {55,0.03944554}, {56,0.04166337}, {57,0.04624752}, {58,0.04293069}, {59,0.04330693}, {60,0.04478218}, {61,0.04582178}, {62,0.04655446}, {63,0.04810891}, {64,0.04975248}, {65,0.05085149}, {66,0.05256436}, {67,0.06284158}, {68,0.05757426}, {69,0.05575248}, {70,0.05759406}, {71,0.06124752}, {72,0.06038614}, {73,0.06586139}, {74,0.06354455}, {75,0.06519802}, {76,0.14695050}, {77,0.06759406}, {78,0.06976238}, {79,0.09669307}, {80,0.08198020}, {81,0.07368317}, {82,0.07594059}, {83,0.07725743}, {84,0.07842574}, {85,0.08893069}, {86,0.09999010}, {87,0.10519802}, {88,0.10687129}, {89,0.10527723}, {90,0.10400990}, {91,0.11252475}, {92,0.11650495}, {93,0.11402970}, {94,0.11111881}, {95,0.11403960}, {96,0.11736634}, {97,0.11783168}, {98,0.12021782}, {99,0.12252475}, {100,0.12539604}, {101,0.12692079}, {102,0.13022772}, {103,0.12547525}, {104,0.12900000}, {105,0.13164356}, {106,0.13372277}, {107,0.13561386}, {108,0.13677228}, {109,0.13911881}, {110,0.14095050}, {111,0.14423762}, {112,0.14479208}, {113,0.14684158}, {114,0.14958416}, {115,0.15201980}, {116,0.15364356}, {117,0.15726733}, {118,0.15875248}, {119,0.16141584}, {120,0.16496040}, {121,0.16775248}, {122,0.16906931}, {123,0.17319802}, {124,0.17451485}, {125,0.17705941}, {126,0.18038614}, {127,0.18298020}, {128,0.18481188}, {129,0.18797030}, {130,0.19113861}, {131,0.19267327}, {132,0.19631683}, {133,0.19792079}, {134,0.20079208}, {135,0.20408911}, {136,0.20821782}, {137,0.20963366}, {138,0.21329703}, {139,0.21584158}, {140,0.21627723}, {141,0.22235644}, {142,0.22378218}, {143,0.22740594}, {144,0.23202970}, {145,0.23256436}, {146,0.23646535}, {147,0.23957426}, {148,0.24291089}, {149,0.24649505}, {150,0.25044554}, {151,0.25142574}, {152,0.25438614}, {153,0.25877228}, {154,0.26232673}, {155,0.26500990}, {156,0.26911881}, {157,0.27041584}, {158,0.27712871}, {159,0.27817822}, {160,0.28186139}, {161,0.28530693}, {162,0.28667327}, {163,0.30189109}, {164,0.29235644}, {165,0.29744554}, {166,0.30082178}, {167,0.30209901}, {168,0.30441584}, {169,0.31198020}, {170,0.31399010}, {171,0.31707921}, {172,0.32434653}, {173,0.32487129}, {174,0.32964356}, {175,0.33168317}, {176,0.33470297}, {177,0.33956436}, {178,0.34306931}, {179,0.34937624}, {180,0.35509901}, {181,0.35832673}, {182,0.36574257}, {183,0.36939604}, {184,0.37487129}, {185,0.37923762}, {186,0.38380198}, {187,0.38851485}, {188,0.38973267}, {189,0.39575248}, {190,0.39550495}, {191,0.39930693}, {192,0.40255446}, {193,0.40529703}, {194,0.40791089}, {195,0.41239604}, {196,0.41405941}, {197,0.41687129}, {198,0.42114851}, {199,0.43187129}, {200,0.44143564}, {201,0.43656436}, {202,0.43755446}, {203,0.44500000}, {204,0.44713861}, {205,0.45978218}, {206,0.46962376}, {207,0.46130693}, {208,0.46463366}, {209,0.46955446}, {210,0.48171287}, {211,0.49269307}, {212,0.48488119}, {213,0.48562376}, {214,0.50211881}, {215,0.51174257}, {216,0.50226733}, {217,0.50660396}, {218,0.52337624}, {219,0.52338614}, {220,0.52260396}, {221,0.54249505}, {222,0.53753465}, {223,0.54048515}, {224,0.55252475}, {225,0.55150495}, {226,0.56083168}, {227,0.55857426}, {228,0.56731683}, {229,0.57650495}, {230,0.57550495}, {231,0.59212871}, {232,0.58346535}, {233,0.60449505}, {234,0.59266337}, {235,0.61187129}, {236,0.60276238}, {237,0.67564356}, {238,0.61659406}, {239,0.70316832}, {240,0.62977228}, {241,0.63274257}, {242,0.64304950}, {243,0.64399010}, {244,0.65206931}, {245,0.72139604}, {246,0.65973267}, {247,0.67160396}, {248,0.67431683}, {249,0.67403960}, {250,0.69082178}, {251,0.68720792}, {252,0.69176238}, {253,0.70636634}, {254,0.70834653}, {255,0.70957426}, {256,0.72246535}, {257,0.72737624}, {258,0.72735644}, {259,0.73322772}, {260,0.74030693}, {261,0.75120792}, {262,0.76091089}, {263,0.76660396}, {264,0.76735644}, {265,0.77178218}, {266,0.77442574}, {267,0.78253465}, {268,0.79271287}, {269,0.79899010}, {270,0.80238614}, {271,0.80549505}, {272,0.81764356}, {273,0.82322772}, {274,0.83219802}, {275,0.83752475}, {276,0.84738614}, {277,0.85205941}, {278,0.85967327}, {279,0.86651485}, {280,0.87005941}, {281,0.87700990}, {282,0.88701980}, {283,0.89664356}, {284,0.90903960}, {285,0.91519802}, {286,0.92472277}, {287,0.92592079}, {288,0.93383168}, {289,0.93947525}, {290,0.94223762}, {291,0.94795050}, {292,0.95028713}, {293,0.95334653}, {294,0.96170297}, {295,0.96809901}, {296,0.97584158}, {297,0.99408911}, {298,0.99609901}, {299,0.99247525}, {300,0.99777228}, {301,1.0531143}, {302,1.1528000}, {303,1.1115714}, {304,1.1116000}, {305,1.0855714}, {306,1.1033143}, {307,1.1310000}, {308,1.1114286}, {309,1.1160571}, {310,1.1720571}, {311,1.1328571}, {312,1.1401143}, {313,1.1646286}, {314,1.1620286}, {315,1.1684857}, {316,1.1756571}, {317,1.1815143}, {318,1.1899714}, {319,1.1980286}, {320,1.2121714}, {321,1.2045143}, {322,1.2591714}, {323,1.2483143}, {324,1.2323714}, {325,1.2660571}, {326,1.2494000}, {327,1.2558286}, {328,1.2685143}, {329,1.2783429}, {330,1.2834286}, {331,1.3058000}, {332,1.2956857}, {333,1.3358000}, {334,1.3035714}, {335,1.3571714}, {336,1.3347429}, {337,1.3379714}, {338,1.3460000}, {339,1.3524000}, {340,1.3825714}, {341,1.3704286}, {342,1.3878571}, {343,1.3986000}, {344,1.4143429}, {345,1.4164286}, {346,1.4238571}, {347,1.4306857}, {348,1.4398000}, {349,1.4492571}, {350,1.4847143}, {351,1.4816000}, {352,1.4778571}, {353,1.4928857}, {354,1.4955714}, {355,1.5085143}, {356,1.5102857}, {357,1.5260000}, {358,1.5356000}, {359,1.5448571}, {360,1.5510000}, {361,1.5632000}, {362,1.5744857}, {363,1.5819714}, {364,1.5961714}, {365,1.6066571}, {366,1.6036286}, {367,1.6199429}, {368,1.6310571}, {369,1.6390286}, {370,1.6484857}, {371,1.6653714}, {372,1.6722000}, {373,1.6820000}, {374,1.6826286}, {375,1.7104857}, {376,1.7160000}, {377,1.7208571}, {378,1.7309714}, {379,1.7353429}, {380,1.7526000}, {381,1.7607714}, {382,1.7749143}, {383,1.7850286}, {384,1.8028857}, {385,1.8134286}, {386,1.8312286}, {387,1.8435143}, {388,1.8456286}, {389,1.8626286}, {390,1.8804000}, {391,1.8846857}, {392,1.8964571}, {393,1.9162857}, {394,1.9142857}, {395,1.9341714}, {396,1.9374286}, {397,1.9584571}, {398,1.9805143}, {399,1.9751429}, {400,1.9876286}, {401,2.0005714}, {402,2.0137143}, {403,2.0314857}, {404,2.0417429}, {405,2.0666571}, {406,2.0713143}, {407,2.0741714}, {408,2.0870286}, {409,2.1029429}, {410,2.1037714}, {411,2.1133714}, {412,2.1109429}, {413,2.1358857}, {414,2.1427429}, {415,2.1602286}, {416,2.1568000}, {417,2.1611714}, {418,2.1748571}, {419,2.1818857}, {420,2.2006000}, {421,2.2205429}, {422,2.2168000}, {423,2.2324286}, {424,2.2351714}, {425,2.2470857}, {426,2.2690000}, {427,2.3242857}, {428,2.3148571}, {429,2.3257143}, {430,2.3260571}, {431,2.3423143}, {432,2.3632571}, {433,2.3719143}, {434,2.4076286}, {435,2.3991714}, {436,2.4146000}, {437,2.4161143}, {438,2.4355714}, {439,2.4640571}, {440,2.4809143}, {441,2.4806286}, {442,2.4947429}, {443,2.5098000}, {444,2.5237714}, {445,2.5325714}, {446,2.5448857}, {447,2.5577429}, {448,2.5663143}, {449,2.5838000}, {450,2.6060857}, {451,2.6075143}, {452,2.6171143}, {453,2.6383143}, {454,2.6526000}, {455,2.6754571}, {456,2.6767143}, {457,2.6909143}, {458,2.7140571}, {459,2.7316857}, {460,2.7403429}, {461,2.7472857}, {462,2.7826571}, {463,2.7828286}, {464,2.8171429}, {465,2.8130286}, {466,2.8222857}, {467,2.9199429}, {468,2.8509714}, {469,2.8620286}, {470,2.9251429}, {471,2.9184286}, {472,2.9299714}, {473,2.9873429}, {474,2.9479429}, {475,2.9393429}, {476,2.9412857}, {477,3.0073143}, {478,2.9759429}, {479,3.0393429}, {480,3.0090286}, {481,3.0332857}, {482,3.0367143}, {483,3.0673714}, {484,3.1144000}, {485,3.0974857}, {486,3.1437429}, {487,3.1263714}, {488,3.1393429}, {489,3.1363143}, {490,3.1432000}, {491,3.1639143}, {492,3.1870857}, {493,3.2054857}, {494,3.2398000}, {495,3.2494857}, {496,3.2653429}, {497,3.2856286}, {498,3.2944286}, {499,3.3138286}, {500,3.3264857}, {505,3.4026857}, {510,3.4809429}, {515,3.5632286}, {520,3.6470286}, {525,3.7340857}, {530,3.8594286}, {535,3.9014000}, {540,4.0860286}, {545,4.0539429}, {550,4.2230571}, {555,4.2677143}, {560,4.3365429}, {565,4.4743714}, {570,4.5290857}, {575,4.6479143}, {580,4.7749429}, {585,4.8520286}, {590,5.0050857}, {595,5.1936286}, {600,5.2589714}, {605,5.3300571}, {610,5.3811714}, {615,5.5541429}, {620,5.6908571}, {625,5.8648286}, {630,5.9364571}, {635,5.9720286}, {640,6.1815429}, {645,6.3162857}, {650,6.3731143}, {655,6.3869429}, {660,6.4432286}, {665,6.6206000}, {670,6.7844286}, {675,6.9057714}, {680,7.1186000}, {685,7.2242286}, {690,7.3826857}, {695,7.3988571}, {700,7.6939143}, {705,7.7784571}, {710,8.0262286}, {715,7.9704000}, {720,8.1188286}, {725,8.3746571}, {730,8.3041143}, {735,8.6350857}, {740,8.7584286}, {745,9.0156000}, {750,9.1214000}, {755,9.3761143}, {760,9.5304857}, {765,9.7404857}, {770,9.7847714}, {775,9.6759143}, {780,10.0352857}, {785,10.1456286}, {790,10.3291143}, {795,10.4283714}, {800,10.7655714}, {805,10.9384571}, {810,10.9783143}, {815,11.2078000}, {820,11.3002286}, {825,11.5623429}, {830,11.6096857}, {835,11.7047143}, {840,12.2426857}, {845,12.3416000}, {850,12.2571429}, {855,12.7730857}, {860,12.7983429}, {865,13.2681714}, {870,13.4032571}, {875,13.6231143}, {880,13.9602000}, {885,13.7358571}, {890,14.2511143}, {895,14.2726857}, {900,14.4606000}, {905,14.8289143}, {910,15.1522571}, {915,15.1325429}, {920,15.4457143}, {925,15.5871429}, {930,15.9238857}, {935,16.1032286}, {940,16.0821429}, {945,16.5326857}, {950,16.6345714}, {955,16.5546000}, {960,17.0201714}, {965,17.5818286}, {970,17.1445714}, {975,17.6022857}, {980,18.2796286}, {985,18.2425714}, {990,18.5787143}, {995,19.0813714}, {1000,19.2943714}, {1010,19.6562286}, {1020,20.1168000}, {1030,20.8150857}, {1040,21.1974857}, {1050,22.0018571}, {1060,22.5033143}, {1070,23.2302000}, {1080,23.7994286}, {1090,24.3305143}, {1100,24.9759714}, {1110,25.7025429}, {1120,26.4641714}, {1130,26.7234286}, {1140,27.9053714}, {1150,28.5174286}, {1160,28.9398000}, {1170,29.3486857}, {1180,30.4500571}, {1190,31.0862571}, {1200,32.1349429}, {1210,32.6579143}, {1220,33.3411143}, {1230,34.1012571}, {1240,34.7168857}, {1250,35.6688000}, {1260,36.6592571}, {1270,37.2851714}, {1280,38.0561429}, {1290,38.6635143}, {1300,39.7266857}, {1310,40.5542571}, {1320,41.6470857}, {1330,42.2030857}, {1340,43.1473714}, {1350,43.8659143}, {1360,45.7459143}, {1370,46.2338857}, {1380,47.2455714}, {1390,48.6465429}, {1400,49.3514286}, {1410,50.1950857}, {1420,51.4848000}, {1430,52.2291143}, {1440,53.5292000}, {1450,54.2499714}, {1460,55.8694857}, {1470,56.6288286}, {1480,57.8882571}, {1490,59.4357143}, {1500,60.2132571}, {1510,61.2080571}, {1520,62.7901714}, {1530,63.1846571}, {1540,65.0386000}, {1550,66.2626000}, {1560,67.5752857}, {1570,68.8718571}, {1580,69.8955714}, {1590,71.3187714}, {1600,72.7052571}, {1610,73.5138286}, {1620,76.1195143}, {1630,76.1982286}, {1640,78.0545714}, {1650,79.2094571}, {1660,79.4974286}, {1670,82.0155429}, {1680,83.4313143}, {1690,85.3875143}, {1700,86.7003429}, {1710,88.0465429}, {1720,90.2205143}, {1730,91.3083714}, {1740,93.1479429}, {1750,94.7986857}, {1760,95.6064571}, {1770,97.6869143}, {1780,98.7938857}, {1790,101.3361714}, {1800,102.4104571}, {1810,105.1380857}, {1820,105.7617429}, {1830,106.5018857}, {1840,108.2282000}, {1850,110.2510000}, {1860,113.2855143}, {1870,115.8255143}, {1880,116.8327143}, {1890,120.5414857}, {1900,120.1410571}, {1910,123.3279143}, {1920,126.4369143}, {1930,125.2636286}, {1940,127.1783143}, {1950,129.6567143}, {1960,130.4997143}, {1970,134.0552000}, {1980,134.5676286}, {1990,137.6238286}, {2000,140.8707714}};
data["big"]["LtacTCGallinaCtx"]["Aggregate"]["user"] = {{1,0.00124752}, {2,0.00144554}, {3,0.00218812}, {4,0.00251485}, {5,0.00254455}, {6,0.00279208}, {7,0.00380198}, {8,0.00369307}, {9,0.00414851}, {10,0.00480198}, {11,0.00485149}, {12,0.00515842}, {13,0.00592079}, {14,0.00642574}, {15,0.00666337}, {16,0.00723762}, {17,0.00794059}, {18,0.00845545}, {19,0.00883168}, {20,0.00950495}, {21,0.01024752}, {22,0.01075248}, {23,0.01123762}, {24,0.01199010}, {25,0.01333663}, {26,0.01306931}, {27,0.01387129}, {28,0.01439604}, {29,0.01499010}, {30,0.01589109}, {31,0.01654455}, {32,0.01727723}, {33,0.01807921}, {34,0.01844554}, {35,0.02003960}, {36,0.02355446}, {37,0.02344554}, {38,0.02230693}, {39,0.02288119}, {40,0.02422772}, {41,0.02521782}, {42,0.02609901}, {43,0.02713861}, {44,0.02938614}, {45,0.02892079}, {46,0.02952475}, {47,0.03264356}, {48,0.03224752}, {49,0.03586139}, {50,0.03323762}, {51,0.03808911}, {52,0.03576238}, {53,0.03898020}, {54,0.03790099}, {55,0.03902970}, {56,0.04123762}, {57,0.04630693}, {58,0.04250495}, {59,0.04283168}, {60,0.04454455}, {61,0.04555446}, {62,0.04628713}, {63,0.04838614}, {64,0.04954455}, {65,0.05081188}, {66,0.05252475}, {67,0.06250495}, {68,0.05755446}, {69,0.05556436}, {70,0.05752475}, {71,0.06112871}, {72,0.06032673}, {73,0.06558416}, {74,0.06300000}, {75,0.06500990}, {76,0.14644554}, {77,0.06722772}, {78,0.06956436}, {79,0.09613861}, {80,0.08200000}, {81,0.07392079}, {82,0.07599010}, {83,0.07729703}, {84,0.07859406}, {85,0.08867327}, {86,0.09973267}, {87,0.10530693}, {88,0.10677228}, {89,0.10531683}, {90,0.10383168}, {91,0.11251485}, {92,0.11642574}, {93,0.11369307}, {94,0.11073267}, {95,0.11382178}, {96,0.11709901}, {97,0.11764356}, {98,0.12010891}, {99,0.12227723}, {100,0.12494059}, {101,0.12681188}, {102,0.12991089}, {103,0.12535644}, {104,0.12877228}, {105,0.13133663}, {106,0.13377228}, {107,0.13530693}, {108,0.13628713}, {109,0.13876238}, {110,0.14052475}, {111,0.14391089}, {112,0.14442574}, {113,0.14650495}, {114,0.14896040}, {115,0.15169307}, {116,0.15343564}, {117,0.15701980}, {118,0.15830693}, {119,0.16126733}, {120,0.16446535}, {121,0.16693069}, {122,0.16859406}, {123,0.17307921}, {124,0.17424752}, {125,0.17661386}, {126,0.17998020}, {127,0.18225743}, {128,0.18450495}, {129,0.18769307}, {130,0.19060396}, {131,0.19236634}, {132,0.19568317}, {133,0.19772277}, {134,0.20050495}, {135,0.20374257}, {136,0.20817822}, {137,0.20920792}, {138,0.21287129}, {139,0.21519802}, {140,0.21585149}, {141,0.22196040}, {142,0.22292079}, {143,0.22696040}, {144,0.23152475}, {145,0.23221782}, {146,0.23586139}, {147,0.23900000}, {148,0.24205941}, {149,0.24586139}, {150,0.25000990}, {151,0.25077228}, {152,0.25378218}, {153,0.25816832}, {154,0.26135644}, {155,0.26421782}, {156,0.26817822}, {157,0.26999010}, {158,0.27648515}, {159,0.27734653}, {160,0.28121782}, {161,0.28437624}, {162,0.28589109}, {163,0.30155446}, {164,0.29140594}, {165,0.29705941}, {166,0.30043564}, {167,0.30148515}, {168,0.30385149}, {169,0.31116832}, {170,0.31324752}, {171,0.31641584}, {172,0.32344554}, {173,0.32410891}, {174,0.32893069}, {175,0.33092079}, {176,0.33373267}, {177,0.33894059}, {178,0.34229703}, {179,0.34863366}, {180,0.35410891}, {181,0.35744554}, {182,0.36492079}, {183,0.36849505}, {184,0.37408911}, {185,0.37830693}, {186,0.38270297}, {187,0.38785149}, {188,0.38881188}, {189,0.39491089}, {190,0.39468317}, {191,0.39847525}, {192,0.40162376}, {193,0.40437624}, {194,0.40719802}, {195,0.41154455}, {196,0.41352475}, {197,0.41600990}, {198,0.42035644}, {199,0.43094059}, {200,0.44058416}, {201,0.43583168}, {202,0.43669307}, {203,0.44419802}, {204,0.44622772}, {205,0.45856436}, {206,0.46884158}, {207,0.46043564}, {208,0.46375248}, {209,0.46859406}, {210,0.48081188}, {211,0.49201980}, {212,0.48374257}, {213,0.48478218}, {214,0.50101980}, {215,0.51107921}, {216,0.50155446}, {217,0.50587129}, {218,0.52276238}, {219,0.52217822}, {220,0.52154455}, {221,0.54163366}, {222,0.53632673}, {223,0.53977228}, {224,0.55178218}, {225,0.55071287}, {226,0.55978218}, {227,0.55748515}, {228,0.56620792}, {229,0.57518812}, {230,0.57458416}, {231,0.59128713}, {232,0.58218812}, {233,0.60285149}, {234,0.59169307}, {235,0.61092079}, {236,0.60140594}, {237,0.67446535}, {238,0.61582178}, {239,0.70167327}, {240,0.62878218}, {241,0.63147525}, {242,0.64186139}, {243,0.64278218}, {244,0.65070297}, {245,0.72000000}, {246,0.65833663}, {247,0.67004950}, {248,0.67271287}, {249,0.67274257}, {250,0.68891089}, {251,0.68606931}, {252,0.69061386}, {253,0.70498020}, {254,0.70696040}, {255,0.70796040}, {256,0.72122772}, {257,0.72601980}, {258,0.72591089}, {259,0.73189109}, {260,0.73882178}, {261,0.74971287}, {262,0.75955446}, {263,0.76513861}, {264,0.76589109}, {265,0.77034653}, {266,0.77259406}, {267,0.78121782}, {268,0.79141584}, {269,0.79737624}, {270,0.80102970}, {271,0.80381188}, {272,0.81618812}, {273,0.82179208}, {274,0.83056436}, {275,0.83596040}, {276,0.84595050}, {277,0.85052475}, {278,0.85827723}, {279,0.86505941}, {280,0.86830693}, {281,0.87531683}, {282,0.88566337}, {283,0.89551485}, {284,0.90783168}, {285,0.91332673}, {286,0.92310891}, {287,0.92447525}, {288,0.93266337}, {289,0.93780198}, {290,0.94070297}, {291,0.94631683}, {292,0.94824752}, {293,0.95195050}, {294,0.96015842}, {295,0.96660396}, {296,0.97400990}, {297,0.99226733}, {298,0.99427723}, {299,0.99047525}, {300,0.99586139}, {301,1.0521429}, {302,1.1457429}, {303,1.1102571}, {304,1.1106000}, {305,1.0838286}, {306,1.1018857}, {307,1.1294000}, {308,1.1097429}, {309,1.1140286}, {310,1.1697714}, {311,1.1314286}, {312,1.1384571}, {313,1.1583429}, {314,1.1606286}, {315,1.1667714}, {316,1.1739429}, {317,1.1797714}, {318,1.1887429}, {319,1.1960000}, {320,1.2074857}, {321,1.2030571}, {322,1.2569143}, {323,1.2477429}, {324,1.2312571}, {325,1.2640571}, {326,1.2482286}, {327,1.2538286}, {328,1.2668286}, {329,1.2747429}, {330,1.2824286}, {331,1.3036286}, {332,1.2936000}, {333,1.3301429}, {334,1.3013714}, {335,1.3390857}, {336,1.3271429}, {337,1.3363143}, {338,1.3438571}, {339,1.3506286}, {340,1.3806571}, {341,1.3685714}, {342,1.3862286}, {343,1.3968286}, {344,1.4120286}, {345,1.4140286}, {346,1.4218857}, {347,1.4286000}, {348,1.4378571}, {349,1.4476000}, {350,1.4829143}, {351,1.4791143}, {352,1.4763429}, {353,1.4917143}, {354,1.4940857}, {355,1.5063143}, {356,1.5083143}, {357,1.5250286}, {358,1.5337429}, {359,1.5427429}, {360,1.5491143}, {361,1.5611714}, {362,1.5726571}, {363,1.5795429}, {364,1.5942000}, {365,1.6039143}, {366,1.6014000}, {367,1.6175143}, {368,1.6293143}, {369,1.6364286}, {370,1.6458000}, {371,1.6633429}, {372,1.6694571}, {373,1.6804286}, {374,1.6796571}, {375,1.7087143}, {376,1.7142286}, {377,1.7182571}, {378,1.7276857}, {379,1.7326286}, {380,1.7492286}, {381,1.7576857}, {382,1.7711429}, {383,1.7817143}, {384,1.7997143}, {385,1.8096000}, {386,1.8285429}, {387,1.8413143}, {388,1.8423143}, {389,1.8596571}, {390,1.8773429}, {391,1.8816000}, {392,1.8936286}, {393,1.9028571}, {394,1.9116000}, {395,1.9320000}, {396,1.9354000}, {397,1.9555143}, {398,1.9771714}, {399,1.9715714}, {400,1.9842571}, {401,1.9984000}, {402,2.0114571}, {403,2.0281714}, {404,2.0383429}, {405,2.0597429}, {406,2.0631714}, {407,2.0644000}, {408,2.0809143}, {409,2.0994286}, {410,2.0999143}, {411,2.1093429}, {412,2.1074000}, {413,2.1315143}, {414,2.1390571}, {415,2.1570857}, {416,2.1526857}, {417,2.1571714}, {418,2.1711429}, {419,2.1787429}, {420,2.1971143}, {421,2.2176857}, {422,2.2137429}, {423,2.2289714}, {424,2.2306571}, {425,2.2429143}, {426,2.2645143}, {427,2.3205429}, {428,2.3095714}, {429,2.3210857}, {430,2.3215714}, {431,2.3374571}, {432,2.3578000}, {433,2.3668571}, {434,2.4027714}, {435,2.3950857}, {436,2.4098286}, {437,2.4118286}, {438,2.4308000}, {439,2.4588857}, {440,2.4754000}, {441,2.4746571}, {442,2.4892000}, {443,2.5046571}, {444,2.5176571}, {445,2.5270000}, {446,2.5395143}, {447,2.5522286}, {448,2.5616286}, {449,2.5789714}, {450,2.6017143}, {451,2.6028286}, {452,2.6127714}, {453,2.6338857}, {454,2.6476857}, {455,2.6702857}, {456,2.6709143}, {457,2.6852286}, {458,2.7090571}, {459,2.7271143}, {460,2.7355143}, {461,2.7431714}, {462,2.7782857}, {463,2.7790000}, {464,2.8135143}, {465,2.8084571}, {466,2.8176000}, {467,2.9159143}, {468,2.8462000}, {469,2.8584571}, {470,2.9201714}, {471,2.9129429}, {472,2.9241429}, {473,2.9822571}, {474,2.9420571}, {475,2.9324000}, {476,2.9356286}, {477,3.0006857}, {478,2.9709429}, {479,3.0331714}, {480,3.0025714}, {481,3.0261714}, {482,3.0283429}, {483,3.0597429}, {484,3.1058857}, {485,3.0885429}, {486,3.1343143}, {487,3.1180857}, {488,3.1305714}, {489,3.1293429}, {490,3.1364000}, {491,3.1569143}, {492,3.1797143}, {493,3.1986000}, {494,3.2311143}, {495,3.2414000}, {496,3.2580286}, {497,3.2789429}, {498,3.2867143}, {499,3.3059143}, {500,3.3186857}, {505,3.3943143}, {510,3.4732857}, {515,3.5533714}, {520,3.6351429}, {525,3.7214000}, {530,3.8484857}, {535,3.8900000}, {540,4.0723429}, {545,4.0408286}, {550,4.2084571}, {555,4.2542571}, {560,4.3228286}, {565,4.4613429}, {570,4.5174000}, {575,4.6364286}, {580,4.7615143}, {585,4.8393429}, {590,4.9918000}, {595,5.1800286}, {600,5.2459429}, {605,5.3173143}, {610,5.3681143}, {615,5.5426000}, {620,5.6777429}, {625,5.8514286}, {630,5.9230000}, {635,5.9584857}, {640,6.1683143}, {645,6.3037143}, {650,6.3639143}, {655,6.3809143}, {660,6.4348857}, {665,6.6108286}, {670,6.7747714}, {675,6.8979714}, {680,7.1088857}, {685,7.2117714}, {690,7.3717143}, {695,7.3883143}, {700,7.6816286}, {705,7.7685714}, {710,8.0169143}, {715,7.9590286}, {720,8.1065429}, {725,8.3573714}, {730,8.2887714}, {735,8.6224286}, {740,8.7476571}, {745,9.0040286}, {750,9.1115143}, {755,9.3653714}, {760,9.5194571}, {765,9.7310571}, {770,9.7704571}, {775,9.6614286}, {780,10.0200571}, {785,10.1320286}, {790,10.3060000}, {795,10.4113714}, {800,10.7425143}, {805,10.9036286}, {810,10.9366857}, {815,11.1881714}, {820,11.2806286}, {825,11.5369714}, {830,11.5913143}, {835,11.6735714}, {840,12.2262000}, {845,12.3250571}, {850,12.2418000}, {855,12.7561429}, {860,12.7806857}, {865,13.2532286}, {870,13.3901429}, {875,13.6128857}, {880,13.9518000}, {885,13.7305429}, {890,14.2454286}, {895,14.2610857}, {900,14.4455143}, {905,14.8151143}, {910,15.1332571}, {915,15.1083714}, {920,15.4272857}, {925,15.5687714}, {930,15.9049429}, {935,16.0798571}, {940,16.0586000}, {945,16.5143143}, {950,16.6223143}, {955,16.5434571}, {960,17.0028000}, {965,17.5614857}, {970,17.1177714}, {975,17.5779143}, {980,18.2515714}, {985,18.2133714}, {990,18.5401429}, {995,19.0430000}, {1000,19.2508000}, {1010,19.6126571}, {1020,20.0733143}, {1030,20.7713429}, {1040,21.1603429}, {1050,21.9384857}, {1060,22.4668000}, {1070,23.2025429}, {1080,23.7232000}, {1090,24.3042571}, {1100,24.9491714}, {1110,25.6653429}, {1120,26.4206571}, {1130,26.6929429}, {1140,27.7728286}, {1150,28.4804286}, {1160,28.9079143}, {1170,29.3200286}, {1180,30.4106571}, {1190,31.0552286}, {1200,32.1042000}, {1210,32.6214857}, {1220,33.3049429}, {1230,34.0491143}, {1240,34.6716571}, {1250,35.6120000}, {1260,36.5927714}, {1270,37.2288857}, {1280,38.0011143}, {1290,38.6080286}, {1300,39.6824857}, {1310,40.5186286}, {1320,41.6052000}, {1330,42.1573143}, {1340,43.1086857}, {1350,43.8199429}, {1360,45.6851714}, {1370,46.1748000}, {1380,47.1915429}, {1390,48.5915429}, {1400,49.3060286}, {1410,50.1463714}, {1420,51.4343714}, {1430,52.1684571}, {1440,53.4810571}, {1450,54.1744286}, {1460,55.7930000}, {1470,56.5659143}, {1480,57.8276857}, {1490,59.3722571}, {1500,60.1416857}, {1510,61.1321143}, {1520,62.6944571}, {1530,63.1005429}, {1540,64.9702286}, {1550,66.1885714}, {1560,67.4887714}, {1570,68.8062857}, {1580,69.8120286}, {1590,71.2221429}, {1600,72.6157429}, {1610,73.4375714}, {1620,76.0457714}, {1630,76.1191714}, {1640,77.9668571}, {1650,79.1184286}, {1660,79.4156857}, {1670,81.9209143}, {1680,83.3462000}, {1690,85.2902286}, {1700,86.6003429}, {1710,87.9642286}, {1720,90.1199143}, {1730,91.1844286}, {1740,93.0257714}, {1750,94.6903714}, {1760,95.5002000}, {1770,97.5586000}, {1780,98.6759143}, {1790,101.2116857}, {1800,102.3307429}, {1810,105.0590571}, {1820,105.6828286}, {1830,106.4224286}, {1840,108.0814571}, {1850,110.1255429}, {1860,113.1627714}, {1870,115.6527429}, {1880,116.7216286}, {1890,120.4130571}, {1900,120.0274000}, {1910,123.2444571}, {1920,126.3675143}, {1930,125.1616857}, {1940,127.0510000}, {1950,129.5599143}, {1960,130.3085714}, {1970,133.9814857}, {1980,134.4915143}, {1990,137.5493429}, {2000,140.7868000}};
data["big"]["LtacTCGallinaCtx"]["Aggregate"]["system"] = {{1,0.00006931}, {2,0.00000000}, {3,0.00007921}, {4,0.00000000}, {5,0.00000000}, {6,0.00006931}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00015842}, {12,0.00000000}, {13,0.00000000}, {14,0.00011881}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00007921}, {19,0.00000000}, {20,0.00019802}, {21,0.00003960}, {22,0.00000000}, {23,0.00007921}, {24,0.00000000}, {25,0.00007921}, {26,0.00003960}, {27,0.00007921}, {28,0.00003960}, {29,0.00000000}, {30,0.00023762}, {31,0.00000000}, {32,0.00003960}, {33,0.00003960}, {34,0.00003960}, {35,0.00003960}, {36,0.00011881}, {37,0.00003960}, {38,0.00003960}, {39,0.00003960}, {40,0.00011881}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00003960}, {45,0.00011881}, {46,0.00003960}, {47,0.00011881}, {48,0.00003960}, {49,0.00003960}, {50,0.00007921}, {51,0.00003960}, {52,0.00007921}, {53,0.00000000}, {54,0.00003960}, {55,0.00003960}, {56,0.00000000}, {57,0.00000000}, {58,0.00011881}, {59,0.00007921}, {60,0.00010891}, {61,0.00007921}, {62,0.00011881}, {63,0.00006931}, {64,0.00015842}, {65,0.00006931}, {66,0.00015842}, {67,0.00003960}, {68,0.00000000}, {69,0.00011881}, {70,0.00007921}, {71,0.00000000}, {72,0.00007921}, {73,0.00000000}, {74,0.00003960}, {75,0.00000000}, {76,0.00030693}, {77,0.00011881}, {78,0.00006931}, {79,0.00011881}, {80,0.00000000}, {81,0.00003960}, {82,0.00003960}, {83,0.00011881}, {84,0.00011881}, {85,0.00007921}, {86,0.00003960}, {87,0.00007921}, {88,0.00007921}, {89,0.00003960}, {90,0.00003960}, {91,0.00003960}, {92,0.00007921}, {93,0.00003960}, {94,0.00003960}, {95,0.00003960}, {96,0.00011881}, {97,0.00003960}, {98,0.00003960}, {99,0.00000000}, {100,0.00007921}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00003960}, {106,0.00007921}, {107,0.00000000}, {108,0.00003960}, {109,0.00003960}, {110,0.00003960}, {111,0.00002970}, {112,0.00003960}, {113,0.00007921}, {114,0.00019802}, {115,0.00007921}, {116,0.00003960}, {117,0.00003960}, {118,0.00014851}, {119,0.00003960}, {120,0.00003960}, {121,0.00011881}, {122,0.00002970}, {123,0.00007921}, {124,0.00011881}, {125,0.00011881}, {126,0.00003960}, {127,0.00015842}, {128,0.00007921}, {129,0.00007921}, {130,0.00003960}, {131,0.00007921}, {132,0.00014851}, {133,0.00000000}, {134,0.00000000}, {135,0.00006931}, {136,0.00003960}, {137,0.00003960}, {138,0.00011881}, {139,0.00011881}, {140,0.00011881}, {141,0.00003960}, {142,0.00015842}, {143,0.00003960}, {144,0.00011881}, {145,0.00011881}, {146,0.00011881}, {147,0.00014851}, {148,0.00011881}, {149,0.00010891}, {150,0.00007921}, {151,0.00011881}, {152,0.00011881}, {153,0.00003960}, {154,0.00000000}, {155,0.00010891}, {156,0.00019802}, {157,0.00007921}, {158,0.00003960}, {159,0.00000000}, {160,0.00011881}, {161,0.00011881}, {162,0.00007921}, {163,0.00007921}, {164,0.00007921}, {165,0.00007921}, {166,0.00000000}, {167,0.00003960}, {168,0.00003960}, {169,0.00000000}, {170,0.00000000}, {171,0.00003960}, {172,0.00011881}, {173,0.00011881}, {174,0.00011881}, {175,0.00007921}, {176,0.00003960}, {177,0.00003960}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00015842}, {183,0.00007921}, {184,0.00015842}, {185,0.00017822}, {186,0.00011881}, {187,0.00003960}, {188,0.00015842}, {189,0.00000000}, {190,0.00007921}, {191,0.00007921}, {192,0.00003960}, {193,0.00010891}, {194,0.00000000}, {195,0.00019802}, {196,0.00003960}, {197,0.00007921}, {198,0.00003960}, {199,0.00011881}, {200,0.00007921}, {201,0.00015842}, {202,0.00007921}, {203,0.00011881}, {204,0.00011881}, {205,0.00007921}, {206,0.00019802}, {207,0.00003960}, {208,0.00007921}, {209,0.00000000}, {210,0.00011881}, {211,0.00007921}, {212,0.00003960}, {213,0.00007921}, {214,0.00015842}, {215,0.00007921}, {216,0.00007921}, {217,0.00003960}, {218,0.00000000}, {219,0.00014851}, {220,0.00023762}, {221,0.00015842}, {222,0.00011881}, {223,0.00007921}, {224,0.00007921}, {225,0.00019802}, {226,0.00015842}, {227,0.00011881}, {228,0.00015842}, {229,0.00015842}, {230,0.00007921}, {231,0.00003960}, {232,0.00000000}, {233,0.00023762}, {234,0.00003960}, {235,0.00000000}, {236,0.00015842}, {237,0.00019802}, {238,0.00011881}, {239,0.00022772}, {240,0.00015842}, {241,0.00011881}, {242,0.00015842}, {243,0.00011881}, {244,0.00011881}, {245,0.00003960}, {246,0.00011881}, {247,0.00007921}, {248,0.00011881}, {249,0.00011881}, {250,0.00015842}, {251,0.00011881}, {252,0.00007921}, {253,0.00023762}, {254,0.00015842}, {255,0.00011881}, {256,0.00007921}, {257,0.00007921}, {258,0.00019802}, {259,0.00007921}, {260,0.00015842}, {261,0.00011881}, {262,0.00011881}, {263,0.00022772}, {264,0.00006931}, {265,0.00007921}, {266,0.00026733}, {267,0.00015842}, {268,0.00011881}, {269,0.00035644}, {270,0.00011881}, {271,0.00003960}, {272,0.00019802}, {273,0.00007921}, {274,0.00015842}, {275,0.00011881}, {276,0.00003960}, {277,0.00003960}, {278,0.00015842}, {279,0.00019802}, {280,0.00011881}, {281,0.00019802}, {282,0.00011881}, {283,0.00007921}, {284,0.00019802}, {285,0.00026733}, {286,0.00031683}, {287,0.00003960}, {288,0.00000000}, {289,0.00003960}, {290,0.00018812}, {291,0.00015842}, {292,0.00035644}, {293,0.00003960}, {294,0.00007921}, {295,0.00023762}, {296,0.00003960}, {297,0.00023762}, {298,0.00023762}, {299,0.00015842}, {300,0.00018812}, {301,0.0002286}, {302,0.0006571}, {303,0.0001143}, {304,0.0002286}, {305,0.0003429}, {306,0.0002286}, {307,0.0002286}, {308,0.0004571}, {309,0.0004286}, {310,0.0002286}, {311,0.0000000}, {312,0.0002286}, {313,0.0002286}, {314,0.0001143}, {315,0.0001143}, {316,0.0001143}, {317,0.0000000}, {318,0.0001143}, {319,0.0001143}, {320,0.0003429}, {321,0.0003429}, {322,0.0006857}, {323,0.0001143}, {324,0.0001143}, {325,0.0001143}, {326,0.0000000}, {327,0.0000000}, {328,0.0003429}, {329,0.0012571}, {330,0.0000000}, {331,0.0000000}, {332,0.0003429}, {333,0.0003429}, {334,0.0001143}, {335,0.0004571}, {336,0.0000000}, {337,0.0001143}, {338,0.0002286}, {339,0.0003429}, {340,0.0001143}, {341,0.0003429}, {342,0.0000000}, {343,0.0001143}, {344,0.0001143}, {345,0.0003429}, {346,0.0001143}, {347,0.0002286}, {348,0.0001143}, {349,0.0001143}, {350,0.0002286}, {351,0.0005714}, {352,0.0001143}, {353,0.0001143}, {354,0.0002286}, {355,0.0001143}, {356,0.0003429}, {357,0.0001143}, {358,0.0001143}, {359,0.0001143}, {360,0.0002286}, {361,0.0000000}, {362,0.0002286}, {363,0.0002286}, {364,0.0001143}, {365,0.0009143}, {366,0.0000000}, {367,0.0001143}, {368,0.0001143}, {369,0.0005714}, {370,0.0003429}, {371,0.0001143}, {372,0.0005714}, {373,0.0000000}, {374,0.0006857}, {375,0.0003429}, {376,0.0001143}, {377,0.0002286}, {378,0.0004571}, {379,0.0002286}, {380,0.0002286}, {381,0.0005714}, {382,0.0005714}, {383,0.0004571}, {384,0.0000000}, {385,0.0005714}, {386,0.0003143}, {387,0.0003429}, {388,0.0003429}, {389,0.0005714}, {390,0.0001143}, {391,0.0002000}, {392,0.0004571}, {393,0.0004571}, {394,0.0004571}, {395,0.0004571}, {396,0.0001143}, {397,0.0001143}, {398,0.0006857}, {399,0.0004571}, {400,0.0002286}, {401,0.0002286}, {402,0.0002286}, {403,0.0002286}, {404,0.0002286}, {405,0.0006857}, {406,0.0005714}, {407,0.0004571}, {408,0.0002286}, {409,0.0004571}, {410,0.0004286}, {411,0.0006571}, {412,0.0003429}, {413,0.0002286}, {414,0.0003429}, {415,0.0000000}, {416,0.0003429}, {417,0.0005714}, {418,0.0000000}, {419,0.0002286}, {420,0.0002286}, {421,0.0001143}, {422,0.0002286}, {423,0.0003429}, {424,0.0003429}, {425,0.0009143}, {426,0.0004571}, {427,0.0003143}, {428,0.0004571}, {429,0.0005714}, {430,0.0002286}, {431,0.0006857}, {432,0.0004571}, {433,0.0003429}, {434,0.0006857}, {435,0.0008000}, {436,0.0003429}, {437,0.0005714}, {438,0.0004571}, {439,0.0002286}, {440,0.0001143}, {441,0.0002286}, {442,0.0003429}, {443,0.0003429}, {444,0.0006857}, {445,0.0002286}, {446,0.0003429}, {447,0.0003429}, {448,0.0004571}, {449,0.0004571}, {450,0.0003429}, {451,0.0005429}, {452,0.0003429}, {453,0.0005714}, {454,0.0006857}, {455,0.0004571}, {456,0.0010286}, {457,0.0005714}, {458,0.0003429}, {459,0.0006857}, {460,0.0003429}, {461,0.0002286}, {462,0.0002286}, {463,0.0004571}, {464,0.0003429}, {465,0.0004571}, {466,0.0006857}, {467,0.0004571}, {468,0.0012286}, {469,0.0003429}, {470,0.0012571}, {471,0.0004571}, {472,0.0008000}, {473,0.0003429}, {474,0.0003429}, {475,0.0017143}, {476,0.0001143}, {477,0.0007714}, {478,0.0003429}, {479,0.0004571}, {480,0.0005429}, {481,0.0005714}, {482,0.0014857}, {483,0.0005714}, {484,0.0010286}, {485,0.0016000}, {486,0.0012571}, {487,0.0010286}, {488,0.0009143}, {489,0.0005714}, {490,0.0003429}, {491,0.0005714}, {492,0.0005714}, {493,0.0004571}, {494,0.0017714}, {495,0.0007714}, {496,0.0006571}, {497,0.0009143}, {498,0.0014857}, {499,0.0007714}, {500,0.0013714}, {505,0.0014571}, {510,0.0003429}, {515,0.0016000}, {520,0.0020571}, {525,0.0022571}, {530,0.0027429}, {535,0.0018000}, {540,0.0031429}, {545,0.0027143}, {550,0.0021714}, {555,0.0014857}, {560,0.0018000}, {565,0.0019429}, {570,0.0010000}, {575,0.0008000}, {580,0.0012571}, {585,0.0014571}, {590,0.0022857}, {595,0.0019143}, {600,0.0016000}, {605,0.0020286}, {610,0.0027143}, {615,0.0012571}, {620,0.0024000}, {625,0.0028000}, {630,0.0017143}, {635,0.0019429}, {640,0.0020571}, {645,0.0033143}, {650,0.0030857}, {655,0.0013714}, {660,0.0032571}, {665,0.0034000}, {670,0.0022571}, {675,0.0017143}, {680,0.0026286}, {685,0.0029714}, {690,0.0015714}, {695,0.0023714}, {700,0.0022857}, {705,0.0027429}, {710,0.0026286}, {715,0.0020571}, {720,0.0026000}, {725,0.0044286}, {730,0.0027429}, {735,0.0030857}, {740,0.0016857}, {745,0.0029429}, {750,0.0028286}, {755,0.0029429}, {760,0.0038286}, {765,0.0022857}, {770,0.0040000}, {775,0.0039714}, {780,0.0040000}, {785,0.0039143}, {790,0.0033143}, {795,0.0046857}, {800,0.0040857}, {805,0.0046286}, {810,0.0046571}, {815,0.0031714}, {820,0.0050286}, {825,0.0026000}, {830,0.0027143}, {835,0.0034286}, {840,0.0029714}, {845,0.0035143}, {850,0.0017143}, {855,0.0033143}, {860,0.0040000}, {865,0.0036286}, {870,0.0030571}, {875,0.0029714}, {880,0.0042571}, {885,0.0029143}, {890,0.0028286}, {895,0.0039714}, {900,0.0075429}, {905,0.0040571}, {910,0.0038286}, {915,0.0053143}, {920,0.0022857}, {925,0.0041143}, {930,0.0036000}, {935,0.0054286}, {940,0.0052000}, {945,0.0046286}, {950,0.0031714}, {955,0.0028571}, {960,0.0059714}, {965,0.0032857}, {970,0.0040000}, {975,0.0027143}, {980,0.0027429}, {985,0.0033143}, {990,0.0046286}, {995,0.0058571}, {1000,0.0078857}, {1010,0.0042571}, {1020,0.0038286}, {1030,0.0030286}, {1040,0.0048571}, {1050,0.0076000}, {1060,0.0046000}, {1070,0.0073143}, {1080,0.0076857}, {1090,0.0056571}, {1100,0.0053714}, {1110,0.0055429}, {1120,0.0072571}, {1130,0.0058857}, {1140,0.0082857}, {1150,0.0081429}, {1160,0.0064857}, {1170,0.0075714}, {1180,0.0106571}, {1190,0.0058286}, {1200,0.0064286}, {1210,0.0077714}, {1220,0.0067429}, {1230,0.0114857}, {1240,0.0101429}, {1250,0.0078857}, {1260,0.0125143}, {1270,0.0092571}, {1280,0.0090571}, {1290,0.0119714}, {1300,0.0097429}, {1310,0.0040857}, {1320,0.0068857}, {1330,0.0131714}, {1340,0.0066857}, {1350,0.0086000}, {1360,0.0186000}, {1370,0.0139429}, {1380,0.0098571}, {1390,0.0177143}, {1400,0.0116571}, {1410,0.0099143}, {1420,0.0137714}, {1430,0.0108286}, {1440,0.0156571}, {1450,0.0163143}, {1460,0.0154571}, {1470,0.0091429}, {1480,0.0153143}, {1490,0.0257429}, {1500,0.0168000}, {1510,0.0251714}, {1520,0.0223714}, {1530,0.0236286}, {1540,0.0199714}, {1550,0.0215143}, {1560,0.0238286}, {1570,0.0225714}, {1580,0.0273714}, {1590,0.0257714}, {1600,0.0264000}, {1610,0.0213714}, {1620,0.0243714}, {1630,0.0200000}, {1640,0.0269143}, {1650,0.0276286}, {1660,0.0192286}, {1670,0.0306000}, {1680,0.0166857}, {1690,0.0241714}, {1700,0.0225143}, {1710,0.0213714}, {1720,0.0302000}, {1730,0.0280857}, {1740,0.0302857}, {1750,0.0298286}, {1760,0.0311429}, {1770,0.0304857}, {1780,0.0272571}, {1790,0.0357429}, {1800,0.0359429}, {1810,0.0380286}, {1820,0.0326857}, {1830,0.0332857}, {1840,0.0380857}, {1850,0.0332286}, {1860,0.0408857}, {1870,0.0358000}, {1880,0.0313143}, {1890,0.0405429}, {1900,0.0309143}, {1910,0.0325714}, {1920,0.0382857}, {1930,0.0392571}, {1940,0.0434571}, {1950,0.0397143}, {1960,0.0293429}, {1970,0.0423714}, {1980,0.0428571}, {1990,0.0345143}, {2000,0.0446571}};
data["big"]["LtacTCGallinaCtx"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00100000}, {4,0.00100000}, {5,0.00100000}, {6,0.00200000}, {7,0.00200000}, {8,0.00238614}, {9,0.00300000}, {10,0.00309901}, {11,0.00400000}, {12,0.00403960}, {13,0.00445545}, {14,0.00502970}, {15,0.00565347}, {16,0.00606931}, {17,0.00673267}, {18,0.00729703}, {19,0.00759406}, {20,0.00849505}, {21,0.00888119}, {22,0.00963366}, {23,0.01051485}, {24,0.01074257}, {25,0.01260396}, {26,0.01200000}, {27,0.01273267}, {28,0.01331683}, {29,0.01403960}, {30,0.01469307}, {31,0.01554455}, {32,0.01610891}, {33,0.01694059}, {34,0.01746535}, {35,0.01903960}, {36,0.02196040}, {37,0.02217822}, {38,0.02059406}, {39,0.02161386}, {40,0.02260396}, {41,0.02359406}, {42,0.02436634}, {43,0.02554455}, {44,0.02787129}, {45,0.02725743}, {46,0.02820792}, {47,0.03080198}, {48,0.03049505}, {49,0.03446535}, {50,0.03155446}, {51,0.03673267}, {52,0.03417822}, {53,0.03746535}, {54,0.03646535}, {55,0.03787129}, {56,0.03994059}, {57,0.04455446}, {58,0.04116832}, {59,0.04148515}, {60,0.04300990}, {61,0.04397030}, {62,0.04484158}, {63,0.04638614}, {64,0.04785149}, {65,0.04900000}, {66,0.05074257}, {67,0.06107921}, {68,0.05577228}, {69,0.05387129}, {70,0.05576238}, {71,0.05937624}, {72,0.05851485}, {73,0.06390099}, {74,0.06159406}, {75,0.06325743}, {76,0.14506931}, {77,0.06559406}, {78,0.06784158}, {79,0.09474257}, {80,0.08006931}, {81,0.07163366}, {82,0.07388119}, {83,0.07513861}, {84,0.07634653}, {85,0.08695050}, {86,0.09796040}, {87,0.10317822}, {88,0.10483168}, {89,0.10320792}, {90,0.10192079}, {91,0.11037624}, {92,0.11437624}, {93,0.11190099}, {94,0.10897030}, {95,0.11187129}, {96,0.11513861}, {97,0.11563366}, {98,0.11798020}, {99,0.12027723}, {100,0.12304950}, {101,0.12455446}, {102,0.12801980}, {103,0.12320792}, {104,0.12676238}, {105,0.12937624}, {106,0.13148515}, {107,0.13334653}, {108,0.13448515}, {109,0.13680198}, {110,0.13864356}, {111,0.14183168}, {112,0.14232673}, {113,0.14442574}, {114,0.14697030}, {115,0.14960396}, {116,0.15128713}, {117,0.15483168}, {118,0.15629703}, {119,0.15888119}, {120,0.16247525}, {121,0.16517822}, {122,0.16654455}, {123,0.17068317}, {124,0.17207921}, {125,0.17449505}, {126,0.17774257}, {127,0.18045545}, {128,0.18216832}, {129,0.18539604}, {130,0.18854455}, {131,0.19005941}, {132,0.19362376}, {133,0.19524752}, {134,0.19808911}, {135,0.20138614}, {136,0.20553465}, {137,0.20692079}, {138,0.21058416}, {139,0.21316832}, {140,0.21357426}, {141,0.21956436}, {142,0.22094059}, {143,0.22463366}, {144,0.22919802}, {145,0.22974257}, {146,0.23365347}, {147,0.23665347}, {148,0.23996040}, {149,0.24358416}, {150,0.24755446}, {151,0.24854455}, {152,0.25143564}, {153,0.25576238}, {154,0.25943564}, {155,0.26210891}, {156,0.26602970}, {157,0.26739604}, {158,0.27405941}, {159,0.27508911}, {160,0.27888119}, {161,0.28224752}, {162,0.28363366}, {163,0.29886139}, {164,0.28930693}, {165,0.29439604}, {166,0.29768317}, {167,0.29895050}, {168,0.30137624}, {169,0.30885149}, {170,0.31080198}, {171,0.31382178}, {172,0.32110891}, {173,0.32171287}, {174,0.32639604}, {175,0.32831683}, {176,0.33142574}, {177,0.33626733}, {178,0.33979208}, {179,0.34603960}, {180,0.35177228}, {181,0.35503960}, {182,0.36238614}, {183,0.36604950}, {184,0.37146535}, {185,0.37598020}, {186,0.38038614}, {187,0.38509901}, {188,0.38629703}, {189,0.39228713}, {190,0.39208911}, {191,0.39586139}, {192,0.39900990}, {193,0.40181188}, {194,0.40440594}, {195,0.40888119}, {196,0.41050495}, {197,0.41334653}, {198,0.41765347}, {199,0.42820792}, {200,0.43794059}, {201,0.43303960}, {202,0.43401980}, {203,0.44134653}, {204,0.44344554}, {205,0.45612871}, {206,0.46605941}, {207,0.45766337}, {208,0.46093069}, {209,0.46594059}, {210,0.47811881}, {211,0.48903960}, {212,0.48114851}, {213,0.48179208}, {214,0.49831683}, {215,0.50790099}, {216,0.49846535}, {217,0.50272277}, {218,0.51956436}, {219,0.51953465}, {220,0.51880198}, {221,0.53855446}, {222,0.53353465}, {223,0.53655446}, {224,0.54859406}, {225,0.54761386}, {226,0.55691089}, {227,0.55464356}, {228,0.56340594}, {229,0.57255446}, {230,0.57154455}, {231,0.58810891}, {232,0.57945545}, {233,0.60043564}, {234,0.58863366}, {235,0.60777228}, {236,0.59870297}, {237,0.67151485}, {238,0.61251485}, {239,0.69908911}, {240,0.62569307}, {241,0.62856436}, {242,0.63900000}, {243,0.63987129}, {244,0.64793069}, {245,0.71726733}, {246,0.65552475}, {247,0.66744554}, {248,0.67007921}, {249,0.66983168}, {250,0.68659406}, {251,0.68304950}, {252,0.68752475}, {253,0.70207921}, {254,0.70402970}, {255,0.70521782}, {256,0.71817822}, {257,0.72309901}, {258,0.72300000}, {259,0.72887129}, {260,0.73594059}, {261,0.74681188}, {262,0.75642574}, {263,0.76214851}, {264,0.76293069}, {265,0.76729703}, {266,0.76990099}, {267,0.77804950}, {268,0.78833663}, {269,0.79451485}, {270,0.79794059}, {271,0.80092079}, {272,0.81318812}, {273,0.81867327}, {274,0.82769307}, {275,0.83291089}, {276,0.84281188}, {277,0.84740594}, {278,0.85510891}, {279,0.86180198}, {280,0.86547525}, {281,0.87233663}, {282,0.88228713}, {283,0.89193069}, {284,0.90065347}, {285,0.90672277}, {286,0.91667327}, {287,0.91805941}, {288,0.92544554}, {289,0.93483168}, {290,0.93768317}, {291,0.94323762}, {292,0.94570297}, {293,0.94881188}, {294,0.95703960}, {295,0.96353465}, {296,0.97123762}, {297,0.98945545}, {298,0.99144554}, {299,0.98780198}, {300,0.99306931}, {301,1.0484286}, {302,1.1478571}, {303,1.1067429}, {304,1.1066857}, {305,1.0807714}, {306,1.0984286}, {307,1.1260857}, {308,1.1065143}, {309,1.1110286}, {310,1.1671714}, {311,1.1277429}, {312,1.1352571}, {313,1.1553714}, {314,1.1571429}, {315,1.1636286}, {316,1.1706857}, {317,1.1765143}, {318,1.1848857}, {319,1.1929429}, {320,1.2071429}, {321,1.1995714}, {322,1.2541714}, {323,1.2434000}, {324,1.2273143}, {325,1.2609429}, {326,1.2442857}, {327,1.2506857}, {328,1.2604857}, {329,1.2698857}, {330,1.2754857}, {331,1.2979429}, {332,1.2904857}, {333,1.3306571}, {334,1.2983429}, {335,1.3520857}, {336,1.3296571}, {337,1.3330571}, {338,1.3408000}, {339,1.3472571}, {340,1.3770857}, {341,1.3651714}, {342,1.3826000}, {343,1.3932286}, {344,1.4089714}, {345,1.4112000}, {346,1.4186571}, {347,1.4254000}, {348,1.4344286}, {349,1.4440000}, {350,1.4792857}, {351,1.4761429}, {352,1.4725429}, {353,1.4876286}, {354,1.4901429}, {355,1.5030857}, {356,1.5048571}, {357,1.5204857}, {358,1.5301429}, {359,1.5393429}, {360,1.5454857}, {361,1.5576571}, {362,1.5688857}, {363,1.5762000}, {364,1.5905143}, {365,1.6010286}, {366,1.5981429}, {367,1.6143714}, {368,1.6255143}, {369,1.6332857}, {370,1.6427143}, {371,1.6597714}, {372,1.6666000}, {373,1.6763429}, {374,1.6767143}, {375,1.7048286}, {376,1.7104000}, {377,1.7151714}, {378,1.7252000}, {379,1.7297429}, {380,1.7469143}, {381,1.7550286}, {382,1.7690286}, {383,1.7792000}, {384,1.7971429}, {385,1.8075429}, {386,1.8255429}, {387,1.8376857}, {388,1.8397714}, {389,1.8568571}, {390,1.8745143}, {391,1.8788000}, {392,1.8905143}, {393,1.9103143}, {394,1.9082857}, {395,1.9283143}, {396,1.9315429}, {397,1.9524286}, {398,1.9744571}, {399,1.9692286}, {400,1.9816857}, {401,1.9946286}, {402,2.0076000}, {403,2.0254286}, {404,2.0356286}, {405,2.0606571}, {406,2.0650571}, {407,2.0682000}, {408,2.0808000}, {409,2.0967143}, {410,2.0976286}, {411,2.1072000}, {412,2.1047429}, {413,2.1296000}, {414,2.1365143}, {415,2.1538857}, {416,2.1506000}, {417,2.1550000}, {418,2.1685429}, {419,2.1756571}, {420,2.1928857}, {421,2.2127714}, {422,2.2094286}, {423,2.2239143}, {424,2.2275429}, {425,2.2408571}, {426,2.2624857}, {427,2.3179714}, {428,2.3085143}, {429,2.3194857}, {430,2.3198000}, {431,2.3359429}, {432,2.3569143}, {433,2.3654571}, {434,2.4011429}, {435,2.3926857}, {436,2.4083143}, {437,2.4098000}, {438,2.4291714}, {439,2.4575714}, {440,2.4744857}, {441,2.4740571}, {442,2.4882286}, {443,2.5032571}, {444,2.5172571}, {445,2.5261714}, {446,2.5384286}, {447,2.5511429}, {448,2.5598000}, {449,2.5772571}, {450,2.5994571}, {451,2.6008857}, {452,2.6105143}, {453,2.6315429}, {454,2.6460857}, {455,2.6687429}, {456,2.6700857}, {457,2.6842286}, {458,2.7072286}, {459,2.7251714}, {460,2.7336286}, {461,2.7406000}, {462,2.7761143}, {463,2.7761714}, {464,2.8104857}, {465,2.8062000}, {466,2.8154000}, {467,2.9132286}, {468,2.8443143}, {469,2.8552286}, {470,2.9184000}, {471,2.9114857}, {472,2.9230857}, {473,2.9805143}, {474,2.9412571}, {475,2.9324857}, {476,2.9345429}, {477,3.0004571}, {478,2.9689143}, {479,3.0323143}, {480,3.0020857}, {481,3.0261714}, {482,3.0298000}, {483,3.0601429}, {484,3.1074286}, {485,3.0904857}, {486,3.1366000}, {487,3.1194571}, {488,3.1322000}, {489,3.1292000}, {490,3.1360286}, {491,3.1566571}, {492,3.1781714}, {493,3.1962000}, {494,3.2312286}, {495,3.2410000}, {496,3.2580857}, {497,3.2783714}, {498,3.2872857}, {499,3.3066000}, {500,3.3192286}, {505,3.3954571}, {510,3.4735429}, {515,3.5560286}, {520,3.6396286}, {525,3.7251714}, {530,3.8520571}, {535,3.8937143}, {540,4.0784286}, {545,4.0462571}, {550,4.2152571}, {555,4.2598000}, {560,4.3286857}, {565,4.4662000}, {570,4.5211143}, {575,4.6398286}, {580,4.7668000}, {585,4.8438571}, {590,4.9968286}, {595,5.1853429}, {600,5.2506286}, {605,5.3216571}, {610,5.3724571}, {615,5.5446571}, {620,5.6806571}, {625,5.8559429}, {630,5.9275714}, {635,5.9632571}, {640,6.1726857}, {645,6.3073143}, {650,6.3642000}, {655,6.3779143}, {660,6.4341143}, {665,6.6113429}, {670,6.7751429}, {675,6.8965143}, {680,7.1091429}, {685,7.2150286}, {690,7.3714857}, {695,7.3892857}, {700,7.6843429}, {705,7.7688000}, {710,8.0164286}, {715,7.9606857}, {720,8.1090571}, {725,8.3634571}, {730,8.2943143}, {735,8.6251143}, {740,8.7484286}, {745,9.0055714}, {750,9.1112857}, {755,9.3659143}, {760,9.5183429}, {765,9.7302286}, {770,9.7743143}, {775,9.6654000}, {780,10.0248571}, {785,10.1349714}, {790,10.3184286}, {795,10.4176571}, {800,10.7546571}, {805,10.9276571}, {810,10.9673143}, {815,11.1966857}, {820,11.2867429}, {825,11.5498571}, {830,11.5985429}, {835,11.6936857}, {840,12.2315429}, {845,12.3303714}, {850,12.2458000}, {855,12.7617714}, {860,12.7868857}, {865,13.2567714}, {870,13.3916571}, {875,13.6115429}, {880,13.9485429}, {885,13.7224000}, {890,14.2396286}, {895,14.2608571}, {900,14.4487714}, {905,14.8139429}, {910,15.1402571}, {915,15.1203143}, {920,15.4334857}, {925,15.5749714}, {930,15.9116000}, {935,16.0911429}, {940,16.0678857}, {945,16.5194286}, {950,16.6222000}, {955,16.5422286}, {960,17.0077143}, {965,17.5694286}, {970,17.1319714}, {975,17.5897143}, {980,18.2671143}, {985,18.2288286}, {990,18.5659429}, {995,19.0666286}, {1000,19.2816000}, {1010,19.6433143}, {1020,20.1036857}, {1030,20.8019143}, {1040,21.1841429}, {1050,21.9884000}, {1060,22.4897143}, {1070,23.2166000}, {1080,23.7854571}, {1090,24.3164000}, {1100,24.9619714}, {1110,25.6884286}, {1120,26.4497429}, {1130,26.7091429}, {1140,27.8881429}, {1150,28.5028857}, {1160,28.9250286}, {1170,29.3338000}, {1180,30.4350571}, {1190,31.0687429}, {1200,32.1195143}, {1210,32.6423143}, {1220,33.3257714}, {1230,34.0849143}, {1240,34.7010000}, {1250,35.6528857}, {1260,36.6430857}, {1270,37.2664000}, {1280,38.0398571}, {1290,38.6470857}, {1300,39.7102000}, {1310,40.5314857}, {1320,41.6302000}, {1330,42.1860571}, {1340,43.1304571}, {1350,43.8462571}, {1360,45.7286000}, {1370,46.2163714}, {1380,47.2279143}, {1390,48.6255714}, {1400,49.3335143}, {1410,50.1772286}, {1420,51.4646000}, {1430,52.2110286}, {1440,53.5110286}, {1450,54.2315429}, {1460,55.8511714}, {1470,56.6104571}, {1480,57.8694571}, {1490,59.4169714}, {1500,60.1891429}, {1510,61.1888857}, {1520,62.7710000}, {1530,63.1653429}, {1540,65.0190000}, {1550,66.2429143}, {1560,67.5556571}, {1570,68.8517714}, {1580,69.8755714}, {1590,71.2989429}, {1600,72.6832857}, {1610,73.4936571}, {1620,76.0966857}, {1630,76.1772571}, {1640,78.0336857}, {1650,79.1888286}, {1660,79.4766571}, {1670,81.9934857}, {1680,83.4103143}, {1690,85.3661429}, {1700,86.6788857}, {1710,88.0251143}, {1720,90.1988571}, {1730,91.2866286}, {1740,93.1263143}, {1750,94.7766857}, {1760,95.5845714}, {1770,97.6644000}, {1780,98.7716571}, {1790,101.3138286}, {1800,102.3834857}, {1810,105.1155429}, {1820,105.7391714}, {1830,106.4791714}, {1840,108.2052000}, {1850,110.2277429}, {1860,113.2621714}, {1870,115.8016286}, {1880,116.8089143}, {1890,120.5174857}, {1900,120.1126857}, {1910,123.3033429}, {1920,126.4122571}, {1930,125.2369143}, {1940,127.1538000}, {1950,129.6321714}, {1960,130.4749429}, {1970,134.0304857}, {1980,134.5425714}, {1990,137.5985714}, {2000,140.8457143}};
data["big"]["LtacTCGallinaCtx"]["actual reif"]["user"] = {{1,0.00053465}, {2,0.00083168}, {3,0.00136634}, {4,0.00177228}, {5,0.00160396}, {6,0.00176238}, {7,0.00293069}, {8,0.00267327}, {9,0.00328713}, {10,0.00343564}, {11,0.00395050}, {12,0.00434653}, {13,0.00471287}, {14,0.00554455}, {15,0.00570297}, {16,0.00629703}, {17,0.00722772}, {18,0.00724752}, {19,0.00783168}, {20,0.00848515}, {21,0.00908911}, {22,0.00964356}, {23,0.01021782}, {24,0.01100990}, {25,0.01238614}, {26,0.01182178}, {27,0.01295050}, {28,0.01289109}, {29,0.01396040}, {30,0.01426733}, {31,0.01506931}, {32,0.01581188}, {33,0.01656436}, {34,0.01699010}, {35,0.01871287}, {36,0.02203960}, {37,0.02211881}, {38,0.02043564}, {39,0.02144554}, {40,0.02265347}, {41,0.02410891}, {42,0.02473267}, {43,0.02599010}, {44,0.02832673}, {45,0.02726733}, {46,0.02838614}, {47,0.03060396}, {48,0.03076238}, {49,0.03432673}, {50,0.03161386}, {51,0.03657426}, {52,0.03418812}, {53,0.03730693}, {54,0.03622772}, {55,0.03756436}, {56,0.03969307}, {57,0.04448515}, {58,0.04058416}, {59,0.04094059}, {60,0.04253465}, {61,0.04394059}, {62,0.04430693}, {63,0.04632673}, {64,0.04836634}, {65,0.04917822}, {66,0.05110891}, {67,0.06086139}, {68,0.05600990}, {69,0.05416832}, {70,0.05575248}, {71,0.05918812}, {72,0.05863366}, {73,0.06368317}, {74,0.06153465}, {75,0.06289109}, {76,0.14497030}, {77,0.06505941}, {78,0.06773267}, {79,0.09440594}, {80,0.08012871}, {81,0.07187129}, {82,0.07445545}, {83,0.07528713}, {84,0.07642574}, {85,0.08664356}, {86,0.09770297}, {87,0.10305941}, {88,0.10474257}, {89,0.10317822}, {90,0.10204950}, {91,0.11005941}, {92,0.11417822}, {93,0.11167327}, {94,0.10876238}, {95,0.11182178}, {96,0.11486139}, {97,0.11550495}, {98,0.11764356}, {99,0.11988119}, {100,0.12292079}, {101,0.12449505}, {102,0.12792079}, {103,0.12308911}, {104,0.12658416}, {105,0.12904950}, {106,0.13133663}, {107,0.13300000}, {108,0.13410891}, {109,0.13633663}, {110,0.13827723}, {111,0.14140594}, {112,0.14190099}, {113,0.14459406}, {114,0.14675248}, {115,0.14923762}, {116,0.15122772}, {117,0.15437624}, {118,0.15614851}, {119,0.15821782}, {120,0.16195050}, {121,0.16474257}, {122,0.16646535}, {123,0.17047525}, {124,0.17181188}, {125,0.17425743}, {126,0.17774257}, {127,0.17985149}, {128,0.18201980}, {129,0.18519802}, {130,0.18810891}, {131,0.18998020}, {132,0.19309901}, {133,0.19516832}, {134,0.19784158}, {135,0.20100990}, {136,0.20519802}, {137,0.20656436}, {138,0.21039604}, {139,0.21275248}, {140,0.21313861}, {141,0.21949505}, {142,0.22029703}, {143,0.22407921}, {144,0.22860396}, {145,0.22938614}, {146,0.23302970}, {147,0.23602970}, {148,0.23971287}, {149,0.24291089}, {150,0.24689109}, {151,0.24804950}, {152,0.25111881}, {153,0.25510891}, {154,0.25881188}, {155,0.26128713}, {156,0.26537624}, {157,0.26697030}, {158,0.27334653}, {159,0.27442574}, {160,0.27822772}, {161,0.28164356}, {162,0.28323762}, {163,0.29831683}, {164,0.28866337}, {165,0.29371287}, {166,0.29707921}, {167,0.29834653}, {168,0.30070297}, {169,0.30805941}, {170,0.30997030}, {171,0.31270297}, {172,0.31997030}, {173,0.32078218}, {174,0.32563366}, {175,0.32736634}, {176,0.33070297}, {177,0.33568317}, {178,0.33901980}, {179,0.34562376}, {180,0.35113861}, {181,0.35438614}, {182,0.36151485}, {183,0.36535644}, {184,0.37066337}, {185,0.37509901}, {186,0.37980198}, {187,0.38444554}, {188,0.38585149}, {189,0.39173267}, {190,0.39117822}, {191,0.39505941}, {192,0.39829703}, {193,0.40115842}, {194,0.40372277}, {195,0.40814851}, {196,0.40978218}, {197,0.41252475}, {198,0.41687129}, {199,0.42744554}, {200,0.43697030}, {201,0.43191089}, {202,0.43319802}, {203,0.44043564}, {204,0.44259406}, {205,0.45527723}, {206,0.46474257}, {207,0.45679208}, {208,0.46016832}, {209,0.46492079}, {210,0.47731683}, {211,0.48810891}, {212,0.48057426}, {213,0.48072277}, {214,0.49779208}, {215,0.50742574}, {216,0.49788119}, {217,0.50214851}, {218,0.51853465}, {219,0.51886139}, {220,0.51804950}, {221,0.53799010}, {222,0.53277228}, {223,0.53572277}, {224,0.54784158}, {225,0.54700000}, {226,0.55625743}, {227,0.55386139}, {228,0.56250495}, {229,0.57184158}, {230,0.57100990}, {231,0.58699010}, {232,0.57877228}, {233,0.59945545}, {234,0.58774257}, {235,0.60647525}, {236,0.59762376}, {237,0.67024752}, {238,0.61148515}, {239,0.69796040}, {240,0.62486139}, {241,0.62730693}, {242,0.63802970}, {243,0.63864356}, {244,0.64688119}, {245,0.71628713}, {246,0.65424752}, {247,0.66619802}, {248,0.66897030}, {249,0.66875248}, {250,0.68558416}, {251,0.68150495}, {252,0.68607921}, {253,0.70059406}, {254,0.70288119}, {255,0.70391089}, {256,0.71686139}, {257,0.72208911}, {258,0.72182178}, {259,0.72770297}, {260,0.73463366}, {261,0.74551485}, {262,0.75503960}, {263,0.76074257}, {264,0.76175248}, {265,0.76640594}, {266,0.76847525}, {267,0.77722772}, {268,0.78688119}, {269,0.79308911}, {270,0.79664356}, {271,0.80015842}, {272,0.81171287}, {273,0.81772277}, {274,0.82634653}, {275,0.83180198}, {276,0.84199010}, {277,0.84622772}, {278,0.85369307}, {279,0.86055446}, {280,0.86386139}, {281,0.87104950}, {282,0.88091089}, {283,0.89052475}, {284,0.89932673}, {285,0.90539604}, {286,0.91489109}, {287,0.91674257}, {288,0.92403960}, {289,0.93345545}, {290,0.93610891}, {291,0.94161386}, {292,0.94404950}, {293,0.94729703}, {294,0.95538614}, {295,0.96163366}, {296,0.96999010}, {297,0.98727723}, {298,0.99000990}, {299,0.98646535}, {300,0.99181188}, {301,1.0475714}, {302,1.1404286}, {303,1.1055143}, {304,1.1054571}, {305,1.0790857}, {306,1.0964571}, {307,1.1246286}, {308,1.1053429}, {309,1.1098000}, {310,1.1653714}, {311,1.1260857}, {312,1.1335714}, {313,1.1541714}, {314,1.1557714}, {315,1.1625429}, {316,1.1693429}, {317,1.1755429}, {318,1.1836857}, {319,1.1913143}, {320,1.2022286}, {321,1.1984286}, {322,1.2518571}, {323,1.2420286}, {324,1.2260857}, {325,1.2591429}, {326,1.2436286}, {327,1.2483429}, {328,1.2595429}, {329,1.2665714}, {330,1.2742857}, {331,1.2954000}, {332,1.2884571}, {333,1.3254000}, {334,1.2961429}, {335,1.3347429}, {336,1.3219429}, {337,1.3314571}, {338,1.3391429}, {339,1.3459143}, {340,1.3759714}, {341,1.3637429}, {342,1.3808571}, {343,1.3914286}, {344,1.4075143}, {345,1.4090286}, {346,1.4164857}, {347,1.4237143}, {348,1.4330857}, {349,1.4425714}, {350,1.4773143}, {351,1.4742571}, {352,1.4707714}, {353,1.4872286}, {354,1.4888571}, {355,1.5014000}, {356,1.5035714}, {357,1.5192000}, {358,1.5293429}, {359,1.5377429}, {360,1.5435143}, {361,1.5556286}, {362,1.5672286}, {363,1.5741143}, {364,1.5885429}, {365,1.5987429}, {366,1.5961143}, {367,1.6125143}, {368,1.6242000}, {369,1.6312000}, {370,1.6412000}, {371,1.6579143}, {372,1.6643429}, {373,1.6746286}, {374,1.6744000}, {375,1.7031429}, {376,1.7086857}, {377,1.7131143}, {378,1.7221429}, {379,1.7266571}, {380,1.7437143}, {381,1.7521143}, {382,1.7657714}, {383,1.7756571}, {384,1.7944000}, {385,1.8044000}, {386,1.8229143}, {387,1.8348571}, {388,1.8368000}, {389,1.8536000}, {390,1.8718286}, {391,1.8756857}, {392,1.8877143}, {393,1.8974571}, {394,1.9060571}, {395,1.9253714}, {396,1.9290000}, {397,1.9497143}, {398,1.9712286}, {399,1.9656286}, {400,1.9782857}, {401,1.9917143}, {402,2.0049429}, {403,2.0221429}, {404,2.0320571}, {405,2.0544000}, {406,2.0571714}, {407,2.0578857}, {408,2.0749143}, {409,2.0929143}, {410,2.0937714}, {411,2.1027429}, {412,2.1017143}, {413,2.1253714}, {414,2.1326857}, {415,2.1508857}, {416,2.1467429}, {417,2.1514571}, {418,2.1654000}, {419,2.1723143}, {420,2.1897714}, {421,2.2100000}, {422,2.2063143}, {423,2.2205714}, {424,2.2245429}, {425,2.2371714}, {426,2.2587143}, {427,2.3146857}, {428,2.3036857}, {429,2.3145429}, {430,2.3156857}, {431,2.3311143}, {432,2.3519429}, {433,2.3599714}, {434,2.3968571}, {435,2.3878286}, {436,2.4029143}, {437,2.4054000}, {438,2.4252000}, {439,2.4532000}, {440,2.4691143}, {441,2.4684857}, {442,2.4828571}, {443,2.4978286}, {444,2.5121143}, {445,2.5209143}, {446,2.5333429}, {447,2.5459143}, {448,2.5540286}, {449,2.5723714}, {450,2.5952000}, {451,2.5965143}, {452,2.6063714}, {453,2.6272286}, {454,2.6404286}, {455,2.6641714}, {456,2.6644000}, {457,2.6789429}, {458,2.7023429}, {459,2.7211143}, {460,2.7292000}, {461,2.7364857}, {462,2.7722571}, {463,2.7718857}, {464,2.8062571}, {465,2.8020857}, {466,2.8106000}, {467,2.9093714}, {468,2.8394571}, {469,2.8514286}, {470,2.9133429}, {471,2.9060857}, {472,2.9168000}, {473,2.9741143}, {474,2.9359714}, {475,2.9256571}, {476,2.9290000}, {477,2.9936000}, {478,2.9642286}, {479,3.0257143}, {480,2.9962571}, {481,3.0194286}, {482,3.0211714}, {483,3.0523429}, {484,3.0991429}, {485,3.0818857}, {486,3.1279429}, {487,3.1111429}, {488,3.1244571}, {489,3.1218571}, {490,3.1296857}, {491,3.1494857}, {492,3.1707714}, {493,3.1890857}, {494,3.2233429}, {495,3.2332571}, {496,3.2506571}, {497,3.2713143}, {498,3.2791143}, {499,3.2991429}, {500,3.3118000}, {505,3.3865714}, {510,3.4660000}, {515,3.5464000}, {520,3.6272286}, {525,3.7140857}, {530,3.8416000}, {535,3.8820286}, {540,4.0656286}, {545,4.0329143}, {550,4.2014000}, {555,4.2460286}, {560,4.3156000}, {565,4.4528571}, {570,4.5095429}, {575,4.6279429}, {580,4.7537714}, {585,4.8307429}, {590,4.9836286}, {595,5.1723429}, {600,5.2374286}, {605,5.3098857}, {610,5.3593143}, {615,5.5332857}, {620,5.6683429}, {625,5.8427429}, {630,5.9150000}, {635,5.9500571}, {640,6.1594571}, {645,6.2951143}, {650,6.3549714}, {655,6.3714286}, {660,6.4258857}, {665,6.6024286}, {670,6.7652000}, {675,6.8880571}, {680,7.0994286}, {685,7.2022286}, {690,7.3606000}, {695,7.3790857}, {700,7.6723143}, {705,7.7590571}, {710,8.0071143}, {715,7.9496857}, {720,8.0961143}, {725,8.3468857}, {730,8.2791714}, {735,8.6130857}, {740,8.7376000}, {745,8.9938857}, {750,9.1011143}, {755,9.3559714}, {760,9.5068286}, {765,9.7208286}, {770,9.7603143}, {775,9.6510286}, {780,10.0099143}, {785,10.1214000}, {790,10.2953429}, {795,10.4009714}, {800,10.7311429}, {805,10.8930857}, {810,10.9261429}, {815,11.1772286}, {820,11.2668000}, {825,11.5248286}, {830,11.5802571}, {835,11.6623143}, {840,12.2149429}, {845,12.3141429}, {850,12.2307143}, {855,12.7449429}, {860,12.7693714}, {865,13.2416286}, {870,13.3786286}, {875,13.6014571}, {880,13.9405429}, {885,13.7173429}, {890,14.2344857}, {895,14.2494857}, {900,14.4338857}, {905,14.8011429}, {910,15.1212286}, {915,15.0964000}, {920,15.4156571}, {925,15.5569143}, {930,15.8928857}, {935,16.0676857}, {940,16.0446286}, {945,16.5010286}, {950,16.6100286}, {955,16.5313143}, {960,16.9900571}, {965,17.5490286}, {970,17.1054000}, {975,17.5653429}, {980,18.2388857}, {985,18.1995714}, {990,18.5271143}, {995,19.0280286}, {1000,19.2382000}, {1010,19.5999143}, {1020,20.0607143}, {1030,20.7592571}, {1040,21.1478000}, {1050,21.9249429}, {1060,22.4536571}, {1070,23.1890286}, {1080,23.7094571}, {1090,24.2899429}, {1100,24.9351143}, {1110,25.6509429}, {1120,26.4062571}, {1130,26.6786000}, {1140,27.7557143}, {1150,28.4652571}, {1160,28.8925143}, {1170,29.3060286}, {1180,30.3958571}, {1190,31.0375429}, {1200,32.0886857}, {1210,32.6060286}, {1220,33.2889429}, {1230,34.0336000}, {1240,34.6560857}, {1250,35.5963143}, {1260,36.5757714}, {1270,37.2101714}, {1280,37.9842857}, {1290,38.5916857}, {1300,39.6660286}, {1310,40.4956857}, {1320,41.5887714}, {1330,42.1404857}, {1340,43.0923143}, {1350,43.8003143}, {1360,45.6674857}, {1370,46.1577143}, {1380,47.1740857}, {1390,48.5708571}, {1400,49.2882000}, {1410,50.1289714}, {1420,51.4143429}, {1430,52.1506000}, {1440,53.4628000}, {1450,54.1561714}, {1460,55.7750000}, {1470,56.5472000}, {1480,57.8090571}, {1490,59.3528286}, {1500,60.1178857}, {1510,61.1129429}, {1520,62.6748286}, {1530,63.0815714}, {1540,64.9505143}, {1550,66.1690286}, {1560,67.4691714}, {1570,68.7869429}, {1580,69.7918000}, {1590,71.2021143}, {1600,72.5937429}, {1610,73.4172286}, {1620,76.0229714}, {1630,76.0982000}, {1640,77.9463429}, {1650,79.0983714}, {1660,79.3954857}, {1670,81.8991429}, {1680,83.3252000}, {1690,85.2686286}, {1700,86.5779714}, {1710,87.9419429}, {1720,90.0984571}, {1730,91.1634286}, {1740,93.0042571}, {1750,94.6686000}, {1760,95.4793429}, {1770,97.5366857}, {1780,98.6534571}, {1790,101.1893429}, {1800,102.3038286}, {1810,105.0368857}, {1820,105.6595714}, {1830,106.3994286}, {1840,108.0584000}, {1850,110.1023429}, {1860,113.1395714}, {1870,115.6291429}, {1880,116.6985429}, {1890,120.3896571}, {1900,119.9990857}, {1910,123.2197143}, {1920,126.3425143}, {1930,125.1354571}, {1940,127.0267143}, {1950,129.5348571}, {1960,130.2831143}, {1970,133.9572571}, {1980,134.4670000}, {1990,137.5243429}, {2000,140.7616000}};
data["big"]["LtacTCGallinaCtx"]["actual reif"]["system"] = {{1,0.00006931}, {2,0.00000000}, {3,0.00007921}, {4,0.00000000}, {5,0.00000000}, {6,0.00003960}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00011881}, {12,0.00000000}, {13,0.00000000}, {14,0.00011881}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00007921}, {19,0.00000000}, {20,0.00007921}, {21,0.00003960}, {22,0.00000000}, {23,0.00007921}, {24,0.00000000}, {25,0.00003960}, {26,0.00003960}, {27,0.00003960}, {28,0.00000000}, {29,0.00000000}, {30,0.00015842}, {31,0.00000000}, {32,0.00003960}, {33,0.00000000}, {34,0.00003960}, {35,0.00003960}, {36,0.00003960}, {37,0.00003960}, {38,0.00003960}, {39,0.00000000}, {40,0.00007921}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00011881}, {46,0.00000000}, {47,0.00003960}, {48,0.00000000}, {49,0.00000000}, {50,0.00007921}, {51,0.00003960}, {52,0.00007921}, {53,0.00000000}, {54,0.00003960}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00011881}, {59,0.00007921}, {60,0.00010891}, {61,0.00003960}, {62,0.00011881}, {63,0.00002970}, {64,0.00011881}, {65,0.00006931}, {66,0.00011881}, {67,0.00000000}, {68,0.00000000}, {69,0.00003960}, {70,0.00003960}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00030693}, {77,0.00007921}, {78,0.00006931}, {79,0.00011881}, {80,0.00000000}, {81,0.00003960}, {82,0.00000000}, {83,0.00011881}, {84,0.00011881}, {85,0.00003960}, {86,0.00003960}, {87,0.00007921}, {88,0.00007921}, {89,0.00003960}, {90,0.00000000}, {91,0.00003960}, {92,0.00007921}, {93,0.00000000}, {94,0.00003960}, {95,0.00000000}, {96,0.00011881}, {97,0.00003960}, {98,0.00003960}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00003960}, {106,0.00007921}, {107,0.00000000}, {108,0.00003960}, {109,0.00003960}, {110,0.00000000}, {111,0.00000000}, {112,0.00003960}, {113,0.00003960}, {114,0.00019802}, {115,0.00000000}, {116,0.00000000}, {117,0.00003960}, {118,0.00014851}, {119,0.00003960}, {120,0.00003960}, {121,0.00007921}, {122,0.00000000}, {123,0.00003960}, {124,0.00011881}, {125,0.00011881}, {126,0.00003960}, {127,0.00011881}, {128,0.00003960}, {129,0.00007921}, {130,0.00003960}, {131,0.00003960}, {132,0.00010891}, {133,0.00000000}, {134,0.00000000}, {135,0.00006931}, {136,0.00003960}, {137,0.00003960}, {138,0.00007921}, {139,0.00007921}, {140,0.00007921}, {141,0.00003960}, {142,0.00015842}, {143,0.00003960}, {144,0.00007921}, {145,0.00003960}, {146,0.00007921}, {147,0.00014851}, {148,0.00003960}, {149,0.00010891}, {150,0.00003960}, {151,0.00007921}, {152,0.00000000}, {153,0.00003960}, {154,0.00000000}, {155,0.00007921}, {156,0.00011881}, {157,0.00007921}, {158,0.00003960}, {159,0.00000000}, {160,0.00003960}, {161,0.00007921}, {162,0.00003960}, {163,0.00000000}, {164,0.00003960}, {165,0.00007921}, {166,0.00000000}, {167,0.00003960}, {168,0.00003960}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00011881}, {173,0.00007921}, {174,0.00007921}, {175,0.00007921}, {176,0.00003960}, {177,0.00003960}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00007921}, {183,0.00007921}, {184,0.00011881}, {185,0.00010891}, {186,0.00003960}, {187,0.00003960}, {188,0.00011881}, {189,0.00000000}, {190,0.00003960}, {191,0.00007921}, {192,0.00003960}, {193,0.00007921}, {194,0.00000000}, {195,0.00019802}, {196,0.00003960}, {197,0.00007921}, {198,0.00003960}, {199,0.00011881}, {200,0.00003960}, {201,0.00015842}, {202,0.00007921}, {203,0.00003960}, {204,0.00007921}, {205,0.00003960}, {206,0.00007921}, {207,0.00000000}, {208,0.00007921}, {209,0.00000000}, {210,0.00003960}, {211,0.00007921}, {212,0.00000000}, {213,0.00003960}, {214,0.00011881}, {215,0.00003960}, {216,0.00007921}, {217,0.00003960}, {218,0.00000000}, {219,0.00006931}, {220,0.00015842}, {221,0.00011881}, {222,0.00011881}, {223,0.00003960}, {224,0.00003960}, {225,0.00011881}, {226,0.00007921}, {227,0.00011881}, {228,0.00007921}, {229,0.00011881}, {230,0.00003960}, {231,0.00003960}, {232,0.00000000}, {233,0.00023762}, {234,0.00003960}, {235,0.00000000}, {236,0.00011881}, {237,0.00015842}, {238,0.00003960}, {239,0.00018812}, {240,0.00007921}, {241,0.00007921}, {242,0.00015842}, {243,0.00007921}, {244,0.00011881}, {245,0.00000000}, {246,0.00011881}, {247,0.00007921}, {248,0.00011881}, {249,0.00007921}, {250,0.00011881}, {251,0.00007921}, {252,0.00007921}, {253,0.00015842}, {254,0.00007921}, {255,0.00007921}, {256,0.00007921}, {257,0.00003960}, {258,0.00011881}, {259,0.00007921}, {260,0.00011881}, {261,0.00007921}, {262,0.00011881}, {263,0.00018812}, {264,0.00006931}, {265,0.00000000}, {266,0.00018812}, {267,0.00011881}, {268,0.00011881}, {269,0.00031683}, {270,0.00011881}, {271,0.00003960}, {272,0.00015842}, {273,0.00007921}, {274,0.00007921}, {275,0.00011881}, {276,0.00000000}, {277,0.00003960}, {278,0.00015842}, {279,0.00011881}, {280,0.00011881}, {281,0.00011881}, {282,0.00003960}, {283,0.00007921}, {284,0.00011881}, {285,0.00014851}, {286,0.00027723}, {287,0.00000000}, {288,0.00000000}, {289,0.00003960}, {290,0.00010891}, {291,0.00015842}, {292,0.00031683}, {293,0.00003960}, {294,0.00007921}, {295,0.00015842}, {296,0.00003960}, {297,0.00015842}, {298,0.00019802}, {299,0.00015842}, {300,0.00011881}, {301,0.0002286}, {302,0.0006571}, {303,0.0001143}, {304,0.0001143}, {305,0.0002286}, {306,0.0002286}, {307,0.0001143}, {308,0.0003429}, {309,0.0003143}, {310,0.0002286}, {311,0.0000000}, {312,0.0002286}, {313,0.0001143}, {314,0.0001143}, {315,0.0000000}, {316,0.0001143}, {317,0.0000000}, {318,0.0001143}, {319,0.0000000}, {320,0.0002286}, {321,0.0003429}, {322,0.0006857}, {323,0.0001143}, {324,0.0000000}, {325,0.0001143}, {326,0.0000000}, {327,0.0000000}, {328,0.0002286}, {329,0.0012571}, {330,0.0000000}, {331,0.0000000}, {332,0.0003429}, {333,0.0002286}, {334,0.0001143}, {335,0.0003429}, {336,0.0000000}, {337,0.0001143}, {338,0.0001143}, {339,0.0003429}, {340,0.0001143}, {341,0.0003429}, {342,0.0000000}, {343,0.0001143}, {344,0.0000000}, {345,0.0002286}, {346,0.0001143}, {347,0.0001143}, {348,0.0000000}, {349,0.0001143}, {350,0.0002286}, {351,0.0005714}, {352,0.0001143}, {353,0.0001143}, {354,0.0001143}, {355,0.0001143}, {356,0.0002286}, {357,0.0001143}, {358,0.0001143}, {359,0.0001143}, {360,0.0002286}, {361,0.0000000}, {362,0.0001143}, {363,0.0001143}, {364,0.0001143}, {365,0.0006857}, {366,0.0000000}, {367,0.0001143}, {368,0.0001143}, {369,0.0005714}, {370,0.0003429}, {371,0.0001143}, {372,0.0004571}, {373,0.0000000}, {374,0.0006857}, {375,0.0003429}, {376,0.0001143}, {377,0.0001143}, {378,0.0003429}, {379,0.0002286}, {380,0.0002286}, {381,0.0004571}, {382,0.0003429}, {383,0.0002286}, {384,0.0000000}, {385,0.0005714}, {386,0.0003143}, {387,0.0003429}, {388,0.0003429}, {389,0.0004571}, {390,0.0001143}, {391,0.0002000}, {392,0.0004571}, {393,0.0004571}, {394,0.0004571}, {395,0.0003429}, {396,0.0001143}, {397,0.0001143}, {398,0.0004571}, {399,0.0004571}, {400,0.0002286}, {401,0.0002286}, {402,0.0001143}, {403,0.0001143}, {404,0.0001143}, {405,0.0006857}, {406,0.0004571}, {407,0.0004571}, {408,0.0002286}, {409,0.0003429}, {410,0.0004286}, {411,0.0006571}, {412,0.0002286}, {413,0.0002286}, {414,0.0003429}, {415,0.0000000}, {416,0.0003429}, {417,0.0005714}, {418,0.0000000}, {419,0.0002286}, {420,0.0002286}, {421,0.0001143}, {422,0.0001143}, {423,0.0002286}, {424,0.0003429}, {425,0.0009143}, {426,0.0004571}, {427,0.0003143}, {428,0.0004571}, {429,0.0005714}, {430,0.0002286}, {431,0.0006857}, {432,0.0004571}, {433,0.0003429}, {434,0.0006857}, {435,0.0006857}, {436,0.0003429}, {437,0.0005714}, {438,0.0002286}, {439,0.0002286}, {440,0.0001143}, {441,0.0002286}, {442,0.0002286}, {443,0.0003429}, {444,0.0006857}, {445,0.0002286}, {446,0.0003429}, {447,0.0002286}, {448,0.0004571}, {449,0.0003429}, {450,0.0003429}, {451,0.0004571}, {452,0.0003429}, {453,0.0002286}, {454,0.0006857}, {455,0.0004571}, {456,0.0010286}, {457,0.0004571}, {458,0.0003429}, {459,0.0004571}, {460,0.0002286}, {461,0.0002286}, {462,0.0001143}, {463,0.0003429}, {464,0.0003429}, {465,0.0004571}, {466,0.0005714}, {467,0.0004571}, {468,0.0011143}, {469,0.0003429}, {470,0.0012571}, {471,0.0003429}, {472,0.0006857}, {473,0.0003429}, {474,0.0002286}, {475,0.0014857}, {476,0.0001143}, {477,0.0007714}, {478,0.0003429}, {479,0.0003429}, {480,0.0005429}, {481,0.0005714}, {482,0.0014857}, {483,0.0005714}, {484,0.0009143}, {485,0.0013714}, {486,0.0012571}, {487,0.0010286}, {488,0.0009143}, {489,0.0005714}, {490,0.0003429}, {491,0.0005714}, {492,0.0003429}, {493,0.0004571}, {494,0.0016571}, {495,0.0006571}, {496,0.0006571}, {497,0.0009143}, {498,0.0014857}, {499,0.0007714}, {500,0.0011429}, {505,0.0014571}, {510,0.0003429}, {515,0.0016000}, {520,0.0019429}, {525,0.0020571}, {530,0.0027429}, {535,0.0018000}, {540,0.0031429}, {545,0.0027143}, {550,0.0021714}, {555,0.0014857}, {560,0.0018000}, {565,0.0019429}, {570,0.0010000}, {575,0.0008000}, {580,0.0012571}, {585,0.0014571}, {590,0.0022857}, {595,0.0019143}, {600,0.0014857}, {605,0.0020286}, {610,0.0027143}, {615,0.0012571}, {620,0.0022857}, {625,0.0028000}, {630,0.0016000}, {635,0.0018286}, {640,0.0020571}, {645,0.0032000}, {650,0.0030857}, {655,0.0013714}, {660,0.0031429}, {665,0.0030571}, {670,0.0022571}, {675,0.0017143}, {680,0.0025143}, {685,0.0028571}, {690,0.0014571}, {695,0.0023714}, {700,0.0021714}, {705,0.0026286}, {710,0.0025143}, {715,0.0020571}, {720,0.0026000}, {725,0.0043143}, {730,0.0025143}, {735,0.0030857}, {740,0.0015714}, {745,0.0029429}, {750,0.0028286}, {755,0.0029429}, {760,0.0038286}, {765,0.0022857}, {770,0.0040000}, {775,0.0039714}, {780,0.0038857}, {785,0.0039143}, {790,0.0030571}, {795,0.0045714}, {800,0.0040857}, {805,0.0044286}, {810,0.0045429}, {815,0.0031714}, {820,0.0049143}, {825,0.0024857}, {830,0.0027143}, {835,0.0033143}, {840,0.0028571}, {845,0.0035143}, {850,0.0014857}, {855,0.0032000}, {860,0.0040000}, {865,0.0036286}, {870,0.0029429}, {875,0.0027429}, {880,0.0041429}, {885,0.0028000}, {890,0.0028286}, {895,0.0039714}, {900,0.0074286}, {905,0.0038286}, {910,0.0037143}, {915,0.0053143}, {920,0.0022857}, {925,0.0040000}, {930,0.0036000}, {935,0.0054286}, {940,0.0049714}, {945,0.0046286}, {950,0.0031714}, {955,0.0026286}, {960,0.0058571}, {965,0.0032857}, {970,0.0038857}, {975,0.0026000}, {980,0.0026286}, {985,0.0033143}, {990,0.0045143}, {995,0.0057429}, {1000,0.0077714}, {1010,0.0042571}, {1020,0.0038286}, {1030,0.0027714}, {1040,0.0047714}, {1050,0.0076000}, {1060,0.0046000}, {1070,0.0073143}, {1080,0.0076857}, {1090,0.0056571}, {1100,0.0053714}, {1110,0.0055429}, {1120,0.0071714}, {1130,0.0057714}, {1140,0.0081714}, {1150,0.0079143}, {1160,0.0063714}, {1170,0.0074571}, {1180,0.0104000}, {1190,0.0057143}, {1200,0.0064286}, {1210,0.0077714}, {1220,0.0067429}, {1230,0.0112857}, {1240,0.0100571}, {1250,0.0076571}, {1260,0.0125143}, {1270,0.0091429}, {1280,0.0090571}, {1290,0.0118571}, {1300,0.0096000}, {1310,0.0040000}, {1320,0.0067714}, {1330,0.0131714}, {1340,0.0065429}, {1350,0.0086000}, {1360,0.0186000}, {1370,0.0138571}, {1380,0.0098571}, {1390,0.0174857}, {1400,0.0116571}, {1410,0.0098286}, {1420,0.0136857}, {1430,0.0106286}, {1440,0.0155714}, {1450,0.0162000}, {1460,0.0152857}, {1470,0.0091429}, {1480,0.0153143}, {1490,0.0257429}, {1500,0.0168000}, {1510,0.0251714}, {1520,0.0223714}, {1530,0.0234857}, {1540,0.0197143}, {1550,0.0215143}, {1560,0.0235714}, {1570,0.0223429}, {1580,0.0273714}, {1590,0.0256286}, {1600,0.0262857}, {1610,0.0213714}, {1620,0.0243714}, {1630,0.0200000}, {1640,0.0269143}, {1650,0.0275429}, {1660,0.0192286}, {1670,0.0304857}, {1680,0.0166857}, {1690,0.0241714}, {1700,0.0225143}, {1710,0.0212571}, {1720,0.0299714}, {1730,0.0278857}, {1740,0.0300571}, {1750,0.0298286}, {1760,0.0311429}, {1770,0.0304857}, {1780,0.0271143}, {1790,0.0357429}, {1800,0.0359429}, {1810,0.0380286}, {1820,0.0325714}, {1830,0.0331143}, {1840,0.0379714}, {1850,0.0332286}, {1860,0.0408857}, {1870,0.0357143}, {1880,0.0312000}, {1890,0.0405429}, {1900,0.0308000}, {1910,0.0323429}, {1920,0.0382857}, {1930,0.0390571}, {1940,0.0433429}, {1950,0.0396000}, {1960,0.0293429}, {1970,0.0423714}, {1980,0.0428571}, {1990,0.0344000}, {2000,0.0445429}};
data["big"]["LtacTCGallinaCtx"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0032857}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0024857}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000286}, {560,0.0000000}, {565,0.0001714}, {570,0.0000571}, {575,0.0001429}, {580,0.0002286}, {585,0.0004857}, {590,0.0004857}, {595,0.0005714}, {600,0.0006286}, {605,0.0007714}, {610,0.0007714}, {615,0.0008571}, {620,0.0021143}, {625,0.0009714}, {630,0.0009714}, {635,0.0010000}, {640,0.0010000}, {645,0.0009429}, {650,0.0009714}, {655,0.0009143}, {660,0.0010000}, {665,0.0009429}, {670,0.0010000}, {675,0.0009429}, {680,0.0010000}, {685,0.0009714}, {690,0.0010000}, {695,0.0010000}, {700,0.0010000}, {705,0.0010000}, {710,0.0010000}, {715,0.0010000}, {720,0.0010000}, {725,0.0010000}, {730,0.0010000}, {735,0.0010000}, {740,0.0010000}, {745,0.0010000}, {750,0.0010000}, {755,0.0010000}, {760,0.0010000}, {765,0.0010000}, {770,0.0010000}, {775,0.0010000}, {780,0.0010000}, {785,0.0010000}, {790,0.0010000}, {795,0.0010000}, {800,0.0010000}, {805,0.0010000}, {810,0.0010000}, {815,0.0010000}, {820,0.0032286}, {825,0.0010000}, {830,0.0010000}, {835,0.0010000}, {840,0.0010000}, {845,0.0010000}, {850,0.0010000}, {855,0.0010000}, {860,0.0010000}, {865,0.0010000}, {870,0.0010000}, {875,0.0010000}, {880,0.0010000}, {885,0.0010000}, {890,0.0010000}, {895,0.0010000}, {900,0.0010000}, {905,0.0041143}, {910,0.0010000}, {915,0.0010000}, {920,0.0010000}, {925,0.0010000}, {930,0.0010000}, {935,0.0010000}, {940,0.0010000}, {945,0.0010000}, {950,0.0010000}, {955,0.0010000}, {960,0.0010000}, {965,0.0010000}, {970,0.0010000}, {975,0.0010000}, {980,0.0010000}, {985,0.0010000}, {990,0.0010000}, {995,0.0010000}, {1000,0.0010000}, {1010,0.0010000}, {1020,0.0010000}, {1030,0.0010000}, {1040,0.0010000}, {1050,0.0010000}, {1060,0.0010000}, {1070,0.0010000}, {1080,0.0010000}, {1090,0.0010000}, {1100,0.0010000}, {1110,0.0010286}, {1120,0.0011429}, {1130,0.0010571}, {1140,0.0011429}, {1150,0.0012000}, {1160,0.0012000}, {1170,0.0013429}, {1180,0.0014286}, {1190,0.0041714}, {1200,0.0016286}, {1210,0.0017429}, {1220,0.0018286}, {1230,0.0018571}, {1240,0.0018571}, {1250,0.0019429}, {1260,0.0019714}, {1270,0.0020000}, {1280,0.0020000}, {1290,0.0020000}, {1300,0.0020000}, {1310,0.0060857}, {1320,0.0020000}, {1330,0.0020000}, {1340,0.0020000}, {1350,0.0020000}, {1360,0.0020000}, {1370,0.0020000}, {1380,0.0020000}, {1390,0.0020000}, {1400,0.0020000}, {1410,0.0020000}, {1420,0.0020000}, {1430,0.0020000}, {1440,0.0020000}, {1450,0.0020000}, {1460,0.0020000}, {1470,0.0020000}, {1480,0.0020000}, {1490,0.0020000}, {1500,0.0020000}, {1510,0.0020000}, {1520,0.0020000}, {1530,0.0020000}, {1540,0.0020000}, {1550,0.0020000}, {1560,0.0020000}, {1570,0.0020000}, {1580,0.0020000}, {1590,0.0020000}, {1600,0.0020000}, {1610,0.0020286}, {1620,0.0020000}, {1630,0.0020286}, {1640,0.0020000}, {1650,0.0020000}, {1660,0.0020857}, {1670,0.0020000}, {1680,0.0020571}, {1690,0.0020286}, {1700,0.0020857}, {1710,0.0020857}, {1720,0.0021429}, {1730,0.0021143}, {1740,0.0022286}, {1750,0.0022571}, {1760,0.0023143}, {1770,0.0025429}, {1780,0.0024857}, {1790,0.0026571}, {1800,0.0072000}, {1810,0.0027429}, {1820,0.0027714}, {1830,0.0027429}, {1840,0.0028286}, {1850,0.0028000}, {1860,0.0027429}, {1870,0.0029714}, {1880,0.0029429}, {1890,0.0030000}, {1900,0.0029714}, {1910,0.0030000}, {1920,0.0029714}, {1930,0.0030000}, {1940,0.0030000}, {1950,0.0030000}, {1960,0.0030000}, {1970,0.0030000}, {1980,0.0030000}, {1990,0.0030000}, {2000,0.0030000}};
data["big"]["LtacTCGallinaCtx"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00003960}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00007921}, {8,0.00007921}, {9,0.00007921}, {10,0.00006931}, {11,0.00013861}, {12,0.00000000}, {13,0.00006931}, {14,0.00007921}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00003960}, {19,0.00009901}, {20,0.00003960}, {21,0.00011881}, {22,0.00003960}, {23,0.00003960}, {24,0.00006931}, {25,0.00009901}, {26,0.00003960}, {27,0.00003960}, {28,0.00003960}, {29,0.00003960}, {30,0.00007921}, {31,0.00013861}, {32,0.00006931}, {33,0.00007921}, {34,0.00010891}, {35,0.00009901}, {36,0.00002970}, {37,0.00006931}, {38,0.00010891}, {39,0.00015842}, {40,0.00003960}, {41,0.00007921}, {42,0.00006931}, {43,0.00007921}, {44,0.00011881}, {45,0.00011881}, {46,0.00007921}, {47,0.00014851}, {48,0.00021782}, {49,0.00022772}, {50,0.00009901}, {51,0.00010891}, {52,0.00007921}, {53,0.00013861}, {54,0.00017822}, {55,0.00003960}, {56,0.00003960}, {57,0.00000000}, {58,0.00010891}, {59,0.00017822}, {60,0.00023762}, {61,0.00010891}, {62,0.00011881}, {63,0.00011881}, {64,0.00003960}, {65,0.00021782}, {66,0.00011881}, {67,0.00007921}, {68,0.00014851}, {69,0.00031683}, {70,0.00023762}, {71,0.00007921}, {72,0.00015842}, {73,0.00007921}, {74,0.00003960}, {75,0.00011881}, {76,0.00005941}, {77,0.00015842}, {78,0.00007921}, {79,0.00017822}, {80,0.00015842}, {81,0.00006931}, {82,0.00013861}, {83,0.00023762}, {84,0.00007921}, {85,0.00031683}, {86,0.00006931}, {87,0.00014851}, {88,0.00007921}, {89,0.00019802}, {90,0.00003960}, {91,0.00011881}, {92,0.00018812}, {93,0.00022772}, {94,0.00025743}, {95,0.00003960}, {96,0.00022772}, {97,0.00002970}, {98,0.00014851}, {99,0.00026733}, {100,0.00023762}, {101,0.00018812}, {102,0.00000000}, {103,0.00010891}, {104,0.00027723}, {105,0.00035644}, {106,0.00018812}, {107,0.00042574}, {108,0.00011881}, {109,0.00021782}, {110,0.00023762}, {111,0.00019802}, {112,0.00020792}, {113,0.00010891}, {114,0.00018812}, {115,0.00019802}, {116,0.00021782}, {117,0.00010891}, {118,0.00009901}, {119,0.00018812}, {120,0.00017822}, {121,0.00017822}, {122,0.00018812}, {123,0.00025743}, {124,0.00025743}, {125,0.00015842}, {126,0.00014851}, {127,0.00032673}, {128,0.00014851}, {129,0.00022772}, {130,0.00025743}, {131,0.00010891}, {132,0.00044554}, {133,0.00024752}, {134,0.00015842}, {135,0.00015842}, {136,0.00037624}, {137,0.00024752}, {138,0.00019802}, {139,0.00033663}, {140,0.00022772}, {141,0.00011881}, {142,0.00003960}, {143,0.00034653}, {144,0.00024752}, {145,0.00025743}, {146,0.00025743}, {147,0.00018812}, {148,0.00007921}, {149,0.00035644}, {150,0.00017822}, {151,0.00010891}, {152,0.00025743}, {153,0.00010891}, {154,0.00011881}, {155,0.00038614}, {156,0.00040594}, {157,0.00034653}, {158,0.00013861}, {159,0.00023762}, {160,0.00018812}, {161,0.00027723}, {162,0.00019802}, {163,0.00037624}, {164,0.00023762}, {165,0.00030693}, {166,0.00024752}, {167,0.00021782}, {168,0.00041584}, {169,0.00034653}, {170,0.00053465}, {171,0.00036634}, {172,0.00039604}, {173,0.00022772}, {174,0.00028713}, {175,0.00030693}, {176,0.00034653}, {177,0.00018812}, {178,0.00014851}, {179,0.00022772}, {180,0.00026733}, {181,0.00038614}, {182,0.00017822}, {183,0.00034653}, {184,0.00013861}, {185,0.00037624}, {186,0.00023762}, {187,0.00029703}, {188,0.00019802}, {189,0.00033663}, {190,0.00018812}, {191,0.00026733}, {192,0.00033663}, {193,0.00030693}, {194,0.00036634}, {195,0.00035644}, {196,0.00027723}, {197,0.00030693}, {198,0.00037624}, {199,0.00045545}, {200,0.00059406}, {201,0.00044554}, {202,0.00046535}, {203,0.00027723}, {204,0.00019802}, {205,0.00046535}, {206,0.00035644}, {207,0.00034653}, {208,0.00046535}, {209,0.00027723}, {210,0.00029703}, {211,0.00030693}, {212,0.00030693}, {213,0.00035644}, {214,0.00030693}, {215,0.00042574}, {216,0.00041584}, {217,0.00052475}, {218,0.00027723}, {219,0.00018812}, {220,0.00041584}, {221,0.00038614}, {222,0.00019802}, {223,0.00047525}, {224,0.00045545}, {225,0.00046535}, {226,0.00021782}, {227,0.00026733}, {228,0.00036634}, {229,0.00030693}, {230,0.00018812}, {231,0.00061386}, {232,0.00029703}, {233,0.00053465}, {234,0.00031683}, {235,0.00032673}, {236,0.00015842}, {237,0.00060396}, {238,0.00024752}, {239,0.00037624}, {240,0.00059406}, {241,0.00050495}, {242,0.00028713}, {243,0.00015842}, {244,0.00049505}, {245,0.00037624}, {246,0.00038614}, {247,0.00037624}, {248,0.00025743}, {249,0.00042574}, {250,0.00026733}, {251,0.00056436}, {252,0.00049505}, {253,0.00037624}, {254,0.00050495}, {255,0.00055446}, {256,0.00060396}, {257,0.00045545}, {258,0.00041584}, {259,0.00043564}, {260,0.00032673}, {261,0.00056436}, {262,0.00052475}, {263,0.00054455}, {264,0.00026733}, {265,0.00043564}, {266,0.00046535}, {267,0.00029703}, {268,0.00025743}, {269,0.00051485}, {270,0.00043564}, {271,0.00020792}, {272,0.00051485}, {273,0.00023762}, {274,0.00033663}, {275,0.00050495}, {276,0.00019802}, {277,0.00032673}, {278,0.00026733}, {279,0.00035644}, {280,0.00045545}, {281,0.00030693}, {282,0.00049505}, {283,0.00015842}, {284,0.00032673}, {285,0.00022772}, {286,0.00033663}, {287,0.00044554}, {288,0.00057426}, {289,0.00065347}, {290,0.00048515}, {291,0.00045545}, {292,0.00043564}, {293,0.00033663}, {294,0.00042574}, {295,0.00045545}, {296,0.00046535}, {297,0.00052475}, {298,0.00036634}, {299,0.00027723}, {300,0.00034653}, {301,0.0004571}, {302,0.0008857}, {303,0.0003714}, {304,0.0004571}, {305,0.0006286}, {306,0.0002571}, {307,0.0006571}, {308,0.0003714}, {309,0.0004000}, {310,0.0002000}, {311,0.0006286}, {312,0.0008000}, {313,0.0001714}, {314,0.0005714}, {315,0.0002000}, {316,0.0000857}, {317,0.0004286}, {318,0.0000857}, {319,0.0004857}, {320,0.0004000}, {321,0.0003714}, {322,0.0008857}, {323,0.0006286}, {324,0.0001714}, {325,0.0002857}, {326,0.0002857}, {327,0.0006286}, {328,0.0005429}, {329,0.0028286}, {330,0.0004000}, {331,0.0002571}, {332,0.0003714}, {333,0.0003714}, {334,0.0005429}, {335,0.0002000}, {336,0.0002857}, {337,0.0003714}, {338,0.0004857}, {339,0.0003429}, {340,0.0003429}, {341,0.0004000}, {342,0.0002857}, {343,0.0005714}, {344,0.0005429}, {345,0.0006571}, {346,0.0007714}, {347,0.0006571}, {348,0.0004000}, {349,0.0003714}, {350,0.0005429}, {351,0.0003714}, {352,0.0007714}, {353,0.0002571}, {354,0.0004286}, {355,0.0002571}, {356,0.0006286}, {357,0.0003429}, {358,0.0004286}, {359,0.0002857}, {360,0.0005714}, {361,0.0008286}, {362,0.0006000}, {363,0.0008857}, {364,0.0006000}, {365,0.0007143}, {366,0.0006000}, {367,0.0006571}, {368,0.0002571}, {369,0.0004000}, {370,0.0002286}, {371,0.0002857}, {372,0.0003429}, {373,0.0003714}, {374,0.0004857}, {375,0.0004286}, {376,0.0000857}, {377,0.0005143}, {378,0.0002857}, {379,0.0005429}, {380,0.0007429}, {381,0.0006571}, {382,0.0004571}, {383,0.0005429}, {384,0.0003429}, {385,0.0007429}, {386,0.0006000}, {387,0.0012286}, {388,0.0006857}, {389,0.0004571}, {390,0.0001143}, {391,0.0004286}, {392,0.0007143}, {393,0.0006000}, {394,0.0003714}, {395,0.0006000}, {396,0.0006857}, {397,0.0001714}, {398,0.0008857}, {399,0.0006000}, {400,0.0006857}, {401,0.0010571}, {402,0.0004000}, {403,0.0006571}, {404,0.0005143}, {405,0.0006000}, {406,0.0008000}, {407,0.0007143}, {408,0.0004286}, {409,0.0005429}, {410,0.0005143}, {411,0.0008857}, {412,0.0005429}, {413,0.0005714}, {414,0.0005143}, {415,0.0005429}, {416,0.0005143}, {417,0.0002857}, {418,0.0006286}, {419,0.0002571}, {420,0.0006286}, {421,0.0004571}, {422,0.0006857}, {423,0.0004571}, {424,0.0001714}, {425,0.0007143}, {426,0.0005429}, {427,0.0003714}, {428,0.0006000}, {429,0.0009143}, {430,0.0003429}, {431,0.0007429}, {432,0.0004571}, {433,0.0004286}, {434,0.0003714}, {435,0.0002000}, {436,0.0009143}, {437,0.0004571}, {438,0.0005429}, {439,0.0004000}, {440,0.0005714}, {441,0.0005714}, {442,0.0005714}, {443,0.0004571}, {444,0.0003714}, {445,0.0003714}, {446,0.0006857}, {447,0.0005429}, {448,0.0006571}, {449,0.0004857}, {450,0.0008000}, {451,0.0002571}, {452,0.0005429}, {453,0.0005143}, {454,0.0008571}, {455,0.0005714}, {456,0.0008000}, {457,0.0004571}, {458,0.0006286}, {459,0.0006286}, {460,0.0006000}, {461,0.0007429}, {462,0.0004000}, {463,0.0004286}, {464,0.0006286}, {465,0.0006571}, {466,0.0009143}, {467,0.0005714}, {468,0.0006286}, {469,0.0010571}, {470,0.0007714}, {471,0.0002857}, {472,0.0007143}, {473,0.0012571}, {474,0.0002571}, {475,0.0005429}, {476,0.0008000}, {477,0.0005429}, {478,0.0006571}, {479,0.0003714}, {480,0.0008571}, {481,0.0003143}, {482,0.0003429}, {483,0.0006000}, {484,0.0008286}, {485,0.0006000}, {486,0.0004286}, {487,0.0006000}, {488,0.0007429}, {489,0.0010571}, {490,0.0004286}, {491,0.0006857}, {492,0.0006000}, {493,0.0022000}, {494,0.0007143}, {495,0.0008000}, {496,0.0006000}, {497,0.0006857}, {498,0.0002571}, {499,0.0012571}, {500,0.0005143}, {505,0.0006000}, {510,0.0005143}, {515,0.0005143}, {520,0.0004857}, {525,0.0003429}, {530,0.0007714}, {535,0.0009429}, {540,0.0004286}, {545,0.0004286}, {550,0.0002857}, {555,0.0007429}, {560,0.0008571}, {565,0.0008000}, {570,0.0009714}, {575,0.0007429}, {580,0.0006000}, {585,0.0010000}, {590,0.0010286}, {595,0.0008000}, {600,0.0010000}, {605,0.0006571}, {610,0.0009429}, {615,0.0011714}, {620,0.0023714}, {625,0.0008286}, {630,0.0003429}, {635,0.0009143}, {640,0.0013143}, {645,0.0008857}, {650,0.0011143}, {655,0.0005714}, {660,0.0008571}, {665,0.0010286}, {670,0.0014571}, {675,0.0010571}, {680,0.0005429}, {685,0.0005714}, {690,0.0013143}, {695,0.0010286}, {700,0.0008000}, {705,0.0006000}, {710,0.0009714}, {715,0.0012286}, {720,0.0006857}, {725,0.0006000}, {730,0.0006857}, {735,0.0007143}, {740,0.0012857}, {745,0.0007714}, {750,0.0009429}, {755,0.0008571}, {760,0.0017429}, {765,0.0007143}, {770,0.0006857}, {775,0.0010286}, {780,0.0008000}, {785,0.0011714}, {790,0.0007714}, {795,0.0007143}, {800,0.0012857}, {805,0.0011143}, {810,0.0004286}, {815,0.0010286}, {820,0.0036000}, {825,0.0010571}, {830,0.0010571}, {835,0.0010571}, {840,0.0007714}, {845,0.0012571}, {850,0.0010857}, {855,0.0013429}, {860,0.0017714}, {865,0.0015429}, {870,0.0008571}, {875,0.0009143}, {880,0.0011143}, {885,0.0012857}, {890,0.0012286}, {895,0.0013143}, {900,0.0011429}, {905,0.0031143}, {910,0.0011714}, {915,0.0013143}, {920,0.0012571}, {925,0.0009429}, {930,0.0016000}, {935,0.0015429}, {940,0.0014000}, {945,0.0014857}, {950,0.0012571}, {955,0.0014857}, {960,0.0011429}, {965,0.0013429}, {970,0.0017143}, {975,0.0008571}, {980,0.0004571}, {985,0.0011714}, {990,0.0016000}, {995,0.0010286}, {1000,0.0017143}, {1010,0.0020571}, {1020,0.0017429}, {1030,0.0015143}, {1040,0.0014857}, {1050,0.0018286}, {1060,0.0017429}, {1070,0.0009429}, {1080,0.0016000}, {1090,0.0015429}, {1100,0.0017429}, {1110,0.0014286}, {1120,0.0016286}, {1130,0.0016000}, {1140,0.0017429}, {1150,0.0020286}, {1160,0.0022857}, {1170,0.0017143}, {1180,0.0011143}, {1190,0.0043714}, {1200,0.0013714}, {1210,0.0020000}, {1220,0.0016286}, {1230,0.0014000}, {1240,0.0018000}, {1250,0.0022857}, {1260,0.0024000}, {1270,0.0018571}, {1280,0.0021429}, {1290,0.0012857}, {1300,0.0017714}, {1310,0.0053143}, {1320,0.0022000}, {1330,0.0019714}, {1340,0.0017429}, {1350,0.0017714}, {1360,0.0018286}, {1370,0.0022286}, {1380,0.0022286}, {1390,0.0016286}, {1400,0.0016286}, {1410,0.0018857}, {1420,0.0021429}, {1430,0.0019714}, {1440,0.0021429}, {1450,0.0024000}, {1460,0.0018286}, {1470,0.0022000}, {1480,0.0017143}, {1490,0.0019714}, {1500,0.0020286}, {1510,0.0016000}, {1520,0.0025143}, {1530,0.0021714}, {1540,0.0025714}, {1550,0.0022000}, {1560,0.0027143}, {1570,0.0026000}, {1580,0.0021143}, {1590,0.0027429}, {1600,0.0024571}, {1610,0.0024286}, {1620,0.0029714}, {1630,0.0027714}, {1640,0.0025429}, {1650,0.0020857}, {1660,0.0027714}, {1670,0.0026857}, {1680,0.0022286}, {1690,0.0030571}, {1700,0.0030000}, {1710,0.0029429}, {1720,0.0029429}, {1730,0.0028857}, {1740,0.0022571}, {1750,0.0022000}, {1760,0.0024571}, {1770,0.0029429}, {1780,0.0028000}, {1790,0.0028286}, {1800,0.0077714}, {1810,0.0024286}, {1820,0.0026286}, {1830,0.0030857}, {1840,0.0028000}, {1850,0.0032571}, {1860,0.0030571}, {1870,0.0026571}, {1880,0.0032000}, {1890,0.0029714}, {1900,0.0035714}, {1910,0.0029143}, {1920,0.0030571}, {1930,0.0027143}, {1940,0.0030857}, {1950,0.0028000}, {1960,0.0033714}, {1970,0.0026000}, {1980,0.0026000}, {1990,0.0033429}, {2000,0.0031714}};
data["big"]["LtacTCGallinaCtx"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00003960}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00003960}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00003960}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00003960}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00003960}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00003960}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00003960}, {161,0.00000000}, {162,0.00003960}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00003960}, {213,0.00000000}, {214,0.00000000}, {215,0.00003960}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00003960}, {220,0.00000000}, {221,0.00003960}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00003960}, {252,0.00000000}, {253,0.00003960}, {254,0.00000000}, {255,0.00003960}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00003960}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0001143}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0001143}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0001143}, {403,0.0000000}, {404,0.0001143}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0001143}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0001143}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000857}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0002286}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0001143}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0001143}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000857}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCGallinaCtx"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00379208}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0014571}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000286}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000286}, {815,0.0000286}, {820,0.0000000}, {825,0.0000286}, {830,0.0000286}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0001714}, {855,0.0001143}, {860,0.0000857}, {865,0.0002000}, {870,0.0004000}, {875,0.0004857}, {880,0.0003143}, {885,0.0004857}, {890,0.0004000}, {895,0.0004857}, {900,0.0006000}, {905,0.0007143}, {910,0.0008000}, {915,0.0008857}, {920,0.0008286}, {925,0.0008571}, {930,0.0009714}, {935,0.0008286}, {940,0.0009143}, {945,0.0010000}, {950,0.0009714}, {955,0.0010000}, {960,0.0010000}, {965,0.0010000}, {970,0.0010000}, {975,0.0010000}, {980,0.0010000}, {985,0.0010000}, {990,0.0010000}, {995,0.0010000}, {1000,0.0010000}, {1010,0.0010000}, {1020,0.0010000}, {1030,0.0010000}, {1040,0.0010000}, {1050,0.0010000}, {1060,0.0010000}, {1070,0.0010000}, {1080,0.0010000}, {1090,0.0010000}, {1100,0.0010000}, {1110,0.0010000}, {1120,0.0010000}, {1130,0.0010000}, {1140,0.0010000}, {1150,0.0010000}, {1160,0.0010000}, {1170,0.0010000}, {1180,0.0010000}, {1190,0.0010000}, {1200,0.0010000}, {1210,0.0010000}, {1220,0.0010000}, {1230,0.0010000}, {1240,0.0010000}, {1250,0.0010000}, {1260,0.0010000}, {1270,0.0010000}, {1280,0.0010000}, {1290,0.0010000}, {1300,0.0010000}, {1310,0.0010000}, {1320,0.0010000}, {1330,0.0010000}, {1340,0.0010000}, {1350,0.0010000}, {1360,0.0010000}, {1370,0.0010000}, {1380,0.0010000}, {1390,0.0010000}, {1400,0.0010000}, {1410,0.0010000}, {1420,0.0010000}, {1430,0.0010000}, {1440,0.0010000}, {1450,0.0010000}, {1460,0.0010000}, {1470,0.0010000}, {1480,0.0010000}, {1490,0.0010000}, {1500,0.0064857}, {1510,0.0010286}, {1520,0.0010000}, {1530,0.0010000}, {1540,0.0010000}, {1550,0.0010000}, {1560,0.0010000}, {1570,0.0010000}, {1580,0.0010000}, {1590,0.0010000}, {1600,0.0010286}, {1610,0.0010000}, {1620,0.0010000}, {1630,0.0010571}, {1640,0.0010000}, {1650,0.0010286}, {1660,0.0010000}, {1670,0.0010000}, {1680,0.0010571}, {1690,0.0010286}, {1700,0.0010571}, {1710,0.0010571}, {1720,0.0010857}, {1730,0.0011429}, {1740,0.0010571}, {1750,0.0012571}, {1760,0.0011714}, {1770,0.0013143}, {1780,0.0014286}, {1790,0.0015429}, {1800,0.0015429}, {1810,0.0015143}, {1820,0.0016286}, {1830,0.0016857}, {1840,0.0017714}, {1850,0.0018286}, {1860,0.0018286}, {1870,0.0019429}, {1880,0.0020000}, {1890,0.0019429}, {1900,0.0019429}, {1910,0.0020000}, {1920,0.0020000}, {1930,0.0020000}, {1940,0.0020000}, {1950,0.0020000}, {1960,0.0020286}, {1970,0.0020000}, {1980,0.0020000}, {1990,0.0020000}, {2000,0.0020000}};
data["big"]["LtacTCGallinaCtx"]["eval lazy"]["user"] = {{1,0.00006931}, {2,0.00000000}, {3,0.00000000}, {4,0.00002970}, {5,0.00003960}, {6,0.00009901}, {7,0.00000000}, {8,0.00000000}, {9,0.00003960}, {10,0.00003960}, {11,0.00000000}, {12,0.00006931}, {13,0.00010891}, {14,0.00003960}, {15,0.00007921}, {16,0.00010891}, {17,0.00003960}, {18,0.00003960}, {19,0.00011881}, {20,0.00003960}, {21,0.00006931}, {22,0.00006931}, {23,0.00009901}, {24,0.00010891}, {25,0.00000000}, {26,0.00003960}, {27,0.00003960}, {28,0.00003960}, {29,0.00011881}, {30,0.00015842}, {31,0.00000000}, {32,0.00011881}, {33,0.00015842}, {34,0.00007921}, {35,0.00000000}, {36,0.00003960}, {37,0.00022772}, {38,0.00007921}, {39,0.00006931}, {40,0.00011881}, {41,0.00007921}, {42,0.00003960}, {43,0.00003960}, {44,0.00002970}, {45,0.00011881}, {46,0.00007921}, {47,0.00002970}, {48,0.00007921}, {49,0.00003960}, {50,0.00003960}, {51,0.00006931}, {52,0.00000000}, {53,0.00006931}, {54,0.00000000}, {55,0.00015842}, {56,0.00014851}, {57,0.00010891}, {58,0.00019802}, {59,0.00006931}, {60,0.00007921}, {61,0.00010891}, {62,0.00018812}, {63,0.00007921}, {64,0.00000000}, {65,0.00007921}, {66,0.00003960}, {67,0.00007921}, {68,0.00017822}, {69,0.00015842}, {70,0.00020792}, {71,0.00014851}, {72,0.00006931}, {73,0.00015842}, {74,0.00019802}, {75,0.00009901}, {76,0.00003960}, {77,0.00011881}, {78,0.00003960}, {79,0.00019802}, {80,0.00007921}, {81,0.00018812}, {82,0.00015842}, {83,0.00014851}, {84,0.00011881}, {85,0.00006931}, {86,0.00025743}, {87,0.00015842}, {88,0.00023762}, {89,0.00013861}, {90,0.00007921}, {91,0.00002970}, {92,0.00014851}, {93,0.00014851}, {94,0.00005941}, {95,0.00002970}, {96,0.00007921}, {97,0.00018812}, {98,0.00002970}, {99,0.00011881}, {100,0.00006931}, {101,0.00007921}, {102,0.00006931}, {103,0.00030693}, {104,0.00010891}, {105,0.00011881}, {106,0.00011881}, {107,0.00019802}, {108,0.00015842}, {109,0.00007921}, {110,0.00026733}, {111,0.00030693}, {112,0.00003960}, {113,0.00011881}, {114,0.00013861}, {115,0.00014851}, {116,0.00025743}, {117,0.00023762}, {118,0.00019802}, {119,0.00043564}, {120,0.00014851}, {121,0.00018812}, {122,0.00007921}, {123,0.00014851}, {124,0.00030693}, {125,0.00002970}, {126,0.00000000}, {127,0.00022772}, {128,0.00015842}, {129,0.00014851}, {130,0.00022772}, {131,0.00009901}, {132,0.00010891}, {133,0.00023762}, {134,0.00019802}, {135,0.00015842}, {136,0.00015842}, {137,0.00010891}, {138,0.00007921}, {139,0.00006931}, {140,0.00007921}, {141,0.00010891}, {142,0.00025743}, {143,0.00019802}, {144,0.00014851}, {145,0.00007921}, {146,0.00011881}, {147,0.00014851}, {148,0.00007921}, {149,0.00018812}, {150,0.00022772}, {151,0.00021782}, {152,0.00014851}, {153,0.00022772}, {154,0.00038614}, {155,0.00031683}, {156,0.00032673}, {157,0.00014851}, {158,0.00019802}, {159,0.00018812}, {160,0.00014851}, {161,0.00027723}, {162,0.00018812}, {163,0.00018812}, {164,0.00035644}, {165,0.00031683}, {166,0.00018812}, {167,0.00027723}, {168,0.00034653}, {169,0.00032673}, {170,0.00023762}, {171,0.00031683}, {172,0.00036634}, {173,0.00018812}, {174,0.00021782}, {175,0.00027723}, {176,0.00022772}, {177,0.00011881}, {178,0.00022772}, {179,0.00027723}, {180,0.00032673}, {181,0.00026733}, {182,0.00050495}, {183,0.00034653}, {184,0.00035644}, {185,0.00019802}, {186,0.00039604}, {187,0.00026733}, {188,0.00039604}, {189,0.00018812}, {190,0.00029703}, {191,0.00024752}, {192,0.00030693}, {193,0.00046535}, {194,0.00022772}, {195,0.00007921}, {196,0.00026733}, {197,0.00018812}, {198,0.00018812}, {199,0.00023762}, {200,0.00022772}, {201,0.00018812}, {202,0.00022772}, {203,0.00026733}, {204,0.00034653}, {205,0.00031683}, {206,0.00034653}, {207,0.00026733}, {208,0.00023762}, {209,0.00033663}, {210,0.00034653}, {211,0.00019802}, {212,0.00033663}, {213,0.00031683}, {214,0.00031683}, {215,0.00007921}, {216,0.00019802}, {217,0.00017822}, {218,0.00035644}, {219,0.00011881}, {220,0.00032673}, {221,0.00018812}, {222,0.00034653}, {223,0.00038614}, {224,0.00033663}, {225,0.00010891}, {226,0.00037624}, {227,0.00031683}, {228,0.00026733}, {229,0.00011881}, {230,0.00021782}, {231,0.00037624}, {232,0.00025743}, {233,0.00027723}, {234,0.00030693}, {235,0.00041584}, {236,0.00022772}, {237,0.00033663}, {238,0.00029703}, {239,0.00035644}, {240,0.00022772}, {241,0.00038614}, {242,0.00010891}, {243,0.00035644}, {244,0.00021782}, {245,0.00026733}, {246,0.00037624}, {247,0.00040594}, {248,0.00041584}, {249,0.00026733}, {250,0.00027723}, {251,0.00017822}, {252,0.00038614}, {253,0.00042574}, {254,0.00041584}, {255,0.00022772}, {256,0.00038614}, {257,0.00027723}, {258,0.00024752}, {259,0.00025743}, {260,0.00037624}, {261,0.00030693}, {262,0.00039604}, {263,0.00022772}, {264,0.00019802}, {265,0.00031683}, {266,0.00020792}, {267,0.00033663}, {268,0.00038614}, {269,0.00026733}, {270,0.00027723}, {271,0.00023762}, {272,0.00039604}, {273,0.00022772}, {274,0.00027723}, {275,0.00031683}, {276,0.00039604}, {277,0.00040594}, {278,0.00022772}, {279,0.00038614}, {280,0.00031683}, {281,0.00012871}, {282,0.00020792}, {283,0.00036634}, {284,0.00035644}, {285,0.00031683}, {286,0.00019802}, {287,0.00023762}, {288,0.00369307}, {289,0.00040594}, {290,0.00035644}, {291,0.00031683}, {292,0.00044554}, {293,0.00020792}, {294,0.00025743}, {295,0.00039604}, {296,0.00028713}, {297,0.00037624}, {298,0.00021782}, {299,0.00035644}, {300,0.00013861}, {301,0.0003429}, {302,0.0005143}, {303,0.0002857}, {304,0.0003429}, {305,0.0004286}, {306,0.0000857}, {307,0.0005143}, {308,0.0000000}, {309,0.0000857}, {310,0.0004286}, {311,0.0002571}, {312,0.0002857}, {313,0.0004571}, {314,0.0005143}, {315,0.0002571}, {316,0.0002571}, {317,0.0002857}, {318,0.0002571}, {319,0.0002571}, {320,0.0004000}, {321,0.0002857}, {322,0.0002571}, {323,0.0000857}, {324,0.0008571}, {325,0.0002000}, {326,0.0004286}, {327,0.0004000}, {328,0.0000000}, {329,0.0007429}, {330,0.0001714}, {331,0.0004571}, {332,0.0004286}, {333,0.0002571}, {334,0.0003429}, {335,0.0004000}, {336,0.0004571}, {337,0.0003429}, {338,0.0005143}, {339,0.0003429}, {340,0.0000857}, {341,0.0001714}, {342,0.0004286}, {343,0.0005429}, {344,0.0003429}, {345,0.0004000}, {346,0.0001143}, {347,0.0005714}, {348,0.0003714}, {349,0.0001143}, {350,0.0004286}, {351,0.0002571}, {352,0.0001143}, {353,0.0000857}, {354,0.0003429}, {355,0.0002857}, {356,0.0003429}, {357,0.0004571}, {358,0.0001714}, {359,0.0002000}, {360,0.0003714}, {361,0.0002000}, {362,0.0002571}, {363,0.0003429}, {364,0.0003143}, {365,0.0000000}, {366,0.0003429}, {367,0.0003143}, {368,0.0003429}, {369,0.0004286}, {370,0.0002000}, {371,0.0003714}, {372,0.0002571}, {373,0.0004000}, {374,0.0002571}, {375,0.0003714}, {376,0.0003143}, {377,0.0005429}, {378,0.0003429}, {379,0.0005714}, {380,0.0006571}, {381,0.0000000}, {382,0.0004571}, {383,0.0004857}, {384,0.0004571}, {385,0.0001714}, {386,0.0001714}, {387,0.0002857}, {388,0.0003714}, {389,0.0000857}, {390,0.0003714}, {391,0.0005429}, {392,0.0002857}, {393,0.0004857}, {394,0.0002000}, {395,0.0005429}, {396,0.0004571}, {397,0.0000857}, {398,0.0000857}, {399,0.0005143}, {400,0.0005429}, {401,0.0002857}, {402,0.0005143}, {403,0.0004571}, {404,0.0005429}, {405,0.0005714}, {406,0.0002000}, {407,0.0003714}, {408,0.0003429}, {409,0.0006857}, {410,0.0004571}, {411,0.0001714}, {412,0.0003429}, {413,0.0008000}, {414,0.0002571}, {415,0.0004000}, {416,0.0002000}, {417,0.0002000}, {418,0.0003429}, {419,0.0005143}, {420,0.0006286}, {421,0.0005143}, {422,0.0004000}, {423,0.0004571}, {424,0.0008571}, {425,0.0003714}, {426,0.0000000}, {427,0.0003429}, {428,0.0002857}, {429,0.0000857}, {430,0.0001714}, {431,0.0004571}, {432,0.0002857}, {433,0.0006286}, {434,0.0003143}, {435,0.0002000}, {436,0.0003429}, {437,0.0003429}, {438,0.0002000}, {439,0.0000857}, {440,0.0001714}, {441,0.0003714}, {442,0.0003714}, {443,0.0002571}, {444,0.0006857}, {445,0.0006286}, {446,0.0002857}, {447,0.0004000}, {448,0.0006571}, {449,0.0004571}, {450,0.0003429}, {451,0.0005143}, {452,0.0005714}, {453,0.0007714}, {454,0.0007429}, {455,0.0005714}, {456,0.0001714}, {457,0.0002571}, {458,0.0004571}, {459,0.0005429}, {460,0.0002000}, {461,0.0004857}, {462,0.0004286}, {463,0.0005714}, {464,0.0005714}, {465,0.0004857}, {466,0.0003714}, {467,0.0003429}, {468,0.0006000}, {469,0.0002571}, {470,0.0006000}, {471,0.0005143}, {472,0.0004571}, {473,0.0005429}, {474,0.0002571}, {475,0.0004571}, {476,0.0004571}, {477,0.0005143}, {478,0.0006571}, {479,0.0006857}, {480,0.0000000}, {481,0.0006000}, {482,0.0005429}, {483,0.0004571}, {484,0.0006000}, {485,0.0003429}, {486,0.0000857}, {487,0.0000857}, {488,0.0001714}, {489,0.0003714}, {490,0.0001714}, {491,0.0004286}, {492,0.0006000}, {493,0.0005143}, {494,0.0000857}, {495,0.0005143}, {496,0.0006857}, {497,0.0006857}, {498,0.0006571}, {499,0.0004286}, {500,0.0003714}, {505,0.0007429}, {510,0.0006000}, {515,0.0003429}, {520,0.0007429}, {525,0.0001714}, {530,0.0003714}, {535,0.0007143}, {540,0.0002571}, {545,0.0006286}, {550,0.0005143}, {555,0.0003429}, {560,0.0005143}, {565,0.0008286}, {570,0.0003429}, {575,0.0005429}, {580,0.0004286}, {585,0.0007714}, {590,0.0004571}, {595,0.0005429}, {600,0.0005429}, {605,0.0003429}, {610,0.0006000}, {615,0.0004286}, {620,0.0006286}, {625,0.0004286}, {630,0.0005143}, {635,0.0004286}, {640,0.0007143}, {645,0.0005143}, {650,0.0002571}, {655,0.0006000}, {660,0.0006286}, {665,0.0006000}, {670,0.0008286}, {675,0.0008000}, {680,0.0006286}, {685,0.0006000}, {690,0.0001714}, {695,0.0008286}, {700,0.0006286}, {705,0.0009429}, {710,0.0007714}, {715,0.0005143}, {720,0.0011143}, {725,0.0006286}, {730,0.0010286}, {735,0.0007143}, {740,0.0003429}, {745,0.0011143}, {750,0.0008857}, {755,0.0004286}, {760,0.0006286}, {765,0.0010000}, {770,0.0005143}, {775,0.0006286}, {780,0.0010857}, {785,0.0007429}, {790,0.0004571}, {795,0.0008286}, {800,0.0006000}, {805,0.0006000}, {810,0.0004857}, {815,0.0008000}, {820,0.0007714}, {825,0.0002571}, {830,0.0004571}, {835,0.0008286}, {840,0.0010571}, {845,0.0007429}, {850,0.0006286}, {855,0.0009714}, {860,0.0006857}, {865,0.0007714}, {870,0.0005714}, {875,0.0008000}, {880,0.0007714}, {885,0.0010000}, {890,0.0006857}, {895,0.0007143}, {900,0.0008857}, {905,0.0011429}, {910,0.0010286}, {915,0.0005143}, {920,0.0006286}, {925,0.0008571}, {930,0.0004286}, {935,0.0006000}, {940,0.0010857}, {945,0.0007714}, {950,0.0008000}, {955,0.0008571}, {960,0.0010857}, {965,0.0012571}, {970,0.0008857}, {975,0.0007143}, {980,0.0010286}, {985,0.0007714}, {990,0.0010857}, {995,0.0012286}, {1000,0.0010857}, {1010,0.0014286}, {1020,0.0006000}, {1030,0.0004857}, {1040,0.0005714}, {1050,0.0007429}, {1060,0.0013143}, {1070,0.0008857}, {1080,0.0008286}, {1090,0.0013143}, {1100,0.0011143}, {1110,0.0009714}, {1120,0.0010857}, {1130,0.0012571}, {1140,0.0009429}, {1150,0.0014571}, {1160,0.0016000}, {1170,0.0005143}, {1180,0.0011143}, {1190,0.0014571}, {1200,0.0011143}, {1210,0.0007714}, {1220,0.0014857}, {1230,0.0008571}, {1240,0.0012286}, {1250,0.0010857}, {1260,0.0018000}, {1270,0.0009714}, {1280,0.0017143}, {1290,0.0017143}, {1300,0.0008857}, {1310,0.0010286}, {1320,0.0018286}, {1330,0.0016000}, {1340,0.0006857}, {1350,0.0006857}, {1360,0.0015714}, {1370,0.0016857}, {1380,0.0016000}, {1390,0.0014571}, {1400,0.0009714}, {1410,0.0011429}, {1420,0.0014857}, {1430,0.0012857}, {1440,0.0018000}, {1450,0.0010857}, {1460,0.0013714}, {1470,0.0019429}, {1480,0.0016857}, {1490,0.0013429}, {1500,0.0058000}, {1510,0.0018000}, {1520,0.0019143}, {1530,0.0011714}, {1540,0.0021143}, {1550,0.0016000}, {1560,0.0013429}, {1570,0.0015143}, {1580,0.0013143}, {1590,0.0019714}, {1600,0.0018571}, {1610,0.0018571}, {1620,0.0017143}, {1630,0.0018857}, {1640,0.0015429}, {1650,0.0017714}, {1660,0.0012571}, {1670,0.0020000}, {1680,0.0011714}, {1690,0.0021143}, {1700,0.0017714}, {1710,0.0020286}, {1720,0.0015429}, {1730,0.0016286}, {1740,0.0020000}, {1750,0.0017143}, {1760,0.0012571}, {1770,0.0017714}, {1780,0.0020857}, {1790,0.0016000}, {1800,0.0018857}, {1810,0.0017429}, {1820,0.0022857}, {1830,0.0014286}, {1840,0.0018286}, {1850,0.0016000}, {1860,0.0019143}, {1870,0.0020000}, {1880,0.0013714}, {1890,0.0016571}, {1900,0.0022571}, {1910,0.0020286}, {1920,0.0018571}, {1930,0.0021714}, {1940,0.0024286}, {1950,0.0026571}, {1960,0.0023429}, {1970,0.0018000}, {1980,0.0022000}, {1990,0.0020286}, {2000,0.0020000}};
data["big"]["LtacTCGallinaCtx"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00003960}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00003960}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00003960}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00003960}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00003960}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00003960}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00003960}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003960}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00003960}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00003960}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00003960}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0001143}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0001143}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0001143}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0001143}, {905,0.0000000}, {910,0.0001143}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0001143}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0001143}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000857}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0001143}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0001143}, {1730,0.0000000}, {1740,0.0000857}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000857}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000857}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCGallinaCtx"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0021143}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000286}, {1280,0.0000286}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000286}, {1320,0.0000286}, {1330,0.0000286}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000571}, {1380,0.0000571}, {1390,0.0000000}, {1400,0.0000571}, {1410,0.0000857}, {1420,0.0001429}, {1430,0.0002000}, {1440,0.0001143}, {1450,0.0002000}, {1460,0.0002000}, {1470,0.0002857}, {1480,0.0001714}, {1490,0.0001714}, {1500,0.0002571}, {1510,0.0002857}, {1520,0.0003714}, {1530,0.0003429}, {1540,0.0003143}, {1550,0.0003429}, {1560,0.0003143}, {1570,0.0005714}, {1580,0.0006286}, {1590,0.0006571}, {1600,0.0008286}, {1610,0.0008571}, {1620,0.0009429}, {1630,0.0010000}, {1640,0.0010000}, {1650,0.0010000}, {1660,0.0010000}, {1670,0.0010000}, {1680,0.0010000}, {1690,0.0010000}, {1700,0.0010000}, {1710,0.0010000}, {1720,0.0010000}, {1730,0.0010000}, {1740,0.0010000}, {1750,0.0010000}, {1760,0.0010000}, {1770,0.0010000}, {1780,0.0010000}, {1790,0.0010000}, {1800,0.0010000}, {1810,0.0010000}, {1820,0.0010000}, {1830,0.0010000}, {1840,0.0010000}, {1850,0.0010000}, {1860,0.0010000}, {1870,0.0010000}, {1880,0.0010000}, {1890,0.0010000}, {1900,0.0010000}, {1910,0.0010000}, {1920,0.0010000}, {1930,0.0010000}, {1940,0.0010000}, {1950,0.0010000}, {1960,0.0010000}, {1970,0.0010000}, {1980,0.0010000}, {1990,0.0010000}, {2000,0.0010000}};
data["big"]["LtacTCGallinaCtx"]["lazy beta iota"]["user"] = {{1,0.00002970}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00003960}, {6,0.00003960}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00003960}, {15,0.00003960}, {16,0.00000000}, {17,0.00000000}, {18,0.00003960}, {19,0.00003960}, {20,0.00002970}, {21,0.00000000}, {22,0.00000000}, {23,0.00003960}, {24,0.00000000}, {25,0.00000000}, {26,0.00003960}, {27,0.00003960}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00007921}, {33,0.00000000}, {34,0.00003960}, {35,0.00011881}, {36,0.00003960}, {37,0.00007921}, {38,0.00010891}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00003960}, {44,0.00007921}, {45,0.00003960}, {46,0.00000000}, {47,0.00007921}, {48,0.00000000}, {49,0.00000000}, {50,0.00007921}, {51,0.00014851}, {52,0.00007921}, {53,0.00002970}, {54,0.00015842}, {55,0.00007921}, {56,0.00000000}, {57,0.00003960}, {58,0.00010891}, {59,0.00011881}, {60,0.00007921}, {61,0.00011881}, {62,0.00003960}, {63,0.00011881}, {64,0.00006931}, {65,0.00003960}, {66,0.00010891}, {67,0.00000000}, {68,0.00003960}, {69,0.00002970}, {70,0.00000000}, {71,0.00010891}, {72,0.00007921}, {73,0.00014851}, {74,0.00006931}, {75,0.00007921}, {76,0.00000000}, {77,0.00003960}, {78,0.00011881}, {79,0.00007921}, {80,0.00007921}, {81,0.00010891}, {82,0.00002970}, {83,0.00014851}, {84,0.00011881}, {85,0.00000000}, {86,0.00007921}, {87,0.00011881}, {88,0.00003960}, {89,0.00007921}, {90,0.00000000}, {91,0.00018812}, {92,0.00022772}, {93,0.00013861}, {94,0.00005941}, {95,0.00007921}, {96,0.00007921}, {97,0.00000000}, {98,0.00000000}, {99,0.00003960}, {100,0.00011881}, {101,0.00019802}, {102,0.00000000}, {103,0.00007921}, {104,0.00000000}, {105,0.00014851}, {106,0.00003960}, {107,0.00003960}, {108,0.00017822}, {109,0.00000000}, {110,0.00007921}, {111,0.00003960}, {112,0.00018812}, {113,0.00015842}, {114,0.00010891}, {115,0.00003960}, {116,0.00000000}, {117,0.00011881}, {118,0.00006931}, {119,0.00006931}, {120,0.00011881}, {121,0.00019802}, {122,0.00018812}, {123,0.00007921}, {124,0.00011881}, {125,0.00007921}, {126,0.00017822}, {127,0.00014851}, {128,0.00011881}, {129,0.00011881}, {130,0.00007921}, {131,0.00002970}, {132,0.00022772}, {133,0.00000000}, {134,0.00029703}, {135,0.00010891}, {136,0.00020792}, {137,0.00007921}, {138,0.00003960}, {139,0.00007921}, {140,0.00015842}, {141,0.00016832}, {142,0.00022772}, {143,0.00007921}, {144,0.00011881}, {145,0.00015842}, {146,0.00019802}, {147,0.00007921}, {148,0.00000000}, {149,0.00011881}, {150,0.00011881}, {151,0.00029703}, {152,0.00003960}, {153,0.00010891}, {154,0.00013861}, {155,0.00018812}, {156,0.00011881}, {157,0.00000000}, {158,0.00018812}, {159,0.00007921}, {160,0.00011881}, {161,0.00018812}, {162,0.00011881}, {163,0.00003960}, {164,0.00011881}, {165,0.00011881}, {166,0.00011881}, {167,0.00006931}, {168,0.00015842}, {169,0.00015842}, {170,0.00018812}, {171,0.00011881}, {172,0.00011881}, {173,0.00006931}, {174,0.00023762}, {175,0.00015842}, {176,0.00015842}, {177,0.00011881}, {178,0.00007921}, {179,0.00011881}, {180,0.00010891}, {181,0.00007921}, {182,0.00026733}, {183,0.00010891}, {184,0.00011881}, {185,0.00011881}, {186,0.00007921}, {187,0.00010891}, {188,0.00010891}, {189,0.00007921}, {190,0.00026733}, {191,0.00010891}, {192,0.00011881}, {193,0.00018812}, {194,0.00006931}, {195,0.00019802}, {196,0.00007921}, {197,0.00007921}, {198,0.00014851}, {199,0.00022772}, {200,0.00015842}, {201,0.00025743}, {202,0.00022772}, {203,0.00014851}, {204,0.00014851}, {205,0.00007921}, {206,0.00026733}, {207,0.00021782}, {208,0.00024752}, {209,0.00014851}, {210,0.00003960}, {211,0.00011881}, {212,0.00015842}, {213,0.00015842}, {214,0.00007921}, {215,0.00006931}, {216,0.00015842}, {217,0.00011881}, {218,0.00019802}, {219,0.00026733}, {220,0.00014851}, {221,0.00011881}, {222,0.00018812}, {223,0.00011881}, {224,0.00016832}, {225,0.00003960}, {226,0.00007921}, {227,0.00011881}, {228,0.00029703}, {229,0.00030693}, {230,0.00027723}, {231,0.00010891}, {232,0.00007921}, {233,0.00007921}, {234,0.00026733}, {235,0.00006931}, {236,0.00015842}, {237,0.00014851}, {238,0.00011881}, {239,0.00018812}, {240,0.00022772}, {241,0.00003960}, {242,0.00030693}, {243,0.00025743}, {244,0.00022772}, {245,0.00019802}, {246,0.00007921}, {247,0.00009901}, {248,0.00030693}, {249,0.00031683}, {250,0.00010891}, {251,0.00011881}, {252,0.00031683}, {253,0.00011881}, {254,0.00018812}, {255,0.00020792}, {256,0.00013861}, {257,0.00018812}, {258,0.00020792}, {259,0.00025743}, {260,0.00024752}, {261,0.00016832}, {262,0.00026733}, {263,0.00003960}, {264,0.00016832}, {265,0.00018812}, {266,0.00032673}, {267,0.00022772}, {268,0.00020792}, {269,0.00017822}, {270,0.00020792}, {271,0.00010891}, {272,0.00016832}, {273,0.00010891}, {274,0.00018812}, {275,0.00003960}, {276,0.00016832}, {277,0.00009901}, {278,0.00032673}, {279,0.00010891}, {280,0.00013861}, {281,0.00018812}, {282,0.00019802}, {283,0.00015842}, {284,0.00009901}, {285,0.00009901}, {286,0.00021782}, {287,0.00017822}, {288,0.00009901}, {289,0.00006931}, {290,0.00006931}, {291,0.00021782}, {292,0.00016832}, {293,0.00009901}, {294,0.00029703}, {295,0.00011881}, {296,0.00008911}, {297,0.00028713}, {298,0.00021782}, {299,0.00009901}, {300,0.00018812}, {301,0.0000857}, {302,0.0000857}, {303,0.0000000}, {304,0.0002000}, {305,0.0002857}, {306,0.0004571}, {307,0.0000000}, {308,0.0001714}, {309,0.0000000}, {310,0.0003429}, {311,0.0002571}, {312,0.0001714}, {313,0.0002571}, {314,0.0000857}, {315,0.0003429}, {316,0.0002000}, {317,0.0001714}, {318,0.0002571}, {319,0.0001143}, {320,0.0000857}, {321,0.0001143}, {322,0.0002000}, {323,0.0001143}, {324,0.0000000}, {325,0.0004571}, {326,0.0001714}, {327,0.0001714}, {328,0.0002000}, {329,0.0000857}, {330,0.0001714}, {331,0.0004000}, {332,0.0000857}, {333,0.0000000}, {334,0.0002857}, {335,0.0000857}, {336,0.0000857}, {337,0.0001714}, {338,0.0003429}, {339,0.0000857}, {340,0.0001714}, {341,0.0002000}, {342,0.0004286}, {343,0.0000000}, {344,0.0002571}, {345,0.0002857}, {346,0.0000000}, {347,0.0002857}, {348,0.0001143}, {349,0.0002571}, {350,0.0003429}, {351,0.0001714}, {352,0.0004857}, {353,0.0001714}, {354,0.0001714}, {355,0.0000000}, {356,0.0000000}, {357,0.0002857}, {358,0.0001714}, {359,0.0005714}, {360,0.0002571}, {361,0.0004571}, {362,0.0002571}, {363,0.0000857}, {364,0.0004286}, {365,0.0002000}, {366,0.0001714}, {367,0.0004857}, {368,0.0000857}, {369,0.0001714}, {370,0.0002571}, {371,0.0004857}, {372,0.0000857}, {373,0.0003714}, {374,0.0002571}, {375,0.0000857}, {376,0.0000000}, {377,0.0000857}, {378,0.0000000}, {379,0.0004857}, {380,0.0004857}, {381,0.0001714}, {382,0.0006571}, {383,0.0002571}, {384,0.0001714}, {385,0.0004286}, {386,0.0002000}, {387,0.0000000}, {388,0.0003429}, {389,0.0002857}, {390,0.0000857}, {391,0.0001714}, {392,0.0005143}, {393,0.0000857}, {394,0.0003429}, {395,0.0001714}, {396,0.0003143}, {397,0.0002857}, {398,0.0000000}, {399,0.0002571}, {400,0.0004571}, {401,0.0000000}, {402,0.0001714}, {403,0.0002857}, {404,0.0000857}, {405,0.0002857}, {406,0.0000857}, {407,0.0005143}, {408,0.0002571}, {409,0.0004857}, {410,0.0000857}, {411,0.0002857}, {412,0.0000000}, {413,0.0002000}, {414,0.0002000}, {415,0.0000857}, {416,0.0000857}, {417,0.0001714}, {418,0.0000000}, {419,0.0001143}, {420,0.0001714}, {421,0.0003714}, {422,0.0002857}, {423,0.0016571}, {424,0.0004857}, {425,0.0001714}, {426,0.0003429}, {427,0.0002571}, {428,0.0002571}, {429,0.0006286}, {430,0.0003429}, {431,0.0001714}, {432,0.0004571}, {433,0.0002000}, {434,0.0003714}, {435,0.0001143}, {436,0.0001714}, {437,0.0002857}, {438,0.0001143}, {439,0.0002000}, {440,0.0004571}, {441,0.0002857}, {442,0.0001143}, {443,0.0002571}, {444,0.0002857}, {445,0.0004857}, {446,0.0004571}, {447,0.0004571}, {448,0.0000857}, {449,0.0001714}, {450,0.0002000}, {451,0.0002571}, {452,0.0002286}, {453,0.0001714}, {454,0.0002571}, {455,0.0000857}, {456,0.0003429}, {457,0.0000857}, {458,0.0002857}, {459,0.0000000}, {460,0.0004286}, {461,0.0002857}, {462,0.0003429}, {463,0.0002000}, {464,0.0004571}, {465,0.0002000}, {466,0.0004571}, {467,0.0001714}, {468,0.0002571}, {469,0.0006571}, {470,0.0002000}, {471,0.0001714}, {472,0.0006571}, {473,0.0003429}, {474,0.0002571}, {475,0.0002857}, {476,0.0000857}, {477,0.0000857}, {478,0.0003429}, {479,0.0005429}, {480,0.0002571}, {481,0.0005429}, {482,0.0008286}, {483,0.0002571}, {484,0.0001714}, {485,0.0002571}, {486,0.0002571}, {487,0.0003714}, {488,0.0001714}, {489,0.0002571}, {490,0.0006000}, {491,0.0002571}, {492,0.0003429}, {493,0.0003429}, {494,0.0003429}, {495,0.0001714}, {496,0.0005429}, {497,0.0002571}, {498,0.0003429}, {499,0.0000857}, {500,0.0004571}, {505,0.0005143}, {510,0.0003714}, {515,0.0004286}, {520,0.0006000}, {525,0.0002571}, {530,0.0002571}, {535,0.0000857}, {540,0.0000857}, {545,0.0002571}, {550,0.0004857}, {555,0.0002571}, {560,0.0002857}, {565,0.0002857}, {570,0.0000857}, {575,0.0003429}, {580,0.0003429}, {585,0.0002000}, {590,0.0003714}, {595,0.0000857}, {600,0.0003714}, {605,0.0000857}, {610,0.0001714}, {615,0.0004286}, {620,0.0001714}, {625,0.0004286}, {630,0.0003429}, {635,0.0005429}, {640,0.0000857}, {645,0.0004000}, {650,0.0002857}, {655,0.0006857}, {660,0.0003429}, {665,0.0002571}, {670,0.0005714}, {675,0.0001143}, {680,0.0002000}, {685,0.0007714}, {690,0.0001714}, {695,0.0000857}, {700,0.0001714}, {705,0.0003429}, {710,0.0008000}, {715,0.0004286}, {720,0.0001714}, {725,0.0003429}, {730,0.0000857}, {735,0.0004286}, {740,0.0006571}, {745,0.0002000}, {750,0.0002000}, {755,0.0001714}, {760,0.0005429}, {765,0.0005429}, {770,0.0003429}, {775,0.0004286}, {780,0.0001714}, {785,0.0003714}, {790,0.0006000}, {795,0.0002571}, {800,0.0006571}, {805,0.0004571}, {810,0.0002571}, {815,0.0002571}, {820,0.0004286}, {825,0.0004571}, {830,0.0005143}, {835,0.0007143}, {840,0.0002000}, {845,0.0005143}, {850,0.0005429}, {855,0.0002571}, {860,0.0005429}, {865,0.0003429}, {870,0.0007143}, {875,0.0005714}, {880,0.0002571}, {885,0.0002857}, {890,0.0004000}, {895,0.0004571}, {900,0.0004571}, {905,0.0005143}, {910,0.0005714}, {915,0.0004857}, {920,0.0002571}, {925,0.0006571}, {930,0.0003429}, {935,0.0005143}, {940,0.0001714}, {945,0.0004286}, {950,0.0002571}, {955,0.0003429}, {960,0.0006571}, {965,0.0001714}, {970,0.0004571}, {975,0.0004000}, {980,0.0008286}, {985,0.0003714}, {990,0.0005429}, {995,0.0009143}, {1000,0.0006857}, {1010,0.0006857}, {1020,0.0007714}, {1030,0.0010286}, {1040,0.0006000}, {1050,0.0008857}, {1060,0.0007143}, {1070,0.0006286}, {1080,0.0008286}, {1090,0.0006000}, {1100,0.0004857}, {1110,0.0005143}, {1120,0.0005714}, {1130,0.0007714}, {1140,0.0009429}, {1150,0.0005429}, {1160,0.0006286}, {1170,0.0008286}, {1180,0.0007429}, {1190,0.0004857}, {1200,0.0006571}, {1210,0.0010286}, {1220,0.0007429}, {1230,0.0006000}, {1240,0.0008000}, {1250,0.0009143}, {1260,0.0008857}, {1270,0.0007143}, {1280,0.0005143}, {1290,0.0007143}, {1300,0.0010571}, {1310,0.0004571}, {1320,0.0007143}, {1330,0.0005714}, {1340,0.0007143}, {1350,0.0008286}, {1360,0.0006286}, {1370,0.0005143}, {1380,0.0004857}, {1390,0.0009429}, {1400,0.0012286}, {1410,0.0008286}, {1420,0.0007429}, {1430,0.0008286}, {1440,0.0004000}, {1450,0.0015429}, {1460,0.0008857}, {1470,0.0010286}, {1480,0.0007714}, {1490,0.0012000}, {1500,0.0012857}, {1510,0.0005429}, {1520,0.0002857}, {1530,0.0007714}, {1540,0.0005143}, {1550,0.0008571}, {1560,0.0011143}, {1570,0.0008857}, {1580,0.0010000}, {1590,0.0008857}, {1600,0.0010286}, {1610,0.0009714}, {1620,0.0011714}, {1630,0.0005714}, {1640,0.0005429}, {1650,0.0010000}, {1660,0.0016286}, {1670,0.0010000}, {1680,0.0007429}, {1690,0.0006000}, {1700,0.0011429}, {1710,0.0010286}, {1720,0.0012571}, {1730,0.0012571}, {1740,0.0008571}, {1750,0.0013143}, {1760,0.0011714}, {1770,0.0010000}, {1780,0.0008857}, {1790,0.0011429}, {1800,0.0013714}, {1810,0.0010000}, {1820,0.0011143}, {1830,0.0014857}, {1840,0.0014000}, {1850,0.0012571}, {1860,0.0015143}, {1870,0.0010286}, {1880,0.0016857}, {1890,0.0015143}, {1900,0.0010286}, {1910,0.0014286}, {1920,0.0012857}, {1930,0.0008571}, {1940,0.0010571}, {1950,0.0007143}, {1960,0.0008286}, {1970,0.0011429}, {1980,0.0015429}, {1990,0.0013714}, {2000,0.0012286}};
data["big"]["LtacTCGallinaCtx"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00003960}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00003960}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00003960}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00003960}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0001143}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0001143}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0001143}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0001143}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0001143}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0001143}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0001143}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0001143}, {1240,0.0000857}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000857}, {1450,0.0000000}, {1460,0.0000857}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0001143}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000857}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000857}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000857}, {2000,0.0000000}};
data["big"]["LtacTCGallinaCtx"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00001980}, {3,0.00100000}, {4,0.00100000}, {5,0.00114851}, {6,0.00200000}, {7,0.00200000}, {8,0.00263366}, {9,0.00300000}, {10,0.00321782}, {11,0.00400000}, {12,0.00413861}, {13,0.00492079}, {14,0.00523762}, {15,0.00573267}, {16,0.00624752}, {17,0.00681188}, {18,0.00749505}, {19,0.00780198}, {20,0.00854455}, {21,0.00909901}, {22,0.00966337}, {23,0.01063366}, {24,0.01085149}, {25,0.01272277}, {26,0.01227723}, {27,0.01295050}, {28,0.01334653}, {29,0.01426733}, {30,0.01490099}, {31,0.01560396}, {32,0.01637624}, {33,0.01704950}, {34,0.01750495}, {35,0.01914851}, {36,0.02207921}, {37,0.02235644}, {38,0.02069307}, {39,0.02167327}, {40,0.02272277}, {41,0.02383168}, {42,0.02449505}, {43,0.02566337}, {44,0.02813861}, {45,0.02735644}, {46,0.02831683}, {47,0.03095050}, {48,0.03060396}, {49,0.03462376}, {50,0.03164356}, {51,0.03687129}, {52,0.03435644}, {53,0.03762376}, {54,0.03661386}, {55,0.03803960}, {56,0.04006931}, {57,0.04476238}, {58,0.04131683}, {59,0.04171287}, {60,0.04320792}, {61,0.04422772}, {62,0.04500000}, {63,0.04656436}, {64,0.04804950}, {65,0.04913861}, {66,0.05096040}, {67,0.06129703}, {68,0.05600000}, {69,0.05414851}, {70,0.05590099}, {71,0.05961386}, {72,0.05873267}, {73,0.06411881}, {74,0.06183168}, {75,0.06349505}, {76,0.14529703}, {77,0.06595050}, {78,0.06800990}, {79,0.09495050}, {80,0.08026733}, {81,0.07191089}, {82,0.07411881}, {83,0.07545545}, {84,0.07658416}, {85,0.08715842}, {86,0.09813861}, {87,0.10337624}, {88,0.10510891}, {89,0.10345545}, {90,0.10213861}, {91,0.11068317}, {92,0.11470297}, {93,0.11213861}, {94,0.10920792}, {95,0.11210891}, {96,0.11547525}, {97,0.11587129}, {98,0.11826733}, {99,0.12059406}, {100,0.12341584}, {101,0.12491089}, {102,0.12824752}, {103,0.12345545}, {104,0.12699010}, {105,0.12959406}, {106,0.13167327}, {107,0.13353465}, {108,0.13472277}, {109,0.13704950}, {110,0.13890099}, {111,0.14211881}, {112,0.14267327}, {113,0.14474257}, {114,0.14737624}, {115,0.14987129}, {116,0.15150495}, {117,0.15507921}, {118,0.15660396}, {119,0.15921782}, {120,0.16272277}, {121,0.16553465}, {122,0.16684158}, {123,0.17090099}, {124,0.17226733}, {125,0.17479208}, {126,0.17812871}, {127,0.18072277}, {128,0.18246535}, {129,0.18562376}, {130,0.18875248}, {131,0.19040594}, {132,0.19397030}, {133,0.19556436}, {134,0.19835644}, {135,0.20171287}, {136,0.20584158}, {137,0.20726733}, {138,0.21087129}, {139,0.21340594}, {140,0.21382178}, {141,0.21995050}, {142,0.22125743}, {143,0.22496040}, {144,0.22951485}, {145,0.23011881}, {146,0.23402970}, {147,0.23695050}, {148,0.24036634}, {149,0.24396040}, {150,0.24785149}, {151,0.24882178}, {152,0.25193069}, {153,0.25615842}, {154,0.25976238}, {155,0.26243564}, {156,0.26641584}, {157,0.26772277}, {158,0.27447525}, {159,0.27547525}, {160,0.27923762}, {161,0.28259406}, {162,0.28393069}, {163,0.29915842}, {164,0.28971287}, {165,0.29479208}, {166,0.29805941}, {167,0.29932673}, {168,0.30162376}, {169,0.30917822}, {170,0.31117822}, {171,0.31417822}, {172,0.32157426}, {173,0.32198020}, {174,0.32674257}, {175,0.32882178}, {176,0.33184158}, {177,0.33663366}, {178,0.34018812}, {179,0.34646535}, {180,0.35212871}, {181,0.35535644}, {182,0.36281188}, {183,0.36643564}, {184,0.37186139}, {185,0.37624752}, {186,0.38080198}, {187,0.38553465}, {188,0.38672277}, {189,0.39269307}, {190,0.39245545}, {191,0.39623762}, {192,0.39952475}, {193,0.40222772}, {194,0.40483168}, {195,0.40928713}, {196,0.41094059}, {197,0.41375248}, {198,0.41803960}, {199,0.42871287}, {200,0.43831683}, {201,0.43342574}, {202,0.43434653}, {203,0.44184158}, {204,0.44399010}, {205,0.45662376}, {206,0.46639604}, {207,0.45805941}, {208,0.46142574}, {209,0.46627723}, {210,0.47853465}, {211,0.48934653}, {212,0.48160396}, {213,0.48225743}, {214,0.49882178}, {215,0.50838614}, {216,0.49887129}, {217,0.50325743}, {218,0.52005941}, {219,0.51997030}, {220,0.51928713}, {221,0.53909901}, {222,0.53410891}, {223,0.53711881}, {224,0.54906931}, {225,0.54798020}, {226,0.55728713}, {227,0.55510891}, {228,0.56390099}, {229,0.57295050}, {230,0.57199010}, {231,0.58861386}, {232,0.57992079}, {233,0.60091089}, {234,0.58909901}, {235,0.60827723}, {236,0.59912871}, {237,0.67199010}, {238,0.61297030}, {239,0.69948515}, {240,0.62608911}, {241,0.62902970}, {242,0.63935644}, {243,0.64025743}, {244,0.64843564}, {245,0.71767327}, {246,0.65606931}, {247,0.66790099}, {248,0.67062376}, {249,0.67033663}, {250,0.68704950}, {251,0.68350495}, {252,0.68794059}, {253,0.70261386}, {254,0.70458416}, {255,0.70577228}, {256,0.71865347}, {257,0.72352475}, {258,0.72350495}, {259,0.72934653}, {260,0.73635644}, {261,0.74739604}, {262,0.75697030}, {263,0.76267327}, {264,0.76343564}, {265,0.76783168}, {266,0.77055446}, {267,0.77860396}, {268,0.78869307}, {269,0.79502970}, {270,0.79837624}, {271,0.80148515}, {272,0.81366337}, {273,0.81924752}, {274,0.82812871}, {275,0.83346535}, {276,0.84338614}, {277,0.84800990}, {278,0.85561386}, {279,0.86239604}, {280,0.86596040}, {281,0.87293069}, {282,0.88284158}, {283,0.89257426}, {284,0.90110891}, {285,0.90737624}, {286,0.91718812}, {287,0.91855446}, {288,0.92981188}, {289,0.93535644}, {290,0.93822772}, {291,0.94380198}, {292,0.94613861}, {293,0.94926733}, {294,0.95755446}, {295,0.96391089}, {296,0.97167327}, {297,0.98984158}, {298,0.99192079}, {299,0.98820792}, {300,0.99355446}, {301,1.0490571}, {302,1.1484286}, {303,1.1072571}, {304,1.1074857}, {305,1.0812571}, {306,1.0989143}, {307,1.1267429}, {308,1.1070571}, {309,1.1116571}, {310,1.1677429}, {311,1.1284000}, {312,1.1356571}, {313,1.1601714}, {314,1.1577714}, {315,1.1640857}, {316,1.1712571}, {317,1.1772000}, {318,1.1855429}, {319,1.1936286}, {320,1.2076857}, {321,1.2000286}, {322,1.2546286}, {323,1.2439714}, {324,1.2280286}, {325,1.2614571}, {326,1.2448000}, {327,1.2514571}, {328,1.2608571}, {329,1.2704857}, {330,1.2759714}, {331,1.2984286}, {332,1.2911429}, {333,1.3313429}, {334,1.2989143}, {335,1.3526000}, {336,1.3302286}, {337,1.3333714}, {338,1.3413429}, {339,1.3476857}, {340,1.3779429}, {341,1.3658857}, {342,1.3830857}, {343,1.3938857}, {344,1.4096000}, {345,1.4116571}, {346,1.4191429}, {347,1.4260571}, {348,1.4350286}, {349,1.4443714}, {350,1.4799143}, {351,1.4767429}, {352,1.4731429}, {353,1.4881714}, {354,1.4905714}, {355,1.5036571}, {356,1.5052857}, {357,1.5211714}, {358,1.5306286}, {359,1.5398857}, {360,1.5459714}, {361,1.5582571}, {362,1.5696857}, {363,1.5769714}, {364,1.5912000}, {365,1.6017714}, {366,1.5988000}, {367,1.6151429}, {368,1.6261429}, {369,1.6339429}, {370,1.6434000}, {371,1.6603714}, {372,1.6672286}, {373,1.6768571}, {374,1.6774571}, {375,1.7054571}, {376,1.7110286}, {377,1.7158857}, {378,1.7258286}, {379,1.7302857}, {380,1.7475143}, {381,1.7556000}, {382,1.7697429}, {383,1.7798286}, {384,1.7977429}, {385,1.8082000}, {386,1.8260571}, {387,1.8382571}, {388,1.8404000}, {389,1.8573429}, {390,1.8750857}, {391,1.8793429}, {392,1.8910000}, {393,1.9108857}, {394,1.9089714}, {395,1.9288857}, {396,1.9321714}, {397,1.9530571}, {398,1.9750286}, {399,1.9697429}, {400,1.9822571}, {401,1.9951714}, {402,2.0082857}, {403,2.0259429}, {404,2.0361714}, {405,2.0612571}, {406,2.0658857}, {407,2.0687143}, {408,2.0815143}, {409,2.0973143}, {410,2.0983429}, {411,2.1078286}, {412,2.1054571}, {413,2.1302286}, {414,2.1370857}, {415,2.1546571}, {416,2.1513143}, {417,2.1556571}, {418,2.1692000}, {419,2.1764286}, {420,2.1936286}, {421,2.2135714}, {422,2.2099714}, {423,2.2247429}, {424,2.2296286}, {425,2.2415429}, {426,2.2633429}, {427,2.3186000}, {428,2.3091714}, {429,2.3200286}, {430,2.3203143}, {431,2.3365714}, {432,2.3576286}, {433,2.3661714}, {434,2.4017429}, {435,2.3934286}, {436,2.4087714}, {437,2.4104286}, {438,2.4297429}, {439,2.4581429}, {440,2.4750857}, {441,2.4748000}, {442,2.4888000}, {443,2.5038286}, {444,2.5179143}, {445,2.5266286}, {446,2.5390000}, {447,2.5518286}, {448,2.5603429}, {449,2.5778000}, {450,2.6002000}, {451,2.6014000}, {452,2.6110857}, {453,2.6322857}, {454,2.6466571}, {455,2.6693714}, {456,2.6708000}, {457,2.6847714}, {458,2.7079714}, {459,2.7258000}, {460,2.7342286}, {461,2.7412286}, {462,2.7766000}, {463,2.7768286}, {464,2.8110571}, {465,2.8068286}, {466,2.8162286}, {467,2.9138286}, {468,2.8448286}, {469,2.8558286}, {470,2.9190571}, {471,2.9121714}, {472,2.9236857}, {473,2.9812000}, {474,2.9418571}, {475,2.9332000}, {476,2.9352286}, {477,3.0011143}, {478,2.9696857}, {479,3.0330000}, {480,3.0029143}, {481,3.0270286}, {482,3.0304286}, {483,3.0609714}, {484,3.1081714}, {485,3.0912286}, {486,3.1373429}, {487,3.1202000}, {488,3.1328857}, {489,3.1300000}, {490,3.1368286}, {491,3.1575429}, {492,3.1788571}, {493,3.1970571}, {494,3.2318857}, {495,3.2416857}, {496,3.2588571}, {497,3.2792000}, {498,3.2878857}, {499,3.3072571}, {500,3.3199714}, {505,3.3961143}, {510,3.4742571}, {515,3.5566571}, {520,3.6403143}, {525,3.7259429}, {530,3.8526000}, {535,3.8945714}, {540,4.0790571}, {545,4.0469714}, {550,4.2158857}, {555,4.2606000}, {560,4.3294286}, {565,4.4671143}, {570,4.5219143}, {575,4.6406571}, {580,4.7676000}, {585,4.8447429}, {590,4.9976286}, {595,5.1862000}, {600,5.2514000}, {605,5.3225429}, {610,5.3734286}, {615,5.5453714}, {620,5.6814571}, {625,5.8569429}, {630,5.9284571}, {635,5.9640571}, {640,6.1736000}, {645,6.3080571}, {650,6.3649714}, {655,6.3787429}, {660,6.4349714}, {665,6.6121714}, {670,6.7759429}, {675,6.8973143}, {680,7.1100857}, {685,7.2158857}, {690,7.3724571}, {695,7.3902000}, {700,7.6852571}, {705,7.7697143}, {710,8.0174286}, {715,7.9616000}, {720,8.1099429}, {725,8.3642571}, {730,8.2952857}, {735,8.6260571}, {740,8.7494000}, {745,9.0065143}, {750,9.1122857}, {755,9.3668571}, {760,9.5194286}, {765,9.7312571}, {770,9.7753143}, {775,9.6664000}, {780,10.0258571}, {785,10.1359714}, {790,10.3194286}, {795,10.4186286}, {800,10.7556000}, {805,10.9286286}, {810,10.9683429}, {815,11.1977429}, {820,11.2878000}, {825,11.5509143}, {830,11.5995714}, {835,11.6947714}, {840,12.2326000}, {845,12.3313714}, {850,12.2468286}, {855,12.7629143}, {860,12.7879714}, {865,13.2578286}, {870,13.3926857}, {875,13.6126857}, {880,13.9496857}, {885,13.7235143}, {890,14.2407143}, {895,14.2621143}, {900,14.4499714}, {905,14.8150571}, {910,15.1414286}, {915,15.1214286}, {920,15.4346857}, {925,15.5761429}, {930,15.9126857}, {935,16.0923143}, {940,16.0691143}, {945,16.5215714}, {950,16.6234286}, {955,16.5434286}, {960,17.0089714}, {965,17.5706000}, {970,17.1332286}, {975,17.5909429}, {980,18.2682857}, {985,18.2300857}, {990,18.5672000}, {995,19.0679143}, {1000,19.2828000}, {1010,19.6446000}, {1020,20.1049143}, {1030,20.8031714}, {1040,21.1854571}, {1050,21.9896000}, {1060,22.4910000}, {1070,23.2178286}, {1080,23.7866571}, {1090,24.3177143}, {1100,24.9632857}, {1110,25.6897143}, {1120,26.4512857}, {1130,26.7105143}, {1140,27.8896286}, {1150,28.5041143}, {1160,28.9263143}, {1170,29.3352000}, {1180,30.4364286}, {1190,31.0700857}, {1200,32.1209429}, {1210,32.6437714}, {1220,33.3270000}, {1230,34.0863429}, {1240,34.7026286}, {1250,35.6544857}, {1260,36.6446857}, {1270,37.2679429}, {1280,38.0412286}, {1290,38.6486571}, {1300,39.7117429}, {1310,40.5331429}, {1320,41.6318286}, {1330,42.1876571}, {1340,43.1320571}, {1350,43.8477714}, {1360,45.7302000}, {1370,46.2180571}, {1380,47.2294571}, {1390,48.6271143}, {1400,49.3351714}, {1410,50.1788571}, {1420,51.4660286}, {1430,52.2127429}, {1440,53.5124857}, {1450,54.2332286}, {1460,55.8528286}, {1470,56.6121143}, {1480,57.8711714}, {1490,59.4187429}, {1500,60.1963143}, {1510,61.1906857}, {1520,62.7728571}, {1530,63.1670571}, {1540,65.0208571}, {1550,66.2447143}, {1560,67.5574000}, {1570,68.8536857}, {1580,69.8774857}, {1590,71.3007143}, {1600,72.6850857}, {1610,73.4956000}, {1620,76.0986286}, {1630,76.1791143}, {1640,78.0356000}, {1650,79.1907714}, {1660,79.4785143}, {1670,81.9954857}, {1680,83.4122571}, {1690,85.3681429}, {1700,86.6809143}, {1710,88.0271429}, {1720,90.2008571}, {1730,91.2886571}, {1740,93.1283429}, {1750,94.7787143}, {1760,95.5866000}, {1770,97.6665143}, {1780,98.7737143}, {1790,101.3159143}, {1800,102.3855143}, {1810,105.1176571}, {1820,105.7412571}, {1830,106.4813143}, {1840,108.2073429}, {1850,110.2298857}, {1860,113.2644000}, {1870,115.8039143}, {1880,116.8110571}, {1890,120.5196571}, {1900,120.1149714}, {1910,123.3057143}, {1920,126.4145714}, {1930,125.2391429}, {1940,127.1561143}, {1950,129.6344571}, {1960,130.4771429}, {1970,134.0328286}, {1980,134.5450000}, {1990,137.6009429}, {2000,140.8481714}};
data["big"]["LtacTCGallinaCtx"]["norm reif"]["user"] = {{1,0.00060396}, {2,0.00091089}, {3,0.00139604}, {4,0.00188119}, {5,0.00168317}, {6,0.00190099}, {7,0.00297030}, {8,0.00271287}, {9,0.00336634}, {10,0.00347525}, {11,0.00395050}, {12,0.00449505}, {13,0.00494059}, {14,0.00570297}, {15,0.00586139}, {16,0.00640594}, {17,0.00729703}, {18,0.00747525}, {19,0.00795050}, {20,0.00867327}, {21,0.00919802}, {22,0.00971287}, {23,0.01035644}, {24,0.01115842}, {25,0.01245545}, {26,0.01208911}, {27,0.01302970}, {28,0.01311881}, {29,0.01418812}, {30,0.01450495}, {31,0.01514851}, {32,0.01593069}, {33,0.01680198}, {34,0.01722772}, {35,0.01882178}, {36,0.02211881}, {37,0.02240594}, {38,0.02058416}, {39,0.02157426}, {40,0.02278218}, {41,0.02423762}, {42,0.02477228}, {43,0.02602970}, {44,0.02839604}, {45,0.02754455}, {46,0.02853465}, {47,0.03075248}, {48,0.03084158}, {49,0.03447525}, {50,0.03165347}, {51,0.03671287}, {52,0.03426733}, {53,0.03741584}, {54,0.03634653}, {55,0.03776238}, {56,0.03984158}, {57,0.04466337}, {58,0.04079208}, {59,0.04105941}, {60,0.04266337}, {61,0.04411881}, {62,0.04458416}, {63,0.04650495}, {64,0.04848515}, {65,0.04929703}, {66,0.05122772}, {67,0.06098020}, {68,0.05622772}, {69,0.05436634}, {70,0.05603960}, {71,0.05941584}, {72,0.05873267}, {73,0.06397030}, {74,0.06177228}, {75,0.06305941}, {76,0.14505941}, {77,0.06523762}, {78,0.06787129}, {79,0.09468317}, {80,0.08024752}, {81,0.07211881}, {82,0.07466337}, {83,0.07547525}, {84,0.07661386}, {85,0.08675248}, {86,0.09816832}, {87,0.10335644}, {88,0.10499010}, {89,0.10331683}, {90,0.10216832}, {91,0.11008911}, {92,0.11440594}, {93,0.11191089}, {94,0.10886139}, {95,0.11195050}, {96,0.11501980}, {97,0.11583168}, {98,0.11781188}, {99,0.12006931}, {100,0.12303960}, {101,0.12465347}, {102,0.12810891}, {103,0.12352475}, {104,0.12687129}, {105,0.12924752}, {106,0.13159406}, {107,0.13319802}, {108,0.13427723}, {109,0.13657426}, {110,0.13858416}, {111,0.14180198}, {112,0.14198020}, {113,0.14482178}, {114,0.14694059}, {115,0.14952475}, {116,0.15155446}, {117,0.15474257}, {118,0.15634653}, {119,0.15868317}, {120,0.16235644}, {121,0.16502970}, {122,0.16668317}, {123,0.17067327}, {124,0.17216832}, {125,0.17428713}, {126,0.17789109}, {127,0.18022772}, {128,0.18229703}, {129,0.18548515}, {130,0.18837624}, {131,0.19008911}, {132,0.19321782}, {133,0.19551485}, {134,0.19815842}, {135,0.20135644}, {136,0.20549505}, {137,0.20679208}, {138,0.21051485}, {139,0.21301980}, {140,0.21330693}, {141,0.21965347}, {142,0.22061386}, {143,0.22448515}, {144,0.22890099}, {145,0.22954455}, {146,0.23318812}, {147,0.23635644}, {148,0.23994059}, {149,0.24315842}, {150,0.24724752}, {151,0.24835644}, {152,0.25135644}, {153,0.25542574}, {154,0.25927723}, {155,0.26161386}, {156,0.26577228}, {157,0.26711881}, {158,0.27371287}, {159,0.27479208}, {160,0.27849505}, {161,0.28200000}, {162,0.28354455}, {163,0.29864356}, {164,0.28902970}, {165,0.29406931}, {166,0.29736634}, {167,0.29864356}, {168,0.30108911}, {169,0.30859406}, {170,0.31028713}, {171,0.31321782}, {172,0.32054455}, {173,0.32108911}, {174,0.32594059}, {175,0.32772277}, {176,0.33103960}, {177,0.33584158}, {178,0.33951485}, {179,0.34602970}, {180,0.35159406}, {181,0.35478218}, {182,0.36218812}, {183,0.36583168}, {184,0.37110891}, {185,0.37540594}, {186,0.38030693}, {187,0.38482178}, {188,0.38628713}, {189,0.39204950}, {190,0.39153465}, {191,0.39542574}, {192,0.39873267}, {193,0.40173267}, {194,0.40413861}, {195,0.40822772}, {196,0.41012871}, {197,0.41279208}, {198,0.41710891}, {199,0.42774257}, {200,0.43736634}, {201,0.43218812}, {202,0.43350495}, {203,0.44088119}, {204,0.44300000}, {205,0.45564356}, {206,0.46518812}, {207,0.45718812}, {208,0.46045545}, {209,0.46540594}, {210,0.47774257}, {211,0.48839604}, {212,0.48104950}, {213,0.48107921}, {214,0.49823762}, {215,0.50768317}, {216,0.49825743}, {217,0.50240594}, {218,0.51891089}, {219,0.51916832}, {220,0.51841584}, {221,0.53825743}, {222,0.53323762}, {223,0.53616832}, {224,0.54829703}, {225,0.54722772}, {226,0.55680198}, {227,0.55432673}, {228,0.56291089}, {229,0.57200000}, {230,0.57123762}, {231,0.58758416}, {232,0.57911881}, {233,0.59982178}, {234,0.58810891}, {235,0.60693069}, {236,0.59809901}, {237,0.67067327}, {238,0.61185149}, {239,0.69842574}, {240,0.62510891}, {241,0.62776238}, {242,0.63824752}, {243,0.63919802}, {244,0.64718812}, {245,0.71658416}, {246,0.65471287}, {247,0.66674257}, {248,0.66947525}, {249,0.66901980}, {250,0.68607921}, {251,0.68190099}, {252,0.68657426}, {253,0.70108911}, {254,0.70336634}, {255,0.70430693}, {256,0.71745545}, {257,0.72253465}, {258,0.72209901}, {259,0.72810891}, {260,0.73510891}, {261,0.74607921}, {262,0.75551485}, {263,0.76107921}, {264,0.76210891}, {265,0.76685149}, {266,0.76878218}, {267,0.77772277}, {268,0.78740594}, {269,0.79358416}, {270,0.79711881}, {271,0.80051485}, {272,0.81232673}, {273,0.81806931}, {274,0.82680198}, {275,0.83230693}, {276,0.84253465}, {277,0.84672277}, {278,0.85400990}, {279,0.86111881}, {280,0.86432673}, {281,0.87131683}, {282,0.88123762}, {283,0.89098020}, {284,0.89983168}, {285,0.90579208}, {286,0.91509901}, {287,0.91700990}, {288,0.92820792}, {289,0.93401980}, {290,0.93664356}, {291,0.94214851}, {292,0.94468317}, {293,0.94767327}, {294,0.95574257}, {295,0.96224752}, {296,0.97040594}, {297,0.98774257}, {298,0.99034653}, {299,0.98692079}, {300,0.99204950}, {301,1.0480571}, {302,1.1413143}, {303,1.1058857}, {304,1.1058857}, {305,1.0799143}, {306,1.0967429}, {307,1.1254000}, {308,1.1053429}, {309,1.1100571}, {310,1.1660000}, {311,1.1264000}, {312,1.1340286}, {313,1.1548857}, {314,1.1566000}, {315,1.1629429}, {316,1.1696857}, {317,1.1759714}, {318,1.1842571}, {319,1.1918571}, {320,1.2027429}, {321,1.1988857}, {322,1.2522571}, {323,1.2421429}, {324,1.2271429}, {325,1.2594000}, {326,1.2442000}, {327,1.2491714}, {328,1.2595429}, {329,1.2678857}, {330,1.2744857}, {331,1.2960000}, {332,1.2892571}, {333,1.3257429}, {334,1.2967143}, {335,1.3352571}, {336,1.3224571}, {337,1.3321429}, {338,1.3398286}, {339,1.3464000}, {340,1.3760857}, {341,1.3640857}, {342,1.3814286}, {343,1.3921714}, {344,1.4079429}, {345,1.4095143}, {346,1.4170571}, {347,1.4246857}, {348,1.4338000}, {349,1.4428286}, {350,1.4778571}, {351,1.4745429}, {352,1.4708857}, {353,1.4875714}, {354,1.4894000}, {355,1.5020000}, {356,1.5039714}, {357,1.5200000}, {358,1.5296571}, {359,1.5380000}, {360,1.5441429}, {361,1.5562000}, {362,1.5676286}, {363,1.5749143}, {364,1.5889429}, {365,1.5988571}, {366,1.5965714}, {367,1.6131429}, {368,1.6247429}, {369,1.6317143}, {370,1.6414571}, {371,1.6584000}, {372,1.6648000}, {373,1.6753143}, {374,1.6747429}, {375,1.7037143}, {376,1.7091429}, {377,1.7138857}, {378,1.7226857}, {379,1.7273714}, {380,1.7445429}, {381,1.7522286}, {382,1.7664571}, {383,1.7763714}, {384,1.7949429}, {385,1.8046000}, {386,1.8231429}, {387,1.8351714}, {388,1.8372857}, {389,1.8538286}, {390,1.8725143}, {391,1.8763714}, {392,1.8881429}, {393,1.8980571}, {394,1.9062857}, {395,1.9264857}, {396,1.9295143}, {397,1.9498286}, {398,1.9714286}, {399,1.9662571}, {400,1.9789714}, {401,1.9921714}, {402,2.0056857}, {403,2.0229714}, {404,2.0329429}, {405,2.0552571}, {406,2.0576000}, {407,2.0585429}, {408,2.0753714}, {409,2.0937714}, {410,2.0944571}, {411,2.1029714}, {412,2.1021429}, {413,2.1264286}, {414,2.1330286}, {415,2.1514000}, {416,2.1470000}, {417,2.1517143}, {418,2.1660000}, {419,2.1729429}, {420,2.1905714}, {421,2.2107714}, {422,2.2068000}, {423,2.2211714}, {424,2.2258286}, {425,2.2376286}, {426,2.2587143}, {427,2.3151714}, {428,2.3042571}, {429,2.3146286}, {430,2.3159143}, {431,2.3317714}, {432,2.3524286}, {433,2.3607429}, {434,2.3972286}, {435,2.3881714}, {436,2.4036000}, {437,2.4060000}, {438,2.4254571}, {439,2.4533143}, {440,2.4694286}, {441,2.4690286}, {442,2.4833429}, {443,2.4985143}, {444,2.5130286}, {445,2.5218857}, {446,2.5337714}, {447,2.5464000}, {448,2.5548286}, {449,2.5729714}, {450,2.5957143}, {451,2.5971143}, {452,2.6070571}, {453,2.6282286}, {454,2.6413714}, {455,2.6650000}, {456,2.6646000}, {457,2.6794000}, {458,2.7028857}, {459,2.7218000}, {460,2.7295714}, {461,2.7370857}, {462,2.7727714}, {463,2.7727143}, {464,2.8071143}, {465,2.8028000}, {466,2.8112000}, {467,2.9098000}, {468,2.8402571}, {469,2.8518857}, {470,2.9141143}, {471,2.9067429}, {472,2.9175429}, {473,2.9751714}, {474,2.9362571}, {475,2.9262857}, {476,2.9296000}, {477,2.9943429}, {478,2.9650000}, {479,3.0266857}, {480,2.9964857}, {481,3.0201714}, {482,3.0218857}, {483,3.0530286}, {484,3.0999143}, {485,3.0824571}, {486,3.1281714}, {487,3.1112571}, {488,3.1246857}, {489,3.1223143}, {490,3.1299143}, {491,3.1500286}, {492,3.1716857}, {493,3.1898857}, {494,3.2234571}, {495,3.2341714}, {496,3.2515143}, {497,3.2722857}, {498,3.2799714}, {499,3.2998000}, {500,3.3122571}, {505,3.3876286}, {510,3.4668000}, {515,3.5467714}, {520,3.6281714}, {525,3.7143143}, {530,3.8420286}, {535,3.8831143}, {540,4.0659714}, {545,4.0340571}, {550,4.2020571}, {555,4.2466000}, {560,4.3162286}, {565,4.4539429}, {570,4.5101714}, {575,4.6287714}, {580,4.7543143}, {585,4.8318286}, {590,4.9842286}, {595,5.1730000}, {600,5.2382286}, {605,5.3103429}, {610,5.3602000}, {615,5.5340286}, {620,5.6691143}, {625,5.8434286}, {630,5.9156286}, {635,5.9507429}, {640,6.1604571}, {645,6.2957714}, {650,6.3552857}, {655,6.3722286}, {660,6.4268286}, {665,6.6032000}, {670,6.7662571}, {675,6.8890857}, {680,7.1003714}, {685,7.2031429}, {690,7.3611429}, {695,7.3801429}, {700,7.6730857}, {705,7.7605429}, {710,8.0080857}, {715,7.9504571}, {720,8.0977143}, {725,8.3476857}, {730,8.2806571}, {735,8.6140286}, {740,8.7381429}, {745,8.9953429}, {750,9.1022857}, {755,9.3567143}, {760,9.5076286}, {765,9.7220857}, {770,9.7612000}, {775,9.6522857}, {780,10.0114286}, {785,10.1222571}, {790,10.2959143}, {795,10.4020000}, {800,10.7322000}, {805,10.8940000}, {810,10.9269429}, {815,11.1783714}, {820,11.2677714}, {825,11.5251714}, {830,11.5808286}, {835,11.6633714}, {840,12.2164000}, {845,12.3150857}, {850,12.2314857}, {855,12.7462286}, {860,12.7703714}, {865,13.2427429}, {870,13.3793429}, {875,13.6025143}, {880,13.9415143}, {885,13.7187429}, {890,14.2353714}, {895,14.2508571}, {900,14.4351429}, {905,14.8026286}, {910,15.1225714}, {915,15.0970857}, {920,15.4164286}, {925,15.5579429}, {930,15.8935714}, {935,16.0684857}, {940,16.0460286}, {945,16.5032000}, {950,16.6110571}, {955,16.5324286}, {960,16.9917714}, {965,17.5507429}, {970,17.1066286}, {975,17.5663714}, {980,18.2401143}, {985,18.2007429}, {990,18.5285143}, {995,19.0296286}, {1000,19.2396286}, {1010,19.6015714}, {1020,20.0614286}, {1030,20.7599714}, {1040,21.1484000}, {1050,21.9258857}, {1060,22.4552286}, {1070,23.1901714}, {1080,23.7105429}, {1090,24.2915143}, {1100,24.9365429}, {1110,25.6522286}, {1120,26.4074857}, {1130,26.6800000}, {1140,27.7568857}, {1150,28.4668571}, {1160,28.8942857}, {1170,29.3067143}, {1180,30.3971714}, {1190,31.0392000}, {1200,32.0902857}, {1210,32.6069714}, {1220,33.2907429}, {1230,34.0347714}, {1240,34.6576571}, {1250,35.5975429}, {1260,36.5778571}, {1270,37.2112571}, {1280,37.9865143}, {1290,38.5939429}, {1300,39.6671714}, {1310,40.4970286}, {1320,41.5908571}, {1330,42.1422571}, {1340,43.0930857}, {1350,43.8012857}, {1360,45.6693429}, {1370,46.1596286}, {1380,47.1760571}, {1390,48.5726000}, {1400,49.2893429}, {1410,50.1302571}, {1420,51.4160571}, {1430,52.1520857}, {1440,53.4649143}, {1450,54.1573714}, {1460,55.7764857}, {1470,56.5494857}, {1480,57.8109143}, {1490,59.3544857}, {1500,60.1243714}, {1510,61.1149714}, {1520,62.6770857}, {1530,63.0829143}, {1540,64.9528571}, {1550,66.1709429}, {1560,67.4705714}, {1570,68.7887429}, {1580,69.7932857}, {1590,71.2043429}, {1600,72.5956857}, {1610,73.4192286}, {1620,76.0247429}, {1630,76.1001714}, {1640,77.9480286}, {1650,79.1002286}, {1660,79.3967429}, {1670,81.9012857}, {1680,83.3267714}, {1690,85.2711714}, {1700,86.5800000}, {1710,87.9441714}, {1720,90.1002286}, {1730,91.1652000}, {1740,93.0064857}, {1750,94.6704571}, {1760,95.4808286}, {1770,97.5386000}, {1780,98.6557429}, {1790,101.1910286}, {1800,102.3058000}, {1810,105.0388857}, {1820,105.6620286}, {1830,106.4010000}, {1840,108.0603714}, {1850,110.1042000}, {1860,113.1416286}, {1870,115.6312857}, {1880,116.7000000}, {1890,120.3914571}, {1900,120.0018000}, {1910,123.2218286}, {1920,126.3446857}, {1930,125.1377714}, {1940,127.0293143}, {1950,129.5378857}, {1960,130.2858286}, {1970,133.9593714}, {1980,134.4694571}, {1990,137.5267429}, {2000,140.7639714}};
data["big"]["LtacTCGallinaCtx"]["norm reif"]["system"] = {{1,0.00006931}, {2,0.00000000}, {3,0.00007921}, {4,0.00000000}, {5,0.00000000}, {6,0.00003960}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00011881}, {12,0.00000000}, {13,0.00000000}, {14,0.00011881}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00007921}, {19,0.00000000}, {20,0.00007921}, {21,0.00003960}, {22,0.00000000}, {23,0.00007921}, {24,0.00000000}, {25,0.00007921}, {26,0.00003960}, {27,0.00003960}, {28,0.00000000}, {29,0.00000000}, {30,0.00015842}, {31,0.00000000}, {32,0.00003960}, {33,0.00000000}, {34,0.00003960}, {35,0.00003960}, {36,0.00003960}, {37,0.00003960}, {38,0.00003960}, {39,0.00000000}, {40,0.00007921}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00003960}, {45,0.00011881}, {46,0.00000000}, {47,0.00003960}, {48,0.00000000}, {49,0.00000000}, {50,0.00007921}, {51,0.00003960}, {52,0.00007921}, {53,0.00000000}, {54,0.00003960}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00011881}, {59,0.00007921}, {60,0.00010891}, {61,0.00003960}, {62,0.00011881}, {63,0.00002970}, {64,0.00011881}, {65,0.00006931}, {66,0.00011881}, {67,0.00000000}, {68,0.00000000}, {69,0.00003960}, {70,0.00003960}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00003960}, {75,0.00000000}, {76,0.00030693}, {77,0.00007921}, {78,0.00006931}, {79,0.00011881}, {80,0.00000000}, {81,0.00003960}, {82,0.00000000}, {83,0.00011881}, {84,0.00011881}, {85,0.00003960}, {86,0.00003960}, {87,0.00007921}, {88,0.00007921}, {89,0.00003960}, {90,0.00000000}, {91,0.00003960}, {92,0.00007921}, {93,0.00000000}, {94,0.00003960}, {95,0.00000000}, {96,0.00011881}, {97,0.00003960}, {98,0.00003960}, {99,0.00000000}, {100,0.00003960}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00003960}, {106,0.00007921}, {107,0.00000000}, {108,0.00003960}, {109,0.00003960}, {110,0.00000000}, {111,0.00000000}, {112,0.00003960}, {113,0.00003960}, {114,0.00019802}, {115,0.00000000}, {116,0.00000000}, {117,0.00003960}, {118,0.00014851}, {119,0.00003960}, {120,0.00003960}, {121,0.00007921}, {122,0.00000000}, {123,0.00003960}, {124,0.00011881}, {125,0.00011881}, {126,0.00003960}, {127,0.00011881}, {128,0.00003960}, {129,0.00007921}, {130,0.00003960}, {131,0.00003960}, {132,0.00010891}, {133,0.00000000}, {134,0.00000000}, {135,0.00006931}, {136,0.00003960}, {137,0.00003960}, {138,0.00007921}, {139,0.00007921}, {140,0.00007921}, {141,0.00003960}, {142,0.00015842}, {143,0.00003960}, {144,0.00007921}, {145,0.00003960}, {146,0.00007921}, {147,0.00014851}, {148,0.00003960}, {149,0.00010891}, {150,0.00003960}, {151,0.00007921}, {152,0.00000000}, {153,0.00003960}, {154,0.00000000}, {155,0.00007921}, {156,0.00011881}, {157,0.00007921}, {158,0.00003960}, {159,0.00000000}, {160,0.00003960}, {161,0.00007921}, {162,0.00003960}, {163,0.00000000}, {164,0.00003960}, {165,0.00007921}, {166,0.00000000}, {167,0.00003960}, {168,0.00003960}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00011881}, {173,0.00007921}, {174,0.00007921}, {175,0.00007921}, {176,0.00003960}, {177,0.00003960}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00007921}, {183,0.00007921}, {184,0.00011881}, {185,0.00010891}, {186,0.00003960}, {187,0.00003960}, {188,0.00011881}, {189,0.00000000}, {190,0.00003960}, {191,0.00007921}, {192,0.00003960}, {193,0.00007921}, {194,0.00000000}, {195,0.00019802}, {196,0.00003960}, {197,0.00007921}, {198,0.00003960}, {199,0.00011881}, {200,0.00003960}, {201,0.00015842}, {202,0.00007921}, {203,0.00003960}, {204,0.00007921}, {205,0.00003960}, {206,0.00011881}, {207,0.00000000}, {208,0.00007921}, {209,0.00000000}, {210,0.00007921}, {211,0.00007921}, {212,0.00000000}, {213,0.00003960}, {214,0.00011881}, {215,0.00003960}, {216,0.00007921}, {217,0.00003960}, {218,0.00000000}, {219,0.00010891}, {220,0.00015842}, {221,0.00011881}, {222,0.00011881}, {223,0.00003960}, {224,0.00003960}, {225,0.00011881}, {226,0.00007921}, {227,0.00011881}, {228,0.00007921}, {229,0.00011881}, {230,0.00003960}, {231,0.00003960}, {232,0.00000000}, {233,0.00023762}, {234,0.00003960}, {235,0.00000000}, {236,0.00011881}, {237,0.00015842}, {238,0.00003960}, {239,0.00018812}, {240,0.00007921}, {241,0.00007921}, {242,0.00015842}, {243,0.00007921}, {244,0.00011881}, {245,0.00000000}, {246,0.00011881}, {247,0.00007921}, {248,0.00011881}, {249,0.00007921}, {250,0.00011881}, {251,0.00007921}, {252,0.00007921}, {253,0.00015842}, {254,0.00007921}, {255,0.00007921}, {256,0.00007921}, {257,0.00003960}, {258,0.00015842}, {259,0.00007921}, {260,0.00011881}, {261,0.00007921}, {262,0.00011881}, {263,0.00018812}, {264,0.00006931}, {265,0.00003960}, {266,0.00018812}, {267,0.00011881}, {268,0.00011881}, {269,0.00035644}, {270,0.00011881}, {271,0.00003960}, {272,0.00015842}, {273,0.00007921}, {274,0.00011881}, {275,0.00011881}, {276,0.00000000}, {277,0.00003960}, {278,0.00015842}, {279,0.00011881}, {280,0.00011881}, {281,0.00015842}, {282,0.00003960}, {283,0.00007921}, {284,0.00011881}, {285,0.00014851}, {286,0.00027723}, {287,0.00000000}, {288,0.00000000}, {289,0.00003960}, {290,0.00010891}, {291,0.00015842}, {292,0.00031683}, {293,0.00003960}, {294,0.00007921}, {295,0.00019802}, {296,0.00003960}, {297,0.00015842}, {298,0.00019802}, {299,0.00015842}, {300,0.00011881}, {301,0.0002286}, {302,0.0006571}, {303,0.0001143}, {304,0.0001143}, {305,0.0002286}, {306,0.0002286}, {307,0.0001143}, {308,0.0003429}, {309,0.0003143}, {310,0.0002286}, {311,0.0000000}, {312,0.0002286}, {313,0.0001143}, {314,0.0001143}, {315,0.0000000}, {316,0.0001143}, {317,0.0000000}, {318,0.0001143}, {319,0.0000000}, {320,0.0002286}, {321,0.0003429}, {322,0.0006857}, {323,0.0001143}, {324,0.0000000}, {325,0.0001143}, {326,0.0000000}, {327,0.0000000}, {328,0.0002286}, {329,0.0012571}, {330,0.0000000}, {331,0.0000000}, {332,0.0003429}, {333,0.0002286}, {334,0.0001143}, {335,0.0003429}, {336,0.0000000}, {337,0.0001143}, {338,0.0001143}, {339,0.0003429}, {340,0.0001143}, {341,0.0003429}, {342,0.0000000}, {343,0.0001143}, {344,0.0000000}, {345,0.0002286}, {346,0.0001143}, {347,0.0001143}, {348,0.0000000}, {349,0.0001143}, {350,0.0002286}, {351,0.0005714}, {352,0.0001143}, {353,0.0001143}, {354,0.0001143}, {355,0.0001143}, {356,0.0002286}, {357,0.0001143}, {358,0.0001143}, {359,0.0001143}, {360,0.0002286}, {361,0.0000000}, {362,0.0001143}, {363,0.0001143}, {364,0.0001143}, {365,0.0006857}, {366,0.0000000}, {367,0.0001143}, {368,0.0001143}, {369,0.0005714}, {370,0.0003429}, {371,0.0001143}, {372,0.0004571}, {373,0.0000000}, {374,0.0006857}, {375,0.0003429}, {376,0.0001143}, {377,0.0001143}, {378,0.0003429}, {379,0.0002286}, {380,0.0002286}, {381,0.0004571}, {382,0.0004571}, {383,0.0002286}, {384,0.0000000}, {385,0.0005714}, {386,0.0003143}, {387,0.0003429}, {388,0.0003429}, {389,0.0005714}, {390,0.0001143}, {391,0.0002000}, {392,0.0004571}, {393,0.0004571}, {394,0.0004571}, {395,0.0003429}, {396,0.0001143}, {397,0.0001143}, {398,0.0004571}, {399,0.0004571}, {400,0.0002286}, {401,0.0002286}, {402,0.0001143}, {403,0.0001143}, {404,0.0001143}, {405,0.0006857}, {406,0.0004571}, {407,0.0004571}, {408,0.0002286}, {409,0.0003429}, {410,0.0004286}, {411,0.0006571}, {412,0.0002286}, {413,0.0002286}, {414,0.0003429}, {415,0.0000000}, {416,0.0003429}, {417,0.0005714}, {418,0.0000000}, {419,0.0002286}, {420,0.0002286}, {421,0.0001143}, {422,0.0001143}, {423,0.0002286}, {424,0.0003429}, {425,0.0009143}, {426,0.0004571}, {427,0.0003143}, {428,0.0004571}, {429,0.0005714}, {430,0.0002286}, {431,0.0006857}, {432,0.0004571}, {433,0.0003429}, {434,0.0006857}, {435,0.0006857}, {436,0.0003429}, {437,0.0005714}, {438,0.0002286}, {439,0.0002286}, {440,0.0001143}, {441,0.0002286}, {442,0.0002286}, {443,0.0003429}, {444,0.0006857}, {445,0.0002286}, {446,0.0003429}, {447,0.0002286}, {448,0.0004571}, {449,0.0003429}, {450,0.0003429}, {451,0.0004571}, {452,0.0003429}, {453,0.0002286}, {454,0.0006857}, {455,0.0004571}, {456,0.0010286}, {457,0.0004571}, {458,0.0003429}, {459,0.0004571}, {460,0.0002286}, {461,0.0002286}, {462,0.0001143}, {463,0.0003429}, {464,0.0003429}, {465,0.0004571}, {466,0.0006857}, {467,0.0004571}, {468,0.0011143}, {469,0.0003429}, {470,0.0012571}, {471,0.0003429}, {472,0.0008000}, {473,0.0003429}, {474,0.0002286}, {475,0.0014857}, {476,0.0001143}, {477,0.0007714}, {478,0.0003429}, {479,0.0003429}, {480,0.0005429}, {481,0.0005714}, {482,0.0014857}, {483,0.0005714}, {484,0.0009143}, {485,0.0013714}, {486,0.0012571}, {487,0.0010286}, {488,0.0009143}, {489,0.0005714}, {490,0.0003429}, {491,0.0005714}, {492,0.0004571}, {493,0.0004571}, {494,0.0016571}, {495,0.0006571}, {496,0.0006571}, {497,0.0009143}, {498,0.0014857}, {499,0.0007714}, {500,0.0011429}, {505,0.0014571}, {510,0.0003429}, {515,0.0016000}, {520,0.0019429}, {525,0.0020571}, {530,0.0027429}, {535,0.0018000}, {540,0.0031429}, {545,0.0027143}, {550,0.0021714}, {555,0.0014857}, {560,0.0018000}, {565,0.0019429}, {570,0.0010000}, {575,0.0008000}, {580,0.0012571}, {585,0.0014571}, {590,0.0022857}, {595,0.0019143}, {600,0.0014857}, {605,0.0020286}, {610,0.0027143}, {615,0.0012571}, {620,0.0022857}, {625,0.0028000}, {630,0.0016000}, {635,0.0018286}, {640,0.0020571}, {645,0.0032000}, {650,0.0030857}, {655,0.0013714}, {660,0.0031429}, {665,0.0030571}, {670,0.0022571}, {675,0.0017143}, {680,0.0025143}, {685,0.0028571}, {690,0.0014571}, {695,0.0023714}, {700,0.0021714}, {705,0.0026286}, {710,0.0025143}, {715,0.0020571}, {720,0.0026000}, {725,0.0043143}, {730,0.0025143}, {735,0.0030857}, {740,0.0015714}, {745,0.0029429}, {750,0.0028286}, {755,0.0029429}, {760,0.0038286}, {765,0.0022857}, {770,0.0040000}, {775,0.0039714}, {780,0.0038857}, {785,0.0039143}, {790,0.0030571}, {795,0.0045714}, {800,0.0040857}, {805,0.0044286}, {810,0.0045429}, {815,0.0031714}, {820,0.0049143}, {825,0.0024857}, {830,0.0027143}, {835,0.0034286}, {840,0.0028571}, {845,0.0035143}, {850,0.0014857}, {855,0.0032000}, {860,0.0040000}, {865,0.0036286}, {870,0.0029429}, {875,0.0027429}, {880,0.0041429}, {885,0.0028000}, {890,0.0028286}, {895,0.0039714}, {900,0.0075429}, {905,0.0038286}, {910,0.0038286}, {915,0.0053143}, {920,0.0022857}, {925,0.0040000}, {930,0.0036000}, {935,0.0054286}, {940,0.0049714}, {945,0.0046286}, {950,0.0031714}, {955,0.0026286}, {960,0.0058571}, {965,0.0032857}, {970,0.0038857}, {975,0.0026000}, {980,0.0026286}, {985,0.0033143}, {990,0.0046286}, {995,0.0057429}, {1000,0.0077714}, {1010,0.0042571}, {1020,0.0038286}, {1030,0.0028857}, {1040,0.0047714}, {1050,0.0076000}, {1060,0.0046000}, {1070,0.0073143}, {1080,0.0076857}, {1090,0.0056571}, {1100,0.0053714}, {1110,0.0055429}, {1120,0.0071714}, {1130,0.0057714}, {1140,0.0081714}, {1150,0.0079143}, {1160,0.0063714}, {1170,0.0074571}, {1180,0.0104000}, {1190,0.0057143}, {1200,0.0064286}, {1210,0.0077714}, {1220,0.0067429}, {1230,0.0112857}, {1240,0.0100571}, {1250,0.0076571}, {1260,0.0125143}, {1270,0.0091429}, {1280,0.0090571}, {1290,0.0118571}, {1300,0.0096000}, {1310,0.0040000}, {1320,0.0067714}, {1330,0.0131714}, {1340,0.0065429}, {1350,0.0086000}, {1360,0.0186000}, {1370,0.0139429}, {1380,0.0098571}, {1390,0.0174857}, {1400,0.0116571}, {1410,0.0098286}, {1420,0.0136857}, {1430,0.0106286}, {1440,0.0155714}, {1450,0.0162000}, {1460,0.0152857}, {1470,0.0091429}, {1480,0.0153143}, {1490,0.0257429}, {1500,0.0168000}, {1510,0.0251714}, {1520,0.0223714}, {1530,0.0234857}, {1540,0.0198286}, {1550,0.0215143}, {1560,0.0235714}, {1570,0.0223429}, {1580,0.0273714}, {1590,0.0256286}, {1600,0.0262857}, {1610,0.0213714}, {1620,0.0243714}, {1630,0.0200000}, {1640,0.0269143}, {1650,0.0275429}, {1660,0.0192286}, {1670,0.0304857}, {1680,0.0166857}, {1690,0.0241714}, {1700,0.0225143}, {1710,0.0212571}, {1720,0.0300857}, {1730,0.0278857}, {1740,0.0301714}, {1750,0.0298286}, {1760,0.0311429}, {1770,0.0304857}, {1780,0.0271143}, {1790,0.0357429}, {1800,0.0359429}, {1810,0.0380286}, {1820,0.0325714}, {1830,0.0332000}, {1840,0.0379714}, {1850,0.0332286}, {1860,0.0408857}, {1870,0.0357143}, {1880,0.0312000}, {1890,0.0405429}, {1900,0.0308000}, {1910,0.0323429}, {1920,0.0382857}, {1930,0.0391429}, {1940,0.0433429}, {1950,0.0396000}, {1960,0.0293429}, {1970,0.0423714}, {1980,0.0428571}, {1990,0.0344000}, {2000,0.0445429}};
data["big"]["LtacTCGallinaCtx"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCGallinaCtx"]["post"]["user"] = {{1,0.00000000}, {2,0.00003960}, {3,0.00003960}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00003960}, {8,0.00000000}, {9,0.00007921}, {10,0.00000000}, {11,0.00003960}, {12,0.00000000}, {13,0.00003960}, {14,0.00002970}, {15,0.00007921}, {16,0.00000000}, {17,0.00003960}, {18,0.00000000}, {19,0.00003960}, {20,0.00000000}, {21,0.00003960}, {22,0.00003960}, {23,0.00007921}, {24,0.00002970}, {25,0.00003960}, {26,0.00007921}, {27,0.00006931}, {28,0.00011881}, {29,0.00000000}, {30,0.00000000}, {31,0.00007921}, {32,0.00000000}, {33,0.00003960}, {34,0.00007921}, {35,0.00003960}, {36,0.00000000}, {37,0.00003960}, {38,0.00002970}, {39,0.00000000}, {40,0.00000000}, {41,0.00011881}, {42,0.00007921}, {43,0.00003960}, {44,0.00000000}, {45,0.00006931}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00003960}, {50,0.00000000}, {51,0.00003960}, {52,0.00000000}, {53,0.00000000}, {54,0.00003960}, {55,0.00007921}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00006931}, {60,0.00000000}, {61,0.00007921}, {62,0.00000000}, {63,0.00000000}, {64,0.00003960}, {65,0.00000000}, {66,0.00003960}, {67,0.00000000}, {68,0.00006931}, {69,0.00002970}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00007921}, {74,0.00006931}, {75,0.00003960}, {76,0.00000000}, {77,0.00003960}, {78,0.00006931}, {79,0.00003960}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00003960}, {85,0.00007921}, {86,0.00003960}, {87,0.00000000}, {88,0.00006931}, {89,0.00000000}, {90,0.00002970}, {91,0.00010891}, {92,0.00007921}, {93,0.00007921}, {94,0.00000000}, {95,0.00000000}, {96,0.00007921}, {97,0.00002970}, {98,0.00002970}, {99,0.00000000}, {100,0.00000000}, {101,0.00003960}, {102,0.00003960}, {103,0.00007921}, {104,0.00003960}, {105,0.00007921}, {106,0.00000000}, {107,0.00000000}, {108,0.00007921}, {109,0.00002970}, {110,0.00000000}, {111,0.00000000}, {112,0.00003960}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00010891}, {117,0.00000000}, {118,0.00003960}, {119,0.00006931}, {120,0.00003960}, {121,0.00002970}, {122,0.00007921}, {123,0.00003960}, {124,0.00007921}, {125,0.00007921}, {126,0.00003960}, {127,0.00000000}, {128,0.00000000}, {129,0.00003960}, {130,0.00000000}, {131,0.00000000}, {132,0.00007921}, {133,0.00000000}, {134,0.00000000}, {135,0.00011881}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00007921}, {141,0.00007921}, {142,0.00000000}, {143,0.00003960}, {144,0.00000000}, {145,0.00003960}, {146,0.00003960}, {147,0.00000000}, {148,0.00000000}, {149,0.00002970}, {150,0.00000000}, {151,0.00007921}, {152,0.00002970}, {153,0.00003960}, {154,0.00000000}, {155,0.00006931}, {156,0.00000000}, {157,0.00002970}, {158,0.00003960}, {159,0.00000000}, {160,0.00006931}, {161,0.00000000}, {162,0.00007921}, {163,0.00003960}, {164,0.00000000}, {165,0.00003960}, {166,0.00009901}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00003960}, {171,0.00003960}, {172,0.00006931}, {173,0.00009901}, {174,0.00000000}, {175,0.00006931}, {176,0.00011881}, {177,0.00003960}, {178,0.00015842}, {179,0.00000000}, {180,0.00000000}, {181,0.00007921}, {182,0.00000000}, {183,0.00002970}, {184,0.00003960}, {185,0.00000000}, {186,0.00000000}, {187,0.00007921}, {188,0.00000000}, {189,0.00000000}, {190,0.00002970}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00003960}, {196,0.00000000}, {197,0.00003960}, {198,0.00007921}, {199,0.00000000}, {200,0.00000000}, {201,0.00003960}, {202,0.00002970}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00003960}, {212,0.00007921}, {213,0.00003960}, {214,0.00007921}, {215,0.00003960}, {216,0.00000000}, {217,0.00003960}, {218,0.00000000}, {219,0.00003960}, {220,0.00000000}, {221,0.00003960}, {222,0.00003960}, {223,0.00000000}, {224,0.00000000}, {225,0.00002970}, {226,0.00006931}, {227,0.00007921}, {228,0.00002970}, {229,0.00003960}, {230,0.00000000}, {231,0.00003960}, {232,0.00000000}, {233,0.00007921}, {234,0.00000000}, {235,0.00000000}, {236,0.00011881}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00006931}, {241,0.00007921}, {242,0.00003960}, {243,0.00003960}, {244,0.00000000}, {245,0.00003960}, {246,0.00003960}, {247,0.00000000}, {248,0.00002970}, {249,0.00000000}, {250,0.00003960}, {251,0.00000000}, {252,0.00007921}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00002970}, {257,0.00000000}, {258,0.00000000}, {259,0.00006931}, {260,0.00000000}, {261,0.00003960}, {262,0.00003960}, {263,0.00000000}, {264,0.00002970}, {265,0.00006931}, {266,0.00007921}, {267,0.00000000}, {268,0.00007921}, {269,0.00000000}, {270,0.00000000}, {271,0.00002970}, {272,0.00000000}, {273,0.00002970}, {274,0.00010891}, {275,0.00010891}, {276,0.00000000}, {277,0.00005941}, {278,0.00010891}, {279,0.00003960}, {280,0.00000000}, {281,0.00003960}, {282,0.00000000}, {283,0.00000000}, {284,0.00002970}, {285,0.00003960}, {286,0.00003960}, {287,0.00002970}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00002970}, {294,0.00002970}, {295,0.00007921}, {296,0.00000000}, {297,0.00002970}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000857}, {303,0.0000857}, {304,0.0003429}, {305,0.0001714}, {306,0.0000000}, {307,0.0000857}, {308,0.0000857}, {309,0.0000000}, {310,0.0001143}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000857}, {315,0.0000000}, {316,0.0000857}, {317,0.0000857}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000857}, {325,0.0000857}, {326,0.0001143}, {327,0.0000000}, {328,0.0001143}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000857}, {336,0.0000857}, {337,0.0000857}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0001143}, {342,0.0001143}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0001714}, {348,0.0000857}, {349,0.0002571}, {350,0.0000857}, {351,0.0000000}, {352,0.0000000}, {353,0.0000857}, {354,0.0000000}, {355,0.0001143}, {356,0.0000857}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0001143}, {366,0.0000000}, {367,0.0000000}, {368,0.0000857}, {369,0.0000000}, {370,0.0000857}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0001143}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000857}, {382,0.0001714}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0001143}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000857}, {393,0.0000000}, {394,0.0000857}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000857}, {400,0.0000000}, {401,0.0000857}, {402,0.0000000}, {403,0.0000857}, {404,0.0000857}, {405,0.0000857}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0001143}, {412,0.0000857}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000857}, {417,0.0000857}, {418,0.0000857}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000857}, {427,0.0000000}, {428,0.0000857}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0001714}, {433,0.0000000}, {434,0.0000857}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0002571}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0001143}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000857}, {450,0.0000857}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0002571}, {456,0.0001143}, {457,0.0000857}, {458,0.0000857}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000857}, {466,0.0000857}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000857}, {473,0.0000000}, {474,0.0000857}, {475,0.0000000}, {476,0.0000000}, {477,0.0000857}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000857}, {485,0.0000000}, {486,0.0000857}, {487,0.0000000}, {488,0.0000857}, {489,0.0000857}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000857}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0001143}, {520,0.0000000}, {525,0.0000857}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000857}, {550,0.0000000}, {555,0.0000857}, {560,0.0000857}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000857}, {620,0.0000000}, {625,0.0000857}, {630,0.0000000}, {635,0.0001714}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0001143}, {660,0.0000857}, {665,0.0000857}, {670,0.0000000}, {675,0.0000857}, {680,0.0001143}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000857}, {725,0.0000857}, {730,0.0000000}, {735,0.0000000}, {740,0.0001714}, {745,0.0000857}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0001143}, {775,0.0000000}, {780,0.0001714}, {785,0.0000857}, {790,0.0000000}, {795,0.0000000}, {800,0.0000857}, {805,0.0000000}, {810,0.0000000}, {815,0.0000857}, {820,0.0000000}, {825,0.0000857}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000857}, {850,0.0000000}, {855,0.0000857}, {860,0.0000000}, {865,0.0001143}, {870,0.0000857}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000857}, {920,0.0000857}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000857}, {965,0.0000857}, {970,0.0000000}, {975,0.0000000}, {980,0.0000857}, {985,0.0000000}, {990,0.0002000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0001143}, {1030,0.0001143}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0001143}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000857}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000857}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0001143}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0001143}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000857}, {1320,0.0000857}, {1330,0.0000857}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000857}, {1370,0.0000000}, {1380,0.0000857}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000857}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0001143}, {1580,0.0001143}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000857}, {1670,0.0000000}, {1680,0.0003143}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0003143}, {1740,0.0001143}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0001143}, {1780,0.0000000}, {1790,0.0002286}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0001143}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000857}, {1920,0.0001143}, {1930,0.0001143}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0001143}, {1970,0.0001143}, {1980,0.0001143}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCGallinaCtx"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00003960}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00003960}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00003960}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000857}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCGallinaCtx"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCGallinaCtx"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003960}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00003960}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00003960}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00006931}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00003960}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00002970}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00003960}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00003960}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00003960}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00003960}, {106,0.00000000}, {107,0.00000000}, {108,0.00003960}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00003960}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00003960}, {137,0.00000000}, {138,0.00003960}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00003960}, {147,0.00003960}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00003960}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00003960}, {156,0.00000000}, {157,0.00003960}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00003960}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00002970}, {177,0.00003960}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00003960}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00003960}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00003960}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00003960}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00003960}, {236,0.00000000}, {237,0.00003960}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00003960}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00002970}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00002970}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00002970}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00005941}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0001143}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000857}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000857}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000857}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000857}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0001143}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000857}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000857}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000857}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000857}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000857}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000857}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000857}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0001143}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCGallinaCtx"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCGallinaCtx"]["reif"]["real"] = {{1,0.00000000}, {2,0.00100000}, {3,0.00100000}, {4,0.00100000}, {5,0.00187129}, {6,0.00200000}, {7,0.00200990}, {8,0.00300000}, {9,0.00300000}, {10,0.00332673}, {11,0.00400990}, {12,0.00434653}, {13,0.00500000}, {14,0.00547525}, {15,0.00600990}, {16,0.00640594}, {17,0.00700000}, {18,0.00750495}, {19,0.00806931}, {20,0.00859406}, {21,0.00947525}, {22,0.00971287}, {23,0.01064356}, {24,0.01114851}, {25,0.01283168}, {26,0.01248515}, {27,0.01318812}, {28,0.01336634}, {29,0.01449505}, {30,0.01500000}, {31,0.01569307}, {32,0.01648515}, {33,0.01721782}, {34,0.01764356}, {35,0.01939604}, {36,0.02220792}, {37,0.02251485}, {38,0.02088119}, {39,0.02178218}, {40,0.02276238}, {41,0.02390099}, {42,0.02473267}, {43,0.02587129}, {44,0.02829703}, {45,0.02743564}, {46,0.02842574}, {47,0.03107921}, {48,0.03069307}, {49,0.03478218}, {50,0.03176238}, {51,0.03703960}, {52,0.03458416}, {53,0.03780198}, {54,0.03674257}, {55,0.03813861}, {56,0.04028713}, {57,0.04497030}, {58,0.04157426}, {59,0.04190099}, {60,0.04348515}, {61,0.04441584}, {62,0.04514851}, {63,0.04668317}, {64,0.04829703}, {65,0.04935644}, {66,0.05112871}, {67,0.06141584}, {68,0.05612871}, {69,0.05434653}, {70,0.05609901}, {71,0.05976238}, {72,0.05892079}, {73,0.06432673}, {74,0.06203960}, {75,0.06367327}, {76,0.14546535}, {77,0.06611881}, {78,0.06821782}, {79,0.09514851}, {80,0.08040594}, {81,0.07216832}, {82,0.07432673}, {83,0.07565347}, {84,0.07672277}, {85,0.08736634}, {86,0.09841584}, {87,0.10362376}, {88,0.10527723}, {89,0.10365347}, {90,0.10236634}, {91,0.11086139}, {92,0.11490099}, {93,0.11236634}, {94,0.10936634}, {95,0.11236634}, {96,0.11565347}, {97,0.11611881}, {98,0.11844554}, {99,0.12079208}, {100,0.12359406}, {101,0.12504950}, {102,0.12848515}, {103,0.12362376}, {104,0.12712871}, {105,0.12979208}, {106,0.13195050}, {107,0.13379208}, {108,0.13498020}, {109,0.13728713}, {110,0.13905941}, {111,0.14234653}, {112,0.14288119}, {113,0.14493069}, {114,0.14760396}, {115,0.15010891}, {116,0.15164356}, {117,0.15533663}, {118,0.15677228}, {119,0.15944554}, {120,0.16289109}, {121,0.16575248}, {122,0.16701980}, {123,0.17113861}, {124,0.17243564}, {125,0.17500000}, {126,0.17829703}, {127,0.18089109}, {128,0.18271287}, {129,0.18587129}, {130,0.18901980}, {131,0.19057426}, {132,0.19414851}, {133,0.19579208}, {134,0.19863366}, {135,0.20196040}, {136,0.20604950}, {137,0.20751485}, {138,0.21106931}, {139,0.21365347}, {140,0.21403960}, {141,0.22009901}, {142,0.22148515}, {143,0.22516832}, {144,0.22978218}, {145,0.23031683}, {146,0.23425743}, {147,0.23716832}, {148,0.24058416}, {149,0.24422772}, {150,0.24815842}, {151,0.24908911}, {152,0.25216832}, {153,0.25652475}, {154,0.25996040}, {155,0.26265347}, {156,0.26666337}, {157,0.26803960}, {158,0.27473267}, {159,0.27568317}, {160,0.27953465}, {161,0.28278218}, {162,0.28421782}, {163,0.29949505}, {164,0.28992079}, {165,0.29503960}, {166,0.29831683}, {167,0.29950495}, {168,0.30196040}, {169,0.30938614}, {170,0.31146535}, {171,0.31447525}, {172,0.32175248}, {173,0.32230693}, {174,0.32698020}, {175,0.32905941}, {176,0.33203960}, {177,0.33691089}, {178,0.34044554}, {179,0.34677228}, {180,0.35237624}, {181,0.35564356}, {182,0.36301980}, {183,0.36671287}, {184,0.37213861}, {185,0.37664356}, {186,0.38109901}, {187,0.38580198}, {188,0.38708911}, {189,0.39297030}, {190,0.39269307}, {191,0.39652475}, {192,0.39977228}, {193,0.40239604}, {194,0.40509901}, {195,0.40952475}, {196,0.41119802}, {197,0.41400000}, {198,0.41828713}, {199,0.42897030}, {200,0.43853465}, {201,0.43372277}, {202,0.43464356}, {203,0.44206931}, {204,0.44421782}, {205,0.45688119}, {206,0.46666337}, {207,0.45831683}, {208,0.46166337}, {209,0.46657426}, {210,0.47872277}, {211,0.48967327}, {212,0.48182178}, {213,0.48253465}, {214,0.49905941}, {215,0.50864356}, {216,0.49921782}, {217,0.50355446}, {218,0.52032673}, {219,0.52029703}, {220,0.51953465}, {221,0.53939604}, {222,0.53443564}, {223,0.53736634}, {224,0.54929703}, {225,0.54832673}, {226,0.55756436}, {227,0.55530693}, {228,0.56413861}, {229,0.57326733}, {230,0.57230693}, {231,0.58889109}, {232,0.58018812}, {233,0.60116832}, {234,0.58939604}, {235,0.60853465}, {236,0.59940594}, {237,0.67231683}, {238,0.61330693}, {239,0.69978218}, {240,0.62638614}, {241,0.62933663}, {242,0.63975248}, {243,0.64062376}, {244,0.64866337}, {245,0.71805941}, {246,0.65631683}, {247,0.66822772}, {248,0.67088119}, {249,0.67062376}, {250,0.68736634}, {251,0.68384158}, {252,0.68829703}, {253,0.70298020}, {254,0.70487129}, {255,0.70602970}, {256,0.71897030}, {257,0.72384158}, {258,0.72377228}, {259,0.72974257}, {260,0.73671287}, {261,0.74768317}, {262,0.75729703}, {263,0.76300990}, {264,0.76372277}, {265,0.76815842}, {266,0.77087129}, {267,0.77898020}, {268,0.78907921}, {269,0.79534653}, {270,0.79871287}, {271,0.80177228}, {272,0.81396040}, {273,0.81952475}, {274,0.82849505}, {275,0.83383168}, {276,0.84373267}, {277,0.84834653}, {278,0.85595050}, {279,0.86269307}, {280,0.86628713}, {281,0.87325743}, {282,0.88317822}, {283,0.89281188}, {284,0.90148515}, {285,0.90774257}, {286,0.91747525}, {287,0.91890099}, {288,0.93018812}, {289,0.93579208}, {290,0.93854455}, {291,0.94412871}, {292,0.94655446}, {293,0.94956436}, {294,0.95786139}, {295,0.96419802}, {296,0.97198020}, {297,0.99020792}, {298,0.99223762}, {299,0.98868317}, {300,0.99386139}, {301,1.0492571}, {302,1.1488286}, {303,1.1075714}, {304,1.1077714}, {305,1.0817429}, {306,1.0994000}, {307,1.1271143}, {308,1.1074000}, {309,1.1120857}, {310,1.1680857}, {311,1.1288000}, {312,1.1361429}, {313,1.1606286}, {314,1.1581429}, {315,1.1644571}, {316,1.1716571}, {317,1.1774000}, {318,1.1858857}, {319,1.1938857}, {320,1.2081143}, {321,1.2004000}, {322,1.2550000}, {323,1.2442571}, {324,1.2282286}, {325,1.2619143}, {326,1.2452857}, {327,1.2517143}, {328,1.2612286}, {329,1.2707714}, {330,1.2764000}, {331,1.2987429}, {332,1.2914286}, {333,1.3316286}, {334,1.2993714}, {335,1.3529143}, {336,1.3306000}, {337,1.3338857}, {338,1.3416571}, {339,1.3481714}, {340,1.3781714}, {341,1.3661143}, {342,1.3834857}, {343,1.3942286}, {344,1.4100286}, {345,1.4121143}, {346,1.4196000}, {347,1.4264286}, {348,1.4353429}, {349,1.4448286}, {350,1.4801714}, {351,1.4770286}, {352,1.4735429}, {353,1.4885143}, {354,1.4909714}, {355,1.5040571}, {356,1.5058000}, {357,1.5214857}, {358,1.5310857}, {359,1.5402571}, {360,1.5464571}, {361,1.5587143}, {362,1.5700000}, {363,1.5773714}, {364,1.5914857}, {365,1.6021714}, {366,1.5991714}, {367,1.6154000}, {368,1.6265714}, {369,1.6344286}, {370,1.6438571}, {371,1.6608286}, {372,1.6675714}, {373,1.6773143}, {374,1.6778286}, {375,1.7058571}, {376,1.7113714}, {377,1.7162000}, {378,1.7263143}, {379,1.7306571}, {380,1.7479714}, {381,1.7560000}, {382,1.7701143}, {383,1.7802000}, {384,1.7981429}, {385,1.8085143}, {386,1.8264857}, {387,1.8386286}, {388,1.8407714}, {389,1.8578286}, {390,1.8755143}, {391,1.8797714}, {392,1.8914571}, {393,1.9112571}, {394,1.9092571}, {395,1.9293143}, {396,1.9324857}, {397,1.9534000}, {398,1.9753714}, {399,1.9701714}, {400,1.9826857}, {401,1.9956000}, {402,2.0086000}, {403,2.0264000}, {404,2.0366000}, {405,2.0616571}, {406,2.0662000}, {407,2.0691714}, {408,2.0818857}, {409,2.0977429}, {410,2.0987714}, {411,2.1082000}, {412,2.1057143}, {413,2.1307429}, {414,2.1376000}, {415,2.1549429}, {416,2.1516857}, {417,2.1560286}, {418,2.1697429}, {419,2.1767714}, {420,2.1939714}, {421,2.2139143}, {422,2.2105714}, {423,2.2272857}, {424,2.2300571}, {425,2.2419143}, {426,2.2636571}, {427,2.3190286}, {428,2.3095429}, {429,2.3204857}, {430,2.3208571}, {431,2.3370000}, {432,2.3580286}, {433,2.3665429}, {434,2.4022000}, {435,2.3937143}, {436,2.4093714}, {437,2.4108571}, {438,2.4302857}, {439,2.4586000}, {440,2.4755714}, {441,2.4751714}, {442,2.4892571}, {443,2.5043429}, {444,2.5182857}, {445,2.5272857}, {446,2.5394571}, {447,2.5521714}, {448,2.5608286}, {449,2.5782857}, {450,2.6005143}, {451,2.6020000}, {452,2.6116000}, {453,2.6326000}, {454,2.6471714}, {455,2.6697714}, {456,2.6712286}, {457,2.6853429}, {458,2.7084571}, {459,2.7262000}, {460,2.7347429}, {461,2.7416571}, {462,2.7772000}, {463,2.7772286}, {464,2.8115143}, {465,2.8072857}, {466,2.8165143}, {467,2.9143429}, {468,2.8453429}, {469,2.8562857}, {470,2.9195429}, {471,2.9126000}, {472,2.9241714}, {473,2.9816857}, {474,2.9422857}, {475,2.9336286}, {476,2.9356571}, {477,3.0015429}, {478,2.9701714}, {479,3.0335714}, {480,3.0032000}, {481,3.0273429}, {482,3.0308571}, {483,3.0614000}, {484,3.1086286}, {485,3.0917429}, {486,3.1378286}, {487,3.1206286}, {488,3.1333429}, {489,3.1305429}, {490,3.1372286}, {491,3.1578571}, {492,3.1793429}, {493,3.1975143}, {494,3.2323714}, {495,3.2422000}, {496,3.2593714}, {497,3.2797429}, {498,3.2885429}, {499,3.3077143}, {500,3.3204857}, {505,3.3966571}, {510,3.4748857}, {515,3.5570857}, {520,3.6407429}, {525,3.7264286}, {530,3.8532571}, {535,3.8951429}, {540,4.0797143}, {545,4.0474857}, {550,4.2165429}, {555,4.2612000}, {560,4.3299143}, {565,4.4677143}, {570,4.5223714}, {575,4.6411714}, {580,4.7681714}, {585,4.8452571}, {590,4.9981143}, {595,5.1867429}, {600,5.2520857}, {605,5.3231143}, {610,5.3740000}, {615,5.5459714}, {620,5.6820000}, {625,5.8577143}, {630,5.9290857}, {635,5.9646857}, {640,6.1742571}, {645,6.3087143}, {650,6.3654571}, {655,6.3793714}, {660,6.4354857}, {665,6.6128286}, {670,6.7766000}, {675,6.8980000}, {680,7.1105714}, {685,7.2164000}, {690,7.3730000}, {695,7.3909714}, {700,7.6858571}, {705,7.7702857}, {710,8.0178571}, {715,7.9622571}, {720,8.1105714}, {725,8.3664286}, {730,8.2958857}, {735,8.6267429}, {740,8.7500571}, {745,9.0072857}, {750,9.1129429}, {755,9.3675714}, {760,9.5200571}, {765,9.7319143}, {770,9.7760286}, {775,9.6670857}, {780,10.0264286}, {785,10.1367143}, {790,10.3200857}, {795,10.4193429}, {800,10.7564857}, {805,10.9293714}, {810,10.9690857}, {815,11.1986000}, {820,11.2884000}, {825,11.5514857}, {830,11.6004286}, {835,11.6955143}, {840,12.2333143}, {845,12.3320286}, {850,12.2475714}, {855,12.7636857}, {860,12.7887429}, {865,13.2585143}, {870,13.3933714}, {875,13.6133429}, {880,13.9504857}, {885,13.7242571}, {890,14.2413714}, {895,14.2628000}, {900,14.4506857}, {905,14.8158286}, {910,15.1421143}, {915,15.1222571}, {920,15.4354000}, {925,15.5768857}, {930,15.9135143}, {935,16.0930286}, {940,16.0698000}, {945,16.5224286}, {950,16.6242000}, {955,16.5442000}, {960,17.0096571}, {965,17.5714571}, {970,17.1340286}, {975,17.5916857}, {980,18.2691143}, {985,18.2308286}, {990,18.5680286}, {995,19.0687429}, {1000,19.2835714}, {1010,19.6454000}, {1020,20.1057429}, {1030,20.8040286}, {1040,21.1863143}, {1050,21.9904857}, {1060,22.4918857}, {1070,23.2187429}, {1080,23.7876571}, {1090,24.3186571}, {1100,24.9641429}, {1110,25.6906000}, {1120,26.4521429}, {1130,26.7114286}, {1140,27.8905143}, {1150,28.5050857}, {1160,28.9272857}, {1170,29.3361714}, {1180,30.4374000}, {1190,31.0709714}, {1200,32.1218571}, {1210,32.6446571}, {1220,33.3279429}, {1230,34.0872857}, {1240,34.7035714}, {1250,35.6554000}, {1260,36.6456286}, {1270,37.2689143}, {1280,38.0422857}, {1290,38.6495714}, {1300,39.7127429}, {1310,40.5341429}, {1320,41.6328000}, {1330,42.1886857}, {1340,43.1330571}, {1350,43.8488000}, {1360,45.7312571}, {1370,46.2190286}, {1380,47.2304571}, {1390,48.6281714}, {1400,49.3362286}, {1410,50.1798571}, {1420,51.4671143}, {1430,52.2138286}, {1440,53.5136000}, {1450,54.2342857}, {1460,55.8538857}, {1470,56.6132857}, {1480,57.8723429}, {1490,59.4198286}, {1500,60.1974000}, {1510,61.1918286}, {1520,62.7738857}, {1530,63.1682286}, {1540,65.0219714}, {1550,66.2458857}, {1560,67.5586286}, {1570,68.8548286}, {1580,69.8785429}, {1590,71.3019143}, {1600,72.6863429}, {1610,73.4967714}, {1620,76.1022857}, {1630,76.1803429}, {1640,78.0368286}, {1650,79.1918857}, {1660,79.4797143}, {1670,81.9966857}, {1680,83.4135429}, {1690,85.3693714}, {1700,86.6822000}, {1710,88.0283714}, {1720,90.2021714}, {1730,91.2899143}, {1740,93.1296286}, {1750,94.7799143}, {1760,95.5879143}, {1770,97.6678286}, {1780,98.7750000}, {1790,101.3171143}, {1800,102.3868286}, {1810,105.1189714}, {1820,105.7426286}, {1830,106.4826857}, {1840,108.2086000}, {1850,110.2311714}, {1860,113.2658571}, {1870,115.8052857}, {1880,116.8124000}, {1890,120.5210857}, {1900,120.1164000}, {1910,123.3070857}, {1920,126.4159714}, {1930,125.2406857}, {1940,127.1576286}, {1950,129.6358857}, {1960,130.4786000}, {1970,134.0342571}, {1980,134.5464286}, {1990,137.6023429}, {2000,140.8496286}};
data["big"]["LtacTCGallinaCtx"]["reif"]["user"] = {{1,0.00067327}, {2,0.00101980}, {3,0.00142574}, {4,0.00192079}, {5,0.00188119}, {6,0.00208911}, {7,0.00320792}, {8,0.00279208}, {9,0.00347525}, {10,0.00373267}, {11,0.00399010}, {12,0.00456436}, {13,0.00505941}, {14,0.00577228}, {15,0.00601980}, {16,0.00652475}, {17,0.00733663}, {18,0.00759406}, {19,0.00810891}, {20,0.00878218}, {21,0.00927723}, {22,0.00982178}, {23,0.01051485}, {24,0.01119802}, {25,0.01248515}, {26,0.01220792}, {27,0.01309901}, {28,0.01325743}, {29,0.01422772}, {30,0.01462376}, {31,0.01533663}, {32,0.01618812}, {33,0.01692079}, {34,0.01726733}, {35,0.01899010}, {36,0.02239604}, {37,0.02254455}, {38,0.02077228}, {39,0.02181188}, {40,0.02282178}, {41,0.02430693}, {42,0.02486139}, {43,0.02606931}, {44,0.02858416}, {45,0.02778218}, {46,0.02869307}, {47,0.03106931}, {48,0.03095050}, {49,0.03451485}, {50,0.03181188}, {51,0.03698020}, {52,0.03453465}, {53,0.03748515}, {54,0.03653465}, {55,0.03788119}, {56,0.04002970}, {57,0.04476238}, {58,0.04121782}, {59,0.04149505}, {60,0.04275248}, {61,0.04433663}, {62,0.04473267}, {63,0.04681188}, {64,0.04865347}, {65,0.04948515}, {66,0.05153465}, {67,0.06101980}, {68,0.05626733}, {69,0.05443564}, {70,0.05610891}, {71,0.05963366}, {72,0.05893069}, {73,0.06419802}, {74,0.06184158}, {75,0.06332673}, {76,0.14512871}, {77,0.06531683}, {78,0.06810891}, {79,0.09494059}, {80,0.08042574}, {81,0.07232673}, {82,0.07469307}, {83,0.07574257}, {84,0.07689109}, {85,0.08689109}, {86,0.09831683}, {87,0.10377228}, {88,0.10509901}, {89,0.10348515}, {90,0.10219802}, {91,0.11043564}, {92,0.11475248}, {93,0.11211881}, {94,0.10896040}, {95,0.11218812}, {96,0.11522772}, {97,0.11595050}, {98,0.11785149}, {99,0.12030693}, {100,0.12328713}, {101,0.12495050}, {102,0.12821782}, {103,0.12364356}, {104,0.12692079}, {105,0.12947525}, {106,0.13170297}, {107,0.13335644}, {108,0.13453465}, {109,0.13665347}, {110,0.13874257}, {111,0.14188119}, {112,0.14225743}, {113,0.14507921}, {114,0.14717822}, {115,0.14967327}, {116,0.15155446}, {117,0.15499010}, {118,0.15645545}, {119,0.15889109}, {120,0.16255446}, {121,0.16526733}, {122,0.16694059}, {123,0.17092079}, {124,0.17233663}, {125,0.17443564}, {126,0.17814851}, {127,0.18048515}, {128,0.18252475}, {129,0.18565347}, {130,0.18868317}, {131,0.19014851}, {132,0.19357426}, {133,0.19555446}, {134,0.19867327}, {135,0.20154455}, {136,0.20588119}, {137,0.20695050}, {138,0.21063366}, {139,0.21316832}, {140,0.21364356}, {141,0.22005941}, {142,0.22097030}, {143,0.22475248}, {144,0.22909901}, {145,0.22995050}, {146,0.23342574}, {147,0.23674257}, {148,0.23998020}, {149,0.24331683}, {150,0.24736634}, {151,0.24872277}, {152,0.25148515}, {153,0.25558416}, {154,0.25953465}, {155,0.26192079}, {156,0.26593069}, {157,0.26722772}, {158,0.27405941}, {159,0.27506931}, {160,0.27882178}, {161,0.28227723}, {162,0.28379208}, {163,0.29885149}, {164,0.28927723}, {165,0.29427723}, {166,0.29757426}, {167,0.29879208}, {168,0.30129703}, {169,0.30883168}, {170,0.31057426}, {171,0.31347525}, {172,0.32074257}, {173,0.32115842}, {174,0.32620792}, {175,0.32796040}, {176,0.33124752}, {177,0.33619802}, {178,0.33967327}, {179,0.34620792}, {180,0.35181188}, {181,0.35498020}, {182,0.36258416}, {183,0.36611881}, {184,0.37133663}, {185,0.37561386}, {186,0.38056436}, {187,0.38498020}, {188,0.38646535}, {189,0.39225743}, {190,0.39181188}, {191,0.39560396}, {192,0.39914851}, {193,0.40209901}, {194,0.40424752}, {195,0.40864356}, {196,0.41038614}, {197,0.41299010}, {198,0.41737624}, {199,0.42806931}, {200,0.43768317}, {201,0.43251485}, {202,0.43378218}, {203,0.44115842}, {204,0.44334653}, {205,0.45590099}, {206,0.46564356}, {207,0.45748515}, {208,0.46083168}, {209,0.46573267}, {210,0.47792079}, {211,0.48867327}, {212,0.48134653}, {213,0.48138614}, {214,0.49840594}, {215,0.50795050}, {216,0.49853465}, {217,0.50256436}, {218,0.51927723}, {219,0.51962376}, {220,0.51865347}, {221,0.53840594}, {222,0.53356436}, {223,0.53646535}, {224,0.54854455}, {225,0.54726733}, {226,0.55713861}, {227,0.55468317}, {228,0.56337624}, {229,0.57242574}, {230,0.57159406}, {231,0.58778218}, {232,0.57927723}, {233,0.60019802}, {234,0.58845545}, {235,0.60712871}, {236,0.59849505}, {237,0.67089109}, {238,0.61212871}, {239,0.69865347}, {240,0.62549505}, {241,0.62794059}, {242,0.63872277}, {243,0.63949505}, {244,0.64754455}, {245,0.71694059}, {246,0.65483168}, {247,0.66689109}, {248,0.66989109}, {249,0.66947525}, {250,0.68622772}, {251,0.68208911}, {252,0.68689109}, {253,0.70126733}, {254,0.70356436}, {255,0.70469307}, {256,0.71766337}, {257,0.72274257}, {258,0.72241584}, {259,0.72851485}, {260,0.73541584}, {261,0.74639604}, {262,0.75589109}, {263,0.76130693}, {264,0.76234653}, {265,0.76708911}, {266,0.76921782}, {267,0.77803960}, {268,0.78773267}, {269,0.79380198}, {270,0.79746535}, {271,0.80080198}, {272,0.81258416}, {273,0.81819802}, {274,0.82713861}, {275,0.83238614}, {276,0.84289109}, {277,0.84699010}, {278,0.85458416}, {279,0.86141584}, {280,0.86473267}, {281,0.87169307}, {282,0.88151485}, {283,0.89133663}, {284,0.90001980}, {285,0.90609901}, {286,0.91547525}, {287,0.91738614}, {288,0.92855446}, {289,0.93425743}, {290,0.93694059}, {291,0.94257426}, {292,0.94499010}, {293,0.94791089}, {294,0.95615842}, {295,0.96248515}, {296,0.97057426}, {297,0.98819802}, {298,0.99067327}, {299,0.98706931}, {300,0.99243564}, {301,1.0481714}, {302,1.1415143}, {303,1.1058857}, {304,1.1061429}, {305,1.0803714}, {306,1.0975143}, {307,1.1254000}, {308,1.1055714}, {309,1.1101714}, {310,1.1667143}, {311,1.1268571}, {312,1.1344857}, {313,1.1552000}, {314,1.1568286}, {315,1.1635714}, {316,1.1700286}, {317,1.1763143}, {318,1.1848000}, {319,1.1923714}, {320,1.2030857}, {321,1.1990286}, {322,1.2526000}, {323,1.2424000}, {324,1.2273714}, {325,1.2599429}, {326,1.2444286}, {327,1.2495143}, {328,1.2599143}, {329,1.2681143}, {330,1.2748286}, {331,1.2964857}, {332,1.2893429}, {333,1.3260571}, {334,1.2970571}, {335,1.3354571}, {336,1.3226857}, {337,1.3324571}, {338,1.3406286}, {339,1.3466000}, {340,1.3766000}, {341,1.3645143}, {342,1.3820857}, {343,1.3921714}, {344,1.4082571}, {345,1.4100286}, {346,1.4171714}, {347,1.4250571}, {348,1.4339429}, {349,1.4431429}, {350,1.4782857}, {351,1.4748571}, {352,1.4714571}, {353,1.4878286}, {354,1.4898286}, {355,1.5023714}, {356,1.5039714}, {357,1.5206000}, {358,1.5300000}, {359,1.5388571}, {360,1.5448286}, {361,1.5567429}, {362,1.5680571}, {363,1.5752857}, {364,1.5896286}, {365,1.5991143}, {366,1.5970286}, {367,1.6138571}, {368,1.6249714}, {369,1.6319429}, {370,1.6418000}, {371,1.6591143}, {372,1.6651429}, {373,1.6758857}, {374,1.6751714}, {375,1.7038286}, {376,1.7094000}, {377,1.7140000}, {378,1.7228000}, {379,1.7283429}, {380,1.7452857}, {381,1.7528571}, {382,1.7673143}, {383,1.7768000}, {384,1.7952571}, {385,1.8054286}, {386,1.8236000}, {387,1.8351714}, {388,1.8376571}, {389,1.8544286}, {390,1.8728857}, {391,1.8768000}, {392,1.8888286}, {393,1.8981714}, {394,1.9066857}, {395,1.9268571}, {396,1.9302000}, {397,1.9503143}, {398,1.9715429}, {399,1.9668000}, {400,1.9797714}, {401,1.9921714}, {402,2.0061143}, {403,2.0235714}, {404,2.0331714}, {405,2.0556000}, {406,2.0579429}, {407,2.0591714}, {408,2.0759429}, {409,2.0946000}, {410,2.0948000}, {411,2.1035714}, {412,2.1022571}, {413,2.1267714}, {414,2.1335143}, {415,2.1516571}, {416,2.1473429}, {417,2.1520571}, {418,2.1661143}, {419,2.1732000}, {420,2.1907714}, {421,2.2113714}, {422,2.2074000}, {423,2.2233714}, {424,2.2265714}, {425,2.2378286}, {426,2.2591714}, {427,2.3154857}, {428,2.3049143}, {429,2.3154857}, {430,2.3164857}, {431,2.3320000}, {432,2.3533714}, {433,2.3613143}, {434,2.3977714}, {435,2.3884286}, {436,2.4040571}, {437,2.4063714}, {438,2.4256857}, {439,2.4536857}, {440,2.4701429}, {441,2.4695429}, {442,2.4837429}, {443,2.4989429}, {444,2.5134857}, {445,2.5227429}, {446,2.5344286}, {447,2.5470000}, {448,2.5550571}, {449,2.5733143}, {450,2.5960286}, {451,2.5974286}, {452,2.6074286}, {453,2.6287714}, {454,2.6417143}, {455,2.6651143}, {456,2.6650286}, {457,2.6796286}, {458,2.7032286}, {459,2.7219143}, {460,2.7303714}, {461,2.7374571}, {462,2.7733143}, {463,2.7729714}, {464,2.8078000}, {465,2.8032571}, {466,2.8118571}, {467,2.9103143}, {468,2.8406000}, {469,2.8528571}, {470,2.9146571}, {471,2.9070857}, {472,2.9184000}, {473,2.9756286}, {474,2.9366857}, {475,2.9266571}, {476,2.9298286}, {477,2.9946571}, {478,2.9655714}, {479,3.0274857}, {480,2.9968286}, {481,3.0208857}, {482,3.0229143}, {483,3.0533429}, {484,3.1003429}, {485,3.0828000}, {486,3.1286000}, {487,3.1119714}, {488,3.1249143}, {489,3.1226571}, {490,3.1308000}, {491,3.1503714}, {492,3.1721429}, {493,3.1905429}, {494,3.2240286}, {495,3.2344000}, {496,3.2523429}, {497,3.2727143}, {498,3.2808000}, {499,3.2999143}, {500,3.3128571}, {505,3.3884286}, {510,3.4672571}, {515,3.5475143}, {520,3.6290286}, {525,3.7146571}, {530,3.8425714}, {535,3.8834286}, {540,4.0665429}, {545,4.0345143}, {550,4.2028286}, {555,4.2471714}, {560,4.3166571}, {565,4.4545429}, {570,4.5104000}, {575,4.6293429}, {580,4.7549143}, {585,4.8323143}, {590,4.9847143}, {595,5.1731143}, {600,5.2387143}, {605,5.3108000}, {610,5.3606286}, {615,5.5346000}, {620,5.6693429}, {625,5.8440000}, {630,5.9162857}, {635,5.9515143}, {640,6.1607143}, {645,6.2964000}, {650,6.3557714}, {655,6.3731143}, {660,6.4272857}, {665,6.6037714}, {670,6.7671143}, {675,6.8893429}, {680,7.1008571}, {685,7.2044857}, {690,7.3616286}, {695,7.3803714}, {700,7.6736286}, {705,7.7609714}, {710,8.0091429}, {715,7.9511429}, {720,8.0979429}, {725,8.3496286}, {730,8.2807714}, {735,8.6146571}, {740,8.7390000}, {745,8.9956000}, {750,9.1027429}, {755,9.3572571}, {760,9.5086286}, {765,9.7229714}, {770,9.7617714}, {775,9.6530000}, {780,10.0117714}, {785,10.1227429}, {790,10.2970000}, {795,10.4023429}, {800,10.7330571}, {805,10.8948571}, {810,10.9273714}, {815,11.1787143}, {820,11.2683429}, {825,11.5257429}, {830,11.5816286}, {835,11.6643714}, {840,12.2170286}, {845,12.3158857}, {850,12.2323143}, {855,12.7465714}, {860,12.7714286}, {865,13.2433143}, {870,13.3805143}, {875,13.6034857}, {880,13.9419429}, {885,13.7191143}, {890,14.2361143}, {895,14.2514286}, {900,14.4357429}, {905,14.8034000}, {910,15.1234000}, {915,15.0979143}, {920,15.4168571}, {925,15.5588857}, {930,15.8940000}, {935,16.0691714}, {940,16.0463714}, {945,16.5037143}, {950,16.6114000}, {955,16.5328571}, {960,16.9927429}, {965,17.5513143}, {970,17.1071429}, {975,17.5668857}, {980,18.2412286}, {985,18.2014286}, {990,18.5292286}, {995,19.0306286}, {1000,19.2403429}, {1010,19.6026286}, {1020,20.0625429}, {1030,20.7614000}, {1040,21.1491429}, {1050,21.9268857}, {1060,22.4560286}, {1070,23.1910857}, {1080,23.7117714}, {1090,24.2922000}, {1100,24.9373714}, {1110,25.6532286}, {1120,26.4082857}, {1130,26.6809429}, {1140,27.7582000}, {1150,28.4675429}, {1160,28.8950857}, {1170,29.3077429}, {1180,30.3980000}, {1190,31.0398286}, {1200,32.0912571}, {1210,32.6081714}, {1220,33.2916857}, {1230,34.0356000}, {1240,34.6587429}, {1250,35.5986000}, {1260,36.5789143}, {1270,37.2123143}, {1280,37.9874857}, {1290,38.5949143}, {1300,39.6686000}, {1310,40.4978000}, {1320,41.5918000}, {1330,42.1429143}, {1340,43.0940857}, {1350,43.8025714}, {1360,45.6701429}, {1370,46.1604000}, {1380,47.1767143}, {1390,48.5738286}, {1400,49.2908857}, {1410,50.1312857}, {1420,51.4171714}, {1430,52.1530571}, {1440,53.4654857}, {1450,54.1590286}, {1460,55.7777143}, {1470,56.5506000}, {1480,57.8118857}, {1490,59.3559714}, {1500,60.1259714}, {1510,61.1155714}, {1520,62.6776857}, {1530,63.0839429}, {1540,64.9534857}, {1550,66.1718286}, {1560,67.4718857}, {1570,68.7898000}, {1580,69.7945714}, {1590,71.2054000}, {1600,72.5970857}, {1610,73.4204571}, {1620,76.0286571}, {1630,76.1009714}, {1640,77.9490286}, {1650,79.1014000}, {1660,79.3985429}, {1670,81.9023429}, {1680,83.3280571}, {1690,85.2720857}, {1700,86.5812000}, {1710,87.9452286}, {1720,90.1018286}, {1730,91.1664857}, {1740,93.0075429}, {1750,94.6720000}, {1760,95.4820286}, {1770,97.5397143}, {1780,98.6568857}, {1790,101.1924286}, {1800,102.3073714}, {1810,105.0402571}, {1820,105.6632286}, {1830,106.4030000}, {1840,108.0621143}, {1850,110.1056857}, {1860,113.1432286}, {1870,115.6325714}, {1880,116.7018857}, {1890,120.3932571}, {1900,120.0031143}, {1910,123.2235714}, {1920,126.3460000}, {1930,125.1389714}, {1940,127.0305143}, {1950,129.5388857}, {1960,130.2867143}, {1970,133.9610571}, {1980,134.4711143}, {1990,137.5281714}, {2000,140.7653429}};
data["big"]["LtacTCGallinaCtx"]["reif"]["system"] = {{1,0.00006931}, {2,0.00000000}, {3,0.00007921}, {4,0.00000000}, {5,0.00000000}, {6,0.00003960}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00011881}, {12,0.00000000}, {13,0.00000000}, {14,0.00011881}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00007921}, {19,0.00000000}, {20,0.00011881}, {21,0.00003960}, {22,0.00000000}, {23,0.00007921}, {24,0.00000000}, {25,0.00007921}, {26,0.00003960}, {27,0.00007921}, {28,0.00000000}, {29,0.00000000}, {30,0.00015842}, {31,0.00000000}, {32,0.00003960}, {33,0.00003960}, {34,0.00003960}, {35,0.00003960}, {36,0.00003960}, {37,0.00003960}, {38,0.00003960}, {39,0.00000000}, {40,0.00007921}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00003960}, {45,0.00011881}, {46,0.00000000}, {47,0.00003960}, {48,0.00000000}, {49,0.00000000}, {50,0.00007921}, {51,0.00003960}, {52,0.00007921}, {53,0.00000000}, {54,0.00003960}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00011881}, {59,0.00007921}, {60,0.00010891}, {61,0.00003960}, {62,0.00011881}, {63,0.00002970}, {64,0.00011881}, {65,0.00006931}, {66,0.00011881}, {67,0.00000000}, {68,0.00000000}, {69,0.00003960}, {70,0.00003960}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00003960}, {75,0.00000000}, {76,0.00030693}, {77,0.00007921}, {78,0.00006931}, {79,0.00011881}, {80,0.00000000}, {81,0.00003960}, {82,0.00000000}, {83,0.00011881}, {84,0.00011881}, {85,0.00003960}, {86,0.00003960}, {87,0.00007921}, {88,0.00007921}, {89,0.00003960}, {90,0.00000000}, {91,0.00003960}, {92,0.00007921}, {93,0.00000000}, {94,0.00003960}, {95,0.00000000}, {96,0.00011881}, {97,0.00003960}, {98,0.00003960}, {99,0.00000000}, {100,0.00003960}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00003960}, {106,0.00007921}, {107,0.00000000}, {108,0.00003960}, {109,0.00003960}, {110,0.00000000}, {111,0.00000000}, {112,0.00003960}, {113,0.00003960}, {114,0.00019802}, {115,0.00003960}, {116,0.00000000}, {117,0.00003960}, {118,0.00014851}, {119,0.00003960}, {120,0.00003960}, {121,0.00007921}, {122,0.00000000}, {123,0.00003960}, {124,0.00011881}, {125,0.00011881}, {126,0.00003960}, {127,0.00011881}, {128,0.00007921}, {129,0.00007921}, {130,0.00003960}, {131,0.00003960}, {132,0.00010891}, {133,0.00000000}, {134,0.00000000}, {135,0.00006931}, {136,0.00003960}, {137,0.00003960}, {138,0.00007921}, {139,0.00007921}, {140,0.00007921}, {141,0.00003960}, {142,0.00015842}, {143,0.00003960}, {144,0.00007921}, {145,0.00007921}, {146,0.00007921}, {147,0.00014851}, {148,0.00003960}, {149,0.00010891}, {150,0.00003960}, {151,0.00007921}, {152,0.00000000}, {153,0.00003960}, {154,0.00000000}, {155,0.00007921}, {156,0.00011881}, {157,0.00007921}, {158,0.00003960}, {159,0.00000000}, {160,0.00003960}, {161,0.00007921}, {162,0.00003960}, {163,0.00000000}, {164,0.00003960}, {165,0.00007921}, {166,0.00000000}, {167,0.00003960}, {168,0.00003960}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00011881}, {173,0.00007921}, {174,0.00007921}, {175,0.00007921}, {176,0.00003960}, {177,0.00003960}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00007921}, {183,0.00007921}, {184,0.00011881}, {185,0.00010891}, {186,0.00003960}, {187,0.00003960}, {188,0.00011881}, {189,0.00000000}, {190,0.00003960}, {191,0.00007921}, {192,0.00003960}, {193,0.00007921}, {194,0.00000000}, {195,0.00019802}, {196,0.00003960}, {197,0.00007921}, {198,0.00003960}, {199,0.00011881}, {200,0.00007921}, {201,0.00015842}, {202,0.00007921}, {203,0.00003960}, {204,0.00007921}, {205,0.00003960}, {206,0.00011881}, {207,0.00003960}, {208,0.00007921}, {209,0.00000000}, {210,0.00007921}, {211,0.00007921}, {212,0.00000000}, {213,0.00003960}, {214,0.00011881}, {215,0.00003960}, {216,0.00007921}, {217,0.00003960}, {218,0.00000000}, {219,0.00010891}, {220,0.00019802}, {221,0.00011881}, {222,0.00011881}, {223,0.00003960}, {224,0.00003960}, {225,0.00011881}, {226,0.00007921}, {227,0.00011881}, {228,0.00007921}, {229,0.00011881}, {230,0.00003960}, {231,0.00003960}, {232,0.00000000}, {233,0.00023762}, {234,0.00003960}, {235,0.00000000}, {236,0.00011881}, {237,0.00015842}, {238,0.00003960}, {239,0.00018812}, {240,0.00007921}, {241,0.00007921}, {242,0.00015842}, {243,0.00011881}, {244,0.00011881}, {245,0.00000000}, {246,0.00011881}, {247,0.00007921}, {248,0.00011881}, {249,0.00011881}, {250,0.00011881}, {251,0.00007921}, {252,0.00007921}, {253,0.00015842}, {254,0.00007921}, {255,0.00007921}, {256,0.00007921}, {257,0.00003960}, {258,0.00015842}, {259,0.00007921}, {260,0.00011881}, {261,0.00007921}, {262,0.00011881}, {263,0.00018812}, {264,0.00006931}, {265,0.00003960}, {266,0.00018812}, {267,0.00011881}, {268,0.00011881}, {269,0.00035644}, {270,0.00011881}, {271,0.00003960}, {272,0.00015842}, {273,0.00007921}, {274,0.00011881}, {275,0.00011881}, {276,0.00000000}, {277,0.00003960}, {278,0.00015842}, {279,0.00011881}, {280,0.00011881}, {281,0.00015842}, {282,0.00003960}, {283,0.00007921}, {284,0.00011881}, {285,0.00014851}, {286,0.00027723}, {287,0.00000000}, {288,0.00000000}, {289,0.00003960}, {290,0.00010891}, {291,0.00015842}, {292,0.00031683}, {293,0.00003960}, {294,0.00007921}, {295,0.00019802}, {296,0.00003960}, {297,0.00015842}, {298,0.00019802}, {299,0.00015842}, {300,0.00011881}, {301,0.0002286}, {302,0.0006571}, {303,0.0001143}, {304,0.0001143}, {305,0.0002286}, {306,0.0002286}, {307,0.0001143}, {308,0.0004571}, {309,0.0003143}, {310,0.0002286}, {311,0.0000000}, {312,0.0002286}, {313,0.0001143}, {314,0.0001143}, {315,0.0000000}, {316,0.0001143}, {317,0.0000000}, {318,0.0001143}, {319,0.0000000}, {320,0.0002286}, {321,0.0003429}, {322,0.0006857}, {323,0.0001143}, {324,0.0000000}, {325,0.0001143}, {326,0.0000000}, {327,0.0000000}, {328,0.0003429}, {329,0.0012571}, {330,0.0000000}, {331,0.0000000}, {332,0.0003429}, {333,0.0002286}, {334,0.0001143}, {335,0.0003429}, {336,0.0000000}, {337,0.0001143}, {338,0.0001143}, {339,0.0003429}, {340,0.0001143}, {341,0.0003429}, {342,0.0000000}, {343,0.0001143}, {344,0.0000000}, {345,0.0002286}, {346,0.0001143}, {347,0.0001143}, {348,0.0000000}, {349,0.0001143}, {350,0.0002286}, {351,0.0005714}, {352,0.0001143}, {353,0.0001143}, {354,0.0001143}, {355,0.0001143}, {356,0.0002286}, {357,0.0001143}, {358,0.0001143}, {359,0.0001143}, {360,0.0002286}, {361,0.0000000}, {362,0.0001143}, {363,0.0001143}, {364,0.0001143}, {365,0.0006857}, {366,0.0000000}, {367,0.0001143}, {368,0.0001143}, {369,0.0005714}, {370,0.0003429}, {371,0.0001143}, {372,0.0004571}, {373,0.0000000}, {374,0.0006857}, {375,0.0003429}, {376,0.0001143}, {377,0.0001143}, {378,0.0003429}, {379,0.0002286}, {380,0.0002286}, {381,0.0005714}, {382,0.0004571}, {383,0.0002286}, {384,0.0000000}, {385,0.0005714}, {386,0.0003143}, {387,0.0003429}, {388,0.0003429}, {389,0.0005714}, {390,0.0001143}, {391,0.0002000}, {392,0.0004571}, {393,0.0004571}, {394,0.0004571}, {395,0.0003429}, {396,0.0001143}, {397,0.0001143}, {398,0.0004571}, {399,0.0004571}, {400,0.0002286}, {401,0.0002286}, {402,0.0001143}, {403,0.0001143}, {404,0.0001143}, {405,0.0006857}, {406,0.0004571}, {407,0.0004571}, {408,0.0002286}, {409,0.0003429}, {410,0.0004286}, {411,0.0006571}, {412,0.0002286}, {413,0.0002286}, {414,0.0003429}, {415,0.0000000}, {416,0.0003429}, {417,0.0005714}, {418,0.0000000}, {419,0.0002286}, {420,0.0002286}, {421,0.0001143}, {422,0.0001143}, {423,0.0002286}, {424,0.0003429}, {425,0.0009143}, {426,0.0004571}, {427,0.0003143}, {428,0.0004571}, {429,0.0005714}, {430,0.0002286}, {431,0.0006857}, {432,0.0004571}, {433,0.0003429}, {434,0.0006857}, {435,0.0006857}, {436,0.0003429}, {437,0.0005714}, {438,0.0002286}, {439,0.0002286}, {440,0.0001143}, {441,0.0002286}, {442,0.0002286}, {443,0.0003429}, {444,0.0006857}, {445,0.0002286}, {446,0.0003429}, {447,0.0003429}, {448,0.0004571}, {449,0.0003429}, {450,0.0003429}, {451,0.0004571}, {452,0.0003429}, {453,0.0002286}, {454,0.0006857}, {455,0.0004571}, {456,0.0010286}, {457,0.0004571}, {458,0.0003429}, {459,0.0004571}, {460,0.0002286}, {461,0.0002286}, {462,0.0001143}, {463,0.0003429}, {464,0.0003429}, {465,0.0004571}, {466,0.0006857}, {467,0.0004571}, {468,0.0011143}, {469,0.0003429}, {470,0.0012571}, {471,0.0003429}, {472,0.0008000}, {473,0.0003429}, {474,0.0002286}, {475,0.0014857}, {476,0.0001143}, {477,0.0007714}, {478,0.0003429}, {479,0.0003429}, {480,0.0005429}, {481,0.0005714}, {482,0.0014857}, {483,0.0005714}, {484,0.0009143}, {485,0.0013714}, {486,0.0012571}, {487,0.0010286}, {488,0.0009143}, {489,0.0005714}, {490,0.0003429}, {491,0.0005714}, {492,0.0004571}, {493,0.0004571}, {494,0.0016571}, {495,0.0006571}, {496,0.0006571}, {497,0.0009143}, {498,0.0014857}, {499,0.0007714}, {500,0.0011429}, {505,0.0014571}, {510,0.0003429}, {515,0.0016000}, {520,0.0019429}, {525,0.0021714}, {530,0.0027429}, {535,0.0018000}, {540,0.0031429}, {545,0.0027143}, {550,0.0021714}, {555,0.0014857}, {560,0.0018000}, {565,0.0019429}, {570,0.0010000}, {575,0.0008000}, {580,0.0012571}, {585,0.0014571}, {590,0.0022857}, {595,0.0019143}, {600,0.0014857}, {605,0.0020286}, {610,0.0027143}, {615,0.0012571}, {620,0.0022857}, {625,0.0028000}, {630,0.0016000}, {635,0.0018286}, {640,0.0020571}, {645,0.0032000}, {650,0.0030857}, {655,0.0013714}, {660,0.0031429}, {665,0.0030571}, {670,0.0022571}, {675,0.0017143}, {680,0.0025143}, {685,0.0028571}, {690,0.0014571}, {695,0.0023714}, {700,0.0021714}, {705,0.0026286}, {710,0.0025143}, {715,0.0020571}, {720,0.0026000}, {725,0.0043143}, {730,0.0025143}, {735,0.0030857}, {740,0.0015714}, {745,0.0029429}, {750,0.0028286}, {755,0.0029429}, {760,0.0038286}, {765,0.0022857}, {770,0.0040000}, {775,0.0039714}, {780,0.0040000}, {785,0.0039143}, {790,0.0030571}, {795,0.0045714}, {800,0.0040857}, {805,0.0044286}, {810,0.0045429}, {815,0.0031714}, {820,0.0049143}, {825,0.0024857}, {830,0.0027143}, {835,0.0034286}, {840,0.0028571}, {845,0.0035143}, {850,0.0016000}, {855,0.0032000}, {860,0.0040000}, {865,0.0036286}, {870,0.0029429}, {875,0.0027429}, {880,0.0041429}, {885,0.0028000}, {890,0.0028286}, {895,0.0039714}, {900,0.0075429}, {905,0.0038286}, {910,0.0038286}, {915,0.0053143}, {920,0.0022857}, {925,0.0040000}, {930,0.0036000}, {935,0.0054286}, {940,0.0049714}, {945,0.0046286}, {950,0.0031714}, {955,0.0026286}, {960,0.0058571}, {965,0.0032857}, {970,0.0038857}, {975,0.0026000}, {980,0.0026286}, {985,0.0033143}, {990,0.0046286}, {995,0.0057429}, {1000,0.0077714}, {1010,0.0042571}, {1020,0.0038286}, {1030,0.0028857}, {1040,0.0047714}, {1050,0.0076000}, {1060,0.0046000}, {1070,0.0073143}, {1080,0.0076857}, {1090,0.0056571}, {1100,0.0053714}, {1110,0.0055429}, {1120,0.0071714}, {1130,0.0057714}, {1140,0.0081714}, {1150,0.0079143}, {1160,0.0064857}, {1170,0.0074571}, {1180,0.0104000}, {1190,0.0057143}, {1200,0.0064286}, {1210,0.0077714}, {1220,0.0067429}, {1230,0.0114000}, {1240,0.0101429}, {1250,0.0076571}, {1260,0.0125143}, {1270,0.0091429}, {1280,0.0090571}, {1290,0.0118571}, {1300,0.0097429}, {1310,0.0040000}, {1320,0.0067714}, {1330,0.0131714}, {1340,0.0065429}, {1350,0.0086000}, {1360,0.0186000}, {1370,0.0139429}, {1380,0.0098571}, {1390,0.0174857}, {1400,0.0116571}, {1410,0.0098286}, {1420,0.0136857}, {1430,0.0106286}, {1440,0.0156571}, {1450,0.0162000}, {1460,0.0153714}, {1470,0.0091429}, {1480,0.0153143}, {1490,0.0257429}, {1500,0.0168000}, {1510,0.0251714}, {1520,0.0223714}, {1530,0.0234857}, {1540,0.0199714}, {1550,0.0215143}, {1560,0.0235714}, {1570,0.0223429}, {1580,0.0273714}, {1590,0.0256286}, {1600,0.0262857}, {1610,0.0213714}, {1620,0.0243714}, {1630,0.0200000}, {1640,0.0269143}, {1650,0.0276286}, {1660,0.0192286}, {1670,0.0304857}, {1680,0.0166857}, {1690,0.0241714}, {1700,0.0225143}, {1710,0.0212571}, {1720,0.0300857}, {1730,0.0278857}, {1740,0.0301714}, {1750,0.0298286}, {1760,0.0311429}, {1770,0.0304857}, {1780,0.0271143}, {1790,0.0357429}, {1800,0.0359429}, {1810,0.0380286}, {1820,0.0325714}, {1830,0.0332000}, {1840,0.0379714}, {1850,0.0332286}, {1860,0.0408857}, {1870,0.0357143}, {1880,0.0313143}, {1890,0.0405429}, {1900,0.0308000}, {1910,0.0323429}, {1920,0.0382857}, {1930,0.0391429}, {1940,0.0433429}, {1950,0.0396000}, {1960,0.0293429}, {1970,0.0423714}, {1980,0.0428571}, {1990,0.0345143}, {2000,0.0445429}};
data["big"]["LtacTCPrimPair"]["Aggregate"]["real"] = {{1,0.00101980}, {2,0.00101980}, {3,0.00200000}, {4,0.00200000}, {5,0.00215842}, {6,0.00300000}, {7,0.00303960}, {8,0.00385149}, {9,0.00400000}, {10,0.00432673}, {11,0.00500990}, {12,0.00526733}, {13,0.00600000}, {14,0.00646535}, {15,0.00693069}, {16,0.00741584}, {17,0.00789109}, {18,0.00854455}, {19,0.00895050}, {20,0.01041584}, {21,0.01001980}, {22,0.01071287}, {23,0.01119802}, {24,0.01179208}, {25,0.01258416}, {26,0.01287129}, {27,0.01377228}, {28,0.01739604}, {29,0.01474257}, {30,0.01548515}, {31,0.01590099}, {32,0.01646535}, {33,0.01727723}, {34,0.02173267}, {35,0.01820792}, {36,0.01940594}, {37,0.01993069}, {38,0.02327723}, {39,0.02419802}, {40,0.02159406}, {41,0.02258416}, {42,0.02302970}, {43,0.02431683}, {44,0.02507921}, {45,0.02555446}, {46,0.02632673}, {47,0.02724752}, {48,0.02821782}, {49,0.02834653}, {50,0.02880198}, {51,0.03045545}, {52,0.03121782}, {53,0.03208911}, {54,0.03299010}, {55,0.03477228}, {56,0.03474257}, {57,0.03523762}, {58,0.03655446}, {59,0.03602970}, {60,0.04141584}, {61,0.04437624}, {62,0.04612871}, {63,0.04656436}, {64,0.04539604}, {65,0.04166337}, {66,0.04368317}, {67,0.04445545}, {68,0.04550495}, {69,0.05025743}, {70,0.04697030}, {71,0.04894059}, {72,0.04842574}, {73,0.05049505}, {74,0.05054455}, {75,0.05229703}, {76,0.05324752}, {77,0.06400000}, {78,0.05579208}, {79,0.05660396}, {80,0.05778218}, {81,0.05807921}, {82,0.05906931}, {83,0.08756436}, {84,0.06080198}, {85,0.06239604}, {86,0.07895050}, {87,0.08320792}, {88,0.07557426}, {89,0.07975248}, {90,0.07967327}, {91,0.07828713}, {92,0.07843564}, {93,0.07841584}, {94,0.07893069}, {95,0.08000990}, {96,0.08051485}, {97,0.08070297}, {98,0.08133663}, {99,0.08166337}, {100,0.08352475}, {101,0.08440594}, {102,0.08525743}, {103,0.08754455}, {104,0.08609901}, {105,0.08794059}, {106,0.08954455}, {107,0.09080198}, {108,0.09197030}, {109,0.09360396}, {110,0.09414851}, {111,0.09611881}, {112,0.09812871}, {113,0.09986139}, {114,0.10109901}, {115,0.10345545}, {116,0.10354455}, {117,0.10544554}, {118,0.10767327}, {119,0.10983168}, {120,0.11134653}, {121,0.11320792}, {122,0.12447525}, {123,0.12636634}, {124,0.12908911}, {125,0.13154455}, {126,0.13515842}, {127,0.13788119}, {128,0.13440594}, {129,0.14680198}, {130,0.14928713}, {131,0.14978218}, {132,0.15164356}, {133,0.15140594}, {134,0.15622772}, {135,0.15821782}, {136,0.16075248}, {137,0.15996040}, {138,0.16529703}, {139,0.16502970}, {140,0.16804950}, {141,0.17163366}, {142,0.17230693}, {143,0.17605941}, {144,0.17652475}, {145,0.17767327}, {146,0.17995050}, {147,0.18065347}, {148,0.18404950}, {149,0.18675248}, {150,0.18800990}, {151,0.18890099}, {152,0.18928713}, {153,0.19636634}, {154,0.19804950}, {155,0.19946535}, {156,0.20245545}, {157,0.20387129}, {158,0.20406931}, {159,0.20790099}, {160,0.21004950}, {161,0.21241584}, {162,0.21208911}, {163,0.21706931}, {164,0.21782178}, {165,0.22241584}, {166,0.22308911}, {167,0.22281188}, {168,0.22951485}, {169,0.23159406}, {170,0.23266337}, {171,0.23787129}, {172,0.23861386}, {173,0.24133663}, {174,0.24172277}, {175,0.24345545}, {176,0.24892079}, {177,0.25138614}, {178,0.25552475}, {179,0.25871287}, {180,0.25794059}, {181,0.26238614}, {182,0.26522772}, {183,0.26921782}, {184,0.27093069}, {185,0.27203960}, {186,0.27351485}, {187,0.27633663}, {188,0.27709901}, {189,0.27878218}, {190,0.28970297}, {191,0.29270297}, {192,0.29577228}, {193,0.29707921}, {194,0.29767327}, {195,0.29626733}, {196,0.29786139}, {197,0.30185149}, {198,0.30277228}, {199,0.30461386}, {200,0.31426733}, {201,0.31996040}, {202,0.31699010}, {203,0.31753465}, {204,0.32149505}, {205,0.32309901}, {206,0.33011881}, {207,0.34132673}, {208,0.32881188}, {209,0.33589109}, {210,0.33763366}, {211,0.34672277}, {212,0.35313861}, {213,0.34688119}, {214,0.34767327}, {215,0.35820792}, {216,0.36130693}, {217,0.35881188}, {218,0.36754455}, {219,0.37280198}, {220,0.37051485}, {221,0.37406931}, {222,0.38283168}, {223,0.38202970}, {224,0.38818812}, {225,0.38901980}, {226,0.39101980}, {227,0.39842574}, {228,0.39558416}, {229,0.40179208}, {230,0.40260396}, {231,0.41200990}, {232,0.41050495}, {233,0.41252475}, {234,0.41701980}, {235,0.42287129}, {236,0.42338614}, {237,0.42978218}, {238,0.42846535}, {239,0.43878218}, {240,0.43504950}, {241,0.44943564}, {242,0.44456436}, {243,0.45071287}, {244,0.45417822}, {245,0.45545545}, {246,0.46084158}, {247,0.46871287}, {248,0.46597030}, {249,0.47320792}, {250,0.48179208}, {251,0.47955446}, {252,0.49512871}, {253,0.49094059}, {254,0.48558416}, {255,0.49500990}, {256,0.49939604}, {257,0.49941584}, {258,0.50444554}, {259,0.50388119}, {260,0.51466337}, {261,0.51870297}, {262,0.51509901}, {263,0.52070297}, {264,0.52509901}, {265,0.52681188}, {266,0.53389109}, {267,0.53975248}, {268,0.54159406}, {269,0.54326733}, {270,0.54816832}, {271,0.55392079}, {272,0.57079208}, {273,0.56062376}, {274,0.58128713}, {275,0.56969307}, {276,0.57501980}, {277,0.58262376}, {278,0.58780198}, {279,0.62322772}, {280,0.58792079}, {281,0.58979208}, {282,0.59539604}, {283,0.60085149}, {284,0.60400000}, {285,0.60652475}, {286,0.61075248}, {287,0.62147525}, {288,0.62156436}, {289,0.62522772}, {290,0.63203960}, {291,0.64802970}, {292,0.65736634}, {293,0.66444554}, {294,0.66508911}, {295,0.67213861}, {296,0.67408911}, {297,0.67697030}, {298,0.67941584}, {299,0.68752475}, {300,0.69313861}, {301,0.7159429}, {302,0.7605143}, {303,0.7427429}, {304,0.7518286}, {305,0.7291429}, {306,0.7327714}, {307,0.7440000}, {308,0.7475143}, {309,0.7497429}, {310,0.7539714}, {311,0.7582857}, {312,0.7656857}, {313,0.7695429}, {314,0.7771429}, {315,0.7788286}, {316,0.7801429}, {317,0.7848857}, {318,0.7940857}, {319,0.8010286}, {320,0.8142571}, {321,0.8072000}, {322,0.8119143}, {323,0.8193143}, {324,0.8187143}, {325,0.8258571}, {326,0.8345143}, {327,0.8418286}, {328,0.8434857}, {329,0.8512286}, {330,0.8518857}, {331,0.8618000}, {332,0.8622571}, {333,0.8682857}, {334,0.8764000}, {335,0.8812000}, {336,0.8902857}, {337,0.8900000}, {338,0.8993143}, {339,0.8998857}, {340,0.9053429}, {341,0.9081714}, {342,0.9229429}, {343,0.9254000}, {344,0.9375714}, {345,0.9584286}, {346,0.9503429}, {347,0.9462286}, {348,0.9560000}, {349,0.9547143}, {350,0.9672286}, {351,0.9769429}, {352,0.9753429}, {353,0.9798000}, {354,0.9854286}, {355,0.9968571}, {356,0.9936571}, {357,1.0024857}, {358,1.0074571}, {359,1.0092286}, {360,1.0115714}, {361,1.0459714}, {362,1.0300000}, {363,1.0336857}, {364,1.0422286}, {365,1.0428000}, {366,1.0480571}, {367,1.0538571}, {368,1.0680286}, {369,1.0888571}, {370,1.0771429}, {371,1.1057429}, {372,1.0904571}, {373,1.0962857}, {374,1.0980571}, {375,1.1136000}, {376,1.1173143}, {377,1.1187143}, {378,1.1704286}, {379,1.1330000}, {380,1.1568571}, {381,1.1413429}, {382,1.1697429}, {383,1.1614000}, {384,1.1859714}, {385,1.1770571}, {386,1.2033714}, {387,1.1912857}, {388,1.2006571}, {389,1.1995429}, {390,1.2090857}, {391,1.2146000}, {392,1.2722286}, {393,1.2257714}, {394,1.2370571}, {395,1.2424571}, {396,1.2740857}, {397,1.2583143}, {398,1.2846857}, {399,1.2867714}, {400,1.2982857}, {401,1.2776857}, {402,1.2915714}, {403,1.2931143}, {404,1.3227429}, {405,1.3083714}, {406,1.3178571}, {407,1.3502286}, {408,1.3362571}, {409,1.3348000}, {410,1.3443143}, {411,1.3489429}, {412,1.3484000}, {413,1.3562286}, {414,1.3667429}, {415,1.3994286}, {416,1.3776286}, {417,1.3819429}, {418,1.3891143}, {419,1.3935143}, {420,1.4042286}, {421,1.4124857}, {422,1.4194571}, {423,1.4286571}, {424,1.4343143}, {425,1.4395429}, {426,1.4484857}, {427,1.4573714}, {428,1.4684857}, {429,1.4821714}, {430,1.5021429}, {431,1.4954571}, {432,1.5163429}, {433,1.5192286}, {434,1.5264000}, {435,1.5359714}, {436,1.5447429}, {437,1.5538857}, {438,1.5577714}, {439,1.5698857}, {440,1.5770857}, {441,1.5877714}, {442,1.5946286}, {443,1.5982857}, {444,1.6062571}, {445,1.6184000}, {446,1.6263714}, {447,1.6325429}, {448,1.6403714}, {449,1.6431143}, {450,1.6588286}, {451,1.6702000}, {452,1.6698571}, {453,1.6797143}, {454,1.6856286}, {455,1.6993714}, {456,1.7279143}, {457,1.7185143}, {458,1.7442857}, {459,1.7354286}, {460,1.7318286}, {461,1.7441714}, {462,1.7532857}, {463,1.7623143}, {464,1.7781714}, {465,1.7702857}, {466,1.7958000}, {467,1.8271714}, {468,1.8271714}, {469,1.8182000}, {470,1.8199143}, {471,1.8280571}, {472,1.8368286}, {473,1.8382857}, {474,1.8578571}, {475,1.8615429}, {476,1.8619429}, {477,1.8662857}, {478,1.8828571}, {479,1.8922000}, {480,1.9327143}, {481,1.9124857}, {482,1.9250571}, {483,1.9395714}, {484,1.9415714}, {485,1.9642571}, {486,1.9623429}, {487,2.0006000}, {488,1.9737429}, {489,1.9775143}, {490,1.9741429}, {491,2.0073714}, {492,2.0020000}, {493,2.0380857}, {494,2.0441143}, {495,2.0460286}, {496,2.0883714}, {497,2.0522571}, {498,2.0686857}, {499,2.0805429}, {500,2.0865714}, {505,2.1299429}, {510,2.1721143}, {515,2.2550571}, {520,2.2674000}, {525,2.3216286}, {530,2.3611143}, {535,2.3989143}, {540,2.4718857}, {545,2.5340000}, {550,2.5899143}, {555,2.6343714}, {560,2.6960286}, {565,2.7590571}, {570,2.7897143}, {575,2.8616857}, {580,2.9127714}, {585,2.9707429}, {590,3.0560571}, {595,3.0742857}, {600,3.1367714}, {605,3.2252857}, {610,3.3337429}, {615,3.3761143}, {620,3.4400857}, {625,3.5531429}, {630,3.6584857}, {635,3.6388857}, {640,3.7113714}, {645,3.7875429}, {650,3.8142000}, {655,3.9808857}, {660,3.9184286}, {665,3.9627143}, {670,4.0188286}, {675,4.2078571}, {680,4.0840857}, {685,4.2708000}, {690,4.3328000}, {695,4.3429429}, {700,4.5615429}, {705,4.6487143}, {710,4.5580286}, {715,4.7198000}, {720,4.7903429}, {725,4.8389714}, {730,4.8403143}, {735,4.9505429}, {740,5.0540571}, {745,5.1388857}, {750,5.1832571}, {755,5.2629429}, {760,5.3729714}, {765,5.4663429}, {770,5.5618571}, {775,5.6004571}, {780,5.7080571}, {785,5.8326857}, {790,5.8827714}, {795,5.9955143}, {800,6.1470571}, {805,6.1768286}, {810,6.2758286}, {815,6.4277714}, {820,6.4614286}, {825,6.6002571}, {830,6.6701429}, {835,6.7579714}, {840,6.8536571}, {845,6.9496857}, {850,7.1371429}, {855,7.3057714}, {860,7.3136000}, {865,7.4717143}, {870,7.4890286}, {875,7.7561143}, {880,7.8065143}, {885,7.9475429}, {890,8.0763714}, {895,8.1490000}, {900,8.2081143}, {905,8.2966286}, {910,8.3807143}, {915,8.6091143}, {920,8.7306000}, {925,8.8145143}, {930,8.9039429}, {935,8.9729714}, {940,9.3182286}, {945,9.3053714}, {950,9.2900000}, {955,9.5772857}, {960,9.8034857}, {965,9.8106000}, {970,9.9453429}, {975,10.0087143}, {980,10.1344286}, {985,10.3818286}, {990,10.6457143}, {995,10.6148571}, {1000,11.0253143}, {1010,11.1337429}, {1020,11.4304857}, {1030,11.7301143}, {1040,12.1788286}, {1050,12.2843429}, {1060,12.4620000}, {1070,12.7565429}, {1080,13.3572857}, {1090,13.4244000}, {1100,13.7245143}, {1110,14.1114286}, {1120,14.4413714}, {1130,14.6647143}, {1140,15.2309429}, {1150,15.3004857}, {1160,15.7602571}, {1170,16.1065143}, {1180,16.5690286}, {1190,16.7278000}, {1200,17.4488286}, {1210,17.6200857}, {1220,18.0535143}, {1230,18.3405714}, {1240,19.0593714}, {1250,19.2183714}, {1260,19.7324571}, {1270,20.1679429}, {1280,20.5306571}, {1290,21.0392857}, {1300,21.1568571}, {1310,21.8809143}, {1320,22.1340571}, {1330,22.6406000}, {1340,23.3826286}, {1350,23.8934286}, {1360,24.4189143}, {1370,24.6986857}, {1380,25.3115714}, {1390,25.7966857}, {1400,26.0992286}, {1410,26.8168857}, {1420,27.3051429}, {1430,27.5803143}, {1440,28.3173714}, {1450,28.9113429}, {1460,28.9793714}, {1470,29.7274000}, {1480,30.5307714}, {1490,31.1482000}, {1500,31.5241143}, {1510,32.2985429}, {1520,32.9525714}, {1530,33.6031429}, {1540,33.8663714}, {1550,34.7108857}, {1560,35.3070571}, {1570,36.1328571}, {1580,36.0708857}, {1590,37.0263429}, {1600,37.9106000}, {1610,38.1650857}, {1620,39.1909714}, {1630,39.4399143}, {1640,40.1179429}, {1650,40.6278857}, {1660,41.5414000}, {1670,42.2625143}, {1680,43.2936286}, {1690,44.1010571}, {1700,44.9895429}, {1710,45.3242571}, {1720,46.3738000}, {1730,46.9713429}, {1740,47.4498571}, {1750,48.0802857}, {1760,49.0701714}, {1770,49.5838000}, {1780,50.7330571}, {1790,51.2523429}, {1800,52.0287143}, {1810,52.8967714}, {1820,53.5350857}, {1830,54.5993429}, {1840,55.1638286}, {1850,56.3578857}, {1860,56.9400571}, {1870,58.3052000}, {1880,59.2526857}, {1890,60.1352286}, {1900,61.5945429}, {1910,62.2665429}, {1920,63.5044571}, {1930,63.8157714}, {1940,64.2426857}, {1950,65.2180857}, {1960,66.1062286}, {1970,67.0989143}, {1980,67.6952571}, {1990,69.2600571}, {2000,69.7358000}};
data["big"]["LtacTCPrimPair"]["Aggregate"]["user"] = {{1,0.00126733}, {2,0.00173267}, {3,0.00191089}, {4,0.00259406}, {5,0.00301980}, {6,0.00298020}, {7,0.00378218}, {8,0.00388119}, {9,0.00432673}, {10,0.00451485}, {11,0.00497030}, {12,0.00556436}, {13,0.00579208}, {14,0.00692079}, {15,0.00682178}, {16,0.00753465}, {17,0.00818812}, {18,0.00811881}, {19,0.00924752}, {20,0.01017822}, {21,0.00999010}, {22,0.01051485}, {23,0.01122772}, {24,0.01175248}, {25,0.01258416}, {26,0.01282178}, {27,0.01367327}, {28,0.01715842}, {29,0.01448515}, {30,0.01493069}, {31,0.01570297}, {32,0.01635644}, {33,0.01686139}, {34,0.02177228}, {35,0.01791089}, {36,0.01902970}, {37,0.01940594}, {38,0.02368317}, {39,0.02451485}, {40,0.02184158}, {41,0.02266337}, {42,0.02344554}, {43,0.02453465}, {44,0.02527723}, {45,0.02586139}, {46,0.02701980}, {47,0.02749505}, {48,0.02831683}, {49,0.02857426}, {50,0.02867327}, {51,0.03056436}, {52,0.03134653}, {53,0.03185149}, {54,0.03297030}, {55,0.03488119}, {56,0.03450495}, {57,0.03524752}, {58,0.03625743}, {59,0.03618812}, {60,0.04146535}, {61,0.04447525}, {62,0.04629703}, {63,0.04626733}, {64,0.04544554}, {65,0.04088119}, {66,0.04337624}, {67,0.04402970}, {68,0.04557426}, {69,0.05061386}, {70,0.04720792}, {71,0.04918812}, {72,0.04845545}, {73,0.05070297}, {74,0.05077228}, {75,0.05253465}, {76,0.05326733}, {77,0.06344554}, {78,0.05594059}, {79,0.05659406}, {80,0.05764356}, {81,0.05797030}, {82,0.05882178}, {83,0.08715842}, {84,0.06049505}, {85,0.06192079}, {86,0.07899010}, {87,0.08310891}, {88,0.07599010}, {89,0.07997030}, {90,0.07968317}, {91,0.07852475}, {92,0.07866337}, {93,0.07846535}, {94,0.07880198}, {95,0.08013861}, {96,0.08043564}, {97,0.08063366}, {98,0.08108911}, {99,0.08105941}, {100,0.08337624}, {101,0.08394059}, {102,0.08459406}, {103,0.08749505}, {104,0.08567327}, {105,0.08749505}, {106,0.08923762}, {107,0.09010891}, {108,0.09159406}, {109,0.09338614}, {110,0.09413861}, {111,0.09595050}, {112,0.09820792}, {113,0.09989109}, {114,0.10105941}, {115,0.10339604}, {116,0.10312871}, {117,0.10522772}, {118,0.10754455}, {119,0.10923762}, {120,0.11108911}, {121,0.11298020}, {122,0.12410891}, {123,0.12623762}, {124,0.12903960}, {125,0.13135644}, {126,0.13468317}, {127,0.13750495}, {128,0.13402970}, {129,0.14658416}, {130,0.14926733}, {131,0.14955446}, {132,0.15136634}, {133,0.15104950}, {134,0.15569307}, {135,0.15797030}, {136,0.16079208}, {137,0.15957426}, {138,0.16469307}, {139,0.16447525}, {140,0.16789109}, {141,0.17121782}, {142,0.17229703}, {143,0.17577228}, {144,0.17639604}, {145,0.17715842}, {146,0.17920792}, {147,0.18047525}, {148,0.18383168}, {149,0.18629703}, {150,0.18763366}, {151,0.18859406}, {152,0.18903960}, {153,0.19566337}, {154,0.19753465}, {155,0.19914851}, {156,0.20225743}, {157,0.20327723}, {158,0.20366337}, {159,0.20768317}, {160,0.20944554}, {161,0.21182178}, {162,0.21119802}, {163,0.21618812}, {164,0.21714851}, {165,0.22176238}, {166,0.22242574}, {167,0.22228713}, {168,0.22900000}, {169,0.23116832}, {170,0.23198020}, {171,0.23737624}, {172,0.23744554}, {173,0.24056436}, {174,0.24102970}, {175,0.24307921}, {176,0.24834653}, {177,0.25067327}, {178,0.25491089}, {179,0.25816832}, {180,0.25740594}, {181,0.26200990}, {182,0.26487129}, {183,0.26874257}, {184,0.27054455}, {185,0.27127723}, {186,0.27291089}, {187,0.27585149}, {188,0.27670297}, {189,0.27803960}, {190,0.28908911}, {191,0.29194059}, {192,0.29546535}, {193,0.29631683}, {194,0.29695050}, {195,0.29551485}, {196,0.29726733}, {197,0.30127723}, {198,0.30237624}, {199,0.30370297}, {200,0.31351485}, {201,0.31958416}, {202,0.31634653}, {203,0.31695050}, {204,0.32063366}, {205,0.32253465}, {206,0.32933663}, {207,0.34100000}, {208,0.32813861}, {209,0.33510891}, {210,0.33682178}, {211,0.34581188}, {212,0.35253465}, {213,0.34591089}, {214,0.34682178}, {215,0.35762376}, {216,0.36081188}, {217,0.35783168}, {218,0.36660396}, {219,0.37203960}, {220,0.36976238}, {221,0.37349505}, {222,0.38229703}, {223,0.38123762}, {224,0.38722772}, {225,0.38849505}, {226,0.39018812}, {227,0.39789109}, {228,0.39486139}, {229,0.40093069}, {230,0.40183168}, {231,0.41072277}, {232,0.40954455}, {233,0.41171287}, {234,0.41597030}, {235,0.42182178}, {236,0.42241584}, {237,0.42815842}, {238,0.42744554}, {239,0.43782178}, {240,0.43413861}, {241,0.44876238}, {242,0.44380198}, {243,0.44996040}, {244,0.45346535}, {245,0.45436634}, {246,0.45981188}, {247,0.46773267}, {248,0.46469307}, {249,0.47241584}, {250,0.48085149}, {251,0.47861386}, {252,0.49378218}, {253,0.48991089}, {254,0.48447525}, {255,0.49414851}, {256,0.49863366}, {257,0.49826733}, {258,0.50361386}, {259,0.50322772}, {260,0.51383168}, {261,0.51779208}, {262,0.51439604}, {263,0.51971287}, {264,0.52407921}, {265,0.52608911}, {266,0.53319802}, {267,0.53883168}, {268,0.54065347}, {269,0.54200990}, {270,0.54699010}, {271,0.55315842}, {272,0.56967327}, {273,0.55981188}, {274,0.58044554}, {275,0.56884158}, {276,0.57389109}, {277,0.58184158}, {278,0.58689109}, {279,0.62205941}, {280,0.58705941}, {281,0.58900990}, {282,0.59421782}, {283,0.60002970}, {284,0.60302970}, {285,0.60524752}, {286,0.60961386}, {287,0.62072277}, {288,0.62035644}, {289,0.62385149}, {290,0.63051485}, {291,0.64686139}, {292,0.65614851}, {293,0.66328713}, {294,0.66363366}, {295,0.67079208}, {296,0.67283168}, {297,0.67600990}, {298,0.67827723}, {299,0.68627723}, {300,0.69177228}, {301,0.7151429}, {302,0.7569143}, {303,0.7417143}, {304,0.7508286}, {305,0.7283429}, {306,0.7312000}, {307,0.7426857}, {308,0.7464571}, {309,0.7483143}, {310,0.7524857}, {311,0.7572000}, {312,0.7642857}, {313,0.7684571}, {314,0.7765429}, {315,0.7776286}, {316,0.7792857}, {317,0.7842000}, {318,0.7933143}, {319,0.7990286}, {320,0.8082286}, {321,0.8066857}, {322,0.8116857}, {323,0.8176286}, {324,0.8176000}, {325,0.8240571}, {326,0.8339714}, {327,0.8369714}, {328,0.8410000}, {329,0.8492857}, {330,0.8504571}, {331,0.8587429}, {332,0.8612286}, {333,0.8650000}, {334,0.8747429}, {335,0.8775714}, {336,0.8836286}, {337,0.8888571}, {338,0.8982571}, {339,0.8985714}, {340,0.9049714}, {341,0.9067143}, {342,0.9214571}, {343,0.9239714}, {344,0.9367714}, {345,0.9567714}, {346,0.9491714}, {347,0.9451143}, {348,0.9542857}, {349,0.9537429}, {350,0.9657714}, {351,0.9753714}, {352,0.9736857}, {353,0.9792000}, {354,0.9845143}, {355,0.9957429}, {356,0.9919714}, {357,1.0018571}, {358,1.0066571}, {359,1.0080000}, {360,1.0103143}, {361,1.0440857}, {362,1.0286000}, {363,1.0326571}, {364,1.0405429}, {365,1.0418286}, {366,1.0463714}, {367,1.0529714}, {368,1.0672286}, {369,1.0873714}, {370,1.0754571}, {371,1.1041429}, {372,1.0892857}, {373,1.0939429}, {374,1.0964571}, {375,1.1124571}, {376,1.1160000}, {377,1.1164571}, {378,1.1683429}, {379,1.1305429}, {380,1.1554857}, {381,1.1388857}, {382,1.1680571}, {383,1.1592000}, {384,1.1839143}, {385,1.1741714}, {386,1.2012857}, {387,1.1898571}, {388,1.1984571}, {389,1.1974571}, {390,1.2071429}, {391,1.2121714}, {392,1.2702000}, {393,1.2226000}, {394,1.2352286}, {395,1.2406000}, {396,1.2726000}, {397,1.2568571}, {398,1.2826857}, {399,1.2852000}, {400,1.2952286}, {401,1.2750286}, {402,1.2897714}, {403,1.2915143}, {404,1.3202000}, {405,1.3041429}, {406,1.3140000}, {407,1.3427143}, {408,1.3329143}, {409,1.3319714}, {410,1.3419714}, {411,1.3464857}, {412,1.3456857}, {413,1.3535429}, {414,1.3643143}, {415,1.3972571}, {416,1.3754857}, {417,1.3797714}, {418,1.3868857}, {419,1.3911429}, {420,1.4020000}, {421,1.4108000}, {422,1.4175143}, {423,1.4260857}, {424,1.4318571}, {425,1.4368571}, {426,1.4459143}, {427,1.4545714}, {428,1.4651429}, {429,1.4796571}, {430,1.4995429}, {431,1.4918000}, {432,1.5129714}, {433,1.5156857}, {434,1.5236286}, {435,1.5331714}, {436,1.5412000}, {437,1.5504857}, {438,1.5544286}, {439,1.5672286}, {440,1.5737714}, {441,1.5842286}, {442,1.5911143}, {443,1.5944286}, {444,1.6026857}, {445,1.6151429}, {446,1.6232571}, {447,1.6288571}, {448,1.6366857}, {449,1.6396286}, {450,1.6559714}, {451,1.6677143}, {452,1.6674000}, {453,1.6771143}, {454,1.6820286}, {455,1.6962286}, {456,1.7249714}, {457,1.7148571}, {458,1.7413714}, {459,1.7330571}, {460,1.7282000}, {461,1.7413429}, {462,1.7506286}, {463,1.7596000}, {464,1.7756000}, {465,1.7676571}, {466,1.7924000}, {467,1.8245714}, {468,1.8248286}, {469,1.8158000}, {470,1.8176571}, {471,1.8242000}, {472,1.8330857}, {473,1.8340571}, {474,1.8536286}, {475,1.8577429}, {476,1.8583714}, {477,1.8622857}, {478,1.8794857}, {479,1.8874571}, {480,1.9278571}, {481,1.9080571}, {482,1.9203429}, {483,1.9348286}, {484,1.9369714}, {485,1.9586571}, {486,1.9569429}, {487,1.9948571}, {488,1.9686571}, {489,1.9730000}, {490,1.9697429}, {491,2.0030571}, {492,1.9972000}, {493,2.0326571}, {494,2.0394286}, {495,2.0408286}, {496,2.0841143}, {497,2.0485143}, {498,2.0643429}, {499,2.0764000}, {500,2.0815429}, {505,2.1248857}, {510,2.1682571}, {515,2.2485429}, {520,2.2604286}, {525,2.3142857}, {530,2.3544857}, {535,2.3925714}, {540,2.4641714}, {545,2.5266571}, {550,2.5822286}, {555,2.6250857}, {560,2.6877143}, {565,2.7501714}, {570,2.7819143}, {575,2.8544000}, {580,2.9052000}, {585,2.9630857}, {590,3.0493143}, {595,3.0671143}, {600,3.1289714}, {605,3.2171429}, {610,3.3264571}, {615,3.3677143}, {620,3.4327714}, {625,3.5457143}, {630,3.6511429}, {635,3.6303714}, {640,3.7038000}, {645,3.7796286}, {650,3.8093429}, {655,3.9759143}, {660,3.9146857}, {665,3.9574571}, {670,4.0132571}, {675,4.2032857}, {680,4.0794286}, {685,4.2635143}, {690,4.3260571}, {695,4.3371143}, {700,4.5542286}, {705,4.6410000}, {710,4.5516857}, {715,4.7112000}, {720,4.7810571}, {725,4.8295429}, {730,4.8290571}, {735,4.9397714}, {740,5.0447143}, {745,5.1292286}, {750,5.1756571}, {755,5.2544857}, {760,5.3652571}, {765,5.4564000}, {770,5.5513143}, {775,5.5909429}, {780,5.6973429}, {785,5.8243714}, {790,5.8728571}, {795,5.9844857}, {800,6.1305714}, {805,6.1604857}, {810,6.2567429}, {815,6.4074857}, {820,6.4455429}, {825,6.5822286}, {830,6.6534857}, {835,6.7402000}, {840,6.8395143}, {845,6.9358000}, {850,7.1246857}, {855,7.2919429}, {860,7.2989143}, {865,7.4587143}, {870,7.4765143}, {875,7.7413143}, {880,7.7963714}, {885,7.9422857}, {890,8.0692286}, {895,8.1410857}, {900,8.1994857}, {905,8.2841714}, {910,8.3657429}, {915,8.5904571}, {920,8.7143429}, {925,8.7998286}, {930,8.8891714}, {935,8.9573143}, {940,9.3007714}, {945,9.2879143}, {950,9.2767714}, {955,9.5631429}, {960,9.7927429}, {965,9.7921714}, {970,9.9200286}, {975,9.9850571}, {980,10.1098571}, {985,10.3611714}, {990,10.6161143}, {995,10.5868571}, {1000,10.9985143}, {1010,11.1005143}, {1020,11.3997143}, {1030,11.6987143}, {1040,12.1520000}, {1050,12.2504571}, {1060,12.4381143}, {1070,12.7394286}, {1080,13.3334000}, {1090,13.4081714}, {1100,13.7056286}, {1110,14.0850571}, {1120,14.4108286}, {1130,14.6423143}, {1140,15.1759143}, {1150,15.2752571}, {1160,15.7380000}, {1170,16.0817429}, {1180,16.5448857}, {1190,16.7073143}, {1200,17.4287714}, {1210,17.5976571}, {1220,18.0242286}, {1230,18.3088571}, {1240,19.0328000}, {1250,19.1809143}, {1260,19.6988857}, {1270,20.1287429}, {1280,20.4946286}, {1290,21.0029429}, {1300,21.1326286}, {1310,21.8579429}, {1320,22.1148571}, {1330,22.6157429}, {1340,23.3574571}, {1350,23.8598857}, {1360,24.3836286}, {1370,24.6642857}, {1380,25.2746000}, {1390,25.7713429}, {1400,26.0695714}, {1410,26.7891429}, {1420,27.2721714}, {1430,27.5504571}, {1440,28.2908857}, {1450,28.8668857}, {1460,28.9322857}, {1470,29.6900571}, {1480,30.4954000}, {1490,31.1122000}, {1500,31.4896571}, {1510,32.2640000}, {1520,32.9010857}, {1530,33.5674000}, {1540,33.8292286}, {1550,34.6716000}, {1560,35.2660286}, {1570,36.0992857}, {1580,36.0137143}, {1590,36.9827429}, {1600,37.8540857}, {1610,38.1193143}, {1620,39.1479143}, {1630,39.3889143}, {1640,40.0704286}, {1650,40.5759143}, {1660,41.4911143}, {1670,42.2146571}, {1680,43.2418286}, {1690,44.0480000}, {1700,44.9255714}, {1710,45.2749429}, {1720,46.3267429}, {1730,46.9049429}, {1740,47.3874000}, {1750,48.0220857}, {1760,49.0103714}, {1770,49.5164571}, {1780,50.6692000}, {1790,51.1920286}, {1800,51.9854286}, {1810,52.8537714}, {1820,53.4923429}, {1830,54.5481714}, {1840,55.0798857}, {1850,56.2863429}, {1860,56.8758571}, {1870,58.2147429}, {1880,59.1952000}, {1890,60.0480857}, {1900,61.5144286}, {1910,62.2184000}, {1920,63.4576857}, {1930,63.7641429}, {1940,64.1718571}, {1950,65.1527714}, {1960,66.0752571}, {1970,67.0555143}, {1980,67.6522571}, {1990,69.2257714}, {2000,69.6994571}};
data["big"]["LtacTCPrimPair"]["Aggregate"]["system"] = {{1,0.00003960}, {2,0.00003960}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00019802}, {7,0.00003960}, {8,0.00000000}, {9,0.00000000}, {10,0.00007921}, {11,0.00003960}, {12,0.00011881}, {13,0.00007921}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00006931}, {18,0.00015842}, {19,0.00000000}, {20,0.00003960}, {21,0.00007921}, {22,0.00003960}, {23,0.00000000}, {24,0.00011881}, {25,0.00000000}, {26,0.00011881}, {27,0.00007921}, {28,0.00007921}, {29,0.00003960}, {30,0.00000000}, {31,0.00007921}, {32,0.00000000}, {33,0.00000000}, {34,0.00007921}, {35,0.00011881}, {36,0.00003960}, {37,0.00003960}, {38,0.00007921}, {39,0.00007921}, {40,0.00000000}, {41,0.00000000}, {42,0.00003960}, {43,0.00000000}, {44,0.00007921}, {45,0.00007921}, {46,0.00000000}, {47,0.00002970}, {48,0.00007921}, {49,0.00003960}, {50,0.00003960}, {51,0.00007921}, {52,0.00002970}, {53,0.00003960}, {54,0.00000000}, {55,0.00000000}, {56,0.00003960}, {57,0.00000000}, {58,0.00019802}, {59,0.00011881}, {60,0.00000000}, {61,0.00003960}, {62,0.00000000}, {63,0.00003960}, {64,0.00000000}, {65,0.00007921}, {66,0.00000000}, {67,0.00011881}, {68,0.00000000}, {69,0.00000000}, {70,0.00003960}, {71,0.00003960}, {72,0.00007921}, {73,0.00000000}, {74,0.00003960}, {75,0.00003960}, {76,0.00003960}, {77,0.00003960}, {78,0.00003960}, {79,0.00011881}, {80,0.00003960}, {81,0.00010891}, {82,0.00000000}, {83,0.00015842}, {84,0.00003960}, {85,0.00003960}, {86,0.00002970}, {87,0.00000000}, {88,0.00007921}, {89,0.00007921}, {90,0.00003960}, {91,0.00000000}, {92,0.00003960}, {93,0.00000000}, {94,0.00003960}, {95,0.00003960}, {96,0.00000000}, {97,0.00015842}, {98,0.00003960}, {99,0.00003960}, {100,0.00000000}, {101,0.00007921}, {102,0.00003960}, {103,0.00011881}, {104,0.00007921}, {105,0.00000000}, {106,0.00003960}, {107,0.00003960}, {108,0.00000000}, {109,0.00003960}, {110,0.00007921}, {111,0.00007921}, {112,0.00011881}, {113,0.00019802}, {114,0.00007921}, {115,0.00023762}, {116,0.00011881}, {117,0.00007921}, {118,0.00003960}, {119,0.00006931}, {120,0.00003960}, {121,0.00003960}, {122,0.00011881}, {123,0.00000000}, {124,0.00003960}, {125,0.00000000}, {126,0.00007921}, {127,0.00003960}, {128,0.00003960}, {129,0.00011881}, {130,0.00003960}, {131,0.00000000}, {132,0.00011881}, {133,0.00003960}, {134,0.00011881}, {135,0.00003960}, {136,0.00003960}, {137,0.00000000}, {138,0.00014851}, {139,0.00000000}, {140,0.00007921}, {141,0.00007921}, {142,0.00002970}, {143,0.00007921}, {144,0.00002970}, {145,0.00007921}, {146,0.00010891}, {147,0.00003960}, {148,0.00000000}, {149,0.00007921}, {150,0.00003960}, {151,0.00007921}, {152,0.00015842}, {153,0.00003960}, {154,0.00003960}, {155,0.00000000}, {156,0.00003960}, {157,0.00003960}, {158,0.00007921}, {159,0.00000000}, {160,0.00007921}, {161,0.00000000}, {162,0.00011881}, {163,0.00007921}, {164,0.00007921}, {165,0.00006931}, {166,0.00007921}, {167,0.00003960}, {168,0.00003960}, {169,0.00007921}, {170,0.00011881}, {171,0.00003960}, {172,0.00007921}, {173,0.00000000}, {174,0.00007921}, {175,0.00000000}, {176,0.00000000}, {177,0.00006931}, {178,0.00015842}, {179,0.00000000}, {180,0.00000000}, {181,0.00003960}, {182,0.00003960}, {183,0.00000000}, {184,0.00007921}, {185,0.00010891}, {186,0.00003960}, {187,0.00003960}, {188,0.00007921}, {189,0.00007921}, {190,0.00011881}, {191,0.00011881}, {192,0.00011881}, {193,0.00011881}, {194,0.00003960}, {195,0.00015842}, {196,0.00006931}, {197,0.00003960}, {198,0.00003960}, {199,0.00011881}, {200,0.00007921}, {201,0.00000000}, {202,0.00011881}, {203,0.00007921}, {204,0.00015842}, {205,0.00000000}, {206,0.00003960}, {207,0.00000000}, {208,0.00011881}, {209,0.00011881}, {210,0.00007921}, {211,0.00011881}, {212,0.00003960}, {213,0.00019802}, {214,0.00015842}, {215,0.00003960}, {216,0.00007921}, {217,0.00011881}, {218,0.00019802}, {219,0.00023762}, {220,0.00011881}, {221,0.00007921}, {222,0.00003960}, {223,0.00000000}, {224,0.00003960}, {225,0.00000000}, {226,0.00019802}, {227,0.00002970}, {228,0.00007921}, {229,0.00019802}, {230,0.00010891}, {231,0.00011881}, {232,0.00035644}, {233,0.00000000}, {234,0.00007921}, {235,0.00007921}, {236,0.00007921}, {237,0.00055446}, {238,0.00011881}, {239,0.00039604}, {240,0.00007921}, {241,0.00000000}, {242,0.00011881}, {243,0.00007921}, {244,0.00003960}, {245,0.00031683}, {246,0.00011881}, {247,0.00007921}, {248,0.00007921}, {249,0.00006931}, {250,0.00007921}, {251,0.00015842}, {252,0.00015842}, {253,0.00003960}, {254,0.00011881}, {255,0.00007921}, {256,0.00011881}, {257,0.00007921}, {258,0.00011881}, {259,0.00003960}, {260,0.00003960}, {261,0.00007921}, {262,0.00000000}, {263,0.00007921}, {264,0.00015842}, {265,0.00003960}, {266,0.00007921}, {267,0.00007921}, {268,0.00003960}, {269,0.00019802}, {270,0.00023762}, {271,0.00011881}, {272,0.00015842}, {273,0.00000000}, {274,0.00007921}, {275,0.00019802}, {276,0.00011881}, {277,0.00003960}, {278,0.00015842}, {279,0.00011881}, {280,0.00007921}, {281,0.00011881}, {282,0.00011881}, {283,0.00007921}, {284,0.00003960}, {285,0.00003960}, {286,0.00007921}, {287,0.00011881}, {288,0.00014851}, {289,0.00015842}, {290,0.00007921}, {291,0.00007921}, {292,0.00011881}, {293,0.00011881}, {294,0.00023762}, {295,0.00003960}, {296,0.00023762}, {297,0.00007921}, {298,0.00011881}, {299,0.00003960}, {300,0.00011881}, {301,0.0002286}, {302,0.0003429}, {303,0.0003429}, {304,0.0004286}, {305,0.0001143}, {306,0.0002286}, {307,0.0004286}, {308,0.0000000}, {309,0.0002000}, {310,0.0003429}, {311,0.0001143}, {312,0.0002286}, {313,0.0000000}, {314,0.0000000}, {315,0.0001143}, {316,0.0003429}, {317,0.0000000}, {318,0.0001143}, {319,0.0002000}, {320,0.0004571}, {321,0.0000000}, {322,0.0002286}, {323,0.0004571}, {324,0.0001143}, {325,0.0001143}, {326,0.0000000}, {327,0.0002286}, {328,0.0000000}, {329,0.0002286}, {330,0.0002286}, {331,0.0002286}, {332,0.0000000}, {333,0.0001143}, {334,0.0000000}, {335,0.0004571}, {336,0.0003429}, {337,0.0000000}, {338,0.0003429}, {339,0.0003429}, {340,0.0000000}, {341,0.0001143}, {342,0.0002286}, {343,0.0001143}, {344,0.0001143}, {345,0.0000000}, {346,0.0000000}, {347,0.0002286}, {348,0.0008000}, {349,0.0001143}, {350,0.0002286}, {351,0.0001143}, {352,0.0001143}, {353,0.0002286}, {354,0.0000000}, {355,0.0002286}, {356,0.0003429}, {357,0.0001143}, {358,0.0000000}, {359,0.0001143}, {360,0.0000000}, {361,0.0001143}, {362,0.0001143}, {363,0.0000000}, {364,0.0002286}, {365,0.0001143}, {366,0.0001143}, {367,0.0002286}, {368,0.0001143}, {369,0.0002286}, {370,0.0001143}, {371,0.0003429}, {372,0.0000000}, {373,0.0004571}, {374,0.0003429}, {375,0.0001143}, {376,0.0002000}, {377,0.0003143}, {378,0.0003429}, {379,0.0003429}, {380,0.0001143}, {381,0.0005714}, {382,0.0001143}, {383,0.0004571}, {384,0.0002286}, {385,0.0004571}, {386,0.0003429}, {387,0.0001143}, {388,0.0002286}, {389,0.0004571}, {390,0.0002286}, {391,0.0002286}, {392,0.0002286}, {393,0.0001143}, {394,0.0002286}, {395,0.0001143}, {396,0.0000000}, {397,0.0002286}, {398,0.0004571}, {399,0.0003429}, {400,0.0004571}, {401,0.0006857}, {402,0.0003429}, {403,0.0002286}, {404,0.0000000}, {405,0.0005714}, {406,0.0001143}, {407,0.0002286}, {408,0.0001143}, {409,0.0000000}, {410,0.0000000}, {411,0.0001143}, {412,0.0002286}, {413,0.0001143}, {414,0.0002286}, {415,0.0002286}, {416,0.0001143}, {417,0.0004571}, {418,0.0002286}, {419,0.0000000}, {420,0.0000000}, {421,0.0001143}, {422,0.0001143}, {423,0.0004286}, {424,0.0000000}, {425,0.0002286}, {426,0.0002286}, {427,0.0003429}, {428,0.0006857}, {429,0.0001143}, {430,0.0002286}, {431,0.0003429}, {432,0.0006571}, {433,0.0002286}, {434,0.0004571}, {435,0.0001143}, {436,0.0002286}, {437,0.0003429}, {438,0.0004571}, {439,0.0000000}, {440,0.0003429}, {441,0.0001143}, {442,0.0001143}, {443,0.0003429}, {444,0.0005714}, {445,0.0002286}, {446,0.0005429}, {447,0.0003429}, {448,0.0004571}, {449,0.0002286}, {450,0.0003429}, {451,0.0001143}, {452,0.0000000}, {453,0.0000000}, {454,0.0002286}, {455,0.0000000}, {456,0.0003429}, {457,0.0005714}, {458,0.0002000}, {459,0.0002286}, {460,0.0003429}, {461,0.0003429}, {462,0.0004571}, {463,0.0005714}, {464,0.0001143}, {465,0.0006857}, {466,0.0006857}, {467,0.0005714}, {468,0.0002286}, {469,0.0005714}, {470,0.0003429}, {471,0.0006857}, {472,0.0004571}, {473,0.0009143}, {474,0.0013714}, {475,0.0004571}, {476,0.0002286}, {477,0.0001143}, {478,0.0006857}, {479,0.0012286}, {480,0.0008000}, {481,0.0002286}, {482,0.0004571}, {483,0.0004571}, {484,0.0002286}, {485,0.0009143}, {486,0.0002286}, {487,0.0014857}, {488,0.0002286}, {489,0.0000000}, {490,0.0002286}, {491,0.0002286}, {492,0.0000000}, {493,0.0005714}, {494,0.0004571}, {495,0.0004571}, {496,0.0000000}, {497,0.0001143}, {498,0.0003429}, {499,0.0000000}, {500,0.0004571}, {505,0.0011429}, {510,0.0001143}, {515,0.0010286}, {520,0.0002286}, {525,0.0008000}, {530,0.0013714}, {535,0.0004571}, {540,0.0009143}, {545,0.0004571}, {550,0.0005714}, {555,0.0014857}, {560,0.0009143}, {565,0.0019429}, {570,0.0013714}, {575,0.0004571}, {580,0.0008000}, {585,0.0002286}, {590,0.0005714}, {595,0.0006857}, {600,0.0008000}, {605,0.0010286}, {610,0.0013714}, {615,0.0021714}, {620,0.0009143}, {625,0.0012571}, {630,0.0005714}, {635,0.0018000}, {640,0.0010286}, {645,0.0022571}, {650,0.0009143}, {655,0.0016857}, {660,0.0010286}, {665,0.0017143}, {670,0.0013714}, {675,0.0009143}, {680,0.0006857}, {685,0.0015714}, {690,0.0018286}, {695,0.0007714}, {700,0.0022857}, {705,0.0034286}, {710,0.0030857}, {715,0.0038857}, {720,0.0036571}, {725,0.0017143}, {730,0.0042286}, {735,0.0044571}, {740,0.0048000}, {745,0.0036571}, {750,0.0033143}, {755,0.0024000}, {760,0.0036286}, {765,0.0052000}, {770,0.0040857}, {775,0.0021714}, {780,0.0040000}, {785,0.0027143}, {790,0.0044571}, {795,0.0051429}, {800,0.0058286}, {805,0.0050000}, {810,0.0053714}, {815,0.0063714}, {820,0.0059143}, {825,0.0083143}, {830,0.0072857}, {835,0.0057714}, {840,0.0061429}, {845,0.0066000}, {850,0.0046857}, {855,0.0058286}, {860,0.0068286}, {865,0.0067429}, {870,0.0056857}, {875,0.0100571}, {880,0.0058000}, {885,0.0039429}, {890,0.0053429}, {895,0.0045429}, {900,0.0045429}, {905,0.0067429}, {910,0.0053143}, {915,0.0062571}, {920,0.0068571}, {925,0.0058286}, {930,0.0068000}, {935,0.0058857}, {940,0.0057714}, {945,0.0085429}, {950,0.0061143}, {955,0.0081143}, {960,0.0040000}, {965,0.0092571}, {970,0.0113429}, {975,0.0093143}, {980,0.0094571}, {985,0.0060286}, {990,0.0084286}, {995,0.0065143}, {1000,0.0071429}, {1010,0.0099143}, {1020,0.0069429}, {1030,0.0087714}, {1040,0.0054571}, {1050,0.0098571}, {1060,0.0046857}, {1070,0.0066286}, {1080,0.0058571}, {1090,0.0047714}, {1100,0.0073429}, {1110,0.0078571}, {1120,0.0052286}, {1130,0.0056571}, {1140,0.0089143}, {1150,0.0102286}, {1160,0.0071143}, {1170,0.0095143}, {1180,0.0075714}, {1190,0.0054286}, {1200,0.0075143}, {1210,0.0075714}, {1220,0.0126286}, {1230,0.0098571}, {1240,0.0056857}, {1250,0.0092286}, {1260,0.0077714}, {1270,0.0090286}, {1280,0.0066857}, {1290,0.0080000}, {1300,0.0065714}, {1310,0.0057143}, {1320,0.0054000}, {1330,0.0053714}, {1340,0.0091714}, {1350,0.0089143}, {1360,0.0119143}, {1370,0.0075143}, {1380,0.0095429}, {1390,0.0069714}, {1400,0.0079429}, {1410,0.0064286}, {1420,0.0108286}, {1430,0.0082286}, {1440,0.0092857}, {1450,0.0072571}, {1460,0.0116000}, {1470,0.0091429}, {1480,0.0089143}, {1490,0.0063429}, {1500,0.0120286}, {1510,0.0125143}, {1520,0.0138000}, {1530,0.0087429}, {1540,0.0091429}, {1550,0.0110286}, {1560,0.0110571}, {1570,0.0098571}, {1580,0.0178286}, {1590,0.0111143}, {1600,0.0112857}, {1610,0.0163143}, {1620,0.0142286}, {1630,0.0167143}, {1640,0.0132571}, {1650,0.0169714}, {1660,0.0173429}, {1670,0.0122286}, {1680,0.0120286}, {1690,0.0111714}, {1700,0.0238857}, {1710,0.0131714}, {1720,0.0168571}, {1730,0.0126857}, {1740,0.0136857}, {1750,0.0191143}, {1760,0.0190286}, {1770,0.0234286}, {1780,0.0142857}, {1790,0.0241429}, {1800,0.0215429}, {1810,0.0211143}, {1820,0.0218286}, {1830,0.0216000}, {1840,0.0260857}, {1850,0.0219429}, {1860,0.0211714}, {1870,0.0231143}, {1880,0.0204000}, {1890,0.0274571}, {1900,0.0254857}, {1910,0.0148000}, {1920,0.0229429}, {1930,0.0162000}, {1940,0.0294571}, {1950,0.0256571}, {1960,0.0133429}, {1970,0.0240857}, {1980,0.0231714}, {1990,0.0210571}, {2000,0.0216571}};
data["big"]["LtacTCPrimPair"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00100000}, {4,0.00100000}, {5,0.00131683}, {6,0.00200000}, {7,0.00200990}, {8,0.00300000}, {9,0.00300000}, {10,0.00330693}, {11,0.00400000}, {12,0.00423762}, {13,0.00500000}, {14,0.00520792}, {15,0.00574257}, {16,0.00614851}, {17,0.00681188}, {18,0.00717822}, {19,0.00778218}, {20,0.00911881}, {21,0.00889109}, {22,0.00959406}, {23,0.00992079}, {24,0.01073267}, {25,0.01094059}, {26,0.01171287}, {27,0.01230693}, {28,0.01611881}, {29,0.01351485}, {30,0.01397030}, {31,0.01462376}, {32,0.01512871}, {33,0.01571287}, {34,0.02036634}, {35,0.01685149}, {36,0.01782178}, {37,0.01835644}, {38,0.01905941}, {39,0.02273267}, {40,0.01983168}, {41,0.02115842}, {42,0.02170297}, {43,0.02265347}, {44,0.02343564}, {45,0.02403960}, {46,0.02497030}, {47,0.02566337}, {48,0.02659406}, {49,0.02678218}, {50,0.02697030}, {51,0.02884158}, {52,0.02964356}, {53,0.03049505}, {54,0.03130693}, {55,0.03303960}, {56,0.03298020}, {57,0.03353465}, {58,0.03481188}, {59,0.03443564}, {60,0.03981188}, {61,0.04276238}, {62,0.04442574}, {63,0.04490099}, {64,0.04364356}, {65,0.03995050}, {66,0.04193069}, {67,0.04268317}, {68,0.04375248}, {69,0.04838614}, {70,0.04512871}, {71,0.04708911}, {72,0.04655446}, {73,0.04861386}, {74,0.04855446}, {75,0.05039604}, {76,0.05131683}, {77,0.06210891}, {78,0.05379208}, {79,0.05461386}, {80,0.05584158}, {81,0.05611881}, {82,0.05704950}, {83,0.05824752}, {84,0.05884158}, {85,0.06037624}, {86,0.07695050}, {87,0.08115842}, {88,0.07351485}, {89,0.07766337}, {90,0.07758416}, {91,0.07621782}, {92,0.07623762}, {93,0.07627723}, {94,0.07682178}, {95,0.07783168}, {96,0.07839604}, {97,0.07856436}, {98,0.07914851}, {99,0.07943564}, {100,0.08135644}, {101,0.08220792}, {102,0.08304950}, {103,0.08440594}, {104,0.08379208}, {105,0.08563366}, {106,0.08717822}, {107,0.08845545}, {108,0.08960396}, {109,0.09124752}, {110,0.09184158}, {111,0.09379208}, {112,0.09569307}, {113,0.09748515}, {114,0.09869307}, {115,0.10103960}, {116,0.10106931}, {117,0.10304950}, {118,0.10518812}, {119,0.10732673}, {120,0.10886139}, {121,0.11070297}, {122,0.11193069}, {123,0.12400990}, {124,0.12667327}, {125,0.12903960}, {126,0.13259406}, {127,0.13541584}, {128,0.12202970}, {129,0.14438614}, {130,0.14679208}, {131,0.14721782}, {132,0.14907921}, {133,0.14884158}, {134,0.15363366}, {135,0.15560396}, {136,0.15821782}, {137,0.15737624}, {138,0.16273267}, {139,0.16237624}, {140,0.16531683}, {141,0.16890099}, {142,0.16959406}, {143,0.17337624}, {144,0.17389109}, {145,0.17494059}, {146,0.17724752}, {147,0.17792079}, {148,0.18135644}, {149,0.18396040}, {150,0.18528713}, {151,0.18611881}, {152,0.18652475}, {153,0.19359406}, {154,0.19530693}, {155,0.19662376}, {156,0.19960396}, {157,0.20100990}, {158,0.20122772}, {159,0.20507921}, {160,0.20715842}, {161,0.20950495}, {162,0.20925743}, {163,0.21413861}, {164,0.21495050}, {165,0.21951485}, {166,0.22018812}, {167,0.21975248}, {168,0.22650495}, {169,0.22852475}, {170,0.22967327}, {171,0.23482178}, {172,0.23552475}, {173,0.23823762}, {174,0.23867327}, {175,0.24041584}, {176,0.24578218}, {177,0.24829703}, {178,0.25244554}, {179,0.25561386}, {180,0.25484158}, {181,0.25918812}, {182,0.26204950}, {183,0.26603960}, {184,0.26769307}, {185,0.26884158}, {186,0.27030693}, {187,0.27316832}, {188,0.27390099}, {189,0.27551485}, {190,0.28648515}, {191,0.28942574}, {192,0.29257426}, {193,0.29377228}, {194,0.29429703}, {195,0.29291089}, {196,0.29453465}, {197,0.29850495}, {198,0.29945545}, {199,0.30133663}, {200,0.31087129}, {201,0.31658416}, {202,0.31352475}, {203,0.31401980}, {204,0.31802970}, {205,0.31972277}, {206,0.32658416}, {207,0.33781188}, {208,0.32535644}, {209,0.33237624}, {210,0.33411881}, {211,0.34315842}, {212,0.34950495}, {213,0.34333663}, {214,0.34415842}, {215,0.35467327}, {216,0.35769307}, {217,0.35526733}, {218,0.36388119}, {219,0.36922772}, {220,0.36692079}, {221,0.37051485}, {222,0.37915842}, {223,0.37839604}, {224,0.38444554}, {225,0.38523762}, {226,0.38728713}, {227,0.39468317}, {228,0.39197030}, {229,0.39800990}, {230,0.39874257}, {231,0.40806931}, {232,0.40677228}, {233,0.40868317}, {234,0.41316832}, {235,0.41903960}, {236,0.41955446}, {237,0.42589109}, {238,0.42462376}, {239,0.43499010}, {240,0.43116832}, {241,0.44552475}, {242,0.44058416}, {243,0.44680198}, {244,0.45028713}, {245,0.45141584}, {246,0.45688119}, {247,0.46476238}, {248,0.46186139}, {249,0.46917822}, {250,0.47783168}, {251,0.47548515}, {252,0.49111881}, {253,0.48686139}, {254,0.48148515}, {255,0.49088119}, {256,0.49529703}, {257,0.49526733}, {258,0.50029703}, {259,0.49977228}, {260,0.51055446}, {261,0.51462376}, {262,0.51092079}, {263,0.51658416}, {264,0.52073267}, {265,0.52249505}, {266,0.52974257}, {267,0.53555446}, {268,0.53721782}, {269,0.53890099}, {270,0.54397030}, {271,0.54962376}, {272,0.56637624}, {273,0.55621782}, {274,0.57696040}, {275,0.56541584}, {276,0.57059406}, {277,0.57823762}, {278,0.58355446}, {279,0.61886139}, {280,0.58354455}, {281,0.58546535}, {282,0.59106931}, {283,0.59644554}, {284,0.59955446}, {285,0.60207921}, {286,0.60630693}, {287,0.61708911}, {288,0.61703960}, {289,0.62069307}, {290,0.62747525}, {291,0.63994059}, {292,0.65014851}, {293,0.65699010}, {294,0.66044554}, {295,0.66748515}, {296,0.66951485}, {297,0.67238614}, {298,0.67477228}, {299,0.68293069}, {300,0.68857426}, {301,0.7111143}, {302,0.7557143}, {303,0.7380286}, {304,0.7471429}, {305,0.7244000}, {306,0.7280286}, {307,0.7392571}, {308,0.7428000}, {309,0.7448571}, {310,0.7490000}, {311,0.7534857}, {312,0.7607714}, {313,0.7645714}, {314,0.7723143}, {315,0.7740286}, {316,0.7752857}, {317,0.7800000}, {318,0.7891143}, {319,0.7960000}, {320,0.8092857}, {321,0.8024000}, {322,0.8069714}, {323,0.8142571}, {324,0.8135714}, {325,0.8208286}, {326,0.8296286}, {327,0.8368286}, {328,0.8384571}, {329,0.8460857}, {330,0.8467429}, {331,0.8568286}, {332,0.8571429}, {333,0.8630857}, {334,0.8686571}, {335,0.8727429}, {336,0.8821429}, {337,0.8823429}, {338,0.8914571}, {339,0.8920857}, {340,0.8974286}, {341,0.9028000}, {342,0.9176857}, {343,0.9202286}, {344,0.9324000}, {345,0.9531429}, {346,0.9450000}, {347,0.9410000}, {348,0.9508571}, {349,0.9494857}, {350,0.9620286}, {351,0.9717143}, {352,0.9700857}, {353,0.9746286}, {354,0.9801429}, {355,0.9916286}, {356,0.9883714}, {357,0.9973714}, {358,1.0022857}, {359,1.0038857}, {360,1.0062571}, {361,1.0406571}, {362,1.0247714}, {363,1.0282286}, {364,1.0368857}, {365,1.0375143}, {366,1.0425429}, {367,1.0485714}, {368,1.0626571}, {369,1.0834286}, {370,1.0716286}, {371,1.1001143}, {372,1.0849143}, {373,1.0906286}, {374,1.0925429}, {375,1.1081143}, {376,1.1117143}, {377,1.1128286}, {378,1.1648857}, {379,1.1273429}, {380,1.1511429}, {381,1.1356000}, {382,1.1640000}, {383,1.1555714}, {384,1.1802571}, {385,1.1712571}, {386,1.1976000}, {387,1.1856571}, {388,1.1948857}, {389,1.1940000}, {390,1.2034286}, {391,1.2089429}, {392,1.2663429}, {393,1.2194571}, {394,1.2312000}, {395,1.2366571}, {396,1.2683429}, {397,1.2525429}, {398,1.2788857}, {399,1.2810286}, {400,1.2925714}, {401,1.2718857}, {402,1.2857429}, {403,1.2874571}, {404,1.3169143}, {405,1.3025429}, {406,1.3119429}, {407,1.3443429}, {408,1.3303429}, {409,1.3289714}, {410,1.3382857}, {411,1.3428571}, {412,1.3424571}, {413,1.3502000}, {414,1.3608286}, {415,1.3934857}, {416,1.3717714}, {417,1.3761429}, {418,1.3831143}, {419,1.3875714}, {420,1.3982286}, {421,1.4064286}, {422,1.4134000}, {423,1.4226571}, {424,1.4282857}, {425,1.4335714}, {426,1.4424000}, {427,1.4511429}, {428,1.4624000}, {429,1.4760857}, {430,1.4960286}, {431,1.4892000}, {432,1.5080000}, {433,1.5117143}, {434,1.5189429}, {435,1.5296857}, {436,1.5385143}, {437,1.5475143}, {438,1.5515429}, {439,1.5635143}, {440,1.5707429}, {441,1.5814000}, {442,1.5882000}, {443,1.5917714}, {444,1.5998000}, {445,1.6120571}, {446,1.6201143}, {447,1.6260857}, {448,1.6339429}, {449,1.6368286}, {450,1.6526857}, {451,1.6637429}, {452,1.6634571}, {453,1.6732286}, {454,1.6792000}, {455,1.6929429}, {456,1.7213714}, {457,1.7118286}, {458,1.7376857}, {459,1.7289429}, {460,1.7254000}, {461,1.7376286}, {462,1.7467143}, {463,1.7558857}, {464,1.7718286}, {465,1.7636857}, {466,1.7892286}, {467,1.8203714}, {468,1.8205429}, {469,1.8116857}, {470,1.8133143}, {471,1.8214571}, {472,1.8301714}, {473,1.8317143}, {474,1.8512000}, {475,1.8546857}, {476,1.8553714}, {477,1.8596000}, {478,1.8760857}, {479,1.8855429}, {480,1.9258000}, {481,1.9056857}, {482,1.9182857}, {483,1.9327429}, {484,1.9347714}, {485,1.9572857}, {486,1.9554000}, {487,1.9937429}, {488,1.9669429}, {489,1.9705714}, {490,1.9672571}, {491,2.0004857}, {492,1.9952571}, {493,2.0311429}, {494,2.0372000}, {495,2.0391429}, {496,2.0814000}, {497,2.0451143}, {498,2.0600857}, {499,2.0716857}, {500,2.0779143}, {505,2.1227143}, {510,2.1649714}, {515,2.2479429}, {520,2.2598857}, {525,2.3143429}, {530,2.3538000}, {535,2.3914857}, {540,2.4642571}, {545,2.5252000}, {550,2.5822571}, {555,2.6268571}, {560,2.6883429}, {565,2.7513429}, {570,2.7818571}, {575,2.8536857}, {580,2.9048286}, {585,2.9627429}, {590,3.0481143}, {595,3.0661143}, {600,3.1284857}, {605,3.2171143}, {610,3.3256000}, {615,3.3677714}, {620,3.4317143}, {625,3.5432286}, {630,3.6471143}, {635,3.6280000}, {640,3.7026857}, {645,3.7790000}, {650,3.8055143}, {655,3.9719429}, {660,3.9097143}, {665,3.9535714}, {670,4.0099714}, {675,4.1988857}, {680,4.0750857}, {685,4.2616857}, {690,4.3235714}, {695,4.3337429}, {700,4.5523143}, {705,4.6393429}, {710,4.5486286}, {715,4.7075143}, {720,4.7810286}, {725,4.8292857}, {730,4.8306571}, {735,4.9398000}, {740,5.0441714}, {745,5.1287429}, {750,5.1730857}, {755,5.2528286}, {760,5.3627143}, {765,5.4561143}, {770,5.5516857}, {775,5.5902857}, {780,5.6977143}, {785,5.8222857}, {790,5.8723429}, {795,5.9850857}, {800,6.1362571}, {805,6.1661714}, {810,6.2652286}, {815,6.4172000}, {820,6.4506000}, {825,6.5878286}, {830,6.6560857}, {835,6.7470857}, {840,6.8429429}, {845,6.9388571}, {850,7.1262571}, {855,7.2934571}, {860,7.3025429}, {865,7.4604286}, {870,7.4776286}, {875,7.7447143}, {880,7.7950571}, {885,7.9360571}, {890,8.0648571}, {895,8.1373714}, {900,8.1964857}, {905,8.2849143}, {910,8.3670286}, {915,8.5963714}, {920,8.7188000}, {925,8.8025143}, {930,8.8921429}, {935,8.9610000}, {940,9.3062571}, {945,9.2933143}, {950,9.2779143}, {955,9.5651143}, {960,9.7910571}, {965,9.7984000}, {970,9.9329714}, {975,9.9945429}, {980,10.1219143}, {985,10.3693143}, {990,10.6311429}, {995,10.6007429}, {1000,11.0125143}, {1010,11.1209714}, {1020,11.4176286}, {1030,11.7170857}, {1040,12.1656571}, {1050,12.2710571}, {1060,12.4486286}, {1070,12.7430000}, {1080,13.3435429}, {1090,13.4104000}, {1100,13.7106000}, {1110,14.0973143}, {1120,14.4272571}, {1130,14.6485429}, {1140,15.2166000}, {1150,15.2860000}, {1160,15.7457143}, {1170,16.0918571}, {1180,16.5542000}, {1190,16.7128857}, {1200,17.4309143}, {1210,17.6047429}, {1220,18.0380571}, {1230,18.3248857}, {1240,19.0437143}, {1250,19.2026571}, {1260,19.7153714}, {1270,20.1519143}, {1280,20.5145429}, {1290,21.0230857}, {1300,21.1404857}, {1310,21.8643429}, {1320,22.1133429}, {1330,22.6239429}, {1340,23.3658857}, {1350,23.8765714}, {1360,24.3972286}, {1370,24.6816000}, {1380,25.2941714}, {1390,25.7792286}, {1400,26.0748571}, {1410,26.7992000}, {1420,27.2873143}, {1430,27.5612571}, {1440,28.2954000}, {1450,28.8932000}, {1460,28.9612286}, {1470,29.7090286}, {1480,30.5080857}, {1490,31.1295714}, {1500,31.5055143}, {1510,32.2796857}, {1520,32.9335714}, {1530,33.5805714}, {1540,33.8472857}, {1550,34.6915714}, {1560,35.2874857}, {1570,36.1131429}, {1580,36.0482857}, {1590,37.0056286}, {1600,37.8906000}, {1610,38.1450857}, {1620,39.1708000}, {1630,39.4186857}, {1640,40.0975714}, {1650,40.6074000}, {1660,41.5207714}, {1670,42.2417429}, {1680,43.2728857}, {1690,44.0454571}, {1700,44.9683429}, {1710,45.3027429}, {1720,46.3501429}, {1730,46.9498286}, {1740,47.4282857}, {1750,48.0583429}, {1760,49.0482286}, {1770,49.5618286}, {1780,50.7109714}, {1790,51.2301143}, {1800,52.0064571}, {1810,52.8687714}, {1820,53.5114286}, {1830,54.5767429}, {1840,55.1408857}, {1850,56.3315429}, {1860,56.9167143}, {1870,58.2816000}, {1880,59.2275714}, {1890,60.1082857}, {1900,61.5700286}, {1910,62.2407714}, {1920,63.4798286}, {1930,63.7877429}, {1940,64.2169714}, {1950,65.1935714}, {1960,66.0815714}, {1970,67.0714571}, {1980,67.6705714}, {1990,69.2350000}, {2000,69.7110000}};
data["big"]["LtacTCPrimPair"]["actual reif"]["user"] = {{1,0.00054455}, {2,0.00092079}, {3,0.00109901}, {4,0.00161386}, {5,0.00195050}, {6,0.00224752}, {7,0.00292079}, {8,0.00327723}, {9,0.00342574}, {10,0.00374257}, {11,0.00412871}, {12,0.00474257}, {13,0.00474257}, {14,0.00592079}, {15,0.00583168}, {16,0.00632673}, {17,0.00709901}, {18,0.00719802}, {19,0.00802970}, {20,0.00925743}, {21,0.00871287}, {22,0.00922772}, {23,0.01016832}, {24,0.01035644}, {25,0.01072277}, {26,0.01162376}, {27,0.01229703}, {28,0.01573267}, {29,0.01328713}, {30,0.01373267}, {31,0.01465347}, {32,0.01484158}, {33,0.01562376}, {34,0.02013861}, {35,0.01646535}, {36,0.01772277}, {37,0.01784158}, {38,0.01879208}, {39,0.02268317}, {40,0.01948515}, {41,0.02095050}, {42,0.02180198}, {43,0.02296040}, {44,0.02366337}, {45,0.02426733}, {46,0.02505941}, {47,0.02598020}, {48,0.02694059}, {49,0.02674257}, {50,0.02744554}, {51,0.02910891}, {52,0.02979208}, {53,0.03048515}, {54,0.03156436}, {55,0.03298020}, {56,0.03281188}, {57,0.03350495}, {58,0.03468317}, {59,0.03425743}, {60,0.03949505}, {61,0.04251485}, {62,0.04418812}, {63,0.04443564}, {64,0.04323762}, {65,0.03969307}, {66,0.04167327}, {67,0.04211881}, {68,0.04324752}, {69,0.04884158}, {70,0.04503960}, {71,0.04701980}, {72,0.04677228}, {73,0.04877228}, {74,0.04924752}, {75,0.05027723}, {76,0.05139604}, {77,0.06175248}, {78,0.05410891}, {79,0.05435644}, {80,0.05578218}, {81,0.05602970}, {82,0.05696040}, {83,0.05827723}, {84,0.05879208}, {85,0.06011881}, {86,0.07663366}, {87,0.08130693}, {88,0.07373267}, {89,0.07802970}, {90,0.07768317}, {91,0.07628713}, {92,0.07670297}, {93,0.07640594}, {94,0.07713861}, {95,0.07801980}, {96,0.07853465}, {97,0.07842574}, {98,0.07883168}, {99,0.07934653}, {100,0.08136634}, {101,0.08191089}, {102,0.08298020}, {103,0.08404950}, {104,0.08359406}, {105,0.08537624}, {106,0.08700000}, {107,0.08821782}, {108,0.08911881}, {109,0.09099010}, {110,0.09116832}, {111,0.09368317}, {112,0.09521782}, {113,0.09745545}, {114,0.09884158}, {115,0.10100000}, {116,0.10110891}, {117,0.10324752}, {118,0.10492079}, {119,0.10692079}, {120,0.10855446}, {121,0.11025743}, {122,0.11155446}, {123,0.12397030}, {124,0.12630693}, {125,0.12867327}, {126,0.13231683}, {127,0.13461386}, {128,0.12219802}, {129,0.14404950}, {130,0.14680198}, {131,0.14707921}, {132,0.14880198}, {133,0.14848515}, {134,0.15350495}, {135,0.15514851}, {136,0.15785149}, {137,0.15690099}, {138,0.16203960}, {139,0.16212871}, {140,0.16518812}, {141,0.16885149}, {142,0.16914851}, {143,0.17329703}, {144,0.17396040}, {145,0.17462376}, {146,0.17652475}, {147,0.17751485}, {148,0.18100990}, {149,0.18337624}, {150,0.18487129}, {151,0.18566337}, {152,0.18591089}, {153,0.19316832}, {154,0.19492079}, {155,0.19633663}, {156,0.19912871}, {157,0.20059406}, {158,0.20062376}, {159,0.20504950}, {160,0.20669307}, {161,0.20913861}, {162,0.20876238}, {163,0.21371287}, {164,0.21458416}, {165,0.21903960}, {166,0.21997030}, {167,0.21961386}, {168,0.22618812}, {169,0.22777228}, {170,0.22903960}, {171,0.23433663}, {172,0.23490099}, {173,0.23769307}, {174,0.23807921}, {175,0.23989109}, {176,0.24514851}, {177,0.24787129}, {178,0.25189109}, {179,0.25512871}, {180,0.25454455}, {181,0.25872277}, {182,0.26168317}, {183,0.26568317}, {184,0.26690099}, {185,0.26840594}, {186,0.26953465}, {187,0.27272277}, {188,0.27293069}, {189,0.27474257}, {190,0.28567327}, {191,0.28878218}, {192,0.29201980}, {193,0.29302970}, {194,0.29374257}, {195,0.29245545}, {196,0.29412871}, {197,0.29811881}, {198,0.29896040}, {199,0.30059406}, {200,0.31036634}, {201,0.31605941}, {202,0.31290099}, {203,0.31329703}, {204,0.31733663}, {205,0.31920792}, {206,0.32604950}, {207,0.33727723}, {208,0.32489109}, {209,0.33172277}, {210,0.33351485}, {211,0.34240594}, {212,0.34888119}, {213,0.34308911}, {214,0.34337624}, {215,0.35433663}, {216,0.35700990}, {217,0.35445545}, {218,0.36309901}, {219,0.36833663}, {220,0.36632673}, {221,0.36979208}, {222,0.37852475}, {223,0.37774257}, {224,0.38412871}, {225,0.38469307}, {226,0.38599010}, {227,0.39394059}, {228,0.39137624}, {229,0.39727723}, {230,0.39808911}, {231,0.40726733}, {232,0.40586139}, {233,0.40807921}, {234,0.41238614}, {235,0.41834653}, {236,0.41858416}, {237,0.42454455}, {238,0.42404950}, {239,0.43348515}, {240,0.43076238}, {241,0.44468317}, {242,0.43972277}, {243,0.44561386}, {244,0.44913861}, {245,0.45007921}, {246,0.45598020}, {247,0.46413861}, {248,0.46071287}, {249,0.46826733}, {250,0.47666337}, {251,0.47440594}, {252,0.48989109}, {253,0.48617822}, {254,0.48064356}, {255,0.49013861}, {256,0.49436634}, {257,0.49461386}, {258,0.49952475}, {259,0.49901980}, {260,0.50972277}, {261,0.51377228}, {262,0.51028713}, {263,0.51569307}, {264,0.51996040}, {265,0.52137624}, {266,0.52898020}, {267,0.53504950}, {268,0.53615842}, {269,0.53768317}, {270,0.54326733}, {271,0.54873267}, {272,0.56552475}, {273,0.55566337}, {274,0.57620792}, {275,0.56443564}, {276,0.56971287}, {277,0.57768317}, {278,0.58295050}, {279,0.61815842}, {280,0.58216832}, {281,0.58432673}, {282,0.58984158}, {283,0.59548515}, {284,0.59890099}, {285,0.60142574}, {286,0.60511881}, {287,0.61565347}, {288,0.61590099}, {289,0.61975248}, {290,0.62680198}, {291,0.63888119}, {292,0.64907921}, {293,0.65574257}, {294,0.65935644}, {295,0.66647525}, {296,0.66812871}, {297,0.67099010}, {298,0.67320792}, {299,0.68189109}, {300,0.68731683}, {301,0.7104857}, {302,0.7518000}, {303,0.7368571}, {304,0.7459143}, {305,0.7235143}, {306,0.7265143}, {307,0.7379714}, {308,0.7420286}, {309,0.7438286}, {310,0.7481143}, {311,0.7524000}, {312,0.7602571}, {313,0.7642286}, {314,0.7714000}, {315,0.7732000}, {316,0.7744857}, {317,0.7792857}, {318,0.7878857}, {319,0.7950286}, {320,0.8036000}, {321,0.8015429}, {322,0.8050857}, {323,0.8125143}, {324,0.8126286}, {325,0.8194571}, {326,0.8287143}, {327,0.8320000}, {328,0.8366857}, {329,0.8445143}, {330,0.8454286}, {331,0.8539429}, {332,0.8561714}, {333,0.8604286}, {334,0.8668286}, {335,0.8691143}, {336,0.8753429}, {337,0.8815429}, {338,0.8897143}, {339,0.8911429}, {340,0.8966000}, {341,0.9021429}, {342,0.9163714}, {343,0.9188286}, {344,0.9309143}, {345,0.9523143}, {346,0.9444571}, {347,0.9398857}, {348,0.9496571}, {349,0.9484857}, {350,0.9606857}, {351,0.9704571}, {352,0.9691429}, {353,0.9736857}, {354,0.9796857}, {355,0.9905143}, {356,0.9869714}, {357,0.9966286}, {358,1.0021714}, {359,1.0031429}, {360,1.0054571}, {361,1.0396000}, {362,1.0239429}, {363,1.0269143}, {364,1.0352000}, {365,1.0364857}, {366,1.0410000}, {367,1.0471143}, {368,1.0610571}, {369,1.0821429}, {370,1.0709429}, {371,1.0987714}, {372,1.0844000}, {373,1.0891143}, {374,1.0912286}, {375,1.1068857}, {376,1.1103429}, {377,1.1114286}, {378,1.1623143}, {379,1.1256857}, {380,1.1494857}, {381,1.1334000}, {382,1.1624286}, {383,1.1534571}, {384,1.1783714}, {385,1.1689714}, {386,1.1960571}, {387,1.1838571}, {388,1.1930857}, {389,1.1919714}, {390,1.2020571}, {391,1.2063143}, {392,1.2651429}, {393,1.2174000}, {394,1.2294571}, {395,1.2355143}, {396,1.2668571}, {397,1.2509143}, {398,1.2764857}, {399,1.2790857}, {400,1.2902571}, {401,1.2694286}, {402,1.2838571}, {403,1.2856571}, {404,1.3137714}, {405,1.2990571}, {406,1.3080571}, {407,1.3370286}, {408,1.3278286}, {409,1.3257143}, {410,1.3366000}, {411,1.3398571}, {412,1.3398286}, {413,1.3476000}, {414,1.3586286}, {415,1.3914286}, {416,1.3701143}, {417,1.3736286}, {418,1.3806000}, {419,1.3854571}, {420,1.3958857}, {421,1.4045714}, {422,1.4112000}, {423,1.4204000}, {424,1.4258286}, {425,1.4312857}, {426,1.4397143}, {427,1.4488857}, {428,1.4589429}, {429,1.4737143}, {430,1.4932571}, {431,1.4859714}, {432,1.5044000}, {433,1.5086571}, {434,1.5164857}, {435,1.5270571}, {436,1.5353429}, {437,1.5451143}, {438,1.5486286}, {439,1.5603143}, {440,1.5669714}, {441,1.5777429}, {442,1.5855143}, {443,1.5882000}, {444,1.5961714}, {445,1.6089143}, {446,1.6162857}, {447,1.6230571}, {448,1.6301714}, {449,1.6340857}, {450,1.6490286}, {451,1.6608571}, {452,1.6608857}, {453,1.6706286}, {454,1.6768286}, {455,1.6900286}, {456,1.7182286}, {457,1.7080286}, {458,1.7342286}, {459,1.7258857}, {460,1.7222286}, {461,1.7348286}, {462,1.7440000}, {463,1.7530286}, {464,1.7689143}, {465,1.7609714}, {466,1.7863429}, {467,1.8178857}, {468,1.8185429}, {469,1.8087714}, {470,1.8110286}, {471,1.8171714}, {472,1.8261429}, {473,1.8280286}, {474,1.8462857}, {475,1.8510857}, {476,1.8512857}, {477,1.8556857}, {478,1.8733714}, {479,1.8806857}, {480,1.9212286}, {481,1.9013429}, {482,1.9139714}, {483,1.9279143}, {484,1.9301143}, {485,1.9516286}, {486,1.9497429}, {487,1.9877143}, {488,1.9613714}, {489,1.9661143}, {490,1.9627429}, {491,1.9965714}, {492,1.9906000}, {493,2.0265429}, {494,2.0328000}, {495,2.0344286}, {496,2.0772571}, {497,2.0414857}, {498,2.0561429}, {499,2.0669429}, {500,2.0738571}, {505,2.1178571}, {510,2.1603143}, {515,2.2412857}, {520,2.2538571}, {525,2.3070857}, {530,2.3475429}, {535,2.3859714}, {540,2.4572000}, {545,2.5181143}, {550,2.5742000}, {555,2.6180286}, {560,2.6802571}, {565,2.7426000}, {570,2.7742571}, {575,2.8463143}, {580,2.8968571}, {585,2.9550000}, {590,3.0406571}, {595,3.0585429}, {600,3.1208000}, {605,3.2094857}, {610,3.3184571}, {615,3.3593143}, {620,3.4246857}, {625,3.5353714}, {630,3.6394286}, {635,3.6194857}, {640,3.6947714}, {645,3.7709714}, {650,3.8005714}, {655,3.9674857}, {660,3.9058000}, {665,3.9490286}, {670,4.0038000}, {675,4.1938000}, {680,4.0710857}, {685,4.2547714}, {690,4.3153714}, {695,4.3283429}, {700,4.5454571}, {705,4.6329143}, {710,4.5427429}, {715,4.6988571}, {720,4.7717143}, {725,4.8204857}, {730,4.8187143}, {735,4.9293143}, {740,5.0347714}, {745,5.1196000}, {750,5.1658571}, {755,5.2449143}, {760,5.3545429}, {765,5.4463714}, {770,5.5413714}, {775,5.5818286}, {780,5.6876857}, {785,5.8141429}, {790,5.8627714}, {795,5.9736286}, {800,6.1196286}, {805,6.1503429}, {810,6.2460571}, {815,6.3972571}, {820,6.4350571}, {825,6.5702571}, {830,6.6397143}, {835,6.7294857}, {840,6.8286571}, {845,6.9251714}, {850,7.1141429}, {855,7.2798286}, {860,7.2885714}, {865,7.4473714}, {870,7.4656857}, {875,7.7300571}, {880,7.7846286}, {885,7.9302000}, {890,8.0576571}, {895,8.1296286}, {900,8.1874571}, {905,8.2730286}, {910,8.3526286}, {915,8.5777714}, {920,8.7024000}, {925,8.7880286}, {930,8.8778000}, {935,8.9453714}, {940,9.2889143}, {945,9.2763143}, {950,9.2647143}, {955,9.5513143}, {960,9.7805143}, {965,9.7798571}, {970,9.9078571}, {975,9.9707143}, {980,10.0975714}, {985,10.3482286}, {990,10.6014857}, {995,10.5727429}, {1000,10.9861429}, {1010,11.0874000}, {1020,11.3867143}, {1030,11.6858000}, {1040,12.1391143}, {1050,12.2376571}, {1060,12.4251429}, {1070,12.7259429}, {1080,13.3200000}, {1090,13.3941429}, {1100,13.6914286}, {1110,14.0713429}, {1120,14.3972571}, {1130,14.6264571}, {1140,15.1618000}, {1150,15.2610571}, {1160,15.7240286}, {1170,16.0665714}, {1180,16.5295714}, {1190,16.6924571}, {1200,17.4113714}, {1210,17.5821714}, {1220,18.0079429}, {1230,18.2925714}, {1240,19.0174000}, {1250,19.1653714}, {1260,19.6819143}, {1270,20.1127143}, {1280,20.4790000}, {1290,20.9865429}, {1300,21.1167714}, {1310,21.8410286}, {1320,22.0943429}, {1330,22.5988857}, {1340,23.3403714}, {1350,23.8433429}, {1360,24.3626000}, {1370,24.6478857}, {1380,25.2581429}, {1390,25.7538000}, {1400,26.0453429}, {1410,26.7719143}, {1420,27.2547143}, {1430,27.5319714}, {1440,28.2698286}, {1450,28.8496571}, {1460,28.9140286}, {1470,29.6721143}, {1480,30.4728286}, {1490,31.0945143}, {1500,31.4709429}, {1510,32.2459714}, {1520,32.8822000}, {1530,33.5452286}, {1540,33.8103143}, {1550,34.6515714}, {1560,35.2465714}, {1570,36.0803143}, {1580,35.9906857}, {1590,36.9623143}, {1600,37.8340000}, {1610,38.0999429}, {1620,39.1276286}, {1630,39.3671143}, {1640,40.0503714}, {1650,40.5555714}, {1660,41.4712000}, {1670,42.1936000}, {1680,43.2205714}, {1690,43.9917429}, {1700,44.9042857}, {1710,45.2532000}, {1720,46.3035429}, {1730,46.8834286}, {1740,47.3660857}, {1750,47.9998286}, {1760,48.9884571}, {1770,49.4945714}, {1780,50.6476000}, {1790,51.1696571}, {1800,51.9636857}, {1810,52.8256000}, {1820,53.4690857}, {1830,54.5252286}, {1840,55.0566286}, {1850,56.2598000}, {1860,56.8525143}, {1870,58.1906000}, {1880,59.1705143}, {1890,60.0216857}, {1900,61.4898286}, {1910,62.1927143}, {1920,63.4330286}, {1930,63.7358000}, {1940,64.1465143}, {1950,65.1285714}, {1960,66.0507429}, {1970,67.0276571}, {1980,67.6281143}, {1990,69.2010000}, {2000,69.6748000}};
data["big"]["LtacTCPrimPair"]["actual reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00007921}, {7,0.00003960}, {8,0.00000000}, {9,0.00000000}, {10,0.00007921}, {11,0.00003960}, {12,0.00011881}, {13,0.00007921}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00006931}, {18,0.00011881}, {19,0.00000000}, {20,0.00003960}, {21,0.00007921}, {22,0.00003960}, {23,0.00000000}, {24,0.00011881}, {25,0.00000000}, {26,0.00007921}, {27,0.00003960}, {28,0.00007921}, {29,0.00003960}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00003960}, {35,0.00011881}, {36,0.00003960}, {37,0.00000000}, {38,0.00003960}, {39,0.00007921}, {40,0.00000000}, {41,0.00000000}, {42,0.00003960}, {43,0.00000000}, {44,0.00007921}, {45,0.00007921}, {46,0.00000000}, {47,0.00002970}, {48,0.00007921}, {49,0.00003960}, {50,0.00000000}, {51,0.00007921}, {52,0.00002970}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00003960}, {57,0.00000000}, {58,0.00015842}, {59,0.00007921}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00003960}, {64,0.00000000}, {65,0.00003960}, {66,0.00000000}, {67,0.00007921}, {68,0.00000000}, {69,0.00000000}, {70,0.00003960}, {71,0.00000000}, {72,0.00003960}, {73,0.00000000}, {74,0.00003960}, {75,0.00003960}, {76,0.00003960}, {77,0.00003960}, {78,0.00003960}, {79,0.00003960}, {80,0.00003960}, {81,0.00002970}, {82,0.00000000}, {83,0.00003960}, {84,0.00003960}, {85,0.00000000}, {86,0.00002970}, {87,0.00000000}, {88,0.00000000}, {89,0.00007921}, {90,0.00003960}, {91,0.00000000}, {92,0.00003960}, {93,0.00000000}, {94,0.00003960}, {95,0.00003960}, {96,0.00000000}, {97,0.00007921}, {98,0.00003960}, {99,0.00000000}, {100,0.00000000}, {101,0.00007921}, {102,0.00003960}, {103,0.00003960}, {104,0.00003960}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00003960}, {111,0.00003960}, {112,0.00011881}, {113,0.00015842}, {114,0.00007921}, {115,0.00015842}, {116,0.00007921}, {117,0.00007921}, {118,0.00003960}, {119,0.00006931}, {120,0.00003960}, {121,0.00003960}, {122,0.00003960}, {123,0.00000000}, {124,0.00003960}, {125,0.00000000}, {126,0.00003960}, {127,0.00003960}, {128,0.00003960}, {129,0.00003960}, {130,0.00003960}, {131,0.00000000}, {132,0.00003960}, {133,0.00003960}, {134,0.00003960}, {135,0.00003960}, {136,0.00003960}, {137,0.00000000}, {138,0.00007921}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00003960}, {144,0.00002970}, {145,0.00007921}, {146,0.00006931}, {147,0.00003960}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00003960}, {153,0.00000000}, {154,0.00003960}, {155,0.00000000}, {156,0.00003960}, {157,0.00003960}, {158,0.00003960}, {159,0.00000000}, {160,0.00003960}, {161,0.00000000}, {162,0.00011881}, {163,0.00007921}, {164,0.00003960}, {165,0.00003960}, {166,0.00007921}, {167,0.00000000}, {168,0.00003960}, {169,0.00003960}, {170,0.00003960}, {171,0.00003960}, {172,0.00007921}, {173,0.00000000}, {174,0.00007921}, {175,0.00000000}, {176,0.00000000}, {177,0.00003960}, {178,0.00007921}, {179,0.00000000}, {180,0.00000000}, {181,0.00003960}, {182,0.00003960}, {183,0.00000000}, {184,0.00000000}, {185,0.00007921}, {186,0.00003960}, {187,0.00003960}, {188,0.00007921}, {189,0.00003960}, {190,0.00007921}, {191,0.00003960}, {192,0.00007921}, {193,0.00007921}, {194,0.00003960}, {195,0.00003960}, {196,0.00003960}, {197,0.00003960}, {198,0.00000000}, {199,0.00011881}, {200,0.00003960}, {201,0.00000000}, {202,0.00000000}, {203,0.00007921}, {204,0.00011881}, {205,0.00000000}, {206,0.00003960}, {207,0.00000000}, {208,0.00007921}, {209,0.00007921}, {210,0.00007921}, {211,0.00003960}, {212,0.00000000}, {213,0.00003960}, {214,0.00003960}, {215,0.00003960}, {216,0.00000000}, {217,0.00007921}, {218,0.00011881}, {219,0.00023762}, {220,0.00011881}, {221,0.00003960}, {222,0.00003960}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00011881}, {227,0.00002970}, {228,0.00007921}, {229,0.00011881}, {230,0.00010891}, {231,0.00007921}, {232,0.00015842}, {233,0.00000000}, {234,0.00007921}, {235,0.00000000}, {236,0.00007921}, {237,0.00047525}, {238,0.00003960}, {239,0.00035644}, {240,0.00003960}, {241,0.00000000}, {242,0.00011881}, {243,0.00007921}, {244,0.00000000}, {245,0.00031683}, {246,0.00007921}, {247,0.00003960}, {248,0.00007921}, {249,0.00003960}, {250,0.00007921}, {251,0.00011881}, {252,0.00015842}, {253,0.00000000}, {254,0.00007921}, {255,0.00007921}, {256,0.00003960}, {257,0.00000000}, {258,0.00011881}, {259,0.00000000}, {260,0.00000000}, {261,0.00007921}, {262,0.00000000}, {263,0.00003960}, {264,0.00003960}, {265,0.00003960}, {266,0.00003960}, {267,0.00007921}, {268,0.00003960}, {269,0.00015842}, {270,0.00015842}, {271,0.00003960}, {272,0.00015842}, {273,0.00000000}, {274,0.00007921}, {275,0.00015842}, {276,0.00011881}, {277,0.00000000}, {278,0.00015842}, {279,0.00011881}, {280,0.00007921}, {281,0.00011881}, {282,0.00007921}, {283,0.00007921}, {284,0.00003960}, {285,0.00000000}, {286,0.00007921}, {287,0.00011881}, {288,0.00003960}, {289,0.00011881}, {290,0.00000000}, {291,0.00007921}, {292,0.00011881}, {293,0.00007921}, {294,0.00023762}, {295,0.00003960}, {296,0.00019802}, {297,0.00007921}, {298,0.00007921}, {299,0.00003960}, {300,0.00011881}, {301,0.0001143}, {302,0.0002286}, {303,0.0003429}, {304,0.0002286}, {305,0.0001143}, {306,0.0002286}, {307,0.0003143}, {308,0.0000000}, {309,0.0002000}, {310,0.0002286}, {311,0.0000000}, {312,0.0001143}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0002286}, {317,0.0000000}, {318,0.0001143}, {319,0.0000000}, {320,0.0002286}, {321,0.0000000}, {322,0.0001143}, {323,0.0004571}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0002286}, {330,0.0001143}, {331,0.0002286}, {332,0.0000000}, {333,0.0001143}, {334,0.0000000}, {335,0.0004571}, {336,0.0003429}, {337,0.0000000}, {338,0.0003429}, {339,0.0003429}, {340,0.0000000}, {341,0.0001143}, {342,0.0002286}, {343,0.0001143}, {344,0.0001143}, {345,0.0000000}, {346,0.0000000}, {347,0.0002286}, {348,0.0004571}, {349,0.0001143}, {350,0.0002286}, {351,0.0000000}, {352,0.0001143}, {353,0.0002286}, {354,0.0000000}, {355,0.0002286}, {356,0.0002286}, {357,0.0000000}, {358,0.0000000}, {359,0.0001143}, {360,0.0000000}, {361,0.0001143}, {362,0.0001143}, {363,0.0000000}, {364,0.0001143}, {365,0.0001143}, {366,0.0001143}, {367,0.0002286}, {368,0.0000000}, {369,0.0002286}, {370,0.0000000}, {371,0.0003429}, {372,0.0000000}, {373,0.0004571}, {374,0.0002286}, {375,0.0001143}, {376,0.0000000}, {377,0.0002286}, {378,0.0003429}, {379,0.0001143}, {380,0.0001143}, {381,0.0005714}, {382,0.0001143}, {383,0.0004571}, {384,0.0002286}, {385,0.0004571}, {386,0.0003429}, {387,0.0001143}, {388,0.0002286}, {389,0.0001143}, {390,0.0001143}, {391,0.0002286}, {392,0.0002286}, {393,0.0001143}, {394,0.0002286}, {395,0.0001143}, {396,0.0000000}, {397,0.0002286}, {398,0.0004571}, {399,0.0001143}, {400,0.0004571}, {401,0.0006857}, {402,0.0002286}, {403,0.0001143}, {404,0.0000000}, {405,0.0004571}, {406,0.0001143}, {407,0.0002286}, {408,0.0001143}, {409,0.0000000}, {410,0.0000000}, {411,0.0001143}, {412,0.0002286}, {413,0.0001143}, {414,0.0002286}, {415,0.0001143}, {416,0.0001143}, {417,0.0003429}, {418,0.0002286}, {419,0.0000000}, {420,0.0000000}, {421,0.0001143}, {422,0.0001143}, {423,0.0002286}, {424,0.0000000}, {425,0.0002286}, {426,0.0002286}, {427,0.0003429}, {428,0.0005714}, {429,0.0001143}, {430,0.0002286}, {431,0.0003429}, {432,0.0006571}, {433,0.0001143}, {434,0.0004571}, {435,0.0001143}, {436,0.0001143}, {437,0.0002286}, {438,0.0004571}, {439,0.0000000}, {440,0.0002286}, {441,0.0001143}, {442,0.0000000}, {443,0.0003429}, {444,0.0005714}, {445,0.0002286}, {446,0.0005429}, {447,0.0003429}, {448,0.0003429}, {449,0.0002286}, {450,0.0003429}, {451,0.0001143}, {452,0.0000000}, {453,0.0000000}, {454,0.0002286}, {455,0.0000000}, {456,0.0002286}, {457,0.0005714}, {458,0.0002000}, {459,0.0002286}, {460,0.0003429}, {461,0.0003429}, {462,0.0004571}, {463,0.0005714}, {464,0.0001143}, {465,0.0006857}, {466,0.0005714}, {467,0.0005714}, {468,0.0002286}, {469,0.0004571}, {470,0.0003429}, {471,0.0006857}, {472,0.0004571}, {473,0.0009143}, {474,0.0012571}, {475,0.0004571}, {476,0.0001143}, {477,0.0001143}, {478,0.0003429}, {479,0.0012286}, {480,0.0006857}, {481,0.0002286}, {482,0.0003429}, {483,0.0004571}, {484,0.0002286}, {485,0.0009143}, {486,0.0002286}, {487,0.0014857}, {488,0.0002286}, {489,0.0000000}, {490,0.0002286}, {491,0.0002286}, {492,0.0000000}, {493,0.0005714}, {494,0.0004571}, {495,0.0001143}, {496,0.0000000}, {497,0.0000000}, {498,0.0002286}, {499,0.0000000}, {500,0.0004571}, {505,0.0008000}, {510,0.0001143}, {515,0.0010286}, {520,0.0002286}, {525,0.0008000}, {530,0.0013714}, {535,0.0004571}, {540,0.0009143}, {545,0.0002286}, {550,0.0005714}, {555,0.0013714}, {560,0.0009143}, {565,0.0018286}, {570,0.0013714}, {575,0.0002286}, {580,0.0006857}, {585,0.0002286}, {590,0.0005714}, {595,0.0006857}, {600,0.0006857}, {605,0.0009143}, {610,0.0012571}, {615,0.0019429}, {620,0.0009143}, {625,0.0011429}, {630,0.0004571}, {635,0.0016857}, {640,0.0010286}, {645,0.0022571}, {650,0.0009143}, {655,0.0016857}, {660,0.0010286}, {665,0.0016000}, {670,0.0013714}, {675,0.0009143}, {680,0.0005714}, {685,0.0015714}, {690,0.0018286}, {695,0.0006571}, {700,0.0021714}, {705,0.0033143}, {710,0.0028571}, {715,0.0038857}, {720,0.0035429}, {725,0.0017143}, {730,0.0040000}, {735,0.0044571}, {740,0.0048000}, {745,0.0035429}, {750,0.0033143}, {755,0.0024000}, {760,0.0036286}, {765,0.0050857}, {770,0.0039714}, {775,0.0021714}, {780,0.0038857}, {785,0.0027143}, {790,0.0043429}, {795,0.0050286}, {800,0.0057143}, {805,0.0046571}, {810,0.0053714}, {815,0.0062571}, {820,0.0059143}, {825,0.0079714}, {830,0.0072857}, {835,0.0057714}, {840,0.0061429}, {845,0.0064857}, {850,0.0045714}, {855,0.0054857}, {860,0.0067143}, {865,0.0066286}, {870,0.0056857}, {875,0.0099429}, {880,0.0058000}, {885,0.0039429}, {890,0.0051143}, {895,0.0043429}, {900,0.0045429}, {905,0.0065143}, {910,0.0053143}, {915,0.0062571}, {920,0.0068571}, {925,0.0057143}, {930,0.0068000}, {935,0.0058857}, {940,0.0056571}, {945,0.0085429}, {950,0.0061143}, {955,0.0081143}, {960,0.0040000}, {965,0.0091429}, {970,0.0112286}, {975,0.0093143}, {980,0.0093429}, {985,0.0060286}, {990,0.0082000}, {995,0.0065143}, {1000,0.0069429}, {1010,0.0099143}, {1020,0.0069429}, {1030,0.0087714}, {1040,0.0054571}, {1050,0.0096286}, {1060,0.0045429}, {1070,0.0066286}, {1080,0.0057429}, {1090,0.0047714}, {1100,0.0073429}, {1110,0.0076286}, {1120,0.0050286}, {1130,0.0056571}, {1140,0.0089143}, {1150,0.0102286}, {1160,0.0071143}, {1170,0.0094000}, {1180,0.0075714}, {1190,0.0053143}, {1200,0.0073143}, {1210,0.0075714}, {1220,0.0125143}, {1230,0.0096571}, {1240,0.0056857}, {1250,0.0090857}, {1260,0.0076571}, {1270,0.0089143}, {1280,0.0066857}, {1290,0.0080000}, {1300,0.0064000}, {1310,0.0055714}, {1320,0.0054000}, {1330,0.0053714}, {1340,0.0090857}, {1350,0.0089143}, {1360,0.0119143}, {1370,0.0075143}, {1380,0.0093429}, {1390,0.0068857}, {1400,0.0078286}, {1410,0.0062571}, {1420,0.0107143}, {1430,0.0080000}, {1440,0.0090571}, {1450,0.0072571}, {1460,0.0114857}, {1470,0.0091429}, {1480,0.0088000}, {1490,0.0063429}, {1500,0.0119429}, {1510,0.0120857}, {1520,0.0138000}, {1530,0.0087429}, {1540,0.0089429}, {1550,0.0110286}, {1560,0.0110571}, {1570,0.0096286}, {1580,0.0177429}, {1590,0.0108286}, {1600,0.0110857}, {1610,0.0162000}, {1620,0.0142286}, {1630,0.0167143}, {1640,0.0128857}, {1650,0.0168857}, {1660,0.0169714}, {1670,0.0122286}, {1680,0.0120286}, {1690,0.0110571}, {1700,0.0237714}, {1710,0.0131714}, {1720,0.0167714}, {1730,0.0126857}, {1740,0.0136857}, {1750,0.0190000}, {1760,0.0190286}, {1770,0.0234286}, {1780,0.0142857}, {1790,0.0240286}, {1800,0.0214571}, {1810,0.0210286}, {1820,0.0218286}, {1830,0.0216000}, {1840,0.0260000}, {1850,0.0219429}, {1860,0.0210571}, {1870,0.0231143}, {1880,0.0204000}, {1890,0.0274571}, {1900,0.0253714}, {1910,0.0145714}, {1920,0.0229429}, {1930,0.0159714}, {1940,0.0292571}, {1950,0.0255429}, {1960,0.0133429}, {1970,0.0240857}, {1980,0.0230571}, {1990,0.0208000}, {2000,0.0216571}};
data["big"]["LtacTCPrimPair"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00047525}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00338614}, {292,0.00269307}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0023429}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000286}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000286}, {565,0.0000000}, {570,0.0001143}, {575,0.0001429}, {580,0.0002857}, {585,0.0004000}, {590,0.0003714}, {595,0.0006286}, {600,0.0004571}, {605,0.0005714}, {610,0.0006571}, {615,0.0007143}, {620,0.0009143}, {625,0.0009429}, {630,0.0009429}, {635,0.0028286}, {640,0.0010000}, {645,0.0008857}, {650,0.0009714}, {655,0.0009143}, {660,0.0009143}, {665,0.0009143}, {670,0.0009143}, {675,0.0009143}, {680,0.0009714}, {685,0.0010000}, {690,0.0010000}, {695,0.0010000}, {700,0.0010000}, {705,0.0010000}, {710,0.0010000}, {715,0.0035429}, {720,0.0010000}, {725,0.0010000}, {730,0.0010000}, {735,0.0010000}, {740,0.0010000}, {745,0.0010000}, {750,0.0010000}, {755,0.0010000}, {760,0.0010000}, {765,0.0010000}, {770,0.0010000}, {775,0.0010000}, {780,0.0010000}, {785,0.0010000}, {790,0.0010000}, {795,0.0010000}, {800,0.0010000}, {805,0.0010000}, {810,0.0010000}, {815,0.0010000}, {820,0.0010000}, {825,0.0010000}, {830,0.0010000}, {835,0.0010000}, {840,0.0010000}, {845,0.0010000}, {850,0.0010000}, {855,0.0020857}, {860,0.0010000}, {865,0.0010000}, {870,0.0010000}, {875,0.0010000}, {880,0.0010000}, {885,0.0010000}, {890,0.0010000}, {895,0.0010000}, {900,0.0010000}, {905,0.0010000}, {910,0.0010000}, {915,0.0010000}, {920,0.0010000}, {925,0.0010000}, {930,0.0010000}, {935,0.0010000}, {940,0.0010000}, {945,0.0010000}, {950,0.0010000}, {955,0.0010000}, {960,0.0010000}, {965,0.0010000}, {970,0.0010000}, {975,0.0028857}, {980,0.0010000}, {985,0.0010000}, {990,0.0010000}, {995,0.0010000}, {1000,0.0010000}, {1010,0.0010000}, {1020,0.0010000}, {1030,0.0010000}, {1040,0.0010000}, {1050,0.0010000}, {1060,0.0010000}, {1070,0.0010000}, {1080,0.0010286}, {1090,0.0010286}, {1100,0.0010000}, {1110,0.0010857}, {1120,0.0010857}, {1130,0.0011143}, {1140,0.0011714}, {1150,0.0011429}, {1160,0.0012286}, {1170,0.0012571}, {1180,0.0014286}, {1190,0.0015429}, {1200,0.0017143}, {1210,0.0016857}, {1220,0.0018000}, {1230,0.0019143}, {1240,0.0018000}, {1250,0.0018857}, {1260,0.0019714}, {1270,0.0020000}, {1280,0.0019714}, {1290,0.0020000}, {1300,0.0020000}, {1310,0.0020000}, {1320,0.0020000}, {1330,0.0020000}, {1340,0.0020000}, {1350,0.0020000}, {1360,0.0062000}, {1370,0.0020000}, {1380,0.0020000}, {1390,0.0020000}, {1400,0.0085143}, {1410,0.0020000}, {1420,0.0020000}, {1430,0.0020000}, {1440,0.0058000}, {1450,0.0020000}, {1460,0.0020000}, {1470,0.0020000}, {1480,0.0020000}, {1490,0.0020000}, {1500,0.0020000}, {1510,0.0020000}, {1520,0.0020000}, {1530,0.0020000}, {1540,0.0020000}, {1550,0.0020000}, {1560,0.0020000}, {1570,0.0020000}, {1580,0.0020286}, {1590,0.0020000}, {1600,0.0020000}, {1610,0.0020000}, {1620,0.0020000}, {1630,0.0020000}, {1640,0.0020000}, {1650,0.0020000}, {1660,0.0020571}, {1670,0.0020000}, {1680,0.0020286}, {1690,0.0371143}, {1700,0.0021714}, {1710,0.0021429}, {1720,0.0021143}, {1730,0.0023143}, {1740,0.0022286}, {1750,0.0022857}, {1760,0.0024857}, {1770,0.0022286}, {1780,0.0024857}, {1790,0.0025143}, {1800,0.0027429}, {1810,0.0027714}, {1820,0.0027143}, {1830,0.0027714}, {1840,0.0027714}, {1850,0.0028857}, {1860,0.0028571}, {1870,0.0029143}, {1880,0.0029429}, {1890,0.0030000}, {1900,0.0030000}, {1910,0.0030000}, {1920,0.0029714}, {1930,0.0030000}, {1940,0.0030000}, {1950,0.0030000}, {1960,0.0030000}, {1970,0.0030000}, {1980,0.0030000}, {1990,0.0030000}, {2000,0.0030000}};
data["big"]["LtacTCPrimPair"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00011881}, {3,0.00000000}, {4,0.00003960}, {5,0.00003960}, {6,0.00002970}, {7,0.00000000}, {8,0.00000000}, {9,0.00002970}, {10,0.00003960}, {11,0.00003960}, {12,0.00000000}, {13,0.00000000}, {14,0.00002970}, {15,0.00007921}, {16,0.00000000}, {17,0.00011881}, {18,0.00003960}, {19,0.00003960}, {20,0.00014851}, {21,0.00003960}, {22,0.00011881}, {23,0.00007921}, {24,0.00003960}, {25,0.00019802}, {26,0.00000000}, {27,0.00003960}, {28,0.00000000}, {29,0.00000000}, {30,0.00006931}, {31,0.00007921}, {32,0.00003960}, {33,0.00000000}, {34,0.00003960}, {35,0.00015842}, {36,0.00007921}, {37,0.00007921}, {38,0.00014851}, {39,0.00017822}, {40,0.00007921}, {41,0.00000000}, {42,0.00003960}, {43,0.00006931}, {44,0.00003960}, {45,0.00003960}, {46,0.00009901}, {47,0.00011881}, {48,0.00007921}, {49,0.00003960}, {50,0.00003960}, {51,0.00015842}, {52,0.00022772}, {53,0.00002970}, {54,0.00007921}, {55,0.00007921}, {56,0.00003960}, {57,0.00022772}, {58,0.00007921}, {59,0.00007921}, {60,0.00006931}, {61,0.00019802}, {62,0.00011881}, {63,0.00000000}, {64,0.00003960}, {65,0.00014851}, {66,0.00007921}, {67,0.00007921}, {68,0.00031683}, {69,0.00000000}, {70,0.00022772}, {71,0.00000000}, {72,0.00011881}, {73,0.00011881}, {74,0.00006931}, {75,0.00020792}, {76,0.00010891}, {77,0.00009901}, {78,0.00017822}, {79,0.00017822}, {80,0.00014851}, {81,0.00011881}, {82,0.00023762}, {83,0.00052475}, {84,0.00007921}, {85,0.00023762}, {86,0.00015842}, {87,0.00019802}, {88,0.00000000}, {89,0.00007921}, {90,0.00018812}, {91,0.00011881}, {92,0.00009901}, {93,0.00023762}, {94,0.00011881}, {95,0.00019802}, {96,0.00023762}, {97,0.00010891}, {98,0.00022772}, {99,0.00014851}, {100,0.00026733}, {101,0.00015842}, {102,0.00007921}, {103,0.00021782}, {104,0.00017822}, {105,0.00000000}, {106,0.00023762}, {107,0.00023762}, {108,0.00019802}, {109,0.00011881}, {110,0.00032673}, {111,0.00021782}, {112,0.00017822}, {113,0.00025743}, {114,0.00018812}, {115,0.00011881}, {116,0.00007921}, {117,0.00010891}, {118,0.00028713}, {119,0.00022772}, {120,0.00016832}, {121,0.00017822}, {122,0.00021782}, {123,0.00019802}, {124,0.00035644}, {125,0.00026733}, {126,0.00019802}, {127,0.00043564}, {128,0.00013861}, {129,0.00021782}, {130,0.00014851}, {131,0.00029703}, {132,0.00031683}, {133,0.00011881}, {134,0.00024752}, {135,0.00028713}, {136,0.00035644}, {137,0.00011881}, {138,0.00003960}, {139,0.00021782}, {140,0.00011881}, {141,0.00019802}, {142,0.00035644}, {143,0.00031683}, {144,0.00014851}, {145,0.00033663}, {146,0.00011881}, {147,0.00011881}, {148,0.00009901}, {149,0.00022772}, {150,0.00019802}, {151,0.00006931}, {152,0.00019802}, {153,0.00013861}, {154,0.00031683}, {155,0.00019802}, {156,0.00026733}, {157,0.00011881}, {158,0.00025743}, {159,0.00027723}, {160,0.00015842}, {161,0.00014851}, {162,0.00021782}, {163,0.00014851}, {164,0.00025743}, {165,0.00033663}, {166,0.00014851}, {167,0.00021782}, {168,0.00034653}, {169,0.00050495}, {170,0.00027723}, {171,0.00032673}, {172,0.00023762}, {173,0.00041584}, {174,0.00029703}, {175,0.00021782}, {176,0.00041584}, {177,0.00011881}, {178,0.00033663}, {179,0.00020792}, {180,0.00014851}, {181,0.00007921}, {182,0.00034653}, {183,0.00026733}, {184,0.00007921}, {185,0.00022772}, {186,0.00039604}, {187,0.00028713}, {188,0.00038614}, {189,0.00011881}, {190,0.00031683}, {191,0.00029703}, {192,0.00025743}, {193,0.00023762}, {194,0.00046535}, {195,0.00038614}, {196,0.00026733}, {197,0.00042574}, {198,0.00033663}, {199,0.00023762}, {200,0.00037624}, {201,0.00035644}, {202,0.00030693}, {203,0.00030693}, {204,0.00033663}, {205,0.00047525}, {206,0.00036634}, {207,0.00050495}, {208,0.00027723}, {209,0.00044554}, {210,0.00042574}, {211,0.00054455}, {212,0.00038614}, {213,0.00023762}, {214,0.00062376}, {215,0.00022772}, {216,0.00042574}, {217,0.00038614}, {218,0.00045545}, {219,0.00033663}, {220,0.00041584}, {221,0.00016832}, {222,0.00025743}, {223,0.00050495}, {224,0.00025743}, {225,0.00050495}, {226,0.00051485}, {227,0.00021782}, {228,0.00038614}, {229,0.00043564}, {230,0.00041584}, {231,0.00039604}, {232,0.00014851}, {233,0.00040594}, {234,0.00024752}, {235,0.00042574}, {236,0.00039604}, {237,0.00015842}, {238,0.00039604}, {239,0.00031683}, {240,0.00027723}, {241,0.00051485}, {242,0.00041584}, {243,0.00049505}, {244,0.00043564}, {245,0.00026733}, {246,0.00026733}, {247,0.00034653}, {248,0.00041584}, {249,0.00048515}, {250,0.00035644}, {251,0.00030693}, {252,0.00031683}, {253,0.00019802}, {254,0.00029703}, {255,0.00040594}, {256,0.00044554}, {257,0.00021782}, {258,0.00050495}, {259,0.00041584}, {260,0.00054455}, {261,0.00025743}, {262,0.00023762}, {263,0.00035644}, {264,0.00034653}, {265,0.00054455}, {266,0.00040594}, {267,0.00024752}, {268,0.00064356}, {269,0.00026733}, {270,0.00020792}, {271,0.00037624}, {272,0.00037624}, {273,0.00020792}, {274,0.00034653}, {275,0.00027723}, {276,0.00032673}, {277,0.00052475}, {278,0.00049505}, {279,0.00046535}, {280,0.00063366}, {281,0.00067327}, {282,0.00051485}, {283,0.00048515}, {284,0.00044554}, {285,0.00020792}, {286,0.00066337}, {287,0.00044554}, {288,0.00043564}, {289,0.00027723}, {290,0.00047525}, {291,0.00318812}, {292,0.00272277}, {293,0.00049505}, {294,0.00042574}, {295,0.00047525}, {296,0.00040594}, {297,0.00059406}, {298,0.00044554}, {299,0.00052475}, {300,0.00035644}, {301,0.0004571}, {302,0.0008286}, {303,0.0006286}, {304,0.0005714}, {305,0.0004571}, {306,0.0004000}, {307,0.0006286}, {308,0.0006000}, {309,0.0005143}, {310,0.0008571}, {311,0.0001714}, {312,0.0003714}, {313,0.0002857}, {314,0.0003714}, {315,0.0004286}, {316,0.0003429}, {317,0.0007143}, {318,0.0004286}, {319,0.0001714}, {320,0.0004286}, {321,0.0007143}, {322,0.0012571}, {323,0.0002571}, {324,0.0002571}, {325,0.0005429}, {326,0.0005143}, {327,0.0005429}, {328,0.0002000}, {329,0.0004857}, {330,0.0004286}, {331,0.0004571}, {332,0.0004571}, {333,0.0005714}, {334,0.0003429}, {335,0.0005143}, {336,0.0005143}, {337,0.0006000}, {338,0.0007143}, {339,0.0002000}, {340,0.0003429}, {341,0.0002000}, {342,0.0008857}, {343,0.0005429}, {344,0.0004857}, {345,0.0003429}, {346,0.0001714}, {347,0.0005429}, {348,0.0001714}, {349,0.0004857}, {350,0.0004571}, {351,0.0001714}, {352,0.0002000}, {353,0.0008571}, {354,0.0002857}, {355,0.0001143}, {356,0.0005143}, {357,0.0006286}, {358,0.0003714}, {359,0.0002571}, {360,0.0005714}, {361,0.0004571}, {362,0.0003143}, {363,0.0004286}, {364,0.0002000}, {365,0.0004857}, {366,0.0003429}, {367,0.0005143}, {368,0.0004857}, {369,0.0006286}, {370,0.0001714}, {371,0.0005429}, {372,0.0004571}, {373,0.0008571}, {374,0.0008857}, {375,0.0006857}, {376,0.0003714}, {377,0.0006571}, {378,0.0004571}, {379,0.0005714}, {380,0.0005714}, {381,0.0004857}, {382,0.0005429}, {383,0.0004571}, {384,0.0006286}, {385,0.0006000}, {386,0.0005143}, {387,0.0002571}, {388,0.0005429}, {389,0.0002571}, {390,0.0001143}, {391,0.0007143}, {392,0.0001714}, {393,0.0002571}, {394,0.0004286}, {395,0.0006286}, {396,0.0004857}, {397,0.0005714}, {398,0.0003429}, {399,0.0005143}, {400,0.0002571}, {401,0.0004571}, {402,0.0006857}, {403,0.0005429}, {404,0.0004286}, {405,0.0006286}, {406,0.0007429}, {407,0.0002857}, {408,0.0003714}, {409,0.0009143}, {410,0.0007714}, {411,0.0007429}, {412,0.0008571}, {413,0.0003714}, {414,0.0007143}, {415,0.0006857}, {416,0.0003714}, {417,0.0005714}, {418,0.0006571}, {419,0.0005714}, {420,0.0004286}, {421,0.0005714}, {422,0.0008571}, {423,0.0008571}, {424,0.0004286}, {425,0.0005429}, {426,0.0010286}, {427,0.0008286}, {428,0.0005143}, {429,0.0007714}, {430,0.0008286}, {431,0.0003429}, {432,0.0021714}, {433,0.0004000}, {434,0.0004286}, {435,0.0001714}, {436,0.0003714}, {437,0.0000857}, {438,0.0008000}, {439,0.0010286}, {440,0.0006286}, {441,0.0003714}, {442,0.0005429}, {443,0.0001714}, {444,0.0005143}, {445,0.0004571}, {446,0.0006571}, {447,0.0006857}, {448,0.0009714}, {449,0.0005429}, {450,0.0010571}, {451,0.0009143}, {452,0.0001714}, {453,0.0006857}, {454,0.0005429}, {455,0.0007143}, {456,0.0009429}, {457,0.0007714}, {458,0.0006000}, {459,0.0004286}, {460,0.0003714}, {461,0.0004571}, {462,0.0006286}, {463,0.0006000}, {464,0.0007429}, {465,0.0006857}, {466,0.0009143}, {467,0.0005143}, {468,0.0010286}, {469,0.0004571}, {470,0.0003429}, {471,0.0011429}, {472,0.0009429}, {473,0.0002571}, {474,0.0010571}, {475,0.0005429}, {476,0.0007143}, {477,0.0005143}, {478,0.0004286}, {479,0.0006286}, {480,0.0006286}, {481,0.0004571}, {482,0.0005714}, {483,0.0007714}, {484,0.0005714}, {485,0.0003714}, {486,0.0007429}, {487,0.0006571}, {488,0.0007714}, {489,0.0007714}, {490,0.0005143}, {491,0.0004571}, {492,0.0004571}, {493,0.0006286}, {494,0.0004286}, {495,0.0004571}, {496,0.0006286}, {497,0.0004286}, {498,0.0004286}, {499,0.0006571}, {500,0.0003429}, {505,0.0009143}, {510,0.0008000}, {515,0.0006286}, {520,0.0003429}, {525,0.0003429}, {530,0.0008857}, {535,0.0002571}, {540,0.0005429}, {545,0.0008286}, {550,0.0007714}, {555,0.0003429}, {560,0.0006857}, {565,0.0007143}, {570,0.0008571}, {575,0.0008571}, {580,0.0007714}, {585,0.0008000}, {590,0.0006857}, {595,0.0007714}, {600,0.0006000}, {605,0.0006857}, {610,0.0005143}, {615,0.0007429}, {620,0.0006571}, {625,0.0004286}, {630,0.0007714}, {635,0.0025714}, {640,0.0006857}, {645,0.0008857}, {650,0.0008857}, {655,0.0002571}, {660,0.0010571}, {665,0.0006857}, {670,0.0008286}, {675,0.0006000}, {680,0.0008000}, {685,0.0010571}, {690,0.0009429}, {695,0.0007714}, {700,0.0013714}, {705,0.0006000}, {710,0.0010571}, {715,0.0030571}, {720,0.0006571}, {725,0.0011143}, {730,0.0010286}, {735,0.0010286}, {740,0.0004571}, {745,0.0009714}, {750,0.0013143}, {755,0.0013143}, {760,0.0006000}, {765,0.0012000}, {770,0.0013143}, {775,0.0014000}, {780,0.0009429}, {785,0.0011143}, {790,0.0010000}, {795,0.0015714}, {800,0.0007714}, {805,0.0010857}, {810,0.0012286}, {815,0.0006000}, {820,0.0010286}, {825,0.0011143}, {830,0.0011429}, {835,0.0008571}, {840,0.0006000}, {845,0.0010857}, {850,0.0011429}, {855,0.0025143}, {860,0.0013429}, {865,0.0013714}, {870,0.0014000}, {875,0.0012286}, {880,0.0011714}, {885,0.0010286}, {890,0.0012857}, {895,0.0011429}, {900,0.0008571}, {905,0.0010571}, {910,0.0018571}, {915,0.0013714}, {920,0.0014857}, {925,0.0012000}, {930,0.0009143}, {935,0.0011429}, {940,0.0007714}, {945,0.0012571}, {950,0.0011429}, {955,0.0016000}, {960,0.0012000}, {965,0.0007714}, {970,0.0016000}, {975,0.0026571}, {980,0.0010857}, {985,0.0012286}, {990,0.0017429}, {995,0.0018000}, {1000,0.0019143}, {1010,0.0013714}, {1020,0.0014000}, {1030,0.0019714}, {1040,0.0017429}, {1050,0.0010286}, {1060,0.0016571}, {1070,0.0017714}, {1080,0.0016571}, {1090,0.0014857}, {1100,0.0013714}, {1110,0.0018286}, {1120,0.0020286}, {1130,0.0012571}, {1140,0.0014571}, {1150,0.0016857}, {1160,0.0012857}, {1170,0.0015714}, {1180,0.0023429}, {1190,0.0013714}, {1200,0.0018857}, {1210,0.0020571}, {1220,0.0021714}, {1230,0.0018000}, {1240,0.0016857}, {1250,0.0018857}, {1260,0.0015143}, {1270,0.0020000}, {1280,0.0021714}, {1290,0.0017143}, {1300,0.0020286}, {1310,0.0020000}, {1320,0.0020286}, {1330,0.0018857}, {1340,0.0020286}, {1350,0.0019714}, {1360,0.0059429}, {1370,0.0018571}, {1380,0.0017714}, {1390,0.0016000}, {1400,0.0079714}, {1410,0.0018571}, {1420,0.0019143}, {1430,0.0019429}, {1440,0.0052000}, {1450,0.0018571}, {1460,0.0020286}, {1470,0.0020000}, {1480,0.0023429}, {1490,0.0023143}, {1500,0.0027429}, {1510,0.0021714}, {1520,0.0022286}, {1530,0.0023143}, {1540,0.0030000}, {1550,0.0026000}, {1560,0.0023714}, {1570,0.0024857}, {1580,0.0023429}, {1590,0.0030000}, {1600,0.0023714}, {1610,0.0028857}, {1620,0.0031143}, {1630,0.0023714}, {1640,0.0027143}, {1650,0.0024571}, {1660,0.0028000}, {1670,0.0029429}, {1680,0.0030571}, {1690,0.0373714}, {1700,0.0021714}, {1710,0.0021429}, {1720,0.0030000}, {1730,0.0028286}, {1740,0.0030000}, {1750,0.0030857}, {1760,0.0031143}, {1770,0.0025143}, {1780,0.0030000}, {1790,0.0030571}, {1800,0.0024571}, {1810,0.0030286}, {1820,0.0029429}, {1830,0.0027143}, {1840,0.0024571}, {1850,0.0031143}, {1860,0.0032286}, {1870,0.0028571}, {1880,0.0033143}, {1890,0.0030000}, {1900,0.0034857}, {1910,0.0028571}, {1920,0.0036286}, {1930,0.0031143}, {1940,0.0030286}, {1950,0.0033429}, {1960,0.0034857}, {1970,0.0028286}, {1980,0.0036571}, {1990,0.0028000}, {2000,0.0030286}};
data["big"]["LtacTCPrimPair"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00003960}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00003960}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00003960}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00003960}, {151,0.00000000}, {152,0.00003960}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00003960}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00003960}, {215,0.00000000}, {216,0.00003960}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00003960}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00003960}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00003960}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00003960}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0001143}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0001143}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0001143}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0001143}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0001143}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0001143}, {895,0.0000000}, {900,0.0000000}, {905,0.0001143}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0001143}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000857}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0001143}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000857}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0001143}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000857}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCPrimPair"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0026857}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0029714}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000286}, {805,0.0000286}, {810,0.0000286}, {815,0.0000000}, {820,0.0000000}, {825,0.0000286}, {830,0.0000000}, {835,0.0000571}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000857}, {860,0.0000000}, {865,0.0000571}, {870,0.0002286}, {875,0.0002000}, {880,0.0002000}, {885,0.0003429}, {890,0.0002857}, {895,0.0003143}, {900,0.0004286}, {905,0.0005429}, {910,0.0007714}, {915,0.0006286}, {920,0.0007143}, {925,0.0008857}, {930,0.0007714}, {935,0.0007429}, {940,0.0009143}, {945,0.0009429}, {950,0.0010000}, {955,0.0010000}, {960,0.0010000}, {965,0.0010000}, {970,0.0010000}, {975,0.0010000}, {980,0.0010000}, {985,0.0010000}, {990,0.0010000}, {995,0.0020571}, {1000,0.0010000}, {1010,0.0010000}, {1020,0.0010000}, {1030,0.0010000}, {1040,0.0010000}, {1050,0.0010000}, {1060,0.0010000}, {1070,0.0010000}, {1080,0.0010000}, {1090,0.0010000}, {1100,0.0010000}, {1110,0.0010000}, {1120,0.0010000}, {1130,0.0010000}, {1140,0.0010000}, {1150,0.0010000}, {1160,0.0010000}, {1170,0.0010000}, {1180,0.0010286}, {1190,0.0010000}, {1200,0.0010000}, {1210,0.0010000}, {1220,0.0010000}, {1230,0.0010000}, {1240,0.0010000}, {1250,0.0010000}, {1260,0.0010000}, {1270,0.0010000}, {1280,0.0010000}, {1290,0.0010000}, {1300,0.0010000}, {1310,0.0010000}, {1320,0.0010000}, {1330,0.0010000}, {1340,0.0010000}, {1350,0.0010000}, {1360,0.0010000}, {1370,0.0010000}, {1380,0.0010000}, {1390,0.0010000}, {1400,0.0010000}, {1410,0.0010000}, {1420,0.0010000}, {1430,0.0010000}, {1440,0.0010000}, {1450,0.0010000}, {1460,0.0010000}, {1470,0.0010000}, {1480,0.0010000}, {1490,0.0010000}, {1500,0.0010000}, {1510,0.0010000}, {1520,0.0010000}, {1530,0.0010000}, {1540,0.0010000}, {1550,0.0010000}, {1560,0.0010000}, {1570,0.0010000}, {1580,0.0010000}, {1590,0.0010000}, {1600,0.0010000}, {1610,0.0010000}, {1620,0.0010000}, {1630,0.0010000}, {1640,0.0010000}, {1650,0.0010000}, {1660,0.0010286}, {1670,0.0010000}, {1680,0.0010000}, {1690,0.0010286}, {1700,0.0010000}, {1710,0.0010571}, {1720,0.0010286}, {1730,0.0010857}, {1740,0.0011143}, {1750,0.0012000}, {1760,0.0012286}, {1770,0.0011429}, {1780,0.0013143}, {1790,0.0013714}, {1800,0.0013714}, {1810,0.0014286}, {1820,0.0015714}, {1830,0.0016000}, {1840,0.0017714}, {1850,0.0017714}, {1860,0.0018286}, {1870,0.0018857}, {1880,0.0018857}, {1890,0.0019714}, {1900,0.0020000}, {1910,0.0020000}, {1920,0.0020000}, {1930,0.0020000}, {1940,0.0020000}, {1950,0.0020000}, {1960,0.0020000}, {1970,0.0020000}, {1980,0.0020000}, {1990,0.0020000}, {2000,0.0020000}};
data["big"]["LtacTCPrimPair"]["eval lazy"]["user"] = {{1,0.00003960}, {2,0.00000000}, {3,0.00000000}, {4,0.00003960}, {5,0.00000000}, {6,0.00003960}, {7,0.00003960}, {8,0.00000000}, {9,0.00003960}, {10,0.00000000}, {11,0.00000000}, {12,0.00002970}, {13,0.00000000}, {14,0.00002970}, {15,0.00003960}, {16,0.00000000}, {17,0.00000000}, {18,0.00011881}, {19,0.00007921}, {20,0.00003960}, {21,0.00003960}, {22,0.00015842}, {23,0.00007921}, {24,0.00006931}, {25,0.00031683}, {26,0.00003960}, {27,0.00003960}, {28,0.00003960}, {29,0.00006931}, {30,0.00002970}, {31,0.00010891}, {32,0.00003960}, {33,0.00015842}, {34,0.00003960}, {35,0.00002970}, {36,0.00000000}, {37,0.00007921}, {38,0.00003960}, {39,0.00011881}, {40,0.00007921}, {41,0.00011881}, {42,0.00007921}, {43,0.00003960}, {44,0.00007921}, {45,0.00007921}, {46,0.00018812}, {47,0.00014851}, {48,0.00003960}, {49,0.00003960}, {50,0.00000000}, {51,0.00006931}, {52,0.00007921}, {53,0.00003960}, {54,0.00006931}, {55,0.00019802}, {56,0.00011881}, {57,0.00011881}, {58,0.00006931}, {59,0.00014851}, {60,0.00007921}, {61,0.00003960}, {62,0.00006931}, {63,0.00011881}, {64,0.00003960}, {65,0.00006931}, {66,0.00005941}, {67,0.00014851}, {68,0.00018812}, {69,0.00011881}, {70,0.00011881}, {71,0.00017822}, {72,0.00021782}, {73,0.00014851}, {74,0.00003960}, {75,0.00011881}, {76,0.00013861}, {77,0.00014851}, {78,0.00007921}, {79,0.00026733}, {80,0.00006931}, {81,0.00006931}, {82,0.00013861}, {83,0.00014851}, {84,0.00010891}, {85,0.00010891}, {86,0.00026733}, {87,0.00011881}, {88,0.00015842}, {89,0.00007921}, {90,0.00015842}, {91,0.00013861}, {92,0.00020792}, {93,0.00021782}, {94,0.00003960}, {95,0.00022772}, {96,0.00015842}, {97,0.00015842}, {98,0.00027723}, {99,0.00022772}, {100,0.00007921}, {101,0.00014851}, {102,0.00007921}, {103,0.00015842}, {104,0.00014851}, {105,0.00013861}, {106,0.00010891}, {107,0.00003960}, {108,0.00022772}, {109,0.00010891}, {110,0.00029703}, {111,0.00006931}, {112,0.00014851}, {113,0.00027723}, {114,0.00011881}, {115,0.00022772}, {116,0.00015842}, {117,0.00021782}, {118,0.00018812}, {119,0.00030693}, {120,0.00011881}, {121,0.00019802}, {122,0.00007921}, {123,0.00014851}, {124,0.00038614}, {125,0.00025743}, {126,0.00029703}, {127,0.00011881}, {128,0.00015842}, {129,0.00031683}, {130,0.00018812}, {131,0.00010891}, {132,0.00010891}, {133,0.00014851}, {134,0.00021782}, {135,0.00033663}, {136,0.00025743}, {137,0.00010891}, {138,0.00023762}, {139,0.00021782}, {140,0.00011881}, {141,0.00015842}, {142,0.00014851}, {143,0.00019802}, {144,0.00018812}, {145,0.00015842}, {146,0.00015842}, {147,0.00019802}, {148,0.00023762}, {149,0.00013861}, {150,0.00007921}, {151,0.00009901}, {152,0.00030693}, {153,0.00015842}, {154,0.00025743}, {155,0.00020792}, {156,0.00010891}, {157,0.00015842}, {158,0.00019802}, {159,0.00007921}, {160,0.00015842}, {161,0.00022772}, {162,0.00023762}, {163,0.00007921}, {164,0.00014851}, {165,0.00011881}, {166,0.00025743}, {167,0.00006931}, {168,0.00026733}, {169,0.00029703}, {170,0.00031683}, {171,0.00020792}, {172,0.00014851}, {173,0.00003960}, {174,0.00023762}, {175,0.00018812}, {176,0.00015842}, {177,0.00030693}, {178,0.00015842}, {179,0.00014851}, {180,0.00033663}, {181,0.00010891}, {182,0.00007921}, {183,0.00019802}, {184,0.00022772}, {185,0.00019802}, {186,0.00039604}, {187,0.00017822}, {188,0.00033663}, {189,0.00017822}, {190,0.00030693}, {191,0.00031683}, {192,0.00057426}, {193,0.00039604}, {194,0.00034653}, {195,0.00029703}, {196,0.00018812}, {197,0.00022772}, {198,0.00020792}, {199,0.00025743}, {200,0.00033663}, {201,0.00010891}, {202,0.00019802}, {203,0.00040594}, {204,0.00034653}, {205,0.00011881}, {206,0.00019802}, {207,0.00027723}, {208,0.00018812}, {209,0.00037624}, {210,0.00014851}, {211,0.00031683}, {212,0.00030693}, {213,0.00035644}, {214,0.00040594}, {215,0.00029703}, {216,0.00023762}, {217,0.00026733}, {218,0.00023762}, {219,0.00019802}, {220,0.00011881}, {221,0.00018812}, {222,0.00018812}, {223,0.00038614}, {224,0.00037624}, {225,0.00042574}, {226,0.00040594}, {227,0.00033663}, {228,0.00022772}, {229,0.00011881}, {230,0.00011881}, {231,0.00043564}, {232,0.00031683}, {233,0.00058416}, {234,0.00033663}, {235,0.00042574}, {236,0.00052475}, {237,0.00045545}, {238,0.00031683}, {239,0.00030693}, {240,0.00019802}, {241,0.00037624}, {242,0.00017822}, {243,0.00022772}, {244,0.00036634}, {245,0.00020792}, {246,0.00024752}, {247,0.00033663}, {248,0.00045545}, {249,0.00023762}, {250,0.00021782}, {251,0.00049505}, {252,0.00049505}, {253,0.00026733}, {254,0.00033663}, {255,0.00036634}, {256,0.00049505}, {257,0.00029703}, {258,0.00018812}, {259,0.00029703}, {260,0.00011881}, {261,0.00029703}, {262,0.00034653}, {263,0.00049505}, {264,0.00020792}, {265,0.00020792}, {266,0.00039604}, {267,0.00015842}, {268,0.00037624}, {269,0.00044554}, {270,0.00020792}, {271,0.00016832}, {272,0.00029703}, {273,0.00020792}, {274,0.00028713}, {275,0.00035644}, {276,0.00022772}, {277,0.00016832}, {278,0.00009901}, {279,0.00024752}, {280,0.00032673}, {281,0.00027723}, {282,0.00024752}, {283,0.00005941}, {284,0.00025743}, {285,0.00036634}, {286,0.00044554}, {287,0.00026733}, {288,0.00020792}, {289,0.00020792}, {290,0.00013861}, {291,0.00029703}, {292,0.00041584}, {293,0.00039604}, {294,0.00020792}, {295,0.00035644}, {296,0.00032673}, {297,0.00042574}, {298,0.00051485}, {299,0.00026733}, {300,0.00029703}, {301,0.0002571}, {302,0.0000857}, {303,0.0002571}, {304,0.0004571}, {305,0.0002857}, {306,0.0004571}, {307,0.0002571}, {308,0.0001714}, {309,0.0002000}, {310,0.0002571}, {311,0.0009429}, {312,0.0000857}, {313,0.0001714}, {314,0.0000857}, {315,0.0002857}, {316,0.0005143}, {317,0.0004000}, {318,0.0004571}, {319,0.0001714}, {320,0.0004000}, {321,0.0002571}, {322,0.0004000}, {323,0.0004571}, {324,0.0007429}, {325,0.0002857}, {326,0.0006000}, {327,0.0003714}, {328,0.0001714}, {329,0.0004000}, {330,0.0002857}, {331,0.0007143}, {332,0.0001714}, {333,0.0004571}, {334,0.0004286}, {335,0.0003429}, {336,0.0003429}, {337,0.0004286}, {338,0.0002571}, {339,0.0000000}, {340,0.0030286}, {341,0.0002000}, {342,0.0005429}, {343,0.0003714}, {344,0.0004000}, {345,0.0002571}, {346,0.0002571}, {347,0.0002000}, {348,0.0006000}, {349,0.0000857}, {350,0.0005143}, {351,0.0002571}, {352,0.0004000}, {353,0.0004571}, {354,0.0003429}, {355,0.0003429}, {356,0.0002000}, {357,0.0002857}, {358,0.0001714}, {359,0.0003714}, {360,0.0004286}, {361,0.0003714}, {362,0.0004286}, {363,0.0002571}, {364,0.0006571}, {365,0.0001714}, {366,0.0005429}, {367,0.0004857}, {368,0.0001714}, {369,0.0005143}, {370,0.0001714}, {371,0.0002857}, {372,0.0000857}, {373,0.0005143}, {374,0.0002000}, {375,0.0002571}, {376,0.0007143}, {377,0.0001714}, {378,0.0005429}, {379,0.0004857}, {380,0.0003714}, {381,0.0004286}, {382,0.0001143}, {383,0.0002857}, {384,0.0005429}, {385,0.0004571}, {386,0.0002000}, {387,0.0002857}, {388,0.0007714}, {389,0.0005143}, {390,0.0003429}, {391,0.0005714}, {392,0.0002000}, {393,0.0003429}, {394,0.0005143}, {395,0.0000857}, {396,0.0004000}, {397,0.0002857}, {398,0.0003429}, {399,0.0003429}, {400,0.0004857}, {401,0.0004286}, {402,0.0002857}, {403,0.0005143}, {404,0.0005714}, {405,0.0005429}, {406,0.0002857}, {407,0.0002000}, {408,0.0003429}, {409,0.0005143}, {410,0.0003714}, {411,0.0008000}, {412,0.0005714}, {413,0.0009143}, {414,0.0000857}, {415,0.0003714}, {416,0.0001714}, {417,0.0005714}, {418,0.0006286}, {419,0.0003714}, {420,0.0008571}, {421,0.0003429}, {422,0.0005714}, {423,0.0002857}, {424,0.0007429}, {425,0.0001714}, {426,0.0000857}, {427,0.0003714}, {428,0.0004571}, {429,0.0000000}, {430,0.0004286}, {431,0.0004571}, {432,0.0002857}, {433,0.0006000}, {434,0.0002857}, {435,0.0002000}, {436,0.0004571}, {437,0.0002571}, {438,0.0002571}, {439,0.0008571}, {440,0.0003714}, {441,0.0005143}, {442,0.0004286}, {443,0.0005143}, {444,0.0005429}, {445,0.0003714}, {446,0.0002857}, {447,0.0005429}, {448,0.0004000}, {449,0.0002571}, {450,0.0002571}, {451,0.0004571}, {452,0.0005143}, {453,0.0002571}, {454,0.0002571}, {455,0.0004286}, {456,0.0003714}, {457,0.0002000}, {458,0.0005429}, {459,0.0006286}, {460,0.0005429}, {461,0.0002571}, {462,0.0006286}, {463,0.0003714}, {464,0.0004571}, {465,0.0008571}, {466,0.0004857}, {467,0.0005143}, {468,0.0003429}, {469,0.0005143}, {470,0.0004000}, {471,0.0006571}, {472,0.0002857}, {473,0.0002857}, {474,0.0003143}, {475,0.0001714}, {476,0.0004000}, {477,0.0007143}, {478,0.0004857}, {479,0.0003429}, {480,0.0005429}, {481,0.0008000}, {482,0.0004571}, {483,0.0002571}, {484,0.0004286}, {485,0.0005429}, {486,0.0005143}, {487,0.0005714}, {488,0.0005429}, {489,0.0001714}, {490,0.0006857}, {491,0.0005143}, {492,0.0006286}, {493,0.0005143}, {494,0.0006000}, {495,0.0003714}, {496,0.0002571}, {497,0.0004286}, {498,0.0006286}, {499,0.0004286}, {500,0.0003714}, {505,0.0004286}, {510,0.0007143}, {515,0.0006000}, {520,0.0003143}, {525,0.0005429}, {530,0.0001714}, {535,0.0004571}, {540,0.0004286}, {545,0.0005429}, {550,0.0005429}, {555,0.0003714}, {560,0.0005143}, {565,0.0005429}, {570,0.0004286}, {575,0.0006000}, {580,0.0006286}, {585,0.0006571}, {590,0.0007429}, {595,0.0005143}, {600,0.0008857}, {605,0.0004571}, {610,0.0009143}, {615,0.0008571}, {620,0.0004286}, {625,0.0005429}, {630,0.0024857}, {635,0.0003714}, {640,0.0007429}, {645,0.0004286}, {650,0.0006286}, {655,0.0006571}, {660,0.0004286}, {665,0.0005143}, {670,0.0009714}, {675,0.0008000}, {680,0.0005429}, {685,0.0006857}, {690,0.0004571}, {695,0.0009143}, {700,0.0003429}, {705,0.0002571}, {710,0.0005143}, {715,0.0005429}, {720,0.0007143}, {725,0.0008000}, {730,0.0006857}, {735,0.0002571}, {740,0.0006000}, {745,0.0008000}, {750,0.0004286}, {755,0.0006000}, {760,0.0006000}, {765,0.0008000}, {770,0.0007714}, {775,0.0003714}, {780,0.0006571}, {785,0.0005429}, {790,0.0007714}, {795,0.0011714}, {800,0.0007429}, {805,0.0008000}, {810,0.0006000}, {815,0.0006000}, {820,0.0007143}, {825,0.0008571}, {830,0.0008571}, {835,0.0008857}, {840,0.0004286}, {845,0.0008000}, {850,0.0006000}, {855,0.0007714}, {860,0.0004286}, {865,0.0006571}, {870,0.0004857}, {875,0.0008571}, {880,0.0009714}, {885,0.0013429}, {890,0.0010857}, {895,0.0005429}, {900,0.0008286}, {905,0.0007714}, {910,0.0007143}, {915,0.0008286}, {920,0.0011429}, {925,0.0007714}, {930,0.0007714}, {935,0.0005429}, {940,0.0010286}, {945,0.0007714}, {950,0.0008286}, {955,0.0008857}, {960,0.0008000}, {965,0.0011143}, {970,0.0010000}, {975,0.0003429}, {980,0.0003714}, {985,0.0008000}, {990,0.0011714}, {995,0.0019143}, {1000,0.0008571}, {1010,0.0019429}, {1020,0.0012571}, {1030,0.0007429}, {1040,0.0008571}, {1050,0.0009143}, {1060,0.0013143}, {1070,0.0012857}, {1080,0.0007714}, {1090,0.0013429}, {1100,0.0009143}, {1110,0.0011714}, {1120,0.0010000}, {1130,0.0011143}, {1140,0.0009429}, {1150,0.0010286}, {1160,0.0010000}, {1170,0.0015429}, {1180,0.0014000}, {1190,0.0012571}, {1200,0.0013429}, {1210,0.0011143}, {1220,0.0012857}, {1230,0.0014571}, {1240,0.0012286}, {1250,0.0011714}, {1260,0.0010000}, {1270,0.0014286}, {1280,0.0012571}, {1290,0.0010286}, {1300,0.0014286}, {1310,0.0013143}, {1320,0.0008857}, {1330,0.0011143}, {1340,0.0015143}, {1350,0.0010571}, {1360,0.0010857}, {1370,0.0010000}, {1380,0.0018571}, {1390,0.0008286}, {1400,0.0014286}, {1410,0.0012571}, {1420,0.0010571}, {1430,0.0017143}, {1440,0.0016286}, {1450,0.0010571}, {1460,0.0018857}, {1470,0.0012286}, {1480,0.0012857}, {1490,0.0016000}, {1500,0.0014286}, {1510,0.0016286}, {1520,0.0014857}, {1530,0.0012857}, {1540,0.0014857}, {1550,0.0016857}, {1560,0.0015714}, {1570,0.0015714}, {1580,0.0020000}, {1590,0.0012571}, {1600,0.0016286}, {1610,0.0015429}, {1620,0.0018000}, {1630,0.0021143}, {1640,0.0022571}, {1650,0.0014857}, {1660,0.0011714}, {1670,0.0016857}, {1680,0.0020286}, {1690,0.0020286}, {1700,0.0022286}, {1710,0.0022857}, {1720,0.0017714}, {1730,0.0016571}, {1740,0.0012000}, {1750,0.0016286}, {1760,0.0023429}, {1770,0.0023143}, {1780,0.0016571}, {1790,0.0022286}, {1800,0.0019429}, {1810,0.0020857}, {1820,0.0014857}, {1830,0.0015429}, {1840,0.0019429}, {1850,0.0024000}, {1860,0.0015429}, {1870,0.0019143}, {1880,0.0024571}, {1890,0.0015714}, {1900,0.0022857}, {1910,0.0020000}, {1920,0.0023429}, {1930,0.0026857}, {1940,0.0016571}, {1950,0.0016571}, {1960,0.0019429}, {1970,0.0023429}, {1980,0.0020857}, {1990,0.0017714}, {2000,0.0016857}};
data["big"]["LtacTCPrimPair"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00003960}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00003960}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00003960}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0001143}, {302,0.0000000}, {303,0.0000000}, {304,0.0001143}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0001143}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0001143}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0002286}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0001143}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0001143}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0001143}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0001143}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0001143}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0001143}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000857}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0001143}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000857}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000857}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCPrimPair"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0025429}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0032286}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000286}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000286}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0030000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000286}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000286}, {1360,0.0001714}, {1370,0.0000571}, {1380,0.0000571}, {1390,0.0000571}, {1400,0.0005143}, {1410,0.0001143}, {1420,0.0001143}, {1430,0.0001143}, {1440,0.0002000}, {1450,0.0001143}, {1460,0.0002000}, {1470,0.0002286}, {1480,0.0002000}, {1490,0.0001714}, {1500,0.0002000}, {1510,0.0002000}, {1520,0.0001714}, {1530,0.0002000}, {1540,0.0002571}, {1550,0.0001429}, {1560,0.0003143}, {1570,0.0002000}, {1580,0.0006286}, {1590,0.0006286}, {1600,0.0005143}, {1610,0.0007429}, {1620,0.0007714}, {1630,0.0009714}, {1640,0.0010000}, {1650,0.0010000}, {1660,0.0010000}, {1670,0.0010000}, {1680,0.0010000}, {1690,0.0010000}, {1700,0.0010000}, {1710,0.0010000}, {1720,0.0010000}, {1730,0.0010000}, {1740,0.0010000}, {1750,0.0010000}, {1760,0.0010000}, {1770,0.0010000}, {1780,0.0010000}, {1790,0.0010000}, {1800,0.0010000}, {1810,0.0064571}, {1820,0.0010000}, {1830,0.0010000}, {1840,0.0010000}, {1850,0.0010000}, {1860,0.0010000}, {1870,0.0010000}, {1880,0.0010000}, {1890,0.0010000}, {1900,0.0010000}, {1910,0.0010000}, {1920,0.0010000}, {1930,0.0010000}, {1940,0.0010000}, {1950,0.0010000}, {1960,0.0010000}, {1970,0.0010000}, {1980,0.0010000}, {1990,0.0010000}, {2000,0.0010000}};
data["big"]["LtacTCPrimPair"]["lazy beta iota"]["user"] = {{1,0.00003960}, {2,0.00000000}, {3,0.00011881}, {4,0.00002970}, {5,0.00006931}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00003960}, {11,0.00003960}, {12,0.00000000}, {13,0.00000000}, {14,0.00007921}, {15,0.00003960}, {16,0.00003960}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00003960}, {22,0.00000000}, {23,0.00003960}, {24,0.00003960}, {25,0.00003960}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00007921}, {30,0.00003960}, {31,0.00000000}, {32,0.00006931}, {33,0.00007921}, {34,0.00002970}, {35,0.00003960}, {36,0.00019802}, {37,0.00006931}, {38,0.00003960}, {39,0.00003960}, {40,0.00003960}, {41,0.00010891}, {42,0.00011881}, {43,0.00007921}, {44,0.00007921}, {45,0.00003960}, {46,0.00002970}, {47,0.00002970}, {48,0.00006931}, {49,0.00000000}, {50,0.00009901}, {51,0.00006931}, {52,0.00000000}, {53,0.00000000}, {54,0.00003960}, {55,0.00007921}, {56,0.00000000}, {57,0.00003960}, {58,0.00010891}, {59,0.00007921}, {60,0.00011881}, {61,0.00000000}, {62,0.00003960}, {63,0.00003960}, {64,0.00002970}, {65,0.00003960}, {66,0.00007921}, {67,0.00007921}, {68,0.00006931}, {69,0.00006931}, {70,0.00014851}, {71,0.00000000}, {72,0.00000000}, {73,0.00002970}, {74,0.00003960}, {75,0.00007921}, {76,0.00003960}, {77,0.00007921}, {78,0.00003960}, {79,0.00015842}, {80,0.00003960}, {81,0.00009901}, {82,0.00006931}, {83,0.00011881}, {84,0.00002970}, {85,0.00014851}, {86,0.00019802}, {87,0.00000000}, {88,0.00007921}, {89,0.00023762}, {90,0.00010891}, {91,0.00007921}, {92,0.00007921}, {93,0.00006931}, {94,0.00011881}, {95,0.00000000}, {96,0.00003960}, {97,0.00015842}, {98,0.00023762}, {99,0.00011881}, {100,0.00002970}, {101,0.00007921}, {102,0.00000000}, {103,0.00017822}, {104,0.00011881}, {105,0.00007921}, {106,0.00015842}, {107,0.00003960}, {108,0.00023762}, {109,0.00007921}, {110,0.00011881}, {111,0.00007921}, {112,0.00000000}, {113,0.00015842}, {114,0.00017822}, {115,0.00007921}, {116,0.00011881}, {117,0.00006931}, {118,0.00006931}, {119,0.00015842}, {120,0.00011881}, {121,0.00003960}, {122,0.00007921}, {123,0.00011881}, {124,0.00003960}, {125,0.00007921}, {126,0.00006931}, {127,0.00011881}, {128,0.00003960}, {129,0.00007921}, {130,0.00007921}, {131,0.00011881}, {132,0.00005941}, {133,0.00006931}, {134,0.00015842}, {135,0.00009901}, {136,0.00013861}, {137,0.00014851}, {138,0.00016832}, {139,0.00023762}, {140,0.00011881}, {141,0.00015842}, {142,0.00011881}, {143,0.00007921}, {144,0.00014851}, {145,0.00023762}, {146,0.00007921}, {147,0.00010891}, {148,0.00013861}, {149,0.00029703}, {150,0.00002970}, {151,0.00010891}, {152,0.00003960}, {153,0.00018812}, {154,0.00007921}, {155,0.00007921}, {156,0.00009901}, {157,0.00019802}, {158,0.00007921}, {159,0.00011881}, {160,0.00003960}, {161,0.00011881}, {162,0.00010891}, {163,0.00022772}, {164,0.00010891}, {165,0.00025743}, {166,0.00018812}, {167,0.00011881}, {168,0.00015842}, {169,0.00011881}, {170,0.00011881}, {171,0.00003960}, {172,0.00006931}, {173,0.00010891}, {174,0.00007921}, {175,0.00018812}, {176,0.00011881}, {177,0.00022772}, {178,0.00000000}, {179,0.00025743}, {180,0.00007921}, {181,0.00007921}, {182,0.00023762}, {183,0.00015842}, {184,0.00018812}, {185,0.00014851}, {186,0.00018812}, {187,0.00019802}, {188,0.00006931}, {189,0.00029703}, {190,0.00025743}, {191,0.00003960}, {192,0.00014851}, {193,0.00011881}, {194,0.00023762}, {195,0.00018812}, {196,0.00018812}, {197,0.00003960}, {198,0.00014851}, {199,0.00014851}, {200,0.00007921}, {201,0.00018812}, {202,0.00025743}, {203,0.00007921}, {204,0.00003960}, {205,0.00003960}, {206,0.00003960}, {207,0.00019802}, {208,0.00034653}, {209,0.00003960}, {210,0.00021782}, {211,0.00022772}, {212,0.00013861}, {213,0.00014851}, {214,0.00010891}, {215,0.00014851}, {216,0.00015842}, {217,0.00010891}, {218,0.00007921}, {219,0.00021782}, {220,0.00015842}, {221,0.00016832}, {222,0.00026733}, {223,0.00014851}, {224,0.00003960}, {225,0.00007921}, {226,0.00007921}, {227,0.00026733}, {228,0.00021782}, {229,0.00028713}, {230,0.00015842}, {231,0.00010891}, {232,0.00018812}, {233,0.00017822}, {234,0.00007921}, {235,0.00003960}, {236,0.00015842}, {237,0.00014851}, {238,0.00010891}, {239,0.00029703}, {240,0.00014851}, {241,0.00010891}, {242,0.00022772}, {243,0.00011881}, {244,0.00022772}, {245,0.00017822}, {246,0.00020792}, {247,0.00006931}, {248,0.00014851}, {249,0.00015842}, {250,0.00015842}, {251,0.00029703}, {252,0.00019802}, {253,0.00022772}, {254,0.00034653}, {255,0.00014851}, {256,0.00021782}, {257,0.00006931}, {258,0.00010891}, {259,0.00006931}, {260,0.00020792}, {261,0.00025743}, {262,0.00017822}, {263,0.00020792}, {264,0.00035644}, {265,0.00026733}, {266,0.00005941}, {267,0.00016832}, {268,0.00026733}, {269,0.00010891}, {270,0.00013861}, {271,0.00010891}, {272,0.00025743}, {273,0.00012871}, {274,0.00009901}, {275,0.00020792}, {276,0.00011881}, {277,0.00014851}, {278,0.00006931}, {279,0.00013861}, {280,0.00015842}, {281,0.00013861}, {282,0.00027723}, {283,0.00017822}, {284,0.00002970}, {285,0.00008911}, {286,0.00015842}, {287,0.00018812}, {288,0.00034653}, {289,0.00024752}, {290,0.00026733}, {291,0.00043564}, {292,0.00020792}, {293,0.00010891}, {294,0.00020792}, {295,0.00009901}, {296,0.00019802}, {297,0.00030693}, {298,0.00005941}, {299,0.00009901}, {300,0.00028713}, {301,0.0002857}, {302,0.0000000}, {303,0.0004571}, {304,0.0002571}, {305,0.0002000}, {306,0.0002571}, {307,0.0002000}, {308,0.0002571}, {309,0.0005429}, {310,0.0000857}, {311,0.0000000}, {312,0.0000857}, {313,0.0002571}, {314,0.0003714}, {315,0.0003429}, {316,0.0002857}, {317,0.0000000}, {318,0.0003143}, {319,0.0000857}, {320,0.0002000}, {321,0.0002571}, {322,0.0001714}, {323,0.0006286}, {324,0.0002857}, {325,0.0004571}, {326,0.0000857}, {327,0.0001714}, {328,0.0000857}, {329,0.0000857}, {330,0.0002571}, {331,0.0001714}, {332,0.0000000}, {333,0.0004571}, {334,0.0002857}, {335,0.0004000}, {336,0.0001714}, {337,0.0001714}, {338,0.0002571}, {339,0.0024571}, {340,0.0000857}, {341,0.0002571}, {342,0.0000857}, {343,0.0002571}, {344,0.0000857}, {345,0.0001714}, {346,0.0000000}, {347,0.0001714}, {348,0.0000000}, {349,0.0001143}, {350,0.0002571}, {351,0.0005429}, {352,0.0000857}, {353,0.0000857}, {354,0.0003714}, {355,0.0000857}, {356,0.0003714}, {357,0.0000857}, {358,0.0002000}, {359,0.0000857}, {360,0.0002857}, {361,0.0002857}, {362,0.0003714}, {363,0.0000000}, {364,0.0000857}, {365,0.0000857}, {366,0.0000000}, {367,0.0000857}, {368,0.0002571}, {369,0.0003714}, {370,0.0000857}, {371,0.0003143}, {372,0.0000857}, {373,0.0002571}, {374,0.0002571}, {375,0.0000857}, {376,0.0002857}, {377,0.0001714}, {378,0.0000000}, {379,0.0002571}, {380,0.0000857}, {381,0.0001714}, {382,0.0003429}, {383,0.0000000}, {384,0.0003429}, {385,0.0002286}, {386,0.0002857}, {387,0.0002000}, {388,0.0000857}, {389,0.0003714}, {390,0.0001714}, {391,0.0002857}, {392,0.0002571}, {393,0.0001714}, {394,0.0000857}, {395,0.0002857}, {396,0.0000000}, {397,0.0003714}, {398,0.0003429}, {399,0.0003714}, {400,0.0003143}, {401,0.0002857}, {402,0.0000857}, {403,0.0001143}, {404,0.0002000}, {405,0.0000857}, {406,0.0000857}, {407,0.0002571}, {408,0.0003429}, {409,0.0002571}, {410,0.0000000}, {411,0.0002000}, {412,0.0001714}, {413,0.0002857}, {414,0.0002571}, {415,0.0000000}, {416,0.0000857}, {417,0.0004286}, {418,0.0001143}, {419,0.0003429}, {420,0.0002286}, {421,0.0003714}, {422,0.0002857}, {423,0.0003429}, {424,0.0000000}, {425,0.0003429}, {426,0.0004571}, {427,0.0002000}, {428,0.0002571}, {429,0.0002571}, {430,0.0002857}, {431,0.0002571}, {432,0.0004000}, {433,0.0003714}, {434,0.0001143}, {435,0.0002571}, {436,0.0001143}, {437,0.0002571}, {438,0.0002857}, {439,0.0000857}, {440,0.0004000}, {441,0.0002000}, {442,0.0001714}, {443,0.0004571}, {444,0.0001714}, {445,0.0000857}, {446,0.0001714}, {447,0.0001714}, {448,0.0002571}, {449,0.0003429}, {450,0.0002571}, {451,0.0000857}, {452,0.0001714}, {453,0.0002571}, {454,0.0001714}, {455,0.0002571}, {456,0.0001714}, {457,0.0003714}, {458,0.0000000}, {459,0.0001714}, {460,0.0002571}, {461,0.0002000}, {462,0.0003143}, {463,0.0002571}, {464,0.0002000}, {465,0.0002571}, {466,0.0001714}, {467,0.0003429}, {468,0.0000857}, {469,0.0000000}, {470,0.0002571}, {471,0.0002000}, {472,0.0002571}, {473,0.0000857}, {474,0.0004571}, {475,0.0001714}, {476,0.0001714}, {477,0.0004571}, {478,0.0002000}, {479,0.0001714}, {480,0.0002571}, {481,0.0000857}, {482,0.0000000}, {483,0.0001714}, {484,0.0002571}, {485,0.0002857}, {486,0.0005429}, {487,0.0000000}, {488,0.0004571}, {489,0.0001714}, {490,0.0000857}, {491,0.0002571}, {492,0.0001714}, {493,0.0001714}, {494,0.0001143}, {495,0.0002571}, {496,0.0004571}, {497,0.0001714}, {498,0.0000857}, {499,0.0002571}, {500,0.0000857}, {505,0.0002571}, {510,0.0002857}, {515,0.0001714}, {520,0.0004286}, {525,0.0005429}, {530,0.0005143}, {535,0.0000857}, {540,0.0003714}, {545,0.0004571}, {550,0.0004000}, {555,0.0003429}, {560,0.0002000}, {565,0.0004286}, {570,0.0004571}, {575,0.0002571}, {580,0.0004286}, {585,0.0003429}, {590,0.0005429}, {595,0.0006857}, {600,0.0002571}, {605,0.0001714}, {610,0.0001714}, {615,0.0003429}, {620,0.0001714}, {625,0.0001714}, {630,0.0005714}, {635,0.0006000}, {640,0.0002571}, {645,0.0004286}, {650,0.0002571}, {655,0.0002571}, {660,0.0002571}, {665,0.0002000}, {670,0.0001714}, {675,0.0006286}, {680,0.0001714}, {685,0.0001714}, {690,0.0010571}, {695,0.0004286}, {700,0.0000857}, {705,0.0002571}, {710,0.0003429}, {715,0.0002571}, {720,0.0002000}, {725,0.0000857}, {730,0.0004286}, {735,0.0001714}, {740,0.0004857}, {745,0.0007714}, {750,0.0005429}, {755,0.0003714}, {760,0.0004286}, {765,0.0006571}, {770,0.0004571}, {775,0.0006286}, {780,0.0002000}, {785,0.0004571}, {790,0.0004286}, {795,0.0005714}, {800,0.0004857}, {805,0.0005429}, {810,0.0007143}, {815,0.0004000}, {820,0.0004286}, {825,0.0002286}, {830,0.0027714}, {835,0.0006857}, {840,0.0006000}, {845,0.0005429}, {850,0.0001714}, {855,0.0002571}, {860,0.0001714}, {865,0.0003714}, {870,0.0006857}, {875,0.0007143}, {880,0.0004286}, {885,0.0002571}, {890,0.0006857}, {895,0.0004286}, {900,0.0003714}, {905,0.0006857}, {910,0.0004286}, {915,0.0003714}, {920,0.0004571}, {925,0.0005429}, {930,0.0006000}, {935,0.0006000}, {940,0.0004286}, {945,0.0003429}, {950,0.0006571}, {955,0.0005143}, {960,0.0006286}, {965,0.0005429}, {970,0.0007143}, {975,0.0010000}, {980,0.0009143}, {985,0.0006000}, {990,0.0003429}, {995,0.0006857}, {1000,0.0006286}, {1010,0.0002857}, {1020,0.0003429}, {1030,0.0003429}, {1040,0.0007143}, {1050,0.0010000}, {1060,0.0006286}, {1070,0.0002857}, {1080,0.0008571}, {1090,0.0004857}, {1100,0.0003429}, {1110,0.0004571}, {1120,0.0008571}, {1130,0.0007143}, {1140,0.0006571}, {1150,0.0006571}, {1160,0.0006857}, {1170,0.0008000}, {1180,0.0007143}, {1190,0.0010286}, {1200,0.0034000}, {1210,0.0008857}, {1220,0.0008286}, {1230,0.0009143}, {1240,0.0008571}, {1250,0.0006000}, {1260,0.0009143}, {1270,0.0003714}, {1280,0.0006000}, {1290,0.0011714}, {1300,0.0007429}, {1310,0.0011714}, {1320,0.0014286}, {1330,0.0010571}, {1340,0.0008286}, {1350,0.0008857}, {1360,0.0007429}, {1370,0.0009714}, {1380,0.0002857}, {1390,0.0008857}, {1400,0.0005143}, {1410,0.0008571}, {1420,0.0006571}, {1430,0.0005714}, {1440,0.0005429}, {1450,0.0010571}, {1460,0.0006000}, {1470,0.0008286}, {1480,0.0008000}, {1490,0.0007429}, {1500,0.0013714}, {1510,0.0005143}, {1520,0.0009429}, {1530,0.0009143}, {1540,0.0008857}, {1550,0.0009429}, {1560,0.0011143}, {1570,0.0010000}, {1580,0.0004857}, {1590,0.0011714}, {1600,0.0011143}, {1610,0.0012000}, {1620,0.0006571}, {1630,0.0006286}, {1640,0.0007429}, {1650,0.0012857}, {1660,0.0015429}, {1670,0.0011429}, {1680,0.0015714}, {1690,0.0007429}, {1700,0.0005714}, {1710,0.0008571}, {1720,0.0012571}, {1730,0.0008857}, {1740,0.0011714}, {1750,0.0007429}, {1760,0.0008571}, {1770,0.0007714}, {1780,0.0016286}, {1790,0.0010857}, {1800,0.0008857}, {1810,0.0059714}, {1820,0.0017429}, {1830,0.0015143}, {1840,0.0013429}, {1850,0.0008857}, {1860,0.0013143}, {1870,0.0012286}, {1880,0.0007714}, {1890,0.0013143}, {1900,0.0009714}, {1910,0.0012286}, {1920,0.0012286}, {1930,0.0007429}, {1940,0.0014857}, {1950,0.0015714}, {1960,0.0013143}, {1970,0.0009143}, {1980,0.0012857}, {1990,0.0013143}, {2000,0.0018000}};
data["big"]["LtacTCPrimPair"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00003960}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00002970}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00003960}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00003960}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00003960}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00003960}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0001143}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0001143}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0001143}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0001143}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0001143}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0001143}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000857}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0001143}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0001143}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000857}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0001143}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000857}, {1650,0.0000857}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000857}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000857}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000857}, {1810,0.0000857}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000857}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCPrimPair"]["norm reif"]["real"] = {{1,0.00001980}, {2,0.00082178}, {3,0.00100000}, {4,0.00100000}, {5,0.00200000}, {6,0.00200000}, {7,0.00219802}, {8,0.00300000}, {9,0.00300000}, {10,0.00354455}, {11,0.00400990}, {12,0.00431683}, {13,0.00500000}, {14,0.00547525}, {15,0.00599010}, {16,0.00640594}, {17,0.00690099}, {18,0.00751485}, {19,0.00786139}, {20,0.00932673}, {21,0.00894059}, {22,0.00966337}, {23,0.00995050}, {24,0.01077228}, {25,0.01117822}, {26,0.01175248}, {27,0.01266337}, {28,0.01623762}, {29,0.01362376}, {30,0.01413861}, {31,0.01471287}, {32,0.01525743}, {33,0.01588119}, {34,0.02055446}, {35,0.01696040}, {36,0.01805941}, {37,0.01851485}, {38,0.01910891}, {39,0.02287129}, {40,0.02003960}, {41,0.02128713}, {42,0.02186139}, {43,0.02298020}, {44,0.02363366}, {45,0.02419802}, {46,0.02510891}, {47,0.02595050}, {48,0.02681188}, {49,0.02696040}, {50,0.02718812}, {51,0.02893069}, {52,0.02983168}, {53,0.03072277}, {54,0.03161386}, {55,0.03320792}, {56,0.03315842}, {57,0.03366337}, {58,0.03499010}, {59,0.03465347}, {60,0.03999010}, {61,0.04287129}, {62,0.04457426}, {63,0.04502970}, {64,0.04387129}, {65,0.04011881}, {66,0.04222772}, {67,0.04286139}, {68,0.04392079}, {69,0.04867327}, {70,0.04533663}, {71,0.04729703}, {72,0.04677228}, {73,0.04885149}, {74,0.04887129}, {75,0.05067327}, {76,0.05155446}, {77,0.06235644}, {78,0.05404950}, {79,0.05482178}, {80,0.05611881}, {81,0.05631683}, {82,0.05726733}, {83,0.05848515}, {84,0.05902970}, {85,0.06059406}, {86,0.07717822}, {87,0.08139604}, {88,0.07371287}, {89,0.07794059}, {90,0.07777228}, {91,0.07645545}, {92,0.07660396}, {93,0.07651485}, {94,0.07702970}, {95,0.07810891}, {96,0.07863366}, {97,0.07879208}, {98,0.07939604}, {99,0.07972277}, {100,0.08157426}, {101,0.08244554}, {102,0.08330693}, {103,0.08462376}, {104,0.08410891}, {105,0.08590099}, {106,0.08750495}, {107,0.08875248}, {108,0.08989109}, {109,0.09150495}, {110,0.09213861}, {111,0.09404950}, {112,0.09603960}, {113,0.09778218}, {114,0.09899010}, {115,0.10134653}, {116,0.10144554}, {117,0.10328713}, {118,0.10553465}, {119,0.10766337}, {120,0.10917822}, {121,0.11101980}, {122,0.11216832}, {123,0.12425743}, {124,0.12691089}, {125,0.12934653}, {126,0.13296040}, {127,0.13571287}, {128,0.12237624}, {129,0.14460396}, {130,0.14709901}, {131,0.14751485}, {132,0.14942574}, {133,0.14910891}, {134,0.15391089}, {135,0.15590099}, {136,0.15846535}, {137,0.15765347}, {138,0.16303960}, {139,0.16258416}, {140,0.16557426}, {141,0.16925743}, {142,0.16992079}, {143,0.17365347}, {144,0.17411881}, {145,0.17525743}, {146,0.17758416}, {147,0.17818812}, {148,0.18159406}, {149,0.18434653}, {150,0.18559406}, {151,0.18647525}, {152,0.18675248}, {153,0.19391089}, {154,0.19560396}, {155,0.19688119}, {156,0.19992079}, {157,0.20128713}, {158,0.20149505}, {159,0.20536634}, {160,0.20743564}, {161,0.20978218}, {162,0.20949505}, {163,0.21449505}, {164,0.21521782}, {165,0.21983168}, {166,0.22047525}, {167,0.22018812}, {168,0.22682178}, {169,0.22891089}, {170,0.23003960}, {171,0.23517822}, {172,0.23590099}, {173,0.23860396}, {174,0.23903960}, {175,0.24080198}, {176,0.24622772}, {177,0.24872277}, {178,0.25281188}, {179,0.25596040}, {180,0.25520792}, {181,0.25958416}, {182,0.26239604}, {183,0.26640594}, {184,0.26805941}, {185,0.26923762}, {186,0.27064356}, {187,0.27352475}, {188,0.27428713}, {189,0.27588119}, {190,0.28682178}, {191,0.28980198}, {192,0.29287129}, {193,0.29418812}, {194,0.29472277}, {195,0.29338614}, {196,0.29493069}, {197,0.29888119}, {198,0.29980198}, {199,0.30162376}, {200,0.31126733}, {201,0.31696040}, {202,0.31399010}, {203,0.31450495}, {204,0.31847525}, {205,0.32005941}, {206,0.32706931}, {207,0.33827723}, {208,0.32574257}, {209,0.33278218}, {210,0.33454455}, {211,0.34355446}, {212,0.35000000}, {213,0.34371287}, {214,0.34456436}, {215,0.35509901}, {216,0.35817822}, {217,0.35563366}, {218,0.36432673}, {219,0.36957426}, {220,0.36731683}, {221,0.37089109}, {222,0.37963366}, {223,0.37879208}, {224,0.38486139}, {225,0.38569307}, {226,0.38770297}, {227,0.39520792}, {228,0.39232673}, {229,0.39842574}, {230,0.39924752}, {231,0.40871287}, {232,0.40709901}, {233,0.40922772}, {234,0.41370297}, {235,0.41952475}, {236,0.42005941}, {237,0.42631683}, {238,0.42508911}, {239,0.43540594}, {240,0.43169307}, {241,0.44603960}, {242,0.44112871}, {243,0.44725743}, {244,0.45070297}, {245,0.45196040}, {246,0.45729703}, {247,0.46531683}, {248,0.46235644}, {249,0.46962376}, {250,0.47827723}, {251,0.47595050}, {252,0.49156436}, {253,0.48727723}, {254,0.48203960}, {255,0.49142574}, {256,0.49584158}, {257,0.49578218}, {258,0.50083168}, {259,0.50024752}, {260,0.51094059}, {261,0.51503960}, {262,0.51135644}, {263,0.51697030}, {264,0.52142574}, {265,0.52302970}, {266,0.53022772}, {267,0.53605941}, {268,0.53776238}, {269,0.53952475}, {270,0.54446535}, {271,0.55007921}, {272,0.56698020}, {273,0.55680198}, {274,0.57748515}, {275,0.56591089}, {276,0.57112871}, {277,0.57877228}, {278,0.58402970}, {279,0.61937624}, {280,0.58406931}, {281,0.58590099}, {282,0.59152475}, {283,0.59696040}, {284,0.60010891}, {285,0.60253465}, {286,0.60680198}, {287,0.61753465}, {288,0.61759406}, {289,0.62127723}, {290,0.62804950}, {291,0.64050495}, {292,0.65068317}, {293,0.65753465}, {294,0.66102970}, {295,0.66810891}, {296,0.67002970}, {297,0.67286139}, {298,0.67530693}, {299,0.68346535}, {300,0.68900990}, {301,0.7115429}, {302,0.7562857}, {303,0.7386000}, {304,0.7476000}, {305,0.7249429}, {306,0.7284000}, {307,0.7398286}, {308,0.7432571}, {309,0.7453714}, {310,0.7496857}, {311,0.7539143}, {312,0.7613143}, {313,0.7652000}, {314,0.7727143}, {315,0.7744857}, {316,0.7756286}, {317,0.7804571}, {318,0.7897429}, {319,0.7965429}, {320,0.8098286}, {321,0.8028857}, {322,0.8075429}, {323,0.8148857}, {324,0.8141143}, {325,0.8213429}, {326,0.8301429}, {327,0.8372857}, {328,0.8389143}, {329,0.8468571}, {330,0.8473429}, {331,0.8572286}, {332,0.8576000}, {333,0.8637714}, {334,0.8690857}, {335,0.8734857}, {336,0.8828286}, {337,0.8829429}, {338,0.8920857}, {339,0.8925714}, {340,0.9007714}, {341,0.9035429}, {342,0.9183429}, {343,0.9207143}, {344,0.9329714}, {345,0.9538857}, {346,0.9456571}, {347,0.9415143}, {348,0.9515429}, {349,0.9501143}, {350,0.9626000}, {351,0.9721143}, {352,0.9706571}, {353,0.9752571}, {354,0.9806857}, {355,0.9921714}, {356,0.9889714}, {357,0.9976286}, {358,1.0026857}, {359,1.0046571}, {360,1.0068571}, {361,1.0410857}, {362,1.0252286}, {363,1.0288857}, {364,1.0374286}, {365,1.0380571}, {366,1.0431429}, {367,1.0490857}, {368,1.0631429}, {369,1.0841143}, {370,1.0722000}, {371,1.1009143}, {372,1.0856286}, {373,1.0914571}, {374,1.0932571}, {375,1.1087143}, {376,1.1123429}, {377,1.1137143}, {378,1.1654857}, {379,1.1280571}, {380,1.1518571}, {381,1.1363429}, {382,1.1647143}, {383,1.1564000}, {384,1.1810000}, {385,1.1720000}, {386,1.1983714}, {387,1.1863143}, {388,1.1956571}, {389,1.1944000}, {390,1.2039714}, {391,1.2094571}, {392,1.2670571}, {393,1.2202857}, {394,1.2318857}, {395,1.2372857}, {396,1.2688571}, {397,1.2531714}, {398,1.2795714}, {399,1.2816000}, {400,1.2931143}, {401,1.2724571}, {402,1.2862857}, {403,1.2878571}, {404,1.3174571}, {405,1.3031429}, {406,1.3125714}, {407,1.3449429}, {408,1.3309429}, {409,1.3296286}, {410,1.3389143}, {411,1.3434571}, {412,1.3429714}, {413,1.3508857}, {414,1.3613714}, {415,1.3941429}, {416,1.3724000}, {417,1.3766000}, {418,1.3836571}, {419,1.3880286}, {420,1.3988000}, {421,1.4070286}, {422,1.4140857}, {423,1.4232571}, {424,1.4289714}, {425,1.4341714}, {426,1.4430857}, {427,1.4519429}, {428,1.4630000}, {429,1.4766286}, {430,1.4966286}, {431,1.4897143}, {432,1.5088286}, {433,1.5124571}, {434,1.5195714}, {435,1.5304000}, {436,1.5391714}, {437,1.5482857}, {438,1.5522286}, {439,1.5642000}, {440,1.5715429}, {441,1.5820286}, {442,1.5888571}, {443,1.5925429}, {444,1.6005714}, {445,1.6127143}, {446,1.6206571}, {447,1.6267429}, {448,1.6346000}, {449,1.6373714}, {450,1.6529429}, {451,1.6644000}, {452,1.6640857}, {453,1.6739143}, {454,1.6798857}, {455,1.6936857}, {456,1.7221429}, {457,1.7125714}, {458,1.7384000}, {459,1.7294286}, {460,1.7259143}, {461,1.7383429}, {462,1.7473714}, {463,1.7564286}, {464,1.7722571}, {465,1.7644000}, {466,1.7898000}, {467,1.8210857}, {468,1.8212286}, {469,1.8122286}, {470,1.8140000}, {471,1.8221429}, {472,1.8307714}, {473,1.8323143}, {474,1.8518000}, {475,1.8554857}, {476,1.8560571}, {477,1.8603429}, {478,1.8768286}, {479,1.8861429}, {480,1.9265714}, {481,1.9063143}, {482,1.9189714}, {483,1.9334000}, {484,1.9354857}, {485,1.9578857}, {486,1.9562857}, {487,1.9944571}, {488,1.9676286}, {489,1.9712286}, {490,1.9679429}, {491,2.0011429}, {492,1.9957714}, {493,2.0318571}, {494,2.0379143}, {495,2.0397143}, {496,2.0820286}, {497,2.0460286}, {498,2.0608000}, {499,2.0724000}, {500,2.0784857}, {505,2.1235429}, {510,2.1656857}, {515,2.2486286}, {520,2.2608571}, {525,2.3150571}, {530,2.3545429}, {535,2.3922857}, {540,2.4651143}, {545,2.5261429}, {550,2.5830286}, {555,2.6276571}, {560,2.6891429}, {565,2.7521143}, {570,2.7827143}, {575,2.8546000}, {580,2.9055143}, {585,2.9636286}, {590,3.0488286}, {595,3.0669143}, {600,3.1293143}, {605,3.2177714}, {610,3.3264286}, {615,3.3685714}, {620,3.4326000}, {625,3.5440286}, {630,3.6507143}, {635,3.6288571}, {640,3.7035714}, {645,3.7797714}, {650,3.8062000}, {655,3.9728857}, {660,3.9104571}, {665,3.9543714}, {670,4.0107714}, {675,4.1997143}, {680,4.0759714}, {685,4.2626000}, {690,4.3244571}, {695,4.3346571}, {700,4.5531714}, {705,4.6402286}, {710,4.5496286}, {715,4.7084000}, {720,4.7818857}, {725,4.8304571}, {730,4.8316286}, {735,4.9408000}, {740,5.0452571}, {745,5.1298571}, {750,5.1744000}, {755,5.2540286}, {760,5.3640286}, {765,5.4573143}, {770,5.5528857}, {775,5.5912857}, {780,5.6987143}, {785,5.8233143}, {790,5.8734286}, {795,5.9861429}, {800,6.1374286}, {805,6.1672571}, {810,6.2662000}, {815,6.4181429}, {820,6.4516000}, {825,6.5888857}, {830,6.6571143}, {835,6.7480857}, {840,6.8439714}, {845,6.9398571}, {850,7.1272286}, {855,7.2945429}, {860,7.3035429}, {865,7.4616000}, {870,7.4787143}, {875,7.7458857}, {880,7.7962000}, {885,7.9372000}, {890,8.0659143}, {895,8.1385429}, {900,8.1976000}, {905,8.2859143}, {910,8.3682571}, {915,8.5974857}, {920,8.7199143}, {925,8.8037143}, {930,8.8932571}, {935,8.9620286}, {940,9.3073429}, {945,9.2944000}, {950,9.2790000}, {955,9.5662000}, {960,9.7922857}, {965,9.7996286}, {970,9.9340857}, {975,9.9958000}, {980,10.1230571}, {985,10.3705429}, {990,10.6323429}, {995,10.6033714}, {1000,11.0138571}, {1010,11.1221714}, {1020,11.4188857}, {1030,11.7182571}, {1040,12.1668857}, {1050,12.2722857}, {1060,12.4497714}, {1070,12.7443143}, {1080,13.3448286}, {1090,13.4118571}, {1100,13.7118000}, {1110,14.0986286}, {1120,14.4286000}, {1130,14.6499429}, {1140,15.2178571}, {1150,15.2872857}, {1160,15.7470571}, {1170,16.0932571}, {1180,16.5554857}, {1190,16.7142571}, {1200,17.4324857}, {1210,17.6061429}, {1220,18.0394857}, {1230,18.3264571}, {1240,19.0451143}, {1250,19.2040286}, {1260,19.7168571}, {1270,20.1534571}, {1280,20.5160571}, {1290,21.0244571}, {1300,21.1420571}, {1310,21.8658000}, {1320,22.1149429}, {1330,22.6255714}, {1340,23.3675143}, {1350,23.8780857}, {1360,24.3989429}, {1370,24.6831429}, {1380,25.2958000}, {1390,25.7808857}, {1400,26.0765143}, {1410,26.8008571}, {1420,27.2890286}, {1430,27.5629429}, {1440,28.2970571}, {1450,28.8949429}, {1460,28.9628286}, {1470,29.7106571}, {1480,30.5098286}, {1490,31.1312857}, {1500,31.5072571}, {1510,32.2814286}, {1520,32.9352571}, {1530,33.5823143}, {1540,33.8491143}, {1550,34.6933143}, {1560,35.2893143}, {1570,36.1150000}, {1580,36.0501429}, {1590,37.0074571}, {1600,37.8924000}, {1610,38.1470000}, {1620,39.1726286}, {1630,39.4205429}, {1640,40.0994000}, {1650,40.6093429}, {1660,41.5226286}, {1670,42.2436286}, {1680,43.2748571}, {1690,44.0474000}, {1700,44.9703143}, {1710,45.3047143}, {1720,46.3521429}, {1730,46.9518857}, {1740,47.4302571}, {1750,48.0603429}, {1760,49.0502000}, {1770,49.5638857}, {1780,50.7129714}, {1790,51.2322000}, {1800,52.0085714}, {1810,52.8708571}, {1820,53.5135429}, {1830,54.5788857}, {1840,55.1432000}, {1850,56.3338286}, {1860,56.9189429}, {1870,58.2837714}, {1880,59.2298571}, {1890,60.1105429}, {1900,61.5723714}, {1910,62.2431143}, {1920,63.4821143}, {1930,63.7900000}, {1940,64.2193714}, {1950,65.1958000}, {1960,66.0838857}, {1970,67.0737143}, {1980,67.6729429}, {1990,69.2372857}, {2000,69.7134000}};
data["big"]["LtacTCPrimPair"]["norm reif"]["user"] = {{1,0.00062376}, {2,0.00096040}, {3,0.00117822}, {4,0.00173267}, {5,0.00202970}, {6,0.00228713}, {7,0.00303960}, {8,0.00327723}, {9,0.00353465}, {10,0.00382178}, {11,0.00419802}, {12,0.00477228}, {13,0.00484158}, {14,0.00606931}, {15,0.00587129}, {16,0.00640594}, {17,0.00717822}, {18,0.00734653}, {19,0.00826733}, {20,0.00929703}, {21,0.00891089}, {22,0.00950495}, {23,0.01028713}, {24,0.01049505}, {25,0.01115842}, {26,0.01170297}, {27,0.01248515}, {28,0.01593069}, {29,0.01335644}, {30,0.01376238}, {31,0.01488119}, {32,0.01502970}, {33,0.01586139}, {34,0.02036634}, {35,0.01649505}, {36,0.01780198}, {37,0.01800000}, {38,0.01900990}, {39,0.02290099}, {40,0.01962376}, {41,0.02129703}, {42,0.02195050}, {43,0.02305941}, {44,0.02380198}, {45,0.02466337}, {46,0.02541584}, {47,0.02616832}, {48,0.02708911}, {49,0.02695050}, {50,0.02748515}, {51,0.02933663}, {52,0.02994059}, {53,0.03056436}, {54,0.03163366}, {55,0.03337624}, {56,0.03297030}, {57,0.03366337}, {58,0.03486139}, {59,0.03452475}, {60,0.03965347}, {61,0.04260396}, {62,0.04431683}, {63,0.04461386}, {64,0.04328713}, {65,0.03980198}, {66,0.04173267}, {67,0.04246535}, {68,0.04359406}, {69,0.04906931}, {70,0.04530693}, {71,0.04739604}, {72,0.04707921}, {73,0.04896040}, {74,0.04948515}, {75,0.05047525}, {76,0.05168317}, {77,0.06208911}, {78,0.05433663}, {79,0.05468317}, {80,0.05593069}, {81,0.05617822}, {82,0.05712871}, {83,0.05850495}, {84,0.05901980}, {85,0.06026733}, {86,0.07698020}, {87,0.08150495}, {88,0.07391089}, {89,0.07823762}, {90,0.07785149}, {91,0.07662376}, {92,0.07700000}, {93,0.07670297}, {94,0.07717822}, {95,0.07836634}, {96,0.07873267}, {97,0.07858416}, {98,0.07914851}, {99,0.07961386}, {100,0.08152475}, {101,0.08217822}, {102,0.08324752}, {103,0.08428713}, {104,0.08385149}, {105,0.08559406}, {106,0.08726733}, {107,0.08825743}, {108,0.08945545}, {109,0.09116832}, {110,0.09169307}, {111,0.09385149}, {112,0.09543564}, {113,0.09782178}, {114,0.09896040}, {115,0.10126733}, {116,0.10134653}, {117,0.10350495}, {118,0.10514851}, {119,0.10730693}, {120,0.10879208}, {121,0.11056436}, {122,0.11167327}, {123,0.12411881}, {124,0.12676238}, {125,0.12897030}, {126,0.13262376}, {127,0.13485149}, {128,0.12240594}, {129,0.14454455}, {130,0.14703960}, {131,0.14725743}, {132,0.14891089}, {133,0.14872277}, {134,0.15389109}, {135,0.15562376}, {136,0.15824752}, {137,0.15716832}, {138,0.16232673}, {139,0.16241584}, {140,0.16530693}, {141,0.16901980}, {142,0.16938614}, {143,0.17350495}, {144,0.17418812}, {145,0.17482178}, {146,0.17680198}, {147,0.17776238}, {148,0.18132673}, {149,0.18355446}, {150,0.18502970}, {151,0.18598020}, {152,0.18635644}, {153,0.19339604}, {154,0.19517822}, {155,0.19672277}, {156,0.19927723}, {157,0.20085149}, {158,0.20086139}, {159,0.20520792}, {160,0.20698020}, {161,0.20938614}, {162,0.20907921}, {163,0.21388119}, {164,0.21473267}, {165,0.21923762}, {166,0.22028713}, {167,0.21973267}, {168,0.22654455}, {169,0.22811881}, {170,0.22939604}, {171,0.23460396}, {172,0.23510891}, {173,0.23777228}, {174,0.23832673}, {175,0.24015842}, {176,0.24540594}, {177,0.24826733}, {178,0.25213861}, {179,0.25536634}, {180,0.25497030}, {181,0.25889109}, {182,0.26180198}, {183,0.26600990}, {184,0.26730693}, {185,0.26866337}, {186,0.27016832}, {187,0.27294059}, {188,0.27340594}, {189,0.27507921}, {190,0.28605941}, {191,0.28909901}, {192,0.29266337}, {193,0.29351485}, {194,0.29418812}, {195,0.29285149}, {196,0.29434653}, {197,0.29844554}, {198,0.29924752}, {199,0.30090099}, {200,0.31072277}, {201,0.31625743}, {202,0.31314851}, {203,0.31383168}, {204,0.31774257}, {205,0.31936634}, {206,0.32630693}, {207,0.33756436}, {208,0.32507921}, {209,0.33211881}, {210,0.33386139}, {211,0.34280198}, {212,0.34941584}, {213,0.34366337}, {214,0.34397030}, {215,0.35463366}, {216,0.35737624}, {217,0.35476238}, {218,0.36353465}, {219,0.36860396}, {220,0.36653465}, {221,0.37015842}, {222,0.37881188}, {223,0.37820792}, {224,0.38457426}, {225,0.38520792}, {226,0.38654455}, {227,0.39436634}, {228,0.39177228}, {229,0.39748515}, {230,0.39824752}, {231,0.40788119}, {232,0.40623762}, {233,0.40869307}, {234,0.41285149}, {235,0.41887129}, {236,0.41916832}, {237,0.42511881}, {238,0.42442574}, {239,0.43393069}, {240,0.43101980}, {241,0.44514851}, {242,0.44006931}, {243,0.44601980}, {244,0.44963366}, {245,0.45047525}, {246,0.45632673}, {247,0.46460396}, {248,0.46121782}, {249,0.46850495}, {250,0.47698020}, {251,0.47498020}, {252,0.49051485}, {253,0.48647525}, {254,0.48100000}, {255,0.49063366}, {256,0.49499010}, {257,0.49501980}, {258,0.49986139}, {259,0.49950495}, {260,0.50994059}, {261,0.51417822}, {262,0.51069307}, {263,0.51631683}, {264,0.52028713}, {265,0.52170297}, {266,0.52956436}, {267,0.53533663}, {268,0.53669307}, {269,0.53826733}, {270,0.54348515}, {271,0.54901980}, {272,0.56595050}, {273,0.55601980}, {274,0.57653465}, {275,0.56491089}, {276,0.57000990}, {277,0.57787129}, {278,0.58307921}, {279,0.61845545}, {280,0.58266337}, {281,0.58469307}, {282,0.59028713}, {283,0.59577228}, {284,0.59925743}, {285,0.60193069}, {286,0.60575248}, {287,0.61604950}, {288,0.61621782}, {289,0.62013861}, {290,0.62700000}, {291,0.63924752}, {292,0.64964356}, {293,0.65640594}, {294,0.65961386}, {295,0.66705941}, {296,0.66856436}, {297,0.67158416}, {298,0.67388119}, {299,0.68226733}, {300,0.68774257}, {301,0.7108286}, {302,0.7518857}, {303,0.7373714}, {304,0.7465714}, {305,0.7241429}, {306,0.7271143}, {307,0.7382857}, {308,0.7422286}, {309,0.7443429}, {310,0.7485714}, {311,0.7534571}, {312,0.7604286}, {313,0.7646857}, {314,0.7716000}, {315,0.7735714}, {316,0.7751143}, {317,0.7798000}, {318,0.7888000}, {319,0.7953429}, {320,0.8040857}, {321,0.8020000}, {322,0.8057143}, {323,0.8134571}, {324,0.8137143}, {325,0.8198000}, {326,0.8296000}, {327,0.8324571}, {328,0.8372857}, {329,0.8450000}, {330,0.8458857}, {331,0.8548571}, {332,0.8564857}, {333,0.8610286}, {334,0.8674286}, {335,0.8696571}, {336,0.8758000}, {337,0.8820571}, {338,0.8900000}, {339,0.8912571}, {340,0.9002857}, {341,0.9025714}, {342,0.9170571}, {343,0.9194286}, {344,0.9313429}, {345,0.9527429}, {346,0.9447714}, {347,0.9401429}, {348,0.9503714}, {349,0.9486857}, {350,0.9615714}, {351,0.9707714}, {352,0.9696571}, {353,0.9744000}, {354,0.9801143}, {355,0.9910857}, {356,0.9871714}, {357,0.9972286}, {358,1.0024857}, {359,1.0037429}, {360,1.0061429}, {361,1.0401143}, {362,1.0245143}, {363,1.0272857}, {364,1.0361714}, {365,1.0368000}, {366,1.0419429}, {367,1.0476571}, {368,1.0613714}, {369,1.0828571}, {370,1.0712857}, {371,1.0992571}, {372,1.0845143}, {373,1.0898571}, {374,1.0918571}, {375,1.1073429}, {376,1.1112000}, {377,1.1118571}, {378,1.1632286}, {379,1.1263143}, {380,1.1500857}, {381,1.1341714}, {382,1.1625429}, {383,1.1539143}, {384,1.1790857}, {385,1.1696000}, {386,1.1965429}, {387,1.1842286}, {388,1.1940286}, {389,1.1925714}, {390,1.2025429}, {391,1.2071429}, {392,1.2653714}, {393,1.2179143}, {394,1.2302286}, {395,1.2357429}, {396,1.2673143}, {397,1.2514000}, {398,1.2770571}, {399,1.2796286}, {400,1.2910857}, {401,1.2701143}, {402,1.2842000}, {403,1.2862857}, {404,1.3147143}, {405,1.2998286}, {406,1.3084286}, {407,1.3374000}, {408,1.3282571}, {409,1.3263714}, {410,1.3370286}, {411,1.3409714}, {412,1.3405714}, {413,1.3487143}, {414,1.3588286}, {415,1.3919714}, {416,1.3704286}, {417,1.3743714}, {418,1.3813714}, {419,1.3860286}, {420,1.3971143}, {421,1.4050286}, {422,1.4119143}, {423,1.4206857}, {424,1.4270571}, {425,1.4318000}, {426,1.4399143}, {427,1.4493429}, {428,1.4595429}, {429,1.4738286}, {430,1.4938000}, {431,1.4865429}, {432,1.5047429}, {433,1.5094286}, {434,1.5168571}, {435,1.5273143}, {436,1.5359429}, {437,1.5454286}, {438,1.5491714}, {439,1.5614286}, {440,1.5674571}, {441,1.5785714}, {442,1.5860286}, {443,1.5890571}, {444,1.5968571}, {445,1.6096286}, {446,1.6167429}, {447,1.6237429}, {448,1.6306857}, {449,1.6343714}, {450,1.6496286}, {451,1.6615429}, {452,1.6617143}, {453,1.6709429}, {454,1.6771714}, {455,1.6905143}, {456,1.7187143}, {457,1.7085714}, {458,1.7350286}, {459,1.7267143}, {460,1.7231714}, {461,1.7352857}, {462,1.7448857}, {463,1.7536286}, {464,1.7696286}, {465,1.7620286}, {466,1.7869429}, {467,1.8185429}, {468,1.8190000}, {469,1.8094000}, {470,1.8116000}, {471,1.8180000}, {472,1.8266857}, {473,1.8283714}, {474,1.8468000}, {475,1.8516857}, {476,1.8521429}, {477,1.8566571}, {478,1.8739429}, {479,1.8812000}, {480,1.9220000}, {481,1.9024286}, {482,1.9146286}, {483,1.9283714}, {484,1.9307714}, {485,1.9524286}, {486,1.9504286}, {487,1.9884571}, {488,1.9621143}, {489,1.9665714}, {490,1.9636857}, {491,1.9972286}, {492,1.9914286}, {493,2.0273143}, {494,2.0337143}, {495,2.0351143}, {496,2.0776000}, {497,2.0422571}, {498,2.0570857}, {499,2.0676286}, {500,2.0746571}, {505,2.1185429}, {510,2.1612571}, {515,2.2420857}, {520,2.2542571}, {525,2.3077714}, {530,2.3477714}, {535,2.3865714}, {540,2.4580857}, {545,2.5189429}, {550,2.5749143}, {555,2.6186571}, {560,2.6809143}, {565,2.7435143}, {570,2.7749429}, {575,2.8472000}, {580,2.8976571}, {585,2.9558571}, {590,3.0418286}, {595,3.0593429}, {600,3.1220571}, {605,3.2102000}, {610,3.3195714}, {615,3.3605143}, {620,3.4252571}, {625,3.5365143}, {630,3.6428000}, {635,3.6199429}, {640,3.6957143}, {645,3.7715143}, {650,3.8014571}, {655,3.9684571}, {660,3.9063714}, {665,3.9497143}, {670,4.0052571}, {675,4.1949714}, {680,4.0718000}, {685,4.2558571}, {690,4.3159429}, {695,4.3295143}, {700,4.5459143}, {705,4.6333714}, {710,4.5436571}, {715,4.6995714}, {720,4.7726286}, {725,4.8217714}, {730,4.8200000}, {735,4.9297143}, {740,5.0355429}, {745,5.1206286}, {750,5.1666571}, {755,5.2456857}, {760,5.3554286}, {765,5.4473714}, {770,5.5424857}, {775,5.5822857}, {780,5.6886571}, {785,5.8148857}, {790,5.8639143}, {795,5.9751143}, {800,6.1208000}, {805,6.1513714}, {810,6.2469714}, {815,6.3980286}, {820,6.4360000}, {825,6.5713714}, {830,6.6409429}, {835,6.7308286}, {840,6.8292286}, {845,6.9261714}, {850,7.1149429}, {855,7.2808286}, {860,7.2891143}, {865,7.4482000}, {870,7.4663143}, {875,7.7311714}, {880,7.7858857}, {885,7.9318857}, {890,8.0590857}, {895,8.1305429}, {900,8.1888571}, {905,8.2741429}, {910,8.3535429}, {915,8.5790286}, {920,8.7040286}, {925,8.7891429}, {930,8.8790571}, {935,8.9462000}, {940,9.2903429}, {945,9.2774571}, {950,9.2660000}, {955,9.5524286}, {960,9.7815429}, {965,9.7812571}, {970,9.9090857}, {975,9.9711714}, {980,10.0980000}, {985,10.3492571}, {990,10.6030000}, {995,10.5751143}, {1000,10.9871143}, {1010,11.0896000}, {1020,11.3880857}, {1030,11.6867429}, {1040,12.1400857}, {1050,12.2387714}, {1060,12.4266571}, {1070,12.7274000}, {1080,13.3210000}, {1090,13.3958857}, {1100,13.6924000}, {1110,14.0728571}, {1120,14.3983714}, {1130,14.6278286}, {1140,15.1632000}, {1150,15.2625429}, {1160,15.7251429}, {1170,16.0683429}, {1180,16.5312571}, {1190,16.6940286}, {1200,17.4129143}, {1210,17.5834000}, {1220,18.0095429}, {1230,18.2942000}, {1240,19.0188571}, {1250,19.1667429}, {1260,19.6831429}, {1270,20.1143714}, {1280,20.4805143}, {1290,20.9876286}, {1300,21.1184000}, {1310,21.8424286}, {1320,22.0953714}, {1330,22.6001429}, {1340,23.3420571}, {1350,23.8445429}, {1360,24.3638857}, {1370,24.6490571}, {1380,25.2602857}, {1390,25.7547429}, {1400,26.0470000}, {1410,26.7732857}, {1420,27.2560286}, {1430,27.5338857}, {1440,28.2720857}, {1450,28.8510286}, {1460,28.9164571}, {1470,29.6734857}, {1480,30.4746000}, {1490,31.0962857}, {1500,31.4727143}, {1510,32.2480571}, {1520,32.8840000}, {1530,33.5467143}, {1540,33.8122571}, {1550,34.6533714}, {1560,35.2483714}, {1570,36.0821429}, {1580,35.9929714}, {1590,36.9638571}, {1600,37.8358286}, {1610,38.1015714}, {1620,39.1296857}, {1630,39.3693143}, {1640,40.0526857}, {1650,40.5571429}, {1660,41.4724571}, {1670,42.1953714}, {1680,43.2228286}, {1690,43.9940000}, {1700,44.9065143}, {1710,45.2558000}, {1720,46.3055714}, {1730,46.8853714}, {1740,47.3675714}, {1750,48.0018857}, {1760,48.9908857}, {1770,49.4970571}, {1780,50.6493143}, {1790,51.1720000}, {1800,51.9656857}, {1810,52.8280286}, {1820,53.4706857}, {1830,54.5269714}, {1840,55.0586286}, {1850,56.2623429}, {1860,56.8543714}, {1870,58.1928000}, {1880,59.1732857}, {1890,60.0233429}, {1900,61.4924000}, {1910,62.1948571}, {1920,63.4355143}, {1930,63.7387429}, {1940,64.1482857}, {1950,65.1305143}, {1960,66.0527714}, {1970,67.0303429}, {1980,67.6304286}, {1990,69.2032000}, {2000,69.6765429}};
data["big"]["LtacTCPrimPair"]["norm reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00007921}, {7,0.00003960}, {8,0.00000000}, {9,0.00000000}, {10,0.00007921}, {11,0.00003960}, {12,0.00011881}, {13,0.00007921}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00006931}, {18,0.00011881}, {19,0.00000000}, {20,0.00003960}, {21,0.00007921}, {22,0.00003960}, {23,0.00000000}, {24,0.00011881}, {25,0.00000000}, {26,0.00007921}, {27,0.00003960}, {28,0.00007921}, {29,0.00003960}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00007921}, {35,0.00011881}, {36,0.00003960}, {37,0.00000000}, {38,0.00003960}, {39,0.00007921}, {40,0.00000000}, {41,0.00000000}, {42,0.00003960}, {43,0.00000000}, {44,0.00007921}, {45,0.00007921}, {46,0.00000000}, {47,0.00002970}, {48,0.00007921}, {49,0.00003960}, {50,0.00000000}, {51,0.00007921}, {52,0.00002970}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00003960}, {57,0.00000000}, {58,0.00015842}, {59,0.00007921}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00003960}, {64,0.00000000}, {65,0.00003960}, {66,0.00000000}, {67,0.00007921}, {68,0.00000000}, {69,0.00000000}, {70,0.00003960}, {71,0.00000000}, {72,0.00003960}, {73,0.00000000}, {74,0.00003960}, {75,0.00003960}, {76,0.00003960}, {77,0.00003960}, {78,0.00003960}, {79,0.00003960}, {80,0.00003960}, {81,0.00002970}, {82,0.00000000}, {83,0.00003960}, {84,0.00003960}, {85,0.00000000}, {86,0.00002970}, {87,0.00000000}, {88,0.00000000}, {89,0.00007921}, {90,0.00003960}, {91,0.00000000}, {92,0.00003960}, {93,0.00000000}, {94,0.00003960}, {95,0.00003960}, {96,0.00000000}, {97,0.00007921}, {98,0.00003960}, {99,0.00000000}, {100,0.00000000}, {101,0.00007921}, {102,0.00003960}, {103,0.00003960}, {104,0.00003960}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00003960}, {111,0.00003960}, {112,0.00011881}, {113,0.00015842}, {114,0.00007921}, {115,0.00019802}, {116,0.00007921}, {117,0.00007921}, {118,0.00003960}, {119,0.00006931}, {120,0.00003960}, {121,0.00003960}, {122,0.00003960}, {123,0.00000000}, {124,0.00003960}, {125,0.00000000}, {126,0.00003960}, {127,0.00003960}, {128,0.00003960}, {129,0.00003960}, {130,0.00003960}, {131,0.00000000}, {132,0.00003960}, {133,0.00003960}, {134,0.00003960}, {135,0.00003960}, {136,0.00003960}, {137,0.00000000}, {138,0.00007921}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00003960}, {144,0.00002970}, {145,0.00007921}, {146,0.00006931}, {147,0.00003960}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00003960}, {153,0.00000000}, {154,0.00003960}, {155,0.00000000}, {156,0.00003960}, {157,0.00003960}, {158,0.00003960}, {159,0.00000000}, {160,0.00003960}, {161,0.00000000}, {162,0.00011881}, {163,0.00007921}, {164,0.00003960}, {165,0.00003960}, {166,0.00007921}, {167,0.00000000}, {168,0.00003960}, {169,0.00003960}, {170,0.00003960}, {171,0.00003960}, {172,0.00007921}, {173,0.00000000}, {174,0.00007921}, {175,0.00000000}, {176,0.00000000}, {177,0.00003960}, {178,0.00007921}, {179,0.00000000}, {180,0.00000000}, {181,0.00003960}, {182,0.00003960}, {183,0.00000000}, {184,0.00000000}, {185,0.00007921}, {186,0.00003960}, {187,0.00003960}, {188,0.00007921}, {189,0.00003960}, {190,0.00007921}, {191,0.00003960}, {192,0.00007921}, {193,0.00007921}, {194,0.00003960}, {195,0.00003960}, {196,0.00003960}, {197,0.00003960}, {198,0.00000000}, {199,0.00011881}, {200,0.00003960}, {201,0.00000000}, {202,0.00000000}, {203,0.00007921}, {204,0.00011881}, {205,0.00000000}, {206,0.00003960}, {207,0.00000000}, {208,0.00007921}, {209,0.00007921}, {210,0.00007921}, {211,0.00003960}, {212,0.00000000}, {213,0.00003960}, {214,0.00007921}, {215,0.00003960}, {216,0.00000000}, {217,0.00007921}, {218,0.00011881}, {219,0.00023762}, {220,0.00011881}, {221,0.00003960}, {222,0.00003960}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00011881}, {227,0.00002970}, {228,0.00007921}, {229,0.00011881}, {230,0.00010891}, {231,0.00007921}, {232,0.00015842}, {233,0.00000000}, {234,0.00007921}, {235,0.00000000}, {236,0.00007921}, {237,0.00047525}, {238,0.00003960}, {239,0.00035644}, {240,0.00003960}, {241,0.00000000}, {242,0.00011881}, {243,0.00007921}, {244,0.00000000}, {245,0.00031683}, {246,0.00007921}, {247,0.00003960}, {248,0.00007921}, {249,0.00003960}, {250,0.00007921}, {251,0.00011881}, {252,0.00015842}, {253,0.00000000}, {254,0.00007921}, {255,0.00007921}, {256,0.00003960}, {257,0.00000000}, {258,0.00011881}, {259,0.00000000}, {260,0.00000000}, {261,0.00007921}, {262,0.00000000}, {263,0.00003960}, {264,0.00003960}, {265,0.00003960}, {266,0.00003960}, {267,0.00007921}, {268,0.00003960}, {269,0.00015842}, {270,0.00015842}, {271,0.00003960}, {272,0.00015842}, {273,0.00000000}, {274,0.00007921}, {275,0.00019802}, {276,0.00011881}, {277,0.00000000}, {278,0.00015842}, {279,0.00011881}, {280,0.00007921}, {281,0.00011881}, {282,0.00007921}, {283,0.00007921}, {284,0.00003960}, {285,0.00000000}, {286,0.00007921}, {287,0.00011881}, {288,0.00003960}, {289,0.00011881}, {290,0.00000000}, {291,0.00007921}, {292,0.00011881}, {293,0.00007921}, {294,0.00023762}, {295,0.00003960}, {296,0.00019802}, {297,0.00007921}, {298,0.00007921}, {299,0.00003960}, {300,0.00011881}, {301,0.0002286}, {302,0.0002286}, {303,0.0003429}, {304,0.0003429}, {305,0.0001143}, {306,0.0002286}, {307,0.0003143}, {308,0.0000000}, {309,0.0002000}, {310,0.0002286}, {311,0.0000000}, {312,0.0001143}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0002286}, {317,0.0000000}, {318,0.0001143}, {319,0.0000000}, {320,0.0002286}, {321,0.0000000}, {322,0.0001143}, {323,0.0004571}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0002286}, {330,0.0001143}, {331,0.0002286}, {332,0.0000000}, {333,0.0001143}, {334,0.0000000}, {335,0.0004571}, {336,0.0003429}, {337,0.0000000}, {338,0.0003429}, {339,0.0003429}, {340,0.0000000}, {341,0.0001143}, {342,0.0002286}, {343,0.0001143}, {344,0.0001143}, {345,0.0000000}, {346,0.0000000}, {347,0.0002286}, {348,0.0004571}, {349,0.0001143}, {350,0.0002286}, {351,0.0000000}, {352,0.0001143}, {353,0.0002286}, {354,0.0000000}, {355,0.0002286}, {356,0.0002286}, {357,0.0000000}, {358,0.0000000}, {359,0.0001143}, {360,0.0000000}, {361,0.0001143}, {362,0.0001143}, {363,0.0000000}, {364,0.0001143}, {365,0.0001143}, {366,0.0001143}, {367,0.0002286}, {368,0.0000000}, {369,0.0002286}, {370,0.0000000}, {371,0.0003429}, {372,0.0000000}, {373,0.0004571}, {374,0.0002286}, {375,0.0001143}, {376,0.0000000}, {377,0.0002286}, {378,0.0003429}, {379,0.0001143}, {380,0.0001143}, {381,0.0005714}, {382,0.0001143}, {383,0.0004571}, {384,0.0002286}, {385,0.0004571}, {386,0.0003429}, {387,0.0001143}, {388,0.0002286}, {389,0.0001143}, {390,0.0001143}, {391,0.0002286}, {392,0.0002286}, {393,0.0001143}, {394,0.0002286}, {395,0.0001143}, {396,0.0000000}, {397,0.0002286}, {398,0.0004571}, {399,0.0001143}, {400,0.0004571}, {401,0.0006857}, {402,0.0002286}, {403,0.0001143}, {404,0.0000000}, {405,0.0004571}, {406,0.0001143}, {407,0.0002286}, {408,0.0001143}, {409,0.0000000}, {410,0.0000000}, {411,0.0001143}, {412,0.0002286}, {413,0.0001143}, {414,0.0002286}, {415,0.0001143}, {416,0.0001143}, {417,0.0003429}, {418,0.0002286}, {419,0.0000000}, {420,0.0000000}, {421,0.0001143}, {422,0.0001143}, {423,0.0003429}, {424,0.0000000}, {425,0.0002286}, {426,0.0002286}, {427,0.0003429}, {428,0.0005714}, {429,0.0001143}, {430,0.0002286}, {431,0.0003429}, {432,0.0006571}, {433,0.0001143}, {434,0.0004571}, {435,0.0001143}, {436,0.0001143}, {437,0.0002286}, {438,0.0004571}, {439,0.0000000}, {440,0.0002286}, {441,0.0001143}, {442,0.0000000}, {443,0.0003429}, {444,0.0005714}, {445,0.0002286}, {446,0.0005429}, {447,0.0003429}, {448,0.0003429}, {449,0.0002286}, {450,0.0003429}, {451,0.0001143}, {452,0.0000000}, {453,0.0000000}, {454,0.0002286}, {455,0.0000000}, {456,0.0002286}, {457,0.0005714}, {458,0.0002000}, {459,0.0002286}, {460,0.0003429}, {461,0.0003429}, {462,0.0004571}, {463,0.0005714}, {464,0.0001143}, {465,0.0006857}, {466,0.0005714}, {467,0.0005714}, {468,0.0002286}, {469,0.0004571}, {470,0.0003429}, {471,0.0006857}, {472,0.0004571}, {473,0.0009143}, {474,0.0012571}, {475,0.0004571}, {476,0.0001143}, {477,0.0001143}, {478,0.0003429}, {479,0.0012286}, {480,0.0006857}, {481,0.0002286}, {482,0.0003429}, {483,0.0004571}, {484,0.0002286}, {485,0.0009143}, {486,0.0002286}, {487,0.0014857}, {488,0.0002286}, {489,0.0000000}, {490,0.0002286}, {491,0.0002286}, {492,0.0000000}, {493,0.0005714}, {494,0.0004571}, {495,0.0002286}, {496,0.0000000}, {497,0.0000000}, {498,0.0002286}, {499,0.0000000}, {500,0.0004571}, {505,0.0010286}, {510,0.0001143}, {515,0.0010286}, {520,0.0002286}, {525,0.0008000}, {530,0.0013714}, {535,0.0004571}, {540,0.0009143}, {545,0.0002286}, {550,0.0005714}, {555,0.0013714}, {560,0.0009143}, {565,0.0018286}, {570,0.0013714}, {575,0.0002286}, {580,0.0006857}, {585,0.0002286}, {590,0.0005714}, {595,0.0006857}, {600,0.0006857}, {605,0.0010286}, {610,0.0012571}, {615,0.0019429}, {620,0.0009143}, {625,0.0011429}, {630,0.0004571}, {635,0.0016857}, {640,0.0010286}, {645,0.0022571}, {650,0.0009143}, {655,0.0016857}, {660,0.0010286}, {665,0.0016000}, {670,0.0013714}, {675,0.0009143}, {680,0.0005714}, {685,0.0015714}, {690,0.0018286}, {695,0.0006571}, {700,0.0021714}, {705,0.0033143}, {710,0.0028571}, {715,0.0038857}, {720,0.0035429}, {725,0.0017143}, {730,0.0040000}, {735,0.0044571}, {740,0.0048000}, {745,0.0035429}, {750,0.0033143}, {755,0.0024000}, {760,0.0036286}, {765,0.0050857}, {770,0.0039714}, {775,0.0021714}, {780,0.0038857}, {785,0.0027143}, {790,0.0043429}, {795,0.0050286}, {800,0.0057143}, {805,0.0047714}, {810,0.0053714}, {815,0.0062571}, {820,0.0059143}, {825,0.0080857}, {830,0.0072857}, {835,0.0057714}, {840,0.0061429}, {845,0.0064857}, {850,0.0045714}, {855,0.0054857}, {860,0.0067143}, {865,0.0066286}, {870,0.0056857}, {875,0.0099429}, {880,0.0058000}, {885,0.0039429}, {890,0.0051143}, {895,0.0043429}, {900,0.0045429}, {905,0.0066286}, {910,0.0053143}, {915,0.0062571}, {920,0.0068571}, {925,0.0057143}, {930,0.0068000}, {935,0.0058857}, {940,0.0056571}, {945,0.0085429}, {950,0.0061143}, {955,0.0081143}, {960,0.0040000}, {965,0.0091429}, {970,0.0113429}, {975,0.0093143}, {980,0.0093429}, {985,0.0060286}, {990,0.0082000}, {995,0.0065143}, {1000,0.0069429}, {1010,0.0099143}, {1020,0.0069429}, {1030,0.0087714}, {1040,0.0054571}, {1050,0.0096286}, {1060,0.0045429}, {1070,0.0066286}, {1080,0.0058571}, {1090,0.0047714}, {1100,0.0073429}, {1110,0.0076286}, {1120,0.0050286}, {1130,0.0056571}, {1140,0.0089143}, {1150,0.0102286}, {1160,0.0071143}, {1170,0.0094000}, {1180,0.0075714}, {1190,0.0053143}, {1200,0.0073143}, {1210,0.0075714}, {1220,0.0125143}, {1230,0.0097714}, {1240,0.0056857}, {1250,0.0090857}, {1260,0.0077714}, {1270,0.0089143}, {1280,0.0066857}, {1290,0.0080000}, {1300,0.0064000}, {1310,0.0055714}, {1320,0.0054000}, {1330,0.0053714}, {1340,0.0090857}, {1350,0.0089143}, {1360,0.0119143}, {1370,0.0075143}, {1380,0.0094286}, {1390,0.0068857}, {1400,0.0078286}, {1410,0.0062571}, {1420,0.0107143}, {1430,0.0080000}, {1440,0.0090571}, {1450,0.0072571}, {1460,0.0114857}, {1470,0.0091429}, {1480,0.0088000}, {1490,0.0063429}, {1500,0.0119429}, {1510,0.0122286}, {1520,0.0138000}, {1530,0.0087429}, {1540,0.0089429}, {1550,0.0110286}, {1560,0.0110571}, {1570,0.0096286}, {1580,0.0177429}, {1590,0.0108286}, {1600,0.0112000}, {1610,0.0162000}, {1620,0.0142286}, {1630,0.0167143}, {1640,0.0128857}, {1650,0.0168857}, {1660,0.0169714}, {1670,0.0122286}, {1680,0.0120286}, {1690,0.0110571}, {1700,0.0237714}, {1710,0.0131714}, {1720,0.0167714}, {1730,0.0126857}, {1740,0.0136857}, {1750,0.0190000}, {1760,0.0190286}, {1770,0.0234286}, {1780,0.0142857}, {1790,0.0240286}, {1800,0.0214571}, {1810,0.0210286}, {1820,0.0218286}, {1830,0.0216000}, {1840,0.0260000}, {1850,0.0219429}, {1860,0.0210571}, {1870,0.0231143}, {1880,0.0204000}, {1890,0.0274571}, {1900,0.0253714}, {1910,0.0145714}, {1920,0.0229429}, {1930,0.0159714}, {1940,0.0293714}, {1950,0.0255429}, {1960,0.0133429}, {1970,0.0240857}, {1980,0.0230571}, {1990,0.0208000}, {2000,0.0216571}};
data["big"]["LtacTCPrimPair"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCPrimPair"]["post"]["user"] = {{1,0.00006931}, {2,0.00000000}, {3,0.00003960}, {4,0.00003960}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00003960}, {9,0.00003960}, {10,0.00006931}, {11,0.00000000}, {12,0.00000000}, {13,0.00006931}, {14,0.00003960}, {15,0.00003960}, {16,0.00006931}, {17,0.00003960}, {18,0.00000000}, {19,0.00003960}, {20,0.00000000}, {21,0.00000000}, {22,0.00002970}, {23,0.00003960}, {24,0.00003960}, {25,0.00000000}, {26,0.00007921}, {27,0.00000000}, {28,0.00003960}, {29,0.00003960}, {30,0.00003960}, {31,0.00003960}, {32,0.00003960}, {33,0.00003960}, {34,0.00000000}, {35,0.00000000}, {36,0.00003960}, {37,0.00003960}, {38,0.00003960}, {39,0.00003960}, {40,0.00006931}, {41,0.00003960}, {42,0.00007921}, {43,0.00000000}, {44,0.00003960}, {45,0.00000000}, {46,0.00000000}, {47,0.00003960}, {48,0.00000000}, {49,0.00000000}, {50,0.00006931}, {51,0.00000000}, {52,0.00003960}, {53,0.00000000}, {54,0.00003960}, {55,0.00000000}, {56,0.00006931}, {57,0.00003960}, {58,0.00003960}, {59,0.00007921}, {60,0.00000000}, {61,0.00002970}, {62,0.00000000}, {63,0.00000000}, {64,0.00003960}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00003960}, {70,0.00002970}, {71,0.00000000}, {72,0.00003960}, {73,0.00000000}, {74,0.00000000}, {75,0.00007921}, {76,0.00003960}, {77,0.00003960}, {78,0.00002970}, {79,0.00003960}, {80,0.00010891}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00003960}, {85,0.00000000}, {86,0.00003960}, {87,0.00003960}, {88,0.00003960}, {89,0.00000000}, {90,0.00003960}, {91,0.00003960}, {92,0.00003960}, {93,0.00000000}, {94,0.00007921}, {95,0.00000000}, {96,0.00000000}, {97,0.00003960}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00007921}, {103,0.00000000}, {104,0.00003960}, {105,0.00000000}, {106,0.00003960}, {107,0.00007921}, {108,0.00000000}, {109,0.00003960}, {110,0.00002970}, {111,0.00003960}, {112,0.00000000}, {113,0.00000000}, {114,0.00011881}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00003960}, {119,0.00000000}, {120,0.00007921}, {121,0.00003960}, {122,0.00003960}, {123,0.00007921}, {124,0.00003960}, {125,0.00002970}, {126,0.00000000}, {127,0.00003960}, {128,0.00000000}, {129,0.00003960}, {130,0.00000000}, {131,0.00007921}, {132,0.00011881}, {133,0.00003960}, {134,0.00000000}, {135,0.00000000}, {136,0.00002970}, {137,0.00000000}, {138,0.00009901}, {139,0.00003960}, {140,0.00003960}, {141,0.00000000}, {142,0.00000000}, {143,0.00007921}, {144,0.00003960}, {145,0.00003960}, {146,0.00003960}, {147,0.00000000}, {148,0.00000000}, {149,0.00007921}, {150,0.00007921}, {151,0.00007921}, {152,0.00006931}, {153,0.00003960}, {154,0.00000000}, {155,0.00002970}, {156,0.00003960}, {157,0.00002970}, {158,0.00000000}, {159,0.00000000}, {160,0.00002970}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00006931}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00003960}, {171,0.00007921}, {172,0.00000000}, {173,0.00000000}, {174,0.00005941}, {175,0.00000000}, {176,0.00003960}, {177,0.00003960}, {178,0.00007921}, {179,0.00007921}, {180,0.00000000}, {181,0.00003960}, {182,0.00000000}, {183,0.00000000}, {184,0.00010891}, {185,0.00003960}, {186,0.00000000}, {187,0.00000000}, {188,0.00007921}, {189,0.00000000}, {190,0.00010891}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00010891}, {195,0.00000000}, {196,0.00000000}, {197,0.00007921}, {198,0.00000000}, {199,0.00003960}, {200,0.00000000}, {201,0.00000000}, {202,0.00003960}, {203,0.00000000}, {204,0.00002970}, {205,0.00000000}, {206,0.00000000}, {207,0.00007921}, {208,0.00000000}, {209,0.00003960}, {210,0.00003960}, {211,0.00003960}, {212,0.00003960}, {213,0.00002970}, {214,0.00007921}, {215,0.00007921}, {216,0.00003960}, {217,0.00006931}, {218,0.00003960}, {219,0.00003960}, {220,0.00000000}, {221,0.00006931}, {222,0.00007921}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00007921}, {227,0.00000000}, {228,0.00011881}, {229,0.00007921}, {230,0.00003960}, {231,0.00000000}, {232,0.00003960}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00003960}, {239,0.00003960}, {240,0.00003960}, {241,0.00000000}, {242,0.00003960}, {243,0.00000000}, {244,0.00007921}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00007921}, {250,0.00000000}, {251,0.00003960}, {252,0.00000000}, {253,0.00000000}, {254,0.00003960}, {255,0.00000000}, {256,0.00002970}, {257,0.00003960}, {258,0.00000000}, {259,0.00006931}, {260,0.00013861}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00003960}, {265,0.00003960}, {266,0.00002970}, {267,0.00007921}, {268,0.00002970}, {269,0.00003960}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00003960}, {274,0.00002970}, {275,0.00000000}, {276,0.00002970}, {277,0.00010891}, {278,0.00009901}, {279,0.00000000}, {280,0.00002970}, {281,0.00006931}, {282,0.00005941}, {283,0.00008911}, {284,0.00000000}, {285,0.00003960}, {286,0.00012871}, {287,0.00000000}, {288,0.00000000}, {289,0.00005941}, {290,0.00000000}, {291,0.00000000}, {292,0.00002970}, {293,0.00003960}, {294,0.00002970}, {295,0.00008911}, {296,0.00003960}, {297,0.00000000}, {298,0.00002970}, {299,0.00000000}, {300,0.00006931}, {301,0.0000857}, {302,0.0000000}, {303,0.0001143}, {304,0.0000000}, {305,0.0000000}, {306,0.0001143}, {307,0.0000000}, {308,0.0000000}, {309,0.0000857}, {310,0.0000000}, {311,0.0000857}, {312,0.0000000}, {313,0.0000000}, {314,0.0000857}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000857}, {323,0.0000857}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000857}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000857}, {335,0.0000000}, {336,0.0000000}, {337,0.0001143}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0001714}, {353,0.0000000}, {354,0.0000000}, {355,0.0000857}, {356,0.0000000}, {357,0.0000000}, {358,0.0001143}, {359,0.0000000}, {360,0.0000000}, {361,0.0000857}, {362,0.0000000}, {363,0.0001143}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000857}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0001143}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000857}, {390,0.0000857}, {391,0.0001143}, {392,0.0000000}, {393,0.0000000}, {394,0.0001714}, {395,0.0000857}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0001714}, {401,0.0000000}, {402,0.0000000}, {403,0.0002000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000857}, {407,0.0000000}, {408,0.0000857}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0001143}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000857}, {419,0.0000000}, {420,0.0000000}, {421,0.0001143}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0001714}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000857}, {431,0.0000000}, {432,0.0000000}, {433,0.0000857}, {434,0.0002571}, {435,0.0000000}, {436,0.0000857}, {437,0.0000000}, {438,0.0000000}, {439,0.0000857}, {440,0.0000000}, {441,0.0000000}, {442,0.0000857}, {443,0.0000857}, {444,0.0000000}, {445,0.0000857}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000857}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0001714}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0001143}, {473,0.0000857}, {474,0.0000857}, {475,0.0000857}, {476,0.0000857}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000857}, {483,0.0000857}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000857}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000857}, {500,0.0000857}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000857}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000857}, {605,0.0001714}, {610,0.0000000}, {615,0.0000000}, {620,0.0001714}, {625,0.0000857}, {630,0.0000000}, {635,0.0000857}, {640,0.0000857}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000857}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000857}, {705,0.0000000}, {710,0.0000857}, {715,0.0000857}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0001143}, {815,0.0000857}, {820,0.0000000}, {825,0.0000000}, {830,0.0000857}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000857}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000857}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000857}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000857}, {970,0.0000000}, {975,0.0000000}, {980,0.0000857}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000857}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000857}, {1220,0.0000857}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0001143}, {1260,0.0000000}, {1270,0.0000857}, {1280,0.0002000}, {1290,0.0000857}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0001143}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000857}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000857}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000857}, {1480,0.0000000}, {1490,0.0002286}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0001143}, {1580,0.0000000}, {1590,0.0001143}, {1600,0.0000000}, {1610,0.0000857}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0001143}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0001143}, {1700,0.0000000}, {1710,0.0001143}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000857}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0001143}, {1870,0.0001143}, {1880,0.0000000}, {1890,0.0001143}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0001143}, {1940,0.0001143}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0001143}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000857}};
data["big"]["LtacTCPrimPair"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00003960}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00003960}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCPrimPair"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCPrimPair"]["pre"]["user"] = {{1,0.00000000}, {2,0.00003960}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00003960}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00002970}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00003960}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00007921}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00003960}, {63,0.00003960}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00003960}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00003960}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00002970}, {95,0.00000000}, {96,0.00007921}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00003960}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00003960}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00003960}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00003960}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00003960}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00007921}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00003960}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00003960}, {183,0.00000000}, {184,0.00000000}, {185,0.00002970}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00003960}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00002970}, {207,0.00000000}, {208,0.00002970}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00003960}, {214,0.00000000}, {215,0.00000000}, {216,0.00002970}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00002970}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00007921}, {234,0.00000000}, {235,0.00003960}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00002970}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00003960}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00003960}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00002970}, {289,0.00000000}, {290,0.00005941}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000857}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000857}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000857}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000857}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000857}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000857}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0001143}, {580,0.0000000}, {585,0.0000857}, {590,0.0000000}, {595,0.0000000}, {600,0.0000857}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000857}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000857}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0001714}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0001143}, {1400,0.0000857}, {1410,0.0000000}, {1420,0.0001143}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0001143}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCPrimPair"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0001143}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0001143}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTCPrimPair"]["reif"]["real"] = {{1,0.00001980}, {2,0.00100990}, {3,0.00100000}, {4,0.00100000}, {5,0.00200000}, {6,0.00200000}, {7,0.00244554}, {8,0.00300000}, {9,0.00307921}, {10,0.00400000}, {11,0.00400990}, {12,0.00441584}, {13,0.00500990}, {14,0.00556436}, {15,0.00604950}, {16,0.00647525}, {17,0.00702970}, {18,0.00755446}, {19,0.00801980}, {20,0.00950495}, {21,0.00904950}, {22,0.00974257}, {23,0.01020792}, {24,0.01079208}, {25,0.01158416}, {26,0.01186139}, {27,0.01275248}, {28,0.01639604}, {29,0.01368317}, {30,0.01445545}, {31,0.01481188}, {32,0.01539604}, {33,0.01614851}, {34,0.02068317}, {35,0.01707921}, {36,0.01830693}, {37,0.01867327}, {38,0.02212871}, {39,0.02305941}, {40,0.02029703}, {41,0.02136634}, {42,0.02194059}, {43,0.02314851}, {44,0.02379208}, {45,0.02429703}, {46,0.02518812}, {47,0.02607921}, {48,0.02707921}, {49,0.02710891}, {50,0.02749505}, {51,0.02908911}, {52,0.02992079}, {53,0.03083168}, {54,0.03176238}, {55,0.03342574}, {56,0.03331683}, {57,0.03383168}, {58,0.03521782}, {59,0.03476238}, {60,0.04013861}, {61,0.04301980}, {62,0.04478218}, {63,0.04512871}, {64,0.04401980}, {65,0.04022772}, {66,0.04229703}, {67,0.04301980}, {68,0.04406931}, {69,0.04883168}, {70,0.04547525}, {71,0.04746535}, {72,0.04696040}, {73,0.04903960}, {74,0.04906931}, {75,0.05090099}, {76,0.05171287}, {77,0.06251485}, {78,0.05423762}, {79,0.05500990}, {80,0.05626733}, {81,0.05647525}, {82,0.05741584}, {83,0.05863366}, {84,0.05922772}, {85,0.06080198}, {86,0.07738614}, {87,0.08162376}, {88,0.07390099}, {89,0.07813861}, {90,0.07797030}, {91,0.07668317}, {92,0.07679208}, {93,0.07670297}, {94,0.07722772}, {95,0.07829703}, {96,0.07887129}, {97,0.07900990}, {98,0.07962376}, {99,0.07994059}, {100,0.08172277}, {101,0.08259406}, {102,0.08345545}, {103,0.08482178}, {104,0.08427723}, {105,0.08612871}, {106,0.08772277}, {107,0.08892079}, {108,0.09008911}, {109,0.09171287}, {110,0.09234653}, {111,0.09419802}, {112,0.09621782}, {113,0.09798020}, {114,0.09920792}, {115,0.10152475}, {116,0.10160396}, {117,0.10350495}, {118,0.10575248}, {119,0.10788119}, {120,0.10938614}, {121,0.11118812}, {122,0.11235644}, {123,0.12439604}, {124,0.12710891}, {125,0.12952475}, {126,0.13320792}, {127,0.13590099}, {128,0.12257426}, {129,0.14479208}, {130,0.14726733}, {131,0.14772277}, {132,0.14962376}, {133,0.14934653}, {134,0.15413861}, {135,0.15611881}, {136,0.15868317}, {137,0.15786139}, {138,0.16320792}, {139,0.16283168}, {140,0.16585149}, {141,0.16951485}, {142,0.17015842}, {143,0.17387129}, {144,0.17435644}, {145,0.17553465}, {146,0.17773267}, {147,0.17843564}, {148,0.18179208}, {149,0.18453465}, {150,0.18578218}, {151,0.18666337}, {152,0.18706931}, {153,0.19411881}, {154,0.19580198}, {155,0.19714851}, {156,0.20021782}, {157,0.20149505}, {158,0.20180198}, {159,0.20559406}, {160,0.20772277}, {161,0.21002970}, {162,0.20973267}, {163,0.21471287}, {164,0.21539604}, {165,0.22004950}, {166,0.22076238}, {167,0.22041584}, {168,0.22712871}, {169,0.22918812}, {170,0.23030693}, {171,0.23541584}, {172,0.23618812}, {173,0.23882178}, {174,0.23930693}, {175,0.24108911}, {176,0.24648515}, {177,0.24888119}, {178,0.25303960}, {179,0.25619802}, {180,0.25545545}, {181,0.25990099}, {182,0.26258416}, {183,0.26658416}, {184,0.26839604}, {185,0.26945545}, {186,0.27088119}, {187,0.27383168}, {188,0.27452475}, {189,0.27609901}, {190,0.28707921}, {191,0.29001980}, {192,0.29324752}, {193,0.29444554}, {194,0.29493069}, {195,0.29366337}, {196,0.29522772}, {197,0.29913861}, {198,0.30002970}, {199,0.30193069}, {200,0.31158416}, {201,0.31726733}, {202,0.31424752}, {203,0.31479208}, {204,0.31872277}, {205,0.32031683}, {206,0.32732673}, {207,0.33851485}, {208,0.32599010}, {209,0.33306931}, {210,0.33480198}, {211,0.34379208}, {212,0.35030693}, {213,0.34405941}, {214,0.34490099}, {215,0.35529703}, {216,0.35843564}, {217,0.35593069}, {218,0.36467327}, {219,0.36991089}, {220,0.36756436}, {221,0.37109901}, {222,0.37988119}, {223,0.37908911}, {224,0.38522772}, {225,0.38598020}, {226,0.38798020}, {227,0.39541584}, {228,0.39261386}, {229,0.39877228}, {230,0.39956436}, {231,0.40895050}, {232,0.40744554}, {233,0.40946535}, {234,0.41396040}, {235,0.41981188}, {236,0.42030693}, {237,0.42664356}, {238,0.42534653}, {239,0.43562376}, {240,0.43188119}, {241,0.44635644}, {242,0.44140594}, {243,0.44754455}, {244,0.45101980}, {245,0.45223762}, {246,0.45763366}, {247,0.46558416}, {248,0.46274257}, {249,0.46994059}, {250,0.47852475}, {251,0.47635644}, {252,0.49185149}, {253,0.48764356}, {254,0.48226733}, {255,0.49172277}, {256,0.49610891}, {257,0.49607921}, {258,0.50104950}, {259,0.50053465}, {260,0.51120792}, {261,0.51531683}, {262,0.51172277}, {263,0.51734653}, {264,0.52167327}, {265,0.52331683}, {266,0.53050495}, {267,0.53640594}, {268,0.53813861}, {269,0.53981188}, {270,0.54474257}, {271,0.55048515}, {272,0.56728713}, {273,0.55714851}, {274,0.57778218}, {275,0.56620792}, {276,0.57141584}, {277,0.57912871}, {278,0.58433663}, {279,0.61968317}, {280,0.58437624}, {281,0.58623762}, {282,0.59187129}, {283,0.59720792}, {284,0.60046535}, {285,0.60288119}, {286,0.60716832}, {287,0.61787129}, {288,0.61787129}, {289,0.62162376}, {290,0.62837624}, {291,0.64096040}, {292,0.65093069}, {293,0.65789109}, {294,0.66136634}, {295,0.66845545}, {296,0.67033663}, {297,0.67328713}, {298,0.67568317}, {299,0.68378218}, {300,0.68939604}, {301,0.7120571}, {302,0.7565714}, {303,0.7388857}, {304,0.7479429}, {305,0.7252571}, {306,0.7288286}, {307,0.7400857}, {308,0.7435714}, {309,0.7458000}, {310,0.7499714}, {311,0.7543429}, {312,0.7616857}, {313,0.7655143}, {314,0.7731429}, {315,0.7748286}, {316,0.7761429}, {317,0.7808286}, {318,0.7900571}, {319,0.7969429}, {320,0.8101714}, {321,0.8031429}, {322,0.8078571}, {323,0.8152000}, {324,0.8145429}, {325,0.8216857}, {326,0.8303714}, {327,0.8376857}, {328,0.8392571}, {329,0.8470286}, {330,0.8477714}, {331,0.8577143}, {332,0.8580286}, {333,0.8639714}, {334,0.8695429}, {335,0.8736857}, {336,0.8831714}, {337,0.8832571}, {338,0.8923714}, {339,0.8956571}, {340,0.9010857}, {341,0.9038857}, {342,0.9186000}, {343,0.9211714}, {344,0.9333143}, {345,0.9541429}, {346,0.9459143}, {347,0.9420286}, {348,0.9518000}, {349,0.9504571}, {350,0.9629143}, {351,0.9726000}, {352,0.9710286}, {353,0.9755714}, {354,0.9811143}, {355,0.9924571}, {356,0.9892286}, {357,0.9982571}, {358,1.0032000}, {359,1.0048571}, {360,1.0072286}, {361,1.0416000}, {362,1.0257429}, {363,1.0292000}, {364,1.0378000}, {365,1.0384571}, {366,1.0435714}, {367,1.0495429}, {368,1.0636857}, {369,1.0844571}, {370,1.0726571}, {371,1.1013143}, {372,1.0860000}, {373,1.0918000}, {374,1.0936857}, {375,1.1092286}, {376,1.1128286}, {377,1.1139714}, {378,1.1660286}, {379,1.1285143}, {380,1.1522286}, {381,1.1368000}, {382,1.1651429}, {383,1.1567714}, {384,1.1813143}, {385,1.1723429}, {386,1.1986857}, {387,1.1866857}, {388,1.1960000}, {389,1.1949714}, {390,1.2045143}, {391,1.2100000}, {392,1.2674000}, {393,1.2206000}, {394,1.2322286}, {395,1.2376286}, {396,1.2693429}, {397,1.2535429}, {398,1.2799143}, {399,1.2820286}, {400,1.2935143}, {401,1.2728857}, {402,1.2867143}, {403,1.2884000}, {404,1.3179143}, {405,1.3034857}, {406,1.3128857}, {407,1.3453714}, {408,1.3312571}, {409,1.3299714}, {410,1.3393143}, {411,1.3439429}, {412,1.3434571}, {413,1.3512571}, {414,1.3618571}, {415,1.3945143}, {416,1.3727714}, {417,1.3771429}, {418,1.3841429}, {419,1.3885429}, {420,1.3992571}, {421,1.4074857}, {422,1.4144286}, {423,1.4236571}, {424,1.4292857}, {425,1.4345714}, {426,1.4434000}, {427,1.4522000}, {428,1.4634000}, {429,1.4770857}, {430,1.4970571}, {431,1.4902286}, {432,1.5090857}, {433,1.5127714}, {434,1.5199714}, {435,1.5307143}, {436,1.5395429}, {437,1.5486000}, {438,1.5526000}, {439,1.5645714}, {440,1.5718000}, {441,1.5825143}, {442,1.5892571}, {443,1.5928857}, {444,1.6008857}, {445,1.6131143}, {446,1.6212000}, {447,1.6270857}, {448,1.6350857}, {449,1.6378571}, {450,1.6536857}, {451,1.6649143}, {452,1.6645143}, {453,1.6743143}, {454,1.6803143}, {455,1.6940571}, {456,1.7225429}, {457,1.7128857}, {458,1.7387143}, {459,1.7299714}, {460,1.7265429}, {461,1.7387429}, {462,1.7477714}, {463,1.7569714}, {464,1.7728571}, {465,1.7647429}, {466,1.7902571}, {467,1.8215429}, {468,1.8217143}, {469,1.8127714}, {470,1.8144571}, {471,1.8225714}, {472,1.8312571}, {473,1.8328000}, {474,1.8522571}, {475,1.8558571}, {476,1.8565143}, {477,1.8607143}, {478,1.8772857}, {479,1.8866571}, {480,1.9269429}, {481,1.9068286}, {482,1.9193714}, {483,1.9338571}, {484,1.9358571}, {485,1.9584000}, {486,1.9565429}, {487,1.9949429}, {488,1.9680571}, {489,1.9718000}, {490,1.9684571}, {491,2.0016857}, {492,1.9964286}, {493,2.0323714}, {494,2.0383429}, {495,2.0402857}, {496,2.0825714}, {497,2.0463143}, {498,2.0612000}, {499,2.0728571}, {500,2.0791143}, {505,2.1239429}, {510,2.1662000}, {515,2.2491429}, {520,2.2613429}, {525,2.3155714}, {530,2.3550571}, {535,2.3928286}, {540,2.4656000}, {545,2.5265429}, {550,2.5836286}, {555,2.6281429}, {560,2.6895429}, {565,2.7525143}, {570,2.7832571}, {575,2.8551143}, {580,2.9060000}, {585,2.9641143}, {590,3.0493429}, {595,3.0675143}, {600,3.1298857}, {605,3.2184286}, {610,3.3268571}, {615,3.3690571}, {620,3.4330571}, {625,3.5446000}, {630,3.6513714}, {635,3.6294571}, {640,3.7041714}, {645,3.7804286}, {650,3.8069143}, {655,3.9734857}, {660,3.9109143}, {665,3.9549429}, {670,4.0114000}, {675,4.2002857}, {680,4.0766571}, {685,4.2630286}, {690,4.3250000}, {695,4.3352857}, {700,4.5538857}, {705,4.6407143}, {710,4.5501429}, {715,4.7090286}, {720,4.7825143}, {725,4.8309714}, {730,4.8322571}, {735,4.9414286}, {740,5.0459429}, {745,5.1307714}, {750,5.1750286}, {755,5.2546286}, {760,5.3646286}, {765,5.4578571}, {770,5.5534857}, {775,5.5919714}, {780,5.6994286}, {785,5.8240571}, {790,5.8741143}, {795,5.9868000}, {800,6.1380571}, {805,6.1679429}, {810,6.2668000}, {815,6.4187714}, {820,6.4522857}, {825,6.5894571}, {830,6.6610857}, {835,6.7488571}, {840,6.8445429}, {845,6.9407143}, {850,7.1278571}, {855,7.2951143}, {860,7.3043714}, {865,7.4622857}, {870,7.4794286}, {875,7.7465714}, {880,7.7969429}, {885,7.9378857}, {890,8.0667714}, {895,8.1391429}, {900,8.1983143}, {905,8.2867429}, {910,8.3689143}, {915,8.5982571}, {920,8.7206857}, {925,8.8044286}, {930,8.8939429}, {935,8.9628857}, {940,9.3082286}, {945,9.2952857}, {950,9.2798286}, {955,9.5670571}, {960,9.7929714}, {965,9.8003714}, {970,9.9348857}, {975,9.9965143}, {980,10.1238857}, {985,10.3713143}, {990,10.6331143}, {995,10.6042857}, {1000,11.0147143}, {1010,11.1230857}, {1020,11.4197143}, {1030,11.7191143}, {1040,12.1677429}, {1050,12.2731714}, {1060,12.4506571}, {1070,12.7451714}, {1080,13.3457429}, {1090,13.4127429}, {1100,13.7127143}, {1110,14.0995143}, {1120,14.4294857}, {1130,14.6507714}, {1140,15.2187143}, {1150,15.2882286}, {1160,15.7478857}, {1170,16.0941714}, {1180,16.5564857}, {1190,16.7152286}, {1200,17.4361143}, {1210,17.6071143}, {1220,18.0404000}, {1230,18.3273714}, {1240,19.0461714}, {1250,19.2050000}, {1260,19.7178286}, {1270,20.1544571}, {1280,20.5170571}, {1290,21.0254286}, {1300,21.1430857}, {1310,21.8668286}, {1320,22.1190000}, {1330,22.6265429}, {1340,23.3685429}, {1350,23.8790857}, {1360,24.4000000}, {1370,24.6841714}, {1380,25.2968571}, {1390,25.7819143}, {1400,26.0776857}, {1410,26.8018857}, {1420,27.2900571}, {1430,27.5640000}, {1440,28.2982000}, {1450,28.8959429}, {1460,28.9638571}, {1470,29.7117714}, {1480,30.5109143}, {1490,31.1323714}, {1500,31.5084000}, {1510,32.2825714}, {1520,32.9363714}, {1530,33.5834857}, {1540,33.8502000}, {1550,34.6944857}, {1560,35.2904857}, {1570,36.1161429}, {1580,36.0513143}, {1590,37.0086000}, {1600,37.8936000}, {1610,38.1481143}, {1620,39.1738571}, {1630,39.4217429}, {1640,40.1006286}, {1650,40.6105714}, {1660,41.5238571}, {1670,42.2449714}, {1680,43.2760571}, {1690,44.0486286}, {1700,44.9716000}, {1710,45.3058571}, {1720,46.3534286}, {1730,46.9530286}, {1740,47.4314857}, {1750,48.0618000}, {1760,49.0514571}, {1770,49.5652000}, {1780,50.7143429}, {1790,51.2334571}, {1800,52.0099714}, {1810,52.8778571}, {1820,53.5148000}, {1830,54.5802571}, {1840,55.1444857}, {1850,56.3351143}, {1860,56.9202857}, {1870,58.2851143}, {1880,59.2312286}, {1890,60.1120857}, {1900,61.5736571}, {1910,62.2444857}, {1920,63.4835143}, {1930,63.7913714}, {1940,64.2207714}, {1950,65.1972286}, {1960,66.0852857}, {1970,67.0751143}, {1980,67.6743429}, {1990,69.2388000}, {2000,69.7148571}};
data["big"]["LtacTCPrimPair"]["reif"]["user"] = {{1,0.00073267}, {2,0.00100000}, {3,0.00140594}, {4,0.00183168}, {5,0.00221782}, {6,0.00244554}, {7,0.00326733}, {8,0.00327723}, {9,0.00361386}, {10,0.00397030}, {11,0.00434653}, {12,0.00477228}, {13,0.00511881}, {14,0.00614851}, {15,0.00602970}, {16,0.00652475}, {17,0.00725743}, {18,0.00746535}, {19,0.00842574}, {20,0.00933663}, {21,0.00908911}, {22,0.00958416}, {23,0.01044554}, {24,0.01053465}, {25,0.01126733}, {26,0.01170297}, {27,0.01252475}, {28,0.01608911}, {29,0.01355446}, {30,0.01398020}, {31,0.01491089}, {32,0.01525743}, {33,0.01600990}, {34,0.02057426}, {35,0.01673267}, {36,0.01803960}, {37,0.01818812}, {38,0.02254455}, {39,0.02318812}, {40,0.01975248}, {41,0.02153465}, {42,0.02219802}, {43,0.02328713}, {44,0.02396040}, {45,0.02474257}, {46,0.02548515}, {47,0.02635644}, {48,0.02727723}, {49,0.02698020}, {50,0.02758416}, {51,0.02948515}, {52,0.02998020}, {53,0.03072277}, {54,0.03179208}, {55,0.03361386}, {56,0.03311881}, {57,0.03381188}, {58,0.03504950}, {59,0.03460396}, {60,0.04000000}, {61,0.04264356}, {62,0.04447525}, {63,0.04479208}, {64,0.04354455}, {65,0.03996040}, {66,0.04185149}, {67,0.04267327}, {68,0.04381188}, {69,0.04916832}, {70,0.04549505}, {71,0.04757426}, {72,0.04716832}, {73,0.04903960}, {74,0.04967327}, {75,0.05063366}, {76,0.05192079}, {77,0.06216832}, {78,0.05444554}, {79,0.05495050}, {80,0.05600990}, {81,0.05635644}, {82,0.05739604}, {83,0.05866337}, {84,0.05910891}, {85,0.06049505}, {86,0.07743564}, {87,0.08155446}, {88,0.07411881}, {89,0.07855446}, {90,0.07819802}, {91,0.07681188}, {92,0.07707921}, {93,0.07697030}, {94,0.07737624}, {95,0.07848515}, {96,0.07889109}, {97,0.07882178}, {98,0.07938614}, {99,0.07995050}, {100,0.08171287}, {101,0.08241584}, {102,0.08328713}, {103,0.08450495}, {104,0.08400990}, {105,0.08594059}, {106,0.08746535}, {107,0.08837624}, {108,0.08985149}, {109,0.09129703}, {110,0.09192079}, {111,0.09408911}, {112,0.09566337}, {113,0.09810891}, {114,0.09917822}, {115,0.10134653}, {116,0.10150495}, {117,0.10367327}, {118,0.10537624}, {119,0.10762376}, {120,0.10906931}, {121,0.11080198}, {122,0.11187129}, {123,0.12427723}, {124,0.12691089}, {125,0.12922772}, {126,0.13273267}, {127,0.13512871}, {128,0.12245545}, {129,0.14466337}, {130,0.14719802}, {131,0.14747525}, {132,0.14909901}, {133,0.14883168}, {134,0.15408911}, {135,0.15587129}, {136,0.15847525}, {137,0.15746535}, {138,0.16259406}, {139,0.16286139}, {140,0.16548515}, {141,0.16938614}, {142,0.16959406}, {143,0.17358416}, {144,0.17438614}, {145,0.17513861}, {146,0.17707921}, {147,0.17801980}, {148,0.18162376}, {149,0.18393069}, {150,0.18517822}, {151,0.18630693}, {152,0.18651485}, {153,0.19358416}, {154,0.19533663}, {155,0.19705941}, {156,0.19950495}, {157,0.20118812}, {158,0.20108911}, {159,0.20536634}, {160,0.20709901}, {161,0.20965347}, {162,0.20931683}, {163,0.21423762}, {164,0.21497030}, {165,0.21964356}, {166,0.22053465}, {167,0.21997030}, {168,0.22674257}, {169,0.22831683}, {170,0.22955446}, {171,0.23476238}, {172,0.23528713}, {173,0.23800000}, {174,0.23863366}, {175,0.24044554}, {176,0.24568317}, {177,0.24853465}, {178,0.25220792}, {179,0.25570297}, {180,0.25508911}, {181,0.25897030}, {182,0.26207921}, {183,0.26624752}, {184,0.26763366}, {185,0.26896040}, {186,0.27051485}, {187,0.27316832}, {188,0.27363366}, {189,0.27546535}, {190,0.28639604}, {191,0.28913861}, {192,0.29288119}, {193,0.29379208}, {194,0.29447525}, {195,0.29312871}, {196,0.29465347}, {197,0.29864356}, {198,0.29959406}, {199,0.30124752}, {200,0.31089109}, {201,0.31659406}, {202,0.31350495}, {203,0.31414851}, {204,0.31786139}, {205,0.31955446}, {206,0.32638614}, {207,0.33780198}, {208,0.32555446}, {209,0.33227723}, {210,0.33408911}, {211,0.34317822}, {212,0.34955446}, {213,0.34386139}, {214,0.34416832}, {215,0.35485149}, {216,0.35765347}, {217,0.35492079}, {218,0.36366337}, {219,0.36900000}, {220,0.36676238}, {221,0.37053465}, {222,0.37920792}, {223,0.37841584}, {224,0.38474257}, {225,0.38545545}, {226,0.38678218}, {227,0.39471287}, {228,0.39219802}, {229,0.39794059}, {230,0.39857426}, {231,0.40811881}, {232,0.40655446}, {233,0.40900990}, {234,0.41307921}, {235,0.41899010}, {236,0.41949505}, {237,0.42541584}, {238,0.42453465}, {239,0.43443564}, {240,0.43125743}, {241,0.44543564}, {242,0.44038614}, {243,0.44631683}, {244,0.45000000}, {245,0.45082178}, {246,0.45659406}, {247,0.46472277}, {248,0.46152475}, {249,0.46884158}, {250,0.47731683}, {251,0.47535644}, {252,0.49087129}, {253,0.48684158}, {254,0.48146535}, {255,0.49092079}, {256,0.49525743}, {257,0.49516832}, {258,0.50013861}, {259,0.49979208}, {260,0.51034653}, {261,0.51464356}, {262,0.51097030}, {263,0.51668317}, {264,0.52091089}, {265,0.52213861}, {266,0.52977228}, {267,0.53560396}, {268,0.53709901}, {269,0.53858416}, {270,0.54385149}, {271,0.54920792}, {272,0.56624752}, {273,0.55625743}, {274,0.57681188}, {275,0.56523762}, {276,0.57014851}, {277,0.57809901}, {278,0.58325743}, {279,0.61870297}, {280,0.58296040}, {281,0.58499010}, {282,0.59072277}, {283,0.59603960}, {284,0.59936634}, {285,0.60204950}, {286,0.60593069}, {287,0.61632673}, {288,0.61688119}, {289,0.62060396}, {290,0.62744554}, {291,0.63978218}, {292,0.65002970}, {293,0.65660396}, {294,0.66003960}, {295,0.66720792}, {296,0.66891089}, {297,0.67207921}, {298,0.67411881}, {299,0.68245545}, {300,0.68817822}, {301,0.7112857}, {302,0.7520857}, {303,0.7379429}, {304,0.7469143}, {305,0.7245143}, {306,0.7275429}, {307,0.7387429}, {308,0.7426571}, {309,0.7450571}, {310,0.7490286}, {311,0.7534571}, {312,0.7606286}, {313,0.7650857}, {314,0.7722571}, {315,0.7740000}, {316,0.7754286}, {317,0.7801429}, {318,0.7892000}, {319,0.7954571}, {320,0.8046857}, {321,0.8026857}, {322,0.8060571}, {323,0.8143429}, {324,0.8140571}, {325,0.8203714}, {326,0.8297143}, {327,0.8329429}, {328,0.8374857}, {329,0.8452000}, {330,0.8463429}, {331,0.8553429}, {332,0.8564857}, {333,0.8616286}, {334,0.8680000}, {335,0.8701143}, {336,0.8761429}, {337,0.8824857}, {338,0.8905714}, {339,0.8947143}, {340,0.9004857}, {341,0.9029143}, {342,0.9171714}, {343,0.9200286}, {344,0.9315429}, {345,0.9532000}, {346,0.9451143}, {347,0.9404571}, {348,0.9504571}, {349,0.9489429}, {350,0.9619143}, {351,0.9714286}, {352,0.9698857}, {353,0.9745143}, {354,0.9806000}, {355,0.9913143}, {356,0.9876286}, {357,0.9976286}, {358,1.0027143}, {359,1.0038571}, {360,1.0066000}, {361,1.0404857}, {362,1.0249714}, {363,1.0274000}, {364,1.0362857}, {365,1.0372857}, {366,1.0420571}, {367,1.0477714}, {368,1.0618286}, {369,1.0833714}, {370,1.0714857}, {371,1.0996571}, {372,1.0846286}, {373,1.0903143}, {374,1.0923143}, {375,1.1075429}, {376,1.1115714}, {377,1.1123429}, {378,1.1633143}, {379,1.1267429}, {380,1.1502571}, {381,1.1344000}, {382,1.1630571}, {383,1.1541143}, {384,1.1795143}, {385,1.1698571}, {386,1.1970286}, {387,1.1847143}, {388,1.1941429}, {389,1.1931143}, {390,1.2027429}, {391,1.2076000}, {392,1.2660286}, {393,1.2181429}, {394,1.2303429}, {395,1.2363143}, {396,1.2676571}, {397,1.2520000}, {398,1.2775143}, {399,1.2802000}, {400,1.2916571}, {401,1.2706286}, {402,1.2843143}, {403,1.2864286}, {404,1.3149714}, {405,1.3000571}, {406,1.3086286}, {407,1.3380857}, {408,1.3290571}, {409,1.3266857}, {410,1.3370286}, {411,1.3412286}, {412,1.3410000}, {413,1.3491714}, {414,1.3592857}, {415,1.3921143}, {416,1.3707714}, {417,1.3750000}, {418,1.3816286}, {419,1.3866857}, {420,1.3974857}, {421,1.4054857}, {422,1.4124571}, {423,1.4212286}, {424,1.4271714}, {425,1.4322571}, {426,1.4404286}, {427,1.4498286}, {428,1.4600000}, {429,1.4741714}, {430,1.4941714}, {431,1.4868571}, {432,1.5055143}, {433,1.5100286}, {434,1.5172000}, {435,1.5278000}, {436,1.5362000}, {437,1.5459143}, {438,1.5498571}, {439,1.5615143}, {440,1.5680571}, {441,1.5792000}, {442,1.5863714}, {443,1.5901429}, {444,1.5973143}, {445,1.6097429}, {446,1.6169714}, {447,1.6240571}, {448,1.6311429}, {449,1.6351429}, {450,1.6502000}, {451,1.6616286}, {452,1.6620286}, {453,1.6715143}, {454,1.6774000}, {455,1.6908286}, {456,1.7189143}, {457,1.7091714}, {458,1.7351429}, {459,1.7270857}, {460,1.7237429}, {461,1.7357714}, {462,1.7452571}, {463,1.7542286}, {464,1.7701143}, {465,1.7624571}, {466,1.7871714}, {467,1.8190000}, {468,1.8192000}, {469,1.8096286}, {470,1.8119143}, {471,1.8184857}, {472,1.8271429}, {473,1.8286000}, {474,1.8473714}, {475,1.8519143}, {476,1.8524286}, {477,1.8572286}, {478,1.8742857}, {479,1.8814286}, {480,1.9228000}, {481,1.9027429}, {482,1.9147429}, {483,1.9285714}, {484,1.9312286}, {485,1.9529143}, {486,1.9511429}, {487,1.9885714}, {488,1.9629143}, {489,1.9669143}, {490,1.9640286}, {491,1.9976571}, {492,1.9918571}, {493,2.0275429}, {494,2.0340000}, {495,2.0355714}, {496,2.0784571}, {497,2.0427143}, {498,2.0572000}, {499,2.0686571}, {500,2.0748857}, {505,2.1188000}, {510,2.1619714}, {515,2.2425429}, {520,2.2550571}, {525,2.3087143}, {530,2.3485429}, {535,2.3868000}, {540,2.4586571}, {545,2.5196571}, {550,2.5755429}, {555,2.6191143}, {560,2.6815143}, {565,2.7440857}, {570,2.7755143}, {575,2.8475429}, {580,2.8984286}, {585,2.9564286}, {590,3.0427714}, {595,3.0602286}, {600,3.1223714}, {605,3.2104000}, {610,3.3199143}, {615,3.3609429}, {620,3.4256000}, {625,3.5367429}, {630,3.6436286}, {635,3.6209429}, {640,3.6965714}, {645,3.7720857}, {650,3.8018857}, {655,3.9688000}, {660,3.9067143}, {665,3.9500857}, {670,4.0055714}, {675,4.1959143}, {680,4.0720286}, {685,4.2560857}, {690,4.3173714}, {695,4.3302000}, {700,4.5461429}, {705,4.6336857}, {710,4.5441143}, {715,4.7002571}, {720,4.7729714}, {725,4.8219714}, {730,4.8205714}, {735,4.9301714}, {740,5.0361429}, {745,5.1216000}, {750,5.1673429}, {755,5.2462571}, {760,5.3561429}, {765,5.4484000}, {770,5.5432000}, {775,5.5833429}, {780,5.6889714}, {785,5.8155714}, {790,5.8647143}, {795,5.9758571}, {800,6.1214000}, {805,6.1520857}, {810,6.2480286}, {815,6.3985143}, {820,6.4367714}, {825,6.5719429}, {830,6.6448000}, {835,6.7316857}, {840,6.8300286}, {845,6.9270000}, {850,7.1154286}, {855,7.2811714}, {860,7.2894571}, {865,7.4488571}, {870,7.4675714}, {875,7.7320857}, {880,7.7868571}, {885,7.9322286}, {890,8.0602571}, {895,8.1314571}, {900,8.1894571}, {905,8.2751143}, {910,8.3542286}, {915,8.5798571}, {920,8.7048857}, {925,8.7899429}, {930,8.8798286}, {935,8.9469714}, {940,9.2911143}, {945,9.2779143}, {950,9.2671714}, {955,9.5532000}, {960,9.7825429}, {965,9.7821714}, {970,9.9100000}, {975,9.9724286}, {980,10.0992571}, {985,10.3502286}, {990,10.6036857}, {995,10.5760571}, {1000,10.9879714}, {1010,11.0900857}, {1020,11.3886857}, {1030,11.6873429}, {1040,12.1409714}, {1050,12.2401429}, {1060,12.4273714}, {1070,12.7278571}, {1080,13.3222571}, {1090,13.3964286}, {1100,13.6928000}, {1110,14.0734571}, {1120,14.3993429}, {1130,14.6286286}, {1140,15.1642571}, {1150,15.2634857}, {1160,15.7259714}, {1170,16.0693429}, {1180,16.5323429}, {1190,16.6951429}, {1200,17.4168000}, {1210,17.5846000}, {1220,18.0104286}, {1230,18.2953714}, {1240,19.0198571}, {1250,19.1674857}, {1260,19.6845143}, {1270,20.1147714}, {1280,20.4811714}, {1290,20.9889714}, {1300,21.1192857}, {1310,21.8438571}, {1320,22.0996000}, {1330,22.6020000}, {1340,23.3431429}, {1350,23.8456571}, {1360,24.3649143}, {1370,24.6501429}, {1380,25.2606000}, {1390,25.7557429}, {1400,26.0480286}, {1410,26.7742857}, {1420,27.2570571}, {1430,27.5348571}, {1440,28.2728286}, {1450,28.8523143}, {1460,28.9172000}, {1470,29.6746286}, {1480,30.4758000}, {1490,31.0972000}, {1500,31.4742571}, {1510,32.2488000}, {1520,32.8850857}, {1530,33.5479143}, {1540,33.8132000}, {1550,34.6546286}, {1560,35.2497143}, {1570,36.0831429}, {1580,35.9937143}, {1590,36.9651429}, {1600,37.8373143}, {1610,38.1029714}, {1620,39.1305143}, {1630,39.3700286}, {1640,40.0535429}, {1650,40.5589143}, {1660,41.4742286}, {1670,42.1965714}, {1680,43.2244857}, {1690,43.9951429}, {1700,44.9074571}, {1710,45.2568857}, {1720,46.3069143}, {1730,46.8863714}, {1740,47.3688286}, {1750,48.0030571}, {1760,48.9918857}, {1770,49.4978857}, {1780,50.6510857}, {1790,51.1732857}, {1800,51.9666286}, {1810,52.8344286}, {1820,53.4725143}, {1830,54.5285429}, {1840,55.0603429}, {1850,56.2635143}, {1860,56.8558571}, {1870,58.1941429}, {1880,59.1742857}, {1890,60.0250857}, {1900,61.4937143}, {1910,62.1962286}, {1920,63.4368286}, {1930,63.7395143}, {1940,64.1498286}, {1950,65.1322000}, {1960,66.0542857}, {1970,67.0312571}, {1980,67.6319714}, {1990,69.2046857}, {2000,69.6783714}};
data["big"]["LtacTCPrimPair"]["reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00007921}, {7,0.00003960}, {8,0.00000000}, {9,0.00000000}, {10,0.00007921}, {11,0.00003960}, {12,0.00011881}, {13,0.00007921}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00006931}, {18,0.00011881}, {19,0.00000000}, {20,0.00003960}, {21,0.00007921}, {22,0.00003960}, {23,0.00000000}, {24,0.00011881}, {25,0.00000000}, {26,0.00007921}, {27,0.00003960}, {28,0.00007921}, {29,0.00003960}, {30,0.00000000}, {31,0.00003960}, {32,0.00000000}, {33,0.00000000}, {34,0.00007921}, {35,0.00011881}, {36,0.00003960}, {37,0.00000000}, {38,0.00007921}, {39,0.00007921}, {40,0.00000000}, {41,0.00000000}, {42,0.00003960}, {43,0.00000000}, {44,0.00007921}, {45,0.00007921}, {46,0.00000000}, {47,0.00002970}, {48,0.00007921}, {49,0.00003960}, {50,0.00000000}, {51,0.00007921}, {52,0.00002970}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00003960}, {57,0.00000000}, {58,0.00015842}, {59,0.00007921}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00003960}, {64,0.00000000}, {65,0.00003960}, {66,0.00000000}, {67,0.00011881}, {68,0.00000000}, {69,0.00000000}, {70,0.00003960}, {71,0.00000000}, {72,0.00003960}, {73,0.00000000}, {74,0.00003960}, {75,0.00003960}, {76,0.00003960}, {77,0.00003960}, {78,0.00003960}, {79,0.00003960}, {80,0.00003960}, {81,0.00002970}, {82,0.00000000}, {83,0.00003960}, {84,0.00003960}, {85,0.00000000}, {86,0.00002970}, {87,0.00000000}, {88,0.00000000}, {89,0.00007921}, {90,0.00003960}, {91,0.00000000}, {92,0.00003960}, {93,0.00000000}, {94,0.00003960}, {95,0.00003960}, {96,0.00000000}, {97,0.00011881}, {98,0.00003960}, {99,0.00000000}, {100,0.00000000}, {101,0.00007921}, {102,0.00003960}, {103,0.00003960}, {104,0.00007921}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00003960}, {111,0.00003960}, {112,0.00011881}, {113,0.00015842}, {114,0.00007921}, {115,0.00019802}, {116,0.00007921}, {117,0.00007921}, {118,0.00003960}, {119,0.00006931}, {120,0.00003960}, {121,0.00003960}, {122,0.00003960}, {123,0.00000000}, {124,0.00003960}, {125,0.00000000}, {126,0.00003960}, {127,0.00003960}, {128,0.00003960}, {129,0.00007921}, {130,0.00003960}, {131,0.00000000}, {132,0.00003960}, {133,0.00003960}, {134,0.00003960}, {135,0.00003960}, {136,0.00003960}, {137,0.00000000}, {138,0.00007921}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00003960}, {144,0.00002970}, {145,0.00007921}, {146,0.00006931}, {147,0.00003960}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00003960}, {153,0.00000000}, {154,0.00003960}, {155,0.00000000}, {156,0.00003960}, {157,0.00003960}, {158,0.00003960}, {159,0.00000000}, {160,0.00003960}, {161,0.00000000}, {162,0.00011881}, {163,0.00007921}, {164,0.00003960}, {165,0.00006931}, {166,0.00007921}, {167,0.00000000}, {168,0.00003960}, {169,0.00003960}, {170,0.00003960}, {171,0.00003960}, {172,0.00007921}, {173,0.00000000}, {174,0.00007921}, {175,0.00000000}, {176,0.00000000}, {177,0.00003960}, {178,0.00007921}, {179,0.00000000}, {180,0.00000000}, {181,0.00003960}, {182,0.00003960}, {183,0.00000000}, {184,0.00000000}, {185,0.00007921}, {186,0.00003960}, {187,0.00003960}, {188,0.00007921}, {189,0.00003960}, {190,0.00007921}, {191,0.00003960}, {192,0.00007921}, {193,0.00007921}, {194,0.00003960}, {195,0.00003960}, {196,0.00003960}, {197,0.00003960}, {198,0.00000000}, {199,0.00011881}, {200,0.00003960}, {201,0.00000000}, {202,0.00000000}, {203,0.00007921}, {204,0.00011881}, {205,0.00000000}, {206,0.00003960}, {207,0.00000000}, {208,0.00007921}, {209,0.00007921}, {210,0.00007921}, {211,0.00003960}, {212,0.00000000}, {213,0.00003960}, {214,0.00007921}, {215,0.00003960}, {216,0.00000000}, {217,0.00007921}, {218,0.00011881}, {219,0.00023762}, {220,0.00011881}, {221,0.00003960}, {222,0.00003960}, {223,0.00000000}, {224,0.00003960}, {225,0.00000000}, {226,0.00015842}, {227,0.00002970}, {228,0.00007921}, {229,0.00011881}, {230,0.00010891}, {231,0.00011881}, {232,0.00015842}, {233,0.00000000}, {234,0.00007921}, {235,0.00003960}, {236,0.00007921}, {237,0.00047525}, {238,0.00007921}, {239,0.00035644}, {240,0.00007921}, {241,0.00000000}, {242,0.00011881}, {243,0.00007921}, {244,0.00000000}, {245,0.00031683}, {246,0.00007921}, {247,0.00007921}, {248,0.00007921}, {249,0.00003960}, {250,0.00007921}, {251,0.00011881}, {252,0.00015842}, {253,0.00000000}, {254,0.00007921}, {255,0.00007921}, {256,0.00003960}, {257,0.00000000}, {258,0.00011881}, {259,0.00003960}, {260,0.00000000}, {261,0.00007921}, {262,0.00000000}, {263,0.00003960}, {264,0.00003960}, {265,0.00003960}, {266,0.00003960}, {267,0.00007921}, {268,0.00003960}, {269,0.00015842}, {270,0.00015842}, {271,0.00003960}, {272,0.00015842}, {273,0.00000000}, {274,0.00007921}, {275,0.00019802}, {276,0.00011881}, {277,0.00000000}, {278,0.00015842}, {279,0.00011881}, {280,0.00007921}, {281,0.00011881}, {282,0.00007921}, {283,0.00007921}, {284,0.00003960}, {285,0.00000000}, {286,0.00007921}, {287,0.00011881}, {288,0.00003960}, {289,0.00015842}, {290,0.00000000}, {291,0.00007921}, {292,0.00011881}, {293,0.00007921}, {294,0.00023762}, {295,0.00003960}, {296,0.00019802}, {297,0.00007921}, {298,0.00007921}, {299,0.00003960}, {300,0.00011881}, {301,0.0002286}, {302,0.0002286}, {303,0.0003429}, {304,0.0003429}, {305,0.0001143}, {306,0.0002286}, {307,0.0003143}, {308,0.0000000}, {309,0.0002000}, {310,0.0002286}, {311,0.0000000}, {312,0.0001143}, {313,0.0000000}, {314,0.0000000}, {315,0.0001143}, {316,0.0002286}, {317,0.0000000}, {318,0.0001143}, {319,0.0000000}, {320,0.0002286}, {321,0.0000000}, {322,0.0001143}, {323,0.0004571}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0002286}, {330,0.0001143}, {331,0.0002286}, {332,0.0000000}, {333,0.0001143}, {334,0.0000000}, {335,0.0004571}, {336,0.0003429}, {337,0.0000000}, {338,0.0003429}, {339,0.0003429}, {340,0.0000000}, {341,0.0001143}, {342,0.0002286}, {343,0.0001143}, {344,0.0001143}, {345,0.0000000}, {346,0.0000000}, {347,0.0002286}, {348,0.0004571}, {349,0.0001143}, {350,0.0002286}, {351,0.0000000}, {352,0.0001143}, {353,0.0002286}, {354,0.0000000}, {355,0.0002286}, {356,0.0002286}, {357,0.0001143}, {358,0.0000000}, {359,0.0001143}, {360,0.0000000}, {361,0.0001143}, {362,0.0001143}, {363,0.0000000}, {364,0.0001143}, {365,0.0001143}, {366,0.0001143}, {367,0.0002286}, {368,0.0000000}, {369,0.0002286}, {370,0.0000000}, {371,0.0003429}, {372,0.0000000}, {373,0.0004571}, {374,0.0003429}, {375,0.0001143}, {376,0.0000000}, {377,0.0002286}, {378,0.0003429}, {379,0.0001143}, {380,0.0001143}, {381,0.0005714}, {382,0.0001143}, {383,0.0004571}, {384,0.0002286}, {385,0.0004571}, {386,0.0003429}, {387,0.0001143}, {388,0.0002286}, {389,0.0001143}, {390,0.0001143}, {391,0.0002286}, {392,0.0002286}, {393,0.0001143}, {394,0.0002286}, {395,0.0001143}, {396,0.0000000}, {397,0.0002286}, {398,0.0004571}, {399,0.0001143}, {400,0.0004571}, {401,0.0006857}, {402,0.0002286}, {403,0.0001143}, {404,0.0000000}, {405,0.0004571}, {406,0.0001143}, {407,0.0002286}, {408,0.0001143}, {409,0.0000000}, {410,0.0000000}, {411,0.0001143}, {412,0.0002286}, {413,0.0001143}, {414,0.0002286}, {415,0.0001143}, {416,0.0001143}, {417,0.0003429}, {418,0.0002286}, {419,0.0000000}, {420,0.0000000}, {421,0.0001143}, {422,0.0001143}, {423,0.0003429}, {424,0.0000000}, {425,0.0002286}, {426,0.0002286}, {427,0.0003429}, {428,0.0005714}, {429,0.0001143}, {430,0.0002286}, {431,0.0003429}, {432,0.0006571}, {433,0.0001143}, {434,0.0004571}, {435,0.0001143}, {436,0.0001143}, {437,0.0002286}, {438,0.0004571}, {439,0.0000000}, {440,0.0002286}, {441,0.0001143}, {442,0.0000000}, {443,0.0003429}, {444,0.0005714}, {445,0.0002286}, {446,0.0005429}, {447,0.0003429}, {448,0.0003429}, {449,0.0002286}, {450,0.0003429}, {451,0.0001143}, {452,0.0000000}, {453,0.0000000}, {454,0.0002286}, {455,0.0000000}, {456,0.0002286}, {457,0.0005714}, {458,0.0002000}, {459,0.0002286}, {460,0.0003429}, {461,0.0003429}, {462,0.0004571}, {463,0.0005714}, {464,0.0001143}, {465,0.0006857}, {466,0.0005714}, {467,0.0005714}, {468,0.0002286}, {469,0.0004571}, {470,0.0003429}, {471,0.0006857}, {472,0.0004571}, {473,0.0009143}, {474,0.0012571}, {475,0.0004571}, {476,0.0001143}, {477,0.0001143}, {478,0.0004571}, {479,0.0012286}, {480,0.0006857}, {481,0.0002286}, {482,0.0003429}, {483,0.0004571}, {484,0.0002286}, {485,0.0009143}, {486,0.0002286}, {487,0.0014857}, {488,0.0002286}, {489,0.0000000}, {490,0.0002286}, {491,0.0002286}, {492,0.0000000}, {493,0.0005714}, {494,0.0004571}, {495,0.0003429}, {496,0.0000000}, {497,0.0000000}, {498,0.0002286}, {499,0.0000000}, {500,0.0004571}, {505,0.0010286}, {510,0.0001143}, {515,0.0010286}, {520,0.0002286}, {525,0.0008000}, {530,0.0013714}, {535,0.0004571}, {540,0.0009143}, {545,0.0002286}, {550,0.0005714}, {555,0.0013714}, {560,0.0009143}, {565,0.0018286}, {570,0.0013714}, {575,0.0002286}, {580,0.0006857}, {585,0.0002286}, {590,0.0005714}, {595,0.0006857}, {600,0.0006857}, {605,0.0010286}, {610,0.0012571}, {615,0.0019429}, {620,0.0009143}, {625,0.0011429}, {630,0.0004571}, {635,0.0016857}, {640,0.0010286}, {645,0.0022571}, {650,0.0009143}, {655,0.0016857}, {660,0.0010286}, {665,0.0016000}, {670,0.0013714}, {675,0.0009143}, {680,0.0005714}, {685,0.0015714}, {690,0.0018286}, {695,0.0006571}, {700,0.0021714}, {705,0.0033143}, {710,0.0028571}, {715,0.0038857}, {720,0.0035429}, {725,0.0017143}, {730,0.0040000}, {735,0.0044571}, {740,0.0048000}, {745,0.0035429}, {750,0.0033143}, {755,0.0024000}, {760,0.0036286}, {765,0.0050857}, {770,0.0039714}, {775,0.0021714}, {780,0.0038857}, {785,0.0027143}, {790,0.0043429}, {795,0.0050286}, {800,0.0057143}, {805,0.0047714}, {810,0.0053714}, {815,0.0062571}, {820,0.0059143}, {825,0.0080857}, {830,0.0072857}, {835,0.0057714}, {840,0.0061429}, {845,0.0064857}, {850,0.0045714}, {855,0.0054857}, {860,0.0067143}, {865,0.0067429}, {870,0.0056857}, {875,0.0099429}, {880,0.0058000}, {885,0.0039429}, {890,0.0052286}, {895,0.0043429}, {900,0.0045429}, {905,0.0066286}, {910,0.0053143}, {915,0.0062571}, {920,0.0068571}, {925,0.0057143}, {930,0.0068000}, {935,0.0058857}, {940,0.0056571}, {945,0.0085429}, {950,0.0061143}, {955,0.0081143}, {960,0.0040000}, {965,0.0092571}, {970,0.0113429}, {975,0.0093143}, {980,0.0093429}, {985,0.0060286}, {990,0.0082000}, {995,0.0065143}, {1000,0.0070286}, {1010,0.0099143}, {1020,0.0069429}, {1030,0.0087714}, {1040,0.0054571}, {1050,0.0096286}, {1060,0.0045429}, {1070,0.0066286}, {1080,0.0058571}, {1090,0.0047714}, {1100,0.0073429}, {1110,0.0076286}, {1120,0.0050286}, {1130,0.0056571}, {1140,0.0089143}, {1150,0.0102286}, {1160,0.0071143}, {1170,0.0094000}, {1180,0.0075714}, {1190,0.0054286}, {1200,0.0073143}, {1210,0.0075714}, {1220,0.0125143}, {1230,0.0097714}, {1240,0.0056857}, {1250,0.0090857}, {1260,0.0077714}, {1270,0.0089143}, {1280,0.0066857}, {1290,0.0080000}, {1300,0.0064000}, {1310,0.0057143}, {1320,0.0054000}, {1330,0.0053714}, {1340,0.0091714}, {1350,0.0089143}, {1360,0.0119143}, {1370,0.0075143}, {1380,0.0094286}, {1390,0.0068857}, {1400,0.0078286}, {1410,0.0062571}, {1420,0.0107143}, {1430,0.0080000}, {1440,0.0090571}, {1450,0.0072571}, {1460,0.0114857}, {1470,0.0091429}, {1480,0.0088000}, {1490,0.0063429}, {1500,0.0119429}, {1510,0.0122286}, {1520,0.0138000}, {1530,0.0087429}, {1540,0.0089429}, {1550,0.0110286}, {1560,0.0110571}, {1570,0.0097429}, {1580,0.0177429}, {1590,0.0108286}, {1600,0.0112000}, {1610,0.0162000}, {1620,0.0142286}, {1630,0.0167143}, {1640,0.0130000}, {1650,0.0169714}, {1660,0.0169714}, {1670,0.0122286}, {1680,0.0120286}, {1690,0.0110571}, {1700,0.0238857}, {1710,0.0131714}, {1720,0.0167714}, {1730,0.0126857}, {1740,0.0136857}, {1750,0.0191143}, {1760,0.0190286}, {1770,0.0234286}, {1780,0.0142857}, {1790,0.0240286}, {1800,0.0215429}, {1810,0.0211143}, {1820,0.0218286}, {1830,0.0216000}, {1840,0.0260000}, {1850,0.0219429}, {1860,0.0210571}, {1870,0.0231143}, {1880,0.0204000}, {1890,0.0274571}, {1900,0.0253714}, {1910,0.0145714}, {1920,0.0229429}, {1930,0.0159714}, {1940,0.0293714}, {1950,0.0256571}, {1960,0.0133429}, {1970,0.0240857}, {1980,0.0230571}, {1990,0.0208000}, {2000,0.0216571}};
data["big"]["LtacTacInTermExplicitCtx"]["Aggregate"]["real"] = {{1,0.00100000}, {2,0.00106931}, {3,0.00200000}, {4,0.00200000}, {5,0.00300990}, {6,0.00300000}, {7,0.00347525}, {8,0.00400000}, {9,0.00427723}, {10,0.00500000}, {11,0.00528713}, {12,0.00715842}, {13,0.00633663}, {14,0.00700990}, {15,0.00763366}, {16,0.00816832}, {17,0.01054455}, {18,0.00927723}, {19,0.01004950}, {20,0.01083168}, {21,0.01375248}, {22,0.01199010}, {23,0.01262376}, {24,0.01337624}, {25,0.01400000}, {26,0.01473267}, {27,0.01516832}, {28,0.01606931}, {29,0.01692079}, {30,0.01750495}, {31,0.01954455}, {32,0.01901980}, {33,0.01989109}, {34,0.02050495}, {35,0.02144554}, {36,0.02219802}, {37,0.02300990}, {38,0.02396040}, {39,0.02870297}, {40,0.02797030}, {41,0.02638614}, {42,0.02748515}, {43,0.02818812}, {44,0.03833663}, {45,0.03015842}, {46,0.03109901}, {47,0.03911881}, {48,0.03283168}, {49,0.03929703}, {50,0.03522772}, {51,0.04349505}, {52,0.03706931}, {53,0.03807921}, {54,0.03908911}, {55,0.04009901}, {56,0.04110891}, {57,0.04608911}, {58,0.05382178}, {59,0.04450495}, {60,0.04563366}, {61,0.04677228}, {62,0.04793069}, {63,0.04901980}, {64,0.05757426}, {65,0.06018812}, {66,0.05553465}, {67,0.05377228}, {68,0.05503960}, {69,0.06883168}, {70,0.05745545}, {71,0.06505941}, {72,0.05960396}, {73,0.06771287}, {74,0.06248515}, {75,0.08546535}, {76,0.06491089}, {77,0.06641584}, {78,0.07866337}, {79,0.09108911}, {80,0.08414851}, {81,0.08526733}, {82,0.07334653}, {83,0.08818812}, {84,0.11967327}, {85,0.07701980}, {86,0.07856436}, {87,0.08029703}, {88,0.08168317}, {89,0.08326733}, {90,0.08491089}, {91,0.08647525}, {92,0.08732673}, {93,0.08928713}, {94,0.09101980}, {95,0.09159406}, {96,0.09351485}, {97,0.09577228}, {98,0.09632673}, {99,0.09855446}, {100,0.10055446}, {101,0.10223762}, {102,0.10380198}, {103,0.11764356}, {104,0.11976238}, {105,0.12108911}, {106,0.12386139}, {107,0.12517822}, {108,0.12768317}, {109,0.13056436}, {110,0.13404950}, {111,0.13552475}, {112,0.13895050}, {113,0.14219802}, {114,0.14560396}, {115,0.14771287}, {116,0.15177228}, {117,0.15613861}, {118,0.15726733}, {119,0.16052475}, {120,0.16214851}, {121,0.16501980}, {122,0.16549505}, {123,0.16668317}, {124,0.16838614}, {125,0.17214851}, {126,0.17421782}, {127,0.17710891}, {128,0.18256436}, {129,0.18279208}, {130,0.18797030}, {131,0.18903960}, {132,0.19136634}, {133,0.19339604}, {134,0.19523762}, {135,0.19819802}, {136,0.20074257}, {137,0.20486139}, {138,0.20696040}, {139,0.20994059}, {140,0.21278218}, {141,0.21273267}, {142,0.21877228}, {143,0.21923762}, {144,0.22406931}, {145,0.22741584}, {146,0.22837624}, {147,0.23237624}, {148,0.23586139}, {149,0.23586139}, {150,0.23897030}, {151,0.24074257}, {152,0.24360396}, {153,0.24648515}, {154,0.24929703}, {155,0.25180198}, {156,0.25602970}, {157,0.25664356}, {158,0.26121782}, {159,0.26155446}, {160,0.26490099}, {161,0.26744554}, {162,0.27197030}, {163,0.27316832}, {164,0.27573267}, {165,0.27691089}, {166,0.28307921}, {167,0.28609901}, {168,0.29004950}, {169,0.29647525}, {170,0.29738614}, {171,0.29807921}, {172,0.29950495}, {173,0.30303960}, {174,0.30846535}, {175,0.31300000}, {176,0.31701980}, {177,0.31789109}, {178,0.31929703}, {179,0.32380198}, {180,0.32741584}, {181,0.32907921}, {182,0.33361386}, {183,0.33471287}, {184,0.33800990}, {185,0.34123762}, {186,0.34439604}, {187,0.34647525}, {188,0.35016832}, {189,0.35398020}, {190,0.35949505}, {191,0.35961386}, {192,0.36760396}, {193,0.37452475}, {194,0.37318812}, {195,0.37267327}, {196,0.37609901}, {197,0.37969307}, {198,0.38271287}, {199,0.38536634}, {200,0.39269307}, {201,0.40340594}, {202,0.39839604}, {203,0.39427723}, {204,0.40323762}, {205,0.40477228}, {206,0.41638614}, {207,0.42463366}, {208,0.41347525}, {209,0.41878218}, {210,0.42266337}, {211,0.44230693}, {212,0.43706931}, {213,0.43381188}, {214,0.43540594}, {215,0.45418812}, {216,0.44949505}, {217,0.44875248}, {218,0.46784158}, {219,0.46136634}, {220,0.46153465}, {221,0.47389109}, {222,0.47449505}, {223,0.47553465}, {224,0.48921782}, {225,0.48376238}, {226,0.49104950}, {227,0.49040594}, {228,0.49613861}, {229,0.50743564}, {230,0.50441584}, {231,0.51862376}, {232,0.51002970}, {233,0.52855446}, {234,0.51866337}, {235,0.53676238}, {236,0.52539604}, {237,0.53779208}, {238,0.53735644}, {239,0.53653465}, {240,0.54956436}, {241,0.54447525}, {242,0.56010891}, {243,0.56013861}, {244,0.56368317}, {245,0.56920792}, {246,0.61352475}, {247,0.57319802}, {248,0.58328713}, {249,0.58251485}, {250,0.58824752}, {251,0.61271287}, {252,0.59475248}, {253,0.59484158}, {254,0.60490099}, {255,0.61302970}, {256,0.62663366}, {257,0.74852475}, {258,0.63575248}, {259,0.63795050}, {260,0.63657426}, {261,0.64328713}, {262,0.64794059}, {263,0.64941584}, {264,0.66154455}, {265,0.66053465}, {266,0.73114851}, {267,0.66576238}, {268,0.66965347}, {269,0.67744554}, {270,0.67909901}, {271,0.69484158}, {272,0.69265347}, {273,0.75674257}, {274,0.70154455}, {275,0.70909901}, {276,0.71031683}, {277,0.71179208}, {278,0.71376238}, {279,0.72577228}, {280,0.76628713}, {281,0.73084158}, {282,0.73719802}, {283,0.74056436}, {284,0.74486139}, {285,0.74940594}, {286,0.75160396}, {287,0.75867327}, {288,0.76479208}, {289,0.77354455}, {290,0.77619802}, {291,0.78415842}, {292,0.80468317}, {293,0.79551485}, {294,0.80759406}, {295,0.82064356}, {296,0.82044554}, {297,0.82507921}, {298,0.82966337}, {299,0.84934653}, {300,0.84478218}, {301,1.0368857}, {302,0.9670000}, {303,0.9572286}, {304,0.9308571}, {305,0.9043429}, {306,0.9139714}, {307,0.9367143}, {308,0.9278857}, {309,0.9295429}, {310,0.9405714}, {311,0.9514571}, {312,0.9509429}, {313,0.9610286}, {314,0.9640286}, {315,0.9683714}, {316,0.9710857}, {317,0.9801429}, {318,0.9866571}, {319,0.9952286}, {320,0.9986571}, {321,0.9925714}, {322,1.0134000}, {323,1.0058000}, {324,1.0164286}, {325,1.0141143}, {326,1.0280571}, {327,1.0317714}, {328,1.0371429}, {329,1.0403429}, {330,1.0464857}, {331,1.0705429}, {332,1.0509429}, {333,1.0624286}, {334,1.0590000}, {335,1.0741429}, {336,1.1029429}, {337,1.0758571}, {338,1.0891714}, {339,1.0882571}, {340,1.1018571}, {341,1.1131429}, {342,1.1195714}, {343,1.1307714}, {344,1.1383143}, {345,1.1411714}, {346,1.1434571}, {347,1.1528857}, {348,1.1544571}, {349,1.1635714}, {350,1.1725143}, {351,1.1880571}, {352,1.1840571}, {353,1.1944286}, {354,1.1964571}, {355,1.1974000}, {356,1.2137429}, {357,1.2215714}, {358,1.2198857}, {359,1.2342571}, {360,1.2348857}, {361,1.2343143}, {362,1.2499429}, {363,1.2629429}, {364,1.2646857}, {365,1.2964286}, {366,1.2762571}, {367,1.2857429}, {368,1.2832857}, {369,1.3004571}, {370,1.3041143}, {371,1.3110571}, {372,1.3415429}, {373,1.3159143}, {374,1.3399429}, {375,1.3493143}, {376,1.3408857}, {377,1.3547714}, {378,1.3666000}, {379,1.3653429}, {380,1.3718286}, {381,1.3977714}, {382,1.3990000}, {383,1.4122857}, {384,1.4164000}, {385,1.4290000}, {386,1.4372571}, {387,1.4517143}, {388,1.4504000}, {389,1.4635143}, {390,1.4663714}, {391,1.4775429}, {392,1.4845429}, {393,1.5201714}, {394,1.4990571}, {395,1.5091714}, {396,1.5163143}, {397,1.5186000}, {398,1.5562000}, {399,1.5360571}, {400,1.5724286}, {401,1.5858571}, {402,1.5912286}, {403,1.5803714}, {404,1.5968571}, {405,1.6166286}, {406,1.5981143}, {407,1.6091429}, {408,1.6087714}, {409,1.6277143}, {410,1.6612286}, {411,1.6286857}, {412,1.6327429}, {413,1.6434286}, {414,1.6558286}, {415,1.6578000}, {416,1.6667714}, {417,1.6755714}, {418,1.6770571}, {419,1.6847143}, {420,1.7037143}, {421,1.7312571}, {422,1.7118571}, {423,1.7523143}, {424,1.7425714}, {425,1.7586857}, {426,1.7781429}, {427,1.8107143}, {428,1.8028571}, {429,1.7926857}, {430,1.8305714}, {431,1.8258571}, {432,1.8220857}, {433,1.8292000}, {434,1.8438857}, {435,1.8797429}, {436,1.8458857}, {437,1.8716286}, {438,1.8886857}, {439,1.8966000}, {440,1.8988000}, {441,1.9102286}, {442,1.9214286}, {443,1.9228286}, {444,1.9477714}, {445,1.9574857}, {446,1.9356857}, {447,1.9540000}, {448,1.9597714}, {449,1.9686571}, {450,2.0273429}, {451,2.0072286}, {452,1.9906857}, {453,2.0479714}, {454,2.0366571}, {455,2.0423143}, {456,2.0586000}, {457,2.0706857}, {458,2.0498571}, {459,2.0969714}, {460,2.0720286}, {461,2.1051143}, {462,2.1143714}, {463,2.1862000}, {464,2.1837714}, {465,2.1065714}, {466,2.1775714}, {467,2.1653714}, {468,2.1696000}, {469,2.1540571}, {470,2.1905714}, {471,2.1691143}, {472,2.1795429}, {473,2.1836000}, {474,2.1901714}, {475,2.1931143}, {476,2.2133143}, {477,2.2228000}, {478,2.2299714}, {479,2.2380857}, {480,2.2557429}, {481,2.2676857}, {482,2.2899429}, {483,2.3302286}, {484,2.2998286}, {485,2.3211429}, {486,2.3201714}, {487,2.3260000}, {488,2.3340857}, {489,2.3374000}, {490,2.3532286}, {491,2.3535429}, {492,2.3599429}, {493,2.3848000}, {494,2.3957714}, {495,2.4019143}, {496,2.4236286}, {497,2.4373714}, {498,2.4443714}, {499,2.4466571}, {500,2.4477714}, {505,2.4993429}, {510,2.5523143}, {515,2.5935429}, {520,2.6718000}, {525,2.7491143}, {530,2.7429143}, {535,2.8424000}, {540,2.9211143}, {545,3.0971143}, {550,3.1076857}, {555,3.1553429}, {560,3.2087714}, {565,3.3314571}, {570,3.3540857}, {575,3.4378000}, {580,3.4332286}, {585,3.6064857}, {590,3.6310857}, {595,3.5599714}, {600,3.6557714}, {605,3.7379714}, {610,3.7637714}, {615,3.8202286}, {620,3.8677143}, {625,3.9401143}, {630,3.9985429}, {635,4.0385143}, {640,4.0762286}, {645,4.1294571}, {650,4.2334286}, {655,4.3258286}, {660,4.2974571}, {665,4.3854571}, {670,4.4947714}, {675,4.5621429}, {680,4.5754571}, {685,4.6534000}, {690,4.7325714}, {695,4.8144571}, {700,4.9095429}, {705,4.9978000}, {710,5.0346000}, {715,5.1468571}, {720,5.1892000}, {725,5.3060000}, {730,5.3661714}, {735,5.4695429}, {740,5.5222286}, {745,5.6288000}, {750,5.7496571}, {755,5.8683714}, {760,5.9458286}, {765,6.0368857}, {770,6.0997143}, {775,6.2319429}, {780,6.2970571}, {785,6.3836857}, {790,6.4966571}, {795,6.5964571}, {800,6.6756857}, {805,6.7958571}, {810,6.8586286}, {815,6.9830000}, {820,7.1029714}, {825,7.1713143}, {830,7.2592286}, {835,7.3548571}, {840,7.4131143}, {845,7.5362571}, {850,7.7707429}, {855,7.8365143}, {860,7.9666000}, {865,8.0699143}, {870,8.3262857}, {875,8.4466000}, {880,8.6145143}, {885,8.6106857}, {890,8.8100571}, {895,8.9350571}, {900,8.8644857}, {905,9.2297429}, {910,9.3060571}, {915,9.4038000}, {920,9.5126286}, {925,9.8628000}, {930,10.0211429}, {935,10.0775143}, {940,9.9661429}, {945,10.0946000}, {950,9.9796000}, {955,10.4389714}, {960,10.3249143}, {965,10.4017714}, {970,10.6998857}, {975,10.9046571}, {980,11.0394000}, {985,11.0770571}, {990,11.4408571}, {995,11.1214571}, {1000,11.4076571}, {1010,11.6462571}, {1020,11.8365429}, {1030,12.4912857}, {1040,12.7623714}, {1050,12.9245429}, {1060,13.4770286}, {1070,13.7211143}, {1080,14.3175143}, {1090,14.3839429}, {1100,14.9434000}, {1110,15.0870571}, {1120,15.6462571}, {1130,15.4507429}, {1140,15.8630000}, {1150,16.6868857}, {1160,16.7728286}, {1170,17.1575143}, {1180,17.7429429}, {1190,17.8868286}, {1200,18.2712286}, {1210,18.3815714}, {1220,19.2710000}, {1230,19.3050857}, {1240,19.7752571}, {1250,20.4354286}, {1260,20.3581714}, {1270,21.1832571}, {1280,21.5402571}, {1290,22.3482857}, {1300,22.4258286}, {1310,22.8286571}, {1320,22.9940000}, {1330,23.6347429}, {1340,23.2056571}, {1350,23.6978000}, {1360,24.9477143}, {1370,25.2419429}, {1380,25.5122000}, {1390,26.0514857}, {1400,26.3360857}, {1410,26.4392571}, {1420,27.4596000}, {1430,27.8262857}, {1440,28.0010286}, {1450,28.4349714}, {1460,29.3702286}, {1470,29.4004857}, {1480,29.7847143}, {1490,30.4344857}, {1500,30.8495143}, {1510,31.5441429}, {1520,31.9122571}, {1530,33.0223143}, {1540,33.7207714}, {1550,33.7399143}, {1560,34.6709429}, {1570,34.9949143}, {1580,36.0756286}, {1590,35.5202857}, {1600,37.2607429}, {1610,37.3133714}, {1620,37.4696286}, {1630,38.3053143}, {1640,38.7065143}, {1650,39.3922286}, {1660,40.4021429}, {1670,41.0274857}, {1680,41.6496857}, {1690,42.0883429}, {1700,43.2859714}, {1710,42.9046000}, {1720,44.4859714}, {1730,44.7315143}, {1740,45.1654286}, {1750,45.7778000}, {1760,46.5489429}, {1770,47.6429714}, {1780,48.1316286}, {1790,48.5159429}, {1800,48.5619143}, {1810,49.6051714}, {1820,50.2884000}, {1830,51.0062000}, {1840,52.7526571}, {1850,52.8628000}, {1860,53.2562571}, {1870,54.2876000}, {1880,54.9630286}, {1890,55.6286857}, {1900,56.7382571}, {1910,57.1411714}, {1920,58.7383143}, {1930,58.6616571}, {1940,59.2147714}, {1950,61.1020286}, {1960,59.9764857}, {1970,61.6478286}, {1980,62.1912857}, {1990,63.2912000}, {2000,64.1646571}};
data["big"]["LtacTacInTermExplicitCtx"]["Aggregate"]["user"] = {{1,0.00135644}, {2,0.00195050}, {3,0.00195050}, {4,0.00266337}, {5,0.00298020}, {6,0.00368317}, {7,0.00386139}, {8,0.00416832}, {9,0.00467327}, {10,0.00494059}, {11,0.00527723}, {12,0.00752475}, {13,0.00691089}, {14,0.00700990}, {15,0.00764356}, {16,0.00831683}, {17,0.01051485}, {18,0.00926733}, {19,0.00982178}, {20,0.01057426}, {21,0.01371287}, {22,0.01189109}, {23,0.01259406}, {24,0.01303960}, {25,0.01386139}, {26,0.01430693}, {27,0.01506931}, {28,0.01577228}, {29,0.01693069}, {30,0.01704950}, {31,0.01927723}, {32,0.01873267}, {33,0.01933663}, {34,0.02019802}, {35,0.02158416}, {36,0.02261386}, {37,0.02340594}, {38,0.02425743}, {39,0.02877228}, {40,0.02808911}, {41,0.02669307}, {42,0.02779208}, {43,0.02842574}, {44,0.03818812}, {45,0.03005941}, {46,0.03125743}, {47,0.03903960}, {48,0.03265347}, {49,0.03870297}, {50,0.03521782}, {51,0.04314851}, {52,0.03695050}, {53,0.03795050}, {54,0.03908911}, {55,0.04011881}, {56,0.04056436}, {57,0.04628713}, {58,0.05388119}, {59,0.04404950}, {60,0.04540594}, {61,0.04642574}, {62,0.04821782}, {63,0.04925743}, {64,0.05761386}, {65,0.05984158}, {66,0.05573267}, {67,0.05391089}, {68,0.05504950}, {69,0.06821782}, {70,0.05723762}, {71,0.06466337}, {72,0.05946535}, {73,0.06729703}, {74,0.06201980}, {75,0.08566337}, {76,0.06447525}, {77,0.06574257}, {78,0.07844554}, {79,0.09119802}, {80,0.08391089}, {81,0.08501980}, {82,0.07335644}, {83,0.08786139}, {84,0.11952475}, {85,0.07690099}, {86,0.07836634}, {87,0.08012871}, {88,0.08147525}, {89,0.08316832}, {90,0.08404950}, {91,0.08609901}, {92,0.08685149}, {93,0.08898020}, {94,0.09042574}, {95,0.09126733}, {96,0.09331683}, {97,0.09546535}, {98,0.09641584}, {99,0.09851485}, {100,0.10037624}, {101,0.10212871}, {102,0.10350495}, {103,0.11745545}, {104,0.11976238}, {105,0.12069307}, {106,0.12403960}, {107,0.12500990}, {108,0.12719802}, {109,0.13019802}, {110,0.13388119}, {111,0.13493069}, {112,0.13826733}, {113,0.14178218}, {114,0.14498020}, {115,0.14764356}, {116,0.15129703}, {117,0.15588119}, {118,0.15713861}, {119,0.15998020}, {120,0.16149505}, {121,0.16491089}, {122,0.16527723}, {123,0.16619802}, {124,0.16775248}, {125,0.17176238}, {126,0.17331683}, {127,0.17680198}, {128,0.18237624}, {129,0.18223762}, {130,0.18745545}, {131,0.18859406}, {132,0.19099010}, {133,0.19274257}, {134,0.19474257}, {135,0.19766337}, {136,0.20019802}, {137,0.20430693}, {138,0.20610891}, {139,0.20945545}, {140,0.21223762}, {141,0.21231683}, {142,0.21817822}, {143,0.21907921}, {144,0.22311881}, {145,0.22696040}, {146,0.22777228}, {147,0.23175248}, {148,0.23519802}, {149,0.23499010}, {150,0.23850495}, {151,0.24007921}, {152,0.24302970}, {153,0.24550495}, {154,0.24878218}, {155,0.25118812}, {156,0.25511881}, {157,0.25601980}, {158,0.26011881}, {159,0.26066337}, {160,0.26437624}, {161,0.26706931}, {162,0.27113861}, {163,0.27225743}, {164,0.27495050}, {165,0.27620792}, {166,0.28267327}, {167,0.28504950}, {168,0.28894059}, {169,0.29544554}, {170,0.29638614}, {171,0.29734653}, {172,0.29857426}, {173,0.30204950}, {174,0.30769307}, {175,0.31238614}, {176,0.31637624}, {177,0.31730693}, {178,0.31823762}, {179,0.32323762}, {180,0.32666337}, {181,0.32792079}, {182,0.33269307}, {183,0.33415842}, {184,0.33698020}, {185,0.34025743}, {186,0.34376238}, {187,0.34564356}, {188,0.34905941}, {189,0.35337624}, {190,0.35852475}, {191,0.35857426}, {192,0.36704950}, {193,0.37376238}, {194,0.37238614}, {195,0.37158416}, {196,0.37509901}, {197,0.37894059}, {198,0.38176238}, {199,0.38411881}, {200,0.39137624}, {201,0.40209901}, {202,0.39736634}, {203,0.39309901}, {204,0.40220792}, {205,0.40408911}, {206,0.41536634}, {207,0.42380198}, {208,0.41258416}, {209,0.41766337}, {210,0.42168317}, {211,0.44144554}, {212,0.43610891}, {213,0.43290099}, {214,0.43452475}, {215,0.45317822}, {216,0.44840594}, {217,0.44805941}, {218,0.46713861}, {219,0.46036634}, {220,0.46038614}, {221,0.47308911}, {222,0.47348515}, {223,0.47499010}, {224,0.48844554}, {225,0.48275248}, {226,0.48997030}, {227,0.48970297}, {228,0.49534653}, {229,0.50657426}, {230,0.50320792}, {231,0.51760396}, {232,0.50885149}, {233,0.52729703}, {234,0.51752475}, {235,0.53553465}, {236,0.52406931}, {237,0.53632673}, {238,0.53563366}, {239,0.53543564}, {240,0.54866337}, {241,0.54377228}, {242,0.55881188}, {243,0.55892079}, {244,0.56215842}, {245,0.56786139}, {246,0.61227723}, {247,0.57182178}, {248,0.58221782}, {249,0.58103960}, {250,0.58655446}, {251,0.61150495}, {252,0.59347525}, {253,0.59340594}, {254,0.60369307}, {255,0.61156436}, {256,0.62520792}, {257,0.74722772}, {258,0.63443564}, {259,0.63656436}, {260,0.63508911}, {261,0.64201980}, {262,0.64683168}, {263,0.64813861}, {264,0.66042574}, {265,0.65860396}, {266,0.73021782}, {267,0.66435644}, {268,0.66830693}, {269,0.67604950}, {270,0.67795050}, {271,0.69342574}, {272,0.69138614}, {273,0.75510891}, {274,0.70018812}, {275,0.70763366}, {276,0.70921782}, {277,0.71032673}, {278,0.71204950}, {279,0.72455446}, {280,0.76490099}, {281,0.72935644}, {282,0.73586139}, {283,0.73935644}, {284,0.74376238}, {285,0.74772277}, {286,0.74968317}, {287,0.75742574}, {288,0.76315842}, {289,0.77192079}, {290,0.77437624}, {291,0.78286139}, {292,0.80315842}, {293,0.79367327}, {294,0.80626733}, {295,0.81882178}, {296,0.81876238}, {297,0.82333663}, {298,0.82820792}, {299,0.84774257}, {300,0.84332673}, {301,1.0319143}, {302,0.9659429}, {303,0.9561143}, {304,0.9294571}, {305,0.9025429}, {306,0.9125714}, {307,0.9318286}, {308,0.9266857}, {309,0.9277429}, {310,0.9387714}, {311,0.9500000}, {312,0.9498286}, {313,0.9600000}, {314,0.9630857}, {315,0.9676571}, {316,0.9699429}, {317,0.9790286}, {318,0.9848571}, {319,0.9910286}, {320,0.9975714}, {321,0.9917143}, {322,1.0046000}, {323,1.0041143}, {324,1.0119143}, {325,1.0129143}, {326,1.0264857}, {327,1.0278857}, {328,1.0355714}, {329,1.0386857}, {330,1.0436000}, {331,1.0588000}, {332,1.0486286}, {333,1.0597429}, {334,1.0568000}, {335,1.0718000}, {336,1.1012857}, {337,1.0744857}, {338,1.0878857}, {339,1.0874286}, {340,1.1001714}, {341,1.1117143}, {342,1.1180571}, {343,1.1289429}, {344,1.1367429}, {345,1.1400857}, {346,1.1421429}, {347,1.1509714}, {348,1.1533714}, {349,1.1624286}, {350,1.1700286}, {351,1.1867143}, {352,1.1827714}, {353,1.1930571}, {354,1.1947714}, {355,1.1956857}, {356,1.2125714}, {357,1.2204000}, {358,1.2189143}, {359,1.2326571}, {360,1.2329143}, {361,1.2330857}, {362,1.2484571}, {363,1.2606000}, {364,1.2628000}, {365,1.2947143}, {366,1.2742286}, {367,1.2842000}, {368,1.2824857}, {369,1.2980857}, {370,1.3021429}, {371,1.3096571}, {372,1.3389714}, {373,1.3144000}, {374,1.3378857}, {375,1.3484857}, {376,1.3393429}, {377,1.3524286}, {378,1.3644286}, {379,1.3622286}, {380,1.3694857}, {381,1.3948571}, {382,1.3966000}, {383,1.4094286}, {384,1.4136571}, {385,1.4270286}, {386,1.4353429}, {387,1.4493429}, {388,1.4474571}, {389,1.4611714}, {390,1.4635714}, {391,1.4753714}, {392,1.4819429}, {393,1.5175143}, {394,1.4967143}, {395,1.5067714}, {396,1.5145429}, {397,1.5160571}, {398,1.5531714}, {399,1.5340000}, {400,1.5698000}, {401,1.5840000}, {402,1.5885143}, {403,1.5739714}, {404,1.5852571}, {405,1.6122857}, {406,1.5905714}, {407,1.6066000}, {408,1.6056857}, {409,1.6192857}, {410,1.6574857}, {411,1.6254000}, {412,1.6295429}, {413,1.6401714}, {414,1.6523143}, {415,1.6551143}, {416,1.6635714}, {417,1.6732286}, {418,1.6742286}, {419,1.6818857}, {420,1.7011143}, {421,1.7286000}, {422,1.7087429}, {423,1.7500857}, {424,1.7389429}, {425,1.7549143}, {426,1.7750286}, {427,1.8068857}, {428,1.7991429}, {429,1.7887714}, {430,1.8262286}, {431,1.8218000}, {432,1.8182571}, {433,1.8252857}, {434,1.8401429}, {435,1.8754000}, {436,1.8420857}, {437,1.8678571}, {438,1.8849714}, {439,1.8922000}, {440,1.8945429}, {441,1.9049429}, {442,1.9171143}, {443,1.9190571}, {444,1.9428286}, {445,1.9528286}, {446,1.9312571}, {447,1.9502857}, {448,1.9557429}, {449,1.9656857}, {450,2.0233429}, {451,2.0034571}, {452,1.9872000}, {453,2.0433714}, {454,2.0318000}, {455,2.0377143}, {456,2.0550571}, {457,2.0670000}, {458,2.0467714}, {459,2.0934286}, {460,2.0683143}, {461,2.1014000}, {462,2.1110571}, {463,2.1828857}, {464,2.1800571}, {465,2.1029143}, {466,2.1742000}, {467,2.1622000}, {468,2.1667714}, {469,2.1513143}, {470,2.1864000}, {471,2.1651429}, {472,2.1755143}, {473,2.1787429}, {474,2.1857714}, {475,2.1891714}, {476,2.2088286}, {477,2.2186857}, {478,2.2252857}, {479,2.2326857}, {480,2.2501429}, {481,2.2624286}, {482,2.2835143}, {483,2.3230857}, {484,2.2935714}, {485,2.3154000}, {486,2.3135429}, {487,2.3197143}, {488,2.3280571}, {489,2.3324000}, {490,2.3476000}, {491,2.3468857}, {492,2.3548857}, {493,2.3792857}, {494,2.3898000}, {495,2.3965429}, {496,2.4189429}, {497,2.4321714}, {498,2.4386857}, {499,2.4409714}, {500,2.4421714}, {505,2.4946286}, {510,2.5457143}, {515,2.5858571}, {520,2.6639429}, {525,2.7416857}, {530,2.7340571}, {535,2.8330857}, {540,2.9122857}, {545,3.0879714}, {550,3.0976286}, {555,3.1465429}, {560,3.1988286}, {565,3.3230857}, {570,3.3460000}, {575,3.4283429}, {580,3.4237143}, {585,3.5979714}, {590,3.6229429}, {595,3.5516286}, {600,3.6470286}, {605,3.7299714}, {610,3.7555143}, {615,3.8119714}, {620,3.8584000}, {625,3.9306857}, {630,3.9896000}, {635,4.0284571}, {640,4.0689429}, {645,4.1228571}, {650,4.2278286}, {655,4.3203429}, {660,4.2915143}, {665,4.3789429}, {670,4.4894000}, {675,4.5560857}, {680,4.5673429}, {685,4.6457714}, {690,4.7247429}, {695,4.8062000}, {700,4.9001143}, {705,4.9908000}, {710,5.0242286}, {715,5.1354571}, {720,5.1762857}, {725,5.2945429}, {730,5.3549429}, {735,5.4588857}, {740,5.5104000}, {745,5.6196286}, {750,5.7367429}, {755,5.8538286}, {760,5.9346571}, {765,6.0232000}, {770,6.0862286}, {775,6.2184286}, {780,6.2844857}, {785,6.3696286}, {790,6.4754286}, {795,6.5724571}, {800,6.6495714}, {805,6.7588571}, {810,6.8396571}, {815,6.9624000}, {820,7.0842857}, {825,7.1521429}, {830,7.2394571}, {835,7.3373143}, {840,7.3900000}, {845,7.5171429}, {850,7.7522000}, {855,7.8166571}, {860,7.9439714}, {865,8.0533714}, {870,8.3090286}, {875,8.4304000}, {880,8.5964571}, {885,8.6028571}, {890,8.7930857}, {895,8.9196571}, {900,8.8516857}, {905,9.2094286}, {910,9.2822286}, {915,9.3824857}, {920,9.4920571}, {925,9.8436286}, {930,9.9973714}, {935,10.0489714}, {940,9.9451429}, {945,10.0728000}, {950,9.9642286}, {955,10.4208857}, {960,10.3058571}, {965,10.3720571}, {970,10.6694571}, {975,10.8771143}, {980,11.0089714}, {985,11.0462286}, {990,11.4014000}, {995,11.0894000}, {1000,11.3699714}, {1010,11.6116571}, {1020,11.8031143}, {1030,12.4594571}, {1040,12.7350571}, {1050,12.8981429}, {1060,13.4536000}, {1070,13.6912000}, {1080,14.2962286}, {1090,14.3632571}, {1100,14.9164571}, {1110,15.0438857}, {1120,15.6179714}, {1130,15.4216000}, {1140,15.8340000}, {1150,16.6618571}, {1160,16.7462571}, {1170,17.1317429}, {1180,17.7110857}, {1190,17.8591143}, {1200,18.2427429}, {1210,18.3498286}, {1220,19.2333143}, {1230,19.2667429}, {1240,19.7210286}, {1250,20.3884857}, {1260,20.3160571}, {1270,21.1405429}, {1280,21.4942286}, {1290,22.3117143}, {1300,22.3915143}, {1310,22.7948571}, {1320,22.9526000}, {1330,23.6044571}, {1340,23.1573714}, {1350,23.6573429}, {1360,24.9082286}, {1370,25.1932571}, {1380,25.4717429}, {1390,26.0034571}, {1400,26.2965143}, {1410,26.3948000}, {1420,27.4190286}, {1430,27.7861143}, {1440,27.9304571}, {1450,28.3744000}, {1460,29.3086000}, {1470,29.3398857}, {1480,29.7310571}, {1490,30.3862571}, {1500,30.7940286}, {1510,31.4731714}, {1520,31.8582000}, {1530,32.9682000}, {1540,33.6606571}, {1550,33.6798286}, {1560,34.6075429}, {1570,34.9056571}, {1580,36.0063714}, {1590,35.4282857}, {1600,37.1961714}, {1610,37.2547714}, {1620,37.4008857}, {1630,38.2464286}, {1640,38.6488000}, {1650,39.3165714}, {1660,40.3327714}, {1670,40.9389714}, {1680,41.5752000}, {1690,42.0118571}, {1700,43.2062000}, {1710,42.8376857}, {1720,44.3927714}, {1730,44.6382286}, {1740,45.0767429}, {1750,45.6942286}, {1760,46.4568000}, {1770,47.5571143}, {1780,48.0646286}, {1790,48.4590571}, {1800,48.4968286}, {1810,49.5487429}, {1820,50.2125714}, {1830,50.9062571}, {1840,52.6579429}, {1850,52.7750000}, {1860,53.1257429}, {1870,54.1923143}, {1880,54.8533714}, {1890,55.5210000}, {1900,56.6528000}, {1910,57.0708000}, {1920,58.6578286}, {1930,58.5742857}, {1940,59.1250857}, {1950,61.0457714}, {1960,59.8831714}, {1970,61.6014286}, {1980,62.1406857}, {1990,63.2234857}, {2000,64.0877429}};
data["big"]["LtacTacInTermExplicitCtx"]["Aggregate"]["system"] = {{1,0.00000000}, {2,0.00002970}, {3,0.00007921}, {4,0.00000000}, {5,0.00003960}, {6,0.00003960}, {7,0.00000000}, {8,0.00007921}, {9,0.00007921}, {10,0.00000000}, {11,0.00003960}, {12,0.00007921}, {13,0.00000000}, {14,0.00019802}, {15,0.00011881}, {16,0.00003960}, {17,0.00003960}, {18,0.00003960}, {19,0.00003960}, {20,0.00000000}, {21,0.00000000}, {22,0.00007921}, {23,0.00011881}, {24,0.00003960}, {25,0.00015842}, {26,0.00007921}, {27,0.00003960}, {28,0.00003960}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00014851}, {34,0.00002970}, {35,0.00003960}, {36,0.00003960}, {37,0.00000000}, {38,0.00003960}, {39,0.00011881}, {40,0.00000000}, {41,0.00007921}, {42,0.00010891}, {43,0.00003960}, {44,0.00000000}, {45,0.00000000}, {46,0.00011881}, {47,0.00007921}, {48,0.00003960}, {49,0.00007921}, {50,0.00003960}, {51,0.00011881}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00015842}, {56,0.00003960}, {57,0.00000000}, {58,0.00003960}, {59,0.00011881}, {60,0.00003960}, {61,0.00011881}, {62,0.00011881}, {63,0.00003960}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00019802}, {68,0.00000000}, {69,0.00007921}, {70,0.00007921}, {71,0.00003960}, {72,0.00007921}, {73,0.00000000}, {74,0.00011881}, {75,0.00000000}, {76,0.00000000}, {77,0.00007921}, {78,0.00011881}, {79,0.00000000}, {80,0.00003960}, {81,0.00003960}, {82,0.00000000}, {83,0.00000000}, {84,0.00015842}, {85,0.00007921}, {86,0.00019802}, {87,0.00007921}, {88,0.00003960}, {89,0.00000000}, {90,0.00003960}, {91,0.00007921}, {92,0.00007921}, {93,0.00007921}, {94,0.00011881}, {95,0.00000000}, {96,0.00003960}, {97,0.00011881}, {98,0.00000000}, {99,0.00000000}, {100,0.00003960}, {101,0.00015842}, {102,0.00023762}, {103,0.00003960}, {104,0.00003960}, {105,0.00007921}, {106,0.00000000}, {107,0.00011881}, {108,0.00007921}, {109,0.00003960}, {110,0.00003960}, {111,0.00003960}, {112,0.00015842}, {113,0.00003960}, {114,0.00011881}, {115,0.00006931}, {116,0.00003960}, {117,0.00003960}, {118,0.00011881}, {119,0.00000000}, {120,0.00003960}, {121,0.00000000}, {122,0.00003960}, {123,0.00007921}, {124,0.00011881}, {125,0.00003960}, {126,0.00011881}, {127,0.00003960}, {128,0.00003960}, {129,0.00007921}, {130,0.00000000}, {131,0.00003960}, {132,0.00003960}, {133,0.00007921}, {134,0.00010891}, {135,0.00003960}, {136,0.00010891}, {137,0.00003960}, {138,0.00015842}, {139,0.00003960}, {140,0.00000000}, {141,0.00007921}, {142,0.00007921}, {143,0.00011881}, {144,0.00007921}, {145,0.00000000}, {146,0.00000000}, {147,0.00011881}, {148,0.00003960}, {149,0.00003960}, {150,0.00000000}, {151,0.00015842}, {152,0.00011881}, {153,0.00003960}, {154,0.00003960}, {155,0.00011881}, {156,0.00011881}, {157,0.00007921}, {158,0.00015842}, {159,0.00019802}, {160,0.00015842}, {161,0.00018812}, {162,0.00003960}, {163,0.00007921}, {164,0.00003960}, {165,0.00000000}, {166,0.00003960}, {167,0.00015842}, {168,0.00023762}, {169,0.00000000}, {170,0.00007921}, {171,0.00011881}, {172,0.00002970}, {173,0.00000000}, {174,0.00007921}, {175,0.00000000}, {176,0.00003960}, {177,0.00003960}, {178,0.00019802}, {179,0.00003960}, {180,0.00000000}, {181,0.00011881}, {182,0.00011881}, {183,0.00000000}, {184,0.00015842}, {185,0.00015842}, {186,0.00003960}, {187,0.00003960}, {188,0.00007921}, {189,0.00003960}, {190,0.00007921}, {191,0.00003960}, {192,0.00000000}, {193,0.00011881}, {194,0.00014851}, {195,0.00011881}, {196,0.00000000}, {197,0.00007921}, {198,0.00000000}, {199,0.00019802}, {200,0.00007921}, {201,0.00003960}, {202,0.00007921}, {203,0.00007921}, {204,0.00019802}, {205,0.00007921}, {206,0.00006931}, {207,0.00003960}, {208,0.00011881}, {209,0.00011881}, {210,0.00023762}, {211,0.00000000}, {212,0.00007921}, {213,0.00007921}, {214,0.00000000}, {215,0.00007921}, {216,0.00003960}, {217,0.00000000}, {218,0.00007921}, {219,0.00003960}, {220,0.00000000}, {221,0.00000000}, {222,0.00007921}, {223,0.00011881}, {224,0.00010891}, {225,0.00011881}, {226,0.00015842}, {227,0.00003960}, {228,0.00003960}, {229,0.00007921}, {230,0.00000000}, {231,0.00007921}, {232,0.00007921}, {233,0.00011881}, {234,0.00023762}, {235,0.00007921}, {236,0.00019802}, {237,0.00015842}, {238,0.00058416}, {239,0.00011881}, {240,0.00015842}, {241,0.00007921}, {242,0.00011881}, {243,0.00011881}, {244,0.00031683}, {245,0.00000000}, {246,0.00019802}, {247,0.00007921}, {248,0.00010891}, {249,0.00011881}, {250,0.00023762}, {251,0.00015842}, {252,0.00000000}, {253,0.00019802}, {254,0.00000000}, {255,0.00007921}, {256,0.00022772}, {257,0.00011881}, {258,0.00007921}, {259,0.00010891}, {260,0.00011881}, {261,0.00007921}, {262,0.00015842}, {263,0.00015842}, {264,0.00007921}, {265,0.00023762}, {266,0.00015842}, {267,0.00026733}, {268,0.00015842}, {269,0.00015842}, {270,0.00003960}, {271,0.00031683}, {272,0.00003960}, {273,0.00031683}, {274,0.00015842}, {275,0.00011881}, {276,0.00003960}, {277,0.00018812}, {278,0.00050495}, {279,0.00011881}, {280,0.00010891}, {281,0.00002970}, {282,0.00007921}, {283,0.00000000}, {284,0.00003960}, {285,0.00018812}, {286,0.00015842}, {287,0.00006931}, {288,0.00018812}, {289,0.00003960}, {290,0.00015842}, {291,0.00007921}, {292,0.00011881}, {293,0.00015842}, {294,0.00023762}, {295,0.00023762}, {296,0.00007921}, {297,0.00011881}, {298,0.00000000}, {299,0.00019802}, {300,0.00007921}, {301,0.0004571}, {302,0.0002286}, {303,0.0003429}, {304,0.0000000}, {305,0.0002286}, {306,0.0002286}, {307,0.0002286}, {308,0.0001143}, {309,0.0002286}, {310,0.0000000}, {311,0.0003429}, {312,0.0002286}, {313,0.0001143}, {314,0.0001143}, {315,0.0001143}, {316,0.0000000}, {317,0.0000857}, {318,0.0001143}, {319,0.0003143}, {320,0.0001143}, {321,0.0003143}, {322,0.0001143}, {323,0.0000000}, {324,0.0003429}, {325,0.0000000}, {326,0.0003429}, {327,0.0001143}, {328,0.0001143}, {329,0.0001143}, {330,0.0002000}, {331,0.0001143}, {332,0.0004571}, {333,0.0001143}, {334,0.0001143}, {335,0.0002286}, {336,0.0001143}, {337,0.0001143}, {338,0.0001143}, {339,0.0001143}, {340,0.0002286}, {341,0.0000000}, {342,0.0002286}, {343,0.0004571}, {344,0.0003429}, {345,0.0002286}, {346,0.0000000}, {347,0.0003429}, {348,0.0000000}, {349,0.0003429}, {350,0.0001143}, {351,0.0001143}, {352,0.0001143}, {353,0.0000000}, {354,0.0002000}, {355,0.0001143}, {356,0.0001143}, {357,0.0002286}, {358,0.0000000}, {359,0.0001143}, {360,0.0003429}, {361,0.0001143}, {362,0.0000000}, {363,0.0003143}, {364,0.0002286}, {365,0.0003429}, {366,0.0002286}, {367,0.0002286}, {368,0.0001143}, {369,0.0004571}, {370,0.0001143}, {371,0.0001143}, {372,0.0006286}, {373,0.0001143}, {374,0.0001143}, {375,0.0001143}, {376,0.0001143}, {377,0.0002286}, {378,0.0003429}, {379,0.0003429}, {380,0.0002286}, {381,0.0009143}, {382,0.0003429}, {383,0.0006857}, {384,0.0003429}, {385,0.0004571}, {386,0.0001143}, {387,0.0002286}, {388,0.0004571}, {389,0.0001143}, {390,0.0004571}, {391,0.0006857}, {392,0.0008000}, {393,0.0006857}, {394,0.0003429}, {395,0.0004571}, {396,0.0003429}, {397,0.0000000}, {398,0.0004286}, {399,0.0002286}, {400,0.0003429}, {401,0.0001143}, {402,0.0004571}, {403,0.0002286}, {404,0.0000000}, {405,0.0000000}, {406,0.0002286}, {407,0.0004286}, {408,0.0001143}, {409,0.0003429}, {410,0.0007714}, {411,0.0005714}, {412,0.0003429}, {413,0.0002286}, {414,0.0005429}, {415,0.0000000}, {416,0.0003429}, {417,0.0002286}, {418,0.0002286}, {419,0.0004571}, {420,0.0003429}, {421,0.0004571}, {422,0.0002286}, {423,0.0001143}, {424,0.0002286}, {425,0.0004571}, {426,0.0004571}, {427,0.0004571}, {428,0.0004571}, {429,0.0003429}, {430,0.0003429}, {431,0.0004571}, {432,0.0001143}, {433,0.0003429}, {434,0.0001143}, {435,0.0002286}, {436,0.0003429}, {437,0.0006571}, {438,0.0004571}, {439,0.0003429}, {440,0.0003429}, {441,0.0004571}, {442,0.0005714}, {443,0.0001143}, {444,0.0002286}, {445,0.0004571}, {446,0.0006857}, {447,0.0003429}, {448,0.0008000}, {449,0.0001143}, {450,0.0005714}, {451,0.0006857}, {452,0.0003429}, {453,0.0008000}, {454,0.0009143}, {455,0.0005714}, {456,0.0004571}, {457,0.0004571}, {458,0.0000000}, {459,0.0001143}, {460,0.0005714}, {461,0.0005714}, {462,0.0003429}, {463,0.0004286}, {464,0.0005714}, {465,0.0010286}, {466,0.0005714}, {467,0.0004571}, {468,0.0002286}, {469,0.0003429}, {470,0.0000000}, {471,0.0002286}, {472,0.0003429}, {473,0.0008000}, {474,0.0004571}, {475,0.0001143}, {476,0.0005714}, {477,0.0008000}, {478,0.0004571}, {479,0.0008000}, {480,0.0003429}, {481,0.0004571}, {482,0.0006857}, {483,0.0006857}, {484,0.0004571}, {485,0.0004571}, {486,0.0006571}, {487,0.0002286}, {488,0.0008000}, {489,0.0003143}, {490,0.0006857}, {491,0.0008857}, {492,0.0003429}, {493,0.0004286}, {494,0.0005714}, {495,0.0005714}, {496,0.0004571}, {497,0.0004571}, {498,0.0004571}, {499,0.0005714}, {500,0.0003429}, {505,0.0000000}, {510,0.0009143}, {515,0.0002286}, {520,0.0003429}, {525,0.0004571}, {530,0.0014857}, {535,0.0008000}, {540,0.0007714}, {545,0.0010286}, {550,0.0014857}, {555,0.0004571}, {560,0.0018286}, {565,0.0009143}, {570,0.0004571}, {575,0.0018286}, {580,0.0010286}, {585,0.0003429}, {590,0.0005714}, {595,0.0009143}, {600,0.0014571}, {605,0.0014857}, {610,0.0010286}, {615,0.0012571}, {620,0.0014857}, {625,0.0013714}, {630,0.0010000}, {635,0.0018286}, {640,0.0012571}, {645,0.0020286}, {650,0.0023714}, {655,0.0014857}, {660,0.0014857}, {665,0.0008000}, {670,0.0006857}, {675,0.0012571}, {680,0.0019429}, {685,0.0013429}, {690,0.0016000}, {695,0.0028286}, {700,0.0030286}, {705,0.0024000}, {710,0.0024000}, {715,0.0035143}, {720,0.0056000}, {725,0.0033143}, {730,0.0026000}, {735,0.0052571}, {740,0.0037429}, {745,0.0043429}, {750,0.0069714}, {755,0.0085429}, {760,0.0057714}, {765,0.0073143}, {770,0.0058286}, {775,0.0058286}, {780,0.0062571}, {785,0.0084571}, {790,0.0080571}, {795,0.0078571}, {800,0.0058286}, {805,0.0070857}, {810,0.0080000}, {815,0.0087429}, {820,0.0082857}, {825,0.0078286}, {830,0.0082000}, {835,0.0077429}, {840,0.0137143}, {845,0.0093714}, {850,0.0090000}, {855,0.0104000}, {860,0.0132571}, {865,0.0088571}, {870,0.0107143}, {875,0.0104000}, {880,0.0147429}, {885,0.0056857}, {890,0.0130286}, {895,0.0097429}, {900,0.0074286}, {905,0.0101429}, {910,0.0108000}, {915,0.0098857}, {920,0.0095429}, {925,0.0086857}, {930,0.0112857}, {935,0.0166286}, {940,0.0100286}, {945,0.0122286}, {950,0.0098857}, {955,0.0104000}, {960,0.0095429}, {965,0.0138000}, {970,0.0154857}, {975,0.0106857}, {980,0.0138000}, {985,0.0093429}, {990,0.0134000}, {995,0.0115429}, {1000,0.0133429}, {1010,0.0067714}, {1020,0.0094571}, {1030,0.0066857}, {1040,0.0078571}, {1050,0.0070286}, {1060,0.0071714}, {1070,0.0048000}, {1080,0.0076000}, {1090,0.0078286}, {1100,0.0074857}, {1110,0.0102857}, {1120,0.0079143}, {1130,0.0096857}, {1140,0.0118571}, {1150,0.0085143}, {1160,0.0093143}, {1170,0.0088286}, {1180,0.0119143}, {1190,0.0109714}, {1200,0.0110000}, {1210,0.0119143}, {1220,0.0149429}, {1230,0.0133429}, {1240,0.0226571}, {1250,0.0120571}, {1260,0.0134857}, {1270,0.0113714}, {1280,0.0107714}, {1290,0.0137429}, {1300,0.0118000}, {1310,0.0171714}, {1320,0.0166857}, {1330,0.0128000}, {1340,0.0200286}, {1350,0.0178000}, {1360,0.0143143}, {1370,0.0146000}, {1380,0.0180857}, {1390,0.0187714}, {1400,0.0195143}, {1410,0.0232286}, {1420,0.0155714}, {1430,0.0205429}, {1440,0.0256571}, {1450,0.0258000}, {1460,0.0248000}, {1470,0.0248857}, {1480,0.0273714}, {1490,0.0258286}, {1500,0.0283143}, {1510,0.0293429}, {1520,0.0287714}, {1530,0.0226571}, {1540,0.0228571}, {1550,0.0253429}, {1560,0.0333714}, {1570,0.0299714}, {1580,0.0360286}, {1590,0.0365143}, {1600,0.0254286}, {1610,0.0274286}, {1620,0.0335429}, {1630,0.0267429}, {1640,0.0275714}, {1650,0.0322000}, {1660,0.0296286}, {1670,0.0315429}, {1680,0.0271429}, {1690,0.0312000}, {1700,0.0301143}, {1710,0.0314857}, {1720,0.0282857}, {1730,0.0388286}, {1740,0.0351143}, {1750,0.0369429}, {1760,0.0438857}, {1770,0.0351143}, {1780,0.0290857}, {1790,0.0321429}, {1800,0.0369143}, {1810,0.0320571}, {1820,0.0456857}, {1830,0.0438000}, {1840,0.0317429}, {1850,0.0404000}, {1860,0.0563429}, {1870,0.0454286}, {1880,0.0469714}, {1890,0.0483143}, {1900,0.0520857}, {1910,0.0442857}, {1920,0.0409429}, {1930,0.0452000}, {1940,0.0479714}, {1950,0.0343429}, {1960,0.0436286}, {1970,0.0312000}, {1980,0.0414000}, {1990,0.0517714}, {2000,0.0455714}};
data["big"]["LtacTacInTermExplicitCtx"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00028713}, {3,0.00100000}, {4,0.00100000}, {5,0.00200000}, {6,0.00200000}, {7,0.00247525}, {8,0.00300000}, {9,0.00320792}, {10,0.00400000}, {11,0.00423762}, {12,0.00610891}, {13,0.00526733}, {14,0.00600000}, {15,0.00635644}, {16,0.00700000}, {17,0.00933663}, {18,0.00805941}, {19,0.00893069}, {20,0.00931683}, {21,0.01243564}, {22,0.01078218}, {23,0.01124752}, {24,0.01202970}, {25,0.01269307}, {26,0.01326733}, {27,0.01400990}, {28,0.01480198}, {29,0.01532673}, {30,0.01604950}, {31,0.01820792}, {32,0.01770297}, {33,0.01829703}, {34,0.01905941}, {35,0.02000000}, {36,0.02083168}, {37,0.02149505}, {38,0.02234653}, {39,0.02723762}, {40,0.02645545}, {41,0.02490099}, {42,0.02590099}, {43,0.02672277}, {44,0.03674257}, {45,0.02851485}, {46,0.02950495}, {47,0.03753465}, {48,0.03109901}, {49,0.03770297}, {50,0.03351485}, {51,0.04182178}, {52,0.03521782}, {53,0.03627723}, {54,0.03736634}, {55,0.03832673}, {56,0.03925743}, {57,0.04420792}, {58,0.05205941}, {59,0.04276238}, {60,0.04379208}, {61,0.04484158}, {62,0.04606931}, {63,0.04720792}, {64,0.05580198}, {65,0.05830693}, {66,0.05365347}, {67,0.05180198}, {68,0.05305941}, {69,0.06688119}, {70,0.05543564}, {71,0.06319802}, {72,0.05763366}, {73,0.06584158}, {74,0.06042574}, {75,0.08348515}, {76,0.06286139}, {77,0.06437624}, {78,0.07663366}, {79,0.08903960}, {80,0.08214851}, {81,0.08201980}, {82,0.07116832}, {83,0.08617822}, {84,0.11762376}, {85,0.07484158}, {86,0.07638614}, {87,0.07812871}, {88,0.07951485}, {89,0.08103960}, {90,0.08273267}, {91,0.08417822}, {92,0.08506931}, {93,0.08703960}, {94,0.08876238}, {95,0.08937624}, {96,0.09129703}, {97,0.09338614}, {98,0.09409901}, {99,0.09616832}, {100,0.09817822}, {101,0.09983168}, {102,0.10146535}, {103,0.10308911}, {104,0.11758416}, {105,0.11876238}, {106,0.12159406}, {107,0.12277228}, {108,0.12530693}, {109,0.12823762}, {110,0.13175248}, {111,0.13314851}, {112,0.13652475}, {113,0.13977228}, {114,0.14310891}, {115,0.14528713}, {116,0.14937624}, {117,0.15360396}, {118,0.15478218}, {119,0.15790099}, {120,0.15956436}, {121,0.16243564}, {122,0.16285149}, {123,0.16405941}, {124,0.16565347}, {125,0.16949505}, {126,0.17150495}, {127,0.17437624}, {128,0.17988119}, {129,0.18007921}, {130,0.18525743}, {131,0.18638614}, {132,0.18864356}, {133,0.19062376}, {134,0.19250495}, {135,0.19547525}, {136,0.19795050}, {137,0.20208911}, {138,0.20413861}, {139,0.20714851}, {140,0.20987129}, {141,0.20991089}, {142,0.21594059}, {143,0.21643564}, {144,0.22114851}, {145,0.22455446}, {146,0.22549505}, {147,0.22945545}, {148,0.23293069}, {149,0.23291089}, {150,0.23601980}, {151,0.23776238}, {152,0.24063366}, {153,0.24346535}, {154,0.24629703}, {155,0.24877228}, {156,0.25294059}, {157,0.25364356}, {158,0.25811881}, {159,0.25849505}, {160,0.26184158}, {161,0.26442574}, {162,0.26885149}, {163,0.27004950}, {164,0.27269307}, {165,0.27375248}, {166,0.27990099}, {167,0.28294059}, {168,0.28696040}, {169,0.29320792}, {170,0.29420792}, {171,0.29488119}, {172,0.29623762}, {173,0.29985149}, {174,0.30518812}, {175,0.30969307}, {176,0.31373267}, {177,0.31461386}, {178,0.31594059}, {179,0.32050495}, {180,0.32406931}, {181,0.32568317}, {182,0.33033663}, {183,0.33134653}, {184,0.33463366}, {185,0.33790099}, {186,0.34085149}, {187,0.34314851}, {188,0.34667327}, {189,0.35055446}, {190,0.35596040}, {191,0.35603960}, {192,0.36416832}, {193,0.37100000}, {194,0.36980198}, {195,0.36916832}, {196,0.37257426}, {197,0.37617822}, {198,0.37911881}, {199,0.38174257}, {200,0.38903960}, {201,0.39975248}, {202,0.39475248}, {203,0.39051485}, {204,0.39968317}, {205,0.40113861}, {206,0.41265347}, {207,0.42096040}, {208,0.40976238}, {209,0.41508911}, {210,0.41892079}, {211,0.43841584}, {212,0.43337624}, {213,0.43003960}, {214,0.43159406}, {215,0.45043564}, {216,0.44570297}, {217,0.44493069}, {218,0.46398020}, {219,0.45746535}, {220,0.45766337}, {221,0.46998020}, {222,0.47061386}, {223,0.47165347}, {224,0.48528713}, {225,0.47974257}, {226,0.48701980}, {227,0.48647525}, {228,0.49217822}, {229,0.50342574}, {230,0.50038614}, {231,0.51458416}, {232,0.50598020}, {233,0.52446535}, {234,0.51458416}, {235,0.53263366}, {236,0.52135644}, {237,0.53372277}, {238,0.53318812}, {239,0.53229703}, {240,0.54548515}, {241,0.54028713}, {242,0.55591089}, {243,0.55585149}, {244,0.55934653}, {245,0.56494059}, {246,0.60927723}, {247,0.56893069}, {248,0.57902970}, {249,0.57820792}, {250,0.58396040}, {251,0.60837624}, {252,0.59051485}, {253,0.59057426}, {254,0.60057426}, {255,0.60871287}, {256,0.62224752}, {257,0.74416832}, {258,0.62887129}, {259,0.63129703}, {260,0.63206931}, {261,0.63891089}, {262,0.64349505}, {263,0.64497030}, {264,0.65697030}, {265,0.65611881}, {266,0.72671287}, {267,0.66134653}, {268,0.66503960}, {269,0.67293069}, {270,0.67457426}, {271,0.69041584}, {272,0.68810891}, {273,0.75207921}, {274,0.69691089}, {275,0.70442574}, {276,0.70576238}, {277,0.70718812}, {278,0.70916832}, {279,0.72118812}, {280,0.76156436}, {281,0.72631683}, {282,0.73254455}, {283,0.73582178}, {284,0.74005941}, {285,0.74466337}, {286,0.74679208}, {287,0.75391089}, {288,0.75999010}, {289,0.76867327}, {290,0.77145545}, {291,0.77927723}, {292,0.79988119}, {293,0.79068317}, {294,0.79979208}, {295,0.81267327}, {296,0.81262376}, {297,0.81780198}, {298,0.82128713}, {299,0.84149505}, {300,0.84006931}, {301,1.0318571}, {302,0.9620571}, {303,0.9524000}, {304,0.9258000}, {305,0.8992571}, {306,0.9090286}, {307,0.9284286}, {308,0.9228571}, {309,0.9246571}, {310,0.9354286}, {311,0.9464000}, {312,0.9459714}, {313,0.9559143}, {314,0.9589429}, {315,0.9634000}, {316,0.9660857}, {317,0.9750571}, {318,0.9816857}, {319,0.9901714}, {320,0.9936000}, {321,0.9876857}, {322,1.0083143}, {323,1.0005143}, {324,1.0114571}, {325,1.0091429}, {326,1.0230286}, {327,1.0265429}, {328,1.0319429}, {329,1.0351429}, {330,1.0412571}, {331,1.0653143}, {332,1.0459143}, {333,1.0574000}, {334,1.0539143}, {335,1.0689143}, {336,1.0975714}, {337,1.0704286}, {338,1.0840000}, {339,1.0830857}, {340,1.0966571}, {341,1.1077714}, {342,1.1142000}, {343,1.1254857}, {344,1.1330571}, {345,1.1358857}, {346,1.1382571}, {347,1.1476286}, {348,1.1492571}, {349,1.1582571}, {350,1.1670000}, {351,1.1827143}, {352,1.1787143}, {353,1.1890857}, {354,1.1910571}, {355,1.1920286}, {356,1.2083143}, {357,1.2160000}, {358,1.2145429}, {359,1.2288286}, {360,1.2296000}, {361,1.2290286}, {362,1.2443143}, {363,1.2574000}, {364,1.2592857}, {365,1.2907429}, {366,1.2706571}, {367,1.2802286}, {368,1.2776000}, {369,1.2948000}, {370,1.2983714}, {371,1.3055143}, {372,1.3357429}, {373,1.3102857}, {374,1.3341143}, {375,1.3438000}, {376,1.3350000}, {377,1.3489714}, {378,1.3607429}, {379,1.3594857}, {380,1.3658857}, {381,1.3902857}, {382,1.3919714}, {383,1.4065143}, {384,1.4105714}, {385,1.4233714}, {386,1.4313714}, {387,1.4459143}, {388,1.4444000}, {389,1.4576571}, {390,1.4602571}, {391,1.4718286}, {392,1.4786000}, {393,1.5140857}, {394,1.4930571}, {395,1.5033143}, {396,1.5103143}, {397,1.5126000}, {398,1.5501143}, {399,1.5301714}, {400,1.5664571}, {401,1.5799143}, {402,1.5851429}, {403,1.5744286}, {404,1.5906857}, {405,1.6105714}, {406,1.5920571}, {407,1.6029714}, {408,1.6026571}, {409,1.6217143}, {410,1.6550857}, {411,1.6225429}, {412,1.6266286}, {413,1.6372857}, {414,1.6496286}, {415,1.6516000}, {416,1.6605143}, {417,1.6693429}, {418,1.6708000}, {419,1.6784286}, {420,1.6973714}, {421,1.7248000}, {422,1.7054000}, {423,1.7459714}, {424,1.7360286}, {425,1.7520857}, {426,1.7715143}, {427,1.8041429}, {428,1.7961714}, {429,1.7859429}, {430,1.8238000}, {431,1.8193143}, {432,1.8155429}, {433,1.8225429}, {434,1.8372000}, {435,1.8715429}, {436,1.8378286}, {437,1.8639143}, {438,1.8807143}, {439,1.8879714}, {440,1.8922000}, {441,1.9036571}, {442,1.9150286}, {443,1.9162286}, {444,1.9412857}, {445,1.9510286}, {446,1.9290000}, {447,1.9474286}, {448,1.9531429}, {449,1.9620857}, {450,2.0209143}, {451,2.0006571}, {452,1.9841714}, {453,2.0413143}, {454,2.0299714}, {455,2.0356000}, {456,2.0518286}, {457,2.0640571}, {458,2.0430857}, {459,2.0902286}, {460,2.0652857}, {461,2.0983714}, {462,2.1077143}, {463,2.1794571}, {464,2.1770857}, {465,2.0998286}, {466,2.1708857}, {467,2.1585714}, {468,2.1626857}, {469,2.1471714}, {470,2.1837143}, {471,2.1622857}, {472,2.1725714}, {473,2.1766857}, {474,2.1834000}, {475,2.1848286}, {476,2.2052571}, {477,2.2149143}, {478,2.2231143}, {479,2.2311714}, {480,2.2486857}, {481,2.2608571}, {482,2.2830286}, {483,2.3230857}, {484,2.2929143}, {485,2.3140857}, {486,2.3131429}, {487,2.3190857}, {488,2.3269714}, {489,2.3304857}, {490,2.3463429}, {491,2.3466286}, {492,2.3528571}, {493,2.3776857}, {494,2.3886286}, {495,2.3946857}, {496,2.4163714}, {497,2.4300571}, {498,2.4373429}, {499,2.4394857}, {500,2.4404857}, {505,2.4919429}, {510,2.5450857}, {515,2.5859429}, {520,2.6644000}, {525,2.7413429}, {530,2.7351714}, {535,2.8347429}, {540,2.9135143}, {545,3.0880571}, {550,3.0998286}, {555,3.1454000}, {560,3.2007714}, {565,3.3234571}, {570,3.3460857}, {575,3.4298286}, {580,3.4251714}, {585,3.5981429}, {590,3.6228000}, {595,3.5517143}, {600,3.6473714}, {605,3.7296000}, {610,3.7552286}, {615,3.8117714}, {620,3.8590571}, {625,3.9288000}, {630,3.9898571}, {635,4.0282571}, {640,4.0674857}, {645,4.1206286}, {650,4.2245143}, {655,4.3168571}, {660,4.2883429}, {665,4.3762857}, {670,4.4854571}, {675,4.5527429}, {680,4.5661714}, {685,4.6439714}, {690,4.7222286}, {695,4.8048286}, {700,4.8999429}, {705,4.9879714}, {710,5.0247143}, {715,5.1355143}, {720,5.1791714}, {725,5.2959714}, {730,5.3559429}, {735,5.4594857}, {740,5.5120286}, {745,5.6187143}, {750,5.7395143}, {755,5.8580857}, {760,5.9356000}, {765,6.0264571}, {770,6.0893714}, {775,6.2214857}, {780,6.2865714}, {785,6.3731143}, {790,6.4850857}, {795,6.5858857}, {800,6.6650857}, {805,6.7850571}, {810,6.8476857}, {815,6.9721714}, {820,7.0921143}, {825,7.1602571}, {830,7.2482000}, {835,7.3437714}, {840,7.4019143}, {845,7.5250000}, {850,7.7594286}, {855,7.8238000}, {860,7.9552857}, {865,8.0585429}, {870,8.3145143}, {875,8.4350286}, {880,8.6029429}, {885,8.5989429}, {890,8.7982286}, {895,8.9230286}, {900,8.8488286}, {905,9.2179429}, {910,9.2941714}, {915,9.3898571}, {920,9.4992286}, {925,9.8505714}, {930,10.0090286}, {935,10.0652286}, {940,9.9538286}, {945,10.0823143}, {950,9.9670857}, {955,10.4264857}, {960,10.3125714}, {965,10.3891143}, {970,10.6873714}, {975,10.8903429}, {980,11.0267429}, {985,11.0645143}, {990,11.4261714}, {995,11.1088000}, {1000,11.3948857}, {1010,11.6334000}, {1020,11.8234571}, {1030,12.4764286}, {1040,12.7490000}, {1050,12.9110286}, {1060,13.4634000}, {1070,13.7072857}, {1080,14.3036571}, {1090,14.3700286}, {1100,14.9294286}, {1110,15.0728000}, {1120,15.6318857}, {1130,15.4362857}, {1140,15.8485143}, {1150,16.6712571}, {1160,16.7580286}, {1170,17.1426000}, {1180,17.7256286}, {1190,17.8715714}, {1200,18.2559429}, {1210,18.3661143}, {1220,19.2531143}, {1230,19.2894857}, {1240,19.7593429}, {1250,20.4192286}, {1260,20.3420571}, {1270,21.1642857}, {1280,21.5239143}, {1290,22.3311429}, {1300,22.4090571}, {1310,22.8120286}, {1320,22.9773429}, {1330,23.6178571}, {1340,23.1886571}, {1350,23.6805143}, {1360,24.9304857}, {1370,25.2243429}, {1380,25.4946857}, {1390,26.0336857}, {1400,26.3183714}, {1410,26.4210857}, {1420,27.4416000}, {1430,27.8080286}, {1440,27.9825714}, {1450,28.4166286}, {1460,29.3518571}, {1470,29.3818571}, {1480,29.7661143}, {1490,30.4158000}, {1500,30.8306857}, {1510,31.5216000}, {1520,31.8931143}, {1530,33.0030286}, {1540,33.7009429}, {1550,33.7151714}, {1560,34.6500857}, {1570,34.9750000}, {1580,36.0555714}, {1590,35.5002286}, {1600,37.2406857}, {1610,37.2932000}, {1620,37.4433143}, {1630,38.2849143}, {1640,38.6846857}, {1650,39.3711429}, {1660,40.3811714}, {1670,41.0064000}, {1680,41.6285429}, {1690,42.0670286}, {1700,43.2643714}, {1710,42.8830000}, {1720,44.4607429}, {1730,44.7097429}, {1740,45.1434571}, {1750,45.7525714}, {1760,46.5268571}, {1770,47.6207143}, {1780,48.1093714}, {1790,48.4918571}, {1800,48.5393143}, {1810,49.5824000}, {1820,50.2655714}, {1830,50.9832286}, {1840,52.7295429}, {1850,52.8394857}, {1860,53.2272286}, {1870,54.2637143}, {1880,54.9387143}, {1890,55.6044286}, {1900,56.7137714}, {1910,57.1165714}, {1920,58.7137429}, {1930,58.6371429}, {1940,59.1900571}, {1950,61.0690000}, {1960,59.9482571}, {1970,61.6232000}, {1980,62.1662857}, {1990,63.2635429}, {2000,64.1396000}};
data["big"]["LtacTacInTermExplicitCtx"]["actual reif"]["user"] = {{1,0.00064356}, {2,0.00092079}, {3,0.00114851}, {4,0.00207921}, {5,0.00201980}, {6,0.00259406}, {7,0.00321782}, {8,0.00318812}, {9,0.00370297}, {10,0.00418812}, {11,0.00432673}, {12,0.00632673}, {13,0.00576238}, {14,0.00586139}, {15,0.00634653}, {16,0.00720792}, {17,0.00958416}, {18,0.00813861}, {19,0.00874257}, {20,0.00941584}, {21,0.01256436}, {22,0.01051485}, {23,0.01102970}, {24,0.01171287}, {25,0.01244554}, {26,0.01341584}, {27,0.01370297}, {28,0.01452475}, {29,0.01498020}, {30,0.01600990}, {31,0.01757426}, {32,0.01720792}, {33,0.01800990}, {34,0.01869307}, {35,0.01971287}, {36,0.02070297}, {37,0.02172277}, {38,0.02204950}, {39,0.02733663}, {40,0.02645545}, {41,0.02501980}, {42,0.02601980}, {43,0.02698020}, {44,0.03670297}, {45,0.02858416}, {46,0.02963366}, {47,0.03728713}, {48,0.03128713}, {49,0.03736634}, {50,0.03399010}, {51,0.04147525}, {52,0.03509901}, {53,0.03624752}, {54,0.03718812}, {55,0.03805941}, {56,0.03897030}, {57,0.04389109}, {58,0.05222772}, {59,0.04253465}, {60,0.04318812}, {61,0.04448515}, {62,0.04587129}, {63,0.04732673}, {64,0.05587129}, {65,0.05802970}, {66,0.05377228}, {67,0.05167327}, {68,0.05327723}, {69,0.06678218}, {70,0.05555446}, {71,0.06295050}, {72,0.05718812}, {73,0.06538614}, {74,0.05995050}, {75,0.08376238}, {76,0.06269307}, {77,0.06393069}, {78,0.07666337}, {79,0.08858416}, {80,0.08202970}, {81,0.08186139}, {82,0.07147525}, {83,0.08608911}, {84,0.11730693}, {85,0.07471287}, {86,0.07645545}, {87,0.07790099}, {88,0.07935644}, {89,0.08088119}, {90,0.08283168}, {91,0.08402970}, {92,0.08464356}, {93,0.08650495}, {94,0.08811881}, {95,0.08879208}, {96,0.09063366}, {97,0.09356436}, {98,0.09384158}, {99,0.09639604}, {100,0.09816832}, {101,0.09987129}, {102,0.10110891}, {103,0.10292079}, {104,0.11744554}, {105,0.11855446}, {106,0.12130693}, {107,0.12283168}, {108,0.12524752}, {109,0.12793069}, {110,0.13115842}, {111,0.13259406}, {112,0.13619802}, {113,0.13937624}, {114,0.14298020}, {115,0.14472277}, {116,0.14918812}, {117,0.15338614}, {118,0.15444554}, {119,0.15750495}, {120,0.15927723}, {121,0.16174257}, {122,0.16237624}, {123,0.16358416}, {124,0.16537624}, {125,0.16920792}, {126,0.17117822}, {127,0.17382178}, {128,0.17940594}, {129,0.17944554}, {130,0.18477228}, {131,0.18602970}, {132,0.18807921}, {133,0.19056436}, {134,0.19209901}, {135,0.19521782}, {136,0.19750495}, {137,0.20153465}, {138,0.20369307}, {139,0.20674257}, {140,0.20921782}, {141,0.20947525}, {142,0.21534653}, {143,0.21585149}, {144,0.22060396}, {145,0.22398020}, {146,0.22515842}, {147,0.22890099}, {148,0.23220792}, {149,0.23233663}, {150,0.23530693}, {151,0.23710891}, {152,0.23989109}, {153,0.24310891}, {154,0.24580198}, {155,0.24816832}, {156,0.25218812}, {157,0.25288119}, {158,0.25737624}, {159,0.25778218}, {160,0.26117822}, {161,0.26374257}, {162,0.26813861}, {163,0.26936634}, {164,0.27225743}, {165,0.27298020}, {166,0.27914851}, {167,0.28232673}, {168,0.28632673}, {169,0.29253465}, {170,0.29363366}, {171,0.29400000}, {172,0.29568317}, {173,0.29911881}, {174,0.30459406}, {175,0.30916832}, {176,0.31287129}, {177,0.31386139}, {178,0.31512871}, {179,0.31957426}, {180,0.32322772}, {181,0.32462376}, {182,0.32964356}, {183,0.33095050}, {184,0.33398020}, {185,0.33738614}, {186,0.34014851}, {187,0.34220792}, {188,0.34544554}, {189,0.34956436}, {190,0.35522772}, {191,0.35512871}, {192,0.36337624}, {193,0.37025743}, {194,0.36909901}, {195,0.36843564}, {196,0.37191089}, {197,0.37528713}, {198,0.37852475}, {199,0.38103960}, {200,0.38840594}, {201,0.39898020}, {202,0.39391089}, {203,0.38953465}, {204,0.39882178}, {205,0.40045545}, {206,0.41165347}, {207,0.42006931}, {208,0.40916832}, {209,0.41418812}, {210,0.41779208}, {211,0.43762376}, {212,0.43250495}, {213,0.42950495}, {214,0.43077228}, {215,0.44969307}, {216,0.44476238}, {217,0.44409901}, {218,0.46300990}, {219,0.45683168}, {220,0.45688119}, {221,0.46933663}, {222,0.46963366}, {223,0.47040594}, {224,0.48437624}, {225,0.47854455}, {226,0.48620792}, {227,0.48564356}, {228,0.49144554}, {229,0.50259406}, {230,0.50005941}, {231,0.51355446}, {232,0.50503960}, {233,0.52363366}, {234,0.51310891}, {235,0.53164356}, {236,0.52040594}, {237,0.53304950}, {238,0.53192079}, {239,0.53130693}, {240,0.54420792}, {241,0.53892079}, {242,0.55489109}, {243,0.55518812}, {244,0.55824752}, {245,0.56433663}, {246,0.60793069}, {247,0.56789109}, {248,0.57796040}, {249,0.57717822}, {250,0.58271287}, {251,0.60703960}, {252,0.58949505}, {253,0.58924752}, {254,0.59904950}, {255,0.60757426}, {256,0.62127723}, {257,0.74275248}, {258,0.62750495}, {259,0.63014851}, {260,0.63104950}, {261,0.63800990}, {262,0.64214851}, {263,0.64392079}, {264,0.65576238}, {265,0.65483168}, {266,0.72579208}, {267,0.66002970}, {268,0.66390099}, {269,0.67136634}, {270,0.67347525}, {271,0.68897030}, {272,0.68705941}, {273,0.75059406}, {274,0.69590099}, {275,0.70343564}, {276,0.70456436}, {277,0.70601980}, {278,0.70768317}, {279,0.71983168}, {280,0.76022772}, {281,0.72533663}, {282,0.73131683}, {283,0.73474257}, {284,0.73890099}, {285,0.74315842}, {286,0.74542574}, {287,0.75251485}, {288,0.75857426}, {289,0.76726733}, {290,0.76989109}, {291,0.77795050}, {292,0.79880198}, {293,0.78932673}, {294,0.79790099}, {295,0.81124752}, {296,0.81100990}, {297,0.81617822}, {298,0.81965347}, {299,0.84013861}, {300,0.83879208}, {301,1.0272857}, {302,0.9603714}, {303,0.9515429}, {304,0.9249429}, {305,0.8980857}, {306,0.9078286}, {307,0.9270286}, {308,0.9220571}, {309,0.9240857}, {310,0.9349143}, {311,0.9451143}, {312,0.9451143}, {313,0.9545714}, {314,0.9579714}, {315,0.9621714}, {316,0.9650571}, {317,0.9742286}, {318,0.9808857}, {319,0.9853429}, {320,0.9926857}, {321,0.9862571}, {322,0.9994857}, {323,0.9996571}, {324,1.0072286}, {325,1.0082857}, {326,1.0212000}, {327,1.0230286}, {328,1.0298571}, {329,1.0341714}, {330,1.0388286}, {331,1.0540286}, {332,1.0441429}, {333,1.0547714}, {334,1.0513143}, {335,1.0669429}, {336,1.0959143}, {337,1.0692571}, {338,1.0825714}, {339,1.0812286}, {340,1.0952000}, {341,1.1067429}, {342,1.1127429}, {343,1.1242000}, {344,1.1313143}, {345,1.1346857}, {346,1.1377143}, {347,1.1468857}, {348,1.1483143}, {349,1.1568286}, {350,1.1656000}, {351,1.1822000}, {352,1.1775714}, {353,1.1877143}, {354,1.1897429}, {355,1.1907714}, {356,1.2073429}, {357,1.2155714}, {358,1.2130857}, {359,1.2276571}, {360,1.2276857}, {361,1.2274000}, {362,1.2431714}, {363,1.2556286}, {364,1.2569714}, {365,1.2888286}, {366,1.2686857}, {367,1.2784000}, {368,1.2763429}, {369,1.2932857}, {370,1.2965429}, {371,1.3035714}, {372,1.3340571}, {373,1.3088000}, {374,1.3324571}, {375,1.3423429}, {376,1.3339714}, {377,1.3468571}, {378,1.3583714}, {379,1.3568000}, {380,1.3636286}, {381,1.3871429}, {382,1.3895714}, {383,1.4038571}, {384,1.4074571}, {385,1.4208857}, {386,1.4292000}, {387,1.4436000}, {388,1.4418857}, {389,1.4551429}, {390,1.4574571}, {391,1.4698000}, {392,1.4763714}, {393,1.5117429}, {394,1.4911429}, {395,1.5017143}, {396,1.5090571}, {397,1.5109429}, {398,1.5479143}, {399,1.5280857}, {400,1.5638571}, {401,1.5780571}, {402,1.5826000}, {403,1.5682000}, {404,1.5782571}, {405,1.6065429}, {406,1.5851143}, {407,1.6008286}, {408,1.5991143}, {409,1.6135429}, {410,1.6511143}, {411,1.6196000}, {412,1.6233429}, {413,1.6343143}, {414,1.6460286}, {415,1.6488571}, {416,1.6578000}, {417,1.6666000}, {418,1.6676857}, {419,1.6757429}, {420,1.6949714}, {421,1.7219429}, {422,1.7030286}, {423,1.7435714}, {424,1.7331714}, {425,1.7488571}, {426,1.7694857}, {427,1.7999429}, {428,1.7935714}, {429,1.7822286}, {430,1.8198000}, {431,1.8155714}, {432,1.8116571}, {433,1.8186571}, {434,1.8341143}, {435,1.8680286}, {436,1.8344857}, {437,1.8597429}, {438,1.8766571}, {439,1.8833429}, {440,1.8878286}, {441,1.8987429}, {442,1.9109429}, {443,1.9128286}, {444,1.9376000}, {445,1.9468286}, {446,1.9248000}, {447,1.9434571}, {448,1.9487714}, {449,1.9590000}, {450,2.0170286}, {451,1.9967143}, {452,1.9812000}, {453,2.0368571}, {454,2.0252000}, {455,2.0320286}, {456,2.0482000}, {457,2.0603143}, {458,2.0397429}, {459,2.0864571}, {460,2.0618571}, {461,2.0951714}, {462,2.1041714}, {463,2.1764000}, {464,2.1738571}, {465,2.0962571}, {466,2.1673143}, {467,2.1554571}, {468,2.1599429}, {469,2.1440857}, {470,2.1802000}, {471,2.1586000}, {472,2.1681429}, {473,2.1724000}, {474,2.1786571}, {475,2.1808286}, {476,2.2001714}, {477,2.2105429}, {478,2.2188857}, {479,2.2262571}, {480,2.2432286}, {481,2.2554286}, {482,2.2772000}, {483,2.3163429}, {484,2.2866571}, {485,2.3082857}, {486,2.3070857}, {487,2.3132857}, {488,2.3210857}, {489,2.3255429}, {490,2.3402857}, {491,2.3410857}, {492,2.3466857}, {493,2.3718571}, {494,2.3822286}, {495,2.3891714}, {496,2.4111429}, {497,2.4249429}, {498,2.4317429}, {499,2.4344286}, {500,2.4351714}, {505,2.4869714}, {510,2.5382286}, {515,2.5800571}, {520,2.6567143}, {525,2.7344857}, {530,2.7272000}, {535,2.8258000}, {540,2.9052571}, {545,3.0787714}, {550,3.0894286}, {555,3.1361143}, {560,3.1910000}, {565,3.3147714}, {570,3.3382857}, {575,3.4195143}, {580,3.4152000}, {585,3.5894857}, {590,3.6146286}, {595,3.5430286}, {600,3.6385714}, {605,3.7220857}, {610,3.7476286}, {615,3.8036857}, {620,3.8505429}, {625,3.9200857}, {630,3.9805143}, {635,4.0187714}, {640,4.0597429}, {645,4.1138000}, {650,4.2185429}, {655,4.3122571}, {660,4.2827429}, {665,4.3698286}, {670,4.4793714}, {675,4.5468000}, {680,4.5585143}, {685,4.6360571}, {690,4.7146571}, {695,4.7963429}, {700,4.8905429}, {705,4.9809429}, {710,5.0152571}, {715,5.1247143}, {720,5.1669143}, {725,5.2844857}, {730,5.3452000}, {735,5.4495143}, {740,5.5014000}, {745,5.6092571}, {750,5.7269429}, {755,5.8442000}, {760,5.9246000}, {765,6.0125714}, {770,6.0758000}, {775,6.2078000}, {780,6.2734857}, {785,6.3585143}, {790,6.4634571}, {795,6.5625714}, {800,6.6392857}, {805,6.7480000}, {810,6.8288000}, {815,6.9516000}, {820,7.0735429}, {825,7.1418286}, {830,7.2288000}, {835,7.3264571}, {840,7.3786000}, {845,7.5059714}, {850,7.7406000}, {855,7.8038857}, {860,7.9323714}, {865,8.0416857}, {870,8.2973714}, {875,8.4195714}, {880,8.5851714}, {885,8.5911429}, {890,8.7813429}, {895,8.9077429}, {900,8.8366286}, {905,9.1985714}, {910,9.2700571}, {915,9.3687429}, {920,9.4796286}, {925,9.8319429}, {930,9.9854286}, {935,10.0367143}, {940,9.9329714}, {945,10.0611143}, {950,9.9520286}, {955,10.4077714}, {960,10.2936286}, {965,10.3593143}, {970,10.6569429}, {975,10.8626000}, {980,10.9965429}, {985,11.0334571}, {990,11.3864857}, {995,11.0764571}, {1000,11.3572000}, {1010,11.5989143}, {1020,11.7898000}, {1030,12.4445429}, {1040,12.7213429}, {1050,12.8848857}, {1060,13.4402857}, {1070,13.6778857}, {1080,14.2824571}, {1090,14.3496286}, {1100,14.9028000}, {1110,15.0304000}, {1120,15.6033714}, {1130,15.4070571}, {1140,15.8195429}, {1150,16.6465714}, {1160,16.7311429}, {1170,17.1168571}, {1180,17.6939714}, {1190,17.8436286}, {1200,18.2272000}, {1210,18.3347429}, {1220,19.2156571}, {1230,19.2504571}, {1240,19.7048857}, {1250,20.3714571}, {1260,20.3002000}, {1270,21.1215429}, {1280,21.4781143}, {1290,22.2947714}, {1300,22.3756571}, {1310,22.7776571}, {1320,22.9363143}, {1330,23.5872571}, {1340,23.1406857}, {1350,23.6394286}, {1360,24.8912571}, {1370,25.1760286}, {1380,25.4533429}, {1390,25.9861429}, {1400,26.2788286}, {1410,26.3768571}, {1420,27.4018286}, {1430,27.7676000}, {1440,27.9126571}, {1450,28.3560857}, {1460,29.2914000}, {1470,29.3216000}, {1480,29.7122857}, {1490,30.3680000}, {1500,30.7748000}, {1510,31.4510857}, {1520,31.8385714}, {1530,32.9493429}, {1540,33.6412000}, {1550,33.6553143}, {1560,34.5864000}, {1570,34.8854857}, {1580,35.9859143}, {1590,35.4085429}, {1600,37.1761143}, {1610,37.2346286}, {1620,37.3744000}, {1630,38.2258571}, {1640,38.6274000}, {1650,39.2944286}, {1660,40.3116857}, {1670,40.9179429}, {1680,41.5544571}, {1690,41.9912286}, {1700,43.1844857}, {1710,42.8157714}, {1720,44.3682000}, {1730,44.6166000}, {1740,45.0545143}, {1750,45.6679429}, {1760,46.4350857}, {1770,47.5347714}, {1780,48.0428000}, {1790,48.4349714}, {1800,48.4745714}, {1810,49.5268857}, {1820,50.1893714}, {1830,50.8834286}, {1840,52.6346286}, {1850,52.7511143}, {1860,53.0965714}, {1870,54.1680286}, {1880,54.8296286}, {1890,55.4965143}, {1900,56.6285429}, {1910,57.0462857}, {1920,58.6327429}, {1930,58.5496286}, {1940,59.1006286}, {1950,61.0130857}, {1960,59.8552000}, {1970,61.5776286}, {1980,62.1156857}, {1990,63.1953143}, {2000,64.0631143}};
data["big"]["LtacTacInTermExplicitCtx"]["actual reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003960}, {4,0.00000000}, {5,0.00003960}, {6,0.00003960}, {7,0.00000000}, {8,0.00007921}, {9,0.00007921}, {10,0.00000000}, {11,0.00003960}, {12,0.00007921}, {13,0.00000000}, {14,0.00019802}, {15,0.00007921}, {16,0.00003960}, {17,0.00003960}, {18,0.00003960}, {19,0.00003960}, {20,0.00000000}, {21,0.00000000}, {22,0.00007921}, {23,0.00007921}, {24,0.00003960}, {25,0.00015842}, {26,0.00007921}, {27,0.00003960}, {28,0.00003960}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00010891}, {34,0.00002970}, {35,0.00003960}, {36,0.00003960}, {37,0.00000000}, {38,0.00003960}, {39,0.00007921}, {40,0.00000000}, {41,0.00007921}, {42,0.00006931}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00011881}, {47,0.00007921}, {48,0.00003960}, {49,0.00003960}, {50,0.00003960}, {51,0.00011881}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00015842}, {56,0.00003960}, {57,0.00000000}, {58,0.00003960}, {59,0.00007921}, {60,0.00003960}, {61,0.00003960}, {62,0.00007921}, {63,0.00003960}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00007921}, {68,0.00000000}, {69,0.00007921}, {70,0.00007921}, {71,0.00003960}, {72,0.00007921}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00007921}, {78,0.00007921}, {79,0.00000000}, {80,0.00000000}, {81,0.00003960}, {82,0.00000000}, {83,0.00000000}, {84,0.00011881}, {85,0.00003960}, {86,0.00015842}, {87,0.00007921}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00003960}, {92,0.00003960}, {93,0.00003960}, {94,0.00011881}, {95,0.00000000}, {96,0.00003960}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00003960}, {101,0.00011881}, {102,0.00019802}, {103,0.00003960}, {104,0.00003960}, {105,0.00007921}, {106,0.00000000}, {107,0.00003960}, {108,0.00003960}, {109,0.00003960}, {110,0.00000000}, {111,0.00003960}, {112,0.00015842}, {113,0.00003960}, {114,0.00011881}, {115,0.00003960}, {116,0.00003960}, {117,0.00000000}, {118,0.00011881}, {119,0.00000000}, {120,0.00003960}, {121,0.00000000}, {122,0.00000000}, {123,0.00003960}, {124,0.00011881}, {125,0.00000000}, {126,0.00007921}, {127,0.00000000}, {128,0.00000000}, {129,0.00007921}, {130,0.00000000}, {131,0.00003960}, {132,0.00003960}, {133,0.00007921}, {134,0.00007921}, {135,0.00003960}, {136,0.00006931}, {137,0.00003960}, {138,0.00015842}, {139,0.00003960}, {140,0.00000000}, {141,0.00000000}, {142,0.00003960}, {143,0.00003960}, {144,0.00003960}, {145,0.00000000}, {146,0.00000000}, {147,0.00003960}, {148,0.00003960}, {149,0.00003960}, {150,0.00000000}, {151,0.00011881}, {152,0.00007921}, {153,0.00000000}, {154,0.00003960}, {155,0.00007921}, {156,0.00003960}, {157,0.00007921}, {158,0.00011881}, {159,0.00015842}, {160,0.00015842}, {161,0.00011881}, {162,0.00003960}, {163,0.00003960}, {164,0.00003960}, {165,0.00000000}, {166,0.00000000}, {167,0.00011881}, {168,0.00011881}, {169,0.00000000}, {170,0.00007921}, {171,0.00007921}, {172,0.00002970}, {173,0.00000000}, {174,0.00007921}, {175,0.00000000}, {176,0.00003960}, {177,0.00003960}, {178,0.00015842}, {179,0.00000000}, {180,0.00000000}, {181,0.00011881}, {182,0.00007921}, {183,0.00000000}, {184,0.00007921}, {185,0.00007921}, {186,0.00000000}, {187,0.00000000}, {188,0.00003960}, {189,0.00003960}, {190,0.00007921}, {191,0.00000000}, {192,0.00000000}, {193,0.00003960}, {194,0.00010891}, {195,0.00007921}, {196,0.00000000}, {197,0.00003960}, {198,0.00000000}, {199,0.00011881}, {200,0.00007921}, {201,0.00003960}, {202,0.00007921}, {203,0.00007921}, {204,0.00011881}, {205,0.00007921}, {206,0.00006931}, {207,0.00003960}, {208,0.00007921}, {209,0.00011881}, {210,0.00011881}, {211,0.00000000}, {212,0.00007921}, {213,0.00007921}, {214,0.00000000}, {215,0.00007921}, {216,0.00003960}, {217,0.00000000}, {218,0.00007921}, {219,0.00003960}, {220,0.00000000}, {221,0.00000000}, {222,0.00007921}, {223,0.00007921}, {224,0.00006931}, {225,0.00011881}, {226,0.00007921}, {227,0.00003960}, {228,0.00000000}, {229,0.00007921}, {230,0.00000000}, {231,0.00007921}, {232,0.00007921}, {233,0.00003960}, {234,0.00019802}, {235,0.00003960}, {236,0.00019802}, {237,0.00007921}, {238,0.00054455}, {239,0.00011881}, {240,0.00015842}, {241,0.00000000}, {242,0.00011881}, {243,0.00003960}, {244,0.00031683}, {245,0.00000000}, {246,0.00015842}, {247,0.00007921}, {248,0.00003960}, {249,0.00007921}, {250,0.00019802}, {251,0.00007921}, {252,0.00000000}, {253,0.00015842}, {254,0.00000000}, {255,0.00007921}, {256,0.00007921}, {257,0.00007921}, {258,0.00003960}, {259,0.00010891}, {260,0.00007921}, {261,0.00003960}, {262,0.00015842}, {263,0.00011881}, {264,0.00000000}, {265,0.00019802}, {266,0.00003960}, {267,0.00023762}, {268,0.00015842}, {269,0.00015842}, {270,0.00000000}, {271,0.00023762}, {272,0.00003960}, {273,0.00023762}, {274,0.00007921}, {275,0.00011881}, {276,0.00003960}, {277,0.00011881}, {278,0.00050495}, {279,0.00011881}, {280,0.00000000}, {281,0.00002970}, {282,0.00003960}, {283,0.00000000}, {284,0.00003960}, {285,0.00011881}, {286,0.00015842}, {287,0.00006931}, {288,0.00018812}, {289,0.00003960}, {290,0.00007921}, {291,0.00003960}, {292,0.00011881}, {293,0.00007921}, {294,0.00019802}, {295,0.00019802}, {296,0.00003960}, {297,0.00011881}, {298,0.00000000}, {299,0.00015842}, {300,0.00007921}, {301,0.0004571}, {302,0.0002286}, {303,0.0002286}, {304,0.0000000}, {305,0.0002286}, {306,0.0002286}, {307,0.0001143}, {308,0.0000000}, {309,0.0001143}, {310,0.0000000}, {311,0.0001143}, {312,0.0002286}, {313,0.0001143}, {314,0.0000000}, {315,0.0001143}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0002000}, {320,0.0001143}, {321,0.0003143}, {322,0.0000000}, {323,0.0000000}, {324,0.0002286}, {325,0.0000000}, {326,0.0002286}, {327,0.0001143}, {328,0.0001143}, {329,0.0001143}, {330,0.0002000}, {331,0.0001143}, {332,0.0003429}, {333,0.0001143}, {334,0.0001143}, {335,0.0001143}, {336,0.0001143}, {337,0.0001143}, {338,0.0001143}, {339,0.0001143}, {340,0.0001143}, {341,0.0000000}, {342,0.0002286}, {343,0.0000000}, {344,0.0003429}, {345,0.0002286}, {346,0.0000000}, {347,0.0001143}, {348,0.0000000}, {349,0.0003429}, {350,0.0001143}, {351,0.0000000}, {352,0.0001143}, {353,0.0000000}, {354,0.0002000}, {355,0.0001143}, {356,0.0001143}, {357,0.0001143}, {358,0.0000000}, {359,0.0001143}, {360,0.0003429}, {361,0.0001143}, {362,0.0000000}, {363,0.0003143}, {364,0.0002286}, {365,0.0002286}, {366,0.0002286}, {367,0.0002286}, {368,0.0000000}, {369,0.0004571}, {370,0.0001143}, {371,0.0001143}, {372,0.0005143}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0001143}, {377,0.0002286}, {378,0.0003429}, {379,0.0003429}, {380,0.0001143}, {381,0.0008000}, {382,0.0002286}, {383,0.0005714}, {384,0.0003429}, {385,0.0004571}, {386,0.0001143}, {387,0.0002286}, {388,0.0003429}, {389,0.0001143}, {390,0.0003429}, {391,0.0006857}, {392,0.0006857}, {393,0.0005714}, {394,0.0002286}, {395,0.0004571}, {396,0.0003429}, {397,0.0000000}, {398,0.0004286}, {399,0.0002286}, {400,0.0002286}, {401,0.0001143}, {402,0.0003429}, {403,0.0001143}, {404,0.0000000}, {405,0.0000000}, {406,0.0001143}, {407,0.0003429}, {408,0.0001143}, {409,0.0003429}, {410,0.0007714}, {411,0.0004571}, {412,0.0003429}, {413,0.0001143}, {414,0.0004286}, {415,0.0000000}, {416,0.0003429}, {417,0.0002286}, {418,0.0001143}, {419,0.0002286}, {420,0.0002286}, {421,0.0004571}, {422,0.0002286}, {423,0.0001143}, {424,0.0002286}, {425,0.0002286}, {426,0.0002286}, {427,0.0004571}, {428,0.0004571}, {429,0.0002286}, {430,0.0003429}, {431,0.0004571}, {432,0.0001143}, {433,0.0003429}, {434,0.0001143}, {435,0.0001143}, {436,0.0003429}, {437,0.0006571}, {438,0.0004571}, {439,0.0003429}, {440,0.0003429}, {441,0.0004571}, {442,0.0003429}, {443,0.0001143}, {444,0.0002286}, {445,0.0004571}, {446,0.0006857}, {447,0.0002286}, {448,0.0006857}, {449,0.0001143}, {450,0.0004571}, {451,0.0006857}, {452,0.0003429}, {453,0.0006857}, {454,0.0008000}, {455,0.0005714}, {456,0.0004571}, {457,0.0003429}, {458,0.0000000}, {459,0.0001143}, {460,0.0005714}, {461,0.0005714}, {462,0.0002286}, {463,0.0004286}, {464,0.0005714}, {465,0.0010286}, {466,0.0004571}, {467,0.0004571}, {468,0.0002286}, {469,0.0002286}, {470,0.0000000}, {471,0.0002286}, {472,0.0002286}, {473,0.0008000}, {474,0.0003429}, {475,0.0001143}, {476,0.0005714}, {477,0.0008000}, {478,0.0003429}, {479,0.0008000}, {480,0.0003429}, {481,0.0002286}, {482,0.0005714}, {483,0.0006857}, {484,0.0003429}, {485,0.0004571}, {486,0.0005429}, {487,0.0001143}, {488,0.0008000}, {489,0.0003143}, {490,0.0006857}, {491,0.0005429}, {492,0.0003429}, {493,0.0004286}, {494,0.0005714}, {495,0.0005714}, {496,0.0004571}, {497,0.0004571}, {498,0.0004571}, {499,0.0005714}, {500,0.0003429}, {505,0.0000000}, {510,0.0008000}, {515,0.0000000}, {520,0.0003429}, {525,0.0002286}, {530,0.0013714}, {535,0.0008000}, {540,0.0007714}, {545,0.0010286}, {550,0.0014857}, {555,0.0003429}, {560,0.0018286}, {565,0.0009143}, {570,0.0002286}, {575,0.0018286}, {580,0.0010286}, {585,0.0003429}, {590,0.0005714}, {595,0.0009143}, {600,0.0013429}, {605,0.0013714}, {610,0.0010286}, {615,0.0011429}, {620,0.0014857}, {625,0.0013714}, {630,0.0008857}, {635,0.0017143}, {640,0.0012571}, {645,0.0020286}, {650,0.0023714}, {655,0.0012571}, {660,0.0013714}, {665,0.0006857}, {670,0.0006857}, {675,0.0011429}, {680,0.0019429}, {685,0.0012286}, {690,0.0016000}, {695,0.0028286}, {700,0.0030286}, {705,0.0022857}, {710,0.0022857}, {715,0.0032857}, {720,0.0056000}, {725,0.0032000}, {730,0.0026000}, {735,0.0050286}, {740,0.0037429}, {745,0.0042286}, {750,0.0067429}, {755,0.0085429}, {760,0.0056571}, {765,0.0073143}, {770,0.0058286}, {775,0.0057143}, {780,0.0061429}, {785,0.0084571}, {790,0.0080571}, {795,0.0077429}, {800,0.0058286}, {805,0.0069714}, {810,0.0080000}, {815,0.0087429}, {820,0.0081714}, {825,0.0077143}, {830,0.0079714}, {835,0.0075143}, {840,0.0137143}, {845,0.0093714}, {850,0.0088857}, {855,0.0104000}, {860,0.0132571}, {865,0.0088571}, {870,0.0106000}, {875,0.0104000}, {880,0.0147429}, {885,0.0056857}, {890,0.0130286}, {895,0.0097429}, {900,0.0073143}, {905,0.0100286}, {910,0.0106857}, {915,0.0096571}, {920,0.0093143}, {925,0.0086857}, {930,0.0112857}, {935,0.0166286}, {940,0.0099143}, {945,0.0120000}, {950,0.0096571}, {955,0.0102857}, {960,0.0094286}, {965,0.0136857}, {970,0.0152571}, {975,0.0106857}, {980,0.0136857}, {985,0.0093429}, {990,0.0131714}, {995,0.0114286}, {1000,0.0132286}, {1010,0.0066857}, {1020,0.0094571}, {1030,0.0066857}, {1040,0.0077429}, {1050,0.0069143}, {1060,0.0071714}, {1070,0.0046000}, {1080,0.0076000}, {1090,0.0075714}, {1100,0.0072286}, {1110,0.0102857}, {1120,0.0078000}, {1130,0.0095714}, {1140,0.0118571}, {1150,0.0085143}, {1160,0.0093143}, {1170,0.0088286}, {1180,0.0118000}, {1190,0.0109714}, {1200,0.0110000}, {1210,0.0117143}, {1220,0.0146000}, {1230,0.0133429}, {1240,0.0226571}, {1250,0.0120571}, {1260,0.0133429}, {1270,0.0113714}, {1280,0.0107714}, {1290,0.0137429}, {1300,0.0116857}, {1310,0.0171714}, {1320,0.0164857}, {1330,0.0128000}, {1340,0.0199429}, {1350,0.0176571}, {1360,0.0143143}, {1370,0.0146000}, {1380,0.0180857}, {1390,0.0186286}, {1400,0.0195143}, {1410,0.0232286}, {1420,0.0151143}, {1430,0.0205429}, {1440,0.0256571}, {1450,0.0258000}, {1460,0.0247143}, {1470,0.0248857}, {1480,0.0272286}, {1490,0.0256857}, {1500,0.0283143}, {1510,0.0292286}, {1520,0.0287714}, {1530,0.0226571}, {1540,0.0228571}, {1550,0.0252286}, {1560,0.0332571}, {1570,0.0299714}, {1580,0.0360286}, {1590,0.0365143}, {1600,0.0254286}, {1610,0.0274286}, {1620,0.0335429}, {1630,0.0265143}, {1640,0.0274571}, {1650,0.0321143}, {1660,0.0293429}, {1670,0.0315429}, {1680,0.0271429}, {1690,0.0310857}, {1700,0.0301143}, {1710,0.0314857}, {1720,0.0280000}, {1730,0.0385429}, {1740,0.0350000}, {1750,0.0369429}, {1760,0.0438857}, {1770,0.0351143}, {1780,0.0290857}, {1790,0.0321429}, {1800,0.0368000}, {1810,0.0319429}, {1820,0.0456857}, {1830,0.0435714}, {1840,0.0316571}, {1850,0.0401714}, {1860,0.0562286}, {1870,0.0454286}, {1880,0.0467429}, {1890,0.0483143}, {1900,0.0518857}, {1910,0.0442857}, {1920,0.0408000}, {1930,0.0450000}, {1940,0.0479714}, {1950,0.0342286}, {1960,0.0434000}, {1970,0.0310857}, {1980,0.0414000}, {1990,0.0517714}, {2000,0.0454571}};
data["big"]["LtacTacInTermExplicitCtx"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00242574}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0020000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0012857}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000286}, {525,0.0000000}, {530,0.0000000}, {535,0.0000286}, {540,0.0000286}, {545,0.0000000}, {550,0.0000286}, {555,0.0026286}, {560,0.0000286}, {565,0.0001143}, {570,0.0001714}, {575,0.0000857}, {580,0.0002000}, {585,0.0004000}, {590,0.0005143}, {595,0.0006000}, {600,0.0006286}, {605,0.0006857}, {610,0.0008571}, {615,0.0008857}, {620,0.0009429}, {625,0.0031714}, {630,0.0009429}, {635,0.0009714}, {640,0.0009143}, {645,0.0010000}, {650,0.0009714}, {655,0.0009143}, {660,0.0009714}, {665,0.0009714}, {670,0.0009714}, {675,0.0010000}, {680,0.0010000}, {685,0.0010000}, {690,0.0010000}, {695,0.0010000}, {700,0.0010000}, {705,0.0010000}, {710,0.0010000}, {715,0.0010000}, {720,0.0010000}, {725,0.0010000}, {730,0.0010000}, {735,0.0010000}, {740,0.0010000}, {745,0.0010000}, {750,0.0010000}, {755,0.0010000}, {760,0.0010000}, {765,0.0010000}, {770,0.0010000}, {775,0.0010000}, {780,0.0010000}, {785,0.0010000}, {790,0.0010000}, {795,0.0010000}, {800,0.0010000}, {805,0.0010000}, {810,0.0010000}, {815,0.0010000}, {820,0.0010000}, {825,0.0010000}, {830,0.0010000}, {835,0.0010000}, {840,0.0010000}, {845,0.0010000}, {850,0.0010000}, {855,0.0010000}, {860,0.0010000}, {865,0.0010000}, {870,0.0010000}, {875,0.0010000}, {880,0.0010000}, {885,0.0010000}, {890,0.0010000}, {895,0.0010000}, {900,0.0045429}, {905,0.0010000}, {910,0.0010000}, {915,0.0010000}, {920,0.0010000}, {925,0.0010000}, {930,0.0010000}, {935,0.0010000}, {940,0.0010000}, {945,0.0010000}, {950,0.0010000}, {955,0.0010000}, {960,0.0010000}, {965,0.0010000}, {970,0.0010000}, {975,0.0010000}, {980,0.0010000}, {985,0.0010000}, {990,0.0032000}, {995,0.0010000}, {1000,0.0010000}, {1010,0.0010000}, {1020,0.0010000}, {1030,0.0010000}, {1040,0.0010000}, {1050,0.0010000}, {1060,0.0010000}, {1070,0.0010000}, {1080,0.0010000}, {1090,0.0010000}, {1100,0.0010000}, {1110,0.0010571}, {1120,0.0010000}, {1130,0.0011143}, {1140,0.0011143}, {1150,0.0012286}, {1160,0.0012857}, {1170,0.0012286}, {1180,0.0013714}, {1190,0.0015143}, {1200,0.0015714}, {1210,0.0017714}, {1220,0.0018571}, {1230,0.0017714}, {1240,0.0019429}, {1250,0.0019429}, {1260,0.0019143}, {1270,0.0019714}, {1280,0.0020000}, {1290,0.0019714}, {1300,0.0020000}, {1310,0.0020000}, {1320,0.0020000}, {1330,0.0020000}, {1340,0.0020000}, {1350,0.0020000}, {1360,0.0020000}, {1370,0.0020000}, {1380,0.0020000}, {1390,0.0020000}, {1400,0.0020000}, {1410,0.0020000}, {1420,0.0020000}, {1430,0.0020000}, {1440,0.0020000}, {1450,0.0020000}, {1460,0.0020000}, {1470,0.0020000}, {1480,0.0020000}, {1490,0.0020000}, {1500,0.0020000}, {1510,0.0020000}, {1520,0.0020000}, {1530,0.0020000}, {1540,0.0020000}, {1550,0.0020000}, {1560,0.0020000}, {1570,0.0020000}, {1580,0.0020000}, {1590,0.0020000}, {1600,0.0020286}, {1610,0.0020000}, {1620,0.0020000}, {1630,0.0020000}, {1640,0.0020000}, {1650,0.0020286}, {1660,0.0020000}, {1670,0.0020000}, {1680,0.0020286}, {1690,0.0020857}, {1700,0.0020857}, {1710,0.0020571}, {1720,0.0021143}, {1730,0.0022286}, {1740,0.0023429}, {1750,0.0023143}, {1760,0.0024571}, {1770,0.0023714}, {1780,0.0024857}, {1790,0.0043143}, {1800,0.0026857}, {1810,0.0027429}, {1820,0.0027714}, {1830,0.0028286}, {1840,0.0028000}, {1850,0.0028286}, {1860,0.0080571}, {1870,0.0029429}, {1880,0.0029714}, {1890,0.0029714}, {1900,0.0030000}, {1910,0.0030000}, {1920,0.0030000}, {1930,0.0030000}, {1940,0.0030000}, {1950,0.0113143}, {1960,0.0030000}, {1970,0.0030000}, {1980,0.0030000}, {1990,0.0030000}, {2000,0.0030000}};
data["big"]["LtacTacInTermExplicitCtx"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00002970}, {4,0.00000000}, {5,0.00007921}, {6,0.00011881}, {7,0.00000000}, {8,0.00006931}, {9,0.00006931}, {10,0.00009901}, {11,0.00003960}, {12,0.00000000}, {13,0.00007921}, {14,0.00000000}, {15,0.00010891}, {16,0.00003960}, {17,0.00000000}, {18,0.00000000}, {19,0.00003960}, {20,0.00000000}, {21,0.00002970}, {22,0.00011881}, {23,0.00007921}, {24,0.00003960}, {25,0.00003960}, {26,0.00006931}, {27,0.00011881}, {28,0.00002970}, {29,0.00007921}, {30,0.00007921}, {31,0.00000000}, {32,0.00010891}, {33,0.00000000}, {34,0.00000000}, {35,0.00007921}, {36,0.00007921}, {37,0.00022772}, {38,0.00006931}, {39,0.00003960}, {40,0.00000000}, {41,0.00024752}, {42,0.00006931}, {43,0.00010891}, {44,0.00003960}, {45,0.00002970}, {46,0.00002970}, {47,0.00007921}, {48,0.00007921}, {49,0.00014851}, {50,0.00011881}, {51,0.00010891}, {52,0.00006931}, {53,0.00011881}, {54,0.00025743}, {55,0.00007921}, {56,0.00013861}, {57,0.00021782}, {58,0.00019802}, {59,0.00007921}, {60,0.00006931}, {61,0.00022772}, {62,0.00011881}, {63,0.00002970}, {64,0.00011881}, {65,0.00023762}, {66,0.00007921}, {67,0.00025743}, {68,0.00007921}, {69,0.00007921}, {70,0.00009901}, {71,0.00013861}, {72,0.00019802}, {73,0.00011881}, {74,0.00015842}, {75,0.00011881}, {76,0.00005941}, {77,0.00018812}, {78,0.00011881}, {79,0.00020792}, {80,0.00019802}, {81,0.00003960}, {82,0.00010891}, {83,0.00018812}, {84,0.00019802}, {85,0.00018812}, {86,0.00007921}, {87,0.00020792}, {88,0.00037624}, {89,0.00027723}, {90,0.00003960}, {91,0.00018812}, {92,0.00006931}, {93,0.00010891}, {94,0.00011881}, {95,0.00015842}, {96,0.00027723}, {97,0.00018812}, {98,0.00023762}, {99,0.00014851}, {100,0.00031683}, {101,0.00003960}, {102,0.00014851}, {103,0.00006931}, {104,0.00018812}, {105,0.00011881}, {106,0.00000000}, {107,0.00014851}, {108,0.00026733}, {109,0.00017822}, {110,0.00034653}, {111,0.00018812}, {112,0.00013861}, {113,0.00007921}, {114,0.00007921}, {115,0.00025743}, {116,0.00015842}, {117,0.00023762}, {118,0.00017822}, {119,0.00015842}, {120,0.00030693}, {121,0.00035644}, {122,0.00003960}, {123,0.00030693}, {124,0.00015842}, {125,0.00014851}, {126,0.00020792}, {127,0.00025743}, {128,0.00019802}, {129,0.00045545}, {130,0.00019802}, {131,0.00032673}, {132,0.00022772}, {133,0.00021782}, {134,0.00011881}, {135,0.00011881}, {136,0.00010891}, {137,0.00025743}, {138,0.00010891}, {139,0.00019802}, {140,0.00034653}, {141,0.00019802}, {142,0.00035644}, {143,0.00038614}, {144,0.00023762}, {145,0.00014851}, {146,0.00019802}, {147,0.00029703}, {148,0.00036634}, {149,0.00022772}, {150,0.00027723}, {151,0.00032673}, {152,0.00030693}, {153,0.00025743}, {154,0.00030693}, {155,0.00019802}, {156,0.00029703}, {157,0.00031683}, {158,0.00028713}, {159,0.00028713}, {160,0.00036634}, {161,0.00023762}, {162,0.00019802}, {163,0.00043564}, {164,0.00017822}, {165,0.00015842}, {166,0.00043564}, {167,0.00015842}, {168,0.00044554}, {169,0.00014851}, {170,0.00015842}, {171,0.00042574}, {172,0.00034653}, {173,0.00013861}, {174,0.00029703}, {175,0.00033663}, {176,0.00017822}, {177,0.00042574}, {178,0.00043564}, {179,0.00027723}, {180,0.00027723}, {181,0.00038614}, {182,0.00015842}, {183,0.00044554}, {184,0.00022772}, {185,0.00019802}, {186,0.00038614}, {187,0.00029703}, {188,0.00028713}, {189,0.00042574}, {190,0.00034653}, {191,0.00026733}, {192,0.00029703}, {193,0.00037624}, {194,0.00018812}, {195,0.00003960}, {196,0.00014851}, {197,0.00032673}, {198,0.00031683}, {199,0.00023762}, {200,0.00037624}, {201,0.00028713}, {202,0.00044554}, {203,0.00049505}, {204,0.00022772}, {205,0.00033663}, {206,0.00023762}, {207,0.00026733}, {208,0.00037624}, {209,0.00037624}, {210,0.00049505}, {211,0.00044554}, {212,0.00028713}, {213,0.00050495}, {214,0.00039604}, {215,0.00027723}, {216,0.00015842}, {217,0.00033663}, {218,0.00034653}, {219,0.00030693}, {220,0.00031683}, {221,0.00034653}, {222,0.00050495}, {223,0.00066337}, {224,0.00041584}, {225,0.00046535}, {226,0.00025743}, {227,0.00062376}, {228,0.00025743}, {229,0.00035644}, {230,0.00042574}, {231,0.00043564}, {232,0.00031683}, {233,0.00050495}, {234,0.00022772}, {235,0.00032673}, {236,0.00024752}, {237,0.00034653}, {238,0.00031683}, {239,0.00021782}, {240,0.00058416}, {241,0.00047525}, {242,0.00045545}, {243,0.00049505}, {244,0.00054455}, {245,0.00020792}, {246,0.00037624}, {247,0.00027723}, {248,0.00050495}, {249,0.00042574}, {250,0.00026733}, {251,0.00035644}, {252,0.00059406}, {253,0.00042574}, {254,0.00029703}, {255,0.00035644}, {256,0.00051485}, {257,0.00039604}, {258,0.00311881}, {259,0.00020792}, {260,0.00030693}, {261,0.00030693}, {262,0.00034653}, {263,0.00039604}, {264,0.00040594}, {265,0.00021782}, {266,0.00037624}, {267,0.00032673}, {268,0.00041584}, {269,0.00023762}, {270,0.00032673}, {271,0.00031683}, {272,0.00036634}, {273,0.00026733}, {274,0.00034653}, {275,0.00028713}, {276,0.00036634}, {277,0.00035644}, {278,0.00032673}, {279,0.00066337}, {280,0.00048515}, {281,0.00031683}, {282,0.00030693}, {283,0.00033663}, {284,0.00038614}, {285,0.00041584}, {286,0.00032673}, {287,0.00077228}, {288,0.00009901}, {289,0.00031683}, {290,0.00047525}, {291,0.00064356}, {292,0.00034653}, {293,0.00023762}, {294,0.00060396}, {295,0.00057426}, {296,0.00039604}, {297,0.00033663}, {298,0.00058416}, {299,0.00040594}, {300,0.00047525}, {301,0.0006000}, {302,0.0007143}, {303,0.0002571}, {304,0.0004857}, {305,0.0004286}, {306,0.0003429}, {307,0.0007714}, {308,0.0004286}, {309,0.0004571}, {310,0.0004571}, {311,0.0006000}, {312,0.0002286}, {313,0.0003714}, {314,0.0004000}, {315,0.0006000}, {316,0.0005714}, {317,0.0003429}, {318,0.0001143}, {319,0.0005429}, {320,0.0002000}, {321,0.0005714}, {322,0.0004286}, {323,0.0004286}, {324,0.0003143}, {325,0.0008286}, {326,0.0002857}, {327,0.0009429}, {328,0.0005143}, {329,0.0004571}, {330,0.0002000}, {331,0.0002571}, {332,0.0000000}, {333,0.0001714}, {334,0.0005429}, {335,0.0000857}, {336,0.0005714}, {337,0.0004000}, {338,0.0002857}, {339,0.0004000}, {340,0.0004286}, {341,0.0008000}, {342,0.0004000}, {343,0.0001714}, {344,0.0005429}, {345,0.0001714}, {346,0.0002571}, {347,0.0003143}, {348,0.0003429}, {349,0.0002571}, {350,0.0005143}, {351,0.0001714}, {352,0.0005143}, {353,0.0002571}, {354,0.0004000}, {355,0.0003429}, {356,0.0004857}, {357,0.0004286}, {358,0.0006571}, {359,0.0003429}, {360,0.0004000}, {361,0.0005143}, {362,0.0006571}, {363,0.0002571}, {364,0.0004571}, {365,0.0005429}, {366,0.0006571}, {367,0.0008286}, {368,0.0003714}, {369,0.0002857}, {370,0.0008286}, {371,0.0007714}, {372,0.0006000}, {373,0.0005143}, {374,0.0008857}, {375,0.0002857}, {376,0.0004286}, {377,0.0006857}, {378,0.0005429}, {379,0.0006857}, {380,0.0007429}, {381,0.0023714}, {382,0.0006286}, {383,0.0002857}, {384,0.0010857}, {385,0.0006000}, {386,0.0010000}, {387,0.0005143}, {388,0.0004286}, {389,0.0009429}, {390,0.0007714}, {391,0.0006286}, {392,0.0002857}, {393,0.0005143}, {394,0.0000857}, {395,0.0004571}, {396,0.0004000}, {397,0.0004286}, {398,0.0001714}, {399,0.0006571}, {400,0.0006571}, {401,0.0005429}, {402,0.0007714}, {403,0.0006571}, {404,0.0008857}, {405,0.0006286}, {406,0.0003714}, {407,0.0002000}, {408,0.0003714}, {409,0.0006857}, {410,0.0004286}, {411,0.0008857}, {412,0.0005429}, {413,0.0003429}, {414,0.0007143}, {415,0.0004286}, {416,0.0005143}, {417,0.0006286}, {418,0.0006286}, {419,0.0007714}, {420,0.0002571}, {421,0.0009429}, {422,0.0004857}, {423,0.0004571}, {424,0.0003714}, {425,0.0002857}, {426,0.0004571}, {427,0.0008286}, {428,0.0003429}, {429,0.0007714}, {430,0.0008286}, {431,0.0004286}, {432,0.0004571}, {433,0.0007429}, {434,0.0007429}, {435,0.0008000}, {436,0.0006000}, {437,0.0008571}, {438,0.0006286}, {439,0.0003714}, {440,0.0008286}, {441,0.0005429}, {442,0.0008286}, {443,0.0003429}, {444,0.0005429}, {445,0.0004286}, {446,0.0008857}, {447,0.0004857}, {448,0.0005714}, {449,0.0008571}, {450,0.0007429}, {451,0.0005429}, {452,0.0004571}, {453,0.0004571}, {454,0.0004571}, {455,0.0005429}, {456,0.0008286}, {457,0.0006857}, {458,0.0004571}, {459,0.0006286}, {460,0.0004857}, {461,0.0005429}, {462,0.0006286}, {463,0.0006571}, {464,0.0006571}, {465,0.0005714}, {466,0.0008286}, {467,0.0006571}, {468,0.0004571}, {469,0.0004571}, {470,0.0005143}, {471,0.0007714}, {472,0.0009714}, {473,0.0006857}, {474,0.0008571}, {475,0.0006571}, {476,0.0018571}, {477,0.0004571}, {478,0.0004286}, {479,0.0005143}, {480,0.0006286}, {481,0.0006286}, {482,0.0006000}, {483,0.0005143}, {484,0.0010286}, {485,0.0008857}, {486,0.0008857}, {487,0.0006000}, {488,0.0008857}, {489,0.0003714}, {490,0.0004286}, {491,0.0006000}, {492,0.0008000}, {493,0.0007714}, {494,0.0007429}, {495,0.0004286}, {496,0.0006857}, {497,0.0006286}, {498,0.0005714}, {499,0.0008000}, {500,0.0006857}, {505,0.0007429}, {510,0.0006286}, {515,0.0008286}, {520,0.0008571}, {525,0.0010286}, {530,0.0005429}, {535,0.0006571}, {540,0.0004286}, {545,0.0004571}, {550,0.0008000}, {555,0.0027143}, {560,0.0008000}, {565,0.0010000}, {570,0.0006857}, {575,0.0010000}, {580,0.0010571}, {585,0.0008857}, {590,0.0003429}, {595,0.0010000}, {600,0.0006857}, {605,0.0005143}, {610,0.0008857}, {615,0.0008571}, {620,0.0007714}, {625,0.0026857}, {630,0.0010857}, {635,0.0007714}, {640,0.0009143}, {645,0.0007714}, {650,0.0010571}, {655,0.0005143}, {660,0.0006857}, {665,0.0010571}, {670,0.0011429}, {675,0.0010286}, {680,0.0005143}, {685,0.0007143}, {690,0.0006857}, {695,0.0011429}, {700,0.0008000}, {705,0.0009429}, {710,0.0008286}, {715,0.0008286}, {720,0.0006286}, {725,0.0010571}, {730,0.0008857}, {735,0.0006857}, {740,0.0008000}, {745,0.0011714}, {750,0.0010286}, {755,0.0009429}, {760,0.0007714}, {765,0.0011143}, {770,0.0008286}, {775,0.0008571}, {780,0.0009429}, {785,0.0006286}, {790,0.0011143}, {795,0.0010571}, {800,0.0010286}, {805,0.0014571}, {810,0.0014571}, {815,0.0010571}, {820,0.0011429}, {825,0.0011429}, {830,0.0009714}, {835,0.0008857}, {840,0.0010286}, {845,0.0009429}, {850,0.0012000}, {855,0.0011714}, {860,0.0011714}, {865,0.0011429}, {870,0.0015143}, {875,0.0009714}, {880,0.0011143}, {885,0.0010857}, {890,0.0008857}, {895,0.0007714}, {900,0.0042286}, {905,0.0008000}, {910,0.0009143}, {915,0.0013429}, {920,0.0014000}, {925,0.0014000}, {930,0.0015429}, {935,0.0010000}, {940,0.0009714}, {945,0.0011143}, {950,0.0009714}, {955,0.0011714}, {960,0.0013143}, {965,0.0013714}, {970,0.0014857}, {975,0.0014000}, {980,0.0013143}, {985,0.0013714}, {990,0.0030000}, {995,0.0016286}, {1000,0.0014000}, {1010,0.0010857}, {1020,0.0014571}, {1030,0.0013429}, {1040,0.0018286}, {1050,0.0014286}, {1060,0.0014571}, {1070,0.0014000}, {1080,0.0014571}, {1090,0.0019714}, {1100,0.0012286}, {1110,0.0015429}, {1120,0.0020571}, {1130,0.0018571}, {1140,0.0018000}, {1150,0.0022857}, {1160,0.0013429}, {1170,0.0015429}, {1180,0.0016857}, {1190,0.0014571}, {1200,0.0022000}, {1210,0.0021714}, {1220,0.0022000}, {1230,0.0015714}, {1240,0.0014857}, {1250,0.0020857}, {1260,0.0017714}, {1270,0.0018286}, {1280,0.0018857}, {1290,0.0018286}, {1300,0.0019143}, {1310,0.0018571}, {1320,0.0016857}, {1330,0.0020000}, {1340,0.0014857}, {1350,0.0019429}, {1360,0.0012000}, {1370,0.0018000}, {1380,0.0020000}, {1390,0.0021714}, {1400,0.0024000}, {1410,0.0027143}, {1420,0.0018286}, {1430,0.0021714}, {1440,0.0018571}, {1450,0.0016857}, {1460,0.0017429}, {1470,0.0022857}, {1480,0.0024000}, {1490,0.0021143}, {1500,0.0023429}, {1510,0.0017714}, {1520,0.0022286}, {1530,0.0021429}, {1540,0.0020857}, {1550,0.0027714}, {1560,0.0026000}, {1570,0.0026286}, {1580,0.0030000}, {1590,0.0024571}, {1600,0.0025429}, {1610,0.0026000}, {1620,0.0029143}, {1630,0.0024571}, {1640,0.0028000}, {1650,0.0025429}, {1660,0.0027429}, {1670,0.0027429}, {1680,0.0026000}, {1690,0.0030857}, {1700,0.0025429}, {1710,0.0032286}, {1720,0.0027143}, {1730,0.0029143}, {1740,0.0022000}, {1750,0.0031143}, {1760,0.0028286}, {1770,0.0023714}, {1780,0.0025714}, {1790,0.0048286}, {1800,0.0028857}, {1810,0.0027143}, {1820,0.0032857}, {1830,0.0021429}, {1840,0.0026286}, {1850,0.0032000}, {1860,0.0083429}, {1870,0.0032286}, {1880,0.0036857}, {1890,0.0033143}, {1900,0.0029714}, {1910,0.0030286}, {1920,0.0034571}, {1930,0.0030857}, {1940,0.0031429}, {1950,0.0110857}, {1960,0.0027143}, {1970,0.0029714}, {1980,0.0032286}, {1990,0.0030286}, {2000,0.0032571}};
data["big"]["LtacTacInTermExplicitCtx"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00003960}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00003960}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00003960}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00002970}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00003960}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00003960}, {157,0.00000000}, {158,0.00000000}, {159,0.00003960}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00003960}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00003960}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00003960}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00003960}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00003960}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00003960}, {265,0.00000000}, {266,0.00000000}, {267,0.00002970}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00003960}, {274,0.00003960}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0001143}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0001143}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0001143}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0001143}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0001143}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0001143}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0001143}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0001143}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0001143}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0001143}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0001143}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0001143}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000857}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermExplicitCtx"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00310891}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0021714}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000286}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000286}, {835,0.0000000}, {840,0.0000286}, {845,0.0000286}, {850,0.0000286}, {855,0.0000571}, {860,0.0000286}, {865,0.0001429}, {870,0.0001714}, {875,0.0001429}, {880,0.0003143}, {885,0.0003429}, {890,0.0004000}, {895,0.0005429}, {900,0.0005429}, {905,0.0006286}, {910,0.0005429}, {915,0.0008000}, {920,0.0020571}, {925,0.0008571}, {930,0.0009143}, {935,0.0010000}, {940,0.0009143}, {945,0.0010000}, {950,0.0009714}, {955,0.0010000}, {960,0.0010000}, {965,0.0010000}, {970,0.0010000}, {975,0.0010000}, {980,0.0010000}, {985,0.0010000}, {990,0.0010000}, {995,0.0010000}, {1000,0.0010000}, {1010,0.0010000}, {1020,0.0010000}, {1030,0.0010000}, {1040,0.0010000}, {1050,0.0010000}, {1060,0.0010000}, {1070,0.0010000}, {1080,0.0010000}, {1090,0.0010000}, {1100,0.0010000}, {1110,0.0010000}, {1120,0.0010000}, {1130,0.0010000}, {1140,0.0010000}, {1150,0.0010000}, {1160,0.0010000}, {1170,0.0010000}, {1180,0.0010000}, {1190,0.0010000}, {1200,0.0010000}, {1210,0.0010000}, {1220,0.0010000}, {1230,0.0010000}, {1240,0.0010000}, {1250,0.0010000}, {1260,0.0010000}, {1270,0.0010000}, {1280,0.0010000}, {1290,0.0010000}, {1300,0.0010000}, {1310,0.0010000}, {1320,0.0010000}, {1330,0.0010000}, {1340,0.0010000}, {1350,0.0010000}, {1360,0.0010000}, {1370,0.0010000}, {1380,0.0010000}, {1390,0.0010000}, {1400,0.0010000}, {1410,0.0010000}, {1420,0.0010000}, {1430,0.0010000}, {1440,0.0010000}, {1450,0.0010000}, {1460,0.0010000}, {1470,0.0010000}, {1480,0.0010000}, {1490,0.0010000}, {1500,0.0010000}, {1510,0.0010000}, {1520,0.0010000}, {1530,0.0010000}, {1540,0.0010000}, {1550,0.0064857}, {1560,0.0010000}, {1570,0.0010571}, {1580,0.0010000}, {1590,0.0010000}, {1600,0.0010000}, {1610,0.0010000}, {1620,0.0010000}, {1630,0.0010000}, {1640,0.0010000}, {1650,0.0010286}, {1660,0.0010000}, {1670,0.0010286}, {1680,0.0010000}, {1690,0.0010286}, {1700,0.0010571}, {1710,0.0010571}, {1720,0.0010857}, {1730,0.0010857}, {1740,0.0011429}, {1750,0.0012857}, {1760,0.0012286}, {1770,0.0012571}, {1780,0.0013143}, {1790,0.0013429}, {1800,0.0014286}, {1810,0.0015714}, {1820,0.0017143}, {1830,0.0017143}, {1840,0.0017429}, {1850,0.0018571}, {1860,0.0018571}, {1870,0.0019429}, {1880,0.0019429}, {1890,0.0020000}, {1900,0.0020000}, {1910,0.0019714}, {1920,0.0020000}, {1930,0.0020000}, {1940,0.0020000}, {1950,0.0020000}, {1960,0.0020000}, {1970,0.0020000}, {1980,0.0020000}, {1990,0.0020000}, {2000,0.0020000}};
data["big"]["LtacTacInTermExplicitCtx"]["eval lazy"]["user"] = {{1,0.00003960}, {2,0.00006931}, {3,0.00000000}, {4,0.00000000}, {5,0.00003960}, {6,0.00007921}, {7,0.00003960}, {8,0.00003960}, {9,0.00003960}, {10,0.00002970}, {11,0.00002970}, {12,0.00002970}, {13,0.00003960}, {14,0.00000000}, {15,0.00006931}, {16,0.00003960}, {17,0.00003960}, {18,0.00003960}, {19,0.00015842}, {20,0.00000000}, {21,0.00003960}, {22,0.00015842}, {23,0.00003960}, {24,0.00003960}, {25,0.00006931}, {26,0.00011881}, {27,0.00006931}, {28,0.00014851}, {29,0.00014851}, {30,0.00002970}, {31,0.00010891}, {32,0.00003960}, {33,0.00002970}, {34,0.00007921}, {35,0.00000000}, {36,0.00007921}, {37,0.00006931}, {38,0.00015842}, {39,0.00021782}, {40,0.00013861}, {41,0.00003960}, {42,0.00019802}, {43,0.00000000}, {44,0.00003960}, {45,0.00007921}, {46,0.00003960}, {47,0.00006931}, {48,0.00007921}, {49,0.00010891}, {50,0.00007921}, {51,0.00011881}, {52,0.00003960}, {53,0.00003960}, {54,0.00014851}, {55,0.00000000}, {56,0.00010891}, {57,0.00003960}, {58,0.00003960}, {59,0.00006931}, {60,0.00014851}, {61,0.00003960}, {62,0.00003960}, {63,0.00014851}, {64,0.00003960}, {65,0.00011881}, {66,0.00007921}, {67,0.00007921}, {68,0.00006931}, {69,0.00007921}, {70,0.00000000}, {71,0.00003960}, {72,0.00000000}, {73,0.00007921}, {74,0.00007921}, {75,0.00010891}, {76,0.00011881}, {77,0.00021782}, {78,0.00007921}, {79,0.00029703}, {80,0.00015842}, {81,0.00011881}, {82,0.00019802}, {83,0.00007921}, {84,0.00014851}, {85,0.00015842}, {86,0.00013861}, {87,0.00019802}, {88,0.00009901}, {89,0.00007921}, {90,0.00000000}, {91,0.00010891}, {92,0.00014851}, {93,0.00011881}, {94,0.00022772}, {95,0.00015842}, {96,0.00015842}, {97,0.00022772}, {98,0.00011881}, {99,0.00022772}, {100,0.00013861}, {101,0.00015842}, {102,0.00019802}, {103,0.00031683}, {104,0.00015842}, {105,0.00010891}, {106,0.00024752}, {107,0.00023762}, {108,0.00014851}, {109,0.00018812}, {110,0.00026733}, {111,0.00011881}, {112,0.00011881}, {113,0.00027723}, {114,0.00003960}, {115,0.00013861}, {116,0.00021782}, {117,0.00021782}, {118,0.00019802}, {119,0.00019802}, {120,0.00021782}, {121,0.00035644}, {122,0.00026733}, {123,0.00010891}, {124,0.00017822}, {125,0.00013861}, {126,0.00011881}, {127,0.00027723}, {128,0.00023762}, {129,0.00032673}, {130,0.00015842}, {131,0.00011881}, {132,0.00014851}, {133,0.00009901}, {134,0.00007921}, {135,0.00022772}, {136,0.00018812}, {137,0.00011881}, {138,0.00007921}, {139,0.00022772}, {140,0.00014851}, {141,0.00024752}, {142,0.00018812}, {143,0.00015842}, {144,0.00000000}, {145,0.00006931}, {146,0.00026733}, {147,0.00018812}, {148,0.00027723}, {149,0.00010891}, {150,0.00017822}, {151,0.00022772}, {152,0.00014851}, {153,0.00007921}, {154,0.00010891}, {155,0.00007921}, {156,0.00015842}, {157,0.00003960}, {158,0.00034653}, {159,0.00011881}, {160,0.00031683}, {161,0.00018812}, {162,0.00011881}, {163,0.00033663}, {164,0.00026733}, {165,0.00014851}, {166,0.00019802}, {167,0.00018812}, {168,0.00029703}, {169,0.00023762}, {170,0.00018812}, {171,0.00014851}, {172,0.00010891}, {173,0.00021782}, {174,0.00022772}, {175,0.00003960}, {176,0.00027723}, {177,0.00019802}, {178,0.00019802}, {179,0.00026733}, {180,0.00011881}, {181,0.00031683}, {182,0.00011881}, {183,0.00014851}, {184,0.00035644}, {185,0.00025743}, {186,0.00022772}, {187,0.00026733}, {188,0.00026733}, {189,0.00030693}, {190,0.00029703}, {191,0.00026733}, {192,0.00019802}, {193,0.00013861}, {194,0.00019802}, {195,0.00031683}, {196,0.00022772}, {197,0.00006931}, {198,0.00017822}, {199,0.00031683}, {200,0.00014851}, {201,0.00019802}, {202,0.00031683}, {203,0.00011881}, {204,0.00007921}, {205,0.00019802}, {206,0.00022772}, {207,0.00034653}, {208,0.00017822}, {209,0.00031683}, {210,0.00029703}, {211,0.00042574}, {212,0.00007921}, {213,0.00011881}, {214,0.00022772}, {215,0.00025743}, {216,0.00017822}, {217,0.00025743}, {218,0.00037624}, {219,0.00030693}, {220,0.00047525}, {221,0.00023762}, {222,0.00029703}, {223,0.00015842}, {224,0.00034653}, {225,0.00052475}, {226,0.00020792}, {227,0.00014851}, {228,0.00023762}, {229,0.00037624}, {230,0.00003960}, {231,0.00022772}, {232,0.00034653}, {233,0.00026733}, {234,0.00036634}, {235,0.00034653}, {236,0.00038614}, {237,0.00030693}, {238,0.00036634}, {239,0.00018812}, {240,0.00044554}, {241,0.00029703}, {242,0.00020792}, {243,0.00026733}, {244,0.00029703}, {245,0.00022772}, {246,0.00031683}, {247,0.00043564}, {248,0.00039604}, {249,0.00015842}, {250,0.00013861}, {251,0.00017822}, {252,0.00016832}, {253,0.00033663}, {254,0.00061386}, {255,0.00028713}, {256,0.00028713}, {257,0.00027723}, {258,0.00029703}, {259,0.00032673}, {260,0.00040594}, {261,0.00029703}, {262,0.00023762}, {263,0.00038614}, {264,0.00032673}, {265,0.00044554}, {266,0.00028713}, {267,0.00036634}, {268,0.00019802}, {269,0.00033663}, {270,0.00021782}, {271,0.00035644}, {272,0.00036634}, {273,0.00035644}, {274,0.00024752}, {275,0.00008911}, {276,0.00024752}, {277,0.00030693}, {278,0.00026733}, {279,0.00045545}, {280,0.00034653}, {281,0.00008911}, {282,0.00026733}, {283,0.00022772}, {284,0.00024752}, {285,0.00015842}, {286,0.00038614}, {287,0.00016832}, {288,0.00045545}, {289,0.00018812}, {290,0.00035644}, {291,0.00038614}, {292,0.00025743}, {293,0.00044554}, {294,0.00032673}, {295,0.00012871}, {296,0.00031683}, {297,0.00035644}, {298,0.00038614}, {299,0.00304950}, {300,0.00019802}, {301,0.0002571}, {302,0.0002857}, {303,0.0004286}, {304,0.0002857}, {305,0.0003143}, {306,0.0002571}, {307,0.0002857}, {308,0.0001714}, {309,0.0002000}, {310,0.0004571}, {311,0.0003714}, {312,0.0001714}, {313,0.0007143}, {314,0.0006571}, {315,0.0005429}, {316,0.0000857}, {317,0.0003714}, {318,0.0003714}, {319,0.0004286}, {320,0.0001714}, {321,0.0002857}, {322,0.0002000}, {323,0.0002857}, {324,0.0002000}, {325,0.0004571}, {326,0.0003714}, {327,0.0005429}, {328,0.0003714}, {329,0.0003714}, {330,0.0001714}, {331,0.0000857}, {332,0.0002571}, {333,0.0002857}, {334,0.0003429}, {335,0.0001714}, {336,0.0001714}, {337,0.0000857}, {338,0.0006286}, {339,0.0000000}, {340,0.0006571}, {341,0.0000857}, {342,0.0004571}, {343,0.0006000}, {344,0.0001714}, {345,0.0003714}, {346,0.0002000}, {347,0.0001714}, {348,0.0004571}, {349,0.0002000}, {350,0.0004571}, {351,0.0002857}, {352,0.0002857}, {353,0.0006286}, {354,0.0008286}, {355,0.0002286}, {356,0.0002571}, {357,0.0000000}, {358,0.0002571}, {359,0.0002000}, {360,0.0002857}, {361,0.0004000}, {362,0.0001714}, {363,0.0003714}, {364,0.0004571}, {365,0.0002571}, {366,0.0004286}, {367,0.0004571}, {368,0.0002000}, {369,0.0003143}, {370,0.0005429}, {371,0.0003714}, {372,0.0000857}, {373,0.0006571}, {374,0.0008000}, {375,0.0002000}, {376,0.0004000}, {377,0.0004857}, {378,0.0005143}, {379,0.0004571}, {380,0.0002857}, {381,0.0004857}, {382,0.0004286}, {383,0.0002571}, {384,0.0004000}, {385,0.0003714}, {386,0.0004286}, {387,0.0004571}, {388,0.0006000}, {389,0.0005143}, {390,0.0002571}, {391,0.0003429}, {392,0.0002857}, {393,0.0004000}, {394,0.0003714}, {395,0.0001714}, {396,0.0003714}, {397,0.0002571}, {398,0.0000000}, {399,0.0003714}, {400,0.0002857}, {401,0.0003714}, {402,0.0004571}, {403,0.0000857}, {404,0.0005429}, {405,0.0004286}, {406,0.0002857}, {407,0.0004286}, {408,0.0004571}, {409,0.0000857}, {410,0.0004571}, {411,0.0003714}, {412,0.0006000}, {413,0.0005143}, {414,0.0005429}, {415,0.0004286}, {416,0.0001714}, {417,0.0004571}, {418,0.0006571}, {419,0.0003714}, {420,0.0005429}, {421,0.0004571}, {422,0.0003429}, {423,0.0002857}, {424,0.0006000}, {425,0.0008286}, {426,0.0001714}, {427,0.0002571}, {428,0.0001143}, {429,0.0005714}, {430,0.0004286}, {431,0.0002857}, {432,0.0004000}, {433,0.0004571}, {434,0.0002571}, {435,0.0002571}, {436,0.0001714}, {437,0.0005714}, {438,0.0005143}, {439,0.0021714}, {440,0.0002571}, {441,0.0005143}, {442,0.0005429}, {443,0.0002571}, {444,0.0004286}, {445,0.0003143}, {446,0.0004571}, {447,0.0006000}, {448,0.0006571}, {449,0.0001714}, {450,0.0001714}, {451,0.0002571}, {452,0.0004000}, {453,0.0005429}, {454,0.0005714}, {455,0.0002571}, {456,0.0005714}, {457,0.0004571}, {458,0.0004857}, {459,0.0005429}, {460,0.0002571}, {461,0.0008000}, {462,0.0006000}, {463,0.0009714}, {464,0.0002000}, {465,0.0002571}, {466,0.0002571}, {467,0.0008286}, {468,0.0004571}, {469,0.0007714}, {470,0.0001714}, {471,0.0004286}, {472,0.0007714}, {473,0.0002857}, {474,0.0005143}, {475,0.0001714}, {476,0.0006857}, {477,0.0002571}, {478,0.0003143}, {479,0.0002571}, {480,0.0008000}, {481,0.0006857}, {482,0.0002857}, {483,0.0007143}, {484,0.0004286}, {485,0.0004286}, {486,0.0004286}, {487,0.0000857}, {488,0.0003714}, {489,0.0001714}, {490,0.0005143}, {491,0.0001714}, {492,0.0009714}, {493,0.0006857}, {494,0.0005143}, {495,0.0002857}, {496,0.0006857}, {497,0.0007714}, {498,0.0001714}, {499,0.0006286}, {500,0.0003714}, {505,0.0002857}, {510,0.0003143}, {515,0.0003429}, {520,0.0003429}, {525,0.0005143}, {530,0.0005143}, {535,0.0003429}, {540,0.0004571}, {545,0.0005143}, {550,0.0007714}, {555,0.0006000}, {560,0.0003429}, {565,0.0007714}, {570,0.0006286}, {575,0.0004286}, {580,0.0006000}, {585,0.0006000}, {590,0.0008857}, {595,0.0003714}, {600,0.0002571}, {605,0.0004571}, {610,0.0007143}, {615,0.0007429}, {620,0.0005143}, {625,0.0004286}, {630,0.0008000}, {635,0.0006000}, {640,0.0007429}, {645,0.0006857}, {650,0.0006000}, {655,0.0004286}, {660,0.0007143}, {665,0.0004286}, {670,0.0008571}, {675,0.0002571}, {680,0.0002857}, {685,0.0008000}, {690,0.0009143}, {695,0.0004286}, {700,0.0006857}, {705,0.0004286}, {710,0.0006286}, {715,0.0006000}, {720,0.0002571}, {725,0.0008000}, {730,0.0008571}, {735,0.0009714}, {740,0.0003714}, {745,0.0006857}, {750,0.0000857}, {755,0.0009714}, {760,0.0006286}, {765,0.0006000}, {770,0.0007714}, {775,0.0008286}, {780,0.0009714}, {785,0.0007143}, {790,0.0006857}, {795,0.0007143}, {800,0.0006286}, {805,0.0007143}, {810,0.0008000}, {815,0.0005143}, {820,0.0007143}, {825,0.0007714}, {830,0.0013143}, {835,0.0006000}, {840,0.0009714}, {845,0.0005714}, {850,0.0010857}, {855,0.0006000}, {860,0.0008000}, {865,0.0006286}, {870,0.0010000}, {875,0.0006000}, {880,0.0006571}, {885,0.0009143}, {890,0.0006857}, {895,0.0006857}, {900,0.0006286}, {905,0.0006286}, {910,0.0013143}, {915,0.0008857}, {920,0.0015714}, {925,0.0006857}, {930,0.0006857}, {935,0.0007714}, {940,0.0008857}, {945,0.0010571}, {950,0.0010286}, {955,0.0009143}, {960,0.0007714}, {965,0.0012571}, {970,0.0008571}, {975,0.0009429}, {980,0.0008286}, {985,0.0010571}, {990,0.0012857}, {995,0.0013714}, {1000,0.0006571}, {1010,0.0010857}, {1020,0.0013429}, {1030,0.0008286}, {1040,0.0012571}, {1050,0.0010571}, {1060,0.0007429}, {1070,0.0012286}, {1080,0.0010571}, {1090,0.0006571}, {1100,0.0008571}, {1110,0.0009143}, {1120,0.0011143}, {1130,0.0015714}, {1140,0.0011714}, {1150,0.0009143}, {1160,0.0013429}, {1170,0.0007714}, {1180,0.0012857}, {1190,0.0011714}, {1200,0.0014286}, {1210,0.0014571}, {1220,0.0012286}, {1230,0.0017429}, {1240,0.0014000}, {1250,0.0012286}, {1260,0.0014571}, {1270,0.0012000}, {1280,0.0012857}, {1290,0.0009429}, {1300,0.0010857}, {1310,0.0015714}, {1320,0.0013143}, {1330,0.0012286}, {1340,0.0017429}, {1350,0.0016000}, {1360,0.0010857}, {1370,0.0014857}, {1380,0.0014000}, {1390,0.0018000}, {1400,0.0013143}, {1410,0.0014286}, {1420,0.0018857}, {1430,0.0015143}, {1440,0.0020000}, {1450,0.0014857}, {1460,0.0014857}, {1470,0.0016000}, {1480,0.0016571}, {1490,0.0011143}, {1500,0.0015714}, {1510,0.0009429}, {1520,0.0012857}, {1530,0.0014286}, {1540,0.0016857}, {1550,0.0067714}, {1560,0.0016571}, {1570,0.0017714}, {1580,0.0020000}, {1590,0.0014000}, {1600,0.0020857}, {1610,0.0016286}, {1620,0.0017714}, {1630,0.0020857}, {1640,0.0019714}, {1650,0.0018571}, {1660,0.0020571}, {1670,0.0016000}, {1680,0.0013714}, {1690,0.0016286}, {1700,0.0015714}, {1710,0.0023429}, {1720,0.0014000}, {1730,0.0017714}, {1740,0.0023429}, {1750,0.0022857}, {1760,0.0018571}, {1770,0.0018857}, {1780,0.0013143}, {1790,0.0019714}, {1800,0.0021714}, {1810,0.0008000}, {1820,0.0014571}, {1830,0.0021429}, {1840,0.0014571}, {1850,0.0013143}, {1860,0.0022286}, {1870,0.0018286}, {1880,0.0020857}, {1890,0.0023429}, {1900,0.0026571}, {1910,0.0024286}, {1920,0.0030000}, {1930,0.0023429}, {1940,0.0019429}, {1950,0.0023143}, {1960,0.0017429}, {1970,0.0018000}, {1980,0.0024571}, {1990,0.0027714}, {2000,0.0021429}};
data["big"]["LtacTacInTermExplicitCtx"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00003960}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00003960}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00003960}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0001143}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0001143}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0001143}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0001143}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0001143}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0001143}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0001143}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0001143}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0001143}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0001143}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0001143}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000857}, {1730,0.0002000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000857}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000857}, {1890,0.0000000}, {1900,0.0000857}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000857}, {1960,0.0000857}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermExplicitCtx"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00116832}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00325743}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000286}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000286}, {1320,0.0000000}, {1330,0.0000286}, {1340,0.0000000}, {1350,0.0000286}, {1360,0.0000286}, {1370,0.0000286}, {1380,0.0000000}, {1390,0.0001143}, {1400,0.0001143}, {1410,0.0001143}, {1420,0.0001143}, {1430,0.0001429}, {1440,0.0001429}, {1450,0.0002000}, {1460,0.0002286}, {1470,0.0002000}, {1480,0.0002000}, {1490,0.0001714}, {1500,0.0002000}, {1510,0.0002571}, {1520,0.0002286}, {1530,0.0002857}, {1540,0.0002571}, {1550,0.0002000}, {1560,0.0004286}, {1570,0.0004571}, {1580,0.0007429}, {1590,0.0006286}, {1600,0.0008286}, {1610,0.0009714}, {1620,0.0065429}, {1630,0.0010000}, {1640,0.0010000}, {1650,0.0010000}, {1660,0.0010000}, {1670,0.0010000}, {1680,0.0010000}, {1690,0.0010000}, {1700,0.0010000}, {1710,0.0010000}, {1720,0.0010000}, {1730,0.0010000}, {1740,0.0010000}, {1750,0.0010000}, {1760,0.0010000}, {1770,0.0010000}, {1780,0.0010000}, {1790,0.0010000}, {1800,0.0010000}, {1810,0.0010000}, {1820,0.0010000}, {1830,0.0010000}, {1840,0.0010000}, {1850,0.0010000}, {1860,0.0010000}, {1870,0.0010000}, {1880,0.0010000}, {1890,0.0010000}, {1900,0.0010000}, {1910,0.0010000}, {1920,0.0010000}, {1930,0.0010000}, {1940,0.0010000}, {1950,0.0010000}, {1960,0.0010000}, {1970,0.0010000}, {1980,0.0010000}, {1990,0.0010000}, {2000,0.0010000}};
data["big"]["LtacTacInTermExplicitCtx"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00002970}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00003960}, {9,0.00003960}, {10,0.00000000}, {11,0.00000000}, {12,0.00003960}, {13,0.00000000}, {14,0.00007921}, {15,0.00003960}, {16,0.00000000}, {17,0.00011881}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00003960}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00003960}, {28,0.00003960}, {29,0.00011881}, {30,0.00000000}, {31,0.00003960}, {32,0.00003960}, {33,0.00006931}, {34,0.00011881}, {35,0.00007921}, {36,0.00003960}, {37,0.00007921}, {38,0.00011881}, {39,0.00002970}, {40,0.00000000}, {41,0.00003960}, {42,0.00003960}, {43,0.00011881}, {44,0.00003960}, {45,0.00003960}, {46,0.00000000}, {47,0.00002970}, {48,0.00003960}, {49,0.00007921}, {50,0.00000000}, {51,0.00007921}, {52,0.00011881}, {53,0.00011881}, {54,0.00003960}, {55,0.00011881}, {56,0.00000000}, {57,0.00000000}, {58,0.00003960}, {59,0.00003960}, {60,0.00009901}, {61,0.00000000}, {62,0.00010891}, {63,0.00003960}, {64,0.00002970}, {65,0.00003960}, {66,0.00003960}, {67,0.00011881}, {68,0.00007921}, {69,0.00007921}, {70,0.00000000}, {71,0.00003960}, {72,0.00015842}, {73,0.00010891}, {74,0.00019802}, {75,0.00007921}, {76,0.00015842}, {77,0.00007921}, {78,0.00002970}, {79,0.00006931}, {80,0.00000000}, {81,0.00109901}, {82,0.00003960}, {83,0.00010891}, {84,0.00000000}, {85,0.00003960}, {86,0.00015842}, {87,0.00014851}, {88,0.00011881}, {89,0.00003960}, {90,0.00003960}, {91,0.00021782}, {92,0.00009901}, {93,0.00023762}, {94,0.00011881}, {95,0.00014851}, {96,0.00006931}, {97,0.00007921}, {98,0.00011881}, {99,0.00010891}, {100,0.00015842}, {101,0.00003960}, {102,0.00007921}, {103,0.00010891}, {104,0.00005941}, {105,0.00015842}, {106,0.00005941}, {107,0.00010891}, {108,0.00006931}, {109,0.00011881}, {110,0.00014851}, {111,0.00009901}, {112,0.00014851}, {113,0.00019802}, {114,0.00011881}, {115,0.00003960}, {116,0.00000000}, {117,0.00010891}, {118,0.00003960}, {119,0.00014851}, {120,0.00003960}, {121,0.00022772}, {122,0.00003960}, {123,0.00007921}, {124,0.00000000}, {125,0.00017822}, {126,0.00009901}, {127,0.00022772}, {128,0.00010891}, {129,0.00014851}, {130,0.00014851}, {131,0.00010891}, {132,0.00027723}, {133,0.00022772}, {134,0.00015842}, {135,0.00003960}, {136,0.00007921}, {137,0.00010891}, {138,0.00014851}, {139,0.00003960}, {140,0.00031683}, {141,0.00007921}, {142,0.00006931}, {143,0.00011881}, {144,0.00014851}, {145,0.00014851}, {146,0.00003960}, {147,0.00022772}, {148,0.00003960}, {149,0.00015842}, {150,0.00007921}, {151,0.00019802}, {152,0.00010891}, {153,0.00011881}, {154,0.00006931}, {155,0.00007921}, {156,0.00011881}, {157,0.00010891}, {158,0.00006931}, {159,0.00007921}, {160,0.00019802}, {161,0.00015842}, {162,0.00011881}, {163,0.00022772}, {164,0.00015842}, {165,0.00015842}, {166,0.00010891}, {167,0.00024752}, {168,0.00002970}, {169,0.00007921}, {170,0.00000000}, {171,0.00022772}, {172,0.00015842}, {173,0.00011881}, {174,0.00007921}, {175,0.00007921}, {176,0.00010891}, {177,0.00019802}, {178,0.00011881}, {179,0.00018812}, {180,0.00011881}, {181,0.00017822}, {182,0.00022772}, {183,0.00011881}, {184,0.00003960}, {185,0.00022772}, {186,0.00015842}, {187,0.00019802}, {188,0.00022772}, {189,0.00011881}, {190,0.00023762}, {191,0.00005941}, {192,0.00018812}, {193,0.00010891}, {194,0.00014851}, {195,0.00015842}, {196,0.00014851}, {197,0.00006931}, {198,0.00023762}, {199,0.00011881}, {200,0.00018812}, {201,0.00023762}, {202,0.00016832}, {203,0.00019802}, {204,0.00027723}, {205,0.00006931}, {206,0.00011881}, {207,0.00014851}, {208,0.00011881}, {209,0.00021782}, {210,0.00019802}, {211,0.00011881}, {212,0.00018812}, {213,0.00016832}, {214,0.00018812}, {215,0.00019802}, {216,0.00015842}, {217,0.00009901}, {218,0.00010891}, {219,0.00023762}, {220,0.00013861}, {221,0.00022772}, {222,0.00015842}, {223,0.00021782}, {224,0.00007921}, {225,0.00018812}, {226,0.00010891}, {227,0.00015842}, {228,0.00009901}, {229,0.00007921}, {230,0.00014851}, {231,0.00025743}, {232,0.00017822}, {233,0.00019802}, {234,0.00038614}, {235,0.00003960}, {236,0.00006931}, {237,0.00010891}, {238,0.00011881}, {239,0.00035644}, {240,0.00018812}, {241,0.00023762}, {242,0.00021782}, {243,0.00011881}, {244,0.00006931}, {245,0.00019802}, {246,0.00006931}, {247,0.00019802}, {248,0.00019802}, {249,0.00029703}, {250,0.00017822}, {251,0.00011881}, {252,0.00009901}, {253,0.00003960}, {254,0.00015842}, {255,0.00024752}, {256,0.00002970}, {257,0.00021782}, {258,0.00017822}, {259,0.00015842}, {260,0.00005941}, {261,0.00009901}, {262,0.00007921}, {263,0.00020792}, {264,0.00009901}, {265,0.00018812}, {266,0.00005941}, {267,0.00031683}, {268,0.00017822}, {269,0.00009901}, {270,0.00023762}, {271,0.00012871}, {272,0.00005941}, {273,0.00009901}, {274,0.00002970}, {275,0.00009901}, {276,0.00005941}, {277,0.00019802}, {278,0.00015842}, {279,0.00031683}, {280,0.00032673}, {281,0.00015842}, {282,0.00030693}, {283,0.00016832}, {284,0.00010891}, {285,0.00026733}, {286,0.00026733}, {287,0.00040594}, {288,0.00009901}, {289,0.00030693}, {290,0.00017822}, {291,0.00017822}, {292,0.00012871}, {293,0.00027723}, {294,0.00026733}, {295,0.00025743}, {296,0.00018812}, {297,0.00017822}, {298,0.00310891}, {299,0.00003960}, {300,0.00009901}, {301,0.0002000}, {302,0.0000000}, {303,0.0000857}, {304,0.0002857}, {305,0.0002571}, {306,0.0003429}, {307,0.0000000}, {308,0.0000857}, {309,0.0000000}, {310,0.0000000}, {311,0.0001143}, {312,0.0000857}, {313,0.0000857}, {314,0.0002571}, {315,0.0003714}, {316,0.0002857}, {317,0.0001714}, {318,0.0000000}, {319,0.0000857}, {320,0.0002857}, {321,0.0001714}, {322,0.0002571}, {323,0.0003429}, {324,0.0000000}, {325,0.0004286}, {326,0.0003429}, {327,0.0000857}, {328,0.0001714}, {329,0.0003429}, {330,0.0001714}, {331,0.0002571}, {332,0.0002571}, {333,0.0000857}, {334,0.0000857}, {335,0.0000857}, {336,0.0001714}, {337,0.0003714}, {338,0.0000857}, {339,0.0006000}, {340,0.0002571}, {341,0.0000000}, {342,0.0000857}, {343,0.0003714}, {344,0.0003714}, {345,0.0000857}, {346,0.0001714}, {347,0.0000857}, {348,0.0002857}, {349,0.0002571}, {350,0.0004857}, {351,0.0003714}, {352,0.0001714}, {353,0.0004857}, {354,0.0000000}, {355,0.0002571}, {356,0.0002000}, {357,0.0001714}, {358,0.0002857}, {359,0.0000857}, {360,0.0001714}, {361,0.0002000}, {362,0.0002571}, {363,0.0003143}, {364,0.0003429}, {365,0.0002000}, {366,0.0002571}, {367,0.0000857}, {368,0.0000857}, {369,0.0002000}, {370,0.0001714}, {371,0.0003714}, {372,0.0000000}, {373,0.0000000}, {374,0.0001714}, {375,0.0003143}, {376,0.0003714}, {377,0.0000857}, {378,0.0000857}, {379,0.0006000}, {380,0.0003429}, {381,0.0001714}, {382,0.0001714}, {383,0.0002857}, {384,0.0003429}, {385,0.0000000}, {386,0.0002286}, {387,0.0004286}, {388,0.0005429}, {389,0.0004571}, {390,0.0003429}, {391,0.0002857}, {392,0.0000857}, {393,0.0002000}, {394,0.0001714}, {395,0.0001714}, {396,0.0001714}, {397,0.0002571}, {398,0.0005714}, {399,0.0002000}, {400,0.0003714}, {401,0.0000857}, {402,0.0004286}, {403,0.0002000}, {404,0.0000857}, {405,0.0000857}, {406,0.0003714}, {407,0.0002571}, {408,0.0001714}, {409,0.0000857}, {410,0.0005429}, {411,0.0002571}, {412,0.0002857}, {413,0.0002000}, {414,0.0003429}, {415,0.0004857}, {416,0.0002000}, {417,0.0000000}, {418,0.0004286}, {419,0.0002857}, {420,0.0000857}, {421,0.0003714}, {422,0.0001714}, {423,0.0003143}, {424,0.0004571}, {425,0.0001714}, {426,0.0000857}, {427,0.0001714}, {428,0.0003714}, {429,0.0004286}, {430,0.0000857}, {431,0.0000857}, {432,0.0004286}, {433,0.0002571}, {434,0.0003714}, {435,0.0000857}, {436,0.0002571}, {437,0.0004286}, {438,0.0003429}, {439,0.0003714}, {440,0.0005143}, {441,0.0002857}, {442,0.0002571}, {443,0.0002857}, {444,0.0002571}, {445,0.0000857}, {446,0.0004286}, {447,0.0000857}, {448,0.0004571}, {449,0.0001714}, {450,0.0001714}, {451,0.0006857}, {452,0.0003429}, {453,0.0004857}, {454,0.0004857}, {455,0.0002857}, {456,0.0001714}, {457,0.0002000}, {458,0.0000000}, {459,0.0003143}, {460,0.0003429}, {461,0.0002571}, {462,0.0002857}, {463,0.0001714}, {464,0.0003714}, {465,0.0000857}, {466,0.0004571}, {467,0.0002000}, {468,0.0002571}, {469,0.0000857}, {470,0.0002857}, {471,0.0001143}, {472,0.0001714}, {473,0.0002571}, {474,0.0002000}, {475,0.0002571}, {476,0.0005429}, {477,0.0005714}, {478,0.0002571}, {479,0.0004571}, {480,0.0003429}, {481,0.0004286}, {482,0.0003714}, {483,0.0000000}, {484,0.0001714}, {485,0.0003143}, {486,0.0003714}, {487,0.0002571}, {488,0.0002571}, {489,0.0004286}, {490,0.0005429}, {491,0.0002571}, {492,0.0001714}, {493,0.0004286}, {494,0.0004000}, {495,0.0002571}, {496,0.0002000}, {497,0.0002571}, {498,0.0002571}, {499,0.0005143}, {500,0.0003714}, {505,0.0002857}, {510,0.0002571}, {515,0.0003714}, {520,0.0007143}, {525,0.0001714}, {530,0.0005143}, {535,0.0004571}, {540,0.0004286}, {545,0.0000857}, {550,0.0003714}, {555,0.0005429}, {560,0.0006000}, {565,0.0003429}, {570,0.0003429}, {575,0.0003714}, {580,0.0005143}, {585,0.0004571}, {590,0.0002571}, {595,0.0004286}, {600,0.0006571}, {605,0.0006286}, {610,0.0002857}, {615,0.0001714}, {620,0.0000857}, {625,0.0001714}, {630,0.0004286}, {635,0.0003429}, {640,0.0000857}, {645,0.0005429}, {650,0.0001714}, {655,0.0002571}, {660,0.0004571}, {665,0.0004571}, {670,0.0005429}, {675,0.0004000}, {680,0.0002000}, {685,0.0006000}, {690,0.0003429}, {695,0.0002857}, {700,0.0004571}, {705,0.0003429}, {710,0.0004286}, {715,0.0007714}, {720,0.0006286}, {725,0.0008857}, {730,0.0004857}, {735,0.0000000}, {740,0.0004286}, {745,0.0002857}, {750,0.0005143}, {755,0.0004286}, {760,0.0002571}, {765,0.0005143}, {770,0.0000857}, {775,0.0006000}, {780,0.0004571}, {785,0.0005714}, {790,0.0003429}, {795,0.0002571}, {800,0.0004286}, {805,0.0004286}, {810,0.0006000}, {815,0.0002857}, {820,0.0001714}, {825,0.0003429}, {830,0.0003714}, {835,0.0007714}, {840,0.0006000}, {845,0.0003429}, {850,0.0005143}, {855,0.0006000}, {860,0.0003429}, {865,0.0004286}, {870,0.0004286}, {875,0.0003429}, {880,0.0005429}, {885,0.0002857}, {890,0.0005429}, {895,0.0010571}, {900,0.0005143}, {905,0.0004857}, {910,0.0000857}, {915,0.0006000}, {920,0.0005429}, {925,0.0003714}, {930,0.0004286}, {935,0.0004286}, {940,0.0004571}, {945,0.0002571}, {950,0.0007143}, {955,0.0007143}, {960,0.0008571}, {965,0.0006000}, {970,0.0003714}, {975,0.0007143}, {980,0.0002000}, {985,0.0008286}, {990,0.0004857}, {995,0.0004000}, {1000,0.0005143}, {1010,0.0005143}, {1020,0.0007429}, {1030,0.0008286}, {1040,0.0004000}, {1050,0.0005429}, {1060,0.0008286}, {1070,0.0008571}, {1080,0.0007143}, {1090,0.0006286}, {1100,0.0007143}, {1110,0.0008857}, {1120,0.0008857}, {1130,0.0004286}, {1140,0.0006857}, {1150,0.0008000}, {1160,0.0006000}, {1170,0.0010000}, {1180,0.0006000}, {1190,0.0006857}, {1200,0.0006000}, {1210,0.0002286}, {1220,0.0006286}, {1230,0.0007143}, {1240,0.0008571}, {1250,0.0014857}, {1260,0.0011143}, {1270,0.0010857}, {1280,0.0006571}, {1290,0.0010000}, {1300,0.0005714}, {1310,0.0008000}, {1320,0.0006000}, {1330,0.0010286}, {1340,0.0004857}, {1350,0.0005429}, {1360,0.0006571}, {1370,0.0006286}, {1380,0.0009143}, {1390,0.0008286}, {1400,0.0010000}, {1410,0.0009714}, {1420,0.0005429}, {1430,0.0008000}, {1440,0.0010286}, {1450,0.0004857}, {1460,0.0008857}, {1470,0.0009714}, {1480,0.0011714}, {1490,0.0006286}, {1500,0.0009143}, {1510,0.0011143}, {1520,0.0014571}, {1530,0.0011143}, {1540,0.0005429}, {1550,0.0008857}, {1560,0.0007143}, {1570,0.0007429}, {1580,0.0006571}, {1590,0.0007429}, {1600,0.0009714}, {1610,0.0010000}, {1620,0.0064286}, {1630,0.0006571}, {1640,0.0006857}, {1650,0.0010286}, {1660,0.0009429}, {1670,0.0009143}, {1680,0.0008286}, {1690,0.0008571}, {1700,0.0011714}, {1710,0.0005714}, {1720,0.0010000}, {1730,0.0012571}, {1740,0.0008571}, {1750,0.0009429}, {1760,0.0015143}, {1770,0.0008857}, {1780,0.0012857}, {1790,0.0009714}, {1800,0.0007714}, {1810,0.0019429}, {1820,0.0014286}, {1830,0.0010857}, {1840,0.0010857}, {1850,0.0018286}, {1860,0.0010857}, {1870,0.0013143}, {1880,0.0013714}, {1890,0.0011429}, {1900,0.0006000}, {1910,0.0009429}, {1920,0.0006571}, {1930,0.0011429}, {1940,0.0010857}, {1950,0.0009714}, {1960,0.0010000}, {1970,0.0015143}, {1980,0.0012571}, {1990,0.0010000}, {2000,0.0013143}};
data["big"]["LtacTacInTermExplicitCtx"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00003960}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00003960}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00003960}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00003960}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00003960}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0001143}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0001143}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0001143}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0001143}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0001143}, {830,0.0001143}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0001143}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0001143}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0001143}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0001143}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000857}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermExplicitCtx"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00100000}, {3,0.00100000}, {4,0.00100990}, {5,0.00200990}, {6,0.00200000}, {7,0.00299010}, {8,0.00300000}, {9,0.00331683}, {10,0.00400000}, {11,0.00427723}, {12,0.00618812}, {13,0.00532673}, {14,0.00600990}, {15,0.00651485}, {16,0.00703960}, {17,0.00948515}, {18,0.00820792}, {19,0.00898020}, {20,0.00944554}, {21,0.01251485}, {22,0.01093069}, {23,0.01135644}, {24,0.01206931}, {25,0.01291089}, {26,0.01342574}, {27,0.01403960}, {28,0.01492079}, {29,0.01552475}, {30,0.01614851}, {31,0.01832673}, {32,0.01785149}, {33,0.01840594}, {34,0.01919802}, {35,0.02005941}, {36,0.02098020}, {37,0.02174257}, {38,0.02255446}, {39,0.02736634}, {40,0.02657426}, {41,0.02503960}, {42,0.02604950}, {43,0.02694059}, {44,0.03693069}, {45,0.02878218}, {46,0.02972277}, {47,0.03767327}, {48,0.03134653}, {49,0.03782178}, {50,0.03370297}, {51,0.04208911}, {52,0.03546535}, {53,0.03644554}, {54,0.03753465}, {55,0.03859406}, {56,0.03945545}, {57,0.04444554}, {58,0.05223762}, {59,0.04291089}, {60,0.04398020}, {61,0.04505941}, {62,0.04619802}, {63,0.04746535}, {64,0.05595050}, {65,0.05848515}, {66,0.05389109}, {67,0.05194059}, {68,0.05329703}, {69,0.06712871}, {70,0.05572277}, {71,0.06338614}, {72,0.05787129}, {73,0.06610891}, {74,0.06072277}, {75,0.08368317}, {76,0.06308911}, {77,0.06455446}, {78,0.07682178}, {79,0.08927723}, {80,0.08236634}, {81,0.08228713}, {82,0.07143564}, {83,0.08639604}, {84,0.11789109}, {85,0.07507921}, {86,0.07666337}, {87,0.07835644}, {88,0.07975248}, {89,0.08128713}, {90,0.08292079}, {91,0.08442574}, {92,0.08530693}, {93,0.08727723}, {94,0.08897030}, {95,0.08959406}, {96,0.09148515}, {97,0.09367327}, {98,0.09430693}, {99,0.09645545}, {100,0.09840594}, {101,0.10008911}, {102,0.10170297}, {103,0.10334653}, {104,0.11776238}, {105,0.11906931}, {106,0.12182178}, {107,0.12309901}, {108,0.12561386}, {109,0.12850495}, {110,0.13200990}, {111,0.13339604}, {112,0.13688119}, {113,0.14002970}, {114,0.14339604}, {115,0.14554455}, {116,0.14959406}, {117,0.15390099}, {118,0.15500990}, {119,0.15817822}, {120,0.15986139}, {121,0.16277228}, {122,0.16322772}, {123,0.16432673}, {124,0.16601980}, {125,0.16972277}, {126,0.17189109}, {127,0.17469307}, {128,0.18016832}, {129,0.18043564}, {130,0.18561386}, {131,0.18670297}, {132,0.18891089}, {133,0.19093069}, {134,0.19281188}, {135,0.19584158}, {136,0.19830693}, {137,0.20239604}, {138,0.20447525}, {139,0.20749505}, {140,0.21023762}, {141,0.21025743}, {142,0.21635644}, {143,0.21677228}, {144,0.22143564}, {145,0.22491089}, {146,0.22575248}, {147,0.22981188}, {148,0.23323762}, {149,0.23327723}, {150,0.23640594}, {151,0.23814851}, {152,0.24095050}, {153,0.24376238}, {154,0.24661386}, {155,0.24905941}, {156,0.25336634}, {157,0.25394059}, {158,0.25842574}, {159,0.25877228}, {160,0.26218812}, {161,0.26475248}, {162,0.26921782}, {163,0.27043564}, {164,0.27294059}, {165,0.27408911}, {166,0.28031683}, {167,0.28328713}, {168,0.28723762}, {169,0.29357426}, {170,0.29455446}, {171,0.29521782}, {172,0.29666337}, {173,0.30017822}, {174,0.30562376}, {175,0.31004950}, {176,0.31411881}, {177,0.31494059}, {178,0.31634653}, {179,0.32087129}, {180,0.32446535}, {181,0.32603960}, {182,0.33062376}, {183,0.33175248}, {184,0.33498020}, {185,0.33823762}, {186,0.34136634}, {187,0.34346535}, {188,0.34707921}, {189,0.35092079}, {190,0.35645545}, {191,0.35648515}, {192,0.36443564}, {193,0.37143564}, {194,0.37009901}, {195,0.36953465}, {196,0.37299010}, {197,0.37654455}, {198,0.37953465}, {199,0.38214851}, {200,0.38947525}, {201,0.40014851}, {202,0.39517822}, {203,0.39100990}, {204,0.40002970}, {205,0.40154455}, {206,0.41307921}, {207,0.42138614}, {208,0.41023762}, {209,0.41544554}, {210,0.41937624}, {211,0.43896040}, {212,0.43372277}, {213,0.43046535}, {214,0.43206931}, {215,0.45083168}, {216,0.44611881}, {217,0.44525743}, {218,0.46439604}, {219,0.45792079}, {220,0.45813861}, {221,0.47045545}, {222,0.47098020}, {223,0.47214851}, {224,0.48578218}, {225,0.48020792}, {226,0.48756436}, {227,0.48697030}, {228,0.49264356}, {229,0.50386139}, {230,0.50083168}, {231,0.51499010}, {232,0.50643564}, {233,0.52499010}, {234,0.51512871}, {235,0.53313861}, {236,0.52173267}, {237,0.53411881}, {238,0.53375248}, {239,0.53289109}, {240,0.54598020}, {241,0.54074257}, {242,0.55636634}, {243,0.55643564}, {244,0.56000990}, {245,0.56542574}, {246,0.60986139}, {247,0.56938614}, {248,0.57958416}, {249,0.57873267}, {250,0.58442574}, {251,0.60892079}, {252,0.59100000}, {253,0.59100000}, {254,0.60103960}, {255,0.60921782}, {256,0.62281188}, {257,0.74476238}, {258,0.62931683}, {259,0.63189109}, {260,0.63264356}, {261,0.63945545}, {262,0.64399010}, {263,0.64547525}, {264,0.65767327}, {265,0.65657426}, {266,0.72713861}, {267,0.66181188}, {268,0.66560396}, {269,0.67343564}, {270,0.67505941}, {271,0.69087129}, {272,0.68866337}, {273,0.75269307}, {274,0.69745545}, {275,0.70500990}, {276,0.70618812}, {277,0.70761386}, {278,0.70968317}, {279,0.72171287}, {280,0.76219802}, {281,0.72676238}, {282,0.73301980}, {283,0.73639604}, {284,0.74065347}, {285,0.74518812}, {286,0.74739604}, {287,0.75447525}, {288,0.76053465}, {289,0.76937624}, {290,0.77194059}, {291,0.77986139}, {292,0.80035644}, {293,0.79116832}, {294,0.80029703}, {295,0.81328713}, {296,0.81322772}, {297,0.81831683}, {298,0.82175248}, {299,0.84508911}, {300,0.84049505}, {301,1.0326000}, {302,0.9627429}, {303,0.9529714}, {304,0.9265143}, {305,0.9000571}, {306,0.9095429}, {307,0.9324000}, {308,0.9235143}, {309,0.9252000}, {310,0.9362000}, {311,0.9470000}, {312,0.9464571}, {313,0.9565429}, {314,0.9596571}, {315,0.9639714}, {316,0.9667143}, {317,0.9755714}, {318,0.9822571}, {319,0.9906286}, {320,0.9942286}, {321,0.9881143}, {322,1.0088571}, {323,1.0010857}, {324,1.0119143}, {325,1.0094286}, {326,1.0234000}, {327,1.0269714}, {328,1.0325143}, {329,1.0356286}, {330,1.0417143}, {331,1.0656857}, {332,1.0464000}, {333,1.0578571}, {334,1.0544286}, {335,1.0696286}, {336,1.0983143}, {337,1.0710857}, {338,1.0844857}, {339,1.0835143}, {340,1.0972000}, {341,1.1084000}, {342,1.1147429}, {343,1.1260857}, {344,1.1337429}, {345,1.1364286}, {346,1.1387714}, {347,1.1481714}, {348,1.1496571}, {349,1.1587429}, {350,1.1676286}, {351,1.1832857}, {352,1.1792286}, {353,1.1895429}, {354,1.1916286}, {355,1.1924857}, {356,1.2088857}, {357,1.2166571}, {358,1.2151143}, {359,1.2293429}, {360,1.2300571}, {361,1.2294286}, {362,1.2448571}, {363,1.2580286}, {364,1.2598000}, {365,1.2914286}, {366,1.2712000}, {367,1.2808000}, {368,1.2783429}, {369,1.2954571}, {370,1.2990000}, {371,1.3060571}, {372,1.3363429}, {373,1.3108286}, {374,1.3348286}, {375,1.3442286}, {376,1.3357714}, {377,1.3496571}, {378,1.3613714}, {379,1.3600857}, {380,1.3666286}, {381,1.3907143}, {382,1.3926000}, {383,1.4070857}, {384,1.4112286}, {385,1.4237429}, {386,1.4321143}, {387,1.4464571}, {388,1.4452571}, {389,1.4582286}, {390,1.4610571}, {391,1.4723714}, {392,1.4790857}, {393,1.5149429}, {394,1.4937143}, {395,1.5037714}, {396,1.5110286}, {397,1.5132000}, {398,1.5509429}, {399,1.5308857}, {400,1.5668857}, {401,1.5804286}, {402,1.5856857}, {403,1.5750000}, {404,1.5912857}, {405,1.6112000}, {406,1.5927429}, {407,1.6036571}, {408,1.6033143}, {409,1.6222571}, {410,1.6558857}, {411,1.6231714}, {412,1.6271429}, {413,1.6378571}, {414,1.6503429}, {415,1.6522857}, {416,1.6611143}, {417,1.6701714}, {418,1.6715143}, {419,1.6791714}, {420,1.6981429}, {421,1.7256286}, {422,1.7061143}, {423,1.7466857}, {424,1.7370286}, {425,1.7530000}, {426,1.7725143}, {427,1.8050000}, {428,1.7969714}, {429,1.7869714}, {430,1.8248000}, {431,1.8200857}, {432,1.8163143}, {433,1.8234571}, {434,1.8380571}, {435,1.8723429}, {436,1.8386286}, {437,1.8645429}, {438,1.8815143}, {439,1.8908857}, {440,1.8929143}, {441,1.9044286}, {442,1.9156000}, {443,1.9168571}, {444,1.9420286}, {445,1.9516286}, {446,1.9298286}, {447,1.9481714}, {448,1.9539143}, {449,1.9627143}, {450,2.0214857}, {451,2.0013143}, {452,1.9847143}, {453,2.0420000}, {454,2.0308000}, {455,2.0362286}, {456,2.0524571}, {457,2.0646286}, {458,2.0437714}, {459,2.0908571}, {460,2.0659429}, {461,2.0990857}, {462,2.1083429}, {463,2.1801714}, {464,2.1776286}, {465,2.1005143}, {466,2.1714857}, {467,2.1590286}, {468,2.1633429}, {469,2.1478571}, {470,2.1844286}, {471,2.1629429}, {472,2.1732857}, {473,2.1774000}, {474,2.1840000}, {475,2.1855429}, {476,2.2059714}, {477,2.2155429}, {478,2.2235429}, {479,2.2317429}, {480,2.2493714}, {481,2.2615429}, {482,2.2836286}, {483,2.3237714}, {484,2.2936000}, {485,2.3148286}, {486,2.3138286}, {487,2.3196000}, {488,2.3275143}, {489,2.3310857}, {490,2.3468857}, {491,2.3471143}, {492,2.3535429}, {493,2.3782571}, {494,2.3893429}, {495,2.3954571}, {496,2.4172000}, {497,2.4309714}, {498,2.4378000}, {499,2.4401714}, {500,2.4410857}, {505,2.4927429}, {510,2.5459714}, {515,2.5870571}, {520,2.6652000}, {525,2.7422286}, {530,2.7361714}, {535,2.8357143}, {540,2.9143429}, {545,3.0889143}, {550,3.1006000}, {555,3.1460857}, {560,3.2015429}, {565,3.3240286}, {570,3.3468286}, {575,3.4305143}, {580,3.4258857}, {585,3.5989714}, {590,3.6236286}, {595,3.5524000}, {600,3.6481714}, {605,3.7305429}, {610,3.7561429}, {615,3.8124857}, {620,3.8600000}, {625,3.9297143}, {630,3.9906857}, {635,4.0289714}, {640,4.0682286}, {645,4.1214857}, {650,4.2252857}, {655,4.3177143}, {660,4.2890857}, {665,4.3770857}, {670,4.4862857}, {675,4.5536857}, {680,4.5670286}, {685,4.6449143}, {690,4.7232000}, {695,4.8057714}, {700,4.9009714}, {705,4.9891714}, {710,5.0258286}, {715,5.1367429}, {720,5.1804571}, {725,5.2970000}, {730,5.3573429}, {735,5.4606857}, {740,5.5132857}, {745,5.6196857}, {750,5.7405714}, {755,5.8590571}, {760,5.9366286}, {765,6.0274857}, {770,6.0903714}, {775,6.2224571}, {780,6.2875429}, {785,6.3741143}, {790,6.4860857}, {795,6.5869143}, {800,6.6660857}, {805,6.7860571}, {810,6.8486571}, {815,6.9731429}, {820,7.0931429}, {825,7.1612571}, {830,7.2492000}, {835,7.3448000}, {840,7.4029714}, {845,7.5260286}, {850,7.7605143}, {855,7.8248286}, {860,7.9563429}, {865,8.0595714}, {870,8.3156000}, {875,8.4360571}, {880,8.6040286}, {885,8.6001143}, {890,8.7993143}, {895,8.9241143}, {900,8.8499143}, {905,9.2190286}, {910,9.2952571}, {915,9.3910000}, {920,9.5016857}, {925,9.8517429}, {930,10.0101429}, {935,10.0662571}, {940,9.9550286}, {945,10.0834571}, {950,9.9682571}, {955,10.4277429}, {960,10.3136286}, {965,10.3902571}, {970,10.6885429}, {975,10.8914571}, {980,11.0279143}, {985,11.0656000}, {990,11.4274000}, {995,11.1099714}, {1000,11.3960286}, {1010,11.6346286}, {1020,11.8246857}, {1030,12.4776857}, {1040,12.7502000}, {1050,12.9123143}, {1060,13.4646571}, {1070,13.7086571}, {1080,14.3050286}, {1090,14.3714000}, {1100,14.9306571}, {1110,15.0742286}, {1120,15.6330857}, {1130,15.4375429}, {1140,15.8500000}, {1150,16.6727143}, {1160,16.7594000}, {1170,17.1439429}, {1180,17.7270857}, {1190,17.8730286}, {1200,18.2573429}, {1210,18.3674571}, {1220,19.2546571}, {1230,19.2911429}, {1240,19.7608571}, {1250,20.4207429}, {1260,20.3435143}, {1270,21.1658000}, {1280,21.5254286}, {1290,22.3324857}, {1300,22.4107143}, {1310,22.8135143}, {1320,22.9788286}, {1330,23.6193429}, {1340,23.1902000}, {1350,23.6822000}, {1360,24.9319143}, {1370,25.2260286}, {1380,25.4962857}, {1390,26.0353429}, {1400,26.3200571}, {1410,26.4228286}, {1420,27.4434000}, {1430,27.8098286}, {1440,27.9843714}, {1450,28.4183429}, {1460,29.3536286}, {1470,29.3837429}, {1480,29.7678286}, {1490,30.4175429}, {1500,30.8324857}, {1510,31.5233143}, {1520,31.8948857}, {1530,33.0048286}, {1540,33.7028000}, {1550,33.7221429}, {1560,34.6517429}, {1570,34.9768000}, {1580,36.0574286}, {1590,35.5020286}, {1600,37.2425143}, {1610,37.2950857}, {1620,37.4452000}, {1630,38.2867714}, {1640,38.6866571}, {1650,39.3731429}, {1660,40.3831714}, {1670,41.0083143}, {1680,41.6305143}, {1690,42.0690000}, {1700,43.2663143}, {1710,42.8850000}, {1720,44.4627714}, {1730,44.7117429}, {1740,45.1454857}, {1750,45.7546571}, {1760,46.5288857}, {1770,47.6228000}, {1780,48.1114286}, {1790,48.4939429}, {1800,48.5413714}, {1810,49.5844857}, {1820,50.2676857}, {1830,50.9852857}, {1840,52.7317143}, {1850,52.8417143}, {1860,53.2294000}, {1870,54.2659714}, {1880,54.9410286}, {1890,55.6067143}, {1900,56.7162000}, {1910,57.1188571}, {1920,58.7160286}, {1930,58.6396000}, {1940,59.1924286}, {1950,61.0712286}, {1960,59.9505143}, {1970,61.6254571}, {1980,62.1686857}, {1990,63.2658857}, {2000,64.1420000}};
data["big"]["LtacTacInTermExplicitCtx"]["norm reif"]["user"] = {{1,0.00068317}, {2,0.00102970}, {3,0.00118812}, {4,0.00215842}, {5,0.00209901}, {6,0.00270297}, {7,0.00340594}, {8,0.00326733}, {9,0.00374257}, {10,0.00429703}, {11,0.00439604}, {12,0.00635644}, {13,0.00587129}, {14,0.00590099}, {15,0.00645545}, {16,0.00724752}, {17,0.00970297}, {18,0.00829703}, {19,0.00894059}, {20,0.00952475}, {21,0.01264356}, {22,0.01082178}, {23,0.01114851}, {24,0.01179208}, {25,0.01266337}, {26,0.01353465}, {27,0.01388119}, {28,0.01475248}, {29,0.01527723}, {30,0.01607921}, {31,0.01776238}, {32,0.01735644}, {33,0.01815842}, {34,0.01889109}, {35,0.01976238}, {36,0.02085149}, {37,0.02185149}, {38,0.02243564}, {39,0.02763366}, {40,0.02673267}, {41,0.02513861}, {42,0.02621782}, {43,0.02708911}, {44,0.03682178}, {45,0.02874257}, {46,0.02986139}, {47,0.03751485}, {48,0.03147525}, {49,0.03758416}, {50,0.03414851}, {51,0.04172277}, {52,0.03521782}, {53,0.03639604}, {54,0.03740594}, {55,0.03817822}, {56,0.03907921}, {57,0.04398020}, {58,0.05238614}, {59,0.04260396}, {60,0.04349505}, {61,0.04463366}, {62,0.04597030}, {63,0.04754455}, {64,0.05599010}, {65,0.05824752}, {66,0.05388119}, {67,0.05208911}, {68,0.05345545}, {69,0.06698020}, {70,0.05555446}, {71,0.06309901}, {72,0.05722772}, {73,0.06550495}, {74,0.06013861}, {75,0.08397030}, {76,0.06289109}, {77,0.06422772}, {78,0.07682178}, {79,0.08888119}, {80,0.08218812}, {81,0.08209901}, {82,0.07175248}, {83,0.08616832}, {84,0.11755446}, {85,0.07491089}, {86,0.07670297}, {87,0.07813861}, {88,0.07953465}, {89,0.08108911}, {90,0.08287129}, {91,0.08417822}, {92,0.08483168}, {93,0.08674257}, {94,0.08841584}, {95,0.08906931}, {96,0.09090099}, {97,0.09390099}, {98,0.09403960}, {99,0.09679208}, {100,0.09838614}, {101,0.10017822}, {102,0.10138614}, {103,0.10335644}, {104,0.11773267}, {105,0.11876238}, {106,0.12160396}, {107,0.12314851}, {108,0.12547525}, {109,0.12826733}, {110,0.13146535}, {111,0.13287129}, {112,0.13635644}, {113,0.13974257}, {114,0.14329703}, {115,0.14503960}, {116,0.14945545}, {117,0.15373267}, {118,0.15477228}, {119,0.15780198}, {120,0.15957426}, {121,0.16219802}, {122,0.16278218}, {123,0.16377228}, {124,0.16556436}, {125,0.16942574}, {126,0.17134653}, {127,0.17427723}, {128,0.17972277}, {129,0.17981188}, {130,0.18506931}, {131,0.18621782}, {132,0.18826733}, {133,0.19078218}, {134,0.19221782}, {135,0.19557426}, {136,0.19786139}, {137,0.20170297}, {138,0.20384158}, {139,0.20701980}, {140,0.20937624}, {141,0.20981188}, {142,0.21562376}, {143,0.21613861}, {144,0.22084158}, {145,0.22408911}, {146,0.22548515}, {147,0.22911881}, {148,0.23248515}, {149,0.23261386}, {150,0.23558416}, {151,0.23749505}, {152,0.24007921}, {153,0.24322772}, {154,0.24591089}, {155,0.24845545}, {156,0.25252475}, {157,0.25297030}, {158,0.25780198}, {159,0.25790099}, {160,0.26161386}, {161,0.26405941}, {162,0.26831683}, {163,0.26970297}, {164,0.27258416}, {165,0.27321782}, {166,0.27943564}, {167,0.28265347}, {168,0.28662376}, {169,0.29294059}, {170,0.29393069}, {171,0.29418812}, {172,0.29588119}, {173,0.29955446}, {174,0.30498020}, {175,0.30935644}, {176,0.31328713}, {177,0.31409901}, {178,0.31540594}, {179,0.31993069}, {180,0.32347525}, {181,0.32504950}, {182,0.32977228}, {183,0.33110891}, {184,0.33447525}, {185,0.33776238}, {186,0.34037624}, {187,0.34259406}, {188,0.34592079}, {189,0.34997030}, {190,0.35560396}, {191,0.35553465}, {192,0.36370297}, {193,0.37051485}, {194,0.36937624}, {195,0.36876238}, {196,0.37227723}, {197,0.37553465}, {198,0.37887129}, {199,0.38144554}, {200,0.38860396}, {201,0.39925743}, {202,0.39426733}, {203,0.38974257}, {204,0.39898020}, {205,0.40069307}, {206,0.41211881}, {207,0.42053465}, {208,0.40951485}, {209,0.41457426}, {210,0.41813861}, {211,0.43821782}, {212,0.43270297}, {213,0.42966337}, {214,0.43100990}, {215,0.45000000}, {216,0.44504950}, {217,0.44448515}, {218,0.46351485}, {219,0.45723762}, {220,0.45740594}, {221,0.46966337}, {222,0.47000990}, {223,0.47065347}, {224,0.48477228}, {225,0.47923762}, {226,0.48657426}, {227,0.48579208}, {228,0.49174257}, {229,0.50304950}, {230,0.50026733}, {231,0.51383168}, {232,0.50554455}, {233,0.52399010}, {234,0.51359406}, {235,0.53212871}, {236,0.52080198}, {237,0.53343564}, {238,0.53238614}, {239,0.53157426}, {240,0.54475248}, {241,0.53935644}, {242,0.55524752}, {243,0.55563366}, {244,0.55858416}, {245,0.56458416}, {246,0.60832673}, {247,0.56840594}, {248,0.57847525}, {249,0.57746535}, {250,0.58289109}, {251,0.60725743}, {252,0.58967327}, {253,0.58963366}, {254,0.59979208}, {255,0.60790099}, {256,0.62162376}, {257,0.74305941}, {258,0.62791089}, {259,0.63066337}, {260,0.63162376}, {261,0.63840594}, {262,0.64258416}, {263,0.64435644}, {264,0.65640594}, {265,0.65537624}, {266,0.72618812}, {267,0.66051485}, {268,0.66416832}, {269,0.67180198}, {270,0.67377228}, {271,0.68944554}, {272,0.68753465}, {273,0.75107921}, {274,0.69628713}, {275,0.70370297}, {276,0.70505941}, {277,0.70637624}, {278,0.70797030}, {279,0.72043564}, {280,0.76074257}, {281,0.72556436}, {282,0.73170297}, {283,0.73515842}, {284,0.73921782}, {285,0.74341584}, {286,0.74592079}, {287,0.75281188}, {288,0.75914851}, {289,0.76755446}, {290,0.77041584}, {291,0.77841584}, {292,0.79912871}, {293,0.78996040}, {294,0.79837624}, {295,0.81152475}, {296,0.81147525}, {297,0.81675248}, {298,0.82012871}, {299,0.84374257}, {300,0.83900990}, {301,1.0277143}, {302,0.9609143}, {303,0.9521714}, {304,0.9252857}, {305,0.8984857}, {306,0.9081143}, {307,0.9273143}, {308,0.9222857}, {309,0.9243429}, {310,0.9356286}, {311,0.9457143}, {312,0.9453429}, {313,0.9555143}, {314,0.9588286}, {315,0.9630000}, {316,0.9651429}, {317,0.9750000}, {318,0.9813714}, {319,0.9858857}, {320,0.9929143}, {321,0.9867429}, {322,0.9998286}, {323,1.0001429}, {324,1.0074857}, {325,1.0087714}, {326,1.0217429}, {327,1.0238286}, {328,1.0303429}, {329,1.0346000}, {330,1.0390571}, {331,1.0541429}, {332,1.0444857}, {333,1.0551143}, {334,1.0516571}, {335,1.0671714}, {336,1.0962571}, {337,1.0693714}, {338,1.0834857}, {339,1.0812286}, {340,1.0961143}, {341,1.1068571}, {342,1.1132857}, {343,1.1249714}, {344,1.1316571}, {345,1.1352857}, {346,1.1380857}, {347,1.1473143}, {348,1.1488000}, {349,1.1571714}, {350,1.1662000}, {351,1.1826857}, {352,1.1780286}, {353,1.1885714}, {354,1.1908000}, {355,1.1910571}, {356,1.2077714}, {357,1.2155714}, {358,1.2135429}, {359,1.2281143}, {360,1.2280000}, {361,1.2278857}, {362,1.2433714}, {363,1.2564286}, {364,1.2577143}, {365,1.2894000}, {366,1.2694571}, {367,1.2790000}, {368,1.2766857}, {369,1.2938000}, {370,1.2974000}, {371,1.3041714}, {372,1.3344000}, {373,1.3095714}, {374,1.3334571}, {375,1.3425714}, {376,1.3344286}, {377,1.3474571}, {378,1.3593429}, {379,1.3573143}, {380,1.3641429}, {381,1.3879143}, {382,1.3901143}, {383,1.4043143}, {384,1.4079714}, {385,1.4214857}, {386,1.4298857}, {387,1.4441714}, {388,1.4427714}, {389,1.4559143}, {390,1.4577714}, {391,1.4702000}, {392,1.4768571}, {393,1.5122286}, {394,1.4915714}, {395,1.5020571}, {396,1.5094571}, {397,1.5113714}, {398,1.5480286}, {399,1.5287143}, {400,1.5642286}, {401,1.5785429}, {402,1.5833429}, {403,1.5682857}, {404,1.5790571}, {405,1.6071143}, {406,1.5855714}, {407,1.6014000}, {408,1.5998000}, {409,1.6136571}, {410,1.6516857}, {411,1.6200571}, {412,1.6241429}, {413,1.6350571}, {414,1.6468000}, {415,1.6495429}, {416,1.6580000}, {417,1.6671143}, {418,1.6685143}, {419,1.6762000}, {420,1.6956286}, {421,1.7226000}, {422,1.7036000}, {423,1.7439429}, {424,1.7341429}, {425,1.7501143}, {426,1.7699143}, {427,1.8007714}, {428,1.7938286}, {429,1.7831429}, {430,1.8203714}, {431,1.8160286}, {432,1.8125429}, {433,1.8193429}, {434,1.8345429}, {435,1.8684857}, {436,1.8347143}, {437,1.8606571}, {438,1.8775714}, {439,1.8862000}, {440,1.8881429}, {441,1.8995714}, {442,1.9116857}, {443,1.9132286}, {444,1.9381714}, {445,1.9472000}, {446,1.9255143}, {447,1.9443143}, {448,1.9497143}, {449,1.9593714}, {450,2.0173429}, {451,1.9971714}, {452,1.9817143}, {453,2.0375714}, {454,2.0261714}, {455,2.0324857}, {456,2.0489143}, {457,2.0610286}, {458,2.0404000}, {459,2.0871714}, {460,2.0623143}, {461,2.0962000}, {462,2.1050571}, {463,2.1776571}, {464,2.1741143}, {465,2.0968571}, {466,2.1679143}, {467,2.1565714}, {468,2.1605429}, {469,2.1452000}, {470,2.1805429}, {471,2.1592571}, {472,2.1693429}, {473,2.1727714}, {474,2.1793143}, {475,2.1812857}, {476,2.2010571}, {477,2.2110000}, {478,2.2192571}, {479,2.2268286}, {480,2.2444000}, {481,2.2564857}, {482,2.2776857}, {483,2.3172571}, {484,2.2872000}, {485,2.3088000}, {486,2.3076286}, {487,2.3135143}, {488,2.3216571}, {489,2.3260000}, {490,2.3409429}, {491,2.3415143}, {492,2.3480857}, {493,2.3728571}, {494,2.3829143}, {495,2.3896571}, {496,2.4120571}, {497,2.4259429}, {498,2.4319714}, {499,2.4352286}, {500,2.4357429}, {505,2.4876857}, {510,2.5389714}, {515,2.5805143}, {520,2.6574000}, {525,2.7352571}, {530,2.7279429}, {535,2.8263143}, {540,2.9058571}, {545,3.0795714}, {550,3.0904000}, {555,3.1371429}, {560,3.1917714}, {565,3.3157714}, {570,3.3390571}, {575,3.4203143}, {580,3.4159714}, {585,3.5902857}, {590,3.6158000}, {595,3.5435143}, {600,3.6389143}, {605,3.7226571}, {610,3.7485143}, {615,3.8046000}, {620,3.8512000}, {625,3.9208857}, {630,3.9815429}, {635,4.0195429}, {640,4.0608000}, {645,4.1146571}, {650,4.2192857}, {655,4.3131143}, {660,4.2836857}, {665,4.3704857}, {670,4.4806286}, {675,4.5472286}, {680,4.5590000}, {685,4.6371714}, {690,4.7157429}, {695,4.7969143}, {700,4.8915714}, {705,4.9817429}, {710,5.0160857}, {715,5.1257429}, {720,5.1672571}, {725,5.2854857}, {730,5.3463429}, {735,5.4508857}, {740,5.5018571}, {745,5.6102286}, {750,5.7271714}, {755,5.8454857}, {760,5.9254286}, {765,6.0134857}, {770,6.0767714}, {775,6.2090000}, {780,6.2746857}, {785,6.3595429}, {790,6.4644571}, {795,6.5635714}, {800,6.6403429}, {805,6.7489429}, {810,6.8298000}, {815,6.9524000}, {820,7.0745714}, {825,7.1429429}, {830,7.2307714}, {835,7.3272571}, {840,7.3798000}, {845,7.5067143}, {850,7.7421429}, {855,7.8048000}, {860,7.9335429}, {865,8.0426000}, {870,8.2986857}, {875,8.4204857}, {880,8.5860286}, {885,8.5922857}, {890,8.7822857}, {895,8.9087714}, {900,8.8374571}, {905,9.1994571}, {910,9.2718857}, {915,9.3700000}, {920,9.4816000}, {925,9.8328000}, {930,9.9863429}, {935,10.0377714}, {940,9.9342571}, {945,10.0624857}, {950,9.9535429}, {955,10.4089429}, {960,10.2947143}, {965,10.3611143}, {970,10.6580571}, {975,10.8638857}, {980,10.9975143}, {985,11.0347429}, {990,11.3882000}, {995,11.0780286}, {1000,11.3579714}, {1010,11.6001429}, {1020,11.7913429}, {1030,12.4456571}, {1040,12.7228286}, {1050,12.8860000}, {1060,13.4412857}, {1070,13.6792857}, {1080,14.2836857}, {1090,14.3504000}, {1100,14.9038286}, {1110,15.0314857}, {1120,15.6046857}, {1130,15.4089429}, {1140,15.8208286}, {1150,16.6476000}, {1160,16.7327714}, {1170,17.1177714}, {1180,17.6955714}, {1190,17.8449429}, {1200,18.2288000}, {1210,18.3364571}, {1220,19.2170857}, {1230,19.2526857}, {1240,19.7064571}, {1250,20.3728286}, {1260,20.3019714}, {1270,21.1230571}, {1280,21.4795143}, {1290,22.2957714}, {1300,22.3768857}, {1310,22.7793714}, {1320,22.9381429}, {1330,23.5888571}, {1340,23.1428000}, {1350,23.6413714}, {1360,24.8924857}, {1370,25.1777714}, {1380,25.4549429}, {1390,25.9881143}, {1400,26.2803429}, {1410,26.3787143}, {1420,27.4040571}, {1430,27.7694571}, {1440,27.9149429}, {1450,28.3579714}, {1460,29.2932286}, {1470,29.3232857}, {1480,29.7142286}, {1490,30.3692571}, {1500,30.7765143}, {1510,31.4522286}, {1520,31.8403429}, {1530,32.9509143}, {1540,33.6431143}, {1550,33.6624571}, {1560,34.5883714}, {1570,34.8874286}, {1580,35.9880571}, {1590,35.4100857}, {1600,37.1783143}, {1610,37.2364857}, {1620,37.3762571}, {1630,38.2284000}, {1640,38.6295714}, {1650,39.2968286}, {1660,40.3139714}, {1670,40.9197143}, {1680,41.5558571}, {1690,41.9929714}, {1700,43.1863429}, {1710,42.8182286}, {1720,44.3698286}, {1730,44.6186286}, {1740,45.0570571}, {1750,45.6703714}, {1760,46.4371714}, {1770,47.5371143}, {1780,48.0442286}, {1790,48.4371714}, {1800,48.4770000}, {1810,49.5277143}, {1820,50.1911429}, {1830,50.8858000}, {1840,52.6365714}, {1850,52.7526571}, {1860,53.0990286}, {1870,54.1701143}, {1880,54.8318000}, {1890,55.4990571}, {1900,56.6315143}, {1910,57.0490000}, {1920,58.6360857}, {1930,58.5521143}, {1940,59.1029714}, {1950,61.0155429}, {1960,59.8573429}, {1970,61.5796286}, {1980,62.1183429}, {1990,63.1981714}, {2000,64.0653714}};
data["big"]["LtacTacInTermExplicitCtx"]["norm reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003960}, {4,0.00000000}, {5,0.00003960}, {6,0.00003960}, {7,0.00000000}, {8,0.00007921}, {9,0.00007921}, {10,0.00000000}, {11,0.00003960}, {12,0.00007921}, {13,0.00000000}, {14,0.00019802}, {15,0.00007921}, {16,0.00003960}, {17,0.00003960}, {18,0.00003960}, {19,0.00003960}, {20,0.00000000}, {21,0.00000000}, {22,0.00007921}, {23,0.00007921}, {24,0.00003960}, {25,0.00015842}, {26,0.00007921}, {27,0.00003960}, {28,0.00003960}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00010891}, {34,0.00002970}, {35,0.00003960}, {36,0.00003960}, {37,0.00000000}, {38,0.00003960}, {39,0.00007921}, {40,0.00000000}, {41,0.00007921}, {42,0.00006931}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00011881}, {47,0.00007921}, {48,0.00003960}, {49,0.00003960}, {50,0.00003960}, {51,0.00011881}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00015842}, {56,0.00003960}, {57,0.00000000}, {58,0.00003960}, {59,0.00007921}, {60,0.00003960}, {61,0.00003960}, {62,0.00007921}, {63,0.00003960}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00007921}, {68,0.00000000}, {69,0.00007921}, {70,0.00007921}, {71,0.00003960}, {72,0.00007921}, {73,0.00000000}, {74,0.00003960}, {75,0.00000000}, {76,0.00000000}, {77,0.00007921}, {78,0.00007921}, {79,0.00000000}, {80,0.00000000}, {81,0.00003960}, {82,0.00000000}, {83,0.00000000}, {84,0.00011881}, {85,0.00003960}, {86,0.00015842}, {87,0.00007921}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00003960}, {92,0.00003960}, {93,0.00003960}, {94,0.00011881}, {95,0.00000000}, {96,0.00003960}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00003960}, {101,0.00011881}, {102,0.00019802}, {103,0.00003960}, {104,0.00003960}, {105,0.00007921}, {106,0.00000000}, {107,0.00003960}, {108,0.00003960}, {109,0.00003960}, {110,0.00000000}, {111,0.00003960}, {112,0.00015842}, {113,0.00003960}, {114,0.00011881}, {115,0.00003960}, {116,0.00003960}, {117,0.00000000}, {118,0.00011881}, {119,0.00000000}, {120,0.00003960}, {121,0.00000000}, {122,0.00000000}, {123,0.00003960}, {124,0.00011881}, {125,0.00000000}, {126,0.00007921}, {127,0.00000000}, {128,0.00000000}, {129,0.00007921}, {130,0.00000000}, {131,0.00003960}, {132,0.00003960}, {133,0.00007921}, {134,0.00007921}, {135,0.00003960}, {136,0.00006931}, {137,0.00003960}, {138,0.00015842}, {139,0.00003960}, {140,0.00000000}, {141,0.00000000}, {142,0.00003960}, {143,0.00003960}, {144,0.00003960}, {145,0.00000000}, {146,0.00000000}, {147,0.00003960}, {148,0.00003960}, {149,0.00003960}, {150,0.00000000}, {151,0.00011881}, {152,0.00007921}, {153,0.00000000}, {154,0.00003960}, {155,0.00011881}, {156,0.00003960}, {157,0.00007921}, {158,0.00011881}, {159,0.00015842}, {160,0.00015842}, {161,0.00011881}, {162,0.00003960}, {163,0.00003960}, {164,0.00003960}, {165,0.00000000}, {166,0.00000000}, {167,0.00011881}, {168,0.00011881}, {169,0.00000000}, {170,0.00007921}, {171,0.00007921}, {172,0.00002970}, {173,0.00000000}, {174,0.00007921}, {175,0.00000000}, {176,0.00003960}, {177,0.00003960}, {178,0.00015842}, {179,0.00000000}, {180,0.00000000}, {181,0.00011881}, {182,0.00007921}, {183,0.00000000}, {184,0.00007921}, {185,0.00007921}, {186,0.00000000}, {187,0.00000000}, {188,0.00003960}, {189,0.00003960}, {190,0.00007921}, {191,0.00000000}, {192,0.00000000}, {193,0.00003960}, {194,0.00010891}, {195,0.00007921}, {196,0.00000000}, {197,0.00003960}, {198,0.00000000}, {199,0.00011881}, {200,0.00007921}, {201,0.00003960}, {202,0.00007921}, {203,0.00007921}, {204,0.00011881}, {205,0.00007921}, {206,0.00006931}, {207,0.00003960}, {208,0.00011881}, {209,0.00011881}, {210,0.00011881}, {211,0.00000000}, {212,0.00007921}, {213,0.00007921}, {214,0.00000000}, {215,0.00007921}, {216,0.00003960}, {217,0.00000000}, {218,0.00007921}, {219,0.00003960}, {220,0.00000000}, {221,0.00000000}, {222,0.00007921}, {223,0.00007921}, {224,0.00006931}, {225,0.00011881}, {226,0.00011881}, {227,0.00003960}, {228,0.00000000}, {229,0.00007921}, {230,0.00000000}, {231,0.00007921}, {232,0.00007921}, {233,0.00003960}, {234,0.00019802}, {235,0.00003960}, {236,0.00019802}, {237,0.00007921}, {238,0.00054455}, {239,0.00011881}, {240,0.00015842}, {241,0.00000000}, {242,0.00011881}, {243,0.00003960}, {244,0.00031683}, {245,0.00000000}, {246,0.00015842}, {247,0.00007921}, {248,0.00003960}, {249,0.00007921}, {250,0.00023762}, {251,0.00007921}, {252,0.00000000}, {253,0.00015842}, {254,0.00000000}, {255,0.00007921}, {256,0.00011881}, {257,0.00007921}, {258,0.00003960}, {259,0.00010891}, {260,0.00007921}, {261,0.00003960}, {262,0.00015842}, {263,0.00011881}, {264,0.00000000}, {265,0.00019802}, {266,0.00003960}, {267,0.00023762}, {268,0.00015842}, {269,0.00015842}, {270,0.00000000}, {271,0.00023762}, {272,0.00003960}, {273,0.00023762}, {274,0.00007921}, {275,0.00011881}, {276,0.00003960}, {277,0.00011881}, {278,0.00050495}, {279,0.00011881}, {280,0.00000000}, {281,0.00002970}, {282,0.00003960}, {283,0.00000000}, {284,0.00003960}, {285,0.00011881}, {286,0.00015842}, {287,0.00006931}, {288,0.00018812}, {289,0.00003960}, {290,0.00007921}, {291,0.00003960}, {292,0.00011881}, {293,0.00011881}, {294,0.00019802}, {295,0.00019802}, {296,0.00003960}, {297,0.00011881}, {298,0.00000000}, {299,0.00015842}, {300,0.00007921}, {301,0.0004571}, {302,0.0002286}, {303,0.0002286}, {304,0.0000000}, {305,0.0002286}, {306,0.0002286}, {307,0.0001143}, {308,0.0000000}, {309,0.0001143}, {310,0.0000000}, {311,0.0001143}, {312,0.0002286}, {313,0.0001143}, {314,0.0000000}, {315,0.0001143}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0002000}, {320,0.0001143}, {321,0.0003143}, {322,0.0000000}, {323,0.0000000}, {324,0.0002286}, {325,0.0000000}, {326,0.0002286}, {327,0.0001143}, {328,0.0001143}, {329,0.0001143}, {330,0.0002000}, {331,0.0001143}, {332,0.0003429}, {333,0.0001143}, {334,0.0001143}, {335,0.0001143}, {336,0.0001143}, {337,0.0001143}, {338,0.0001143}, {339,0.0001143}, {340,0.0001143}, {341,0.0000000}, {342,0.0002286}, {343,0.0000000}, {344,0.0003429}, {345,0.0002286}, {346,0.0000000}, {347,0.0002286}, {348,0.0000000}, {349,0.0003429}, {350,0.0001143}, {351,0.0001143}, {352,0.0001143}, {353,0.0000000}, {354,0.0002000}, {355,0.0001143}, {356,0.0001143}, {357,0.0001143}, {358,0.0000000}, {359,0.0001143}, {360,0.0003429}, {361,0.0001143}, {362,0.0000000}, {363,0.0003143}, {364,0.0002286}, {365,0.0002286}, {366,0.0002286}, {367,0.0002286}, {368,0.0000000}, {369,0.0004571}, {370,0.0001143}, {371,0.0001143}, {372,0.0005143}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0001143}, {377,0.0002286}, {378,0.0003429}, {379,0.0003429}, {380,0.0001143}, {381,0.0008000}, {382,0.0002286}, {383,0.0005714}, {384,0.0003429}, {385,0.0004571}, {386,0.0001143}, {387,0.0002286}, {388,0.0003429}, {389,0.0001143}, {390,0.0003429}, {391,0.0006857}, {392,0.0006857}, {393,0.0005714}, {394,0.0002286}, {395,0.0004571}, {396,0.0003429}, {397,0.0000000}, {398,0.0004286}, {399,0.0002286}, {400,0.0002286}, {401,0.0001143}, {402,0.0003429}, {403,0.0001143}, {404,0.0000000}, {405,0.0000000}, {406,0.0001143}, {407,0.0003429}, {408,0.0001143}, {409,0.0003429}, {410,0.0007714}, {411,0.0004571}, {412,0.0003429}, {413,0.0001143}, {414,0.0004286}, {415,0.0000000}, {416,0.0003429}, {417,0.0002286}, {418,0.0001143}, {419,0.0002286}, {420,0.0002286}, {421,0.0004571}, {422,0.0002286}, {423,0.0001143}, {424,0.0002286}, {425,0.0002286}, {426,0.0002286}, {427,0.0004571}, {428,0.0004571}, {429,0.0002286}, {430,0.0003429}, {431,0.0004571}, {432,0.0001143}, {433,0.0003429}, {434,0.0001143}, {435,0.0001143}, {436,0.0003429}, {437,0.0006571}, {438,0.0004571}, {439,0.0003429}, {440,0.0003429}, {441,0.0004571}, {442,0.0003429}, {443,0.0001143}, {444,0.0002286}, {445,0.0004571}, {446,0.0006857}, {447,0.0002286}, {448,0.0006857}, {449,0.0001143}, {450,0.0005714}, {451,0.0006857}, {452,0.0003429}, {453,0.0006857}, {454,0.0008000}, {455,0.0005714}, {456,0.0004571}, {457,0.0003429}, {458,0.0000000}, {459,0.0001143}, {460,0.0005714}, {461,0.0005714}, {462,0.0002286}, {463,0.0004286}, {464,0.0005714}, {465,0.0010286}, {466,0.0004571}, {467,0.0004571}, {468,0.0002286}, {469,0.0002286}, {470,0.0000000}, {471,0.0002286}, {472,0.0002286}, {473,0.0008000}, {474,0.0003429}, {475,0.0001143}, {476,0.0005714}, {477,0.0008000}, {478,0.0003429}, {479,0.0008000}, {480,0.0003429}, {481,0.0002286}, {482,0.0005714}, {483,0.0006857}, {484,0.0003429}, {485,0.0004571}, {486,0.0005429}, {487,0.0001143}, {488,0.0008000}, {489,0.0003143}, {490,0.0006857}, {491,0.0005429}, {492,0.0003429}, {493,0.0004286}, {494,0.0005714}, {495,0.0005714}, {496,0.0004571}, {497,0.0004571}, {498,0.0004571}, {499,0.0005714}, {500,0.0003429}, {505,0.0000000}, {510,0.0008000}, {515,0.0000000}, {520,0.0003429}, {525,0.0002286}, {530,0.0013714}, {535,0.0008000}, {540,0.0007714}, {545,0.0010286}, {550,0.0014857}, {555,0.0003429}, {560,0.0018286}, {565,0.0009143}, {570,0.0002286}, {575,0.0018286}, {580,0.0010286}, {585,0.0003429}, {590,0.0005714}, {595,0.0009143}, {600,0.0013429}, {605,0.0013714}, {610,0.0010286}, {615,0.0011429}, {620,0.0014857}, {625,0.0013714}, {630,0.0008857}, {635,0.0017143}, {640,0.0012571}, {645,0.0020286}, {650,0.0023714}, {655,0.0013714}, {660,0.0013714}, {665,0.0006857}, {670,0.0006857}, {675,0.0011429}, {680,0.0019429}, {685,0.0012286}, {690,0.0016000}, {695,0.0028286}, {700,0.0030286}, {705,0.0022857}, {710,0.0022857}, {715,0.0032857}, {720,0.0056000}, {725,0.0032000}, {730,0.0026000}, {735,0.0050286}, {740,0.0037429}, {745,0.0042286}, {750,0.0067429}, {755,0.0085429}, {760,0.0056571}, {765,0.0073143}, {770,0.0058286}, {775,0.0057143}, {780,0.0061429}, {785,0.0084571}, {790,0.0080571}, {795,0.0077429}, {800,0.0058286}, {805,0.0069714}, {810,0.0080000}, {815,0.0087429}, {820,0.0081714}, {825,0.0077143}, {830,0.0079714}, {835,0.0075143}, {840,0.0137143}, {845,0.0093714}, {850,0.0088857}, {855,0.0104000}, {860,0.0132571}, {865,0.0088571}, {870,0.0106000}, {875,0.0104000}, {880,0.0147429}, {885,0.0056857}, {890,0.0130286}, {895,0.0097429}, {900,0.0073143}, {905,0.0100286}, {910,0.0108000}, {915,0.0097714}, {920,0.0093143}, {925,0.0086857}, {930,0.0112857}, {935,0.0166286}, {940,0.0099143}, {945,0.0121143}, {950,0.0096571}, {955,0.0102857}, {960,0.0094286}, {965,0.0136857}, {970,0.0154857}, {975,0.0106857}, {980,0.0136857}, {985,0.0093429}, {990,0.0131714}, {995,0.0115429}, {1000,0.0132286}, {1010,0.0066857}, {1020,0.0094571}, {1030,0.0066857}, {1040,0.0078571}, {1050,0.0069143}, {1060,0.0071714}, {1070,0.0046000}, {1080,0.0076000}, {1090,0.0077143}, {1100,0.0072286}, {1110,0.0102857}, {1120,0.0078000}, {1130,0.0095714}, {1140,0.0118571}, {1150,0.0085143}, {1160,0.0093143}, {1170,0.0088286}, {1180,0.0118000}, {1190,0.0109714}, {1200,0.0110000}, {1210,0.0117143}, {1220,0.0146000}, {1230,0.0133429}, {1240,0.0226571}, {1250,0.0120571}, {1260,0.0133429}, {1270,0.0113714}, {1280,0.0107714}, {1290,0.0137429}, {1300,0.0116857}, {1310,0.0171714}, {1320,0.0164857}, {1330,0.0128000}, {1340,0.0199429}, {1350,0.0176571}, {1360,0.0143143}, {1370,0.0146000}, {1380,0.0180857}, {1390,0.0186286}, {1400,0.0195143}, {1410,0.0232286}, {1420,0.0152286}, {1430,0.0205429}, {1440,0.0256571}, {1450,0.0258000}, {1460,0.0247143}, {1470,0.0248857}, {1480,0.0272286}, {1490,0.0256857}, {1500,0.0283143}, {1510,0.0292286}, {1520,0.0287714}, {1530,0.0226571}, {1540,0.0228571}, {1550,0.0253429}, {1560,0.0332571}, {1570,0.0299714}, {1580,0.0360286}, {1590,0.0365143}, {1600,0.0254286}, {1610,0.0274286}, {1620,0.0335429}, {1630,0.0265143}, {1640,0.0274571}, {1650,0.0321143}, {1660,0.0293429}, {1670,0.0315429}, {1680,0.0271429}, {1690,0.0310857}, {1700,0.0301143}, {1710,0.0314857}, {1720,0.0281143}, {1730,0.0387429}, {1740,0.0350000}, {1750,0.0369429}, {1760,0.0438857}, {1770,0.0351143}, {1780,0.0290857}, {1790,0.0321429}, {1800,0.0368000}, {1810,0.0319429}, {1820,0.0456857}, {1830,0.0435714}, {1840,0.0316571}, {1850,0.0402857}, {1860,0.0562286}, {1870,0.0454286}, {1880,0.0468571}, {1890,0.0483143}, {1900,0.0519714}, {1910,0.0442857}, {1920,0.0408000}, {1930,0.0450000}, {1940,0.0479714}, {1950,0.0343429}, {1960,0.0435143}, {1970,0.0310857}, {1980,0.0414000}, {1990,0.0517714}, {2000,0.0454571}};
data["big"]["LtacTacInTermExplicitCtx"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermExplicitCtx"]["post"]["user"] = {{1,0.00007921}, {2,0.00003960}, {3,0.00000000}, {4,0.00000000}, {5,0.00003960}, {6,0.00000000}, {7,0.00000000}, {8,0.00002970}, {9,0.00003960}, {10,0.00000000}, {11,0.00006931}, {12,0.00000000}, {13,0.00000000}, {14,0.00003960}, {15,0.00003960}, {16,0.00003960}, {17,0.00000000}, {18,0.00003960}, {19,0.00011881}, {20,0.00003960}, {21,0.00003960}, {22,0.00003960}, {23,0.00003960}, {24,0.00007921}, {25,0.00000000}, {26,0.00003960}, {27,0.00003960}, {28,0.00003960}, {29,0.00011881}, {30,0.00003960}, {31,0.00000000}, {32,0.00003960}, {33,0.00003960}, {34,0.00000000}, {35,0.00003960}, {36,0.00000000}, {37,0.00003960}, {38,0.00002970}, {39,0.00000000}, {40,0.00000000}, {41,0.00006931}, {42,0.00011881}, {43,0.00003960}, {44,0.00002970}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00006931}, {51,0.00000000}, {52,0.00018812}, {53,0.00000000}, {54,0.00003960}, {55,0.00002970}, {56,0.00003960}, {57,0.00000000}, {58,0.00000000}, {59,0.00003960}, {60,0.00006931}, {61,0.00003960}, {62,0.00000000}, {63,0.00007921}, {64,0.00009901}, {65,0.00000000}, {66,0.00003960}, {67,0.00007921}, {68,0.00003960}, {69,0.00000000}, {70,0.00000000}, {71,0.00003960}, {72,0.00000000}, {73,0.00010891}, {74,0.00011881}, {75,0.00003960}, {76,0.00003960}, {77,0.00003960}, {78,0.00003960}, {79,0.00003960}, {80,0.00000000}, {81,0.00003960}, {82,0.00000000}, {83,0.00002970}, {84,0.00000000}, {85,0.00002970}, {86,0.00007921}, {87,0.00000000}, {88,0.00003960}, {89,0.00003960}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00003960}, {94,0.00000000}, {95,0.00000000}, {96,0.00003960}, {97,0.00002970}, {98,0.00003960}, {99,0.00007921}, {100,0.00002970}, {101,0.00000000}, {102,0.00000000}, {103,0.00019802}, {104,0.00000000}, {105,0.00003960}, {106,0.00007921}, {107,0.00000000}, {108,0.00003960}, {109,0.00003960}, {110,0.00000000}, {111,0.00000000}, {112,0.00003960}, {113,0.00000000}, {114,0.00007921}, {115,0.00000000}, {116,0.00007921}, {117,0.00003960}, {118,0.00002970}, {119,0.00000000}, {120,0.00002970}, {121,0.00003960}, {122,0.00007921}, {123,0.00003960}, {124,0.00000000}, {125,0.00003960}, {126,0.00000000}, {127,0.00000000}, {128,0.00011881}, {129,0.00003960}, {130,0.00000000}, {131,0.00003960}, {132,0.00002970}, {133,0.00011881}, {134,0.00003960}, {135,0.00003960}, {136,0.00007921}, {137,0.00000000}, {138,0.00006931}, {139,0.00000000}, {140,0.00003960}, {141,0.00002970}, {142,0.00007921}, {143,0.00000000}, {144,0.00010891}, {145,0.00000000}, {146,0.00000000}, {147,0.00007921}, {148,0.00003960}, {149,0.00003960}, {150,0.00003960}, {151,0.00000000}, {152,0.00002970}, {153,0.00000000}, {154,0.00003960}, {155,0.00011881}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00003960}, {160,0.00000000}, {161,0.00000000}, {162,0.00003960}, {163,0.00010891}, {164,0.00000000}, {165,0.00000000}, {166,0.00006931}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00003960}, {171,0.00000000}, {172,0.00003960}, {173,0.00003960}, {174,0.00000000}, {175,0.00000000}, {176,0.00003960}, {177,0.00000000}, {178,0.00002970}, {179,0.00002970}, {180,0.00003960}, {181,0.00000000}, {182,0.00003960}, {183,0.00000000}, {184,0.00006931}, {185,0.00000000}, {186,0.00003960}, {187,0.00003960}, {188,0.00000000}, {189,0.00003960}, {190,0.00000000}, {191,0.00006931}, {192,0.00000000}, {193,0.00007921}, {194,0.00003960}, {195,0.00000000}, {196,0.00003960}, {197,0.00003960}, {198,0.00003960}, {199,0.00003960}, {200,0.00003960}, {201,0.00003960}, {202,0.00007921}, {203,0.00003960}, {204,0.00007921}, {205,0.00003960}, {206,0.00007921}, {207,0.00003960}, {208,0.00003960}, {209,0.00000000}, {210,0.00000000}, {211,0.00003960}, {212,0.00003960}, {213,0.00011881}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00006931}, {218,0.00000000}, {219,0.00003960}, {220,0.00000000}, {221,0.00003960}, {222,0.00000000}, {223,0.00003960}, {224,0.00003960}, {225,0.00002970}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00014851}, {230,0.00007921}, {231,0.00007921}, {232,0.00000000}, {233,0.00003960}, {234,0.00000000}, {235,0.00003960}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00007921}, {242,0.00000000}, {243,0.00003960}, {244,0.00000000}, {245,0.00003960}, {246,0.00002970}, {247,0.00002970}, {248,0.00003960}, {249,0.00003960}, {250,0.00003960}, {251,0.00003960}, {252,0.00003960}, {253,0.00002970}, {254,0.00006931}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00006931}, {259,0.00003960}, {260,0.00000000}, {261,0.00000000}, {262,0.00006931}, {263,0.00000000}, {264,0.00005941}, {265,0.00003960}, {266,0.00003960}, {267,0.00002970}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00003960}, {272,0.00003960}, {273,0.00003960}, {274,0.00003960}, {275,0.00000000}, {276,0.00014851}, {277,0.00016832}, {278,0.00002970}, {279,0.00000000}, {280,0.00000000}, {281,0.00002970}, {282,0.00002970}, {283,0.00003960}, {284,0.00002970}, {285,0.00003960}, {286,0.00000000}, {287,0.00006931}, {288,0.00000000}, {289,0.00002970}, {290,0.00002970}, {291,0.00010891}, {292,0.00000000}, {293,0.00009901}, {294,0.00003960}, {295,0.00000000}, {296,0.00000000}, {297,0.00002970}, {298,0.00000000}, {299,0.00000000}, {300,0.00009901}, {301,0.0000857}, {302,0.0002286}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000857}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000857}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000857}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0002000}, {330,0.0000857}, {331,0.0001143}, {332,0.0000000}, {333,0.0000857}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000857}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000857}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000857}, {362,0.0000000}, {363,0.0000857}, {364,0.0000857}, {365,0.0000857}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000857}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000857}, {375,0.0000000}, {376,0.0000000}, {377,0.0000857}, {378,0.0000857}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000857}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000857}, {393,0.0000857}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0001714}, {404,0.0001143}, {405,0.0001143}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000857}, {410,0.0000857}, {411,0.0000000}, {412,0.0000857}, {413,0.0000000}, {414,0.0001143}, {415,0.0000857}, {416,0.0000000}, {417,0.0000000}, {418,0.0000857}, {419,0.0000000}, {420,0.0000000}, {421,0.0001143}, {422,0.0000857}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000857}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000857}, {432,0.0000857}, {433,0.0000000}, {434,0.0000000}, {435,0.0000857}, {436,0.0000000}, {437,0.0001714}, {438,0.0000000}, {439,0.0000857}, {440,0.0000000}, {441,0.0000857}, {442,0.0001143}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000857}, {447,0.0001714}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000857}, {456,0.0000000}, {457,0.0000000}, {458,0.0000857}, {459,0.0000000}, {460,0.0000000}, {461,0.0000857}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000857}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000857}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000857}, {475,0.0000857}, {476,0.0000000}, {477,0.0000000}, {478,0.0000857}, {479,0.0000857}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000857}, {488,0.0001714}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000857}, {493,0.0000857}, {494,0.0000000}, {495,0.0000000}, {496,0.0000857}, {497,0.0000857}, {498,0.0001143}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000857}, {515,0.0000857}, {520,0.0000000}, {525,0.0000857}, {530,0.0000000}, {535,0.0000857}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000857}, {620,0.0000000}, {625,0.0000857}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000857}, {660,0.0000000}, {665,0.0000857}, {670,0.0000000}, {675,0.0000857}, {680,0.0001714}, {685,0.0000000}, {690,0.0000000}, {695,0.0000857}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0001143}, {765,0.0000000}, {770,0.0000000}, {775,0.0000857}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000857}, {850,0.0000000}, {855,0.0001714}, {860,0.0000000}, {865,0.0000857}, {870,0.0000000}, {875,0.0000857}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000857}, {930,0.0000000}, {935,0.0000857}, {940,0.0000857}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000857}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000857}, {1000,0.0001143}, {1010,0.0001143}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000857}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000857}, {1130,0.0000000}, {1140,0.0002857}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000857}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0001143}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0001714}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0001143}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0001143}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000857}, {1480,0.0000857}, {1490,0.0000000}, {1500,0.0000857}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000857}, {1580,0.0000000}, {1590,0.0001143}, {1600,0.0000857}, {1610,0.0000000}, {1620,0.0001143}, {1630,0.0000000}, {1640,0.0002286}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0002000}, {1690,0.0001143}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0001143}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0001143}, {1850,0.0000000}, {1860,0.0001143}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0001143}, {1900,0.0002286}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0001143}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermExplicitCtx"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00003960}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00003960}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0001143}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0001143}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0001143}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermExplicitCtx"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermExplicitCtx"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00003960}, {6,0.00002970}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00003960}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00002970}, {76,0.00003960}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00002970}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00003960}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00003960}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00007921}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00003960}, {143,0.00000000}, {144,0.00003960}, {145,0.00000000}, {146,0.00003960}, {147,0.00003960}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00003960}, {152,0.00003960}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00003960}, {165,0.00002970}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00003960}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00002970}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00003960}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00003960}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00003960}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00003960}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00006931}, {258,0.00000000}, {259,0.00000000}, {260,0.00002970}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003960}, {266,0.00000000}, {267,0.00000000}, {268,0.00003960}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00003960}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00003960}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00002970}, {298,0.00003960}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000857}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000857}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0001143}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0001143}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0001143}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000857}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000857}, {425,0.0000857}, {426,0.0000857}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000857}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000857}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000857}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000857}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000857}, {705,0.0000000}, {710,0.0000000}, {715,0.0000857}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000857}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000857}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0002000}, {1080,0.0000000}, {1090,0.0000857}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000857}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0001143}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000857}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000857}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0001143}};
data["big"]["LtacTacInTermExplicitCtx"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermExplicitCtx"]["reif"]["real"] = {{1,0.00000000}, {2,0.00100000}, {3,0.00100000}, {4,0.00116832}, {5,0.00201980}, {6,0.00202970}, {7,0.00300000}, {8,0.00300000}, {9,0.00387129}, {10,0.00400000}, {11,0.00450495}, {12,0.00636634}, {13,0.00557426}, {14,0.00605941}, {15,0.00677228}, {16,0.00721782}, {17,0.00963366}, {18,0.00830693}, {19,0.00904950}, {20,0.00984158}, {21,0.01274257}, {22,0.01099010}, {23,0.01156436}, {24,0.01224752}, {25,0.01299010}, {26,0.01361386}, {27,0.01413861}, {28,0.01499010}, {29,0.01578218}, {30,0.01634653}, {31,0.01841584}, {32,0.01794059}, {33,0.01872277}, {34,0.01925743}, {35,0.02023762}, {36,0.02106931}, {37,0.02188119}, {38,0.02279208}, {39,0.02749505}, {40,0.02670297}, {41,0.02512871}, {42,0.02617822}, {43,0.02703960}, {44,0.03707921}, {45,0.02898020}, {46,0.02984158}, {47,0.03783168}, {48,0.03150495}, {49,0.03801980}, {50,0.03390099}, {51,0.04224752}, {52,0.03568317}, {53,0.03665347}, {54,0.03769307}, {55,0.03878218}, {56,0.03969307}, {57,0.04462376}, {58,0.05245545}, {59,0.04301980}, {60,0.04418812}, {61,0.04525743}, {62,0.04645545}, {63,0.04764356}, {64,0.05615842}, {65,0.05867327}, {66,0.05402970}, {67,0.05221782}, {68,0.05346535}, {69,0.06731683}, {70,0.05588119}, {71,0.06358416}, {72,0.05803960}, {73,0.06625743}, {74,0.06089109}, {75,0.08383168}, {76,0.06324752}, {77,0.06473267}, {78,0.07701980}, {79,0.08946535}, {80,0.08256436}, {81,0.08370297}, {82,0.07163366}, {83,0.08657426}, {84,0.11805941}, {85,0.07530693}, {86,0.07685149}, {87,0.07856436}, {88,0.07989109}, {89,0.08150495}, {90,0.08304950}, {91,0.08466337}, {92,0.08551485}, {93,0.08754455}, {94,0.08912871}, {95,0.08982178}, {96,0.09168317}, {97,0.09389109}, {98,0.09450495}, {99,0.09664356}, {100,0.09869307}, {101,0.10030693}, {102,0.10186139}, {103,0.11581188}, {104,0.11798020}, {105,0.11926733}, {106,0.12199010}, {107,0.12328713}, {108,0.12585149}, {109,0.12869307}, {110,0.13217822}, {111,0.13361386}, {112,0.13701980}, {113,0.14027723}, {114,0.14370297}, {115,0.14570297}, {116,0.14978218}, {117,0.15413861}, {118,0.15522772}, {119,0.15845545}, {120,0.16006931}, {121,0.16293069}, {122,0.16349505}, {123,0.16456436}, {124,0.16627723}, {125,0.17001980}, {126,0.17213861}, {127,0.17496040}, {128,0.18043564}, {129,0.18067327}, {130,0.18581188}, {131,0.18688119}, {132,0.18917822}, {133,0.19116832}, {134,0.19312871}, {135,0.19608911}, {136,0.19857426}, {137,0.20260396}, {138,0.20472277}, {139,0.20772277}, {140,0.21045545}, {141,0.21048515}, {142,0.21652475}, {143,0.21702970}, {144,0.22168317}, {145,0.22510891}, {146,0.22605941}, {147,0.23004950}, {148,0.23348515}, {149,0.23354455}, {150,0.23662376}, {151,0.23842574}, {152,0.24123762}, {153,0.24399010}, {154,0.24686139}, {155,0.24935644}, {156,0.25360396}, {157,0.25419802}, {158,0.25872277}, {159,0.25902970}, {160,0.26240594}, {161,0.26498020}, {162,0.26944554}, {163,0.27063366}, {164,0.27324752}, {165,0.27438614}, {166,0.28055446}, {167,0.28351485}, {168,0.28756436}, {169,0.29383168}, {170,0.29475248}, {171,0.29548515}, {172,0.29686139}, {173,0.30045545}, {174,0.30590099}, {175,0.31038614}, {176,0.31435644}, {177,0.31520792}, {178,0.31657426}, {179,0.32109901}, {180,0.32472277}, {181,0.32633663}, {182,0.33097030}, {183,0.33201980}, {184,0.33531683}, {185,0.33853465}, {186,0.34157426}, {187,0.34375248}, {188,0.34736634}, {189,0.35117822}, {190,0.35669307}, {191,0.35677228}, {192,0.36477228}, {193,0.37171287}, {194,0.37039604}, {195,0.36978218}, {196,0.37327723}, {197,0.37684158}, {198,0.37978218}, {199,0.38247525}, {200,0.38977228}, {201,0.40043564}, {202,0.39548515}, {203,0.39137624}, {204,0.40026733}, {205,0.40180198}, {206,0.41337624}, {207,0.42165347}, {208,0.41044554}, {209,0.41582178}, {210,0.41966337}, {211,0.43930693}, {212,0.43404950}, {213,0.43075248}, {214,0.43235644}, {215,0.45114851}, {216,0.44635644}, {217,0.44563366}, {218,0.46467327}, {219,0.45825743}, {220,0.45843564}, {221,0.47074257}, {222,0.47132673}, {223,0.47244554}, {224,0.48601980}, {225,0.48059406}, {226,0.48786139}, {227,0.48722772}, {228,0.49291089}, {229,0.50413861}, {230,0.50119802}, {231,0.51538614}, {232,0.50671287}, {233,0.52529703}, {234,0.51544554}, {235,0.53340594}, {236,0.52209901}, {237,0.53445545}, {238,0.53408911}, {239,0.53316832}, {240,0.54626733}, {241,0.54100000}, {242,0.55671287}, {243,0.55670297}, {244,0.56026733}, {245,0.56580198}, {246,0.61009901}, {247,0.56973267}, {248,0.57987129}, {249,0.57907921}, {250,0.58474257}, {251,0.60919802}, {252,0.59117822}, {253,0.59133663}, {254,0.60132673}, {255,0.60953465}, {256,0.62311881}, {257,0.74501980}, {258,0.62960396}, {259,0.63215842}, {260,0.63294059}, {261,0.63971287}, {262,0.64423762}, {263,0.64577228}, {264,0.65802970}, {265,0.65695050}, {266,0.72744554}, {267,0.66207921}, {268,0.66598020}, {269,0.67376238}, {270,0.67538614}, {271,0.69117822}, {272,0.68903960}, {273,0.75302970}, {274,0.69774257}, {275,0.70531683}, {276,0.70655446}, {277,0.70795050}, {278,0.71001980}, {279,0.72203960}, {280,0.76259406}, {281,0.72709901}, {282,0.73341584}, {283,0.73671287}, {284,0.74100000}, {285,0.74557426}, {286,0.74780198}, {287,0.75479208}, {288,0.76088119}, {289,0.76962376}, {290,0.77225743}, {291,0.78020792}, {292,0.80072277}, {293,0.79153465}, {294,0.80071287}, {295,0.81361386}, {296,0.81363366}, {297,0.81864356}, {298,0.82567327}, {299,0.84546535}, {300,0.84088119}, {301,1.0329143}, {302,0.9630286}, {303,0.9532286}, {304,0.9269143}, {305,0.9003714}, {306,0.9100286}, {307,0.9328286}, {308,0.9238571}, {309,0.9254857}, {310,0.9364857}, {311,0.9474000}, {312,0.9469143}, {313,0.9570000}, {314,0.9599429}, {315,0.9642286}, {316,0.9670000}, {317,0.9760571}, {318,0.9825714}, {319,0.9909143}, {320,0.9945429}, {321,0.9884286}, {322,1.0091714}, {323,1.0013429}, {324,1.0122571}, {325,1.0100000}, {326,1.0238857}, {327,1.0274286}, {328,1.0328571}, {329,1.0360286}, {330,1.0422857}, {331,1.0662286}, {332,1.0467429}, {333,1.0581714}, {334,1.0548000}, {335,1.0699143}, {336,1.0986000}, {337,1.0715143}, {338,1.0848571}, {339,1.0839714}, {340,1.0976286}, {341,1.1088286}, {342,1.1151143}, {343,1.1264000}, {344,1.1340000}, {345,1.1367714}, {346,1.1392286}, {347,1.1484000}, {348,1.1501429}, {349,1.1592000}, {350,1.1679429}, {351,1.1836571}, {352,1.1796286}, {353,1.1900857}, {354,1.1920000}, {355,1.1929143}, {356,1.2092857}, {357,1.2169714}, {358,1.2154286}, {359,1.2297714}, {360,1.2304857}, {361,1.2298286}, {362,1.2453143}, {363,1.2584286}, {364,1.2602571}, {365,1.2918286}, {366,1.2715714}, {367,1.2811714}, {368,1.2786286}, {369,1.2958000}, {370,1.2993714}, {371,1.3065143}, {372,1.3367429}, {373,1.3112286}, {374,1.3351429}, {375,1.3447143}, {376,1.3361714}, {377,1.3500000}, {378,1.3618000}, {379,1.3604857}, {380,1.3670286}, {381,1.3912000}, {382,1.3930286}, {383,1.4074857}, {384,1.4116000}, {385,1.4244000}, {386,1.4324857}, {387,1.4469143}, {388,1.4455143}, {389,1.4586000}, {390,1.4614286}, {391,1.4727429}, {392,1.4795429}, {393,1.5152286}, {394,1.4940857}, {395,1.5042857}, {396,1.5113429}, {397,1.5136857}, {398,1.5512286}, {399,1.5311429}, {400,1.5674571}, {401,1.5808571}, {402,1.5862000}, {403,1.5754571}, {404,1.5917143}, {405,1.6115143}, {406,1.5930286}, {407,1.6040286}, {408,1.6037143}, {409,1.6227143}, {410,1.6562571}, {411,1.6235714}, {412,1.6276857}, {413,1.6383143}, {414,1.6507143}, {415,1.6527143}, {416,1.6616571}, {417,1.6704857}, {418,1.6719714}, {419,1.6796000}, {420,1.6986286}, {421,1.7260571}, {422,1.7066286}, {423,1.7471714}, {424,1.7374286}, {425,1.7534571}, {426,1.7729143}, {427,1.8054571}, {428,1.7976286}, {429,1.7873714}, {430,1.8253429}, {431,1.8206286}, {432,1.8168000}, {433,1.8238571}, {434,1.8385143}, {435,1.8728286}, {436,1.8390571}, {437,1.8650286}, {438,1.8819143}, {439,1.8912286}, {440,1.8933714}, {441,1.9048571}, {442,1.9161143}, {443,1.9173143}, {444,1.9424286}, {445,1.9521143}, {446,1.9301429}, {447,1.9486000}, {448,1.9543714}, {449,1.9630857}, {450,2.0219714}, {451,2.0017143}, {452,1.9853143}, {453,2.0424000}, {454,2.0310000}, {455,2.0367429}, {456,2.0530286}, {457,2.0651143}, {458,2.0441429}, {459,2.0913429}, {460,2.0663143}, {461,2.0994286}, {462,2.1088286}, {463,2.1806857}, {464,2.1781714}, {465,2.1009429}, {466,2.1719714}, {467,2.1596286}, {468,2.1637714}, {469,2.1482857}, {470,2.1848286}, {471,2.1633714}, {472,2.1737143}, {473,2.1778000}, {474,2.1844857}, {475,2.1860857}, {476,2.2063429}, {477,2.2160000}, {478,2.2242571}, {479,2.2322286}, {480,2.2498286}, {481,2.2620000}, {482,2.2840857}, {483,2.3242000}, {484,2.2940571}, {485,2.3152857}, {486,2.3142000}, {487,2.3202571}, {488,2.3280857}, {489,2.3315143}, {490,2.3474000}, {491,2.3477429}, {492,2.3539714}, {493,2.3787143}, {494,2.3898571}, {495,2.3958286}, {496,2.4176286}, {497,2.4314286}, {498,2.4384571}, {499,2.4407143}, {500,2.4417429}, {505,2.4932286}, {510,2.5463714}, {515,2.5875714}, {520,2.6656571}, {525,2.7430000}, {530,2.7366000}, {535,2.8362571}, {540,2.9147143}, {545,3.0893429}, {550,3.1011143}, {555,3.1465714}, {560,3.2021429}, {565,3.3246286}, {570,3.3472857}, {575,3.4310571}, {580,3.4264000}, {585,3.5996000}, {590,3.6240857}, {595,3.5529714}, {600,3.6488286}, {605,3.7310286}, {610,3.7566286}, {615,3.8130857}, {620,3.8606286}, {625,3.9301714}, {630,3.9913429}, {635,4.0297714}, {640,4.0688571}, {645,4.1221429}, {650,4.2258000}, {655,4.3183714}, {660,4.2896286}, {665,4.3776571}, {670,4.4869714}, {675,4.5544000}, {680,4.5676286}, {685,4.6455429}, {690,4.7237714}, {695,4.8063143}, {700,4.9014571}, {705,4.9897143}, {710,5.0266000}, {715,5.1373714}, {720,5.1812286}, {725,5.2978286}, {730,5.3580286}, {735,5.4613429}, {740,5.5138286}, {745,5.6202857}, {750,5.7412000}, {755,5.8597429}, {760,5.9372857}, {765,6.0281714}, {770,6.0909714}, {775,6.2231143}, {780,6.2882286}, {785,6.3747143}, {790,6.4868000}, {795,6.5875429}, {800,6.6667143}, {805,6.7868286}, {810,6.8493714}, {815,6.9736857}, {820,7.0938857}, {825,7.1619714}, {830,7.2499429}, {835,7.3454857}, {840,7.4035714}, {845,7.5268571}, {850,7.7613714}, {855,7.8254857}, {860,7.9569429}, {865,8.0602286}, {870,8.3163714}, {875,8.4368857}, {880,8.6047429}, {885,8.6008000}, {890,8.7999714}, {895,8.9249714}, {900,8.8507714}, {905,9.2198286}, {910,9.2959143}, {915,9.3917143}, {920,9.5025143}, {925,9.8524857}, {930,10.0108571}, {935,10.0672000}, {940,9.9558857}, {945,10.0842857}, {950,9.9690286}, {955,10.4284571}, {960,10.3146000}, {965,10.3910857}, {970,10.6892857}, {975,10.8923429}, {980,11.0288000}, {985,11.0664857}, {990,11.4281714}, {995,11.1108571}, {1000,11.3969429}, {1010,11.6354857}, {1020,11.8256000}, {1030,12.4785429}, {1040,12.7510857}, {1050,12.9131714}, {1060,13.4656286}, {1070,13.7095429}, {1080,14.3059429}, {1090,14.3723143}, {1100,14.9316000}, {1110,15.0751429}, {1120,15.6340286}, {1130,15.4384286}, {1140,15.8509143}, {1150,16.6736571}, {1160,16.7603714}, {1170,17.1448857}, {1180,17.7280000}, {1190,17.8739429}, {1200,18.2582857}, {1210,18.3684000}, {1220,19.2556571}, {1230,19.2920286}, {1240,19.7618286}, {1250,20.4216857}, {1260,20.3445143}, {1270,21.1667714}, {1280,21.5264000}, {1290,22.3335143}, {1300,22.4117143}, {1310,22.8145143}, {1320,22.9798000}, {1330,23.6203429}, {1340,23.1911429}, {1350,23.6832000}, {1360,24.9329429}, {1370,25.2270000}, {1380,25.4973429}, {1390,26.0364000}, {1400,26.3210857}, {1410,26.4238286}, {1420,27.4444286}, {1430,27.8108286}, {1440,27.9854571}, {1450,28.4194286}, {1460,29.3546857}, {1470,29.3847714}, {1480,29.7689143}, {1490,30.4185714}, {1500,30.8335143}, {1510,31.5244857}, {1520,31.8959714}, {1530,33.0060286}, {1540,33.7038571}, {1550,33.7234000}, {1560,34.6530571}, {1570,34.9779429}, {1580,36.0586286}, {1590,35.5032857}, {1600,37.2437714}, {1610,37.2962571}, {1620,37.4523429}, {1630,38.2880286}, {1640,38.6878000}, {1650,39.3743429}, {1660,40.3843429}, {1670,41.0096000}, {1680,41.6318286}, {1690,42.0702571}, {1700,43.2676286}, {1710,42.8863429}, {1720,44.4640000}, {1730,44.7130000}, {1740,45.1466286}, {1750,45.7559714}, {1760,46.5303429}, {1770,47.6241714}, {1780,48.1126857}, {1790,48.4952571}, {1800,48.5426857}, {1810,49.5860000}, {1820,50.2690286}, {1830,50.9866857}, {1840,52.7330571}, {1850,52.8429143}, {1860,53.2309143}, {1870,54.2672857}, {1880,54.9423429}, {1890,55.6081429}, {1900,56.7175143}, {1910,57.1202857}, {1920,58.7174571}, {1930,58.6409714}, {1940,59.1937714}, {1950,61.0728000}, {1960,59.9518571}, {1970,61.6268857}, {1980,62.1700571}, {1990,63.2672571}, {2000,64.1434571}};
data["big"]["LtacTacInTermExplicitCtx"]["reif"]["user"] = {{1,0.00072277}, {2,0.00106931}, {3,0.00133663}, {4,0.00223762}, {5,0.00217822}, {6,0.00286139}, {7,0.00344554}, {8,0.00342574}, {9,0.00382178}, {10,0.00441584}, {11,0.00450495}, {12,0.00650495}, {13,0.00587129}, {14,0.00612871}, {15,0.00665347}, {16,0.00740594}, {17,0.00986139}, {18,0.00829703}, {19,0.00905941}, {20,0.00966337}, {21,0.01276238}, {22,0.01094059}, {23,0.01126733}, {24,0.01183168}, {25,0.01266337}, {26,0.01361386}, {27,0.01403960}, {28,0.01487129}, {29,0.01550495}, {30,0.01618812}, {31,0.01800000}, {32,0.01742574}, {33,0.01829703}, {34,0.01910891}, {35,0.01989109}, {36,0.02100000}, {37,0.02208911}, {38,0.02282178}, {39,0.02792079}, {40,0.02685149}, {41,0.02528713}, {42,0.02637624}, {43,0.02724752}, {44,0.03717822}, {45,0.02882178}, {46,0.02993069}, {47,0.03757426}, {48,0.03166337}, {49,0.03774257}, {50,0.03418812}, {51,0.04184158}, {52,0.03552475}, {53,0.03659406}, {54,0.03748515}, {55,0.03840594}, {56,0.03927723}, {57,0.04407921}, {58,0.05242574}, {59,0.04273267}, {60,0.04374257}, {61,0.04473267}, {62,0.04630693}, {63,0.04776238}, {64,0.05623762}, {65,0.05832673}, {66,0.05398020}, {67,0.05228713}, {68,0.05364356}, {69,0.06709901}, {70,0.05563366}, {71,0.06324752}, {72,0.05750495}, {73,0.06569307}, {74,0.06055446}, {75,0.08408911}, {76,0.06323762}, {77,0.06434653}, {78,0.07689109}, {79,0.08919802}, {80,0.08234653}, {81,0.08345545}, {82,0.07184158}, {83,0.08643564}, {84,0.11772277}, {85,0.07505941}, {86,0.07690099}, {87,0.07848515}, {88,0.07972277}, {89,0.08119802}, {90,0.08299010}, {91,0.08454455}, {92,0.08493069}, {93,0.08709901}, {94,0.08857426}, {95,0.08947525}, {96,0.09111881}, {97,0.09400000}, {98,0.09432673}, {99,0.09699010}, {100,0.09865347}, {101,0.10029703}, {102,0.10158416}, {103,0.11529703}, {104,0.11788119}, {105,0.11895050}, {106,0.12172277}, {107,0.12333663}, {108,0.12557426}, {109,0.12853465}, {110,0.13173267}, {111,0.13307921}, {112,0.13669307}, {113,0.14005941}, {114,0.14349505}, {115,0.14523762}, {116,0.14945545}, {117,0.15387129}, {118,0.15490099}, {119,0.15809901}, {120,0.15971287}, {121,0.16250495}, {122,0.16290099}, {123,0.16403960}, {124,0.16564356}, {125,0.16973267}, {126,0.17153465}, {127,0.17456436}, {128,0.18000000}, {129,0.18003960}, {130,0.18534653}, {131,0.18648515}, {132,0.18866337}, {133,0.19107921}, {134,0.19260396}, {135,0.19576238}, {136,0.19803960}, {137,0.20197030}, {138,0.20409901}, {139,0.20709901}, {140,0.20991089}, {141,0.21008911}, {142,0.21569307}, {143,0.21629703}, {144,0.22102970}, {145,0.22443564}, {146,0.22566337}, {147,0.22939604}, {148,0.23264356}, {149,0.23298020}, {150,0.23572277}, {151,0.23778218}, {152,0.24026733}, {153,0.24349505}, {154,0.24609901}, {155,0.24862376}, {156,0.25280198}, {157,0.25317822}, {158,0.25795050}, {159,0.25801980}, {160,0.26189109}, {161,0.26430693}, {162,0.26857426}, {163,0.27004950}, {164,0.27299010}, {165,0.27353465}, {166,0.27964356}, {167,0.28292079}, {168,0.28691089}, {169,0.29309901}, {170,0.29403960}, {171,0.29450495}, {172,0.29605941}, {173,0.29986139}, {174,0.30518812}, {175,0.30948515}, {176,0.31349505}, {177,0.31459406}, {178,0.31574257}, {179,0.32018812}, {180,0.32381188}, {181,0.32534653}, {182,0.33006931}, {183,0.33136634}, {184,0.33464356}, {185,0.33806931}, {186,0.34062376}, {187,0.34279208}, {188,0.34628713}, {189,0.35026733}, {190,0.35592079}, {191,0.35576238}, {192,0.36405941}, {193,0.37062376}, {194,0.36965347}, {195,0.36906931}, {196,0.37271287}, {197,0.37574257}, {198,0.37920792}, {199,0.38160396}, {200,0.38896040}, {201,0.39969307}, {202,0.39456436}, {203,0.39010891}, {204,0.39942574}, {205,0.40084158}, {206,0.41231683}, {207,0.42084158}, {208,0.40967327}, {209,0.41497030}, {210,0.41839604}, {211,0.43842574}, {212,0.43297030}, {213,0.42995050}, {214,0.43128713}, {215,0.45031683}, {216,0.44549505}, {217,0.44475248}, {218,0.46392079}, {219,0.45762376}, {220,0.45770297}, {221,0.47004950}, {222,0.47041584}, {223,0.47099010}, {224,0.48495050}, {225,0.47950495}, {226,0.48672277}, {227,0.48615842}, {228,0.49210891}, {229,0.50321782}, {230,0.50057426}, {231,0.51421782}, {232,0.50572277}, {233,0.52434653}, {234,0.51400990}, {235,0.53229703}, {236,0.52100000}, {237,0.53361386}, {238,0.53258416}, {239,0.53203960}, {240,0.54503960}, {241,0.53973267}, {242,0.55552475}, {243,0.55590099}, {244,0.55873267}, {245,0.56494059}, {246,0.60855446}, {247,0.56872277}, {248,0.57876238}, {249,0.57777228}, {250,0.58319802}, {251,0.60760396}, {252,0.58981188}, {253,0.58978218}, {254,0.60000000}, {255,0.60828713}, {256,0.62169307}, {257,0.74339604}, {258,0.62819802}, {259,0.63091089}, {260,0.63176238}, {261,0.63864356}, {262,0.64286139}, {263,0.64463366}, {264,0.65665347}, {265,0.65578218}, {266,0.72625743}, {267,0.66093069}, {268,0.66447525}, {269,0.67209901}, {270,0.67416832}, {271,0.68970297}, {272,0.68764356}, {273,0.75135644}, {274,0.69647525}, {275,0.70403960}, {276,0.70544554}, {277,0.70677228}, {278,0.70824752}, {279,0.72101980}, {280,0.76129703}, {281,0.72589109}, {282,0.73212871}, {283,0.73548515}, {284,0.73933663}, {285,0.74400000}, {286,0.74634653}, {287,0.75329703}, {288,0.75934653}, {289,0.76794059}, {290,0.77076238}, {291,0.77882178}, {292,0.79936634}, {293,0.79032673}, {294,0.79876238}, {295,0.81198020}, {296,0.81174257}, {297,0.81701980}, {298,0.82396040}, {299,0.84395050}, {300,0.83919802}, {301,1.0280857}, {302,0.9610286}, {303,0.9524286}, {304,0.9257143}, {305,0.8989143}, {306,0.9086857}, {307,0.9274286}, {308,0.9226571}, {309,0.9244571}, {310,0.9356286}, {311,0.9458571}, {312,0.9454571}, {313,0.9556286}, {314,0.9591143}, {315,0.9636286}, {316,0.9656286}, {317,0.9753429}, {318,0.9816286}, {319,0.9861143}, {320,0.9934571}, {321,0.9869714}, {322,1.0001714}, {323,1.0006857}, {324,1.0074857}, {325,1.0093429}, {326,1.0221714}, {327,1.0240286}, {328,1.0308000}, {329,1.0351429}, {330,1.0392571}, {331,1.0545143}, {332,1.0450571}, {333,1.0552286}, {334,1.0518571}, {335,1.0674857}, {336,1.0967429}, {337,1.0701143}, {338,1.0838286}, {339,1.0821714}, {340,1.0965714}, {341,1.1068571}, {342,1.1135429}, {343,1.1254571}, {344,1.1322571}, {345,1.1354000}, {346,1.1384000}, {347,1.1476857}, {348,1.1494000}, {349,1.1575143}, {350,1.1668000}, {351,1.1831429}, {352,1.1782571}, {353,1.1892857}, {354,1.1909429}, {355,1.1914000}, {356,1.2082286}, {357,1.2157714}, {358,1.2138857}, {359,1.2286857}, {360,1.2283429}, {361,1.2285143}, {362,1.2439143}, {363,1.2567714}, {364,1.2581429}, {365,1.2896571}, {366,1.2699143}, {367,1.2791143}, {368,1.2770286}, {369,1.2942571}, {370,1.2976286}, {371,1.3046286}, {372,1.3344000}, {373,1.3098000}, {374,1.3336857}, {375,1.3433143}, {376,1.3348857}, {377,1.3477714}, {378,1.3595429}, {379,1.3580571}, {380,1.3648000}, {381,1.3881429}, {382,1.3904571}, {383,1.4048286}, {384,1.4084000}, {385,1.4214857}, {386,1.4302286}, {387,1.4446857}, {388,1.4435714}, {389,1.4567143}, {390,1.4582000}, {391,1.4705714}, {392,1.4771143}, {393,1.5126000}, {394,1.4918000}, {395,1.5024000}, {396,1.5097714}, {397,1.5117143}, {398,1.5487143}, {399,1.5292857}, {400,1.5649143}, {401,1.5786286}, {402,1.5840000}, {403,1.5686571}, {404,1.5792857}, {405,1.6072286}, {406,1.5862000}, {407,1.6016857}, {408,1.6000286}, {409,1.6138857}, {410,1.6524857}, {411,1.6204857}, {412,1.6246000}, {413,1.6355714}, {414,1.6473429}, {415,1.6502286}, {416,1.6585143}, {417,1.6673429}, {418,1.6693143}, {419,1.6765143}, {420,1.6958571}, {421,1.7231714}, {422,1.7039429}, {423,1.7443429}, {424,1.7350000}, {425,1.7503429}, {426,1.7701714}, {427,1.8011429}, {428,1.7943143}, {429,1.7837143}, {430,1.8205714}, {431,1.8161143}, {432,1.8130286}, {433,1.8196571}, {434,1.8349429}, {435,1.8686000}, {436,1.8350286}, {437,1.8611429}, {438,1.8781429}, {439,1.8869143}, {440,1.8888857}, {441,1.9002857}, {442,1.9120000}, {443,1.9136000}, {444,1.9385143}, {445,1.9474857}, {446,1.9260286}, {447,1.9444286}, {448,1.9506000}, {449,1.9597143}, {450,2.0178857}, {451,1.9981429}, {452,1.9822571}, {453,2.0383429}, {454,2.0268000}, {455,2.0330286}, {456,2.0492286}, {457,2.0612286}, {458,2.0404000}, {459,2.0880000}, {460,2.0627429}, {461,2.0965429}, {462,2.1054286}, {463,2.1780000}, {464,2.1745714}, {465,2.0972000}, {466,2.1688857}, {467,2.1568000}, {468,2.1610286}, {469,2.1453143}, {470,2.1810000}, {471,2.1595143}, {472,2.1696571}, {473,2.1730857}, {474,2.1795714}, {475,2.1816286}, {476,2.2018286}, {477,2.2118000}, {478,2.2197143}, {479,2.2275143}, {480,2.2449429}, {481,2.2570286}, {482,2.2784000}, {483,2.3174000}, {484,2.2874286}, {485,2.3091714}, {486,2.3083143}, {487,2.3138571}, {488,2.3221429}, {489,2.3268857}, {490,2.3417143}, {491,2.3418571}, {492,2.3485429}, {493,2.3735143}, {494,2.3836571}, {495,2.3901429}, {496,2.4122857}, {497,2.4264000}, {498,2.4323143}, {499,2.4361429}, {500,2.4362857}, {505,2.4882857}, {510,2.5394000}, {515,2.5810857}, {520,2.6582857}, {525,2.7354857}, {530,2.7288571}, {535,2.8268857}, {540,2.9064000}, {545,3.0799143}, {550,3.0911429}, {555,3.1378571}, {560,3.1926000}, {565,3.3163714}, {570,3.3397429}, {575,3.4208000}, {580,3.4167714}, {585,3.5910000}, {590,3.6161143}, {595,3.5440857}, {600,3.6400000}, {605,3.7234857}, {610,3.7488857}, {615,3.8049429}, {620,3.8512857}, {625,3.9211143}, {630,3.9822000}, {635,4.0202286}, {640,4.0611429}, {645,4.1153714}, {650,4.2195143}, {655,4.3134571}, {660,4.2846571}, {665,4.3713143}, {670,4.4814571}, {675,4.5481143}, {680,4.5592571}, {685,4.6380571}, {690,4.7163143}, {695,4.7974571}, {700,4.8923714}, {705,4.9823429}, {710,5.0166571}, {715,5.1270000}, {720,5.1681714}, {725,5.2866286}, {730,5.3470857}, {735,5.4513714}, {740,5.5027429}, {745,5.6105714}, {750,5.7280857}, {755,5.8461714}, {760,5.9260286}, {765,6.0141429}, {770,6.0770000}, {775,6.2098000}, {780,6.2752857}, {785,6.3604000}, {790,6.4650286}, {795,6.5641143}, {800,6.6411429}, {805,6.7495143}, {810,6.8308000}, {815,6.9528857}, {820,7.0750571}, {825,7.1434000}, {830,7.2314000}, {835,7.3282571}, {840,7.3806857}, {845,7.5071714}, {850,7.7428286}, {855,7.8055714}, {860,7.9341429}, {865,8.0431714}, {870,8.2993714}, {875,8.4210286}, {880,8.5868571}, {885,8.5926571}, {890,8.7831143}, {895,8.9102286}, {900,8.8384857}, {905,9.2000286}, {910,9.2720000}, {915,9.3707714}, {920,9.4826000}, {925,9.8332857}, {930,9.9868857}, {935,10.0383429}, {940,9.9348571}, {945,10.0628286}, {950,9.9544857}, {955,10.4098571}, {960,10.2959429}, {965,10.3620857}, {970,10.6585143}, {975,10.8649429}, {980,10.9980000}, {985,11.0358286}, {990,11.3888000}, {995,11.0785143}, {1000,11.3586000}, {1010,11.6009143}, {1020,11.7922000}, {1030,12.4468000}, {1040,12.7232571}, {1050,12.8866286}, {1060,13.4422286}, {1070,13.6803429}, {1080,14.2846571}, {1090,14.3510857}, {1100,14.9049429}, {1110,15.0324571}, {1120,15.6056857}, {1130,15.4095714}, {1140,15.8217143}, {1150,16.6487429}, {1160,16.7336286}, {1170,17.1190571}, {1180,17.6962857}, {1190,17.8458000}, {1200,18.2296571}, {1210,18.3370000}, {1220,19.2180000}, {1230,19.2534571}, {1240,19.7074286}, {1250,20.3748000}, {1260,20.3033714}, {1270,21.1243714}, {1280,21.4803714}, {1290,22.2968571}, {1300,22.3778286}, {1310,22.7802286}, {1320,22.9389429}, {1330,23.5900000}, {1340,23.1433429}, {1350,23.6422571}, {1360,24.8934857}, {1370,25.1784571}, {1380,25.4562000}, {1390,25.9890286}, {1400,26.2815429}, {1410,26.3798000}, {1420,27.4049429}, {1430,27.7703429}, {1440,27.9161429}, {1450,28.3587429}, {1460,29.2942571}, {1470,29.3245143}, {1480,29.7156857}, {1490,30.3702286}, {1500,30.7777429}, {1510,31.4534571}, {1520,31.8420000}, {1530,32.9520857}, {1540,33.6436857}, {1550,33.6635143}, {1560,34.5893143}, {1570,34.8884286}, {1580,35.9888571}, {1590,35.4112286}, {1600,37.1792857}, {1610,37.2377714}, {1620,37.3832000}, {1630,38.2295143}, {1640,38.6304000}, {1650,39.2978857}, {1660,40.3151429}, {1670,40.9207429}, {1680,41.5568286}, {1690,41.9941143}, {1700,43.1876857}, {1710,42.8189143}, {1720,44.3709143}, {1730,44.6199429}, {1740,45.0581429}, {1750,45.6715143}, {1760,46.4389429}, {1770,47.5381714}, {1780,48.0458286}, {1790,48.4385143}, {1800,48.4779429}, {1810,49.5300857}, {1820,50.1927429}, {1830,50.8870857}, {1840,52.6378571}, {1850,52.7550286}, {1860,53.1002857}, {1870,54.1717714}, {1880,54.8332000}, {1890,55.5002286}, {1900,56.6322857}, {1910,57.0501143}, {1920,58.6368000}, {1930,58.5536000}, {1940,59.1044571}, {1950,61.0166857}, {1960,59.8585429}, {1970,61.5811429}, {1980,62.1197714}, {1990,63.1992000}, {2000,64.0668571}};
data["big"]["LtacTacInTermExplicitCtx"]["reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003960}, {4,0.00000000}, {5,0.00003960}, {6,0.00003960}, {7,0.00000000}, {8,0.00007921}, {9,0.00007921}, {10,0.00000000}, {11,0.00003960}, {12,0.00007921}, {13,0.00000000}, {14,0.00019802}, {15,0.00007921}, {16,0.00003960}, {17,0.00003960}, {18,0.00003960}, {19,0.00003960}, {20,0.00000000}, {21,0.00000000}, {22,0.00007921}, {23,0.00007921}, {24,0.00003960}, {25,0.00015842}, {26,0.00007921}, {27,0.00003960}, {28,0.00003960}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00010891}, {34,0.00002970}, {35,0.00003960}, {36,0.00003960}, {37,0.00000000}, {38,0.00003960}, {39,0.00007921}, {40,0.00000000}, {41,0.00007921}, {42,0.00006931}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00011881}, {47,0.00007921}, {48,0.00003960}, {49,0.00003960}, {50,0.00003960}, {51,0.00011881}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00015842}, {56,0.00003960}, {57,0.00000000}, {58,0.00003960}, {59,0.00007921}, {60,0.00003960}, {61,0.00003960}, {62,0.00007921}, {63,0.00003960}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00007921}, {68,0.00000000}, {69,0.00007921}, {70,0.00007921}, {71,0.00003960}, {72,0.00007921}, {73,0.00000000}, {74,0.00003960}, {75,0.00000000}, {76,0.00000000}, {77,0.00007921}, {78,0.00007921}, {79,0.00000000}, {80,0.00000000}, {81,0.00003960}, {82,0.00000000}, {83,0.00000000}, {84,0.00011881}, {85,0.00003960}, {86,0.00015842}, {87,0.00007921}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00003960}, {92,0.00003960}, {93,0.00003960}, {94,0.00011881}, {95,0.00000000}, {96,0.00003960}, {97,0.00003960}, {98,0.00000000}, {99,0.00000000}, {100,0.00003960}, {101,0.00011881}, {102,0.00019802}, {103,0.00003960}, {104,0.00003960}, {105,0.00007921}, {106,0.00000000}, {107,0.00003960}, {108,0.00003960}, {109,0.00003960}, {110,0.00000000}, {111,0.00003960}, {112,0.00015842}, {113,0.00003960}, {114,0.00011881}, {115,0.00003960}, {116,0.00003960}, {117,0.00003960}, {118,0.00011881}, {119,0.00000000}, {120,0.00003960}, {121,0.00000000}, {122,0.00000000}, {123,0.00003960}, {124,0.00011881}, {125,0.00000000}, {126,0.00007921}, {127,0.00000000}, {128,0.00000000}, {129,0.00007921}, {130,0.00000000}, {131,0.00003960}, {132,0.00003960}, {133,0.00007921}, {134,0.00007921}, {135,0.00003960}, {136,0.00006931}, {137,0.00003960}, {138,0.00015842}, {139,0.00003960}, {140,0.00000000}, {141,0.00000000}, {142,0.00003960}, {143,0.00003960}, {144,0.00003960}, {145,0.00000000}, {146,0.00000000}, {147,0.00003960}, {148,0.00003960}, {149,0.00003960}, {150,0.00000000}, {151,0.00011881}, {152,0.00007921}, {153,0.00000000}, {154,0.00003960}, {155,0.00011881}, {156,0.00003960}, {157,0.00007921}, {158,0.00015842}, {159,0.00015842}, {160,0.00015842}, {161,0.00011881}, {162,0.00003960}, {163,0.00003960}, {164,0.00003960}, {165,0.00000000}, {166,0.00000000}, {167,0.00011881}, {168,0.00011881}, {169,0.00000000}, {170,0.00007921}, {171,0.00007921}, {172,0.00002970}, {173,0.00000000}, {174,0.00007921}, {175,0.00000000}, {176,0.00003960}, {177,0.00003960}, {178,0.00019802}, {179,0.00000000}, {180,0.00000000}, {181,0.00011881}, {182,0.00007921}, {183,0.00000000}, {184,0.00007921}, {185,0.00011881}, {186,0.00000000}, {187,0.00003960}, {188,0.00003960}, {189,0.00003960}, {190,0.00007921}, {191,0.00000000}, {192,0.00000000}, {193,0.00011881}, {194,0.00010891}, {195,0.00007921}, {196,0.00000000}, {197,0.00003960}, {198,0.00000000}, {199,0.00011881}, {200,0.00007921}, {201,0.00003960}, {202,0.00007921}, {203,0.00007921}, {204,0.00011881}, {205,0.00007921}, {206,0.00006931}, {207,0.00003960}, {208,0.00011881}, {209,0.00011881}, {210,0.00011881}, {211,0.00000000}, {212,0.00007921}, {213,0.00007921}, {214,0.00000000}, {215,0.00007921}, {216,0.00003960}, {217,0.00000000}, {218,0.00007921}, {219,0.00003960}, {220,0.00000000}, {221,0.00000000}, {222,0.00007921}, {223,0.00007921}, {224,0.00006931}, {225,0.00011881}, {226,0.00011881}, {227,0.00003960}, {228,0.00003960}, {229,0.00007921}, {230,0.00000000}, {231,0.00007921}, {232,0.00007921}, {233,0.00003960}, {234,0.00019802}, {235,0.00003960}, {236,0.00019802}, {237,0.00007921}, {238,0.00054455}, {239,0.00011881}, {240,0.00015842}, {241,0.00000000}, {242,0.00011881}, {243,0.00003960}, {244,0.00031683}, {245,0.00000000}, {246,0.00015842}, {247,0.00007921}, {248,0.00003960}, {249,0.00011881}, {250,0.00023762}, {251,0.00007921}, {252,0.00000000}, {253,0.00015842}, {254,0.00000000}, {255,0.00007921}, {256,0.00011881}, {257,0.00007921}, {258,0.00003960}, {259,0.00010891}, {260,0.00007921}, {261,0.00003960}, {262,0.00015842}, {263,0.00011881}, {264,0.00000000}, {265,0.00019802}, {266,0.00003960}, {267,0.00023762}, {268,0.00015842}, {269,0.00015842}, {270,0.00000000}, {271,0.00027723}, {272,0.00003960}, {273,0.00023762}, {274,0.00007921}, {275,0.00011881}, {276,0.00003960}, {277,0.00011881}, {278,0.00050495}, {279,0.00011881}, {280,0.00000000}, {281,0.00002970}, {282,0.00003960}, {283,0.00000000}, {284,0.00003960}, {285,0.00011881}, {286,0.00015842}, {287,0.00006931}, {288,0.00018812}, {289,0.00003960}, {290,0.00011881}, {291,0.00003960}, {292,0.00011881}, {293,0.00011881}, {294,0.00019802}, {295,0.00019802}, {296,0.00003960}, {297,0.00011881}, {298,0.00000000}, {299,0.00015842}, {300,0.00007921}, {301,0.0004571}, {302,0.0002286}, {303,0.0002286}, {304,0.0000000}, {305,0.0002286}, {306,0.0002286}, {307,0.0001143}, {308,0.0000000}, {309,0.0002286}, {310,0.0000000}, {311,0.0001143}, {312,0.0002286}, {313,0.0001143}, {314,0.0000000}, {315,0.0001143}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0002000}, {320,0.0001143}, {321,0.0003143}, {322,0.0000000}, {323,0.0000000}, {324,0.0002286}, {325,0.0000000}, {326,0.0002286}, {327,0.0001143}, {328,0.0001143}, {329,0.0001143}, {330,0.0002000}, {331,0.0001143}, {332,0.0003429}, {333,0.0001143}, {334,0.0001143}, {335,0.0001143}, {336,0.0001143}, {337,0.0001143}, {338,0.0001143}, {339,0.0001143}, {340,0.0001143}, {341,0.0000000}, {342,0.0002286}, {343,0.0000000}, {344,0.0003429}, {345,0.0002286}, {346,0.0000000}, {347,0.0002286}, {348,0.0000000}, {349,0.0003429}, {350,0.0001143}, {351,0.0001143}, {352,0.0001143}, {353,0.0000000}, {354,0.0002000}, {355,0.0001143}, {356,0.0001143}, {357,0.0002286}, {358,0.0000000}, {359,0.0001143}, {360,0.0003429}, {361,0.0001143}, {362,0.0000000}, {363,0.0003143}, {364,0.0002286}, {365,0.0002286}, {366,0.0002286}, {367,0.0002286}, {368,0.0000000}, {369,0.0004571}, {370,0.0001143}, {371,0.0001143}, {372,0.0005143}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0001143}, {377,0.0002286}, {378,0.0003429}, {379,0.0003429}, {380,0.0001143}, {381,0.0008000}, {382,0.0002286}, {383,0.0005714}, {384,0.0003429}, {385,0.0004571}, {386,0.0001143}, {387,0.0002286}, {388,0.0003429}, {389,0.0001143}, {390,0.0003429}, {391,0.0006857}, {392,0.0006857}, {393,0.0005714}, {394,0.0002286}, {395,0.0004571}, {396,0.0003429}, {397,0.0000000}, {398,0.0004286}, {399,0.0002286}, {400,0.0002286}, {401,0.0001143}, {402,0.0003429}, {403,0.0001143}, {404,0.0000000}, {405,0.0000000}, {406,0.0001143}, {407,0.0003429}, {408,0.0001143}, {409,0.0003429}, {410,0.0007714}, {411,0.0004571}, {412,0.0003429}, {413,0.0001143}, {414,0.0004286}, {415,0.0000000}, {416,0.0003429}, {417,0.0002286}, {418,0.0001143}, {419,0.0002286}, {420,0.0002286}, {421,0.0004571}, {422,0.0002286}, {423,0.0001143}, {424,0.0002286}, {425,0.0002286}, {426,0.0002286}, {427,0.0004571}, {428,0.0004571}, {429,0.0002286}, {430,0.0003429}, {431,0.0004571}, {432,0.0001143}, {433,0.0003429}, {434,0.0001143}, {435,0.0001143}, {436,0.0003429}, {437,0.0006571}, {438,0.0004571}, {439,0.0003429}, {440,0.0003429}, {441,0.0004571}, {442,0.0003429}, {443,0.0001143}, {444,0.0002286}, {445,0.0004571}, {446,0.0006857}, {447,0.0002286}, {448,0.0006857}, {449,0.0001143}, {450,0.0005714}, {451,0.0006857}, {452,0.0003429}, {453,0.0008000}, {454,0.0008000}, {455,0.0005714}, {456,0.0004571}, {457,0.0003429}, {458,0.0000000}, {459,0.0001143}, {460,0.0005714}, {461,0.0005714}, {462,0.0002286}, {463,0.0004286}, {464,0.0005714}, {465,0.0010286}, {466,0.0004571}, {467,0.0004571}, {468,0.0002286}, {469,0.0002286}, {470,0.0000000}, {471,0.0002286}, {472,0.0002286}, {473,0.0008000}, {474,0.0003429}, {475,0.0001143}, {476,0.0005714}, {477,0.0008000}, {478,0.0003429}, {479,0.0008000}, {480,0.0003429}, {481,0.0002286}, {482,0.0005714}, {483,0.0006857}, {484,0.0003429}, {485,0.0004571}, {486,0.0005429}, {487,0.0001143}, {488,0.0008000}, {489,0.0003143}, {490,0.0006857}, {491,0.0006571}, {492,0.0003429}, {493,0.0004286}, {494,0.0005714}, {495,0.0005714}, {496,0.0004571}, {497,0.0004571}, {498,0.0004571}, {499,0.0005714}, {500,0.0003429}, {505,0.0000000}, {510,0.0009143}, {515,0.0000000}, {520,0.0003429}, {525,0.0002286}, {530,0.0013714}, {535,0.0008000}, {540,0.0007714}, {545,0.0010286}, {550,0.0014857}, {555,0.0003429}, {560,0.0018286}, {565,0.0009143}, {570,0.0002286}, {575,0.0018286}, {580,0.0010286}, {585,0.0003429}, {590,0.0005714}, {595,0.0009143}, {600,0.0013429}, {605,0.0013714}, {610,0.0010286}, {615,0.0011429}, {620,0.0014857}, {625,0.0013714}, {630,0.0008857}, {635,0.0017143}, {640,0.0012571}, {645,0.0020286}, {650,0.0023714}, {655,0.0013714}, {660,0.0013714}, {665,0.0006857}, {670,0.0006857}, {675,0.0011429}, {680,0.0019429}, {685,0.0012286}, {690,0.0016000}, {695,0.0028286}, {700,0.0030286}, {705,0.0022857}, {710,0.0022857}, {715,0.0032857}, {720,0.0056000}, {725,0.0032000}, {730,0.0026000}, {735,0.0050286}, {740,0.0037429}, {745,0.0042286}, {750,0.0067429}, {755,0.0085429}, {760,0.0056571}, {765,0.0073143}, {770,0.0058286}, {775,0.0057143}, {780,0.0061429}, {785,0.0084571}, {790,0.0080571}, {795,0.0077429}, {800,0.0058286}, {805,0.0069714}, {810,0.0080000}, {815,0.0087429}, {820,0.0081714}, {825,0.0078286}, {830,0.0080857}, {835,0.0075143}, {840,0.0137143}, {845,0.0093714}, {850,0.0088857}, {855,0.0104000}, {860,0.0132571}, {865,0.0088571}, {870,0.0106000}, {875,0.0104000}, {880,0.0147429}, {885,0.0056857}, {890,0.0130286}, {895,0.0097429}, {900,0.0073143}, {905,0.0100286}, {910,0.0108000}, {915,0.0097714}, {920,0.0093143}, {925,0.0086857}, {930,0.0112857}, {935,0.0166286}, {940,0.0099143}, {945,0.0121143}, {950,0.0096571}, {955,0.0102857}, {960,0.0094286}, {965,0.0136857}, {970,0.0154857}, {975,0.0106857}, {980,0.0136857}, {985,0.0093429}, {990,0.0132857}, {995,0.0115429}, {1000,0.0132286}, {1010,0.0066857}, {1020,0.0094571}, {1030,0.0066857}, {1040,0.0078571}, {1050,0.0070286}, {1060,0.0071714}, {1070,0.0046000}, {1080,0.0076000}, {1090,0.0077143}, {1100,0.0073429}, {1110,0.0102857}, {1120,0.0078000}, {1130,0.0095714}, {1140,0.0118571}, {1150,0.0085143}, {1160,0.0093143}, {1170,0.0088286}, {1180,0.0118000}, {1190,0.0109714}, {1200,0.0110000}, {1210,0.0117143}, {1220,0.0146000}, {1230,0.0133429}, {1240,0.0226571}, {1250,0.0120571}, {1260,0.0133429}, {1270,0.0113714}, {1280,0.0107714}, {1290,0.0137429}, {1300,0.0116857}, {1310,0.0171714}, {1320,0.0164857}, {1330,0.0128000}, {1340,0.0199429}, {1350,0.0176571}, {1360,0.0143143}, {1370,0.0146000}, {1380,0.0180857}, {1390,0.0186286}, {1400,0.0195143}, {1410,0.0232286}, {1420,0.0153429}, {1430,0.0205429}, {1440,0.0256571}, {1450,0.0258000}, {1460,0.0247143}, {1470,0.0248857}, {1480,0.0272286}, {1490,0.0256857}, {1500,0.0283143}, {1510,0.0292286}, {1520,0.0287714}, {1530,0.0226571}, {1540,0.0228571}, {1550,0.0253429}, {1560,0.0332571}, {1570,0.0299714}, {1580,0.0360286}, {1590,0.0365143}, {1600,0.0254286}, {1610,0.0274286}, {1620,0.0335429}, {1630,0.0265143}, {1640,0.0274571}, {1650,0.0321143}, {1660,0.0293429}, {1670,0.0315429}, {1680,0.0271429}, {1690,0.0310857}, {1700,0.0301143}, {1710,0.0314857}, {1720,0.0281143}, {1730,0.0387429}, {1740,0.0350000}, {1750,0.0369429}, {1760,0.0438857}, {1770,0.0351143}, {1780,0.0290857}, {1790,0.0321429}, {1800,0.0368000}, {1810,0.0319429}, {1820,0.0456857}, {1830,0.0435714}, {1840,0.0317429}, {1850,0.0402857}, {1860,0.0562286}, {1870,0.0454286}, {1880,0.0468571}, {1890,0.0483143}, {1900,0.0519714}, {1910,0.0442857}, {1920,0.0408000}, {1930,0.0450000}, {1940,0.0479714}, {1950,0.0343429}, {1960,0.0435143}, {1970,0.0310857}, {1980,0.0414000}, {1990,0.0517714}, {2000,0.0454571}};
data["big"]["LtacTacInTermGallinaCtx"]["Aggregate"]["real"] = {{1,0.00100000}, {2,0.00100000}, {3,0.00200000}, {4,0.00200000}, {5,0.00221782}, {6,0.00300000}, {7,0.00300990}, {8,0.00383168}, {9,0.00400000}, {10,0.00431683}, {11,0.00500990}, {12,0.00524752}, {13,0.00601980}, {14,0.00640594}, {15,0.00700990}, {16,0.00735644}, {17,0.00804950}, {18,0.00827723}, {19,0.00909901}, {20,0.00951485}, {21,0.01037624}, {22,0.01061386}, {23,0.01125743}, {24,0.01206931}, {25,0.01245545}, {26,0.01461386}, {27,0.01365347}, {28,0.01439604}, {29,0.01521782}, {30,0.01545545}, {31,0.01624752}, {32,0.01720792}, {33,0.01778218}, {34,0.01849505}, {35,0.01935644}, {36,0.01990099}, {37,0.02065347}, {38,0.02150495}, {39,0.02237624}, {40,0.02303960}, {41,0.02899010}, {42,0.02461386}, {43,0.02543564}, {44,0.02630693}, {45,0.03108911}, {46,0.02806931}, {47,0.02894059}, {48,0.02945545}, {49,0.03087129}, {50,0.03161386}, {51,0.03259406}, {52,0.03338614}, {53,0.04025743}, {54,0.03526733}, {55,0.03627723}, {56,0.04726733}, {57,0.03848515}, {58,0.03987129}, {59,0.04058416}, {60,0.04152475}, {61,0.04251485}, {62,0.04326733}, {63,0.04486139}, {64,0.04583168}, {65,0.04695050}, {66,0.04780198}, {67,0.05723762}, {68,0.04997030}, {69,0.05167327}, {70,0.06555446}, {71,0.05359406}, {72,0.06277228}, {73,0.05598020}, {74,0.07326733}, {75,0.05844554}, {76,0.07215842}, {77,0.08084158}, {78,0.06261386}, {79,0.06351485}, {80,0.06487129}, {81,0.06827723}, {82,0.07474257}, {83,0.07892079}, {84,0.07360396}, {85,0.08746535}, {86,0.09896040}, {87,0.09167327}, {88,0.10457426}, {89,0.13055446}, {90,0.11210891}, {91,0.10097030}, {92,0.10139604}, {93,0.10765347}, {94,0.10598020}, {95,0.10789109}, {96,0.11101980}, {97,0.11131683}, {98,0.11406931}, {99,0.11745545}, {100,0.12032673}, {101,0.12303960}, {102,0.12338614}, {103,0.12518812}, {104,0.12821782}, {105,0.13049505}, {106,0.13472277}, {107,0.13532673}, {108,0.13783168}, {109,0.13139604}, {110,0.13320792}, {111,0.13572277}, {112,0.13597030}, {113,0.13957426}, {114,0.14113861}, {115,0.14315842}, {116,0.14492079}, {117,0.14828713}, {118,0.15040594}, {119,0.15163366}, {120,0.15454455}, {121,0.15733663}, {122,0.15718812}, {123,0.16258416}, {124,0.16513861}, {125,0.16653465}, {126,0.16867327}, {127,0.17067327}, {128,0.17324752}, {129,0.17537624}, {130,0.17954455}, {131,0.18022772}, {132,0.18437624}, {133,0.18561386}, {134,0.18768317}, {135,0.19031683}, {136,0.19198020}, {137,0.19498020}, {138,0.19619802}, {139,0.20108911}, {140,0.20309901}, {141,0.20476238}, {142,0.20934653}, {143,0.20941584}, {144,0.21151485}, {145,0.21589109}, {146,0.21823762}, {147,0.22000000}, {148,0.22264356}, {149,0.22503960}, {150,0.22939604}, {151,0.23306931}, {152,0.23405941}, {153,0.23771287}, {154,0.24149505}, {155,0.24218812}, {156,0.24506931}, {157,0.24957426}, {158,0.25122772}, {159,0.25596040}, {160,0.25435644}, {161,0.25742574}, {162,0.26112871}, {163,0.26325743}, {164,0.26641584}, {165,0.27034653}, {166,0.27507921}, {167,0.27621782}, {168,0.28215842}, {169,0.28504950}, {170,0.28455446}, {171,0.28730693}, {172,0.29233663}, {173,0.29586139}, {174,0.29881188}, {175,0.30134653}, {176,0.30433663}, {177,0.30753465}, {178,0.31054455}, {179,0.31284158}, {180,0.31381188}, {181,0.31724752}, {182,0.32087129}, {183,0.32437624}, {184,0.32760396}, {185,0.33039604}, {186,0.33382178}, {187,0.33581188}, {188,0.33876238}, {189,0.34363366}, {190,0.34695050}, {191,0.35061386}, {192,0.35412871}, {193,0.35976238}, {194,0.36911881}, {195,0.37468317}, {196,0.37487129}, {197,0.37521782}, {198,0.37591089}, {199,0.38145545}, {200,0.38519802}, {201,0.38964356}, {202,0.40208911}, {203,0.40318812}, {204,0.39613861}, {205,0.40017822}, {206,0.40032673}, {207,0.41555446}, {208,0.42527723}, {209,0.41913861}, {210,0.41816832}, {211,0.42025743}, {212,0.43662376}, {213,0.43437624}, {214,0.42932673}, {215,0.43674257}, {216,0.45257426}, {217,0.44795050}, {218,0.44750495}, {219,0.46452475}, {220,0.45957426}, {221,0.46061386}, {222,0.47809901}, {223,0.47234653}, {224,0.47814851}, {225,0.48198020}, {226,0.48446535}, {227,0.49880198}, {228,0.48948515}, {229,0.50225743}, {230,0.49947525}, {231,0.50949505}, {232,0.51256436}, {233,0.51403960}, {234,0.51936634}, {235,0.52610891}, {236,0.52597030}, {237,0.53783168}, {238,0.53293069}, {239,0.54973267}, {240,0.54202970}, {241,0.55345545}, {242,0.55568317}, {243,0.55991089}, {244,0.56781188}, {245,0.57167327}, {246,0.56904950}, {247,0.58063366}, {248,0.57687129}, {249,0.58711881}, {250,0.59442574}, {251,0.58919802}, {252,0.59822772}, {253,0.60985149}, {254,0.60279208}, {255,0.61173267}, {256,0.62466337}, {257,0.61885149}, {258,0.62221782}, {259,0.62881188}, {260,0.63514851}, {261,0.64579208}, {262,0.73887129}, {263,0.65574257}, {264,0.65696040}, {265,0.65654455}, {266,0.70447525}, {267,0.66981188}, {268,0.67609901}, {269,0.67776238}, {270,0.68198020}, {271,0.68796040}, {272,0.69132673}, {273,0.70468317}, {274,0.71228713}, {275,0.75819802}, {276,0.71887129}, {277,0.72389109}, {278,0.72998020}, {279,0.73455446}, {280,0.73765347}, {281,0.74633663}, {282,0.75777228}, {283,0.75940594}, {284,0.76148515}, {285,0.76901980}, {286,0.77086139}, {287,0.77537624}, {288,0.79826733}, {289,0.78767327}, {290,0.78875248}, {291,0.79570297}, {292,0.79172277}, {293,0.79586139}, {294,0.80096040}, {295,0.81110891}, {296,0.81902970}, {297,0.83397030}, {298,0.83517822}, {299,0.83279208}, {300,0.83048515}, {301,0.8751143}, {302,0.9911143}, {303,0.8936286}, {304,0.9013429}, {305,0.9124857}, {306,0.9080857}, {307,0.9156857}, {308,0.9329714}, {309,0.9228571}, {310,0.9257429}, {311,0.9446000}, {312,0.9486571}, {313,0.9534857}, {314,0.9603714}, {315,0.9647714}, {316,0.9694571}, {317,0.9731143}, {318,1.0381714}, {319,0.9889143}, {320,0.9926571}, {321,1.0003429}, {322,1.0040286}, {323,1.0040000}, {324,1.0122286}, {325,1.0171143}, {326,1.0231429}, {327,1.0368286}, {328,1.0353143}, {329,1.0506571}, {330,1.0494857}, {331,1.0660571}, {332,1.0647143}, {333,1.0662000}, {334,1.0741714}, {335,1.0765429}, {336,1.0886857}, {337,1.0860286}, {338,1.0989429}, {339,1.0981714}, {340,1.1131143}, {341,1.1148000}, {342,1.1314571}, {343,1.1377714}, {344,1.1526286}, {345,1.1514286}, {346,1.1601429}, {347,1.1597714}, {348,1.1688857}, {349,1.1762286}, {350,1.1899429}, {351,1.1984000}, {352,1.1945429}, {353,1.2008286}, {354,1.2095714}, {355,1.2181429}, {356,1.2197143}, {357,1.2335429}, {358,1.2322000}, {359,1.2392000}, {360,1.2429143}, {361,1.2590000}, {362,1.2592286}, {363,1.2984571}, {364,1.2776571}, {365,1.2816286}, {366,1.2800571}, {367,1.3041143}, {368,1.3311143}, {369,1.3062571}, {370,1.3209143}, {371,1.3298000}, {372,1.3346286}, {373,1.3388571}, {374,1.3572286}, {375,1.3635714}, {376,1.3657143}, {377,1.3746857}, {378,1.3748571}, {379,1.3810000}, {380,1.4010857}, {381,1.4029429}, {382,1.4100571}, {383,1.4248286}, {384,1.4352000}, {385,1.4392571}, {386,1.4551143}, {387,1.4938286}, {388,1.4642000}, {389,1.4847714}, {390,1.4836000}, {391,1.4953714}, {392,1.4965143}, {393,1.5020286}, {394,1.5094286}, {395,1.5192286}, {396,1.5324857}, {397,1.5441714}, {398,1.5466857}, {399,1.5563429}, {400,1.5683143}, {401,1.5792286}, {402,1.5889143}, {403,1.6080286}, {404,1.6105714}, {405,1.6240286}, {406,1.6352286}, {407,1.6394286}, {408,1.6664000}, {409,1.6721714}, {410,1.6830286}, {411,1.6526857}, {412,1.7092857}, {413,1.6724286}, {414,1.6825143}, {415,1.7167143}, {416,1.7498857}, {417,1.6982857}, {418,1.7302857}, {419,1.7658286}, {420,1.7881429}, {421,1.8188571}, {422,1.7320857}, {423,1.7408000}, {424,1.7492571}, {425,1.7653143}, {426,1.8106571}, {427,1.8960857}, {428,1.8054857}, {429,1.8446571}, {430,1.8227143}, {431,1.8658286}, {432,1.9188286}, {433,1.9312571}, {434,1.8948857}, {435,1.8969714}, {436,1.8743429}, {437,1.9107429}, {438,1.9298000}, {439,1.9522286}, {440,2.0232286}, {441,1.9581429}, {442,2.0047143}, {443,2.0125714}, {444,1.9847714}, {445,1.9655429}, {446,1.9704286}, {447,1.9868286}, {448,2.0252857}, {449,2.0147429}, {450,2.0251714}, {451,2.0098000}, {452,2.0221714}, {453,2.0384286}, {454,2.0574286}, {455,2.0626000}, {456,2.0730286}, {457,2.0842571}, {458,2.1298857}, {459,2.1261714}, {460,2.1384571}, {461,2.1637143}, {462,2.1779143}, {463,2.1347429}, {464,2.1639429}, {465,2.2310857}, {466,2.2433143}, {467,2.2577714}, {468,2.3462571}, {469,2.2527714}, {470,2.2386286}, {471,2.2889714}, {472,2.3129429}, {473,2.2706286}, {474,2.3137429}, {475,2.3141714}, {476,2.3058000}, {477,2.2676286}, {478,2.3038000}, {479,2.3220571}, {480,2.3312857}, {481,2.3358000}, {482,2.3776857}, {483,2.3784857}, {484,2.4379143}, {485,2.3755143}, {486,2.4012286}, {487,2.3888857}, {488,2.5541429}, {489,2.3982286}, {490,2.4075143}, {491,2.5106857}, {492,2.4160571}, {493,2.4466571}, {494,2.5201429}, {495,2.5689429}, {496,2.5052857}, {497,2.5082571}, {498,2.5553429}, {499,2.5491143}, {500,2.5654000}, {505,2.6108571}, {510,2.7074857}, {515,2.7783429}, {520,2.9573143}, {525,2.9935143}, {530,2.8966571}, {535,2.9628571}, {540,3.0346000}, {545,3.0955714}, {550,3.1671429}, {555,3.2397714}, {560,3.2378857}, {565,3.2702571}, {570,3.3379714}, {575,3.4229143}, {580,3.4828571}, {585,3.5203143}, {590,3.6214000}, {595,3.7411714}, {600,3.7808571}, {605,3.8972857}, {610,3.9239143}, {615,4.0419714}, {620,4.0970571}, {625,4.1120000}, {630,4.2263143}, {635,4.2480571}, {640,4.3277143}, {645,4.2892571}, {650,4.3923429}, {655,4.5146571}, {660,4.5695429}, {665,4.5911714}, {670,4.7386286}, {675,4.9992857}, {680,4.9870000}, {685,5.0441429}, {690,5.2050000}, {695,5.2061143}, {700,5.3420000}, {705,5.4430571}, {710,5.4792571}, {715,5.4507714}, {720,5.6248000}, {725,5.6506571}, {730,5.8040000}, {735,5.7936000}, {740,6.0336000}, {745,6.2228286}, {750,6.2981714}, {755,6.2858286}, {760,6.4524857}, {765,6.5730000}, {770,6.6484286}, {775,6.8924571}, {780,6.8968571}, {785,6.9652000}, {790,7.1450000}, {795,7.1008000}, {800,7.2532571}, {805,7.5349429}, {810,7.4102857}, {815,7.6241429}, {820,7.6062000}, {825,7.7816857}, {830,7.8283143}, {835,7.8596857}, {840,8.1308857}, {845,8.3481714}, {850,8.4788000}, {855,8.7052000}, {860,8.7306857}, {865,9.1731714}, {870,9.0971429}, {875,9.1832571}, {880,9.2675714}, {885,9.2107714}, {890,9.6182857}, {895,9.7268286}, {900,9.5722857}, {905,9.9092571}, {910,9.8986857}, {915,10.0550286}, {920,10.1547714}, {925,10.3468571}, {930,10.2922286}, {935,10.5776000}, {940,10.5707429}, {945,10.6198857}, {950,10.7868571}, {955,11.0254286}, {960,10.9047143}, {965,11.2780857}, {970,11.2744286}, {975,11.3478857}, {980,11.5528571}, {985,11.6366571}, {990,12.0312286}, {995,11.8285429}, {1000,11.9814286}, {1010,12.2074000}, {1020,12.7302571}, {1030,12.9019429}, {1040,13.3401714}, {1050,13.7704857}, {1060,14.1923714}, {1070,14.5049714}, {1080,14.7217143}, {1090,15.0635143}, {1100,15.2480571}, {1110,15.8984000}, {1120,15.9602000}, {1130,16.7004571}, {1140,17.0009143}, {1150,16.9413429}, {1160,17.6144571}, {1170,18.0167429}, {1180,18.5526857}, {1190,19.1390000}, {1200,19.1649429}, {1210,19.5562000}, {1220,20.3767143}, {1230,21.0478857}, {1240,21.5163143}, {1250,21.5532571}, {1260,22.3413143}, {1270,22.6087714}, {1280,23.0880857}, {1290,23.5268571}, {1300,23.8150571}, {1310,24.4487143}, {1320,24.9152857}, {1330,25.6518571}, {1340,25.8239143}, {1350,26.9110571}, {1360,27.2730000}, {1370,27.1962286}, {1380,28.0894857}, {1390,28.2787429}, {1400,29.4470000}, {1410,30.0223714}, {1420,30.5837429}, {1430,30.9630571}, {1440,31.2482571}, {1450,31.8419714}, {1460,32.4556000}, {1470,33.1025429}, {1480,34.8344857}, {1490,34.6697143}, {1500,34.7678857}, {1510,35.8444857}, {1520,36.6368571}, {1530,36.6270857}, {1540,37.5201143}, {1550,38.5217429}, {1560,38.9161714}, {1570,39.6822286}, {1580,39.9586000}, {1590,40.7061714}, {1600,40.7511143}, {1610,42.9382857}, {1620,42.3521143}, {1630,43.5548286}, {1640,44.2657429}, {1650,44.8833429}, {1660,45.8442000}, {1670,45.9574286}, {1680,47.7309143}, {1690,48.0571429}, {1700,49.1505714}, {1710,50.4349714}, {1720,51.3389429}, {1730,51.0079714}, {1740,52.0462000}, {1750,51.9474857}, {1760,52.6471429}, {1770,53.9323143}, {1780,54.6808571}, {1790,55.5873143}, {1800,56.2348000}, {1810,57.5767714}, {1820,58.2231714}, {1830,58.5207714}, {1840,59.9690857}, {1850,60.4620857}, {1860,61.6319429}, {1870,63.5824286}, {1880,64.4703143}, {1890,64.7271429}, {1900,66.6695714}, {1910,67.4198571}, {1920,69.2408571}, {1930,68.0583143}, {1940,69.5932571}, {1950,72.5191714}, {1960,71.7331429}, {1970,73.3724000}, {1980,74.7359143}, {1990,75.1006571}, {2000,75.2582857}};
data["big"]["LtacTacInTermGallinaCtx"]["Aggregate"]["user"] = {{1,0.00131683}, {2,0.00164356}, {3,0.00229703}, {4,0.00227723}, {5,0.00269307}, {6,0.00328713}, {7,0.00356436}, {8,0.00374257}, {9,0.00425743}, {10,0.00480198}, {11,0.00509901}, {12,0.00551485}, {13,0.00550495}, {14,0.00644554}, {15,0.00708911}, {16,0.00754455}, {17,0.00810891}, {18,0.00883168}, {19,0.00910891}, {20,0.00976238}, {21,0.01005941}, {22,0.01057426}, {23,0.01138614}, {24,0.01193069}, {25,0.01233663}, {26,0.01459406}, {27,0.01375248}, {28,0.01433663}, {29,0.01488119}, {30,0.01523762}, {31,0.01585149}, {32,0.01676238}, {33,0.01729703}, {34,0.01813861}, {35,0.01919802}, {36,0.01949505}, {37,0.02054455}, {38,0.02115842}, {39,0.02290099}, {40,0.02368317}, {41,0.02907921}, {42,0.02506931}, {43,0.02544554}, {44,0.02676238}, {45,0.03101980}, {46,0.02846535}, {47,0.02899010}, {48,0.02990099}, {49,0.03092079}, {50,0.03170297}, {51,0.03275248}, {52,0.03322772}, {53,0.03970297}, {54,0.03499010}, {55,0.03598020}, {56,0.04726733}, {57,0.03804950}, {58,0.03946535}, {59,0.04042574}, {60,0.04126733}, {61,0.04184158}, {62,0.04268317}, {63,0.04470297}, {64,0.04544554}, {65,0.04703960}, {66,0.04832673}, {67,0.05703960}, {68,0.05008911}, {69,0.05180198}, {70,0.06539604}, {71,0.05377228}, {72,0.06230693}, {73,0.05590099}, {74,0.07285149}, {75,0.05816832}, {76,0.07183168}, {77,0.08080198}, {78,0.06231683}, {79,0.06272277}, {80,0.06444554}, {81,0.06795050}, {82,0.07490099}, {83,0.07883168}, {84,0.07393069}, {85,0.08725743}, {86,0.09845545}, {87,0.09120792}, {88,0.10417822}, {89,0.13030693}, {90,0.11201980}, {91,0.10070297}, {92,0.10111881}, {93,0.10763366}, {94,0.10544554}, {95,0.10764356}, {96,0.11071287}, {97,0.11112871}, {98,0.11349505}, {99,0.11727723}, {100,0.12011881}, {101,0.12291089}, {102,0.12315842}, {103,0.12498020}, {104,0.12808911}, {105,0.13009901}, {106,0.13443564}, {107,0.13467327}, {108,0.13725743}, {109,0.13117822}, {110,0.13304950}, {111,0.13522772}, {112,0.13582178}, {113,0.13914851}, {114,0.14055446}, {115,0.14304950}, {116,0.14464356}, {117,0.14797030}, {118,0.15011881}, {119,0.15131683}, {120,0.15426733}, {121,0.15693069}, {122,0.15646535}, {123,0.16202970}, {124,0.16461386}, {125,0.16604950}, {126,0.16856436}, {127,0.17034653}, {128,0.17305941}, {129,0.17507921}, {130,0.17946535}, {131,0.17966337}, {132,0.18355446}, {133,0.18518812}, {134,0.18700990}, {135,0.18957426}, {136,0.19153465}, {137,0.19477228}, {138,0.19586139}, {139,0.20053465}, {140,0.20268317}, {141,0.20418812}, {142,0.20886139}, {143,0.20883168}, {144,0.21108911}, {145,0.21499010}, {146,0.21787129}, {147,0.21925743}, {148,0.22234653}, {149,0.22436634}, {150,0.22897030}, {151,0.23217822}, {152,0.23343564}, {153,0.23676238}, {154,0.24100000}, {155,0.24141584}, {156,0.24465347}, {157,0.24895050}, {158,0.25060396}, {159,0.25543564}, {160,0.25378218}, {161,0.25671287}, {162,0.26066337}, {163,0.26295050}, {164,0.26598020}, {165,0.26963366}, {166,0.27446535}, {167,0.27564356}, {168,0.28179208}, {169,0.28401980}, {170,0.28370297}, {171,0.28663366}, {172,0.29144554}, {173,0.29500990}, {174,0.29794059}, {175,0.30046535}, {176,0.30369307}, {177,0.30685149}, {178,0.30977228}, {179,0.31225743}, {180,0.31326733}, {181,0.31675248}, {182,0.32024752}, {183,0.32357426}, {184,0.32701980}, {185,0.32965347}, {186,0.33299010}, {187,0.33516832}, {188,0.33797030}, {189,0.34259406}, {190,0.34613861}, {191,0.34961386}, {192,0.35385149}, {193,0.35913861}, {194,0.36858416}, {195,0.37404950}, {196,0.37415842}, {197,0.37430693}, {198,0.37519802}, {199,0.38025743}, {200,0.38436634}, {201,0.38877228}, {202,0.40150495}, {203,0.40218812}, {204,0.39556436}, {205,0.39918812}, {206,0.39963366}, {207,0.41481188}, {208,0.42461386}, {209,0.41840594}, {210,0.41711881}, {211,0.41934653}, {212,0.43539604}, {213,0.43339604}, {214,0.42859406}, {215,0.43568317}, {216,0.45146535}, {217,0.44724752}, {218,0.44675248}, {219,0.46342574}, {220,0.45898020}, {221,0.45992079}, {222,0.47684158}, {223,0.47121782}, {224,0.47719802}, {225,0.48119802}, {226,0.48359406}, {227,0.49790099}, {228,0.48832673}, {229,0.50123762}, {230,0.49862376}, {231,0.50849505}, {232,0.51161386}, {233,0.51299010}, {234,0.51841584}, {235,0.52507921}, {236,0.52472277}, {237,0.53678218}, {238,0.53149505}, {239,0.54885149}, {240,0.54115842}, {241,0.55236634}, {242,0.55447525}, {243,0.55897030}, {244,0.56670297}, {245,0.57040594}, {246,0.56757426}, {247,0.57944554}, {248,0.57583168}, {249,0.58565347}, {250,0.59335644}, {251,0.58753465}, {252,0.59683168}, {253,0.60845545}, {254,0.60166337}, {255,0.61031683}, {256,0.62343564}, {257,0.61675248}, {258,0.62107921}, {259,0.62748515}, {260,0.63391089}, {261,0.64479208}, {262,0.73727723}, {263,0.65442574}, {264,0.65563366}, {265,0.65565347}, {266,0.70210891}, {267,0.66829703}, {268,0.67497030}, {269,0.67625743}, {270,0.68038614}, {271,0.68669307}, {272,0.68991089}, {273,0.70249505}, {274,0.71156436}, {275,0.75700990}, {276,0.71798020}, {277,0.72286139}, {278,0.72869307}, {279,0.73306931}, {280,0.73636634}, {281,0.74471287}, {282,0.75657426}, {283,0.75798020}, {284,0.76026733}, {285,0.76743564}, {286,0.76958416}, {287,0.77394059}, {288,0.79700990}, {289,0.78584158}, {290,0.78702970}, {291,0.79455446}, {292,0.79047525}, {293,0.79443564}, {294,0.79950495}, {295,0.80915842}, {296,0.81732673}, {297,0.83222772}, {298,0.83324752}, {299,0.83084158}, {300,0.82904950}, {301,0.8740286}, {302,0.9892857}, {303,0.8924571}, {304,0.8998571}, {305,0.9117714}, {306,0.9063143}, {307,0.9143429}, {308,0.9318857}, {309,0.9224571}, {310,0.9244000}, {311,0.9428571}, {312,0.9470571}, {313,0.9523714}, {314,0.9590286}, {315,0.9639714}, {316,0.9684571}, {317,0.9720571}, {318,1.0369143}, {319,0.9855429}, {320,0.9919429}, {321,0.9994000}, {322,1.0029143}, {323,1.0031143}, {324,1.0106857}, {325,1.0160571}, {326,1.0222571}, {327,1.0348857}, {328,1.0338857}, {329,1.0479143}, {330,1.0451429}, {331,1.0576286}, {332,1.0542000}, {333,1.0596000}, {334,1.0708000}, {335,1.0740857}, {336,1.0872571}, {337,1.0848000}, {338,1.0974857}, {339,1.0963429}, {340,1.1121143}, {341,1.1136571}, {342,1.1302286}, {343,1.1365714}, {344,1.1506286}, {345,1.1496000}, {346,1.1593714}, {347,1.1575714}, {348,1.1677143}, {349,1.1745143}, {350,1.1882286}, {351,1.1967714}, {352,1.1934000}, {353,1.1994857}, {354,1.2079714}, {355,1.2168000}, {356,1.2184571}, {357,1.2324286}, {358,1.2301714}, {359,1.2380286}, {360,1.2408000}, {361,1.2576857}, {362,1.2573714}, {363,1.2968000}, {364,1.2757429}, {365,1.2793429}, {366,1.2783714}, {367,1.3022857}, {368,1.3291143}, {369,1.3040286}, {370,1.3184571}, {371,1.3278000}, {372,1.3329143}, {373,1.3372571}, {374,1.3553714}, {375,1.3614571}, {376,1.3634857}, {377,1.3715714}, {378,1.3730286}, {379,1.3783714}, {380,1.3984857}, {381,1.4003714}, {382,1.4079714}, {383,1.4220571}, {384,1.4326571}, {385,1.4366286}, {386,1.4527143}, {387,1.4911714}, {388,1.4614286}, {389,1.4822857}, {390,1.4807429}, {391,1.4926286}, {392,1.4942000}, {393,1.5000857}, {394,1.5077714}, {395,1.5172857}, {396,1.5306000}, {397,1.5418286}, {398,1.5444000}, {399,1.5537143}, {400,1.5655143}, {401,1.5776286}, {402,1.5865143}, {403,1.6045429}, {404,1.6000571}, {405,1.6197429}, {406,1.6259143}, {407,1.6360857}, {408,1.6587143}, {409,1.6681143}, {410,1.6797429}, {411,1.6496286}, {412,1.7058571}, {413,1.6688000}, {414,1.6788000}, {415,1.7136000}, {416,1.7465143}, {417,1.6954571}, {418,1.7275714}, {419,1.7628857}, {420,1.7851143}, {421,1.8160571}, {422,1.7295143}, {423,1.7380286}, {424,1.7465143}, {425,1.7626286}, {426,1.8073714}, {427,1.8922571}, {428,1.8020857}, {429,1.8404286}, {430,1.8190857}, {431,1.8614857}, {432,1.9144571}, {433,1.9280000}, {434,1.8916571}, {435,1.8937143}, {436,1.8699714}, {437,1.9070286}, {438,1.9254286}, {439,1.9472000}, {440,2.0184286}, {441,1.9529143}, {442,1.9999429}, {443,2.0082000}, {444,1.9807429}, {445,1.9610571}, {446,1.9665714}, {447,1.9830571}, {448,2.0196286}, {449,2.0104571}, {450,2.0216000}, {451,2.0061143}, {452,2.0192286}, {453,2.0344857}, {454,2.0532000}, {455,2.0590286}, {456,2.0698857}, {457,2.0800000}, {458,2.1250286}, {459,2.1229143}, {460,2.1348286}, {461,2.1604571}, {462,2.1749714}, {463,2.1308286}, {464,2.1610000}, {465,2.2268857}, {466,2.2400571}, {467,2.2542286}, {468,2.3423143}, {469,2.2494857}, {470,2.2345143}, {471,2.2847143}, {472,2.3082286}, {473,2.2658000}, {474,2.3087429}, {475,2.3095714}, {476,2.3011143}, {477,2.2634286}, {478,2.2995429}, {479,2.3171429}, {480,2.3251714}, {481,2.3297143}, {482,2.3716857}, {483,2.3714000}, {484,2.4310857}, {485,2.3694000}, {486,2.3955429}, {487,2.3830000}, {488,2.5463429}, {489,2.3931714}, {490,2.4017714}, {491,2.5058286}, {492,2.4108286}, {493,2.4415714}, {494,2.5130857}, {495,2.5625429}, {496,2.5001143}, {497,2.5024857}, {498,2.5490571}, {499,2.5438286}, {500,2.5600857}, {505,2.6054571}, {510,2.7005429}, {515,2.7709714}, {520,2.9482857}, {525,2.9856857}, {530,2.8883429}, {535,2.9538000}, {540,3.0252857}, {545,3.0862857}, {550,3.1575429}, {555,3.2301429}, {560,3.2291714}, {565,3.2615143}, {570,3.3289143}, {575,3.4142286}, {580,3.4724571}, {585,3.5118857}, {590,3.6130571}, {595,3.7302000}, {600,3.7722571}, {605,3.8887429}, {610,3.9143143}, {615,4.0331714}, {620,4.0886571}, {625,4.1007714}, {630,4.2138000}, {635,4.2382286}, {640,4.3189714}, {645,4.2805143}, {650,4.3862286}, {655,4.5075714}, {660,4.5637429}, {665,4.5834286}, {670,4.7308571}, {675,4.9923429}, {680,4.9783143}, {685,5.0339714}, {690,5.1964000}, {695,5.1973714}, {700,5.3324000}, {705,5.4362000}, {710,5.4714286}, {715,5.4401429}, {720,5.6142000}, {725,5.6402286}, {730,5.7914000}, {735,5.7856857}, {740,6.0217714}, {745,6.2140857}, {750,6.2902857}, {755,6.2779429}, {760,6.4450857}, {765,6.5642571}, {770,6.6375714}, {775,6.8784571}, {780,6.8848857}, {785,6.9540571}, {790,7.1207429}, {795,7.0898286}, {800,7.2253429}, {805,7.4988286}, {810,7.3958571}, {815,7.6074000}, {820,7.5907143}, {825,7.7635714}, {830,7.8140286}, {835,7.8446000}, {840,8.1173714}, {845,8.3304857}, {850,8.4607714}, {855,8.6901143}, {860,8.7139429}, {865,9.1583714}, {870,9.0852000}, {875,9.1728571}, {880,9.2567429}, {885,9.2029143}, {890,9.6099429}, {895,9.7148000}, {900,9.5596000}, {905,9.8899714}, {910,9.8775714}, {915,10.0387143}, {920,10.1358571}, {925,10.3250000}, {930,10.2704857}, {935,10.5552000}, {940,10.5499714}, {945,10.6024571}, {950,10.7722286}, {955,11.0091143}, {960,10.8907429}, {965,11.2514000}, {970,11.2495714}, {975,11.3206286}, {980,11.5284571}, {985,11.6062571}, {990,11.9956286}, {995,11.7981429}, {1000,11.9504000}, {1010,12.1731429}, {1020,12.6972571}, {1030,12.8636571}, {1040,13.3132857}, {1050,13.7439429}, {1060,14.1642286}, {1070,14.4631143}, {1080,14.6825714}, {1090,15.0412000}, {1100,15.2225714}, {1110,15.8597714}, {1120,15.9260571}, {1130,16.6672571}, {1140,16.9715714}, {1150,16.9153714}, {1160,17.5856000}, {1170,17.9901429}, {1180,18.5142286}, {1190,19.1067143}, {1200,19.1279429}, {1210,19.5169714}, {1220,20.3435143}, {1230,21.0108571}, {1240,21.4640286}, {1250,21.4943143}, {1260,22.2866571}, {1270,22.5555143}, {1280,23.0279143}, {1290,23.4844000}, {1300,23.7645714}, {1310,24.4140571}, {1320,24.8693429}, {1330,25.6129714}, {1340,25.7764286}, {1350,26.8671429}, {1360,27.2248857}, {1370,27.1379429}, {1380,28.0402000}, {1390,28.2266857}, {1400,29.4077429}, {1410,29.9757143}, {1420,30.5424000}, {1430,30.9122571}, {1440,31.1855143}, {1450,31.7825429}, {1460,32.3984286}, {1470,33.0378857}, {1480,34.7754000}, {1490,34.6238571}, {1500,34.7163429}, {1510,35.7736857}, {1520,36.5760571}, {1530,36.5592000}, {1540,37.4523714}, {1550,38.4503143}, {1560,38.8587429}, {1570,39.6163714}, {1580,39.8854857}, {1590,40.6121143}, {1600,40.6719429}, {1610,42.8735429}, {1620,42.2905143}, {1630,43.4826857}, {1640,44.1978857}, {1650,44.7984857}, {1660,45.7798286}, {1670,45.8673714}, {1680,47.6534286}, {1690,47.9760571}, {1700,49.0546571}, {1710,50.3462571}, {1720,51.2320857}, {1730,50.9134857}, {1740,51.9352857}, {1750,51.8520000}, {1760,52.5592286}, {1770,53.8368571}, {1780,54.5792571}, {1790,55.4985429}, {1800,56.1528286}, {1810,57.5053143}, {1820,58.1418286}, {1830,58.4303143}, {1840,59.8489429}, {1850,60.3547429}, {1860,61.4926000}, {1870,63.4703714}, {1880,64.3514286}, {1890,64.6193429}, {1900,66.5726857}, {1910,67.3243714}, {1920,69.1472571}, {1930,67.9710000}, {1940,69.4814571}, {1950,72.4406000}, {1960,71.4164286}, {1970,73.2968000}, {1980,74.6616571}, {1990,75.0261429}, {2000,75.1705429}};
data["big"]["LtacTacInTermGallinaCtx"]["Aggregate"]["system"] = {{1,0.00007921}, {2,0.00000000}, {3,0.00007921}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00007921}, {8,0.00007921}, {9,0.00000000}, {10,0.00007921}, {11,0.00003960}, {12,0.00000000}, {13,0.00007921}, {14,0.00007921}, {15,0.00000000}, {16,0.00000000}, {17,0.00011881}, {18,0.00003960}, {19,0.00000000}, {20,0.00003960}, {21,0.00007921}, {22,0.00007921}, {23,0.00003960}, {24,0.00007921}, {25,0.00000000}, {26,0.00007921}, {27,0.00003960}, {28,0.00000000}, {29,0.00000000}, {30,0.00003960}, {31,0.00003960}, {32,0.00003960}, {33,0.00007921}, {34,0.00003960}, {35,0.00000000}, {36,0.00003960}, {37,0.00007921}, {38,0.00003960}, {39,0.00015842}, {40,0.00003960}, {41,0.00007921}, {42,0.00003960}, {43,0.00007921}, {44,0.00003960}, {45,0.00011881}, {46,0.00003960}, {47,0.00000000}, {48,0.00007921}, {49,0.00003960}, {50,0.00011881}, {51,0.00000000}, {52,0.00000000}, {53,0.00019802}, {54,0.00003960}, {55,0.00003960}, {56,0.00000000}, {57,0.00007921}, {58,0.00003960}, {59,0.00000000}, {60,0.00003960}, {61,0.00007921}, {62,0.00003960}, {63,0.00007921}, {64,0.00000000}, {65,0.00003960}, {66,0.00003960}, {67,0.00000000}, {68,0.00003960}, {69,0.00003960}, {70,0.00000000}, {71,0.00000000}, {72,0.00007921}, {73,0.00003960}, {74,0.00007921}, {75,0.00003960}, {76,0.00000000}, {77,0.00007921}, {78,0.00003960}, {79,0.00015842}, {80,0.00003960}, {81,0.00000000}, {82,0.00011881}, {83,0.00007921}, {84,0.00000000}, {85,0.00003960}, {86,0.00019802}, {87,0.00015842}, {88,0.00015842}, {89,0.00015842}, {90,0.00015842}, {91,0.00003960}, {92,0.00003960}, {93,0.00003960}, {94,0.00011881}, {95,0.00003960}, {96,0.00002970}, {97,0.00003960}, {98,0.00003960}, {99,0.00003960}, {100,0.00007921}, {101,0.00010891}, {102,0.00015842}, {103,0.00003960}, {104,0.00000000}, {105,0.00000000}, {106,0.00003960}, {107,0.00007921}, {108,0.00007921}, {109,0.00003960}, {110,0.00007921}, {111,0.00007921}, {112,0.00000000}, {113,0.00003960}, {114,0.00003960}, {115,0.00007921}, {116,0.00000000}, {117,0.00011881}, {118,0.00003960}, {119,0.00007921}, {120,0.00007921}, {121,0.00003960}, {122,0.00011881}, {123,0.00003960}, {124,0.00003960}, {125,0.00011881}, {126,0.00011881}, {127,0.00003960}, {128,0.00000000}, {129,0.00011881}, {130,0.00000000}, {131,0.00003960}, {132,0.00000000}, {133,0.00015842}, {134,0.00007921}, {135,0.00023762}, {136,0.00007921}, {137,0.00003960}, {138,0.00015842}, {139,0.00007921}, {140,0.00003960}, {141,0.00023762}, {142,0.00007921}, {143,0.00009901}, {144,0.00007921}, {145,0.00003960}, {146,0.00000000}, {147,0.00007921}, {148,0.00000000}, {149,0.00003960}, {150,0.00007921}, {151,0.00015842}, {152,0.00000000}, {153,0.00015842}, {154,0.00000000}, {155,0.00002970}, {156,0.00003960}, {157,0.00007921}, {158,0.00015842}, {159,0.00003960}, {160,0.00003960}, {161,0.00003960}, {162,0.00023762}, {163,0.00003960}, {164,0.00003960}, {165,0.00000000}, {166,0.00000000}, {167,0.00003960}, {168,0.00000000}, {169,0.00015842}, {170,0.00011881}, {171,0.00007921}, {172,0.00011881}, {173,0.00018812}, {174,0.00007921}, {175,0.00003960}, {176,0.00007921}, {177,0.00007921}, {178,0.00007921}, {179,0.00003960}, {180,0.00003960}, {181,0.00003960}, {182,0.00022772}, {183,0.00011881}, {184,0.00003960}, {185,0.00011881}, {186,0.00007921}, {187,0.00015842}, {188,0.00000000}, {189,0.00007921}, {190,0.00006931}, {191,0.00007921}, {192,0.00003960}, {193,0.00003960}, {194,0.00000000}, {195,0.00007921}, {196,0.00000000}, {197,0.00019802}, {198,0.00011881}, {199,0.00011881}, {200,0.00003960}, {201,0.00011881}, {202,0.00000000}, {203,0.00003960}, {204,0.00007921}, {205,0.00009901}, {206,0.00011881}, {207,0.00011881}, {208,0.00015842}, {209,0.00003960}, {210,0.00010891}, {211,0.00011881}, {212,0.00015842}, {213,0.00011881}, {214,0.00011881}, {215,0.00003960}, {216,0.00003960}, {217,0.00003960}, {218,0.00011881}, {219,0.00007921}, {220,0.00003960}, {221,0.00015842}, {222,0.00000000}, {223,0.00003960}, {224,0.00007921}, {225,0.00003960}, {226,0.00007921}, {227,0.00003960}, {228,0.00019802}, {229,0.00007921}, {230,0.00003960}, {231,0.00007921}, {232,0.00003960}, {233,0.00011881}, {234,0.00011881}, {235,0.00011881}, {236,0.00003960}, {237,0.00015842}, {238,0.00003960}, {239,0.00011881}, {240,0.00006931}, {241,0.00007921}, {242,0.00015842}, {243,0.00003960}, {244,0.00015842}, {245,0.00007921}, {246,0.00023762}, {247,0.00019802}, {248,0.00023762}, {249,0.00019802}, {250,0.00003960}, {251,0.00023762}, {252,0.00010891}, {253,0.00003960}, {254,0.00014851}, {255,0.00011881}, {256,0.00015842}, {257,0.00083168}, {258,0.00007921}, {259,0.00019802}, {260,0.00003960}, {261,0.00000000}, {262,0.00043564}, {263,0.00007921}, {264,0.00019802}, {265,0.00023762}, {266,0.00079208}, {267,0.00030693}, {268,0.00006931}, {269,0.00007921}, {270,0.00034653}, {271,0.00015842}, {272,0.00007921}, {273,0.00082178}, {274,0.00011881}, {275,0.00011881}, {276,0.00015842}, {277,0.00011881}, {278,0.00031683}, {279,0.00019802}, {280,0.00039604}, {281,0.00019802}, {282,0.00003960}, {283,0.00003960}, {284,0.00011881}, {285,0.00019802}, {286,0.00007921}, {287,0.00019802}, {288,0.00000000}, {289,0.00018812}, {290,0.00007921}, {291,0.00007921}, {292,0.00007921}, {293,0.00027723}, {294,0.00011881}, {295,0.00023762}, {296,0.00015842}, {297,0.00015842}, {298,0.00031683}, {299,0.00057426}, {300,0.00018812}, {301,0.0003429}, {302,0.0006857}, {303,0.0002286}, {304,0.0008000}, {305,0.0001143}, {306,0.0003429}, {307,0.0003429}, {308,0.0000000}, {309,0.0001143}, {310,0.0003429}, {311,0.0005714}, {312,0.0001143}, {313,0.0000000}, {314,0.0000000}, {315,0.0004571}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0002286}, {320,0.0000000}, {321,0.0001143}, {322,0.0003429}, {323,0.0001143}, {324,0.0000000}, {325,0.0003429}, {326,0.0000000}, {327,0.0002286}, {328,0.0003429}, {329,0.0001143}, {330,0.0002286}, {331,0.0000000}, {332,0.0003429}, {333,0.0002286}, {334,0.0002286}, {335,0.0002286}, {336,0.0003429}, {337,0.0003429}, {338,0.0000000}, {339,0.0002286}, {340,0.0001143}, {341,0.0003429}, {342,0.0000000}, {343,0.0001143}, {344,0.0002286}, {345,0.0000000}, {346,0.0003429}, {347,0.0002286}, {348,0.0001143}, {349,0.0004571}, {350,0.0003429}, {351,0.0003429}, {352,0.0003429}, {353,0.0000000}, {354,0.0001143}, {355,0.0000000}, {356,0.0000000}, {357,0.0001143}, {358,0.0002286}, {359,0.0002286}, {360,0.0001143}, {361,0.0002286}, {362,0.0002286}, {363,0.0000000}, {364,0.0004571}, {365,0.0003429}, {366,0.0003429}, {367,0.0001143}, {368,0.0001143}, {369,0.0003429}, {370,0.0004571}, {371,0.0001143}, {372,0.0000000}, {373,0.0002000}, {374,0.0002286}, {375,0.0001143}, {376,0.0004571}, {377,0.0005714}, {378,0.0002286}, {379,0.0003429}, {380,0.0005429}, {381,0.0003143}, {382,0.0001143}, {383,0.0003429}, {384,0.0002286}, {385,0.0003429}, {386,0.0005714}, {387,0.0005714}, {388,0.0004571}, {389,0.0003429}, {390,0.0005714}, {391,0.0003429}, {392,0.0004286}, {393,0.0003429}, {394,0.0003429}, {395,0.0003429}, {396,0.0004286}, {397,0.0004571}, {398,0.0004571}, {399,0.0002286}, {400,0.0005714}, {401,0.0004571}, {402,0.0003429}, {403,0.0004571}, {404,0.0003429}, {405,0.0001143}, {406,0.0003429}, {407,0.0002286}, {408,0.0003143}, {409,0.0002286}, {410,0.0005143}, {411,0.0005714}, {412,0.0004571}, {413,0.0006857}, {414,0.0003429}, {415,0.0001143}, {416,0.0002286}, {417,0.0002286}, {418,0.0001143}, {419,0.0003429}, {420,0.0003429}, {421,0.0002286}, {422,0.0005714}, {423,0.0003429}, {424,0.0006857}, {425,0.0002286}, {426,0.0004571}, {427,0.0011429}, {428,0.0004571}, {429,0.0006857}, {430,0.0003429}, {431,0.0006857}, {432,0.0004571}, {433,0.0002286}, {434,0.0003429}, {435,0.0002286}, {436,0.0003429}, {437,0.0003429}, {438,0.0003429}, {439,0.0006857}, {440,0.0003429}, {441,0.0006857}, {442,0.0006857}, {443,0.0005429}, {444,0.0002286}, {445,0.0005429}, {446,0.0004571}, {447,0.0003429}, {448,0.0012571}, {449,0.0002000}, {450,0.0002286}, {451,0.0002286}, {452,0.0001143}, {453,0.0002286}, {454,0.0004571}, {455,0.0000000}, {456,0.0003429}, {457,0.0004286}, {458,0.0008857}, {459,0.0003429}, {460,0.0003429}, {461,0.0003429}, {462,0.0003429}, {463,0.0008000}, {464,0.0004571}, {465,0.0010286}, {466,0.0006857}, {467,0.0006857}, {468,0.0008000}, {469,0.0006857}, {470,0.0003429}, {471,0.0003429}, {472,0.0008000}, {473,0.0006857}, {474,0.0005714}, {475,0.0005714}, {476,0.0008000}, {477,0.0001143}, {478,0.0004571}, {479,0.0002286}, {480,0.0011429}, {481,0.0004571}, {482,0.0002286}, {483,0.0010286}, {484,0.0012571}, {485,0.0003429}, {486,0.0004571}, {487,0.0005714}, {488,0.0021714}, {489,0.0002286}, {490,0.0008000}, {491,0.0004571}, {492,0.0001143}, {493,0.0003429}, {494,0.0012571}, {495,0.0010286}, {496,0.0003429}, {497,0.0004571}, {498,0.0009714}, {499,0.0006857}, {500,0.0003429}, {505,0.0006857}, {510,0.0005714}, {515,0.0013714}, {520,0.0013714}, {525,0.0008000}, {530,0.0006857}, {535,0.0012286}, {540,0.0010000}, {545,0.0004571}, {550,0.0004571}, {555,0.0010000}, {560,0.0005429}, {565,0.0010286}, {570,0.0008000}, {575,0.0010286}, {580,0.0012571}, {585,0.0009143}, {590,0.0010286}, {595,0.0025143}, {600,0.0008000}, {605,0.0010286}, {610,0.0025143}, {615,0.0014857}, {620,0.0014857}, {625,0.0026286}, {630,0.0032000}, {635,0.0018000}, {640,0.0021714}, {645,0.0021714}, {650,0.0026286}, {655,0.0029714}, {660,0.0016000}, {665,0.0016000}, {670,0.0027429}, {675,0.0022857}, {680,0.0025143}, {685,0.0034000}, {690,0.0016000}, {695,0.0030571}, {700,0.0020571}, {705,0.0017143}, {710,0.0022857}, {715,0.0024857}, {720,0.0027429}, {725,0.0008000}, {730,0.0026286}, {735,0.0019429}, {740,0.0033143}, {745,0.0032000}, {750,0.0014857}, {755,0.0023714}, {760,0.0018000}, {765,0.0020571}, {770,0.0025143}, {775,0.0045429}, {780,0.0043429}, {785,0.0035429}, {790,0.0034000}, {795,0.0038571}, {800,0.0026286}, {805,0.0027143}, {810,0.0032000}, {815,0.0038857}, {820,0.0051429}, {825,0.0029714}, {830,0.0027714}, {835,0.0043143}, {840,0.0034286}, {845,0.0054286}, {850,0.0068571}, {855,0.0045714}, {860,0.0065143}, {865,0.0042286}, {870,0.0045429}, {875,0.0044857}, {880,0.0078286}, {885,0.0056571}, {890,0.0042286}, {895,0.0062000}, {900,0.0071714}, {905,0.0089714}, {910,0.0074000}, {915,0.0059429}, {920,0.0069714}, {925,0.0105143}, {930,0.0074857}, {935,0.0097143}, {940,0.0074857}, {945,0.0072857}, {950,0.0080000}, {955,0.0075429}, {960,0.0057143}, {965,0.0103429}, {970,0.0088857}, {975,0.0102000}, {980,0.0065143}, {985,0.0093714}, {990,0.0112286}, {995,0.0063714}, {1000,0.0068000}, {1010,0.0055429}, {1020,0.0074000}, {1030,0.0098857}, {1040,0.0057714}, {1050,0.0052571}, {1060,0.0081714}, {1070,0.0136857}, {1080,0.0090000}, {1090,0.0080571}, {1100,0.0090571}, {1110,0.0127429}, {1120,0.0093714}, {1130,0.0109429}, {1140,0.0090857}, {1150,0.0086000}, {1160,0.0130857}, {1170,0.0143429}, {1180,0.0149714}, {1190,0.0147714}, {1200,0.0188000}, {1210,0.0200000}, {1220,0.0143143}, {1230,0.0113714}, {1240,0.0163143}, {1250,0.0167429}, {1260,0.0207714}, {1270,0.0211429}, {1280,0.0250857}, {1290,0.0144571}, {1300,0.0239429}, {1310,0.0170000}, {1320,0.0203429}, {1330,0.0204571}, {1340,0.0163143}, {1350,0.0180000}, {1360,0.0201429}, {1370,0.0226857}, {1380,0.0258000}, {1390,0.0190000}, {1400,0.0166857}, {1410,0.0236857}, {1420,0.0148571}, {1430,0.0240286}, {1440,0.0249429}, {1450,0.0188000}, {1460,0.0134571}, {1470,0.0257143}, {1480,0.0268571}, {1490,0.0211714}, {1500,0.0223714}, {1510,0.0220286}, {1520,0.0301143}, {1530,0.0324571}, {1540,0.0267714}, {1550,0.0213429}, {1560,0.0241714}, {1570,0.0276000}, {1580,0.0226857}, {1590,0.0315714}, {1600,0.0351143}, {1610,0.0274857}, {1620,0.0294000}, {1630,0.0332571}, {1640,0.0327143}, {1650,0.0352286}, {1660,0.0297143}, {1670,0.0330857}, {1680,0.0347714}, {1690,0.0373143}, {1700,0.0399429}, {1710,0.0412000}, {1720,0.0408571}, {1730,0.0359143}, {1740,0.0443429}, {1750,0.0412000}, {1760,0.0363143}, {1770,0.0412571}, {1780,0.0465714}, {1790,0.0480857}, {1800,0.0415143}, {1810,0.0434286}, {1820,0.0539143}, {1830,0.0417429}, {1840,0.0491429}, {1850,0.0522286}, {1860,0.0558571}, {1870,0.0547714}, {1880,0.0614571}, {1890,0.0476857}, {1900,0.0579143}, {1910,0.0653429}, {1920,0.0584571}, {1930,0.0441714}, {1940,0.0592286}, {1950,0.0628286}, {1960,0.0551429}, {1970,0.0581714}, {1980,0.0571143}, {1990,0.0497143}, {2000,0.0522857}};
data["big"]["LtacTacInTermGallinaCtx"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000990}, {3,0.00100000}, {4,0.00100000}, {5,0.00124752}, {6,0.00200000}, {7,0.00200000}, {8,0.00296040}, {9,0.00300000}, {10,0.00321782}, {11,0.00400000}, {12,0.00415842}, {13,0.00500000}, {14,0.00515842}, {15,0.00589109}, {16,0.00619802}, {17,0.00687129}, {18,0.00717822}, {19,0.00782178}, {20,0.00839604}, {21,0.00899010}, {22,0.00936634}, {23,0.01015842}, {24,0.01056436}, {25,0.01131683}, {26,0.01345545}, {27,0.01238614}, {28,0.01328713}, {29,0.01349505}, {30,0.01417822}, {31,0.01502970}, {32,0.01563366}, {33,0.01638614}, {34,0.01718812}, {35,0.01781188}, {36,0.01835644}, {37,0.01935644}, {38,0.01996040}, {39,0.02067327}, {40,0.02164356}, {41,0.02746535}, {42,0.02321782}, {43,0.02377228}, {44,0.02464356}, {45,0.02944554}, {46,0.02659406}, {47,0.02744554}, {48,0.02792079}, {49,0.02919802}, {50,0.02982178}, {51,0.03087129}, {52,0.03155446}, {53,0.03864356}, {54,0.03351485}, {55,0.03451485}, {56,0.04552475}, {57,0.03673267}, {58,0.03798020}, {59,0.03878218}, {60,0.03977228}, {61,0.04069307}, {62,0.04143564}, {63,0.04301980}, {64,0.04397030}, {65,0.04508911}, {66,0.04598020}, {67,0.05542574}, {68,0.04803960}, {69,0.04975248}, {70,0.06371287}, {71,0.05171287}, {72,0.06089109}, {73,0.05400000}, {74,0.07136634}, {75,0.05652475}, {76,0.07017822}, {77,0.07889109}, {78,0.06062376}, {79,0.06147525}, {80,0.06287129}, {81,0.06627723}, {82,0.07265347}, {83,0.07688119}, {84,0.07156436}, {85,0.08542574}, {86,0.09690099}, {87,0.08961386}, {88,0.10250495}, {89,0.12848515}, {90,0.10997030}, {91,0.09882178}, {92,0.09925743}, {93,0.10552475}, {94,0.10380198}, {95,0.10579208}, {96,0.10885149}, {97,0.10913861}, {98,0.11178218}, {99,0.11522772}, {100,0.11799010}, {101,0.12075248}, {102,0.12111881}, {103,0.12295050}, {104,0.12594059}, {105,0.12818812}, {106,0.13237624}, {107,0.13306931}, {108,0.13537624}, {109,0.12903960}, {110,0.13085149}, {111,0.13335644}, {112,0.13366337}, {113,0.13724752}, {114,0.13866337}, {115,0.14068317}, {116,0.14251485}, {117,0.14592079}, {118,0.14792079}, {119,0.14921782}, {120,0.15197030}, {121,0.15487129}, {122,0.15467327}, {123,0.16011881}, {124,0.16257426}, {125,0.16400990}, {126,0.16607921}, {127,0.16816832}, {128,0.17075248}, {129,0.17277228}, {130,0.17704950}, {131,0.17766337}, {132,0.18175248}, {133,0.18302970}, {134,0.18503960}, {135,0.18769307}, {136,0.18929703}, {137,0.19237624}, {138,0.19355446}, {139,0.19840594}, {140,0.20032673}, {141,0.20199010}, {142,0.20665347}, {143,0.20670297}, {144,0.20874257}, {145,0.21302970}, {146,0.21535644}, {147,0.21720792}, {148,0.21983168}, {149,0.22211881}, {150,0.22654455}, {151,0.23023762}, {152,0.23116832}, {153,0.23478218}, {154,0.23855446}, {155,0.23930693}, {156,0.24214851}, {157,0.24667327}, {158,0.24833663}, {159,0.25301980}, {160,0.25132673}, {161,0.25443564}, {162,0.25806931}, {163,0.26025743}, {164,0.26338614}, {165,0.26724752}, {166,0.27201980}, {167,0.27315842}, {168,0.27918812}, {169,0.28198020}, {170,0.28143564}, {171,0.28422772}, {172,0.28922772}, {173,0.29274257}, {174,0.29569307}, {175,0.29819802}, {176,0.30118812}, {177,0.30430693}, {178,0.30729703}, {179,0.30966337}, {180,0.31067327}, {181,0.31403960}, {182,0.31749505}, {183,0.32117822}, {184,0.32437624}, {185,0.32715842}, {186,0.33053465}, {187,0.33257426}, {188,0.33550495}, {189,0.34026733}, {190,0.34357426}, {191,0.34717822}, {192,0.35074257}, {193,0.35635644}, {194,0.36572277}, {195,0.37139604}, {196,0.37154455}, {197,0.37186139}, {198,0.37248515}, {199,0.37794059}, {200,0.38174257}, {201,0.38618812}, {202,0.39858416}, {203,0.39967327}, {204,0.39263366}, {205,0.39660396}, {206,0.39678218}, {207,0.41193069}, {208,0.42166337}, {209,0.41558416}, {210,0.41459406}, {211,0.41659406}, {212,0.43303960}, {213,0.43076238}, {214,0.42567327}, {215,0.43308911}, {216,0.44889109}, {217,0.44433663}, {218,0.44382178}, {219,0.46078218}, {220,0.45581188}, {221,0.45700990}, {222,0.47432673}, {223,0.46855446}, {224,0.47445545}, {225,0.47824752}, {226,0.48061386}, {227,0.49486139}, {228,0.48565347}, {229,0.49851485}, {230,0.49563366}, {231,0.50559406}, {232,0.50867327}, {233,0.51018812}, {234,0.51546535}, {235,0.52210891}, {236,0.52201980}, {237,0.53394059}, {238,0.52891089}, {239,0.54576238}, {240,0.53810891}, {241,0.54948515}, {242,0.55156436}, {243,0.55586139}, {244,0.56381188}, {245,0.56760396}, {246,0.56508911}, {247,0.57657426}, {248,0.57281188}, {249,0.58304950}, {250,0.59037624}, {251,0.58505941}, {252,0.59399010}, {253,0.60561386}, {254,0.59861386}, {255,0.60754455}, {256,0.62054455}, {257,0.61467327}, {258,0.61800000}, {259,0.62465347}, {260,0.63082178}, {261,0.63931683}, {262,0.73195050}, {263,0.64900000}, {264,0.65031683}, {265,0.65012871}, {266,0.70002970}, {267,0.66559406}, {268,0.67178218}, {269,0.67347525}, {270,0.67758416}, {271,0.68366337}, {272,0.68709901}, {273,0.69773267}, {274,0.70562376}, {275,0.75395050}, {276,0.71451485}, {277,0.71947525}, {278,0.72566337}, {279,0.72994059}, {280,0.73316832}, {281,0.74188119}, {282,0.75341584}, {283,0.75487129}, {284,0.75698020}, {285,0.76440594}, {286,0.76627723}, {287,0.77076238}, {288,0.79371287}, {289,0.78313861}, {290,0.78410891}, {291,0.79121782}, {292,0.78710891}, {293,0.79126733}, {294,0.79633663}, {295,0.80638614}, {296,0.81446535}, {297,0.82925743}, {298,0.83046535}, {299,0.82818812}, {300,0.82584158}, {301,0.8706000}, {302,0.9865143}, {303,0.8886857}, {304,0.8964857}, {305,0.9076286}, {306,0.9033714}, {307,0.9108000}, {308,0.9280286}, {309,0.9180286}, {310,0.9208857}, {311,0.9396000}, {312,0.9437714}, {313,0.9485143}, {314,0.9555143}, {315,0.9598571}, {316,0.9645143}, {317,0.9680571}, {318,1.0332571}, {319,0.9839143}, {320,0.9876286}, {321,0.9954000}, {322,0.9990857}, {323,0.9991143}, {324,1.0073143}, {325,1.0121714}, {326,1.0181714}, {327,1.0318286}, {328,1.0298857}, {329,1.0456286}, {330,1.0444000}, {331,1.0610286}, {332,1.0596571}, {333,1.0611143}, {334,1.0692000}, {335,1.0714000}, {336,1.0834857}, {337,1.0808857}, {338,1.0937714}, {339,1.0929143}, {340,1.1080286}, {341,1.1094286}, {342,1.1263429}, {343,1.1324286}, {344,1.1475143}, {345,1.1462571}, {346,1.1548286}, {347,1.1544571}, {348,1.1636857}, {349,1.1710286}, {350,1.1846286}, {351,1.1930571}, {352,1.1891714}, {353,1.1954571}, {354,1.2041429}, {355,1.2127714}, {356,1.2143429}, {357,1.2279714}, {358,1.2267429}, {359,1.2336286}, {360,1.2373429}, {361,1.2535429}, {362,1.2537143}, {363,1.2929143}, {364,1.2719429}, {365,1.2759143}, {366,1.2745429}, {367,1.2985429}, {368,1.3254571}, {369,1.3005429}, {370,1.3153429}, {371,1.3243143}, {372,1.3290000}, {373,1.3330857}, {374,1.3516286}, {375,1.3577714}, {376,1.3600571}, {377,1.3691143}, {378,1.3692286}, {379,1.3752857}, {380,1.3951714}, {381,1.3974000}, {382,1.4045429}, {383,1.4191429}, {384,1.4280286}, {385,1.4321143}, {386,1.4483143}, {387,1.4864286}, {388,1.4573429}, {389,1.4789429}, {390,1.4778571}, {391,1.4896286}, {392,1.4906571}, {393,1.4963143}, {394,1.5036857}, {395,1.5135143}, {396,1.5267429}, {397,1.5383143}, {398,1.5408857}, {399,1.5506000}, {400,1.5624857}, {401,1.5733429}, {402,1.5829714}, {403,1.6022286}, {404,1.6046571}, {405,1.6164286}, {406,1.6280857}, {407,1.6333714}, {408,1.6603714}, {409,1.6661429}, {410,1.6770286}, {411,1.6467429}, {412,1.7032571}, {413,1.6665143}, {414,1.6764857}, {415,1.7106286}, {416,1.7437714}, {417,1.6921143}, {418,1.7241143}, {419,1.7597429}, {420,1.7819143}, {421,1.8127429}, {422,1.7258286}, {423,1.7347143}, {424,1.7431143}, {425,1.7591714}, {426,1.8045143}, {427,1.8896571}, {428,1.7992000}, {429,1.8385429}, {430,1.8164571}, {431,1.8596000}, {432,1.9125714}, {433,1.9249714}, {434,1.8884857}, {435,1.8905714}, {436,1.8678857}, {437,1.9044286}, {438,1.9234857}, {439,1.9458000}, {440,2.0167143}, {441,1.9515429}, {442,1.9982286}, {443,2.0060000}, {444,1.9782571}, {445,1.9590857}, {446,1.9640286}, {447,1.9803143}, {448,2.0188286}, {449,2.0081143}, {450,2.0187429}, {451,2.0032857}, {452,2.0156000}, {453,2.0318286}, {454,2.0507429}, {455,2.0559714}, {456,2.0664857}, {457,2.0775714}, {458,2.1231714}, {459,2.1194857}, {460,2.1318000}, {461,2.1571143}, {462,2.1713714}, {463,2.1280286}, {464,2.1573143}, {465,2.2244000}, {466,2.2368000}, {467,2.2511429}, {468,2.3394857}, {469,2.2461143}, {470,2.2318571}, {471,2.2823143}, {472,2.3062000}, {473,2.2638286}, {474,2.3069429}, {475,2.3074286}, {476,2.2988571}, {477,2.2606857}, {478,2.2971429}, {479,2.3141143}, {480,2.3234571}, {481,2.3276286}, {482,2.3691143}, {483,2.3716571}, {484,2.4311143}, {485,2.3686857}, {486,2.3944286}, {487,2.3819429}, {488,2.5471714}, {489,2.3915143}, {490,2.4006286}, {491,2.5036571}, {492,2.4091143}, {493,2.4395429}, {494,2.5130571}, {495,2.5617714}, {496,2.4981714}, {497,2.5011429}, {498,2.5482857}, {499,2.5419143}, {500,2.5583143}, {505,2.6036286}, {510,2.7000571}, {515,2.7710571}, {520,2.9500286}, {525,2.9862571}, {530,2.8893143}, {535,2.9554857}, {540,3.0270286}, {545,3.0880000}, {550,3.1595143}, {555,3.2322857}, {560,3.2292857}, {565,3.2624571}, {570,3.3300286}, {575,3.4150286}, {580,3.4748571}, {585,3.5121429}, {590,3.6132286}, {595,3.7330857}, {600,3.7724857}, {605,3.8889714}, {610,3.9156286}, {615,4.0336857}, {620,4.0886286}, {625,4.1035143}, {630,4.2167429}, {635,4.2393143}, {640,4.3188857}, {645,4.2807143}, {650,4.3836571}, {655,4.5056857}, {660,4.5608000}, {665,4.5822286}, {670,4.7296571}, {675,4.9903429}, {680,4.9779714}, {685,5.0349429}, {690,5.1957429}, {695,5.1945714}, {700,5.3326857}, {705,5.4333714}, {710,5.4696286}, {715,5.4410571}, {720,5.6150000}, {725,5.6408857}, {730,5.7944286}, {735,5.7821429}, {740,6.0237714}, {745,6.2130000}, {750,6.2866571}, {755,6.2757714}, {760,6.4423714}, {765,6.5629143}, {770,6.6380857}, {775,6.8821429}, {780,6.8866000}, {785,6.9547429}, {790,7.1346286}, {795,7.0904571}, {800,7.2422286}, {805,7.5226857}, {810,7.3997714}, {815,7.6134571}, {820,7.5954000}, {825,7.7708571}, {830,7.8173714}, {835,7.8488000}, {840,8.1199429}, {845,8.3370571}, {850,8.4676286}, {855,8.6894000}, {860,8.7194571}, {865,9.1618571}, {870,9.0856000}, {875,9.1720286}, {880,9.2560286}, {885,9.1993143}, {890,9.6066571}, {895,9.7151143}, {900,9.5606000}, {905,9.8962571}, {910,9.8846286}, {915,10.0431714}, {920,10.1428000}, {925,10.3347714}, {930,10.2802000}, {935,10.5656857}, {940,10.5586571}, {945,10.6076286}, {950,10.7731143}, {955,11.0132571}, {960,10.8924000}, {965,11.2657143}, {970,11.2620571}, {975,11.3352857}, {980,11.5403429}, {985,11.6240000}, {990,12.0185714}, {995,11.8149143}, {1000,11.9686571}, {1010,12.1924286}, {1020,12.7172571}, {1030,12.8886857}, {1040,13.3270000}, {1050,13.7571714}, {1060,14.1787143}, {1070,14.4913429}, {1080,14.7080000}, {1090,15.0495143}, {1100,15.2341143}, {1110,15.8840857}, {1120,15.9460286}, {1130,16.6863143}, {1140,16.9866000}, {1150,16.9268571}, {1160,17.5997143}, {1170,18.0020000}, {1180,18.5377429}, {1190,19.1227714}, {1200,19.1496000}, {1210,19.5407714}, {1220,20.3610857}, {1230,21.0326000}, {1240,21.5004000}, {1250,21.5374000}, {1260,22.3241143}, {1270,22.5926571}, {1280,23.0718286}, {1290,23.5105714}, {1300,23.7986000}, {1310,24.4320286}, {1320,24.8986857}, {1330,25.6352000}, {1340,25.8069429}, {1350,26.8940857}, {1360,27.2558857}, {1370,27.1790000}, {1380,28.0721429}, {1390,28.2600571}, {1400,29.4290857}, {1410,30.0045714}, {1420,30.5650000}, {1430,30.9453143}, {1440,31.2299714}, {1450,31.8226286}, {1460,32.4373143}, {1470,33.0839714}, {1480,34.8095714}, {1490,34.6510571}, {1500,34.7489143}, {1510,35.8254000}, {1520,36.6178857}, {1530,36.6078000}, {1540,37.5008286}, {1550,38.5021714}, {1560,38.8963143}, {1570,39.6622286}, {1580,39.9387143}, {1590,40.6835429}, {1600,40.7309429}, {1610,42.9179714}, {1620,42.3318857}, {1630,43.5345429}, {1640,44.2455429}, {1650,44.8626571}, {1660,45.8235714}, {1670,45.9354000}, {1680,47.7100286}, {1690,48.0360286}, {1700,49.1289714}, {1710,50.4136571}, {1720,51.3150571}, {1730,50.9862000}, {1740,52.0243429}, {1750,51.9257429}, {1760,52.6252000}, {1770,53.9084857}, {1780,54.6586571}, {1790,55.5650000}, {1800,56.2122286}, {1810,57.5530857}, {1820,58.2006857}, {1830,58.4978571}, {1840,59.9438571}, {1850,60.4384857}, {1860,61.6086286}, {1870,63.5586286}, {1880,64.4466571}, {1890,64.7017429}, {1900,66.6452000}, {1910,67.3933143}, {1920,69.2163714}, {1930,68.0336857}, {1940,69.5608286}, {1950,72.4944857}, {1960,71.7084857}, {1970,73.3477429}, {1980,74.7108000}, {1990,75.0665429}, {2000,75.2271143}};
data["big"]["LtacTacInTermGallinaCtx"]["actual reif"]["user"] = {{1,0.00037624}, {2,0.00076238}, {3,0.00134653}, {4,0.00136634}, {5,0.00201980}, {6,0.00231683}, {7,0.00299010}, {8,0.00306931}, {9,0.00332673}, {10,0.00363366}, {11,0.00401980}, {12,0.00460396}, {13,0.00455446}, {14,0.00540594}, {15,0.00583168}, {16,0.00636634}, {17,0.00709901}, {18,0.00734653}, {19,0.00793069}, {20,0.00842574}, {21,0.00914851}, {22,0.00925743}, {23,0.00998020}, {24,0.01059406}, {25,0.01123762}, {26,0.01314851}, {27,0.01205941}, {28,0.01308911}, {29,0.01342574}, {30,0.01393069}, {31,0.01488119}, {32,0.01554455}, {33,0.01595050}, {34,0.01669307}, {35,0.01745545}, {36,0.01818812}, {37,0.01904950}, {38,0.01959406}, {39,0.02095050}, {40,0.02141584}, {41,0.02757426}, {42,0.02340594}, {43,0.02404950}, {44,0.02522772}, {45,0.02949505}, {46,0.02699010}, {47,0.02776238}, {48,0.02831683}, {49,0.02940594}, {50,0.03026733}, {51,0.03104950}, {52,0.03185149}, {53,0.03836634}, {54,0.03367327}, {55,0.03454455}, {56,0.04525743}, {57,0.03647525}, {58,0.03770297}, {59,0.03840594}, {60,0.03906931}, {61,0.04009901}, {62,0.04089109}, {63,0.04244554}, {64,0.04370297}, {65,0.04481188}, {66,0.04595050}, {67,0.05541584}, {68,0.04852475}, {69,0.05018812}, {70,0.06370297}, {71,0.05189109}, {72,0.06046535}, {73,0.05392079}, {74,0.07082178}, {75,0.05630693}, {76,0.07028713}, {77,0.07865347}, {78,0.06043564}, {79,0.06108911}, {80,0.06248515}, {81,0.06611881}, {82,0.07264356}, {83,0.07735644}, {84,0.07161386}, {85,0.08505941}, {86,0.09665347}, {87,0.08908911}, {88,0.10216832}, {89,0.12769307}, {90,0.10970297}, {91,0.09864356}, {92,0.09914851}, {93,0.10554455}, {94,0.10370297}, {95,0.10576238}, {96,0.10861386}, {97,0.10909901}, {98,0.11152475}, {99,0.11483168}, {100,0.11777228}, {101,0.12058416}, {102,0.12106931}, {103,0.12300990}, {104,0.12570297}, {105,0.12785149}, {106,0.13200000}, {107,0.13252475}, {108,0.13533663}, {109,0.12888119}, {110,0.13045545}, {111,0.13289109}, {112,0.13342574}, {113,0.13699010}, {114,0.13877228}, {115,0.14016832}, {116,0.14216832}, {117,0.14560396}, {118,0.14768317}, {119,0.14907921}, {120,0.15183168}, {121,0.15450495}, {122,0.15427723}, {123,0.15997030}, {124,0.16209901}, {125,0.16352475}, {126,0.16563366}, {127,0.16808911}, {128,0.17046535}, {129,0.17239604}, {130,0.17717822}, {131,0.17756436}, {132,0.18110891}, {133,0.18289109}, {134,0.18457426}, {135,0.18699010}, {136,0.18881188}, {137,0.19195050}, {138,0.19300000}, {139,0.19838614}, {140,0.19990099}, {141,0.20155446}, {142,0.20615842}, {143,0.20642574}, {144,0.20810891}, {145,0.21235644}, {146,0.21497030}, {147,0.21692079}, {148,0.21943564}, {149,0.22162376}, {150,0.22607921}, {151,0.22984158}, {152,0.23079208}, {153,0.23441584}, {154,0.23838614}, {155,0.23871287}, {156,0.24154455}, {157,0.24633663}, {158,0.24742574}, {159,0.25245545}, {160,0.25069307}, {161,0.25431683}, {162,0.25704950}, {163,0.25956436}, {164,0.26276238}, {165,0.26677228}, {166,0.27164356}, {167,0.27242574}, {168,0.27857426}, {169,0.28154455}, {170,0.28057426}, {171,0.28339604}, {172,0.28876238}, {173,0.29187129}, {174,0.29506931}, {175,0.29766337}, {176,0.30018812}, {177,0.30363366}, {178,0.30672277}, {179,0.30896040}, {180,0.31000000}, {181,0.31348515}, {182,0.31669307}, {183,0.32033663}, {184,0.32357426}, {185,0.32607921}, {186,0.32974257}, {187,0.33200990}, {188,0.33514851}, {189,0.33980198}, {190,0.34298020}, {191,0.34655446}, {192,0.35009901}, {193,0.35559406}, {194,0.36472277}, {195,0.37051485}, {196,0.37050495}, {197,0.37147525}, {198,0.37155446}, {199,0.37701980}, {200,0.38089109}, {201,0.38562376}, {202,0.39776238}, {203,0.39893069}, {204,0.39159406}, {205,0.39575248}, {206,0.39616832}, {207,0.41098020}, {208,0.42094059}, {209,0.41487129}, {210,0.41359406}, {211,0.41553465}, {212,0.43202970}, {213,0.43004950}, {214,0.42506931}, {215,0.43237624}, {216,0.44797030}, {217,0.44346535}, {218,0.44300000}, {219,0.46000000}, {220,0.45507921}, {221,0.45623762}, {222,0.47349505}, {223,0.46814851}, {224,0.47380198}, {225,0.47761386}, {226,0.48000000}, {227,0.49410891}, {228,0.48498020}, {229,0.49796040}, {230,0.49450495}, {231,0.50468317}, {232,0.50771287}, {233,0.50921782}, {234,0.51467327}, {235,0.52115842}, {236,0.52098020}, {237,0.53300000}, {238,0.52832673}, {239,0.54528713}, {240,0.53757426}, {241,0.54833663}, {242,0.55062376}, {243,0.55477228}, {244,0.56261386}, {245,0.56661386}, {246,0.56366337}, {247,0.57530693}, {248,0.57168317}, {249,0.58183168}, {250,0.58954455}, {251,0.58354455}, {252,0.59246535}, {253,0.60459406}, {254,0.59775248}, {255,0.60605941}, {256,0.61924752}, {257,0.61297030}, {258,0.61673267}, {259,0.62344554}, {260,0.62996040}, {261,0.63825743}, {262,0.73060396}, {263,0.64787129}, {264,0.64945545}, {265,0.64850495}, {266,0.69810891}, {267,0.66419802}, {268,0.67071287}, {269,0.67225743}, {270,0.67629703}, {271,0.68258416}, {272,0.68587129}, {273,0.69598020}, {274,0.70463366}, {275,0.75279208}, {276,0.71344554}, {277,0.71861386}, {278,0.72395050}, {279,0.72850495}, {280,0.73139604}, {281,0.74060396}, {282,0.75230693}, {283,0.75372277}, {284,0.75601980}, {285,0.76308911}, {286,0.76500000}, {287,0.76891089}, {288,0.79252475}, {289,0.78190099}, {290,0.78300000}, {291,0.78975248}, {292,0.78560396}, {293,0.78973267}, {294,0.79493069}, {295,0.80472277}, {296,0.81263366}, {297,0.82768317}, {298,0.82840594}, {299,0.82632673}, {300,0.82417822}, {301,0.8693714}, {302,0.9843714}, {303,0.8880857}, {304,0.8949429}, {305,0.9062286}, {306,0.9018857}, {307,0.9094286}, {308,0.9266571}, {309,0.9172286}, {310,0.9193714}, {311,0.9379143}, {312,0.9429714}, {313,0.9472571}, {314,0.9547714}, {315,0.9583429}, {316,0.9636571}, {317,0.9670286}, {318,1.0322286}, {319,0.9805143}, {320,0.9862571}, {321,0.9948857}, {322,0.9984571}, {323,0.9983429}, {324,1.0058857}, {325,1.0112571}, {326,1.0166571}, {327,1.0299429}, {328,1.0284286}, {329,1.0426571}, {330,1.0407143}, {331,1.0524000}, {332,1.0493429}, {333,1.0554571}, {334,1.0656286}, {335,1.0689143}, {336,1.0824286}, {337,1.0797429}, {338,1.0927143}, {339,1.0914000}, {340,1.1068571}, {341,1.1079429}, {342,1.1249714}, {343,1.1313429}, {344,1.1458000}, {345,1.1449429}, {346,1.1533429}, {347,1.1536286}, {348,1.1626571}, {349,1.1693429}, {350,1.1828000}, {351,1.1918000}, {352,1.1879714}, {353,1.1943143}, {354,1.2030571}, {355,1.2114571}, {356,1.2137714}, {357,1.2267143}, {358,1.2248571}, {359,1.2327714}, {360,1.2356571}, {361,1.2518286}, {362,1.2525143}, {363,1.2916571}, {364,1.2699714}, {365,1.2747714}, {366,1.2724571}, {367,1.2972286}, {368,1.3243429}, {369,1.2989429}, {370,1.3140000}, {371,1.3223714}, {372,1.3276286}, {373,1.3318286}, {374,1.3505143}, {375,1.3564286}, {376,1.3585429}, {377,1.3664571}, {378,1.3670286}, {379,1.3729429}, {380,1.3922286}, {381,1.3950286}, {382,1.4020571}, {383,1.4158571}, {384,1.4258286}, {385,1.4295143}, {386,1.4460286}, {387,1.4841429}, {388,1.4542857}, {389,1.4771429}, {390,1.4746000}, {391,1.4874857}, {392,1.4884571}, {393,1.4946857}, {394,1.5020286}, {395,1.5119714}, {396,1.5248857}, {397,1.5355714}, {398,1.5388286}, {399,1.5483714}, {400,1.5591714}, {401,1.5715143}, {402,1.5804000}, {403,1.5985429}, {404,1.5944286}, {405,1.6116857}, {406,1.6191143}, {407,1.6296000}, {408,1.6527429}, {409,1.6617429}, {410,1.6735143}, {411,1.6432571}, {412,1.7000571}, {413,1.6635714}, {414,1.6731429}, {415,1.7076286}, {416,1.7408000}, {417,1.6896286}, {418,1.7216857}, {419,1.7570571}, {420,1.7792571}, {421,1.8109143}, {422,1.7234286}, {423,1.7320000}, {424,1.7405143}, {425,1.7560571}, {426,1.8012286}, {427,1.8861714}, {428,1.7963143}, {429,1.8340571}, {430,1.8122000}, {431,1.8553429}, {432,1.9083714}, {433,1.9213429}, {434,1.8857143}, {435,1.8871714}, {436,1.8637429}, {437,1.9014000}, {438,1.9190286}, {439,1.9412571}, {440,2.0124571}, {441,1.9472286}, {442,1.9937429}, {443,2.0019143}, {444,1.9743714}, {445,1.9547714}, {446,1.9601143}, {447,1.9763143}, {448,2.0134286}, {449,2.0036286}, {450,2.0153143}, {451,2.0002286}, {452,2.0126000}, {453,2.0278571}, {454,2.0465143}, {455,2.0524857}, {456,2.0623143}, {457,2.0736000}, {458,2.1191429}, {459,2.1162000}, {460,2.1283143}, {461,2.1532857}, {462,2.1683714}, {463,2.1241429}, {464,2.1543714}, {465,2.2202000}, {466,2.2330571}, {467,2.2481714}, {468,2.3358571}, {469,2.2427714}, {470,2.2273429}, {471,2.2777143}, {472,2.3017429}, {473,2.2590571}, {474,2.3026857}, {475,2.3030857}, {476,2.2944000}, {477,2.2570000}, {478,2.2927714}, {479,2.3092857}, {480,2.3174857}, {481,2.3227143}, {482,2.3636286}, {483,2.3642000}, {484,2.4241714}, {485,2.3633714}, {486,2.3882571}, {487,2.3760000}, {488,2.5397714}, {489,2.3862857}, {490,2.3945714}, {491,2.4984286}, {492,2.4041143}, {493,2.4340571}, {494,2.5060571}, {495,2.5555143}, {496,2.4931429}, {497,2.4960286}, {498,2.5419429}, {499,2.5361714}, {500,2.5532286}, {505,2.5981143}, {510,2.6938571}, {515,2.7635429}, {520,2.9414857}, {525,2.9782286}, {530,2.8811714}, {535,2.9464286}, {540,3.0179143}, {545,3.0797143}, {550,3.1501143}, {555,3.2226000}, {560,3.2198286}, {565,3.2539429}, {570,3.3218571}, {575,3.4056000}, {580,3.4648000}, {585,3.5032286}, {590,3.6045143}, {595,3.7225429}, {600,3.7638000}, {605,3.8812000}, {610,3.9059429}, {615,4.0251714}, {620,4.0803143}, {625,4.0923714}, {630,4.2044000}, {635,4.2291714}, {640,4.3098857}, {645,4.2726571}, {650,4.3770000}, {655,4.4988571}, {660,4.5552286}, {665,4.5748571}, {670,4.7218000}, {675,4.9832857}, {680,4.9691714}, {685,5.0247714}, {690,5.1872000}, {695,5.1852286}, {700,5.3232000}, {705,5.4268857}, {710,5.4621714}, {715,5.4305143}, {720,5.6051143}, {725,5.6300000}, {730,5.7822000}, {735,5.7746857}, {740,6.0129429}, {745,6.2038286}, {750,6.2789714}, {755,6.2681143}, {760,6.4352286}, {765,6.5538286}, {770,6.6273143}, {775,6.8679143}, {780,6.8746286}, {785,6.9436857}, {790,7.1104857}, {795,7.0801714}, {800,7.2151429}, {805,7.4864857}, {810,7.3854286}, {815,7.5962000}, {820,7.5797429}, {825,7.7535143}, {830,7.8033429}, {835,7.8335714}, {840,8.1067429}, {845,8.3191429}, {850,8.4503143}, {855,8.6741429}, {860,8.7030857}, {865,9.1473714}, {870,9.0739714}, {875,9.1616571}, {880,9.2453714}, {885,9.1913143}, {890,9.5986000}, {895,9.7036000}, {900,9.5477714}, {905,9.8772857}, {910,9.8640857}, {915,10.0274286}, {920,10.1240000}, {925,10.3134286}, {930,10.2582857}, {935,10.5435714}, {940,10.5379429}, {945,10.5900286}, {950,10.7589143}, {955,10.9976000}, {960,10.8785429}, {965,11.2389429}, {970,11.2375429}, {975,11.3081143}, {980,11.5161143}, {985,11.5942857}, {990,11.9829429}, {995,11.7844286}, {1000,11.9366571}, {1010,12.1584857}, {1020,12.6850000}, {1030,12.8503714}, {1040,13.3003143}, {1050,13.7303714}, {1060,14.1501714}, {1070,14.4500286}, {1080,14.6690286}, {1090,15.0282000}, {1100,15.2090000}, {1110,15.8458857}, {1120,15.9126857}, {1130,16.6532000}, {1140,16.9578286}, {1150,16.9012286}, {1160,17.5708857}, {1170,17.9749143}, {1180,18.4998571}, {1190,19.0898857}, {1200,19.1132000}, {1210,19.5028571}, {1220,20.3288000}, {1230,20.9949429}, {1240,21.4476857}, {1250,21.4784857}, {1260,22.2700000}, {1270,22.5385429}, {1280,23.0116857}, {1290,23.4683714}, {1300,23.7483714}, {1310,24.3967143}, {1320,24.8529143}, {1330,25.5961143}, {1340,25.7593429}, {1350,26.8503714}, {1360,27.2082286}, {1370,27.1212286}, {1380,28.0227143}, {1390,28.2084000}, {1400,29.3901429}, {1410,29.9584000}, {1420,30.5234286}, {1430,30.8947714}, {1440,31.1677143}, {1450,31.7641714}, {1460,32.3800000}, {1470,33.0206571}, {1480,34.7500286}, {1490,34.6052286}, {1500,34.6968000}, {1510,35.7548857}, {1520,36.5569429}, {1530,36.5404000}, {1540,37.4333143}, {1550,38.4302857}, {1560,38.8396000}, {1570,39.5967714}, {1580,39.8661429}, {1590,40.5890571}, {1600,40.6527714}, {1610,42.8526286}, {1620,42.2701143}, {1630,43.4623143}, {1640,44.1776571}, {1650,44.7776857}, {1660,45.7594286}, {1670,45.8453143}, {1680,47.6324857}, {1690,47.9549429}, {1700,49.0330000}, {1710,50.3250857}, {1720,51.2079143}, {1730,50.8917143}, {1740,51.9133714}, {1750,51.8305429}, {1760,52.5368857}, {1770,53.8132571}, {1780,54.5566571}, {1790,55.4767714}, {1800,56.1303143}, {1810,57.4815429}, {1820,58.1200000}, {1830,58.4077143}, {1840,59.8237143}, {1850,60.3315714}, {1860,61.4694571}, {1870,63.4474286}, {1880,64.3271714}, {1890,64.5939714}, {1900,66.5485143}, {1910,67.2977143}, {1920,69.1228286}, {1930,67.9464000}, {1940,69.4489429}, {1950,72.4165429}, {1960,71.3925714}, {1970,73.2720857}, {1980,74.6366857}, {1990,74.9919429}, {2000,75.1398857}};
data["big"]["LtacTacInTermGallinaCtx"]["actual reif"]["system"] = {{1,0.00003960}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00007921}, {8,0.00007921}, {9,0.00000000}, {10,0.00007921}, {11,0.00003960}, {12,0.00000000}, {13,0.00007921}, {14,0.00007921}, {15,0.00000000}, {16,0.00000000}, {17,0.00007921}, {18,0.00003960}, {19,0.00000000}, {20,0.00003960}, {21,0.00003960}, {22,0.00007921}, {23,0.00003960}, {24,0.00007921}, {25,0.00000000}, {26,0.00003960}, {27,0.00003960}, {28,0.00000000}, {29,0.00000000}, {30,0.00003960}, {31,0.00003960}, {32,0.00003960}, {33,0.00003960}, {34,0.00003960}, {35,0.00000000}, {36,0.00003960}, {37,0.00003960}, {38,0.00003960}, {39,0.00007921}, {40,0.00000000}, {41,0.00003960}, {42,0.00003960}, {43,0.00007921}, {44,0.00003960}, {45,0.00011881}, {46,0.00003960}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00003960}, {51,0.00000000}, {52,0.00000000}, {53,0.00015842}, {54,0.00003960}, {55,0.00003960}, {56,0.00000000}, {57,0.00003960}, {58,0.00003960}, {59,0.00000000}, {60,0.00000000}, {61,0.00003960}, {62,0.00000000}, {63,0.00007921}, {64,0.00000000}, {65,0.00003960}, {66,0.00003960}, {67,0.00000000}, {68,0.00000000}, {69,0.00003960}, {70,0.00000000}, {71,0.00000000}, {72,0.00007921}, {73,0.00003960}, {74,0.00007921}, {75,0.00000000}, {76,0.00000000}, {77,0.00007921}, {78,0.00003960}, {79,0.00007921}, {80,0.00000000}, {81,0.00000000}, {82,0.00011881}, {83,0.00003960}, {84,0.00000000}, {85,0.00003960}, {86,0.00007921}, {87,0.00003960}, {88,0.00007921}, {89,0.00015842}, {90,0.00011881}, {91,0.00003960}, {92,0.00000000}, {93,0.00000000}, {94,0.00003960}, {95,0.00000000}, {96,0.00000000}, {97,0.00003960}, {98,0.00003960}, {99,0.00003960}, {100,0.00007921}, {101,0.00010891}, {102,0.00015842}, {103,0.00003960}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00007921}, {108,0.00003960}, {109,0.00003960}, {110,0.00003960}, {111,0.00003960}, {112,0.00000000}, {113,0.00003960}, {114,0.00003960}, {115,0.00000000}, {116,0.00000000}, {117,0.00003960}, {118,0.00003960}, {119,0.00007921}, {120,0.00007921}, {121,0.00000000}, {122,0.00003960}, {123,0.00000000}, {124,0.00003960}, {125,0.00011881}, {126,0.00000000}, {127,0.00003960}, {128,0.00000000}, {129,0.00003960}, {130,0.00000000}, {131,0.00003960}, {132,0.00000000}, {133,0.00011881}, {134,0.00003960}, {135,0.00015842}, {136,0.00007921}, {137,0.00003960}, {138,0.00011881}, {139,0.00003960}, {140,0.00003960}, {141,0.00015842}, {142,0.00007921}, {143,0.00002970}, {144,0.00007921}, {145,0.00000000}, {146,0.00000000}, {147,0.00007921}, {148,0.00000000}, {149,0.00003960}, {150,0.00007921}, {151,0.00003960}, {152,0.00000000}, {153,0.00007921}, {154,0.00000000}, {155,0.00002970}, {156,0.00003960}, {157,0.00007921}, {158,0.00015842}, {159,0.00000000}, {160,0.00003960}, {161,0.00003960}, {162,0.00023762}, {163,0.00003960}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00003960}, {168,0.00000000}, {169,0.00015842}, {170,0.00003960}, {171,0.00003960}, {172,0.00011881}, {173,0.00010891}, {174,0.00007921}, {175,0.00003960}, {176,0.00003960}, {177,0.00003960}, {178,0.00007921}, {179,0.00000000}, {180,0.00000000}, {181,0.00003960}, {182,0.00014851}, {183,0.00003960}, {184,0.00003960}, {185,0.00011881}, {186,0.00003960}, {187,0.00015842}, {188,0.00000000}, {189,0.00003960}, {190,0.00006931}, {191,0.00003960}, {192,0.00003960}, {193,0.00003960}, {194,0.00000000}, {195,0.00003960}, {196,0.00000000}, {197,0.00003960}, {198,0.00007921}, {199,0.00003960}, {200,0.00003960}, {201,0.00007921}, {202,0.00000000}, {203,0.00003960}, {204,0.00003960}, {205,0.00002970}, {206,0.00003960}, {207,0.00007921}, {208,0.00003960}, {209,0.00000000}, {210,0.00010891}, {211,0.00003960}, {212,0.00011881}, {213,0.00007921}, {214,0.00007921}, {215,0.00003960}, {216,0.00000000}, {217,0.00000000}, {218,0.00011881}, {219,0.00007921}, {220,0.00003960}, {221,0.00011881}, {222,0.00000000}, {223,0.00003960}, {224,0.00003960}, {225,0.00003960}, {226,0.00003960}, {227,0.00003960}, {228,0.00011881}, {229,0.00007921}, {230,0.00000000}, {231,0.00003960}, {232,0.00003960}, {233,0.00007921}, {234,0.00000000}, {235,0.00007921}, {236,0.00003960}, {237,0.00007921}, {238,0.00003960}, {239,0.00011881}, {240,0.00002970}, {241,0.00007921}, {242,0.00011881}, {243,0.00003960}, {244,0.00011881}, {245,0.00007921}, {246,0.00023762}, {247,0.00019802}, {248,0.00015842}, {249,0.00015842}, {250,0.00003960}, {251,0.00019802}, {252,0.00010891}, {253,0.00000000}, {254,0.00010891}, {255,0.00011881}, {256,0.00007921}, {257,0.00079208}, {258,0.00003960}, {259,0.00011881}, {260,0.00003960}, {261,0.00000000}, {262,0.00043564}, {263,0.00007921}, {264,0.00015842}, {265,0.00023762}, {266,0.00079208}, {267,0.00026733}, {268,0.00006931}, {269,0.00007921}, {270,0.00034653}, {271,0.00015842}, {272,0.00007921}, {273,0.00070297}, {274,0.00000000}, {275,0.00007921}, {276,0.00011881}, {277,0.00007921}, {278,0.00027723}, {279,0.00019802}, {280,0.00039604}, {281,0.00015842}, {282,0.00000000}, {283,0.00003960}, {284,0.00003960}, {285,0.00011881}, {286,0.00003960}, {287,0.00015842}, {288,0.00000000}, {289,0.00011881}, {290,0.00003960}, {291,0.00007921}, {292,0.00003960}, {293,0.00027723}, {294,0.00007921}, {295,0.00019802}, {296,0.00011881}, {297,0.00011881}, {298,0.00027723}, {299,0.00053465}, {300,0.00014851}, {301,0.0002286}, {302,0.0006857}, {303,0.0002286}, {304,0.0005714}, {305,0.0001143}, {306,0.0003429}, {307,0.0003429}, {308,0.0000000}, {309,0.0001143}, {310,0.0002286}, {311,0.0004571}, {312,0.0001143}, {313,0.0000000}, {314,0.0000000}, {315,0.0002286}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0001143}, {320,0.0000000}, {321,0.0000000}, {322,0.0001143}, {323,0.0001143}, {324,0.0000000}, {325,0.0002286}, {326,0.0000000}, {327,0.0001143}, {328,0.0002286}, {329,0.0001143}, {330,0.0002286}, {331,0.0000000}, {332,0.0002286}, {333,0.0001143}, {334,0.0002286}, {335,0.0002286}, {336,0.0001143}, {337,0.0003429}, {338,0.0000000}, {339,0.0002286}, {340,0.0001143}, {341,0.0002286}, {342,0.0000000}, {343,0.0001143}, {344,0.0002286}, {345,0.0000000}, {346,0.0003429}, {347,0.0002286}, {348,0.0001143}, {349,0.0003429}, {350,0.0002286}, {351,0.0002286}, {352,0.0001143}, {353,0.0000000}, {354,0.0001143}, {355,0.0000000}, {356,0.0000000}, {357,0.0001143}, {358,0.0001143}, {359,0.0001143}, {360,0.0001143}, {361,0.0000000}, {362,0.0001143}, {363,0.0000000}, {364,0.0002286}, {365,0.0002286}, {366,0.0003429}, {367,0.0001143}, {368,0.0000000}, {369,0.0001143}, {370,0.0003429}, {371,0.0001143}, {372,0.0000000}, {373,0.0001143}, {374,0.0002286}, {375,0.0001143}, {376,0.0002286}, {377,0.0004571}, {378,0.0001143}, {379,0.0003429}, {380,0.0005429}, {381,0.0002286}, {382,0.0001143}, {383,0.0003429}, {384,0.0002286}, {385,0.0003429}, {386,0.0005714}, {387,0.0005714}, {388,0.0004571}, {389,0.0003429}, {390,0.0005714}, {391,0.0003429}, {392,0.0004286}, {393,0.0003429}, {394,0.0002286}, {395,0.0003429}, {396,0.0003429}, {397,0.0004571}, {398,0.0003429}, {399,0.0001143}, {400,0.0003429}, {401,0.0002286}, {402,0.0002286}, {403,0.0004571}, {404,0.0003429}, {405,0.0001143}, {406,0.0002286}, {407,0.0002286}, {408,0.0002286}, {409,0.0002286}, {410,0.0005143}, {411,0.0005714}, {412,0.0003429}, {413,0.0005714}, {414,0.0003429}, {415,0.0001143}, {416,0.0002286}, {417,0.0002286}, {418,0.0000000}, {419,0.0003429}, {420,0.0003429}, {421,0.0002286}, {422,0.0004571}, {423,0.0003429}, {424,0.0006857}, {425,0.0002286}, {426,0.0004571}, {427,0.0011429}, {428,0.0003429}, {429,0.0006857}, {430,0.0002286}, {431,0.0006857}, {432,0.0004571}, {433,0.0002286}, {434,0.0003429}, {435,0.0002286}, {436,0.0002286}, {437,0.0002286}, {438,0.0003429}, {439,0.0006857}, {440,0.0003429}, {441,0.0005714}, {442,0.0005714}, {443,0.0004571}, {444,0.0002286}, {445,0.0004286}, {446,0.0003429}, {447,0.0001143}, {448,0.0012571}, {449,0.0000857}, {450,0.0002286}, {451,0.0001143}, {452,0.0001143}, {453,0.0002286}, {454,0.0004571}, {455,0.0000000}, {456,0.0003429}, {457,0.0003143}, {458,0.0008857}, {459,0.0003429}, {460,0.0003429}, {461,0.0002286}, {462,0.0003429}, {463,0.0008000}, {464,0.0004571}, {465,0.0010286}, {466,0.0006857}, {467,0.0005714}, {468,0.0008000}, {469,0.0005714}, {470,0.0001143}, {471,0.0002286}, {472,0.0005714}, {473,0.0006857}, {474,0.0005714}, {475,0.0003429}, {476,0.0005714}, {477,0.0001143}, {478,0.0003429}, {479,0.0001143}, {480,0.0010286}, {481,0.0004571}, {482,0.0002286}, {483,0.0010286}, {484,0.0011429}, {485,0.0003429}, {486,0.0003429}, {487,0.0004571}, {488,0.0021714}, {489,0.0001143}, {490,0.0008000}, {491,0.0004571}, {492,0.0001143}, {493,0.0002286}, {494,0.0012571}, {495,0.0010286}, {496,0.0003429}, {497,0.0004571}, {498,0.0008571}, {499,0.0006857}, {500,0.0003429}, {505,0.0006857}, {510,0.0004571}, {515,0.0012571}, {520,0.0010286}, {525,0.0008000}, {530,0.0003429}, {535,0.0012286}, {540,0.0009143}, {545,0.0004571}, {550,0.0004571}, {555,0.0010000}, {560,0.0005429}, {565,0.0010286}, {570,0.0008000}, {575,0.0008000}, {580,0.0012571}, {585,0.0009143}, {590,0.0009143}, {595,0.0022857}, {600,0.0006857}, {605,0.0006857}, {610,0.0022857}, {615,0.0013714}, {620,0.0014857}, {625,0.0026286}, {630,0.0032000}, {635,0.0018000}, {640,0.0020571}, {645,0.0021714}, {650,0.0025143}, {655,0.0029714}, {660,0.0014857}, {665,0.0016000}, {670,0.0026286}, {675,0.0021714}, {680,0.0025143}, {685,0.0032857}, {690,0.0016000}, {695,0.0030571}, {700,0.0019429}, {705,0.0017143}, {710,0.0022857}, {715,0.0024857}, {720,0.0026286}, {725,0.0008000}, {730,0.0024000}, {735,0.0017143}, {740,0.0030857}, {745,0.0030857}, {750,0.0014857}, {755,0.0022571}, {760,0.0018000}, {765,0.0020571}, {770,0.0024000}, {775,0.0044286}, {780,0.0043429}, {785,0.0034286}, {790,0.0031714}, {795,0.0037429}, {800,0.0026286}, {805,0.0027143}, {810,0.0030857}, {815,0.0038857}, {820,0.0050286}, {825,0.0026286}, {830,0.0027714}, {835,0.0043143}, {840,0.0033143}, {845,0.0054286}, {850,0.0067429}, {855,0.0044571}, {860,0.0065143}, {865,0.0042286}, {870,0.0044286}, {875,0.0043714}, {880,0.0078286}, {885,0.0056571}, {890,0.0041143}, {895,0.0062000}, {900,0.0071714}, {905,0.0087429}, {910,0.0074000}, {915,0.0058286}, {920,0.0068571}, {925,0.0102857}, {930,0.0074857}, {935,0.0094857}, {940,0.0073429}, {945,0.0072857}, {950,0.0078857}, {955,0.0072000}, {960,0.0057143}, {965,0.0103429}, {970,0.0086571}, {975,0.0098571}, {980,0.0065143}, {985,0.0092571}, {990,0.0112286}, {995,0.0061429}, {1000,0.0067143}, {1010,0.0054286}, {1020,0.0072000}, {1030,0.0095714}, {1040,0.0057714}, {1050,0.0052571}, {1060,0.0080571}, {1070,0.0135714}, {1080,0.0088857}, {1090,0.0079429}, {1100,0.0089429}, {1110,0.0126286}, {1120,0.0092286}, {1130,0.0109429}, {1140,0.0088571}, {1150,0.0084857}, {1160,0.0127143}, {1170,0.0142286}, {1180,0.0148571}, {1190,0.0146571}, {1200,0.0186857}, {1210,0.0197714}, {1220,0.0143143}, {1230,0.0112571}, {1240,0.0162000}, {1250,0.0166286}, {1260,0.0207714}, {1270,0.0211429}, {1280,0.0249429}, {1290,0.0144571}, {1300,0.0239429}, {1310,0.0169143}, {1320,0.0203429}, {1330,0.0204571}, {1340,0.0162000}, {1350,0.0178857}, {1360,0.0201429}, {1370,0.0226857}, {1380,0.0258000}, {1390,0.0190000}, {1400,0.0166857}, {1410,0.0234571}, {1420,0.0148571}, {1430,0.0239429}, {1440,0.0249429}, {1450,0.0186571}, {1460,0.0133429}, {1470,0.0255714}, {1480,0.0268571}, {1490,0.0210571}, {1500,0.0222571}, {1510,0.0219143}, {1520,0.0299143}, {1530,0.0323714}, {1540,0.0266571}, {1550,0.0213429}, {1560,0.0241714}, {1570,0.0276000}, {1580,0.0226857}, {1590,0.0313429}, {1600,0.0351143}, {1610,0.0274857}, {1620,0.0291714}, {1630,0.0332571}, {1640,0.0327143}, {1650,0.0352286}, {1660,0.0296286}, {1670,0.0329714}, {1680,0.0347714}, {1690,0.0373143}, {1700,0.0399429}, {1710,0.0410000}, {1720,0.0406286}, {1730,0.0356857}, {1740,0.0442000}, {1750,0.0412000}, {1760,0.0363143}, {1770,0.0410286}, {1780,0.0465714}, {1790,0.0480857}, {1800,0.0414000}, {1810,0.0433143}, {1820,0.0539143}, {1830,0.0416571}, {1840,0.0491429}, {1850,0.0522286}, {1860,0.0558571}, {1870,0.0547714}, {1880,0.0614571}, {1890,0.0476857}, {1900,0.0577714}, {1910,0.0653429}, {1920,0.0584571}, {1930,0.0441714}, {1940,0.0590857}, {1950,0.0627143}, {1960,0.0548000}, {1970,0.0580571}, {1980,0.0570000}, {1990,0.0494857}, {2000,0.0519429}};
data["big"]["LtacTacInTermGallinaCtx"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00256436}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0017714}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0001143}, {555,0.0000286}, {560,0.0000571}, {565,0.0000286}, {570,0.0000857}, {575,0.0000571}, {580,0.0002571}, {585,0.0004000}, {590,0.0006000}, {595,0.0005143}, {600,0.0006286}, {605,0.0006571}, {610,0.0007714}, {615,0.0008857}, {620,0.0009143}, {625,0.0009714}, {630,0.0009143}, {635,0.0009714}, {640,0.0009429}, {645,0.0009143}, {650,0.0009429}, {655,0.0010000}, {660,0.0009429}, {665,0.0009429}, {670,0.0010000}, {675,0.0009143}, {680,0.0010000}, {685,0.0010000}, {690,0.0010000}, {695,0.0010000}, {700,0.0010000}, {705,0.0010000}, {710,0.0010000}, {715,0.0010000}, {720,0.0010000}, {725,0.0010000}, {730,0.0010000}, {735,0.0021143}, {740,0.0010000}, {745,0.0010000}, {750,0.0010000}, {755,0.0010000}, {760,0.0010000}, {765,0.0010000}, {770,0.0010000}, {775,0.0010000}, {780,0.0010000}, {785,0.0010000}, {790,0.0010000}, {795,0.0010000}, {800,0.0010000}, {805,0.0010000}, {810,0.0010000}, {815,0.0010000}, {820,0.0010000}, {825,0.0010000}, {830,0.0010000}, {835,0.0010000}, {840,0.0010000}, {845,0.0010000}, {850,0.0010000}, {855,0.0039143}, {860,0.0010000}, {865,0.0010000}, {870,0.0010000}, {875,0.0010000}, {880,0.0010000}, {885,0.0010000}, {890,0.0010000}, {895,0.0010000}, {900,0.0010000}, {905,0.0010000}, {910,0.0033143}, {915,0.0010000}, {920,0.0010000}, {925,0.0010000}, {930,0.0010000}, {935,0.0010000}, {940,0.0010000}, {945,0.0010000}, {950,0.0010000}, {955,0.0010000}, {960,0.0010000}, {965,0.0010000}, {970,0.0010000}, {975,0.0010000}, {980,0.0010000}, {985,0.0010000}, {990,0.0010000}, {995,0.0010000}, {1000,0.0010000}, {1010,0.0010000}, {1020,0.0010000}, {1030,0.0010000}, {1040,0.0010000}, {1050,0.0010000}, {1060,0.0010000}, {1070,0.0010000}, {1080,0.0010571}, {1090,0.0010000}, {1100,0.0010000}, {1110,0.0010857}, {1120,0.0010571}, {1130,0.0011143}, {1140,0.0011429}, {1150,0.0012286}, {1160,0.0012000}, {1170,0.0012857}, {1180,0.0014000}, {1190,0.0016286}, {1200,0.0015429}, {1210,0.0017429}, {1220,0.0018571}, {1230,0.0018000}, {1240,0.0018000}, {1250,0.0019429}, {1260,0.0019714}, {1270,0.0019714}, {1280,0.0019714}, {1290,0.0020000}, {1300,0.0020000}, {1310,0.0020000}, {1320,0.0020000}, {1330,0.0020000}, {1340,0.0020000}, {1350,0.0020000}, {1360,0.0020000}, {1370,0.0020000}, {1380,0.0020000}, {1390,0.0020000}, {1400,0.0020000}, {1410,0.0020000}, {1420,0.0020000}, {1430,0.0020000}, {1440,0.0020000}, {1450,0.0020000}, {1460,0.0020000}, {1470,0.0020000}, {1480,0.0020000}, {1490,0.0020000}, {1500,0.0020000}, {1510,0.0020000}, {1520,0.0020000}, {1530,0.0020000}, {1540,0.0020000}, {1550,0.0020000}, {1560,0.0020000}, {1570,0.0020000}, {1580,0.0020000}, {1590,0.0020000}, {1600,0.0020000}, {1610,0.0020000}, {1620,0.0020286}, {1630,0.0020286}, {1640,0.0020000}, {1650,0.0020000}, {1660,0.0020286}, {1670,0.0020571}, {1680,0.0020571}, {1690,0.0020857}, {1700,0.0021143}, {1710,0.0020571}, {1720,0.0021429}, {1730,0.0022857}, {1740,0.0022286}, {1750,0.0023143}, {1760,0.0023714}, {1770,0.0024000}, {1780,0.0025429}, {1790,0.0024571}, {1800,0.0027143}, {1810,0.0027429}, {1820,0.0027714}, {1830,0.0027429}, {1840,0.0027714}, {1850,0.0028857}, {1860,0.0028571}, {1870,0.0029429}, {1880,0.0030000}, {1890,0.0029714}, {1900,0.0030000}, {1910,0.0030000}, {1920,0.0030000}, {1930,0.0030000}, {1940,0.0106857}, {1950,0.0030000}, {1960,0.0030000}, {1970,0.0030000}, {1980,0.0030000}, {1990,0.0121429}, {2000,0.0030000}};
data["big"]["LtacTacInTermGallinaCtx"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00014851}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00003960}, {7,0.00000000}, {8,0.00003960}, {9,0.00000000}, {10,0.00000000}, {11,0.00006931}, {12,0.00003960}, {13,0.00010891}, {14,0.00003960}, {15,0.00003960}, {16,0.00007921}, {17,0.00002970}, {18,0.00007921}, {19,0.00002970}, {20,0.00007921}, {21,0.00000000}, {22,0.00006931}, {23,0.00003960}, {24,0.00010891}, {25,0.00003960}, {26,0.00003960}, {27,0.00007921}, {28,0.00007921}, {29,0.00026733}, {30,0.00003960}, {31,0.00003960}, {32,0.00003960}, {33,0.00003960}, {34,0.00010891}, {35,0.00000000}, {36,0.00005941}, {37,0.00011881}, {38,0.00000000}, {39,0.00003960}, {40,0.00003960}, {41,0.00015842}, {42,0.00011881}, {43,0.00015842}, {44,0.00003960}, {45,0.00009901}, {46,0.00011881}, {47,0.00007921}, {48,0.00007921}, {49,0.00007921}, {50,0.00011881}, {51,0.00003960}, {52,0.00014851}, {53,0.00003960}, {54,0.00003960}, {55,0.00010891}, {56,0.00006931}, {57,0.00019802}, {58,0.00002970}, {59,0.00011881}, {60,0.00015842}, {61,0.00006931}, {62,0.00013861}, {63,0.00011881}, {64,0.00010891}, {65,0.00010891}, {66,0.00011881}, {67,0.00007921}, {68,0.00003960}, {69,0.00000000}, {70,0.00009901}, {71,0.00003960}, {72,0.00019802}, {73,0.00023762}, {74,0.00015842}, {75,0.00029703}, {76,0.00007921}, {77,0.00018812}, {78,0.00015842}, {79,0.00011881}, {80,0.00014851}, {81,0.00008911}, {82,0.00015842}, {83,0.00015842}, {84,0.00022772}, {85,0.00006931}, {86,0.00014851}, {87,0.00015842}, {88,0.00007921}, {89,0.00018812}, {90,0.00026733}, {91,0.00013861}, {92,0.00011881}, {93,0.00022772}, {94,0.00015842}, {95,0.00021782}, {96,0.00014851}, {97,0.00017822}, {98,0.00007921}, {99,0.00025743}, {100,0.00011881}, {101,0.00011881}, {102,0.00015842}, {103,0.00019802}, {104,0.00025743}, {105,0.00029703}, {106,0.00014851}, {107,0.00018812}, {108,0.00003960}, {109,0.00025743}, {110,0.00039604}, {111,0.00022772}, {112,0.00026733}, {113,0.00014851}, {114,0.00013861}, {115,0.00023762}, {116,0.00002970}, {117,0.00018812}, {118,0.00019802}, {119,0.00030693}, {120,0.00019802}, {121,0.00014851}, {122,0.00031683}, {123,0.00011881}, {124,0.00042574}, {125,0.00027723}, {126,0.00023762}, {127,0.00034653}, {128,0.00026733}, {129,0.00022772}, {130,0.00011881}, {131,0.00011881}, {132,0.00015842}, {133,0.00019802}, {134,0.00019802}, {135,0.00026733}, {136,0.00017822}, {137,0.00015842}, {138,0.00021782}, {139,0.00014851}, {140,0.00006931}, {141,0.00022772}, {142,0.00023762}, {143,0.00021782}, {144,0.00020792}, {145,0.00029703}, {146,0.00011881}, {147,0.00022772}, {148,0.00022772}, {149,0.00019802}, {150,0.00042574}, {151,0.00022772}, {152,0.00036634}, {153,0.00014851}, {154,0.00023762}, {155,0.00019802}, {156,0.00034653}, {157,0.00036634}, {158,0.00018812}, {159,0.00028713}, {160,0.00030693}, {161,0.00025743}, {162,0.00046535}, {163,0.00038614}, {164,0.00021782}, {165,0.00022772}, {166,0.00010891}, {167,0.00018812}, {168,0.00025743}, {169,0.00022772}, {170,0.00033663}, {171,0.00042574}, {172,0.00015842}, {173,0.00041584}, {174,0.00038614}, {175,0.00031683}, {176,0.00022772}, {177,0.00038614}, {178,0.00026733}, {179,0.00030693}, {180,0.00052475}, {181,0.00049505}, {182,0.00026733}, {183,0.00033663}, {184,0.00023762}, {185,0.00050495}, {186,0.00034653}, {187,0.00019802}, {188,0.00041584}, {189,0.00014851}, {190,0.00029703}, {191,0.00037624}, {192,0.00043564}, {193,0.00029703}, {194,0.00027723}, {195,0.00042574}, {196,0.00053465}, {197,0.00014851}, {198,0.00026733}, {199,0.00030693}, {200,0.00042574}, {201,0.00027723}, {202,0.00054455}, {203,0.00030693}, {204,0.00018812}, {205,0.00013861}, {206,0.00023762}, {207,0.00045545}, {208,0.00023762}, {209,0.00042574}, {210,0.00043564}, {211,0.00043564}, {212,0.00027723}, {213,0.00035644}, {214,0.00040594}, {215,0.00039604}, {216,0.00034653}, {217,0.00026733}, {218,0.00021782}, {219,0.00025743}, {220,0.00063366}, {221,0.00056436}, {222,0.00043564}, {223,0.00027723}, {224,0.00030693}, {225,0.00029703}, {226,0.00049505}, {227,0.00036634}, {228,0.00043564}, {229,0.00034653}, {230,0.00031683}, {231,0.00049505}, {232,0.00030693}, {233,0.00033663}, {234,0.00050495}, {235,0.00035644}, {236,0.00033663}, {237,0.00027723}, {238,0.00031683}, {239,0.00033663}, {240,0.00051485}, {241,0.00047525}, {242,0.00043564}, {243,0.00033663}, {244,0.00038614}, {245,0.00034653}, {246,0.00025743}, {247,0.00037624}, {248,0.00027723}, {249,0.00040594}, {250,0.00041584}, {251,0.00045545}, {252,0.00062376}, {253,0.00030693}, {254,0.00039604}, {255,0.00049505}, {256,0.00052475}, {257,0.00026733}, {258,0.00026733}, {259,0.00022772}, {260,0.00038614}, {261,0.00021782}, {262,0.00043564}, {263,0.00031683}, {264,0.00036634}, {265,0.00033663}, {266,0.00035644}, {267,0.00027723}, {268,0.00032673}, {269,0.00038614}, {270,0.00028713}, {271,0.00025743}, {272,0.00039604}, {273,0.00276238}, {274,0.00053465}, {275,0.00043564}, {276,0.00035644}, {277,0.00035644}, {278,0.00057426}, {279,0.00036634}, {280,0.00041584}, {281,0.00042574}, {282,0.00041584}, {283,0.00050495}, {284,0.00026733}, {285,0.00025743}, {286,0.00031683}, {287,0.00044554}, {288,0.00063366}, {289,0.00037624}, {290,0.00039604}, {291,0.00031683}, {292,0.00045545}, {293,0.00030693}, {294,0.00035644}, {295,0.00047525}, {296,0.00060396}, {297,0.00034653}, {298,0.00045545}, {299,0.00039604}, {300,0.00054455}, {301,0.0002000}, {302,0.0001714}, {303,0.0005143}, {304,0.0001714}, {305,0.0004571}, {306,0.0004286}, {307,0.0002857}, {308,0.0005143}, {309,0.0004571}, {310,0.0006857}, {311,0.0001714}, {312,0.0003429}, {313,0.0006286}, {314,0.0004000}, {315,0.0005714}, {316,0.0005429}, {317,0.0004571}, {318,0.0005429}, {319,0.0004286}, {320,0.0005714}, {321,0.0002857}, {322,0.0002571}, {323,0.0005429}, {324,0.0003714}, {325,0.0004857}, {326,0.0009429}, {327,0.0006286}, {328,0.0005714}, {329,0.0002571}, {330,0.0002571}, {331,0.0005143}, {332,0.0003429}, {333,0.0004857}, {334,0.0002571}, {335,0.0006286}, {336,0.0006286}, {337,0.0003714}, {338,0.0001714}, {339,0.0004571}, {340,0.0003714}, {341,0.0004286}, {342,0.0004286}, {343,0.0004286}, {344,0.0004286}, {345,0.0006571}, {346,0.0006286}, {347,0.0002571}, {348,0.0004571}, {349,0.0005714}, {350,0.0006000}, {351,0.0003429}, {352,0.0005429}, {353,0.0007143}, {354,0.0004286}, {355,0.0004857}, {356,0.0004857}, {357,0.0008857}, {358,0.0005429}, {359,0.0005714}, {360,0.0003714}, {361,0.0004857}, {362,0.0006000}, {363,0.0003714}, {364,0.0008000}, {365,0.0001714}, {366,0.0007429}, {367,0.0002000}, {368,0.0001714}, {369,0.0002000}, {370,0.0004000}, {371,0.0005429}, {372,0.0007143}, {373,0.0002571}, {374,0.0001714}, {375,0.0003429}, {376,0.0001714}, {377,0.0004571}, {378,0.0005143}, {379,0.0004571}, {380,0.0005429}, {381,0.0003429}, {382,0.0004286}, {383,0.0005143}, {384,0.0008571}, {385,0.0009429}, {386,0.0003714}, {387,0.0004286}, {388,0.0007714}, {389,0.0007143}, {390,0.0007714}, {391,0.0005429}, {392,0.0007143}, {393,0.0004571}, {394,0.0005143}, {395,0.0005714}, {396,0.0006857}, {397,0.0005143}, {398,0.0001143}, {399,0.0002857}, {400,0.0005143}, {401,0.0005429}, {402,0.0005714}, {403,0.0005429}, {404,0.0005143}, {405,0.0017143}, {406,0.0005429}, {407,0.0008000}, {408,0.0005143}, {409,0.0005714}, {410,0.0004286}, {411,0.0008000}, {412,0.0006857}, {413,0.0002571}, {414,0.0006857}, {415,0.0005429}, {416,0.0004286}, {417,0.0003714}, {418,0.0004286}, {419,0.0003714}, {420,0.0003429}, {421,0.0002857}, {422,0.0007143}, {423,0.0003143}, {424,0.0006286}, {425,0.0008857}, {426,0.0004571}, {427,0.0007429}, {428,0.0006857}, {429,0.0007143}, {430,0.0005143}, {431,0.0004571}, {432,0.0008000}, {433,0.0008571}, {434,0.0008286}, {435,0.0004571}, {436,0.0009714}, {437,0.0005429}, {438,0.0004000}, {439,0.0004857}, {440,0.0005143}, {441,0.0003714}, {442,0.0007143}, {443,0.0002857}, {444,0.0004857}, {445,0.0006000}, {446,0.0007714}, {447,0.0009143}, {448,0.0006000}, {449,0.0009429}, {450,0.0003714}, {451,0.0006286}, {452,0.0010286}, {453,0.0011143}, {454,0.0005429}, {455,0.0005429}, {456,0.0009143}, {457,0.0004286}, {458,0.0001143}, {459,0.0006286}, {460,0.0004286}, {461,0.0012286}, {462,0.0008571}, {463,0.0004571}, {464,0.0002857}, {465,0.0006000}, {466,0.0007143}, {467,0.0004286}, {468,0.0005143}, {469,0.0007714}, {470,0.0005714}, {471,0.0007143}, {472,0.0003714}, {473,0.0005714}, {474,0.0006571}, {475,0.0002857}, {476,0.0005143}, {477,0.0003714}, {478,0.0004571}, {479,0.0008857}, {480,0.0007429}, {481,0.0004286}, {482,0.0001714}, {483,0.0006857}, {484,0.0006000}, {485,0.0004571}, {486,0.0010857}, {487,0.0007429}, {488,0.0008000}, {489,0.0003429}, {490,0.0007714}, {491,0.0007143}, {492,0.0006000}, {493,0.0009714}, {494,0.0006286}, {495,0.0008571}, {496,0.0008000}, {497,0.0004000}, {498,0.0008000}, {499,0.0007714}, {500,0.0009429}, {505,0.0006000}, {510,0.0006000}, {515,0.0006571}, {520,0.0005429}, {525,0.0006286}, {530,0.0008857}, {535,0.0008000}, {540,0.0009143}, {545,0.0008857}, {550,0.0009714}, {555,0.0005143}, {560,0.0012286}, {565,0.0010571}, {570,0.0005143}, {575,0.0009143}, {580,0.0008571}, {585,0.0007714}, {590,0.0009429}, {595,0.0008000}, {600,0.0008286}, {605,0.0007714}, {610,0.0007143}, {615,0.0007143}, {620,0.0013714}, {625,0.0013714}, {630,0.0008000}, {635,0.0010000}, {640,0.0010286}, {645,0.0006286}, {650,0.0008857}, {655,0.0010571}, {660,0.0007714}, {665,0.0006000}, {670,0.0005714}, {675,0.0006286}, {680,0.0010286}, {685,0.0008286}, {690,0.0008857}, {695,0.0008286}, {700,0.0005429}, {705,0.0007714}, {710,0.0014286}, {715,0.0011143}, {720,0.0008286}, {725,0.0007143}, {730,0.0006571}, {735,0.0021143}, {740,0.0008857}, {745,0.0010000}, {750,0.0009143}, {755,0.0007714}, {760,0.0007714}, {765,0.0011714}, {770,0.0011143}, {775,0.0010571}, {780,0.0008286}, {785,0.0006000}, {790,0.0009714}, {795,0.0008857}, {800,0.0009429}, {805,0.0008000}, {810,0.0010286}, {815,0.0018571}, {820,0.0012286}, {825,0.0010571}, {830,0.0008571}, {835,0.0010571}, {840,0.0009143}, {845,0.0014000}, {850,0.0012286}, {855,0.0030857}, {860,0.0009714}, {865,0.0012286}, {870,0.0014571}, {875,0.0010571}, {880,0.0011429}, {885,0.0013143}, {890,0.0010571}, {895,0.0008000}, {900,0.0012857}, {905,0.0010000}, {910,0.0029714}, {915,0.0011714}, {920,0.0014857}, {925,0.0016000}, {930,0.0016571}, {935,0.0009429}, {940,0.0009143}, {945,0.0014857}, {950,0.0010000}, {955,0.0010857}, {960,0.0010286}, {965,0.0010857}, {970,0.0016000}, {975,0.0010857}, {980,0.0014000}, {985,0.0009714}, {990,0.0018000}, {995,0.0014571}, {1000,0.0015429}, {1010,0.0013143}, {1020,0.0009429}, {1030,0.0012571}, {1040,0.0014857}, {1050,0.0018857}, {1060,0.0011143}, {1070,0.0021429}, {1080,0.0017714}, {1090,0.0011429}, {1100,0.0018000}, {1110,0.0016286}, {1120,0.0016571}, {1130,0.0018857}, {1140,0.0018857}, {1150,0.0019429}, {1160,0.0016571}, {1170,0.0020286}, {1180,0.0016857}, {1190,0.0018000}, {1200,0.0016286}, {1210,0.0014571}, {1220,0.0014286}, {1230,0.0021143}, {1240,0.0020857}, {1250,0.0018000}, {1260,0.0015429}, {1270,0.0024571}, {1280,0.0019143}, {1290,0.0018286}, {1300,0.0022571}, {1310,0.0018857}, {1320,0.0020000}, {1330,0.0019143}, {1340,0.0019143}, {1350,0.0022000}, {1360,0.0023143}, {1370,0.0020857}, {1380,0.0022286}, {1390,0.0020000}, {1400,0.0020000}, {1410,0.0012857}, {1420,0.0022571}, {1430,0.0023429}, {1440,0.0020857}, {1450,0.0023714}, {1460,0.0023143}, {1470,0.0016286}, {1480,0.0023429}, {1490,0.0024286}, {1500,0.0027429}, {1510,0.0028286}, {1520,0.0024571}, {1530,0.0023429}, {1540,0.0023143}, {1550,0.0028571}, {1560,0.0019143}, {1570,0.0020857}, {1580,0.0024000}, {1590,0.0022857}, {1600,0.0025143}, {1610,0.0029143}, {1620,0.0028857}, {1630,0.0029143}, {1640,0.0026286}, {1650,0.0024571}, {1660,0.0023143}, {1670,0.0027143}, {1680,0.0027714}, {1690,0.0026286}, {1700,0.0025714}, {1710,0.0029714}, {1720,0.0030571}, {1730,0.0030000}, {1740,0.0026857}, {1750,0.0024000}, {1760,0.0026286}, {1770,0.0028286}, {1780,0.0033714}, {1790,0.0032000}, {1800,0.0028571}, {1810,0.0028571}, {1820,0.0032857}, {1830,0.0023143}, {1840,0.0030000}, {1850,0.0032857}, {1860,0.0029143}, {1870,0.0031714}, {1880,0.0028000}, {1890,0.0032571}, {1900,0.0031714}, {1910,0.0030286}, {1920,0.0028571}, {1930,0.0031429}, {1940,0.0110286}, {1950,0.0033714}, {1960,0.0032857}, {1970,0.0030857}, {1980,0.0028571}, {1990,0.0122286}, {2000,0.0031143}};
data["big"]["LtacTacInTermGallinaCtx"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00003960}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00003960}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00003960}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00003960}, {116,0.00000000}, {117,0.00003960}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00003960}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00003960}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00007921}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00003960}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00003960}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00003960}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00003960}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00003960}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00003960}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00003960}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00003960}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00003960}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0001143}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0001143}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0001143}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0001143}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0001143}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0001143}, {845,0.0000000}, {850,0.0000000}, {855,0.0001143}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0001143}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0001143}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000857}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0001143}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0001143}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000857}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermGallinaCtx"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00225743}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0010000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000286}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0020000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0023714}, {700,0.0000000}, {705,0.0000000}, {710,0.0000286}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000286}, {805,0.0000571}, {810,0.0000286}, {815,0.0000000}, {820,0.0000000}, {825,0.0000286}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0001143}, {860,0.0000286}, {865,0.0000571}, {870,0.0001143}, {875,0.0001143}, {880,0.0001714}, {885,0.0003143}, {890,0.0003143}, {895,0.0003429}, {900,0.0006571}, {905,0.0006571}, {910,0.0006286}, {915,0.0006571}, {920,0.0008286}, {925,0.0008000}, {930,0.0008857}, {935,0.0008857}, {940,0.0009714}, {945,0.0010000}, {950,0.0010000}, {955,0.0009714}, {960,0.0010000}, {965,0.0010000}, {970,0.0010000}, {975,0.0010000}, {980,0.0010000}, {985,0.0010000}, {990,0.0010000}, {995,0.0010000}, {1000,0.0010000}, {1010,0.0010000}, {1020,0.0010000}, {1030,0.0010000}, {1040,0.0010000}, {1050,0.0010000}, {1060,0.0010000}, {1070,0.0010000}, {1080,0.0010000}, {1090,0.0010000}, {1100,0.0010000}, {1110,0.0010000}, {1120,0.0010000}, {1130,0.0010000}, {1140,0.0010000}, {1150,0.0010000}, {1160,0.0010000}, {1170,0.0010000}, {1180,0.0010000}, {1190,0.0010000}, {1200,0.0010000}, {1210,0.0010000}, {1220,0.0010000}, {1230,0.0010000}, {1240,0.0010000}, {1250,0.0010000}, {1260,0.0010000}, {1270,0.0010000}, {1280,0.0010000}, {1290,0.0010000}, {1300,0.0010000}, {1310,0.0010000}, {1320,0.0010000}, {1330,0.0010000}, {1340,0.0010000}, {1350,0.0010000}, {1360,0.0010000}, {1370,0.0010000}, {1380,0.0010000}, {1390,0.0010000}, {1400,0.0010000}, {1410,0.0010000}, {1420,0.0010000}, {1430,0.0010000}, {1440,0.0010000}, {1450,0.0010000}, {1460,0.0010286}, {1470,0.0010000}, {1480,0.0010000}, {1490,0.0010000}, {1500,0.0010000}, {1510,0.0010286}, {1520,0.0010000}, {1530,0.0010000}, {1540,0.0010000}, {1550,0.0010000}, {1560,0.0010000}, {1570,0.0010286}, {1580,0.0010000}, {1590,0.0010000}, {1600,0.0010000}, {1610,0.0010000}, {1620,0.0010000}, {1630,0.0010000}, {1640,0.0010000}, {1650,0.0010571}, {1660,0.0010000}, {1670,0.0010286}, {1680,0.0010000}, {1690,0.0010000}, {1700,0.0010571}, {1710,0.0010857}, {1720,0.0010000}, {1730,0.0010857}, {1740,0.0011143}, {1750,0.0010286}, {1760,0.0013143}, {1770,0.0012571}, {1780,0.0014286}, {1790,0.0015429}, {1800,0.0015714}, {1810,0.0015714}, {1820,0.0016857}, {1830,0.0017143}, {1840,0.0017714}, {1850,0.0018857}, {1860,0.0019143}, {1870,0.0019714}, {1880,0.0019714}, {1890,0.0019429}, {1900,0.0019714}, {1910,0.0020000}, {1920,0.0020000}, {1930,0.0020000}, {1940,0.0020000}, {1950,0.0020000}, {1960,0.0020000}, {1970,0.0020000}, {1980,0.0020286}, {1990,0.0020000}, {2000,0.0080857}};
data["big"]["LtacTacInTermGallinaCtx"]["eval lazy"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003960}, {4,0.00000000}, {5,0.00003960}, {6,0.00002970}, {7,0.00000000}, {8,0.00002970}, {9,0.00007921}, {10,0.00007921}, {11,0.00007921}, {12,0.00006931}, {13,0.00003960}, {14,0.00003960}, {15,0.00003960}, {16,0.00007921}, {17,0.00010891}, {18,0.00000000}, {19,0.00011881}, {20,0.00003960}, {21,0.00002970}, {22,0.00003960}, {23,0.00007921}, {24,0.00007921}, {25,0.00007921}, {26,0.00007921}, {27,0.00007921}, {28,0.00007921}, {29,0.00007921}, {30,0.00006931}, {31,0.00006931}, {32,0.00006931}, {33,0.00000000}, {34,0.00005941}, {35,0.00007921}, {36,0.00007921}, {37,0.00007921}, {38,0.00011881}, {39,0.00018812}, {40,0.00007921}, {41,0.00000000}, {42,0.00014851}, {43,0.00007921}, {44,0.00003960}, {45,0.00010891}, {46,0.00006931}, {47,0.00007921}, {48,0.00011881}, {49,0.00007921}, {50,0.00007921}, {51,0.00002970}, {52,0.00010891}, {53,0.00002970}, {54,0.00007921}, {55,0.00009901}, {56,0.00007921}, {57,0.00003960}, {58,0.00018812}, {59,0.00015842}, {60,0.00007921}, {61,0.00011881}, {62,0.00011881}, {63,0.00017822}, {64,0.00007921}, {65,0.00007921}, {66,0.00019802}, {67,0.00003960}, {68,0.00007921}, {69,0.00007921}, {70,0.00011881}, {71,0.00007921}, {72,0.00003960}, {73,0.00003960}, {74,0.00007921}, {75,0.00009901}, {76,0.00011881}, {77,0.00003960}, {78,0.00014851}, {79,0.00015842}, {80,0.00007921}, {81,0.00003960}, {82,0.00019802}, {83,0.00011881}, {84,0.00017822}, {85,0.00010891}, {86,0.00019802}, {87,0.00010891}, {88,0.00000000}, {89,0.00025743}, {90,0.00022772}, {91,0.00007921}, {92,0.00010891}, {93,0.00015842}, {94,0.00014851}, {95,0.00011881}, {96,0.00018812}, {97,0.00021782}, {98,0.00022772}, {99,0.00000000}, {100,0.00018812}, {101,0.00011881}, {102,0.00014851}, {103,0.00000000}, {104,0.00030693}, {105,0.00011881}, {106,0.00014851}, {107,0.00027723}, {108,0.00018812}, {109,0.00003960}, {110,0.00007921}, {111,0.00024752}, {112,0.00018812}, {113,0.00033663}, {114,0.00003960}, {115,0.00019802}, {116,0.00026733}, {117,0.00011881}, {118,0.00017822}, {119,0.00005941}, {120,0.00019802}, {121,0.00011881}, {122,0.00018812}, {123,0.00011881}, {124,0.00011881}, {125,0.00037624}, {126,0.00022772}, {127,0.00023762}, {128,0.00007921}, {129,0.00019802}, {130,0.00010891}, {131,0.00014851}, {132,0.00030693}, {133,0.00019802}, {134,0.00013861}, {135,0.00027723}, {136,0.00011881}, {137,0.00031683}, {138,0.00026733}, {139,0.00007921}, {140,0.00033663}, {141,0.00015842}, {142,0.00026733}, {143,0.00026733}, {144,0.00033663}, {145,0.00011881}, {146,0.00037624}, {147,0.00014851}, {148,0.00012871}, {149,0.00023762}, {150,0.00019802}, {151,0.00022772}, {152,0.00013861}, {153,0.00015842}, {154,0.00026733}, {155,0.00030693}, {156,0.00030693}, {157,0.00005941}, {158,0.00018812}, {159,0.00021782}, {160,0.00036634}, {161,0.00044554}, {162,0.00022772}, {163,0.00025743}, {164,0.00031683}, {165,0.00003960}, {166,0.00026733}, {167,0.00022772}, {168,0.00019802}, {169,0.00011881}, {170,0.00020792}, {171,0.00030693}, {172,0.00023762}, {173,0.00019802}, {174,0.00010891}, {175,0.00023762}, {176,0.00036634}, {177,0.00019802}, {178,0.00038614}, {179,0.00038614}, {180,0.00022772}, {181,0.00011881}, {182,0.00037624}, {183,0.00033663}, {184,0.00011881}, {185,0.00023762}, {186,0.00025743}, {187,0.00015842}, {188,0.00031683}, {189,0.00019802}, {190,0.00019802}, {191,0.00022772}, {192,0.00031683}, {193,0.00037624}, {194,0.00031683}, {195,0.00034653}, {196,0.00029703}, {197,0.00018812}, {198,0.00023762}, {199,0.00022772}, {200,0.00035644}, {201,0.00006931}, {202,0.00010891}, {203,0.00025743}, {204,0.00014851}, {205,0.00030693}, {206,0.00021782}, {207,0.00015842}, {208,0.00022772}, {209,0.00022772}, {210,0.00034653}, {211,0.00037624}, {212,0.00022772}, {213,0.00028713}, {214,0.00025743}, {215,0.00034653}, {216,0.00038614}, {217,0.00039604}, {218,0.00039604}, {219,0.00023762}, {220,0.00028713}, {221,0.00050495}, {222,0.00042574}, {223,0.00026733}, {224,0.00028713}, {225,0.00027723}, {226,0.00022772}, {227,0.00026733}, {228,0.00022772}, {229,0.00015842}, {230,0.00027723}, {231,0.00039604}, {232,0.00022772}, {233,0.00018812}, {234,0.00031683}, {235,0.00019802}, {236,0.00021782}, {237,0.00026733}, {238,0.00031683}, {239,0.00013861}, {240,0.00013861}, {241,0.00050495}, {242,0.00027723}, {243,0.00027723}, {244,0.00046535}, {245,0.00015842}, {246,0.00043564}, {247,0.00037624}, {248,0.00039604}, {249,0.00029703}, {250,0.00011881}, {251,0.00030693}, {252,0.00036634}, {253,0.00029703}, {254,0.00011881}, {255,0.00031683}, {256,0.00023762}, {257,0.00030693}, {258,0.00040594}, {259,0.00025743}, {260,0.00024752}, {261,0.00034653}, {262,0.00025743}, {263,0.00024752}, {264,0.00013861}, {265,0.00239604}, {266,0.00023762}, {267,0.00030693}, {268,0.00012871}, {269,0.00019802}, {270,0.00024752}, {271,0.00013861}, {272,0.00032673}, {273,0.00036634}, {274,0.00024752}, {275,0.00025743}, {276,0.00025743}, {277,0.00020792}, {278,0.00027723}, {279,0.00045545}, {280,0.00044554}, {281,0.00032673}, {282,0.00015842}, {283,0.00025743}, {284,0.00045545}, {285,0.00035644}, {286,0.00022772}, {287,0.00047525}, {288,0.00022772}, {289,0.00027723}, {290,0.00027723}, {291,0.00010891}, {292,0.00022772}, {293,0.00023762}, {294,0.00031683}, {295,0.00020792}, {296,0.00050495}, {297,0.00033663}, {298,0.00041584}, {299,0.00019802}, {300,0.00028713}, {301,0.0002857}, {302,0.0003714}, {303,0.0003429}, {304,0.0000857}, {305,0.0001714}, {306,0.0003429}, {307,0.0002857}, {308,0.0003714}, {309,0.0000000}, {310,0.0002000}, {311,0.0005714}, {312,0.0004286}, {313,0.0003714}, {314,0.0000000}, {315,0.0006571}, {316,0.0004571}, {317,0.0003714}, {318,0.0002000}, {319,0.0004571}, {320,0.0004857}, {321,0.0003714}, {322,0.0004286}, {323,0.0000857}, {324,0.0002571}, {325,0.0004000}, {326,0.0005143}, {327,0.0000857}, {328,0.0004000}, {329,0.0002571}, {330,0.0001143}, {331,0.0004571}, {332,0.0003429}, {333,0.0007143}, {334,0.0007429}, {335,0.0003714}, {336,0.0002857}, {337,0.0003429}, {338,0.0006571}, {339,0.0004571}, {340,0.0000000}, {341,0.0003714}, {342,0.0003429}, {343,0.0004286}, {344,0.0005143}, {345,0.0002857}, {346,0.0003429}, {347,0.0003429}, {348,0.0003714}, {349,0.0002000}, {350,0.0001714}, {351,0.0003714}, {352,0.0002857}, {353,0.0006286}, {354,0.0006286}, {355,0.0002571}, {356,0.0006000}, {357,0.0004857}, {358,0.0004571}, {359,0.0002857}, {360,0.0004286}, {361,0.0002857}, {362,0.0002857}, {363,0.0004571}, {364,0.0001714}, {365,0.0003714}, {366,0.0002857}, {367,0.0000857}, {368,0.0001714}, {369,0.0006286}, {370,0.0000857}, {371,0.0003143}, {372,0.0001143}, {373,0.0004571}, {374,0.0007143}, {375,0.0002571}, {376,0.0003714}, {377,0.0002857}, {378,0.0000857}, {379,0.0004000}, {380,0.0003429}, {381,0.0004571}, {382,0.0004857}, {383,0.0002571}, {384,0.0004286}, {385,0.0003714}, {386,0.0006000}, {387,0.0003143}, {388,0.0016571}, {389,0.0000857}, {390,0.0002857}, {391,0.0005714}, {392,0.0002857}, {393,0.0002857}, {394,0.0004000}, {395,0.0003429}, {396,0.0002571}, {397,0.0005429}, {398,0.0001714}, {399,0.0000857}, {400,0.0004571}, {401,0.0002000}, {402,0.0002000}, {403,0.0004857}, {404,0.0002571}, {405,0.0003714}, {406,0.0008571}, {407,0.0002857}, {408,0.0003429}, {409,0.0003429}, {410,0.0004857}, {411,0.0000857}, {412,0.0004857}, {413,0.0003714}, {414,0.0005143}, {415,0.0003429}, {416,0.0001714}, {417,0.0000857}, {418,0.0003143}, {419,0.0004286}, {420,0.0001714}, {421,0.0003429}, {422,0.0006286}, {423,0.0004286}, {424,0.0000857}, {425,0.0003429}, {426,0.0001714}, {427,0.0003143}, {428,0.0004000}, {429,0.0004571}, {430,0.0002571}, {431,0.0006857}, {432,0.0001714}, {433,0.0005143}, {434,0.0002571}, {435,0.0002571}, {436,0.0004571}, {437,0.0002571}, {438,0.0003429}, {439,0.0007143}, {440,0.0004571}, {441,0.0001714}, {442,0.0003714}, {443,0.0004286}, {444,0.0005429}, {445,0.0007429}, {446,0.0001714}, {447,0.0003429}, {448,0.0002571}, {449,0.0005429}, {450,0.0003714}, {451,0.0001714}, {452,0.0003429}, {453,0.0005143}, {454,0.0006000}, {455,0.0005429}, {456,0.0006000}, {457,0.0004857}, {458,0.0006857}, {459,0.0005143}, {460,0.0004857}, {461,0.0008000}, {462,0.0002571}, {463,0.0005143}, {464,0.0003714}, {465,0.0006000}, {466,0.0005714}, {467,0.0007143}, {468,0.0004857}, {469,0.0002571}, {470,0.0007714}, {471,0.0006571}, {472,0.0007714}, {473,0.0007714}, {474,0.0000857}, {475,0.0007714}, {476,0.0002857}, {477,0.0005143}, {478,0.0004286}, {479,0.0002571}, {480,0.0003429}, {481,0.0006000}, {482,0.0017714}, {483,0.0006571}, {484,0.0003429}, {485,0.0002571}, {486,0.0006857}, {487,0.0003714}, {488,0.0005143}, {489,0.0005143}, {490,0.0002571}, {491,0.0009714}, {492,0.0005143}, {493,0.0003429}, {494,0.0003714}, {495,0.0006000}, {496,0.0002571}, {497,0.0003429}, {498,0.0007429}, {499,0.0009714}, {500,0.0004286}, {505,0.0004286}, {510,0.0006857}, {515,0.0006857}, {520,0.0005143}, {525,0.0004286}, {530,0.0005143}, {535,0.0008000}, {540,0.0004286}, {545,0.0000857}, {550,0.0002571}, {555,0.0004286}, {560,0.0007429}, {565,0.0004286}, {570,0.0004286}, {575,0.0009143}, {580,0.0007714}, {585,0.0006000}, {590,0.0004571}, {595,0.0007714}, {600,0.0004571}, {605,0.0001714}, {610,0.0003429}, {615,0.0005429}, {620,0.0003429}, {625,0.0007429}, {630,0.0008000}, {635,0.0008000}, {640,0.0009429}, {645,0.0008000}, {650,0.0005143}, {655,0.0004571}, {660,0.0002571}, {665,0.0005143}, {670,0.0006857}, {675,0.0005143}, {680,0.0006857}, {685,0.0005143}, {690,0.0008286}, {695,0.0022857}, {700,0.0008000}, {705,0.0006286}, {710,0.0007143}, {715,0.0005429}, {720,0.0007429}, {725,0.0008000}, {730,0.0010286}, {735,0.0009714}, {740,0.0006857}, {745,0.0005143}, {750,0.0006000}, {755,0.0005143}, {760,0.0010000}, {765,0.0008571}, {770,0.0006571}, {775,0.0009143}, {780,0.0011429}, {785,0.0010286}, {790,0.0007143}, {795,0.0008571}, {800,0.0006000}, {805,0.0007143}, {810,0.0007714}, {815,0.0002000}, {820,0.0007143}, {825,0.0007143}, {830,0.0008571}, {835,0.0006000}, {840,0.0009429}, {845,0.0008857}, {850,0.0008000}, {855,0.0011429}, {860,0.0004286}, {865,0.0009429}, {870,0.0004571}, {875,0.0013429}, {880,0.0007714}, {885,0.0005429}, {890,0.0009714}, {895,0.0006000}, {900,0.0012571}, {905,0.0009143}, {910,0.0005143}, {915,0.0006000}, {920,0.0004286}, {925,0.0008571}, {930,0.0008571}, {935,0.0008000}, {940,0.0009714}, {945,0.0006857}, {950,0.0003429}, {955,0.0009143}, {960,0.0010571}, {965,0.0010571}, {970,0.0010571}, {975,0.0006286}, {980,0.0006286}, {985,0.0008000}, {990,0.0008000}, {995,0.0012000}, {1000,0.0018571}, {1010,0.0009429}, {1020,0.0005143}, {1030,0.0011143}, {1040,0.0012286}, {1050,0.0012000}, {1060,0.0011429}, {1070,0.0007143}, {1080,0.0005714}, {1090,0.0005143}, {1100,0.0012000}, {1110,0.0008286}, {1120,0.0010286}, {1130,0.0009429}, {1140,0.0008000}, {1150,0.0010000}, {1160,0.0009429}, {1170,0.0014571}, {1180,0.0010857}, {1190,0.0010000}, {1200,0.0005143}, {1210,0.0011429}, {1220,0.0013714}, {1230,0.0011143}, {1240,0.0016000}, {1250,0.0015714}, {1260,0.0016000}, {1270,0.0017143}, {1280,0.0008571}, {1290,0.0016286}, {1300,0.0012571}, {1310,0.0014857}, {1320,0.0013143}, {1330,0.0015143}, {1340,0.0010286}, {1350,0.0011143}, {1360,0.0008857}, {1370,0.0010857}, {1380,0.0010571}, {1390,0.0013429}, {1400,0.0015714}, {1410,0.0016286}, {1420,0.0021714}, {1430,0.0013429}, {1440,0.0018000}, {1450,0.0013429}, {1460,0.0025143}, {1470,0.0010286}, {1480,0.0013429}, {1490,0.0015714}, {1500,0.0015143}, {1510,0.0019714}, {1520,0.0013714}, {1530,0.0018571}, {1540,0.0019714}, {1550,0.0015714}, {1560,0.0017714}, {1570,0.0015143}, {1580,0.0014286}, {1590,0.0017143}, {1600,0.0015429}, {1610,0.0021143}, {1620,0.0021143}, {1630,0.0020000}, {1640,0.0018857}, {1650,0.0021143}, {1660,0.0016857}, {1670,0.0019143}, {1680,0.0018857}, {1690,0.0017429}, {1700,0.0017429}, {1710,0.0023429}, {1720,0.0016286}, {1730,0.0022286}, {1740,0.0018286}, {1750,0.0017143}, {1760,0.0022286}, {1770,0.0018286}, {1780,0.0021143}, {1790,0.0013714}, {1800,0.0018857}, {1810,0.0025143}, {1820,0.0013714}, {1830,0.0019429}, {1840,0.0024286}, {1850,0.0014000}, {1860,0.0019714}, {1870,0.0015429}, {1880,0.0023714}, {1890,0.0021429}, {1900,0.0017714}, {1910,0.0018571}, {1920,0.0019429}, {1930,0.0018286}, {1940,0.0022857}, {1950,0.0015429}, {1960,0.0021143}, {1970,0.0020571}, {1980,0.0021429}, {1990,0.0017714}, {2000,0.0083714}};
data["big"]["LtacTacInTermGallinaCtx"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00003960}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00003960}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00003960}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00003960}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0001143}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0001143}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0001143}, {775,0.0001143}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0001143}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0001143}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0001143}, {925,0.0000000}, {930,0.0000000}, {935,0.0001143}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000857}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0001143}, {1070,0.0001143}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0001143}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000857}, {1420,0.0000000}, {1430,0.0000857}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000857}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000857}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000857}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000857}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0001714}};
data["big"]["LtacTacInTermGallinaCtx"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0013429}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000571}, {1310,0.0000000}, {1320,0.0000286}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000571}, {1360,0.0000000}, {1370,0.0000857}, {1380,0.0000000}, {1390,0.0000286}, {1400,0.0000571}, {1410,0.0001143}, {1420,0.0001143}, {1430,0.0001429}, {1440,0.0001429}, {1450,0.0001714}, {1460,0.0002286}, {1470,0.0002286}, {1480,0.0044000}, {1490,0.0001714}, {1500,0.0001714}, {1510,0.0002286}, {1520,0.0002571}, {1530,0.0002571}, {1540,0.0002286}, {1550,0.0003714}, {1560,0.0003429}, {1570,0.0004286}, {1580,0.0006000}, {1590,0.0007143}, {1600,0.0007714}, {1610,0.0009429}, {1620,0.0010000}, {1630,0.0010000}, {1640,0.0010000}, {1650,0.0010000}, {1660,0.0010000}, {1670,0.0010000}, {1680,0.0010000}, {1690,0.0010000}, {1700,0.0010000}, {1710,0.0010000}, {1720,0.0010000}, {1730,0.0010000}, {1740,0.0010000}, {1750,0.0010000}, {1760,0.0010000}, {1770,0.0010000}, {1780,0.0010000}, {1790,0.0010000}, {1800,0.0010000}, {1810,0.0010000}, {1820,0.0010000}, {1830,0.0010000}, {1840,0.0010000}, {1850,0.0010000}, {1860,0.0010000}, {1870,0.0010000}, {1880,0.0010000}, {1890,0.0010000}, {1900,0.0010000}, {1910,0.0010000}, {1920,0.0010000}, {1930,0.0010000}, {1940,0.0010000}, {1950,0.0010000}, {1960,0.0010000}, {1970,0.0010000}, {1980,0.0010000}, {1990,0.0010000}, {2000,0.0010000}};
data["big"]["LtacTacInTermGallinaCtx"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003960}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00007921}, {9,0.00007921}, {10,0.00000000}, {11,0.00000000}, {12,0.00010891}, {13,0.00000000}, {14,0.00009901}, {15,0.00003960}, {16,0.00007921}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00003960}, {21,0.00000000}, {22,0.00015842}, {23,0.00003960}, {24,0.00002970}, {25,0.00003960}, {26,0.00002970}, {27,0.00007921}, {28,0.00000000}, {29,0.00003960}, {30,0.00000000}, {31,0.00007921}, {32,0.00003960}, {33,0.00000000}, {34,0.00007921}, {35,0.00000000}, {36,0.00007921}, {37,0.00002970}, {38,0.00007921}, {39,0.00000000}, {40,0.00003960}, {41,0.00007921}, {42,0.00000000}, {43,0.00000000}, {44,0.00003960}, {45,0.00003960}, {46,0.00007921}, {47,0.00000000}, {48,0.00003960}, {49,0.00006931}, {50,0.00007921}, {51,0.00003960}, {52,0.00003960}, {53,0.00003960}, {54,0.00003960}, {55,0.00003960}, {56,0.00002970}, {57,0.00007921}, {58,0.00011881}, {59,0.00007921}, {60,0.00006931}, {61,0.00007921}, {62,0.00000000}, {63,0.00006931}, {64,0.00003960}, {65,0.00011881}, {66,0.00007921}, {67,0.00003960}, {68,0.00003960}, {69,0.00010891}, {70,0.00003960}, {71,0.00007921}, {72,0.00006931}, {73,0.00003960}, {74,0.00003960}, {75,0.00006931}, {76,0.00000000}, {77,0.00011881}, {78,0.00011881}, {79,0.00007921}, {80,0.00007921}, {81,0.00019802}, {82,0.00000000}, {83,0.00006931}, {84,0.00013861}, {85,0.00011881}, {86,0.00010891}, {87,0.00007921}, {88,0.00013861}, {89,0.00010891}, {90,0.00003960}, {91,0.00009901}, {92,0.00007921}, {93,0.00000000}, {94,0.00009901}, {95,0.00003960}, {96,0.00003960}, {97,0.00006931}, {98,0.00003960}, {99,0.00011881}, {100,0.00011881}, {101,0.00011881}, {102,0.00010891}, {103,0.00006931}, {104,0.00000000}, {105,0.00011881}, {106,0.00011881}, {107,0.00011881}, {108,0.00006931}, {109,0.00017822}, {110,0.00022772}, {111,0.00003960}, {112,0.00014851}, {113,0.00011881}, {114,0.00000000}, {115,0.00010891}, {116,0.00003960}, {117,0.00005941}, {118,0.00015842}, {119,0.00010891}, {120,0.00010891}, {121,0.00019802}, {122,0.00015842}, {123,0.00010891}, {124,0.00022772}, {125,0.00000000}, {126,0.00010891}, {127,0.00009901}, {128,0.00011881}, {129,0.00007921}, {130,0.00011881}, {131,0.00000000}, {132,0.00029703}, {133,0.00003960}, {134,0.00003960}, {135,0.00019802}, {136,0.00013861}, {137,0.00011881}, {138,0.00007921}, {139,0.00011881}, {140,0.00007921}, {141,0.00014851}, {142,0.00007921}, {143,0.00014851}, {144,0.00013861}, {145,0.00015842}, {146,0.00015842}, {147,0.00027723}, {148,0.00003960}, {149,0.00007921}, {150,0.00007921}, {151,0.00002970}, {152,0.00013861}, {153,0.00011881}, {154,0.00006931}, {155,0.00007921}, {156,0.00022772}, {157,0.00015842}, {158,0.00018812}, {159,0.00018812}, {160,0.00007921}, {161,0.00011881}, {162,0.00010891}, {163,0.00010891}, {164,0.00025743}, {165,0.00011881}, {166,0.00017822}, {167,0.00011881}, {168,0.00023762}, {169,0.00007921}, {170,0.00021782}, {171,0.00014851}, {172,0.00010891}, {173,0.00010891}, {174,0.00006931}, {175,0.00011881}, {176,0.00019802}, {177,0.00024752}, {178,0.00011881}, {179,0.00010891}, {180,0.00007921}, {181,0.00011881}, {182,0.00007921}, {183,0.00003960}, {184,0.00010891}, {185,0.00013861}, {186,0.00007921}, {187,0.00014851}, {188,0.00003960}, {189,0.00017822}, {190,0.00009901}, {191,0.00027723}, {192,0.00011881}, {193,0.00014851}, {194,0.00019802}, {195,0.00021782}, {196,0.00017822}, {197,0.00014851}, {198,0.00011881}, {199,0.00018812}, {200,0.00026733}, {201,0.00011881}, {202,0.00013861}, {203,0.00027723}, {204,0.00014851}, {205,0.00011881}, {206,0.00003960}, {207,0.00011881}, {208,0.00023762}, {209,0.00030693}, {210,0.00007921}, {211,0.00009901}, {212,0.00010891}, {213,0.00019802}, {214,0.00019802}, {215,0.00027723}, {216,0.00025743}, {217,0.00015842}, {218,0.00011881}, {219,0.00034653}, {220,0.00007921}, {221,0.00011881}, {222,0.00021782}, {223,0.00015842}, {224,0.00003960}, {225,0.00019802}, {226,0.00021782}, {227,0.00011881}, {228,0.00007921}, {229,0.00031683}, {230,0.00015842}, {231,0.00021782}, {232,0.00023762}, {233,0.00017822}, {234,0.00014851}, {235,0.00006931}, {236,0.00019802}, {237,0.00006931}, {238,0.00011881}, {239,0.00011881}, {240,0.00029703}, {241,0.00003960}, {242,0.00023762}, {243,0.00019802}, {244,0.00023762}, {245,0.00015842}, {246,0.00027723}, {247,0.00015842}, {248,0.00015842}, {249,0.00000000}, {250,0.00010891}, {251,0.00027723}, {252,0.00014851}, {253,0.00019802}, {254,0.00014851}, {255,0.00015842}, {256,0.00023762}, {257,0.00017822}, {258,0.00015842}, {259,0.00024752}, {260,0.00006931}, {261,0.00026733}, {262,0.00005941}, {263,0.00026733}, {264,0.00030693}, {265,0.00009901}, {266,0.00021782}, {267,0.00019802}, {268,0.00011881}, {269,0.00014851}, {270,0.00016832}, {271,0.00019802}, {272,0.00031683}, {273,0.00021782}, {274,0.00018812}, {275,0.00016832}, {276,0.00007921}, {277,0.00016832}, {278,0.00024752}, {279,0.00035644}, {280,0.00011881}, {281,0.00009901}, {282,0.00016832}, {283,0.00025743}, {284,0.00014851}, {285,0.00012871}, {286,0.00017822}, {287,0.00019802}, {288,0.00010891}, {289,0.00009901}, {290,0.00015842}, {291,0.00027723}, {292,0.00008911}, {293,0.00018812}, {294,0.00036634}, {295,0.00019802}, {296,0.00017822}, {297,0.00011881}, {298,0.00020792}, {299,0.00036634}, {300,0.00034653}, {301,0.0001714}, {302,0.0000857}, {303,0.0000857}, {304,0.0002571}, {305,0.0000000}, {306,0.0003714}, {307,0.0001143}, {308,0.0001143}, {309,0.0000000}, {310,0.0002000}, {311,0.0001714}, {312,0.0002571}, {313,0.0002000}, {314,0.0001714}, {315,0.0000000}, {316,0.0002571}, {317,0.0002000}, {318,0.0002571}, {319,0.0002286}, {320,0.0002286}, {321,0.0000857}, {322,0.0000857}, {323,0.0004286}, {324,0.0001714}, {325,0.0001143}, {326,0.0000857}, {327,0.0000857}, {328,0.0000857}, {329,0.0000857}, {330,0.0004571}, {331,0.0002571}, {332,0.0002000}, {333,0.0000857}, {334,0.0000857}, {335,0.0000857}, {336,0.0002000}, {337,0.0000000}, {338,0.0000857}, {339,0.0005429}, {340,0.0005143}, {341,0.0001714}, {342,0.0001714}, {343,0.0001714}, {344,0.0001714}, {345,0.0002857}, {346,0.0001714}, {347,0.0000857}, {348,0.0003429}, {349,0.0000857}, {350,0.0002857}, {351,0.0000857}, {352,0.0005429}, {353,0.0002571}, {354,0.0000857}, {355,0.0000857}, {356,0.0000857}, {357,0.0002857}, {358,0.0001714}, {359,0.0000000}, {360,0.0002286}, {361,0.0002857}, {362,0.0000857}, {363,0.0003714}, {364,0.0000000}, {365,0.0001714}, {366,0.0000857}, {367,0.0002000}, {368,0.0004571}, {369,0.0000000}, {370,0.0002000}, {371,0.0002571}, {372,0.0003143}, {373,0.0003143}, {374,0.0000000}, {375,0.0003429}, {376,0.0005143}, {377,0.0003714}, {378,0.0002571}, {379,0.0000857}, {380,0.0000857}, {381,0.0002571}, {382,0.0002857}, {383,0.0004286}, {384,0.0001714}, {385,0.0003714}, {386,0.0000000}, {387,0.0014000}, {388,0.0003714}, {389,0.0000000}, {390,0.0002000}, {391,0.0001714}, {392,0.0005143}, {393,0.0000857}, {394,0.0002286}, {395,0.0000857}, {396,0.0002857}, {397,0.0000857}, {398,0.0000857}, {399,0.0002000}, {400,0.0001714}, {401,0.0003714}, {402,0.0004571}, {403,0.0001714}, {404,0.0001714}, {405,0.0002571}, {406,0.0002000}, {407,0.0001143}, {408,0.0002000}, {409,0.0000857}, {410,0.0001714}, {411,0.0003714}, {412,0.0002000}, {413,0.0003429}, {414,0.0001714}, {415,0.0002000}, {416,0.0001714}, {417,0.0004857}, {418,0.0002857}, {419,0.0003143}, {420,0.0001714}, {421,0.0001714}, {422,0.0001714}, {423,0.0002571}, {424,0.0001143}, {425,0.0002571}, {426,0.0002857}, {427,0.0001714}, {428,0.0003714}, {429,0.0002571}, {430,0.0002000}, {431,0.0001714}, {432,0.0003714}, {433,0.0000857}, {434,0.0002000}, {435,0.0004000}, {436,0.0002000}, {437,0.0004571}, {438,0.0001714}, {439,0.0002571}, {440,0.0003714}, {441,0.0004571}, {442,0.0000000}, {443,0.0001714}, {444,0.0002571}, {445,0.0001714}, {446,0.0002571}, {447,0.0000857}, {448,0.0003143}, {449,0.0003714}, {450,0.0002571}, {451,0.0002571}, {452,0.0003143}, {453,0.0001714}, {454,0.0002857}, {455,0.0004000}, {456,0.0002857}, {457,0.0002571}, {458,0.0000857}, {459,0.0001714}, {460,0.0003714}, {461,0.0002571}, {462,0.0002857}, {463,0.0001714}, {464,0.0005429}, {465,0.0001714}, {466,0.0000857}, {467,0.0003429}, {468,0.0002000}, {469,0.0000000}, {470,0.0002571}, {471,0.0001714}, {472,0.0001143}, {473,0.0001714}, {474,0.0003714}, {475,0.0000857}, {476,0.0000000}, {477,0.0000000}, {478,0.0004857}, {479,0.0004000}, {480,0.0005143}, {481,0.0002857}, {482,0.0005429}, {483,0.0002571}, {484,0.0003714}, {485,0.0005143}, {486,0.0003429}, {487,0.0003143}, {488,0.0001714}, {489,0.0003429}, {490,0.0000857}, {491,0.0000000}, {492,0.0002857}, {493,0.0001714}, {494,0.0000857}, {495,0.0002000}, {496,0.0004000}, {497,0.0006571}, {498,0.0001714}, {499,0.0002571}, {500,0.0003429}, {505,0.0004000}, {510,0.0003714}, {515,0.0003429}, {520,0.0002000}, {525,0.0001143}, {530,0.0009143}, {535,0.0000857}, {540,0.0004286}, {545,0.0001714}, {550,0.0003429}, {555,0.0001714}, {560,0.0003429}, {565,0.0002571}, {570,0.0000857}, {575,0.0000857}, {580,0.0003143}, {585,0.0005143}, {590,0.0004000}, {595,0.0002571}, {600,0.0002857}, {605,0.0004286}, {610,0.0002571}, {615,0.0003429}, {620,0.0003714}, {625,0.0000857}, {630,0.0002571}, {635,0.0003429}, {640,0.0001714}, {645,0.0000000}, {650,0.0005143}, {655,0.0004286}, {660,0.0002571}, {665,0.0003714}, {670,0.0004286}, {675,0.0004286}, {680,0.0000857}, {685,0.0004286}, {690,0.0004571}, {695,0.0004286}, {700,0.0001714}, {705,0.0003429}, {710,0.0002571}, {715,0.0005714}, {720,0.0002571}, {725,0.0004571}, {730,0.0002857}, {735,0.0003429}, {740,0.0002571}, {745,0.0001714}, {750,0.0000857}, {755,0.0003714}, {760,0.0003429}, {765,0.0004000}, {770,0.0005143}, {775,0.0003429}, {780,0.0003714}, {785,0.0002000}, {790,0.0003429}, {795,0.0003429}, {800,0.0006286}, {805,0.0004286}, {810,0.0002571}, {815,0.0007143}, {820,0.0007429}, {825,0.0001714}, {830,0.0005429}, {835,0.0005143}, {840,0.0006000}, {845,0.0004571}, {850,0.0004286}, {855,0.0001714}, {860,0.0007143}, {865,0.0001714}, {870,0.0002571}, {875,0.0004286}, {880,0.0001714}, {885,0.0005143}, {890,0.0004286}, {895,0.0007429}, {900,0.0004571}, {905,0.0001714}, {910,0.0005143}, {915,0.0005143}, {920,0.0006000}, {925,0.0003714}, {930,0.0004571}, {935,0.0004286}, {940,0.0002571}, {945,0.0010286}, {950,0.0005429}, {955,0.0008000}, {960,0.0005143}, {965,0.0005143}, {970,0.0003429}, {975,0.0006286}, {980,0.0004571}, {985,0.0010571}, {990,0.0006000}, {995,0.0006000}, {1000,0.0002000}, {1010,0.0007429}, {1020,0.0004286}, {1030,0.0006857}, {1040,0.0006286}, {1050,0.0007714}, {1060,0.0007714}, {1070,0.0006000}, {1080,0.0007143}, {1090,0.0011429}, {1100,0.0004857}, {1110,0.0008857}, {1120,0.0014571}, {1130,0.0007714}, {1140,0.0007429}, {1150,0.0004286}, {1160,0.0008286}, {1170,0.0004286}, {1180,0.0004571}, {1190,0.0010857}, {1200,0.0005714}, {1210,0.0005429}, {1220,0.0005714}, {1230,0.0005143}, {1240,0.0007429}, {1250,0.0004857}, {1260,0.0002286}, {1270,0.0004857}, {1280,0.0010286}, {1290,0.0006571}, {1300,0.0007143}, {1310,0.0007429}, {1320,0.0007429}, {1330,0.0005429}, {1340,0.0009429}, {1350,0.0008286}, {1360,0.0006857}, {1370,0.0006857}, {1380,0.0009714}, {1390,0.0009143}, {1400,0.0007429}, {1410,0.0013143}, {1420,0.0007429}, {1430,0.0005714}, {1440,0.0004857}, {1450,0.0009143}, {1460,0.0007429}, {1470,0.0012857}, {1480,0.0044857}, {1490,0.0006571}, {1500,0.0009429}, {1510,0.0005143}, {1520,0.0008571}, {1530,0.0007143}, {1540,0.0005429}, {1550,0.0011714}, {1560,0.0012857}, {1570,0.0010000}, {1580,0.0008286}, {1590,0.0012000}, {1600,0.0006857}, {1610,0.0007714}, {1620,0.0006286}, {1630,0.0008000}, {1640,0.0008571}, {1650,0.0009143}, {1660,0.0009429}, {1670,0.0011429}, {1680,0.0010286}, {1690,0.0007714}, {1700,0.0016000}, {1710,0.0006571}, {1720,0.0012000}, {1730,0.0006286}, {1740,0.0011143}, {1750,0.0011143}, {1760,0.0011143}, {1770,0.0015143}, {1780,0.0010571}, {1790,0.0008571}, {1800,0.0008857}, {1810,0.0006000}, {1820,0.0018286}, {1830,0.0008857}, {1840,0.0008571}, {1850,0.0018857}, {1860,0.0011714}, {1870,0.0019143}, {1880,0.0009143}, {1890,0.0010286}, {1900,0.0019143}, {1910,0.0015714}, {1920,0.0010286}, {1930,0.0012857}, {1940,0.0010857}, {1950,0.0014000}, {1960,0.0010857}, {1970,0.0017143}, {1980,0.0013143}, {1990,0.0017714}, {2000,0.0007714}};
data["big"]["LtacTacInTermGallinaCtx"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00003960}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00003960}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00003960}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00003960}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0001143}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0001143}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0001143}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0001143}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0001143}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0001143}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0001143}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0001143}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0001143}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000857}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000857}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0002000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermGallinaCtx"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00018812}, {3,0.00100000}, {4,0.00100000}, {5,0.00163366}, {6,0.00200000}, {7,0.00204950}, {8,0.00300000}, {9,0.00300000}, {10,0.00338614}, {11,0.00400000}, {12,0.00424752}, {13,0.00500000}, {14,0.00533663}, {15,0.00600000}, {16,0.00630693}, {17,0.00700990}, {18,0.00720792}, {19,0.00801980}, {20,0.00845545}, {21,0.00912871}, {22,0.00950495}, {23,0.01020792}, {24,0.01072277}, {25,0.01134653}, {26,0.01349505}, {27,0.01248515}, {28,0.01331683}, {29,0.01381188}, {30,0.01424752}, {31,0.01516832}, {32,0.01581188}, {33,0.01652475}, {34,0.01730693}, {35,0.01803960}, {36,0.01850495}, {37,0.01943564}, {38,0.02020792}, {39,0.02085149}, {40,0.02172277}, {41,0.02762376}, {42,0.02347525}, {43,0.02400000}, {44,0.02474257}, {45,0.02961386}, {46,0.02671287}, {47,0.02753465}, {48,0.02821782}, {49,0.02939604}, {50,0.03006931}, {51,0.03108911}, {52,0.03175248}, {53,0.03877228}, {54,0.03362376}, {55,0.03464356}, {56,0.04566337}, {57,0.03688119}, {58,0.03813861}, {59,0.03883168}, {60,0.03989109}, {61,0.04089109}, {62,0.04163366}, {63,0.04317822}, {64,0.04412871}, {65,0.04534653}, {66,0.04617822}, {67,0.05566337}, {68,0.04830693}, {69,0.04999010}, {70,0.06393069}, {71,0.05187129}, {72,0.06104950}, {73,0.05419802}, {74,0.07160396}, {75,0.05680198}, {76,0.07048515}, {77,0.07911881}, {78,0.06078218}, {79,0.06168317}, {80,0.06306931}, {81,0.06645545}, {82,0.07290099}, {83,0.07708911}, {84,0.07175248}, {85,0.08560396}, {86,0.09713861}, {87,0.08984158}, {88,0.10266337}, {89,0.12866337}, {90,0.11018812}, {91,0.09904950}, {92,0.09949505}, {93,0.10577228}, {94,0.10401980}, {95,0.10599010}, {96,0.10906931}, {97,0.10937624}, {98,0.11205941}, {99,0.11546535}, {100,0.11830693}, {101,0.12105941}, {102,0.12139604}, {103,0.12322772}, {104,0.12619802}, {105,0.12845545}, {106,0.13266337}, {107,0.13329703}, {108,0.13571287}, {109,0.12930693}, {110,0.13113861}, {111,0.13364356}, {112,0.13391089}, {113,0.13746535}, {114,0.13902970}, {115,0.14100990}, {116,0.14283168}, {117,0.14611881}, {118,0.14819802}, {119,0.14945545}, {120,0.15235644}, {121,0.15515842}, {122,0.15492079}, {123,0.16039604}, {124,0.16290099}, {125,0.16431683}, {126,0.16640594}, {127,0.16850495}, {128,0.17093069}, {129,0.17305941}, {130,0.17727723}, {131,0.17805941}, {132,0.18202970}, {133,0.18327723}, {134,0.18530693}, {135,0.18796040}, {136,0.18968317}, {137,0.19259406}, {138,0.19377228}, {139,0.19868317}, {140,0.20068317}, {141,0.20223762}, {142,0.20696040}, {143,0.20700990}, {144,0.20905941}, {145,0.21342574}, {146,0.21577228}, {147,0.21747525}, {148,0.22011881}, {149,0.22248515}, {150,0.22693069}, {151,0.23056436}, {152,0.23152475}, {153,0.23506931}, {154,0.23885149}, {155,0.23965347}, {156,0.24251485}, {157,0.24701980}, {158,0.24865347}, {159,0.25339604}, {160,0.25174257}, {161,0.25473267}, {162,0.25853465}, {163,0.26063366}, {164,0.26373267}, {165,0.26762376}, {166,0.27237624}, {167,0.27356436}, {168,0.27947525}, {169,0.28232673}, {170,0.28182178}, {171,0.28451485}, {172,0.28968317}, {173,0.29314851}, {174,0.29602970}, {175,0.29851485}, {176,0.30153465}, {177,0.30476238}, {178,0.30771287}, {179,0.31004950}, {180,0.31094059}, {181,0.31447525}, {182,0.31808911}, {183,0.32150495}, {184,0.32472277}, {185,0.32750495}, {186,0.33089109}, {187,0.33287129}, {188,0.33587129}, {189,0.34063366}, {190,0.34398020}, {191,0.34769307}, {192,0.35115842}, {193,0.35675248}, {194,0.36615842}, {195,0.37170297}, {196,0.37187129}, {197,0.37219802}, {198,0.37287129}, {199,0.37841584}, {200,0.38218812}, {201,0.38656436}, {202,0.39901980}, {203,0.40008911}, {204,0.39304950}, {205,0.39709901}, {206,0.39719802}, {207,0.41239604}, {208,0.42214851}, {209,0.41597030}, {210,0.41498020}, {211,0.41700990}, {212,0.43347525}, {213,0.43119802}, {214,0.42612871}, {215,0.43354455}, {216,0.44931683}, {217,0.44477228}, {218,0.44421782}, {219,0.46126733}, {220,0.45622772}, {221,0.45738614}, {222,0.47482178}, {223,0.46902970}, {224,0.47488119}, {225,0.47869307}, {226,0.48110891}, {227,0.49537624}, {228,0.48621782}, {229,0.49884158}, {230,0.49605941}, {231,0.50604950}, {232,0.50904950}, {233,0.51059406}, {234,0.51592079}, {235,0.52257426}, {236,0.52251485}, {237,0.53435644}, {238,0.52939604}, {239,0.54627723}, {240,0.53852475}, {241,0.54991089}, {242,0.55215842}, {243,0.55629703}, {244,0.56417822}, {245,0.56799010}, {246,0.56555446}, {247,0.57710891}, {248,0.57328713}, {249,0.58350495}, {250,0.59084158}, {251,0.58556436}, {252,0.59456436}, {253,0.60611881}, {254,0.59915842}, {255,0.60801980}, {256,0.62098020}, {257,0.61515842}, {258,0.61850495}, {259,0.62501980}, {260,0.63148515}, {261,0.63979208}, {262,0.73247525}, {263,0.64946535}, {264,0.65080198}, {265,0.65282178}, {266,0.70079208}, {267,0.66603960}, {268,0.67225743}, {269,0.67402970}, {270,0.67813861}, {271,0.68408911}, {272,0.68753465}, {273,0.69820792}, {274,0.70623762}, {275,0.75431683}, {276,0.71498020}, {277,0.71994059}, {278,0.72605941}, {279,0.73058416}, {280,0.73371287}, {281,0.74236634}, {282,0.75388119}, {283,0.75545545}, {284,0.75753465}, {285,0.76500990}, {286,0.76690099}, {287,0.77137624}, {288,0.79427723}, {289,0.78366337}, {290,0.78469307}, {291,0.79167327}, {292,0.78771287}, {293,0.79180198}, {294,0.79688119}, {295,0.80696040}, {296,0.81492079}, {297,0.82984158}, {298,0.83099010}, {299,0.82862376}, {300,0.82631683}, {301,0.8709429}, {302,0.9868857}, {303,0.8894000}, {304,0.8970286}, {305,0.9082286}, {306,0.9037429}, {307,0.9114000}, {308,0.9285714}, {309,0.9185714}, {310,0.9213714}, {311,0.9402286}, {312,0.9441714}, {313,0.9490571}, {314,0.9561143}, {315,0.9603429}, {316,0.9650286}, {317,0.9686000}, {318,1.0337714}, {319,0.9844286}, {320,0.9882286}, {321,0.9959429}, {322,0.9995143}, {323,0.9996571}, {324,1.0077143}, {325,1.0128000}, {326,1.0186571}, {327,1.0325143}, {328,1.0305143}, {329,1.0461429}, {330,1.0450571}, {331,1.0615143}, {332,1.0602286}, {333,1.0616286}, {334,1.0696857}, {335,1.0720286}, {336,1.0842571}, {337,1.0815143}, {338,1.0943143}, {339,1.0936286}, {340,1.1084286}, {341,1.1102571}, {342,1.1267429}, {343,1.1330000}, {344,1.1479143}, {345,1.1467714}, {346,1.1555429}, {347,1.1550286}, {348,1.1641429}, {349,1.1714286}, {350,1.1850571}, {351,1.1935714}, {352,1.1896857}, {353,1.1960286}, {354,1.2047143}, {355,1.2133429}, {356,1.2148286}, {357,1.2288571}, {358,1.2274000}, {359,1.2342857}, {360,1.2380000}, {361,1.2541714}, {362,1.2544571}, {363,1.2937143}, {364,1.2728000}, {365,1.2766857}, {366,1.2752857}, {367,1.2991429}, {368,1.3261714}, {369,1.3013143}, {370,1.3159714}, {371,1.3249429}, {372,1.3297429}, {373,1.3337714}, {374,1.3523429}, {375,1.3585714}, {376,1.3606857}, {377,1.3696857}, {378,1.3698571}, {379,1.3759714}, {380,1.3960000}, {381,1.3978857}, {382,1.4050000}, {383,1.4196857}, {384,1.4286286}, {385,1.4326571}, {386,1.4488286}, {387,1.4870000}, {388,1.4590286}, {389,1.4795714}, {390,1.4783143}, {391,1.4902286}, {392,1.4912286}, {393,1.4968000}, {394,1.5042000}, {395,1.5140571}, {396,1.5273429}, {397,1.5389143}, {398,1.5415429}, {399,1.5511143}, {400,1.5629714}, {401,1.5738000}, {402,1.5836286}, {403,1.6026571}, {404,1.6053143}, {405,1.6170571}, {406,1.6287429}, {407,1.6341429}, {408,1.6610000}, {409,1.6667714}, {410,1.6776857}, {411,1.6472000}, {412,1.7038571}, {413,1.6670000}, {414,1.6770000}, {415,1.7113143}, {416,1.7444000}, {417,1.6927429}, {418,1.7248857}, {419,1.7605143}, {420,1.7827429}, {421,1.8132571}, {422,1.7267143}, {423,1.7352571}, {424,1.7437143}, {425,1.7598571}, {426,1.8051429}, {427,1.8903143}, {428,1.7998857}, {429,1.8391143}, {430,1.8169429}, {431,1.8602571}, {432,1.9131143}, {433,1.9256000}, {434,1.8893143}, {435,1.8912286}, {436,1.8685429}, {437,1.9051429}, {438,1.9240000}, {439,1.9464571}, {440,2.0174286}, {441,1.9522857}, {442,1.9989429}, {443,2.0067714}, {444,1.9790000}, {445,1.9596000}, {446,1.9645714}, {447,1.9810571}, {448,2.0194857}, {449,2.0089143}, {450,2.0194000}, {451,2.0039714}, {452,2.0162571}, {453,2.0325143}, {454,2.0515429}, {455,2.0567429}, {456,2.0671429}, {457,2.0783714}, {458,2.1238857}, {459,2.1201429}, {460,2.1324000}, {461,2.1578571}, {462,2.1719429}, {463,2.1287143}, {464,2.1579429}, {465,2.2250571}, {466,2.2373429}, {467,2.2517429}, {468,2.3401714}, {469,2.2466286}, {470,2.2324571}, {471,2.2829714}, {472,2.3067143}, {473,2.2646000}, {474,2.3076857}, {475,2.3080286}, {476,2.2997143}, {477,2.2613429}, {478,2.2976571}, {479,2.3148000}, {480,2.3240286}, {481,2.3282286}, {482,2.3716000}, {483,2.3723429}, {484,2.4316286}, {485,2.3693143}, {486,2.3950571}, {487,2.3826857}, {488,2.5479429}, {489,2.3920571}, {490,2.4011714}, {491,2.5044571}, {492,2.4098000}, {493,2.4403714}, {494,2.5138286}, {495,2.5626286}, {496,2.4988571}, {497,2.5017429}, {498,2.5489714}, {499,2.5427143}, {500,2.5592000}, {505,2.6045714}, {510,2.7009714}, {515,2.7719143}, {520,2.9507714}, {525,2.9869143}, {530,2.8899714}, {535,2.9561429}, {540,3.0277714}, {545,3.0886286}, {550,3.1601714}, {555,3.2329429}, {560,3.2299143}, {565,3.2630571}, {570,3.3308000}, {575,3.4157143}, {580,3.4757429}, {585,3.5128857}, {590,3.6141429}, {595,3.7337714}, {600,3.7733143}, {605,3.8897143}, {610,3.9164286}, {615,4.0344286}, {620,4.0894571}, {625,4.1043429}, {630,4.2176286}, {635,4.2402286}, {640,4.3198286}, {645,4.2815143}, {650,4.3844571}, {655,4.5064286}, {660,4.5616571}, {665,4.5831143}, {670,4.7304857}, {675,4.9912286}, {680,4.9789143}, {685,5.0358571}, {690,5.1968000}, {695,5.1977143}, {700,5.3336286}, {705,5.4345143}, {710,5.4706857}, {715,5.4422571}, {720,5.6162000}, {725,5.6419143}, {730,5.7954286}, {735,5.7833429}, {740,6.0247429}, {745,6.2140000}, {750,6.2876857}, {755,6.2767714}, {760,6.4432571}, {765,6.5638857}, {770,6.6390857}, {775,6.8831143}, {780,6.8876000}, {785,6.9557429}, {790,7.1356000}, {795,7.0914000}, {800,7.2435143}, {805,7.5236571}, {810,7.4007714}, {815,7.6144286}, {820,7.5964000}, {825,7.7719143}, {830,7.8183714}, {835,7.8498286}, {840,8.1209429}, {845,8.3380571}, {850,8.4686857}, {855,8.6904286}, {860,8.7205714}, {865,9.1628571}, {870,9.0866571}, {875,9.1730857}, {880,9.2572286}, {885,9.2003714}, {890,9.6077714}, {895,9.7162286}, {900,9.5616857}, {905,9.8974286}, {910,9.8857143}, {915,10.0442000}, {920,10.1439714}, {925,10.3359714}, {930,10.2813143}, {935,10.5667429}, {940,10.5598000}, {945,10.6087714}, {950,10.7741429}, {955,11.0144000}, {960,10.8936286}, {965,11.2670286}, {970,11.2632000}, {975,11.3365429}, {980,11.5415714}, {985,11.6252857}, {990,12.0196857}, {995,11.8162000}, {1000,11.9698857}, {1010,12.1936000}, {1020,12.7184857}, {1030,12.8899714}, {1040,13.3282571}, {1050,13.7584000}, {1060,14.1799429}, {1070,14.4925429}, {1080,14.7092000}, {1090,15.0508000}, {1100,15.2353714}, {1110,15.8854286}, {1120,15.9472857}, {1130,16.6875143}, {1140,16.9878571}, {1150,16.9281714}, {1160,17.6011714}, {1170,18.0033429}, {1180,18.5391143}, {1190,19.1241714}, {1200,19.1510286}, {1210,19.5422000}, {1220,20.3625143}, {1230,21.0338857}, {1240,21.5019143}, {1250,21.5389429}, {1260,22.3255143}, {1270,22.5940857}, {1280,23.0734571}, {1290,23.5120571}, {1300,23.8000857}, {1310,24.4336000}, {1320,24.9000571}, {1330,25.6367714}, {1340,25.8084571}, {1350,26.8954571}, {1360,27.2574857}, {1370,27.1805143}, {1380,28.0738000}, {1390,28.2618286}, {1400,29.4307429}, {1410,30.0062857}, {1420,30.5668000}, {1430,30.9468286}, {1440,31.2317429}, {1450,31.8244000}, {1460,32.4390286}, {1470,33.0857429}, {1480,34.8112571}, {1490,34.6527429}, {1500,34.7506571}, {1510,35.8272286}, {1520,36.6195429}, {1530,36.6096857}, {1540,37.5027143}, {1550,38.5039429}, {1560,38.8981714}, {1570,39.6641429}, {1580,39.9405429}, {1590,40.6853429}, {1600,40.7327714}, {1610,42.9198857}, {1620,42.3337143}, {1630,43.5364571}, {1640,44.2474286}, {1650,44.8646286}, {1660,45.8255429}, {1670,45.9373143}, {1680,47.7119429}, {1690,48.0380000}, {1700,49.1310000}, {1710,50.4157429}, {1720,51.3170286}, {1730,50.9881714}, {1740,52.0264000}, {1750,51.9278000}, {1760,52.6273429}, {1770,53.9105143}, {1780,54.6607143}, {1790,55.5671143}, {1800,56.2143714}, {1810,57.5552000}, {1820,58.2028000}, {1830,58.5000857}, {1840,59.9460000}, {1850,60.4406000}, {1860,61.6109429}, {1870,63.5610000}, {1880,64.4488571}, {1890,64.7040571}, {1900,66.6476000}, {1910,67.3956571}, {1920,69.2187143}, {1930,68.0360571}, {1940,69.5631143}, {1950,72.4967714}, {1960,71.7107714}, {1970,73.3501714}, {1980,74.7131429}, {1990,75.0689429}, {2000,75.2358571}};
data["big"]["LtacTacInTermGallinaCtx"]["norm reif"]["user"] = {{1,0.00041584}, {2,0.00080198}, {3,0.00146535}, {4,0.00143564}, {5,0.00208911}, {6,0.00238614}, {7,0.00301980}, {8,0.00309901}, {9,0.00348515}, {10,0.00382178}, {11,0.00417822}, {12,0.00475248}, {13,0.00459406}, {14,0.00559406}, {15,0.00591089}, {16,0.00652475}, {17,0.00720792}, {18,0.00738614}, {19,0.00811881}, {20,0.00850495}, {21,0.00924752}, {22,0.00936634}, {23,0.01012871}, {24,0.01074257}, {25,0.01139604}, {26,0.01325743}, {27,0.01224752}, {28,0.01320792}, {29,0.01366337}, {30,0.01400000}, {31,0.01495050}, {32,0.01573267}, {33,0.01599010}, {34,0.01686139}, {35,0.01757426}, {36,0.01834653}, {37,0.01919802}, {38,0.01982178}, {39,0.02126733}, {40,0.02164356}, {41,0.02764356}, {42,0.02372277}, {43,0.02416832}, {44,0.02543564}, {45,0.02967327}, {46,0.02719802}, {47,0.02784158}, {48,0.02854455}, {49,0.02955446}, {50,0.03038614}, {51,0.03115842}, {52,0.03203960}, {53,0.03843564}, {54,0.03375248}, {55,0.03476238}, {56,0.04545545}, {57,0.03651485}, {58,0.03797030}, {59,0.03864356}, {60,0.03933663}, {61,0.04034653}, {62,0.04119802}, {63,0.04267327}, {64,0.04382178}, {65,0.04496040}, {66,0.04633663}, {67,0.05553465}, {68,0.04868317}, {69,0.05042574}, {70,0.06390099}, {71,0.05215842}, {72,0.06053465}, {73,0.05396040}, {74,0.07099010}, {75,0.05651485}, {76,0.07044554}, {77,0.07882178}, {78,0.06062376}, {79,0.06128713}, {80,0.06263366}, {81,0.06624752}, {82,0.07285149}, {83,0.07763366}, {84,0.07182178}, {85,0.08527723}, {86,0.09687129}, {87,0.08927723}, {88,0.10220792}, {89,0.12803960}, {90,0.11004950}, {91,0.09892079}, {92,0.09934653}, {93,0.10594059}, {94,0.10385149}, {95,0.10592079}, {96,0.10892079}, {97,0.10948515}, {98,0.11191089}, {99,0.11500990}, {100,0.11806931}, {101,0.12080198}, {102,0.12147525}, {103,0.12304950}, {104,0.12602970}, {105,0.12812871}, {106,0.13223762}, {107,0.13288119}, {108,0.13563366}, {109,0.12896040}, {110,0.13053465}, {111,0.13318812}, {112,0.13369307}, {113,0.13732673}, {114,0.13886139}, {115,0.14046535}, {116,0.14249505}, {117,0.14580198}, {118,0.14803960}, {119,0.14914851}, {120,0.15215842}, {121,0.15466337}, {122,0.15462376}, {123,0.16012871}, {124,0.16226733}, {125,0.16400990}, {126,0.16592079}, {127,0.16834653}, {128,0.17058416}, {129,0.17268317}, {130,0.17729703}, {131,0.17775248}, {132,0.18144554}, {133,0.18313861}, {134,0.18492079}, {135,0.18735644}, {136,0.18919802}, {137,0.19238614}, {138,0.19335644}, {139,0.19851485}, {140,0.20030693}, {141,0.20181188}, {142,0.20653465}, {143,0.20685149}, {144,0.20849505}, {145,0.21255446}, {146,0.21552475}, {147,0.21712871}, {148,0.21962376}, {149,0.22192079}, {150,0.22643564}, {151,0.23019802}, {152,0.23105941}, {153,0.23469307}, {154,0.23865347}, {155,0.23914851}, {156,0.24193069}, {157,0.24648515}, {158,0.24774257}, {159,0.25270297}, {160,0.25112871}, {161,0.25481188}, {162,0.25735644}, {163,0.25988119}, {164,0.26316832}, {165,0.26694059}, {166,0.27202970}, {167,0.27283168}, {168,0.27886139}, {169,0.28179208}, {170,0.28084158}, {171,0.28381188}, {172,0.28910891}, {173,0.29214851}, {174,0.29525743}, {175,0.29810891}, {176,0.30063366}, {177,0.30391089}, {178,0.30719802}, {179,0.30947525}, {180,0.31027723}, {181,0.31360396}, {182,0.31716832}, {183,0.32086139}, {184,0.32383168}, {185,0.32643564}, {186,0.33002970}, {187,0.33227723}, {188,0.33548515}, {189,0.34000990}, {190,0.34322772}, {191,0.34682178}, {192,0.35052475}, {193,0.35611881}, {194,0.36513861}, {195,0.37096040}, {196,0.37094059}, {197,0.37176238}, {198,0.37189109}, {199,0.37741584}, {200,0.38137624}, {201,0.38585149}, {202,0.39798020}, {203,0.39927723}, {204,0.39182178}, {205,0.39607921}, {206,0.39640594}, {207,0.41121782}, {208,0.42117822}, {209,0.41514851}, {210,0.41399010}, {211,0.41598020}, {212,0.43235644}, {213,0.43041584}, {214,0.42540594}, {215,0.43276238}, {216,0.44848515}, {217,0.44391089}, {218,0.44340594}, {219,0.46041584}, {220,0.45539604}, {221,0.45674257}, {222,0.47400990}, {223,0.46853465}, {224,0.47414851}, {225,0.47799010}, {226,0.48041584}, {227,0.49452475}, {228,0.48524752}, {229,0.49815842}, {230,0.49490099}, {231,0.50510891}, {232,0.50801980}, {233,0.50948515}, {234,0.51510891}, {235,0.52149505}, {236,0.52131683}, {237,0.53339604}, {238,0.52879208}, {239,0.54546535}, {240,0.53776238}, {241,0.54911881}, {242,0.55094059}, {243,0.55514851}, {244,0.56313861}, {245,0.56678218}, {246,0.56418812}, {247,0.57585149}, {248,0.57213861}, {249,0.58229703}, {250,0.58975248}, {251,0.58393069}, {252,0.59299010}, {253,0.60499010}, {254,0.59802970}, {255,0.60642574}, {256,0.61961386}, {257,0.61333663}, {258,0.61721782}, {259,0.62393069}, {260,0.63028713}, {261,0.63881188}, {262,0.73103960}, {263,0.64827723}, {264,0.64973267}, {265,0.65127723}, {266,0.69840594}, {267,0.66459406}, {268,0.67102970}, {269,0.67272277}, {270,0.67666337}, {271,0.68275248}, {272,0.68631683}, {273,0.69641584}, {274,0.70504950}, {275,0.75318812}, {276,0.71384158}, {277,0.71896040}, {278,0.72437624}, {279,0.72909901}, {280,0.73198020}, {281,0.74103960}, {282,0.75250495}, {283,0.75408911}, {284,0.75667327}, {285,0.76350495}, {286,0.76535644}, {287,0.76954455}, {288,0.79286139}, {289,0.78221782}, {290,0.78335644}, {291,0.79003960}, {292,0.78594059}, {293,0.79002970}, {294,0.79540594}, {295,0.80497030}, {296,0.81329703}, {297,0.82815842}, {298,0.82902970}, {299,0.82667327}, {300,0.82457426}, {301,0.8698286}, {302,0.9850571}, {303,0.8885143}, {304,0.8951714}, {305,0.9064571}, {306,0.9023143}, {307,0.9100000}, {308,0.9271143}, {309,0.9172286}, {310,0.9196000}, {311,0.9387429}, {312,0.9435429}, {313,0.9478286}, {314,0.9549714}, {315,0.9591429}, {316,0.9642571}, {317,0.9677143}, {318,1.0326000}, {319,0.9810857}, {320,0.9868857}, {321,0.9953714}, {322,0.9989714}, {323,0.9984571}, {324,1.0061714}, {325,1.0117143}, {326,1.0174286}, {327,1.0304000}, {328,1.0292286}, {329,1.0429714}, {330,1.0408571}, {331,1.0529714}, {332,1.0503143}, {333,1.0563429}, {334,1.0665714}, {335,1.0694000}, {336,1.0827429}, {337,1.0802286}, {338,1.0936857}, {339,1.0922000}, {340,1.1068571}, {341,1.1084000}, {342,1.1254000}, {343,1.1318857}, {344,1.1464857}, {345,1.1454571}, {346,1.1537714}, {347,1.1542000}, {348,1.1632000}, {349,1.1696857}, {350,1.1831429}, {351,1.1924000}, {352,1.1884571}, {353,1.1950857}, {354,1.2038286}, {355,1.2120000}, {356,1.2144857}, {357,1.2273429}, {358,1.2255429}, {359,1.2331143}, {360,1.2363429}, {361,1.2524286}, {362,1.2530000}, {363,1.2923714}, {364,1.2705714}, {365,1.2752000}, {366,1.2728286}, {367,1.2974857}, {368,1.3246571}, {369,1.3000286}, {370,1.3142000}, {371,1.3227429}, {372,1.3277429}, {373,1.3324000}, {374,1.3514000}, {375,1.3568857}, {376,1.3590286}, {377,1.3671429}, {378,1.3672286}, {379,1.3735714}, {380,1.3928571}, {381,1.3956857}, {382,1.4027714}, {383,1.4163429}, {384,1.4263143}, {385,1.4300000}, {386,1.4468286}, {387,1.4845429}, {388,1.4563429}, {389,1.4772571}, {390,1.4749429}, {391,1.4881714}, {392,1.4888000}, {393,1.4951429}, {394,1.5024857}, {395,1.5124286}, {396,1.5252000}, {397,1.5362571}, {398,1.5392571}, {399,1.5485714}, {400,1.5597714}, {401,1.5717714}, {402,1.5810000}, {403,1.5992571}, {404,1.5948571}, {405,1.6121714}, {406,1.6202571}, {407,1.6300571}, {408,1.6533714}, {409,1.6622000}, {410,1.6742286}, {411,1.6433714}, {412,1.7006571}, {413,1.6640000}, {414,1.6738286}, {415,1.7081714}, {416,1.7412857}, {417,1.6897143}, {418,1.7220000}, {419,1.7575714}, {420,1.7796286}, {421,1.8113429}, {422,1.7241429}, {423,1.7329714}, {424,1.7406000}, {425,1.7566000}, {426,1.8014571}, {427,1.8865429}, {428,1.7969429}, {429,1.8346571}, {430,1.8126857}, {431,1.8562000}, {432,1.9088571}, {433,1.9221714}, {434,1.8861429}, {435,1.8876857}, {436,1.8644286}, {437,1.9016857}, {438,1.9196000}, {439,1.9424571}, {440,2.0130286}, {441,1.9475714}, {442,1.9943429}, {443,2.0026000}, {444,1.9752000}, {445,1.9557143}, {446,1.9603143}, {447,1.9768857}, {448,2.0140857}, {449,2.0043143}, {450,2.0159143}, {451,2.0005714}, {452,2.0132571}, {453,2.0285429}, {454,2.0473714}, {455,2.0532571}, {456,2.0631143}, {457,2.0742286}, {458,2.1200857}, {459,2.1168000}, {460,2.1290000}, {461,2.1542857}, {462,2.1688000}, {463,2.1249429}, {464,2.1548286}, {465,2.2210000}, {466,2.2338857}, {467,2.2490571}, {468,2.3366000}, {469,2.2432286}, {470,2.2285429}, {471,2.2786857}, {472,2.3027429}, {473,2.2600571}, {474,2.3028000}, {475,2.3040571}, {476,2.2947714}, {477,2.2577429}, {478,2.2932286}, {479,2.3097143}, {480,2.3178571}, {481,2.3236286}, {482,2.3660286}, {483,2.3651143}, {484,2.4247143}, {485,2.3636857}, {486,2.3892286}, {487,2.3766000}, {488,2.5406000}, {489,2.3869714}, {490,2.3951714}, {491,2.4997429}, {492,2.4048000}, {493,2.4346000}, {494,2.5066571}, {495,2.5564571}, {496,2.4934857}, {497,2.4965429}, {498,2.5429143}, {499,2.5376571}, {500,2.5538857}, {505,2.5989714}, {510,2.6949714}, {515,2.7646857}, {520,2.9423714}, {525,2.9790000}, {530,2.8818571}, {535,2.9477143}, {540,3.0184571}, {545,3.0799429}, {550,3.1505429}, {555,3.2231143}, {560,3.2208857}, {565,3.2544857}, {570,3.3225429}, {575,3.4067714}, {580,3.4658286}, {585,3.5040286}, {590,3.6052000}, {595,3.7235429}, {600,3.7646571}, {605,3.8814286}, {610,3.9068857}, {615,4.0260000}, {620,4.0808857}, {625,4.0932857}, {630,4.2054571}, {635,4.2300857}, {640,4.3110857}, {645,4.2739143}, {650,4.3778000}, {655,4.4996286}, {660,4.5556857}, {665,4.5755143}, {670,4.7228286}, {675,4.9839714}, {680,4.9700571}, {685,5.0254286}, {690,5.1884571}, {695,5.1882286}, {700,5.3243714}, {705,5.4277143}, {710,5.4632000}, {715,5.4312286}, {720,5.6063143}, {725,5.6310571}, {730,5.7836286}, {735,5.7759429}, {740,6.0139714}, {745,6.2048571}, {750,6.2800000}, {755,6.2687714}, {760,6.4364857}, {765,6.5549714}, {770,6.6282857}, {775,6.8691143}, {780,6.8761429}, {785,6.9451714}, {790,7.1113714}, {795,7.0812286}, {800,7.2159429}, {805,7.4875143}, {810,7.3864571}, {815,7.5965714}, {820,7.5806857}, {825,7.7546571}, {830,7.8044857}, {835,7.8343714}, {840,8.1079714}, {845,8.3204286}, {850,8.4513429}, {855,8.6757714}, {860,8.7039143}, {865,9.1486000}, {870,9.0748857}, {875,9.1633429}, {880,9.2464000}, {885,9.1921429}, {890,9.5999429}, {895,9.7045714}, {900,9.5495714}, {905,9.8784000}, {910,9.8647429}, {915,10.0284286}, {920,10.1248286}, {925,10.3145714}, {930,10.2596286}, {935,10.5446286}, {940,10.5391714}, {945,10.5908857}, {950,10.7594857}, {955,10.9988000}, {960,10.8799429}, {965,11.2402857}, {970,11.2390000}, {975,11.3088571}, {980,11.5169143}, {985,11.5952571}, {990,11.9839429}, {995,11.7859143}, {1000,11.9387429}, {1010,12.1595143}, {1020,12.6858000}, {1030,12.8516000}, {1040,13.3017143}, {1050,13.7318286}, {1060,14.1515143}, {1070,14.4508571}, {1080,14.6696857}, {1090,15.0287714}, {1100,15.2103429}, {1110,15.8469429}, {1120,15.9138000}, {1130,16.6544000}, {1140,16.9587714}, {1150,16.9023429}, {1160,17.5721143}, {1170,17.9766000}, {1180,18.5012286}, {1190,19.0910286}, {1200,19.1139714}, {1210,19.5041143}, {1220,20.3304286}, {1230,20.9962571}, {1240,21.4495714}, {1250,21.4802571}, {1260,22.2718571}, {1270,22.5406286}, {1280,23.0126857}, {1290,23.4704286}, {1300,23.7499714}, {1310,24.3985143}, {1320,24.8544857}, {1330,25.5980000}, {1340,25.7604286}, {1350,26.8516857}, {1360,27.2094571}, {1370,27.1226000}, {1380,28.0238857}, {1390,28.2098857}, {1400,29.3919714}, {1410,29.9603429}, {1420,30.5259714}, {1430,30.8963714}, {1440,31.1697429}, {1450,31.7657429}, {1460,32.3826857}, {1470,33.0217429}, {1480,34.7516857}, {1490,34.6072857}, {1500,34.6986000}, {1510,35.7571714}, {1520,36.5584857}, {1530,36.5423714}, {1540,37.4354000}, {1550,38.4321143}, {1560,38.8416000}, {1570,39.5986571}, {1580,39.8679714}, {1590,40.5910286}, {1600,40.6544571}, {1610,42.8548571}, {1620,42.2724286}, {1630,43.4644286}, {1640,44.1799143}, {1650,44.7798857}, {1660,45.7613429}, {1670,45.8475714}, {1680,47.6345143}, {1690,47.9568286}, {1700,49.0348571}, {1710,50.3277143}, {1720,51.2096857}, {1730,50.8942000}, {1740,51.9152857}, {1750,51.8324571}, {1760,52.5392857}, {1770,53.8152286}, {1780,54.5589143}, {1790,55.4784571}, {1800,56.1324286}, {1810,57.4843143}, {1820,58.1214286}, {1830,58.4100000}, {1840,59.8262571}, {1850,60.3333714}, {1860,61.4715429}, {1870,63.4490571}, {1880,64.3298571}, {1890,64.5964286}, {1900,66.5504286}, {1910,67.2996857}, {1920,69.1249429}, {1930,67.9485143}, {1940,69.4514571}, {1950,72.4182857}, {1960,71.3947429}, {1970,73.2743714}, {1980,74.6390286}, {1990,74.9940000}, {2000,75.1489714}};
data["big"]["LtacTacInTermGallinaCtx"]["norm reif"]["system"] = {{1,0.00003960}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00007921}, {8,0.00007921}, {9,0.00000000}, {10,0.00007921}, {11,0.00003960}, {12,0.00000000}, {13,0.00007921}, {14,0.00007921}, {15,0.00000000}, {16,0.00000000}, {17,0.00007921}, {18,0.00003960}, {19,0.00000000}, {20,0.00003960}, {21,0.00003960}, {22,0.00007921}, {23,0.00003960}, {24,0.00007921}, {25,0.00000000}, {26,0.00003960}, {27,0.00003960}, {28,0.00000000}, {29,0.00000000}, {30,0.00003960}, {31,0.00003960}, {32,0.00003960}, {33,0.00003960}, {34,0.00003960}, {35,0.00000000}, {36,0.00003960}, {37,0.00003960}, {38,0.00003960}, {39,0.00007921}, {40,0.00000000}, {41,0.00003960}, {42,0.00003960}, {43,0.00007921}, {44,0.00003960}, {45,0.00011881}, {46,0.00003960}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00003960}, {51,0.00000000}, {52,0.00000000}, {53,0.00015842}, {54,0.00003960}, {55,0.00003960}, {56,0.00000000}, {57,0.00007921}, {58,0.00003960}, {59,0.00000000}, {60,0.00000000}, {61,0.00003960}, {62,0.00000000}, {63,0.00007921}, {64,0.00000000}, {65,0.00003960}, {66,0.00003960}, {67,0.00000000}, {68,0.00000000}, {69,0.00003960}, {70,0.00000000}, {71,0.00000000}, {72,0.00007921}, {73,0.00003960}, {74,0.00007921}, {75,0.00000000}, {76,0.00000000}, {77,0.00007921}, {78,0.00003960}, {79,0.00007921}, {80,0.00000000}, {81,0.00000000}, {82,0.00011881}, {83,0.00003960}, {84,0.00000000}, {85,0.00003960}, {86,0.00007921}, {87,0.00007921}, {88,0.00007921}, {89,0.00015842}, {90,0.00011881}, {91,0.00003960}, {92,0.00000000}, {93,0.00000000}, {94,0.00003960}, {95,0.00000000}, {96,0.00000000}, {97,0.00003960}, {98,0.00003960}, {99,0.00003960}, {100,0.00007921}, {101,0.00010891}, {102,0.00015842}, {103,0.00003960}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00007921}, {108,0.00003960}, {109,0.00003960}, {110,0.00003960}, {111,0.00003960}, {112,0.00000000}, {113,0.00003960}, {114,0.00003960}, {115,0.00000000}, {116,0.00000000}, {117,0.00003960}, {118,0.00003960}, {119,0.00007921}, {120,0.00007921}, {121,0.00000000}, {122,0.00007921}, {123,0.00000000}, {124,0.00003960}, {125,0.00011881}, {126,0.00000000}, {127,0.00003960}, {128,0.00000000}, {129,0.00003960}, {130,0.00000000}, {131,0.00003960}, {132,0.00000000}, {133,0.00011881}, {134,0.00003960}, {135,0.00015842}, {136,0.00007921}, {137,0.00003960}, {138,0.00011881}, {139,0.00003960}, {140,0.00003960}, {141,0.00015842}, {142,0.00007921}, {143,0.00002970}, {144,0.00007921}, {145,0.00000000}, {146,0.00000000}, {147,0.00007921}, {148,0.00000000}, {149,0.00003960}, {150,0.00007921}, {151,0.00003960}, {152,0.00000000}, {153,0.00007921}, {154,0.00000000}, {155,0.00002970}, {156,0.00003960}, {157,0.00007921}, {158,0.00015842}, {159,0.00000000}, {160,0.00003960}, {161,0.00003960}, {162,0.00023762}, {163,0.00003960}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00003960}, {168,0.00000000}, {169,0.00015842}, {170,0.00003960}, {171,0.00007921}, {172,0.00011881}, {173,0.00010891}, {174,0.00007921}, {175,0.00003960}, {176,0.00003960}, {177,0.00007921}, {178,0.00007921}, {179,0.00000000}, {180,0.00000000}, {181,0.00003960}, {182,0.00014851}, {183,0.00003960}, {184,0.00003960}, {185,0.00011881}, {186,0.00003960}, {187,0.00015842}, {188,0.00000000}, {189,0.00003960}, {190,0.00006931}, {191,0.00003960}, {192,0.00003960}, {193,0.00003960}, {194,0.00000000}, {195,0.00003960}, {196,0.00000000}, {197,0.00003960}, {198,0.00007921}, {199,0.00003960}, {200,0.00003960}, {201,0.00007921}, {202,0.00000000}, {203,0.00003960}, {204,0.00003960}, {205,0.00002970}, {206,0.00003960}, {207,0.00007921}, {208,0.00007921}, {209,0.00000000}, {210,0.00010891}, {211,0.00003960}, {212,0.00011881}, {213,0.00007921}, {214,0.00007921}, {215,0.00003960}, {216,0.00000000}, {217,0.00000000}, {218,0.00011881}, {219,0.00007921}, {220,0.00003960}, {221,0.00011881}, {222,0.00000000}, {223,0.00003960}, {224,0.00003960}, {225,0.00003960}, {226,0.00003960}, {227,0.00003960}, {228,0.00011881}, {229,0.00007921}, {230,0.00000000}, {231,0.00003960}, {232,0.00003960}, {233,0.00007921}, {234,0.00000000}, {235,0.00007921}, {236,0.00003960}, {237,0.00007921}, {238,0.00003960}, {239,0.00011881}, {240,0.00002970}, {241,0.00007921}, {242,0.00011881}, {243,0.00003960}, {244,0.00011881}, {245,0.00007921}, {246,0.00023762}, {247,0.00019802}, {248,0.00015842}, {249,0.00015842}, {250,0.00003960}, {251,0.00019802}, {252,0.00010891}, {253,0.00000000}, {254,0.00010891}, {255,0.00011881}, {256,0.00007921}, {257,0.00079208}, {258,0.00003960}, {259,0.00015842}, {260,0.00003960}, {261,0.00000000}, {262,0.00043564}, {263,0.00007921}, {264,0.00015842}, {265,0.00023762}, {266,0.00079208}, {267,0.00026733}, {268,0.00006931}, {269,0.00007921}, {270,0.00034653}, {271,0.00015842}, {272,0.00007921}, {273,0.00070297}, {274,0.00000000}, {275,0.00007921}, {276,0.00011881}, {277,0.00007921}, {278,0.00027723}, {279,0.00019802}, {280,0.00039604}, {281,0.00015842}, {282,0.00000000}, {283,0.00003960}, {284,0.00003960}, {285,0.00011881}, {286,0.00003960}, {287,0.00015842}, {288,0.00000000}, {289,0.00011881}, {290,0.00003960}, {291,0.00007921}, {292,0.00003960}, {293,0.00027723}, {294,0.00007921}, {295,0.00019802}, {296,0.00015842}, {297,0.00011881}, {298,0.00027723}, {299,0.00053465}, {300,0.00014851}, {301,0.0002286}, {302,0.0006857}, {303,0.0002286}, {304,0.0005714}, {305,0.0001143}, {306,0.0003429}, {307,0.0003429}, {308,0.0000000}, {309,0.0001143}, {310,0.0002286}, {311,0.0004571}, {312,0.0001143}, {313,0.0000000}, {314,0.0000000}, {315,0.0002286}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0001143}, {320,0.0000000}, {321,0.0000000}, {322,0.0001143}, {323,0.0001143}, {324,0.0000000}, {325,0.0002286}, {326,0.0000000}, {327,0.0001143}, {328,0.0003429}, {329,0.0001143}, {330,0.0002286}, {331,0.0000000}, {332,0.0002286}, {333,0.0001143}, {334,0.0002286}, {335,0.0002286}, {336,0.0001143}, {337,0.0003429}, {338,0.0000000}, {339,0.0002286}, {340,0.0001143}, {341,0.0002286}, {342,0.0000000}, {343,0.0001143}, {344,0.0002286}, {345,0.0000000}, {346,0.0003429}, {347,0.0002286}, {348,0.0001143}, {349,0.0003429}, {350,0.0002286}, {351,0.0002286}, {352,0.0002286}, {353,0.0000000}, {354,0.0001143}, {355,0.0000000}, {356,0.0000000}, {357,0.0001143}, {358,0.0001143}, {359,0.0001143}, {360,0.0001143}, {361,0.0000000}, {362,0.0001143}, {363,0.0000000}, {364,0.0002286}, {365,0.0002286}, {366,0.0003429}, {367,0.0001143}, {368,0.0000000}, {369,0.0001143}, {370,0.0003429}, {371,0.0001143}, {372,0.0000000}, {373,0.0001143}, {374,0.0002286}, {375,0.0001143}, {376,0.0002286}, {377,0.0004571}, {378,0.0001143}, {379,0.0003429}, {380,0.0005429}, {381,0.0002286}, {382,0.0001143}, {383,0.0003429}, {384,0.0002286}, {385,0.0003429}, {386,0.0005714}, {387,0.0005714}, {388,0.0004571}, {389,0.0003429}, {390,0.0005714}, {391,0.0003429}, {392,0.0004286}, {393,0.0003429}, {394,0.0002286}, {395,0.0003429}, {396,0.0003429}, {397,0.0004571}, {398,0.0003429}, {399,0.0001143}, {400,0.0003429}, {401,0.0002286}, {402,0.0002286}, {403,0.0004571}, {404,0.0003429}, {405,0.0001143}, {406,0.0002286}, {407,0.0002286}, {408,0.0002286}, {409,0.0002286}, {410,0.0005143}, {411,0.0005714}, {412,0.0003429}, {413,0.0005714}, {414,0.0003429}, {415,0.0001143}, {416,0.0002286}, {417,0.0002286}, {418,0.0000000}, {419,0.0003429}, {420,0.0003429}, {421,0.0002286}, {422,0.0004571}, {423,0.0003429}, {424,0.0006857}, {425,0.0002286}, {426,0.0004571}, {427,0.0011429}, {428,0.0003429}, {429,0.0006857}, {430,0.0002286}, {431,0.0006857}, {432,0.0004571}, {433,0.0002286}, {434,0.0003429}, {435,0.0002286}, {436,0.0002286}, {437,0.0002286}, {438,0.0003429}, {439,0.0006857}, {440,0.0003429}, {441,0.0006857}, {442,0.0005714}, {443,0.0004571}, {444,0.0002286}, {445,0.0005429}, {446,0.0003429}, {447,0.0001143}, {448,0.0012571}, {449,0.0000857}, {450,0.0002286}, {451,0.0001143}, {452,0.0001143}, {453,0.0002286}, {454,0.0004571}, {455,0.0000000}, {456,0.0003429}, {457,0.0003143}, {458,0.0008857}, {459,0.0003429}, {460,0.0003429}, {461,0.0002286}, {462,0.0003429}, {463,0.0008000}, {464,0.0004571}, {465,0.0010286}, {466,0.0006857}, {467,0.0005714}, {468,0.0008000}, {469,0.0005714}, {470,0.0001143}, {471,0.0002286}, {472,0.0005714}, {473,0.0006857}, {474,0.0005714}, {475,0.0003429}, {476,0.0005714}, {477,0.0001143}, {478,0.0003429}, {479,0.0001143}, {480,0.0010286}, {481,0.0004571}, {482,0.0002286}, {483,0.0010286}, {484,0.0011429}, {485,0.0003429}, {486,0.0003429}, {487,0.0004571}, {488,0.0021714}, {489,0.0001143}, {490,0.0008000}, {491,0.0004571}, {492,0.0001143}, {493,0.0002286}, {494,0.0012571}, {495,0.0010286}, {496,0.0003429}, {497,0.0004571}, {498,0.0008571}, {499,0.0006857}, {500,0.0003429}, {505,0.0006857}, {510,0.0004571}, {515,0.0013714}, {520,0.0010286}, {525,0.0008000}, {530,0.0003429}, {535,0.0012286}, {540,0.0009143}, {545,0.0004571}, {550,0.0004571}, {555,0.0010000}, {560,0.0005429}, {565,0.0010286}, {570,0.0008000}, {575,0.0008000}, {580,0.0012571}, {585,0.0009143}, {590,0.0009143}, {595,0.0022857}, {600,0.0006857}, {605,0.0006857}, {610,0.0022857}, {615,0.0013714}, {620,0.0014857}, {625,0.0026286}, {630,0.0032000}, {635,0.0018000}, {640,0.0020571}, {645,0.0021714}, {650,0.0025143}, {655,0.0029714}, {660,0.0014857}, {665,0.0016000}, {670,0.0026286}, {675,0.0021714}, {680,0.0025143}, {685,0.0032857}, {690,0.0016000}, {695,0.0030571}, {700,0.0019429}, {705,0.0017143}, {710,0.0022857}, {715,0.0024857}, {720,0.0026286}, {725,0.0008000}, {730,0.0024000}, {735,0.0017143}, {740,0.0030857}, {745,0.0030857}, {750,0.0014857}, {755,0.0022571}, {760,0.0018000}, {765,0.0020571}, {770,0.0025143}, {775,0.0045429}, {780,0.0043429}, {785,0.0034286}, {790,0.0031714}, {795,0.0037429}, {800,0.0026286}, {805,0.0027143}, {810,0.0030857}, {815,0.0038857}, {820,0.0050286}, {825,0.0026286}, {830,0.0027714}, {835,0.0043143}, {840,0.0033143}, {845,0.0054286}, {850,0.0068571}, {855,0.0044571}, {860,0.0065143}, {865,0.0042286}, {870,0.0045429}, {875,0.0043714}, {880,0.0078286}, {885,0.0056571}, {890,0.0041143}, {895,0.0062000}, {900,0.0071714}, {905,0.0087429}, {910,0.0074000}, {915,0.0058286}, {920,0.0069714}, {925,0.0102857}, {930,0.0074857}, {935,0.0096000}, {940,0.0073429}, {945,0.0072857}, {950,0.0078857}, {955,0.0072000}, {960,0.0057143}, {965,0.0103429}, {970,0.0086571}, {975,0.0098571}, {980,0.0065143}, {985,0.0092571}, {990,0.0112286}, {995,0.0061429}, {1000,0.0067143}, {1010,0.0054286}, {1020,0.0072000}, {1030,0.0096571}, {1040,0.0057714}, {1050,0.0052571}, {1060,0.0081714}, {1070,0.0136857}, {1080,0.0088857}, {1090,0.0079429}, {1100,0.0089429}, {1110,0.0126286}, {1120,0.0092286}, {1130,0.0109429}, {1140,0.0088571}, {1150,0.0086000}, {1160,0.0128571}, {1170,0.0142286}, {1180,0.0148571}, {1190,0.0146571}, {1200,0.0186857}, {1210,0.0197714}, {1220,0.0143143}, {1230,0.0113714}, {1240,0.0162000}, {1250,0.0166286}, {1260,0.0207714}, {1270,0.0211429}, {1280,0.0249429}, {1290,0.0144571}, {1300,0.0239429}, {1310,0.0169143}, {1320,0.0203429}, {1330,0.0204571}, {1340,0.0162000}, {1350,0.0178857}, {1360,0.0201429}, {1370,0.0226857}, {1380,0.0258000}, {1390,0.0190000}, {1400,0.0166857}, {1410,0.0235714}, {1420,0.0148571}, {1430,0.0240286}, {1440,0.0249429}, {1450,0.0186571}, {1460,0.0133429}, {1470,0.0255714}, {1480,0.0268571}, {1490,0.0210571}, {1500,0.0222571}, {1510,0.0219143}, {1520,0.0300000}, {1530,0.0323714}, {1540,0.0266571}, {1550,0.0213429}, {1560,0.0241714}, {1570,0.0276000}, {1580,0.0226857}, {1590,0.0314571}, {1600,0.0351143}, {1610,0.0274857}, {1620,0.0291714}, {1630,0.0332571}, {1640,0.0327143}, {1650,0.0352286}, {1660,0.0296286}, {1670,0.0329714}, {1680,0.0347714}, {1690,0.0373143}, {1700,0.0399429}, {1710,0.0410000}, {1720,0.0406286}, {1730,0.0358000}, {1740,0.0442000}, {1750,0.0412000}, {1760,0.0363143}, {1770,0.0410286}, {1780,0.0465714}, {1790,0.0480857}, {1800,0.0415143}, {1810,0.0433143}, {1820,0.0539143}, {1830,0.0416571}, {1840,0.0491429}, {1850,0.0522286}, {1860,0.0558571}, {1870,0.0547714}, {1880,0.0614571}, {1890,0.0476857}, {1900,0.0577714}, {1910,0.0653429}, {1920,0.0584571}, {1930,0.0441714}, {1940,0.0590857}, {1950,0.0628286}, {1960,0.0548000}, {1970,0.0580571}, {1980,0.0570000}, {1990,0.0494857}, {2000,0.0521714}};
data["big"]["LtacTacInTermGallinaCtx"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermGallinaCtx"]["post"]["user"] = {{1,0.00000000}, {2,0.00003960}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00006931}, {8,0.00002970}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00006931}, {13,0.00000000}, {14,0.00007921}, {15,0.00002970}, {16,0.00007921}, {17,0.00002970}, {18,0.00007921}, {19,0.00000000}, {20,0.00003960}, {21,0.00003960}, {22,0.00000000}, {23,0.00000000}, {24,0.00007921}, {25,0.00000000}, {26,0.00000000}, {27,0.00007921}, {28,0.00000000}, {29,0.00000000}, {30,0.00005941}, {31,0.00000000}, {32,0.00007921}, {33,0.00002970}, {34,0.00002970}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00003960}, {40,0.00007921}, {41,0.00003960}, {42,0.00000000}, {43,0.00003960}, {44,0.00007921}, {45,0.00007921}, {46,0.00002970}, {47,0.00003960}, {48,0.00000000}, {49,0.00007921}, {50,0.00007921}, {51,0.00006931}, {52,0.00003960}, {53,0.00003960}, {54,0.00002970}, {55,0.00000000}, {56,0.00007921}, {57,0.00003960}, {58,0.00003960}, {59,0.00010891}, {60,0.00000000}, {61,0.00000000}, {62,0.00003960}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00007921}, {68,0.00007921}, {69,0.00000000}, {70,0.00003960}, {71,0.00000000}, {72,0.00007921}, {73,0.00000000}, {74,0.00000000}, {75,0.00003960}, {76,0.00003960}, {77,0.00000000}, {78,0.00005941}, {79,0.00000000}, {80,0.00011881}, {81,0.00003960}, {82,0.00007921}, {83,0.00002970}, {84,0.00000000}, {85,0.00003960}, {86,0.00000000}, {87,0.00013861}, {88,0.00000000}, {89,0.00007921}, {90,0.00007921}, {91,0.00002970}, {92,0.00007921}, {93,0.00000000}, {94,0.00011881}, {95,0.00000000}, {96,0.00003960}, {97,0.00003960}, {98,0.00000000}, {99,0.00007921}, {100,0.00003960}, {101,0.00003960}, {102,0.00003960}, {103,0.00000000}, {104,0.00007921}, {105,0.00000000}, {106,0.00000000}, {107,0.00003960}, {108,0.00003960}, {109,0.00003960}, {110,0.00000000}, {111,0.00003960}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00007921}, {116,0.00003960}, {117,0.00003960}, {118,0.00007921}, {119,0.00000000}, {120,0.00007921}, {121,0.00003960}, {122,0.00000000}, {123,0.00005941}, {124,0.00000000}, {125,0.00002970}, {126,0.00000000}, {127,0.00007921}, {128,0.00003960}, {129,0.00003960}, {130,0.00003960}, {131,0.00007921}, {132,0.00003960}, {133,0.00000000}, {134,0.00010891}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00011881}, {141,0.00000000}, {142,0.00003960}, {143,0.00003960}, {144,0.00000000}, {145,0.00003960}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00003960}, {151,0.00003960}, {152,0.00003960}, {153,0.00003960}, {154,0.00000000}, {155,0.00000000}, {156,0.00003960}, {157,0.00000000}, {158,0.00003960}, {159,0.00003960}, {160,0.00000000}, {161,0.00002970}, {162,0.00000000}, {163,0.00003960}, {164,0.00007921}, {165,0.00000000}, {166,0.00003960}, {167,0.00000000}, {168,0.00007921}, {169,0.00007921}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00006931}, {174,0.00003960}, {175,0.00000000}, {176,0.00003960}, {177,0.00000000}, {178,0.00007921}, {179,0.00000000}, {180,0.00003960}, {181,0.00000000}, {182,0.00000000}, {183,0.00003960}, {184,0.00003960}, {185,0.00007921}, {186,0.00002970}, {187,0.00007921}, {188,0.00000000}, {189,0.00003960}, {190,0.00011881}, {191,0.00003960}, {192,0.00000000}, {193,0.00003960}, {194,0.00003960}, {195,0.00006931}, {196,0.00002970}, {197,0.00003960}, {198,0.00003960}, {199,0.00000000}, {200,0.00007921}, {201,0.00000000}, {202,0.00000000}, {203,0.00003960}, {204,0.00003960}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00003960}, {211,0.00000000}, {212,0.00003960}, {213,0.00014851}, {214,0.00000000}, {215,0.00000000}, {216,0.00003960}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00003960}, {221,0.00010891}, {222,0.00000000}, {223,0.00000000}, {224,0.00003960}, {225,0.00003960}, {226,0.00000000}, {227,0.00003960}, {228,0.00002970}, {229,0.00000000}, {230,0.00007921}, {231,0.00000000}, {232,0.00007921}, {233,0.00000000}, {234,0.00000000}, {235,0.00003960}, {236,0.00000000}, {237,0.00010891}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00003960}, {244,0.00000000}, {245,0.00002970}, {246,0.00000000}, {247,0.00011881}, {248,0.00000000}, {249,0.00000000}, {250,0.00007921}, {251,0.00007921}, {252,0.00000000}, {253,0.00006931}, {254,0.00000000}, {255,0.00007921}, {256,0.00000000}, {257,0.00003960}, {258,0.00014851}, {259,0.00000000}, {260,0.00002970}, {261,0.00003960}, {262,0.00000000}, {263,0.00003960}, {264,0.00002970}, {265,0.00000000}, {266,0.00000000}, {267,0.00002970}, {268,0.00010891}, {269,0.00007921}, {270,0.00006931}, {271,0.00003960}, {272,0.00003960}, {273,0.00002970}, {274,0.00003960}, {275,0.00000000}, {276,0.00002970}, {277,0.00000000}, {278,0.00002970}, {279,0.00000000}, {280,0.00000000}, {281,0.00002970}, {282,0.00005941}, {283,0.00003960}, {284,0.00000000}, {285,0.00003960}, {286,0.00003960}, {287,0.00000000}, {288,0.00006931}, {289,0.00002970}, {290,0.00000000}, {291,0.00002970}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00006931}, {296,0.00007921}, {297,0.00003960}, {298,0.00002970}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0001143}, {307,0.0000857}, {308,0.0000857}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000857}, {315,0.0000000}, {316,0.0000857}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000857}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000857}, {330,0.0000000}, {331,0.0000857}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000857}, {338,0.0000857}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000857}, {350,0.0000000}, {351,0.0000857}, {352,0.0000000}, {353,0.0001714}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000857}, {358,0.0000857}, {359,0.0000000}, {360,0.0000000}, {361,0.0000857}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000857}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000857}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000857}, {383,0.0000857}, {384,0.0000000}, {385,0.0001143}, {386,0.0000857}, {387,0.0000857}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000857}, {393,0.0000857}, {394,0.0000857}, {395,0.0000000}, {396,0.0002286}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000857}, {401,0.0000000}, {402,0.0001143}, {403,0.0000000}, {404,0.0000000}, {405,0.0002000}, {406,0.0000857}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000857}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000857}, {420,0.0001143}, {421,0.0000000}, {422,0.0001143}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0001714}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000857}, {431,0.0000000}, {432,0.0001143}, {433,0.0000857}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000857}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000857}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000857}, {448,0.0002000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000857}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0001143}, {459,0.0000000}, {460,0.0000000}, {461,0.0001714}, {462,0.0000857}, {463,0.0002000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000857}, {467,0.0000857}, {468,0.0000000}, {469,0.0000000}, {470,0.0001143}, {471,0.0001143}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000857}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000857}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000857}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000857}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000857}, {560,0.0000000}, {565,0.0000857}, {570,0.0000000}, {575,0.0001714}, {580,0.0000000}, {585,0.0000857}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000857}, {610,0.0000000}, {615,0.0000000}, {620,0.0000857}, {625,0.0000000}, {630,0.0000857}, {635,0.0000857}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000857}, {670,0.0000000}, {675,0.0000000}, {680,0.0001143}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000857}, {740,0.0000857}, {745,0.0000000}, {750,0.0000000}, {755,0.0000857}, {760,0.0000000}, {765,0.0000857}, {770,0.0000857}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000857}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000857}, {825,0.0000857}, {830,0.0000857}, {835,0.0000857}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000857}, {885,0.0000857}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0001714}, {910,0.0000000}, {915,0.0000000}, {920,0.0000857}, {925,0.0000857}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000857}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000857}, {975,0.0000000}, {980,0.0000000}, {985,0.0000857}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0001143}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000857}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000857}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000857}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0002286}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0001143}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000857}, {1360,0.0000857}, {1370,0.0000857}, {1380,0.0002286}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0001143}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000857}, {1480,0.0002286}, {1490,0.0000000}, {1500,0.0000857}, {1510,0.0000857}, {1520,0.0000000}, {1530,0.0000857}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000857}, {1580,0.0001143}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0002286}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0001143}, {1680,0.0000000}, {1690,0.0000857}, {1700,0.0000000}, {1710,0.0002286}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0001143}, {1750,0.0001143}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000857}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000857}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0001143}, {2000,0.0000000}};
data["big"]["LtacTacInTermGallinaCtx"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00003960}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00003960}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00003960}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0001143}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0001143}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermGallinaCtx"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermGallinaCtx"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00002970}, {16,0.00003960}, {17,0.00000000}, {18,0.00003960}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00003960}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00003960}, {33,0.00003960}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00003960}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00003960}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00003960}, {59,0.00003960}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00003960}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00006931}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003960}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00003960}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00003960}, {133,0.00000000}, {134,0.00000000}, {135,0.00002970}, {136,0.00000000}, {137,0.00003960}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00003960}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00003960}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00006931}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00003960}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00003960}, {165,0.00003960}, {166,0.00003960}, {167,0.00003960}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00003960}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00002970}, {184,0.00000000}, {185,0.00003960}, {186,0.00003960}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00003960}, {203,0.00000000}, {204,0.00000000}, {205,0.00003960}, {206,0.00000000}, {207,0.00000000}, {208,0.00011881}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00002970}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00003960}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00003960}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00003960}, {235,0.00000000}, {236,0.00007921}, {237,0.00000000}, {238,0.00000000}, {239,0.00003960}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00003960}, {277,0.00000000}, {278,0.00000000}, {279,0.00002970}, {280,0.00000000}, {281,0.00000000}, {282,0.00003960}, {283,0.00003960}, {284,0.00000000}, {285,0.00002970}, {286,0.00000000}, {287,0.00003960}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0001143}, {329,0.0000857}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000857}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000857}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0001143}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000857}, {409,0.0000000}, {410,0.0000000}, {411,0.0000857}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0001143}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0001143}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000857}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0001143}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0001143}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0001143}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0001143}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0002286}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermGallinaCtx"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermGallinaCtx"]["reif"]["real"] = {{1,0.00000000}, {2,0.00100000}, {3,0.00100000}, {4,0.00100000}, {5,0.00200000}, {6,0.00200000}, {7,0.00232673}, {8,0.00300000}, {9,0.00300000}, {10,0.00396040}, {11,0.00401980}, {12,0.00439604}, {13,0.00501980}, {14,0.00546535}, {15,0.00600990}, {16,0.00645545}, {17,0.00704950}, {18,0.00734653}, {19,0.00811881}, {20,0.00852475}, {21,0.00935644}, {22,0.00964356}, {23,0.01024752}, {24,0.01100990}, {25,0.01144554}, {26,0.01360396}, {27,0.01260396}, {28,0.01337624}, {29,0.01416832}, {30,0.01434653}, {31,0.01522772}, {32,0.01607921}, {33,0.01670297}, {34,0.01736634}, {35,0.01828713}, {36,0.01868317}, {37,0.01960396}, {38,0.02036634}, {39,0.02113861}, {40,0.02184158}, {41,0.02781188}, {42,0.02357426}, {43,0.02426733}, {44,0.02501980}, {45,0.02981188}, {46,0.02682178}, {47,0.02764356}, {48,0.02834653}, {49,0.02959406}, {50,0.03035644}, {51,0.03134653}, {52,0.03198020}, {53,0.03889109}, {54,0.03384158}, {55,0.03484158}, {56,0.04595050}, {57,0.03706931}, {58,0.03828713}, {59,0.03904950}, {60,0.04003960}, {61,0.04103960}, {62,0.04184158}, {63,0.04334653}, {64,0.04438614}, {65,0.04551485}, {66,0.04635644}, {67,0.05578218}, {68,0.04861386}, {69,0.05017822}, {70,0.06407921}, {71,0.05201980}, {72,0.06128713}, {73,0.05444554}, {74,0.07181188}, {75,0.05696040}, {76,0.07066337}, {77,0.07923762}, {78,0.06094059}, {79,0.06183168}, {80,0.06327723}, {81,0.06666337}, {82,0.07303960}, {83,0.07728713}, {84,0.07190099}, {85,0.08581188}, {86,0.09726733}, {87,0.09005941}, {88,0.10287129}, {89,0.12886139}, {90,0.11037624}, {91,0.09925743}, {92,0.09973267}, {93,0.10595050}, {94,0.10419802}, {95,0.10620792}, {96,0.10923762}, {97,0.10959406}, {98,0.11219802}, {99,0.11573267}, {100,0.11851485}, {101,0.12125743}, {102,0.12161386}, {103,0.12340594}, {104,0.12641584}, {105,0.12865347}, {106,0.13286139}, {107,0.13352475}, {108,0.13596040}, {109,0.12955446}, {110,0.13133663}, {111,0.13379208}, {112,0.13408911}, {113,0.13769307}, {114,0.13922772}, {115,0.14122772}, {116,0.14299010}, {117,0.14634653}, {118,0.14843564}, {119,0.14964356}, {120,0.15254455}, {121,0.15536634}, {122,0.15514851}, {123,0.16063366}, {124,0.16313861}, {125,0.16452475}, {126,0.16662376}, {127,0.16864356}, {128,0.17120792}, {129,0.17330693}, {130,0.17745545}, {131,0.17815842}, {132,0.18225743}, {133,0.18351485}, {134,0.18556436}, {135,0.18820792}, {136,0.18990099}, {137,0.19280198}, {138,0.19400990}, {139,0.19888119}, {140,0.20092079}, {141,0.20257426}, {142,0.20721782}, {143,0.20723762}, {144,0.20930693}, {145,0.21363366}, {146,0.21597030}, {147,0.21782178}, {148,0.22033663}, {149,0.22277228}, {150,0.22714851}, {151,0.23077228}, {152,0.23175248}, {153,0.23539604}, {154,0.23911881}, {155,0.23987129}, {156,0.24275248}, {157,0.24725743}, {158,0.24891089}, {159,0.25357426}, {160,0.25195050}, {161,0.25502970}, {162,0.25877228}, {163,0.26087129}, {164,0.26401980}, {165,0.26786139}, {166,0.27266337}, {167,0.27372277}, {168,0.27974257}, {169,0.28259406}, {170,0.28211881}, {171,0.28473267}, {172,0.28995050}, {173,0.29335644}, {174,0.29625743}, {175,0.29883168}, {176,0.30176238}, {177,0.30496040}, {178,0.30793069}, {179,0.31026733}, {180,0.31126733}, {181,0.31471287}, {182,0.31821782}, {183,0.32176238}, {184,0.32502970}, {185,0.32778218}, {186,0.33113861}, {187,0.33319802}, {188,0.33613861}, {189,0.34099010}, {190,0.34421782}, {191,0.34792079}, {192,0.35140594}, {193,0.35703960}, {194,0.36647525}, {195,0.37198020}, {196,0.37212871}, {197,0.37244554}, {198,0.37318812}, {199,0.37865347}, {200,0.38243564}, {201,0.38685149}, {202,0.39927723}, {203,0.40033663}, {204,0.39333663}, {205,0.39740594}, {206,0.39748515}, {207,0.41267327}, {208,0.42242574}, {209,0.41632673}, {210,0.41532673}, {211,0.41736634}, {212,0.43377228}, {213,0.43155446}, {214,0.42639604}, {215,0.43380198}, {216,0.44964356}, {217,0.44505941}, {218,0.44459406}, {219,0.46158416}, {220,0.45655446}, {221,0.45762376}, {222,0.47509901}, {223,0.46930693}, {224,0.47511881}, {225,0.47894059}, {226,0.48135644}, {227,0.49575248}, {228,0.48647525}, {229,0.49911881}, {230,0.49633663}, {231,0.50639604}, {232,0.50940594}, {233,0.51088119}, {234,0.51619802}, {235,0.52293069}, {236,0.52277228}, {237,0.53465347}, {238,0.52972277}, {239,0.54652475}, {240,0.53885149}, {241,0.55023762}, {242,0.55244554}, {243,0.55661386}, {244,0.56453465}, {245,0.56834653}, {246,0.56583168}, {247,0.57743564}, {248,0.57355446}, {249,0.58386139}, {250,0.59115842}, {251,0.58591089}, {252,0.59487129}, {253,0.60645545}, {254,0.59945545}, {255,0.60834653}, {256,0.62136634}, {257,0.61552475}, {258,0.61885149}, {259,0.62539604}, {260,0.63186139}, {261,0.64016832}, {262,0.73278218}, {263,0.64983168}, {264,0.65362376}, {265,0.65314851}, {266,0.70109901}, {267,0.66638614}, {268,0.67255446}, {269,0.67435644}, {270,0.67843564}, {271,0.68441584}, {272,0.68779208}, {273,0.69858416}, {274,0.70652475}, {275,0.75476238}, {276,0.71523762}, {277,0.72021782}, {278,0.72651485}, {279,0.73095050}, {280,0.73400990}, {281,0.74270297}, {282,0.75421782}, {283,0.75573267}, {284,0.75786139}, {285,0.76544554}, {286,0.76719802}, {287,0.77167327}, {288,0.79454455}, {289,0.78394059}, {290,0.78510891}, {291,0.79209901}, {292,0.78803960}, {293,0.79206931}, {294,0.79722772}, {295,0.80734653}, {296,0.81525743}, {297,0.83014851}, {298,0.83137624}, {299,0.82895050}, {300,0.82664356}, {301,0.8714000}, {302,0.9872286}, {303,0.8896571}, {304,0.8974571}, {305,0.9084571}, {306,0.9042000}, {307,0.9116571}, {308,0.9288571}, {309,0.9189143}, {310,0.9218000}, {311,0.9405714}, {312,0.9446000}, {313,0.9494000}, {314,0.9563429}, {315,0.9607429}, {316,0.9654571}, {317,0.9689143}, {318,1.0341143}, {319,0.9848857}, {320,0.9886571}, {321,0.9962286}, {322,0.9999143}, {323,0.9999143}, {324,1.0081429}, {325,1.0130571}, {326,1.0190000}, {327,1.0326857}, {328,1.0308286}, {329,1.0465429}, {330,1.0454000}, {331,1.0618857}, {332,1.0606000}, {333,1.0620571}, {334,1.0701143}, {335,1.0723714}, {336,1.0845143}, {337,1.0819429}, {338,1.0946000}, {339,1.0939429}, {340,1.1088286}, {341,1.1105714}, {342,1.1272286}, {343,1.1334857}, {344,1.1484286}, {345,1.1470000}, {346,1.1558857}, {347,1.1553714}, {348,1.1645429}, {349,1.1720000}, {350,1.1854571}, {351,1.1938857}, {352,1.1900857}, {353,1.1964286}, {354,1.2051143}, {355,1.2137429}, {356,1.2153714}, {357,1.2291143}, {358,1.2277429}, {359,1.2346571}, {360,1.2384000}, {361,1.2546571}, {362,1.2548000}, {363,1.2940857}, {364,1.2731429}, {365,1.2770286}, {366,1.2757429}, {367,1.2995143}, {368,1.3265429}, {369,1.3017143}, {370,1.3164286}, {371,1.3252857}, {372,1.3300571}, {373,1.3342286}, {374,1.3526857}, {375,1.3589429}, {376,1.3612000}, {377,1.3700857}, {378,1.3702571}, {379,1.3763143}, {380,1.3961429}, {381,1.3983714}, {382,1.4055143}, {383,1.4202000}, {384,1.4290286}, {385,1.4331429}, {386,1.4493143}, {387,1.4890286}, {388,1.4593429}, {389,1.4799714}, {390,1.4787429}, {391,1.4906000}, {392,1.4916286}, {393,1.4972286}, {394,1.5046857}, {395,1.5144857}, {396,1.5277429}, {397,1.5392571}, {398,1.5418286}, {399,1.5516000}, {400,1.5634000}, {401,1.5743429}, {402,1.5840286}, {403,1.6032000}, {404,1.6056571}, {405,1.6174857}, {406,1.6290286}, {407,1.6343714}, {408,1.6614571}, {409,1.6672286}, {410,1.6781143}, {411,1.6477429}, {412,1.7042857}, {413,1.6675143}, {414,1.6775143}, {415,1.7117429}, {416,1.7448286}, {417,1.6932286}, {418,1.7252286}, {419,1.7608286}, {420,1.7830571}, {421,1.8138000}, {422,1.7270000}, {423,1.7357429}, {424,1.7441714}, {425,1.7602571}, {426,1.8055714}, {427,1.8907429}, {428,1.8003143}, {429,1.8395714}, {430,1.8174857}, {431,1.8606571}, {432,1.9136286}, {433,1.9260571}, {434,1.8896000}, {435,1.8916857}, {436,1.8692000}, {437,1.9055429}, {438,1.9245714}, {439,1.9469429}, {440,2.0180000}, {441,1.9527429}, {442,1.9994286}, {443,2.0072000}, {444,1.9794286}, {445,1.9601143}, {446,1.9651143}, {447,1.9814000}, {448,2.0200286}, {449,2.0092857}, {450,2.0199143}, {451,2.0044857}, {452,2.0166857}, {453,2.0329429}, {454,2.0519143}, {455,2.0571714}, {456,2.0675714}, {457,2.0787429}, {458,2.1244000}, {459,2.1206000}, {460,2.1328857}, {461,2.1582286}, {462,2.1724286}, {463,2.1291429}, {464,2.1583714}, {465,2.2255143}, {466,2.2378857}, {467,2.2522000}, {468,2.3406000}, {469,2.2472571}, {470,2.2329714}, {471,2.2833714}, {472,2.3072571}, {473,2.2650286}, {474,2.3080571}, {475,2.3086286}, {476,2.3000286}, {477,2.2618857}, {478,2.2982000}, {479,2.3152286}, {480,2.3244857}, {481,2.3287143}, {482,2.3720286}, {483,2.3727429}, {484,2.4322000}, {485,2.3697714}, {486,2.3955714}, {487,2.3832571}, {488,2.5484000}, {489,2.3925714}, {490,2.4017143}, {491,2.5049429}, {492,2.4102571}, {493,2.4408571}, {494,2.5144286}, {495,2.5630571}, {496,2.4994857}, {497,2.5023143}, {498,2.5494571}, {499,2.5431714}, {500,2.5597429}, {505,2.6050286}, {510,2.7014286}, {515,2.7724286}, {520,2.9512857}, {525,2.9873429}, {530,2.8904286}, {535,2.9566571}, {540,3.0283714}, {545,3.0892571}, {550,3.1606571}, {555,3.2334857}, {560,3.2304857}, {565,3.2636286}, {570,3.3314286}, {575,3.4163429}, {580,3.4761714}, {585,3.5135143}, {590,3.6145429}, {595,3.7343429}, {600,3.7738857}, {605,3.8902857}, {610,3.9169143}, {615,4.0350286}, {620,4.0899429}, {625,4.1048000}, {630,4.2180571}, {635,4.2407143}, {640,4.3204857}, {645,4.2820571}, {650,4.3850571}, {655,4.5071429}, {660,4.5622286}, {665,4.5837143}, {670,4.7311429}, {675,4.9917714}, {680,4.9794000}, {685,5.0365714}, {690,5.1973429}, {695,5.1982857}, {700,5.3342571}, {705,5.4352000}, {710,5.4712571}, {715,5.4428571}, {720,5.6168571}, {725,5.6425714}, {730,5.7960286}, {735,5.7840000}, {740,6.0254000}, {745,6.2146286}, {750,6.2882857}, {755,6.2774571}, {760,6.4439143}, {765,6.5647143}, {770,6.6396571}, {775,6.8836571}, {780,6.8881429}, {785,6.9564857}, {790,7.1362857}, {795,7.0921143}, {800,7.2443143}, {805,7.5243143}, {810,7.4013429}, {815,7.6151429}, {820,7.5971714}, {825,7.7727143}, {830,7.8190857}, {835,7.8505714}, {840,8.1216000}, {845,8.3388000}, {850,8.4694571}, {855,8.6911429}, {860,8.7213429}, {865,9.1636286}, {870,9.0874000}, {875,9.1737429}, {880,9.2579143}, {885,9.2012000}, {890,9.6085429}, {895,9.7170286}, {900,9.5624286}, {905,9.8980571}, {910,9.8865429}, {915,10.0450571}, {920,10.1446571}, {925,10.3366857}, {930,10.2821429}, {935,10.5675429}, {940,10.5605429}, {945,10.6095714}, {950,10.7748857}, {955,11.0151429}, {960,10.8943714}, {965,11.2676857}, {970,11.2640286}, {975,11.3372857}, {980,11.5424000}, {985,11.6260571}, {990,12.0205714}, {995,11.8169429}, {1000,11.9707143}, {1010,12.1945143}, {1020,12.7193143}, {1030,12.8908571}, {1040,13.3290857}, {1050,13.7593714}, {1060,14.1808571}, {1070,14.4934857}, {1080,14.7100857}, {1090,15.0517143}, {1100,15.2363143}, {1110,15.8863714}, {1120,15.9482286}, {1130,16.6884286}, {1140,16.9888571}, {1150,16.9290857}, {1160,17.6021143}, {1170,18.0042571}, {1180,18.5400857}, {1190,19.1251143}, {1200,19.1520000}, {1210,19.5430571}, {1220,20.3635429}, {1230,21.0348857}, {1240,21.5028571}, {1250,21.5398571}, {1260,22.3264571}, {1270,22.5950571}, {1280,23.0744571}, {1290,23.5130000}, {1300,23.8010571}, {1310,24.4346286}, {1320,24.9011143}, {1330,25.6378000}, {1340,25.8094857}, {1350,26.8964571}, {1360,27.2584857}, {1370,27.1815143}, {1380,28.0748000}, {1390,28.2628286}, {1400,29.4318000}, {1410,30.0073143}, {1420,30.5678571}, {1430,30.9479143}, {1440,31.2327714}, {1450,31.8254286}, {1460,32.4401429}, {1470,33.0868286}, {1480,34.8163143}, {1490,34.6538857}, {1500,34.7517429}, {1510,35.8283429}, {1520,36.6207429}, {1530,36.6108000}, {1540,37.5037714}, {1550,38.5051714}, {1560,38.8993143}, {1570,39.6652571}, {1580,39.9417143}, {1590,40.6865714}, {1600,40.7339714}, {1610,42.9210571}, {1620,42.3349714}, {1630,43.5377143}, {1640,44.2486286}, {1650,44.8658286}, {1660,45.8266857}, {1670,45.9385429}, {1680,47.7130857}, {1690,48.0391429}, {1700,49.1321429}, {1710,50.4169143}, {1720,51.3182286}, {1730,50.9894000}, {1740,52.0278000}, {1750,51.9289714}, {1760,52.6285714}, {1770,53.9118571}, {1780,54.6620571}, {1790,55.5682857}, {1800,56.2157429}, {1810,57.5565714}, {1820,58.2042286}, {1830,58.5013429}, {1840,59.9473714}, {1850,60.4419143}, {1860,61.6122571}, {1870,63.5622857}, {1880,64.4502857}, {1890,64.7054571}, {1900,66.6489429}, {1910,67.3968857}, {1920,69.2200571}, {1930,68.0374571}, {1940,69.5646000}, {1950,72.4982000}, {1960,71.7122571}, {1970,73.3514571}, {1980,74.7146571}, {1990,75.0703429}, {2000,75.2372571}};
data["big"]["LtacTacInTermGallinaCtx"]["reif"]["user"] = {{1,0.00041584}, {2,0.00088119}, {3,0.00165347}, {4,0.00158416}, {5,0.00212871}, {6,0.00246535}, {7,0.00308911}, {8,0.00324752}, {9,0.00368317}, {10,0.00382178}, {11,0.00440594}, {12,0.00498020}, {13,0.00467327}, {14,0.00577228}, {15,0.00614851}, {16,0.00668317}, {17,0.00735644}, {18,0.00750495}, {19,0.00826733}, {20,0.00865347}, {21,0.00936634}, {22,0.00967327}, {23,0.01020792}, {24,0.01096040}, {25,0.01164356}, {26,0.01331683}, {27,0.01247525}, {28,0.01328713}, {29,0.01381188}, {30,0.01407921}, {31,0.01526733}, {32,0.01584158}, {33,0.01626733}, {34,0.01704950}, {35,0.01776238}, {36,0.01863366}, {37,0.01931683}, {38,0.02000990}, {39,0.02151485}, {40,0.02179208}, {41,0.02784158}, {42,0.02376238}, {43,0.02425743}, {44,0.02550495}, {45,0.02979208}, {46,0.02735644}, {47,0.02800000}, {48,0.02862376}, {49,0.02969307}, {50,0.03057426}, {51,0.03123762}, {52,0.03207921}, {53,0.03847525}, {54,0.03386139}, {55,0.03492079}, {56,0.04558416}, {57,0.03662376}, {58,0.03831683}, {59,0.03883168}, {60,0.03952475}, {61,0.04054455}, {62,0.04124752}, {63,0.04296040}, {64,0.04391089}, {65,0.04520792}, {66,0.04648515}, {67,0.05564356}, {68,0.04880198}, {69,0.05064356}, {70,0.06412871}, {71,0.05242574}, {72,0.06068317}, {73,0.05417822}, {74,0.07103960}, {75,0.05662376}, {76,0.07058416}, {77,0.07908911}, {78,0.06082178}, {79,0.06147525}, {80,0.06299010}, {81,0.06652475}, {82,0.07301980}, {83,0.07778218}, {84,0.07200000}, {85,0.08560396}, {86,0.09705941}, {87,0.08943564}, {88,0.10236634}, {89,0.12824752}, {90,0.11021782}, {91,0.09913861}, {92,0.09958416}, {93,0.10598020}, {94,0.10403960}, {95,0.10603960}, {96,0.10910891}, {97,0.10963366}, {98,0.11201980}, {99,0.11520792}, {100,0.11838614}, {101,0.12107921}, {102,0.12164356}, {103,0.12329703}, {104,0.12614851}, {105,0.12832673}, {106,0.13241584}, {107,0.13319802}, {108,0.13582178}, {109,0.12920792}, {110,0.13085149}, {111,0.13323762}, {112,0.13400000}, {113,0.13763366}, {114,0.13895050}, {115,0.14071287}, {116,0.14260396}, {117,0.14600990}, {118,0.14830693}, {119,0.14928713}, {120,0.15226733}, {121,0.15500990}, {122,0.15485149}, {123,0.16028713}, {124,0.16253465}, {125,0.16412871}, {126,0.16624752}, {127,0.16849505}, {128,0.17096040}, {129,0.17290099}, {130,0.17751485}, {131,0.17783168}, {132,0.18189109}, {133,0.18324752}, {134,0.18511881}, {135,0.18777228}, {136,0.18947525}, {137,0.19260396}, {138,0.19364356}, {139,0.19872277}, {140,0.20046535}, {141,0.20209901}, {142,0.20665347}, {143,0.20709901}, {144,0.20867327}, {145,0.21287129}, {146,0.21584158}, {147,0.21749505}, {148,0.21966337}, {149,0.22211881}, {150,0.22669307}, {151,0.23034653}, {152,0.23124752}, {153,0.23492079}, {154,0.23884158}, {155,0.23931683}, {156,0.24224752}, {157,0.24664356}, {158,0.24810891}, {159,0.25305941}, {160,0.25128713}, {161,0.25505941}, {162,0.25773267}, {163,0.26033663}, {164,0.26347525}, {165,0.26714851}, {166,0.27229703}, {167,0.27304950}, {168,0.27923762}, {169,0.28195050}, {170,0.28109901}, {171,0.28414851}, {172,0.28945545}, {173,0.29237624}, {174,0.29533663}, {175,0.29826733}, {176,0.30098020}, {177,0.30421782}, {178,0.30735644}, {179,0.30969307}, {180,0.31047525}, {181,0.31385149}, {182,0.31728713}, {183,0.32104950}, {184,0.32411881}, {185,0.32674257}, {186,0.33027723}, {187,0.33253465}, {188,0.33561386}, {189,0.34031683}, {190,0.34353465}, {191,0.34719802}, {192,0.35072277}, {193,0.35630693}, {194,0.36545545}, {195,0.37125743}, {196,0.37119802}, {197,0.37202970}, {198,0.37221782}, {199,0.37773267}, {200,0.38177228}, {201,0.38615842}, {202,0.39832673}, {203,0.39965347}, {204,0.39198020}, {205,0.39627723}, {206,0.39653465}, {207,0.41143564}, {208,0.42152475}, {209,0.41557426}, {210,0.41413861}, {211,0.41623762}, {212,0.43265347}, {213,0.43077228}, {214,0.42569307}, {215,0.43320792}, {216,0.44882178}, {217,0.44418812}, {218,0.44363366}, {219,0.46090099}, {220,0.45555446}, {221,0.45690099}, {222,0.47439604}, {223,0.46874257}, {224,0.47438614}, {225,0.47829703}, {226,0.48072277}, {227,0.49482178}, {228,0.48548515}, {229,0.49854455}, {230,0.49520792}, {231,0.50537624}, {232,0.50834653}, {233,0.50976238}, {234,0.51538614}, {235,0.52164356}, {236,0.52159406}, {237,0.53371287}, {238,0.52901980}, {239,0.54570297}, {240,0.53815842}, {241,0.54928713}, {242,0.55127723}, {243,0.55549505}, {244,0.56361386}, {245,0.56706931}, {246,0.56450495}, {247,0.57600990}, {248,0.57229703}, {249,0.58245545}, {250,0.58991089}, {251,0.58436634}, {252,0.59325743}, {253,0.60525743}, {254,0.59827723}, {255,0.60674257}, {256,0.61999010}, {257,0.61371287}, {258,0.61755446}, {259,0.62429703}, {260,0.63058416}, {261,0.63912871}, {262,0.73123762}, {263,0.64856436}, {264,0.65255446}, {265,0.65149505}, {266,0.69885149}, {267,0.66488119}, {268,0.67118812}, {269,0.67303960}, {270,0.67691089}, {271,0.68304950}, {272,0.68680198}, {273,0.69670297}, {274,0.70531683}, {275,0.75347525}, {276,0.71400990}, {277,0.71923762}, {278,0.72484158}, {279,0.72957426}, {280,0.73216832}, {281,0.74118812}, {282,0.75300000}, {283,0.75452475}, {284,0.75722772}, {285,0.76384158}, {286,0.76561386}, {287,0.77007921}, {288,0.79301980}, {289,0.78244554}, {290,0.78357426}, {291,0.79047525}, {292,0.78618812}, {293,0.79037624}, {294,0.79601980}, {295,0.80545545}, {296,0.81366337}, {297,0.82842574}, {298,0.82943564}, {299,0.82713861}, {300,0.82499010}, {301,0.8701714}, {302,0.9852571}, {303,0.8886286}, {304,0.8955143}, {305,0.9064571}, {306,0.9027429}, {307,0.9102571}, {308,0.9273714}, {309,0.9172286}, {310,0.9199714}, {311,0.9389714}, {312,0.9439714}, {313,0.9481714}, {314,0.9553714}, {315,0.9593429}, {316,0.9645714}, {317,0.9679714}, {318,1.0329429}, {319,0.9815714}, {320,0.9873714}, {321,0.9956571}, {322,0.9992857}, {323,0.9990000}, {324,1.0063714}, {325,1.0118571}, {326,1.0177714}, {327,1.0305143}, {328,1.0296000}, {329,1.0430857}, {330,1.0414000}, {331,1.0534286}, {332,1.0505714}, {333,1.0564571}, {334,1.0666857}, {335,1.0696571}, {336,1.0831143}, {337,1.0802286}, {338,1.0938857}, {339,1.0930286}, {340,1.1076286}, {341,1.1086000}, {342,1.1256000}, {343,1.1320857}, {344,1.1466857}, {345,1.1459429}, {346,1.1539714}, {347,1.1543143}, {348,1.1636000}, {349,1.1700286}, {350,1.1836286}, {351,1.1926857}, {352,1.1891429}, {353,1.1955143}, {354,1.2040571}, {355,1.2123429}, {356,1.2146000}, {357,1.2276571}, {358,1.2260000}, {359,1.2331143}, {360,1.2366000}, {361,1.2528000}, {362,1.2532571}, {363,1.2928000}, {364,1.2707714}, {365,1.2755429}, {366,1.2730571}, {367,1.2977143}, {368,1.3252857}, {369,1.3001714}, {370,1.3144286}, {371,1.3230571}, {372,1.3282000}, {373,1.3328000}, {374,1.3514857}, {375,1.3576000}, {376,1.3598000}, {377,1.3676000}, {378,1.3675429}, {379,1.3737714}, {380,1.3930571}, {381,1.3960000}, {382,1.4032286}, {383,1.4171143}, {384,1.4265429}, {385,1.4307143}, {386,1.4469429}, {387,1.4863143}, {388,1.4569429}, {389,1.4772571}, {390,1.4753429}, {391,1.4884000}, {392,1.4895429}, {393,1.4952286}, {394,1.5028857}, {395,1.5126571}, {396,1.5255143}, {397,1.5364857}, {398,1.5395143}, {399,1.5492571}, {400,1.5600000}, {401,1.5722286}, {402,1.5816571}, {403,1.5996857}, {404,1.5950857}, {405,1.6127429}, {406,1.6206000}, {407,1.6303714}, {408,1.6537429}, {409,1.6623143}, {410,1.6744286}, {411,1.6438571}, {412,1.7012857}, {413,1.6645429}, {414,1.6742857}, {415,1.7087429}, {416,1.7418571}, {417,1.6903429}, {418,1.7225714}, {419,1.7582000}, {420,1.7798571}, {421,1.8116286}, {422,1.7245143}, {423,1.7334857}, {424,1.7408571}, {425,1.7569429}, {426,1.8020857}, {427,1.8867429}, {428,1.7974286}, {429,1.8349714}, {430,1.8130571}, {431,1.8564286}, {432,1.9093429}, {433,1.9222857}, {434,1.8863429}, {435,1.8882857}, {436,1.8648000}, {437,1.9023429}, {438,1.9199429}, {439,1.9428857}, {440,2.0134571}, {441,1.9482286}, {442,1.9943429}, {443,2.0029429}, {444,1.9756286}, {445,1.9562000}, {446,1.9607429}, {447,1.9771143}, {448,2.0146857}, {449,2.0048000}, {450,2.0162571}, {451,2.0008857}, {452,2.0139143}, {453,2.0287714}, {454,2.0478286}, {455,2.0542286}, {456,2.0636286}, {457,2.0746857}, {458,2.1202000}, {459,2.1170000}, {460,2.1296571}, {461,2.1547429}, {462,2.1692857}, {463,2.1252857}, {464,2.1556571}, {465,2.2212000}, {466,2.2340000}, {467,2.2495143}, {468,2.3368286}, {469,2.2433429}, {470,2.2289429}, {471,2.2788857}, {472,2.3028857}, {473,2.2605143}, {474,2.3035143}, {475,2.3042857}, {476,2.2950286}, {477,2.2577429}, {478,2.2938571}, {479,2.3103429}, {480,2.3186286}, {481,2.3240000}, {482,2.3668286}, {483,2.3656571}, {484,2.4253143}, {485,2.3643143}, {486,2.3897714}, {487,2.3770571}, {488,2.5410571}, {489,2.3874286}, {490,2.3954857}, {491,2.4997429}, {492,2.4051714}, {493,2.4349429}, {494,2.5069143}, {495,2.5568000}, {496,2.4942000}, {497,2.4975143}, {498,2.5432571}, {499,2.5380000}, {500,2.5543143}, {505,2.5998286}, {510,2.6955714}, {515,2.7651429}, {520,2.9427429}, {525,2.9791429}, {530,2.8831429}, {535,2.9478286}, {540,3.0191143}, {545,3.0803714}, {550,3.1509429}, {555,3.2234286}, {560,3.2214571}, {565,3.2548286}, {570,3.3226571}, {575,3.4069714}, {580,3.4663429}, {585,3.5048286}, {590,3.6059429}, {595,3.7238571}, {600,3.7651143}, {605,3.8821143}, {610,3.9072857}, {615,4.0264571}, {620,4.0815714}, {625,4.0934857}, {630,4.2059143}, {635,4.2306571}, {640,4.3113143}, {645,4.2740286}, {650,4.3784857}, {655,4.5003714}, {660,4.5560000}, {665,4.5762000}, {670,4.7234000}, {675,4.9849429}, {680,4.9704000}, {685,5.0262000}, {690,5.1892857}, {695,5.1888857}, {700,5.3246000}, {705,5.4283143}, {710,5.4635429}, {715,5.4319714}, {720,5.6069143}, {725,5.6317429}, {730,5.7839714}, {735,5.7763714}, {740,6.0144286}, {745,6.2053143}, {750,6.2803429}, {755,6.2692286}, {760,6.4369143}, {765,6.5556000}, {770,6.6291714}, {775,6.8695714}, {780,6.8766286}, {785,6.9454857}, {790,7.1119429}, {795,7.0816857}, {800,7.2167714}, {805,7.4880857}, {810,7.3869143}, {815,7.5974857}, {820,7.5816286}, {825,7.7550857}, {830,7.8053143}, {835,7.8355143}, {840,8.1087429}, {845,8.3211143}, {850,8.4520286}, {855,8.6765143}, {860,8.7049714}, {865,9.1488286}, {870,9.0753143}, {875,9.1640857}, {880,9.2468571}, {885,9.1933143}, {890,9.6007714}, {895,9.7056286}, {900,9.5504857}, {905,9.8787429}, {910,9.8655429}, {915,10.0291143}, {920,10.1256000}, {925,10.3150286}, {930,10.2602000}, {935,10.5452000}, {940,10.5394857}, {945,10.5923143}, {950,10.7601714}, {955,10.9998571}, {960,10.8807429}, {965,11.2410857}, {970,11.2396857}, {975,11.3098857}, {980,11.5176857}, {985,11.5964857}, {990,11.9847143}, {995,11.7867714}, {1000,11.9392000}, {1010,12.1603429}, {1020,12.6864286}, {1030,12.8524857}, {1040,13.3023429}, {1050,13.7327429}, {1060,14.1524000}, {1070,14.4517143}, {1080,14.6708571}, {1090,15.0300286}, {1100,15.2110000}, {1110,15.8480857}, {1120,15.9154571}, {1130,16.6552857}, {1140,16.9596571}, {1150,16.9029143}, {1160,17.5732000}, {1170,17.9773143}, {1180,18.5018286}, {1190,19.0924286}, {1200,19.1151143}, {1210,19.5047429}, {1220,20.3310857}, {1230,20.9971714}, {1240,21.4507429}, {1250,21.4809429}, {1260,22.2721143}, {1270,22.5412000}, {1280,23.0138571}, {1290,23.4711714}, {1300,23.7510000}, {1310,24.3995143}, {1320,24.8552571}, {1330,25.5989429}, {1340,25.7615429}, {1350,26.8527714}, {1360,27.2102000}, {1370,27.1234857}, {1380,28.0249429}, {1390,28.2110000}, {1400,29.3928000}, {1410,29.9619429}, {1420,30.5268857}, {1430,30.8970000}, {1440,31.1705143}, {1450,31.7667429}, {1460,32.3834857}, {1470,33.0234000}, {1480,34.7568571}, {1490,34.6083143}, {1500,34.6996571}, {1510,35.7578286}, {1520,36.5596857}, {1530,36.5431143}, {1540,37.4362286}, {1550,38.4334857}, {1560,38.8432000}, {1570,39.5998571}, {1580,39.8693143}, {1590,40.5922571}, {1600,40.6555429}, {1610,42.8559714}, {1620,42.2730857}, {1630,43.4652857}, {1640,44.1810571}, {1650,44.7810571}, {1660,45.7625143}, {1670,45.8489429}, {1680,47.6356571}, {1690,47.9576857}, {1700,49.0366000}, {1710,50.3284857}, {1720,51.2113429}, {1730,50.8949714}, {1740,51.9165143}, {1750,51.8338571}, {1760,52.5404571}, {1770,53.8172286}, {1780,54.5600286}, {1790,55.4797714}, {1800,56.1335143}, {1810,57.4849429}, {1820,58.1233143}, {1830,58.4111429}, {1840,59.8273714}, {1850,60.3355143}, {1860,61.4731429}, {1870,63.4510286}, {1880,64.3309143}, {1890,64.5976571}, {1900,66.5526000}, {1910,67.3015429}, {1920,69.1262857}, {1930,67.9500571}, {1940,69.4526857}, {1950,72.4198286}, {1960,71.3960286}, {1970,73.2762000}, {1980,74.6404000}, {1990,74.9957714}, {2000,75.1497429}};
data["big"]["LtacTacInTermGallinaCtx"]["reif"]["system"] = {{1,0.00003960}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00007921}, {8,0.00007921}, {9,0.00000000}, {10,0.00007921}, {11,0.00003960}, {12,0.00000000}, {13,0.00007921}, {14,0.00007921}, {15,0.00000000}, {16,0.00000000}, {17,0.00007921}, {18,0.00003960}, {19,0.00000000}, {20,0.00003960}, {21,0.00003960}, {22,0.00007921}, {23,0.00003960}, {24,0.00007921}, {25,0.00000000}, {26,0.00003960}, {27,0.00003960}, {28,0.00000000}, {29,0.00000000}, {30,0.00003960}, {31,0.00003960}, {32,0.00003960}, {33,0.00003960}, {34,0.00003960}, {35,0.00000000}, {36,0.00003960}, {37,0.00003960}, {38,0.00003960}, {39,0.00007921}, {40,0.00000000}, {41,0.00003960}, {42,0.00003960}, {43,0.00007921}, {44,0.00003960}, {45,0.00011881}, {46,0.00003960}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00003960}, {51,0.00000000}, {52,0.00000000}, {53,0.00015842}, {54,0.00003960}, {55,0.00003960}, {56,0.00000000}, {57,0.00007921}, {58,0.00003960}, {59,0.00000000}, {60,0.00000000}, {61,0.00003960}, {62,0.00000000}, {63,0.00007921}, {64,0.00000000}, {65,0.00003960}, {66,0.00003960}, {67,0.00000000}, {68,0.00000000}, {69,0.00003960}, {70,0.00000000}, {71,0.00000000}, {72,0.00007921}, {73,0.00003960}, {74,0.00007921}, {75,0.00000000}, {76,0.00000000}, {77,0.00007921}, {78,0.00003960}, {79,0.00007921}, {80,0.00003960}, {81,0.00000000}, {82,0.00011881}, {83,0.00003960}, {84,0.00000000}, {85,0.00003960}, {86,0.00007921}, {87,0.00007921}, {88,0.00007921}, {89,0.00015842}, {90,0.00015842}, {91,0.00003960}, {92,0.00000000}, {93,0.00000000}, {94,0.00003960}, {95,0.00000000}, {96,0.00000000}, {97,0.00003960}, {98,0.00003960}, {99,0.00003960}, {100,0.00007921}, {101,0.00010891}, {102,0.00015842}, {103,0.00003960}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00007921}, {108,0.00003960}, {109,0.00003960}, {110,0.00003960}, {111,0.00003960}, {112,0.00000000}, {113,0.00003960}, {114,0.00003960}, {115,0.00000000}, {116,0.00000000}, {117,0.00003960}, {118,0.00003960}, {119,0.00007921}, {120,0.00007921}, {121,0.00000000}, {122,0.00007921}, {123,0.00000000}, {124,0.00003960}, {125,0.00011881}, {126,0.00000000}, {127,0.00003960}, {128,0.00000000}, {129,0.00003960}, {130,0.00000000}, {131,0.00003960}, {132,0.00000000}, {133,0.00011881}, {134,0.00003960}, {135,0.00015842}, {136,0.00007921}, {137,0.00003960}, {138,0.00011881}, {139,0.00003960}, {140,0.00003960}, {141,0.00015842}, {142,0.00007921}, {143,0.00002970}, {144,0.00007921}, {145,0.00000000}, {146,0.00000000}, {147,0.00007921}, {148,0.00000000}, {149,0.00003960}, {150,0.00007921}, {151,0.00007921}, {152,0.00000000}, {153,0.00007921}, {154,0.00000000}, {155,0.00002970}, {156,0.00003960}, {157,0.00007921}, {158,0.00015842}, {159,0.00000000}, {160,0.00003960}, {161,0.00003960}, {162,0.00023762}, {163,0.00003960}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00003960}, {168,0.00000000}, {169,0.00015842}, {170,0.00003960}, {171,0.00007921}, {172,0.00011881}, {173,0.00010891}, {174,0.00007921}, {175,0.00003960}, {176,0.00003960}, {177,0.00007921}, {178,0.00007921}, {179,0.00000000}, {180,0.00000000}, {181,0.00003960}, {182,0.00014851}, {183,0.00003960}, {184,0.00003960}, {185,0.00011881}, {186,0.00003960}, {187,0.00015842}, {188,0.00000000}, {189,0.00003960}, {190,0.00006931}, {191,0.00003960}, {192,0.00003960}, {193,0.00003960}, {194,0.00000000}, {195,0.00003960}, {196,0.00000000}, {197,0.00003960}, {198,0.00007921}, {199,0.00003960}, {200,0.00003960}, {201,0.00007921}, {202,0.00000000}, {203,0.00003960}, {204,0.00003960}, {205,0.00002970}, {206,0.00003960}, {207,0.00007921}, {208,0.00007921}, {209,0.00000000}, {210,0.00010891}, {211,0.00003960}, {212,0.00011881}, {213,0.00007921}, {214,0.00007921}, {215,0.00003960}, {216,0.00000000}, {217,0.00000000}, {218,0.00011881}, {219,0.00007921}, {220,0.00003960}, {221,0.00011881}, {222,0.00000000}, {223,0.00003960}, {224,0.00003960}, {225,0.00003960}, {226,0.00003960}, {227,0.00003960}, {228,0.00011881}, {229,0.00007921}, {230,0.00000000}, {231,0.00003960}, {232,0.00003960}, {233,0.00007921}, {234,0.00000000}, {235,0.00007921}, {236,0.00003960}, {237,0.00007921}, {238,0.00003960}, {239,0.00011881}, {240,0.00002970}, {241,0.00007921}, {242,0.00011881}, {243,0.00003960}, {244,0.00011881}, {245,0.00007921}, {246,0.00023762}, {247,0.00019802}, {248,0.00019802}, {249,0.00015842}, {250,0.00003960}, {251,0.00019802}, {252,0.00010891}, {253,0.00000000}, {254,0.00010891}, {255,0.00011881}, {256,0.00007921}, {257,0.00079208}, {258,0.00003960}, {259,0.00015842}, {260,0.00003960}, {261,0.00000000}, {262,0.00043564}, {263,0.00007921}, {264,0.00019802}, {265,0.00023762}, {266,0.00079208}, {267,0.00026733}, {268,0.00006931}, {269,0.00007921}, {270,0.00034653}, {271,0.00015842}, {272,0.00007921}, {273,0.00070297}, {274,0.00000000}, {275,0.00007921}, {276,0.00011881}, {277,0.00011881}, {278,0.00027723}, {279,0.00019802}, {280,0.00039604}, {281,0.00015842}, {282,0.00000000}, {283,0.00003960}, {284,0.00003960}, {285,0.00011881}, {286,0.00003960}, {287,0.00015842}, {288,0.00000000}, {289,0.00011881}, {290,0.00003960}, {291,0.00007921}, {292,0.00003960}, {293,0.00027723}, {294,0.00007921}, {295,0.00019802}, {296,0.00015842}, {297,0.00011881}, {298,0.00027723}, {299,0.00053465}, {300,0.00014851}, {301,0.0002286}, {302,0.0006857}, {303,0.0002286}, {304,0.0005714}, {305,0.0001143}, {306,0.0003429}, {307,0.0003429}, {308,0.0000000}, {309,0.0001143}, {310,0.0002286}, {311,0.0004571}, {312,0.0001143}, {313,0.0000000}, {314,0.0000000}, {315,0.0002286}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0001143}, {320,0.0000000}, {321,0.0000000}, {322,0.0001143}, {323,0.0001143}, {324,0.0000000}, {325,0.0002286}, {326,0.0000000}, {327,0.0001143}, {328,0.0003429}, {329,0.0001143}, {330,0.0002286}, {331,0.0000000}, {332,0.0002286}, {333,0.0001143}, {334,0.0002286}, {335,0.0002286}, {336,0.0001143}, {337,0.0003429}, {338,0.0000000}, {339,0.0002286}, {340,0.0001143}, {341,0.0002286}, {342,0.0000000}, {343,0.0001143}, {344,0.0002286}, {345,0.0000000}, {346,0.0003429}, {347,0.0002286}, {348,0.0001143}, {349,0.0003429}, {350,0.0002286}, {351,0.0002286}, {352,0.0002286}, {353,0.0000000}, {354,0.0001143}, {355,0.0000000}, {356,0.0000000}, {357,0.0001143}, {358,0.0001143}, {359,0.0001143}, {360,0.0001143}, {361,0.0000000}, {362,0.0001143}, {363,0.0000000}, {364,0.0002286}, {365,0.0002286}, {366,0.0003429}, {367,0.0001143}, {368,0.0000000}, {369,0.0001143}, {370,0.0003429}, {371,0.0001143}, {372,0.0000000}, {373,0.0001143}, {374,0.0002286}, {375,0.0001143}, {376,0.0002286}, {377,0.0004571}, {378,0.0001143}, {379,0.0003429}, {380,0.0005429}, {381,0.0002286}, {382,0.0001143}, {383,0.0003429}, {384,0.0002286}, {385,0.0003429}, {386,0.0005714}, {387,0.0005714}, {388,0.0004571}, {389,0.0003429}, {390,0.0005714}, {391,0.0003429}, {392,0.0004286}, {393,0.0003429}, {394,0.0002286}, {395,0.0003429}, {396,0.0003429}, {397,0.0004571}, {398,0.0003429}, {399,0.0001143}, {400,0.0003429}, {401,0.0002286}, {402,0.0002286}, {403,0.0004571}, {404,0.0003429}, {405,0.0001143}, {406,0.0002286}, {407,0.0002286}, {408,0.0002286}, {409,0.0002286}, {410,0.0005143}, {411,0.0005714}, {412,0.0003429}, {413,0.0005714}, {414,0.0003429}, {415,0.0001143}, {416,0.0002286}, {417,0.0002286}, {418,0.0000000}, {419,0.0003429}, {420,0.0003429}, {421,0.0002286}, {422,0.0004571}, {423,0.0003429}, {424,0.0006857}, {425,0.0002286}, {426,0.0004571}, {427,0.0011429}, {428,0.0003429}, {429,0.0006857}, {430,0.0002286}, {431,0.0006857}, {432,0.0004571}, {433,0.0002286}, {434,0.0003429}, {435,0.0002286}, {436,0.0002286}, {437,0.0002286}, {438,0.0003429}, {439,0.0006857}, {440,0.0003429}, {441,0.0006857}, {442,0.0005714}, {443,0.0004571}, {444,0.0002286}, {445,0.0005429}, {446,0.0004571}, {447,0.0001143}, {448,0.0012571}, {449,0.0000857}, {450,0.0002286}, {451,0.0001143}, {452,0.0001143}, {453,0.0002286}, {454,0.0004571}, {455,0.0000000}, {456,0.0003429}, {457,0.0003143}, {458,0.0008857}, {459,0.0003429}, {460,0.0003429}, {461,0.0002286}, {462,0.0003429}, {463,0.0008000}, {464,0.0004571}, {465,0.0010286}, {466,0.0006857}, {467,0.0005714}, {468,0.0008000}, {469,0.0005714}, {470,0.0001143}, {471,0.0002286}, {472,0.0005714}, {473,0.0006857}, {474,0.0005714}, {475,0.0003429}, {476,0.0005714}, {477,0.0001143}, {478,0.0004571}, {479,0.0001143}, {480,0.0010286}, {481,0.0004571}, {482,0.0002286}, {483,0.0010286}, {484,0.0011429}, {485,0.0003429}, {486,0.0003429}, {487,0.0004571}, {488,0.0021714}, {489,0.0001143}, {490,0.0008000}, {491,0.0004571}, {492,0.0001143}, {493,0.0002286}, {494,0.0012571}, {495,0.0010286}, {496,0.0003429}, {497,0.0004571}, {498,0.0008571}, {499,0.0006857}, {500,0.0003429}, {505,0.0006857}, {510,0.0005714}, {515,0.0013714}, {520,0.0011429}, {525,0.0008000}, {530,0.0003429}, {535,0.0012286}, {540,0.0009143}, {545,0.0004571}, {550,0.0004571}, {555,0.0010000}, {560,0.0005429}, {565,0.0010286}, {570,0.0008000}, {575,0.0008000}, {580,0.0012571}, {585,0.0009143}, {590,0.0009143}, {595,0.0022857}, {600,0.0006857}, {605,0.0006857}, {610,0.0024000}, {615,0.0014857}, {620,0.0014857}, {625,0.0026286}, {630,0.0032000}, {635,0.0018000}, {640,0.0020571}, {645,0.0021714}, {650,0.0025143}, {655,0.0029714}, {660,0.0014857}, {665,0.0016000}, {670,0.0026286}, {675,0.0021714}, {680,0.0025143}, {685,0.0032857}, {690,0.0016000}, {695,0.0030571}, {700,0.0019429}, {705,0.0017143}, {710,0.0022857}, {715,0.0024857}, {720,0.0026286}, {725,0.0008000}, {730,0.0025143}, {735,0.0017143}, {740,0.0030857}, {745,0.0030857}, {750,0.0014857}, {755,0.0022571}, {760,0.0018000}, {765,0.0020571}, {770,0.0025143}, {775,0.0045429}, {780,0.0043429}, {785,0.0035429}, {790,0.0031714}, {795,0.0037429}, {800,0.0026286}, {805,0.0027143}, {810,0.0030857}, {815,0.0038857}, {820,0.0050286}, {825,0.0026286}, {830,0.0027714}, {835,0.0043143}, {840,0.0033143}, {845,0.0054286}, {850,0.0068571}, {855,0.0044571}, {860,0.0065143}, {865,0.0042286}, {870,0.0045429}, {875,0.0043714}, {880,0.0078286}, {885,0.0056571}, {890,0.0041143}, {895,0.0062000}, {900,0.0071714}, {905,0.0087429}, {910,0.0074000}, {915,0.0059429}, {920,0.0069714}, {925,0.0102857}, {930,0.0074857}, {935,0.0096000}, {940,0.0073429}, {945,0.0072857}, {950,0.0078857}, {955,0.0072000}, {960,0.0057143}, {965,0.0103429}, {970,0.0086571}, {975,0.0098571}, {980,0.0065143}, {985,0.0092571}, {990,0.0112286}, {995,0.0061429}, {1000,0.0067143}, {1010,0.0054286}, {1020,0.0073143}, {1030,0.0096571}, {1040,0.0057714}, {1050,0.0052571}, {1060,0.0081714}, {1070,0.0136857}, {1080,0.0088857}, {1090,0.0079429}, {1100,0.0089429}, {1110,0.0126286}, {1120,0.0092286}, {1130,0.0109429}, {1140,0.0088571}, {1150,0.0086000}, {1160,0.0129714}, {1170,0.0142286}, {1180,0.0148571}, {1190,0.0146571}, {1200,0.0186857}, {1210,0.0197714}, {1220,0.0143143}, {1230,0.0113714}, {1240,0.0163143}, {1250,0.0166286}, {1260,0.0207714}, {1270,0.0211429}, {1280,0.0249429}, {1290,0.0144571}, {1300,0.0239429}, {1310,0.0169143}, {1320,0.0203429}, {1330,0.0204571}, {1340,0.0162000}, {1350,0.0178857}, {1360,0.0201429}, {1370,0.0226857}, {1380,0.0258000}, {1390,0.0190000}, {1400,0.0166857}, {1410,0.0235714}, {1420,0.0148571}, {1430,0.0240286}, {1440,0.0249429}, {1450,0.0188000}, {1460,0.0133429}, {1470,0.0255714}, {1480,0.0268571}, {1490,0.0210571}, {1500,0.0222571}, {1510,0.0219143}, {1520,0.0300000}, {1530,0.0324571}, {1540,0.0266571}, {1550,0.0213429}, {1560,0.0241714}, {1570,0.0276000}, {1580,0.0226857}, {1590,0.0314571}, {1600,0.0351143}, {1610,0.0274857}, {1620,0.0292571}, {1630,0.0332571}, {1640,0.0327143}, {1650,0.0352286}, {1660,0.0296286}, {1670,0.0329714}, {1680,0.0347714}, {1690,0.0373143}, {1700,0.0399429}, {1710,0.0410000}, {1720,0.0406286}, {1730,0.0358000}, {1740,0.0442000}, {1750,0.0412000}, {1760,0.0363143}, {1770,0.0410286}, {1780,0.0465714}, {1790,0.0480857}, {1800,0.0415143}, {1810,0.0433143}, {1820,0.0539143}, {1830,0.0416571}, {1840,0.0491429}, {1850,0.0522286}, {1860,0.0558571}, {1870,0.0547714}, {1880,0.0614571}, {1890,0.0476857}, {1900,0.0577714}, {1910,0.0653429}, {1920,0.0584571}, {1930,0.0441714}, {1940,0.0590857}, {1950,0.0628286}, {1960,0.0550286}, {1970,0.0580571}, {1980,0.0570000}, {1990,0.0494857}, {2000,0.0521714}};
data["big"]["LtacTacInTermPrimPair"]["Aggregate"]["real"] = {{1,0.00100000}, {2,0.00104950}, {3,0.00200990}, {4,0.02043564}, {5,0.00299010}, {6,0.00300000}, {7,0.00347525}, {8,0.00400000}, {9,0.00500990}, {10,0.00500000}, {11,0.00521782}, {12,0.00600990}, {13,0.00624752}, {14,0.00700990}, {15,0.00888119}, {16,0.00800000}, {17,0.00870297}, {18,0.00913861}, {19,0.00976238}, {20,0.01051485}, {21,0.01087129}, {22,0.01150495}, {23,0.01550495}, {24,0.01262376}, {25,0.01338614}, {26,0.01395050}, {27,0.01466337}, {28,0.01534653}, {29,0.01582178}, {30,0.01654455}, {31,0.01723762}, {32,0.01799010}, {33,0.01857426}, {34,0.01929703}, {35,0.02009901}, {36,0.02059406}, {37,0.02114851}, {38,0.02187129}, {39,0.02275248}, {40,0.02360396}, {41,0.02420792}, {42,0.03071287}, {43,0.02583168}, {44,0.02666337}, {45,0.02723762}, {46,0.02789109}, {47,0.02908911}, {48,0.03766337}, {49,0.03068317}, {50,0.03500990}, {51,0.03228713}, {52,0.04068317}, {53,0.03433663}, {54,0.03529703}, {55,0.04700990}, {56,0.03707921}, {57,0.03831683}, {58,0.03912871}, {59,0.04068317}, {60,0.04906931}, {61,0.05199010}, {62,0.05303960}, {63,0.05302970}, {64,0.04996040}, {65,0.04561386}, {66,0.04716832}, {67,0.04804950}, {68,0.06173267}, {69,0.05008911}, {70,0.05166337}, {71,0.06852475}, {72,0.05342574}, {73,0.07163366}, {74,0.05616832}, {75,0.06872277}, {76,0.05798020}, {77,0.05927723}, {78,0.06905941}, {79,0.09360396}, {80,0.06951485}, {81,0.06426733}, {82,0.06533663}, {83,0.06669307}, {84,0.06784158}, {85,0.07899010}, {86,0.09942574}, {87,0.09156436}, {88,0.08775248}, {89,0.09295050}, {90,0.11334653}, {91,0.09987129}, {92,0.09111881}, {93,0.09190099}, {94,0.09348515}, {95,0.09467327}, {96,0.09494059}, {97,0.09524752}, {98,0.09630693}, {99,0.09670297}, {100,0.09743564}, {101,0.09837624}, {102,0.09866337}, {103,0.09962376}, {104,0.10010891}, {105,0.10084158}, {106,0.10177228}, {107,0.10251485}, {108,0.10303960}, {109,0.10518812}, {110,0.10504950}, {111,0.10710891}, {112,0.10842574}, {113,0.11025743}, {114,0.11168317}, {115,0.11345545}, {116,0.11519802}, {117,0.11704950}, {118,0.11906931}, {119,0.12043564}, {120,0.12244554}, {121,0.12397030}, {122,0.12566337}, {123,0.12834653}, {124,0.14288119}, {125,0.14562376}, {126,0.14700990}, {127,0.16215842}, {128,0.16756436}, {129,0.16717822}, {130,0.16940594}, {131,0.17268317}, {132,0.17617822}, {133,0.17567327}, {134,0.18092079}, {135,0.18113861}, {136,0.18397030}, {137,0.18778218}, {138,0.18789109}, {139,0.19242574}, {140,0.19474257}, {141,0.19646535}, {142,0.19853465}, {143,0.19954455}, {144,0.20412871}, {145,0.20703960}, {146,0.21048515}, {147,0.21286139}, {148,0.21394059}, {149,0.21617822}, {150,0.21849505}, {151,0.21983168}, {152,0.22165347}, {153,0.22202970}, {154,0.22364356}, {155,0.23200000}, {156,0.23502970}, {157,0.23985149}, {158,0.24001980}, {159,0.24458416}, {160,0.24687129}, {161,0.24841584}, {162,0.25090099}, {163,0.25551485}, {164,0.25882178}, {165,0.26255446}, {166,0.26446535}, {167,0.26896040}, {168,0.26991089}, {169,0.26806931}, {170,0.27459406}, {171,0.28148515}, {172,0.28088119}, {173,0.28524752}, {174,0.28813861}, {175,0.29032673}, {176,0.29501980}, {177,0.29693069}, {178,0.29898020}, {179,0.30187129}, {180,0.30610891}, {181,0.31082178}, {182,0.31412871}, {183,0.31751485}, {184,0.32095050}, {185,0.32384158}, {186,0.32733663}, {187,0.32948515}, {188,0.33115842}, {189,0.33383168}, {190,0.33826733}, {191,0.34263366}, {192,0.34334653}, {193,0.34411881}, {194,0.34778218}, {195,0.35404950}, {196,0.36139604}, {197,0.37229703}, {198,0.36966337}, {199,0.36869307}, {200,0.37305941}, {201,0.37926733}, {202,0.37917822}, {203,0.38890099}, {204,0.40085149}, {205,0.38555446}, {206,0.39460396}, {207,0.39487129}, {208,0.40583168}, {209,0.41992079}, {210,0.41062376}, {211,0.41117822}, {212,0.41371287}, {213,0.43765347}, {214,0.42428713}, {215,0.42333663}, {216,0.43579208}, {217,0.44429703}, {218,0.44172277}, {219,0.44699010}, {220,0.45988119}, {221,0.45496040}, {222,0.46039604}, {223,0.46820792}, {224,0.46677228}, {225,0.47884158}, {226,0.47467327}, {227,0.47872277}, {228,0.49024752}, {229,0.48748515}, {230,0.50109901}, {231,0.49553465}, {232,0.51044554}, {233,0.50084158}, {234,0.51831683}, {235,0.51072277}, {236,0.52631683}, {237,0.51814851}, {238,0.53056436}, {239,0.53003960}, {240,0.53634653}, {241,0.54411881}, {242,0.54337624}, {243,0.55421782}, {244,0.55708911}, {245,0.55907921}, {246,0.56585149}, {247,0.56996040}, {248,0.57259406}, {249,0.58408911}, {250,0.57858416}, {251,0.58596040}, {252,0.60036634}, {253,0.59558416}, {254,0.59973267}, {255,0.61146535}, {256,0.61078218}, {257,0.61331683}, {258,0.62392079}, {259,0.62977228}, {260,0.63671287}, {261,0.63419802}, {262,0.63828713}, {263,0.64649505}, {264,0.64720792}, {265,0.65641584}, {266,0.66286139}, {267,0.66600000}, {268,0.66838614}, {269,0.67288119}, {270,0.68112871}, {271,0.68505941}, {272,0.69071287}, {273,0.69636634}, {274,0.70076238}, {275,0.70864356}, {276,0.71557426}, {277,0.72307921}, {278,0.72440594}, {279,0.72977228}, {280,0.73408911}, {281,0.73808911}, {282,0.74317822}, {283,0.74791089}, {284,0.75265347}, {285,0.76200990}, {286,0.76177228}, {287,0.76312871}, {288,0.77120792}, {289,0.77866337}, {290,0.79312871}, {291,0.79922772}, {292,0.80696040}, {293,0.81639604}, {294,0.81875248}, {295,0.82507921}, {296,0.84028713}, {297,0.83296040}, {298,0.83700000}, {299,0.84705941}, {300,0.84855446}, {301,0.8687143}, {302,0.9894000}, {303,0.9387714}, {304,0.9371714}, {305,0.9045429}, {306,0.9066000}, {307,0.9079429}, {308,0.9184571}, {309,0.9269143}, {310,0.9238000}, {311,0.9355429}, {312,0.9434286}, {313,0.9483143}, {314,0.9501429}, {315,0.9620000}, {316,0.9656000}, {317,0.9677714}, {318,0.9754571}, {319,0.9869714}, {320,0.9886857}, {321,0.9930286}, {322,1.0078571}, {323,1.0110000}, {324,1.0195714}, {325,1.0263429}, {326,1.0263714}, {327,1.0422286}, {328,1.0428286}, {329,1.0450571}, {330,1.0600857}, {331,1.0572571}, {332,1.0780286}, {333,1.0604286}, {334,1.0780857}, {335,1.0790286}, {336,1.0881429}, {337,1.0956286}, {338,1.0977429}, {339,1.1085714}, {340,1.1094857}, {341,1.1274857}, {342,1.1345143}, {343,1.1430571}, {344,1.1557714}, {345,1.1582000}, {346,1.1582857}, {347,1.1694286}, {348,1.1790857}, {349,1.1845143}, {350,1.1906857}, {351,1.2080000}, {352,1.2126286}, {353,1.2114857}, {354,1.2247714}, {355,1.2228286}, {356,1.2325714}, {357,1.2418857}, {358,1.2537714}, {359,1.2521714}, {360,1.2722000}, {361,1.2732000}, {362,1.2768286}, {363,1.2983429}, {364,1.2944857}, {365,1.3039714}, {366,1.3083143}, {367,1.3256857}, {368,1.3210000}, {369,1.3326857}, {370,1.3498857}, {371,1.3533429}, {372,1.3618571}, {373,1.3662286}, {374,1.3777714}, {375,1.3914000}, {376,1.3941429}, {377,1.4014857}, {378,1.4102000}, {379,1.4157143}, {380,1.4232857}, {381,1.4343429}, {382,1.4464857}, {383,1.4568857}, {384,1.4666857}, {385,1.4787143}, {386,1.4827429}, {387,1.5013714}, {388,1.4998000}, {389,1.5110571}, {390,1.5225429}, {391,1.5247714}, {392,1.5285429}, {393,1.5421143}, {394,1.5559429}, {395,1.5626286}, {396,1.5720571}, {397,1.5776000}, {398,1.5810286}, {399,1.5945143}, {400,1.6032000}, {401,1.6136000}, {402,1.6235714}, {403,1.6343714}, {404,1.6370857}, {405,1.6580000}, {406,1.6633429}, {407,1.6713429}, {408,1.6808857}, {409,1.6870000}, {410,1.6926571}, {411,1.7038286}, {412,1.7033143}, {413,1.7170857}, {414,1.7236857}, {415,1.7385143}, {416,1.7401143}, {417,1.7523714}, {418,1.7547143}, {419,1.8136000}, {420,1.8074571}, {421,1.7932571}, {422,1.8024571}, {423,1.8101143}, {424,1.8168857}, {425,1.8348857}, {426,1.8376857}, {427,1.8639143}, {428,1.8651714}, {429,1.8800571}, {430,1.8848571}, {431,1.9034857}, {432,1.9054000}, {433,1.9167143}, {434,1.9221429}, {435,1.9346857}, {436,1.9385429}, {437,1.9534857}, {438,1.9654571}, {439,1.9821429}, {440,1.9971714}, {441,2.0005429}, {442,2.0103714}, {443,2.0162286}, {444,2.0252571}, {445,2.0441143}, {446,2.0446286}, {447,2.0581429}, {448,2.0622286}, {449,2.0824000}, {450,2.0897143}, {451,2.0994000}, {452,2.1039714}, {453,2.1161714}, {454,2.1296571}, {455,2.1442000}, {456,2.1591714}, {457,2.1661143}, {458,2.1787143}, {459,2.1871429}, {460,2.2024571}, {461,2.2041714}, {462,2.2087143}, {463,2.2306857}, {464,2.2416571}, {465,2.2517429}, {466,2.2592286}, {467,2.2994571}, {468,2.3160286}, {469,2.2972286}, {470,2.3111143}, {471,2.3366571}, {472,2.3232286}, {473,2.3372857}, {474,2.3446000}, {475,2.3434000}, {476,2.3540857}, {477,2.3766000}, {478,2.4118286}, {479,2.3869143}, {480,2.4609429}, {481,2.5215429}, {482,2.4378286}, {483,2.5464286}, {484,2.4740000}, {485,2.5505143}, {486,2.5090000}, {487,2.5851714}, {488,2.6024000}, {489,2.5732571}, {490,2.5334857}, {491,2.5425429}, {492,2.5816000}, {493,2.6133714}, {494,2.6366857}, {495,2.6468857}, {496,2.6924000}, {497,2.7473143}, {498,2.6652000}, {499,2.6947714}, {500,2.6763143}, {505,2.7791714}, {510,2.8008571}, {515,2.9482571}, {520,3.0375143}, {525,3.1796571}, {530,3.1558571}, {535,3.2006571}, {540,3.2307143}, {545,3.2880000}, {550,3.3431143}, {555,3.3962000}, {560,3.4407714}, {565,3.5835143}, {570,3.6368000}, {575,3.6832286}, {580,3.7537429}, {585,3.8779714}, {590,3.9126286}, {595,4.0113143}, {600,4.0753714}, {605,4.2824571}, {610,4.2646857}, {615,4.3213429}, {620,4.4194000}, {625,4.4960000}, {630,4.6478571}, {635,4.6854571}, {640,4.7888000}, {645,4.7840571}, {650,4.8904000}, {655,5.1022857}, {660,5.1722286}, {665,5.1581143}, {670,5.1578571}, {675,5.2630000}, {680,5.3764571}, {685,5.5100000}, {690,5.6651143}, {695,5.6650857}, {700,5.8279143}, {705,5.8236571}, {710,5.9997714}, {715,6.1045714}, {720,6.1540286}, {725,6.2372571}, {730,6.3516571}, {735,6.6141714}, {740,6.6353429}, {745,6.7154000}, {750,6.8611143}, {755,6.9858571}, {760,7.0822571}, {765,7.2223143}, {770,7.3338571}, {775,7.4512857}, {780,7.5336000}, {785,7.6698000}, {790,7.7896571}, {795,7.9117429}, {800,8.1405429}, {805,8.1447429}, {810,8.3050857}, {815,8.3993143}, {820,8.5601143}, {825,8.6726000}, {830,8.8014571}, {835,8.9139429}, {840,9.0491429}, {845,9.2168857}, {850,9.4120000}, {855,9.5280857}, {860,9.6530571}, {865,9.8142286}, {870,9.9653143}, {875,10.2232286}, {880,10.2900000}, {885,10.7433429}, {890,10.5442857}, {895,10.7477429}, {900,11.1513143}, {905,11.1113429}, {910,11.3146571}, {915,11.4125714}, {920,11.9052857}, {925,11.9688000}, {930,12.0677143}, {935,12.0625429}, {940,12.5604857}, {945,12.3222000}, {950,12.5628000}, {955,12.8495429}, {960,13.3715714}, {965,13.4121714}, {970,13.2987714}, {975,13.5782857}, {980,13.8956857}, {985,14.3372571}, {990,14.2789714}, {995,14.6891429}, {1000,14.6599714}, {1010,15.2898571}, {1020,15.5378857}, {1030,16.0889143}, {1040,16.3054857}, {1050,16.8042571}, {1060,17.4240286}, {1070,17.8762857}, {1080,18.5520857}, {1090,18.2649143}, {1100,19.0371714}, {1110,19.3938571}, {1120,19.9538571}, {1130,20.3698857}, {1140,20.8577714}, {1150,21.3690286}, {1160,21.8683429}, {1170,22.3141429}, {1180,23.1373143}, {1190,23.4851714}, {1200,24.0637143}, {1210,24.7415143}, {1220,25.1470000}, {1230,25.4346571}, {1240,26.1812000}, {1250,27.0656571}, {1260,27.6083714}, {1270,28.1684571}, {1280,28.5866000}, {1290,29.0077429}, {1300,29.7030571}, {1310,30.4068571}, {1320,31.0582000}, {1330,31.9951429}, {1340,32.5751143}, {1350,33.1042286}, {1360,33.6092857}, {1370,34.2735714}, {1380,35.0398571}, {1390,35.7208571}, {1400,36.4577143}, {1410,37.0684857}, {1420,38.1096857}, {1430,38.8777714}, {1440,39.4952000}, {1450,40.0569714}, {1460,40.8437429}, {1470,42.0706286}, {1480,42.4758857}, {1490,43.3222000}, {1500,43.7581143}, {1510,45.0631714}, {1520,45.6422857}, {1530,47.0619429}, {1540,48.0180000}, {1550,48.8511143}, {1560,49.4978000}, {1570,50.2317714}, {1580,51.5904286}, {1590,52.5275143}, {1600,53.0986286}, {1610,54.2435143}, {1620,55.2772571}, {1630,55.5747429}, {1640,56.1761429}, {1650,57.7354286}, {1660,58.7435714}, {1670,59.7086571}, {1680,60.4648571}, {1690,62.3275429}, {1700,63.6219429}, {1710,64.5232571}, {1720,65.5803143}, {1730,66.4158000}, {1740,67.5878857}, {1750,68.2263429}, {1760,69.0951714}, {1770,70.5657429}, {1780,71.6643143}, {1790,72.9173429}, {1800,74.0126286}, {1810,75.4193714}, {1820,76.6367429}, {1830,77.1381429}, {1840,78.7407429}, {1850,80.6459143}, {1860,81.8993429}, {1870,83.2306571}, {1880,84.3493429}, {1890,86.4059714}, {1900,86.4408571}, {1910,88.4606571}, {1920,89.4434000}, {1930,90.9131714}, {1940,91.5766571}, {1950,92.8696000}, {1960,95.2766571}, {1970,94.9787714}, {1980,96.8636000}, {1990,98.2015714}, {2000,99.8131714}};
data["big"]["LtacTacInTermPrimPair"]["Aggregate"]["user"] = {{1,0.00142574}, {2,0.00162376}, {3,0.00224752}, {4,0.01983168}, {5,0.00303960}, {6,0.00353465}, {7,0.00388119}, {8,0.00415842}, {9,0.00512871}, {10,0.00510891}, {11,0.00524752}, {12,0.00603960}, {13,0.00634653}, {14,0.00708911}, {15,0.00910891}, {16,0.00809901}, {17,0.00907921}, {18,0.00906931}, {19,0.00955446}, {20,0.01061386}, {21,0.01111881}, {22,0.01161386}, {23,0.01528713}, {24,0.01265347}, {25,0.01298020}, {26,0.01371287}, {27,0.01412871}, {28,0.01486139}, {29,0.01536634}, {30,0.01616832}, {31,0.01673267}, {32,0.01786139}, {33,0.01807921}, {34,0.01903960}, {35,0.01933663}, {36,0.02054455}, {37,0.02112871}, {38,0.02239604}, {39,0.02278218}, {40,0.02394059}, {41,0.02460396}, {42,0.03054455}, {43,0.02594059}, {44,0.02678218}, {45,0.02755446}, {46,0.02810891}, {47,0.02937624}, {48,0.03736634}, {49,0.03072277}, {50,0.03484158}, {51,0.03208911}, {52,0.04029703}, {53,0.03416832}, {54,0.03488119}, {55,0.04708911}, {56,0.03690099}, {57,0.03796040}, {58,0.03872277}, {59,0.04022772}, {60,0.04901980}, {61,0.05193069}, {62,0.05292079}, {63,0.05316832}, {64,0.05006931}, {65,0.04550495}, {66,0.04720792}, {67,0.04822772}, {68,0.06181188}, {69,0.05044554}, {70,0.05165347}, {71,0.06809901}, {72,0.05358416}, {73,0.07129703}, {74,0.05609901}, {75,0.06814851}, {76,0.05747525}, {77,0.05873267}, {78,0.06884158}, {79,0.09364356}, {80,0.06962376}, {81,0.06379208}, {82,0.06503960}, {83,0.06649505}, {84,0.06744554}, {85,0.07883168}, {86,0.09936634}, {87,0.09099010}, {88,0.08742574}, {89,0.09268317}, {90,0.11297030}, {91,0.09928713}, {92,0.09091089}, {93,0.09127723}, {94,0.09348515}, {95,0.09420792}, {96,0.09473267}, {97,0.09509901}, {98,0.09643564}, {99,0.09708911}, {100,0.09741584}, {101,0.09830693}, {102,0.09864356}, {103,0.09957426}, {104,0.10017822}, {105,0.10098020}, {106,0.10144554}, {107,0.10212871}, {108,0.10327723}, {109,0.10486139}, {110,0.10471287}, {111,0.10677228}, {112,0.10809901}, {113,0.10993069}, {114,0.11117822}, {115,0.11284158}, {116,0.11485149}, {117,0.11668317}, {118,0.11904950}, {119,0.12029703}, {120,0.12231683}, {121,0.12385149}, {122,0.12576238}, {123,0.12767327}, {124,0.14263366}, {125,0.14533663}, {126,0.14651485}, {127,0.16204950}, {128,0.16690099}, {129,0.16674257}, {130,0.16923762}, {131,0.17245545}, {132,0.17581188}, {133,0.17519802}, {134,0.18045545}, {135,0.18105941}, {136,0.18331683}, {137,0.18717822}, {138,0.18706931}, {139,0.19190099}, {140,0.19449505}, {141,0.19636634}, {142,0.19822772}, {143,0.19926733}, {144,0.20363366}, {145,0.20633663}, {146,0.20971287}, {147,0.21231683}, {148,0.21324752}, {149,0.21538614}, {150,0.21803960}, {151,0.21918812}, {152,0.22118812}, {153,0.22145545}, {154,0.22309901}, {155,0.23123762}, {156,0.23457426}, {157,0.23931683}, {158,0.23972277}, {159,0.24404950}, {160,0.24614851}, {161,0.24797030}, {162,0.25025743}, {163,0.25482178}, {164,0.25824752}, {165,0.26193069}, {166,0.26386139}, {167,0.26784158}, {168,0.26930693}, {169,0.26763366}, {170,0.27396040}, {171,0.28087129}, {172,0.28009901}, {173,0.28441584}, {174,0.28720792}, {175,0.28955446}, {176,0.29416832}, {177,0.29643564}, {178,0.29860396}, {179,0.30132673}, {180,0.30554455}, {181,0.31010891}, {182,0.31360396}, {183,0.31679208}, {184,0.32000000}, {185,0.32292079}, {186,0.32633663}, {187,0.32868317}, {188,0.33024752}, {189,0.33312871}, {190,0.33781188}, {191,0.34181188}, {192,0.34290099}, {193,0.34352475}, {194,0.34697030}, {195,0.35288119}, {196,0.36078218}, {197,0.37142574}, {198,0.36883168}, {199,0.36804950}, {200,0.37218812}, {201,0.37857426}, {202,0.37825743}, {203,0.38813861}, {204,0.39961386}, {205,0.38467327}, {206,0.39362376}, {207,0.39377228}, {208,0.40519802}, {209,0.41889109}, {210,0.41000000}, {211,0.41023762}, {212,0.41238614}, {213,0.43713861}, {214,0.42371287}, {215,0.42287129}, {216,0.43452475}, {217,0.44342574}, {218,0.44129703}, {219,0.44631683}, {220,0.45890099}, {221,0.45394059}, {222,0.45944554}, {223,0.46749505}, {224,0.46576238}, {225,0.47800990}, {226,0.47405941}, {227,0.47784158}, {228,0.48929703}, {229,0.48649505}, {230,0.50039604}, {231,0.49434653}, {232,0.50952475}, {233,0.49999010}, {234,0.51757426}, {235,0.50947525}, {236,0.52560396}, {237,0.51741584}, {238,0.52949505}, {239,0.52928713}, {240,0.53524752}, {241,0.54294059}, {242,0.54226733}, {243,0.55316832}, {244,0.55587129}, {245,0.55781188}, {246,0.56451485}, {247,0.56858416}, {248,0.57133663}, {249,0.58265347}, {250,0.57748515}, {251,0.58471287}, {252,0.59870297}, {253,0.59426733}, {254,0.59845545}, {255,0.60979208}, {256,0.60970297}, {257,0.61190099}, {258,0.62258416}, {259,0.62915842}, {260,0.63559406}, {261,0.63301980}, {262,0.63664356}, {263,0.64510891}, {264,0.64610891}, {265,0.65499010}, {266,0.66148515}, {267,0.66491089}, {268,0.66696040}, {269,0.67159406}, {270,0.68004950}, {271,0.68367327}, {272,0.68923762}, {273,0.69501980}, {274,0.69928713}, {275,0.70726733}, {276,0.71428713}, {277,0.72204950}, {278,0.72314851}, {279,0.72860396}, {280,0.73218812}, {281,0.73678218}, {282,0.74191089}, {283,0.74642574}, {284,0.75085149}, {285,0.76048515}, {286,0.76028713}, {287,0.76146535}, {288,0.77009901}, {289,0.77739604}, {290,0.79199010}, {291,0.79774257}, {292,0.80579208}, {293,0.81488119}, {294,0.81715842}, {295,0.82348515}, {296,0.83855446}, {297,0.83122772}, {298,0.83550495}, {299,0.84508911}, {300,0.84718812}, {301,0.8676286}, {302,0.9879714}, {303,0.9374857}, {304,0.9361714}, {305,0.9031429}, {306,0.9051714}, {307,0.9064571}, {308,0.9166000}, {309,0.9264286}, {310,0.9232286}, {311,0.9343143}, {312,0.9415143}, {313,0.9471429}, {314,0.9487714}, {315,0.9610000}, {316,0.9643429}, {317,0.9670286}, {318,0.9732571}, {319,0.9847143}, {320,0.9862857}, {321,0.9923143}, {322,1.0066286}, {323,1.0105714}, {324,1.0181429}, {325,1.0239429}, {326,1.0247714}, {327,1.0405143}, {328,1.0399143}, {329,1.0410857}, {330,1.0571143}, {331,1.0553143}, {332,1.0722000}, {333,1.0582857}, {334,1.0754000}, {335,1.0748857}, {336,1.0862857}, {337,1.0936286}, {338,1.0964286}, {339,1.1070857}, {340,1.1082857}, {341,1.1262000}, {342,1.1329143}, {343,1.1412286}, {344,1.1536571}, {345,1.1564571}, {346,1.1559714}, {347,1.1679429}, {348,1.1777143}, {349,1.1828857}, {350,1.1890286}, {351,1.2069714}, {352,1.2117143}, {353,1.2104857}, {354,1.2235429}, {355,1.2212571}, {356,1.2313714}, {357,1.2409143}, {358,1.2527143}, {359,1.2509429}, {360,1.2708286}, {361,1.2716571}, {362,1.2756000}, {363,1.2961714}, {364,1.2924857}, {365,1.3024286}, {366,1.3063143}, {367,1.3238857}, {368,1.3186286}, {369,1.3304286}, {370,1.3482000}, {371,1.3518286}, {372,1.3598857}, {373,1.3652857}, {374,1.3768000}, {375,1.3893143}, {376,1.3922571}, {377,1.3993429}, {378,1.4079143}, {379,1.4133429}, {380,1.4206857}, {381,1.4323714}, {382,1.4444286}, {383,1.4533143}, {384,1.4646000}, {385,1.4762857}, {386,1.4811429}, {387,1.4984857}, {388,1.4971143}, {389,1.5087143}, {390,1.5193714}, {391,1.5234857}, {392,1.5264000}, {393,1.5396857}, {394,1.5538857}, {395,1.5611429}, {396,1.5697714}, {397,1.5754286}, {398,1.5784857}, {399,1.5923429}, {400,1.6001714}, {401,1.6115429}, {402,1.6217429}, {403,1.6314571}, {404,1.6337714}, {405,1.6498571}, {406,1.6544571}, {407,1.6634857}, {408,1.6730000}, {409,1.6846286}, {410,1.6892286}, {411,1.6994286}, {412,1.7000857}, {413,1.7143429}, {414,1.7201714}, {415,1.7340286}, {416,1.7363143}, {417,1.7492286}, {418,1.7519143}, {419,1.8105143}, {420,1.8047429}, {421,1.7914000}, {422,1.8002571}, {423,1.8084571}, {424,1.8137714}, {425,1.8307143}, {426,1.8334571}, {427,1.8615143}, {428,1.8618000}, {429,1.8756857}, {430,1.8809429}, {431,1.8994857}, {432,1.9016286}, {433,1.9133143}, {434,1.9194000}, {435,1.9308571}, {436,1.9349429}, {437,1.9507714}, {438,1.9618000}, {439,1.9770571}, {440,1.9920857}, {441,1.9950857}, {442,2.0059143}, {443,2.0117714}, {444,2.0209143}, {445,2.0400286}, {446,2.0412571}, {447,2.0540571}, {448,2.0571714}, {449,2.0788857}, {450,2.0860857}, {451,2.0959714}, {452,2.0997429}, {453,2.1124286}, {454,2.1257143}, {455,2.1405714}, {456,2.1548857}, {457,2.1620571}, {458,2.1749143}, {459,2.1835429}, {460,2.1992000}, {461,2.2004571}, {462,2.2053429}, {463,2.2272000}, {464,2.2380286}, {465,2.2472571}, {466,2.2550286}, {467,2.2963143}, {468,2.3113429}, {469,2.2937429}, {470,2.3063143}, {471,2.3315429}, {472,2.3178571}, {473,2.3312000}, {474,2.3385714}, {475,2.3383143}, {476,2.3484000}, {477,2.3719429}, {478,2.4068286}, {479,2.3814857}, {480,2.4552571}, {481,2.5155143}, {482,2.4320571}, {483,2.5382000}, {484,2.4670571}, {485,2.5439714}, {486,2.5025714}, {487,2.5780571}, {488,2.5955714}, {489,2.5668000}, {490,2.5283714}, {491,2.5365429}, {492,2.5757143}, {493,2.6073429}, {494,2.6293714}, {495,2.6404000}, {496,2.6861429}, {497,2.7409429}, {498,2.6590857}, {499,2.6880000}, {500,2.6710000}, {505,2.7726857}, {510,2.7945714}, {515,2.9402857}, {520,3.0285143}, {525,3.1693714}, {530,3.1478286}, {535,3.1919143}, {540,3.2197429}, {545,3.2777143}, {550,3.3315143}, {555,3.3859143}, {560,3.4294000}, {565,3.5743143}, {570,3.6276571}, {575,3.6736286}, {580,3.7428286}, {585,3.8667714}, {590,3.9031429}, {595,4.0009143}, {600,4.0667714}, {605,4.2734857}, {610,4.2551714}, {615,4.3121714}, {620,4.4100571}, {625,4.4852000}, {630,4.6362571}, {635,4.6757714}, {640,4.7806286}, {645,4.7760286}, {650,4.8859143}, {655,5.0962571}, {660,5.1671714}, {665,5.1496857}, {670,5.1510857}, {675,5.2566286}, {680,5.3702000}, {685,5.5020000}, {690,5.6561143}, {695,5.6576286}, {700,5.8189143}, {705,5.8173429}, {710,5.9944571}, {715,6.0943714}, {720,6.1461429}, {725,6.2271143}, {730,6.3406857}, {735,6.6066286}, {740,6.6278000}, {745,6.7080857}, {750,6.8528571}, {755,6.9790286}, {760,7.0753143}, {765,7.2145143}, {770,7.3238571}, {775,7.4425714}, {780,7.5257143}, {785,7.6604286}, {790,7.7754857}, {795,7.8964571}, {800,8.1122857}, {805,8.1188571}, {810,8.2886000}, {815,8.3822286}, {820,8.5484000}, {825,8.6562000}, {830,8.7874286}, {835,8.8834286}, {840,9.0354286}, {845,9.2022571}, {850,9.3983429}, {855,9.5143714}, {860,9.6398000}, {865,9.7991714}, {870,9.9536286}, {875,10.2123714}, {880,10.2844857}, {885,10.7364857}, {890,10.5361714}, {895,10.7401429}, {900,11.1422286}, {905,11.0978857}, {910,11.2986857}, {915,11.3988857}, {920,11.8877714}, {925,11.9537143}, {930,12.0496000}, {935,12.0444571}, {940,12.5413143}, {945,12.3074571}, {950,12.5530857}, {955,12.8372286}, {960,13.3584571}, {965,13.3925143}, {970,13.2762571}, {975,13.5563714}, {980,13.8697143}, {985,14.3101143}, {990,14.2478286}, {995,14.6555143}, {1000,14.6250000}, {1010,15.2381143}, {1020,15.5028571}, {1030,16.0498286}, {1040,16.2753714}, {1050,16.7737143}, {1060,17.3988857}, {1070,17.8548571}, {1080,18.4812857}, {1090,18.2454000}, {1100,19.0160571}, {1110,19.3582000}, {1120,19.9198571}, {1130,20.3417143}, {1140,20.8234286}, {1150,21.3431714}, {1160,21.8439714}, {1170,22.2910857}, {1180,23.0943714}, {1190,23.4600000}, {1200,24.0378857}, {1210,24.7167714}, {1220,25.1175143}, {1230,25.3998000}, {1240,26.1401714}, {1250,27.0172286}, {1260,27.5592286}, {1270,28.1213714}, {1280,28.5425143}, {1290,28.9630571}, {1300,29.6641429}, {1310,30.3758000}, {1320,31.0200000}, {1330,31.9632286}, {1340,32.5284857}, {1350,33.0614571}, {1360,33.5634571}, {1370,34.2249429}, {1380,35.0034286}, {1390,35.6740857}, {1400,36.4229429}, {1410,37.0266571}, {1420,38.0640000}, {1430,38.8369143}, {1440,39.4446286}, {1450,39.9946286}, {1460,40.7876286}, {1470,42.0138857}, {1480,42.4294571}, {1490,43.2788571}, {1500,43.7124571}, {1510,44.9808857}, {1520,45.5854857}, {1530,47.0056571}, {1540,47.9715143}, {1550,48.7777714}, {1560,49.4450000}, {1570,50.1767429}, {1580,51.5368000}, {1590,52.4476000}, {1600,53.0396286}, {1610,54.1953714}, {1620,55.2312286}, {1630,55.5138571}, {1640,56.1194571}, {1650,57.6660286}, {1660,58.6808571}, {1670,59.6384286}, {1680,60.3988857}, {1690,62.2662857}, {1700,63.5478857}, {1710,64.4581714}, {1720,65.5057143}, {1730,66.3295143}, {1740,67.5016286}, {1750,68.1461143}, {1760,69.0170571}, {1770,70.4836286}, {1780,71.5730286}, {1790,72.8465143}, {1800,73.9558000}, {1810,75.3794286}, {1820,76.5749429}, {1830,77.0629714}, {1840,78.6465714}, {1850,80.5598000}, {1860,81.8019429}, {1870,83.1352286}, {1880,84.2544571}, {1890,86.3140857}, {1900,86.3596286}, {1910,88.4050857}, {1920,89.3858857}, {1930,90.8515714}, {1940,91.4957143}, {1950,92.8103429}, {1960,95.0172000}, {1970,94.9448000}, {1980,96.8174000}, {1990,98.1452571}, {2000,99.7600571}};
data["big"]["LtacTacInTermPrimPair"]["Aggregate"]["system"] = {{1,0.00000000}, {2,0.00003960}, {3,0.00003960}, {4,0.00007921}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00003960}, {9,0.00000000}, {10,0.00000000}, {11,0.00003960}, {12,0.00002970}, {13,0.00000000}, {14,0.00000000}, {15,0.00003960}, {16,0.00007921}, {17,0.00003960}, {18,0.00003960}, {19,0.00010891}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00003960}, {25,0.00000000}, {26,0.00003960}, {27,0.00000000}, {28,0.00003960}, {29,0.00000000}, {30,0.00000000}, {31,0.00003960}, {32,0.00003960}, {33,0.00007921}, {34,0.00011881}, {35,0.00007921}, {36,0.00000000}, {37,0.00007921}, {38,0.00000000}, {39,0.00003960}, {40,0.00000000}, {41,0.00003960}, {42,0.00000000}, {43,0.00002970}, {44,0.00003960}, {45,0.00019802}, {46,0.00003960}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00003960}, {51,0.00015842}, {52,0.00007921}, {53,0.00014851}, {54,0.00003960}, {55,0.00003960}, {56,0.00000000}, {57,0.00007921}, {58,0.00000000}, {59,0.00003960}, {60,0.00000000}, {61,0.00003960}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00003960}, {66,0.00003960}, {67,0.00011881}, {68,0.00003960}, {69,0.00003960}, {70,0.00003960}, {71,0.00007921}, {72,0.00003960}, {73,0.00003960}, {74,0.00000000}, {75,0.00007921}, {76,0.00011881}, {77,0.00015842}, {78,0.00000000}, {79,0.00015842}, {80,0.00011881}, {81,0.00003960}, {82,0.00007921}, {83,0.00007921}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00003960}, {88,0.00007921}, {89,0.00003960}, {90,0.00011881}, {91,0.00023762}, {92,0.00010891}, {93,0.00015842}, {94,0.00003960}, {95,0.00015842}, {96,0.00007921}, {97,0.00000000}, {98,0.00003960}, {99,0.00011881}, {100,0.00006931}, {101,0.00000000}, {102,0.00015842}, {103,0.00000000}, {104,0.00007921}, {105,0.00007921}, {106,0.00000000}, {107,0.00011881}, {108,0.00000000}, {109,0.00011881}, {110,0.00009901}, {111,0.00007921}, {112,0.00003960}, {113,0.00003960}, {114,0.00007921}, {115,0.00011881}, {116,0.00007921}, {117,0.00011881}, {118,0.00000000}, {119,0.00007921}, {120,0.00015842}, {121,0.00000000}, {122,0.00015842}, {123,0.00011881}, {124,0.00003960}, {125,0.00000000}, {126,0.00007921}, {127,0.00000000}, {128,0.00007921}, {129,0.00011881}, {130,0.00007921}, {131,0.00007921}, {132,0.00000000}, {133,0.00019802}, {134,0.00007921}, {135,0.00007921}, {136,0.00007921}, {137,0.00011881}, {138,0.00007921}, {139,0.00007921}, {140,0.00000000}, {141,0.00002970}, {142,0.00003960}, {143,0.00000000}, {144,0.00007921}, {145,0.00015842}, {146,0.00007921}, {147,0.00007921}, {148,0.00015842}, {149,0.00011881}, {150,0.00003960}, {151,0.00003960}, {152,0.00003960}, {153,0.00007921}, {154,0.00007921}, {155,0.00011881}, {156,0.00010891}, {157,0.00007921}, {158,0.00000000}, {159,0.00007921}, {160,0.00011881}, {161,0.00003960}, {162,0.00007921}, {163,0.00003960}, {164,0.00003960}, {165,0.00003960}, {166,0.00000000}, {167,0.00015842}, {168,0.00007921}, {169,0.00010891}, {170,0.00007921}, {171,0.00007921}, {172,0.00003960}, {173,0.00007921}, {174,0.00003960}, {175,0.00007921}, {176,0.00002970}, {177,0.00007921}, {178,0.00007921}, {179,0.00019802}, {180,0.00007921}, {181,0.00007921}, {182,0.00007921}, {183,0.00000000}, {184,0.00023762}, {185,0.00003960}, {186,0.00011881}, {187,0.00003960}, {188,0.00003960}, {189,0.00000000}, {190,0.00007921}, {191,0.00006931}, {192,0.00003960}, {193,0.00011881}, {194,0.00007921}, {195,0.00007921}, {196,0.00003960}, {197,0.00014851}, {198,0.00010891}, {199,0.00007921}, {200,0.00000000}, {201,0.00011881}, {202,0.00007921}, {203,0.00007921}, {204,0.00007921}, {205,0.00011881}, {206,0.00007921}, {207,0.00003960}, {208,0.00007921}, {209,0.00015842}, {210,0.00003960}, {211,0.00011881}, {212,0.00003960}, {213,0.00000000}, {214,0.00007921}, {215,0.00007921}, {216,0.00011881}, {217,0.00003960}, {218,0.00000000}, {219,0.00007921}, {220,0.00000000}, {221,0.00023762}, {222,0.00010891}, {223,0.00015842}, {224,0.00000000}, {225,0.00007921}, {226,0.00015842}, {227,0.00003960}, {228,0.00007921}, {229,0.00011881}, {230,0.00000000}, {231,0.00019802}, {232,0.00007921}, {233,0.00014851}, {234,0.00007921}, {235,0.00007921}, {236,0.00011881}, {237,0.00003960}, {238,0.00019802}, {239,0.00011881}, {240,0.00003960}, {241,0.00007921}, {242,0.00007921}, {243,0.00014851}, {244,0.00015842}, {245,0.00019802}, {246,0.00007921}, {247,0.00007921}, {248,0.00019802}, {249,0.00007921}, {250,0.00011881}, {251,0.00003960}, {252,0.00023762}, {253,0.00003960}, {254,0.00019802}, {255,0.00027723}, {256,0.00006931}, {257,0.00039604}, {258,0.00000000}, {259,0.00003960}, {260,0.00007921}, {261,0.00007921}, {262,0.00056436}, {263,0.00011881}, {264,0.00011881}, {265,0.00003960}, {266,0.00039604}, {267,0.00003960}, {268,0.00007921}, {269,0.00011881}, {270,0.00015842}, {271,0.00007921}, {272,0.00023762}, {273,0.00019802}, {274,0.00011881}, {275,0.00034653}, {276,0.00019802}, {277,0.00003960}, {278,0.00015842}, {279,0.00011881}, {280,0.00031683}, {281,0.00014851}, {282,0.00007921}, {283,0.00007921}, {284,0.00079208}, {285,0.00007921}, {286,0.00011881}, {287,0.00003960}, {288,0.00019802}, {289,0.00022772}, {290,0.00010891}, {291,0.00011881}, {292,0.00003960}, {293,0.00011881}, {294,0.00015842}, {295,0.00015842}, {296,0.00019802}, {297,0.00007921}, {298,0.00015842}, {299,0.00043564}, {300,0.00018812}, {301,0.0001143}, {302,0.0003429}, {303,0.0002286}, {304,0.0004286}, {305,0.0002286}, {306,0.0001143}, {307,0.0002286}, {308,0.0001143}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0005714}, {313,0.0001143}, {314,0.0000000}, {315,0.0002286}, {316,0.0002286}, {317,0.0000000}, {318,0.0003429}, {319,0.0002286}, {320,0.0000000}, {321,0.0001143}, {322,0.0002286}, {323,0.0001143}, {324,0.0003429}, {325,0.0000000}, {326,0.0002286}, {327,0.0000000}, {328,0.0003429}, {329,0.0005429}, {330,0.0003429}, {331,0.0000000}, {332,0.0000000}, {333,0.0001143}, {334,0.0005714}, {335,0.0004571}, {336,0.0003429}, {337,0.0006857}, {338,0.0002286}, {339,0.0001143}, {340,0.0000000}, {341,0.0002286}, {342,0.0003143}, {343,0.0000000}, {344,0.0002286}, {345,0.0000000}, {346,0.0001143}, {347,0.0001143}, {348,0.0001143}, {349,0.0003429}, {350,0.0001143}, {351,0.0001143}, {352,0.0000000}, {353,0.0002286}, {354,0.0001143}, {355,0.0000000}, {356,0.0003429}, {357,0.0000857}, {358,0.0001143}, {359,0.0000000}, {360,0.0002286}, {361,0.0001143}, {362,0.0003429}, {363,0.0005714}, {364,0.0002286}, {365,0.0001143}, {366,0.0000000}, {367,0.0000000}, {368,0.0006857}, {369,0.0003429}, {370,0.0000000}, {371,0.0000857}, {372,0.0001143}, {373,0.0000000}, {374,0.0000000}, {375,0.0002286}, {376,0.0002286}, {377,0.0000000}, {378,0.0002286}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0001143}, {383,0.0008000}, {384,0.0002286}, {385,0.0002286}, {386,0.0003429}, {387,0.0005714}, {388,0.0002286}, {389,0.0001143}, {390,0.0003429}, {391,0.0001143}, {392,0.0001143}, {393,0.0006857}, {394,0.0003429}, {395,0.0001143}, {396,0.0003429}, {397,0.0001143}, {398,0.0001143}, {399,0.0001143}, {400,0.0002286}, {401,0.0001143}, {402,0.0003429}, {403,0.0002286}, {404,0.0005714}, {405,0.0001143}, {406,0.0001143}, {407,0.0001143}, {408,0.0003429}, {409,0.0004571}, {410,0.0002000}, {411,0.0005714}, {412,0.0004571}, {413,0.0001143}, {414,0.0003143}, {415,0.0011429}, {416,0.0005714}, {417,0.0001143}, {418,0.0003429}, {419,0.0009143}, {420,0.0000000}, {421,0.0001143}, {422,0.0002286}, {423,0.0004571}, {424,0.0003429}, {425,0.0008000}, {426,0.0010286}, {427,0.0002286}, {428,0.0004571}, {429,0.0005714}, {430,0.0001143}, {431,0.0004571}, {432,0.0002286}, {433,0.0001143}, {434,0.0002286}, {435,0.0001143}, {436,0.0004571}, {437,0.0002286}, {438,0.0000000}, {439,0.0006857}, {440,0.0003429}, {441,0.0006857}, {442,0.0001143}, {443,0.0004571}, {444,0.0002286}, {445,0.0004571}, {446,0.0001143}, {447,0.0002286}, {448,0.0010286}, {449,0.0000000}, {450,0.0002286}, {451,0.0000000}, {452,0.0003429}, {453,0.0004571}, {454,0.0001143}, {455,0.0002286}, {456,0.0006857}, {457,0.0004286}, {458,0.0003429}, {459,0.0002286}, {460,0.0004571}, {461,0.0006571}, {462,0.0003143}, {463,0.0006857}, {464,0.0005714}, {465,0.0009143}, {466,0.0010286}, {467,0.0003429}, {468,0.0019143}, {469,0.0010286}, {470,0.0012286}, {471,0.0012571}, {472,0.0017143}, {473,0.0014571}, {474,0.0016857}, {475,0.0009143}, {476,0.0014857}, {477,0.0003429}, {478,0.0004571}, {479,0.0005714}, {480,0.0002286}, {481,0.0010286}, {482,0.0002286}, {483,0.0013714}, {484,0.0005714}, {485,0.0010286}, {486,0.0009143}, {487,0.0010286}, {488,0.0012571}, {489,0.0006857}, {490,0.0005714}, {491,0.0006857}, {492,0.0002286}, {493,0.0004571}, {494,0.0008000}, {495,0.0011429}, {496,0.0008000}, {497,0.0008000}, {498,0.0006857}, {499,0.0013429}, {500,0.0003429}, {505,0.0009143}, {510,0.0004571}, {515,0.0013714}, {520,0.0011429}, {525,0.0016000}, {530,0.0016857}, {535,0.0011429}, {540,0.0024857}, {545,0.0014857}, {550,0.0018000}, {555,0.0004571}, {560,0.0019429}, {565,0.0009143}, {570,0.0011429}, {575,0.0016000}, {580,0.0014857}, {585,0.0020286}, {590,0.0014857}, {595,0.0010000}, {600,0.0008000}, {605,0.0015714}, {610,0.0019429}, {615,0.0014571}, {620,0.0018286}, {625,0.0019429}, {630,0.0019429}, {635,0.0011143}, {640,0.0006857}, {645,0.0006857}, {650,0.0001143}, {655,0.0016000}, {660,0.0008000}, {665,0.0013714}, {670,0.0014857}, {675,0.0013714}, {680,0.0014857}, {685,0.0010286}, {690,0.0026286}, {695,0.0016000}, {700,0.0022571}, {705,0.0018286}, {710,0.0009143}, {715,0.0022857}, {720,0.0004571}, {725,0.0008000}, {730,0.0010286}, {735,0.0014571}, {740,0.0005429}, {745,0.0008000}, {750,0.0021714}, {755,0.0004571}, {760,0.0008000}, {765,0.0017143}, {770,0.0025143}, {775,0.0016000}, {780,0.0006286}, {785,0.0022857}, {790,0.0040000}, {795,0.0019429}, {800,0.0027429}, {805,0.0018286}, {810,0.0029714}, {815,0.0048857}, {820,0.0021143}, {825,0.0045714}, {830,0.0020571}, {835,0.0008000}, {840,0.0034286}, {845,0.0034286}, {850,0.0038286}, {855,0.0037143}, {860,0.0033143}, {865,0.0048000}, {870,0.0045714}, {875,0.0054857}, {880,0.0025143}, {885,0.0045714}, {890,0.0062571}, {895,0.0021714}, {900,0.0029143}, {905,0.0040857}, {910,0.0020571}, {915,0.0027143}, {920,0.0045714}, {925,0.0045714}, {930,0.0030857}, {935,0.0048000}, {940,0.0058857}, {945,0.0045429}, {950,0.0026000}, {955,0.0049714}, {960,0.0048857}, {965,0.0045714}, {970,0.0055714}, {975,0.0047714}, {980,0.0066000}, {985,0.0060857}, {990,0.0058286}, {995,0.0072857}, {1000,0.0074286}, {1010,0.0062857}, {1020,0.0056857}, {1030,0.0060857}, {1040,0.0058857}, {1050,0.0074000}, {1060,0.0042857}, {1070,0.0042571}, {1080,0.0056571}, {1090,0.0047429}, {1100,0.0062571}, {1110,0.0037714}, {1120,0.0059714}, {1130,0.0062000}, {1140,0.0066000}, {1150,0.0063143}, {1160,0.0053429}, {1170,0.0083429}, {1180,0.0076857}, {1190,0.0057714}, {1200,0.0077714}, {1210,0.0052571}, {1220,0.0067143}, {1230,0.0047714}, {1240,0.0066857}, {1250,0.0099429}, {1260,0.0116000}, {1270,0.0114857}, {1280,0.0141714}, {1290,0.0122286}, {1300,0.0102857}, {1310,0.0084857}, {1320,0.0126000}, {1330,0.0110857}, {1340,0.0128000}, {1350,0.0141143}, {1360,0.0130000}, {1370,0.0135714}, {1380,0.0096286}, {1390,0.0148000}, {1400,0.0139429}, {1410,0.0132857}, {1420,0.0140286}, {1430,0.0106857}, {1440,0.0142286}, {1450,0.0209429}, {1460,0.0119714}, {1470,0.0117714}, {1480,0.0149714}, {1490,0.0176857}, {1500,0.0146571}, {1510,0.0138571}, {1520,0.0153714}, {1530,0.0170857}, {1540,0.0140857}, {1550,0.0206571}, {1560,0.0162286}, {1570,0.0201429}, {1580,0.0155714}, {1590,0.0195143}, {1600,0.0165143}, {1610,0.0130000}, {1620,0.0140857}, {1630,0.0156000}, {1640,0.0204000}, {1650,0.0217429}, {1660,0.0140571}, {1670,0.0193429}, {1680,0.0200000}, {1690,0.0151429}, {1700,0.0140000}, {1710,0.0203714}, {1720,0.0181143}, {1730,0.0232286}, {1740,0.0166571}, {1750,0.0254286}, {1760,0.0210857}, {1770,0.0235714}, {1780,0.0307429}, {1790,0.0262000}, {1800,0.0195714}, {1810,0.0143143}, {1820,0.0277429}, {1830,0.0260571}, {1840,0.0262857}, {1850,0.0240000}, {1860,0.0194000}, {1870,0.0238000}, {1880,0.0259714}, {1890,0.0231143}, {1900,0.0322000}, {1910,0.0262571}, {1920,0.0308286}, {1930,0.0212857}, {1940,0.0280286}, {1950,0.0252286}, {1960,0.0251714}, {1970,0.0223429}, {1980,0.0274000}, {1990,0.0271143}, {2000,0.0247143}};
data["big"]["LtacTacInTermPrimPair"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00023762}, {3,0.00100000}, {4,0.01938614}, {5,0.00200000}, {6,0.00200000}, {7,0.00251485}, {8,0.00300000}, {9,0.00330693}, {10,0.00400000}, {11,0.00414851}, {12,0.00500000}, {13,0.00517822}, {14,0.00597030}, {15,0.00770297}, {16,0.00690099}, {17,0.00760396}, {18,0.00793069}, {19,0.00854455}, {20,0.00910891}, {21,0.00970297}, {22,0.01030693}, {23,0.01414851}, {24,0.01148515}, {25,0.01194059}, {26,0.01263366}, {27,0.01341584}, {28,0.01377228}, {29,0.01445545}, {30,0.01523762}, {31,0.01572277}, {32,0.01655446}, {33,0.01712871}, {34,0.01787129}, {35,0.01851485}, {36,0.01911881}, {37,0.01979208}, {38,0.02045545}, {39,0.02110891}, {40,0.02201980}, {41,0.02280198}, {42,0.02911881}, {43,0.02418812}, {44,0.02500000}, {45,0.02570297}, {46,0.02640594}, {47,0.02758416}, {48,0.03604950}, {49,0.02898020}, {50,0.03335644}, {51,0.03068317}, {52,0.03896040}, {53,0.03263366}, {54,0.03363366}, {55,0.04533663}, {56,0.03532673}, {57,0.03644554}, {58,0.03726733}, {59,0.03893069}, {60,0.04737624}, {61,0.05019802}, {62,0.05134653}, {63,0.05123762}, {64,0.04821782}, {65,0.04379208}, {66,0.04535644}, {67,0.04618812}, {68,0.05992079}, {69,0.04819802}, {70,0.04964356}, {71,0.06663366}, {72,0.05146535}, {73,0.06971287}, {74,0.05419802}, {75,0.06679208}, {76,0.05596040}, {77,0.05731683}, {78,0.06708911}, {79,0.09159406}, {80,0.06757426}, {81,0.06218812}, {82,0.06325743}, {83,0.06461386}, {84,0.06572277}, {85,0.07696040}, {86,0.09741584}, {87,0.08954455}, {88,0.08567327}, {89,0.09086139}, {90,0.11122772}, {91,0.09762376}, {92,0.08893069}, {93,0.08971287}, {94,0.09130693}, {95,0.09245545}, {96,0.09278218}, {97,0.09306931}, {98,0.09408911}, {99,0.09452475}, {100,0.09515842}, {101,0.09609901}, {102,0.09636634}, {103,0.09734653}, {104,0.09785149}, {105,0.09860396}, {106,0.09939604}, {107,0.10017822}, {108,0.10072277}, {109,0.10133663}, {110,0.10262376}, {111,0.10459406}, {112,0.10600990}, {113,0.10784158}, {114,0.10916832}, {115,0.11099010}, {116,0.11272277}, {117,0.11455446}, {118,0.11650495}, {119,0.11790099}, {120,0.11986139}, {121,0.12139604}, {122,0.12308911}, {123,0.12578218}, {124,0.14049505}, {125,0.14316832}, {126,0.14441584}, {127,0.15961386}, {128,0.16505941}, {129,0.16465347}, {130,0.16685149}, {131,0.17019802}, {132,0.17349505}, {133,0.17301980}, {134,0.17826733}, {135,0.17852475}, {136,0.18128713}, {137,0.18504950}, {138,0.18530693}, {139,0.18968317}, {140,0.19203960}, {141,0.19376238}, {142,0.19575248}, {143,0.19680198}, {144,0.20141584}, {145,0.20424752}, {146,0.20779208}, {147,0.21002970}, {148,0.21116832}, {149,0.21325743}, {150,0.21563366}, {151,0.21701980}, {152,0.21881188}, {153,0.21905941}, {154,0.22081188}, {155,0.22906931}, {156,0.23216832}, {157,0.23689109}, {158,0.23705941}, {159,0.24169307}, {160,0.24390099}, {161,0.24549505}, {162,0.24794059}, {163,0.25251485}, {164,0.25582178}, {165,0.25953465}, {166,0.26141584}, {167,0.26589109}, {168,0.26689109}, {169,0.26499010}, {170,0.27150495}, {171,0.27844554}, {172,0.27782178}, {173,0.28218812}, {174,0.28501980}, {175,0.28712871}, {176,0.29191089}, {177,0.29380198}, {178,0.29587129}, {179,0.29868317}, {180,0.30291089}, {181,0.30753465}, {182,0.31091089}, {183,0.31430693}, {184,0.31775248}, {185,0.32043564}, {186,0.32400000}, {187,0.32614851}, {188,0.32785149}, {189,0.33048515}, {190,0.33502970}, {191,0.33923762}, {192,0.34000000}, {193,0.34066337}, {194,0.34440594}, {195,0.35060396}, {196,0.35798020}, {197,0.36891089}, {198,0.36620792}, {199,0.36535644}, {200,0.36957426}, {201,0.37570297}, {202,0.37571287}, {203,0.38529703}, {204,0.39732673}, {205,0.38205941}, {206,0.39114851}, {207,0.39134653}, {208,0.40231683}, {209,0.41635644}, {210,0.40709901}, {211,0.40757426}, {212,0.41005941}, {213,0.43391089}, {214,0.42067327}, {215,0.41972277}, {216,0.43214851}, {217,0.44063366}, {218,0.43804950}, {219,0.44322772}, {220,0.45620792}, {221,0.45109901}, {222,0.45666337}, {223,0.46441584}, {224,0.46301980}, {225,0.47508911}, {226,0.47087129}, {227,0.47494059}, {228,0.48645545}, {229,0.48349505}, {230,0.49714851}, {231,0.49172277}, {232,0.50666337}, {233,0.49700990}, {234,0.51444554}, {235,0.50667327}, {236,0.52235644}, {237,0.51423762}, {238,0.52659406}, {239,0.52608911}, {240,0.53240594}, {241,0.54000000}, {242,0.53936634}, {243,0.55017822}, {244,0.55301980}, {245,0.55492079}, {246,0.56184158}, {247,0.56590099}, {248,0.56853465}, {249,0.57994059}, {250,0.57446535}, {251,0.58177228}, {252,0.59621782}, {253,0.59142574}, {254,0.59563366}, {255,0.60727723}, {256,0.60666337}, {257,0.60918812}, {258,0.61966337}, {259,0.62550495}, {260,0.63248515}, {261,0.62996040}, {262,0.63405941}, {263,0.64211881}, {264,0.64280198}, {265,0.65221782}, {266,0.65857426}, {267,0.66163366}, {268,0.66396040}, {269,0.66859406}, {270,0.67670297}, {271,0.68063366}, {272,0.68630693}, {273,0.69195050}, {274,0.69633663}, {275,0.70416832}, {276,0.71113861}, {277,0.71629703}, {278,0.71774257}, {279,0.72334653}, {280,0.72736634}, {281,0.73366337}, {282,0.73880198}, {283,0.74343564}, {284,0.74811881}, {285,0.75750495}, {286,0.75725743}, {287,0.75860396}, {288,0.76678218}, {289,0.77416832}, {290,0.78859406}, {291,0.79463366}, {292,0.80247525}, {293,0.81182178}, {294,0.81411881}, {295,0.82050495}, {296,0.83567327}, {297,0.82832673}, {298,0.83237624}, {299,0.84243564}, {300,0.84393069}, {301,0.8640571}, {302,0.9846571}, {303,0.9341143}, {304,0.9324571}, {305,0.8998857}, {306,0.9017714}, {307,0.9032000}, {308,0.9135429}, {309,0.9219714}, {310,0.9190571}, {311,0.9306571}, {312,0.9385429}, {313,0.9434286}, {314,0.9452286}, {315,0.9570571}, {316,0.9606571}, {317,0.9628571}, {318,0.9704571}, {319,0.9820571}, {320,0.9838286}, {321,0.9880000}, {322,0.9994000}, {323,1.0032286}, {324,1.0121429}, {325,1.0212286}, {326,1.0214286}, {327,1.0373429}, {328,1.0378571}, {329,1.0400286}, {330,1.0548286}, {331,1.0520857}, {332,1.0728857}, {333,1.0555429}, {334,1.0730000}, {335,1.0738857}, {336,1.0830857}, {337,1.0903714}, {338,1.0925714}, {339,1.1033714}, {340,1.1043714}, {341,1.1222286}, {342,1.1293143}, {343,1.1378000}, {344,1.1504857}, {345,1.1528571}, {346,1.1531714}, {347,1.1641714}, {348,1.1737714}, {349,1.1792286}, {350,1.1854286}, {351,1.2027714}, {352,1.2073143}, {353,1.2060571}, {354,1.2193429}, {355,1.2173714}, {356,1.2271429}, {357,1.2366000}, {358,1.2485143}, {359,1.2468571}, {360,1.2668571}, {361,1.2676571}, {362,1.2714000}, {363,1.2930286}, {364,1.2890571}, {365,1.2984857}, {366,1.3027143}, {367,1.3202571}, {368,1.3154286}, {369,1.3272286}, {370,1.3444857}, {371,1.3477714}, {372,1.3563714}, {373,1.3607143}, {374,1.3722286}, {375,1.3856286}, {376,1.3883714}, {377,1.3959143}, {378,1.4046857}, {379,1.4100857}, {380,1.4178857}, {381,1.4286000}, {382,1.4408857}, {383,1.4510857}, {384,1.4610286}, {385,1.4727714}, {386,1.4770571}, {387,1.4955714}, {388,1.4940857}, {389,1.5052286}, {390,1.5167429}, {391,1.5191143}, {392,1.5226857}, {393,1.5363143}, {394,1.5501714}, {395,1.5568571}, {396,1.5660857}, {397,1.5717714}, {398,1.5752857}, {399,1.5886571}, {400,1.5973429}, {401,1.6077714}, {402,1.6176286}, {403,1.6284571}, {404,1.6311429}, {405,1.6520286}, {406,1.6574286}, {407,1.6653714}, {408,1.6734000}, {409,1.6794000}, {410,1.6853429}, {411,1.6962571}, {412,1.6953143}, {413,1.7110571}, {414,1.7176286}, {415,1.7325143}, {416,1.7340857}, {417,1.7463429}, {418,1.7486571}, {419,1.8076000}, {420,1.8013143}, {421,1.7871143}, {422,1.7964000}, {423,1.8040571}, {424,1.8108286}, {425,1.8287429}, {426,1.8316000}, {427,1.8578000}, {428,1.8590286}, {429,1.8738286}, {430,1.8785429}, {431,1.8972571}, {432,1.8992286}, {433,1.9104000}, {434,1.9158857}, {435,1.9284571}, {436,1.9323429}, {437,1.9472571}, {438,1.9590857}, {439,1.9756857}, {440,1.9906571}, {441,1.9941143}, {442,2.0040571}, {443,2.0099143}, {444,2.0188000}, {445,2.0377714}, {446,2.0382000}, {447,2.0517714}, {448,2.0558857}, {449,2.0759429}, {450,2.0830571}, {451,2.0928286}, {452,2.0974857}, {453,2.1099143}, {454,2.1232000}, {455,2.1376286}, {456,2.1526286}, {457,2.1596000}, {458,2.1723714}, {459,2.1805143}, {460,2.1958286}, {461,2.1976286}, {462,2.2021143}, {463,2.2240286}, {464,2.2350857}, {465,2.2450857}, {466,2.2526000}, {467,2.2928000}, {468,2.3093429}, {469,2.2906286}, {470,2.3042000}, {471,2.3299714}, {472,2.3166571}, {473,2.3305429}, {474,2.3378571}, {475,2.3367143}, {476,2.3472286}, {477,2.3698286}, {478,2.4048571}, {479,2.3802286}, {480,2.4543714}, {481,2.5117714}, {482,2.4291714}, {483,2.5379429}, {484,2.4657429}, {485,2.5436571}, {486,2.5020857}, {487,2.5781714}, {488,2.5954571}, {489,2.5662857}, {490,2.5265143}, {491,2.5356857}, {492,2.5746286}, {493,2.6062571}, {494,2.6297143}, {495,2.6398571}, {496,2.6853714}, {497,2.7402286}, {498,2.6581429}, {499,2.6878000}, {500,2.6692857}, {505,2.7720000}, {510,2.7924571}, {515,2.9409429}, {520,3.0301429}, {525,3.1719429}, {530,3.1480286}, {535,3.1928286}, {540,3.2231429}, {545,3.2804000}, {550,3.3354000}, {555,3.3885714}, {560,3.4329429}, {565,3.5757143}, {570,3.6289714}, {575,3.6752571}, {580,3.7458571}, {585,3.8700857}, {590,3.9045714}, {595,4.0018000}, {600,4.0671714}, {605,4.2724571}, {610,4.2563714}, {615,4.3128857}, {620,4.4109429}, {625,4.4874571}, {630,4.6392571}, {635,4.6768571}, {640,4.7800571}, {645,4.7754857}, {650,4.8817429}, {655,5.0934286}, {660,5.1631143}, {665,5.1490000}, {670,5.1474286}, {675,5.2538286}, {680,5.3673714}, {685,5.5008000}, {690,5.6558571}, {695,5.6557714}, {700,5.8183714}, {705,5.8142286}, {710,5.9892000}, {715,6.0950571}, {720,6.1446286}, {725,6.2276286}, {730,6.3419714}, {735,6.6045143}, {740,6.6244286}, {745,6.7055429}, {750,6.8512571}, {755,6.9758857}, {760,7.0722000}, {765,7.2121429}, {770,7.3238286}, {775,7.4410000}, {780,7.5232286}, {785,7.6595143}, {790,7.7793429}, {795,7.9012286}, {800,8.1282000}, {805,8.1340000}, {810,8.2944286}, {815,8.3887429}, {820,8.5493143}, {825,8.6620000}, {830,8.7907714}, {835,8.9030571}, {840,9.0381714}, {845,9.2058571}, {850,9.4008286}, {855,9.5169429}, {860,9.6402571}, {865,9.8026286}, {870,9.9538857}, {875,10.2118571}, {880,10.2785143}, {885,10.7308857}, {890,10.5327143}, {895,10.7360857}, {900,11.1396000}, {905,11.0995143}, {910,11.3029143}, {915,11.3996000}, {920,11.8932571}, {925,11.9568571}, {930,12.0558286}, {935,12.0505714}, {940,12.5484286}, {945,12.3102286}, {950,12.5506571}, {955,12.8372571}, {960,13.3584286}, {965,13.3982000}, {970,13.2863714}, {975,13.5657143}, {980,13.8833143}, {985,14.3247143}, {990,14.2662571}, {995,14.6765429}, {1000,14.6470571}, {1010,15.2766857}, {1020,15.5248571}, {1030,16.0742857}, {1040,16.2922286}, {1050,16.7908571}, {1060,17.4106000}, {1070,17.8625714}, {1080,18.5382571}, {1090,18.2510571}, {1100,19.0232000}, {1110,19.3781143}, {1120,19.9396286}, {1130,20.3554857}, {1140,20.8434571}, {1150,21.3522857}, {1160,21.8525714}, {1170,22.2993714}, {1180,23.1223143}, {1190,23.4700000}, {1200,24.0484571}, {1210,24.7263143}, {1220,25.1303714}, {1230,25.4190857}, {1240,26.1654857}, {1250,27.0497429}, {1260,27.5924857}, {1270,28.1500000}, {1280,28.5704286}, {1290,28.9914000}, {1300,29.6865714}, {1310,30.3887429}, {1320,31.0414857}, {1330,31.9721143}, {1340,32.5580857}, {1350,33.0871714}, {1360,33.5919429}, {1370,34.2562286}, {1380,35.0224286}, {1390,35.7031714}, {1400,36.4398286}, {1410,37.0507143}, {1420,38.0879143}, {1430,38.8599429}, {1440,39.4770857}, {1450,40.0362286}, {1460,40.8254286}, {1470,42.0520571}, {1480,42.4572857}, {1490,43.3034571}, {1500,43.7393143}, {1510,45.0443429}, {1520,45.6194000}, {1530,47.0427143}, {1540,47.9986571}, {1550,48.8295429}, {1560,49.4781714}, {1570,50.2119429}, {1580,51.5669429}, {1590,52.5076571}, {1600,53.0784286}, {1610,54.2233714}, {1620,55.2568857}, {1630,55.5542571}, {1640,56.1558857}, {1650,57.7148000}, {1660,58.7230571}, {1670,59.6875714}, {1680,60.4438571}, {1690,62.3062857}, {1700,63.5973714}, {1710,64.4975714}, {1720,65.5587714}, {1730,66.3916000}, {1740,67.5661429}, {1750,68.2045714}, {1760,69.0712571}, {1770,70.5436286}, {1780,71.6422857}, {1790,72.8949143}, {1800,73.9901429}, {1810,75.3968286}, {1820,76.6139714}, {1830,77.1152571}, {1840,78.7140000}, {1850,80.6224857}, {1860,81.8758857}, {1870,83.2038571}, {1880,84.3255143}, {1890,86.3819143}, {1900,86.4166286}, {1910,88.4289429}, {1920,89.4172571}, {1930,90.8887429}, {1940,91.5520857}, {1950,92.8437143}, {1960,95.2516857}, {1970,94.9509714}, {1980,96.8385143}, {1990,98.1765714}, {2000,99.7883143}};
data["big"]["LtacTacInTermPrimPair"]["actual reif"]["user"] = {{1,0.00058416}, {2,0.00092079}, {3,0.00131683}, {4,0.01895050}, {5,0.00202970}, {6,0.00250495}, {7,0.00334653}, {8,0.00321782}, {9,0.00372277}, {10,0.00403960}, {11,0.00414851}, {12,0.00476238}, {13,0.00532673}, {14,0.00615842}, {15,0.00794059}, {16,0.00684158}, {17,0.00759406}, {18,0.00822772}, {19,0.00847525}, {20,0.00940594}, {21,0.00993069}, {22,0.01032673}, {23,0.01416832}, {24,0.01136634}, {25,0.01172277}, {26,0.01238614}, {27,0.01260396}, {28,0.01377228}, {29,0.01446535}, {30,0.01493069}, {31,0.01552475}, {32,0.01651485}, {33,0.01666337}, {34,0.01734653}, {35,0.01810891}, {36,0.01867327}, {37,0.01920792}, {38,0.02051485}, {39,0.02159406}, {40,0.02241584}, {41,0.02280198}, {42,0.02919802}, {43,0.02463366}, {44,0.02546535}, {45,0.02560396}, {46,0.02634653}, {47,0.02761386}, {48,0.03578218}, {49,0.02934653}, {50,0.03348515}, {51,0.03078218}, {52,0.03876238}, {53,0.03281188}, {54,0.03362376}, {55,0.04517822}, {56,0.03529703}, {57,0.03603960}, {58,0.03711881}, {59,0.03876238}, {60,0.04732673}, {61,0.05026733}, {62,0.05163366}, {63,0.05144554}, {64,0.04857426}, {65,0.04374257}, {66,0.04502970}, {67,0.04613861}, {68,0.06008911}, {69,0.04842574}, {70,0.04989109}, {71,0.06656436}, {72,0.05181188}, {73,0.06919802}, {74,0.05439604}, {75,0.06635644}, {76,0.05599010}, {77,0.05705941}, {78,0.06678218}, {79,0.09134653}, {80,0.06731683}, {81,0.06213861}, {82,0.06289109}, {83,0.06428713}, {84,0.06519802}, {85,0.07726733}, {86,0.09728713}, {87,0.08915842}, {88,0.08576238}, {89,0.09039604}, {90,0.11092079}, {91,0.09690099}, {92,0.08845545}, {93,0.08929703}, {94,0.09060396}, {95,0.09208911}, {96,0.09250495}, {97,0.09287129}, {98,0.09361386}, {99,0.09434653}, {100,0.09538614}, {101,0.09614851}, {102,0.09637624}, {103,0.09750495}, {104,0.09783168}, {105,0.09835644}, {106,0.09946535}, {107,0.10000990}, {108,0.10049505}, {109,0.10168317}, {110,0.10258416}, {111,0.10456436}, {112,0.10567327}, {113,0.10757426}, {114,0.10876238}, {115,0.11054455}, {116,0.11227723}, {117,0.11392079}, {118,0.11597030}, {119,0.11786139}, {120,0.11994059}, {121,0.12142574}, {122,0.12281188}, {123,0.12560396}, {124,0.14031683}, {125,0.14292079}, {126,0.14465347}, {127,0.15925743}, {128,0.16459406}, {129,0.16428713}, {130,0.16651485}, {131,0.16992079}, {132,0.17303960}, {133,0.17258416}, {134,0.17815842}, {135,0.17799010}, {136,0.18093069}, {137,0.18466337}, {138,0.18477228}, {139,0.18919802}, {140,0.19136634}, {141,0.19315842}, {142,0.19554455}, {143,0.19651485}, {144,0.20109901}, {145,0.20393069}, {146,0.20738614}, {147,0.20967327}, {148,0.21056436}, {149,0.21282178}, {150,0.21503960}, {151,0.21675248}, {152,0.21826733}, {153,0.21836634}, {154,0.22029703}, {155,0.22864356}, {156,0.23203960}, {157,0.23630693}, {158,0.23665347}, {159,0.24087129}, {160,0.24343564}, {161,0.24512871}, {162,0.24740594}, {163,0.25196040}, {164,0.25532673}, {165,0.25907921}, {166,0.26079208}, {167,0.26524752}, {168,0.26607921}, {169,0.26406931}, {170,0.27085149}, {171,0.27797030}, {172,0.27710891}, {173,0.28170297}, {174,0.28452475}, {175,0.28658416}, {176,0.29118812}, {177,0.29312871}, {178,0.29539604}, {179,0.29800000}, {180,0.30207921}, {181,0.30686139}, {182,0.31038614}, {183,0.31374257}, {184,0.31689109}, {185,0.32041584}, {186,0.32330693}, {187,0.32530693}, {188,0.32720792}, {189,0.32981188}, {190,0.33413861}, {191,0.33869307}, {192,0.33946535}, {193,0.34006931}, {194,0.34376238}, {195,0.35005941}, {196,0.35739604}, {197,0.36778218}, {198,0.36542574}, {199,0.36445545}, {200,0.36901980}, {201,0.37480198}, {202,0.37519802}, {203,0.38432673}, {204,0.39672277}, {205,0.38141584}, {206,0.39058416}, {207,0.39074257}, {208,0.40126733}, {209,0.41550495}, {210,0.40644554}, {211,0.40691089}, {212,0.40962376}, {213,0.43313861}, {214,0.42001980}, {215,0.41904950}, {216,0.43152475}, {217,0.44014851}, {218,0.43724752}, {219,0.44260396}, {220,0.45538614}, {221,0.45004950}, {222,0.45587129}, {223,0.46365347}, {224,0.46239604}, {225,0.47450495}, {226,0.46976238}, {227,0.47411881}, {228,0.48591089}, {229,0.48281188}, {230,0.49650495}, {231,0.49081188}, {232,0.50569307}, {233,0.49626733}, {234,0.51357426}, {235,0.50575248}, {236,0.52169307}, {237,0.51325743}, {238,0.52600000}, {239,0.52513861}, {240,0.53175248}, {241,0.53875248}, {242,0.53861386}, {243,0.54958416}, {244,0.55217822}, {245,0.55370297}, {246,0.56089109}, {247,0.56518812}, {248,0.56724752}, {249,0.57904950}, {250,0.57298020}, {251,0.58079208}, {252,0.59461386}, {253,0.59049505}, {254,0.59441584}, {255,0.60579208}, {256,0.60537624}, {257,0.60781188}, {258,0.61875248}, {259,0.62435644}, {260,0.63115842}, {261,0.62912871}, {262,0.63220792}, {263,0.64096040}, {264,0.64204950}, {265,0.65126733}, {266,0.65723762}, {267,0.66058416}, {268,0.66289109}, {269,0.66742574}, {270,0.67565347}, {271,0.67958416}, {272,0.68500000}, {273,0.69089109}, {274,0.69519802}, {275,0.70274257}, {276,0.71012871}, {277,0.71493069}, {278,0.71649505}, {279,0.72200000}, {280,0.72588119}, {281,0.73222772}, {282,0.73771287}, {283,0.74241584}, {284,0.74603960}, {285,0.75603960}, {286,0.75600990}, {287,0.75734653}, {288,0.76529703}, {289,0.77246535}, {290,0.78719802}, {291,0.79351485}, {292,0.80147525}, {293,0.81037624}, {294,0.81277228}, {295,0.81925743}, {296,0.83396040}, {297,0.82711881}, {298,0.83056436}, {299,0.84089109}, {300,0.84248515}, {301,0.8630571}, {302,0.9841143}, {303,0.9328571}, {304,0.9306571}, {305,0.8982000}, {306,0.9007143}, {307,0.9021429}, {308,0.9125714}, {309,0.9208000}, {310,0.9180000}, {311,0.9298571}, {312,0.9374000}, {313,0.9421429}, {314,0.9450857}, {315,0.9556286}, {316,0.9596571}, {317,0.9622571}, {318,0.9687714}, {319,0.9803429}, {320,0.9808571}, {321,0.9870857}, {322,0.9983429}, {323,1.0023714}, {324,1.0106571}, {325,1.0196000}, {326,1.0198000}, {327,1.0356000}, {328,1.0354571}, {329,1.0357143}, {330,1.0520857}, {331,1.0502571}, {332,1.0675143}, {333,1.0540571}, {334,1.0716000}, {335,1.0692286}, {336,1.0818286}, {337,1.0889714}, {338,1.0914571}, {339,1.1031143}, {340,1.1024857}, {341,1.1205429}, {342,1.1278571}, {343,1.1362286}, {344,1.1488857}, {345,1.1516571}, {346,1.1514571}, {347,1.1632857}, {348,1.1723714}, {349,1.1782857}, {350,1.1841429}, {351,1.2012000}, {352,1.2061143}, {353,1.2048286}, {354,1.2185714}, {355,1.2163714}, {356,1.2263429}, {357,1.2358571}, {358,1.2478000}, {359,1.2456286}, {360,1.2651429}, {361,1.2661143}, {362,1.2703429}, {363,1.2905714}, {364,1.2876571}, {365,1.2975714}, {366,1.3010571}, {367,1.3184286}, {368,1.3137143}, {369,1.3245714}, {370,1.3432286}, {371,1.3462857}, {372,1.3551714}, {373,1.3591714}, {374,1.3709429}, {375,1.3842000}, {376,1.3868286}, {377,1.3939429}, {378,1.4028286}, {379,1.4079429}, {380,1.4154286}, {381,1.4268857}, {382,1.4386286}, {383,1.4478857}, {384,1.4587714}, {385,1.4703714}, {386,1.4751429}, {387,1.4927714}, {388,1.4916857}, {389,1.5029429}, {390,1.5143429}, {391,1.5175143}, {392,1.5207714}, {393,1.5344000}, {394,1.5480571}, {395,1.5550571}, {396,1.5636857}, {397,1.5693143}, {398,1.5727714}, {399,1.5861714}, {400,1.5942857}, {401,1.6054286}, {402,1.6154571}, {403,1.6252286}, {404,1.6279143}, {405,1.6436000}, {406,1.6482857}, {407,1.6575143}, {408,1.6661429}, {409,1.6769429}, {410,1.6823714}, {411,1.6920857}, {412,1.6926000}, {413,1.7087429}, {414,1.7146571}, {415,1.7284571}, {416,1.7311143}, {417,1.7433429}, {418,1.7461714}, {419,1.8045714}, {420,1.7988571}, {421,1.7852857}, {422,1.7937429}, {423,1.8019143}, {424,1.8075143}, {425,1.8246286}, {426,1.8277143}, {427,1.8552286}, {428,1.8564000}, {429,1.8699143}, {430,1.8746000}, {431,1.8934286}, {432,1.8956857}, {433,1.9071714}, {434,1.9127143}, {435,1.9247429}, {436,1.9284571}, {437,1.9438286}, {438,1.9554571}, {439,1.9706000}, {440,1.9861714}, {441,1.9893143}, {442,1.9996857}, {443,2.0059714}, {444,2.0151429}, {445,2.0337429}, {446,2.0344571}, {447,2.0477429}, {448,2.0508857}, {449,2.0721714}, {450,2.0796857}, {451,2.0895143}, {452,2.0940286}, {453,2.1056286}, {454,2.1188857}, {455,2.1344000}, {456,2.1485714}, {457,2.1554286}, {458,2.1677714}, {459,2.1769143}, {460,2.1928000}, {461,2.1941714}, {462,2.1987143}, {463,2.2204857}, {464,2.2317714}, {465,2.2414857}, {466,2.2484286}, {467,2.2895143}, {468,2.3051143}, {469,2.2875714}, {470,2.2995714}, {471,2.3247714}, {472,2.3109714}, {473,2.3251429}, {474,2.3321429}, {475,2.3308571}, {476,2.3416571}, {477,2.3654857}, {478,2.4005429}, {479,2.3749714}, {480,2.4490571}, {481,2.5050571}, {482,2.4230857}, {483,2.5303429}, {484,2.4594857}, {485,2.5365714}, {486,2.4958286}, {487,2.5707714}, {488,2.5889143}, {489,2.5607714}, {490,2.5211714}, {491,2.5297714}, {492,2.5684857}, {493,2.6012857}, {494,2.6226857}, {495,2.6333143}, {496,2.6795714}, {497,2.7337714}, {498,2.6521714}, {499,2.6818571}, {500,2.6638000}, {505,2.7655714}, {510,2.7862857}, {515,2.9325429}, {520,3.0205429}, {525,3.1622000}, {530,3.1398286}, {535,3.1835143}, {540,3.2127429}, {545,3.2704857}, {550,3.3241714}, {555,3.3787143}, {560,3.4215714}, {565,3.5669143}, {570,3.6194000}, {575,3.6651429}, {580,3.7347143}, {585,3.8593143}, {590,3.8955143}, {595,3.9922857}, {600,4.0577143}, {605,4.2626857}, {610,4.2473714}, {615,4.3033429}, {620,4.4016857}, {625,4.4764000}, {630,4.6284000}, {635,4.6672571}, {640,4.7717714}, {645,4.7683143}, {650,4.8770286}, {655,5.0880857}, {660,5.1576857}, {665,5.1408286}, {670,5.1407429}, {675,5.2482857}, {680,5.3608286}, {685,5.4928571}, {690,5.6460000}, {695,5.6481714}, {700,5.8100000}, {705,5.8082000}, {710,5.9832000}, {715,6.0840857}, {720,6.1368571}, {725,6.2183429}, {730,6.3322286}, {735,6.5969143}, {740,6.6168000}, {745,6.6974857}, {750,6.8437714}, {755,6.9690000}, {760,7.0652286}, {765,7.2038286}, {770,7.3136571}, {775,7.4322857}, {780,7.5155143}, {785,7.6504000}, {790,7.7655429}, {795,7.8864286}, {800,8.1002857}, {805,8.1080000}, {810,8.2783143}, {815,8.3719429}, {820,8.5370000}, {825,8.6457429}, {830,8.7763714}, {835,8.8742000}, {840,9.0237714}, {845,9.1910857}, {850,9.3873143}, {855,9.5033714}, {860,9.6267429}, {865,9.7877143}, {870,9.9422286}, {875,10.2011143}, {880,10.2734286}, {885,10.7242571}, {890,10.5244000}, {895,10.7286000}, {900,11.1310571}, {905,11.0862286}, {910,11.2876857}, {915,11.3856571}, {920,11.8762000}, {925,11.9418571}, {930,12.0377429}, {935,12.0326286}, {940,12.5291714}, {945,12.2952571}, {950,12.5410000}, {955,12.8248571}, {960,13.3453714}, {965,13.3788857}, {970,13.2641429}, {975,13.5438571}, {980,13.8573714}, {985,14.2970571}, {990,14.2351714}, {995,14.6425714}, {1000,14.6121429}, {1010,15.2260000}, {1020,15.4895714}, {1030,16.0353143}, {1040,16.2622571}, {1050,16.7595429}, {1060,17.3854286}, {1070,17.8414000}, {1080,18.4673429}, {1090,18.2309714}, {1100,19.0022000}, {1110,19.3429714}, {1120,19.9056000}, {1130,20.3279143}, {1140,20.8084571}, {1150,21.3270000}, {1160,21.8286286}, {1170,22.2772286}, {1180,23.0790286}, {1190,23.4434571}, {1200,24.0227143}, {1210,24.7015143}, {1220,25.1008000}, {1230,25.3842000}, {1240,26.1243714}, {1250,27.0009429}, {1260,27.5434857}, {1270,28.1036571}, {1280,28.5258857}, {1290,28.9471429}, {1300,29.6477429}, {1310,30.3576286}, {1320,31.0030857}, {1330,31.9411429}, {1340,32.5116571}, {1350,33.0444000}, {1360,33.5462857}, {1370,34.2081714}, {1380,34.9864286}, {1390,35.6566857}, {1400,36.4056571}, {1410,37.0082000}, {1420,38.0423429}, {1430,38.8193143}, {1440,39.4274286}, {1450,39.9738857}, {1460,40.7694286}, {1470,41.9956571}, {1480,42.4116571}, {1490,43.2607714}, {1500,43.6937714}, {1510,44.9623714}, {1520,45.5627143}, {1530,46.9863429}, {1540,47.9529714}, {1550,48.7557714}, {1560,49.4259714}, {1570,50.1568000}, {1580,51.5132571}, {1590,52.4269143}, {1600,53.0195143}, {1610,54.1746286}, {1620,55.2109429}, {1630,55.4934286}, {1640,56.0978286}, {1650,57.6457429}, {1660,58.6600857}, {1670,59.6174571}, {1680,60.3776857}, {1690,62.2451143}, {1700,63.5241714}, {1710,64.4321714}, {1720,65.4838857}, {1730,66.3052286}, {1740,67.4801714}, {1750,68.1246857}, {1760,68.9931429}, {1770,70.4618000}, {1780,71.5511714}, {1790,72.8239429}, {1800,73.9335429}, {1810,75.3569143}, {1820,76.5518857}, {1830,77.0400571}, {1840,78.6203714}, {1850,80.5364571}, {1860,81.7779714}, {1870,83.1086857}, {1880,84.2307429}, {1890,86.2908286}, {1900,86.3350571}, {1910,88.3740571}, {1920,89.3596000}, {1930,90.8271429}, {1940,91.4712571}, {1950,92.7844571}, {1960,94.9918571}, {1970,94.9176000}, {1980,96.7929429}, {1990,98.1203143}, {2000,99.7352000}};
data["big"]["LtacTacInTermPrimPair"]["actual reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00003960}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00003960}, {9,0.00000000}, {10,0.00000000}, {11,0.00003960}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00003960}, {16,0.00000000}, {17,0.00003960}, {18,0.00003960}, {19,0.00010891}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00003960}, {25,0.00000000}, {26,0.00003960}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00003960}, {32,0.00003960}, {33,0.00007921}, {34,0.00011881}, {35,0.00003960}, {36,0.00000000}, {37,0.00007921}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003960}, {42,0.00000000}, {43,0.00002970}, {44,0.00003960}, {45,0.00015842}, {46,0.00003960}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00000000}, {51,0.00015842}, {52,0.00003960}, {53,0.00010891}, {54,0.00003960}, {55,0.00003960}, {56,0.00000000}, {57,0.00007921}, {58,0.00000000}, {59,0.00003960}, {60,0.00000000}, {61,0.00003960}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00003960}, {66,0.00000000}, {67,0.00003960}, {68,0.00000000}, {69,0.00003960}, {70,0.00000000}, {71,0.00003960}, {72,0.00000000}, {73,0.00003960}, {74,0.00000000}, {75,0.00003960}, {76,0.00007921}, {77,0.00011881}, {78,0.00000000}, {79,0.00011881}, {80,0.00007921}, {81,0.00003960}, {82,0.00007921}, {83,0.00003960}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00003960}, {90,0.00011881}, {91,0.00015842}, {92,0.00010891}, {93,0.00015842}, {94,0.00003960}, {95,0.00007921}, {96,0.00007921}, {97,0.00000000}, {98,0.00003960}, {99,0.00011881}, {100,0.00003960}, {101,0.00000000}, {102,0.00011881}, {103,0.00000000}, {104,0.00003960}, {105,0.00007921}, {106,0.00000000}, {107,0.00003960}, {108,0.00000000}, {109,0.00000000}, {110,0.00002970}, {111,0.00007921}, {112,0.00000000}, {113,0.00003960}, {114,0.00000000}, {115,0.00003960}, {116,0.00003960}, {117,0.00000000}, {118,0.00000000}, {119,0.00007921}, {120,0.00007921}, {121,0.00000000}, {122,0.00007921}, {123,0.00011881}, {124,0.00000000}, {125,0.00000000}, {126,0.00003960}, {127,0.00000000}, {128,0.00007921}, {129,0.00007921}, {130,0.00003960}, {131,0.00000000}, {132,0.00000000}, {133,0.00007921}, {134,0.00007921}, {135,0.00007921}, {136,0.00003960}, {137,0.00011881}, {138,0.00007921}, {139,0.00003960}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00007921}, {145,0.00007921}, {146,0.00003960}, {147,0.00007921}, {148,0.00007921}, {149,0.00000000}, {150,0.00003960}, {151,0.00003960}, {152,0.00000000}, {153,0.00003960}, {154,0.00007921}, {155,0.00007921}, {156,0.00010891}, {157,0.00003960}, {158,0.00000000}, {159,0.00003960}, {160,0.00007921}, {161,0.00000000}, {162,0.00003960}, {163,0.00003960}, {164,0.00003960}, {165,0.00003960}, {166,0.00000000}, {167,0.00007921}, {168,0.00007921}, {169,0.00007921}, {170,0.00003960}, {171,0.00003960}, {172,0.00003960}, {173,0.00007921}, {174,0.00003960}, {175,0.00003960}, {176,0.00002970}, {177,0.00007921}, {178,0.00003960}, {179,0.00015842}, {180,0.00007921}, {181,0.00000000}, {182,0.00007921}, {183,0.00000000}, {184,0.00023762}, {185,0.00003960}, {186,0.00007921}, {187,0.00003960}, {188,0.00000000}, {189,0.00000000}, {190,0.00003960}, {191,0.00006931}, {192,0.00000000}, {193,0.00007921}, {194,0.00003960}, {195,0.00007921}, {196,0.00000000}, {197,0.00011881}, {198,0.00006931}, {199,0.00003960}, {200,0.00000000}, {201,0.00011881}, {202,0.00007921}, {203,0.00007921}, {204,0.00007921}, {205,0.00003960}, {206,0.00003960}, {207,0.00000000}, {208,0.00007921}, {209,0.00007921}, {210,0.00003960}, {211,0.00007921}, {212,0.00000000}, {213,0.00000000}, {214,0.00003960}, {215,0.00003960}, {216,0.00007921}, {217,0.00000000}, {218,0.00000000}, {219,0.00003960}, {220,0.00000000}, {221,0.00011881}, {222,0.00006931}, {223,0.00011881}, {224,0.00000000}, {225,0.00007921}, {226,0.00007921}, {227,0.00003960}, {228,0.00003960}, {229,0.00007921}, {230,0.00000000}, {231,0.00015842}, {232,0.00003960}, {233,0.00006931}, {234,0.00000000}, {235,0.00007921}, {236,0.00003960}, {237,0.00003960}, {238,0.00007921}, {239,0.00007921}, {240,0.00003960}, {241,0.00003960}, {242,0.00007921}, {243,0.00010891}, {244,0.00011881}, {245,0.00015842}, {246,0.00007921}, {247,0.00003960}, {248,0.00019802}, {249,0.00003960}, {250,0.00011881}, {251,0.00003960}, {252,0.00019802}, {253,0.00003960}, {254,0.00015842}, {255,0.00027723}, {256,0.00006931}, {257,0.00035644}, {258,0.00000000}, {259,0.00003960}, {260,0.00007921}, {261,0.00007921}, {262,0.00052475}, {263,0.00011881}, {264,0.00007921}, {265,0.00000000}, {266,0.00035644}, {267,0.00003960}, {268,0.00007921}, {269,0.00003960}, {270,0.00007921}, {271,0.00003960}, {272,0.00015842}, {273,0.00011881}, {274,0.00007921}, {275,0.00030693}, {276,0.00011881}, {277,0.00003960}, {278,0.00007921}, {279,0.00011881}, {280,0.00031683}, {281,0.00014851}, {282,0.00003960}, {283,0.00007921}, {284,0.00079208}, {285,0.00007921}, {286,0.00011881}, {287,0.00003960}, {288,0.00015842}, {289,0.00022772}, {290,0.00010891}, {291,0.00003960}, {292,0.00000000}, {293,0.00007921}, {294,0.00003960}, {295,0.00015842}, {296,0.00007921}, {297,0.00007921}, {298,0.00015842}, {299,0.00043564}, {300,0.00014851}, {301,0.0001143}, {302,0.0003429}, {303,0.0002286}, {304,0.0004286}, {305,0.0001143}, {306,0.0001143}, {307,0.0002286}, {308,0.0001143}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0004571}, {313,0.0001143}, {314,0.0000000}, {315,0.0002286}, {316,0.0001143}, {317,0.0000000}, {318,0.0002286}, {319,0.0001143}, {320,0.0000000}, {321,0.0000000}, {322,0.0002286}, {323,0.0001143}, {324,0.0003429}, {325,0.0000000}, {326,0.0002286}, {327,0.0000000}, {328,0.0002286}, {329,0.0005429}, {330,0.0003429}, {331,0.0000000}, {332,0.0000000}, {333,0.0001143}, {334,0.0005714}, {335,0.0004571}, {336,0.0003429}, {337,0.0005714}, {338,0.0001143}, {339,0.0000000}, {340,0.0000000}, {341,0.0002286}, {342,0.0002286}, {343,0.0000000}, {344,0.0002286}, {345,0.0000000}, {346,0.0001143}, {347,0.0001143}, {348,0.0001143}, {349,0.0002286}, {350,0.0000000}, {351,0.0001143}, {352,0.0000000}, {353,0.0002286}, {354,0.0001143}, {355,0.0000000}, {356,0.0001143}, {357,0.0000857}, {358,0.0001143}, {359,0.0000000}, {360,0.0000000}, {361,0.0001143}, {362,0.0001143}, {363,0.0005714}, {364,0.0001143}, {365,0.0001143}, {366,0.0000000}, {367,0.0000000}, {368,0.0005714}, {369,0.0003429}, {370,0.0000000}, {371,0.0000000}, {372,0.0001143}, {373,0.0000000}, {374,0.0000000}, {375,0.0002286}, {376,0.0002286}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0001143}, {383,0.0008000}, {384,0.0001143}, {385,0.0002286}, {386,0.0001143}, {387,0.0005714}, {388,0.0002286}, {389,0.0001143}, {390,0.0002286}, {391,0.0001143}, {392,0.0001143}, {393,0.0005714}, {394,0.0003429}, {395,0.0001143}, {396,0.0002286}, {397,0.0001143}, {398,0.0001143}, {399,0.0001143}, {400,0.0002286}, {401,0.0001143}, {402,0.0003429}, {403,0.0000000}, {404,0.0004571}, {405,0.0000000}, {406,0.0001143}, {407,0.0001143}, {408,0.0003429}, {409,0.0002286}, {410,0.0002000}, {411,0.0005714}, {412,0.0002286}, {413,0.0001143}, {414,0.0003143}, {415,0.0008000}, {416,0.0005714}, {417,0.0001143}, {418,0.0002286}, {419,0.0009143}, {420,0.0000000}, {421,0.0000000}, {422,0.0002286}, {423,0.0003429}, {424,0.0002286}, {425,0.0008000}, {426,0.0008000}, {427,0.0002286}, {428,0.0003429}, {429,0.0005714}, {430,0.0001143}, {431,0.0004571}, {432,0.0001143}, {433,0.0001143}, {434,0.0002286}, {435,0.0001143}, {436,0.0004571}, {437,0.0002286}, {438,0.0000000}, {439,0.0006857}, {440,0.0002286}, {441,0.0006857}, {442,0.0001143}, {443,0.0003429}, {444,0.0002286}, {445,0.0003429}, {446,0.0001143}, {447,0.0002286}, {448,0.0008000}, {449,0.0000000}, {450,0.0002286}, {451,0.0000000}, {452,0.0001143}, {453,0.0003429}, {454,0.0001143}, {455,0.0001143}, {456,0.0005714}, {457,0.0002286}, {458,0.0003429}, {459,0.0002286}, {460,0.0003429}, {461,0.0006571}, {462,0.0003143}, {463,0.0006857}, {464,0.0004571}, {465,0.0009143}, {466,0.0010286}, {467,0.0003429}, {468,0.0018000}, {469,0.0010286}, {470,0.0008000}, {471,0.0011429}, {472,0.0017143}, {473,0.0014571}, {474,0.0015714}, {475,0.0009143}, {476,0.0013714}, {477,0.0003429}, {478,0.0003429}, {479,0.0005714}, {480,0.0002286}, {481,0.0009143}, {482,0.0002286}, {483,0.0012571}, {484,0.0005714}, {485,0.0010286}, {486,0.0008000}, {487,0.0009143}, {488,0.0011429}, {489,0.0005714}, {490,0.0005714}, {491,0.0006857}, {492,0.0002286}, {493,0.0003429}, {494,0.0008000}, {495,0.0011429}, {496,0.0008000}, {497,0.0008000}, {498,0.0006857}, {499,0.0011429}, {500,0.0003429}, {505,0.0009143}, {510,0.0004571}, {515,0.0013714}, {520,0.0011429}, {525,0.0016000}, {530,0.0016857}, {535,0.0011429}, {540,0.0024857}, {545,0.0013714}, {550,0.0017143}, {555,0.0003429}, {560,0.0018286}, {565,0.0009143}, {570,0.0009143}, {575,0.0016000}, {580,0.0013714}, {585,0.0019143}, {590,0.0013714}, {595,0.0008857}, {600,0.0006857}, {605,0.0015714}, {610,0.0019429}, {615,0.0014571}, {620,0.0016000}, {625,0.0018286}, {630,0.0019429}, {635,0.0010286}, {640,0.0006857}, {645,0.0006857}, {650,0.0001143}, {655,0.0014857}, {660,0.0008000}, {665,0.0012571}, {670,0.0014857}, {675,0.0013714}, {680,0.0013714}, {685,0.0010286}, {690,0.0026286}, {695,0.0014857}, {700,0.0022571}, {705,0.0018286}, {710,0.0009143}, {715,0.0022857}, {720,0.0004571}, {725,0.0008000}, {730,0.0010286}, {735,0.0013429}, {740,0.0004286}, {745,0.0008000}, {750,0.0020571}, {755,0.0004571}, {760,0.0008000}, {765,0.0017143}, {770,0.0025143}, {775,0.0016000}, {780,0.0006286}, {785,0.0022857}, {790,0.0038857}, {795,0.0019429}, {800,0.0027429}, {805,0.0017143}, {810,0.0029714}, {815,0.0048857}, {820,0.0018857}, {825,0.0045714}, {830,0.0020571}, {835,0.0004571}, {840,0.0034286}, {845,0.0034286}, {850,0.0037143}, {855,0.0037143}, {860,0.0032000}, {865,0.0046857}, {870,0.0045714}, {875,0.0052571}, {880,0.0024000}, {885,0.0045714}, {890,0.0062571}, {895,0.0021714}, {900,0.0028000}, {905,0.0040857}, {910,0.0019429}, {915,0.0027143}, {920,0.0043429}, {925,0.0044571}, {930,0.0029714}, {935,0.0046857}, {940,0.0058857}, {945,0.0044286}, {950,0.0026000}, {955,0.0048571}, {960,0.0048857}, {965,0.0045714}, {970,0.0054571}, {975,0.0046571}, {980,0.0066000}, {985,0.0059714}, {990,0.0058286}, {995,0.0072857}, {1000,0.0073143}, {1010,0.0061714}, {1020,0.0056857}, {1030,0.0058571}, {1040,0.0058857}, {1050,0.0074000}, {1060,0.0042857}, {1070,0.0042571}, {1080,0.0056571}, {1090,0.0047429}, {1100,0.0062571}, {1110,0.0036571}, {1120,0.0059714}, {1130,0.0060857}, {1140,0.0066000}, {1150,0.0063143}, {1160,0.0053429}, {1170,0.0081143}, {1180,0.0076000}, {1190,0.0056857}, {1200,0.0076571}, {1210,0.0051429}, {1220,0.0064857}, {1230,0.0044571}, {1240,0.0066857}, {1250,0.0099429}, {1260,0.0114857}, {1270,0.0114857}, {1280,0.0139714}, {1290,0.0122286}, {1300,0.0102857}, {1310,0.0082286}, {1320,0.0124857}, {1330,0.0109143}, {1340,0.0128000}, {1350,0.0141143}, {1360,0.0128571}, {1370,0.0135714}, {1380,0.0095429}, {1390,0.0146857}, {1400,0.0136571}, {1410,0.0132857}, {1420,0.0139143}, {1430,0.0106857}, {1440,0.0141429}, {1450,0.0209429}, {1460,0.0118571}, {1470,0.0116571}, {1480,0.0146571}, {1490,0.0176857}, {1500,0.0145429}, {1510,0.0137429}, {1520,0.0152571}, {1530,0.0169714}, {1540,0.0140857}, {1550,0.0206571}, {1560,0.0159429}, {1570,0.0200286}, {1580,0.0155714}, {1590,0.0195143}, {1600,0.0164286}, {1610,0.0128857}, {1620,0.0139429}, {1630,0.0155143}, {1640,0.0204000}, {1650,0.0215143}, {1660,0.0140571}, {1670,0.0192286}, {1680,0.0198857}, {1690,0.0149143}, {1700,0.0140000}, {1710,0.0202286}, {1720,0.0181143}, {1730,0.0231429}, {1740,0.0166571}, {1750,0.0253143}, {1760,0.0210857}, {1770,0.0233429}, {1780,0.0307429}, {1790,0.0260000}, {1800,0.0194000}, {1810,0.0140857}, {1820,0.0277429}, {1830,0.0259143}, {1840,0.0261714}, {1850,0.0240000}, {1860,0.0194000}, {1870,0.0238000}, {1880,0.0257429}, {1890,0.0230286}, {1900,0.0322000}, {1910,0.0259429}, {1920,0.0307143}, {1930,0.0212000}, {1940,0.0278000}, {1950,0.0252286}, {1960,0.0250857}, {1970,0.0222000}, {1980,0.0273143}, {1990,0.0271143}, {2000,0.0244857}};
data["big"]["LtacTacInTermPrimPair"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00118812}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0033714}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0031714}, {482,0.0022286}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000286}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000857}, {560,0.0000000}, {565,0.0000857}, {570,0.0001143}, {575,0.0000857}, {580,0.0002857}, {585,0.0004286}, {590,0.0005143}, {595,0.0005429}, {600,0.0006286}, {605,0.0020857}, {610,0.0008000}, {615,0.0009143}, {620,0.0008571}, {625,0.0009429}, {630,0.0010000}, {635,0.0009714}, {640,0.0010000}, {645,0.0009714}, {650,0.0009429}, {655,0.0009714}, {660,0.0009143}, {665,0.0009714}, {670,0.0009714}, {675,0.0010000}, {680,0.0009714}, {685,0.0010000}, {690,0.0010000}, {695,0.0010000}, {700,0.0010000}, {705,0.0010000}, {710,0.0010000}, {715,0.0010000}, {720,0.0010000}, {725,0.0010000}, {730,0.0010000}, {735,0.0010000}, {740,0.0010000}, {745,0.0010000}, {750,0.0010000}, {755,0.0010000}, {760,0.0010000}, {765,0.0010000}, {770,0.0010000}, {775,0.0010000}, {780,0.0010000}, {785,0.0010000}, {790,0.0010000}, {795,0.0010000}, {800,0.0028857}, {805,0.0010000}, {810,0.0010000}, {815,0.0010000}, {820,0.0010000}, {825,0.0010000}, {830,0.0010000}, {835,0.0010000}, {840,0.0010000}, {845,0.0010000}, {850,0.0010000}, {855,0.0010000}, {860,0.0010000}, {865,0.0010000}, {870,0.0010000}, {875,0.0010000}, {880,0.0010000}, {885,0.0010000}, {890,0.0010000}, {895,0.0010000}, {900,0.0010000}, {905,0.0010000}, {910,0.0010000}, {915,0.0010000}, {920,0.0010000}, {925,0.0010000}, {930,0.0010000}, {935,0.0010000}, {940,0.0010000}, {945,0.0010000}, {950,0.0010000}, {955,0.0010000}, {960,0.0010000}, {965,0.0010000}, {970,0.0010000}, {975,0.0010000}, {980,0.0010000}, {985,0.0010000}, {990,0.0010000}, {995,0.0010000}, {1000,0.0010000}, {1010,0.0010000}, {1020,0.0010000}, {1030,0.0030000}, {1040,0.0010000}, {1050,0.0010000}, {1060,0.0010000}, {1070,0.0010000}, {1080,0.0010571}, {1090,0.0010286}, {1100,0.0010286}, {1110,0.0010571}, {1120,0.0010571}, {1130,0.0010857}, {1140,0.0011429}, {1150,0.0011714}, {1160,0.0012571}, {1170,0.0014286}, {1180,0.0014857}, {1190,0.0015143}, {1200,0.0016857}, {1210,0.0016571}, {1220,0.0019143}, {1230,0.0018286}, {1240,0.0018000}, {1250,0.0019143}, {1260,0.0020000}, {1270,0.0019714}, {1280,0.0020000}, {1290,0.0020000}, {1300,0.0020000}, {1310,0.0020000}, {1320,0.0020000}, {1330,0.0080286}, {1340,0.0020000}, {1350,0.0020000}, {1360,0.0020000}, {1370,0.0020000}, {1380,0.0020000}, {1390,0.0020000}, {1400,0.0020000}, {1410,0.0020000}, {1420,0.0020000}, {1430,0.0020000}, {1440,0.0020000}, {1450,0.0020000}, {1460,0.0020000}, {1470,0.0020000}, {1480,0.0020000}, {1490,0.0020000}, {1500,0.0020000}, {1510,0.0020000}, {1520,0.0020000}, {1530,0.0020000}, {1540,0.0020000}, {1550,0.0020000}, {1560,0.0020000}, {1570,0.0020000}, {1580,0.0020000}, {1590,0.0020000}, {1600,0.0020000}, {1610,0.0020000}, {1620,0.0020000}, {1630,0.0020000}, {1640,0.0020000}, {1650,0.0020000}, {1660,0.0020000}, {1670,0.0020000}, {1680,0.0020571}, {1690,0.0021143}, {1700,0.0020286}, {1710,0.0068571}, {1720,0.0021429}, {1730,0.0021714}, {1740,0.0023143}, {1750,0.0022571}, {1760,0.0023714}, {1770,0.0025714}, {1780,0.0025143}, {1790,0.0025714}, {1800,0.0026857}, {1810,0.0027143}, {1820,0.0028000}, {1830,0.0028000}, {1840,0.0027143}, {1850,0.0029143}, {1860,0.0028571}, {1870,0.0029429}, {1880,0.0029429}, {1890,0.0029429}, {1900,0.0029714}, {1910,0.0101714}, {1920,0.0030000}, {1930,0.0030000}, {1940,0.0030000}, {1950,0.0030000}, {1960,0.0030000}, {1970,0.0030000}, {1980,0.0030000}, {1990,0.0030000}, {2000,0.0030000}};
data["big"]["LtacTacInTermPrimPair"]["cbv"]["user"] = {{1,0.00002970}, {2,0.00000000}, {3,0.00003960}, {4,0.00000000}, {5,0.00007921}, {6,0.00003960}, {7,0.00000000}, {8,0.00000000}, {9,0.00039604}, {10,0.00000000}, {11,0.00003960}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00007921}, {16,0.00000000}, {17,0.00007921}, {18,0.00000000}, {19,0.00007921}, {20,0.00010891}, {21,0.00003960}, {22,0.00000000}, {23,0.00003960}, {24,0.00009901}, {25,0.00014851}, {26,0.00014851}, {27,0.00010891}, {28,0.00003960}, {29,0.00003960}, {30,0.00010891}, {31,0.00006931}, {32,0.00011881}, {33,0.00015842}, {34,0.00011881}, {35,0.00003960}, {36,0.00003960}, {37,0.00015842}, {38,0.00000000}, {39,0.00003960}, {40,0.00010891}, {41,0.00011881}, {42,0.00007921}, {43,0.00007921}, {44,0.00003960}, {45,0.00014851}, {46,0.00015842}, {47,0.00003960}, {48,0.00010891}, {49,0.00011881}, {50,0.00007921}, {51,0.00002970}, {52,0.00014851}, {53,0.00003960}, {54,0.00003960}, {55,0.00014851}, {56,0.00011881}, {57,0.00002970}, {58,0.00011881}, {59,0.00007921}, {60,0.00003960}, {61,0.00011881}, {62,0.00013861}, {63,0.00007921}, {64,0.00007921}, {65,0.00006931}, {66,0.00006931}, {67,0.00011881}, {68,0.00011881}, {69,0.00017822}, {70,0.00011881}, {71,0.00011881}, {72,0.00010891}, {73,0.00014851}, {74,0.00014851}, {75,0.00006931}, {76,0.00029703}, {77,0.00014851}, {78,0.00007921}, {79,0.00026733}, {80,0.00007921}, {81,0.00019802}, {82,0.00014851}, {83,0.00012871}, {84,0.00010891}, {85,0.00011881}, {86,0.00007921}, {87,0.00011881}, {88,0.00007921}, {89,0.00003960}, {90,0.00003960}, {91,0.00014851}, {92,0.00017822}, {93,0.00010891}, {94,0.00019802}, {95,0.00025743}, {96,0.00027723}, {97,0.00014851}, {98,0.00015842}, {99,0.00015842}, {100,0.00022772}, {101,0.00015842}, {102,0.00015842}, {103,0.00013861}, {104,0.00022772}, {105,0.00026733}, {106,0.00019802}, {107,0.00010891}, {108,0.00023762}, {109,0.00135644}, {110,0.00011881}, {111,0.00025743}, {112,0.00018812}, {113,0.00018812}, {114,0.00010891}, {115,0.00012871}, {116,0.00024752}, {117,0.00021782}, {118,0.00035644}, {119,0.00011881}, {120,0.00013861}, {121,0.00026733}, {122,0.00033663}, {123,0.00015842}, {124,0.00016832}, {125,0.00007921}, {126,0.00014851}, {127,0.00034653}, {128,0.00027723}, {129,0.00029703}, {130,0.00015842}, {131,0.00019802}, {132,0.00014851}, {133,0.00021782}, {134,0.00022772}, {135,0.00042574}, {136,0.00015842}, {137,0.00015842}, {138,0.00006931}, {139,0.00029703}, {140,0.00025743}, {141,0.00017822}, {142,0.00054455}, {143,0.00023762}, {144,0.00022772}, {145,0.00019802}, {146,0.00011881}, {147,0.00010891}, {148,0.00033663}, {149,0.00015842}, {150,0.00027723}, {151,0.00023762}, {152,0.00026733}, {153,0.00032673}, {154,0.00022772}, {155,0.00022772}, {156,0.00021782}, {157,0.00033663}, {158,0.00030693}, {159,0.00018812}, {160,0.00014851}, {161,0.00038614}, {162,0.00024752}, {163,0.00021782}, {164,0.00021782}, {165,0.00010891}, {166,0.00023762}, {167,0.00011881}, {168,0.00025743}, {169,0.00030693}, {170,0.00022772}, {171,0.00024752}, {172,0.00007921}, {173,0.00034653}, {174,0.00018812}, {175,0.00030693}, {176,0.00034653}, {177,0.00019802}, {178,0.00015842}, {179,0.00040594}, {180,0.00047525}, {181,0.00043564}, {182,0.00022772}, {183,0.00029703}, {184,0.00030693}, {185,0.00016832}, {186,0.00018812}, {187,0.00013861}, {188,0.00011881}, {189,0.00050495}, {190,0.00031683}, {191,0.00025743}, {192,0.00033663}, {193,0.00031683}, {194,0.00048515}, {195,0.00026733}, {196,0.00030693}, {197,0.00042574}, {198,0.00023762}, {199,0.00040594}, {200,0.00030693}, {201,0.00041584}, {202,0.00038614}, {203,0.00025743}, {204,0.00040594}, {205,0.00037624}, {206,0.00032673}, {207,0.00028713}, {208,0.00041584}, {209,0.00023762}, {210,0.00023762}, {211,0.00032673}, {212,0.00027723}, {213,0.00051485}, {214,0.00032673}, {215,0.00043564}, {216,0.00040594}, {217,0.00030693}, {218,0.00038614}, {219,0.00045545}, {220,0.00034653}, {221,0.00033663}, {222,0.00028713}, {223,0.00031683}, {224,0.00029703}, {225,0.00032673}, {226,0.00051485}, {227,0.00030693}, {228,0.00032673}, {229,0.00040594}, {230,0.00037624}, {231,0.00023762}, {232,0.00051485}, {233,0.00047525}, {234,0.00038614}, {235,0.00025743}, {236,0.00056436}, {237,0.00046535}, {238,0.00034653}, {239,0.00045545}, {240,0.00015842}, {241,0.00059406}, {242,0.00043564}, {243,0.00025743}, {244,0.00034653}, {245,0.00032673}, {246,0.00039604}, {247,0.00023762}, {248,0.00023762}, {249,0.00019802}, {250,0.00059406}, {251,0.00030693}, {252,0.00046535}, {253,0.00034653}, {254,0.00035644}, {255,0.00068317}, {256,0.00044554}, {257,0.00036634}, {258,0.00026733}, {259,0.00065347}, {260,0.00047525}, {261,0.00029703}, {262,0.00046535}, {263,0.00035644}, {264,0.00029703}, {265,0.00027723}, {266,0.00042574}, {267,0.00037624}, {268,0.00053465}, {269,0.00048515}, {270,0.00045545}, {271,0.00037624}, {272,0.00035644}, {273,0.00025743}, {274,0.00019802}, {275,0.00036634}, {276,0.00045545}, {277,0.00051485}, {278,0.00032673}, {279,0.00035644}, {280,0.00032673}, {281,0.00057426}, {282,0.00021782}, {283,0.00035644}, {284,0.00057426}, {285,0.00028713}, {286,0.00029703}, {287,0.00045545}, {288,0.00049505}, {289,0.00054455}, {290,0.00037624}, {291,0.00054455}, {292,0.00045545}, {293,0.00044554}, {294,0.00028713}, {295,0.00019802}, {296,0.00048515}, {297,0.00030693}, {298,0.00044554}, {299,0.00020792}, {300,0.00056436}, {301,0.0004286}, {302,0.0000857}, {303,0.0002571}, {304,0.0006857}, {305,0.0002571}, {306,0.0004857}, {307,0.0002571}, {308,0.0002571}, {309,0.0005143}, {310,0.0002857}, {311,0.0003714}, {312,0.0001714}, {313,0.0003429}, {314,0.0000857}, {315,0.0005143}, {316,0.0002571}, {317,0.0004571}, {318,0.0003429}, {319,0.0006286}, {320,0.0004857}, {321,0.0003714}, {322,0.0030286}, {323,0.0003714}, {324,0.0004571}, {325,0.0006571}, {326,0.0004286}, {327,0.0001143}, {328,0.0001714}, {329,0.0005429}, {330,0.0004571}, {331,0.0007714}, {332,0.0003714}, {333,0.0005143}, {334,0.0000000}, {335,0.0006000}, {336,0.0003429}, {337,0.0002571}, {338,0.0005429}, {339,0.0000857}, {340,0.0011714}, {341,0.0006857}, {342,0.0004000}, {343,0.0007143}, {344,0.0005143}, {345,0.0004571}, {346,0.0005143}, {347,0.0003143}, {348,0.0000857}, {349,0.0004571}, {350,0.0004571}, {351,0.0004571}, {352,0.0007714}, {353,0.0005429}, {354,0.0004571}, {355,0.0002571}, {356,0.0003714}, {357,0.0007429}, {358,0.0002000}, {359,0.0006286}, {360,0.0008571}, {361,0.0003714}, {362,0.0004571}, {363,0.0006571}, {364,0.0006857}, {365,0.0003143}, {366,0.0007429}, {367,0.0006571}, {368,0.0005143}, {369,0.0004571}, {370,0.0004286}, {371,0.0005143}, {372,0.0002571}, {373,0.0004571}, {374,0.0004571}, {375,0.0003429}, {376,0.0002000}, {377,0.0005143}, {378,0.0004571}, {379,0.0006286}, {380,0.0001714}, {381,0.0002857}, {382,0.0007143}, {383,0.0005429}, {384,0.0008000}, {385,0.0005143}, {386,0.0002857}, {387,0.0005143}, {388,0.0003714}, {389,0.0005143}, {390,0.0003714}, {391,0.0005143}, {392,0.0003429}, {393,0.0005429}, {394,0.0002571}, {395,0.0008571}, {396,0.0010000}, {397,0.0003714}, {398,0.0007429}, {399,0.0004286}, {400,0.0004571}, {401,0.0005429}, {402,0.0000000}, {403,0.0010000}, {404,0.0005714}, {405,0.0007714}, {406,0.0009714}, {407,0.0002857}, {408,0.0005714}, {409,0.0006286}, {410,0.0004286}, {411,0.0009143}, {412,0.0004571}, {413,0.0005714}, {414,0.0003429}, {415,0.0005143}, {416,0.0004571}, {417,0.0005143}, {418,0.0002571}, {419,0.0010000}, {420,0.0006286}, {421,0.0005143}, {422,0.0006571}, {423,0.0010000}, {424,0.0006286}, {425,0.0004857}, {426,0.0007429}, {427,0.0006286}, {428,0.0005143}, {429,0.0004286}, {430,0.0006000}, {431,0.0003714}, {432,0.0004571}, {433,0.0005714}, {434,0.0007429}, {435,0.0007143}, {436,0.0004286}, {437,0.0008000}, {438,0.0006286}, {439,0.0006857}, {440,0.0006857}, {441,0.0006286}, {442,0.0008000}, {443,0.0006857}, {444,0.0003429}, {445,0.0005429}, {446,0.0006286}, {447,0.0007143}, {448,0.0005714}, {449,0.0008857}, {450,0.0007143}, {451,0.0005429}, {452,0.0008286}, {453,0.0009714}, {454,0.0009143}, {455,0.0004571}, {456,0.0007714}, {457,0.0005429}, {458,0.0007143}, {459,0.0008000}, {460,0.0006857}, {461,0.0006571}, {462,0.0005714}, {463,0.0004571}, {464,0.0006286}, {465,0.0002571}, {466,0.0008571}, {467,0.0003714}, {468,0.0005429}, {469,0.0001714}, {470,0.0006286}, {471,0.0004286}, {472,0.0006286}, {473,0.0008000}, {474,0.0004857}, {475,0.0010286}, {476,0.0012857}, {477,0.0003714}, {478,0.0004286}, {479,0.0009143}, {480,0.0005143}, {481,0.0032286}, {482,0.0017143}, {483,0.0004571}, {484,0.0009143}, {485,0.0008000}, {486,0.0003429}, {487,0.0011143}, {488,0.0006857}, {489,0.0003429}, {490,0.0005429}, {491,0.0008286}, {492,0.0003714}, {493,0.0003429}, {494,0.0006286}, {495,0.0006286}, {496,0.0006286}, {497,0.0010857}, {498,0.0006286}, {499,0.0002571}, {500,0.0009429}, {505,0.0006857}, {510,0.0004286}, {515,0.0008000}, {520,0.0007143}, {525,0.0008286}, {530,0.0007143}, {535,0.0010286}, {540,0.0003429}, {545,0.0004571}, {550,0.0008857}, {555,0.0006286}, {560,0.0005714}, {565,0.0007429}, {570,0.0005429}, {575,0.0006286}, {580,0.0005143}, {585,0.0004857}, {590,0.0004571}, {595,0.0006857}, {600,0.0011714}, {605,0.0020286}, {610,0.0006286}, {615,0.0009143}, {620,0.0007143}, {625,0.0008000}, {630,0.0010571}, {635,0.0007714}, {640,0.0007429}, {645,0.0008857}, {650,0.0004571}, {655,0.0008000}, {660,0.0014857}, {665,0.0008000}, {670,0.0011143}, {675,0.0006000}, {680,0.0007714}, {685,0.0008857}, {690,0.0013143}, {695,0.0006571}, {700,0.0007143}, {705,0.0006000}, {710,0.0008000}, {715,0.0012000}, {720,0.0007143}, {725,0.0007143}, {730,0.0007143}, {735,0.0016000}, {740,0.0014000}, {745,0.0011143}, {750,0.0006857}, {755,0.0011429}, {760,0.0009429}, {765,0.0007429}, {770,0.0007714}, {775,0.0010286}, {780,0.0011143}, {785,0.0007143}, {790,0.0008000}, {795,0.0014857}, {800,0.0025143}, {805,0.0007714}, {810,0.0008286}, {815,0.0008571}, {820,0.0008857}, {825,0.0014000}, {830,0.0011143}, {835,0.0008000}, {840,0.0010286}, {845,0.0009714}, {850,0.0009143}, {855,0.0014000}, {860,0.0011714}, {865,0.0007714}, {870,0.0006857}, {875,0.0011429}, {880,0.0010000}, {885,0.0012000}, {890,0.0011143}, {895,0.0010000}, {900,0.0015429}, {905,0.0010571}, {910,0.0013714}, {915,0.0010857}, {920,0.0013143}, {925,0.0012000}, {930,0.0014000}, {935,0.0011429}, {940,0.0015429}, {945,0.0009714}, {950,0.0014000}, {955,0.0009714}, {960,0.0012286}, {965,0.0007714}, {970,0.0013143}, {975,0.0011714}, {980,0.0015143}, {985,0.0014000}, {990,0.0018000}, {995,0.0017714}, {1000,0.0018857}, {1010,0.0016286}, {1020,0.0009714}, {1030,0.0028857}, {1040,0.0014857}, {1050,0.0016286}, {1060,0.0018000}, {1070,0.0014286}, {1080,0.0021429}, {1090,0.0011143}, {1100,0.0014571}, {1110,0.0014857}, {1120,0.0018571}, {1130,0.0016000}, {1140,0.0018857}, {1150,0.0015429}, {1160,0.0014571}, {1170,0.0016000}, {1180,0.0019143}, {1190,0.0016857}, {1200,0.0022000}, {1210,0.0013429}, {1220,0.0020857}, {1230,0.0017143}, {1240,0.0017143}, {1250,0.0017714}, {1260,0.0017714}, {1270,0.0015714}, {1280,0.0017429}, {1290,0.0023143}, {1300,0.0020286}, {1310,0.0020571}, {1320,0.0020857}, {1330,0.0078857}, {1340,0.0022286}, {1350,0.0022000}, {1360,0.0019143}, {1370,0.0021429}, {1380,0.0020857}, {1390,0.0022286}, {1400,0.0021143}, {1410,0.0020857}, {1420,0.0018571}, {1430,0.0024000}, {1440,0.0018000}, {1450,0.0017143}, {1460,0.0018286}, {1470,0.0015714}, {1480,0.0019714}, {1490,0.0022857}, {1500,0.0014000}, {1510,0.0022571}, {1520,0.0022571}, {1530,0.0022857}, {1540,0.0021714}, {1550,0.0020857}, {1560,0.0030571}, {1570,0.0024857}, {1580,0.0020857}, {1590,0.0024857}, {1600,0.0024286}, {1610,0.0026000}, {1620,0.0027429}, {1630,0.0027714}, {1640,0.0026857}, {1650,0.0020571}, {1660,0.0024571}, {1670,0.0030857}, {1680,0.0026571}, {1690,0.0024286}, {1700,0.0026286}, {1710,0.0071143}, {1720,0.0028571}, {1730,0.0028571}, {1740,0.0025714}, {1750,0.0030571}, {1760,0.0027714}, {1770,0.0027429}, {1780,0.0026286}, {1790,0.0029143}, {1800,0.0028000}, {1810,0.0025143}, {1820,0.0035143}, {1830,0.0029429}, {1840,0.0031143}, {1850,0.0030286}, {1860,0.0035143}, {1870,0.0028286}, {1880,0.0030571}, {1890,0.0031714}, {1900,0.0032571}, {1910,0.0098000}, {1920,0.0035143}, {1930,0.0033714}, {1940,0.0028000}, {1950,0.0030000}, {1960,0.0034000}, {1970,0.0033143}, {1980,0.0032000}, {1990,0.0034286}, {2000,0.0033143}};
data["big"]["LtacTacInTermPrimPair"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00003960}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00003960}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00011881}, {110,0.00003960}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00003960}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00003960}, {132,0.00000000}, {133,0.00003960}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00003960}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00003960}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00003960}, {235,0.00000000}, {236,0.00003960}, {237,0.00000000}, {238,0.00003960}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00003960}, {274,0.00003960}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00003960}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0001143}, {410,0.0000000}, {411,0.0000000}, {412,0.0001143}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0001143}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0001143}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0001143}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0001143}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0001143}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0001143}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0001143}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000857}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0001143}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000857}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000857}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0001143}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermPrimPair"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0020286}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000286}, {810,0.0000286}, {815,0.0000000}, {820,0.0000000}, {825,0.0000571}, {830,0.0000286}, {835,0.0000571}, {840,0.0000286}, {845,0.0000000}, {850,0.0000000}, {855,0.0000286}, {860,0.0000571}, {865,0.0001429}, {870,0.0001714}, {875,0.0002000}, {880,0.0002286}, {885,0.0002571}, {890,0.0002571}, {895,0.0004286}, {900,0.0005143}, {905,0.0006571}, {910,0.0006857}, {915,0.0006857}, {920,0.0007429}, {925,0.0008857}, {930,0.0007714}, {935,0.0009143}, {940,0.0008857}, {945,0.0010000}, {950,0.0010000}, {955,0.0010000}, {960,0.0010000}, {965,0.0010000}, {970,0.0010000}, {975,0.0010000}, {980,0.0010000}, {985,0.0010000}, {990,0.0010000}, {995,0.0010000}, {1000,0.0010000}, {1010,0.0010000}, {1020,0.0010000}, {1030,0.0010000}, {1040,0.0010000}, {1050,0.0010000}, {1060,0.0010000}, {1070,0.0010000}, {1080,0.0010000}, {1090,0.0010000}, {1100,0.0010000}, {1110,0.0024286}, {1120,0.0010000}, {1130,0.0010000}, {1140,0.0010000}, {1150,0.0010000}, {1160,0.0010000}, {1170,0.0010000}, {1180,0.0010000}, {1190,0.0010000}, {1200,0.0010000}, {1210,0.0010000}, {1220,0.0010000}, {1230,0.0010000}, {1240,0.0010000}, {1250,0.0010000}, {1260,0.0010000}, {1270,0.0010000}, {1280,0.0010000}, {1290,0.0010000}, {1300,0.0010000}, {1310,0.0010000}, {1320,0.0010000}, {1330,0.0010000}, {1340,0.0010000}, {1350,0.0010000}, {1360,0.0010000}, {1370,0.0010000}, {1380,0.0010000}, {1390,0.0010000}, {1400,0.0010000}, {1410,0.0010000}, {1420,0.0052286}, {1430,0.0010000}, {1440,0.0010000}, {1450,0.0010000}, {1460,0.0010000}, {1470,0.0010000}, {1480,0.0010000}, {1490,0.0010000}, {1500,0.0010000}, {1510,0.0010000}, {1520,0.0010000}, {1530,0.0010000}, {1540,0.0010000}, {1550,0.0010000}, {1560,0.0010000}, {1570,0.0010000}, {1580,0.0010286}, {1590,0.0010000}, {1600,0.0010000}, {1610,0.0010000}, {1620,0.0010286}, {1630,0.0010000}, {1640,0.0010000}, {1650,0.0010000}, {1660,0.0010286}, {1670,0.0010286}, {1680,0.0010571}, {1690,0.0010000}, {1700,0.0010857}, {1710,0.0010286}, {1720,0.0010571}, {1730,0.0010571}, {1740,0.0011429}, {1750,0.0011429}, {1760,0.0011714}, {1770,0.0012857}, {1780,0.0013143}, {1790,0.0013714}, {1800,0.0014571}, {1810,0.0014286}, {1820,0.0016857}, {1830,0.0017429}, {1840,0.0017429}, {1850,0.0018571}, {1860,0.0018286}, {1870,0.0046857}, {1880,0.0020000}, {1890,0.0019714}, {1900,0.0019714}, {1910,0.0019714}, {1920,0.0020000}, {1930,0.0020000}, {1940,0.0020000}, {1950,0.0020000}, {1960,0.0020286}, {1970,0.0020000}, {1980,0.0020000}, {1990,0.0020000}, {2000,0.0020000}};
data["big"]["LtacTacInTermPrimPair"]["eval lazy"]["user"] = {{1,0.00003960}, {2,0.00002970}, {3,0.00000000}, {4,0.00003960}, {5,0.00003960}, {6,0.00000000}, {7,0.00007921}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003960}, {13,0.00003960}, {14,0.00000000}, {15,0.00007921}, {16,0.00018812}, {17,0.00006931}, {18,0.00003960}, {19,0.00000000}, {20,0.00000000}, {21,0.00003960}, {22,0.00003960}, {23,0.00003960}, {24,0.00007921}, {25,0.00000000}, {26,0.00003960}, {27,0.00009901}, {28,0.00003960}, {29,0.00003960}, {30,0.00000000}, {31,0.00013861}, {32,0.00011881}, {33,0.00002970}, {34,0.00003960}, {35,0.00006931}, {36,0.00023762}, {37,0.00000000}, {38,0.00003960}, {39,0.00000000}, {40,0.00014851}, {41,0.00014851}, {42,0.00003960}, {43,0.00006931}, {44,0.00002970}, {45,0.00003960}, {46,0.00007921}, {47,0.00007921}, {48,0.00007921}, {49,0.00011881}, {50,0.00011881}, {51,0.00007921}, {52,0.00007921}, {53,0.00006931}, {54,0.00000000}, {55,0.00014851}, {56,0.00015842}, {57,0.00006931}, {58,0.00007921}, {59,0.00006931}, {60,0.00014851}, {61,0.00011881}, {62,0.00000000}, {63,0.00021782}, {64,0.00003960}, {65,0.00015842}, {66,0.00019802}, {67,0.00014851}, {68,0.00015842}, {69,0.00022772}, {70,0.00030693}, {71,0.00015842}, {72,0.00017822}, {73,0.00011881}, {74,0.00007921}, {75,0.00007921}, {76,0.00015842}, {77,0.00018812}, {78,0.00010891}, {79,0.00011881}, {80,0.00021782}, {81,0.00006931}, {82,0.00018812}, {83,0.00007921}, {84,0.00023762}, {85,0.00010891}, {86,0.00003960}, {87,0.00023762}, {88,0.00022772}, {89,0.00020792}, {90,0.00015842}, {91,0.00022772}, {92,0.00010891}, {93,0.00005941}, {94,0.00022772}, {95,0.00011881}, {96,0.00011881}, {97,0.00019802}, {98,0.00011881}, {99,0.00016832}, {100,0.00022772}, {101,0.00005941}, {102,0.00014851}, {103,0.00003960}, {104,0.00023762}, {105,0.00023762}, {106,0.00006931}, {107,0.00017822}, {108,0.00011881}, {109,0.00014851}, {110,0.00010891}, {111,0.00011881}, {112,0.00037624}, {113,0.00007921}, {114,0.00007921}, {115,0.00026733}, {116,0.00018812}, {117,0.00030693}, {118,0.00014851}, {119,0.00010891}, {120,0.00021782}, {121,0.00014851}, {122,0.00015842}, {123,0.00013861}, {124,0.00015842}, {125,0.00003960}, {126,0.00021782}, {127,0.00030693}, {128,0.00010891}, {129,0.00018812}, {130,0.00018812}, {131,0.00010891}, {132,0.00011881}, {133,0.00003960}, {134,0.00015842}, {135,0.00019802}, {136,0.00019802}, {137,0.00015842}, {138,0.00019802}, {139,0.00021782}, {140,0.00018812}, {141,0.00021782}, {142,0.00011881}, {143,0.00018812}, {144,0.00011881}, {145,0.00010891}, {146,0.00016832}, {147,0.00011881}, {148,0.00015842}, {149,0.00026733}, {150,0.00041584}, {151,0.00022772}, {152,0.00021782}, {153,0.00027723}, {154,0.00022772}, {155,0.00022772}, {156,0.00026733}, {157,0.00022772}, {158,0.00026733}, {159,0.00023762}, {160,0.00022772}, {161,0.00011881}, {162,0.00023762}, {163,0.00023762}, {164,0.00025743}, {165,0.00014851}, {166,0.00030693}, {167,0.00017822}, {168,0.00025743}, {169,0.00013861}, {170,0.00023762}, {171,0.00018812}, {172,0.00014851}, {173,0.00010891}, {174,0.00023762}, {175,0.00030693}, {176,0.00015842}, {177,0.00015842}, {178,0.00027723}, {179,0.00007921}, {180,0.00019802}, {181,0.00022772}, {182,0.00033663}, {183,0.00015842}, {184,0.00028713}, {185,0.00007921}, {186,0.00025743}, {187,0.00015842}, {188,0.00023762}, {189,0.00028713}, {190,0.00034653}, {191,0.00049505}, {192,0.00029703}, {193,0.00013861}, {194,0.00036634}, {195,0.00037624}, {196,0.00030693}, {197,0.00034653}, {198,0.00030693}, {199,0.00021782}, {200,0.00037624}, {201,0.00023762}, {202,0.00007921}, {203,0.00031683}, {204,0.00031683}, {205,0.00031683}, {206,0.00029703}, {207,0.00022772}, {208,0.00054455}, {209,0.00029703}, {210,0.00027723}, {211,0.00018812}, {212,0.00011881}, {213,0.00037624}, {214,0.00034653}, {215,0.00034653}, {216,0.00007921}, {217,0.00038614}, {218,0.00024752}, {219,0.00027723}, {220,0.00045545}, {221,0.00026733}, {222,0.00034653}, {223,0.00024752}, {224,0.00018812}, {225,0.00018812}, {226,0.00038614}, {227,0.00026733}, {228,0.00022772}, {229,0.00026733}, {230,0.00021782}, {231,0.00015842}, {232,0.00022772}, {233,0.00036634}, {234,0.00035644}, {235,0.00036634}, {236,0.00021782}, {237,0.00045545}, {238,0.00013861}, {239,0.00022772}, {240,0.00013861}, {241,0.00049505}, {242,0.00033663}, {243,0.00011881}, {244,0.00027723}, {245,0.00023762}, {246,0.00019802}, {247,0.00025743}, {248,0.00034653}, {249,0.00037624}, {250,0.00032673}, {251,0.00032673}, {252,0.00044554}, {253,0.00026733}, {254,0.00025743}, {255,0.00045545}, {256,0.00041584}, {257,0.00025743}, {258,0.00014851}, {259,0.00010891}, {260,0.00041584}, {261,0.00018812}, {262,0.00035644}, {263,0.00019802}, {264,0.00010891}, {265,0.00037624}, {266,0.00025743}, {267,0.00019802}, {268,0.00034653}, {269,0.00023762}, {270,0.00012871}, {271,0.00040594}, {272,0.00029703}, {273,0.00019802}, {274,0.00048515}, {275,0.00025743}, {276,0.00030693}, {277,0.00040594}, {278,0.00032673}, {279,0.00037624}, {280,0.00025743}, {281,0.00028713}, {282,0.00020792}, {283,0.00036634}, {284,0.00026733}, {285,0.00031683}, {286,0.00018812}, {287,0.00006931}, {288,0.00026733}, {289,0.00038614}, {290,0.00012871}, {291,0.00012871}, {292,0.00020792}, {293,0.00036634}, {294,0.00025743}, {295,0.00018812}, {296,0.00013861}, {297,0.00022772}, {298,0.00009901}, {299,0.00038614}, {300,0.00027723}, {301,0.0005429}, {302,0.0002857}, {303,0.0005429}, {304,0.0003714}, {305,0.0004857}, {306,0.0001714}, {307,0.0000857}, {308,0.0004286}, {309,0.0000857}, {310,0.0000000}, {311,0.0003714}, {312,0.0002571}, {313,0.0002000}, {314,0.0001714}, {315,0.0005143}, {316,0.0003714}, {317,0.0001714}, {318,0.0004286}, {319,0.0003429}, {320,0.0003429}, {321,0.0002000}, {322,0.0004571}, {323,0.0005429}, {324,0.0004571}, {325,0.0006000}, {326,0.0002857}, {327,0.0002571}, {328,0.0002000}, {329,0.0002571}, {330,0.0005714}, {331,0.0003429}, {332,0.0000857}, {333,0.0003429}, {334,0.0001714}, {335,0.0004000}, {336,0.0003143}, {337,0.0002571}, {338,0.0001714}, {339,0.0000857}, {340,0.0008000}, {341,0.0000857}, {342,0.0002857}, {343,0.0003429}, {344,0.0004571}, {345,0.0004857}, {346,0.0004286}, {347,0.0001714}, {348,0.0002857}, {349,0.0002000}, {350,0.0002571}, {351,0.0004571}, {352,0.0002857}, {353,0.0001714}, {354,0.0002571}, {355,0.0003714}, {356,0.0002286}, {357,0.0000857}, {358,0.0002000}, {359,0.0002571}, {360,0.0005714}, {361,0.0003714}, {362,0.0000000}, {363,0.0005429}, {364,0.0003714}, {365,0.0003429}, {366,0.0001714}, {367,0.0004286}, {368,0.0005714}, {369,0.0007429}, {370,0.0003143}, {371,0.0000857}, {372,0.0002000}, {373,0.0003714}, {374,0.0005143}, {375,0.0004571}, {376,0.0002857}, {377,0.0003714}, {378,0.0000000}, {379,0.0002857}, {380,0.0005714}, {381,0.0001143}, {382,0.0003429}, {383,0.0004857}, {384,0.0000857}, {385,0.0004857}, {386,0.0003714}, {387,0.0004286}, {388,0.0003714}, {389,0.0006286}, {390,0.0000857}, {391,0.0005429}, {392,0.0003714}, {393,0.0004286}, {394,0.0003714}, {395,0.0006000}, {396,0.0003714}, {397,0.0002857}, {398,0.0002571}, {399,0.0005429}, {400,0.0004571}, {401,0.0002857}, {402,0.0005143}, {403,0.0002000}, {404,0.0002000}, {405,0.0002571}, {406,0.0002286}, {407,0.0002571}, {408,0.0003714}, {409,0.0006286}, {410,0.0003429}, {411,0.0003429}, {412,0.0021714}, {413,0.0001714}, {414,0.0005143}, {415,0.0004571}, {416,0.0003714}, {417,0.0004000}, {418,0.0002571}, {419,0.0001714}, {420,0.0005429}, {421,0.0002571}, {422,0.0003429}, {423,0.0000000}, {424,0.0002571}, {425,0.0003143}, {426,0.0005429}, {427,0.0004857}, {428,0.0003429}, {429,0.0006857}, {430,0.0001714}, {431,0.0006000}, {432,0.0005143}, {433,0.0000857}, {434,0.0004571}, {435,0.0005714}, {436,0.0003429}, {437,0.0003429}, {438,0.0000857}, {439,0.0008857}, {440,0.0005429}, {441,0.0007143}, {442,0.0004571}, {443,0.0003429}, {444,0.0003714}, {445,0.0001714}, {446,0.0003714}, {447,0.0002571}, {448,0.0004000}, {449,0.0004000}, {450,0.0001714}, {451,0.0006286}, {452,0.0003714}, {453,0.0002571}, {454,0.0008000}, {455,0.0001714}, {456,0.0006857}, {457,0.0006857}, {458,0.0012286}, {459,0.0004000}, {460,0.0004000}, {461,0.0002857}, {462,0.0004000}, {463,0.0006286}, {464,0.0003714}, {465,0.0004286}, {466,0.0003714}, {467,0.0003714}, {468,0.0003143}, {469,0.0002571}, {470,0.0004286}, {471,0.0005143}, {472,0.0002857}, {473,0.0005429}, {474,0.0005143}, {475,0.0007714}, {476,0.0003429}, {477,0.0004286}, {478,0.0003714}, {479,0.0003429}, {480,0.0003429}, {481,0.0002571}, {482,0.0006000}, {483,0.0004286}, {484,0.0003429}, {485,0.0006000}, {486,0.0004286}, {487,0.0004571}, {488,0.0006000}, {489,0.0004571}, {490,0.0002000}, {491,0.0005143}, {492,0.0007143}, {493,0.0003429}, {494,0.0003429}, {495,0.0006000}, {496,0.0005143}, {497,0.0005429}, {498,0.0002571}, {499,0.0005143}, {500,0.0006000}, {505,0.0005143}, {510,0.0002571}, {515,0.0005143}, {520,0.0008000}, {525,0.0005143}, {530,0.0000857}, {535,0.0006000}, {540,0.0002857}, {545,0.0005143}, {550,0.0005143}, {555,0.0003429}, {560,0.0007143}, {565,0.0003714}, {570,0.0004571}, {575,0.0003429}, {580,0.0007429}, {585,0.0003429}, {590,0.0009714}, {595,0.0005429}, {600,0.0007714}, {605,0.0006000}, {610,0.0002571}, {615,0.0005429}, {620,0.0006857}, {625,0.0008000}, {630,0.0003429}, {635,0.0005143}, {640,0.0007429}, {645,0.0004286}, {650,0.0009143}, {655,0.0005143}, {660,0.0008286}, {665,0.0007714}, {670,0.0002857}, {675,0.0006286}, {680,0.0005429}, {685,0.0007429}, {690,0.0009429}, {695,0.0005143}, {700,0.0008571}, {705,0.0003429}, {710,0.0006000}, {715,0.0009143}, {720,0.0006286}, {725,0.0005143}, {730,0.0006000}, {735,0.0005429}, {740,0.0010000}, {745,0.0010286}, {750,0.0005429}, {755,0.0010571}, {760,0.0004857}, {765,0.0007714}, {770,0.0005143}, {775,0.0006286}, {780,0.0007143}, {785,0.0008000}, {790,0.0006571}, {795,0.0006286}, {800,0.0005143}, {805,0.0006000}, {810,0.0004286}, {815,0.0006000}, {820,0.0009429}, {825,0.0003714}, {830,0.0009429}, {835,0.0006571}, {840,0.0005143}, {845,0.0007143}, {850,0.0004286}, {855,0.0007143}, {860,0.0007429}, {865,0.0008857}, {870,0.0010857}, {875,0.0009143}, {880,0.0005429}, {885,0.0001714}, {890,0.0006857}, {895,0.0006000}, {900,0.0008571}, {905,0.0013429}, {910,0.0008000}, {915,0.0007143}, {920,0.0008000}, {925,0.0013429}, {930,0.0010000}, {935,0.0005429}, {940,0.0010857}, {945,0.0006286}, {950,0.0006857}, {955,0.0009714}, {960,0.0007143}, {965,0.0006286}, {970,0.0008571}, {975,0.0007143}, {980,0.0007143}, {985,0.0010000}, {990,0.0008857}, {995,0.0009429}, {1000,0.0012571}, {1010,0.0006286}, {1020,0.0006286}, {1030,0.0007714}, {1040,0.0009714}, {1050,0.0019143}, {1060,0.0011143}, {1070,0.0012286}, {1080,0.0011714}, {1090,0.0011429}, {1100,0.0010571}, {1110,0.0023714}, {1120,0.0014000}, {1130,0.0010286}, {1140,0.0016000}, {1150,0.0008571}, {1160,0.0011714}, {1170,0.0007714}, {1180,0.0012000}, {1190,0.0018857}, {1200,0.0005143}, {1210,0.0007429}, {1220,0.0009429}, {1230,0.0014571}, {1240,0.0006857}, {1250,0.0012000}, {1260,0.0013429}, {1270,0.0008000}, {1280,0.0017143}, {1290,0.0011429}, {1300,0.0013429}, {1310,0.0010857}, {1320,0.0017714}, {1330,0.0008857}, {1340,0.0012571}, {1350,0.0017714}, {1360,0.0016571}, {1370,0.0012571}, {1380,0.0008857}, {1390,0.0014000}, {1400,0.0016857}, {1410,0.0012000}, {1420,0.0048571}, {1430,0.0015143}, {1440,0.0015429}, {1450,0.0011714}, {1460,0.0014571}, {1470,0.0019429}, {1480,0.0015429}, {1490,0.0012286}, {1500,0.0012286}, {1510,0.0011143}, {1520,0.0016571}, {1530,0.0014286}, {1540,0.0017143}, {1550,0.0018857}, {1560,0.0012857}, {1570,0.0010857}, {1580,0.0013714}, {1590,0.0023429}, {1600,0.0021143}, {1610,0.0022571}, {1620,0.0015714}, {1630,0.0018286}, {1640,0.0025143}, {1650,0.0016286}, {1660,0.0015143}, {1670,0.0015714}, {1680,0.0016571}, {1690,0.0018286}, {1700,0.0009143}, {1710,0.0020571}, {1720,0.0023143}, {1730,0.0020571}, {1740,0.0016857}, {1750,0.0017143}, {1760,0.0023429}, {1770,0.0012286}, {1780,0.0021143}, {1790,0.0020857}, {1800,0.0014571}, {1810,0.0022286}, {1820,0.0021143}, {1830,0.0020000}, {1840,0.0016000}, {1850,0.0022000}, {1860,0.0019714}, {1870,0.0047429}, {1880,0.0021429}, {1890,0.0020000}, {1900,0.0021143}, {1910,0.0016857}, {1920,0.0022000}, {1930,0.0026571}, {1940,0.0024000}, {1950,0.0021714}, {1960,0.0028000}, {1970,0.0024286}, {1980,0.0018857}, {1990,0.0019714}, {2000,0.0021143}};
data["big"]["LtacTacInTermPrimPair"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00003960}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00003960}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00003960}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00003960}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00003960}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00003960}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00003960}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00003960}, {239,0.00003960}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00003960}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00003960}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0001143}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0001143}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0001143}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0001143}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0001143}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0001143}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0001143}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0001143}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0001143}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0001143}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000857}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000857}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0001714}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000857}, {1810,0.0000857}, {1820,0.0000000}, {1830,0.0001143}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000857}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermPrimPair"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00206931}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0002000}, {1340,0.0000000}, {1350,0.0000286}, {1360,0.0000286}, {1370,0.0000000}, {1380,0.0000571}, {1390,0.0000857}, {1400,0.0001429}, {1410,0.0001429}, {1420,0.0001143}, {1430,0.0001429}, {1440,0.0001429}, {1450,0.0001714}, {1460,0.0002286}, {1470,0.0002000}, {1480,0.0002000}, {1490,0.0001714}, {1500,0.0001714}, {1510,0.0002571}, {1520,0.0042571}, {1530,0.0002000}, {1540,0.0002571}, {1550,0.0002857}, {1560,0.0003143}, {1570,0.0004857}, {1580,0.0004857}, {1590,0.0005714}, {1600,0.0008571}, {1610,0.0008571}, {1620,0.0010000}, {1630,0.0010000}, {1640,0.0010000}, {1650,0.0010000}, {1660,0.0010000}, {1670,0.0010000}, {1680,0.0010000}, {1690,0.0010000}, {1700,0.0010000}, {1710,0.0010000}, {1720,0.0010000}, {1730,0.0010000}, {1740,0.0010000}, {1750,0.0010000}, {1760,0.0010000}, {1770,0.0010000}, {1780,0.0010000}, {1790,0.0010000}, {1800,0.0010000}, {1810,0.0010000}, {1820,0.0010000}, {1830,0.0010000}, {1840,0.0010000}, {1850,0.0010000}, {1860,0.0010000}, {1870,0.0010000}, {1880,0.0010000}, {1890,0.0010000}, {1900,0.0010000}, {1910,0.0010000}, {1920,0.0010000}, {1930,0.0010000}, {1940,0.0010000}, {1950,0.0010000}, {1960,0.0010000}, {1970,0.0010000}, {1980,0.0010000}, {1990,0.0010000}, {2000,0.0010000}};
data["big"]["LtacTacInTermPrimPair"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00006931}, {6,0.00000000}, {7,0.00000000}, {8,0.00007921}, {9,0.00003960}, {10,0.00007921}, {11,0.00000000}, {12,0.00003960}, {13,0.00011881}, {14,0.00000000}, {15,0.00000000}, {16,0.00003960}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00003960}, {21,0.00000000}, {22,0.00000000}, {23,0.00002970}, {24,0.00003960}, {25,0.00011881}, {26,0.00000000}, {27,0.00007921}, {28,0.00007921}, {29,0.00000000}, {30,0.00000000}, {31,0.00003960}, {32,0.00000000}, {33,0.00003960}, {34,0.00000000}, {35,0.00000000}, {36,0.00003960}, {37,0.00007921}, {38,0.00000000}, {39,0.00000000}, {40,0.00003960}, {41,0.00007921}, {42,0.00003960}, {43,0.00007921}, {44,0.00000000}, {45,0.00006931}, {46,0.00003960}, {47,0.00007921}, {48,0.00007921}, {49,0.00003960}, {50,0.00011881}, {51,0.00003960}, {52,0.00000000}, {53,0.00007921}, {54,0.00014851}, {55,0.00000000}, {56,0.00010891}, {57,0.00006931}, {58,0.00000000}, {59,0.00003960}, {60,0.00003960}, {61,0.00007921}, {62,0.00006931}, {63,0.00003960}, {64,0.00000000}, {65,0.00000000}, {66,0.00014851}, {67,0.00015842}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00007921}, {72,0.00000000}, {73,0.00011881}, {74,0.00011881}, {75,0.00018812}, {76,0.00000000}, {77,0.00010891}, {78,0.00010891}, {79,0.00009901}, {80,0.00010891}, {81,0.00011881}, {82,0.00007921}, {83,0.00003960}, {84,0.00007921}, {85,0.00003960}, {86,0.00022772}, {87,0.00006931}, {88,0.00002970}, {89,0.00014851}, {90,0.00015842}, {91,0.00011881}, {92,0.00018812}, {93,0.00000000}, {94,0.00011881}, {95,0.00003960}, {96,0.00002970}, {97,0.00010891}, {98,0.00007921}, {99,0.00007921}, {100,0.00003960}, {101,0.00011881}, {102,0.00015842}, {103,0.00000000}, {104,0.00007921}, {105,0.00010891}, {106,0.00006931}, {107,0.00003960}, {108,0.00022772}, {109,0.00014851}, {110,0.00003960}, {111,0.00014851}, {112,0.00007921}, {113,0.00010891}, {114,0.00007921}, {115,0.00003960}, {116,0.00007921}, {117,0.00000000}, {118,0.00015842}, {119,0.00007921}, {120,0.00007921}, {121,0.00011881}, {122,0.00023762}, {123,0.00013861}, {124,0.00014851}, {125,0.00007921}, {126,0.00003960}, {127,0.00022772}, {128,0.00002970}, {129,0.00010891}, {130,0.00009901}, {131,0.00007921}, {132,0.00015842}, {133,0.00015842}, {134,0.00007921}, {135,0.00011881}, {136,0.00007921}, {137,0.00010891}, {138,0.00007921}, {139,0.00021782}, {140,0.00015842}, {141,0.00011881}, {142,0.00007921}, {143,0.00019802}, {144,0.00014851}, {145,0.00006931}, {146,0.00007921}, {147,0.00003960}, {148,0.00009901}, {149,0.00013861}, {150,0.00011881}, {151,0.00014851}, {152,0.00019802}, {153,0.00010891}, {154,0.00020792}, {155,0.00015842}, {156,0.00013861}, {157,0.00007921}, {158,0.00019802}, {159,0.00005941}, {160,0.00008911}, {161,0.00007921}, {162,0.00011881}, {163,0.00022772}, {164,0.00014851}, {165,0.00013861}, {166,0.00022772}, {167,0.00011881}, {168,0.00018812}, {169,0.00015842}, {170,0.00015842}, {171,0.00006931}, {172,0.00027723}, {173,0.00007921}, {174,0.00007921}, {175,0.00019802}, {176,0.00006931}, {177,0.00017822}, {178,0.00015842}, {179,0.00010891}, {180,0.00019802}, {181,0.00003960}, {182,0.00014851}, {183,0.00023762}, {184,0.00014851}, {185,0.00006931}, {186,0.00011881}, {187,0.00025743}, {188,0.00000000}, {189,0.00017822}, {190,0.00022772}, {191,0.00014851}, {192,0.00003960}, {193,0.00018812}, {194,0.00015842}, {195,0.00026733}, {196,0.00011881}, {197,0.00029703}, {198,0.00007921}, {199,0.00000000}, {200,0.00019802}, {201,0.00007921}, {202,0.00015842}, {203,0.00011881}, {204,0.00015842}, {205,0.00006931}, {206,0.00018812}, {207,0.00015842}, {208,0.00011881}, {209,0.00022772}, {210,0.00015842}, {211,0.00013861}, {212,0.00015842}, {213,0.00018812}, {214,0.00022772}, {215,0.00010891}, {216,0.00015842}, {217,0.00014851}, {218,0.00014851}, {219,0.00022772}, {220,0.00027723}, {221,0.00027723}, {222,0.00014851}, {223,0.00019802}, {224,0.00003960}, {225,0.00014851}, {226,0.00007921}, {227,0.00022772}, {228,0.00015842}, {229,0.00007921}, {230,0.00019802}, {231,0.00003960}, {232,0.00018812}, {233,0.00021782}, {234,0.00011881}, {235,0.00018812}, {236,0.00011881}, {237,0.00011881}, {238,0.00015842}, {239,0.00023762}, {240,0.00014851}, {241,0.00011881}, {242,0.00009901}, {243,0.00018812}, {244,0.00000000}, {245,0.00010891}, {246,0.00023762}, {247,0.00019802}, {248,0.00009901}, {249,0.00022772}, {250,0.00037624}, {251,0.00007921}, {252,0.00022772}, {253,0.00006931}, {254,0.00018812}, {255,0.00034653}, {256,0.00031683}, {257,0.00010891}, {258,0.00020792}, {259,0.00017822}, {260,0.00020792}, {261,0.00006931}, {262,0.00012871}, {263,0.00017822}, {264,0.00027723}, {265,0.00018812}, {266,0.00009901}, {267,0.00010891}, {268,0.00015842}, {269,0.00012871}, {270,0.00029703}, {271,0.00006931}, {272,0.00018812}, {273,0.00021782}, {274,0.00016832}, {275,0.00019802}, {276,0.00013861}, {277,0.00041584}, {278,0.00023762}, {279,0.00034653}, {280,0.00242574}, {281,0.00017822}, {282,0.00021782}, {283,0.00013861}, {284,0.00020792}, {285,0.00015842}, {286,0.00012871}, {287,0.00029703}, {288,0.00026733}, {289,0.00021782}, {290,0.00027723}, {291,0.00020792}, {292,0.00015842}, {293,0.00026733}, {294,0.00020792}, {295,0.00023762}, {296,0.00020792}, {297,0.00020792}, {298,0.00014851}, {299,0.00014851}, {300,0.00027723}, {301,0.0002857}, {302,0.0003714}, {303,0.0000857}, {304,0.0000857}, {305,0.0001714}, {306,0.0003143}, {307,0.0001714}, {308,0.0000857}, {309,0.0002857}, {310,0.0003143}, {311,0.0004286}, {312,0.0001714}, {313,0.0002000}, {314,0.0000000}, {315,0.0001714}, {316,0.0000857}, {317,0.0002000}, {318,0.0003714}, {319,0.0002571}, {320,0.0001714}, {321,0.0000857}, {322,0.0000857}, {323,0.0002000}, {324,0.0002857}, {325,0.0002571}, {326,0.0002857}, {327,0.0001714}, {328,0.0004571}, {329,0.0001714}, {330,0.0002571}, {331,0.0004286}, {332,0.0001714}, {333,0.0002000}, {334,0.0004000}, {335,0.0002857}, {336,0.0000857}, {337,0.0000857}, {338,0.0002857}, {339,0.0002571}, {340,0.0002000}, {341,0.0006000}, {342,0.0002857}, {343,0.0003429}, {344,0.0002857}, {345,0.0000857}, {346,0.0004286}, {347,0.0002857}, {348,0.0005143}, {349,0.0000000}, {350,0.0001143}, {351,0.0002000}, {352,0.0001714}, {353,0.0002571}, {354,0.0001714}, {355,0.0000857}, {356,0.0002857}, {357,0.0001714}, {358,0.0000000}, {359,0.0004857}, {360,0.0001714}, {361,0.0002571}, {362,0.0000000}, {363,0.0002000}, {364,0.0002857}, {365,0.0002286}, {366,0.0003429}, {367,0.0002000}, {368,0.0002000}, {369,0.0004857}, {370,0.0001714}, {371,0.0002000}, {372,0.0004286}, {373,0.0005429}, {374,0.0000000}, {375,0.0004000}, {376,0.0002857}, {377,0.0000000}, {378,0.0004571}, {379,0.0004571}, {380,0.0008857}, {381,0.0003143}, {382,0.0003429}, {383,0.0000857}, {384,0.0002857}, {385,0.0002571}, {386,0.0000857}, {387,0.0002857}, {388,0.0000857}, {389,0.0000000}, {390,0.0000857}, {391,0.0002571}, {392,0.0002000}, {393,0.0004857}, {394,0.0004000}, {395,0.0000000}, {396,0.0003714}, {397,0.0002000}, {398,0.0002571}, {399,0.0001143}, {400,0.0002571}, {401,0.0004286}, {402,0.0002857}, {403,0.0001143}, {404,0.0001714}, {405,0.0002857}, {406,0.0000857}, {407,0.0003714}, {408,0.0001143}, {409,0.0000857}, {410,0.0000857}, {411,0.0002000}, {412,0.0000857}, {413,0.0002000}, {414,0.0001714}, {415,0.0002000}, {416,0.0001143}, {417,0.0005429}, {418,0.0000857}, {419,0.0003714}, {420,0.0006571}, {421,0.0000857}, {422,0.0002571}, {423,0.0001714}, {424,0.0005429}, {425,0.0002571}, {426,0.0001143}, {427,0.0000857}, {428,0.0002571}, {429,0.0002857}, {430,0.0002857}, {431,0.0001714}, {432,0.0000857}, {433,0.0003429}, {434,0.0003143}, {435,0.0002857}, {436,0.0002571}, {437,0.0003714}, {438,0.0004000}, {439,0.0003714}, {440,0.0004286}, {441,0.0002571}, {442,0.0002857}, {443,0.0003429}, {444,0.0004000}, {445,0.0002857}, {446,0.0002571}, {447,0.0000857}, {448,0.0001714}, {449,0.0004286}, {450,0.0004571}, {451,0.0000857}, {452,0.0000857}, {453,0.0007429}, {454,0.0001714}, {455,0.0004857}, {456,0.0000000}, {457,0.0001143}, {458,0.0003714}, {459,0.0002571}, {460,0.0004857}, {461,0.0003714}, {462,0.0001714}, {463,0.0002000}, {464,0.0003714}, {465,0.0002286}, {466,0.0001714}, {467,0.0002857}, {468,0.0002571}, {469,0.0000857}, {470,0.0002857}, {471,0.0002571}, {472,0.0000857}, {473,0.0001143}, {474,0.0001714}, {475,0.0002571}, {476,0.0003714}, {477,0.0001714}, {478,0.0000000}, {479,0.0004571}, {480,0.0003714}, {481,0.0009143}, {482,0.0003429}, {483,0.0001714}, {484,0.0002000}, {485,0.0001714}, {486,0.0002000}, {487,0.0002571}, {488,0.0000857}, {489,0.0002571}, {490,0.0005429}, {491,0.0002571}, {492,0.0002571}, {493,0.0000000}, {494,0.0000857}, {495,0.0003714}, {496,0.0000857}, {497,0.0003714}, {498,0.0006000}, {499,0.0000857}, {500,0.0001714}, {505,0.0002000}, {510,0.0004286}, {515,0.0002571}, {520,0.0003714}, {525,0.0001714}, {530,0.0003429}, {535,0.0003429}, {540,0.0001714}, {545,0.0006000}, {550,0.0000857}, {555,0.0002571}, {560,0.0004286}, {565,0.0000857}, {570,0.0005143}, {575,0.0004286}, {580,0.0003429}, {585,0.0001714}, {590,0.0001714}, {595,0.0002857}, {600,0.0002571}, {605,0.0005714}, {610,0.0005143}, {615,0.0005143}, {620,0.0000857}, {625,0.0004571}, {630,0.0004286}, {635,0.0005143}, {640,0.0002571}, {645,0.0001143}, {650,0.0003429}, {655,0.0003429}, {660,0.0001714}, {665,0.0002571}, {670,0.0003429}, {675,0.0003429}, {680,0.0005714}, {685,0.0002857}, {690,0.0004286}, {695,0.0002571}, {700,0.0001714}, {705,0.0002857}, {710,0.0003714}, {715,0.0003429}, {720,0.0003429}, {725,0.0008000}, {730,0.0000857}, {735,0.0003429}, {740,0.0001714}, {745,0.0005143}, {750,0.0002571}, {755,0.0003143}, {760,0.0007143}, {765,0.0001714}, {770,0.0005429}, {775,0.0003429}, {780,0.0004571}, {785,0.0003429}, {790,0.0003714}, {795,0.0006000}, {800,0.0007429}, {805,0.0003429}, {810,0.0004286}, {815,0.0002000}, {820,0.0004000}, {825,0.0003429}, {830,0.0005143}, {835,0.0002857}, {840,0.0007143}, {845,0.0003714}, {850,0.0003429}, {855,0.0002571}, {860,0.0004286}, {865,0.0004286}, {870,0.0006000}, {875,0.0003429}, {880,0.0009714}, {885,0.0005429}, {890,0.0004286}, {895,0.0006000}, {900,0.0004286}, {905,0.0002000}, {910,0.0006000}, {915,0.0002571}, {920,0.0006286}, {925,0.0002571}, {930,0.0003714}, {935,0.0007143}, {940,0.0004571}, {945,0.0006857}, {950,0.0006571}, {955,0.0002571}, {960,0.0007714}, {965,0.0005143}, {970,0.0008286}, {975,0.0007143}, {980,0.0004286}, {985,0.0004000}, {990,0.0005714}, {995,0.0004286}, {1000,0.0004286}, {1010,0.0008571}, {1020,0.0008000}, {1030,0.0002857}, {1040,0.0007429}, {1050,0.0007143}, {1060,0.0009143}, {1070,0.0011714}, {1080,0.0006571}, {1090,0.0000857}, {1100,0.0010000}, {1110,0.0009143}, {1120,0.0009143}, {1130,0.0010286}, {1140,0.0004286}, {1150,0.0003143}, {1160,0.0007429}, {1170,0.0009143}, {1180,0.0006286}, {1190,0.0006000}, {1200,0.0010571}, {1210,0.0010000}, {1220,0.0011714}, {1230,0.0007429}, {1240,0.0007143}, {1250,0.0011429}, {1260,0.0006857}, {1270,0.0012000}, {1280,0.0008571}, {1290,0.0006571}, {1300,0.0007714}, {1310,0.0009143}, {1320,0.0006857}, {1330,0.0007429}, {1340,0.0008857}, {1350,0.0003714}, {1360,0.0005714}, {1370,0.0009143}, {1380,0.0011714}, {1390,0.0010857}, {1400,0.0005714}, {1410,0.0003143}, {1420,0.0007714}, {1430,0.0009714}, {1440,0.0004571}, {1450,0.0005714}, {1460,0.0008286}, {1470,0.0005429}, {1480,0.0013429}, {1490,0.0009429}, {1500,0.0015143}, {1510,0.0009143}, {1520,0.0042286}, {1530,0.0010000}, {1540,0.0010000}, {1550,0.0010571}, {1560,0.0013143}, {1570,0.0016000}, {1580,0.0011143}, {1590,0.0006857}, {1600,0.0008000}, {1610,0.0004286}, {1620,0.0009714}, {1630,0.0006571}, {1640,0.0005429}, {1650,0.0008857}, {1660,0.0012000}, {1670,0.0014857}, {1680,0.0012000}, {1690,0.0007143}, {1700,0.0010286}, {1710,0.0011714}, {1720,0.0008857}, {1730,0.0008857}, {1740,0.0010857}, {1750,0.0010571}, {1760,0.0006286}, {1770,0.0011714}, {1780,0.0011429}, {1790,0.0010000}, {1800,0.0011714}, {1810,0.0009143}, {1820,0.0012000}, {1830,0.0010000}, {1840,0.0009714}, {1850,0.0010571}, {1860,0.0014000}, {1870,0.0015429}, {1880,0.0012571}, {1890,0.0006857}, {1900,0.0009714}, {1910,0.0013714}, {1920,0.0007143}, {1930,0.0010000}, {1940,0.0010857}, {1950,0.0009714}, {1960,0.0006286}, {1970,0.0007429}, {1980,0.0014571}, {1990,0.0014286}, {2000,0.0015714}};
data["big"]["LtacTacInTermPrimPair"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00003960}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00003960}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00003960}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00003960}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0001143}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0001143}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000857}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0001143}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0001143}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0001143}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0001143}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0001143}, {960,0.0000000}, {965,0.0000000}, {970,0.0001143}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000857}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0001143}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000857}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0001143}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0001143}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0001143}, {1980,0.0000857}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermPrimPair"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00100000}, {3,0.00100000}, {4,0.01958416}, {5,0.00200000}, {6,0.00200000}, {7,0.00300000}, {8,0.00300000}, {9,0.00342574}, {10,0.00400000}, {11,0.00422772}, {12,0.00500000}, {13,0.00523762}, {14,0.00600000}, {15,0.00786139}, {16,0.00700000}, {17,0.00767327}, {18,0.00802970}, {19,0.00862376}, {20,0.00928713}, {21,0.00978218}, {22,0.01045545}, {23,0.01435644}, {24,0.01155446}, {25,0.01213861}, {26,0.01277228}, {27,0.01357426}, {28,0.01397030}, {29,0.01455446}, {30,0.01537624}, {31,0.01599010}, {32,0.01661386}, {33,0.01726733}, {34,0.01807921}, {35,0.01864356}, {36,0.01925743}, {37,0.01991089}, {38,0.02056436}, {39,0.02137624}, {40,0.02212871}, {41,0.02291089}, {42,0.02934653}, {43,0.02448515}, {44,0.02516832}, {45,0.02577228}, {46,0.02652475}, {47,0.02771287}, {48,0.03624752}, {49,0.02917822}, {50,0.03358416}, {51,0.03086139}, {52,0.03914851}, {53,0.03286139}, {54,0.03382178}, {55,0.04545545}, {56,0.03550495}, {57,0.03668317}, {58,0.03749505}, {59,0.03917822}, {60,0.04749505}, {61,0.05038614}, {62,0.05147525}, {63,0.05137624}, {64,0.04842574}, {65,0.04400990}, {66,0.04552475}, {67,0.04641584}, {68,0.06010891}, {69,0.04836634}, {70,0.04985149}, {71,0.06682178}, {72,0.05168317}, {73,0.06992079}, {74,0.05445545}, {75,0.06693069}, {76,0.05619802}, {77,0.05757426}, {78,0.06730693}, {79,0.09182178}, {80,0.06779208}, {81,0.06240594}, {82,0.06356436}, {83,0.06478218}, {84,0.06602970}, {85,0.07713861}, {86,0.09762376}, {87,0.08974257}, {88,0.08594059}, {89,0.09101980}, {90,0.11140594}, {91,0.09800990}, {92,0.08920792}, {93,0.09002970}, {94,0.09156436}, {95,0.09277228}, {96,0.09299010}, {97,0.09328713}, {98,0.09431683}, {99,0.09467327}, {100,0.09546535}, {101,0.09634653}, {102,0.09667327}, {103,0.09756436}, {104,0.09805941}, {105,0.09877228}, {106,0.09973267}, {107,0.10044554}, {108,0.10095050}, {109,0.10176238}, {110,0.10284158}, {111,0.10494059}, {112,0.10634653}, {113,0.10811881}, {114,0.10945545}, {115,0.11128713}, {116,0.11300000}, {117,0.11484158}, {118,0.11683168}, {119,0.11818812}, {120,0.12023762}, {121,0.12177228}, {122,0.12335644}, {123,0.12605941}, {124,0.14076238}, {125,0.14343564}, {126,0.14479208}, {127,0.15990099}, {128,0.16527723}, {129,0.16491089}, {130,0.16716832}, {131,0.17050495}, {132,0.17381188}, {133,0.17334653}, {134,0.17857426}, {135,0.17880198}, {136,0.18161386}, {137,0.18540594}, {138,0.18553465}, {139,0.18997030}, {140,0.19232673}, {141,0.19409901}, {142,0.19602970}, {143,0.19708911}, {144,0.20172277}, {145,0.20458416}, {146,0.20805941}, {147,0.21030693}, {148,0.21146535}, {149,0.21371287}, {150,0.21600990}, {151,0.21730693}, {152,0.21919802}, {153,0.21948515}, {154,0.22103960}, {155,0.22938614}, {156,0.23249505}, {157,0.23723762}, {158,0.23753465}, {159,0.24199010}, {160,0.24427723}, {161,0.24577228}, {162,0.24831683}, {163,0.25289109}, {164,0.25607921}, {165,0.25975248}, {166,0.26172277}, {167,0.26630693}, {168,0.26723762}, {169,0.26543564}, {170,0.27182178}, {171,0.27875248}, {172,0.27810891}, {173,0.28242574}, {174,0.28535644}, {175,0.28749505}, {176,0.29224752}, {177,0.29416832}, {178,0.29620792}, {179,0.29896040}, {180,0.30328713}, {181,0.30799010}, {182,0.31126733}, {183,0.31465347}, {184,0.31800990}, {185,0.32096040}, {186,0.32438614}, {187,0.32656436}, {188,0.32820792}, {189,0.33084158}, {190,0.33533663}, {191,0.33968317}, {192,0.34041584}, {193,0.34116832}, {194,0.34479208}, {195,0.35100990}, {196,0.35841584}, {197,0.36926733}, {198,0.36663366}, {199,0.36567327}, {200,0.36997030}, {201,0.37615842}, {202,0.37612871}, {203,0.38581188}, {204,0.39773267}, {205,0.38245545}, {206,0.39147525}, {207,0.39171287}, {208,0.40271287}, {209,0.41677228}, {210,0.40747525}, {211,0.40799010}, {212,0.41050495}, {213,0.43442574}, {214,0.42104950}, {215,0.42009901}, {216,0.43254455}, {217,0.44104950}, {218,0.43849505}, {219,0.44368317}, {220,0.45657426}, {221,0.45161386}, {222,0.45696040}, {223,0.46495050}, {224,0.46346535}, {225,0.47560396}, {226,0.47135644}, {227,0.47534653}, {228,0.48684158}, {229,0.48407921}, {230,0.49767327}, {231,0.49219802}, {232,0.50715842}, {233,0.49739604}, {234,0.51487129}, {235,0.50718812}, {236,0.52286139}, {237,0.51460396}, {238,0.52705941}, {239,0.52660396}, {240,0.53293069}, {241,0.54057426}, {242,0.53985149}, {243,0.55065347}, {244,0.55346535}, {245,0.55546535}, {246,0.56233663}, {247,0.56633663}, {248,0.56892079}, {249,0.58039604}, {250,0.57494059}, {251,0.58228713}, {252,0.59662376}, {253,0.59183168}, {254,0.59613861}, {255,0.60782178}, {256,0.60702970}, {257,0.60963366}, {258,0.62017822}, {259,0.62605941}, {260,0.63291089}, {261,0.63048515}, {262,0.63448515}, {263,0.64275248}, {264,0.64346535}, {265,0.65260396}, {266,0.65903960}, {267,0.66217822}, {268,0.66454455}, {269,0.66909901}, {270,0.67724752}, {271,0.68125743}, {272,0.68683168}, {273,0.69258416}, {274,0.69681188}, {275,0.70473267}, {276,0.71166337}, {277,0.71687129}, {278,0.71827723}, {279,0.72386139}, {280,0.72786139}, {281,0.73418812}, {282,0.73922772}, {283,0.74399010}, {284,0.74871287}, {285,0.75801980}, {286,0.75781188}, {287,0.75918812}, {288,0.76721782}, {289,0.77467327}, {290,0.78908911}, {291,0.79513861}, {292,0.80290099}, {293,0.81231683}, {294,0.81466337}, {295,0.82103960}, {296,0.83615842}, {297,0.82883168}, {298,0.83289109}, {299,0.84293069}, {300,0.84439604}, {301,0.8644000}, {302,0.9851714}, {303,0.9345714}, {304,0.9328857}, {305,0.9002857}, {306,0.9022000}, {307,0.9036000}, {308,0.9140286}, {309,0.9225714}, {310,0.9195429}, {311,0.9310571}, {312,0.9390286}, {313,0.9440000}, {314,0.9457714}, {315,0.9575143}, {316,0.9611429}, {317,0.9632571}, {318,0.9709143}, {319,0.9824571}, {320,0.9844000}, {321,0.9886000}, {322,0.9999714}, {323,1.0038571}, {324,1.0125143}, {325,1.0219143}, {326,1.0219714}, {327,1.0377714}, {328,1.0383714}, {329,1.0407429}, {330,1.0556286}, {331,1.0526857}, {332,1.0734571}, {333,1.0561143}, {334,1.0735714}, {335,1.0744000}, {336,1.0834571}, {337,1.0910286}, {338,1.0931429}, {339,1.1040571}, {340,1.1047714}, {341,1.1228571}, {342,1.1300286}, {343,1.1384571}, {344,1.1510571}, {345,1.1535429}, {346,1.1536000}, {347,1.1646571}, {348,1.1744571}, {349,1.1799143}, {350,1.1859143}, {351,1.2032286}, {352,1.2078000}, {353,1.2067143}, {354,1.2200857}, {355,1.2180286}, {356,1.2277143}, {357,1.2371143}, {358,1.2490571}, {359,1.2474000}, {360,1.2673714}, {361,1.2683143}, {362,1.2720000}, {363,1.2935143}, {364,1.2896000}, {365,1.2990857}, {366,1.3034286}, {367,1.3207143}, {368,1.3159429}, {369,1.3277714}, {370,1.3450571}, {371,1.3484000}, {372,1.3569714}, {373,1.3613143}, {374,1.3728286}, {375,1.3863429}, {376,1.3891714}, {377,1.3964857}, {378,1.4051714}, {379,1.4106571}, {380,1.4182857}, {381,1.4293429}, {382,1.4414286}, {383,1.4517714}, {384,1.4616286}, {385,1.4735143}, {386,1.4775714}, {387,1.4961429}, {388,1.4947143}, {389,1.5057429}, {390,1.5171714}, {391,1.5197143}, {392,1.5232571}, {393,1.5368857}, {394,1.5508286}, {395,1.5574571}, {396,1.5667714}, {397,1.5723143}, {398,1.5758286}, {399,1.5891714}, {400,1.5978857}, {401,1.6082571}, {402,1.6182000}, {403,1.6289714}, {404,1.6316571}, {405,1.6528000}, {406,1.6579429}, {407,1.6660857}, {408,1.6740286}, {409,1.6799429}, {410,1.6860286}, {411,1.6969714}, {412,1.6978857}, {413,1.7118571}, {414,1.7182000}, {415,1.7330571}, {416,1.7347143}, {417,1.7469714}, {418,1.7492571}, {419,1.8080286}, {420,1.8018571}, {421,1.7877429}, {422,1.7969714}, {423,1.8047429}, {424,1.8113143}, {425,1.8292857}, {426,1.8322000}, {427,1.8583429}, {428,1.8596000}, {429,1.8744571}, {430,1.8792857}, {431,1.8979143}, {432,1.8998286}, {433,1.9111429}, {434,1.9164571}, {435,1.9290857}, {436,1.9329429}, {437,1.9478857}, {438,1.9596857}, {439,1.9763714}, {440,1.9912571}, {441,1.9947714}, {442,2.0046571}, {443,2.0104571}, {444,2.0195429}, {445,2.0384000}, {446,2.0388571}, {447,2.0523714}, {448,2.0564571}, {449,2.0765429}, {450,2.0838000}, {451,2.0935143}, {452,2.0982000}, {453,2.1103143}, {454,2.1237714}, {455,2.1382000}, {456,2.1532000}, {457,2.1601143}, {458,2.1727714}, {459,2.1812286}, {460,2.1964571}, {461,2.1982286}, {462,2.2027143}, {463,2.2246857}, {464,2.2358286}, {465,2.2457429}, {466,2.2532286}, {467,2.2934857}, {468,2.3100286}, {469,2.2912857}, {470,2.3050000}, {471,2.3305714}, {472,2.3172000}, {473,2.3312857}, {474,2.3385429}, {475,2.3373429}, {476,2.3479143}, {477,2.3705714}, {478,2.4056000}, {479,2.3808286}, {480,2.4547429}, {481,2.5125143}, {482,2.4297143}, {483,2.5386286}, {484,2.4663714}, {485,2.5444857}, {486,2.5027714}, {487,2.5789143}, {488,2.5962857}, {489,2.5669714}, {490,2.5272571}, {491,2.5362857}, {492,2.5753143}, {493,2.6071143}, {494,2.6304857}, {495,2.6405429}, {496,2.6860571}, {497,2.7410286}, {498,2.6589143}, {499,2.6884571}, {500,2.6699429}, {505,2.7727429}, {510,2.7932286}, {515,2.9416857}, {520,3.0310857}, {525,3.1730286}, {530,3.1492857}, {535,3.1940000}, {540,3.2239714}, {545,3.2811429}, {550,3.3363143}, {555,3.3893143}, {560,3.4337714}, {565,3.5764857}, {570,3.6296857}, {575,3.6760571}, {580,3.7465714}, {585,3.8706857}, {590,3.9053429}, {595,4.0026000}, {600,4.0679429}, {605,4.2732571}, {610,4.2572286}, {615,4.3136571}, {620,4.4118000}, {625,4.4883143}, {630,4.6401143}, {635,4.6777143}, {640,4.7809429}, {645,4.7762857}, {650,4.8824857}, {655,5.0943714}, {660,5.1640857}, {665,5.1500286}, {670,5.1482571}, {675,5.2546000}, {680,5.3683429}, {685,5.5017714}, {690,5.6568000}, {695,5.6567429}, {700,5.8193429}, {705,5.8151714}, {710,5.9901429}, {715,6.0960000}, {720,6.1455143}, {725,6.2284000}, {730,6.3428571}, {735,6.6054857}, {740,6.6254000}, {745,6.7064571}, {750,6.8522286}, {755,6.9768286}, {760,7.0732000}, {765,7.2130857}, {770,7.3247429}, {775,7.4420000}, {780,7.5242286}, {785,7.6603714}, {790,7.7803143}, {795,7.9022286}, {800,8.1292286}, {805,8.1350286}, {810,8.2954000}, {815,8.3897429}, {820,8.5503143}, {825,8.6630000}, {830,8.7917714}, {835,8.9041143}, {840,9.0392286}, {845,9.2069143}, {850,9.4020000}, {855,9.5180000}, {860,9.6413429}, {865,9.8037714}, {870,9.9550000}, {875,10.2129143}, {880,10.2795714}, {885,10.7319143}, {890,10.5337714}, {895,10.7372000}, {900,11.1407143}, {905,11.1006857}, {910,11.3039714}, {915,11.4007143}, {920,11.8943143}, {925,11.9580571}, {930,12.0569143}, {935,12.0516857}, {940,12.5495714}, {945,12.3112857}, {950,12.5517714}, {955,12.8384571}, {960,13.3595714}, {965,13.3994857}, {970,13.2876571}, {975,13.5669714}, {980,13.8844857}, {985,14.3257714}, {990,14.2674857}, {995,14.6777429}, {1000,14.6481429}, {1010,15.2778857}, {1020,15.5261429}, {1030,16.0754857}, {1040,16.2933429}, {1050,16.7922571}, {1060,17.4118571}, {1070,17.8639143}, {1080,18.5395429}, {1090,18.2523714}, {1100,19.0245143}, {1110,19.3812857}, {1120,19.9409143}, {1130,20.3568571}, {1140,20.8448000}, {1150,21.3537429}, {1160,21.8538286}, {1170,22.3007143}, {1180,23.1238571}, {1190,23.4714571}, {1200,24.0499714}, {1210,24.7276000}, {1220,25.1317429}, {1230,25.4204857}, {1240,26.1669714}, {1250,27.0512857}, {1260,27.5938571}, {1270,28.1513714}, {1280,28.5718857}, {1290,28.9928857}, {1300,29.6881143}, {1310,30.3903429}, {1320,31.0430857}, {1330,31.9736286}, {1340,32.5595714}, {1350,33.0888000}, {1360,33.5935143}, {1370,34.2577429}, {1380,35.0242000}, {1390,35.7047429}, {1400,36.4416000}, {1410,37.0524286}, {1420,38.0936857}, {1430,38.8615143}, {1440,39.4788286}, {1450,40.0378571}, {1460,40.8270857}, {1470,42.0537429}, {1480,42.4589429}, {1490,43.3052857}, {1500,43.7411143}, {1510,45.0461429}, {1520,45.6211429}, {1530,47.0445714}, {1540,48.0005429}, {1550,48.8313429}, {1560,49.4800000}, {1570,50.2138286}, {1580,51.5687714}, {1590,52.5094571}, {1600,53.0803714}, {1610,54.2252571}, {1620,55.2587429}, {1630,55.5561714}, {1640,56.1577429}, {1650,57.7166857}, {1660,58.7250286}, {1670,59.6895143}, {1680,60.4458000}, {1690,62.3082286}, {1700,63.5994286}, {1710,64.4995714}, {1720,65.5607714}, {1730,66.3936286}, {1740,67.5681714}, {1750,68.2066000}, {1760,69.0732571}, {1770,70.5457143}, {1780,71.6443429}, {1790,72.8971143}, {1800,73.9922571}, {1810,75.3989429}, {1820,76.6161143}, {1830,77.1174286}, {1840,78.7160286}, {1850,80.6247429}, {1860,81.8780286}, {1870,83.2091714}, {1880,84.3277429}, {1890,86.3840857}, {1900,86.4189429}, {1910,88.4311429}, {1920,89.4196000}, {1930,90.8909143}, {1940,91.5545429}, {1950,92.8460000}, {1960,95.2540571}, {1970,94.9533429}, {1980,96.8409429}, {1990,98.1788857}, {2000,99.7907143}};
data["big"]["LtacTacInTermPrimPair"]["norm reif"]["user"] = {{1,0.00066337}, {2,0.00102970}, {3,0.00139604}, {4,0.01900000}, {5,0.00206931}, {6,0.00254455}, {7,0.00346535}, {8,0.00324752}, {9,0.00376238}, {10,0.00403960}, {11,0.00414851}, {12,0.00486139}, {13,0.00536634}, {14,0.00618812}, {15,0.00805941}, {16,0.00706931}, {17,0.00774257}, {18,0.00829703}, {19,0.00851485}, {20,0.00944554}, {21,0.01000990}, {22,0.01044554}, {23,0.01424752}, {24,0.01148515}, {25,0.01175248}, {26,0.01245545}, {27,0.01270297}, {28,0.01385149}, {29,0.01454455}, {30,0.01496040}, {31,0.01585149}, {32,0.01667327}, {33,0.01673267}, {34,0.01752475}, {35,0.01832673}, {36,0.01897030}, {37,0.01940594}, {38,0.02066337}, {39,0.02164356}, {40,0.02270297}, {41,0.02306931}, {42,0.02935644}, {43,0.02481188}, {44,0.02555446}, {45,0.02568317}, {46,0.02646535}, {47,0.02782178}, {48,0.03586139}, {49,0.02949505}, {50,0.03368317}, {51,0.03090099}, {52,0.03887129}, {53,0.03300000}, {54,0.03362376}, {55,0.04549505}, {56,0.03561386}, {57,0.03614851}, {58,0.03722772}, {59,0.03883168}, {60,0.04755446}, {61,0.05047525}, {62,0.05163366}, {63,0.05174257}, {64,0.04882178}, {65,0.04392079}, {66,0.04537624}, {67,0.04641584}, {68,0.06024752}, {69,0.04872277}, {70,0.05027723}, {71,0.06682178}, {72,0.05202970}, {73,0.06931683}, {74,0.05451485}, {75,0.06658416}, {76,0.05621782}, {77,0.05728713}, {78,0.06700990}, {79,0.09154455}, {80,0.06760396}, {81,0.06224752}, {82,0.06316832}, {83,0.06444554}, {84,0.06555446}, {85,0.07738614}, {86,0.09747525}, {87,0.08950495}, {88,0.08601980}, {89,0.09074257}, {90,0.11111881}, {91,0.09720792}, {92,0.08860396}, {93,0.08940594}, {94,0.09095050}, {95,0.09224752}, {96,0.09268317}, {97,0.09309901}, {98,0.09379208}, {99,0.09461386}, {100,0.09577228}, {101,0.09637624}, {102,0.09663366}, {103,0.09765347}, {104,0.09812871}, {105,0.09860396}, {106,0.09964356}, {107,0.10025743}, {108,0.10076238}, {109,0.10183168}, {110,0.10277228}, {111,0.10476238}, {112,0.10608911}, {113,0.10777228}, {114,0.10887129}, {115,0.11082178}, {116,0.11259406}, {117,0.11431683}, {118,0.11613861}, {119,0.11810891}, {120,0.12035644}, {121,0.12162376}, {122,0.12304950}, {123,0.12590099}, {124,0.14056436}, {125,0.14307921}, {126,0.14488119}, {127,0.15968317}, {128,0.16486139}, {129,0.16457426}, {130,0.16681188}, {131,0.17006931}, {132,0.17336634}, {133,0.17271287}, {134,0.17840594}, {135,0.17825743}, {136,0.18120792}, {137,0.18497030}, {138,0.18512871}, {139,0.18946535}, {140,0.19171287}, {141,0.19343564}, {142,0.19571287}, {143,0.19684158}, {144,0.20125743}, {145,0.20404950}, {146,0.20768317}, {147,0.20988119}, {148,0.21082178}, {149,0.21322772}, {150,0.21561386}, {151,0.21714851}, {152,0.21856436}, {153,0.21867327}, {154,0.22062376}, {155,0.22895050}, {156,0.23234653}, {157,0.23664356}, {158,0.23705941}, {159,0.24119802}, {160,0.24387129}, {161,0.24524752}, {162,0.24774257}, {163,0.25227723}, {164,0.25559406}, {165,0.25932673}, {166,0.26110891}, {167,0.26552475}, {168,0.26634653}, {169,0.26442574}, {170,0.27117822}, {171,0.27832673}, {172,0.27729703}, {173,0.28182178}, {174,0.28479208}, {175,0.28715842}, {176,0.29139604}, {177,0.29340594}, {178,0.29576238}, {179,0.29811881}, {180,0.30234653}, {181,0.30719802}, {182,0.31093069}, {183,0.31390099}, {184,0.31733663}, {185,0.32054455}, {186,0.32356436}, {187,0.32546535}, {188,0.32745545}, {189,0.33018812}, {190,0.33458416}, {191,0.33925743}, {192,0.33994059}, {193,0.34022772}, {194,0.34423762}, {195,0.35048515}, {196,0.35776238}, {197,0.36831683}, {198,0.36573267}, {199,0.36467327}, {200,0.36942574}, {201,0.37510891}, {202,0.37537624}, {203,0.38475248}, {204,0.39704950}, {205,0.38173267}, {206,0.39094059}, {207,0.39106931}, {208,0.40198020}, {209,0.41582178}, {210,0.40681188}, {211,0.40721782}, {212,0.40979208}, {213,0.43364356}, {214,0.42042574}, {215,0.41944554}, {216,0.43163366}, {217,0.44067327}, {218,0.43750495}, {219,0.44297030}, {220,0.45599010}, {221,0.45048515}, {222,0.45627723}, {223,0.46395050}, {224,0.46275248}, {225,0.47474257}, {226,0.47023762}, {227,0.47445545}, {228,0.48627723}, {229,0.48324752}, {230,0.49678218}, {231,0.49105941}, {232,0.50617822}, {233,0.49667327}, {234,0.51403960}, {235,0.50615842}, {236,0.52199010}, {237,0.51373267}, {238,0.52621782}, {239,0.52540594}, {240,0.53197030}, {241,0.53941584}, {242,0.53905941}, {243,0.54974257}, {244,0.55254455}, {245,0.55399010}, {246,0.56111881}, {247,0.56552475}, {248,0.56764356}, {249,0.57948515}, {250,0.57334653}, {251,0.58129703}, {252,0.59520792}, {253,0.59087129}, {254,0.59475248}, {255,0.60652475}, {256,0.60585149}, {257,0.60814851}, {258,0.61900000}, {259,0.62457426}, {260,0.63168317}, {261,0.62955446}, {262,0.63264356}, {263,0.64126733}, {264,0.64229703}, {265,0.65180198}, {266,0.65755446}, {267,0.66100990}, {268,0.66335644}, {269,0.66777228}, {270,0.67582178}, {271,0.68011881}, {272,0.68543564}, {273,0.69122772}, {274,0.69589109}, {275,0.70315842}, {276,0.71064356}, {277,0.71554455}, {278,0.71696040}, {279,0.72246535}, {280,0.72634653}, {281,0.73259406}, {282,0.73803960}, {283,0.74295050}, {284,0.74645545}, {285,0.75659406}, {286,0.75643564}, {287,0.75751485}, {288,0.76560396}, {289,0.77304950}, {290,0.78739604}, {291,0.79376238}, {292,0.80180198}, {293,0.81083168}, {294,0.81319802}, {295,0.81950495}, {296,0.83420792}, {297,0.82737624}, {298,0.83086139}, {299,0.84134653}, {300,0.84289109}, {301,0.8637143}, {302,0.9844286}, {303,0.9335714}, {304,0.9312571}, {305,0.8990286}, {306,0.9010000}, {307,0.9025429}, {308,0.9131429}, {309,0.9210286}, {310,0.9182571}, {311,0.9303143}, {312,0.9376857}, {313,0.9423714}, {314,0.9454000}, {315,0.9563714}, {316,0.9600857}, {317,0.9624571}, {318,0.9693143}, {319,0.9808000}, {320,0.9812857}, {321,0.9873429}, {322,0.9990000}, {323,1.0030286}, {324,1.0112286}, {325,1.0203714}, {326,1.0202571}, {327,1.0361143}, {328,1.0356857}, {329,1.0360571}, {330,1.0528000}, {331,1.0506571}, {332,1.0678000}, {333,1.0544857}, {334,1.0719429}, {335,1.0696857}, {336,1.0823429}, {337,1.0892857}, {338,1.0918286}, {339,1.1032286}, {340,1.1034857}, {341,1.1207429}, {342,1.1285429}, {343,1.1368571}, {344,1.1494857}, {345,1.1522857}, {346,1.1520000}, {347,1.1636286}, {348,1.1727429}, {349,1.1786286}, {350,1.1844571}, {351,1.2018571}, {352,1.2064571}, {353,1.2050571}, {354,1.2188857}, {355,1.2169429}, {356,1.2267143}, {357,1.2359714}, {358,1.2480571}, {359,1.2460857}, {360,1.2658286}, {361,1.2668000}, {362,1.2706857}, {363,1.2912571}, {364,1.2881429}, {365,1.2980000}, {366,1.3012571}, {367,1.3190571}, {368,1.3145714}, {369,1.3256000}, {370,1.3436286}, {371,1.3464571}, {372,1.3554000}, {373,1.3598857}, {374,1.3717143}, {375,1.3848857}, {376,1.3871429}, {377,1.3945143}, {378,1.4028286}, {379,1.4084286}, {380,1.4163714}, {381,1.4270286}, {382,1.4390857}, {383,1.4486286}, {384,1.4588857}, {385,1.4709714}, {386,1.4756000}, {387,1.4935429}, {388,1.4921429}, {389,1.5037714}, {390,1.5144571}, {391,1.5181714}, {392,1.5212571}, {393,1.5350286}, {394,1.5485143}, {395,1.5558286}, {396,1.5641429}, {397,1.5697714}, {398,1.5730857}, {399,1.5869143}, {400,1.5948857}, {401,1.6061143}, {402,1.6160571}, {403,1.6254857}, {404,1.6282286}, {405,1.6439429}, {406,1.6485429}, {407,1.6578286}, {408,1.6668286}, {409,1.6777714}, {410,1.6829429}, {411,1.6926571}, {412,1.6952571}, {413,1.7089429}, {414,1.7153143}, {415,1.7291429}, {416,1.7317429}, {417,1.7438571}, {418,1.7465143}, {419,1.8047714}, {420,1.7996571}, {421,1.7856000}, {422,1.7942000}, {423,1.8020571}, {424,1.8078286}, {425,1.8252571}, {426,1.8284286}, {427,1.8558286}, {428,1.8568286}, {429,1.8707429}, {430,1.8749714}, {431,1.8941429}, {432,1.8965714}, {433,1.9074000}, {434,1.9135143}, {435,1.9255714}, {436,1.9290286}, {437,1.9442571}, {438,1.9558000}, {439,1.9717143}, {440,1.9868857}, {441,1.9904000}, {442,2.0002571}, {443,2.0064000}, {444,2.0156286}, {445,2.0339429}, {446,2.0349143}, {447,2.0481714}, {448,2.0514286}, {449,2.0729143}, {450,2.0798857}, {451,2.0905143}, {452,2.0946286}, {453,2.1059429}, {454,2.1198571}, {455,2.1347143}, {456,2.1496000}, {457,2.1563143}, {458,2.1694286}, {459,2.1777714}, {460,2.1933143}, {461,2.1945143}, {462,2.1994571}, {463,2.2215429}, {464,2.2322286}, {465,2.2420286}, {466,2.2489143}, {467,2.2900571}, {468,2.3055714}, {469,2.2880000}, {470,2.3003429}, {471,2.3254000}, {472,2.3113429}, {473,2.3258000}, {474,2.3327429}, {475,2.3318286}, {476,2.3420857}, {477,2.3663143}, {478,2.4010286}, {479,2.3755714}, {480,2.4497143}, {481,2.5054000}, {482,2.4238286}, {483,2.5309143}, {484,2.4599429}, {485,2.5373714}, {486,2.4964857}, {487,2.5715714}, {488,2.5898000}, {489,2.5614286}, {490,2.5214286}, {491,2.5304571}, {492,2.5695143}, {493,2.6017429}, {494,2.6231429}, {495,2.6340571}, {496,2.6804571}, {497,2.7346857}, {498,2.6524857}, {499,2.6825429}, {500,2.6646000}, {505,2.7665143}, {510,2.7866286}, {515,2.9333143}, {520,3.0215714}, {525,3.1628857}, {530,3.1400286}, {535,3.1844286}, {540,3.2132286}, {545,3.2712857}, {550,3.3250571}, {555,3.3794000}, {560,3.4227143}, {565,3.5674000}, {570,3.6200857}, {575,3.6658000}, {580,3.7356286}, {585,3.8597714}, {590,3.8967714}, {595,3.9930000}, {600,4.0587429}, {605,4.2635714}, {610,4.2477143}, {615,4.3041714}, {620,4.4026286}, {625,4.4777714}, {630,4.6289143}, {635,4.6680286}, {640,4.7727429}, {645,4.7690857}, {650,4.8782000}, {655,5.0887429}, {660,5.1588857}, {665,5.1418000}, {670,5.1415429}, {675,5.2490857}, {680,5.3616571}, {685,5.4939429}, {690,5.6473429}, {695,5.6491714}, {700,5.8112286}, {705,5.8086286}, {710,5.9841143}, {715,6.0853714}, {720,6.1377429}, {725,6.2190286}, {730,6.3330857}, {735,6.5976000}, {740,6.6181714}, {745,6.6988571}, {750,6.8444857}, {755,6.9703429}, {760,7.0659714}, {765,7.2050857}, {770,7.3143429}, {775,7.4337143}, {780,7.5165714}, {785,7.6517429}, {790,7.7664857}, {795,7.8873714}, {800,8.1009714}, {805,8.1089143}, {810,8.2790000}, {815,8.3727429}, {820,8.5382571}, {825,8.6465429}, {830,8.7776286}, {835,8.8751714}, {840,9.0245429}, {845,9.1920000}, {850,9.3881143}, {855,9.5044286}, {860,9.6278286}, {865,9.7889429}, {870,9.9436000}, {875,10.2023429}, {880,10.2743714}, {885,10.7246000}, {890,10.5255429}, {895,10.7294000}, {900,11.1321714}, {905,11.0881714}, {910,11.2889429}, {915,11.3866571}, {920,11.8772286}, {925,11.9436857}, {930,12.0391143}, {935,12.0333429}, {940,12.5306000}, {945,12.2963143}, {950,12.5418857}, {955,12.8262000}, {960,13.3463143}, {965,13.3796571}, {970,13.2652286}, {975,13.5447429}, {980,13.8584286}, {985,14.2983714}, {990,14.2361429}, {995,14.6436857}, {1000,14.6136571}, {1010,15.2266857}, {1020,15.4903714}, {1030,16.0361143}, {1040,16.2633429}, {1050,16.7619143}, {1060,17.3866857}, {1070,17.8428571}, {1080,18.4686571}, {1090,18.2324000}, {1100,19.0033714}, {1110,19.3458571}, {1120,19.9071143}, {1130,20.3290857}, {1140,20.8103143}, {1150,21.3281143}, {1160,21.8300000}, {1170,22.2780857}, {1180,23.0805429}, {1190,23.4455429}, {1200,24.0235143}, {1210,24.7024000}, {1220,25.1019143}, {1230,25.3860286}, {1240,26.1255714}, {1250,27.0024286}, {1260,27.5450000}, {1270,28.1046286}, {1280,28.5278000}, {1290,28.9485714}, {1300,29.6492286}, {1310,30.3591143}, {1320,31.0053143}, {1330,31.9423714}, {1340,32.5132571}, {1350,33.0464000}, {1360,33.5482286}, {1370,34.2096000}, {1380,34.9874857}, {1390,35.6582857}, {1400,36.4075429}, {1410,37.0098857}, {1420,38.0479714}, {1430,38.8212000}, {1440,39.4292571}, {1450,39.9753429}, {1460,40.7710857}, {1470,41.9980857}, {1480,42.4134000}, {1490,43.2622571}, {1500,43.6951714}, {1510,44.9638000}, {1520,45.5646571}, {1530,46.9881714}, {1540,47.9550571}, {1550,48.7578571}, {1560,49.4273143}, {1570,50.1581143}, {1580,51.5150571}, {1590,52.4294000}, {1600,53.0216857}, {1610,54.1770286}, {1620,55.2126286}, {1630,55.4956571}, {1640,56.1006286}, {1650,57.6474857}, {1660,58.6621429}, {1670,59.6190857}, {1680,60.3795143}, {1690,62.2471143}, {1700,63.5255714}, {1710,64.4344286}, {1720,65.4862857}, {1730,66.3076286}, {1740,67.4820286}, {1750,68.1266286}, {1760,68.9956286}, {1770,70.4630857}, {1780,71.5533429}, {1790,72.8262571}, {1800,73.9352571}, {1810,75.3593143}, {1820,76.5540286}, {1830,77.0421714}, {1840,78.6223429}, {1850,80.5388857}, {1860,81.7800571}, {1870,83.1137429}, {1880,84.2331143}, {1890,86.2930857}, {1900,86.3375429}, {1910,88.3760286}, {1920,89.3620286}, {1930,90.8300857}, {1940,91.4738000}, {1950,92.7869143}, {1960,94.9948857}, {1970,94.9202571}, {1980,96.7950286}, {1990,98.1224571}, {2000,99.7374571}};
data["big"]["LtacTacInTermPrimPair"]["norm reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00003960}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00003960}, {9,0.00000000}, {10,0.00000000}, {11,0.00003960}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00003960}, {16,0.00000000}, {17,0.00003960}, {18,0.00003960}, {19,0.00010891}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00003960}, {25,0.00000000}, {26,0.00003960}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00003960}, {32,0.00003960}, {33,0.00007921}, {34,0.00011881}, {35,0.00003960}, {36,0.00000000}, {37,0.00007921}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003960}, {42,0.00000000}, {43,0.00002970}, {44,0.00003960}, {45,0.00015842}, {46,0.00003960}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00000000}, {51,0.00015842}, {52,0.00003960}, {53,0.00010891}, {54,0.00003960}, {55,0.00003960}, {56,0.00000000}, {57,0.00007921}, {58,0.00000000}, {59,0.00003960}, {60,0.00000000}, {61,0.00003960}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00003960}, {66,0.00000000}, {67,0.00003960}, {68,0.00003960}, {69,0.00003960}, {70,0.00000000}, {71,0.00003960}, {72,0.00000000}, {73,0.00003960}, {74,0.00000000}, {75,0.00003960}, {76,0.00007921}, {77,0.00011881}, {78,0.00000000}, {79,0.00011881}, {80,0.00007921}, {81,0.00003960}, {82,0.00007921}, {83,0.00003960}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00003960}, {90,0.00011881}, {91,0.00019802}, {92,0.00010891}, {93,0.00015842}, {94,0.00003960}, {95,0.00007921}, {96,0.00007921}, {97,0.00000000}, {98,0.00003960}, {99,0.00011881}, {100,0.00003960}, {101,0.00000000}, {102,0.00011881}, {103,0.00000000}, {104,0.00003960}, {105,0.00007921}, {106,0.00000000}, {107,0.00003960}, {108,0.00000000}, {109,0.00000000}, {110,0.00002970}, {111,0.00007921}, {112,0.00000000}, {113,0.00003960}, {114,0.00003960}, {115,0.00003960}, {116,0.00003960}, {117,0.00000000}, {118,0.00000000}, {119,0.00007921}, {120,0.00011881}, {121,0.00000000}, {122,0.00007921}, {123,0.00011881}, {124,0.00000000}, {125,0.00000000}, {126,0.00003960}, {127,0.00000000}, {128,0.00007921}, {129,0.00007921}, {130,0.00003960}, {131,0.00000000}, {132,0.00000000}, {133,0.00007921}, {134,0.00007921}, {135,0.00007921}, {136,0.00003960}, {137,0.00011881}, {138,0.00007921}, {139,0.00003960}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00007921}, {145,0.00011881}, {146,0.00003960}, {147,0.00007921}, {148,0.00011881}, {149,0.00000000}, {150,0.00003960}, {151,0.00003960}, {152,0.00000000}, {153,0.00003960}, {154,0.00007921}, {155,0.00007921}, {156,0.00010891}, {157,0.00003960}, {158,0.00000000}, {159,0.00003960}, {160,0.00007921}, {161,0.00003960}, {162,0.00003960}, {163,0.00003960}, {164,0.00003960}, {165,0.00003960}, {166,0.00000000}, {167,0.00011881}, {168,0.00007921}, {169,0.00007921}, {170,0.00003960}, {171,0.00003960}, {172,0.00003960}, {173,0.00007921}, {174,0.00003960}, {175,0.00003960}, {176,0.00002970}, {177,0.00007921}, {178,0.00003960}, {179,0.00015842}, {180,0.00007921}, {181,0.00000000}, {182,0.00007921}, {183,0.00000000}, {184,0.00023762}, {185,0.00003960}, {186,0.00007921}, {187,0.00003960}, {188,0.00000000}, {189,0.00000000}, {190,0.00003960}, {191,0.00006931}, {192,0.00000000}, {193,0.00011881}, {194,0.00003960}, {195,0.00007921}, {196,0.00000000}, {197,0.00011881}, {198,0.00006931}, {199,0.00003960}, {200,0.00000000}, {201,0.00011881}, {202,0.00007921}, {203,0.00007921}, {204,0.00007921}, {205,0.00003960}, {206,0.00003960}, {207,0.00000000}, {208,0.00007921}, {209,0.00007921}, {210,0.00003960}, {211,0.00007921}, {212,0.00000000}, {213,0.00000000}, {214,0.00003960}, {215,0.00003960}, {216,0.00007921}, {217,0.00000000}, {218,0.00000000}, {219,0.00003960}, {220,0.00000000}, {221,0.00011881}, {222,0.00006931}, {223,0.00011881}, {224,0.00000000}, {225,0.00007921}, {226,0.00007921}, {227,0.00003960}, {228,0.00003960}, {229,0.00007921}, {230,0.00000000}, {231,0.00015842}, {232,0.00003960}, {233,0.00006931}, {234,0.00003960}, {235,0.00007921}, {236,0.00003960}, {237,0.00003960}, {238,0.00011881}, {239,0.00011881}, {240,0.00003960}, {241,0.00003960}, {242,0.00007921}, {243,0.00010891}, {244,0.00011881}, {245,0.00015842}, {246,0.00007921}, {247,0.00003960}, {248,0.00019802}, {249,0.00003960}, {250,0.00011881}, {251,0.00003960}, {252,0.00019802}, {253,0.00003960}, {254,0.00015842}, {255,0.00027723}, {256,0.00006931}, {257,0.00035644}, {258,0.00000000}, {259,0.00003960}, {260,0.00007921}, {261,0.00007921}, {262,0.00052475}, {263,0.00011881}, {264,0.00007921}, {265,0.00000000}, {266,0.00035644}, {267,0.00003960}, {268,0.00007921}, {269,0.00003960}, {270,0.00007921}, {271,0.00003960}, {272,0.00015842}, {273,0.00011881}, {274,0.00007921}, {275,0.00030693}, {276,0.00011881}, {277,0.00003960}, {278,0.00011881}, {279,0.00011881}, {280,0.00031683}, {281,0.00014851}, {282,0.00003960}, {283,0.00007921}, {284,0.00079208}, {285,0.00007921}, {286,0.00011881}, {287,0.00003960}, {288,0.00015842}, {289,0.00022772}, {290,0.00010891}, {291,0.00003960}, {292,0.00000000}, {293,0.00007921}, {294,0.00011881}, {295,0.00015842}, {296,0.00007921}, {297,0.00007921}, {298,0.00015842}, {299,0.00043564}, {300,0.00014851}, {301,0.0001143}, {302,0.0003429}, {303,0.0002286}, {304,0.0004286}, {305,0.0002286}, {306,0.0001143}, {307,0.0002286}, {308,0.0001143}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0004571}, {313,0.0001143}, {314,0.0000000}, {315,0.0002286}, {316,0.0001143}, {317,0.0000000}, {318,0.0002286}, {319,0.0001143}, {320,0.0000000}, {321,0.0000000}, {322,0.0002286}, {323,0.0001143}, {324,0.0003429}, {325,0.0000000}, {326,0.0002286}, {327,0.0000000}, {328,0.0002286}, {329,0.0005429}, {330,0.0003429}, {331,0.0000000}, {332,0.0000000}, {333,0.0001143}, {334,0.0005714}, {335,0.0004571}, {336,0.0003429}, {337,0.0005714}, {338,0.0001143}, {339,0.0000000}, {340,0.0000000}, {341,0.0002286}, {342,0.0002286}, {343,0.0000000}, {344,0.0002286}, {345,0.0000000}, {346,0.0001143}, {347,0.0001143}, {348,0.0001143}, {349,0.0002286}, {350,0.0000000}, {351,0.0001143}, {352,0.0000000}, {353,0.0002286}, {354,0.0001143}, {355,0.0000000}, {356,0.0001143}, {357,0.0000857}, {358,0.0001143}, {359,0.0000000}, {360,0.0000000}, {361,0.0001143}, {362,0.0001143}, {363,0.0005714}, {364,0.0001143}, {365,0.0001143}, {366,0.0000000}, {367,0.0000000}, {368,0.0005714}, {369,0.0003429}, {370,0.0000000}, {371,0.0000000}, {372,0.0001143}, {373,0.0000000}, {374,0.0000000}, {375,0.0002286}, {376,0.0002286}, {377,0.0000000}, {378,0.0001143}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0001143}, {383,0.0008000}, {384,0.0001143}, {385,0.0002286}, {386,0.0002286}, {387,0.0005714}, {388,0.0002286}, {389,0.0001143}, {390,0.0002286}, {391,0.0001143}, {392,0.0001143}, {393,0.0005714}, {394,0.0003429}, {395,0.0001143}, {396,0.0002286}, {397,0.0001143}, {398,0.0001143}, {399,0.0001143}, {400,0.0002286}, {401,0.0001143}, {402,0.0003429}, {403,0.0000000}, {404,0.0004571}, {405,0.0000000}, {406,0.0001143}, {407,0.0001143}, {408,0.0003429}, {409,0.0002286}, {410,0.0002000}, {411,0.0005714}, {412,0.0003429}, {413,0.0001143}, {414,0.0003143}, {415,0.0008000}, {416,0.0005714}, {417,0.0001143}, {418,0.0002286}, {419,0.0009143}, {420,0.0000000}, {421,0.0000000}, {422,0.0002286}, {423,0.0003429}, {424,0.0002286}, {425,0.0008000}, {426,0.0008000}, {427,0.0002286}, {428,0.0003429}, {429,0.0005714}, {430,0.0001143}, {431,0.0004571}, {432,0.0001143}, {433,0.0001143}, {434,0.0002286}, {435,0.0001143}, {436,0.0004571}, {437,0.0002286}, {438,0.0000000}, {439,0.0006857}, {440,0.0002286}, {441,0.0006857}, {442,0.0001143}, {443,0.0003429}, {444,0.0002286}, {445,0.0003429}, {446,0.0001143}, {447,0.0002286}, {448,0.0008000}, {449,0.0000000}, {450,0.0002286}, {451,0.0000000}, {452,0.0001143}, {453,0.0003429}, {454,0.0001143}, {455,0.0001143}, {456,0.0005714}, {457,0.0002286}, {458,0.0003429}, {459,0.0002286}, {460,0.0003429}, {461,0.0006571}, {462,0.0003143}, {463,0.0006857}, {464,0.0004571}, {465,0.0009143}, {466,0.0010286}, {467,0.0003429}, {468,0.0018000}, {469,0.0010286}, {470,0.0008000}, {471,0.0011429}, {472,0.0017143}, {473,0.0014571}, {474,0.0015714}, {475,0.0009143}, {476,0.0013714}, {477,0.0003429}, {478,0.0003429}, {479,0.0005714}, {480,0.0002286}, {481,0.0009143}, {482,0.0002286}, {483,0.0012571}, {484,0.0005714}, {485,0.0010286}, {486,0.0008000}, {487,0.0009143}, {488,0.0011429}, {489,0.0005714}, {490,0.0005714}, {491,0.0006857}, {492,0.0002286}, {493,0.0003429}, {494,0.0008000}, {495,0.0011429}, {496,0.0008000}, {497,0.0008000}, {498,0.0006857}, {499,0.0011429}, {500,0.0003429}, {505,0.0009143}, {510,0.0004571}, {515,0.0013714}, {520,0.0011429}, {525,0.0016000}, {530,0.0016857}, {535,0.0011429}, {540,0.0024857}, {545,0.0013714}, {550,0.0017143}, {555,0.0003429}, {560,0.0018286}, {565,0.0009143}, {570,0.0009143}, {575,0.0016000}, {580,0.0013714}, {585,0.0019143}, {590,0.0013714}, {595,0.0008857}, {600,0.0006857}, {605,0.0015714}, {610,0.0019429}, {615,0.0014571}, {620,0.0017143}, {625,0.0018286}, {630,0.0019429}, {635,0.0010286}, {640,0.0006857}, {645,0.0006857}, {650,0.0001143}, {655,0.0014857}, {660,0.0008000}, {665,0.0012571}, {670,0.0014857}, {675,0.0013714}, {680,0.0013714}, {685,0.0010286}, {690,0.0026286}, {695,0.0014857}, {700,0.0022571}, {705,0.0018286}, {710,0.0009143}, {715,0.0022857}, {720,0.0004571}, {725,0.0008000}, {730,0.0010286}, {735,0.0014571}, {740,0.0004286}, {745,0.0008000}, {750,0.0020571}, {755,0.0004571}, {760,0.0008000}, {765,0.0017143}, {770,0.0025143}, {775,0.0016000}, {780,0.0006286}, {785,0.0022857}, {790,0.0038857}, {795,0.0019429}, {800,0.0027429}, {805,0.0017143}, {810,0.0029714}, {815,0.0048857}, {820,0.0020000}, {825,0.0045714}, {830,0.0020571}, {835,0.0004571}, {840,0.0034286}, {845,0.0034286}, {850,0.0037143}, {855,0.0037143}, {860,0.0033143}, {865,0.0046857}, {870,0.0045714}, {875,0.0052571}, {880,0.0024000}, {885,0.0045714}, {890,0.0062571}, {895,0.0021714}, {900,0.0028000}, {905,0.0040857}, {910,0.0019429}, {915,0.0027143}, {920,0.0043429}, {925,0.0045714}, {930,0.0029714}, {935,0.0046857}, {940,0.0058857}, {945,0.0044286}, {950,0.0026000}, {955,0.0048571}, {960,0.0048857}, {965,0.0045714}, {970,0.0054571}, {975,0.0046571}, {980,0.0066000}, {985,0.0060857}, {990,0.0058286}, {995,0.0072857}, {1000,0.0073143}, {1010,0.0061714}, {1020,0.0056857}, {1030,0.0058571}, {1040,0.0058857}, {1050,0.0074000}, {1060,0.0042857}, {1070,0.0042571}, {1080,0.0056571}, {1090,0.0047429}, {1100,0.0062571}, {1110,0.0036571}, {1120,0.0059714}, {1130,0.0060857}, {1140,0.0066000}, {1150,0.0063143}, {1160,0.0053429}, {1170,0.0081143}, {1180,0.0076000}, {1190,0.0056857}, {1200,0.0076571}, {1210,0.0051429}, {1220,0.0064857}, {1230,0.0044571}, {1240,0.0066857}, {1250,0.0099429}, {1260,0.0114857}, {1270,0.0114857}, {1280,0.0139714}, {1290,0.0122286}, {1300,0.0102857}, {1310,0.0083429}, {1320,0.0124857}, {1330,0.0109143}, {1340,0.0128000}, {1350,0.0141143}, {1360,0.0128571}, {1370,0.0135714}, {1380,0.0095429}, {1390,0.0146857}, {1400,0.0136571}, {1410,0.0132857}, {1420,0.0139143}, {1430,0.0106857}, {1440,0.0141429}, {1450,0.0209429}, {1460,0.0118571}, {1470,0.0117714}, {1480,0.0146571}, {1490,0.0176857}, {1500,0.0145429}, {1510,0.0138571}, {1520,0.0152571}, {1530,0.0169714}, {1540,0.0140857}, {1550,0.0206571}, {1560,0.0159429}, {1570,0.0200286}, {1580,0.0155714}, {1590,0.0195143}, {1600,0.0164286}, {1610,0.0128857}, {1620,0.0139429}, {1630,0.0155143}, {1640,0.0204000}, {1650,0.0216286}, {1660,0.0140571}, {1670,0.0192286}, {1680,0.0198857}, {1690,0.0149143}, {1700,0.0140000}, {1710,0.0202286}, {1720,0.0181143}, {1730,0.0231429}, {1740,0.0166571}, {1750,0.0253143}, {1760,0.0210857}, {1770,0.0235714}, {1780,0.0307429}, {1790,0.0260000}, {1800,0.0194857}, {1810,0.0142000}, {1820,0.0277429}, {1830,0.0260571}, {1840,0.0261714}, {1850,0.0240000}, {1860,0.0194000}, {1870,0.0238000}, {1880,0.0257429}, {1890,0.0231143}, {1900,0.0322000}, {1910,0.0259429}, {1920,0.0307143}, {1930,0.0212000}, {1940,0.0278000}, {1950,0.0252286}, {1960,0.0250857}, {1970,0.0222000}, {1980,0.0273143}, {1990,0.0271143}, {2000,0.0244857}};
data["big"]["LtacTacInTermPrimPair"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermPrimPair"]["post"]["user"] = {{1,0.00007921}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00002970}, {6,0.00000000}, {7,0.00003960}, {8,0.00003960}, {9,0.00003960}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00011881}, {14,0.00000000}, {15,0.00002970}, {16,0.00000000}, {17,0.00002970}, {18,0.00000000}, {19,0.00003960}, {20,0.00003960}, {21,0.00000000}, {22,0.00006931}, {23,0.00000000}, {24,0.00000000}, {25,0.00003960}, {26,0.00000000}, {27,0.00000000}, {28,0.00019802}, {29,0.00007921}, {30,0.00000000}, {31,0.00003960}, {32,0.00007921}, {33,0.00000000}, {34,0.00000000}, {35,0.00006931}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003960}, {42,0.00000000}, {43,0.00003960}, {44,0.00003960}, {45,0.00003960}, {46,0.00000000}, {47,0.00007921}, {48,0.00007921}, {49,0.00007921}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00003960}, {55,0.00003960}, {56,0.00000000}, {57,0.00002970}, {58,0.00009901}, {59,0.00003960}, {60,0.00000000}, {61,0.00000000}, {62,0.00003960}, {63,0.00003960}, {64,0.00000000}, {65,0.00005941}, {66,0.00000000}, {67,0.00003960}, {68,0.00003960}, {69,0.00003960}, {70,0.00000000}, {71,0.00003960}, {72,0.00010891}, {73,0.00000000}, {74,0.00007921}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00002970}, {79,0.00003960}, {80,0.00003960}, {81,0.00011881}, {82,0.00000000}, {83,0.00003960}, {84,0.00011881}, {85,0.00003960}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00006931}, {90,0.00006931}, {91,0.00000000}, {92,0.00003960}, {93,0.00000000}, {94,0.00003960}, {95,0.00000000}, {96,0.00000000}, {97,0.00002970}, {98,0.00000000}, {99,0.00002970}, {100,0.00000000}, {101,0.00003960}, {102,0.00006931}, {103,0.00003960}, {104,0.00003960}, {105,0.00000000}, {106,0.00003960}, {107,0.00007921}, {108,0.00000000}, {109,0.00005941}, {110,0.00000000}, {111,0.00003960}, {112,0.00003960}, {113,0.00000000}, {114,0.00006931}, {115,0.00000000}, {116,0.00003960}, {117,0.00003960}, {118,0.00006931}, {119,0.00000000}, {120,0.00003960}, {121,0.00003960}, {122,0.00003960}, {123,0.00000000}, {124,0.00000000}, {125,0.00003960}, {126,0.00000000}, {127,0.00003960}, {128,0.00000000}, {129,0.00002970}, {130,0.00011881}, {131,0.00000000}, {132,0.00003960}, {133,0.00000000}, {134,0.00003960}, {135,0.00000000}, {136,0.00006931}, {137,0.00003960}, {138,0.00000000}, {139,0.00003960}, {140,0.00013861}, {141,0.00002970}, {142,0.00000000}, {143,0.00003960}, {144,0.00000000}, {145,0.00007921}, {146,0.00007921}, {147,0.00006931}, {148,0.00003960}, {149,0.00000000}, {150,0.00007921}, {151,0.00003960}, {152,0.00006931}, {153,0.00007921}, {154,0.00000000}, {155,0.00000000}, {156,0.00003960}, {157,0.00000000}, {158,0.00000000}, {159,0.00003960}, {160,0.00003960}, {161,0.00000000}, {162,0.00000000}, {163,0.00003960}, {164,0.00003960}, {165,0.00006931}, {166,0.00000000}, {167,0.00000000}, {168,0.00003960}, {169,0.00002970}, {170,0.00003960}, {171,0.00003960}, {172,0.00000000}, {173,0.00007921}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00002970}, {178,0.00002970}, {179,0.00003960}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00007921}, {184,0.00003960}, {185,0.00003960}, {186,0.00000000}, {187,0.00003960}, {188,0.00003960}, {189,0.00000000}, {190,0.00000000}, {191,0.00003960}, {192,0.00000000}, {193,0.00000000}, {194,0.00003960}, {195,0.00000000}, {196,0.00015842}, {197,0.00000000}, {198,0.00000000}, {199,0.00007921}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00003960}, {204,0.00002970}, {205,0.00000000}, {206,0.00003960}, {207,0.00000000}, {208,0.00007921}, {209,0.00000000}, {210,0.00000000}, {211,0.00003960}, {212,0.00000000}, {213,0.00000000}, {214,0.00003960}, {215,0.00002970}, {216,0.00000000}, {217,0.00007921}, {218,0.00003960}, {219,0.00000000}, {220,0.00003960}, {221,0.00000000}, {222,0.00003960}, {223,0.00003960}, {224,0.00003960}, {225,0.00014851}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00006931}, {230,0.00003960}, {231,0.00003960}, {232,0.00007921}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00011881}, {237,0.00003960}, {238,0.00000000}, {239,0.00003960}, {240,0.00000000}, {241,0.00002970}, {242,0.00000000}, {243,0.00003960}, {244,0.00003960}, {245,0.00000000}, {246,0.00000000}, {247,0.00003960}, {248,0.00002970}, {249,0.00000000}, {250,0.00000000}, {251,0.00007921}, {252,0.00002970}, {253,0.00014851}, {254,0.00003960}, {255,0.00000000}, {256,0.00007921}, {257,0.00003960}, {258,0.00003960}, {259,0.00007921}, {260,0.00011881}, {261,0.00000000}, {262,0.00003960}, {263,0.00002970}, {264,0.00006931}, {265,0.00000000}, {266,0.00002970}, {267,0.00002970}, {268,0.00005941}, {269,0.00000000}, {270,0.00002970}, {271,0.00007921}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00006931}, {276,0.00000000}, {277,0.00006931}, {278,0.00000000}, {279,0.00002970}, {280,0.00002970}, {281,0.00003960}, {282,0.00006931}, {283,0.00000000}, {284,0.00000000}, {285,0.00002970}, {286,0.00002970}, {287,0.00002970}, {288,0.00000000}, {289,0.00013861}, {290,0.00000000}, {291,0.00002970}, {292,0.00000000}, {293,0.00000000}, {294,0.00003960}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00011881}, {299,0.00000000}, {300,0.00002970}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0001143}, {308,0.0000000}, {309,0.0000857}, {310,0.0000857}, {311,0.0000000}, {312,0.0001714}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0002000}, {317,0.0000857}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000857}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000857}, {333,0.0000000}, {334,0.0000000}, {335,0.0000857}, {336,0.0000857}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0001714}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000857}, {350,0.0000000}, {351,0.0000857}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000857}, {368,0.0000857}, {369,0.0000857}, {370,0.0000000}, {371,0.0000857}, {372,0.0000000}, {373,0.0000000}, {374,0.0000857}, {375,0.0000000}, {376,0.0000857}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0001143}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0001714}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000857}, {395,0.0000000}, {396,0.0001714}, {397,0.0000857}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000857}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000857}, {415,0.0000000}, {416,0.0001714}, {417,0.0000000}, {418,0.0000857}, {419,0.0000857}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000857}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000857}, {432,0.0000857}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000857}, {444,0.0000000}, {445,0.0000857}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0002000}, {450,0.0000000}, {451,0.0000000}, {452,0.0001143}, {453,0.0001143}, {454,0.0002000}, {455,0.0000857}, {456,0.0000000}, {457,0.0000000}, {458,0.0000857}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000857}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000857}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000857}, {474,0.0000000}, {475,0.0002000}, {476,0.0000857}, {477,0.0000000}, {478,0.0001714}, {479,0.0000857}, {480,0.0000857}, {481,0.0000000}, {482,0.0001143}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000857}, {487,0.0000000}, {488,0.0000857}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000857}, {495,0.0000000}, {496,0.0000857}, {497,0.0000000}, {498,0.0000000}, {499,0.0000857}, {500,0.0000857}, {505,0.0000000}, {510,0.0000857}, {515,0.0000000}, {520,0.0000000}, {525,0.0001143}, {530,0.0000000}, {535,0.0000857}, {540,0.0000857}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000857}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000857}, {615,0.0001143}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000857}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000857}, {680,0.0000000}, {685,0.0000000}, {690,0.0000857}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000857}, {715,0.0000857}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000857}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000857}, {765,0.0000857}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000857}, {810,0.0000857}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0001714}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000857}, {880,0.0000857}, {885,0.0000000}, {890,0.0000857}, {895,0.0000000}, {900,0.0000000}, {905,0.0000857}, {910,0.0000000}, {915,0.0000000}, {920,0.0000857}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000857}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0001143}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000857}, {1080,0.0000000}, {1090,0.0000857}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0001143}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0001143}, {1270,0.0000857}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0002000}, {1370,0.0000000}, {1380,0.0000857}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0001143}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0001143}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000857}, {1480,0.0000000}, {1490,0.0000857}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0001143}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0001143}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0002000}, {1810,0.0000857}, {1820,0.0001143}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0001143}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0002286}, {1930,0.0001143}, {1940,0.0000000}, {1950,0.0002286}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0001143}, {2000,0.0000000}};
data["big"]["LtacTacInTermPrimPair"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00003960}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0001143}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermPrimPair"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermPrimPair"]["pre"]["user"] = {{1,0.00000000}, {2,0.00003960}, {3,0.00000000}, {4,0.00003960}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00003960}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00003960}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00003960}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00003960}, {40,0.00003960}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00003960}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00003960}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00006931}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00003960}, {92,0.00000000}, {93,0.00000000}, {94,0.00003960}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00003960}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003960}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00003960}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00002970}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00002970}, {142,0.00000000}, {143,0.00000000}, {144,0.00002970}, {145,0.00000000}, {146,0.00002970}, {147,0.00000000}, {148,0.00000000}, {149,0.00003960}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00003960}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00003960}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00003960}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00003960}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00003960}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00003960}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00003960}, {234,0.00000000}, {235,0.00003960}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00003960}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00003960}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00005941}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003960}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00002970}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000857}, {310,0.0000857}, {311,0.0000000}, {312,0.0000857}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000857}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000857}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000857}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000857}, {466,0.0000000}, {467,0.0000000}, {468,0.0000857}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000857}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000857}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000857}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0001714}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000857}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000857}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0001143}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000857}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000857}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0001143}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0001143}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0001143}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0001143}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0001143}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermPrimPair"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.0000000}, {302,0.0000000}, {303,0.0000000}, {304,0.0000000}, {305,0.0000000}, {306,0.0000000}, {307,0.0000000}, {308,0.0000000}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0000000}, {313,0.0000000}, {314,0.0000000}, {315,0.0000000}, {316,0.0000000}, {317,0.0000000}, {318,0.0000000}, {319,0.0000000}, {320,0.0000000}, {321,0.0000000}, {322,0.0000000}, {323,0.0000000}, {324,0.0000000}, {325,0.0000000}, {326,0.0000000}, {327,0.0000000}, {328,0.0000000}, {329,0.0000000}, {330,0.0000000}, {331,0.0000000}, {332,0.0000000}, {333,0.0000000}, {334,0.0000000}, {335,0.0000000}, {336,0.0000000}, {337,0.0000000}, {338,0.0000000}, {339,0.0000000}, {340,0.0000000}, {341,0.0000000}, {342,0.0000000}, {343,0.0000000}, {344,0.0000000}, {345,0.0000000}, {346,0.0000000}, {347,0.0000000}, {348,0.0000000}, {349,0.0000000}, {350,0.0000000}, {351,0.0000000}, {352,0.0000000}, {353,0.0000000}, {354,0.0000000}, {355,0.0000000}, {356,0.0000000}, {357,0.0000000}, {358,0.0000000}, {359,0.0000000}, {360,0.0000000}, {361,0.0000000}, {362,0.0000000}, {363,0.0000000}, {364,0.0000000}, {365,0.0000000}, {366,0.0000000}, {367,0.0000000}, {368,0.0000000}, {369,0.0000000}, {370,0.0000000}, {371,0.0000000}, {372,0.0000000}, {373,0.0000000}, {374,0.0000000}, {375,0.0000000}, {376,0.0000000}, {377,0.0000000}, {378,0.0000000}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0000000}, {383,0.0000000}, {384,0.0000000}, {385,0.0000000}, {386,0.0000000}, {387,0.0000000}, {388,0.0000000}, {389,0.0000000}, {390,0.0000000}, {391,0.0000000}, {392,0.0000000}, {393,0.0000000}, {394,0.0000000}, {395,0.0000000}, {396,0.0000000}, {397,0.0000000}, {398,0.0000000}, {399,0.0000000}, {400,0.0000000}, {401,0.0000000}, {402,0.0000000}, {403,0.0000000}, {404,0.0000000}, {405,0.0000000}, {406,0.0000000}, {407,0.0000000}, {408,0.0000000}, {409,0.0000000}, {410,0.0000000}, {411,0.0000000}, {412,0.0000000}, {413,0.0000000}, {414,0.0000000}, {415,0.0000000}, {416,0.0000000}, {417,0.0000000}, {418,0.0000000}, {419,0.0000000}, {420,0.0000000}, {421,0.0000000}, {422,0.0000000}, {423,0.0000000}, {424,0.0000000}, {425,0.0000000}, {426,0.0000000}, {427,0.0000000}, {428,0.0000000}, {429,0.0000000}, {430,0.0000000}, {431,0.0000000}, {432,0.0000000}, {433,0.0000000}, {434,0.0000000}, {435,0.0000000}, {436,0.0000000}, {437,0.0000000}, {438,0.0000000}, {439,0.0000000}, {440,0.0000000}, {441,0.0000000}, {442,0.0000000}, {443,0.0000000}, {444,0.0000000}, {445,0.0000000}, {446,0.0000000}, {447,0.0000000}, {448,0.0000000}, {449,0.0000000}, {450,0.0000000}, {451,0.0000000}, {452,0.0000000}, {453,0.0000000}, {454,0.0000000}, {455,0.0000000}, {456,0.0000000}, {457,0.0000000}, {458,0.0000000}, {459,0.0000000}, {460,0.0000000}, {461,0.0000000}, {462,0.0000000}, {463,0.0000000}, {464,0.0000000}, {465,0.0000000}, {466,0.0000000}, {467,0.0000000}, {468,0.0000000}, {469,0.0000000}, {470,0.0000000}, {471,0.0000000}, {472,0.0000000}, {473,0.0000000}, {474,0.0000000}, {475,0.0000000}, {476,0.0000000}, {477,0.0000000}, {478,0.0000000}, {479,0.0000000}, {480,0.0000000}, {481,0.0000000}, {482,0.0000000}, {483,0.0000000}, {484,0.0000000}, {485,0.0000000}, {486,0.0000000}, {487,0.0000000}, {488,0.0000000}, {489,0.0000000}, {490,0.0000000}, {491,0.0000000}, {492,0.0000000}, {493,0.0000000}, {494,0.0000000}, {495,0.0000000}, {496,0.0000000}, {497,0.0000000}, {498,0.0000000}, {499,0.0000000}, {500,0.0000000}, {505,0.0000000}, {510,0.0000000}, {515,0.0000000}, {520,0.0000000}, {525,0.0000000}, {530,0.0000000}, {535,0.0000000}, {540,0.0000000}, {545,0.0000000}, {550,0.0000000}, {555,0.0000000}, {560,0.0000000}, {565,0.0000000}, {570,0.0000000}, {575,0.0000000}, {580,0.0000000}, {585,0.0000000}, {590,0.0000000}, {595,0.0000000}, {600,0.0000000}, {605,0.0000000}, {610,0.0000000}, {615,0.0000000}, {620,0.0000000}, {625,0.0000000}, {630,0.0000000}, {635,0.0000000}, {640,0.0000000}, {645,0.0000000}, {650,0.0000000}, {655,0.0000000}, {660,0.0000000}, {665,0.0000000}, {670,0.0000000}, {675,0.0000000}, {680,0.0000000}, {685,0.0000000}, {690,0.0000000}, {695,0.0000000}, {700,0.0000000}, {705,0.0000000}, {710,0.0000000}, {715,0.0000000}, {720,0.0000000}, {725,0.0000000}, {730,0.0000000}, {735,0.0000000}, {740,0.0000000}, {745,0.0000000}, {750,0.0000000}, {755,0.0000000}, {760,0.0000000}, {765,0.0000000}, {770,0.0000000}, {775,0.0000000}, {780,0.0000000}, {785,0.0000000}, {790,0.0000000}, {795,0.0000000}, {800,0.0000000}, {805,0.0000000}, {810,0.0000000}, {815,0.0000000}, {820,0.0000000}, {825,0.0000000}, {830,0.0000000}, {835,0.0000000}, {840,0.0000000}, {845,0.0000000}, {850,0.0000000}, {855,0.0000000}, {860,0.0000000}, {865,0.0000000}, {870,0.0000000}, {875,0.0000000}, {880,0.0000000}, {885,0.0000000}, {890,0.0000000}, {895,0.0000000}, {900,0.0000000}, {905,0.0000000}, {910,0.0000000}, {915,0.0000000}, {920,0.0000000}, {925,0.0000000}, {930,0.0000000}, {935,0.0000000}, {940,0.0000000}, {945,0.0000000}, {950,0.0000000}, {955,0.0000000}, {960,0.0000000}, {965,0.0000000}, {970,0.0000000}, {975,0.0000000}, {980,0.0000000}, {985,0.0000000}, {990,0.0000000}, {995,0.0000000}, {1000,0.0000000}, {1010,0.0000000}, {1020,0.0000000}, {1030,0.0000000}, {1040,0.0000000}, {1050,0.0000000}, {1060,0.0000000}, {1070,0.0000000}, {1080,0.0000000}, {1090,0.0000000}, {1100,0.0000000}, {1110,0.0000000}, {1120,0.0000000}, {1130,0.0000000}, {1140,0.0000000}, {1150,0.0000000}, {1160,0.0000000}, {1170,0.0000000}, {1180,0.0000000}, {1190,0.0000000}, {1200,0.0000000}, {1210,0.0000000}, {1220,0.0000000}, {1230,0.0000000}, {1240,0.0000000}, {1250,0.0000000}, {1260,0.0000000}, {1270,0.0000000}, {1280,0.0000000}, {1290,0.0000000}, {1300,0.0000000}, {1310,0.0000000}, {1320,0.0000000}, {1330,0.0000000}, {1340,0.0000000}, {1350,0.0000000}, {1360,0.0000000}, {1370,0.0000000}, {1380,0.0000000}, {1390,0.0000000}, {1400,0.0000000}, {1410,0.0000000}, {1420,0.0000000}, {1430,0.0000000}, {1440,0.0000000}, {1450,0.0000000}, {1460,0.0000000}, {1470,0.0000000}, {1480,0.0000000}, {1490,0.0000000}, {1500,0.0000000}, {1510,0.0000000}, {1520,0.0000000}, {1530,0.0000000}, {1540,0.0000000}, {1550,0.0000000}, {1560,0.0000000}, {1570,0.0000000}, {1580,0.0000000}, {1590,0.0000000}, {1600,0.0000000}, {1610,0.0000000}, {1620,0.0000000}, {1630,0.0000000}, {1640,0.0000000}, {1650,0.0000000}, {1660,0.0000000}, {1670,0.0000000}, {1680,0.0000000}, {1690,0.0000000}, {1700,0.0000000}, {1710,0.0000000}, {1720,0.0000000}, {1730,0.0000000}, {1740,0.0000000}, {1750,0.0000000}, {1760,0.0000000}, {1770,0.0000000}, {1780,0.0000000}, {1790,0.0000000}, {1800,0.0000000}, {1810,0.0000000}, {1820,0.0000000}, {1830,0.0000000}, {1840,0.0000000}, {1850,0.0000000}, {1860,0.0000000}, {1870,0.0000000}, {1880,0.0000000}, {1890,0.0000000}, {1900,0.0000000}, {1910,0.0000000}, {1920,0.0000000}, {1930,0.0000000}, {1940,0.0000000}, {1950,0.0000000}, {1960,0.0000000}, {1970,0.0000000}, {1980,0.0000000}, {1990,0.0000000}, {2000,0.0000000}};
data["big"]["LtacTacInTermPrimPair"]["reif"]["real"] = {{1,0.00000000}, {2,0.00100000}, {3,0.00100000}, {4,0.01966337}, {5,0.00200000}, {6,0.00204950}, {7,0.00300000}, {8,0.00300000}, {9,0.00382178}, {10,0.00400000}, {11,0.00431683}, {12,0.00500990}, {13,0.00536634}, {14,0.00601980}, {15,0.00799010}, {16,0.00703960}, {17,0.00774257}, {18,0.00817822}, {19,0.00879208}, {20,0.00952475}, {21,0.00989109}, {22,0.01050495}, {23,0.01451485}, {24,0.01158416}, {25,0.01234653}, {26,0.01288119}, {27,0.01364356}, {28,0.01427723}, {29,0.01471287}, {30,0.01546535}, {31,0.01617822}, {32,0.01678218}, {33,0.01745545}, {34,0.01815842}, {35,0.01893069}, {36,0.01944554}, {37,0.02001980}, {38,0.02070297}, {39,0.02161386}, {40,0.02231683}, {41,0.02300990}, {42,0.02951485}, {43,0.02467327}, {44,0.02540594}, {45,0.02595050}, {46,0.02667327}, {47,0.02785149}, {48,0.03639604}, {49,0.02936634}, {50,0.03377228}, {51,0.03100990}, {52,0.03933663}, {53,0.03303960}, {54,0.03398020}, {55,0.04562376}, {56,0.03576238}, {57,0.03687129}, {58,0.03775248}, {59,0.03939604}, {60,0.04766337}, {61,0.05057426}, {62,0.05166337}, {63,0.05155446}, {64,0.04861386}, {65,0.04414851}, {66,0.04566337}, {67,0.04658416}, {68,0.06030693}, {69,0.04854455}, {70,0.05002970}, {71,0.06700000}, {72,0.05191089}, {73,0.07008911}, {74,0.05473267}, {75,0.06709901}, {76,0.05635644}, {77,0.05776238}, {78,0.06749505}, {79,0.09201980}, {80,0.06793069}, {81,0.06263366}, {82,0.06376238}, {83,0.06499010}, {84,0.06622772}, {85,0.07733663}, {86,0.09788119}, {87,0.08995050}, {88,0.08603960}, {89,0.09122772}, {90,0.11157426}, {91,0.09818812}, {92,0.08941584}, {93,0.09010891}, {94,0.09173267}, {95,0.09297030}, {96,0.09320792}, {97,0.09349505}, {98,0.09445545}, {99,0.09490099}, {100,0.09562376}, {101,0.09654455}, {102,0.09685149}, {103,0.09779208}, {104,0.09826733}, {105,0.09900990}, {106,0.09993069}, {107,0.10065347}, {108,0.10117822}, {109,0.10195050}, {110,0.10306931}, {111,0.10517822}, {112,0.10652475}, {113,0.10830693}, {114,0.10971287}, {115,0.11145545}, {116,0.11316832}, {117,0.11509901}, {118,0.11709901}, {119,0.11841584}, {120,0.12044554}, {121,0.12199010}, {122,0.12358416}, {123,0.12629703}, {124,0.14093069}, {125,0.14361386}, {126,0.14498020}, {127,0.16013861}, {128,0.16549505}, {129,0.16512871}, {130,0.16734653}, {131,0.17067327}, {132,0.17408911}, {133,0.17355446}, {134,0.17883168}, {135,0.17903960}, {136,0.18180198}, {137,0.18558416}, {138,0.18571287}, {139,0.19017822}, {140,0.19257426}, {141,0.19429703}, {142,0.19634653}, {143,0.19731683}, {144,0.20189109}, {145,0.20478218}, {146,0.20831683}, {147,0.21053465}, {148,0.21173267}, {149,0.21395050}, {150,0.21624752}, {151,0.21758416}, {152,0.21933663}, {153,0.21971287}, {154,0.22129703}, {155,0.22968317}, {156,0.23278218}, {157,0.23750495}, {158,0.23777228}, {159,0.24222772}, {160,0.24456436}, {161,0.24606931}, {162,0.24853465}, {163,0.25310891}, {164,0.25638614}, {165,0.26004950}, {166,0.26200000}, {167,0.26656436}, {168,0.26747525}, {169,0.26569307}, {170,0.27207921}, {171,0.27909901}, {172,0.27840594}, {173,0.28265347}, {174,0.28562376}, {175,0.28773267}, {176,0.29250495}, {177,0.29442574}, {178,0.29641584}, {179,0.29931683}, {180,0.30356436}, {181,0.30830693}, {182,0.31149505}, {183,0.31488119}, {184,0.31827723}, {185,0.32119802}, {186,0.32461386}, {187,0.32676238}, {188,0.32847525}, {189,0.33109901}, {190,0.33564356}, {191,0.33998020}, {192,0.34068317}, {193,0.34142574}, {194,0.34511881}, {195,0.35130693}, {196,0.35863366}, {197,0.36953465}, {198,0.36688119}, {199,0.36597030}, {200,0.37024752}, {201,0.37648515}, {202,0.37635644}, {203,0.38604950}, {204,0.39800990}, {205,0.38275248}, {206,0.39177228}, {207,0.39200000}, {208,0.40300000}, {209,0.41703960}, {210,0.40775248}, {211,0.40827723}, {212,0.41074257}, {213,0.43475248}, {214,0.42141584}, {215,0.42047525}, {216,0.43290099}, {217,0.44134653}, {218,0.43877228}, {219,0.44398020}, {220,0.45685149}, {221,0.45197030}, {222,0.45732673}, {223,0.46516832}, {224,0.46373267}, {225,0.47584158}, {226,0.47160396}, {227,0.47564356}, {228,0.48718812}, {229,0.48437624}, {230,0.49802970}, {231,0.49241584}, {232,0.50735644}, {233,0.49773267}, {234,0.51515842}, {235,0.50755446}, {236,0.52318812}, {237,0.51500990}, {238,0.52737624}, {239,0.52685149}, {240,0.53320792}, {241,0.54085149}, {242,0.54017822}, {243,0.55090099}, {244,0.55377228}, {245,0.55580198}, {246,0.56261386}, {247,0.56667327}, {248,0.56924752}, {249,0.58080198}, {250,0.57521782}, {251,0.58252475}, {252,0.59700000}, {253,0.59223762}, {254,0.59637624}, {255,0.60815842}, {256,0.60741584}, {257,0.60998020}, {258,0.62041584}, {259,0.62631683}, {260,0.63325743}, {261,0.63073267}, {262,0.63487129}, {263,0.64308911}, {264,0.64370297}, {265,0.65294059}, {266,0.65939604}, {267,0.66249505}, {268,0.66486139}, {269,0.66947525}, {270,0.67752475}, {271,0.68151485}, {272,0.68712871}, {273,0.69286139}, {274,0.69719802}, {275,0.70500990}, {276,0.71196040}, {277,0.71722772}, {278,0.71868317}, {279,0.72420792}, {280,0.73051485}, {281,0.73450495}, {282,0.73959406}, {283,0.74436634}, {284,0.74905941}, {285,0.75841584}, {286,0.75807921}, {287,0.75946535}, {288,0.76756436}, {289,0.77501980}, {290,0.78946535}, {291,0.79550495}, {292,0.80322772}, {293,0.81268317}, {294,0.81497030}, {295,0.82130693}, {296,0.83653465}, {297,0.82911881}, {298,0.83317822}, {299,0.84330693}, {300,0.84475248}, {301,0.8647714}, {302,0.9854000}, {303,0.9348286}, {304,0.9332571}, {305,0.9006571}, {306,0.9025714}, {307,0.9039429}, {308,0.9144571}, {309,0.9228571}, {310,0.9198571}, {311,0.9316000}, {312,0.9394571}, {313,0.9443143}, {314,0.9461143}, {315,0.9579714}, {316,0.9614857}, {317,0.9636857}, {318,0.9712571}, {319,0.9828571}, {320,0.9846000}, {321,0.9890286}, {322,1.0003714}, {323,1.0042000}, {324,1.0129429}, {325,1.0221429}, {326,1.0222571}, {327,1.0381143}, {328,1.0387143}, {329,1.0409429}, {330,1.0558857}, {331,1.0530000}, {332,1.0738857}, {333,1.0564000}, {334,1.0740286}, {335,1.0748571}, {336,1.0840000}, {337,1.0914286}, {338,1.0936000}, {339,1.1044000}, {340,1.1052286}, {341,1.1231429}, {342,1.1302571}, {343,1.1388000}, {344,1.1514571}, {345,1.1537714}, {346,1.1540000}, {347,1.1650857}, {348,1.1747714}, {349,1.1800857}, {350,1.1863714}, {351,1.2036000}, {352,1.2082571}, {353,1.2070571}, {354,1.2204286}, {355,1.2183714}, {356,1.2281429}, {357,1.2374857}, {358,1.2494000}, {359,1.2478000}, {360,1.2677714}, {361,1.2686000}, {362,1.2722000}, {363,1.2939714}, {364,1.2900286}, {365,1.2994571}, {366,1.3038000}, {367,1.3212286}, {368,1.3164286}, {369,1.3281714}, {370,1.3454571}, {371,1.3488286}, {372,1.3573429}, {373,1.3617143}, {374,1.3731714}, {375,1.3868000}, {376,1.3894286}, {377,1.3969714}, {378,1.4056857}, {379,1.4111429}, {380,1.4188286}, {381,1.4296857}, {382,1.4418857}, {383,1.4522286}, {384,1.4619714}, {385,1.4738571}, {386,1.4780571}, {387,1.4966571}, {388,1.4951429}, {389,1.5062000}, {390,1.5175429}, {391,1.5201143}, {392,1.5236571}, {393,1.5373143}, {394,1.5511429}, {395,1.5577714}, {396,1.5671714}, {397,1.5727143}, {398,1.5762857}, {399,1.5896857}, {400,1.5984286}, {401,1.6087714}, {402,1.6186857}, {403,1.6294857}, {404,1.6321429}, {405,1.6530571}, {406,1.6584286}, {407,1.6664000}, {408,1.6745143}, {409,1.6804286}, {410,1.6864000}, {411,1.6974571}, {412,1.6983714}, {413,1.7121143}, {414,1.7187143}, {415,1.7336000}, {416,1.7351429}, {417,1.7473714}, {418,1.7496571}, {419,1.8086286}, {420,1.8023714}, {421,1.7881429}, {422,1.7974286}, {423,1.8051143}, {424,1.8118571}, {425,1.8298000}, {426,1.8326000}, {427,1.8588000}, {428,1.8600571}, {429,1.8748857}, {430,1.8796571}, {431,1.8983143}, {432,1.9002286}, {433,1.9114286}, {434,1.9169429}, {435,1.9294571}, {436,1.9333429}, {437,1.9483143}, {438,1.9600857}, {439,1.9768000}, {440,1.9917429}, {441,1.9951714}, {442,2.0051143}, {443,2.0109143}, {444,2.0198857}, {445,2.0387714}, {446,2.0392286}, {447,2.0527714}, {448,2.0569143}, {449,2.0771429}, {450,2.0841714}, {451,2.0938857}, {452,2.0985714}, {453,2.1109429}, {454,2.1242571}, {455,2.1387143}, {456,2.1537143}, {457,2.1606857}, {458,2.1734000}, {459,2.1817143}, {460,2.1968857}, {461,2.1987143}, {462,2.2032571}, {463,2.2252286}, {464,2.2361714}, {465,2.2461714}, {466,2.2536286}, {467,2.2938286}, {468,2.3104286}, {469,2.2917429}, {470,2.3054857}, {471,2.3310571}, {472,2.3177429}, {473,2.3316857}, {474,2.3389714}, {475,2.3378000}, {476,2.3484571}, {477,2.3709714}, {478,2.4058857}, {479,2.3813714}, {480,2.4554857}, {481,2.5129714}, {482,2.4302857}, {483,2.5392286}, {484,2.4669714}, {485,2.5448000}, {486,2.5033143}, {487,2.5792857}, {488,2.5966286}, {489,2.5674857}, {490,2.5277429}, {491,2.5367714}, {492,2.5758571}, {493,2.6074571}, {494,2.6309143}, {495,2.6410571}, {496,2.6865429}, {497,2.7414000}, {498,2.6592857}, {499,2.6890286}, {500,2.6704857}, {505,2.7731714}, {510,2.7936571}, {515,2.9422857}, {520,3.0314571}, {525,3.1735714}, {530,3.1497429}, {535,3.1944571}, {540,3.2245429}, {545,3.2817714}, {550,3.3367429}, {555,3.3897429}, {560,3.4343143}, {565,3.5770000}, {570,3.6301714}, {575,3.6766286}, {580,3.7470857}, {585,3.8712857}, {590,3.9059714}, {595,4.0030000}, {600,4.0684857}, {605,4.2738000}, {610,4.2577429}, {615,4.3143143}, {620,4.4122857}, {625,4.4889429}, {630,4.6406571}, {635,4.6781429}, {640,4.7814000}, {645,4.7768000}, {650,4.8831143}, {655,5.0948571}, {660,5.1646000}, {665,5.1506571}, {670,5.1489429}, {675,5.2554857}, {680,5.3689714}, {685,5.5024286}, {690,5.6573714}, {695,5.6571714}, {700,5.8199714}, {705,5.8157429}, {710,5.9907143}, {715,6.0966000}, {720,6.1461429}, {725,6.2292000}, {730,6.3436000}, {735,6.6060571}, {740,6.6260857}, {745,6.7070857}, {750,6.8529143}, {755,6.9774571}, {760,7.0738286}, {765,7.2136286}, {770,7.3254000}, {775,7.4427143}, {780,7.5250000}, {785,7.6611143}, {790,7.7808571}, {795,7.9030000}, {800,8.1298000}, {805,8.1356857}, {810,8.2960000}, {815,8.3903429}, {820,8.5509143}, {825,8.6636857}, {830,8.7923429}, {835,8.9047143}, {840,9.0398857}, {845,9.2076571}, {850,9.4027429}, {855,9.5187714}, {860,9.6420000}, {865,9.8045714}, {870,9.9555714}, {875,10.2136857}, {880,10.2802571}, {885,10.7327429}, {890,10.5344571}, {895,10.7379429}, {900,11.1414857}, {905,11.1014571}, {910,11.3046857}, {915,11.4014857}, {920,11.8952000}, {925,11.9586571}, {930,12.0576000}, {935,12.0524571}, {940,12.5502857}, {945,12.3122286}, {950,12.5525714}, {955,12.8392857}, {960,13.3603429}, {965,13.4001714}, {970,13.2884286}, {975,13.5678000}, {980,13.8853143}, {985,14.3266286}, {990,14.2682000}, {995,14.6785143}, {1000,14.6491143}, {1010,15.2787714}, {1020,15.5269714}, {1030,16.0764000}, {1040,16.2942286}, {1050,16.7929714}, {1060,17.4128000}, {1070,17.8647429}, {1080,18.5404286}, {1090,18.2532571}, {1100,19.0254000}, {1110,19.3821143}, {1120,19.9417714}, {1130,20.3577714}, {1140,20.8457714}, {1150,21.3545714}, {1160,21.8547714}, {1170,22.3016571}, {1180,23.1248000}, {1190,23.4724286}, {1200,24.0508000}, {1210,24.7285143}, {1220,25.1326857}, {1230,25.4214571}, {1240,26.1679429}, {1250,27.0522000}, {1260,27.5948571}, {1270,28.1524000}, {1280,28.5728000}, {1290,28.9939143}, {1300,29.6890857}, {1310,30.3914000}, {1320,31.0440571}, {1330,31.9746857}, {1340,32.5606000}, {1350,33.0897714}, {1360,33.5945143}, {1370,34.2587429}, {1380,35.0252000}, {1390,35.7057714}, {1400,36.4426571}, {1410,37.0534571}, {1420,38.0946857}, {1430,38.8625714}, {1440,39.4799143}, {1450,40.0389714}, {1460,40.8281714}, {1470,42.0548286}, {1480,42.4601429}, {1490,43.3064000}, {1500,43.7422000}, {1510,45.0472286}, {1520,45.6261143}, {1530,47.0456000}, {1540,48.0016286}, {1550,48.8325143}, {1560,49.4811714}, {1570,50.2149714}, {1580,51.5699429}, {1590,52.5106571}, {1600,53.0815143}, {1610,54.2264857}, {1620,55.2599714}, {1630,55.5574000}, {1640,56.1588857}, {1650,57.7179143}, {1660,58.7261714}, {1670,59.6906286}, {1680,60.4470000}, {1690,62.3095429}, {1700,63.6007143}, {1710,64.5008286}, {1720,65.5620000}, {1730,66.3948000}, {1740,67.5694857}, {1750,68.2079143}, {1760,69.0746000}, {1770,70.5469143}, {1780,71.6455429}, {1790,72.8983429}, {1800,73.9936857}, {1810,75.4002000}, {1820,76.6174571}, {1830,77.1188571}, {1840,78.7174571}, {1850,80.6260286}, {1860,81.8795143}, {1870,83.2105714}, {1880,84.3291143}, {1890,86.3856286}, {1900,86.4202571}, {1910,88.4325714}, {1920,89.4210000}, {1930,90.8923714}, {1940,91.5558571}, {1950,92.8473143}, {1960,95.2555143}, {1970,94.9547429}, {1980,96.8423714}, {1990,98.1804000}, {2000,99.7920857}};
data["big"]["LtacTacInTermPrimPair"]["reif"]["user"] = {{1,0.00074257}, {2,0.00102970}, {3,0.00147525}, {4,0.01909901}, {5,0.00225743}, {6,0.00258416}, {7,0.00350495}, {8,0.00343564}, {9,0.00395050}, {10,0.00415842}, {11,0.00422772}, {12,0.00498020}, {13,0.00548515}, {14,0.00629703}, {15,0.00820792}, {16,0.00720792}, {17,0.00778218}, {18,0.00845545}, {19,0.00859406}, {20,0.00963366}, {21,0.01003960}, {22,0.01052475}, {23,0.01435644}, {24,0.01156436}, {25,0.01205941}, {26,0.01257426}, {27,0.01298020}, {28,0.01397030}, {29,0.01474257}, {30,0.01507921}, {31,0.01589109}, {32,0.01671287}, {33,0.01689109}, {34,0.01767327}, {35,0.01836634}, {36,0.01917822}, {37,0.01963366}, {38,0.02066337}, {39,0.02169307}, {40,0.02275248}, {41,0.02318812}, {42,0.02943564}, {43,0.02506931}, {44,0.02563366}, {45,0.02583168}, {46,0.02685149}, {47,0.02798020}, {48,0.03628713}, {49,0.02953465}, {50,0.03392079}, {51,0.03116832}, {52,0.03895050}, {53,0.03327723}, {54,0.03384158}, {55,0.04553465}, {56,0.03580198}, {57,0.03636634}, {58,0.03734653}, {59,0.03895050}, {60,0.04772277}, {61,0.05058416}, {62,0.05178218}, {63,0.05198020}, {64,0.04899010}, {65,0.04392079}, {66,0.04580198}, {67,0.04661386}, {68,0.06040594}, {69,0.04877228}, {70,0.05027723}, {71,0.06692079}, {72,0.05214851}, {73,0.06951485}, {74,0.05474257}, {75,0.06686139}, {76,0.05629703}, {77,0.05742574}, {78,0.06715842}, {79,0.09181188}, {80,0.06787129}, {81,0.06247525}, {82,0.06332673}, {83,0.06456436}, {84,0.06588119}, {85,0.07753465}, {86,0.09783168}, {87,0.08969307}, {88,0.08612871}, {89,0.09108911}, {90,0.11144554}, {91,0.09749505}, {92,0.08899010}, {93,0.08949505}, {94,0.09128713}, {95,0.09237624}, {96,0.09284158}, {97,0.09335644}, {98,0.09400990}, {99,0.09497030}, {100,0.09590099}, {101,0.09658416}, {102,0.09688119}, {103,0.09804950}, {104,0.09820792}, {105,0.09891089}, {106,0.09971287}, {107,0.10043564}, {108,0.10110891}, {109,0.10216832}, {110,0.10289109}, {111,0.10495050}, {112,0.10624752}, {113,0.10791089}, {114,0.10912871}, {115,0.11090099}, {116,0.11271287}, {117,0.11435644}, {118,0.11643564}, {119,0.11845545}, {120,0.12061386}, {121,0.12186139}, {122,0.12336634}, {123,0.12607921}, {124,0.14082178}, {125,0.14342574}, {126,0.14504950}, {127,0.15996040}, {128,0.16507921}, {129,0.16478218}, {130,0.16707921}, {131,0.17027723}, {132,0.17368317}, {133,0.17294059}, {134,0.17849505}, {135,0.17856436}, {136,0.18140594}, {137,0.18520792}, {138,0.18524752}, {139,0.18987129}, {140,0.19197030}, {141,0.19371287}, {142,0.19595050}, {143,0.19717822}, {144,0.20153465}, {145,0.20419802}, {146,0.20788119}, {147,0.21012871}, {148,0.21109901}, {149,0.21345545}, {150,0.21586139}, {151,0.21738614}, {152,0.21890099}, {153,0.21886139}, {154,0.22096040}, {155,0.22927723}, {156,0.23254455}, {157,0.23693069}, {158,0.23726733}, {159,0.24149505}, {160,0.24400000}, {161,0.24545545}, {162,0.24791089}, {163,0.25258416}, {164,0.25584158}, {165,0.25958416}, {166,0.26148515}, {167,0.26584158}, {168,0.26679208}, {169,0.26462376}, {170,0.27157426}, {171,0.27845545}, {172,0.27772277}, {173,0.28202970}, {174,0.28499010}, {175,0.28743564}, {176,0.29161386}, {177,0.29370297}, {178,0.29609901}, {179,0.29831683}, {180,0.30264356}, {181,0.30730693}, {182,0.31127723}, {183,0.31416832}, {184,0.31749505}, {185,0.32072277}, {186,0.32378218}, {187,0.32585149}, {188,0.32761386}, {189,0.33038614}, {190,0.33489109}, {191,0.33946535}, {192,0.34022772}, {193,0.34051485}, {194,0.34457426}, {195,0.35081188}, {196,0.35797030}, {197,0.36871287}, {198,0.36595050}, {199,0.36475248}, {200,0.36979208}, {201,0.37538614}, {202,0.37569307}, {203,0.38495050}, {204,0.39725743}, {205,0.38189109}, {206,0.39112871}, {207,0.39144554}, {208,0.40221782}, {209,0.41625743}, {210,0.40705941}, {211,0.40754455}, {212,0.41010891}, {213,0.43398020}, {214,0.42066337}, {215,0.41960396}, {216,0.43191089}, {217,0.44095050}, {218,0.43781188}, {219,0.44324752}, {220,0.45632673}, {221,0.45086139}, {222,0.45662376}, {223,0.46421782}, {224,0.46290099}, {225,0.47510891}, {226,0.47048515}, {227,0.47486139}, {228,0.48651485}, {229,0.48341584}, {230,0.49703960}, {231,0.49114851}, {232,0.50637624}, {233,0.49693069}, {234,0.51440594}, {235,0.50638614}, {236,0.52218812}, {237,0.51390099}, {238,0.52642574}, {239,0.52575248}, {240,0.53224752}, {241,0.53979208}, {242,0.53928713}, {243,0.54996040}, {244,0.55266337}, {245,0.55435644}, {246,0.56146535}, {247,0.56587129}, {248,0.56787129}, {249,0.57973267}, {250,0.57384158}, {251,0.58154455}, {252,0.59570297}, {253,0.59105941}, {254,0.59513861}, {255,0.60700990}, {256,0.60626733}, {257,0.60831683}, {258,0.61936634}, {259,0.62501980}, {260,0.63205941}, {261,0.62968317}, {262,0.63292079}, {263,0.64154455}, {264,0.64271287}, {265,0.65204950}, {266,0.65780198}, {267,0.66127723}, {268,0.66357426}, {269,0.66801980}, {270,0.67639604}, {271,0.68036634}, {272,0.68602970}, {273,0.69176238}, {274,0.69619802}, {275,0.70347525}, {276,0.71087129}, {277,0.71613861}, {278,0.71738614}, {279,0.72311881}, {280,0.72932673}, {281,0.73292079}, {282,0.73837624}, {283,0.74338614}, {284,0.74673267}, {285,0.75682178}, {286,0.75674257}, {287,0.75800990}, {288,0.76592079}, {289,0.77338614}, {290,0.78776238}, {291,0.79403960}, {292,0.80206931}, {293,0.81124752}, {294,0.81345545}, {295,0.81988119}, {296,0.83456436}, {297,0.82761386}, {298,0.83115842}, {299,0.84168317}, {300,0.84331683}, {301,0.8640857}, {302,0.9848857}, {303,0.9339714}, {304,0.9317143}, {305,0.8994000}, {306,0.9013714}, {307,0.9027714}, {308,0.9132571}, {309,0.9216571}, {310,0.9187714}, {311,0.9309714}, {312,0.9378857}, {313,0.9428286}, {314,0.9454000}, {315,0.9565714}, {316,0.9603143}, {317,0.9628286}, {318,0.9698571}, {319,0.9811143}, {320,0.9816857}, {321,0.9874286}, {322,0.9990857}, {323,1.0034000}, {324,1.0117143}, {325,1.0209143}, {326,1.0207143}, {327,1.0364571}, {328,1.0364857}, {329,1.0362857}, {330,1.0532571}, {331,1.0514286}, {332,1.0681714}, {333,1.0548286}, {334,1.0726571}, {335,1.0700000}, {336,1.0825429}, {337,1.0895143}, {338,1.0923143}, {339,1.1035429}, {340,1.1038571}, {341,1.1217143}, {342,1.1288857}, {343,1.1373143}, {344,1.1500286}, {345,1.1525429}, {346,1.1529143}, {347,1.1640857}, {348,1.1734571}, {349,1.1787429}, {350,1.1847143}, {351,1.2021143}, {352,1.2066857}, {353,1.2053429}, {354,1.2194286}, {355,1.2170571}, {356,1.2271714}, {357,1.2363714}, {358,1.2482857}, {359,1.2466571}, {360,1.2662000}, {361,1.2672286}, {362,1.2706857}, {363,1.2915143}, {364,1.2886000}, {365,1.2983714}, {366,1.3016857}, {367,1.3194286}, {368,1.3147714}, {369,1.3265143}, {370,1.3442000}, {371,1.3466857}, {372,1.3559143}, {373,1.3606857}, {374,1.3718286}, {375,1.3854857}, {376,1.3876286}, {377,1.3948857}, {378,1.4033429}, {379,1.4092857}, {380,1.4174000}, {381,1.4274286}, {382,1.4395714}, {383,1.4487143}, {384,1.4592571}, {385,1.4714571}, {386,1.4759429}, {387,1.4940000}, {388,1.4923714}, {389,1.5038857}, {390,1.5146857}, {391,1.5185143}, {392,1.5218286}, {393,1.5356000}, {394,1.5490857}, {395,1.5558286}, {396,1.5645714}, {397,1.5704857}, {398,1.5734286}, {399,1.5870571}, {400,1.5954286}, {401,1.6068857}, {402,1.6165143}, {403,1.6258286}, {404,1.6284286}, {405,1.6443714}, {406,1.6486571}, {407,1.6584286}, {408,1.6669714}, {409,1.6778857}, {410,1.6831714}, {411,1.6930286}, {412,1.6954857}, {413,1.7092857}, {414,1.7156571}, {415,1.7295143}, {416,1.7318571}, {417,1.7446000}, {418,1.7468286}, {419,1.8052571}, {420,1.8004571}, {421,1.7858000}, {422,1.7947429}, {423,1.8024000}, {424,1.8087714}, {425,1.8257143}, {426,1.8287714}, {427,1.8560857}, {428,1.8572286}, {429,1.8711143}, {430,1.8753429}, {431,1.8943714}, {432,1.8966857}, {433,1.9079143}, {434,1.9139714}, {435,1.9260571}, {436,1.9294857}, {437,1.9449714}, {438,1.9564571}, {439,1.9722571}, {440,1.9874286}, {441,1.9906857}, {442,2.0006000}, {443,2.0068000}, {444,2.0162571}, {445,2.0344571}, {446,2.0354857}, {447,2.0484857}, {448,2.0516286}, {449,2.0734571}, {450,2.0804857}, {451,2.0906286}, {452,2.0949714}, {453,2.1068571}, {454,2.1202000}, {455,2.1352857}, {456,2.1497143}, {457,2.1564571}, {458,2.1698571}, {459,2.1780571}, {460,2.1940286}, {461,2.1952286}, {462,2.1998000}, {463,2.2218000}, {464,2.2331429}, {465,2.2425143}, {466,2.2492571}, {467,2.2905143}, {468,2.3061143}, {469,2.2882000}, {470,2.3007714}, {471,2.3258000}, {472,2.3115143}, {473,2.3261429}, {474,2.3330571}, {475,2.3324000}, {476,2.3426571}, {477,2.3665429}, {478,2.4014000}, {479,2.3762571}, {480,2.4502000}, {481,2.5066857}, {482,2.4246000}, {483,2.5315143}, {484,2.4604286}, {485,2.5378286}, {486,2.4967429}, {487,2.5722857}, {488,2.5899143}, {489,2.5617714}, {490,2.5221429}, {491,2.5309143}, {492,2.5699429}, {493,2.6017429}, {494,2.6233429}, {495,2.6346571}, {496,2.6805714}, {497,2.7351429}, {498,2.6534857}, {499,2.6827714}, {500,2.6649429}, {505,2.7670000}, {510,2.7874286}, {515,2.9336286}, {520,3.0224571}, {525,3.1631143}, {530,3.1408000}, {535,3.1852000}, {540,3.2134571}, {545,3.2721714}, {550,3.3254000}, {555,3.3798286}, {560,3.4232857}, {565,3.5677429}, {570,3.6209714}, {575,3.6664571}, {580,3.7364000}, {585,3.8602000}, {590,3.8972286}, {595,3.9933714}, {600,4.0594571}, {605,4.2645143}, {610,4.2486000}, {615,4.3048571}, {620,4.4030571}, {625,4.4783714}, {630,4.6294857}, {635,4.6689429}, {640,4.7734000}, {645,4.7692286}, {650,4.8787714}, {655,5.0892857}, {660,5.1591143}, {665,5.1423714}, {670,5.1420000}, {675,5.2496571}, {680,5.3624000}, {685,5.4944286}, {690,5.6479143}, {695,5.6496000}, {700,5.8114571}, {705,5.8096000}, {710,5.9847143}, {715,6.0858000}, {720,6.1384286}, {725,6.2202000}, {730,6.3333143}, {735,6.5982857}, {740,6.6185143}, {745,6.6998857}, {750,6.8449143}, {755,6.9707143}, {760,7.0669143}, {765,7.2057714}, {770,7.3154286}, {775,7.4344857}, {780,7.5174000}, {785,7.6522000}, {790,7.7672857}, {795,7.8881143}, {800,8.1020000}, {805,8.1094857}, {810,8.2796857}, {815,8.3733429}, {820,8.5387429}, {825,8.6472286}, {830,8.7782857}, {835,8.8755429}, {840,9.0256000}, {845,9.1924571}, {850,9.3889143}, {855,9.5048857}, {860,9.6285143}, {865,9.7895143}, {870,9.9443714}, {875,10.2028000}, {880,10.2757714}, {885,10.7255143}, {890,10.5260286}, {895,10.7304571}, {900,11.1330571}, {905,11.0884286}, {910,11.2898571}, {915,11.3872286}, {920,11.8782571}, {925,11.9440000}, {930,12.0396000}, {935,12.0342857}, {940,12.5313143}, {945,12.2973143}, {950,12.5428571}, {955,12.8265429}, {960,13.3473429}, {965,13.3803429}, {970,13.2664000}, {975,13.5457429}, {980,13.8591143}, {985,14.2990286}, {990,14.2370000}, {995,14.6441429}, {1000,14.6140857}, {1010,15.2275714}, {1020,15.4916857}, {1030,16.0366000}, {1040,16.2643143}, {1050,16.7628571}, {1060,17.3878857}, {1070,17.8443143}, {1080,18.4695429}, {1090,18.2326857}, {1100,19.0048000}, {1110,19.3468286}, {1120,19.9082857}, {1130,20.3301714}, {1140,20.8108000}, {1150,21.3286000}, {1160,21.8308857}, {1170,22.2790571}, {1180,23.0814857}, {1190,23.4462286}, {1200,24.0250571}, {1210,24.7035143}, {1220,25.1034000}, {1230,25.3869429}, {1240,26.1265429}, {1250,27.0037143}, {1260,27.5460571}, {1270,28.1059429}, {1280,28.5291429}, {1290,28.9496286}, {1300,29.6501429}, {1310,30.3601143}, {1320,31.0061714}, {1330,31.9433143}, {1340,32.5145714}, {1350,33.0473143}, {1360,33.5489429}, {1370,34.2108857}, {1380,34.9888286}, {1390,35.6595143}, {1400,36.4083143}, {1410,37.0104000}, {1420,38.0490286}, {1430,38.8225143}, {1440,39.4299429}, {1450,39.9762286}, {1460,40.7721143}, {1470,41.9988286}, {1480,42.4150571}, {1490,43.2634571}, {1500,43.6968857}, {1510,44.9652000}, {1520,45.5693143}, {1530,46.9893143}, {1540,47.9561714}, {1550,48.7592286}, {1560,49.4288857}, {1570,50.1598286}, {1580,51.5163429}, {1590,52.4303143}, {1600,53.0226000}, {1610,54.1775429}, {1620,55.2138000}, {1630,55.4964571}, {1640,56.1013429}, {1650,57.6486857}, {1660,58.6635143}, {1670,59.6208571}, {1680,60.3808857}, {1690,62.2480286}, {1700,63.5269429}, {1710,64.4356571}, {1720,65.4871714}, {1730,66.3087714}, {1740,67.4832857}, {1750,68.1279429}, {1760,68.9965143}, {1770,70.4646571}, {1780,71.5546571}, {1790,72.8274286}, {1800,73.9366857}, {1810,75.3602857}, {1820,76.5554000}, {1830,77.0435714}, {1840,78.6234571}, {1850,80.5400571}, {1860,81.7817714}, {1870,83.1155143}, {1880,84.2344286}, {1890,86.2937714}, {1900,86.3386000}, {1910,88.3774286}, {1920,89.3632286}, {1930,90.8312286}, {1940,91.4749714}, {1950,92.7878857}, {1960,94.9956286}, {1970,94.9210000}, {1980,96.7964857}, {1990,98.1239143}, {2000,99.7391714}};
data["big"]["LtacTacInTermPrimPair"]["reif"]["system"] = {{1,0.00000000}, {2,0.00003960}, {3,0.00000000}, {4,0.00003960}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00003960}, {9,0.00000000}, {10,0.00000000}, {11,0.00003960}, {12,0.00002970}, {13,0.00000000}, {14,0.00000000}, {15,0.00003960}, {16,0.00000000}, {17,0.00003960}, {18,0.00003960}, {19,0.00010891}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00003960}, {25,0.00000000}, {26,0.00003960}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00003960}, {32,0.00003960}, {33,0.00007921}, {34,0.00011881}, {35,0.00003960}, {36,0.00000000}, {37,0.00007921}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003960}, {42,0.00000000}, {43,0.00002970}, {44,0.00003960}, {45,0.00015842}, {46,0.00003960}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00000000}, {51,0.00015842}, {52,0.00003960}, {53,0.00010891}, {54,0.00003960}, {55,0.00003960}, {56,0.00000000}, {57,0.00007921}, {58,0.00000000}, {59,0.00003960}, {60,0.00000000}, {61,0.00003960}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00003960}, {66,0.00000000}, {67,0.00003960}, {68,0.00003960}, {69,0.00003960}, {70,0.00003960}, {71,0.00003960}, {72,0.00000000}, {73,0.00003960}, {74,0.00000000}, {75,0.00003960}, {76,0.00007921}, {77,0.00011881}, {78,0.00000000}, {79,0.00011881}, {80,0.00011881}, {81,0.00003960}, {82,0.00007921}, {83,0.00003960}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00003960}, {89,0.00003960}, {90,0.00011881}, {91,0.00019802}, {92,0.00010891}, {93,0.00015842}, {94,0.00003960}, {95,0.00007921}, {96,0.00007921}, {97,0.00000000}, {98,0.00003960}, {99,0.00011881}, {100,0.00003960}, {101,0.00000000}, {102,0.00011881}, {103,0.00000000}, {104,0.00003960}, {105,0.00007921}, {106,0.00000000}, {107,0.00003960}, {108,0.00000000}, {109,0.00000000}, {110,0.00002970}, {111,0.00007921}, {112,0.00000000}, {113,0.00003960}, {114,0.00003960}, {115,0.00003960}, {116,0.00003960}, {117,0.00000000}, {118,0.00000000}, {119,0.00007921}, {120,0.00015842}, {121,0.00000000}, {122,0.00007921}, {123,0.00011881}, {124,0.00000000}, {125,0.00000000}, {126,0.00003960}, {127,0.00000000}, {128,0.00007921}, {129,0.00007921}, {130,0.00003960}, {131,0.00000000}, {132,0.00000000}, {133,0.00007921}, {134,0.00007921}, {135,0.00007921}, {136,0.00003960}, {137,0.00011881}, {138,0.00007921}, {139,0.00003960}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00007921}, {145,0.00011881}, {146,0.00003960}, {147,0.00007921}, {148,0.00011881}, {149,0.00000000}, {150,0.00003960}, {151,0.00003960}, {152,0.00000000}, {153,0.00003960}, {154,0.00007921}, {155,0.00007921}, {156,0.00010891}, {157,0.00003960}, {158,0.00000000}, {159,0.00003960}, {160,0.00007921}, {161,0.00003960}, {162,0.00003960}, {163,0.00003960}, {164,0.00003960}, {165,0.00003960}, {166,0.00000000}, {167,0.00011881}, {168,0.00007921}, {169,0.00007921}, {170,0.00003960}, {171,0.00003960}, {172,0.00003960}, {173,0.00007921}, {174,0.00003960}, {175,0.00003960}, {176,0.00002970}, {177,0.00007921}, {178,0.00003960}, {179,0.00015842}, {180,0.00007921}, {181,0.00000000}, {182,0.00007921}, {183,0.00000000}, {184,0.00023762}, {185,0.00003960}, {186,0.00007921}, {187,0.00003960}, {188,0.00000000}, {189,0.00000000}, {190,0.00003960}, {191,0.00006931}, {192,0.00003960}, {193,0.00011881}, {194,0.00003960}, {195,0.00007921}, {196,0.00000000}, {197,0.00011881}, {198,0.00006931}, {199,0.00003960}, {200,0.00000000}, {201,0.00011881}, {202,0.00007921}, {203,0.00007921}, {204,0.00007921}, {205,0.00003960}, {206,0.00003960}, {207,0.00000000}, {208,0.00007921}, {209,0.00007921}, {210,0.00003960}, {211,0.00007921}, {212,0.00000000}, {213,0.00000000}, {214,0.00003960}, {215,0.00003960}, {216,0.00007921}, {217,0.00000000}, {218,0.00000000}, {219,0.00003960}, {220,0.00000000}, {221,0.00011881}, {222,0.00006931}, {223,0.00011881}, {224,0.00000000}, {225,0.00007921}, {226,0.00015842}, {227,0.00003960}, {228,0.00003960}, {229,0.00007921}, {230,0.00000000}, {231,0.00015842}, {232,0.00003960}, {233,0.00006931}, {234,0.00003960}, {235,0.00007921}, {236,0.00003960}, {237,0.00003960}, {238,0.00011881}, {239,0.00011881}, {240,0.00003960}, {241,0.00003960}, {242,0.00007921}, {243,0.00010891}, {244,0.00011881}, {245,0.00015842}, {246,0.00007921}, {247,0.00003960}, {248,0.00019802}, {249,0.00003960}, {250,0.00011881}, {251,0.00003960}, {252,0.00019802}, {253,0.00003960}, {254,0.00015842}, {255,0.00027723}, {256,0.00006931}, {257,0.00035644}, {258,0.00000000}, {259,0.00003960}, {260,0.00007921}, {261,0.00007921}, {262,0.00052475}, {263,0.00011881}, {264,0.00007921}, {265,0.00000000}, {266,0.00035644}, {267,0.00003960}, {268,0.00007921}, {269,0.00003960}, {270,0.00007921}, {271,0.00003960}, {272,0.00015842}, {273,0.00011881}, {274,0.00007921}, {275,0.00030693}, {276,0.00011881}, {277,0.00003960}, {278,0.00011881}, {279,0.00011881}, {280,0.00031683}, {281,0.00014851}, {282,0.00003960}, {283,0.00007921}, {284,0.00079208}, {285,0.00007921}, {286,0.00011881}, {287,0.00003960}, {288,0.00015842}, {289,0.00022772}, {290,0.00010891}, {291,0.00003960}, {292,0.00000000}, {293,0.00007921}, {294,0.00011881}, {295,0.00015842}, {296,0.00007921}, {297,0.00007921}, {298,0.00015842}, {299,0.00043564}, {300,0.00014851}, {301,0.0001143}, {302,0.0003429}, {303,0.0002286}, {304,0.0004286}, {305,0.0002286}, {306,0.0001143}, {307,0.0002286}, {308,0.0001143}, {309,0.0000000}, {310,0.0000000}, {311,0.0000000}, {312,0.0004571}, {313,0.0001143}, {314,0.0000000}, {315,0.0002286}, {316,0.0001143}, {317,0.0000000}, {318,0.0002286}, {319,0.0001143}, {320,0.0000000}, {321,0.0000000}, {322,0.0002286}, {323,0.0001143}, {324,0.0003429}, {325,0.0000000}, {326,0.0002286}, {327,0.0000000}, {328,0.0002286}, {329,0.0005429}, {330,0.0003429}, {331,0.0000000}, {332,0.0000000}, {333,0.0001143}, {334,0.0005714}, {335,0.0004571}, {336,0.0003429}, {337,0.0005714}, {338,0.0001143}, {339,0.0000000}, {340,0.0000000}, {341,0.0002286}, {342,0.0002286}, {343,0.0000000}, {344,0.0002286}, {345,0.0000000}, {346,0.0001143}, {347,0.0001143}, {348,0.0001143}, {349,0.0002286}, {350,0.0000000}, {351,0.0001143}, {352,0.0000000}, {353,0.0002286}, {354,0.0001143}, {355,0.0000000}, {356,0.0001143}, {357,0.0000857}, {358,0.0001143}, {359,0.0000000}, {360,0.0000000}, {361,0.0001143}, {362,0.0001143}, {363,0.0005714}, {364,0.0001143}, {365,0.0001143}, {366,0.0000000}, {367,0.0000000}, {368,0.0005714}, {369,0.0003429}, {370,0.0000000}, {371,0.0000000}, {372,0.0001143}, {373,0.0000000}, {374,0.0000000}, {375,0.0002286}, {376,0.0002286}, {377,0.0000000}, {378,0.0001143}, {379,0.0000000}, {380,0.0000000}, {381,0.0000000}, {382,0.0001143}, {383,0.0008000}, {384,0.0001143}, {385,0.0002286}, {386,0.0002286}, {387,0.0005714}, {388,0.0002286}, {389,0.0001143}, {390,0.0002286}, {391,0.0001143}, {392,0.0001143}, {393,0.0005714}, {394,0.0003429}, {395,0.0001143}, {396,0.0002286}, {397,0.0001143}, {398,0.0001143}, {399,0.0001143}, {400,0.0002286}, {401,0.0001143}, {402,0.0003429}, {403,0.0000000}, {404,0.0004571}, {405,0.0001143}, {406,0.0001143}, {407,0.0001143}, {408,0.0003429}, {409,0.0002286}, {410,0.0002000}, {411,0.0005714}, {412,0.0003429}, {413,0.0001143}, {414,0.0003143}, {415,0.0009143}, {416,0.0005714}, {417,0.0001143}, {418,0.0002286}, {419,0.0009143}, {420,0.0000000}, {421,0.0000000}, {422,0.0002286}, {423,0.0003429}, {424,0.0002286}, {425,0.0008000}, {426,0.0008000}, {427,0.0002286}, {428,0.0003429}, {429,0.0005714}, {430,0.0001143}, {431,0.0004571}, {432,0.0001143}, {433,0.0001143}, {434,0.0002286}, {435,0.0001143}, {436,0.0004571}, {437,0.0002286}, {438,0.0000000}, {439,0.0006857}, {440,0.0002286}, {441,0.0006857}, {442,0.0001143}, {443,0.0003429}, {444,0.0002286}, {445,0.0003429}, {446,0.0001143}, {447,0.0002286}, {448,0.0008000}, {449,0.0000000}, {450,0.0002286}, {451,0.0000000}, {452,0.0001143}, {453,0.0003429}, {454,0.0001143}, {455,0.0001143}, {456,0.0005714}, {457,0.0002286}, {458,0.0003429}, {459,0.0002286}, {460,0.0003429}, {461,0.0006571}, {462,0.0003143}, {463,0.0006857}, {464,0.0004571}, {465,0.0009143}, {466,0.0010286}, {467,0.0003429}, {468,0.0018000}, {469,0.0010286}, {470,0.0008000}, {471,0.0011429}, {472,0.0017143}, {473,0.0014571}, {474,0.0015714}, {475,0.0009143}, {476,0.0013714}, {477,0.0003429}, {478,0.0004571}, {479,0.0005714}, {480,0.0002286}, {481,0.0009143}, {482,0.0002286}, {483,0.0012571}, {484,0.0005714}, {485,0.0010286}, {486,0.0008000}, {487,0.0009143}, {488,0.0012571}, {489,0.0005714}, {490,0.0005714}, {491,0.0006857}, {492,0.0002286}, {493,0.0003429}, {494,0.0008000}, {495,0.0011429}, {496,0.0008000}, {497,0.0008000}, {498,0.0006857}, {499,0.0012286}, {500,0.0003429}, {505,0.0009143}, {510,0.0004571}, {515,0.0013714}, {520,0.0011429}, {525,0.0016000}, {530,0.0016857}, {535,0.0011429}, {540,0.0024857}, {545,0.0013714}, {550,0.0017143}, {555,0.0003429}, {560,0.0018286}, {565,0.0009143}, {570,0.0010286}, {575,0.0016000}, {580,0.0013714}, {585,0.0019143}, {590,0.0013714}, {595,0.0008857}, {600,0.0008000}, {605,0.0015714}, {610,0.0019429}, {615,0.0014571}, {620,0.0018286}, {625,0.0018286}, {630,0.0019429}, {635,0.0011143}, {640,0.0006857}, {645,0.0006857}, {650,0.0001143}, {655,0.0014857}, {660,0.0008000}, {665,0.0012571}, {670,0.0014857}, {675,0.0013714}, {680,0.0013714}, {685,0.0010286}, {690,0.0026286}, {695,0.0014857}, {700,0.0022571}, {705,0.0018286}, {710,0.0009143}, {715,0.0022857}, {720,0.0004571}, {725,0.0008000}, {730,0.0010286}, {735,0.0014571}, {740,0.0004286}, {745,0.0008000}, {750,0.0020571}, {755,0.0004571}, {760,0.0008000}, {765,0.0017143}, {770,0.0025143}, {775,0.0016000}, {780,0.0006286}, {785,0.0022857}, {790,0.0038857}, {795,0.0019429}, {800,0.0027429}, {805,0.0018286}, {810,0.0029714}, {815,0.0048857}, {820,0.0020000}, {825,0.0045714}, {830,0.0020571}, {835,0.0004571}, {840,0.0034286}, {845,0.0034286}, {850,0.0037143}, {855,0.0037143}, {860,0.0033143}, {865,0.0046857}, {870,0.0045714}, {875,0.0052571}, {880,0.0024000}, {885,0.0045714}, {890,0.0062571}, {895,0.0021714}, {900,0.0028000}, {905,0.0040857}, {910,0.0019429}, {915,0.0027143}, {920,0.0043429}, {925,0.0045714}, {930,0.0029714}, {935,0.0046857}, {940,0.0058857}, {945,0.0044286}, {950,0.0026000}, {955,0.0049714}, {960,0.0048857}, {965,0.0045714}, {970,0.0055714}, {975,0.0046571}, {980,0.0066000}, {985,0.0060857}, {990,0.0058286}, {995,0.0072857}, {1000,0.0073143}, {1010,0.0061714}, {1020,0.0056857}, {1030,0.0058571}, {1040,0.0058857}, {1050,0.0074000}, {1060,0.0042857}, {1070,0.0042571}, {1080,0.0056571}, {1090,0.0047429}, {1100,0.0062571}, {1110,0.0036571}, {1120,0.0059714}, {1130,0.0060857}, {1140,0.0066000}, {1150,0.0063143}, {1160,0.0053429}, {1170,0.0081143}, {1180,0.0076000}, {1190,0.0056857}, {1200,0.0077714}, {1210,0.0051429}, {1220,0.0064857}, {1230,0.0044571}, {1240,0.0066857}, {1250,0.0099429}, {1260,0.0116000}, {1270,0.0114857}, {1280,0.0139714}, {1290,0.0122286}, {1300,0.0102857}, {1310,0.0083429}, {1320,0.0124857}, {1330,0.0109143}, {1340,0.0128000}, {1350,0.0141143}, {1360,0.0128571}, {1370,0.0135714}, {1380,0.0096286}, {1390,0.0146857}, {1400,0.0136571}, {1410,0.0132857}, {1420,0.0139143}, {1430,0.0106857}, {1440,0.0141429}, {1450,0.0209429}, {1460,0.0118571}, {1470,0.0117714}, {1480,0.0146571}, {1490,0.0176857}, {1500,0.0145429}, {1510,0.0138571}, {1520,0.0152571}, {1530,0.0169714}, {1540,0.0140857}, {1550,0.0206571}, {1560,0.0159429}, {1570,0.0201429}, {1580,0.0155714}, {1590,0.0195143}, {1600,0.0164286}, {1610,0.0130000}, {1620,0.0139429}, {1630,0.0155143}, {1640,0.0204000}, {1650,0.0216286}, {1660,0.0140571}, {1670,0.0192286}, {1680,0.0198857}, {1690,0.0149143}, {1700,0.0140000}, {1710,0.0202286}, {1720,0.0181143}, {1730,0.0231429}, {1740,0.0166571}, {1750,0.0253143}, {1760,0.0210857}, {1770,0.0235714}, {1780,0.0307429}, {1790,0.0260000}, {1800,0.0194857}, {1810,0.0142000}, {1820,0.0277429}, {1830,0.0260571}, {1840,0.0261714}, {1850,0.0240000}, {1860,0.0194000}, {1870,0.0238000}, {1880,0.0257429}, {1890,0.0231143}, {1900,0.0322000}, {1910,0.0260571}, {1920,0.0307143}, {1930,0.0212000}, {1940,0.0278000}, {1950,0.0252286}, {1960,0.0250857}, {1970,0.0223429}, {1980,0.0274000}, {1990,0.0271143}, {2000,0.0244857}};
data["big"]["Mtac2"]["Aggregate"]["real"] = {{1,0.001070423}, {2,0.001093897}, {3,0.002037559}, {4,0.002953052}, {5,0.003140845}, {6,0.004061033}, {7,0.005075117}, {8,0.006075117}, {9,0.007150235}, {10,0.008967136}, {11,0.010103286}, {12,0.012065728}, {13,0.013042254}, {14,0.014943662}, {15,0.026807512}, {16,0.018009390}, {17,0.019957746}, {18,0.021981221}, {19,0.025704225}, {20,0.027187793}, {21,0.038413146}, {22,0.031746479}, {23,0.034403756}, {24,0.037291080}, {25,0.040197183}, {26,0.043164319}, {27,0.068816901}, {28,0.049558685}, {29,0.053624413}, {30,0.080849765}, {31,0.059544601}, {32,0.092502347}, {33,0.067483568}, {34,0.078798122}, {35,0.136821596}, {36,0.083295775}, {37,0.111835681}, {38,0.103906103}, {39,0.093511737}, {40,0.120061033}, {41,0.133802817}, {42,0.492356808}, {43,0.190807512}, {44,0.139798122}, {45,0.166276995}, {46,0.152553991}, {47,0.229037559}, {48,0.186230047}, {49,0.510727700}, {50,0.239924883}, {51,0.202356808}, {52,0.184112676}, {53,0.310347418}, {54,0.537901408}, {55,0.321629108}, {56,0.212192488}, {57,0.289028169}, {58,0.621981221}, {59,0.351136150}, {60,0.310464789}, {61,0.371474178}, {62,0.307009390}, {63,0.339605634}, {64,0.677300469}, {65,0.400225352}, {66,0.389812207}, {67,0.698558685}, {68,0.424319249}, {69,0.418361502}, {70,0.819347418}, {71,0.384572770}, {72,0.473798122}, {73,0.832784038}, {74,0.838417840}, {75,0.512718310}, {76,0.512018779}, {77,0.869474178}, {78,0.548483568}, {79,0.542539906}, {80,0.575629108}, {81,0.915732394}, {82,0.958309859}, {83,0.600755869}, {84,0.982441315}, {85,0.723793427}, {86,1.013915493}, {87,0.657051643}, {88,1.076553991}, {89,0.671375587}, {90,1.153201878}, {91,1.147647887}, {92,0.718037559}, {93,1.197840376}, {94,1.234291080}, {95,1.249126761}, {96,0.995692}, {97,1.161923}, {98,1.195385}, {99,1.416923}, {100,1.311923}, {101,1.019769}, {102,1.464615}, {103,1.375769}, {104,1.462308}, {105,1.562846}, {106,1.197154}, {107,1.483154}, {108,1.559692}, {109,2.041077}, {110,1.245154}, {111,1.965923}, {112,1.418077}, {113,1.150692}, {114,1.801154}, {115,1.236462}, {116,2.123538}, {117,1.852769}, {118,1.699231}, {119,1.883077}, {120,1.714846}, {121,1.980538}, {122,1.829077}, {123,1.862538}, {124,1.642077}, {125,2.446077}, {126,1.982692}, {127,1.872923}, {128,2.261538}, {129,2.511385}, {130,1.672462}, {131,2.411077}, {132,2.369308}, {133,2.203923}, {134,2.213462}, {135,2.243692}, {136,2.819923}, {137,1.966308}, {138,2.795000}, {139,2.982077}, {140,2.821923}, {141,2.935846}, {142,2.006692}, {143,3.501154}, {144,2.715769}, {145,2.444000}, {146,2.679538}, {147,3.294692}, {148,3.141000}, {149,3.284769}, {150,2.293154}, {151,3.341000}, {152,3.914923}, {153,2.844692}, {154,3.324846}, {155,3.152846}, {156,3.379769}, {157,4.149077}, {158,3.514308}, {159,3.732077}, {160,3.190231}, {161,3.689846}, {162,3.614538}, {163,4.480615}, {164,3.870846}, {165,4.371615}, {166,4.387692}, {167,4.363077}, {168,3.551615}, {169,5.234538}, {170,4.050846}, {171,4.526231}, {172,4.092692}, {173,4.548462}, {174,5.459615}, {175,4.300231}, {176,4.695615}, {177,4.976154}, {178,4.817000}, {179,4.941385}, {180,5.025308}, {181,5.697538}, {182,3.933000}, {183,5.078846}, {184,5.806154}, {185,5.750846}, {186,5.998692}, {187,5.446154}, {188,4.946000}, {189,6.168231}, {190,5.517615}, {191,4.621154}, {192,5.990077}, {193,6.230231}, {194,6.361692}, {195,6.343154}, {196,5.891385}, {197,6.005462}, {198,6.072538}, {199,6.143615}, {200,6.308846}, {201,6.206000}, {202,6.802769}, {203,6.843077}, {204,6.892538}, {205,6.905923}, {206,7.704615}, {207,6.418923}, {208,7.732462}, {209,6.651154}, {210,7.774385}, {211,7.985385}, {212,6.239769}, {213,7.840000}, {214,7.972308}, {215,7.493231}, {216,8.191462}, {217,8.007462}, {218,7.753385}, {219,7.260385}, {220,8.285538}, {221,7.247231}, {222,8.211462}, {223,8.657462}, {224,8.121154}, {225,8.208769}, {226,8.877923}, {227,9.096923}, {228,8.950385}, {229,9.629000}, {230,9.169538}, {231,9.911538}, {232,9.779000}, {233,8.377154}, {234,9.842692}, {235,10.064000}, {236,10.189692}, {237,10.731769}, {238,10.797462}, {239,10.107692}, {240,9.999462}, {241,11.293538}, {242,11.162000}, {243,11.239077}, {244,10.833077}, {245,9.972692}, {246,11.530385}, {247,11.329615}, {248,12.253538}, {249,10.918154}, {250,12.064385}, {251,11.413231}, {252,12.240308}, {253,12.976385}, {254,12.239077}, {255,13.051154}, {256,12.190077}, {257,11.301538}, {258,14.076000}, {259,10.860615}, {260,13.817769}, {261,13.117615}, {262,14.377923}, {263,12.661769}, {264,14.645077}, {265,13.593923}, {266,11.932385}, {267,14.721462}, {268,14.386615}, {269,15.780615}, {270,15.414692}, {271,15.199923}, {272,14.502538}, {273,15.544385}, {274,15.994615}, {275,15.512000}, {276,16.207385}, {277,16.222923}, {278,16.240462}, {279,16.180077}, {280,17.011385}, {281,16.388846}, {282,16.806615}, {283,17.508923}, {284,16.036000}, {285,16.629769}, {286,17.243385}, {287,18.140231}, {288,17.209462}, {289,18.076538}, {290,19.296538}, {291,17.258846}, {292,18.833692}, {293,19.391538}, {294,17.940000}, {295,18.587077}, {296,18.335846}, {297,18.616000}, {298,18.707385}, {299,18.997077}, {300,19.234385}, {301,19.043077}, {302,19.934538}, {303,18.609923}, {304,19.944000}, {305,19.227923}, {306,20.465000}, {307,16.674385}, {308,20.167077}, {309,20.408308}, {310,19.315154}, {311,20.421231}, {312,19.909308}, {313,20.491308}, {314,20.714385}, {315,21.627385}, {316,19.915077}, {317,21.280154}, {318,19.266154}, {319,22.298615}, {320,22.005692}, {321,23.049769}, {322,22.719846}, {323,23.382231}, {324,21.944769}, {325,23.019000}, {326,22.231846}, {327,22.191923}, {328,23.005769}, {329,22.390154}, {330,22.917231}, {331,23.074231}, {332,23.137615}, {333,23.219077}, {334,23.540615}, {335,23.830077}, {336,25.024846}, {337,24.593846}, {338,25.219538}, {339,23.733846}, {340,25.753692}, {341,24.313923}, {342,26.233077}, {343,25.449308}, {344,26.319385}, {345,25.719769}, {346,25.496231}, {347,26.894308}, {348,26.912769}, {349,27.987231}, {350,28.673000}, {351,28.237462}, {352,27.806462}, {353,29.258538}, {354,27.788231}, {355,28.634308}, {356,29.628154}, {357,30.622000}, {358,29.544308}, {359,28.543077}, {360,29.790692}, {361,28.836462}, {362,30.717692}, {363,30.287385}, {364,31.932769}, {365,30.946385}, {366,31.309615}, {367,31.521615}, {368,31.246923}, {369,30.539154}, {370,31.053923}, {371,31.807231}, {372,32.572154}, {373,32.700538}, {374,32.583308}, {375,32.892615}, {376,32.832231}, {377,32.730769}, {378,32.223769}, {379,33.164308}, {380,34.166308}, {381,34.573692}, {382,33.969462}, {383,34.444615}, {384,35.459923}, {385,34.481462}, {386,34.449308}, {387,34.808154}, {388,34.868231}, {389,35.710615}, {390,36.053769}, {391,36.152846}, {392,36.275077}, {393,36.883462}, {394,37.921077}, {395,37.545231}, {396,36.422692}, {397,37.250615}, {398,37.051000}, {399,37.870077}, {400,38.145538}, {401,39.372000}, {402,38.902923}, {403,38.742000}, {404,40.358846}, {405,39.446769}, {406,40.329846}, {407,40.372769}, {408,40.355769}, {409,40.272846}, {410,41.358462}, {411,39.869769}, {412,41.290077}, {413,40.911154}, {414,41.162077}, {415,42.468923}, {416,41.807462}, {417,42.747231}, {418,42.872154}, {419,42.699000}, {420,42.754923}, {421,43.800385}, {422,43.952692}, {423,45.554462}, {424,45.630923}, {425,44.842923}, {426,45.956385}, {427,45.879308}, {428,45.260615}, {429,47.032923}, {430,47.783692}, {431,47.953462}, {432,49.214385}, {433,48.181154}, {434,48.706077}, {435,48.690000}, {436,49.846154}, {437,47.262231}, {438,49.274077}, {439,49.251846}, {440,50.672385}, {441,49.640846}, {442,51.184615}, {443,51.880077}, {444,51.289385}, {445,50.902538}, {446,53.956769}, {447,53.541231}, {448,53.811154}, {449,52.330769}, {450,55.734692}};
data["big"]["Mtac2"]["Aggregate"]["user"] = {{1,0.001553991}, {2,0.001652582}, {3,0.002145540}, {4,0.002859155}, {5,0.003586854}, {6,0.004300469}, {7,0.005314554}, {8,0.006037559}, {9,0.007281690}, {10,0.008788732}, {11,0.010431925}, {12,0.012262911}, {13,0.013220657}, {14,0.014854460}, {15,0.026849765}, {16,0.017896714}, {17,0.019755869}, {18,0.021896714}, {19,0.025220657}, {20,0.027107981}, {21,0.038089202}, {22,0.031103286}, {23,0.034338028}, {24,0.037154930}, {25,0.039816901}, {26,0.042680751}, {27,0.068046948}, {28,0.048981221}, {29,0.053211268}, {30,0.080737089}, {31,0.059661972}, {32,0.092018779}, {33,0.067112676}, {34,0.078629108}, {35,0.137061033}, {36,0.083492958}, {37,0.111474178}, {38,0.103605634}, {39,0.092967136}, {40,0.119812207}, {41,0.133760563}, {42,0.490061033}, {43,0.190384977}, {44,0.139483568}, {45,0.165737089}, {46,0.152248826}, {47,0.226638498}, {48,0.182882629}, {49,0.509305164}, {50,0.239492958}, {51,0.202061033}, {52,0.183863850}, {53,0.307342723}, {54,0.536521127}, {55,0.321413146}, {56,0.212164319}, {57,0.286896714}, {58,0.620516432}, {59,0.350859155}, {60,0.310314554}, {61,0.370877934}, {62,0.306845070}, {63,0.334784038}, {64,0.673619718}, {65,0.399943662}, {66,0.383605634}, {67,0.695788732}, {68,0.423995305}, {69,0.409976526}, {70,0.817399061}, {71,0.381600939}, {72,0.466154930}, {73,0.831272300}, {74,0.832295775}, {75,0.511248826}, {76,0.504399061}, {77,0.868544601}, {78,0.541995305}, {79,0.538483568}, {80,0.570793427}, {81,0.914516432}, {82,0.951835681}, {83,0.597126761}, {84,0.972577465}, {85,0.718248826}, {86,1.007338028}, {87,0.645690141}, {88,1.071028169}, {89,0.667258216}, {90,1.148093897}, {91,1.134267606}, {92,0.709802817}, {93,1.187821596}, {94,1.228704225}, {95,1.242558685}, {96,0.989923}, {97,1.152923}, {98,1.189385}, {99,1.412231}, {100,1.297538}, {101,1.012538}, {102,1.457154}, {103,1.369308}, {104,1.451308}, {105,1.550385}, {106,1.184923}, {107,1.470615}, {108,1.549615}, {109,2.026231}, {110,1.232154}, {111,1.952308}, {112,1.406077}, {113,1.142692}, {114,1.793615}, {115,1.211769}, {116,2.111462}, {117,1.842231}, {118,1.689846}, {119,1.873923}, {120,1.704000}, {121,1.962769}, {122,1.816692}, {123,1.852846}, {124,1.621615}, {125,2.429385}, {126,1.958000}, {127,1.859385}, {128,2.254308}, {129,2.484538}, {130,1.655231}, {131,2.388462}, {132,2.355154}, {133,2.190154}, {134,2.188231}, {135,2.232000}, {136,2.794308}, {137,1.948769}, {138,2.770385}, {139,2.957846}, {140,2.794231}, {141,2.910462}, {142,1.984154}, {143,3.474000}, {144,2.687923}, {145,2.415923}, {146,2.661462}, {147,3.281077}, {148,3.117692}, {149,3.258000}, {150,2.272000}, {151,3.304923}, {152,3.884692}, {153,2.814000}, {154,3.301231}, {155,3.119231}, {156,3.339769}, {157,4.113846}, {158,3.490154}, {159,3.698308}, {160,3.155154}, {161,3.649308}, {162,3.577000}, {163,4.453231}, {164,3.840077}, {165,4.334923}, {166,4.339231}, {167,4.319538}, {168,3.521231}, {169,5.197846}, {170,4.007846}, {171,4.468923}, {172,4.059154}, {173,4.494385}, {174,5.400385}, {175,4.254231}, {176,4.630538}, {177,4.909308}, {178,4.743000}, {179,4.876077}, {180,4.970231}, {181,5.632231}, {182,3.899846}, {183,5.010538}, {184,5.737308}, {185,5.699615}, {186,5.948923}, {187,5.388462}, {188,4.897000}, {189,6.094769}, {190,5.451462}, {191,4.573538}, {192,5.920923}, {193,6.149538}, {194,6.293385}, {195,6.260231}, {196,5.831769}, {197,5.935923}, {198,6.017615}, {199,6.090308}, {200,6.253385}, {201,6.143462}, {202,6.712000}, {203,6.769000}, {204,6.799615}, {205,6.818615}, {206,7.599769}, {207,6.342615}, {208,7.638154}, {209,6.590538}, {210,7.701308}, {211,7.886385}, {212,6.154000}, {213,7.746846}, {214,7.880000}, {215,7.403308}, {216,8.092615}, {217,7.904077}, {218,7.676846}, {219,7.179615}, {220,8.169385}, {221,7.180846}, {222,8.110615}, {223,8.541923}, {224,8.051308}, {225,8.128538}, {226,8.763692}, {227,8.981462}, {228,8.823846}, {229,9.519538}, {230,9.046769}, {231,9.796077}, {232,9.660462}, {233,8.284462}, {234,9.735385}, {235,9.938538}, {236,10.054923}, {237,10.616231}, {238,10.686462}, {239,9.986308}, {240,9.881000}, {241,11.162077}, {242,11.051692}, {243,11.107462}, {244,10.721231}, {245,9.856846}, {246,11.396846}, {247,11.190769}, {248,12.108846}, {249,10.805000}, {250,11.924000}, {251,11.253154}, {252,12.083923}, {253,12.828692}, {254,12.090077}, {255,12.901385}, {256,12.073692}, {257,11.180538}, {258,13.922692}, {259,10.732385}, {260,13.651692}, {261,12.959000}, {262,14.210462}, {263,12.544000}, {264,14.484154}, {265,13.462077}, {266,11.785692}, {267,14.562077}, {268,14.215846}, {269,15.620846}, {270,15.249385}, {271,15.039615}, {272,14.330846}, {273,15.379462}, {274,15.813385}, {275,15.335846}, {276,16.032231}, {277,16.048231}, {278,16.073692}, {279,15.992923}, {280,16.819692}, {281,16.235231}, {282,16.622385}, {283,17.328615}, {284,15.851462}, {285,16.468077}, {286,17.049385}, {287,17.941385}, {288,17.008462}, {289,17.854538}, {290,19.073231}, {291,17.096769}, {292,18.619462}, {293,19.180154}, {294,17.725615}, {295,18.355154}, {296,18.125846}, {297,18.402846}, {298,18.477846}, {299,18.784923}, {300,19.001000}, {301,18.788385}, {302,19.691231}, {303,18.422308}, {304,19.719923}, {305,18.979615}, {306,20.213154}, {307,16.487692}, {308,19.942615}, {309,20.159538}, {310,19.091615}, {311,20.199308}, {312,19.657923}, {313,20.248769}, {314,20.462231}, {315,21.384462}, {316,19.693308}, {317,21.033154}, {318,19.005231}, {319,22.018154}, {320,21.732692}, {321,22.811385}, {322,22.504385}, {323,23.153692}, {324,21.733077}, {325,22.755923}, {326,21.956615}, {327,21.934462}, {328,22.705077}, {329,22.110923}, {330,22.621308}, {331,22.779154}, {332,22.846923}, {333,22.916231}, {334,23.230538}, {335,23.561154}, {336,24.741615}, {337,24.349923}, {338,24.952538}, {339,23.406846}, {340,25.453846}, {341,23.970154}, {342,25.927615}, {343,25.118692}, {344,25.965923}, {345,25.373923}, {346,25.209692}, {347,26.568462}, {348,26.585615}, {349,27.703308}, {350,28.372923}, {351,27.920538}, {352,27.479077}, {353,28.935615}, {354,27.441462}, {355,28.276077}, {356,29.310615}, {357,30.297769}, {358,29.216923}, {359,28.202462}, {360,29.459154}, {361,28.478923}, {362,30.382615}, {363,29.931923}, {364,31.592615}, {365,30.614692}, {366,30.981923}, {367,31.172692}, {368,30.879154}, {369,30.156538}, {370,30.667769}, {371,31.426462}, {372,32.206769}, {373,32.343923}, {374,32.240077}, {375,32.542692}, {376,32.470077}, {377,32.327308}, {378,31.856692}, {379,32.787154}, {380,33.740846}, {381,34.203538}, {382,33.591231}, {383,34.069077}, {384,35.092077}, {385,34.095846}, {386,34.079462}, {387,34.415846}, {388,34.490308}, {389,35.291769}, {390,35.689615}, {391,35.745923}, {392,35.854615}, {393,36.462000}, {394,37.525077}, {395,37.148154}, {396,36.003000}, {397,36.844077}, {398,36.670462}, {399,37.442000}, {400,37.710308}, {401,38.936462}, {402,38.475231}, {403,38.269615}, {404,39.937154}, {405,39.018538}, {406,39.887692}, {407,39.916308}, {408,39.918846}, {409,39.860385}, {410,40.897077}, {411,39.399000}, {412,40.813154}, {413,40.413385}, {414,40.663692}, {415,41.964538}, {416,41.349000}, {417,42.237231}, {418,42.420154}, {419,42.209538}, {420,42.253308}, {421,43.318231}, {422,43.459538}, {423,45.072846}, {424,45.166769}, {425,44.362385}, {426,45.432769}, {427,45.385000}, {428,44.795231}, {429,46.509769}, {430,47.271769}, {431,47.466231}, {432,48.727385}, {433,47.678308}, {434,48.189846}, {435,48.173000}, {436,49.305846}, {437,46.769000}, {438,48.801385}, {439,48.771923}, {440,50.071692}, {441,49.112538}, {442,50.663692}, {443,51.328154}, {444,50.735154}, {445,50.349231}, {446,53.422846}, {447,52.999769}, {448,53.310154}, {449,51.777308}, {450,55.178615}};
data["big"]["Mtac2"]["Aggregate"]["system"] = {{1,0.000000000}, {2,0.000032864}, {3,0.000028169}, {4,0.000018779}, {5,0.000056338}, {6,0.000018779}, {7,0.000075117}, {8,0.000084507}, {9,0.000018779}, {10,0.000056338}, {11,0.000093897}, {12,0.000089202}, {13,0.000126761}, {14,0.000051643}, {15,0.000037559}, {16,0.000089202}, {17,0.000018779}, {18,0.000131455}, {19,0.000549296}, {20,0.000305164}, {21,0.000450704}, {22,0.000422535}, {23,0.000338028}, {24,0.000366197}, {25,0.000403756}, {26,0.000408451}, {27,0.000615023}, {28,0.000666667}, {29,0.000295775}, {30,0.000107981}, {31,0.000089202}, {32,0.000107981}, {33,0.000093897}, {34,0.000018779}, {35,0.000051643}, {36,0.000056338}, {37,0.000056338}, {38,0.000056338}, {39,0.000338028}, {40,0.000126761}, {41,0.000131455}, {42,0.002262911}, {43,0.000126761}, {44,0.000342723}, {45,0.000248826}, {46,0.000272300}, {47,0.002154930}, {48,0.003431925}, {49,0.001187793}, {50,0.000107981}, {51,0.000070423}, {52,0.000197183}, {53,0.002723005}, {54,0.001150235}, {55,0.000126761}, {56,0.000075117}, {57,0.002051643}, {58,0.001474178}, {59,0.000164319}, {60,0.000075117}, {61,0.000075117}, {62,0.000103286}, {63,0.004732394}, {64,0.003107981}, {65,0.000215962}, {66,0.005995305}, {67,0.002544601}, {68,0.000140845}, {69,0.008093897}, {70,0.001690141}, {71,0.002610329}, {72,0.007159624}, {73,0.001089202}, {74,0.005765258}, {75,0.001239437}, {76,0.007164319}, {77,0.000798122}, {78,0.006234742}, {79,0.003920188}, {80,0.004384977}, {81,0.000995305}, {82,0.005995305}, {83,0.003220657}, {84,0.009638498}, {85,0.004938967}, {86,0.006352113}, {87,0.010910798}, {88,0.005089202}, {89,0.003835681}, {90,0.004948357}, {91,0.013070423}, {92,0.007981221}, {93,0.009460094}, {94,0.005239437}, {95,0.006281690}, {96,0.005769}, {97,0.008538}, {98,0.006385}, {99,0.003923}, {100,0.014385}, {101,0.007231}, {102,0.007385}, {103,0.006385}, {104,0.010615}, {105,0.012154}, {106,0.011308}, {107,0.012846}, {108,0.009769}, {109,0.014385}, {110,0.013692}, {111,0.013231}, {112,0.011538}, {113,0.007615}, {114,0.008308}, {115,0.023231}, {116,0.011846}, {117,0.010769}, {118,0.009538}, {119,0.009769}, {120,0.010692}, {121,0.018000}, {122,0.011769}, {123,0.009538}, {124,0.019308}, {125,0.016846}, {126,0.024385}, {127,0.014077}, {128,0.007385}, {129,0.026923}, {130,0.017000}, {131,0.022385}, {132,0.013846}, {133,0.014385}, {134,0.025154}, {135,0.011077}, {136,0.024692}, {137,0.016923}, {138,0.024538}, {139,0.023846}, {140,0.027846}, {141,0.024231}, {142,0.023385}, {143,0.026000}, {144,0.028000}, {145,0.027154}, {146,0.018615}, {147,0.013077}, {148,0.022769}, {149,0.027000}, {150,0.021846}, {151,0.036538}, {152,0.030154}, {153,0.030385}, {154,0.023077}, {155,0.032923}, {156,0.040538}, {157,0.034385}, {158,0.024462}, {159,0.033462}, {160,0.034385}, {161,0.040462}, {162,0.037154}, {163,0.026615}, {164,0.029923}, {165,0.035615}, {166,0.048692}, {167,0.043308}, {168,0.030692}, {169,0.036846}, {170,0.042231}, {171,0.058154}, {172,0.033615}, {173,0.054000}, {174,0.058769}, {175,0.045308}, {176,0.065154}, {177,0.066308}, {178,0.073923}, {179,0.064923}, {180,0.054385}, {181,0.064846}, {182,0.033077}, {183,0.067769}, {184,0.068538}, {185,0.050692}, {186,0.049769}, {187,0.057846}, {188,0.048923}, {189,0.072692}, {190,0.066077}, {191,0.047231}, {192,0.069769}, {193,0.080385}, {194,0.066462}, {195,0.082846}, {196,0.059615}, {197,0.068846}, {198,0.054846}, {199,0.052769}, {200,0.055692}, {201,0.061692}, {202,0.090692}, {203,0.073769}, {204,0.092692}, {205,0.086923}, {206,0.103846}, {207,0.075308}, {208,0.093769}, {209,0.061077}, {210,0.072538}, {211,0.098615}, {212,0.085308}, {213,0.092769}, {214,0.091385}, {215,0.089923}, {216,0.098692}, {217,0.102692}, {218,0.075769}, {219,0.080769}, {220,0.115692}, {221,0.066846}, {222,0.100308}, {223,0.115000}, {224,0.069846}, {225,0.079231}, {226,0.112538}, {227,0.115154}, {228,0.125385}, {229,0.109615}, {230,0.122000}, {231,0.114385}, {232,0.118692}, {233,0.092462}, {234,0.106615}, {235,0.125615}, {236,0.134769}, {237,0.116000}, {238,0.110308}, {239,0.120923}, {240,0.118231}, {241,0.130769}, {242,0.110385}, {243,0.131000}, {244,0.111000}, {245,0.115615}, {246,0.132154}, {247,0.138615}, {248,0.143923}, {249,0.112692}, {250,0.139538}, {251,0.159538}, {252,0.155538}, {253,0.146692}, {254,0.148154}, {255,0.150000}, {256,0.115462}, {257,0.120615}, {258,0.153077}, {259,0.127538}, {260,0.165308}, {261,0.158000}, {262,0.166231}, {263,0.117385}, {264,0.160231}, {265,0.132692}, {266,0.145077}, {267,0.159000}, {268,0.170308}, {269,0.159077}, {270,0.164462}, {271,0.160538}, {272,0.171308}, {273,0.164077}, {274,0.181077}, {275,0.176000}, {276,0.173538}, {277,0.174308}, {278,0.167077}, {279,0.186615}, {280,0.190385}, {281,0.152692}, {282,0.184462}, {283,0.179462}, {284,0.183308}, {285,0.162077}, {286,0.192846}, {287,0.197692}, {288,0.200308}, {289,0.221154}, {290,0.222308}, {291,0.161769}, {292,0.213154}, {293,0.210462}, {294,0.213923}, {295,0.230615}, {296,0.209923}, {297,0.212462}, {298,0.228923}, {299,0.211308}, {300,0.231000}, {301,0.252077}, {302,0.241000}, {303,0.186000}, {304,0.221615}, {305,0.246538}, {306,0.250385}, {307,0.185692}, {308,0.223231}, {309,0.246615}, {310,0.221692}, {311,0.219462}, {312,0.250231}, {313,0.241692}, {314,0.251462}, {315,0.242538}, {316,0.220769}, {317,0.246923}, {318,0.259846}, {319,0.280077}, {320,0.273154}, {321,0.238308}, {322,0.214538}, {323,0.227692}, {324,0.211000}, {325,0.262154}, {326,0.275077}, {327,0.256154}, {328,0.300154}, {329,0.279231}, {330,0.293769}, {331,0.291462}, {332,0.288846}, {333,0.301154}, {334,0.308077}, {335,0.265692}, {336,0.281154}, {337,0.241615}, {338,0.264538}, {339,0.324615}, {340,0.298077}, {341,0.342231}, {342,0.303615}, {343,0.328692}, {344,0.350462}, {345,0.343692}, {346,0.284077}, {347,0.322615}, {348,0.326846}, {349,0.282923}, {350,0.299385}, {351,0.315615}, {352,0.327154}, {353,0.321231}, {354,0.345615}, {355,0.357077}, {356,0.317385}, {357,0.322769}, {358,0.328000}, {359,0.339462}, {360,0.331462}, {361,0.355923}, {362,0.334308}, {363,0.355538}, {364,0.339000}, {365,0.331077}, {366,0.327538}, {367,0.347308}, {368,0.367000}, {369,0.382231}, {370,0.383769}, {371,0.380846}, {372,0.362846}, {373,0.356462}, {374,0.342692}, {375,0.349077}, {376,0.360000}, {377,0.402769}, {378,0.365462}, {379,0.374462}, {380,0.420846}, {381,0.368231}, {382,0.375308}, {383,0.371923}, {384,0.365077}, {385,0.383538}, {386,0.369000}, {387,0.391000}, {388,0.376385}, {389,0.417923}, {390,0.363846}, {391,0.405538}, {392,0.419000}, {393,0.420077}, {394,0.393846}, {395,0.395615}, {396,0.418615}, {397,0.405923}, {398,0.379692}, {399,0.426308}, {400,0.434769}, {401,0.434231}, {402,0.426462}, {403,0.471769}, {404,0.421000}, {405,0.427462}, {406,0.441231}, {407,0.456231}, {408,0.435231}, {409,0.411769}, {410,0.460000}, {411,0.470615}, {412,0.476308}, {413,0.496308}, {414,0.496077}, {415,0.503000}, {416,0.457538}, {417,0.506923}, {418,0.449923}, {419,0.488692}, {420,0.500462}, {421,0.478538}, {422,0.489385}, {423,0.481000}, {424,0.463077}, {425,0.479769}, {426,0.522615}, {427,0.492923}, {428,0.464538}, {429,0.523462}, {430,0.510769}, {431,0.485462}, {432,0.487154}, {433,0.500846}, {434,0.514923}, {435,0.515692}, {436,0.540154}, {437,0.491385}, {438,0.472000}, {439,0.478462}, {440,0.600923}, {441,0.526769}, {442,0.519846}, {443,0.550846}, {444,0.552692}, {445,0.549769}, {446,0.532462}, {447,0.540231}, {448,0.499692}, {449,0.550462}, {450,0.550769}};
data["big"]["Mtac2"]["actual reif"]["real"] = {{1,0.000009390}, {2,0.000788732}, {3,0.001018779}, {4,0.002028169}, {5,0.002084507}, {6,0.003046948}, {7,0.004061033}, {8,0.005056338}, {9,0.006084507}, {10,0.007765258}, {11,0.009065728}, {12,0.011037559}, {13,0.011948357}, {14,0.013755869}, {15,0.025004695}, {16,0.016915493}, {17,0.018826291}, {18,0.020849765}, {19,0.024474178}, {20,0.026014085}, {21,0.037169014}, {22,0.030488263}, {23,0.033145540}, {24,0.036000000}, {25,0.038845070}, {26,0.041868545}, {27,0.067539906}, {28,0.048178404}, {29,0.052244131}, {30,0.079516432}, {31,0.058150235}, {32,0.091061033}, {33,0.066103286}, {34,0.077431925}, {35,0.135399061}, {36,0.081896714}, {37,0.110370892}, {38,0.102469484}, {39,0.092103286}, {40,0.118436620}, {41,0.132328638}, {42,0.490873239}, {43,0.189323944}, {44,0.138136150}, {45,0.164535211}, {46,0.151037559}, {47,0.227507042}, {48,0.184671362}, {49,0.508887324}, {50,0.238230047}, {51,0.200732394}, {52,0.182516432}, {53,0.308615023}, {54,0.536107981}, {55,0.319943662}, {56,0.210525822}, {57,0.287314554}, {58,0.620192488}, {59,0.349427230}, {60,0.308680751}, {61,0.369460094}, {62,0.305215962}, {63,0.337765258}, {64,0.675375587}, {65,0.398314554}, {66,0.387915493}, {67,0.696591549}, {68,0.422446009}, {69,0.416502347}, {70,0.817460094}, {71,0.382629108}, {72,0.471732394}, {73,0.830854460}, {74,0.836342723}, {75,0.510690141}, {76,0.510018779}, {77,0.867521127}, {78,0.546436620}, {79,0.540455399}, {80,0.573558685}, {81,0.913676056}, {82,0.956154930}, {83,0.598596244}, {84,0.980413146}, {85,0.721586854}, {86,1.011732394}, {87,0.654910798}, {88,1.074211268}, {89,0.669244131}, {90,1.151056338}, {91,1.145530516}, {92,0.715830986}, {93,1.195553991}, {94,1.232056338}, {95,1.246938967}, {96,0.993462}, {97,1.159923}, {98,1.193308}, {99,1.414308}, {100,1.309846}, {101,1.017615}, {102,1.462231}, {103,1.372692}, {104,1.460154}, {105,1.560615}, {106,1.194769}, {107,1.480615}, {108,1.557538}, {109,1.967231}, {110,1.243000}, {111,1.963692}, {112,1.306615}, {113,1.148308}, {114,1.798846}, {115,1.233846}, {116,2.121077}, {117,1.850385}, {118,1.696692}, {119,1.880769}, {120,1.712385}, {121,1.977923}, {122,1.826692}, {123,1.859846}, {124,1.638615}, {125,2.443462}, {126,1.980385}, {127,1.870462}, {128,2.140231}, {129,2.508846}, {130,1.669923}, {131,2.408462}, {132,2.366692}, {133,2.201615}, {134,2.210923}, {135,2.241000}, {136,2.817154}, {137,1.963769}, {138,2.792538}, {139,2.979615}, {140,2.819154}, {141,2.932923}, {142,2.004077}, {143,3.497846}, {144,2.712846}, {145,2.440846}, {146,2.676538}, {147,3.291846}, {148,3.138077}, {149,3.282000}, {150,2.290000}, {151,3.338308}, {152,3.912077}, {153,2.842154}, {154,3.322077}, {155,3.150000}, {156,3.376923}, {157,4.146308}, {158,3.511462}, {159,3.729154}, {160,3.187231}, {161,3.686923}, {162,3.611615}, {163,4.477846}, {164,3.867923}, {165,4.368538}, {166,4.384846}, {167,4.360154}, {168,3.548615}, {169,5.231538}, {170,4.047923}, {171,4.523231}, {172,4.089769}, {173,4.545538}, {174,4.790077}, {175,4.297154}, {176,4.692615}, {177,4.972769}, {178,4.814077}, {179,4.938462}, {180,5.021615}, {181,5.548462}, {182,3.929923}, {183,5.075846}, {184,5.803077}, {185,5.747231}, {186,5.995462}, {187,5.443077}, {188,4.942692}, {189,6.165077}, {190,5.513769}, {191,4.617923}, {192,5.986923}, {193,6.226462}, {194,6.358231}, {195,6.339615}, {196,5.888000}, {197,6.002000}, {198,6.069231}, {199,6.140154}, {200,6.305692}, {201,6.202769}, {202,6.799692}, {203,6.839923}, {204,6.889000}, {205,6.902462}, {206,7.701308}, {207,6.415769}, {208,7.729077}, {209,6.647846}, {210,7.641615}, {211,7.982000}, {212,6.155769}, {213,7.836615}, {214,7.968923}, {215,7.489769}, {216,8.188000}, {217,8.004000}, {218,7.750000}, {219,7.256615}, {220,8.282000}, {221,7.243846}, {222,8.197923}, {223,8.653923}, {224,8.117615}, {225,8.205231}, {226,8.874385}, {227,9.093231}, {228,8.946462}, {229,9.625000}, {230,9.165846}, {231,9.908000}, {232,9.775462}, {233,8.373154}, {234,9.838769}, {235,10.060385}, {236,10.185923}, {237,10.728077}, {238,10.793615}, {239,10.104077}, {240,9.995846}, {241,11.289692}, {242,11.158000}, {243,11.235385}, {244,10.829231}, {245,9.968923}, {246,11.526615}, {247,11.325692}, {248,12.249615}, {249,10.914308}, {250,12.060385}, {251,11.409231}, {252,12.236462}, {253,12.972615}, {254,12.235077}, {255,13.047154}, {256,12.186154}, {257,11.297538}, {258,14.071846}, {259,10.856769}, {260,13.813692}, {261,13.113615}, {262,14.373385}, {263,12.657615}, {264,14.641077}, {265,13.589846}, {266,11.928385}, {267,14.717385}, {268,14.382615}, {269,15.776615}, {270,15.410615}, {271,15.076769}, {272,14.498462}, {273,15.540462}, {274,15.990615}, {275,15.508000}, {276,16.203154}, {277,16.218692}, {278,16.236385}, {279,16.175769}, {280,17.007308}, {281,16.384692}, {282,16.802308}, {283,17.504769}, {284,16.031385}, {285,16.446538}, {286,17.239154}, {287,18.135846}, {288,17.205154}, {289,17.633923}, {290,19.291615}, {291,17.254462}, {292,18.829077}, {293,19.387154}, {294,17.935231}, {295,18.582538}, {296,18.331231}, {297,18.611462}, {298,18.702846}, {299,18.992308}, {300,19.044769}, {301,19.038615}, {302,19.929769}, {303,18.605385}, {304,19.860308}, {305,19.223385}, {306,20.460462}, {307,16.669846}, {308,20.162538}, {309,20.403769}, {310,19.310538}, {311,20.416538}, {312,19.904538}, {313,20.486769}, {314,20.709615}, {315,21.622846}, {316,19.910538}, {317,21.205308}, {318,19.261231}, {319,22.294000}, {320,22.000923}, {321,22.849154}, {322,22.715231}, {323,23.377615}, {324,21.940231}, {325,23.014231}, {326,22.227154}, {327,22.187385}, {328,23.000846}, {329,22.385154}, {330,22.912308}, {331,23.069462}, {332,23.132231}, {333,23.213615}, {334,23.535538}, {335,23.825308}, {336,25.019846}, {337,24.503462}, {338,25.214538}, {339,23.728923}, {340,25.748692}, {341,24.308846}, {342,26.228077}, {343,25.444462}, {344,26.314308}, {345,25.714769}, {346,25.491077}, {347,26.889308}, {348,26.907769}, {349,27.982154}, {350,28.667923}, {351,28.232154}, {352,27.801538}, {353,29.253538}, {354,27.783231}, {355,28.629000}, {356,29.623154}, {357,30.617000}, {358,29.539308}, {359,28.373538}, {360,29.785462}, {361,28.831385}, {362,30.712154}, {363,30.281538}, {364,31.927308}, {365,30.941308}, {366,31.304462}, {367,31.400769}, {368,31.241615}, {369,30.534000}, {370,31.048538}, {371,31.639462}, {372,32.566846}, {373,32.695154}, {374,32.578000}, {375,32.887231}, {376,32.826923}, {377,32.725462}, {378,32.218385}, {379,33.159154}, {380,34.161000}, {381,34.568385}, {382,33.963846}, {383,34.439000}, {384,35.454615}, {385,34.461846}, {386,34.443923}, {387,34.802615}, {388,34.862769}, {389,35.705231}, {390,36.048462}, {391,36.146692}, {392,36.269692}, {393,36.878077}, {394,37.914769}, {395,37.539154}, {396,36.416846}, {397,37.240538}, {398,37.045692}, {399,37.864308}, {400,38.053462}, {401,39.365923}, {402,38.896923}, {403,38.736462}, {404,40.255462}, {405,39.440846}, {406,40.324154}, {407,40.367231}, {408,40.350000}, {409,40.267231}, {410,41.237231}, {411,39.864000}, {412,41.284308}, {413,40.905385}, {414,41.156462}, {415,42.463231}, {416,41.702538}, {417,42.741385}, {418,42.866385}, {419,42.693308}, {420,42.725000}, {421,43.794231}, {422,43.946692}, {423,45.548538}, {424,45.625231}, {425,44.760462}, {426,45.950615}, {427,45.873538}, {428,45.254846}, {429,46.948692}, {430,47.777692}, {431,47.947385}, {432,49.208615}, {433,48.175231}, {434,48.700154}, {435,48.684000}, {436,49.840231}, {437,47.256000}, {438,49.268077}, {439,49.245769}, {440,50.666385}, {441,49.634769}, {442,51.178538}, {443,51.874077}, {444,51.283308}, {445,50.896308}, {446,53.950615}, {447,53.535077}, {448,53.805077}, {449,52.324385}, {450,55.664308}};
data["big"]["Mtac2"]["actual reif"]["user"] = {{1,0.000591549}, {2,0.000816901}, {3,0.001427230}, {4,0.002032864}, {5,0.002586854}, {6,0.003525822}, {7,0.004258216}, {8,0.005197183}, {9,0.006225352}, {10,0.007319249}, {11,0.009281690}, {12,0.011140845}, {13,0.012140845}, {14,0.013779343}, {15,0.025230047}, {16,0.016826291}, {17,0.018539906}, {18,0.020605634}, {19,0.024225352}, {20,0.026028169}, {21,0.037093897}, {22,0.030070423}, {23,0.032830986}, {24,0.035830986}, {25,0.038633803}, {26,0.041474178}, {27,0.066671362}, {28,0.047859155}, {29,0.051910798}, {30,0.079201878}, {31,0.058046948}, {32,0.090676056}, {33,0.065685446}, {34,0.077107981}, {35,0.135558685}, {36,0.081774648}, {37,0.110103286}, {38,0.102089202}, {39,0.091657277}, {40,0.118366197}, {41,0.132173709}, {42,0.488784038}, {43,0.189220657}, {44,0.137896714}, {45,0.164488263}, {46,0.150779343}, {47,0.224896714}, {48,0.181122066}, {49,0.507802817}, {50,0.237910798}, {51,0.200647887}, {52,0.182338028}, {53,0.305760563}, {54,0.534943662}, {55,0.319938967}, {56,0.210530516}, {57,0.285394366}, {58,0.618920188}, {59,0.349159624}, {60,0.308492958}, {61,0.369220657}, {62,0.305169014}, {63,0.332854460}, {64,0.672070423}, {65,0.398145540}, {66,0.381760563}, {67,0.693816901}, {68,0.422300469}, {69,0.408272300}, {70,0.815788732}, {71,0.379835681}, {72,0.464239437}, {73,0.829647887}, {74,0.830417840}, {75,0.509291080}, {76,0.502830986}, {77,0.866615023}, {78,0.540225352}, {79,0.536643192}, {80,0.568840376}, {81,0.912436620}, {82,0.950093897}, {83,0.595384977}, {84,0.970436620}, {85,0.716333333}, {86,1.005211268}, {87,0.643990610}, {88,1.068985915}, {89,0.665502347}, {90,1.146051643}, {91,1.132215962}, {92,0.707586854}, {93,1.185610329}, {94,1.226633803}, {95,1.240474178}, {96,0.988308}, {97,1.152308}, {98,1.187154}, {99,1.410538}, {100,1.295077}, {101,1.010769}, {102,1.455615}, {103,1.367077}, {104,1.448923}, {105,1.548231}, {106,1.184385}, {107,1.468308}, {108,1.547077}, {109,1.953308}, {110,1.228692}, {111,1.949846}, {112,1.294615}, {113,1.140846}, {114,1.789615}, {115,1.210077}, {116,2.109385}, {117,1.840000}, {118,1.686846}, {119,1.871923}, {120,1.701846}, {121,1.959077}, {122,1.814846}, {123,1.850308}, {124,1.619385}, {125,2.426231}, {126,1.955615}, {127,1.855846}, {128,2.132923}, {129,2.481462}, {130,1.652538}, {131,2.385615}, {132,2.352692}, {133,2.186538}, {134,2.185615}, {135,2.229615}, {136,2.792000}, {137,1.947000}, {138,2.768385}, {139,2.956000}, {140,2.790615}, {141,2.908385}, {142,1.980231}, {143,3.472231}, {144,2.684615}, {145,2.414000}, {146,2.657385}, {147,3.279154}, {148,3.115154}, {149,3.255077}, {150,2.268615}, {151,3.301846}, {152,3.881231}, {153,2.810769}, {154,3.299385}, {155,3.116231}, {156,3.335615}, {157,4.112538}, {158,3.487077}, {159,3.695538}, {160,3.152692}, {161,3.646077}, {162,3.573846}, {163,4.451308}, {164,3.838077}, {165,4.332538}, {166,4.336000}, {167,4.316692}, {168,3.517538}, {169,5.194231}, {170,4.005923}, {171,4.464769}, {172,4.055308}, {173,4.491154}, {174,4.731308}, {175,4.251846}, {176,4.628077}, {177,4.905846}, {178,4.739769}, {179,4.872615}, {180,4.967462}, {181,5.484077}, {182,3.896462}, {183,5.007769}, {184,5.733923}, {185,5.696462}, {186,5.946000}, {187,5.385462}, {188,4.893077}, {189,6.092846}, {190,5.447231}, {191,4.570615}, {192,5.916692}, {193,6.145846}, {194,6.291385}, {195,6.256231}, {196,5.828077}, {197,5.931923}, {198,6.015154}, {199,6.087154}, {200,6.249923}, {201,6.140462}, {202,6.708000}, {203,6.766231}, {204,6.796538}, {205,6.815077}, {206,7.596385}, {207,6.339538}, {208,7.634615}, {209,6.587077}, {210,7.568692}, {211,7.882615}, {212,6.069692}, {213,7.743692}, {214,7.878077}, {215,7.399923}, {216,8.089154}, {217,7.900846}, {218,7.673769}, {219,7.175308}, {220,8.166923}, {221,7.175615}, {222,8.098385}, {223,8.537846}, {224,8.047769}, {225,8.124615}, {226,8.761385}, {227,8.977462}, {228,8.820846}, {229,9.514692}, {230,9.043769}, {231,9.792692}, {232,9.656462}, {233,8.280538}, {234,9.731692}, {235,9.933846}, {236,10.051385}, {237,10.612231}, {238,10.683231}, {239,9.983077}, {240,9.877000}, {241,11.158846}, {242,11.047231}, {243,11.103846}, {244,10.717308}, {245,9.853154}, {246,11.394000}, {247,11.186462}, {248,12.106077}, {249,10.800769}, {250,11.919846}, {251,11.249462}, {252,12.080385}, {253,12.825000}, {254,12.085615}, {255,12.896538}, {256,12.069769}, {257,11.177000}, {258,13.919538}, {259,10.728000}, {260,13.647462}, {261,12.955462}, {262,14.206692}, {263,12.539231}, {264,14.480769}, {265,13.456615}, {266,11.783231}, {267,14.557692}, {268,14.211154}, {269,15.617077}, {270,15.245846}, {271,14.916000}, {272,14.326846}, {273,15.376231}, {274,15.808692}, {275,15.331231}, {276,16.029462}, {277,16.043923}, {278,16.068231}, {279,15.988615}, {280,16.817308}, {281,16.230615}, {282,16.617385}, {283,17.325231}, {284,15.848769}, {285,16.283231}, {286,17.045462}, {287,17.937462}, {288,17.005077}, {289,17.414692}, {290,19.068385}, {291,17.091615}, {292,18.615923}, {293,19.176000}, {294,17.720615}, {295,18.351000}, {296,18.119846}, {297,18.398154}, {298,18.472615}, {299,18.779846}, {300,18.813077}, {301,18.785000}, {302,19.687308}, {303,18.418308}, {304,19.636846}, {305,18.974615}, {306,20.206923}, {307,16.482538}, {308,19.937000}, {309,20.155154}, {310,19.087000}, {311,20.196000}, {312,19.654846}, {313,20.243846}, {314,20.457000}, {315,21.379000}, {316,19.688308}, {317,20.958615}, {318,19.001154}, {319,22.013308}, {320,21.726923}, {321,22.609462}, {322,22.500077}, {323,23.148154}, {324,21.728846}, {325,22.752385}, {326,21.951615}, {327,21.930385}, {328,22.700385}, {329,22.105923}, {330,22.616692}, {331,22.776000}, {332,22.840231}, {333,22.909769}, {334,23.225692}, {335,23.557154}, {336,24.736615}, {337,24.259462}, {338,24.947923}, {339,23.402000}, {340,25.448538}, {341,23.963615}, {342,25.921923}, {343,25.114385}, {344,25.961923}, {345,25.368923}, {346,25.206000}, {347,26.564000}, {348,26.579769}, {349,27.698846}, {350,28.368615}, {351,27.915615}, {352,27.472923}, {353,28.931385}, {354,27.436769}, {355,28.272077}, {356,29.305692}, {357,30.293231}, {358,29.210615}, {359,28.032923}, {360,29.454000}, {361,28.475231}, {362,30.376769}, {363,29.925769}, {364,31.588154}, {365,30.609615}, {366,30.976000}, {367,31.054000}, {368,30.874154}, {369,30.151923}, {370,30.663462}, {371,31.258769}, {372,32.201846}, {373,32.338462}, {374,32.235154}, {375,32.537538}, {376,32.465846}, {377,32.322231}, {378,31.851077}, {379,32.781923}, {380,33.736154}, {381,34.197154}, {382,33.587231}, {383,34.063538}, {384,35.087000}, {385,34.075769}, {386,34.074154}, {387,34.410385}, {388,34.485000}, {389,35.286923}, {390,35.684538}, {391,35.741154}, {392,35.849923}, {393,36.457154}, {394,37.519385}, {395,37.143385}, {396,35.996923}, {397,36.834000}, {398,36.665231}, {399,37.437538}, {400,37.618462}, {401,38.930231}, {402,38.468462}, {403,38.264231}, {404,39.833308}, {405,39.012308}, {406,39.882308}, {407,39.910462}, {408,39.914231}, {409,39.854692}, {410,40.776769}, {411,39.392846}, {412,40.807846}, {413,40.406692}, {414,40.658000}, {415,41.959154}, {416,41.244077}, {417,42.231923}, {418,42.414538}, {419,42.203692}, {420,42.223769}, {421,43.311923}, {422,43.453615}, {423,45.066846}, {424,45.160769}, {425,44.279692}, {426,45.427538}, {427,45.379000}, {428,44.789231}, {429,46.424077}, {430,47.266000}, {431,47.460846}, {432,48.720538}, {433,47.672692}, {434,48.184308}, {435,48.167154}, {436,49.299077}, {437,46.763769}, {438,48.795077}, {439,48.766231}, {440,50.064923}, {441,49.107154}, {442,50.658000}, {443,51.322923}, {444,50.729154}, {445,50.344692}, {446,53.417000}, {447,52.993769}, {448,53.303846}, {449,51.771077}, {450,55.108615}};
data["big"]["Mtac2"]["actual reif"]["system"] = {{1,0.000000000}, {2,0.000018779}, {3,0.000014085}, {4,0.000000000}, {5,0.000056338}, {6,0.000018779}, {7,0.000075117}, {8,0.000051643}, {9,0.000000000}, {10,0.000037559}, {11,0.000056338}, {12,0.000089202}, {13,0.000093897}, {14,0.000032864}, {15,0.000000000}, {16,0.000070423}, {17,0.000018779}, {18,0.000093897}, {19,0.000535211}, {20,0.000286385}, {21,0.000431925}, {22,0.000403756}, {23,0.000305164}, {24,0.000347418}, {25,0.000370892}, {26,0.000389671}, {27,0.000596244}, {28,0.000666667}, {29,0.000244131}, {30,0.000075117}, {31,0.000070423}, {32,0.000089202}, {33,0.000056338}, {34,0.000018779}, {35,0.000032864}, {36,0.000037559}, {37,0.000018779}, {38,0.000037559}, {39,0.000319249}, {40,0.000075117}, {41,0.000093897}, {42,0.002192488}, {43,0.000075117}, {44,0.000323944}, {45,0.000230047}, {46,0.000197183}, {47,0.002117371}, {48,0.003361502}, {49,0.001061033}, {50,0.000051643}, {51,0.000018779}, {52,0.000178404}, {53,0.002652582}, {54,0.001032864}, {55,0.000093897}, {56,0.000018779}, {57,0.002032864}, {58,0.001333333}, {59,0.000145540}, {60,0.000037559}, {61,0.000037559}, {62,0.000084507}, {63,0.004619718}, {64,0.003018779}, {65,0.000107981}, {66,0.005976526}, {67,0.002399061}, {68,0.000103286}, {69,0.007943662}, {70,0.001507042}, {71,0.002553991}, {72,0.006971831}, {73,0.001037559}, {74,0.005708920}, {75,0.001056338}, {76,0.006962441}, {77,0.000727700}, {78,0.006126761}, {79,0.003751174}, {80,0.004272300}, {81,0.000943662}, {82,0.005830986}, {83,0.003075117}, {84,0.009474178}, {85,0.004849765}, {86,0.006262911}, {87,0.010784038}, {88,0.005014085}, {89,0.003741784}, {90,0.004816901}, {91,0.012938967}, {92,0.007812207}, {93,0.009384977}, {94,0.005131455}, {95,0.006173709}, {96,0.005769}, {97,0.008538}, {98,0.006385}, {99,0.003615}, {100,0.014077}, {101,0.007231}, {102,0.007385}, {103,0.006385}, {104,0.010615}, {105,0.012154}, {106,0.011308}, {107,0.012846}, {108,0.009769}, {109,0.013769}, {110,0.013692}, {111,0.013231}, {112,0.011538}, {113,0.007615}, {114,0.008308}, {115,0.023231}, {116,0.011846}, {117,0.010769}, {118,0.009538}, {119,0.009769}, {120,0.010692}, {121,0.018000}, {122,0.011769}, {123,0.009538}, {124,0.019308}, {125,0.016846}, {126,0.024385}, {127,0.014077}, {128,0.007385}, {129,0.026923}, {130,0.016692}, {131,0.022385}, {132,0.013846}, {133,0.014385}, {134,0.025154}, {135,0.011077}, {136,0.024692}, {137,0.016923}, {138,0.024538}, {139,0.023846}, {140,0.027846}, {141,0.024231}, {142,0.023385}, {143,0.026000}, {144,0.028000}, {145,0.026846}, {146,0.018615}, {147,0.013077}, {148,0.022769}, {149,0.027000}, {150,0.021846}, {151,0.036538}, {152,0.030154}, {153,0.030385}, {154,0.023077}, {155,0.032923}, {156,0.040538}, {157,0.034077}, {158,0.024462}, {159,0.033154}, {160,0.034385}, {161,0.040462}, {162,0.037154}, {163,0.026615}, {164,0.029923}, {165,0.035615}, {166,0.048692}, {167,0.043308}, {168,0.030692}, {169,0.036846}, {170,0.042231}, {171,0.057846}, {172,0.033615}, {173,0.054000}, {174,0.058462}, {175,0.045308}, {176,0.065154}, {177,0.066308}, {178,0.073923}, {179,0.064923}, {180,0.054385}, {181,0.064846}, {182,0.033077}, {183,0.067769}, {184,0.068538}, {185,0.050692}, {186,0.049769}, {187,0.057538}, {188,0.048615}, {189,0.072692}, {190,0.066077}, {191,0.047231}, {192,0.069769}, {193,0.080385}, {194,0.066462}, {195,0.082846}, {196,0.059615}, {197,0.068846}, {198,0.054154}, {199,0.052769}, {200,0.055692}, {201,0.061692}, {202,0.090692}, {203,0.073769}, {204,0.092692}, {205,0.086923}, {206,0.103846}, {207,0.075308}, {208,0.093769}, {209,0.061077}, {210,0.072231}, {211,0.098615}, {212,0.085308}, {213,0.092769}, {214,0.091385}, {215,0.089615}, {216,0.098692}, {217,0.102692}, {218,0.075769}, {219,0.080769}, {220,0.115692}, {221,0.066846}, {222,0.100000}, {223,0.115000}, {224,0.069846}, {225,0.079231}, {226,0.112538}, {227,0.115154}, {228,0.125154}, {229,0.109615}, {230,0.122000}, {231,0.114385}, {232,0.118692}, {233,0.092462}, {234,0.106615}, {235,0.125615}, {236,0.134385}, {237,0.115692}, {238,0.110308}, {239,0.120923}, {240,0.118231}, {241,0.130769}, {242,0.110000}, {243,0.131000}, {244,0.111000}, {245,0.115615}, {246,0.132154}, {247,0.138308}, {248,0.143538}, {249,0.112692}, {250,0.139538}, {251,0.159538}, {252,0.155538}, {253,0.146692}, {254,0.148154}, {255,0.150000}, {256,0.115462}, {257,0.120615}, {258,0.152385}, {259,0.127538}, {260,0.165308}, {261,0.157692}, {262,0.166000}, {263,0.117385}, {264,0.160000}, {265,0.132692}, {266,0.145077}, {267,0.159000}, {268,0.170308}, {269,0.158692}, {270,0.164462}, {271,0.160231}, {272,0.171308}, {273,0.164077}, {274,0.181077}, {275,0.176000}, {276,0.173538}, {277,0.174308}, {278,0.167077}, {279,0.186385}, {280,0.190385}, {281,0.152692}, {282,0.184462}, {283,0.179462}, {284,0.183308}, {285,0.161769}, {286,0.192846}, {287,0.197692}, {288,0.200308}, {289,0.218308}, {290,0.222308}, {291,0.161769}, {292,0.213154}, {293,0.210462}, {294,0.213923}, {295,0.230615}, {296,0.209923}, {297,0.212462}, {298,0.228923}, {299,0.211308}, {300,0.230769}, {301,0.252077}, {302,0.241000}, {303,0.186000}, {304,0.220923}, {305,0.246538}, {306,0.250385}, {307,0.185462}, {308,0.223231}, {309,0.246615}, {310,0.221692}, {311,0.219462}, {312,0.250231}, {313,0.241692}, {314,0.251462}, {315,0.242538}, {316,0.220769}, {317,0.246308}, {318,0.259846}, {319,0.280077}, {320,0.273154}, {321,0.238308}, {322,0.214538}, {323,0.227692}, {324,0.210769}, {325,0.262154}, {326,0.275077}, {327,0.256154}, {328,0.300154}, {329,0.278846}, {330,0.293769}, {331,0.291462}, {332,0.288846}, {333,0.300769}, {334,0.308077}, {335,0.265692}, {336,0.281154}, {337,0.241385}, {338,0.264308}, {339,0.324615}, {340,0.298077}, {341,0.342231}, {342,0.303615}, {343,0.328385}, {344,0.350462}, {345,0.343692}, {346,0.284077}, {347,0.322615}, {348,0.326846}, {349,0.282923}, {350,0.299385}, {351,0.315615}, {352,0.327154}, {353,0.321231}, {354,0.345615}, {355,0.356769}, {356,0.317385}, {357,0.322769}, {358,0.328000}, {359,0.339154}, {360,0.331462}, {361,0.355923}, {362,0.334308}, {363,0.355538}, {364,0.339000}, {365,0.331077}, {366,0.327538}, {367,0.346308}, {368,0.367000}, {369,0.382231}, {370,0.383769}, {371,0.380462}, {372,0.362846}, {373,0.356462}, {374,0.342385}, {375,0.349077}, {376,0.360000}, {377,0.402769}, {378,0.365462}, {379,0.374462}, {380,0.420846}, {381,0.368231}, {382,0.374923}, {383,0.371923}, {384,0.364846}, {385,0.383538}, {386,0.369000}, {387,0.390692}, {388,0.376385}, {389,0.417923}, {390,0.363846}, {391,0.405538}, {392,0.419000}, {393,0.420077}, {394,0.393538}, {395,0.395308}, {396,0.418615}, {397,0.405615}, {398,0.379692}, {399,0.426000}, {400,0.434769}, {401,0.434231}, {402,0.426462}, {403,0.471769}, {404,0.421000}, {405,0.427231}, {406,0.441000}, {407,0.456231}, {408,0.435231}, {409,0.411769}, {410,0.460000}, {411,0.470615}, {412,0.476000}, {413,0.496308}, {414,0.496077}, {415,0.503000}, {416,0.456923}, {417,0.506923}, {418,0.449923}, {419,0.488692}, {420,0.500462}, {421,0.478538}, {422,0.489385}, {423,0.481000}, {424,0.463077}, {425,0.479769}, {426,0.522615}, {427,0.492923}, {428,0.464231}, {429,0.523462}, {430,0.510769}, {431,0.485462}, {432,0.487154}, {433,0.500846}, {434,0.514923}, {435,0.515692}, {436,0.540154}, {437,0.491385}, {438,0.472000}, {439,0.478462}, {440,0.600923}, {441,0.526769}, {442,0.519846}, {443,0.550846}, {444,0.552692}, {445,0.549769}, {446,0.532462}, {447,0.540231}, {448,0.499462}, {449,0.550462}, {450,0.550769}};
data["big"]["Mtac2"]["cbv"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000000}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000077}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000077}, {235,0.000000}, {236,0.000000}, {237,0.000000}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000077}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000077}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.437385}, {290,0.000154}, {291,0.000077}, {292,0.000000}, {293,0.000000}, {294,0.000000}, {295,0.000077}, {296,0.000000}, {297,0.000077}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.000000}, {302,0.000000}, {303,0.000000}, {304,0.000000}, {305,0.000000}, {306,0.000000}, {307,0.000000}, {308,0.000000}, {309,0.000000}, {310,0.000000}, {311,0.000000}, {312,0.000000}, {313,0.000000}, {314,0.000000}, {315,0.000000}, {316,0.000000}, {317,0.000000}, {318,0.000000}, {319,0.000000}, {320,0.000000}, {321,0.000000}, {322,0.000000}, {323,0.000000}, {324,0.000000}, {325,0.000000}, {326,0.000000}, {327,0.000000}, {328,0.000000}, {329,0.000000}, {330,0.000000}, {331,0.000000}, {332,0.000000}, {333,0.000077}, {334,0.000077}, {335,0.000000}, {336,0.000000}, {337,0.000000}, {338,0.000000}, {339,0.000000}, {340,0.000000}, {341,0.000000}, {342,0.000000}, {343,0.000000}, {344,0.000000}, {345,0.000000}, {346,0.000000}, {347,0.000000}, {348,0.000000}, {349,0.000000}, {350,0.000000}, {351,0.000000}, {352,0.000000}, {353,0.000000}, {354,0.000000}, {355,0.000000}, {356,0.000000}, {357,0.000000}, {358,0.000000}, {359,0.000000}, {360,0.000000}, {361,0.000000}, {362,0.000000}, {363,0.000077}, {364,0.000077}, {365,0.000000}, {366,0.000000}, {367,0.000000}, {368,0.000000}, {369,0.000000}, {370,0.000000}, {371,0.000000}, {372,0.000000}, {373,0.000000}, {374,0.000000}, {375,0.000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000077}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000077}, {397,0.004308}, {398,0.000000}, {399,0.000000}, {400,0.000000}, {401,0.000000}, {402,0.000077}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000077}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000077}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}};
data["big"]["Mtac2"]["cbv"]["user"] = {{1,0.000032864}, {2,0.000000000}, {3,0.000028169}, {4,0.000056338}, {5,0.000000000}, {6,0.000037559}, {7,0.000037559}, {8,0.000032864}, {9,0.000098592}, {10,0.000051643}, {11,0.000018779}, {12,0.000000000}, {13,0.000051643}, {14,0.000037559}, {15,0.000018779}, {16,0.000018779}, {17,0.000000000}, {18,0.000065728}, {19,0.000018779}, {20,0.000037559}, {21,0.000103286}, {22,0.000000000}, {23,0.000070423}, {24,0.000051643}, {25,0.000107981}, {26,0.000037559}, {27,0.000032864}, {28,0.000046948}, {29,0.000122066}, {30,0.000112676}, {31,0.000056338}, {32,0.000070423}, {33,0.000065728}, {34,0.000192488}, {35,0.000061033}, {36,0.000117371}, {37,0.000032864}, {38,0.000107981}, {39,0.000145540}, {40,0.000070423}, {41,0.000107981}, {42,0.000145540}, {43,0.000056338}, {44,0.000089202}, {45,0.000065728}, {46,0.000018779}, {47,0.000122066}, {48,0.000140845}, {49,0.000075117}, {50,0.000107981}, {51,0.000056338}, {52,0.000051643}, {53,0.000065728}, {54,0.000065728}, {55,0.000046948}, {56,0.000098592}, {57,0.000065728}, {58,0.000126761}, {59,0.000084507}, {60,0.000131455}, {61,0.000089202}, {62,0.000225352}, {63,0.000103286}, {64,0.000093897}, {65,0.000065728}, {66,0.000089202}, {67,0.000117371}, {68,0.000070423}, {69,0.000117371}, {70,0.000117371}, {71,0.000145540}, {72,0.000070423}, {73,0.000093897}, {74,0.000122066}, {75,0.000183099}, {76,0.000093897}, {77,0.000164319}, {78,0.000211268}, {79,0.000154930}, {80,0.000117371}, {81,0.000117371}, {82,0.000178404}, {83,0.000192488}, {84,0.000197183}, {85,0.000117371}, {86,0.000211268}, {87,0.000084507}, {88,0.000187793}, {89,0.000018779}, {90,0.000187793}, {91,0.000122066}, {92,0.000201878}, {93,0.000178404}, {94,0.000305164}, {95,0.000192488}, {96,0.000000}, {97,0.000000}, {98,0.000462}, {99,0.000231}, {100,0.000462}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000231}, {105,0.000462}, {106,0.000000}, {107,0.000308}, {108,0.000462}, {109,0.000462}, {110,0.000231}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000462}, {115,0.000000}, {116,0.000000}, {117,0.000308}, {118,0.000231}, {119,0.000000}, {120,0.000231}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000308}, {126,0.000231}, {127,0.000000}, {128,0.000231}, {129,0.000231}, {130,0.000000}, {131,0.000231}, {132,0.000462}, {133,0.000000}, {134,0.000308}, {135,0.000000}, {136,0.000308}, {137,0.000000}, {138,0.000231}, {139,0.000000}, {140,0.000538}, {141,0.000538}, {142,0.000000}, {143,0.000000}, {144,0.000308}, {145,0.000000}, {146,0.000231}, {147,0.000000}, {148,0.000462}, {149,0.000000}, {150,0.000000}, {151,0.000538}, {152,0.000769}, {153,0.000538}, {154,0.000000}, {155,0.000462}, {156,0.000308}, {157,0.000231}, {158,0.000231}, {159,0.000231}, {160,0.000000}, {161,0.000231}, {162,0.000231}, {163,0.000000}, {164,0.000231}, {165,0.000462}, {166,0.000000}, {167,0.000000}, {168,0.000462}, {169,0.000308}, {170,0.000000}, {171,0.000462}, {172,0.000231}, {173,0.000231}, {174,0.000231}, {175,0.000000}, {176,0.000000}, {177,0.000769}, {178,0.000923}, {179,0.000231}, {180,0.000231}, {181,0.000231}, {182,0.000231}, {183,0.000000}, {184,0.000231}, {185,0.000000}, {186,0.000231}, {187,0.000231}, {188,0.000462}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000462}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000231}, {197,0.000769}, {198,0.000538}, {199,0.000692}, {200,0.000000}, {201,0.000538}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000462}, {206,0.000000}, {207,0.000000}, {208,0.000231}, {209,0.000000}, {210,0.001077}, {211,0.000000}, {212,0.000231}, {213,0.000538}, {214,0.000231}, {215,0.001231}, {216,0.000231}, {217,0.000231}, {218,0.000000}, {219,0.000231}, {220,0.000308}, {221,0.001000}, {222,0.000000}, {223,0.000692}, {224,0.000308}, {225,0.000231}, {226,0.000231}, {227,0.000692}, {228,0.000308}, {229,0.000000}, {230,0.000231}, {231,0.000231}, {232,0.000538}, {233,0.000769}, {234,0.000462}, {235,0.000692}, {236,0.000000}, {237,0.000231}, {238,0.000231}, {239,0.000000}, {240,0.000231}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000231}, {245,0.000538}, {246,0.000231}, {247,0.000615}, {248,0.000462}, {249,0.000615}, {250,0.000462}, {251,0.000462}, {252,0.000462}, {253,0.000462}, {254,0.000538}, {255,0.000538}, {256,0.000538}, {257,0.000308}, {258,0.000231}, {259,0.000231}, {260,0.000769}, {261,0.000000}, {262,0.000692}, {263,0.000692}, {264,0.000231}, {265,0.000231}, {266,0.000462}, {267,0.000000}, {268,0.000462}, {269,0.000462}, {270,0.000692}, {271,0.000462}, {272,0.000769}, {273,0.000462}, {274,0.000000}, {275,0.000231}, {276,0.000462}, {277,0.000308}, {278,0.000538}, {279,0.000231}, {280,0.000000}, {281,0.000308}, {282,0.000231}, {283,0.000000}, {284,0.000231}, {285,0.000308}, {286,0.000692}, {287,0.000692}, {288,0.000231}, {289,0.433308}, {290,0.000692}, {291,0.000846}, {292,0.000000}, {293,0.000692}, {294,0.000000}, {295,0.000462}, {296,0.000000}, {297,0.000846}, {298,0.000231}, {299,0.000462}, {300,0.000231}, {301,0.000231}, {302,0.000231}, {303,0.000231}, {304,0.000692}, {305,0.000462}, {306,0.000923}, {307,0.000231}, {308,0.001231}, {309,0.000538}, {310,0.000462}, {311,0.000692}, {312,0.000000}, {313,0.000308}, {314,0.000231}, {315,0.000692}, {316,0.000692}, {317,0.000769}, {318,0.000462}, {319,0.000000}, {320,0.001154}, {321,0.000000}, {322,0.000231}, {323,0.000462}, {324,0.000231}, {325,0.000462}, {326,0.000231}, {327,0.000231}, {328,0.000231}, {329,0.000000}, {330,0.000231}, {331,0.000231}, {332,0.000000}, {333,0.000000}, {334,0.000462}, {335,0.000231}, {336,0.000462}, {337,0.000769}, {338,0.000462}, {339,0.000231}, {340,0.000000}, {341,0.001692}, {342,0.000231}, {343,0.000538}, {344,0.000000}, {345,0.000308}, {346,0.000462}, {347,0.000462}, {348,0.000462}, {349,0.000692}, {350,0.000231}, {351,0.000000}, {352,0.000769}, {353,0.000462}, {354,0.000462}, {355,0.000231}, {356,0.000231}, {357,0.000231}, {358,0.000231}, {359,0.000000}, {360,0.000692}, {361,0.000000}, {362,0.000231}, {363,0.000231}, {364,0.000000}, {365,0.000000}, {366,0.001154}, {367,0.000231}, {368,0.000231}, {369,0.000000}, {370,0.000462}, {371,0.000000}, {372,0.000923}, {373,0.000923}, {374,0.000923}, {375,0.000462}, {376,0.000000}, {377,0.000538}, {378,0.000231}, {379,0.000769}, {380,0.000000}, {381,0.000000}, {382,0.000462}, {383,0.001077}, {384,0.000462}, {385,0.000462}, {386,0.000231}, {387,0.000231}, {388,0.000538}, {389,0.000538}, {390,0.000231}, {391,0.000462}, {392,0.000692}, {393,0.000231}, {394,0.000000}, {395,0.000923}, {396,0.000769}, {397,0.004231}, {398,0.000769}, {399,0.000308}, {400,0.000538}, {401,0.000000}, {402,0.001000}, {403,0.000538}, {404,0.000462}, {405,0.000462}, {406,0.001000}, {407,0.000000}, {408,0.000923}, {409,0.000692}, {410,0.000462}, {411,0.000462}, {412,0.000538}, {413,0.000462}, {414,0.000923}, {415,0.000231}, {416,0.000692}, {417,0.000000}, {418,0.000462}, {419,0.000462}, {420,0.000308}, {421,0.000462}, {422,0.000462}, {423,0.000231}, {424,0.000231}, {425,0.001154}, {426,0.000846}, {427,0.000308}, {428,0.001000}, {429,0.001077}, {430,0.001077}, {431,0.000769}, {432,0.000615}, {433,0.000769}, {434,0.000231}, {435,0.000538}, {436,0.001385}, {437,0.000923}, {438,0.000538}, {439,0.000846}, {440,0.000308}, {441,0.000538}, {442,0.000846}, {443,0.000231}, {444,0.001231}, {445,0.000000}, {446,0.001077}, {447,0.000615}, {448,0.000615}, {449,0.000923}, {450,0.000231}};
data["big"]["Mtac2"]["cbv"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000018779}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000018779}, {44,0.000000000}, {45,0.000000000}, {46,0.000018779}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000018779}, {54,0.000000000}, {55,0.000000000}, {56,0.000018779}, {57,0.000000000}, {58,0.000037559}, {59,0.000000000}, {60,0.000018779}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000037559}, {73,0.000000000}, {74,0.000000000}, {75,0.000018779}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000018779}, {84,0.000018779}, {85,0.000018779}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000037559}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000018779}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000231}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000000}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000000}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000000}, {237,0.000000}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000308}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000231}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000000}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.002462}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000000}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.000000}, {302,0.000000}, {303,0.000000}, {304,0.000000}, {305,0.000000}, {306,0.000000}, {307,0.000000}, {308,0.000000}, {309,0.000000}, {310,0.000000}, {311,0.000000}, {312,0.000000}, {313,0.000000}, {314,0.000000}, {315,0.000000}, {316,0.000000}, {317,0.000000}, {318,0.000000}, {319,0.000000}, {320,0.000000}, {321,0.000000}, {322,0.000000}, {323,0.000000}, {324,0.000000}, {325,0.000000}, {326,0.000000}, {327,0.000000}, {328,0.000000}, {329,0.000000}, {330,0.000000}, {331,0.000000}, {332,0.000000}, {333,0.000000}, {334,0.000000}, {335,0.000000}, {336,0.000000}, {337,0.000000}, {338,0.000000}, {339,0.000000}, {340,0.000000}, {341,0.000000}, {342,0.000000}, {343,0.000000}, {344,0.000000}, {345,0.000000}, {346,0.000000}, {347,0.000000}, {348,0.000000}, {349,0.000000}, {350,0.000000}, {351,0.000000}, {352,0.000000}, {353,0.000000}, {354,0.000000}, {355,0.000000}, {356,0.000000}, {357,0.000000}, {358,0.000000}, {359,0.000000}, {360,0.000000}, {361,0.000000}, {362,0.000000}, {363,0.000000}, {364,0.000000}, {365,0.000000}, {366,0.000000}, {367,0.000000}, {368,0.000000}, {369,0.000000}, {370,0.000000}, {371,0.000000}, {372,0.000000}, {373,0.000000}, {374,0.000000}, {375,0.000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000231}, {398,0.000000}, {399,0.000000}, {400,0.000000}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}};
data["big"]["Mtac2"]["eval lazy"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.666077}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.026769}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000000}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000000}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000000}, {237,0.000000}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.122769}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000000}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.000000}, {302,0.000000}, {303,0.000000}, {304,0.000000}, {305,0.000000}, {306,0.000000}, {307,0.000000}, {308,0.000000}, {309,0.000000}, {310,0.000000}, {311,0.000000}, {312,0.000000}, {313,0.000000}, {314,0.000000}, {315,0.000000}, {316,0.000000}, {317,0.000000}, {318,0.000000}, {319,0.000000}, {320,0.000000}, {321,0.000000}, {322,0.000000}, {323,0.000000}, {324,0.000000}, {325,0.000000}, {326,0.000000}, {327,0.000000}, {328,0.000000}, {329,0.000000}, {330,0.000000}, {331,0.000000}, {332,0.000000}, {333,0.000000}, {334,0.000000}, {335,0.000000}, {336,0.000000}, {337,0.000000}, {338,0.000000}, {339,0.000000}, {340,0.000000}, {341,0.000000}, {342,0.000000}, {343,0.000000}, {344,0.000000}, {345,0.000000}, {346,0.000000}, {347,0.000000}, {348,0.000000}, {349,0.000000}, {350,0.000000}, {351,0.000000}, {352,0.000000}, {353,0.000000}, {354,0.000000}, {355,0.000000}, {356,0.000000}, {357,0.000000}, {358,0.000000}, {359,0.000000}, {360,0.000000}, {361,0.000000}, {362,0.000000}, {363,0.000000}, {364,0.000000}, {365,0.000000}, {366,0.000000}, {367,0.000000}, {368,0.000000}, {369,0.000000}, {370,0.000000}, {371,0.000000}, {372,0.000000}, {373,0.000000}, {374,0.000000}, {375,0.000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000000}, {400,0.000000}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.115308}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.023846}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.054462}};
data["big"]["Mtac2"]["eval lazy"]["user"] = {{1,0.000018779}, {2,0.000000000}, {3,0.000056338}, {4,0.000000000}, {5,0.000032864}, {6,0.000000000}, {7,0.000051643}, {8,0.000018779}, {9,0.000051643}, {10,0.000051643}, {11,0.000018779}, {12,0.000089202}, {13,0.000093897}, {14,0.000018779}, {15,0.000103286}, {16,0.000079812}, {17,0.000070423}, {18,0.000084507}, {19,0.000056338}, {20,0.000061033}, {21,0.000089202}, {22,0.000037559}, {23,0.000051643}, {24,0.000056338}, {25,0.000046948}, {26,0.000093897}, {27,0.000075117}, {28,0.000051643}, {29,0.000159624}, {30,0.000051643}, {31,0.000136150}, {32,0.000037559}, {33,0.000070423}, {34,0.000075117}, {35,0.000032864}, {36,0.000037559}, {37,0.000145540}, {38,0.000051643}, {39,0.000093897}, {40,0.000046948}, {41,0.000079812}, {42,0.000089202}, {43,0.000070423}, {44,0.000014085}, {45,0.000051643}, {46,0.000192488}, {47,0.000065728}, {48,0.000122066}, {49,0.000117371}, {50,0.000112676}, {51,0.000140845}, {52,0.000056338}, {53,0.000065728}, {54,0.000107981}, {55,0.000056338}, {56,0.000187793}, {57,0.000089202}, {58,0.000046948}, {59,0.000136150}, {60,0.000084507}, {61,0.000126761}, {62,0.000164319}, {63,0.000107981}, {64,0.000122066}, {65,0.000098592}, {66,0.000112676}, {67,0.000136150}, {68,0.000046948}, {69,0.000084507}, {70,0.000051643}, {71,0.000122066}, {72,0.000117371}, {73,0.000103286}, {74,0.000103286}, {75,0.000126761}, {76,0.000014085}, {77,0.000065728}, {78,0.000093897}, {79,0.000079812}, {80,0.000145540}, {81,0.000075117}, {82,0.000117371}, {83,0.000103286}, {84,0.000122066}, {85,0.000145540}, {86,0.000089202}, {87,0.000037559}, {88,0.000103286}, {89,0.000122066}, {90,0.000122066}, {91,0.000187793}, {92,0.000112676}, {93,0.000103286}, {94,0.000084507}, {95,0.000169014}, {96,0.000000}, {97,0.000000}, {98,0.000231}, {99,0.000000}, {100,0.000000}, {101,0.000231}, {102,0.000308}, {103,0.000000}, {104,0.000000}, {105,0.000462}, {106,0.000000}, {107,0.000000}, {108,0.000231}, {109,0.000000}, {110,0.000462}, {111,0.000000}, {112,0.000231}, {113,0.000000}, {114,0.000000}, {115,0.000692}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000538}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000231}, {126,0.000000}, {127,0.000231}, {128,0.000000}, {129,0.000000}, {130,0.000231}, {131,0.000231}, {132,0.000231}, {133,0.000538}, {134,0.000000}, {135,0.000231}, {136,0.000000}, {137,0.000538}, {138,0.000231}, {139,0.000538}, {140,0.000231}, {141,0.000000}, {142,0.000462}, {143,0.000000}, {144,0.000000}, {145,0.000231}, {146,0.000000}, {147,0.000231}, {148,0.000231}, {149,0.000000}, {150,0.000231}, {151,0.000231}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000231}, {156,0.000000}, {157,0.000231}, {158,0.000000}, {159,0.000231}, {160,0.000231}, {161,0.000231}, {162,0.000000}, {163,0.000615}, {164,0.000000}, {165,0.000308}, {166,0.000000}, {167,0.000231}, {168,0.000231}, {169,0.000231}, {170,0.000000}, {171,0.000231}, {172,0.000538}, {173,0.000308}, {174,0.666000}, {175,0.000692}, {176,0.000231}, {177,0.000000}, {178,0.000000}, {179,0.000231}, {180,0.000231}, {181,0.000308}, {182,0.000231}, {183,0.000231}, {184,0.000308}, {185,0.000769}, {186,0.000231}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000231}, {192,0.000231}, {193,0.000308}, {194,0.000692}, {195,0.000692}, {196,0.000308}, {197,0.000231}, {198,0.000231}, {199,0.000615}, {200,0.000231}, {201,0.000231}, {202,0.000231}, {203,0.000692}, {204,0.000538}, {205,0.000308}, {206,0.000846}, {207,0.000231}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000769}, {212,0.027000}, {213,0.000231}, {214,0.000462}, {215,0.000462}, {216,0.000000}, {217,0.000308}, {218,0.000000}, {219,0.000462}, {220,0.000000}, {221,0.000692}, {222,0.000000}, {223,0.000462}, {224,0.000231}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000231}, {230,0.000000}, {231,0.000308}, {232,0.000000}, {233,0.000231}, {234,0.000538}, {235,0.000000}, {236,0.000231}, {237,0.000000}, {238,0.000231}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000231}, {243,0.000231}, {244,0.000231}, {245,0.000615}, {246,0.000231}, {247,0.000231}, {248,0.000538}, {249,0.000231}, {250,0.000462}, {251,0.000000}, {252,0.000000}, {253,0.000692}, {254,0.000538}, {255,0.000000}, {256,0.000231}, {257,0.000000}, {258,0.000000}, {259,0.000923}, {260,0.000000}, {261,0.000769}, {262,0.000308}, {263,0.000000}, {264,0.000000}, {265,0.000231}, {266,0.000000}, {267,0.000462}, {268,0.000308}, {269,0.000462}, {270,0.000231}, {271,0.000231}, {272,0.000308}, {273,0.000000}, {274,0.000231}, {275,0.000462}, {276,0.000231}, {277,0.000462}, {278,0.000231}, {279,0.000000}, {280,0.000231}, {281,0.000000}, {282,0.000000}, {283,0.000231}, {284,0.000231}, {285,0.123308}, {286,0.000462}, {287,0.000231}, {288,0.000000}, {289,0.000231}, {290,0.000000}, {291,0.000000}, {292,0.000769}, {293,0.000000}, {294,0.000000}, {295,0.000231}, {296,0.000692}, {297,0.000000}, {298,0.000000}, {299,0.000231}, {300,0.000692}, {301,0.000462}, {302,0.000000}, {303,0.000231}, {304,0.000462}, {305,0.000538}, {306,0.000538}, {307,0.000000}, {308,0.000231}, {309,0.000000}, {310,0.000000}, {311,0.000000}, {312,0.000231}, {313,0.000231}, {314,0.000462}, {315,0.000692}, {316,0.000000}, {317,0.000231}, {318,0.000462}, {319,0.000462}, {320,0.000462}, {321,0.000692}, {322,0.000000}, {323,0.000923}, {324,0.000231}, {325,0.000231}, {326,0.000231}, {327,0.000000}, {328,0.000231}, {329,0.000231}, {330,0.000000}, {331,0.001538}, {332,0.001154}, {333,0.000231}, {334,0.000231}, {335,0.000538}, {336,0.000231}, {337,0.000000}, {338,0.000231}, {339,0.000462}, {340,0.000000}, {341,0.000462}, {342,0.000538}, {343,0.000000}, {344,0.000231}, {345,0.000000}, {346,0.000231}, {347,0.000231}, {348,0.000462}, {349,0.000000}, {350,0.000000}, {351,0.000692}, {352,0.000000}, {353,0.000231}, {354,0.000231}, {355,0.000462}, {356,0.000692}, {357,0.000692}, {358,0.000538}, {359,0.000462}, {360,0.000000}, {361,0.000692}, {362,0.000692}, {363,0.000000}, {364,0.000692}, {365,0.000231}, {366,0.000538}, {367,0.000692}, {368,0.000000}, {369,0.000000}, {370,0.000000}, {371,0.000000}, {372,0.000231}, {373,0.000231}, {374,0.000231}, {375,0.000231}, {376,0.000231}, {377,0.000231}, {378,0.000231}, {379,0.000462}, {380,0.001154}, {381,0.000231}, {382,0.000000}, {383,0.000231}, {384,0.000538}, {385,0.000231}, {386,0.000000}, {387,0.000692}, {388,0.000231}, {389,0.000462}, {390,0.000000}, {391,0.000231}, {392,0.000692}, {393,0.000462}, {394,0.000231}, {395,0.000462}, {396,0.000462}, {397,0.000538}, {398,0.000231}, {399,0.000462}, {400,0.000308}, {401,0.000231}, {402,0.000923}, {403,0.000000}, {404,0.000692}, {405,0.000692}, {406,0.000692}, {407,0.000231}, {408,0.000000}, {409,0.000308}, {410,0.115462}, {411,0.000000}, {412,0.000538}, {413,0.000231}, {414,0.000692}, {415,0.000231}, {416,0.000462}, {417,0.000462}, {418,0.000462}, {419,0.000462}, {420,0.024385}, {421,0.000769}, {422,0.000308}, {423,0.000308}, {424,0.000769}, {425,0.000692}, {426,0.000462}, {427,0.000308}, {428,0.000000}, {429,0.000615}, {430,0.000846}, {431,0.000231}, {432,0.000923}, {433,0.000538}, {434,0.000615}, {435,0.000538}, {436,0.000923}, {437,0.000231}, {438,0.000231}, {439,0.000462}, {440,0.000538}, {441,0.000231}, {442,0.000846}, {443,0.000231}, {444,0.001231}, {445,0.000308}, {446,0.000769}, {447,0.000538}, {448,0.000231}, {449,0.000538}, {450,0.054000}};
data["big"]["Mtac2"]["eval lazy"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000018779}, {42,0.000018779}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000018779}, {49,0.000018779}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000014085}, {55,0.000000000}, {56,0.000000000}, {57,0.000018779}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000018779}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000018779}, {68,0.000000000}, {69,0.000037559}, {70,0.000018779}, {71,0.000000000}, {72,0.000018779}, {73,0.000014085}, {74,0.000018779}, {75,0.000018779}, {76,0.000037559}, {77,0.000000000}, {78,0.000018779}, {79,0.000000000}, {80,0.000037559}, {81,0.000000000}, {82,0.000018779}, {83,0.000051643}, {84,0.000018779}, {85,0.000000000}, {86,0.000014085}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000018779}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000018779}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000308}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000308}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000000}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000000}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000000}, {237,0.000000}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000231}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000000}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.000000}, {302,0.000000}, {303,0.000000}, {304,0.000000}, {305,0.000000}, {306,0.000000}, {307,0.000000}, {308,0.000000}, {309,0.000000}, {310,0.000000}, {311,0.000000}, {312,0.000000}, {313,0.000000}, {314,0.000000}, {315,0.000000}, {316,0.000000}, {317,0.000000}, {318,0.000000}, {319,0.000000}, {320,0.000000}, {321,0.000000}, {322,0.000000}, {323,0.000000}, {324,0.000000}, {325,0.000000}, {326,0.000000}, {327,0.000000}, {328,0.000000}, {329,0.000000}, {330,0.000000}, {331,0.000000}, {332,0.000000}, {333,0.000000}, {334,0.000000}, {335,0.000000}, {336,0.000000}, {337,0.000000}, {338,0.000000}, {339,0.000000}, {340,0.000000}, {341,0.000000}, {342,0.000000}, {343,0.000000}, {344,0.000000}, {345,0.000000}, {346,0.000000}, {347,0.000000}, {348,0.000000}, {349,0.000000}, {350,0.000000}, {351,0.000000}, {352,0.000000}, {353,0.000000}, {354,0.000000}, {355,0.000000}, {356,0.000000}, {357,0.000000}, {358,0.000000}, {359,0.000000}, {360,0.000000}, {361,0.000000}, {362,0.000000}, {363,0.000000}, {364,0.000000}, {365,0.000000}, {366,0.000000}, {367,0.000000}, {368,0.000000}, {369,0.000000}, {370,0.000000}, {371,0.000000}, {372,0.000000}, {373,0.000000}, {374,0.000000}, {375,0.000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000231}, {400,0.000000}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000231}, {449,0.000000}, {450,0.000000}};
data["big"]["Mtac2"]["lazy beta iota"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000000}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000000}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000000}, {237,0.000000}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.028231}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000000}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.000000}, {302,0.000000}, {303,0.000000}, {304,0.012077}, {305,0.000000}, {306,0.000000}, {307,0.000000}, {308,0.000000}, {309,0.000000}, {310,0.000000}, {311,0.000000}, {312,0.000000}, {313,0.000000}, {314,0.000000}, {315,0.000000}, {316,0.000000}, {317,0.000000}, {318,0.000000}, {319,0.000000}, {320,0.000000}, {321,0.000000}, {322,0.000000}, {323,0.000000}, {324,0.000000}, {325,0.000000}, {326,0.000000}, {327,0.000000}, {328,0.000000}, {329,0.000000}, {330,0.000000}, {331,0.000000}, {332,0.000000}, {333,0.000000}, {334,0.000000}, {335,0.000000}, {336,0.000000}, {337,0.000000}, {338,0.000000}, {339,0.000000}, {340,0.000000}, {341,0.000000}, {342,0.000000}, {343,0.000000}, {344,0.000000}, {345,0.000000}, {346,0.000000}, {347,0.000000}, {348,0.000000}, {349,0.000000}, {350,0.000000}, {351,0.000000}, {352,0.000000}, {353,0.000000}, {354,0.000000}, {355,0.000000}, {356,0.000000}, {357,0.000000}, {358,0.000000}, {359,0.000000}, {360,0.000000}, {361,0.000000}, {362,0.000000}, {363,0.000000}, {364,0.000000}, {365,0.000000}, {366,0.000000}, {367,0.000000}, {368,0.000000}, {369,0.000000}, {370,0.000000}, {371,0.000000}, {372,0.000000}, {373,0.000000}, {374,0.000000}, {375,0.000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000000}, {400,0.000000}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}};
data["big"]["Mtac2"]["lazy beta iota"]["user"] = {{1,0.000018779}, {2,0.000051643}, {3,0.000014085}, {4,0.000014085}, {5,0.000018779}, {6,0.000000000}, {7,0.000032864}, {8,0.000018779}, {9,0.000000000}, {10,0.000018779}, {11,0.000018779}, {12,0.000065728}, {13,0.000056338}, {14,0.000032864}, {15,0.000000000}, {16,0.000032864}, {17,0.000018779}, {18,0.000000000}, {19,0.000000000}, {20,0.000056338}, {21,0.000000000}, {22,0.000032864}, {23,0.000089202}, {24,0.000037559}, {25,0.000079812}, {26,0.000000000}, {27,0.000075117}, {28,0.000028169}, {29,0.000051643}, {30,0.000000000}, {31,0.000061033}, {32,0.000032864}, {33,0.000018779}, {34,0.000093897}, {35,0.000018779}, {36,0.000032864}, {37,0.000065728}, {38,0.000051643}, {39,0.000032864}, {40,0.000037559}, {41,0.000032864}, {42,0.000070423}, {43,0.000051643}, {44,0.000037559}, {45,0.000051643}, {46,0.000051643}, {47,0.000037559}, {48,0.000084507}, {49,0.000032864}, {50,0.000042254}, {51,0.000079812}, {52,0.000014085}, {53,0.000018779}, {54,0.000131455}, {55,0.000037559}, {56,0.000018779}, {57,0.000070423}, {58,0.000037559}, {59,0.000000000}, {60,0.000056338}, {61,0.000061033}, {62,0.000000000}, {63,0.000056338}, {64,0.000046948}, {65,0.000075117}, {66,0.000070423}, {67,0.000089202}, {68,0.000018779}, {69,0.000028169}, {70,0.000032864}, {71,0.000061033}, {72,0.000065728}, {73,0.000159624}, {74,0.000014085}, {75,0.000070423}, {76,0.000018779}, {77,0.000056338}, {78,0.000065728}, {79,0.000070423}, {80,0.000107981}, {81,0.000164319}, {82,0.000122066}, {83,0.000046948}, {84,0.000075117}, {85,0.000103286}, {86,0.000032864}, {87,0.000037559}, {88,0.000084507}, {89,0.000070423}, {90,0.000070423}, {91,0.000032864}, {92,0.000098592}, {93,0.000037559}, {94,0.000093897}, {95,0.000089202}, {96,0.000000}, {97,0.000000}, {98,0.000231}, {99,0.000231}, {100,0.000000}, {101,0.000000}, {102,0.000231}, {103,0.000000}, {104,0.000000}, {105,0.000308}, {106,0.000000}, {107,0.000000}, {108,0.000308}, {109,0.000000}, {110,0.000000}, {111,0.000231}, {112,0.000000}, {113,0.000000}, {114,0.000231}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000231}, {119,0.000000}, {120,0.000000}, {121,0.000231}, {122,0.000308}, {123,0.000231}, {124,0.000000}, {125,0.000000}, {126,0.000231}, {127,0.000231}, {128,0.000538}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000231}, {134,0.000000}, {135,0.000000}, {136,0.000308}, {137,0.000000}, {138,0.000231}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000231}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000231}, {147,0.000000}, {148,0.000000}, {149,0.000231}, {150,0.000308}, {151,0.000000}, {152,0.000231}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000231}, {160,0.000000}, {161,0.000000}, {162,0.000231}, {163,0.000000}, {164,0.000000}, {165,0.000231}, {166,0.000000}, {167,0.000231}, {168,0.000000}, {169,0.000462}, {170,0.000231}, {171,0.000231}, {172,0.000231}, {173,0.000231}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000231}, {182,0.000000}, {183,0.000231}, {184,0.000231}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000231}, {189,0.000231}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000231}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000308}, {207,0.000000}, {208,0.000308}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000462}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000615}, {219,0.000000}, {220,0.000000}, {221,0.000538}, {222,0.000000}, {223,0.000308}, {224,0.000000}, {225,0.000308}, {226,0.000000}, {227,0.000000}, {228,0.000231}, {229,0.000231}, {230,0.000000}, {231,0.000462}, {232,0.000615}, {233,0.000000}, {234,0.000462}, {235,0.000692}, {236,0.000231}, {237,0.000462}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000231}, {245,0.000308}, {246,0.000000}, {247,0.000000}, {248,0.000308}, {249,0.000231}, {250,0.000308}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000231}, {255,0.000000}, {256,0.000462}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000231}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000231}, {265,0.000231}, {266,0.000000}, {267,0.000000}, {268,0.000462}, {269,0.000000}, {270,0.000462}, {271,0.000231}, {272,0.000308}, {273,0.000231}, {274,0.000231}, {275,0.000615}, {276,0.000231}, {277,0.000000}, {278,0.000692}, {279,0.000462}, {280,0.000462}, {281,0.000000}, {282,0.000231}, {283,0.000000}, {284,0.000231}, {285,0.028231}, {286,0.000462}, {287,0.000000}, {288,0.000231}, {289,0.000231}, {290,0.000308}, {291,0.000000}, {292,0.000231}, {293,0.000000}, {294,0.000000}, {295,0.000462}, {296,0.000231}, {297,0.000000}, {298,0.000462}, {299,0.000000}, {300,0.000000}, {301,0.000231}, {302,0.000000}, {303,0.000231}, {304,0.012308}, {305,0.000692}, {306,0.000000}, {307,0.000462}, {308,0.000000}, {309,0.000462}, {310,0.000538}, {311,0.000000}, {312,0.000000}, {313,0.000231}, {314,0.000231}, {315,0.000000}, {316,0.000231}, {317,0.000000}, {318,0.000000}, {319,0.000462}, {320,0.000000}, {321,0.000231}, {322,0.000692}, {323,0.000462}, {324,0.000231}, {325,0.000000}, {326,0.000000}, {327,0.000000}, {328,0.000000}, {329,0.000231}, {330,0.000000}, {331,0.000000}, {332,0.000000}, {333,0.000000}, {334,0.000231}, {335,0.000231}, {336,0.000000}, {337,0.000231}, {338,0.000462}, {339,0.000231}, {340,0.000462}, {341,0.000000}, {342,0.000231}, {343,0.000000}, {344,0.000231}, {345,0.000462}, {346,0.000000}, {347,0.000769}, {348,0.000231}, {349,0.000462}, {350,0.000000}, {351,0.000231}, {352,0.000308}, {353,0.000000}, {354,0.000000}, {355,0.000231}, {356,0.000000}, {357,0.000000}, {358,0.000462}, {359,0.000462}, {360,0.000000}, {361,0.000231}, {362,0.000231}, {363,0.000000}, {364,0.000231}, {365,0.000000}, {366,0.000000}, {367,0.000000}, {368,0.000231}, {369,0.000000}, {370,0.000462}, {371,0.000000}, {372,0.000462}, {373,0.000000}, {374,0.000000}, {375,0.000231}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000231}, {380,0.000462}, {381,0.000000}, {382,0.000000}, {383,0.000231}, {384,0.000231}, {385,0.000692}, {386,0.000462}, {387,0.000231}, {388,0.000000}, {389,0.000231}, {390,0.000231}, {391,0.000231}, {392,0.000000}, {393,0.000308}, {394,0.000231}, {395,0.000000}, {396,0.000462}, {397,0.000000}, {398,0.000231}, {399,0.000231}, {400,0.000231}, {401,0.000231}, {402,0.000000}, {403,0.000462}, {404,0.000231}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000308}, {411,0.000231}, {412,0.000231}, {413,0.000462}, {414,0.000000}, {415,0.000000}, {416,0.000231}, {417,0.000000}, {418,0.000000}, {419,0.000462}, {420,0.000538}, {421,0.000231}, {422,0.000462}, {423,0.000000}, {424,0.000231}, {425,0.000231}, {426,0.000231}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000615}, {432,0.000000}, {433,0.000308}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000538}, {438,0.000846}, {439,0.000231}, {440,0.000000}, {441,0.000000}, {442,0.000308}, {443,0.000308}, {444,0.000000}, {445,0.000231}, {446,0.000308}, {447,0.000846}, {448,0.000000}, {449,0.000538}, {450,0.000615}};
data["big"]["Mtac2"]["lazy beta iota"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000018779}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000032864}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000018779}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000018779}, {66,0.000018779}, {67,0.000018779}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000018779}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000018779}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000018779}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000032864}, {95,0.000000000}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000000}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000000}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000000}, {237,0.000308}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000308}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000000}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000000}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.000000}, {302,0.000000}, {303,0.000000}, {304,0.000000}, {305,0.000000}, {306,0.000000}, {307,0.000000}, {308,0.000000}, {309,0.000000}, {310,0.000000}, {311,0.000000}, {312,0.000000}, {313,0.000000}, {314,0.000000}, {315,0.000000}, {316,0.000000}, {317,0.000000}, {318,0.000000}, {319,0.000000}, {320,0.000000}, {321,0.000000}, {322,0.000000}, {323,0.000000}, {324,0.000000}, {325,0.000000}, {326,0.000000}, {327,0.000000}, {328,0.000000}, {329,0.000000}, {330,0.000000}, {331,0.000000}, {332,0.000000}, {333,0.000000}, {334,0.000000}, {335,0.000000}, {336,0.000000}, {337,0.000000}, {338,0.000000}, {339,0.000000}, {340,0.000000}, {341,0.000000}, {342,0.000000}, {343,0.000000}, {344,0.000000}, {345,0.000000}, {346,0.000000}, {347,0.000000}, {348,0.000000}, {349,0.000000}, {350,0.000000}, {351,0.000000}, {352,0.000000}, {353,0.000000}, {354,0.000000}, {355,0.000231}, {356,0.000000}, {357,0.000000}, {358,0.000000}, {359,0.000000}, {360,0.000000}, {361,0.000000}, {362,0.000000}, {363,0.000000}, {364,0.000000}, {365,0.000000}, {366,0.000000}, {367,0.000000}, {368,0.000000}, {369,0.000000}, {370,0.000000}, {371,0.000000}, {372,0.000000}, {373,0.000000}, {374,0.000000}, {375,0.000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000000}, {400,0.000000}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}};
data["big"]["Mtac2"]["norm reif"]["real"] = {{1,0.000009390}, {2,0.001009390}, {3,0.001028169}, {4,0.002028169}, {5,0.002586854}, {6,0.003065728}, {7,0.004084507}, {8,0.005070423}, {9,0.006187793}, {10,0.008009390}, {11,0.009103286}, {12,0.011070423}, {13,0.012046948}, {14,0.013948357}, {15,0.025117371}, {16,0.017004695}, {17,0.018943662}, {18,0.020938967}, {19,0.024638498}, {20,0.026136150}, {21,0.037352113}, {22,0.030643192}, {23,0.033281690}, {24,0.036164319}, {25,0.038990610}, {26,0.042000000}, {27,0.067732394}, {28,0.048399061}, {29,0.052441315}, {30,0.079699531}, {31,0.058328638}, {32,0.091300469}, {33,0.066262911}, {34,0.077615023}, {35,0.135549296}, {36,0.082065728}, {37,0.110572770}, {38,0.102676056}, {39,0.092239437}, {40,0.118802817}, {41,0.132478873}, {42,0.491098592}, {43,0.189544601}, {44,0.138417840}, {45,0.164877934}, {46,0.151244131}, {47,0.227666667}, {48,0.184924883}, {49,0.509253521}, {50,0.238474178}, {51,0.200910798}, {52,0.182690141}, {53,0.308915493}, {54,0.536417840}, {55,0.320140845}, {56,0.210699531}, {57,0.287563380}, {58,0.620483568}, {59,0.349638498}, {60,0.308938967}, {61,0.369910798}, {62,0.305450704}, {63,0.337976526}, {64,0.675723005}, {65,0.398582160}, {66,0.388225352}, {67,0.696882629}, {68,0.422723005}, {69,0.416727700}, {70,0.817727700}, {71,0.382901408}, {72,0.472093897}, {73,0.831126761}, {74,0.836723005}, {75,0.511032864}, {76,0.510253521}, {77,0.867826291}, {78,0.546769953}, {79,0.540821596}, {80,0.573845070}, {81,0.913995305}, {82,0.956577465}, {83,0.598976526}, {84,0.980685446}, {85,0.721981221}, {86,1.012089202}, {87,0.655239437}, {88,1.074718310}, {89,0.669563380}, {90,1.151370892}, {91,1.145793427}, {92,0.716225352}, {93,1.195934272}, {94,1.232403756}, {95,1.247248826}, {96,0.993846}, {97,1.160154}, {98,1.193385}, {99,1.415154}, {100,1.309923}, {101,1.017846}, {102,1.462769}, {103,1.373692}, {104,1.460385}, {105,1.560923}, {106,1.195154}, {107,1.481231}, {108,1.557769}, {109,1.967615}, {110,1.243231}, {111,1.964000}, {112,1.306846}, {113,1.148692}, {114,1.799231}, {115,1.234308}, {116,2.121462}, {117,1.850692}, {118,1.697154}, {119,1.881077}, {120,1.712692}, {121,1.978385}, {122,1.827000}, {123,1.860308}, {124,1.639538}, {125,2.443692}, {126,1.980615}, {127,1.870769}, {128,2.218615}, {129,2.509154}, {130,1.670308}, {131,2.408846}, {132,2.367154}, {133,2.201769}, {134,2.211385}, {135,2.241231}, {136,2.817538}, {137,1.963923}, {138,2.792769}, {139,2.979769}, {140,2.819462}, {141,2.933692}, {142,2.004385}, {143,3.498615}, {144,2.713462}, {145,2.441385}, {146,2.676769}, {147,3.292231}, {148,3.138385}, {149,3.282231}, {150,2.290615}, {151,3.338385}, {152,3.912308}, {153,2.842231}, {154,3.322308}, {155,3.150385}, {156,3.377154}, {157,4.146692}, {158,3.511615}, {159,3.729308}, {160,3.187846}, {161,3.687231}, {162,3.611846}, {163,4.478077}, {164,3.868308}, {165,4.369231}, {166,4.385154}, {167,4.360385}, {168,3.548769}, {169,5.231769}, {170,4.048308}, {171,4.523538}, {172,4.089846}, {173,4.545846}, {174,5.456692}, {175,4.297692}, {176,4.693077}, {177,4.973538}, {178,4.814538}, {179,4.938615}, {180,5.022385}, {181,5.549385}, {182,3.930077}, {183,5.076000}, {184,5.803538}, {185,5.748000}, {186,5.996000}, {187,5.443462}, {188,4.943154}, {189,6.165308}, {190,5.514769}, {191,4.618385}, {192,5.987462}, {193,6.227077}, {194,6.358769}, {195,6.340154}, {196,5.888538}, {197,6.002462}, {198,6.069692}, {199,6.140769}, {200,6.305923}, {201,6.203077}, {202,6.799769}, {203,6.840231}, {204,6.889462}, {205,6.902846}, {206,7.701538}, {207,6.415923}, {208,7.729385}, {209,6.648308}, {210,7.641923}, {211,7.982385}, {212,6.183000}, {213,7.836923}, {214,7.969308}, {215,7.490154}, {216,8.188308}, {217,8.004231}, {218,7.750308}, {219,7.257308}, {220,8.282462}, {221,7.244154}, {222,8.198385}, {223,8.654385}, {224,8.118000}, {225,8.205538}, {226,8.874692}, {227,9.093615}, {228,8.946923}, {229,9.625462}, {230,9.166231}, {231,9.908231}, {232,9.775769}, {233,8.373615}, {234,9.839462}, {235,10.060692}, {236,10.186154}, {237,10.728538}, {238,10.794231}, {239,10.104462}, {240,9.996154}, {241,11.290077}, {242,11.158538}, {243,11.235769}, {244,10.829769}, {245,9.969308}, {246,11.527000}, {247,11.325923}, {248,12.249923}, {249,10.914615}, {250,12.061077}, {251,11.409462}, {252,12.236692}, {253,12.972846}, {254,12.235385}, {255,13.047692}, {256,12.186462}, {257,11.297769}, {258,14.072154}, {259,10.857231}, {260,13.814154}, {261,13.113923}, {262,14.374000}, {263,12.657846}, {264,14.641462}, {265,13.590308}, {266,11.928769}, {267,14.717769}, {268,14.383077}, {269,15.776923}, {270,15.410846}, {271,15.077077}, {272,14.498923}, {273,15.540769}, {274,15.990692}, {275,15.508462}, {276,16.203769}, {277,16.219000}, {278,16.236846}, {279,16.176231}, {280,17.007769}, {281,16.385000}, {282,16.802769}, {283,17.505231}, {284,16.031923}, {285,16.570077}, {286,17.239462}, {287,18.136462}, {288,17.205538}, {289,17.634769}, {290,19.292077}, {291,17.254846}, {292,18.829692}, {293,19.387692}, {294,17.935846}, {295,18.583000}, {296,18.331615}, {297,18.611846}, {298,18.703308}, {299,18.993000}, {300,19.045308}, {301,19.039154}, {302,19.930462}, {303,18.605923}, {304,19.860692}, {305,19.224000}, {306,20.460923}, {307,16.670385}, {308,20.162846}, {309,20.404231}, {310,19.311154}, {311,20.417077}, {312,19.905231}, {313,20.487154}, {314,20.710308}, {315,21.623231}, {316,19.910846}, {317,21.205692}, {318,19.262154}, {319,22.294538}, {320,22.001538}, {321,22.849692}, {322,22.715615}, {323,23.377769}, {324,21.940538}, {325,23.014769}, {326,22.227615}, {327,22.187846}, {328,23.001231}, {329,22.385769}, {330,22.912769}, {331,23.069846}, {332,23.132923}, {333,23.214154}, {334,23.536000}, {335,23.825769}, {336,25.020154}, {337,24.503846}, {338,25.215231}, {339,23.729308}, {340,25.749308}, {341,24.309308}, {342,26.228615}, {343,25.445077}, {344,26.314692}, {345,25.715385}, {346,25.491615}, {347,26.889923}, {348,26.908462}, {349,27.982769}, {350,28.668769}, {351,28.232846}, {352,27.802000}, {353,29.254000}, {354,27.783462}, {355,28.629692}, {356,29.623692}, {357,30.617385}, {358,29.539846}, {359,28.374077}, {360,29.786077}, {361,28.832154}, {362,30.712692}, {363,30.282308}, {364,31.928077}, {365,30.941615}, {366,31.305000}, {367,31.401231}, {368,31.242308}, {369,30.534538}, {370,31.049000}, {371,31.640000}, {372,32.567385}, {373,32.695846}, {374,32.578538}, {375,32.887692}, {376,32.827308}, {377,32.725923}, {378,32.218923}, {379,33.159538}, {380,34.161385}, {381,34.568923}, {382,33.964692}, {383,34.439769}, {384,35.455154}, {385,34.462385}, {386,34.444385}, {387,34.803231}, {388,34.863385}, {389,35.705615}, {390,36.049000}, {391,36.147538}, {392,36.270000}, {393,36.878615}, {394,37.915308}, {395,37.539923}, {396,36.417538}, {397,37.241308}, {398,37.046000}, {399,37.865077}, {400,38.053846}, {401,39.366538}, {402,38.897615}, {403,38.737000}, {404,40.256231}, {405,39.441615}, {406,40.324692}, {407,40.367692}, {408,40.350769}, {409,40.267769}, {410,41.353154}, {411,39.864769}, {412,41.285000}, {413,40.906000}, {414,41.156923}, {415,42.463769}, {416,41.703308}, {417,42.742077}, {418,42.867000}, {419,42.693846}, {420,42.749385}, {421,43.795000}, {422,43.947385}, {423,45.549154}, {424,45.625846}, {425,44.761000}, {426,45.951231}, {427,45.874154}, {428,45.255385}, {429,46.949231}, {430,47.778154}, {431,47.947923}, {432,49.209000}, {433,48.175769}, {434,48.700769}, {435,48.684692}, {436,49.840846}, {437,47.256692}, {438,49.268538}, {439,49.246308}, {440,50.667154}, {441,49.635308}, {442,51.179077}, {443,51.874538}, {444,51.283846}, {445,50.896923}, {446,53.951077}, {447,53.535769}, {448,53.805692}, {449,52.324923}, {450,55.719308}};
data["big"]["Mtac2"]["norm reif"]["user"] = {{1,0.000694836}, {2,0.000868545}, {3,0.001530516}, {4,0.002093897}, {5,0.002657277}, {6,0.003615023}, {7,0.004394366}, {8,0.005281690}, {9,0.006342723}, {10,0.007511737}, {11,0.009389671}, {12,0.011384977}, {13,0.012399061}, {14,0.013915493}, {15,0.025403756}, {16,0.016971831}, {17,0.018723005}, {18,0.020821596}, {19,0.024413146}, {20,0.026150235}, {21,0.037295775}, {22,0.030234742}, {23,0.033023474}, {24,0.035990610}, {25,0.038751174}, {26,0.041708920}, {27,0.066816901}, {28,0.047976526}, {29,0.052169014}, {30,0.079539906}, {31,0.058211268}, {32,0.090737089}, {33,0.065830986}, {34,0.077276995}, {35,0.135699531}, {36,0.081924883}, {37,0.110333333}, {38,0.102276995}, {39,0.091816901}, {40,0.118460094}, {41,0.132347418}, {42,0.488985915}, {43,0.189361502}, {44,0.137971831}, {45,0.164680751}, {46,0.151046948}, {47,0.225084507}, {48,0.181356808}, {49,0.508084507}, {50,0.238103286}, {51,0.200807512}, {52,0.182521127}, {53,0.305938967}, {54,0.535154930}, {55,0.320089202}, {56,0.210915493}, {57,0.285582160}, {58,0.619056338}, {59,0.349333333}, {60,0.308661972}, {61,0.369436620}, {62,0.305441315}, {63,0.333089202}, {64,0.672286385}, {65,0.398286385}, {66,0.382000000}, {67,0.694117371}, {68,0.422488263}, {69,0.408521127}, {70,0.815873239}, {71,0.380089202}, {72,0.464483568}, {73,0.829868545}, {74,0.830563380}, {75,0.509492958}, {76,0.503014085}, {77,0.866793427}, {78,0.540394366}, {79,0.536812207}, {80,0.569089202}, {81,0.912629108}, {82,0.950286385}, {83,0.595586854}, {84,0.970737089}, {85,0.716507042}, {86,1.005408451}, {87,0.644183099}, {88,1.069225352}, {89,0.665732394}, {90,1.146258216}, {91,1.132488263}, {92,0.707798122}, {93,1.185868545}, {94,1.226816901}, {95,1.240784038}, {96,0.988615}, {97,1.152308}, {98,1.187462}, {99,1.410538}, {100,1.295077}, {101,1.011077}, {102,1.456000}, {103,1.367077}, {104,1.448923}, {105,1.548769}, {106,1.184385}, {107,1.468615}, {108,1.547385}, {109,1.953308}, {110,1.229231}, {111,1.949846}, {112,1.295154}, {113,1.140846}, {114,1.790000}, {115,1.210923}, {116,2.109692}, {117,1.840000}, {118,1.686846}, {119,1.871923}, {120,1.702462}, {121,1.959077}, {122,1.814846}, {123,1.850308}, {124,1.619385}, {125,2.426538}, {126,1.955615}, {127,1.856154}, {128,2.211077}, {129,2.481769}, {130,1.652769}, {131,2.385923}, {132,2.353000}, {133,2.187231}, {134,2.185615}, {135,2.230231}, {136,2.792000}, {137,1.947692}, {138,2.768692}, {139,2.956692}, {140,2.790846}, {141,2.908385}, {142,1.981077}, {143,3.472538}, {144,2.685692}, {145,2.414231}, {146,2.657385}, {147,3.279385}, {148,3.115462}, {149,3.255308}, {150,2.268923}, {151,3.302462}, {152,3.881231}, {153,2.811385}, {154,3.299385}, {155,3.116538}, {156,3.335923}, {157,4.112846}, {158,3.487077}, {159,3.695846}, {160,3.153308}, {161,3.646385}, {162,3.573846}, {163,4.452077}, {164,3.838077}, {165,4.332923}, {166,4.336000}, {167,4.317000}, {168,3.517846}, {169,5.194538}, {170,4.005923}, {171,4.465077}, {172,4.056000}, {173,4.491538}, {174,5.397615}, {175,4.252692}, {176,4.628692}, {177,4.905846}, {178,4.739769}, {179,4.873231}, {180,4.968385}, {181,5.485077}, {182,3.897077}, {183,5.008000}, {184,5.734615}, {185,5.697769}, {186,5.946308}, {187,5.385462}, {188,4.893385}, {189,6.092846}, {190,5.447231}, {191,4.570923}, {192,5.917000}, {193,6.146154}, {194,6.292231}, {195,6.257000}, {196,5.828462}, {197,5.932231}, {198,6.015462}, {199,6.087846}, {200,6.250231}, {201,6.140769}, {202,6.708308}, {203,6.767077}, {204,6.797154}, {205,6.815462}, {206,7.597385}, {207,6.339846}, {208,7.635000}, {209,6.587385}, {210,7.568692}, {211,7.883462}, {212,6.096769}, {213,7.744308}, {214,7.878692}, {215,7.400385}, {216,8.089154}, {217,7.901231}, {218,7.673769}, {219,7.175846}, {220,8.166923}, {221,7.176385}, {222,8.098385}, {223,8.538385}, {224,8.048077}, {225,8.124615}, {226,8.761385}, {227,8.977462}, {228,8.820846}, {229,9.514923}, {230,9.044385}, {231,9.793077}, {232,9.656462}, {233,8.281154}, {234,9.732385}, {235,9.933846}, {236,10.051692}, {237,10.612231}, {238,10.683538}, {239,9.983077}, {240,9.877000}, {241,11.158846}, {242,11.047538}, {243,11.104154}, {244,10.717615}, {245,9.854154}, {246,11.394308}, {247,11.186769}, {248,12.106615}, {249,10.801077}, {250,11.920692}, {251,11.249846}, {252,12.080385}, {253,12.825769}, {254,12.086231}, {255,12.896538}, {256,12.070077}, {257,11.177000}, {258,13.919538}, {259,10.729231}, {260,13.647462}, {261,12.956692}, {262,14.207077}, {263,12.539231}, {264,14.480769}, {265,13.457231}, {266,11.783462}, {267,14.558231}, {268,14.211462}, {269,15.618000}, {270,15.246077}, {271,14.916615}, {272,14.327154}, {273,15.376231}, {274,15.809231}, {275,15.331769}, {276,16.029769}, {277,16.044538}, {278,16.068538}, {279,15.988615}, {280,16.817615}, {281,16.230615}, {282,16.617385}, {283,17.325538}, {284,15.849077}, {285,16.407000}, {286,17.046077}, {287,17.937769}, {288,17.005077}, {289,17.415000}, {290,19.068385}, {291,17.091923}, {292,18.617231}, {293,19.176308}, {294,17.720615}, {295,18.351308}, {296,18.121000}, {297,18.398462}, {298,18.472923}, {299,18.780538}, {300,18.814000}, {301,18.785615}, {302,19.687308}, {303,18.418923}, {304,19.637462}, {305,18.975231}, {306,20.208231}, {307,16.482538}, {308,19.937308}, {309,20.155154}, {310,19.087000}, {311,20.196000}, {312,19.655077}, {313,20.244154}, {314,20.457923}, {315,21.380231}, {316,19.688308}, {317,20.958923}, {318,19.001769}, {319,22.013923}, {320,21.727538}, {321,22.610385}, {322,22.500077}, {323,23.149385}, {324,21.729462}, {325,22.752692}, {326,21.951923}, {327,21.930385}, {328,22.700923}, {329,22.106231}, {330,22.616692}, {331,22.777923}, {332,22.841769}, {333,22.911000}, {334,23.226000}, {335,23.557846}, {336,24.736923}, {337,24.259462}, {338,24.948231}, {339,23.402615}, {340,25.449077}, {341,23.964231}, {342,25.922615}, {343,25.114385}, {344,25.962231}, {345,25.368923}, {346,25.206308}, {347,26.564308}, {348,26.580308}, {349,27.699154}, {350,28.369231}, {351,27.916538}, {352,27.472923}, {353,28.931692}, {354,27.437077}, {355,28.273000}, {356,29.306615}, {357,30.294154}, {358,29.211308}, {359,28.033923}, {360,29.454308}, {361,28.476077}, {362,30.377692}, {363,29.925769}, {364,31.589000}, {365,30.610231}, {366,30.976692}, {367,31.054923}, {368,30.874154}, {369,30.151923}, {370,30.663769}, {371,31.258769}, {372,32.202077}, {373,32.338769}, {374,32.235385}, {375,32.538154}, {376,32.466154}, {377,32.323154}, {378,31.851692}, {379,32.782538}, {380,33.737692}, {381,34.197692}, {382,33.587231}, {383,34.063846}, {384,35.087692}, {385,34.076077}, {386,34.074462}, {387,34.411615}, {388,34.485538}, {389,35.287538}, {390,35.684769}, {391,35.741385}, {392,35.851154}, {393,36.457923}, {394,37.519692}, {395,37.144308}, {396,35.997846}, {397,36.835077}, {398,36.665462}, {399,37.438154}, {400,37.618846}, {401,38.930462}, {402,38.470000}, {403,38.264231}, {404,39.834385}, {405,39.013077}, {406,39.883538}, {407,39.910769}, {408,39.914231}, {409,39.855077}, {410,40.892846}, {411,39.392846}, {412,40.809154}, {413,40.407000}, {414,40.658923}, {415,41.959462}, {416,41.245077}, {417,42.232846}, {418,42.415769}, {419,42.204615}, {420,42.248462}, {421,43.312846}, {422,43.454000}, {423,45.067231}, {424,45.161769}, {425,44.280538}, {426,45.428154}, {427,45.379385}, {428,44.789231}, {429,46.424769}, {430,47.267000}, {431,47.461462}, {432,48.721538}, {433,47.673308}, {434,48.184923}, {435,48.167692}, {436,49.300538}, {437,46.764231}, {438,48.795308}, {439,48.766769}, {440,50.065538}, {441,49.108000}, {442,50.658923}, {443,51.323154}, {444,50.730615}, {445,50.345308}, {446,53.417923}, {447,52.994385}, {448,53.304077}, {449,51.771615}, {450,55.162769}};
data["big"]["Mtac2"]["norm reif"]["system"] = {{1,0.000000000}, {2,0.000018779}, {3,0.000014085}, {4,0.000000000}, {5,0.000056338}, {6,0.000018779}, {7,0.000075117}, {8,0.000051643}, {9,0.000000000}, {10,0.000056338}, {11,0.000056338}, {12,0.000089202}, {13,0.000093897}, {14,0.000032864}, {15,0.000000000}, {16,0.000070423}, {17,0.000018779}, {18,0.000093897}, {19,0.000535211}, {20,0.000286385}, {21,0.000431925}, {22,0.000403756}, {23,0.000305164}, {24,0.000347418}, {25,0.000370892}, {26,0.000389671}, {27,0.000596244}, {28,0.000666667}, {29,0.000244131}, {30,0.000075117}, {31,0.000070423}, {32,0.000089202}, {33,0.000056338}, {34,0.000018779}, {35,0.000032864}, {36,0.000037559}, {37,0.000018779}, {38,0.000037559}, {39,0.000319249}, {40,0.000075117}, {41,0.000112676}, {42,0.002211268}, {43,0.000075117}, {44,0.000323944}, {45,0.000230047}, {46,0.000197183}, {47,0.002117371}, {48,0.003380282}, {49,0.001079812}, {50,0.000070423}, {51,0.000018779}, {52,0.000178404}, {53,0.002671362}, {54,0.001061033}, {55,0.000093897}, {56,0.000018779}, {57,0.002051643}, {58,0.001333333}, {59,0.000145540}, {60,0.000056338}, {61,0.000056338}, {62,0.000084507}, {63,0.004676056}, {64,0.003018779}, {65,0.000107981}, {66,0.005976526}, {67,0.002436620}, {68,0.000103286}, {69,0.008000000}, {70,0.001544601}, {71,0.002591549}, {72,0.006990610}, {73,0.001051643}, {74,0.005727700}, {75,0.001075117}, {76,0.007000000}, {77,0.000727700}, {78,0.006145540}, {79,0.003788732}, {80,0.004328638}, {81,0.000943662}, {82,0.005868545}, {83,0.003126761}, {84,0.009530516}, {85,0.004849765}, {86,0.006295775}, {87,0.010784038}, {88,0.005014085}, {89,0.003741784}, {90,0.004835681}, {91,0.012976526}, {92,0.007812207}, {93,0.009384977}, {94,0.005131455}, {95,0.006192488}, {96,0.005769}, {97,0.008538}, {98,0.006385}, {99,0.003615}, {100,0.014077}, {101,0.007231}, {102,0.007385}, {103,0.006385}, {104,0.010615}, {105,0.012154}, {106,0.011308}, {107,0.012846}, {108,0.009769}, {109,0.013769}, {110,0.013692}, {111,0.013231}, {112,0.011538}, {113,0.007615}, {114,0.008308}, {115,0.023231}, {116,0.011846}, {117,0.010769}, {118,0.009538}, {119,0.009769}, {120,0.010692}, {121,0.018000}, {122,0.011769}, {123,0.009538}, {124,0.019308}, {125,0.016846}, {126,0.024385}, {127,0.014077}, {128,0.007385}, {129,0.026923}, {130,0.016692}, {131,0.022385}, {132,0.013846}, {133,0.014385}, {134,0.025154}, {135,0.011077}, {136,0.024692}, {137,0.016923}, {138,0.024538}, {139,0.023846}, {140,0.027846}, {141,0.024231}, {142,0.023385}, {143,0.026000}, {144,0.028000}, {145,0.026846}, {146,0.018615}, {147,0.013077}, {148,0.022769}, {149,0.027000}, {150,0.021846}, {151,0.036538}, {152,0.030154}, {153,0.030385}, {154,0.023077}, {155,0.032923}, {156,0.040538}, {157,0.034077}, {158,0.024462}, {159,0.033154}, {160,0.034385}, {161,0.040462}, {162,0.037154}, {163,0.026615}, {164,0.029923}, {165,0.035615}, {166,0.048692}, {167,0.043308}, {168,0.030692}, {169,0.036846}, {170,0.042231}, {171,0.057846}, {172,0.033615}, {173,0.054000}, {174,0.058769}, {175,0.045308}, {176,0.065154}, {177,0.066308}, {178,0.073923}, {179,0.064923}, {180,0.054385}, {181,0.064846}, {182,0.033077}, {183,0.067769}, {184,0.068538}, {185,0.050692}, {186,0.049769}, {187,0.057538}, {188,0.048923}, {189,0.072692}, {190,0.066077}, {191,0.047231}, {192,0.069769}, {193,0.080385}, {194,0.066462}, {195,0.082846}, {196,0.059615}, {197,0.068846}, {198,0.054154}, {199,0.052769}, {200,0.055692}, {201,0.061692}, {202,0.090692}, {203,0.073769}, {204,0.092692}, {205,0.086923}, {206,0.103846}, {207,0.075308}, {208,0.093769}, {209,0.061077}, {210,0.072231}, {211,0.098615}, {212,0.085308}, {213,0.092769}, {214,0.091385}, {215,0.089615}, {216,0.098692}, {217,0.102692}, {218,0.075769}, {219,0.080769}, {220,0.115692}, {221,0.066846}, {222,0.100000}, {223,0.115000}, {224,0.069846}, {225,0.079231}, {226,0.112538}, {227,0.115154}, {228,0.125154}, {229,0.109615}, {230,0.122000}, {231,0.114385}, {232,0.118692}, {233,0.092462}, {234,0.106615}, {235,0.125615}, {236,0.134385}, {237,0.115692}, {238,0.110308}, {239,0.120923}, {240,0.118231}, {241,0.130769}, {242,0.110000}, {243,0.131000}, {244,0.111000}, {245,0.115615}, {246,0.132154}, {247,0.138308}, {248,0.143538}, {249,0.112692}, {250,0.139538}, {251,0.159538}, {252,0.155538}, {253,0.146692}, {254,0.148154}, {255,0.150000}, {256,0.115462}, {257,0.120615}, {258,0.152385}, {259,0.127538}, {260,0.165308}, {261,0.157692}, {262,0.166000}, {263,0.117385}, {264,0.160000}, {265,0.132692}, {266,0.145077}, {267,0.159000}, {268,0.170308}, {269,0.158692}, {270,0.164462}, {271,0.160231}, {272,0.171308}, {273,0.164077}, {274,0.181077}, {275,0.176000}, {276,0.173538}, {277,0.174308}, {278,0.167077}, {279,0.186385}, {280,0.190385}, {281,0.152692}, {282,0.184462}, {283,0.179462}, {284,0.183308}, {285,0.162077}, {286,0.192846}, {287,0.197692}, {288,0.200308}, {289,0.218308}, {290,0.222308}, {291,0.161769}, {292,0.213154}, {293,0.210462}, {294,0.213923}, {295,0.230615}, {296,0.209923}, {297,0.212462}, {298,0.228923}, {299,0.211308}, {300,0.230769}, {301,0.252077}, {302,0.241000}, {303,0.186000}, {304,0.220923}, {305,0.246538}, {306,0.250385}, {307,0.185462}, {308,0.223231}, {309,0.246615}, {310,0.221692}, {311,0.219462}, {312,0.250231}, {313,0.241692}, {314,0.251462}, {315,0.242538}, {316,0.220769}, {317,0.246308}, {318,0.259846}, {319,0.280077}, {320,0.273154}, {321,0.238308}, {322,0.214538}, {323,0.227692}, {324,0.210769}, {325,0.262154}, {326,0.275077}, {327,0.256154}, {328,0.300154}, {329,0.278846}, {330,0.293769}, {331,0.291462}, {332,0.288846}, {333,0.300769}, {334,0.308077}, {335,0.265692}, {336,0.281154}, {337,0.241385}, {338,0.264308}, {339,0.324615}, {340,0.298077}, {341,0.342231}, {342,0.303615}, {343,0.328385}, {344,0.350462}, {345,0.343692}, {346,0.284077}, {347,0.322615}, {348,0.326846}, {349,0.282923}, {350,0.299385}, {351,0.315615}, {352,0.327154}, {353,0.321231}, {354,0.345615}, {355,0.356769}, {356,0.317385}, {357,0.322769}, {358,0.328000}, {359,0.339154}, {360,0.331462}, {361,0.355923}, {362,0.334308}, {363,0.355538}, {364,0.339000}, {365,0.331077}, {366,0.327538}, {367,0.346308}, {368,0.367000}, {369,0.382231}, {370,0.383769}, {371,0.380462}, {372,0.362846}, {373,0.356462}, {374,0.342385}, {375,0.349077}, {376,0.360000}, {377,0.402769}, {378,0.365462}, {379,0.374462}, {380,0.420846}, {381,0.368231}, {382,0.374923}, {383,0.371923}, {384,0.364846}, {385,0.383538}, {386,0.369000}, {387,0.390692}, {388,0.376385}, {389,0.417923}, {390,0.363846}, {391,0.405538}, {392,0.419000}, {393,0.420077}, {394,0.393538}, {395,0.395308}, {396,0.418615}, {397,0.405615}, {398,0.379692}, {399,0.426308}, {400,0.434769}, {401,0.434231}, {402,0.426462}, {403,0.471769}, {404,0.421000}, {405,0.427231}, {406,0.441000}, {407,0.456231}, {408,0.435231}, {409,0.411769}, {410,0.460000}, {411,0.470615}, {412,0.476000}, {413,0.496308}, {414,0.496077}, {415,0.503000}, {416,0.456923}, {417,0.506923}, {418,0.449923}, {419,0.488692}, {420,0.500462}, {421,0.478538}, {422,0.489385}, {423,0.481000}, {424,0.463077}, {425,0.479769}, {426,0.522615}, {427,0.492923}, {428,0.464231}, {429,0.523462}, {430,0.510769}, {431,0.485462}, {432,0.487154}, {433,0.500846}, {434,0.514923}, {435,0.515692}, {436,0.540154}, {437,0.491385}, {438,0.472000}, {439,0.478462}, {440,0.600923}, {441,0.526769}, {442,0.519846}, {443,0.550846}, {444,0.552692}, {445,0.549769}, {446,0.532462}, {447,0.540231}, {448,0.499692}, {449,0.550462}, {450,0.550769}};
data["big"]["Mtac2"]["post"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000000}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000000}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000000}, {237,0.000000}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000000}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000000}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.000000}, {302,0.000000}, {303,0.000000}, {304,0.000000}, {305,0.000000}, {306,0.000000}, {307,0.000000}, {308,0.000000}, {309,0.000000}, {310,0.000000}, {311,0.000000}, {312,0.000000}, {313,0.000000}, {314,0.000000}, {315,0.000000}, {316,0.000000}, {317,0.000000}, {318,0.000000}, {319,0.000000}, {320,0.000000}, {321,0.000000}, {322,0.000000}, {323,0.000000}, {324,0.000000}, {325,0.000000}, {326,0.000000}, {327,0.000000}, {328,0.000000}, {329,0.000000}, {330,0.000000}, {331,0.000000}, {332,0.000000}, {333,0.000000}, {334,0.000000}, {335,0.000000}, {336,0.000000}, {337,0.000000}, {338,0.000000}, {339,0.000000}, {340,0.000000}, {341,0.000000}, {342,0.000000}, {343,0.000000}, {344,0.000000}, {345,0.000000}, {346,0.000000}, {347,0.000000}, {348,0.000000}, {349,0.000000}, {350,0.000000}, {351,0.000000}, {352,0.000000}, {353,0.000000}, {354,0.000000}, {355,0.000000}, {356,0.000000}, {357,0.000000}, {358,0.000000}, {359,0.000000}, {360,0.000000}, {361,0.000000}, {362,0.000000}, {363,0.000000}, {364,0.000000}, {365,0.000000}, {366,0.000000}, {367,0.000000}, {368,0.000000}, {369,0.000000}, {370,0.000000}, {371,0.000000}, {372,0.000000}, {373,0.000000}, {374,0.000000}, {375,0.000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000000}, {400,0.000000}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}};
data["big"]["Mtac2"]["post"]["user"] = {{1,0.000018779}, {2,0.000051643}, {3,0.000018779}, {4,0.000000000}, {5,0.000028169}, {6,0.000018779}, {7,0.000032864}, {8,0.000051643}, {9,0.000018779}, {10,0.000032864}, {11,0.000065728}, {12,0.000000000}, {13,0.000000000}, {14,0.000018779}, {15,0.000000000}, {16,0.000032864}, {17,0.000000000}, {18,0.000032864}, {19,0.000014085}, {20,0.000000000}, {21,0.000032864}, {22,0.000028169}, {23,0.000014085}, {24,0.000075117}, {25,0.000032864}, {26,0.000037559}, {27,0.000061033}, {28,0.000000000}, {29,0.000037559}, {30,0.000037559}, {31,0.000018779}, {32,0.000046948}, {33,0.000028169}, {34,0.000065728}, {35,0.000075117}, {36,0.000014085}, {37,0.000032864}, {38,0.000084507}, {39,0.000037559}, {40,0.000000000}, {41,0.000000000}, {42,0.000089202}, {43,0.000018779}, {44,0.000046948}, {45,0.000032864}, {46,0.000014085}, {47,0.000070423}, {48,0.000051643}, {49,0.000018779}, {50,0.000065728}, {51,0.000014085}, {52,0.000028169}, {53,0.000018779}, {54,0.000056338}, {55,0.000056338}, {56,0.000065728}, {57,0.000032864}, {58,0.000037559}, {59,0.000037559}, {60,0.000000000}, {61,0.000037559}, {62,0.000037559}, {63,0.000056338}, {64,0.000037559}, {65,0.000061033}, {66,0.000046948}, {67,0.000018779}, {68,0.000032864}, {69,0.000014085}, {70,0.000014085}, {71,0.000000000}, {72,0.000056338}, {73,0.000065728}, {74,0.000018779}, {75,0.000070423}, {76,0.000037559}, {77,0.000018779}, {78,0.000000000}, {79,0.000014085}, {80,0.000018779}, {81,0.000037559}, {82,0.000000000}, {83,0.000037559}, {84,0.000046948}, {85,0.000018779}, {86,0.000051643}, {87,0.000018779}, {88,0.000018779}, {89,0.000000000}, {90,0.000018779}, {91,0.000014085}, {92,0.000018779}, {93,0.000042254}, {94,0.000000000}, {95,0.000000000}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000231}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000231}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000231}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000231}, {131,0.000308}, {132,0.000000}, {133,0.000231}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000231}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000231}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000538}, {168,0.000000}, {169,0.000308}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000231}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000231}, {205,0.000308}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000231}, {223,0.000000}, {224,0.000000}, {225,0.000231}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000231}, {230,0.000000}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000000}, {237,0.000231}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000231}, {257,0.000231}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000231}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000231}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000308}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000231}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000000}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.000000}, {302,0.000000}, {303,0.000000}, {304,0.000000}, {305,0.000000}, {306,0.000000}, {307,0.000000}, {308,0.000000}, {309,0.000000}, {310,0.000000}, {311,0.000000}, {312,0.000000}, {313,0.000231}, {314,0.000000}, {315,0.000231}, {316,0.000231}, {317,0.000000}, {318,0.000000}, {319,0.000000}, {320,0.000000}, {321,0.000000}, {322,0.000000}, {323,0.000000}, {324,0.000000}, {325,0.000231}, {326,0.000000}, {327,0.000000}, {328,0.000000}, {329,0.000000}, {330,0.000000}, {331,0.000000}, {332,0.000000}, {333,0.000000}, {334,0.000000}, {335,0.000000}, {336,0.000000}, {337,0.000000}, {338,0.000231}, {339,0.000000}, {340,0.000231}, {341,0.000000}, {342,0.000000}, {343,0.000000}, {344,0.000000}, {345,0.000000}, {346,0.000231}, {347,0.000000}, {348,0.000000}, {349,0.000000}, {350,0.000000}, {351,0.000000}, {352,0.000000}, {353,0.000231}, {354,0.000000}, {355,0.000000}, {356,0.000000}, {357,0.000231}, {358,0.000000}, {359,0.000000}, {360,0.000000}, {361,0.000000}, {362,0.000000}, {363,0.000000}, {364,0.000000}, {365,0.000000}, {366,0.000231}, {367,0.000000}, {368,0.000000}, {369,0.000000}, {370,0.000000}, {371,0.000000}, {372,0.000000}, {373,0.000000}, {374,0.000000}, {375,0.000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000231}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000231}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000000}, {398,0.000231}, {399,0.000000}, {400,0.000000}, {401,0.000231}, {402,0.000000}, {403,0.000000}, {404,0.000231}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000231}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}};
data["big"]["Mtac2"]["post"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000018779}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000018779}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000018779}, {83,0.000000000}, {84,0.000018779}, {85,0.000000000}, {86,0.000000000}, {87,0.000014085}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000000}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000000}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000000}, {237,0.000000}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000000}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000000}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.000000}, {302,0.000000}, {303,0.000000}, {304,0.000000}, {305,0.000000}, {306,0.000000}, {307,0.000000}, {308,0.000000}, {309,0.000000}, {310,0.000000}, {311,0.000000}, {312,0.000000}, {313,0.000000}, {314,0.000000}, {315,0.000000}, {316,0.000000}, {317,0.000000}, {318,0.000000}, {319,0.000000}, {320,0.000000}, {321,0.000000}, {322,0.000000}, {323,0.000000}, {324,0.000000}, {325,0.000000}, {326,0.000000}, {327,0.000000}, {328,0.000000}, {329,0.000000}, {330,0.000000}, {331,0.000000}, {332,0.000000}, {333,0.000000}, {334,0.000000}, {335,0.000000}, {336,0.000000}, {337,0.000000}, {338,0.000000}, {339,0.000000}, {340,0.000000}, {341,0.000000}, {342,0.000000}, {343,0.000000}, {344,0.000000}, {345,0.000000}, {346,0.000000}, {347,0.000000}, {348,0.000000}, {349,0.000000}, {350,0.000000}, {351,0.000000}, {352,0.000000}, {353,0.000000}, {354,0.000000}, {355,0.000000}, {356,0.000000}, {357,0.000000}, {358,0.000000}, {359,0.000000}, {360,0.000000}, {361,0.000000}, {362,0.000000}, {363,0.000000}, {364,0.000000}, {365,0.000000}, {366,0.000000}, {367,0.000000}, {368,0.000000}, {369,0.000000}, {370,0.000000}, {371,0.000000}, {372,0.000000}, {373,0.000000}, {374,0.000000}, {375,0.000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000000}, {400,0.000000}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}};
data["big"]["Mtac2"]["pre"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000000}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000000}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000000}, {237,0.000000}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000000}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000000}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.000000}, {302,0.000000}, {303,0.000000}, {304,0.000000}, {305,0.000000}, {306,0.000000}, {307,0.000000}, {308,0.000000}, {309,0.000000}, {310,0.000000}, {311,0.000000}, {312,0.000000}, {313,0.000000}, {314,0.000000}, {315,0.000000}, {316,0.000000}, {317,0.000000}, {318,0.000000}, {319,0.000000}, {320,0.000000}, {321,0.000000}, {322,0.000000}, {323,0.000000}, {324,0.000000}, {325,0.000000}, {326,0.000000}, {327,0.000000}, {328,0.000000}, {329,0.000000}, {330,0.000000}, {331,0.000000}, {332,0.000000}, {333,0.000000}, {334,0.000000}, {335,0.000000}, {336,0.000000}, {337,0.000000}, {338,0.000000}, {339,0.000000}, {340,0.000000}, {341,0.000000}, {342,0.000000}, {343,0.000000}, {344,0.000000}, {345,0.000000}, {346,0.000000}, {347,0.000000}, {348,0.000000}, {349,0.000000}, {350,0.000000}, {351,0.000000}, {352,0.000000}, {353,0.000000}, {354,0.000000}, {355,0.000000}, {356,0.000000}, {357,0.000000}, {358,0.000000}, {359,0.000000}, {360,0.000000}, {361,0.000000}, {362,0.000000}, {363,0.000000}, {364,0.000000}, {365,0.000000}, {366,0.000000}, {367,0.000000}, {368,0.000000}, {369,0.000000}, {370,0.000000}, {371,0.000000}, {372,0.000000}, {373,0.000000}, {374,0.000000}, {375,0.000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000000}, {400,0.000000}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}};
data["big"]["Mtac2"]["pre"]["user"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000014085}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000014085}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000014085}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000014085}, {24,0.000018779}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000037559}, {34,0.000000000}, {35,0.000014085}, {36,0.000000000}, {37,0.000000000}, {38,0.000032864}, {39,0.000000000}, {40,0.000032864}, {41,0.000000000}, {42,0.000018779}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000014085}, {53,0.000000000}, {54,0.000014085}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000018779}, {59,0.000000000}, {60,0.000014085}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000032864}, {65,0.000018779}, {66,0.000000000}, {67,0.000037559}, {68,0.000000000}, {69,0.000000000}, {70,0.000014085}, {71,0.000000000}, {72,0.000000000}, {73,0.000018779}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000018779}, {79,0.000018779}, {80,0.000000000}, {81,0.000014085}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000018779}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000018779}, {93,0.000018779}, {94,0.000000000}, {95,0.000000000}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000231}, {157,0.000000}, {158,0.000231}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000231}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000000}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000000}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000000}, {237,0.000000}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000231}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000000}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000000}, {295,0.000000}, {296,0.000231}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.000000}, {302,0.000000}, {303,0.000000}, {304,0.000000}, {305,0.000000}, {306,0.000000}, {307,0.000000}, {308,0.000000}, {309,0.000000}, {310,0.000000}, {311,0.000000}, {312,0.000000}, {313,0.000000}, {314,0.000000}, {315,0.000000}, {316,0.000000}, {317,0.000000}, {318,0.000000}, {319,0.000000}, {320,0.000000}, {321,0.000000}, {322,0.000000}, {323,0.000000}, {324,0.000000}, {325,0.000000}, {326,0.000000}, {327,0.000000}, {328,0.000000}, {329,0.000000}, {330,0.000000}, {331,0.000000}, {332,0.000000}, {333,0.000000}, {334,0.000000}, {335,0.000000}, {336,0.000000}, {337,0.000000}, {338,0.000000}, {339,0.000000}, {340,0.000000}, {341,0.000000}, {342,0.000000}, {343,0.000000}, {344,0.000000}, {345,0.000000}, {346,0.000000}, {347,0.000000}, {348,0.000000}, {349,0.000000}, {350,0.000000}, {351,0.000000}, {352,0.000000}, {353,0.000000}, {354,0.000000}, {355,0.000000}, {356,0.000000}, {357,0.000000}, {358,0.000231}, {359,0.000000}, {360,0.000000}, {361,0.000000}, {362,0.000000}, {363,0.000000}, {364,0.000000}, {365,0.000000}, {366,0.000000}, {367,0.000000}, {368,0.000000}, {369,0.000000}, {370,0.000000}, {371,0.000000}, {372,0.000000}, {373,0.000000}, {374,0.000000}, {375,0.000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000231}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000000}, {400,0.000000}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000231}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}};
data["big"]["Mtac2"]["pre"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000018779}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000000}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000000}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000000}, {237,0.000000}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000000}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000000}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.000000}, {302,0.000000}, {303,0.000000}, {304,0.000000}, {305,0.000000}, {306,0.000000}, {307,0.000000}, {308,0.000000}, {309,0.000000}, {310,0.000000}, {311,0.000000}, {312,0.000000}, {313,0.000000}, {314,0.000000}, {315,0.000000}, {316,0.000000}, {317,0.000000}, {318,0.000000}, {319,0.000000}, {320,0.000000}, {321,0.000000}, {322,0.000000}, {323,0.000000}, {324,0.000000}, {325,0.000000}, {326,0.000000}, {327,0.000000}, {328,0.000000}, {329,0.000000}, {330,0.000000}, {331,0.000000}, {332,0.000000}, {333,0.000000}, {334,0.000000}, {335,0.000000}, {336,0.000000}, {337,0.000000}, {338,0.000000}, {339,0.000000}, {340,0.000000}, {341,0.000000}, {342,0.000000}, {343,0.000000}, {344,0.000000}, {345,0.000000}, {346,0.000000}, {347,0.000000}, {348,0.000000}, {349,0.000000}, {350,0.000000}, {351,0.000000}, {352,0.000000}, {353,0.000000}, {354,0.000000}, {355,0.000000}, {356,0.000000}, {357,0.000000}, {358,0.000000}, {359,0.000000}, {360,0.000000}, {361,0.000000}, {362,0.000000}, {363,0.000000}, {364,0.000000}, {365,0.000000}, {366,0.000000}, {367,0.000000}, {368,0.000000}, {369,0.000000}, {370,0.000000}, {371,0.000000}, {372,0.000000}, {373,0.000000}, {374,0.000000}, {375,0.000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000000}, {400,0.000000}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}};
data["big"]["Mtac2"]["reif"]["real"] = {{1,0.000018779}, {2,0.001018779}, {3,0.001037559}, {4,0.002028169}, {5,0.003037559}, {6,0.003525822}, {7,0.004230047}, {8,0.005253521}, {9,0.006657277}, {10,0.008056338}, {11,0.009323944}, {12,0.011089202}, {13,0.012046948}, {14,0.014042254}, {15,0.025253521}, {16,0.017093897}, {17,0.019042254}, {18,0.021065728}, {19,0.024807512}, {20,0.026314554}, {21,0.037521127}, {22,0.030816901}, {23,0.033492958}, {24,0.036356808}, {25,0.039159624}, {26,0.042201878}, {27,0.067859155}, {28,0.048586854}, {29,0.052629108}, {30,0.079849765}, {31,0.058525822}, {32,0.091483568}, {33,0.066446009}, {34,0.077746479}, {35,0.135774648}, {36,0.082206573}, {37,0.110751174}, {38,0.102821596}, {39,0.092422535}, {40,0.118971831}, {41,0.132690141}, {42,0.491258216}, {43,0.189694836}, {44,0.138624413}, {45,0.165107981}, {46,0.151394366}, {47,0.227882629}, {48,0.185103286}, {49,0.509539906}, {50,0.238652582}, {51,0.201103286}, {52,0.182868545}, {53,0.309070423}, {54,0.536596244}, {55,0.320338028}, {56,0.210892019}, {57,0.287784038}, {58,0.620694836}, {59,0.349835681}, {60,0.309154930}, {61,0.370126761}, {62,0.305638498}, {63,0.338201878}, {64,0.675915493}, {65,0.398830986}, {66,0.388431925}, {67,0.697145540}, {68,0.422962441}, {69,0.416920188}, {70,0.817957746}, {71,0.383107981}, {72,0.472291080}, {73,0.831305164}, {74,0.836906103}, {75,0.511253521}, {76,0.510539906}, {77,0.868079812}, {78,0.546990610}, {79,0.541051643}, {80,0.574075117}, {81,0.914164319}, {82,0.956798122}, {83,0.599206573}, {84,0.980934272}, {85,0.722192488}, {86,1.012323944}, {87,0.655460094}, {88,1.074967136}, {89,0.669769953}, {90,1.151558685}, {91,1.146004695}, {92,0.716450704}, {93,1.196183099}, {94,1.232591549}, {95,1.247436620}, {96,0.994154}, {97,1.160538}, {98,1.193692}, {99,1.415538}, {100,1.310077}, {101,1.017923}, {102,1.462769}, {103,1.374000}, {104,1.460615}, {105,1.561077}, {106,1.195385}, {107,1.481538}, {108,1.557923}, {109,1.967692}, {110,1.243462}, {111,1.964231}, {112,1.307231}, {113,1.148923}, {114,1.799385}, {115,1.234692}, {116,2.121692}, {117,1.850846}, {118,1.697385}, {119,1.881308}, {120,1.712923}, {121,1.978615}, {122,1.827231}, {123,1.860538}, {124,1.639846}, {125,2.443846}, {126,1.980692}, {127,1.870923}, {128,2.259692}, {129,2.509538}, {130,1.670538}, {131,2.409077}, {132,2.367385}, {133,2.201923}, {134,2.211462}, {135,2.241615}, {136,2.817923}, {137,1.964154}, {138,2.792923}, {139,2.980077}, {140,2.819923}, {141,2.933692}, {142,2.004615}, {143,3.498769}, {144,2.713538}, {145,2.441769}, {146,2.677231}, {147,3.292462}, {148,3.138846}, {149,3.282462}, {150,2.290846}, {151,3.338692}, {152,3.912846}, {153,2.842385}, {154,3.322846}, {155,3.150846}, {156,3.377385}, {157,4.146769}, {158,3.511923}, {159,3.729769}, {160,3.188000}, {161,3.687692}, {162,3.612308}, {163,4.478308}, {164,3.868538}, {165,4.369385}, {166,4.385385}, {167,4.360615}, {168,3.549077}, {169,5.232231}, {170,4.048385}, {171,4.524000}, {172,4.090154}, {173,4.546231}, {174,5.457077}, {175,4.298077}, {176,4.693385}, {177,4.973769}, {178,4.814692}, {179,4.938769}, {180,5.022769}, {181,5.549846}, {182,3.930385}, {183,5.076692}, {184,5.803846}, {185,5.748308}, {186,5.996308}, {187,5.443769}, {188,4.943385}, {189,6.165692}, {190,5.515154}, {191,4.618769}, {192,5.987692}, {193,6.227308}, {194,6.359077}, {195,6.340308}, {196,5.888846}, {197,6.002846}, {198,6.070231}, {199,6.140846}, {200,6.306385}, {201,6.203385}, {202,6.800154}, {203,6.840308}, {204,6.889692}, {205,6.903077}, {206,7.701769}, {207,6.416385}, {208,7.729846}, {209,6.648385}, {210,7.642308}, {211,7.982538}, {212,6.214000}, {213,7.837308}, {214,7.969615}, {215,7.490385}, {216,8.188692}, {217,8.004692}, {218,7.750615}, {219,7.257615}, {220,8.282615}, {221,7.244385}, {222,8.198615}, {223,8.654615}, {224,8.118308}, {225,8.205923}, {226,8.875000}, {227,9.093923}, {228,8.947154}, {229,9.625769}, {230,9.166538}, {231,9.908692}, {232,9.776154}, {233,8.374000}, {234,9.839615}, {235,10.061000}, {236,10.186769}, {237,10.728846}, {238,10.794385}, {239,10.104692}, {240,9.996385}, {241,11.290385}, {242,11.158923}, {243,11.236077}, {244,10.830000}, {245,9.969615}, {246,11.527308}, {247,11.326538}, {248,12.250462}, {249,10.914923}, {250,12.061231}, {251,11.410000}, {252,12.237154}, {253,12.973231}, {254,12.235692}, {255,13.048000}, {256,12.186769}, {257,11.298308}, {258,14.072769}, {259,10.857462}, {260,13.814538}, {261,13.114462}, {262,14.374231}, {263,12.658154}, {264,14.641923}, {265,13.590769}, {266,11.928923}, {267,14.718154}, {268,14.383385}, {269,15.777462}, {270,15.411615}, {271,15.077385}, {272,14.499308}, {273,15.541231}, {274,15.991308}, {275,15.508692}, {276,16.204000}, {277,16.219615}, {278,16.237385}, {279,16.176692}, {280,17.008231}, {281,16.385385}, {282,16.803154}, {283,17.505615}, {284,16.032538}, {285,16.626231}, {286,17.240000}, {287,18.136615}, {288,17.205846}, {289,17.635231}, {290,19.292385}, {291,17.255385}, {292,18.830077}, {293,19.388077}, {294,17.936308}, {295,18.583462}, {296,18.332077}, {297,18.612385}, {298,18.703615}, {299,18.993231}, {300,19.045846}, {301,19.039538}, {302,19.930769}, {303,18.606077}, {304,19.927462}, {305,19.224308}, {306,20.461462}, {307,16.670692}, {308,20.163154}, {309,20.404462}, {310,19.311385}, {311,20.417692}, {312,19.905462}, {313,20.487692}, {314,20.710462}, {315,21.623615}, {316,19.911308}, {317,21.206077}, {318,19.262231}, {319,22.295000}, {320,22.001846}, {321,22.849923}, {322,22.715923}, {323,23.378231}, {324,21.940769}, {325,23.015154}, {326,22.228000}, {327,22.188231}, {328,23.001769}, {329,22.386154}, {330,22.913308}, {331,23.070308}, {332,23.133462}, {333,23.214692}, {334,23.536462}, {335,23.826154}, {336,25.020846}, {337,24.504308}, {338,25.215538}, {339,23.729923}, {340,25.749615}, {341,24.309769}, {342,26.229077}, {343,25.445385}, {344,26.315308}, {345,25.715692}, {346,25.492077}, {347,26.890231}, {348,26.908615}, {349,27.982846}, {350,28.668769}, {351,28.233154}, {352,27.802308}, {353,29.254308}, {354,27.784077}, {355,28.630000}, {356,29.624000}, {357,30.617692}, {358,29.540231}, {359,28.374385}, {360,29.786462}, {361,28.832385}, {362,30.713077}, {363,30.282692}, {364,31.928385}, {365,30.942308}, {366,31.305308}, {367,31.401769}, {368,31.242538}, {369,30.534923}, {370,31.049538}, {371,31.721231}, {372,32.567769}, {373,32.696154}, {374,32.578923}, {375,32.888077}, {376,32.827846}, {377,32.726385}, {378,32.219231}, {379,33.160077}, {380,34.162000}, {381,34.569308}, {382,33.964846}, {383,34.440000}, {384,35.455538}, {385,34.462769}, {386,34.444923}, {387,34.803538}, {388,34.863769}, {389,35.706154}, {390,36.049462}, {391,36.147846}, {392,36.270538}, {393,36.879000}, {394,37.915769}, {395,37.540385}, {396,36.417769}, {397,37.241615}, {398,37.046615}, {399,37.865231}, {400,38.054462}, {401,39.367000}, {402,38.897923}, {403,38.737538}, {404,40.256462}, {405,39.442000}, {406,40.325308}, {407,40.368231}, {408,40.351077}, {409,40.268308}, {410,41.353692}, {411,39.865000}, {412,41.285308}, {413,40.906385}, {414,41.157462}, {415,42.464231}, {416,41.703538}, {417,42.742385}, {418,42.867385}, {419,42.694308}, {420,42.750077}, {421,43.795308}, {422,43.947692}, {423,45.549538}, {424,45.626308}, {425,44.761538}, {426,45.951615}, {427,45.874615}, {428,45.256000}, {429,46.949692}, {430,47.778692}, {431,47.948538}, {432,49.209615}, {433,48.176231}, {434,48.701231}, {435,48.685000}, {436,49.841231}, {437,47.257077}, {438,49.269077}, {439,49.246846}, {440,50.667385}, {441,49.635769}, {442,51.179538}, {443,51.875077}, {444,51.284462}, {445,50.897385}, {446,53.951615}, {447,53.536077}, {448,53.806154}, {449,52.325462}, {450,55.729615}};
data["big"]["Mtac2"]["reif"]["user"] = {{1,0.000779343}, {2,0.001023474}, {3,0.001690141}, {4,0.002192488}, {5,0.002830986}, {6,0.003694836}, {7,0.004478873}, {8,0.005399061}, {9,0.006521127}, {10,0.007723005}, {11,0.009525822}, {12,0.011553991}, {13,0.012488263}, {14,0.014037559}, {15,0.025563380}, {16,0.017178404}, {17,0.018901408}, {18,0.020962441}, {19,0.024464789}, {20,0.026220657}, {21,0.037328638}, {22,0.030370892}, {23,0.033295775}, {24,0.036220657}, {25,0.039018779}, {26,0.041840376}, {27,0.067004695}, {28,0.048032864}, {29,0.052342723}, {30,0.079680751}, {31,0.058483568}, {32,0.090802817}, {33,0.066023474}, {34,0.077530516}, {35,0.135863850}, {36,0.082051643}, {37,0.110483568}, {38,0.102492958}, {39,0.091920188}, {40,0.118629108}, {41,0.132492958}, {42,0.489178404}, {43,0.189502347}, {44,0.138220657}, {45,0.164877934}, {46,0.151262911}, {47,0.225239437}, {48,0.181582160}, {49,0.508244131}, {50,0.238211268}, {51,0.200981221}, {52,0.182737089}, {53,0.306122066}, {54,0.535370892}, {55,0.320272300}, {56,0.211093897}, {57,0.285835681}, {58,0.619323944}, {59,0.349469484}, {60,0.308943662}, {61,0.369610329}, {62,0.305539906}, {63,0.333347418}, {64,0.672464789}, {65,0.398455399}, {66,0.382183099}, {67,0.694309859}, {68,0.422647887}, {69,0.408676056}, {70,0.816004695}, {71,0.380253521}, {72,0.464600939}, {73,0.830112676}, {74,0.830755869}, {75,0.509746479}, {76,0.503061033}, {77,0.866953052}, {78,0.540600939}, {79,0.536976526}, {80,0.569295775}, {81,0.912971831}, {82,0.950591549}, {83,0.595751174}, {84,0.971000000}, {85,0.716685446}, {86,1.005488263}, {87,0.644361502}, {88,1.069446009}, {89,0.665910798}, {90,1.146544601}, {91,1.132676056}, {92,0.708075117}, {93,1.186065728}, {94,1.226995305}, {95,1.240967136}, {96,0.988615}, {97,1.152308}, {98,1.187769}, {99,1.411154}, {100,1.295077}, {101,1.011077}, {102,1.456308}, {103,1.367077}, {104,1.449154}, {105,1.549538}, {106,1.184385}, {107,1.469000}, {108,1.547769}, {109,1.953308}, {110,1.229231}, {111,1.950769}, {112,1.295462}, {113,1.141462}, {114,1.790538}, {115,1.210923}, {116,2.109923}, {117,1.840000}, {118,1.687462}, {119,1.872923}, {120,1.702462}, {121,1.960308}, {122,1.815231}, {123,1.851154}, {124,1.619385}, {125,2.426538}, {126,1.956538}, {127,1.857000}, {128,2.252538}, {129,2.481769}, {130,1.652769}, {131,2.386231}, {132,2.353000}, {133,2.187538}, {134,2.185615}, {135,2.230231}, {136,2.792385}, {137,1.948077}, {138,2.769000}, {139,2.956692}, {140,2.790846}, {141,2.908385}, {142,1.982000}, {143,3.472846}, {144,2.686077}, {145,2.414462}, {146,2.657615}, {147,3.279385}, {148,3.115462}, {149,3.255615}, {150,2.269308}, {151,3.302462}, {152,3.881538}, {153,2.811385}, {154,3.299692}, {155,3.117154}, {156,3.335923}, {157,4.113077}, {158,3.487077}, {159,3.696154}, {160,3.153308}, {161,3.646385}, {162,3.574385}, {163,4.452077}, {164,3.838615}, {165,4.333154}, {166,4.336615}, {167,4.317308}, {168,3.517846}, {169,5.195154}, {170,4.006231}, {171,4.465385}, {172,4.056308}, {173,4.491846}, {174,5.398308}, {175,4.252923}, {176,4.628692}, {177,4.905846}, {178,4.739769}, {179,4.873231}, {180,4.968692}, {181,5.485385}, {182,3.897385}, {183,5.008308}, {184,5.735231}, {185,5.697769}, {186,5.946538}, {187,5.385462}, {188,4.894000}, {189,6.093154}, {190,5.448077}, {191,4.570923}, {192,5.917000}, {193,6.146154}, {194,6.292538}, {195,6.257000}, {196,5.828462}, {197,5.932231}, {198,6.015769}, {199,6.087846}, {200,6.250615}, {201,6.141077}, {202,6.708615}, {203,6.767077}, {204,6.797154}, {205,6.815462}, {206,7.597692}, {207,6.340154}, {208,7.635385}, {209,6.587385}, {210,7.568692}, {211,7.884077}, {212,6.128385}, {213,7.744308}, {214,7.878692}, {215,7.400385}, {216,8.089154}, {217,7.901231}, {218,7.674769}, {219,7.176154}, {220,8.166923}, {221,7.177385}, {222,8.098692}, {223,8.538769}, {224,8.048077}, {225,8.125000}, {226,8.761385}, {227,8.978077}, {228,8.821462}, {229,9.515231}, {230,9.044385}, {231,9.793923}, {232,9.657231}, {233,8.281154}, {234,9.733000}, {235,9.934615}, {236,10.052000}, {237,10.613154}, {238,10.683923}, {239,9.983308}, {240,9.877000}, {241,11.158846}, {242,11.047538}, {243,11.104462}, {244,10.718308}, {245,9.854462}, {246,11.394308}, {247,11.187000}, {248,12.106923}, {249,10.801385}, {250,11.921077}, {251,11.249846}, {252,12.080385}, {253,12.825769}, {254,12.086538}, {255,12.896538}, {256,12.070615}, {257,11.177000}, {258,13.919538}, {259,10.729538}, {260,13.647692}, {261,12.956692}, {262,14.207077}, {263,12.539231}, {264,14.481000}, {265,13.458000}, {266,11.783769}, {267,14.558923}, {268,14.212077}, {269,15.618385}, {270,15.246692}, {271,14.916923}, {272,14.327462}, {273,15.376846}, {274,15.809538}, {275,15.332846}, {276,16.030077}, {277,16.044846}, {278,16.069308}, {279,15.989462}, {280,16.818462}, {281,16.230615}, {282,16.617692}, {283,17.325538}, {284,15.849385}, {285,16.463308}, {286,17.046923}, {287,17.937769}, {288,17.005385}, {289,17.415769}, {290,19.068769}, {291,17.091923}, {292,18.617538}, {293,19.176308}, {294,17.720615}, {295,18.352231}, {296,18.121308}, {297,18.398769}, {298,18.473538}, {299,18.780538}, {300,18.814000}, {301,18.785923}, {302,19.687615}, {303,18.419154}, {304,19.704154}, {305,18.976154}, {306,20.208538}, {307,16.483769}, {308,19.937308}, {309,20.155769}, {310,19.087692}, {311,20.196308}, {312,19.655385}, {313,20.244769}, {314,20.459154}, {315,21.380615}, {316,19.689000}, {317,20.958923}, {318,19.002077}, {319,22.014538}, {320,21.727846}, {321,22.610692}, {322,22.501000}, {323,23.150000}, {324,21.729692}, {325,22.752923}, {326,21.951923}, {327,21.930385}, {328,22.700923}, {329,22.106769}, {330,22.616692}, {331,22.777923}, {332,22.842077}, {333,22.911308}, {334,23.226615}, {335,23.558462}, {336,24.736923}, {337,24.260308}, {338,24.949077}, {339,23.403231}, {340,25.449692}, {341,23.964538}, {342,25.923538}, {343,25.114385}, {344,25.962846}, {345,25.369538}, {346,25.206615}, {347,26.565615}, {348,26.580615}, {349,27.699769}, {350,28.369538}, {351,27.917154}, {352,27.474000}, {353,28.931692}, {354,27.437462}, {355,28.273308}, {356,29.306615}, {357,30.294154}, {358,29.211846}, {359,28.034462}, {360,29.454308}, {361,28.476385}, {362,30.378615}, {363,29.926077}, {364,31.589538}, {365,30.610231}, {366,30.976692}, {367,31.054923}, {368,30.874462}, {369,30.152615}, {370,30.664692}, {371,31.339000}, {372,32.202692}, {373,32.338769}, {374,32.235692}, {375,32.538462}, {376,32.466385}, {377,32.323154}, {378,31.852308}, {379,32.783462}, {380,33.738231}, {381,34.197692}, {382,33.587231}, {383,34.064462}, {384,35.088000}, {385,34.077000}, {386,34.075077}, {387,34.412538}, {388,34.485846}, {389,35.287769}, {390,35.685077}, {391,35.741923}, {392,35.851462}, {393,36.458308}, {394,37.519923}, {395,37.144308}, {396,35.998462}, {397,36.835077}, {398,36.665769}, {399,37.438462}, {400,37.619154}, {401,38.931077}, {402,38.470000}, {403,38.264846}, {404,39.835385}, {405,39.013385}, {406,39.883538}, {407,39.910769}, {408,39.914615}, {409,39.855077}, {410,40.893231}, {411,39.393462}, {412,40.809462}, {413,40.407846}, {414,40.659538}, {415,41.959462}, {416,41.245385}, {417,42.232846}, {418,42.416077}, {419,42.205462}, {420,42.249462}, {421,43.313154}, {422,43.454615}, {423,45.067538}, {424,45.162000}, {425,44.281077}, {426,45.428385}, {427,45.379923}, {428,44.789231}, {429,46.425154}, {430,47.267000}, {431,47.462231}, {432,48.721769}, {433,47.673615}, {434,48.185615}, {435,48.168000}, {436,49.300538}, {437,46.764769}, {438,48.796154}, {439,48.767077}, {440,50.065538}, {441,49.108308}, {442,50.659308}, {443,51.323462}, {444,50.730846}, {445,50.345923}, {446,53.418231}, {447,52.995615}, {448,53.304308}, {449,51.772154}, {450,55.173308}};
data["big"]["Mtac2"]["reif"]["system"] = {{1,0.000000000}, {2,0.000018779}, {3,0.000028169}, {4,0.000000000}, {5,0.000056338}, {6,0.000018779}, {7,0.000075117}, {8,0.000051643}, {9,0.000000000}, {10,0.000056338}, {11,0.000056338}, {12,0.000089202}, {13,0.000093897}, {14,0.000032864}, {15,0.000000000}, {16,0.000070423}, {17,0.000018779}, {18,0.000093897}, {19,0.000535211}, {20,0.000305164}, {21,0.000431925}, {22,0.000403756}, {23,0.000305164}, {24,0.000366197}, {25,0.000370892}, {26,0.000389671}, {27,0.000596244}, {28,0.000666667}, {29,0.000281690}, {30,0.000089202}, {31,0.000070423}, {32,0.000089202}, {33,0.000075117}, {34,0.000018779}, {35,0.000032864}, {36,0.000037559}, {37,0.000037559}, {38,0.000037559}, {39,0.000319249}, {40,0.000107981}, {41,0.000112676}, {42,0.002230047}, {43,0.000075117}, {44,0.000323944}, {45,0.000230047}, {46,0.000197183}, {47,0.002136150}, {48,0.003380282}, {49,0.001079812}, {50,0.000070423}, {51,0.000018779}, {52,0.000197183}, {53,0.002671362}, {54,0.001079812}, {55,0.000093897}, {56,0.000037559}, {57,0.002051643}, {58,0.001352113}, {59,0.000145540}, {60,0.000056338}, {61,0.000056338}, {62,0.000084507}, {63,0.004676056}, {64,0.003018779}, {65,0.000126761}, {66,0.005995305}, {67,0.002455399}, {68,0.000103286}, {69,0.008000000}, {70,0.001596244}, {71,0.002591549}, {72,0.007009390}, {73,0.001051643}, {74,0.005727700}, {75,0.001093897}, {76,0.007056338}, {77,0.000727700}, {78,0.006164319}, {79,0.003807512}, {80,0.004328638}, {81,0.000943662}, {82,0.005868545}, {83,0.003126761}, {84,0.009549296}, {85,0.004849765}, {86,0.006295775}, {87,0.010821596}, {88,0.005014085}, {89,0.003760563}, {90,0.004835681}, {91,0.012976526}, {92,0.007812207}, {93,0.009384977}, {94,0.005183099}, {95,0.006192488}, {96,0.005769}, {97,0.008538}, {98,0.006385}, {99,0.003923}, {100,0.014077}, {101,0.007231}, {102,0.007385}, {103,0.006385}, {104,0.010615}, {105,0.012154}, {106,0.011308}, {107,0.012846}, {108,0.009769}, {109,0.013769}, {110,0.013692}, {111,0.013231}, {112,0.011538}, {113,0.007615}, {114,0.008308}, {115,0.023231}, {116,0.011846}, {117,0.010769}, {118,0.009538}, {119,0.009769}, {120,0.010692}, {121,0.018000}, {122,0.011769}, {123,0.009538}, {124,0.019308}, {125,0.016846}, {126,0.024385}, {127,0.014077}, {128,0.007385}, {129,0.026923}, {130,0.016692}, {131,0.022385}, {132,0.013846}, {133,0.014385}, {134,0.025154}, {135,0.011077}, {136,0.024692}, {137,0.016923}, {138,0.024538}, {139,0.023846}, {140,0.027846}, {141,0.024231}, {142,0.023385}, {143,0.026000}, {144,0.028000}, {145,0.026846}, {146,0.018615}, {147,0.013077}, {148,0.022769}, {149,0.027000}, {150,0.021846}, {151,0.036538}, {152,0.030154}, {153,0.030385}, {154,0.023077}, {155,0.032923}, {156,0.040538}, {157,0.034077}, {158,0.024462}, {159,0.033154}, {160,0.034385}, {161,0.040462}, {162,0.037154}, {163,0.026615}, {164,0.029923}, {165,0.035615}, {166,0.048692}, {167,0.043308}, {168,0.030692}, {169,0.036846}, {170,0.042231}, {171,0.057846}, {172,0.033615}, {173,0.054000}, {174,0.058769}, {175,0.045308}, {176,0.065154}, {177,0.066308}, {178,0.073923}, {179,0.064923}, {180,0.054385}, {181,0.064846}, {182,0.033077}, {183,0.067769}, {184,0.068538}, {185,0.050692}, {186,0.049769}, {187,0.057538}, {188,0.048923}, {189,0.072692}, {190,0.066077}, {191,0.047231}, {192,0.069769}, {193,0.080385}, {194,0.066462}, {195,0.082846}, {196,0.059615}, {197,0.068846}, {198,0.054154}, {199,0.052769}, {200,0.055692}, {201,0.061692}, {202,0.090692}, {203,0.073769}, {204,0.092692}, {205,0.086923}, {206,0.103846}, {207,0.075308}, {208,0.093769}, {209,0.061077}, {210,0.072231}, {211,0.098615}, {212,0.085308}, {213,0.092769}, {214,0.091385}, {215,0.089615}, {216,0.098692}, {217,0.102692}, {218,0.075769}, {219,0.080769}, {220,0.115692}, {221,0.066846}, {222,0.100000}, {223,0.115000}, {224,0.069846}, {225,0.079231}, {226,0.112538}, {227,0.115154}, {228,0.125154}, {229,0.109615}, {230,0.122000}, {231,0.114385}, {232,0.118692}, {233,0.092462}, {234,0.106615}, {235,0.125615}, {236,0.134385}, {237,0.116000}, {238,0.110308}, {239,0.120923}, {240,0.118231}, {241,0.130769}, {242,0.110385}, {243,0.131000}, {244,0.111000}, {245,0.115615}, {246,0.132154}, {247,0.138308}, {248,0.143538}, {249,0.112692}, {250,0.139538}, {251,0.159538}, {252,0.155538}, {253,0.146692}, {254,0.148154}, {255,0.150000}, {256,0.115462}, {257,0.120615}, {258,0.152385}, {259,0.127538}, {260,0.165308}, {261,0.157692}, {262,0.166000}, {263,0.117385}, {264,0.160000}, {265,0.132692}, {266,0.145077}, {267,0.159000}, {268,0.170308}, {269,0.158692}, {270,0.164462}, {271,0.160231}, {272,0.171308}, {273,0.164077}, {274,0.181077}, {275,0.176000}, {276,0.173538}, {277,0.174308}, {278,0.167077}, {279,0.186385}, {280,0.190385}, {281,0.152692}, {282,0.184462}, {283,0.179462}, {284,0.183308}, {285,0.162077}, {286,0.192846}, {287,0.197692}, {288,0.200308}, {289,0.218308}, {290,0.222308}, {291,0.161769}, {292,0.213154}, {293,0.210462}, {294,0.213923}, {295,0.230615}, {296,0.209923}, {297,0.212462}, {298,0.228923}, {299,0.211308}, {300,0.230769}, {301,0.252077}, {302,0.241000}, {303,0.186000}, {304,0.220923}, {305,0.246538}, {306,0.250385}, {307,0.185462}, {308,0.223231}, {309,0.246615}, {310,0.221692}, {311,0.219462}, {312,0.250231}, {313,0.241692}, {314,0.251462}, {315,0.242538}, {316,0.220769}, {317,0.246308}, {318,0.259846}, {319,0.280077}, {320,0.273154}, {321,0.238308}, {322,0.214538}, {323,0.227692}, {324,0.210769}, {325,0.262154}, {326,0.275077}, {327,0.256154}, {328,0.300154}, {329,0.278846}, {330,0.293769}, {331,0.291462}, {332,0.288846}, {333,0.300769}, {334,0.308077}, {335,0.265692}, {336,0.281154}, {337,0.241385}, {338,0.264308}, {339,0.324615}, {340,0.298077}, {341,0.342231}, {342,0.303615}, {343,0.328385}, {344,0.350462}, {345,0.343692}, {346,0.284077}, {347,0.322615}, {348,0.326846}, {349,0.282923}, {350,0.299385}, {351,0.315615}, {352,0.327154}, {353,0.321231}, {354,0.345615}, {355,0.357077}, {356,0.317385}, {357,0.322769}, {358,0.328000}, {359,0.339154}, {360,0.331462}, {361,0.355923}, {362,0.334308}, {363,0.355538}, {364,0.339000}, {365,0.331077}, {366,0.327538}, {367,0.346308}, {368,0.367000}, {369,0.382231}, {370,0.383769}, {371,0.380462}, {372,0.362846}, {373,0.356462}, {374,0.342385}, {375,0.349077}, {376,0.360000}, {377,0.402769}, {378,0.365462}, {379,0.374462}, {380,0.420846}, {381,0.368231}, {382,0.374923}, {383,0.371923}, {384,0.364846}, {385,0.383538}, {386,0.369000}, {387,0.390692}, {388,0.376385}, {389,0.417923}, {390,0.363846}, {391,0.405538}, {392,0.419000}, {393,0.420077}, {394,0.393538}, {395,0.395308}, {396,0.418615}, {397,0.405615}, {398,0.379692}, {399,0.426308}, {400,0.434769}, {401,0.434231}, {402,0.426462}, {403,0.471769}, {404,0.421000}, {405,0.427231}, {406,0.441000}, {407,0.456231}, {408,0.435231}, {409,0.411769}, {410,0.460000}, {411,0.470615}, {412,0.476000}, {413,0.496308}, {414,0.496077}, {415,0.503000}, {416,0.456923}, {417,0.506923}, {418,0.449923}, {419,0.488692}, {420,0.500462}, {421,0.478538}, {422,0.489385}, {423,0.481000}, {424,0.463077}, {425,0.479769}, {426,0.522615}, {427,0.492923}, {428,0.464231}, {429,0.523462}, {430,0.510769}, {431,0.485462}, {432,0.487154}, {433,0.500846}, {434,0.514923}, {435,0.515692}, {436,0.540154}, {437,0.491385}, {438,0.472000}, {439,0.478462}, {440,0.600923}, {441,0.526769}, {442,0.519846}, {443,0.550846}, {444,0.552692}, {445,0.549769}, {446,0.532462}, {447,0.540231}, {448,0.499692}, {449,0.550462}, {450,0.550769}};
data["big"]["OCaml"]["Aggregate"]["real"] = {{1,0.00100000}, {2,0.00061261}, {3,0.00072973}, {4,0.00090090}, {5,0.00099099}, {6,0.00100000}, {7,0.00100000}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00100000}, {16,0.00100000}, {17,0.00100000}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00100000}, {23,0.00100000}, {24,0.00100000}, {25,0.00100000}, {26,0.00186486}, {27,0.00100000}, {28,0.00100000}, {29,0.00100000}, {30,0.00100000}, {31,0.00100000}, {32,0.00100000}, {33,0.00100000}, {34,0.00101802}, {35,0.00100000}, {36,0.00100000}, {37,0.00100000}, {38,0.00100000}, {39,0.00100000}, {40,0.00100000}, {41,0.00100000}, {42,0.00100000}, {43,0.00100000}, {44,0.00100000}, {45,0.00100000}, {46,0.00100000}, {47,0.00100000}, {48,0.00100000}, {49,0.00100901}, {50,0.00101802}, {51,0.00102703}, {52,0.00101802}, {53,0.00104505}, {54,0.00109009}, {55,0.00107207}, {56,0.00114414}, {57,0.00120721}, {58,0.01518018}, {59,0.00104505}, {60,0.00109009}, {61,0.00110811}, {62,0.00124324}, {63,0.00126126}, {64,0.00125225}, {65,0.00147748}, {66,0.00152252}, {67,0.00166667}, {68,0.00181081}, {69,0.00181982}, {70,0.00188288}, {71,0.00191892}, {72,0.00196396}, {73,0.00198198}, {74,0.00199099}, {75,0.00200000}, {76,0.00200000}, {77,0.00200000}, {78,0.00200000}, {79,0.00201802}, {80,0.00200000}, {81,0.00200000}, {82,0.00200000}, {83,0.00200000}, {84,0.00200000}, {85,0.00200000}, {86,0.00200000}, {87,0.00200000}, {88,0.00200000}, {89,0.00200000}, {90,0.00200000}, {91,0.00200000}, {92,0.00200000}, {93,0.00200000}, {94,0.00200000}, {95,0.00200000}, {96,0.00200000}, {97,0.00200000}, {98,0.00200000}, {99,0.00200000}, {100,0.00302703}, {101,0.00200000}, {102,0.00200000}, {103,0.00200000}, {104,0.00200000}, {105,0.00200000}, {106,0.00200000}, {107,0.00200901}, {108,0.00201802}, {109,0.00204505}, {110,0.00201802}, {111,0.00204505}, {112,0.00207207}, {113,0.00209009}, {114,0.00210811}, {115,0.00213514}, {116,0.00209009}, {117,0.00207207}, {118,0.00208108}, {119,0.00209910}, {120,0.00211712}, {121,0.00211712}, {122,0.00212613}, {123,0.00217117}, {124,0.00219820}, {125,0.00218919}, {126,0.00222523}, {127,0.00221622}, {128,0.00222523}, {129,0.00228829}, {130,0.00238739}, {131,0.00242342}, {132,0.00254054}, {133,0.00272072}, {134,0.00272072}, {135,0.00272072}, {136,0.00280180}, {137,0.00281982}, {138,0.00286486}, {139,0.00290991}, {140,0.00294595}, {141,0.00297297}, {142,0.00298198}, {143,0.00299099}, {144,0.00300000}, {145,0.00300000}, {146,0.00301802}, {147,0.00300000}, {148,0.00300000}, {149,0.00300000}, {150,0.00300000}, {151,0.00301802}, {152,0.00302703}, {153,0.00300000}, {154,0.00300000}, {155,0.00300000}, {156,0.00300000}, {157,0.00300000}, {158,0.00300000}, {159,0.00300000}, {160,0.00403604}, {161,0.00300901}, {162,0.00300000}, {163,0.00300000}, {164,0.00300000}, {165,0.00300901}, {166,0.00300901}, {167,0.00302703}, {168,0.00303604}, {169,0.00303604}, {170,0.00307207}, {171,0.00311712}, {172,0.00305405}, {173,0.00305405}, {174,0.00308108}, {175,0.00308108}, {176,0.00311712}, {177,0.00311712}, {178,0.00311712}, {179,0.00308108}, {180,0.00304505}, {181,0.00309009}, {182,0.00305405}, {183,0.00308108}, {184,0.00498198}, {185,0.00306306}, {186,0.00308108}, {187,0.00312613}, {188,0.00311712}, {189,0.00312613}, {190,0.00316216}, {191,0.00316216}, {192,0.00321622}, {193,0.00326126}, {194,0.00334234}, {195,0.00343243}, {196,0.00345045}, {197,0.00354054}, {198,0.00362162}, {199,0.00367568}, {200,0.00372072}, {201,0.00372072}, {202,0.00372072}, {203,0.00378378}, {204,0.00381081}, {205,0.00385586}, {206,0.00476577}, {207,0.00389189}, {208,0.00391892}, {209,0.00398198}, {210,0.00397297}, {211,0.00399099}, {212,0.00399099}, {213,0.00399099}, {214,0.00400000}, {215,0.00403604}, {216,0.00400000}, {217,0.00400000}, {218,0.00400000}, {219,0.00400000}, {220,0.00400000}, {221,0.00400000}, {222,0.00400901}, {223,0.00400901}, {224,0.00400000}, {225,0.00400901}, {226,0.00509009}, {227,0.00401802}, {228,0.00403604}, {229,0.00404505}, {230,0.00401802}, {231,0.00401802}, {232,0.00403604}, {233,0.00404505}, {234,0.00405405}, {235,0.00406306}, {236,0.00405405}, {237,0.00403604}, {238,0.00407207}, {239,0.00405405}, {240,0.00409009}, {241,0.00409009}, {242,0.00408108}, {243,0.00409910}, {244,0.00408108}, {245,0.00506306}, {246,0.00404505}, {247,0.00407207}, {248,0.00410811}, {249,0.00413514}, {250,0.00416216}, {251,0.00419820}, {252,0.00418018}, {253,0.00422523}, {254,0.00419820}, {255,0.00427027}, {256,0.00433333}, {257,0.00434234}, {258,0.00437838}, {259,0.00439640}, {260,0.00448649}, {261,0.00453153}, {262,0.00572973}, {263,0.00458559}, {264,0.00460360}, {265,0.00459459}, {266,0.00463964}, {267,0.00464865}, {268,0.00465766}, {269,0.00471171}, {270,0.00472072}, {271,0.00474775}, {272,0.00479279}, {273,0.00481081}, {274,0.00488288}, {275,0.00487387}, {276,0.00489189}, {277,0.00493694}, {278,0.00494595}, {279,0.00606306}, {280,0.00499099}, {281,0.00498198}, {282,0.00500901}, {283,0.00500000}, {284,0.00500000}, {285,0.00500901}, {286,0.00503604}, {287,0.00500901}, {288,0.00500901}, {289,0.00500901}, {290,0.00500901}, {291,0.00502703}, {292,0.00502703}, {293,0.00500901}, {294,0.00502703}, {295,0.00577477}, {296,0.00502703}, {297,0.00503604}, {298,0.00503604}, {299,0.00505405}, {300,0.00504505}, {301,0.00501802}, {302,0.00505405}, {303,0.00508108}, {304,0.00502703}, {305,0.00507207}, {306,0.00505405}, {307,0.00504505}, {308,0.00507207}, {309,0.00505405}, {310,0.00596396}, {311,0.00507207}, {312,0.00510811}, {313,0.00509009}, {314,0.00509910}, {315,0.00518018}, {316,0.00517117}, {317,0.00521622}, {318,0.00522523}, {319,0.00525225}, {320,0.00529730}, {321,0.00529730}, {322,0.00527027}, {323,0.00536937}, {324,0.00671171}, {325,0.00542342}, {326,0.00545946}, {327,0.00546847}, {328,0.00547748}, {329,0.00561261}, {330,0.00556757}, {331,0.00567568}, {332,0.00564865}, {333,0.00567568}, {334,0.00563964}, {335,0.00568468}, {336,0.00570270}, {337,0.00572973}, {338,0.00688288}, {339,0.00572072}, {340,0.00571171}, {341,0.00572072}, {342,0.00580180}, {343,0.00581081}, {344,0.00581982}, {345,0.00581982}, {346,0.00585586}, {347,0.00593694}, {348,0.00596396}, {349,0.00594595}, {350,0.00593694}, {351,0.00598198}, {352,0.00600901}, {353,0.00600000}, {354,0.00600901}, {355,0.00600901}, {356,0.00600901}, {357,0.00601802}, {358,0.00603604}, {359,0.00601802}, {360,0.00600901}, {361,0.00601802}, {362,0.00600901}, {363,0.00600000}, {364,0.00601802}, {365,0.00602703}, {366,0.00603604}, {367,0.00605405}, {368,0.00604505}, {369,0.00603604}, {370,0.00609009}, {371,0.00607207}, {372,0.00604505}, {373,0.00604505}, {374,0.00607207}, {375,0.00607207}, {376,0.00608108}, {377,0.00863063}, {378,0.00608108}, {379,0.00612613}, {380,0.00610811}, {381,0.00612613}, {382,0.00616216}, {383,0.00624324}, {384,0.00622523}, {385,0.00623423}, {386,0.00632432}, {387,0.00629730}, {388,0.00634234}, {389,0.00862162}, {390,0.00639640}, {391,0.00650450}, {392,0.00644144}, {393,0.00650450}, {394,0.00648649}, {395,0.00654054}, {396,0.00657658}, {397,0.00662162}, {398,0.00663063}, {399,0.00661261}, {400,0.00667568}, {401,0.00854955}, {402,0.00667568}, {403,0.00669369}, {404,0.00668468}, {405,0.00667568}, {406,0.00669369}, {407,0.00676577}, {408,0.00679279}, {409,0.00680180}, {410,0.00681081}, {411,0.00684685}, {412,0.00680180}, {413,0.00776577}, {414,0.00683784}, {415,0.00682883}, {416,0.00685586}, {417,0.00693694}, {418,0.00697297}, {419,0.00698198}, {420,0.00698198}, {421,0.00701802}, {422,0.00699099}, {423,0.00700000}, {424,0.00855856}, {425,0.00702703}, {426,0.00704505}, {427,0.00702703}, {428,0.00702703}, {429,0.00707207}, {430,0.00705405}, {431,0.00704505}, {432,0.00707207}, {433,0.00707207}, {434,0.00707207}, {435,0.00884685}, {436,0.00709009}, {437,0.00709910}, {438,0.00706306}, {439,0.00711712}, {440,0.00712613}, {441,0.00709910}, {442,0.00709910}, {443,0.00718018}, {444,0.00715315}, {445,0.00718018}, {446,0.01032432}, {447,0.00724324}, {448,0.00722523}, {449,0.00720721}, {450,0.00728829}, {451,0.00733333}, {452,0.00736937}, {453,0.00738739}, {454,0.00738739}, {455,0.00743243}, {456,0.00749550}, {457,0.00747748}, {458,0.00751351}, {459,0.00754054}, {460,0.00755856}, {461,0.00760360}, {462,0.00762162}, {463,0.00762162}, {464,0.00763964}, {465,0.00763063}, {466,0.00762162}, {467,0.00884685}, {468,0.00770270}, {469,0.00771171}, {470,0.00766667}, {471,0.00772973}, {472,0.00772072}, {473,0.00771171}, {474,0.00772072}, {475,0.00770270}, {476,0.00778378}, {477,0.01058559}, {478,0.00781982}, {479,0.00780180}, {480,0.00787387}, {481,0.00782883}, {482,0.00789189}, {483,0.00784685}, {484,0.00789189}, {485,0.00788288}, {486,0.00791892}, {487,0.01107207}, {488,0.00789189}, {489,0.00797297}, {490,0.00800000}, {491,0.00801802}, {492,0.00795495}, {493,0.00800901}, {494,0.00803604}, {495,0.00806306}, {496,0.00806306}, {497,0.00936036}, {498,0.00805405}, {499,0.00812613}, {500,0.00814414}, {505,0.00818018}, {510,0.00826126}, {515,0.00836937}, {520,0.00849550}, {525,0.00854955}, {530,0.01155856}, {535,0.00867568}, {540,0.00871171}, {545,0.00880180}, {550,0.00887387}, {555,0.00895495}, {560,0.00903604}, {565,0.00917117}, {570,0.00919820}, {575,0.01197297}, {580,0.00943243}, {585,0.00952252}, {590,0.00960360}, {595,0.00967568}, {600,0.00969369}, {605,0.00976577}, {610,0.00983784}, {615,0.01253153}, {620,0.00995495}, {625,0.01009009}, {630,0.01017117}, {635,0.01031532}, {640,0.01037838}, {645,0.01051351}, {650,0.01055856}, {655,0.01163964}, {660,0.01071171}, {665,0.01074775}, {670,0.01088288}, {675,0.01092793}, {680,0.01098198}, {685,0.01115315}, {690,0.01372973}, {695,0.01130631}, {700,0.01141441}, {705,0.01152252}, {710,0.01155856}, {715,0.01167568}, {720,0.01171171}, {725,0.01552252}, {730,0.01179279}, {735,0.01188288}, {740,0.01206306}, {745,0.01215315}, {750,0.01225225}, {755,0.01229730}, {760,0.01467568}, {765,0.01250450}, {770,0.01254955}, {775,0.01273874}, {780,0.01273874}, {785,0.01270270}, {790,0.01643243}, {795,0.01296396}, {800,0.01302703}, {805,0.01322523}, {810,0.01322523}, {815,0.01344144}, {820,0.01715315}, {825,0.01354955}, {830,0.01364865}, {835,0.01380180}, {840,0.01378378}, {845,0.01383784}, {850,0.01774775}, {855,0.01396396}, {860,0.01411712}, {865,0.01427027}, {870,0.01433333}, {875,0.01436937}, {880,0.01945045}, {885,0.01464865}, {890,0.01477477}, {895,0.01482883}, {900,0.01490090}, {905,0.01490991}, {910,0.01599099}, {915,0.01513514}, {920,0.01526126}, {925,0.01529730}, {930,0.01547748}, {935,0.02100901}, {940,0.01566667}, {945,0.01571171}, {950,0.01581081}, {955,0.01597297}, {960,0.02039640}, {965,0.01597297}, {970,0.01607207}, {975,0.01613514}, {980,0.01631532}, {985,0.02113514}, {990,0.01661261}, {995,0.01654955}, {1000,0.01687387}, {1010,0.01694595}, {1020,0.02199099}, {1030,0.01721622}, {1040,0.01738739}, {1050,0.01754955}, {1060,0.01775676}, {1070,0.02206306}, {1080,0.01829730}, {1090,0.01865766}, {1100,0.01865766}, {1110,0.01877477}, {1120,0.02309910}, {1130,0.01919820}, {1140,0.01947748}, {1150,0.01963063}, {1160,0.02398198}, {1170,0.02008108}, {1180,0.02043243}, {1190,0.02043243}, {1200,0.02071171}, {1210,0.02081081}, {1220,0.02130631}, {1230,0.02143243}, {1240,0.02160360}, {1250,0.02325225}, {1260,0.02209910}, {1270,0.02217117}, {1280,0.02247748}, {1290,0.02346847}, {1300,0.02305405}, {1310,0.02285586}, {1320,0.02336937}, {1330,0.02343243}, {1340,0.02374775}, {1350,0.02401802}, {1360,0.02996396}, {1370,0.02451351}, {1380,0.02458559}, {1390,0.02483784}, {1400,0.03016216}, {1410,0.02528829}, {1420,0.02559459}, {1430,0.02601802}, {1440,0.02648649}, {1450,0.02625225}, {1460,0.02648649}, {1470,0.03318919}, {1480,0.02697297}, {1490,0.02736036}, {1500,0.02954054}, {1510,0.02763063}, {1520,0.02777477}, {1530,0.02800901}, {1540,0.03527027}, {1550,0.02871171}, {1560,0.02896396}, {1570,0.03200901}, {1580,0.02944144}, {1590,0.02957658}, {1600,0.03514414}, {1610,0.02986486}, {1620,0.03045946}, {1630,0.03777477}, {1640,0.03063964}, {1650,0.03113514}, {1660,0.03142342}, {1670,0.03172973}, {1680,0.03188288}, {1690,0.03172973}, {1700,0.03354054}, {1710,0.03274775}, {1720,0.03271171}, {1730,0.03345045}, {1740,0.03320721}, {1750,0.03335135}, {1760,0.03329730}, {1770,0.03374775}, {1780,0.04108108}, {1790,0.03435135}, {1800,0.03484685}, {1810,0.03917117}, {1820,0.03484685}, {1830,0.03509009}, {1840,0.04101802}, {1850,0.03610811}, {1860,0.03596396}, {1870,0.04494595}, {1880,0.03664865}, {1890,0.03685586}, {1900,0.03670270}, {1910,0.03719820}, {1920,0.04164865}, {1930,0.03770270}, {1940,0.03800000}, {1950,0.04190991}, {1960,0.03857658}, {1970,0.03965766}, {1980,0.03871171}, {1990,0.03902703}, {2000,0.04495495}, {2050,0.04076577}, {2100,0.04195495}, {2150,0.04298198}, {2200,0.04460360}, {2250,0.05073874}, {2300,0.04743243}, {2350,0.05078378}, {2400,0.05054054}, {2450,0.05672072}, {2500,0.05381081}, {2550,0.06188288}, {2600,0.05625225}, {2650,0.06539640}, {2700,0.05899099}, {2750,0.06421622}, {2800,0.06280180}, {2850,0.08010811}, {2900,0.06516216}, {2950,0.07790991}, {3000,0.06737838}, {3050,0.06939640}, {3100,0.07652252}, {3150,0.07390991}, {3200,0.07910811}, {3250,0.08968468}, {3300,0.07798198}, {3350,0.09802703}, {3400,0.08161261}, {3450,0.08227027}, {3500,0.09265766}, {3550,0.08516216}, {3600,0.08713514}, {3650,0.10601802}, {3700,0.10507207}, {3750,0.09167568}, {3800,0.10015315}, {3850,0.10348649}, {3900,0.10923423}, {3950,0.09771171}, {4000,0.10719820}, {4050,0.12806306}, {4100,0.11298198}, {4150,0.10322523}, {4200,0.10395495}, {4250,0.11857658}, {4300,0.12664865}, {4350,0.11438739}, {4400,0.12125225}, {4450,0.11156757}, {4500,0.11208108}, {4550,0.11862162}, {4600,0.13350450}, {4650,0.13844144}, {4700,0.12858559}, {4750,0.12021622}, {4800,0.12806306}, {4850,0.13557658}, {4900,0.13786486}, {4950,0.14222523}, {5000,0.14690090}, {5050,0.12827928}, {5100,0.12863063}, {5150,0.12954054}, {5200,0.13110811}, {5250,0.13222523}, {5300,0.13352252}, {5350,0.15548649}, {5400,0.15526126}, {5450,0.15339640}, {5500,0.15709009}, {5550,0.15292793}, {5600,0.14958559}, {5650,0.13286486}, {5700,0.15836937}, {5750,0.17636036}, {5800,0.15175676}, {5850,0.16013514}, {5900,0.15954955}, {5950,0.16930631}, {6000,0.16454955}, {6050,0.13969369}, {6100,0.18471171}, {6150,0.19945045}, {6200,0.16192793}, {6250,0.18523423}, {6300,0.16750450}, {6350,0.18945045}, {6400,0.20052252}, {6450,0.19961261}, {6500,0.18498198}, {6550,0.19458559}, {6600,0.20160360}, {6650,0.19381081}, {6700,0.18507207}, {6750,0.20883784}, {6800,0.18936036}, {6850,0.19268468}, {6900,0.23966667}, {6950,0.19709910}, {7000,0.19651351}, {7050,0.21367568}, {7100,0.22301802}, {7150,0.19072072}, {7200,0.20558559}, {7250,0.21263964}, {7300,0.20215315}, {7350,0.21364865}, {7400,0.19914414}, {7450,0.20515315}, {7500,0.22174775}, {7550,0.22304505}, {7600,0.22006306}, {7650,0.21741441}, {7700,0.23281982}, {7750,0.21277477}, {7800,0.23428829}, {7850,0.21600000}, {7900,0.23613514}, {7950,0.22118018}, {8000,0.23505405}, {8050,0.25027027}, {8100,0.23046847}, {8150,0.24257658}, {8200,0.22020721}, {8250,0.22009910}, {8300,0.17697297}, {8350,0.24404505}, {8400,0.25013514}, {8450,0.23337838}, {8500,0.23959459}, {8550,0.23773874}, {8600,0.24560360}, {8650,0.24085586}, {8700,0.23634234}, {8750,0.24724324}, {8800,0.26538739}, {8850,0.24618018}, {8900,0.24545045}, {8950,0.27628829}, {9000,0.26285586}, {9050,0.22782883}, {9100,0.26307207}, {9150,0.25759459}, {9200,0.27909009}, {9250,0.22709910}, {9300,0.26243243}, {9350,0.28367568}, {9400,0.28558559}, {9450,0.26750450}, {9500,0.22230631}, {9550,0.26126126}, {9600,0.29293694}, {9650,0.27069369}, {9700,0.31690991}, {9750,0.30251351}, {9800,0.26535135}, {9850,0.24192793}, {9900,0.26570270}, {9950,0.28408108}, {10000,0.30114414}, {10100,0.31363063}, {10200,0.28413514}, {10300,0.28365766}, {10400,0.30109009}, {10500,0.30289189}, {10600,0.30490090}, {10700,0.29521622}, {10800,0.33406306}, {10900,0.32625225}, {11000,0.32618919}, {11100,0.29374775}, {11200,0.24773874}, {11300,0.37999099}, {11400,0.37290991}, {11500,0.32549550}, {11600,0.34671171}, {11700,0.27315315}, {11800,0.38254054}, {11900,0.36513514}, {12000,0.35224324}, {12100,0.34515315}, {12200,0.38768468}, {12300,0.36345946}, {12400,0.36674775}, {12500,0.36632432}, {12600,0.32226126}, {12700,0.39852252}, {12800,0.36652252}, {12900,0.40178378}, {13000,0.36938739}, {13100,0.42149550}, {13200,0.39345946}, {13300,0.39841441}, {13400,0.37381982}, {13500,0.42224324}, {13600,0.33124324}, {13700,0.36609009}, {13800,0.42269369}, {13900,0.35888288}, {14000,0.40531532}, {14100,0.42600901}, {14200,0.35061261}, {14300,0.37080180}, {14400,0.45088288}, {14500,0.45718018}, {14600,0.36476577}, {14700,0.41872072}, {14800,0.41787387}, {14900,0.44505405}, {15000,0.45657658}, {15100,0.47800000}, {15200,0.44863964}, {15300,0.47114414}, {15400,0.38893694}, {15500,0.43442342}, {15600,0.43265766}, {15700,0.42984685}, {15800,0.43721622}, {15900,0.41309009}, {16000,0.40517117}, {16100,0.47985586}, {16200,0.47102703}, {16300,0.54528829}, {16400,0.50790991}, {16500,0.51527027}, {16600,0.48131532}, {16700,0.48291892}, {16800,0.50100901}, {16900,0.52488288}, {17000,0.49136036}, {17100,0.41300901}, {17200,0.50471171}, {17300,0.51446847}, {17400,0.45948649}, {17500,0.51558559}, {17600,0.52554955}, {17700,0.46654955}, {17800,0.54318018}, {17900,0.52568468}, {18000,0.55063063}, {18100,0.56909009}, {18200,0.47495495}, {18300,0.56072973}, {18400,0.46874775}, {18500,0.61520721}, {18600,0.60161261}, {18700,0.57237838}, {18800,0.58967568}, {18900,0.51618018}, {19000,0.58908108}, {19100,0.61681982}, {19200,0.55500000}, {19300,0.63612613}, {19400,0.61009910}, {19500,0.50708108}, {19600,0.62702703}, {19700,0.64442342}, {19800,0.61345045}, {19900,0.46886486}, {20000,0.57947706}};
data["big"]["OCaml"]["Aggregate"]["user"] = {{1,0.00061261}, {2,0.00057658}, {3,0.00080180}, {4,0.00086486}, {5,0.00092793}, {6,0.00109009}, {7,0.00095495}, {8,0.00087387}, {9,0.00118018}, {10,0.00095495}, {11,0.00105405}, {12,0.00115315}, {13,0.00082883}, {14,0.00116216}, {15,0.00112613}, {16,0.00109910}, {17,0.00110811}, {18,0.00102703}, {19,0.00108108}, {20,0.00116216}, {21,0.00128829}, {22,0.00136937}, {23,0.00128829}, {24,0.00149550}, {25,0.00116216}, {26,0.00229730}, {27,0.00135135}, {28,0.00135135}, {29,0.00143243}, {30,0.00128829}, {31,0.00139640}, {32,0.00109009}, {33,0.00145045}, {34,0.00114414}, {35,0.00140541}, {36,0.00152252}, {37,0.00139640}, {38,0.00157658}, {39,0.00145946}, {40,0.00174775}, {41,0.00148649}, {42,0.00170270}, {43,0.00147748}, {44,0.00145045}, {45,0.00150450}, {46,0.00154054}, {47,0.00164865}, {48,0.00155856}, {49,0.00159459}, {50,0.00159459}, {51,0.00168468}, {52,0.00164865}, {53,0.00161261}, {54,0.00182883}, {55,0.00145045}, {56,0.00200901}, {57,0.00127928}, {58,0.01519820}, {59,0.00167568}, {60,0.00185586}, {61,0.00170270}, {62,0.00172072}, {63,0.00178378}, {64,0.00177477}, {65,0.00189189}, {66,0.00170270}, {67,0.00206306}, {68,0.00177477}, {69,0.00182883}, {70,0.00199099}, {71,0.00173874}, {72,0.00215315}, {73,0.00186486}, {74,0.00194595}, {75,0.00211712}, {76,0.00172973}, {77,0.00195495}, {78,0.00197297}, {79,0.00195495}, {80,0.00197297}, {81,0.00189189}, {82,0.00214414}, {83,0.00196396}, {84,0.00205405}, {85,0.00218919}, {86,0.00193694}, {87,0.00195495}, {88,0.00237838}, {89,0.00190090}, {90,0.00207207}, {91,0.00245946}, {92,0.00196396}, {93,0.00231532}, {94,0.00219820}, {95,0.00213514}, {96,0.00225225}, {97,0.00234234}, {98,0.00226126}, {99,0.00198198}, {100,0.00334234}, {101,0.00265766}, {102,0.00227027}, {103,0.00226126}, {104,0.00227027}, {105,0.00257658}, {106,0.00257658}, {107,0.00244144}, {108,0.00210811}, {109,0.00233333}, {110,0.00263063}, {111,0.00262162}, {112,0.00200000}, {113,0.00229730}, {114,0.00291892}, {115,0.00260360}, {116,0.00243243}, {117,0.00201802}, {118,0.00273874}, {119,0.00288288}, {120,0.00272973}, {121,0.00199099}, {122,0.00242342}, {123,0.00267568}, {124,0.00322523}, {125,0.00263964}, {126,0.00244144}, {127,0.00238739}, {128,0.00276577}, {129,0.00273874}, {130,0.00293694}, {131,0.00271171}, {132,0.00254054}, {133,0.00272973}, {134,0.00262162}, {135,0.00279279}, {136,0.00274775}, {137,0.00287387}, {138,0.00294595}, {139,0.00257658}, {140,0.00268468}, {141,0.00303604}, {142,0.00310811}, {143,0.00295495}, {144,0.00280180}, {145,0.00284685}, {146,0.00284685}, {147,0.00295495}, {148,0.00283784}, {149,0.00296396}, {150,0.00290991}, {151,0.00317117}, {152,0.00334234}, {153,0.00316216}, {154,0.00315315}, {155,0.00319820}, {156,0.00321622}, {157,0.00282883}, {158,0.00303604}, {159,0.00299099}, {160,0.00399099}, {161,0.00318919}, {162,0.00329730}, {163,0.00310811}, {164,0.00308108}, {165,0.00299099}, {166,0.00298198}, {167,0.00312613}, {168,0.00318018}, {169,0.00317117}, {170,0.00323423}, {171,0.00322523}, {172,0.00317117}, {173,0.00320721}, {174,0.00335135}, {175,0.00321622}, {176,0.00325225}, {177,0.00336036}, {178,0.00343243}, {179,0.00333333}, {180,0.00336937}, {181,0.00327928}, {182,0.00347748}, {183,0.00351351}, {184,0.00515315}, {185,0.00335135}, {186,0.00351351}, {187,0.00354054}, {188,0.00349550}, {189,0.00344144}, {190,0.00368468}, {191,0.00358559}, {192,0.00342342}, {193,0.00353153}, {194,0.00349550}, {195,0.00365766}, {196,0.00369369}, {197,0.00359459}, {198,0.00370270}, {199,0.00374775}, {200,0.00345045}, {201,0.00360360}, {202,0.00374775}, {203,0.00380180}, {204,0.00369369}, {205,0.00381982}, {206,0.00489189}, {207,0.00380180}, {208,0.00387387}, {209,0.00364865}, {210,0.00389189}, {211,0.00372973}, {212,0.00383784}, {213,0.00388288}, {214,0.00353153}, {215,0.00401802}, {216,0.00379279}, {217,0.00409009}, {218,0.00368468}, {219,0.00399099}, {220,0.00388288}, {221,0.00375676}, {222,0.00416216}, {223,0.00407207}, {224,0.00408108}, {225,0.00406306}, {226,0.00509009}, {227,0.00411712}, {228,0.00403604}, {229,0.00405405}, {230,0.00400000}, {231,0.00401802}, {232,0.00449550}, {233,0.00407207}, {234,0.00418018}, {235,0.00414414}, {236,0.00432432}, {237,0.00422523}, {238,0.00401802}, {239,0.00444144}, {240,0.00409009}, {241,0.00423423}, {242,0.00440541}, {243,0.00436937}, {244,0.00432432}, {245,0.00524324}, {246,0.00405405}, {247,0.00451351}, {248,0.00449550}, {249,0.00443243}, {250,0.00456757}, {251,0.00432432}, {252,0.00436937}, {253,0.00474775}, {254,0.00433333}, {255,0.00446847}, {256,0.00459459}, {257,0.00417117}, {258,0.00464865}, {259,0.00413514}, {260,0.00461261}, {261,0.00463063}, {262,0.00564865}, {263,0.00427027}, {264,0.00458559}, {265,0.00444144}, {266,0.00482883}, {267,0.00461261}, {268,0.00451351}, {269,0.00454054}, {270,0.00461261}, {271,0.00486486}, {272,0.00444144}, {273,0.00463063}, {274,0.00454955}, {275,0.00489189}, {276,0.00473874}, {277,0.00459459}, {278,0.00463063}, {279,0.00590991}, {280,0.00462162}, {281,0.00465766}, {282,0.00487387}, {283,0.00505405}, {284,0.00483784}, {285,0.00490090}, {286,0.00481982}, {287,0.00487387}, {288,0.00459459}, {289,0.00500901}, {290,0.00464865}, {291,0.00501802}, {292,0.00472973}, {293,0.00539640}, {294,0.00478378}, {295,0.00614414}, {296,0.00481081}, {297,0.00533333}, {298,0.00497297}, {299,0.00510811}, {300,0.00533333}, {301,0.00491892}, {302,0.00554054}, {303,0.00487387}, {304,0.00549550}, {305,0.00500000}, {306,0.00531532}, {307,0.00542342}, {308,0.00494595}, {309,0.00536937}, {310,0.00596396}, {311,0.00499099}, {312,0.00544144}, {313,0.00481982}, {314,0.00533333}, {315,0.00525225}, {316,0.00512613}, {317,0.00533333}, {318,0.00550450}, {319,0.00505405}, {320,0.00556757}, {321,0.00530631}, {322,0.00514414}, {323,0.00554955}, {324,0.00658559}, {325,0.00514414}, {326,0.00542342}, {327,0.00572072}, {328,0.00493694}, {329,0.00572973}, {330,0.00545045}, {331,0.00523423}, {332,0.00587387}, {333,0.00537838}, {334,0.00549550}, {335,0.00514414}, {336,0.00595495}, {337,0.00564865}, {338,0.00664865}, {339,0.00498198}, {340,0.00585586}, {341,0.00588288}, {342,0.00521622}, {343,0.00558559}, {344,0.00552252}, {345,0.00594595}, {346,0.00595495}, {347,0.00517117}, {348,0.00569369}, {349,0.00619820}, {350,0.00564865}, {351,0.00547748}, {352,0.00576577}, {353,0.00568468}, {354,0.00571171}, {355,0.00615315}, {356,0.00587387}, {357,0.00575676}, {358,0.00610811}, {359,0.00595495}, {360,0.00561261}, {361,0.00586486}, {362,0.00590090}, {363,0.00599099}, {364,0.00596396}, {365,0.00618018}, {366,0.00588288}, {367,0.00598198}, {368,0.00584685}, {369,0.00592793}, {370,0.00617117}, {371,0.00586486}, {372,0.00614414}, {373,0.00622523}, {374,0.00606306}, {375,0.00595495}, {376,0.00602703}, {377,0.00847748}, {378,0.00633333}, {379,0.00636937}, {380,0.00615315}, {381,0.00598198}, {382,0.00627928}, {383,0.00618919}, {384,0.00635135}, {385,0.00605405}, {386,0.00609009}, {387,0.00628829}, {388,0.00653153}, {389,0.00854955}, {390,0.00655856}, {391,0.00637838}, {392,0.00619820}, {393,0.00630631}, {394,0.00625225}, {395,0.00636036}, {396,0.00646847}, {397,0.00647748}, {398,0.00633333}, {399,0.00652252}, {400,0.00655856}, {401,0.00829730}, {402,0.00653153}, {403,0.00657658}, {404,0.00653153}, {405,0.00654955}, {406,0.00654054}, {407,0.00639640}, {408,0.00627928}, {409,0.00618018}, {410,0.00647748}, {411,0.00625225}, {412,0.00648649}, {413,0.00762162}, {414,0.00630631}, {415,0.00653153}, {416,0.00665766}, {417,0.00654054}, {418,0.00659459}, {419,0.00683784}, {420,0.00685586}, {421,0.00695495}, {422,0.00687387}, {423,0.00682883}, {424,0.00871171}, {425,0.00671171}, {426,0.00654054}, {427,0.00685586}, {428,0.00701802}, {429,0.00699099}, {430,0.00692793}, {431,0.00675676}, {432,0.00693694}, {433,0.00683784}, {434,0.00686486}, {435,0.00912613}, {436,0.00696396}, {437,0.00681982}, {438,0.00696396}, {439,0.00690090}, {440,0.00706306}, {441,0.00690991}, {442,0.00692793}, {443,0.00693694}, {444,0.00711712}, {445,0.00693694}, {446,0.01054054}, {447,0.00713514}, {448,0.00709910}, {449,0.00710811}, {450,0.00718018}, {451,0.00709910}, {452,0.00712613}, {453,0.00711712}, {454,0.00711712}, {455,0.00704505}, {456,0.00711712}, {457,0.00713514}, {458,0.00734234}, {459,0.00719820}, {460,0.00734234}, {461,0.00731532}, {462,0.00725225}, {463,0.00735135}, {464,0.00738739}, {465,0.00736937}, {466,0.00741441}, {467,0.00879279}, {468,0.00728829}, {469,0.00744144}, {470,0.00733333}, {471,0.00747748}, {472,0.00755856}, {473,0.00734234}, {474,0.00747748}, {475,0.00748649}, {476,0.00757658}, {477,0.01048649}, {478,0.00754054}, {479,0.00751351}, {480,0.00771171}, {481,0.00772973}, {482,0.00755856}, {483,0.00765766}, {484,0.00782883}, {485,0.00767568}, {486,0.00790991}, {487,0.01130631}, {488,0.00758559}, {489,0.00795495}, {490,0.00784685}, {491,0.00791892}, {492,0.00799099}, {493,0.00759459}, {494,0.00804505}, {495,0.00795495}, {496,0.00779279}, {497,0.00923423}, {498,0.00782883}, {499,0.00806306}, {500,0.00814414}, {505,0.00811712}, {510,0.00817117}, {515,0.00840541}, {520,0.00820721}, {525,0.00888288}, {530,0.01159459}, {535,0.00855856}, {540,0.00863063}, {545,0.00872072}, {550,0.00896396}, {555,0.00911712}, {560,0.00905405}, {565,0.00909910}, {570,0.00966667}, {575,0.01183784}, {580,0.00979279}, {585,0.00958559}, {590,0.00947748}, {595,0.00941441}, {600,0.00958559}, {605,0.00994595}, {610,0.00998198}, {615,0.01272072}, {620,0.01027027}, {625,0.00993694}, {630,0.01036937}, {635,0.01032432}, {640,0.01039640}, {645,0.01048649}, {650,0.01067568}, {655,0.01200901}, {660,0.01103604}, {665,0.01130631}, {670,0.01140541}, {675,0.01120721}, {680,0.01104505}, {685,0.01130631}, {690,0.01348649}, {695,0.01169369}, {700,0.01165766}, {705,0.01191892}, {710,0.01153153}, {715,0.01212613}, {720,0.01203604}, {725,0.01546847}, {730,0.01212613}, {735,0.01217117}, {740,0.01254955}, {745,0.01241441}, {750,0.01257658}, {755,0.01248649}, {760,0.01500000}, {765,0.01270270}, {770,0.01261261}, {775,0.01271171}, {780,0.01263964}, {785,0.01319820}, {790,0.01640541}, {795,0.01315315}, {800,0.01373874}, {805,0.01319820}, {810,0.01390090}, {815,0.01362162}, {820,0.01678378}, {825,0.01371171}, {830,0.01396396}, {835,0.01412613}, {840,0.01382883}, {845,0.01381982}, {850,0.01735135}, {855,0.01442342}, {860,0.01434234}, {865,0.01430631}, {870,0.01430631}, {875,0.01428829}, {880,0.01923423}, {885,0.01499099}, {890,0.01478378}, {895,0.01498198}, {900,0.01484685}, {905,0.01491892}, {910,0.01591892}, {915,0.01542342}, {920,0.01544144}, {925,0.01534234}, {930,0.01563063}, {935,0.02074775}, {940,0.01550450}, {945,0.01580180}, {950,0.01586486}, {955,0.01606306}, {960,0.01998198}, {965,0.01601802}, {970,0.01599099}, {975,0.01622523}, {980,0.01639640}, {985,0.02073874}, {990,0.01640541}, {995,0.01631532}, {1000,0.01688288}, {1010,0.01691892}, {1020,0.02187387}, {1030,0.01705405}, {1040,0.01742342}, {1050,0.01732432}, {1060,0.01781081}, {1070,0.02206306}, {1080,0.01811712}, {1090,0.01850450}, {1100,0.01835135}, {1110,0.01841441}, {1120,0.02296396}, {1130,0.01884685}, {1140,0.01937838}, {1150,0.01945045}, {1160,0.02410811}, {1170,0.02004505}, {1180,0.02066667}, {1190,0.02005405}, {1200,0.02015315}, {1210,0.02044144}, {1220,0.02091892}, {1230,0.02129730}, {1240,0.02165766}, {1250,0.02320721}, {1260,0.02230631}, {1270,0.02232432}, {1280,0.02251351}, {1290,0.02354054}, {1300,0.02301802}, {1310,0.02336937}, {1320,0.02363063}, {1330,0.02342342}, {1340,0.02394595}, {1350,0.02462162}, {1360,0.02989189}, {1370,0.02482883}, {1380,0.02491892}, {1390,0.02498198}, {1400,0.03002703}, {1410,0.02537838}, {1420,0.02599099}, {1430,0.02618018}, {1440,0.02640541}, {1450,0.02630631}, {1460,0.02653153}, {1470,0.03298198}, {1480,0.02697297}, {1490,0.02752252}, {1500,0.02908108}, {1510,0.02776577}, {1520,0.02781982}, {1530,0.02809009}, {1540,0.03539640}, {1550,0.02859459}, {1560,0.02853153}, {1570,0.03196396}, {1580,0.02948649}, {1590,0.02934234}, {1600,0.03490991}, {1610,0.02972072}, {1620,0.03039640}, {1630,0.03781982}, {1640,0.03025225}, {1650,0.03091892}, {1660,0.03116216}, {1670,0.03130631}, {1680,0.03161261}, {1690,0.03159459}, {1700,0.03333333}, {1710,0.03240541}, {1720,0.03258559}, {1730,0.03354054}, {1740,0.03310811}, {1750,0.03308108}, {1760,0.03318919}, {1770,0.03390991}, {1780,0.04115315}, {1790,0.03423423}, {1800,0.03500000}, {1810,0.03908108}, {1820,0.03480180}, {1830,0.03507207}, {1840,0.04080180}, {1850,0.03644144}, {1860,0.03598198}, {1870,0.04479279}, {1880,0.03682883}, {1890,0.03658559}, {1900,0.03676577}, {1910,0.03720721}, {1920,0.04124324}, {1930,0.03790090}, {1940,0.03795495}, {1950,0.04139640}, {1960,0.03864865}, {1970,0.03949550}, {1980,0.03879279}, {1990,0.03880180}, {2000,0.04462162}, {2050,0.04056757}, {2100,0.04159459}, {2150,0.04262162}, {2200,0.04469369}, {2250,0.05056757}, {2300,0.04748649}, {2350,0.05046847}, {2400,0.05062162}, {2450,0.05653153}, {2500,0.05393694}, {2550,0.06192793}, {2600,0.05618919}, {2650,0.06515315}, {2700,0.05891892}, {2750,0.06374775}, {2800,0.06300901}, {2850,0.07959459}, {2900,0.06511712}, {2950,0.07741441}, {3000,0.06736937}, {3050,0.06918018}, {3100,0.07665766}, {3150,0.07393694}, {3200,0.07892793}, {3250,0.08934234}, {3300,0.07783784}, {3350,0.09730631}, {3400,0.08145946}, {3450,0.08206306}, {3500,0.09235135}, {3550,0.08456757}, {3600,0.08702703}, {3650,0.10551351}, {3700,0.10416216}, {3750,0.09155856}, {3800,0.09975676}, {3850,0.10222523}, {3900,0.10845045}, {3950,0.09736036}, {4000,0.10663063}, {4050,0.12745946}, {4100,0.11240541}, {4150,0.10289189}, {4200,0.10382883}, {4250,0.11832432}, {4300,0.12600000}, {4350,0.11374775}, {4400,0.12049550}, {4450,0.11082883}, {4500,0.11161261}, {4550,0.11813514}, {4600,0.13236937}, {4650,0.13828829}, {4700,0.12800000}, {4750,0.11978378}, {4800,0.12746847}, {4850,0.13493694}, {4900,0.13778378}, {4950,0.14191892}, {5000,0.14637838}, {5050,0.12790090}, {5100,0.12862162}, {5150,0.12923423}, {5200,0.13087387}, {5250,0.13228829}, {5300,0.13354955}, {5350,0.15495495}, {5400,0.15442342}, {5450,0.15276577}, {5500,0.15635135}, {5550,0.15242342}, {5600,0.14932432}, {5650,0.13213514}, {5700,0.15802703}, {5750,0.17538739}, {5800,0.15159459}, {5850,0.15987387}, {5900,0.15926126}, {5950,0.16879279}, {6000,0.16370270}, {6050,0.13940541}, {6100,0.18408108}, {6150,0.19795495}, {6200,0.16182883}, {6250,0.18482883}, {6300,0.16751351}, {6350,0.18921622}, {6400,0.20038739}, {6450,0.19947748}, {6500,0.18496396}, {6550,0.19436036}, {6600,0.20128829}, {6650,0.19364865}, {6700,0.18480180}, {6750,0.20843243}, {6800,0.18911712}, {6850,0.19248649}, {6900,0.23920721}, {6950,0.19642342}, {7000,0.19573874}, {7050,0.21257658}, {7100,0.22159459}, {7150,0.19008108}, {7200,0.20445946}, {7250,0.21163063}, {7300,0.20136036}, {7350,0.21230631}, {7400,0.19827027}, {7450,0.20413514}, {7500,0.22083784}, {7550,0.22171171}, {7600,0.21859459}, {7650,0.21676577}, {7700,0.23109009}, {7750,0.21204505}, {7800,0.23290991}, {7850,0.21457658}, {7900,0.23493694}, {7950,0.22042342}, {8000,0.23361261}, {8050,0.24908108}, {8100,0.22940541}, {8150,0.24118919}, {8200,0.21920721}, {8250,0.21954054}, {8300,0.17572973}, {8350,0.24294595}, {8400,0.24890991}, {8450,0.23254054}, {8500,0.23861261}, {8550,0.23689189}, {8600,0.24447748}, {8650,0.24021622}, {8700,0.23564865}, {8750,0.24684685}, {8800,0.26515315}, {8850,0.24590090}, {8900,0.24498198}, {8950,0.27602703}, {9000,0.26270270}, {9050,0.22734234}, {9100,0.26283784}, {9150,0.25747748}, {9200,0.27881982}, {9250,0.22664865}, {9300,0.26205405}, {9350,0.28340541}, {9400,0.28539640}, {9450,0.26734234}, {9500,0.22198198}, {9550,0.26107207}, {9600,0.29256757}, {9650,0.27070270}, {9700,0.31670270}, {9750,0.30232432}, {9800,0.26476577}, {9850,0.24167568}, {9900,0.26530631}, {9950,0.28387387}, {10000,0.30105405}, {10100,0.31367568}, {10200,0.28416216}, {10300,0.28375676}, {10400,0.30131532}, {10500,0.30272072}, {10600,0.30496396}, {10700,0.29514414}, {10800,0.33371171}, {10900,0.32622523}, {11000,0.32627928}, {11100,0.29381982}, {11200,0.24773874}, {11300,0.37972973}, {11400,0.37267568}, {11500,0.32559459}, {11600,0.34660360}, {11700,0.27324324}, {11800,0.38221622}, {11900,0.36527027}, {12000,0.35224324}, {12100,0.34475676}, {12200,0.38757658}, {12300,0.36356757}, {12400,0.36654054}, {12500,0.36630631}, {12600,0.32214414}, {12700,0.39814414}, {12800,0.36632432}, {12900,0.40133333}, {13000,0.36904505}, {13100,0.42146847}, {13200,0.39295495}, {13300,0.39859459}, {13400,0.37377477}, {13500,0.42208108}, {13600,0.33124324}, {13700,0.36582883}, {13800,0.42217117}, {13900,0.35872973}, {14000,0.40509009}, {14100,0.42577477}, {14200,0.35066667}, {14300,0.37054955}, {14400,0.45089189}, {14500,0.45696396}, {14600,0.36466667}, {14700,0.41845045}, {14800,0.41770270}, {14900,0.44468468}, {15000,0.45616216}, {15100,0.47760360}, {15200,0.44832432}, {15300,0.47087387}, {15400,0.38878378}, {15500,0.43388288}, {15600,0.43240541}, {15700,0.42960360}, {15800,0.43687387}, {15900,0.41267568}, {16000,0.40470270}, {16100,0.47947748}, {16200,0.47072973}, {16300,0.54493694}, {16400,0.50777477}, {16500,0.51476577}, {16600,0.48096396}, {16700,0.48268468}, {16800,0.50064865}, {16900,0.52464865}, {17000,0.49083784}, {17100,0.41293694}, {17200,0.50411712}, {17300,0.51430631}, {17400,0.45901802}, {17500,0.51517117}, {17600,0.52554955}, {17700,0.46628829}, {17800,0.54290991}, {17900,0.52538739}, {18000,0.55018919}, {18100,0.56871171}, {18200,0.47433333}, {18300,0.56072072}, {18400,0.46840541}, {18500,0.61495495}, {18600,0.60163964}, {18700,0.57225225}, {18800,0.58935135}, {18900,0.51600901}, {19000,0.58878378}, {19100,0.61649550}, {19200,0.55486486}, {19300,0.63498198}, {19400,0.60610811}, {19500,0.50486486}, {19600,0.62222523}, {19700,0.63960360}, {19800,0.60906306}, {19900,0.46659459}, {20000,0.57640367}};
data["big"]["OCaml"]["Aggregate"]["system"] = {{1,0.00025225}, {2,0.00018018}, {3,0.00028829}, {4,0.00000000}, {5,0.00000000}, {6,0.00010811}, {7,0.00007207}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003604}, {13,0.00007207}, {14,0.00000000}, {15,0.00000000}, {16,0.00007207}, {17,0.00003604}, {18,0.00000000}, {19,0.00003604}, {20,0.00003604}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00003604}, {27,0.00000000}, {28,0.00000000}, {29,0.00007207}, {30,0.00000000}, {31,0.00007207}, {32,0.00009910}, {33,0.00003604}, {34,0.00000000}, {35,0.00000000}, {36,0.00002703}, {37,0.00003604}, {38,0.00003604}, {39,0.00003604}, {40,0.00000000}, {41,0.00007207}, {42,0.00000000}, {43,0.00000000}, {44,0.00003604}, {45,0.00006306}, {46,0.00003604}, {47,0.00000000}, {48,0.00003604}, {49,0.00000000}, {50,0.00003604}, {51,0.00007207}, {52,0.00000000}, {53,0.00000000}, {54,0.00007207}, {55,0.00003604}, {56,0.00003604}, {57,0.00007207}, {58,0.00018018}, {59,0.00003604}, {60,0.00007207}, {61,0.00000000}, {62,0.00003604}, {63,0.00003604}, {64,0.00006306}, {65,0.00003604}, {66,0.00000000}, {67,0.00000000}, {68,0.00010811}, {69,0.00007207}, {70,0.00007207}, {71,0.00000000}, {72,0.00002703}, {73,0.00003604}, {74,0.00000000}, {75,0.00006306}, {76,0.00010811}, {77,0.00007207}, {78,0.00000000}, {79,0.00007207}, {80,0.00007207}, {81,0.00014414}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00003604}, {86,0.00000000}, {87,0.00010811}, {88,0.00007207}, {89,0.00003604}, {90,0.00003604}, {91,0.00000000}, {92,0.00003604}, {93,0.00007207}, {94,0.00000000}, {95,0.00003604}, {96,0.00003604}, {97,0.00000000}, {98,0.00007207}, {99,0.00007207}, {100,0.00003604}, {101,0.00007207}, {102,0.00000000}, {103,0.00007207}, {104,0.00000000}, {105,0.00007207}, {106,0.00000000}, {107,0.00003604}, {108,0.00007207}, {109,0.00009910}, {110,0.00007207}, {111,0.00000000}, {112,0.00006306}, {113,0.00003604}, {114,0.00006306}, {115,0.00010811}, {116,0.00010811}, {117,0.00003604}, {118,0.00000000}, {119,0.00007207}, {120,0.00014414}, {121,0.00007207}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00009910}, {126,0.00000000}, {127,0.00007207}, {128,0.00006306}, {129,0.00003604}, {130,0.00000000}, {131,0.00003604}, {132,0.00006306}, {133,0.00003604}, {134,0.00007207}, {135,0.00000000}, {136,0.00003604}, {137,0.00007207}, {138,0.00010811}, {139,0.00014414}, {140,0.00007207}, {141,0.00003604}, {142,0.00000000}, {143,0.00003604}, {144,0.00000000}, {145,0.00003604}, {146,0.00010811}, {147,0.00000000}, {148,0.00003604}, {149,0.00003604}, {150,0.00000000}, {151,0.00003604}, {152,0.00003604}, {153,0.00006306}, {154,0.00014414}, {155,0.00007207}, {156,0.00003604}, {157,0.00017117}, {158,0.00003604}, {159,0.00003604}, {160,0.00007207}, {161,0.00003604}, {162,0.00003604}, {163,0.00003604}, {164,0.00010811}, {165,0.00006306}, {166,0.00007207}, {167,0.00003604}, {168,0.00003604}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00007207}, {173,0.00003604}, {174,0.00000000}, {175,0.00003604}, {176,0.00003604}, {177,0.00007207}, {178,0.00000000}, {179,0.00003604}, {180,0.00000000}, {181,0.00003604}, {182,0.00007207}, {183,0.00003604}, {184,0.00007207}, {185,0.00006306}, {186,0.00003604}, {187,0.00003604}, {188,0.00007207}, {189,0.00007207}, {190,0.00003604}, {191,0.00003604}, {192,0.00014414}, {193,0.00002703}, {194,0.00007207}, {195,0.00007207}, {196,0.00000000}, {197,0.00000000}, {198,0.00003604}, {199,0.00003604}, {200,0.00010811}, {201,0.00013514}, {202,0.00003604}, {203,0.00003604}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00010811}, {208,0.00000000}, {209,0.00003604}, {210,0.00000000}, {211,0.00007207}, {212,0.00007207}, {213,0.00003604}, {214,0.00007207}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00007207}, {219,0.00000000}, {220,0.00000000}, {221,0.00007207}, {222,0.00003604}, {223,0.00003604}, {224,0.00007207}, {225,0.00010811}, {226,0.00009910}, {227,0.00003604}, {228,0.00003604}, {229,0.00007207}, {230,0.00003604}, {231,0.00000000}, {232,0.00000000}, {233,0.00003604}, {234,0.00000000}, {235,0.00007207}, {236,0.00000000}, {237,0.00003604}, {238,0.00003604}, {239,0.00000000}, {240,0.00003604}, {241,0.00010811}, {242,0.00000000}, {243,0.00003604}, {244,0.00003604}, {245,0.00009910}, {246,0.00003604}, {247,0.00000000}, {248,0.00003604}, {249,0.00000000}, {250,0.00000000}, {251,0.00018018}, {252,0.00003604}, {253,0.00000000}, {254,0.00002703}, {255,0.00003604}, {256,0.00000000}, {257,0.00010811}, {258,0.00003604}, {259,0.00000000}, {260,0.00003604}, {261,0.00003604}, {262,0.00007207}, {263,0.00006306}, {264,0.00006306}, {265,0.00003604}, {266,0.00007207}, {267,0.00003604}, {268,0.00009910}, {269,0.00003604}, {270,0.00000000}, {271,0.00010811}, {272,0.00010811}, {273,0.00000000}, {274,0.00007207}, {275,0.00000000}, {276,0.00007207}, {277,0.00007207}, {278,0.00007207}, {279,0.00002703}, {280,0.00000000}, {281,0.00007207}, {282,0.00007207}, {283,0.00000000}, {284,0.00007207}, {285,0.00010811}, {286,0.00014414}, {287,0.00010811}, {288,0.00007207}, {289,0.00000000}, {290,0.00003604}, {291,0.00007207}, {292,0.00010811}, {293,0.00003604}, {294,0.00007207}, {295,0.00014414}, {296,0.00000000}, {297,0.00000000}, {298,0.00003604}, {299,0.00007207}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00003604}, {305,0.00003604}, {306,0.00000000}, {307,0.00003604}, {308,0.00007207}, {309,0.00003604}, {310,0.00003604}, {311,0.00000000}, {312,0.00003604}, {313,0.00006306}, {314,0.00000000}, {315,0.00007207}, {316,0.00003604}, {317,0.00009910}, {318,0.00003604}, {319,0.00014414}, {320,0.00007207}, {321,0.00003604}, {322,0.00003604}, {323,0.00007207}, {324,0.00014414}, {325,0.00007207}, {326,0.00007207}, {327,0.00007207}, {328,0.00000000}, {329,0.00010811}, {330,0.00003604}, {331,0.00009009}, {332,0.00003604}, {333,0.00000000}, {334,0.00003604}, {335,0.00014414}, {336,0.00003604}, {337,0.00010811}, {338,0.00003604}, {339,0.00003604}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00003604}, {344,0.00003604}, {345,0.00000000}, {346,0.00000000}, {347,0.00003604}, {348,0.00000000}, {349,0.00007207}, {350,0.00007207}, {351,0.00007207}, {352,0.00003604}, {353,0.00007207}, {354,0.00003604}, {355,0.00003604}, {356,0.00000000}, {357,0.00007207}, {358,0.00003604}, {359,0.00018018}, {360,0.00010811}, {361,0.00000000}, {362,0.00007207}, {363,0.00000000}, {364,0.00010811}, {365,0.00007207}, {366,0.00013514}, {367,0.00003604}, {368,0.00007207}, {369,0.00003604}, {370,0.00003604}, {371,0.00003604}, {372,0.00007207}, {373,0.00007207}, {374,0.00010811}, {375,0.00000000}, {376,0.00003604}, {377,0.00014414}, {378,0.00007207}, {379,0.00003604}, {380,0.00003604}, {381,0.00010811}, {382,0.00000000}, {383,0.00000000}, {384,0.00007207}, {385,0.00003604}, {386,0.00010811}, {387,0.00003604}, {388,0.00000000}, {389,0.00014414}, {390,0.00007207}, {391,0.00000000}, {392,0.00007207}, {393,0.00000000}, {394,0.00007207}, {395,0.00003604}, {396,0.00007207}, {397,0.00007207}, {398,0.00000000}, {399,0.00007207}, {400,0.00007207}, {401,0.00010811}, {402,0.00007207}, {403,0.00007207}, {404,0.00006306}, {405,0.00003604}, {406,0.00003604}, {407,0.00003604}, {408,0.00014414}, {409,0.00018018}, {410,0.00000000}, {411,0.00010811}, {412,0.00003604}, {413,0.00014414}, {414,0.00007207}, {415,0.00007207}, {416,0.00003604}, {417,0.00006306}, {418,0.00007207}, {419,0.00000000}, {420,0.00000000}, {421,0.00003604}, {422,0.00003604}, {423,0.00003604}, {424,0.00003604}, {425,0.00000000}, {426,0.00007207}, {427,0.00007207}, {428,0.00000000}, {429,0.00014414}, {430,0.00000000}, {431,0.00007207}, {432,0.00003604}, {433,0.00003604}, {434,0.00003604}, {435,0.00003604}, {436,0.00007207}, {437,0.00007207}, {438,0.00003604}, {439,0.00003604}, {440,0.00000000}, {441,0.00000000}, {442,0.00014414}, {443,0.00002703}, {444,0.00000000}, {445,0.00003604}, {446,0.00007207}, {447,0.00002703}, {448,0.00014414}, {449,0.00003604}, {450,0.00007207}, {451,0.00018018}, {452,0.00006306}, {453,0.00003604}, {454,0.00003604}, {455,0.00007207}, {456,0.00014414}, {457,0.00006306}, {458,0.00003604}, {459,0.00003604}, {460,0.00009910}, {461,0.00014414}, {462,0.00003604}, {463,0.00007207}, {464,0.00007207}, {465,0.00002703}, {466,0.00007207}, {467,0.00006306}, {468,0.00007207}, {469,0.00003604}, {470,0.00016216}, {471,0.00006306}, {472,0.00010811}, {473,0.00007207}, {474,0.00003604}, {475,0.00003604}, {476,0.00000000}, {477,0.00014414}, {478,0.00000000}, {479,0.00010811}, {480,0.00000000}, {481,0.00000000}, {482,0.00010811}, {483,0.00003604}, {484,0.00003604}, {485,0.00000000}, {486,0.00003604}, {487,0.00014414}, {488,0.00010811}, {489,0.00007207}, {490,0.00003604}, {491,0.00000000}, {492,0.00003604}, {493,0.00010811}, {494,0.00010811}, {495,0.00018018}, {496,0.00010811}, {497,0.00010811}, {498,0.00014414}, {499,0.00002703}, {500,0.00003604}, {505,0.00003604}, {510,0.00007207}, {515,0.00003604}, {520,0.00003604}, {525,0.00000000}, {530,0.00014414}, {535,0.00007207}, {540,0.00007207}, {545,0.00003604}, {550,0.00010811}, {555,0.00003604}, {560,0.00003604}, {565,0.00002703}, {570,0.00003604}, {575,0.00032432}, {580,0.00006306}, {585,0.00000000}, {590,0.00018018}, {595,0.00018018}, {600,0.00003604}, {605,0.00007207}, {610,0.00003604}, {615,0.00018018}, {620,0.00000000}, {625,0.00017117}, {630,0.00007207}, {635,0.00014414}, {640,0.00007207}, {645,0.00014414}, {650,0.00003604}, {655,0.00000000}, {660,0.00000000}, {665,0.00003604}, {670,0.00003604}, {675,0.00003604}, {680,0.00018018}, {685,0.00003604}, {690,0.00007207}, {695,0.00007207}, {700,0.00014414}, {705,0.00000000}, {710,0.00014414}, {715,0.00003604}, {720,0.00003604}, {725,0.00009910}, {730,0.00007207}, {735,0.00006306}, {740,0.00003604}, {745,0.00010811}, {750,0.00013514}, {755,0.00010811}, {760,0.00010811}, {765,0.00006306}, {770,0.00010811}, {775,0.00017117}, {780,0.00003604}, {785,0.00003604}, {790,0.00018018}, {795,0.00007207}, {800,0.00003604}, {805,0.00010811}, {810,0.00003604}, {815,0.00014414}, {820,0.00018018}, {825,0.00021622}, {830,0.00010811}, {835,0.00007207}, {840,0.00018018}, {845,0.00003604}, {850,0.00025225}, {855,0.00007207}, {860,0.00010811}, {865,0.00010811}, {870,0.00010811}, {875,0.00000000}, {880,0.00007207}, {885,0.00007207}, {890,0.00014414}, {895,0.00007207}, {900,0.00006306}, {905,0.00010811}, {910,0.00010811}, {915,0.00003604}, {920,0.00009910}, {925,0.00003604}, {930,0.00007207}, {935,0.00010811}, {940,0.00000000}, {945,0.00014414}, {950,0.00006306}, {955,0.00000000}, {960,0.00039640}, {965,0.00003604}, {970,0.00007207}, {975,0.00003604}, {980,0.00010811}, {985,0.00032432}, {990,0.00020721}, {995,0.00010811}, {1000,0.00010811}, {1010,0.00007207}, {1020,0.00010811}, {1030,0.00010811}, {1040,0.00007207}, {1050,0.00010811}, {1060,0.00002703}, {1070,0.00018018}, {1080,0.00007207}, {1090,0.00003604}, {1100,0.00010811}, {1110,0.00010811}, {1120,0.00018018}, {1130,0.00003604}, {1140,0.00000000}, {1150,0.00003604}, {1160,0.00027928}, {1170,0.00007207}, {1180,0.00010811}, {1190,0.00014414}, {1200,0.00003604}, {1210,0.00003604}, {1220,0.00009910}, {1230,0.00014414}, {1240,0.00007207}, {1250,0.00018018}, {1260,0.00003604}, {1270,0.00000000}, {1280,0.00010811}, {1290,0.00019820}, {1300,0.00010811}, {1310,0.00010811}, {1320,0.00007207}, {1330,0.00000000}, {1340,0.00007207}, {1350,0.00007207}, {1360,0.00014414}, {1370,0.00003604}, {1380,0.00003604}, {1390,0.00007207}, {1400,0.00014414}, {1410,0.00018018}, {1420,0.00003604}, {1430,0.00010811}, {1440,0.00010811}, {1450,0.00003604}, {1460,0.00000000}, {1470,0.00036036}, {1480,0.00007207}, {1490,0.00018018}, {1500,0.00018018}, {1510,0.00007207}, {1520,0.00020721}, {1530,0.00010811}, {1540,0.00013514}, {1550,0.00007207}, {1560,0.00014414}, {1570,0.00006306}, {1580,0.00000000}, {1590,0.00007207}, {1600,0.00035135}, {1610,0.00018018}, {1620,0.00003604}, {1630,0.00017117}, {1640,0.00006306}, {1650,0.00007207}, {1660,0.00007207}, {1670,0.00014414}, {1680,0.00006306}, {1690,0.00020721}, {1700,0.00010811}, {1710,0.00003604}, {1720,0.00006306}, {1730,0.00018018}, {1740,0.00007207}, {1750,0.00006306}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00031532}, {1790,0.00014414}, {1800,0.00000000}, {1810,0.00025225}, {1820,0.00007207}, {1830,0.00007207}, {1840,0.00018018}, {1850,0.00000000}, {1860,0.00018018}, {1870,0.00036036}, {1880,0.00003604}, {1890,0.00024324}, {1900,0.00010811}, {1910,0.00003604}, {1920,0.00019820}, {1930,0.00007207}, {1940,0.00009910}, {1950,0.00028829}, {1960,0.00021622}, {1970,0.00009910}, {1980,0.00009009}, {1990,0.00018018}, {2000,0.00035135}, {2050,0.00003604}, {2100,0.00003604}, {2150,0.00007207}, {2200,0.00013514}, {2250,0.00027928}, {2300,0.00007207}, {2350,0.00028829}, {2400,0.00003604}, {2450,0.00025225}, {2500,0.00010811}, {2550,0.00025225}, {2600,0.00010811}, {2650,0.00045045}, {2700,0.00007207}, {2750,0.00027928}, {2800,0.00003604}, {2850,0.00042342}, {2900,0.00009910}, {2950,0.00032432}, {3000,0.00006306}, {3050,0.00010811}, {3100,0.00018018}, {3150,0.00014414}, {3200,0.00024324}, {3250,0.00020721}, {3300,0.00010811}, {3350,0.00042342}, {3400,0.00007207}, {3450,0.00010811}, {3500,0.00032432}, {3550,0.00021622}, {3600,0.00010811}, {3650,0.00043243}, {3700,0.00043243}, {3750,0.00021622}, {3800,0.00028829}, {3850,0.00077477}, {3900,0.00060360}, {3950,0.00007207}, {4000,0.00024324}, {4050,0.00053153}, {4100,0.00053153}, {4150,0.00000000}, {4200,0.00010811}, {4250,0.00045045}, {4300,0.00061261}, {4350,0.00043243}, {4400,0.00090991}, {4450,0.00043243}, {4500,0.00017117}, {4550,0.00017117}, {4600,0.00083784}, {4650,0.00039640}, {4700,0.00063063}, {4750,0.00060360}, {4800,0.00050450}, {4850,0.00054054}, {4900,0.00032432}, {4950,0.00039640}, {5000,0.00074775}, {5050,0.00028829}, {5100,0.00013514}, {5150,0.00020721}, {5200,0.00018018}, {5250,0.00007207}, {5300,0.00009910}, {5350,0.00063063}, {5400,0.00072072}, {5450,0.00068468}, {5500,0.00060360}, {5550,0.00032432}, {5600,0.00046847}, {5650,0.00057658}, {5700,0.00049550}, {5750,0.00100901}, {5800,0.00038739}, {5850,0.00054054}, {5900,0.00036036}, {5950,0.00039640}, {6000,0.00100901}, {6050,0.00043243}, {6100,0.00073874}, {6150,0.00093694}, {6200,0.00024324}, {6250,0.00046847}, {6300,0.00010811}, {6350,0.00010811}, {6400,0.00003604}, {6450,0.00003604}, {6500,0.00021622}, {6550,0.00010811}, {6600,0.00007207}, {6650,0.00018018}, {6700,0.00006306}, {6750,0.00023423}, {6800,0.00006306}, {6850,0.00010811}, {6900,0.00028829}, {6950,0.00060360}, {7000,0.00056757}, {7050,0.00089189}, {7100,0.00132432}, {7150,0.00074775}, {7200,0.00066667}, {7250,0.00073874}, {7300,0.00110811}, {7350,0.00091892}, {7400,0.00086486}, {7450,0.00075676}, {7500,0.00103604}, {7550,0.00108108}, {7600,0.00140541}, {7650,0.00072072}, {7700,0.00139640}, {7750,0.00070270}, {7800,0.00114414}, {7850,0.00129730}, {7900,0.00103604}, {7950,0.00100901}, {8000,0.00109910}, {8050,0.00138739}, {8100,0.00086486}, {8150,0.00118018}, {8200,0.00090991}, {8250,0.00047748}, {8300,0.00103604}, {8350,0.00099099}, {8400,0.00117117}, {8450,0.00100000}, {8500,0.00097297}, {8550,0.00085586}, {8600,0.00099099}, {8650,0.00053153}, {8700,0.00025225}, {8750,0.00018018}, {8800,0.00006306}, {8850,0.00027928}, {8900,0.00021622}, {8950,0.00021622}, {9000,0.00018018}, {9050,0.00027928}, {9100,0.00007207}, {9150,0.00010811}, {9200,0.00025225}, {9250,0.00025225}, {9300,0.00021622}, {9350,0.00020721}, {9400,0.00021622}, {9450,0.00010811}, {9500,0.00010811}, {9550,0.00013514}, {9600,0.00028829}, {9650,0.00014414}, {9700,0.00003604}, {9750,0.00014414}, {9800,0.00018018}, {9850,0.00028829}, {9900,0.00027928}, {9950,0.00025225}, {10000,0.00018018}, {10100,0.00007207}, {10200,0.00025225}, {10300,0.00003604}, {10400,0.00010811}, {10500,0.00018018}, {10600,0.00010811}, {10700,0.00014414}, {10800,0.00019820}, {10900,0.00014414}, {11000,0.00007207}, {11100,0.00014414}, {11200,0.00007207}, {11300,0.00007207}, {11400,0.00014414}, {11500,0.00000000}, {11600,0.00014414}, {11700,0.00018018}, {11800,0.00028829}, {11900,0.00014414}, {12000,0.00003604}, {12100,0.00007207}, {12200,0.00003604}, {12300,0.00006306}, {12400,0.00003604}, {12500,0.00018018}, {12600,0.00009910}, {12700,0.00003604}, {12800,0.00007207}, {12900,0.00014414}, {13000,0.00021622}, {13100,0.00016216}, {13200,0.00028829}, {13300,0.00003604}, {13400,0.00007207}, {13500,0.00006306}, {13600,0.00010811}, {13700,0.00014414}, {13800,0.00000000}, {13900,0.00007207}, {14000,0.00025225}, {14100,0.00009910}, {14200,0.00007207}, {14300,0.00020721}, {14400,0.00007207}, {14500,0.00010811}, {14600,0.00007207}, {14700,0.00018018}, {14800,0.00018018}, {14900,0.00003604}, {15000,0.00021622}, {15100,0.00021622}, {15200,0.00018018}, {15300,0.00014414}, {15400,0.00021622}, {15500,0.00035135}, {15600,0.00007207}, {15700,0.00028829}, {15800,0.00018018}, {15900,0.00018018}, {16000,0.00009910}, {16100,0.00032432}, {16200,0.00007207}, {16300,0.00010811}, {16400,0.00018018}, {16500,0.00003604}, {16600,0.00021622}, {16700,0.00017117}, {16800,0.00036036}, {16900,0.00021622}, {17000,0.00042342}, {17100,0.00010811}, {17200,0.00032432}, {17300,0.00007207}, {17400,0.00025225}, {17500,0.00018018}, {17600,0.00010811}, {17700,0.00018018}, {17800,0.00021622}, {17900,0.00028829}, {18000,0.00037838}, {18100,0.00025225}, {18200,0.00039640}, {18300,0.00025225}, {18400,0.00024324}, {18500,0.00007207}, {18600,0.00007207}, {18700,0.00010811}, {18800,0.00034234}, {18900,0.00018018}, {19000,0.00032432}, {19100,0.00031532}, {19200,0.00028829}, {19300,0.00096396}, {19400,0.00376577}, {19500,0.00224324}, {19600,0.00485586}, {19700,0.00460360}, {19800,0.00416216}, {19900,0.00223423}, {20000,0.00294495}};
data["big"]["OCaml"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00098198}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00098198}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00001802}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00164865}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000901}, {620,0.00000000}, {625,0.00000901}, {630,0.00000000}, {635,0.00000901}, {640,0.00001802}, {645,0.00001802}, {650,0.00000000}, {655,0.00000000}, {660,0.00000901}, {665,0.00002703}, {670,0.00002703}, {675,0.00005405}, {680,0.00009910}, {685,0.00018919}, {690,0.00010811}, {695,0.00018018}, {700,0.00022523}, {705,0.00023423}, {710,0.00026126}, {715,0.00032432}, {720,0.00044144}, {725,0.00037838}, {730,0.00037838}, {735,0.00059459}, {740,0.00057658}, {745,0.00063964}, {750,0.00072973}, {755,0.00076577}, {760,0.00034234}, {765,0.00081982}, {770,0.00086486}, {775,0.00087387}, {780,0.00091892}, {785,0.00096396}, {790,0.00097297}, {795,0.00096396}, {800,0.00099099}, {805,0.00099099}, {810,0.00097297}, {815,0.00100000}, {820,0.00100000}, {825,0.00100000}, {830,0.00100000}, {835,0.00099099}, {840,0.00100000}, {845,0.00100000}, {850,0.00100000}, {855,0.00100000}, {860,0.00100000}, {865,0.00100000}, {870,0.00100000}, {875,0.00100000}, {880,0.00100000}, {885,0.00100000}, {890,0.00100000}, {895,0.00100000}, {900,0.00100000}, {905,0.00100000}, {910,0.00100000}, {915,0.00100000}, {920,0.00100000}, {925,0.00100000}, {930,0.00100000}, {935,0.00100000}, {940,0.00100000}, {945,0.00100000}, {950,0.00100000}, {955,0.00100000}, {960,0.00100000}, {965,0.00100000}, {970,0.00100000}, {975,0.00100000}, {980,0.00100000}, {985,0.00100000}, {990,0.00100000}, {995,0.00100000}, {1000,0.00100901}, {1010,0.00100000}, {1020,0.00100000}, {1030,0.00100000}, {1040,0.00100000}, {1050,0.00100000}, {1060,0.00100901}, {1070,0.00100000}, {1080,0.00100901}, {1090,0.00100000}, {1100,0.00100000}, {1110,0.00100901}, {1120,0.00100000}, {1130,0.00100901}, {1140,0.00100000}, {1150,0.00103604}, {1160,0.00100000}, {1170,0.00101802}, {1180,0.00101802}, {1190,0.00101802}, {1200,0.00100901}, {1210,0.00101802}, {1220,0.00102703}, {1230,0.00103604}, {1240,0.00103604}, {1250,0.00106306}, {1260,0.00104505}, {1270,0.00105405}, {1280,0.00104505}, {1290,0.00109009}, {1300,0.00112613}, {1310,0.00106306}, {1320,0.00106306}, {1330,0.00115315}, {1340,0.00113514}, {1350,0.00118018}, {1360,0.00127027}, {1370,0.00133333}, {1380,0.00125225}, {1390,0.00127027}, {1400,0.00136036}, {1410,0.00135135}, {1420,0.00145045}, {1430,0.00149550}, {1440,0.00146847}, {1450,0.00148649}, {1460,0.00155856}, {1470,0.00167568}, {1480,0.00170270}, {1490,0.00172072}, {1500,0.00172072}, {1510,0.00180180}, {1520,0.00182883}, {1530,0.00180180}, {1540,0.00104505}, {1550,0.00187387}, {1560,0.00191892}, {1570,0.00194595}, {1580,0.00197297}, {1590,0.00199099}, {1600,0.00200000}, {1610,0.00199099}, {1620,0.00198198}, {1630,0.00201802}, {1640,0.00200901}, {1650,0.00202703}, {1660,0.00206306}, {1670,0.00201802}, {1680,0.00201802}, {1690,0.00207207}, {1700,0.00206306}, {1710,0.00206306}, {1720,0.00205405}, {1730,0.00205405}, {1740,0.00207207}, {1750,0.00209009}, {1760,0.00212613}, {1770,0.00218919}, {1780,0.00209910}, {1790,0.00218919}, {1800,0.00218018}, {1810,0.00216216}, {1820,0.00216216}, {1830,0.00211712}, {1840,0.00218919}, {1850,0.00223423}, {1860,0.00221622}, {1870,0.00200000}, {1880,0.00221622}, {1890,0.00230631}, {1900,0.00229730}, {1910,0.00227027}, {1920,0.00229730}, {1930,0.00235135}, {1940,0.00230631}, {1950,0.00763063}, {1960,0.00240541}, {1970,0.00242342}, {1980,0.00243243}, {1990,0.00244144}, {2000,0.00247748}, {2050,0.00257658}, {2100,0.00272973}, {2150,0.00283784}, {2200,0.00298198}, {2250,0.00310811}, {2300,0.00320721}, {2350,0.00336036}, {2400,0.00346847}, {2450,0.00345946}, {2500,0.00363964}, {2550,0.00372072}, {2600,0.00393694}, {2650,0.00400901}, {2700,0.00418919}, {2750,0.00421622}, {2800,0.00434234}, {2850,0.00442342}, {2900,0.00475676}, {2950,0.00343243}, {3000,0.00470270}, {3050,0.00485586}, {3100,0.00501802}, {3150,0.00533333}, {3200,0.01222523}, {3250,0.00542342}, {3300,0.00553153}, {3350,0.00569369}, {3400,0.00575676}, {3450,0.00581982}, {3500,0.00592793}, {3550,0.00609910}, {3600,0.00624324}, {3650,0.00636036}, {3700,0.00654054}, {3750,0.00658559}, {3800,0.00618919}, {3850,0.00668468}, {3900,0.00668468}, {3950,0.00686486}, {4000,0.00659459}, {4050,0.00714414}, {4100,0.00736036}, {4150,0.00772973}, {4200,0.00761261}, {4250,0.00627928}, {4300,0.00767568}, {4350,0.00771171}, {4400,0.00771171}, {4450,0.00780180}, {4500,0.00798198}, {4550,0.00809910}, {4600,0.00581982}, {4650,0.00839640}, {4700,0.00859459}, {4750,0.00869369}, {4800,0.00870270}, {4850,0.00869369}, {4900,0.00868468}, {4950,0.00902703}, {5000,0.00885586}, {5050,0.00894595}, {5100,0.00912613}, {5150,0.00927027}, {5200,0.00951351}, {5250,0.00961261}, {5300,0.00966667}, {5350,0.00969369}, {5400,0.00971171}, {5450,0.01013514}, {5500,0.00979279}, {5550,0.00990090}, {5600,0.01000000}, {5650,0.01018018}, {5700,0.01038739}, {5750,0.01056757}, {5800,0.02051351}, {5850,0.00940541}, {5900,0.01071171}, {5950,0.01074775}, {6000,0.01076577}, {6050,0.01087387}, {6100,0.01104505}, {6150,0.00782883}, {6200,0.01127027}, {6250,0.01148649}, {6300,0.01154955}, {6350,0.01161261}, {6400,0.00975676}, {6450,0.01174775}, {6500,0.01179279}, {6550,0.01187387}, {6600,0.00978378}, {6650,0.01204505}, {6700,0.01204505}, {6750,0.01230631}, {6800,0.01181081}, {6850,0.01242342}, {6900,0.01263063}, {6950,0.01078378}, {7000,0.01304505}, {7050,0.01281081}, {7100,0.01176577}, {7150,0.01286486}, {7200,0.01312613}, {7250,0.01327928}, {7300,0.01342342}, {7350,0.01073874}, {7400,0.01347748}, {7450,0.01362162}, {7500,0.01365766}, {7550,0.01376577}, {7600,0.01381081}, {7650,0.01401802}, {7700,0.01296396}, {7750,0.01409910}, {7800,0.01265766}, {7850,0.01433333}, {7900,0.01282883}, {7950,0.01449550}, {8000,0.01391892}, {8050,0.01463964}, {8100,0.01474775}, {8150,0.01487387}, {8200,0.01543243}, {8250,0.03167568}, {8300,0.01514414}, {8350,0.01368468}, {8400,0.01537838}, {8450,0.01545045}, {8500,0.00881982}, {8550,0.01556757}, {8600,0.01571171}, {8650,0.01576577}, {8700,0.01577477}, {8750,0.01606306}, {8800,0.04416216}, {8850,0.01611712}, {8900,0.01628829}, {8950,0.01198198}, {9000,0.01647748}, {9050,0.01645045}, {9100,0.01581081}, {9150,0.03409910}, {9200,0.01681081}, {9250,0.01682883}, {9300,0.01706306}, {9350,0.01286486}, {9400,0.01731532}, {9450,0.01731532}, {9500,0.01724324}, {9550,0.01745045}, {9600,0.01468468}, {9650,0.03852252}, {9700,0.01772973}, {9750,0.01789189}, {9800,0.01802703}, {9850,0.01847748}, {9900,0.01824324}, {9950,0.01692793}, {10000,0.01530631}, {10100,0.01382883}, {10200,0.03267568}, {10300,0.04017117}, {10400,0.05070270}, {10500,0.05110811}, {10600,0.04479279}, {10700,0.03389189}, {10800,0.01463063}, {10900,0.01615315}, {11000,0.01809009}, {11100,0.02037838}, {11200,0.02088288}, {11300,0.02062162}, {11400,0.02095495}, {11500,0.04636036}, {11600,0.01830631}, {11700,0.02227027}, {11800,0.02158559}, {11900,0.06218018}, {12000,0.01919820}, {12100,0.02209910}, {12200,0.02246847}, {12300,0.01916216}, {12400,0.02265766}, {12500,0.06156757}, {12600,0.02241441}, {12700,0.02324324}, {12800,0.02012613}, {12900,0.02362162}, {13000,0.01962162}, {13100,0.02401802}, {13200,0.01941441}, {13300,0.02444144}, {13400,0.02065766}, {13500,0.02481982}, {13600,0.02398198}, {13700,0.04965766}, {13800,0.02533333}, {13900,0.02221622}, {14000,0.07934234}, {14100,0.02579279}, {14200,0.02351351}, {14300,0.01503604}, {14400,0.02634234}, {14500,0.02652252}, {14600,0.02421622}, {14700,0.02049550}, {14800,0.07307207}, {14900,0.02746847}, {15000,0.02754054}, {15100,0.02747748}, {15200,0.02731532}, {15300,0.02502703}, {15400,0.02384685}, {15500,0.02312613}, {15600,0.02267568}, {15700,0.02254054}, {15800,0.02283784}, {15900,0.02352252}, {16000,0.02456757}, {16100,0.02601802}, {16200,0.02855856}, {16300,0.02960360}, {16400,0.02998198}, {16500,0.03011712}, {16600,0.07731532}, {16700,0.02436937}, {16800,0.02688288}, {16900,0.03086486}, {17000,0.03115315}, {17100,0.01827928}, {17200,0.02727027}, {17300,0.03170270}, {17400,0.07241441}, {17500,0.02651351}, {17600,0.03222523}, {17700,0.05984685}, {17800,0.02898198}, {17900,0.03285586}, {18000,0.02630631}, {18100,0.03319820}, {18200,0.02551351}, {18300,0.03361261}, {18400,0.02502703}, {18500,0.03400901}, {18600,0.02658559}, {18700,0.03433333}, {18800,0.03028829}, {18900,0.08363964}, {19000,0.03407207}, {19100,0.02899099}, {19200,0.03554955}, {19300,0.03408108}, {19400,0.02816216}, {19500,0.08071171}, {19600,0.03618018}, {19700,0.03291892}, {19800,0.02824324}, {19900,0.06428829}, {20000,0.03703670}};
data["big"]["OCaml"]["actual reif"]["user"] = {{1,0.00003604}, {2,0.00009910}, {3,0.00013514}, {4,0.00003604}, {5,0.00006306}, {6,0.00018919}, {7,0.00014414}, {8,0.00009009}, {9,0.00012613}, {10,0.00019820}, {11,0.00013514}, {12,0.00020721}, {13,0.00017117}, {14,0.00020721}, {15,0.00027928}, {16,0.00007207}, {17,0.00009910}, {18,0.00010811}, {19,0.00012613}, {20,0.00013514}, {21,0.00017117}, {22,0.00012613}, {23,0.00017117}, {24,0.00012613}, {25,0.00019820}, {26,0.00006306}, {27,0.00002703}, {28,0.00023423}, {29,0.00016216}, {30,0.00013514}, {31,0.00027928}, {32,0.00006306}, {33,0.00022523}, {34,0.00024324}, {35,0.00027027}, {36,0.00009910}, {37,0.00009910}, {38,0.00009910}, {39,0.00016216}, {40,0.00019820}, {41,0.00014414}, {42,0.00018018}, {43,0.00017117}, {44,0.00026126}, {45,0.00017117}, {46,0.00022523}, {47,0.00024324}, {48,0.00033333}, {49,0.00036036}, {50,0.00018919}, {51,0.00036937}, {52,0.00016216}, {53,0.00016216}, {54,0.00007207}, {55,0.00006306}, {56,0.00019820}, {57,0.00009009}, {58,0.00011712}, {59,0.00019820}, {60,0.00018018}, {61,0.00024324}, {62,0.00024324}, {63,0.00006306}, {64,0.00023423}, {65,0.00013514}, {66,0.00015315}, {67,0.00019820}, {68,0.00023423}, {69,0.00019820}, {70,0.00020721}, {71,0.00014414}, {72,0.00031532}, {73,0.00005405}, {74,0.00017117}, {75,0.00025225}, {76,0.00013514}, {77,0.00019820}, {78,0.00012613}, {79,0.00006306}, {80,0.00018018}, {81,0.00039640}, {82,0.00018919}, {83,0.00020721}, {84,0.00023423}, {85,0.00023423}, {86,0.00013514}, {87,0.00035135}, {88,0.00020721}, {89,0.00005405}, {90,0.00014414}, {91,0.00013514}, {92,0.00003604}, {93,0.00025225}, {94,0.00023423}, {95,0.00036036}, {96,0.00027928}, {97,0.00039640}, {98,0.00010811}, {99,0.00013514}, {100,0.00027928}, {101,0.00019820}, {102,0.00030631}, {103,0.00020721}, {104,0.00027928}, {105,0.00013514}, {106,0.00025225}, {107,0.00018919}, {108,0.00022523}, {109,0.00028829}, {110,0.00024324}, {111,0.00015315}, {112,0.00017117}, {113,0.00027027}, {114,0.00051351}, {115,0.00029730}, {116,0.00017117}, {117,0.00017117}, {118,0.00024324}, {119,0.00041441}, {120,0.00023423}, {121,0.00009009}, {122,0.00020721}, {123,0.00034234}, {124,0.00032432}, {125,0.00011712}, {126,0.00007207}, {127,0.00021622}, {128,0.00030631}, {129,0.00037838}, {130,0.00031532}, {131,0.00018919}, {132,0.00009009}, {133,0.00020721}, {134,0.00032432}, {135,0.00027027}, {136,0.00022523}, {137,0.00019820}, {138,0.00016216}, {139,0.00036937}, {140,0.00027928}, {141,0.00007207}, {142,0.00025225}, {143,0.00036036}, {144,0.00037838}, {145,0.00015315}, {146,0.00017117}, {147,0.00023423}, {148,0.00027027}, {149,0.00023423}, {150,0.00041441}, {151,0.00021622}, {152,0.00034234}, {153,0.00032432}, {154,0.00027027}, {155,0.00030631}, {156,0.00027027}, {157,0.00023423}, {158,0.00023423}, {159,0.00026126}, {160,0.00095495}, {161,0.00025225}, {162,0.00025225}, {163,0.00034234}, {164,0.00026126}, {165,0.00027928}, {166,0.00012613}, {167,0.00016216}, {168,0.00014414}, {169,0.00023423}, {170,0.00026126}, {171,0.00020721}, {172,0.00033333}, {173,0.00036937}, {174,0.00033333}, {175,0.00023423}, {176,0.00013514}, {177,0.00018018}, {178,0.00017117}, {179,0.00035135}, {180,0.00034234}, {181,0.00046847}, {182,0.00045045}, {183,0.00023423}, {184,0.00041441}, {185,0.00009009}, {186,0.00012613}, {187,0.00037838}, {188,0.00037838}, {189,0.00035135}, {190,0.00025225}, {191,0.00021622}, {192,0.00035135}, {193,0.00024324}, {194,0.00041441}, {195,0.00040541}, {196,0.00029730}, {197,0.00022523}, {198,0.00033333}, {199,0.00042342}, {200,0.00016216}, {201,0.00024324}, {202,0.00022523}, {203,0.00037838}, {204,0.00047748}, {205,0.00030631}, {206,0.00138739}, {207,0.00023423}, {208,0.00027027}, {209,0.00025225}, {210,0.00016216}, {211,0.00033333}, {212,0.00019820}, {213,0.00045946}, {214,0.00032432}, {215,0.00036937}, {216,0.00046847}, {217,0.00022523}, {218,0.00036036}, {219,0.00029730}, {220,0.00045946}, {221,0.00036036}, {222,0.00055856}, {223,0.00020721}, {224,0.00016216}, {225,0.00031532}, {226,0.00035135}, {227,0.00029730}, {228,0.00036036}, {229,0.00027928}, {230,0.00026126}, {231,0.00063964}, {232,0.00037838}, {233,0.00043243}, {234,0.00046847}, {235,0.00035135}, {236,0.00017117}, {237,0.00028829}, {238,0.00032432}, {239,0.00021622}, {240,0.00025225}, {241,0.00023423}, {242,0.00019820}, {243,0.00032432}, {244,0.00032432}, {245,0.00022523}, {246,0.00036937}, {247,0.00052252}, {248,0.00036937}, {249,0.00055856}, {250,0.00034234}, {251,0.00021622}, {252,0.00055856}, {253,0.00029730}, {254,0.00044144}, {255,0.00039640}, {256,0.00026126}, {257,0.00052252}, {258,0.00039640}, {259,0.00035135}, {260,0.00036036}, {261,0.00020721}, {262,0.00032432}, {263,0.00032432}, {264,0.00054054}, {265,0.00051351}, {266,0.00036036}, {267,0.00018018}, {268,0.00035135}, {269,0.00028829}, {270,0.00038739}, {271,0.00018018}, {272,0.00019820}, {273,0.00052252}, {274,0.00049550}, {275,0.00039640}, {276,0.00043243}, {277,0.00036036}, {278,0.00030631}, {279,0.00032432}, {280,0.00035135}, {281,0.00050450}, {282,0.00052252}, {283,0.00038739}, {284,0.00033333}, {285,0.00036937}, {286,0.00033333}, {287,0.00053153}, {288,0.00046847}, {289,0.00064865}, {290,0.00036937}, {291,0.00066667}, {292,0.00042342}, {293,0.00040541}, {294,0.00036036}, {295,0.00037838}, {296,0.00059459}, {297,0.00014414}, {298,0.00048649}, {299,0.00014414}, {300,0.00057658}, {301,0.00027027}, {302,0.00047748}, {303,0.00045045}, {304,0.00030631}, {305,0.00027928}, {306,0.00009910}, {307,0.00050450}, {308,0.00043243}, {309,0.00035135}, {310,0.00053153}, {311,0.00064865}, {312,0.00038739}, {313,0.00048649}, {314,0.00048649}, {315,0.00039640}, {316,0.00027027}, {317,0.00026126}, {318,0.00033333}, {319,0.00046847}, {320,0.00033333}, {321,0.00068468}, {322,0.00038739}, {323,0.00036036}, {324,0.00057658}, {325,0.00052252}, {326,0.00028829}, {327,0.00059459}, {328,0.00034234}, {329,0.00056757}, {330,0.00054955}, {331,0.00013514}, {332,0.00047748}, {333,0.00048649}, {334,0.00041441}, {335,0.00047748}, {336,0.00038739}, {337,0.00064865}, {338,0.00053153}, {339,0.00034234}, {340,0.00030631}, {341,0.00059459}, {342,0.00058559}, {343,0.00052252}, {344,0.00050450}, {345,0.00043243}, {346,0.00068468}, {347,0.00054054}, {348,0.00020721}, {349,0.00028829}, {350,0.00068468}, {351,0.00037838}, {352,0.00048649}, {353,0.00048649}, {354,0.00039640}, {355,0.00053153}, {356,0.00062162}, {357,0.00046847}, {358,0.00052252}, {359,0.00063063}, {360,0.00061261}, {361,0.00045946}, {362,0.00052252}, {363,0.00069369}, {364,0.00054054}, {365,0.00056757}, {366,0.00028829}, {367,0.00070270}, {368,0.00048649}, {369,0.00020721}, {370,0.00058559}, {371,0.00047748}, {372,0.00062162}, {373,0.00036937}, {374,0.00060360}, {375,0.00049550}, {376,0.00069369}, {377,0.00057658}, {378,0.00057658}, {379,0.00046847}, {380,0.00066667}, {381,0.00061261}, {382,0.00039640}, {383,0.00061261}, {384,0.00038739}, {385,0.00070270}, {386,0.00060360}, {387,0.00072072}, {388,0.00032432}, {389,0.00033333}, {390,0.00034234}, {391,0.00041441}, {392,0.00031532}, {393,0.00062162}, {394,0.00052252}, {395,0.00037838}, {396,0.00048649}, {397,0.00057658}, {398,0.00050450}, {399,0.00065766}, {400,0.00041441}, {401,0.00038739}, {402,0.00033333}, {403,0.00029730}, {404,0.00036036}, {405,0.00040541}, {406,0.00059459}, {407,0.00042342}, {408,0.00063063}, {409,0.00045946}, {410,0.00052252}, {411,0.00032432}, {412,0.00038739}, {413,0.00044144}, {414,0.00068468}, {415,0.00072072}, {416,0.00060360}, {417,0.00066667}, {418,0.00054955}, {419,0.00061261}, {420,0.00060360}, {421,0.00062162}, {422,0.00060360}, {423,0.00044144}, {424,0.00046847}, {425,0.00054955}, {426,0.00061261}, {427,0.00078378}, {428,0.00069369}, {429,0.00045045}, {430,0.00039640}, {431,0.00052252}, {432,0.00025225}, {433,0.00048649}, {434,0.00034234}, {435,0.00048649}, {436,0.00066667}, {437,0.00080180}, {438,0.00054054}, {439,0.00053153}, {440,0.00054054}, {441,0.00053153}, {442,0.00047748}, {443,0.00061261}, {444,0.00057658}, {445,0.00048649}, {446,0.00043243}, {447,0.00041441}, {448,0.00057658}, {449,0.00070270}, {450,0.00065766}, {451,0.00067568}, {452,0.00038739}, {453,0.00038739}, {454,0.00039640}, {455,0.00065766}, {456,0.00057658}, {457,0.00067568}, {458,0.00050450}, {459,0.00081081}, {460,0.00067568}, {461,0.00036937}, {462,0.00047748}, {463,0.00035135}, {464,0.00051351}, {465,0.00081982}, {466,0.00085586}, {467,0.00174775}, {468,0.00048649}, {469,0.00053153}, {470,0.00065766}, {471,0.00064865}, {472,0.00081081}, {473,0.00059459}, {474,0.00037838}, {475,0.00066667}, {476,0.00068468}, {477,0.00042342}, {478,0.00054955}, {479,0.00044144}, {480,0.00072072}, {481,0.00066667}, {482,0.00076577}, {483,0.00058559}, {484,0.00073874}, {485,0.00069369}, {486,0.00054955}, {487,0.00063964}, {488,0.00058559}, {489,0.00062162}, {490,0.00064865}, {491,0.00061261}, {492,0.00060360}, {493,0.00075676}, {494,0.00059459}, {495,0.00071171}, {496,0.00080180}, {497,0.00060360}, {498,0.00065766}, {499,0.00058559}, {500,0.00041441}, {505,0.00061261}, {510,0.00087387}, {515,0.00071171}, {520,0.00056757}, {525,0.00068468}, {530,0.00072973}, {535,0.00083784}, {540,0.00056757}, {545,0.00052252}, {550,0.00063063}, {555,0.00076577}, {560,0.00071171}, {565,0.00075676}, {570,0.00054955}, {575,0.00082883}, {580,0.00051351}, {585,0.00085586}, {590,0.00085586}, {595,0.00054054}, {600,0.00072072}, {605,0.00061261}, {610,0.00076577}, {615,0.00066667}, {620,0.00077477}, {625,0.00076577}, {630,0.00097297}, {635,0.00093694}, {640,0.00090991}, {645,0.00094595}, {650,0.00126126}, {655,0.00081081}, {660,0.00066667}, {665,0.00072973}, {670,0.00068468}, {675,0.00100000}, {680,0.00133333}, {685,0.00117117}, {690,0.00105405}, {695,0.00094595}, {700,0.00081982}, {705,0.00072973}, {710,0.00084685}, {715,0.00099099}, {720,0.00081982}, {725,0.00115315}, {730,0.00105405}, {735,0.00060360}, {740,0.00122523}, {745,0.00101802}, {750,0.00109009}, {755,0.00087387}, {760,0.00071171}, {765,0.00112613}, {770,0.00084685}, {775,0.00095495}, {780,0.00077477}, {785,0.00118919}, {790,0.00123423}, {795,0.00082883}, {800,0.00127027}, {805,0.00078378}, {810,0.00135135}, {815,0.00094595}, {820,0.00084685}, {825,0.00109910}, {830,0.00105405}, {835,0.00128829}, {840,0.00085586}, {845,0.00091892}, {850,0.00120721}, {855,0.00098198}, {860,0.00109009}, {865,0.00081081}, {870,0.00093694}, {875,0.00099099}, {880,0.00120721}, {885,0.00136937}, {890,0.00116216}, {895,0.00104505}, {900,0.00111712}, {905,0.00087387}, {910,0.00110811}, {915,0.00098198}, {920,0.00089189}, {925,0.00095495}, {930,0.00116216}, {935,0.00102703}, {940,0.00116216}, {945,0.00114414}, {950,0.00121622}, {955,0.00110811}, {960,0.00141441}, {965,0.00125225}, {970,0.00117117}, {975,0.00114414}, {980,0.00097297}, {985,0.00122523}, {990,0.00114414}, {995,0.00113514}, {1000,0.00104505}, {1010,0.00131532}, {1020,0.00106306}, {1030,0.00127928}, {1040,0.00116216}, {1050,0.00138739}, {1060,0.00124324}, {1070,0.00151351}, {1080,0.00131532}, {1090,0.00122523}, {1100,0.00132432}, {1110,0.00136937}, {1120,0.00103604}, {1130,0.00136036}, {1140,0.00125225}, {1150,0.00135135}, {1160,0.00147748}, {1170,0.00139640}, {1180,0.00120721}, {1190,0.00147748}, {1200,0.00194595}, {1210,0.00182883}, {1220,0.00164865}, {1230,0.00146847}, {1240,0.00176577}, {1250,0.00142342}, {1260,0.00159459}, {1270,0.00145045}, {1280,0.00153153}, {1290,0.00181081}, {1300,0.00159459}, {1310,0.00152252}, {1320,0.00194595}, {1330,0.00154054}, {1340,0.00182883}, {1350,0.00155856}, {1360,0.00145045}, {1370,0.00195495}, {1380,0.00152252}, {1390,0.00172072}, {1400,0.00195495}, {1410,0.00154054}, {1420,0.00191892}, {1430,0.00179279}, {1440,0.00185586}, {1450,0.00212613}, {1460,0.00200901}, {1470,0.00173874}, {1480,0.00181081}, {1490,0.00170270}, {1500,0.00172973}, {1510,0.00191892}, {1520,0.00152252}, {1530,0.00178378}, {1540,0.00191892}, {1550,0.00227027}, {1560,0.00195495}, {1570,0.00228829}, {1580,0.00222523}, {1590,0.00193694}, {1600,0.00193694}, {1610,0.00220721}, {1620,0.00226126}, {1630,0.00228829}, {1640,0.00216216}, {1650,0.00192793}, {1660,0.00221622}, {1670,0.00203604}, {1680,0.00192793}, {1690,0.00214414}, {1700,0.00207207}, {1710,0.00233333}, {1720,0.00221622}, {1730,0.00261261}, {1740,0.00240541}, {1750,0.00230631}, {1760,0.00245045}, {1770,0.00256757}, {1780,0.00247748}, {1790,0.00263063}, {1800,0.00232432}, {1810,0.00250450}, {1820,0.00226126}, {1830,0.00222523}, {1840,0.00256757}, {1850,0.00254054}, {1860,0.00271171}, {1870,0.00204505}, {1880,0.00228829}, {1890,0.00261261}, {1900,0.00276577}, {1910,0.00270270}, {1920,0.00269369}, {1930,0.00294595}, {1940,0.00245045}, {1950,0.00722523}, {1960,0.00273874}, {1970,0.00270270}, {1980,0.00263964}, {1990,0.00279279}, {2000,0.00290991}, {2050,0.00279279}, {2100,0.00298198}, {2150,0.00303604}, {2200,0.00296396}, {2250,0.00339640}, {2300,0.00334234}, {2350,0.00345946}, {2400,0.00361261}, {2450,0.00381982}, {2500,0.00373874}, {2550,0.00354054}, {2600,0.00403604}, {2650,0.00392793}, {2700,0.00434234}, {2750,0.00422523}, {2800,0.00443243}, {2850,0.00436036}, {2900,0.00504505}, {2950,0.00363063}, {3000,0.00483784}, {3050,0.00504505}, {3100,0.00499099}, {3150,0.00512613}, {3200,0.01240541}, {3250,0.00561261}, {3300,0.00561261}, {3350,0.00583784}, {3400,0.00568468}, {3450,0.00572973}, {3500,0.00585586}, {3550,0.00633333}, {3600,0.00609009}, {3650,0.00627928}, {3700,0.00620721}, {3750,0.00634234}, {3800,0.00589189}, {3850,0.00671171}, {3900,0.00675676}, {3950,0.00678378}, {4000,0.00647748}, {4050,0.00702703}, {4100,0.00708108}, {4150,0.00744144}, {4200,0.00736036}, {4250,0.00623423}, {4300,0.00756757}, {4350,0.00746847}, {4400,0.00764865}, {4450,0.00769369}, {4500,0.00806306}, {4550,0.00777477}, {4600,0.00563063}, {4650,0.00782883}, {4700,0.00868468}, {4750,0.00844144}, {4800,0.00871171}, {4850,0.00899099}, {4900,0.00862162}, {4950,0.00878378}, {5000,0.00899099}, {5050,0.00944144}, {5100,0.00920721}, {5150,0.00881081}, {5200,0.00876577}, {5250,0.00952252}, {5300,0.00947748}, {5350,0.00973874}, {5400,0.01001802}, {5450,0.01052252}, {5500,0.01025225}, {5550,0.01018018}, {5600,0.01061261}, {5650,0.01018018}, {5700,0.01028829}, {5750,0.01054054}, {5800,0.02008108}, {5850,0.00936937}, {5900,0.01081982}, {5950,0.01141441}, {6000,0.01124324}, {6050,0.01131532}, {6100,0.01160360}, {6150,0.00774775}, {6200,0.01160360}, {6250,0.01163964}, {6300,0.01182883}, {6350,0.01204505}, {6400,0.01005405}, {6450,0.01219820}, {6500,0.01222523}, {6550,0.01227928}, {6600,0.01025225}, {6650,0.01251351}, {6700,0.01221622}, {6750,0.01261261}, {6800,0.01230631}, {6850,0.01264865}, {6900,0.01286486}, {6950,0.01101802}, {7000,0.01351351}, {7050,0.01305405}, {7100,0.01200901}, {7150,0.01345045}, {7200,0.01344144}, {7250,0.01365766}, {7300,0.01351351}, {7350,0.01101802}, {7400,0.01363964}, {7450,0.01385586}, {7500,0.01374775}, {7550,0.01380180}, {7600,0.01428829}, {7650,0.01432432}, {7700,0.01316216}, {7750,0.01430631}, {7800,0.01296396}, {7850,0.01463063}, {7900,0.01300000}, {7950,0.01449550}, {8000,0.01394595}, {8050,0.01482883}, {8100,0.01518018}, {8150,0.01492793}, {8200,0.01563964}, {8250,0.03133333}, {8300,0.01511712}, {8350,0.01391892}, {8400,0.01556757}, {8450,0.01540541}, {8500,0.00858559}, {8550,0.01581081}, {8600,0.01570270}, {8650,0.01575676}, {8700,0.01614414}, {8750,0.01620721}, {8800,0.04449550}, {8850,0.01609009}, {8900,0.01603604}, {8950,0.01264865}, {9000,0.01647748}, {9050,0.01620721}, {9100,0.01577477}, {9150,0.03424324}, {9200,0.01687387}, {9250,0.01685586}, {9300,0.01714414}, {9350,0.01322523}, {9400,0.01682883}, {9450,0.01722523}, {9500,0.01733333}, {9550,0.01760360}, {9600,0.01462162}, {9650,0.03855856}, {9700,0.01771171}, {9750,0.01768468}, {9800,0.01805405}, {9850,0.01863063}, {9900,0.01812613}, {9950,0.01681982}, {10000,0.01520721}, {10100,0.01363964}, {10200,0.03274775}, {10300,0.04005405}, {10400,0.05048649}, {10500,0.05149550}, {10600,0.04499099}, {10700,0.03380180}, {10800,0.01466667}, {10900,0.01612613}, {11000,0.01808108}, {11100,0.02028829}, {11200,0.02101802}, {11300,0.02076577}, {11400,0.02109910}, {11500,0.04661261}, {11600,0.01831532}, {11700,0.02228829}, {11800,0.02179279}, {11900,0.06236937}, {12000,0.01900000}, {12100,0.02273874}, {12200,0.02272973}, {12300,0.01925225}, {12400,0.02304505}, {12500,0.06107207}, {12600,0.02307207}, {12700,0.02374775}, {12800,0.02030631}, {12900,0.02366667}, {13000,0.01964865}, {13100,0.02434234}, {13200,0.01927928}, {13300,0.02461261}, {13400,0.02094595}, {13500,0.02490991}, {13600,0.02434234}, {13700,0.04977477}, {13800,0.02557658}, {13900,0.02257658}, {14000,0.07923423}, {14100,0.02587387}, {14200,0.02380180}, {14300,0.01506306}, {14400,0.02619820}, {14500,0.02626126}, {14600,0.02470270}, {14700,0.02057658}, {14800,0.07308108}, {14900,0.02724324}, {15000,0.02752252}, {15100,0.02728829}, {15200,0.02725225}, {15300,0.02514414}, {15400,0.02399099}, {15500,0.02383784}, {15600,0.02312613}, {15700,0.02301802}, {15800,0.02343243}, {15900,0.02400901}, {16000,0.02498198}, {16100,0.02602703}, {16200,0.02842342}, {16300,0.02964865}, {16400,0.03016216}, {16500,0.02997297}, {16600,0.07782883}, {16700,0.02465766}, {16800,0.02679279}, {16900,0.03093694}, {17000,0.03118018}, {17100,0.01845946}, {17200,0.02729730}, {17300,0.03192793}, {17400,0.07234234}, {17500,0.02641441}, {17600,0.03237838}, {17700,0.06001802}, {17800,0.02890991}, {17900,0.03314414}, {18000,0.02637838}, {18100,0.03353153}, {18200,0.02554955}, {18300,0.03350450}, {18400,0.02529730}, {18500,0.03413514}, {18600,0.02649550}, {18700,0.03435135}, {18800,0.03034234}, {18900,0.08369369}, {19000,0.03445045}, {19100,0.02887387}, {19200,0.03575676}, {19300,0.03443243}, {19400,0.02818018}, {19500,0.07972973}, {19600,0.03641441}, {19700,0.03303604}, {19800,0.02818919}, {19900,0.06378378}, {20000,0.03722936}};
data["big"]["OCaml"]["actual reif"]["system"] = {{1,0.00007207}, {2,0.00003604}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003604}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00003604}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00003604}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00003604}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00003604}, {96,0.00000000}, {97,0.00000000}, {98,0.00003604}, {99,0.00003604}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00003604}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00003604}, {115,0.00000000}, {116,0.00007207}, {117,0.00000000}, {118,0.00000000}, {119,0.00007207}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00003604}, {128,0.00000000}, {129,0.00003604}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00003604}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00003604}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00003604}, {147,0.00000000}, {148,0.00003604}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00003604}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00003604}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00003604}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00003604}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00003604}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00002703}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00003604}, {272,0.00000000}, {273,0.00000000}, {274,0.00003604}, {275,0.00000000}, {276,0.00003604}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00003604}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00003604}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00003604}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00003604}, {323,0.00000000}, {324,0.00003604}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00002703}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00007207}, {338,0.00003604}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00003604}, {345,0.00000000}, {346,0.00000000}, {347,0.00003604}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00003604}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00003604}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00003604}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00003604}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00003604}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00007207}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00003604}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00003604}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00003604}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00003604}, {461,0.00003604}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00002703}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00003604}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00003604}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00003604}, {494,0.00000000}, {495,0.00003604}, {496,0.00000000}, {497,0.00000000}, {498,0.00003604}, {499,0.00000000}, {500,0.00000000}, {505,0.00003604}, {510,0.00000000}, {515,0.00000000}, {520,0.00003604}, {525,0.00000000}, {530,0.00003604}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00003604}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00007207}, {600,0.00003604}, {605,0.00003604}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00003604}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00003604}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00003604}, {805,0.00003604}, {810,0.00003604}, {815,0.00000000}, {820,0.00000000}, {825,0.00003604}, {830,0.00007207}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00003604}, {855,0.00003604}, {860,0.00000000}, {865,0.00003604}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00003604}, {950,0.00000000}, {955,0.00000000}, {960,0.00010811}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00003604}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00003604}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00003604}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00007207}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00003604}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003604}, {1290,0.00000000}, {1300,0.00003604}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00003604}, {1360,0.00003604}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00003604}, {1440,0.00003604}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00003604}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00003604}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00003604}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00003604}, {1800,0.00000000}, {1810,0.00007207}, {1820,0.00003604}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00007207}, {1870,0.00003604}, {1880,0.00000000}, {1890,0.00003604}, {1900,0.00000000}, {1910,0.00003604}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00003604}, {1950,0.00007207}, {1960,0.00007207}, {1970,0.00003604}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00003604}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00003604}, {2250,0.00003604}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00003604}, {2500,0.00000000}, {2550,0.00003604}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00003604}, {3000,0.00000000}, {3050,0.00003604}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00014414}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00003604}, {3450,0.00000000}, {3500,0.00003604}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00003604}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00003604}, {4050,0.00000000}, {4100,0.00003604}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00007207}, {4450,0.00007207}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00003604}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00010811}, {4850,0.00003604}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00010811}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00003604}, {5400,0.00003604}, {5450,0.00000000}, {5500,0.00007207}, {5550,0.00003604}, {5600,0.00000000}, {5650,0.00003604}, {5700,0.00003604}, {5750,0.00000000}, {5800,0.00018018}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00003604}, {6050,0.00000000}, {6100,0.00002703}, {6150,0.00003604}, {6200,0.00002703}, {6250,0.00003604}, {6300,0.00003604}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00003604}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00007207}, {6700,0.00003604}, {6750,0.00002703}, {6800,0.00003604}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00007207}, {7100,0.00007207}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00007207}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00003604}, {7500,0.00000000}, {7550,0.00003604}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00003604}, {7750,0.00000000}, {7800,0.00003604}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00002703}, {8050,0.00002703}, {8100,0.00000000}, {8150,0.00003604}, {8200,0.00000000}, {8250,0.00044144}, {8300,0.00010811}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00003604}, {8650,0.00000000}, {8700,0.00003604}, {8750,0.00000000}, {8800,0.00002703}, {8850,0.00000000}, {8900,0.00003604}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00007207}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00003604}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00010811}, {9400,0.00003604}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00003604}, {9600,0.00010811}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00007207}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00003604}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00003604}, {10700,0.00003604}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00003604}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00003604}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00003604}, {12200,0.00000000}, {12300,0.00002703}, {12400,0.00000000}, {12500,0.00003604}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00003604}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00003604}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00003604}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00003604}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00003604}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00003604}, {14900,0.00000000}, {15000,0.00010811}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00003604}, {15900,0.00000000}, {16000,0.00002703}, {16100,0.00003604}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00007207}, {16900,0.00003604}, {17000,0.00007207}, {17100,0.00000000}, {17200,0.00007207}, {17300,0.00000000}, {17400,0.00007207}, {17500,0.00003604}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00003604}, {17900,0.00007207}, {18000,0.00000000}, {18100,0.00003604}, {18200,0.00003604}, {18300,0.00000000}, {18400,0.00003604}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00003604}, {18800,0.00007207}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00006306}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00003604}, {19500,0.00092793}, {19600,0.00003604}, {19700,0.00007207}, {19800,0.00000000}, {19900,0.00074775}, {20000,0.00003670}};
data["big"]["OCaml"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00084685}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00001802}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00001802}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00111712}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000901}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000901}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000901}, {466,0.00000901}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00002703}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000901}, {476,0.00000901}, {477,0.00000000}, {478,0.00001802}, {479,0.00002703}, {480,0.00002703}, {481,0.00001802}, {482,0.00000901}, {483,0.00001802}, {484,0.00001802}, {485,0.00001802}, {486,0.00003604}, {487,0.00003604}, {488,0.00003604}, {489,0.00006306}, {490,0.00007207}, {491,0.00007207}, {492,0.00005405}, {493,0.00007207}, {494,0.00004505}, {495,0.00010811}, {496,0.00007207}, {497,0.00196396}, {498,0.00010811}, {499,0.00013514}, {500,0.00016216}, {505,0.00023423}, {510,0.00036937}, {515,0.00042342}, {520,0.00064865}, {525,0.00070270}, {530,0.00074775}, {535,0.00083784}, {540,0.00083784}, {545,0.00094595}, {550,0.00098198}, {555,0.00099099}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00105405}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00103604}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00353153}, {765,0.00100000}, {770,0.00100000}, {775,0.00105405}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00100000}, {830,0.00100000}, {835,0.00100000}, {840,0.00100000}, {845,0.00100000}, {850,0.00100000}, {855,0.00100000}, {860,0.00100000}, {865,0.00100000}, {870,0.00100000}, {875,0.00100000}, {880,0.00100000}, {885,0.00100000}, {890,0.00100000}, {895,0.00100000}, {900,0.00100901}, {905,0.00100000}, {910,0.00100000}, {915,0.00100000}, {920,0.00100000}, {925,0.00100901}, {930,0.00100000}, {935,0.00100000}, {940,0.00100901}, {945,0.00100901}, {950,0.00102703}, {955,0.00101802}, {960,0.00105405}, {965,0.00102703}, {970,0.00107207}, {975,0.00112613}, {980,0.00118018}, {985,0.00129730}, {990,0.00123423}, {995,0.00143243}, {1000,0.00158559}, {1010,0.00159459}, {1020,0.00170270}, {1030,0.00174775}, {1040,0.00181982}, {1050,0.00189189}, {1060,0.00194595}, {1070,0.00199099}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00696396}, {1130,0.00200000}, {1140,0.00200000}, {1150,0.00200000}, {1160,0.00200000}, {1170,0.00200000}, {1180,0.00200000}, {1190,0.00200000}, {1200,0.00200000}, {1210,0.00200000}, {1220,0.00200000}, {1230,0.00200000}, {1240,0.00200000}, {1250,0.00200000}, {1260,0.00200000}, {1270,0.00200000}, {1280,0.00200000}, {1290,0.00200000}, {1300,0.00200000}, {1310,0.00200000}, {1320,0.00200000}, {1330,0.00200000}, {1340,0.00200000}, {1350,0.00200000}, {1360,0.00200000}, {1370,0.00200901}, {1380,0.00200000}, {1390,0.00200000}, {1400,0.00200000}, {1410,0.00200000}, {1420,0.00205405}, {1430,0.00210811}, {1440,0.00217117}, {1450,0.00213514}, {1460,0.00217117}, {1470,0.00235135}, {1480,0.00249550}, {1490,0.00255856}, {1500,0.00263964}, {1510,0.00273874}, {1520,0.00278378}, {1530,0.00278378}, {1540,0.01065766}, {1550,0.00286486}, {1560,0.00294595}, {1570,0.00294595}, {1580,0.00299099}, {1590,0.00300000}, {1600,0.00300000}, {1610,0.00300000}, {1620,0.00312613}, {1630,0.00300000}, {1640,0.00300000}, {1650,0.00300000}, {1660,0.00300000}, {1670,0.00300000}, {1680,0.00300000}, {1690,0.00300000}, {1700,0.00300000}, {1710,0.00300000}, {1720,0.00300000}, {1730,0.00300000}, {1740,0.00300000}, {1750,0.00300000}, {1760,0.00300000}, {1770,0.00300000}, {1780,0.00300000}, {1790,0.00300000}, {1800,0.00307207}, {1810,0.00300000}, {1820,0.00300000}, {1830,0.00300000}, {1840,0.00300000}, {1850,0.00300000}, {1860,0.00300000}, {1870,0.01365766}, {1880,0.00302703}, {1890,0.00302703}, {1900,0.00304505}, {1910,0.00326126}, {1920,0.00315315}, {1930,0.00325225}, {1940,0.00327027}, {1950,0.00344144}, {1960,0.00341441}, {1970,0.00351351}, {1980,0.00354955}, {1990,0.00360360}, {2000,0.00374775}, {2050,0.00384685}, {2100,0.00399099}, {2150,0.00400000}, {2200,0.00400000}, {2250,0.00400901}, {2300,0.00400901}, {2350,0.00403604}, {2400,0.00417117}, {2450,0.00449550}, {2500,0.00473874}, {2550,0.00483784}, {2600,0.00495495}, {2650,0.00500000}, {2700,0.00500000}, {2750,0.00500901}, {2800,0.00505405}, {2850,0.00509009}, {2900,0.00532432}, {2950,0.01945946}, {3000,0.00576577}, {3050,0.00587387}, {3100,0.00594595}, {3150,0.00599099}, {3200,0.00600000}, {3250,0.00602703}, {3300,0.00607207}, {3350,0.00618018}, {3400,0.00654054}, {3450,0.00664865}, {3500,0.00675676}, {3550,0.00700901}, {3600,0.00694595}, {3650,0.00697297}, {3700,0.00701802}, {3750,0.00706306}, {3800,0.01551351}, {3850,0.00735135}, {3900,0.00765766}, {3950,0.00768468}, {4000,0.01739640}, {4050,0.00787387}, {4100,0.00797297}, {4150,0.00801802}, {4200,0.00803604}, {4250,0.02363964}, {4300,0.00831532}, {4350,0.00847748}, {4400,0.00883784}, {4450,0.00873874}, {4500,0.00882883}, {4550,0.00858559}, {4600,0.03238739}, {4650,0.00902703}, {4700,0.00907207}, {4750,0.00922523}, {4800,0.00934234}, {4850,0.00981081}, {4900,0.01022523}, {4950,0.00975676}, {5000,0.00980180}, {5050,0.00990991}, {5100,0.00997297}, {5150,0.01007207}, {5200,0.01021622}, {5250,0.01035135}, {5300,0.01045946}, {5350,0.01065766}, {5400,0.01075676}, {5450,0.01076577}, {5500,0.01139640}, {5550,0.01127027}, {5600,0.01120721}, {5650,0.01108108}, {5700,0.01125225}, {5750,0.01140541}, {5800,0.01158559}, {5850,0.02676577}, {5900,0.01171171}, {5950,0.01177477}, {6000,0.01239640}, {6050,0.01192793}, {6100,0.01203604}, {6150,0.06290090}, {6200,0.01211712}, {6250,0.01252252}, {6300,0.01299099}, {6350,0.01272072}, {6400,0.05472973}, {6450,0.01278378}, {6500,0.01351351}, {6550,0.01297297}, {6600,0.05169369}, {6650,0.01324324}, {6700,0.01400901}, {6750,0.01358559}, {6800,0.03172072}, {6850,0.01369369}, {6900,0.01372973}, {6950,0.04001802}, {7000,0.01380180}, {7050,0.01399099}, {7100,0.03421622}, {7150,0.01504505}, {7200,0.01445946}, {7250,0.01455856}, {7300,0.01481982}, {7350,0.04797297}, {7400,0.01555856}, {7450,0.01483784}, {7500,0.01485586}, {7550,0.01497297}, {7600,0.01476577}, {7650,0.01543243}, {7700,0.03576577}, {7750,0.01598198}, {7800,0.03711712}, {7850,0.01606306}, {7900,0.03654955}, {7950,0.01614414}, {8000,0.03225225}, {8050,0.01604505}, {8100,0.01621622}, {8150,0.01635135}, {8200,0.01650450}, {8250,0.01662162}, {8300,0.01722523}, {8350,0.03660360}, {8400,0.01676577}, {8450,0.01681081}, {8500,0.01690991}, {8550,0.01738739}, {8600,0.01702703}, {8650,0.01745045}, {8700,0.01804505}, {8750,0.01671171}, {8800,0.01768468}, {8850,0.01815315}, {8900,0.01777477}, {8950,0.06327928}, {9000,0.01801802}, {9050,0.01909009}, {9100,0.03166667}, {9150,0.01841441}, {9200,0.01871171}, {9250,0.01956757}, {9300,0.02602703}, {9350,0.06260360}, {9400,0.01889189}, {9450,0.01932432}, {9500,0.01907207}, {9550,0.01842342}, {9600,0.05479279}, {9650,0.01956757}, {9700,0.01961261}, {9750,0.02007207}, {9800,0.02064865}, {9850,0.01972973}, {9900,0.01981982}, {9950,0.03835135}, {10000,0.05509009}, {10100,0.06916216}, {10200,0.02056757}, {10300,0.02072973}, {10400,0.02085586}, {10500,0.02112613}, {10600,0.02133333}, {10700,0.02161261}, {10800,0.07680180}, {10900,0.05537838}, {11000,0.06236937}, {11100,0.03357658}, {11200,0.02261261}, {11300,0.02327027}, {11400,0.02342342}, {11500,0.02334234}, {11600,0.06517117}, {11700,0.02363063}, {11800,0.02459459}, {11900,0.02401802}, {12000,0.06812613}, {12100,0.02575676}, {12200,0.02494595}, {12300,0.06911712}, {12400,0.02633333}, {12500,0.02532432}, {12600,0.04727928}, {12700,0.02630631}, {12800,0.07400901}, {12900,0.02696396}, {13000,0.06847748}, {13100,0.02765766}, {13200,0.08770270}, {13300,0.02796396}, {13400,0.07618018}, {13500,0.02790090}, {13600,0.05129730}, {13700,0.02773874}, {13800,0.02918919}, {13900,0.06973874}, {14000,0.02837838}, {14100,0.02976577}, {14200,0.06600000}, {14300,0.02902703}, {14400,0.02983784}, {14500,0.03078378}, {14600,0.06669369}, {14700,0.09809910}, {14800,0.02996396}, {14900,0.03106306}, {15000,0.03150450}, {15100,0.03002703}, {15200,0.05897297}, {15300,0.06815315}, {15400,0.08154054}, {15500,0.10799099}, {15600,0.10667568}, {15700,0.10609910}, {15800,0.10709910}, {15900,0.10070270}, {16000,0.08981081}, {16100,0.07960360}, {16200,0.06411712}, {16300,0.05137838}, {16400,0.03475676}, {16500,0.03439640}, {16600,0.03403604}, {16700,0.13792793}, {16800,0.08599099}, {16900,0.05489189}, {17000,0.03543243}, {17100,0.03459459}, {17200,0.08695495}, {17300,0.03672973}, {17400,0.03610811}, {17500,0.09542342}, {17600,0.03714414}, {17700,0.03628829}, {17800,0.08418018}, {17900,0.03740541}, {18000,0.12266667}, {18100,0.03845045}, {18200,0.12964865}, {18300,0.03761261}, {18400,0.12609009}, {18500,0.03898198}, {18600,0.13374775}, {18700,0.03960360}, {18800,0.10240541}, {18900,0.03938739}, {19000,0.07236937}, {19100,0.12500901}, {19200,0.04040541}, {19300,0.07384685}, {19400,0.12891892}, {19500,0.04054054}, {19600,0.04036036}, {19700,0.09004505}, {19800,0.12687387}, {19900,0.04148649}, {20000,0.04079817}};
data["big"]["OCaml"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00002703}, {3,0.00003604}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00007207}, {8,0.00007207}, {9,0.00000000}, {10,0.00003604}, {11,0.00000000}, {12,0.00003604}, {13,0.00005405}, {14,0.00003604}, {15,0.00003604}, {16,0.00003604}, {17,0.00002703}, {18,0.00007207}, {19,0.00002703}, {20,0.00003604}, {21,0.00013514}, {22,0.00003604}, {23,0.00003604}, {24,0.00007207}, {25,0.00005405}, {26,0.00100000}, {27,0.00000000}, {28,0.00007207}, {29,0.00006306}, {30,0.00002703}, {31,0.00003604}, {32,0.00006306}, {33,0.00007207}, {34,0.00009009}, {35,0.00006306}, {36,0.00007207}, {37,0.00008108}, {38,0.00018018}, {39,0.00007207}, {40,0.00006306}, {41,0.00009910}, {42,0.00002703}, {43,0.00021622}, {44,0.00006306}, {45,0.00009009}, {46,0.00003604}, {47,0.00000000}, {48,0.00000000}, {49,0.00002703}, {50,0.00009910}, {51,0.00007207}, {52,0.00010811}, {53,0.00006306}, {54,0.00020721}, {55,0.00029730}, {56,0.00003604}, {57,0.00009910}, {58,0.00018018}, {59,0.00007207}, {60,0.00006306}, {61,0.00006306}, {62,0.00006306}, {63,0.00021622}, {64,0.00017117}, {65,0.00018018}, {66,0.00014414}, {67,0.00023423}, {68,0.00005405}, {69,0.00014414}, {70,0.00010811}, {71,0.00018018}, {72,0.00010811}, {73,0.00015315}, {74,0.00011712}, {75,0.00023423}, {76,0.00012613}, {77,0.00011712}, {78,0.00020721}, {79,0.00018018}, {80,0.00023423}, {81,0.00015315}, {82,0.00023423}, {83,0.00007207}, {84,0.00023423}, {85,0.00013514}, {86,0.00020721}, {87,0.00009910}, {88,0.00014414}, {89,0.00012613}, {90,0.00027928}, {91,0.00013514}, {92,0.00016216}, {93,0.00017117}, {94,0.00009009}, {95,0.00026126}, {96,0.00011712}, {97,0.00016216}, {98,0.00012613}, {99,0.00009009}, {100,0.00022523}, {101,0.00018018}, {102,0.00009009}, {103,0.00013514}, {104,0.00025225}, {105,0.00019820}, {106,0.00009910}, {107,0.00014414}, {108,0.00014414}, {109,0.00019820}, {110,0.00015315}, {111,0.00003604}, {112,0.00023423}, {113,0.00018018}, {114,0.00029730}, {115,0.00007207}, {116,0.00013514}, {117,0.00017117}, {118,0.00022523}, {119,0.00021622}, {120,0.00016216}, {121,0.00014414}, {122,0.00024324}, {123,0.00034234}, {124,0.00022523}, {125,0.00024324}, {126,0.00021622}, {127,0.00016216}, {128,0.00013514}, {129,0.00027027}, {130,0.00027027}, {131,0.00036036}, {132,0.00022523}, {133,0.00036937}, {134,0.00032432}, {135,0.00027027}, {136,0.00010811}, {137,0.00026126}, {138,0.00036937}, {139,0.00036937}, {140,0.00021622}, {141,0.00026126}, {142,0.00042342}, {143,0.00038739}, {144,0.00015315}, {145,0.00019820}, {146,0.00023423}, {147,0.00040541}, {148,0.00034234}, {149,0.00032432}, {150,0.00028829}, {151,0.00035135}, {152,0.00031532}, {153,0.00036937}, {154,0.00036036}, {155,0.00029730}, {156,0.00018919}, {157,0.00029730}, {158,0.00019820}, {159,0.00027027}, {160,0.00023423}, {161,0.00023423}, {162,0.00024324}, {163,0.00029730}, {164,0.00040541}, {165,0.00028829}, {166,0.00027027}, {167,0.00030631}, {168,0.00027928}, {169,0.00030631}, {170,0.00044144}, {171,0.00045946}, {172,0.00030631}, {173,0.00037838}, {174,0.00023423}, {175,0.00041441}, {176,0.00050450}, {177,0.00025225}, {178,0.00020721}, {179,0.00027928}, {180,0.00028829}, {181,0.00029730}, {182,0.00018919}, {183,0.00034234}, {184,0.00027928}, {185,0.00020721}, {186,0.00023423}, {187,0.00013514}, {188,0.00027928}, {189,0.00040541}, {190,0.00060360}, {191,0.00042342}, {192,0.00018919}, {193,0.00029730}, {194,0.00036937}, {195,0.00032432}, {196,0.00037838}, {197,0.00045946}, {198,0.00041441}, {199,0.00024324}, {200,0.00047748}, {201,0.00027027}, {202,0.00020721}, {203,0.00039640}, {204,0.00032432}, {205,0.00049550}, {206,0.00035135}, {207,0.00040541}, {208,0.00036036}, {209,0.00037838}, {210,0.00051351}, {211,0.00025225}, {212,0.00047748}, {213,0.00021622}, {214,0.00047748}, {215,0.00033333}, {216,0.00047748}, {217,0.00039640}, {218,0.00034234}, {219,0.00028829}, {220,0.00039640}, {221,0.00061261}, {222,0.00030631}, {223,0.00041441}, {224,0.00032432}, {225,0.00029730}, {226,0.00047748}, {227,0.00054054}, {228,0.00039640}, {229,0.00049550}, {230,0.00035135}, {231,0.00050450}, {232,0.00032432}, {233,0.00033333}, {234,0.00038739}, {235,0.00042342}, {236,0.00040541}, {237,0.00024324}, {238,0.00059459}, {239,0.00059459}, {240,0.00051351}, {241,0.00045946}, {242,0.00042342}, {243,0.00030631}, {244,0.00071171}, {245,0.00061261}, {246,0.00050450}, {247,0.00063964}, {248,0.00035135}, {249,0.00029730}, {250,0.00043243}, {251,0.00035135}, {252,0.00051351}, {253,0.00049550}, {254,0.00048649}, {255,0.00054955}, {256,0.00040541}, {257,0.00053153}, {258,0.00056757}, {259,0.00051351}, {260,0.00045946}, {261,0.00050450}, {262,0.00050450}, {263,0.00036937}, {264,0.00038739}, {265,0.00035135}, {266,0.00050450}, {267,0.00055856}, {268,0.00058559}, {269,0.00033333}, {270,0.00051351}, {271,0.00075676}, {272,0.00046847}, {273,0.00041441}, {274,0.00042342}, {275,0.00044144}, {276,0.00040541}, {277,0.00061261}, {278,0.00048649}, {279,0.00181982}, {280,0.00037838}, {281,0.00041441}, {282,0.00025225}, {283,0.00043243}, {284,0.00048649}, {285,0.00055856}, {286,0.00035135}, {287,0.00024324}, {288,0.00041441}, {289,0.00053153}, {290,0.00023423}, {291,0.00033333}, {292,0.00036937}, {293,0.00062162}, {294,0.00035135}, {295,0.00051351}, {296,0.00057658}, {297,0.00057658}, {298,0.00064865}, {299,0.00052252}, {300,0.00078378}, {301,0.00048649}, {302,0.00063964}, {303,0.00045045}, {304,0.00082883}, {305,0.00083784}, {306,0.00060360}, {307,0.00046847}, {308,0.00050450}, {309,0.00055856}, {310,0.00072973}, {311,0.00039640}, {312,0.00053153}, {313,0.00046847}, {314,0.00052252}, {315,0.00098198}, {316,0.00054054}, {317,0.00073874}, {318,0.00064865}, {319,0.00056757}, {320,0.00047748}, {321,0.00050450}, {322,0.00061261}, {323,0.00071171}, {324,0.00081982}, {325,0.00054955}, {326,0.00052252}, {327,0.00072072}, {328,0.00037838}, {329,0.00061261}, {330,0.00063964}, {331,0.00050450}, {332,0.00072072}, {333,0.00065766}, {334,0.00058559}, {335,0.00056757}, {336,0.00062162}, {337,0.00070270}, {338,0.00037838}, {339,0.00026126}, {340,0.00050450}, {341,0.00077477}, {342,0.00040541}, {343,0.00045946}, {344,0.00055856}, {345,0.00066667}, {346,0.00081081}, {347,0.00054054}, {348,0.00050450}, {349,0.00087387}, {350,0.00051351}, {351,0.00046847}, {352,0.00071171}, {353,0.00042342}, {354,0.00074775}, {355,0.00059459}, {356,0.00062162}, {357,0.00051351}, {358,0.00053153}, {359,0.00069369}, {360,0.00042342}, {361,0.00071171}, {362,0.00058559}, {363,0.00064865}, {364,0.00028829}, {365,0.00051351}, {366,0.00073874}, {367,0.00070270}, {368,0.00036937}, {369,0.00065766}, {370,0.00080180}, {371,0.00081982}, {372,0.00062162}, {373,0.00062162}, {374,0.00081982}, {375,0.00063063}, {376,0.00058559}, {377,0.00051351}, {378,0.00077477}, {379,0.00084685}, {380,0.00080180}, {381,0.00059459}, {382,0.00061261}, {383,0.00076577}, {384,0.00077477}, {385,0.00063964}, {386,0.00049550}, {387,0.00049550}, {388,0.00074775}, {389,0.00079279}, {390,0.00068468}, {391,0.00079279}, {392,0.00072072}, {393,0.00063063}, {394,0.00065766}, {395,0.00059459}, {396,0.00063063}, {397,0.00063063}, {398,0.00063063}, {399,0.00072072}, {400,0.00090090}, {401,0.00085586}, {402,0.00087387}, {403,0.00100000}, {404,0.00111712}, {405,0.00085586}, {406,0.00085586}, {407,0.00086486}, {408,0.00080180}, {409,0.00068468}, {410,0.00059459}, {411,0.00069369}, {412,0.00076577}, {413,0.00067568}, {414,0.00058559}, {415,0.00049550}, {416,0.00063964}, {417,0.00088288}, {418,0.00085586}, {419,0.00069369}, {420,0.00092793}, {421,0.00087387}, {422,0.00087387}, {423,0.00082883}, {424,0.00090991}, {425,0.00054955}, {426,0.00060360}, {427,0.00078378}, {428,0.00071171}, {429,0.00078378}, {430,0.00081982}, {431,0.00073874}, {432,0.00074775}, {433,0.00083784}, {434,0.00088288}, {435,0.00076577}, {436,0.00063964}, {437,0.00060360}, {438,0.00060360}, {439,0.00065766}, {440,0.00072973}, {441,0.00084685}, {442,0.00079279}, {443,0.00079279}, {444,0.00075676}, {445,0.00075676}, {446,0.00093694}, {447,0.00111712}, {448,0.00120721}, {449,0.00096396}, {450,0.00093694}, {451,0.00073874}, {452,0.00080180}, {453,0.00104505}, {454,0.00075676}, {455,0.00063063}, {456,0.00063063}, {457,0.00073874}, {458,0.00090991}, {459,0.00064865}, {460,0.00081081}, {461,0.00125225}, {462,0.00100000}, {463,0.00075676}, {464,0.00050450}, {465,0.00069369}, {466,0.00099099}, {467,0.00110811}, {468,0.00075676}, {469,0.00073874}, {470,0.00066667}, {471,0.00078378}, {472,0.00059459}, {473,0.00085586}, {474,0.00092793}, {475,0.00077477}, {476,0.00080180}, {477,0.00107207}, {478,0.00073874}, {479,0.00078378}, {480,0.00071171}, {481,0.00084685}, {482,0.00092793}, {483,0.00087387}, {484,0.00077477}, {485,0.00092793}, {486,0.00091892}, {487,0.00090991}, {488,0.00101802}, {489,0.00086486}, {490,0.00090991}, {491,0.00105405}, {492,0.00075676}, {493,0.00100901}, {494,0.00082883}, {495,0.00085586}, {496,0.00074775}, {497,0.00198198}, {498,0.00091892}, {499,0.00086486}, {500,0.00072072}, {505,0.00065766}, {510,0.00083784}, {515,0.00076577}, {520,0.00112613}, {525,0.00075676}, {530,0.00090991}, {535,0.00091892}, {540,0.00093694}, {545,0.00118018}, {550,0.00093694}, {555,0.00086486}, {560,0.00087387}, {565,0.00095495}, {570,0.00109910}, {575,0.00129730}, {580,0.00103604}, {585,0.00114414}, {590,0.00117117}, {595,0.00112613}, {600,0.00076577}, {605,0.00121622}, {610,0.00106306}, {615,0.00124324}, {620,0.00122523}, {625,0.00100901}, {630,0.00106306}, {635,0.00104505}, {640,0.00101802}, {645,0.00097297}, {650,0.00088288}, {655,0.00094595}, {660,0.00134234}, {665,0.00152252}, {670,0.00123423}, {675,0.00107207}, {680,0.00107207}, {685,0.00123423}, {690,0.00126126}, {695,0.00122523}, {700,0.00131532}, {705,0.00117117}, {710,0.00119820}, {715,0.00094595}, {720,0.00163063}, {725,0.00116216}, {730,0.00150450}, {735,0.00150450}, {740,0.00087387}, {745,0.00127928}, {750,0.00136937}, {755,0.00152252}, {760,0.00363964}, {765,0.00145045}, {770,0.00133333}, {775,0.00130631}, {780,0.00151351}, {785,0.00125225}, {790,0.00137838}, {795,0.00159459}, {800,0.00119820}, {805,0.00162162}, {810,0.00114414}, {815,0.00118018}, {820,0.00156757}, {825,0.00132432}, {830,0.00135135}, {835,0.00147748}, {840,0.00168468}, {845,0.00150450}, {850,0.00174775}, {855,0.00146847}, {860,0.00161261}, {865,0.00151351}, {870,0.00204505}, {875,0.00187387}, {880,0.00144144}, {885,0.00145045}, {890,0.00136937}, {895,0.00163063}, {900,0.00179279}, {905,0.00182883}, {910,0.00145045}, {915,0.00163964}, {920,0.00172973}, {925,0.00171171}, {930,0.00150450}, {935,0.00172973}, {940,0.00181982}, {945,0.00194595}, {950,0.00166667}, {955,0.00167568}, {960,0.00162162}, {965,0.00184685}, {970,0.00160360}, {975,0.00204505}, {980,0.00182883}, {985,0.00173874}, {990,0.00196396}, {995,0.00197297}, {1000,0.00184685}, {1010,0.00175676}, {1020,0.00222523}, {1030,0.00212613}, {1040,0.00178378}, {1050,0.00181982}, {1060,0.00190090}, {1070,0.00189189}, {1080,0.00185586}, {1090,0.00208108}, {1100,0.00215315}, {1110,0.00208108}, {1120,0.00705405}, {1130,0.00236937}, {1140,0.00209910}, {1150,0.00233333}, {1160,0.00204505}, {1170,0.00195495}, {1180,0.00245946}, {1190,0.00187387}, {1200,0.00189189}, {1210,0.00227027}, {1220,0.00218919}, {1230,0.00254054}, {1240,0.00181982}, {1250,0.00218018}, {1260,0.00229730}, {1270,0.00223423}, {1280,0.00236036}, {1290,0.00222523}, {1300,0.00241441}, {1310,0.00264865}, {1320,0.00203604}, {1330,0.00252252}, {1340,0.00256757}, {1350,0.00275676}, {1360,0.00264865}, {1370,0.00272072}, {1380,0.00259459}, {1390,0.00260360}, {1400,0.00233333}, {1410,0.00257658}, {1420,0.00249550}, {1430,0.00262162}, {1440,0.00244144}, {1450,0.00274775}, {1460,0.00257658}, {1470,0.00259459}, {1480,0.00276577}, {1490,0.00278378}, {1500,0.00313514}, {1510,0.00280180}, {1520,0.00270270}, {1530,0.00293694}, {1540,0.01089189}, {1550,0.00298198}, {1560,0.00273874}, {1570,0.00309009}, {1580,0.00296396}, {1590,0.00269369}, {1600,0.00278378}, {1610,0.00313514}, {1620,0.00303604}, {1630,0.00327928}, {1640,0.00290090}, {1650,0.00304505}, {1660,0.00323423}, {1670,0.00294595}, {1680,0.00297297}, {1690,0.00305405}, {1700,0.00316216}, {1710,0.00317117}, {1720,0.00313514}, {1730,0.00332432}, {1740,0.00314414}, {1750,0.00317117}, {1760,0.00320721}, {1770,0.00320721}, {1780,0.00336937}, {1790,0.00335135}, {1800,0.00336036}, {1810,0.00340541}, {1820,0.00306306}, {1830,0.00330631}, {1840,0.00342342}, {1850,0.00353153}, {1860,0.00347748}, {1870,0.01387387}, {1880,0.00354955}, {1890,0.00349550}, {1900,0.00360360}, {1910,0.00373874}, {1920,0.00362162}, {1930,0.00363063}, {1940,0.00368468}, {1950,0.00372973}, {1960,0.00354955}, {1970,0.00375676}, {1980,0.00365766}, {1990,0.00364865}, {2000,0.00367568}, {2050,0.00374775}, {2100,0.00388288}, {2150,0.00387387}, {2200,0.00421622}, {2250,0.00408108}, {2300,0.00427027}, {2350,0.00440541}, {2400,0.00434234}, {2450,0.00454054}, {2500,0.00460360}, {2550,0.00481982}, {2600,0.00472072}, {2650,0.00505405}, {2700,0.00484685}, {2750,0.00500000}, {2800,0.00501802}, {2850,0.00529730}, {2900,0.00544144}, {2950,0.01934234}, {3000,0.00551351}, {3050,0.00560360}, {3100,0.00559459}, {3150,0.00597297}, {3200,0.00598198}, {3250,0.00640541}, {3300,0.00616216}, {3350,0.00634234}, {3400,0.00649550}, {3450,0.00633333}, {3500,0.00653153}, {3550,0.00682883}, {3600,0.00664865}, {3650,0.00674775}, {3700,0.00664865}, {3750,0.00723423}, {3800,0.01542342}, {3850,0.00722523}, {3900,0.00754955}, {3950,0.00741441}, {4000,0.01714414}, {4050,0.00767568}, {4100,0.00796396}, {4150,0.00789189}, {4200,0.00789189}, {4250,0.02352252}, {4300,0.00835135}, {4350,0.00846847}, {4400,0.00874775}, {4450,0.00852252}, {4500,0.00905405}, {4550,0.00825225}, {4600,0.03225225}, {4650,0.00912613}, {4700,0.00963063}, {4750,0.00951351}, {4800,0.00939640}, {4850,0.00975676}, {4900,0.01009009}, {4950,0.00962162}, {5000,0.01002703}, {5050,0.01014414}, {5100,0.01027027}, {5150,0.00990991}, {5200,0.01018018}, {5250,0.01033333}, {5300,0.01057658}, {5350,0.01087387}, {5400,0.01107207}, {5450,0.01098198}, {5500,0.01164865}, {5550,0.01174775}, {5600,0.01163063}, {5650,0.01145045}, {5700,0.01157658}, {5750,0.01172973}, {5800,0.01175676}, {5850,0.02675676}, {5900,0.01210811}, {5950,0.01230631}, {6000,0.01277477}, {6050,0.01245946}, {6100,0.01253153}, {6150,0.06199099}, {6200,0.01279279}, {6250,0.01286486}, {6300,0.01323423}, {6350,0.01316216}, {6400,0.05456757}, {6450,0.01311712}, {6500,0.01386486}, {6550,0.01352252}, {6600,0.05163964}, {6650,0.01381982}, {6700,0.01424324}, {6750,0.01378378}, {6800,0.03172072}, {6850,0.01364865}, {6900,0.01405405}, {6950,0.03936937}, {7000,0.01436937}, {7050,0.01454054}, {7100,0.03397297}, {7150,0.01543243}, {7200,0.01472973}, {7250,0.01465766}, {7300,0.01489189}, {7350,0.04720721}, {7400,0.01581982}, {7450,0.01536036}, {7500,0.01518018}, {7550,0.01526126}, {7600,0.01493694}, {7650,0.01549550}, {7700,0.03542342}, {7750,0.01598198}, {7800,0.03696396}, {7850,0.01621622}, {7900,0.03610811}, {7950,0.01617117}, {8000,0.03166667}, {8050,0.01623423}, {8100,0.01623423}, {8150,0.01654054}, {8200,0.01624324}, {8250,0.01670270}, {8300,0.01699099}, {8350,0.03663964}, {8400,0.01690090}, {8450,0.01660360}, {8500,0.01700901}, {8550,0.01749550}, {8600,0.01697297}, {8650,0.01745946}, {8700,0.01779279}, {8750,0.01656757}, {8800,0.01767568}, {8850,0.01788288}, {8900,0.01762162}, {8950,0.06319820}, {9000,0.01824324}, {9050,0.01860360}, {9100,0.03149550}, {9150,0.01838739}, {9200,0.01864865}, {9250,0.01920721}, {9300,0.02625225}, {9350,0.06252252}, {9400,0.01885586}, {9450,0.01927027}, {9500,0.01908108}, {9550,0.01818018}, {9600,0.05478378}, {9650,0.01969369}, {9700,0.01948649}, {9750,0.02006306}, {9800,0.02059459}, {9850,0.01981982}, {9900,0.01975676}, {9950,0.03834234}, {10000,0.05511712}, {10100,0.06924324}, {10200,0.02057658}, {10300,0.02086486}, {10400,0.02116216}, {10500,0.02128829}, {10600,0.02125225}, {10700,0.02162162}, {10800,0.07675676}, {10900,0.05577477}, {11000,0.06201802}, {11100,0.03389189}, {11200,0.02288288}, {11300,0.02372072}, {11400,0.02390991}, {11500,0.02363063}, {11600,0.06534234}, {11700,0.02402703}, {11800,0.02496396}, {11900,0.02424324}, {12000,0.06841441}, {12100,0.02628829}, {12200,0.02504505}, {12300,0.06916216}, {12400,0.02636937}, {12500,0.02570270}, {12600,0.04753153}, {12700,0.02646847}, {12800,0.07409009}, {12900,0.02683784}, {13000,0.06856757}, {13100,0.02737838}, {13200,0.08805405}, {13300,0.02791892}, {13400,0.07644144}, {13500,0.02780180}, {13600,0.05104505}, {13700,0.02765766}, {13800,0.02896396}, {13900,0.07000000}, {14000,0.02822523}, {14100,0.02971171}, {14200,0.06582883}, {14300,0.02853153}, {14400,0.02984685}, {14500,0.03077477}, {14600,0.06631532}, {14700,0.09813514}, {14800,0.03016216}, {14900,0.03139640}, {15000,0.03167568}, {15100,0.02996396}, {15200,0.05909009}, {15300,0.06818018}, {15400,0.08176577}, {15500,0.10765766}, {15600,0.10645946}, {15700,0.10598198}, {15800,0.10667568}, {15900,0.10092793}, {16000,0.08997297}, {16100,0.07952252}, {16200,0.06420721}, {16300,0.05137838}, {16400,0.03500000}, {16500,0.03472072}, {16600,0.03427027}, {16700,0.13805405}, {16800,0.08580180}, {16900,0.05509910}, {17000,0.03572973}, {17100,0.03506306}, {17200,0.08671171}, {17300,0.03677477}, {17400,0.03621622}, {17500,0.09497297}, {17600,0.03750450}, {17700,0.03653153}, {17800,0.08422523}, {17900,0.03754955}, {18000,0.12271171}, {18100,0.03862162}, {18200,0.12943243}, {18300,0.03810811}, {18400,0.12620721}, {18500,0.03901802}, {18600,0.13366667}, {18700,0.03982883}, {18800,0.10262162}, {18900,0.03925225}, {19000,0.07234234}, {19100,0.12536036}, {19200,0.04027928}, {19300,0.07404505}, {19400,0.12703604}, {19500,0.04056757}, {19600,0.04018919}, {19700,0.08894595}, {19800,0.12501802}, {19900,0.04144144}, {20000,0.04076147}};
data["big"]["OCaml"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00003604}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00003604}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00006306}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00003604}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00003604}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00003604}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00003604}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00003604}, {128,0.00003604}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00003604}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00007207}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00003604}, {158,0.00000000}, {159,0.00000000}, {160,0.00007207}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00003604}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00003604}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00003604}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00003604}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00003604}, {188,0.00000000}, {189,0.00003604}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00003604}, {202,0.00003604}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00003604}, {212,0.00003604}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00003604}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00003604}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00003604}, {239,0.00000000}, {240,0.00000000}, {241,0.00003604}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00002703}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00003604}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00003604}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00003604}, {293,0.00000000}, {294,0.00000000}, {295,0.00003604}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00002703}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00003604}, {324,0.00000000}, {325,0.00000000}, {326,0.00003604}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00002703}, {332,0.00000000}, {333,0.00000000}, {334,0.00003604}, {335,0.00000000}, {336,0.00003604}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00003604}, {375,0.00000000}, {376,0.00000000}, {377,0.00003604}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00003604}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00003604}, {396,0.00000000}, {397,0.00003604}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00003604}, {408,0.00000000}, {409,0.00003604}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00003604}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00003604}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00007207}, {437,0.00000000}, {438,0.00003604}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00007207}, {443,0.00000000}, {444,0.00000000}, {445,0.00003604}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00003604}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00003604}, {457,0.00000000}, {458,0.00003604}, {459,0.00000000}, {460,0.00000000}, {461,0.00003604}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00002703}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00003604}, {478,0.00000000}, {479,0.00003604}, {480,0.00000000}, {481,0.00000000}, {482,0.00003604}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00003604}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00010811}, {496,0.00007207}, {497,0.00003604}, {498,0.00003604}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00007207}, {555,0.00003604}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00003604}, {580,0.00000000}, {585,0.00000000}, {590,0.00003604}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00003604}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00003604}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00003604}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00002703}, {755,0.00000000}, {760,0.00007207}, {765,0.00003604}, {770,0.00000000}, {775,0.00003604}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00003604}, {820,0.00000000}, {825,0.00003604}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00003604}, {855,0.00000000}, {860,0.00003604}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00003604}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00003604}, {935,0.00003604}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00003604}, {985,0.00000000}, {990,0.00000000}, {995,0.00003604}, {1000,0.00000000}, {1010,0.00003604}, {1020,0.00003604}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00003604}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00003604}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00003604}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00003604}, {1360,0.00000000}, {1370,0.00003604}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00003604}, {1420,0.00000000}, {1430,0.00003604}, {1440,0.00000000}, {1450,0.00003604}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00006306}, {1530,0.00000000}, {1540,0.00013514}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00003604}, {1600,0.00000000}, {1610,0.00003604}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003604}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00003604}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00003604}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00018018}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00003604}, {1980,0.00000000}, {1990,0.00003604}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00003604}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00003604}, {2500,0.00003604}, {2550,0.00000000}, {2600,0.00003604}, {2650,0.00002703}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00018018}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00003604}, {3550,0.00007207}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00021622}, {3850,0.00003604}, {3900,0.00003604}, {3950,0.00000000}, {4000,0.00017117}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00003604}, {4250,0.00030631}, {4300,0.00000000}, {4350,0.00003604}, {4400,0.00009910}, {4450,0.00003604}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00050450}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00007207}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00007207}, {5500,0.00003604}, {5550,0.00000000}, {5600,0.00003604}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00025225}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00083784}, {6200,0.00000000}, {6250,0.00003604}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00003604}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00002703}, {6850,0.00003604}, {6900,0.00000000}, {6950,0.00053153}, {7000,0.00003604}, {7050,0.00007207}, {7100,0.00039640}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00053153}, {7400,0.00007207}, {7450,0.00000000}, {7500,0.00003604}, {7550,0.00007207}, {7600,0.00003604}, {7650,0.00000000}, {7700,0.00056757}, {7750,0.00003604}, {7800,0.00054054}, {7850,0.00000000}, {7900,0.00032432}, {7950,0.00003604}, {8000,0.00043243}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00007207}, {8350,0.00028829}, {8400,0.00000000}, {8450,0.00003604}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00003604}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00003604}, {9050,0.00010811}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00007207}, {9300,0.00003604}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00003604}, {9700,0.00003604}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00003604}, {9900,0.00000000}, {9950,0.00003604}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00003604}, {10800,0.00002703}, {10900,0.00003604}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00003604}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00003604}, {13500,0.00000000}, {13600,0.00003604}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00003604}, {14800,0.00003604}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00003604}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00009910}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00003604}, {16000,0.00000000}, {16100,0.00003604}, {16200,0.00003604}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00003604}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00003604}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00006306}, {18100,0.00003604}, {18200,0.00003604}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00003604}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00170270}, {19500,0.00007207}, {19600,0.00003604}, {19700,0.00107207}, {19800,0.00196396}, {19900,0.00003604}, {20000,0.00000000}};
data["big"]["OCaml"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.01329730}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00001802}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00098198}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00001802}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00301802}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00003604}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00323423}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000901}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00290991}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00001802}, {815,0.00002703}, {820,0.00000000}, {825,0.00000901}, {830,0.00001802}, {835,0.00001802}, {840,0.00003604}, {845,0.00001802}, {850,0.00003604}, {855,0.00008108}, {860,0.00011712}, {865,0.00026126}, {870,0.00028829}, {875,0.00032432}, {880,0.00044144}, {885,0.00049550}, {890,0.00058559}, {895,0.00072973}, {900,0.00074775}, {905,0.00077477}, {910,0.00080180}, {915,0.00084685}, {920,0.00088288}, {925,0.00094595}, {930,0.00098198}, {935,0.00098198}, {940,0.00098198}, {945,0.00100000}, {950,0.00100000}, {955,0.00100000}, {960,0.00100000}, {965,0.00100000}, {970,0.00100000}, {975,0.00100000}, {980,0.00100000}, {985,0.00100000}, {990,0.00100000}, {995,0.00100000}, {1000,0.00100000}, {1010,0.00100000}, {1020,0.00100000}, {1030,0.00100000}, {1040,0.00100000}, {1050,0.00100000}, {1060,0.00100000}, {1070,0.00100000}, {1080,0.00100000}, {1090,0.00100000}, {1100,0.00100000}, {1110,0.00100000}, {1120,0.00100000}, {1130,0.00100000}, {1140,0.00107207}, {1150,0.00100000}, {1160,0.00100000}, {1170,0.00100000}, {1180,0.00100000}, {1190,0.00100000}, {1200,0.00100000}, {1210,0.00100000}, {1220,0.00100000}, {1230,0.00100000}, {1240,0.00100000}, {1250,0.00100000}, {1260,0.00100000}, {1270,0.00100000}, {1280,0.00100000}, {1290,0.00100000}, {1300,0.00100000}, {1310,0.00100000}, {1320,0.00100000}, {1330,0.00100000}, {1340,0.00100000}, {1350,0.00100000}, {1360,0.00100000}, {1370,0.00100000}, {1380,0.00100000}, {1390,0.00100000}, {1400,0.00100000}, {1410,0.00100000}, {1420,0.00100000}, {1430,0.00100000}, {1440,0.00100000}, {1450,0.00100000}, {1460,0.00100901}, {1470,0.00100000}, {1480,0.00100000}, {1490,0.00100000}, {1500,0.00100901}, {1510,0.00100000}, {1520,0.00100901}, {1530,0.00100000}, {1540,0.00100000}, {1550,0.00100000}, {1560,0.00101802}, {1570,0.00101802}, {1580,0.00100901}, {1590,0.00100901}, {1600,0.00103604}, {1610,0.00100000}, {1620,0.00100901}, {1630,0.00101802}, {1640,0.00103604}, {1650,0.00119820}, {1660,0.00109910}, {1670,0.00112613}, {1680,0.00116216}, {1690,0.00122523}, {1700,0.00124324}, {1710,0.00137838}, {1720,0.00143243}, {1730,0.00152252}, {1740,0.00183784}, {1750,0.00166667}, {1760,0.00169369}, {1770,0.00174775}, {1780,0.00177477}, {1790,0.00184685}, {1800,0.00184685}, {1810,0.00188288}, {1820,0.00191892}, {1830,0.00192793}, {1840,0.00198198}, {1850,0.00197297}, {1860,0.00199099}, {1870,0.00200000}, {1880,0.00200000}, {1890,0.00200000}, {1900,0.00200000}, {1910,0.00200000}, {1920,0.00200000}, {1930,0.00200000}, {1940,0.00200000}, {1950,0.00200000}, {1960,0.00200000}, {1970,0.00200000}, {1980,0.00200000}, {1990,0.00200000}, {2000,0.00200000}, {2050,0.00200000}, {2100,0.00200000}, {2150,0.00200000}, {2200,0.00200000}, {2250,0.00877477}, {2300,0.00224324}, {2350,0.00201802}, {2400,0.00213514}, {2450,0.00225225}, {2500,0.00244144}, {2550,0.00262162}, {2600,0.00279279}, {2650,0.00286486}, {2700,0.00296396}, {2750,0.00300000}, {2800,0.00300000}, {2850,0.00300000}, {2900,0.00300000}, {2950,0.00300901}, {3000,0.00300000}, {3050,0.00300901}, {3100,0.00303604}, {3150,0.00315315}, {3200,0.00326126}, {3250,0.00342342}, {3300,0.00356757}, {3350,0.00371171}, {3400,0.00379279}, {3450,0.00381081}, {3500,0.00388288}, {3550,0.00396396}, {3600,0.00399099}, {3650,0.02448649}, {3700,0.00400000}, {3750,0.00400901}, {3800,0.00400901}, {3850,0.00406306}, {3900,0.00409910}, {3950,0.00428829}, {4000,0.00436036}, {4050,0.00455856}, {4100,0.00466667}, {4150,0.00473874}, {4200,0.00476577}, {4250,0.00480180}, {4300,0.00487387}, {4350,0.00496396}, {4400,0.00499099}, {4450,0.00538739}, {4500,0.00500000}, {4550,0.00502703}, {4600,0.00506306}, {4650,0.03096396}, {4700,0.00527027}, {4750,0.00533333}, {4800,0.00546847}, {4850,0.00560360}, {4900,0.00570270}, {4950,0.00570270}, {5000,0.00609910}, {5050,0.00638739}, {5100,0.00583784}, {5150,0.00586486}, {5200,0.00595495}, {5250,0.00600901}, {5300,0.00600000}, {5350,0.00659459}, {5400,0.00655856}, {5450,0.00620721}, {5500,0.00638739}, {5550,0.00641441}, {5600,0.00655856}, {5650,0.00663063}, {5700,0.00667568}, {5750,0.04275676}, {5800,0.00672072}, {5850,0.00677477}, {5900,0.00681081}, {5950,0.00745946}, {6000,0.00695495}, {6050,0.00696396}, {6100,0.00698198}, {6150,0.00706306}, {6200,0.00712613}, {6250,0.00766667}, {6300,0.00737838}, {6350,0.00753153}, {6400,0.00761261}, {6450,0.00764865}, {6500,0.00769369}, {6550,0.00770270}, {6600,0.00772973}, {6650,0.00772973}, {6700,0.00776577}, {6750,0.04844144}, {6800,0.00786486}, {6850,0.00790991}, {6900,0.00804505}, {6950,0.00802703}, {7000,0.00813514}, {7050,0.00837838}, {7100,0.00845045}, {7150,0.00851351}, {7200,0.03696396}, {7250,0.00865766}, {7300,0.00868468}, {7350,0.00870270}, {7400,0.00871171}, {7450,0.02990090}, {7500,0.00940541}, {7550,0.00875676}, {7600,0.00875676}, {7650,0.00884685}, {7700,0.00891892}, {7750,0.00907207}, {7800,0.00918919}, {7850,0.00934234}, {7900,0.00946847}, {7950,0.00954054}, {8000,0.00965766}, {8050,0.00969369}, {8100,0.01058559}, {8150,0.05086486}, {8200,0.00966667}, {8250,0.00968468}, {8300,0.00969369}, {8350,0.00974775}, {8400,0.00977477}, {8450,0.01025225}, {8500,0.00996396}, {8550,0.01003604}, {8600,0.01106306}, {8650,0.03652252}, {8700,0.01043243}, {8750,0.01163964}, {8800,0.01001802}, {8850,0.01066667}, {8900,0.01136937}, {8950,0.01068468}, {9000,0.01069369}, {9050,0.01068468}, {9100,0.01072072}, {9150,0.01072072}, {9200,0.01075676}, {9250,0.01083784}, {9300,0.01187387}, {9350,0.01105405}, {9400,0.05359459}, {9450,0.01127928}, {9500,0.01138739}, {9550,0.01249550}, {9600,0.01162162}, {9650,0.01166667}, {9700,0.06012613}, {9750,0.01170270}, {9800,0.01168468}, {9850,0.01166667}, {9900,0.01244144}, {9950,0.01169369}, {10000,0.01174775}, {10100,0.01184685}, {10200,0.01206306}, {10300,0.01237838}, {10400,0.01203604}, {10500,0.01223423}, {10600,0.01265766}, {10700,0.01270270}, {10800,0.01272072}, {10900,0.01291892}, {11000,0.01430631}, {11100,0.01422523}, {11200,0.01356757}, {11300,0.01365766}, {11400,0.07450450}, {11500,0.01369369}, {11600,0.01373874}, {11700,0.01390090}, {11800,0.01416216}, {11900,0.01511712}, {12000,0.01606306}, {12100,0.01460360}, {12200,0.06067568}, {12300,0.01581081}, {12400,0.01474775}, {12500,0.01472072}, {12600,0.01581982}, {12700,0.08299099}, {12800,0.01694595}, {12900,0.01563063}, {13000,0.01566667}, {13100,0.01568468}, {13200,0.01580180}, {13300,0.01590991}, {13400,0.01747748}, {13500,0.07826126}, {13600,0.01744144}, {13700,0.01655856}, {13800,0.01667568}, {13900,0.01801802}, {14000,0.01577477}, {14100,0.01686486}, {14200,0.01798198}, {14300,0.01718919}, {14400,0.07822523}, {14500,0.01749550}, {14600,0.01851351}, {14700,0.01767568}, {14800,0.01751351}, {14900,0.07381982}, {15000,0.01808108}, {15100,0.01820721}, {15200,0.01836937}, {15300,0.01926126}, {15400,0.01959459}, {15500,0.01992793}, {15600,0.02018919}, {15700,0.02012613}, {15800,0.02041441}, {15900,0.02063964}, {16000,0.02055856}, {16100,0.02022523}, {16200,0.01947748}, {16300,0.01962162}, {16400,0.01971171}, {16500,0.08025225}, {16600,0.02100901}, {16700,0.02179279}, {16800,0.02100000}, {16900,0.02039640}, {17000,0.07737838}, {17100,0.02061261}, {17200,0.02156757}, {17300,0.02095495}, {17400,0.02011712}, {17500,0.02224324}, {17600,0.02136036}, {17700,0.02136937}, {17800,0.02211712}, {17900,0.08045045}, {18000,0.02309009}, {18100,0.11363964}, {18200,0.02382883}, {18300,0.08592793}, {18400,0.02392793}, {18500,0.13579279}, {18600,0.02397297}, {18700,0.09968468}, {18800,0.02387387}, {18900,0.02295495}, {19000,0.02308108}, {19100,0.02479279}, {19200,0.06700901}, {19300,0.02343243}, {19400,0.02477477}, {19500,0.02318018}, {19600,0.11682883}, {19700,0.02394595}, {19800,0.02564865}, {19900,0.02424324}, {20000,0.08391743}};
data["big"]["OCaml"]["eval lazy"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00006306}, {4,0.00000000}, {5,0.00000000}, {6,0.00003604}, {7,0.00007207}, {8,0.00003604}, {9,0.00003604}, {10,0.00007207}, {11,0.00003604}, {12,0.00005405}, {13,0.00005405}, {14,0.00003604}, {15,0.00002703}, {16,0.00003604}, {17,0.00000000}, {18,0.00009009}, {19,0.00000000}, {20,0.00000000}, {21,0.00007207}, {22,0.00000000}, {23,0.00007207}, {24,0.00014414}, {25,0.00006306}, {26,0.00003604}, {27,0.00003604}, {28,0.00011712}, {29,0.00007207}, {30,0.00002703}, {31,0.00003604}, {32,0.00003604}, {33,0.00000000}, {34,0.00000000}, {35,0.00009910}, {36,0.00007207}, {37,0.00003604}, {38,0.00006306}, {39,0.00009910}, {40,0.00010811}, {41,0.00003604}, {42,0.00009910}, {43,0.00006306}, {44,0.00002703}, {45,0.00003604}, {46,0.00015315}, {47,0.00009009}, {48,0.00010811}, {49,0.00009910}, {50,0.00006306}, {51,0.00002703}, {52,0.00003604}, {53,0.00007207}, {54,0.00003604}, {55,0.00003604}, {56,0.00007207}, {57,0.00009910}, {58,0.01356757}, {59,0.00002703}, {60,0.00013514}, {61,0.00013514}, {62,0.00011712}, {63,0.00017117}, {64,0.00006306}, {65,0.00009910}, {66,0.00016216}, {67,0.00009009}, {68,0.00009910}, {69,0.00020721}, {70,0.00013514}, {71,0.00009910}, {72,0.00009009}, {73,0.00017117}, {74,0.00010811}, {75,0.00009910}, {76,0.00009910}, {77,0.00011712}, {78,0.00009910}, {79,0.00018018}, {80,0.00003604}, {81,0.00009910}, {82,0.00016216}, {83,0.00009910}, {84,0.00018018}, {85,0.00017117}, {86,0.00003604}, {87,0.00022523}, {88,0.00018018}, {89,0.00003604}, {90,0.00027928}, {91,0.00020721}, {92,0.00015315}, {93,0.00007207}, {94,0.00013514}, {95,0.00010811}, {96,0.00016216}, {97,0.00024324}, {98,0.00003604}, {99,0.00017117}, {100,0.00009009}, {101,0.00012613}, {102,0.00022523}, {103,0.00003604}, {104,0.00006306}, {105,0.00019820}, {106,0.00013514}, {107,0.00016216}, {108,0.00013514}, {109,0.00018018}, {110,0.00016216}, {111,0.00028829}, {112,0.00009009}, {113,0.00003604}, {114,0.00018018}, {115,0.00015315}, {116,0.00007207}, {117,0.00018919}, {118,0.00015315}, {119,0.00023423}, {120,0.00012613}, {121,0.00017117}, {122,0.00020721}, {123,0.00016216}, {124,0.00027928}, {125,0.00017117}, {126,0.00013514}, {127,0.00009009}, {128,0.00016216}, {129,0.00012613}, {130,0.00021622}, {131,0.00017117}, {132,0.00031532}, {133,0.00010811}, {134,0.00027027}, {135,0.00019820}, {136,0.00017117}, {137,0.00013514}, {138,0.00010811}, {139,0.00009009}, {140,0.00033333}, {141,0.00019820}, {142,0.00023423}, {143,0.00019820}, {144,0.00010811}, {145,0.00014414}, {146,0.00017117}, {147,0.00017117}, {148,0.00015315}, {149,0.00020721}, {150,0.00013514}, {151,0.00034234}, {152,0.00018018}, {153,0.00017117}, {154,0.00024324}, {155,0.00022523}, {156,0.00015315}, {157,0.00020721}, {158,0.00015315}, {159,0.00016216}, {160,0.00031532}, {161,0.00023423}, {162,0.00016216}, {163,0.00017117}, {164,0.00020721}, {165,0.00012613}, {166,0.00026126}, {167,0.00026126}, {168,0.00017117}, {169,0.00016216}, {170,0.00012613}, {171,0.00019820}, {172,0.00016216}, {173,0.00009910}, {174,0.00011712}, {175,0.00018018}, {176,0.00023423}, {177,0.00015315}, {178,0.00039640}, {179,0.00036036}, {180,0.00032432}, {181,0.00017117}, {182,0.00029730}, {183,0.00046847}, {184,0.00019820}, {185,0.00019820}, {186,0.00033333}, {187,0.00036937}, {188,0.00030631}, {189,0.00009009}, {190,0.00020721}, {191,0.00018018}, {192,0.00023423}, {193,0.00014414}, {194,0.00027928}, {195,0.00028829}, {196,0.00018919}, {197,0.00019820}, {198,0.00018018}, {199,0.00025225}, {200,0.00031532}, {201,0.00015315}, {202,0.00016216}, {203,0.00033333}, {204,0.00020721}, {205,0.00018919}, {206,0.00019820}, {207,0.00027928}, {208,0.00018018}, {209,0.00040541}, {210,0.00030631}, {211,0.00040541}, {212,0.00008108}, {213,0.00033333}, {214,0.00007207}, {215,0.00024324}, {216,0.00009910}, {217,0.00025225}, {218,0.00031532}, {219,0.00029730}, {220,0.00015315}, {221,0.00012613}, {222,0.00018919}, {223,0.00027928}, {224,0.00022523}, {225,0.00022523}, {226,0.00142342}, {227,0.00015315}, {228,0.00029730}, {229,0.00024324}, {230,0.00037838}, {231,0.00017117}, {232,0.00012613}, {233,0.00023423}, {234,0.00025225}, {235,0.00037838}, {236,0.00018919}, {237,0.00027928}, {238,0.00026126}, {239,0.00018018}, {240,0.00017117}, {241,0.00025225}, {242,0.00016216}, {243,0.00036036}, {244,0.00036937}, {245,0.00022523}, {246,0.00036937}, {247,0.00017117}, {248,0.00006306}, {249,0.00030631}, {250,0.00022523}, {251,0.00024324}, {252,0.00027027}, {253,0.00031532}, {254,0.00024324}, {255,0.00041441}, {256,0.00025225}, {257,0.00045946}, {258,0.00013514}, {259,0.00027928}, {260,0.00037838}, {261,0.00028829}, {262,0.00039640}, {263,0.00032432}, {264,0.00030631}, {265,0.00030631}, {266,0.00027928}, {267,0.00024324}, {268,0.00023423}, {269,0.00027027}, {270,0.00037838}, {271,0.00030631}, {272,0.00036036}, {273,0.00018919}, {274,0.00043243}, {275,0.00032432}, {276,0.00026126}, {277,0.00033333}, {278,0.00029730}, {279,0.00031532}, {280,0.00049550}, {281,0.00036937}, {282,0.00044144}, {283,0.00040541}, {284,0.00049550}, {285,0.00035135}, {286,0.00045946}, {287,0.00039640}, {288,0.00034234}, {289,0.00036937}, {290,0.00047748}, {291,0.00020721}, {292,0.00029730}, {293,0.00044144}, {294,0.00036937}, {295,0.00035135}, {296,0.00046847}, {297,0.00036036}, {298,0.00039640}, {299,0.00014414}, {300,0.00039640}, {301,0.00041441}, {302,0.00030631}, {303,0.00029730}, {304,0.00022523}, {305,0.00042342}, {306,0.00036937}, {307,0.00031532}, {308,0.00040541}, {309,0.00030631}, {310,0.00037838}, {311,0.00028829}, {312,0.00021622}, {313,0.00039640}, {314,0.00024324}, {315,0.00047748}, {316,0.00041441}, {317,0.00031532}, {318,0.00037838}, {319,0.00032432}, {320,0.00042342}, {321,0.00026126}, {322,0.00050450}, {323,0.00027027}, {324,0.00044144}, {325,0.00055856}, {326,0.00020721}, {327,0.00032432}, {328,0.00050450}, {329,0.00018018}, {330,0.00032432}, {331,0.00039640}, {332,0.00027928}, {333,0.00045045}, {334,0.00051351}, {335,0.00036036}, {336,0.00029730}, {337,0.00038739}, {338,0.00072072}, {339,0.00041441}, {340,0.00017117}, {341,0.00041441}, {342,0.00038739}, {343,0.00034234}, {344,0.00032432}, {345,0.00024324}, {346,0.00022523}, {347,0.00058559}, {348,0.00034234}, {349,0.00031532}, {350,0.00039640}, {351,0.00050450}, {352,0.00029730}, {353,0.00047748}, {354,0.00018018}, {355,0.00028829}, {356,0.00029730}, {357,0.00037838}, {358,0.00030631}, {359,0.00027027}, {360,0.00048649}, {361,0.00034234}, {362,0.00042342}, {363,0.00024324}, {364,0.00036937}, {365,0.00044144}, {366,0.00043243}, {367,0.00034234}, {368,0.00053153}, {369,0.00038739}, {370,0.00039640}, {371,0.00048649}, {372,0.00020721}, {373,0.00055856}, {374,0.00033333}, {375,0.00046847}, {376,0.00035135}, {377,0.00044144}, {378,0.00025225}, {379,0.00042342}, {380,0.00045946}, {381,0.00035135}, {382,0.00053153}, {383,0.00022523}, {384,0.00067568}, {385,0.00031532}, {386,0.00025225}, {387,0.00040541}, {388,0.00066667}, {389,0.00059459}, {390,0.00066667}, {391,0.00063063}, {392,0.00038739}, {393,0.00036036}, {394,0.00051351}, {395,0.00058559}, {396,0.00043243}, {397,0.00042342}, {398,0.00021622}, {399,0.00027027}, {400,0.00044144}, {401,0.00045045}, {402,0.00040541}, {403,0.00051351}, {404,0.00041441}, {405,0.00034234}, {406,0.00029730}, {407,0.00053153}, {408,0.00027928}, {409,0.00041441}, {410,0.00034234}, {411,0.00036036}, {412,0.00031532}, {413,0.00058559}, {414,0.00051351}, {415,0.00048649}, {416,0.00063964}, {417,0.00050450}, {418,0.00047748}, {419,0.00023423}, {420,0.00037838}, {421,0.00029730}, {422,0.00026126}, {423,0.00023423}, {424,0.00041441}, {425,0.00055856}, {426,0.00044144}, {427,0.00036036}, {428,0.00034234}, {429,0.00046847}, {430,0.00031532}, {431,0.00041441}, {432,0.00061261}, {433,0.00045045}, {434,0.00034234}, {435,0.00073874}, {436,0.00055856}, {437,0.00033333}, {438,0.00042342}, {439,0.00040541}, {440,0.00034234}, {441,0.00031532}, {442,0.00042342}, {443,0.00034234}, {444,0.00038739}, {445,0.00038739}, {446,0.00337838}, {447,0.00037838}, {448,0.00035135}, {449,0.00039640}, {450,0.00047748}, {451,0.00027027}, {452,0.00032432}, {453,0.00029730}, {454,0.00058559}, {455,0.00052252}, {456,0.00045946}, {457,0.00052252}, {458,0.00050450}, {459,0.00061261}, {460,0.00036937}, {461,0.00047748}, {462,0.00045045}, {463,0.00048649}, {464,0.00067568}, {465,0.00059459}, {466,0.00038739}, {467,0.00038739}, {468,0.00062162}, {469,0.00049550}, {470,0.00041441}, {471,0.00052252}, {472,0.00054955}, {473,0.00051351}, {474,0.00042342}, {475,0.00049550}, {476,0.00052252}, {477,0.00051351}, {478,0.00045946}, {479,0.00080180}, {480,0.00056757}, {481,0.00050450}, {482,0.00045946}, {483,0.00054955}, {484,0.00060360}, {485,0.00041441}, {486,0.00050450}, {487,0.00340541}, {488,0.00054054}, {489,0.00049550}, {490,0.00036937}, {491,0.00049550}, {492,0.00045946}, {493,0.00045045}, {494,0.00048649}, {495,0.00042342}, {496,0.00032432}, {497,0.00071171}, {498,0.00045946}, {499,0.00051351}, {500,0.00056757}, {505,0.00063964}, {510,0.00039640}, {515,0.00054955}, {520,0.00054054}, {525,0.00036036}, {530,0.00052252}, {535,0.00045946}, {540,0.00063964}, {545,0.00057658}, {550,0.00068468}, {555,0.00058559}, {560,0.00062162}, {565,0.00063063}, {570,0.00045946}, {575,0.00295495}, {580,0.00082883}, {585,0.00043243}, {590,0.00027027}, {595,0.00065766}, {600,0.00072973}, {605,0.00074775}, {610,0.00057658}, {615,0.00100000}, {620,0.00078378}, {625,0.00077477}, {630,0.00046847}, {635,0.00045045}, {640,0.00072973}, {645,0.00087387}, {650,0.00072072}, {655,0.00048649}, {660,0.00063063}, {665,0.00073874}, {670,0.00063964}, {675,0.00096396}, {680,0.00060360}, {685,0.00063964}, {690,0.00066667}, {695,0.00065766}, {700,0.00060360}, {705,0.00075676}, {710,0.00076577}, {715,0.00069369}, {720,0.00072973}, {725,0.00084685}, {730,0.00050450}, {735,0.00101802}, {740,0.00078378}, {745,0.00072973}, {750,0.00073874}, {755,0.00087387}, {760,0.00080180}, {765,0.00072072}, {770,0.00081982}, {775,0.00075676}, {780,0.00080180}, {785,0.00079279}, {790,0.00071171}, {795,0.00084685}, {800,0.00081081}, {805,0.00096396}, {810,0.00085586}, {815,0.00116216}, {820,0.00088288}, {825,0.00081081}, {830,0.00081081}, {835,0.00077477}, {840,0.00085586}, {845,0.00090991}, {850,0.00073874}, {855,0.00094595}, {860,0.00081982}, {865,0.00115315}, {870,0.00061261}, {875,0.00045045}, {880,0.00096396}, {885,0.00087387}, {890,0.00096396}, {895,0.00103604}, {900,0.00094595}, {905,0.00082883}, {910,0.00116216}, {915,0.00113514}, {920,0.00125225}, {925,0.00119820}, {930,0.00096396}, {935,0.00118018}, {940,0.00081081}, {945,0.00097297}, {950,0.00081081}, {955,0.00109910}, {960,0.00088288}, {965,0.00098198}, {970,0.00072973}, {975,0.00119820}, {980,0.00128829}, {985,0.00089189}, {990,0.00109910}, {995,0.00111712}, {1000,0.00090991}, {1010,0.00106306}, {1020,0.00117117}, {1030,0.00097297}, {1040,0.00114414}, {1050,0.00093694}, {1060,0.00119820}, {1070,0.00098198}, {1080,0.00102703}, {1090,0.00114414}, {1100,0.00120721}, {1110,0.00133333}, {1120,0.00117117}, {1130,0.00135135}, {1140,0.00136036}, {1150,0.00149550}, {1160,0.00122523}, {1170,0.00132432}, {1180,0.00147748}, {1190,0.00103604}, {1200,0.00102703}, {1210,0.00121622}, {1220,0.00109009}, {1230,0.00143243}, {1240,0.00064865}, {1250,0.00134234}, {1260,0.00136937}, {1270,0.00146847}, {1280,0.00139640}, {1290,0.00117117}, {1300,0.00135135}, {1310,0.00160360}, {1320,0.00090991}, {1330,0.00143243}, {1340,0.00145946}, {1350,0.00169369}, {1360,0.00168468}, {1370,0.00134234}, {1380,0.00161261}, {1390,0.00136036}, {1400,0.00126126}, {1410,0.00169369}, {1420,0.00132432}, {1430,0.00161261}, {1440,0.00146847}, {1450,0.00133333}, {1460,0.00143243}, {1470,0.00167568}, {1480,0.00172072}, {1490,0.00159459}, {1500,0.00176577}, {1510,0.00138739}, {1520,0.00204505}, {1530,0.00181982}, {1540,0.00134234}, {1550,0.00136937}, {1560,0.00187387}, {1570,0.00142342}, {1580,0.00158559}, {1590,0.00194595}, {1600,0.00180180}, {1610,0.00145946}, {1620,0.00153153}, {1630,0.00159459}, {1640,0.00177477}, {1650,0.00200901}, {1660,0.00172973}, {1670,0.00199099}, {1680,0.00197297}, {1690,0.00179279}, {1700,0.00194595}, {1710,0.00157658}, {1720,0.00194595}, {1730,0.00172973}, {1740,0.00190991}, {1750,0.00192793}, {1760,0.00208108}, {1770,0.00178378}, {1780,0.00193694}, {1790,0.00180180}, {1800,0.00190090}, {1810,0.00184685}, {1820,0.00215315}, {1830,0.00236937}, {1840,0.00186486}, {1850,0.00215315}, {1860,0.00173874}, {1870,0.00173874}, {1880,0.00221622}, {1890,0.00180180}, {1900,0.00180180}, {1910,0.00169369}, {1920,0.00188288}, {1930,0.00188288}, {1940,0.00212613}, {1950,0.00219820}, {1960,0.00201802}, {1970,0.00190090}, {1980,0.00200901}, {1990,0.00189189}, {2000,0.00191892}, {2050,0.00225225}, {2100,0.00225225}, {2150,0.00236036}, {2200,0.00225225}, {2250,0.00848649}, {2300,0.00254955}, {2350,0.00245045}, {2400,0.00254054}, {2450,0.00222523}, {2500,0.00267568}, {2550,0.00307207}, {2600,0.00294595}, {2650,0.00294595}, {2700,0.00288288}, {2750,0.00312613}, {2800,0.00324324}, {2850,0.00331532}, {2900,0.00317117}, {2950,0.00327027}, {3000,0.00340541}, {3050,0.00326126}, {3100,0.00331532}, {3150,0.00345045}, {3200,0.00352252}, {3250,0.00366667}, {3300,0.00362162}, {3350,0.00372072}, {3400,0.00380180}, {3450,0.00381982}, {3500,0.00390090}, {3550,0.00391892}, {3600,0.00405405}, {3650,0.02421622}, {3700,0.00411712}, {3750,0.00427928}, {3800,0.00423423}, {3850,0.00418919}, {3900,0.00429730}, {3950,0.00460360}, {4000,0.00437838}, {4050,0.00472973}, {4100,0.00459459}, {4150,0.00475676}, {4200,0.00445946}, {4250,0.00472072}, {4300,0.00481982}, {4350,0.00483784}, {4400,0.00460360}, {4450,0.00524324}, {4500,0.00481982}, {4550,0.00503604}, {4600,0.00539640}, {4650,0.03081081}, {4700,0.00502703}, {4750,0.00555856}, {4800,0.00521622}, {4850,0.00517117}, {4900,0.00556757}, {4950,0.00604505}, {5000,0.00613514}, {5050,0.00618919}, {5100,0.00593694}, {5150,0.00607207}, {5200,0.00633333}, {5250,0.00599099}, {5300,0.00634234}, {5350,0.00667568}, {5400,0.00669369}, {5450,0.00626126}, {5500,0.00613514}, {5550,0.00619820}, {5600,0.00631532}, {5650,0.00672973}, {5700,0.00662162}, {5750,0.04199099}, {5800,0.00650450}, {5850,0.00672973}, {5900,0.00677477}, {5950,0.00722523}, {6000,0.00676577}, {6050,0.00698198}, {6100,0.00688288}, {6150,0.00692793}, {6200,0.00715315}, {6250,0.00748649}, {6300,0.00721622}, {6350,0.00727928}, {6400,0.00724324}, {6450,0.00734234}, {6500,0.00722523}, {6550,0.00748649}, {6600,0.00749550}, {6650,0.00765766}, {6700,0.00802703}, {6750,0.04869369}, {6800,0.00779279}, {6850,0.00793694}, {6900,0.00793694}, {6950,0.00808108}, {7000,0.00791892}, {7050,0.00821622}, {7100,0.00839640}, {7150,0.00844144}, {7200,0.03655856}, {7250,0.00823423}, {7300,0.00869369}, {7350,0.00866667}, {7400,0.00867568}, {7450,0.02942342}, {7500,0.00965766}, {7550,0.00928829}, {7600,0.00876577}, {7650,0.00897297}, {7700,0.00922523}, {7750,0.00910811}, {7800,0.00909910}, {7850,0.00920721}, {7900,0.00970270}, {7950,0.00966667}, {8000,0.00988288}, {8050,0.00963063}, {8100,0.01042342}, {8150,0.04989189}, {8200,0.00969369}, {8250,0.00968468}, {8300,0.01036036}, {8350,0.01016216}, {8400,0.01023423}, {8450,0.01072072}, {8500,0.01067568}, {8550,0.01018018}, {8600,0.01156757}, {8650,0.03650450}, {8700,0.01026126}, {8750,0.01135135}, {8800,0.01013514}, {8850,0.01066667}, {8900,0.01162162}, {8950,0.01097297}, {9000,0.01093694}, {9050,0.01105405}, {9100,0.01118018}, {9150,0.01150450}, {9200,0.01133333}, {9250,0.01156757}, {9300,0.01220721}, {9350,0.01176577}, {9400,0.05381081}, {9450,0.01167568}, {9500,0.01167568}, {9550,0.01264865}, {9600,0.01179279}, {9650,0.01195495}, {9700,0.06018919}, {9750,0.01220721}, {9800,0.01190090}, {9850,0.01190991}, {9900,0.01283784}, {9950,0.01214414}, {10000,0.01229730}, {10100,0.01251351}, {10200,0.01253153}, {10300,0.01245946}, {10400,0.01253153}, {10500,0.01250450}, {10600,0.01286486}, {10700,0.01319820}, {10800,0.01313514}, {10900,0.01333333}, {11000,0.01446847}, {11100,0.01440541}, {11200,0.01360360}, {11300,0.01364865}, {11400,0.07464865}, {11500,0.01393694}, {11600,0.01392793}, {11700,0.01406306}, {11800,0.01419820}, {11900,0.01514414}, {12000,0.01619820}, {12100,0.01445045}, {12200,0.06084685}, {12300,0.01567568}, {12400,0.01491892}, {12500,0.01466667}, {12600,0.01569369}, {12700,0.08300901}, {12800,0.01675676}, {12900,0.01555856}, {13000,0.01576577}, {13100,0.01594595}, {13200,0.01582883}, {13300,0.01568468}, {13400,0.01728829}, {13500,0.07833333}, {13600,0.01734234}, {13700,0.01634234}, {13800,0.01651351}, {13900,0.01785586}, {14000,0.01567568}, {14100,0.01717117}, {14200,0.01806306}, {14300,0.01708108}, {14400,0.07868468}, {14500,0.01725225}, {14600,0.01834234}, {14700,0.01768468}, {14800,0.01718018}, {14900,0.07382883}, {15000,0.01777477}, {15100,0.01842342}, {15200,0.01840541}, {15300,0.01902703}, {15400,0.01956757}, {15500,0.01982883}, {15600,0.02032432}, {15700,0.01999099}, {15800,0.02013514}, {15900,0.02072973}, {16000,0.02050450}, {16100,0.02050450}, {16200,0.01972973}, {16300,0.01956757}, {16400,0.02002703}, {16500,0.08037838}, {16600,0.02101802}, {16700,0.02200901}, {16800,0.02109910}, {16900,0.02033333}, {17000,0.07749550}, {17100,0.02072072}, {17200,0.02173874}, {17300,0.02135135}, {17400,0.02027928}, {17500,0.02272973}, {17600,0.02174775}, {17700,0.02179279}, {17800,0.02236036}, {17900,0.08061261}, {18000,0.02315315}, {18100,0.11374775}, {18200,0.02409910}, {18300,0.08605405}, {18400,0.02419820}, {18500,0.13565766}, {18600,0.02428829}, {18700,0.09988288}, {18800,0.02416216}, {18900,0.02331532}, {19000,0.02348649}, {19100,0.02495495}, {19200,0.06695495}, {19300,0.02374775}, {19400,0.02508108}, {19500,0.02365766}, {19600,0.11450450}, {19700,0.02419820}, {19800,0.02579279}, {19900,0.02448649}, {20000,0.08287156}};
data["big"]["OCaml"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003604}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00018018}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00002703}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00003604}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00003604}, {155,0.00003604}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00002703}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00003604}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00003604}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00003604}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00003604}, {214,0.00003604}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00003604}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00003604}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00003604}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00003604}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00003604}, {256,0.00000000}, {257,0.00000000}, {258,0.00003604}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00003604}, {269,0.00000000}, {270,0.00000000}, {271,0.00003604}, {272,0.00007207}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00003604}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00003604}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00003604}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00003604}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00003604}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00003604}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00003604}, {360,0.00003604}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00006306}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00003604}, {379,0.00000000}, {380,0.00000000}, {381,0.00003604}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00003604}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00003604}, {401,0.00000000}, {402,0.00003604}, {403,0.00003604}, {404,0.00002703}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00003604}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00003604}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00007207}, {447,0.00000000}, {448,0.00003604}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00003604}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00003604}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00003604}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00003604}, {487,0.00007207}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00003604}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00003604}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00003604}, {575,0.00014414}, {580,0.00002703}, {585,0.00000000}, {590,0.00003604}, {595,0.00007207}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00003604}, {680,0.00000000}, {685,0.00003604}, {690,0.00000000}, {695,0.00000000}, {700,0.00003604}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00003604}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00003604}, {750,0.00000000}, {755,0.00007207}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00003604}, {835,0.00000000}, {840,0.00003604}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00003604}, {865,0.00003604}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00003604}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00003604}, {950,0.00003604}, {955,0.00000000}, {960,0.00000000}, {965,0.00003604}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00007207}, {1120,0.00007207}, {1130,0.00003604}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00003604}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00003604}, {1240,0.00000000}, {1250,0.00003604}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00003604}, {1300,0.00003604}, {1310,0.00003604}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00003604}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00003604}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00003604}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00003604}, {1740,0.00007207}, {1750,0.00002703}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00003604}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00003604}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00003604}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00003604}, {1960,0.00003604}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00003604}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00003604}, {2150,0.00000000}, {2200,0.00002703}, {2250,0.00020721}, {2300,0.00003604}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00003604}, {2550,0.00000000}, {2600,0.00003604}, {2650,0.00003604}, {2700,0.00003604}, {2750,0.00000000}, {2800,0.00003604}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00003604}, {3100,0.00000000}, {3150,0.00003604}, {3200,0.00002703}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00003604}, {3450,0.00003604}, {3500,0.00003604}, {3550,0.00000000}, {3600,0.00003604}, {3650,0.00032432}, {3700,0.00000000}, {3750,0.00003604}, {3800,0.00000000}, {3850,0.00003604}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00003604}, {4100,0.00007207}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00003604}, {4300,0.00003604}, {4350,0.00000000}, {4400,0.00007207}, {4450,0.00003604}, {4500,0.00000000}, {4550,0.00003604}, {4600,0.00000000}, {4650,0.00028829}, {4700,0.00006306}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00003604}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00003604}, {5100,0.00000000}, {5150,0.00003604}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00002703}, {5350,0.00003604}, {5400,0.00003604}, {5450,0.00003604}, {5500,0.00007207}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00075676}, {5800,0.00000000}, {5850,0.00014414}, {5900,0.00003604}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00003604}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00007207}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00003604}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00003604}, {6650,0.00000000}, {6700,0.00002703}, {6750,0.00002703}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00003604}, {7150,0.00003604}, {7200,0.00053153}, {7250,0.00000000}, {7300,0.00003604}, {7350,0.00003604}, {7400,0.00000000}, {7450,0.00043243}, {7500,0.00010811}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00007207}, {7700,0.00003604}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00007207}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00107207}, {8200,0.00003604}, {8250,0.00000000}, {8300,0.00003604}, {8350,0.00003604}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00003604}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00045946}, {8700,0.00000000}, {8750,0.00010811}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00010811}, {8950,0.00003604}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00003604}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00003604}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00003604}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00003604}, {9900,0.00007207}, {9950,0.00007207}, {10000,0.00000000}, {10100,0.00003604}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00007207}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00003604}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00003604}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00003604}, {11900,0.00003604}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00002703}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00007207}, {13200,0.00003604}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00007207}, {14400,0.00000000}, {14500,0.00003604}, {14600,0.00003604}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00007207}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00003604}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00003604}, {16700,0.00003604}, {16800,0.00003604}, {16900,0.00007207}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00003604}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00003604}, {17800,0.00000000}, {17900,0.00003604}, {18000,0.00007207}, {18100,0.00003604}, {18200,0.00007207}, {18300,0.00003604}, {18400,0.00007207}, {18500,0.00003604}, {18600,0.00003604}, {18700,0.00000000}, {18800,0.00006306}, {18900,0.00000000}, {19000,0.00003604}, {19100,0.00003604}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00228829}, {19700,0.00003604}, {19800,0.00007207}, {19900,0.00003604}, {20000,0.00120183}};
data["big"]["OCaml"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00117117}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00001802}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00284685}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000901}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000901}, {620,0.00000901}, {625,0.00000901}, {630,0.00000000}, {635,0.00000901}, {640,0.00000901}, {645,0.00000000}, {650,0.00000901}, {655,0.00000000}, {660,0.00000901}, {665,0.00001802}, {670,0.00000901}, {675,0.00001802}, {680,0.00002703}, {685,0.00004505}, {690,0.00004505}, {695,0.00001802}, {700,0.00004505}, {705,0.00007207}, {710,0.00004505}, {715,0.00008108}, {720,0.00006306}, {725,0.00011712}, {730,0.00008108}, {735,0.00010811}, {740,0.00016216}, {745,0.00016216}, {750,0.00014414}, {755,0.00016216}, {760,0.00006306}, {765,0.00022523}, {770,0.00025225}, {775,0.00018018}, {780,0.00028829}, {785,0.00016216}, {790,0.00030631}, {795,0.00034234}, {800,0.00039640}, {805,0.00042342}, {810,0.00037838}, {815,0.00046847}, {820,0.00053153}, {825,0.00056757}, {830,0.00055856}, {835,0.00062162}, {840,0.00067568}, {845,0.00068468}, {850,0.00072072}, {855,0.00078378}, {860,0.00082883}, {865,0.00081081}, {870,0.00086486}, {875,0.00086486}, {880,0.00562162}, {885,0.00092793}, {890,0.00092793}, {895,0.00094595}, {900,0.00093694}, {905,0.00094595}, {910,0.00095495}, {915,0.00097297}, {920,0.00098198}, {925,0.00097297}, {930,0.00097297}, {935,0.00650450}, {940,0.00100000}, {945,0.00100000}, {950,0.00100000}, {955,0.00100000}, {960,0.00099099}, {965,0.00100000}, {970,0.00100000}, {975,0.00100000}, {980,0.00100000}, {985,0.00100000}, {990,0.00100000}, {995,0.00100000}, {1000,0.00100000}, {1010,0.00100000}, {1020,0.00100000}, {1030,0.00100000}, {1040,0.00100000}, {1050,0.00100000}, {1060,0.00100000}, {1070,0.00100901}, {1080,0.00100901}, {1090,0.00100000}, {1100,0.00100000}, {1110,0.00100901}, {1120,0.00036937}, {1130,0.00100000}, {1140,0.00100000}, {1150,0.00102703}, {1160,0.00102703}, {1170,0.00109009}, {1180,0.00108108}, {1190,0.00107207}, {1200,0.00107207}, {1210,0.00111712}, {1220,0.00112613}, {1230,0.00119820}, {1240,0.00117117}, {1250,0.00128829}, {1260,0.00130631}, {1270,0.00126126}, {1280,0.00127928}, {1290,0.00129730}, {1300,0.00144144}, {1310,0.00135135}, {1320,0.00137838}, {1330,0.00147748}, {1340,0.00141441}, {1350,0.00154955}, {1360,0.00161261}, {1370,0.00166667}, {1380,0.00176577}, {1390,0.00163063}, {1400,0.00667568}, {1410,0.00166667}, {1420,0.00170270}, {1430,0.00174775}, {1440,0.00175676}, {1450,0.00172072}, {1460,0.00184685}, {1470,0.00184685}, {1480,0.00187387}, {1490,0.00190991}, {1500,0.00190991}, {1510,0.00196396}, {1520,0.00197297}, {1530,0.00191892}, {1540,0.00103604}, {1550,0.00195495}, {1560,0.00197297}, {1570,0.00200901}, {1580,0.00200000}, {1590,0.00200000}, {1600,0.00198198}, {1610,0.00200000}, {1620,0.00199099}, {1630,0.00200000}, {1640,0.00201802}, {1650,0.00201802}, {1660,0.00201802}, {1670,0.00203604}, {1680,0.00219820}, {1690,0.00206306}, {1700,0.00208108}, {1710,0.00226126}, {1720,0.00207207}, {1730,0.00209910}, {1740,0.00206306}, {1750,0.00220721}, {1760,0.00218919}, {1770,0.00216216}, {1780,0.00228829}, {1790,0.00231532}, {1800,0.00237838}, {1810,0.00242342}, {1820,0.00245045}, {1830,0.00241441}, {1840,0.00252252}, {1850,0.00258559}, {1860,0.00257658}, {1870,0.00200901}, {1880,0.00269369}, {1890,0.00266667}, {1900,0.00271171}, {1910,0.00267568}, {1920,0.00272973}, {1930,0.00275676}, {1940,0.00281982}, {1950,0.00103604}, {1960,0.00289189}, {1970,0.00290090}, {1980,0.00292793}, {1990,0.00288288}, {2000,0.00288288}, {2050,0.00299099}, {2100,0.00299099}, {2150,0.00299099}, {2200,0.00301802}, {2250,0.00147748}, {2300,0.00313514}, {2350,0.00351351}, {2400,0.00359459}, {2450,0.00376577}, {2500,0.00390090}, {2550,0.00390090}, {2600,0.00395495}, {2650,0.00400000}, {2700,0.00400901}, {2750,0.00403604}, {2800,0.00409910}, {2850,0.02132432}, {2900,0.00438739}, {2950,0.00309910}, {3000,0.00467568}, {3050,0.00479279}, {3100,0.00481982}, {3150,0.00519820}, {3200,0.00220721}, {3250,0.00500000}, {3300,0.00501802}, {3350,0.02510811}, {3400,0.00522523}, {3450,0.00532432}, {3500,0.00558559}, {3550,0.00561261}, {3600,0.00576577}, {3650,0.00305405}, {3700,0.00589189}, {3750,0.00622523}, {3800,0.00556757}, {3850,0.00602703}, {3900,0.00602703}, {3950,0.00674775}, {4000,0.00593694}, {4050,0.03506306}, {4100,0.00665766}, {4150,0.00663964}, {4200,0.00679279}, {4250,0.00564865}, {4300,0.02705405}, {4350,0.00696396}, {4400,0.00696396}, {4450,0.00701802}, {4500,0.00716216}, {4550,0.00721622}, {4600,0.00511712}, {4650,0.00400000}, {4700,0.00763964}, {4750,0.00773874}, {4800,0.00777477}, {4850,0.00783784}, {4900,0.00781081}, {4950,0.00787387}, {5000,0.00798198}, {5050,0.00801802}, {5100,0.00851351}, {5150,0.00870270}, {5200,0.00895495}, {5250,0.00906306}, {5300,0.00911712}, {5350,0.00863063}, {5400,0.00871171}, {5450,0.00873874}, {5500,0.00885586}, {5550,0.00895495}, {5600,0.00902703}, {5650,0.00918018}, {5700,0.00933333}, {5750,0.00499099}, {5800,0.00500901}, {5850,0.00839640}, {5900,0.00971171}, {5950,0.00966667}, {6000,0.00975676}, {6050,0.00984685}, {6100,0.04038739}, {6150,0.00704505}, {6200,0.01005405}, {6250,0.01018919}, {6300,0.01036937}, {6350,0.03893694}, {6400,0.00886486}, {6450,0.01156757}, {6500,0.01063964}, {6550,0.01074775}, {6600,0.00893694}, {6650,0.01126126}, {6700,0.01099099}, {6750,0.00711712}, {6800,0.01072973}, {6850,0.01106306}, {6900,0.07624324}, {6950,0.00981982}, {7000,0.01154955}, {7050,0.04637838}, {7100,0.01072072}, {7150,0.01168468}, {7200,0.00611712}, {7250,0.01234234}, {7300,0.01202703}, {7350,0.00972072}, {7400,0.01205405}, {7450,0.00636937}, {7500,0.01227928}, {7550,0.04328829}, {7600,0.01345946}, {7650,0.01271171}, {7700,0.01176577}, {7750,0.01275676}, {7800,0.01137838}, {7850,0.01284685}, {7900,0.01169369}, {7950,0.01309009}, {8000,0.01357658}, {8050,0.05929730}, {8100,0.01328829}, {8150,0.00711712}, {8200,0.01353153}, {8250,0.00715315}, {8300,0.01367568}, {8350,0.01245045}, {8400,0.04995495}, {8450,0.01380180}, {8500,0.00727928}, {8550,0.01413514}, {8600,0.01417117}, {8650,0.00758559}, {8700,0.01448649}, {8750,0.01445946}, {8800,0.00783784}, {8850,0.01459459}, {8900,0.01463063}, {8950,0.01080180}, {9000,0.04751351}, {9050,0.01484685}, {9100,0.01506306}, {9150,0.00807207}, {9200,0.05909910}, {9250,0.01527928}, {9300,0.01534234}, {9350,0.01169369}, {9400,0.00820721}, {9450,0.01568468}, {9500,0.01566667}, {9550,0.01566667}, {9600,0.01432432}, {9650,0.00873874}, {9700,0.00864865}, {9750,0.06845946}, {9800,0.01632432}, {9850,0.01636036}, {9900,0.01643243}, {9950,0.01526126}, {10000,0.01486486}, {10100,0.01256757}, {10200,0.00899099}, {10300,0.00930631}, {10400,0.00917117}, {10500,0.00925225}, {10600,0.00976577}, {10700,0.00963063}, {10800,0.01312613}, {10900,0.01582883}, {11000,0.01625225}, {11100,0.01840541}, {11200,0.01846847}, {11300,0.10409009}, {11400,0.01013514}, {11500,0.01035135}, {11600,0.01745045}, {11700,0.01951351}, {11800,0.07576577}, {11900,0.01120721}, {12000,0.01723423}, {12100,0.02018919}, {12200,0.01097297}, {12300,0.01721622}, {12400,0.02062162}, {12500,0.01127928}, {12600,0.02041441}, {12700,0.01139640}, {12800,0.01819820}, {12900,0.07363063}, {13000,0.01872072}, {13100,0.08579279}, {13200,0.01855856}, {13300,0.06759459}, {13400,0.01859459}, {13500,0.01197297}, {13600,0.02179279}, {13700,0.01254955}, {13800,0.07997297}, {13900,0.01996396}, {14000,0.01263063}, {14100,0.07954955}, {14200,0.02129730}, {14300,0.01417117}, {14400,0.01285586}, {14500,0.09915315}, {14600,0.02187387}, {14700,0.01944144}, {14800,0.01331532}, {14900,0.01341441}, {15000,0.06923423}, {15100,0.10444144}, {15200,0.02396396}, {15300,0.02263964}, {15400,0.02156757}, {15500,0.02077477}, {15600,0.02034234}, {15700,0.02027027}, {15800,0.02060360}, {15900,0.02124324}, {16000,0.02215315}, {16100,0.02338739}, {16200,0.02509910}, {16300,0.11338739}, {16400,0.07579279}, {16500,0.01793694}, {16600,0.02011712}, {16700,0.02190991}, {16800,0.02413514}, {16900,0.09064865}, {17000,0.01534234}, {17100,0.01656757}, {17200,0.02458559}, {17300,0.07538739}, {17400,0.01752252}, {17500,0.02381081}, {17600,0.07954955}, {17700,0.01771171}, {17800,0.02631532}, {17900,0.01608108}, {18000,0.02345946}, {18100,0.01643243}, {18200,0.02288288}, {18300,0.01669369}, {18400,0.02236036}, {18500,0.01681982}, {18600,0.02369369}, {18700,0.01762162}, {18800,0.02750450}, {18900,0.02171171}, {19000,0.09862162}, {19100,0.02605405}, {19200,0.02281081}, {19300,0.08840541}, {19400,0.02529730}, {19500,0.01936036}, {19600,0.01790991}, {19700,0.12186486}, {19800,0.02539640}, {19900,0.01979279}, {20000,0.01804587}};
data["big"]["OCaml"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003604}, {4,0.00000000}, {5,0.00000000}, {6,0.00003604}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00005405}, {12,0.00003604}, {13,0.00000000}, {14,0.00007207}, {15,0.00003604}, {16,0.00000000}, {17,0.00000000}, {18,0.00003604}, {19,0.00000000}, {20,0.00003604}, {21,0.00007207}, {22,0.00006306}, {23,0.00003604}, {24,0.00006306}, {25,0.00003604}, {26,0.00005405}, {27,0.00003604}, {28,0.00003604}, {29,0.00005405}, {30,0.00000000}, {31,0.00003604}, {32,0.00002703}, {33,0.00007207}, {34,0.00009009}, {35,0.00006306}, {36,0.00003604}, {37,0.00012613}, {38,0.00012613}, {39,0.00000000}, {40,0.00002703}, {41,0.00017117}, {42,0.00007207}, {43,0.00003604}, {44,0.00000000}, {45,0.00006306}, {46,0.00000000}, {47,0.00007207}, {48,0.00007207}, {49,0.00006306}, {50,0.00006306}, {51,0.00000000}, {52,0.00002703}, {53,0.00003604}, {54,0.00013514}, {55,0.00003604}, {56,0.00003604}, {57,0.00000000}, {58,0.00003604}, {59,0.00000000}, {60,0.00009910}, {61,0.00005405}, {62,0.00010811}, {63,0.00013514}, {64,0.00003604}, {65,0.00016216}, {66,0.00000000}, {67,0.00009009}, {68,0.00000000}, {69,0.00003604}, {70,0.00009910}, {71,0.00003604}, {72,0.00009009}, {73,0.00005405}, {74,0.00009910}, {75,0.00009009}, {76,0.00003604}, {77,0.00007207}, {78,0.00003604}, {79,0.00002703}, {80,0.00017117}, {81,0.00000000}, {82,0.00006306}, {83,0.00013514}, {84,0.00014414}, {85,0.00009910}, {86,0.00002703}, {87,0.00007207}, {88,0.00009910}, {89,0.00007207}, {90,0.00014414}, {91,0.00006306}, {92,0.00011712}, {93,0.00007207}, {94,0.00009009}, {95,0.00007207}, {96,0.00006306}, {97,0.00010811}, {98,0.00000000}, {99,0.00013514}, {100,0.00007207}, {101,0.00010811}, {102,0.00023423}, {103,0.00003604}, {104,0.00005405}, {105,0.00020721}, {106,0.00016216}, {107,0.00013514}, {108,0.00000000}, {109,0.00003604}, {110,0.00010811}, {111,0.00010811}, {112,0.00000000}, {113,0.00014414}, {114,0.00010811}, {115,0.00016216}, {116,0.00006306}, {117,0.00002703}, {118,0.00013514}, {119,0.00007207}, {120,0.00013514}, {121,0.00003604}, {122,0.00009910}, {123,0.00007207}, {124,0.00027027}, {125,0.00014414}, {126,0.00021622}, {127,0.00006306}, {128,0.00014414}, {129,0.00012613}, {130,0.00020721}, {131,0.00014414}, {132,0.00009910}, {133,0.00009910}, {134,0.00009910}, {135,0.00005405}, {136,0.00020721}, {137,0.00006306}, {138,0.00009910}, {139,0.00010811}, {140,0.00009910}, {141,0.00006306}, {142,0.00021622}, {143,0.00012613}, {144,0.00006306}, {145,0.00009910}, {146,0.00003604}, {147,0.00014414}, {148,0.00007207}, {149,0.00002703}, {150,0.00017117}, {151,0.00013514}, {152,0.00013514}, {153,0.00013514}, {154,0.00011712}, {155,0.00018018}, {156,0.00020721}, {157,0.00006306}, {158,0.00013514}, {159,0.00005405}, {160,0.00013514}, {161,0.00023423}, {162,0.00013514}, {163,0.00003604}, {164,0.00009910}, {165,0.00010811}, {166,0.00014414}, {167,0.00018919}, {168,0.00012613}, {169,0.00006306}, {170,0.00017117}, {171,0.00006306}, {172,0.00016216}, {173,0.00012613}, {174,0.00019820}, {175,0.00010811}, {176,0.00017117}, {177,0.00020721}, {178,0.00019820}, {179,0.00020721}, {180,0.00025225}, {181,0.00031532}, {182,0.00017117}, {183,0.00002703}, {184,0.00128829}, {185,0.00016216}, {186,0.00017117}, {187,0.00023423}, {188,0.00012613}, {189,0.00018919}, {190,0.00025225}, {191,0.00018919}, {192,0.00009009}, {193,0.00035135}, {194,0.00020721}, {195,0.00014414}, {196,0.00027027}, {197,0.00017117}, {198,0.00018018}, {199,0.00009009}, {200,0.00010811}, {201,0.00019820}, {202,0.00022523}, {203,0.00022523}, {204,0.00006306}, {205,0.00031532}, {206,0.00006306}, {207,0.00016216}, {208,0.00016216}, {209,0.00009009}, {210,0.00024324}, {211,0.00008108}, {212,0.00031532}, {213,0.00009009}, {214,0.00023423}, {215,0.00019820}, {216,0.00018919}, {217,0.00009910}, {218,0.00003604}, {219,0.00019820}, {220,0.00020721}, {221,0.00019820}, {222,0.00029730}, {223,0.00023423}, {224,0.00036937}, {225,0.00017117}, {226,0.00014414}, {227,0.00026126}, {228,0.00018919}, {229,0.00017117}, {230,0.00033333}, {231,0.00009910}, {232,0.00020721}, {233,0.00019820}, {234,0.00031532}, {235,0.00026126}, {236,0.00016216}, {237,0.00036036}, {238,0.00039640}, {239,0.00033333}, {240,0.00026126}, {241,0.00023423}, {242,0.00021622}, {243,0.00024324}, {244,0.00019820}, {245,0.00016216}, {246,0.00029730}, {247,0.00022523}, {248,0.00024324}, {249,0.00025225}, {250,0.00011712}, {251,0.00020721}, {252,0.00021622}, {253,0.00025225}, {254,0.00030631}, {255,0.00009910}, {256,0.00019820}, {257,0.00018018}, {258,0.00023423}, {259,0.00017117}, {260,0.00040541}, {261,0.00036937}, {262,0.00016216}, {263,0.00019820}, {264,0.00020721}, {265,0.00016216}, {266,0.00027027}, {267,0.00034234}, {268,0.00031532}, {269,0.00020721}, {270,0.00022523}, {271,0.00021622}, {272,0.00028829}, {273,0.00020721}, {274,0.00011712}, {275,0.00016216}, {276,0.00032432}, {277,0.00022523}, {278,0.00036036}, {279,0.00030631}, {280,0.00009910}, {281,0.00028829}, {282,0.00019820}, {283,0.00017117}, {284,0.00022523}, {285,0.00028829}, {286,0.00045045}, {287,0.00020721}, {288,0.00034234}, {289,0.00015315}, {290,0.00028829}, {291,0.00021622}, {292,0.00039640}, {293,0.00010811}, {294,0.00038739}, {295,0.00002703}, {296,0.00030631}, {297,0.00022523}, {298,0.00035135}, {299,0.00050450}, {300,0.00018919}, {301,0.00041441}, {302,0.00019820}, {303,0.00026126}, {304,0.00009910}, {305,0.00048649}, {306,0.00045045}, {307,0.00022523}, {308,0.00024324}, {309,0.00020721}, {310,0.00009009}, {311,0.00026126}, {312,0.00011712}, {313,0.00029730}, {314,0.00009009}, {315,0.00022523}, {316,0.00041441}, {317,0.00036036}, {318,0.00035135}, {319,0.00037838}, {320,0.00023423}, {321,0.00019820}, {322,0.00011712}, {323,0.00033333}, {324,0.00017117}, {325,0.00022523}, {326,0.00028829}, {327,0.00027928}, {328,0.00044144}, {329,0.00017117}, {330,0.00045946}, {331,0.00051351}, {332,0.00041441}, {333,0.00024324}, {334,0.00027027}, {335,0.00028829}, {336,0.00025225}, {337,0.00033333}, {338,0.00040541}, {339,0.00045946}, {340,0.00027928}, {341,0.00016216}, {342,0.00036036}, {343,0.00033333}, {344,0.00026126}, {345,0.00021622}, {346,0.00027928}, {347,0.00056757}, {348,0.00026126}, {349,0.00014414}, {350,0.00036937}, {351,0.00052252}, {352,0.00034234}, {353,0.00036036}, {354,0.00048649}, {355,0.00031532}, {356,0.00035135}, {357,0.00041441}, {358,0.00033333}, {359,0.00045045}, {360,0.00032432}, {361,0.00012613}, {362,0.00033333}, {363,0.00035135}, {364,0.00031532}, {365,0.00028829}, {366,0.00037838}, {367,0.00042342}, {368,0.00048649}, {369,0.00030631}, {370,0.00024324}, {371,0.00028829}, {372,0.00045045}, {373,0.00027928}, {374,0.00045045}, {375,0.00045045}, {376,0.00036937}, {377,0.00031532}, {378,0.00026126}, {379,0.00027027}, {380,0.00026126}, {381,0.00031532}, {382,0.00044144}, {383,0.00039640}, {384,0.00017117}, {385,0.00049550}, {386,0.00046847}, {387,0.00014414}, {388,0.00026126}, {389,0.00022523}, {390,0.00018018}, {391,0.00034234}, {392,0.00050450}, {393,0.00045045}, {394,0.00042342}, {395,0.00036036}, {396,0.00043243}, {397,0.00036937}, {398,0.00053153}, {399,0.00032432}, {400,0.00036036}, {401,0.00037838}, {402,0.00034234}, {403,0.00032432}, {404,0.00037838}, {405,0.00021622}, {406,0.00043243}, {407,0.00037838}, {408,0.00048649}, {409,0.00036937}, {410,0.00063964}, {411,0.00048649}, {412,0.00037838}, {413,0.00040541}, {414,0.00039640}, {415,0.00045045}, {416,0.00025225}, {417,0.00038739}, {418,0.00044144}, {419,0.00032432}, {420,0.00014414}, {421,0.00023423}, {422,0.00023423}, {423,0.00033333}, {424,0.00036036}, {425,0.00043243}, {426,0.00022523}, {427,0.00025225}, {428,0.00033333}, {429,0.00024324}, {430,0.00023423}, {431,0.00051351}, {432,0.00036937}, {433,0.00027027}, {434,0.00045946}, {435,0.00031532}, {436,0.00032432}, {437,0.00053153}, {438,0.00034234}, {439,0.00047748}, {440,0.00054955}, {441,0.00049550}, {442,0.00028829}, {443,0.00040541}, {444,0.00046847}, {445,0.00049550}, {446,0.00019820}, {447,0.00027027}, {448,0.00030631}, {449,0.00039640}, {450,0.00027928}, {451,0.00026126}, {452,0.00025225}, {453,0.00063063}, {454,0.00054955}, {455,0.00042342}, {456,0.00034234}, {457,0.00055856}, {458,0.00046847}, {459,0.00023423}, {460,0.00046847}, {461,0.00041441}, {462,0.00034234}, {463,0.00067568}, {464,0.00063063}, {465,0.00048649}, {466,0.00051351}, {467,0.00049550}, {468,0.00036937}, {469,0.00057658}, {470,0.00053153}, {471,0.00046847}, {472,0.00047748}, {473,0.00028829}, {474,0.00040541}, {475,0.00069369}, {476,0.00023423}, {477,0.00280180}, {478,0.00047748}, {479,0.00036937}, {480,0.00042342}, {481,0.00048649}, {482,0.00036036}, {483,0.00048649}, {484,0.00041441}, {485,0.00051351}, {486,0.00047748}, {487,0.00025225}, {488,0.00040541}, {489,0.00055856}, {490,0.00055856}, {491,0.00052252}, {492,0.00063063}, {493,0.00038739}, {494,0.00056757}, {495,0.00055856}, {496,0.00041441}, {497,0.00039640}, {498,0.00047748}, {499,0.00052252}, {500,0.00045946}, {505,0.00041441}, {510,0.00044144}, {515,0.00047748}, {520,0.00055856}, {525,0.00073874}, {530,0.00059459}, {535,0.00042342}, {540,0.00062162}, {545,0.00054955}, {550,0.00057658}, {555,0.00036937}, {560,0.00047748}, {565,0.00056757}, {570,0.00066667}, {575,0.00040541}, {580,0.00058559}, {585,0.00054054}, {590,0.00072072}, {595,0.00044144}, {600,0.00057658}, {605,0.00046847}, {610,0.00067568}, {615,0.00048649}, {620,0.00035135}, {625,0.00053153}, {630,0.00074775}, {635,0.00081081}, {640,0.00073874}, {645,0.00055856}, {650,0.00068468}, {655,0.00044144}, {660,0.00079279}, {665,0.00079279}, {670,0.00101802}, {675,0.00055856}, {680,0.00062162}, {685,0.00038739}, {690,0.00057658}, {695,0.00069369}, {700,0.00063063}, {705,0.00076577}, {710,0.00109910}, {715,0.00059459}, {720,0.00100000}, {725,0.00054955}, {730,0.00067568}, {735,0.00079279}, {740,0.00062162}, {745,0.00083784}, {750,0.00058559}, {755,0.00078378}, {760,0.00082883}, {765,0.00100901}, {770,0.00081081}, {775,0.00082883}, {780,0.00109009}, {785,0.00077477}, {790,0.00100000}, {795,0.00087387}, {800,0.00081982}, {805,0.00090991}, {810,0.00065766}, {815,0.00072072}, {820,0.00114414}, {825,0.00085586}, {830,0.00065766}, {835,0.00102703}, {840,0.00099099}, {845,0.00097297}, {850,0.00103604}, {855,0.00099099}, {860,0.00099099}, {865,0.00124324}, {870,0.00147748}, {875,0.00125225}, {880,0.00540541}, {885,0.00074775}, {890,0.00101802}, {895,0.00117117}, {900,0.00108108}, {905,0.00133333}, {910,0.00100000}, {915,0.00100000}, {920,0.00097297}, {925,0.00100000}, {930,0.00110811}, {935,0.00593694}, {940,0.00120721}, {945,0.00121622}, {950,0.00121622}, {955,0.00125225}, {960,0.00096396}, {965,0.00103604}, {970,0.00137838}, {975,0.00110811}, {980,0.00119820}, {985,0.00120721}, {990,0.00113514}, {995,0.00132432}, {1000,0.00153153}, {1010,0.00115315}, {1020,0.00135135}, {1030,0.00131532}, {1040,0.00118018}, {1050,0.00146847}, {1060,0.00135135}, {1070,0.00135135}, {1080,0.00165766}, {1090,0.00133333}, {1100,0.00129730}, {1110,0.00116216}, {1120,0.00097297}, {1130,0.00136036}, {1140,0.00162162}, {1150,0.00118018}, {1160,0.00153153}, {1170,0.00158559}, {1180,0.00145045}, {1190,0.00192793}, {1200,0.00163063}, {1210,0.00145946}, {1220,0.00175676}, {1230,0.00134234}, {1240,0.00223423}, {1250,0.00182883}, {1260,0.00184685}, {1270,0.00167568}, {1280,0.00151351}, {1290,0.00183784}, {1300,0.00162162}, {1310,0.00159459}, {1320,0.00216216}, {1330,0.00143243}, {1340,0.00160360}, {1350,0.00138739}, {1360,0.00165766}, {1370,0.00209910}, {1380,0.00184685}, {1390,0.00190991}, {1400,0.00669369}, {1410,0.00156757}, {1420,0.00203604}, {1430,0.00184685}, {1440,0.00215315}, {1450,0.00217117}, {1460,0.00195495}, {1470,0.00204505}, {1480,0.00192793}, {1490,0.00218018}, {1500,0.00186486}, {1510,0.00226126}, {1520,0.00170270}, {1530,0.00182883}, {1540,0.00191892}, {1550,0.00233333}, {1560,0.00202703}, {1570,0.00244144}, {1580,0.00234234}, {1590,0.00200901}, {1600,0.00225225}, {1610,0.00252252}, {1620,0.00244144}, {1630,0.00238739}, {1640,0.00236937}, {1650,0.00219820}, {1660,0.00234234}, {1670,0.00235135}, {1680,0.00252252}, {1690,0.00258559}, {1700,0.00259459}, {1710,0.00272973}, {1720,0.00232432}, {1730,0.00245946}, {1740,0.00266667}, {1750,0.00245045}, {1760,0.00233333}, {1770,0.00249550}, {1780,0.00237838}, {1790,0.00269369}, {1800,0.00256757}, {1810,0.00282883}, {1820,0.00251351}, {1830,0.00238739}, {1840,0.00271171}, {1850,0.00253153}, {1860,0.00272072}, {1870,0.00216216}, {1880,0.00286486}, {1890,0.00300000}, {1900,0.00272973}, {1910,0.00300901}, {1920,0.00294595}, {1930,0.00254955}, {1940,0.00276577}, {1950,0.00154054}, {1960,0.00279279}, {1970,0.00294595}, {1980,0.00304505}, {1990,0.00305405}, {2000,0.00304505}, {2050,0.00303604}, {2100,0.00323423}, {2150,0.00324324}, {2200,0.00334234}, {2250,0.00202703}, {2300,0.00345045}, {2350,0.00372072}, {2400,0.00374775}, {2450,0.00372072}, {2500,0.00382883}, {2550,0.00391892}, {2600,0.00404505}, {2650,0.00411712}, {2700,0.00408108}, {2750,0.00407207}, {2800,0.00410811}, {2850,0.02090090}, {2900,0.00453153}, {2950,0.00329730}, {3000,0.00466667}, {3050,0.00476577}, {3100,0.00483784}, {3150,0.00522523}, {3200,0.00260360}, {3250,0.00490090}, {3300,0.00508108}, {3350,0.02497297}, {3400,0.00524324}, {3450,0.00527027}, {3500,0.00520721}, {3550,0.00527928}, {3600,0.00588288}, {3650,0.00301802}, {3700,0.00588288}, {3750,0.00579279}, {3800,0.00538739}, {3850,0.00587387}, {3900,0.00613514}, {3950,0.00668468}, {4000,0.00593694}, {4050,0.03463063}, {4100,0.00645045}, {4150,0.00641441}, {4200,0.00676577}, {4250,0.00544144}, {4300,0.02671171}, {4350,0.00694595}, {4400,0.00698198}, {4450,0.00691892}, {4500,0.00718018}, {4550,0.00707207}, {4600,0.00527027}, {4650,0.00386486}, {4700,0.00741441}, {4750,0.00737838}, {4800,0.00768468}, {4850,0.00763063}, {4900,0.00762162}, {4950,0.00775676}, {5000,0.00784685}, {5050,0.00796396}, {5100,0.00839640}, {5150,0.00836937}, {5200,0.00852252}, {5250,0.00878378}, {5300,0.00872973}, {5350,0.00867568}, {5400,0.00863063}, {5450,0.00863063}, {5500,0.00890991}, {5550,0.00931532}, {5600,0.00905405}, {5650,0.00917117}, {5700,0.00922523}, {5750,0.00472973}, {5800,0.00488288}, {5850,0.00829730}, {5900,0.01014414}, {5950,0.01006306}, {6000,0.01014414}, {6050,0.00987387}, {6100,0.03954955}, {6150,0.00695495}, {6200,0.01027027}, {6250,0.01079279}, {6300,0.01084685}, {6350,0.03915315}, {6400,0.00872973}, {6450,0.01175676}, {6500,0.01098198}, {6550,0.01103604}, {6600,0.00868468}, {6650,0.01159459}, {6700,0.01118018}, {6750,0.00703604}, {6800,0.01119820}, {6850,0.01154955}, {6900,0.07614414}, {6950,0.00999099}, {7000,0.01194595}, {7050,0.04602703}, {7100,0.01097297}, {7150,0.01206306}, {7200,0.00616216}, {7250,0.01277477}, {7300,0.01262162}, {7350,0.00984685}, {7400,0.01246847}, {7450,0.00607207}, {7500,0.01257658}, {7550,0.04225225}, {7600,0.01354955}, {7650,0.01281982}, {7700,0.01208108}, {7750,0.01306306}, {7800,0.01172072}, {7850,0.01320721}, {7900,0.01213514}, {7950,0.01336036}, {8000,0.01359459}, {8050,0.05836036}, {8100,0.01372973}, {8150,0.00710811}, {8200,0.01424324}, {8250,0.00708108}, {8300,0.01375676}, {8350,0.01272973}, {8400,0.04910811}, {8450,0.01391892}, {8500,0.00701802}, {8550,0.01429730}, {8600,0.01423423}, {8650,0.00720721}, {8700,0.01475676}, {8750,0.01447748}, {8800,0.00751351}, {8850,0.01490090}, {8900,0.01478378}, {8950,0.01084685}, {9000,0.04758559}, {9050,0.01502703}, {9100,0.01502703}, {9150,0.00794595}, {9200,0.05904505}, {9250,0.01530631}, {9300,0.01540541}, {9350,0.01209009}, {9400,0.00831532}, {9450,0.01582883}, {9500,0.01551351}, {9550,0.01581081}, {9600,0.01466667}, {9650,0.00879279}, {9700,0.00839640}, {9750,0.06865766}, {9800,0.01619820}, {9850,0.01631532}, {9900,0.01630631}, {9950,0.01513514}, {10000,0.01528829}, {10100,0.01290991}, {10200,0.00908108}, {10300,0.00973874}, {10400,0.00957658}, {10500,0.00919820}, {10600,0.00981081}, {10700,0.00954955}, {10800,0.01327027}, {10900,0.01563964}, {11000,0.01613514}, {11100,0.01823423}, {11200,0.01845946}, {11300,0.10411712}, {11400,0.01049550}, {11500,0.01071171}, {11600,0.01740541}, {11700,0.01977477}, {11800,0.07582883}, {11900,0.01133333}, {12000,0.01708108}, {12100,0.02036937}, {12200,0.01134234}, {12300,0.01730631}, {12400,0.02085586}, {12500,0.01175676}, {12600,0.02047748}, {12700,0.01190090}, {12800,0.01834234}, {12900,0.07353153}, {13000,0.01835135}, {13100,0.08551351}, {13200,0.01845045}, {13300,0.06782883}, {13400,0.01853153}, {13500,0.01252252}, {13600,0.02200000}, {13700,0.01281081}, {13800,0.08003604}, {13900,0.02037838}, {14000,0.01287387}, {14100,0.07979279}, {14200,0.02133333}, {14300,0.01427928}, {14400,0.01280180}, {14500,0.09928829}, {14600,0.02209009}, {14700,0.01940541}, {14800,0.01355856}, {14900,0.01359459}, {15000,0.06934234}, {15100,0.10401802}, {15200,0.02411712}, {15300,0.02318018}, {15400,0.02188288}, {15500,0.02065766}, {15600,0.02025225}, {15700,0.02030631}, {15800,0.02086486}, {15900,0.02143243}, {16000,0.02269369}, {16100,0.02381081}, {16200,0.02514414}, {16300,0.11345045}, {16400,0.07560360}, {16500,0.01798198}, {16600,0.02014414}, {16700,0.02196396}, {16800,0.02454955}, {16900,0.09057658}, {17000,0.01527928}, {17100,0.01645946}, {17200,0.02487387}, {17300,0.07533333}, {17400,0.01718018}, {17500,0.02414414}, {17600,0.07946847}, {17700,0.01734234}, {17800,0.02612613}, {17900,0.01568468}, {18000,0.02392793}, {18100,0.01642342}, {18200,0.02311712}, {18300,0.01634234}, {18400,0.02247748}, {18500,0.01685586}, {18600,0.02421622}, {18700,0.01737838}, {18800,0.02740541}, {18900,0.02152252}, {19000,0.09845946}, {19100,0.02616216}, {19200,0.02291892}, {19300,0.08845045}, {19400,0.02567568}, {19500,0.01920721}, {19600,0.01785586}, {19700,0.11950450}, {19800,0.02545045}, {19900,0.01986486}, {20000,0.01786239}};
data["big"]["OCaml"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00003604}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00003604}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00003604}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00003604}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00003604}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00003604}, {106,0.00000000}, {107,0.00000000}, {108,0.00003604}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00003604}, {114,0.00000000}, {115,0.00003604}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00003604}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00003604}, {132,0.00000000}, {133,0.00000000}, {134,0.00003604}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00003604}, {142,0.00000000}, {143,0.00003604}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00002703}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00003604}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003604}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00007207}, {287,0.00003604}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00007207}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00003604}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00003604}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00003604}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00003604}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00003604}, {378,0.00000000}, {379,0.00000000}, {380,0.00003604}, {381,0.00003604}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00003604}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00003604}, {409,0.00003604}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00003604}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00003604}, {453,0.00000000}, {454,0.00000000}, {455,0.00003604}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00003604}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00003604}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00007207}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00003604}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00003604}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00003604}, {540,0.00003604}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00003604}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00003604}, {630,0.00000000}, {635,0.00003604}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00003604}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00003604}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00003604}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00003604}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00007207}, {825,0.00000000}, {830,0.00000000}, {835,0.00003604}, {840,0.00000000}, {845,0.00000000}, {850,0.00003604}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00003604}, {875,0.00000000}, {880,0.00003604}, {885,0.00000000}, {890,0.00003604}, {895,0.00003604}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00003604}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00003604}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00003604}, {965,0.00000000}, {970,0.00000000}, {975,0.00003604}, {980,0.00000000}, {985,0.00003604}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00003604}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00003604}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00003604}, {1180,0.00000000}, {1190,0.00003604}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00003604}, {1320,0.00003604}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00003604}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00014414}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00003604}, {1500,0.00003604}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00003604}, {1540,0.00000000}, {1550,0.00003604}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00003604}, {1620,0.00000000}, {1630,0.00003604}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003604}, {1670,0.00000000}, {1680,0.00003604}, {1690,0.00003604}, {1700,0.00000000}, {1710,0.00003604}, {1720,0.00002703}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00007207}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00007207}, {1820,0.00003604}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00003604}, {1940,0.00000000}, {1950,0.00003604}, {1960,0.00003604}, {1970,0.00000000}, {1980,0.00002703}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00003604}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00031532}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00006306}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00031532}, {3400,0.00000000}, {3450,0.00003604}, {3500,0.00000000}, {3550,0.00003604}, {3600,0.00003604}, {3650,0.00003604}, {3700,0.00000000}, {3750,0.00010811}, {3800,0.00000000}, {3850,0.00003604}, {3900,0.00007207}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00036036}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00003604}, {4250,0.00003604}, {4300,0.00046847}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00003604}, {4500,0.00000000}, {4550,0.00007207}, {4600,0.00003604}, {4650,0.00003604}, {4700,0.00000000}, {4750,0.00003604}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00003604}, {5100,0.00000000}, {5150,0.00002703}, {5200,0.00000000}, {5250,0.00003604}, {5300,0.00003604}, {5350,0.00000000}, {5400,0.00003604}, {5450,0.00003604}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00003604}, {5750,0.00010811}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00003604}, {5950,0.00000000}, {6000,0.00007207}, {6050,0.00000000}, {6100,0.00060360}, {6150,0.00003604}, {6200,0.00000000}, {6250,0.00007207}, {6300,0.00000000}, {6350,0.00007207}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00003604}, {6600,0.00000000}, {6650,0.00003604}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00014414}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00063964}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00006306}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00007207}, {7400,0.00000000}, {7450,0.00003604}, {7500,0.00000000}, {7550,0.00082883}, {7600,0.00010811}, {7650,0.00003604}, {7700,0.00003604}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00003604}, {7900,0.00000000}, {7950,0.00003604}, {8000,0.00003604}, {8050,0.00107207}, {8100,0.00003604}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00003604}, {8350,0.00000000}, {8400,0.00085586}, {8450,0.00003604}, {8500,0.00003604}, {8550,0.00000000}, {8600,0.00003604}, {8650,0.00000000}, {8700,0.00003604}, {8750,0.00003604}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00010811}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00003604}, {9150,0.00003604}, {9200,0.00007207}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00002703}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00010811}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00003604}, {9900,0.00007207}, {9950,0.00000000}, {10000,0.00007207}, {10100,0.00000000}, {10200,0.00007207}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00003604}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00003604}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00003604}, {11400,0.00007207}, {11500,0.00000000}, {11600,0.00003604}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00003604}, {12900,0.00000000}, {13000,0.00003604}, {13100,0.00002703}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00003604}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00003604}, {14000,0.00007207}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00007207}, {14900,0.00000000}, {15000,0.00007207}, {15100,0.00007207}, {15200,0.00003604}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00007207}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00003604}, {15900,0.00000000}, {16000,0.00003604}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00003604}, {16400,0.00007207}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00003604}, {16800,0.00007207}, {16900,0.00000000}, {17000,0.00002703}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00003604}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00003604}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00003604}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00007207}, {18300,0.00000000}, {18400,0.00006306}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00003604}, {18800,0.00003604}, {18900,0.00007207}, {19000,0.00000000}, {19100,0.00003604}, {19200,0.00003604}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00006306}, {19700,0.00255856}, {19800,0.00007207}, {19900,0.00003604}, {20000,0.00003670}};
data["big"]["OCaml"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.01361261}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00002703}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00003604}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000901}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00099099}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000901}, {187,0.00000901}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00099099}, {207,0.00000000}, {208,0.00000000}, {209,0.00001802}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00125225}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00003604}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000901}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000901}, {298,0.00000000}, {299,0.00000000}, {300,0.00000901}, {301,0.00000000}, {302,0.00000000}, {303,0.00000901}, {304,0.00000000}, {305,0.00000901}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00001802}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00001802}, {317,0.00000000}, {318,0.00000901}, {319,0.00000000}, {320,0.00004505}, {321,0.00003604}, {322,0.00001802}, {323,0.00002703}, {324,0.00002703}, {325,0.00004505}, {326,0.00003604}, {327,0.00004505}, {328,0.00002703}, {329,0.00007207}, {330,0.00003604}, {331,0.00004505}, {332,0.00000901}, {333,0.00005405}, {334,0.00009910}, {335,0.00010811}, {336,0.00012613}, {337,0.00013514}, {338,0.00017117}, {339,0.00010811}, {340,0.00015315}, {341,0.00016216}, {342,0.00019820}, {343,0.00026126}, {344,0.00025225}, {345,0.00027027}, {346,0.00020721}, {347,0.00024324}, {348,0.00026126}, {349,0.00036036}, {350,0.00039640}, {351,0.00041441}, {352,0.00047748}, {353,0.00044144}, {354,0.00045946}, {355,0.00050450}, {356,0.00050450}, {357,0.00062162}, {358,0.00063964}, {359,0.00061261}, {360,0.00069369}, {361,0.00070270}, {362,0.00072072}, {363,0.00075676}, {364,0.00079279}, {365,0.00081081}, {366,0.00082883}, {367,0.00079279}, {368,0.00081081}, {369,0.00083784}, {370,0.00086486}, {371,0.00090090}, {372,0.00092793}, {373,0.00094595}, {374,0.00092793}, {375,0.00091892}, {376,0.00096396}, {377,0.00097297}, {378,0.00097297}, {379,0.00099099}, {380,0.00100000}, {381,0.00099099}, {382,0.00100901}, {383,0.00100000}, {384,0.00099099}, {385,0.00100000}, {386,0.00100000}, {387,0.00100000}, {388,0.00100000}, {389,0.00100000}, {390,0.00100000}, {391,0.00100000}, {392,0.00100000}, {393,0.00100000}, {394,0.00100000}, {395,0.00101802}, {396,0.00100000}, {397,0.00100000}, {398,0.00100000}, {399,0.00100000}, {400,0.00100000}, {401,0.00100000}, {402,0.00100000}, {403,0.00100000}, {404,0.00100000}, {405,0.00100000}, {406,0.00100000}, {407,0.00100000}, {408,0.00100000}, {409,0.00100000}, {410,0.00100000}, {411,0.00100000}, {412,0.00100000}, {413,0.00100000}, {414,0.00100000}, {415,0.00100000}, {416,0.00100000}, {417,0.00100000}, {418,0.00100000}, {419,0.00100000}, {420,0.00100000}, {421,0.00100000}, {422,0.00100000}, {423,0.00100000}, {424,0.00100000}, {425,0.00100000}, {426,0.00100000}, {427,0.00100000}, {428,0.00100000}, {429,0.00100000}, {430,0.00100901}, {431,0.00100000}, {432,0.00100000}, {433,0.00100000}, {434,0.00100000}, {435,0.00100000}, {436,0.00100000}, {437,0.00100000}, {438,0.00100000}, {439,0.00100000}, {440,0.00100000}, {441,0.00100000}, {442,0.00100000}, {443,0.00100000}, {444,0.00100000}, {445,0.00100000}, {446,0.00377477}, {447,0.00100000}, {448,0.00100000}, {449,0.00100000}, {450,0.00100000}, {451,0.00102703}, {452,0.00100000}, {453,0.00100000}, {454,0.00100000}, {455,0.00100000}, {456,0.00100000}, {457,0.00100000}, {458,0.00100000}, {459,0.00100000}, {460,0.00100000}, {461,0.00100000}, {462,0.00100000}, {463,0.00100000}, {464,0.00100000}, {465,0.00100000}, {466,0.00100000}, {467,0.00204505}, {468,0.00100000}, {469,0.00100000}, {470,0.00100000}, {471,0.00100000}, {472,0.00100000}, {473,0.00100000}, {474,0.00100000}, {475,0.00100000}, {476,0.00100000}, {477,0.00100000}, {478,0.00100000}, {479,0.00100000}, {480,0.00100000}, {481,0.00100000}, {482,0.00100000}, {483,0.00100000}, {484,0.00100000}, {485,0.00100000}, {486,0.00100000}, {487,0.00397297}, {488,0.00100000}, {489,0.00100000}, {490,0.00100000}, {491,0.00100000}, {492,0.00100000}, {493,0.00100000}, {494,0.00100000}, {495,0.00100000}, {496,0.00100000}, {497,0.00100000}, {498,0.00100000}, {499,0.00100000}, {500,0.00100000}, {505,0.00100000}, {510,0.00100000}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00100000}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00381982}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100901}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100901}, {685,0.00101802}, {690,0.00100901}, {695,0.00101802}, {700,0.00103604}, {705,0.00102703}, {710,0.00101802}, {715,0.00105405}, {720,0.00107207}, {725,0.00107207}, {730,0.00108108}, {735,0.00109009}, {740,0.00116216}, {745,0.00120721}, {750,0.00122523}, {755,0.00125225}, {760,0.00118018}, {765,0.00139640}, {770,0.00143243}, {775,0.00143243}, {780,0.00150450}, {785,0.00159459}, {790,0.00165766}, {795,0.00180180}, {800,0.00182883}, {805,0.00187387}, {810,0.00183784}, {815,0.00184685}, {820,0.00189189}, {825,0.00195495}, {830,0.00196396}, {835,0.00197297}, {840,0.00199099}, {845,0.00199099}, {850,0.00200000}, {855,0.00200000}, {860,0.00200000}, {865,0.00209009}, {870,0.00200000}, {875,0.00200000}, {880,0.00200000}, {885,0.00200000}, {890,0.00200000}, {895,0.00200000}, {900,0.00200901}, {905,0.00200000}, {910,0.00200000}, {915,0.00200000}, {920,0.00200000}, {925,0.00200000}, {930,0.00200000}, {935,0.00200000}, {940,0.00200000}, {945,0.00200000}, {950,0.00200000}, {955,0.00200000}, {960,0.00200000}, {965,0.00200000}, {970,0.00200000}, {975,0.00200000}, {980,0.00200901}, {985,0.00200901}, {990,0.00200000}, {995,0.00200901}, {1000,0.00200901}, {1010,0.00200901}, {1020,0.00201802}, {1030,0.00202703}, {1040,0.00200901}, {1050,0.00200901}, {1060,0.00204505}, {1070,0.00204505}, {1080,0.00207207}, {1090,0.00209009}, {1100,0.00208108}, {1110,0.00209910}, {1120,0.00200000}, {1130,0.00218919}, {1140,0.00239640}, {1150,0.00240541}, {1160,0.00250450}, {1170,0.00255856}, {1180,0.00263964}, {1190,0.00266667}, {1200,0.00274775}, {1210,0.00286486}, {1220,0.00286486}, {1230,0.00289189}, {1240,0.00291892}, {1250,0.00297297}, {1260,0.00297297}, {1270,0.00300000}, {1280,0.00300901}, {1290,0.00300901}, {1300,0.00300000}, {1310,0.00300000}, {1320,0.00300901}, {1330,0.00301802}, {1340,0.00300901}, {1350,0.00302703}, {1360,0.00305405}, {1370,0.00309009}, {1380,0.00301802}, {1390,0.00307207}, {1400,0.00306306}, {1410,0.00307207}, {1420,0.00307207}, {1430,0.00315315}, {1440,0.00318018}, {1450,0.00310811}, {1460,0.00316216}, {1470,0.00327027}, {1480,0.00324324}, {1490,0.00327027}, {1500,0.00336937}, {1510,0.00334234}, {1520,0.00336937}, {1530,0.00340541}, {1540,0.00302703}, {1550,0.00358559}, {1560,0.00369369}, {1570,0.00369369}, {1580,0.00376577}, {1590,0.00380180}, {1600,0.00386486}, {1610,0.00388288}, {1620,0.00387387}, {1630,0.00395495}, {1640,0.00391892}, {1650,0.00408108}, {1660,0.00405405}, {1670,0.00399099}, {1680,0.00399099}, {1690,0.00409910}, {1700,0.00408108}, {1710,0.00412613}, {1720,0.00408108}, {1730,0.00408108}, {1740,0.00432432}, {1750,0.00415315}, {1760,0.00418919}, {1770,0.00427027}, {1780,0.00418018}, {1790,0.00431532}, {1800,0.00428829}, {1810,0.00433333}, {1820,0.00427027}, {1830,0.00430631}, {1840,0.00435135}, {1850,0.00445946}, {1860,0.00443243}, {1870,0.00400901}, {1880,0.00449550}, {1890,0.00460360}, {1900,0.00459459}, {1910,0.00461261}, {1920,0.00465766}, {1930,0.00480180}, {1940,0.00474775}, {1950,0.00990991}, {1960,0.00485586}, {1970,0.00495495}, {1980,0.00489189}, {1990,0.00500901}, {2000,0.00508108}, {2050,0.00515315}, {2100,0.00527928}, {2150,0.00547748}, {2200,0.00558559}, {2250,0.01253153}, {2300,0.00619820}, {2350,0.00620721}, {2400,0.00639640}, {2450,0.00651351}, {2500,0.00676577}, {2550,0.00685586}, {2600,0.00704505}, {2650,0.00723423}, {2700,0.00745946}, {2750,0.00758559}, {2800,0.00777477}, {2850,0.00800000}, {2900,0.00837838}, {2950,0.00711712}, {3000,0.00842342}, {3050,0.00867568}, {3100,0.00889189}, {3150,0.00924324}, {3200,0.01623423}, {3250,0.00945045}, {3300,0.00955856}, {3350,0.00982883}, {3400,0.00996396}, {3450,0.01017117}, {3500,0.01037838}, {3550,0.01050450}, {3600,0.01068468}, {3650,0.03141441}, {3700,0.01106306}, {3750,0.01128829}, {3800,0.01081982}, {3850,0.01159459}, {3900,0.01163964}, {3950,0.01182883}, {4000,0.01161261}, {4050,0.01232432}, {4100,0.01251351}, {4150,0.01281081}, {4200,0.01274775}, {4250,0.01163964}, {4300,0.01302703}, {4350,0.01315315}, {4400,0.01343243}, {4450,0.01400901}, {4500,0.01372973}, {4550,0.01386486}, {4600,0.01170270}, {4650,0.03989189}, {4700,0.01437838}, {4750,0.01455856}, {4800,0.01471171}, {4850,0.01477477}, {4900,0.01494595}, {4950,0.01536036}, {5000,0.01572072}, {5050,0.01608108}, {5100,0.01564865}, {5150,0.01572072}, {5200,0.01586486}, {5250,0.01605405}, {5300,0.01629730}, {5350,0.01696396}, {5400,0.01699099}, {5450,0.01706306}, {5500,0.01681982}, {5550,0.01694595}, {5600,0.01721622}, {5650,0.01733333}, {5700,0.01745045}, {5750,0.05370270}, {5800,0.02787387}, {5850,0.01667568}, {5900,0.01819820}, {5950,0.01889189}, {6000,0.01845946}, {6050,0.01855856}, {6100,0.01872072}, {6150,0.01572973}, {6200,0.01913514}, {6250,0.01972973}, {6300,0.01941441}, {6350,0.01952252}, {6400,0.01776577}, {6450,0.01990090}, {6500,0.01994595}, {6550,0.02027928}, {6600,0.01820721}, {6650,0.02046847}, {6700,0.02052252}, {6750,0.06131532}, {6800,0.02045946}, {6850,0.02094595}, {6900,0.02123423}, {6950,0.01962162}, {7000,0.02181982}, {7050,0.02175676}, {7100,0.02072072}, {7150,0.02196396}, {7200,0.05059459}, {7250,0.02234234}, {7300,0.02255856}, {7350,0.02009009}, {7400,0.02271171}, {7450,0.04412613}, {7500,0.02372973}, {7550,0.02332432}, {7600,0.02336036}, {7650,0.02361261}, {7700,0.02268468}, {7750,0.02381081}, {7800,0.02240541}, {7850,0.02418018}, {7900,0.02279279}, {7950,0.02446847}, {8000,0.02401802}, {8050,0.02476577}, {8100,0.02591892}, {8150,0.06632432}, {8200,0.02578378}, {8250,0.04198198}, {8300,0.02545045}, {8350,0.02417117}, {8400,0.02588288}, {8450,0.02646847}, {8500,0.01947748}, {8550,0.02632432}, {8600,0.02745045}, {8650,0.05293694}, {8700,0.02669369}, {8750,0.02802703}, {8800,0.05477477}, {8850,0.02713514}, {8900,0.02811712}, {8950,0.02331532}, {9000,0.02769369}, {9050,0.02781081}, {9100,0.02726126}, {9150,0.04563063}, {9200,0.02834234}, {9250,0.02846847}, {9300,0.02967568}, {9350,0.02464865}, {9400,0.07148649}, {9450,0.02914414}, {9500,0.02910811}, {9550,0.03043243}, {9600,0.02669369}, {9650,0.05063063}, {9700,0.07847748}, {9750,0.03012613}, {9800,0.03016216}, {9850,0.03077477}, {9900,0.03127928}, {9950,0.02968468}, {10000,0.02779279}, {10100,0.02652252}, {10200,0.04541441}, {10300,0.05306306}, {10400,0.06344144}, {10500,0.06390090}, {10600,0.05800901}, {10700,0.04741441}, {10800,0.02799099}, {10900,0.02985586}, {11000,0.03300901}, {11100,0.03503604}, {11200,0.03484685}, {11300,0.03471171}, {11400,0.09607207}, {11500,0.06072973}, {11600,0.03271171}, {11700,0.03694595}, {11800,0.03636937}, {11900,0.07792793}, {12000,0.03565766}, {12100,0.03720721}, {12200,0.08374775}, {12300,0.03558559}, {12400,0.03813514}, {12500,0.07699099}, {12600,0.03887387}, {12700,0.10681081}, {12800,0.03753153}, {12900,0.03977477}, {13000,0.03582883}, {13100,0.04036937}, {13200,0.03590991}, {13300,0.04095495}, {13400,0.03876577}, {13500,0.10367568}, {13600,0.04192793}, {13700,0.06677477}, {13800,0.04260360}, {13900,0.04072072}, {14000,0.09577477}, {14100,0.04333333}, {14200,0.04214414}, {14300,0.03287387}, {14400,0.10519820}, {14500,0.04463063}, {14600,0.04332432}, {14700,0.03881982}, {14800,0.09107207}, {14900,0.10192793}, {15000,0.04625225}, {15100,0.04627027}, {15200,0.04623423}, {15300,0.04485586}, {15400,0.04405405}, {15500,0.04368468}, {15600,0.04350450}, {15700,0.04325225}, {15800,0.04392793}, {15900,0.04482883}, {16000,0.04571171}, {16100,0.04683784}, {16200,0.04866667}, {16300,0.04980180}, {16400,0.05035135}, {16500,0.11100000}, {16600,0.09891892}, {16700,0.04672973}, {16800,0.04846847}, {16900,0.05181982}, {17000,0.10915315}, {17100,0.03948649}, {17200,0.04940541}, {17300,0.05327027}, {17400,0.09313514}, {17500,0.04934234}, {17600,0.05414414}, {17700,0.08185586}, {17800,0.05186486}, {17900,0.11392793}, {18000,0.04996396}, {18100,0.14744144}, {18200,0.04987387}, {18300,0.12011712}, {18400,0.04960360}, {18500,0.17039640}, {18600,0.05114414}, {18700,0.13456757}, {18800,0.05470270}, {18900,0.10715315}, {19000,0.05776577}, {19100,0.05428829}, {19200,0.10310811}, {19300,0.05815315}, {19400,0.05355856}, {19500,0.10446847}, {19600,0.15359459}, {19700,0.05749550}, {19800,0.05436937}, {19900,0.08913514}, {20000,0.12150459}};
data["big"]["OCaml"]["norm reif"]["user"] = {{1,0.00006306}, {2,0.00016216}, {3,0.00019820}, {4,0.00006306}, {5,0.00019820}, {6,0.00033333}, {7,0.00027928}, {8,0.00022523}, {9,0.00032432}, {10,0.00036937}, {11,0.00022523}, {12,0.00026126}, {13,0.00025225}, {14,0.00027027}, {15,0.00037838}, {16,0.00018018}, {17,0.00016216}, {18,0.00032432}, {19,0.00022523}, {20,0.00027027}, {21,0.00024324}, {22,0.00023423}, {23,0.00029730}, {24,0.00030631}, {25,0.00026126}, {26,0.00012613}, {27,0.00009910}, {28,0.00038739}, {29,0.00029730}, {30,0.00026126}, {31,0.00035135}, {32,0.00017117}, {33,0.00022523}, {34,0.00024324}, {35,0.00036937}, {36,0.00024324}, {37,0.00019820}, {38,0.00022523}, {39,0.00029730}, {40,0.00033333}, {41,0.00020721}, {42,0.00031532}, {43,0.00027027}, {44,0.00038739}, {45,0.00020721}, {46,0.00041441}, {47,0.00040541}, {48,0.00044144}, {49,0.00058559}, {50,0.00034234}, {51,0.00048649}, {52,0.00027027}, {53,0.00027027}, {54,0.00014414}, {55,0.00017117}, {56,0.00036937}, {57,0.00018919}, {58,0.01371171}, {59,0.00028829}, {60,0.00036937}, {61,0.00041441}, {62,0.00036036}, {63,0.00030631}, {64,0.00029730}, {65,0.00029730}, {66,0.00035135}, {67,0.00031532}, {68,0.00038739}, {69,0.00047748}, {70,0.00040541}, {71,0.00024324}, {72,0.00043243}, {73,0.00029730}, {74,0.00034234}, {75,0.00035135}, {76,0.00023423}, {77,0.00037838}, {78,0.00028829}, {79,0.00030631}, {80,0.00036036}, {81,0.00060360}, {82,0.00044144}, {83,0.00039640}, {84,0.00041441}, {85,0.00054955}, {86,0.00024324}, {87,0.00057658}, {88,0.00042342}, {89,0.00012613}, {90,0.00048649}, {91,0.00037838}, {92,0.00035135}, {93,0.00038739}, {94,0.00046847}, {95,0.00046847}, {96,0.00046847}, {97,0.00070270}, {98,0.00014414}, {99,0.00037838}, {100,0.00036937}, {101,0.00036036}, {102,0.00053153}, {103,0.00027928}, {104,0.00040541}, {105,0.00033333}, {106,0.00051351}, {107,0.00038739}, {108,0.00039640}, {109,0.00050450}, {110,0.00047748}, {111,0.00047748}, {112,0.00033333}, {113,0.00030631}, {114,0.00069369}, {115,0.00051351}, {116,0.00024324}, {117,0.00039640}, {118,0.00045045}, {119,0.00068468}, {120,0.00042342}, {121,0.00033333}, {122,0.00044144}, {123,0.00070270}, {124,0.00063964}, {125,0.00028829}, {126,0.00020721}, {127,0.00030631}, {128,0.00046847}, {129,0.00054054}, {130,0.00055856}, {131,0.00036036}, {132,0.00044144}, {133,0.00035135}, {134,0.00063063}, {135,0.00056757}, {136,0.00049550}, {137,0.00033333}, {138,0.00033333}, {139,0.00052252}, {140,0.00067568}, {141,0.00027027}, {142,0.00052252}, {143,0.00065766}, {144,0.00054955}, {145,0.00039640}, {146,0.00044144}, {147,0.00040541}, {148,0.00042342}, {149,0.00044144}, {150,0.00063964}, {151,0.00059459}, {152,0.00062162}, {153,0.00056757}, {154,0.00058559}, {155,0.00053153}, {156,0.00056757}, {157,0.00047748}, {158,0.00045946}, {159,0.00052252}, {160,0.00140541}, {161,0.00052252}, {162,0.00045045}, {163,0.00051351}, {164,0.00050450}, {165,0.00044144}, {166,0.00041441}, {167,0.00045045}, {168,0.00044144}, {169,0.00043243}, {170,0.00038739}, {171,0.00050450}, {172,0.00053153}, {173,0.00050450}, {174,0.00057658}, {175,0.00041441}, {176,0.00036937}, {177,0.00036036}, {178,0.00067568}, {179,0.00074775}, {180,0.00077477}, {181,0.00075676}, {182,0.00074775}, {183,0.00072973}, {184,0.00067568}, {185,0.00032432}, {186,0.00055856}, {187,0.00074775}, {188,0.00078378}, {189,0.00046847}, {190,0.00048649}, {191,0.00045946}, {192,0.00067568}, {193,0.00048649}, {194,0.00072973}, {195,0.00075676}, {196,0.00055856}, {197,0.00052252}, {198,0.00061261}, {199,0.00071171}, {200,0.00050450}, {201,0.00039640}, {202,0.00045946}, {203,0.00076577}, {204,0.00077477}, {205,0.00049550}, {206,0.00165766}, {207,0.00051351}, {208,0.00045045}, {209,0.00075676}, {210,0.00054054}, {211,0.00076577}, {212,0.00037838}, {213,0.00079279}, {214,0.00039640}, {215,0.00064865}, {216,0.00063964}, {217,0.00047748}, {218,0.00067568}, {219,0.00059459}, {220,0.00072072}, {221,0.00048649}, {222,0.00074775}, {223,0.00051351}, {224,0.00041441}, {225,0.00067568}, {226,0.00183784}, {227,0.00047748}, {228,0.00071171}, {229,0.00055856}, {230,0.00066667}, {231,0.00084685}, {232,0.00050450}, {233,0.00070270}, {234,0.00075676}, {235,0.00082883}, {236,0.00045045}, {237,0.00060360}, {238,0.00072973}, {239,0.00051351}, {240,0.00042342}, {241,0.00055856}, {242,0.00043243}, {243,0.00072072}, {244,0.00069369}, {245,0.00048649}, {246,0.00073874}, {247,0.00069369}, {248,0.00052252}, {249,0.00089189}, {250,0.00063964}, {251,0.00048649}, {252,0.00095495}, {253,0.00064865}, {254,0.00079279}, {255,0.00081081}, {256,0.00054054}, {257,0.00103604}, {258,0.00053153}, {259,0.00063063}, {260,0.00081081}, {261,0.00053153}, {262,0.00082883}, {263,0.00064865}, {264,0.00088288}, {265,0.00092793}, {266,0.00063964}, {267,0.00048649}, {268,0.00062162}, {269,0.00059459}, {270,0.00085586}, {271,0.00051351}, {272,0.00059459}, {273,0.00073874}, {274,0.00096396}, {275,0.00078378}, {276,0.00069369}, {277,0.00079279}, {278,0.00063964}, {279,0.00063964}, {280,0.00091892}, {281,0.00090090}, {282,0.00100000}, {283,0.00089189}, {284,0.00089189}, {285,0.00085586}, {286,0.00081982}, {287,0.00096396}, {288,0.00091892}, {289,0.00105405}, {290,0.00088288}, {291,0.00090991}, {292,0.00075676}, {293,0.00087387}, {294,0.00080180}, {295,0.00080180}, {296,0.00109009}, {297,0.00054054}, {298,0.00091892}, {299,0.00028829}, {300,0.00100000}, {301,0.00079279}, {302,0.00078378}, {303,0.00085586}, {304,0.00055856}, {305,0.00073874}, {306,0.00046847}, {307,0.00088288}, {308,0.00090991}, {309,0.00069369}, {310,0.00094595}, {311,0.00100901}, {312,0.00067568}, {313,0.00100901}, {314,0.00072973}, {315,0.00090991}, {316,0.00074775}, {317,0.00063063}, {318,0.00078378}, {319,0.00084685}, {320,0.00082883}, {321,0.00097297}, {322,0.00092793}, {323,0.00066667}, {324,0.00104505}, {325,0.00111712}, {326,0.00056757}, {327,0.00094595}, {328,0.00088288}, {329,0.00074775}, {330,0.00097297}, {331,0.00059459}, {332,0.00075676}, {333,0.00102703}, {334,0.00096396}, {335,0.00083784}, {336,0.00071171}, {337,0.00106306}, {338,0.00125225}, {339,0.00092793}, {340,0.00051351}, {341,0.00100901}, {342,0.00100901}, {343,0.00090090}, {344,0.00089189}, {345,0.00070270}, {346,0.00093694}, {347,0.00118919}, {348,0.00054955}, {349,0.00069369}, {350,0.00115315}, {351,0.00088288}, {352,0.00084685}, {353,0.00100000}, {354,0.00061261}, {355,0.00089189}, {356,0.00091892}, {357,0.00088288}, {358,0.00092793}, {359,0.00093694}, {360,0.00115315}, {361,0.00080180}, {362,0.00097297}, {363,0.00093694}, {364,0.00100000}, {365,0.00104505}, {366,0.00075676}, {367,0.00108108}, {368,0.00101802}, {369,0.00059459}, {370,0.00100901}, {371,0.00106306}, {372,0.00093694}, {373,0.00095495}, {374,0.00093694}, {375,0.00103604}, {376,0.00111712}, {377,0.00105405}, {378,0.00088288}, {379,0.00100000}, {380,0.00119820}, {381,0.00099099}, {382,0.00092793}, {383,0.00090090}, {384,0.00109910}, {385,0.00101802}, {386,0.00089189}, {387,0.00122523}, {388,0.00101802}, {389,0.00098198}, {390,0.00107207}, {391,0.00108108}, {392,0.00070270}, {393,0.00105405}, {394,0.00109910}, {395,0.00102703}, {396,0.00091892}, {397,0.00102703}, {398,0.00075676}, {399,0.00100000}, {400,0.00089189}, {401,0.00087387}, {402,0.00077477}, {403,0.00081081}, {404,0.00081081}, {405,0.00077477}, {406,0.00095495}, {407,0.00108108}, {408,0.00098198}, {409,0.00090090}, {410,0.00090090}, {411,0.00073874}, {412,0.00072973}, {413,0.00109910}, {414,0.00122523}, {415,0.00123423}, {416,0.00135135}, {417,0.00117117}, {418,0.00102703}, {419,0.00090991}, {420,0.00104505}, {421,0.00099099}, {422,0.00092793}, {423,0.00070270}, {424,0.00090991}, {425,0.00120721}, {426,0.00108108}, {427,0.00117117}, {428,0.00103604}, {429,0.00094595}, {430,0.00081982}, {431,0.00093694}, {432,0.00093694}, {433,0.00097297}, {434,0.00081982}, {435,0.00122523}, {436,0.00129730}, {437,0.00113514}, {438,0.00103604}, {439,0.00097297}, {440,0.00097297}, {441,0.00090991}, {442,0.00099099}, {443,0.00099099}, {444,0.00101802}, {445,0.00090991}, {446,0.00384685}, {447,0.00082883}, {448,0.00100000}, {449,0.00109910}, {450,0.00120721}, {451,0.00101802}, {452,0.00071171}, {453,0.00071171}, {454,0.00109009}, {455,0.00120721}, {456,0.00106306}, {457,0.00127027}, {458,0.00108108}, {459,0.00145946}, {460,0.00110811}, {461,0.00088288}, {462,0.00092793}, {463,0.00090991}, {464,0.00127928}, {465,0.00148649}, {466,0.00127027}, {467,0.00219820}, {468,0.00118018}, {469,0.00106306}, {470,0.00113514}, {471,0.00122523}, {472,0.00136036}, {473,0.00117117}, {474,0.00088288}, {475,0.00118919}, {476,0.00124324}, {477,0.00104505}, {478,0.00103604}, {479,0.00134234}, {480,0.00128829}, {481,0.00120721}, {482,0.00128829}, {483,0.00113514}, {484,0.00137838}, {485,0.00121622}, {486,0.00111712}, {487,0.00410811}, {488,0.00116216}, {489,0.00115315}, {490,0.00105405}, {491,0.00113514}, {492,0.00109910}, {493,0.00127027}, {494,0.00108108}, {495,0.00117117}, {496,0.00116216}, {497,0.00135135}, {498,0.00115315}, {499,0.00124324}, {500,0.00108108}, {505,0.00131532}, {510,0.00133333}, {515,0.00128829}, {520,0.00114414}, {525,0.00104505}, {530,0.00128829}, {535,0.00133333}, {540,0.00124324}, {545,0.00113514}, {550,0.00135135}, {555,0.00140541}, {560,0.00140541}, {565,0.00148649}, {570,0.00107207}, {575,0.00384685}, {580,0.00134234}, {585,0.00131532}, {590,0.00118919}, {595,0.00130631}, {600,0.00145045}, {605,0.00141441}, {610,0.00139640}, {615,0.00166667}, {620,0.00155856}, {625,0.00154054}, {630,0.00150450}, {635,0.00148649}, {640,0.00163964}, {645,0.00191892}, {650,0.00205405}, {655,0.00129730}, {660,0.00140541}, {665,0.00150450}, {670,0.00139640}, {675,0.00200000}, {680,0.00197297}, {685,0.00187387}, {690,0.00175676}, {695,0.00163063}, {700,0.00152252}, {705,0.00155856}, {710,0.00163964}, {715,0.00171171}, {720,0.00163063}, {725,0.00207207}, {730,0.00162162}, {735,0.00169369}, {740,0.00200901}, {745,0.00177477}, {750,0.00186486}, {755,0.00174775}, {760,0.00157658}, {765,0.00184685}, {770,0.00180180}, {775,0.00177477}, {780,0.00161261}, {785,0.00198198}, {790,0.00204505}, {795,0.00167568}, {800,0.00216216}, {805,0.00181982}, {810,0.00224324}, {815,0.00213514}, {820,0.00183784}, {825,0.00200000}, {830,0.00209910}, {835,0.00213514}, {840,0.00173874}, {845,0.00186486}, {850,0.00194595}, {855,0.00192793}, {860,0.00190991}, {865,0.00203604}, {870,0.00165766}, {875,0.00158559}, {880,0.00220721}, {885,0.00233333}, {890,0.00223423}, {895,0.00215315}, {900,0.00209910}, {905,0.00177477}, {910,0.00230631}, {915,0.00218919}, {920,0.00220721}, {925,0.00222523}, {930,0.00219820}, {935,0.00235135}, {940,0.00204505}, {945,0.00222523}, {950,0.00209910}, {955,0.00227928}, {960,0.00233333}, {965,0.00227027}, {970,0.00207207}, {975,0.00234234}, {980,0.00242342}, {985,0.00220721}, {990,0.00231532}, {995,0.00231532}, {1000,0.00216216}, {1010,0.00245045}, {1020,0.00226126}, {1030,0.00234234}, {1040,0.00247748}, {1050,0.00245946}, {1060,0.00254955}, {1070,0.00253153}, {1080,0.00234234}, {1090,0.00246847}, {1100,0.00266667}, {1110,0.00276577}, {1120,0.00227027}, {1130,0.00277477}, {1140,0.00268468}, {1150,0.00290991}, {1160,0.00272973}, {1170,0.00272072}, {1180,0.00271171}, {1190,0.00254955}, {1200,0.00303604}, {1210,0.00311712}, {1220,0.00273874}, {1230,0.00302703}, {1240,0.00263964}, {1250,0.00282883}, {1260,0.00296396}, {1270,0.00298198}, {1280,0.00292793}, {1290,0.00304505}, {1300,0.00298198}, {1310,0.00319820}, {1320,0.00300000}, {1330,0.00312613}, {1340,0.00328829}, {1350,0.00336036}, {1360,0.00326126}, {1370,0.00340541}, {1380,0.00320721}, {1390,0.00326126}, {1400,0.00324324}, {1410,0.00331532}, {1420,0.00334234}, {1430,0.00350450}, {1440,0.00342342}, {1450,0.00353153}, {1460,0.00346847}, {1470,0.00347748}, {1480,0.00355856}, {1490,0.00336036}, {1500,0.00360360}, {1510,0.00343243}, {1520,0.00376577}, {1530,0.00369369}, {1540,0.00335135}, {1550,0.00376577}, {1560,0.00386486}, {1570,0.00381982}, {1580,0.00394595}, {1590,0.00399099}, {1600,0.00380180}, {1610,0.00381081}, {1620,0.00382883}, {1630,0.00395495}, {1640,0.00400901}, {1650,0.00405405}, {1660,0.00401802}, {1670,0.00408108}, {1680,0.00410811}, {1690,0.00402703}, {1700,0.00408108}, {1710,0.00414414}, {1720,0.00422523}, {1730,0.00440541}, {1740,0.00442342}, {1750,0.00423423}, {1760,0.00453153}, {1770,0.00438739}, {1780,0.00452252}, {1790,0.00443243}, {1800,0.00436036}, {1810,0.00435135}, {1820,0.00454054}, {1830,0.00466667}, {1840,0.00454955}, {1850,0.00486486}, {1860,0.00448649}, {1870,0.00384685}, {1880,0.00461261}, {1890,0.00448649}, {1900,0.00463063}, {1910,0.00446847}, {1920,0.00463063}, {1930,0.00492793}, {1940,0.00463964}, {1950,0.01001802}, {1960,0.00488288}, {1970,0.00469369}, {1980,0.00471171}, {1990,0.00481982}, {2000,0.00490090}, {2050,0.00518919}, {2100,0.00529730}, {2150,0.00545946}, {2200,0.00531532}, {2250,0.01262162}, {2300,0.00595495}, {2350,0.00598198}, {2400,0.00618919}, {2450,0.00608108}, {2500,0.00652252}, {2550,0.00665766}, {2600,0.00700901}, {2650,0.00701802}, {2700,0.00743243}, {2750,0.00754955}, {2800,0.00790090}, {2850,0.00796396}, {2900,0.00851351}, {2950,0.00699099}, {3000,0.00857658}, {3050,0.00863964}, {3100,0.00869369}, {3150,0.00906306}, {3200,0.01612613}, {3250,0.00986486}, {3300,0.00976577}, {3350,0.01020721}, {3400,0.01020721}, {3450,0.01028829}, {3500,0.01057658}, {3550,0.01106306}, {3600,0.01090991}, {3650,0.03105405}, {3700,0.01127027}, {3750,0.01159459}, {3800,0.01107207}, {3850,0.01194595}, {3900,0.01207207}, {3950,0.01245045}, {4000,0.01181081}, {4050,0.01279279}, {4100,0.01265766}, {4150,0.01331532}, {4200,0.01283784}, {4250,0.01196396}, {4300,0.01337838}, {4350,0.01336937}, {4400,0.01327027}, {4450,0.01390090}, {4500,0.01384685}, {4550,0.01377477}, {4600,0.01196396}, {4650,0.03945946}, {4700,0.01448649}, {4750,0.01482883}, {4800,0.01473874}, {4850,0.01480180}, {4900,0.01497297}, {4950,0.01558559}, {5000,0.01584685}, {5050,0.01620721}, {5100,0.01580180}, {5150,0.01568468}, {5200,0.01595495}, {5250,0.01618919}, {5300,0.01635135}, {5350,0.01700000}, {5400,0.01719820}, {5450,0.01728829}, {5500,0.01681982}, {5550,0.01686486}, {5600,0.01736036}, {5650,0.01736036}, {5700,0.01729730}, {5750,0.05280180}, {5800,0.02734234}, {5850,0.01669369}, {5900,0.01790991}, {5950,0.01881982}, {6000,0.01819820}, {6050,0.01856757}, {6100,0.01865766}, {6150,0.01566667}, {6200,0.01894595}, {6250,0.01930631}, {6300,0.01927928}, {6350,0.01955856}, {6400,0.01779279}, {6450,0.01977477}, {6500,0.01981982}, {6550,0.01994595}, {6600,0.01822523}, {6650,0.02056757}, {6700,0.02050450}, {6750,0.06143243}, {6800,0.02036937}, {6850,0.02081081}, {6900,0.02127928}, {6950,0.01944144}, {7000,0.02184685}, {7050,0.02163063}, {7100,0.02069369}, {7150,0.02234234}, {7200,0.05007207}, {7250,0.02241441}, {7300,0.02272072}, {7350,0.01978378}, {7400,0.02300000}, {7450,0.04357658}, {7500,0.02396396}, {7550,0.02373874}, {7600,0.02372072}, {7650,0.02391892}, {7700,0.02290991}, {7750,0.02405405}, {7800,0.02250450}, {7850,0.02442342}, {7900,0.02302703}, {7950,0.02479279}, {8000,0.02436036}, {8050,0.02499099}, {8100,0.02622523}, {8150,0.06501802}, {8200,0.02581081}, {8250,0.04135135}, {8300,0.02582883}, {8350,0.02454054}, {8400,0.02638739}, {8450,0.02663964}, {8500,0.01946847}, {8550,0.02644144}, {8600,0.02762162}, {8650,0.05257658}, {8700,0.02686486}, {8750,0.02800901}, {8800,0.05498198}, {8850,0.02713514}, {8900,0.02790090}, {8950,0.02379279}, {9000,0.02772973}, {9050,0.02755856}, {9100,0.02721622}, {9150,0.04579279}, {9200,0.02834234}, {9250,0.02861261}, {9300,0.02957658}, {9350,0.02506306}, {9400,0.07123423}, {9450,0.02909910}, {9500,0.02920721}, {9550,0.03038739}, {9600,0.02654955}, {9650,0.05078378}, {9700,0.07864865}, {9750,0.03001802}, {9800,0.03011712}, {9850,0.03077477}, {9900,0.03109009}, {9950,0.02951351}, {10000,0.02764865}, {10100,0.02627027}, {10200,0.04543243}, {10300,0.05265766}, {10400,0.06327928}, {10500,0.06419820}, {10600,0.05808108}, {10700,0.04739640}, {10800,0.02795495}, {10900,0.02979279}, {11000,0.03293694}, {11100,0.03534234}, {11200,0.03511712}, {11300,0.03484685}, {11400,0.09592793}, {11500,0.06081081}, {11600,0.03278378}, {11700,0.03680180}, {11800,0.03652252}, {11900,0.07827027}, {12000,0.03596396}, {12100,0.03746847}, {12200,0.08363964}, {12300,0.03582883}, {12400,0.03832432}, {12500,0.07645946}, {12600,0.03903604}, {12700,0.10695495}, {12800,0.03775676}, {12900,0.03956757}, {13000,0.03618919}, {13100,0.04061261}, {13200,0.03606306}, {13300,0.04060360}, {13400,0.03885586}, {13500,0.10363063}, {13600,0.04204505}, {13700,0.06681081}, {13800,0.04270270}, {13900,0.04069369}, {14000,0.09531532}, {14100,0.04362162}, {14200,0.04218018}, {14300,0.03309009}, {14400,0.10519820}, {14500,0.04433333}, {14600,0.04344144}, {14700,0.03874775}, {14800,0.09108108}, {14900,0.10188288}, {15000,0.04622523}, {15100,0.04659459}, {15200,0.04651351}, {15300,0.04470270}, {15400,0.04384685}, {15500,0.04376577}, {15600,0.04356757}, {15700,0.04311712}, {15800,0.04378378}, {15900,0.04488288}, {16000,0.04583784}, {16100,0.04718919}, {16200,0.04885586}, {16300,0.04969369}, {16400,0.05063964}, {16500,0.11103604}, {16600,0.09902703}, {16700,0.04711712}, {16800,0.04844144}, {16900,0.05161261}, {17000,0.10891892}, {17100,0.03947748}, {17200,0.04943243}, {17300,0.05346847}, {17400,0.09325225}, {17500,0.04959459}, {17600,0.05423423}, {17700,0.08204505}, {17800,0.05172973}, {17900,0.11418919}, {18000,0.04981081}, {18100,0.14751351}, {18200,0.04993694}, {18300,0.11978378}, {18400,0.04978378}, {18500,0.17002703}, {18600,0.05118018}, {18700,0.13440541}, {18800,0.05479279}, {18900,0.10722523}, {19000,0.05797297}, {19100,0.05411712}, {19200,0.10308108}, {19300,0.05831532}, {19400,0.05351351}, {19500,0.10353153}, {19600,0.15118919}, {19700,0.05750450}, {19800,0.05438739}, {19900,0.08856757}, {20000,0.12045872}};
data["big"]["OCaml"]["norm reif"]["system"] = {{1,0.00010811}, {2,0.00003604}, {3,0.00003604}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003604}, {13,0.00003604}, {14,0.00000000}, {15,0.00000000}, {16,0.00003604}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00003604}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00003604}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003604}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00018018}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00002703}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00003604}, {70,0.00000000}, {71,0.00000000}, {72,0.00002703}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00003604}, {96,0.00000000}, {97,0.00000000}, {98,0.00003604}, {99,0.00003604}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00003604}, {106,0.00000000}, {107,0.00000000}, {108,0.00003604}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00003604}, {115,0.00000000}, {116,0.00007207}, {117,0.00000000}, {118,0.00000000}, {119,0.00007207}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00003604}, {128,0.00000000}, {129,0.00003604}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00003604}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00003604}, {138,0.00003604}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00003604}, {147,0.00000000}, {148,0.00003604}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00003604}, {154,0.00007207}, {155,0.00003604}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00002703}, {166,0.00003604}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00003604}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00003604}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00003604}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00003604}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00003604}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00003604}, {214,0.00003604}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00003604}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00003604}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00003604}, {230,0.00003604}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00003604}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00003604}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00003604}, {252,0.00000000}, {253,0.00000000}, {254,0.00002703}, {255,0.00003604}, {256,0.00000000}, {257,0.00000000}, {258,0.00003604}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00003604}, {269,0.00000000}, {270,0.00000000}, {271,0.00007207}, {272,0.00007207}, {273,0.00000000}, {274,0.00003604}, {275,0.00000000}, {276,0.00003604}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00003604}, {285,0.00000000}, {286,0.00000000}, {287,0.00003604}, {288,0.00000000}, {289,0.00000000}, {290,0.00003604}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00003604}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00003604}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00003604}, {322,0.00003604}, {323,0.00000000}, {324,0.00003604}, {325,0.00003604}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00003604}, {331,0.00002703}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00007207}, {338,0.00003604}, {339,0.00003604}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00003604}, {345,0.00000000}, {346,0.00000000}, {347,0.00003604}, {348,0.00000000}, {349,0.00003604}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00007207}, {360,0.00003604}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00006306}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00003604}, {379,0.00003604}, {380,0.00000000}, {381,0.00003604}, {382,0.00000000}, {383,0.00000000}, {384,0.00003604}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00003604}, {390,0.00000000}, {391,0.00000000}, {392,0.00003604}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00003604}, {401,0.00000000}, {402,0.00003604}, {403,0.00003604}, {404,0.00002703}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00003604}, {410,0.00000000}, {411,0.00000000}, {412,0.00003604}, {413,0.00003604}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00007207}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00003604}, {424,0.00003604}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00003604}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00003604}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00007207}, {447,0.00000000}, {448,0.00003604}, {449,0.00000000}, {450,0.00000000}, {451,0.00003604}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00003604}, {461,0.00007207}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00003604}, {467,0.00002703}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00003604}, {480,0.00000000}, {481,0.00000000}, {482,0.00003604}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00003604}, {487,0.00010811}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00007207}, {494,0.00000000}, {495,0.00003604}, {496,0.00000000}, {497,0.00003604}, {498,0.00007207}, {499,0.00000000}, {500,0.00000000}, {505,0.00003604}, {510,0.00000000}, {515,0.00000000}, {520,0.00003604}, {525,0.00000000}, {530,0.00003604}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00003604}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00003604}, {575,0.00014414}, {580,0.00002703}, {585,0.00000000}, {590,0.00003604}, {595,0.00014414}, {600,0.00003604}, {605,0.00003604}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00003604}, {680,0.00000000}, {685,0.00003604}, {690,0.00003604}, {695,0.00000000}, {700,0.00003604}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00003604}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00007207}, {750,0.00000000}, {755,0.00007207}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00003604}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00003604}, {805,0.00003604}, {810,0.00003604}, {815,0.00000000}, {820,0.00000000}, {825,0.00003604}, {830,0.00010811}, {835,0.00000000}, {840,0.00003604}, {845,0.00000000}, {850,0.00003604}, {855,0.00003604}, {860,0.00003604}, {865,0.00007207}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00003604}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00007207}, {950,0.00003604}, {955,0.00000000}, {960,0.00010811}, {965,0.00003604}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00003604}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00003604}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00003604}, {1110,0.00007207}, {1120,0.00007207}, {1130,0.00003604}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00007207}, {1170,0.00000000}, {1180,0.00007207}, {1190,0.00003604}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00007207}, {1240,0.00000000}, {1250,0.00003604}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003604}, {1290,0.00003604}, {1300,0.00007207}, {1310,0.00003604}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00003604}, {1360,0.00003604}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00003604}, {1420,0.00000000}, {1430,0.00003604}, {1440,0.00003604}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00003604}, {1480,0.00000000}, {1490,0.00003604}, {1500,0.00003604}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00003604}, {1680,0.00000000}, {1690,0.00003604}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00003604}, {1730,0.00003604}, {1740,0.00007207}, {1750,0.00002703}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00007207}, {1800,0.00000000}, {1810,0.00007207}, {1820,0.00003604}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00007207}, {1870,0.00007207}, {1880,0.00000000}, {1890,0.00003604}, {1900,0.00000000}, {1910,0.00003604}, {1920,0.00003604}, {1930,0.00000000}, {1940,0.00003604}, {1950,0.00010811}, {1960,0.00010811}, {1970,0.00003604}, {1980,0.00000000}, {1990,0.00003604}, {2000,0.00000000}, {2050,0.00003604}, {2100,0.00003604}, {2150,0.00000000}, {2200,0.00006306}, {2250,0.00024324}, {2300,0.00003604}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00003604}, {2500,0.00007207}, {2550,0.00003604}, {2600,0.00003604}, {2650,0.00003604}, {2700,0.00003604}, {2750,0.00000000}, {2800,0.00003604}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00003604}, {3000,0.00000000}, {3050,0.00007207}, {3100,0.00000000}, {3150,0.00003604}, {3200,0.00017117}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00007207}, {3450,0.00003604}, {3500,0.00007207}, {3550,0.00000000}, {3600,0.00003604}, {3650,0.00032432}, {3700,0.00000000}, {3750,0.00007207}, {3800,0.00000000}, {3850,0.00003604}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00003604}, {4050,0.00003604}, {4100,0.00010811}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00003604}, {4300,0.00003604}, {4350,0.00000000}, {4400,0.00014414}, {4450,0.00010811}, {4500,0.00000000}, {4550,0.00003604}, {4600,0.00003604}, {4650,0.00028829}, {4700,0.00006306}, {4750,0.00000000}, {4800,0.00010811}, {4850,0.00003604}, {4900,0.00003604}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00003604}, {5100,0.00000000}, {5150,0.00014414}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00002703}, {5350,0.00007207}, {5400,0.00007207}, {5450,0.00003604}, {5500,0.00014414}, {5550,0.00003604}, {5600,0.00000000}, {5650,0.00007207}, {5700,0.00003604}, {5750,0.00075676}, {5800,0.00018018}, {5850,0.00014414}, {5900,0.00003604}, {5950,0.00000000}, {6000,0.00003604}, {6050,0.00003604}, {6100,0.00002703}, {6150,0.00003604}, {6200,0.00009910}, {6250,0.00003604}, {6300,0.00003604}, {6350,0.00003604}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00003604}, {6550,0.00000000}, {6600,0.00003604}, {6650,0.00007207}, {6700,0.00006306}, {6750,0.00005405}, {6800,0.00003604}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00007207}, {7100,0.00010811}, {7150,0.00003604}, {7200,0.00053153}, {7250,0.00007207}, {7300,0.00003604}, {7350,0.00003604}, {7400,0.00000000}, {7450,0.00046847}, {7500,0.00010811}, {7550,0.00003604}, {7600,0.00000000}, {7650,0.00007207}, {7700,0.00007207}, {7750,0.00000000}, {7800,0.00003604}, {7850,0.00007207}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00002703}, {8050,0.00002703}, {8100,0.00000000}, {8150,0.00110811}, {8200,0.00003604}, {8250,0.00044144}, {8300,0.00014414}, {8350,0.00003604}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00003604}, {8550,0.00000000}, {8600,0.00003604}, {8650,0.00045946}, {8700,0.00003604}, {8750,0.00010811}, {8800,0.00002703}, {8850,0.00000000}, {8900,0.00014414}, {8950,0.00003604}, {9000,0.00000000}, {9050,0.00007207}, {9100,0.00000000}, {9150,0.00003604}, {9200,0.00003604}, {9250,0.00000000}, {9300,0.00003604}, {9350,0.00010811}, {9400,0.00003604}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00003604}, {9600,0.00014414}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00007207}, {9850,0.00003604}, {9900,0.00007207}, {9950,0.00007207}, {10000,0.00000000}, {10100,0.00007207}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00007207}, {10600,0.00003604}, {10700,0.00003604}, {10800,0.00003604}, {10900,0.00000000}, {11000,0.00003604}, {11100,0.00003604}, {11200,0.00000000}, {11300,0.00003604}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00003604}, {11800,0.00003604}, {11900,0.00003604}, {12000,0.00000000}, {12100,0.00003604}, {12200,0.00000000}, {12300,0.00002703}, {12400,0.00000000}, {12500,0.00003604}, {12600,0.00002703}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00003604}, {13000,0.00000000}, {13100,0.00007207}, {13200,0.00007207}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00003604}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00003604}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00007207}, {14400,0.00000000}, {14500,0.00007207}, {14600,0.00003604}, {14700,0.00000000}, {14800,0.00003604}, {14900,0.00000000}, {15000,0.00010811}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00007207}, {15800,0.00003604}, {15900,0.00000000}, {16000,0.00002703}, {16100,0.00003604}, {16200,0.00000000}, {16300,0.00003604}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00003604}, {16700,0.00003604}, {16800,0.00010811}, {16900,0.00010811}, {17000,0.00007207}, {17100,0.00000000}, {17200,0.00010811}, {17300,0.00000000}, {17400,0.00007207}, {17500,0.00003604}, {17600,0.00000000}, {17700,0.00003604}, {17800,0.00003604}, {17900,0.00010811}, {18000,0.00007207}, {18100,0.00007207}, {18200,0.00010811}, {18300,0.00003604}, {18400,0.00010811}, {18500,0.00003604}, {18600,0.00003604}, {18700,0.00003604}, {18800,0.00017117}, {18900,0.00000000}, {19000,0.00003604}, {19100,0.00009910}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00003604}, {19500,0.00092793}, {19600,0.00232432}, {19700,0.00010811}, {19800,0.00007207}, {19900,0.00078378}, {20000,0.00123853}};
data["big"]["OCaml"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big"]["OCaml"]["post"]["user"] = {{1,0.00000000}, {2,0.00002703}, {3,0.00003604}, {4,0.00005405}, {5,0.00000000}, {6,0.00007207}, {7,0.00009910}, {8,0.00000000}, {9,0.00009910}, {10,0.00003604}, {11,0.00000000}, {12,0.00003604}, {13,0.00002703}, {14,0.00015315}, {15,0.00006306}, {16,0.00003604}, {17,0.00000000}, {18,0.00000000}, {19,0.00016216}, {20,0.00010811}, {21,0.00000000}, {22,0.00006306}, {23,0.00002703}, {24,0.00006306}, {25,0.00000000}, {26,0.00000000}, {27,0.00003604}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00006306}, {32,0.00009910}, {33,0.00000000}, {34,0.00006306}, {35,0.00003604}, {36,0.00000000}, {37,0.00007207}, {38,0.00002703}, {39,0.00007207}, {40,0.00003604}, {41,0.00003604}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00003604}, {46,0.00002703}, {47,0.00007207}, {48,0.00003604}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00007207}, {53,0.00000000}, {54,0.00010811}, {55,0.00000000}, {56,0.00003604}, {57,0.00000000}, {58,0.00009910}, {59,0.00003604}, {60,0.00000000}, {61,0.00000000}, {62,0.00003604}, {63,0.00009910}, {64,0.00000000}, {65,0.00009910}, {66,0.00012613}, {67,0.00002703}, {68,0.00005405}, {69,0.00000000}, {70,0.00000000}, {71,0.00003604}, {72,0.00003604}, {73,0.00003604}, {74,0.00007207}, {75,0.00007207}, {76,0.00000000}, {77,0.00000000}, {78,0.00003604}, {79,0.00003604}, {80,0.00003604}, {81,0.00003604}, {82,0.00000000}, {83,0.00010811}, {84,0.00000000}, {85,0.00003604}, {86,0.00000000}, {87,0.00002703}, {88,0.00000000}, {89,0.00003604}, {90,0.00009910}, {91,0.00000000}, {92,0.00007207}, {93,0.00003604}, {94,0.00006306}, {95,0.00002703}, {96,0.00003604}, {97,0.00000000}, {98,0.00003604}, {99,0.00007207}, {100,0.00003604}, {101,0.00003604}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00003604}, {106,0.00000000}, {107,0.00000000}, {108,0.00002703}, {109,0.00003604}, {110,0.00014414}, {111,0.00000000}, {112,0.00003604}, {113,0.00003604}, {114,0.00003604}, {115,0.00003604}, {116,0.00000000}, {117,0.00003604}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00002703}, {122,0.00002703}, {123,0.00000000}, {124,0.00009910}, {125,0.00006306}, {126,0.00003604}, {127,0.00000000}, {128,0.00003604}, {129,0.00006306}, {130,0.00003604}, {131,0.00012613}, {132,0.00003604}, {133,0.00000000}, {134,0.00002703}, {135,0.00002703}, {136,0.00007207}, {137,0.00002703}, {138,0.00000000}, {139,0.00007207}, {140,0.00000000}, {141,0.00003604}, {142,0.00000000}, {143,0.00003604}, {144,0.00000000}, {145,0.00003604}, {146,0.00000000}, {147,0.00000000}, {148,0.00002703}, {149,0.00007207}, {150,0.00003604}, {151,0.00000000}, {152,0.00006306}, {153,0.00003604}, {154,0.00009910}, {155,0.00006306}, {156,0.00002703}, {157,0.00003604}, {158,0.00003604}, {159,0.00000000}, {160,0.00003604}, {161,0.00005405}, {162,0.00003604}, {163,0.00009910}, {164,0.00002703}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00003604}, {171,0.00006306}, {172,0.00000000}, {173,0.00000000}, {174,0.00006306}, {175,0.00000000}, {176,0.00000000}, {177,0.00002703}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00003604}, {183,0.00000000}, {184,0.00006306}, {185,0.00005405}, {186,0.00003604}, {187,0.00012613}, {188,0.00003604}, {189,0.00002703}, {190,0.00003604}, {191,0.00006306}, {192,0.00002703}, {193,0.00003604}, {194,0.00003604}, {195,0.00006306}, {196,0.00000000}, {197,0.00000000}, {198,0.00003604}, {199,0.00003604}, {200,0.00002703}, {201,0.00003604}, {202,0.00002703}, {203,0.00003604}, {204,0.00000000}, {205,0.00007207}, {206,0.00006306}, {207,0.00000000}, {208,0.00005405}, {209,0.00002703}, {210,0.00005405}, {211,0.00003604}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00007207}, {216,0.00003604}, {217,0.00003604}, {218,0.00000000}, {219,0.00006306}, {220,0.00005405}, {221,0.00000000}, {222,0.00002703}, {223,0.00000000}, {224,0.00000000}, {225,0.00003604}, {226,0.00002703}, {227,0.00000000}, {228,0.00000000}, {229,0.00005405}, {230,0.00002703}, {231,0.00003604}, {232,0.00000000}, {233,0.00003604}, {234,0.00003604}, {235,0.00002703}, {236,0.00002703}, {237,0.00006306}, {238,0.00002703}, {239,0.00003604}, {240,0.00009009}, {241,0.00006306}, {242,0.00003604}, {243,0.00002703}, {244,0.00003604}, {245,0.00000000}, {246,0.00006306}, {247,0.00007207}, {248,0.00009910}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00003604}, {254,0.00009910}, {255,0.00006306}, {256,0.00007207}, {257,0.00006306}, {258,0.00007207}, {259,0.00003604}, {260,0.00003604}, {261,0.00006306}, {262,0.00009009}, {263,0.00003604}, {264,0.00000000}, {265,0.00000000}, {266,0.00002703}, {267,0.00000000}, {268,0.00002703}, {269,0.00000000}, {270,0.00002703}, {271,0.00000000}, {272,0.00000000}, {273,0.00002703}, {274,0.00002703}, {275,0.00000000}, {276,0.00007207}, {277,0.00002703}, {278,0.00003604}, {279,0.00000000}, {280,0.00002703}, {281,0.00000000}, {282,0.00003604}, {283,0.00002703}, {284,0.00000000}, {285,0.00007207}, {286,0.00000000}, {287,0.00003604}, {288,0.00009910}, {289,0.00000000}, {290,0.00003604}, {291,0.00000000}, {292,0.00003604}, {293,0.00000000}, {294,0.00000000}, {295,0.00003604}, {296,0.00003604}, {297,0.00000000}, {298,0.00000000}, {299,0.00002703}, {300,0.00012613}, {301,0.00003604}, {302,0.00002703}, {303,0.00006306}, {304,0.00006306}, {305,0.00009910}, {306,0.00002703}, {307,0.00003604}, {308,0.00003604}, {309,0.00000000}, {310,0.00000000}, {311,0.00009910}, {312,0.00007207}, {313,0.00009910}, {314,0.00000000}, {315,0.00003604}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00002703}, {322,0.00000000}, {323,0.00000000}, {324,0.00007207}, {325,0.00007207}, {326,0.00009910}, {327,0.00006306}, {328,0.00009910}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00006306}, {334,0.00000000}, {335,0.00003604}, {336,0.00000000}, {337,0.00000000}, {338,0.00003604}, {339,0.00010811}, {340,0.00000000}, {341,0.00000000}, {342,0.00006306}, {343,0.00000000}, {344,0.00009910}, {345,0.00010811}, {346,0.00006306}, {347,0.00000000}, {348,0.00000000}, {349,0.00003604}, {350,0.00000000}, {351,0.00006306}, {352,0.00003604}, {353,0.00007207}, {354,0.00003604}, {355,0.00006306}, {356,0.00006306}, {357,0.00003604}, {358,0.00000000}, {359,0.00000000}, {360,0.00003604}, {361,0.00007207}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00007207}, {366,0.00010811}, {367,0.00002703}, {368,0.00000000}, {369,0.00002703}, {370,0.00000000}, {371,0.00003604}, {372,0.00003604}, {373,0.00000000}, {374,0.00006306}, {375,0.00007207}, {376,0.00003604}, {377,0.00003604}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00003604}, {382,0.00000000}, {383,0.00003604}, {384,0.00003604}, {385,0.00002703}, {386,0.00000000}, {387,0.00007207}, {388,0.00000000}, {389,0.00002703}, {390,0.00003604}, {391,0.00000000}, {392,0.00007207}, {393,0.00002703}, {394,0.00006306}, {395,0.00006306}, {396,0.00000000}, {397,0.00007207}, {398,0.00002703}, {399,0.00000000}, {400,0.00000000}, {401,0.00002703}, {402,0.00007207}, {403,0.00000000}, {404,0.00003604}, {405,0.00003604}, {406,0.00003604}, {407,0.00009009}, {408,0.00002703}, {409,0.00000000}, {410,0.00002703}, {411,0.00000000}, {412,0.00000000}, {413,0.00003604}, {414,0.00002703}, {415,0.00003604}, {416,0.00002703}, {417,0.00002703}, {418,0.00003604}, {419,0.00003604}, {420,0.00009910}, {421,0.00003604}, {422,0.00003604}, {423,0.00003604}, {424,0.00000000}, {425,0.00003604}, {426,0.00006306}, {427,0.00006306}, {428,0.00007207}, {429,0.00007207}, {430,0.00000000}, {431,0.00002703}, {432,0.00000000}, {433,0.00003604}, {434,0.00000000}, {435,0.00003604}, {436,0.00000000}, {437,0.00003604}, {438,0.00002703}, {439,0.00007207}, {440,0.00003604}, {441,0.00007207}, {442,0.00003604}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00003604}, {447,0.00002703}, {448,0.00003604}, {449,0.00002703}, {450,0.00003604}, {451,0.00000000}, {452,0.00007207}, {453,0.00003604}, {454,0.00000000}, {455,0.00000000}, {456,0.00003604}, {457,0.00000000}, {458,0.00013514}, {459,0.00002703}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00007207}, {464,0.00003604}, {465,0.00000000}, {466,0.00000000}, {467,0.00009009}, {468,0.00009910}, {469,0.00000000}, {470,0.00006306}, {471,0.00006306}, {472,0.00000000}, {473,0.00002703}, {474,0.00002703}, {475,0.00000000}, {476,0.00007207}, {477,0.00000000}, {478,0.00009910}, {479,0.00000000}, {480,0.00000000}, {481,0.00007207}, {482,0.00003604}, {483,0.00009009}, {484,0.00003604}, {485,0.00000000}, {486,0.00003604}, {487,0.00007207}, {488,0.00007207}, {489,0.00006306}, {490,0.00000000}, {491,0.00000000}, {492,0.00006306}, {493,0.00000000}, {494,0.00005405}, {495,0.00000000}, {496,0.00010811}, {497,0.00012613}, {498,0.00000000}, {499,0.00003604}, {500,0.00007207}, {505,0.00009009}, {510,0.00002703}, {515,0.00003604}, {520,0.00000000}, {525,0.00010811}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00006306}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00009910}, {590,0.00007207}, {595,0.00003604}, {600,0.00005405}, {605,0.00007207}, {610,0.00000000}, {615,0.00003604}, {620,0.00000000}, {625,0.00006306}, {630,0.00000000}, {635,0.00000000}, {640,0.00003604}, {645,0.00003604}, {650,0.00003604}, {655,0.00003604}, {660,0.00002703}, {665,0.00003604}, {670,0.00000000}, {675,0.00000000}, {680,0.00002703}, {685,0.00003604}, {690,0.00003604}, {695,0.00000000}, {700,0.00003604}, {705,0.00000000}, {710,0.00000000}, {715,0.00007207}, {720,0.00006306}, {725,0.00006306}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00007207}, {750,0.00003604}, {755,0.00007207}, {760,0.00000000}, {765,0.00000000}, {770,0.00009910}, {775,0.00003604}, {780,0.00006306}, {785,0.00003604}, {790,0.00000000}, {795,0.00012613}, {800,0.00002703}, {805,0.00007207}, {810,0.00009910}, {815,0.00006306}, {820,0.00002703}, {825,0.00003604}, {830,0.00006306}, {835,0.00000000}, {840,0.00002703}, {845,0.00003604}, {850,0.00000000}, {855,0.00007207}, {860,0.00006306}, {865,0.00003604}, {870,0.00000000}, {875,0.00007207}, {880,0.00000000}, {885,0.00006306}, {890,0.00007207}, {895,0.00002703}, {900,0.00003604}, {905,0.00003604}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00009009}, {930,0.00002703}, {935,0.00003604}, {940,0.00003604}, {945,0.00003604}, {950,0.00002703}, {955,0.00002703}, {960,0.00000000}, {965,0.00006306}, {970,0.00003604}, {975,0.00002703}, {980,0.00009009}, {985,0.00003604}, {990,0.00007207}, {995,0.00009910}, {1000,0.00007207}, {1010,0.00003604}, {1020,0.00007207}, {1030,0.00003604}, {1040,0.00000000}, {1050,0.00007207}, {1060,0.00005405}, {1070,0.00002703}, {1080,0.00003604}, {1090,0.00000000}, {1100,0.00003604}, {1110,0.00003604}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00007207}, {1150,0.00006306}, {1160,0.00003604}, {1170,0.00003604}, {1180,0.00000000}, {1190,0.00002703}, {1200,0.00002703}, {1210,0.00003604}, {1220,0.00012613}, {1230,0.00000000}, {1240,0.00003604}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00002703}, {1280,0.00000000}, {1290,0.00006306}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00003604}, {1330,0.00003604}, {1340,0.00000000}, {1350,0.00007207}, {1360,0.00000000}, {1370,0.00003604}, {1380,0.00002703}, {1390,0.00003604}, {1400,0.00009910}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00009910}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00007207}, {1470,0.00002703}, {1480,0.00000000}, {1490,0.00007207}, {1500,0.00006306}, {1510,0.00003604}, {1520,0.00003604}, {1530,0.00006306}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00003604}, {1590,0.00000000}, {1600,0.00003604}, {1610,0.00007207}, {1620,0.00000000}, {1630,0.00007207}, {1640,0.00007207}, {1650,0.00003604}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00007207}, {1690,0.00000000}, {1700,0.00002703}, {1710,0.00003604}, {1720,0.00006306}, {1730,0.00006306}, {1740,0.00003604}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00003604}, {1780,0.00003604}, {1790,0.00006306}, {1800,0.00000000}, {1810,0.00003604}, {1820,0.00000000}, {1830,0.00003604}, {1840,0.00002703}, {1850,0.00003604}, {1860,0.00006306}, {1870,0.00002703}, {1880,0.00003604}, {1890,0.00006306}, {1900,0.00003604}, {1910,0.00000000}, {1920,0.00008108}, {1930,0.00002703}, {1940,0.00007207}, {1950,0.00000000}, {1960,0.00002703}, {1970,0.00003604}, {1980,0.00003604}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00003604}, {2350,0.00003604}, {2400,0.00009009}, {2450,0.00003604}, {2500,0.00000000}, {2550,0.00005405}, {2600,0.00000000}, {2650,0.00007207}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00002703}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00009910}, {3000,0.00009910}, {3050,0.00000000}, {3100,0.00003604}, {3150,0.00000000}, {3200,0.00003604}, {3250,0.00000000}, {3300,0.00003604}, {3350,0.00002703}, {3400,0.00003604}, {3450,0.00007207}, {3500,0.00002703}, {3550,0.00000000}, {3600,0.00002703}, {3650,0.00009910}, {3700,0.00000000}, {3750,0.00008108}, {3800,0.00003604}, {3850,0.00003604}, {3900,0.00003604}, {3950,0.00003604}, {4000,0.00000000}, {4050,0.00003604}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00003604}, {4250,0.00003604}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00007207}, {4450,0.00017117}, {4500,0.00003604}, {4550,0.00005405}, {4600,0.00002703}, {4650,0.00000000}, {4700,0.00009009}, {4750,0.00002703}, {4800,0.00000000}, {4850,0.00013514}, {4900,0.00003604}, {4950,0.00006306}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00007207}, {5200,0.00003604}, {5250,0.00003604}, {5300,0.00010811}, {5350,0.00006306}, {5400,0.00000000}, {5450,0.00010811}, {5500,0.00003604}, {5550,0.00000000}, {5600,0.00003604}, {5650,0.00000000}, {5700,0.00009910}, {5750,0.00009009}, {5800,0.00000000}, {5850,0.00006306}, {5900,0.00002703}, {5950,0.00006306}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00007207}, {6150,0.00005405}, {6200,0.00007207}, {6250,0.00000000}, {6300,0.00002703}, {6350,0.00005405}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00009009}, {6550,0.00000000}, {6600,0.00018919}, {6650,0.00002703}, {6700,0.00002703}, {6750,0.00003604}, {6800,0.00007207}, {6850,0.00007207}, {6900,0.00000000}, {6950,0.00007207}, {7000,0.00007207}, {7050,0.00007207}, {7100,0.00000000}, {7150,0.00006306}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00002703}, {7350,0.00000000}, {7400,0.00003604}, {7450,0.00007207}, {7500,0.00003604}, {7550,0.00000000}, {7600,0.00003604}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00003604}, {7800,0.00009910}, {7850,0.00003604}, {7900,0.00006306}, {7950,0.00013514}, {8000,0.00000000}, {8050,0.00003604}, {8100,0.00002703}, {8150,0.00006306}, {8200,0.00008108}, {8250,0.00003604}, {8300,0.00003604}, {8350,0.00006306}, {8400,0.00003604}, {8450,0.00010811}, {8500,0.00003604}, {8550,0.00009009}, {8600,0.00003604}, {8650,0.00003604}, {8700,0.00003604}, {8750,0.00006306}, {8800,0.00007207}, {8850,0.00002703}, {8900,0.00003604}, {8950,0.00002703}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00006306}, {9200,0.00000000}, {9250,0.00006306}, {9300,0.00002703}, {9350,0.00000000}, {9400,0.00003604}, {9450,0.00002703}, {9500,0.00000000}, {9550,0.00003604}, {9600,0.00006306}, {9650,0.00006306}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00002703}, {9900,0.00009910}, {9950,0.00000000}, {10000,0.00002703}, {10100,0.00000000}, {10200,0.00014414}, {10300,0.00003604}, {10400,0.00002703}, {10500,0.00000000}, {10600,0.00003604}, {10700,0.00012613}, {10800,0.00005405}, {10900,0.00009009}, {11000,0.00006306}, {11100,0.00002703}, {11200,0.00000000}, {11300,0.00002703}, {11400,0.00003604}, {11500,0.00007207}, {11600,0.00007207}, {11700,0.00009009}, {11800,0.00009009}, {11900,0.00009910}, {12000,0.00002703}, {12100,0.00007207}, {12200,0.00003604}, {12300,0.00002703}, {12400,0.00000000}, {12500,0.00006306}, {12600,0.00006306}, {12700,0.00003604}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00003604}, {13100,0.00002703}, {13200,0.00006306}, {13300,0.00003604}, {13400,0.00009910}, {13500,0.00007207}, {13600,0.00005405}, {13700,0.00002703}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00005405}, {14100,0.00009009}, {14200,0.00002703}, {14300,0.00000000}, {14400,0.00002703}, {14500,0.00011712}, {14600,0.00002703}, {14700,0.00009910}, {14800,0.00000000}, {14900,0.00002703}, {15000,0.00005405}, {15100,0.00000000}, {15200,0.00006306}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00005405}, {15600,0.00002703}, {15700,0.00002703}, {15800,0.00008108}, {15900,0.00003604}, {16000,0.00008108}, {16100,0.00000000}, {16200,0.00002703}, {16300,0.00005405}, {16400,0.00005405}, {16500,0.00005405}, {16600,0.00002703}, {16700,0.00006306}, {16800,0.00006306}, {16900,0.00011712}, {17000,0.00007207}, {17100,0.00002703}, {17200,0.00000000}, {17300,0.00008108}, {17400,0.00002703}, {17500,0.00012613}, {17600,0.00005405}, {17700,0.00007207}, {17800,0.00005405}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00006306}, {18200,0.00002703}, {18300,0.00003604}, {18400,0.00003604}, {18500,0.00000000}, {18600,0.00012613}, {18700,0.00003604}, {18800,0.00008108}, {18900,0.00002703}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00002703}, {19400,0.00002703}, {19500,0.00009910}, {19600,0.00003604}, {19700,0.00003604}, {19800,0.00009910}, {19900,0.00008108}, {20000,0.00012844}};
data["big"]["OCaml"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00003604}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00003604}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00003604}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00003604}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00003604}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00003604}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00003604}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00003604}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00003604}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00003604}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00003604}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00003604}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00003604}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00003604}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00002703}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big"]["OCaml"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big"]["OCaml"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00003604}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00003604}, {10,0.00000000}, {11,0.00003604}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00002703}, {17,0.00003604}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00003604}, {23,0.00000000}, {24,0.00000000}, {25,0.00002703}, {26,0.00000000}, {27,0.00003604}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00003604}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00003604}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00003604}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00003604}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00003604}, {94,0.00000000}, {95,0.00003604}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00003604}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00002703}, {115,0.00000000}, {116,0.00000000}, {117,0.00003604}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00003604}, {129,0.00003604}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00003604}, {140,0.00000000}, {141,0.00003604}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00003604}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00002703}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00002703}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00002703}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00003604}, {173,0.00003604}, {174,0.00000000}, {175,0.00003604}, {176,0.00000000}, {177,0.00003604}, {178,0.00003604}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00002703}, {191,0.00000000}, {192,0.00000000}, {193,0.00002703}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00002703}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00002703}, {210,0.00003604}, {211,0.00000000}, {212,0.00002703}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00003604}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00003604}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00002703}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00007207}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00003604}, {260,0.00002703}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00002703}, {270,0.00002703}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00003604}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00002703}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00003604}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00003604}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00006306}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00003604}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00003604}, {365,0.00002703}, {366,0.00007207}, {367,0.00000000}, {368,0.00003604}, {369,0.00000000}, {370,0.00000000}, {371,0.00002703}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00003604}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00002703}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00002703}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00003604}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00002703}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00002703}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00003604}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00003604}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00006306}, {463,0.00000000}, {464,0.00002703}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00002703}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00003604}, {478,0.00000000}, {479,0.00002703}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00003604}, {486,0.00000000}, {487,0.00000000}, {488,0.00002703}, {489,0.00003604}, {490,0.00000000}, {491,0.00000000}, {492,0.00003604}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00003604}, {505,0.00003604}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00003604}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00003604}, {625,0.00003604}, {630,0.00003604}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00002703}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00005405}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00003604}, {835,0.00000000}, {840,0.00002703}, {845,0.00000000}, {850,0.00000000}, {855,0.00002703}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00003604}, {920,0.00000000}, {925,0.00000000}, {930,0.00003604}, {935,0.00000000}, {940,0.00003604}, {945,0.00000000}, {950,0.00000000}, {955,0.00003604}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00003604}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00003604}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00002703}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00003604}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00002703}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00003604}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00003604}, {1400,0.00003604}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00003604}, {1460,0.00003604}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00003604}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00003604}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00003604}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00003604}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00003604}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00003604}, {1760,0.00003604}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00002703}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00003604}, {1890,0.00003604}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00002703}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00005405}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00003604}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00003604}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00002703}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00003604}, {3350,0.00003604}, {3400,0.00000000}, {3450,0.00002703}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00003604}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00002703}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00003604}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00003604}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00002703}, {6500,0.00002703}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00003604}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00003604}, {7150,0.00000000}, {7200,0.00003604}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00003604}, {7400,0.00000000}, {7450,0.00002703}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00003604}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00003604}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00003604}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00002703}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00002703}, {9600,0.00000000}, {9650,0.00002703}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00002703}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00006306}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00002703}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00002703}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00003604}, {11500,0.00000000}, {11600,0.00003604}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00002703}, {12300,0.00000000}, {12400,0.00002703}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00002703}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00003604}, {13700,0.00003604}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00003604}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00002703}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00002703}, {15700,0.00002703}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00007207}, {16200,0.00005405}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00002703}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00002703}, {17700,0.00000000}, {17800,0.00002703}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00006306}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00002703}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00002703}, {19500,0.00000000}, {19600,0.00002703}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00002703}, {20000,0.00000000}};
data["big"]["OCaml"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00003604}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00003604}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00003604}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00003604}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big"]["OCaml"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.01371171}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00002703}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00003604}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000901}, {152,0.00000901}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00150450}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000901}, {173,0.00000000}, {174,0.00000901}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000901}, {180,0.00000000}, {181,0.00000901}, {182,0.00000901}, {183,0.00001802}, {184,0.00196396}, {185,0.00000901}, {186,0.00002703}, {187,0.00002703}, {188,0.00004505}, {189,0.00000901}, {190,0.00001802}, {191,0.00002703}, {192,0.00002703}, {193,0.00003604}, {194,0.00005405}, {195,0.00008108}, {196,0.00004505}, {197,0.00005405}, {198,0.00009910}, {199,0.00010811}, {200,0.00018018}, {201,0.00017117}, {202,0.00018919}, {203,0.00021622}, {204,0.00024324}, {205,0.00026126}, {206,0.00145946}, {207,0.00027928}, {208,0.00026126}, {209,0.00039640}, {210,0.00039640}, {211,0.00048649}, {212,0.00052252}, {213,0.00054054}, {214,0.00060360}, {215,0.00060360}, {216,0.00073874}, {217,0.00075676}, {218,0.00071171}, {219,0.00080180}, {220,0.00086486}, {221,0.00086486}, {222,0.00088288}, {223,0.00092793}, {224,0.00093694}, {225,0.00098198}, {226,0.00198198}, {227,0.00098198}, {228,0.00098198}, {229,0.00098198}, {230,0.00100000}, {231,0.00100000}, {232,0.00100000}, {233,0.00100000}, {234,0.00100000}, {235,0.00100000}, {236,0.00100000}, {237,0.00100000}, {238,0.00100000}, {239,0.00100000}, {240,0.00100000}, {241,0.00100000}, {242,0.00100000}, {243,0.00100000}, {244,0.00100000}, {245,0.00100000}, {246,0.00100000}, {247,0.00100000}, {248,0.00100000}, {249,0.00100000}, {250,0.00100000}, {251,0.00100000}, {252,0.00100000}, {253,0.00101802}, {254,0.00100000}, {255,0.00100000}, {256,0.00100000}, {257,0.00100000}, {258,0.00100000}, {259,0.00100000}, {260,0.00100000}, {261,0.00100000}, {262,0.00100000}, {263,0.00100000}, {264,0.00100000}, {265,0.00100000}, {266,0.00100000}, {267,0.00100000}, {268,0.00100000}, {269,0.00100000}, {270,0.00101802}, {271,0.00100000}, {272,0.00100000}, {273,0.00100000}, {274,0.00100000}, {275,0.00100000}, {276,0.00100901}, {277,0.00100000}, {278,0.00100000}, {279,0.00100000}, {280,0.00100000}, {281,0.00100000}, {282,0.00100000}, {283,0.00100000}, {284,0.00100000}, {285,0.00100000}, {286,0.00100000}, {287,0.00100000}, {288,0.00100000}, {289,0.00100000}, {290,0.00100000}, {291,0.00100000}, {292,0.00100000}, {293,0.00100000}, {294,0.00100000}, {295,0.00100000}, {296,0.00100000}, {297,0.00100000}, {298,0.00100000}, {299,0.00100000}, {300,0.00100000}, {301,0.00100000}, {302,0.00100000}, {303,0.00100000}, {304,0.00100000}, {305,0.00100000}, {306,0.00100000}, {307,0.00100000}, {308,0.00100000}, {309,0.00100000}, {310,0.00100000}, {311,0.00100000}, {312,0.00100000}, {313,0.00100000}, {314,0.00100000}, {315,0.00100000}, {316,0.00100000}, {317,0.00100000}, {318,0.00100000}, {319,0.00100000}, {320,0.00100000}, {321,0.00100000}, {322,0.00100000}, {323,0.00100000}, {324,0.00100000}, {325,0.00100000}, {326,0.00100000}, {327,0.00100000}, {328,0.00100000}, {329,0.00100000}, {330,0.00100000}, {331,0.00100000}, {332,0.00100000}, {333,0.00100000}, {334,0.00100000}, {335,0.00100000}, {336,0.00100000}, {337,0.00100000}, {338,0.00100000}, {339,0.00100000}, {340,0.00100000}, {341,0.00100000}, {342,0.00100000}, {343,0.00100000}, {344,0.00100000}, {345,0.00100000}, {346,0.00100000}, {347,0.00100000}, {348,0.00100000}, {349,0.00100000}, {350,0.00100000}, {351,0.00100000}, {352,0.00100000}, {353,0.00100000}, {354,0.00100000}, {355,0.00100000}, {356,0.00100000}, {357,0.00100000}, {358,0.00100000}, {359,0.00100000}, {360,0.00100000}, {361,0.00100000}, {362,0.00100000}, {363,0.00100000}, {364,0.00100000}, {365,0.00100000}, {366,0.00100000}, {367,0.00100000}, {368,0.00100000}, {369,0.00100000}, {370,0.00100000}, {371,0.00100000}, {372,0.00100000}, {373,0.00100000}, {374,0.00100000}, {375,0.00100000}, {376,0.00100000}, {377,0.00100000}, {378,0.00100000}, {379,0.00100000}, {380,0.00100000}, {381,0.00100000}, {382,0.00101802}, {383,0.00100000}, {384,0.00100000}, {385,0.00100000}, {386,0.00100000}, {387,0.00100000}, {388,0.00100000}, {389,0.00100000}, {390,0.00100000}, {391,0.00100000}, {392,0.00100000}, {393,0.00100000}, {394,0.00100000}, {395,0.00101802}, {396,0.00100000}, {397,0.00100000}, {398,0.00100000}, {399,0.00100000}, {400,0.00100000}, {401,0.00100000}, {402,0.00100000}, {403,0.00100000}, {404,0.00100000}, {405,0.00100000}, {406,0.00100000}, {407,0.00100901}, {408,0.00100901}, {409,0.00100000}, {410,0.00100000}, {411,0.00101802}, {412,0.00100000}, {413,0.00100000}, {414,0.00100000}, {415,0.00100000}, {416,0.00100000}, {417,0.00100000}, {418,0.00100901}, {419,0.00100000}, {420,0.00100000}, {421,0.00100000}, {422,0.00100000}, {423,0.00100000}, {424,0.00100901}, {425,0.00100901}, {426,0.00100000}, {427,0.00100000}, {428,0.00100000}, {429,0.00100000}, {430,0.00102703}, {431,0.00101802}, {432,0.00100000}, {433,0.00100901}, {434,0.00100901}, {435,0.00100901}, {436,0.00100000}, {437,0.00100000}, {438,0.00100000}, {439,0.00100901}, {440,0.00100901}, {441,0.00101802}, {442,0.00100901}, {443,0.00100901}, {444,0.00100901}, {445,0.00100000}, {446,0.00430631}, {447,0.00100901}, {448,0.00100901}, {449,0.00100000}, {450,0.00100901}, {451,0.00105405}, {452,0.00102703}, {453,0.00102703}, {454,0.00102703}, {455,0.00103604}, {456,0.00102703}, {457,0.00100000}, {458,0.00102703}, {459,0.00104505}, {460,0.00101802}, {461,0.00102703}, {462,0.00103604}, {463,0.00101802}, {464,0.00101802}, {465,0.00105405}, {466,0.00103604}, {467,0.00279279}, {468,0.00104505}, {469,0.00103604}, {470,0.00103604}, {471,0.00109910}, {472,0.00107207}, {473,0.00108108}, {474,0.00109910}, {475,0.00113514}, {476,0.00109910}, {477,0.00408108}, {478,0.00116216}, {479,0.00115315}, {480,0.00116216}, {481,0.00111712}, {482,0.00114414}, {483,0.00110811}, {484,0.00119820}, {485,0.00113514}, {486,0.00114414}, {487,0.00459459}, {488,0.00121622}, {489,0.00115315}, {490,0.00122523}, {491,0.00125225}, {492,0.00126126}, {493,0.00120721}, {494,0.00130631}, {495,0.00126126}, {496,0.00128829}, {497,0.00129730}, {498,0.00127027}, {499,0.00134234}, {500,0.00139640}, {505,0.00143243}, {510,0.00152252}, {515,0.00165766}, {520,0.00174775}, {525,0.00176577}, {530,0.00178378}, {535,0.00184685}, {540,0.00190090}, {545,0.00195495}, {550,0.00196396}, {555,0.00199099}, {560,0.00200000}, {565,0.00199099}, {570,0.00200000}, {575,0.00445946}, {580,0.00200000}, {585,0.00200000}, {590,0.00200000}, {595,0.00200000}, {600,0.00200000}, {605,0.00200000}, {610,0.00200000}, {615,0.00200901}, {620,0.00200000}, {625,0.00201802}, {630,0.00200000}, {635,0.00201802}, {640,0.00200901}, {645,0.00200000}, {650,0.00200901}, {655,0.00200000}, {660,0.00201802}, {665,0.00200901}, {670,0.00201802}, {675,0.00201802}, {680,0.00203604}, {685,0.00208108}, {690,0.00207207}, {695,0.00206306}, {700,0.00209009}, {705,0.00210811}, {710,0.00207207}, {715,0.00214414}, {720,0.00214414}, {725,0.00221622}, {730,0.00218018}, {735,0.00228829}, {740,0.00229730}, {745,0.00247748}, {750,0.00241441}, {755,0.00240541}, {760,0.00224324}, {765,0.00257658}, {770,0.00256757}, {775,0.00261261}, {780,0.00266667}, {785,0.00273874}, {790,0.00279279}, {795,0.00290090}, {800,0.00289189}, {805,0.00291892}, {810,0.00290991}, {815,0.00291892}, {820,0.00292793}, {825,0.00296396}, {830,0.00300000}, {835,0.00300000}, {840,0.00300901}, {845,0.00299099}, {850,0.00300901}, {855,0.00300901}, {860,0.00300000}, {865,0.00313514}, {870,0.00302703}, {875,0.00301802}, {880,0.00809910}, {885,0.00304505}, {890,0.00307207}, {895,0.00306306}, {900,0.00309009}, {905,0.00310811}, {910,0.00309009}, {915,0.00312613}, {920,0.00309009}, {925,0.00317117}, {930,0.00316216}, {935,0.00894595}, {940,0.00322523}, {945,0.00327027}, {950,0.00324324}, {955,0.00331532}, {960,0.00328829}, {965,0.00327928}, {970,0.00337838}, {975,0.00333333}, {980,0.00348649}, {985,0.00346847}, {990,0.00346847}, {995,0.00349550}, {1000,0.00354955}, {1010,0.00359459}, {1020,0.00370270}, {1030,0.00372072}, {1040,0.00376577}, {1050,0.00385586}, {1060,0.00390090}, {1070,0.00395495}, {1080,0.00400000}, {1090,0.00400901}, {1100,0.00406306}, {1110,0.00404505}, {1120,0.00301802}, {1130,0.00410811}, {1140,0.00423423}, {1150,0.00425225}, {1160,0.00426126}, {1170,0.00430631}, {1180,0.00440541}, {1190,0.00440541}, {1200,0.00445045}, {1210,0.00458559}, {1220,0.00456757}, {1230,0.00456757}, {1240,0.00463063}, {1250,0.00480180}, {1260,0.00472072}, {1270,0.00481081}, {1280,0.00484685}, {1290,0.00490090}, {1300,0.00495495}, {1310,0.00498198}, {1320,0.00500000}, {1330,0.00508108}, {1340,0.00509009}, {1350,0.00516216}, {1360,0.00531532}, {1370,0.00533333}, {1380,0.00540541}, {1390,0.00533333}, {1400,0.01063063}, {1410,0.00542342}, {1420,0.00548649}, {1430,0.00558559}, {1440,0.00564865}, {1450,0.00563063}, {1460,0.00572072}, {1470,0.00581081}, {1480,0.00584685}, {1490,0.00591892}, {1500,0.00591892}, {1510,0.00599099}, {1520,0.00600000}, {1530,0.00603604}, {1540,0.00503604}, {1550,0.00612613}, {1560,0.00618919}, {1570,0.00632432}, {1580,0.00630631}, {1590,0.00631532}, {1600,0.00637838}, {1610,0.00640541}, {1620,0.00649550}, {1630,0.00650450}, {1640,0.00656757}, {1650,0.00670270}, {1660,0.00671171}, {1670,0.00669369}, {1680,0.00686486}, {1690,0.00681982}, {1700,0.00683784}, {1710,0.00717117}, {1720,0.00694595}, {1730,0.00703604}, {1740,0.00717117}, {1750,0.00710811}, {1760,0.00716216}, {1770,0.00723423}, {1780,0.00724324}, {1790,0.00736937}, {1800,0.00738739}, {1810,0.00750450}, {1820,0.00748649}, {1830,0.00742342}, {1840,0.00760360}, {1850,0.00767568}, {1860,0.00766667}, {1870,0.00636036}, {1880,0.00781081}, {1890,0.00783784}, {1900,0.00791892}, {1910,0.00781081}, {1920,0.00799099}, {1930,0.00801802}, {1940,0.00804505}, {1950,0.01190991}, {1960,0.00824324}, {1970,0.00827027}, {1980,0.00828829}, {1990,0.00830631}, {2000,0.00839640}, {2050,0.00871171}, {2100,0.00890991}, {2150,0.00918018}, {2200,0.00945946}, {2250,0.01466667}, {2300,0.01011712}, {2350,0.01029730}, {2400,0.01061261}, {2450,0.01078378}, {2500,0.01113514}, {2550,0.01132432}, {2600,0.01164865}, {2650,0.01180180}, {2700,0.01222523}, {2750,0.01236937}, {2800,0.01269369}, {2850,0.02994595}, {2900,0.01340541}, {2950,0.01102703}, {3000,0.01373874}, {3050,0.01405405}, {3100,0.01435135}, {3150,0.01500000}, {3200,0.01934234}, {3250,0.01508108}, {3300,0.01535135}, {3350,0.03567568}, {3400,0.01596396}, {3450,0.01620721}, {3500,0.01649550}, {3550,0.01672973}, {3600,0.01705405}, {3650,0.03496396}, {3700,0.01763964}, {3750,0.01804505}, {3800,0.01704505}, {3850,0.01833333}, {3900,0.01845045}, {3950,0.01936036}, {4000,0.01805405}, {4050,0.04792793}, {4100,0.01959459}, {4150,0.02005405}, {4200,0.02012613}, {4250,0.01784685}, {4300,0.04078378}, {4350,0.02085586}, {4400,0.02105405}, {4450,0.02166667}, {4500,0.02157658}, {4550,0.02182883}, {4600,0.01756757}, {4650,0.04439640}, {4700,0.02250450}, {4750,0.02277477}, {4800,0.02305405}, {4850,0.02328829}, {4900,0.02349550}, {4950,0.02390991}, {5000,0.02434234}, {5050,0.02475676}, {5100,0.02484685}, {5150,0.02500000}, {5200,0.02554955}, {5250,0.02568468}, {5300,0.02591892}, {5350,0.02624324}, {5400,0.02637838}, {5450,0.02654054}, {5500,0.02645045}, {5550,0.02662162}, {5600,0.02688288}, {5650,0.02724324}, {5700,0.02740541}, {5750,0.05927027}, {5800,0.03333333}, {5850,0.02572973}, {5900,0.02848649}, {5950,0.02919820}, {6000,0.02883784}, {6050,0.02920721}, {6100,0.05983784}, {6150,0.02336036}, {6200,0.02985586}, {6250,0.03061261}, {6300,0.03036937}, {6350,0.05910811}, {6400,0.02732432}, {6450,0.03201802}, {6500,0.03134234}, {6550,0.03158559}, {6600,0.02785586}, {6650,0.03251351}, {6700,0.03223423}, {6750,0.06917117}, {6800,0.03191892}, {6850,0.03276577}, {6900,0.09810811}, {6950,0.03009009}, {7000,0.03382883}, {7050,0.06879279}, {7100,0.03213514}, {7150,0.03426126}, {7200,0.05742342}, {7250,0.03547748}, {7300,0.03533333}, {7350,0.03031532}, {7400,0.03552252}, {7450,0.05120721}, {7500,0.03662162}, {7550,0.06720721}, {7600,0.03738739}, {7650,0.03685586}, {7700,0.03510811}, {7750,0.03727027}, {7800,0.03430631}, {7850,0.03775676}, {7900,0.03514414}, {7950,0.03818919}, {8000,0.03813514}, {8050,0.08474775}, {8100,0.03984685}, {8150,0.07410811}, {8200,0.03988288}, {8250,0.04981982}, {8300,0.03976577}, {8350,0.03718018}, {8400,0.07652252}, {8450,0.04100000}, {8500,0.02756757}, {8550,0.04114414}, {8600,0.04223423}, {8650,0.06115315}, {8700,0.04172072}, {8750,0.04309910}, {8800,0.06315315}, {8850,0.04236036}, {8900,0.04334234}, {8950,0.03479279}, {9000,0.07592793}, {9050,0.04337838}, {9100,0.04288288}, {9150,0.05431532}, {9200,0.08814414}, {9250,0.04439640}, {9300,0.04561261}, {9350,0.03698198}, {9400,0.08048649}, {9450,0.04549550}, {9500,0.04543243}, {9550,0.04671171}, {9600,0.04166667}, {9650,0.05991892}, {9700,0.08771171}, {9750,0.09930631}, {9800,0.04712613}, {9850,0.04772973}, {9900,0.04829730}, {9950,0.04599099}, {10000,0.04332432}, {10100,0.03963964}, {10200,0.05511712}, {10300,0.06302703}, {10400,0.07326126}, {10500,0.07391892}, {10600,0.06834234}, {10700,0.05754054}, {10800,0.04177477}, {10900,0.04620721}, {11000,0.04988288}, {11100,0.05416216}, {11200,0.05402703}, {11300,0.13949550}, {11400,0.10688288}, {11500,0.07173874}, {11600,0.05081081}, {11700,0.05705405}, {11800,0.11280180}, {11900,0.08973874}, {12000,0.05353153}, {12100,0.05803604}, {12200,0.09543243}, {12300,0.05345946}, {12400,0.05947748}, {12500,0.08893694}, {12600,0.06000901}, {12700,0.11879279}, {12800,0.05641441}, {12900,0.11401802}, {13000,0.05518919}, {13100,0.12684685}, {13200,0.05501802}, {13300,0.10927027}, {13400,0.05800901}, {13500,0.11647748}, {13600,0.06436036}, {13700,0.07988288}, {13800,0.12323423}, {13900,0.06139640}, {14000,0.10905405}, {14100,0.12354054}, {14200,0.06405405}, {14300,0.04771171}, {14400,0.11877477}, {14500,0.14446847}, {14600,0.06584685}, {14700,0.05882883}, {14800,0.10509910}, {14900,0.11597297}, {15000,0.11610811}, {15100,0.15130631}, {15200,0.07084685}, {15300,0.06811712}, {15400,0.06630631}, {15500,0.06505405}, {15600,0.06452252}, {15700,0.06420721}, {15800,0.06506306}, {15900,0.06665766}, {16000,0.06851351}, {16100,0.07085586}, {16200,0.07442342}, {16300,0.16382883}, {16400,0.12689189}, {16500,0.12953153}, {16600,0.11969369}, {16700,0.06928829}, {16800,0.07328829}, {16900,0.14318919}, {17000,0.12515315}, {17100,0.05671171}, {17200,0.07470270}, {17300,0.12937838}, {17400,0.11127027}, {17500,0.07377477}, {17600,0.13436036}, {17700,0.10026126}, {17800,0.07881081}, {17900,0.13076577}, {18000,0.07401802}, {18100,0.16446847}, {18200,0.07343243}, {18300,0.13732432}, {18400,0.07261261}, {18500,0.18779279}, {18600,0.07550450}, {18700,0.15291892}, {18800,0.08291892}, {18900,0.12956757}, {19000,0.15701802}, {19100,0.08100000}, {19200,0.12662162}, {19300,0.14718919}, {19400,0.07955856}, {19500,0.12435135}, {19600,0.17215315}, {19700,0.17999099}, {19800,0.08052252}, {19900,0.10961261}, {20000,0.14027523}};
data["big"]["OCaml"]["reif"]["user"] = {{1,0.00017117}, {2,0.00024324}, {3,0.00023423}, {4,0.00016216}, {5,0.00039640}, {6,0.00044144}, {7,0.00027928}, {8,0.00039640}, {9,0.00038739}, {10,0.00039640}, {11,0.00027928}, {12,0.00040541}, {13,0.00031532}, {14,0.00036937}, {15,0.00041441}, {16,0.00025225}, {17,0.00027928}, {18,0.00043243}, {19,0.00026126}, {20,0.00030631}, {21,0.00041441}, {22,0.00033333}, {23,0.00033333}, {24,0.00043243}, {25,0.00032432}, {26,0.00036937}, {27,0.00030631}, {28,0.00052252}, {29,0.00052252}, {30,0.00033333}, {31,0.00038739}, {32,0.00023423}, {33,0.00036937}, {34,0.00036937}, {35,0.00049550}, {36,0.00036937}, {37,0.00036036}, {38,0.00037838}, {39,0.00039640}, {40,0.00043243}, {41,0.00047748}, {42,0.00054955}, {43,0.00043243}, {44,0.00048649}, {45,0.00044144}, {46,0.00051351}, {47,0.00054054}, {48,0.00060360}, {49,0.00067568}, {50,0.00047748}, {51,0.00058559}, {52,0.00040541}, {53,0.00047748}, {54,0.00031532}, {55,0.00033333}, {56,0.00049550}, {57,0.00026126}, {58,0.01388288}, {59,0.00039640}, {60,0.00053153}, {61,0.00046847}, {62,0.00050450}, {63,0.00050450}, {64,0.00040541}, {65,0.00053153}, {66,0.00042342}, {67,0.00044144}, {68,0.00044144}, {69,0.00072072}, {70,0.00055856}, {71,0.00036937}, {72,0.00059459}, {73,0.00042342}, {74,0.00060360}, {75,0.00054054}, {76,0.00029730}, {77,0.00051351}, {78,0.00055856}, {79,0.00036937}, {80,0.00053153}, {81,0.00069369}, {82,0.00057658}, {83,0.00059459}, {84,0.00066667}, {85,0.00084685}, {86,0.00034234}, {87,0.00080180}, {88,0.00070270}, {89,0.00027027}, {90,0.00070270}, {91,0.00059459}, {92,0.00053153}, {93,0.00058559}, {94,0.00068468}, {95,0.00057658}, {96,0.00063063}, {97,0.00099099}, {98,0.00014414}, {99,0.00069369}, {100,0.00057658}, {101,0.00054054}, {102,0.00085586}, {103,0.00031532}, {104,0.00052252}, {105,0.00056757}, {106,0.00081081}, {107,0.00059459}, {108,0.00047748}, {109,0.00063964}, {110,0.00081081}, {111,0.00062162}, {112,0.00039640}, {113,0.00052252}, {114,0.00083784}, {115,0.00089189}, {116,0.00033333}, {117,0.00048649}, {118,0.00065766}, {119,0.00097297}, {120,0.00055856}, {121,0.00043243}, {122,0.00054054}, {123,0.00081081}, {124,0.00090991}, {125,0.00053153}, {126,0.00048649}, {127,0.00051351}, {128,0.00064865}, {129,0.00066667}, {130,0.00082883}, {131,0.00063964}, {132,0.00060360}, {133,0.00061261}, {134,0.00080180}, {135,0.00068468}, {136,0.00075676}, {137,0.00045946}, {138,0.00046847}, {139,0.00069369}, {140,0.00090991}, {141,0.00044144}, {142,0.00080180}, {143,0.00089189}, {144,0.00081081}, {145,0.00058559}, {146,0.00057658}, {147,0.00061261}, {148,0.00056757}, {149,0.00060360}, {150,0.00088288}, {151,0.00081982}, {152,0.00085586}, {153,0.00088288}, {154,0.00087387}, {155,0.00085586}, {156,0.00086486}, {157,0.00063964}, {158,0.00069369}, {159,0.00067568}, {160,0.00169369}, {161,0.00078378}, {162,0.00072973}, {163,0.00062162}, {164,0.00063964}, {165,0.00068468}, {166,0.00055856}, {167,0.00063964}, {168,0.00063964}, {169,0.00062162}, {170,0.00063964}, {171,0.00066667}, {172,0.00076577}, {173,0.00069369}, {174,0.00080180}, {175,0.00069369}, {176,0.00070270}, {177,0.00071171}, {178,0.00097297}, {179,0.00109910}, {180,0.00112613}, {181,0.00120721}, {182,0.00111712}, {183,0.00091892}, {184,0.00220721}, {185,0.00055856}, {186,0.00079279}, {187,0.00101802}, {188,0.00094595}, {189,0.00072973}, {190,0.00077477}, {191,0.00074775}, {192,0.00090991}, {193,0.00095495}, {194,0.00096396}, {195,0.00097297}, {196,0.00100000}, {197,0.00092793}, {198,0.00089189}, {199,0.00080180}, {200,0.00064865}, {201,0.00071171}, {202,0.00078378}, {203,0.00111712}, {204,0.00100901}, {205,0.00101802}, {206,0.00182883}, {207,0.00070270}, {208,0.00067568}, {209,0.00093694}, {210,0.00087387}, {211,0.00094595}, {212,0.00076577}, {213,0.00098198}, {214,0.00072973}, {215,0.00100901}, {216,0.00090090}, {217,0.00072072}, {218,0.00085586}, {219,0.00085586}, {220,0.00102703}, {221,0.00083784}, {222,0.00117117}, {223,0.00089189}, {224,0.00081982}, {225,0.00094595}, {226,0.00208108}, {227,0.00076577}, {228,0.00100000}, {229,0.00076577}, {230,0.00103604}, {231,0.00103604}, {232,0.00078378}, {233,0.00099099}, {234,0.00124324}, {235,0.00109009}, {236,0.00071171}, {237,0.00106306}, {238,0.00119820}, {239,0.00099099}, {240,0.00075676}, {241,0.00086486}, {242,0.00080180}, {243,0.00108108}, {244,0.00102703}, {245,0.00077477}, {246,0.00107207}, {247,0.00102703}, {248,0.00080180}, {249,0.00124324}, {250,0.00075676}, {251,0.00092793}, {252,0.00127027}, {253,0.00102703}, {254,0.00113514}, {255,0.00096396}, {256,0.00081081}, {257,0.00136036}, {258,0.00083784}, {259,0.00094595}, {260,0.00133333}, {261,0.00093694}, {262,0.00117117}, {263,0.00098198}, {264,0.00112613}, {265,0.00114414}, {266,0.00105405}, {267,0.00086486}, {268,0.00093694}, {269,0.00103604}, {270,0.00120721}, {271,0.00076577}, {272,0.00091892}, {273,0.00107207}, {274,0.00111712}, {275,0.00097297}, {276,0.00109009}, {277,0.00110811}, {278,0.00113514}, {279,0.00108108}, {280,0.00108108}, {281,0.00126126}, {282,0.00127027}, {283,0.00133333}, {284,0.00115315}, {285,0.00124324}, {286,0.00127027}, {287,0.00128829}, {288,0.00129730}, {289,0.00124324}, {290,0.00133333}, {291,0.00115315}, {292,0.00125225}, {293,0.00112613}, {294,0.00131532}, {295,0.00082883}, {296,0.00156757}, {297,0.00083784}, {298,0.00144144}, {299,0.00089189}, {300,0.00134234}, {301,0.00132432}, {302,0.00104505}, {303,0.00118018}, {304,0.00069369}, {305,0.00135135}, {306,0.00095495}, {307,0.00117117}, {308,0.00118919}, {309,0.00100901}, {310,0.00114414}, {311,0.00150450}, {312,0.00082883}, {313,0.00137838}, {314,0.00089189}, {315,0.00124324}, {316,0.00134234}, {317,0.00108108}, {318,0.00130631}, {319,0.00125225}, {320,0.00113514}, {321,0.00129730}, {322,0.00113514}, {323,0.00100000}, {324,0.00135135}, {325,0.00141441}, {326,0.00110811}, {327,0.00126126}, {328,0.00149550}, {329,0.00091892}, {330,0.00145946}, {331,0.00120721}, {332,0.00123423}, {333,0.00130631}, {334,0.00135135}, {335,0.00119820}, {336,0.00100000}, {337,0.00146847}, {338,0.00174775}, {339,0.00159459}, {340,0.00079279}, {341,0.00120721}, {342,0.00150450}, {343,0.00129730}, {344,0.00131532}, {345,0.00098198}, {346,0.00129730}, {347,0.00185586}, {348,0.00087387}, {349,0.00087387}, {350,0.00162162}, {351,0.00150450}, {352,0.00125225}, {353,0.00143243}, {354,0.00112613}, {355,0.00124324}, {356,0.00139640}, {357,0.00145946}, {358,0.00128829}, {359,0.00153153}, {360,0.00154054}, {361,0.00113514}, {362,0.00134234}, {363,0.00145045}, {364,0.00148649}, {365,0.00136036}, {366,0.00120721}, {367,0.00160360}, {368,0.00162162}, {369,0.00110811}, {370,0.00131532}, {371,0.00138739}, {372,0.00142342}, {373,0.00133333}, {374,0.00147748}, {375,0.00148649}, {376,0.00152252}, {377,0.00140541}, {378,0.00120721}, {379,0.00134234}, {380,0.00156757}, {381,0.00147748}, {382,0.00144144}, {383,0.00139640}, {384,0.00137838}, {385,0.00161261}, {386,0.00154054}, {387,0.00153153}, {388,0.00133333}, {389,0.00129730}, {390,0.00128829}, {391,0.00148649}, {392,0.00142342}, {393,0.00157658}, {394,0.00154955}, {395,0.00149550}, {396,0.00145045}, {397,0.00149550}, {398,0.00137838}, {399,0.00139640}, {400,0.00128829}, {401,0.00139640}, {402,0.00125225}, {403,0.00113514}, {404,0.00127027}, {405,0.00131532}, {406,0.00144144}, {407,0.00159459}, {408,0.00159459}, {409,0.00143243}, {410,0.00159459}, {411,0.00126126}, {412,0.00127928}, {413,0.00167568}, {414,0.00176577}, {415,0.00178378}, {416,0.00171171}, {417,0.00163063}, {418,0.00157658}, {419,0.00152252}, {420,0.00124324}, {421,0.00133333}, {422,0.00122523}, {423,0.00116216}, {424,0.00137838}, {425,0.00188288}, {426,0.00138739}, {427,0.00154955}, {428,0.00140541}, {429,0.00124324}, {430,0.00116216}, {431,0.00158559}, {432,0.00137838}, {433,0.00130631}, {434,0.00142342}, {435,0.00154054}, {436,0.00172072}, {437,0.00170270}, {438,0.00141441}, {439,0.00147748}, {440,0.00158559}, {441,0.00150450}, {442,0.00138739}, {443,0.00152252}, {444,0.00152252}, {445,0.00148649}, {446,0.00413514}, {447,0.00123423}, {448,0.00137838}, {449,0.00149550}, {450,0.00154955}, {451,0.00137838}, {452,0.00103604}, {453,0.00149550}, {454,0.00166667}, {455,0.00172973}, {456,0.00154054}, {457,0.00190090}, {458,0.00167568}, {459,0.00172973}, {460,0.00173874}, {461,0.00139640}, {462,0.00134234}, {463,0.00158559}, {464,0.00194595}, {465,0.00204505}, {466,0.00187387}, {467,0.00280180}, {468,0.00154955}, {469,0.00173874}, {470,0.00177477}, {471,0.00176577}, {472,0.00197297}, {473,0.00166667}, {474,0.00143243}, {475,0.00190991}, {476,0.00161261}, {477,0.00398198}, {478,0.00156757}, {479,0.00182883}, {480,0.00181081}, {481,0.00188288}, {482,0.00175676}, {483,0.00164865}, {484,0.00186486}, {485,0.00176577}, {486,0.00172973}, {487,0.00445946}, {488,0.00170270}, {489,0.00180180}, {490,0.00175676}, {491,0.00165766}, {492,0.00188288}, {493,0.00165766}, {494,0.00172072}, {495,0.00178378}, {496,0.00172973}, {497,0.00187387}, {498,0.00181081}, {499,0.00176577}, {500,0.00169369}, {505,0.00172973}, {510,0.00188288}, {515,0.00181982}, {520,0.00184685}, {525,0.00192793}, {530,0.00191892}, {535,0.00188288}, {540,0.00190090}, {545,0.00175676}, {550,0.00200901}, {555,0.00184685}, {560,0.00205405}, {565,0.00215315}, {570,0.00180180}, {575,0.00432432}, {580,0.00202703}, {585,0.00196396}, {590,0.00193694}, {595,0.00183784}, {600,0.00218919}, {605,0.00194595}, {610,0.00218018}, {615,0.00215315}, {620,0.00203604}, {625,0.00220721}, {630,0.00237838}, {635,0.00236036}, {640,0.00247748}, {645,0.00261261}, {650,0.00277477}, {655,0.00190090}, {660,0.00229730}, {665,0.00243243}, {670,0.00251351}, {675,0.00282883}, {680,0.00266667}, {685,0.00237838}, {690,0.00239640}, {695,0.00243243}, {700,0.00232432}, {705,0.00248649}, {710,0.00283784}, {715,0.00230631}, {720,0.00265766}, {725,0.00281982}, {730,0.00236036}, {735,0.00264865}, {740,0.00272973}, {745,0.00272072}, {750,0.00264865}, {755,0.00253153}, {760,0.00250450}, {765,0.00290991}, {770,0.00278378}, {775,0.00271171}, {780,0.00281982}, {785,0.00275676}, {790,0.00309910}, {795,0.00266667}, {800,0.00311712}, {805,0.00293694}, {810,0.00300901}, {815,0.00294595}, {820,0.00305405}, {825,0.00300000}, {830,0.00291892}, {835,0.00318919}, {840,0.00282883}, {845,0.00297297}, {850,0.00315315}, {855,0.00309009}, {860,0.00309009}, {865,0.00345946}, {870,0.00327928}, {875,0.00300901}, {880,0.00798198}, {885,0.00318018}, {890,0.00328829}, {895,0.00338739}, {900,0.00335135}, {905,0.00326126}, {910,0.00343243}, {915,0.00327928}, {920,0.00332432}, {925,0.00329730}, {930,0.00343243}, {935,0.00870270}, {940,0.00351351}, {945,0.00350450}, {950,0.00340541}, {955,0.00363964}, {960,0.00343243}, {965,0.00344144}, {970,0.00355856}, {975,0.00354955}, {980,0.00369369}, {985,0.00364865}, {990,0.00363964}, {995,0.00369369}, {1000,0.00390090}, {1010,0.00363964}, {1020,0.00376577}, {1030,0.00369369}, {1040,0.00375676}, {1050,0.00409910}, {1060,0.00399099}, {1070,0.00401802}, {1080,0.00409910}, {1090,0.00390991}, {1100,0.00412613}, {1110,0.00409009}, {1120,0.00331532}, {1130,0.00420721}, {1140,0.00446847}, {1150,0.00426126}, {1160,0.00440541}, {1170,0.00436937}, {1180,0.00429730}, {1190,0.00468468}, {1200,0.00487387}, {1210,0.00472072}, {1220,0.00455856}, {1230,0.00448649}, {1240,0.00500901}, {1250,0.00472072}, {1260,0.00481081}, {1270,0.00475676}, {1280,0.00456757}, {1290,0.00501802}, {1300,0.00484685}, {1310,0.00493694}, {1320,0.00526126}, {1330,0.00481081}, {1340,0.00496396}, {1350,0.00487387}, {1360,0.00505405}, {1370,0.00563964}, {1380,0.00521622}, {1390,0.00544144}, {1400,0.01082883}, {1410,0.00491892}, {1420,0.00547748}, {1430,0.00547748}, {1440,0.00572973}, {1450,0.00583784}, {1460,0.00566667}, {1470,0.00558559}, {1480,0.00561261}, {1490,0.00560360}, {1500,0.00554054}, {1510,0.00582883}, {1520,0.00554054}, {1530,0.00563063}, {1540,0.00530631}, {1550,0.00612613}, {1560,0.00603604}, {1570,0.00633333}, {1580,0.00637838}, {1590,0.00612613}, {1600,0.00623423}, {1610,0.00640541}, {1620,0.00640541}, {1630,0.00639640}, {1640,0.00647748}, {1650,0.00636036}, {1660,0.00657658}, {1670,0.00663964}, {1680,0.00690991}, {1690,0.00670270}, {1700,0.00682883}, {1710,0.00698198}, {1720,0.00673874}, {1730,0.00700901}, {1740,0.00727928}, {1750,0.00685586}, {1760,0.00700901}, {1770,0.00702703}, {1780,0.00702703}, {1790,0.00733333}, {1800,0.00705405}, {1810,0.00741441}, {1820,0.00729730}, {1830,0.00728829}, {1840,0.00739640}, {1850,0.00767568}, {1860,0.00742342}, {1870,0.00627027}, {1880,0.00757658}, {1890,0.00767568}, {1900,0.00779279}, {1910,0.00767568}, {1920,0.00767568}, {1930,0.00778378}, {1940,0.00754955}, {1950,0.01193694}, {1960,0.00797297}, {1970,0.00790090}, {1980,0.00806306}, {1990,0.00821622}, {2000,0.00815315}, {2050,0.00872072}, {2100,0.00896396}, {2150,0.00926126}, {2200,0.00930631}, {2250,0.01472973}, {2300,0.01018018}, {2350,0.01040541}, {2400,0.01086486}, {2450,0.01063964}, {2500,0.01123423}, {2550,0.01152252}, {2600,0.01200000}, {2650,0.01217117}, {2700,0.01263964}, {2750,0.01259459}, {2800,0.01296396}, {2850,0.02933333}, {2900,0.01388288}, {2950,0.01129730}, {3000,0.01400000}, {3050,0.01426126}, {3100,0.01439640}, {3150,0.01510811}, {3200,0.01897297}, {3250,0.01547748}, {3300,0.01552252}, {3350,0.03550450}, {3400,0.01597297}, {3450,0.01595495}, {3500,0.01624324}, {3550,0.01666667}, {3600,0.01709910}, {3650,0.03469369}, {3700,0.01754955}, {3750,0.01772973}, {3800,0.01672072}, {3850,0.01813514}, {3900,0.01843243}, {3950,0.01933333}, {4000,0.01794595}, {4050,0.04745045}, {4100,0.01933333}, {4150,0.02000901}, {4200,0.01985586}, {4250,0.01762162}, {4300,0.04024324}, {4350,0.02072973}, {4400,0.02068468}, {4450,0.02129730}, {4500,0.02166667}, {4550,0.02133333}, {4600,0.01736036}, {4650,0.04375676}, {4700,0.02273874}, {4750,0.02300901}, {4800,0.02331532}, {4850,0.02334234}, {4900,0.02345045}, {4950,0.02418919}, {5000,0.02467568}, {5050,0.02507207}, {5100,0.02517117}, {5150,0.02499099}, {5200,0.02552252}, {5250,0.02585586}, {5300,0.02590991}, {5350,0.02646847}, {5400,0.02664865}, {5450,0.02672072}, {5500,0.02646847}, {5550,0.02689189}, {5600,0.02714414}, {5650,0.02718919}, {5700,0.02732432}, {5750,0.05820721}, {5800,0.03292793}, {5850,0.02593694}, {5900,0.02854054}, {5950,0.02950450}, {6000,0.02876577}, {6050,0.02909009}, {6100,0.05896396}, {6150,0.02361261}, {6200,0.02963063}, {6250,0.03043243}, {6300,0.03045045}, {6350,0.05944144}, {6400,0.02733333}, {6450,0.03180180}, {6500,0.03113514}, {6550,0.03136937}, {6600,0.02764865}, {6650,0.03236937}, {6700,0.03206306}, {6750,0.06933333}, {6800,0.03181081}, {6850,0.03263964}, {6900,0.09790991}, {6950,0.03000901}, {7000,0.03401802}, {7050,0.06809910}, {7100,0.03192793}, {7150,0.03459459}, {7200,0.05707207}, {7250,0.03547748}, {7300,0.03545946}, {7350,0.03018018}, {7400,0.03564865}, {7450,0.05058559}, {7500,0.03665766}, {7550,0.06630631}, {7600,0.03748649}, {7650,0.03694595}, {7700,0.03517117}, {7750,0.03727928}, {7800,0.03445045}, {7850,0.03781982}, {7900,0.03524324}, {7950,0.03830631}, {8000,0.03819820}, {8050,0.08354054}, {8100,0.04015315}, {8150,0.07306306}, {8200,0.04010811}, {8250,0.04948649}, {8300,0.03974775}, {8350,0.03731532}, {8400,0.07579279}, {8450,0.04079279}, {8500,0.02761261}, {8550,0.04094595}, {8600,0.04194595}, {8650,0.06072072}, {8700,0.04173874}, {8750,0.04264865}, {8800,0.06336036}, {8850,0.04220721}, {8900,0.04286486}, {8950,0.03500000}, {9000,0.07566667}, {9050,0.04280180}, {9100,0.04245045}, {9150,0.05438739}, {9200,0.08775676}, {9250,0.04436036}, {9300,0.04549550}, {9350,0.03731532}, {9400,0.08045045}, {9450,0.04564865}, {9500,0.04539640}, {9550,0.04700901}, {9600,0.04161261}, {9650,0.06029730}, {9700,0.08749550}, {9750,0.09900000}, {9800,0.04718919}, {9850,0.04782883}, {9900,0.04825225}, {9950,0.04578378}, {10000,0.04327027}, {10100,0.03930631}, {10200,0.05500000}, {10300,0.06277477}, {10400,0.07309009}, {10500,0.07368468}, {10600,0.06848649}, {10700,0.05741441}, {10800,0.04160360}, {10900,0.04613514}, {11000,0.04996396}, {11100,0.05385586}, {11200,0.05404505}, {11300,0.13929730}, {11400,0.10682883}, {11500,0.07175676}, {11600,0.05081982}, {11700,0.05723423}, {11800,0.11289189}, {11900,0.08993694}, {12000,0.05345045}, {12100,0.05830631}, {12200,0.09523423}, {12300,0.05350450}, {12400,0.05964865}, {12500,0.08865766}, {12600,0.06006306}, {12700,0.11900901}, {12800,0.05657658}, {12900,0.11392793}, {13000,0.05499099}, {13100,0.12685586}, {13200,0.05491892}, {13300,0.10901802}, {13400,0.05831532}, {13500,0.11645045}, {13600,0.06442342}, {13700,0.07985586}, {13800,0.12334234}, {13900,0.06154955}, {14000,0.10855856}, {14100,0.12404505}, {14200,0.06400000}, {14300,0.04776577}, {14400,0.11818919}, {14500,0.14393694}, {14600,0.06581081}, {14700,0.05900901}, {14800,0.10484685}, {14900,0.11585586}, {15000,0.11599099}, {15100,0.15106306}, {15200,0.07088288}, {15300,0.06810811}, {15400,0.06611712}, {15500,0.06481081}, {15600,0.06440541}, {15700,0.06388288}, {15800,0.06503604}, {15900,0.06673874}, {16000,0.06871171}, {16100,0.07121622}, {16200,0.07418919}, {16300,0.16374775}, {16400,0.12705405}, {16500,0.12954955}, {16600,0.11954054}, {16700,0.06931532}, {16800,0.07314414}, {16900,0.14247748}, {17000,0.12517117}, {17100,0.05675676}, {17200,0.07462162}, {17300,0.12931532}, {17400,0.11114414}, {17500,0.07383784}, {17600,0.13438739}, {17700,0.10022523}, {17800,0.07858559}, {17900,0.13039640}, {18000,0.07395495}, {18100,0.16443243}, {18200,0.07332432}, {18300,0.13718018}, {18400,0.07259459}, {18500,0.18755856}, {18600,0.07554955}, {18700,0.15232432}, {18800,0.08304505}, {18900,0.12954054}, {19000,0.15681081}, {19100,0.08086486}, {19200,0.12657658}, {19300,0.14719820}, {19400,0.07974775}, {19500,0.12323423}, {19600,0.16973874}, {19700,0.17747748}, {19800,0.08038739}, {19900,0.10884685}, {20000,0.13907339}};
data["big"]["OCaml"]["reif"]["system"] = {{1,0.00014414}, {2,0.00003604}, {3,0.00010811}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003604}, {13,0.00003604}, {14,0.00000000}, {15,0.00000000}, {16,0.00003604}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00003604}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00003604}, {38,0.00000000}, {39,0.00003604}, {40,0.00000000}, {41,0.00003604}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00003604}, {47,0.00000000}, {48,0.00003604}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00003604}, {58,0.00018018}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00002703}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00003604}, {70,0.00000000}, {71,0.00000000}, {72,0.00002703}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00003604}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00003604}, {88,0.00000000}, {89,0.00003604}, {90,0.00000000}, {91,0.00000000}, {92,0.00003604}, {93,0.00000000}, {94,0.00000000}, {95,0.00003604}, {96,0.00000000}, {97,0.00000000}, {98,0.00003604}, {99,0.00003604}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00007207}, {106,0.00000000}, {107,0.00000000}, {108,0.00007207}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00003604}, {114,0.00003604}, {115,0.00003604}, {116,0.00007207}, {117,0.00000000}, {118,0.00000000}, {119,0.00007207}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00003604}, {126,0.00000000}, {127,0.00003604}, {128,0.00000000}, {129,0.00003604}, {130,0.00000000}, {131,0.00003604}, {132,0.00000000}, {133,0.00003604}, {134,0.00003604}, {135,0.00000000}, {136,0.00000000}, {137,0.00003604}, {138,0.00003604}, {139,0.00000000}, {140,0.00000000}, {141,0.00003604}, {142,0.00000000}, {143,0.00003604}, {144,0.00000000}, {145,0.00000000}, {146,0.00003604}, {147,0.00000000}, {148,0.00003604}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00003604}, {154,0.00007207}, {155,0.00003604}, {156,0.00000000}, {157,0.00002703}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00002703}, {166,0.00003604}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00003604}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00003604}, {182,0.00003604}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00003604}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00003604}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00003604}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00003604}, {214,0.00003604}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00003604}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00003604}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00003604}, {230,0.00003604}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00007207}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00003604}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00003604}, {252,0.00000000}, {253,0.00000000}, {254,0.00002703}, {255,0.00003604}, {256,0.00000000}, {257,0.00010811}, {258,0.00003604}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003604}, {266,0.00000000}, {267,0.00000000}, {268,0.00003604}, {269,0.00000000}, {270,0.00000000}, {271,0.00007207}, {272,0.00010811}, {273,0.00000000}, {274,0.00003604}, {275,0.00000000}, {276,0.00003604}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00003604}, {285,0.00000000}, {286,0.00007207}, {287,0.00010811}, {288,0.00000000}, {289,0.00000000}, {290,0.00003604}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00003604}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00003604}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00007207}, {320,0.00000000}, {321,0.00003604}, {322,0.00003604}, {323,0.00000000}, {324,0.00003604}, {325,0.00007207}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00003604}, {330,0.00003604}, {331,0.00002703}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00003604}, {336,0.00000000}, {337,0.00007207}, {338,0.00003604}, {339,0.00003604}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00003604}, {345,0.00000000}, {346,0.00000000}, {347,0.00003604}, {348,0.00000000}, {349,0.00003604}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00003604}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00007207}, {360,0.00003604}, {361,0.00000000}, {362,0.00007207}, {363,0.00000000}, {364,0.00003604}, {365,0.00000000}, {366,0.00006306}, {367,0.00000000}, {368,0.00000000}, {369,0.00003604}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00003604}, {378,0.00003604}, {379,0.00003604}, {380,0.00003604}, {381,0.00007207}, {382,0.00000000}, {383,0.00000000}, {384,0.00003604}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00003604}, {390,0.00000000}, {391,0.00000000}, {392,0.00003604}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00003604}, {401,0.00003604}, {402,0.00003604}, {403,0.00003604}, {404,0.00002703}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00003604}, {409,0.00007207}, {410,0.00000000}, {411,0.00000000}, {412,0.00003604}, {413,0.00007207}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00003604}, {418,0.00007207}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00003604}, {423,0.00003604}, {424,0.00003604}, {425,0.00000000}, {426,0.00003604}, {427,0.00000000}, {428,0.00000000}, {429,0.00003604}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00003604}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00007207}, {447,0.00000000}, {448,0.00003604}, {449,0.00000000}, {450,0.00000000}, {451,0.00003604}, {452,0.00003604}, {453,0.00000000}, {454,0.00000000}, {455,0.00003604}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00003604}, {461,0.00007207}, {462,0.00000000}, {463,0.00000000}, {464,0.00003604}, {465,0.00000000}, {466,0.00003604}, {467,0.00002703}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00003604}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00007207}, {478,0.00000000}, {479,0.00003604}, {480,0.00000000}, {481,0.00000000}, {482,0.00003604}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00003604}, {487,0.00010811}, {488,0.00000000}, {489,0.00003604}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00007207}, {494,0.00000000}, {495,0.00007207}, {496,0.00000000}, {497,0.00003604}, {498,0.00007207}, {499,0.00000000}, {500,0.00000000}, {505,0.00003604}, {510,0.00000000}, {515,0.00000000}, {520,0.00003604}, {525,0.00000000}, {530,0.00003604}, {535,0.00003604}, {540,0.00003604}, {545,0.00000000}, {550,0.00003604}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00003604}, {575,0.00014414}, {580,0.00002703}, {585,0.00000000}, {590,0.00003604}, {595,0.00014414}, {600,0.00003604}, {605,0.00007207}, {610,0.00000000}, {615,0.00003604}, {620,0.00000000}, {625,0.00003604}, {630,0.00000000}, {635,0.00003604}, {640,0.00000000}, {645,0.00000000}, {650,0.00003604}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00003604}, {680,0.00000000}, {685,0.00003604}, {690,0.00003604}, {695,0.00003604}, {700,0.00003604}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00003604}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00010811}, {750,0.00000000}, {755,0.00007207}, {760,0.00000000}, {765,0.00000000}, {770,0.00003604}, {775,0.00003604}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00003604}, {800,0.00003604}, {805,0.00003604}, {810,0.00003604}, {815,0.00003604}, {820,0.00007207}, {825,0.00003604}, {830,0.00010811}, {835,0.00003604}, {840,0.00003604}, {845,0.00000000}, {850,0.00010811}, {855,0.00003604}, {860,0.00003604}, {865,0.00010811}, {870,0.00003604}, {875,0.00000000}, {880,0.00003604}, {885,0.00000000}, {890,0.00003604}, {895,0.00003604}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00003604}, {920,0.00003604}, {925,0.00000000}, {930,0.00000000}, {935,0.00003604}, {940,0.00000000}, {945,0.00007207}, {950,0.00003604}, {955,0.00000000}, {960,0.00014414}, {965,0.00003604}, {970,0.00000000}, {975,0.00003604}, {980,0.00000000}, {985,0.00007207}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00003604}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00003604}, {1100,0.00003604}, {1110,0.00007207}, {1120,0.00010811}, {1130,0.00003604}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00007207}, {1170,0.00003604}, {1180,0.00007207}, {1190,0.00007207}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00007207}, {1240,0.00000000}, {1250,0.00003604}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003604}, {1290,0.00003604}, {1300,0.00007207}, {1310,0.00007207}, {1320,0.00003604}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00003604}, {1360,0.00007207}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00014414}, {1410,0.00003604}, {1420,0.00000000}, {1430,0.00003604}, {1440,0.00003604}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00003604}, {1480,0.00000000}, {1490,0.00007207}, {1500,0.00007207}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00003604}, {1540,0.00000000}, {1550,0.00007207}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00003604}, {1620,0.00000000}, {1630,0.00003604}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003604}, {1670,0.00003604}, {1680,0.00003604}, {1690,0.00007207}, {1700,0.00003604}, {1710,0.00003604}, {1720,0.00006306}, {1730,0.00003604}, {1740,0.00007207}, {1750,0.00002703}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00007207}, {1790,0.00007207}, {1800,0.00000000}, {1810,0.00014414}, {1820,0.00007207}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00007207}, {1870,0.00007207}, {1880,0.00000000}, {1890,0.00006306}, {1900,0.00000000}, {1910,0.00003604}, {1920,0.00003604}, {1930,0.00003604}, {1940,0.00003604}, {1950,0.00018018}, {1960,0.00014414}, {1970,0.00003604}, {1980,0.00006306}, {1990,0.00003604}, {2000,0.00000000}, {2050,0.00003604}, {2100,0.00003604}, {2150,0.00000000}, {2200,0.00009910}, {2250,0.00024324}, {2300,0.00003604}, {2350,0.00000000}, {2400,0.00003604}, {2450,0.00003604}, {2500,0.00007207}, {2550,0.00003604}, {2600,0.00007207}, {2650,0.00003604}, {2700,0.00003604}, {2750,0.00000000}, {2800,0.00003604}, {2850,0.00031532}, {2900,0.00000000}, {2950,0.00003604}, {3000,0.00006306}, {3050,0.00007207}, {3100,0.00000000}, {3150,0.00003604}, {3200,0.00017117}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00031532}, {3400,0.00007207}, {3450,0.00007207}, {3500,0.00007207}, {3550,0.00003604}, {3600,0.00007207}, {3650,0.00036036}, {3700,0.00000000}, {3750,0.00018018}, {3800,0.00000000}, {3850,0.00007207}, {3900,0.00007207}, {3950,0.00000000}, {4000,0.00003604}, {4050,0.00043243}, {4100,0.00010811}, {4150,0.00000000}, {4200,0.00003604}, {4250,0.00007207}, {4300,0.00050450}, {4350,0.00000000}, {4400,0.00014414}, {4450,0.00014414}, {4500,0.00000000}, {4550,0.00010811}, {4600,0.00007207}, {4650,0.00032432}, {4700,0.00006306}, {4750,0.00003604}, {4800,0.00010811}, {4850,0.00003604}, {4900,0.00003604}, {4950,0.00000000}, {5000,0.00003604}, {5050,0.00007207}, {5100,0.00000000}, {5150,0.00017117}, {5200,0.00000000}, {5250,0.00003604}, {5300,0.00006306}, {5350,0.00007207}, {5400,0.00010811}, {5450,0.00010811}, {5500,0.00014414}, {5550,0.00003604}, {5600,0.00000000}, {5650,0.00007207}, {5700,0.00007207}, {5750,0.00086486}, {5800,0.00018018}, {5850,0.00014414}, {5900,0.00007207}, {5950,0.00000000}, {6000,0.00010811}, {6050,0.00003604}, {6100,0.00063063}, {6150,0.00007207}, {6200,0.00009910}, {6250,0.00010811}, {6300,0.00003604}, {6350,0.00010811}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00003604}, {6550,0.00003604}, {6600,0.00003604}, {6650,0.00010811}, {6700,0.00006306}, {6750,0.00005405}, {6800,0.00003604}, {6850,0.00000000}, {6900,0.00014414}, {6950,0.00003604}, {7000,0.00000000}, {7050,0.00071171}, {7100,0.00010811}, {7150,0.00003604}, {7200,0.00059459}, {7250,0.00007207}, {7300,0.00003604}, {7350,0.00010811}, {7400,0.00000000}, {7450,0.00050450}, {7500,0.00010811}, {7550,0.00086486}, {7600,0.00010811}, {7650,0.00010811}, {7700,0.00010811}, {7750,0.00000000}, {7800,0.00003604}, {7850,0.00010811}, {7900,0.00000000}, {7950,0.00003604}, {8000,0.00006306}, {8050,0.00109910}, {8100,0.00007207}, {8150,0.00110811}, {8200,0.00003604}, {8250,0.00044144}, {8300,0.00018018}, {8350,0.00003604}, {8400,0.00085586}, {8450,0.00003604}, {8500,0.00010811}, {8550,0.00000000}, {8600,0.00007207}, {8650,0.00045946}, {8700,0.00007207}, {8750,0.00014414}, {8800,0.00002703}, {8850,0.00000000}, {8900,0.00014414}, {8950,0.00014414}, {9000,0.00000000}, {9050,0.00007207}, {9100,0.00003604}, {9150,0.00007207}, {9200,0.00010811}, {9250,0.00000000}, {9300,0.00003604}, {9350,0.00013514}, {9400,0.00003604}, {9450,0.00000000}, {9500,0.00010811}, {9550,0.00003604}, {9600,0.00014414}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00007207}, {9850,0.00007207}, {9900,0.00014414}, {9950,0.00010811}, {10000,0.00007207}, {10100,0.00007207}, {10200,0.00007207}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00007207}, {10600,0.00007207}, {10700,0.00003604}, {10800,0.00007207}, {10900,0.00000000}, {11000,0.00007207}, {11100,0.00003604}, {11200,0.00000000}, {11300,0.00007207}, {11400,0.00007207}, {11500,0.00000000}, {11600,0.00007207}, {11700,0.00003604}, {11800,0.00003604}, {11900,0.00003604}, {12000,0.00000000}, {12100,0.00003604}, {12200,0.00000000}, {12300,0.00002703}, {12400,0.00000000}, {12500,0.00003604}, {12600,0.00002703}, {12700,0.00000000}, {12800,0.00003604}, {12900,0.00003604}, {13000,0.00003604}, {13100,0.00009910}, {13200,0.00007207}, {13300,0.00000000}, {13400,0.00003604}, {13500,0.00000000}, {13600,0.00003604}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00003604}, {14000,0.00010811}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00007207}, {14400,0.00000000}, {14500,0.00007207}, {14600,0.00003604}, {14700,0.00000000}, {14800,0.00010811}, {14900,0.00000000}, {15000,0.00018018}, {15100,0.00007207}, {15200,0.00003604}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00007207}, {15600,0.00000000}, {15700,0.00007207}, {15800,0.00007207}, {15900,0.00000000}, {16000,0.00006306}, {16100,0.00003604}, {16200,0.00000000}, {16300,0.00007207}, {16400,0.00007207}, {16500,0.00000000}, {16600,0.00003604}, {16700,0.00007207}, {16800,0.00018018}, {16900,0.00010811}, {17000,0.00009910}, {17100,0.00000000}, {17200,0.00010811}, {17300,0.00003604}, {17400,0.00007207}, {17500,0.00003604}, {17600,0.00007207}, {17700,0.00003604}, {17800,0.00003604}, {17900,0.00014414}, {18000,0.00007207}, {18100,0.00007207}, {18200,0.00018018}, {18300,0.00003604}, {18400,0.00017117}, {18500,0.00003604}, {18600,0.00003604}, {18700,0.00007207}, {18800,0.00020721}, {18900,0.00007207}, {19000,0.00003604}, {19100,0.00013514}, {19200,0.00003604}, {19300,0.00000000}, {19400,0.00003604}, {19500,0.00092793}, {19600,0.00238739}, {19700,0.00266667}, {19800,0.00018018}, {19900,0.00081982}, {20000,0.00127523}};
data["big"]["Parametricity; beta"]["Aggregate"]["real"] = {{1,0.001028436}, {2,0.001000000}, {3,0.001000000}, {4,0.001000000}, {5,0.027104265}, {6,0.001000000}, {7,0.001000000}, {8,0.001000000}, {9,0.001000000}, {10,0.001004739}, {11,0.001000000}, {12,0.001000000}, {13,0.001000000}, {14,0.001000000}, {15,0.001000000}, {16,0.001000000}, {17,0.001000000}, {18,0.001009479}, {19,0.001000000}, {20,0.001000000}, {21,0.001000000}, {22,0.001000000}, {23,0.001000000}, {24,0.023208531}, {25,0.001004739}, {26,0.001018957}, {27,0.001023697}, {28,0.001009479}, {29,0.001004739}, {30,0.001018957}, {31,0.001023697}, {32,0.001052133}, {33,0.001080569}, {34,0.001104265}, {35,0.001109005}, {36,0.001189573}, {37,0.001194313}, {38,0.001251185}, {39,0.001336493}, {40,0.001388626}, {41,0.001473934}, {42,0.001497630}, {43,0.001516588}, {44,0.001616114}, {45,0.001649289}, {46,0.001777251}, {47,0.001668246}, {48,0.001663507}, {49,0.001687204}, {50,0.001701422}, {51,0.001781991}, {52,0.001819905}, {53,0.001834123}, {54,0.001905213}, {55,0.001928910}, {56,0.001966825}, {57,0.001990521}, {58,0.002516588}, {59,0.002000000}, {60,0.002000000}, {61,0.002000000}, {62,0.002000000}, {63,0.002000000}, {64,0.002000000}, {65,0.002004739}, {66,0.002000000}, {67,0.002606635}, {68,0.002000000}, {69,0.002000000}, {70,0.002000000}, {71,0.002000000}, {72,0.002000000}, {73,0.002000000}, {74,0.002004739}, {75,0.002009479}, {76,0.002018957}, {77,0.002014218}, {78,0.002018957}, {79,0.002018957}, {80,0.002037915}, {81,0.002052133}, {82,0.002047393}, {83,0.002066351}, {84,0.002061611}, {85,0.002056872}, {86,0.002080569}, {87,0.002109005}, {88,0.002118483}, {89,0.002118483}, {90,0.002132701}, {91,0.002170616}, {92,0.002175355}, {93,0.002199052}, {94,0.002189573}, {95,0.002270142}, {96,0.002293839}, {97,0.002317536}, {98,0.002350711}, {99,0.002924171}, {100,0.002488152}, {101,0.002454976}, {102,0.002488152}, {103,0.002502370}, {104,0.002521327}, {105,0.002582938}, {106,0.002578199}, {107,0.002573460}, {108,0.002592417}, {109,0.002606635}, {110,0.002635071}, {111,0.002635071}, {112,0.002682464}, {113,0.002677725}, {114,0.002687204}, {115,0.002672986}, {116,0.002706161}, {117,0.002725118}, {118,0.002729858}, {119,0.002763033}, {120,0.002824645}, {121,0.002914692}, {122,0.002938389}, {123,0.002971564}, {124,0.002962085}, {125,0.002966825}, {126,0.003483412}, {127,0.002985782}, {128,0.002990521}, {129,0.003000000}, {130,0.003000000}, {131,0.003014218}, {132,0.003014218}, {133,0.003018957}, {134,0.003028436}, {135,0.003018957}, {136,0.003018957}, {137,0.003047393}, {138,0.003056872}, {139,0.003052133}, {140,0.003066351}, {141,0.003066351}, {142,0.003056872}, {143,0.003090047}, {144,0.003080569}, {145,0.003085308}, {146,0.003071090}, {147,0.003075829}, {148,0.003099526}, {149,0.003957346}, {150,0.003123223}, {151,0.003151659}, {152,0.003156398}, {153,0.003213270}, {154,0.003251185}, {155,0.003265403}, {156,0.003308057}, {157,0.003350711}, {158,0.003374408}, {159,0.003379147}, {160,0.003402844}, {161,0.003417062}, {162,0.003454976}, {163,0.003478673}, {164,0.003521327}, {165,0.003559242}, {166,0.003582938}, {167,0.003582938}, {168,0.003592417}, {169,0.003620853}, {170,0.004597156}, {171,0.003597156}, {172,0.003611374}, {173,0.003606635}, {174,0.003597156}, {175,0.003620853}, {176,0.003649289}, {177,0.003658768}, {178,0.003639810}, {179,0.003677725}, {180,0.003682464}, {181,0.003687204}, {182,0.003701422}, {183,0.003710900}, {184,0.003767773}, {185,0.003791469}, {186,0.003829384}, {187,0.003843602}, {188,0.003867299}, {189,0.004521327}, {190,0.004483412}, {191,0.003971564}, {192,0.003962085}, {193,0.003966825}, {194,0.003976303}, {195,0.003981043}, {196,0.003990521}, {197,0.004037915}, {198,0.004018957}, {199,0.004028436}, {200,0.004023697}, {201,0.004028436}, {202,0.004028436}, {203,0.004052133}, {204,0.004042654}, {205,0.004094787}, {206,0.004066351}, {207,0.004644550}, {208,0.004137441}, {209,0.005109005}, {210,0.004165877}, {211,0.004203791}, {212,0.004199052}, {213,0.004255924}, {214,0.004289100}, {215,0.004341232}, {216,0.004355450}, {217,0.004388626}, {218,0.004393365}, {219,0.004398104}, {220,0.004402844}, {221,0.004393365}, {222,0.004431280}, {223,0.005132701}, {224,0.004469194}, {225,0.004492891}, {226,0.004563981}, {227,0.004981043}, {228,0.004545024}, {229,0.004559242}, {230,0.004554502}, {231,0.004559242}, {232,0.004559242}, {233,0.004549763}, {234,0.004573460}, {235,0.004563981}, {236,0.004573460}, {237,0.004597156}, {238,0.004611374}, {239,0.005289100}, {240,0.004635071}, {241,0.004620853}, {242,0.004630332}, {243,0.005261905}, {244,0.004657143}, {245,0.004666667}, {246,0.004676190}, {247,0.004671429}, {248,0.004709524}, {249,0.004719048}, {250,0.004780952}, {251,0.004800000}, {252,0.004814286}, {253,0.004861905}, {254,0.005895238}, {255,0.004885714}, {256,0.004914286}, {257,0.004957143}, {258,0.004957143}, {259,0.005452381}, {260,0.004976190}, {261,0.005009524}, {262,0.005009524}, {263,0.005014286}, {264,0.005057143}, {265,0.005004762}, {266,0.005076190}, {267,0.005104762}, {268,0.005952381}, {269,0.005214286}, {270,0.005190476}, {271,0.005228571}, {272,0.005247619}, {273,0.005290476}, {274,0.005828571}, {275,0.005304762}, {276,0.005352381}, {277,0.005357143}, {278,0.005380952}, {279,0.005366667}, {280,0.005376190}, {281,0.005390476}, {282,0.005890476}, {283,0.005404762}, {284,0.005433333}, {285,0.005452381}, {286,0.005457143}, {287,0.005466667}, {288,0.005490476}, {289,0.005485714}, {290,0.005533333}, {291,0.005552381}, {292,0.005557143}, {293,0.005590476}, {294,0.005590476}, {295,0.006476190}, {296,0.005576190}, {297,0.005552381}, {298,0.005604762}, {299,0.005595238}, {300,0.005614286}, {301,0.005623810}, {302,0.006261905}, {303,0.005600000}, {304,0.005590476}, {305,0.005647619}, {306,0.005647619}, {307,0.005647619}, {308,0.006114286}, {309,0.005680952}, {310,0.005700000}, {311,0.005676190}, {312,0.005695238}, {313,0.005728571}, {314,0.005738095}, {315,0.005757143}, {316,0.006095238}, {317,0.005800000}, {318,0.005800000}, {319,0.005852381}, {320,0.006485714}, {321,0.005942857}, {322,0.005985714}, {323,0.005961905}, {324,0.006000000}, {325,0.006071429}, {326,0.006090476}, {327,0.006085714}, {328,0.006100000}, {329,0.006114286}, {330,0.006157143}, {331,0.006180952}, {332,0.006633333}, {333,0.006228571}, {334,0.006228571}, {335,0.006266667}, {336,0.006271429}, {337,0.006323810}, {338,0.006314286}, {339,0.006338095}, {340,0.006338095}, {341,0.007252381}, {342,0.006400000}, {343,0.007014286}, {344,0.006380952}, {345,0.006400000}, {346,0.006414286}, {347,0.006423810}, {348,0.006419048}, {349,0.006447619}, {350,0.006428571}, {351,0.006452381}, {352,0.006495238}, {353,0.007447619}, {354,0.007285714}, {355,0.006519048}, {356,0.006533333}, {357,0.006528571}, {358,0.006514286}, {359,0.006523810}, {360,0.006528571}, {361,0.006538095}, {362,0.006557143}, {363,0.006571429}, {364,0.006576190}, {365,0.007971429}, {366,0.006571429}, {367,0.006580952}, {368,0.006576190}, {369,0.006595238}, {370,0.006638095}, {371,0.006604762}, {372,0.006647619}, {373,0.006638095}, {374,0.006652381}, {375,0.006633333}, {376,0.008261905}, {377,0.006671429}, {378,0.006661905}, {379,0.006709524}, {380,0.006742857}, {381,0.006804762}, {382,0.006785714}, {383,0.006861905}, {384,0.006842857}, {385,0.006914286}, {386,0.008176190}, {387,0.007595238}, {388,0.006980952}, {389,0.007028571}, {390,0.007023810}, {391,0.007095238}, {392,0.007080952}, {393,0.007128571}, {394,0.007166667}, {395,0.007171429}, {396,0.008128571}, {397,0.007223810}, {398,0.007800000}, {399,0.007233333}, {400,0.007266667}, {401,0.007309524}, {402,0.007295238}, {403,0.007309524}, {404,0.007328571}, {405,0.007333333}, {406,0.008304762}, {407,0.007352381}, {408,0.007352381}, {409,0.007852381}, {410,0.007400000}, {411,0.007419048}, {412,0.007414286}, {413,0.007433333}, {414,0.007438095}, {415,0.007442857}, {416,0.008352381}, {417,0.007471429}, {418,0.007485714}, {419,0.008128571}, {420,0.007480952}, {421,0.007485714}, {422,0.007504762}, {423,0.007514286}, {424,0.007509524}, {425,0.007519048}, {426,0.007533333}, {427,0.007538095}, {428,0.007576190}, {429,0.008414286}, {430,0.007600000}, {431,0.007580952}, {432,0.007576190}, {433,0.007614286}, {434,0.007590476}, {435,0.008409524}, {436,0.007604762}, {437,0.007604762}, {438,0.007647619}, {439,0.008633333}, {440,0.007638095}, {441,0.007642857}, {442,0.007671429}, {443,0.007680952}, {444,0.009442857}, {445,0.007690476}, {446,0.007766667}, {447,0.007780952}, {448,0.007842857}, {449,0.008800000}, {450,0.007909524}, {451,0.007938095}, {452,0.007980952}, {453,0.009671429}, {454,0.008071429}, {455,0.008080952}, {456,0.008104762}, {457,0.008138095}, {458,0.008142857}, {459,0.008571429}, {460,0.008223810}, {461,0.008238095}, {462,0.008800000}, {463,0.008242857}, {464,0.008252381}, {465,0.008280952}, {466,0.008290476}, {467,0.008261905}, {468,0.009976190}, {469,0.008295238}, {470,0.008295238}, {471,0.008300000}, {472,0.008342857}, {473,0.008333333}, {474,0.008361905}, {475,0.008371429}, {476,0.008380952}, {477,0.009214286}, {478,0.008390476}, {479,0.010290476}, {480,0.008423810}, {481,0.008404762}, {482,0.008423810}, {483,0.008490476}, {484,0.008471429}, {485,0.008461905}, {486,0.008904762}, {487,0.008476190}, {488,0.008504762}, {489,0.008504762}, {490,0.008547619}, {491,0.008557143}, {492,0.008528571}, {493,0.008547619}, {494,0.008561905}, {495,0.009490476}, {496,0.009033333}, {497,0.008580952}, {498,0.008585714}, {499,0.008623810}, {500,0.008633333}, {505,0.008680952}, {510,0.008771429}, {515,0.008890476}, {520,0.010280952}, {525,0.009180952}, {530,0.009261905}, {535,0.009290476}, {540,0.009328571}, {545,0.009380952}, {550,0.009509524}, {555,0.009571429}, {560,0.010652381}, {565,0.009709524}, {570,0.009780952}, {575,0.009890476}, {580,0.009900000}, {585,0.010019048}, {590,0.010119048}, {595,0.011152381}, {600,0.012266667}, {605,0.010366667}, {610,0.010442857}, {615,0.010485714}, {620,0.010552381}, {625,0.010661905}, {630,0.010757143}, {635,0.011885714}, {640,0.010876190}, {645,0.010938095}, {650,0.010971429}, {655,0.011061905}, {660,0.012704762}, {665,0.011300000}, {670,0.012185714}, {675,0.011490476}, {680,0.011547619}, {685,0.011580952}, {690,0.013295238}, {695,0.011752381}, {700,0.011895238}, {705,0.012461905}, {710,0.011961905}, {715,0.011980952}, {720,0.013338095}, {725,0.012223810}, {730,0.012328571}, {735,0.013633333}, {740,0.012490476}, {745,0.012619048}, {750,0.014266667}, {755,0.012714286}, {760,0.012780952}, {765,0.013742857}, {770,0.012914286}, {775,0.012976190}, {780,0.013066667}, {785,0.013138095}, {790,0.013290476}, {795,0.015052381}, {800,0.013528571}, {805,0.014271429}, {810,0.013695238}, {815,0.013780952}, {820,0.013776190}, {825,0.014676190}, {830,0.016538095}, {835,0.013933333}, {840,0.014066667}, {845,0.014085714}, {850,0.015280952}, {855,0.016119048}, {860,0.014419048}, {865,0.014561905}, {870,0.014661905}, {875,0.014695238}, {880,0.017900000}, {885,0.014833333}, {890,0.014895238}, {895,0.014923810}, {900,0.014971429}, {905,0.016852381}, {910,0.015176190}, {915,0.015342857}, {920,0.015400000}, {925,0.015542857}, {930,0.016200000}, {935,0.015723810}, {940,0.015800000}, {945,0.015857143}, {950,0.017290476}, {955,0.016495238}, {960,0.016061905}, {965,0.016085714}, {970,0.016180952}, {975,0.016971429}, {980,0.016680952}, {985,0.016447619}, {990,0.016542857}, {995,0.019242857}, {1000,0.018109524}, {1010,0.017057143}, {1020,0.017123810}, {1030,0.019171429}, {1040,0.017385714}, {1050,0.018452381}, {1060,0.017780952}, {1070,0.020123810}, {1080,0.018266667}, {1090,0.019542857}, {1100,0.018447619}, {1110,0.020514286}, {1120,0.018733333}, {1130,0.020757143}, {1140,0.019271429}, {1150,0.021580952}, {1160,0.019619048}, {1170,0.019690476}, {1180,0.019928571}, {1190,0.021361905}, {1200,0.020266667}, {1210,0.022214286}, {1220,0.023195238}, {1230,0.020828571}, {1240,0.021000000}, {1250,0.022923810}, {1260,0.024719048}, {1270,0.021719048}, {1280,0.021871429}, {1290,0.026195238}, {1300,0.022209524}, {1310,0.022338095}, {1320,0.022590476}, {1330,0.025114286}, {1340,0.023004762}, {1350,0.023157143}, {1360,0.030085714}, {1370,0.023566667}, {1380,0.023671429}, {1390,0.025442857}, {1400,0.023961905}, {1410,0.024247619}, {1420,0.026090476}, {1430,0.026195238}, {1440,0.024980952}, {1450,0.027352381}, {1460,0.027561905}, {1470,0.025571429}, {1480,0.027723810}, {1490,0.028714286}, {1500,0.026076190}, {1510,0.027871429}, {1520,0.026442857}, {1530,0.026585714}, {1540,0.028838095}, {1550,0.027047619}, {1560,0.028090476}, {1570,0.031480952}, {1580,0.027652381}, {1590,0.028209524}, {1600,0.029676190}, {1610,0.028266667}, {1620,0.031957143}, {1630,0.028757143}, {1640,0.028909524}, {1650,0.029733333}, {1660,0.029461905}, {1670,0.031885714}, {1680,0.030757143}, {1690,0.029880952}, {1700,0.034619048}, {1710,0.030385714}, {1720,0.030485714}, {1730,0.040666667}, {1740,0.030819048}, {1750,0.031038095}, {1760,0.032300000}, {1770,0.031442857}, {1780,0.037890476}, {1790,0.031757143}, {1800,0.033533333}, {1810,0.037780952}, {1820,0.032571429}, {1830,0.035676190}, {1840,0.034014286}, {1850,0.036366667}, {1860,0.036004762}, {1870,0.033471429}, {1880,0.035238095}, {1890,0.035304762}, {1900,0.038804762}, {1910,0.037009524}, {1920,0.038257143}, {1930,0.034900000}, {1940,0.036414286}, {1950,0.036233333}, {1960,0.040000000}, {1970,0.038647619}, {1980,0.036185714}, {1990,0.039971429}, {2000,0.036480952}, {2050,0.042366667}, {2100,0.038328571}, {2150,0.046628571}, {2200,0.040833333}, {2250,0.045761905}, {2300,0.044000000}, {2350,0.048019048}, {2400,0.046680952}, {2450,0.047547619}, {2500,0.048576190}, {2550,0.057076190}, {2600,0.051038095}, {2650,0.056857143}, {2700,0.055190476}, {2750,0.056357143}, {2800,0.059680952}, {2850,0.059085714}, {2900,0.057966667}, {2950,0.064419048}, {3000,0.062923810}, {3050,0.062985714}, {3100,0.073500000}, {3150,0.068966667}, {3200,0.065090476}, {3250,0.072719048}, {3300,0.076938095}, {3350,0.068990476}, {3400,0.074500000}, {3450,0.080680952}, {3500,0.074285714}, {3550,0.082776190}, {3600,0.083347619}, {3650,0.084076190}, {3700,0.086185714}, {3750,0.074342857}, {3800,0.089128571}, {3850,0.086776190}, {3900,0.089328571}, {3950,0.086714286}, {4000,0.089447619}, {4050,0.097614286}, {4100,0.110757143}, {4150,0.100890476}, {4200,0.093238095}, {4250,0.092585714}, {4300,0.097985714}, {4350,0.101842857}, {4400,0.104000000}, {4450,0.106709524}, {4500,0.117923810}, {4550,0.115780952}, {4600,0.108528571}, {4650,0.109395238}, {4700,0.109166667}, {4750,0.110666667}, {4800,0.105980952}, {4850,0.115785714}, {4900,0.126500000}, {4950,0.128876190}, {5000,0.119780952}, {5050,0.122295238}, {5100,0.118157143}, {5150,0.119100000}, {5200,0.123580952}, {5250,0.111328571}, {5300,0.142704762}, {5350,0.132300000}, {5400,0.131061905}, {5450,0.134323810}, {5500,0.118947619}, {5550,0.138076190}, {5600,0.136680952}, {5650,0.143147619}, {5700,0.145738095}, {5750,0.142600000}, {5800,0.140485714}, {5850,0.150590476}, {5900,0.144671429}, {5950,0.150214286}, {6000,0.154514286}, {6050,0.151923810}, {6100,0.147780952}, {6150,0.172980952}, {6200,0.169623810}, {6250,0.156757143}, {6300,0.150595238}, {6350,0.182428571}, {6400,0.161390476}, {6450,0.178761905}, {6500,0.165214286}, {6550,0.150176190}, {6600,0.159957143}, {6650,0.176776190}, {6700,0.170347619}, {6750,0.183466667}, {6800,0.181695238}, {6850,0.177047619}, {6900,0.190447619}, {6950,0.168209524}, {7000,0.167114286}, {7050,0.158723810}, {7100,0.183861905}, {7150,0.204538095}, {7200,0.192433333}, {7250,0.195319048}, {7300,0.176447619}, {7350,0.192371429}, {7400,0.199533333}, {7450,0.189100000}, {7500,0.208633333}, {7550,0.217847619}, {7600,0.189819048}, {7650,0.208514286}, {7700,0.204780952}, {7750,0.184947619}, {7800,0.194480952}, {7850,0.208952381}, {7900,0.209180952}, {7950,0.197471429}, {8000,0.206466667}, {8050,0.219828571}, {8100,0.227295238}, {8150,0.190490476}, {8200,0.219200000}, {8250,0.211857143}, {8300,0.220609524}, {8350,0.230028571}, {8400,0.211585714}, {8450,0.203566667}, {8500,0.220971429}, {8550,0.221485714}, {8600,0.221704762}, {8650,0.241366667}, {8700,0.259519048}, {8750,0.244695238}, {8800,0.230838095}, {8850,0.239538095}, {8900,0.264328571}, {8950,0.242933333}, {9000,0.247047619}, {9050,0.217871429}, {9100,0.230409524}, {9150,0.237657143}, {9200,0.241557143}, {9250,0.275123810}, {9300,0.266628571}, {9350,0.253385714}, {9400,0.273476190}, {9450,0.268766667}, {9500,0.246057143}, {9550,0.252819048}, {9600,0.239309524}, {9650,0.239038095}, {9700,0.225400000}, {9750,0.247609524}, {9800,0.266200000}, {9850,0.285819048}, {9900,0.268700000}, {9950,0.250766667}, {10000,0.226347619}, {10100,0.273100000}, {10200,0.276576190}, {10300,0.248223810}, {10400,0.255304762}, {10500,0.305342857}, {10600,0.314671429}, {10700,0.275223810}, {10800,0.297700000}, {10900,0.261100000}, {11000,0.303785714}, {11100,0.346285714}, {11200,0.261076190}, {11300,0.309276190}, {11400,0.273500000}, {11500,0.346942857}, {11600,0.276038095}, {11700,0.365542857}, {11800,0.371409524}, {11900,0.330142857}, {12000,0.365171429}, {12100,0.317942857}, {12200,0.332780952}, {12300,0.325719048}, {12400,0.389280952}, {12500,0.298128571}, {12600,0.359409524}, {12700,0.393971429}, {12800,0.360719048}, {12900,0.360171429}, {13000,0.278766667}, {13100,0.349223810}, {13200,0.374514286}, {13300,0.336690476}, {13400,0.380771429}, {13500,0.418366667}, {13600,0.415804762}, {13700,0.360900000}, {13800,0.392890476}, {13900,0.408380952}, {14000,0.421185714}, {14100,0.390823810}, {14200,0.376885714}, {14300,0.373747619}, {14400,0.398300000}, {14500,0.387323810}, {14600,0.404066667}, {14700,0.387047619}, {14800,0.398504762}, {14900,0.424642857}, {15000,0.409923810}, {15100,0.358652381}, {15200,0.414180952}, {15300,0.462728571}, {15400,0.403738095}, {15500,0.464376190}, {15600,0.462895238}, {15700,0.480766667}, {15800,0.442319048}, {15900,0.444842857}, {16000,0.471980952}, {16100,0.512371429}, {16200,0.452576190}, {16300,0.510338095}, {16400,0.473604762}, {16500,0.492704762}, {16600,0.523495238}, {16700,0.471128571}, {16800,0.426690476}, {16900,0.500919048}, {17000,0.428400000}, {17100,0.516438095}, {17200,0.478504762}, {17300,0.516628571}, {17400,0.473052381}, {17500,0.477871429}, {17600,0.486671429}, {17700,0.507380952}, {17800,0.469423810}, {17900,0.524142857}, {18000,0.527533333}, {18100,0.494014286}, {18200,0.537314286}, {18300,0.541461905}, {18400,0.517076190}, {18500,0.530280952}, {18600,0.547738095}, {18700,0.558695238}, {18800,0.550166667}, {18900,0.488604762}, {19000,0.554966667}, {19100,0.584790476}, {19200,0.574728571}, {19300,0.554204762}, {19400,0.526757143}, {19500,0.594966667}, {19600,0.570814286}, {19700,0.547785714}, {19800,0.576171429}, {19900,0.575771429}, {20000,0.529625000}};
data["big"]["Parametricity; beta"]["Aggregate"]["user"] = {{1,0.000962085}, {2,0.001255924}, {3,0.000914692}, {4,0.001260664}, {5,0.026682464}, {6,0.001199052}, {7,0.001303318}, {8,0.001109005}, {9,0.001341232}, {10,0.001284360}, {11,0.001497630}, {12,0.001236967}, {13,0.001511848}, {14,0.001061611}, {15,0.001516588}, {16,0.001099526}, {17,0.001606635}, {18,0.001208531}, {19,0.001663507}, {20,0.001317536}, {21,0.001535545}, {22,0.001426540}, {23,0.001492891}, {24,0.023213270}, {25,0.001639810}, {26,0.001483412}, {27,0.001805687}, {28,0.001611374}, {29,0.001715640}, {30,0.001407583}, {31,0.001952607}, {32,0.001393365}, {33,0.001867299}, {34,0.001563981}, {35,0.001919431}, {36,0.001573460}, {37,0.001829384}, {38,0.001701422}, {39,0.001639810}, {40,0.001876777}, {41,0.001677725}, {42,0.001928910}, {43,0.001834123}, {44,0.001710900}, {45,0.002037915}, {46,0.002052133}, {47,0.001815166}, {48,0.001957346}, {49,0.001734597}, {50,0.001772512}, {51,0.002023697}, {52,0.001758294}, {53,0.002014218}, {54,0.001900474}, {55,0.001729858}, {56,0.002222749}, {57,0.001976303}, {58,0.002791469}, {59,0.001800948}, {60,0.002137441}, {61,0.002066351}, {62,0.001957346}, {63,0.002170616}, {64,0.002085308}, {65,0.002161137}, {66,0.002037915}, {67,0.002748815}, {68,0.002236967}, {69,0.002298578}, {70,0.002445498}, {71,0.001985782}, {72,0.002241706}, {73,0.002393365}, {74,0.002360190}, {75,0.002189573}, {76,0.002469194}, {77,0.002317536}, {78,0.002165877}, {79,0.002341232}, {80,0.002464455}, {81,0.002459716}, {82,0.002246445}, {83,0.002454976}, {84,0.002473934}, {85,0.002322275}, {86,0.002284360}, {87,0.002677725}, {88,0.002511848}, {89,0.002417062}, {90,0.002417062}, {91,0.002436019}, {92,0.002582938}, {93,0.002663507}, {94,0.002767773}, {95,0.002478673}, {96,0.002639810}, {97,0.002582938}, {98,0.002573460}, {99,0.003336493}, {100,0.002597156}, {101,0.002421801}, {102,0.002611374}, {103,0.002815166}, {104,0.002796209}, {105,0.002706161}, {106,0.002582938}, {107,0.002748815}, {108,0.002857820}, {109,0.002919431}, {110,0.002862559}, {111,0.002819905}, {112,0.002758294}, {113,0.002739336}, {114,0.002796209}, {115,0.002597156}, {116,0.002720379}, {117,0.002781991}, {118,0.002924171}, {119,0.002900474}, {120,0.003042654}, {121,0.002990521}, {122,0.002838863}, {123,0.003052133}, {124,0.003090047}, {125,0.003037915}, {126,0.003459716}, {127,0.002981043}, {128,0.002900474}, {129,0.002876777}, {130,0.003056872}, {131,0.003137441}, {132,0.003109005}, {133,0.003061611}, {134,0.003350711}, {135,0.003232227}, {136,0.003284360}, {137,0.003170616}, {138,0.003208531}, {139,0.003180095}, {140,0.003279621}, {141,0.003331754}, {142,0.003331754}, {143,0.003331754}, {144,0.003251185}, {145,0.003303318}, {146,0.003161137}, {147,0.003312796}, {148,0.003402844}, {149,0.004137441}, {150,0.003312796}, {151,0.003454976}, {152,0.003407583}, {153,0.003379147}, {154,0.003454976}, {155,0.003426540}, {156,0.003341232}, {157,0.003507109}, {158,0.003578199}, {159,0.003582938}, {160,0.003521327}, {161,0.003563981}, {162,0.003563981}, {163,0.003635071}, {164,0.003587678}, {165,0.003549763}, {166,0.003710900}, {167,0.003563981}, {168,0.003597156}, {169,0.003668246}, {170,0.004663507}, {171,0.003739336}, {172,0.003635071}, {173,0.003838863}, {174,0.003677725}, {175,0.003772512}, {176,0.003829384}, {177,0.003943128}, {178,0.003725118}, {179,0.003706161}, {180,0.003900474}, {181,0.003791469}, {182,0.003800948}, {183,0.003848341}, {184,0.003872038}, {185,0.003890995}, {186,0.003834123}, {187,0.003862559}, {188,0.003985782}, {189,0.004407583}, {190,0.004417062}, {191,0.003938389}, {192,0.004009479}, {193,0.003909953}, {194,0.003933649}, {195,0.003990521}, {196,0.004066351}, {197,0.004014218}, {198,0.004033175}, {199,0.004127962}, {200,0.004052133}, {201,0.003976303}, {202,0.004208531}, {203,0.004052133}, {204,0.004303318}, {205,0.004213270}, {206,0.004218009}, {207,0.004540284}, {208,0.004113744}, {209,0.005090047}, {210,0.004161137}, {211,0.004322275}, {212,0.004308057}, {213,0.004218009}, {214,0.004218009}, {215,0.004303318}, {216,0.004421801}, {217,0.004412322}, {218,0.004270142}, {219,0.004454976}, {220,0.004151659}, {221,0.004611374}, {222,0.004473934}, {223,0.005113744}, {224,0.004502370}, {225,0.004620853}, {226,0.004104265}, {227,0.005132701}, {228,0.004317536}, {229,0.004421801}, {230,0.004644550}, {231,0.004412322}, {232,0.004473934}, {233,0.004620853}, {234,0.004672986}, {235,0.004620853}, {236,0.004568720}, {237,0.004706161}, {238,0.004706161}, {239,0.005374408}, {240,0.004696682}, {241,0.004635071}, {242,0.004625592}, {243,0.005204762}, {244,0.004523810}, {245,0.004800000}, {246,0.004880952}, {247,0.004623810}, {248,0.004742857}, {249,0.004595238}, {250,0.004871429}, {251,0.004785714}, {252,0.004828571}, {253,0.004719048}, {254,0.005728571}, {255,0.004928571}, {256,0.004857143}, {257,0.004900000}, {258,0.004904762}, {259,0.005647619}, {260,0.004909524}, {261,0.005247619}, {262,0.004857143}, {263,0.005138095}, {264,0.004990476}, {265,0.004966667}, {266,0.004776190}, {267,0.004995238}, {268,0.005723810}, {269,0.004971429}, {270,0.004942857}, {271,0.005133333}, {272,0.005523810}, {273,0.004752381}, {274,0.005719048}, {275,0.005480952}, {276,0.004880952}, {277,0.005442857}, {278,0.004980952}, {279,0.005247619}, {280,0.005300000}, {281,0.005176190}, {282,0.005819048}, {283,0.005390476}, {284,0.005328571}, {285,0.005285714}, {286,0.005533333}, {287,0.005323810}, {288,0.005319048}, {289,0.005295238}, {290,0.005523810}, {291,0.005409524}, {292,0.005342857}, {293,0.005709524}, {294,0.005433333}, {295,0.006338095}, {296,0.005547619}, {297,0.005400000}, {298,0.005495238}, {299,0.005338095}, {300,0.005609524}, {301,0.005747619}, {302,0.005995238}, {303,0.005461905}, {304,0.005671429}, {305,0.005590476}, {306,0.005500000}, {307,0.005819048}, {308,0.006304762}, {309,0.005866667}, {310,0.005600000}, {311,0.005585714}, {312,0.005533333}, {313,0.005590476}, {314,0.005890476}, {315,0.005752381}, {316,0.006042857}, {317,0.005704762}, {318,0.005738095}, {319,0.005885714}, {320,0.006133333}, {321,0.005995238}, {322,0.005919048}, {323,0.005842857}, {324,0.006052381}, {325,0.005880952}, {326,0.005928571}, {327,0.005795238}, {328,0.005938095}, {329,0.005880952}, {330,0.006228571}, {331,0.006161905}, {332,0.006142857}, {333,0.006023810}, {334,0.006133333}, {335,0.006109524}, {336,0.006114286}, {337,0.006019048}, {338,0.006185714}, {339,0.006095238}, {340,0.006114286}, {341,0.007042857}, {342,0.006161905}, {343,0.006680952}, {344,0.006390476}, {345,0.006238095}, {346,0.006261905}, {347,0.006309524}, {348,0.006366667}, {349,0.006200000}, {350,0.006190476}, {351,0.006185714}, {352,0.006242857}, {353,0.007157143}, {354,0.007328571}, {355,0.006142857}, {356,0.006204762}, {357,0.006328571}, {358,0.006423810}, {359,0.006423810}, {360,0.006476190}, {361,0.006561905}, {362,0.006519048}, {363,0.006361905}, {364,0.006595238}, {365,0.007838095}, {366,0.006266667}, {367,0.006738095}, {368,0.006619048}, {369,0.006504762}, {370,0.006509524}, {371,0.006547619}, {372,0.006628571}, {373,0.006547619}, {374,0.006538095}, {375,0.006580952}, {376,0.008214286}, {377,0.006723810}, {378,0.006752381}, {379,0.006804762}, {380,0.006838095}, {381,0.006785714}, {382,0.006595238}, {383,0.006647619}, {384,0.006804762}, {385,0.006704762}, {386,0.007947619}, {387,0.007195238}, {388,0.006680952}, {389,0.006628571}, {390,0.006828571}, {391,0.007023810}, {392,0.006861905}, {393,0.006942857}, {394,0.006947619}, {395,0.006847619}, {396,0.007704762}, {397,0.006976190}, {398,0.007671429}, {399,0.006861905}, {400,0.006966667}, {401,0.007133333}, {402,0.006919048}, {403,0.007061905}, {404,0.007161905}, {405,0.006976190}, {406,0.008157143}, {407,0.007090476}, {408,0.007100000}, {409,0.007580952}, {410,0.007247619}, {411,0.007195238}, {412,0.007176190}, {413,0.007000000}, {414,0.007204762}, {415,0.007138095}, {416,0.008285714}, {417,0.007142857}, {418,0.007319048}, {419,0.007933333}, {420,0.007128571}, {421,0.007290476}, {422,0.007190476}, {423,0.007285714}, {424,0.007552381}, {425,0.007228571}, {426,0.007514286}, {427,0.007238095}, {428,0.007333333}, {429,0.008261905}, {430,0.007442857}, {431,0.007400000}, {432,0.007271429}, {433,0.007271429}, {434,0.007533333}, {435,0.008309524}, {436,0.007538095}, {437,0.007685714}, {438,0.007685714}, {439,0.008557143}, {440,0.007471429}, {441,0.007495238}, {442,0.007561905}, {443,0.007819048}, {444,0.009380952}, {445,0.007490476}, {446,0.007838095}, {447,0.007671429}, {448,0.008038095}, {449,0.008557143}, {450,0.007976190}, {451,0.007795238}, {452,0.007885714}, {453,0.009800000}, {454,0.007871429}, {455,0.007885714}, {456,0.007880952}, {457,0.007866667}, {458,0.008047619}, {459,0.008257143}, {460,0.008038095}, {461,0.007904762}, {462,0.008357143}, {463,0.008014286}, {464,0.007928571}, {465,0.007880952}, {466,0.008014286}, {467,0.007880952}, {468,0.009909524}, {469,0.008176190}, {470,0.007785714}, {471,0.008076190}, {472,0.008161905}, {473,0.008176190}, {474,0.008057143}, {475,0.007980952}, {476,0.008500000}, {477,0.009142857}, {478,0.008042857}, {479,0.010204762}, {480,0.008004762}, {481,0.008247619}, {482,0.008257143}, {483,0.008380952}, {484,0.008409524}, {485,0.008385714}, {486,0.008752381}, {487,0.008357143}, {488,0.008290476}, {489,0.008466667}, {490,0.008390476}, {491,0.008528571}, {492,0.008238095}, {493,0.008476190}, {494,0.008666667}, {495,0.009528571}, {496,0.009204762}, {497,0.008814286}, {498,0.008385714}, {499,0.008361905}, {500,0.008609524}, {505,0.008961905}, {510,0.008766667}, {515,0.008604762}, {520,0.009809524}, {525,0.008842857}, {530,0.009057143}, {535,0.009471429}, {540,0.009419048}, {545,0.009709524}, {550,0.009752381}, {555,0.009638095}, {560,0.010980952}, {565,0.009766667}, {570,0.009952381}, {575,0.010185714}, {580,0.010209524}, {585,0.010280952}, {590,0.010414286}, {595,0.011400000}, {600,0.012504762}, {605,0.010638095}, {610,0.010523810}, {615,0.010747619}, {620,0.010714286}, {625,0.010680952}, {630,0.011119048}, {635,0.012219048}, {640,0.010938095}, {645,0.010990476}, {650,0.011304762}, {655,0.011328571}, {660,0.012895238}, {665,0.011542857}, {670,0.012561905}, {675,0.011890476}, {680,0.011890476}, {685,0.011766667}, {690,0.013238095}, {695,0.011880952}, {700,0.012180952}, {705,0.012523810}, {710,0.012114286}, {715,0.012461905}, {720,0.013514286}, {725,0.012509524}, {730,0.012595238}, {735,0.013780952}, {740,0.012690476}, {745,0.012576190}, {750,0.014280952}, {755,0.013214286}, {760,0.013080952}, {765,0.013919048}, {770,0.013171429}, {775,0.013323810}, {780,0.013195238}, {785,0.013395238}, {790,0.013385714}, {795,0.015000000}, {800,0.013704762}, {805,0.014385714}, {810,0.013800000}, {815,0.013857143}, {820,0.014109524}, {825,0.014552381}, {830,0.016695238}, {835,0.014185714}, {840,0.014357143}, {845,0.014466667}, {850,0.015252381}, {855,0.015933333}, {860,0.014495238}, {865,0.014609524}, {870,0.014604762}, {875,0.014680952}, {880,0.017909524}, {885,0.015004762}, {890,0.015028571}, {895,0.015014286}, {900,0.015190476}, {905,0.016700000}, {910,0.015109524}, {915,0.015314286}, {920,0.015404762}, {925,0.015642857}, {930,0.015933333}, {935,0.015904762}, {940,0.015871429}, {945,0.015895238}, {950,0.017185714}, {955,0.016338095}, {960,0.016157143}, {965,0.016190476}, {970,0.016271429}, {975,0.016938095}, {980,0.016752381}, {985,0.016595238}, {990,0.016476190}, {995,0.019500000}, {1000,0.017966667}, {1010,0.016642857}, {1020,0.016857143}, {1030,0.019142857}, {1040,0.017176190}, {1050,0.018090476}, {1060,0.017690476}, {1070,0.019904762}, {1080,0.017890476}, {1090,0.019238095}, {1100,0.018419048}, {1110,0.020638095}, {1120,0.018419048}, {1130,0.020452381}, {1140,0.019133333}, {1150,0.021366667}, {1160,0.019480952}, {1170,0.019590476}, {1180,0.019966667}, {1190,0.021323810}, {1200,0.020076190}, {1210,0.022266667}, {1220,0.022990476}, {1230,0.020757143}, {1240,0.020942857}, {1250,0.023033333}, {1260,0.024571429}, {1270,0.021771429}, {1280,0.021828571}, {1290,0.026233333}, {1300,0.022257143}, {1310,0.022442857}, {1320,0.022619048}, {1330,0.025104762}, {1340,0.022947619}, {1350,0.022771429}, {1360,0.029609524}, {1370,0.023542857}, {1380,0.023571429}, {1390,0.025252381}, {1400,0.023933333}, {1410,0.023923810}, {1420,0.026300000}, {1430,0.026428571}, {1440,0.025266667}, {1450,0.027419048}, {1460,0.027471429}, {1470,0.025528571}, {1480,0.027576190}, {1490,0.028619048}, {1500,0.026247619}, {1510,0.027947619}, {1520,0.026519048}, {1530,0.026604762}, {1540,0.028814286}, {1550,0.027114286}, {1560,0.028185714}, {1570,0.031428571}, {1580,0.027661905}, {1590,0.028019048}, {1600,0.029880952}, {1610,0.028276190}, {1620,0.032147619}, {1630,0.028614286}, {1640,0.028880952}, {1650,0.029695238}, {1660,0.029414286}, {1670,0.031595238}, {1680,0.030904762}, {1690,0.029852381}, {1700,0.034500000}, {1710,0.030452381}, {1720,0.030395238}, {1730,0.040033333}, {1740,0.030742857}, {1750,0.031161905}, {1760,0.032114286}, {1770,0.031647619}, {1780,0.037566667}, {1790,0.031838095}, {1800,0.033452381}, {1810,0.037519048}, {1820,0.032571429}, {1830,0.035542857}, {1840,0.033790476}, {1850,0.035928571}, {1860,0.036047619}, {1870,0.033542857}, {1880,0.035176190}, {1890,0.035319048}, {1900,0.038800000}, {1910,0.037261905}, {1920,0.038071429}, {1930,0.034861905}, {1940,0.036366667}, {1950,0.036109524}, {1960,0.039995238}, {1970,0.038495238}, {1980,0.035838095}, {1990,0.039838095}, {2000,0.036180952}, {2050,0.042171429}, {2100,0.038019048}, {2150,0.046285714}, {2200,0.041023810}, {2250,0.045623810}, {2300,0.043980952}, {2350,0.047700000}, {2400,0.046566667}, {2450,0.047366667}, {2500,0.048557143}, {2550,0.056752381}, {2600,0.050638095}, {2650,0.056509524}, {2700,0.054847619}, {2750,0.056228571}, {2800,0.059438095}, {2850,0.058880952}, {2900,0.057723810}, {2950,0.064047619}, {3000,0.062609524}, {3050,0.062914286}, {3100,0.072833333}, {3150,0.068819048}, {3200,0.064971429}, {3250,0.072476190}, {3300,0.076614286}, {3350,0.068690476}, {3400,0.074242857}, {3450,0.080300000}, {3500,0.074104762}, {3550,0.082428571}, {3600,0.082814286}, {3650,0.083623810}, {3700,0.085719048}, {3750,0.073914286}, {3800,0.088461905}, {3850,0.086433333}, {3900,0.088800000}, {3950,0.086357143}, {4000,0.088919048}, {4050,0.097038095}, {4100,0.109880952}, {4150,0.100285714}, {4200,0.092819048}, {4250,0.092171429}, {4300,0.097314286}, {4350,0.101304762}, {4400,0.103495238}, {4450,0.105852381}, {4500,0.117195238}, {4550,0.115019048}, {4600,0.108190476}, {4650,0.108538095}, {4700,0.108728571}, {4750,0.110180952}, {4800,0.105461905}, {4850,0.115328571}, {4900,0.126095238}, {4950,0.128295238}, {5000,0.119000000}, {5050,0.121680952}, {5100,0.117766667}, {5150,0.118590476}, {5200,0.123180952}, {5250,0.110957143}, {5300,0.142047619}, {5350,0.131623810}, {5400,0.130904762}, {5450,0.133809524}, {5500,0.118466667}, {5550,0.137619048}, {5600,0.136204762}, {5650,0.142738095}, {5700,0.145428571}, {5750,0.142152381}, {5800,0.140047619}, {5850,0.150066667}, {5900,0.144300000}, {5950,0.150076190}, {6000,0.154142857}, {6050,0.151266667}, {6100,0.147390476}, {6150,0.172095238}, {6200,0.169276190}, {6250,0.156261905}, {6300,0.150176190}, {6350,0.181676190}, {6400,0.161033333}, {6450,0.178290476}, {6500,0.164519048}, {6550,0.149880952}, {6600,0.159528571}, {6650,0.176257143}, {6700,0.169995238}, {6750,0.182447619}, {6800,0.180890476}, {6850,0.176238095}, {6900,0.189333333}, {6950,0.168009524}, {7000,0.166871429}, {7050,0.158076190}, {7100,0.182823810}, {7150,0.203457143}, {7200,0.191523810}, {7250,0.194285714}, {7300,0.175733333}, {7350,0.191252381}, {7400,0.198452381}, {7450,0.188195238}, {7500,0.207352381}, {7550,0.216657143}, {7600,0.188819048}, {7650,0.207304762}, {7700,0.203761905}, {7750,0.183952381}, {7800,0.193880952}, {7850,0.207585714}, {7900,0.207890476}, {7950,0.196514286}, {8000,0.205742857}, {8050,0.218766667}, {8100,0.226128571}, {8150,0.189604762}, {8200,0.218109524}, {8250,0.211047619}, {8300,0.219680952}, {8350,0.229080952}, {8400,0.210528571}, {8450,0.202800000}, {8500,0.220047619}, {8550,0.220342857}, {8600,0.220847619}, {8650,0.240404762}, {8700,0.259019048}, {8750,0.244123810}, {8800,0.230709524}, {8850,0.239033333}, {8900,0.263519048}, {8950,0.242147619}, {9000,0.246428571}, {9050,0.217342857}, {9100,0.229866667}, {9150,0.237133333}, {9200,0.241047619}, {9250,0.274347619}, {9300,0.265876190}, {9350,0.253000000}, {9400,0.272680952}, {9450,0.268071429}, {9500,0.245352381}, {9550,0.252104762}, {9600,0.238957143}, {9650,0.238585714}, {9700,0.224990476}, {9750,0.247314286}, {9800,0.265885714}, {9850,0.285128571}, {9900,0.268166667}, {9950,0.250476190}, {10000,0.225528571}, {10100,0.272676190}, {10200,0.275980952}, {10300,0.247395238}, {10400,0.254447619}, {10500,0.304757143}, {10600,0.313485714}, {10700,0.274509524}, {10800,0.297257143}, {10900,0.260638095}, {11000,0.303147619}, {11100,0.345552381}, {11200,0.260804762}, {11300,0.308966667}, {11400,0.273185714}, {11500,0.346504762}, {11600,0.275633333}, {11700,0.365200000}, {11800,0.369980952}, {11900,0.329019048}, {12000,0.363923810}, {12100,0.316709524}, {12200,0.331304762}, {12300,0.324776190}, {12400,0.387614286}, {12500,0.297319048}, {12600,0.358123810}, {12700,0.392585714}, {12800,0.360228571}, {12900,0.359361905}, {13000,0.278290476}, {13100,0.347952381}, {13200,0.373157143}, {13300,0.335566667}, {13400,0.380014286}, {13500,0.416890476}, {13600,0.414771429}, {13700,0.360471429}, {13800,0.392042857}, {13900,0.407690476}, {14000,0.420838095}, {14100,0.390585714}, {14200,0.376395238}, {14300,0.373404762}, {14400,0.398142857}, {14500,0.386704762}, {14600,0.403585714}, {14700,0.386642857}, {14800,0.398066667}, {14900,0.424157143}, {15000,0.409557143}, {15100,0.358542857}, {15200,0.413719048}, {15300,0.462585714}, {15400,0.403471429}, {15500,0.464014286}, {15600,0.462490476}, {15700,0.480242857}, {15800,0.441985714}, {15900,0.444380952}, {16000,0.471609524}, {16100,0.511990476}, {16200,0.452147619}, {16300,0.509914286}, {16400,0.473180952}, {16500,0.492285714}, {16600,0.523038095}, {16700,0.470533333}, {16800,0.426623810}, {16900,0.500585714}, {17000,0.428023810}, {17100,0.516004762}, {17200,0.478004762}, {17300,0.516371429}, {17400,0.472276190}, {17500,0.477271429}, {17600,0.486428571}, {17700,0.506933333}, {17800,0.469090476}, {17900,0.523823810}, {18000,0.527142857}, {18100,0.493452381}, {18200,0.536800000}, {18300,0.540704762}, {18400,0.516628571}, {18500,0.529833333}, {18600,0.547361905}, {18700,0.558023810}, {18800,0.549914286}, {18900,0.487961905}, {19000,0.554595238}, {19100,0.584171429}, {19200,0.574190476}, {19300,0.553438095}, {19400,0.526271429}, {19500,0.594319048}, {19600,0.570090476}, {19700,0.547114286}, {19800,0.575738095}, {19900,0.575071429}, {20000,0.529144231}};
data["big"]["Parametricity; beta"]["Aggregate"]["system"] = {{1,0.000246445}, {2,0.000127962}, {3,0.000056872}, {4,0.000075829}, {5,0.000502370}, {6,0.000037915}, {7,0.000000000}, {8,0.000056872}, {9,0.000075829}, {10,0.000018957}, {11,0.000018957}, {12,0.000018957}, {13,0.000037915}, {14,0.000037915}, {15,0.000037915}, {16,0.000094787}, {17,0.000018957}, {18,0.000018957}, {19,0.000037915}, {20,0.000000000}, {21,0.000037915}, {22,0.000033175}, {23,0.000075829}, {24,0.000317536}, {25,0.000037915}, {26,0.000018957}, {27,0.000037915}, {28,0.000000000}, {29,0.000018957}, {30,0.000018957}, {31,0.000000000}, {32,0.000018957}, {33,0.000000000}, {34,0.000018957}, {35,0.000000000}, {36,0.000056872}, {37,0.000018957}, {38,0.000037915}, {39,0.000000000}, {40,0.000018957}, {41,0.000056872}, {42,0.000033175}, {43,0.000052133}, {44,0.000056872}, {45,0.000033175}, {46,0.000000000}, {47,0.000000000}, {48,0.000056872}, {49,0.000071090}, {50,0.000075829}, {51,0.000056872}, {52,0.000037915}, {53,0.000094787}, {54,0.000094787}, {55,0.000037915}, {56,0.000018957}, {57,0.000056872}, {58,0.000037915}, {59,0.000018957}, {60,0.000075829}, {61,0.000018957}, {62,0.000037915}, {63,0.000018957}, {64,0.000033175}, {65,0.000000000}, {66,0.000037915}, {67,0.000018957}, {68,0.000018957}, {69,0.000037915}, {70,0.000000000}, {71,0.000000000}, {72,0.000056872}, {73,0.000056872}, {74,0.000014218}, {75,0.000018957}, {76,0.000056872}, {77,0.000037915}, {78,0.000000000}, {79,0.000056872}, {80,0.000018957}, {81,0.000018957}, {82,0.000018957}, {83,0.000056872}, {84,0.000000000}, {85,0.000056872}, {86,0.000052133}, {87,0.000037915}, {88,0.000033175}, {89,0.000056872}, {90,0.000094787}, {91,0.000094787}, {92,0.000018957}, {93,0.000037915}, {94,0.000018957}, {95,0.000066351}, {96,0.000056872}, {97,0.000037915}, {98,0.000018957}, {99,0.000037915}, {100,0.000037915}, {101,0.000018957}, {102,0.000018957}, {103,0.000018957}, {104,0.000037915}, {105,0.000033175}, {106,0.000075829}, {107,0.000075829}, {108,0.000037915}, {109,0.000018957}, {110,0.000075829}, {111,0.000037915}, {112,0.000018957}, {113,0.000018957}, {114,0.000018957}, {115,0.000018957}, {116,0.000037915}, {117,0.000000000}, {118,0.000000000}, {119,0.000037915}, {120,0.000000000}, {121,0.000000000}, {122,0.000071090}, {123,0.000037915}, {124,0.000037915}, {125,0.000075829}, {126,0.000052133}, {127,0.000033175}, {128,0.000075829}, {129,0.000037915}, {130,0.000014218}, {131,0.000075829}, {132,0.000000000}, {133,0.000000000}, {134,0.000018957}, {135,0.000000000}, {136,0.000018957}, {137,0.000037915}, {138,0.000037915}, {139,0.000018957}, {140,0.000056872}, {141,0.000052133}, {142,0.000000000}, {143,0.000018957}, {144,0.000037915}, {145,0.000075829}, {146,0.000056872}, {147,0.000075829}, {148,0.000037915}, {149,0.000075829}, {150,0.000094787}, {151,0.000056872}, {152,0.000000000}, {153,0.000033175}, {154,0.000037915}, {155,0.000014218}, {156,0.000056872}, {157,0.000018957}, {158,0.000075829}, {159,0.000037915}, {160,0.000056872}, {161,0.000018957}, {162,0.000014218}, {163,0.000018957}, {164,0.000037915}, {165,0.000090047}, {166,0.000018957}, {167,0.000071090}, {168,0.000056872}, {169,0.000018957}, {170,0.000052133}, {171,0.000037915}, {172,0.000056872}, {173,0.000037915}, {174,0.000037915}, {175,0.000075829}, {176,0.000056872}, {177,0.000037915}, {178,0.000037915}, {179,0.000037915}, {180,0.000037915}, {181,0.000037915}, {182,0.000037915}, {183,0.000000000}, {184,0.000090047}, {185,0.000056872}, {186,0.000075829}, {187,0.000075829}, {188,0.000018957}, {189,0.000123223}, {190,0.000018957}, {191,0.000018957}, {192,0.000075829}, {193,0.000018957}, {194,0.000109005}, {195,0.000018957}, {196,0.000056872}, {197,0.000033175}, {198,0.000056872}, {199,0.000018957}, {200,0.000075829}, {201,0.000056872}, {202,0.000000000}, {203,0.000052133}, {204,0.000037915}, {205,0.000056872}, {206,0.000075829}, {207,0.000075829}, {208,0.000056872}, {209,0.000075829}, {210,0.000075829}, {211,0.000018957}, {212,0.000132701}, {213,0.000090047}, {214,0.000094787}, {215,0.000037915}, {216,0.000000000}, {217,0.000037915}, {218,0.000014218}, {219,0.000056872}, {220,0.000090047}, {221,0.000018957}, {222,0.000018957}, {223,0.000037915}, {224,0.000037915}, {225,0.000000000}, {226,0.000094787}, {227,0.000075829}, {228,0.000056872}, {229,0.000075829}, {230,0.000052133}, {231,0.000037915}, {232,0.000075829}, {233,0.000071090}, {234,0.000000000}, {235,0.000037915}, {236,0.000056872}, {237,0.000037915}, {238,0.000000000}, {239,0.000037915}, {240,0.000037915}, {241,0.000037915}, {242,0.000056872}, {243,0.000019048}, {244,0.000052381}, {245,0.000038095}, {246,0.000019048}, {247,0.000090476}, {248,0.000095238}, {249,0.000076190}, {250,0.000038095}, {251,0.000019048}, {252,0.000057143}, {253,0.000076190}, {254,0.000038095}, {255,0.000052381}, {256,0.000038095}, {257,0.000057143}, {258,0.000000000}, {259,0.000095238}, {260,0.000019048}, {261,0.000052381}, {262,0.000038095}, {263,0.000038095}, {264,0.000071429}, {265,0.000000000}, {266,0.000057143}, {267,0.000019048}, {268,0.000104762}, {269,0.000076190}, {270,0.000019048}, {271,0.000038095}, {272,0.000076190}, {273,0.000038095}, {274,0.000128571}, {275,0.000133333}, {276,0.000057143}, {277,0.000019048}, {278,0.000095238}, {279,0.000019048}, {280,0.000000000}, {281,0.000038095}, {282,0.000019048}, {283,0.000038095}, {284,0.000057143}, {285,0.000038095}, {286,0.000038095}, {287,0.000052381}, {288,0.000095238}, {289,0.000076190}, {290,0.000019048}, {291,0.000019048}, {292,0.000095238}, {293,0.000038095}, {294,0.000038095}, {295,0.000114286}, {296,0.000076190}, {297,0.000133333}, {298,0.000076190}, {299,0.000076190}, {300,0.000057143}, {301,0.000038095}, {302,0.000076190}, {303,0.000038095}, {304,0.000038095}, {305,0.000038095}, {306,0.000038095}, {307,0.000038095}, {308,0.000095238}, {309,0.000052381}, {310,0.000019048}, {311,0.000019048}, {312,0.000095238}, {313,0.000095238}, {314,0.000057143}, {315,0.000019048}, {316,0.000076190}, {317,0.000109524}, {318,0.000019048}, {319,0.000109524}, {320,0.000071429}, {321,0.000019048}, {322,0.000000000}, {323,0.000019048}, {324,0.000038095}, {325,0.000095238}, {326,0.000019048}, {327,0.000128571}, {328,0.000038095}, {329,0.000057143}, {330,0.000095238}, {331,0.000033333}, {332,0.000057143}, {333,0.000057143}, {334,0.000076190}, {335,0.000076190}, {336,0.000052381}, {337,0.000038095}, {338,0.000038095}, {339,0.000019048}, {340,0.000038095}, {341,0.000019048}, {342,0.000000000}, {343,0.000071429}, {344,0.000057143}, {345,0.000057143}, {346,0.000019048}, {347,0.000019048}, {348,0.000052381}, {349,0.000014286}, {350,0.000019048}, {351,0.000095238}, {352,0.000033333}, {353,0.000128571}, {354,0.000114286}, {355,0.000095238}, {356,0.000076190}, {357,0.000000000}, {358,0.000057143}, {359,0.000033333}, {360,0.000095238}, {361,0.000057143}, {362,0.000038095}, {363,0.000038095}, {364,0.000038095}, {365,0.000052381}, {366,0.000095238}, {367,0.000019048}, {368,0.000038095}, {369,0.000057143}, {370,0.000052381}, {371,0.000038095}, {372,0.000038095}, {373,0.000038095}, {374,0.000095238}, {375,0.000076190}, {376,0.000152381}, {377,0.000014286}, {378,0.000057143}, {379,0.000014286}, {380,0.000019048}, {381,0.000057143}, {382,0.000095238}, {383,0.000057143}, {384,0.000019048}, {385,0.000038095}, {386,0.000128571}, {387,0.000166667}, {388,0.000090476}, {389,0.000038095}, {390,0.000057143}, {391,0.000019048}, {392,0.000057143}, {393,0.000038095}, {394,0.000014286}, {395,0.000057143}, {396,0.000133333}, {397,0.000076190}, {398,0.000095238}, {399,0.000033333}, {400,0.000019048}, {401,0.000019048}, {402,0.000095238}, {403,0.000038095}, {404,0.000019048}, {405,0.000071429}, {406,0.000057143}, {407,0.000052381}, {408,0.000076190}, {409,0.000057143}, {410,0.000052381}, {411,0.000019048}, {412,0.000038095}, {413,0.000038095}, {414,0.000076190}, {415,0.000095238}, {416,0.000057143}, {417,0.000085714}, {418,0.000114286}, {419,0.000076190}, {420,0.000057143}, {421,0.000038095}, {422,0.000109524}, {423,0.000057143}, {424,0.000052381}, {425,0.000057143}, {426,0.000019048}, {427,0.000038095}, {428,0.000019048}, {429,0.000057143}, {430,0.000057143}, {431,0.000038095}, {432,0.000133333}, {433,0.000095238}, {434,0.000057143}, {435,0.000076190}, {436,0.000057143}, {437,0.000000000}, {438,0.000057143}, {439,0.000076190}, {440,0.000095238}, {441,0.000076190}, {442,0.000057143}, {443,0.000019048}, {444,0.000166667}, {445,0.000019048}, {446,0.000057143}, {447,0.000076190}, {448,0.000057143}, {449,0.000057143}, {450,0.000038095}, {451,0.000071429}, {452,0.000095238}, {453,0.000114286}, {454,0.000038095}, {455,0.000076190}, {456,0.000057143}, {457,0.000052381}, {458,0.000038095}, {459,0.000152381}, {460,0.000057143}, {461,0.000076190}, {462,0.000095238}, {463,0.000038095}, {464,0.000038095}, {465,0.000133333}, {466,0.000052381}, {467,0.000095238}, {468,0.000133333}, {469,0.000038095}, {470,0.000166667}, {471,0.000114286}, {472,0.000095238}, {473,0.000076190}, {474,0.000076190}, {475,0.000071429}, {476,0.000019048}, {477,0.000133333}, {478,0.000171429}, {479,0.000114286}, {480,0.000076190}, {481,0.000076190}, {482,0.000019048}, {483,0.000057143}, {484,0.000057143}, {485,0.000128571}, {486,0.000071429}, {487,0.000095238}, {488,0.000076190}, {489,0.000095238}, {490,0.000038095}, {491,0.000114286}, {492,0.000114286}, {493,0.000095238}, {494,0.000000000}, {495,0.000109524}, {496,0.000071429}, {497,0.000038095}, {498,0.000133333}, {499,0.000038095}, {500,0.000109524}, {505,0.000114286}, {510,0.000038095}, {515,0.000095238}, {520,0.000114286}, {525,0.000052381}, {530,0.000019048}, {535,0.000000000}, {540,0.000076190}, {545,0.000014286}, {550,0.000057143}, {555,0.000019048}, {560,0.000057143}, {565,0.000147619}, {570,0.000114286}, {575,0.000095238}, {580,0.000038095}, {585,0.000076190}, {590,0.000000000}, {595,0.000057143}, {600,0.000076190}, {605,0.000095238}, {610,0.000076190}, {615,0.000076190}, {620,0.000114286}, {625,0.000090476}, {630,0.000038095}, {635,0.000109524}, {640,0.000019048}, {645,0.000076190}, {650,0.000019048}, {655,0.000095238}, {660,0.000038095}, {665,0.000095238}, {670,0.000114286}, {675,0.000076190}, {680,0.000128571}, {685,0.000057143}, {690,0.000133333}, {695,0.000114286}, {700,0.000095238}, {705,0.000114286}, {710,0.000095238}, {715,0.000095238}, {720,0.000152381}, {725,0.000114286}, {730,0.000038095}, {735,0.000133333}, {740,0.000114286}, {745,0.000152381}, {750,0.000114286}, {755,0.000038095}, {760,0.000057143}, {765,0.000071429}, {770,0.000190476}, {775,0.000076190}, {780,0.000171429}, {785,0.000033333}, {790,0.000095238}, {795,0.000190476}, {800,0.000038095}, {805,0.000076190}, {810,0.000019048}, {815,0.000057143}, {820,0.000076190}, {825,0.000095238}, {830,0.000185714}, {835,0.000076190}, {840,0.000090476}, {845,0.000095238}, {850,0.000171429}, {855,0.000095238}, {860,0.000185714}, {865,0.000109524}, {870,0.000090476}, {875,0.000071429}, {880,0.000223810}, {885,0.000000000}, {890,0.000071429}, {895,0.000152381}, {900,0.000057143}, {905,0.000114286}, {910,0.000133333}, {915,0.000038095}, {920,0.000057143}, {925,0.000090476}, {930,0.000171429}, {935,0.000000000}, {940,0.000095238}, {945,0.000090476}, {950,0.000090476}, {955,0.000076190}, {960,0.000057143}, {965,0.000052381}, {970,0.000038095}, {975,0.000090476}, {980,0.000038095}, {985,0.000057143}, {990,0.000090476}, {995,0.000114286}, {1000,0.000152381}, {1010,0.000152381}, {1020,0.000109524}, {1030,0.000161905}, {1040,0.000057143}, {1050,0.000133333}, {1060,0.000076190}, {1070,0.000190476}, {1080,0.000095238}, {1090,0.000076190}, {1100,0.000052381}, {1110,0.000147619}, {1120,0.000095238}, {1130,0.000147619}, {1140,0.000085714}, {1150,0.000133333}, {1160,0.000076190}, {1170,0.000076190}, {1180,0.000095238}, {1190,0.000052381}, {1200,0.000095238}, {1210,0.000171429}, {1220,0.000161905}, {1230,0.000057143}, {1240,0.000128571}, {1250,0.000185714}, {1260,0.000057143}, {1270,0.000114286}, {1280,0.000114286}, {1290,0.000128571}, {1300,0.000114286}, {1310,0.000057143}, {1320,0.000095238}, {1330,0.000095238}, {1340,0.000076190}, {1350,0.000114286}, {1360,0.000414286}, {1370,0.000076190}, {1380,0.000076190}, {1390,0.000057143}, {1400,0.000057143}, {1410,0.000114286}, {1420,0.000152381}, {1430,0.000095238}, {1440,0.000057143}, {1450,0.000166667}, {1460,0.000128571}, {1470,0.000152381}, {1480,0.000114286}, {1490,0.000095238}, {1500,0.000052381}, {1510,0.000190476}, {1520,0.000095238}, {1530,0.000114286}, {1540,0.000280952}, {1550,0.000076190}, {1560,0.000038095}, {1570,0.000247619}, {1580,0.000114286}, {1590,0.000095238}, {1600,0.000057143}, {1610,0.000109524}, {1620,0.000095238}, {1630,0.000114286}, {1640,0.000038095}, {1650,0.000114286}, {1660,0.000166667}, {1670,0.000142857}, {1680,0.000152381}, {1690,0.000057143}, {1700,0.000171429}, {1710,0.000166667}, {1720,0.000114286}, {1730,0.000452381}, {1740,0.000057143}, {1750,0.000076190}, {1760,0.000166667}, {1770,0.000000000}, {1780,0.000300000}, {1790,0.000090476}, {1800,0.000133333}, {1810,0.000304762}, {1820,0.000128571}, {1830,0.000152381}, {1840,0.000228571}, {1850,0.000190476}, {1860,0.000076190}, {1870,0.000057143}, {1880,0.000076190}, {1890,0.000204762}, {1900,0.000133333}, {1910,0.000095238}, {1920,0.000261905}, {1930,0.000095238}, {1940,0.000161905}, {1950,0.000128571}, {1960,0.000171429}, {1970,0.000152381}, {1980,0.000152381}, {1990,0.000209524}, {2000,0.000114286}, {2050,0.000147619}, {2100,0.000171429}, {2150,0.000242857}, {2200,0.000038095}, {2250,0.000114286}, {2300,0.000171429}, {2350,0.000314286}, {2400,0.000166667}, {2450,0.000109524}, {2500,0.000109524}, {2550,0.000247619}, {2600,0.000209524}, {2650,0.000338095}, {2700,0.000219048}, {2750,0.000128571}, {2800,0.000247619}, {2850,0.000152381}, {2900,0.000204762}, {2950,0.000300000}, {3000,0.000261905}, {3050,0.000076190}, {3100,0.000457143}, {3150,0.000223810}, {3200,0.000038095}, {3250,0.000214286}, {3300,0.000285714}, {3350,0.000090476}, {3400,0.000228571}, {3450,0.000209524}, {3500,0.000200000}, {3550,0.000304762}, {3600,0.000476190}, {3650,0.000533333}, {3700,0.000357143}, {3750,0.000300000}, {3800,0.000528571}, {3850,0.000223810}, {3900,0.000338095}, {3950,0.000185714}, {4000,0.000357143}, {4050,0.000514286}, {4100,0.000657143}, {4150,0.000609524}, {4200,0.000390476}, {4250,0.000242857}, {4300,0.000423810}, {4350,0.000433333}, {4400,0.000419048}, {4450,0.000728571}, {4500,0.000619048}, {4550,0.000680952}, {4600,0.000385714}, {4650,0.000695238}, {4700,0.000409524}, {4750,0.000542857}, {4800,0.000376190}, {4850,0.000447619}, {4900,0.000485714}, {4950,0.000528571}, {5000,0.000604762}, {5050,0.000419048}, {5100,0.000428571}, {5150,0.000623810}, {5200,0.000490476}, {5250,0.000414286}, {5300,0.000680952}, {5350,0.000457143}, {5400,0.000280952}, {5450,0.000333333}, {5500,0.000395238}, {5550,0.000452381}, {5600,0.000514286}, {5650,0.000476190}, {5700,0.000428571}, {5750,0.000433333}, {5800,0.000261905}, {5850,0.000333333}, {5900,0.000419048}, {5950,0.000319048}, {6000,0.000323810}, {6050,0.000371429}, {6100,0.000395238}, {6150,0.000638095}, {6200,0.000185714}, {6250,0.000300000}, {6300,0.000314286}, {6350,0.000566667}, {6400,0.000204762}, {6450,0.000414286}, {6500,0.000566667}, {6550,0.000242857}, {6600,0.000461905}, {6650,0.000395238}, {6700,0.000395238}, {6750,0.000738095}, {6800,0.000733333}, {6850,0.000542857}, {6900,0.000800000}, {6950,0.000414286}, {7000,0.000342857}, {7050,0.000780952}, {7100,0.000876190}, {7150,0.000938095}, {7200,0.000847619}, {7250,0.000895238}, {7300,0.000738095}, {7350,0.000738095}, {7400,0.000919048}, {7450,0.000680952}, {7500,0.000923810}, {7550,0.001114286}, {7600,0.000742857}, {7650,0.001019048}, {7700,0.000866667}, {7750,0.000666667}, {7800,0.000428571}, {7850,0.001209524}, {7900,0.000976190}, {7950,0.000842857}, {8000,0.000638095}, {8050,0.000628571}, {8100,0.001071429}, {8150,0.000680952}, {8200,0.000695238}, {8250,0.000652381}, {8300,0.000785714}, {8350,0.000661905}, {8400,0.001000000}, {8450,0.000733333}, {8500,0.000623810}, {8550,0.000909524}, {8600,0.000671429}, {8650,0.000623810}, {8700,0.000438095}, {8750,0.000528571}, {8800,0.000338095}, {8850,0.000390476}, {8900,0.000585714}, {8950,0.000414286}, {9000,0.000419048}, {9050,0.000400000}, {9100,0.000352381}, {9150,0.000323810}, {9200,0.000300000}, {9250,0.000638095}, {9300,0.000685714}, {9350,0.000285714}, {9400,0.000609524}, {9450,0.000409524}, {9500,0.000338095}, {9550,0.000419048}, {9600,0.000376190}, {9650,0.000319048}, {9700,0.000300000}, {9750,0.000285714}, {9800,0.000319048}, {9850,0.000395238}, {9900,0.000338095}, {9950,0.000285714}, {10000,0.000342857}, {10100,0.000342857}, {10200,0.000342857}, {10300,0.000338095}, {10400,0.000533333}, {10500,0.000357143}, {10600,0.000890476}, {10700,0.000600000}, {10800,0.000457143}, {10900,0.000285714}, {11000,0.000690476}, {11100,0.000361905}, {11200,0.000133333}, {11300,0.000128571}, {11400,0.000090476}, {11500,0.000204762}, {11600,0.000266667}, {11700,0.000133333}, {11800,0.001138095}, {11900,0.000947619}, {12000,0.001076190}, {12100,0.001038095}, {12200,0.001233333}, {12300,0.000642857}, {12400,0.001295238}, {12500,0.000742857}, {12600,0.001138095}, {12700,0.001033333}, {12800,0.000476190}, {12900,0.000647619}, {13000,0.000571429}, {13100,0.001109524}, {13200,0.001228571}, {13300,0.000885714}, {13400,0.000776190}, {13500,0.001304762}, {13600,0.000757143}, {13700,0.000357143}, {13800,0.000604762}, {13900,0.000642857}, {14000,0.000128571}, {14100,0.000114286}, {14200,0.000166667}, {14300,0.000223810}, {14400,0.000166667}, {14500,0.000261905}, {14600,0.000171429}, {14700,0.000166667}, {14800,0.000280952}, {14900,0.000204762}, {15000,0.000133333}, {15100,0.000095238}, {15200,0.000180952}, {15300,0.000095238}, {15400,0.000114286}, {15500,0.000095238}, {15600,0.000133333}, {15700,0.000261905}, {15800,0.000142857}, {15900,0.000242857}, {16000,0.000252381}, {16100,0.000190476}, {16200,0.000171429}, {16300,0.000171429}, {16400,0.000190476}, {16500,0.000190476}, {16600,0.000133333}, {16700,0.000190476}, {16800,0.000152381}, {16900,0.000190476}, {17000,0.000114286}, {17100,0.000152381}, {17200,0.000114286}, {17300,0.000147619}, {17400,0.000171429}, {17500,0.000228571}, {17600,0.000204762}, {17700,0.000190476}, {17800,0.000095238}, {17900,0.000190476}, {18000,0.000152381}, {18100,0.000185714}, {18200,0.000190476}, {18300,0.000238095}, {18400,0.000242857}, {18500,0.000152381}, {18600,0.000128571}, {18700,0.000209524}, {18800,0.000190476}, {18900,0.000166667}, {19000,0.000266667}, {19100,0.000133333}, {19200,0.000304762}, {19300,0.000380952}, {19400,0.000285714}, {19500,0.000247619}, {19600,0.000314286}, {19700,0.000390476}, {19800,0.000152381}, {19900,0.000261905}, {20000,0.000153846}};
data["big"]["Parametricity; beta"]["actual reif"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.022000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000004739}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000511848}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.001085308}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000004739}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000004739}, {225,0.000000000}, {226,0.000000000}, {227,0.000004739}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000004739}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000009479}, {240,0.000018957}, {241,0.000014218}, {242,0.000000000}, {243,0.000004739}, {244,0.000009524}, {245,0.000009524}, {246,0.000004762}, {247,0.000000000}, {248,0.000023810}, {249,0.000009524}, {250,0.000028571}, {251,0.000033333}, {252,0.000014286}, {253,0.000038095}, {254,0.000047619}, {255,0.000052381}, {256,0.000061905}, {257,0.000071429}, {258,0.000071429}, {259,0.000080952}, {260,0.000123810}, {261,0.000133333}, {262,0.000114286}, {263,0.000152381}, {264,0.000171429}, {265,0.000195238}, {266,0.000209524}, {267,0.000233333}, {268,0.000257143}, {269,0.000304762}, {270,0.000280952}, {271,0.000295238}, {272,0.000323810}, {273,0.000347619}, {274,0.000342857}, {275,0.000352381}, {276,0.000333333}, {277,0.000395238}, {278,0.000385714}, {279,0.000423810}, {280,0.000414286}, {281,0.000442857}, {282,0.000847619}, {283,0.000476190}, {284,0.000461905}, {285,0.000504762}, {286,0.000523810}, {287,0.000514286}, {288,0.000528571}, {289,0.000538095}, {290,0.000552381}, {291,0.000580952}, {292,0.000614286}, {293,0.000614286}, {294,0.000609524}, {295,0.000661905}, {296,0.000661905}, {297,0.000666667}, {298,0.000714286}, {299,0.000728571}, {300,0.000757143}, {301,0.000752381}, {302,0.000771429}, {303,0.000790476}, {304,0.000823810}, {305,0.000871429}, {306,0.000876190}, {307,0.000890476}, {308,0.000909524}, {309,0.000909524}, {310,0.000914286}, {311,0.000928571}, {312,0.000933333}, {313,0.000928571}, {314,0.000947619}, {315,0.000942857}, {316,0.000971429}, {317,0.000961905}, {318,0.000942857}, {319,0.000947619}, {320,0.001347619}, {321,0.000971429}, {322,0.000971429}, {323,0.000990476}, {324,0.000980952}, {325,0.000985714}, {326,0.000995238}, {327,0.000990476}, {328,0.000995238}, {329,0.001000000}, {330,0.001000000}, {331,0.001000000}, {332,0.001000000}, {333,0.001000000}, {334,0.001000000}, {335,0.001000000}, {336,0.001000000}, {337,0.001000000}, {338,0.001000000}, {339,0.001000000}, {340,0.001000000}, {341,0.001000000}, {342,0.001000000}, {343,0.001000000}, {344,0.001000000}, {345,0.001000000}, {346,0.001000000}, {347,0.001000000}, {348,0.001000000}, {349,0.001000000}, {350,0.001000000}, {351,0.001000000}, {352,0.001000000}, {353,0.001000000}, {354,0.001000000}, {355,0.001000000}, {356,0.001000000}, {357,0.001000000}, {358,0.001000000}, {359,0.001000000}, {360,0.001000000}, {361,0.001000000}, {362,0.001000000}, {363,0.001000000}, {364,0.001000000}, {365,0.001480952}, {366,0.001000000}, {367,0.001000000}, {368,0.001000000}, {369,0.001000000}, {370,0.001000000}, {371,0.001000000}, {372,0.001000000}, {373,0.001000000}, {374,0.001000000}, {375,0.001000000}, {376,0.001000000}, {377,0.001000000}, {378,0.001000000}, {379,0.001000000}, {380,0.001000000}, {381,0.001009524}, {382,0.001000000}, {383,0.001000000}, {384,0.001000000}, {385,0.001000000}, {386,0.001000000}, {387,0.001000000}, {388,0.001000000}, {389,0.001000000}, {390,0.001000000}, {391,0.001000000}, {392,0.001000000}, {393,0.001000000}, {394,0.001000000}, {395,0.001000000}, {396,0.001000000}, {397,0.001000000}, {398,0.001000000}, {399,0.001000000}, {400,0.001000000}, {401,0.001000000}, {402,0.001000000}, {403,0.001000000}, {404,0.001000000}, {405,0.001000000}, {406,0.001000000}, {407,0.001000000}, {408,0.001000000}, {409,0.001471429}, {410,0.001000000}, {411,0.001009524}, {412,0.001019048}, {413,0.001000000}, {414,0.001000000}, {415,0.001000000}, {416,0.001000000}, {417,0.001000000}, {418,0.001000000}, {419,0.001000000}, {420,0.001000000}, {421,0.001000000}, {422,0.001000000}, {423,0.001000000}, {424,0.001000000}, {425,0.001000000}, {426,0.001000000}, {427,0.001000000}, {428,0.001000000}, {429,0.001000000}, {430,0.001000000}, {431,0.001000000}, {432,0.001000000}, {433,0.001000000}, {434,0.001000000}, {435,0.001571429}, {436,0.001000000}, {437,0.001000000}, {438,0.001000000}, {439,0.001000000}, {440,0.001000000}, {441,0.001000000}, {442,0.001000000}, {443,0.001000000}, {444,0.001000000}, {445,0.001000000}, {446,0.001000000}, {447,0.001000000}, {448,0.001000000}, {449,0.001000000}, {450,0.001000000}, {451,0.001000000}, {452,0.001000000}, {453,0.001000000}, {454,0.001000000}, {455,0.001000000}, {456,0.001000000}, {457,0.001000000}, {458,0.001000000}, {459,0.001000000}, {460,0.001000000}, {461,0.001000000}, {462,0.001514286}, {463,0.001000000}, {464,0.001000000}, {465,0.001000000}, {466,0.001000000}, {467,0.001000000}, {468,0.001000000}, {469,0.001000000}, {470,0.001000000}, {471,0.001000000}, {472,0.001000000}, {473,0.001000000}, {474,0.001000000}, {475,0.001000000}, {476,0.001000000}, {477,0.001000000}, {478,0.001000000}, {479,0.001000000}, {480,0.001000000}, {481,0.001000000}, {482,0.001000000}, {483,0.001000000}, {484,0.001000000}, {485,0.001000000}, {486,0.001000000}, {487,0.001000000}, {488,0.001000000}, {489,0.001000000}, {490,0.001000000}, {491,0.001000000}, {492,0.001000000}, {493,0.001000000}, {494,0.001000000}, {495,0.001000000}, {496,0.001509524}, {497,0.001000000}, {498,0.001000000}, {499,0.001000000}, {500,0.001000000}, {505,0.001000000}, {510,0.001000000}, {515,0.001000000}, {520,0.001514286}, {525,0.001000000}, {530,0.001000000}, {535,0.001000000}, {540,0.001000000}, {545,0.001000000}, {550,0.001000000}, {555,0.001000000}, {560,0.001000000}, {565,0.001000000}, {570,0.001000000}, {575,0.001000000}, {580,0.001000000}, {585,0.001000000}, {590,0.001000000}, {595,0.001000000}, {600,0.001000000}, {605,0.001000000}, {610,0.001000000}, {615,0.001000000}, {620,0.001000000}, {625,0.001000000}, {630,0.001000000}, {635,0.001004762}, {640,0.001000000}, {645,0.001000000}, {650,0.001000000}, {655,0.001000000}, {660,0.001004762}, {665,0.001004762}, {670,0.001000000}, {675,0.001004762}, {680,0.001014286}, {685,0.001009524}, {690,0.001028571}, {695,0.001047619}, {700,0.001061905}, {705,0.001790476}, {710,0.001114286}, {715,0.001152381}, {720,0.001214286}, {725,0.001271429}, {730,0.001309524}, {735,0.001366667}, {740,0.001390476}, {745,0.001433333}, {750,0.001461905}, {755,0.001514286}, {760,0.001590476}, {765,0.001638095}, {770,0.001723810}, {775,0.001771429}, {780,0.001833333}, {785,0.001861905}, {790,0.001885714}, {795,0.001890476}, {800,0.001904762}, {805,0.002466667}, {810,0.001933333}, {815,0.001961905}, {820,0.001980952}, {825,0.002538095}, {830,0.002000000}, {835,0.002000000}, {840,0.002000000}, {845,0.002000000}, {850,0.002000000}, {855,0.002000000}, {860,0.002000000}, {865,0.002000000}, {870,0.002000000}, {875,0.002000000}, {880,0.002000000}, {885,0.002000000}, {890,0.002000000}, {895,0.002000000}, {900,0.002000000}, {905,0.003614286}, {910,0.002000000}, {915,0.002000000}, {920,0.002000000}, {925,0.002000000}, {930,0.002500000}, {935,0.002000000}, {940,0.002000000}, {945,0.002000000}, {950,0.002000000}, {955,0.002485714}, {960,0.002000000}, {965,0.002000000}, {970,0.002000000}, {975,0.002000000}, {980,0.002000000}, {985,0.002000000}, {990,0.002000000}, {995,0.002000000}, {1000,0.002000000}, {1010,0.002000000}, {1020,0.002000000}, {1030,0.002000000}, {1040,0.002000000}, {1050,0.002928571}, {1060,0.002000000}, {1070,0.002000000}, {1080,0.002000000}, {1090,0.002004762}, {1100,0.002009524}, {1110,0.002000000}, {1120,0.002004762}, {1130,0.002028571}, {1140,0.002052381}, {1150,0.002066667}, {1160,0.002133333}, {1170,0.002176190}, {1180,0.002223810}, {1190,0.003661905}, {1200,0.002376190}, {1210,0.002395238}, {1220,0.002457143}, {1230,0.002557143}, {1240,0.002685714}, {1250,0.002766667}, {1260,0.002833333}, {1270,0.002842857}, {1280,0.002861905}, {1290,0.002885714}, {1300,0.002904762}, {1310,0.002971429}, {1320,0.003000000}, {1330,0.003000000}, {1340,0.003000000}, {1350,0.003000000}, {1360,0.003000000}, {1370,0.003000000}, {1380,0.003000000}, {1390,0.003000000}, {1400,0.003000000}, {1410,0.003000000}, {1420,0.003000000}, {1430,0.004395238}, {1440,0.003000000}, {1450,0.003000000}, {1460,0.003000000}, {1470,0.003000000}, {1480,0.003004762}, {1490,0.003004762}, {1500,0.003000000}, {1510,0.003014286}, {1520,0.003004762}, {1530,0.003019048}, {1540,0.003014286}, {1550,0.003004762}, {1560,0.003023810}, {1570,0.003042857}, {1580,0.003066667}, {1590,0.003100000}, {1600,0.003019048}, {1610,0.003142857}, {1620,0.003204762}, {1630,0.003252381}, {1640,0.003266667}, {1650,0.003371429}, {1660,0.003376190}, {1670,0.003400000}, {1680,0.004790476}, {1690,0.003509524}, {1700,0.003557143}, {1710,0.003633333}, {1720,0.003714286}, {1730,0.003776190}, {1740,0.003814286}, {1750,0.003876190}, {1760,0.005052381}, {1770,0.003880952}, {1780,0.003885714}, {1790,0.003904762}, {1800,0.003923810}, {1810,0.003966667}, {1820,0.003995238}, {1830,0.003995238}, {1840,0.005014286}, {1850,0.004000000}, {1860,0.004004762}, {1870,0.004000000}, {1880,0.004000000}, {1890,0.005442857}, {1900,0.004009524}, {1910,0.004000000}, {1920,0.004000000}, {1930,0.004004762}, {1940,0.004057143}, {1950,0.004009524}, {1960,0.004019048}, {1970,0.004023810}, {1980,0.004042857}, {1990,0.005547619}, {2000,0.004100000}, {2050,0.004257143}, {2100,0.004328571}, {2150,0.004533333}, {2200,0.004819048}, {2250,0.004885714}, {2300,0.004952381}, {2350,0.005019048}, {2400,0.005076190}, {2450,0.005195238}, {2500,0.005304762}, {2550,0.005409524}, {2600,0.005609524}, {2650,0.005780952}, {2700,0.005895238}, {2750,0.005938095}, {2800,0.006061905}, {2850,0.006214286}, {2900,0.006261905}, {2950,0.006342857}, {3000,0.006514286}, {3050,0.006519048}, {3100,0.008966667}, {3150,0.006966667}, {3200,0.006971429}, {3250,0.009871429}, {3300,0.007252381}, {3350,0.007352381}, {3400,0.010452381}, {3450,0.007547619}, {3500,0.007680952}, {3550,0.007914286}, {3600,0.007995238}, {3650,0.007766667}, {3700,0.008228571}, {3750,0.008304762}, {3800,0.008433333}, {3850,0.008552381}, {3900,0.008623810}, {3950,0.008757143}, {4000,0.011633333}, {4050,0.009114286}, {4100,0.009200000}, {4150,0.009323810}, {4200,0.009419048}, {4250,0.009528571}, {4300,0.009709524}, {4350,0.009880952}, {4400,0.012723810}, {4450,0.010176190}, {4500,0.010285714}, {4550,0.010380952}, {4600,0.010509524}, {4650,0.010642857}, {4700,0.010761905}, {4750,0.010866667}, {4800,0.010966667}, {4850,0.011190476}, {4900,0.011223810}, {4950,0.011352381}, {5000,0.011442857}, {5050,0.019471429}, {5100,0.011742857}, {5150,0.011833333}, {5200,0.012114286}, {5250,0.012119048}, {5300,0.012385714}, {5350,0.021771429}, {5400,0.019895238}, {5450,0.012647619}, {5500,0.012823810}, {5550,0.012876190}, {5600,0.020542857}, {5650,0.013219048}, {5700,0.013495238}, {5750,0.019528571}, {5800,0.022152381}, {5850,0.013714286}, {5900,0.013823810}, {5950,0.013885714}, {6000,0.020823810}, {6050,0.014261905}, {6100,0.014428571}, {6150,0.014566667}, {6200,0.020028571}, {6250,0.021571429}, {6300,0.014919048}, {6350,0.015042857}, {6400,0.019476190}, {6450,0.015261905}, {6500,0.020285714}, {6550,0.022147619}, {6600,0.015823810}, {6650,0.015914286}, {6700,0.023680952}, {6750,0.016104762}, {6800,0.016195238}, {6850,0.016361905}, {6900,0.016576190}, {6950,0.022566667}, {7000,0.016885714}, {7050,0.017171429}, {7100,0.021528571}, {7150,0.017304762}, {7200,0.017300000}, {7250,0.017476190}, {7300,0.017695238}, {7350,0.022866667}, {7400,0.017861905}, {7450,0.018109524}, {7500,0.018219048}, {7550,0.018409524}, {7600,0.018514286}, {7650,0.018609524}, {7700,0.018923810}, {7750,0.023842857}, {7800,0.023833333}, {7850,0.022871429}, {7900,0.019380952}, {7950,0.019419048}, {8000,0.032423810}, {8050,0.019757143}, {8100,0.019990476}, {8150,0.020061905}, {8200,0.023876190}, {8250,0.027433333}, {8300,0.020547619}, {8350,0.020619048}, {8400,0.020900000}, {8450,0.025828571}, {8500,0.024728571}, {8550,0.028119048}, {8600,0.028176190}, {8650,0.027704762}, {8700,0.021657143}, {8750,0.021600000}, {8800,0.021976190}, {8850,0.027200000}, {8900,0.022295238}, {8950,0.022428571}, {9000,0.022633333}, {9050,0.022757143}, {9100,0.022595238}, {9150,0.029885714}, {9200,0.030738095}, {9250,0.023266667}, {9300,0.023433333}, {9350,0.023604762}, {9400,0.023619048}, {9450,0.023580952}, {9500,0.023752381}, {9550,0.023952381}, {9600,0.030738095}, {9650,0.036457143}, {9700,0.030457143}, {9750,0.031295238}, {9800,0.032171429}, {9850,0.033495238}, {9900,0.034023810}, {9950,0.039795238}, {10000,0.031452381}, {10100,0.032080952}, {10200,0.024771429}, {10300,0.034823810}, {10400,0.032938095}, {10500,0.026852381}, {10600,0.026957143}, {10700,0.036242857}, {10800,0.034990476}, {10900,0.042204762}, {11000,0.028052381}, {11100,0.028219048}, {11200,0.045552381}, {11300,0.035538095}, {11400,0.036519048}, {11500,0.029547619}, {11600,0.042733333}, {11700,0.030047619}, {11800,0.039723810}, {11900,0.042061905}, {12000,0.031019048}, {12100,0.045280952}, {12200,0.039652381}, {12300,0.037890476}, {12400,0.031966667}, {12500,0.048319048}, {12600,0.032638095}, {12700,0.031985714}, {12800,0.033476190}, {12900,0.042123810}, {13000,0.051728571}, {13100,0.049804762}, {13200,0.034333333}, {13300,0.045109524}, {13400,0.035085714}, {13500,0.035471429}, {13600,0.032600000}, {13700,0.044595238}, {13800,0.036261905}, {13900,0.036538095}, {14000,0.036866667}, {14100,0.034880952}, {14200,0.056190476}, {14300,0.055161905}, {14400,0.061533333}, {14500,0.044738095}, {14600,0.038571429}, {14700,0.038985714}, {14800,0.052585714}, {14900,0.047785714}, {15000,0.039676190}, {15100,0.047923810}, {15200,0.059852381}, {15300,0.055404762}, {15400,0.059880952}, {15500,0.059785714}, {15600,0.041309524}, {15700,0.053300000}, {15800,0.042176190}, {15900,0.065804762}, {16000,0.049885714}, {16100,0.055966667}, {16200,0.043190476}, {16300,0.066866667}, {16400,0.043595238}, {16500,0.042195238}, {16600,0.066428571}, {16700,0.044442857}, {16800,0.052147619}, {16900,0.058904762}, {17000,0.045409524}, {17100,0.059185714}, {17200,0.052247619}, {17300,0.065838095}, {17400,0.053804762}, {17500,0.060409524}, {17600,0.047176190}, {17700,0.050490476}, {17800,0.060828571}, {17900,0.063285714}, {18000,0.071609524}, {18100,0.058933333}, {18200,0.059785714}, {18300,0.072295238}, {18400,0.070733333}, {18500,0.063414286}, {18600,0.072571429}, {18700,0.065947619}, {18800,0.057923810}, {18900,0.050742857}, {19000,0.051061905}, {19100,0.058504762}, {19200,0.084171429}, {19300,0.072547619}, {19400,0.065366667}, {19500,0.068333333}, {19600,0.069533333}, {19700,0.057961905}, {19800,0.059647619}, {19900,0.067861905}, {20000,0.059057692}};
data["big"]["Parametricity; beta"]["actual reif"]["user"] = {{1,0.000274882}, {2,0.000388626}, {3,0.000104265}, {4,0.000251185}, {5,0.000331754}, {6,0.000218009}, {7,0.000331754}, {8,0.000345972}, {9,0.000393365}, {10,0.000265403}, {11,0.000331754}, {12,0.000327014}, {13,0.000327014}, {14,0.000312796}, {15,0.000402844}, {16,0.000246445}, {17,0.000464455}, {18,0.000398104}, {19,0.000369668}, {20,0.000388626}, {21,0.000407583}, {22,0.000331754}, {23,0.000317536}, {24,0.021881517}, {25,0.000436019}, {26,0.000345972}, {27,0.000445498}, {28,0.000341232}, {29,0.000421801}, {30,0.000279621}, {31,0.000488152}, {32,0.000393365}, {33,0.000526066}, {34,0.000360190}, {35,0.000454976}, {36,0.000417062}, {37,0.000549763}, {38,0.000279621}, {39,0.000274882}, {40,0.000507109}, {41,0.000327014}, {42,0.000436019}, {43,0.000345972}, {44,0.000345972}, {45,0.000464455}, {46,0.000379147}, {47,0.000355450}, {48,0.000473934}, {49,0.000322275}, {50,0.000345972}, {51,0.000502370}, {52,0.000345972}, {53,0.000454976}, {54,0.000492891}, {55,0.000374408}, {56,0.000516588}, {57,0.000616114}, {58,0.000289100}, {59,0.000436019}, {60,0.000554502}, {61,0.000398104}, {62,0.000431280}, {63,0.000469194}, {64,0.000431280}, {65,0.000341232}, {66,0.000469194}, {67,0.000516588}, {68,0.000478673}, {69,0.000587678}, {70,0.000398104}, {71,0.000421801}, {72,0.000431280}, {73,0.000497630}, {74,0.000483412}, {75,0.000459716}, {76,0.000426540}, {77,0.000587678}, {78,0.000388626}, {79,0.000511848}, {80,0.000559242}, {81,0.000464455}, {82,0.000445498}, {83,0.000559242}, {84,0.000654028}, {85,0.000407583}, {86,0.000478673}, {87,0.000445498}, {88,0.000587678}, {89,0.000417062}, {90,0.000473934}, {91,0.000668246}, {92,0.000573460}, {93,0.000549763}, {94,0.000616114}, {95,0.000412322}, {96,0.000440758}, {97,0.000412322}, {98,0.000573460}, {99,0.000478673}, {100,0.000369668}, {101,0.000412322}, {102,0.000402844}, {103,0.000582938}, {104,0.000597156}, {105,0.000511848}, {106,0.000554502}, {107,0.000398104}, {108,0.000469194}, {109,0.000521327}, {110,0.000563981}, {111,0.000412322}, {112,0.000497630}, {113,0.000549763}, {114,0.000658768}, {115,0.000663507}, {116,0.000507109}, {117,0.000691943}, {118,0.000701422}, {119,0.000677725}, {120,0.000578199}, {121,0.000597156}, {122,0.000473934}, {123,0.000635071}, {124,0.000668246}, {125,0.000530806}, {126,0.000909953}, {127,0.000421801}, {128,0.000431280}, {129,0.000421801}, {130,0.000436019}, {131,0.000478673}, {132,0.000431280}, {133,0.000507109}, {134,0.000511848}, {135,0.000497630}, {136,0.000511848}, {137,0.000630332}, {138,0.000758294}, {139,0.000706161}, {140,0.000644550}, {141,0.000649289}, {142,0.000563981}, {143,0.000545024}, {144,0.000587678}, {145,0.000459716}, {146,0.000398104}, {147,0.000483412}, {148,0.000744076}, {149,0.000739336}, {150,0.000701422}, {151,0.000578199}, {152,0.000559242}, {153,0.000573460}, {154,0.000616114}, {155,0.000872038}, {156,0.000625592}, {157,0.000767773}, {158,0.000549763}, {159,0.000592417}, {160,0.000549763}, {161,0.000729858}, {162,0.000758294}, {163,0.000644550}, {164,0.000582938}, {165,0.000710900}, {166,0.000744076}, {167,0.000554502}, {168,0.000734597}, {169,0.000625592}, {170,0.001459716}, {171,0.000687204}, {172,0.000663507}, {173,0.000644550}, {174,0.000729858}, {175,0.000668246}, {176,0.000981043}, {177,0.000578199}, {178,0.000720379}, {179,0.000696682}, {180,0.000748815}, {181,0.000601896}, {182,0.000672986}, {183,0.000682464}, {184,0.000763033}, {185,0.000763033}, {186,0.000611374}, {187,0.000777251}, {188,0.000616114}, {189,0.000516588}, {190,0.000649289}, {191,0.000691943}, {192,0.000691943}, {193,0.000616114}, {194,0.000744076}, {195,0.000848341}, {196,0.000819905}, {197,0.000554502}, {198,0.000777251}, {199,0.000649289}, {200,0.000687204}, {201,0.000701422}, {202,0.000748815}, {203,0.000701422}, {204,0.000701422}, {205,0.000886256}, {206,0.000777251}, {207,0.000739336}, {208,0.000895735}, {209,0.000668246}, {210,0.000701422}, {211,0.000587678}, {212,0.000848341}, {213,0.000663507}, {214,0.000748815}, {215,0.000838863}, {216,0.000786730}, {217,0.000763033}, {218,0.000947867}, {219,0.000758294}, {220,0.000777251}, {221,0.000834123}, {222,0.000597156}, {223,0.000919431}, {224,0.000957346}, {225,0.000710900}, {226,0.001004739}, {227,0.000763033}, {228,0.000739336}, {229,0.000696682}, {230,0.000720379}, {231,0.000744076}, {232,0.000895735}, {233,0.000777251}, {234,0.000838863}, {235,0.000872038}, {236,0.000819905}, {237,0.000639810}, {238,0.000853081}, {239,0.000767773}, {240,0.000938389}, {241,0.000725118}, {242,0.000952607}, {243,0.000838863}, {244,0.000942857}, {245,0.000633333}, {246,0.001166667}, {247,0.000776190}, {248,0.000933333}, {249,0.000933333}, {250,0.000819048}, {251,0.000847619}, {252,0.000847619}, {253,0.000823810}, {254,0.001047619}, {255,0.000980952}, {256,0.000885714}, {257,0.001090476}, {258,0.000757143}, {259,0.001042857}, {260,0.000780952}, {261,0.000766667}, {262,0.000847619}, {263,0.000685714}, {264,0.000966667}, {265,0.000757143}, {266,0.000890476}, {267,0.000976190}, {268,0.000938095}, {269,0.000990476}, {270,0.000942857}, {271,0.000804762}, {272,0.000904762}, {273,0.000909524}, {274,0.000742857}, {275,0.000995238}, {276,0.000890476}, {277,0.000814286}, {278,0.000923810}, {279,0.000923810}, {280,0.001128571}, {281,0.000880952}, {282,0.001385714}, {283,0.000780952}, {284,0.001114286}, {285,0.000819048}, {286,0.000966667}, {287,0.001028571}, {288,0.000928571}, {289,0.000847619}, {290,0.001057143}, {291,0.000933333}, {292,0.000819048}, {293,0.001023810}, {294,0.000857143}, {295,0.000823810}, {296,0.000990476}, {297,0.000980952}, {298,0.000752381}, {299,0.000838095}, {300,0.000909524}, {301,0.000971429}, {302,0.001085714}, {303,0.000933333}, {304,0.000761905}, {305,0.000909524}, {306,0.000900000}, {307,0.001057143}, {308,0.000952381}, {309,0.001280952}, {310,0.000961905}, {311,0.000852381}, {312,0.000976190}, {313,0.000880952}, {314,0.000919048}, {315,0.000995238}, {316,0.000900000}, {317,0.000985714}, {318,0.000814286}, {319,0.000852381}, {320,0.001580952}, {321,0.000804762}, {322,0.001033333}, {323,0.001123810}, {324,0.000914286}, {325,0.000928571}, {326,0.000890476}, {327,0.000709524}, {328,0.000928571}, {329,0.000852381}, {330,0.000909524}, {331,0.000957143}, {332,0.000890476}, {333,0.000700000}, {334,0.000847619}, {335,0.001147619}, {336,0.001085714}, {337,0.000900000}, {338,0.001028571}, {339,0.001104762}, {340,0.000900000}, {341,0.000933333}, {342,0.001061905}, {343,0.000971429}, {344,0.000942857}, {345,0.000895238}, {346,0.000909524}, {347,0.000971429}, {348,0.001138095}, {349,0.001061905}, {350,0.000971429}, {351,0.000961905}, {352,0.000928571}, {353,0.000880952}, {354,0.001147619}, {355,0.001128571}, {356,0.000933333}, {357,0.001038095}, {358,0.001023810}, {359,0.000904762}, {360,0.001142857}, {361,0.001328571}, {362,0.001061905}, {363,0.000980952}, {364,0.001004762}, {365,0.001342857}, {366,0.001028571}, {367,0.001109524}, {368,0.001004762}, {369,0.001019048}, {370,0.001014286}, {371,0.000890476}, {372,0.001138095}, {373,0.001014286}, {374,0.001104762}, {375,0.001138095}, {376,0.000876190}, {377,0.001252381}, {378,0.001204762}, {379,0.001214286}, {380,0.001038095}, {381,0.001038095}, {382,0.001076190}, {383,0.001180952}, {384,0.001085714}, {385,0.001047619}, {386,0.001147619}, {387,0.001114286}, {388,0.001080952}, {389,0.000938095}, {390,0.000995238}, {391,0.001033333}, {392,0.001138095}, {393,0.001238095}, {394,0.001000000}, {395,0.001042857}, {396,0.000942857}, {397,0.000919048}, {398,0.000919048}, {399,0.001242857}, {400,0.001138095}, {401,0.001085714}, {402,0.001157143}, {403,0.001061905}, {404,0.001266667}, {405,0.001223810}, {406,0.001185714}, {407,0.001090476}, {408,0.001161905}, {409,0.001623810}, {410,0.001271429}, {411,0.001290476}, {412,0.001195238}, {413,0.001009524}, {414,0.001042857}, {415,0.001195238}, {416,0.001080952}, {417,0.001147619}, {418,0.001242857}, {419,0.001042857}, {420,0.001280952}, {421,0.001119048}, {422,0.001461905}, {423,0.001261905}, {424,0.001142857}, {425,0.001219048}, {426,0.001090476}, {427,0.001009524}, {428,0.001066667}, {429,0.001166667}, {430,0.001252381}, {431,0.000995238}, {432,0.000785714}, {433,0.001261905}, {434,0.001233333}, {435,0.002100000}, {436,0.001219048}, {437,0.001338095}, {438,0.001228571}, {439,0.001180952}, {440,0.001166667}, {441,0.001023810}, {442,0.001228571}, {443,0.001300000}, {444,0.001447619}, {445,0.001280952}, {446,0.001104762}, {447,0.001304762}, {448,0.001100000}, {449,0.001585714}, {450,0.001090476}, {451,0.001652381}, {452,0.001219048}, {453,0.001133333}, {454,0.001366667}, {455,0.001252381}, {456,0.001238095}, {457,0.001219048}, {458,0.001295238}, {459,0.001285714}, {460,0.001252381}, {461,0.001147619}, {462,0.001809524}, {463,0.001114286}, {464,0.001147619}, {465,0.001285714}, {466,0.001219048}, {467,0.001195238}, {468,0.001271429}, {469,0.001404762}, {470,0.001190476}, {471,0.001204762}, {472,0.001352381}, {473,0.001309524}, {474,0.001361905}, {475,0.001238095}, {476,0.001257143}, {477,0.001414286}, {478,0.001223810}, {479,0.001242857}, {480,0.001442857}, {481,0.001200000}, {482,0.001223810}, {483,0.001376190}, {484,0.001223810}, {485,0.001195238}, {486,0.001319048}, {487,0.001266667}, {488,0.001352381}, {489,0.001171429}, {490,0.001576190}, {491,0.001076190}, {492,0.001504762}, {493,0.001371429}, {494,0.001457143}, {495,0.001242857}, {496,0.001566667}, {497,0.001352381}, {498,0.001395238}, {499,0.001314286}, {500,0.001238095}, {505,0.001219048}, {510,0.001566667}, {515,0.001357143}, {520,0.002185714}, {525,0.001390476}, {530,0.001442857}, {535,0.001209524}, {540,0.001438095}, {545,0.001409524}, {550,0.001366667}, {555,0.001390476}, {560,0.001347619}, {565,0.001404762}, {570,0.001390476}, {575,0.001304762}, {580,0.001395238}, {585,0.001347619}, {590,0.001414286}, {595,0.001509524}, {600,0.001457143}, {605,0.001304762}, {610,0.001619048}, {615,0.001614286}, {620,0.001671429}, {625,0.001514286}, {630,0.001547619}, {635,0.001647619}, {640,0.001661905}, {645,0.001866667}, {650,0.001780952}, {655,0.001623810}, {660,0.001757143}, {665,0.001771429}, {670,0.001619048}, {675,0.001585714}, {680,0.001571429}, {685,0.001709524}, {690,0.001780952}, {695,0.001942857}, {700,0.001742857}, {705,0.002185714}, {710,0.001766667}, {715,0.001733333}, {720,0.001704762}, {725,0.001566667}, {730,0.001576190}, {735,0.001780952}, {740,0.001804762}, {745,0.001904762}, {750,0.001957143}, {755,0.001876190}, {760,0.001766667}, {765,0.001876190}, {770,0.002061905}, {775,0.001728571}, {780,0.002019048}, {785,0.002052381}, {790,0.001880952}, {795,0.001966667}, {800,0.001947619}, {805,0.002585714}, {810,0.001771429}, {815,0.001871429}, {820,0.001809524}, {825,0.002619048}, {830,0.002180952}, {835,0.001757143}, {840,0.002033333}, {845,0.001990476}, {850,0.001938095}, {855,0.001819048}, {860,0.002033333}, {865,0.001990476}, {870,0.001995238}, {875,0.002042857}, {880,0.002066667}, {885,0.002042857}, {890,0.002142857}, {895,0.002014286}, {900,0.002014286}, {905,0.003842857}, {910,0.002114286}, {915,0.002104762}, {920,0.002033333}, {925,0.002076190}, {930,0.002838095}, {935,0.002309524}, {940,0.002247619}, {945,0.002371429}, {950,0.002176190}, {955,0.002528571}, {960,0.002252381}, {965,0.002409524}, {970,0.002161905}, {975,0.002152381}, {980,0.002419048}, {985,0.002190476}, {990,0.002480952}, {995,0.002428571}, {1000,0.002261905}, {1010,0.002461905}, {1020,0.002333333}, {1030,0.002414286}, {1040,0.002366667}, {1050,0.003200000}, {1060,0.002438095}, {1070,0.002457143}, {1080,0.002290476}, {1090,0.002266667}, {1100,0.002742857}, {1110,0.002552381}, {1120,0.002480952}, {1130,0.002509524}, {1140,0.002452381}, {1150,0.002580952}, {1160,0.002509524}, {1170,0.002523810}, {1180,0.002628571}, {1190,0.004061905}, {1200,0.002576190}, {1210,0.002828571}, {1220,0.002780952}, {1230,0.002728571}, {1240,0.002466667}, {1250,0.002757143}, {1260,0.002714286}, {1270,0.002785714}, {1280,0.002757143}, {1290,0.002842857}, {1300,0.002833333}, {1310,0.002757143}, {1320,0.003042857}, {1330,0.002957143}, {1340,0.002914286}, {1350,0.003019048}, {1360,0.002919048}, {1370,0.003019048}, {1380,0.002961905}, {1390,0.003238095}, {1400,0.003176190}, {1410,0.003333333}, {1420,0.003038095}, {1430,0.004700000}, {1440,0.003057143}, {1450,0.003104762}, {1460,0.003190476}, {1470,0.003176190}, {1480,0.003214286}, {1490,0.003309524}, {1500,0.003242857}, {1510,0.003195238}, {1520,0.003242857}, {1530,0.003319048}, {1540,0.003400000}, {1550,0.003447619}, {1560,0.003442857}, {1570,0.003504762}, {1580,0.003333333}, {1590,0.003485714}, {1600,0.003476190}, {1610,0.003500000}, {1620,0.003447619}, {1630,0.003457143}, {1640,0.003542857}, {1650,0.003552381}, {1660,0.003580952}, {1670,0.003647619}, {1680,0.004909524}, {1690,0.003695238}, {1700,0.003680952}, {1710,0.003685714}, {1720,0.003747619}, {1730,0.003771429}, {1740,0.003757143}, {1750,0.003847619}, {1760,0.004714286}, {1770,0.003838095}, {1780,0.003728571}, {1790,0.003880952}, {1800,0.003957143}, {1810,0.003942857}, {1820,0.004061905}, {1830,0.003885714}, {1840,0.005004762}, {1850,0.004000000}, {1860,0.004052381}, {1870,0.004095238}, {1880,0.003928571}, {1890,0.005385714}, {1900,0.004185714}, {1910,0.004004762}, {1920,0.004247619}, {1930,0.004323810}, {1940,0.004223810}, {1950,0.004314286}, {1960,0.004242857}, {1970,0.004138095}, {1980,0.004400000}, {1990,0.005671429}, {2000,0.004457143}, {2050,0.004519048}, {2100,0.004509524}, {2150,0.004504762}, {2200,0.004638095}, {2250,0.004657143}, {2300,0.004928571}, {2350,0.005138095}, {2400,0.005252381}, {2450,0.005238095}, {2500,0.005357143}, {2550,0.005223810}, {2600,0.005604762}, {2650,0.005652381}, {2700,0.005847619}, {2750,0.005785714}, {2800,0.005823810}, {2850,0.006114286}, {2900,0.006200000}, {2950,0.006180952}, {3000,0.006480952}, {3050,0.006509524}, {3100,0.008985714}, {3150,0.006857143}, {3200,0.006785714}, {3250,0.009890476}, {3300,0.007280952}, {3350,0.007157143}, {3400,0.010680952}, {3450,0.007485714}, {3500,0.007409524}, {3550,0.007719048}, {3600,0.007814286}, {3650,0.007485714}, {3700,0.008214286}, {3750,0.008123810}, {3800,0.008742857}, {3850,0.008476190}, {3900,0.008523810}, {3950,0.009090476}, {4000,0.011938095}, {4050,0.008971429}, {4100,0.009190476}, {4150,0.009471429}, {4200,0.009723810}, {4250,0.009657143}, {4300,0.010009524}, {4350,0.010133333}, {4400,0.012890476}, {4450,0.009842857}, {4500,0.010471429}, {4550,0.010423810}, {4600,0.010276190}, {4650,0.010780952}, {4700,0.011157143}, {4750,0.011390476}, {4800,0.011304762}, {4850,0.011504762}, {4900,0.011461905}, {4950,0.011680952}, {5000,0.011857143}, {5050,0.019657143}, {5100,0.012023810}, {5150,0.012114286}, {5200,0.012352381}, {5250,0.012400000}, {5300,0.012738095}, {5350,0.021576190}, {5400,0.020157143}, {5450,0.013119048}, {5500,0.013157143}, {5550,0.013261905}, {5600,0.020914286}, {5650,0.013504762}, {5700,0.013947619}, {5750,0.019533333}, {5800,0.022166667}, {5850,0.014033333}, {5900,0.014219048}, {5950,0.014033333}, {6000,0.020738095}, {6050,0.014280952}, {6100,0.014557143}, {6150,0.014666667}, {6200,0.020176190}, {6250,0.021638095}, {6300,0.015114286}, {6350,0.014961905}, {6400,0.019590476}, {6450,0.015404762}, {6500,0.020271429}, {6550,0.022300000}, {6600,0.015952381}, {6650,0.016000000}, {6700,0.023438095}, {6750,0.016195238}, {6800,0.016485714}, {6850,0.016609524}, {6900,0.016466667}, {6950,0.022380952}, {7000,0.016914286}, {7050,0.017066667}, {7100,0.021585714}, {7150,0.017509524}, {7200,0.017395238}, {7250,0.017347619}, {7300,0.017666667}, {7350,0.022738095}, {7400,0.017728571}, {7450,0.017938095}, {7500,0.018085714}, {7550,0.018323810}, {7600,0.018695238}, {7650,0.018552381}, {7700,0.018680952}, {7750,0.023642857}, {7800,0.023566667}, {7850,0.022466667}, {7900,0.019366667}, {7950,0.019319048}, {8000,0.032057143}, {8050,0.019719048}, {8100,0.019938095}, {8150,0.020014286}, {8200,0.023519048}, {8250,0.027328571}, {8300,0.020619048}, {8350,0.020638095}, {8400,0.021066667}, {8450,0.025685714}, {8500,0.024457143}, {8550,0.027980952}, {8600,0.027671429}, {8650,0.027700000}, {8700,0.021652381}, {8750,0.021800000}, {8800,0.021985714}, {8850,0.026961905}, {8900,0.022171429}, {8950,0.022676190}, {9000,0.022466667}, {9050,0.022700000}, {9100,0.022961905}, {9150,0.029914286}, {9200,0.030966667}, {9250,0.023371429}, {9300,0.023595238}, {9350,0.023666667}, {9400,0.023909524}, {9450,0.023814286}, {9500,0.023709524}, {9550,0.024085714}, {9600,0.030595238}, {9650,0.036247619}, {9700,0.030461905}, {9750,0.031085714}, {9800,0.032152381}, {9850,0.033485714}, {9900,0.034042857}, {9950,0.039861905}, {10000,0.031428571}, {10100,0.031914286}, {10200,0.024928571}, {10300,0.035109524}, {10400,0.032976190}, {10500,0.026852381}, {10600,0.026795238}, {10700,0.036333333}, {10800,0.035133333}, {10900,0.042361905}, {11000,0.028161905}, {11100,0.028257143}, {11200,0.045319048}, {11300,0.035519048}, {11400,0.036452381}, {11500,0.029509524}, {11600,0.042819048}, {11700,0.029980952}, {11800,0.039680952}, {11900,0.042195238}, {12000,0.031090476}, {12100,0.044966667}, {12200,0.039795238}, {12300,0.037895238}, {12400,0.031976190}, {12500,0.048276190}, {12600,0.032719048}, {12700,0.031990476}, {12800,0.033452381}, {12900,0.042409524}, {13000,0.051447619}, {13100,0.050057143}, {13200,0.034709524}, {13300,0.044914286}, {13400,0.035319048}, {13500,0.035638095}, {13600,0.032409524}, {13700,0.044371429}, {13800,0.036290476}, {13900,0.036700000}, {14000,0.036914286}, {14100,0.034842857}, {14200,0.056400000}, {14300,0.055195238}, {14400,0.061523810}, {14500,0.044890476}, {14600,0.038890476}, {14700,0.038880952}, {14800,0.052614286}, {14900,0.047923810}, {15000,0.039719048}, {15100,0.048114286}, {15200,0.059976190}, {15300,0.055676190}, {15400,0.059909524}, {15500,0.059904762}, {15600,0.041371429}, {15700,0.053461905}, {15800,0.042009524}, {15900,0.066047619}, {16000,0.049942857}, {16100,0.056142857}, {16200,0.043361905}, {16300,0.067095238}, {16400,0.043566667}, {16500,0.042271429}, {16600,0.066700000}, {16700,0.044633333}, {16800,0.052209524}, {16900,0.058861905}, {17000,0.045552381}, {17100,0.059242857}, {17200,0.052142857}, {17300,0.066076190}, {17400,0.053761905}, {17500,0.060304762}, {17600,0.047314286}, {17700,0.050457143}, {17800,0.061014286}, {17900,0.063300000}, {18000,0.071704762}, {18100,0.058880952}, {18200,0.059647619}, {18300,0.072219048}, {18400,0.070871429}, {18500,0.063304762}, {18600,0.072609524}, {18700,0.065942857}, {18800,0.057814286}, {18900,0.050652381}, {19000,0.051219048}, {19100,0.058428571}, {19200,0.084233333}, {19300,0.072466667}, {19400,0.065280952}, {19500,0.068361905}, {19600,0.069571429}, {19700,0.057909524}, {19800,0.059833333}, {19900,0.067704762}, {20000,0.059201923}};
data["big"]["Parametricity; beta"]["actual reif"]["system"] = {{1,0.000056872}, {2,0.000018957}, {3,0.000000000}, {4,0.000037915}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000018957}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000018957}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000018957}, {17,0.000000000}, {18,0.000018957}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000037915}, {24,0.000279621}, {25,0.000018957}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000018957}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000018957}, {38,0.000018957}, {39,0.000000000}, {40,0.000000000}, {41,0.000037915}, {42,0.000014218}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000037915}, {49,0.000018957}, {50,0.000018957}, {51,0.000000000}, {52,0.000000000}, {53,0.000018957}, {54,0.000000000}, {55,0.000018957}, {56,0.000000000}, {57,0.000018957}, {58,0.000000000}, {59,0.000000000}, {60,0.000018957}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000014218}, {75,0.000018957}, {76,0.000037915}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000018957}, {81,0.000000000}, {82,0.000018957}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000014218}, {89,0.000018957}, {90,0.000000000}, {91,0.000000000}, {92,0.000018957}, {93,0.000018957}, {94,0.000000000}, {95,0.000033175}, {96,0.000056872}, {97,0.000018957}, {98,0.000000000}, {99,0.000018957}, {100,0.000000000}, {101,0.000000000}, {102,0.000018957}, {103,0.000000000}, {104,0.000018957}, {105,0.000000000}, {106,0.000037915}, {107,0.000037915}, {108,0.000000000}, {109,0.000018957}, {110,0.000000000}, {111,0.000018957}, {112,0.000000000}, {113,0.000018957}, {114,0.000000000}, {115,0.000018957}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000033175}, {123,0.000018957}, {124,0.000000000}, {125,0.000000000}, {126,0.000014218}, {127,0.000018957}, {128,0.000037915}, {129,0.000000000}, {130,0.000014218}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000018957}, {138,0.000018957}, {139,0.000000000}, {140,0.000000000}, {141,0.000033175}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000018957}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000018957}, {150,0.000018957}, {151,0.000018957}, {152,0.000000000}, {153,0.000000000}, {154,0.000018957}, {155,0.000014218}, {156,0.000018957}, {157,0.000018957}, {158,0.000018957}, {159,0.000000000}, {160,0.000000000}, {161,0.000018957}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000018957}, {171,0.000018957}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000018957}, {177,0.000018957}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000018957}, {183,0.000000000}, {184,0.000000000}, {185,0.000018957}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000018957}, {190,0.000000000}, {191,0.000018957}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000018957}, {197,0.000000000}, {198,0.000018957}, {199,0.000000000}, {200,0.000018957}, {201,0.000018957}, {202,0.000000000}, {203,0.000014218}, {204,0.000037915}, {205,0.000000000}, {206,0.000037915}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000018957}, {212,0.000018957}, {213,0.000018957}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000018957}, {223,0.000000000}, {224,0.000018957}, {225,0.000000000}, {226,0.000037915}, {227,0.000000000}, {228,0.000018957}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000018957}, {241,0.000018957}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000019048}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000019048}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000019048}, {265,0.000000000}, {266,0.000038095}, {267,0.000000000}, {268,0.000014286}, {269,0.000019048}, {270,0.000000000}, {271,0.000000000}, {272,0.000019048}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000019048}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000038095}, {287,0.000019048}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000019048}, {295,0.000000000}, {296,0.000000000}, {297,0.000019048}, {298,0.000000000}, {299,0.000019048}, {300,0.000000000}, {301,0.000019048}, {302,0.000000000}, {303,0.000019048}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000019048}, {309,0.000014286}, {310,0.000000000}, {311,0.000000000}, {312,0.000038095}, {313,0.000019048}, {314,0.000000000}, {315,0.000000000}, {316,0.000019048}, {317,0.000071429}, {318,0.000000000}, {319,0.000014286}, {320,0.000038095}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000038095}, {326,0.000019048}, {327,0.000038095}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000014286}, {332,0.000000000}, {333,0.000000000}, {334,0.000038095}, {335,0.000019048}, {336,0.000014286}, {337,0.000000000}, {338,0.000019048}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000014286}, {344,0.000000000}, {345,0.000019048}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000019048}, {355,0.000019048}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000019048}, {361,0.000000000}, {362,0.000019048}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000019048}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000019048}, {375,0.000019048}, {376,0.000019048}, {377,0.000014286}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000038095}, {383,0.000019048}, {384,0.000000000}, {385,0.000000000}, {386,0.000014286}, {387,0.000000000}, {388,0.000000000}, {389,0.000038095}, {390,0.000000000}, {391,0.000019048}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000057143}, {397,0.000019048}, {398,0.000019048}, {399,0.000019048}, {400,0.000000000}, {401,0.000000000}, {402,0.000019048}, {403,0.000019048}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000014286}, {408,0.000000000}, {409,0.000019048}, {410,0.000019048}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000019048}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000038095}, {419,0.000019048}, {420,0.000019048}, {421,0.000019048}, {422,0.000019048}, {423,0.000000000}, {424,0.000014286}, {425,0.000000000}, {426,0.000000000}, {427,0.000019048}, {428,0.000019048}, {429,0.000000000}, {430,0.000000000}, {431,0.000019048}, {432,0.000076190}, {433,0.000038095}, {434,0.000019048}, {435,0.000038095}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000019048}, {440,0.000000000}, {441,0.000000000}, {442,0.000038095}, {443,0.000000000}, {444,0.000019048}, {445,0.000000000}, {446,0.000000000}, {447,0.000019048}, {448,0.000000000}, {449,0.000000000}, {450,0.000019048}, {451,0.000000000}, {452,0.000000000}, {453,0.000019048}, {454,0.000000000}, {455,0.000019048}, {456,0.000000000}, {457,0.000019048}, {458,0.000000000}, {459,0.000057143}, {460,0.000000000}, {461,0.000000000}, {462,0.000038095}, {463,0.000019048}, {464,0.000038095}, {465,0.000057143}, {466,0.000000000}, {467,0.000019048}, {468,0.000000000}, {469,0.000000000}, {470,0.000038095}, {471,0.000000000}, {472,0.000019048}, {473,0.000019048}, {474,0.000000000}, {475,0.000019048}, {476,0.000000000}, {477,0.000019048}, {478,0.000057143}, {479,0.000000000}, {480,0.000038095}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000033333}, {486,0.000033333}, {487,0.000019048}, {488,0.000019048}, {489,0.000038095}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000038095}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000019048}, {498,0.000019048}, {499,0.000000000}, {500,0.000019048}, {505,0.000019048}, {510,0.000000000}, {515,0.000000000}, {520,0.000019048}, {525,0.000019048}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000019048}, {565,0.000038095}, {570,0.000019048}, {575,0.000000000}, {580,0.000019048}, {585,0.000038095}, {590,0.000000000}, {595,0.000038095}, {600,0.000019048}, {605,0.000019048}, {610,0.000000000}, {615,0.000000000}, {620,0.000019048}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000019048}, {670,0.000000000}, {675,0.000019048}, {680,0.000038095}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000019048}, {705,0.000000000}, {710,0.000019048}, {715,0.000000000}, {720,0.000038095}, {725,0.000019048}, {730,0.000019048}, {735,0.000057143}, {740,0.000019048}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000019048}, {765,0.000000000}, {770,0.000038095}, {775,0.000038095}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000038095}, {800,0.000000000}, {805,0.000038095}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000014286}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000038095}, {865,0.000000000}, {870,0.000019048}, {875,0.000014286}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000019048}, {900,0.000000000}, {905,0.000057143}, {910,0.000038095}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000019048}, {945,0.000000000}, {950,0.000019048}, {955,0.000019048}, {960,0.000000000}, {965,0.000000000}, {970,0.000019048}, {975,0.000019048}, {980,0.000000000}, {985,0.000019048}, {990,0.000000000}, {995,0.000019048}, {1000,0.000038095}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000019048}, {1050,0.000076190}, {1060,0.000019048}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000019048}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000019048}, {1130,0.000000000}, {1140,0.000057143}, {1150,0.000000000}, {1160,0.000019048}, {1170,0.000019048}, {1180,0.000038095}, {1190,0.000000000}, {1200,0.000019048}, {1210,0.000019048}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000038095}, {1260,0.000019048}, {1270,0.000019048}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000019048}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000019048}, {1360,0.000038095}, {1370,0.000019048}, {1380,0.000019048}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000019048}, {1440,0.000000000}, {1450,0.000019048}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000019048}, {1490,0.000019048}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000019048}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000019048}, {1570,0.000019048}, {1580,0.000019048}, {1590,0.000019048}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000019048}, {1640,0.000000000}, {1650,0.000019048}, {1660,0.000019048}, {1670,0.000038095}, {1680,0.000057143}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000038095}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000114286}, {1770,0.000000000}, {1780,0.000038095}, {1790,0.000014286}, {1800,0.000000000}, {1810,0.000038095}, {1820,0.000019048}, {1830,0.000038095}, {1840,0.000057143}, {1850,0.000057143}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000038095}, {1900,0.000000000}, {1910,0.000038095}, {1920,0.000019048}, {1930,0.000019048}, {1940,0.000000000}, {1950,0.000019048}, {1960,0.000019048}, {1970,0.000019048}, {1980,0.000038095}, {1990,0.000038095}, {2000,0.000000000}, {2050,0.000014286}, {2100,0.000019048}, {2150,0.000019048}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000019048}, {2350,0.000000000}, {2400,0.000019048}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000057143}, {2600,0.000000000}, {2650,0.000019048}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000019048}, {2850,0.000019048}, {2900,0.000000000}, {2950,0.000057143}, {3000,0.000019048}, {3050,0.000000000}, {3100,0.000038095}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000085714}, {3300,0.000000000}, {3350,0.000019048}, {3400,0.000019048}, {3450,0.000019048}, {3500,0.000019048}, {3550,0.000000000}, {3600,0.000019048}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000019048}, {3850,0.000000000}, {3900,0.000038095}, {3950,0.000057143}, {4000,0.000057143}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000019048}, {4200,0.000019048}, {4250,0.000000000}, {4300,0.000038095}, {4350,0.000000000}, {4400,0.000095238}, {4450,0.000038095}, {4500,0.000019048}, {4550,0.000019048}, {4600,0.000033333}, {4650,0.000038095}, {4700,0.000019048}, {4750,0.000019048}, {4800,0.000038095}, {4850,0.000019048}, {4900,0.000000000}, {4950,0.000019048}, {5000,0.000019048}, {5050,0.000133333}, {5100,0.000019048}, {5150,0.000019048}, {5200,0.000038095}, {5250,0.000019048}, {5300,0.000000000}, {5350,0.000152381}, {5400,0.000166667}, {5450,0.000000000}, {5500,0.000019048}, {5550,0.000000000}, {5600,0.000133333}, {5650,0.000038095}, {5700,0.000000000}, {5750,0.000152381}, {5800,0.000038095}, {5850,0.000019048}, {5900,0.000038095}, {5950,0.000038095}, {6000,0.000247619}, {6050,0.000033333}, {6100,0.000038095}, {6150,0.000038095}, {6200,0.000057143}, {6250,0.000000000}, {6300,0.000014286}, {6350,0.000038095}, {6400,0.000095238}, {6450,0.000038095}, {6500,0.000057143}, {6550,0.000090476}, {6600,0.000000000}, {6650,0.000000000}, {6700,0.000190476}, {6750,0.000000000}, {6800,0.000019048}, {6850,0.000000000}, {6900,0.000038095}, {6950,0.000095238}, {7000,0.000000000}, {7050,0.000000000}, {7100,0.000076190}, {7150,0.000019048}, {7200,0.000000000}, {7250,0.000019048}, {7300,0.000019048}, {7350,0.000076190}, {7400,0.000000000}, {7450,0.000038095}, {7500,0.000019048}, {7550,0.000000000}, {7600,0.000057143}, {7650,0.000038095}, {7700,0.000019048}, {7750,0.000190476}, {7800,0.000109524}, {7850,0.000304762}, {7900,0.000038095}, {7950,0.000000000}, {8000,0.000300000}, {8050,0.000000000}, {8100,0.000019048}, {8150,0.000000000}, {8200,0.000095238}, {8250,0.000109524}, {8300,0.000019048}, {8350,0.000000000}, {8400,0.000019048}, {8450,0.000109524}, {8500,0.000109524}, {8550,0.000266667}, {8600,0.000190476}, {8650,0.000057143}, {8700,0.000038095}, {8750,0.000038095}, {8800,0.000000000}, {8850,0.000019048}, {8900,0.000019048}, {8950,0.000000000}, {9000,0.000019048}, {9050,0.000019048}, {9100,0.000000000}, {9150,0.000095238}, {9200,0.000076190}, {9250,0.000019048}, {9300,0.000000000}, {9350,0.000000000}, {9400,0.000000000}, {9450,0.000038095}, {9500,0.000000000}, {9550,0.000019048}, {9600,0.000000000}, {9650,0.000152381}, {9700,0.000095238}, {9750,0.000095238}, {9800,0.000109524}, {9850,0.000052381}, {9900,0.000076190}, {9950,0.000114286}, {10000,0.000076190}, {10100,0.000152381}, {10200,0.000038095}, {10300,0.000019048}, {10400,0.000038095}, {10500,0.000000000}, {10600,0.000038095}, {10700,0.000038095}, {10800,0.000171429}, {10900,0.000057143}, {11000,0.000000000}, {11100,0.000057143}, {11200,0.000038095}, {11300,0.000038095}, {11400,0.000014286}, {11500,0.000019048}, {11600,0.000057143}, {11700,0.000000000}, {11800,0.000000000}, {11900,0.000019048}, {12000,0.000000000}, {12100,0.000338095}, {12200,0.000000000}, {12300,0.000223810}, {12400,0.000038095}, {12500,0.000133333}, {12600,0.000019048}, {12700,0.000019048}, {12800,0.000038095}, {12900,0.000000000}, {13000,0.000190476}, {13100,0.000038095}, {13200,0.000019048}, {13300,0.000342857}, {13400,0.000000000}, {13500,0.000038095}, {13600,0.000038095}, {13700,0.000147619}, {13800,0.000019048}, {13900,0.000000000}, {14000,0.000000000}, {14100,0.000000000}, {14200,0.000000000}, {14300,0.000019048}, {14400,0.000014286}, {14500,0.000000000}, {14600,0.000019048}, {14700,0.000000000}, {14800,0.000000000}, {14900,0.000019048}, {15000,0.000038095}, {15100,0.000000000}, {15200,0.000057143}, {15300,0.000019048}, {15400,0.000019048}, {15500,0.000019048}, {15600,0.000000000}, {15700,0.000000000}, {15800,0.000014286}, {15900,0.000000000}, {16000,0.000019048}, {16100,0.000057143}, {16200,0.000057143}, {16300,0.000000000}, {16400,0.000057143}, {16500,0.000019048}, {16600,0.000000000}, {16700,0.000000000}, {16800,0.000019048}, {16900,0.000019048}, {17000,0.000019048}, {17100,0.000000000}, {17200,0.000000000}, {17300,0.000000000}, {17400,0.000019048}, {17500,0.000000000}, {17600,0.000019048}, {17700,0.000019048}, {17800,0.000000000}, {17900,0.000038095}, {18000,0.000019048}, {18100,0.000019048}, {18200,0.000000000}, {18300,0.000000000}, {18400,0.000019048}, {18500,0.000038095}, {18600,0.000019048}, {18700,0.000000000}, {18800,0.000038095}, {18900,0.000019048}, {19000,0.000019048}, {19100,0.000000000}, {19200,0.000057143}, {19300,0.000019048}, {19400,0.000038095}, {19500,0.000019048}, {19600,0.000057143}, {19700,0.000019048}, {19800,0.000019048}, {19900,0.000076190}, {20000,0.000000000}};
data["big"]["Parametricity; beta"]["cbv"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000473934}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000454976}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000509524}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000495238}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000971429}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000019048}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000004762}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000019048}, {1050,0.000014286}, {1060,0.000004762}, {1070,0.000052381}, {1080,0.000038095}, {1090,0.000057143}, {1100,0.000080952}, {1110,0.000133333}, {1120,0.000190476}, {1130,0.000219048}, {1140,0.000342857}, {1150,0.000409524}, {1160,0.000514286}, {1170,0.000552381}, {1180,0.000595238}, {1190,0.000676190}, {1200,0.000676190}, {1210,0.000719048}, {1220,0.000757143}, {1230,0.000800000}, {1240,0.000809524}, {1250,0.000833333}, {1260,0.000876190}, {1270,0.000919048}, {1280,0.000919048}, {1290,0.000947619}, {1300,0.000976190}, {1310,0.001000000}, {1320,0.001000000}, {1330,0.002347619}, {1340,0.001000000}, {1350,0.001000000}, {1360,0.001000000}, {1370,0.001000000}, {1380,0.001000000}, {1390,0.001000000}, {1400,0.001000000}, {1410,0.001000000}, {1420,0.001000000}, {1430,0.001000000}, {1440,0.001019048}, {1450,0.001000000}, {1460,0.001000000}, {1470,0.001019048}, {1480,0.001000000}, {1490,0.001000000}, {1500,0.001019048}, {1510,0.001000000}, {1520,0.001000000}, {1530,0.001000000}, {1540,0.001000000}, {1550,0.001000000}, {1560,0.001000000}, {1570,0.001000000}, {1580,0.001000000}, {1590,0.001000000}, {1600,0.001000000}, {1610,0.001000000}, {1620,0.001000000}, {1630,0.001000000}, {1640,0.001047619}, {1650,0.001000000}, {1660,0.001000000}, {1670,0.001000000}, {1680,0.001000000}, {1690,0.001000000}, {1700,0.001000000}, {1710,0.001000000}, {1720,0.001000000}, {1730,0.001000000}, {1740,0.001000000}, {1750,0.001000000}, {1760,0.001000000}, {1770,0.001019048}, {1780,0.001000000}, {1790,0.001000000}, {1800,0.001000000}, {1810,0.001000000}, {1820,0.001000000}, {1830,0.001000000}, {1840,0.001000000}, {1850,0.001000000}, {1860,0.001000000}, {1870,0.001000000}, {1880,0.002623810}, {1890,0.001000000}, {1900,0.001004762}, {1910,0.001000000}, {1920,0.001000000}, {1930,0.001000000}, {1940,0.001004762}, {1950,0.001000000}, {1960,0.001038095}, {1970,0.001000000}, {1980,0.001004762}, {1990,0.001004762}, {2000,0.001004762}, {2050,0.001028571}, {2100,0.001038095}, {2150,0.001138095}, {2200,0.001228571}, {2250,0.001352381}, {2300,0.001471429}, {2350,0.001600000}, {2400,0.001719048}, {2450,0.001857143}, {2500,0.001871429}, {2550,0.001938095}, {2600,0.001980952}, {2650,0.003847619}, {2700,0.001995238}, {2750,0.002000000}, {2800,0.002004762}, {2850,0.002000000}, {2900,0.002004762}, {2950,0.002004762}, {3000,0.002028571}, {3050,0.002038095}, {3100,0.002114286}, {3150,0.002219048}, {3200,0.002300000}, {3250,0.002361905}, {3300,0.002423810}, {3350,0.002485714}, {3400,0.002585714}, {3450,0.002723810}, {3500,0.002761905}, {3550,0.002847619}, {3600,0.002876190}, {3650,0.002904762}, {3700,0.002957143}, {3750,0.002928571}, {3800,0.003080952}, {3850,0.003019048}, {3900,0.003023810}, {3950,0.003009524}, {4000,0.005352381}, {4050,0.003142857}, {4100,0.003233333}, {4150,0.003300000}, {4200,0.003323810}, {4250,0.003423810}, {4300,0.003433333}, {4350,0.006661905}, {4400,0.003523810}, {4450,0.003628571}, {4500,0.003719048}, {4550,0.003780952}, {4600,0.003828571}, {4650,0.003895238}, {4700,0.003933333}, {4750,0.003961905}, {4800,0.004061905}, {4850,0.004042857}, {4900,0.004028571}, {4950,0.004114286}, {5000,0.004185714}, {5050,0.004242857}, {5100,0.004052381}, {5150,0.004295238}, {5200,0.004361905}, {5250,0.004461905}, {5300,0.004423810}, {5350,0.004490476}, {5400,0.009647619}, {5450,0.007985714}, {5500,0.004700000}, {5550,0.004809524}, {5600,0.004847619}, {5650,0.004909524}, {5700,0.004985714}, {5750,0.005004762}, {5800,0.008652381}, {5850,0.005090476}, {5900,0.005285714}, {5950,0.005200000}, {6000,0.005228571}, {6050,0.008514286}, {6100,0.005328571}, {6150,0.005347619}, {6200,0.005519048}, {6250,0.005319048}, {6300,0.005504762}, {6350,0.005585714}, {6400,0.010733333}, {6450,0.005866667}, {6500,0.005790476}, {6550,0.005871429}, {6600,0.005914286}, {6650,0.005938095}, {6700,0.006047619}, {6750,0.006114286}, {6800,0.006104762}, {6850,0.011942857}, {6900,0.006252381}, {6950,0.006247619}, {7000,0.006319048}, {7050,0.006342857}, {7100,0.006376190}, {7150,0.006495238}, {7200,0.019185714}, {7250,0.006561905}, {7300,0.015333333}, {7350,0.006714286}, {7400,0.013542857}, {7450,0.006557143}, {7500,0.014752381}, {7550,0.007028571}, {7600,0.011752381}, {7650,0.007114286}, {7700,0.007166667}, {7750,0.007200000}, {7800,0.007214286}, {7850,0.007276190}, {7900,0.007338095}, {7950,0.014457143}, {8000,0.007471429}, {8050,0.007509524}, {8100,0.013676190}, {8150,0.007619048}, {8200,0.007695238}, {8250,0.013490476}, {8300,0.007800000}, {8350,0.007861905}, {8400,0.007904762}, {8450,0.007504762}, {8500,0.008080952}, {8550,0.008119048}, {8600,0.015919048}, {8650,0.008242857}, {8700,0.008395238}, {8750,0.008323810}, {8800,0.007942857}, {8850,0.008385714}, {8900,0.008476190}, {8950,0.008514286}, {9000,0.008585714}, {9050,0.008633333}, {9100,0.013585714}, {9150,0.008776190}, {9200,0.008857143}, {9250,0.008871429}, {9300,0.008985714}, {9350,0.008976190}, {9400,0.009004762}, {9450,0.009200000}, {9500,0.008861905}, {9550,0.014647619}, {9600,0.009238095}, {9650,0.009342857}, {9700,0.016300000}, {9750,0.009509524}, {9800,0.009538095}, {9850,0.009728571}, {9900,0.009628571}, {9950,0.009728571}, {10000,0.017304762}, {10100,0.009890476}, {10200,0.016276190}, {10300,0.014680952}, {10400,0.010219048}, {10500,0.010347619}, {10600,0.010533333}, {10700,0.010533333}, {10800,0.010604762}, {10900,0.010733333}, {11000,0.018238095}, {11100,0.011204762}, {11200,0.011119048}, {11300,0.011185714}, {11400,0.011309524}, {11500,0.011390476}, {11600,0.011571429}, {11700,0.011923810}, {11800,0.021023810}, {11900,0.018985714}, {12000,0.011952381}, {12100,0.012014286}, {12200,0.012261905}, {12300,0.012295238}, {12400,0.024647619}, {12500,0.012600000}, {12600,0.013000000}, {12700,0.022295238}, {12800,0.019776190}, {12900,0.013047619}, {13000,0.013223810}, {13100,0.013442857}, {13200,0.021295238}, {13300,0.013466667}, {13400,0.013709524}, {13500,0.013780952}, {13600,0.013861905}, {13700,0.013961905}, {13800,0.014100000}, {13900,0.014233333}, {14000,0.020271429}, {14100,0.023357143}, {14200,0.014723810}, {14300,0.014733333}, {14400,0.014819048}, {14500,0.027638095}, {14600,0.014685714}, {14700,0.015085714}, {14800,0.015261905}, {14900,0.015357143}, {15000,0.014623810}, {15100,0.015861905}, {15200,0.015757143}, {15300,0.023580952}, {15400,0.016180952}, {15500,0.016019048}, {15600,0.024442857}, {15700,0.016309524}, {15800,0.015990476}, {15900,0.016476190}, {16000,0.026490476}, {16100,0.024176190}, {16200,0.016919048}, {16300,0.016914286}, {16400,0.028776190}, {16500,0.033595238}, {16600,0.017523810}, {16700,0.028361905}, {16800,0.017519048}, {16900,0.017952381}, {17000,0.017795238}, {17100,0.028504762}, {17200,0.017557143}, {17300,0.018223810}, {17400,0.017828571}, {17500,0.018357143}, {17600,0.028147619}, {17700,0.032357143}, {17800,0.018661905}, {17900,0.031980952}, {18000,0.018828571}, {18100,0.018995238}, {18200,0.034014286}, {18300,0.019157143}, {18400,0.019276190}, {18500,0.028104762}, {18600,0.019614286}, {18700,0.019623810}, {18800,0.030880952}, {18900,0.032942857}, {19000,0.031480952}, {19100,0.030838095}, {19200,0.020133333}, {19300,0.020366667}, {19400,0.033757143}, {19500,0.020576190}, {19600,0.020614286}, {19700,0.031761905}, {19800,0.020890476}, {19900,0.020980952}, {20000,0.036048077}};
data["big"]["Parametricity; beta"]["cbv"]["user"] = {{1,0.000018957}, {2,0.000018957}, {3,0.000037915}, {4,0.000052133}, {5,0.000037915}, {6,0.000000000}, {7,0.000014218}, {8,0.000000000}, {9,0.000018957}, {10,0.000075829}, {11,0.000028436}, {12,0.000018957}, {13,0.000018957}, {14,0.000014218}, {15,0.000037915}, {16,0.000052133}, {17,0.000047393}, {18,0.000080569}, {19,0.000075829}, {20,0.000033175}, {21,0.000052133}, {22,0.000085308}, {23,0.000056872}, {24,0.000047393}, {25,0.000071090}, {26,0.000090047}, {27,0.000052133}, {28,0.000018957}, {29,0.000047393}, {30,0.000052133}, {31,0.000094787}, {32,0.000066351}, {33,0.000090047}, {34,0.000056872}, {35,0.000052133}, {36,0.000123223}, {37,0.000056872}, {38,0.000075829}, {39,0.000075829}, {40,0.000085308}, {41,0.000033175}, {42,0.000109005}, {43,0.000056872}, {44,0.000075829}, {45,0.000066351}, {46,0.000085308}, {47,0.000094787}, {48,0.000014218}, {49,0.000090047}, {50,0.000090047}, {51,0.000037915}, {52,0.000109005}, {53,0.000109005}, {54,0.000018957}, {55,0.000137441}, {56,0.000052133}, {57,0.000033175}, {58,0.000635071}, {59,0.000066351}, {60,0.000161137}, {61,0.000151659}, {62,0.000066351}, {63,0.000071090}, {64,0.000090047}, {65,0.000161137}, {66,0.000071090}, {67,0.000052133}, {68,0.000099526}, {69,0.000104265}, {70,0.000113744}, {71,0.000071090}, {72,0.000109005}, {73,0.000123223}, {74,0.000123223}, {75,0.000090047}, {76,0.000066351}, {77,0.000000000}, {78,0.000071090}, {79,0.000099526}, {80,0.000104265}, {81,0.000071090}, {82,0.000071090}, {83,0.000094787}, {84,0.000090047}, {85,0.000175355}, {86,0.000109005}, {87,0.000127962}, {88,0.000071090}, {89,0.000052133}, {90,0.000099526}, {91,0.000033175}, {92,0.000118483}, {93,0.000170616}, {94,0.000047393}, {95,0.000109005}, {96,0.000047393}, {97,0.000161137}, {98,0.000213270}, {99,0.000123223}, {100,0.000052133}, {101,0.000132701}, {102,0.000132701}, {103,0.000113744}, {104,0.000099526}, {105,0.000075829}, {106,0.000037915}, {107,0.000142180}, {108,0.000113744}, {109,0.000127962}, {110,0.000165877}, {111,0.000075829}, {112,0.000137441}, {113,0.000047393}, {114,0.000028436}, {115,0.000085308}, {116,0.000052133}, {117,0.000118483}, {118,0.000080569}, {119,0.000071090}, {120,0.000180095}, {121,0.000312796}, {122,0.000085308}, {123,0.000208531}, {124,0.000113744}, {125,0.000118483}, {126,0.000194313}, {127,0.000066351}, {128,0.000203791}, {129,0.000123223}, {130,0.000099526}, {131,0.000170616}, {132,0.000142180}, {133,0.000104265}, {134,0.000175355}, {135,0.000156398}, {136,0.000236967}, {137,0.000071090}, {138,0.000113744}, {139,0.000109005}, {140,0.000104265}, {141,0.000194313}, {142,0.000118483}, {143,0.000203791}, {144,0.000170616}, {145,0.000222749}, {146,0.000099526}, {147,0.000075829}, {148,0.000137441}, {149,0.000113744}, {150,0.000246445}, {151,0.000180095}, {152,0.000123223}, {153,0.000075829}, {154,0.000085308}, {155,0.000080569}, {156,0.000165877}, {157,0.000165877}, {158,0.000298578}, {159,0.000132701}, {160,0.000189573}, {161,0.000099526}, {162,0.000137441}, {163,0.000265403}, {164,0.000099526}, {165,0.000142180}, {166,0.000151659}, {167,0.000208531}, {168,0.000042654}, {169,0.000175355}, {170,0.000151659}, {171,0.000184834}, {172,0.000184834}, {173,0.000146919}, {174,0.000151659}, {175,0.000109005}, {176,0.000156398}, {177,0.000203791}, {178,0.000251185}, {179,0.000071090}, {180,0.000194313}, {181,0.000236967}, {182,0.000099526}, {183,0.000161137}, {184,0.000165877}, {185,0.000075829}, {186,0.000132701}, {187,0.000175355}, {188,0.000236967}, {189,0.000213270}, {190,0.000199052}, {191,0.000132701}, {192,0.000184834}, {193,0.000251185}, {194,0.000165877}, {195,0.000156398}, {196,0.000232227}, {197,0.000199052}, {198,0.000170616}, {199,0.000175355}, {200,0.000151659}, {201,0.000227488}, {202,0.000227488}, {203,0.000151659}, {204,0.000184834}, {205,0.000104265}, {206,0.000170616}, {207,0.000521327}, {208,0.000104265}, {209,0.000246445}, {210,0.000213270}, {211,0.000265403}, {212,0.000142180}, {213,0.000170616}, {214,0.000327014}, {215,0.000222749}, {216,0.000265403}, {217,0.000161137}, {218,0.000303318}, {219,0.000203791}, {220,0.000232227}, {221,0.000142180}, {222,0.000270142}, {223,0.000213270}, {224,0.000289100}, {225,0.000232227}, {226,0.000180095}, {227,0.000236967}, {228,0.000170616}, {229,0.000322275}, {230,0.000260664}, {231,0.000199052}, {232,0.000270142}, {233,0.000123223}, {234,0.000227488}, {235,0.000199052}, {236,0.000251185}, {237,0.000218009}, {238,0.000322275}, {239,0.000189573}, {240,0.000180095}, {241,0.000246445}, {242,0.000184834}, {243,0.000194313}, {244,0.000285714}, {245,0.000138095}, {246,0.000257143}, {247,0.000166667}, {248,0.000247619}, {249,0.000285714}, {250,0.000200000}, {251,0.000100000}, {252,0.000271429}, {253,0.000214286}, {254,0.000252381}, {255,0.000247619}, {256,0.000152381}, {257,0.000380952}, {258,0.000195238}, {259,0.000204762}, {260,0.000252381}, {261,0.000285714}, {262,0.000276190}, {263,0.000295238}, {264,0.000209524}, {265,0.000214286}, {266,0.000209524}, {267,0.000323810}, {268,0.000280952}, {269,0.000242857}, {270,0.000209524}, {271,0.000200000}, {272,0.000352381}, {273,0.000123810}, {274,0.000261905}, {275,0.000428571}, {276,0.000195238}, {277,0.000333333}, {278,0.000261905}, {279,0.000257143}, {280,0.000257143}, {281,0.000242857}, {282,0.000204762}, {283,0.000247619}, {284,0.000285714}, {285,0.000242857}, {286,0.000300000}, {287,0.000261905}, {288,0.000285714}, {289,0.000271429}, {290,0.000261905}, {291,0.000295238}, {292,0.000285714}, {293,0.000309524}, {294,0.000261905}, {295,0.000242857}, {296,0.000366667}, {297,0.000319048}, {298,0.000309524}, {299,0.000276190}, {300,0.000204762}, {301,0.000352381}, {302,0.000261905}, {303,0.000333333}, {304,0.000347619}, {305,0.000238095}, {306,0.000238095}, {307,0.000261905}, {308,0.000242857}, {309,0.000323810}, {310,0.000295238}, {311,0.000371429}, {312,0.000247619}, {313,0.000161905}, {314,0.000309524}, {315,0.000209524}, {316,0.000309524}, {317,0.000266667}, {318,0.000261905}, {319,0.000276190}, {320,0.000176190}, {321,0.000385714}, {322,0.000390476}, {323,0.000219048}, {324,0.000190476}, {325,0.000271429}, {326,0.000323810}, {327,0.000300000}, {328,0.000157143}, {329,0.000347619}, {330,0.000295238}, {331,0.000376190}, {332,0.000719048}, {333,0.000200000}, {334,0.000352381}, {335,0.000290476}, {336,0.000238095}, {337,0.000319048}, {338,0.000247619}, {339,0.000285714}, {340,0.000328571}, {341,0.000300000}, {342,0.000190476}, {343,0.000352381}, {344,0.000238095}, {345,0.000423810}, {346,0.000371429}, {347,0.000390476}, {348,0.000371429}, {349,0.000414286}, {350,0.000300000}, {351,0.000171429}, {352,0.000357143}, {353,0.000314286}, {354,0.000257143}, {355,0.000252381}, {356,0.000166667}, {357,0.000295238}, {358,0.000304762}, {359,0.000266667}, {360,0.000309524}, {361,0.000257143}, {362,0.000261905}, {363,0.000514286}, {364,0.000371429}, {365,0.000309524}, {366,0.000314286}, {367,0.000261905}, {368,0.000442857}, {369,0.000400000}, {370,0.000376190}, {371,0.000180952}, {372,0.000285714}, {373,0.000223810}, {374,0.000219048}, {375,0.000142857}, {376,0.000423810}, {377,0.000380952}, {378,0.000295238}, {379,0.000266667}, {380,0.000323810}, {381,0.000404762}, {382,0.000390476}, {383,0.000371429}, {384,0.000323810}, {385,0.000328571}, {386,0.000323810}, {387,0.000357143}, {388,0.000204762}, {389,0.000333333}, {390,0.000304762}, {391,0.000276190}, {392,0.000261905}, {393,0.000300000}, {394,0.000319048}, {395,0.000214286}, {396,0.000280952}, {397,0.000300000}, {398,0.000180952}, {399,0.000233333}, {400,0.000442857}, {401,0.000400000}, {402,0.000366667}, {403,0.000380952}, {404,0.000300000}, {405,0.000304762}, {406,0.000300000}, {407,0.000300000}, {408,0.000314286}, {409,0.000352381}, {410,0.000333333}, {411,0.000366667}, {412,0.000214286}, {413,0.000419048}, {414,0.000304762}, {415,0.000242857}, {416,0.000380952}, {417,0.000447619}, {418,0.000285714}, {419,0.000371429}, {420,0.000314286}, {421,0.000242857}, {422,0.000271429}, {423,0.000366667}, {424,0.000404762}, {425,0.000285714}, {426,0.000352381}, {427,0.000366667}, {428,0.000376190}, {429,0.000285714}, {430,0.000442857}, {431,0.000338095}, {432,0.000304762}, {433,0.000171429}, {434,0.000480952}, {435,0.000295238}, {436,0.000409524}, {437,0.000328571}, {438,0.000314286}, {439,0.000490476}, {440,0.000314286}, {441,0.000442857}, {442,0.000328571}, {443,0.000285714}, {444,0.000300000}, {445,0.000580952}, {446,0.000242857}, {447,0.000423810}, {448,0.000271429}, {449,0.000271429}, {450,0.000261905}, {451,0.000252381}, {452,0.000376190}, {453,0.000514286}, {454,0.000304762}, {455,0.000319048}, {456,0.000285714}, {457,0.000404762}, {458,0.000266667}, {459,0.000809524}, {460,0.000352381}, {461,0.000357143}, {462,0.000385714}, {463,0.000314286}, {464,0.000319048}, {465,0.000533333}, {466,0.000533333}, {467,0.000680952}, {468,0.000323810}, {469,0.000380952}, {470,0.000519048}, {471,0.000414286}, {472,0.000328571}, {473,0.000323810}, {474,0.000357143}, {475,0.000523810}, {476,0.000333333}, {477,0.000338095}, {478,0.000342857}, {479,0.000304762}, {480,0.000400000}, {481,0.000433333}, {482,0.000380952}, {483,0.000380952}, {484,0.000319048}, {485,0.000380952}, {486,0.000319048}, {487,0.000423810}, {488,0.000433333}, {489,0.000423810}, {490,0.000261905}, {491,0.000438095}, {492,0.000400000}, {493,0.000400000}, {494,0.000361905}, {495,0.000423810}, {496,0.000385714}, {497,0.000271429}, {498,0.000528571}, {499,0.000395238}, {500,0.000514286}, {505,0.000419048}, {510,0.000428571}, {515,0.000533333}, {520,0.000376190}, {525,0.000314286}, {530,0.000438095}, {535,0.000342857}, {540,0.000480952}, {545,0.000504762}, {550,0.000428571}, {555,0.000504762}, {560,0.000666667}, {565,0.000504762}, {570,0.000557143}, {575,0.000585714}, {580,0.000538095}, {585,0.000471429}, {590,0.000542857}, {595,0.001271429}, {600,0.000504762}, {605,0.000523810}, {610,0.000485714}, {615,0.000490476}, {620,0.000404762}, {625,0.000476190}, {630,0.000390476}, {635,0.000547619}, {640,0.000566667}, {645,0.000371429}, {650,0.000480952}, {655,0.000438095}, {660,0.000371429}, {665,0.000452381}, {670,0.000471429}, {675,0.000480952}, {680,0.000523810}, {685,0.000385714}, {690,0.000423810}, {695,0.000366667}, {700,0.000471429}, {705,0.000595238}, {710,0.000580952}, {715,0.000571429}, {720,0.000519048}, {725,0.000704762}, {730,0.000519048}, {735,0.000485714}, {740,0.000471429}, {745,0.000785714}, {750,0.000442857}, {755,0.000571429}, {760,0.000814286}, {765,0.000614286}, {770,0.000523810}, {775,0.000538095}, {780,0.000500000}, {785,0.000509524}, {790,0.000619048}, {795,0.000633333}, {800,0.000690476}, {805,0.000747619}, {810,0.000642857}, {815,0.000676190}, {820,0.000800000}, {825,0.000714286}, {830,0.000523810}, {835,0.000757143}, {840,0.000676190}, {845,0.000833333}, {850,0.000680952}, {855,0.000885714}, {860,0.000609524}, {865,0.000657143}, {870,0.000947619}, {875,0.000866667}, {880,0.000604762}, {885,0.000719048}, {890,0.000590476}, {895,0.000752381}, {900,0.000880952}, {905,0.000742857}, {910,0.000719048}, {915,0.000690476}, {920,0.000761905}, {925,0.000761905}, {930,0.000738095}, {935,0.000752381}, {940,0.000690476}, {945,0.000671429}, {950,0.000790476}, {955,0.000814286}, {960,0.000795238}, {965,0.000633333}, {970,0.000790476}, {975,0.000861905}, {980,0.000661905}, {985,0.000895238}, {990,0.000733333}, {995,0.000619048}, {1000,0.000871429}, {1010,0.000833333}, {1020,0.000728571}, {1030,0.000814286}, {1040,0.000828571}, {1050,0.000652381}, {1060,0.000709524}, {1070,0.001052381}, {1080,0.000919048}, {1090,0.000895238}, {1100,0.000880952}, {1110,0.000942857}, {1120,0.000947619}, {1130,0.001028571}, {1140,0.000695238}, {1150,0.000833333}, {1160,0.000776190}, {1170,0.000909524}, {1180,0.001033333}, {1190,0.000790476}, {1200,0.001042857}, {1210,0.000995238}, {1220,0.000785714}, {1230,0.001028571}, {1240,0.001119048}, {1250,0.000890476}, {1260,0.000838095}, {1270,0.001061905}, {1280,0.000733333}, {1290,0.000900000}, {1300,0.000938095}, {1310,0.001052381}, {1320,0.000890476}, {1330,0.002228571}, {1340,0.000838095}, {1350,0.001314286}, {1360,0.001076190}, {1370,0.001061905}, {1380,0.001047619}, {1390,0.001085714}, {1400,0.000942857}, {1410,0.001257143}, {1420,0.001028571}, {1430,0.000933333}, {1440,0.001100000}, {1450,0.001038095}, {1460,0.001109524}, {1470,0.001100000}, {1480,0.001190476}, {1490,0.001071429}, {1500,0.001271429}, {1510,0.001480952}, {1520,0.001261905}, {1530,0.001238095}, {1540,0.000923810}, {1550,0.001171429}, {1560,0.001219048}, {1570,0.001061905}, {1580,0.001366667}, {1590,0.001228571}, {1600,0.001085714}, {1610,0.001242857}, {1620,0.001333333}, {1630,0.001157143}, {1640,0.001352381}, {1650,0.001390476}, {1660,0.001323810}, {1670,0.001147619}, {1680,0.001347619}, {1690,0.001419048}, {1700,0.001138095}, {1710,0.001357143}, {1720,0.001552381}, {1730,0.001476190}, {1740,0.001142857}, {1750,0.001600000}, {1760,0.001361905}, {1770,0.001490476}, {1780,0.001423810}, {1790,0.001514286}, {1800,0.001533333}, {1810,0.001347619}, {1820,0.001419048}, {1830,0.001633333}, {1840,0.001404762}, {1850,0.001428571}, {1860,0.001247619}, {1870,0.001485714}, {1880,0.003042857}, {1890,0.001609524}, {1900,0.001409524}, {1910,0.001795238}, {1920,0.001571429}, {1930,0.001509524}, {1940,0.001595238}, {1950,0.001471429}, {1960,0.001866667}, {1970,0.001733333}, {1980,0.001466667}, {1990,0.001580952}, {2000,0.001780952}, {2050,0.001428571}, {2100,0.001609524}, {2150,0.001428571}, {2200,0.001914286}, {2250,0.001933333}, {2300,0.001809524}, {2350,0.001914286}, {2400,0.001947619}, {2450,0.001752381}, {2500,0.002066667}, {2550,0.002171429}, {2600,0.002014286}, {2650,0.003923810}, {2700,0.002328571}, {2750,0.002300000}, {2800,0.002076190}, {2850,0.002119048}, {2900,0.002057143}, {2950,0.002261905}, {3000,0.002433333}, {3050,0.002519048}, {3100,0.002485714}, {3150,0.002728571}, {3200,0.002823810}, {3250,0.002680952}, {3300,0.002738095}, {3350,0.002804762}, {3400,0.002642857}, {3450,0.002828571}, {3500,0.002900000}, {3550,0.003076190}, {3600,0.002919048}, {3650,0.003052381}, {3700,0.003095238}, {3750,0.003109524}, {3800,0.003385714}, {3850,0.003247619}, {3900,0.003142857}, {3950,0.003066667}, {4000,0.005385714}, {4050,0.003333333}, {4100,0.003409524}, {4150,0.003414286}, {4200,0.003519048}, {4250,0.003519048}, {4300,0.003690476}, {4350,0.006842857}, {4400,0.003723810}, {4450,0.003761905}, {4500,0.003823810}, {4550,0.003842857}, {4600,0.003733333}, {4650,0.003895238}, {4700,0.003990476}, {4750,0.003966667}, {4800,0.004080952}, {4850,0.004152381}, {4900,0.004180952}, {4950,0.004233333}, {5000,0.004342857}, {5050,0.004361905}, {5100,0.004223810}, {5150,0.004476190}, {5200,0.004485714}, {5250,0.004504762}, {5300,0.004557143}, {5350,0.004676190}, {5400,0.009728571}, {5450,0.008109524}, {5500,0.004709524}, {5550,0.004923810}, {5600,0.004980952}, {5650,0.005052381}, {5700,0.005157143}, {5750,0.005014286}, {5800,0.008633333}, {5850,0.004942857}, {5900,0.005252381}, {5950,0.005100000}, {6000,0.005457143}, {6050,0.008376190}, {6100,0.005280952}, {6150,0.005290476}, {6200,0.005419048}, {6250,0.005342857}, {6300,0.005700000}, {6350,0.005538095}, {6400,0.010819048}, {6450,0.006009524}, {6500,0.005666667}, {6550,0.005852381}, {6600,0.005714286}, {6650,0.005842857}, {6700,0.006133333}, {6750,0.006138095}, {6800,0.005804762}, {6850,0.012000000}, {6900,0.006409524}, {6950,0.006128571}, {7000,0.006214286}, {7050,0.006333333}, {7100,0.006171429}, {7150,0.006419048}, {7200,0.019019048}, {7250,0.006742857}, {7300,0.015200000}, {7350,0.006638095}, {7400,0.013252381}, {7450,0.006338095}, {7500,0.014866667}, {7550,0.006761905}, {7600,0.011404762}, {7650,0.006952381}, {7700,0.006952381}, {7750,0.007071429}, {7800,0.007133333}, {7850,0.007085714}, {7900,0.007095238}, {7950,0.014061905}, {8000,0.007266667}, {8050,0.007404762}, {8100,0.013361905}, {8150,0.007552381}, {8200,0.007428571}, {8250,0.013161905}, {8300,0.007580952}, {8350,0.007733333}, {8400,0.007719048}, {8450,0.007328571}, {8500,0.007966667}, {8550,0.008080952}, {8600,0.015904762}, {8650,0.008090476}, {8700,0.008428571}, {8750,0.008371429}, {8800,0.008257143}, {8850,0.008280952}, {8900,0.008561905}, {8950,0.008980952}, {9000,0.008457143}, {9050,0.008628571}, {9100,0.013795238}, {9150,0.008957143}, {9200,0.009019048}, {9250,0.009190476}, {9300,0.008919048}, {9350,0.009019048}, {9400,0.009119048}, {9450,0.009261905}, {9500,0.008838095}, {9550,0.014828571}, {9600,0.009442857}, {9650,0.009204762}, {9700,0.016204762}, {9750,0.009671429}, {9800,0.009914286}, {9850,0.009838095}, {9900,0.009809524}, {9950,0.009700000}, {10000,0.017461905}, {10100,0.010133333}, {10200,0.016371429}, {10300,0.014809524}, {10400,0.010447619}, {10500,0.010590476}, {10600,0.010757143}, {10700,0.010819048}, {10800,0.011028571}, {10900,0.011157143}, {11000,0.018176190}, {11100,0.011466667}, {11200,0.011471429}, {11300,0.011471429}, {11400,0.011561905}, {11500,0.011795238}, {11600,0.011800000}, {11700,0.012238095}, {11800,0.021400000}, {11900,0.018980952}, {12000,0.012295238}, {12100,0.012519048}, {12200,0.012604762}, {12300,0.012538095}, {12400,0.024561905}, {12500,0.012800000}, {12600,0.013090476}, {12700,0.022233333}, {12800,0.019904762}, {12900,0.013109524}, {13000,0.013366667}, {13100,0.013823810}, {13200,0.020957143}, {13300,0.013533333}, {13400,0.013919048}, {13500,0.013738095}, {13600,0.013842857}, {13700,0.014247619}, {13800,0.013995238}, {13900,0.014376190}, {14000,0.020257143}, {14100,0.023114286}, {14200,0.014714286}, {14300,0.014519048}, {14400,0.014671429}, {14500,0.027728571}, {14600,0.014885714}, {14700,0.014976190}, {14800,0.015180952}, {14900,0.015204762}, {15000,0.014619048}, {15100,0.015676190}, {15200,0.015480952}, {15300,0.023514286}, {15400,0.016019048}, {15500,0.015947619}, {15600,0.024519048}, {15700,0.016166667}, {15800,0.015876190}, {15900,0.016600000}, {16000,0.026295238}, {16100,0.024180952}, {16200,0.016657143}, {16300,0.016704762}, {16400,0.029071429}, {16500,0.033585714}, {16600,0.017271429}, {16700,0.028542857}, {16800,0.017547619}, {16900,0.017923810}, {17000,0.017776190}, {17100,0.028576190}, {17200,0.017585714}, {17300,0.018233333}, {17400,0.017661905}, {17500,0.018228571}, {17600,0.028109524}, {17700,0.032476190}, {17800,0.018652381}, {17900,0.032090476}, {18000,0.018795238}, {18100,0.019171429}, {18200,0.033980952}, {18300,0.019290476}, {18400,0.019452381}, {18500,0.028342857}, {18600,0.019647619}, {18700,0.019780952}, {18800,0.030852381}, {18900,0.033180952}, {19000,0.031619048}, {19100,0.030928571}, {19200,0.020414286}, {19300,0.020590476}, {19400,0.034057143}, {19500,0.020771429}, {19600,0.020719048}, {19700,0.031847619}, {19800,0.021038095}, {19900,0.021071429}, {20000,0.036004808}};
data["big"]["Parametricity; beta"]["cbv"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000018957}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000037915}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000018957}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000018957}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000018957}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000018957}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000018957}, {178,0.000000000}, {179,0.000000000}, {180,0.000018957}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000014218}, {185,0.000000000}, {186,0.000018957}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000018957}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000037915}, {208,0.000000000}, {209,0.000000000}, {210,0.000018957}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000018957}, {225,0.000000000}, {226,0.000018957}, {227,0.000000000}, {228,0.000000000}, {229,0.000018957}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000018957}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000014286}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000019048}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000019048}, {279,0.000000000}, {280,0.000000000}, {281,0.000019048}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000019048}, {290,0.000000000}, {291,0.000000000}, {292,0.000019048}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000019048}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000019048}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000038095}, {331,0.000000000}, {332,0.000019048}, {333,0.000000000}, {334,0.000019048}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000019048}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000019048}, {361,0.000000000}, {362,0.000000000}, {363,0.000019048}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000019048}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000014286}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000019048}, {388,0.000033333}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000019048}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000019048}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000019048}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000019048}, {416,0.000000000}, {417,0.000000000}, {418,0.000019048}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000019048}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000019048}, {445,0.000000000}, {446,0.000038095}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000019048}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000019048}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000019048}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000019048}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000019048}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000019048}, {535,0.000000000}, {540,0.000000000}, {545,0.000014286}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000019048}, {580,0.000000000}, {585,0.000019048}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000019048}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000019048}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000019048}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000019048}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000019048}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000019048}, {840,0.000019048}, {845,0.000038095}, {850,0.000019048}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000019048}, {875,0.000000000}, {880,0.000019048}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000019048}, {920,0.000000000}, {925,0.000014286}, {930,0.000038095}, {935,0.000000000}, {940,0.000000000}, {945,0.000019048}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000019048}, {1000,0.000000000}, {1010,0.000019048}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000019048}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000038095}, {1090,0.000000000}, {1100,0.000014286}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000038095}, {1190,0.000000000}, {1200,0.000019048}, {1210,0.000019048}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000038095}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000019048}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000038095}, {1310,0.000000000}, {1320,0.000019048}, {1330,0.000038095}, {1340,0.000019048}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000019048}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000019048}, {1440,0.000019048}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000019048}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000019048}, {1520,0.000038095}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000038095}, {1600,0.000019048}, {1610,0.000000000}, {1620,0.000019048}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000019048}, {1660,0.000014286}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000019048}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000019048}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000019048}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000019048}, {1910,0.000000000}, {1920,0.000019048}, {1930,0.000000000}, {1940,0.000019048}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000019048}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000038095}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000038095}, {2650,0.000019048}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000038095}, {2950,0.000000000}, {3000,0.000019048}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000019048}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000019048}, {3650,0.000057143}, {3700,0.000019048}, {3750,0.000019048}, {3800,0.000038095}, {3850,0.000019048}, {3900,0.000000000}, {3950,0.000014286}, {4000,0.000090476}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000019048}, {4200,0.000000000}, {4250,0.000038095}, {4300,0.000000000}, {4350,0.000052381}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000019048}, {4550,0.000000000}, {4600,0.000019048}, {4650,0.000014286}, {4700,0.000000000}, {4750,0.000019048}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000038095}, {5050,0.000000000}, {5100,0.000033333}, {5150,0.000000000}, {5200,0.000000000}, {5250,0.000000000}, {5300,0.000019048}, {5350,0.000019048}, {5400,0.000000000}, {5450,0.000033333}, {5500,0.000019048}, {5550,0.000000000}, {5600,0.000000000}, {5650,0.000019048}, {5700,0.000000000}, {5750,0.000000000}, {5800,0.000076190}, {5850,0.000000000}, {5900,0.000000000}, {5950,0.000000000}, {6000,0.000000000}, {6050,0.000095238}, {6100,0.000000000}, {6150,0.000000000}, {6200,0.000000000}, {6250,0.000000000}, {6300,0.000000000}, {6350,0.000000000}, {6400,0.000038095}, {6450,0.000000000}, {6500,0.000000000}, {6550,0.000019048}, {6600,0.000038095}, {6650,0.000000000}, {6700,0.000000000}, {6750,0.000000000}, {6800,0.000038095}, {6850,0.000076190}, {6900,0.000019048}, {6950,0.000000000}, {7000,0.000000000}, {7050,0.000019048}, {7100,0.000038095}, {7150,0.000000000}, {7200,0.000152381}, {7250,0.000019048}, {7300,0.000228571}, {7350,0.000019048}, {7400,0.000247619}, {7450,0.000057143}, {7500,0.000128571}, {7550,0.000019048}, {7600,0.000104762}, {7650,0.000000000}, {7700,0.000019048}, {7750,0.000019048}, {7800,0.000000000}, {7850,0.000057143}, {7900,0.000000000}, {7950,0.000276190}, {8000,0.000000000}, {8050,0.000000000}, {8100,0.000057143}, {8150,0.000000000}, {8200,0.000019048}, {8250,0.000076190}, {8300,0.000000000}, {8350,0.000000000}, {8400,0.000019048}, {8450,0.000000000}, {8500,0.000019048}, {8550,0.000019048}, {8600,0.000057143}, {8650,0.000000000}, {8700,0.000000000}, {8750,0.000000000}, {8800,0.000019048}, {8850,0.000000000}, {8900,0.000000000}, {8950,0.000000000}, {9000,0.000019048}, {9050,0.000019048}, {9100,0.000090476}, {9150,0.000000000}, {9200,0.000000000}, {9250,0.000019048}, {9300,0.000019048}, {9350,0.000000000}, {9400,0.000000000}, {9450,0.000000000}, {9500,0.000000000}, {9550,0.000076190}, {9600,0.000000000}, {9650,0.000000000}, {9700,0.000019048}, {9750,0.000000000}, {9800,0.000000000}, {9850,0.000019048}, {9900,0.000000000}, {9950,0.000019048}, {10000,0.000000000}, {10100,0.000019048}, {10200,0.000114286}, {10300,0.000033333}, {10400,0.000000000}, {10500,0.000019048}, {10600,0.000000000}, {10700,0.000000000}, {10800,0.000019048}, {10900,0.000000000}, {11000,0.000038095}, {11100,0.000000000}, {11200,0.000038095}, {11300,0.000000000}, {11400,0.000000000}, {11500,0.000019048}, {11600,0.000019048}, {11700,0.000000000}, {11800,0.000000000}, {11900,0.000280952}, {12000,0.000000000}, {12100,0.000000000}, {12200,0.000000000}, {12300,0.000000000}, {12400,0.000000000}, {12500,0.000000000}, {12600,0.000000000}, {12700,0.000185714}, {12800,0.000000000}, {12900,0.000000000}, {13000,0.000038095}, {13100,0.000000000}, {13200,0.000266667}, {13300,0.000019048}, {13400,0.000038095}, {13500,0.000000000}, {13600,0.000000000}, {13700,0.000000000}, {13800,0.000019048}, {13900,0.000000000}, {14000,0.000000000}, {14100,0.000000000}, {14200,0.000014286}, {14300,0.000000000}, {14400,0.000038095}, {14500,0.000038095}, {14600,0.000019048}, {14700,0.000000000}, {14800,0.000019048}, {14900,0.000000000}, {15000,0.000019048}, {15100,0.000019048}, {15200,0.000000000}, {15300,0.000000000}, {15400,0.000000000}, {15500,0.000000000}, {15600,0.000019048}, {15700,0.000000000}, {15800,0.000019048}, {15900,0.000000000}, {16000,0.000000000}, {16100,0.000019048}, {16200,0.000000000}, {16300,0.000000000}, {16400,0.000000000}, {16500,0.000038095}, {16600,0.000000000}, {16700,0.000000000}, {16800,0.000000000}, {16900,0.000019048}, {17000,0.000000000}, {17100,0.000000000}, {17200,0.000000000}, {17300,0.000000000}, {17400,0.000000000}, {17500,0.000019048}, {17600,0.000000000}, {17700,0.000000000}, {17800,0.000019048}, {17900,0.000019048}, {18000,0.000019048}, {18100,0.000000000}, {18200,0.000000000}, {18300,0.000000000}, {18400,0.000019048}, {18500,0.000019048}, {18600,0.000000000}, {18700,0.000000000}, {18800,0.000000000}, {18900,0.000019048}, {19000,0.000000000}, {19100,0.000019048}, {19200,0.000000000}, {19300,0.000000000}, {19400,0.000000000}, {19500,0.000000000}, {19600,0.000019048}, {19700,0.000057143}, {19800,0.000019048}, {19900,0.000000000}, {20000,0.000000000}};
data["big"]["Parametricity; beta"]["eval lazy"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000009479}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000516588}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000009479}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000009479}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000516588}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.001014286}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.001019048}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000019048}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000976190}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.001000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000014286}, {431,0.000000000}, {432,0.000000000}, {433,0.000014286}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000004762}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000014286}, {444,0.001838095}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000004762}, {449,0.000000000}, {450,0.000000000}, {451,0.000004762}, {452,0.000004762}, {453,0.001919048}, {454,0.000004762}, {455,0.000000000}, {456,0.000009524}, {457,0.000019048}, {458,0.000009524}, {459,0.000000000}, {460,0.000014286}, {461,0.000023810}, {462,0.000019048}, {463,0.000009524}, {464,0.000009524}, {465,0.000014286}, {466,0.000028571}, {467,0.000023810}, {468,0.000028571}, {469,0.000028571}, {470,0.000033333}, {471,0.000042857}, {472,0.000038095}, {473,0.000019048}, {474,0.000014286}, {475,0.000014286}, {476,0.000019048}, {477,0.000052381}, {478,0.000047619}, {479,0.000042857}, {480,0.000061905}, {481,0.000042857}, {482,0.000061905}, {483,0.000076190}, {484,0.000066667}, {485,0.000057143}, {486,0.000085714}, {487,0.000042857}, {488,0.000066667}, {489,0.000023810}, {490,0.000042857}, {491,0.000076190}, {492,0.000100000}, {493,0.000061905}, {494,0.000095238}, {495,0.000114286}, {496,0.000109524}, {497,0.000119048}, {498,0.000128571}, {499,0.000185714}, {500,0.000171429}, {505,0.000195238}, {510,0.000319048}, {515,0.000428571}, {520,0.000552381}, {525,0.000604762}, {530,0.000704762}, {535,0.000819048}, {540,0.000900000}, {545,0.000928571}, {550,0.000942857}, {555,0.000976190}, {560,0.000990476}, {565,0.001000000}, {570,0.001000000}, {575,0.001019048}, {580,0.001000000}, {585,0.001000000}, {590,0.001000000}, {595,0.001000000}, {600,0.002842857}, {605,0.001000000}, {610,0.001028571}, {615,0.001000000}, {620,0.001000000}, {625,0.001000000}, {630,0.001000000}, {635,0.001000000}, {640,0.001000000}, {645,0.001000000}, {650,0.001000000}, {655,0.001000000}, {660,0.001000000}, {665,0.001000000}, {670,0.001000000}, {675,0.001028571}, {680,0.001000000}, {685,0.001000000}, {690,0.001000000}, {695,0.001000000}, {700,0.001000000}, {705,0.001000000}, {710,0.001000000}, {715,0.001000000}, {720,0.001000000}, {725,0.001000000}, {730,0.001000000}, {735,0.001019048}, {740,0.001000000}, {745,0.001000000}, {750,0.002661905}, {755,0.001000000}, {760,0.001000000}, {765,0.001000000}, {770,0.001000000}, {775,0.001000000}, {780,0.001000000}, {785,0.001000000}, {790,0.001000000}, {795,0.001000000}, {800,0.001000000}, {805,0.001000000}, {810,0.001000000}, {815,0.001000000}, {820,0.001000000}, {825,0.001000000}, {830,0.001000000}, {835,0.001000000}, {840,0.001000000}, {845,0.001000000}, {850,0.001000000}, {855,0.001000000}, {860,0.001000000}, {865,0.001000000}, {870,0.001000000}, {875,0.001000000}, {880,0.001000000}, {885,0.001000000}, {890,0.001000000}, {895,0.001000000}, {900,0.001000000}, {905,0.001000000}, {910,0.001000000}, {915,0.001000000}, {920,0.001000000}, {925,0.001004762}, {930,0.001004762}, {935,0.001000000}, {940,0.001000000}, {945,0.001009524}, {950,0.001019048}, {955,0.001019048}, {960,0.001028571}, {965,0.001019048}, {970,0.001033333}, {975,0.001028571}, {980,0.001061905}, {985,0.001076190}, {990,0.001090476}, {995,0.003895238}, {1000,0.001180952}, {1010,0.001333333}, {1020,0.001304762}, {1030,0.001466667}, {1040,0.001490476}, {1050,0.001552381}, {1060,0.001695238}, {1070,0.001809524}, {1080,0.001838095}, {1090,0.001895238}, {1100,0.001919048}, {1110,0.001947619}, {1120,0.001961905}, {1130,0.001985714}, {1140,0.002000000}, {1150,0.002000000}, {1160,0.002000000}, {1170,0.002019048}, {1180,0.002000000}, {1190,0.002000000}, {1200,0.002000000}, {1210,0.002000000}, {1220,0.002000000}, {1230,0.002000000}, {1240,0.002000000}, {1250,0.002000000}, {1260,0.005395238}, {1270,0.002000000}, {1280,0.002000000}, {1290,0.003852381}, {1300,0.002000000}, {1310,0.002061905}, {1320,0.002000000}, {1330,0.002000000}, {1340,0.002000000}, {1350,0.002000000}, {1360,0.005928571}, {1370,0.002000000}, {1380,0.002000000}, {1390,0.002000000}, {1400,0.002004762}, {1410,0.002000000}, {1420,0.002009524}, {1430,0.002004762}, {1440,0.002023810}, {1450,0.002033333}, {1460,0.002042857}, {1470,0.002061905}, {1480,0.002071429}, {1490,0.002138095}, {1500,0.002176190}, {1510,0.002238095}, {1520,0.002304762}, {1530,0.002395238}, {1540,0.002471429}, {1550,0.002485714}, {1560,0.002566667}, {1570,0.006628571}, {1580,0.002704762}, {1590,0.002733333}, {1600,0.002776190}, {1610,0.002871429}, {1620,0.002914286}, {1630,0.002914286}, {1640,0.002933333}, {1650,0.002961905}, {1660,0.002957143}, {1670,0.002976190}, {1680,0.002985714}, {1690,0.003000000}, {1700,0.003000000}, {1710,0.003000000}, {1720,0.003000000}, {1730,0.013152381}, {1740,0.003000000}, {1750,0.003000000}, {1760,0.003000000}, {1770,0.003000000}, {1780,0.003000000}, {1790,0.003000000}, {1800,0.003000000}, {1810,0.003000000}, {1820,0.003004762}, {1830,0.006304762}, {1840,0.003000000}, {1850,0.003000000}, {1860,0.003004762}, {1870,0.003000000}, {1880,0.003000000}, {1890,0.003004762}, {1900,0.003004762}, {1910,0.003000000}, {1920,0.003009524}, {1930,0.003023810}, {1940,0.004533333}, {1950,0.003038095}, {1960,0.003066667}, {1970,0.006385714}, {1980,0.003261905}, {1990,0.003133333}, {2000,0.003228571}, {2050,0.003414286}, {2100,0.003714286}, {2150,0.003900000}, {2200,0.003966667}, {2250,0.003995238}, {2300,0.004000000}, {2350,0.004000000}, {2400,0.004014286}, {2450,0.004071429}, {2500,0.004238095}, {2550,0.012590476}, {2600,0.004638095}, {2650,0.004857143}, {2700,0.004942857}, {2750,0.004971429}, {2800,0.010004762}, {2850,0.007928571}, {2900,0.005028571}, {2950,0.005076190}, {3000,0.005195238}, {3050,0.005371429}, {3100,0.005447619}, {3150,0.005771429}, {3200,0.005904762}, {3250,0.009723810}, {3300,0.006004762}, {3350,0.006104762}, {3400,0.006019048}, {3450,0.012119048}, {3500,0.006223810}, {3550,0.006385714}, {3600,0.014428571}, {3650,0.006585714}, {3700,0.015523810}, {3750,0.006900000}, {3800,0.012128571}, {3850,0.007104762}, {3900,0.007042857}, {3950,0.007104762}, {4000,0.007061905}, {4050,0.019223810}, {4100,0.007504762}, {4150,0.007657143}, {4200,0.007800000}, {4250,0.007880952}, {4300,0.007961905}, {4350,0.008023810}, {4400,0.008004762}, {4450,0.014500000}, {4500,0.024171429}, {4550,0.008352381}, {4600,0.008447619}, {4650,0.008614286}, {4700,0.008785714}, {4750,0.008885714}, {4800,0.008933333}, {4850,0.008985714}, {4900,0.009047619}, {4950,0.024785714}, {5000,0.014433333}, {5050,0.009133333}, {5100,0.009461905}, {5150,0.009880952}, {5200,0.009747619}, {5250,0.009852381}, {5300,0.024861905}, {5350,0.016061905}, {5400,0.009985714}, {5450,0.010371429}, {5500,0.010257143}, {5550,0.010357143}, {5600,0.010219048}, {5650,0.010795238}, {5700,0.027533333}, {5750,0.010576190}, {5800,0.010776190}, {5850,0.011180952}, {5900,0.011052381}, {5950,0.020652381}, {6000,0.011547619}, {6050,0.011347619}, {6100,0.018209524}, {6150,0.011866667}, {6200,0.011452381}, {6250,0.011666667}, {6300,0.011995238}, {6350,0.051871429}, {6400,0.011961905}, {6450,0.012100000}, {6500,0.012047619}, {6550,0.012233333}, {6600,0.017280952}, {6650,0.012652381}, {6700,0.023690476}, {6750,0.012957143}, {6800,0.040742857}, {6850,0.013119048}, {6900,0.024861905}, {6950,0.013128571}, {7000,0.018366667}, {7050,0.022542857}, {7100,0.013171429}, {7150,0.031000000}, {7200,0.014042857}, {7250,0.034409524}, {7300,0.014095238}, {7350,0.013800000}, {7400,0.014047619}, {7450,0.014519048}, {7500,0.021385714}, {7550,0.034376190}, {7600,0.014880952}, {7650,0.031876190}, {7700,0.014642857}, {7750,0.014776190}, {7800,0.014652381}, {7850,0.036804762}, {7900,0.036714286}, {7950,0.015585714}, {8000,0.014771429}, {8050,0.031280952}, {8100,0.015409524}, {8150,0.023485714}, {8200,0.015395238}, {8250,0.015504762}, {8300,0.043523810}, {8350,0.015961905}, {8400,0.016057143}, {8450,0.016204762}, {8500,0.036357143}, {8550,0.015947619}, {8600,0.016114286}, {8650,0.032447619}, {8700,0.060700000}, {8750,0.016671429}, {8800,0.016866667}, {8850,0.016647619}, {8900,0.024795238}, {8950,0.040571429}, {9000,0.017228571}, {9050,0.017300000}, {9100,0.017371429}, {9150,0.017333333}, {9200,0.017385714}, {9250,0.032509524}, {9300,0.041538095}, {9350,0.018004762}, {9400,0.018061905}, {9450,0.043766667}, {9500,0.037123810}, {9550,0.028019048}, {9600,0.017871429}, {9650,0.018700000}, {9700,0.018761905}, {9750,0.018580952}, {9800,0.018528571}, {9850,0.049761905}, {9900,0.028800000}, {9950,0.018476190}, {10000,0.019309524}, {10100,0.019214286}, {10200,0.049461905}, {10300,0.019519048}, {10400,0.020157143}, {10500,0.020195238}, {10600,0.064257143}, {10700,0.032457143}, {10800,0.020514286}, {10900,0.020261905}, {11000,0.021476190}, {11100,0.076800000}, {11200,0.021466667}, {11300,0.054957143}, {11400,0.022128571}, {11500,0.062033333}, {11600,0.022019048}, {11700,0.079480952}, {11800,0.022695238}, {11900,0.022652381}, {12000,0.074690476}, {12100,0.022947619}, {12200,0.041728571}, {12300,0.054271429}, {12400,0.047228571}, {12500,0.024142857}, {12600,0.058214286}, {12700,0.057476190}, {12800,0.036476190}, {12900,0.025095238}, {13000,0.024985714}, {13100,0.041447619}, {13200,0.040000000}, {13300,0.046614286}, {13400,0.065947619}, {13500,0.091671429}, {13600,0.058738095}, {13700,0.059266667}, {13800,0.068209524}, {13900,0.078509524}, {14000,0.084847619}, {14100,0.040309524}, {14200,0.026547619}, {14300,0.027433333}, {14400,0.027514286}, {14500,0.027523810}, {14600,0.074228571}, {14700,0.053823810}, {14800,0.038476190}, {14900,0.036695238}, {15000,0.070228571}, {15100,0.039690476}, {15200,0.028966667}, {15300,0.079738095}, {15400,0.029628571}, {15500,0.029285714}, {15600,0.093485714}, {15700,0.054066667}, {15800,0.072580952}, {15900,0.030509524}, {16000,0.060985714}, {16100,0.068714286}, {16200,0.070371429}, {16300,0.031290476}, {16400,0.090590476}, {16500,0.099833333}, {16600,0.031938095}, {16700,0.089904762}, {16800,0.036980952}, {16900,0.032361905}, {17000,0.064571429}, {17100,0.070809524}, {17200,0.056804762}, {17300,0.033080952}, {17400,0.057347619}, {17500,0.054042857}, {17600,0.086623810}, {17700,0.075914286}, {17800,0.033552381}, {17900,0.067695238}, {18000,0.034190476}, {18100,0.045290476}, {18200,0.070671429}, {18300,0.034757143}, {18400,0.034957143}, {18500,0.064909524}, {18600,0.074604762}, {18700,0.086076190}, {18800,0.075557143}, {18900,0.078790476}, {19000,0.078666667}, {19100,0.065700000}, {19200,0.079471429}, {19300,0.081790476}, {19400,0.068019048}, {19500,0.037442857}, {19600,0.037190476}, {19700,0.072966667}, {19800,0.047238095}, {19900,0.037728571}, {20000,0.069884615}};
data["big"]["Parametricity; beta"]["eval lazy"]["user"] = {{1,0.000071090}, {2,0.000071090}, {3,0.000033175}, {4,0.000052133}, {5,0.000014218}, {6,0.000052133}, {7,0.000066351}, {8,0.000028436}, {9,0.000090047}, {10,0.000033175}, {11,0.000132701}, {12,0.000052133}, {13,0.000014218}, {14,0.000047393}, {15,0.000052133}, {16,0.000028436}, {17,0.000056872}, {18,0.000052133}, {19,0.000109005}, {20,0.000071090}, {21,0.000018957}, {22,0.000085308}, {23,0.000066351}, {24,0.000066351}, {25,0.000175355}, {26,0.000066351}, {27,0.000137441}, {28,0.000137441}, {29,0.000066351}, {30,0.000127962}, {31,0.000037915}, {32,0.000066351}, {33,0.000118483}, {34,0.000061611}, {35,0.000170616}, {36,0.000113744}, {37,0.000037915}, {38,0.000184834}, {39,0.000123223}, {40,0.000146919}, {41,0.000127962}, {42,0.000104265}, {43,0.000165877}, {44,0.000104265}, {45,0.000104265}, {46,0.000090047}, {47,0.000109005}, {48,0.000156398}, {49,0.000123223}, {50,0.000075829}, {51,0.000104265}, {52,0.000151659}, {53,0.000208531}, {54,0.000099526}, {55,0.000118483}, {56,0.000146919}, {57,0.000118483}, {58,0.000180095}, {59,0.000109005}, {60,0.000151659}, {61,0.000137441}, {62,0.000151659}, {63,0.000165877}, {64,0.000161137}, {65,0.000109005}, {66,0.000194313}, {67,0.000251185}, {68,0.000161137}, {69,0.000137441}, {70,0.000142180}, {71,0.000099526}, {72,0.000123223}, {73,0.000137441}, {74,0.000127962}, {75,0.000180095}, {76,0.000213270}, {77,0.000227488}, {78,0.000180095}, {79,0.000156398}, {80,0.000227488}, {81,0.000066351}, {82,0.000161137}, {83,0.000189573}, {84,0.000246445}, {85,0.000132701}, {86,0.000274882}, {87,0.000194313}, {88,0.000161137}, {89,0.000118483}, {90,0.000127962}, {91,0.000218009}, {92,0.000236967}, {93,0.000194313}, {94,0.000270142}, {95,0.000151659}, {96,0.000194313}, {97,0.000303318}, {98,0.000189573}, {99,0.000260664}, {100,0.000398104}, {101,0.000241706}, {102,0.000218009}, {103,0.000175355}, {104,0.000341232}, {105,0.000255924}, {106,0.000170616}, {107,0.000289100}, {108,0.000222749}, {109,0.000194313}, {110,0.000180095}, {111,0.000194313}, {112,0.000146919}, {113,0.000137441}, {114,0.000222749}, {115,0.000246445}, {116,0.000341232}, {117,0.000241706}, {118,0.000161137}, {119,0.000218009}, {120,0.000218009}, {121,0.000199052}, {122,0.000265403}, {123,0.000208531}, {124,0.000161137}, {125,0.000213270}, {126,0.000364929}, {127,0.000289100}, {128,0.000236967}, {129,0.000279621}, {130,0.000184834}, {131,0.000180095}, {132,0.000303318}, {133,0.000255924}, {134,0.000327014}, {135,0.000274882}, {136,0.000379147}, {137,0.000260664}, {138,0.000274882}, {139,0.000421801}, {140,0.000327014}, {141,0.000360190}, {142,0.000317536}, {143,0.000208531}, {144,0.000251185}, {145,0.000255924}, {146,0.000270142}, {147,0.000360190}, {148,0.000407583}, {149,0.000867299}, {150,0.000303318}, {151,0.000270142}, {152,0.000251185}, {153,0.000322275}, {154,0.000331754}, {155,0.000308057}, {156,0.000407583}, {157,0.000251185}, {158,0.000289100}, {159,0.000270142}, {160,0.000398104}, {161,0.000379147}, {162,0.000284360}, {163,0.000345972}, {164,0.000360190}, {165,0.000298578}, {166,0.000436019}, {167,0.000279621}, {168,0.000289100}, {169,0.000303318}, {170,0.000312796}, {171,0.000364929}, {172,0.000379147}, {173,0.000284360}, {174,0.000298578}, {175,0.000436019}, {176,0.000104265}, {177,0.000345972}, {178,0.000317536}, {179,0.000355450}, {180,0.000279621}, {181,0.000322275}, {182,0.000246445}, {183,0.000554502}, {184,0.000360190}, {185,0.000165877}, {186,0.000393365}, {187,0.000402844}, {188,0.000398104}, {189,0.000995261}, {190,0.000369668}, {191,0.000360190}, {192,0.000445498}, {193,0.000270142}, {194,0.000364929}, {195,0.000360190}, {196,0.000232227}, {197,0.000511848}, {198,0.000355450}, {199,0.000402844}, {200,0.000507109}, {201,0.000350711}, {202,0.000355450}, {203,0.000364929}, {204,0.000369668}, {205,0.000331754}, {206,0.000393365}, {207,0.000270142}, {208,0.000232227}, {209,0.000483412}, {210,0.000554502}, {211,0.000450237}, {212,0.000327014}, {213,0.000364929}, {214,0.000426540}, {215,0.000426540}, {216,0.000526066}, {217,0.000497630}, {218,0.000246445}, {219,0.000279621}, {220,0.000383886}, {221,0.000355450}, {222,0.000417062}, {223,0.000412322}, {224,0.000398104}, {225,0.000161137}, {226,0.000469194}, {227,0.000274882}, {228,0.000407583}, {229,0.000535545}, {230,0.000393365}, {231,0.000436019}, {232,0.000473934}, {233,0.000417062}, {234,0.000530806}, {235,0.000402844}, {236,0.000521327}, {237,0.000606635}, {238,0.000402844}, {239,0.000355450}, {240,0.000393365}, {241,0.000469194}, {242,0.000355450}, {243,0.000327014}, {244,0.000538095}, {245,0.000452381}, {246,0.000371429}, {247,0.000342857}, {248,0.000280952}, {249,0.000414286}, {250,0.000480952}, {251,0.000561905}, {252,0.000347619}, {253,0.000447619}, {254,0.001161905}, {255,0.000414286}, {256,0.000400000}, {257,0.000414286}, {258,0.000542857}, {259,0.000395238}, {260,0.000733333}, {261,0.000423810}, {262,0.000533333}, {263,0.000485714}, {264,0.000371429}, {265,0.000466667}, {266,0.000490476}, {267,0.000376190}, {268,0.000352381}, {269,0.000414286}, {270,0.000485714}, {271,0.000442857}, {272,0.000428571}, {273,0.000866667}, {274,0.000338095}, {275,0.000376190}, {276,0.000714286}, {277,0.000423810}, {278,0.000528571}, {279,0.000328571}, {280,0.000466667}, {281,0.000514286}, {282,0.000585714}, {283,0.000361905}, {284,0.000633333}, {285,0.000500000}, {286,0.000366667}, {287,0.000557143}, {288,0.000514286}, {289,0.000485714}, {290,0.000457143}, {291,0.000595238}, {292,0.000485714}, {293,0.000485714}, {294,0.000661905}, {295,0.001342857}, {296,0.000414286}, {297,0.000561905}, {298,0.000761905}, {299,0.000485714}, {300,0.000628571}, {301,0.000523810}, {302,0.000647619}, {303,0.000600000}, {304,0.000528571}, {305,0.000666667}, {306,0.000519048}, {307,0.000409524}, {308,0.000495238}, {309,0.000514286}, {310,0.000685714}, {311,0.000542857}, {312,0.000604762}, {313,0.000423810}, {314,0.000485714}, {315,0.000523810}, {316,0.000628571}, {317,0.000609524}, {318,0.000614286}, {319,0.000590476}, {320,0.000538095}, {321,0.000547619}, {322,0.000585714}, {323,0.000552381}, {324,0.000609524}, {325,0.000590476}, {326,0.000695238}, {327,0.000666667}, {328,0.000485714}, {329,0.000533333}, {330,0.000585714}, {331,0.000590476}, {332,0.000709524}, {333,0.000576190}, {334,0.000457143}, {335,0.000523810}, {336,0.000547619}, {337,0.000533333}, {338,0.000452381}, {339,0.000652381}, {340,0.000680952}, {341,0.001461905}, {342,0.000633333}, {343,0.000604762}, {344,0.000604762}, {345,0.000547619}, {346,0.000542857}, {347,0.000542857}, {348,0.000595238}, {349,0.000642857}, {350,0.000685714}, {351,0.000609524}, {352,0.000671429}, {353,0.000647619}, {354,0.000652381}, {355,0.000614286}, {356,0.000580952}, {357,0.000461905}, {358,0.000704762}, {359,0.000785714}, {360,0.000528571}, {361,0.000485714}, {362,0.000690476}, {363,0.000647619}, {364,0.000633333}, {365,0.000790476}, {366,0.000590476}, {367,0.000519048}, {368,0.000614286}, {369,0.000600000}, {370,0.000800000}, {371,0.000809524}, {372,0.000552381}, {373,0.000661905}, {374,0.000638095}, {375,0.000566667}, {376,0.001614286}, {377,0.000604762}, {378,0.000514286}, {379,0.000542857}, {380,0.000490476}, {381,0.000719048}, {382,0.000733333}, {383,0.000628571}, {384,0.000638095}, {385,0.000680952}, {386,0.000590476}, {387,0.000647619}, {388,0.000585714}, {389,0.000704762}, {390,0.000704762}, {391,0.000695238}, {392,0.000633333}, {393,0.000580952}, {394,0.000600000}, {395,0.000633333}, {396,0.000790476}, {397,0.000666667}, {398,0.000704762}, {399,0.000780952}, {400,0.000695238}, {401,0.000761905}, {402,0.000628571}, {403,0.000714286}, {404,0.000704762}, {405,0.000666667}, {406,0.000719048}, {407,0.000723810}, {408,0.000671429}, {409,0.000838095}, {410,0.000566667}, {411,0.000623810}, {412,0.000723810}, {413,0.000733333}, {414,0.000880952}, {415,0.000757143}, {416,0.000676190}, {417,0.000814286}, {418,0.000638095}, {419,0.000790476}, {420,0.000780952}, {421,0.000709524}, {422,0.000714286}, {423,0.000676190}, {424,0.000619048}, {425,0.000714286}, {426,0.000671429}, {427,0.000842857}, {428,0.000771429}, {429,0.001004762}, {430,0.000623810}, {431,0.000657143}, {432,0.000852381}, {433,0.001000000}, {434,0.000828571}, {435,0.000738095}, {436,0.000819048}, {437,0.000619048}, {438,0.000747619}, {439,0.000857143}, {440,0.000766667}, {441,0.000747619}, {442,0.000861905}, {443,0.000790476}, {444,0.002114286}, {445,0.000723810}, {446,0.000885714}, {447,0.000738095}, {448,0.000828571}, {449,0.000585714}, {450,0.000823810}, {451,0.000680952}, {452,0.000561905}, {453,0.002342857}, {454,0.000657143}, {455,0.000795238}, {456,0.000814286}, {457,0.000638095}, {458,0.000871429}, {459,0.000804762}, {460,0.000714286}, {461,0.000757143}, {462,0.000647619}, {463,0.000957143}, {464,0.000919048}, {465,0.000942857}, {466,0.000819048}, {467,0.000752381}, {468,0.000747619}, {469,0.000866667}, {470,0.000680952}, {471,0.000871429}, {472,0.000857143}, {473,0.000804762}, {474,0.000752381}, {475,0.000614286}, {476,0.000828571}, {477,0.000785714}, {478,0.000842857}, {479,0.000914286}, {480,0.000828571}, {481,0.000900000}, {482,0.001004762}, {483,0.000857143}, {484,0.000971429}, {485,0.000795238}, {486,0.000800000}, {487,0.000928571}, {488,0.000876190}, {489,0.000795238}, {490,0.000852381}, {491,0.000919048}, {492,0.000804762}, {493,0.000942857}, {494,0.000757143}, {495,0.000928571}, {496,0.000947619}, {497,0.001019048}, {498,0.000695238}, {499,0.000800000}, {500,0.001033333}, {505,0.000771429}, {510,0.000866667}, {515,0.000785714}, {520,0.000833333}, {525,0.000957143}, {530,0.000976190}, {535,0.001052381}, {540,0.000923810}, {545,0.000885714}, {550,0.000804762}, {555,0.000957143}, {560,0.001076190}, {565,0.001014286}, {570,0.000995238}, {575,0.001157143}, {580,0.001038095}, {585,0.001066667}, {590,0.001052381}, {595,0.000942857}, {600,0.002771429}, {605,0.001080952}, {610,0.000952381}, {615,0.001109524}, {620,0.001009524}, {625,0.001142857}, {630,0.001361905}, {635,0.001142857}, {640,0.001085714}, {645,0.001171429}, {650,0.001071429}, {655,0.001333333}, {660,0.001171429}, {665,0.000961905}, {670,0.001223810}, {675,0.001247619}, {680,0.001261905}, {685,0.001228571}, {690,0.001214286}, {695,0.001171429}, {700,0.001171429}, {705,0.001295238}, {710,0.001180952}, {715,0.001290476}, {720,0.001038095}, {725,0.001400000}, {730,0.001390476}, {735,0.001195238}, {740,0.001157143}, {745,0.001214286}, {750,0.002790476}, {755,0.001209524}, {760,0.001352381}, {765,0.001280952}, {770,0.001166667}, {775,0.001357143}, {780,0.001185714}, {785,0.001195238}, {790,0.001328571}, {795,0.001309524}, {800,0.001442857}, {805,0.001452381}, {810,0.001685714}, {815,0.001557143}, {820,0.001480952}, {825,0.001600000}, {830,0.001309524}, {835,0.001780952}, {840,0.001433333}, {845,0.001514286}, {850,0.001576190}, {855,0.001685714}, {860,0.001447619}, {865,0.001533333}, {870,0.001514286}, {875,0.001500000}, {880,0.001580952}, {885,0.001638095}, {890,0.001452381}, {895,0.001566667}, {900,0.001614286}, {905,0.001566667}, {910,0.001623810}, {915,0.001576190}, {920,0.001752381}, {925,0.001776190}, {930,0.001371429}, {935,0.001490476}, {940,0.001571429}, {945,0.001671429}, {950,0.001609524}, {955,0.001738095}, {960,0.001628571}, {965,0.001438095}, {970,0.001838095}, {975,0.001704762}, {980,0.001566667}, {985,0.001842857}, {990,0.001690476}, {995,0.004042857}, {1000,0.001728571}, {1010,0.001723810}, {1020,0.001776190}, {1030,0.001852381}, {1040,0.001857143}, {1050,0.001961905}, {1060,0.001861905}, {1070,0.001871429}, {1080,0.002100000}, {1090,0.002100000}, {1100,0.001709524}, {1110,0.001709524}, {1120,0.001861905}, {1130,0.001971429}, {1140,0.002114286}, {1150,0.001947619}, {1160,0.002052381}, {1170,0.002233333}, {1180,0.002104762}, {1190,0.001900000}, {1200,0.001938095}, {1210,0.002057143}, {1220,0.002133333}, {1230,0.002352381}, {1240,0.002385714}, {1250,0.002314286}, {1260,0.005638095}, {1270,0.001985714}, {1280,0.002347619}, {1290,0.004009524}, {1300,0.002452381}, {1310,0.002471429}, {1320,0.002395238}, {1330,0.002552381}, {1340,0.002347619}, {1350,0.002195238}, {1360,0.006152381}, {1370,0.002414286}, {1380,0.002395238}, {1390,0.002471429}, {1400,0.002490476}, {1410,0.002209524}, {1420,0.002671429}, {1430,0.002409524}, {1440,0.002552381}, {1450,0.002652381}, {1460,0.002671429}, {1470,0.002790476}, {1480,0.002671429}, {1490,0.002685714}, {1500,0.002633333}, {1510,0.002538095}, {1520,0.002619048}, {1530,0.002704762}, {1540,0.003061905}, {1550,0.002733333}, {1560,0.002928571}, {1570,0.006957143}, {1580,0.002742857}, {1590,0.002847619}, {1600,0.002757143}, {1610,0.002814286}, {1620,0.002847619}, {1630,0.002947619}, {1640,0.002890476}, {1650,0.002909524}, {1660,0.002742857}, {1670,0.002952381}, {1680,0.002833333}, {1690,0.002885714}, {1700,0.002847619}, {1710,0.002971429}, {1720,0.003128571}, {1730,0.013033333}, {1740,0.003128571}, {1750,0.003066667}, {1760,0.003133333}, {1770,0.003090476}, {1780,0.003176190}, {1790,0.003090476}, {1800,0.003076190}, {1810,0.003114286}, {1820,0.003161905}, {1830,0.006238095}, {1840,0.003090476}, {1850,0.003252381}, {1860,0.003261905}, {1870,0.003371429}, {1880,0.003304762}, {1890,0.003328571}, {1900,0.003295238}, {1910,0.003304762}, {1920,0.003376190}, {1930,0.003300000}, {1940,0.004695238}, {1950,0.003466667}, {1960,0.003514286}, {1970,0.006600000}, {1980,0.003500000}, {1990,0.003400000}, {2000,0.003461905}, {2050,0.003633333}, {2100,0.003661905}, {2150,0.003776190}, {2200,0.003947619}, {2250,0.004038095}, {2300,0.004076190}, {2350,0.004252381}, {2400,0.004314286}, {2450,0.004223810}, {2500,0.004314286}, {2550,0.012519048}, {2600,0.004604762}, {2650,0.004657143}, {2700,0.004814286}, {2750,0.004923810}, {2800,0.010038095}, {2850,0.008157143}, {2900,0.005014286}, {2950,0.005228571}, {3000,0.005185714}, {3050,0.005533333}, {3100,0.005385714}, {3150,0.005538095}, {3200,0.005690476}, {3250,0.009600000}, {3300,0.005738095}, {3350,0.006061905}, {3400,0.005838095}, {3450,0.012019048}, {3500,0.006285714}, {3550,0.006428571}, {3600,0.014266667}, {3650,0.006452381}, {3700,0.015309524}, {3750,0.006719048}, {3800,0.011819048}, {3850,0.006833333}, {3900,0.007061905}, {3950,0.006847619}, {4000,0.007019048}, {4050,0.018752381}, {4100,0.007361905}, {4150,0.007509524}, {4200,0.007514286}, {4250,0.007709524}, {4300,0.007676190}, {4350,0.008080952}, {4400,0.007966667}, {4450,0.014514286}, {4500,0.023895238}, {4550,0.008442857}, {4600,0.008876190}, {4650,0.008547619}, {4700,0.008780952}, {4750,0.008480952}, {4800,0.008728571}, {4850,0.008980952}, {4900,0.009361905}, {4950,0.024723810}, {5000,0.014385714}, {5050,0.009085714}, {5100,0.009623810}, {5150,0.009771429}, {5200,0.009819048}, {5250,0.009838095}, {5300,0.024695238}, {5350,0.016128571}, {5400,0.010052381}, {5450,0.010452381}, {5500,0.010414286}, {5550,0.010733333}, {5600,0.010314286}, {5650,0.011119048}, {5700,0.027157143}, {5750,0.010623810}, {5800,0.010966667}, {5850,0.011490476}, {5900,0.011352381}, {5950,0.020785714}, {6000,0.011671429}, {6050,0.011647619}, {6100,0.018685714}, {6150,0.012280952}, {6200,0.011833333}, {6250,0.012057143}, {6300,0.012314286}, {6350,0.051376190}, {6400,0.012333333}, {6450,0.012414286}, {6500,0.012400000}, {6550,0.012604762}, {6600,0.017623810}, {6650,0.012995238}, {6700,0.024042857}, {6750,0.013338095}, {6800,0.040138095}, {6850,0.013261905}, {6900,0.024852381}, {6950,0.013604762}, {7000,0.018500000}, {7050,0.022457143}, {7100,0.013576190}, {7150,0.030761905}, {7200,0.014304762}, {7250,0.033980952}, {7300,0.014223810}, {7350,0.013995238}, {7400,0.014509524}, {7450,0.014709524}, {7500,0.021485714}, {7550,0.033890476}, {7600,0.014866667}, {7650,0.031485714}, {7700,0.014790476}, {7750,0.015095238}, {7800,0.014771429}, {7850,0.036319048}, {7900,0.036252381}, {7950,0.015790476}, {8000,0.015042857}, {8050,0.031171429}, {8100,0.015480952}, {8150,0.023276190}, {8200,0.015576190}, {8250,0.015480952}, {8300,0.043042857}, {8350,0.015733333}, {8400,0.016066667}, {8450,0.016385714}, {8500,0.036276190}, {8550,0.016071429}, {8600,0.016319048}, {8650,0.032228571}, {8700,0.060357143}, {8750,0.016528571}, {8800,0.016909524}, {8850,0.016719048}, {8900,0.025066667}, {8950,0.040000000}, {9000,0.017366667}, {9050,0.017509524}, {9100,0.017119048}, {9150,0.017333333}, {9200,0.017219048}, {9250,0.032219048}, {9300,0.041185714}, {9350,0.018042857}, {9400,0.017819048}, {9450,0.043723810}, {9500,0.037300000}, {9550,0.028104762}, {9600,0.017890476}, {9650,0.018585714}, {9700,0.018538095}, {9750,0.018600000}, {9800,0.018604762}, {9850,0.049833333}, {9900,0.028742857}, {9950,0.018352381}, {10000,0.019414286}, {10100,0.019166667}, {10200,0.049457143}, {10300,0.019361905}, {10400,0.020238095}, {10500,0.020285714}, {10600,0.063919048}, {10700,0.032476190}, {10800,0.020528571}, {10900,0.020076190}, {11000,0.021457143}, {11100,0.076761905}, {11200,0.021609524}, {11300,0.054890476}, {11400,0.022471429}, {11500,0.062209524}, {11600,0.022128571}, {11700,0.079490476}, {11800,0.022904762}, {11900,0.022995238}, {12000,0.074109524}, {12100,0.023342857}, {12200,0.041528571}, {12300,0.054385714}, {12400,0.046857143}, {12500,0.024490476}, {12600,0.057857143}, {12700,0.057623810}, {12800,0.036652381}, {12900,0.025161905}, {13000,0.025347619}, {13100,0.041042857}, {13200,0.039966667}, {13300,0.046647619}, {13400,0.065590476}, {13500,0.090866667}, {13600,0.058838095}, {13700,0.059323810}, {13800,0.068176190}, {13900,0.078147619}, {14000,0.084847619}, {14100,0.040400000}, {14200,0.026533333}, {14300,0.027419048}, {14400,0.027247619}, {14500,0.027257143}, {14600,0.074347619}, {14700,0.054014286}, {14800,0.038357143}, {14900,0.036638095}, {15000,0.070104762}, {15100,0.039461905}, {15200,0.028638095}, {15300,0.079333333}, {15400,0.029471429}, {15500,0.029119048}, {15600,0.093252381}, {15700,0.053961905}, {15800,0.072519048}, {15900,0.030557143}, {16000,0.060947619}, {16100,0.068528571}, {16200,0.070185714}, {16300,0.031361905}, {16400,0.090604762}, {16500,0.099833333}, {16600,0.032104762}, {16700,0.089828571}, {16800,0.037009524}, {16900,0.032476190}, {17000,0.064557143}, {17100,0.070614286}, {17200,0.057185714}, {17300,0.033223810}, {17400,0.057366667}, {17500,0.054052381}, {17600,0.086561905}, {17700,0.075919048}, {17800,0.033457143}, {17900,0.067814286}, {18000,0.034228571}, {18100,0.045652381}, {18200,0.071119048}, {18300,0.035038095}, {18400,0.035104762}, {18500,0.065076190}, {18600,0.074790476}, {18700,0.086219048}, {18800,0.075880952}, {18900,0.078909524}, {19000,0.078652381}, {19100,0.065666667}, {19200,0.079500000}, {19300,0.081880952}, {19400,0.068138095}, {19500,0.037680952}, {19600,0.037366667}, {19700,0.073028571}, {19800,0.047357143}, {19900,0.037771429}, {20000,0.069903846}};
data["big"]["Parametricity; beta"]["eval lazy"]["system"] = {{1,0.000018957}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000018957}, {17,0.000000000}, {18,0.000000000}, {19,0.000018957}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000018957}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000018957}, {54,0.000018957}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000018957}, {63,0.000000000}, {64,0.000018957}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000018957}, {89,0.000000000}, {90,0.000000000}, {91,0.000018957}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000037915}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000018957}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000018957}, {127,0.000000000}, {128,0.000018957}, {129,0.000018957}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000018957}, {139,0.000000000}, {140,0.000000000}, {141,0.000018957}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000037915}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000018957}, {173,0.000000000}, {174,0.000018957}, {175,0.000000000}, {176,0.000018957}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000018957}, {187,0.000000000}, {188,0.000000000}, {189,0.000071090}, {190,0.000018957}, {191,0.000000000}, {192,0.000018957}, {193,0.000000000}, {194,0.000018957}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000018957}, {199,0.000000000}, {200,0.000000000}, {201,0.000018957}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000018957}, {208,0.000000000}, {209,0.000018957}, {210,0.000018957}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000018957}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000018957}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000018957}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000018957}, {241,0.000000000}, {242,0.000018957}, {243,0.000000000}, {244,0.000000000}, {245,0.000019048}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000019048}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000019048}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000019048}, {274,0.000019048}, {275,0.000019048}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000019048}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000019048}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000019048}, {293,0.000000000}, {294,0.000019048}, {295,0.000038095}, {296,0.000000000}, {297,0.000000000}, {298,0.000019048}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000019048}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000019048}, {308,0.000000000}, {309,0.000000000}, {310,0.000019048}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000014286}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000019048}, {329,0.000019048}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000019048}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000019048}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000019048}, {357,0.000000000}, {358,0.000019048}, {359,0.000000000}, {360,0.000019048}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000019048}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000019048}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000019048}, {376,0.000057143}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000019048}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000019048}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000019048}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000019048}, {401,0.000000000}, {402,0.000019048}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000019048}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000019048}, {414,0.000000000}, {415,0.000019048}, {416,0.000038095}, {417,0.000000000}, {418,0.000019048}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000019048}, {424,0.000019048}, {425,0.000019048}, {426,0.000019048}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000019048}, {437,0.000000000}, {438,0.000000000}, {439,0.000019048}, {440,0.000019048}, {441,0.000019048}, {442,0.000019048}, {443,0.000000000}, {444,0.000095238}, {445,0.000019048}, {446,0.000019048}, {447,0.000019048}, {448,0.000000000}, {449,0.000000000}, {450,0.000019048}, {451,0.000019048}, {452,0.000000000}, {453,0.000019048}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000019048}, {459,0.000019048}, {460,0.000019048}, {461,0.000000000}, {462,0.000019048}, {463,0.000000000}, {464,0.000000000}, {465,0.000019048}, {466,0.000014286}, {467,0.000000000}, {468,0.000019048}, {469,0.000000000}, {470,0.000019048}, {471,0.000038095}, {472,0.000038095}, {473,0.000000000}, {474,0.000019048}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000019048}, {482,0.000000000}, {483,0.000000000}, {484,0.000019048}, {485,0.000000000}, {486,0.000038095}, {487,0.000019048}, {488,0.000019048}, {489,0.000000000}, {490,0.000019048}, {491,0.000000000}, {492,0.000038095}, {493,0.000000000}, {494,0.000000000}, {495,0.000019048}, {496,0.000014286}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000019048}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000019048}, {525,0.000019048}, {530,0.000000000}, {535,0.000000000}, {540,0.000019048}, {545,0.000000000}, {550,0.000019048}, {555,0.000019048}, {560,0.000000000}, {565,0.000019048}, {570,0.000019048}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000019048}, {600,0.000019048}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000019048}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000019048}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000019048}, {690,0.000000000}, {695,0.000000000}, {700,0.000019048}, {705,0.000019048}, {710,0.000019048}, {715,0.000038095}, {720,0.000019048}, {725,0.000019048}, {730,0.000000000}, {735,0.000019048}, {740,0.000000000}, {745,0.000000000}, {750,0.000038095}, {755,0.000019048}, {760,0.000000000}, {765,0.000000000}, {770,0.000038095}, {775,0.000000000}, {780,0.000057143}, {785,0.000000000}, {790,0.000019048}, {795,0.000038095}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000038095}, {825,0.000019048}, {830,0.000019048}, {835,0.000000000}, {840,0.000000000}, {845,0.000019048}, {850,0.000000000}, {855,0.000000000}, {860,0.000019048}, {865,0.000000000}, {870,0.000019048}, {875,0.000000000}, {880,0.000019048}, {885,0.000000000}, {890,0.000038095}, {895,0.000057143}, {900,0.000019048}, {905,0.000019048}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000052381}, {995,0.000057143}, {1000,0.000038095}, {1010,0.000000000}, {1020,0.000052381}, {1030,0.000019048}, {1040,0.000038095}, {1050,0.000019048}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000033333}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000019048}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000019048}, {1220,0.000033333}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000014286}, {1260,0.000019048}, {1270,0.000000000}, {1280,0.000019048}, {1290,0.000057143}, {1300,0.000019048}, {1310,0.000019048}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000019048}, {1360,0.000209524}, {1370,0.000019048}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000038095}, {1420,0.000000000}, {1430,0.000019048}, {1440,0.000000000}, {1450,0.000038095}, {1460,0.000019048}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000038095}, {1510,0.000019048}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000038095}, {1550,0.000019048}, {1560,0.000019048}, {1570,0.000095238}, {1580,0.000038095}, {1590,0.000038095}, {1600,0.000019048}, {1610,0.000038095}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000038095}, {1660,0.000038095}, {1670,0.000000000}, {1680,0.000019048}, {1690,0.000000000}, {1700,0.000019048}, {1710,0.000000000}, {1720,0.000019048}, {1730,0.000357143}, {1740,0.000000000}, {1750,0.000019048}, {1760,0.000019048}, {1770,0.000000000}, {1780,0.000038095}, {1790,0.000000000}, {1800,0.000019048}, {1810,0.000038095}, {1820,0.000019048}, {1830,0.000057143}, {1840,0.000019048}, {1850,0.000000000}, {1860,0.000019048}, {1870,0.000019048}, {1880,0.000019048}, {1890,0.000057143}, {1900,0.000019048}, {1910,0.000019048}, {1920,0.000019048}, {1930,0.000000000}, {1940,0.000066667}, {1950,0.000019048}, {1960,0.000000000}, {1970,0.000095238}, {1980,0.000019048}, {1990,0.000019048}, {2000,0.000038095}, {2050,0.000000000}, {2100,0.000019048}, {2150,0.000038095}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000052381}, {2450,0.000019048}, {2500,0.000033333}, {2550,0.000133333}, {2600,0.000038095}, {2650,0.000038095}, {2700,0.000019048}, {2750,0.000000000}, {2800,0.000171429}, {2850,0.000019048}, {2900,0.000019048}, {2950,0.000019048}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000038095}, {3150,0.000019048}, {3200,0.000019048}, {3250,0.000057143}, {3300,0.000000000}, {3350,0.000014286}, {3400,0.000019048}, {3450,0.000114286}, {3500,0.000000000}, {3550,0.000038095}, {3600,0.000266667}, {3650,0.000019048}, {3700,0.000242857}, {3750,0.000019048}, {3800,0.000190476}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000019048}, {4000,0.000038095}, {4050,0.000438095}, {4100,0.000019048}, {4150,0.000038095}, {4200,0.000000000}, {4250,0.000019048}, {4300,0.000019048}, {4350,0.000057143}, {4400,0.000019048}, {4450,0.000309524}, {4500,0.000376190}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000057143}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000038095}, {4850,0.000000000}, {4900,0.000019048}, {4950,0.000342857}, {5000,0.000133333}, {5050,0.000019048}, {5100,0.000000000}, {5150,0.000038095}, {5200,0.000019048}, {5250,0.000038095}, {5300,0.000380952}, {5350,0.000209524}, {5400,0.000000000}, {5450,0.000019048}, {5500,0.000014286}, {5550,0.000038095}, {5600,0.000057143}, {5650,0.000057143}, {5700,0.000333333}, {5750,0.000038095}, {5800,0.000000000}, {5850,0.000000000}, {5900,0.000019048}, {5950,0.000019048}, {6000,0.000019048}, {6050,0.000071429}, {6100,0.000052381}, {6150,0.000019048}, {6200,0.000019048}, {6250,0.000038095}, {6300,0.000019048}, {6350,0.000433333}, {6400,0.000019048}, {6450,0.000057143}, {6500,0.000019048}, {6550,0.000057143}, {6600,0.000038095}, {6650,0.000019048}, {6700,0.000095238}, {6750,0.000000000}, {6800,0.000542857}, {6850,0.000000000}, {6900,0.000209524}, {6950,0.000019048}, {7000,0.000095238}, {7050,0.000228571}, {7100,0.000038095}, {7150,0.000338095}, {7200,0.000000000}, {7250,0.000419048}, {7300,0.000019048}, {7350,0.000019048}, {7400,0.000000000}, {7450,0.000019048}, {7500,0.000095238}, {7550,0.000523810}, {7600,0.000057143}, {7650,0.000414286}, {7700,0.000038095}, {7750,0.000019048}, {7800,0.000038095}, {7850,0.000619048}, {7900,0.000480952}, {7950,0.000033333}, {8000,0.000000000}, {8050,0.000304762}, {8100,0.000057143}, {8150,0.000114286}, {8200,0.000019048}, {8250,0.000000000}, {8300,0.000504762}, {8350,0.000000000}, {8400,0.000019048}, {8450,0.000076190}, {8500,0.000209524}, {8550,0.000038095}, {8600,0.000019048}, {8650,0.000228571}, {8700,0.000209524}, {8750,0.000038095}, {8800,0.000000000}, {8850,0.000090476}, {8900,0.000152381}, {8950,0.000280952}, {9000,0.000000000}, {9050,0.000038095}, {9100,0.000038095}, {9150,0.000019048}, {9200,0.000000000}, {9250,0.000323810}, {9300,0.000438095}, {9350,0.000019048}, {9400,0.000000000}, {9450,0.000019048}, {9500,0.000000000}, {9550,0.000057143}, {9600,0.000000000}, {9650,0.000019048}, {9700,0.000000000}, {9750,0.000019048}, {9800,0.000019048}, {9850,0.000019048}, {9900,0.000038095}, {9950,0.000000000}, {10000,0.000019048}, {10100,0.000000000}, {10200,0.000019048}, {10300,0.000019048}, {10400,0.000000000}, {10500,0.000000000}, {10600,0.000471429}, {10700,0.000238095}, {10800,0.000038095}, {10900,0.000019048}, {11000,0.000019048}, {11100,0.000133333}, {11200,0.000000000}, {11300,0.000000000}, {11400,0.000019048}, {11500,0.000000000}, {11600,0.000019048}, {11700,0.000038095}, {11800,0.000038095}, {11900,0.000000000}, {12000,0.000566667}, {12100,0.000014286}, {12200,0.000514286}, {12300,0.000038095}, {12400,0.000595238}, {12500,0.000019048}, {12600,0.000419048}, {12700,0.000000000}, {12800,0.000171429}, {12900,0.000019048}, {13000,0.000000000}, {13100,0.000485714}, {13200,0.000057143}, {13300,0.000052381}, {13400,0.000266667}, {13500,0.000676190}, {13600,0.000000000}, {13700,0.000019048}, {13800,0.000209524}, {13900,0.000300000}, {14000,0.000000000}, {14100,0.000000000}, {14200,0.000019048}, {14300,0.000019048}, {14400,0.000000000}, {14500,0.000019048}, {14600,0.000000000}, {14700,0.000038095}, {14800,0.000057143}, {14900,0.000019048}, {15000,0.000019048}, {15100,0.000019048}, {15200,0.000000000}, {15300,0.000019048}, {15400,0.000057143}, {15500,0.000019048}, {15600,0.000019048}, {15700,0.000057143}, {15800,0.000000000}, {15900,0.000057143}, {16000,0.000066667}, {16100,0.000000000}, {16200,0.000038095}, {16300,0.000000000}, {16400,0.000019048}, {16500,0.000038095}, {16600,0.000000000}, {16700,0.000057143}, {16800,0.000038095}, {16900,0.000019048}, {17000,0.000019048}, {17100,0.000038095}, {17200,0.000000000}, {17300,0.000014286}, {17400,0.000019048}, {17500,0.000076190}, {17600,0.000000000}, {17700,0.000000000}, {17800,0.000000000}, {17900,0.000038095}, {18000,0.000038095}, {18100,0.000000000}, {18200,0.000019048}, {18300,0.000019048}, {18400,0.000038095}, {18500,0.000000000}, {18600,0.000000000}, {18700,0.000019048}, {18800,0.000038095}, {18900,0.000000000}, {19000,0.000019048}, {19100,0.000019048}, {19200,0.000019048}, {19300,0.000076190}, {19400,0.000076190}, {19500,0.000000000}, {19600,0.000019048}, {19700,0.000019048}, {19800,0.000019048}, {19900,0.000019048}, {20000,0.000057692}};
data["big"]["Parametricity; beta"]["lazy beta iota"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000009479}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000862559}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000526066}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000019048}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000009524}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000971429}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000019048}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000028571}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.001009524}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.001714286}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.001895238}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000009524}, {640,0.000000000}, {645,0.000009524}, {650,0.000000000}, {655,0.000004762}, {660,0.001742857}, {665,0.000014286}, {670,0.000014286}, {675,0.000033333}, {680,0.000038095}, {685,0.000066667}, {690,0.000042857}, {695,0.000080952}, {700,0.000114286}, {705,0.000171429}, {710,0.000161905}, {715,0.000219048}, {720,0.000295238}, {725,0.000280952}, {730,0.000338095}, {735,0.000400000}, {740,0.000414286}, {745,0.000447619}, {750,0.000438095}, {755,0.000495238}, {760,0.000500000}, {765,0.000519048}, {770,0.000519048}, {775,0.000523810}, {780,0.000519048}, {785,0.000523810}, {790,0.000542857}, {795,0.002428571}, {800,0.000523810}, {805,0.000533333}, {810,0.000538095}, {815,0.000552381}, {820,0.000538095}, {825,0.000533333}, {830,0.003042857}, {835,0.000580952}, {840,0.000595238}, {845,0.000590476}, {850,0.000657143}, {855,0.000695238}, {860,0.000685714}, {865,0.000757143}, {870,0.000800000}, {875,0.000847619}, {880,0.003471429}, {885,0.000880952}, {890,0.000890476}, {895,0.000904762}, {900,0.000900000}, {905,0.000909524}, {910,0.000947619}, {915,0.001009524}, {920,0.000980952}, {925,0.000995238}, {930,0.000995238}, {935,0.001000000}, {940,0.001000000}, {945,0.001000000}, {950,0.001000000}, {955,0.001000000}, {960,0.001000000}, {965,0.001000000}, {970,0.001000000}, {975,0.001000000}, {980,0.001000000}, {985,0.001000000}, {990,0.001000000}, {995,0.001000000}, {1000,0.001000000}, {1010,0.001000000}, {1020,0.001000000}, {1030,0.001000000}, {1040,0.001000000}, {1050,0.001000000}, {1060,0.001000000}, {1070,0.001000000}, {1080,0.001000000}, {1090,0.001000000}, {1100,0.001000000}, {1110,0.001000000}, {1120,0.001000000}, {1130,0.001085714}, {1140,0.001000000}, {1150,0.001000000}, {1160,0.001000000}, {1170,0.001000000}, {1180,0.001000000}, {1190,0.001000000}, {1200,0.001000000}, {1210,0.001000000}, {1220,0.001000000}, {1230,0.001004762}, {1240,0.001028571}, {1250,0.001009524}, {1260,0.001000000}, {1270,0.001014286}, {1280,0.001009524}, {1290,0.001019048}, {1300,0.001061905}, {1310,0.001052381}, {1320,0.001080952}, {1330,0.001147619}, {1340,0.001180952}, {1350,0.001219048}, {1360,0.004219048}, {1370,0.001309524}, {1380,0.001380952}, {1390,0.001395238}, {1400,0.001400000}, {1410,0.001457143}, {1420,0.001495238}, {1430,0.001519048}, {1440,0.001500000}, {1450,0.001504762}, {1460,0.001519048}, {1470,0.001514286}, {1480,0.001519048}, {1490,0.001519048}, {1500,0.001523810}, {1510,0.001523810}, {1520,0.001523810}, {1530,0.001528571}, {1540,0.001538095}, {1550,0.001533333}, {1560,0.001547619}, {1570,0.001542857}, {1580,0.001576190}, {1590,0.001585714}, {1600,0.001604762}, {1610,0.001666667}, {1620,0.001628571}, {1630,0.001661905}, {1640,0.001661905}, {1650,0.001704762}, {1660,0.001738095}, {1670,0.001771429}, {1680,0.001757143}, {1690,0.001895238}, {1700,0.001861905}, {1710,0.001880952}, {1720,0.001904762}, {1730,0.001819048}, {1740,0.001938095}, {1750,0.001914286}, {1760,0.001876190}, {1770,0.001928571}, {1780,0.005804762}, {1790,0.001957143}, {1800,0.001990476}, {1810,0.007514286}, {1820,0.002000000}, {1830,0.002000000}, {1840,0.002076190}, {1850,0.002004762}, {1860,0.002000000}, {1870,0.002000000}, {1880,0.002004762}, {1890,0.002004762}, {1900,0.006914286}, {1910,0.002014286}, {1920,0.002014286}, {1930,0.002038095}, {1940,0.002071429}, {1950,0.002061905}, {1960,0.002104762}, {1970,0.002014286}, {1980,0.002142857}, {1990,0.002190476}, {2000,0.002238095}, {2050,0.002409524}, {2100,0.002480952}, {2150,0.002514286}, {2200,0.002519048}, {2250,0.002538095}, {2300,0.002576190}, {2350,0.002609524}, {2400,0.002776190}, {2450,0.002852381}, {2500,0.003047619}, {2550,0.002961905}, {2600,0.003100000}, {2650,0.003219048}, {2700,0.003361905}, {2750,0.003466667}, {2800,0.003295238}, {2850,0.003519048}, {2900,0.003519048}, {2950,0.003523810}, {3000,0.003542857}, {3050,0.003561905}, {3100,0.013023810}, {3150,0.003747619}, {3200,0.003866667}, {3250,0.003595238}, {3300,0.004152381}, {3350,0.004309524}, {3400,0.004242857}, {3450,0.004104762}, {3500,0.004509524}, {3550,0.004519048}, {3600,0.004723810}, {3650,0.004457143}, {3700,0.004504762}, {3750,0.004566667}, {3800,0.004533333}, {3850,0.004657143}, {3900,0.005114286}, {3950,0.004976190}, {4000,0.004904762}, {4050,0.004580952}, {4100,0.028914286}, {4150,0.005452381}, {4200,0.005490476}, {4250,0.005514286}, {4300,0.005519048}, {4350,0.005523810}, {4400,0.005490476}, {4450,0.005523810}, {4500,0.005576190}, {4550,0.018600000}, {4600,0.005876190}, {4650,0.006071429}, {4700,0.006204762}, {4750,0.006300000}, {4800,0.006376190}, {4850,0.006428571}, {4900,0.019619048}, {4950,0.006280952}, {5000,0.006376190}, {5050,0.006428571}, {5100,0.006876190}, {5150,0.006614286}, {5200,0.006657143}, {5250,0.016395238}, {5300,0.018114286}, {5350,0.006523810}, {5400,0.007357143}, {5450,0.007271429}, {5500,0.007371429}, {5550,0.015419048}, {5600,0.007128571}, {5650,0.007457143}, {5700,0.007128571}, {5750,0.015904762}, {5800,0.007528571}, {5850,0.007685714}, {5900,0.007785714}, {5950,0.015742857}, {6000,0.007766667}, {6050,0.008000000}, {6100,0.007766667}, {6150,0.023476190}, {6200,0.033761905}, {6250,0.008233333}, {6300,0.008404762}, {6350,0.007957143}, {6400,0.008333333}, {6450,0.037638095}, {6500,0.022395238}, {6550,0.008376190}, {6600,0.008542857}, {6650,0.020690476}, {6700,0.008480952}, {6750,0.008976190}, {6800,0.008419048}, {6850,0.009100000}, {6900,0.030723810}, {6950,0.008961905}, {7000,0.009057143}, {7050,0.009100000}, {7100,0.009819048}, {7150,0.033485714}, {7200,0.009685714}, {7250,0.018109524}, {7300,0.009823810}, {7350,0.022338095}, {7400,0.029638095}, {7450,0.021304762}, {7500,0.009623810}, {7550,0.034319048}, {7600,0.010176190}, {7650,0.009561905}, {7700,0.030561905}, {7750,0.010057143}, {7800,0.011071429}, {7850,0.009871429}, {7900,0.010352381}, {7950,0.010742857}, {8000,0.010680952}, {8050,0.027966667}, {8100,0.039866667}, {8150,0.010571429}, {8200,0.035047619}, {8250,0.010676190}, {8300,0.010438095}, {8350,0.047485714}, {8400,0.011342857}, {8450,0.011071429}, {8500,0.010714286}, {8550,0.011742857}, {8600,0.011323810}, {8650,0.010952381}, {8700,0.010961905}, {8750,0.048619048}, {8800,0.032838095}, {8850,0.035200000}, {8900,0.039633333}, {8950,0.011661905}, {9000,0.033995238}, {9050,0.012190476}, {9100,0.012266667}, {9150,0.012171429}, {9200,0.012219048}, {9250,0.041361905}, {9300,0.035947619}, {9350,0.047661905}, {9400,0.052285714}, {9450,0.012376190}, {9500,0.012385714}, {9550,0.012442857}, {9600,0.012557143}, {9650,0.012190476}, {9700,0.012757143}, {9750,0.012885714}, {9800,0.032704762}, {9850,0.012580952}, {9900,0.012638095}, {9950,0.013057143}, {10000,0.013333333}, {10100,0.041552381}, {10200,0.013157143}, {10300,0.014019048}, {10400,0.039447619}, {10500,0.054185714}, {10600,0.013480952}, {10700,0.013719048}, {10800,0.033957143}, {10900,0.014404762}, {11000,0.039280952}, {11100,0.014238095}, {11200,0.014438095}, {11300,0.014566667}, {11400,0.028709524}, {11500,0.014842857}, {11600,0.014857143}, {11700,0.015809524}, {11800,0.053619048}, {11900,0.048176190}, {12000,0.015271429}, {12100,0.015400000}, {12200,0.016147619}, {12300,0.015733333}, {12400,0.050095238}, {12500,0.016152381}, {12600,0.016852381}, {12700,0.048819048}, {12800,0.046042857}, {12900,0.029819048}, {13000,0.016552381}, {13100,0.017657143}, {13200,0.039704762}, {13300,0.017838095}, {13400,0.017157143}, {13500,0.017280952}, {13600,0.046638095}, {13700,0.017461905}, {13800,0.017561905}, {13900,0.017776190}, {14000,0.018400000}, {14100,0.042323810}, {14200,0.056071429}, {14300,0.018366667}, {14400,0.061757143}, {14500,0.041514286}, {14600,0.018671429}, {14700,0.019347619}, {14800,0.019100000}, {14900,0.049238095}, {15000,0.019295238}, {15100,0.019804762}, {15200,0.058200000}, {15300,0.019619048}, {15400,0.057347619}, {15500,0.066952381}, {15600,0.020661905}, {15700,0.068714286}, {15800,0.021185714}, {15900,0.052485714}, {16000,0.044900000}, {16100,0.067095238}, {16200,0.021590476}, {16300,0.098957143}, {16400,0.021976190}, {16500,0.021804762}, {16600,0.115642857}, {16700,0.022133333}, {16800,0.034700000}, {16900,0.086314286}, {17000,0.022142857}, {17100,0.055676190}, {17200,0.041133333}, {17300,0.101223810}, {17400,0.022371429}, {17500,0.052971429}, {17600,0.023576190}, {17700,0.037500000}, {17800,0.036547619}, {17900,0.044942857}, {18000,0.084247619}, {18100,0.049638095}, {18200,0.057076190}, {18300,0.087809524}, {18400,0.058785714}, {18500,0.053761905}, {18600,0.041704762}, {18700,0.050500000}, {18800,0.074571429}, {18900,0.025471429}, {19000,0.024742857}, {19100,0.076252381}, {19200,0.045114286}, {19300,0.043376190}, {19400,0.048904762}, {19500,0.113776190}, {19600,0.083338095}, {19700,0.062390476}, {19800,0.061304762}, {19900,0.080871429}, {20000,0.053471154}};
data["big"]["Parametricity; beta"]["lazy beta iota"]["user"] = {{1,0.000000000}, {2,0.000018957}, {3,0.000033175}, {4,0.000037915}, {5,0.000014218}, {6,0.000033175}, {7,0.000018957}, {8,0.000000000}, {9,0.000018957}, {10,0.000037915}, {11,0.000066351}, {12,0.000033175}, {13,0.000028436}, {14,0.000033175}, {15,0.000018957}, {16,0.000018957}, {17,0.000033175}, {18,0.000000000}, {19,0.000052133}, {20,0.000014218}, {21,0.000071090}, {22,0.000037915}, {23,0.000018957}, {24,0.000104265}, {25,0.000090047}, {26,0.000037915}, {27,0.000018957}, {28,0.000037915}, {29,0.000132701}, {30,0.000047393}, {31,0.000161137}, {32,0.000018957}, {33,0.000052133}, {34,0.000018957}, {35,0.000066351}, {36,0.000014218}, {37,0.000014218}, {38,0.000028436}, {39,0.000066351}, {40,0.000056872}, {41,0.000047393}, {42,0.000052133}, {43,0.000161137}, {44,0.000071090}, {45,0.000052133}, {46,0.000094787}, {47,0.000037915}, {48,0.000052133}, {49,0.000104265}, {50,0.000094787}, {51,0.000066351}, {52,0.000033175}, {53,0.000018957}, {54,0.000104265}, {55,0.000014218}, {56,0.000061611}, {57,0.000061611}, {58,0.000037915}, {59,0.000014218}, {60,0.000066351}, {61,0.000161137}, {62,0.000075829}, {63,0.000123223}, {64,0.000056872}, {65,0.000104265}, {66,0.000085308}, {67,0.000085308}, {68,0.000056872}, {69,0.000194313}, {70,0.000118483}, {71,0.000123223}, {72,0.000037915}, {73,0.000137441}, {74,0.000156398}, {75,0.000085308}, {76,0.000080569}, {77,0.000071090}, {78,0.000085308}, {79,0.000033175}, {80,0.000161137}, {81,0.000161137}, {82,0.000080569}, {83,0.000071090}, {84,0.000066351}, {85,0.000113744}, {86,0.000099526}, {87,0.000165877}, {88,0.000203791}, {89,0.000080569}, {90,0.000056872}, {91,0.000090047}, {92,0.000142180}, {93,0.000123223}, {94,0.000123223}, {95,0.000194313}, {96,0.000056872}, {97,0.000056872}, {98,0.000137441}, {99,0.000146919}, {100,0.000170616}, {101,0.000071090}, {102,0.000109005}, {103,0.000123223}, {104,0.000109005}, {105,0.000189573}, {106,0.000184834}, {107,0.000137441}, {108,0.000156398}, {109,0.000123223}, {110,0.000071090}, {111,0.000118483}, {112,0.000132701}, {113,0.000161137}, {114,0.000094787}, {115,0.000094787}, {116,0.000123223}, {117,0.000146919}, {118,0.000194313}, {119,0.000265403}, {120,0.000142180}, {121,0.000208531}, {122,0.000137441}, {123,0.000180095}, {124,0.000213270}, {125,0.000123223}, {126,0.000161137}, {127,0.000132701}, {128,0.000151659}, {129,0.000175355}, {130,0.000156398}, {131,0.000175355}, {132,0.000184834}, {133,0.000265403}, {134,0.000199052}, {135,0.000298578}, {136,0.000189573}, {137,0.000156398}, {138,0.000127962}, {139,0.000170616}, {140,0.000151659}, {141,0.000208531}, {142,0.000203791}, {143,0.000170616}, {144,0.000127962}, {145,0.000184834}, {146,0.000194313}, {147,0.000289100}, {148,0.000213270}, {149,0.000165877}, {150,0.000146919}, {151,0.000175355}, {152,0.000222749}, {153,0.000180095}, {154,0.000265403}, {155,0.000184834}, {156,0.000218009}, {157,0.000236967}, {158,0.000208531}, {159,0.000194313}, {160,0.000222749}, {161,0.000241706}, {162,0.000213270}, {163,0.000170616}, {164,0.000312796}, {165,0.000199052}, {166,0.000085308}, {167,0.000236967}, {168,0.000227488}, {169,0.000251185}, {170,0.000151659}, {171,0.000227488}, {172,0.000199052}, {173,0.000180095}, {174,0.000218009}, {175,0.000203791}, {176,0.000227488}, {177,0.000194313}, {178,0.000194313}, {179,0.000327014}, {180,0.000213270}, {181,0.000189573}, {182,0.000194313}, {183,0.000180095}, {184,0.000218009}, {185,0.000208531}, {186,0.000208531}, {187,0.000218009}, {188,0.000151659}, {189,0.000260664}, {190,0.000284360}, {191,0.000360190}, {192,0.000203791}, {193,0.000236967}, {194,0.000327014}, {195,0.000336493}, {196,0.000151659}, {197,0.000232227}, {198,0.000289100}, {199,0.000222749}, {200,0.000236967}, {201,0.000355450}, {202,0.000227488}, {203,0.000236967}, {204,0.000255924}, {205,0.000156398}, {206,0.000218009}, {207,0.000293839}, {208,0.000227488}, {209,0.001042654}, {210,0.000241706}, {211,0.000274882}, {212,0.000355450}, {213,0.000236967}, {214,0.000127962}, {215,0.000170616}, {216,0.000241706}, {217,0.000260664}, {218,0.000289100}, {219,0.000218009}, {220,0.000454976}, {221,0.000255924}, {222,0.000350711}, {223,0.000199052}, {224,0.000336493}, {225,0.000374408}, {226,0.000189573}, {227,0.000236967}, {228,0.000440758}, {229,0.000274882}, {230,0.000331754}, {231,0.000355450}, {232,0.000175355}, {233,0.000308057}, {234,0.000265403}, {235,0.000227488}, {236,0.000232227}, {237,0.000284360}, {238,0.000312796}, {239,0.000890995}, {240,0.000194313}, {241,0.000246445}, {242,0.000336493}, {243,0.000298578}, {244,0.000180952}, {245,0.000252381}, {246,0.000252381}, {247,0.000290476}, {248,0.000319048}, {249,0.000347619}, {250,0.000228571}, {251,0.000314286}, {252,0.000304762}, {253,0.000166667}, {254,0.000461905}, {255,0.000261905}, {256,0.000261905}, {257,0.000185714}, {258,0.000319048}, {259,0.000257143}, {260,0.000404762}, {261,0.000276190}, {262,0.000352381}, {263,0.000404762}, {264,0.000380952}, {265,0.000400000}, {266,0.000352381}, {267,0.000323810}, {268,0.000409524}, {269,0.000323810}, {270,0.000276190}, {271,0.000376190}, {272,0.000266667}, {273,0.000323810}, {274,0.000261905}, {275,0.000190476}, {276,0.000414286}, {277,0.000280952}, {278,0.000347619}, {279,0.000261905}, {280,0.000404762}, {281,0.000314286}, {282,0.000352381}, {283,0.000333333}, {284,0.000214286}, {285,0.000519048}, {286,0.000323810}, {287,0.000290476}, {288,0.000333333}, {289,0.000433333}, {290,0.000338095}, {291,0.000357143}, {292,0.000376190}, {293,0.000271429}, {294,0.000342857}, {295,0.000433333}, {296,0.000323810}, {297,0.000376190}, {298,0.000380952}, {299,0.000461905}, {300,0.000233333}, {301,0.000352381}, {302,0.000247619}, {303,0.000404762}, {304,0.000414286}, {305,0.000295238}, {306,0.000461905}, {307,0.000380952}, {308,0.000319048}, {309,0.000285714}, {310,0.000357143}, {311,0.000385714}, {312,0.000347619}, {313,0.000457143}, {314,0.000361905}, {315,0.000361905}, {316,0.000333333}, {317,0.000352381}, {318,0.000333333}, {319,0.000300000}, {320,0.000342857}, {321,0.000419048}, {322,0.000300000}, {323,0.000400000}, {324,0.000323810}, {325,0.000347619}, {326,0.000414286}, {327,0.000490476}, {328,0.000414286}, {329,0.000438095}, {330,0.000366667}, {331,0.000309524}, {332,0.000433333}, {333,0.000519048}, {334,0.000409524}, {335,0.000357143}, {336,0.000338095}, {337,0.000523810}, {338,0.000480952}, {339,0.000480952}, {340,0.000390476}, {341,0.000352381}, {342,0.000423810}, {343,0.000323810}, {344,0.000352381}, {345,0.000452381}, {346,0.000438095}, {347,0.000390476}, {348,0.000290476}, {349,0.000390476}, {350,0.000538095}, {351,0.000419048}, {352,0.000476190}, {353,0.001276190}, {354,0.000428571}, {355,0.000414286}, {356,0.000642857}, {357,0.000514286}, {358,0.000380952}, {359,0.000319048}, {360,0.000342857}, {361,0.000285714}, {362,0.000309524}, {363,0.000400000}, {364,0.000366667}, {365,0.000433333}, {366,0.000585714}, {367,0.000376190}, {368,0.000433333}, {369,0.000433333}, {370,0.000423810}, {371,0.000423810}, {372,0.000390476}, {373,0.000438095}, {374,0.000409524}, {375,0.000538095}, {376,0.000333333}, {377,0.000404762}, {378,0.000485714}, {379,0.000447619}, {380,0.000523810}, {381,0.000533333}, {382,0.000423810}, {383,0.000385714}, {384,0.000490476}, {385,0.000419048}, {386,0.000523810}, {387,0.000352381}, {388,0.000666667}, {389,0.000542857}, {390,0.000471429}, {391,0.000480952}, {392,0.000400000}, {393,0.000504762}, {394,0.000619048}, {395,0.000633333}, {396,0.000395238}, {397,0.000638095}, {398,0.000566667}, {399,0.000528571}, {400,0.000519048}, {401,0.000595238}, {402,0.000447619}, {403,0.000480952}, {404,0.000428571}, {405,0.000419048}, {406,0.000419048}, {407,0.000433333}, {408,0.000457143}, {409,0.000376190}, {410,0.000538095}, {411,0.000533333}, {412,0.000523810}, {413,0.000490476}, {414,0.000542857}, {415,0.000447619}, {416,0.001395238}, {417,0.000390476}, {418,0.000638095}, {419,0.000380952}, {420,0.000528571}, {421,0.000590476}, {422,0.000442857}, {423,0.000442857}, {424,0.000528571}, {425,0.000466667}, {426,0.000738095}, {427,0.000461905}, {428,0.000433333}, {429,0.000542857}, {430,0.000614286}, {431,0.000723810}, {432,0.000642857}, {433,0.000380952}, {434,0.000419048}, {435,0.000519048}, {436,0.000395238}, {437,0.000495238}, {438,0.000614286}, {439,0.000533333}, {440,0.000509524}, {441,0.000709524}, {442,0.000490476}, {443,0.000471429}, {444,0.000519048}, {445,0.000376190}, {446,0.000642857}, {447,0.000495238}, {448,0.000676190}, {449,0.000471429}, {450,0.000566667}, {451,0.000500000}, {452,0.000585714}, {453,0.000633333}, {454,0.000485714}, {455,0.000533333}, {456,0.000500000}, {457,0.000647619}, {458,0.000571429}, {459,0.000390476}, {460,0.000661905}, {461,0.000447619}, {462,0.000595238}, {463,0.000519048}, {464,0.000595238}, {465,0.000485714}, {466,0.000557143}, {467,0.000476190}, {468,0.002066667}, {469,0.000514286}, {470,0.000609524}, {471,0.000600000}, {472,0.000619048}, {473,0.000514286}, {474,0.000552381}, {475,0.000609524}, {476,0.000690476}, {477,0.000452381}, {478,0.000738095}, {479,0.002195238}, {480,0.000504762}, {481,0.000523810}, {482,0.000452381}, {483,0.000561905}, {484,0.000566667}, {485,0.000614286}, {486,0.000561905}, {487,0.000580952}, {488,0.000514286}, {489,0.000676190}, {490,0.000500000}, {491,0.000571429}, {492,0.000461905}, {493,0.000547619}, {494,0.000580952}, {495,0.000447619}, {496,0.000390476}, {497,0.000504762}, {498,0.000628571}, {499,0.000528571}, {500,0.000533333}, {505,0.000709524}, {510,0.000457143}, {515,0.000700000}, {520,0.000566667}, {525,0.000385714}, {530,0.000500000}, {535,0.000785714}, {540,0.000714286}, {545,0.000676190}, {550,0.000800000}, {555,0.000657143}, {560,0.000733333}, {565,0.000700000}, {570,0.000580952}, {575,0.000628571}, {580,0.000733333}, {585,0.000828571}, {590,0.000709524}, {595,0.000766667}, {600,0.000771429}, {605,0.000804762}, {610,0.000790476}, {615,0.000695238}, {620,0.000595238}, {625,0.000714286}, {630,0.000471429}, {635,0.000790476}, {640,0.000842857}, {645,0.000595238}, {650,0.000719048}, {655,0.000566667}, {660,0.002090476}, {665,0.000995238}, {670,0.000704762}, {675,0.000742857}, {680,0.000790476}, {685,0.000776190}, {690,0.000661905}, {695,0.000747619}, {700,0.000704762}, {705,0.001004762}, {710,0.000795238}, {715,0.000757143}, {720,0.000976190}, {725,0.000866667}, {730,0.000976190}, {735,0.000966667}, {740,0.000928571}, {745,0.000976190}, {750,0.000757143}, {755,0.000904762}, {760,0.000642857}, {765,0.000809524}, {770,0.000780952}, {775,0.000890476}, {780,0.000957143}, {785,0.001152381}, {790,0.000985714}, {795,0.002409524}, {800,0.000923810}, {805,0.001033333}, {810,0.000885714}, {815,0.001066667}, {820,0.000900000}, {825,0.000885714}, {830,0.003280952}, {835,0.000795238}, {840,0.000961905}, {845,0.000928571}, {850,0.001109524}, {855,0.000842857}, {860,0.001076190}, {865,0.001061905}, {870,0.001147619}, {875,0.000990476}, {880,0.003400000}, {885,0.000961905}, {890,0.001119048}, {895,0.001123810}, {900,0.001080952}, {905,0.000947619}, {910,0.001014286}, {915,0.001095238}, {920,0.001038095}, {925,0.001019048}, {930,0.001233333}, {935,0.001161905}, {940,0.000995238}, {945,0.001090476}, {950,0.001266667}, {955,0.000942857}, {960,0.001157143}, {965,0.001300000}, {970,0.001085714}, {975,0.001176190}, {980,0.001371429}, {985,0.001157143}, {990,0.001076190}, {995,0.001209524}, {1000,0.001333333}, {1010,0.001280952}, {1020,0.001166667}, {1030,0.001019048}, {1040,0.001104762}, {1050,0.001138095}, {1060,0.001380952}, {1070,0.001195238}, {1080,0.001266667}, {1090,0.001185714}, {1100,0.001528571}, {1110,0.001476190}, {1120,0.001376190}, {1130,0.001357143}, {1140,0.001400000}, {1150,0.001471429}, {1160,0.001409524}, {1170,0.001295238}, {1180,0.001438095}, {1190,0.001628571}, {1200,0.001585714}, {1210,0.001533333}, {1220,0.001400000}, {1230,0.001328571}, {1240,0.001528571}, {1250,0.001395238}, {1260,0.001342857}, {1270,0.001695238}, {1280,0.001461905}, {1290,0.001519048}, {1300,0.001338095}, {1310,0.001528571}, {1320,0.001428571}, {1330,0.001428571}, {1340,0.001619048}, {1350,0.001747619}, {1360,0.004228571}, {1370,0.001600000}, {1380,0.001566667}, {1390,0.001476190}, {1400,0.001690476}, {1410,0.001890476}, {1420,0.001714286}, {1430,0.001538095}, {1440,0.001800000}, {1450,0.001952381}, {1460,0.001895238}, {1470,0.001680952}, {1480,0.001804762}, {1490,0.001847619}, {1500,0.001871429}, {1510,0.001861905}, {1520,0.001828571}, {1530,0.001914286}, {1540,0.001680952}, {1550,0.001847619}, {1560,0.001733333}, {1570,0.001804762}, {1580,0.002095238}, {1590,0.001909524}, {1600,0.002000000}, {1610,0.002042857}, {1620,0.001980952}, {1630,0.002233333}, {1640,0.002200000}, {1650,0.001904762}, {1660,0.002076190}, {1670,0.002104762}, {1680,0.002033333}, {1690,0.002033333}, {1700,0.002071429}, {1710,0.002223810}, {1720,0.001842857}, {1730,0.002119048}, {1740,0.002347619}, {1750,0.001919048}, {1760,0.002100000}, {1770,0.002061905}, {1780,0.005876190}, {1790,0.002071429}, {1800,0.002133333}, {1810,0.007928571}, {1820,0.002423810}, {1830,0.002033333}, {1840,0.002285714}, {1850,0.002209524}, {1860,0.002457143}, {1870,0.002342857}, {1880,0.002471429}, {1890,0.002266667}, {1900,0.007000000}, {1910,0.002609524}, {1920,0.002080952}, {1930,0.002414286}, {1940,0.002400000}, {1950,0.002366667}, {1960,0.002447619}, {1970,0.002471429}, {1980,0.002419048}, {1990,0.002147619}, {2000,0.002638095}, {2050,0.002414286}, {2100,0.002638095}, {2150,0.002757143}, {2200,0.002771429}, {2250,0.002823810}, {2300,0.002790476}, {2350,0.002928571}, {2400,0.002857143}, {2450,0.003157143}, {2500,0.003300000}, {2550,0.003242857}, {2600,0.003409524}, {2650,0.003338095}, {2700,0.003371429}, {2750,0.003385714}, {2800,0.003423810}, {2850,0.003557143}, {2900,0.003680952}, {2950,0.003666667}, {3000,0.003761905}, {3050,0.003928571}, {3100,0.012995238}, {3150,0.004038095}, {3200,0.003990476}, {3250,0.003842857}, {3300,0.004123810}, {3350,0.004290476}, {3400,0.004323810}, {3450,0.004261905}, {3500,0.004514286}, {3550,0.004242857}, {3600,0.004571429}, {3650,0.004414286}, {3700,0.004557143}, {3750,0.004852381}, {3800,0.004757143}, {3850,0.005147619}, {3900,0.005004762}, {3950,0.005090476}, {4000,0.004814286}, {4050,0.004947619}, {4100,0.028476190}, {4150,0.005090476}, {4200,0.005461905}, {4250,0.005347619}, {4300,0.005428571}, {4350,0.005500000}, {4400,0.005433333}, {4450,0.005371429}, {4500,0.005266667}, {4550,0.018209524}, {4600,0.005719048}, {4650,0.005980952}, {4700,0.006090476}, {4750,0.006409524}, {4800,0.006200000}, {4850,0.006333333}, {4900,0.019233333}, {4950,0.005938095}, {5000,0.006085714}, {5050,0.006400000}, {5100,0.006790476}, {5150,0.006633333}, {5200,0.006771429}, {5250,0.016133333}, {5300,0.017533333}, {5350,0.006376190}, {5400,0.007247619}, {5450,0.007052381}, {5500,0.007080952}, {5550,0.015342857}, {5600,0.006985714}, {5650,0.007314286}, {5700,0.007419048}, {5750,0.016171429}, {5800,0.007395238}, {5850,0.007738095}, {5900,0.007723810}, {5950,0.015766667}, {6000,0.007757143}, {6050,0.007980952}, {6100,0.007571429}, {6150,0.022985714}, {6200,0.033519048}, {6250,0.007890476}, {6300,0.008380952}, {6350,0.007876190}, {6400,0.008461905}, {6450,0.037476190}, {6500,0.022261905}, {6550,0.008285714}, {6600,0.008423810}, {6650,0.020295238}, {6700,0.008323810}, {6750,0.008957143}, {6800,0.008285714}, {6850,0.009538095}, {6900,0.030590476}, {6950,0.008852381}, {7000,0.009238095}, {7050,0.009104762}, {7100,0.009714286}, {7150,0.032795238}, {7200,0.009814286}, {7250,0.017933333}, {7300,0.010042857}, {7350,0.022114286}, {7400,0.029104762}, {7450,0.021333333}, {7500,0.009823810}, {7550,0.033823810}, {7600,0.010438095}, {7650,0.009695238}, {7700,0.030380952}, {7750,0.010342857}, {7800,0.011071429}, {7850,0.009909524}, {7900,0.010585714}, {7950,0.011071429}, {8000,0.010861905}, {8050,0.027914286}, {8100,0.039476190}, {8150,0.010766667}, {8200,0.034847619}, {8250,0.011142857}, {8300,0.010690476}, {8350,0.047185714}, {8400,0.011823810}, {8450,0.011266667}, {8500,0.010866667}, {8550,0.012119048}, {8600,0.011638095}, {8650,0.011090476}, {8700,0.011200000}, {8750,0.048452381}, {8800,0.033042857}, {8850,0.035385714}, {8900,0.039638095}, {8950,0.012147619}, {9000,0.033928571}, {9050,0.012628571}, {9100,0.012557143}, {9150,0.012200000}, {9200,0.012300000}, {9250,0.041361905}, {9300,0.035914286}, {9350,0.047457143}, {9400,0.051923810}, {9450,0.012604762}, {9500,0.012733333}, {9550,0.012795238}, {9600,0.012895238}, {9650,0.012680952}, {9700,0.013085714}, {9750,0.013266667}, {9800,0.033038095}, {9850,0.012852381}, {9900,0.012747619}, {9950,0.013180952}, {10000,0.013309524}, {10100,0.041723810}, {10200,0.013404762}, {10300,0.014342857}, {10400,0.038866667}, {10500,0.053742857}, {10600,0.013633333}, {10700,0.013733333}, {10800,0.033985714}, {10900,0.014519048}, {11000,0.038742857}, {11100,0.014209524}, {11200,0.014404762}, {11300,0.014538095}, {11400,0.028419048}, {11500,0.014861905}, {11600,0.014795238}, {11700,0.015938095}, {11800,0.053585714}, {11900,0.047661905}, {12000,0.015209524}, {12100,0.015361905}, {12200,0.016138095}, {12300,0.015666667}, {12400,0.049752381}, {12500,0.015900000}, {12600,0.016642857}, {12700,0.048204762}, {12800,0.045847619}, {12900,0.029504762}, {13000,0.016557143}, {13100,0.017442857}, {13200,0.039252381}, {13300,0.017728571}, {13400,0.017019048}, {13500,0.017314286}, {13600,0.046357143}, {13700,0.017409524}, {13800,0.017666667}, {13900,0.017800000}, {14000,0.018285714}, {14100,0.042147619}, {14200,0.056204762}, {14300,0.018209524}, {14400,0.061942857}, {14500,0.041685714}, {14600,0.018904762}, {14700,0.019228571}, {14800,0.019533333}, {14900,0.049119048}, {15000,0.019447619}, {15100,0.020242857}, {15200,0.058042857}, {15300,0.020071429}, {15400,0.057723810}, {15500,0.067004762}, {15600,0.020980952}, {15700,0.068480952}, {15800,0.021371429}, {15900,0.052195238}, {16000,0.044961905}, {16100,0.067257143}, {16200,0.021819048}, {16300,0.098880952}, {16400,0.022185714}, {16500,0.021876190}, {16600,0.115519048}, {16700,0.022490476}, {16800,0.034757143}, {16900,0.086485714}, {17000,0.022590476}, {17100,0.055804762}, {17200,0.041147619}, {17300,0.101271429}, {17400,0.022528571}, {17500,0.053080952}, {17600,0.023733333}, {17700,0.037666667}, {17800,0.036923810}, {17900,0.045123810}, {18000,0.084409524}, {18100,0.049695238}, {18200,0.056857143}, {18300,0.087819048}, {18400,0.059042857}, {18500,0.053871429}, {18600,0.041861905}, {18700,0.050452381}, {18800,0.074461905}, {18900,0.025633333}, {19000,0.024642857}, {19100,0.076566667}, {19200,0.045076190}, {19300,0.043242857}, {19400,0.048852381}, {19500,0.113628571}, {19600,0.083252381}, {19700,0.062200000}, {19800,0.061095238}, {19900,0.080790476}, {20000,0.053331731}};
data["big"]["Parametricity; beta"]["lazy beta iota"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000018957}, {16,0.000000000}, {17,0.000018957}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000018957}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000018957}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000018957}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000018957}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000018957}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000014218}, {106,0.000018957}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000018957}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000018957}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000018957}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000037915}, {146,0.000000000}, {147,0.000018957}, {148,0.000000000}, {149,0.000018957}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000014218}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000018957}, {169,0.000000000}, {170,0.000018957}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000018957}, {185,0.000000000}, {186,0.000000000}, {187,0.000018957}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000018957}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000018957}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000018957}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000018957}, {214,0.000018957}, {215,0.000000000}, {216,0.000000000}, {217,0.000018957}, {218,0.000000000}, {219,0.000018957}, {220,0.000018957}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000018957}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000019048}, {247,0.000019048}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000019048}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000019048}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000019048}, {275,0.000000000}, {276,0.000038095}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000019048}, {291,0.000000000}, {292,0.000000000}, {293,0.000019048}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000019048}, {300,0.000000000}, {301,0.000000000}, {302,0.000038095}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000019048}, {310,0.000000000}, {311,0.000000000}, {312,0.000019048}, {313,0.000019048}, {314,0.000019048}, {315,0.000000000}, {316,0.000000000}, {317,0.000019048}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000019048}, {324,0.000019048}, {325,0.000019048}, {326,0.000000000}, {327,0.000019048}, {328,0.000019048}, {329,0.000000000}, {330,0.000000000}, {331,0.000019048}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000019048}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000019048}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000019048}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000019048}, {356,0.000019048}, {357,0.000000000}, {358,0.000019048}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000019048}, {367,0.000000000}, {368,0.000000000}, {369,0.000019048}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000019048}, {374,0.000019048}, {375,0.000019048}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000019048}, {386,0.000019048}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000019048}, {396,0.000000000}, {397,0.000019048}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000019048}, {403,0.000019048}, {404,0.000000000}, {405,0.000019048}, {406,0.000000000}, {407,0.000000000}, {408,0.000019048}, {409,0.000019048}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000019048}, {415,0.000000000}, {416,0.000019048}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000019048}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000019048}, {426,0.000000000}, {427,0.000019048}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000019048}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000019048}, {439,0.000000000}, {440,0.000000000}, {441,0.000038095}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000019048}, {448,0.000038095}, {449,0.000000000}, {450,0.000000000}, {451,0.000019048}, {452,0.000000000}, {453,0.000000000}, {454,0.000019048}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000019048}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000019048}, {468,0.000076190}, {469,0.000019048}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000019048}, {479,0.000057143}, {480,0.000000000}, {481,0.000000000}, {482,0.000019048}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000019048}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000019048}, {499,0.000019048}, {500,0.000014286}, {505,0.000038095}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000038095}, {575,0.000019048}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000019048}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000019048}, {630,0.000019048}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000038095}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000019048}, {705,0.000019048}, {710,0.000019048}, {715,0.000019048}, {720,0.000038095}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000019048}, {755,0.000000000}, {760,0.000019048}, {765,0.000000000}, {770,0.000038095}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000057143}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000019048}, {820,0.000000000}, {825,0.000000000}, {830,0.000109524}, {835,0.000019048}, {840,0.000000000}, {845,0.000019048}, {850,0.000000000}, {855,0.000076190}, {860,0.000000000}, {865,0.000000000}, {870,0.000019048}, {875,0.000000000}, {880,0.000095238}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000019048}, {915,0.000019048}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000019048}, {945,0.000019048}, {950,0.000000000}, {955,0.000000000}, {960,0.000019048}, {965,0.000000000}, {970,0.000019048}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000019048}, {1010,0.000057143}, {1020,0.000019048}, {1030,0.000019048}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000038095}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000019048}, {1120,0.000019048}, {1130,0.000076190}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000019048}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000019048}, {1210,0.000000000}, {1220,0.000019048}, {1230,0.000038095}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000057143}, {1280,0.000000000}, {1290,0.000019048}, {1300,0.000019048}, {1310,0.000000000}, {1320,0.000019048}, {1330,0.000000000}, {1340,0.000019048}, {1350,0.000019048}, {1360,0.000114286}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000019048}, {1400,0.000000000}, {1410,0.000019048}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000019048}, {1450,0.000019048}, {1460,0.000000000}, {1470,0.000057143}, {1480,0.000019048}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000038095}, {1530,0.000000000}, {1540,0.000019048}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000019048}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000019048}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000019048}, {1690,0.000000000}, {1700,0.000057143}, {1710,0.000000000}, {1720,0.000019048}, {1730,0.000000000}, {1740,0.000019048}, {1750,0.000038095}, {1760,0.000019048}, {1770,0.000000000}, {1780,0.000071429}, {1790,0.000000000}, {1800,0.000019048}, {1810,0.000190476}, {1820,0.000038095}, {1830,0.000000000}, {1840,0.000038095}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000019048}, {1910,0.000000000}, {1920,0.000019048}, {1930,0.000019048}, {1940,0.000019048}, {1950,0.000038095}, {1960,0.000019048}, {1970,0.000000000}, {1980,0.000019048}, {1990,0.000019048}, {2000,0.000019048}, {2050,0.000000000}, {2100,0.000038095}, {2150,0.000019048}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000038095}, {2550,0.000038095}, {2600,0.000019048}, {2650,0.000019048}, {2700,0.000000000}, {2750,0.000038095}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000019048}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000266667}, {3150,0.000019048}, {3200,0.000000000}, {3250,0.000019048}, {3300,0.000000000}, {3350,0.000019048}, {3400,0.000019048}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000038095}, {3600,0.000000000}, {3650,0.000019048}, {3700,0.000019048}, {3750,0.000019048}, {3800,0.000019048}, {3850,0.000019048}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000038095}, {4050,0.000038095}, {4100,0.000542857}, {4150,0.000019048}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000014286}, {4350,0.000019048}, {4400,0.000019048}, {4450,0.000000000}, {4500,0.000076190}, {4550,0.000438095}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000019048}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000185714}, {4950,0.000000000}, {5000,0.000038095}, {5050,0.000038095}, {5100,0.000019048}, {5150,0.000038095}, {5200,0.000038095}, {5250,0.000166667}, {5300,0.000128571}, {5350,0.000000000}, {5400,0.000019048}, {5450,0.000019048}, {5500,0.000019048}, {5550,0.000128571}, {5600,0.000019048}, {5650,0.000038095}, {5700,0.000000000}, {5750,0.000038095}, {5800,0.000019048}, {5850,0.000019048}, {5900,0.000000000}, {5950,0.000147619}, {6000,0.000019048}, {6050,0.000019048}, {6100,0.000038095}, {6150,0.000447619}, {6200,0.000057143}, {6250,0.000019048}, {6300,0.000000000}, {6350,0.000038095}, {6400,0.000019048}, {6450,0.000019048}, {6500,0.000395238}, {6550,0.000000000}, {6600,0.000019048}, {6650,0.000280952}, {6700,0.000000000}, {6750,0.000038095}, {6800,0.000038095}, {6850,0.000000000}, {6900,0.000419048}, {6950,0.000000000}, {7000,0.000019048}, {7050,0.000019048}, {7100,0.000000000}, {7150,0.000542857}, {7200,0.000019048}, {7250,0.000342857}, {7300,0.000019048}, {7350,0.000361905}, {7400,0.000390476}, {7450,0.000247619}, {7500,0.000038095}, {7550,0.000438095}, {7600,0.000019048}, {7650,0.000057143}, {7700,0.000304762}, {7750,0.000057143}, {7800,0.000019048}, {7850,0.000057143}, {7900,0.000076190}, {7950,0.000000000}, {8000,0.000019048}, {8050,0.000266667}, {8100,0.000604762}, {8150,0.000019048}, {8200,0.000314286}, {8250,0.000033333}, {8300,0.000057143}, {8350,0.000528571}, {8400,0.000057143}, {8450,0.000019048}, {8500,0.000019048}, {8550,0.000095238}, {8600,0.000033333}, {8650,0.000019048}, {8700,0.000076190}, {8750,0.000266667}, {8800,0.000000000}, {8850,0.000000000}, {8900,0.000000000}, {8950,0.000019048}, {9000,0.000266667}, {9050,0.000000000}, {9100,0.000057143}, {9150,0.000019048}, {9200,0.000000000}, {9250,0.000019048}, {9300,0.000019048}, {9350,0.000190476}, {9400,0.000380952}, {9450,0.000019048}, {9500,0.000019048}, {9550,0.000019048}, {9600,0.000019048}, {9650,0.000000000}, {9700,0.000000000}, {9750,0.000000000}, {9800,0.000038095}, {9850,0.000019048}, {9900,0.000019048}, {9950,0.000000000}, {10000,0.000057143}, {10100,0.000057143}, {10200,0.000000000}, {10300,0.000000000}, {10400,0.000342857}, {10500,0.000190476}, {10600,0.000038095}, {10700,0.000019048}, {10800,0.000057143}, {10900,0.000000000}, {11000,0.000466667}, {11100,0.000000000}, {11200,0.000000000}, {11300,0.000019048}, {11400,0.000000000}, {11500,0.000019048}, {11600,0.000019048}, {11700,0.000000000}, {11800,0.000014286}, {11900,0.000533333}, {12000,0.000038095}, {12100,0.000019048}, {12200,0.000038095}, {12300,0.000000000}, {12400,0.000095238}, {12500,0.000038095}, {12600,0.000000000}, {12700,0.000619048}, {12800,0.000000000}, {12900,0.000266667}, {13000,0.000038095}, {13100,0.000000000}, {13200,0.000371429}, {13300,0.000038095}, {13400,0.000019048}, {13500,0.000019048}, {13600,0.000228571}, {13700,0.000019048}, {13800,0.000000000}, {13900,0.000019048}, {14000,0.000019048}, {14100,0.000057143}, {14200,0.000000000}, {14300,0.000019048}, {14400,0.000000000}, {14500,0.000019048}, {14600,0.000057143}, {14700,0.000019048}, {14800,0.000033333}, {14900,0.000052381}, {15000,0.000000000}, {15100,0.000000000}, {15200,0.000057143}, {15300,0.000000000}, {15400,0.000000000}, {15500,0.000019048}, {15600,0.000038095}, {15700,0.000052381}, {15800,0.000019048}, {15900,0.000052381}, {16000,0.000000000}, {16100,0.000057143}, {16200,0.000019048}, {16300,0.000057143}, {16400,0.000019048}, {16500,0.000038095}, {16600,0.000000000}, {16700,0.000000000}, {16800,0.000019048}, {16900,0.000038095}, {17000,0.000019048}, {17100,0.000019048}, {17200,0.000019048}, {17300,0.000000000}, {17400,0.000038095}, {17500,0.000038095}, {17600,0.000019048}, {17700,0.000019048}, {17800,0.000000000}, {17900,0.000019048}, {18000,0.000019048}, {18100,0.000019048}, {18200,0.000019048}, {18300,0.000033333}, {18400,0.000052381}, {18500,0.000019048}, {18600,0.000000000}, {18700,0.000019048}, {18800,0.000000000}, {18900,0.000000000}, {19000,0.000038095}, {19100,0.000000000}, {19200,0.000038095}, {19300,0.000057143}, {19400,0.000019048}, {19500,0.000095238}, {19600,0.000000000}, {19700,0.000052381}, {19800,0.000019048}, {19900,0.000076190}, {20000,0.000019231}};
data["big"]["Parametricity; beta"]["norm reif"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.022085308}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000009479}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000004739}, {89,0.000004739}, {90,0.000000000}, {91,0.000004739}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000004739}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000004739}, {102,0.000000000}, {103,0.000014218}, {104,0.000004739}, {105,0.000000000}, {106,0.000004739}, {107,0.000014218}, {108,0.000014218}, {109,0.000009479}, {110,0.000018957}, {111,0.000023697}, {112,0.000042654}, {113,0.000047393}, {114,0.000056872}, {115,0.000061611}, {116,0.000075829}, {117,0.000052133}, {118,0.000080569}, {119,0.000071090}, {120,0.000142180}, {121,0.000156398}, {122,0.000203791}, {123,0.000222749}, {124,0.000246445}, {125,0.000293839}, {126,0.000687204}, {127,0.000383886}, {128,0.000374408}, {129,0.000426540}, {130,0.000454976}, {131,0.000502370}, {132,0.000563981}, {133,0.000587678}, {134,0.000601896}, {135,0.000620853}, {136,0.000620853}, {137,0.000620853}, {138,0.000668246}, {139,0.000672986}, {140,0.000691943}, {141,0.000706161}, {142,0.000753555}, {143,0.000800948}, {144,0.000857820}, {145,0.000890995}, {146,0.000933649}, {147,0.000943128}, {148,0.000962085}, {149,0.001454976}, {150,0.000976303}, {151,0.000981043}, {152,0.000990521}, {153,0.000981043}, {154,0.000995261}, {155,0.000995261}, {156,0.001004739}, {157,0.001000000}, {158,0.001004739}, {159,0.001009479}, {160,0.001000000}, {161,0.001000000}, {162,0.001000000}, {163,0.001000000}, {164,0.001000000}, {165,0.001000000}, {166,0.001000000}, {167,0.001000000}, {168,0.001000000}, {169,0.001000000}, {170,0.001886256}, {171,0.001000000}, {172,0.001000000}, {173,0.001000000}, {174,0.001000000}, {175,0.001000000}, {176,0.001000000}, {177,0.001000000}, {178,0.001000000}, {179,0.001009479}, {180,0.001000000}, {181,0.001000000}, {182,0.001000000}, {183,0.001004739}, {184,0.001000000}, {185,0.001000000}, {186,0.001000000}, {187,0.001000000}, {188,0.001000000}, {189,0.001511848}, {190,0.001000000}, {191,0.001000000}, {192,0.001000000}, {193,0.001000000}, {194,0.001000000}, {195,0.001000000}, {196,0.001000000}, {197,0.001000000}, {198,0.001000000}, {199,0.001000000}, {200,0.001000000}, {201,0.001000000}, {202,0.001000000}, {203,0.001000000}, {204,0.001000000}, {205,0.001000000}, {206,0.001000000}, {207,0.001000000}, {208,0.001000000}, {209,0.001000000}, {210,0.001000000}, {211,0.001000000}, {212,0.001000000}, {213,0.001000000}, {214,0.001000000}, {215,0.001000000}, {216,0.001000000}, {217,0.001000000}, {218,0.001000000}, {219,0.001000000}, {220,0.001000000}, {221,0.001000000}, {222,0.001000000}, {223,0.001000000}, {224,0.001000000}, {225,0.001000000}, {226,0.001000000}, {227,0.001000000}, {228,0.001000000}, {229,0.001000000}, {230,0.001000000}, {231,0.001000000}, {232,0.001000000}, {233,0.001000000}, {234,0.001000000}, {235,0.001000000}, {236,0.001000000}, {237,0.001000000}, {238,0.001000000}, {239,0.001000000}, {240,0.001004739}, {241,0.001000000}, {242,0.001000000}, {243,0.001000000}, {244,0.001000000}, {245,0.001000000}, {246,0.001000000}, {247,0.001000000}, {248,0.001000000}, {249,0.001000000}, {250,0.001000000}, {251,0.001000000}, {252,0.001000000}, {253,0.001000000}, {254,0.002019048}, {255,0.001000000}, {256,0.001000000}, {257,0.001000000}, {258,0.001000000}, {259,0.001000000}, {260,0.001000000}, {261,0.001000000}, {262,0.001000000}, {263,0.001000000}, {264,0.001000000}, {265,0.001000000}, {266,0.001000000}, {267,0.001000000}, {268,0.001000000}, {269,0.001000000}, {270,0.001000000}, {271,0.001000000}, {272,0.001000000}, {273,0.001000000}, {274,0.001000000}, {275,0.001000000}, {276,0.001000000}, {277,0.001000000}, {278,0.001000000}, {279,0.001000000}, {280,0.001000000}, {281,0.001000000}, {282,0.001523810}, {283,0.001000000}, {284,0.001000000}, {285,0.001009524}, {286,0.001000000}, {287,0.001000000}, {288,0.001000000}, {289,0.001000000}, {290,0.001000000}, {291,0.001000000}, {292,0.001000000}, {293,0.001000000}, {294,0.001000000}, {295,0.002066667}, {296,0.001004762}, {297,0.001000000}, {298,0.001000000}, {299,0.001000000}, {300,0.001000000}, {301,0.001019048}, {302,0.001000000}, {303,0.001000000}, {304,0.001000000}, {305,0.001000000}, {306,0.001004762}, {307,0.001000000}, {308,0.001000000}, {309,0.001000000}, {310,0.001000000}, {311,0.001000000}, {312,0.001000000}, {313,0.001000000}, {314,0.001000000}, {315,0.001000000}, {316,0.001000000}, {317,0.001000000}, {318,0.001009524}, {319,0.001000000}, {320,0.001638095}, {321,0.001000000}, {322,0.001004762}, {323,0.001000000}, {324,0.001000000}, {325,0.001000000}, {326,0.001000000}, {327,0.001009524}, {328,0.001004762}, {329,0.001000000}, {330,0.001009524}, {331,0.001004762}, {332,0.001023810}, {333,0.001014286}, {334,0.001014286}, {335,0.001038095}, {336,0.001004762}, {337,0.001014286}, {338,0.001023810}, {339,0.001014286}, {340,0.001033333}, {341,0.002047619}, {342,0.001033333}, {343,0.001042857}, {344,0.001042857}, {345,0.001047619}, {346,0.001038095}, {347,0.001066667}, {348,0.001057143}, {349,0.001076190}, {350,0.001076190}, {351,0.001080952}, {352,0.001114286}, {353,0.001114286}, {354,0.001142857}, {355,0.001142857}, {356,0.001166667}, {357,0.001185714}, {358,0.001214286}, {359,0.001228571}, {360,0.001242857}, {361,0.001204762}, {362,0.001266667}, {363,0.001319048}, {364,0.001352381}, {365,0.002128571}, {366,0.001347619}, {367,0.001342857}, {368,0.001404762}, {369,0.001409524}, {370,0.001442857}, {371,0.001457143}, {372,0.001471429}, {373,0.001485714}, {374,0.001466667}, {375,0.001500000}, {376,0.002090476}, {377,0.001495238}, {378,0.001538095}, {379,0.001542857}, {380,0.001547619}, {381,0.001595238}, {382,0.001614286}, {383,0.001619048}, {384,0.001657143}, {385,0.001657143}, {386,0.001680952}, {387,0.001700000}, {388,0.001695238}, {389,0.001728571}, {390,0.001766667}, {391,0.001771429}, {392,0.001828571}, {393,0.001852381}, {394,0.001861905}, {395,0.001904762}, {396,0.001890476}, {397,0.001914286}, {398,0.001933333}, {399,0.001923810}, {400,0.001919048}, {401,0.001933333}, {402,0.001928571}, {403,0.001933333}, {404,0.001942857}, {405,0.001952381}, {406,0.001947619}, {407,0.001957143}, {408,0.001942857}, {409,0.002380952}, {410,0.001966667}, {411,0.001990476}, {412,0.001985714}, {413,0.001966667}, {414,0.001961905}, {415,0.001985714}, {416,0.001976190}, {417,0.001990476}, {418,0.001990476}, {419,0.002000000}, {420,0.001995238}, {421,0.002000000}, {422,0.002000000}, {423,0.002000000}, {424,0.002000000}, {425,0.002000000}, {426,0.002000000}, {427,0.002000000}, {428,0.002000000}, {429,0.002000000}, {430,0.002009524}, {431,0.002000000}, {432,0.002000000}, {433,0.002000000}, {434,0.002000000}, {435,0.002557143}, {436,0.002004762}, {437,0.002000000}, {438,0.002000000}, {439,0.002000000}, {440,0.002000000}, {441,0.002000000}, {442,0.002000000}, {443,0.002000000}, {444,0.003533333}, {445,0.002000000}, {446,0.002000000}, {447,0.002000000}, {448,0.002000000}, {449,0.002000000}, {450,0.002000000}, {451,0.002000000}, {452,0.002000000}, {453,0.003619048}, {454,0.002004762}, {455,0.002000000}, {456,0.002000000}, {457,0.002000000}, {458,0.002000000}, {459,0.002000000}, {460,0.002000000}, {461,0.002000000}, {462,0.002528571}, {463,0.002000000}, {464,0.002000000}, {465,0.002000000}, {466,0.002019048}, {467,0.002000000}, {468,0.002000000}, {469,0.002000000}, {470,0.002000000}, {471,0.002000000}, {472,0.002000000}, {473,0.002000000}, {474,0.002000000}, {475,0.002000000}, {476,0.002000000}, {477,0.002000000}, {478,0.002000000}, {479,0.002000000}, {480,0.002000000}, {481,0.002000000}, {482,0.002000000}, {483,0.002038095}, {484,0.002004762}, {485,0.002000000}, {486,0.002000000}, {487,0.002000000}, {488,0.002000000}, {489,0.002000000}, {490,0.002000000}, {491,0.002000000}, {492,0.002000000}, {493,0.002000000}, {494,0.002000000}, {495,0.002000000}, {496,0.002514286}, {497,0.002000000}, {498,0.002004762}, {499,0.002000000}, {500,0.002000000}, {505,0.002000000}, {510,0.002000000}, {515,0.002000000}, {520,0.002580952}, {525,0.002000000}, {530,0.002000000}, {535,0.002000000}, {540,0.002000000}, {545,0.002009524}, {550,0.002004762}, {555,0.002000000}, {560,0.002014286}, {565,0.002019048}, {570,0.002023810}, {575,0.002071429}, {580,0.002061905}, {585,0.002090476}, {590,0.002142857}, {595,0.002228571}, {600,0.004404762}, {605,0.002333333}, {610,0.002400000}, {615,0.002380952}, {620,0.002461905}, {625,0.002509524}, {630,0.002576190}, {635,0.002638095}, {640,0.002714286}, {645,0.002814286}, {650,0.002861905}, {655,0.002895238}, {660,0.002890476}, {665,0.002914286}, {670,0.002919048}, {675,0.002976190}, {680,0.002980952}, {685,0.002995238}, {690,0.003000000}, {695,0.003000000}, {700,0.003000000}, {705,0.003480952}, {710,0.003000000}, {715,0.003000000}, {720,0.003000000}, {725,0.003000000}, {730,0.003000000}, {735,0.003019048}, {740,0.003000000}, {745,0.003000000}, {750,0.004804762}, {755,0.003000000}, {760,0.003000000}, {765,0.003000000}, {770,0.003004762}, {775,0.003000000}, {780,0.003000000}, {785,0.003004762}, {790,0.003009524}, {795,0.003014286}, {800,0.003009524}, {805,0.004019048}, {810,0.003023810}, {815,0.003052381}, {820,0.003085714}, {825,0.004119048}, {830,0.003209524}, {835,0.003233333}, {840,0.003271429}, {845,0.003295238}, {850,0.003366667}, {855,0.003385714}, {860,0.003404762}, {865,0.003452381}, {870,0.003480952}, {875,0.003566667}, {880,0.003595238}, {885,0.003633333}, {890,0.003738095}, {895,0.003780952}, {900,0.003842857}, {905,0.005528571}, {910,0.003880952}, {915,0.003890476}, {920,0.003923810}, {925,0.003942857}, {930,0.004476190}, {935,0.003952381}, {940,0.003966667}, {945,0.003985714}, {950,0.003995238}, {955,0.004485714}, {960,0.004000000}, {965,0.004000000}, {970,0.004000000}, {975,0.004000000}, {980,0.004009524}, {985,0.004004762}, {990,0.004000000}, {995,0.006795238}, {1000,0.004004762}, {1010,0.004061905}, {1020,0.004019048}, {1030,0.004019048}, {1040,0.004057143}, {1050,0.005038095}, {1060,0.004109524}, {1070,0.004238095}, {1080,0.004280952}, {1090,0.004352381}, {1100,0.004404762}, {1110,0.004447619}, {1120,0.004557143}, {1130,0.004671429}, {1140,0.004747619}, {1150,0.004857143}, {1160,0.004876190}, {1170,0.004914286}, {1180,0.004928571}, {1190,0.006338095}, {1200,0.004985714}, {1210,0.004995238}, {1220,0.005000000}, {1230,0.005009524}, {1240,0.005004762}, {1250,0.005009524}, {1260,0.008461905}, {1270,0.005061905}, {1280,0.005066667}, {1290,0.007047619}, {1300,0.005161905}, {1310,0.005271429}, {1320,0.005280952}, {1330,0.005380952}, {1340,0.005371429}, {1350,0.005438095}, {1360,0.009366667}, {1370,0.005600000}, {1380,0.005680952}, {1390,0.005804762}, {1400,0.005857143}, {1410,0.005880952}, {1420,0.005880952}, {1430,0.007314286}, {1440,0.005933333}, {1450,0.005952381}, {1460,0.005995238}, {1470,0.006000000}, {1480,0.006004762}, {1490,0.006023810}, {1500,0.006047619}, {1510,0.006061905}, {1520,0.006090476}, {1530,0.006119048}, {1540,0.006166667}, {1550,0.006238095}, {1560,0.006290476}, {1570,0.010447619}, {1580,0.006409524}, {1590,0.006419048}, {1600,0.006428571}, {1610,0.006561905}, {1620,0.006633333}, {1630,0.006733333}, {1640,0.006823810}, {1650,0.006861905}, {1660,0.006871429}, {1670,0.006885714}, {1680,0.008280952}, {1690,0.006928571}, {1700,0.006938095}, {1710,0.006995238}, {1720,0.007023810}, {1730,0.017380952}, {1740,0.007071429}, {1750,0.007066667}, {1760,0.008438095}, {1770,0.007171429}, {1780,0.007228571}, {1790,0.007261905}, {1800,0.007314286}, {1810,0.007366667}, {1820,0.007390476}, {1830,0.010519048}, {1840,0.008680952}, {1850,0.007500000}, {1860,0.007633333}, {1870,0.007647619}, {1880,0.007795238}, {1890,0.009333333}, {1900,0.007861905}, {1910,0.007880952}, {1920,0.007890476}, {1930,0.007914286}, {1940,0.009404762}, {1950,0.008000000}, {1960,0.008019048}, {1970,0.011314286}, {1980,0.008214286}, {1990,0.009547619}, {2000,0.008242857}, {2050,0.008366667}, {2100,0.008595238}, {2150,0.008871429}, {2200,0.008995238}, {2250,0.009280952}, {2300,0.009390476}, {2350,0.009657143}, {2400,0.009928571}, {2450,0.010128571}, {2500,0.010333333}, {2550,0.018766667}, {2600,0.010823810}, {2650,0.010990476}, {2700,0.011219048}, {2750,0.011385714}, {2800,0.016566667}, {2850,0.014752381}, {2900,0.012042857}, {2950,0.012214286}, {3000,0.012485714}, {3050,0.012561905}, {3100,0.015076190}, {3150,0.013214286}, {3200,0.013290476}, {3250,0.020109524}, {3300,0.013742857}, {3350,0.014100000}, {3400,0.017147619}, {3450,0.020319048}, {3500,0.014552381}, {3550,0.014966667}, {3600,0.022976190}, {3650,0.014790476}, {3700,0.024233333}, {3750,0.015623810}, {3800,0.021209524}, {3850,0.016366667}, {3900,0.016380952}, {3950,0.016495238}, {4000,0.019352381}, {4050,0.028923810}, {4100,0.017295238}, {4150,0.017476190}, {4200,0.017600000}, {4250,0.017952381}, {4300,0.018314286}, {4350,0.018514286}, {4400,0.021371429}, {4450,0.025247619}, {4500,0.035066667}, {4550,0.019466667}, {4600,0.019604762}, {4650,0.019795238}, {4700,0.020057143}, {4750,0.020352381}, {4800,0.020547619}, {4850,0.020733333}, {4900,0.020800000}, {4950,0.036704762}, {5000,0.026576190}, {5050,0.029319048}, {5100,0.021795238}, {5150,0.022319048}, {5200,0.022419048}, {5250,0.022490476}, {5300,0.037780952}, {5350,0.038323810}, {5400,0.030452381}, {5450,0.023666667}, {5500,0.023776190}, {5550,0.023909524}, {5600,0.031423810}, {5650,0.024609524}, {5700,0.041561905}, {5750,0.030780952}, {5800,0.033395238}, {5850,0.025447619}, {5900,0.025542857}, {5950,0.035200000}, {6000,0.032933333}, {6050,0.026252381}, {6100,0.033190476}, {6150,0.027085714}, {6200,0.032147619}, {6250,0.033733333}, {6300,0.027485714}, {6350,0.067514286}, {6400,0.031961905}, {6450,0.028014286}, {6500,0.032980952}, {6550,0.034952381}, {6600,0.033623810}, {6650,0.029190476}, {6700,0.048019048}, {6750,0.029604762}, {6800,0.057614286}, {6850,0.030119048}, {6900,0.042019048}, {6950,0.036223810}, {7000,0.035842857}, {7050,0.040223810}, {7100,0.035361905}, {7150,0.048952381}, {7200,0.032052381}, {7250,0.052504762}, {7300,0.032371429}, {7350,0.037185714}, {7400,0.032447619}, {7450,0.033228571}, {7500,0.040247619}, {7550,0.053380952}, {7600,0.033957143}, {7650,0.051138095}, {7700,0.034185714}, {7750,0.039271429}, {7800,0.039052381}, {7850,0.060233333}, {7900,0.056752381}, {7950,0.035609524}, {8000,0.047795238}, {8050,0.051709524}, {8100,0.036033333}, {8150,0.044104762}, {8200,0.039819048}, {8250,0.043485714}, {8300,0.064623810}, {8350,0.037042857}, {8400,0.037504762}, {8450,0.042600000}, {8500,0.061747619}, {8550,0.044757143}, {8600,0.044895238}, {8650,0.060800000}, {8700,0.082823810}, {8750,0.038928571}, {8800,0.039380952}, {8850,0.044452381}, {8900,0.047738095}, {8950,0.063595238}, {9000,0.040428571}, {9050,0.040628571}, {9100,0.040619048}, {9150,0.047785714}, {9200,0.048804762}, {9250,0.056385714}, {9300,0.065604762}, {9350,0.042195238}, {9400,0.042219048}, {9450,0.067938095}, {9500,0.061504762}, {9550,0.052595238}, {9600,0.049138095}, {9650,0.055666667}, {9700,0.049861905}, {9750,0.050533333}, {9800,0.051380952}, {9850,0.083923810}, {9900,0.063433333}, {9950,0.058928571}, {10000,0.051404762}, {10100,0.051876190}, {10200,0.074861905}, {10300,0.054866667}, {10400,0.053652381}, {10500,0.047700000}, {10600,0.091804762}, {10700,0.069271429}, {10800,0.056157143}, {10900,0.063147619}, {11000,0.050066667}, {11100,0.105633333}, {11200,0.067538095}, {11300,0.091114286}, {11400,0.059209524}, {11500,0.092142857}, {11600,0.065366667}, {11700,0.110095238}, {11800,0.062985714}, {11900,0.065266667}, {12000,0.106309524}, {12100,0.068857143}, {12200,0.081985714}, {12300,0.092719048}, {12400,0.079780952}, {12500,0.073080952}, {12600,0.091395238}, {12700,0.090047619}, {12800,0.070504762}, {12900,0.067809524}, {13000,0.077280952}, {13100,0.091880952}, {13200,0.074985714}, {13300,0.092242857}, {13400,0.101661905}, {13500,0.127719048}, {13600,0.092009524}, {13700,0.104452381}, {13800,0.105109524}, {13900,0.115685714}, {14000,0.122309524}, {14100,0.075780952}, {14200,0.083447619}, {14300,0.083266667}, {14400,0.089638095}, {14500,0.072847619}, {14600,0.113428571}, {14700,0.093423810}, {14800,0.091666667}, {14900,0.085161905}, {15000,0.110509524}, {15100,0.088209524}, {15200,0.089380952}, {15300,0.135785714}, {15400,0.090171429}, {15500,0.089633333}, {15600,0.135404762}, {15700,0.107957143}, {15800,0.115319048}, {15900,0.096842857}, {16000,0.111471429}, {16100,0.125261905}, {16200,0.114123810}, {16300,0.098795238}, {16400,0.134790476}, {16500,0.142557143}, {16600,0.098961905}, {16700,0.134933333}, {16800,0.089747619}, {16900,0.091876190}, {17000,0.110595238}, {17100,0.130552381}, {17200,0.109657143}, {17300,0.099557143}, {17400,0.111747619}, {17500,0.114985714}, {17600,0.134490476}, {17700,0.127038095}, {17800,0.095023810}, {17900,0.131580952}, {18000,0.106457143}, {18100,0.104809524}, {18200,0.131014286}, {18300,0.107680952}, {18400,0.106309524}, {18500,0.128904762}, {18600,0.147847619}, {18700,0.152661905}, {18800,0.134100000}, {18900,0.130171429}, {19000,0.130352381}, {19100,0.124752381}, {19200,0.164261905}, {19300,0.154923810}, {19400,0.133995238}, {19500,0.106419048}, {19600,0.107266667}, {19700,0.131471429}, {19800,0.107490476}, {19900,0.106247619}, {20000,0.129490385}};
data["big"]["Parametricity; beta"]["norm reif"]["user"] = {{1,0.000345972}, {2,0.000459716}, {3,0.000156398}, {4,0.000398104}, {5,0.000360190}, {6,0.000322275}, {7,0.000431280}, {8,0.000421801}, {9,0.000540284}, {10,0.000298578}, {11,0.000478673}, {12,0.000398104}, {13,0.000426540}, {14,0.000402844}, {15,0.000497630}, {16,0.000417062}, {17,0.000540284}, {18,0.000507109}, {19,0.000492891}, {20,0.000511848}, {21,0.000492891}, {22,0.000483412}, {23,0.000469194}, {24,0.022000000}, {25,0.000639810}, {26,0.000483412}, {27,0.000639810}, {28,0.000497630}, {29,0.000507109}, {30,0.000473934}, {31,0.000559242}, {32,0.000526066}, {33,0.000644550}, {34,0.000440758}, {35,0.000658768}, {36,0.000582938}, {37,0.000620853}, {38,0.000464455}, {39,0.000412322}, {40,0.000701422}, {41,0.000492891}, {42,0.000578199}, {43,0.000530806}, {44,0.000502370}, {45,0.000616114}, {46,0.000469194}, {47,0.000530806}, {48,0.000720379}, {49,0.000535545}, {50,0.000459716}, {51,0.000658768}, {52,0.000511848}, {53,0.000729858}, {54,0.000606635}, {55,0.000492891}, {56,0.000725118}, {57,0.000748815}, {58,0.000488152}, {59,0.000635071}, {60,0.000810427}, {61,0.000535545}, {62,0.000649289}, {63,0.000654028}, {64,0.000663507}, {65,0.000545024}, {66,0.000677725}, {67,0.000819905}, {68,0.000748815}, {69,0.000796209}, {70,0.000639810}, {71,0.000559242}, {72,0.000606635}, {73,0.000706161}, {74,0.000682464}, {75,0.000672986}, {76,0.000696682}, {77,0.000834123}, {78,0.000620853}, {79,0.000710900}, {80,0.000824645}, {81,0.000563981}, {82,0.000677725}, {83,0.000763033}, {84,0.000919431}, {85,0.000587678}, {86,0.000753555}, {87,0.000687204}, {88,0.000838863}, {89,0.000592417}, {90,0.000635071}, {91,0.000919431}, {92,0.000895735}, {93,0.000781991}, {94,0.000924171}, {95,0.000672986}, {96,0.000687204}, {97,0.000777251}, {98,0.000791469}, {99,0.000791469}, {100,0.000838863}, {101,0.000725118}, {102,0.000639810}, {103,0.000843602}, {104,0.000938389}, {105,0.000862559}, {106,0.000777251}, {107,0.000725118}, {108,0.000781991}, {109,0.000753555}, {110,0.000781991}, {111,0.000696682}, {112,0.000701422}, {113,0.000796209}, {114,0.000900474}, {115,0.000928910}, {116,0.000914692}, {117,0.001000000}, {118,0.000928910}, {119,0.000914692}, {120,0.000938389}, {121,0.000853081}, {122,0.000810427}, {123,0.000895735}, {124,0.000848341}, {125,0.000800948}, {126,0.001274882}, {127,0.000781991}, {128,0.000701422}, {129,0.000701422}, {130,0.000696682}, {131,0.000753555}, {132,0.000791469}, {133,0.000819905}, {134,0.000890995}, {135,0.000824645}, {136,0.000943128}, {137,0.000976303}, {138,0.001090047}, {139,0.001161137}, {140,0.001028436}, {141,0.001047393}, {142,0.001033175}, {143,0.000819905}, {144,0.000895735}, {145,0.000729858}, {146,0.000734597}, {147,0.000881517}, {148,0.001218009}, {149,0.001729858}, {150,0.001042654}, {151,0.000933649}, {152,0.000857820}, {153,0.001080569}, {154,0.001075829}, {155,0.001246445}, {156,0.001066351}, {157,0.001075829}, {158,0.000909953}, {159,0.000900474}, {160,0.001004739}, {161,0.001142180}, {162,0.001056872}, {163,0.001018957}, {164,0.000985782}, {165,0.001085308}, {166,0.001199052}, {167,0.000872038}, {168,0.001099526}, {169,0.000962085}, {170,0.001843602}, {171,0.001165877}, {172,0.001123223}, {173,0.001023697}, {174,0.001085308}, {175,0.001161137}, {176,0.001194313}, {177,0.000995261}, {178,0.001037915}, {179,0.001175355}, {180,0.001090047}, {181,0.000957346}, {182,0.000995261}, {183,0.001255924}, {184,0.001123223}, {185,0.001037915}, {186,0.001033175}, {187,0.001232227}, {188,0.001066351}, {189,0.001625592}, {190,0.001033175}, {191,0.001104265}, {192,0.001156398}, {193,0.000938389}, {194,0.001142180}, {195,0.001255924}, {196,0.001090047}, {197,0.001099526}, {198,0.001170616}, {199,0.001109005}, {200,0.001298578}, {201,0.001066351}, {202,0.001123223}, {203,0.001094787}, {204,0.001085308}, {205,0.001274882}, {206,0.001236967}, {207,0.001042654}, {208,0.001180095}, {209,0.001246445}, {210,0.001345972}, {211,0.001075829}, {212,0.001194313}, {213,0.001123223}, {214,0.001194313}, {215,0.001360190}, {216,0.001312796}, {217,0.001345972}, {218,0.001236967}, {219,0.001151659}, {220,0.001199052}, {221,0.001255924}, {222,0.001085308}, {223,0.001364929}, {224,0.001393365}, {225,0.000905213}, {226,0.001492891}, {227,0.001056872}, {228,0.001194313}, {229,0.001308057}, {230,0.001170616}, {231,0.001232227}, {232,0.001483412}, {233,0.001241706}, {234,0.001450237}, {235,0.001345972}, {236,0.001398104}, {237,0.001260664}, {238,0.001298578}, {239,0.001203791}, {240,0.001417062}, {241,0.001213270}, {242,0.001402844}, {243,0.001218009}, {244,0.001514286}, {245,0.001152381}, {246,0.001585714}, {247,0.001152381}, {248,0.001314286}, {249,0.001404762}, {250,0.001300000}, {251,0.001514286}, {252,0.001223810}, {253,0.001376190}, {254,0.002285714}, {255,0.001414286}, {256,0.001376190}, {257,0.001552381}, {258,0.001338095}, {259,0.001485714}, {260,0.001576190}, {261,0.001209524}, {262,0.001419048}, {263,0.001190476}, {264,0.001357143}, {265,0.001314286}, {266,0.001452381}, {267,0.001390476}, {268,0.001309524}, {269,0.001404762}, {270,0.001461905}, {271,0.001285714}, {272,0.001385714}, {273,0.001861905}, {274,0.001119048}, {275,0.001428571}, {276,0.001604762}, {277,0.001252381}, {278,0.001519048}, {279,0.001309524}, {280,0.001609524}, {281,0.001395238}, {282,0.002019048}, {283,0.001238095}, {284,0.001785714}, {285,0.001371429}, {286,0.001371429}, {287,0.001623810}, {288,0.001495238}, {289,0.001428571}, {290,0.001561905}, {291,0.001623810}, {292,0.001323810}, {293,0.001571429}, {294,0.001552381}, {295,0.002252381}, {296,0.001509524}, {297,0.001542857}, {298,0.001533333}, {299,0.001371429}, {300,0.001609524}, {301,0.001542857}, {302,0.001780952}, {303,0.001580952}, {304,0.001347619}, {305,0.001680952}, {306,0.001509524}, {307,0.001500000}, {308,0.001466667}, {309,0.001795238}, {310,0.001780952}, {311,0.001438095}, {312,0.001657143}, {313,0.001352381}, {314,0.001504762}, {315,0.001580952}, {316,0.001628571}, {317,0.001595238}, {318,0.001480952}, {319,0.001533333}, {320,0.002176190}, {321,0.001404762}, {322,0.001728571}, {323,0.001709524}, {324,0.001580952}, {325,0.001590476}, {326,0.001642857}, {327,0.001423810}, {328,0.001490476}, {329,0.001419048}, {330,0.001576190}, {331,0.001695238}, {332,0.001661905}, {333,0.001333333}, {334,0.001323810}, {335,0.001709524}, {336,0.001719048}, {337,0.001519048}, {338,0.001604762}, {339,0.001833333}, {340,0.001666667}, {341,0.002480952}, {342,0.001728571}, {343,0.001595238}, {344,0.001547619}, {345,0.001533333}, {346,0.001542857}, {347,0.001566667}, {348,0.001785714}, {349,0.001771429}, {350,0.001728571}, {351,0.001638095}, {352,0.001633333}, {353,0.001638095}, {354,0.001833333}, {355,0.001780952}, {356,0.001604762}, {357,0.001647619}, {358,0.001761905}, {359,0.001819048}, {360,0.001709524}, {361,0.001847619}, {362,0.001800000}, {363,0.001723810}, {364,0.001657143}, {365,0.002209524}, {366,0.001633333}, {367,0.001709524}, {368,0.001633333}, {369,0.001685714}, {370,0.001828571}, {371,0.001800000}, {372,0.001738095}, {373,0.001695238}, {374,0.001757143}, {375,0.001723810}, {376,0.002528571}, {377,0.001985714}, {378,0.001766667}, {379,0.001814286}, {380,0.001638095}, {381,0.001828571}, {382,0.001871429}, {383,0.001842857}, {384,0.001800000}, {385,0.001814286}, {386,0.001795238}, {387,0.001780952}, {388,0.001723810}, {389,0.001700000}, {390,0.001733333}, {391,0.001780952}, {392,0.001890476}, {393,0.001895238}, {394,0.001680952}, {395,0.001709524}, {396,0.001828571}, {397,0.001619048}, {398,0.001695238}, {399,0.002042857}, {400,0.001904762}, {401,0.001880952}, {402,0.001871429}, {403,0.001866667}, {404,0.002085714}, {405,0.001938095}, {406,0.001938095}, {407,0.001885714}, {408,0.001900000}, {409,0.002547619}, {410,0.001909524}, {411,0.001952381}, {412,0.001966667}, {413,0.001842857}, {414,0.002028571}, {415,0.002100000}, {416,0.001828571}, {417,0.002019048}, {418,0.001900000}, {419,0.001938095}, {420,0.002095238}, {421,0.001880952}, {422,0.002261905}, {423,0.002009524}, {424,0.001895238}, {425,0.002019048}, {426,0.001866667}, {427,0.002019048}, {428,0.001919048}, {429,0.002190476}, {430,0.001966667}, {431,0.001723810}, {432,0.001761905}, {433,0.002338095}, {434,0.002114286}, {435,0.002852381}, {436,0.002109524}, {437,0.002023810}, {438,0.002028571}, {439,0.002109524}, {440,0.001971429}, {441,0.001876190}, {442,0.002128571}, {443,0.002209524}, {444,0.003647619}, {445,0.002071429}, {446,0.001990476}, {447,0.002138095}, {448,0.001995238}, {449,0.002280952}, {450,0.002066667}, {451,0.002333333}, {452,0.001857143}, {453,0.003576190}, {454,0.002147619}, {455,0.002123810}, {456,0.002104762}, {457,0.001942857}, {458,0.002238095}, {459,0.002119048}, {460,0.002076190}, {461,0.001985714}, {462,0.002542857}, {463,0.002180952}, {464,0.002142857}, {465,0.002295238}, {466,0.002114286}, {467,0.002004762}, {468,0.002071429}, {469,0.002290476}, {470,0.001928571}, {471,0.002166667}, {472,0.002300000}, {473,0.002200000}, {474,0.002133333}, {475,0.001976190}, {476,0.002214286}, {477,0.002238095}, {478,0.002128571}, {479,0.002190476}, {480,0.002342857}, {481,0.002166667}, {482,0.002242857}, {483,0.002252381}, {484,0.002328571}, {485,0.002090476}, {486,0.002233333}, {487,0.002195238}, {488,0.002300000}, {489,0.002004762}, {490,0.002514286}, {491,0.002100000}, {492,0.002361905}, {493,0.002433333}, {494,0.002276190}, {495,0.002252381}, {496,0.002657143}, {497,0.002476190}, {498,0.002123810}, {499,0.002257143}, {500,0.002338095}, {505,0.002061905}, {510,0.002509524}, {515,0.002195238}, {520,0.003052381}, {525,0.002457143}, {530,0.002495238}, {535,0.002333333}, {540,0.002414286}, {545,0.002328571}, {550,0.002247619}, {555,0.002409524}, {560,0.002423810}, {565,0.002485714}, {570,0.002419048}, {575,0.002514286}, {580,0.002480952}, {585,0.002447619}, {590,0.002585714}, {595,0.002538095}, {600,0.004328571}, {605,0.002447619}, {610,0.002609524}, {615,0.002795238}, {620,0.002752381}, {625,0.002704762}, {630,0.003014286}, {635,0.002842857}, {640,0.002800000}, {645,0.003090476}, {650,0.002909524}, {655,0.003071429}, {660,0.003014286}, {665,0.002790476}, {670,0.002914286}, {675,0.002957143}, {680,0.002919048}, {685,0.002990476}, {690,0.003157143}, {695,0.003114286}, {700,0.003028571}, {705,0.003519048}, {710,0.003095238}, {715,0.003090476}, {720,0.002828571}, {725,0.003109524}, {730,0.003004762}, {735,0.003061905}, {740,0.003090476}, {745,0.003200000}, {750,0.004876190}, {755,0.003161905}, {760,0.003238095}, {765,0.003280952}, {770,0.003280952}, {775,0.003166667}, {780,0.003276190}, {785,0.003352381}, {790,0.003285714}, {795,0.003380952}, {800,0.003461905}, {805,0.004066667}, {810,0.003490476}, {815,0.003519048}, {820,0.003352381}, {825,0.004276190}, {830,0.003566667}, {835,0.003557143}, {840,0.003533333}, {845,0.003576190}, {850,0.003600000}, {855,0.003604762}, {860,0.003547619}, {865,0.003628571}, {870,0.003614286}, {875,0.003604762}, {880,0.003680952}, {885,0.003728571}, {890,0.003609524}, {895,0.003671429}, {900,0.003728571}, {905,0.005519048}, {910,0.003790476}, {915,0.003852381}, {920,0.003842857}, {925,0.003990476}, {930,0.004295238}, {935,0.003880952}, {940,0.003890476}, {945,0.004119048}, {950,0.003814286}, {955,0.004404762}, {960,0.003957143}, {965,0.003985714}, {970,0.004080952}, {975,0.003876190}, {980,0.004052381}, {985,0.004119048}, {990,0.004204762}, {995,0.006766667}, {1000,0.004004762}, {1010,0.004295238}, {1020,0.004161905}, {1030,0.004323810}, {1040,0.004295238}, {1050,0.005190476}, {1060,0.004357143}, {1070,0.004419048}, {1080,0.004500000}, {1090,0.004457143}, {1100,0.004542857}, {1110,0.004319048}, {1120,0.004495238}, {1130,0.004557143}, {1140,0.004623810}, {1150,0.004666667}, {1160,0.004671429}, {1170,0.004838095}, {1180,0.004780952}, {1190,0.006114286}, {1200,0.004652381}, {1210,0.004942857}, {1220,0.005033333}, {1230,0.005185714}, {1240,0.004919048}, {1250,0.005138095}, {1260,0.008823810}, {1270,0.004914286}, {1280,0.005204762}, {1290,0.007080952}, {1300,0.005376190}, {1310,0.005328571}, {1320,0.005533333}, {1330,0.005590476}, {1340,0.005371429}, {1350,0.005233333}, {1360,0.009328571}, {1370,0.005528571}, {1380,0.005490476}, {1390,0.005819048}, {1400,0.005790476}, {1410,0.005614286}, {1420,0.005761905}, {1430,0.007495238}, {1440,0.005747619}, {1450,0.005814286}, {1460,0.005876190}, {1470,0.006000000}, {1480,0.005985714}, {1490,0.006033333}, {1500,0.005914286}, {1510,0.005814286}, {1520,0.005928571}, {1530,0.006138095}, {1540,0.006500000}, {1550,0.006280952}, {1560,0.006457143}, {1570,0.010614286}, {1580,0.006152381}, {1590,0.006476190}, {1600,0.006285714}, {1610,0.006385714}, {1620,0.006347619}, {1630,0.006500000}, {1640,0.006504762}, {1650,0.006600000}, {1660,0.006433333}, {1670,0.006647619}, {1680,0.008100000}, {1690,0.006704762}, {1700,0.006633333}, {1710,0.006733333}, {1720,0.006923810}, {1730,0.017019048}, {1740,0.006938095}, {1750,0.007000000}, {1760,0.008133333}, {1770,0.007052381}, {1780,0.006985714}, {1790,0.007109524}, {1800,0.007180952}, {1810,0.007176190}, {1820,0.007309524}, {1830,0.010547619}, {1840,0.008457143}, {1850,0.007323810}, {1860,0.007495238}, {1870,0.007609524}, {1880,0.007333333}, {1890,0.009195238}, {1900,0.007771429}, {1910,0.007533333}, {1920,0.007852381}, {1930,0.007866667}, {1940,0.009380952}, {1950,0.007990476}, {1960,0.007971429}, {1970,0.011104762}, {1980,0.008109524}, {1990,0.009661905}, {2000,0.008228571}, {2050,0.008442857}, {2100,0.008471429}, {2150,0.008604762}, {2200,0.008995238}, {2250,0.009171429}, {2300,0.009580952}, {2350,0.010085714}, {2400,0.010319048}, {2450,0.010204762}, {2500,0.010433333}, {2550,0.018514286}, {2600,0.011042857}, {2650,0.011242857}, {2700,0.011628571}, {2750,0.011771429}, {2800,0.016619048}, {2850,0.014971429}, {2900,0.012300000}, {2950,0.012490476}, {3000,0.012714286}, {3050,0.013128571}, {3100,0.015038095}, {3150,0.013476190}, {3200,0.013542857}, {3250,0.019847619}, {3300,0.014080952}, {3350,0.014314286}, {3400,0.017171429}, {3450,0.020485714}, {3500,0.014723810}, {3550,0.015152381}, {3600,0.022752381}, {3650,0.014985714}, {3700,0.024090476}, {3750,0.015742857}, {3800,0.021238095}, {3850,0.016133333}, {3900,0.016404762}, {3950,0.016709524}, {4000,0.019728571}, {4050,0.028357143}, {4100,0.017166667}, {4150,0.017523810}, {4200,0.017742857}, {4250,0.017890476}, {4300,0.018095238}, {4350,0.018542857}, {4400,0.021404762}, {4450,0.024680952}, {4500,0.034709524}, {4550,0.019109524}, {4600,0.019400000}, {4650,0.019595238}, {4700,0.020019048}, {4750,0.020090476}, {4800,0.020266667}, {4850,0.020661905}, {4900,0.021033333}, {4950,0.036552381}, {5000,0.026423810}, {5050,0.029061905}, {5100,0.021952381}, {5150,0.022195238}, {5200,0.022414286}, {5250,0.022519048}, {5300,0.037723810}, {5350,0.038000000}, {5400,0.030619048}, {5450,0.023857143}, {5500,0.023876190}, {5550,0.024257143}, {5600,0.031733333}, {5650,0.024990476}, {5700,0.041471429}, {5750,0.030538095}, {5800,0.033409524}, {5850,0.025742857}, {5900,0.025814286}, {5950,0.035238095}, {6000,0.032728571}, {6050,0.026147619}, {6100,0.033380952}, {6150,0.027080952}, {6200,0.032195238}, {6250,0.033838095}, {6300,0.027538095}, {6350,0.066652381}, {6400,0.031966667}, {6450,0.027971429}, {6500,0.032800000}, {6550,0.034961905}, {6600,0.033752381}, {6650,0.029057143}, {6700,0.047704762}, {6750,0.029657143}, {6800,0.057038095}, {6850,0.029971429}, {6900,0.041504762}, {6950,0.036233333}, {7000,0.035604762}, {7050,0.040142857}, {7100,0.035300000}, {7150,0.048604762}, {7200,0.032028571}, {7250,0.051795238}, {7300,0.032266667}, {7350,0.036947619}, {7400,0.032633333}, {7450,0.033042857}, {7500,0.039990476}, {7550,0.053023810}, {7600,0.033995238}, {7650,0.050704762}, {7700,0.033985714}, {7750,0.039128571}, {7800,0.038738095}, {7850,0.059195238}, {7900,0.056228571}, {7950,0.035680952}, {8000,0.047442857}, {8050,0.051485714}, {8100,0.036109524}, {8150,0.044057143}, {8200,0.039595238}, {8250,0.043300000}, {8300,0.064295238}, {8350,0.037057143}, {8400,0.037761905}, {8450,0.042671429}, {8500,0.061238095}, {8550,0.044580952}, {8600,0.044638095}, {8650,0.060414286}, {8700,0.082452381}, {8750,0.038971429}, {8800,0.039509524}, {8850,0.044304762}, {8900,0.047661905}, {8950,0.063161905}, {9000,0.040385714}, {9050,0.040723810}, {9100,0.040714286}, {9150,0.047647619}, {9200,0.048614286}, {9250,0.055990476}, {9300,0.065219048}, {9350,0.042228571}, {9400,0.042252381}, {9450,0.067985714}, {9500,0.061528571}, {9550,0.052561905}, {9600,0.049219048}, {9650,0.055571429}, {9700,0.049542857}, {9750,0.050280952}, {9800,0.051319048}, {9850,0.083804762}, {9900,0.063466667}, {9950,0.058676190}, {10000,0.051395238}, {10100,0.051671429}, {10200,0.074761905}, {10300,0.054923810}, {10400,0.053795238}, {10500,0.047547619}, {10600,0.091176190}, {10700,0.069195238}, {10800,0.056095238}, {10900,0.063042857}, {11000,0.050085714}, {11100,0.105423810}, {11200,0.067323810}, {11300,0.090995238}, {11400,0.059276190}, {11500,0.092366667}, {11600,0.065304762}, {11700,0.109976190}, {11800,0.062861905}, {11900,0.065376190}, {12000,0.105680952}, {12100,0.068471429}, {12200,0.081547619}, {12300,0.092466667}, {12400,0.079176190}, {12500,0.073047619}, {12600,0.090933333}, {12700,0.089885714}, {12800,0.070519048}, {12900,0.067904762}, {13000,0.077014286}, {13100,0.091461905}, {13200,0.075128571}, {13300,0.092047619}, {13400,0.101261905}, {13500,0.127019048}, {13600,0.091766667}, {13700,0.104157143}, {13800,0.104880952}, {13900,0.115152381}, {14000,0.122157143}, {14100,0.075971429}, {14200,0.083423810}, {14300,0.083233333}, {14400,0.089528571}, {14500,0.072704762}, {14600,0.113538095}, {14700,0.093304762}, {14800,0.091438095}, {14900,0.085080952}, {15000,0.110461905}, {15100,0.088204762}, {15200,0.089457143}, {15300,0.135471429}, {15400,0.089890476}, {15500,0.089742857}, {15600,0.135080952}, {15700,0.107742857}, {15800,0.114995238}, {15900,0.097352381}, {16000,0.111400000}, {16100,0.125300000}, {16200,0.113919048}, {16300,0.098733333}, {16400,0.134619048}, {16500,0.142528571}, {16600,0.099114286}, {16700,0.134666667}, {16800,0.089671429}, {16900,0.091695238}, {17000,0.110376190}, {17100,0.130457143}, {17200,0.109723810}, {17300,0.099585714}, {17400,0.111495238}, {17500,0.114957143}, {17600,0.134280952}, {17700,0.126833333}, {17800,0.094885714}, {17900,0.131457143}, {18000,0.106166667}, {18100,0.104800000}, {18200,0.131114286}, {18300,0.107542857}, {18400,0.106171429}, {18500,0.128814286}, {18600,0.147623810}, {18700,0.152466667}, {18800,0.133876190}, {18900,0.130100000}, {19000,0.130452381}, {19100,0.124423810}, {19200,0.163966667}, {19300,0.154785714}, {19400,0.133780952}, {19500,0.106261905}, {19600,0.107309524}, {19700,0.131480952}, {19800,0.107547619}, {19900,0.106000000}, {20000,0.129427885}};
data["big"]["Parametricity; beta"]["norm reif"]["system"] = {{1,0.000094787}, {2,0.000018957}, {3,0.000000000}, {4,0.000037915}, {5,0.000018957}, {6,0.000000000}, {7,0.000000000}, {8,0.000018957}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000018957}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000037915}, {17,0.000000000}, {18,0.000018957}, {19,0.000018957}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000037915}, {24,0.000279621}, {25,0.000018957}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000018957}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000018957}, {38,0.000018957}, {39,0.000000000}, {40,0.000018957}, {41,0.000037915}, {42,0.000014218}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000037915}, {49,0.000018957}, {50,0.000018957}, {51,0.000000000}, {52,0.000000000}, {53,0.000056872}, {54,0.000018957}, {55,0.000018957}, {56,0.000000000}, {57,0.000018957}, {58,0.000000000}, {59,0.000000000}, {60,0.000018957}, {61,0.000000000}, {62,0.000018957}, {63,0.000000000}, {64,0.000018957}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000018957}, {73,0.000000000}, {74,0.000014218}, {75,0.000018957}, {76,0.000037915}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000018957}, {81,0.000000000}, {82,0.000018957}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000033175}, {89,0.000018957}, {90,0.000000000}, {91,0.000018957}, {92,0.000018957}, {93,0.000018957}, {94,0.000000000}, {95,0.000033175}, {96,0.000056872}, {97,0.000018957}, {98,0.000000000}, {99,0.000018957}, {100,0.000018957}, {101,0.000000000}, {102,0.000018957}, {103,0.000000000}, {104,0.000018957}, {105,0.000000000}, {106,0.000037915}, {107,0.000037915}, {108,0.000000000}, {109,0.000018957}, {110,0.000037915}, {111,0.000018957}, {112,0.000000000}, {113,0.000018957}, {114,0.000000000}, {115,0.000018957}, {116,0.000018957}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000033175}, {123,0.000018957}, {124,0.000000000}, {125,0.000000000}, {126,0.000033175}, {127,0.000018957}, {128,0.000056872}, {129,0.000018957}, {130,0.000014218}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000018957}, {135,0.000000000}, {136,0.000000000}, {137,0.000018957}, {138,0.000037915}, {139,0.000000000}, {140,0.000000000}, {141,0.000052133}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000018957}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000018957}, {150,0.000018957}, {151,0.000018957}, {152,0.000000000}, {153,0.000000000}, {154,0.000018957}, {155,0.000014218}, {156,0.000018957}, {157,0.000018957}, {158,0.000018957}, {159,0.000000000}, {160,0.000000000}, {161,0.000018957}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000037915}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000018957}, {171,0.000018957}, {172,0.000018957}, {173,0.000000000}, {174,0.000018957}, {175,0.000000000}, {176,0.000037915}, {177,0.000018957}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000018957}, {183,0.000000000}, {184,0.000000000}, {185,0.000018957}, {186,0.000037915}, {187,0.000000000}, {188,0.000000000}, {189,0.000090047}, {190,0.000018957}, {191,0.000018957}, {192,0.000018957}, {193,0.000000000}, {194,0.000018957}, {195,0.000000000}, {196,0.000018957}, {197,0.000000000}, {198,0.000037915}, {199,0.000000000}, {200,0.000018957}, {201,0.000037915}, {202,0.000000000}, {203,0.000014218}, {204,0.000037915}, {205,0.000000000}, {206,0.000037915}, {207,0.000018957}, {208,0.000000000}, {209,0.000018957}, {210,0.000018957}, {211,0.000018957}, {212,0.000018957}, {213,0.000018957}, {214,0.000018957}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000018957}, {220,0.000000000}, {221,0.000000000}, {222,0.000018957}, {223,0.000000000}, {224,0.000018957}, {225,0.000000000}, {226,0.000037915}, {227,0.000000000}, {228,0.000018957}, {229,0.000000000}, {230,0.000000000}, {231,0.000018957}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000037915}, {241,0.000018957}, {242,0.000018957}, {243,0.000000000}, {244,0.000000000}, {245,0.000019048}, {246,0.000000000}, {247,0.000000000}, {248,0.000019048}, {249,0.000000000}, {250,0.000000000}, {251,0.000019048}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000019048}, {256,0.000000000}, {257,0.000019048}, {258,0.000000000}, {259,0.000019048}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000038095}, {265,0.000000000}, {266,0.000038095}, {267,0.000000000}, {268,0.000014286}, {269,0.000019048}, {270,0.000000000}, {271,0.000000000}, {272,0.000019048}, {273,0.000019048}, {274,0.000019048}, {275,0.000038095}, {276,0.000000000}, {277,0.000000000}, {278,0.000019048}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000019048}, {284,0.000000000}, {285,0.000000000}, {286,0.000038095}, {287,0.000019048}, {288,0.000019048}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000019048}, {293,0.000000000}, {294,0.000038095}, {295,0.000038095}, {296,0.000000000}, {297,0.000019048}, {298,0.000019048}, {299,0.000019048}, {300,0.000000000}, {301,0.000019048}, {302,0.000019048}, {303,0.000019048}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000019048}, {308,0.000019048}, {309,0.000014286}, {310,0.000019048}, {311,0.000000000}, {312,0.000038095}, {313,0.000019048}, {314,0.000000000}, {315,0.000000000}, {316,0.000019048}, {317,0.000071429}, {318,0.000000000}, {319,0.000033333}, {320,0.000052381}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000038095}, {326,0.000019048}, {327,0.000038095}, {328,0.000019048}, {329,0.000019048}, {330,0.000000000}, {331,0.000014286}, {332,0.000000000}, {333,0.000000000}, {334,0.000038095}, {335,0.000019048}, {336,0.000014286}, {337,0.000000000}, {338,0.000019048}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000033333}, {344,0.000000000}, {345,0.000038095}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000019048}, {352,0.000000000}, {353,0.000000000}, {354,0.000038095}, {355,0.000019048}, {356,0.000019048}, {357,0.000000000}, {358,0.000019048}, {359,0.000000000}, {360,0.000057143}, {361,0.000000000}, {362,0.000019048}, {363,0.000000000}, {364,0.000019048}, {365,0.000000000}, {366,0.000019048}, {367,0.000000000}, {368,0.000019048}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000019048}, {375,0.000038095}, {376,0.000076190}, {377,0.000014286}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000057143}, {383,0.000038095}, {384,0.000000000}, {385,0.000000000}, {386,0.000014286}, {387,0.000000000}, {388,0.000019048}, {389,0.000038095}, {390,0.000000000}, {391,0.000019048}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000076190}, {397,0.000019048}, {398,0.000019048}, {399,0.000019048}, {400,0.000019048}, {401,0.000000000}, {402,0.000038095}, {403,0.000019048}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000014286}, {408,0.000038095}, {409,0.000019048}, {410,0.000019048}, {411,0.000000000}, {412,0.000000000}, {413,0.000019048}, {414,0.000019048}, {415,0.000038095}, {416,0.000038095}, {417,0.000000000}, {418,0.000057143}, {419,0.000019048}, {420,0.000019048}, {421,0.000019048}, {422,0.000019048}, {423,0.000019048}, {424,0.000033333}, {425,0.000019048}, {426,0.000019048}, {427,0.000019048}, {428,0.000019048}, {429,0.000000000}, {430,0.000000000}, {431,0.000019048}, {432,0.000076190}, {433,0.000038095}, {434,0.000019048}, {435,0.000038095}, {436,0.000019048}, {437,0.000000000}, {438,0.000000000}, {439,0.000038095}, {440,0.000019048}, {441,0.000019048}, {442,0.000057143}, {443,0.000000000}, {444,0.000114286}, {445,0.000019048}, {446,0.000019048}, {447,0.000038095}, {448,0.000000000}, {449,0.000000000}, {450,0.000038095}, {451,0.000019048}, {452,0.000000000}, {453,0.000038095}, {454,0.000000000}, {455,0.000019048}, {456,0.000000000}, {457,0.000019048}, {458,0.000019048}, {459,0.000076190}, {460,0.000019048}, {461,0.000000000}, {462,0.000057143}, {463,0.000019048}, {464,0.000038095}, {465,0.000076190}, {466,0.000014286}, {467,0.000019048}, {468,0.000019048}, {469,0.000000000}, {470,0.000057143}, {471,0.000057143}, {472,0.000057143}, {473,0.000019048}, {474,0.000019048}, {475,0.000019048}, {476,0.000000000}, {477,0.000019048}, {478,0.000057143}, {479,0.000000000}, {480,0.000038095}, {481,0.000019048}, {482,0.000000000}, {483,0.000000000}, {484,0.000019048}, {485,0.000033333}, {486,0.000071429}, {487,0.000038095}, {488,0.000057143}, {489,0.000038095}, {490,0.000019048}, {491,0.000000000}, {492,0.000038095}, {493,0.000038095}, {494,0.000000000}, {495,0.000019048}, {496,0.000014286}, {497,0.000019048}, {498,0.000019048}, {499,0.000000000}, {500,0.000038095}, {505,0.000019048}, {510,0.000000000}, {515,0.000000000}, {520,0.000038095}, {525,0.000038095}, {530,0.000000000}, {535,0.000000000}, {540,0.000019048}, {545,0.000000000}, {550,0.000019048}, {555,0.000019048}, {560,0.000019048}, {565,0.000057143}, {570,0.000038095}, {575,0.000000000}, {580,0.000019048}, {585,0.000038095}, {590,0.000000000}, {595,0.000057143}, {600,0.000038095}, {605,0.000019048}, {610,0.000000000}, {615,0.000000000}, {620,0.000038095}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000019048}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000038095}, {670,0.000000000}, {675,0.000019048}, {680,0.000057143}, {685,0.000019048}, {690,0.000000000}, {695,0.000000000}, {700,0.000038095}, {705,0.000019048}, {710,0.000038095}, {715,0.000038095}, {720,0.000057143}, {725,0.000038095}, {730,0.000019048}, {735,0.000076190}, {740,0.000019048}, {745,0.000000000}, {750,0.000038095}, {755,0.000019048}, {760,0.000019048}, {765,0.000000000}, {770,0.000076190}, {775,0.000038095}, {780,0.000057143}, {785,0.000000000}, {790,0.000019048}, {795,0.000076190}, {800,0.000000000}, {805,0.000038095}, {810,0.000000000}, {815,0.000000000}, {820,0.000038095}, {825,0.000019048}, {830,0.000019048}, {835,0.000000000}, {840,0.000014286}, {845,0.000019048}, {850,0.000000000}, {855,0.000000000}, {860,0.000057143}, {865,0.000000000}, {870,0.000038095}, {875,0.000014286}, {880,0.000019048}, {885,0.000000000}, {890,0.000038095}, {895,0.000076190}, {900,0.000019048}, {905,0.000076190}, {910,0.000038095}, {915,0.000000000}, {920,0.000019048}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000019048}, {945,0.000000000}, {950,0.000019048}, {955,0.000019048}, {960,0.000000000}, {965,0.000000000}, {970,0.000019048}, {975,0.000019048}, {980,0.000000000}, {985,0.000019048}, {990,0.000052381}, {995,0.000076190}, {1000,0.000076190}, {1010,0.000000000}, {1020,0.000052381}, {1030,0.000019048}, {1040,0.000057143}, {1050,0.000095238}, {1060,0.000019048}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000019048}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000019048}, {1130,0.000033333}, {1140,0.000071429}, {1150,0.000000000}, {1160,0.000038095}, {1170,0.000019048}, {1180,0.000038095}, {1190,0.000000000}, {1200,0.000038095}, {1210,0.000038095}, {1220,0.000033333}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000052381}, {1260,0.000038095}, {1270,0.000019048}, {1280,0.000019048}, {1290,0.000057143}, {1300,0.000038095}, {1310,0.000019048}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000038095}, {1360,0.000247619}, {1370,0.000038095}, {1380,0.000019048}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000038095}, {1420,0.000000000}, {1430,0.000038095}, {1440,0.000000000}, {1450,0.000057143}, {1460,0.000019048}, {1470,0.000000000}, {1480,0.000019048}, {1490,0.000019048}, {1500,0.000038095}, {1510,0.000019048}, {1520,0.000000000}, {1530,0.000019048}, {1540,0.000038095}, {1550,0.000019048}, {1560,0.000038095}, {1570,0.000114286}, {1580,0.000057143}, {1590,0.000057143}, {1600,0.000019048}, {1610,0.000038095}, {1620,0.000000000}, {1630,0.000019048}, {1640,0.000000000}, {1650,0.000057143}, {1660,0.000057143}, {1670,0.000038095}, {1680,0.000076190}, {1690,0.000000000}, {1700,0.000019048}, {1710,0.000000000}, {1720,0.000057143}, {1730,0.000357143}, {1740,0.000000000}, {1750,0.000019048}, {1760,0.000133333}, {1770,0.000000000}, {1780,0.000076190}, {1790,0.000014286}, {1800,0.000019048}, {1810,0.000076190}, {1820,0.000038095}, {1830,0.000095238}, {1840,0.000076190}, {1850,0.000057143}, {1860,0.000019048}, {1870,0.000019048}, {1880,0.000019048}, {1890,0.000095238}, {1900,0.000019048}, {1910,0.000057143}, {1920,0.000038095}, {1930,0.000019048}, {1940,0.000066667}, {1950,0.000038095}, {1960,0.000019048}, {1970,0.000114286}, {1980,0.000057143}, {1990,0.000057143}, {2000,0.000038095}, {2050,0.000014286}, {2100,0.000038095}, {2150,0.000057143}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000019048}, {2350,0.000000000}, {2400,0.000071429}, {2450,0.000019048}, {2500,0.000033333}, {2550,0.000190476}, {2600,0.000038095}, {2650,0.000057143}, {2700,0.000019048}, {2750,0.000000000}, {2800,0.000190476}, {2850,0.000057143}, {2900,0.000019048}, {2950,0.000076190}, {3000,0.000019048}, {3050,0.000000000}, {3100,0.000076190}, {3150,0.000019048}, {3200,0.000019048}, {3250,0.000142857}, {3300,0.000000000}, {3350,0.000033333}, {3400,0.000038095}, {3450,0.000133333}, {3500,0.000019048}, {3550,0.000038095}, {3600,0.000285714}, {3650,0.000019048}, {3700,0.000261905}, {3750,0.000019048}, {3800,0.000209524}, {3850,0.000000000}, {3900,0.000038095}, {3950,0.000076190}, {4000,0.000095238}, {4050,0.000438095}, {4100,0.000019048}, {4150,0.000057143}, {4200,0.000019048}, {4250,0.000019048}, {4300,0.000076190}, {4350,0.000076190}, {4400,0.000114286}, {4450,0.000347619}, {4500,0.000395238}, {4550,0.000019048}, {4600,0.000033333}, {4650,0.000095238}, {4700,0.000038095}, {4750,0.000019048}, {4800,0.000076190}, {4850,0.000019048}, {4900,0.000019048}, {4950,0.000361905}, {5000,0.000171429}, {5050,0.000152381}, {5100,0.000038095}, {5150,0.000076190}, {5200,0.000057143}, {5250,0.000057143}, {5300,0.000380952}, {5350,0.000361905}, {5400,0.000166667}, {5450,0.000019048}, {5500,0.000033333}, {5550,0.000038095}, {5600,0.000190476}, {5650,0.000095238}, {5700,0.000333333}, {5750,0.000190476}, {5800,0.000038095}, {5850,0.000019048}, {5900,0.000057143}, {5950,0.000057143}, {6000,0.000266667}, {6050,0.000123810}, {6100,0.000090476}, {6150,0.000076190}, {6200,0.000076190}, {6250,0.000038095}, {6300,0.000033333}, {6350,0.000471429}, {6400,0.000133333}, {6450,0.000095238}, {6500,0.000076190}, {6550,0.000166667}, {6600,0.000038095}, {6650,0.000019048}, {6700,0.000285714}, {6750,0.000000000}, {6800,0.000561905}, {6850,0.000000000}, {6900,0.000247619}, {6950,0.000114286}, {7000,0.000095238}, {7050,0.000228571}, {7100,0.000114286}, {7150,0.000357143}, {7200,0.000000000}, {7250,0.000438095}, {7300,0.000038095}, {7350,0.000095238}, {7400,0.000000000}, {7450,0.000057143}, {7500,0.000114286}, {7550,0.000523810}, {7600,0.000114286}, {7650,0.000452381}, {7700,0.000057143}, {7750,0.000209524}, {7800,0.000147619}, {7850,0.000923810}, {7900,0.000519048}, {7950,0.000033333}, {8000,0.000300000}, {8050,0.000304762}, {8100,0.000076190}, {8150,0.000114286}, {8200,0.000114286}, {8250,0.000109524}, {8300,0.000523810}, {8350,0.000000000}, {8400,0.000038095}, {8450,0.000185714}, {8500,0.000338095}, {8550,0.000323810}, {8600,0.000209524}, {8650,0.000285714}, {8700,0.000247619}, {8750,0.000076190}, {8800,0.000000000}, {8850,0.000109524}, {8900,0.000171429}, {8950,0.000280952}, {9000,0.000019048}, {9050,0.000057143}, {9100,0.000038095}, {9150,0.000114286}, {9200,0.000076190}, {9250,0.000342857}, {9300,0.000438095}, {9350,0.000019048}, {9400,0.000000000}, {9450,0.000057143}, {9500,0.000000000}, {9550,0.000076190}, {9600,0.000000000}, {9650,0.000171429}, {9700,0.000095238}, {9750,0.000114286}, {9800,0.000128571}, {9850,0.000071429}, {9900,0.000114286}, {9950,0.000114286}, {10000,0.000095238}, {10100,0.000152381}, {10200,0.000057143}, {10300,0.000038095}, {10400,0.000038095}, {10500,0.000000000}, {10600,0.000509524}, {10700,0.000276190}, {10800,0.000209524}, {10900,0.000076190}, {11000,0.000019048}, {11100,0.000190476}, {11200,0.000038095}, {11300,0.000038095}, {11400,0.000033333}, {11500,0.000019048}, {11600,0.000076190}, {11700,0.000038095}, {11800,0.000038095}, {11900,0.000019048}, {12000,0.000566667}, {12100,0.000352381}, {12200,0.000514286}, {12300,0.000261905}, {12400,0.000633333}, {12500,0.000152381}, {12600,0.000438095}, {12700,0.000019048}, {12800,0.000209524}, {12900,0.000019048}, {13000,0.000190476}, {13100,0.000523810}, {13200,0.000076190}, {13300,0.000414286}, {13400,0.000266667}, {13500,0.000714286}, {13600,0.000038095}, {13700,0.000166667}, {13800,0.000228571}, {13900,0.000300000}, {14000,0.000000000}, {14100,0.000000000}, {14200,0.000019048}, {14300,0.000038095}, {14400,0.000014286}, {14500,0.000019048}, {14600,0.000019048}, {14700,0.000038095}, {14800,0.000057143}, {14900,0.000038095}, {15000,0.000057143}, {15100,0.000019048}, {15200,0.000057143}, {15300,0.000038095}, {15400,0.000076190}, {15500,0.000038095}, {15600,0.000019048}, {15700,0.000057143}, {15800,0.000014286}, {15900,0.000057143}, {16000,0.000085714}, {16100,0.000057143}, {16200,0.000095238}, {16300,0.000000000}, {16400,0.000076190}, {16500,0.000057143}, {16600,0.000000000}, {16700,0.000057143}, {16800,0.000057143}, {16900,0.000038095}, {17000,0.000038095}, {17100,0.000038095}, {17200,0.000000000}, {17300,0.000014286}, {17400,0.000038095}, {17500,0.000076190}, {17600,0.000019048}, {17700,0.000019048}, {17800,0.000000000}, {17900,0.000076190}, {18000,0.000057143}, {18100,0.000019048}, {18200,0.000019048}, {18300,0.000019048}, {18400,0.000057143}, {18500,0.000038095}, {18600,0.000019048}, {18700,0.000019048}, {18800,0.000076190}, {18900,0.000019048}, {19000,0.000038095}, {19100,0.000019048}, {19200,0.000076190}, {19300,0.000095238}, {19400,0.000114286}, {19500,0.000019048}, {19600,0.000076190}, {19700,0.000038095}, {19800,0.000057143}, {19900,0.000095238}, {20000,0.000057692}};
data["big"]["Parametricity; beta"]["post"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000400000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000452381}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.000000000}, {5100,0.000000000}, {5150,0.000000000}, {5200,0.000000000}, {5250,0.000000000}, {5300,0.000000000}, {5350,0.000000000}, {5400,0.000000000}, {5450,0.000000000}, {5500,0.000000000}, {5550,0.000000000}, {5600,0.000000000}, {5650,0.000000000}, {5700,0.000000000}, {5750,0.000000000}, {5800,0.000000000}, {5850,0.000000000}, {5900,0.000000000}, {5950,0.000000000}, {6000,0.000000000}, {6050,0.000000000}, {6100,0.000000000}, {6150,0.000000000}, {6200,0.000000000}, {6250,0.000000000}, {6300,0.000000000}, {6350,0.000000000}, {6400,0.000000000}, {6450,0.000000000}, {6500,0.000000000}, {6550,0.000000000}, {6600,0.000000000}, {6650,0.000000000}, {6700,0.000000000}, {6750,0.000000000}, {6800,0.000000000}, {6850,0.000000000}, {6900,0.000000000}, {6950,0.000000000}, {7000,0.000000000}, {7050,0.000000000}, {7100,0.000000000}, {7150,0.000000000}, {7200,0.000000000}, {7250,0.000000000}, {7300,0.000000000}, {7350,0.000000000}, {7400,0.000000000}, {7450,0.000000000}, {7500,0.000000000}, {7550,0.000000000}, {7600,0.000000000}, {7650,0.000000000}, {7700,0.000000000}, {7750,0.000000000}, {7800,0.000000000}, {7850,0.000000000}, {7900,0.000000000}, {7950,0.000000000}, {8000,0.000000000}, {8050,0.000000000}, {8100,0.000000000}, {8150,0.000000000}, {8200,0.000000000}, {8250,0.000000000}, {8300,0.000000000}, {8350,0.000000000}, {8400,0.000000000}, {8450,0.000000000}, {8500,0.000000000}, {8550,0.000000000}, {8600,0.000000000}, {8650,0.000000000}, {8700,0.000000000}, {8750,0.000000000}, {8800,0.000000000}, {8850,0.000000000}, {8900,0.000000000}, {8950,0.000000000}, {9000,0.000000000}, {9050,0.000000000}, {9100,0.000000000}, {9150,0.000000000}, {9200,0.000000000}, {9250,0.000000000}, {9300,0.000000000}, {9350,0.000000000}, {9400,0.000000000}, {9450,0.000000000}, {9500,0.000000000}, {9550,0.000000000}, {9600,0.000000000}, {9650,0.000000000}, {9700,0.000000000}, {9750,0.000000000}, {9800,0.000000000}, {9850,0.000000000}, {9900,0.000000000}, {9950,0.000000000}, {10000,0.000000000}, {10100,0.000000000}, {10200,0.000000000}, {10300,0.000000000}, {10400,0.000000000}, {10500,0.000000000}, {10600,0.000000000}, {10700,0.000000000}, {10800,0.000000000}, {10900,0.000000000}, {11000,0.000000000}, {11100,0.000000000}, {11200,0.000000000}, {11300,0.000000000}, {11400,0.000000000}, {11500,0.000000000}, {11600,0.000000000}, {11700,0.000000000}, {11800,0.000000000}, {11900,0.000000000}, {12000,0.000000000}, {12100,0.000000000}, {12200,0.000000000}, {12300,0.000000000}, {12400,0.000000000}, {12500,0.000000000}, {12600,0.000000000}, {12700,0.000000000}, {12800,0.000000000}, {12900,0.000000000}, {13000,0.000000000}, {13100,0.000000000}, {13200,0.000000000}, {13300,0.000000000}, {13400,0.000000000}, {13500,0.000000000}, {13600,0.000000000}, {13700,0.000000000}, {13800,0.000000000}, {13900,0.000000000}, {14000,0.000000000}, {14100,0.000000000}, {14200,0.000000000}, {14300,0.000000000}, {14400,0.000000000}, {14500,0.000000000}, {14600,0.000000000}, {14700,0.000000000}, {14800,0.000000000}, {14900,0.000000000}, {15000,0.000000000}, {15100,0.000000000}, {15200,0.000000000}, {15300,0.000000000}, {15400,0.000000000}, {15500,0.000000000}, {15600,0.000000000}, {15700,0.000000000}, {15800,0.000000000}, {15900,0.000000000}, {16000,0.000000000}, {16100,0.000000000}, {16200,0.000000000}, {16300,0.000000000}, {16400,0.000000000}, {16500,0.000000000}, {16600,0.000000000}, {16700,0.000000000}, {16800,0.000000000}, {16900,0.000000000}, {17000,0.000000000}, {17100,0.000000000}, {17200,0.000000000}, {17300,0.000000000}, {17400,0.000000000}, {17500,0.000000000}, {17600,0.000000000}, {17700,0.000000000}, {17800,0.000000000}, {17900,0.000000000}, {18000,0.000000000}, {18100,0.000000000}, {18200,0.000000000}, {18300,0.000000000}, {18400,0.000000000}, {18500,0.000000000}, {18600,0.000000000}, {18700,0.000000000}, {18800,0.000000000}, {18900,0.000000000}, {19000,0.000000000}, {19100,0.000000000}, {19200,0.000000000}, {19300,0.000000000}, {19400,0.000000000}, {19500,0.000000000}, {19600,0.000000000}, {19700,0.000000000}, {19800,0.000000000}, {19900,0.000000000}, {20000,0.000000000}};
data["big"]["Parametricity; beta"]["post"]["user"] = {{1,0.000080569}, {2,0.000014218}, {3,0.000018957}, {4,0.000014218}, {5,0.000000000}, {6,0.000028436}, {7,0.000033175}, {8,0.000014218}, {9,0.000033175}, {10,0.000014218}, {11,0.000018957}, {12,0.000042654}, {13,0.000018957}, {14,0.000033175}, {15,0.000071090}, {16,0.000000000}, {17,0.000014218}, {18,0.000000000}, {19,0.000085308}, {20,0.000037915}, {21,0.000028436}, {22,0.000014218}, {23,0.000018957}, {24,0.000000000}, {25,0.000037915}, {26,0.000018957}, {27,0.000018957}, {28,0.000000000}, {29,0.000018957}, {30,0.000000000}, {31,0.000071090}, {32,0.000000000}, {33,0.000028436}, {34,0.000018957}, {35,0.000018957}, {36,0.000047393}, {37,0.000028436}, {38,0.000018957}, {39,0.000071090}, {40,0.000018957}, {41,0.000018957}, {42,0.000033175}, {43,0.000018957}, {44,0.000018957}, {45,0.000000000}, {46,0.000056872}, {47,0.000014218}, {48,0.000061611}, {49,0.000028436}, {50,0.000000000}, {51,0.000018957}, {52,0.000000000}, {53,0.000000000}, {54,0.000052133}, {55,0.000018957}, {56,0.000014218}, {57,0.000056872}, {58,0.000052133}, {59,0.000037915}, {60,0.000014218}, {61,0.000018957}, {62,0.000037915}, {63,0.000047393}, {64,0.000000000}, {65,0.000037915}, {66,0.000037915}, {67,0.000018957}, {68,0.000000000}, {69,0.000014218}, {70,0.000018957}, {71,0.000018957}, {72,0.000047393}, {73,0.000071090}, {74,0.000033175}, {75,0.000052133}, {76,0.000037915}, {77,0.000071090}, {78,0.000037915}, {79,0.000014218}, {80,0.000090047}, {81,0.000033175}, {82,0.000018957}, {83,0.000014218}, {84,0.000000000}, {85,0.000037915}, {86,0.000014218}, {87,0.000018957}, {88,0.000047393}, {89,0.000014218}, {90,0.000052133}, {91,0.000000000}, {92,0.000000000}, {93,0.000014218}, {94,0.000028436}, {95,0.000000000}, {96,0.000056872}, {97,0.000052133}, {98,0.000033175}, {99,0.000033175}, {100,0.000033175}, {101,0.000018957}, {102,0.000066351}, {103,0.000033175}, {104,0.000018957}, {105,0.000052133}, {106,0.000014218}, {107,0.000037915}, {108,0.000037915}, {109,0.000109005}, {110,0.000047393}, {111,0.000052133}, {112,0.000047393}, {113,0.000033175}, {114,0.000071090}, {115,0.000014218}, {116,0.000000000}, {117,0.000037915}, {118,0.000018957}, {119,0.000014218}, {120,0.000018957}, {121,0.000014218}, {122,0.000033175}, {123,0.000047393}, {124,0.000071090}, {125,0.000000000}, {126,0.000033175}, {127,0.000014218}, {128,0.000000000}, {129,0.000000000}, {130,0.000014218}, {131,0.000033175}, {132,0.000018957}, {133,0.000109005}, {134,0.000056872}, {135,0.000056872}, {136,0.000033175}, {137,0.000037915}, {138,0.000033175}, {139,0.000018957}, {140,0.000033175}, {141,0.000037915}, {142,0.000066351}, {143,0.000085308}, {144,0.000075829}, {145,0.000033175}, {146,0.000033175}, {147,0.000033175}, {148,0.000014218}, {149,0.000056872}, {150,0.000018957}, {151,0.000042654}, {152,0.000056872}, {153,0.000014218}, {154,0.000018957}, {155,0.000037915}, {156,0.000018957}, {157,0.000033175}, {158,0.000033175}, {159,0.000056872}, {160,0.000018957}, {161,0.000037915}, {162,0.000037915}, {163,0.000094787}, {164,0.000047393}, {165,0.000014218}, {166,0.000000000}, {167,0.000033175}, {168,0.000018957}, {169,0.000033175}, {170,0.000085308}, {171,0.000066351}, {172,0.000014218}, {173,0.000018957}, {174,0.000056872}, {175,0.000037915}, {176,0.000018957}, {177,0.000028436}, {178,0.000033175}, {179,0.000056872}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000052133}, {184,0.000028436}, {185,0.000047393}, {186,0.000037915}, {187,0.000000000}, {188,0.000047393}, {189,0.000056872}, {190,0.000018957}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000033175}, {195,0.000014218}, {196,0.000028436}, {197,0.000047393}, {198,0.000037915}, {199,0.000018957}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000018957}, {204,0.000037915}, {205,0.000037915}, {206,0.000037915}, {207,0.000066351}, {208,0.000018957}, {209,0.000028436}, {210,0.000000000}, {211,0.000033175}, {212,0.000037915}, {213,0.000037915}, {214,0.000071090}, {215,0.000000000}, {216,0.000018957}, {217,0.000018957}, {218,0.000047393}, {219,0.000033175}, {220,0.000037915}, {221,0.000028436}, {222,0.000052133}, {223,0.000099526}, {224,0.000018957}, {225,0.000052133}, {226,0.000018957}, {227,0.000000000}, {228,0.000018957}, {229,0.000037915}, {230,0.000033175}, {231,0.000109005}, {232,0.000047393}, {233,0.000028436}, {234,0.000018957}, {235,0.000000000}, {236,0.000000000}, {237,0.000052133}, {238,0.000018957}, {239,0.000056872}, {240,0.000066351}, {241,0.000033175}, {242,0.000052133}, {243,0.000066351}, {244,0.000019048}, {245,0.000038095}, {246,0.000033333}, {247,0.000095238}, {248,0.000033333}, {249,0.000000000}, {250,0.000019048}, {251,0.000014286}, {252,0.000019048}, {253,0.000000000}, {254,0.000019048}, {255,0.000038095}, {256,0.000047619}, {257,0.000033333}, {258,0.000019048}, {259,0.000380952}, {260,0.000000000}, {261,0.000057143}, {262,0.000066667}, {263,0.000038095}, {264,0.000047619}, {265,0.000066667}, {266,0.000014286}, {267,0.000061905}, {268,0.000038095}, {269,0.000019048}, {270,0.000019048}, {271,0.000033333}, {272,0.000019048}, {273,0.000019048}, {274,0.000066667}, {275,0.000014286}, {276,0.000052381}, {277,0.000019048}, {278,0.000038095}, {279,0.000019048}, {280,0.000014286}, {281,0.000014286}, {282,0.000019048}, {283,0.000019048}, {284,0.000019048}, {285,0.000052381}, {286,0.000095238}, {287,0.000033333}, {288,0.000047619}, {289,0.000019048}, {290,0.000033333}, {291,0.000047619}, {292,0.000000000}, {293,0.000000000}, {294,0.000019048}, {295,0.000019048}, {296,0.000057143}, {297,0.000014286}, {298,0.000038095}, {299,0.000066667}, {300,0.000028571}, {301,0.000090476}, {302,0.000014286}, {303,0.000100000}, {304,0.000033333}, {305,0.000000000}, {306,0.000033333}, {307,0.000019048}, {308,0.000033333}, {309,0.000019048}, {310,0.000057143}, {311,0.000038095}, {312,0.000085714}, {313,0.000038095}, {314,0.000038095}, {315,0.000033333}, {316,0.000014286}, {317,0.000038095}, {318,0.000019048}, {319,0.000033333}, {320,0.000014286}, {321,0.000052381}, {322,0.000038095}, {323,0.000066667}, {324,0.000038095}, {325,0.000033333}, {326,0.000057143}, {327,0.000033333}, {328,0.000038095}, {329,0.000038095}, {330,0.000000000}, {331,0.000019048}, {332,0.000028571}, {333,0.000033333}, {334,0.000057143}, {335,0.000052381}, {336,0.000000000}, {337,0.000019048}, {338,0.000000000}, {339,0.000057143}, {340,0.000066667}, {341,0.000028571}, {342,0.000038095}, {343,0.000038095}, {344,0.000014286}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000019048}, {349,0.000038095}, {350,0.000000000}, {351,0.000071429}, {352,0.000000000}, {353,0.000057143}, {354,0.000000000}, {355,0.000047619}, {356,0.000014286}, {357,0.000028571}, {358,0.000014286}, {359,0.000028571}, {360,0.000019048}, {361,0.000038095}, {362,0.000033333}, {363,0.000047619}, {364,0.000090476}, {365,0.000104762}, {366,0.000052381}, {367,0.000071429}, {368,0.000000000}, {369,0.000000000}, {370,0.000047619}, {371,0.000014286}, {372,0.000052381}, {373,0.000019048}, {374,0.000114286}, {375,0.000061905}, {376,0.000019048}, {377,0.000014286}, {378,0.000038095}, {379,0.000000000}, {380,0.000052381}, {381,0.000038095}, {382,0.000000000}, {383,0.000085714}, {384,0.000038095}, {385,0.000019048}, {386,0.000000000}, {387,0.000014286}, {388,0.000038095}, {389,0.000038095}, {390,0.000076190}, {391,0.000019048}, {392,0.000000000}, {393,0.000019048}, {394,0.000033333}, {395,0.000019048}, {396,0.000052381}, {397,0.000014286}, {398,0.000076190}, {399,0.000038095}, {400,0.000019048}, {401,0.000071429}, {402,0.000033333}, {403,0.000019048}, {404,0.000038095}, {405,0.000019048}, {406,0.000061905}, {407,0.000019048}, {408,0.000047619}, {409,0.000000000}, {410,0.000066667}, {411,0.000033333}, {412,0.000019048}, {413,0.000028571}, {414,0.000076190}, {415,0.000019048}, {416,0.000038095}, {417,0.000033333}, {418,0.000000000}, {419,0.000071429}, {420,0.000000000}, {421,0.000000000}, {422,0.000057143}, {423,0.000019048}, {424,0.000000000}, {425,0.000071429}, {426,0.000019048}, {427,0.000033333}, {428,0.000057143}, {429,0.000014286}, {430,0.000076190}, {431,0.000038095}, {432,0.000033333}, {433,0.000019048}, {434,0.000014286}, {435,0.000033333}, {436,0.000019048}, {437,0.000066667}, {438,0.000019048}, {439,0.000028571}, {440,0.000000000}, {441,0.000000000}, {442,0.000019048}, {443,0.000071429}, {444,0.000000000}, {445,0.000047619}, {446,0.000057143}, {447,0.000019048}, {448,0.000057143}, {449,0.000019048}, {450,0.000019048}, {451,0.000000000}, {452,0.000019048}, {453,0.000014286}, {454,0.000014286}, {455,0.000019048}, {456,0.000000000}, {457,0.000071429}, {458,0.000000000}, {459,0.000019048}, {460,0.000019048}, {461,0.000028571}, {462,0.000028571}, {463,0.000019048}, {464,0.000038095}, {465,0.000047619}, {466,0.000000000}, {467,0.000014286}, {468,0.000000000}, {469,0.000028571}, {470,0.000095238}, {471,0.000071429}, {472,0.000000000}, {473,0.000033333}, {474,0.000019048}, {475,0.000128571}, {476,0.000019048}, {477,0.000014286}, {478,0.000000000}, {479,0.000038095}, {480,0.000066667}, {481,0.000000000}, {482,0.000033333}, {483,0.000028571}, {484,0.000052381}, {485,0.000052381}, {486,0.000014286}, {487,0.000028571}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000052381}, {492,0.000076190}, {493,0.000000000}, {494,0.000076190}, {495,0.000019048}, {496,0.000085714}, {497,0.000057143}, {498,0.000019048}, {499,0.000057143}, {500,0.000042857}, {505,0.000052381}, {510,0.000071429}, {515,0.000057143}, {520,0.000566667}, {525,0.000047619}, {530,0.000000000}, {535,0.000019048}, {540,0.000052381}, {545,0.000076190}, {550,0.000014286}, {555,0.000014286}, {560,0.000052381}, {565,0.000000000}, {570,0.000095238}, {575,0.000066667}, {580,0.000014286}, {585,0.000014286}, {590,0.000014286}, {595,0.000038095}, {600,0.000052381}, {605,0.000014286}, {610,0.000047619}, {615,0.000038095}, {620,0.000071429}, {625,0.000057143}, {630,0.000000000}, {635,0.000014286}, {640,0.000061905}, {645,0.000000000}, {650,0.000071429}, {655,0.000000000}, {660,0.000000000}, {665,0.000019048}, {670,0.000014286}, {675,0.000057143}, {680,0.000038095}, {685,0.000033333}, {690,0.000000000}, {695,0.000038095}, {700,0.000033333}, {705,0.000014286}, {710,0.000014286}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000052381}, {735,0.000014286}, {740,0.000000000}, {745,0.000052381}, {750,0.000019048}, {755,0.000080952}, {760,0.000000000}, {765,0.000038095}, {770,0.000057143}, {775,0.000047619}, {780,0.000019048}, {785,0.000000000}, {790,0.000033333}, {795,0.000014286}, {800,0.000019048}, {805,0.000071429}, {810,0.000038095}, {815,0.000033333}, {820,0.000071429}, {825,0.000000000}, {830,0.000038095}, {835,0.000019048}, {840,0.000000000}, {845,0.000000000}, {850,0.000047619}, {855,0.000019048}, {860,0.000052381}, {865,0.000019048}, {870,0.000052381}, {875,0.000019048}, {880,0.000000000}, {885,0.000057143}, {890,0.000000000}, {895,0.000038095}, {900,0.000038095}, {905,0.000014286}, {910,0.000019048}, {915,0.000033333}, {920,0.000019048}, {925,0.000000000}, {930,0.000076190}, {935,0.000019048}, {940,0.000047619}, {945,0.000028571}, {950,0.000057143}, {955,0.000052381}, {960,0.000033333}, {965,0.000080952}, {970,0.000014286}, {975,0.000019048}, {980,0.000071429}, {985,0.000019048}, {990,0.000028571}, {995,0.000033333}, {1000,0.000014286}, {1010,0.000014286}, {1020,0.000000000}, {1030,0.000066667}, {1040,0.000042857}, {1050,0.000057143}, {1060,0.000057143}, {1070,0.000042857}, {1080,0.000033333}, {1090,0.000038095}, {1100,0.000071429}, {1110,0.000052381}, {1120,0.000019048}, {1130,0.000038095}, {1140,0.000019048}, {1150,0.000019048}, {1160,0.000019048}, {1170,0.000019048}, {1180,0.000057143}, {1190,0.000057143}, {1200,0.000000000}, {1210,0.000038095}, {1220,0.000014286}, {1230,0.000019048}, {1240,0.000019048}, {1250,0.000019048}, {1260,0.000042857}, {1270,0.000057143}, {1280,0.000033333}, {1290,0.000000000}, {1300,0.000033333}, {1310,0.000033333}, {1320,0.000038095}, {1330,0.000019048}, {1340,0.000019048}, {1350,0.000019048}, {1360,0.000019048}, {1370,0.000000000}, {1380,0.000057143}, {1390,0.000052381}, {1400,0.000019048}, {1410,0.000014286}, {1420,0.000019048}, {1430,0.000014286}, {1440,0.000038095}, {1450,0.000057143}, {1460,0.000061905}, {1470,0.000038095}, {1480,0.000019048}, {1490,0.000019048}, {1500,0.000000000}, {1510,0.000014286}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000033333}, {1550,0.000047619}, {1560,0.000057143}, {1570,0.000019048}, {1580,0.000014286}, {1590,0.000057143}, {1600,0.000061905}, {1610,0.000019048}, {1620,0.000000000}, {1630,0.000019048}, {1640,0.000014286}, {1650,0.000033333}, {1660,0.000042857}, {1670,0.000038095}, {1680,0.000000000}, {1690,0.000052381}, {1700,0.000019048}, {1710,0.000033333}, {1720,0.000033333}, {1730,0.000033333}, {1740,0.000033333}, {1750,0.000071429}, {1760,0.000071429}, {1770,0.000019048}, {1780,0.000000000}, {1790,0.000033333}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000057143}, {1830,0.000071429}, {1840,0.000038095}, {1850,0.000000000}, {1860,0.000033333}, {1870,0.000019048}, {1880,0.000028571}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000033333}, {1920,0.000038095}, {1930,0.000038095}, {1940,0.000038095}, {1950,0.000042857}, {1960,0.000071429}, {1970,0.000033333}, {1980,0.000019048}, {1990,0.000095238}, {2000,0.000038095}, {2050,0.000000000}, {2100,0.000019048}, {2150,0.000038095}, {2200,0.000000000}, {2250,0.000038095}, {2300,0.000071429}, {2350,0.000052381}, {2400,0.000000000}, {2450,0.000019048}, {2500,0.000038095}, {2550,0.000071429}, {2600,0.000014286}, {2650,0.000019048}, {2700,0.000000000}, {2750,0.000071429}, {2800,0.000071429}, {2850,0.000000000}, {2900,0.000028571}, {2950,0.000000000}, {3000,0.000019048}, {3050,0.000033333}, {3100,0.000019048}, {3150,0.000000000}, {3200,0.000019048}, {3250,0.000033333}, {3300,0.000052381}, {3350,0.000033333}, {3400,0.000033333}, {3450,0.000033333}, {3500,0.000071429}, {3550,0.000014286}, {3600,0.000019048}, {3650,0.000047619}, {3700,0.000014286}, {3750,0.000033333}, {3800,0.000038095}, {3850,0.000052381}, {3900,0.000038095}, {3950,0.000061905}, {4000,0.000014286}, {4050,0.000014286}, {4100,0.000038095}, {4150,0.000000000}, {4200,0.000019048}, {4250,0.000000000}, {4300,0.000090476}, {4350,0.000052381}, {4400,0.000038095}, {4450,0.000061905}, {4500,0.000033333}, {4550,0.000057143}, {4600,0.000071429}, {4650,0.000033333}, {4700,0.000052381}, {4750,0.000033333}, {4800,0.000042857}, {4850,0.000057143}, {4900,0.000000000}, {4950,0.000019048}, {5000,0.000071429}, {5050,0.000014286}, {5100,0.000038095}, {5150,0.000000000}, {5200,0.000066667}, {5250,0.000076190}, {5300,0.000071429}, {5350,0.000052381}, {5400,0.000014286}, {5450,0.000038095}, {5500,0.000042857}, {5550,0.000019048}, {5600,0.000042857}, {5650,0.000000000}, {5700,0.000033333}, {5750,0.000038095}, {5800,0.000000000}, {5850,0.000019048}, {5900,0.000000000}, {5950,0.000052381}, {6000,0.000014286}, {6050,0.000076190}, {6100,0.000071429}, {6150,0.000028571}, {6200,0.000061905}, {6250,0.000000000}, {6300,0.000028571}, {6350,0.000019048}, {6400,0.000019048}, {6450,0.000014286}, {6500,0.000019048}, {6550,0.000052381}, {6600,0.000042857}, {6650,0.000104762}, {6700,0.000061905}, {6750,0.000109524}, {6800,0.000019048}, {6850,0.000014286}, {6900,0.000052381}, {6950,0.000019048}, {7000,0.000000000}, {7050,0.000038095}, {7100,0.000052381}, {7150,0.000057143}, {7200,0.000019048}, {7250,0.000066667}, {7300,0.000019048}, {7350,0.000019048}, {7400,0.000033333}, {7450,0.000095238}, {7500,0.000019048}, {7550,0.000095238}, {7600,0.000057143}, {7650,0.000014286}, {7700,0.000000000}, {7750,0.000061905}, {7800,0.000033333}, {7850,0.000000000}, {7900,0.000076190}, {7950,0.000014286}, {8000,0.000014286}, {8050,0.000000000}, {8100,0.000014286}, {8150,0.000047619}, {8200,0.000014286}, {8250,0.000052381}, {8300,0.000019048}, {8350,0.000057143}, {8400,0.000076190}, {8450,0.000033333}, {8500,0.000019048}, {8550,0.000038095}, {8600,0.000052381}, {8650,0.000052381}, {8700,0.000090476}, {8750,0.000071429}, {8800,0.000042857}, {8850,0.000014286}, {8900,0.000047619}, {8950,0.000014286}, {9000,0.000019048}, {9050,0.000019048}, {9100,0.000038095}, {9150,0.000057143}, {9200,0.000028571}, {9250,0.000119048}, {9300,0.000057143}, {9350,0.000019048}, {9400,0.000033333}, {9450,0.000100000}, {9500,0.000052381}, {9550,0.000019048}, {9600,0.000019048}, {9650,0.000038095}, {9700,0.000033333}, {9750,0.000014286}, {9800,0.000052381}, {9850,0.000014286}, {9900,0.000080952}, {9950,0.000076190}, {10000,0.000038095}, {10100,0.000014286}, {10200,0.000019048}, {10300,0.000028571}, {10400,0.000047619}, {10500,0.000052381}, {10600,0.000047619}, {10700,0.000028571}, {10800,0.000085714}, {10900,0.000071429}, {11000,0.000028571}, {11100,0.000033333}, {11200,0.000000000}, {11300,0.000038095}, {11400,0.000066667}, {11500,0.000033333}, {11600,0.000014286}, {11700,0.000033333}, {11800,0.000033333}, {11900,0.000052381}, {12000,0.000028571}, {12100,0.000042857}, {12200,0.000033333}, {12300,0.000000000}, {12400,0.000028571}, {12500,0.000000000}, {12600,0.000019048}, {12700,0.000052381}, {12800,0.000019048}, {12900,0.000047619}, {13000,0.000014286}, {13100,0.000042857}, {13200,0.000014286}, {13300,0.000000000}, {13400,0.000028571}, {13500,0.000119048}, {13600,0.000066667}, {13700,0.000019048}, {13800,0.000047619}, {13900,0.000033333}, {14000,0.000052381}, {14100,0.000052381}, {14200,0.000019048}, {14300,0.000095238}, {14400,0.000090476}, {14500,0.000014286}, {14600,0.000057143}, {14700,0.000000000}, {14800,0.000066667}, {14900,0.000028571}, {15000,0.000066667}, {15100,0.000028571}, {15200,0.000019048}, {15300,0.000028571}, {15400,0.000033333}, {15500,0.000095238}, {15600,0.000047619}, {15700,0.000042857}, {15800,0.000014286}, {15900,0.000028571}, {16000,0.000028571}, {16100,0.000047619}, {16200,0.000028571}, {16300,0.000076190}, {16400,0.000033333}, {16500,0.000028571}, {16600,0.000014286}, {16700,0.000014286}, {16800,0.000047619}, {16900,0.000066667}, {17000,0.000071429}, {17100,0.000042857}, {17200,0.000071429}, {17300,0.000066667}, {17400,0.000109524}, {17500,0.000047619}, {17600,0.000061905}, {17700,0.000033333}, {17800,0.000000000}, {17900,0.000038095}, {18000,0.000028571}, {18100,0.000047619}, {18200,0.000019048}, {18300,0.000114286}, {18400,0.000076190}, {18500,0.000014286}, {18600,0.000066667}, {18700,0.000028571}, {18800,0.000019048}, {18900,0.000057143}, {19000,0.000071429}, {19100,0.000080952}, {19200,0.000019048}, {19300,0.000028571}, {19400,0.000019048}, {19500,0.000080952}, {19600,0.000047619}, {19700,0.000080952}, {19800,0.000076190}, {19900,0.000047619}, {20000,0.000067308}};
data["big"]["Parametricity; beta"]["post"]["system"] = {{1,0.000018957}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000018957}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000018957}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000018957}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000018957}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000018957}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000019048}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000019048}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000019048}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000019048}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000019048}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000019048}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000019048}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000019048}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000019048}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000019048}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000019048}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000019048}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000019048}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000019048}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000014286}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.000000000}, {5100,0.000000000}, {5150,0.000000000}, {5200,0.000000000}, {5250,0.000000000}, {5300,0.000000000}, {5350,0.000000000}, {5400,0.000000000}, {5450,0.000000000}, {5500,0.000000000}, {5550,0.000000000}, {5600,0.000000000}, {5650,0.000000000}, {5700,0.000000000}, {5750,0.000000000}, {5800,0.000000000}, {5850,0.000000000}, {5900,0.000000000}, {5950,0.000000000}, {6000,0.000000000}, {6050,0.000000000}, {6100,0.000000000}, {6150,0.000000000}, {6200,0.000000000}, {6250,0.000000000}, {6300,0.000000000}, {6350,0.000000000}, {6400,0.000000000}, {6450,0.000000000}, {6500,0.000000000}, {6550,0.000000000}, {6600,0.000000000}, {6650,0.000000000}, {6700,0.000000000}, {6750,0.000000000}, {6800,0.000000000}, {6850,0.000000000}, {6900,0.000000000}, {6950,0.000000000}, {7000,0.000000000}, {7050,0.000000000}, {7100,0.000000000}, {7150,0.000000000}, {7200,0.000000000}, {7250,0.000000000}, {7300,0.000000000}, {7350,0.000000000}, {7400,0.000000000}, {7450,0.000000000}, {7500,0.000000000}, {7550,0.000000000}, {7600,0.000000000}, {7650,0.000019048}, {7700,0.000000000}, {7750,0.000000000}, {7800,0.000000000}, {7850,0.000000000}, {7900,0.000000000}, {7950,0.000000000}, {8000,0.000000000}, {8050,0.000000000}, {8100,0.000000000}, {8150,0.000000000}, {8200,0.000000000}, {8250,0.000000000}, {8300,0.000000000}, {8350,0.000000000}, {8400,0.000000000}, {8450,0.000000000}, {8500,0.000000000}, {8550,0.000000000}, {8600,0.000000000}, {8650,0.000000000}, {8700,0.000000000}, {8750,0.000000000}, {8800,0.000000000}, {8850,0.000000000}, {8900,0.000000000}, {8950,0.000000000}, {9000,0.000000000}, {9050,0.000000000}, {9100,0.000019048}, {9150,0.000000000}, {9200,0.000000000}, {9250,0.000000000}, {9300,0.000000000}, {9350,0.000000000}, {9400,0.000000000}, {9450,0.000000000}, {9500,0.000000000}, {9550,0.000000000}, {9600,0.000000000}, {9650,0.000000000}, {9700,0.000000000}, {9750,0.000000000}, {9800,0.000000000}, {9850,0.000000000}, {9900,0.000000000}, {9950,0.000000000}, {10000,0.000000000}, {10100,0.000000000}, {10200,0.000000000}, {10300,0.000000000}, {10400,0.000000000}, {10500,0.000000000}, {10600,0.000000000}, {10700,0.000000000}, {10800,0.000019048}, {10900,0.000000000}, {11000,0.000000000}, {11100,0.000000000}, {11200,0.000000000}, {11300,0.000000000}, {11400,0.000000000}, {11500,0.000000000}, {11600,0.000000000}, {11700,0.000000000}, {11800,0.000000000}, {11900,0.000000000}, {12000,0.000000000}, {12100,0.000000000}, {12200,0.000000000}, {12300,0.000000000}, {12400,0.000000000}, {12500,0.000000000}, {12600,0.000019048}, {12700,0.000000000}, {12800,0.000000000}, {12900,0.000000000}, {13000,0.000000000}, {13100,0.000000000}, {13200,0.000000000}, {13300,0.000000000}, {13400,0.000000000}, {13500,0.000000000}, {13600,0.000000000}, {13700,0.000000000}, {13800,0.000000000}, {13900,0.000000000}, {14000,0.000000000}, {14100,0.000000000}, {14200,0.000000000}, {14300,0.000014286}, {14400,0.000000000}, {14500,0.000000000}, {14600,0.000000000}, {14700,0.000000000}, {14800,0.000000000}, {14900,0.000000000}, {15000,0.000000000}, {15100,0.000000000}, {15200,0.000000000}, {15300,0.000000000}, {15400,0.000000000}, {15500,0.000000000}, {15600,0.000000000}, {15700,0.000000000}, {15800,0.000000000}, {15900,0.000000000}, {16000,0.000000000}, {16100,0.000000000}, {16200,0.000000000}, {16300,0.000000000}, {16400,0.000000000}, {16500,0.000000000}, {16600,0.000000000}, {16700,0.000000000}, {16800,0.000000000}, {16900,0.000000000}, {17000,0.000000000}, {17100,0.000000000}, {17200,0.000000000}, {17300,0.000000000}, {17400,0.000000000}, {17500,0.000000000}, {17600,0.000000000}, {17700,0.000019048}, {17800,0.000000000}, {17900,0.000000000}, {18000,0.000000000}, {18100,0.000000000}, {18200,0.000000000}, {18300,0.000000000}, {18400,0.000000000}, {18500,0.000000000}, {18600,0.000000000}, {18700,0.000000000}, {18800,0.000000000}, {18900,0.000000000}, {19000,0.000000000}, {19100,0.000000000}, {19200,0.000000000}, {19300,0.000000000}, {19400,0.000000000}, {19500,0.000000000}, {19600,0.000000000}, {19700,0.000000000}, {19800,0.000000000}, {19900,0.000000000}, {20000,0.000000000}};
data["big"]["Parametricity; beta"]["pre"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.000000000}, {5100,0.000000000}, {5150,0.000000000}, {5200,0.000000000}, {5250,0.000000000}, {5300,0.000000000}, {5350,0.000000000}, {5400,0.000000000}, {5450,0.000000000}, {5500,0.000000000}, {5550,0.000000000}, {5600,0.000000000}, {5650,0.000000000}, {5700,0.000000000}, {5750,0.000000000}, {5800,0.000000000}, {5850,0.000000000}, {5900,0.000000000}, {5950,0.000000000}, {6000,0.000000000}, {6050,0.000000000}, {6100,0.000000000}, {6150,0.000000000}, {6200,0.000000000}, {6250,0.000000000}, {6300,0.000000000}, {6350,0.000000000}, {6400,0.000000000}, {6450,0.000000000}, {6500,0.000000000}, {6550,0.000000000}, {6600,0.000000000}, {6650,0.000000000}, {6700,0.000000000}, {6750,0.000000000}, {6800,0.000000000}, {6850,0.000000000}, {6900,0.000000000}, {6950,0.000000000}, {7000,0.000000000}, {7050,0.000000000}, {7100,0.000000000}, {7150,0.000000000}, {7200,0.000000000}, {7250,0.000000000}, {7300,0.000000000}, {7350,0.000000000}, {7400,0.000000000}, {7450,0.000000000}, {7500,0.000000000}, {7550,0.000000000}, {7600,0.000000000}, {7650,0.000000000}, {7700,0.000000000}, {7750,0.000000000}, {7800,0.000000000}, {7850,0.000000000}, {7900,0.000000000}, {7950,0.000000000}, {8000,0.000000000}, {8050,0.000000000}, {8100,0.000000000}, {8150,0.000000000}, {8200,0.000000000}, {8250,0.000000000}, {8300,0.000000000}, {8350,0.000000000}, {8400,0.000000000}, {8450,0.000000000}, {8500,0.000000000}, {8550,0.000000000}, {8600,0.000000000}, {8650,0.000000000}, {8700,0.000000000}, {8750,0.000000000}, {8800,0.000000000}, {8850,0.000000000}, {8900,0.000000000}, {8950,0.000000000}, {9000,0.000000000}, {9050,0.000000000}, {9100,0.000000000}, {9150,0.000000000}, {9200,0.000000000}, {9250,0.000000000}, {9300,0.000000000}, {9350,0.000000000}, {9400,0.000000000}, {9450,0.000000000}, {9500,0.000000000}, {9550,0.000000000}, {9600,0.000000000}, {9650,0.000000000}, {9700,0.000000000}, {9750,0.000000000}, {9800,0.000000000}, {9850,0.000000000}, {9900,0.000000000}, {9950,0.000000000}, {10000,0.000000000}, {10100,0.000000000}, {10200,0.000000000}, {10300,0.000000000}, {10400,0.000000000}, {10500,0.000000000}, {10600,0.000000000}, {10700,0.000000000}, {10800,0.000000000}, {10900,0.000000000}, {11000,0.000000000}, {11100,0.000000000}, {11200,0.000000000}, {11300,0.000000000}, {11400,0.000000000}, {11500,0.000000000}, {11600,0.000000000}, {11700,0.000000000}, {11800,0.000000000}, {11900,0.000000000}, {12000,0.000000000}, {12100,0.000000000}, {12200,0.000000000}, {12300,0.000000000}, {12400,0.000000000}, {12500,0.000000000}, {12600,0.000000000}, {12700,0.000000000}, {12800,0.000000000}, {12900,0.000000000}, {13000,0.000000000}, {13100,0.000000000}, {13200,0.000000000}, {13300,0.000000000}, {13400,0.000000000}, {13500,0.000000000}, {13600,0.000000000}, {13700,0.000000000}, {13800,0.000000000}, {13900,0.000000000}, {14000,0.000000000}, {14100,0.000000000}, {14200,0.000000000}, {14300,0.000000000}, {14400,0.000000000}, {14500,0.000000000}, {14600,0.000000000}, {14700,0.000000000}, {14800,0.000000000}, {14900,0.000000000}, {15000,0.000000000}, {15100,0.000000000}, {15200,0.000000000}, {15300,0.000000000}, {15400,0.000000000}, {15500,0.000000000}, {15600,0.000000000}, {15700,0.000000000}, {15800,0.000000000}, {15900,0.000000000}, {16000,0.000000000}, {16100,0.000000000}, {16200,0.000000000}, {16300,0.000000000}, {16400,0.000000000}, {16500,0.000000000}, {16600,0.000000000}, {16700,0.000000000}, {16800,0.000000000}, {16900,0.000000000}, {17000,0.000000000}, {17100,0.000000000}, {17200,0.000000000}, {17300,0.000000000}, {17400,0.000000000}, {17500,0.000000000}, {17600,0.000000000}, {17700,0.000000000}, {17800,0.000000000}, {17900,0.000000000}, {18000,0.000000000}, {18100,0.000000000}, {18200,0.000000000}, {18300,0.000000000}, {18400,0.000000000}, {18500,0.000000000}, {18600,0.000000000}, {18700,0.000000000}, {18800,0.000000000}, {18900,0.000000000}, {19000,0.000000000}, {19100,0.000000000}, {19200,0.000000000}, {19300,0.000000000}, {19400,0.000000000}, {19500,0.000000000}, {19600,0.000000000}, {19700,0.000000000}, {19800,0.000000000}, {19900,0.000000000}, {20000,0.000000000}};
data["big"]["Parametricity; beta"]["pre"]["user"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000014218}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000018957}, {9,0.000000000}, {10,0.000000000}, {11,0.000018957}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000014218}, {16,0.000018957}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000018957}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000018957}, {28,0.000014218}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000018957}, {34,0.000018957}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000014218}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000018957}, {57,0.000018957}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000014218}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000018957}, {75,0.000028436}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000018957}, {83,0.000000000}, {84,0.000000000}, {85,0.000014218}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000018957}, {90,0.000014218}, {91,0.000033175}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000014218}, {108,0.000000000}, {109,0.000000000}, {110,0.000018957}, {111,0.000028436}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000014218}, {117,0.000000000}, {118,0.000018957}, {119,0.000000000}, {120,0.000018957}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000014218}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000014218}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000018957}, {140,0.000018957}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000037915}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000014218}, {150,0.000018957}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000056872}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000018957}, {165,0.000000000}, {166,0.000037915}, {167,0.000000000}, {168,0.000014218}, {169,0.000000000}, {170,0.000000000}, {171,0.000014218}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000018957}, {179,0.000014218}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000014218}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000018957}, {190,0.000000000}, {191,0.000000000}, {192,0.000014218}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000018957}, {202,0.000018957}, {203,0.000000000}, {204,0.000000000}, {205,0.000018957}, {206,0.000018957}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000018957}, {211,0.000000000}, {212,0.000000000}, {213,0.000033175}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000018957}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000018957}, {234,0.000014218}, {235,0.000018957}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000037915}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000014286}, {245,0.000014286}, {246,0.000000000}, {247,0.000019048}, {248,0.000042857}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000019048}, {253,0.000000000}, {254,0.000019048}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000014286}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000014286}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000038095}, {270,0.000000000}, {271,0.000019048}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000038095}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000019048}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000019048}, {284,0.000019048}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000014286}, {290,0.000019048}, {291,0.000000000}, {292,0.000000000}, {293,0.000014286}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000019048}, {299,0.000014286}, {300,0.000019048}, {301,0.000019048}, {302,0.000000000}, {303,0.000000000}, {304,0.000014286}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000014286}, {314,0.000019048}, {315,0.000000000}, {316,0.000014286}, {317,0.000000000}, {318,0.000000000}, {319,0.000038095}, {320,0.000000000}, {321,0.000019048}, {322,0.000000000}, {323,0.000000000}, {324,0.000019048}, {325,0.000000000}, {326,0.000000000}, {327,0.000047619}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000014286}, {332,0.000000000}, {333,0.000000000}, {334,0.000019048}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000014286}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000014286}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000019048}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000014286}, {355,0.000000000}, {356,0.000000000}, {357,0.000019048}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000019048}, {363,0.000000000}, {364,0.000019048}, {365,0.000000000}, {366,0.000000000}, {367,0.000019048}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000019048}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000019048}, {387,0.000000000}, {388,0.000033333}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000019048}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000019048}, {401,0.000000000}, {402,0.000014286}, {403,0.000000000}, {404,0.000000000}, {405,0.000014286}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000019048}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000014286}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000019048}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000038095}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000019048}, {445,0.000000000}, {446,0.000019048}, {447,0.000014286}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000038095}, {452,0.000019048}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000019048}, {457,0.000019048}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000033333}, {465,0.000000000}, {466,0.000000000}, {467,0.000038095}, {468,0.000000000}, {469,0.000019048}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000019048}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000019048}, {488,0.000014286}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000019048}, {495,0.000019048}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000038095}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000019048}, {535,0.000000000}, {540,0.000000000}, {545,0.000019048}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000014286}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000014286}, {605,0.000000000}, {610,0.000000000}, {615,0.000019048}, {620,0.000019048}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000033333}, {645,0.000000000}, {650,0.000019048}, {655,0.000019048}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000014286}, {725,0.000019048}, {730,0.000000000}, {735,0.000000000}, {740,0.000019048}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000014286}, {785,0.000000000}, {790,0.000014286}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000038095}, {865,0.000014286}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000019048}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000019048}, {925,0.000000000}, {930,0.000000000}, {935,0.000019048}, {940,0.000000000}, {945,0.000000000}, {950,0.000033333}, {955,0.000014286}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000014286}, {995,0.000019048}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000019048}, {1030,0.000019048}, {1040,0.000014286}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000019048}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000019048}, {1120,0.000000000}, {1130,0.000014286}, {1140,0.000052381}, {1150,0.000014286}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000019048}, {1200,0.000000000}, {1210,0.000019048}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000019048}, {1250,0.000000000}, {1260,0.000019048}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000014286}, {1300,0.000000000}, {1310,0.000019048}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000033333}, {1370,0.000014286}, {1380,0.000014286}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000019048}, {1510,0.000000000}, {1520,0.000033333}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000019048}, {1580,0.000019048}, {1590,0.000000000}, {1600,0.000019048}, {1610,0.000014286}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000014286}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000014286}, {1720,0.000033333}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000028571}, {1760,0.000000000}, {1770,0.000033333}, {1780,0.000038095}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000019048}, {1820,0.000000000}, {1830,0.000019048}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000019048}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000019048}, {2150,0.000019048}, {2200,0.000000000}, {2250,0.000019048}, {2300,0.000000000}, {2350,0.000019048}, {2400,0.000014286}, {2450,0.000019048}, {2500,0.000014286}, {2550,0.000019048}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000019048}, {2850,0.000033333}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000019048}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000019048}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000019048}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000019048}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000019048}, {4100,0.000014286}, {4150,0.000000000}, {4200,0.000014286}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000014286}, {4500,0.000000000}, {4550,0.000019048}, {4600,0.000033333}, {4650,0.000038095}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000019048}, {4900,0.000000000}, {4950,0.000019048}, {5000,0.000000000}, {5050,0.000000000}, {5100,0.000000000}, {5150,0.000000000}, {5200,0.000000000}, {5250,0.000000000}, {5300,0.000000000}, {5350,0.000000000}, {5400,0.000000000}, {5450,0.000000000}, {5500,0.000000000}, {5550,0.000019048}, {5600,0.000000000}, {5650,0.000000000}, {5700,0.000014286}, {5750,0.000014286}, {5800,0.000000000}, {5850,0.000000000}, {5900,0.000000000}, {5950,0.000000000}, {6000,0.000014286}, {6050,0.000000000}, {6100,0.000019048}, {6150,0.000014286}, {6200,0.000000000}, {6250,0.000000000}, {6300,0.000000000}, {6350,0.000014286}, {6400,0.000000000}, {6450,0.000000000}, {6500,0.000000000}, {6550,0.000000000}, {6600,0.000019048}, {6650,0.000000000}, {6700,0.000000000}, {6750,0.000033333}, {6800,0.000000000}, {6850,0.000028571}, {6900,0.000033333}, {6950,0.000014286}, {7000,0.000000000}, {7050,0.000000000}, {7100,0.000000000}, {7150,0.000000000}, {7200,0.000014286}, {7250,0.000000000}, {7300,0.000014286}, {7350,0.000000000}, {7400,0.000000000}, {7450,0.000014286}, {7500,0.000000000}, {7550,0.000019048}, {7600,0.000019048}, {7650,0.000000000}, {7700,0.000019048}, {7750,0.000000000}, {7800,0.000000000}, {7850,0.000000000}, {7900,0.000019048}, {7950,0.000038095}, {8000,0.000000000}, {8050,0.000019048}, {8100,0.000014286}, {8150,0.000033333}, {8200,0.000014286}, {8250,0.000000000}, {8300,0.000000000}, {8350,0.000000000}, {8400,0.000000000}, {8450,0.000000000}, {8500,0.000019048}, {8550,0.000000000}, {8600,0.000000000}, {8650,0.000000000}, {8700,0.000019048}, {8750,0.000000000}, {8800,0.000000000}, {8850,0.000019048}, {8900,0.000019048}, {8950,0.000038095}, {9000,0.000028571}, {9050,0.000000000}, {9100,0.000033333}, {9150,0.000014286}, {9200,0.000000000}, {9250,0.000000000}, {9300,0.000000000}, {9350,0.000000000}, {9400,0.000000000}, {9450,0.000014286}, {9500,0.000000000}, {9550,0.000000000}, {9600,0.000000000}, {9650,0.000000000}, {9700,0.000000000}, {9750,0.000052381}, {9800,0.000000000}, {9850,0.000000000}, {9900,0.000000000}, {9950,0.000000000}, {10000,0.000014286}, {10100,0.000019048}, {10200,0.000000000}, {10300,0.000033333}, {10400,0.000000000}, {10500,0.000000000}, {10600,0.000000000}, {10700,0.000000000}, {10800,0.000019048}, {10900,0.000014286}, {11000,0.000000000}, {11100,0.000000000}, {11200,0.000014286}, {11300,0.000000000}, {11400,0.000000000}, {11500,0.000000000}, {11600,0.000000000}, {11700,0.000019048}, {11800,0.000014286}, {11900,0.000000000}, {12000,0.000000000}, {12100,0.000014286}, {12200,0.000000000}, {12300,0.000000000}, {12400,0.000000000}, {12500,0.000000000}, {12600,0.000000000}, {12700,0.000000000}, {12800,0.000000000}, {12900,0.000014286}, {13000,0.000000000}, {13100,0.000000000}, {13200,0.000000000}, {13300,0.000014286}, {13400,0.000019048}, {13500,0.000000000}, {13600,0.000000000}, {13700,0.000000000}, {13800,0.000000000}, {13900,0.000019048}, {14000,0.000000000}, {14100,0.000014286}, {14200,0.000000000}, {14300,0.000000000}, {14400,0.000000000}, {14500,0.000014286}, {14600,0.000000000}, {14700,0.000000000}, {14800,0.000000000}, {14900,0.000000000}, {15000,0.000000000}, {15100,0.000000000}, {15200,0.000014286}, {15300,0.000000000}, {15400,0.000000000}, {15500,0.000028571}, {15600,0.000019048}, {15700,0.000000000}, {15800,0.000000000}, {15900,0.000014286}, {16000,0.000019048}, {16100,0.000014286}, {16200,0.000019048}, {16300,0.000000000}, {16400,0.000014286}, {16500,0.000000000}, {16600,0.000000000}, {16700,0.000000000}, {16800,0.000000000}, {16900,0.000028571}, {17000,0.000000000}, {17100,0.000000000}, {17200,0.000014286}, {17300,0.000028571}, {17400,0.000000000}, {17500,0.000000000}, {17600,0.000000000}, {17700,0.000000000}, {17800,0.000000000}, {17900,0.000019048}, {18000,0.000000000}, {18100,0.000033333}, {18200,0.000000000}, {18300,0.000019048}, {18400,0.000000000}, {18500,0.000000000}, {18600,0.000000000}, {18700,0.000000000}, {18800,0.000000000}, {18900,0.000014286}, {19000,0.000000000}, {19100,0.000000000}, {19200,0.000000000}, {19300,0.000019048}, {19400,0.000000000}, {19500,0.000000000}, {19600,0.000014286}, {19700,0.000019048}, {19800,0.000000000}, {19900,0.000014286}, {20000,0.000000000}};
data["big"]["Parametricity; beta"]["pre"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000018957}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000019048}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.000000000}, {5100,0.000000000}, {5150,0.000000000}, {5200,0.000000000}, {5250,0.000000000}, {5300,0.000000000}, {5350,0.000000000}, {5400,0.000000000}, {5450,0.000000000}, {5500,0.000000000}, {5550,0.000000000}, {5600,0.000000000}, {5650,0.000000000}, {5700,0.000000000}, {5750,0.000000000}, {5800,0.000000000}, {5850,0.000000000}, {5900,0.000000000}, {5950,0.000000000}, {6000,0.000000000}, {6050,0.000000000}, {6100,0.000000000}, {6150,0.000000000}, {6200,0.000000000}, {6250,0.000000000}, {6300,0.000000000}, {6350,0.000000000}, {6400,0.000000000}, {6450,0.000000000}, {6500,0.000000000}, {6550,0.000000000}, {6600,0.000000000}, {6650,0.000000000}, {6700,0.000000000}, {6750,0.000000000}, {6800,0.000000000}, {6850,0.000000000}, {6900,0.000000000}, {6950,0.000000000}, {7000,0.000000000}, {7050,0.000000000}, {7100,0.000000000}, {7150,0.000000000}, {7200,0.000000000}, {7250,0.000000000}, {7300,0.000000000}, {7350,0.000000000}, {7400,0.000000000}, {7450,0.000000000}, {7500,0.000000000}, {7550,0.000000000}, {7600,0.000000000}, {7650,0.000000000}, {7700,0.000000000}, {7750,0.000000000}, {7800,0.000000000}, {7850,0.000000000}, {7900,0.000000000}, {7950,0.000000000}, {8000,0.000000000}, {8050,0.000000000}, {8100,0.000000000}, {8150,0.000000000}, {8200,0.000000000}, {8250,0.000000000}, {8300,0.000000000}, {8350,0.000000000}, {8400,0.000000000}, {8450,0.000000000}, {8500,0.000000000}, {8550,0.000000000}, {8600,0.000000000}, {8650,0.000000000}, {8700,0.000000000}, {8750,0.000000000}, {8800,0.000000000}, {8850,0.000000000}, {8900,0.000000000}, {8950,0.000000000}, {9000,0.000000000}, {9050,0.000000000}, {9100,0.000000000}, {9150,0.000000000}, {9200,0.000000000}, {9250,0.000000000}, {9300,0.000000000}, {9350,0.000000000}, {9400,0.000000000}, {9450,0.000000000}, {9500,0.000000000}, {9550,0.000000000}, {9600,0.000000000}, {9650,0.000000000}, {9700,0.000000000}, {9750,0.000000000}, {9800,0.000000000}, {9850,0.000000000}, {9900,0.000000000}, {9950,0.000000000}, {10000,0.000000000}, {10100,0.000000000}, {10200,0.000000000}, {10300,0.000000000}, {10400,0.000000000}, {10500,0.000000000}, {10600,0.000000000}, {10700,0.000000000}, {10800,0.000000000}, {10900,0.000000000}, {11000,0.000000000}, {11100,0.000000000}, {11200,0.000000000}, {11300,0.000000000}, {11400,0.000000000}, {11500,0.000019048}, {11600,0.000000000}, {11700,0.000000000}, {11800,0.000000000}, {11900,0.000000000}, {12000,0.000000000}, {12100,0.000000000}, {12200,0.000000000}, {12300,0.000000000}, {12400,0.000000000}, {12500,0.000000000}, {12600,0.000000000}, {12700,0.000000000}, {12800,0.000000000}, {12900,0.000000000}, {13000,0.000000000}, {13100,0.000000000}, {13200,0.000000000}, {13300,0.000000000}, {13400,0.000000000}, {13500,0.000000000}, {13600,0.000000000}, {13700,0.000000000}, {13800,0.000000000}, {13900,0.000000000}, {14000,0.000000000}, {14100,0.000000000}, {14200,0.000000000}, {14300,0.000000000}, {14400,0.000000000}, {14500,0.000000000}, {14600,0.000000000}, {14700,0.000000000}, {14800,0.000000000}, {14900,0.000000000}, {15000,0.000000000}, {15100,0.000000000}, {15200,0.000000000}, {15300,0.000000000}, {15400,0.000000000}, {15500,0.000000000}, {15600,0.000000000}, {15700,0.000000000}, {15800,0.000000000}, {15900,0.000000000}, {16000,0.000000000}, {16100,0.000000000}, {16200,0.000000000}, {16300,0.000000000}, {16400,0.000000000}, {16500,0.000000000}, {16600,0.000000000}, {16700,0.000000000}, {16800,0.000000000}, {16900,0.000000000}, {17000,0.000000000}, {17100,0.000000000}, {17200,0.000000000}, {17300,0.000000000}, {17400,0.000000000}, {17500,0.000000000}, {17600,0.000000000}, {17700,0.000000000}, {17800,0.000000000}, {17900,0.000000000}, {18000,0.000000000}, {18100,0.000000000}, {18200,0.000000000}, {18300,0.000000000}, {18400,0.000000000}, {18500,0.000000000}, {18600,0.000000000}, {18700,0.000000000}, {18800,0.000000000}, {18900,0.000000000}, {19000,0.000000000}, {19100,0.000000000}, {19200,0.000000000}, {19300,0.000000000}, {19400,0.000000000}, {19500,0.000000000}, {19600,0.000000000}, {19700,0.000000000}, {19800,0.000000000}, {19900,0.000000000}, {20000,0.000000000}};
data["big"]["Parametricity; beta"]["reif"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.022165877}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000004739}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000004739}, {54,0.000000000}, {55,0.000014218}, {56,0.000009479}, {57,0.000009479}, {58,0.000004739}, {59,0.000023697}, {60,0.000037915}, {61,0.000047393}, {62,0.000075829}, {63,0.000056872}, {64,0.000071090}, {65,0.000118483}, {66,0.000109005}, {67,0.000146919}, {68,0.000132701}, {69,0.000170616}, {70,0.000161137}, {71,0.000255924}, {72,0.000289100}, {73,0.000369668}, {74,0.000398104}, {75,0.000488152}, {76,0.000502370}, {77,0.000540284}, {78,0.000587678}, {79,0.000601896}, {80,0.000606635}, {81,0.000606635}, {82,0.000616114}, {83,0.000654028}, {84,0.000658768}, {85,0.000696682}, {86,0.000734597}, {87,0.000753555}, {88,0.000805687}, {89,0.000800948}, {90,0.000862559}, {91,0.000938389}, {92,0.000957346}, {93,0.000971564}, {94,0.000990521}, {95,0.000990521}, {96,0.001000000}, {97,0.001000000}, {98,0.001000000}, {99,0.001000000}, {100,0.001000000}, {101,0.001000000}, {102,0.001000000}, {103,0.001000000}, {104,0.001000000}, {105,0.001000000}, {106,0.001000000}, {107,0.001000000}, {108,0.001004739}, {109,0.001000000}, {110,0.001000000}, {111,0.001000000}, {112,0.001000000}, {113,0.001000000}, {114,0.001000000}, {115,0.001000000}, {116,0.001000000}, {117,0.001000000}, {118,0.001000000}, {119,0.001000000}, {120,0.001000000}, {121,0.001000000}, {122,0.001000000}, {123,0.001000000}, {124,0.001000000}, {125,0.001000000}, {126,0.001511848}, {127,0.001000000}, {128,0.001000000}, {129,0.001000000}, {130,0.001000000}, {131,0.001000000}, {132,0.001000000}, {133,0.001000000}, {134,0.001000000}, {135,0.001000000}, {136,0.001000000}, {137,0.001009479}, {138,0.001004739}, {139,0.001000000}, {140,0.001000000}, {141,0.001000000}, {142,0.001000000}, {143,0.001000000}, {144,0.001000000}, {145,0.001000000}, {146,0.001000000}, {147,0.001000000}, {148,0.001000000}, {149,0.001587678}, {150,0.001000000}, {151,0.001000000}, {152,0.001000000}, {153,0.001000000}, {154,0.001000000}, {155,0.001000000}, {156,0.001004739}, {157,0.001000000}, {158,0.001004739}, {159,0.001009479}, {160,0.001000000}, {161,0.001000000}, {162,0.001000000}, {163,0.001000000}, {164,0.001000000}, {165,0.001000000}, {166,0.001000000}, {167,0.001000000}, {168,0.001000000}, {169,0.001000000}, {170,0.002014218}, {171,0.001000000}, {172,0.001000000}, {173,0.001000000}, {174,0.001000000}, {175,0.001000000}, {176,0.001000000}, {177,0.001000000}, {178,0.001000000}, {179,0.001018957}, {180,0.001000000}, {181,0.001000000}, {182,0.001000000}, {183,0.001004739}, {184,0.001000000}, {185,0.001000000}, {186,0.001000000}, {187,0.001000000}, {188,0.001000000}, {189,0.001635071}, {190,0.001000000}, {191,0.001000000}, {192,0.001000000}, {193,0.001000000}, {194,0.001000000}, {195,0.001000000}, {196,0.001000000}, {197,0.001000000}, {198,0.001000000}, {199,0.001000000}, {200,0.001000000}, {201,0.001000000}, {202,0.001000000}, {203,0.001000000}, {204,0.001000000}, {205,0.001004739}, {206,0.001000000}, {207,0.001009479}, {208,0.001004739}, {209,0.001990521}, {210,0.001000000}, {211,0.001000000}, {212,0.001000000}, {213,0.001000000}, {214,0.001004739}, {215,0.001000000}, {216,0.001000000}, {217,0.001004739}, {218,0.001000000}, {219,0.001000000}, {220,0.001004739}, {221,0.001004739}, {222,0.001000000}, {223,0.001004739}, {224,0.001004739}, {225,0.001009479}, {226,0.001004739}, {227,0.001018957}, {228,0.001014218}, {229,0.001009479}, {230,0.001014218}, {231,0.001033175}, {232,0.001023697}, {233,0.001014218}, {234,0.001037915}, {235,0.001052133}, {236,0.001071090}, {237,0.001056872}, {238,0.001052133}, {239,0.002023697}, {240,0.001094787}, {241,0.001127962}, {242,0.001146919}, {243,0.001113744}, {244,0.001171429}, {245,0.001214286}, {246,0.001228571}, {247,0.001257143}, {248,0.001242857}, {249,0.001290476}, {250,0.001304762}, {251,0.001347619}, {252,0.001380952}, {253,0.001428571}, {254,0.002257143}, {255,0.001414286}, {256,0.001495238}, {257,0.001485714}, {258,0.001485714}, {259,0.001519048}, {260,0.001514286}, {261,0.001485714}, {262,0.001514286}, {263,0.001542857}, {264,0.001571429}, {265,0.001580952}, {266,0.001576190}, {267,0.001600000}, {268,0.001628571}, {269,0.001623810}, {270,0.001638095}, {271,0.001666667}, {272,0.001652381}, {273,0.001709524}, {274,0.001719048}, {275,0.001695238}, {276,0.001728571}, {277,0.001757143}, {278,0.001790476}, {279,0.001790476}, {280,0.001871429}, {281,0.001900000}, {282,0.002333333}, {283,0.001919048}, {284,0.001938095}, {285,0.001947619}, {286,0.001952381}, {287,0.001933333}, {288,0.001942857}, {289,0.001952381}, {290,0.001942857}, {291,0.001957143}, {292,0.001966667}, {293,0.001971429}, {294,0.001966667}, {295,0.002895238}, {296,0.001990476}, {297,0.001990476}, {298,0.001990476}, {299,0.002000000}, {300,0.002000000}, {301,0.002019048}, {302,0.002000000}, {303,0.002000000}, {304,0.002000000}, {305,0.002000000}, {306,0.002004762}, {307,0.002000000}, {308,0.002000000}, {309,0.002000000}, {310,0.002000000}, {311,0.002000000}, {312,0.002000000}, {313,0.002000000}, {314,0.002000000}, {315,0.002000000}, {316,0.002000000}, {317,0.002000000}, {318,0.002000000}, {319,0.002000000}, {320,0.002509524}, {321,0.002000000}, {322,0.002004762}, {323,0.002000000}, {324,0.002000000}, {325,0.002000000}, {326,0.002000000}, {327,0.002000000}, {328,0.002000000}, {329,0.002000000}, {330,0.002000000}, {331,0.002000000}, {332,0.002000000}, {333,0.002000000}, {334,0.002000000}, {335,0.002000000}, {336,0.002000000}, {337,0.002000000}, {338,0.002000000}, {339,0.002000000}, {340,0.002000000}, {341,0.002923810}, {342,0.002000000}, {343,0.002000000}, {344,0.002000000}, {345,0.002000000}, {346,0.002000000}, {347,0.002000000}, {348,0.002000000}, {349,0.002000000}, {350,0.002000000}, {351,0.002000000}, {352,0.002000000}, {353,0.002966667}, {354,0.002000000}, {355,0.002004762}, {356,0.002000000}, {357,0.002000000}, {358,0.002004762}, {359,0.002004762}, {360,0.002000000}, {361,0.002000000}, {362,0.002000000}, {363,0.002000000}, {364,0.002000000}, {365,0.002480952}, {366,0.002000000}, {367,0.002000000}, {368,0.002000000}, {369,0.002000000}, {370,0.002000000}, {371,0.002000000}, {372,0.002004762}, {373,0.002000000}, {374,0.002000000}, {375,0.002000000}, {376,0.002933333}, {377,0.002004762}, {378,0.002000000}, {379,0.002000000}, {380,0.002000000}, {381,0.002009524}, {382,0.002004762}, {383,0.002000000}, {384,0.002004762}, {385,0.002000000}, {386,0.002000000}, {387,0.002000000}, {388,0.002000000}, {389,0.002000000}, {390,0.002000000}, {391,0.002023810}, {392,0.002004762}, {393,0.002000000}, {394,0.002000000}, {395,0.002004762}, {396,0.002009524}, {397,0.002009524}, {398,0.002000000}, {399,0.002028571}, {400,0.002009524}, {401,0.002061905}, {402,0.002014286}, {403,0.002019048}, {404,0.002052381}, {405,0.002019048}, {406,0.002042857}, {407,0.002023810}, {408,0.002038095}, {409,0.002585714}, {410,0.002061905}, {411,0.002090476}, {412,0.002090476}, {413,0.002080952}, {414,0.002066667}, {415,0.002104762}, {416,0.003066667}, {417,0.002128571}, {418,0.002138095}, {419,0.002109524}, {420,0.002109524}, {421,0.002128571}, {422,0.002176190}, {423,0.002166667}, {424,0.002157143}, {425,0.002200000}, {426,0.002252381}, {427,0.002247619}, {428,0.002252381}, {429,0.002271429}, {430,0.002314286}, {431,0.002300000}, {432,0.002342857}, {433,0.002371429}, {434,0.002347619}, {435,0.003033333}, {436,0.002390476}, {437,0.002414286}, {438,0.002414286}, {439,0.002395238}, {440,0.002419048}, {441,0.002414286}, {442,0.002414286}, {443,0.002447619}, {444,0.003971429}, {445,0.002442857}, {446,0.002485714}, {447,0.002495238}, {448,0.002490476}, {449,0.002542857}, {450,0.002514286}, {451,0.002552381}, {452,0.002542857}, {453,0.004071429}, {454,0.002547619}, {455,0.002557143}, {456,0.002580952}, {457,0.002561905}, {458,0.002566667}, {459,0.002614286}, {460,0.002600000}, {461,0.002609524}, {462,0.003128571}, {463,0.002642857}, {464,0.002642857}, {465,0.002642857}, {466,0.002690476}, {467,0.002671429}, {468,0.004500000}, {469,0.002728571}, {470,0.002761905}, {471,0.002747619}, {472,0.002761905}, {473,0.002785714}, {474,0.002795238}, {475,0.002828571}, {476,0.002823810}, {477,0.002866667}, {478,0.002890476}, {479,0.004695238}, {480,0.002885714}, {481,0.002909524}, {482,0.002900000}, {483,0.002942857}, {484,0.002928571}, {485,0.002923810}, {486,0.002923810}, {487,0.002923810}, {488,0.002928571}, {489,0.002928571}, {490,0.002928571}, {491,0.002933333}, {492,0.002942857}, {493,0.002933333}, {494,0.002952381}, {495,0.002952381}, {496,0.003461905}, {497,0.002976190}, {498,0.002971429}, {499,0.002966667}, {500,0.002961905}, {505,0.002985714}, {510,0.003000000}, {515,0.003000000}, {520,0.003523810}, {525,0.003000000}, {530,0.003000000}, {535,0.003000000}, {540,0.003000000}, {545,0.003009524}, {550,0.003004762}, {555,0.003000000}, {560,0.003009524}, {565,0.003009524}, {570,0.003009524}, {575,0.003057143}, {580,0.003052381}, {585,0.003066667}, {590,0.003104762}, {595,0.003176190}, {600,0.005290476}, {605,0.003271429}, {610,0.003333333}, {615,0.003314286}, {620,0.003395238}, {625,0.003438095}, {630,0.003457143}, {635,0.003504762}, {640,0.003547619}, {645,0.003571429}, {650,0.003585714}, {655,0.003638095}, {660,0.005071429}, {665,0.003728571}, {670,0.003776190}, {675,0.003900000}, {680,0.003895238}, {685,0.003900000}, {690,0.003904762}, {695,0.003938095}, {700,0.003971429}, {705,0.004504762}, {710,0.004004762}, {715,0.004009524}, {720,0.004019048}, {725,0.004000000}, {730,0.004014286}, {735,0.005304762}, {740,0.004004762}, {745,0.004023810}, {750,0.005866667}, {755,0.004038095}, {760,0.004128571}, {765,0.004114286}, {770,0.004157143}, {775,0.004228571}, {780,0.004280952}, {785,0.004271429}, {790,0.004347619}, {795,0.006095238}, {800,0.004376190}, {805,0.005071429}, {810,0.004471429}, {815,0.004490476}, {820,0.004500000}, {825,0.005461905}, {830,0.007142857}, {835,0.004566667}, {840,0.004604762}, {845,0.004633333}, {850,0.004700000}, {855,0.004733333}, {860,0.004757143}, {865,0.004833333}, {870,0.004857143}, {875,0.004885714}, {880,0.007733333}, {885,0.004900000}, {890,0.004919048}, {895,0.004942857}, {900,0.004947619}, {905,0.006852381}, {910,0.005009524}, {915,0.005100000}, {920,0.005061905}, {925,0.005095238}, {930,0.005666667}, {935,0.005119048}, {940,0.005166667}, {945,0.005214286}, {950,0.005257143}, {955,0.005800000}, {960,0.005319048}, {965,0.005314286}, {970,0.005376190}, {975,0.005376190}, {980,0.005419048}, {985,0.005442857}, {990,0.005480952}, {995,0.007961905}, {1000,0.005500000}, {1010,0.005604762}, {1020,0.005571429}, {1030,0.005642857}, {1040,0.005666667}, {1050,0.006590476}, {1060,0.005852381}, {1070,0.005900000}, {1080,0.005909524}, {1090,0.005990476}, {1100,0.006047619}, {1110,0.006142857}, {1120,0.006176190}, {1130,0.006395238}, {1140,0.006319048}, {1150,0.006390476}, {1160,0.006419048}, {1170,0.006500000}, {1180,0.006500000}, {1190,0.007880952}, {1200,0.006566667}, {1210,0.006609524}, {1220,0.006661905}, {1230,0.006723810}, {1240,0.006842857}, {1250,0.006871429}, {1260,0.010328571}, {1270,0.006995238}, {1280,0.007033333}, {1290,0.009014286}, {1300,0.007209524}, {1310,0.007342857}, {1320,0.007352381}, {1330,0.007414286}, {1340,0.007400000}, {1350,0.007466667}, {1360,0.014509524}, {1370,0.007533333}, {1380,0.007566667}, {1390,0.007604762}, {1400,0.007638095}, {1410,0.007671429}, {1420,0.007776190}, {1430,0.009342857}, {1440,0.007961905}, {1450,0.008052381}, {1460,0.008095238}, {1470,0.008161905}, {1480,0.008223810}, {1490,0.008266667}, {1500,0.008314286}, {1510,0.008385714}, {1520,0.008438095}, {1530,0.008471429}, {1540,0.008519048}, {1550,0.008547619}, {1560,0.008580952}, {1570,0.012723810}, {1580,0.008671429}, {1590,0.008714286}, {1600,0.008733333}, {1610,0.008900000}, {1620,0.008942857}, {1630,0.009057143}, {1640,0.009095238}, {1650,0.009214286}, {1660,0.009233333}, {1670,0.009257143}, {1680,0.010580952}, {1690,0.009447619}, {1700,0.009438095}, {1710,0.009438095}, {1720,0.009495238}, {1730,0.019766667}, {1740,0.009566667}, {1750,0.009614286}, {1760,0.010942857}, {1770,0.009714286}, {1780,0.013495238}, {1790,0.009819048}, {1800,0.009985714}, {1810,0.015704762}, {1820,0.010157143}, {1830,0.013257143}, {1840,0.011328571}, {1850,0.010247619}, {1860,0.010295238}, {1870,0.010338095}, {1880,0.010366667}, {1890,0.011914286}, {1900,0.015209524}, {1910,0.010566667}, {1920,0.010571429}, {1930,0.010661905}, {1940,0.012109524}, {1950,0.010761905}, {1960,0.010809524}, {1970,0.014052381}, {1980,0.011100000}, {1990,0.012409524}, {2000,0.011161905}, {2050,0.011371429}, {2100,0.011590476}, {2150,0.011928571}, {2200,0.012276190}, {2250,0.012442857}, {2300,0.012776190}, {2350,0.013133333}, {2400,0.013328571}, {2450,0.013619048}, {2500,0.014095238}, {2550,0.022380952}, {2600,0.014538095}, {2650,0.014785714}, {2700,0.015080952}, {2750,0.015361905}, {2800,0.020523810}, {2850,0.018819048}, {2900,0.016238095}, {2950,0.016485714}, {3000,0.016823810}, {3050,0.017047619}, {3100,0.028838095}, {3150,0.017685714}, {3200,0.017895238}, {3250,0.024523810}, {3300,0.018576190}, {3350,0.018880952}, {3400,0.021871429}, {3450,0.025266667}, {3500,0.019747619}, {3550,0.020019048}, {3600,0.028200000}, {3650,0.019909524}, {3700,0.029414286}, {3750,0.021033333}, {3800,0.026528571}, {3850,0.021919048}, {3900,0.022285714}, {3950,0.022214286}, {4000,0.025004762}, {4050,0.034423810}, {4100,0.046795238}, {4150,0.023471429}, {4200,0.023804762}, {4250,0.024028571}, {4300,0.024333333}, {4350,0.024866667}, {4400,0.027528571}, {4450,0.031538095}, {4500,0.041357143}, {4550,0.038795238}, {4600,0.026242857}, {4650,0.026509524}, {4700,0.026900000}, {4750,0.027190476}, {4800,0.027323810}, {4850,0.027709524}, {4900,0.041095238}, {4950,0.043566667}, {5000,0.033423810}, {5050,0.036357143}, {5100,0.029533333}, {5150,0.029666667}, {5200,0.029876190}, {5250,0.039566667}, {5300,0.056519048}, {5350,0.045495238}, {5400,0.038395238}, {5450,0.031485714}, {5500,0.031614286}, {5550,0.039942857}, {5600,0.039252381}, {5650,0.032766667}, {5700,0.049476190}, {5750,0.047357143}, {5800,0.041633333}, {5850,0.033861905}, {5900,0.034047619}, {5950,0.051733333}, {6000,0.041276190}, {6050,0.034928571}, {6100,0.041766667}, {6150,0.051176190}, {6200,0.066571429}, {6250,0.042533333}, {6300,0.036542857}, {6350,0.076195238}, {6400,0.041133333}, {6450,0.066285714}, {6500,0.056019048}, {6550,0.044085714}, {6600,0.042871429}, {6650,0.050480952}, {6700,0.057138095}, {6750,0.039261905}, {6800,0.066757143}, {6850,0.039900000}, {6900,0.073504762}, {6950,0.045871429}, {7000,0.045547619}, {7050,0.050085714}, {7100,0.045747619}, {7150,0.083109524}, {7200,0.042409524}, {7250,0.071209524}, {7300,0.042809524}, {7350,0.060185714}, {7400,0.062819048}, {7450,0.055171429}, {7500,0.050633333}, {7550,0.088304762}, {7600,0.044942857}, {7650,0.061352381}, {7700,0.065404762}, {7750,0.050047619}, {7800,0.050666667}, {7850,0.070714286}, {7900,0.067738095}, {7950,0.047019048}, {8000,0.059209524}, {8050,0.080323810}, {8100,0.076628571}, {8150,0.055490476}, {8200,0.075580952}, {8250,0.054909524}, {8300,0.075752381}, {8350,0.085228571}, {8400,0.049576190}, {8450,0.054285714}, {8500,0.073038095}, {8550,0.057100000}, {8600,0.056842857}, {8650,0.072400000}, {8700,0.094480952}, {8750,0.088161905}, {8800,0.072971429}, {8850,0.080328571}, {8900,0.088090476}, {8950,0.075985714}, {9000,0.075157143}, {9050,0.053571429}, {9100,0.053642857}, {9150,0.060533333}, {9200,0.061552381}, {9250,0.098376190}, {9300,0.102147619}, {9350,0.090523810}, {9400,0.095233333}, {9450,0.080971429}, {9500,0.074604762}, {9550,0.065752381}, {9600,0.062504762}, {9650,0.068576190}, {9700,0.063361905}, {9750,0.064133333}, {9800,0.084828571}, {9850,0.097119048}, {9900,0.076723810}, {9950,0.072542857}, {10000,0.065404762}, {10100,0.094076190}, {10200,0.088700000}, {10300,0.069652381}, {10400,0.093785714}, {10500,0.102552381}, {10600,0.105966667}, {10700,0.083638095}, {10800,0.090728571}, {10900,0.078176190}, {11000,0.090071429}, {11100,0.120528571}, {11200,0.082609524}, {11300,0.106276190}, {11400,0.088523810}, {11500,0.107676190}, {11600,0.080833333}, {11700,0.126609524}, {11800,0.117304762}, {11900,0.114152381}, {12000,0.122342857}, {12100,0.084990476}, {12200,0.098857143}, {12300,0.109071429}, {12400,0.130466667}, {12500,0.089819048}, {12600,0.108895238}, {12700,0.139528571}, {12800,0.117304762}, {12900,0.098285714}, {13000,0.094600000}, {13100,0.110171429}, {13200,0.115366667}, {13300,0.110652381}, {13400,0.119457143}, {13500,0.145666667}, {13600,0.139304762}, {13700,0.122709524}, {13800,0.123457143}, {13900,0.134190476}, {14000,0.141338095}, {14100,0.118785714}, {14200,0.140176190}, {14300,0.102266667}, {14400,0.152109524}, {14500,0.115138095}, {14600,0.132904762}, {14700,0.113452381}, {14800,0.111442857}, {14900,0.134971429}, {15000,0.130414286}, {15100,0.108657143}, {15200,0.148352381}, {15300,0.156176190}, {15400,0.148147619}, {15500,0.157280952}, {15600,0.156661905}, {15700,0.177280952}, {15800,0.137142857}, {15900,0.150004762}, {16000,0.157080952}, {16100,0.193119048}, {16200,0.136500000}, {16300,0.198404762}, {16400,0.157433333}, {16500,0.164971429}, {16600,0.215300000}, {16700,0.157761905}, {16800,0.125147619}, {16900,0.178890476}, {17000,0.133476190}, {17100,0.186904762}, {17200,0.151485714}, {17300,0.201461905}, {17400,0.134728571}, {17500,0.168695238}, {17600,0.158642857}, {17700,0.165128571}, {17800,0.132261905}, {17900,0.177300000}, {18000,0.191476190}, {18100,0.155138095}, {18200,0.188704762}, {18300,0.196152381}, {18400,0.165757143}, {18500,0.183395238}, {18600,0.190261905}, {18700,0.203852381}, {18800,0.209314286}, {18900,0.156333333}, {19000,0.155752381}, {19100,0.201728571}, {19200,0.209966667}, {19300,0.198980952}, {19400,0.183547619}, {19500,0.220800000}, {19600,0.191314286}, {19700,0.194480952}, {19800,0.169523810}, {19900,0.187738095}, {20000,0.183620192}};
data["big"]["Parametricity; beta"]["reif"]["user"] = {{1,0.000383886}, {2,0.000582938}, {3,0.000260664}, {4,0.000611374}, {5,0.000492891}, {6,0.000421801}, {7,0.000545024}, {8,0.000488152}, {9,0.000663507}, {10,0.000436019}, {11,0.000715640}, {12,0.000478673}, {13,0.000592417}, {14,0.000488152}, {15,0.000597156}, {16,0.000511848}, {17,0.000644550}, {18,0.000573460}, {19,0.000578199}, {20,0.000597156}, {21,0.000682464}, {22,0.000635071}, {23,0.000568720}, {24,0.022218009}, {25,0.000857820}, {26,0.000644550}, {27,0.000748815}, {28,0.000568720}, {29,0.000763033}, {30,0.000644550}, {31,0.000796209}, {32,0.000630332}, {33,0.000815166}, {34,0.000606635}, {35,0.000843602}, {36,0.000663507}, {37,0.000729858}, {38,0.000563981}, {39,0.000563981}, {40,0.000876777}, {41,0.000635071}, {42,0.000772512}, {43,0.000763033}, {44,0.000672986}, {45,0.000810427}, {46,0.000649289}, {47,0.000616114}, {48,0.000895735}, {49,0.000777251}, {50,0.000663507}, {51,0.000900474}, {52,0.000654028}, {53,0.000796209}, {54,0.000853081}, {55,0.000597156}, {56,0.000862559}, {57,0.000876777}, {58,0.000582938}, {59,0.000753555}, {60,0.000962085}, {61,0.000791469}, {62,0.000810427}, {63,0.000815166}, {64,0.000872038}, {65,0.000734597}, {66,0.000843602}, {67,0.001033175}, {68,0.000919431}, {69,0.001104265}, {70,0.000862559}, {71,0.000734597}, {72,0.000772512}, {73,0.000909953}, {74,0.000886256}, {75,0.000829384}, {76,0.000862559}, {77,0.000919431}, {78,0.000777251}, {79,0.000905213}, {80,0.001109005}, {81,0.000853081}, {82,0.000824645}, {83,0.000886256}, {84,0.001023697}, {85,0.000815166}, {86,0.000938389}, {87,0.000938389}, {88,0.001161137}, {89,0.000862559}, {90,0.000791469}, {91,0.001094787}, {92,0.001203791}, {93,0.000924171}, {94,0.001227488}, {95,0.000966825}, {96,0.000810427}, {97,0.000881517}, {98,0.001000000}, {99,0.001123223}, {100,0.001127962}, {101,0.000848341}, {102,0.000900474}, {103,0.001014218}, {104,0.001175355}, {105,0.001161137}, {106,0.001028436}, {107,0.000947867}, {108,0.001018957}, {109,0.001018957}, {110,0.000909953}, {111,0.000867299}, {112,0.000971564}, {113,0.001042654}, {114,0.001085308}, {115,0.001075829}, {116,0.001127962}, {117,0.001303318}, {118,0.001265403}, {119,0.001322275}, {120,0.001161137}, {121,0.001075829}, {122,0.001042654}, {123,0.001132701}, {124,0.001132701}, {125,0.001042654}, {126,0.001540284}, {127,0.000995261}, {128,0.000905213}, {129,0.000981043}, {130,0.000990521}, {131,0.001018957}, {132,0.001118483}, {133,0.001113744}, {134,0.001222749}, {135,0.001260664}, {136,0.001203791}, {137,0.001232227}, {138,0.001317536}, {139,0.001412322}, {140,0.001270142}, {141,0.001398104}, {142,0.001331754}, {143,0.001071090}, {144,0.001075829}, {145,0.000947867}, {146,0.001014218}, {147,0.001293839}, {148,0.001549763}, {149,0.002052133}, {150,0.001289100}, {151,0.001265403}, {152,0.001213270}, {153,0.001398104}, {154,0.001445498}, {155,0.001530806}, {156,0.001364929}, {157,0.001398104}, {158,0.001194313}, {159,0.001151659}, {160,0.001327014}, {161,0.001473934}, {162,0.001412322}, {163,0.001241706}, {164,0.001393365}, {165,0.001450237}, {166,0.001360190}, {167,0.001199052}, {168,0.001341232}, {169,0.001327014}, {170,0.002118483}, {171,0.001478673}, {172,0.001388626}, {173,0.001293839}, {174,0.001450237}, {175,0.001502370}, {176,0.001473934}, {177,0.001345972}, {178,0.001317536}, {179,0.001587678}, {180,0.001369668}, {181,0.001246445}, {182,0.001383886}, {183,0.001597156}, {184,0.001540284}, {185,0.001298578}, {186,0.001398104}, {187,0.001521327}, {188,0.001246445}, {189,0.001971564}, {190,0.001388626}, {191,0.001516588}, {192,0.001407583}, {193,0.001265403}, {194,0.001587678}, {195,0.001729858}, {196,0.001289100}, {197,0.001417062}, {198,0.001554502}, {199,0.001436019}, {200,0.001611374}, {201,0.001530806}, {202,0.001417062}, {203,0.001398104}, {204,0.001488152}, {205,0.001573460}, {206,0.001611374}, {207,0.001478673}, {208,0.001511848}, {209,0.002360190}, {210,0.001663507}, {211,0.001502370}, {212,0.001781991}, {213,0.001464455}, {214,0.001407583}, {215,0.001597156}, {216,0.001587678}, {217,0.001720379}, {218,0.001592417}, {219,0.001478673}, {220,0.001725118}, {221,0.001625592}, {222,0.001535545}, {223,0.001635071}, {224,0.001834123}, {225,0.001360190}, {226,0.001796209}, {227,0.001393365}, {228,0.001772512}, {229,0.001753555}, {230,0.001587678}, {231,0.001710900}, {232,0.001715640}, {233,0.001691943}, {234,0.001838863}, {235,0.001767773}, {236,0.001649289}, {237,0.001620853}, {238,0.001701422}, {239,0.002222749}, {240,0.001753555}, {241,0.001616114}, {242,0.001862559}, {243,0.001649289}, {244,0.001761905}, {245,0.001457143}, {246,0.001942857}, {247,0.001666667}, {248,0.001747619}, {249,0.001895238}, {250,0.001719048}, {251,0.001952381}, {252,0.001695238}, {253,0.001700000}, {254,0.002795238}, {255,0.001795238}, {256,0.001709524}, {257,0.001795238}, {258,0.001738095}, {259,0.001861905}, {260,0.002133333}, {261,0.001614286}, {262,0.002028571}, {263,0.001680952}, {264,0.001861905}, {265,0.001800000}, {266,0.001919048}, {267,0.001752381}, {268,0.001842857}, {269,0.001814286}, {270,0.001980952}, {271,0.001742857}, {272,0.001785714}, {273,0.002285714}, {274,0.001409524}, {275,0.001761905}, {276,0.002138095}, {277,0.001700000}, {278,0.001952381}, {279,0.001752381}, {280,0.002138095}, {281,0.001800000}, {282,0.002514286}, {283,0.001623810}, {284,0.002090476}, {285,0.001990476}, {286,0.001842857}, {287,0.002114286}, {288,0.001985714}, {289,0.001985714}, {290,0.001957143}, {291,0.002085714}, {292,0.001866667}, {293,0.001900000}, {294,0.002095238}, {295,0.002733333}, {296,0.002004762}, {297,0.001985714}, {298,0.001952381}, {299,0.001985714}, {300,0.001876190}, {301,0.001966667}, {302,0.002147619}, {303,0.002000000}, {304,0.001961905}, {305,0.001995238}, {306,0.002076190}, {307,0.002042857}, {308,0.001914286}, {309,0.002128571}, {310,0.002209524}, {311,0.001900000}, {312,0.002095238}, {313,0.001938095}, {314,0.002019048}, {315,0.002095238}, {316,0.002004762}, {317,0.002052381}, {318,0.001942857}, {319,0.001880952}, {320,0.002623810}, {321,0.002000000}, {322,0.002085714}, {323,0.002252381}, {324,0.002023810}, {325,0.002000000}, {326,0.002166667}, {327,0.002019048}, {328,0.002033333}, {329,0.001938095}, {330,0.001961905}, {331,0.002109524}, {332,0.002257143}, {333,0.001976190}, {334,0.001838095}, {335,0.002152381}, {336,0.002200000}, {337,0.002190476}, {338,0.002180952}, {339,0.002371429}, {340,0.002200000}, {341,0.003071429}, {342,0.002223810}, {343,0.002104762}, {344,0.002000000}, {345,0.002014286}, {346,0.002085714}, {347,0.002123810}, {348,0.002190476}, {349,0.002214286}, {350,0.002404762}, {351,0.002219048}, {352,0.002185714}, {353,0.003090476}, {354,0.002352381}, {355,0.002338095}, {356,0.002323810}, {357,0.002323810}, {358,0.002285714}, {359,0.002266667}, {360,0.002147619}, {361,0.002257143}, {362,0.002266667}, {363,0.002204762}, {364,0.002166667}, {365,0.002776190}, {366,0.002342857}, {367,0.002204762}, {368,0.002128571}, {369,0.002261905}, {370,0.002342857}, {371,0.002347619}, {372,0.002285714}, {373,0.002333333}, {374,0.002295238}, {375,0.002438095}, {376,0.002952381}, {377,0.002476190}, {378,0.002404762}, {379,0.002390476}, {380,0.002271429}, {381,0.002452381}, {382,0.002361905}, {383,0.002319048}, {384,0.002414286}, {385,0.002333333}, {386,0.002466667}, {387,0.002261905}, {388,0.002500000}, {389,0.002376190}, {390,0.002309524}, {391,0.002423810}, {392,0.002366667}, {393,0.002528571}, {394,0.002438095}, {395,0.002471429}, {396,0.002328571}, {397,0.002319048}, {398,0.002371429}, {399,0.002676190}, {400,0.002509524}, {401,0.002623810}, {402,0.002423810}, {403,0.002452381}, {404,0.002628571}, {405,0.002533333}, {406,0.002485714}, {407,0.002438095}, {408,0.002552381}, {409,0.003052381}, {410,0.002552381}, {411,0.002609524}, {412,0.002671429}, {413,0.002390476}, {414,0.002661905}, {415,0.002676190}, {416,0.003357143}, {417,0.002428571}, {418,0.002666667}, {419,0.002414286}, {420,0.002690476}, {421,0.002580952}, {422,0.002900000}, {423,0.002519048}, {424,0.002576190}, {425,0.002614286}, {426,0.002642857}, {427,0.002661905}, {428,0.002509524}, {429,0.002857143}, {430,0.002704762}, {431,0.002628571}, {432,0.002547619}, {433,0.002828571}, {434,0.002614286}, {435,0.003447619}, {436,0.002619048}, {437,0.002595238}, {438,0.002785714}, {439,0.002723810}, {440,0.002661905}, {441,0.002623810}, {442,0.002804762}, {443,0.002752381}, {444,0.004228571}, {445,0.002552381}, {446,0.002819048}, {447,0.002714286}, {448,0.002733333}, {449,0.002857143}, {450,0.002828571}, {451,0.002961905}, {452,0.002600000}, {453,0.004404762}, {454,0.002757143}, {455,0.002780952}, {456,0.002700000}, {457,0.002714286}, {458,0.002904762}, {459,0.002628571}, {460,0.002790476}, {461,0.002614286}, {462,0.003280952}, {463,0.002842857}, {464,0.002857143}, {465,0.002838095}, {466,0.002700000}, {467,0.002576190}, {468,0.004342857}, {469,0.002842857}, {470,0.002671429}, {471,0.002866667}, {472,0.002957143}, {473,0.002914286}, {474,0.002776190}, {475,0.002728571}, {476,0.002947619}, {477,0.002776190}, {478,0.002961905}, {479,0.004547619}, {480,0.002900000}, {481,0.002909524}, {482,0.002809524}, {483,0.002914286}, {484,0.003057143}, {485,0.002880952}, {486,0.002885714}, {487,0.002852381}, {488,0.002947619}, {489,0.002766667}, {490,0.003061905}, {491,0.002823810}, {492,0.002942857}, {493,0.003066667}, {494,0.002971429}, {495,0.002780952}, {496,0.003176190}, {497,0.003138095}, {498,0.002847619}, {499,0.002876190}, {500,0.002942857}, {505,0.002900000}, {510,0.003090476}, {515,0.002961905}, {520,0.003657143}, {525,0.003133333}, {530,0.003142857}, {535,0.003200000}, {540,0.003180952}, {545,0.003128571}, {550,0.003233333}, {555,0.003247619}, {560,0.003314286}, {565,0.003319048}, {570,0.003142857}, {575,0.003280952}, {580,0.003285714}, {585,0.003404762}, {590,0.003433333}, {595,0.003395238}, {600,0.005347619}, {605,0.003423810}, {610,0.003514286}, {615,0.003542857}, {620,0.003504762}, {625,0.003504762}, {630,0.003638095}, {635,0.003719048}, {640,0.003790476}, {645,0.003719048}, {650,0.003719048}, {655,0.003776190}, {660,0.005261905}, {665,0.003814286}, {670,0.003761905}, {675,0.003880952}, {680,0.003800000}, {685,0.003971429}, {690,0.003904762}, {695,0.003961905}, {700,0.003833333}, {705,0.004623810}, {710,0.004033333}, {715,0.003928571}, {720,0.004028571}, {725,0.004080952}, {730,0.004161905}, {735,0.005338095}, {740,0.004123810}, {745,0.004304762}, {750,0.005866667}, {755,0.004161905}, {760,0.004109524}, {765,0.004200000}, {770,0.004228571}, {775,0.004147619}, {780,0.004395238}, {785,0.004685714}, {790,0.004338095}, {795,0.005928571}, {800,0.004485714}, {805,0.005180952}, {810,0.004457143}, {815,0.004657143}, {820,0.004357143}, {825,0.005361905}, {830,0.007390476}, {835,0.004461905}, {840,0.004690476}, {845,0.004590476}, {850,0.004823810}, {855,0.004628571}, {860,0.004738095}, {865,0.004800000}, {870,0.004823810}, {875,0.004700000}, {880,0.007542857}, {885,0.004761905}, {890,0.004847619}, {895,0.004933333}, {900,0.004919048}, {905,0.006609524}, {910,0.005133333}, {915,0.005166667}, {920,0.005052381}, {925,0.005061905}, {930,0.005680952}, {935,0.005195238}, {940,0.005061905}, {945,0.005323810}, {950,0.005228571}, {955,0.005566667}, {960,0.005261905}, {965,0.005447619}, {970,0.005304762}, {975,0.005228571}, {980,0.005552381}, {985,0.005366667}, {990,0.005438095}, {995,0.008409524}, {1000,0.005409524}, {1010,0.005666667}, {1020,0.005471429}, {1030,0.005471429}, {1040,0.005528571}, {1050,0.006452381}, {1060,0.005861905}, {1070,0.005704762}, {1080,0.005838095}, {1090,0.005714286}, {1100,0.006185714}, {1110,0.005966667}, {1120,0.006028571}, {1130,0.006076190}, {1140,0.006071429}, {1150,0.006190476}, {1160,0.006123810}, {1170,0.006266667}, {1180,0.006304762}, {1190,0.008095238}, {1200,0.006376190}, {1210,0.006604762}, {1220,0.006542857}, {1230,0.006633333}, {1240,0.006595238}, {1250,0.006690476}, {1260,0.010328571}, {1270,0.006795238}, {1280,0.006866667}, {1290,0.008904762}, {1300,0.006933333}, {1310,0.007057143}, {1320,0.007138095}, {1330,0.007123810}, {1340,0.007195238}, {1350,0.007085714}, {1360,0.014109524}, {1370,0.007361905}, {1380,0.007261905}, {1390,0.007447619}, {1400,0.007842857}, {1410,0.007633333}, {1420,0.007742857}, {1430,0.009476190}, {1440,0.007814286}, {1450,0.008147619}, {1460,0.007961905}, {1470,0.008066667}, {1480,0.008090476}, {1490,0.008195238}, {1500,0.008171429}, {1510,0.008152381}, {1520,0.008157143}, {1530,0.008433333}, {1540,0.008814286}, {1550,0.008514286}, {1560,0.008495238}, {1570,0.012623810}, {1580,0.008676190}, {1590,0.008795238}, {1600,0.008766667}, {1610,0.008885714}, {1620,0.008828571}, {1630,0.009219048}, {1640,0.009261905}, {1650,0.009004762}, {1660,0.009161905}, {1670,0.009319048}, {1680,0.010666667}, {1690,0.009295238}, {1700,0.009352381}, {1710,0.009590476}, {1720,0.009290476}, {1730,0.019461905}, {1740,0.009947619}, {1750,0.009585714}, {1760,0.010985714}, {1770,0.009866667}, {1780,0.013509524}, {1790,0.009914286}, {1800,0.010109524}, {1810,0.015828571}, {1820,0.010447619}, {1830,0.012942857}, {1840,0.011376190}, {1850,0.010300000}, {1860,0.010780952}, {1870,0.010752381}, {1880,0.010661905}, {1890,0.012052381}, {1900,0.015242857}, {1910,0.010985714}, {1920,0.010733333}, {1930,0.011195238}, {1940,0.012457143}, {1950,0.011166667}, {1960,0.011247619}, {1970,0.013990476}, {1980,0.011380952}, {1990,0.012576190}, {2000,0.011728571}, {2050,0.011685714}, {2100,0.011942857}, {2150,0.012214286}, {2200,0.012580952}, {2250,0.012680952}, {2300,0.013076190}, {2350,0.013519048}, {2400,0.013657143}, {2450,0.013838095}, {2500,0.014176190}, {2550,0.022047619}, {2600,0.014819048}, {2650,0.014880952}, {2700,0.015233333}, {2750,0.015414286}, {2800,0.020523810}, {2850,0.018819048}, {2900,0.016109524}, {2950,0.016342857}, {3000,0.016738095}, {3050,0.017209524}, {3100,0.028452381}, {3150,0.017695238}, {3200,0.017652381}, {3250,0.024533333}, {3300,0.018366667}, {3350,0.018804762}, {3400,0.021995238}, {3450,0.024990476}, {3500,0.019519048}, {3550,0.019723810}, {3600,0.028028571}, {3650,0.019752381}, {3700,0.029119048}, {3750,0.021119048}, {3800,0.026509524}, {3850,0.022009524}, {3900,0.022066667}, {3950,0.022628571}, {4000,0.025085714}, {4050,0.034028571}, {4100,0.046409524}, {4150,0.023614286}, {4200,0.024200000}, {4250,0.024295238}, {4300,0.024585714}, {4350,0.025119048}, {4400,0.027576190}, {4450,0.030985714}, {4500,0.040895238}, {4550,0.038352381}, {4600,0.026152381}, {4650,0.026585714}, {4700,0.027128571}, {4750,0.027466667}, {4800,0.027438095}, {4850,0.027857143}, {4900,0.041023810}, {4950,0.043357143}, {5000,0.033314286}, {5050,0.036285714}, {5100,0.029395238}, {5150,0.029357143}, {5200,0.029757143}, {5250,0.039085714}, {5300,0.055909524}, {5350,0.045119048}, {5400,0.038304762}, {5450,0.031323810}, {5500,0.031438095}, {5550,0.039876190}, {5600,0.039309524}, {5650,0.032747619}, {5700,0.049476190}, {5750,0.047023810}, {5800,0.041357143}, {5850,0.034028571}, {5900,0.034104762}, {5950,0.051485714}, {6000,0.041133333}, {6050,0.034766667}, {6100,0.041723810}, {6150,0.050619048}, {6200,0.066166667}, {6250,0.042566667}, {6300,0.036623810}, {6350,0.075371429}, {6400,0.040971429}, {6450,0.066219048}, {6500,0.055571429}, {6550,0.044071429}, {6600,0.042990476}, {6650,0.049933333}, {6700,0.056776190}, {6750,0.039357143}, {6800,0.066071429}, {6850,0.040138095}, {6900,0.072676190}, {6950,0.045666667}, {7000,0.045538095}, {7050,0.049747619}, {7100,0.045709524}, {7150,0.082138095}, {7200,0.042423810}, {7250,0.070280952}, {7300,0.042733333}, {7350,0.059604762}, {7400,0.062271429}, {7450,0.054952381}, {7500,0.050347619}, {7550,0.087400000}, {7600,0.044861905}, {7650,0.060823810}, {7700,0.064604762}, {7750,0.049961905}, {7800,0.050171429}, {7850,0.069647619}, {7900,0.067190476}, {7950,0.046990476}, {8000,0.058790476}, {8050,0.079728571}, {8100,0.075938095}, {8150,0.055290476}, {8200,0.074947619}, {8250,0.054533333}, {8300,0.075247619}, {8350,0.084585714}, {8400,0.049700000}, {8450,0.054133333}, {8500,0.072519048}, {8550,0.057023810}, {8600,0.056547619}, {8650,0.071814286}, {8700,0.093904762}, {8750,0.087742857}, {8800,0.072990476}, {8850,0.080114286}, {8900,0.087790476}, {8950,0.075695238}, {9000,0.074695238}, {9050,0.053652381}, {9100,0.053657143}, {9150,0.060466667}, {9200,0.061538095}, {9250,0.097804762}, {9300,0.101552381}, {9350,0.090133333}, {9400,0.094709524}, {9450,0.080819048}, {9500,0.074485714}, {9550,0.065676190}, {9600,0.062423810}, {9650,0.068590476}, {9700,0.063023810}, {9750,0.064009524}, {9800,0.084600000}, {9850,0.097000000}, {9900,0.076471429}, {9950,0.072200000}, {10000,0.065200000}, {10100,0.093671429}, {10200,0.088509524}, {10300,0.069709524}, {10400,0.093257143}, {10500,0.102095238}, {10600,0.105395238}, {10700,0.083276190}, {10800,0.090500000}, {10900,0.078047619}, {11000,0.089500000}, {11100,0.120223810}, {11200,0.082380952}, {11300,0.106066667}, {11400,0.088485714}, {11500,0.107647619}, {11600,0.080723810}, {11700,0.126728571}, {11800,0.116904762}, {11900,0.113547619}, {12000,0.121566667}, {12100,0.084409524}, {12200,0.098357143}, {12300,0.108961905}, {12400,0.129476190}, {12500,0.089457143}, {12600,0.108085714}, {12700,0.138561905}, {12800,0.117085714}, {12900,0.097957143}, {13000,0.094161905}, {13100,0.109414286}, {13200,0.114847619}, {13300,0.110395238}, {13400,0.118990476}, {13500,0.144866667}, {13600,0.138852381}, {13700,0.122319048}, {13800,0.122995238}, {13900,0.133814286}, {14000,0.141285714}, {14100,0.118571429}, {14200,0.140180952}, {14300,0.101966667}, {14400,0.151961905}, {14500,0.115133333}, {14600,0.133052381}, {14700,0.113128571}, {14800,0.111647619}, {14900,0.134776190}, {15000,0.130314286}, {15100,0.109004762}, {15200,0.148061905}, {15300,0.156128571}, {15400,0.148138095}, {15500,0.157076190}, {15600,0.156642857}, {15700,0.176890476}, {15800,0.136771429}, {15900,0.150080952}, {16000,0.156757143}, {16100,0.193014286}, {16200,0.136233333}, {16300,0.198295238}, {16400,0.157123810}, {16500,0.164804762}, {16600,0.215185714}, {16700,0.157347619}, {16800,0.124890476}, {16900,0.178680952}, {17000,0.133171429}, {17100,0.186652381}, {17200,0.151138095}, {17300,0.201419048}, {17400,0.134409524}, {17500,0.168414286}, {17600,0.158352381}, {17700,0.165009524}, {17800,0.132357143}, {17900,0.176838095}, {18000,0.191123810}, {18100,0.154885714}, {18200,0.188509524}, {18300,0.195861905}, {18400,0.165566667}, {18500,0.183066667}, {18600,0.189990476}, {18700,0.203385714}, {18800,0.209204762}, {18900,0.156190476}, {19000,0.155466667}, {19100,0.201409524}, {19200,0.209538095}, {19300,0.198638095}, {19400,0.183119048}, {19500,0.220433333}, {19600,0.191080952}, {19700,0.194242857}, {19800,0.169333333}, {19900,0.187447619}, {20000,0.183384615}};
data["big"]["Parametricity; beta"]["reif"]["system"] = {{1,0.000113744}, {2,0.000033175}, {3,0.000000000}, {4,0.000037915}, {5,0.000018957}, {6,0.000018957}, {7,0.000000000}, {8,0.000018957}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000018957}, {13,0.000000000}, {14,0.000018957}, {15,0.000018957}, {16,0.000037915}, {17,0.000018957}, {18,0.000018957}, {19,0.000018957}, {20,0.000000000}, {21,0.000000000}, {22,0.000018957}, {23,0.000056872}, {24,0.000298578}, {25,0.000018957}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000018957}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000018957}, {38,0.000018957}, {39,0.000000000}, {40,0.000018957}, {41,0.000037915}, {42,0.000014218}, {43,0.000037915}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000037915}, {49,0.000018957}, {50,0.000018957}, {51,0.000000000}, {52,0.000000000}, {53,0.000056872}, {54,0.000037915}, {55,0.000037915}, {56,0.000000000}, {57,0.000037915}, {58,0.000000000}, {59,0.000000000}, {60,0.000018957}, {61,0.000018957}, {62,0.000018957}, {63,0.000000000}, {64,0.000018957}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000018957}, {73,0.000000000}, {74,0.000014218}, {75,0.000018957}, {76,0.000037915}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000018957}, {81,0.000000000}, {82,0.000018957}, {83,0.000018957}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000033175}, {89,0.000037915}, {90,0.000000000}, {91,0.000018957}, {92,0.000018957}, {93,0.000018957}, {94,0.000000000}, {95,0.000033175}, {96,0.000056872}, {97,0.000018957}, {98,0.000000000}, {99,0.000018957}, {100,0.000018957}, {101,0.000018957}, {102,0.000018957}, {103,0.000000000}, {104,0.000018957}, {105,0.000014218}, {106,0.000056872}, {107,0.000037915}, {108,0.000000000}, {109,0.000018957}, {110,0.000056872}, {111,0.000018957}, {112,0.000000000}, {113,0.000018957}, {114,0.000000000}, {115,0.000018957}, {116,0.000018957}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000052133}, {123,0.000018957}, {124,0.000000000}, {125,0.000018957}, {126,0.000033175}, {127,0.000033175}, {128,0.000075829}, {129,0.000018957}, {130,0.000014218}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000018957}, {135,0.000000000}, {136,0.000018957}, {137,0.000018957}, {138,0.000037915}, {139,0.000000000}, {140,0.000000000}, {141,0.000052133}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000056872}, {146,0.000018957}, {147,0.000018957}, {148,0.000000000}, {149,0.000037915}, {150,0.000018957}, {151,0.000018957}, {152,0.000000000}, {153,0.000014218}, {154,0.000018957}, {155,0.000014218}, {156,0.000037915}, {157,0.000018957}, {158,0.000018957}, {159,0.000000000}, {160,0.000000000}, {161,0.000018957}, {162,0.000014218}, {163,0.000018957}, {164,0.000000000}, {165,0.000037915}, {166,0.000000000}, {167,0.000000000}, {168,0.000018957}, {169,0.000000000}, {170,0.000037915}, {171,0.000018957}, {172,0.000018957}, {173,0.000018957}, {174,0.000018957}, {175,0.000018957}, {176,0.000037915}, {177,0.000018957}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000018957}, {183,0.000000000}, {184,0.000018957}, {185,0.000018957}, {186,0.000037915}, {187,0.000018957}, {188,0.000000000}, {189,0.000090047}, {190,0.000018957}, {191,0.000018957}, {192,0.000037915}, {193,0.000000000}, {194,0.000033175}, {195,0.000000000}, {196,0.000018957}, {197,0.000000000}, {198,0.000037915}, {199,0.000000000}, {200,0.000037915}, {201,0.000037915}, {202,0.000000000}, {203,0.000014218}, {204,0.000037915}, {205,0.000000000}, {206,0.000037915}, {207,0.000018957}, {208,0.000000000}, {209,0.000037915}, {210,0.000018957}, {211,0.000018957}, {212,0.000018957}, {213,0.000037915}, {214,0.000056872}, {215,0.000000000}, {216,0.000000000}, {217,0.000018957}, {218,0.000000000}, {219,0.000037915}, {220,0.000018957}, {221,0.000000000}, {222,0.000018957}, {223,0.000000000}, {224,0.000018957}, {225,0.000000000}, {226,0.000037915}, {227,0.000000000}, {228,0.000018957}, {229,0.000000000}, {230,0.000000000}, {231,0.000018957}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000018957}, {240,0.000037915}, {241,0.000018957}, {242,0.000018957}, {243,0.000000000}, {244,0.000000000}, {245,0.000019048}, {246,0.000019048}, {247,0.000019048}, {248,0.000038095}, {249,0.000000000}, {250,0.000000000}, {251,0.000019048}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000019048}, {256,0.000019048}, {257,0.000019048}, {258,0.000000000}, {259,0.000019048}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000038095}, {265,0.000000000}, {266,0.000038095}, {267,0.000000000}, {268,0.000033333}, {269,0.000038095}, {270,0.000000000}, {271,0.000000000}, {272,0.000019048}, {273,0.000019048}, {274,0.000038095}, {275,0.000038095}, {276,0.000038095}, {277,0.000000000}, {278,0.000038095}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000019048}, {284,0.000000000}, {285,0.000000000}, {286,0.000038095}, {287,0.000019048}, {288,0.000019048}, {289,0.000000000}, {290,0.000019048}, {291,0.000000000}, {292,0.000019048}, {293,0.000019048}, {294,0.000038095}, {295,0.000038095}, {296,0.000019048}, {297,0.000038095}, {298,0.000019048}, {299,0.000057143}, {300,0.000000000}, {301,0.000019048}, {302,0.000057143}, {303,0.000019048}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000019048}, {308,0.000019048}, {309,0.000033333}, {310,0.000019048}, {311,0.000000000}, {312,0.000057143}, {313,0.000038095}, {314,0.000019048}, {315,0.000000000}, {316,0.000038095}, {317,0.000090476}, {318,0.000000000}, {319,0.000033333}, {320,0.000052381}, {321,0.000000000}, {322,0.000000000}, {323,0.000019048}, {324,0.000019048}, {325,0.000057143}, {326,0.000019048}, {327,0.000057143}, {328,0.000038095}, {329,0.000038095}, {330,0.000019048}, {331,0.000033333}, {332,0.000000000}, {333,0.000000000}, {334,0.000038095}, {335,0.000038095}, {336,0.000033333}, {337,0.000000000}, {338,0.000019048}, {339,0.000000000}, {340,0.000019048}, {341,0.000000000}, {342,0.000000000}, {343,0.000033333}, {344,0.000019048}, {345,0.000038095}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000019048}, {351,0.000038095}, {352,0.000000000}, {353,0.000000000}, {354,0.000038095}, {355,0.000038095}, {356,0.000038095}, {357,0.000000000}, {358,0.000038095}, {359,0.000000000}, {360,0.000057143}, {361,0.000000000}, {362,0.000019048}, {363,0.000000000}, {364,0.000019048}, {365,0.000000000}, {366,0.000038095}, {367,0.000000000}, {368,0.000019048}, {369,0.000038095}, {370,0.000000000}, {371,0.000019048}, {372,0.000000000}, {373,0.000019048}, {374,0.000038095}, {375,0.000057143}, {376,0.000076190}, {377,0.000014286}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000057143}, {383,0.000038095}, {384,0.000000000}, {385,0.000019048}, {386,0.000033333}, {387,0.000000000}, {388,0.000019048}, {389,0.000038095}, {390,0.000000000}, {391,0.000019048}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000019048}, {396,0.000076190}, {397,0.000038095}, {398,0.000019048}, {399,0.000019048}, {400,0.000019048}, {401,0.000000000}, {402,0.000076190}, {403,0.000038095}, {404,0.000000000}, {405,0.000038095}, {406,0.000000000}, {407,0.000014286}, {408,0.000057143}, {409,0.000038095}, {410,0.000019048}, {411,0.000000000}, {412,0.000019048}, {413,0.000019048}, {414,0.000038095}, {415,0.000057143}, {416,0.000057143}, {417,0.000000000}, {418,0.000057143}, {419,0.000019048}, {420,0.000038095}, {421,0.000019048}, {422,0.000019048}, {423,0.000019048}, {424,0.000033333}, {425,0.000038095}, {426,0.000019048}, {427,0.000038095}, {428,0.000019048}, {429,0.000000000}, {430,0.000000000}, {431,0.000019048}, {432,0.000076190}, {433,0.000057143}, {434,0.000038095}, {435,0.000057143}, {436,0.000019048}, {437,0.000000000}, {438,0.000038095}, {439,0.000038095}, {440,0.000019048}, {441,0.000057143}, {442,0.000057143}, {443,0.000000000}, {444,0.000114286}, {445,0.000019048}, {446,0.000019048}, {447,0.000057143}, {448,0.000038095}, {449,0.000000000}, {450,0.000038095}, {451,0.000057143}, {452,0.000000000}, {453,0.000038095}, {454,0.000019048}, {455,0.000019048}, {456,0.000000000}, {457,0.000019048}, {458,0.000019048}, {459,0.000095238}, {460,0.000019048}, {461,0.000000000}, {462,0.000076190}, {463,0.000019048}, {464,0.000038095}, {465,0.000076190}, {466,0.000014286}, {467,0.000038095}, {468,0.000095238}, {469,0.000019048}, {470,0.000057143}, {471,0.000057143}, {472,0.000057143}, {473,0.000019048}, {474,0.000019048}, {475,0.000019048}, {476,0.000000000}, {477,0.000038095}, {478,0.000076190}, {479,0.000057143}, {480,0.000038095}, {481,0.000019048}, {482,0.000019048}, {483,0.000000000}, {484,0.000019048}, {485,0.000033333}, {486,0.000071429}, {487,0.000057143}, {488,0.000057143}, {489,0.000038095}, {490,0.000019048}, {491,0.000019048}, {492,0.000038095}, {493,0.000038095}, {494,0.000000000}, {495,0.000019048}, {496,0.000014286}, {497,0.000019048}, {498,0.000057143}, {499,0.000019048}, {500,0.000052381}, {505,0.000057143}, {510,0.000000000}, {515,0.000000000}, {520,0.000038095}, {525,0.000038095}, {530,0.000000000}, {535,0.000000000}, {540,0.000038095}, {545,0.000000000}, {550,0.000019048}, {555,0.000019048}, {560,0.000019048}, {565,0.000057143}, {570,0.000076190}, {575,0.000038095}, {580,0.000019048}, {585,0.000038095}, {590,0.000000000}, {595,0.000057143}, {600,0.000057143}, {605,0.000019048}, {610,0.000019048}, {615,0.000000000}, {620,0.000038095}, {625,0.000019048}, {630,0.000019048}, {635,0.000000000}, {640,0.000000000}, {645,0.000019048}, {650,0.000000000}, {655,0.000000000}, {660,0.000038095}, {665,0.000038095}, {670,0.000000000}, {675,0.000019048}, {680,0.000057143}, {685,0.000019048}, {690,0.000000000}, {695,0.000000000}, {700,0.000057143}, {705,0.000038095}, {710,0.000057143}, {715,0.000057143}, {720,0.000095238}, {725,0.000038095}, {730,0.000019048}, {735,0.000076190}, {740,0.000019048}, {745,0.000000000}, {750,0.000057143}, {755,0.000019048}, {760,0.000038095}, {765,0.000000000}, {770,0.000114286}, {775,0.000038095}, {780,0.000057143}, {785,0.000000000}, {790,0.000019048}, {795,0.000133333}, {800,0.000000000}, {805,0.000038095}, {810,0.000000000}, {815,0.000019048}, {820,0.000038095}, {825,0.000019048}, {830,0.000128571}, {835,0.000019048}, {840,0.000014286}, {845,0.000038095}, {850,0.000019048}, {855,0.000076190}, {860,0.000057143}, {865,0.000000000}, {870,0.000057143}, {875,0.000014286}, {880,0.000133333}, {885,0.000000000}, {890,0.000038095}, {895,0.000076190}, {900,0.000019048}, {905,0.000076190}, {910,0.000076190}, {915,0.000019048}, {920,0.000019048}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000038095}, {945,0.000019048}, {950,0.000019048}, {955,0.000019048}, {960,0.000019048}, {965,0.000000000}, {970,0.000038095}, {975,0.000019048}, {980,0.000000000}, {985,0.000019048}, {990,0.000052381}, {995,0.000076190}, {1000,0.000095238}, {1010,0.000057143}, {1020,0.000071429}, {1030,0.000038095}, {1040,0.000057143}, {1050,0.000095238}, {1060,0.000019048}, {1070,0.000038095}, {1080,0.000000000}, {1090,0.000038095}, {1100,0.000000000}, {1110,0.000019048}, {1120,0.000038095}, {1130,0.000109524}, {1140,0.000071429}, {1150,0.000000000}, {1160,0.000057143}, {1170,0.000019048}, {1180,0.000038095}, {1190,0.000000000}, {1200,0.000057143}, {1210,0.000057143}, {1220,0.000052381}, {1230,0.000038095}, {1240,0.000000000}, {1250,0.000052381}, {1260,0.000038095}, {1270,0.000076190}, {1280,0.000019048}, {1290,0.000076190}, {1300,0.000057143}, {1310,0.000019048}, {1320,0.000019048}, {1330,0.000000000}, {1340,0.000019048}, {1350,0.000076190}, {1360,0.000361905}, {1370,0.000038095}, {1380,0.000019048}, {1390,0.000019048}, {1400,0.000000000}, {1410,0.000057143}, {1420,0.000000000}, {1430,0.000038095}, {1440,0.000019048}, {1450,0.000076190}, {1460,0.000019048}, {1470,0.000057143}, {1480,0.000038095}, {1490,0.000019048}, {1500,0.000038095}, {1510,0.000019048}, {1520,0.000038095}, {1530,0.000019048}, {1540,0.000057143}, {1550,0.000019048}, {1560,0.000038095}, {1570,0.000133333}, {1580,0.000057143}, {1590,0.000057143}, {1600,0.000019048}, {1610,0.000038095}, {1620,0.000000000}, {1630,0.000038095}, {1640,0.000000000}, {1650,0.000057143}, {1660,0.000057143}, {1670,0.000038095}, {1680,0.000095238}, {1690,0.000000000}, {1700,0.000076190}, {1710,0.000000000}, {1720,0.000076190}, {1730,0.000357143}, {1740,0.000019048}, {1750,0.000057143}, {1760,0.000152381}, {1770,0.000000000}, {1780,0.000147619}, {1790,0.000014286}, {1800,0.000038095}, {1810,0.000266667}, {1820,0.000076190}, {1830,0.000095238}, {1840,0.000114286}, {1850,0.000057143}, {1860,0.000019048}, {1870,0.000019048}, {1880,0.000038095}, {1890,0.000095238}, {1900,0.000038095}, {1910,0.000057143}, {1920,0.000057143}, {1930,0.000038095}, {1940,0.000085714}, {1950,0.000076190}, {1960,0.000038095}, {1970,0.000114286}, {1980,0.000076190}, {1990,0.000076190}, {2000,0.000057143}, {2050,0.000033333}, {2100,0.000076190}, {2150,0.000076190}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000019048}, {2350,0.000019048}, {2400,0.000071429}, {2450,0.000019048}, {2500,0.000071429}, {2550,0.000228571}, {2600,0.000057143}, {2650,0.000076190}, {2700,0.000019048}, {2750,0.000038095}, {2800,0.000190476}, {2850,0.000057143}, {2900,0.000019048}, {2950,0.000095238}, {3000,0.000019048}, {3050,0.000000000}, {3100,0.000342857}, {3150,0.000038095}, {3200,0.000019048}, {3250,0.000161905}, {3300,0.000000000}, {3350,0.000052381}, {3400,0.000057143}, {3450,0.000133333}, {3500,0.000033333}, {3550,0.000076190}, {3600,0.000285714}, {3650,0.000057143}, {3700,0.000300000}, {3750,0.000038095}, {3800,0.000228571}, {3850,0.000019048}, {3900,0.000076190}, {3950,0.000076190}, {4000,0.000133333}, {4050,0.000476190}, {4100,0.000561905}, {4150,0.000076190}, {4200,0.000019048}, {4250,0.000019048}, {4300,0.000090476}, {4350,0.000095238}, {4400,0.000133333}, {4450,0.000347619}, {4500,0.000471429}, {4550,0.000457143}, {4600,0.000033333}, {4650,0.000095238}, {4700,0.000057143}, {4750,0.000019048}, {4800,0.000076190}, {4850,0.000019048}, {4900,0.000204762}, {4950,0.000361905}, {5000,0.000209524}, {5050,0.000209524}, {5100,0.000057143}, {5150,0.000114286}, {5200,0.000095238}, {5250,0.000223810}, {5300,0.000509524}, {5350,0.000361905}, {5400,0.000185714}, {5450,0.000038095}, {5500,0.000052381}, {5550,0.000166667}, {5600,0.000209524}, {5650,0.000133333}, {5700,0.000333333}, {5750,0.000228571}, {5800,0.000057143}, {5850,0.000038095}, {5900,0.000057143}, {5950,0.000204762}, {6000,0.000285714}, {6050,0.000142857}, {6100,0.000147619}, {6150,0.000523810}, {6200,0.000133333}, {6250,0.000057143}, {6300,0.000033333}, {6350,0.000509524}, {6400,0.000152381}, {6450,0.000114286}, {6500,0.000471429}, {6550,0.000166667}, {6600,0.000057143}, {6650,0.000300000}, {6700,0.000285714}, {6750,0.000038095}, {6800,0.000600000}, {6850,0.000000000}, {6900,0.000666667}, {6950,0.000114286}, {7000,0.000114286}, {7050,0.000266667}, {7100,0.000114286}, {7150,0.000900000}, {7200,0.000019048}, {7250,0.000800000}, {7300,0.000057143}, {7350,0.000457143}, {7400,0.000409524}, {7450,0.000304762}, {7500,0.000171429}, {7550,0.000980952}, {7600,0.000133333}, {7650,0.000528571}, {7700,0.000361905}, {7750,0.000266667}, {7800,0.000166667}, {7850,0.001000000}, {7900,0.000595238}, {7950,0.000052381}, {8000,0.000319048}, {8050,0.000571429}, {8100,0.000700000}, {8150,0.000133333}, {8200,0.000428571}, {8250,0.000142857}, {8300,0.000580952}, {8350,0.000547619}, {8400,0.000095238}, {8450,0.000204762}, {8500,0.000357143}, {8550,0.000419048}, {8600,0.000242857}, {8650,0.000323810}, {8700,0.000323810}, {8750,0.000342857}, {8800,0.000000000}, {8850,0.000109524}, {8900,0.000171429}, {8950,0.000300000}, {9000,0.000304762}, {9050,0.000057143}, {9100,0.000095238}, {9150,0.000133333}, {9200,0.000076190}, {9250,0.000361905}, {9300,0.000457143}, {9350,0.000209524}, {9400,0.000400000}, {9450,0.000076190}, {9500,0.000019048}, {9550,0.000095238}, {9600,0.000019048}, {9650,0.000171429}, {9700,0.000095238}, {9750,0.000114286}, {9800,0.000166667}, {9850,0.000090476}, {9900,0.000133333}, {9950,0.000114286}, {10000,0.000152381}, {10100,0.000209524}, {10200,0.000057143}, {10300,0.000038095}, {10400,0.000380952}, {10500,0.000190476}, {10600,0.000547619}, {10700,0.000295238}, {10800,0.000266667}, {10900,0.000076190}, {11000,0.000485714}, {11100,0.000190476}, {11200,0.000038095}, {11300,0.000057143}, {11400,0.000033333}, {11500,0.000038095}, {11600,0.000095238}, {11700,0.000038095}, {11800,0.000071429}, {11900,0.000552381}, {12000,0.000604762}, {12100,0.000371429}, {12200,0.000552381}, {12300,0.000261905}, {12400,0.000728571}, {12500,0.000190476}, {12600,0.000438095}, {12700,0.000657143}, {12800,0.000209524}, {12900,0.000285714}, {13000,0.000228571}, {13100,0.000523810}, {13200,0.000447619}, {13300,0.000452381}, {13400,0.000304762}, {13500,0.000733333}, {13600,0.000266667}, {13700,0.000185714}, {13800,0.000228571}, {13900,0.000319048}, {14000,0.000019048}, {14100,0.000057143}, {14200,0.000019048}, {14300,0.000057143}, {14400,0.000014286}, {14500,0.000038095}, {14600,0.000076190}, {14700,0.000057143}, {14800,0.000090476}, {14900,0.000090476}, {15000,0.000057143}, {15100,0.000019048}, {15200,0.000114286}, {15300,0.000038095}, {15400,0.000076190}, {15500,0.000057143}, {15600,0.000057143}, {15700,0.000109524}, {15800,0.000033333}, {15900,0.000109524}, {16000,0.000085714}, {16100,0.000114286}, {16200,0.000114286}, {16300,0.000076190}, {16400,0.000095238}, {16500,0.000095238}, {16600,0.000000000}, {16700,0.000057143}, {16800,0.000076190}, {16900,0.000076190}, {17000,0.000057143}, {17100,0.000076190}, {17200,0.000019048}, {17300,0.000014286}, {17400,0.000076190}, {17500,0.000114286}, {17600,0.000038095}, {17700,0.000038095}, {17800,0.000000000}, {17900,0.000095238}, {18000,0.000076190}, {18100,0.000038095}, {18200,0.000038095}, {18300,0.000052381}, {18400,0.000109524}, {18500,0.000057143}, {18600,0.000019048}, {18700,0.000038095}, {18800,0.000076190}, {18900,0.000019048}, {19000,0.000076190}, {19100,0.000019048}, {19200,0.000114286}, {19300,0.000152381}, {19400,0.000133333}, {19500,0.000114286}, {19600,0.000076190}, {19700,0.000090476}, {19800,0.000076190}, {19900,0.000171429}, {20000,0.000076923}};
data["big"]["Parsing"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00016379}, {6,0.00071552}, {7,0.00100000}, {8,0.00100862}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00102586}, {13,0.00165517}, {14,0.00189655}, {15,0.00200000}, {16,0.00200000}, {17,0.00200862}, {18,0.00200862}, {19,0.00216379}, {20,0.00276724}, {21,0.00300000}, {22,0.00300000}, {23,0.00300000}, {24,0.00341379}, {25,0.00399138}, {26,0.00381897}, {27,0.00400000}, {28,0.00400000}, {29,0.00400000}, {30,0.04643966}, {31,0.00400000}, {32,0.00402586}, {33,0.00496552}, {34,0.00500000}, {35,0.00500862}, {36,0.00501724}, {37,0.00539655}, {38,0.00647414}, {39,0.00600862}, {40,0.00606897}, {41,0.00693966}, {42,0.00700000}, {43,0.00700862}, {44,0.00720690}, {45,0.00799138}, {46,0.00800862}, {47,0.02368966}, {48,0.00822414}, {49,0.00929310}, {50,0.00903448}, {51,0.00968103}, {52,0.00993966}, {53,0.01003448}, {54,0.01056034}, {55,0.01203448}, {56,0.01100862}, {57,0.03189655}, {58,0.01195690}, {59,0.01212069}, {60,0.01286207}, {61,0.01300862}, {62,0.01305172}, {63,0.01362931}, {64,0.01398276}, {65,0.02893966}, {66,0.01494828}, {67,0.01527586}, {68,0.01546552}, {69,0.01615517}, {70,0.01658621}, {71,0.01693103}, {72,0.02760345}, {73,0.01775862}, {74,0.01802586}, {75,0.01869828}, {76,0.01891379}, {77,0.03437931}, {78,0.02002586}, {79,0.02000862}, {80,0.02363793}, {81,0.02174138}, {82,0.04206897}, {83,0.02243966}, {84,0.02289655}, {85,0.02361207}, {86,0.02385345}, {87,0.03440517}, {88,0.02491379}, {89,0.02532759}, {90,0.02584483}, {91,0.04040517}, {92,0.02688793}, {93,0.02713793}, {94,0.02792241}, {95,0.03797414}, {96,0.02888793}, {97,0.02979310}, {98,0.04817241}, {99,0.03073276}, {100,0.03161207}, {101,0.04655172}, {102,0.03222414}, {103,0.03300862}, {104,0.03393966}, {105,0.03962931}, {106,0.03489655}, {107,0.03569828}, {108,0.04852586}, {109,0.03697414}, {110,0.05002586}, {111,0.03809483}, {112,0.03874138}, {113,0.05308621}, {114,0.03999138}, {115,0.04611207}, {116,0.05357759}, {117,0.04202586}, {118,0.05815517}, {119,0.04297414}, {120,0.04357759}, {121,0.05036207}, {122,0.04548276}, {123,0.05425000}, {124,0.04697414}, {125,0.06701724}, {126,0.04814655}, {127,0.06799138}, {128,0.04972414}, {129,0.06942241}, {130,0.05080172}, {131,0.07197414}, {132,0.05203448}, {133,0.07444828}, {134,0.05360345}, {135,0.07416379}, {136,0.05523276}, {137,0.07307759}, {138,0.05661207}, {139,0.06725000}, {140,0.05790517}, {141,0.08779310}, {142,0.10888793}, {143,0.06069828}, {144,0.08905172}, {145,0.06221552}, {146,0.07608621}, {147,0.09384483}, {148,0.06499138}, {149,0.08151724}, {150,0.06662069}, {151,0.07774138}, {152,0.11343103}, {153,0.06859483}, {154,0.07979310}, {155,0.09928448}, {156,0.07125862}, {157,0.07964655}, {158,0.08737069}, {159,0.10489655}, {160,0.07520690}, {161,0.08588793}, {162,0.11070690}, {163,0.10554310}, {164,0.07844828}, {165,0.11143103}, {166,0.11620690}, {167,0.11592241}, {168,0.08257759}, {169,0.08700862}, {170,0.09406034}, {171,0.10294828}, {172,0.14537931}, {173,0.13128448}, {174,0.08805172}, {175,0.09647414}, {176,0.10385345}, {177,0.12375862}, {178,0.12368966}, {179,0.12924138}, {180,0.12893103}, {181,0.11861207}, {182,0.12556897}, {183,0.12691379}, {184,0.13208621}, {185,0.09939655}, {186,0.10482759}, {187,0.10521552}, {188,0.13260345}, {189,0.13331034}, {190,0.13562069}, {191,0.13793103}, {192,0.13775000}, {193,0.15653448}, {194,0.17031034}, {195,0.16329310}, {196,0.14937931}, {197,0.14436207}, {198,0.14512931}, {199,0.14765517}, {200,0.14155172}, {201,0.13616379}, {202,0.14720690}, {203,0.18070690}, {204,0.15656897}, {205,0.15644828}, {206,0.15187931}, {207,0.15373276}, {208,0.15588793}, {209,0.18001724}, {210,0.19883621}, {211,0.17704310}, {212,0.16223276}, {213,0.18609483}, {214,0.17294828}, {215,0.16350862}, {216,0.16295690}, {217,0.20098276}, {218,0.16779310}, {219,0.16575000}, {220,0.20215517}, {221,0.17107759}, {222,0.17168966}, {223,0.20416379}, {224,0.20498276}, {225,0.23233621}, {226,0.18091379}, {227,0.17514655}, {228,0.21998276}, {229,0.16861207}, {230,0.21800000}, {231,0.17994828}, {232,0.21620690}, {233,0.18384483}, {234,0.21988793}, {235,0.18876724}, {236,0.24360345}, {237,0.21575862}, {238,0.24927586}, {239,0.21581897}, {240,0.21172414}, {241,0.22820690}, {242,0.18620690}, {243,0.23551724}, {244,0.22625000}, {245,0.20531034}, {246,0.23567241}, {247,0.23156034}, {248,0.21035345}, {249,0.22000862}, {250,0.28968103}, {251,0.24512069}, {252,0.21885345}, {253,0.25187069}, {254,0.24195690}, {255,0.24037931}, {256,0.24182759}, {257,0.24379310}, {258,0.24612069}, {259,0.25325862}, {260,0.23978448}, {261,0.27772414}, {262,0.25658621}, {263,0.30446552}, {264,0.26656034}, {265,0.26255172}, {266,0.26370690}, {267,0.26610345}, {268,0.26570690}, {269,0.27495690}, {270,0.26147414}, {271,0.30000862}, {272,0.28976724}, {273,0.32273276}, {274,0.28269828}, {275,0.28731897}, {276,0.28737931}, {277,0.28916379}, {278,0.29318103}, {279,0.29880172}, {280,0.32027586}, {281,0.33312931}, {282,0.32607759}, {283,0.30154310}, {284,0.30552586}, {285,0.30957759}, {286,0.31326724}, {287,0.31780172}, {288,0.33358621}, {289,0.34433621}, {290,0.36674138}, {291,0.33893103}, {292,0.32984483}, {293,0.33474138}, {294,0.33255172}, {295,0.34025862}, {296,0.37635345}, {297,0.36848276}, {298,0.38446552}, {299,0.35470690}, {300,0.35162931}, {301,0.35156034}, {302,0.35306897}, {303,0.36061207}, {304,0.43051724}, {305,0.37981034}, {306,0.38068103}, {307,0.36963793}, {308,0.37133621}, {309,0.37210345}, {310,0.37846552}, {311,0.41542241}, {312,0.40479310}, {313,0.41432759}, {314,0.37447414}, {315,0.38815517}, {316,0.38893103}, {317,0.39517241}, {318,0.46696552}, {319,0.42437931}, {320,0.43065517}, {321,0.40849138}, {322,0.40713793}, {323,0.40893966}, {324,0.42141379}, {325,0.44181034}, {326,0.49893966}, {327,0.42818103}, {328,0.42333621}, {329,0.42644828}, {330,0.43520690}, {331,0.52037069}, {332,0.45621552}, {333,0.46043966}, {334,0.44743966}, {335,0.44531034}, {336,0.59821552}, {337,0.47893966}, {338,0.48765517}, {339,0.45749138}, {340,0.45795690}, {341,0.46181897}, {342,0.52011207}, {343,0.50100000}, {344,0.51802586}, {345,0.47411207}, {346,0.47993966}, {347,0.47961207}, {348,0.56842241}, {349,0.51955172}, {350,0.51161207}, {351,0.49366379}, {352,0.49293103}, {353,0.50147414}, {354,0.58658621}, {355,0.52748276}, {356,0.52358621}, {357,0.51057759}, {358,0.51204310}, {359,0.52670690}, {360,0.58151724}, {361,0.59718966}, {362,0.53009483}, {363,0.52621552}, {364,0.53725862}, {365,0.64332759}, {366,0.56501724}, {367,0.55523276}, {368,0.54686207}, {369,0.55095690}, {370,0.66543103}, {371,0.58725862}, {372,0.57566379}, {373,0.56227586}, {374,0.56455172}, {375,0.68571552}, {376,0.60250000}, {377,0.59040517}, {378,0.57752586}, {379,0.58660345}, {380,0.70692241}, {381,0.61939655}, {382,0.59679310}, {383,0.59057759}, {384,0.60030172}, {385,0.70950000}, {386,0.63718966}, {387,0.61837069}, {388,0.61606897}, {389,0.61839655}, {390,0.72638793}, {391,0.65411207}, {392,0.62347414}, {393,0.62461207}, {394,0.63491379}, {395,0.76786207}, {396,0.67445690}, {397,0.64368103}, {398,0.64827586}, {399,0.65306034}, {400,0.78156897}, {401,0.69831897}, {402,0.65248276}, {403,0.66241379}, {404,0.67049138}, {405,0.79116379}, {406,0.72000000}, {407,0.68036207}, {408,0.67832759}, {409,0.73330172}, {410,0.80743966}, {411,0.72334483}, {412,0.69690517}, {413,0.70263793}, {414,0.85483621}, {415,0.75069828}, {416,0.70596552}, {417,0.71092241}, {418,0.75591379}, {419,0.85040517}, {420,0.75895690}, {421,0.72612069}, {422,0.73706034}, {423,0.88468103}, {424,0.79330172}, {425,0.75481897}, {426,0.74950862}, {427,0.90346552}, {428,0.79478448}, {429,0.75959483}, {430,0.76346552}, {431,0.77306897}, {432,0.90829310}, {433,0.82555172}, {434,0.78126724}, {435,0.77904310}, {436,0.92806897}, {437,0.84236207}, {438,0.80833621}, {439,0.79717241}, {440,0.81116379}, {441,0.98537931}, {442,0.84942241}, {443,0.81491379}, {444,0.81555172}, {445,0.99207759}, {446,0.87845690}, {447,0.84063793}, {448,0.82992241}, {449,1.00599138}, {450,0.89548276}, {451,0.84661207}, {452,0.84837931}, {453,0.93685345}, {454,0.98471552}, {455,0.89302586}, {456,0.86554310}, {457,0.90068966}, {458,1.05226724}, {459,0.91553448}, {460,0.87848276}, {461,0.90520690}, {462,1.07014655}, {463,0.93393966}, {464,0.89681034}, {465,0.91997414}, {466,1.09322414}, {467,0.95885345}, {468,0.91593103}, {469,1.55359483}, {470,1.10892241}, {471,0.97508621}, {472,0.94010345}, {473,1.04424138}, {474,1.06549138}, {475,0.96917241}, {476,0.95136207}, {477,1.25598276}, {478,1.03934483}, {479,0.97814655}, {480,0.97258621}, {481,1.07418103}, {482,1.09011207}, {483,1.00189655}, {484,0.98724138}, {485,1.08092241}, {486,1.12894828}, {487,1.02448276}, {488,1.01554310}, {489,1.11826724}, {490,1.14107759}, {491,1.04342241}, {492,1.04113793}, {493,1.14325862}, {494,1.14377586}, {495,1.06670690}, {496,1.09757759}, {497,1.19381034}, {498,1.12700000}, {499,1.06385345}, {500,1.10082759}, {505,1.16967}, {510,1.17700}, {515,1.17800}, {520,1.20800}, {525,1.22600}, {530,1.22433}, {535,1.30033}, {540,1.31967}, {545,1.33567}, {550,1.31867}, {555,1.36967}, {560,1.39933}, {565,1.42567}, {570,1.40500}, {575,1.47533}, {580,1.50133}, {585,1.49667}, {590,1.45533}, {595,1.53967}, {600,1.54875}, {605,1.61233}, {610,1.61800}, {615,1.65067}, {620,1.71267}, {625,1.68700}, {630,2.28467}, {635,1.97333}, {640,1.74533}, {645,1.78200}, {650,2.37400}, {655,1.80133}, {660,1.87267}, {665,2.47533}, {670,1.96000}, {675,2.04600}, {680,2.65800}, {685,2.08100}, {690,2.10133}, {695,2.14267}, {700,2.77650}, {705,2.18733}, {710,2.23467}, {715,2.58933}, {720,2.67633}, {725,2.72833}, {730,2.40867}, {735,2.43733}, {740,2.42333}, {745,2.83600}, {750,2.84567}, {755,2.92400}, {760,2.58100}, {765,2.69667}, {770,3.16067}, {775,3.20467}, {780,2.86000}, {785,3.31933}, {790,2.98033}, {795,3.05967}, {800,3.31075}, {805,3.10533}, {810,3.11867}, {815,3.55400}, {820,3.20067}, {825,3.25133}, {830,3.24533}, {835,3.78167}, {840,3.39833}, {845,3.43233}, {850,3.50833}, {855,3.58267}, {860,3.67333}, {865,4.15167}, {870,3.66467}, {875,4.27800}, {880,3.56533}, {885,3.62167}, {890,3.77333}, {895,3.78933}, {900,4.04375}, {905,4.33067}, {910,3.97000}, {915,3.95367}, {920,3.95600}, {925,3.94867}, {930,4.54800}, {935,4.05167}, {940,4.09067}, {945,4.16933}, {950,4.35500}, {955,4.38867}, {960,5.26067}, {965,4.48233}, {970,4.55467}, {975,4.61067}, {980,4.66233}, {985,5.65967}, {990,4.73833}, {995,4.75567}, {1000,4.84900}, {1010,4.92233}, {1020,5.04833}, {1030,5.21833}, {1040,5.31433}, {1050,5.44767}, {1060,5.53200}, {1070,6.53467}, {1080,5.64000}, {1090,6.72933}, {1100,5.92367}, {1110,6.16433}, {1120,6.16600}, {1130,6.21333}, {1140,6.28300}, {1150,7.57267}, {1160,6.58500}, {1170,7.82600}, {1180,6.91300}, {1190,7.02233}, {1200,7.13900}, {1210,7.26233}, {1220,7.41400}, {1230,7.46533}, {1240,7.72100}, {1250,7.77333}, {1260,8.00400}, {1270,8.08267}, {1280,8.22167}, {1290,9.63033}, {1300,9.72133}, {1310,10.03933}, {1320,8.67200}, {1330,10.27067}, {1340,10.52667}, {1350,10.64600}, {1360,10.68867}, {1370,9.60367}, {1380,9.63967}, {1390,9.80400}, {1400,10.33633}, {1410,10.17600}, {1420,12.08333}, {1430,12.03267}, {1440,12.31133}, {1450,12.20100}, {1460,12.20533}, {1470,14.22067}, {1480,11.21133}, {1490,11.66433}, {1500,13.91525}, {1510,11.76800}, {1520,11.99533}, {1530,13.55133}, {1540,15.50300}, {1550,14.19967}, {1560,12.66767}, {1570,15.51933}, {1580,12.42867}, {1590,14.15633}, {1600,15.86133}, {1610,14.72400}, {1620,14.61067}, {1630,16.74633}, {1640,16.88300}, {1650,16.82033}, {1660,18.53967}, {1670,19.26667}, {1680,17.37967}, {1690,16.75467}, {1700,16.05100}, {1710,18.43867}, {1720,14.60000}, {1730,16.72767}, {1740,17.30733}, {1750,17.65000}, {1760,16.81333}, {1770,19.01633}, {1780,21.70167}, {1790,18.14800}, {1800,18.43133}, {1810,17.78500}, {1820,18.83133}, {1830,20.47700}, {1840,20.94733}, {1850,23.24467}, {1860,21.80667}, {1870,22.33200}, {1880,23.96033}, {1890,20.36500}, {1900,21.93000}, {1910,23.67933}, {1920,21.85500}, {1930,24.82067}, {1940,18.65333}, {1950,22.25867}, {1960,22.75333}, {1970,23.19667}, {1980,25.25867}, {1990,21.00633}, {2000,25.92825}, {2050,29.03900}, {2100,27.13533}, {2150,28.06567}, {2200,28.41233}, {2250,32.33933}, {2300,33.50633}, {2350,35.11900}, {2400,36.73300}, {2450,43.15733}, {2500,39.10450}, {2550,43.93633}, {2600,42.73400}, {2650,45.39667}, {2700,45.19633}, {2750,52.12967}, {2800,52.59700}, {2850,56.88600}, {2900,58.95167}, {2950,61.93633}, {3000,63.46225}, {3050,66.17433}, {3100,68.71767}, {3150,65.34767}, {3200,65.45767}, {3250,68.79500}, {3300,66.97367}, {3350,73.11267}, {3400,76.03800}, {3450,73.97900}, {3500,81.82600}, {3550,89.81367}, {3600,91.38833}, {3650,87.02433}, {3700,91.82533}, {3750,93.77200}, {3800,106.21667}, {3850,99.64867}, {3900,102.3630}, {3950,99.7130}, {4000,110.80600}, {4050,110.5535}, {4100,111.5150}, {4150,134.291}, {4500,140.227}};
data["big"]["Parsing"]["actual reif"]["user"] = {{1,0.00012931}, {2,0.00023276}, {3,0.00041379}, {4,0.00062069}, {5,0.00054310}, {6,0.00097414}, {7,0.00090517}, {8,0.00120690}, {9,0.00124138}, {10,0.00128448}, {11,0.00156897}, {12,0.00162931}, {13,0.00150862}, {14,0.00211207}, {15,0.00198276}, {16,0.00191379}, {17,0.00222414}, {18,0.00260345}, {19,0.00242241}, {20,0.00225862}, {21,0.00269828}, {22,0.00288793}, {23,0.00300000}, {24,0.00355172}, {25,0.00343966}, {26,0.00352586}, {27,0.00352586}, {28,0.00374138}, {29,0.00413793}, {30,0.04378448}, {31,0.00437069}, {32,0.00454310}, {33,0.00539655}, {34,0.00503448}, {35,0.00548276}, {36,0.00550000}, {37,0.00622414}, {38,0.00658621}, {39,0.00601724}, {40,0.00671552}, {41,0.00714655}, {42,0.00740517}, {43,0.00762069}, {44,0.00775862}, {45,0.00820690}, {46,0.00841379}, {47,0.02350862}, {48,0.00862069}, {49,0.00985345}, {50,0.00950862}, {51,0.01014655}, {52,0.01024138}, {53,0.01040517}, {54,0.01050000}, {55,0.01239655}, {56,0.01120690}, {57,0.03184483}, {58,0.01241379}, {59,0.01289655}, {60,0.01300000}, {61,0.01354310}, {62,0.01337069}, {63,0.01418103}, {64,0.01431034}, {65,0.02913793}, {66,0.01541379}, {67,0.01587069}, {68,0.01588793}, {69,0.01610345}, {70,0.01668966}, {71,0.01744828}, {72,0.02755172}, {73,0.01817241}, {74,0.01812069}, {75,0.01864655}, {76,0.01912931}, {77,0.03436207}, {78,0.02033621}, {79,0.02055172}, {80,0.02393103}, {81,0.02200000}, {82,0.04195690}, {83,0.02245690}, {84,0.02296552}, {85,0.02358621}, {86,0.02423276}, {87,0.03468966}, {88,0.02524138}, {89,0.02600000}, {90,0.02602586}, {91,0.03999138}, {92,0.02714655}, {93,0.02773276}, {94,0.02862069}, {95,0.03806897}, {96,0.02893103}, {97,0.03041379}, {98,0.04806897}, {99,0.03068966}, {100,0.03180172}, {101,0.04592241}, {102,0.03274138}, {103,0.03320690}, {104,0.03337931}, {105,0.03987931}, {106,0.03506897}, {107,0.03593966}, {108,0.04855172}, {109,0.03768966}, {110,0.05031034}, {111,0.03817241}, {112,0.03906897}, {113,0.05289655}, {114,0.03992241}, {115,0.04616379}, {116,0.05356034}, {117,0.04251724}, {118,0.05810345}, {119,0.04351724}, {120,0.04406897}, {121,0.05079310}, {122,0.04609483}, {123,0.05404310}, {124,0.04720690}, {125,0.06656034}, {126,0.04856034}, {127,0.06797414}, {128,0.05002586}, {129,0.06962069}, {130,0.05137069}, {131,0.07158621}, {132,0.05219828}, {133,0.07380172}, {134,0.05375000}, {135,0.07424138}, {136,0.05569828}, {137,0.07319828}, {138,0.05696552}, {139,0.06687931}, {140,0.05801724}, {141,0.08731897}, {142,0.10852586}, {143,0.06079310}, {144,0.08884483}, {145,0.06262069}, {146,0.07591379}, {147,0.09341379}, {148,0.06485345}, {149,0.08090517}, {150,0.06652586}, {151,0.07794828}, {152,0.11261207}, {153,0.06829310}, {154,0.08005172}, {155,0.09801724}, {156,0.07144828}, {157,0.07947414}, {158,0.08721552}, {159,0.10422414}, {160,0.07513793}, {161,0.08585345}, {162,0.10995690}, {163,0.10487069}, {164,0.07829310}, {165,0.11095690}, {166,0.11580172}, {167,0.11589655}, {168,0.08260345}, {169,0.08721552}, {170,0.09434483}, {171,0.10286207}, {172,0.14530172}, {173,0.13126724}, {174,0.08814655}, {175,0.09633621}, {176,0.10378448}, {177,0.12367241}, {178,0.12400862}, {179,0.12851724}, {180,0.12814655}, {181,0.11798276}, {182,0.12497414}, {183,0.12590517}, {184,0.13131034}, {185,0.09944828}, {186,0.10500862}, {187,0.10515517}, {188,0.13254310}, {189,0.13326724}, {190,0.13532759}, {191,0.13793103}, {192,0.13772414}, {193,0.15695690}, {194,0.17056897}, {195,0.16288793}, {196,0.14941379}, {197,0.14419828}, {198,0.14496552}, {199,0.14738793}, {200,0.14088793}, {201,0.13522414}, {202,0.14680172}, {203,0.17884483}, {204,0.15539655}, {205,0.15565517}, {206,0.15196552}, {207,0.15373276}, {208,0.15592241}, {209,0.17980172}, {210,0.19880172}, {211,0.17676724}, {212,0.16181034}, {213,0.18636207}, {214,0.17275862}, {215,0.16350000}, {216,0.16235345}, {217,0.20106897}, {218,0.16775862}, {219,0.16562069}, {220,0.20237069}, {221,0.17099138}, {222,0.17187069}, {223,0.20451724}, {224,0.20501724}, {225,0.23212069}, {226,0.18096552}, {227,0.17523276}, {228,0.22001724}, {229,0.16881034}, {230,0.21819828}, {231,0.17948276}, {232,0.21612931}, {233,0.18346552}, {234,0.21997414}, {235,0.18901724}, {236,0.24344828}, {237,0.21538793}, {238,0.24954310}, {239,0.21553448}, {240,0.21138793}, {241,0.22717241}, {242,0.18527586}, {243,0.23360345}, {244,0.22418966}, {245,0.20420690}, {246,0.23524138}, {247,0.23122414}, {248,0.20991379}, {249,0.21986207}, {250,0.28964655}, {251,0.24500862}, {252,0.21850000}, {253,0.25190517}, {254,0.24187931}, {255,0.23986207}, {256,0.24155172}, {257,0.24362069}, {258,0.24582759}, {259,0.25322414}, {260,0.23950000}, {261,0.27738793}, {262,0.25616379}, {263,0.30441379}, {264,0.26638793}, {265,0.26222414}, {266,0.26388793}, {267,0.26597414}, {268,0.26543966}, {269,0.27462931}, {270,0.26143103}, {271,0.29964655}, {272,0.28933621}, {273,0.32237069}, {274,0.28133621}, {275,0.28496552}, {276,0.28492241}, {277,0.28687069}, {278,0.29262931}, {279,0.29817241}, {280,0.31978448}, {281,0.33268103}, {282,0.32542241}, {283,0.29987931}, {284,0.30418103}, {285,0.30908621}, {286,0.31275862}, {287,0.31662069}, {288,0.33239655}, {289,0.34323276}, {290,0.36557759}, {291,0.33868966}, {292,0.32937931}, {293,0.33404310}, {294,0.33250000}, {295,0.33956034}, {296,0.37583621}, {297,0.36775862}, {298,0.38403448}, {299,0.35426724}, {300,0.35163793}, {301,0.35122414}, {302,0.35300862}, {303,0.36024138}, {304,0.43029310}, {305,0.37984483}, {306,0.38050000}, {307,0.36918966}, {308,0.37131034}, {309,0.37191379}, {310,0.37846552}, {311,0.41510345}, {312,0.40450000}, {313,0.41403448}, {314,0.37429310}, {315,0.38806034}, {316,0.38891379}, {317,0.39461207}, {318,0.46639655}, {319,0.42418966}, {320,0.42992241}, {321,0.40813793}, {322,0.40684483}, {323,0.40874138}, {324,0.42111207}, {325,0.44197414}, {326,0.49898276}, {327,0.42761207}, {328,0.42318966}, {329,0.42606034}, {330,0.43513793}, {331,0.52015517}, {332,0.45601724}, {333,0.45818103}, {334,0.44327586}, {335,0.44250862}, {336,0.59724138}, {337,0.47830172}, {338,0.48753448}, {339,0.45718966}, {340,0.45762069}, {341,0.46168103}, {342,0.51988793}, {343,0.50107759}, {344,0.51789655}, {345,0.47384483}, {346,0.47967241}, {347,0.47946552}, {348,0.56838793}, {349,0.51927586}, {350,0.51123276}, {351,0.49343103}, {352,0.49265517}, {353,0.50156897}, {354,0.58606034}, {355,0.52745690}, {356,0.52309483}, {357,0.51049138}, {358,0.51193103}, {359,0.52612931}, {360,0.58125000}, {361,0.59686207}, {362,0.52970690}, {363,0.52619828}, {364,0.53710345}, {365,0.64320690}, {366,0.56485345}, {367,0.55489655}, {368,0.54640517}, {369,0.55080172}, {370,0.66525862}, {371,0.58667241}, {372,0.57557759}, {373,0.56208621}, {374,0.56425862}, {375,0.68542241}, {376,0.60229310}, {377,0.58992241}, {378,0.57711207}, {379,0.58624138}, {380,0.70660345}, {381,0.61935345}, {382,0.59651724}, {383,0.59012931}, {384,0.59946552}, {385,0.70929310}, {386,0.63686207}, {387,0.61312069}, {388,0.60964655}, {389,0.61750862}, {390,0.72578448}, {391,0.65387069}, {392,0.62325000}, {393,0.62412931}, {394,0.63466379}, {395,0.76745690}, {396,0.67447414}, {397,0.64343103}, {398,0.64798276}, {399,0.65284483}, {400,0.78135345}, {401,0.69787069}, {402,0.65223276}, {403,0.66180172}, {404,0.67009483}, {405,0.79097414}, {406,0.71975862}, {407,0.67993966}, {408,0.67811207}, {409,0.73293966}, {410,0.80694828}, {411,0.72287069}, {412,0.69631034}, {413,0.70226724}, {414,0.85464655}, {415,0.75025862}, {416,0.70599138}, {417,0.71025862}, {418,0.75578448}, {419,0.85015517}, {420,0.75850862}, {421,0.72575862}, {422,0.73661207}, {423,0.88448276}, {424,0.79261207}, {425,0.74821552}, {426,0.74419828}, {427,0.90283621}, {428,0.79435345}, {429,0.75963793}, {430,0.76312069}, {431,0.77270690}, {432,0.90788793}, {433,0.82503448}, {434,0.78086207}, {435,0.77867241}, {436,0.92756034}, {437,0.84196552}, {438,0.80781034}, {439,0.79662069}, {440,0.81105172}, {441,0.98497414}, {442,0.84912931}, {443,0.81472414}, {444,0.81512069}, {445,0.99168966}, {446,0.87801724}, {447,0.84040517}, {448,0.82961207}, {449,1.00559483}, {450,0.89529310}, {451,0.84625000}, {452,0.84785345}, {453,0.93605172}, {454,0.98412931}, {455,0.89278448}, {456,0.86513793}, {457,0.90029310}, {458,1.05181897}, {459,0.91506897}, {460,0.87821552}, {461,0.90468103}, {462,1.06972414}, {463,0.93375000}, {464,0.89629310}, {465,0.91962931}, {466,1.09294828}, {467,0.95715517}, {468,0.91217241}, {469,1.55218966}, {470,1.10848276}, {471,0.97125862}, {472,0.93381034}, {473,1.04341379}, {474,1.06481897}, {475,0.96872414}, {476,0.95076724}, {477,1.25527586}, {478,1.03893966}, {479,0.97767241}, {480,0.97226724}, {481,1.07362931}, {482,1.08996552}, {483,1.00140517}, {484,0.98706897}, {485,1.08044828}, {486,1.12839655}, {487,1.02395690}, {488,1.01520690}, {489,1.11760345}, {490,1.14065517}, {491,1.04325000}, {492,1.04107759}, {493,1.14260345}, {494,1.14343966}, {495,1.06447414}, {496,1.09522414}, {497,1.19342241}, {498,1.12615517}, {499,1.06350000}, {500,1.10050000}, {505,1.14500}, {510,1.16400}, {515,1.17800}, {520,1.20633}, {525,1.22467}, {530,1.22133}, {535,1.29233}, {540,1.32000}, {545,1.33400}, {550,1.31800}, {555,1.37033}, {560,1.39800}, {565,1.42200}, {570,1.40367}, {575,1.47667}, {580,1.50067}, {585,1.49533}, {590,1.45700}, {595,1.53800}, {600,1.54975}, {605,1.61167}, {610,1.61867}, {615,1.65000}, {620,1.69633}, {625,1.68367}, {630,2.28200}, {635,1.97367}, {640,1.74100}, {645,1.77533}, {650,2.37467}, {655,1.80167}, {660,1.85833}, {665,2.47367}, {670,1.95133}, {675,2.03167}, {680,2.65400}, {685,2.07133}, {690,2.08867}, {695,2.13967}, {700,2.77550}, {705,2.18633}, {710,2.22233}, {715,2.58700}, {720,2.66900}, {725,2.72267}, {730,2.40267}, {735,2.42067}, {740,2.41733}, {745,2.82733}, {750,2.84233}, {755,2.91633}, {760,2.56467}, {765,2.69600}, {770,3.15533}, {775,3.19800}, {780,2.84700}, {785,3.31567}, {790,2.97033}, {795,3.05600}, {800,3.30625}, {805,3.09733}, {810,3.11367}, {815,3.55033}, {820,3.19833}, {825,3.25033}, {830,3.24367}, {835,3.78267}, {840,3.39267}, {845,3.42867}, {850,3.50600}, {855,3.57400}, {860,3.67333}, {865,4.14833}, {870,3.64333}, {875,4.27433}, {880,3.56667}, {885,3.62167}, {890,3.75700}, {895,3.78300}, {900,4.04175}, {905,4.31800}, {910,3.95800}, {915,3.95600}, {920,3.94967}, {925,3.94600}, {930,4.54733}, {935,4.04367}, {940,4.08900}, {945,4.16733}, {950,4.35433}, {955,4.38467}, {960,5.25433}, {965,4.48333}, {970,4.55433}, {975,4.61000}, {980,4.65967}, {985,5.65400}, {990,4.73833}, {995,4.75533}, {1000,4.84650}, {1010,4.92100}, {1020,5.04700}, {1030,5.21867}, {1040,5.30433}, {1050,5.44767}, {1060,5.53200}, {1070,6.52567}, {1080,5.63933}, {1090,6.73033}, {1100,5.92167}, {1110,6.16500}, {1120,6.14833}, {1130,6.21167}, {1140,6.28200}, {1150,7.57100}, {1160,6.57600}, {1170,7.82733}, {1180,6.91067}, {1190,7.01667}, {1200,7.13833}, {1210,7.25933}, {1220,7.41333}, {1230,7.46667}, {1240,7.71800}, {1250,7.77167}, {1260,7.99133}, {1270,8.07133}, {1280,8.21133}, {1290,9.63133}, {1300,9.72000}, {1310,10.03633}, {1320,8.66067}, {1330,10.26900}, {1340,10.52367}, {1350,10.63667}, {1360,10.68900}, {1370,9.60233}, {1380,9.63333}, {1390,9.80167}, {1400,10.33600}, {1410,10.14233}, {1420,12.08333}, {1430,12.02833}, {1440,12.30800}, {1450,12.19000}, {1460,12.20067}, {1470,14.20067}, {1480,11.20900}, {1490,11.65667}, {1500,13.86175}, {1510,11.74733}, {1520,11.97967}, {1530,13.54900}, {1540,15.50200}, {1550,14.19833}, {1560,12.65300}, {1570,15.49167}, {1580,12.41167}, {1590,14.13433}, {1600,15.84767}, {1610,14.70867}, {1620,14.59433}, {1630,16.73167}, {1640,16.88233}, {1650,16.81967}, {1660,18.53933}, {1670,19.26367}, {1680,17.37767}, {1690,16.73033}, {1700,16.00500}, {1710,18.41233}, {1720,14.56100}, {1730,16.71200}, {1740,17.30067}, {1750,17.64633}, {1760,16.81400}, {1770,18.99567}, {1780,21.70100}, {1790,18.12067}, {1800,18.42367}, {1810,17.77967}, {1820,18.79067}, {1830,20.46833}, {1840,20.93967}, {1850,23.24233}, {1860,21.76967}, {1870,22.31333}, {1880,23.94367}, {1890,20.32467}, {1900,21.92600}, {1910,23.67733}, {1920,21.82567}, {1930,24.81433}, {1940,18.60133}, {1950,22.22200}, {1960,22.69800}, {1970,23.12100}, {1980,25.20200}, {1990,20.98467}, {2000,25.86175}, {2050,28.98600}, {2100,27.13267}, {2150,28.01333}, {2200,28.35300}, {2250,32.26233}, {2300,33.50500}, {2350,35.02933}, {2400,36.69500}, {2450,43.04467}, {2500,39.03950}, {2550,43.93000}, {2600,42.65967}, {2650,45.38333}, {2700,45.09100}, {2750,51.99667}, {2800,52.56100}, {2850,56.81267}, {2900,58.92667}, {2950,61.86633}, {3000,63.34550}, {3050,66.13400}, {3100,68.65000}, {3150,65.34267}, {3200,65.41233}, {3250,68.71300}, {3300,66.93667}, {3350,72.99567}, {3400,75.96867}, {3450,73.90867}, {3500,81.63650}, {3550,89.64267}, {3600,91.34500}, {3650,87.02100}, {3700,91.68633}, {3750,93.62800}, {3800,106.05033}, {3850,99.60467}, {3900,102.2180}, {3950,99.5255}, {4000,110.51567}, {4050,110.4440}, {4100,111.3010}, {4150,134.048}, {4500,139.88}};
data["big"]["Parsing"]["actual reif"]["system"] = {{1,0.00018103}, {2,0.00041379}, {3,0.00031897}, {4,0.00009483}, {5,0.00012069}, {6,0.00009483}, {7,0.00016379}, {8,0.00012069}, {9,0.00010345}, {10,0.00008621}, {11,0.00006897}, {12,0.00021552}, {13,0.00048276}, {14,0.00023276}, {15,0.00035345}, {16,0.00018966}, {17,0.00034483}, {18,0.00020690}, {19,0.00038793}, {20,0.00044828}, {21,0.00035345}, {22,0.00027586}, {23,0.00037069}, {24,0.00041379}, {25,0.00077586}, {26,0.00055172}, {27,0.00047414}, {28,0.00069828}, {29,0.00083621}, {30,0.00223276}, {31,0.00010345}, {32,0.00016379}, {33,0.00002586}, {34,0.00000000}, {35,0.00002586}, {36,0.00003448}, {37,0.00000000}, {38,0.00003448}, {39,0.00012069}, {40,0.00000000}, {41,0.00003448}, {42,0.00003448}, {43,0.00006034}, {44,0.00003448}, {45,0.00002586}, {46,0.00000000}, {47,0.00020690}, {48,0.00002586}, {49,0.00012931}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00003448}, {55,0.00003448}, {56,0.00000000}, {57,0.00025000}, {58,0.00008621}, {59,0.00003448}, {60,0.00006034}, {61,0.00003448}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00026724}, {66,0.00006897}, {67,0.00000000}, {68,0.00000000}, {69,0.00002586}, {70,0.00003448}, {71,0.00006034}, {72,0.00006897}, {73,0.00012931}, {74,0.00003448}, {75,0.00006034}, {76,0.00003448}, {77,0.00021552}, {78,0.00010345}, {79,0.00010345}, {80,0.00008621}, {81,0.00013793}, {82,0.00022414}, {83,0.00002586}, {84,0.00005172}, {85,0.00006034}, {86,0.00000000}, {87,0.00020690}, {88,0.00010345}, {89,0.00006034}, {90,0.00002586}, {91,0.00012931}, {92,0.00000000}, {93,0.00006897}, {94,0.00013793}, {95,0.00027586}, {96,0.00010345}, {97,0.00006034}, {98,0.00043103}, {99,0.00012931}, {100,0.00003448}, {101,0.00021552}, {102,0.00009483}, {103,0.00002586}, {104,0.00013793}, {105,0.00006034}, {106,0.00000000}, {107,0.00002586}, {108,0.00026724}, {109,0.00008621}, {110,0.00013793}, {111,0.00006897}, {112,0.00006897}, {113,0.00050862}, {114,0.00006897}, {115,0.00013793}, {116,0.00033621}, {117,0.00018103}, {118,0.00056897}, {119,0.00000000}, {120,0.00009483}, {121,0.00012069}, {122,0.00012069}, {123,0.00023276}, {124,0.00012069}, {125,0.00027586}, {126,0.00017241}, {127,0.00033621}, {128,0.00000000}, {129,0.00037069}, {130,0.00006897}, {131,0.00062069}, {132,0.00024138}, {133,0.00056897}, {134,0.00018966}, {135,0.00036207}, {136,0.00006897}, {137,0.00050862}, {138,0.00009483}, {139,0.00044828}, {140,0.00008621}, {141,0.00076724}, {142,0.00055172}, {143,0.00027586}, {144,0.00037931}, {145,0.00006897}, {146,0.00013793}, {147,0.00084483}, {148,0.00033621}, {149,0.00049138}, {150,0.00015517}, {151,0.00012931}, {152,0.00077586}, {153,0.00016379}, {154,0.00032759}, {155,0.00097414}, {156,0.00018966}, {157,0.00042241}, {158,0.00060345}, {159,0.00078448}, {160,0.00031034}, {161,0.00028448}, {162,0.00073276}, {163,0.00069828}, {164,0.00024138}, {165,0.00058621}, {166,0.00006897}, {167,0.00012931}, {168,0.00009483}, {169,0.00006034}, {170,0.00003448}, {171,0.00006897}, {172,0.00009483}, {173,0.00016379}, {174,0.00012069}, {175,0.00023276}, {176,0.00003448}, {177,0.00006034}, {178,0.00008621}, {179,0.00077586}, {180,0.00064655}, {181,0.00100862}, {182,0.00090517}, {183,0.00087931}, {184,0.00068966}, {185,0.00006897}, {186,0.00022414}, {187,0.00003448}, {188,0.00006897}, {189,0.00013793}, {190,0.00016379}, {191,0.00012069}, {192,0.00010345}, {193,0.00010345}, {194,0.00012069}, {195,0.00009483}, {196,0.00009483}, {197,0.00010345}, {198,0.00002586}, {199,0.00016379}, {200,0.00087069}, {201,0.00076724}, {202,0.00061207}, {203,0.00145690}, {204,0.00096552}, {205,0.00100000}, {206,0.00016379}, {207,0.00009483}, {208,0.00012931}, {209,0.00010345}, {210,0.00009483}, {211,0.00006897}, {212,0.00002586}, {213,0.00010345}, {214,0.00003448}, {215,0.00003448}, {216,0.00009483}, {217,0.00010345}, {218,0.00002586}, {219,0.00003448}, {220,0.00003448}, {221,0.00012069}, {222,0.00000000}, {223,0.00002586}, {224,0.00009483}, {225,0.00016379}, {226,0.00010345}, {227,0.00000000}, {228,0.00013793}, {229,0.00006897}, {230,0.00017241}, {231,0.00003448}, {232,0.00003448}, {233,0.00031034}, {234,0.00002586}, {235,0.00006034}, {236,0.00016379}, {237,0.00012931}, {238,0.00013793}, {239,0.00018966}, {240,0.00000000}, {241,0.00063793}, {242,0.00087069}, {243,0.00182759}, {244,0.00209483}, {245,0.00094828}, {246,0.00062931}, {247,0.00012931}, {248,0.00026724}, {249,0.00020690}, {250,0.00027586}, {251,0.00023276}, {252,0.00006034}, {253,0.00020690}, {254,0.00010345}, {255,0.00010345}, {256,0.00017241}, {257,0.00006034}, {258,0.00012931}, {259,0.00006897}, {260,0.00017241}, {261,0.00019828}, {262,0.00019828}, {263,0.00009483}, {264,0.00006897}, {265,0.00017241}, {266,0.00009483}, {267,0.00013793}, {268,0.00010345}, {269,0.00006897}, {270,0.00003448}, {271,0.00010345}, {272,0.00018966}, {273,0.00029310}, {274,0.00145690}, {275,0.00236207}, {276,0.00268103}, {277,0.00210345}, {278,0.00065517}, {279,0.00036207}, {280,0.00043966}, {281,0.00030172}, {282,0.00069828}, {283,0.00135345}, {284,0.00118103}, {285,0.00091379}, {286,0.00050000}, {287,0.00113793}, {288,0.00067241}, {289,0.00103448}, {290,0.00089655}, {291,0.00018966}, {292,0.00023276}, {293,0.00063793}, {294,0.00044828}, {295,0.00052586}, {296,0.00026724}, {297,0.00036207}, {298,0.00006897}, {299,0.00012069}, {300,0.00020690}, {301,0.00020690}, {302,0.00023276}, {303,0.00017241}, {304,0.00020690}, {305,0.00006897}, {306,0.00006034}, {307,0.00017241}, {308,0.00010345}, {309,0.00009483}, {310,0.00023276}, {311,0.00013793}, {312,0.00024138}, {313,0.00022414}, {314,0.00020690}, {315,0.00012931}, {316,0.00020690}, {317,0.00026724}, {318,0.00019828}, {319,0.00006897}, {320,0.00027586}, {321,0.00016379}, {322,0.00024138}, {323,0.00018966}, {324,0.00027586}, {325,0.00017241}, {326,0.00027586}, {327,0.00019828}, {328,0.00010345}, {329,0.00017241}, {330,0.00012931}, {331,0.00012931}, {332,0.00010345}, {333,0.00212931}, {334,0.00406897}, {335,0.00276724}, {336,0.00087069}, {337,0.00026724}, {338,0.00010345}, {339,0.00027586}, {340,0.00032759}, {341,0.00012069}, {342,0.00031034}, {343,0.00009483}, {344,0.00006897}, {345,0.00023276}, {346,0.00017241}, {347,0.00006897}, {348,0.00020690}, {349,0.00017241}, {350,0.00012931}, {351,0.00010345}, {352,0.00017241}, {353,0.00026724}, {354,0.00032759}, {355,0.00014655}, {356,0.00039655}, {357,0.00016379}, {358,0.00020690}, {359,0.00013793}, {360,0.00017241}, {361,0.00013793}, {362,0.00013793}, {363,0.00013793}, {364,0.00033621}, {365,0.00016379}, {366,0.00019828}, {367,0.00003448}, {368,0.00019828}, {369,0.00010345}, {370,0.00023276}, {371,0.00013793}, {372,0.00009483}, {373,0.00012931}, {374,0.00019828}, {375,0.00028448}, {376,0.00020690}, {377,0.00015517}, {378,0.00027586}, {379,0.00026724}, {380,0.00016379}, {381,0.00031897}, {382,0.00024138}, {383,0.00036207}, {384,0.00041379}, {385,0.00030172}, {386,0.00027586}, {387,0.00506034}, {388,0.00624138}, {389,0.00093103}, {390,0.00029310}, {391,0.00030172}, {392,0.00022414}, {393,0.00024138}, {394,0.00020690}, {395,0.00032759}, {396,0.00016379}, {397,0.00031034}, {398,0.00017241}, {399,0.00018103}, {400,0.00034483}, {401,0.00041379}, {402,0.00017241}, {403,0.00050862}, {404,0.00034483}, {405,0.00002586}, {406,0.00020690}, {407,0.00019828}, {408,0.00020690}, {409,0.00012931}, {410,0.00027586}, {411,0.00026724}, {412,0.00030172}, {413,0.00019828}, {414,0.00017241}, {415,0.00031034}, {416,0.00019828}, {417,0.00034483}, {418,0.00026724}, {419,0.00020690}, {420,0.00036207}, {421,0.00027586}, {422,0.00033621}, {423,0.00033621}, {424,0.00056897}, {425,0.00631034}, {426,0.00519828}, {427,0.00041379}, {428,0.00037069}, {429,0.00019828}, {430,0.00020690}, {431,0.00015517}, {432,0.00024138}, {433,0.00018966}, {434,0.00048276}, {435,0.00047414}, {436,0.00019828}, {437,0.00037069}, {438,0.00003448}, {439,0.00026724}, {440,0.00012931}, {441,0.00027586}, {442,0.00012931}, {443,0.00020690}, {444,0.00024138}, {445,0.00022414}, {446,0.00017241}, {447,0.00026724}, {448,0.00020690}, {449,0.00026724}, {450,0.00034483}, {451,0.00010345}, {452,0.00017241}, {453,0.00039655}, {454,0.00030172}, {455,0.00036207}, {456,0.00031034}, {457,0.00030172}, {458,0.00041379}, {459,0.00030172}, {460,0.00017241}, {461,0.00020690}, {462,0.00020690}, {463,0.00030172}, {464,0.00017241}, {465,0.00031034}, {466,0.00030172}, {467,0.00124138}, {468,0.00360345}, {469,0.00136207}, {470,0.00042241}, {471,0.00337931}, {472,0.00596552}, {473,0.00074138}, {474,0.00042241}, {475,0.00019828}, {476,0.00034483}, {477,0.00062931}, {478,0.00034483}, {479,0.00024138}, {480,0.00037931}, {481,0.00037069}, {482,0.00037931}, {483,0.00023276}, {484,0.00006897}, {485,0.00031034}, {486,0.00020690}, {487,0.00019828}, {488,0.00048276}, {489,0.00034483}, {490,0.00030172}, {491,0.00019828}, {492,0.00006897}, {493,0.00032759}, {494,0.00031034}, {495,0.00197414}, {496,0.00225000}, {497,0.00034483}, {498,0.00031897}, {499,0.00020690}, {500,0.00023276}, {505,0.02367}, {510,0.01433}, {515,0.00000}, {520,0.00133}, {525,0.00133}, {530,0.00233}, {535,0.00667}, {540,0.00133}, {545,0.00000}, {550,0.00000}, {555,0.00000}, {560,0.00100}, {565,0.00267}, {570,0.00133}, {575,0.00000}, {580,0.00000}, {585,0.00000}, {590,0.00000}, {595,0.00000}, {600,0.00000}, {605,0.00133}, {610,0.00000}, {615,0.00000}, {620,0.01600}, {625,0.00400}, {630,0.00233}, {635,0.00000}, {640,0.00500}, {645,0.00667}, {650,0.00000}, {655,0.00000}, {660,0.01533}, {665,0.00000}, {670,0.00667}, {675,0.01400}, {680,0.00400}, {685,0.00800}, {690,0.01300}, {695,0.00367}, {700,0.00100}, {705,0.00133}, {710,0.01200}, {715,0.00133}, {720,0.00900}, {725,0.00533}, {730,0.00667}, {735,0.01433}, {740,0.00533}, {745,0.00767}, {750,0.00500}, {755,0.00533}, {760,0.01733}, {765,0.00133}, {770,0.00367}, {775,0.00667}, {780,0.01300}, {785,0.00400}, {790,0.01067}, {795,0.00367}, {800,0.00500}, {805,0.00900}, {810,0.00400}, {815,0.00400}, {820,0.00133}, {825,0.00133}, {830,0.00133}, {835,0.00000}, {840,0.00533}, {845,0.00267}, {850,0.00133}, {855,0.00800}, {860,0.00100}, {865,0.00400}, {870,0.01967}, {875,0.00400}, {880,0.00000}, {885,0.00000}, {890,0.01467}, {895,0.00533}, {900,0.00200}, {905,0.01167}, {910,0.01167}, {915,0.00000}, {920,0.00667}, {925,0.00133}, {930,0.00000}, {935,0.00900}, {940,0.00267}, {945,0.00267}, {950,0.00133}, {955,0.00400}, {960,0.00667}, {965,0.00000}, {970,0.00000}, {975,0.00133}, {980,0.00133}, {985,0.00400}, {990,0.00000}, {995,0.00000}, {1000,0.00200}, {1010,0.00000}, {1020,0.00000}, {1030,0.00000}, {1040,0.00800}, {1050,0.00000}, {1060,0.00000}, {1070,0.00667}, {1080,0.00000}, {1090,0.00000}, {1100,0.00133}, {1110,0.00000}, {1120,0.01600}, {1130,0.00133}, {1140,0.00000}, {1150,0.00000}, {1160,0.01067}, {1170,0.00000}, {1180,0.00267}, {1190,0.00400}, {1200,0.00133}, {1210,0.00133}, {1220,0.00133}, {1230,0.00000}, {1240,0.00133}, {1250,0.00367}, {1260,0.01200}, {1270,0.01067}, {1280,0.01033}, {1290,0.00000}, {1300,0.00133}, {1310,0.00133}, {1320,0.00933}, {1330,0.00000}, {1340,0.00400}, {1350,0.01067}, {1360,0.00000}, {1370,0.00000}, {1380,0.00533}, {1390,0.00133}, {1400,0.00133}, {1410,0.03167}, {1420,0.00000}, {1430,0.00400}, {1440,0.00267}, {1450,0.01200}, {1460,0.00400}, {1470,0.01833}, {1480,0.00267}, {1490,0.00633}, {1500,0.05100}, {1510,0.01967}, {1520,0.01467}, {1530,0.00133}, {1540,0.00133}, {1550,0.00133}, {1560,0.01600}, {1570,0.02933}, {1580,0.01600}, {1590,0.02100}, {1600,0.01333}, {1610,0.01600}, {1620,0.01567}, {1630,0.01433}, {1640,0.00133}, {1650,0.00000}, {1660,0.00000}, {1670,0.00267}, {1680,0.00000}, {1690,0.02400}, {1700,0.04633}, {1710,0.02400}, {1720,0.03733}, {1730,0.01700}, {1740,0.00533}, {1750,0.00267}, {1760,0.00100}, {1770,0.02000}, {1780,0.00000}, {1790,0.02533}, {1800,0.00667}, {1810,0.00400}, {1820,0.04000}, {1830,0.00667}, {1840,0.00633}, {1850,0.00133}, {1860,0.03600}, {1870,0.01833}, {1880,0.01600}, {1890,0.04000}, {1900,0.00133}, {1910,0.00133}, {1920,0.02800}, {1930,0.00533}, {1940,0.05167}, {1950,0.03467}, {1960,0.05567}, {1970,0.07700}, {1980,0.05733}, {1990,0.02133}, {2000,0.06100}, {2050,0.05300}, {2100,0.00267}, {2150,0.05300}, {2200,0.05833}, {2250,0.07733}, {2300,0.00267}, {2350,0.09067}, {2400,0.03833}, {2450,0.11167}, {2500,0.05600}, {2550,0.00533}, {2600,0.07433}, {2650,0.01200}, {2700,0.10400}, {2750,0.13300}, {2800,0.03467}, {2850,0.07300}, {2900,0.02400}, {2950,0.07067}, {3000,0.10400}, {3050,0.04000}, {3100,0.06767}, {3150,0.00533}, {3200,0.04400}, {3250,0.08100}, {3300,0.03533}, {3350,0.11600}, {3400,0.06800}, {3450,0.06933}, {3500,0.17175}, {3550,0.16900}, {3600,0.04267}, {3650,0.00267}, {3700,0.13800}, {3750,0.14267}, {3800,0.16467}, {3850,0.04267}, {3900,0.1435}, {3950,0.1875}, {4000,0.28733}, {4050,0.1095}, {4100,0.2115}, {4150,0.243}, {4500,0.344}};
data["big"]["Parsing"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00016379}, {6,0.00071552}, {7,0.00100000}, {8,0.00100862}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00102586}, {13,0.00165517}, {14,0.00189655}, {15,0.00200000}, {16,0.00200000}, {17,0.00200862}, {18,0.00200862}, {19,0.00216379}, {20,0.00276724}, {21,0.00300000}, {22,0.00300000}, {23,0.00300000}, {24,0.00341379}, {25,0.00399138}, {26,0.00381897}, {27,0.00400000}, {28,0.00400000}, {29,0.00400000}, {30,0.04643966}, {31,0.00400000}, {32,0.00402586}, {33,0.00496552}, {34,0.00500000}, {35,0.00500862}, {36,0.00501724}, {37,0.00539655}, {38,0.00647414}, {39,0.00600862}, {40,0.00606897}, {41,0.00693966}, {42,0.00700000}, {43,0.00700862}, {44,0.00720690}, {45,0.00799138}, {46,0.00800862}, {47,0.02368966}, {48,0.00822414}, {49,0.00929310}, {50,0.00903448}, {51,0.00968103}, {52,0.00993966}, {53,0.01003448}, {54,0.01056034}, {55,0.01203448}, {56,0.01100862}, {57,0.03189655}, {58,0.01195690}, {59,0.01212069}, {60,0.01286207}, {61,0.01300862}, {62,0.01305172}, {63,0.01362931}, {64,0.01398276}, {65,0.02893966}, {66,0.01494828}, {67,0.01527586}, {68,0.01546552}, {69,0.01615517}, {70,0.01658621}, {71,0.01693103}, {72,0.02760345}, {73,0.01775862}, {74,0.01802586}, {75,0.01869828}, {76,0.01891379}, {77,0.03437931}, {78,0.02002586}, {79,0.02000862}, {80,0.02363793}, {81,0.02174138}, {82,0.04206897}, {83,0.02243966}, {84,0.02289655}, {85,0.02361207}, {86,0.02385345}, {87,0.03440517}, {88,0.02491379}, {89,0.02532759}, {90,0.02584483}, {91,0.04040517}, {92,0.02688793}, {93,0.02713793}, {94,0.02792241}, {95,0.03797414}, {96,0.02888793}, {97,0.02979310}, {98,0.04817241}, {99,0.03073276}, {100,0.03161207}, {101,0.04655172}, {102,0.03222414}, {103,0.03300862}, {104,0.03393966}, {105,0.03962931}, {106,0.03489655}, {107,0.03569828}, {108,0.04852586}, {109,0.03697414}, {110,0.05002586}, {111,0.03809483}, {112,0.03874138}, {113,0.05308621}, {114,0.03999138}, {115,0.04611207}, {116,0.05357759}, {117,0.04202586}, {118,0.05815517}, {119,0.04297414}, {120,0.04357759}, {121,0.05036207}, {122,0.04548276}, {123,0.05425000}, {124,0.04697414}, {125,0.06701724}, {126,0.04814655}, {127,0.06799138}, {128,0.04972414}, {129,0.06942241}, {130,0.05080172}, {131,0.07197414}, {132,0.05203448}, {133,0.07444828}, {134,0.05360345}, {135,0.07416379}, {136,0.05523276}, {137,0.07307759}, {138,0.05661207}, {139,0.06725000}, {140,0.05790517}, {141,0.08779310}, {142,0.10888793}, {143,0.06069828}, {144,0.08905172}, {145,0.06221552}, {146,0.07608621}, {147,0.09384483}, {148,0.06499138}, {149,0.08151724}, {150,0.06662069}, {151,0.07774138}, {152,0.11343103}, {153,0.06859483}, {154,0.07979310}, {155,0.09928448}, {156,0.07125862}, {157,0.07964655}, {158,0.08737069}, {159,0.10489655}, {160,0.07520690}, {161,0.08588793}, {162,0.11070690}, {163,0.10554310}, {164,0.07844828}, {165,0.11143103}, {166,0.11620690}, {167,0.11592241}, {168,0.08257759}, {169,0.08700862}, {170,0.09406034}, {171,0.10294828}, {172,0.14537931}, {173,0.13128448}, {174,0.08805172}, {175,0.09647414}, {176,0.10385345}, {177,0.12375862}, {178,0.12368966}, {179,0.12924138}, {180,0.12893103}, {181,0.11861207}, {182,0.12556897}, {183,0.12691379}, {184,0.13208621}, {185,0.09939655}, {186,0.10482759}, {187,0.10521552}, {188,0.13260345}, {189,0.13331034}, {190,0.13562069}, {191,0.13793103}, {192,0.13775000}, {193,0.15653448}, {194,0.17031034}, {195,0.16329310}, {196,0.14937931}, {197,0.14436207}, {198,0.14512931}, {199,0.14765517}, {200,0.14155172}, {201,0.13616379}, {202,0.14720690}, {203,0.18070690}, {204,0.15656897}, {205,0.15644828}, {206,0.15187931}, {207,0.15373276}, {208,0.15588793}, {209,0.18001724}, {210,0.19883621}, {211,0.17704310}, {212,0.16223276}, {213,0.18609483}, {214,0.17294828}, {215,0.16350862}, {216,0.16295690}, {217,0.20098276}, {218,0.16779310}, {219,0.16575000}, {220,0.20215517}, {221,0.17107759}, {222,0.17168966}, {223,0.20416379}, {224,0.20498276}, {225,0.23233621}, {226,0.18091379}, {227,0.17514655}, {228,0.21998276}, {229,0.16861207}, {230,0.21800000}, {231,0.17994828}, {232,0.21620690}, {233,0.18384483}, {234,0.21988793}, {235,0.18876724}, {236,0.24360345}, {237,0.21575862}, {238,0.24927586}, {239,0.21581897}, {240,0.21172414}, {241,0.22820690}, {242,0.18620690}, {243,0.23551724}, {244,0.22625000}, {245,0.20531034}, {246,0.23567241}, {247,0.23156034}, {248,0.21035345}, {249,0.22000862}, {250,0.28968103}, {251,0.24512069}, {252,0.21885345}, {253,0.25187069}, {254,0.24195690}, {255,0.24037931}, {256,0.24182759}, {257,0.24379310}, {258,0.24612069}, {259,0.25325862}, {260,0.23978448}, {261,0.27772414}, {262,0.25658621}, {263,0.30446552}, {264,0.26656034}, {265,0.26255172}, {266,0.26370690}, {267,0.26610345}, {268,0.26570690}, {269,0.27495690}, {270,0.26147414}, {271,0.30000862}, {272,0.28976724}, {273,0.32273276}, {274,0.28269828}, {275,0.28731897}, {276,0.28737931}, {277,0.28916379}, {278,0.29318103}, {279,0.29880172}, {280,0.32027586}, {281,0.33312931}, {282,0.32607759}, {283,0.30154310}, {284,0.30552586}, {285,0.30957759}, {286,0.31326724}, {287,0.31780172}, {288,0.33358621}, {289,0.34433621}, {290,0.36674138}, {291,0.33893103}, {292,0.32984483}, {293,0.33474138}, {294,0.33255172}, {295,0.34025862}, {296,0.37635345}, {297,0.36848276}, {298,0.38446552}, {299,0.35470690}, {300,0.35162931}, {301,0.35156034}, {302,0.35306897}, {303,0.36061207}, {304,0.43051724}, {305,0.37981034}, {306,0.38068103}, {307,0.36963793}, {308,0.37133621}, {309,0.37210345}, {310,0.37846552}, {311,0.41542241}, {312,0.40479310}, {313,0.41432759}, {314,0.37447414}, {315,0.38815517}, {316,0.38893103}, {317,0.39517241}, {318,0.46696552}, {319,0.42437931}, {320,0.43065517}, {321,0.40849138}, {322,0.40713793}, {323,0.40893966}, {324,0.42141379}, {325,0.44181034}, {326,0.49893966}, {327,0.42818103}, {328,0.42333621}, {329,0.42644828}, {330,0.43520690}, {331,0.52037069}, {332,0.45621552}, {333,0.46043966}, {334,0.44743966}, {335,0.44531034}, {336,0.59821552}, {337,0.47893966}, {338,0.48765517}, {339,0.45749138}, {340,0.45795690}, {341,0.46181897}, {342,0.52011207}, {343,0.50100000}, {344,0.51802586}, {345,0.47411207}, {346,0.47993966}, {347,0.47961207}, {348,0.56842241}, {349,0.51955172}, {350,0.51161207}, {351,0.49366379}, {352,0.49293103}, {353,0.50147414}, {354,0.58658621}, {355,0.52748276}, {356,0.52358621}, {357,0.51057759}, {358,0.51204310}, {359,0.52670690}, {360,0.58151724}, {361,0.59718966}, {362,0.53009483}, {363,0.52621552}, {364,0.53725862}, {365,0.64332759}, {366,0.56501724}, {367,0.55523276}, {368,0.54686207}, {369,0.55095690}, {370,0.66543103}, {371,0.58725862}, {372,0.57566379}, {373,0.56227586}, {374,0.56455172}, {375,0.68571552}, {376,0.60250000}, {377,0.59040517}, {378,0.57752586}, {379,0.58660345}, {380,0.70692241}, {381,0.61939655}, {382,0.59679310}, {383,0.59057759}, {384,0.60030172}, {385,0.70950000}, {386,0.63718966}, {387,0.61837069}, {388,0.61606897}, {389,0.61839655}, {390,0.72638793}, {391,0.65411207}, {392,0.62347414}, {393,0.62461207}, {394,0.63491379}, {395,0.76786207}, {396,0.67445690}, {397,0.64368103}, {398,0.64827586}, {399,0.65306034}, {400,0.78156897}, {401,0.69831897}, {402,0.65248276}, {403,0.66241379}, {404,0.67049138}, {405,0.79116379}, {406,0.72000000}, {407,0.68036207}, {408,0.67832759}, {409,0.73330172}, {410,0.80743966}, {411,0.72334483}, {412,0.69690517}, {413,0.70263793}, {414,0.85483621}, {415,0.75069828}, {416,0.70596552}, {417,0.71092241}, {418,0.75591379}, {419,0.85040517}, {420,0.75895690}, {421,0.72612069}, {422,0.73706034}, {423,0.88468103}, {424,0.79330172}, {425,0.75481897}, {426,0.74950862}, {427,0.90346552}, {428,0.79478448}, {429,0.75959483}, {430,0.76346552}, {431,0.77306897}, {432,0.90829310}, {433,0.82555172}, {434,0.78126724}, {435,0.77904310}, {436,0.92806897}, {437,0.84236207}, {438,0.80833621}, {439,0.79717241}, {440,0.81116379}, {441,0.98537931}, {442,0.84942241}, {443,0.81491379}, {444,0.81555172}, {445,0.99207759}, {446,0.87845690}, {447,0.84063793}, {448,0.82992241}, {449,1.00599138}, {450,0.89548276}, {451,0.84661207}, {452,0.84837931}, {453,0.93685345}, {454,0.98471552}, {455,0.89302586}, {456,0.86554310}, {457,0.90068966}, {458,1.05226724}, {459,0.91553448}, {460,0.87848276}, {461,0.90520690}, {462,1.07014655}, {463,0.93393966}, {464,0.89681034}, {465,0.91997414}, {466,1.09322414}, {467,0.95885345}, {468,0.91593103}, {469,1.55359483}, {470,1.10892241}, {471,0.97508621}, {472,0.94010345}, {473,1.04424138}, {474,1.06549138}, {475,0.96917241}, {476,0.95136207}, {477,1.25598276}, {478,1.03934483}, {479,0.97814655}, {480,0.97258621}, {481,1.07418103}, {482,1.09011207}, {483,1.00189655}, {484,0.98724138}, {485,1.08092241}, {486,1.12894828}, {487,1.02448276}, {488,1.01554310}, {489,1.11826724}, {490,1.14107759}, {491,1.04342241}, {492,1.04113793}, {493,1.14325862}, {494,1.14377586}, {495,1.06670690}, {496,1.09757759}, {497,1.19381034}, {498,1.12700000}, {499,1.06385345}, {500,1.10082759}, {505,1.16967}, {510,1.17700}, {515,1.17800}, {520,1.20800}, {525,1.22600}, {530,1.22433}, {535,1.30033}, {540,1.31967}, {545,1.33567}, {550,1.31867}, {555,1.36967}, {560,1.39933}, {565,1.42567}, {570,1.40500}, {575,1.47533}, {580,1.50133}, {585,1.49667}, {590,1.45533}, {595,1.53967}, {600,1.54875}, {605,1.61233}, {610,1.61800}, {615,1.65067}, {620,1.71267}, {625,1.68700}, {630,2.28467}, {635,1.97333}, {640,1.74533}, {645,1.78200}, {650,2.37400}, {655,1.80133}, {660,1.87267}, {665,2.47533}, {670,1.96000}, {675,2.04600}, {680,2.65800}, {685,2.08100}, {690,2.10133}, {695,2.14267}, {700,2.77650}, {705,2.18733}, {710,2.23467}, {715,2.58933}, {720,2.67633}, {725,2.72833}, {730,2.40867}, {735,2.43733}, {740,2.42333}, {745,2.83600}, {750,2.84567}, {755,2.92400}, {760,2.58100}, {765,2.69667}, {770,3.16067}, {775,3.20467}, {780,2.86000}, {785,3.31933}, {790,2.98033}, {795,3.05967}, {800,3.31075}, {805,3.10533}, {810,3.11867}, {815,3.55400}, {820,3.20067}, {825,3.25133}, {830,3.24533}, {835,3.78167}, {840,3.39833}, {845,3.43233}, {850,3.50833}, {855,3.58267}, {860,3.67333}, {865,4.15167}, {870,3.66467}, {875,4.27800}, {880,3.56533}, {885,3.62167}, {890,3.77333}, {895,3.78933}, {900,4.04375}, {905,4.33067}, {910,3.97000}, {915,3.95367}, {920,3.95600}, {925,3.94867}, {930,4.54800}, {935,4.05167}, {940,4.09067}, {945,4.16933}, {950,4.35500}, {955,4.38867}, {960,5.26067}, {965,4.48233}, {970,4.55467}, {975,4.61067}, {980,4.66233}, {985,5.65967}, {990,4.73833}, {995,4.75567}, {1000,4.84900}, {1010,4.92233}, {1020,5.04833}, {1030,5.21833}, {1040,5.31433}, {1050,5.44767}, {1060,5.53200}, {1070,6.53467}, {1080,5.64000}, {1090,6.72933}, {1100,5.92367}, {1110,6.16433}, {1120,6.16600}, {1130,6.21333}, {1140,6.28300}, {1150,7.57267}, {1160,6.58500}, {1170,7.82600}, {1180,6.91300}, {1190,7.02233}, {1200,7.13900}, {1210,7.26233}, {1220,7.41400}, {1230,7.46533}, {1240,7.72100}, {1250,7.77333}, {1260,8.00400}, {1270,8.08267}, {1280,8.22167}, {1290,9.63033}, {1300,9.72133}, {1310,10.03933}, {1320,8.67200}, {1330,10.27067}, {1340,10.52667}, {1350,10.64600}, {1360,10.68867}, {1370,9.60367}, {1380,9.63967}, {1390,9.80400}, {1400,10.33633}, {1410,10.17600}, {1420,12.08333}, {1430,12.03267}, {1440,12.31133}, {1450,12.20100}, {1460,12.20533}, {1470,14.22067}, {1480,11.21133}, {1490,11.66433}, {1500,13.91525}, {1510,11.76800}, {1520,11.99533}, {1530,13.55133}, {1540,15.50300}, {1550,14.19967}, {1560,12.66767}, {1570,15.51933}, {1580,12.42867}, {1590,14.15633}, {1600,15.86133}, {1610,14.72400}, {1620,14.61067}, {1630,16.74633}, {1640,16.88300}, {1650,16.82033}, {1660,18.53967}, {1670,19.26667}, {1680,17.37967}, {1690,16.75467}, {1700,16.05100}, {1710,18.43867}, {1720,14.60000}, {1730,16.72767}, {1740,17.30733}, {1750,17.65000}, {1760,16.81333}, {1770,19.01633}, {1780,21.70167}, {1790,18.14800}, {1800,18.43133}, {1810,17.78500}, {1820,18.83133}, {1830,20.47700}, {1840,20.94733}, {1850,23.24467}, {1860,21.80667}, {1870,22.33200}, {1880,23.96033}, {1890,20.36500}, {1900,21.93000}, {1910,23.67933}, {1920,21.85500}, {1930,24.82067}, {1940,18.65333}, {1950,22.25867}, {1960,22.75333}, {1970,23.19667}, {1980,25.25867}, {1990,21.00633}, {2000,25.92825}, {2050,29.03900}, {2100,27.13533}, {2150,28.06567}, {2200,28.41233}, {2250,32.33933}, {2300,33.50633}, {2350,35.11900}, {2400,36.73300}, {2450,43.15733}, {2500,39.10450}, {2550,43.93633}, {2600,42.73400}, {2650,45.39667}, {2700,45.19633}, {2750,52.12967}, {2800,52.59700}, {2850,56.88600}, {2900,58.95167}, {2950,61.93633}, {3000,63.46225}, {3050,66.17433}, {3100,68.71767}, {3150,65.34767}, {3200,65.45767}, {3250,68.79500}, {3300,66.97367}, {3350,73.11267}, {3400,76.03800}, {3450,73.97900}, {3500,81.82600}, {3550,89.81367}, {3600,91.38833}, {3650,87.02433}, {3700,91.82533}, {3750,93.77200}, {3800,106.21667}, {3850,99.64867}, {3900,102.3630}, {3950,99.7130}, {4000,110.80600}, {4050,110.5535}, {4100,111.5150}, {4150,134.291}, {4500,140.227}};
data["big"]["Parsing"]["norm reif"]["user"] = {{1,0.00012931}, {2,0.00023276}, {3,0.00041379}, {4,0.00062069}, {5,0.00054310}, {6,0.00097414}, {7,0.00090517}, {8,0.00120690}, {9,0.00124138}, {10,0.00128448}, {11,0.00156897}, {12,0.00162931}, {13,0.00150862}, {14,0.00211207}, {15,0.00198276}, {16,0.00191379}, {17,0.00222414}, {18,0.00260345}, {19,0.00242241}, {20,0.00225862}, {21,0.00269828}, {22,0.00288793}, {23,0.00300000}, {24,0.00355172}, {25,0.00343966}, {26,0.00352586}, {27,0.00352586}, {28,0.00374138}, {29,0.00413793}, {30,0.04378448}, {31,0.00437069}, {32,0.00454310}, {33,0.00539655}, {34,0.00503448}, {35,0.00548276}, {36,0.00550000}, {37,0.00622414}, {38,0.00658621}, {39,0.00601724}, {40,0.00671552}, {41,0.00714655}, {42,0.00740517}, {43,0.00762069}, {44,0.00775862}, {45,0.00820690}, {46,0.00841379}, {47,0.02350862}, {48,0.00862069}, {49,0.00985345}, {50,0.00950862}, {51,0.01014655}, {52,0.01024138}, {53,0.01040517}, {54,0.01050000}, {55,0.01239655}, {56,0.01120690}, {57,0.03184483}, {58,0.01241379}, {59,0.01289655}, {60,0.01300000}, {61,0.01354310}, {62,0.01337069}, {63,0.01418103}, {64,0.01431034}, {65,0.02913793}, {66,0.01541379}, {67,0.01587069}, {68,0.01588793}, {69,0.01610345}, {70,0.01668966}, {71,0.01744828}, {72,0.02755172}, {73,0.01817241}, {74,0.01812069}, {75,0.01864655}, {76,0.01912931}, {77,0.03436207}, {78,0.02033621}, {79,0.02055172}, {80,0.02393103}, {81,0.02200000}, {82,0.04195690}, {83,0.02245690}, {84,0.02296552}, {85,0.02358621}, {86,0.02423276}, {87,0.03468966}, {88,0.02524138}, {89,0.02600000}, {90,0.02602586}, {91,0.03999138}, {92,0.02714655}, {93,0.02773276}, {94,0.02862069}, {95,0.03806897}, {96,0.02893103}, {97,0.03041379}, {98,0.04806897}, {99,0.03068966}, {100,0.03180172}, {101,0.04592241}, {102,0.03274138}, {103,0.03320690}, {104,0.03337931}, {105,0.03987931}, {106,0.03506897}, {107,0.03593966}, {108,0.04855172}, {109,0.03768966}, {110,0.05031034}, {111,0.03817241}, {112,0.03906897}, {113,0.05289655}, {114,0.03992241}, {115,0.04616379}, {116,0.05356034}, {117,0.04251724}, {118,0.05810345}, {119,0.04351724}, {120,0.04406897}, {121,0.05079310}, {122,0.04609483}, {123,0.05404310}, {124,0.04720690}, {125,0.06656034}, {126,0.04856034}, {127,0.06797414}, {128,0.05002586}, {129,0.06962069}, {130,0.05137069}, {131,0.07158621}, {132,0.05219828}, {133,0.07380172}, {134,0.05375000}, {135,0.07424138}, {136,0.05569828}, {137,0.07319828}, {138,0.05696552}, {139,0.06687931}, {140,0.05801724}, {141,0.08731897}, {142,0.10852586}, {143,0.06079310}, {144,0.08884483}, {145,0.06262069}, {146,0.07591379}, {147,0.09341379}, {148,0.06485345}, {149,0.08090517}, {150,0.06652586}, {151,0.07794828}, {152,0.11261207}, {153,0.06829310}, {154,0.08005172}, {155,0.09801724}, {156,0.07144828}, {157,0.07947414}, {158,0.08721552}, {159,0.10422414}, {160,0.07513793}, {161,0.08585345}, {162,0.10995690}, {163,0.10487069}, {164,0.07829310}, {165,0.11095690}, {166,0.11580172}, {167,0.11589655}, {168,0.08260345}, {169,0.08721552}, {170,0.09434483}, {171,0.10286207}, {172,0.14530172}, {173,0.13126724}, {174,0.08814655}, {175,0.09633621}, {176,0.10378448}, {177,0.12367241}, {178,0.12400862}, {179,0.12851724}, {180,0.12814655}, {181,0.11798276}, {182,0.12497414}, {183,0.12590517}, {184,0.13131034}, {185,0.09944828}, {186,0.10500862}, {187,0.10515517}, {188,0.13254310}, {189,0.13326724}, {190,0.13532759}, {191,0.13793103}, {192,0.13772414}, {193,0.15695690}, {194,0.17056897}, {195,0.16288793}, {196,0.14941379}, {197,0.14419828}, {198,0.14496552}, {199,0.14738793}, {200,0.14088793}, {201,0.13522414}, {202,0.14680172}, {203,0.17884483}, {204,0.15539655}, {205,0.15565517}, {206,0.15196552}, {207,0.15373276}, {208,0.15592241}, {209,0.17980172}, {210,0.19880172}, {211,0.17676724}, {212,0.16181034}, {213,0.18636207}, {214,0.17275862}, {215,0.16350000}, {216,0.16235345}, {217,0.20106897}, {218,0.16775862}, {219,0.16562069}, {220,0.20237069}, {221,0.17099138}, {222,0.17187069}, {223,0.20451724}, {224,0.20501724}, {225,0.23212069}, {226,0.18096552}, {227,0.17523276}, {228,0.22001724}, {229,0.16881034}, {230,0.21819828}, {231,0.17948276}, {232,0.21612931}, {233,0.18346552}, {234,0.21997414}, {235,0.18901724}, {236,0.24344828}, {237,0.21538793}, {238,0.24954310}, {239,0.21553448}, {240,0.21138793}, {241,0.22717241}, {242,0.18527586}, {243,0.23360345}, {244,0.22418966}, {245,0.20420690}, {246,0.23524138}, {247,0.23122414}, {248,0.20991379}, {249,0.21986207}, {250,0.28964655}, {251,0.24500862}, {252,0.21850000}, {253,0.25190517}, {254,0.24187931}, {255,0.23986207}, {256,0.24155172}, {257,0.24362069}, {258,0.24582759}, {259,0.25322414}, {260,0.23950000}, {261,0.27738793}, {262,0.25616379}, {263,0.30441379}, {264,0.26638793}, {265,0.26222414}, {266,0.26388793}, {267,0.26597414}, {268,0.26543966}, {269,0.27462931}, {270,0.26143103}, {271,0.29964655}, {272,0.28933621}, {273,0.32237069}, {274,0.28133621}, {275,0.28496552}, {276,0.28492241}, {277,0.28687069}, {278,0.29262931}, {279,0.29817241}, {280,0.31978448}, {281,0.33268103}, {282,0.32542241}, {283,0.29987931}, {284,0.30418103}, {285,0.30908621}, {286,0.31275862}, {287,0.31662069}, {288,0.33239655}, {289,0.34323276}, {290,0.36557759}, {291,0.33868966}, {292,0.32937931}, {293,0.33404310}, {294,0.33250000}, {295,0.33956034}, {296,0.37583621}, {297,0.36775862}, {298,0.38403448}, {299,0.35426724}, {300,0.35163793}, {301,0.35122414}, {302,0.35300862}, {303,0.36024138}, {304,0.43029310}, {305,0.37984483}, {306,0.38050000}, {307,0.36918966}, {308,0.37131034}, {309,0.37191379}, {310,0.37846552}, {311,0.41510345}, {312,0.40450000}, {313,0.41403448}, {314,0.37429310}, {315,0.38806034}, {316,0.38891379}, {317,0.39461207}, {318,0.46639655}, {319,0.42418966}, {320,0.42992241}, {321,0.40813793}, {322,0.40684483}, {323,0.40874138}, {324,0.42111207}, {325,0.44197414}, {326,0.49898276}, {327,0.42761207}, {328,0.42318966}, {329,0.42606034}, {330,0.43513793}, {331,0.52015517}, {332,0.45601724}, {333,0.45818103}, {334,0.44327586}, {335,0.44250862}, {336,0.59724138}, {337,0.47830172}, {338,0.48753448}, {339,0.45718966}, {340,0.45762069}, {341,0.46168103}, {342,0.51988793}, {343,0.50107759}, {344,0.51789655}, {345,0.47384483}, {346,0.47967241}, {347,0.47946552}, {348,0.56838793}, {349,0.51927586}, {350,0.51123276}, {351,0.49343103}, {352,0.49265517}, {353,0.50156897}, {354,0.58606034}, {355,0.52745690}, {356,0.52309483}, {357,0.51049138}, {358,0.51193103}, {359,0.52612931}, {360,0.58125000}, {361,0.59686207}, {362,0.52970690}, {363,0.52619828}, {364,0.53710345}, {365,0.64320690}, {366,0.56485345}, {367,0.55489655}, {368,0.54640517}, {369,0.55080172}, {370,0.66525862}, {371,0.58667241}, {372,0.57557759}, {373,0.56208621}, {374,0.56425862}, {375,0.68542241}, {376,0.60229310}, {377,0.58992241}, {378,0.57711207}, {379,0.58624138}, {380,0.70660345}, {381,0.61935345}, {382,0.59651724}, {383,0.59012931}, {384,0.59946552}, {385,0.70929310}, {386,0.63686207}, {387,0.61312069}, {388,0.60964655}, {389,0.61750862}, {390,0.72578448}, {391,0.65387069}, {392,0.62325000}, {393,0.62412931}, {394,0.63466379}, {395,0.76745690}, {396,0.67447414}, {397,0.64343103}, {398,0.64798276}, {399,0.65284483}, {400,0.78135345}, {401,0.69787069}, {402,0.65223276}, {403,0.66180172}, {404,0.67009483}, {405,0.79097414}, {406,0.71975862}, {407,0.67993966}, {408,0.67811207}, {409,0.73293966}, {410,0.80694828}, {411,0.72287069}, {412,0.69631034}, {413,0.70226724}, {414,0.85464655}, {415,0.75025862}, {416,0.70599138}, {417,0.71025862}, {418,0.75578448}, {419,0.85015517}, {420,0.75850862}, {421,0.72575862}, {422,0.73661207}, {423,0.88448276}, {424,0.79261207}, {425,0.74821552}, {426,0.74419828}, {427,0.90283621}, {428,0.79435345}, {429,0.75963793}, {430,0.76312069}, {431,0.77270690}, {432,0.90788793}, {433,0.82503448}, {434,0.78086207}, {435,0.77867241}, {436,0.92756034}, {437,0.84196552}, {438,0.80781034}, {439,0.79662069}, {440,0.81105172}, {441,0.98497414}, {442,0.84912931}, {443,0.81472414}, {444,0.81512069}, {445,0.99168966}, {446,0.87801724}, {447,0.84040517}, {448,0.82961207}, {449,1.00559483}, {450,0.89529310}, {451,0.84625000}, {452,0.84785345}, {453,0.93605172}, {454,0.98412931}, {455,0.89278448}, {456,0.86513793}, {457,0.90029310}, {458,1.05181897}, {459,0.91506897}, {460,0.87821552}, {461,0.90468103}, {462,1.06972414}, {463,0.93375000}, {464,0.89629310}, {465,0.91962931}, {466,1.09294828}, {467,0.95715517}, {468,0.91217241}, {469,1.55218966}, {470,1.10848276}, {471,0.97125862}, {472,0.93381034}, {473,1.04341379}, {474,1.06481897}, {475,0.96872414}, {476,0.95076724}, {477,1.25527586}, {478,1.03893966}, {479,0.97767241}, {480,0.97226724}, {481,1.07362931}, {482,1.08996552}, {483,1.00140517}, {484,0.98706897}, {485,1.08044828}, {486,1.12839655}, {487,1.02395690}, {488,1.01520690}, {489,1.11760345}, {490,1.14065517}, {491,1.04325000}, {492,1.04107759}, {493,1.14260345}, {494,1.14343966}, {495,1.06447414}, {496,1.09522414}, {497,1.19342241}, {498,1.12615517}, {499,1.06350000}, {500,1.10050000}, {505,1.14500}, {510,1.16400}, {515,1.17800}, {520,1.20633}, {525,1.22467}, {530,1.22133}, {535,1.29233}, {540,1.32000}, {545,1.33400}, {550,1.31800}, {555,1.37033}, {560,1.39800}, {565,1.42200}, {570,1.40367}, {575,1.47667}, {580,1.50067}, {585,1.49533}, {590,1.45700}, {595,1.53800}, {600,1.54975}, {605,1.61167}, {610,1.61867}, {615,1.65000}, {620,1.69633}, {625,1.68367}, {630,2.28200}, {635,1.97367}, {640,1.74100}, {645,1.77533}, {650,2.37467}, {655,1.80167}, {660,1.85833}, {665,2.47367}, {670,1.95133}, {675,2.03167}, {680,2.65400}, {685,2.07133}, {690,2.08867}, {695,2.13967}, {700,2.77550}, {705,2.18633}, {710,2.22233}, {715,2.58700}, {720,2.66900}, {725,2.72267}, {730,2.40267}, {735,2.42067}, {740,2.41733}, {745,2.82733}, {750,2.84233}, {755,2.91633}, {760,2.56467}, {765,2.69600}, {770,3.15533}, {775,3.19800}, {780,2.84700}, {785,3.31567}, {790,2.97033}, {795,3.05600}, {800,3.30625}, {805,3.09733}, {810,3.11367}, {815,3.55033}, {820,3.19833}, {825,3.25033}, {830,3.24367}, {835,3.78267}, {840,3.39267}, {845,3.42867}, {850,3.50600}, {855,3.57400}, {860,3.67333}, {865,4.14833}, {870,3.64333}, {875,4.27433}, {880,3.56667}, {885,3.62167}, {890,3.75700}, {895,3.78300}, {900,4.04175}, {905,4.31800}, {910,3.95800}, {915,3.95600}, {920,3.94967}, {925,3.94600}, {930,4.54733}, {935,4.04367}, {940,4.08900}, {945,4.16733}, {950,4.35433}, {955,4.38467}, {960,5.25433}, {965,4.48333}, {970,4.55433}, {975,4.61000}, {980,4.65967}, {985,5.65400}, {990,4.73833}, {995,4.75533}, {1000,4.84650}, {1010,4.92100}, {1020,5.04700}, {1030,5.21867}, {1040,5.30433}, {1050,5.44767}, {1060,5.53200}, {1070,6.52567}, {1080,5.63933}, {1090,6.73033}, {1100,5.92167}, {1110,6.16500}, {1120,6.14833}, {1130,6.21167}, {1140,6.28200}, {1150,7.57100}, {1160,6.57600}, {1170,7.82733}, {1180,6.91067}, {1190,7.01667}, {1200,7.13833}, {1210,7.25933}, {1220,7.41333}, {1230,7.46667}, {1240,7.71800}, {1250,7.77167}, {1260,7.99133}, {1270,8.07133}, {1280,8.21133}, {1290,9.63133}, {1300,9.72000}, {1310,10.03633}, {1320,8.66067}, {1330,10.26900}, {1340,10.52367}, {1350,10.63667}, {1360,10.68900}, {1370,9.60233}, {1380,9.63333}, {1390,9.80167}, {1400,10.33600}, {1410,10.14233}, {1420,12.08333}, {1430,12.02833}, {1440,12.30800}, {1450,12.19000}, {1460,12.20067}, {1470,14.20067}, {1480,11.20900}, {1490,11.65667}, {1500,13.86175}, {1510,11.74733}, {1520,11.97967}, {1530,13.54900}, {1540,15.50200}, {1550,14.19833}, {1560,12.65300}, {1570,15.49167}, {1580,12.41167}, {1590,14.13433}, {1600,15.84767}, {1610,14.70867}, {1620,14.59433}, {1630,16.73167}, {1640,16.88233}, {1650,16.81967}, {1660,18.53933}, {1670,19.26367}, {1680,17.37767}, {1690,16.73033}, {1700,16.00500}, {1710,18.41233}, {1720,14.56100}, {1730,16.71200}, {1740,17.30067}, {1750,17.64633}, {1760,16.81400}, {1770,18.99567}, {1780,21.70100}, {1790,18.12067}, {1800,18.42367}, {1810,17.77967}, {1820,18.79067}, {1830,20.46833}, {1840,20.93967}, {1850,23.24233}, {1860,21.76967}, {1870,22.31333}, {1880,23.94367}, {1890,20.32467}, {1900,21.92600}, {1910,23.67733}, {1920,21.82567}, {1930,24.81433}, {1940,18.60133}, {1950,22.22200}, {1960,22.69800}, {1970,23.12100}, {1980,25.20200}, {1990,20.98467}, {2000,25.86175}, {2050,28.98600}, {2100,27.13267}, {2150,28.01333}, {2200,28.35300}, {2250,32.26233}, {2300,33.50500}, {2350,35.02933}, {2400,36.69500}, {2450,43.04467}, {2500,39.03950}, {2550,43.93000}, {2600,42.65967}, {2650,45.38333}, {2700,45.09100}, {2750,51.99667}, {2800,52.56100}, {2850,56.81267}, {2900,58.92667}, {2950,61.86633}, {3000,63.34550}, {3050,66.13400}, {3100,68.65000}, {3150,65.34267}, {3200,65.41233}, {3250,68.71300}, {3300,66.93667}, {3350,72.99567}, {3400,75.96867}, {3450,73.90867}, {3500,81.63650}, {3550,89.64267}, {3600,91.34500}, {3650,87.02100}, {3700,91.68633}, {3750,93.62800}, {3800,106.05033}, {3850,99.60467}, {3900,102.2180}, {3950,99.5255}, {4000,110.51567}, {4050,110.4440}, {4100,111.3010}, {4150,134.048}, {4500,139.88}};
data["big"]["Parsing"]["norm reif"]["system"] = {{1,0.00018103}, {2,0.00041379}, {3,0.00031897}, {4,0.00009483}, {5,0.00012069}, {6,0.00009483}, {7,0.00016379}, {8,0.00012069}, {9,0.00010345}, {10,0.00008621}, {11,0.00006897}, {12,0.00021552}, {13,0.00048276}, {14,0.00023276}, {15,0.00035345}, {16,0.00018966}, {17,0.00034483}, {18,0.00020690}, {19,0.00038793}, {20,0.00044828}, {21,0.00035345}, {22,0.00027586}, {23,0.00037069}, {24,0.00041379}, {25,0.00077586}, {26,0.00055172}, {27,0.00047414}, {28,0.00069828}, {29,0.00083621}, {30,0.00223276}, {31,0.00010345}, {32,0.00016379}, {33,0.00002586}, {34,0.00000000}, {35,0.00002586}, {36,0.00003448}, {37,0.00000000}, {38,0.00003448}, {39,0.00012069}, {40,0.00000000}, {41,0.00003448}, {42,0.00003448}, {43,0.00006034}, {44,0.00003448}, {45,0.00002586}, {46,0.00000000}, {47,0.00020690}, {48,0.00002586}, {49,0.00012931}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00003448}, {55,0.00003448}, {56,0.00000000}, {57,0.00025000}, {58,0.00008621}, {59,0.00003448}, {60,0.00006034}, {61,0.00003448}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00026724}, {66,0.00006897}, {67,0.00000000}, {68,0.00000000}, {69,0.00002586}, {70,0.00003448}, {71,0.00006034}, {72,0.00006897}, {73,0.00012931}, {74,0.00003448}, {75,0.00006034}, {76,0.00003448}, {77,0.00021552}, {78,0.00010345}, {79,0.00010345}, {80,0.00008621}, {81,0.00013793}, {82,0.00022414}, {83,0.00002586}, {84,0.00005172}, {85,0.00006034}, {86,0.00000000}, {87,0.00020690}, {88,0.00010345}, {89,0.00006034}, {90,0.00002586}, {91,0.00012931}, {92,0.00000000}, {93,0.00006897}, {94,0.00013793}, {95,0.00027586}, {96,0.00010345}, {97,0.00006034}, {98,0.00043103}, {99,0.00012931}, {100,0.00003448}, {101,0.00021552}, {102,0.00009483}, {103,0.00002586}, {104,0.00013793}, {105,0.00006034}, {106,0.00000000}, {107,0.00002586}, {108,0.00026724}, {109,0.00008621}, {110,0.00013793}, {111,0.00006897}, {112,0.00006897}, {113,0.00050862}, {114,0.00006897}, {115,0.00013793}, {116,0.00033621}, {117,0.00018103}, {118,0.00056897}, {119,0.00000000}, {120,0.00009483}, {121,0.00012069}, {122,0.00012069}, {123,0.00023276}, {124,0.00012069}, {125,0.00027586}, {126,0.00017241}, {127,0.00033621}, {128,0.00000000}, {129,0.00037069}, {130,0.00006897}, {131,0.00062069}, {132,0.00024138}, {133,0.00056897}, {134,0.00018966}, {135,0.00036207}, {136,0.00006897}, {137,0.00050862}, {138,0.00009483}, {139,0.00044828}, {140,0.00008621}, {141,0.00076724}, {142,0.00055172}, {143,0.00027586}, {144,0.00037931}, {145,0.00006897}, {146,0.00013793}, {147,0.00084483}, {148,0.00033621}, {149,0.00049138}, {150,0.00015517}, {151,0.00012931}, {152,0.00077586}, {153,0.00016379}, {154,0.00032759}, {155,0.00097414}, {156,0.00018966}, {157,0.00042241}, {158,0.00060345}, {159,0.00078448}, {160,0.00031034}, {161,0.00028448}, {162,0.00073276}, {163,0.00069828}, {164,0.00024138}, {165,0.00058621}, {166,0.00006897}, {167,0.00012931}, {168,0.00009483}, {169,0.00006034}, {170,0.00003448}, {171,0.00006897}, {172,0.00009483}, {173,0.00016379}, {174,0.00012069}, {175,0.00023276}, {176,0.00003448}, {177,0.00006034}, {178,0.00008621}, {179,0.00077586}, {180,0.00064655}, {181,0.00100862}, {182,0.00090517}, {183,0.00087931}, {184,0.00068966}, {185,0.00006897}, {186,0.00022414}, {187,0.00003448}, {188,0.00006897}, {189,0.00013793}, {190,0.00016379}, {191,0.00012069}, {192,0.00010345}, {193,0.00010345}, {194,0.00012069}, {195,0.00009483}, {196,0.00009483}, {197,0.00010345}, {198,0.00002586}, {199,0.00016379}, {200,0.00087069}, {201,0.00076724}, {202,0.00061207}, {203,0.00145690}, {204,0.00096552}, {205,0.00100000}, {206,0.00016379}, {207,0.00009483}, {208,0.00012931}, {209,0.00010345}, {210,0.00009483}, {211,0.00006897}, {212,0.00002586}, {213,0.00010345}, {214,0.00003448}, {215,0.00003448}, {216,0.00009483}, {217,0.00010345}, {218,0.00002586}, {219,0.00003448}, {220,0.00003448}, {221,0.00012069}, {222,0.00000000}, {223,0.00002586}, {224,0.00009483}, {225,0.00016379}, {226,0.00010345}, {227,0.00000000}, {228,0.00013793}, {229,0.00006897}, {230,0.00017241}, {231,0.00003448}, {232,0.00003448}, {233,0.00031034}, {234,0.00002586}, {235,0.00006034}, {236,0.00016379}, {237,0.00012931}, {238,0.00013793}, {239,0.00018966}, {240,0.00000000}, {241,0.00063793}, {242,0.00087069}, {243,0.00182759}, {244,0.00209483}, {245,0.00094828}, {246,0.00062931}, {247,0.00012931}, {248,0.00026724}, {249,0.00020690}, {250,0.00027586}, {251,0.00023276}, {252,0.00006034}, {253,0.00020690}, {254,0.00010345}, {255,0.00010345}, {256,0.00017241}, {257,0.00006034}, {258,0.00012931}, {259,0.00006897}, {260,0.00017241}, {261,0.00019828}, {262,0.00019828}, {263,0.00009483}, {264,0.00006897}, {265,0.00017241}, {266,0.00009483}, {267,0.00013793}, {268,0.00010345}, {269,0.00006897}, {270,0.00003448}, {271,0.00010345}, {272,0.00018966}, {273,0.00029310}, {274,0.00145690}, {275,0.00236207}, {276,0.00268103}, {277,0.00210345}, {278,0.00065517}, {279,0.00036207}, {280,0.00043966}, {281,0.00030172}, {282,0.00069828}, {283,0.00135345}, {284,0.00118103}, {285,0.00091379}, {286,0.00050000}, {287,0.00113793}, {288,0.00067241}, {289,0.00103448}, {290,0.00089655}, {291,0.00018966}, {292,0.00023276}, {293,0.00063793}, {294,0.00044828}, {295,0.00052586}, {296,0.00026724}, {297,0.00036207}, {298,0.00006897}, {299,0.00012069}, {300,0.00020690}, {301,0.00020690}, {302,0.00023276}, {303,0.00017241}, {304,0.00020690}, {305,0.00006897}, {306,0.00006034}, {307,0.00017241}, {308,0.00010345}, {309,0.00009483}, {310,0.00023276}, {311,0.00013793}, {312,0.00024138}, {313,0.00022414}, {314,0.00020690}, {315,0.00012931}, {316,0.00020690}, {317,0.00026724}, {318,0.00019828}, {319,0.00006897}, {320,0.00027586}, {321,0.00016379}, {322,0.00024138}, {323,0.00018966}, {324,0.00027586}, {325,0.00017241}, {326,0.00027586}, {327,0.00019828}, {328,0.00010345}, {329,0.00017241}, {330,0.00012931}, {331,0.00012931}, {332,0.00010345}, {333,0.00212931}, {334,0.00406897}, {335,0.00276724}, {336,0.00087069}, {337,0.00026724}, {338,0.00010345}, {339,0.00027586}, {340,0.00032759}, {341,0.00012069}, {342,0.00031034}, {343,0.00009483}, {344,0.00006897}, {345,0.00023276}, {346,0.00017241}, {347,0.00006897}, {348,0.00020690}, {349,0.00017241}, {350,0.00012931}, {351,0.00010345}, {352,0.00017241}, {353,0.00026724}, {354,0.00032759}, {355,0.00014655}, {356,0.00039655}, {357,0.00016379}, {358,0.00020690}, {359,0.00013793}, {360,0.00017241}, {361,0.00013793}, {362,0.00013793}, {363,0.00013793}, {364,0.00033621}, {365,0.00016379}, {366,0.00019828}, {367,0.00003448}, {368,0.00019828}, {369,0.00010345}, {370,0.00023276}, {371,0.00013793}, {372,0.00009483}, {373,0.00012931}, {374,0.00019828}, {375,0.00028448}, {376,0.00020690}, {377,0.00015517}, {378,0.00027586}, {379,0.00026724}, {380,0.00016379}, {381,0.00031897}, {382,0.00024138}, {383,0.00036207}, {384,0.00041379}, {385,0.00030172}, {386,0.00027586}, {387,0.00506034}, {388,0.00624138}, {389,0.00093103}, {390,0.00029310}, {391,0.00030172}, {392,0.00022414}, {393,0.00024138}, {394,0.00020690}, {395,0.00032759}, {396,0.00016379}, {397,0.00031034}, {398,0.00017241}, {399,0.00018103}, {400,0.00034483}, {401,0.00041379}, {402,0.00017241}, {403,0.00050862}, {404,0.00034483}, {405,0.00002586}, {406,0.00020690}, {407,0.00019828}, {408,0.00020690}, {409,0.00012931}, {410,0.00027586}, {411,0.00026724}, {412,0.00030172}, {413,0.00019828}, {414,0.00017241}, {415,0.00031034}, {416,0.00019828}, {417,0.00034483}, {418,0.00026724}, {419,0.00020690}, {420,0.00036207}, {421,0.00027586}, {422,0.00033621}, {423,0.00033621}, {424,0.00056897}, {425,0.00631034}, {426,0.00519828}, {427,0.00041379}, {428,0.00037069}, {429,0.00019828}, {430,0.00020690}, {431,0.00015517}, {432,0.00024138}, {433,0.00018966}, {434,0.00048276}, {435,0.00047414}, {436,0.00019828}, {437,0.00037069}, {438,0.00003448}, {439,0.00026724}, {440,0.00012931}, {441,0.00027586}, {442,0.00012931}, {443,0.00020690}, {444,0.00024138}, {445,0.00022414}, {446,0.00017241}, {447,0.00026724}, {448,0.00020690}, {449,0.00026724}, {450,0.00034483}, {451,0.00010345}, {452,0.00017241}, {453,0.00039655}, {454,0.00030172}, {455,0.00036207}, {456,0.00031034}, {457,0.00030172}, {458,0.00041379}, {459,0.00030172}, {460,0.00017241}, {461,0.00020690}, {462,0.00020690}, {463,0.00030172}, {464,0.00017241}, {465,0.00031034}, {466,0.00030172}, {467,0.00124138}, {468,0.00360345}, {469,0.00136207}, {470,0.00042241}, {471,0.00337931}, {472,0.00596552}, {473,0.00074138}, {474,0.00042241}, {475,0.00019828}, {476,0.00034483}, {477,0.00062931}, {478,0.00034483}, {479,0.00024138}, {480,0.00037931}, {481,0.00037069}, {482,0.00037931}, {483,0.00023276}, {484,0.00006897}, {485,0.00031034}, {486,0.00020690}, {487,0.00019828}, {488,0.00048276}, {489,0.00034483}, {490,0.00030172}, {491,0.00019828}, {492,0.00006897}, {493,0.00032759}, {494,0.00031034}, {495,0.00197414}, {496,0.00225000}, {497,0.00034483}, {498,0.00031897}, {499,0.00020690}, {500,0.00023276}, {505,0.02367}, {510,0.01433}, {515,0.00000}, {520,0.00133}, {525,0.00133}, {530,0.00233}, {535,0.00667}, {540,0.00133}, {545,0.00000}, {550,0.00000}, {555,0.00000}, {560,0.00100}, {565,0.00267}, {570,0.00133}, {575,0.00000}, {580,0.00000}, {585,0.00000}, {590,0.00000}, {595,0.00000}, {600,0.00000}, {605,0.00133}, {610,0.00000}, {615,0.00000}, {620,0.01600}, {625,0.00400}, {630,0.00233}, {635,0.00000}, {640,0.00500}, {645,0.00667}, {650,0.00000}, {655,0.00000}, {660,0.01533}, {665,0.00000}, {670,0.00667}, {675,0.01400}, {680,0.00400}, {685,0.00800}, {690,0.01300}, {695,0.00367}, {700,0.00100}, {705,0.00133}, {710,0.01200}, {715,0.00133}, {720,0.00900}, {725,0.00533}, {730,0.00667}, {735,0.01433}, {740,0.00533}, {745,0.00767}, {750,0.00500}, {755,0.00533}, {760,0.01733}, {765,0.00133}, {770,0.00367}, {775,0.00667}, {780,0.01300}, {785,0.00400}, {790,0.01067}, {795,0.00367}, {800,0.00500}, {805,0.00900}, {810,0.00400}, {815,0.00400}, {820,0.00133}, {825,0.00133}, {830,0.00133}, {835,0.00000}, {840,0.00533}, {845,0.00267}, {850,0.00133}, {855,0.00800}, {860,0.00100}, {865,0.00400}, {870,0.01967}, {875,0.00400}, {880,0.00000}, {885,0.00000}, {890,0.01467}, {895,0.00533}, {900,0.00200}, {905,0.01167}, {910,0.01167}, {915,0.00000}, {920,0.00667}, {925,0.00133}, {930,0.00000}, {935,0.00900}, {940,0.00267}, {945,0.00267}, {950,0.00133}, {955,0.00400}, {960,0.00667}, {965,0.00000}, {970,0.00000}, {975,0.00133}, {980,0.00133}, {985,0.00400}, {990,0.00000}, {995,0.00000}, {1000,0.00200}, {1010,0.00000}, {1020,0.00000}, {1030,0.00000}, {1040,0.00800}, {1050,0.00000}, {1060,0.00000}, {1070,0.00667}, {1080,0.00000}, {1090,0.00000}, {1100,0.00133}, {1110,0.00000}, {1120,0.01600}, {1130,0.00133}, {1140,0.00000}, {1150,0.00000}, {1160,0.01067}, {1170,0.00000}, {1180,0.00267}, {1190,0.00400}, {1200,0.00133}, {1210,0.00133}, {1220,0.00133}, {1230,0.00000}, {1240,0.00133}, {1250,0.00367}, {1260,0.01200}, {1270,0.01067}, {1280,0.01033}, {1290,0.00000}, {1300,0.00133}, {1310,0.00133}, {1320,0.00933}, {1330,0.00000}, {1340,0.00400}, {1350,0.01067}, {1360,0.00000}, {1370,0.00000}, {1380,0.00533}, {1390,0.00133}, {1400,0.00133}, {1410,0.03167}, {1420,0.00000}, {1430,0.00400}, {1440,0.00267}, {1450,0.01200}, {1460,0.00400}, {1470,0.01833}, {1480,0.00267}, {1490,0.00633}, {1500,0.05100}, {1510,0.01967}, {1520,0.01467}, {1530,0.00133}, {1540,0.00133}, {1550,0.00133}, {1560,0.01600}, {1570,0.02933}, {1580,0.01600}, {1590,0.02100}, {1600,0.01333}, {1610,0.01600}, {1620,0.01567}, {1630,0.01433}, {1640,0.00133}, {1650,0.00000}, {1660,0.00000}, {1670,0.00267}, {1680,0.00000}, {1690,0.02400}, {1700,0.04633}, {1710,0.02400}, {1720,0.03733}, {1730,0.01700}, {1740,0.00533}, {1750,0.00267}, {1760,0.00100}, {1770,0.02000}, {1780,0.00000}, {1790,0.02533}, {1800,0.00667}, {1810,0.00400}, {1820,0.04000}, {1830,0.00667}, {1840,0.00633}, {1850,0.00133}, {1860,0.03600}, {1870,0.01833}, {1880,0.01600}, {1890,0.04000}, {1900,0.00133}, {1910,0.00133}, {1920,0.02800}, {1930,0.00533}, {1940,0.05167}, {1950,0.03467}, {1960,0.05567}, {1970,0.07700}, {1980,0.05733}, {1990,0.02133}, {2000,0.06100}, {2050,0.05300}, {2100,0.00267}, {2150,0.05300}, {2200,0.05833}, {2250,0.07733}, {2300,0.00267}, {2350,0.09067}, {2400,0.03833}, {2450,0.11167}, {2500,0.05600}, {2550,0.00533}, {2600,0.07433}, {2650,0.01200}, {2700,0.10400}, {2750,0.13300}, {2800,0.03467}, {2850,0.07300}, {2900,0.02400}, {2950,0.07067}, {3000,0.10400}, {3050,0.04000}, {3100,0.06767}, {3150,0.00533}, {3200,0.04400}, {3250,0.08100}, {3300,0.03533}, {3350,0.11600}, {3400,0.06800}, {3450,0.06933}, {3500,0.17175}, {3550,0.16900}, {3600,0.04267}, {3650,0.00267}, {3700,0.13800}, {3750,0.14267}, {3800,0.16467}, {3850,0.04267}, {3900,0.1435}, {3950,0.1875}, {4000,0.28733}, {4050,0.1095}, {4100,0.2115}, {4150,0.243}, {4500,0.344}};
data["big"]["Parsing"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00016379}, {6,0.00071552}, {7,0.00100000}, {8,0.00100862}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00102586}, {13,0.00165517}, {14,0.00189655}, {15,0.00200000}, {16,0.00200000}, {17,0.00200862}, {18,0.00200862}, {19,0.00216379}, {20,0.00276724}, {21,0.00300000}, {22,0.00300000}, {23,0.00300000}, {24,0.00341379}, {25,0.00399138}, {26,0.00381897}, {27,0.00400000}, {28,0.00400000}, {29,0.00400000}, {30,0.04643966}, {31,0.00400000}, {32,0.00402586}, {33,0.00496552}, {34,0.00500000}, {35,0.00500862}, {36,0.00501724}, {37,0.00539655}, {38,0.00647414}, {39,0.00600862}, {40,0.00606897}, {41,0.00693966}, {42,0.00700000}, {43,0.00700862}, {44,0.00720690}, {45,0.00799138}, {46,0.00800862}, {47,0.02368966}, {48,0.00822414}, {49,0.00929310}, {50,0.00903448}, {51,0.00968103}, {52,0.00993966}, {53,0.01003448}, {54,0.01056034}, {55,0.01203448}, {56,0.01100862}, {57,0.03189655}, {58,0.01195690}, {59,0.01212069}, {60,0.01286207}, {61,0.01300862}, {62,0.01305172}, {63,0.01362931}, {64,0.01398276}, {65,0.02893966}, {66,0.01494828}, {67,0.01527586}, {68,0.01546552}, {69,0.01615517}, {70,0.01658621}, {71,0.01693103}, {72,0.02760345}, {73,0.01775862}, {74,0.01802586}, {75,0.01869828}, {76,0.01891379}, {77,0.03437931}, {78,0.02002586}, {79,0.02000862}, {80,0.02363793}, {81,0.02174138}, {82,0.04206897}, {83,0.02243966}, {84,0.02289655}, {85,0.02361207}, {86,0.02385345}, {87,0.03440517}, {88,0.02491379}, {89,0.02532759}, {90,0.02584483}, {91,0.04040517}, {92,0.02688793}, {93,0.02713793}, {94,0.02792241}, {95,0.03797414}, {96,0.02888793}, {97,0.02979310}, {98,0.04817241}, {99,0.03073276}, {100,0.03161207}, {101,0.04655172}, {102,0.03222414}, {103,0.03300862}, {104,0.03393966}, {105,0.03962931}, {106,0.03489655}, {107,0.03569828}, {108,0.04852586}, {109,0.03697414}, {110,0.05002586}, {111,0.03809483}, {112,0.03874138}, {113,0.05308621}, {114,0.03999138}, {115,0.04611207}, {116,0.05357759}, {117,0.04202586}, {118,0.05815517}, {119,0.04297414}, {120,0.04357759}, {121,0.05036207}, {122,0.04548276}, {123,0.05425000}, {124,0.04697414}, {125,0.06701724}, {126,0.04814655}, {127,0.06799138}, {128,0.04972414}, {129,0.06942241}, {130,0.05080172}, {131,0.07197414}, {132,0.05203448}, {133,0.07444828}, {134,0.05360345}, {135,0.07416379}, {136,0.05523276}, {137,0.07307759}, {138,0.05661207}, {139,0.06725000}, {140,0.05790517}, {141,0.08779310}, {142,0.10888793}, {143,0.06069828}, {144,0.08905172}, {145,0.06221552}, {146,0.07608621}, {147,0.09384483}, {148,0.06499138}, {149,0.08151724}, {150,0.06662069}, {151,0.07774138}, {152,0.11343103}, {153,0.06859483}, {154,0.07979310}, {155,0.09928448}, {156,0.07125862}, {157,0.07964655}, {158,0.08737069}, {159,0.10489655}, {160,0.07520690}, {161,0.08588793}, {162,0.11070690}, {163,0.10554310}, {164,0.07844828}, {165,0.11143103}, {166,0.11620690}, {167,0.11592241}, {168,0.08257759}, {169,0.08700862}, {170,0.09406034}, {171,0.10294828}, {172,0.14537931}, {173,0.13128448}, {174,0.08805172}, {175,0.09647414}, {176,0.10385345}, {177,0.12375862}, {178,0.12368966}, {179,0.12924138}, {180,0.12893103}, {181,0.11861207}, {182,0.12556897}, {183,0.12691379}, {184,0.13208621}, {185,0.09939655}, {186,0.10482759}, {187,0.10521552}, {188,0.13260345}, {189,0.13331034}, {190,0.13562069}, {191,0.13793103}, {192,0.13775000}, {193,0.15653448}, {194,0.17031034}, {195,0.16329310}, {196,0.14937931}, {197,0.14436207}, {198,0.14512931}, {199,0.14765517}, {200,0.14155172}, {201,0.13616379}, {202,0.14720690}, {203,0.18070690}, {204,0.15656897}, {205,0.15644828}, {206,0.15187931}, {207,0.15373276}, {208,0.15588793}, {209,0.18001724}, {210,0.19883621}, {211,0.17704310}, {212,0.16223276}, {213,0.18609483}, {214,0.17294828}, {215,0.16350862}, {216,0.16295690}, {217,0.20098276}, {218,0.16779310}, {219,0.16575000}, {220,0.20215517}, {221,0.17107759}, {222,0.17168966}, {223,0.20416379}, {224,0.20498276}, {225,0.23233621}, {226,0.18091379}, {227,0.17514655}, {228,0.21998276}, {229,0.16861207}, {230,0.21800000}, {231,0.17994828}, {232,0.21620690}, {233,0.18384483}, {234,0.21988793}, {235,0.18876724}, {236,0.24360345}, {237,0.21575862}, {238,0.24927586}, {239,0.21581897}, {240,0.21172414}, {241,0.22820690}, {242,0.18620690}, {243,0.23551724}, {244,0.22625000}, {245,0.20531034}, {246,0.23567241}, {247,0.23156034}, {248,0.21035345}, {249,0.22000862}, {250,0.28968103}, {251,0.24512069}, {252,0.21885345}, {253,0.25187069}, {254,0.24195690}, {255,0.24037931}, {256,0.24182759}, {257,0.24379310}, {258,0.24612069}, {259,0.25325862}, {260,0.23978448}, {261,0.27772414}, {262,0.25658621}, {263,0.30446552}, {264,0.26656034}, {265,0.26255172}, {266,0.26370690}, {267,0.26610345}, {268,0.26570690}, {269,0.27495690}, {270,0.26147414}, {271,0.30000862}, {272,0.28976724}, {273,0.32273276}, {274,0.28269828}, {275,0.28731897}, {276,0.28737931}, {277,0.28916379}, {278,0.29318103}, {279,0.29880172}, {280,0.32027586}, {281,0.33312931}, {282,0.32607759}, {283,0.30154310}, {284,0.30552586}, {285,0.30957759}, {286,0.31326724}, {287,0.31780172}, {288,0.33358621}, {289,0.34433621}, {290,0.36674138}, {291,0.33893103}, {292,0.32984483}, {293,0.33474138}, {294,0.33255172}, {295,0.34025862}, {296,0.37635345}, {297,0.36848276}, {298,0.38446552}, {299,0.35470690}, {300,0.35162931}, {301,0.35156034}, {302,0.35306897}, {303,0.36061207}, {304,0.43051724}, {305,0.37981034}, {306,0.38068103}, {307,0.36963793}, {308,0.37133621}, {309,0.37210345}, {310,0.37846552}, {311,0.41542241}, {312,0.40479310}, {313,0.41432759}, {314,0.37447414}, {315,0.38815517}, {316,0.38893103}, {317,0.39517241}, {318,0.46696552}, {319,0.42437931}, {320,0.43065517}, {321,0.40849138}, {322,0.40713793}, {323,0.40893966}, {324,0.42141379}, {325,0.44181034}, {326,0.49893966}, {327,0.42818103}, {328,0.42333621}, {329,0.42644828}, {330,0.43520690}, {331,0.52037069}, {332,0.45621552}, {333,0.46043966}, {334,0.44743966}, {335,0.44531034}, {336,0.59821552}, {337,0.47893966}, {338,0.48765517}, {339,0.45749138}, {340,0.45795690}, {341,0.46181897}, {342,0.52011207}, {343,0.50100000}, {344,0.51802586}, {345,0.47411207}, {346,0.47993966}, {347,0.47961207}, {348,0.56842241}, {349,0.51955172}, {350,0.51161207}, {351,0.49366379}, {352,0.49293103}, {353,0.50147414}, {354,0.58658621}, {355,0.52748276}, {356,0.52358621}, {357,0.51057759}, {358,0.51204310}, {359,0.52670690}, {360,0.58151724}, {361,0.59718966}, {362,0.53009483}, {363,0.52621552}, {364,0.53725862}, {365,0.64332759}, {366,0.56501724}, {367,0.55523276}, {368,0.54686207}, {369,0.55095690}, {370,0.66543103}, {371,0.58725862}, {372,0.57566379}, {373,0.56227586}, {374,0.56455172}, {375,0.68571552}, {376,0.60250000}, {377,0.59040517}, {378,0.57752586}, {379,0.58660345}, {380,0.70692241}, {381,0.61939655}, {382,0.59679310}, {383,0.59057759}, {384,0.60030172}, {385,0.70950000}, {386,0.63718966}, {387,0.61837069}, {388,0.61606897}, {389,0.61839655}, {390,0.72638793}, {391,0.65411207}, {392,0.62347414}, {393,0.62461207}, {394,0.63491379}, {395,0.76786207}, {396,0.67445690}, {397,0.64368103}, {398,0.64827586}, {399,0.65306034}, {400,0.78156897}, {401,0.69831897}, {402,0.65248276}, {403,0.66241379}, {404,0.67049138}, {405,0.79116379}, {406,0.72000000}, {407,0.68036207}, {408,0.67832759}, {409,0.73330172}, {410,0.80743966}, {411,0.72334483}, {412,0.69690517}, {413,0.70263793}, {414,0.85483621}, {415,0.75069828}, {416,0.70596552}, {417,0.71092241}, {418,0.75591379}, {419,0.85040517}, {420,0.75895690}, {421,0.72612069}, {422,0.73706034}, {423,0.88468103}, {424,0.79330172}, {425,0.75481897}, {426,0.74950862}, {427,0.90346552}, {428,0.79478448}, {429,0.75959483}, {430,0.76346552}, {431,0.77306897}, {432,0.90829310}, {433,0.82555172}, {434,0.78126724}, {435,0.77904310}, {436,0.92806897}, {437,0.84236207}, {438,0.80833621}, {439,0.79717241}, {440,0.81116379}, {441,0.98537931}, {442,0.84942241}, {443,0.81491379}, {444,0.81555172}, {445,0.99207759}, {446,0.87845690}, {447,0.84063793}, {448,0.82992241}, {449,1.00599138}, {450,0.89548276}, {451,0.84661207}, {452,0.84837931}, {453,0.93685345}, {454,0.98471552}, {455,0.89302586}, {456,0.86554310}, {457,0.90068966}, {458,1.05226724}, {459,0.91553448}, {460,0.87848276}, {461,0.90520690}, {462,1.07014655}, {463,0.93393966}, {464,0.89681034}, {465,0.91997414}, {466,1.09322414}, {467,0.95885345}, {468,0.91593103}, {469,1.55359483}, {470,1.10892241}, {471,0.97508621}, {472,0.94010345}, {473,1.04424138}, {474,1.06549138}, {475,0.96917241}, {476,0.95136207}, {477,1.25598276}, {478,1.03934483}, {479,0.97814655}, {480,0.97258621}, {481,1.07418103}, {482,1.09011207}, {483,1.00189655}, {484,0.98724138}, {485,1.08092241}, {486,1.12894828}, {487,1.02448276}, {488,1.01554310}, {489,1.11826724}, {490,1.14107759}, {491,1.04342241}, {492,1.04113793}, {493,1.14325862}, {494,1.14377586}, {495,1.06670690}, {496,1.09757759}, {497,1.19381034}, {498,1.12700000}, {499,1.06385345}, {500,1.10082759}, {505,1.16967}, {510,1.17700}, {515,1.17800}, {520,1.20800}, {525,1.22600}, {530,1.22433}, {535,1.30033}, {540,1.31967}, {545,1.33567}, {550,1.31867}, {555,1.36967}, {560,1.39933}, {565,1.42567}, {570,1.40500}, {575,1.47533}, {580,1.50133}, {585,1.49667}, {590,1.45533}, {595,1.53967}, {600,1.54875}, {605,1.61233}, {610,1.61800}, {615,1.65067}, {620,1.71267}, {625,1.68700}, {630,2.28467}, {635,1.97333}, {640,1.74533}, {645,1.78200}, {650,2.37400}, {655,1.80133}, {660,1.87267}, {665,2.47533}, {670,1.96000}, {675,2.04600}, {680,2.65800}, {685,2.08100}, {690,2.10133}, {695,2.14267}, {700,2.77650}, {705,2.18733}, {710,2.23467}, {715,2.58933}, {720,2.67633}, {725,2.72833}, {730,2.40867}, {735,2.43733}, {740,2.42333}, {745,2.83600}, {750,2.84567}, {755,2.92400}, {760,2.58100}, {765,2.69667}, {770,3.16067}, {775,3.20467}, {780,2.86000}, {785,3.31933}, {790,2.98033}, {795,3.05967}, {800,3.31075}, {805,3.10533}, {810,3.11867}, {815,3.55400}, {820,3.20067}, {825,3.25133}, {830,3.24533}, {835,3.78167}, {840,3.39833}, {845,3.43233}, {850,3.50833}, {855,3.58267}, {860,3.67333}, {865,4.15167}, {870,3.66467}, {875,4.27800}, {880,3.56533}, {885,3.62167}, {890,3.77333}, {895,3.78933}, {900,4.04375}, {905,4.33067}, {910,3.97000}, {915,3.95367}, {920,3.95600}, {925,3.94867}, {930,4.54800}, {935,4.05167}, {940,4.09067}, {945,4.16933}, {950,4.35500}, {955,4.38867}, {960,5.26067}, {965,4.48233}, {970,4.55467}, {975,4.61067}, {980,4.66233}, {985,5.65967}, {990,4.73833}, {995,4.75567}, {1000,4.84900}, {1010,4.92233}, {1020,5.04833}, {1030,5.21833}, {1040,5.31433}, {1050,5.44767}, {1060,5.53200}, {1070,6.53467}, {1080,5.64000}, {1090,6.72933}, {1100,5.92367}, {1110,6.16433}, {1120,6.16600}, {1130,6.21333}, {1140,6.28300}, {1150,7.57267}, {1160,6.58500}, {1170,7.82600}, {1180,6.91300}, {1190,7.02233}, {1200,7.13900}, {1210,7.26233}, {1220,7.41400}, {1230,7.46533}, {1240,7.72100}, {1250,7.77333}, {1260,8.00400}, {1270,8.08267}, {1280,8.22167}, {1290,9.63033}, {1300,9.72133}, {1310,10.03933}, {1320,8.67200}, {1330,10.27067}, {1340,10.52667}, {1350,10.64600}, {1360,10.68867}, {1370,9.60367}, {1380,9.63967}, {1390,9.80400}, {1400,10.33633}, {1410,10.17600}, {1420,12.08333}, {1430,12.03267}, {1440,12.31133}, {1450,12.20100}, {1460,12.20533}, {1470,14.22067}, {1480,11.21133}, {1490,11.66433}, {1500,13.91525}, {1510,11.76800}, {1520,11.99533}, {1530,13.55133}, {1540,15.50300}, {1550,14.19967}, {1560,12.66767}, {1570,15.51933}, {1580,12.42867}, {1590,14.15633}, {1600,15.86133}, {1610,14.72400}, {1620,14.61067}, {1630,16.74633}, {1640,16.88300}, {1650,16.82033}, {1660,18.53967}, {1670,19.26667}, {1680,17.37967}, {1690,16.75467}, {1700,16.05100}, {1710,18.43867}, {1720,14.60000}, {1730,16.72767}, {1740,17.30733}, {1750,17.65000}, {1760,16.81333}, {1770,19.01633}, {1780,21.70167}, {1790,18.14800}, {1800,18.43133}, {1810,17.78500}, {1820,18.83133}, {1830,20.47700}, {1840,20.94733}, {1850,23.24467}, {1860,21.80667}, {1870,22.33200}, {1880,23.96033}, {1890,20.36500}, {1900,21.93000}, {1910,23.67933}, {1920,21.85500}, {1930,24.82067}, {1940,18.65333}, {1950,22.25867}, {1960,22.75333}, {1970,23.19667}, {1980,25.25867}, {1990,21.00633}, {2000,25.92825}, {2050,29.03900}, {2100,27.13533}, {2150,28.06567}, {2200,28.41233}, {2250,32.33933}, {2300,33.50633}, {2350,35.11900}, {2400,36.73300}, {2450,43.15733}, {2500,39.10450}, {2550,43.93633}, {2600,42.73400}, {2650,45.39667}, {2700,45.19633}, {2750,52.12967}, {2800,52.59700}, {2850,56.88600}, {2900,58.95167}, {2950,61.93633}, {3000,63.46225}, {3050,66.17433}, {3100,68.71767}, {3150,65.34767}, {3200,65.45767}, {3250,68.79500}, {3300,66.97367}, {3350,73.11267}, {3400,76.03800}, {3450,73.97900}, {3500,81.82600}, {3550,89.81367}, {3600,91.38833}, {3650,87.02433}, {3700,91.82533}, {3750,93.77200}, {3800,106.21667}, {3850,99.64867}, {3900,102.3630}, {3950,99.7130}, {4000,110.80600}, {4050,110.5535}, {4100,111.5150}, {4150,134.291}, {4500,140.227}};
data["big"]["Parsing"]["reif"]["user"] = {{1,0.00012931}, {2,0.00023276}, {3,0.00041379}, {4,0.00062069}, {5,0.00054310}, {6,0.00097414}, {7,0.00090517}, {8,0.00120690}, {9,0.00124138}, {10,0.00128448}, {11,0.00156897}, {12,0.00162931}, {13,0.00150862}, {14,0.00211207}, {15,0.00198276}, {16,0.00191379}, {17,0.00222414}, {18,0.00260345}, {19,0.00242241}, {20,0.00225862}, {21,0.00269828}, {22,0.00288793}, {23,0.00300000}, {24,0.00355172}, {25,0.00343966}, {26,0.00352586}, {27,0.00352586}, {28,0.00374138}, {29,0.00413793}, {30,0.04378448}, {31,0.00437069}, {32,0.00454310}, {33,0.00539655}, {34,0.00503448}, {35,0.00548276}, {36,0.00550000}, {37,0.00622414}, {38,0.00658621}, {39,0.00601724}, {40,0.00671552}, {41,0.00714655}, {42,0.00740517}, {43,0.00762069}, {44,0.00775862}, {45,0.00820690}, {46,0.00841379}, {47,0.02350862}, {48,0.00862069}, {49,0.00985345}, {50,0.00950862}, {51,0.01014655}, {52,0.01024138}, {53,0.01040517}, {54,0.01050000}, {55,0.01239655}, {56,0.01120690}, {57,0.03184483}, {58,0.01241379}, {59,0.01289655}, {60,0.01300000}, {61,0.01354310}, {62,0.01337069}, {63,0.01418103}, {64,0.01431034}, {65,0.02913793}, {66,0.01541379}, {67,0.01587069}, {68,0.01588793}, {69,0.01610345}, {70,0.01668966}, {71,0.01744828}, {72,0.02755172}, {73,0.01817241}, {74,0.01812069}, {75,0.01864655}, {76,0.01912931}, {77,0.03436207}, {78,0.02033621}, {79,0.02055172}, {80,0.02393103}, {81,0.02200000}, {82,0.04195690}, {83,0.02245690}, {84,0.02296552}, {85,0.02358621}, {86,0.02423276}, {87,0.03468966}, {88,0.02524138}, {89,0.02600000}, {90,0.02602586}, {91,0.03999138}, {92,0.02714655}, {93,0.02773276}, {94,0.02862069}, {95,0.03806897}, {96,0.02893103}, {97,0.03041379}, {98,0.04806897}, {99,0.03068966}, {100,0.03180172}, {101,0.04592241}, {102,0.03274138}, {103,0.03320690}, {104,0.03337931}, {105,0.03987931}, {106,0.03506897}, {107,0.03593966}, {108,0.04855172}, {109,0.03768966}, {110,0.05031034}, {111,0.03817241}, {112,0.03906897}, {113,0.05289655}, {114,0.03992241}, {115,0.04616379}, {116,0.05356034}, {117,0.04251724}, {118,0.05810345}, {119,0.04351724}, {120,0.04406897}, {121,0.05079310}, {122,0.04609483}, {123,0.05404310}, {124,0.04720690}, {125,0.06656034}, {126,0.04856034}, {127,0.06797414}, {128,0.05002586}, {129,0.06962069}, {130,0.05137069}, {131,0.07158621}, {132,0.05219828}, {133,0.07380172}, {134,0.05375000}, {135,0.07424138}, {136,0.05569828}, {137,0.07319828}, {138,0.05696552}, {139,0.06687931}, {140,0.05801724}, {141,0.08731897}, {142,0.10852586}, {143,0.06079310}, {144,0.08884483}, {145,0.06262069}, {146,0.07591379}, {147,0.09341379}, {148,0.06485345}, {149,0.08090517}, {150,0.06652586}, {151,0.07794828}, {152,0.11261207}, {153,0.06829310}, {154,0.08005172}, {155,0.09801724}, {156,0.07144828}, {157,0.07947414}, {158,0.08721552}, {159,0.10422414}, {160,0.07513793}, {161,0.08585345}, {162,0.10995690}, {163,0.10487069}, {164,0.07829310}, {165,0.11095690}, {166,0.11580172}, {167,0.11589655}, {168,0.08260345}, {169,0.08721552}, {170,0.09434483}, {171,0.10286207}, {172,0.14530172}, {173,0.13126724}, {174,0.08814655}, {175,0.09633621}, {176,0.10378448}, {177,0.12367241}, {178,0.12400862}, {179,0.12851724}, {180,0.12814655}, {181,0.11798276}, {182,0.12497414}, {183,0.12590517}, {184,0.13131034}, {185,0.09944828}, {186,0.10500862}, {187,0.10515517}, {188,0.13254310}, {189,0.13326724}, {190,0.13532759}, {191,0.13793103}, {192,0.13772414}, {193,0.15695690}, {194,0.17056897}, {195,0.16288793}, {196,0.14941379}, {197,0.14419828}, {198,0.14496552}, {199,0.14738793}, {200,0.14088793}, {201,0.13522414}, {202,0.14680172}, {203,0.17884483}, {204,0.15539655}, {205,0.15565517}, {206,0.15196552}, {207,0.15373276}, {208,0.15592241}, {209,0.17980172}, {210,0.19880172}, {211,0.17676724}, {212,0.16181034}, {213,0.18636207}, {214,0.17275862}, {215,0.16350000}, {216,0.16235345}, {217,0.20106897}, {218,0.16775862}, {219,0.16562069}, {220,0.20237069}, {221,0.17099138}, {222,0.17187069}, {223,0.20451724}, {224,0.20501724}, {225,0.23212069}, {226,0.18096552}, {227,0.17523276}, {228,0.22001724}, {229,0.16881034}, {230,0.21819828}, {231,0.17948276}, {232,0.21612931}, {233,0.18346552}, {234,0.21997414}, {235,0.18901724}, {236,0.24344828}, {237,0.21538793}, {238,0.24954310}, {239,0.21553448}, {240,0.21138793}, {241,0.22717241}, {242,0.18527586}, {243,0.23360345}, {244,0.22418966}, {245,0.20420690}, {246,0.23524138}, {247,0.23122414}, {248,0.20991379}, {249,0.21986207}, {250,0.28964655}, {251,0.24500862}, {252,0.21850000}, {253,0.25190517}, {254,0.24187931}, {255,0.23986207}, {256,0.24155172}, {257,0.24362069}, {258,0.24582759}, {259,0.25322414}, {260,0.23950000}, {261,0.27738793}, {262,0.25616379}, {263,0.30441379}, {264,0.26638793}, {265,0.26222414}, {266,0.26388793}, {267,0.26597414}, {268,0.26543966}, {269,0.27462931}, {270,0.26143103}, {271,0.29964655}, {272,0.28933621}, {273,0.32237069}, {274,0.28133621}, {275,0.28496552}, {276,0.28492241}, {277,0.28687069}, {278,0.29262931}, {279,0.29817241}, {280,0.31978448}, {281,0.33268103}, {282,0.32542241}, {283,0.29987931}, {284,0.30418103}, {285,0.30908621}, {286,0.31275862}, {287,0.31662069}, {288,0.33239655}, {289,0.34323276}, {290,0.36557759}, {291,0.33868966}, {292,0.32937931}, {293,0.33404310}, {294,0.33250000}, {295,0.33956034}, {296,0.37583621}, {297,0.36775862}, {298,0.38403448}, {299,0.35426724}, {300,0.35163793}, {301,0.35122414}, {302,0.35300862}, {303,0.36024138}, {304,0.43029310}, {305,0.37984483}, {306,0.38050000}, {307,0.36918966}, {308,0.37131034}, {309,0.37191379}, {310,0.37846552}, {311,0.41510345}, {312,0.40450000}, {313,0.41403448}, {314,0.37429310}, {315,0.38806034}, {316,0.38891379}, {317,0.39461207}, {318,0.46639655}, {319,0.42418966}, {320,0.42992241}, {321,0.40813793}, {322,0.40684483}, {323,0.40874138}, {324,0.42111207}, {325,0.44197414}, {326,0.49898276}, {327,0.42761207}, {328,0.42318966}, {329,0.42606034}, {330,0.43513793}, {331,0.52015517}, {332,0.45601724}, {333,0.45818103}, {334,0.44327586}, {335,0.44250862}, {336,0.59724138}, {337,0.47830172}, {338,0.48753448}, {339,0.45718966}, {340,0.45762069}, {341,0.46168103}, {342,0.51988793}, {343,0.50107759}, {344,0.51789655}, {345,0.47384483}, {346,0.47967241}, {347,0.47946552}, {348,0.56838793}, {349,0.51927586}, {350,0.51123276}, {351,0.49343103}, {352,0.49265517}, {353,0.50156897}, {354,0.58606034}, {355,0.52745690}, {356,0.52309483}, {357,0.51049138}, {358,0.51193103}, {359,0.52612931}, {360,0.58125000}, {361,0.59686207}, {362,0.52970690}, {363,0.52619828}, {364,0.53710345}, {365,0.64320690}, {366,0.56485345}, {367,0.55489655}, {368,0.54640517}, {369,0.55080172}, {370,0.66525862}, {371,0.58667241}, {372,0.57557759}, {373,0.56208621}, {374,0.56425862}, {375,0.68542241}, {376,0.60229310}, {377,0.58992241}, {378,0.57711207}, {379,0.58624138}, {380,0.70660345}, {381,0.61935345}, {382,0.59651724}, {383,0.59012931}, {384,0.59946552}, {385,0.70929310}, {386,0.63686207}, {387,0.61312069}, {388,0.60964655}, {389,0.61750862}, {390,0.72578448}, {391,0.65387069}, {392,0.62325000}, {393,0.62412931}, {394,0.63466379}, {395,0.76745690}, {396,0.67447414}, {397,0.64343103}, {398,0.64798276}, {399,0.65284483}, {400,0.78135345}, {401,0.69787069}, {402,0.65223276}, {403,0.66180172}, {404,0.67009483}, {405,0.79097414}, {406,0.71975862}, {407,0.67993966}, {408,0.67811207}, {409,0.73293966}, {410,0.80694828}, {411,0.72287069}, {412,0.69631034}, {413,0.70226724}, {414,0.85464655}, {415,0.75025862}, {416,0.70599138}, {417,0.71025862}, {418,0.75578448}, {419,0.85015517}, {420,0.75850862}, {421,0.72575862}, {422,0.73661207}, {423,0.88448276}, {424,0.79261207}, {425,0.74821552}, {426,0.74419828}, {427,0.90283621}, {428,0.79435345}, {429,0.75963793}, {430,0.76312069}, {431,0.77270690}, {432,0.90788793}, {433,0.82503448}, {434,0.78086207}, {435,0.77867241}, {436,0.92756034}, {437,0.84196552}, {438,0.80781034}, {439,0.79662069}, {440,0.81105172}, {441,0.98497414}, {442,0.84912931}, {443,0.81472414}, {444,0.81512069}, {445,0.99168966}, {446,0.87801724}, {447,0.84040517}, {448,0.82961207}, {449,1.00559483}, {450,0.89529310}, {451,0.84625000}, {452,0.84785345}, {453,0.93605172}, {454,0.98412931}, {455,0.89278448}, {456,0.86513793}, {457,0.90029310}, {458,1.05181897}, {459,0.91506897}, {460,0.87821552}, {461,0.90468103}, {462,1.06972414}, {463,0.93375000}, {464,0.89629310}, {465,0.91962931}, {466,1.09294828}, {467,0.95715517}, {468,0.91217241}, {469,1.55218966}, {470,1.10848276}, {471,0.97125862}, {472,0.93381034}, {473,1.04341379}, {474,1.06481897}, {475,0.96872414}, {476,0.95076724}, {477,1.25527586}, {478,1.03893966}, {479,0.97767241}, {480,0.97226724}, {481,1.07362931}, {482,1.08996552}, {483,1.00140517}, {484,0.98706897}, {485,1.08044828}, {486,1.12839655}, {487,1.02395690}, {488,1.01520690}, {489,1.11760345}, {490,1.14065517}, {491,1.04325000}, {492,1.04107759}, {493,1.14260345}, {494,1.14343966}, {495,1.06447414}, {496,1.09522414}, {497,1.19342241}, {498,1.12615517}, {499,1.06350000}, {500,1.10050000}, {505,1.14500}, {510,1.16400}, {515,1.17800}, {520,1.20633}, {525,1.22467}, {530,1.22133}, {535,1.29233}, {540,1.32000}, {545,1.33400}, {550,1.31800}, {555,1.37033}, {560,1.39800}, {565,1.42200}, {570,1.40367}, {575,1.47667}, {580,1.50067}, {585,1.49533}, {590,1.45700}, {595,1.53800}, {600,1.54975}, {605,1.61167}, {610,1.61867}, {615,1.65000}, {620,1.69633}, {625,1.68367}, {630,2.28200}, {635,1.97367}, {640,1.74100}, {645,1.77533}, {650,2.37467}, {655,1.80167}, {660,1.85833}, {665,2.47367}, {670,1.95133}, {675,2.03167}, {680,2.65400}, {685,2.07133}, {690,2.08867}, {695,2.13967}, {700,2.77550}, {705,2.18633}, {710,2.22233}, {715,2.58700}, {720,2.66900}, {725,2.72267}, {730,2.40267}, {735,2.42067}, {740,2.41733}, {745,2.82733}, {750,2.84233}, {755,2.91633}, {760,2.56467}, {765,2.69600}, {770,3.15533}, {775,3.19800}, {780,2.84700}, {785,3.31567}, {790,2.97033}, {795,3.05600}, {800,3.30625}, {805,3.09733}, {810,3.11367}, {815,3.55033}, {820,3.19833}, {825,3.25033}, {830,3.24367}, {835,3.78267}, {840,3.39267}, {845,3.42867}, {850,3.50600}, {855,3.57400}, {860,3.67333}, {865,4.14833}, {870,3.64333}, {875,4.27433}, {880,3.56667}, {885,3.62167}, {890,3.75700}, {895,3.78300}, {900,4.04175}, {905,4.31800}, {910,3.95800}, {915,3.95600}, {920,3.94967}, {925,3.94600}, {930,4.54733}, {935,4.04367}, {940,4.08900}, {945,4.16733}, {950,4.35433}, {955,4.38467}, {960,5.25433}, {965,4.48333}, {970,4.55433}, {975,4.61000}, {980,4.65967}, {985,5.65400}, {990,4.73833}, {995,4.75533}, {1000,4.84650}, {1010,4.92100}, {1020,5.04700}, {1030,5.21867}, {1040,5.30433}, {1050,5.44767}, {1060,5.53200}, {1070,6.52567}, {1080,5.63933}, {1090,6.73033}, {1100,5.92167}, {1110,6.16500}, {1120,6.14833}, {1130,6.21167}, {1140,6.28200}, {1150,7.57100}, {1160,6.57600}, {1170,7.82733}, {1180,6.91067}, {1190,7.01667}, {1200,7.13833}, {1210,7.25933}, {1220,7.41333}, {1230,7.46667}, {1240,7.71800}, {1250,7.77167}, {1260,7.99133}, {1270,8.07133}, {1280,8.21133}, {1290,9.63133}, {1300,9.72000}, {1310,10.03633}, {1320,8.66067}, {1330,10.26900}, {1340,10.52367}, {1350,10.63667}, {1360,10.68900}, {1370,9.60233}, {1380,9.63333}, {1390,9.80167}, {1400,10.33600}, {1410,10.14233}, {1420,12.08333}, {1430,12.02833}, {1440,12.30800}, {1450,12.19000}, {1460,12.20067}, {1470,14.20067}, {1480,11.20900}, {1490,11.65667}, {1500,13.86175}, {1510,11.74733}, {1520,11.97967}, {1530,13.54900}, {1540,15.50200}, {1550,14.19833}, {1560,12.65300}, {1570,15.49167}, {1580,12.41167}, {1590,14.13433}, {1600,15.84767}, {1610,14.70867}, {1620,14.59433}, {1630,16.73167}, {1640,16.88233}, {1650,16.81967}, {1660,18.53933}, {1670,19.26367}, {1680,17.37767}, {1690,16.73033}, {1700,16.00500}, {1710,18.41233}, {1720,14.56100}, {1730,16.71200}, {1740,17.30067}, {1750,17.64633}, {1760,16.81400}, {1770,18.99567}, {1780,21.70100}, {1790,18.12067}, {1800,18.42367}, {1810,17.77967}, {1820,18.79067}, {1830,20.46833}, {1840,20.93967}, {1850,23.24233}, {1860,21.76967}, {1870,22.31333}, {1880,23.94367}, {1890,20.32467}, {1900,21.92600}, {1910,23.67733}, {1920,21.82567}, {1930,24.81433}, {1940,18.60133}, {1950,22.22200}, {1960,22.69800}, {1970,23.12100}, {1980,25.20200}, {1990,20.98467}, {2000,25.86175}, {2050,28.98600}, {2100,27.13267}, {2150,28.01333}, {2200,28.35300}, {2250,32.26233}, {2300,33.50500}, {2350,35.02933}, {2400,36.69500}, {2450,43.04467}, {2500,39.03950}, {2550,43.93000}, {2600,42.65967}, {2650,45.38333}, {2700,45.09100}, {2750,51.99667}, {2800,52.56100}, {2850,56.81267}, {2900,58.92667}, {2950,61.86633}, {3000,63.34550}, {3050,66.13400}, {3100,68.65000}, {3150,65.34267}, {3200,65.41233}, {3250,68.71300}, {3300,66.93667}, {3350,72.99567}, {3400,75.96867}, {3450,73.90867}, {3500,81.63650}, {3550,89.64267}, {3600,91.34500}, {3650,87.02100}, {3700,91.68633}, {3750,93.62800}, {3800,106.05033}, {3850,99.60467}, {3900,102.2180}, {3950,99.5255}, {4000,110.51567}, {4050,110.4440}, {4100,111.3010}, {4150,134.048}, {4500,139.88}};
data["big"]["Parsing"]["reif"]["system"] = {{1,0.00018103}, {2,0.00041379}, {3,0.00031897}, {4,0.00009483}, {5,0.00012069}, {6,0.00009483}, {7,0.00016379}, {8,0.00012069}, {9,0.00010345}, {10,0.00008621}, {11,0.00006897}, {12,0.00021552}, {13,0.00048276}, {14,0.00023276}, {15,0.00035345}, {16,0.00018966}, {17,0.00034483}, {18,0.00020690}, {19,0.00038793}, {20,0.00044828}, {21,0.00035345}, {22,0.00027586}, {23,0.00037069}, {24,0.00041379}, {25,0.00077586}, {26,0.00055172}, {27,0.00047414}, {28,0.00069828}, {29,0.00083621}, {30,0.00223276}, {31,0.00010345}, {32,0.00016379}, {33,0.00002586}, {34,0.00000000}, {35,0.00002586}, {36,0.00003448}, {37,0.00000000}, {38,0.00003448}, {39,0.00012069}, {40,0.00000000}, {41,0.00003448}, {42,0.00003448}, {43,0.00006034}, {44,0.00003448}, {45,0.00002586}, {46,0.00000000}, {47,0.00020690}, {48,0.00002586}, {49,0.00012931}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00003448}, {55,0.00003448}, {56,0.00000000}, {57,0.00025000}, {58,0.00008621}, {59,0.00003448}, {60,0.00006034}, {61,0.00003448}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00026724}, {66,0.00006897}, {67,0.00000000}, {68,0.00000000}, {69,0.00002586}, {70,0.00003448}, {71,0.00006034}, {72,0.00006897}, {73,0.00012931}, {74,0.00003448}, {75,0.00006034}, {76,0.00003448}, {77,0.00021552}, {78,0.00010345}, {79,0.00010345}, {80,0.00008621}, {81,0.00013793}, {82,0.00022414}, {83,0.00002586}, {84,0.00005172}, {85,0.00006034}, {86,0.00000000}, {87,0.00020690}, {88,0.00010345}, {89,0.00006034}, {90,0.00002586}, {91,0.00012931}, {92,0.00000000}, {93,0.00006897}, {94,0.00013793}, {95,0.00027586}, {96,0.00010345}, {97,0.00006034}, {98,0.00043103}, {99,0.00012931}, {100,0.00003448}, {101,0.00021552}, {102,0.00009483}, {103,0.00002586}, {104,0.00013793}, {105,0.00006034}, {106,0.00000000}, {107,0.00002586}, {108,0.00026724}, {109,0.00008621}, {110,0.00013793}, {111,0.00006897}, {112,0.00006897}, {113,0.00050862}, {114,0.00006897}, {115,0.00013793}, {116,0.00033621}, {117,0.00018103}, {118,0.00056897}, {119,0.00000000}, {120,0.00009483}, {121,0.00012069}, {122,0.00012069}, {123,0.00023276}, {124,0.00012069}, {125,0.00027586}, {126,0.00017241}, {127,0.00033621}, {128,0.00000000}, {129,0.00037069}, {130,0.00006897}, {131,0.00062069}, {132,0.00024138}, {133,0.00056897}, {134,0.00018966}, {135,0.00036207}, {136,0.00006897}, {137,0.00050862}, {138,0.00009483}, {139,0.00044828}, {140,0.00008621}, {141,0.00076724}, {142,0.00055172}, {143,0.00027586}, {144,0.00037931}, {145,0.00006897}, {146,0.00013793}, {147,0.00084483}, {148,0.00033621}, {149,0.00049138}, {150,0.00015517}, {151,0.00012931}, {152,0.00077586}, {153,0.00016379}, {154,0.00032759}, {155,0.00097414}, {156,0.00018966}, {157,0.00042241}, {158,0.00060345}, {159,0.00078448}, {160,0.00031034}, {161,0.00028448}, {162,0.00073276}, {163,0.00069828}, {164,0.00024138}, {165,0.00058621}, {166,0.00006897}, {167,0.00012931}, {168,0.00009483}, {169,0.00006034}, {170,0.00003448}, {171,0.00006897}, {172,0.00009483}, {173,0.00016379}, {174,0.00012069}, {175,0.00023276}, {176,0.00003448}, {177,0.00006034}, {178,0.00008621}, {179,0.00077586}, {180,0.00064655}, {181,0.00100862}, {182,0.00090517}, {183,0.00087931}, {184,0.00068966}, {185,0.00006897}, {186,0.00022414}, {187,0.00003448}, {188,0.00006897}, {189,0.00013793}, {190,0.00016379}, {191,0.00012069}, {192,0.00010345}, {193,0.00010345}, {194,0.00012069}, {195,0.00009483}, {196,0.00009483}, {197,0.00010345}, {198,0.00002586}, {199,0.00016379}, {200,0.00087069}, {201,0.00076724}, {202,0.00061207}, {203,0.00145690}, {204,0.00096552}, {205,0.00100000}, {206,0.00016379}, {207,0.00009483}, {208,0.00012931}, {209,0.00010345}, {210,0.00009483}, {211,0.00006897}, {212,0.00002586}, {213,0.00010345}, {214,0.00003448}, {215,0.00003448}, {216,0.00009483}, {217,0.00010345}, {218,0.00002586}, {219,0.00003448}, {220,0.00003448}, {221,0.00012069}, {222,0.00000000}, {223,0.00002586}, {224,0.00009483}, {225,0.00016379}, {226,0.00010345}, {227,0.00000000}, {228,0.00013793}, {229,0.00006897}, {230,0.00017241}, {231,0.00003448}, {232,0.00003448}, {233,0.00031034}, {234,0.00002586}, {235,0.00006034}, {236,0.00016379}, {237,0.00012931}, {238,0.00013793}, {239,0.00018966}, {240,0.00000000}, {241,0.00063793}, {242,0.00087069}, {243,0.00182759}, {244,0.00209483}, {245,0.00094828}, {246,0.00062931}, {247,0.00012931}, {248,0.00026724}, {249,0.00020690}, {250,0.00027586}, {251,0.00023276}, {252,0.00006034}, {253,0.00020690}, {254,0.00010345}, {255,0.00010345}, {256,0.00017241}, {257,0.00006034}, {258,0.00012931}, {259,0.00006897}, {260,0.00017241}, {261,0.00019828}, {262,0.00019828}, {263,0.00009483}, {264,0.00006897}, {265,0.00017241}, {266,0.00009483}, {267,0.00013793}, {268,0.00010345}, {269,0.00006897}, {270,0.00003448}, {271,0.00010345}, {272,0.00018966}, {273,0.00029310}, {274,0.00145690}, {275,0.00236207}, {276,0.00268103}, {277,0.00210345}, {278,0.00065517}, {279,0.00036207}, {280,0.00043966}, {281,0.00030172}, {282,0.00069828}, {283,0.00135345}, {284,0.00118103}, {285,0.00091379}, {286,0.00050000}, {287,0.00113793}, {288,0.00067241}, {289,0.00103448}, {290,0.00089655}, {291,0.00018966}, {292,0.00023276}, {293,0.00063793}, {294,0.00044828}, {295,0.00052586}, {296,0.00026724}, {297,0.00036207}, {298,0.00006897}, {299,0.00012069}, {300,0.00020690}, {301,0.00020690}, {302,0.00023276}, {303,0.00017241}, {304,0.00020690}, {305,0.00006897}, {306,0.00006034}, {307,0.00017241}, {308,0.00010345}, {309,0.00009483}, {310,0.00023276}, {311,0.00013793}, {312,0.00024138}, {313,0.00022414}, {314,0.00020690}, {315,0.00012931}, {316,0.00020690}, {317,0.00026724}, {318,0.00019828}, {319,0.00006897}, {320,0.00027586}, {321,0.00016379}, {322,0.00024138}, {323,0.00018966}, {324,0.00027586}, {325,0.00017241}, {326,0.00027586}, {327,0.00019828}, {328,0.00010345}, {329,0.00017241}, {330,0.00012931}, {331,0.00012931}, {332,0.00010345}, {333,0.00212931}, {334,0.00406897}, {335,0.00276724}, {336,0.00087069}, {337,0.00026724}, {338,0.00010345}, {339,0.00027586}, {340,0.00032759}, {341,0.00012069}, {342,0.00031034}, {343,0.00009483}, {344,0.00006897}, {345,0.00023276}, {346,0.00017241}, {347,0.00006897}, {348,0.00020690}, {349,0.00017241}, {350,0.00012931}, {351,0.00010345}, {352,0.00017241}, {353,0.00026724}, {354,0.00032759}, {355,0.00014655}, {356,0.00039655}, {357,0.00016379}, {358,0.00020690}, {359,0.00013793}, {360,0.00017241}, {361,0.00013793}, {362,0.00013793}, {363,0.00013793}, {364,0.00033621}, {365,0.00016379}, {366,0.00019828}, {367,0.00003448}, {368,0.00019828}, {369,0.00010345}, {370,0.00023276}, {371,0.00013793}, {372,0.00009483}, {373,0.00012931}, {374,0.00019828}, {375,0.00028448}, {376,0.00020690}, {377,0.00015517}, {378,0.00027586}, {379,0.00026724}, {380,0.00016379}, {381,0.00031897}, {382,0.00024138}, {383,0.00036207}, {384,0.00041379}, {385,0.00030172}, {386,0.00027586}, {387,0.00506034}, {388,0.00624138}, {389,0.00093103}, {390,0.00029310}, {391,0.00030172}, {392,0.00022414}, {393,0.00024138}, {394,0.00020690}, {395,0.00032759}, {396,0.00016379}, {397,0.00031034}, {398,0.00017241}, {399,0.00018103}, {400,0.00034483}, {401,0.00041379}, {402,0.00017241}, {403,0.00050862}, {404,0.00034483}, {405,0.00002586}, {406,0.00020690}, {407,0.00019828}, {408,0.00020690}, {409,0.00012931}, {410,0.00027586}, {411,0.00026724}, {412,0.00030172}, {413,0.00019828}, {414,0.00017241}, {415,0.00031034}, {416,0.00019828}, {417,0.00034483}, {418,0.00026724}, {419,0.00020690}, {420,0.00036207}, {421,0.00027586}, {422,0.00033621}, {423,0.00033621}, {424,0.00056897}, {425,0.00631034}, {426,0.00519828}, {427,0.00041379}, {428,0.00037069}, {429,0.00019828}, {430,0.00020690}, {431,0.00015517}, {432,0.00024138}, {433,0.00018966}, {434,0.00048276}, {435,0.00047414}, {436,0.00019828}, {437,0.00037069}, {438,0.00003448}, {439,0.00026724}, {440,0.00012931}, {441,0.00027586}, {442,0.00012931}, {443,0.00020690}, {444,0.00024138}, {445,0.00022414}, {446,0.00017241}, {447,0.00026724}, {448,0.00020690}, {449,0.00026724}, {450,0.00034483}, {451,0.00010345}, {452,0.00017241}, {453,0.00039655}, {454,0.00030172}, {455,0.00036207}, {456,0.00031034}, {457,0.00030172}, {458,0.00041379}, {459,0.00030172}, {460,0.00017241}, {461,0.00020690}, {462,0.00020690}, {463,0.00030172}, {464,0.00017241}, {465,0.00031034}, {466,0.00030172}, {467,0.00124138}, {468,0.00360345}, {469,0.00136207}, {470,0.00042241}, {471,0.00337931}, {472,0.00596552}, {473,0.00074138}, {474,0.00042241}, {475,0.00019828}, {476,0.00034483}, {477,0.00062931}, {478,0.00034483}, {479,0.00024138}, {480,0.00037931}, {481,0.00037069}, {482,0.00037931}, {483,0.00023276}, {484,0.00006897}, {485,0.00031034}, {486,0.00020690}, {487,0.00019828}, {488,0.00048276}, {489,0.00034483}, {490,0.00030172}, {491,0.00019828}, {492,0.00006897}, {493,0.00032759}, {494,0.00031034}, {495,0.00197414}, {496,0.00225000}, {497,0.00034483}, {498,0.00031897}, {499,0.00020690}, {500,0.00023276}, {505,0.02367}, {510,0.01433}, {515,0.00000}, {520,0.00133}, {525,0.00133}, {530,0.00233}, {535,0.00667}, {540,0.00133}, {545,0.00000}, {550,0.00000}, {555,0.00000}, {560,0.00100}, {565,0.00267}, {570,0.00133}, {575,0.00000}, {580,0.00000}, {585,0.00000}, {590,0.00000}, {595,0.00000}, {600,0.00000}, {605,0.00133}, {610,0.00000}, {615,0.00000}, {620,0.01600}, {625,0.00400}, {630,0.00233}, {635,0.00000}, {640,0.00500}, {645,0.00667}, {650,0.00000}, {655,0.00000}, {660,0.01533}, {665,0.00000}, {670,0.00667}, {675,0.01400}, {680,0.00400}, {685,0.00800}, {690,0.01300}, {695,0.00367}, {700,0.00100}, {705,0.00133}, {710,0.01200}, {715,0.00133}, {720,0.00900}, {725,0.00533}, {730,0.00667}, {735,0.01433}, {740,0.00533}, {745,0.00767}, {750,0.00500}, {755,0.00533}, {760,0.01733}, {765,0.00133}, {770,0.00367}, {775,0.00667}, {780,0.01300}, {785,0.00400}, {790,0.01067}, {795,0.00367}, {800,0.00500}, {805,0.00900}, {810,0.00400}, {815,0.00400}, {820,0.00133}, {825,0.00133}, {830,0.00133}, {835,0.00000}, {840,0.00533}, {845,0.00267}, {850,0.00133}, {855,0.00800}, {860,0.00100}, {865,0.00400}, {870,0.01967}, {875,0.00400}, {880,0.00000}, {885,0.00000}, {890,0.01467}, {895,0.00533}, {900,0.00200}, {905,0.01167}, {910,0.01167}, {915,0.00000}, {920,0.00667}, {925,0.00133}, {930,0.00000}, {935,0.00900}, {940,0.00267}, {945,0.00267}, {950,0.00133}, {955,0.00400}, {960,0.00667}, {965,0.00000}, {970,0.00000}, {975,0.00133}, {980,0.00133}, {985,0.00400}, {990,0.00000}, {995,0.00000}, {1000,0.00200}, {1010,0.00000}, {1020,0.00000}, {1030,0.00000}, {1040,0.00800}, {1050,0.00000}, {1060,0.00000}, {1070,0.00667}, {1080,0.00000}, {1090,0.00000}, {1100,0.00133}, {1110,0.00000}, {1120,0.01600}, {1130,0.00133}, {1140,0.00000}, {1150,0.00000}, {1160,0.01067}, {1170,0.00000}, {1180,0.00267}, {1190,0.00400}, {1200,0.00133}, {1210,0.00133}, {1220,0.00133}, {1230,0.00000}, {1240,0.00133}, {1250,0.00367}, {1260,0.01200}, {1270,0.01067}, {1280,0.01033}, {1290,0.00000}, {1300,0.00133}, {1310,0.00133}, {1320,0.00933}, {1330,0.00000}, {1340,0.00400}, {1350,0.01067}, {1360,0.00000}, {1370,0.00000}, {1380,0.00533}, {1390,0.00133}, {1400,0.00133}, {1410,0.03167}, {1420,0.00000}, {1430,0.00400}, {1440,0.00267}, {1450,0.01200}, {1460,0.00400}, {1470,0.01833}, {1480,0.00267}, {1490,0.00633}, {1500,0.05100}, {1510,0.01967}, {1520,0.01467}, {1530,0.00133}, {1540,0.00133}, {1550,0.00133}, {1560,0.01600}, {1570,0.02933}, {1580,0.01600}, {1590,0.02100}, {1600,0.01333}, {1610,0.01600}, {1620,0.01567}, {1630,0.01433}, {1640,0.00133}, {1650,0.00000}, {1660,0.00000}, {1670,0.00267}, {1680,0.00000}, {1690,0.02400}, {1700,0.04633}, {1710,0.02400}, {1720,0.03733}, {1730,0.01700}, {1740,0.00533}, {1750,0.00267}, {1760,0.00100}, {1770,0.02000}, {1780,0.00000}, {1790,0.02533}, {1800,0.00667}, {1810,0.00400}, {1820,0.04000}, {1830,0.00667}, {1840,0.00633}, {1850,0.00133}, {1860,0.03600}, {1870,0.01833}, {1880,0.01600}, {1890,0.04000}, {1900,0.00133}, {1910,0.00133}, {1920,0.02800}, {1930,0.00533}, {1940,0.05167}, {1950,0.03467}, {1960,0.05567}, {1970,0.07700}, {1980,0.05733}, {1990,0.02133}, {2000,0.06100}, {2050,0.05300}, {2100,0.00267}, {2150,0.05300}, {2200,0.05833}, {2250,0.07733}, {2300,0.00267}, {2350,0.09067}, {2400,0.03833}, {2450,0.11167}, {2500,0.05600}, {2550,0.00533}, {2600,0.07433}, {2650,0.01200}, {2700,0.10400}, {2750,0.13300}, {2800,0.03467}, {2850,0.07300}, {2900,0.02400}, {2950,0.07067}, {3000,0.10400}, {3050,0.04000}, {3100,0.06767}, {3150,0.00533}, {3200,0.04400}, {3250,0.08100}, {3300,0.03533}, {3350,0.11600}, {3400,0.06800}, {3450,0.06933}, {3500,0.17175}, {3550,0.16900}, {3600,0.04267}, {3650,0.00267}, {3700,0.13800}, {3750,0.14267}, {3800,0.16467}, {3850,0.04267}, {3900,0.1435}, {3950,0.1875}, {4000,0.28733}, {4050,0.1095}, {4100,0.2115}, {4150,0.243}, {4500,0.344}};
data["big"]["ParsingElaborated"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000870}, {6,0.00004348}, {7,0.00078261}, {8,0.00081739}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00197391}, {16,0.00131304}, {17,0.00152174}, {18,0.00184348}, {19,0.00200000}, {20,0.00200000}, {21,0.00200000}, {22,0.00298261}, {23,0.00200000}, {24,0.00200000}, {25,0.00200000}, {26,0.00206087}, {27,0.00233913}, {28,0.00296522}, {29,0.00298261}, {30,0.00300000}, {31,0.00300000}, {32,0.00408696}, {33,0.00300000}, {34,0.00300000}, {35,0.00300000}, {36,0.00306087}, {37,0.00336522}, {38,0.00371304}, {39,0.00398261}, {40,0.05750435}, {41,0.00387826}, {42,0.00396522}, {43,0.00398261}, {44,0.00400000}, {45,0.00400000}, {46,0.00400000}, {47,0.00697391}, {48,0.00401739}, {49,0.00400000}, {50,0.00408696}, {51,0.00434783}, {52,0.00463478}, {53,0.00494783}, {54,0.00500000}, {55,0.00500000}, {56,0.00501739}, {57,0.00505217}, {58,0.00506087}, {59,0.00513913}, {60,0.00541739}, {61,0.00573043}, {62,0.00592174}, {63,0.00600000}, {64,0.00600000}, {65,0.00600000}, {66,0.00600870}, {67,0.01191304}, {68,0.00611304}, {69,0.00652174}, {70,0.07798261}, {71,0.00699130}, {72,0.00698261}, {73,0.00700000}, {74,0.00712174}, {75,0.00700870}, {76,0.00706087}, {77,0.00725217}, {78,0.00776522}, {79,0.00780000}, {80,0.00775652}, {81,0.00798261}, {82,0.00809565}, {83,0.00800000}, {84,0.00800870}, {85,0.00802609}, {86,0.00813913}, {87,0.00853043}, {88,0.00883478}, {89,0.00887826}, {90,0.00890435}, {91,0.00894783}, {92,0.06572174}, {93,0.00911304}, {94,0.00900870}, {95,0.00906957}, {96,0.02132174}, {97,0.00907826}, {98,0.00916522}, {99,0.00946957}, {100,0.00983478}, {101,0.00991304}, {102,0.00993913}, {103,0.00998261}, {104,0.01000000}, {105,0.01000870}, {106,0.01002609}, {107,0.01020870}, {108,0.01067826}, {109,0.06221739}, {110,0.01100000}, {111,0.01100870}, {112,0.01100870}, {113,0.01114783}, {114,0.01130435}, {115,0.01153913}, {116,0.01166087}, {117,0.01167826}, {118,0.01168696}, {119,0.01197391}, {120,0.01200000}, {121,0.01200870}, {122,0.01206087}, {123,0.01203478}, {124,0.05059130}, {125,0.01278261}, {126,0.01293043}, {127,0.01296522}, {128,0.01294783}, {129,0.01297391}, {130,0.01317391}, {131,0.01302609}, {132,0.01312174}, {133,0.01328696}, {134,0.01367826}, {135,0.01389565}, {136,0.01388696}, {137,0.09320870}, {138,0.01375652}, {139,0.01372174}, {140,0.01388696}, {141,0.01393043}, {142,0.01400000}, {143,0.01413913}, {144,0.01406087}, {145,0.01404348}, {146,0.01431304}, {147,0.01414783}, {148,0.01435652}, {149,0.05273913}, {150,0.01493043}, {151,0.01492174}, {152,0.01497391}, {153,0.01509565}, {154,0.01506087}, {155,0.01514783}, {156,0.01532174}, {157,0.01544348}, {158,0.01559130}, {159,0.01540000}, {160,0.05324348}, {161,0.01600000}, {162,0.01604348}, {163,0.01615652}, {164,0.01602609}, {165,0.01612174}, {166,0.01634783}, {167,0.01666957}, {168,0.01689565}, {169,0.01693913}, {170,0.01696522}, {171,0.05917391}, {172,0.01714783}, {173,0.01703478}, {174,0.01706957}, {175,0.01708696}, {176,0.01733043}, {177,0.01772174}, {178,0.01791304}, {179,0.01794783}, {180,0.01798261}, {181,0.05982609}, {182,0.01806957}, {183,0.01813043}, {184,0.01812174}, {185,0.01815652}, {186,0.01839130}, {187,0.01888696}, {188,0.01893913}, {189,0.01901739}, {190,0.06019130}, {191,0.01903478}, {192,0.01913913}, {193,0.01916522}, {194,0.01910435}, {195,0.07034783}, {196,0.01996522}, {197,0.01989565}, {198,0.02000870}, {199,0.07963478}, {200,0.02003478}, {201,0.02013043}, {202,0.02042609}, {203,0.02074783}, {204,0.02085217}, {205,0.02080870}, {206,0.02073043}, {207,0.09565217}, {208,0.02176522}, {209,0.02194783}, {210,0.02206957}, {211,0.02205217}, {212,0.02210435}, {213,0.02208696}, {214,0.02219130}, {215,0.02259130}, {216,0.08388696}, {217,0.02292174}, {218,0.02293913}, {219,0.02300000}, {220,0.02300870}, {221,0.02310435}, {222,0.02315652}, {223,0.02350435}, {224,0.07128696}, {225,0.02386957}, {226,0.02388696}, {227,0.02384348}, {228,0.02393913}, {229,0.02401739}, {230,0.02462609}, {231,0.02423478}, {232,0.06054783}, {233,0.02482609}, {234,0.02493043}, {235,0.02510435}, {236,0.02489565}, {237,0.02506087}, {238,0.02622609}, {239,0.06938261}, {240,0.02550435}, {241,0.02558261}, {242,0.02592174}, {243,0.02585217}, {244,0.02598261}, {245,0.02601739}, {246,0.07409565}, {247,0.02633043}, {248,0.02629565}, {249,0.02661739}, {250,0.02673043}, {251,0.02660000}, {252,0.02673043}, {253,0.10032174}, {254,0.02720870}, {255,0.02736522}, {256,0.02726087}, {257,0.02711304}, {258,0.02722609}, {259,0.02772174}, {260,0.07811304}, {261,0.02779130}, {262,0.02790435}, {263,0.02800000}, {264,0.02799130}, {265,0.02814783}, {266,0.02815652}, {267,0.07135652}, {268,0.02880000}, {269,0.02885217}, {270,0.02888696}, {271,0.02893043}, {272,0.02900000}, {273,0.02912174}, {274,0.06224348}, {275,0.02830435}, {276,0.12993043}, {277,0.02891304}, {278,0.02893043}, {279,0.12380000}, {280,0.02906957}, {281,0.02905217}, {282,0.02911304}, {283,0.02918261}, {284,0.02945217}, {285,0.06961739}, {286,0.02984348}, {287,0.02998261}, {288,0.03004348}, {289,0.03003478}, {290,0.03009565}, {291,0.03026087}, {292,0.06969565}, {293,0.03064348}, {294,0.03080870}, {295,0.03087826}, {296,0.03095652}, {297,0.03106957}, {298,0.07166087}, {299,0.03115652}, {300,0.03123478}, {301,0.03142609}, {302,0.03162609}, {303,0.07556522}, {304,0.03194783}, {305,0.03196522}, {306,0.03203478}, {307,0.03210435}, {308,0.03235652}, {309,0.09420870}, {310,0.03246957}, {311,0.03279130}, {312,0.03286957}, {313,0.03300870}, {314,0.03302609}, {315,0.07620870}, {316,0.03319130}, {317,0.03340000}, {318,0.03355652}, {319,0.03382609}, {320,0.03375652}, {321,0.06021739}, {322,0.03397391}, {323,0.03401739}, {324,0.03407826}, {325,0.03421739}, {326,0.12957391}, {327,0.03580870}, {328,0.03592174}, {329,0.03606087}, {330,0.03606087}, {331,0.09406957}, {332,0.03650435}, {333,0.03661739}, {334,0.03664348}, {335,0.03673913}, {336,0.03691304}, {337,0.08888696}, {338,0.04012174}, {339,0.03724348}, {340,0.03735652}, {341,0.03755652}, {342,0.07744348}, {343,0.03785217}, {344,0.03797391}, {345,0.03802609}, {346,0.03815652}, {347,0.08401739}, {348,0.03836522}, {349,0.03865217}, {350,0.03934783}, {351,0.03883478}, {352,0.09401739}, {353,0.03916522}, {354,0.03925217}, {355,0.03931304}, {356,0.03946087}, {357,0.11413913}, {358,0.03972174}, {359,0.03973043}, {360,0.04002609}, {361,0.04013913}, {362,0.12025217}, {363,0.04021739}, {364,0.04058261}, {365,0.04049565}, {366,0.04074783}, {367,0.11944348}, {368,0.04114783}, {369,0.04126957}, {370,0.04128696}, {371,0.04118261}, {372,0.10452174}, {373,0.04137391}, {374,0.04153043}, {375,0.04180000}, {376,0.04202609}, {377,0.07629565}, {378,0.04218261}, {379,0.04230435}, {380,0.04235652}, {381,0.08732174}, {382,0.04266957}, {383,0.04286087}, {384,0.04300000}, {385,0.04299130}, {386,0.08564348}, {387,0.04338261}, {388,0.04353043}, {389,0.04352174}, {390,0.09686957}, {391,0.04373913}, {392,0.24049565}, {393,0.04288696}, {394,0.13680870}, {395,0.04281739}, {396,0.04289565}, {397,0.04300870}, {398,0.08079130}, {399,0.04336522}, {400,0.04343478}, {401,0.04354783}, {402,0.04380000}, {403,0.09373043}, {404,0.04384348}, {405,0.04398261}, {406,0.04400870}, {407,0.08357391}, {408,0.04426087}, {409,0.04446957}, {410,0.04465217}, {411,0.08453043}, {412,0.04488696}, {413,0.04495652}, {414,0.04510435}, {415,0.04510435}, {416,0.08679130}, {417,0.04556522}, {418,0.04553043}, {419,0.04568696}, {420,0.08420870}, {421,0.04600870}, {422,0.04612174}, {423,0.04618261}, {424,0.08418261}, {425,0.04645217}, {426,0.04680000}, {427,0.04679130}, {428,0.08763478}, {429,0.04699130}, {430,0.04706957}, {431,0.04722609}, {432,0.08836522}, {433,0.04768696}, {434,0.04769565}, {435,0.04785217}, {436,0.04793913}, {437,0.08656522}, {438,0.04811304}, {439,0.04819130}, {440,0.04828696}, {441,0.08716522}, {442,0.04873043}, {443,0.04885217}, {444,0.04894783}, {445,0.08641739}, {446,0.04905217}, {447,0.04919130}, {448,0.04940000}, {449,0.08880870}, {450,0.04966087}, {451,0.04978261}, {452,0.04994783}, {453,0.09040000}, {454,0.05015652}, {455,0.05023478}, {456,0.09540000}, {457,0.05046957}, {458,0.05075652}, {459,0.05080000}, {460,0.11756522}, {461,0.05102609}, {462,0.05114783}, {463,0.05125217}, {464,0.15617391}, {465,0.05319130}, {466,0.05335652}, {467,0.05360000}, {468,0.11586957}, {469,0.05385217}, {470,0.05406087}, {471,0.05407826}, {472,0.10232174}, {473,0.05433913}, {474,0.05451304}, {475,0.05462609}, {476,0.08709565}, {477,0.05495652}, {478,0.05497391}, {479,0.09901739}, {480,0.05520000}, {481,0.05547826}, {482,0.05560870}, {483,0.10692174}, {484,0.05580000}, {485,0.05593913}, {486,0.05600000}, {487,0.12169565}, {488,0.05641739}, {489,0.05667826}, {490,0.13707826}, {491,0.05685217}, {492,0.05693043}, {493,0.05703478}, {494,0.14198261}, {495,0.05723478}, {496,0.05756522}, {497,0.13182609}, {498,0.05781739}, {499,0.05798261}, {500,0.103528384}, {505,0.05889474}, {510,0.05950000}, {515,0.06007895}, {520,0.12678070}, {525,0.06152632}, {530,0.06221053}, {535,0.17248246}, {540,0.06369298}, {545,0.06445614}, {550,0.14132456}, {555,0.06589474}, {560,0.06658772}, {565,0.11584211}, {570,0.06799123}, {575,0.06871930}, {580,0.11538596}, {585,0.07014912}, {590,0.07084211}, {595,0.11857018}, {600,0.07226087}, {605,0.07300877}, {610,0.12071053}, {615,0.07468421}, {620,0.07535965}, {625,0.12393860}, {630,0.07689474}, {635,0.07759649}, {640,0.12514035}, {645,0.07913158}, {650,0.07995614}, {655,0.12137719}, {660,0.08155263}, {665,0.12123684}, {670,0.08313158}, {675,0.08392982}, {680,0.13475439}, {685,0.08539474}, {690,0.08612281}, {695,0.12594737}, {700,0.08513043}, {705,0.12587719}, {710,0.08663158}, {715,0.08742105}, {720,0.14843860}, {725,0.08901754}, {730,0.63685965}, {735,0.25885965}, {740,0.09173684}, {745,0.09258772}, {750,0.13750877}, {755,0.09412281}, {760,0.13366667}, {765,0.09582456}, {770,0.13929825}, {775,0.09747368}, {780,0.09816667}, {785,0.14649123}, {790,0.09994737}, {795,0.14467544}, {800,0.10154783}, {805,0.14591228}, {810,0.10322807}, {815,0.14406140}, {820,0.10494737}, {825,0.10573684}, {830,0.19558772}, {835,0.11049123}, {840,0.21104386}, {845,0.11213158}, {850,0.16114912}, {855,0.11405263}, {860,0.15431579}, {865,0.11580702}, {870,0.15660526}, {875,0.11788596}, {880,0.17031579}, {885,0.11959649}, {890,0.16334211}, {895,0.12142105}, {900,0.16434783}, {905,0.12340351}, {910,0.16663158}, {915,0.12528070}, {920,0.16809649}, {925,0.12740351}, {930,0.16608772}, {935,0.12904386}, {940,0.16287719}, {945,0.13178070}, {950,0.16789474}, {955,0.18628947}, {960,0.13558772}, {965,0.18960526}, {970,0.13715789}, {975,0.19213158}, {980,0.13942982}, {985,0.18803509}, {990,0.14387719}, {995,0.17930702}, {1000,0.18301739}, {1010,0.20450}, {1020,0.14425}, {1030,0.22925}, {1040,0.14725}, {1050,0.22925}, {1060,0.15325}, {1070,0.17675}, {1080,0.20625}, {1090,0.15925}, {1100,0.23450}, {1110,0.19425}, {1120,0.16300}, {1130,0.21450}, {1140,0.16675}, {1150,0.19450}, {1160,0.22875}, {1170,0.17350}, {1180,0.25600}, {1190,0.23875}, {1200,0.18025}, {1210,0.20975}, {1220,0.26125}, {1230,0.23275}, {1240,0.19425}, {1250,0.25075}, {1260,0.24025}, {1270,0.20100}, {1280,0.25600}, {1290,0.25975}, {1300,0.27125}, {1310,0.21125}, {1320,0.26525}, {1330,0.24125}, {1340,0.41000}, {1350,0.21625}, {1360,0.25700}, {1370,0.26975}, {1380,0.27000}, {1390,0.22800}, {1400,0.27300}, {1410,0.27600}, {1420,0.31800}, {1430,0.30300}, {1440,0.24400}, {1450,0.28675}, {1460,0.29850}, {1470,0.29475}, {1480,0.32450}, {1490,0.34825}, {1500,0.27540}, {1510,0.33800}, {1520,0.35300}, {1530,0.31000}, {1540,0.31500}, {1550,0.32325}, {1560,0.34450}, {1570,0.27950}, {1580,0.29925}, {1590,0.31250}, {1600,0.56900}, {1610,0.39225}, {1620,0.32975}, {1630,0.33050}, {1640,0.33375}, {1650,0.33875}, {1660,0.34725}, {1670,0.33625}, {1680,0.40350}, {1690,0.38250}, {1700,0.37425}, {1710,0.37325}, {1720,0.38400}, {1730,0.43050}, {1740,0.45425}, {1750,0.44100}, {1760,0.44300}, {1770,0.43950}, {1780,0.40225}, {1790,0.40525}, {1800,0.40900}, {1810,0.41400}, {1820,0.43325}, {1830,0.41900}, {1840,0.39825}, {1850,0.41325}, {1860,0.41425}, {1870,0.41650}, {1880,0.41800}, {1890,0.42200}, {1900,0.42175}, {1910,0.41825}, {1920,0.42050}, {1930,0.42275}, {1940,0.41350}, {1950,0.41025}, {1960,0.47200}, {1970,0.45525}, {1980,0.45700}, {1990,0.46100}, {2000,0.47740}, {2050,0.48100}, {2100,0.54125}, {2150,1.73475}, {2200,0.59725}, {2250,0.58925}, {2300,0.60225}, {2350,0.60575}, {2400,0.64250}, {2450,0.66225}, {2500,0.67780}, {2550,0.70850}, {2600,0.72175}, {2650,0.74775}, {2700,0.78225}, {2750,0.78425}, {2800,0.78200}, {2850,0.82250}, {2900,0.86625}, {2950,0.87175}, {3000,0.89640}, {3050,0.93175}, {3100,0.91850}, {3150,0.96125}, {3200,0.97500}, {3250,0.98750}, {3300,1.03850}, {3350,1.12825}, {3400,1.13000}, {3450,1.17675}, {3500,1.21040}, {3550,1.29400}, {3600,1.33025}, {3650,1.34500}, {3700,1.41125}, {3750,1.45450}, {3800,1.42750}, {3850,1.39250}, {3900,1.40075}, {3950,1.42100}, {4000,1.46800}, {4050,1.51825}, {4100,1.50325}, {4150,1.54825}, {4200,1.58625}, {4250,1.56675}, {4300,1.65725}, {4350,1.62325}, {4400,1.68975}, {4450,1.69050}, {4500,3.11880}, {4550,1.83225}, {4600,1.91650}, {4650,2.01000}, {4700,1.96525}, {4750,2.07150}, {4800,2.22050}, {4850,2.16375}, {4900,2.06050}, {4950,2.09825}, {5000,2.13020}, {5050,2.3340}, {5100,2.3470}, {5150,2.3755}};
data["big"]["ParsingElaborated"]["actual reif"]["user"] = {{1,0.00011304}, {2,0.00024348}, {3,0.00023478}, {4,0.00060000}, {5,0.00073913}, {6,0.00095652}, {7,0.00090435}, {8,0.00092174}, {9,0.00110435}, {10,0.00125217}, {11,0.00119130}, {12,0.00174783}, {13,0.00133913}, {14,0.00164348}, {15,0.00173913}, {16,0.00177391}, {17,0.00188696}, {18,0.00186087}, {19,0.00190435}, {20,0.00208696}, {21,0.00225217}, {22,0.00306957}, {23,0.00228696}, {24,0.00260000}, {25,0.00226087}, {26,0.00246087}, {27,0.00273043}, {28,0.00271304}, {29,0.00266087}, {30,0.00272174}, {31,0.00295652}, {32,0.00439130}, {33,0.00347826}, {34,0.00320870}, {35,0.00345217}, {36,0.00343478}, {37,0.00348696}, {38,0.00364348}, {39,0.00363478}, {40,0.05470435}, {41,0.00412174}, {42,0.00417391}, {43,0.00399130}, {44,0.00424348}, {45,0.00402609}, {46,0.00440000}, {47,0.00710435}, {48,0.00458261}, {49,0.00447826}, {50,0.00447826}, {51,0.00495652}, {52,0.00493913}, {53,0.00506957}, {54,0.00545217}, {55,0.00542609}, {56,0.00562609}, {57,0.00579130}, {58,0.00587826}, {59,0.00575652}, {60,0.00583478}, {61,0.00588696}, {62,0.00593913}, {63,0.00607826}, {64,0.00581739}, {65,0.00613043}, {66,0.00635652}, {67,0.01212174}, {68,0.00692174}, {69,0.00684348}, {70,0.07733913}, {71,0.00713043}, {72,0.00707826}, {73,0.00722609}, {74,0.00744348}, {75,0.00757391}, {76,0.00778261}, {77,0.00785217}, {78,0.00793043}, {79,0.00803478}, {80,0.00802609}, {81,0.00795652}, {82,0.00825217}, {83,0.00853913}, {84,0.00843478}, {85,0.00833913}, {86,0.00876522}, {87,0.00869565}, {88,0.00884348}, {89,0.00937391}, {90,0.00886957}, {91,0.00920870}, {92,0.06488696}, {93,0.00943478}, {94,0.00962609}, {95,0.00942609}, {96,0.02181739}, {97,0.00933913}, {98,0.00997391}, {99,0.00973913}, {100,0.01019130}, {101,0.01019130}, {102,0.01008696}, {103,0.01022609}, {104,0.01074783}, {105,0.01043478}, {106,0.01041739}, {107,0.01070435}, {108,0.01115652}, {109,0.06082609}, {110,0.01132174}, {111,0.01144348}, {112,0.01163478}, {113,0.01182609}, {114,0.01175652}, {115,0.01175652}, {116,0.01179130}, {117,0.01193043}, {118,0.01192174}, {119,0.01209565}, {120,0.01241739}, {121,0.01226087}, {122,0.01254783}, {123,0.01231304}, {124,0.05033913}, {125,0.01293043}, {126,0.01313913}, {127,0.01327826}, {128,0.01348696}, {129,0.01339130}, {130,0.01360000}, {131,0.01324348}, {132,0.01384348}, {133,0.01370435}, {134,0.01405217}, {135,0.01401739}, {136,0.01384348}, {137,0.09227826}, {138,0.01353913}, {139,0.01367826}, {140,0.01399130}, {141,0.01417391}, {142,0.01411304}, {143,0.01483478}, {144,0.01459130}, {145,0.01475652}, {146,0.01444348}, {147,0.01436522}, {148,0.01470435}, {149,0.05213043}, {150,0.01507826}, {151,0.01498261}, {152,0.01529565}, {153,0.01550435}, {154,0.01547826}, {155,0.01589565}, {156,0.01589565}, {157,0.01582609}, {158,0.01582609}, {159,0.01586087}, {160,0.05313913}, {161,0.01620870}, {162,0.01620870}, {163,0.01655652}, {164,0.01638261}, {165,0.01674783}, {166,0.01676522}, {167,0.01708696}, {168,0.01679130}, {169,0.01662609}, {170,0.01721739}, {171,0.05787826}, {172,0.01757391}, {173,0.01731304}, {174,0.01758261}, {175,0.01753043}, {176,0.01793043}, {177,0.01791304}, {178,0.01790435}, {179,0.01840000}, {180,0.01825217}, {181,0.05965217}, {182,0.01835652}, {183,0.01860870}, {184,0.01849565}, {185,0.01858261}, {186,0.01888696}, {187,0.01928696}, {188,0.01891304}, {189,0.01876522}, {190,0.05973913}, {191,0.01901739}, {192,0.01922609}, {193,0.01956522}, {194,0.01966087}, {195,0.07020000}, {196,0.02004348}, {197,0.02000000}, {198,0.02033913}, {199,0.07797391}, {200,0.02000000}, {201,0.02033913}, {202,0.02058261}, {203,0.02086087}, {204,0.02091304}, {205,0.02093913}, {206,0.02087826}, {207,0.09441739}, {208,0.02193913}, {209,0.02211304}, {210,0.02207826}, {211,0.02269565}, {212,0.02246957}, {213,0.02246957}, {214,0.02284348}, {215,0.02263478}, {216,0.08340870}, {217,0.02316522}, {218,0.02319130}, {219,0.02344348}, {220,0.02309565}, {221,0.02323478}, {222,0.02360000}, {223,0.02375652}, {224,0.07073043}, {225,0.02386957}, {226,0.02414783}, {227,0.02385217}, {228,0.02433043}, {229,0.02446957}, {230,0.02473913}, {231,0.02437391}, {232,0.05973913}, {233,0.02488696}, {234,0.02494783}, {235,0.02482609}, {236,0.02523478}, {237,0.02500000}, {238,0.02671304}, {239,0.06878261}, {240,0.02521739}, {241,0.02566957}, {242,0.02598261}, {243,0.02577391}, {244,0.02603478}, {245,0.02628696}, {246,0.07306087}, {247,0.02622609}, {248,0.02591304}, {249,0.02622609}, {250,0.02671304}, {251,0.02662609}, {252,0.02695652}, {253,0.09986957}, {254,0.02695652}, {255,0.02721739}, {256,0.02722609}, {257,0.02690435}, {258,0.02721739}, {259,0.02741739}, {260,0.07741739}, {261,0.02740000}, {262,0.02754783}, {263,0.02794783}, {264,0.02773913}, {265,0.02779130}, {266,0.02815652}, {267,0.07064348}, {268,0.02866087}, {269,0.02842609}, {270,0.02881739}, {271,0.02906957}, {272,0.02917391}, {273,0.02888696}, {274,0.06172174}, {275,0.02812174}, {276,0.12941739}, {277,0.02828696}, {278,0.02896522}, {279,0.12146087}, {280,0.02853913}, {281,0.02893913}, {282,0.02898261}, {283,0.02928696}, {284,0.02935652}, {285,0.06876522}, {286,0.02992174}, {287,0.03017391}, {288,0.02996522}, {289,0.03002609}, {290,0.03040000}, {291,0.03057391}, {292,0.06918261}, {293,0.03076522}, {294,0.03070435}, {295,0.03076522}, {296,0.03110435}, {297,0.03109565}, {298,0.07126957}, {299,0.03127826}, {300,0.03145217}, {301,0.03180000}, {302,0.03171304}, {303,0.07539130}, {304,0.03195652}, {305,0.03204348}, {306,0.03208696}, {307,0.03246957}, {308,0.03232174}, {309,0.09389565}, {310,0.03250435}, {311,0.03263478}, {312,0.03316522}, {313,0.03314783}, {314,0.03330435}, {315,0.07589565}, {316,0.03314783}, {317,0.03344348}, {318,0.03336522}, {319,0.03355652}, {320,0.03400870}, {321,0.05964348}, {322,0.03348696}, {323,0.03422609}, {324,0.03386087}, {325,0.03401739}, {326,0.12833913}, {327,0.03544348}, {328,0.03558261}, {329,0.03577391}, {330,0.03574783}, {331,0.09311304}, {332,0.03614783}, {333,0.03633043}, {334,0.03640000}, {335,0.03625217}, {336,0.03651304}, {337,0.08806087}, {338,0.03934783}, {339,0.03693043}, {340,0.03671304}, {341,0.03693043}, {342,0.07651304}, {343,0.03723478}, {344,0.03746957}, {345,0.03742609}, {346,0.03774783}, {347,0.08299130}, {348,0.03828696}, {349,0.03821739}, {350,0.03882609}, {351,0.03833043}, {352,0.09328696}, {353,0.03882609}, {354,0.03891304}, {355,0.03914783}, {356,0.03926087}, {357,0.11301739}, {358,0.03933043}, {359,0.03948696}, {360,0.03958261}, {361,0.04017391}, {362,0.11904348}, {363,0.03985217}, {364,0.04028696}, {365,0.04031304}, {366,0.04033043}, {367,0.11898261}, {368,0.04094783}, {369,0.04095652}, {370,0.04106957}, {371,0.04088696}, {372,0.10380000}, {373,0.04089565}, {374,0.04109565}, {375,0.04190435}, {376,0.04154783}, {377,0.07596522}, {378,0.04197391}, {379,0.04184348}, {380,0.04212174}, {381,0.08653043}, {382,0.04271304}, {383,0.04253043}, {384,0.04302609}, {385,0.04291304}, {386,0.08472174}, {387,0.04330435}, {388,0.04340870}, {389,0.04320870}, {390,0.09536522}, {391,0.04365217}, {392,0.23926957}, {393,0.04271304}, {394,0.13080000}, {395,0.04238261}, {396,0.04271304}, {397,0.04270435}, {398,0.07976522}, {399,0.04335652}, {400,0.04337391}, {401,0.04321739}, {402,0.04373043}, {403,0.09237391}, {404,0.04385217}, {405,0.04387826}, {406,0.04396522}, {407,0.08252174}, {408,0.04421739}, {409,0.04460000}, {410,0.04431304}, {411,0.08333043}, {412,0.04519130}, {413,0.04473043}, {414,0.04520000}, {415,0.04474783}, {416,0.08657391}, {417,0.04523478}, {418,0.04560870}, {419,0.04565217}, {420,0.08258261}, {421,0.04600870}, {422,0.04620870}, {423,0.04635652}, {424,0.08330435}, {425,0.04615652}, {426,0.04646087}, {427,0.04663478}, {428,0.08673913}, {429,0.04682609}, {430,0.04732174}, {431,0.04737391}, {432,0.08700870}, {433,0.04763478}, {434,0.04787826}, {435,0.04793043}, {436,0.04800870}, {437,0.08582609}, {438,0.04800870}, {439,0.04840000}, {440,0.04829565}, {441,0.08618261}, {442,0.04878261}, {443,0.04866087}, {444,0.04858261}, {445,0.08510435}, {446,0.04873913}, {447,0.04905217}, {448,0.04912174}, {449,0.08855652}, {450,0.04943478}, {451,0.04968696}, {452,0.04986087}, {453,0.09012174}, {454,0.04980000}, {455,0.04993913}, {456,0.09505217}, {457,0.05016522}, {458,0.05010435}, {459,0.05049565}, {460,0.11712174}, {461,0.05075652}, {462,0.05066087}, {463,0.05075652}, {464,0.15477391}, {465,0.05271304}, {466,0.05270435}, {467,0.05302609}, {468,0.11456522}, {469,0.05349565}, {470,0.05347826}, {471,0.05381739}, {472,0.10102609}, {473,0.05394783}, {474,0.05400870}, {475,0.05427826}, {476,0.08643478}, {477,0.05447826}, {478,0.05479130}, {479,0.09772174}, {480,0.05513043}, {481,0.05544348}, {482,0.05552174}, {483,0.10587826}, {484,0.05561739}, {485,0.05573043}, {486,0.05601739}, {487,0.12074783}, {488,0.05606087}, {489,0.05617391}, {490,0.13663478}, {491,0.05648696}, {492,0.05646957}, {493,0.05702609}, {494,0.14040870}, {495,0.05678261}, {496,0.05760000}, {497,0.13053913}, {498,0.05719130}, {499,0.05774783}, {500,0.102925764}, {505,0.05843860}, {510,0.05894737}, {515,0.05970175}, {520,0.12618421}, {525,0.06126316}, {530,0.06206140}, {535,0.17107018}, {540,0.06351754}, {545,0.06409649}, {550,0.14019298}, {555,0.06599123}, {560,0.06614035}, {565,0.11453509}, {570,0.06754386}, {575,0.06837719}, {580,0.11372807}, {585,0.06950877}, {590,0.06991228}, {595,0.11718421}, {600,0.07158261}, {605,0.07231579}, {610,0.11930702}, {615,0.07445614}, {620,0.07516667}, {625,0.12219298}, {630,0.07683333}, {635,0.07735965}, {640,0.12414035}, {645,0.07837719}, {650,0.07944737}, {655,0.12025439}, {660,0.08094737}, {665,0.11987719}, {670,0.08212281}, {675,0.08287719}, {680,0.13373684}, {685,0.08450000}, {690,0.08528947}, {695,0.12527193}, {700,0.08434783}, {705,0.12467544}, {710,0.08635088}, {715,0.08717544}, {720,0.14633333}, {725,0.08839474}, {730,0.62993860}, {735,0.25164035}, {740,0.09111404}, {745,0.09200877}, {750,0.13668421}, {755,0.09367544}, {760,0.13307895}, {765,0.09598246}, {770,0.13921930}, {775,0.09692982}, {780,0.09784211}, {785,0.14592982}, {790,0.09966667}, {795,0.14421930}, {800,0.10105217}, {805,0.14530702}, {810,0.10240351}, {815,0.14315789}, {820,0.10415789}, {825,0.10507018}, {830,0.19421053}, {835,0.10978070}, {840,0.20927193}, {845,0.11149123}, {850,0.15995614}, {855,0.11323684}, {860,0.15231579}, {865,0.11453509}, {870,0.15547368}, {875,0.11671930}, {880,0.16913158}, {885,0.11887719}, {890,0.16235965}, {895,0.12028070}, {900,0.16298261}, {905,0.12266667}, {910,0.16492105}, {915,0.12449123}, {920,0.16655263}, {925,0.12707018}, {930,0.16427193}, {935,0.12807018}, {940,0.16136842}, {945,0.13065789}, {950,0.16437719}, {955,0.18203509}, {960,0.13399123}, {965,0.18785965}, {970,0.13604386}, {975,0.18896491}, {980,0.13836842}, {985,0.18505263}, {990,0.14124561}, {995,0.17738596}, {1000,0.18164348}, {1010,0.18875}, {1020,0.14400}, {1030,0.22750}, {1040,0.14675}, {1050,0.22200}, {1060,0.15325}, {1070,0.17675}, {1080,0.20200}, {1090,0.15650}, {1100,0.22875}, {1110,0.19425}, {1120,0.16100}, {1130,0.21300}, {1140,0.16600}, {1150,0.19275}, {1160,0.22650}, {1170,0.17275}, {1180,0.25125}, {1190,0.23650}, {1200,0.18000}, {1210,0.20850}, {1220,0.26125}, {1230,0.23325}, {1240,0.19275}, {1250,0.24900}, {1260,0.23725}, {1270,0.20050}, {1280,0.25050}, {1290,0.25950}, {1300,0.26675}, {1310,0.20750}, {1320,0.26425}, {1330,0.23825}, {1340,0.40575}, {1350,0.21550}, {1360,0.25550}, {1370,0.26650}, {1380,0.26875}, {1390,0.22550}, {1400,0.27175}, {1410,0.27475}, {1420,0.31575}, {1430,0.29925}, {1440,0.23925}, {1450,0.28625}, {1460,0.29650}, {1470,0.29250}, {1480,0.32200}, {1490,0.34625}, {1500,0.27160}, {1510,0.33725}, {1520,0.34975}, {1530,0.30825}, {1540,0.31350}, {1550,0.32150}, {1560,0.34175}, {1570,0.27725}, {1580,0.29575}, {1590,0.31025}, {1600,0.56450}, {1610,0.38775}, {1620,0.32750}, {1630,0.32925}, {1640,0.33125}, {1650,0.33550}, {1660,0.34650}, {1670,0.32900}, {1680,0.40250}, {1690,0.37950}, {1700,0.37375}, {1710,0.37125}, {1720,0.38350}, {1730,0.42925}, {1740,0.45125}, {1750,0.43850}, {1760,0.43850}, {1770,0.43625}, {1780,0.39850}, {1790,0.40525}, {1800,0.40650}, {1810,0.41275}, {1820,0.43000}, {1830,0.41450}, {1840,0.39725}, {1850,0.41075}, {1860,0.41075}, {1870,0.41625}, {1880,0.41375}, {1890,0.41725}, {1900,0.41575}, {1910,0.41750}, {1920,0.41875}, {1930,0.42175}, {1940,0.41350}, {1950,0.40950}, {1960,0.47200}, {1970,0.45225}, {1980,0.45450}, {1990,0.46050}, {2000,0.47640}, {2050,0.47975}, {2100,0.53975}, {2150,1.63700}, {2200,0.58750}, {2250,0.57175}, {2300,0.58825}, {2350,0.59675}, {2400,0.62825}, {2450,0.65075}, {2500,0.66500}, {2550,0.69250}, {2600,0.70875}, {2650,0.73100}, {2700,0.76250}, {2750,0.76700}, {2800,0.76875}, {2850,0.81000}, {2900,0.84425}, {2950,0.85475}, {3000,0.88320}, {3050,0.91625}, {3100,0.90050}, {3150,0.94825}, {3200,0.96775}, {3250,0.98550}, {3300,1.03625}, {3350,1.12175}, {3400,1.12750}, {3450,1.16500}, {3500,1.19320}, {3550,1.27450}, {3600,1.31075}, {3650,1.32125}, {3700,1.39150}, {3750,1.42850}, {3800,1.41075}, {3850,1.37250}, {3900,1.38325}, {3950,1.39950}, {4000,1.45060}, {4050,1.49425}, {4100,1.48050}, {4150,1.51850}, {4200,1.56175}, {4250,1.54500}, {4300,1.63100}, {4350,1.61675}, {4400,1.68725}, {4450,1.68500}, {4500,2.94600}, {4550,1.81425}, {4600,1.91175}, {4650,2.00575}, {4700,1.95925}, {4750,2.06725}, {4800,2.18900}, {4850,2.13725}, {4900,2.02725}, {4950,2.06475}, {5000,2.11180}, {5050,2.2555}, {5100,2.2490}, {5150,2.2635}};
data["big"]["ParsingElaborated"]["actual reif"]["system"] = {{1,0.00024348}, {2,0.00036522}, {3,0.00020000}, {4,0.00016522}, {5,0.00010435}, {6,0.00013913}, {7,0.00026087}, {8,0.00003478}, {9,0.00016522}, {10,0.00018261}, {11,0.00013043}, {12,0.00006957}, {13,0.00006957}, {14,0.00023478}, {15,0.00016522}, {16,0.00015652}, {17,0.00020870}, {18,0.00013043}, {19,0.00043478}, {20,0.00023478}, {21,0.00009565}, {22,0.00026957}, {23,0.00029565}, {24,0.00024348}, {25,0.00028696}, {26,0.00027826}, {27,0.00023478}, {28,0.00041739}, {29,0.00039130}, {30,0.00040870}, {31,0.00040870}, {32,0.00035652}, {33,0.00022609}, {34,0.00046957}, {35,0.00025217}, {36,0.00038261}, {37,0.00034783}, {38,0.00037391}, {39,0.00038261}, {40,0.00243478}, {41,0.00006957}, {42,0.00000000}, {43,0.00003478}, {44,0.00009565}, {45,0.00006087}, {46,0.00000000}, {47,0.00003478}, {48,0.00003478}, {49,0.00003478}, {50,0.00000000}, {51,0.00000000}, {52,0.00006957}, {53,0.00018261}, {54,0.00000000}, {55,0.00002609}, {56,0.00009565}, {57,0.00006957}, {58,0.00000000}, {59,0.00012174}, {60,0.00000000}, {61,0.00000000}, {62,0.00002609}, {63,0.00009565}, {64,0.00009565}, {65,0.00006087}, {66,0.00009565}, {67,0.00013043}, {68,0.00006957}, {69,0.00006087}, {70,0.00060000}, {71,0.00010435}, {72,0.00008696}, {73,0.00003478}, {74,0.00013043}, {75,0.00006957}, {76,0.00002609}, {77,0.00003478}, {78,0.00006087}, {79,0.00009565}, {80,0.00003478}, {81,0.00009565}, {82,0.00003478}, {83,0.00006957}, {84,0.00002609}, {85,0.00006957}, {86,0.00008696}, {87,0.00000000}, {88,0.00020870}, {89,0.00003478}, {90,0.00006957}, {91,0.00010435}, {92,0.00075652}, {93,0.00013913}, {94,0.00006957}, {95,0.00006087}, {96,0.00013043}, {97,0.00016522}, {98,0.00008696}, {99,0.00017391}, {100,0.00006957}, {101,0.00016522}, {102,0.00006087}, {103,0.00002609}, {104,0.00006957}, {105,0.00002609}, {106,0.00006087}, {107,0.00006957}, {108,0.00000000}, {109,0.00108696}, {110,0.00010435}, {111,0.00006087}, {112,0.00000000}, {113,0.00010435}, {114,0.00013913}, {115,0.00010435}, {116,0.00006087}, {117,0.00010435}, {118,0.00003478}, {119,0.00006087}, {120,0.00026087}, {121,0.00006957}, {122,0.00006957}, {123,0.00006957}, {124,0.00050435}, {125,0.00022609}, {126,0.00009565}, {127,0.00009565}, {128,0.00006087}, {129,0.00015652}, {130,0.00006087}, {131,0.00006957}, {132,0.00009565}, {133,0.00000000}, {134,0.00024348}, {135,0.00006087}, {136,0.00013913}, {137,0.00125217}, {138,0.00038261}, {139,0.00027826}, {140,0.00006957}, {141,0.00020870}, {142,0.00013043}, {143,0.00002609}, {144,0.00003478}, {145,0.00000000}, {146,0.00013043}, {147,0.00008696}, {148,0.00014783}, {149,0.00080870}, {150,0.00006957}, {151,0.00023478}, {152,0.00013043}, {153,0.00010435}, {154,0.00013913}, {155,0.00003478}, {156,0.00003478}, {157,0.00006957}, {158,0.00009565}, {159,0.00013043}, {160,0.00057391}, {161,0.00026957}, {162,0.00020870}, {163,0.00009565}, {164,0.00013913}, {165,0.00013913}, {166,0.00009565}, {167,0.00012174}, {168,0.00009565}, {169,0.00017391}, {170,0.00017391}, {171,0.00131304}, {172,0.00020000}, {173,0.00010435}, {174,0.00037391}, {175,0.00006087}, {176,0.00026087}, {177,0.00016522}, {178,0.00016522}, {179,0.00017391}, {180,0.00020870}, {181,0.00032174}, {182,0.00038261}, {183,0.00022609}, {184,0.00020000}, {185,0.00010435}, {186,0.00020870}, {187,0.00010435}, {188,0.00012174}, {189,0.00010435}, {190,0.00073913}, {191,0.00012174}, {192,0.00010435}, {193,0.00013913}, {194,0.00010435}, {195,0.00058261}, {196,0.00013043}, {197,0.00017391}, {198,0.00013913}, {199,0.00156522}, {200,0.00042609}, {201,0.00029565}, {202,0.00003478}, {203,0.00036522}, {204,0.00017391}, {205,0.00006957}, {206,0.00026087}, {207,0.00098261}, {208,0.00026957}, {209,0.00016522}, {210,0.00016522}, {211,0.00013913}, {212,0.00021739}, {213,0.00017391}, {214,0.00002609}, {215,0.00006087}, {216,0.00084348}, {217,0.00019130}, {218,0.00016522}, {219,0.00013043}, {220,0.00020870}, {221,0.00017391}, {222,0.00010435}, {223,0.00020000}, {224,0.00100870}, {225,0.00017391}, {226,0.00006957}, {227,0.00022609}, {228,0.00017391}, {229,0.00010435}, {230,0.00010435}, {231,0.00020870}, {232,0.00083478}, {233,0.00013913}, {234,0.00012174}, {235,0.00020870}, {236,0.00013913}, {237,0.00017391}, {238,0.00026957}, {239,0.00091304}, {240,0.00029565}, {241,0.00017391}, {242,0.00026087}, {243,0.00009565}, {244,0.00023478}, {245,0.00015652}, {246,0.00084348}, {247,0.00052174}, {248,0.00031304}, {249,0.00020870}, {250,0.00017391}, {251,0.00024348}, {252,0.00010435}, {253,0.00080870}, {254,0.00022609}, {255,0.00017391}, {256,0.00013913}, {257,0.00009565}, {258,0.00002609}, {259,0.00009565}, {260,0.00076522}, {261,0.00033913}, {262,0.00030435}, {263,0.00006957}, {264,0.00016522}, {265,0.00036522}, {266,0.00010435}, {267,0.00099130}, {268,0.00016522}, {269,0.00027826}, {270,0.00010435}, {271,0.00009565}, {272,0.00016522}, {273,0.00033043}, {274,0.00070435}, {275,0.00026957}, {276,0.00072174}, {277,0.00043478}, {278,0.00024348}, {279,0.00226087}, {280,0.00059130}, {281,0.00023478}, {282,0.00036522}, {283,0.00022609}, {284,0.00038261}, {285,0.00093043}, {286,0.00009565}, {287,0.00006087}, {288,0.00031304}, {289,0.00033913}, {290,0.00013043}, {291,0.00020870}, {292,0.00066087}, {293,0.00020870}, {294,0.00020000}, {295,0.00025217}, {296,0.00017391}, {297,0.00027826}, {298,0.00031304}, {299,0.00015652}, {300,0.00023478}, {301,0.00010435}, {302,0.00028696}, {303,0.00020870}, {304,0.00029565}, {305,0.00020870}, {306,0.00013043}, {307,0.00020870}, {308,0.00052174}, {309,0.00042609}, {310,0.00028696}, {311,0.00045217}, {312,0.00010435}, {313,0.00013913}, {314,0.00010435}, {315,0.00046087}, {316,0.00029565}, {317,0.00020870}, {318,0.00036522}, {319,0.00027826}, {320,0.00006957}, {321,0.00033913}, {322,0.00036522}, {323,0.00023478}, {324,0.00016522}, {325,0.00020870}, {326,0.00163478}, {327,0.00015652}, {328,0.00041739}, {329,0.00020000}, {330,0.00029565}, {331,0.00080000}, {332,0.00040870}, {333,0.00026087}, {334,0.00013913}, {335,0.00020870}, {336,0.00020870}, {337,0.00086957}, {338,0.00053913}, {339,0.00042609}, {340,0.00033913}, {341,0.00034783}, {342,0.00094783}, {343,0.00046087}, {344,0.00030435}, {345,0.00036522}, {346,0.00031304}, {347,0.00093043}, {348,0.00020870}, {349,0.00046957}, {350,0.00033913}, {351,0.00044348}, {352,0.00106087}, {353,0.00017391}, {354,0.00044348}, {355,0.00017391}, {356,0.00020000}, {357,0.00095652}, {358,0.00041739}, {359,0.00021739}, {360,0.00029565}, {361,0.00023478}, {362,0.00101739}, {363,0.00047826}, {364,0.00032174}, {365,0.00024348}, {366,0.00031304}, {367,0.00081739}, {368,0.00044348}, {369,0.00031304}, {370,0.00034783}, {371,0.00020870}, {372,0.00089565}, {373,0.00030435}, {374,0.00037391}, {375,0.00024348}, {376,0.00027826}, {377,0.00100000}, {378,0.00042609}, {379,0.00028696}, {380,0.00023478}, {381,0.00089565}, {382,0.00024348}, {383,0.00020870}, {384,0.00017391}, {385,0.00026957}, {386,0.00081739}, {387,0.00039130}, {388,0.00033913}, {389,0.00026957}, {390,0.00135652}, {391,0.00036522}, {392,0.00151304}, {393,0.00033043}, {394,0.00586957}, {395,0.00033043}, {396,0.00040870}, {397,0.00030435}, {398,0.00102609}, {399,0.00020870}, {400,0.00020000}, {401,0.00033043}, {402,0.00019130}, {403,0.00141739}, {404,0.00016522}, {405,0.00029565}, {406,0.00022609}, {407,0.00073913}, {408,0.00029565}, {409,0.00029565}, {410,0.00033043}, {411,0.00103478}, {412,0.00013043}, {413,0.00030435}, {414,0.00044348}, {415,0.00027826}, {416,0.00061739}, {417,0.00034783}, {418,0.00030435}, {419,0.00033913}, {420,0.00126957}, {421,0.00036522}, {422,0.00041739}, {423,0.00006957}, {424,0.00078261}, {425,0.00024348}, {426,0.00034783}, {427,0.00035652}, {428,0.00104348}, {429,0.00044348}, {430,0.00013913}, {431,0.00024348}, {432,0.00118261}, {433,0.00037391}, {434,0.00022609}, {435,0.00031304}, {436,0.00030435}, {437,0.00100870}, {438,0.00034783}, {439,0.00030435}, {440,0.00040000}, {441,0.00124348}, {442,0.00027826}, {443,0.00043478}, {444,0.00037391}, {445,0.00131304}, {446,0.00039130}, {447,0.00037391}, {448,0.00040870}, {449,0.00038261}, {450,0.00031304}, {451,0.00037391}, {452,0.00020000}, {453,0.00013913}, {454,0.00030435}, {455,0.00024348}, {456,0.00040870}, {457,0.00031304}, {458,0.00033913}, {459,0.00020000}, {460,0.00060000}, {461,0.00020000}, {462,0.00026957}, {463,0.00023478}, {464,0.00139130}, {465,0.00044348}, {466,0.00037391}, {467,0.00036522}, {468,0.00139130}, {469,0.00038261}, {470,0.00031304}, {471,0.00034783}, {472,0.00132174}, {473,0.00034783}, {474,0.00050435}, {475,0.00033913}, {476,0.00069565}, {477,0.00023478}, {478,0.00024348}, {479,0.00154783}, {480,0.00026087}, {481,0.00013913}, {482,0.00017391}, {483,0.00110435}, {484,0.00029565}, {485,0.00034783}, {486,0.00017391}, {487,0.00086087}, {488,0.00054783}, {489,0.00053913}, {490,0.00072174}, {491,0.00044348}, {492,0.00031304}, {493,0.00031304}, {494,0.00141739}, {495,0.00027826}, {496,0.00055652}, {497,0.00100870}, {498,0.00040870}, {499,0.00024348}, {500,0.000676856}, {505,0.00041228}, {510,0.00036842}, {515,0.00059649}, {520,0.00081579}, {525,0.00040351}, {530,0.00052632}, {535,0.00144737}, {540,0.00062281}, {545,0.00073684}, {550,0.00131579}, {555,0.00028070}, {560,0.00049123}, {565,0.00094737}, {570,0.00044737}, {575,0.00035088}, {580,0.00141228}, {585,0.00041228}, {590,0.00059649}, {595,0.00131579}, {600,0.00069565}, {605,0.00065789}, {610,0.00118421}, {615,0.00041228}, {620,0.00035088}, {625,0.00181579}, {630,0.00024561}, {635,0.00034211}, {640,0.00112281}, {645,0.00056140}, {650,0.00035965}, {655,0.00099123}, {660,0.00042982}, {665,0.00152632}, {670,0.00064035}, {675,0.00051754}, {680,0.00116667}, {685,0.00035088}, {690,0.00069298}, {695,0.00107018}, {700,0.00054783}, {705,0.00131579}, {710,0.00037719}, {715,0.00055263}, {720,0.00174561}, {725,0.00055263}, {730,0.00678947}, {735,0.00701754}, {740,0.00057895}, {745,0.00068421}, {750,0.00116667}, {755,0.00077193}, {760,0.00047368}, {765,0.00035088}, {770,0.00038596}, {775,0.00051754}, {780,0.00052632}, {785,0.00031579}, {790,0.00024561}, {795,0.00056140}, {800,0.00062609}, {805,0.00031579}, {810,0.00055263}, {815,0.00075439}, {820,0.00056140}, {825,0.00086842}, {830,0.00130702}, {835,0.00062281}, {840,0.00138596}, {845,0.00059649}, {850,0.00145614}, {855,0.00084211}, {860,0.00171053}, {865,0.00090351}, {870,0.00151754}, {875,0.00091228}, {880,0.00113158}, {885,0.00062281}, {890,0.00114912}, {895,0.00082456}, {900,0.00157391}, {905,0.00079825}, {910,0.00147368}, {915,0.00093860}, {920,0.00154386}, {925,0.00070175}, {930,0.00192982}, {935,0.00088596}, {940,0.00164035}, {945,0.00079825}, {950,0.00127193}, {955,0.00155263}, {960,0.00062281}, {965,0.00171053}, {970,0.00116667}, {975,0.00207018}, {980,0.00096491}, {985,0.00168421}, {990,0.00062281}, {995,0.00135088}, {1000,0.00155652}, {1010,0.01575}, {1020,0.00000}, {1030,0.00175}, {1040,0.00175}, {1050,0.00675}, {1060,0.00000}, {1070,0.00000}, {1080,0.00400}, {1090,0.00300}, {1100,0.00475}, {1110,0.00000}, {1120,0.00175}, {1130,0.00175}, {1140,0.00100}, {1150,0.00300}, {1160,0.00100}, {1170,0.00200}, {1180,0.00375}, {1190,0.00175}, {1200,0.00100}, {1210,0.00200}, {1220,0.00000}, {1230,0.00075}, {1240,0.00100}, {1250,0.00200}, {1260,0.00400}, {1270,0.00000}, {1280,0.00375}, {1290,0.00100}, {1300,0.00500}, {1310,0.00275}, {1320,0.00100}, {1330,0.00200}, {1340,0.00500}, {1350,0.00000}, {1360,0.00275}, {1370,0.00200}, {1380,0.00200}, {1390,0.00200}, {1400,0.00100}, {1410,0.00200}, {1420,0.00200}, {1430,0.00175}, {1440,0.00300}, {1450,0.00000}, {1460,0.00200}, {1470,0.00200}, {1480,0.00250}, {1490,0.00200}, {1500,0.00400}, {1510,0.00000}, {1520,0.00300}, {1530,0.00200}, {1540,0.00275}, {1550,0.00000}, {1560,0.00200}, {1570,0.00100}, {1580,0.00400}, {1590,0.00200}, {1600,0.00350}, {1610,0.00500}, {1620,0.00200}, {1630,0.00175}, {1640,0.00100}, {1650,0.00475}, {1660,0.00100}, {1670,0.00600}, {1680,0.00100}, {1690,0.00300}, {1700,0.00200}, {1710,0.00200}, {1720,0.00100}, {1730,0.00000}, {1740,0.00175}, {1750,0.00200}, {1760,0.00375}, {1770,0.00300}, {1780,0.00300}, {1790,0.00000}, {1800,0.00200}, {1810,0.00175}, {1820,0.00200}, {1830,0.00500}, {1840,0.00000}, {1850,0.00400}, {1860,0.00200}, {1870,0.00100}, {1880,0.00500}, {1890,0.00300}, {1900,0.00575}, {1910,0.00075}, {1920,0.00200}, {1930,0.00100}, {1940,0.00000}, {1950,0.00100}, {1960,0.00100}, {1970,0.00000}, {1980,0.00100}, {1990,0.00000}, {2000,0.00160}, {2050,0.00000}, {2100,0.00300}, {2150,0.09550}, {2200,0.01000}, {2250,0.01700}, {2300,0.01175}, {2350,0.00875}, {2400,0.01400}, {2450,0.01075}, {2500,0.01120}, {2550,0.01475}, {2600,0.01275}, {2650,0.01500}, {2700,0.02000}, {2750,0.01800}, {2800,0.01275}, {2850,0.01200}, {2900,0.02100}, {2950,0.01600}, {3000,0.01260}, {3050,0.01500}, {3100,0.01675}, {3150,0.01200}, {3200,0.00575}, {3250,0.00300}, {3300,0.00175}, {3350,0.00600}, {3400,0.00200}, {3450,0.01300}, {3500,0.01660}, {3550,0.01775}, {3600,0.02000}, {3650,0.02175}, {3700,0.02000}, {3750,0.02500}, {3800,0.01775}, {3850,0.01900}, {3900,0.01800}, {3950,0.02175}, {4000,0.01660}, {4050,0.02200}, {4100,0.02300}, {4150,0.02800}, {4200,0.02400}, {4250,0.02200}, {4300,0.02575}, {4350,0.00675}, {4400,0.00200}, {4450,0.00400}, {4500,0.17100}, {4550,0.01600}, {4600,0.00475}, {4650,0.00300}, {4700,0.00575}, {4750,0.00300}, {4800,0.03075}, {4850,0.02500}, {4900,0.02975}, {4950,0.03200}, {5000,0.01900}, {5050,0.0695}, {5100,0.0675}, {5150,0.0435}};
data["big"]["ParsingElaborated"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000870}, {6,0.00004348}, {7,0.00078261}, {8,0.00081739}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00197391}, {16,0.00131304}, {17,0.00152174}, {18,0.00184348}, {19,0.00200000}, {20,0.00200000}, {21,0.00200000}, {22,0.00298261}, {23,0.00200000}, {24,0.00200000}, {25,0.00200000}, {26,0.00206087}, {27,0.00233913}, {28,0.00296522}, {29,0.00298261}, {30,0.00300000}, {31,0.00300000}, {32,0.00408696}, {33,0.00300000}, {34,0.00300000}, {35,0.00300000}, {36,0.00306087}, {37,0.00336522}, {38,0.00371304}, {39,0.00398261}, {40,0.05750435}, {41,0.00387826}, {42,0.00396522}, {43,0.00398261}, {44,0.00400000}, {45,0.00400000}, {46,0.00400000}, {47,0.00697391}, {48,0.00401739}, {49,0.00400000}, {50,0.00408696}, {51,0.00434783}, {52,0.00463478}, {53,0.00494783}, {54,0.00500000}, {55,0.00500000}, {56,0.00501739}, {57,0.00505217}, {58,0.00506087}, {59,0.00513913}, {60,0.00541739}, {61,0.00573043}, {62,0.00592174}, {63,0.00600000}, {64,0.00600000}, {65,0.00600000}, {66,0.00600870}, {67,0.01191304}, {68,0.00611304}, {69,0.00652174}, {70,0.07798261}, {71,0.00699130}, {72,0.00698261}, {73,0.00700000}, {74,0.00712174}, {75,0.00700870}, {76,0.00706087}, {77,0.00725217}, {78,0.00776522}, {79,0.00780000}, {80,0.00775652}, {81,0.00798261}, {82,0.00809565}, {83,0.00800000}, {84,0.00800870}, {85,0.00802609}, {86,0.00813913}, {87,0.00853043}, {88,0.00883478}, {89,0.00887826}, {90,0.00890435}, {91,0.00894783}, {92,0.06572174}, {93,0.00911304}, {94,0.00900870}, {95,0.00906957}, {96,0.02132174}, {97,0.00907826}, {98,0.00916522}, {99,0.00946957}, {100,0.00983478}, {101,0.00991304}, {102,0.00993913}, {103,0.00998261}, {104,0.01000000}, {105,0.01000870}, {106,0.01002609}, {107,0.01020870}, {108,0.01067826}, {109,0.06221739}, {110,0.01100000}, {111,0.01100870}, {112,0.01100870}, {113,0.01114783}, {114,0.01130435}, {115,0.01153913}, {116,0.01166087}, {117,0.01167826}, {118,0.01168696}, {119,0.01197391}, {120,0.01200000}, {121,0.01200870}, {122,0.01206087}, {123,0.01203478}, {124,0.05059130}, {125,0.01278261}, {126,0.01293043}, {127,0.01296522}, {128,0.01294783}, {129,0.01297391}, {130,0.01317391}, {131,0.01302609}, {132,0.01312174}, {133,0.01328696}, {134,0.01367826}, {135,0.01389565}, {136,0.01388696}, {137,0.09320870}, {138,0.01375652}, {139,0.01372174}, {140,0.01388696}, {141,0.01393043}, {142,0.01400000}, {143,0.01413913}, {144,0.01406087}, {145,0.01404348}, {146,0.01431304}, {147,0.01414783}, {148,0.01435652}, {149,0.05273913}, {150,0.01493043}, {151,0.01492174}, {152,0.01497391}, {153,0.01509565}, {154,0.01506087}, {155,0.01514783}, {156,0.01532174}, {157,0.01544348}, {158,0.01559130}, {159,0.01540000}, {160,0.05324348}, {161,0.01600000}, {162,0.01604348}, {163,0.01615652}, {164,0.01602609}, {165,0.01612174}, {166,0.01634783}, {167,0.01666957}, {168,0.01689565}, {169,0.01693913}, {170,0.01696522}, {171,0.05917391}, {172,0.01714783}, {173,0.01703478}, {174,0.01706957}, {175,0.01708696}, {176,0.01733043}, {177,0.01772174}, {178,0.01791304}, {179,0.01794783}, {180,0.01798261}, {181,0.05982609}, {182,0.01806957}, {183,0.01813043}, {184,0.01812174}, {185,0.01815652}, {186,0.01839130}, {187,0.01888696}, {188,0.01893913}, {189,0.01901739}, {190,0.06019130}, {191,0.01903478}, {192,0.01913913}, {193,0.01916522}, {194,0.01910435}, {195,0.07034783}, {196,0.01996522}, {197,0.01989565}, {198,0.02000870}, {199,0.07963478}, {200,0.02003478}, {201,0.02013043}, {202,0.02042609}, {203,0.02074783}, {204,0.02085217}, {205,0.02080870}, {206,0.02073043}, {207,0.09565217}, {208,0.02176522}, {209,0.02194783}, {210,0.02206957}, {211,0.02205217}, {212,0.02210435}, {213,0.02208696}, {214,0.02219130}, {215,0.02259130}, {216,0.08388696}, {217,0.02292174}, {218,0.02293913}, {219,0.02300000}, {220,0.02300870}, {221,0.02310435}, {222,0.02315652}, {223,0.02350435}, {224,0.07128696}, {225,0.02386957}, {226,0.02388696}, {227,0.02384348}, {228,0.02393913}, {229,0.02401739}, {230,0.02462609}, {231,0.02423478}, {232,0.06054783}, {233,0.02482609}, {234,0.02493043}, {235,0.02510435}, {236,0.02489565}, {237,0.02506087}, {238,0.02622609}, {239,0.06938261}, {240,0.02550435}, {241,0.02558261}, {242,0.02592174}, {243,0.02585217}, {244,0.02598261}, {245,0.02601739}, {246,0.07409565}, {247,0.02633043}, {248,0.02629565}, {249,0.02661739}, {250,0.02673043}, {251,0.02660000}, {252,0.02673043}, {253,0.10032174}, {254,0.02720870}, {255,0.02736522}, {256,0.02726087}, {257,0.02711304}, {258,0.02722609}, {259,0.02772174}, {260,0.07811304}, {261,0.02779130}, {262,0.02790435}, {263,0.02800000}, {264,0.02799130}, {265,0.02814783}, {266,0.02815652}, {267,0.07135652}, {268,0.02880000}, {269,0.02885217}, {270,0.02888696}, {271,0.02893043}, {272,0.02900000}, {273,0.02912174}, {274,0.06224348}, {275,0.02830435}, {276,0.12993043}, {277,0.02891304}, {278,0.02893043}, {279,0.12380000}, {280,0.02906957}, {281,0.02905217}, {282,0.02911304}, {283,0.02918261}, {284,0.02945217}, {285,0.06961739}, {286,0.02984348}, {287,0.02998261}, {288,0.03004348}, {289,0.03003478}, {290,0.03009565}, {291,0.03026087}, {292,0.06969565}, {293,0.03064348}, {294,0.03080870}, {295,0.03087826}, {296,0.03095652}, {297,0.03106957}, {298,0.07166087}, {299,0.03115652}, {300,0.03123478}, {301,0.03142609}, {302,0.03162609}, {303,0.07556522}, {304,0.03194783}, {305,0.03196522}, {306,0.03203478}, {307,0.03210435}, {308,0.03235652}, {309,0.09420870}, {310,0.03246957}, {311,0.03279130}, {312,0.03286957}, {313,0.03300870}, {314,0.03302609}, {315,0.07620870}, {316,0.03319130}, {317,0.03340000}, {318,0.03355652}, {319,0.03382609}, {320,0.03375652}, {321,0.06021739}, {322,0.03397391}, {323,0.03401739}, {324,0.03407826}, {325,0.03421739}, {326,0.12957391}, {327,0.03580870}, {328,0.03592174}, {329,0.03606087}, {330,0.03606087}, {331,0.09406957}, {332,0.03650435}, {333,0.03661739}, {334,0.03664348}, {335,0.03673913}, {336,0.03691304}, {337,0.08888696}, {338,0.04012174}, {339,0.03724348}, {340,0.03735652}, {341,0.03755652}, {342,0.07744348}, {343,0.03785217}, {344,0.03797391}, {345,0.03802609}, {346,0.03815652}, {347,0.08401739}, {348,0.03836522}, {349,0.03865217}, {350,0.03934783}, {351,0.03883478}, {352,0.09401739}, {353,0.03916522}, {354,0.03925217}, {355,0.03931304}, {356,0.03946087}, {357,0.11413913}, {358,0.03972174}, {359,0.03973043}, {360,0.04002609}, {361,0.04013913}, {362,0.12025217}, {363,0.04021739}, {364,0.04058261}, {365,0.04049565}, {366,0.04074783}, {367,0.11944348}, {368,0.04114783}, {369,0.04126957}, {370,0.04128696}, {371,0.04118261}, {372,0.10452174}, {373,0.04137391}, {374,0.04153043}, {375,0.04180000}, {376,0.04202609}, {377,0.07629565}, {378,0.04218261}, {379,0.04230435}, {380,0.04235652}, {381,0.08732174}, {382,0.04266957}, {383,0.04286087}, {384,0.04300000}, {385,0.04299130}, {386,0.08564348}, {387,0.04338261}, {388,0.04353043}, {389,0.04352174}, {390,0.09686957}, {391,0.04373913}, {392,0.24049565}, {393,0.04288696}, {394,0.13680870}, {395,0.04281739}, {396,0.04289565}, {397,0.04300870}, {398,0.08079130}, {399,0.04336522}, {400,0.04343478}, {401,0.04354783}, {402,0.04380000}, {403,0.09373043}, {404,0.04384348}, {405,0.04398261}, {406,0.04400870}, {407,0.08357391}, {408,0.04426087}, {409,0.04446957}, {410,0.04465217}, {411,0.08453043}, {412,0.04488696}, {413,0.04495652}, {414,0.04510435}, {415,0.04510435}, {416,0.08679130}, {417,0.04556522}, {418,0.04553043}, {419,0.04568696}, {420,0.08420870}, {421,0.04600870}, {422,0.04612174}, {423,0.04618261}, {424,0.08418261}, {425,0.04645217}, {426,0.04680000}, {427,0.04679130}, {428,0.08763478}, {429,0.04699130}, {430,0.04706957}, {431,0.04722609}, {432,0.08836522}, {433,0.04768696}, {434,0.04769565}, {435,0.04785217}, {436,0.04793913}, {437,0.08656522}, {438,0.04811304}, {439,0.04819130}, {440,0.04828696}, {441,0.08716522}, {442,0.04873043}, {443,0.04885217}, {444,0.04894783}, {445,0.08641739}, {446,0.04905217}, {447,0.04919130}, {448,0.04940000}, {449,0.08880870}, {450,0.04966087}, {451,0.04978261}, {452,0.04994783}, {453,0.09040000}, {454,0.05015652}, {455,0.05023478}, {456,0.09540000}, {457,0.05046957}, {458,0.05075652}, {459,0.05080000}, {460,0.11756522}, {461,0.05102609}, {462,0.05114783}, {463,0.05125217}, {464,0.15617391}, {465,0.05319130}, {466,0.05335652}, {467,0.05360000}, {468,0.11586957}, {469,0.05385217}, {470,0.05406087}, {471,0.05407826}, {472,0.10232174}, {473,0.05433913}, {474,0.05451304}, {475,0.05462609}, {476,0.08709565}, {477,0.05495652}, {478,0.05497391}, {479,0.09901739}, {480,0.05520000}, {481,0.05547826}, {482,0.05560870}, {483,0.10692174}, {484,0.05580000}, {485,0.05593913}, {486,0.05600000}, {487,0.12169565}, {488,0.05641739}, {489,0.05667826}, {490,0.13707826}, {491,0.05685217}, {492,0.05693043}, {493,0.05703478}, {494,0.14198261}, {495,0.05723478}, {496,0.05756522}, {497,0.13182609}, {498,0.05781739}, {499,0.05798261}, {500,0.103528384}, {505,0.05889474}, {510,0.05950000}, {515,0.06007895}, {520,0.12678070}, {525,0.06152632}, {530,0.06221053}, {535,0.17248246}, {540,0.06369298}, {545,0.06445614}, {550,0.14132456}, {555,0.06589474}, {560,0.06658772}, {565,0.11584211}, {570,0.06799123}, {575,0.06871930}, {580,0.11538596}, {585,0.07014912}, {590,0.07084211}, {595,0.11857018}, {600,0.07226087}, {605,0.07300877}, {610,0.12071053}, {615,0.07468421}, {620,0.07535965}, {625,0.12393860}, {630,0.07689474}, {635,0.07759649}, {640,0.12514035}, {645,0.07913158}, {650,0.07995614}, {655,0.12137719}, {660,0.08155263}, {665,0.12123684}, {670,0.08313158}, {675,0.08392982}, {680,0.13475439}, {685,0.08539474}, {690,0.08612281}, {695,0.12594737}, {700,0.08513043}, {705,0.12587719}, {710,0.08663158}, {715,0.08742105}, {720,0.14843860}, {725,0.08901754}, {730,0.63685965}, {735,0.25885965}, {740,0.09173684}, {745,0.09258772}, {750,0.13750877}, {755,0.09412281}, {760,0.13366667}, {765,0.09582456}, {770,0.13929825}, {775,0.09747368}, {780,0.09816667}, {785,0.14649123}, {790,0.09994737}, {795,0.14467544}, {800,0.10154783}, {805,0.14591228}, {810,0.10322807}, {815,0.14406140}, {820,0.10494737}, {825,0.10573684}, {830,0.19558772}, {835,0.11049123}, {840,0.21104386}, {845,0.11213158}, {850,0.16114912}, {855,0.11405263}, {860,0.15431579}, {865,0.11580702}, {870,0.15660526}, {875,0.11788596}, {880,0.17031579}, {885,0.11959649}, {890,0.16334211}, {895,0.12142105}, {900,0.16434783}, {905,0.12340351}, {910,0.16663158}, {915,0.12528070}, {920,0.16809649}, {925,0.12740351}, {930,0.16608772}, {935,0.12904386}, {940,0.16287719}, {945,0.13178070}, {950,0.16789474}, {955,0.18628947}, {960,0.13558772}, {965,0.18960526}, {970,0.13715789}, {975,0.19213158}, {980,0.13942982}, {985,0.18803509}, {990,0.14387719}, {995,0.17930702}, {1000,0.18301739}, {1010,0.20450}, {1020,0.14425}, {1030,0.22925}, {1040,0.14725}, {1050,0.22925}, {1060,0.15325}, {1070,0.17675}, {1080,0.20625}, {1090,0.15925}, {1100,0.23450}, {1110,0.19425}, {1120,0.16300}, {1130,0.21450}, {1140,0.16675}, {1150,0.19450}, {1160,0.22875}, {1170,0.17350}, {1180,0.25600}, {1190,0.23875}, {1200,0.18025}, {1210,0.20975}, {1220,0.26125}, {1230,0.23275}, {1240,0.19425}, {1250,0.25075}, {1260,0.24025}, {1270,0.20100}, {1280,0.25600}, {1290,0.25975}, {1300,0.27125}, {1310,0.21125}, {1320,0.26525}, {1330,0.24125}, {1340,0.41000}, {1350,0.21625}, {1360,0.25700}, {1370,0.26975}, {1380,0.27000}, {1390,0.22800}, {1400,0.27300}, {1410,0.27600}, {1420,0.31800}, {1430,0.30300}, {1440,0.24400}, {1450,0.28675}, {1460,0.29850}, {1470,0.29475}, {1480,0.32450}, {1490,0.34825}, {1500,0.27540}, {1510,0.33800}, {1520,0.35300}, {1530,0.31000}, {1540,0.31500}, {1550,0.32325}, {1560,0.34450}, {1570,0.27950}, {1580,0.29925}, {1590,0.31250}, {1600,0.56900}, {1610,0.39225}, {1620,0.32975}, {1630,0.33050}, {1640,0.33375}, {1650,0.33875}, {1660,0.34725}, {1670,0.33625}, {1680,0.40350}, {1690,0.38250}, {1700,0.37425}, {1710,0.37325}, {1720,0.38400}, {1730,0.43050}, {1740,0.45425}, {1750,0.44100}, {1760,0.44300}, {1770,0.43950}, {1780,0.40225}, {1790,0.40525}, {1800,0.40900}, {1810,0.41400}, {1820,0.43325}, {1830,0.41900}, {1840,0.39825}, {1850,0.41325}, {1860,0.41425}, {1870,0.41650}, {1880,0.41800}, {1890,0.42200}, {1900,0.42175}, {1910,0.41825}, {1920,0.42050}, {1930,0.42275}, {1940,0.41350}, {1950,0.41025}, {1960,0.47200}, {1970,0.45525}, {1980,0.45700}, {1990,0.46100}, {2000,0.47740}, {2050,0.48100}, {2100,0.54125}, {2150,1.73475}, {2200,0.59725}, {2250,0.58925}, {2300,0.60225}, {2350,0.60575}, {2400,0.64250}, {2450,0.66225}, {2500,0.67780}, {2550,0.70850}, {2600,0.72175}, {2650,0.74775}, {2700,0.78225}, {2750,0.78425}, {2800,0.78200}, {2850,0.82250}, {2900,0.86625}, {2950,0.87175}, {3000,0.89640}, {3050,0.93175}, {3100,0.91850}, {3150,0.96125}, {3200,0.97500}, {3250,0.98750}, {3300,1.03850}, {3350,1.12825}, {3400,1.13000}, {3450,1.17675}, {3500,1.21040}, {3550,1.29400}, {3600,1.33025}, {3650,1.34500}, {3700,1.41125}, {3750,1.45450}, {3800,1.42750}, {3850,1.39250}, {3900,1.40075}, {3950,1.42100}, {4000,1.46800}, {4050,1.51825}, {4100,1.50325}, {4150,1.54825}, {4200,1.58625}, {4250,1.56675}, {4300,1.65725}, {4350,1.62325}, {4400,1.68975}, {4450,1.69050}, {4500,3.11880}, {4550,1.83225}, {4600,1.91650}, {4650,2.01000}, {4700,1.96525}, {4750,2.07150}, {4800,2.22050}, {4850,2.16375}, {4900,2.06050}, {4950,2.09825}, {5000,2.13020}, {5050,2.3340}, {5100,2.3470}, {5150,2.3755}};
data["big"]["ParsingElaborated"]["norm reif"]["user"] = {{1,0.00011304}, {2,0.00024348}, {3,0.00023478}, {4,0.00060000}, {5,0.00073913}, {6,0.00095652}, {7,0.00090435}, {8,0.00092174}, {9,0.00110435}, {10,0.00125217}, {11,0.00119130}, {12,0.00174783}, {13,0.00133913}, {14,0.00164348}, {15,0.00173913}, {16,0.00177391}, {17,0.00188696}, {18,0.00186087}, {19,0.00190435}, {20,0.00208696}, {21,0.00225217}, {22,0.00306957}, {23,0.00228696}, {24,0.00260000}, {25,0.00226087}, {26,0.00246087}, {27,0.00273043}, {28,0.00271304}, {29,0.00266087}, {30,0.00272174}, {31,0.00295652}, {32,0.00439130}, {33,0.00347826}, {34,0.00320870}, {35,0.00345217}, {36,0.00343478}, {37,0.00348696}, {38,0.00364348}, {39,0.00363478}, {40,0.05470435}, {41,0.00412174}, {42,0.00417391}, {43,0.00399130}, {44,0.00424348}, {45,0.00402609}, {46,0.00440000}, {47,0.00710435}, {48,0.00458261}, {49,0.00447826}, {50,0.00447826}, {51,0.00495652}, {52,0.00493913}, {53,0.00506957}, {54,0.00545217}, {55,0.00542609}, {56,0.00562609}, {57,0.00579130}, {58,0.00587826}, {59,0.00575652}, {60,0.00583478}, {61,0.00588696}, {62,0.00593913}, {63,0.00607826}, {64,0.00581739}, {65,0.00613043}, {66,0.00635652}, {67,0.01212174}, {68,0.00692174}, {69,0.00684348}, {70,0.07733913}, {71,0.00713043}, {72,0.00707826}, {73,0.00722609}, {74,0.00744348}, {75,0.00757391}, {76,0.00778261}, {77,0.00785217}, {78,0.00793043}, {79,0.00803478}, {80,0.00802609}, {81,0.00795652}, {82,0.00825217}, {83,0.00853913}, {84,0.00843478}, {85,0.00833913}, {86,0.00876522}, {87,0.00869565}, {88,0.00884348}, {89,0.00937391}, {90,0.00886957}, {91,0.00920870}, {92,0.06488696}, {93,0.00943478}, {94,0.00962609}, {95,0.00942609}, {96,0.02181739}, {97,0.00933913}, {98,0.00997391}, {99,0.00973913}, {100,0.01019130}, {101,0.01019130}, {102,0.01008696}, {103,0.01022609}, {104,0.01074783}, {105,0.01043478}, {106,0.01041739}, {107,0.01070435}, {108,0.01115652}, {109,0.06082609}, {110,0.01132174}, {111,0.01144348}, {112,0.01163478}, {113,0.01182609}, {114,0.01175652}, {115,0.01175652}, {116,0.01179130}, {117,0.01193043}, {118,0.01192174}, {119,0.01209565}, {120,0.01241739}, {121,0.01226087}, {122,0.01254783}, {123,0.01231304}, {124,0.05033913}, {125,0.01293043}, {126,0.01313913}, {127,0.01327826}, {128,0.01348696}, {129,0.01339130}, {130,0.01360000}, {131,0.01324348}, {132,0.01384348}, {133,0.01370435}, {134,0.01405217}, {135,0.01401739}, {136,0.01384348}, {137,0.09227826}, {138,0.01353913}, {139,0.01367826}, {140,0.01399130}, {141,0.01417391}, {142,0.01411304}, {143,0.01483478}, {144,0.01459130}, {145,0.01475652}, {146,0.01444348}, {147,0.01436522}, {148,0.01470435}, {149,0.05213043}, {150,0.01507826}, {151,0.01498261}, {152,0.01529565}, {153,0.01550435}, {154,0.01547826}, {155,0.01589565}, {156,0.01589565}, {157,0.01582609}, {158,0.01582609}, {159,0.01586087}, {160,0.05313913}, {161,0.01620870}, {162,0.01620870}, {163,0.01655652}, {164,0.01638261}, {165,0.01674783}, {166,0.01676522}, {167,0.01708696}, {168,0.01679130}, {169,0.01662609}, {170,0.01721739}, {171,0.05787826}, {172,0.01757391}, {173,0.01731304}, {174,0.01758261}, {175,0.01753043}, {176,0.01793043}, {177,0.01791304}, {178,0.01790435}, {179,0.01840000}, {180,0.01825217}, {181,0.05965217}, {182,0.01835652}, {183,0.01860870}, {184,0.01849565}, {185,0.01858261}, {186,0.01888696}, {187,0.01928696}, {188,0.01891304}, {189,0.01876522}, {190,0.05973913}, {191,0.01901739}, {192,0.01922609}, {193,0.01956522}, {194,0.01966087}, {195,0.07020000}, {196,0.02004348}, {197,0.02000000}, {198,0.02033913}, {199,0.07797391}, {200,0.02000000}, {201,0.02033913}, {202,0.02058261}, {203,0.02086087}, {204,0.02091304}, {205,0.02093913}, {206,0.02087826}, {207,0.09441739}, {208,0.02193913}, {209,0.02211304}, {210,0.02207826}, {211,0.02269565}, {212,0.02246957}, {213,0.02246957}, {214,0.02284348}, {215,0.02263478}, {216,0.08340870}, {217,0.02316522}, {218,0.02319130}, {219,0.02344348}, {220,0.02309565}, {221,0.02323478}, {222,0.02360000}, {223,0.02375652}, {224,0.07073043}, {225,0.02386957}, {226,0.02414783}, {227,0.02385217}, {228,0.02433043}, {229,0.02446957}, {230,0.02473913}, {231,0.02437391}, {232,0.05973913}, {233,0.02488696}, {234,0.02494783}, {235,0.02482609}, {236,0.02523478}, {237,0.02500000}, {238,0.02671304}, {239,0.06878261}, {240,0.02521739}, {241,0.02566957}, {242,0.02598261}, {243,0.02577391}, {244,0.02603478}, {245,0.02628696}, {246,0.07306087}, {247,0.02622609}, {248,0.02591304}, {249,0.02622609}, {250,0.02671304}, {251,0.02662609}, {252,0.02695652}, {253,0.09986957}, {254,0.02695652}, {255,0.02721739}, {256,0.02722609}, {257,0.02690435}, {258,0.02721739}, {259,0.02741739}, {260,0.07741739}, {261,0.02740000}, {262,0.02754783}, {263,0.02794783}, {264,0.02773913}, {265,0.02779130}, {266,0.02815652}, {267,0.07064348}, {268,0.02866087}, {269,0.02842609}, {270,0.02881739}, {271,0.02906957}, {272,0.02917391}, {273,0.02888696}, {274,0.06172174}, {275,0.02812174}, {276,0.12941739}, {277,0.02828696}, {278,0.02896522}, {279,0.12146087}, {280,0.02853913}, {281,0.02893913}, {282,0.02898261}, {283,0.02928696}, {284,0.02935652}, {285,0.06876522}, {286,0.02992174}, {287,0.03017391}, {288,0.02996522}, {289,0.03002609}, {290,0.03040000}, {291,0.03057391}, {292,0.06918261}, {293,0.03076522}, {294,0.03070435}, {295,0.03076522}, {296,0.03110435}, {297,0.03109565}, {298,0.07126957}, {299,0.03127826}, {300,0.03145217}, {301,0.03180000}, {302,0.03171304}, {303,0.07539130}, {304,0.03195652}, {305,0.03204348}, {306,0.03208696}, {307,0.03246957}, {308,0.03232174}, {309,0.09389565}, {310,0.03250435}, {311,0.03263478}, {312,0.03316522}, {313,0.03314783}, {314,0.03330435}, {315,0.07589565}, {316,0.03314783}, {317,0.03344348}, {318,0.03336522}, {319,0.03355652}, {320,0.03400870}, {321,0.05964348}, {322,0.03348696}, {323,0.03422609}, {324,0.03386087}, {325,0.03401739}, {326,0.12833913}, {327,0.03544348}, {328,0.03558261}, {329,0.03577391}, {330,0.03574783}, {331,0.09311304}, {332,0.03614783}, {333,0.03633043}, {334,0.03640000}, {335,0.03625217}, {336,0.03651304}, {337,0.08806087}, {338,0.03934783}, {339,0.03693043}, {340,0.03671304}, {341,0.03693043}, {342,0.07651304}, {343,0.03723478}, {344,0.03746957}, {345,0.03742609}, {346,0.03774783}, {347,0.08299130}, {348,0.03828696}, {349,0.03821739}, {350,0.03882609}, {351,0.03833043}, {352,0.09328696}, {353,0.03882609}, {354,0.03891304}, {355,0.03914783}, {356,0.03926087}, {357,0.11301739}, {358,0.03933043}, {359,0.03948696}, {360,0.03958261}, {361,0.04017391}, {362,0.11904348}, {363,0.03985217}, {364,0.04028696}, {365,0.04031304}, {366,0.04033043}, {367,0.11898261}, {368,0.04094783}, {369,0.04095652}, {370,0.04106957}, {371,0.04088696}, {372,0.10380000}, {373,0.04089565}, {374,0.04109565}, {375,0.04190435}, {376,0.04154783}, {377,0.07596522}, {378,0.04197391}, {379,0.04184348}, {380,0.04212174}, {381,0.08653043}, {382,0.04271304}, {383,0.04253043}, {384,0.04302609}, {385,0.04291304}, {386,0.08472174}, {387,0.04330435}, {388,0.04340870}, {389,0.04320870}, {390,0.09536522}, {391,0.04365217}, {392,0.23926957}, {393,0.04271304}, {394,0.13080000}, {395,0.04238261}, {396,0.04271304}, {397,0.04270435}, {398,0.07976522}, {399,0.04335652}, {400,0.04337391}, {401,0.04321739}, {402,0.04373043}, {403,0.09237391}, {404,0.04385217}, {405,0.04387826}, {406,0.04396522}, {407,0.08252174}, {408,0.04421739}, {409,0.04460000}, {410,0.04431304}, {411,0.08333043}, {412,0.04519130}, {413,0.04473043}, {414,0.04520000}, {415,0.04474783}, {416,0.08657391}, {417,0.04523478}, {418,0.04560870}, {419,0.04565217}, {420,0.08258261}, {421,0.04600870}, {422,0.04620870}, {423,0.04635652}, {424,0.08330435}, {425,0.04615652}, {426,0.04646087}, {427,0.04663478}, {428,0.08673913}, {429,0.04682609}, {430,0.04732174}, {431,0.04737391}, {432,0.08700870}, {433,0.04763478}, {434,0.04787826}, {435,0.04793043}, {436,0.04800870}, {437,0.08582609}, {438,0.04800870}, {439,0.04840000}, {440,0.04829565}, {441,0.08618261}, {442,0.04878261}, {443,0.04866087}, {444,0.04858261}, {445,0.08510435}, {446,0.04873913}, {447,0.04905217}, {448,0.04912174}, {449,0.08855652}, {450,0.04943478}, {451,0.04968696}, {452,0.04986087}, {453,0.09012174}, {454,0.04980000}, {455,0.04993913}, {456,0.09505217}, {457,0.05016522}, {458,0.05010435}, {459,0.05049565}, {460,0.11712174}, {461,0.05075652}, {462,0.05066087}, {463,0.05075652}, {464,0.15477391}, {465,0.05271304}, {466,0.05270435}, {467,0.05302609}, {468,0.11456522}, {469,0.05349565}, {470,0.05347826}, {471,0.05381739}, {472,0.10102609}, {473,0.05394783}, {474,0.05400870}, {475,0.05427826}, {476,0.08643478}, {477,0.05447826}, {478,0.05479130}, {479,0.09772174}, {480,0.05513043}, {481,0.05544348}, {482,0.05552174}, {483,0.10587826}, {484,0.05561739}, {485,0.05573043}, {486,0.05601739}, {487,0.12074783}, {488,0.05606087}, {489,0.05617391}, {490,0.13663478}, {491,0.05648696}, {492,0.05646957}, {493,0.05702609}, {494,0.14040870}, {495,0.05678261}, {496,0.05760000}, {497,0.13053913}, {498,0.05719130}, {499,0.05774783}, {500,0.102925764}, {505,0.05843860}, {510,0.05894737}, {515,0.05970175}, {520,0.12618421}, {525,0.06126316}, {530,0.06206140}, {535,0.17107018}, {540,0.06351754}, {545,0.06409649}, {550,0.14019298}, {555,0.06599123}, {560,0.06614035}, {565,0.11453509}, {570,0.06754386}, {575,0.06837719}, {580,0.11372807}, {585,0.06950877}, {590,0.06991228}, {595,0.11718421}, {600,0.07158261}, {605,0.07231579}, {610,0.11930702}, {615,0.07445614}, {620,0.07516667}, {625,0.12219298}, {630,0.07683333}, {635,0.07735965}, {640,0.12414035}, {645,0.07837719}, {650,0.07944737}, {655,0.12025439}, {660,0.08094737}, {665,0.11987719}, {670,0.08212281}, {675,0.08287719}, {680,0.13373684}, {685,0.08450000}, {690,0.08528947}, {695,0.12527193}, {700,0.08434783}, {705,0.12467544}, {710,0.08635088}, {715,0.08717544}, {720,0.14633333}, {725,0.08839474}, {730,0.62993860}, {735,0.25164035}, {740,0.09111404}, {745,0.09200877}, {750,0.13668421}, {755,0.09367544}, {760,0.13307895}, {765,0.09598246}, {770,0.13921930}, {775,0.09692982}, {780,0.09784211}, {785,0.14592982}, {790,0.09966667}, {795,0.14421930}, {800,0.10105217}, {805,0.14530702}, {810,0.10240351}, {815,0.14315789}, {820,0.10415789}, {825,0.10507018}, {830,0.19421053}, {835,0.10978070}, {840,0.20927193}, {845,0.11149123}, {850,0.15995614}, {855,0.11323684}, {860,0.15231579}, {865,0.11453509}, {870,0.15547368}, {875,0.11671930}, {880,0.16913158}, {885,0.11887719}, {890,0.16235965}, {895,0.12028070}, {900,0.16298261}, {905,0.12266667}, {910,0.16492105}, {915,0.12449123}, {920,0.16655263}, {925,0.12707018}, {930,0.16427193}, {935,0.12807018}, {940,0.16136842}, {945,0.13065789}, {950,0.16437719}, {955,0.18203509}, {960,0.13399123}, {965,0.18785965}, {970,0.13604386}, {975,0.18896491}, {980,0.13836842}, {985,0.18505263}, {990,0.14124561}, {995,0.17738596}, {1000,0.18164348}, {1010,0.18875}, {1020,0.14400}, {1030,0.22750}, {1040,0.14675}, {1050,0.22200}, {1060,0.15325}, {1070,0.17675}, {1080,0.20200}, {1090,0.15650}, {1100,0.22875}, {1110,0.19425}, {1120,0.16100}, {1130,0.21300}, {1140,0.16600}, {1150,0.19275}, {1160,0.22650}, {1170,0.17275}, {1180,0.25125}, {1190,0.23650}, {1200,0.18000}, {1210,0.20850}, {1220,0.26125}, {1230,0.23325}, {1240,0.19275}, {1250,0.24900}, {1260,0.23725}, {1270,0.20050}, {1280,0.25050}, {1290,0.25950}, {1300,0.26675}, {1310,0.20750}, {1320,0.26425}, {1330,0.23825}, {1340,0.40575}, {1350,0.21550}, {1360,0.25550}, {1370,0.26650}, {1380,0.26875}, {1390,0.22550}, {1400,0.27175}, {1410,0.27475}, {1420,0.31575}, {1430,0.29925}, {1440,0.23925}, {1450,0.28625}, {1460,0.29650}, {1470,0.29250}, {1480,0.32200}, {1490,0.34625}, {1500,0.27160}, {1510,0.33725}, {1520,0.34975}, {1530,0.30825}, {1540,0.31350}, {1550,0.32150}, {1560,0.34175}, {1570,0.27725}, {1580,0.29575}, {1590,0.31025}, {1600,0.56450}, {1610,0.38775}, {1620,0.32750}, {1630,0.32925}, {1640,0.33125}, {1650,0.33550}, {1660,0.34650}, {1670,0.32900}, {1680,0.40250}, {1690,0.37950}, {1700,0.37375}, {1710,0.37125}, {1720,0.38350}, {1730,0.42925}, {1740,0.45125}, {1750,0.43850}, {1760,0.43850}, {1770,0.43625}, {1780,0.39850}, {1790,0.40525}, {1800,0.40650}, {1810,0.41275}, {1820,0.43000}, {1830,0.41450}, {1840,0.39725}, {1850,0.41075}, {1860,0.41075}, {1870,0.41625}, {1880,0.41375}, {1890,0.41725}, {1900,0.41575}, {1910,0.41750}, {1920,0.41875}, {1930,0.42175}, {1940,0.41350}, {1950,0.40950}, {1960,0.47200}, {1970,0.45225}, {1980,0.45450}, {1990,0.46050}, {2000,0.47640}, {2050,0.47975}, {2100,0.53975}, {2150,1.63700}, {2200,0.58750}, {2250,0.57175}, {2300,0.58825}, {2350,0.59675}, {2400,0.62825}, {2450,0.65075}, {2500,0.66500}, {2550,0.69250}, {2600,0.70875}, {2650,0.73100}, {2700,0.76250}, {2750,0.76700}, {2800,0.76875}, {2850,0.81000}, {2900,0.84425}, {2950,0.85475}, {3000,0.88320}, {3050,0.91625}, {3100,0.90050}, {3150,0.94825}, {3200,0.96775}, {3250,0.98550}, {3300,1.03625}, {3350,1.12175}, {3400,1.12750}, {3450,1.16500}, {3500,1.19320}, {3550,1.27450}, {3600,1.31075}, {3650,1.32125}, {3700,1.39150}, {3750,1.42850}, {3800,1.41075}, {3850,1.37250}, {3900,1.38325}, {3950,1.39950}, {4000,1.45060}, {4050,1.49425}, {4100,1.48050}, {4150,1.51850}, {4200,1.56175}, {4250,1.54500}, {4300,1.63100}, {4350,1.61675}, {4400,1.68725}, {4450,1.68500}, {4500,2.94600}, {4550,1.81425}, {4600,1.91175}, {4650,2.00575}, {4700,1.95925}, {4750,2.06725}, {4800,2.18900}, {4850,2.13725}, {4900,2.02725}, {4950,2.06475}, {5000,2.11180}, {5050,2.2555}, {5100,2.2490}, {5150,2.2635}};
data["big"]["ParsingElaborated"]["norm reif"]["system"] = {{1,0.00024348}, {2,0.00036522}, {3,0.00020000}, {4,0.00016522}, {5,0.00010435}, {6,0.00013913}, {7,0.00026087}, {8,0.00003478}, {9,0.00016522}, {10,0.00018261}, {11,0.00013043}, {12,0.00006957}, {13,0.00006957}, {14,0.00023478}, {15,0.00016522}, {16,0.00015652}, {17,0.00020870}, {18,0.00013043}, {19,0.00043478}, {20,0.00023478}, {21,0.00009565}, {22,0.00026957}, {23,0.00029565}, {24,0.00024348}, {25,0.00028696}, {26,0.00027826}, {27,0.00023478}, {28,0.00041739}, {29,0.00039130}, {30,0.00040870}, {31,0.00040870}, {32,0.00035652}, {33,0.00022609}, {34,0.00046957}, {35,0.00025217}, {36,0.00038261}, {37,0.00034783}, {38,0.00037391}, {39,0.00038261}, {40,0.00243478}, {41,0.00006957}, {42,0.00000000}, {43,0.00003478}, {44,0.00009565}, {45,0.00006087}, {46,0.00000000}, {47,0.00003478}, {48,0.00003478}, {49,0.00003478}, {50,0.00000000}, {51,0.00000000}, {52,0.00006957}, {53,0.00018261}, {54,0.00000000}, {55,0.00002609}, {56,0.00009565}, {57,0.00006957}, {58,0.00000000}, {59,0.00012174}, {60,0.00000000}, {61,0.00000000}, {62,0.00002609}, {63,0.00009565}, {64,0.00009565}, {65,0.00006087}, {66,0.00009565}, {67,0.00013043}, {68,0.00006957}, {69,0.00006087}, {70,0.00060000}, {71,0.00010435}, {72,0.00008696}, {73,0.00003478}, {74,0.00013043}, {75,0.00006957}, {76,0.00002609}, {77,0.00003478}, {78,0.00006087}, {79,0.00009565}, {80,0.00003478}, {81,0.00009565}, {82,0.00003478}, {83,0.00006957}, {84,0.00002609}, {85,0.00006957}, {86,0.00008696}, {87,0.00000000}, {88,0.00020870}, {89,0.00003478}, {90,0.00006957}, {91,0.00010435}, {92,0.00075652}, {93,0.00013913}, {94,0.00006957}, {95,0.00006087}, {96,0.00013043}, {97,0.00016522}, {98,0.00008696}, {99,0.00017391}, {100,0.00006957}, {101,0.00016522}, {102,0.00006087}, {103,0.00002609}, {104,0.00006957}, {105,0.00002609}, {106,0.00006087}, {107,0.00006957}, {108,0.00000000}, {109,0.00108696}, {110,0.00010435}, {111,0.00006087}, {112,0.00000000}, {113,0.00010435}, {114,0.00013913}, {115,0.00010435}, {116,0.00006087}, {117,0.00010435}, {118,0.00003478}, {119,0.00006087}, {120,0.00026087}, {121,0.00006957}, {122,0.00006957}, {123,0.00006957}, {124,0.00050435}, {125,0.00022609}, {126,0.00009565}, {127,0.00009565}, {128,0.00006087}, {129,0.00015652}, {130,0.00006087}, {131,0.00006957}, {132,0.00009565}, {133,0.00000000}, {134,0.00024348}, {135,0.00006087}, {136,0.00013913}, {137,0.00125217}, {138,0.00038261}, {139,0.00027826}, {140,0.00006957}, {141,0.00020870}, {142,0.00013043}, {143,0.00002609}, {144,0.00003478}, {145,0.00000000}, {146,0.00013043}, {147,0.00008696}, {148,0.00014783}, {149,0.00080870}, {150,0.00006957}, {151,0.00023478}, {152,0.00013043}, {153,0.00010435}, {154,0.00013913}, {155,0.00003478}, {156,0.00003478}, {157,0.00006957}, {158,0.00009565}, {159,0.00013043}, {160,0.00057391}, {161,0.00026957}, {162,0.00020870}, {163,0.00009565}, {164,0.00013913}, {165,0.00013913}, {166,0.00009565}, {167,0.00012174}, {168,0.00009565}, {169,0.00017391}, {170,0.00017391}, {171,0.00131304}, {172,0.00020000}, {173,0.00010435}, {174,0.00037391}, {175,0.00006087}, {176,0.00026087}, {177,0.00016522}, {178,0.00016522}, {179,0.00017391}, {180,0.00020870}, {181,0.00032174}, {182,0.00038261}, {183,0.00022609}, {184,0.00020000}, {185,0.00010435}, {186,0.00020870}, {187,0.00010435}, {188,0.00012174}, {189,0.00010435}, {190,0.00073913}, {191,0.00012174}, {192,0.00010435}, {193,0.00013913}, {194,0.00010435}, {195,0.00058261}, {196,0.00013043}, {197,0.00017391}, {198,0.00013913}, {199,0.00156522}, {200,0.00042609}, {201,0.00029565}, {202,0.00003478}, {203,0.00036522}, {204,0.00017391}, {205,0.00006957}, {206,0.00026087}, {207,0.00098261}, {208,0.00026957}, {209,0.00016522}, {210,0.00016522}, {211,0.00013913}, {212,0.00021739}, {213,0.00017391}, {214,0.00002609}, {215,0.00006087}, {216,0.00084348}, {217,0.00019130}, {218,0.00016522}, {219,0.00013043}, {220,0.00020870}, {221,0.00017391}, {222,0.00010435}, {223,0.00020000}, {224,0.00100870}, {225,0.00017391}, {226,0.00006957}, {227,0.00022609}, {228,0.00017391}, {229,0.00010435}, {230,0.00010435}, {231,0.00020870}, {232,0.00083478}, {233,0.00013913}, {234,0.00012174}, {235,0.00020870}, {236,0.00013913}, {237,0.00017391}, {238,0.00026957}, {239,0.00091304}, {240,0.00029565}, {241,0.00017391}, {242,0.00026087}, {243,0.00009565}, {244,0.00023478}, {245,0.00015652}, {246,0.00084348}, {247,0.00052174}, {248,0.00031304}, {249,0.00020870}, {250,0.00017391}, {251,0.00024348}, {252,0.00010435}, {253,0.00080870}, {254,0.00022609}, {255,0.00017391}, {256,0.00013913}, {257,0.00009565}, {258,0.00002609}, {259,0.00009565}, {260,0.00076522}, {261,0.00033913}, {262,0.00030435}, {263,0.00006957}, {264,0.00016522}, {265,0.00036522}, {266,0.00010435}, {267,0.00099130}, {268,0.00016522}, {269,0.00027826}, {270,0.00010435}, {271,0.00009565}, {272,0.00016522}, {273,0.00033043}, {274,0.00070435}, {275,0.00026957}, {276,0.00072174}, {277,0.00043478}, {278,0.00024348}, {279,0.00226087}, {280,0.00059130}, {281,0.00023478}, {282,0.00036522}, {283,0.00022609}, {284,0.00038261}, {285,0.00093043}, {286,0.00009565}, {287,0.00006087}, {288,0.00031304}, {289,0.00033913}, {290,0.00013043}, {291,0.00020870}, {292,0.00066087}, {293,0.00020870}, {294,0.00020000}, {295,0.00025217}, {296,0.00017391}, {297,0.00027826}, {298,0.00031304}, {299,0.00015652}, {300,0.00023478}, {301,0.00010435}, {302,0.00028696}, {303,0.00020870}, {304,0.00029565}, {305,0.00020870}, {306,0.00013043}, {307,0.00020870}, {308,0.00052174}, {309,0.00042609}, {310,0.00028696}, {311,0.00045217}, {312,0.00010435}, {313,0.00013913}, {314,0.00010435}, {315,0.00046087}, {316,0.00029565}, {317,0.00020870}, {318,0.00036522}, {319,0.00027826}, {320,0.00006957}, {321,0.00033913}, {322,0.00036522}, {323,0.00023478}, {324,0.00016522}, {325,0.00020870}, {326,0.00163478}, {327,0.00015652}, {328,0.00041739}, {329,0.00020000}, {330,0.00029565}, {331,0.00080000}, {332,0.00040870}, {333,0.00026087}, {334,0.00013913}, {335,0.00020870}, {336,0.00020870}, {337,0.00086957}, {338,0.00053913}, {339,0.00042609}, {340,0.00033913}, {341,0.00034783}, {342,0.00094783}, {343,0.00046087}, {344,0.00030435}, {345,0.00036522}, {346,0.00031304}, {347,0.00093043}, {348,0.00020870}, {349,0.00046957}, {350,0.00033913}, {351,0.00044348}, {352,0.00106087}, {353,0.00017391}, {354,0.00044348}, {355,0.00017391}, {356,0.00020000}, {357,0.00095652}, {358,0.00041739}, {359,0.00021739}, {360,0.00029565}, {361,0.00023478}, {362,0.00101739}, {363,0.00047826}, {364,0.00032174}, {365,0.00024348}, {366,0.00031304}, {367,0.00081739}, {368,0.00044348}, {369,0.00031304}, {370,0.00034783}, {371,0.00020870}, {372,0.00089565}, {373,0.00030435}, {374,0.00037391}, {375,0.00024348}, {376,0.00027826}, {377,0.00100000}, {378,0.00042609}, {379,0.00028696}, {380,0.00023478}, {381,0.00089565}, {382,0.00024348}, {383,0.00020870}, {384,0.00017391}, {385,0.00026957}, {386,0.00081739}, {387,0.00039130}, {388,0.00033913}, {389,0.00026957}, {390,0.00135652}, {391,0.00036522}, {392,0.00151304}, {393,0.00033043}, {394,0.00586957}, {395,0.00033043}, {396,0.00040870}, {397,0.00030435}, {398,0.00102609}, {399,0.00020870}, {400,0.00020000}, {401,0.00033043}, {402,0.00019130}, {403,0.00141739}, {404,0.00016522}, {405,0.00029565}, {406,0.00022609}, {407,0.00073913}, {408,0.00029565}, {409,0.00029565}, {410,0.00033043}, {411,0.00103478}, {412,0.00013043}, {413,0.00030435}, {414,0.00044348}, {415,0.00027826}, {416,0.00061739}, {417,0.00034783}, {418,0.00030435}, {419,0.00033913}, {420,0.00126957}, {421,0.00036522}, {422,0.00041739}, {423,0.00006957}, {424,0.00078261}, {425,0.00024348}, {426,0.00034783}, {427,0.00035652}, {428,0.00104348}, {429,0.00044348}, {430,0.00013913}, {431,0.00024348}, {432,0.00118261}, {433,0.00037391}, {434,0.00022609}, {435,0.00031304}, {436,0.00030435}, {437,0.00100870}, {438,0.00034783}, {439,0.00030435}, {440,0.00040000}, {441,0.00124348}, {442,0.00027826}, {443,0.00043478}, {444,0.00037391}, {445,0.00131304}, {446,0.00039130}, {447,0.00037391}, {448,0.00040870}, {449,0.00038261}, {450,0.00031304}, {451,0.00037391}, {452,0.00020000}, {453,0.00013913}, {454,0.00030435}, {455,0.00024348}, {456,0.00040870}, {457,0.00031304}, {458,0.00033913}, {459,0.00020000}, {460,0.00060000}, {461,0.00020000}, {462,0.00026957}, {463,0.00023478}, {464,0.00139130}, {465,0.00044348}, {466,0.00037391}, {467,0.00036522}, {468,0.00139130}, {469,0.00038261}, {470,0.00031304}, {471,0.00034783}, {472,0.00132174}, {473,0.00034783}, {474,0.00050435}, {475,0.00033913}, {476,0.00069565}, {477,0.00023478}, {478,0.00024348}, {479,0.00154783}, {480,0.00026087}, {481,0.00013913}, {482,0.00017391}, {483,0.00110435}, {484,0.00029565}, {485,0.00034783}, {486,0.00017391}, {487,0.00086087}, {488,0.00054783}, {489,0.00053913}, {490,0.00072174}, {491,0.00044348}, {492,0.00031304}, {493,0.00031304}, {494,0.00141739}, {495,0.00027826}, {496,0.00055652}, {497,0.00100870}, {498,0.00040870}, {499,0.00024348}, {500,0.000676856}, {505,0.00041228}, {510,0.00036842}, {515,0.00059649}, {520,0.00081579}, {525,0.00040351}, {530,0.00052632}, {535,0.00144737}, {540,0.00062281}, {545,0.00073684}, {550,0.00131579}, {555,0.00028070}, {560,0.00049123}, {565,0.00094737}, {570,0.00044737}, {575,0.00035088}, {580,0.00141228}, {585,0.00041228}, {590,0.00059649}, {595,0.00131579}, {600,0.00069565}, {605,0.00065789}, {610,0.00118421}, {615,0.00041228}, {620,0.00035088}, {625,0.00181579}, {630,0.00024561}, {635,0.00034211}, {640,0.00112281}, {645,0.00056140}, {650,0.00035965}, {655,0.00099123}, {660,0.00042982}, {665,0.00152632}, {670,0.00064035}, {675,0.00051754}, {680,0.00116667}, {685,0.00035088}, {690,0.00069298}, {695,0.00107018}, {700,0.00054783}, {705,0.00131579}, {710,0.00037719}, {715,0.00055263}, {720,0.00174561}, {725,0.00055263}, {730,0.00678947}, {735,0.00701754}, {740,0.00057895}, {745,0.00068421}, {750,0.00116667}, {755,0.00077193}, {760,0.00047368}, {765,0.00035088}, {770,0.00038596}, {775,0.00051754}, {780,0.00052632}, {785,0.00031579}, {790,0.00024561}, {795,0.00056140}, {800,0.00062609}, {805,0.00031579}, {810,0.00055263}, {815,0.00075439}, {820,0.00056140}, {825,0.00086842}, {830,0.00130702}, {835,0.00062281}, {840,0.00138596}, {845,0.00059649}, {850,0.00145614}, {855,0.00084211}, {860,0.00171053}, {865,0.00090351}, {870,0.00151754}, {875,0.00091228}, {880,0.00113158}, {885,0.00062281}, {890,0.00114912}, {895,0.00082456}, {900,0.00157391}, {905,0.00079825}, {910,0.00147368}, {915,0.00093860}, {920,0.00154386}, {925,0.00070175}, {930,0.00192982}, {935,0.00088596}, {940,0.00164035}, {945,0.00079825}, {950,0.00127193}, {955,0.00155263}, {960,0.00062281}, {965,0.00171053}, {970,0.00116667}, {975,0.00207018}, {980,0.00096491}, {985,0.00168421}, {990,0.00062281}, {995,0.00135088}, {1000,0.00155652}, {1010,0.01575}, {1020,0.00000}, {1030,0.00175}, {1040,0.00175}, {1050,0.00675}, {1060,0.00000}, {1070,0.00000}, {1080,0.00400}, {1090,0.00300}, {1100,0.00475}, {1110,0.00000}, {1120,0.00175}, {1130,0.00175}, {1140,0.00100}, {1150,0.00300}, {1160,0.00100}, {1170,0.00200}, {1180,0.00375}, {1190,0.00175}, {1200,0.00100}, {1210,0.00200}, {1220,0.00000}, {1230,0.00075}, {1240,0.00100}, {1250,0.00200}, {1260,0.00400}, {1270,0.00000}, {1280,0.00375}, {1290,0.00100}, {1300,0.00500}, {1310,0.00275}, {1320,0.00100}, {1330,0.00200}, {1340,0.00500}, {1350,0.00000}, {1360,0.00275}, {1370,0.00200}, {1380,0.00200}, {1390,0.00200}, {1400,0.00100}, {1410,0.00200}, {1420,0.00200}, {1430,0.00175}, {1440,0.00300}, {1450,0.00000}, {1460,0.00200}, {1470,0.00200}, {1480,0.00250}, {1490,0.00200}, {1500,0.00400}, {1510,0.00000}, {1520,0.00300}, {1530,0.00200}, {1540,0.00275}, {1550,0.00000}, {1560,0.00200}, {1570,0.00100}, {1580,0.00400}, {1590,0.00200}, {1600,0.00350}, {1610,0.00500}, {1620,0.00200}, {1630,0.00175}, {1640,0.00100}, {1650,0.00475}, {1660,0.00100}, {1670,0.00600}, {1680,0.00100}, {1690,0.00300}, {1700,0.00200}, {1710,0.00200}, {1720,0.00100}, {1730,0.00000}, {1740,0.00175}, {1750,0.00200}, {1760,0.00375}, {1770,0.00300}, {1780,0.00300}, {1790,0.00000}, {1800,0.00200}, {1810,0.00175}, {1820,0.00200}, {1830,0.00500}, {1840,0.00000}, {1850,0.00400}, {1860,0.00200}, {1870,0.00100}, {1880,0.00500}, {1890,0.00300}, {1900,0.00575}, {1910,0.00075}, {1920,0.00200}, {1930,0.00100}, {1940,0.00000}, {1950,0.00100}, {1960,0.00100}, {1970,0.00000}, {1980,0.00100}, {1990,0.00000}, {2000,0.00160}, {2050,0.00000}, {2100,0.00300}, {2150,0.09550}, {2200,0.01000}, {2250,0.01700}, {2300,0.01175}, {2350,0.00875}, {2400,0.01400}, {2450,0.01075}, {2500,0.01120}, {2550,0.01475}, {2600,0.01275}, {2650,0.01500}, {2700,0.02000}, {2750,0.01800}, {2800,0.01275}, {2850,0.01200}, {2900,0.02100}, {2950,0.01600}, {3000,0.01260}, {3050,0.01500}, {3100,0.01675}, {3150,0.01200}, {3200,0.00575}, {3250,0.00300}, {3300,0.00175}, {3350,0.00600}, {3400,0.00200}, {3450,0.01300}, {3500,0.01660}, {3550,0.01775}, {3600,0.02000}, {3650,0.02175}, {3700,0.02000}, {3750,0.02500}, {3800,0.01775}, {3850,0.01900}, {3900,0.01800}, {3950,0.02175}, {4000,0.01660}, {4050,0.02200}, {4100,0.02300}, {4150,0.02800}, {4200,0.02400}, {4250,0.02200}, {4300,0.02575}, {4350,0.00675}, {4400,0.00200}, {4450,0.00400}, {4500,0.17100}, {4550,0.01600}, {4600,0.00475}, {4650,0.00300}, {4700,0.00575}, {4750,0.00300}, {4800,0.03075}, {4850,0.02500}, {4900,0.02975}, {4950,0.03200}, {5000,0.01900}, {5050,0.0695}, {5100,0.0675}, {5150,0.0435}};
data["big"]["ParsingElaborated"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000870}, {6,0.00004348}, {7,0.00078261}, {8,0.00081739}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00197391}, {16,0.00131304}, {17,0.00152174}, {18,0.00184348}, {19,0.00200000}, {20,0.00200000}, {21,0.00200000}, {22,0.00298261}, {23,0.00200000}, {24,0.00200000}, {25,0.00200000}, {26,0.00206087}, {27,0.00233913}, {28,0.00296522}, {29,0.00298261}, {30,0.00300000}, {31,0.00300000}, {32,0.00408696}, {33,0.00300000}, {34,0.00300000}, {35,0.00300000}, {36,0.00306087}, {37,0.00336522}, {38,0.00371304}, {39,0.00398261}, {40,0.05750435}, {41,0.00387826}, {42,0.00396522}, {43,0.00398261}, {44,0.00400000}, {45,0.00400000}, {46,0.00400000}, {47,0.00697391}, {48,0.00401739}, {49,0.00400000}, {50,0.00408696}, {51,0.00434783}, {52,0.00463478}, {53,0.00494783}, {54,0.00500000}, {55,0.00500000}, {56,0.00501739}, {57,0.00505217}, {58,0.00506087}, {59,0.00513913}, {60,0.00541739}, {61,0.00573043}, {62,0.00592174}, {63,0.00600000}, {64,0.00600000}, {65,0.00600000}, {66,0.00600870}, {67,0.01191304}, {68,0.00611304}, {69,0.00652174}, {70,0.07798261}, {71,0.00699130}, {72,0.00698261}, {73,0.00700000}, {74,0.00712174}, {75,0.00700870}, {76,0.00706087}, {77,0.00725217}, {78,0.00776522}, {79,0.00780000}, {80,0.00775652}, {81,0.00798261}, {82,0.00809565}, {83,0.00800000}, {84,0.00800870}, {85,0.00802609}, {86,0.00813913}, {87,0.00853043}, {88,0.00883478}, {89,0.00887826}, {90,0.00890435}, {91,0.00894783}, {92,0.06572174}, {93,0.00911304}, {94,0.00900870}, {95,0.00906957}, {96,0.02132174}, {97,0.00907826}, {98,0.00916522}, {99,0.00946957}, {100,0.00983478}, {101,0.00991304}, {102,0.00993913}, {103,0.00998261}, {104,0.01000000}, {105,0.01000870}, {106,0.01002609}, {107,0.01020870}, {108,0.01067826}, {109,0.06221739}, {110,0.01100000}, {111,0.01100870}, {112,0.01100870}, {113,0.01114783}, {114,0.01130435}, {115,0.01153913}, {116,0.01166087}, {117,0.01167826}, {118,0.01168696}, {119,0.01197391}, {120,0.01200000}, {121,0.01200870}, {122,0.01206087}, {123,0.01203478}, {124,0.05059130}, {125,0.01278261}, {126,0.01293043}, {127,0.01296522}, {128,0.01294783}, {129,0.01297391}, {130,0.01317391}, {131,0.01302609}, {132,0.01312174}, {133,0.01328696}, {134,0.01367826}, {135,0.01389565}, {136,0.01388696}, {137,0.09320870}, {138,0.01375652}, {139,0.01372174}, {140,0.01388696}, {141,0.01393043}, {142,0.01400000}, {143,0.01413913}, {144,0.01406087}, {145,0.01404348}, {146,0.01431304}, {147,0.01414783}, {148,0.01435652}, {149,0.05273913}, {150,0.01493043}, {151,0.01492174}, {152,0.01497391}, {153,0.01509565}, {154,0.01506087}, {155,0.01514783}, {156,0.01532174}, {157,0.01544348}, {158,0.01559130}, {159,0.01540000}, {160,0.05324348}, {161,0.01600000}, {162,0.01604348}, {163,0.01615652}, {164,0.01602609}, {165,0.01612174}, {166,0.01634783}, {167,0.01666957}, {168,0.01689565}, {169,0.01693913}, {170,0.01696522}, {171,0.05917391}, {172,0.01714783}, {173,0.01703478}, {174,0.01706957}, {175,0.01708696}, {176,0.01733043}, {177,0.01772174}, {178,0.01791304}, {179,0.01794783}, {180,0.01798261}, {181,0.05982609}, {182,0.01806957}, {183,0.01813043}, {184,0.01812174}, {185,0.01815652}, {186,0.01839130}, {187,0.01888696}, {188,0.01893913}, {189,0.01901739}, {190,0.06019130}, {191,0.01903478}, {192,0.01913913}, {193,0.01916522}, {194,0.01910435}, {195,0.07034783}, {196,0.01996522}, {197,0.01989565}, {198,0.02000870}, {199,0.07963478}, {200,0.02003478}, {201,0.02013043}, {202,0.02042609}, {203,0.02074783}, {204,0.02085217}, {205,0.02080870}, {206,0.02073043}, {207,0.09565217}, {208,0.02176522}, {209,0.02194783}, {210,0.02206957}, {211,0.02205217}, {212,0.02210435}, {213,0.02208696}, {214,0.02219130}, {215,0.02259130}, {216,0.08388696}, {217,0.02292174}, {218,0.02293913}, {219,0.02300000}, {220,0.02300870}, {221,0.02310435}, {222,0.02315652}, {223,0.02350435}, {224,0.07128696}, {225,0.02386957}, {226,0.02388696}, {227,0.02384348}, {228,0.02393913}, {229,0.02401739}, {230,0.02462609}, {231,0.02423478}, {232,0.06054783}, {233,0.02482609}, {234,0.02493043}, {235,0.02510435}, {236,0.02489565}, {237,0.02506087}, {238,0.02622609}, {239,0.06938261}, {240,0.02550435}, {241,0.02558261}, {242,0.02592174}, {243,0.02585217}, {244,0.02598261}, {245,0.02601739}, {246,0.07409565}, {247,0.02633043}, {248,0.02629565}, {249,0.02661739}, {250,0.02673043}, {251,0.02660000}, {252,0.02673043}, {253,0.10032174}, {254,0.02720870}, {255,0.02736522}, {256,0.02726087}, {257,0.02711304}, {258,0.02722609}, {259,0.02772174}, {260,0.07811304}, {261,0.02779130}, {262,0.02790435}, {263,0.02800000}, {264,0.02799130}, {265,0.02814783}, {266,0.02815652}, {267,0.07135652}, {268,0.02880000}, {269,0.02885217}, {270,0.02888696}, {271,0.02893043}, {272,0.02900000}, {273,0.02912174}, {274,0.06224348}, {275,0.02830435}, {276,0.12993043}, {277,0.02891304}, {278,0.02893043}, {279,0.12380000}, {280,0.02906957}, {281,0.02905217}, {282,0.02911304}, {283,0.02918261}, {284,0.02945217}, {285,0.06961739}, {286,0.02984348}, {287,0.02998261}, {288,0.03004348}, {289,0.03003478}, {290,0.03009565}, {291,0.03026087}, {292,0.06969565}, {293,0.03064348}, {294,0.03080870}, {295,0.03087826}, {296,0.03095652}, {297,0.03106957}, {298,0.07166087}, {299,0.03115652}, {300,0.03123478}, {301,0.03142609}, {302,0.03162609}, {303,0.07556522}, {304,0.03194783}, {305,0.03196522}, {306,0.03203478}, {307,0.03210435}, {308,0.03235652}, {309,0.09420870}, {310,0.03246957}, {311,0.03279130}, {312,0.03286957}, {313,0.03300870}, {314,0.03302609}, {315,0.07620870}, {316,0.03319130}, {317,0.03340000}, {318,0.03355652}, {319,0.03382609}, {320,0.03375652}, {321,0.06021739}, {322,0.03397391}, {323,0.03401739}, {324,0.03407826}, {325,0.03421739}, {326,0.12957391}, {327,0.03580870}, {328,0.03592174}, {329,0.03606087}, {330,0.03606087}, {331,0.09406957}, {332,0.03650435}, {333,0.03661739}, {334,0.03664348}, {335,0.03673913}, {336,0.03691304}, {337,0.08888696}, {338,0.04012174}, {339,0.03724348}, {340,0.03735652}, {341,0.03755652}, {342,0.07744348}, {343,0.03785217}, {344,0.03797391}, {345,0.03802609}, {346,0.03815652}, {347,0.08401739}, {348,0.03836522}, {349,0.03865217}, {350,0.03934783}, {351,0.03883478}, {352,0.09401739}, {353,0.03916522}, {354,0.03925217}, {355,0.03931304}, {356,0.03946087}, {357,0.11413913}, {358,0.03972174}, {359,0.03973043}, {360,0.04002609}, {361,0.04013913}, {362,0.12025217}, {363,0.04021739}, {364,0.04058261}, {365,0.04049565}, {366,0.04074783}, {367,0.11944348}, {368,0.04114783}, {369,0.04126957}, {370,0.04128696}, {371,0.04118261}, {372,0.10452174}, {373,0.04137391}, {374,0.04153043}, {375,0.04180000}, {376,0.04202609}, {377,0.07629565}, {378,0.04218261}, {379,0.04230435}, {380,0.04235652}, {381,0.08732174}, {382,0.04266957}, {383,0.04286087}, {384,0.04300000}, {385,0.04299130}, {386,0.08564348}, {387,0.04338261}, {388,0.04353043}, {389,0.04352174}, {390,0.09686957}, {391,0.04373913}, {392,0.24049565}, {393,0.04288696}, {394,0.13680870}, {395,0.04281739}, {396,0.04289565}, {397,0.04300870}, {398,0.08079130}, {399,0.04336522}, {400,0.04343478}, {401,0.04354783}, {402,0.04380000}, {403,0.09373043}, {404,0.04384348}, {405,0.04398261}, {406,0.04400870}, {407,0.08357391}, {408,0.04426087}, {409,0.04446957}, {410,0.04465217}, {411,0.08453043}, {412,0.04488696}, {413,0.04495652}, {414,0.04510435}, {415,0.04510435}, {416,0.08679130}, {417,0.04556522}, {418,0.04553043}, {419,0.04568696}, {420,0.08420870}, {421,0.04600870}, {422,0.04612174}, {423,0.04618261}, {424,0.08418261}, {425,0.04645217}, {426,0.04680000}, {427,0.04679130}, {428,0.08763478}, {429,0.04699130}, {430,0.04706957}, {431,0.04722609}, {432,0.08836522}, {433,0.04768696}, {434,0.04769565}, {435,0.04785217}, {436,0.04793913}, {437,0.08656522}, {438,0.04811304}, {439,0.04819130}, {440,0.04828696}, {441,0.08716522}, {442,0.04873043}, {443,0.04885217}, {444,0.04894783}, {445,0.08641739}, {446,0.04905217}, {447,0.04919130}, {448,0.04940000}, {449,0.08880870}, {450,0.04966087}, {451,0.04978261}, {452,0.04994783}, {453,0.09040000}, {454,0.05015652}, {455,0.05023478}, {456,0.09540000}, {457,0.05046957}, {458,0.05075652}, {459,0.05080000}, {460,0.11756522}, {461,0.05102609}, {462,0.05114783}, {463,0.05125217}, {464,0.15617391}, {465,0.05319130}, {466,0.05335652}, {467,0.05360000}, {468,0.11586957}, {469,0.05385217}, {470,0.05406087}, {471,0.05407826}, {472,0.10232174}, {473,0.05433913}, {474,0.05451304}, {475,0.05462609}, {476,0.08709565}, {477,0.05495652}, {478,0.05497391}, {479,0.09901739}, {480,0.05520000}, {481,0.05547826}, {482,0.05560870}, {483,0.10692174}, {484,0.05580000}, {485,0.05593913}, {486,0.05600000}, {487,0.12169565}, {488,0.05641739}, {489,0.05667826}, {490,0.13707826}, {491,0.05685217}, {492,0.05693043}, {493,0.05703478}, {494,0.14198261}, {495,0.05723478}, {496,0.05756522}, {497,0.13182609}, {498,0.05781739}, {499,0.05798261}, {500,0.103528384}, {505,0.05889474}, {510,0.05950000}, {515,0.06007895}, {520,0.12678070}, {525,0.06152632}, {530,0.06221053}, {535,0.17248246}, {540,0.06369298}, {545,0.06445614}, {550,0.14132456}, {555,0.06589474}, {560,0.06658772}, {565,0.11584211}, {570,0.06799123}, {575,0.06871930}, {580,0.11538596}, {585,0.07014912}, {590,0.07084211}, {595,0.11857018}, {600,0.07226087}, {605,0.07300877}, {610,0.12071053}, {615,0.07468421}, {620,0.07535965}, {625,0.12393860}, {630,0.07689474}, {635,0.07759649}, {640,0.12514035}, {645,0.07913158}, {650,0.07995614}, {655,0.12137719}, {660,0.08155263}, {665,0.12123684}, {670,0.08313158}, {675,0.08392982}, {680,0.13475439}, {685,0.08539474}, {690,0.08612281}, {695,0.12594737}, {700,0.08513043}, {705,0.12587719}, {710,0.08663158}, {715,0.08742105}, {720,0.14843860}, {725,0.08901754}, {730,0.63685965}, {735,0.25885965}, {740,0.09173684}, {745,0.09258772}, {750,0.13750877}, {755,0.09412281}, {760,0.13366667}, {765,0.09582456}, {770,0.13929825}, {775,0.09747368}, {780,0.09816667}, {785,0.14649123}, {790,0.09994737}, {795,0.14467544}, {800,0.10154783}, {805,0.14591228}, {810,0.10322807}, {815,0.14406140}, {820,0.10494737}, {825,0.10573684}, {830,0.19558772}, {835,0.11049123}, {840,0.21104386}, {845,0.11213158}, {850,0.16114912}, {855,0.11405263}, {860,0.15431579}, {865,0.11580702}, {870,0.15660526}, {875,0.11788596}, {880,0.17031579}, {885,0.11959649}, {890,0.16334211}, {895,0.12142105}, {900,0.16434783}, {905,0.12340351}, {910,0.16663158}, {915,0.12528070}, {920,0.16809649}, {925,0.12740351}, {930,0.16608772}, {935,0.12904386}, {940,0.16287719}, {945,0.13178070}, {950,0.16789474}, {955,0.18628947}, {960,0.13558772}, {965,0.18960526}, {970,0.13715789}, {975,0.19213158}, {980,0.13942982}, {985,0.18803509}, {990,0.14387719}, {995,0.17930702}, {1000,0.18301739}, {1010,0.20450}, {1020,0.14425}, {1030,0.22925}, {1040,0.14725}, {1050,0.22925}, {1060,0.15325}, {1070,0.17675}, {1080,0.20625}, {1090,0.15925}, {1100,0.23450}, {1110,0.19425}, {1120,0.16300}, {1130,0.21450}, {1140,0.16675}, {1150,0.19450}, {1160,0.22875}, {1170,0.17350}, {1180,0.25600}, {1190,0.23875}, {1200,0.18025}, {1210,0.20975}, {1220,0.26125}, {1230,0.23275}, {1240,0.19425}, {1250,0.25075}, {1260,0.24025}, {1270,0.20100}, {1280,0.25600}, {1290,0.25975}, {1300,0.27125}, {1310,0.21125}, {1320,0.26525}, {1330,0.24125}, {1340,0.41000}, {1350,0.21625}, {1360,0.25700}, {1370,0.26975}, {1380,0.27000}, {1390,0.22800}, {1400,0.27300}, {1410,0.27600}, {1420,0.31800}, {1430,0.30300}, {1440,0.24400}, {1450,0.28675}, {1460,0.29850}, {1470,0.29475}, {1480,0.32450}, {1490,0.34825}, {1500,0.27540}, {1510,0.33800}, {1520,0.35300}, {1530,0.31000}, {1540,0.31500}, {1550,0.32325}, {1560,0.34450}, {1570,0.27950}, {1580,0.29925}, {1590,0.31250}, {1600,0.56900}, {1610,0.39225}, {1620,0.32975}, {1630,0.33050}, {1640,0.33375}, {1650,0.33875}, {1660,0.34725}, {1670,0.33625}, {1680,0.40350}, {1690,0.38250}, {1700,0.37425}, {1710,0.37325}, {1720,0.38400}, {1730,0.43050}, {1740,0.45425}, {1750,0.44100}, {1760,0.44300}, {1770,0.43950}, {1780,0.40225}, {1790,0.40525}, {1800,0.40900}, {1810,0.41400}, {1820,0.43325}, {1830,0.41900}, {1840,0.39825}, {1850,0.41325}, {1860,0.41425}, {1870,0.41650}, {1880,0.41800}, {1890,0.42200}, {1900,0.42175}, {1910,0.41825}, {1920,0.42050}, {1930,0.42275}, {1940,0.41350}, {1950,0.41025}, {1960,0.47200}, {1970,0.45525}, {1980,0.45700}, {1990,0.46100}, {2000,0.47740}, {2050,0.48100}, {2100,0.54125}, {2150,1.73475}, {2200,0.59725}, {2250,0.58925}, {2300,0.60225}, {2350,0.60575}, {2400,0.64250}, {2450,0.66225}, {2500,0.67780}, {2550,0.70850}, {2600,0.72175}, {2650,0.74775}, {2700,0.78225}, {2750,0.78425}, {2800,0.78200}, {2850,0.82250}, {2900,0.86625}, {2950,0.87175}, {3000,0.89640}, {3050,0.93175}, {3100,0.91850}, {3150,0.96125}, {3200,0.97500}, {3250,0.98750}, {3300,1.03850}, {3350,1.12825}, {3400,1.13000}, {3450,1.17675}, {3500,1.21040}, {3550,1.29400}, {3600,1.33025}, {3650,1.34500}, {3700,1.41125}, {3750,1.45450}, {3800,1.42750}, {3850,1.39250}, {3900,1.40075}, {3950,1.42100}, {4000,1.46800}, {4050,1.51825}, {4100,1.50325}, {4150,1.54825}, {4200,1.58625}, {4250,1.56675}, {4300,1.65725}, {4350,1.62325}, {4400,1.68975}, {4450,1.69050}, {4500,3.11880}, {4550,1.83225}, {4600,1.91650}, {4650,2.01000}, {4700,1.96525}, {4750,2.07150}, {4800,2.22050}, {4850,2.16375}, {4900,2.06050}, {4950,2.09825}, {5000,2.13020}, {5050,2.3340}, {5100,2.3470}, {5150,2.3755}};
data["big"]["ParsingElaborated"]["reif"]["user"] = {{1,0.00011304}, {2,0.00024348}, {3,0.00023478}, {4,0.00060000}, {5,0.00073913}, {6,0.00095652}, {7,0.00090435}, {8,0.00092174}, {9,0.00110435}, {10,0.00125217}, {11,0.00119130}, {12,0.00174783}, {13,0.00133913}, {14,0.00164348}, {15,0.00173913}, {16,0.00177391}, {17,0.00188696}, {18,0.00186087}, {19,0.00190435}, {20,0.00208696}, {21,0.00225217}, {22,0.00306957}, {23,0.00228696}, {24,0.00260000}, {25,0.00226087}, {26,0.00246087}, {27,0.00273043}, {28,0.00271304}, {29,0.00266087}, {30,0.00272174}, {31,0.00295652}, {32,0.00439130}, {33,0.00347826}, {34,0.00320870}, {35,0.00345217}, {36,0.00343478}, {37,0.00348696}, {38,0.00364348}, {39,0.00363478}, {40,0.05470435}, {41,0.00412174}, {42,0.00417391}, {43,0.00399130}, {44,0.00424348}, {45,0.00402609}, {46,0.00440000}, {47,0.00710435}, {48,0.00458261}, {49,0.00447826}, {50,0.00447826}, {51,0.00495652}, {52,0.00493913}, {53,0.00506957}, {54,0.00545217}, {55,0.00542609}, {56,0.00562609}, {57,0.00579130}, {58,0.00587826}, {59,0.00575652}, {60,0.00583478}, {61,0.00588696}, {62,0.00593913}, {63,0.00607826}, {64,0.00581739}, {65,0.00613043}, {66,0.00635652}, {67,0.01212174}, {68,0.00692174}, {69,0.00684348}, {70,0.07733913}, {71,0.00713043}, {72,0.00707826}, {73,0.00722609}, {74,0.00744348}, {75,0.00757391}, {76,0.00778261}, {77,0.00785217}, {78,0.00793043}, {79,0.00803478}, {80,0.00802609}, {81,0.00795652}, {82,0.00825217}, {83,0.00853913}, {84,0.00843478}, {85,0.00833913}, {86,0.00876522}, {87,0.00869565}, {88,0.00884348}, {89,0.00937391}, {90,0.00886957}, {91,0.00920870}, {92,0.06488696}, {93,0.00943478}, {94,0.00962609}, {95,0.00942609}, {96,0.02181739}, {97,0.00933913}, {98,0.00997391}, {99,0.00973913}, {100,0.01019130}, {101,0.01019130}, {102,0.01008696}, {103,0.01022609}, {104,0.01074783}, {105,0.01043478}, {106,0.01041739}, {107,0.01070435}, {108,0.01115652}, {109,0.06082609}, {110,0.01132174}, {111,0.01144348}, {112,0.01163478}, {113,0.01182609}, {114,0.01175652}, {115,0.01175652}, {116,0.01179130}, {117,0.01193043}, {118,0.01192174}, {119,0.01209565}, {120,0.01241739}, {121,0.01226087}, {122,0.01254783}, {123,0.01231304}, {124,0.05033913}, {125,0.01293043}, {126,0.01313913}, {127,0.01327826}, {128,0.01348696}, {129,0.01339130}, {130,0.01360000}, {131,0.01324348}, {132,0.01384348}, {133,0.01370435}, {134,0.01405217}, {135,0.01401739}, {136,0.01384348}, {137,0.09227826}, {138,0.01353913}, {139,0.01367826}, {140,0.01399130}, {141,0.01417391}, {142,0.01411304}, {143,0.01483478}, {144,0.01459130}, {145,0.01475652}, {146,0.01444348}, {147,0.01436522}, {148,0.01470435}, {149,0.05213043}, {150,0.01507826}, {151,0.01498261}, {152,0.01529565}, {153,0.01550435}, {154,0.01547826}, {155,0.01589565}, {156,0.01589565}, {157,0.01582609}, {158,0.01582609}, {159,0.01586087}, {160,0.05313913}, {161,0.01620870}, {162,0.01620870}, {163,0.01655652}, {164,0.01638261}, {165,0.01674783}, {166,0.01676522}, {167,0.01708696}, {168,0.01679130}, {169,0.01662609}, {170,0.01721739}, {171,0.05787826}, {172,0.01757391}, {173,0.01731304}, {174,0.01758261}, {175,0.01753043}, {176,0.01793043}, {177,0.01791304}, {178,0.01790435}, {179,0.01840000}, {180,0.01825217}, {181,0.05965217}, {182,0.01835652}, {183,0.01860870}, {184,0.01849565}, {185,0.01858261}, {186,0.01888696}, {187,0.01928696}, {188,0.01891304}, {189,0.01876522}, {190,0.05973913}, {191,0.01901739}, {192,0.01922609}, {193,0.01956522}, {194,0.01966087}, {195,0.07020000}, {196,0.02004348}, {197,0.02000000}, {198,0.02033913}, {199,0.07797391}, {200,0.02000000}, {201,0.02033913}, {202,0.02058261}, {203,0.02086087}, {204,0.02091304}, {205,0.02093913}, {206,0.02087826}, {207,0.09441739}, {208,0.02193913}, {209,0.02211304}, {210,0.02207826}, {211,0.02269565}, {212,0.02246957}, {213,0.02246957}, {214,0.02284348}, {215,0.02263478}, {216,0.08340870}, {217,0.02316522}, {218,0.02319130}, {219,0.02344348}, {220,0.02309565}, {221,0.02323478}, {222,0.02360000}, {223,0.02375652}, {224,0.07073043}, {225,0.02386957}, {226,0.02414783}, {227,0.02385217}, {228,0.02433043}, {229,0.02446957}, {230,0.02473913}, {231,0.02437391}, {232,0.05973913}, {233,0.02488696}, {234,0.02494783}, {235,0.02482609}, {236,0.02523478}, {237,0.02500000}, {238,0.02671304}, {239,0.06878261}, {240,0.02521739}, {241,0.02566957}, {242,0.02598261}, {243,0.02577391}, {244,0.02603478}, {245,0.02628696}, {246,0.07306087}, {247,0.02622609}, {248,0.02591304}, {249,0.02622609}, {250,0.02671304}, {251,0.02662609}, {252,0.02695652}, {253,0.09986957}, {254,0.02695652}, {255,0.02721739}, {256,0.02722609}, {257,0.02690435}, {258,0.02721739}, {259,0.02741739}, {260,0.07741739}, {261,0.02740000}, {262,0.02754783}, {263,0.02794783}, {264,0.02773913}, {265,0.02779130}, {266,0.02815652}, {267,0.07064348}, {268,0.02866087}, {269,0.02842609}, {270,0.02881739}, {271,0.02906957}, {272,0.02917391}, {273,0.02888696}, {274,0.06172174}, {275,0.02812174}, {276,0.12941739}, {277,0.02828696}, {278,0.02896522}, {279,0.12146087}, {280,0.02853913}, {281,0.02893913}, {282,0.02898261}, {283,0.02928696}, {284,0.02935652}, {285,0.06876522}, {286,0.02992174}, {287,0.03017391}, {288,0.02996522}, {289,0.03002609}, {290,0.03040000}, {291,0.03057391}, {292,0.06918261}, {293,0.03076522}, {294,0.03070435}, {295,0.03076522}, {296,0.03110435}, {297,0.03109565}, {298,0.07126957}, {299,0.03127826}, {300,0.03145217}, {301,0.03180000}, {302,0.03171304}, {303,0.07539130}, {304,0.03195652}, {305,0.03204348}, {306,0.03208696}, {307,0.03246957}, {308,0.03232174}, {309,0.09389565}, {310,0.03250435}, {311,0.03263478}, {312,0.03316522}, {313,0.03314783}, {314,0.03330435}, {315,0.07589565}, {316,0.03314783}, {317,0.03344348}, {318,0.03336522}, {319,0.03355652}, {320,0.03400870}, {321,0.05964348}, {322,0.03348696}, {323,0.03422609}, {324,0.03386087}, {325,0.03401739}, {326,0.12833913}, {327,0.03544348}, {328,0.03558261}, {329,0.03577391}, {330,0.03574783}, {331,0.09311304}, {332,0.03614783}, {333,0.03633043}, {334,0.03640000}, {335,0.03625217}, {336,0.03651304}, {337,0.08806087}, {338,0.03934783}, {339,0.03693043}, {340,0.03671304}, {341,0.03693043}, {342,0.07651304}, {343,0.03723478}, {344,0.03746957}, {345,0.03742609}, {346,0.03774783}, {347,0.08299130}, {348,0.03828696}, {349,0.03821739}, {350,0.03882609}, {351,0.03833043}, {352,0.09328696}, {353,0.03882609}, {354,0.03891304}, {355,0.03914783}, {356,0.03926087}, {357,0.11301739}, {358,0.03933043}, {359,0.03948696}, {360,0.03958261}, {361,0.04017391}, {362,0.11904348}, {363,0.03985217}, {364,0.04028696}, {365,0.04031304}, {366,0.04033043}, {367,0.11898261}, {368,0.04094783}, {369,0.04095652}, {370,0.04106957}, {371,0.04088696}, {372,0.10380000}, {373,0.04089565}, {374,0.04109565}, {375,0.04190435}, {376,0.04154783}, {377,0.07596522}, {378,0.04197391}, {379,0.04184348}, {380,0.04212174}, {381,0.08653043}, {382,0.04271304}, {383,0.04253043}, {384,0.04302609}, {385,0.04291304}, {386,0.08472174}, {387,0.04330435}, {388,0.04340870}, {389,0.04320870}, {390,0.09536522}, {391,0.04365217}, {392,0.23926957}, {393,0.04271304}, {394,0.13080000}, {395,0.04238261}, {396,0.04271304}, {397,0.04270435}, {398,0.07976522}, {399,0.04335652}, {400,0.04337391}, {401,0.04321739}, {402,0.04373043}, {403,0.09237391}, {404,0.04385217}, {405,0.04387826}, {406,0.04396522}, {407,0.08252174}, {408,0.04421739}, {409,0.04460000}, {410,0.04431304}, {411,0.08333043}, {412,0.04519130}, {413,0.04473043}, {414,0.04520000}, {415,0.04474783}, {416,0.08657391}, {417,0.04523478}, {418,0.04560870}, {419,0.04565217}, {420,0.08258261}, {421,0.04600870}, {422,0.04620870}, {423,0.04635652}, {424,0.08330435}, {425,0.04615652}, {426,0.04646087}, {427,0.04663478}, {428,0.08673913}, {429,0.04682609}, {430,0.04732174}, {431,0.04737391}, {432,0.08700870}, {433,0.04763478}, {434,0.04787826}, {435,0.04793043}, {436,0.04800870}, {437,0.08582609}, {438,0.04800870}, {439,0.04840000}, {440,0.04829565}, {441,0.08618261}, {442,0.04878261}, {443,0.04866087}, {444,0.04858261}, {445,0.08510435}, {446,0.04873913}, {447,0.04905217}, {448,0.04912174}, {449,0.08855652}, {450,0.04943478}, {451,0.04968696}, {452,0.04986087}, {453,0.09012174}, {454,0.04980000}, {455,0.04993913}, {456,0.09505217}, {457,0.05016522}, {458,0.05010435}, {459,0.05049565}, {460,0.11712174}, {461,0.05075652}, {462,0.05066087}, {463,0.05075652}, {464,0.15477391}, {465,0.05271304}, {466,0.05270435}, {467,0.05302609}, {468,0.11456522}, {469,0.05349565}, {470,0.05347826}, {471,0.05381739}, {472,0.10102609}, {473,0.05394783}, {474,0.05400870}, {475,0.05427826}, {476,0.08643478}, {477,0.05447826}, {478,0.05479130}, {479,0.09772174}, {480,0.05513043}, {481,0.05544348}, {482,0.05552174}, {483,0.10587826}, {484,0.05561739}, {485,0.05573043}, {486,0.05601739}, {487,0.12074783}, {488,0.05606087}, {489,0.05617391}, {490,0.13663478}, {491,0.05648696}, {492,0.05646957}, {493,0.05702609}, {494,0.14040870}, {495,0.05678261}, {496,0.05760000}, {497,0.13053913}, {498,0.05719130}, {499,0.05774783}, {500,0.102925764}, {505,0.05843860}, {510,0.05894737}, {515,0.05970175}, {520,0.12618421}, {525,0.06126316}, {530,0.06206140}, {535,0.17107018}, {540,0.06351754}, {545,0.06409649}, {550,0.14019298}, {555,0.06599123}, {560,0.06614035}, {565,0.11453509}, {570,0.06754386}, {575,0.06837719}, {580,0.11372807}, {585,0.06950877}, {590,0.06991228}, {595,0.11718421}, {600,0.07158261}, {605,0.07231579}, {610,0.11930702}, {615,0.07445614}, {620,0.07516667}, {625,0.12219298}, {630,0.07683333}, {635,0.07735965}, {640,0.12414035}, {645,0.07837719}, {650,0.07944737}, {655,0.12025439}, {660,0.08094737}, {665,0.11987719}, {670,0.08212281}, {675,0.08287719}, {680,0.13373684}, {685,0.08450000}, {690,0.08528947}, {695,0.12527193}, {700,0.08434783}, {705,0.12467544}, {710,0.08635088}, {715,0.08717544}, {720,0.14633333}, {725,0.08839474}, {730,0.62993860}, {735,0.25164035}, {740,0.09111404}, {745,0.09200877}, {750,0.13668421}, {755,0.09367544}, {760,0.13307895}, {765,0.09598246}, {770,0.13921930}, {775,0.09692982}, {780,0.09784211}, {785,0.14592982}, {790,0.09966667}, {795,0.14421930}, {800,0.10105217}, {805,0.14530702}, {810,0.10240351}, {815,0.14315789}, {820,0.10415789}, {825,0.10507018}, {830,0.19421053}, {835,0.10978070}, {840,0.20927193}, {845,0.11149123}, {850,0.15995614}, {855,0.11323684}, {860,0.15231579}, {865,0.11453509}, {870,0.15547368}, {875,0.11671930}, {880,0.16913158}, {885,0.11887719}, {890,0.16235965}, {895,0.12028070}, {900,0.16298261}, {905,0.12266667}, {910,0.16492105}, {915,0.12449123}, {920,0.16655263}, {925,0.12707018}, {930,0.16427193}, {935,0.12807018}, {940,0.16136842}, {945,0.13065789}, {950,0.16437719}, {955,0.18203509}, {960,0.13399123}, {965,0.18785965}, {970,0.13604386}, {975,0.18896491}, {980,0.13836842}, {985,0.18505263}, {990,0.14124561}, {995,0.17738596}, {1000,0.18164348}, {1010,0.18875}, {1020,0.14400}, {1030,0.22750}, {1040,0.14675}, {1050,0.22200}, {1060,0.15325}, {1070,0.17675}, {1080,0.20200}, {1090,0.15650}, {1100,0.22875}, {1110,0.19425}, {1120,0.16100}, {1130,0.21300}, {1140,0.16600}, {1150,0.19275}, {1160,0.22650}, {1170,0.17275}, {1180,0.25125}, {1190,0.23650}, {1200,0.18000}, {1210,0.20850}, {1220,0.26125}, {1230,0.23325}, {1240,0.19275}, {1250,0.24900}, {1260,0.23725}, {1270,0.20050}, {1280,0.25050}, {1290,0.25950}, {1300,0.26675}, {1310,0.20750}, {1320,0.26425}, {1330,0.23825}, {1340,0.40575}, {1350,0.21550}, {1360,0.25550}, {1370,0.26650}, {1380,0.26875}, {1390,0.22550}, {1400,0.27175}, {1410,0.27475}, {1420,0.31575}, {1430,0.29925}, {1440,0.23925}, {1450,0.28625}, {1460,0.29650}, {1470,0.29250}, {1480,0.32200}, {1490,0.34625}, {1500,0.27160}, {1510,0.33725}, {1520,0.34975}, {1530,0.30825}, {1540,0.31350}, {1550,0.32150}, {1560,0.34175}, {1570,0.27725}, {1580,0.29575}, {1590,0.31025}, {1600,0.56450}, {1610,0.38775}, {1620,0.32750}, {1630,0.32925}, {1640,0.33125}, {1650,0.33550}, {1660,0.34650}, {1670,0.32900}, {1680,0.40250}, {1690,0.37950}, {1700,0.37375}, {1710,0.37125}, {1720,0.38350}, {1730,0.42925}, {1740,0.45125}, {1750,0.43850}, {1760,0.43850}, {1770,0.43625}, {1780,0.39850}, {1790,0.40525}, {1800,0.40650}, {1810,0.41275}, {1820,0.43000}, {1830,0.41450}, {1840,0.39725}, {1850,0.41075}, {1860,0.41075}, {1870,0.41625}, {1880,0.41375}, {1890,0.41725}, {1900,0.41575}, {1910,0.41750}, {1920,0.41875}, {1930,0.42175}, {1940,0.41350}, {1950,0.40950}, {1960,0.47200}, {1970,0.45225}, {1980,0.45450}, {1990,0.46050}, {2000,0.47640}, {2050,0.47975}, {2100,0.53975}, {2150,1.63700}, {2200,0.58750}, {2250,0.57175}, {2300,0.58825}, {2350,0.59675}, {2400,0.62825}, {2450,0.65075}, {2500,0.66500}, {2550,0.69250}, {2600,0.70875}, {2650,0.73100}, {2700,0.76250}, {2750,0.76700}, {2800,0.76875}, {2850,0.81000}, {2900,0.84425}, {2950,0.85475}, {3000,0.88320}, {3050,0.91625}, {3100,0.90050}, {3150,0.94825}, {3200,0.96775}, {3250,0.98550}, {3300,1.03625}, {3350,1.12175}, {3400,1.12750}, {3450,1.16500}, {3500,1.19320}, {3550,1.27450}, {3600,1.31075}, {3650,1.32125}, {3700,1.39150}, {3750,1.42850}, {3800,1.41075}, {3850,1.37250}, {3900,1.38325}, {3950,1.39950}, {4000,1.45060}, {4050,1.49425}, {4100,1.48050}, {4150,1.51850}, {4200,1.56175}, {4250,1.54500}, {4300,1.63100}, {4350,1.61675}, {4400,1.68725}, {4450,1.68500}, {4500,2.94600}, {4550,1.81425}, {4600,1.91175}, {4650,2.00575}, {4700,1.95925}, {4750,2.06725}, {4800,2.18900}, {4850,2.13725}, {4900,2.02725}, {4950,2.06475}, {5000,2.11180}, {5050,2.2555}, {5100,2.2490}, {5150,2.2635}};
data["big"]["ParsingElaborated"]["reif"]["system"] = {{1,0.00024348}, {2,0.00036522}, {3,0.00020000}, {4,0.00016522}, {5,0.00010435}, {6,0.00013913}, {7,0.00026087}, {8,0.00003478}, {9,0.00016522}, {10,0.00018261}, {11,0.00013043}, {12,0.00006957}, {13,0.00006957}, {14,0.00023478}, {15,0.00016522}, {16,0.00015652}, {17,0.00020870}, {18,0.00013043}, {19,0.00043478}, {20,0.00023478}, {21,0.00009565}, {22,0.00026957}, {23,0.00029565}, {24,0.00024348}, {25,0.00028696}, {26,0.00027826}, {27,0.00023478}, {28,0.00041739}, {29,0.00039130}, {30,0.00040870}, {31,0.00040870}, {32,0.00035652}, {33,0.00022609}, {34,0.00046957}, {35,0.00025217}, {36,0.00038261}, {37,0.00034783}, {38,0.00037391}, {39,0.00038261}, {40,0.00243478}, {41,0.00006957}, {42,0.00000000}, {43,0.00003478}, {44,0.00009565}, {45,0.00006087}, {46,0.00000000}, {47,0.00003478}, {48,0.00003478}, {49,0.00003478}, {50,0.00000000}, {51,0.00000000}, {52,0.00006957}, {53,0.00018261}, {54,0.00000000}, {55,0.00002609}, {56,0.00009565}, {57,0.00006957}, {58,0.00000000}, {59,0.00012174}, {60,0.00000000}, {61,0.00000000}, {62,0.00002609}, {63,0.00009565}, {64,0.00009565}, {65,0.00006087}, {66,0.00009565}, {67,0.00013043}, {68,0.00006957}, {69,0.00006087}, {70,0.00060000}, {71,0.00010435}, {72,0.00008696}, {73,0.00003478}, {74,0.00013043}, {75,0.00006957}, {76,0.00002609}, {77,0.00003478}, {78,0.00006087}, {79,0.00009565}, {80,0.00003478}, {81,0.00009565}, {82,0.00003478}, {83,0.00006957}, {84,0.00002609}, {85,0.00006957}, {86,0.00008696}, {87,0.00000000}, {88,0.00020870}, {89,0.00003478}, {90,0.00006957}, {91,0.00010435}, {92,0.00075652}, {93,0.00013913}, {94,0.00006957}, {95,0.00006087}, {96,0.00013043}, {97,0.00016522}, {98,0.00008696}, {99,0.00017391}, {100,0.00006957}, {101,0.00016522}, {102,0.00006087}, {103,0.00002609}, {104,0.00006957}, {105,0.00002609}, {106,0.00006087}, {107,0.00006957}, {108,0.00000000}, {109,0.00108696}, {110,0.00010435}, {111,0.00006087}, {112,0.00000000}, {113,0.00010435}, {114,0.00013913}, {115,0.00010435}, {116,0.00006087}, {117,0.00010435}, {118,0.00003478}, {119,0.00006087}, {120,0.00026087}, {121,0.00006957}, {122,0.00006957}, {123,0.00006957}, {124,0.00050435}, {125,0.00022609}, {126,0.00009565}, {127,0.00009565}, {128,0.00006087}, {129,0.00015652}, {130,0.00006087}, {131,0.00006957}, {132,0.00009565}, {133,0.00000000}, {134,0.00024348}, {135,0.00006087}, {136,0.00013913}, {137,0.00125217}, {138,0.00038261}, {139,0.00027826}, {140,0.00006957}, {141,0.00020870}, {142,0.00013043}, {143,0.00002609}, {144,0.00003478}, {145,0.00000000}, {146,0.00013043}, {147,0.00008696}, {148,0.00014783}, {149,0.00080870}, {150,0.00006957}, {151,0.00023478}, {152,0.00013043}, {153,0.00010435}, {154,0.00013913}, {155,0.00003478}, {156,0.00003478}, {157,0.00006957}, {158,0.00009565}, {159,0.00013043}, {160,0.00057391}, {161,0.00026957}, {162,0.00020870}, {163,0.00009565}, {164,0.00013913}, {165,0.00013913}, {166,0.00009565}, {167,0.00012174}, {168,0.00009565}, {169,0.00017391}, {170,0.00017391}, {171,0.00131304}, {172,0.00020000}, {173,0.00010435}, {174,0.00037391}, {175,0.00006087}, {176,0.00026087}, {177,0.00016522}, {178,0.00016522}, {179,0.00017391}, {180,0.00020870}, {181,0.00032174}, {182,0.00038261}, {183,0.00022609}, {184,0.00020000}, {185,0.00010435}, {186,0.00020870}, {187,0.00010435}, {188,0.00012174}, {189,0.00010435}, {190,0.00073913}, {191,0.00012174}, {192,0.00010435}, {193,0.00013913}, {194,0.00010435}, {195,0.00058261}, {196,0.00013043}, {197,0.00017391}, {198,0.00013913}, {199,0.00156522}, {200,0.00042609}, {201,0.00029565}, {202,0.00003478}, {203,0.00036522}, {204,0.00017391}, {205,0.00006957}, {206,0.00026087}, {207,0.00098261}, {208,0.00026957}, {209,0.00016522}, {210,0.00016522}, {211,0.00013913}, {212,0.00021739}, {213,0.00017391}, {214,0.00002609}, {215,0.00006087}, {216,0.00084348}, {217,0.00019130}, {218,0.00016522}, {219,0.00013043}, {220,0.00020870}, {221,0.00017391}, {222,0.00010435}, {223,0.00020000}, {224,0.00100870}, {225,0.00017391}, {226,0.00006957}, {227,0.00022609}, {228,0.00017391}, {229,0.00010435}, {230,0.00010435}, {231,0.00020870}, {232,0.00083478}, {233,0.00013913}, {234,0.00012174}, {235,0.00020870}, {236,0.00013913}, {237,0.00017391}, {238,0.00026957}, {239,0.00091304}, {240,0.00029565}, {241,0.00017391}, {242,0.00026087}, {243,0.00009565}, {244,0.00023478}, {245,0.00015652}, {246,0.00084348}, {247,0.00052174}, {248,0.00031304}, {249,0.00020870}, {250,0.00017391}, {251,0.00024348}, {252,0.00010435}, {253,0.00080870}, {254,0.00022609}, {255,0.00017391}, {256,0.00013913}, {257,0.00009565}, {258,0.00002609}, {259,0.00009565}, {260,0.00076522}, {261,0.00033913}, {262,0.00030435}, {263,0.00006957}, {264,0.00016522}, {265,0.00036522}, {266,0.00010435}, {267,0.00099130}, {268,0.00016522}, {269,0.00027826}, {270,0.00010435}, {271,0.00009565}, {272,0.00016522}, {273,0.00033043}, {274,0.00070435}, {275,0.00026957}, {276,0.00072174}, {277,0.00043478}, {278,0.00024348}, {279,0.00226087}, {280,0.00059130}, {281,0.00023478}, {282,0.00036522}, {283,0.00022609}, {284,0.00038261}, {285,0.00093043}, {286,0.00009565}, {287,0.00006087}, {288,0.00031304}, {289,0.00033913}, {290,0.00013043}, {291,0.00020870}, {292,0.00066087}, {293,0.00020870}, {294,0.00020000}, {295,0.00025217}, {296,0.00017391}, {297,0.00027826}, {298,0.00031304}, {299,0.00015652}, {300,0.00023478}, {301,0.00010435}, {302,0.00028696}, {303,0.00020870}, {304,0.00029565}, {305,0.00020870}, {306,0.00013043}, {307,0.00020870}, {308,0.00052174}, {309,0.00042609}, {310,0.00028696}, {311,0.00045217}, {312,0.00010435}, {313,0.00013913}, {314,0.00010435}, {315,0.00046087}, {316,0.00029565}, {317,0.00020870}, {318,0.00036522}, {319,0.00027826}, {320,0.00006957}, {321,0.00033913}, {322,0.00036522}, {323,0.00023478}, {324,0.00016522}, {325,0.00020870}, {326,0.00163478}, {327,0.00015652}, {328,0.00041739}, {329,0.00020000}, {330,0.00029565}, {331,0.00080000}, {332,0.00040870}, {333,0.00026087}, {334,0.00013913}, {335,0.00020870}, {336,0.00020870}, {337,0.00086957}, {338,0.00053913}, {339,0.00042609}, {340,0.00033913}, {341,0.00034783}, {342,0.00094783}, {343,0.00046087}, {344,0.00030435}, {345,0.00036522}, {346,0.00031304}, {347,0.00093043}, {348,0.00020870}, {349,0.00046957}, {350,0.00033913}, {351,0.00044348}, {352,0.00106087}, {353,0.00017391}, {354,0.00044348}, {355,0.00017391}, {356,0.00020000}, {357,0.00095652}, {358,0.00041739}, {359,0.00021739}, {360,0.00029565}, {361,0.00023478}, {362,0.00101739}, {363,0.00047826}, {364,0.00032174}, {365,0.00024348}, {366,0.00031304}, {367,0.00081739}, {368,0.00044348}, {369,0.00031304}, {370,0.00034783}, {371,0.00020870}, {372,0.00089565}, {373,0.00030435}, {374,0.00037391}, {375,0.00024348}, {376,0.00027826}, {377,0.00100000}, {378,0.00042609}, {379,0.00028696}, {380,0.00023478}, {381,0.00089565}, {382,0.00024348}, {383,0.00020870}, {384,0.00017391}, {385,0.00026957}, {386,0.00081739}, {387,0.00039130}, {388,0.00033913}, {389,0.00026957}, {390,0.00135652}, {391,0.00036522}, {392,0.00151304}, {393,0.00033043}, {394,0.00586957}, {395,0.00033043}, {396,0.00040870}, {397,0.00030435}, {398,0.00102609}, {399,0.00020870}, {400,0.00020000}, {401,0.00033043}, {402,0.00019130}, {403,0.00141739}, {404,0.00016522}, {405,0.00029565}, {406,0.00022609}, {407,0.00073913}, {408,0.00029565}, {409,0.00029565}, {410,0.00033043}, {411,0.00103478}, {412,0.00013043}, {413,0.00030435}, {414,0.00044348}, {415,0.00027826}, {416,0.00061739}, {417,0.00034783}, {418,0.00030435}, {419,0.00033913}, {420,0.00126957}, {421,0.00036522}, {422,0.00041739}, {423,0.00006957}, {424,0.00078261}, {425,0.00024348}, {426,0.00034783}, {427,0.00035652}, {428,0.00104348}, {429,0.00044348}, {430,0.00013913}, {431,0.00024348}, {432,0.00118261}, {433,0.00037391}, {434,0.00022609}, {435,0.00031304}, {436,0.00030435}, {437,0.00100870}, {438,0.00034783}, {439,0.00030435}, {440,0.00040000}, {441,0.00124348}, {442,0.00027826}, {443,0.00043478}, {444,0.00037391}, {445,0.00131304}, {446,0.00039130}, {447,0.00037391}, {448,0.00040870}, {449,0.00038261}, {450,0.00031304}, {451,0.00037391}, {452,0.00020000}, {453,0.00013913}, {454,0.00030435}, {455,0.00024348}, {456,0.00040870}, {457,0.00031304}, {458,0.00033913}, {459,0.00020000}, {460,0.00060000}, {461,0.00020000}, {462,0.00026957}, {463,0.00023478}, {464,0.00139130}, {465,0.00044348}, {466,0.00037391}, {467,0.00036522}, {468,0.00139130}, {469,0.00038261}, {470,0.00031304}, {471,0.00034783}, {472,0.00132174}, {473,0.00034783}, {474,0.00050435}, {475,0.00033913}, {476,0.00069565}, {477,0.00023478}, {478,0.00024348}, {479,0.00154783}, {480,0.00026087}, {481,0.00013913}, {482,0.00017391}, {483,0.00110435}, {484,0.00029565}, {485,0.00034783}, {486,0.00017391}, {487,0.00086087}, {488,0.00054783}, {489,0.00053913}, {490,0.00072174}, {491,0.00044348}, {492,0.00031304}, {493,0.00031304}, {494,0.00141739}, {495,0.00027826}, {496,0.00055652}, {497,0.00100870}, {498,0.00040870}, {499,0.00024348}, {500,0.000676856}, {505,0.00041228}, {510,0.00036842}, {515,0.00059649}, {520,0.00081579}, {525,0.00040351}, {530,0.00052632}, {535,0.00144737}, {540,0.00062281}, {545,0.00073684}, {550,0.00131579}, {555,0.00028070}, {560,0.00049123}, {565,0.00094737}, {570,0.00044737}, {575,0.00035088}, {580,0.00141228}, {585,0.00041228}, {590,0.00059649}, {595,0.00131579}, {600,0.00069565}, {605,0.00065789}, {610,0.00118421}, {615,0.00041228}, {620,0.00035088}, {625,0.00181579}, {630,0.00024561}, {635,0.00034211}, {640,0.00112281}, {645,0.00056140}, {650,0.00035965}, {655,0.00099123}, {660,0.00042982}, {665,0.00152632}, {670,0.00064035}, {675,0.00051754}, {680,0.00116667}, {685,0.00035088}, {690,0.00069298}, {695,0.00107018}, {700,0.00054783}, {705,0.00131579}, {710,0.00037719}, {715,0.00055263}, {720,0.00174561}, {725,0.00055263}, {730,0.00678947}, {735,0.00701754}, {740,0.00057895}, {745,0.00068421}, {750,0.00116667}, {755,0.00077193}, {760,0.00047368}, {765,0.00035088}, {770,0.00038596}, {775,0.00051754}, {780,0.00052632}, {785,0.00031579}, {790,0.00024561}, {795,0.00056140}, {800,0.00062609}, {805,0.00031579}, {810,0.00055263}, {815,0.00075439}, {820,0.00056140}, {825,0.00086842}, {830,0.00130702}, {835,0.00062281}, {840,0.00138596}, {845,0.00059649}, {850,0.00145614}, {855,0.00084211}, {860,0.00171053}, {865,0.00090351}, {870,0.00151754}, {875,0.00091228}, {880,0.00113158}, {885,0.00062281}, {890,0.00114912}, {895,0.00082456}, {900,0.00157391}, {905,0.00079825}, {910,0.00147368}, {915,0.00093860}, {920,0.00154386}, {925,0.00070175}, {930,0.00192982}, {935,0.00088596}, {940,0.00164035}, {945,0.00079825}, {950,0.00127193}, {955,0.00155263}, {960,0.00062281}, {965,0.00171053}, {970,0.00116667}, {975,0.00207018}, {980,0.00096491}, {985,0.00168421}, {990,0.00062281}, {995,0.00135088}, {1000,0.00155652}, {1010,0.01575}, {1020,0.00000}, {1030,0.00175}, {1040,0.00175}, {1050,0.00675}, {1060,0.00000}, {1070,0.00000}, {1080,0.00400}, {1090,0.00300}, {1100,0.00475}, {1110,0.00000}, {1120,0.00175}, {1130,0.00175}, {1140,0.00100}, {1150,0.00300}, {1160,0.00100}, {1170,0.00200}, {1180,0.00375}, {1190,0.00175}, {1200,0.00100}, {1210,0.00200}, {1220,0.00000}, {1230,0.00075}, {1240,0.00100}, {1250,0.00200}, {1260,0.00400}, {1270,0.00000}, {1280,0.00375}, {1290,0.00100}, {1300,0.00500}, {1310,0.00275}, {1320,0.00100}, {1330,0.00200}, {1340,0.00500}, {1350,0.00000}, {1360,0.00275}, {1370,0.00200}, {1380,0.00200}, {1390,0.00200}, {1400,0.00100}, {1410,0.00200}, {1420,0.00200}, {1430,0.00175}, {1440,0.00300}, {1450,0.00000}, {1460,0.00200}, {1470,0.00200}, {1480,0.00250}, {1490,0.00200}, {1500,0.00400}, {1510,0.00000}, {1520,0.00300}, {1530,0.00200}, {1540,0.00275}, {1550,0.00000}, {1560,0.00200}, {1570,0.00100}, {1580,0.00400}, {1590,0.00200}, {1600,0.00350}, {1610,0.00500}, {1620,0.00200}, {1630,0.00175}, {1640,0.00100}, {1650,0.00475}, {1660,0.00100}, {1670,0.00600}, {1680,0.00100}, {1690,0.00300}, {1700,0.00200}, {1710,0.00200}, {1720,0.00100}, {1730,0.00000}, {1740,0.00175}, {1750,0.00200}, {1760,0.00375}, {1770,0.00300}, {1780,0.00300}, {1790,0.00000}, {1800,0.00200}, {1810,0.00175}, {1820,0.00200}, {1830,0.00500}, {1840,0.00000}, {1850,0.00400}, {1860,0.00200}, {1870,0.00100}, {1880,0.00500}, {1890,0.00300}, {1900,0.00575}, {1910,0.00075}, {1920,0.00200}, {1930,0.00100}, {1940,0.00000}, {1950,0.00100}, {1960,0.00100}, {1970,0.00000}, {1980,0.00100}, {1990,0.00000}, {2000,0.00160}, {2050,0.00000}, {2100,0.00300}, {2150,0.09550}, {2200,0.01000}, {2250,0.01700}, {2300,0.01175}, {2350,0.00875}, {2400,0.01400}, {2450,0.01075}, {2500,0.01120}, {2550,0.01475}, {2600,0.01275}, {2650,0.01500}, {2700,0.02000}, {2750,0.01800}, {2800,0.01275}, {2850,0.01200}, {2900,0.02100}, {2950,0.01600}, {3000,0.01260}, {3050,0.01500}, {3100,0.01675}, {3150,0.01200}, {3200,0.00575}, {3250,0.00300}, {3300,0.00175}, {3350,0.00600}, {3400,0.00200}, {3450,0.01300}, {3500,0.01660}, {3550,0.01775}, {3600,0.02000}, {3650,0.02175}, {3700,0.02000}, {3750,0.02500}, {3800,0.01775}, {3850,0.01900}, {3900,0.01800}, {3950,0.02175}, {4000,0.01660}, {4050,0.02200}, {4100,0.02300}, {4150,0.02800}, {4200,0.02400}, {4250,0.02200}, {4300,0.02575}, {4350,0.00675}, {4400,0.00200}, {4450,0.00400}, {4500,0.17100}, {4550,0.01600}, {4600,0.00475}, {4650,0.00300}, {4700,0.00575}, {4750,0.00300}, {4800,0.03075}, {4850,0.02500}, {4900,0.02975}, {4950,0.03200}, {5000,0.01900}, {5050,0.0695}, {5100,0.0675}, {5150,0.0435}};
data["big"]["TemplateCoq"]["Aggregate"]["real"] = {{1,0.00100909}, {2,0.00100000}, {3,0.00100000}, {4,0.00100000}, {5,0.00100000}, {6,0.00100000}, {7,0.00100000}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00102727}, {15,0.00114545}, {16,0.00146364}, {17,0.00177273}, {18,0.00194545}, {19,0.00200000}, {20,0.00200000}, {21,0.00200000}, {22,0.00200000}, {23,0.00200000}, {24,0.00200000}, {25,0.00200000}, {26,0.00200000}, {27,0.00200000}, {28,0.00200000}, {29,0.00200000}, {30,0.00202727}, {31,0.00216364}, {32,0.00228182}, {33,0.00240000}, {34,0.00264545}, {35,0.00290000}, {36,0.00299091}, {37,0.00836364}, {38,0.00300000}, {39,0.00300000}, {40,0.00300000}, {41,0.00300000}, {42,0.00300000}, {43,0.00300000}, {44,0.00300000}, {45,0.00300000}, {46,0.00301818}, {47,0.00301818}, {48,0.00308182}, {49,0.00314545}, {50,0.00328182}, {51,0.00356364}, {52,0.00379091}, {53,0.00389091}, {54,0.00396364}, {55,0.00400000}, {56,0.00400000}, {57,0.00532727}, {58,0.00400000}, {59,0.00400000}, {60,0.00400000}, {61,0.00400000}, {62,0.00400000}, {63,0.00404545}, {64,0.00404545}, {65,0.00415455}, {66,0.00422727}, {67,0.00440000}, {68,0.00460909}, {69,0.00476364}, {70,0.00488182}, {71,0.00494545}, {72,0.00497273}, {73,0.00600000}, {74,0.00500000}, {75,0.00500000}, {76,0.00500000}, {77,0.00500000}, {78,0.00502727}, {79,0.00501818}, {80,0.00502727}, {81,0.00508182}, {82,0.00520000}, {83,0.00528182}, {84,0.00552727}, {85,0.00564545}, {86,0.00610000}, {87,0.00590909}, {88,0.00596364}, {89,0.00597273}, {90,0.00599091}, {91,0.00600000}, {92,0.00600000}, {93,0.00600000}, {94,0.00600909}, {95,0.00603636}, {96,0.00602727}, {97,0.00604545}, {98,0.00739091}, {99,0.00625455}, {100,0.00644545}, {101,0.00654545}, {102,0.00669091}, {103,0.00679091}, {104,0.00685455}, {105,0.00692727}, {106,0.00696364}, {107,0.00699091}, {108,0.00699091}, {109,0.00782727}, {110,0.00700909}, {111,0.00701818}, {112,0.00700909}, {113,0.00703636}, {114,0.00712727}, {115,0.00717273}, {116,0.00729091}, {117,0.00738182}, {118,0.00970909}, {119,0.00769091}, {120,0.00778182}, {121,0.00780909}, {122,0.00786364}, {123,0.00792727}, {124,0.00798182}, {125,0.00802727}, {126,0.00800000}, {127,0.01084545}, {128,0.00800000}, {129,0.00801818}, {130,0.00806364}, {131,0.00812727}, {132,0.00821818}, {133,0.00835455}, {134,0.00845455}, {135,0.00860909}, {136,0.00995455}, {137,0.00874545}, {138,0.00882727}, {139,0.00888182}, {140,0.00891818}, {141,0.00897273}, {142,0.00897273}, {143,0.00900000}, {144,0.01010000}, {145,0.00902727}, {146,0.00902727}, {147,0.00908182}, {148,0.00916364}, {149,0.00925455}, {150,0.00930000}, {151,0.01036364}, {152,0.00960000}, {153,0.00973636}, {154,0.00972727}, {155,0.00982727}, {156,0.00982727}, {157,0.00992727}, {158,0.00993636}, {159,0.01088182}, {160,0.00999091}, {161,0.01003636}, {162,0.01002727}, {163,0.01002727}, {164,0.01010000}, {165,0.01008182}, {166,0.01114545}, {167,0.01035455}, {168,0.01043636}, {169,0.01063636}, {170,0.01074545}, {171,0.01077273}, {172,0.01464545}, {173,0.01080909}, {174,0.01089091}, {175,0.01088182}, {176,0.01089091}, {177,0.01103636}, {178,0.01101818}, {179,0.01261818}, {180,0.01110909}, {181,0.01120000}, {182,0.01120909}, {183,0.01139091}, {184,0.01138182}, {185,0.01291818}, {186,0.01158182}, {187,0.01164545}, {188,0.01170909}, {189,0.01180909}, {190,0.01183636}, {191,0.01366364}, {192,0.01190000}, {193,0.01195455}, {194,0.01196364}, {195,0.01208182}, {196,0.01203636}, {197,0.01374545}, {198,0.01210909}, {199,0.01221818}, {200,0.01237273}, {201,0.01245455}, {202,0.01255455}, {203,0.01381818}, {204,0.01268182}, {205,0.01270909}, {206,0.01272727}, {207,0.01282727}, {208,0.01746364}, {209,0.01286364}, {210,0.01288182}, {211,0.01290000}, {212,0.01299091}, {213,0.01306364}, {214,0.01472727}, {215,0.01315455}, {216,0.01320000}, {217,0.01333636}, {218,0.01342727}, {219,0.01534545}, {220,0.01362727}, {221,0.01369091}, {222,0.01371818}, {223,0.01382727}, {224,0.01750000}, {225,0.01385455}, {226,0.01390000}, {227,0.01396364}, {228,0.01402727}, {229,0.01572727}, {230,0.01407273}, {231,0.01413636}, {232,0.01415455}, {233,0.01427273}, {234,0.01956364}, {235,0.01440000}, {236,0.01452727}, {237,0.01460000}, {238,0.01463636}, {239,0.01690000}, {240,0.01476364}, {241,0.01479091}, {242,0.01485455}, {243,0.01483636}, {244,0.01847273}, {245,0.01497273}, {246,0.01498182}, {247,0.01516364}, {248,0.01512727}, {249,0.01672727}, {250,0.01530000}, {251,0.01543636}, {252,0.01552727}, {253,0.02031818}, {254,0.01562727}, {255,0.01566364}, {256,0.01571818}, {257,0.01575455}, {258,0.01809091}, {259,0.01576364}, {260,0.01582727}, {261,0.01590909}, {262,0.02073636}, {263,0.01595455}, {264,0.01608182}, {265,0.01620000}, {266,0.01625455}, {267,0.01845455}, {268,0.01641818}, {269,0.01650000}, {270,0.01659091}, {271,0.01850000}, {272,0.01668182}, {273,0.01671818}, {274,0.01678182}, {275,0.02068182}, {276,0.01682727}, {277,0.01684545}, {278,0.01700909}, {279,0.01968182}, {280,0.01696364}, {281,0.01710000}, {282,0.01718182}, {283,0.01726364}, {284,0.01808182}, {285,0.01739091}, {286,0.01744545}, {287,0.01756364}, {288,0.01895455}, {289,0.01767273}, {290,0.01770909}, {291,0.01778182}, {292,0.01941818}, {293,0.01788182}, {294,0.01790000}, {295,0.01791818}, {296,0.01950000}, {297,0.01794545}, {298,0.01812727}, {299,0.01819091}, {300,0.01884545}, {301,0.01836364}, {302,0.01851818}, {303,0.01974545}, {304,0.01862727}, {305,0.01866364}, {306,0.01872727}, {307,0.02295455}, {308,0.01878182}, {309,0.01878182}, {310,0.01880000}, {311,0.02241818}, {312,0.01882727}, {313,0.01890909}, {314,0.01905455}, {315,0.02098182}, {316,0.01910909}, {317,0.01920909}, {318,0.02082727}, {319,0.01940000}, {320,0.01952727}, {321,0.01953636}, {322,0.02208182}, {323,0.01969091}, {324,0.01967273}, {325,0.01977273}, {326,0.02167273}, {327,0.01976364}, {328,0.01988182}, {329,0.02535455}, {330,0.01988182}, {331,0.01997273}, {332,0.02006364}, {333,0.02331818}, {334,0.02020000}, {335,0.02034545}, {336,0.02712727}, {337,0.02045455}, {338,0.02053636}, {339,0.02068182}, {340,0.02304545}, {341,0.02067273}, {342,0.02080000}, {343,0.02390000}, {344,0.02074545}, {345,0.02080909}, {346,0.02093636}, {347,0.02508182}, {348,0.02097273}, {349,0.02113636}, {350,0.02337273}, {351,0.02115455}, {352,0.02129091}, {353,0.02825455}, {354,0.02141818}, {355,0.02152727}, {356,0.02161818}, {357,0.02376364}, {358,0.02165455}, {359,0.02175455}, {360,0.02453636}, {361,0.02182727}, {362,0.02191818}, {363,0.02490000}, {364,0.02187273}, {365,0.02208182}, {366,0.02318182}, {367,0.02214545}, {368,0.02225455}, {369,0.02241818}, {370,0.02402727}, {371,0.02241818}, {372,0.02255455}, {373,0.02476364}, {374,0.02269091}, {375,0.02273636}, {376,0.02545455}, {377,0.02275455}, {378,0.02285455}, {379,0.02532727}, {380,0.02297273}, {381,0.02309091}, {382,0.02590909}, {383,0.02317273}, {384,0.02322727}, {385,0.02630000}, {386,0.02333636}, {387,0.02360000}, {388,0.02667273}, {389,0.02360909}, {390,0.02380000}, {391,0.02704545}, {392,0.02375455}, {393,0.02384545}, {394,0.02716364}, {395,0.02385455}, {396,0.02398182}, {397,0.02724545}, {398,0.02397273}, {399,0.02420909}, {400,0.02724545}, {401,0.02409091}, {402,0.02433636}, {403,0.02702727}, {404,0.02431818}, {405,0.02445455}, {406,0.02679091}, {407,0.02464545}, {408,0.02471818}, {409,0.02753636}, {410,0.02475455}, {411,0.02483636}, {412,0.02705455}, {413,0.02482727}, {414,0.02492727}, {415,0.02574545}, {416,0.02499091}, {417,0.02678182}, {418,0.02524545}, {419,0.02523636}, {420,0.02876364}, {421,0.02542727}, {422,0.06668182}, {423,0.03136364}, {424,0.02560000}, {425,0.02575455}, {426,0.02840000}, {427,0.02578182}, {428,0.02588182}, {429,0.02738182}, {430,0.02583636}, {431,0.03358182}, {432,0.02601818}, {433,0.02614545}, {434,0.03048182}, {435,0.02620909}, {436,0.02649091}, {437,0.02878182}, {438,0.02639091}, {439,0.02845455}, {440,0.02651818}, {441,0.02690909}, {442,0.03021818}, {443,0.02673636}, {444,0.02683636}, {445,0.02940000}, {446,0.02690000}, {447,0.02867273}, {448,0.02699091}, {449,0.02714545}, {450,0.86009091}, {451,0.02723636}, {452,0.02735455}, {453,0.03015455}, {454,0.02732727}, {455,0.03402727}, {456,0.02750909}, {457,0.02755455}, {458,0.03373636}, {459,0.02760000}, {460,0.02994545}, {461,0.02777273}, {462,0.02793636}, {463,0.03130909}, {464,0.02790909}, {465,0.02805455}, {466,0.02866364}, {467,0.02823636}, {468,0.03196364}, {469,0.02823636}, {470,0.02841818}, {471,0.02933636}, {472,0.02856364}, {473,0.03240000}, {474,0.02855455}, {475,0.02870909}, {476,0.02958182}, {477,0.02892727}, {478,0.03253636}, {479,0.02884545}, {480,0.02894545}, {481,0.02953636}, {482,0.02906364}, {483,0.03263636}, {484,0.02903636}, {485,0.03161818}, {486,0.02920000}, {487,0.02940000}, {488,0.03355455}, {489,0.02943636}, {490,0.03715455}, {491,0.02955455}, {492,0.02970000}, {493,0.03500000}, {494,0.02972727}, {495,0.03358182}, {496,0.02983636}, {497,0.03209091}, {498,0.02996364}, {499,0.03007273}, {500,0.03357273}, {505,0.03043636}, {510,0.03476364}, {515,0.03102727}, {520,0.03355455}, {525,0.03159091}, {530,0.03190909}, {535,0.03492727}, {540,0.03259091}, {545,0.03680909}, {550,0.03306364}, {555,0.03713636}, {560,0.03370000}, {565,0.03860000}, {570,0.03428182}, {575,0.04172727}, {580,0.03484545}, {585,0.04786364}, {590,0.03543636}, {595,0.04800000}, {600,0.03607273}, {605,0.04698182}, {610,0.03661818}, {615,0.04473636}, {620,0.03720000}, {625,0.04642727}, {630,0.03784545}, {635,0.04206364}, {640,0.03865455}, {645,0.04307273}, {650,0.03912727}, {655,0.04262727}, {660,0.03976364}, {665,0.04082727}, {670,0.05539091}, {675,0.04057273}, {680,0.04813636}, {685,0.04130909}, {690,0.04651818}, {695,0.04176364}, {700,0.04332727}, {705,0.05007273}, {710,0.04277273}, {715,0.05275455}, {720,0.04334545}, {725,0.04430000}, {730,0.04853636}, {735,0.04431818}, {740,0.05475455}, {745,0.04811818}, {750,0.04510000}, {755,0.05037273}, {760,0.04570909}, {765,0.04808182}, {770,0.05208182}, {775,0.04674545}, {780,0.05039091}, {785,0.05302727}, {790,0.04775455}, {795,0.05777273}, {800,0.05440909}, {805,0.04859091}, {810,0.05843636}, {815,0.05566364}, {820,0.04942727}, {825,1.15369091}, {830,0.05719091}, {835,0.05030000}, {840,0.05111818}, {845,0.05603636}, {850,0.07105455}, {855,0.05173636}, {860,0.05795455}, {865,0.05934545}, {870,0.05229091}, {875,0.05308182}, {880,0.06007273}, {885,0.06090000}, {890,0.05366364}, {895,0.06489091}, {900,0.06011818}, {905,0.06090909}, {910,0.05501818}, {915,0.06327273}, {920,0.06220000}, {925,0.06223636}, {930,0.05942727}, {935,0.05669091}, {940,0.06076364}, {945,0.06183636}, {950,0.06524545}, {955,0.05777273}, {960,0.05809091}, {965,0.06319091}, {970,0.06350000}, {975,0.06617273}, {980,0.06282727}, {985,0.05962727}, {990,0.06430000}, {995,0.06765455}, {1000,0.06830000}, {1010,0.07121818}, {1020,0.07163636}, {1030,0.06240000}, {1040,0.06463636}, {1050,0.06807273}, {1060,0.07044545}, {1070,0.07049091}, {1080,0.07252727}, {1090,0.07456364}, {1100,0.08378182}, {1110,0.07447273}, {1120,0.07254545}, {1130,0.06881818}, {1140,0.07068182}, {1150,0.07550909}, {1160,0.07482727}, {1170,0.07590909}, {1180,0.07645455}, {1190,0.07743636}, {1200,0.07797273}, {1210,0.07906364}, {1220,0.07952727}, {1230,0.08037273}, {1240,0.08077273}, {1250,0.07947273}, {1260,0.08106364}, {1270,0.08500000}, {1280,0.08399091}, {1290,0.10118182}, {1300,0.09442727}, {1310,0.09829091}, {1320,0.08910909}, {1330,0.08839091}, {1340,0.09025455}, {1350,0.08957273}, {1360,0.08894545}, {1370,0.08977273}, {1380,0.10436364}, {1390,0.10081818}, {1400,0.09424545}, {1410,0.09591818}, {1420,0.09446364}, {1430,0.09011818}, {1440,0.10193636}, {1450,0.10826364}, {1460,0.09984545}, {1470,0.09780909}, {1480,0.12302727}, {1490,0.10391818}, {1500,0.10105455}, {1510,0.09952727}, {1520,0.12818182}, {1530,0.10680909}, {1540,0.10580000}, {1550,0.10606364}, {1560,0.11113636}, {1570,0.11641818}, {1580,0.10608182}, {1590,0.12018182}, {1600,0.11530909}, {1610,0.10919091}, {1620,0.12376364}, {1630,0.11859091}, {1640,0.11080000}, {1650,0.11492727}, {1660,0.12510000}, {1670,0.11320000}, {1680,0.11654545}, {1690,0.11523636}, {1700,0.11820909}, {1710,0.12681818}, {1720,0.13628182}, {1730,0.11961818}, {1740,0.11700909}, {1750,0.12220909}, {1760,0.12332727}, {1770,0.12393636}, {1780,0.12088182}, {1790,0.12790909}, {1800,0.12612727}, {1810,0.12935455}, {1820,0.12750000}, {1830,0.12950909}, {1840,0.13019091}, {1850,0.12872727}, {1860,0.12662727}, {1870,0.13005455}, {1880,0.15099091}, {1890,0.13240909}, {1900,0.13752727}, {1910,0.14340909}, {1920,0.13416364}, {1930,0.13025455}, {1940,0.13310000}, {1950,0.13917273}, {1960,0.14370000}, {1970,0.13666364}, {1980,0.15674545}, {1990,0.14416364}, {2000,0.14350000}, {2050,0.16043636}, {2100,0.15403636}, {2150,0.14963636}, {2200,0.15421818}, {2250,0.15591818}, {2300,0.17327273}, {2350,0.19632727}, {2400,0.19836364}, {2450,0.19843636}, {2500,0.19359091}, {2550,0.19686364}, {2600,0.18256364}, {2650,0.18871818}, {2700,0.18575455}, {2750,0.21540909}, {2800,0.21222727}, {2850,0.20172727}, {2900,0.22260000}, {2950,0.22694545}, {3000,0.24256364}, {3050,0.23403636}, {3100,0.24029091}, {3150,0.24110909}, {3200,0.23608182}, {3250,0.26820909}, {3300,0.25187273}, {3350,0.25340909}, {3400,0.25466364}, {3450,0.26205455}, {3500,0.30135455}, {3550,0.30949091}, {3600,0.30665455}, {3650,0.30721818}, {3700,0.30766364}, {3750,0.30240000}, {3800,0.31361818}, {3850,0.29357273}, {3900,0.28620000}, {3950,0.32987273}, {4000,0.31542727}, {4050,0.33173636}, {4100,0.33419091}, {4150,0.33807273}, {4200,0.35931818}, {4250,0.34130000}, {4300,0.35852727}, {4350,0.36183636}, {4400,0.33534545}, {4450,0.41468182}, {4500,0.33944545}, {4550,0.34180909}, {4600,0.36182727}, {4650,0.41590909}, {4700,0.43593636}, {4750,0.43140909}, {4800,0.43930000}, {4850,0.44304545}, {4900,0.43948182}, {4950,0.43274545}, {5000,0.44028182}, {5050,0.41908182}, {5100,0.38304545}, {5150,0.40330909}, {5200,0.44621818}, {5250,0.46745455}, {5300,0.41219091}, {5350,0.43886364}, {5400,0.37493636}, {5450,0.45080000}, {5500,0.44310000}, {5550,0.48555455}, {5600,0.49290000}, {5650,0.42663636}, {5700,0.49791818}, {5750,0.48762727}, {5800,0.53497273}, {5850,0.46169091}, {5900,0.43989091}, {5950,0.50182727}, {6000,0.50325455}, {6050,0.50823636}, {6100,0.50782727}, {6150,0.45688182}, {6200,0.47510000}, {6250,0.55614545}, {6300,0.55333636}, {6350,0.57394545}, {6400,0.45374545}, {6450,0.56740000}, {6500,0.58105455}, {6550,0.51565455}, {6600,0.60607273}, {6650,0.50664545}, {6700,0.58826364}, {6750,0.61877273}, {6800,0.59512727}, {6850,0.59535455}, {6900,0.54095455}, {6950,0.59957273}, {7000,0.61249091}, {7050,0.64890909}, {7100,0.62105455}, {7150,0.63308182}, {7200,0.65821818}, {7250,0.66220909}, {7300,0.65759091}, {7350,0.65516364}, {7400,0.68452727}, {7450,0.65392727}, {7500,0.65435455}, {7550,0.63873636}, {7600,0.69251818}, {7650,0.67623636}, {7700,0.65963636}, {7750,0.72530909}, {7800,0.65984545}, {7850,0.69038182}, {7900,0.66455455}, {7950,0.74707273}, {8000,0.68027273}, {8050,0.71628182}, {8100,0.75991818}, {8150,0.69080909}, {8200,0.68151818}, {8250,0.73628182}, {8300,0.74111818}, {8350,0.75855455}, {8400,0.78280909}, {8450,0.79574545}, {8500,0.79209091}, {8550,0.78262727}, {8600,0.78122727}, {8650,0.76209091}, {8700,0.72386364}, {8750,0.80434545}, {8800,0.80392727}, {8850,0.78340909}, {8900,0.79597273}, {8950,0.82560000}, {9000,0.73409091}};
data["big"]["TemplateCoq"]["Aggregate"]["user"] = {{1,0.00109091}, {2,0.00070909}, {3,0.00096364}, {4,0.00120909}, {5,0.00108182}, {6,0.00118182}, {7,0.00125455}, {8,0.00114545}, {9,0.00121818}, {10,0.00138182}, {11,0.00126364}, {12,0.00150909}, {13,0.00140909}, {14,0.00167273}, {15,0.00144545}, {16,0.00155455}, {17,0.00188182}, {18,0.00162727}, {19,0.00193636}, {20,0.00181818}, {21,0.00161818}, {22,0.00194545}, {23,0.00217273}, {24,0.00179091}, {25,0.00213636}, {26,0.00233636}, {27,0.00239091}, {28,0.00195455}, {29,0.00250000}, {30,0.00237273}, {31,0.00270909}, {32,0.00214545}, {33,0.00222727}, {34,0.00279091}, {35,0.00268182}, {36,0.00258182}, {37,0.00829091}, {38,0.00260909}, {39,0.00280909}, {40,0.00288182}, {41,0.00287273}, {42,0.00293636}, {43,0.00313636}, {44,0.00302727}, {45,0.00304545}, {46,0.00308182}, {47,0.00302727}, {48,0.00310000}, {49,0.00342727}, {50,0.00317273}, {51,0.00343636}, {52,0.00340909}, {53,0.00337273}, {54,0.00349091}, {55,0.00351818}, {56,0.00354545}, {57,0.00560909}, {58,0.00390000}, {59,0.00376364}, {60,0.00433636}, {61,0.00399091}, {62,0.00395455}, {63,0.00400909}, {64,0.00413636}, {65,0.00456364}, {66,0.00429091}, {67,0.00428182}, {68,0.00455455}, {69,0.00468182}, {70,0.00459091}, {71,0.00456364}, {72,0.00450909}, {73,0.00623636}, {74,0.00494545}, {75,0.00486364}, {76,0.00495455}, {77,0.00482727}, {78,0.00514545}, {79,0.00485455}, {80,0.00524545}, {81,0.00524545}, {82,0.00530000}, {83,0.00558182}, {84,0.00542727}, {85,0.00561818}, {86,0.00665455}, {87,0.00540909}, {88,0.00556364}, {89,0.00638182}, {90,0.00551818}, {91,0.00578182}, {92,0.00607273}, {93,0.00607273}, {94,0.00614545}, {95,0.00614545}, {96,0.00628182}, {97,0.00620000}, {98,0.00757273}, {99,0.00650909}, {100,0.00676364}, {101,0.00646364}, {102,0.00676364}, {103,0.00670909}, {104,0.00676364}, {105,0.00700909}, {106,0.00705455}, {107,0.00680909}, {108,0.00686364}, {109,0.00771818}, {110,0.00735455}, {111,0.00715455}, {112,0.00721818}, {113,0.00730909}, {114,0.00728182}, {115,0.00757273}, {116,0.00744545}, {117,0.00760909}, {118,0.01005455}, {119,0.00774545}, {120,0.00761818}, {121,0.00800909}, {122,0.00776364}, {123,0.00760000}, {124,0.00796364}, {125,0.00826364}, {126,0.00808182}, {127,0.01126364}, {128,0.00806364}, {129,0.00863636}, {130,0.00831818}, {131,0.00815455}, {132,0.00868182}, {133,0.00890000}, {134,0.00840909}, {135,0.00887273}, {136,0.01004545}, {137,0.00888182}, {138,0.00882727}, {139,0.00891818}, {140,0.00905455}, {141,0.00900000}, {142,0.00909091}, {143,0.00911818}, {144,0.01073636}, {145,0.00950909}, {146,0.00936364}, {147,0.00951818}, {148,0.00946364}, {149,0.00984545}, {150,0.00955455}, {151,0.01085455}, {152,0.00985455}, {153,0.00959091}, {154,0.00967273}, {155,0.01035455}, {156,0.01000909}, {157,0.00970000}, {158,0.01059091}, {159,0.01136364}, {160,0.01027273}, {161,0.01030909}, {162,0.01015455}, {163,0.01059091}, {164,0.01084545}, {165,0.01060909}, {166,0.01153636}, {167,0.01096364}, {168,0.01099091}, {169,0.01099091}, {170,0.01065455}, {171,0.01032727}, {172,0.01436364}, {173,0.01104545}, {174,0.01114545}, {175,0.01120909}, {176,0.01124545}, {177,0.01158182}, {178,0.01150000}, {179,0.01270000}, {180,0.01142727}, {181,0.01162727}, {182,0.01172727}, {183,0.01176364}, {184,0.01180000}, {185,0.01310000}, {186,0.01197273}, {187,0.01189091}, {188,0.01192727}, {189,0.01219091}, {190,0.01193636}, {191,0.01355455}, {192,0.01219091}, {193,0.01225455}, {194,0.01239091}, {195,0.01241818}, {196,0.01243636}, {197,0.01362727}, {198,0.01237273}, {199,0.01254545}, {200,0.01260000}, {201,0.01260000}, {202,0.01301818}, {203,0.01410909}, {204,0.01290000}, {205,0.01281818}, {206,0.01279091}, {207,0.01299091}, {208,0.01731818}, {209,0.01316364}, {210,0.01315455}, {211,0.01328182}, {212,0.01310000}, {213,0.01330909}, {214,0.01485455}, {215,0.01320909}, {216,0.01342727}, {217,0.01348182}, {218,0.01340909}, {219,0.01511818}, {220,0.01331818}, {221,0.01390000}, {222,0.01377273}, {223,0.01347273}, {224,0.01772727}, {225,0.01387273}, {226,0.01373636}, {227,0.01390000}, {228,0.01416364}, {229,0.01543636}, {230,0.01416364}, {231,0.01425455}, {232,0.01417273}, {233,0.01411818}, {234,0.01975455}, {235,0.01428182}, {236,0.01417273}, {237,0.01446364}, {238,0.01460909}, {239,0.01695455}, {240,0.01458182}, {241,0.01448182}, {242,0.01478182}, {243,0.01490000}, {244,0.01840909}, {245,0.01479091}, {246,0.01501818}, {247,0.01522727}, {248,0.01478182}, {249,0.01619091}, {250,0.01517273}, {251,0.01527273}, {252,0.01521818}, {253,0.02048182}, {254,0.01532727}, {255,0.01550909}, {256,0.01554545}, {257,0.01561818}, {258,0.01824545}, {259,0.01549091}, {260,0.01547273}, {261,0.01572727}, {262,0.02087273}, {263,0.01594545}, {264,0.01585455}, {265,0.01603636}, {266,0.01596364}, {267,0.01822727}, {268,0.01626364}, {269,0.01629091}, {270,0.01591818}, {271,0.01825455}, {272,0.01645455}, {273,0.01643636}, {274,0.01656364}, {275,0.02077273}, {276,0.01703636}, {277,0.01668182}, {278,0.01703636}, {279,0.01976364}, {280,0.01677273}, {281,0.01696364}, {282,0.01741818}, {283,0.01682727}, {284,0.01808182}, {285,0.01764545}, {286,0.01701818}, {287,0.01710000}, {288,0.01885455}, {289,0.01776364}, {290,0.01756364}, {291,0.01774545}, {292,0.01950909}, {293,0.01779091}, {294,0.01769091}, {295,0.01776364}, {296,0.01966364}, {297,0.01807273}, {298,0.01790909}, {299,0.01828182}, {300,0.01930000}, {301,0.01833636}, {302,0.01870000}, {303,0.01986364}, {304,0.01846364}, {305,0.01871818}, {306,0.01840000}, {307,0.02318182}, {308,0.01857273}, {309,0.01878182}, {310,0.01850000}, {311,0.02266364}, {312,0.01897273}, {313,0.01905455}, {314,0.01939091}, {315,0.02111818}, {316,0.01891818}, {317,0.01940909}, {318,0.02073636}, {319,0.01947273}, {320,0.01964545}, {321,0.01939091}, {322,0.02256364}, {323,0.01966364}, {324,0.01977273}, {325,0.01981818}, {326,0.02181818}, {327,0.01966364}, {328,0.02012727}, {329,0.02532727}, {330,0.02013636}, {331,0.02010909}, {332,0.02032727}, {333,0.02356364}, {334,0.02029091}, {335,0.02054545}, {336,0.02683636}, {337,0.02083636}, {338,0.02030909}, {339,0.02103636}, {340,0.02333636}, {341,0.02080000}, {342,0.02102727}, {343,0.02418182}, {344,0.02103636}, {345,0.02088182}, {346,0.02121818}, {347,0.02531818}, {348,0.02097273}, {349,0.02178182}, {350,0.02344545}, {351,0.02162727}, {352,0.02103636}, {353,0.02807273}, {354,0.02178182}, {355,0.02140909}, {356,0.02192727}, {357,0.02400000}, {358,0.02196364}, {359,0.02190909}, {360,0.02448182}, {361,0.02250000}, {362,0.02236364}, {363,0.02475455}, {364,0.02178182}, {365,0.02209091}, {366,0.02366364}, {367,0.02232727}, {368,0.02228182}, {369,0.02239091}, {370,0.02430000}, {371,0.02238182}, {372,0.02244545}, {373,0.02488182}, {374,0.02266364}, {375,0.02278182}, {376,0.02540909}, {377,0.02320000}, {378,0.02328182}, {379,0.02520909}, {380,0.02322727}, {381,0.02346364}, {382,0.02577273}, {383,0.02330000}, {384,0.02355455}, {385,0.02619091}, {386,0.02347273}, {387,0.02370909}, {388,0.02653636}, {389,0.02399091}, {390,0.02414545}, {391,0.02688182}, {392,0.02406364}, {393,0.02411818}, {394,0.02716364}, {395,0.02396364}, {396,0.02433636}, {397,0.02695455}, {398,0.02449091}, {399,0.02433636}, {400,0.02711818}, {401,0.02441818}, {402,0.02463636}, {403,0.02673636}, {404,0.02457273}, {405,0.02445455}, {406,0.02668182}, {407,0.02491818}, {408,0.02463636}, {409,0.02748182}, {410,0.02481818}, {411,0.02522727}, {412,0.02692727}, {413,0.02476364}, {414,0.02518182}, {415,0.02595455}, {416,0.02491818}, {417,0.02646364}, {418,0.02531818}, {419,0.02519091}, {420,0.02873636}, {421,0.02541818}, {422,0.06677273}, {423,0.03150909}, {424,0.02559091}, {425,0.02570909}, {426,0.02821818}, {427,0.02573636}, {428,0.02562727}, {429,0.02740000}, {430,0.02563636}, {431,0.03361818}, {432,0.02597273}, {433,0.02596364}, {434,0.03055455}, {435,0.02623636}, {436,0.02643636}, {437,0.02849091}, {438,0.02631818}, {439,0.02834545}, {440,0.02640909}, {441,0.02655455}, {442,0.03017273}, {443,0.02644545}, {444,0.02650909}, {445,0.02966364}, {446,0.02662727}, {447,0.02834545}, {448,0.02698182}, {449,0.02688182}, {450,0.85905455}, {451,0.02674545}, {452,0.02726364}, {453,0.03004545}, {454,0.02703636}, {455,0.03408182}, {456,0.02739091}, {457,0.02725455}, {458,0.03415455}, {459,0.02722727}, {460,0.03004545}, {461,0.02735455}, {462,0.02771818}, {463,0.03103636}, {464,0.02797273}, {465,0.02783636}, {466,0.02829091}, {467,0.02808182}, {468,0.03232727}, {469,0.02800000}, {470,0.02816364}, {471,0.02896364}, {472,0.02791818}, {473,0.03249091}, {474,0.02840909}, {475,0.02852727}, {476,0.02934545}, {477,0.02884545}, {478,0.03297273}, {479,0.02846364}, {480,0.02900909}, {481,0.02928182}, {482,0.02857273}, {483,0.03281818}, {484,0.02860909}, {485,0.03177273}, {486,0.02901818}, {487,0.02930000}, {488,0.03358182}, {489,0.02924545}, {490,0.03735455}, {491,0.02984545}, {492,0.02957273}, {493,0.03503636}, {494,0.02957273}, {495,0.03390000}, {496,0.02982727}, {497,0.03211818}, {498,0.02994545}, {499,0.02986364}, {500,0.03366364}, {505,0.03035455}, {510,0.03490000}, {515,0.03100000}, {520,0.03388182}, {525,0.03153636}, {530,0.03171818}, {535,0.03498182}, {540,0.03292727}, {545,0.03675455}, {550,0.03353636}, {555,0.03744545}, {560,0.03377273}, {565,0.03867273}, {570,0.03432727}, {575,0.04148182}, {580,0.03496364}, {585,0.04813636}, {590,0.03566364}, {595,0.04834545}, {600,0.03622727}, {605,0.04730909}, {610,0.03687273}, {615,0.04506364}, {620,0.03725455}, {625,0.04659091}, {630,0.03764545}, {635,0.04215455}, {640,0.03844545}, {645,0.04310000}, {650,0.03904545}, {655,0.04244545}, {660,0.03927273}, {665,0.04051818}, {670,0.05545455}, {675,0.04051818}, {680,0.04823636}, {685,0.04116364}, {690,0.04676364}, {695,0.04189091}, {700,0.04305455}, {705,0.04999091}, {710,0.04250909}, {715,0.05228182}, {720,0.04321818}, {725,0.04422727}, {730,0.04836364}, {735,0.04418182}, {740,0.05461818}, {745,0.04816364}, {750,0.04470909}, {755,0.05013636}, {760,0.04590909}, {765,0.04822727}, {770,0.05210909}, {775,0.04698182}, {780,0.05004545}, {785,0.05291818}, {790,0.04805455}, {795,0.05805455}, {800,0.05411818}, {805,0.04858182}, {810,0.05867273}, {815,0.05566364}, {820,0.04959091}, {825,1.15193636}, {830,0.05722727}, {835,0.05037273}, {840,0.05105455}, {845,0.05557273}, {850,0.07118182}, {855,0.05163636}, {860,0.05805455}, {865,0.05908182}, {870,0.05217273}, {875,0.05288182}, {880,0.06010000}, {885,0.06118182}, {890,0.05361818}, {895,0.06463636}, {900,0.06024545}, {905,0.06089091}, {910,0.05483636}, {915,0.06318182}, {920,0.06218182}, {925,0.06190000}, {930,0.05958182}, {935,0.05635455}, {940,0.06053636}, {945,0.06143636}, {950,0.06501818}, {955,0.05824545}, {960,0.05830000}, {965,0.06301818}, {970,0.06311818}, {975,0.06600909}, {980,0.06258182}, {985,0.05953636}, {990,0.06413636}, {995,0.06740909}, {1000,0.06833636}, {1010,0.07157273}, {1020,0.07140909}, {1030,0.06205455}, {1040,0.06455455}, {1050,0.06788182}, {1060,0.07030909}, {1070,0.07067273}, {1080,0.07262727}, {1090,0.07430000}, {1100,0.08373636}, {1110,0.07437273}, {1120,0.07245455}, {1130,0.06870000}, {1140,0.07101818}, {1150,0.07541818}, {1160,0.07438182}, {1170,0.07573636}, {1180,0.07653636}, {1190,0.07720000}, {1200,0.07789091}, {1210,0.07887273}, {1220,0.07912727}, {1230,0.08053636}, {1240,0.08073636}, {1250,0.07944545}, {1260,0.08124545}, {1270,0.08500000}, {1280,0.08380909}, {1290,0.10101818}, {1300,0.09426364}, {1310,0.09828182}, {1320,0.08845455}, {1330,0.08814545}, {1340,0.09028182}, {1350,0.08943636}, {1360,0.08877273}, {1370,0.08968182}, {1380,0.10409091}, {1390,0.10021818}, {1400,0.09404545}, {1410,0.09591818}, {1420,0.09443636}, {1430,0.09008182}, {1440,0.10168182}, {1450,0.10784545}, {1460,0.09976364}, {1470,0.09770909}, {1480,0.12291818}, {1490,0.10356364}, {1500,0.10065455}, {1510,0.09948182}, {1520,0.12824545}, {1530,0.10649091}, {1540,0.10596364}, {1550,0.10571818}, {1560,0.11087273}, {1570,0.11619091}, {1580,0.10620000}, {1590,0.11982727}, {1600,0.11520909}, {1610,0.10885455}, {1620,0.12354545}, {1630,0.11848182}, {1640,0.11073636}, {1650,0.11485455}, {1660,0.12478182}, {1670,0.11309091}, {1680,0.11640000}, {1690,0.11513636}, {1700,0.11815455}, {1710,0.12687273}, {1720,0.13617273}, {1730,0.11966364}, {1740,0.11691818}, {1750,0.12185455}, {1760,0.12328182}, {1770,0.12377273}, {1780,0.12069091}, {1790,0.12737273}, {1800,0.12570000}, {1810,0.12911818}, {1820,0.12747273}, {1830,0.12929091}, {1840,0.13000000}, {1850,0.12847273}, {1860,0.12697273}, {1870,0.13014545}, {1880,0.15069091}, {1890,0.13232727}, {1900,0.13733636}, {1910,0.14308182}, {1920,0.13386364}, {1930,0.13018182}, {1940,0.13276364}, {1950,0.13895455}, {1960,0.14330000}, {1970,0.13662727}, {1980,0.15656364}, {1990,0.14391818}, {2000,0.14335455}, {2050,0.16023636}, {2100,0.15401818}, {2150,0.14938182}, {2200,0.15413636}, {2250,0.15577273}, {2300,0.17331818}, {2350,0.19581818}, {2400,0.19808182}, {2450,0.19841818}, {2500,0.19349091}, {2550,0.19652727}, {2600,0.18215455}, {2650,0.18840000}, {2700,0.18577273}, {2750,0.21510000}, {2800,0.21196364}, {2850,0.20167273}, {2900,0.22214545}, {2950,0.22655455}, {3000,0.24230000}, {3050,0.23385455}, {3100,0.24009091}, {3150,0.24056364}, {3200,0.23555455}, {3250,0.26774545}, {3300,0.25159091}, {3350,0.25321818}, {3400,0.25408182}, {3450,0.26184545}, {3500,0.30047273}, {3550,0.30838182}, {3600,0.30580000}, {3650,0.30656364}, {3700,0.30696364}, {3750,0.30199091}, {3800,0.31301818}, {3850,0.29359091}, {3900,0.28568182}, {3950,0.32941818}, {4000,0.31442727}, {4050,0.33132727}, {4100,0.33368182}, {4150,0.33734545}, {4200,0.35864545}, {4250,0.34082727}, {4300,0.35810909}, {4350,0.36123636}, {4400,0.33506364}, {4450,0.41382727}, {4500,0.33903636}, {4550,0.34128182}, {4600,0.36101818}, {4650,0.41442727}, {4700,0.43519091}, {4750,0.43061818}, {4800,0.43818182}, {4850,0.44217273}, {4900,0.43817273}, {4950,0.43197273}, {5000,0.43960000}, {5050,0.41820000}, {5100,0.38265455}, {5150,0.40249091}, {5200,0.44577273}, {5250,0.46739091}, {5300,0.41180000}, {5350,0.43837273}, {5400,0.37466364}, {5450,0.44987273}, {5500,0.44226364}, {5550,0.48455455}, {5600,0.49190000}, {5650,0.42617273}, {5700,0.49697273}, {5750,0.48665455}, {5800,0.53457273}, {5850,0.46108182}, {5900,0.43983636}, {5950,0.50165455}, {6000,0.50293636}, {6050,0.50765455}, {6100,0.50780000}, {6150,0.45655455}, {6200,0.47446364}, {6250,0.55573636}, {6300,0.55340909}, {6350,0.57377273}, {6400,0.45340909}, {6450,0.56738182}, {6500,0.58054545}, {6550,0.51524545}, {6600,0.60588182}, {6650,0.50621818}, {6700,0.58808182}, {6750,0.61840909}, {6800,0.59476364}, {6850,0.59524545}, {6900,0.54068182}, {6950,0.59939091}, {7000,0.61233636}, {7050,0.64872727}, {7100,0.62053636}, {7150,0.63260909}, {7200,0.65800000}, {7250,0.66158182}, {7300,0.65719091}, {7350,0.65462727}, {7400,0.68416364}, {7450,0.65358182}, {7500,0.65402727}, {7550,0.63849091}, {7600,0.69229091}, {7650,0.67573636}, {7700,0.65937273}, {7750,0.72488182}, {7800,0.65940000}, {7850,0.69014545}, {7900,0.66422727}, {7950,0.74680000}, {8000,0.68000909}, {8050,0.71595455}, {8100,0.75997273}, {8150,0.69044545}, {8200,0.68093636}, {8250,0.73587273}, {8300,0.74079091}, {8350,0.75832727}, {8400,0.78262727}, {8450,0.79536364}, {8500,0.79194545}, {8550,0.78180909}, {8600,0.78057273}, {8650,0.76172727}, {8700,0.72337273}, {8750,0.80400909}, {8800,0.80381818}, {8850,0.78300909}, {8900,0.79546364}, {8950,0.82515455}, {9000,0.73303636}};
data["big"]["TemplateCoq"]["Aggregate"]["system"] = {{1,0.00003636}, {2,0.00007273}, {3,0.00007273}, {4,0.00006364}, {5,0.00003636}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00007273}, {10,0.00003636}, {11,0.00003636}, {12,0.00003636}, {13,0.00003636}, {14,0.00000000}, {15,0.00000000}, {16,0.00010909}, {17,0.00003636}, {18,0.00000000}, {19,0.00002727}, {20,0.00010909}, {21,0.00010909}, {22,0.00007273}, {23,0.00003636}, {24,0.00003636}, {25,0.00003636}, {26,0.00000000}, {27,0.00000000}, {28,0.00003636}, {29,0.00003636}, {30,0.00003636}, {31,0.00003636}, {32,0.00000000}, {33,0.00013636}, {34,0.00003636}, {35,0.00003636}, {36,0.00000000}, {37,0.00003636}, {38,0.00007273}, {39,0.00010000}, {40,0.00003636}, {41,0.00003636}, {42,0.00007273}, {43,0.00003636}, {44,0.00000000}, {45,0.00000000}, {46,0.00010909}, {47,0.00007273}, {48,0.00010909}, {49,0.00000000}, {50,0.00003636}, {51,0.00007273}, {52,0.00003636}, {53,0.00003636}, {54,0.00000000}, {55,0.00006364}, {56,0.00010909}, {57,0.00000000}, {58,0.00007273}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00003636}, {63,0.00000000}, {64,0.00010909}, {65,0.00000000}, {66,0.00002727}, {67,0.00007273}, {68,0.00010909}, {69,0.00000000}, {70,0.00007273}, {71,0.00003636}, {72,0.00000000}, {73,0.00000000}, {74,0.00003636}, {75,0.00003636}, {76,0.00007273}, {77,0.00010909}, {78,0.00003636}, {79,0.00010909}, {80,0.00007273}, {81,0.00000000}, {82,0.00003636}, {83,0.00003636}, {84,0.00003636}, {85,0.00000000}, {86,0.00010909}, {87,0.00000000}, {88,0.00006364}, {89,0.00003636}, {90,0.00000000}, {91,0.00003636}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00007273}, {96,0.00007273}, {97,0.00000000}, {98,0.00000000}, {99,0.00003636}, {100,0.00000000}, {101,0.00007273}, {102,0.00003636}, {103,0.00000000}, {104,0.00003636}, {105,0.00006364}, {106,0.00007273}, {107,0.00010909}, {108,0.00010909}, {109,0.00017273}, {110,0.00003636}, {111,0.00007273}, {112,0.00010000}, {113,0.00003636}, {114,0.00007273}, {115,0.00000000}, {116,0.00003636}, {117,0.00000000}, {118,0.00007273}, {119,0.00003636}, {120,0.00013636}, {121,0.00010909}, {122,0.00000000}, {123,0.00018182}, {124,0.00003636}, {125,0.00003636}, {126,0.00003636}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00007273}, {131,0.00007273}, {132,0.00007273}, {133,0.00000000}, {134,0.00007273}, {135,0.00007273}, {136,0.00003636}, {137,0.00003636}, {138,0.00003636}, {139,0.00014545}, {140,0.00007273}, {141,0.00007273}, {142,0.00000000}, {143,0.00007273}, {144,0.00003636}, {145,0.00006364}, {146,0.00007273}, {147,0.00007273}, {148,0.00007273}, {149,0.00003636}, {150,0.00003636}, {151,0.00002727}, {152,0.00003636}, {153,0.00007273}, {154,0.00010909}, {155,0.00010909}, {156,0.00003636}, {157,0.00003636}, {158,0.00000000}, {159,0.00010000}, {160,0.00003636}, {161,0.00010909}, {162,0.00007273}, {163,0.00003636}, {164,0.00000000}, {165,0.00003636}, {166,0.00014545}, {167,0.00000000}, {168,0.00006364}, {169,0.00010909}, {170,0.00000000}, {171,0.00014545}, {172,0.00007273}, {173,0.00003636}, {174,0.00000000}, {175,0.00003636}, {176,0.00003636}, {177,0.00003636}, {178,0.00003636}, {179,0.00010909}, {180,0.00018182}, {181,0.00003636}, {182,0.00010909}, {183,0.00007273}, {184,0.00003636}, {185,0.00003636}, {186,0.00003636}, {187,0.00007273}, {188,0.00003636}, {189,0.00010909}, {190,0.00006364}, {191,0.00003636}, {192,0.00003636}, {193,0.00017273}, {194,0.00003636}, {195,0.00003636}, {196,0.00014545}, {197,0.00003636}, {198,0.00003636}, {199,0.00017273}, {200,0.00013636}, {201,0.00003636}, {202,0.00003636}, {203,0.00002727}, {204,0.00002727}, {205,0.00014545}, {206,0.00006364}, {207,0.00003636}, {208,0.00003636}, {209,0.00003636}, {210,0.00000000}, {211,0.00007273}, {212,0.00003636}, {213,0.00007273}, {214,0.00007273}, {215,0.00003636}, {216,0.00010909}, {217,0.00007273}, {218,0.00007273}, {219,0.00007273}, {220,0.00007273}, {221,0.00007273}, {222,0.00010909}, {223,0.00007273}, {224,0.00007273}, {225,0.00007273}, {226,0.00003636}, {227,0.00010909}, {228,0.00003636}, {229,0.00010909}, {230,0.00007273}, {231,0.00007273}, {232,0.00007273}, {233,0.00010909}, {234,0.00007273}, {235,0.00007273}, {236,0.00010909}, {237,0.00010909}, {238,0.00003636}, {239,0.00010909}, {240,0.00009091}, {241,0.00007273}, {242,0.00003636}, {243,0.00003636}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00010909}, {248,0.00007273}, {249,0.00000000}, {250,0.00010909}, {251,0.00010000}, {252,0.00007273}, {253,0.00006364}, {254,0.00010909}, {255,0.00003636}, {256,0.00014545}, {257,0.00010909}, {258,0.00003636}, {259,0.00003636}, {260,0.00010909}, {261,0.00007273}, {262,0.00010909}, {263,0.00002727}, {264,0.00007273}, {265,0.00010909}, {266,0.00014545}, {267,0.00018182}, {268,0.00003636}, {269,0.00021818}, {270,0.00010909}, {271,0.00014545}, {272,0.00003636}, {273,0.00006364}, {274,0.00007273}, {275,0.00007273}, {276,0.00003636}, {277,0.00007273}, {278,0.00003636}, {279,0.00017273}, {280,0.00007273}, {281,0.00007273}, {282,0.00000000}, {283,0.00007273}, {284,0.00003636}, {285,0.00007273}, {286,0.00000000}, {287,0.00018182}, {288,0.00010000}, {289,0.00010909}, {290,0.00003636}, {291,0.00010909}, {292,0.00010909}, {293,0.00010909}, {294,0.00007273}, {295,0.00007273}, {296,0.00007273}, {297,0.00007273}, {298,0.00007273}, {299,0.00003636}, {300,0.00006364}, {301,0.00006364}, {302,0.00000000}, {303,0.00007273}, {304,0.00010909}, {305,0.00000000}, {306,0.00006364}, {307,0.00007273}, {308,0.00018182}, {309,0.00010909}, {310,0.00003636}, {311,0.00010909}, {312,0.00010909}, {313,0.00003636}, {314,0.00003636}, {315,0.00007273}, {316,0.00018182}, {317,0.00003636}, {318,0.00010909}, {319,0.00009091}, {320,0.00003636}, {321,0.00007273}, {322,0.00007273}, {323,0.00013636}, {324,0.00010909}, {325,0.00010909}, {326,0.00014545}, {327,0.00010909}, {328,0.00003636}, {329,0.00014545}, {330,0.00007273}, {331,0.00006364}, {332,0.00010909}, {333,0.00014545}, {334,0.00010909}, {335,0.00010000}, {336,0.00014545}, {337,0.00003636}, {338,0.00010909}, {339,0.00003636}, {340,0.00010909}, {341,0.00010909}, {342,0.00003636}, {343,0.00003636}, {344,0.00000000}, {345,0.00007273}, {346,0.00010909}, {347,0.00018182}, {348,0.00002727}, {349,0.00003636}, {350,0.00010909}, {351,0.00003636}, {352,0.00007273}, {353,0.00007273}, {354,0.00007273}, {355,0.00010909}, {356,0.00014545}, {357,0.00007273}, {358,0.00006364}, {359,0.00018182}, {360,0.00010909}, {361,0.00010909}, {362,0.00007273}, {363,0.00010909}, {364,0.00003636}, {365,0.00007273}, {366,0.00014545}, {367,0.00003636}, {368,0.00006364}, {369,0.00010909}, {370,0.00010909}, {371,0.00014545}, {372,0.00010909}, {373,0.00007273}, {374,0.00003636}, {375,0.00021818}, {376,0.00010909}, {377,0.00003636}, {378,0.00006364}, {379,0.00021818}, {380,0.00014545}, {381,0.00010909}, {382,0.00007273}, {383,0.00017273}, {384,0.00003636}, {385,0.00010909}, {386,0.00014545}, {387,0.00013636}, {388,0.00006364}, {389,0.00000000}, {390,0.00010909}, {391,0.00007273}, {392,0.00003636}, {393,0.00010909}, {394,0.00007273}, {395,0.00010000}, {396,0.00010000}, {397,0.00003636}, {398,0.00003636}, {399,0.00014545}, {400,0.00000000}, {401,0.00003636}, {402,0.00000000}, {403,0.00012727}, {404,0.00010000}, {405,0.00002727}, {406,0.00014545}, {407,0.00003636}, {408,0.00007273}, {409,0.00003636}, {410,0.00007273}, {411,0.00007273}, {412,0.00007273}, {413,0.00018182}, {414,0.00014545}, {415,0.00003636}, {416,0.00021818}, {417,0.00010909}, {418,0.00003636}, {419,0.00000000}, {420,0.00003636}, {421,0.00000000}, {422,0.00010909}, {423,0.00007273}, {424,0.00014545}, {425,0.00018182}, {426,0.00010000}, {427,0.00014545}, {428,0.00000000}, {429,0.00003636}, {430,0.00014545}, {431,0.00010909}, {432,0.00003636}, {433,0.00006364}, {434,0.00000000}, {435,0.00000000}, {436,0.00007273}, {437,0.00003636}, {438,0.00007273}, {439,0.00003636}, {440,0.00014545}, {441,0.00013636}, {442,0.00010000}, {443,0.00010909}, {444,0.00021818}, {445,0.00000000}, {446,0.00003636}, {447,0.00007273}, {448,0.00003636}, {449,0.00010909}, {450,0.00085455}, {451,0.00018182}, {452,0.00010909}, {453,0.00007273}, {454,0.00003636}, {455,0.00007273}, {456,0.00007273}, {457,0.00013636}, {458,0.00010909}, {459,0.00021818}, {460,0.00007273}, {461,0.00010909}, {462,0.00010909}, {463,0.00014545}, {464,0.00003636}, {465,0.00003636}, {466,0.00003636}, {467,0.00010909}, {468,0.00007273}, {469,0.00003636}, {470,0.00010909}, {471,0.00003636}, {472,0.00021818}, {473,0.00003636}, {474,0.00018182}, {475,0.00010909}, {476,0.00020000}, {477,0.00003636}, {478,0.00003636}, {479,0.00007273}, {480,0.00000000}, {481,0.00010000}, {482,0.00007273}, {483,0.00017273}, {484,0.00021818}, {485,0.00003636}, {486,0.00003636}, {487,0.00007273}, {488,0.00007273}, {489,0.00007273}, {490,0.00010000}, {491,0.00007273}, {492,0.00013636}, {493,0.00002727}, {494,0.00003636}, {495,0.00003636}, {496,0.00010909}, {497,0.00014545}, {498,0.00007273}, {499,0.00007273}, {500,0.00003636}, {505,0.00003636}, {510,0.00017273}, {515,0.00003636}, {520,0.00003636}, {525,0.00010000}, {530,0.00010909}, {535,0.00014545}, {540,0.00006364}, {545,0.00018182}, {550,0.00017273}, {555,0.00010909}, {560,0.00000000}, {565,0.00010909}, {570,0.00017273}, {575,0.00003636}, {580,0.00020909}, {585,0.00010909}, {590,0.00034545}, {595,0.00007273}, {600,0.00024545}, {605,0.00007273}, {610,0.00010909}, {615,0.00007273}, {620,0.00017273}, {625,0.00010909}, {630,0.00017273}, {635,0.00003636}, {640,0.00014545}, {645,0.00003636}, {650,0.00007273}, {655,0.00013636}, {660,0.00007273}, {665,0.00010909}, {670,0.00010909}, {675,0.00010909}, {680,0.00003636}, {685,0.00014545}, {690,0.00010909}, {695,0.00000000}, {700,0.00007273}, {705,0.00010000}, {710,0.00025455}, {715,0.00018182}, {720,0.00010909}, {725,0.00018182}, {730,0.00014545}, {735,0.00025455}, {740,0.00006364}, {745,0.00014545}, {750,0.00018182}, {755,0.00014545}, {760,0.00010909}, {765,0.00018182}, {770,0.00013636}, {775,0.00000000}, {780,0.00029091}, {785,0.00010909}, {790,0.00018182}, {795,0.00007273}, {800,0.00010909}, {805,0.00014545}, {810,0.00007273}, {815,0.00018182}, {820,0.00007273}, {825,0.00144545}, {830,0.00014545}, {835,0.00007273}, {840,0.00007273}, {845,0.00018182}, {850,0.00003636}, {855,0.00007273}, {860,0.00018182}, {865,0.00018182}, {870,0.00014545}, {875,0.00002727}, {880,0.00007273}, {885,0.00003636}, {890,0.00003636}, {895,0.00017273}, {900,0.00000000}, {905,0.00021818}, {910,0.00003636}, {915,0.00003636}, {920,0.00003636}, {925,0.00013636}, {930,0.00003636}, {935,0.00021818}, {940,0.00014545}, {945,0.00014545}, {950,0.00002727}, {955,0.00018182}, {960,0.00006364}, {965,0.00010909}, {970,0.00010909}, {975,0.00007273}, {980,0.00007273}, {985,0.00007273}, {990,0.00014545}, {995,0.00007273}, {1000,0.00007273}, {1010,0.00021818}, {1020,0.00014545}, {1030,0.00018182}, {1040,0.00010909}, {1050,0.00021818}, {1060,0.00010909}, {1070,0.00018182}, {1080,0.00018182}, {1090,0.00010909}, {1100,0.00010000}, {1110,0.00010909}, {1120,0.00007273}, {1130,0.00007273}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00013636}, {1170,0.00007273}, {1180,0.00007273}, {1190,0.00010909}, {1200,0.00003636}, {1210,0.00014545}, {1220,0.00010909}, {1230,0.00007273}, {1240,0.00018182}, {1250,0.00003636}, {1260,0.00018182}, {1270,0.00002727}, {1280,0.00014545}, {1290,0.00010909}, {1300,0.00021818}, {1310,0.00003636}, {1320,0.00010909}, {1330,0.00014545}, {1340,0.00010000}, {1350,0.00002727}, {1360,0.00003636}, {1370,0.00003636}, {1380,0.00000000}, {1390,0.00010909}, {1400,0.00007273}, {1410,0.00012727}, {1420,0.00021818}, {1430,0.00018182}, {1440,0.00007273}, {1450,0.00021818}, {1460,0.00010909}, {1470,0.00000000}, {1480,0.00014545}, {1490,0.00007273}, {1500,0.00025455}, {1510,0.00010909}, {1520,0.00000000}, {1530,0.00010909}, {1540,0.00007273}, {1550,0.00018182}, {1560,0.00003636}, {1570,0.00029091}, {1580,0.00002727}, {1590,0.00010909}, {1600,0.00010909}, {1610,0.00010909}, {1620,0.00007273}, {1630,0.00021818}, {1640,0.00014545}, {1650,0.00014545}, {1660,0.00010000}, {1670,0.00007273}, {1680,0.00013636}, {1690,0.00007273}, {1700,0.00010000}, {1710,0.00014545}, {1720,0.00014545}, {1730,0.00007273}, {1740,0.00025455}, {1750,0.00010909}, {1760,0.00010909}, {1770,0.00007273}, {1780,0.00014545}, {1790,0.00017273}, {1800,0.00007273}, {1810,0.00020909}, {1820,0.00006364}, {1830,0.00018182}, {1840,0.00010909}, {1850,0.00025455}, {1860,0.00021818}, {1870,0.00010909}, {1880,0.00021818}, {1890,0.00000000}, {1900,0.00010909}, {1910,0.00003636}, {1920,0.00007273}, {1930,0.00021818}, {1940,0.00021818}, {1950,0.00002727}, {1960,0.00007273}, {1970,0.00003636}, {1980,0.00003636}, {1990,0.00018182}, {2000,0.00010909}, {2050,0.00010909}, {2100,0.00003636}, {2150,0.00003636}, {2200,0.00017273}, {2250,0.00010909}, {2300,0.00003636}, {2350,0.00024545}, {2400,0.00018182}, {2450,0.00007273}, {2500,0.00014545}, {2550,0.00003636}, {2600,0.00007273}, {2650,0.00010909}, {2700,0.00000000}, {2750,0.00007273}, {2800,0.00014545}, {2850,0.00013636}, {2900,0.00007273}, {2950,0.00014545}, {3000,0.00003636}, {3050,0.00007273}, {3100,0.00007273}, {3150,0.00042727}, {3200,0.00043636}, {3250,0.00032727}, {3300,0.00039091}, {3350,0.00014545}, {3400,0.00025455}, {3450,0.00020909}, {3500,0.00070909}, {3550,0.00133636}, {3600,0.00093636}, {3650,0.00079091}, {3700,0.00070909}, {3750,0.00031818}, {3800,0.00042727}, {3850,0.00039091}, {3900,0.00036364}, {3950,0.00050000}, {4000,0.00064545}, {4050,0.00035455}, {4100,0.00068182}, {4150,0.00075455}, {4200,0.00070909}, {4250,0.00047273}, {4300,0.00039091}, {4350,0.00050909}, {4400,0.00041818}, {4450,0.00068182}, {4500,0.00043636}, {4550,0.00061818}, {4600,0.00053636}, {4650,0.00133636}, {4700,0.00073636}, {4750,0.00089091}, {4800,0.00098182}, {4850,0.00081818}, {4900,0.00116364}, {4950,0.00081818}, {5000,0.00058182}, {5050,0.00058182}, {5100,0.00041818}, {5150,0.00040000}, {5200,0.00016364}, {5250,0.00021818}, {5300,0.00025455}, {5350,0.00032727}, {5400,0.00029091}, {5450,0.00045455}, {5500,0.00055455}, {5550,0.00090909}, {5600,0.00100000}, {5650,0.00025455}, {5700,0.00076364}, {5750,0.00086364}, {5800,0.00036364}, {5850,0.00018182}, {5900,0.00000000}, {5950,0.00010909}, {6000,0.00014545}, {6050,0.00042727}, {6100,0.00014545}, {6150,0.00025455}, {6200,0.00029091}, {6250,0.00031818}, {6300,0.00020909}, {6350,0.00018182}, {6400,0.00025455}, {6450,0.00010909}, {6500,0.00039091}, {6550,0.00014545}, {6600,0.00014545}, {6650,0.00014545}, {6700,0.00018182}, {6750,0.00031818}, {6800,0.00018182}, {6850,0.00018182}, {6900,0.00029091}, {6950,0.00007273}, {7000,0.00010909}, {7050,0.00006364}, {7100,0.00042727}, {7150,0.00029091}, {7200,0.00018182}, {7250,0.00028182}, {7300,0.00010909}, {7350,0.00021818}, {7400,0.00025455}, {7450,0.00018182}, {7500,0.00025455}, {7550,0.00014545}, {7600,0.00021818}, {7650,0.00018182}, {7700,0.00010909}, {7750,0.00021818}, {7800,0.00024545}, {7850,0.00017273}, {7900,0.00003636}, {7950,0.00018182}, {8000,0.00014545}, {8050,0.00010909}, {8100,0.00018182}, {8150,0.00020909}, {8200,0.00031818}, {8250,0.00020909}, {8300,0.00013636}, {8350,0.00018182}, {8400,0.00025455}, {8450,0.00021818}, {8500,0.00020000}, {8550,0.00043636}, {8600,0.00029091}, {8650,0.00032727}, {8700,0.00025455}, {8750,0.00021818}, {8800,0.00010909}, {8850,0.00021818}, {8900,0.00024545}, {8950,0.00050909}, {9000,0.00117273}};
data["big"]["TemplateCoq"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000909}, {43,0.00002727}, {44,0.00005455}, {45,0.00006364}, {46,0.00020909}, {47,0.00056364}, {48,0.00085455}, {49,0.00098182}, {50,0.00100000}, {51,0.00100000}, {52,0.00100000}, {53,0.00100000}, {54,0.00100000}, {55,0.00100000}, {56,0.00100000}, {57,0.00100000}, {58,0.00100000}, {59,0.00100000}, {60,0.00100000}, {61,0.00100000}, {62,0.00100000}, {63,0.00100000}, {64,0.00100000}, {65,0.00100000}, {66,0.00100000}, {67,0.00100000}, {68,0.00100000}, {69,0.00101818}, {70,0.00100000}, {71,0.00100000}, {72,0.00100000}, {73,0.00100000}, {74,0.00100000}, {75,0.00100000}, {76,0.00100000}, {77,0.00100000}, {78,0.00100000}, {79,0.00100000}, {80,0.00100000}, {81,0.00100000}, {82,0.00100000}, {83,0.00101818}, {84,0.00100000}, {85,0.00100000}, {86,0.00100000}, {87,0.00100909}, {88,0.00102727}, {89,0.00100000}, {90,0.00102727}, {91,0.00100909}, {92,0.00105455}, {93,0.00111818}, {94,0.00118182}, {95,0.00135455}, {96,0.00153636}, {97,0.00169091}, {98,0.00186364}, {99,0.00191818}, {100,0.00197273}, {101,0.00199091}, {102,0.00200000}, {103,0.00200000}, {104,0.00200000}, {105,0.00200000}, {106,0.00200000}, {107,0.00200000}, {108,0.00200000}, {109,0.00200000}, {110,0.00200000}, {111,0.00200000}, {112,0.00200000}, {113,0.00200000}, {114,0.00200000}, {115,0.00200000}, {116,0.00200000}, {117,0.00200000}, {118,0.00200000}, {119,0.00200000}, {120,0.00200000}, {121,0.00200000}, {122,0.00200000}, {123,0.00200000}, {124,0.00200000}, {125,0.00201818}, {126,0.00200000}, {127,0.00200000}, {128,0.00200000}, {129,0.00200000}, {130,0.00200000}, {131,0.00200000}, {132,0.00200000}, {133,0.00200000}, {134,0.00200000}, {135,0.00200000}, {136,0.00396364}, {137,0.00202727}, {138,0.00204545}, {139,0.00210909}, {140,0.00211818}, {141,0.00217273}, {142,0.00228182}, {143,0.00240909}, {144,0.00395455}, {145,0.00262727}, {146,0.00273636}, {147,0.00280909}, {148,0.00284545}, {149,0.00290909}, {150,0.00298182}, {151,0.00299091}, {152,0.00300000}, {153,0.00300000}, {154,0.00300000}, {155,0.00300000}, {156,0.00300000}, {157,0.00300000}, {158,0.00300000}, {159,0.00399091}, {160,0.00300000}, {161,0.00300000}, {162,0.00300000}, {163,0.00300000}, {164,0.00301818}, {165,0.00300000}, {166,0.00398182}, {167,0.00300000}, {168,0.00300000}, {169,0.00300000}, {170,0.00300000}, {171,0.00300000}, {172,0.00300000}, {173,0.00300000}, {174,0.00300000}, {175,0.00300000}, {176,0.00300000}, {177,0.00300000}, {178,0.00300000}, {179,0.00496364}, {180,0.00300000}, {181,0.00300000}, {182,0.00300909}, {183,0.00300000}, {184,0.00301818}, {185,0.00304545}, {186,0.00302727}, {187,0.00306364}, {188,0.00314545}, {189,0.00316364}, {190,0.00320000}, {191,0.00347273}, {192,0.00349091}, {193,0.00359091}, {194,0.00364545}, {195,0.00373636}, {196,0.00375455}, {197,0.00379091}, {198,0.00383636}, {199,0.00389091}, {200,0.00394545}, {201,0.00392727}, {202,0.00395455}, {203,0.00553636}, {204,0.00400000}, {205,0.00400000}, {206,0.00400000}, {207,0.00402727}, {208,0.00400000}, {209,0.00400000}, {210,0.00400000}, {211,0.00400000}, {212,0.00400000}, {213,0.00400000}, {214,0.00589091}, {215,0.00400000}, {216,0.00400000}, {217,0.00400000}, {218,0.00400000}, {219,0.00400000}, {220,0.00400000}, {221,0.00400000}, {222,0.00400000}, {223,0.00404545}, {224,0.00400000}, {225,0.00400909}, {226,0.00400000}, {227,0.00400000}, {228,0.00405455}, {229,0.00401818}, {230,0.00400000}, {231,0.00402727}, {232,0.00400909}, {233,0.00412727}, {234,0.00409091}, {235,0.00414545}, {236,0.00412727}, {237,0.00419091}, {238,0.00437273}, {239,0.00436364}, {240,0.00450000}, {241,0.00460909}, {242,0.00461818}, {243,0.00472727}, {244,0.00472727}, {245,0.00476364}, {246,0.00471818}, {247,0.00478182}, {248,0.00483636}, {249,0.00663636}, {250,0.00488182}, {251,0.00493636}, {252,0.00498182}, {253,0.00500000}, {254,0.00499091}, {255,0.00500000}, {256,0.00500000}, {257,0.00500000}, {258,0.00771818}, {259,0.00500000}, {260,0.00500000}, {261,0.00500000}, {262,0.00500000}, {263,0.00500000}, {264,0.00500000}, {265,0.00500000}, {266,0.00500000}, {267,0.00766364}, {268,0.00500000}, {269,0.00500000}, {270,0.00504545}, {271,0.00500000}, {272,0.00500000}, {273,0.00501818}, {274,0.00500000}, {275,0.00500000}, {276,0.00500000}, {277,0.00500909}, {278,0.00501818}, {279,0.00504545}, {280,0.00506364}, {281,0.00507273}, {282,0.00507273}, {283,0.00510000}, {284,0.00652727}, {285,0.00527273}, {286,0.00523636}, {287,0.00539091}, {288,0.00749091}, {289,0.00559091}, {290,0.00566364}, {291,0.00569091}, {292,0.00770909}, {293,0.00576364}, {294,0.00579091}, {295,0.00579091}, {296,0.00762727}, {297,0.00586364}, {298,0.00590000}, {299,0.00588182}, {300,0.00651818}, {301,0.00595455}, {302,0.00594545}, {303,0.00597273}, {304,0.00600000}, {305,0.00599091}, {306,0.00600000}, {307,0.00600000}, {308,0.00600000}, {309,0.00600000}, {310,0.00600000}, {311,0.00600000}, {312,0.00600000}, {313,0.00600000}, {314,0.00604545}, {315,0.00864545}, {316,0.00600000}, {317,0.00600000}, {318,0.00600909}, {319,0.00600000}, {320,0.00600909}, {321,0.00600000}, {322,0.00600909}, {323,0.00601818}, {324,0.00602727}, {325,0.00604545}, {326,0.00870000}, {327,0.00610909}, {328,0.00609091}, {329,0.00611818}, {330,0.00618182}, {331,0.00620000}, {332,0.00633636}, {333,0.01000000}, {334,0.00640000}, {335,0.00641818}, {336,0.00649091}, {337,0.00658182}, {338,0.00662727}, {339,0.00670909}, {340,0.00966364}, {341,0.00674545}, {342,0.00674545}, {343,0.00679091}, {344,0.00679091}, {345,0.00678182}, {346,0.00687273}, {347,0.01136364}, {348,0.00686364}, {349,0.00687273}, {350,0.00690000}, {351,0.00690909}, {352,0.00693636}, {353,0.00690000}, {354,0.00693636}, {355,0.00698182}, {356,0.00704545}, {357,0.00967273}, {358,0.00700000}, {359,0.00700000}, {360,0.01043636}, {361,0.00700000}, {362,0.00700000}, {363,0.00700000}, {364,0.00700000}, {365,0.00701818}, {366,0.00700000}, {367,0.00700000}, {368,0.00700000}, {369,0.00706364}, {370,0.00701818}, {371,0.00703636}, {372,0.00710000}, {373,0.01006364}, {374,0.00710000}, {375,0.00709091}, {376,0.01069091}, {377,0.00715455}, {378,0.00720000}, {379,0.00722727}, {380,0.00739091}, {381,0.00739091}, {382,0.00744545}, {383,0.00751818}, {384,0.00759091}, {385,0.00757273}, {386,0.00769091}, {387,0.00770000}, {388,0.00770909}, {389,0.00772727}, {390,0.00777273}, {391,0.00777273}, {392,0.00780000}, {393,0.00778182}, {394,0.00784545}, {395,0.00784545}, {396,0.00785455}, {397,0.00787273}, {398,0.00790000}, {399,0.00792727}, {400,0.00792727}, {401,0.00791818}, {402,0.00793636}, {403,0.00795455}, {404,0.00795455}, {405,0.00798182}, {406,0.00798182}, {407,0.00799091}, {408,0.00800909}, {409,0.01161818}, {410,0.00800909}, {411,0.00808182}, {412,0.01090909}, {413,0.00800000}, {414,0.00807273}, {415,0.00895455}, {416,0.00800909}, {417,0.00804545}, {418,0.00806364}, {419,0.00805455}, {420,0.00805455}, {421,0.00810000}, {422,0.00818182}, {423,0.00811818}, {424,0.00820909}, {425,0.00834545}, {426,0.01176364}, {427,0.00830000}, {428,0.00853636}, {429,0.00839091}, {430,0.00841818}, {431,0.00854545}, {432,0.00863636}, {433,0.00866364}, {434,0.00868182}, {435,0.00867273}, {436,0.00872727}, {437,0.01174545}, {438,0.00877273}, {439,0.00884545}, {440,0.00879091}, {441,0.00879091}, {442,0.00881818}, {443,0.00883636}, {444,0.00885455}, {445,0.01210909}, {446,0.00887273}, {447,0.00899091}, {448,0.00890000}, {449,0.00891818}, {450,0.00895455}, {451,0.00895455}, {452,0.00910909}, {453,0.01254545}, {454,0.00900000}, {455,0.00899091}, {456,0.00900000}, {457,0.00901818}, {458,0.01601818}, {459,0.00900000}, {460,0.00909091}, {461,0.00901818}, {462,0.00902727}, {463,0.00901818}, {464,0.00906364}, {465,0.00920000}, {466,0.00907273}, {467,0.00907273}, {468,0.00916364}, {469,0.00920000}, {470,0.00927273}, {471,0.01044545}, {472,0.00930000}, {473,0.00936364}, {474,0.00939091}, {475,0.00951818}, {476,0.01059091}, {477,0.00951818}, {478,0.00951818}, {479,0.00959091}, {480,0.00960909}, {481,0.00967273}, {482,0.00968182}, {483,0.00968182}, {484,0.00974545}, {485,0.00984545}, {486,0.00974545}, {487,0.00974545}, {488,0.01471818}, {489,0.00978182}, {490,0.00978182}, {491,0.00980909}, {492,0.00984545}, {493,0.01605455}, {494,0.00983636}, {495,0.00986364}, {496,0.00990909}, {497,0.00998182}, {498,0.00993636}, {499,0.00998182}, {500,0.01428182}, {505,0.01000909}, {510,0.01003636}, {515,0.01020909}, {520,0.01045455}, {525,0.01053636}, {530,0.01068182}, {535,0.01431818}, {540,0.01084545}, {545,0.01590909}, {550,0.01099091}, {555,0.01105455}, {560,0.01116364}, {565,0.01131818}, {570,0.01150909}, {575,0.01169091}, {580,0.01170000}, {585,0.01181818}, {590,0.01183636}, {595,0.01204545}, {600,0.01200909}, {605,0.01227273}, {610,0.01230909}, {615,0.01247273}, {620,0.01257273}, {625,0.01273636}, {630,0.01275455}, {635,0.01282727}, {640,0.01293636}, {645,0.01849091}, {650,0.01309091}, {655,0.01770000}, {660,0.01337273}, {665,0.01355455}, {670,0.01376364}, {675,0.01371818}, {680,0.01379091}, {685,0.01380000}, {690,0.02039091}, {695,0.01401818}, {700,0.01410909}, {705,0.01437273}, {710,0.01450000}, {715,0.02556364}, {720,0.01474545}, {725,0.01585455}, {730,0.01489091}, {735,0.01490000}, {740,0.02669091}, {745,0.01510909}, {750,0.01534545}, {755,0.01545455}, {760,0.01562727}, {765,0.01858182}, {770,0.01583636}, {775,0.01576364}, {780,0.02081818}, {785,0.01608182}, {790,0.01606364}, {795,0.02771818}, {800,0.01656364}, {805,0.01650909}, {810,0.02778182}, {815,0.01690909}, {820,0.01675455}, {825,1.12251818}, {830,0.01710000}, {835,0.01702727}, {840,0.01706364}, {845,0.01731818}, {850,0.01748182}, {855,0.01764545}, {860,0.02550909}, {865,0.01786364}, {870,0.01775455}, {875,0.01783636}, {880,0.02682727}, {885,0.01820909}, {890,0.01830909}, {895,0.01803636}, {900,0.02606364}, {905,0.01876364}, {910,0.01877273}, {915,0.01878182}, {920,0.02733636}, {925,0.01906364}, {930,0.01901818}, {935,0.01922727}, {940,0.02510000}, {945,0.01958182}, {950,0.01973636}, {955,0.01970000}, {960,0.01978182}, {965,0.02666364}, {970,0.02008182}, {975,0.02015455}, {980,0.02023636}, {985,0.02037273}, {990,0.02688182}, {995,0.02989091}, {1000,0.02078182}, {1010,0.02100000}, {1020,0.02094545}, {1030,0.02125455}, {1040,0.02389091}, {1050,0.02847273}, {1060,0.03027273}, {1070,0.02227273}, {1080,0.02256364}, {1090,0.02274545}, {1100,0.02276364}, {1110,0.02297273}, {1120,0.02319091}, {1130,0.02350000}, {1140,0.02371818}, {1150,0.02350909}, {1160,0.02965455}, {1170,0.03100000}, {1180,0.03150000}, {1190,0.03173636}, {1200,0.03210909}, {1210,0.03258182}, {1220,0.03253636}, {1230,0.03270909}, {1240,0.03277273}, {1250,0.03016364}, {1260,0.02588182}, {1270,0.02637273}, {1280,0.02675455}, {1290,0.02693636}, {1300,0.02700909}, {1310,0.02749091}, {1320,0.02769091}, {1330,0.02788182}, {1340,0.03890000}, {1350,0.03744545}, {1360,0.03618182}, {1370,0.02842727}, {1380,0.02880909}, {1390,0.02930909}, {1400,0.02948182}, {1410,0.04109091}, {1420,0.03889091}, {1430,0.02885455}, {1440,0.03020909}, {1450,0.03052727}, {1460,0.04295455}, {1470,0.04022727}, {1480,0.03091818}, {1490,0.03124545}, {1500,0.03151818}, {1510,0.03999091}, {1520,0.03140000}, {1530,0.03234545}, {1540,0.04576364}, {1550,0.04219091}, {1560,0.03265455}, {1570,0.03316364}, {1580,0.04390000}, {1590,0.03328182}, {1600,0.03378182}, {1610,0.04541818}, {1620,0.03401818}, {1630,0.03457273}, {1640,0.04565455}, {1650,0.03480000}, {1660,0.03514545}, {1670,0.04491818}, {1680,0.03565455}, {1690,0.04820909}, {1700,0.03576364}, {1710,0.03614545}, {1720,0.04556364}, {1730,0.03682727}, {1740,0.04760909}, {1750,0.03740000}, {1760,0.05016364}, {1770,0.03729091}, {1780,0.05013636}, {1790,0.03778182}, {1800,0.05407273}, {1810,0.03824545}, {1820,0.05480000}, {1830,0.03871818}, {1840,0.05250000}, {1850,0.03909091}, {1860,0.05203636}, {1870,0.04000909}, {1880,0.05160000}, {1890,0.04029091}, {1900,0.05230909}, {1910,0.06670000}, {1920,0.04063636}, {1930,0.05421818}, {1940,0.04157273}, {1950,0.05197273}, {1960,0.06493636}, {1970,0.04175455}, {1980,0.05188182}, {1990,0.04248182}, {2000,0.04247273}, {2050,0.05763636}, {2100,0.06667273}, {2150,0.04619091}, {2200,0.05135455}, {2250,0.06077273}, {2300,0.06538182}, {2350,0.08125455}, {2400,0.07805455}, {2450,0.07842727}, {2500,0.07840000}, {2550,0.08644545}, {2600,0.07129091}, {2650,0.06750909}, {2700,0.05834545}, {2750,0.08050000}, {2800,0.09067273}, {2850,0.06620909}, {2900,0.08596364}, {2950,0.09857273}, {3000,0.08937273}, {3050,0.09360909}, {3100,0.09178182}, {3150,0.10665455}, {3200,0.09274545}, {3250,0.09549091}, {3300,0.10623636}, {3350,0.09809091}, {3400,0.10134545}, {3450,0.10087273}, {3500,0.10964545}, {3550,0.11600000}, {3600,0.11360909}, {3650,0.11375455}, {3700,0.11703636}, {3750,0.11321818}, {3800,0.10458182}, {3850,0.11259091}, {3900,0.11213636}, {3950,0.11263636}, {4000,0.13564545}, {4050,0.11714545}, {4100,0.11503636}, {4150,0.14361818}, {4200,0.11890909}, {4250,0.14084545}, {4300,0.12293636}, {4350,0.16372727}, {4400,0.12404545}, {4450,0.12639091}, {4500,0.14248182}, {4550,0.12581818}, {4600,0.13250000}, {4650,0.13175455}, {4700,0.12646364}, {4750,0.14918182}, {4800,0.14713636}, {4850,0.14815455}, {4900,0.14971818}, {4950,0.15133636}, {5000,0.13352727}, {5050,0.14553636}, {5100,0.14539091}, {5150,0.15040000}, {5200,0.15913636}, {5250,0.15154545}, {5300,0.15781818}, {5350,0.16130000}, {5400,0.15475455}, {5450,0.16247273}, {5500,0.15492727}, {5550,0.16758182}, {5600,0.16523636}, {5650,0.15329091}, {5700,0.17124545}, {5750,0.16691818}, {5800,0.16209091}, {5850,0.15720000}, {5900,0.17469091}, {5950,0.17795455}, {6000,0.17160000}, {6050,0.17370000}, {6100,0.17824545}, {6150,0.18375455}, {6200,0.18158182}, {6250,0.18537273}, {6300,0.17851818}, {6350,0.18471818}, {6400,0.18654545}, {6450,0.18495455}, {6500,0.18676364}, {6550,0.18717273}, {6600,0.17490000}, {6650,0.19275455}, {6700,0.17092727}, {6750,0.19590909}, {6800,0.19554545}, {6850,0.20515455}, {6900,0.20721818}, {6950,0.19807273}, {7000,0.20050909}, {7050,0.21600000}, {7100,0.20672727}, {7150,0.20641818}, {7200,0.20769091}, {7250,0.20793636}, {7300,0.20797273}, {7350,0.20877273}, {7400,0.21105455}, {7450,0.21145455}, {7500,0.22490909}, {7550,0.21985455}, {7600,0.21475455}, {7650,0.22032727}, {7700,0.23559091}, {7750,0.21662727}, {7800,0.22244545}, {7850,0.20531818}, {7900,0.22985455}, {7950,0.21456364}, {8000,0.22954545}, {8050,0.23288182}, {8100,0.24653636}, {8150,0.22996364}, {8200,0.23283636}, {8250,0.22816364}, {8300,0.23870000}, {8350,0.24915455}, {8400,0.25638182}, {8450,0.26328182}, {8500,0.26192727}, {8550,0.26330909}, {8600,0.25864545}, {8650,0.25494545}, {8700,0.23235455}, {8750,0.25065455}, {8800,0.25661818}, {8850,0.26496364}, {8900,0.24024545}, {8950,0.25860909}, {9000,0.26326364}};
data["big"]["TemplateCoq"]["actual reif"]["user"] = {{1,0.00011818}, {2,0.00005455}, {3,0.00014545}, {4,0.00010909}, {5,0.00037273}, {6,0.00010000}, {7,0.00013636}, {8,0.00020909}, {9,0.00023636}, {10,0.00014545}, {11,0.00039091}, {12,0.00024545}, {13,0.00033636}, {14,0.00024545}, {15,0.00030000}, {16,0.00029091}, {17,0.00034545}, {18,0.00038182}, {19,0.00050909}, {20,0.00026364}, {21,0.00024545}, {22,0.00056364}, {23,0.00037273}, {24,0.00041818}, {25,0.00045455}, {26,0.00065455}, {27,0.00035455}, {28,0.00039091}, {29,0.00068182}, {30,0.00066364}, {31,0.00036364}, {32,0.00078182}, {33,0.00040909}, {34,0.00084545}, {35,0.00100909}, {36,0.00060909}, {37,0.00093636}, {38,0.00093636}, {39,0.00061818}, {40,0.00066364}, {41,0.00084545}, {42,0.00076364}, {43,0.00070909}, {44,0.00073636}, {45,0.00081818}, {46,0.00093636}, {47,0.00099091}, {48,0.00089091}, {49,0.00093636}, {50,0.00092727}, {51,0.00095455}, {52,0.00107273}, {53,0.00087273}, {54,0.00080000}, {55,0.00093636}, {56,0.00124545}, {57,0.00102727}, {58,0.00100000}, {59,0.00112727}, {60,0.00104545}, {61,0.00106364}, {62,0.00088182}, {63,0.00112727}, {64,0.00132727}, {65,0.00100000}, {66,0.00102727}, {67,0.00150000}, {68,0.00114545}, {69,0.00105455}, {70,0.00130000}, {71,0.00120909}, {72,0.00138182}, {73,0.00130909}, {74,0.00125455}, {75,0.00125455}, {76,0.00120909}, {77,0.00124545}, {78,0.00121818}, {79,0.00137273}, {80,0.00146364}, {81,0.00140909}, {82,0.00140909}, {83,0.00146364}, {84,0.00143636}, {85,0.00126364}, {86,0.00174545}, {87,0.00144545}, {88,0.00123636}, {89,0.00190000}, {90,0.00165455}, {91,0.00123636}, {92,0.00169091}, {93,0.00189091}, {94,0.00151818}, {95,0.00143636}, {96,0.00155455}, {97,0.00161818}, {98,0.00174545}, {99,0.00169091}, {100,0.00201818}, {101,0.00159091}, {102,0.00160909}, {103,0.00167273}, {104,0.00198182}, {105,0.00215455}, {106,0.00205455}, {107,0.00192727}, {108,0.00193636}, {109,0.00190909}, {110,0.00201818}, {111,0.00178182}, {112,0.00180909}, {113,0.00180000}, {114,0.00188182}, {115,0.00184545}, {116,0.00196364}, {117,0.00192727}, {118,0.00180000}, {119,0.00215455}, {120,0.00203636}, {121,0.00180909}, {122,0.00206364}, {123,0.00215455}, {124,0.00220000}, {125,0.00190000}, {126,0.00214545}, {127,0.00234545}, {128,0.00242727}, {129,0.00230000}, {130,0.00226364}, {131,0.00242727}, {132,0.00211818}, {133,0.00220000}, {134,0.00247273}, {135,0.00226364}, {136,0.00378182}, {137,0.00240909}, {138,0.00242727}, {139,0.00230909}, {140,0.00232727}, {141,0.00237273}, {142,0.00252727}, {143,0.00250909}, {144,0.00394545}, {145,0.00253636}, {146,0.00224545}, {147,0.00255455}, {148,0.00260909}, {149,0.00263636}, {150,0.00256364}, {151,0.00249091}, {152,0.00245455}, {153,0.00266364}, {154,0.00266364}, {155,0.00228182}, {156,0.00288182}, {157,0.00271818}, {158,0.00252727}, {159,0.00393636}, {160,0.00274545}, {161,0.00280000}, {162,0.00282727}, {163,0.00277273}, {164,0.00268182}, {165,0.00280909}, {166,0.00360000}, {167,0.00284545}, {168,0.00295455}, {169,0.00280000}, {170,0.00288182}, {171,0.00302727}, {172,0.00318182}, {173,0.00294545}, {174,0.00300000}, {175,0.00290000}, {176,0.00290909}, {177,0.00295455}, {178,0.00309091}, {179,0.00458182}, {180,0.00310000}, {181,0.00315455}, {182,0.00302727}, {183,0.00310000}, {184,0.00306364}, {185,0.00318182}, {186,0.00304545}, {187,0.00314545}, {188,0.00328182}, {189,0.00323636}, {190,0.00330909}, {191,0.00340909}, {192,0.00343636}, {193,0.00326364}, {194,0.00342727}, {195,0.00336364}, {196,0.00335455}, {197,0.00340909}, {198,0.00365455}, {199,0.00335455}, {200,0.00339091}, {201,0.00344545}, {202,0.00346364}, {203,0.00530000}, {204,0.00370909}, {205,0.00348182}, {206,0.00398182}, {207,0.00365455}, {208,0.00354545}, {209,0.00380909}, {210,0.00358182}, {211,0.00371818}, {212,0.00377273}, {213,0.00380000}, {214,0.00610909}, {215,0.00372727}, {216,0.00365455}, {217,0.00389091}, {218,0.00373636}, {219,0.00381818}, {220,0.00360000}, {221,0.00390000}, {222,0.00392727}, {223,0.00402727}, {224,0.00380909}, {225,0.00412727}, {226,0.00387273}, {227,0.00414545}, {228,0.00408182}, {229,0.00428182}, {230,0.00427273}, {231,0.00431818}, {232,0.00435455}, {233,0.00424545}, {234,0.00400909}, {235,0.00414545}, {236,0.00416364}, {237,0.00416364}, {238,0.00410909}, {239,0.00440909}, {240,0.00422727}, {241,0.00430000}, {242,0.00446364}, {243,0.00437273}, {244,0.00485455}, {245,0.00426364}, {246,0.00426364}, {247,0.00430000}, {248,0.00428182}, {249,0.00669091}, {250,0.00451818}, {251,0.00457273}, {252,0.00462727}, {253,0.00482727}, {254,0.00466364}, {255,0.00472727}, {256,0.00444545}, {257,0.00480909}, {258,0.00791818}, {259,0.00480000}, {260,0.00478182}, {261,0.00477273}, {262,0.00505455}, {263,0.00489091}, {264,0.00506364}, {265,0.00494545}, {266,0.00499091}, {267,0.00777273}, {268,0.00526364}, {269,0.00442727}, {270,0.00533636}, {271,0.00471818}, {272,0.00520909}, {273,0.00497273}, {274,0.00513636}, {275,0.00511818}, {276,0.00520000}, {277,0.00527273}, {278,0.00501818}, {279,0.00550909}, {280,0.00537273}, {281,0.00538182}, {282,0.00518182}, {283,0.00566364}, {284,0.00645455}, {285,0.00521818}, {286,0.00583636}, {287,0.00529091}, {288,0.00766364}, {289,0.00526364}, {290,0.00557273}, {291,0.00553636}, {292,0.00764545}, {293,0.00571818}, {294,0.00555455}, {295,0.00554545}, {296,0.00745455}, {297,0.00548182}, {298,0.00531818}, {299,0.00507273}, {300,0.00637273}, {301,0.00583636}, {302,0.00548182}, {303,0.00566364}, {304,0.00579091}, {305,0.00588182}, {306,0.00580909}, {307,0.00610000}, {308,0.00590909}, {309,0.00595455}, {310,0.00604545}, {311,0.00590909}, {312,0.00539091}, {313,0.00585455}, {314,0.00630000}, {315,0.00879091}, {316,0.00604545}, {317,0.00619091}, {318,0.00639091}, {319,0.00584545}, {320,0.00626364}, {321,0.00606364}, {322,0.00649091}, {323,0.00621818}, {324,0.00595455}, {325,0.00618182}, {326,0.00865455}, {327,0.00621818}, {328,0.00626364}, {329,0.00648182}, {330,0.00652727}, {331,0.00667273}, {332,0.00629091}, {333,0.01050000}, {334,0.00656364}, {335,0.00635455}, {336,0.00640909}, {337,0.00665455}, {338,0.00640000}, {339,0.00671818}, {340,0.00981818}, {341,0.00641818}, {342,0.00693636}, {343,0.00661818}, {344,0.00700909}, {345,0.00659091}, {346,0.00672727}, {347,0.01184545}, {348,0.00697273}, {349,0.00672727}, {350,0.00671818}, {351,0.00673636}, {352,0.00702727}, {353,0.00676364}, {354,0.00680000}, {355,0.00700909}, {356,0.00727273}, {357,0.00971818}, {358,0.00709091}, {359,0.00687273}, {360,0.01063636}, {361,0.00709091}, {362,0.00697273}, {363,0.00708182}, {364,0.00716364}, {365,0.00729091}, {366,0.00726364}, {367,0.00727273}, {368,0.00733636}, {369,0.00724545}, {370,0.00737273}, {371,0.00706364}, {372,0.00739091}, {373,0.01067273}, {374,0.00739091}, {375,0.00736364}, {376,0.01100000}, {377,0.00753636}, {378,0.00750000}, {379,0.00733636}, {380,0.00761818}, {381,0.00743636}, {382,0.00761818}, {383,0.00761818}, {384,0.00784545}, {385,0.00759091}, {386,0.00757273}, {387,0.00788182}, {388,0.00778182}, {389,0.00780909}, {390,0.00780909}, {391,0.00771818}, {392,0.00776364}, {393,0.00788182}, {394,0.00776364}, {395,0.00803636}, {396,0.00811818}, {397,0.00796364}, {398,0.00788182}, {399,0.00782727}, {400,0.00773636}, {401,0.00798182}, {402,0.00817273}, {403,0.00804545}, {404,0.00793636}, {405,0.00826364}, {406,0.00793636}, {407,0.00807273}, {408,0.00806364}, {409,0.01180909}, {410,0.00829091}, {411,0.00840909}, {412,0.01162727}, {413,0.00855455}, {414,0.00815455}, {415,0.00930909}, {416,0.00846364}, {417,0.00850000}, {418,0.00846364}, {419,0.00841818}, {420,0.00819091}, {421,0.00845455}, {422,0.00835455}, {423,0.00838182}, {424,0.00863636}, {425,0.00845455}, {426,0.01198182}, {427,0.00860909}, {428,0.00892727}, {429,0.00865455}, {430,0.00892727}, {431,0.00924545}, {432,0.00886364}, {433,0.00879091}, {434,0.00859091}, {435,0.00865455}, {436,0.00894545}, {437,0.01232727}, {438,0.00892727}, {439,0.00891818}, {440,0.00872727}, {441,0.00890909}, {442,0.00886364}, {443,0.00873636}, {444,0.00860909}, {445,0.01231818}, {446,0.00894545}, {447,0.00880000}, {448,0.00873636}, {449,0.00916364}, {450,0.00932727}, {451,0.00933636}, {452,0.00884545}, {453,0.01280000}, {454,0.00958182}, {455,0.00961818}, {456,0.00902727}, {457,0.00910000}, {458,0.01595455}, {459,0.00919091}, {460,0.00927273}, {461,0.00930000}, {462,0.00937273}, {463,0.00951818}, {464,0.00897273}, {465,0.00950909}, {466,0.00935455}, {467,0.00984545}, {468,0.00962727}, {469,0.00973636}, {470,0.00961818}, {471,0.01062727}, {472,0.00985455}, {473,0.00959091}, {474,0.00983636}, {475,0.00981818}, {476,0.01065455}, {477,0.01028182}, {478,0.00958182}, {479,0.01008182}, {480,0.01008182}, {481,0.00940909}, {482,0.01016364}, {483,0.00967273}, {484,0.00985455}, {485,0.01030000}, {486,0.01015455}, {487,0.00989091}, {488,0.01462727}, {489,0.01021818}, {490,0.00992727}, {491,0.00992727}, {492,0.00966364}, {493,0.01568182}, {494,0.01008182}, {495,0.01022727}, {496,0.01008182}, {497,0.01022727}, {498,0.01015455}, {499,0.01028182}, {500,0.01431818}, {505,0.01052727}, {510,0.01077273}, {515,0.01080909}, {520,0.01109091}, {525,0.01108182}, {530,0.01097273}, {535,0.01448182}, {540,0.01141818}, {545,0.01585455}, {550,0.01137273}, {555,0.01163636}, {560,0.01151818}, {565,0.01193636}, {570,0.01186364}, {575,0.01231818}, {580,0.01225455}, {585,0.01191818}, {590,0.01200000}, {595,0.01239091}, {600,0.01249091}, {605,0.01262727}, {610,0.01252727}, {615,0.01276364}, {620,0.01261818}, {625,0.01287273}, {630,0.01298182}, {635,0.01306364}, {640,0.01314545}, {645,0.01841818}, {650,0.01312727}, {655,0.01788182}, {660,0.01354545}, {665,0.01360909}, {670,0.01365455}, {675,0.01396364}, {680,0.01405455}, {685,0.01420909}, {690,0.02030909}, {695,0.01425455}, {700,0.01424545}, {705,0.01426364}, {710,0.01434545}, {715,0.02563636}, {720,0.01432727}, {725,0.01563636}, {730,0.01480000}, {735,0.01459091}, {740,0.02657273}, {745,0.01490909}, {750,0.01509091}, {755,0.01515455}, {760,0.01529091}, {765,0.01860909}, {770,0.01555455}, {775,0.01574545}, {780,0.02114545}, {785,0.01601818}, {790,0.01587273}, {795,0.02772727}, {800,0.01610909}, {805,0.01620909}, {810,0.02760000}, {815,0.01680000}, {820,0.01662727}, {825,1.12114545}, {830,0.01708182}, {835,0.01695455}, {840,0.01686364}, {845,0.01668182}, {850,0.01693636}, {855,0.01762727}, {860,0.02565455}, {865,0.01753636}, {870,0.01783636}, {875,0.01800000}, {880,0.02688182}, {885,0.01840909}, {890,0.01851818}, {895,0.01819091}, {900,0.02597273}, {905,0.01881818}, {910,0.01907273}, {915,0.01882727}, {920,0.02743636}, {925,0.01918182}, {930,0.01906364}, {935,0.01920000}, {940,0.02525455}, {945,0.01960909}, {950,0.01987273}, {955,0.01989091}, {960,0.01992727}, {965,0.02662727}, {970,0.02046364}, {975,0.02045455}, {980,0.02019091}, {985,0.02040000}, {990,0.02672727}, {995,0.02985455}, {1000,0.02081818}, {1010,0.02133636}, {1020,0.02181818}, {1030,0.02117273}, {1040,0.02390909}, {1050,0.02842727}, {1060,0.03040000}, {1070,0.02279091}, {1080,0.02290909}, {1090,0.02331818}, {1100,0.02340000}, {1110,0.02335455}, {1120,0.02357273}, {1130,0.02389091}, {1140,0.02408182}, {1150,0.02386364}, {1160,0.02976364}, {1170,0.03099091}, {1180,0.03160000}, {1190,0.03195455}, {1200,0.03247273}, {1210,0.03281818}, {1220,0.03266364}, {1230,0.03318182}, {1240,0.03275455}, {1250,0.03054545}, {1260,0.02600909}, {1270,0.02650909}, {1280,0.02649091}, {1290,0.02663636}, {1300,0.02682727}, {1310,0.02720000}, {1320,0.02780000}, {1330,0.02799091}, {1340,0.03883636}, {1350,0.03728182}, {1360,0.03636364}, {1370,0.02810000}, {1380,0.02906364}, {1390,0.02929091}, {1400,0.02932727}, {1410,0.04086364}, {1420,0.03868182}, {1430,0.02846364}, {1440,0.03040000}, {1450,0.03065455}, {1460,0.04314545}, {1470,0.04036364}, {1480,0.03082727}, {1490,0.03131818}, {1500,0.03153636}, {1510,0.04006364}, {1520,0.03154545}, {1530,0.03221818}, {1540,0.04616364}, {1550,0.04223636}, {1560,0.03243636}, {1570,0.03347273}, {1580,0.04437273}, {1590,0.03368182}, {1600,0.03383636}, {1610,0.04582727}, {1620,0.03460000}, {1630,0.03510000}, {1640,0.04622727}, {1650,0.03519091}, {1660,0.03532727}, {1670,0.04518182}, {1680,0.03589091}, {1690,0.04833636}, {1700,0.03612727}, {1710,0.03637273}, {1720,0.04573636}, {1730,0.03721818}, {1740,0.04795455}, {1750,0.03751818}, {1760,0.05008182}, {1770,0.03720000}, {1780,0.05017273}, {1790,0.03781818}, {1800,0.05411818}, {1810,0.03835455}, {1820,0.05473636}, {1830,0.03853636}, {1840,0.05246364}, {1850,0.03872727}, {1860,0.05210000}, {1870,0.03998182}, {1880,0.05179091}, {1890,0.04003636}, {1900,0.05217273}, {1910,0.06679091}, {1920,0.04067273}, {1930,0.05420909}, {1940,0.04160000}, {1950,0.05148182}, {1960,0.06504545}, {1970,0.04151818}, {1980,0.05207273}, {1990,0.04261818}, {2000,0.04274545}, {2050,0.05790000}, {2100,0.06669091}, {2150,0.04654545}, {2200,0.05123636}, {2250,0.06055455}, {2300,0.06542727}, {2350,0.08113636}, {2400,0.07779091}, {2450,0.07818182}, {2500,0.07839091}, {2550,0.08646364}, {2600,0.07122727}, {2650,0.06743636}, {2700,0.05828182}, {2750,0.08061818}, {2800,0.09074545}, {2850,0.06660909}, {2900,0.08620909}, {2950,0.09855455}, {3000,0.08953636}, {3050,0.09323636}, {3100,0.09160909}, {3150,0.10642727}, {3200,0.09246364}, {3250,0.09566364}, {3300,0.10604545}, {3350,0.09797273}, {3400,0.10157273}, {3450,0.10079091}, {3500,0.10965455}, {3550,0.11558182}, {3600,0.11296364}, {3650,0.11350909}, {3700,0.11680000}, {3750,0.11307273}, {3800,0.10453636}, {3850,0.11222727}, {3900,0.11229091}, {3950,0.11216364}, {4000,0.13479091}, {4050,0.11731818}, {4100,0.11495455}, {4150,0.14302727}, {4200,0.11854545}, {4250,0.14071818}, {4300,0.12281818}, {4350,0.16333636}, {4400,0.12382727}, {4450,0.12644545}, {4500,0.14205455}, {4550,0.12534545}, {4600,0.13226364}, {4650,0.13128182}, {4700,0.12620000}, {4750,0.14861818}, {4800,0.14668182}, {4850,0.14757273}, {4900,0.14902727}, {4950,0.15083636}, {5000,0.13330000}, {5050,0.14472727}, {5100,0.14505455}, {5150,0.15036364}, {5200,0.15874545}, {5250,0.15179091}, {5300,0.15727273}, {5350,0.16117273}, {5400,0.15467273}, {5450,0.16210000}, {5500,0.15476364}, {5550,0.16740000}, {5600,0.16478182}, {5650,0.15291818}, {5700,0.17099091}, {5750,0.16630909}, {5800,0.16201818}, {5850,0.15677273}, {5900,0.17488182}, {5950,0.17786364}, {6000,0.17164545}, {6050,0.17360909}, {6100,0.17809091}, {6150,0.18336364}, {6200,0.18154545}, {6250,0.18496364}, {6300,0.17854545}, {6350,0.18431818}, {6400,0.18642727}, {6450,0.18460909}, {6500,0.18673636}, {6550,0.18692727}, {6600,0.17457273}, {6650,0.19253636}, {6700,0.17041818}, {6750,0.19551818}, {6800,0.19538182}, {6850,0.20466364}, {6900,0.20697273}, {6950,0.19818182}, {7000,0.20060909}, {7050,0.21620000}, {7100,0.20631818}, {7150,0.20606364}, {7200,0.20748182}, {7250,0.20754545}, {7300,0.20792727}, {7350,0.20888182}, {7400,0.21086364}, {7450,0.21120000}, {7500,0.22469091}, {7550,0.21962727}, {7600,0.21486364}, {7650,0.22008182}, {7700,0.23557273}, {7750,0.21633636}, {7800,0.22230909}, {7850,0.20507273}, {7900,0.22928182}, {7950,0.21426364}, {8000,0.22922727}, {8050,0.23280909}, {8100,0.24608182}, {8150,0.22978182}, {8200,0.23258182}, {8250,0.22782727}, {8300,0.23851818}, {8350,0.24945455}, {8400,0.25618182}, {8450,0.26360909}, {8500,0.26175455}, {8550,0.26314545}, {8600,0.25861818}, {8650,0.25473636}, {8700,0.23178182}, {8750,0.25088182}, {8800,0.25673636}, {8850,0.26499091}, {8900,0.23987273}, {8950,0.25837273}, {9000,0.26289091}};
data["big"]["TemplateCoq"]["actual reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00003636}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00003636}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00003636}, {21,0.00003636}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00003636}, {29,0.00000000}, {30,0.00003636}, {31,0.00000000}, {32,0.00000000}, {33,0.00003636}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00007273}, {39,0.00000000}, {40,0.00000000}, {41,0.00003636}, {42,0.00003636}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00003636}, {47,0.00000000}, {48,0.00003636}, {49,0.00000000}, {50,0.00000000}, {51,0.00003636}, {52,0.00003636}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00003636}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00003636}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00003636}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00003636}, {84,0.00003636}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00003636}, {96,0.00003636}, {97,0.00000000}, {98,0.00000000}, {99,0.00003636}, {100,0.00000000}, {101,0.00007273}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00003636}, {107,0.00007273}, {108,0.00007273}, {109,0.00003636}, {110,0.00003636}, {111,0.00003636}, {112,0.00002727}, {113,0.00003636}, {114,0.00003636}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00003636}, {119,0.00000000}, {120,0.00003636}, {121,0.00007273}, {122,0.00000000}, {123,0.00010909}, {124,0.00000000}, {125,0.00003636}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00003636}, {132,0.00000000}, {133,0.00000000}, {134,0.00003636}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00003636}, {140,0.00000000}, {141,0.00003636}, {142,0.00000000}, {143,0.00003636}, {144,0.00000000}, {145,0.00000000}, {146,0.00003636}, {147,0.00000000}, {148,0.00003636}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00003636}, {153,0.00007273}, {154,0.00000000}, {155,0.00000000}, {156,0.00003636}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00003636}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00003636}, {166,0.00007273}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00003636}, {172,0.00000000}, {173,0.00003636}, {174,0.00000000}, {175,0.00003636}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00003636}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00003636}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00007273}, {190,0.00002727}, {191,0.00000000}, {192,0.00003636}, {193,0.00010000}, {194,0.00000000}, {195,0.00003636}, {196,0.00003636}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00003636}, {202,0.00000000}, {203,0.00002727}, {204,0.00000000}, {205,0.00010909}, {206,0.00000000}, {207,0.00000000}, {208,0.00003636}, {209,0.00000000}, {210,0.00000000}, {211,0.00003636}, {212,0.00000000}, {213,0.00000000}, {214,0.00003636}, {215,0.00000000}, {216,0.00007273}, {217,0.00007273}, {218,0.00003636}, {219,0.00003636}, {220,0.00003636}, {221,0.00000000}, {222,0.00007273}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00003636}, {229,0.00003636}, {230,0.00003636}, {231,0.00003636}, {232,0.00000000}, {233,0.00003636}, {234,0.00003636}, {235,0.00000000}, {236,0.00000000}, {237,0.00003636}, {238,0.00003636}, {239,0.00000000}, {240,0.00002727}, {241,0.00003636}, {242,0.00000000}, {243,0.00003636}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00007273}, {249,0.00000000}, {250,0.00003636}, {251,0.00002727}, {252,0.00003636}, {253,0.00000000}, {254,0.00000000}, {255,0.00003636}, {256,0.00010909}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00003636}, {261,0.00003636}, {262,0.00003636}, {263,0.00000000}, {264,0.00003636}, {265,0.00003636}, {266,0.00000000}, {267,0.00007273}, {268,0.00000000}, {269,0.00007273}, {270,0.00000000}, {271,0.00007273}, {272,0.00000000}, {273,0.00000000}, {274,0.00003636}, {275,0.00003636}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00003636}, {280,0.00003636}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00007273}, {286,0.00000000}, {287,0.00010909}, {288,0.00003636}, {289,0.00003636}, {290,0.00000000}, {291,0.00003636}, {292,0.00007273}, {293,0.00000000}, {294,0.00003636}, {295,0.00003636}, {296,0.00003636}, {297,0.00000000}, {298,0.00003636}, {299,0.00000000}, {300,0.00003636}, {301,0.00002727}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00003636}, {307,0.00007273}, {308,0.00003636}, {309,0.00003636}, {310,0.00000000}, {311,0.00000000}, {312,0.00003636}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00003636}, {317,0.00003636}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00007273}, {324,0.00000000}, {325,0.00007273}, {326,0.00003636}, {327,0.00007273}, {328,0.00003636}, {329,0.00000000}, {330,0.00003636}, {331,0.00000000}, {332,0.00007273}, {333,0.00003636}, {334,0.00000000}, {335,0.00003636}, {336,0.00007273}, {337,0.00000000}, {338,0.00003636}, {339,0.00000000}, {340,0.00007273}, {341,0.00003636}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00003636}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00003636}, {351,0.00003636}, {352,0.00000000}, {353,0.00003636}, {354,0.00000000}, {355,0.00003636}, {356,0.00003636}, {357,0.00000000}, {358,0.00000000}, {359,0.00003636}, {360,0.00007273}, {361,0.00003636}, {362,0.00003636}, {363,0.00000000}, {364,0.00000000}, {365,0.00003636}, {366,0.00000000}, {367,0.00000000}, {368,0.00003636}, {369,0.00003636}, {370,0.00000000}, {371,0.00000000}, {372,0.00003636}, {373,0.00000000}, {374,0.00003636}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00003636}, {379,0.00007273}, {380,0.00003636}, {381,0.00003636}, {382,0.00003636}, {383,0.00000000}, {384,0.00000000}, {385,0.00003636}, {386,0.00003636}, {387,0.00007273}, {388,0.00000000}, {389,0.00000000}, {390,0.00003636}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00003636}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00007273}, {400,0.00000000}, {401,0.00003636}, {402,0.00000000}, {403,0.00002727}, {404,0.00000000}, {405,0.00000000}, {406,0.00003636}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00003636}, {413,0.00003636}, {414,0.00000000}, {415,0.00000000}, {416,0.00010909}, {417,0.00003636}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00003636}, {424,0.00003636}, {425,0.00000000}, {426,0.00010000}, {427,0.00003636}, {428,0.00000000}, {429,0.00000000}, {430,0.00003636}, {431,0.00000000}, {432,0.00003636}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00003636}, {441,0.00003636}, {442,0.00003636}, {443,0.00003636}, {444,0.00010909}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00003636}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00003636}, {458,0.00007273}, {459,0.00007273}, {460,0.00000000}, {461,0.00007273}, {462,0.00003636}, {463,0.00003636}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003636}, {469,0.00000000}, {470,0.00007273}, {471,0.00000000}, {472,0.00000000}, {473,0.00003636}, {474,0.00007273}, {475,0.00000000}, {476,0.00006364}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00003636}, {483,0.00007273}, {484,0.00007273}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00006364}, {491,0.00007273}, {492,0.00003636}, {493,0.00000000}, {494,0.00003636}, {495,0.00003636}, {496,0.00000000}, {497,0.00003636}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00003636}, {535,0.00007273}, {540,0.00002727}, {545,0.00003636}, {550,0.00003636}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00003636}, {575,0.00000000}, {580,0.00000000}, {585,0.00007273}, {590,0.00013636}, {595,0.00000000}, {600,0.00007273}, {605,0.00003636}, {610,0.00003636}, {615,0.00003636}, {620,0.00000000}, {625,0.00007273}, {630,0.00007273}, {635,0.00003636}, {640,0.00003636}, {645,0.00000000}, {650,0.00003636}, {655,0.00002727}, {660,0.00003636}, {665,0.00000000}, {670,0.00003636}, {675,0.00000000}, {680,0.00003636}, {685,0.00000000}, {690,0.00007273}, {695,0.00000000}, {700,0.00003636}, {705,0.00000000}, {710,0.00007273}, {715,0.00003636}, {720,0.00000000}, {725,0.00007273}, {730,0.00000000}, {735,0.00007273}, {740,0.00006364}, {745,0.00007273}, {750,0.00000000}, {755,0.00010909}, {760,0.00000000}, {765,0.00000000}, {770,0.00002727}, {775,0.00000000}, {780,0.00010909}, {785,0.00003636}, {790,0.00010909}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00137273}, {830,0.00000000}, {835,0.00000000}, {840,0.00003636}, {845,0.00007273}, {850,0.00000000}, {855,0.00000000}, {860,0.00003636}, {865,0.00003636}, {870,0.00000000}, {875,0.00002727}, {880,0.00000000}, {885,0.00000000}, {890,0.00003636}, {895,0.00006364}, {900,0.00000000}, {905,0.00003636}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00003636}, {930,0.00000000}, {935,0.00003636}, {940,0.00000000}, {945,0.00003636}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00003636}, {970,0.00000000}, {975,0.00003636}, {980,0.00003636}, {985,0.00000000}, {990,0.00003636}, {995,0.00000000}, {1000,0.00003636}, {1010,0.00007273}, {1020,0.00000000}, {1030,0.00003636}, {1040,0.00003636}, {1050,0.00003636}, {1060,0.00003636}, {1070,0.00007273}, {1080,0.00000000}, {1090,0.00003636}, {1100,0.00000000}, {1110,0.00003636}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00003636}, {1200,0.00000000}, {1210,0.00003636}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00007273}, {1250,0.00000000}, {1260,0.00003636}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00003636}, {1300,0.00007273}, {1310,0.00003636}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00003636}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00007273}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00003636}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00003636}, {1580,0.00000000}, {1590,0.00003636}, {1600,0.00003636}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00003636}, {1640,0.00000000}, {1650,0.00003636}, {1660,0.00003636}, {1670,0.00003636}, {1680,0.00003636}, {1690,0.00000000}, {1700,0.00003636}, {1710,0.00003636}, {1720,0.00003636}, {1730,0.00003636}, {1740,0.00003636}, {1750,0.00003636}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00007273}, {1790,0.00007273}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00003636}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00003636}, {1860,0.00003636}, {1870,0.00000000}, {1880,0.00003636}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00003636}, {1940,0.00007273}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00003636}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00002727}, {2250,0.00003636}, {2300,0.00003636}, {2350,0.00003636}, {2400,0.00003636}, {2450,0.00003636}, {2500,0.00007273}, {2550,0.00000000}, {2600,0.00003636}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00003636}, {2900,0.00000000}, {2950,0.00003636}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00003636}, {3150,0.00029091}, {3200,0.00014545}, {3250,0.00007273}, {3300,0.00021818}, {3350,0.00007273}, {3400,0.00014545}, {3450,0.00002727}, {3500,0.00010909}, {3550,0.00058182}, {3600,0.00071818}, {3650,0.00040000}, {3700,0.00029091}, {3750,0.00017273}, {3800,0.00010909}, {3850,0.00014545}, {3900,0.00010909}, {3950,0.00018182}, {4000,0.00043636}, {4050,0.00003636}, {4100,0.00035455}, {4150,0.00039091}, {4200,0.00035455}, {4250,0.00010909}, {4300,0.00018182}, {4350,0.00021818}, {4400,0.00018182}, {4450,0.00007273}, {4500,0.00029091}, {4550,0.00032727}, {4600,0.00029091}, {4650,0.00032727}, {4700,0.00020909}, {4750,0.00035455}, {4800,0.00025455}, {4850,0.00043636}, {4900,0.00061818}, {4950,0.00045455}, {5000,0.00014545}, {5050,0.00025455}, {5100,0.00020909}, {5150,0.00018182}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00014545}, {5350,0.00007273}, {5400,0.00007273}, {5450,0.00010000}, {5500,0.00028182}, {5550,0.00039091}, {5600,0.00027273}, {5650,0.00003636}, {5700,0.00025455}, {5750,0.00025455}, {5800,0.00007273}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00003636}, {6050,0.00017273}, {6100,0.00003636}, {6150,0.00014545}, {6200,0.00003636}, {6250,0.00007273}, {6300,0.00003636}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00007273}, {6500,0.00010909}, {6550,0.00000000}, {6600,0.00010909}, {6650,0.00003636}, {6700,0.00007273}, {6750,0.00014545}, {6800,0.00007273}, {6850,0.00007273}, {6900,0.00007273}, {6950,0.00000000}, {7000,0.00007273}, {7050,0.00006364}, {7100,0.00014545}, {7150,0.00010909}, {7200,0.00003636}, {7250,0.00007273}, {7300,0.00003636}, {7350,0.00000000}, {7400,0.00010909}, {7450,0.00007273}, {7500,0.00003636}, {7550,0.00003636}, {7600,0.00007273}, {7650,0.00007273}, {7700,0.00000000}, {7750,0.00003636}, {7800,0.00000000}, {7850,0.00007273}, {7900,0.00003636}, {7950,0.00010909}, {8000,0.00003636}, {8050,0.00010909}, {8100,0.00003636}, {8150,0.00007273}, {8200,0.00018182}, {8250,0.00006364}, {8300,0.00003636}, {8350,0.00000000}, {8400,0.00010909}, {8450,0.00007273}, {8500,0.00012727}, {8550,0.00007273}, {8600,0.00014545}, {8650,0.00010909}, {8700,0.00014545}, {8750,0.00003636}, {8800,0.00007273}, {8850,0.00007273}, {8900,0.00006364}, {8950,0.00003636}, {9000,0.00032727}};
data["big"]["TemplateCoq"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00071818}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00003636}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00004545}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00195455}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00196364}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000909}, {457,0.00000000}, {458,0.00000000}, {459,0.00000909}, {460,0.00000000}, {461,0.00000000}, {462,0.00000909}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00001818}, {469,0.00001818}, {470,0.00000909}, {471,0.00002727}, {472,0.00002727}, {473,0.00000909}, {474,0.00000000}, {475,0.00002727}, {476,0.00000000}, {477,0.00000909}, {478,0.00001818}, {479,0.00001818}, {480,0.00001818}, {481,0.00003636}, {482,0.00000909}, {483,0.00001818}, {484,0.00000909}, {485,0.00002727}, {486,0.00004545}, {487,0.00008182}, {488,0.00003636}, {489,0.00006364}, {490,0.00005455}, {491,0.00003636}, {492,0.00012727}, {493,0.00005455}, {494,0.00010000}, {495,0.00014545}, {496,0.00007273}, {497,0.00012727}, {498,0.00018182}, {499,0.00014545}, {500,0.00022727}, {505,0.00023636}, {510,0.00043636}, {515,0.00058182}, {520,0.00071818}, {525,0.00077273}, {530,0.00082727}, {535,0.00088182}, {540,0.00092727}, {545,0.00098182}, {550,0.00098182}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00198182}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00234545}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00109091}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00100000}, {830,0.00100000}, {835,0.00100000}, {840,0.00100000}, {845,0.00100000}, {850,0.00100000}, {855,0.00100000}, {860,0.00100000}, {865,0.00100000}, {870,0.00100000}, {875,0.00100000}, {880,0.00100000}, {885,0.00100000}, {890,0.00100000}, {895,0.01298182}, {900,0.00100000}, {905,0.00100000}, {910,0.00100000}, {915,0.00958182}, {920,0.00100000}, {925,0.00101818}, {930,0.00100000}, {935,0.00100909}, {940,0.00100909}, {945,0.00100909}, {950,0.00102727}, {955,0.00101818}, {960,0.00109091}, {965,0.00112727}, {970,0.00109091}, {975,0.00110000}, {980,0.00122727}, {985,0.00130909}, {990,0.00127273}, {995,0.00141818}, {1000,0.00142727}, {1010,0.00166364}, {1020,0.00163636}, {1030,0.00183636}, {1040,0.00186364}, {1050,0.00186364}, {1060,0.00195455}, {1070,0.00196364}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200000}, {1140,0.00200000}, {1150,0.00790909}, {1160,0.00200000}, {1170,0.00200000}, {1180,0.00200000}, {1190,0.00200000}, {1200,0.00200000}, {1210,0.00200000}, {1220,0.00200000}, {1230,0.00200000}, {1240,0.00200000}, {1250,0.00200000}, {1260,0.00663636}, {1270,0.00200000}, {1280,0.00200000}, {1290,0.00200000}, {1300,0.00200000}, {1310,0.00200000}, {1320,0.00200000}, {1330,0.00200000}, {1340,0.00200000}, {1350,0.00200000}, {1360,0.00200000}, {1370,0.00550909}, {1380,0.00200000}, {1390,0.00200909}, {1400,0.00201818}, {1410,0.00200909}, {1420,0.00202727}, {1430,0.00206364}, {1440,0.00211818}, {1450,0.00213636}, {1460,0.00229091}, {1470,0.00240909}, {1480,0.00456364}, {1490,0.00252727}, {1500,0.00258182}, {1510,0.00269091}, {1520,0.00836364}, {1530,0.00274545}, {1540,0.00274545}, {1550,0.00285455}, {1560,0.00291818}, {1570,0.00297273}, {1580,0.00304545}, {1590,0.00399091}, {1600,0.00300000}, {1610,0.00300000}, {1620,0.00496364}, {1630,0.00300000}, {1640,0.00305455}, {1650,0.00300000}, {1660,0.00300000}, {1670,0.00300000}, {1680,0.00300000}, {1690,0.00300000}, {1700,0.00300000}, {1710,0.00300000}, {1720,0.00300000}, {1730,0.00300000}, {1740,0.00300000}, {1750,0.00300000}, {1760,0.00300000}, {1770,0.00300000}, {1780,0.00300000}, {1790,0.00300000}, {1800,0.00300909}, {1810,0.00300000}, {1820,0.00301818}, {1830,0.00300000}, {1840,0.00300000}, {1850,0.00300909}, {1860,0.00300909}, {1870,0.00303636}, {1880,0.00301818}, {1890,0.00301818}, {1900,0.00302727}, {1910,0.00314545}, {1920,0.00311818}, {1930,0.00311818}, {1940,0.00316364}, {1950,0.00330909}, {1960,0.00337273}, {1970,0.00352727}, {1980,0.00355455}, {1990,0.00361818}, {2000,0.00367273}, {2050,0.00398182}, {2100,0.00399091}, {2150,0.00400000}, {2200,0.00400000}, {2250,0.00400000}, {2300,0.00400000}, {2350,0.00406364}, {2400,0.00412727}, {2450,0.00445455}, {2500,0.00470909}, {2550,0.00481818}, {2600,0.00505455}, {2650,0.00500000}, {2700,0.00500000}, {2750,0.00500909}, {2800,0.00501818}, {2850,0.00506364}, {2900,0.00536364}, {2950,0.00576364}, {3000,0.00573636}, {3050,0.00589091}, {3100,0.00596364}, {3150,0.00605455}, {3200,0.00601818}, {3250,0.01318182}, {3300,0.00625455}, {3350,0.00625455}, {3400,0.00648182}, {3450,0.00952727}, {3500,0.00676364}, {3550,0.00683636}, {3600,0.00700909}, {3650,0.00708182}, {3700,0.00703636}, {3750,0.00706364}, {3800,0.00723636}, {3850,0.00729091}, {3900,0.00762727}, {3950,0.00772727}, {4000,0.00780909}, {4050,0.00790000}, {4100,0.00796364}, {4150,0.00800909}, {4200,0.00811818}, {4250,0.00816364}, {4300,0.00832727}, {4350,0.00856364}, {4400,0.00864545}, {4450,0.00870909}, {4500,0.00881818}, {4550,0.00887273}, {4600,0.00904545}, {4650,0.00903636}, {4700,0.04710909}, {4750,0.00934545}, {4800,0.00946364}, {4850,0.01012727}, {4900,0.00973636}, {4950,0.00974545}, {5000,0.04635455}, {5050,0.00985455}, {5100,0.00995455}, {5150,0.01009091}, {5200,0.01071818}, {5250,0.03256364}, {5300,0.01056364}, {5350,0.01066364}, {5400,0.01070909}, {5450,0.01135455}, {5500,0.01085455}, {5550,0.01136364}, {5600,0.01108182}, {5650,0.03844545}, {5700,0.01180909}, {5750,0.01150000}, {5800,0.01160000}, {5850,0.04083636}, {5900,0.01170909}, {5950,0.01236364}, {6000,0.01186364}, {6050,0.01197273}, {6100,0.01212727}, {6150,0.01279091}, {6200,0.01289091}, {6250,0.01255455}, {6300,0.03357273}, {6350,0.01275455}, {6400,0.01275455}, {6450,0.01310909}, {6500,0.01292727}, {6550,0.01299091}, {6600,0.04413636}, {6650,0.01340909}, {6700,0.01350909}, {6750,0.01360909}, {6800,0.02917273}, {6850,0.01433636}, {6900,0.01385455}, {6950,0.03388182}, {7000,0.01422727}, {7050,0.01418182}, {7100,0.01437273}, {7150,0.01440000}, {7200,0.01456364}, {7250,0.01462727}, {7300,0.01470000}, {7350,0.01480909}, {7400,0.01483636}, {7450,0.01498182}, {7500,0.01500000}, {7550,0.01552727}, {7600,0.03835455}, {7650,0.01551818}, {7700,0.01620909}, {7750,0.03748182}, {7800,0.01575455}, {7850,0.01581818}, {7900,0.01592727}, {7950,0.05312727}, {8000,0.01610000}, {8050,0.02968182}, {8100,0.01672727}, {8150,0.01660909}, {8200,0.01662727}, {8250,0.04275455}, {8300,0.01695455}, {8350,0.01729091}, {8400,0.01777273}, {8450,0.01692727}, {8500,0.01708182}, {8550,0.01732727}, {8600,0.01796364}, {8650,0.01789091}, {8700,0.06004545}, {8750,0.02692727}, {8800,0.01784545}, {8850,0.01855455}, {8900,0.05790000}, {8950,0.01810000}, {9000,0.01876364}};
data["big"]["TemplateCoq"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00002727}, {3,0.00000000}, {4,0.00000000}, {5,0.00005455}, {6,0.00006364}, {7,0.00002727}, {8,0.00000000}, {9,0.00000000}, {10,0.00002727}, {11,0.00002727}, {12,0.00010909}, {13,0.00002727}, {14,0.00003636}, {15,0.00003636}, {16,0.00002727}, {17,0.00003636}, {18,0.00002727}, {19,0.00011818}, {20,0.00005455}, {21,0.00010909}, {22,0.00010000}, {23,0.00000000}, {24,0.00010000}, {25,0.00015455}, {26,0.00006364}, {27,0.00005455}, {28,0.00005455}, {29,0.00010909}, {30,0.00006364}, {31,0.00014545}, {32,0.00006364}, {33,0.00000000}, {34,0.00012727}, {35,0.00005455}, {36,0.00002727}, {37,0.00006364}, {38,0.00003636}, {39,0.00002727}, {40,0.00019091}, {41,0.00000000}, {42,0.00012727}, {43,0.00005455}, {44,0.00008182}, {45,0.00005455}, {46,0.00003636}, {47,0.00000000}, {48,0.00011818}, {49,0.00020909}, {50,0.00016364}, {51,0.00011818}, {52,0.00010000}, {53,0.00020909}, {54,0.00014545}, {55,0.00016364}, {56,0.00015455}, {57,0.00007273}, {58,0.00018182}, {59,0.00010000}, {60,0.00002727}, {61,0.00018182}, {62,0.00005455}, {63,0.00007273}, {64,0.00017273}, {65,0.00012727}, {66,0.00017273}, {67,0.00005455}, {68,0.00017273}, {69,0.00018182}, {70,0.00016364}, {71,0.00017273}, {72,0.00014545}, {73,0.00022727}, {74,0.00014545}, {75,0.00016364}, {76,0.00014545}, {77,0.00018182}, {78,0.00020909}, {79,0.00010909}, {80,0.00010909}, {81,0.00010000}, {82,0.00029091}, {83,0.00014545}, {84,0.00008182}, {85,0.00016364}, {86,0.00010000}, {87,0.00005455}, {88,0.00009091}, {89,0.00011818}, {90,0.00003636}, {91,0.00018182}, {92,0.00014545}, {93,0.00011818}, {94,0.00012727}, {95,0.00014545}, {96,0.00023636}, {97,0.00020909}, {98,0.00027273}, {99,0.00024545}, {100,0.00014545}, {101,0.00015455}, {102,0.00013636}, {103,0.00024545}, {104,0.00016364}, {105,0.00005455}, {106,0.00020909}, {107,0.00011818}, {108,0.00006364}, {109,0.00074545}, {110,0.00019091}, {111,0.00020909}, {112,0.00020000}, {113,0.00030909}, {114,0.00026364}, {115,0.00005455}, {116,0.00026364}, {117,0.00029091}, {118,0.00029091}, {119,0.00019091}, {120,0.00029091}, {121,0.00015455}, {122,0.00034545}, {123,0.00024545}, {124,0.00015455}, {125,0.00022727}, {126,0.00030000}, {127,0.00013636}, {128,0.00015455}, {129,0.00030909}, {130,0.00031818}, {131,0.00027273}, {132,0.00029091}, {133,0.00020000}, {134,0.00009091}, {135,0.00028182}, {136,0.00009091}, {137,0.00022727}, {138,0.00024545}, {139,0.00020909}, {140,0.00024545}, {141,0.00015455}, {142,0.00029091}, {143,0.00020909}, {144,0.00010909}, {145,0.00011818}, {146,0.00031818}, {147,0.00019091}, {148,0.00017273}, {149,0.00022727}, {150,0.00030909}, {151,0.00016364}, {152,0.00034545}, {153,0.00011818}, {154,0.00020909}, {155,0.00043636}, {156,0.00013636}, {157,0.00025455}, {158,0.00025455}, {159,0.00022727}, {160,0.00020909}, {161,0.00030909}, {162,0.00025455}, {163,0.00048182}, {164,0.00046364}, {165,0.00022727}, {166,0.00021818}, {167,0.00032727}, {168,0.00020000}, {169,0.00030000}, {170,0.00026364}, {171,0.00006364}, {172,0.00006364}, {173,0.00018182}, {174,0.00024545}, {175,0.00028182}, {176,0.00037273}, {177,0.00032727}, {178,0.00050909}, {179,0.00033636}, {180,0.00020909}, {181,0.00027273}, {182,0.00038182}, {183,0.00031818}, {184,0.00018182}, {185,0.00046364}, {186,0.00035455}, {187,0.00040000}, {188,0.00046364}, {189,0.00027273}, {190,0.00024545}, {191,0.00010909}, {192,0.00053636}, {193,0.00041818}, {194,0.00035455}, {195,0.00028182}, {196,0.00015455}, {197,0.00041818}, {198,0.00027273}, {199,0.00020909}, {200,0.00040909}, {201,0.00031818}, {202,0.00040000}, {203,0.00040000}, {204,0.00034545}, {205,0.00047273}, {206,0.00030000}, {207,0.00034545}, {208,0.00030909}, {209,0.00035455}, {210,0.00040000}, {211,0.00044545}, {212,0.00033636}, {213,0.00025455}, {214,0.00030909}, {215,0.00027273}, {216,0.00040000}, {217,0.00035455}, {218,0.00047273}, {219,0.00035455}, {220,0.00041818}, {221,0.00042727}, {222,0.00031818}, {223,0.00024545}, {224,0.00053636}, {225,0.00034545}, {226,0.00027273}, {227,0.00040000}, {228,0.00036364}, {229,0.00039091}, {230,0.00036364}, {231,0.00036364}, {232,0.00034545}, {233,0.00030909}, {234,0.00031818}, {235,0.00045455}, {236,0.00040909}, {237,0.00044545}, {238,0.00057273}, {239,0.00051818}, {240,0.00028182}, {241,0.00049091}, {242,0.00044545}, {243,0.00056364}, {244,0.00030000}, {245,0.00051818}, {246,0.00029091}, {247,0.00017273}, {248,0.00030909}, {249,0.00044545}, {250,0.00050000}, {251,0.00049091}, {252,0.00037273}, {253,0.00039091}, {254,0.00047273}, {255,0.00046364}, {256,0.00056364}, {257,0.00033636}, {258,0.00037273}, {259,0.00049091}, {260,0.00062727}, {261,0.00041818}, {262,0.00045455}, {263,0.00016364}, {264,0.00066364}, {265,0.00032727}, {266,0.00037273}, {267,0.00040909}, {268,0.00038182}, {269,0.00050000}, {270,0.00040909}, {271,0.00062727}, {272,0.00046364}, {273,0.00029091}, {274,0.00047273}, {275,0.00046364}, {276,0.00042727}, {277,0.00049091}, {278,0.00053636}, {279,0.00060909}, {280,0.00062727}, {281,0.00035455}, {282,0.00044545}, {283,0.00043636}, {284,0.00056364}, {285,0.00056364}, {286,0.00038182}, {287,0.00037273}, {288,0.00052727}, {289,0.00060000}, {290,0.00053636}, {291,0.00040000}, {292,0.00043636}, {293,0.00043636}, {294,0.00046364}, {295,0.00051818}, {296,0.00041818}, {297,0.00060000}, {298,0.00050909}, {299,0.00063636}, {300,0.00062727}, {301,0.00065455}, {302,0.00041818}, {303,0.00066364}, {304,0.00063636}, {305,0.00046364}, {306,0.00059091}, {307,0.00040909}, {308,0.00043636}, {309,0.00042727}, {310,0.00056364}, {311,0.00052727}, {312,0.00068182}, {313,0.00061818}, {314,0.00041818}, {315,0.00039091}, {316,0.00034545}, {317,0.00058182}, {318,0.00039091}, {319,0.00051818}, {320,0.00041818}, {321,0.00047273}, {322,0.00050909}, {323,0.00057273}, {324,0.00067273}, {325,0.00045455}, {326,0.00063636}, {327,0.00074545}, {328,0.00063636}, {329,0.00040909}, {330,0.00045455}, {331,0.00029091}, {332,0.00077273}, {333,0.00047273}, {334,0.00043636}, {335,0.00063636}, {336,0.00050909}, {337,0.00055455}, {338,0.00045455}, {339,0.00061818}, {340,0.00068182}, {341,0.00060909}, {342,0.00043636}, {343,0.00052727}, {344,0.00038182}, {345,0.00055455}, {346,0.00067273}, {347,0.00050909}, {348,0.00047273}, {349,0.00070909}, {350,0.00053636}, {351,0.00062727}, {352,0.00033636}, {353,0.00060000}, {354,0.00084545}, {355,0.00057273}, {356,0.00032727}, {357,0.00078182}, {358,0.00040909}, {359,0.00073636}, {360,0.00050000}, {361,0.00072727}, {362,0.00058182}, {363,0.00055455}, {364,0.00055455}, {365,0.00047273}, {366,0.00074545}, {367,0.00043636}, {368,0.00050909}, {369,0.00073636}, {370,0.00218182}, {371,0.00060000}, {372,0.00039091}, {373,0.00036364}, {374,0.00076364}, {375,0.00071818}, {376,0.00067273}, {377,0.00049091}, {378,0.00045455}, {379,0.00050909}, {380,0.00080000}, {381,0.00066364}, {382,0.00031818}, {383,0.00057273}, {384,0.00048182}, {385,0.00059091}, {386,0.00050909}, {387,0.00042727}, {388,0.00066364}, {389,0.00057273}, {390,0.00059091}, {391,0.00050909}, {392,0.00073636}, {393,0.00071818}, {394,0.00060000}, {395,0.00033636}, {396,0.00070909}, {397,0.00071818}, {398,0.00063636}, {399,0.00055455}, {400,0.00085455}, {401,0.00066364}, {402,0.00060000}, {403,0.00061818}, {404,0.00080909}, {405,0.00060000}, {406,0.00076364}, {407,0.00080000}, {408,0.00064545}, {409,0.00081818}, {410,0.00065455}, {411,0.00076364}, {412,0.00063636}, {413,0.00057273}, {414,0.00056364}, {415,0.00067273}, {416,0.00090000}, {417,0.00032727}, {418,0.00059091}, {419,0.00067273}, {420,0.00079091}, {421,0.00069091}, {422,0.00062727}, {423,0.00066364}, {424,0.00064545}, {425,0.00063636}, {426,0.00070000}, {427,0.00093636}, {428,0.00062727}, {429,0.00189091}, {430,0.00087273}, {431,0.00060909}, {432,0.00073636}, {433,0.00050000}, {434,0.00071818}, {435,0.00072727}, {436,0.00069091}, {437,0.00075455}, {438,0.00081818}, {439,0.00076364}, {440,0.00086364}, {441,0.00084545}, {442,0.00077273}, {443,0.00070909}, {444,0.00072727}, {445,0.00081818}, {446,0.00070000}, {447,0.00074545}, {448,0.00060000}, {449,0.00064545}, {450,0.00102727}, {451,0.00060000}, {452,0.00090000}, {453,0.00058182}, {454,0.00051818}, {455,0.00059091}, {456,0.00086364}, {457,0.00069091}, {458,0.00061818}, {459,0.00075455}, {460,0.00081818}, {461,0.00065455}, {462,0.00068182}, {463,0.00062727}, {464,0.00077273}, {465,0.00057273}, {466,0.00070000}, {467,0.00066364}, {468,0.00071818}, {469,0.00089091}, {470,0.00088182}, {471,0.00093636}, {472,0.00078182}, {473,0.00065455}, {474,0.00059091}, {475,0.00073636}, {476,0.00084545}, {477,0.00066364}, {478,0.00081818}, {479,0.00067273}, {480,0.00078182}, {481,0.00103636}, {482,0.00076364}, {483,0.00083636}, {484,0.00079091}, {485,0.00076364}, {486,0.00085455}, {487,0.00071818}, {488,0.00077273}, {489,0.00079091}, {490,0.00068182}, {491,0.00076364}, {492,0.00099091}, {493,0.00099091}, {494,0.00086364}, {495,0.00061818}, {496,0.00098182}, {497,0.00072727}, {498,0.00080000}, {499,0.00070909}, {500,0.00080000}, {505,0.00065455}, {510,0.00066364}, {515,0.00075455}, {520,0.00081818}, {525,0.00066364}, {530,0.00111818}, {535,0.00090909}, {540,0.00061818}, {545,0.00090909}, {550,0.00071818}, {555,0.00082727}, {560,0.00094545}, {565,0.00108182}, {570,0.00085455}, {575,0.00084545}, {580,0.00097273}, {585,0.00106364}, {590,0.00100000}, {595,0.00105455}, {600,0.00118182}, {605,0.00096364}, {610,0.00091818}, {615,0.00110000}, {620,0.00123636}, {625,0.00090909}, {630,0.00095455}, {635,0.00077273}, {640,0.00091818}, {645,0.00089091}, {650,0.00092727}, {655,0.00100909}, {660,0.00097273}, {665,0.00213636}, {670,0.00109091}, {675,0.00110909}, {680,0.00099091}, {685,0.00097273}, {690,0.00113636}, {695,0.00114545}, {700,0.00238182}, {705,0.00104545}, {710,0.00095455}, {715,0.00129091}, {720,0.00132727}, {725,0.00119091}, {730,0.00143636}, {735,0.00125455}, {740,0.00141818}, {745,0.00101818}, {750,0.00158182}, {755,0.00130909}, {760,0.00120000}, {765,0.00119091}, {770,0.00137273}, {775,0.00130909}, {780,0.00129091}, {785,0.00139091}, {790,0.00140909}, {795,0.00133636}, {800,0.00150909}, {805,0.00150909}, {810,0.00152727}, {815,0.00124545}, {820,0.00147273}, {825,0.00157273}, {830,0.00140909}, {835,0.00149091}, {840,0.00134545}, {845,0.00163636}, {850,0.00158182}, {855,0.00131818}, {860,0.00147273}, {865,0.00160000}, {870,0.00090909}, {875,0.00137273}, {880,0.00137273}, {885,0.00121818}, {890,0.00138182}, {895,0.01316364}, {900,0.00161818}, {905,0.00147273}, {910,0.00162727}, {915,0.00979091}, {920,0.00132727}, {925,0.00149091}, {930,0.00144545}, {935,0.00162727}, {940,0.00170909}, {945,0.00202727}, {950,0.00171818}, {955,0.00144545}, {960,0.00171818}, {965,0.00173636}, {970,0.00142727}, {975,0.00177273}, {980,0.00175455}, {985,0.00168182}, {990,0.00147273}, {995,0.00191818}, {1000,0.00178182}, {1010,0.00152727}, {1020,0.00165455}, {1030,0.00190909}, {1040,0.00176364}, {1050,0.00164545}, {1060,0.00187273}, {1070,0.00179091}, {1080,0.00157273}, {1090,0.00169091}, {1100,0.00188182}, {1110,0.00192727}, {1120,0.00197273}, {1130,0.00199091}, {1140,0.00185455}, {1150,0.00806364}, {1160,0.00193636}, {1170,0.00174545}, {1180,0.00187273}, {1190,0.00194545}, {1200,0.00174545}, {1210,0.00215455}, {1220,0.00200909}, {1230,0.00203636}, {1240,0.00185455}, {1250,0.00195455}, {1260,0.00650000}, {1270,0.00185455}, {1280,0.00228182}, {1290,0.00209091}, {1300,0.00200909}, {1310,0.00227273}, {1320,0.00221818}, {1330,0.00198182}, {1340,0.00213636}, {1350,0.00233636}, {1360,0.00222727}, {1370,0.00551818}, {1380,0.00233636}, {1390,0.00190909}, {1400,0.00228182}, {1410,0.00231818}, {1420,0.00224545}, {1430,0.00245455}, {1440,0.00259091}, {1450,0.00221818}, {1460,0.00264545}, {1470,0.00233636}, {1480,0.00428182}, {1490,0.00230000}, {1500,0.00222727}, {1510,0.00239091}, {1520,0.00854545}, {1530,0.00267273}, {1540,0.00254545}, {1550,0.00247273}, {1560,0.00230909}, {1570,0.00281818}, {1580,0.00292727}, {1590,0.00397273}, {1600,0.00259091}, {1610,0.00296364}, {1620,0.00485455}, {1630,0.00280000}, {1640,0.00295455}, {1650,0.00281818}, {1660,0.00278182}, {1670,0.00285455}, {1680,0.00279091}, {1690,0.00276364}, {1700,0.00280909}, {1710,0.00285455}, {1720,0.00292727}, {1730,0.00298182}, {1740,0.00297273}, {1750,0.00292727}, {1760,0.00287273}, {1770,0.00279091}, {1780,0.00316364}, {1790,0.00289091}, {1800,0.00297273}, {1810,0.00312727}, {1820,0.00305455}, {1830,0.00312727}, {1840,0.00316364}, {1850,0.00319091}, {1860,0.00305455}, {1870,0.00314545}, {1880,0.00330000}, {1890,0.00317273}, {1900,0.00330000}, {1910,0.00325455}, {1920,0.00328182}, {1930,0.00313636}, {1940,0.00319091}, {1950,0.00329091}, {1960,0.00334545}, {1970,0.00326364}, {1980,0.00337273}, {1990,0.00315455}, {2000,0.00339091}, {2050,0.00360000}, {2100,0.00365455}, {2150,0.00382727}, {2200,0.00384545}, {2250,0.00388182}, {2300,0.00428182}, {2350,0.00397273}, {2400,0.00420000}, {2450,0.00450000}, {2500,0.00424545}, {2550,0.00449091}, {2600,0.00469091}, {2650,0.00481818}, {2700,0.00480909}, {2750,0.00525455}, {2800,0.00562727}, {2850,0.00501818}, {2900,0.00550000}, {2950,0.00555455}, {3000,0.00539091}, {3050,0.00597273}, {3100,0.00584545}, {3150,0.00617273}, {3200,0.00603636}, {3250,0.01340000}, {3300,0.00620000}, {3350,0.00663636}, {3400,0.00664545}, {3450,0.00981818}, {3500,0.00685455}, {3550,0.00694545}, {3600,0.00706364}, {3650,0.00717273}, {3700,0.00730000}, {3750,0.00731818}, {3800,0.00746364}, {3850,0.00743636}, {3900,0.00780000}, {3950,0.00778182}, {4000,0.00800000}, {4050,0.00787273}, {4100,0.00857273}, {4150,0.00845455}, {4200,0.00850909}, {4250,0.00815455}, {4300,0.00890909}, {4350,0.00862727}, {4400,0.00897273}, {4450,0.00898182}, {4500,0.00889091}, {4550,0.00901818}, {4600,0.00932727}, {4650,0.00961818}, {4700,0.04710000}, {4750,0.00940000}, {4800,0.00965455}, {4850,0.01030909}, {4900,0.00978182}, {4950,0.01029091}, {5000,0.04633636}, {5050,0.01001818}, {5100,0.01050000}, {5150,0.01069091}, {5200,0.01111818}, {5250,0.03279091}, {5300,0.01059091}, {5350,0.01083636}, {5400,0.01148182}, {5450,0.01164545}, {5500,0.01137273}, {5550,0.01165455}, {5600,0.01133636}, {5650,0.03850000}, {5700,0.01231818}, {5750,0.01190000}, {5800,0.01203636}, {5850,0.04087273}, {5900,0.01213636}, {5950,0.01271818}, {6000,0.01240909}, {6050,0.01261818}, {6100,0.01250909}, {6150,0.01320909}, {6200,0.01330909}, {6250,0.01272727}, {6300,0.03398182}, {6350,0.01294545}, {6400,0.01315455}, {6450,0.01342727}, {6500,0.01324545}, {6550,0.01311818}, {6600,0.04423636}, {6650,0.01360909}, {6700,0.01369091}, {6750,0.01382727}, {6800,0.02909091}, {6850,0.01464545}, {6900,0.01380909}, {6950,0.03423636}, {7000,0.01443636}, {7050,0.01416364}, {7100,0.01431818}, {7150,0.01411818}, {7200,0.01441818}, {7250,0.01430909}, {7300,0.01470000}, {7350,0.01490909}, {7400,0.01491818}, {7450,0.01503636}, {7500,0.01489091}, {7550,0.01547273}, {7600,0.03814545}, {7650,0.01521818}, {7700,0.01600909}, {7750,0.03751818}, {7800,0.01576364}, {7850,0.01591818}, {7900,0.01577273}, {7950,0.05298182}, {8000,0.01630000}, {8050,0.02951818}, {8100,0.01614545}, {8150,0.01638182}, {8200,0.01611818}, {8250,0.04250000}, {8300,0.01692727}, {8350,0.01749091}, {8400,0.01752727}, {8450,0.01676364}, {8500,0.01720000}, {8550,0.01730909}, {8600,0.01808182}, {8650,0.01760000}, {8700,0.06008182}, {8750,0.02676364}, {8800,0.01807273}, {8850,0.01846364}, {8900,0.05812727}, {8950,0.01800000}, {9000,0.01847273}};
data["big"]["TemplateCoq"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00003636}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00003636}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00003636}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00003636}, {57,0.00000000}, {58,0.00003636}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00006364}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00003636}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00003636}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00003636}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00002727}, {160,0.00000000}, {161,0.00000000}, {162,0.00003636}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00003636}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00003636}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00003636}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00002727}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00003636}, {212,0.00003636}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00003636}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00003636}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00003636}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00003636}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00003636}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00003636}, {261,0.00003636}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00003636}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00003636}, {328,0.00000000}, {329,0.00000000}, {330,0.00003636}, {331,0.00000000}, {332,0.00000000}, {333,0.00003636}, {334,0.00003636}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00003636}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00003636}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00003636}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00003636}, {374,0.00000000}, {375,0.00003636}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00003636}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00003636}, {409,0.00000000}, {410,0.00003636}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00003636}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00003636}, {431,0.00007273}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00003636}, {439,0.00000000}, {440,0.00003636}, {441,0.00003636}, {442,0.00000000}, {443,0.00007273}, {444,0.00000000}, {445,0.00000000}, {446,0.00003636}, {447,0.00003636}, {448,0.00000000}, {449,0.00003636}, {450,0.00000000}, {451,0.00003636}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00003636}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00003636}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00003636}, {484,0.00003636}, {485,0.00000000}, {486,0.00003636}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00006364}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00003636}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00003636}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00003636}, {610,0.00000000}, {615,0.00000000}, {620,0.00003636}, {625,0.00003636}, {630,0.00003636}, {635,0.00000000}, {640,0.00003636}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00003636}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00007273}, {720,0.00003636}, {725,0.00000000}, {730,0.00007273}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00003636}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00003636}, {785,0.00000000}, {790,0.00003636}, {795,0.00000000}, {800,0.00003636}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00003636}, {845,0.00000000}, {850,0.00003636}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00003636}, {875,0.00000000}, {880,0.00003636}, {885,0.00003636}, {890,0.00000000}, {895,0.00003636}, {900,0.00000000}, {905,0.00000000}, {910,0.00003636}, {915,0.00003636}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00003636}, {945,0.00000000}, {950,0.00000000}, {955,0.00003636}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00003636}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00003636}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00006364}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00003636}, {1210,0.00003636}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00002727}, {1280,0.00003636}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00007273}, {1340,0.00000000}, {1350,0.00002727}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00003636}, {1410,0.00000000}, {1420,0.00003636}, {1430,0.00000000}, {1440,0.00003636}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00003636}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00003636}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00003636}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00003636}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00002727}, {1820,0.00002727}, {1830,0.00003636}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00003636}, {1870,0.00000000}, {1880,0.00003636}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00003636}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00003636}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00003636}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00003636}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00003636}, {4600,0.00003636}, {4650,0.00000000}, {4700,0.00014545}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00014545}, {5050,0.00000000}, {5100,0.00007273}, {5150,0.00003636}, {5200,0.00003636}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00003636}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00003636}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00007273}, {5700,0.00003636}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00003636}, {5900,0.00000000}, {5950,0.00003636}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00003636}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00007273}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00003636}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00003636}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00003636}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00010000}, {8250,0.00003636}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00003636}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00003636}, {8750,0.00007273}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}};
data["big"]["TemplateCoq"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00005455}, {37,0.00003636}, {38,0.00005455}, {39,0.00020000}, {40,0.00055455}, {41,0.00087273}, {42,0.00099091}, {43,0.00100000}, {44,0.00100000}, {45,0.00100000}, {46,0.00100000}, {47,0.00100000}, {48,0.00100000}, {49,0.00100000}, {50,0.00100000}, {51,0.00100000}, {52,0.00101818}, {53,0.00100000}, {54,0.00100000}, {55,0.00100000}, {56,0.00100000}, {57,0.00246364}, {58,0.00100000}, {59,0.00100000}, {60,0.00100000}, {61,0.00100000}, {62,0.00100000}, {63,0.00100000}, {64,0.00100000}, {65,0.00100000}, {66,0.00100000}, {67,0.00100000}, {68,0.00100000}, {69,0.00100000}, {70,0.00100000}, {71,0.00100000}, {72,0.00100000}, {73,0.00267273}, {74,0.00100000}, {75,0.00103636}, {76,0.00111818}, {77,0.00122727}, {78,0.00146364}, {79,0.00158182}, {80,0.00179091}, {81,0.00189091}, {82,0.00197273}, {83,0.00199091}, {84,0.00200000}, {85,0.00200000}, {86,0.00200000}, {87,0.00200000}, {88,0.00200000}, {89,0.00200000}, {90,0.00200000}, {91,0.00200000}, {92,0.00200000}, {93,0.00200000}, {94,0.00200000}, {95,0.00200000}, {96,0.00200000}, {97,0.00200000}, {98,0.00299091}, {99,0.00200000}, {100,0.00200000}, {101,0.00200000}, {102,0.00200000}, {103,0.00200000}, {104,0.00200000}, {105,0.00200000}, {106,0.00200000}, {107,0.00200000}, {108,0.00200000}, {109,0.00200000}, {110,0.00200000}, {111,0.00200000}, {112,0.00201818}, {113,0.00200909}, {114,0.00209091}, {115,0.00210909}, {116,0.00223636}, {117,0.00240909}, {118,0.00477273}, {119,0.00271818}, {120,0.00282727}, {121,0.00285455}, {122,0.00294545}, {123,0.00299091}, {124,0.00300000}, {125,0.00299091}, {126,0.00300000}, {127,0.00568182}, {128,0.00300000}, {129,0.00300000}, {130,0.00300000}, {131,0.00300000}, {132,0.00300000}, {133,0.00300000}, {134,0.00300000}, {135,0.00300000}, {136,0.00300000}, {137,0.00300000}, {138,0.00300000}, {139,0.00300000}, {140,0.00300000}, {141,0.00300000}, {142,0.00300000}, {143,0.00300000}, {144,0.00300000}, {145,0.00300000}, {146,0.00300000}, {147,0.00300000}, {148,0.00300000}, {149,0.00302727}, {150,0.00300909}, {151,0.00300000}, {152,0.00301818}, {153,0.00305455}, {154,0.00316364}, {155,0.00320000}, {156,0.00325455}, {157,0.00339091}, {158,0.00357273}, {159,0.00301818}, {160,0.00371818}, {161,0.00383636}, {162,0.00390000}, {163,0.00391818}, {164,0.00396364}, {165,0.00399091}, {166,0.00376364}, {167,0.00400000}, {168,0.00399091}, {169,0.00400000}, {170,0.00400000}, {171,0.00400000}, {172,0.00772727}, {173,0.00400000}, {174,0.00400000}, {175,0.00400000}, {176,0.00400000}, {177,0.00402727}, {178,0.00400000}, {179,0.00400000}, {180,0.00400000}, {181,0.00400000}, {182,0.00400000}, {183,0.00405455}, {184,0.00400000}, {185,0.00584545}, {186,0.00400000}, {187,0.00400000}, {188,0.00400000}, {189,0.00400909}, {190,0.00405455}, {191,0.00600000}, {192,0.00407273}, {193,0.00406364}, {194,0.00420000}, {195,0.00429091}, {196,0.00436364}, {197,0.00598182}, {198,0.00462727}, {199,0.00469091}, {200,0.00471818}, {201,0.00481818}, {202,0.00481818}, {203,0.00406364}, {204,0.00494545}, {205,0.00493636}, {206,0.00496364}, {207,0.00497273}, {208,0.00953636}, {209,0.00500000}, {210,0.00500000}, {211,0.00500000}, {212,0.00502727}, {213,0.00500000}, {214,0.00485455}, {215,0.00500000}, {216,0.00500000}, {217,0.00500000}, {218,0.00500000}, {219,0.00689091}, {220,0.00500000}, {221,0.00500000}, {222,0.00500000}, {223,0.00500000}, {224,0.00874545}, {225,0.00500000}, {226,0.00500000}, {227,0.00501818}, {228,0.00503636}, {229,0.00502727}, {230,0.00503636}, {231,0.00504545}, {232,0.00504545}, {233,0.00512727}, {234,0.01064545}, {235,0.00524545}, {236,0.00530909}, {237,0.00541818}, {238,0.00553636}, {239,0.00788182}, {240,0.00572727}, {241,0.00578182}, {242,0.00581818}, {243,0.00580000}, {244,0.00912727}, {245,0.00588182}, {246,0.00590909}, {247,0.00605455}, {248,0.00597273}, {249,0.00530000}, {250,0.00600000}, {251,0.00600000}, {252,0.00602727}, {253,0.01071818}, {254,0.00600000}, {255,0.00600000}, {256,0.00600000}, {257,0.00600000}, {258,0.00594545}, {259,0.00600000}, {260,0.00600000}, {261,0.00603636}, {262,0.01077273}, {263,0.00600000}, {264,0.00600000}, {265,0.00600000}, {266,0.00600909}, {267,0.00600000}, {268,0.00603636}, {269,0.00601818}, {270,0.00602727}, {271,0.00827273}, {272,0.00610909}, {273,0.00614545}, {274,0.00626364}, {275,0.01051818}, {276,0.00638182}, {277,0.00647273}, {278,0.00661818}, {279,0.00666364}, {280,0.00670909}, {281,0.00677273}, {282,0.00675455}, {283,0.00679091}, {284,0.00676364}, {285,0.00684545}, {286,0.00687273}, {287,0.00690000}, {288,0.00608182}, {289,0.00695455}, {290,0.00700000}, {291,0.00698182}, {292,0.00646364}, {293,0.00700000}, {294,0.00700000}, {295,0.00700000}, {296,0.00673636}, {297,0.00700000}, {298,0.00700000}, {299,0.00700000}, {300,0.00700000}, {301,0.00700000}, {302,0.00710909}, {303,0.00700000}, {304,0.00700000}, {305,0.00700909}, {306,0.00706364}, {307,0.01163636}, {308,0.00708182}, {309,0.00701818}, {310,0.00707273}, {311,0.01081818}, {312,0.00711818}, {313,0.00719091}, {314,0.00724545}, {315,0.00700909}, {316,0.00730909}, {317,0.00738182}, {318,0.00752727}, {319,0.00765455}, {320,0.00769091}, {321,0.00771818}, {322,0.01040909}, {323,0.00776364}, {324,0.00780909}, {325,0.00780909}, {326,0.00703636}, {327,0.00790000}, {328,0.00799091}, {329,0.01333636}, {330,0.00791818}, {331,0.00799091}, {332,0.00796364}, {333,0.00731818}, {334,0.00800000}, {335,0.00811818}, {336,0.01479091}, {337,0.00800000}, {338,0.00800000}, {339,0.00799091}, {340,0.00781818}, {341,0.00800000}, {342,0.00806364}, {343,0.01151818}, {344,0.00800000}, {345,0.00800000}, {346,0.00801818}, {347,0.00795455}, {348,0.00806364}, {349,0.00810000}, {350,0.01069091}, {351,0.00810000}, {352,0.00811818}, {353,0.01546364}, {354,0.00820909}, {355,0.00827273}, {356,0.00831818}, {357,0.00800909}, {358,0.00850909}, {359,0.00863636}, {360,0.00800909}, {361,0.00870000}, {362,0.00878182}, {363,0.01172727}, {364,0.00878182}, {365,0.00875455}, {366,0.00879091}, {367,0.00885455}, {368,0.00890909}, {369,0.00889091}, {370,0.00892727}, {371,0.00893636}, {372,0.00894545}, {373,0.00819091}, {374,0.00898182}, {375,0.00903636}, {376,0.00840909}, {377,0.00900000}, {378,0.00905455}, {379,0.01164545}, {380,0.00900000}, {381,0.00907273}, {382,0.01190000}, {383,0.00901818}, {384,0.00910000}, {385,0.01245455}, {386,0.00901818}, {387,0.00918182}, {388,0.01268182}, {389,0.00909091}, {390,0.00926364}, {391,0.01282727}, {392,0.00917273}, {393,0.00931818}, {394,0.01290909}, {395,0.00932727}, {396,0.00950909}, {397,0.01280909}, {398,0.00962727}, {399,0.00974545}, {400,0.01272727}, {401,0.00970000}, {402,0.00983636}, {403,0.01267273}, {404,0.00973636}, {405,0.00980909}, {406,0.01226364}, {407,0.00980909}, {408,0.00984545}, {409,0.00906364}, {410,0.00990000}, {411,0.00986364}, {412,0.00909091}, {413,0.00995455}, {414,0.00996364}, {415,0.00999091}, {416,0.01000000}, {417,0.01000909}, {418,0.01000000}, {419,0.01000909}, {420,0.01366364}, {421,0.01001818}, {422,0.05119091}, {423,0.01618182}, {424,0.01001818}, {425,0.01011818}, {426,0.00981818}, {427,0.01004545}, {428,0.01005455}, {429,0.01007273}, {430,0.01007273}, {431,0.01808182}, {432,0.01020909}, {433,0.01034545}, {434,0.01483636}, {435,0.01039091}, {436,0.01062727}, {437,0.00999091}, {438,0.01054545}, {439,0.01060000}, {440,0.01065455}, {441,0.01092727}, {442,0.01442727}, {443,0.01076364}, {444,0.01087273}, {445,0.01001818}, {446,0.01080909}, {447,0.01077273}, {448,0.01083636}, {449,0.01103636}, {450,0.84401818}, {451,0.01088182}, {452,0.01088182}, {453,0.01007273}, {454,0.01092727}, {455,0.01755455}, {456,0.01098182}, {457,0.01109091}, {458,0.01023636}, {459,0.01100000}, {460,0.01100000}, {461,0.01100909}, {462,0.01110909}, {463,0.01483636}, {464,0.01100909}, {465,0.01102727}, {466,0.01103636}, {467,0.01122727}, {468,0.01511818}, {469,0.01109091}, {470,0.01112727}, {471,0.01121818}, {472,0.01120000}, {473,0.01532727}, {474,0.01134545}, {475,0.01137273}, {476,0.01144545}, {477,0.01165455}, {478,0.01532727}, {479,0.01161818}, {480,0.01161818}, {481,0.01168182}, {482,0.01182727}, {483,0.01529091}, {484,0.01174545}, {485,0.01175455}, {486,0.01179091}, {487,0.01185455}, {488,0.01101818}, {489,0.01183636}, {490,0.01959091}, {491,0.01181818}, {492,0.01194545}, {493,0.01105455}, {494,0.01190000}, {495,0.01590000}, {496,0.01195455}, {497,0.01195455}, {498,0.01198182}, {499,0.01206364}, {500,0.01134545}, {505,0.01205455}, {510,0.01663636}, {515,0.01241818}, {520,0.01257273}, {525,0.01274545}, {530,0.01291818}, {535,0.01205455}, {540,0.01310909}, {545,0.01249091}, {550,0.01310909}, {555,0.01742727}, {560,0.01357273}, {565,0.01850000}, {570,0.01380909}, {575,0.02120000}, {580,0.01400000}, {585,0.02703636}, {590,0.01417273}, {595,0.02678182}, {600,0.01465455}, {605,0.02545455}, {610,0.01480000}, {615,0.02292727}, {620,0.01500000}, {625,0.02423636}, {630,0.01513636}, {635,0.01959091}, {640,0.01561818}, {645,0.01482727}, {650,0.01592727}, {655,0.01500000}, {660,0.01606364}, {665,0.01600909}, {670,0.03162727}, {675,0.01637273}, {680,0.02405455}, {685,0.01690000}, {690,0.01589091}, {695,0.01693636}, {700,0.01690000}, {705,0.02514545}, {710,0.01719091}, {715,0.01651818}, {720,0.01767273}, {725,0.01770000}, {730,0.02270000}, {735,0.01780909}, {740,0.01700000}, {745,0.01810000}, {750,0.01812727}, {755,0.02366364}, {760,0.01871818}, {765,0.01810909}, {770,0.02492727}, {775,0.01895455}, {780,0.01790000}, {785,0.02517273}, {790,0.01945455}, {795,0.01837273}, {800,0.02610000}, {805,0.01987273}, {810,0.01876364}, {815,0.02666364}, {820,0.01993636}, {825,0.01896364}, {830,0.02777273}, {835,0.02046364}, {840,0.02055455}, {845,0.02632727}, {850,0.04115455}, {855,0.02112727}, {860,0.01981818}, {865,0.02880000}, {870,0.02123636}, {875,0.02136364}, {880,0.02028182}, {885,0.02962727}, {890,0.02186364}, {895,0.02180000}, {900,0.02078182}, {905,0.02889091}, {910,0.02222727}, {915,0.02240909}, {920,0.02125455}, {925,0.02948182}, {930,0.02283636}, {935,0.02313636}, {940,0.02178182}, {945,0.02842727}, {950,0.03157273}, {955,0.02352727}, {960,0.02359091}, {965,0.02236364}, {970,0.02916364}, {975,0.03164545}, {980,0.02400909}, {985,0.02418182}, {990,0.02280000}, {995,0.02292727}, {1000,0.03269091}, {1010,0.03541818}, {1020,0.02494545}, {1030,0.02522727}, {1040,0.02537273}, {1050,0.02420909}, {1060,0.02470909}, {1070,0.03244545}, {1080,0.03408182}, {1090,0.03570909}, {1100,0.04460909}, {1110,0.02726364}, {1120,0.02765455}, {1130,0.02787273}, {1140,0.02808182}, {1150,0.02857273}, {1160,0.02806364}, {1170,0.02708182}, {1180,0.02739091}, {1190,0.02772727}, {1200,0.02783636}, {1210,0.02805455}, {1220,0.02836364}, {1230,0.02918182}, {1240,0.02925455}, {1250,0.03034545}, {1260,0.03115455}, {1270,0.03138182}, {1280,0.03150909}, {1290,0.05466364}, {1300,0.04770909}, {1310,0.05071818}, {1320,0.04128182}, {1330,0.04037273}, {1340,0.03094545}, {1350,0.03133636}, {1360,0.03204545}, {1370,0.03396364}, {1380,0.05427273}, {1390,0.04999091}, {1400,0.04303636}, {1410,0.03280909}, {1420,0.03342727}, {1430,0.03540000}, {1440,0.04928182}, {1450,0.05484545}, {1460,0.03391818}, {1470,0.03465455}, {1480,0.06693636}, {1490,0.04922727}, {1500,0.04608182}, {1510,0.03564545}, {1520,0.06700000}, {1530,0.05050909}, {1540,0.03579091}, {1550,0.03626364}, {1560,0.05390909}, {1570,0.05861818}, {1580,0.03726364}, {1590,0.06050000}, {1600,0.05610909}, {1610,0.03793636}, {1620,0.06139091}, {1630,0.05769091}, {1640,0.03862727}, {1650,0.05361818}, {1660,0.06332727}, {1670,0.03913636}, {1680,0.05375455}, {1690,0.03967273}, {1700,0.05384545}, {1710,0.06324545}, {1720,0.06306364}, {1730,0.05509091}, {1740,0.04076364}, {1750,0.05656364}, {1760,0.04130000}, {1770,0.05780000}, {1780,0.04183636}, {1790,0.06000909}, {1800,0.04246364}, {1810,0.06000000}, {1820,0.04282727}, {1830,0.05915455}, {1840,0.04320909}, {1850,0.05914545}, {1860,0.04350909}, {1870,0.05894545}, {1880,0.06812727}, {1890,0.06070909}, {1900,0.05400000}, {1910,0.04500000}, {1920,0.06090909}, {1930,0.04507273}, {1940,0.05967273}, {1950,0.05448182}, {1960,0.04607273}, {1970,0.06199091}, {1980,0.07158182}, {1990,0.06823636}, {2000,0.06575455}, {2050,0.06819091}, {2100,0.04921818}, {2150,0.06632727}, {2200,0.06461818}, {2250,0.05586364}, {2300,0.06785455}, {2350,0.07370909}, {2400,0.07730000}, {2450,0.07625455}, {2500,0.06958182}, {2550,0.06340000}, {2600,0.06381818}, {2650,0.07160000}, {2700,0.08034545}, {2750,0.08323636}, {2800,0.06873636}, {2850,0.08213636}, {2900,0.08050909}, {2950,0.07150909}, {3000,0.09432727}, {3050,0.07398182}, {3100,0.08731818}, {3150,0.07576364}, {3200,0.07894545}, {3250,0.10083636}, {3300,0.07917273}, {3350,0.08263636}, {3400,0.08413636}, {3450,0.08768182}, {3500,0.11955455}, {3550,0.11980909}, {3600,0.11835455}, {3650,0.11802727}, {3700,0.11369091}, {3750,0.11173636}, {3800,0.09473636}, {3850,0.09477273}, {3900,0.09513636}, {3950,0.13409091}, {4000,0.09502727}, {4050,0.09969091}, {4100,0.13300909}, {4150,0.10277273}, {4200,0.15173636}, {4250,0.10579091}, {4300,0.14426364}, {4350,0.10812727}, {4400,0.11771818}, {4450,0.16111818}, {4500,0.11180909}, {4550,0.11343636}, {4600,0.13086364}, {4650,0.15318182}, {4700,0.17025455}, {4750,0.18032727}, {4800,0.18888182}, {4850,0.19056364}, {4900,0.18380909}, {4950,0.17440909}, {5000,0.16100000}, {5050,0.13912727}, {5100,0.12742727}, {5150,0.12777273}, {5200,0.17385455}, {5250,0.13326364}, {5300,0.13151818}, {5350,0.16187273}, {5400,0.13503636}, {5450,0.16981818}, {5500,0.13723636}, {5550,0.15649091}, {5600,0.20690909}, {5650,0.14206364}, {5700,0.16165455}, {5750,0.19593636}, {5800,0.22540909}, {5850,0.14684545}, {5900,0.14939091}, {5950,0.14919091}, {6000,0.15580909}, {6050,0.15860909}, {6100,0.15462727}, {6150,0.15598182}, {6200,0.15603636}, {6250,0.23539091}, {6300,0.21674545}, {6350,0.18781818}, {6400,0.16218182}, {6450,0.24145455}, {6500,0.19336364}, {6550,0.16472727}, {6600,0.21584545}, {6650,0.16802727}, {6700,0.21511818}, {6750,0.27590000}, {6800,0.19374545}, {6850,0.23873636}, {6900,0.17344545}, {6950,0.18777273}, {7000,0.21711818}, {7050,0.24139091}, {7100,0.25748182}, {7150,0.27124545}, {7200,0.27888182}, {7250,0.28635455}, {7300,0.28292727}, {7350,0.27642727}, {7400,0.26406364}, {7450,0.24550000}, {7500,0.22410909}, {7550,0.19387273}, {7600,0.28808182}, {7650,0.24886364}, {7700,0.20571818}, {7750,0.28353636}, {7800,0.22910909}, {7850,0.29811818}, {7900,0.22805455}, {7950,0.28572727}, {8000,0.21036364}, {8050,0.25663636}, {8100,0.29875455}, {8150,0.20690909}, {8200,0.23793636}, {8250,0.26150000}, {8300,0.28130909}, {8350,0.29346364}, {8400,0.30781818}, {8450,0.31467273}, {8500,0.31178182}, {8550,0.29752727}, {8600,0.29481818}, {8650,0.28060909}, {8700,0.25169091}, {8750,0.35083636}, {8800,0.32334545}, {8850,0.28266364}, {8900,0.24048182}, {8950,0.32296364}, {9000,0.26700000}};
data["big"]["TemplateCoq"]["eval lazy"]["user"] = {{1,0.00009091}, {2,0.00002727}, {3,0.00009091}, {4,0.00010909}, {5,0.00008182}, {6,0.00027273}, {7,0.00009091}, {8,0.00024545}, {9,0.00024545}, {10,0.00023636}, {11,0.00020000}, {12,0.00026364}, {13,0.00039091}, {14,0.00040909}, {15,0.00036364}, {16,0.00033636}, {17,0.00039091}, {18,0.00042727}, {19,0.00037273}, {20,0.00048182}, {21,0.00040909}, {22,0.00040909}, {23,0.00071818}, {24,0.00044545}, {25,0.00048182}, {26,0.00062727}, {27,0.00061818}, {28,0.00060000}, {29,0.00052727}, {30,0.00097273}, {31,0.00072727}, {32,0.00031818}, {33,0.00088182}, {34,0.00051818}, {35,0.00063636}, {36,0.00108182}, {37,0.00070909}, {38,0.00068182}, {39,0.00105455}, {40,0.00120000}, {41,0.00096364}, {42,0.00083636}, {43,0.00092727}, {44,0.00091818}, {45,0.00096364}, {46,0.00100909}, {47,0.00094545}, {48,0.00098182}, {49,0.00113636}, {50,0.00090000}, {51,0.00104545}, {52,0.00090000}, {53,0.00116364}, {54,0.00133636}, {55,0.00107273}, {56,0.00090000}, {57,0.00262727}, {58,0.00110000}, {59,0.00139091}, {60,0.00096364}, {61,0.00130909}, {62,0.00148182}, {63,0.00146364}, {64,0.00110909}, {65,0.00127273}, {66,0.00162727}, {67,0.00120000}, {68,0.00125455}, {69,0.00155455}, {70,0.00139091}, {71,0.00161818}, {72,0.00151818}, {73,0.00245455}, {74,0.00150909}, {75,0.00160000}, {76,0.00142727}, {77,0.00167273}, {78,0.00169091}, {79,0.00163636}, {80,0.00164545}, {81,0.00175455}, {82,0.00180000}, {83,0.00176364}, {84,0.00180909}, {85,0.00198182}, {86,0.00163636}, {87,0.00176364}, {88,0.00214545}, {89,0.00159091}, {90,0.00174545}, {91,0.00225455}, {92,0.00187273}, {93,0.00177273}, {94,0.00195455}, {95,0.00200000}, {96,0.00204545}, {97,0.00231818}, {98,0.00307273}, {99,0.00199091}, {100,0.00193636}, {101,0.00206364}, {102,0.00232727}, {103,0.00232727}, {104,0.00230000}, {105,0.00201818}, {106,0.00196364}, {107,0.00202727}, {108,0.00208182}, {109,0.00207273}, {110,0.00194545}, {111,0.00200000}, {112,0.00207273}, {113,0.00238182}, {114,0.00260909}, {115,0.00267273}, {116,0.00265455}, {117,0.00244545}, {118,0.00480909}, {119,0.00261818}, {120,0.00256364}, {121,0.00280000}, {122,0.00240909}, {123,0.00259091}, {124,0.00273636}, {125,0.00279091}, {126,0.00231818}, {127,0.00537273}, {128,0.00253636}, {129,0.00278182}, {130,0.00279091}, {131,0.00280909}, {132,0.00288182}, {133,0.00270000}, {134,0.00302727}, {135,0.00290000}, {136,0.00289091}, {137,0.00273636}, {138,0.00288182}, {139,0.00297273}, {140,0.00303636}, {141,0.00273636}, {142,0.00301818}, {143,0.00278182}, {144,0.00273636}, {145,0.00310000}, {146,0.00304545}, {147,0.00326364}, {148,0.00300909}, {149,0.00316364}, {150,0.00326364}, {151,0.00322727}, {152,0.00320000}, {153,0.00320000}, {154,0.00327273}, {155,0.00326364}, {156,0.00326364}, {157,0.00344545}, {158,0.00328182}, {159,0.00309091}, {160,0.00332727}, {161,0.00348182}, {162,0.00345455}, {163,0.00368182}, {164,0.00369091}, {165,0.00343636}, {166,0.00362727}, {167,0.00345455}, {168,0.00366364}, {169,0.00365455}, {170,0.00370000}, {171,0.00349091}, {172,0.00791818}, {173,0.00367273}, {174,0.00380909}, {175,0.00381818}, {176,0.00391818}, {177,0.00388182}, {178,0.00370000}, {179,0.00373636}, {180,0.00394545}, {181,0.00416364}, {182,0.00409091}, {183,0.00408182}, {184,0.00412727}, {185,0.00589091}, {186,0.00434545}, {187,0.00440000}, {188,0.00397273}, {189,0.00415455}, {190,0.00382727}, {191,0.00634545}, {192,0.00438182}, {193,0.00407273}, {194,0.00415455}, {195,0.00416364}, {196,0.00428182}, {197,0.00608182}, {198,0.00427273}, {199,0.00477273}, {200,0.00439091}, {201,0.00470000}, {202,0.00458182}, {203,0.00422727}, {204,0.00462727}, {205,0.00428182}, {206,0.00450909}, {207,0.00448182}, {208,0.00986364}, {209,0.00462727}, {210,0.00460000}, {211,0.00450000}, {212,0.00518182}, {213,0.00450000}, {214,0.00429091}, {215,0.00512727}, {216,0.00485455}, {217,0.00504545}, {218,0.00519091}, {219,0.00711818}, {220,0.00516364}, {221,0.00473636}, {222,0.00514545}, {223,0.00535455}, {224,0.00892727}, {225,0.00520909}, {226,0.00532727}, {227,0.00521818}, {228,0.00516364}, {229,0.00518182}, {230,0.00503636}, {231,0.00538182}, {232,0.00540000}, {233,0.00545455}, {234,0.01124545}, {235,0.00554545}, {236,0.00537273}, {237,0.00541818}, {238,0.00534545}, {239,0.00822727}, {240,0.00555455}, {241,0.00560909}, {242,0.00537273}, {243,0.00557273}, {244,0.00936364}, {245,0.00595455}, {246,0.00610909}, {247,0.00618182}, {248,0.00582727}, {249,0.00562727}, {250,0.00605455}, {251,0.00585455}, {252,0.00576364}, {253,0.01113636}, {254,0.00601818}, {255,0.00594545}, {256,0.00609091}, {257,0.00592727}, {258,0.00561818}, {259,0.00600909}, {260,0.00606364}, {261,0.00610909}, {262,0.01130000}, {263,0.00619091}, {264,0.00606364}, {265,0.00642727}, {266,0.00612727}, {267,0.00594545}, {268,0.00607273}, {269,0.00652727}, {270,0.00609091}, {271,0.00863636}, {272,0.00632727}, {273,0.00650909}, {274,0.00667273}, {275,0.01065455}, {276,0.00650000}, {277,0.00644545}, {278,0.00669091}, {279,0.00654545}, {280,0.00671818}, {281,0.00630909}, {282,0.00677273}, {283,0.00640000}, {284,0.00630000}, {285,0.00682727}, {286,0.00683636}, {287,0.00667273}, {288,0.00629091}, {289,0.00700000}, {290,0.00685455}, {291,0.00685455}, {292,0.00680909}, {293,0.00674545}, {294,0.00712727}, {295,0.00694545}, {296,0.00670909}, {297,0.00708182}, {298,0.00682727}, {299,0.00710909}, {300,0.00730909}, {301,0.00695455}, {302,0.00761818}, {303,0.00719091}, {304,0.00721818}, {305,0.00746364}, {306,0.00721818}, {307,0.01178182}, {308,0.00733636}, {309,0.00747273}, {310,0.00737273}, {311,0.01139091}, {312,0.00765455}, {313,0.00759091}, {314,0.00742727}, {315,0.00714545}, {316,0.00748182}, {317,0.00760000}, {318,0.00760909}, {319,0.00754545}, {320,0.00762727}, {321,0.00789091}, {322,0.01054545}, {323,0.00762727}, {324,0.00765455}, {325,0.00784545}, {326,0.00750000}, {327,0.00774545}, {328,0.00798182}, {329,0.01348182}, {330,0.00792727}, {331,0.00798182}, {332,0.00832727}, {333,0.00757273}, {334,0.00802727}, {335,0.00808182}, {336,0.01465455}, {337,0.00808182}, {338,0.00814545}, {339,0.00830000}, {340,0.00780000}, {341,0.00837273}, {342,0.00798182}, {343,0.01181818}, {344,0.00827273}, {345,0.00837273}, {346,0.00841818}, {347,0.00780909}, {348,0.00826364}, {349,0.00862727}, {350,0.01110909}, {351,0.00845455}, {352,0.00866364}, {353,0.01520909}, {354,0.00857273}, {355,0.00861818}, {356,0.00828182}, {357,0.00801818}, {358,0.00867273}, {359,0.00897273}, {360,0.00828182}, {361,0.00870909}, {362,0.00915455}, {363,0.01225455}, {364,0.00874545}, {365,0.00841818}, {366,0.00841818}, {367,0.00896364}, {368,0.00874545}, {369,0.00890909}, {370,0.00885455}, {371,0.00927273}, {372,0.00927273}, {373,0.00846364}, {374,0.00886364}, {375,0.00905455}, {376,0.00847273}, {377,0.00940000}, {378,0.00952727}, {379,0.01191818}, {380,0.00894545}, {381,0.00940000}, {382,0.01244545}, {383,0.00938182}, {384,0.00931818}, {385,0.01254545}, {386,0.00961818}, {387,0.00960909}, {388,0.01308182}, {389,0.00975455}, {390,0.00990000}, {391,0.01323636}, {392,0.00974545}, {393,0.00955455}, {394,0.01321818}, {395,0.00985455}, {396,0.00975455}, {397,0.01309091}, {398,0.00973636}, {399,0.00996364}, {400,0.01297273}, {401,0.00970909}, {402,0.00990000}, {403,0.01246364}, {404,0.01001818}, {405,0.00998182}, {406,0.01241818}, {407,0.01025455}, {408,0.01010000}, {409,0.00950909}, {410,0.01015455}, {411,0.01011818}, {412,0.00987273}, {413,0.01008182}, {414,0.01033636}, {415,0.01049091}, {416,0.00994545}, {417,0.01071818}, {418,0.01032727}, {419,0.01035455}, {420,0.01390000}, {421,0.01030000}, {422,0.05189091}, {423,0.01611818}, {424,0.01048182}, {425,0.01066364}, {426,0.01006364}, {427,0.01040909}, {428,0.01030000}, {429,0.01045455}, {430,0.01047273}, {431,0.01782727}, {432,0.01087273}, {433,0.01078182}, {434,0.01488182}, {435,0.01080909}, {436,0.01102727}, {437,0.00979091}, {438,0.01067273}, {439,0.01070000}, {440,0.01102727}, {441,0.01120000}, {442,0.01433636}, {443,0.01100000}, {444,0.01136364}, {445,0.01029091}, {446,0.01128182}, {447,0.01141818}, {448,0.01111818}, {449,0.01135455}, {450,0.84302727}, {451,0.01147273}, {452,0.01150000}, {453,0.01047273}, {454,0.01080000}, {455,0.01773636}, {456,0.01149091}, {457,0.01147273}, {458,0.01091818}, {459,0.01156364}, {460,0.01149091}, {461,0.01153636}, {462,0.01163636}, {463,0.01463636}, {464,0.01160909}, {465,0.01169091}, {466,0.01141818}, {467,0.01150000}, {468,0.01511818}, {469,0.01177273}, {470,0.01172727}, {471,0.01180909}, {472,0.01180000}, {473,0.01528182}, {474,0.01179091}, {475,0.01183636}, {476,0.01187273}, {477,0.01193636}, {478,0.01545455}, {479,0.01184545}, {480,0.01198182}, {481,0.01208182}, {482,0.01214545}, {483,0.01534545}, {484,0.01203636}, {485,0.01211818}, {486,0.01217273}, {487,0.01221818}, {488,0.01163636}, {489,0.01213636}, {490,0.01972727}, {491,0.01226364}, {492,0.01234545}, {493,0.01170000}, {494,0.01227273}, {495,0.01578182}, {496,0.01230909}, {497,0.01229091}, {498,0.01247273}, {499,0.01254545}, {500,0.01180000}, {505,0.01236364}, {510,0.01611818}, {515,0.01270909}, {520,0.01265455}, {525,0.01274545}, {530,0.01310000}, {535,0.01248182}, {540,0.01333636}, {545,0.01276364}, {550,0.01346364}, {555,0.01713636}, {560,0.01362727}, {565,0.01823636}, {570,0.01389091}, {575,0.02134545}, {580,0.01407273}, {585,0.02711818}, {590,0.01425455}, {595,0.02657273}, {600,0.01435455}, {605,0.02570000}, {610,0.01480000}, {615,0.02312727}, {620,0.01489091}, {625,0.02440000}, {630,0.01514545}, {635,0.01998182}, {640,0.01541818}, {645,0.01464545}, {650,0.01576364}, {655,0.01490909}, {660,0.01588182}, {665,0.01607273}, {670,0.03166364}, {675,0.01610909}, {680,0.02430000}, {685,0.01646364}, {690,0.01582727}, {695,0.01667273}, {700,0.01684545}, {705,0.02539091}, {710,0.01728182}, {715,0.01629091}, {720,0.01767273}, {725,0.01773636}, {730,0.02319091}, {735,0.01772727}, {740,0.01698182}, {745,0.01842727}, {750,0.01780909}, {755,0.02403636}, {760,0.01850909}, {765,0.01820000}, {770,0.02510000}, {775,0.01899091}, {780,0.01792727}, {785,0.02527273}, {790,0.01957273}, {795,0.01838182}, {800,0.02619091}, {805,0.01996364}, {810,0.01866364}, {815,0.02664545}, {820,0.02041818}, {825,0.01894545}, {830,0.02764545}, {835,0.02073636}, {840,0.02048182}, {845,0.02635455}, {850,0.04171818}, {855,0.02126364}, {860,0.01991818}, {865,0.02880909}, {870,0.02170909}, {875,0.02153636}, {880,0.02050909}, {885,0.02960909}, {890,0.02188182}, {895,0.02184545}, {900,0.02112727}, {905,0.02856364}, {910,0.02276364}, {915,0.02287273}, {920,0.02146364}, {925,0.02937273}, {930,0.02300909}, {935,0.02361818}, {940,0.02198182}, {945,0.02796364}, {950,0.03164545}, {955,0.02366364}, {960,0.02407273}, {965,0.02277273}, {970,0.02917273}, {975,0.03175455}, {980,0.02454545}, {985,0.02470000}, {990,0.02320909}, {995,0.02354545}, {1000,0.03270909}, {1010,0.03542727}, {1020,0.02488182}, {1030,0.02577273}, {1040,0.02545455}, {1050,0.02452727}, {1060,0.02460909}, {1070,0.03243636}, {1080,0.03457273}, {1090,0.03590000}, {1100,0.04443636}, {1110,0.02710000}, {1120,0.02745455}, {1130,0.02741818}, {1140,0.02810000}, {1150,0.02842727}, {1160,0.02751818}, {1170,0.02711818}, {1180,0.02715455}, {1190,0.02752727}, {1200,0.02745455}, {1210,0.02788182}, {1220,0.02820000}, {1230,0.02875455}, {1240,0.02883636}, {1250,0.03035455}, {1260,0.03094545}, {1270,0.03161818}, {1280,0.03166364}, {1290,0.05485455}, {1300,0.04819091}, {1310,0.05100000}, {1320,0.04138182}, {1330,0.03993636}, {1340,0.03108182}, {1350,0.03154545}, {1360,0.03207273}, {1370,0.03430909}, {1380,0.05424545}, {1390,0.04993636}, {1400,0.04298182}, {1410,0.03321818}, {1420,0.03381818}, {1430,0.03592727}, {1440,0.04930909}, {1450,0.05477273}, {1460,0.03405455}, {1470,0.03495455}, {1480,0.06703636}, {1490,0.04940000}, {1500,0.04640000}, {1510,0.03594545}, {1520,0.06734545}, {1530,0.05052727}, {1540,0.03620909}, {1550,0.03655455}, {1560,0.05400000}, {1570,0.05875455}, {1580,0.03723636}, {1590,0.06068182}, {1600,0.05620000}, {1610,0.03792727}, {1620,0.06141818}, {1630,0.05782727}, {1640,0.03863636}, {1650,0.05351818}, {1660,0.06339091}, {1670,0.03904545}, {1680,0.05380000}, {1690,0.03943636}, {1700,0.05380000}, {1710,0.06328182}, {1720,0.06280000}, {1730,0.05507273}, {1740,0.04063636}, {1750,0.05677273}, {1760,0.04132727}, {1770,0.05816364}, {1780,0.04183636}, {1790,0.05996364}, {1800,0.04257273}, {1810,0.05996364}, {1820,0.04266364}, {1830,0.05956364}, {1840,0.04308182}, {1850,0.05929091}, {1860,0.04351818}, {1870,0.05897273}, {1880,0.06806364}, {1890,0.06115455}, {1900,0.05388182}, {1910,0.04542727}, {1920,0.06121818}, {1930,0.04530000}, {1940,0.05954545}, {1950,0.05470000}, {1960,0.04644545}, {1970,0.06216364}, {1980,0.07153636}, {1990,0.06810909}, {2000,0.06607273}, {2050,0.06790909}, {2100,0.04947273}, {2150,0.06623636}, {2200,0.06450909}, {2250,0.05652727}, {2300,0.06833636}, {2350,0.07363636}, {2400,0.07736364}, {2450,0.07650000}, {2500,0.06978182}, {2550,0.06354545}, {2600,0.06373636}, {2650,0.07176364}, {2700,0.08058182}, {2750,0.08353636}, {2800,0.06874545}, {2850,0.08216364}, {2900,0.08073636}, {2950,0.07175455}, {3000,0.09430909}, {3050,0.07408182}, {3100,0.08730909}, {3150,0.07569091}, {3200,0.07906364}, {3250,0.10073636}, {3300,0.07909091}, {3350,0.08282727}, {3400,0.08416364}, {3450,0.08772727}, {3500,0.11894545}, {3550,0.11949091}, {3600,0.11807273}, {3650,0.11753636}, {3700,0.11364545}, {3750,0.11143636}, {3800,0.09503636}, {3850,0.09510000}, {3900,0.09540909}, {3950,0.13385455}, {4000,0.09541818}, {4050,0.09940909}, {4100,0.13242727}, {4150,0.10277273}, {4200,0.15129091}, {4250,0.10600000}, {4300,0.14373636}, {4350,0.10837273}, {4400,0.11778182}, {4450,0.16023636}, {4500,0.11148182}, {4550,0.11307273}, {4600,0.13042727}, {4650,0.15280909}, {4700,0.16961818}, {4750,0.17978182}, {4800,0.18810000}, {4850,0.19016364}, {4900,0.18350000}, {4950,0.17417273}, {5000,0.16072727}, {5050,0.13905455}, {5100,0.12730909}, {5150,0.12759091}, {5200,0.17416364}, {5250,0.13306364}, {5300,0.13202727}, {5350,0.16150909}, {5400,0.13486364}, {5450,0.16944545}, {5500,0.13702727}, {5550,0.15608182}, {5600,0.20630909}, {5650,0.14199091}, {5700,0.16168182}, {5750,0.19548182}, {5800,0.22537273}, {5850,0.14654545}, {5900,0.14910909}, {5950,0.14892727}, {6000,0.15543636}, {6050,0.15837273}, {6100,0.15480909}, {6150,0.15594545}, {6200,0.15606364}, {6250,0.23493636}, {6300,0.21650000}, {6350,0.18788182}, {6400,0.16212727}, {6450,0.24146364}, {6500,0.19280909}, {6550,0.16469091}, {6600,0.21564545}, {6650,0.16779091}, {6700,0.21499091}, {6750,0.27592727}, {6800,0.19314545}, {6850,0.23878182}, {6900,0.17356364}, {6950,0.18766364}, {7000,0.21691818}, {7050,0.24123636}, {7100,0.25717273}, {7150,0.27145455}, {7200,0.27868182}, {7250,0.28611818}, {7300,0.28290000}, {7350,0.27628182}, {7400,0.26409091}, {7450,0.24547273}, {7500,0.22367273}, {7550,0.19386364}, {7600,0.28775455}, {7650,0.24876364}, {7700,0.20560909}, {7750,0.28342727}, {7800,0.22890909}, {7850,0.29797273}, {7900,0.22784545}, {7950,0.28580909}, {8000,0.21033636}, {8050,0.25629091}, {8100,0.29892727}, {8150,0.20644545}, {8200,0.23812727}, {8250,0.26152727}, {8300,0.28135455}, {8350,0.29331818}, {8400,0.30805455}, {8450,0.31460909}, {8500,0.31204545}, {8550,0.29761818}, {8600,0.29466364}, {8650,0.28054545}, {8700,0.25180000}, {8750,0.35088182}, {8800,0.32323636}, {8850,0.28287273}, {8900,0.24026364}, {8950,0.32300000}, {9000,0.26677273}};
data["big"]["TemplateCoq"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003636}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003636}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00003636}, {17,0.00000000}, {18,0.00000000}, {19,0.00002727}, {20,0.00000000}, {21,0.00003636}, {22,0.00003636}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00002727}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00007273}, {47,0.00003636}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00002727}, {56,0.00007273}, {57,0.00000000}, {58,0.00003636}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00002727}, {67,0.00007273}, {68,0.00007273}, {69,0.00000000}, {70,0.00003636}, {71,0.00003636}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00003636}, {76,0.00007273}, {77,0.00003636}, {78,0.00003636}, {79,0.00007273}, {80,0.00003636}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00003636}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00003636}, {96,0.00003636}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00003636}, {103,0.00000000}, {104,0.00000000}, {105,0.00003636}, {106,0.00003636}, {107,0.00000000}, {108,0.00003636}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00007273}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00003636}, {119,0.00003636}, {120,0.00002727}, {121,0.00003636}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00003636}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00003636}, {132,0.00003636}, {133,0.00000000}, {134,0.00003636}, {135,0.00003636}, {136,0.00000000}, {137,0.00003636}, {138,0.00000000}, {139,0.00003636}, {140,0.00000000}, {141,0.00003636}, {142,0.00000000}, {143,0.00003636}, {144,0.00000000}, {145,0.00002727}, {146,0.00000000}, {147,0.00000000}, {148,0.00003636}, {149,0.00003636}, {150,0.00003636}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00003636}, {155,0.00003636}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00007273}, {160,0.00000000}, {161,0.00003636}, {162,0.00003636}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00007273}, {167,0.00000000}, {168,0.00000000}, {169,0.00003636}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00007273}, {197,0.00000000}, {198,0.00000000}, {199,0.00003636}, {200,0.00006364}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00003636}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00003636}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00003636}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00003636}, {227,0.00003636}, {228,0.00000000}, {229,0.00007273}, {230,0.00000000}, {231,0.00003636}, {232,0.00000000}, {233,0.00003636}, {234,0.00003636}, {235,0.00003636}, {236,0.00007273}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00003636}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00003636}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00003636}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00003636}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003636}, {266,0.00014545}, {267,0.00007273}, {268,0.00000000}, {269,0.00003636}, {270,0.00003636}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003636}, {282,0.00000000}, {283,0.00003636}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00003636}, {290,0.00000000}, {291,0.00007273}, {292,0.00000000}, {293,0.00003636}, {294,0.00003636}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00003636}, {299,0.00000000}, {300,0.00000000}, {301,0.00003636}, {302,0.00000000}, {303,0.00000000}, {304,0.00003636}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00010909}, {309,0.00003636}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00007273}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00002727}, {324,0.00010909}, {325,0.00000000}, {326,0.00003636}, {327,0.00000000}, {328,0.00000000}, {329,0.00003636}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00003636}, {334,0.00000000}, {335,0.00003636}, {336,0.00003636}, {337,0.00000000}, {338,0.00003636}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00003636}, {343,0.00003636}, {344,0.00000000}, {345,0.00003636}, {346,0.00000000}, {347,0.00003636}, {348,0.00000000}, {349,0.00003636}, {350,0.00003636}, {351,0.00000000}, {352,0.00003636}, {353,0.00003636}, {354,0.00007273}, {355,0.00000000}, {356,0.00003636}, {357,0.00003636}, {358,0.00002727}, {359,0.00003636}, {360,0.00000000}, {361,0.00007273}, {362,0.00000000}, {363,0.00007273}, {364,0.00000000}, {365,0.00000000}, {366,0.00007273}, {367,0.00000000}, {368,0.00002727}, {369,0.00000000}, {370,0.00003636}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00003636}, {376,0.00003636}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00007273}, {381,0.00000000}, {382,0.00000000}, {383,0.00007273}, {384,0.00003636}, {385,0.00003636}, {386,0.00003636}, {387,0.00002727}, {388,0.00000000}, {389,0.00000000}, {390,0.00003636}, {391,0.00003636}, {392,0.00003636}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00003636}, {397,0.00000000}, {398,0.00000000}, {399,0.00003636}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00002727}, {405,0.00002727}, {406,0.00003636}, {407,0.00003636}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00003636}, {412,0.00000000}, {413,0.00000000}, {414,0.00007273}, {415,0.00000000}, {416,0.00003636}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00007273}, {423,0.00000000}, {424,0.00003636}, {425,0.00010909}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00003636}, {430,0.00003636}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00003636}, {438,0.00003636}, {439,0.00000000}, {440,0.00003636}, {441,0.00003636}, {442,0.00003636}, {443,0.00000000}, {444,0.00003636}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00076364}, {451,0.00000000}, {452,0.00000000}, {453,0.00003636}, {454,0.00000000}, {455,0.00003636}, {456,0.00003636}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00003636}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00003636}, {468,0.00000000}, {469,0.00000000}, {470,0.00003636}, {471,0.00003636}, {472,0.00007273}, {473,0.00000000}, {474,0.00003636}, {475,0.00000000}, {476,0.00007273}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00003636}, {488,0.00003636}, {489,0.00003636}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00002727}, {494,0.00000000}, {495,0.00000000}, {496,0.00003636}, {497,0.00003636}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00007273}, {515,0.00003636}, {520,0.00003636}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00006364}, {555,0.00000000}, {560,0.00000000}, {565,0.00003636}, {570,0.00007273}, {575,0.00003636}, {580,0.00002727}, {585,0.00003636}, {590,0.00003636}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00003636}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00003636}, {650,0.00000000}, {655,0.00003636}, {660,0.00003636}, {665,0.00000000}, {670,0.00000000}, {675,0.00003636}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00002727}, {710,0.00014545}, {715,0.00000000}, {720,0.00003636}, {725,0.00007273}, {730,0.00007273}, {735,0.00003636}, {740,0.00000000}, {745,0.00000000}, {750,0.00007273}, {755,0.00003636}, {760,0.00007273}, {765,0.00000000}, {770,0.00003636}, {775,0.00000000}, {780,0.00000000}, {785,0.00007273}, {790,0.00003636}, {795,0.00007273}, {800,0.00003636}, {805,0.00000000}, {810,0.00003636}, {815,0.00010909}, {820,0.00000000}, {825,0.00000000}, {830,0.00003636}, {835,0.00003636}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00003636}, {870,0.00003636}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00003636}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00002727}, {930,0.00000000}, {935,0.00010909}, {940,0.00000000}, {945,0.00007273}, {950,0.00000000}, {955,0.00007273}, {960,0.00000000}, {965,0.00003636}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00003636}, {1000,0.00000000}, {1010,0.00007273}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00003636}, {1050,0.00003636}, {1060,0.00000000}, {1070,0.00003636}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00006364}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00003636}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00003636}, {1190,0.00003636}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00003636}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003636}, {1290,0.00000000}, {1300,0.00003636}, {1310,0.00000000}, {1320,0.00003636}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00003636}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00003636}, {1450,0.00007273}, {1460,0.00003636}, {1470,0.00000000}, {1480,0.00003636}, {1490,0.00000000}, {1500,0.00003636}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00007273}, {1560,0.00000000}, {1570,0.00007273}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00007273}, {1620,0.00003636}, {1630,0.00003636}, {1640,0.00003636}, {1650,0.00003636}, {1660,0.00000000}, {1670,0.00003636}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00003636}, {1720,0.00007273}, {1730,0.00003636}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00007273}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00007273}, {1820,0.00000000}, {1830,0.00003636}, {1840,0.00003636}, {1850,0.00000000}, {1860,0.00003636}, {1870,0.00003636}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00003636}, {1910,0.00000000}, {1920,0.00007273}, {1930,0.00003636}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00003636}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00003636}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00003636}, {2700,0.00000000}, {2750,0.00003636}, {2800,0.00003636}, {2850,0.00002727}, {2900,0.00000000}, {2950,0.00007273}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00003636}, {3250,0.00018182}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00003636}, {3450,0.00007273}, {3500,0.00052727}, {3550,0.00047273}, {3600,0.00014545}, {3650,0.00028182}, {3700,0.00024545}, {3750,0.00007273}, {3800,0.00000000}, {3850,0.00006364}, {3900,0.00003636}, {3950,0.00020909}, {4000,0.00000000}, {4050,0.00010000}, {4100,0.00021818}, {4150,0.00000000}, {4200,0.00029091}, {4250,0.00014545}, {4300,0.00010000}, {4350,0.00007273}, {4400,0.00016364}, {4450,0.00046364}, {4500,0.00007273}, {4550,0.00010909}, {4600,0.00017273}, {4650,0.00046364}, {4700,0.00023636}, {4750,0.00040000}, {4800,0.00043636}, {4850,0.00027273}, {4900,0.00040000}, {4950,0.00025455}, {5000,0.00010909}, {5050,0.00014545}, {5100,0.00003636}, {5150,0.00003636}, {5200,0.00002727}, {5250,0.00003636}, {5300,0.00003636}, {5350,0.00010909}, {5400,0.00007273}, {5450,0.00020909}, {5500,0.00006364}, {5550,0.00013636}, {5600,0.00047273}, {5650,0.00003636}, {5700,0.00007273}, {5750,0.00053636}, {5800,0.00003636}, {5850,0.00010909}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00003636}, {6050,0.00010909}, {6100,0.00000000}, {6150,0.00007273}, {6200,0.00000000}, {6250,0.00003636}, {6300,0.00003636}, {6350,0.00007273}, {6400,0.00003636}, {6450,0.00000000}, {6500,0.00013636}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00006364}, {6800,0.00003636}, {6850,0.00007273}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00010000}, {7150,0.00003636}, {7200,0.00003636}, {7250,0.00013636}, {7300,0.00003636}, {7350,0.00003636}, {7400,0.00003636}, {7450,0.00000000}, {7500,0.00007273}, {7550,0.00000000}, {7600,0.00007273}, {7650,0.00003636}, {7700,0.00003636}, {7750,0.00000000}, {7800,0.00010909}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00007273}, {8150,0.00007273}, {8200,0.00000000}, {8250,0.00003636}, {8300,0.00000000}, {8350,0.00010909}, {8400,0.00003636}, {8450,0.00003636}, {8500,0.00000000}, {8550,0.00007273}, {8600,0.00000000}, {8650,0.00014545}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00003636}, {8950,0.00018182}, {9000,0.00040909}};
data["big"]["TemplateCoq"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00001818}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00005455}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00007273}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000909}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000909}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000909}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00008182}, {645,0.00000000}, {650,0.00000909}, {655,0.00000000}, {660,0.00002727}, {665,0.00003636}, {670,0.00000000}, {675,0.00001818}, {680,0.00000000}, {685,0.00003636}, {690,0.00000000}, {695,0.00007273}, {700,0.00002727}, {705,0.00000000}, {710,0.00010000}, {715,0.00000909}, {720,0.00014545}, {725,0.00000000}, {730,0.00000000}, {735,0.00030000}, {740,0.00000909}, {745,0.00026364}, {750,0.00027273}, {755,0.00000000}, {760,0.00029091}, {765,0.00000909}, {770,0.00000000}, {775,0.00037273}, {780,0.00000909}, {785,0.00000000}, {790,0.00046364}, {795,0.00000909}, {800,0.00000000}, {805,0.00055455}, {810,0.00000909}, {815,0.00000000}, {820,0.00068182}, {825,0.00001818}, {830,0.00000000}, {835,0.00077273}, {840,0.00076364}, {845,0.00001818}, {850,0.00000000}, {855,0.00089091}, {860,0.00001818}, {865,0.00000000}, {870,0.00088182}, {875,0.00092727}, {880,0.00001818}, {885,0.00000000}, {890,0.00095455}, {895,0.00013636}, {900,0.00001818}, {905,0.00000000}, {910,0.00098182}, {915,0.00097273}, {920,0.00001818}, {925,0.00000000}, {930,0.00097273}, {935,0.00098182}, {940,0.00001818}, {945,0.00000000}, {950,0.00000000}, {955,0.00098182}, {960,0.00100000}, {965,0.00001818}, {970,0.00000000}, {975,0.00000000}, {980,0.00098182}, {985,0.00098182}, {990,0.00001818}, {995,0.00001818}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00098182}, {1030,0.00098182}, {1040,0.00001818}, {1050,0.00001818}, {1060,0.00004545}, {1070,0.00002727}, {1080,0.00001818}, {1090,0.00003636}, {1100,0.00011818}, {1110,0.00100000}, {1120,0.00100000}, {1130,0.00102727}, {1140,0.00100909}, {1150,0.00099091}, {1160,0.00050000}, {1170,0.00082727}, {1180,0.00066364}, {1190,0.00077273}, {1200,0.00082727}, {1210,0.00090909}, {1220,0.00113636}, {1230,0.00096364}, {1240,0.00098182}, {1250,0.00098182}, {1260,0.00100000}, {1270,0.00131818}, {1280,0.00127273}, {1290,0.00100000}, {1300,0.00100000}, {1310,0.00100000}, {1320,0.00100000}, {1330,0.00100000}, {1340,0.00100000}, {1350,0.00101818}, {1360,0.00100000}, {1370,0.00120909}, {1380,0.00100000}, {1390,0.00100000}, {1400,0.00100000}, {1410,0.00100000}, {1420,0.00100000}, {1430,0.00100000}, {1440,0.00100000}, {1450,0.00100000}, {1460,0.00100000}, {1470,0.00100000}, {1480,0.00100000}, {1490,0.00100000}, {1500,0.00100000}, {1510,0.00100000}, {1520,0.00100000}, {1530,0.00100000}, {1540,0.00100000}, {1550,0.00100000}, {1560,0.00100000}, {1570,0.00100000}, {1580,0.00100000}, {1590,0.00100000}, {1600,0.00100000}, {1610,0.00100000}, {1620,0.00100000}, {1630,0.00100000}, {1640,0.00100000}, {1650,0.00100000}, {1660,0.00100000}, {1670,0.00100000}, {1680,0.00100000}, {1690,0.00100000}, {1700,0.00100000}, {1710,0.00100000}, {1720,0.00100000}, {1730,0.00100000}, {1740,0.00100000}, {1750,0.00100000}, {1760,0.00100000}, {1770,0.00100000}, {1780,0.00100000}, {1790,0.00100000}, {1800,0.00100000}, {1810,0.00100000}, {1820,0.00100000}, {1830,0.00100000}, {1840,0.00100000}, {1850,0.00100000}, {1860,0.00100000}, {1870,0.00100000}, {1880,0.00100000}, {1890,0.00100000}, {1900,0.00100000}, {1910,0.00100000}, {1920,0.00100000}, {1930,0.00100000}, {1940,0.00100000}, {1950,0.00100000}, {1960,0.00100000}, {1970,0.00100000}, {1980,0.00100000}, {1990,0.00100000}, {2000,0.00100000}, {2050,0.00102727}, {2100,0.00102727}, {2150,0.00106364}, {2200,0.00122727}, {2250,0.00148182}, {2300,0.00171818}, {2350,0.00186364}, {2400,0.00192727}, {2450,0.00199091}, {2500,0.00200000}, {2550,0.00200000}, {2600,0.00200000}, {2650,0.00200000}, {2700,0.00200000}, {2750,0.00200000}, {2800,0.00200000}, {2850,0.00200000}, {2900,0.00200000}, {2950,0.00210909}, {3000,0.00200909}, {3050,0.00210909}, {3100,0.00202727}, {3150,0.00205455}, {3200,0.00210909}, {3250,0.00293636}, {3300,0.00248182}, {3350,0.00257273}, {3400,0.00271818}, {3450,0.00283636}, {3500,0.00292727}, {3550,0.00296364}, {3600,0.00299091}, {3650,0.00300000}, {3700,0.00300000}, {3750,0.00300000}, {3800,0.00300000}, {3850,0.00317273}, {3900,0.00300000}, {3950,0.00300909}, {4000,0.00300000}, {4050,0.00300909}, {4100,0.00301818}, {4150,0.00330909}, {4200,0.00304545}, {4250,0.00313636}, {4300,0.00330000}, {4350,0.00340000}, {4400,0.00358182}, {4450,0.00368182}, {4500,0.00370909}, {4550,0.00380000}, {4600,0.00388182}, {4650,0.00397273}, {4700,0.00497273}, {4750,0.00400000}, {4800,0.00400000}, {4850,0.00400000}, {4900,0.00400909}, {4950,0.00400000}, {5000,0.00529091}, {5050,0.00400000}, {5100,0.00401818}, {5150,0.01935455}, {5200,0.00405455}, {5250,0.00430909}, {5300,0.01321818}, {5350,0.00433636}, {5400,0.00439091}, {5450,0.00454545}, {5500,0.00466364}, {5550,0.00474545}, {5600,0.00480000}, {5650,0.00556364}, {5700,0.00488182}, {5750,0.00493636}, {5800,0.00495455}, {5850,0.00601818}, {5900,0.00500000}, {5950,0.00521818}, {6000,0.00536364}, {6050,0.00534545}, {6100,0.00518182}, {6150,0.00509091}, {6200,0.00508182}, {6250,0.00507273}, {6300,0.00599091}, {6350,0.00526364}, {6400,0.00530909}, {6450,0.00550909}, {6500,0.00553636}, {6550,0.02804545}, {6600,0.00708182}, {6650,0.00572727}, {6700,0.00577273}, {6750,0.00580000}, {6800,0.00628182}, {6850,0.00595455}, {6900,0.01600000}, {6950,0.00647273}, {7000,0.00600000}, {7050,0.00600909}, {7100,0.00600000}, {7150,0.00600909}, {7200,0.00602727}, {7250,0.00603636}, {7300,0.00610000}, {7350,0.00617273}, {7400,0.00631818}, {7450,0.00638182}, {7500,0.00774545}, {7550,0.00647273}, {7600,0.00720909}, {7650,0.00670000}, {7700,0.00673636}, {7750,0.00766364}, {7800,0.00707273}, {7850,0.00681818}, {7900,0.00685455}, {7950,0.00889091}, {8000,0.00698182}, {8050,0.00696364}, {8100,0.00721818}, {8150,0.08120909}, {8200,0.00705455}, {8250,0.00830909}, {8300,0.00710000}, {8350,0.00715455}, {8400,0.00717273}, {8450,0.00726364}, {8500,0.00747273}, {8550,0.00750909}, {8600,0.00759091}, {8650,0.00765455}, {8700,0.00978182}, {8750,0.00783636}, {8800,0.00777273}, {8850,0.00783636}, {8900,0.08701818}, {8950,0.00781818}, {9000,0.00788182}};
data["big"]["TemplateCoq"]["lazy beta iota"]["user"] = {{1,0.00002727}, {2,0.00003636}, {3,0.00002727}, {4,0.00000000}, {5,0.00000000}, {6,0.00006364}, {7,0.00000000}, {8,0.00000000}, {9,0.00002727}, {10,0.00000000}, {11,0.00000000}, {12,0.00002727}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00003636}, {17,0.00002727}, {18,0.00000000}, {19,0.00002727}, {20,0.00002727}, {21,0.00002727}, {22,0.00009091}, {23,0.00000000}, {24,0.00002727}, {25,0.00005455}, {26,0.00010000}, {27,0.00007273}, {28,0.00000000}, {29,0.00003636}, {30,0.00006364}, {31,0.00009091}, {32,0.00005455}, {33,0.00000000}, {34,0.00005455}, {35,0.00002727}, {36,0.00002727}, {37,0.00002727}, {38,0.00009091}, {39,0.00009091}, {40,0.00002727}, {41,0.00003636}, {42,0.00002727}, {43,0.00003636}, {44,0.00000000}, {45,0.00002727}, {46,0.00000000}, {47,0.00003636}, {48,0.00005455}, {49,0.00006364}, {50,0.00010000}, {51,0.00002727}, {52,0.00002727}, {53,0.00008182}, {54,0.00003636}, {55,0.00006364}, {56,0.00006364}, {57,0.00000000}, {58,0.00009091}, {59,0.00008182}, {60,0.00009091}, {61,0.00016364}, {62,0.00012727}, {63,0.00006364}, {64,0.00006364}, {65,0.00000000}, {66,0.00009091}, {67,0.00005455}, {68,0.00010909}, {69,0.00009091}, {70,0.00015455}, {71,0.00003636}, {72,0.00005455}, {73,0.00012727}, {74,0.00005455}, {75,0.00015455}, {76,0.00021818}, {77,0.00012727}, {78,0.00006364}, {79,0.00011818}, {80,0.00009091}, {81,0.00006364}, {82,0.00007273}, {83,0.00022727}, {84,0.00008182}, {85,0.00006364}, {86,0.00002727}, {87,0.00020909}, {88,0.00000000}, {89,0.00012727}, {90,0.00005455}, {91,0.00002727}, {92,0.00005455}, {93,0.00019091}, {94,0.00014545}, {95,0.00015455}, {96,0.00002727}, {97,0.00005455}, {98,0.00016364}, {99,0.00019091}, {100,0.00016364}, {101,0.00018182}, {102,0.00002727}, {103,0.00009091}, {104,0.00003636}, {105,0.00005455}, {106,0.00011818}, {107,0.00008182}, {108,0.00009091}, {109,0.00018182}, {110,0.00023636}, {111,0.00017273}, {112,0.00017273}, {113,0.00024545}, {114,0.00010909}, {115,0.00002727}, {116,0.00014545}, {117,0.00009091}, {118,0.00010000}, {119,0.00016364}, {120,0.00009091}, {121,0.00016364}, {122,0.00017273}, {123,0.00010909}, {124,0.00020909}, {125,0.00011818}, {126,0.00020909}, {127,0.00021818}, {128,0.00019091}, {129,0.00003636}, {130,0.00014545}, {131,0.00009091}, {132,0.00002727}, {133,0.00019091}, {134,0.00007273}, {135,0.00017273}, {136,0.00006364}, {137,0.00017273}, {138,0.00018182}, {139,0.00020909}, {140,0.00015455}, {141,0.00030909}, {142,0.00012727}, {143,0.00027273}, {144,0.00027273}, {145,0.00016364}, {146,0.00025455}, {147,0.00006364}, {148,0.00013636}, {149,0.00009091}, {150,0.00008182}, {151,0.00035455}, {152,0.00011818}, {153,0.00010000}, {154,0.00022727}, {155,0.00021818}, {156,0.00005455}, {157,0.00011818}, {158,0.00011818}, {159,0.00011818}, {160,0.00010909}, {161,0.00016364}, {162,0.00019091}, {163,0.00018182}, {164,0.00017273}, {165,0.00021818}, {166,0.00014545}, {167,0.00030000}, {168,0.00005455}, {169,0.00026364}, {170,0.00013636}, {171,0.00030909}, {172,0.00013636}, {173,0.00021818}, {174,0.00005455}, {175,0.00015455}, {176,0.00021818}, {177,0.00018182}, {178,0.00012727}, {179,0.00017273}, {180,0.00016364}, {181,0.00022727}, {182,0.00022727}, {183,0.00024545}, {184,0.00023636}, {185,0.00021818}, {186,0.00023636}, {187,0.00011818}, {188,0.00022727}, {189,0.00027273}, {190,0.00023636}, {191,0.00018182}, {192,0.00013636}, {193,0.00026364}, {194,0.00024545}, {195,0.00028182}, {196,0.00019091}, {197,0.00029091}, {198,0.00020909}, {199,0.00002727}, {200,0.00015455}, {201,0.00009091}, {202,0.00030909}, {203,0.00020909}, {204,0.00022727}, {205,0.00017273}, {206,0.00024545}, {207,0.00030000}, {208,0.00011818}, {209,0.00017273}, {210,0.00025455}, {211,0.00013636}, {212,0.00026364}, {213,0.00023636}, {214,0.00021818}, {215,0.00025455}, {216,0.00014545}, {217,0.00009091}, {218,0.00020000}, {219,0.00019091}, {220,0.00030909}, {221,0.00022727}, {222,0.00023636}, {223,0.00031818}, {224,0.00010909}, {225,0.00020000}, {226,0.00030000}, {227,0.00026364}, {228,0.00027273}, {229,0.00016364}, {230,0.00017273}, {231,0.00017273}, {232,0.00020000}, {233,0.00023636}, {234,0.00018182}, {235,0.00020909}, {236,0.00032727}, {237,0.00038182}, {238,0.00039091}, {239,0.00009091}, {240,0.00038182}, {241,0.00027273}, {242,0.00032727}, {243,0.00023636}, {244,0.00032727}, {245,0.00024545}, {246,0.00013636}, {247,0.00016364}, {248,0.00024545}, {249,0.00028182}, {250,0.00016364}, {251,0.00020909}, {252,0.00042727}, {253,0.00029091}, {254,0.00018182}, {255,0.00047273}, {256,0.00037273}, {257,0.00050000}, {258,0.00024545}, {259,0.00019091}, {260,0.00020909}, {261,0.00032727}, {262,0.00030000}, {263,0.00032727}, {264,0.00019091}, {265,0.00021818}, {266,0.00011818}, {267,0.00012727}, {268,0.00045455}, {269,0.00034545}, {270,0.00023636}, {271,0.00020000}, {272,0.00023636}, {273,0.00034545}, {274,0.00017273}, {275,0.00020909}, {276,0.00018182}, {277,0.00047273}, {278,0.00011818}, {279,0.00039091}, {280,0.00023636}, {281,0.00045455}, {282,0.00020909}, {283,0.00051818}, {284,0.00028182}, {285,0.00021818}, {286,0.00030909}, {287,0.00029091}, {288,0.00027273}, {289,0.00020909}, {290,0.00031818}, {291,0.00030000}, {292,0.00014545}, {293,0.00038182}, {294,0.00024545}, {295,0.00038182}, {296,0.00026364}, {297,0.00033636}, {298,0.00041818}, {299,0.00047273}, {300,0.00011818}, {301,0.00055455}, {302,0.00010909}, {303,0.00023636}, {304,0.00031818}, {305,0.00030000}, {306,0.00039091}, {307,0.00022727}, {308,0.00033636}, {309,0.00017273}, {310,0.00030000}, {311,0.00018182}, {312,0.00020000}, {313,0.00034545}, {314,0.00026364}, {315,0.00023636}, {316,0.00042727}, {317,0.00034545}, {318,0.00037273}, {319,0.00050000}, {320,0.00027273}, {321,0.00039091}, {322,0.00023636}, {323,0.00020000}, {324,0.00043636}, {325,0.00048182}, {326,0.00032727}, {327,0.00064545}, {328,0.00038182}, {329,0.00033636}, {330,0.00023636}, {331,0.00011818}, {332,0.00020000}, {333,0.00026364}, {334,0.00034545}, {335,0.00040909}, {336,0.00031818}, {337,0.00030000}, {338,0.00057273}, {339,0.00025455}, {340,0.00029091}, {341,0.00047273}, {342,0.00038182}, {343,0.00034545}, {344,0.00043636}, {345,0.00036364}, {346,0.00037273}, {347,0.00039091}, {348,0.00041818}, {349,0.00028182}, {350,0.00030909}, {351,0.00054545}, {352,0.00038182}, {353,0.00017273}, {354,0.00035455}, {355,0.00047273}, {356,0.00038182}, {357,0.00039091}, {358,0.00046364}, {359,0.00025455}, {360,0.00028182}, {361,0.00022727}, {362,0.00017273}, {363,0.00020909}, {364,0.00045455}, {365,0.00027273}, {366,0.00036364}, {367,0.00042727}, {368,0.00055455}, {369,0.00037273}, {370,0.00036364}, {371,0.00055455}, {372,0.00042727}, {373,0.00041818}, {374,0.00054545}, {375,0.00048182}, {376,0.00043636}, {377,0.00023636}, {378,0.00039091}, {379,0.00040909}, {380,0.00026364}, {381,0.00050000}, {382,0.00030909}, {383,0.00039091}, {384,0.00051818}, {385,0.00044545}, {386,0.00040909}, {387,0.00046364}, {388,0.00030909}, {389,0.00032727}, {390,0.00030000}, {391,0.00032727}, {392,0.00020909}, {393,0.00036364}, {394,0.00040909}, {395,0.00032727}, {396,0.00033636}, {397,0.00027273}, {398,0.00040909}, {399,0.00050000}, {400,0.00026364}, {401,0.00046364}, {402,0.00034545}, {403,0.00039091}, {404,0.00044545}, {405,0.00025455}, {406,0.00023636}, {407,0.00049091}, {408,0.00039091}, {409,0.00032727}, {410,0.00014545}, {411,0.00038182}, {412,0.00010909}, {413,0.00041818}, {414,0.00032727}, {415,0.00028182}, {416,0.00045455}, {417,0.00027273}, {418,0.00031818}, {419,0.00049091}, {420,0.00045455}, {421,0.00059091}, {422,0.00042727}, {423,0.00021818}, {424,0.00045455}, {425,0.00053636}, {426,0.00034545}, {427,0.00056364}, {428,0.00044545}, {429,0.00057273}, {430,0.00039091}, {431,0.00042727}, {432,0.00037273}, {433,0.00042727}, {434,0.00047273}, {435,0.00048182}, {436,0.00037273}, {437,0.00055455}, {438,0.00040000}, {439,0.00051818}, {440,0.00049091}, {441,0.00037273}, {442,0.00040000}, {443,0.00041818}, {444,0.00037273}, {445,0.00049091}, {446,0.00031818}, {447,0.00031818}, {448,0.00058182}, {449,0.00037273}, {450,0.00042727}, {451,0.00023636}, {452,0.00037273}, {453,0.00040909}, {454,0.00061818}, {455,0.00016364}, {456,0.00038182}, {457,0.00033636}, {458,0.00031818}, {459,0.00040909}, {460,0.00042727}, {461,0.00043636}, {462,0.00049091}, {463,0.00020000}, {464,0.00048182}, {465,0.00040000}, {466,0.00065455}, {467,0.00057273}, {468,0.00044545}, {469,0.00041818}, {470,0.00040909}, {471,0.00025455}, {472,0.00042727}, {473,0.00050909}, {474,0.00060000}, {475,0.00057273}, {476,0.00056364}, {477,0.00058182}, {478,0.00039091}, {479,0.00059091}, {480,0.00060000}, {481,0.00055455}, {482,0.00027273}, {483,0.00038182}, {484,0.00039091}, {485,0.00042727}, {486,0.00049091}, {487,0.00049091}, {488,0.00024545}, {489,0.00050909}, {490,0.00037273}, {491,0.00064545}, {492,0.00052727}, {493,0.00037273}, {494,0.00059091}, {495,0.00039091}, {496,0.00042727}, {497,0.00042727}, {498,0.00044545}, {499,0.00046364}, {500,0.00043636}, {505,0.00060909}, {510,0.00049091}, {515,0.00057273}, {520,0.00045455}, {525,0.00063636}, {530,0.00041818}, {535,0.00033636}, {540,0.00063636}, {545,0.00030000}, {550,0.00046364}, {555,0.00045455}, {560,0.00069091}, {565,0.00053636}, {570,0.00060909}, {575,0.00035455}, {580,0.00032727}, {585,0.00040909}, {590,0.00060909}, {595,0.00056364}, {600,0.00058182}, {605,0.00034545}, {610,0.00042727}, {615,0.00045455}, {620,0.00066364}, {625,0.00045455}, {630,0.00073636}, {635,0.00047273}, {640,0.00073636}, {645,0.00062727}, {650,0.00101818}, {655,0.00022727}, {660,0.00060000}, {665,0.00067273}, {670,0.00065455}, {675,0.00075455}, {680,0.00043636}, {685,0.00083636}, {690,0.00053636}, {695,0.00064545}, {700,0.00080909}, {705,0.00081818}, {710,0.00064545}, {715,0.00033636}, {720,0.00067273}, {725,0.00030909}, {730,0.00031818}, {735,0.00091818}, {740,0.00056364}, {745,0.00055455}, {750,0.00078182}, {755,0.00061818}, {760,0.00080909}, {765,0.00057273}, {770,0.00045455}, {775,0.00091818}, {780,0.00057273}, {785,0.00049091}, {790,0.00070000}, {795,0.00076364}, {800,0.00050000}, {805,0.00084545}, {810,0.00051818}, {815,0.00051818}, {820,0.00089091}, {825,0.00065455}, {830,0.00046364}, {835,0.00054545}, {840,0.00121818}, {845,0.00066364}, {850,0.00037273}, {855,0.00122727}, {860,0.00061818}, {865,0.00041818}, {870,0.00092727}, {875,0.00105455}, {880,0.00068182}, {885,0.00060909}, {890,0.00105455}, {895,0.00067273}, {900,0.00053636}, {905,0.00077273}, {910,0.00087273}, {915,0.00095455}, {920,0.00049091}, {925,0.00068182}, {930,0.00125455}, {935,0.00084545}, {940,0.00074545}, {945,0.00070000}, {950,0.00055455}, {955,0.00141818}, {960,0.00110909}, {965,0.00079091}, {970,0.00070909}, {975,0.00070000}, {980,0.00127273}, {985,0.00105455}, {990,0.00085455}, {995,0.00058182}, {1000,0.00087273}, {1010,0.00075455}, {1020,0.00117273}, {1030,0.00093636}, {1040,0.00083636}, {1050,0.00069091}, {1060,0.00080909}, {1070,0.00090000}, {1080,0.00064545}, {1090,0.00090909}, {1100,0.00087273}, {1110,0.00120909}, {1120,0.00121818}, {1130,0.00122727}, {1140,0.00133636}, {1150,0.00094545}, {1160,0.00074545}, {1170,0.00112727}, {1180,0.00080000}, {1190,0.00085455}, {1200,0.00084545}, {1210,0.00092727}, {1220,0.00115455}, {1230,0.00089091}, {1240,0.00103636}, {1250,0.00073636}, {1260,0.00144545}, {1270,0.00133636}, {1280,0.00189091}, {1290,0.00101818}, {1300,0.00063636}, {1310,0.00072727}, {1320,0.00072727}, {1330,0.00086364}, {1340,0.00089091}, {1350,0.00093636}, {1360,0.00095455}, {1370,0.00146364}, {1380,0.00082727}, {1390,0.00070000}, {1400,0.00100000}, {1410,0.00103636}, {1420,0.00094545}, {1430,0.00093636}, {1440,0.00100909}, {1450,0.00110909}, {1460,0.00111818}, {1470,0.00098182}, {1480,0.00120909}, {1490,0.00103636}, {1500,0.00083636}, {1510,0.00111818}, {1520,0.00103636}, {1530,0.00113636}, {1540,0.00127273}, {1550,0.00099091}, {1560,0.00127273}, {1570,0.00105455}, {1580,0.00128182}, {1590,0.00112727}, {1600,0.00124545}, {1610,0.00119091}, {1620,0.00126364}, {1630,0.00119091}, {1640,0.00115455}, {1650,0.00100909}, {1660,0.00118182}, {1670,0.00094545}, {1680,0.00132727}, {1690,0.00114545}, {1700,0.00119091}, {1710,0.00136364}, {1720,0.00141818}, {1730,0.00133636}, {1740,0.00134545}, {1750,0.00124545}, {1760,0.00130000}, {1770,0.00099091}, {1780,0.00140000}, {1790,0.00120909}, {1800,0.00121818}, {1810,0.00155455}, {1820,0.00158182}, {1830,0.00130000}, {1840,0.00131818}, {1850,0.00145455}, {1860,0.00115455}, {1870,0.00139091}, {1880,0.00139091}, {1890,0.00126364}, {1900,0.00171818}, {1910,0.00119091}, {1920,0.00118182}, {1930,0.00138182}, {1940,0.00152727}, {1950,0.00155455}, {1960,0.00136364}, {1970,0.00130909}, {1980,0.00136364}, {1990,0.00140909}, {2000,0.00125455}, {2050,0.00198182}, {2100,0.00149091}, {2150,0.00156364}, {2200,0.00139091}, {2250,0.00145455}, {2300,0.00124545}, {2350,0.00168182}, {2400,0.00170000}, {2450,0.00170909}, {2500,0.00201818}, {2550,0.00163636}, {2600,0.00175455}, {2650,0.00194545}, {2700,0.00211818}, {2750,0.00209091}, {2800,0.00211818}, {2850,0.00167273}, {2900,0.00186364}, {2950,0.00208182}, {3000,0.00248182}, {3050,0.00262727}, {3100,0.00230909}, {3150,0.00241818}, {3200,0.00213636}, {3250,0.00271818}, {3300,0.00239091}, {3350,0.00230000}, {3400,0.00246364}, {3450,0.00240909}, {3500,0.00268182}, {3550,0.00257273}, {3600,0.00283636}, {3650,0.00264545}, {3700,0.00255455}, {3750,0.00282727}, {3800,0.00287273}, {3850,0.00294545}, {3900,0.00304545}, {3950,0.00292727}, {4000,0.00282727}, {4050,0.00317273}, {4100,0.00315455}, {4150,0.00332727}, {4200,0.00310000}, {4250,0.00324545}, {4300,0.00324545}, {4350,0.00331818}, {4400,0.00338182}, {4450,0.00340000}, {4500,0.00340909}, {4550,0.00347273}, {4600,0.00358182}, {4650,0.00344545}, {4700,0.00518182}, {4750,0.00359091}, {4800,0.00396364}, {4850,0.00372727}, {4900,0.00386364}, {4950,0.00386364}, {5000,0.00525455}, {5050,0.00388182}, {5100,0.00399091}, {5150,0.01948182}, {5200,0.00399091}, {5250,0.00429091}, {5300,0.01319091}, {5350,0.00456364}, {5400,0.00467273}, {5450,0.00411818}, {5500,0.00417273}, {5550,0.00429091}, {5600,0.00460909}, {5650,0.00540909}, {5700,0.00462727}, {5750,0.00440000}, {5800,0.00467273}, {5850,0.00638182}, {5900,0.00493636}, {5950,0.00501818}, {6000,0.00531818}, {6050,0.00555455}, {6100,0.00536364}, {6150,0.00525455}, {6200,0.00515455}, {6250,0.00535455}, {6300,0.00548182}, {6350,0.00511818}, {6400,0.00539091}, {6450,0.00564545}, {6500,0.00548182}, {6550,0.02795455}, {6600,0.00719091}, {6650,0.00578182}, {6700,0.00570000}, {6750,0.00545455}, {6800,0.00620909}, {6850,0.00568182}, {6900,0.01564545}, {6950,0.00632727}, {7000,0.00584545}, {7050,0.00580000}, {7100,0.00599091}, {7150,0.00583636}, {7200,0.00632727}, {7250,0.00650000}, {7300,0.00617273}, {7350,0.00635455}, {7400,0.00620909}, {7450,0.00633636}, {7500,0.00809091}, {7550,0.00646364}, {7600,0.00756364}, {7650,0.00679091}, {7700,0.00671818}, {7750,0.00776364}, {7800,0.00710909}, {7850,0.00681818}, {7900,0.00700909}, {7950,0.00920909}, {8000,0.00704545}, {8050,0.00711818}, {8100,0.00735455}, {8150,0.08145455}, {8200,0.00729091}, {8250,0.00868182}, {8300,0.00727273}, {8350,0.00732727}, {8400,0.00734545}, {8450,0.00754545}, {8500,0.00758182}, {8550,0.00750909}, {8600,0.00750909}, {8650,0.00766364}, {8700,0.01008182}, {8750,0.00808182}, {8800,0.00790909}, {8850,0.00792727}, {8900,0.08678182}, {8950,0.00774545}, {9000,0.00809091}};
data["big"]["TemplateCoq"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00003636}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00003636}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00007273}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00003636}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00003636}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00003636}, {190,0.00000000}, {191,0.00003636}, {192,0.00000000}, {193,0.00000000}, {194,0.00003636}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00003636}, {215,0.00003636}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00003636}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00003636}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00003636}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00003636}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00003636}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00003636}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00003636}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00003636}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00003636}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00003636}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00003636}, {399,0.00003636}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00003636}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00003636}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00002727}, {482,0.00000000}, {483,0.00000000}, {484,0.00003636}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00003636}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00007273}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00003636}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00003636}, {690,0.00003636}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00003636}, {740,0.00000000}, {745,0.00003636}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00003636}, {775,0.00000000}, {780,0.00003636}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00003636}, {810,0.00000000}, {815,0.00000000}, {820,0.00003636}, {825,0.00000000}, {830,0.00003636}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00003636}, {865,0.00000000}, {870,0.00003636}, {875,0.00000000}, {880,0.00003636}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00003636}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00003636}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00003636}, {1040,0.00003636}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00003636}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00003636}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00003636}, {1250,0.00000000}, {1260,0.00003636}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00007273}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00002727}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00003636}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00003636}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00003636}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00003636}, {1540,0.00000000}, {1550,0.00003636}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00003636}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00003636}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00003636}, {1850,0.00003636}, {1860,0.00007273}, {1870,0.00003636}, {1880,0.00007273}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00003636}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00003636}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00003636}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00003636}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00003636}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00003636}, {3050,0.00003636}, {3100,0.00003636}, {3150,0.00003636}, {3200,0.00007273}, {3250,0.00003636}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00007273}, {3600,0.00000000}, {3650,0.00003636}, {3700,0.00007273}, {3750,0.00003636}, {3800,0.00000000}, {3850,0.00007273}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00006364}, {4050,0.00000000}, {4100,0.00003636}, {4150,0.00007273}, {4200,0.00000000}, {4250,0.00003636}, {4300,0.00003636}, {4350,0.00003636}, {4400,0.00003636}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00003636}, {4650,0.00003636}, {4700,0.00000000}, {4750,0.00003636}, {4800,0.00010909}, {4850,0.00000000}, {4900,0.00003636}, {4950,0.00000000}, {5000,0.00003636}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00003636}, {5300,0.00003636}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00007273}, {5500,0.00003636}, {5550,0.00003636}, {5600,0.00010909}, {5650,0.00003636}, {5700,0.00007273}, {5750,0.00000000}, {5800,0.00003636}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00007273}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00007273}, {6250,0.00010000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00003636}, {6600,0.00000000}, {6650,0.00003636}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00007273}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00003636}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00003636}, {7400,0.00000000}, {7450,0.00007273}, {7500,0.00003636}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00003636}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00002727}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00003636}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00003636}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00003636}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00003636}, {8550,0.00000000}, {8600,0.00007273}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00003636}, {8800,0.00000000}, {8850,0.00007273}, {8900,0.00000000}, {8950,0.00010909}, {9000,0.00000000}};
data["big"]["TemplateCoq"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00001818}, {17,0.00015455}, {18,0.00046364}, {19,0.00093636}, {20,0.00100000}, {21,0.00100000}, {22,0.00100000}, {23,0.00100000}, {24,0.00100000}, {25,0.00100000}, {26,0.00100000}, {27,0.00100000}, {28,0.00100000}, {29,0.00100000}, {30,0.00100000}, {31,0.00100000}, {32,0.00100000}, {33,0.00100000}, {34,0.00100000}, {35,0.00100000}, {36,0.00100000}, {37,0.00101818}, {38,0.00100000}, {39,0.00103636}, {40,0.00116364}, {41,0.00140000}, {42,0.00170000}, {43,0.00195455}, {44,0.00200000}, {45,0.00200000}, {46,0.00200000}, {47,0.00200000}, {48,0.00200000}, {49,0.00200000}, {50,0.00200000}, {51,0.00200000}, {52,0.00201818}, {53,0.00200000}, {54,0.00200000}, {55,0.00200000}, {56,0.00200000}, {57,0.00386364}, {58,0.00201818}, {59,0.00201818}, {60,0.00203636}, {61,0.00210909}, {62,0.00230000}, {63,0.00246364}, {64,0.00270000}, {65,0.00283636}, {66,0.00296364}, {67,0.00299091}, {68,0.00300000}, {69,0.00301818}, {70,0.00300000}, {71,0.00300000}, {72,0.00300000}, {73,0.00400909}, {74,0.00300000}, {75,0.00300000}, {76,0.00300000}, {77,0.00300000}, {78,0.00300000}, {79,0.00300000}, {80,0.00301818}, {81,0.00303636}, {82,0.00310000}, {83,0.00319091}, {84,0.00348182}, {85,0.00361818}, {86,0.00376364}, {87,0.00391818}, {88,0.00395455}, {89,0.00399091}, {90,0.00400000}, {91,0.00400000}, {92,0.00400000}, {93,0.00400000}, {94,0.00400000}, {95,0.00401818}, {96,0.00400000}, {97,0.00400000}, {98,0.00510909}, {99,0.00400000}, {100,0.00400909}, {101,0.00401818}, {102,0.00408182}, {103,0.00410000}, {104,0.00426364}, {105,0.00442727}, {106,0.00458182}, {107,0.00472727}, {108,0.00475455}, {109,0.00485455}, {110,0.00494545}, {111,0.00498182}, {112,0.00498182}, {113,0.00500000}, {114,0.00500000}, {115,0.00500000}, {116,0.00500000}, {117,0.00500000}, {118,0.00717273}, {119,0.00500000}, {120,0.00500000}, {121,0.00500000}, {122,0.00500000}, {123,0.00501818}, {124,0.00501818}, {125,0.00514545}, {126,0.00529091}, {127,0.00850000}, {128,0.00560000}, {129,0.00570000}, {130,0.00578182}, {131,0.00587273}, {132,0.00589091}, {133,0.00594545}, {134,0.00598182}, {135,0.00600000}, {136,0.00730909}, {137,0.00600000}, {138,0.00600000}, {139,0.00600000}, {140,0.00600000}, {141,0.00600000}, {142,0.00600909}, {143,0.00600000}, {144,0.00746364}, {145,0.00602727}, {146,0.00605455}, {147,0.00621818}, {148,0.00630909}, {149,0.00650909}, {150,0.00659091}, {151,0.00671818}, {152,0.00681818}, {153,0.00687273}, {154,0.00685455}, {155,0.00690000}, {156,0.00697273}, {157,0.00698182}, {158,0.00699091}, {159,0.00793636}, {160,0.00700000}, {161,0.00700000}, {162,0.00700000}, {163,0.00700000}, {164,0.00703636}, {165,0.00700000}, {166,0.00800909}, {167,0.00709091}, {168,0.00717273}, {169,0.00721818}, {170,0.00738182}, {171,0.00747273}, {172,0.01158182}, {173,0.00768182}, {174,0.00776364}, {175,0.00777273}, {176,0.00784545}, {177,0.00790909}, {178,0.00795455}, {179,0.00933636}, {180,0.00797273}, {181,0.00800000}, {182,0.00800000}, {183,0.00804545}, {184,0.00800000}, {185,0.00973636}, {186,0.00801818}, {187,0.00801818}, {188,0.00805455}, {189,0.00806364}, {190,0.00813636}, {191,0.01014545}, {192,0.00840909}, {193,0.00850909}, {194,0.00863636}, {195,0.00876364}, {196,0.00870909}, {197,0.01023636}, {198,0.00880000}, {199,0.00888182}, {200,0.00891818}, {201,0.00896364}, {202,0.00895455}, {203,0.01047273}, {204,0.00900000}, {205,0.00900000}, {206,0.00900000}, {207,0.00903636}, {208,0.01377273}, {209,0.00905455}, {210,0.00905455}, {211,0.00914545}, {212,0.00923636}, {213,0.00928182}, {214,0.01100000}, {215,0.00954545}, {216,0.00960000}, {217,0.00967273}, {218,0.00973636}, {219,0.01166364}, {220,0.00980000}, {221,0.00980909}, {222,0.00990000}, {223,0.00993636}, {224,0.01364545}, {225,0.00998182}, {226,0.00999091}, {227,0.01000000}, {228,0.01004545}, {229,0.01003636}, {230,0.01006364}, {231,0.01005455}, {232,0.01005455}, {233,0.01020909}, {234,0.01563636}, {235,0.01030909}, {236,0.01036364}, {237,0.01049091}, {238,0.01061818}, {239,0.01287273}, {240,0.01073636}, {241,0.01079091}, {242,0.01080000}, {243,0.01083636}, {244,0.01445455}, {245,0.01091818}, {246,0.01091818}, {247,0.01106364}, {248,0.01098182}, {249,0.01266364}, {250,0.01101818}, {251,0.01103636}, {252,0.01106364}, {253,0.01609091}, {254,0.01111818}, {255,0.01111818}, {256,0.01122727}, {257,0.01132727}, {258,0.01380909}, {259,0.01151818}, {260,0.01161818}, {261,0.01170000}, {262,0.01655455}, {263,0.01176364}, {264,0.01177273}, {265,0.01179091}, {266,0.01186364}, {267,0.01395455}, {268,0.01198182}, {269,0.01196364}, {270,0.01202727}, {271,0.01390000}, {272,0.01201818}, {273,0.01203636}, {274,0.01210909}, {275,0.01620000}, {276,0.01216364}, {277,0.01227273}, {278,0.01238182}, {279,0.01240909}, {280,0.01247273}, {281,0.01256364}, {282,0.01265455}, {283,0.01269091}, {284,0.01370000}, {285,0.01273636}, {286,0.01277273}, {287,0.01281818}, {288,0.01446364}, {289,0.01289091}, {290,0.01290909}, {291,0.01294545}, {292,0.01471818}, {293,0.01300000}, {294,0.01303636}, {295,0.01306364}, {296,0.01472727}, {297,0.01312727}, {298,0.01320000}, {299,0.01331818}, {300,0.01408182}, {301,0.01345455}, {302,0.01364545}, {303,0.01364545}, {304,0.01368182}, {305,0.01369091}, {306,0.01380000}, {307,0.01798182}, {308,0.01382727}, {309,0.01381818}, {310,0.01381818}, {311,0.01759091}, {312,0.01389091}, {313,0.01389091}, {314,0.01401818}, {315,0.01606364}, {316,0.01403636}, {317,0.01408182}, {318,0.01410909}, {319,0.01416364}, {320,0.01425455}, {321,0.01425455}, {322,0.01693636}, {323,0.01438182}, {324,0.01452727}, {325,0.01461818}, {326,0.01666364}, {327,0.01467273}, {328,0.01481818}, {329,0.02025455}, {330,0.01477273}, {331,0.01478182}, {332,0.01486364}, {333,0.01810909}, {334,0.01484545}, {335,0.01498182}, {336,0.02193636}, {337,0.01497273}, {338,0.01502727}, {339,0.01515455}, {340,0.01776364}, {341,0.01515455}, {342,0.01530909}, {343,0.01863636}, {344,0.01540000}, {345,0.01544545}, {346,0.01560000}, {347,0.01967273}, {348,0.01566364}, {349,0.01574545}, {350,0.01789091}, {351,0.01571818}, {352,0.01571818}, {353,0.02283636}, {354,0.01579091}, {355,0.01583636}, {356,0.01590000}, {357,0.01837273}, {358,0.01599091}, {359,0.01605455}, {360,0.01891818}, {361,0.01613636}, {362,0.01626364}, {363,0.01941818}, {364,0.01626364}, {365,0.01635455}, {366,0.01647273}, {367,0.01649091}, {368,0.01657273}, {369,0.01665455}, {370,0.01668182}, {371,0.01669091}, {372,0.01678182}, {373,0.01909091}, {374,0.01677273}, {375,0.01682727}, {376,0.01972727}, {377,0.01683636}, {378,0.01693636}, {379,0.01959091}, {380,0.01697273}, {381,0.01711818}, {382,0.02003636}, {383,0.01715455}, {384,0.01722727}, {385,0.02055455}, {386,0.01731818}, {387,0.01759091}, {388,0.02080000}, {389,0.01759091}, {390,0.01779091}, {391,0.02112727}, {392,0.01769091}, {393,0.01781818}, {394,0.02127273}, {395,0.01775455}, {396,0.01788182}, {397,0.02130000}, {398,0.01781818}, {399,0.01796364}, {400,0.02120000}, {401,0.01789091}, {402,0.01801818}, {403,0.02092727}, {404,0.01802727}, {405,0.01812727}, {406,0.02072727}, {407,0.01820000}, {408,0.01828182}, {409,0.02143636}, {410,0.01843636}, {411,0.01861818}, {412,0.02085455}, {413,0.01860909}, {414,0.01872727}, {415,0.01960000}, {416,0.01871818}, {417,0.01879091}, {418,0.01880909}, {419,0.01879091}, {420,0.02251818}, {421,0.01884545}, {422,0.06008182}, {423,0.02504545}, {424,0.01899091}, {425,0.01919091}, {426,0.02198182}, {427,0.01917273}, {428,0.01931818}, {429,0.01927273}, {430,0.01930909}, {431,0.02717273}, {432,0.01957273}, {433,0.01969091}, {434,0.02401818}, {435,0.01964545}, {436,0.01987273}, {437,0.02236364}, {438,0.01976364}, {439,0.01982727}, {440,0.01975455}, {441,0.02004545}, {442,0.02368182}, {443,0.01987273}, {444,0.01999091}, {445,0.02274545}, {446,0.01999091}, {447,0.02011818}, {448,0.02008182}, {449,0.02025455}, {450,0.85341818}, {451,0.02037273}, {452,0.02058182}, {453,0.02349091}, {454,0.02049091}, {455,0.02722727}, {456,0.02060909}, {457,0.02073636}, {458,0.02694545}, {459,0.02068182}, {460,0.02083636}, {461,0.02075455}, {462,0.02089091}, {463,0.02455455}, {464,0.02081818}, {465,0.02099091}, {466,0.02089091}, {467,0.02114545}, {468,0.02511818}, {469,0.02109091}, {470,0.02116364}, {471,0.02240000}, {472,0.02135455}, {473,0.02543636}, {474,0.02144545}, {475,0.02161818}, {476,0.02261818}, {477,0.02181818}, {478,0.02550000}, {479,0.02165455}, {480,0.02176364}, {481,0.02171818}, {482,0.02185455}, {483,0.02557273}, {484,0.02179091}, {485,0.02191818}, {486,0.02181818}, {487,0.02196364}, {488,0.02645455}, {489,0.02200000}, {490,0.02991818}, {491,0.02205455}, {492,0.02218182}, {493,0.02780000}, {494,0.02225455}, {495,0.02630909}, {496,0.02246364}, {497,0.02256364}, {498,0.02257273}, {499,0.02266364}, {500,0.02627273}, {505,0.02280909}, {510,0.02738182}, {515,0.02332727}, {520,0.02363636}, {525,0.02375455}, {530,0.02400000}, {535,0.02716364}, {540,0.02463636}, {545,0.02892727}, {550,0.02482727}, {555,0.02920000}, {560,0.02535455}, {565,0.03044545}, {570,0.02580000}, {575,0.03341818}, {580,0.02624545}, {585,0.03941818}, {590,0.02676364}, {595,0.03946364}, {600,0.02713636}, {605,0.03831818}, {610,0.02766364}, {615,0.03595455}, {620,0.02810000}, {625,0.03749091}, {630,0.02858182}, {635,0.03303636}, {640,0.02898182}, {645,0.03388182}, {650,0.02963636}, {655,0.03331818}, {660,0.03001818}, {665,0.03013636}, {670,0.04584545}, {675,0.03067273}, {680,0.03846364}, {685,0.03121818}, {690,0.03677273}, {695,0.03167273}, {700,0.03172727}, {705,0.04007273}, {710,0.03230000}, {715,0.04266364}, {720,0.03283636}, {725,0.03409091}, {730,0.03829091}, {735,0.03347273}, {740,0.04434545}, {745,0.03392727}, {750,0.03408182}, {755,0.03963636}, {760,0.03471818}, {765,0.03730000}, {770,0.04131818}, {775,0.03540000}, {780,0.03944545}, {785,0.04194545}, {790,0.03620000}, {795,0.04663636}, {800,0.04321818}, {805,0.03684545}, {810,0.04702727}, {815,0.04416364}, {820,0.03742727}, {825,1.14214545}, {830,0.04561818}, {835,0.03815455}, {840,0.03822727}, {845,0.04419091}, {850,0.05916364}, {855,0.03920000}, {860,0.04591818}, {865,0.04719091}, {870,0.03970909}, {875,0.03983636}, {880,0.04773636}, {885,0.04840909}, {890,0.04063636}, {895,0.04052727}, {900,0.04748182}, {905,0.04820909}, {910,0.04168182}, {915,0.04172727}, {920,0.04920909}, {925,0.04922727}, {930,0.04249091}, {935,0.04294545}, {940,0.04744545}, {945,0.04856364}, {950,0.05190000}, {955,0.04374545}, {960,0.04389091}, {965,0.04959091}, {970,0.04987273}, {975,0.05243636}, {980,0.04489091}, {985,0.04521818}, {990,0.05032727}, {995,0.05360000}, {1000,0.05408182}, {1010,0.05708182}, {1020,0.04667273}, {1030,0.04719091}, {1040,0.04978182}, {1050,0.05330909}, {1060,0.05545455}, {1070,0.05532727}, {1080,0.05716364}, {1090,0.05908182}, {1100,0.06794545}, {1110,0.05089091}, {1120,0.05146364}, {1130,0.05180000}, {1140,0.05239091}, {1150,0.05260909}, {1160,0.05823636}, {1170,0.05880909}, {1180,0.05942727}, {1190,0.06001818}, {1200,0.06056364}, {1210,0.06131818}, {1220,0.06141818}, {1230,0.06245455}, {1240,0.06262727}, {1250,0.06119091}, {1260,0.05777273}, {1270,0.05844545}, {1280,0.05890909}, {1290,0.08219091}, {1300,0.07533636}, {1310,0.07880909}, {1320,0.06965455}, {1330,0.06878182}, {1340,0.07054545}, {1350,0.06939091}, {1360,0.06874545}, {1370,0.06288182}, {1380,0.08366364}, {1390,0.07989091}, {1400,0.07310000}, {1410,0.07447273}, {1420,0.07300000}, {1430,0.06481818}, {1440,0.08014545}, {1450,0.08600000}, {1460,0.07753636}, {1470,0.07544545}, {1480,0.09853636}, {1490,0.08106364}, {1500,0.07825455}, {1510,0.07625455}, {1520,0.09903636}, {1530,0.08342727}, {1540,0.08223636}, {1550,0.07908182}, {1560,0.08712727}, {1570,0.09232727}, {1580,0.08170000}, {1590,0.09434545}, {1600,0.09041818}, {1610,0.08390909}, {1620,0.09602727}, {1630,0.09290909}, {1640,0.08492727}, {1650,0.08896364}, {1660,0.09908182}, {1670,0.08465455}, {1680,0.09000000}, {1690,0.08850909}, {1700,0.09022727}, {1710,0.10000909}, {1720,0.10922727}, {1730,0.09248182}, {1740,0.08900000}, {1750,0.09459091}, {1760,0.09210000}, {1770,0.09569091}, {1780,0.09254545}, {1790,0.09827273}, {1800,0.09720909}, {1810,0.09893636}, {1820,0.09817273}, {1830,0.09855455}, {1840,0.09630000}, {1850,0.09879091}, {1860,0.09613636}, {1870,0.09960000}, {1880,0.12030909}, {1890,0.10161818}, {1900,0.10696364}, {1910,0.11235455}, {1920,0.10211818}, {1930,0.09996364}, {1940,0.10180909}, {1950,0.10712727}, {1960,0.11160000}, {1970,0.10430909}, {1980,0.12408182}, {1990,0.11132727}, {2000,0.10884545}, {2050,0.12644545}, {2100,0.11649091}, {2150,0.11318182}, {2200,0.11662727}, {2250,0.11725455}, {2300,0.13375455}, {2350,0.15551818}, {2400,0.15594545}, {2450,0.15526364}, {2500,0.14856364}, {2550,0.15048182}, {2600,0.13573636}, {2650,0.13966364}, {2700,0.13935455}, {2750,0.16435455}, {2800,0.15997273}, {2850,0.14896364}, {2900,0.16710909}, {2950,0.17067273}, {3000,0.18432727}, {3050,0.16816364}, {3100,0.17972727}, {3150,0.18306364}, {3200,0.17228182}, {3250,0.19694545}, {3300,0.18604545}, {3350,0.18126364}, {3400,0.18616364}, {3450,0.18910000}, {3500,0.22980000}, {3550,0.23649091}, {3600,0.23255455}, {3650,0.23227273}, {3700,0.23141818}, {3750,0.22550000}, {3800,0.19990909}, {3850,0.20790909}, {3900,0.20784545}, {3950,0.24727273}, {4000,0.23126364}, {4050,0.21744545}, {4100,0.24867273}, {4150,0.24694545}, {4200,0.27126364}, {4250,0.24731818}, {4300,0.26775455}, {4350,0.27250909}, {4400,0.24231818}, {4450,0.28804545}, {4500,0.25487273}, {4550,0.23987273}, {4600,0.26389091}, {4650,0.28550909}, {4700,0.29736364}, {4750,0.33018182}, {4800,0.33661818}, {4850,0.33926364}, {4900,0.33415455}, {4950,0.32628182}, {5000,0.29512727}, {5050,0.28520000}, {5100,0.27338182}, {5150,0.27878182}, {5200,0.33366364}, {5250,0.28540000}, {5300,0.28997273}, {5350,0.32378182}, {5400,0.29040909}, {5450,0.33285455}, {5500,0.29277273}, {5550,0.32467273}, {5600,0.37273636}, {5650,0.29595455}, {5700,0.33348182}, {5750,0.36343636}, {5800,0.38813636}, {5850,0.30459091}, {5900,0.32469091}, {5950,0.32774545}, {6000,0.32802727}, {6050,0.33287273}, {6100,0.33343636}, {6150,0.34030909}, {6200,0.33824545}, {6250,0.42132727}, {6300,0.39585455}, {6350,0.37310909}, {6400,0.34934545}, {6450,0.42703636}, {6500,0.38080909}, {6550,0.35248182}, {6600,0.39137273}, {6650,0.36140909}, {6700,0.38659091}, {6750,0.47237273}, {6800,0.38987273}, {6850,0.44451818}, {6900,0.38130000}, {6950,0.38641818}, {7000,0.41829091}, {7050,0.45791818}, {7100,0.46476364}, {7150,0.47823636}, {7200,0.48725455}, {7250,0.49486364}, {7300,0.49150000}, {7350,0.48576364}, {7400,0.47566364}, {7450,0.45761818}, {7500,0.44963636}, {7550,0.41431818}, {7600,0.50348182}, {7650,0.46984545}, {7700,0.44195455}, {7750,0.50075455}, {7800,0.45215455}, {7850,0.50398182}, {7900,0.45851818}, {7950,0.50092727}, {8000,0.44049091}, {8050,0.49015455}, {8100,0.54581818}, {8150,0.43757273}, {8200,0.47136364}, {8250,0.49026364}, {8300,0.52060000}, {8350,0.54320909}, {8400,0.56481818}, {8450,0.57860000}, {8500,0.57430000}, {8550,0.56148182}, {8600,0.55410909}, {8650,0.53614545}, {8700,0.48464545}, {8750,0.60213636}, {8800,0.58065455}, {8850,0.54823636}, {8900,0.48125455}, {8950,0.58225455}, {9000,0.53086364}};
data["big"]["TemplateCoq"]["norm reif"]["user"] = {{1,0.00020909}, {2,0.00010909}, {3,0.00031818}, {4,0.00027273}, {5,0.00053636}, {6,0.00040000}, {7,0.00022727}, {8,0.00049091}, {9,0.00054545}, {10,0.00046364}, {11,0.00059091}, {12,0.00062727}, {13,0.00079091}, {14,0.00076364}, {15,0.00069091}, {16,0.00065455}, {17,0.00076364}, {18,0.00080909}, {19,0.00091818}, {20,0.00077273}, {21,0.00069091}, {22,0.00102727}, {23,0.00114545}, {24,0.00091818}, {25,0.00097273}, {26,0.00140909}, {27,0.00104545}, {28,0.00107273}, {29,0.00120909}, {30,0.00166364}, {31,0.00120000}, {32,0.00110000}, {33,0.00135455}, {34,0.00139091}, {35,0.00167273}, {36,0.00178182}, {37,0.00176364}, {38,0.00164545}, {39,0.00173636}, {40,0.00195455}, {41,0.00196364}, {42,0.00168182}, {43,0.00170909}, {44,0.00177273}, {45,0.00190909}, {46,0.00197273}, {47,0.00200000}, {48,0.00200909}, {49,0.00207273}, {50,0.00188182}, {51,0.00205455}, {52,0.00200000}, {53,0.00206364}, {54,0.00217273}, {55,0.00204545}, {56,0.00214545}, {57,0.00379091}, {58,0.00215455}, {59,0.00264545}, {60,0.00212727}, {61,0.00243636}, {62,0.00241818}, {63,0.00259091}, {64,0.00247273}, {65,0.00242727}, {66,0.00269091}, {67,0.00283636}, {68,0.00242727}, {69,0.00273636}, {70,0.00274545}, {71,0.00290909}, {72,0.00292727}, {73,0.00403636}, {74,0.00290909}, {75,0.00295455}, {76,0.00274545}, {77,0.00297273}, {78,0.00298182}, {79,0.00306364}, {80,0.00316364}, {81,0.00319091}, {82,0.00320909}, {83,0.00328182}, {84,0.00337273}, {85,0.00337273}, {86,0.00358182}, {87,0.00339091}, {88,0.00340909}, {89,0.00359091}, {90,0.00353636}, {91,0.00364545}, {92,0.00373636}, {93,0.00376364}, {94,0.00360909}, {95,0.00368182}, {96,0.00379091}, {97,0.00413636}, {98,0.00536364}, {99,0.00384545}, {100,0.00424545}, {101,0.00390000}, {102,0.00427273}, {103,0.00441818}, {104,0.00464545}, {105,0.00452727}, {106,0.00446364}, {107,0.00447273}, {108,0.00433636}, {109,0.00430000}, {110,0.00420909}, {111,0.00410000}, {112,0.00420909}, {113,0.00454545}, {114,0.00500909}, {115,0.00504545}, {116,0.00504545}, {117,0.00494545}, {118,0.00728182}, {119,0.00524545}, {120,0.00511818}, {121,0.00506364}, {122,0.00489091}, {123,0.00526364}, {124,0.00551818}, {125,0.00520000}, {126,0.00495455}, {127,0.00853636}, {128,0.00550000}, {129,0.00571818}, {130,0.00565455}, {131,0.00595455}, {132,0.00566364}, {133,0.00543636}, {134,0.00627273}, {135,0.00580000}, {136,0.00760000}, {137,0.00580909}, {138,0.00600909}, {139,0.00605455}, {140,0.00601818}, {141,0.00580000}, {142,0.00642727}, {143,0.00595455}, {144,0.00759091}, {145,0.00631818}, {146,0.00610000}, {147,0.00660909}, {148,0.00643636}, {149,0.00655455}, {150,0.00668182}, {151,0.00656364}, {152,0.00653636}, {153,0.00675455}, {154,0.00680909}, {155,0.00638182}, {156,0.00703636}, {157,0.00705455}, {158,0.00668182}, {159,0.00800909}, {160,0.00712727}, {161,0.00720000}, {162,0.00717273}, {163,0.00737273}, {164,0.00729091}, {165,0.00717273}, {166,0.00829091}, {167,0.00724545}, {168,0.00756364}, {169,0.00737273}, {170,0.00750000}, {171,0.00758182}, {172,0.01199091}, {173,0.00768182}, {174,0.00779091}, {175,0.00768182}, {176,0.00784545}, {177,0.00791818}, {178,0.00782727}, {179,0.00947273}, {180,0.00809091}, {181,0.00843636}, {182,0.00813636}, {183,0.00815455}, {184,0.00822727}, {185,0.01008182}, {186,0.00840000}, {187,0.00858182}, {188,0.00832727}, {189,0.00847273}, {190,0.00828182}, {191,0.01082727}, {192,0.00900000}, {193,0.00832727}, {194,0.00870000}, {195,0.00869091}, {196,0.00876364}, {197,0.01049091}, {198,0.00905455}, {199,0.00917273}, {200,0.00877273}, {201,0.00918182}, {202,0.00917273}, {203,0.01063636}, {204,0.00953636}, {205,0.00884545}, {206,0.00952727}, {207,0.00922727}, {208,0.01386364}, {209,0.00959091}, {210,0.00944545}, {211,0.00936364}, {212,0.00995455}, {213,0.00940909}, {214,0.01143636}, {215,0.00996364}, {216,0.00970000}, {217,0.01002727}, {218,0.00999091}, {219,0.01200000}, {220,0.00999091}, {221,0.00976364}, {222,0.01019091}, {223,0.01055455}, {224,0.01343636}, {225,0.01057273}, {226,0.01022727}, {227,0.01040000}, {228,0.01032727}, {229,0.01055455}, {230,0.01033636}, {231,0.01076364}, {232,0.01082727}, {233,0.01072727}, {234,0.01539091}, {235,0.01072727}, {236,0.01065455}, {237,0.01064545}, {238,0.01067273}, {239,0.01332727}, {240,0.01090000}, {241,0.01090000}, {242,0.01095455}, {243,0.01101818}, {244,0.01451818}, {245,0.01137273}, {246,0.01153636}, {247,0.01157273}, {248,0.01125455}, {249,0.01306364}, {250,0.01171818}, {251,0.01150000}, {252,0.01147273}, {253,0.01611818}, {254,0.01171818}, {255,0.01170909}, {256,0.01154545}, {257,0.01175455}, {258,0.01406364}, {259,0.01188182}, {260,0.01184545}, {261,0.01198182}, {262,0.01646364}, {263,0.01203636}, {264,0.01221818}, {265,0.01230909}, {266,0.01214545}, {267,0.01417273}, {268,0.01234545}, {269,0.01200000}, {270,0.01239091}, {271,0.01380000}, {272,0.01249091}, {273,0.01250000}, {274,0.01269091}, {275,0.01592727}, {276,0.01269091}, {277,0.01257273}, {278,0.01271818}, {279,0.01284545}, {280,0.01290000}, {281,0.01253636}, {282,0.01292727}, {283,0.01281818}, {284,0.01341818}, {285,0.01287273}, {286,0.01330909}, {287,0.01276364}, {288,0.01435455}, {289,0.01310000}, {290,0.01310909}, {291,0.01325455}, {292,0.01479091}, {293,0.01318182}, {294,0.01334545}, {295,0.01318182}, {296,0.01456364}, {297,0.01336364}, {298,0.01300000}, {299,0.01296364}, {300,0.01425455}, {301,0.01341818}, {302,0.01373636}, {303,0.01352727}, {304,0.01365455}, {305,0.01380000}, {306,0.01370000}, {307,0.01810000}, {308,0.01381818}, {309,0.01390909}, {310,0.01398182}, {311,0.01735455}, {312,0.01369091}, {313,0.01392727}, {314,0.01427273}, {315,0.01610000}, {316,0.01400909}, {317,0.01417273}, {318,0.01438182}, {319,0.01406364}, {320,0.01429091}, {321,0.01432727}, {322,0.01723636}, {323,0.01431818}, {324,0.01404545}, {325,0.01436364}, {326,0.01624545}, {327,0.01428182}, {328,0.01463636}, {329,0.02055455}, {330,0.01473636}, {331,0.01490000}, {332,0.01484545}, {333,0.01815455}, {334,0.01484545}, {335,0.01480909}, {336,0.02201818}, {337,0.01490000}, {338,0.01475455}, {339,0.01516364}, {340,0.01772727}, {341,0.01493636}, {342,0.01513636}, {343,0.01865455}, {344,0.01531818}, {345,0.01519091}, {346,0.01522727}, {347,0.01974545}, {348,0.01533636}, {349,0.01557273}, {350,0.01787273}, {351,0.01546364}, {352,0.01582727}, {353,0.02290000}, {354,0.01560909}, {355,0.01575455}, {356,0.01575455}, {357,0.01789091}, {358,0.01592727}, {359,0.01604545}, {360,0.01900909}, {361,0.01585455}, {362,0.01633636}, {363,0.01958182}, {364,0.01598182}, {365,0.01597273}, {366,0.01581818}, {367,0.01628182}, {368,0.01609091}, {369,0.01624545}, {370,0.01643636}, {371,0.01640909}, {372,0.01674545}, {373,0.01920909}, {374,0.01645455}, {375,0.01652727}, {376,0.01962727}, {377,0.01693636}, {378,0.01707273}, {379,0.01941818}, {380,0.01668182}, {381,0.01691818}, {382,0.02031818}, {383,0.01708182}, {384,0.01718182}, {385,0.02040000}, {386,0.01738182}, {387,0.01756364}, {388,0.02127273}, {389,0.01764545}, {390,0.01779091}, {391,0.02144545}, {392,0.01763636}, {393,0.01761818}, {394,0.02147273}, {395,0.01797273}, {396,0.01790909}, {397,0.02145455}, {398,0.01778182}, {399,0.01793636}, {400,0.02107273}, {401,0.01773636}, {402,0.01812727}, {403,0.02086364}, {404,0.01802727}, {405,0.01840909}, {406,0.02060000}, {407,0.01836364}, {408,0.01820000}, {409,0.02146364}, {410,0.01860000}, {411,0.01866364}, {412,0.02160909}, {413,0.01868182}, {414,0.01870909}, {415,0.01980000}, {416,0.01852727}, {417,0.01925455}, {418,0.01896364}, {419,0.01881818}, {420,0.02285455}, {421,0.01879091}, {422,0.06024545}, {423,0.02534545}, {424,0.01920000}, {425,0.01915455}, {426,0.02224545}, {427,0.01915455}, {428,0.01950909}, {429,0.01927273}, {430,0.01950909}, {431,0.02722727}, {432,0.01977273}, {433,0.01970000}, {434,0.02424545}, {435,0.01967273}, {436,0.02013636}, {437,0.02229091}, {438,0.01974545}, {439,0.01983636}, {440,0.01982727}, {441,0.02015455}, {442,0.02388182}, {443,0.01993636}, {444,0.02010000}, {445,0.02295455}, {446,0.02043636}, {447,0.02040909}, {448,0.02002727}, {449,0.02062727}, {450,0.85277273}, {451,0.02091818}, {452,0.02045455}, {453,0.02363636}, {454,0.02064545}, {455,0.02753636}, {456,0.02068182}, {457,0.02078182}, {458,0.02710909}, {459,0.02079091}, {460,0.02091818}, {461,0.02087273}, {462,0.02117273}, {463,0.02480000}, {464,0.02072727}, {465,0.02124545}, {466,0.02093636}, {467,0.02143636}, {468,0.02533636}, {469,0.02165455}, {470,0.02142727}, {471,0.02247273}, {472,0.02169091}, {473,0.02541818}, {474,0.02173636}, {475,0.02171818}, {476,0.02261818}, {477,0.02230000}, {478,0.02554545}, {479,0.02206364}, {480,0.02211818}, {481,0.02156364}, {482,0.02244545}, {483,0.02556364}, {484,0.02199091}, {485,0.02257273}, {486,0.02241818}, {487,0.02226364}, {488,0.02636364}, {489,0.02244545}, {490,0.02990909}, {491,0.02249091}, {492,0.02236364}, {493,0.02750909}, {494,0.02251818}, {495,0.02638182}, {496,0.02263636}, {497,0.02272727}, {498,0.02286364}, {499,0.02300000}, {500,0.02630000}, {505,0.02301818}, {510,0.02716364}, {515,0.02371818}, {520,0.02396364}, {525,0.02402727}, {530,0.02440000}, {535,0.02710909}, {540,0.02497273}, {545,0.02883636}, {550,0.02519091}, {555,0.02892727}, {560,0.02531818}, {565,0.03021818}, {570,0.02580909}, {575,0.03372727}, {580,0.02648182}, {585,0.03915455}, {590,0.02639091}, {595,0.03920000}, {600,0.02690909}, {605,0.03841818}, {610,0.02754545}, {615,0.03615455}, {620,0.02763636}, {625,0.03740000}, {630,0.02846364}, {635,0.03345455}, {640,0.02897273}, {645,0.03391818}, {650,0.02936364}, {655,0.03375455}, {660,0.03007273}, {665,0.03026364}, {670,0.04570000}, {675,0.03070000}, {680,0.03863636}, {685,0.03140909}, {690,0.03684545}, {695,0.03170000}, {700,0.03182727}, {705,0.03991818}, {710,0.03240909}, {715,0.04257273}, {720,0.03289091}, {725,0.03451818}, {730,0.03825455}, {735,0.03323636}, {740,0.04441818}, {745,0.03433636}, {750,0.03407273}, {755,0.03944545}, {760,0.03493636}, {765,0.03743636}, {770,0.04110000}, {775,0.03584545}, {780,0.03930909}, {785,0.04179091}, {790,0.03633636}, {795,0.04694545}, {800,0.04306364}, {805,0.03701818}, {810,0.04716364}, {815,0.04440000}, {820,0.03764545}, {825,1.14037273}, {830,0.04577273}, {835,0.03823636}, {840,0.03788182}, {845,0.04385455}, {850,0.05933636}, {855,0.03915455}, {860,0.04611818}, {865,0.04732727}, {870,0.03967273}, {875,0.03988182}, {880,0.04792727}, {885,0.04880000}, {890,0.04048182}, {895,0.04031818}, {900,0.04762727}, {905,0.04826364}, {910,0.04190909}, {915,0.04184545}, {920,0.04950000}, {925,0.04924545}, {930,0.04220909}, {935,0.04292727}, {940,0.04761818}, {945,0.04840000}, {950,0.05176364}, {955,0.04381818}, {960,0.04416364}, {965,0.04977273}, {970,0.05016364}, {975,0.05230000}, {980,0.04500909}, {985,0.04547273}, {990,0.05013636}, {995,0.05350909}, {1000,0.05375455}, {1010,0.05710000}, {1020,0.04703636}, {1030,0.04744545}, {1040,0.04953636}, {1050,0.05320000}, {1060,0.05538182}, {1070,0.05541818}, {1080,0.05758182}, {1090,0.05936364}, {1100,0.06787273}, {1110,0.05072727}, {1120,0.05135455}, {1130,0.05155455}, {1140,0.05234545}, {1150,0.05248182}, {1160,0.05834545}, {1170,0.05914545}, {1180,0.05963636}, {1190,0.06028182}, {1200,0.06073636}, {1210,0.06139091}, {1220,0.06160909}, {1230,0.06245455}, {1240,0.06221818}, {1250,0.06160000}, {1260,0.05776364}, {1270,0.05900000}, {1280,0.05893636}, {1290,0.08227273}, {1300,0.07540000}, {1310,0.07900000}, {1320,0.07019091}, {1330,0.06905455}, {1340,0.07070909}, {1350,0.06954545}, {1360,0.06877273}, {1370,0.06275455}, {1380,0.08413636}, {1390,0.07996364}, {1400,0.07292727}, {1410,0.07440909}, {1420,0.07296364}, {1430,0.06450000}, {1440,0.08035455}, {1450,0.08585455}, {1460,0.07737273}, {1470,0.07558182}, {1480,0.09825455}, {1490,0.08127273}, {1500,0.07806364}, {1510,0.07619091}, {1520,0.09924545}, {1530,0.08339091}, {1540,0.08258182}, {1550,0.07915455}, {1560,0.08679091}, {1570,0.09240909}, {1580,0.08185455}, {1590,0.09465455}, {1600,0.09044545}, {1610,0.08403636}, {1620,0.09628182}, {1630,0.09303636}, {1640,0.08512727}, {1650,0.08887273}, {1660,0.09896364}, {1670,0.08476364}, {1680,0.08991818}, {1690,0.08830000}, {1700,0.09023636}, {1710,0.10004545}, {1720,0.10885455}, {1730,0.09263636}, {1740,0.08920000}, {1750,0.09473636}, {1760,0.09207273}, {1770,0.09570909}, {1780,0.09253636}, {1790,0.09818182}, {1800,0.09723636}, {1810,0.09871818}, {1820,0.09810909}, {1830,0.09840909}, {1840,0.09622727}, {1850,0.09845455}, {1860,0.09620000}, {1870,0.09950909}, {1880,0.12036364}, {1890,0.10180000}, {1900,0.10679091}, {1910,0.11242727}, {1920,0.10238182}, {1930,0.09976364}, {1940,0.10159091}, {1950,0.10687273}, {1960,0.11180000}, {1970,0.10460909}, {1980,0.12410909}, {1990,0.11145455}, {2000,0.10933636}, {2050,0.12620000}, {2100,0.11656364}, {2150,0.11312727}, {2200,0.11658182}, {2250,0.11753636}, {2300,0.13426364}, {2350,0.15515455}, {2400,0.15549091}, {2450,0.15517273}, {2500,0.14831818}, {2550,0.15086364}, {2600,0.13540000}, {2650,0.13952727}, {2700,0.13901818}, {2750,0.16450000}, {2800,0.15993636}, {2850,0.14917273}, {2900,0.16729091}, {2950,0.17044545}, {3000,0.18403636}, {3050,0.16801818}, {3100,0.17922727}, {3150,0.18272727}, {3200,0.17200000}, {3250,0.19690000}, {3300,0.18564545}, {3350,0.18100909}, {3400,0.18606364}, {3450,0.18923636}, {3500,0.22920000}, {3550,0.23543636}, {3600,0.23135455}, {3650,0.23150909}, {3700,0.23083636}, {3750,0.22491818}, {3800,0.19978182}, {3850,0.20747273}, {3900,0.20779091}, {3950,0.24666364}, {4000,0.23041818}, {4050,0.21700909}, {4100,0.24807273}, {4150,0.24629091}, {4200,0.27060000}, {4250,0.24695455}, {4300,0.26742727}, {4350,0.27238182}, {4400,0.24187273}, {4450,0.28742727}, {4500,0.25435455}, {4550,0.23884545}, {4600,0.26358182}, {4650,0.28486364}, {4700,0.29660909}, {4750,0.32928182}, {4800,0.33542727}, {4850,0.33845455}, {4900,0.33316364}, {4950,0.32541818}, {5000,0.29502727}, {5050,0.28470909}, {5100,0.27325455}, {5150,0.27848182}, {5200,0.33378182}, {5250,0.28553636}, {5300,0.29008182}, {5350,0.32346364}, {5400,0.29029091}, {5450,0.33254545}, {5500,0.29259091}, {5550,0.32441818}, {5600,0.37183636}, {5650,0.29580000}, {5700,0.33330000}, {5750,0.36271818}, {5800,0.38801818}, {5850,0.30426364}, {5900,0.32474545}, {5950,0.32767273}, {6000,0.32783636}, {6050,0.33271818}, {6100,0.33345455}, {6150,0.33994545}, {6200,0.33840000}, {6250,0.42085455}, {6300,0.39585455}, {6350,0.37295455}, {6400,0.34938182}, {6450,0.42680909}, {6500,0.38031818}, {6550,0.35222727}, {6600,0.39117273}, {6650,0.36100000}, {6700,0.38638182}, {6750,0.47193636}, {6800,0.38952727}, {6850,0.44445455}, {6900,0.38142727}, {6950,0.38650000}, {7000,0.41822727}, {7050,0.45824545}, {7100,0.46424545}, {7150,0.47814545}, {7200,0.48684545}, {7250,0.49444545}, {7300,0.49155455}, {7350,0.48566364}, {7400,0.47541818}, {7450,0.45720909}, {7500,0.44911818}, {7550,0.41417273}, {7600,0.50325455}, {7650,0.46957273}, {7700,0.44211818}, {7750,0.50061818}, {7800,0.45196364}, {7850,0.50383636}, {7900,0.45816364}, {7950,0.50065455}, {8000,0.44043636}, {8050,0.48990000}, {8100,0.54580909}, {8150,0.43721818}, {8200,0.47134545}, {8250,0.49011818}, {8300,0.52075455}, {8350,0.54314545}, {8400,0.56492727}, {8450,0.57870000}, {8500,0.57426364}, {8550,0.56115455}, {8600,0.55380909}, {8650,0.53587273}, {8700,0.48427273}, {8750,0.60216364}, {8800,0.58054545}, {8850,0.54823636}, {8900,0.48095455}, {8950,0.58194545}, {9000,0.53001818}};
data["big"]["TemplateCoq"]["norm reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003636}, {4,0.00000000}, {5,0.00003636}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00003636}, {10,0.00003636}, {11,0.00000000}, {12,0.00003636}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00007273}, {17,0.00000000}, {18,0.00000000}, {19,0.00002727}, {20,0.00007273}, {21,0.00007273}, {22,0.00003636}, {23,0.00000000}, {24,0.00000000}, {25,0.00003636}, {26,0.00000000}, {27,0.00000000}, {28,0.00003636}, {29,0.00000000}, {30,0.00003636}, {31,0.00000000}, {32,0.00000000}, {33,0.00006364}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00007273}, {39,0.00000000}, {40,0.00000000}, {41,0.00003636}, {42,0.00003636}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00010909}, {47,0.00003636}, {48,0.00007273}, {49,0.00000000}, {50,0.00000000}, {51,0.00003636}, {52,0.00003636}, {53,0.00000000}, {54,0.00000000}, {55,0.00002727}, {56,0.00007273}, {57,0.00000000}, {58,0.00003636}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00003636}, {65,0.00000000}, {66,0.00002727}, {67,0.00007273}, {68,0.00007273}, {69,0.00000000}, {70,0.00007273}, {71,0.00003636}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00003636}, {76,0.00007273}, {77,0.00003636}, {78,0.00003636}, {79,0.00010909}, {80,0.00003636}, {81,0.00000000}, {82,0.00000000}, {83,0.00003636}, {84,0.00003636}, {85,0.00000000}, {86,0.00003636}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00003636}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00007273}, {96,0.00007273}, {97,0.00000000}, {98,0.00000000}, {99,0.00003636}, {100,0.00000000}, {101,0.00007273}, {102,0.00003636}, {103,0.00000000}, {104,0.00000000}, {105,0.00003636}, {106,0.00007273}, {107,0.00007273}, {108,0.00010909}, {109,0.00003636}, {110,0.00003636}, {111,0.00003636}, {112,0.00010000}, {113,0.00003636}, {114,0.00003636}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00007273}, {119,0.00003636}, {120,0.00006364}, {121,0.00010909}, {122,0.00000000}, {123,0.00010909}, {124,0.00000000}, {125,0.00003636}, {126,0.00003636}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00007273}, {132,0.00003636}, {133,0.00000000}, {134,0.00007273}, {135,0.00003636}, {136,0.00000000}, {137,0.00003636}, {138,0.00003636}, {139,0.00007273}, {140,0.00000000}, {141,0.00007273}, {142,0.00000000}, {143,0.00007273}, {144,0.00000000}, {145,0.00002727}, {146,0.00003636}, {147,0.00000000}, {148,0.00007273}, {149,0.00003636}, {150,0.00003636}, {151,0.00000000}, {152,0.00003636}, {153,0.00007273}, {154,0.00003636}, {155,0.00003636}, {156,0.00003636}, {157,0.00000000}, {158,0.00000000}, {159,0.00007273}, {160,0.00003636}, {161,0.00003636}, {162,0.00003636}, {163,0.00000000}, {164,0.00000000}, {165,0.00003636}, {166,0.00014545}, {167,0.00000000}, {168,0.00000000}, {169,0.00003636}, {170,0.00000000}, {171,0.00003636}, {172,0.00000000}, {173,0.00003636}, {174,0.00000000}, {175,0.00003636}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00003636}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00003636}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00007273}, {190,0.00002727}, {191,0.00000000}, {192,0.00003636}, {193,0.00010000}, {194,0.00000000}, {195,0.00003636}, {196,0.00010909}, {197,0.00000000}, {198,0.00000000}, {199,0.00003636}, {200,0.00006364}, {201,0.00003636}, {202,0.00000000}, {203,0.00002727}, {204,0.00000000}, {205,0.00010909}, {206,0.00000000}, {207,0.00003636}, {208,0.00003636}, {209,0.00000000}, {210,0.00000000}, {211,0.00003636}, {212,0.00000000}, {213,0.00003636}, {214,0.00003636}, {215,0.00000000}, {216,0.00007273}, {217,0.00007273}, {218,0.00003636}, {219,0.00003636}, {220,0.00007273}, {221,0.00000000}, {222,0.00007273}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00003636}, {227,0.00003636}, {228,0.00003636}, {229,0.00010909}, {230,0.00003636}, {231,0.00007273}, {232,0.00000000}, {233,0.00007273}, {234,0.00007273}, {235,0.00003636}, {236,0.00007273}, {237,0.00003636}, {238,0.00003636}, {239,0.00000000}, {240,0.00002727}, {241,0.00003636}, {242,0.00003636}, {243,0.00003636}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00003636}, {248,0.00007273}, {249,0.00000000}, {250,0.00003636}, {251,0.00002727}, {252,0.00007273}, {253,0.00000000}, {254,0.00000000}, {255,0.00003636}, {256,0.00010909}, {257,0.00003636}, {258,0.00000000}, {259,0.00000000}, {260,0.00003636}, {261,0.00003636}, {262,0.00003636}, {263,0.00000000}, {264,0.00003636}, {265,0.00007273}, {266,0.00014545}, {267,0.00014545}, {268,0.00000000}, {269,0.00014545}, {270,0.00003636}, {271,0.00007273}, {272,0.00000000}, {273,0.00000000}, {274,0.00003636}, {275,0.00003636}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00007273}, {280,0.00003636}, {281,0.00003636}, {282,0.00000000}, {283,0.00003636}, {284,0.00000000}, {285,0.00007273}, {286,0.00000000}, {287,0.00010909}, {288,0.00003636}, {289,0.00007273}, {290,0.00000000}, {291,0.00010909}, {292,0.00007273}, {293,0.00007273}, {294,0.00007273}, {295,0.00003636}, {296,0.00003636}, {297,0.00000000}, {298,0.00007273}, {299,0.00000000}, {300,0.00003636}, {301,0.00006364}, {302,0.00000000}, {303,0.00000000}, {304,0.00003636}, {305,0.00000000}, {306,0.00003636}, {307,0.00007273}, {308,0.00014545}, {309,0.00007273}, {310,0.00000000}, {311,0.00000000}, {312,0.00003636}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00010909}, {317,0.00003636}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00010000}, {324,0.00010909}, {325,0.00007273}, {326,0.00007273}, {327,0.00007273}, {328,0.00003636}, {329,0.00007273}, {330,0.00003636}, {331,0.00000000}, {332,0.00007273}, {333,0.00007273}, {334,0.00000000}, {335,0.00007273}, {336,0.00010909}, {337,0.00000000}, {338,0.00007273}, {339,0.00000000}, {340,0.00007273}, {341,0.00003636}, {342,0.00003636}, {343,0.00003636}, {344,0.00000000}, {345,0.00003636}, {346,0.00003636}, {347,0.00003636}, {348,0.00000000}, {349,0.00003636}, {350,0.00007273}, {351,0.00003636}, {352,0.00003636}, {353,0.00007273}, {354,0.00007273}, {355,0.00003636}, {356,0.00007273}, {357,0.00003636}, {358,0.00002727}, {359,0.00007273}, {360,0.00007273}, {361,0.00010909}, {362,0.00003636}, {363,0.00007273}, {364,0.00000000}, {365,0.00003636}, {366,0.00007273}, {367,0.00000000}, {368,0.00006364}, {369,0.00003636}, {370,0.00003636}, {371,0.00000000}, {372,0.00003636}, {373,0.00000000}, {374,0.00003636}, {375,0.00007273}, {376,0.00003636}, {377,0.00000000}, {378,0.00003636}, {379,0.00007273}, {380,0.00010909}, {381,0.00003636}, {382,0.00003636}, {383,0.00007273}, {384,0.00003636}, {385,0.00007273}, {386,0.00007273}, {387,0.00010000}, {388,0.00000000}, {389,0.00000000}, {390,0.00007273}, {391,0.00003636}, {392,0.00003636}, {393,0.00000000}, {394,0.00000000}, {395,0.00003636}, {396,0.00003636}, {397,0.00000000}, {398,0.00000000}, {399,0.00010909}, {400,0.00000000}, {401,0.00003636}, {402,0.00000000}, {403,0.00006364}, {404,0.00002727}, {405,0.00002727}, {406,0.00007273}, {407,0.00003636}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00003636}, {412,0.00003636}, {413,0.00003636}, {414,0.00007273}, {415,0.00000000}, {416,0.00014545}, {417,0.00003636}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00007273}, {423,0.00003636}, {424,0.00007273}, {425,0.00010909}, {426,0.00010000}, {427,0.00003636}, {428,0.00000000}, {429,0.00003636}, {430,0.00007273}, {431,0.00000000}, {432,0.00003636}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00003636}, {438,0.00003636}, {439,0.00000000}, {440,0.00007273}, {441,0.00007273}, {442,0.00007273}, {443,0.00003636}, {444,0.00014545}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00003636}, {449,0.00003636}, {450,0.00079091}, {451,0.00000000}, {452,0.00000000}, {453,0.00003636}, {454,0.00000000}, {455,0.00003636}, {456,0.00003636}, {457,0.00003636}, {458,0.00007273}, {459,0.00007273}, {460,0.00003636}, {461,0.00007273}, {462,0.00003636}, {463,0.00003636}, {464,0.00000000}, {465,0.00000000}, {466,0.00003636}, {467,0.00003636}, {468,0.00003636}, {469,0.00000000}, {470,0.00010909}, {471,0.00003636}, {472,0.00010909}, {473,0.00003636}, {474,0.00010909}, {475,0.00000000}, {476,0.00013636}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00003636}, {483,0.00007273}, {484,0.00007273}, {485,0.00000000}, {486,0.00000000}, {487,0.00003636}, {488,0.00003636}, {489,0.00003636}, {490,0.00006364}, {491,0.00007273}, {492,0.00003636}, {493,0.00002727}, {494,0.00003636}, {495,0.00003636}, {496,0.00003636}, {497,0.00007273}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00007273}, {515,0.00003636}, {520,0.00003636}, {525,0.00000000}, {530,0.00003636}, {535,0.00007273}, {540,0.00002727}, {545,0.00003636}, {550,0.00013636}, {555,0.00000000}, {560,0.00000000}, {565,0.00003636}, {570,0.00010909}, {575,0.00003636}, {580,0.00002727}, {585,0.00010909}, {590,0.00017273}, {595,0.00000000}, {600,0.00007273}, {605,0.00003636}, {610,0.00007273}, {615,0.00003636}, {620,0.00000000}, {625,0.00007273}, {630,0.00007273}, {635,0.00003636}, {640,0.00003636}, {645,0.00003636}, {650,0.00003636}, {655,0.00006364}, {660,0.00007273}, {665,0.00000000}, {670,0.00003636}, {675,0.00003636}, {680,0.00003636}, {685,0.00000000}, {690,0.00007273}, {695,0.00000000}, {700,0.00003636}, {705,0.00002727}, {710,0.00021818}, {715,0.00003636}, {720,0.00003636}, {725,0.00014545}, {730,0.00007273}, {735,0.00014545}, {740,0.00006364}, {745,0.00007273}, {750,0.00007273}, {755,0.00014545}, {760,0.00007273}, {765,0.00000000}, {770,0.00006364}, {775,0.00000000}, {780,0.00010909}, {785,0.00010909}, {790,0.00014545}, {795,0.00007273}, {800,0.00003636}, {805,0.00000000}, {810,0.00003636}, {815,0.00010909}, {820,0.00000000}, {825,0.00137273}, {830,0.00003636}, {835,0.00003636}, {840,0.00003636}, {845,0.00007273}, {850,0.00000000}, {855,0.00000000}, {860,0.00003636}, {865,0.00007273}, {870,0.00003636}, {875,0.00002727}, {880,0.00000000}, {885,0.00000000}, {890,0.00003636}, {895,0.00010000}, {900,0.00000000}, {905,0.00003636}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00006364}, {930,0.00000000}, {935,0.00014545}, {940,0.00000000}, {945,0.00010909}, {950,0.00000000}, {955,0.00007273}, {960,0.00000000}, {965,0.00007273}, {970,0.00000000}, {975,0.00003636}, {980,0.00003636}, {985,0.00000000}, {990,0.00003636}, {995,0.00003636}, {1000,0.00003636}, {1010,0.00014545}, {1020,0.00000000}, {1030,0.00003636}, {1040,0.00007273}, {1050,0.00007273}, {1060,0.00003636}, {1070,0.00010909}, {1080,0.00000000}, {1090,0.00003636}, {1100,0.00006364}, {1110,0.00003636}, {1120,0.00000000}, {1130,0.00003636}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00003636}, {1190,0.00007273}, {1200,0.00000000}, {1210,0.00003636}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00007273}, {1250,0.00003636}, {1260,0.00003636}, {1270,0.00000000}, {1280,0.00003636}, {1290,0.00003636}, {1300,0.00010909}, {1310,0.00003636}, {1320,0.00003636}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00003636}, {1400,0.00003636}, {1410,0.00000000}, {1420,0.00007273}, {1430,0.00000000}, {1440,0.00003636}, {1450,0.00010909}, {1460,0.00003636}, {1470,0.00000000}, {1480,0.00003636}, {1490,0.00000000}, {1500,0.00007273}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00007273}, {1560,0.00000000}, {1570,0.00010909}, {1580,0.00000000}, {1590,0.00003636}, {1600,0.00003636}, {1610,0.00007273}, {1620,0.00003636}, {1630,0.00007273}, {1640,0.00003636}, {1650,0.00007273}, {1660,0.00003636}, {1670,0.00007273}, {1680,0.00003636}, {1690,0.00000000}, {1700,0.00003636}, {1710,0.00007273}, {1720,0.00010909}, {1730,0.00007273}, {1740,0.00003636}, {1750,0.00003636}, {1760,0.00007273}, {1770,0.00000000}, {1780,0.00007273}, {1790,0.00007273}, {1800,0.00003636}, {1810,0.00007273}, {1820,0.00003636}, {1830,0.00003636}, {1840,0.00003636}, {1850,0.00007273}, {1860,0.00007273}, {1870,0.00003636}, {1880,0.00003636}, {1890,0.00000000}, {1900,0.00003636}, {1910,0.00000000}, {1920,0.00007273}, {1930,0.00007273}, {1940,0.00007273}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00003636}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00006364}, {2250,0.00003636}, {2300,0.00003636}, {2350,0.00003636}, {2400,0.00003636}, {2450,0.00003636}, {2500,0.00010909}, {2550,0.00000000}, {2600,0.00003636}, {2650,0.00003636}, {2700,0.00000000}, {2750,0.00003636}, {2800,0.00003636}, {2850,0.00006364}, {2900,0.00000000}, {2950,0.00010909}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00003636}, {3150,0.00029091}, {3200,0.00018182}, {3250,0.00025455}, {3300,0.00021818}, {3350,0.00007273}, {3400,0.00018182}, {3450,0.00010000}, {3500,0.00067273}, {3550,0.00112727}, {3600,0.00086364}, {3650,0.00068182}, {3700,0.00057273}, {3750,0.00024545}, {3800,0.00010909}, {3850,0.00020909}, {3900,0.00014545}, {3950,0.00039091}, {4000,0.00043636}, {4050,0.00013636}, {4100,0.00057273}, {4150,0.00039091}, {4200,0.00064545}, {4250,0.00025455}, {4300,0.00028182}, {4350,0.00029091}, {4400,0.00034545}, {4450,0.00053636}, {4500,0.00036364}, {4550,0.00043636}, {4600,0.00046364}, {4650,0.00079091}, {4700,0.00044545}, {4750,0.00075455}, {4800,0.00072727}, {4850,0.00070909}, {4900,0.00101818}, {4950,0.00070909}, {5000,0.00029091}, {5050,0.00040000}, {5100,0.00024545}, {5150,0.00025455}, {5200,0.00002727}, {5250,0.00003636}, {5300,0.00018182}, {5350,0.00018182}, {5400,0.00014545}, {5450,0.00030909}, {5500,0.00034545}, {5550,0.00052727}, {5600,0.00074545}, {5650,0.00007273}, {5700,0.00032727}, {5750,0.00079091}, {5800,0.00014545}, {5850,0.00010909}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00007273}, {6050,0.00031818}, {6100,0.00003636}, {6150,0.00025455}, {6200,0.00003636}, {6250,0.00010909}, {6300,0.00007273}, {6350,0.00007273}, {6400,0.00003636}, {6450,0.00007273}, {6500,0.00024545}, {6550,0.00000000}, {6600,0.00010909}, {6650,0.00003636}, {6700,0.00007273}, {6750,0.00020909}, {6800,0.00010909}, {6850,0.00014545}, {6900,0.00007273}, {6950,0.00000000}, {7000,0.00007273}, {7050,0.00006364}, {7100,0.00024545}, {7150,0.00014545}, {7200,0.00007273}, {7250,0.00020909}, {7300,0.00007273}, {7350,0.00003636}, {7400,0.00014545}, {7450,0.00007273}, {7500,0.00010909}, {7550,0.00003636}, {7600,0.00014545}, {7650,0.00010909}, {7700,0.00003636}, {7750,0.00003636}, {7800,0.00010909}, {7850,0.00007273}, {7900,0.00003636}, {7950,0.00010909}, {8000,0.00003636}, {8050,0.00010909}, {8100,0.00010909}, {8150,0.00014545}, {8200,0.00018182}, {8250,0.00010000}, {8300,0.00003636}, {8350,0.00010909}, {8400,0.00014545}, {8450,0.00010909}, {8500,0.00012727}, {8550,0.00014545}, {8600,0.00014545}, {8650,0.00025455}, {8700,0.00014545}, {8750,0.00003636}, {8800,0.00007273}, {8850,0.00007273}, {8900,0.00010000}, {8950,0.00021818}, {9000,0.00073636}};
data["big"]["TemplateCoq"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00090909}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}};
data["big"]["TemplateCoq"]["post"]["user"] = {{1,0.00000000}, {2,0.00002727}, {3,0.00000000}, {4,0.00008182}, {5,0.00000000}, {6,0.00005455}, {7,0.00006364}, {8,0.00002727}, {9,0.00003636}, {10,0.00000000}, {11,0.00000000}, {12,0.00005455}, {13,0.00000000}, {14,0.00006364}, {15,0.00000000}, {16,0.00006364}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00005455}, {21,0.00005455}, {22,0.00000000}, {23,0.00009091}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00006364}, {31,0.00003636}, {32,0.00005455}, {33,0.00000000}, {34,0.00002727}, {35,0.00000000}, {36,0.00003636}, {37,0.00005455}, {38,0.00002727}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00005455}, {43,0.00007273}, {44,0.00002727}, {45,0.00002727}, {46,0.00012727}, {47,0.00000000}, {48,0.00003636}, {49,0.00000000}, {50,0.00002727}, {51,0.00003636}, {52,0.00002727}, {53,0.00000000}, {54,0.00000000}, {55,0.00006364}, {56,0.00003636}, {57,0.00006364}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00005455}, {62,0.00006364}, {63,0.00002727}, {64,0.00000000}, {65,0.00002727}, {66,0.00002727}, {67,0.00005455}, {68,0.00003636}, {69,0.00005455}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00003636}, {76,0.00003636}, {77,0.00003636}, {78,0.00000000}, {79,0.00002727}, {80,0.00002727}, {81,0.00000000}, {82,0.00003636}, {83,0.00002727}, {84,0.00002727}, {85,0.00002727}, {86,0.00000000}, {87,0.00000000}, {88,0.00003636}, {89,0.00009091}, {90,0.00006364}, {91,0.00005455}, {92,0.00009091}, {93,0.00000000}, {94,0.00002727}, {95,0.00008182}, {96,0.00006364}, {97,0.00000000}, {98,0.00002727}, {99,0.00010909}, {100,0.00005455}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00006364}, {105,0.00000000}, {106,0.00000000}, {107,0.00005455}, {108,0.00006364}, {109,0.00002727}, {110,0.00002727}, {111,0.00006364}, {112,0.00005455}, {113,0.00000000}, {114,0.00000000}, {115,0.00002727}, {116,0.00003636}, {117,0.00000000}, {118,0.00005455}, {119,0.00002727}, {120,0.00002727}, {121,0.00002727}, {122,0.00000000}, {123,0.00010000}, {124,0.00000000}, {125,0.00003636}, {126,0.00012727}, {127,0.00000000}, {128,0.00006364}, {129,0.00000000}, {130,0.00008182}, {131,0.00010000}, {132,0.00010909}, {133,0.00003636}, {134,0.00000000}, {135,0.00000000}, {136,0.00005455}, {137,0.00006364}, {138,0.00003636}, {139,0.00003636}, {140,0.00000000}, {141,0.00005455}, {142,0.00002727}, {143,0.00008182}, {144,0.00000000}, {145,0.00000000}, {146,0.00002727}, {147,0.00006364}, {148,0.00005455}, {149,0.00000000}, {150,0.00002727}, {151,0.00002727}, {152,0.00012727}, {153,0.00000000}, {154,0.00002727}, {155,0.00009091}, {156,0.00005455}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00002727}, {161,0.00000000}, {162,0.00000000}, {163,0.00006364}, {164,0.00000000}, {165,0.00008182}, {166,0.00005455}, {167,0.00005455}, {168,0.00006364}, {169,0.00000000}, {170,0.00002727}, {171,0.00003636}, {172,0.00000000}, {173,0.00000000}, {174,0.00002727}, {175,0.00006364}, {176,0.00000000}, {177,0.00003636}, {178,0.00010000}, {179,0.00000000}, {180,0.00000000}, {181,0.00002727}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00003636}, {188,0.00000000}, {189,0.00000000}, {190,0.00002727}, {191,0.00002727}, {192,0.00000000}, {193,0.00003636}, {194,0.00000000}, {195,0.00006364}, {196,0.00000000}, {197,0.00000000}, {198,0.00006364}, {199,0.00000000}, {200,0.00006364}, {201,0.00000000}, {202,0.00002727}, {203,0.00006364}, {204,0.00010000}, {205,0.00009091}, {206,0.00002727}, {207,0.00000000}, {208,0.00000000}, {209,0.00005455}, {210,0.00009091}, {211,0.00005455}, {212,0.00003636}, {213,0.00000000}, {214,0.00002727}, {215,0.00006364}, {216,0.00008182}, {217,0.00000000}, {218,0.00002727}, {219,0.00000000}, {220,0.00000000}, {221,0.00005455}, {222,0.00000000}, {223,0.00002727}, {224,0.00000000}, {225,0.00000000}, {226,0.00002727}, {227,0.00000000}, {228,0.00003636}, {229,0.00006364}, {230,0.00002727}, {231,0.00000000}, {232,0.00000000}, {233,0.00005455}, {234,0.00002727}, {235,0.00011818}, {236,0.00003636}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00003636}, {241,0.00002727}, {242,0.00000000}, {243,0.00000000}, {244,0.00006364}, {245,0.00003636}, {246,0.00005455}, {247,0.00002727}, {248,0.00010000}, {249,0.00000000}, {250,0.00009091}, {251,0.00003636}, {252,0.00000000}, {253,0.00006364}, {254,0.00003636}, {255,0.00000000}, {256,0.00006364}, {257,0.00000000}, {258,0.00000000}, {259,0.00008182}, {260,0.00006364}, {261,0.00002727}, {262,0.00000000}, {263,0.00000000}, {264,0.00009091}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00003636}, {269,0.00006364}, {270,0.00005455}, {271,0.00005455}, {272,0.00000000}, {273,0.00005455}, {274,0.00000000}, {275,0.00002727}, {276,0.00000000}, {277,0.00005455}, {278,0.00005455}, {279,0.00000000}, {280,0.00000000}, {281,0.00003636}, {282,0.00000000}, {283,0.00002727}, {284,0.00011818}, {285,0.00003636}, {286,0.00000000}, {287,0.00002727}, {288,0.00005455}, {289,0.00002727}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00002727}, {294,0.00011818}, {295,0.00000000}, {296,0.00000000}, {297,0.00003636}, {298,0.00003636}, {299,0.00002727}, {300,0.00006364}, {301,0.00003636}, {302,0.00002727}, {303,0.00006364}, {304,0.00003636}, {305,0.00002727}, {306,0.00002727}, {307,0.00006364}, {308,0.00005455}, {309,0.00011818}, {310,0.00002727}, {311,0.00002727}, {312,0.00002727}, {313,0.00000000}, {314,0.00006364}, {315,0.00008182}, {316,0.00002727}, {317,0.00000000}, {318,0.00000000}, {319,0.00010000}, {320,0.00000000}, {321,0.00011818}, {322,0.00000000}, {323,0.00005455}, {324,0.00003636}, {325,0.00006364}, {326,0.00000000}, {327,0.00000000}, {328,0.00002727}, {329,0.00003636}, {330,0.00008182}, {331,0.00002727}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00002727}, {336,0.00007273}, {337,0.00005455}, {338,0.00000000}, {339,0.00000000}, {340,0.00006364}, {341,0.00000000}, {342,0.00005455}, {343,0.00000000}, {344,0.00002727}, {345,0.00000000}, {346,0.00000000}, {347,0.00002727}, {348,0.00000000}, {349,0.00000000}, {350,0.00002727}, {351,0.00000000}, {352,0.00000000}, {353,0.00002727}, {354,0.00000000}, {355,0.00006364}, {356,0.00002727}, {357,0.00006364}, {358,0.00003636}, {359,0.00003636}, {360,0.00006364}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00003636}, {365,0.00003636}, {366,0.00121818}, {367,0.00003636}, {368,0.00003636}, {369,0.00006364}, {370,0.00003636}, {371,0.00006364}, {372,0.00002727}, {373,0.00000000}, {374,0.00003636}, {375,0.00006364}, {376,0.00002727}, {377,0.00000000}, {378,0.00005455}, {379,0.00002727}, {380,0.00008182}, {381,0.00005455}, {382,0.00000000}, {383,0.00010000}, {384,0.00008182}, {385,0.00002727}, {386,0.00002727}, {387,0.00000000}, {388,0.00000000}, {389,0.00009091}, {390,0.00000000}, {391,0.00002727}, {392,0.00000000}, {393,0.00005455}, {394,0.00002727}, {395,0.00009091}, {396,0.00011818}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00002727}, {404,0.00002727}, {405,0.00003636}, {406,0.00006364}, {407,0.00008182}, {408,0.00010000}, {409,0.00002727}, {410,0.00006364}, {411,0.00000000}, {412,0.00003636}, {413,0.00000000}, {414,0.00006364}, {415,0.00007273}, {416,0.00006364}, {417,0.00000000}, {418,0.00009091}, {419,0.00008182}, {420,0.00002727}, {421,0.00003636}, {422,0.00006364}, {423,0.00000000}, {424,0.00006364}, {425,0.00000000}, {426,0.00000000}, {427,0.00002727}, {428,0.00002727}, {429,0.00006364}, {430,0.00006364}, {431,0.00002727}, {432,0.00002727}, {433,0.00003636}, {434,0.00006364}, {435,0.00006364}, {436,0.00002727}, {437,0.00002727}, {438,0.00000000}, {439,0.00003636}, {440,0.00005455}, {441,0.00000000}, {442,0.00005455}, {443,0.00002727}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00007273}, {448,0.00002727}, {449,0.00000000}, {450,0.00000000}, {451,0.00002727}, {452,0.00009091}, {453,0.00000000}, {454,0.00006364}, {455,0.00002727}, {456,0.00003636}, {457,0.00003636}, {458,0.00006364}, {459,0.00000000}, {460,0.00003636}, {461,0.00008182}, {462,0.00008182}, {463,0.00002727}, {464,0.00006364}, {465,0.00009091}, {466,0.00000000}, {467,0.00003636}, {468,0.00010909}, {469,0.00000000}, {470,0.00006364}, {471,0.00000000}, {472,0.00000000}, {473,0.00005455}, {474,0.00002727}, {475,0.00000000}, {476,0.00009091}, {477,0.00000000}, {478,0.00005455}, {479,0.00002727}, {480,0.00000000}, {481,0.00006364}, {482,0.00003636}, {483,0.00002727}, {484,0.00000000}, {485,0.00002727}, {486,0.00005455}, {487,0.00002727}, {488,0.00005455}, {489,0.00000000}, {490,0.00000000}, {491,0.00002727}, {492,0.00002727}, {493,0.00007273}, {494,0.00000000}, {495,0.00000000}, {496,0.00002727}, {497,0.00009091}, {498,0.00000000}, {499,0.00000000}, {500,0.00007273}, {505,0.00002727}, {510,0.00002727}, {515,0.00002727}, {520,0.00000000}, {525,0.00000000}, {530,0.00002727}, {535,0.00003636}, {540,0.00002727}, {545,0.00000000}, {550,0.00002727}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00002727}, {580,0.00008182}, {585,0.00002727}, {590,0.00006364}, {595,0.00000000}, {600,0.00002727}, {605,0.00009091}, {610,0.00013636}, {615,0.00020000}, {620,0.00000000}, {625,0.00003636}, {630,0.00006364}, {635,0.00005455}, {640,0.00000000}, {645,0.00002727}, {650,0.00000000}, {655,0.00000000}, {660,0.00014545}, {665,0.00002727}, {670,0.00006364}, {675,0.00007273}, {680,0.00006364}, {685,0.00003636}, {690,0.00000000}, {695,0.00007273}, {700,0.00000000}, {705,0.00006364}, {710,0.00003636}, {715,0.00006364}, {720,0.00002727}, {725,0.00000000}, {730,0.00008182}, {735,0.00005455}, {740,0.00000000}, {745,0.00003636}, {750,0.00007273}, {755,0.00007273}, {760,0.00000000}, {765,0.00010000}, {770,0.00000000}, {775,0.00002727}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00002727}, {800,0.00000000}, {805,0.00000000}, {810,0.00006364}, {815,0.00003636}, {820,0.00002727}, {825,0.00003636}, {830,0.00000000}, {835,0.00003636}, {840,0.00000000}, {845,0.00002727}, {850,0.00000000}, {855,0.00000000}, {860,0.00003636}, {865,0.00000000}, {870,0.00000000}, {875,0.00002727}, {880,0.00002727}, {885,0.00005455}, {890,0.00002727}, {895,0.00007273}, {900,0.00003636}, {905,0.00009091}, {910,0.00000000}, {915,0.00003636}, {920,0.00006364}, {925,0.00000000}, {930,0.00005455}, {935,0.00000000}, {940,0.00005455}, {945,0.00005455}, {950,0.00006364}, {955,0.00003636}, {960,0.00002727}, {965,0.00003636}, {970,0.00000000}, {975,0.00000000}, {980,0.00002727}, {985,0.00006364}, {990,0.00006364}, {995,0.00002727}, {1000,0.00002727}, {1010,0.00005455}, {1020,0.00000000}, {1030,0.00002727}, {1040,0.00000000}, {1050,0.00002727}, {1060,0.00006364}, {1070,0.00000000}, {1080,0.00010000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00002727}, {1130,0.00013636}, {1140,0.00006364}, {1150,0.00002727}, {1160,0.00000000}, {1170,0.00005455}, {1180,0.00002727}, {1190,0.00002727}, {1200,0.00003636}, {1210,0.00003636}, {1220,0.00000000}, {1230,0.00005455}, {1240,0.00002727}, {1250,0.00006364}, {1260,0.00002727}, {1270,0.00007273}, {1280,0.00000000}, {1290,0.00006364}, {1300,0.00002727}, {1310,0.00008182}, {1320,0.00010000}, {1330,0.00002727}, {1340,0.00002727}, {1350,0.00005455}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00002727}, {1390,0.00002727}, {1400,0.00006364}, {1410,0.00003636}, {1420,0.00003636}, {1430,0.00003636}, {1440,0.00002727}, {1450,0.00006364}, {1460,0.00000000}, {1470,0.00002727}, {1480,0.00002727}, {1490,0.00000000}, {1500,0.00002727}, {1510,0.00003636}, {1520,0.00005455}, {1530,0.00014545}, {1540,0.00000000}, {1550,0.00002727}, {1560,0.00002727}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00003636}, {1600,0.00009091}, {1610,0.00003636}, {1620,0.00000000}, {1630,0.00002727}, {1640,0.00005455}, {1650,0.00002727}, {1660,0.00003636}, {1670,0.00006364}, {1680,0.00003636}, {1690,0.00002727}, {1700,0.00002727}, {1710,0.00006364}, {1720,0.00005455}, {1730,0.00003636}, {1740,0.00002727}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00002727}, {1780,0.00002727}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00007273}, {1830,0.00000000}, {1840,0.00007273}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00002727}, {1890,0.00005455}, {1900,0.00000000}, {1910,0.00002727}, {1920,0.00000000}, {1930,0.00005455}, {1940,0.00000000}, {1950,0.00002727}, {1960,0.00002727}, {1970,0.00002727}, {1980,0.00000000}, {1990,0.00008182}, {2000,0.00000000}, {2050,0.00003636}, {2100,0.00005455}, {2150,0.00000000}, {2200,0.00002727}, {2250,0.00002727}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00007273}, {2450,0.00007273}, {2500,0.00009091}, {2550,0.00003636}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00003636}, {2850,0.00011818}, {2900,0.00003636}, {2950,0.00006364}, {3000,0.00006364}, {3050,0.00002727}, {3100,0.00002727}, {3150,0.00000000}, {3200,0.00003636}, {3250,0.00000000}, {3300,0.00007273}, {3350,0.00003636}, {3400,0.00006364}, {3450,0.00003636}, {3500,0.00000000}, {3550,0.00009091}, {3600,0.00000000}, {3650,0.00012727}, {3700,0.00002727}, {3750,0.00003636}, {3800,0.00000000}, {3850,0.00009091}, {3900,0.00003636}, {3950,0.00002727}, {4000,0.00002727}, {4050,0.00002727}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00005455}, {4350,0.00002727}, {4400,0.00000000}, {4450,0.00008182}, {4500,0.00000000}, {4550,0.00006364}, {4600,0.00000000}, {4650,0.00006364}, {4700,0.00002727}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00002727}, {4900,0.00008182}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00002727}, {5100,0.00005455}, {5150,0.00003636}, {5200,0.00000000}, {5250,0.00002727}, {5300,0.00000000}, {5350,0.00014545}, {5400,0.00002727}, {5450,0.00002727}, {5500,0.00009091}, {5550,0.00002727}, {5600,0.00005455}, {5650,0.00000000}, {5700,0.00010000}, {5750,0.00009091}, {5800,0.00002727}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00009091}, {6000,0.00003636}, {6050,0.00003636}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00002727}, {6300,0.00000000}, {6350,0.00003636}, {6400,0.00000000}, {6450,0.00003636}, {6500,0.00003636}, {6550,0.00003636}, {6600,0.00000000}, {6650,0.00009091}, {6700,0.00010909}, {6750,0.00002727}, {6800,0.00010000}, {6850,0.00006364}, {6900,0.00002727}, {6950,0.00005455}, {7000,0.00011818}, {7050,0.00003636}, {7100,0.00009091}, {7150,0.00000000}, {7200,0.00002727}, {7250,0.00006364}, {7300,0.00000000}, {7350,0.00003636}, {7400,0.00002727}, {7450,0.00009091}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00008182}, {7650,0.00006364}, {7700,0.00010909}, {7750,0.00002727}, {7800,0.00008182}, {7850,0.00000000}, {7900,0.00002727}, {7950,0.00000000}, {8000,0.00002727}, {8050,0.00002727}, {8100,0.00005455}, {8150,0.00003636}, {8200,0.00002727}, {8250,0.00008182}, {8300,0.00000000}, {8350,0.00009091}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00002727}, {8550,0.00002727}, {8600,0.00010000}, {8650,0.00000000}, {8700,0.00005455}, {8750,0.00009091}, {8800,0.00000000}, {8850,0.00003636}, {8900,0.00003636}, {8950,0.00000000}, {9000,0.00003636}};
data["big"]["TemplateCoq"]["post"]["system"] = {{1,0.00000000}, {2,0.00003636}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00003636}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00003636}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00003636}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00003636}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00003636}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00003636}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00003636}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00003636}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00003636}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00003636}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00003636}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00003636}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}};
data["big"]["TemplateCoq"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}};
data["big"]["TemplateCoq"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00005455}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00002727}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00005455}, {23,0.00000000}, {24,0.00000000}, {25,0.00002727}, {26,0.00002727}, {27,0.00003636}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00003636}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00002727}, {39,0.00000000}, {40,0.00002727}, {41,0.00002727}, {42,0.00002727}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00003636}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00002727}, {58,0.00003636}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00002727}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00002727}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00003636}, {99,0.00000000}, {100,0.00000000}, {101,0.00002727}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00002727}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00003636}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00002727}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00003636}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00002727}, {146,0.00000000}, {147,0.00002727}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00005455}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00006364}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00003636}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00002727}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00003636}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00002727}, {225,0.00003636}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00002727}, {231,0.00000000}, {232,0.00000000}, {233,0.00002727}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00003636}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00003636}, {274,0.00000000}, {275,0.00002727}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00002727}, {291,0.00006364}, {292,0.00002727}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00002727}, {302,0.00000000}, {303,0.00002727}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00003636}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00002727}, {314,0.00000000}, {315,0.00000000}, {316,0.00002727}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00002727}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00002727}, {334,0.00003636}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00003636}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00002727}, {352,0.00002727}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00002727}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00003636}, {370,0.00000000}, {371,0.00002727}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00002727}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00003636}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00003636}, {400,0.00000000}, {401,0.00000000}, {402,0.00003636}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00005455}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00003636}, {425,0.00002727}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00003636}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00003636}, {438,0.00000000}, {439,0.00000000}, {440,0.00002727}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00003636}, {445,0.00000000}, {446,0.00003636}, {447,0.00000000}, {448,0.00000000}, {449,0.00003636}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00002727}, {457,0.00003636}, {458,0.00000000}, {459,0.00005455}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00002727}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00002727}, {473,0.00000000}, {474,0.00000000}, {475,0.00003636}, {476,0.00000000}, {477,0.00000000}, {478,0.00003636}, {479,0.00002727}, {480,0.00000000}, {481,0.00000000}, {482,0.00002727}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00002727}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00002727}, {500,0.00000000}, {505,0.00002727}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00002727}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00002727}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00003636}, {605,0.00000000}, {610,0.00003636}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00002727}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00003636}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00002727}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00002727}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00002727}, {820,0.00000000}, {825,0.00002727}, {830,0.00002727}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00005455}, {870,0.00000000}, {875,0.00000000}, {880,0.00003636}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00002727}, {910,0.00003636}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00002727}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00003636}, {1020,0.00000000}, {1030,0.00003636}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00002727}, {1180,0.00003636}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00002727}, {1220,0.00000000}, {1230,0.00003636}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00002727}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00003636}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00002727}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00002727}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00003636}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00002727}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00005455}, {1720,0.00003636}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00002727}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00002727}, {1870,0.00003636}, {1880,0.00000000}, {1890,0.00002727}, {1900,0.00000000}, {1910,0.00002727}, {1920,0.00002727}, {1930,0.00002727}, {1940,0.00000000}, {1950,0.00002727}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00003636}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00002727}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00002727}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00002727}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00002727}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00002727}, {4100,0.00000000}, {4150,0.00003636}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00005455}, {4600,0.00003636}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00002727}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00003636}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00006364}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00002727}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00003636}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00002727}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00002727}, {7500,0.00000000}, {7550,0.00002727}, {7600,0.00000000}, {7650,0.00003636}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00002727}, {8000,0.00002727}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00002727}, {8250,0.00000000}, {8300,0.00002727}, {8350,0.00000000}, {8400,0.00006364}, {8450,0.00000000}, {8500,0.00002727}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00003636}, {9000,0.00000000}};
data["big"]["TemplateCoq"]["pre"]["system"] = {{1,0.00000000}, {2,0.00003636}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00003636}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}};
data["big"]["TemplateCoq"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000909}, {14,0.00018182}, {15,0.00053636}, {16,0.00096364}, {17,0.00100000}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00100000}, {23,0.00100000}, {24,0.00100000}, {25,0.00100000}, {26,0.00100000}, {27,0.00100000}, {28,0.00100000}, {29,0.00100000}, {30,0.00100000}, {31,0.00100000}, {32,0.00100000}, {33,0.00101818}, {34,0.00105455}, {35,0.00110909}, {36,0.00130000}, {37,0.00151818}, {38,0.00179091}, {39,0.00193636}, {40,0.00200000}, {41,0.00200000}, {42,0.00200000}, {43,0.00200000}, {44,0.00200000}, {45,0.00200000}, {46,0.00200000}, {47,0.00200000}, {48,0.00200000}, {49,0.00200909}, {50,0.00200000}, {51,0.00200000}, {52,0.00201818}, {53,0.00200909}, {54,0.00200909}, {55,0.00204545}, {56,0.00206364}, {57,0.00396364}, {58,0.00245455}, {59,0.00259091}, {60,0.00287273}, {61,0.00294545}, {62,0.00299091}, {63,0.00300000}, {64,0.00300000}, {65,0.00300000}, {66,0.00300000}, {67,0.00300000}, {68,0.00300000}, {69,0.00301818}, {70,0.00300000}, {71,0.00300000}, {72,0.00300000}, {73,0.00429091}, {74,0.00300000}, {75,0.00300909}, {76,0.00308182}, {77,0.00312727}, {78,0.00327273}, {79,0.00342727}, {80,0.00367273}, {81,0.00380000}, {82,0.00390909}, {83,0.00400000}, {84,0.00400000}, {85,0.00400000}, {86,0.00400000}, {87,0.00400000}, {88,0.00400000}, {89,0.00400000}, {90,0.00400000}, {91,0.00400000}, {92,0.00400000}, {93,0.00400000}, {94,0.00400909}, {95,0.00403636}, {96,0.00403636}, {97,0.00405455}, {98,0.00555455}, {99,0.00430000}, {100,0.00452727}, {101,0.00464545}, {102,0.00480000}, {103,0.00485455}, {104,0.00492727}, {105,0.00498182}, {106,0.00500000}, {107,0.00500000}, {108,0.00500000}, {109,0.00500000}, {110,0.00500000}, {111,0.00500000}, {112,0.00500000}, {113,0.00500000}, {114,0.00500000}, {115,0.00500000}, {116,0.00502727}, {117,0.00502727}, {118,0.00757273}, {119,0.00512727}, {120,0.00529091}, {121,0.00549091}, {122,0.00562727}, {123,0.00569091}, {124,0.00580000}, {125,0.00594545}, {126,0.00594545}, {127,0.00864545}, {128,0.00598182}, {129,0.00600909}, {130,0.00600000}, {131,0.00600000}, {132,0.00600000}, {133,0.00603636}, {134,0.00600000}, {135,0.00601818}, {136,0.00769091}, {137,0.00602727}, {138,0.00609091}, {139,0.00613636}, {140,0.00622727}, {141,0.00633636}, {142,0.00646364}, {143,0.00655455}, {144,0.00776364}, {145,0.00676364}, {146,0.00682727}, {147,0.00688182}, {148,0.00695455}, {149,0.00700000}, {150,0.00700000}, {151,0.00700000}, {152,0.00700000}, {153,0.00700000}, {154,0.00700909}, {155,0.00701818}, {156,0.00700909}, {157,0.00700909}, {158,0.00700000}, {159,0.00808182}, {160,0.00710909}, {161,0.00713636}, {162,0.00730909}, {163,0.00733636}, {164,0.00756364}, {165,0.00762727}, {166,0.00859091}, {167,0.00773636}, {168,0.00783636}, {169,0.00787273}, {170,0.00793636}, {171,0.00800000}, {172,0.01171818}, {173,0.00799091}, {174,0.00800000}, {175,0.00800000}, {176,0.00800000}, {177,0.00804545}, {178,0.00801818}, {179,0.00969091}, {180,0.00807273}, {181,0.00818182}, {182,0.00820000}, {183,0.00836364}, {184,0.00836364}, {185,0.00996364}, {186,0.00859091}, {187,0.00865455}, {188,0.00870909}, {189,0.00880000}, {190,0.00883636}, {191,0.01065455}, {192,0.00890000}, {193,0.00894545}, {194,0.00894545}, {195,0.00906364}, {196,0.00900000}, {197,0.01070909}, {198,0.00900000}, {199,0.00900000}, {200,0.00901818}, {201,0.00909091}, {202,0.00910909}, {203,0.01073636}, {204,0.00930000}, {205,0.00939091}, {206,0.00941818}, {207,0.00957273}, {208,0.01413636}, {209,0.00972727}, {210,0.00972727}, {211,0.00980000}, {212,0.00987273}, {213,0.00985455}, {214,0.01152727}, {215,0.00996364}, {216,0.00999091}, {217,0.00998182}, {218,0.01000000}, {219,0.01183636}, {220,0.01002727}, {221,0.01003636}, {222,0.01009091}, {223,0.01013636}, {224,0.01388182}, {225,0.01028182}, {226,0.01030909}, {227,0.01041818}, {228,0.01058182}, {229,0.01061818}, {230,0.01067273}, {231,0.01070000}, {232,0.01079091}, {233,0.01084545}, {234,0.01587273}, {235,0.01090000}, {236,0.01092727}, {237,0.01092727}, {238,0.01099091}, {239,0.01342727}, {240,0.01098182}, {241,0.01101818}, {242,0.01105455}, {243,0.01105455}, {244,0.01471818}, {245,0.01114545}, {246,0.01124545}, {247,0.01147273}, {248,0.01142727}, {249,0.01281818}, {250,0.01161818}, {251,0.01168182}, {252,0.01172727}, {253,0.01660909}, {254,0.01175455}, {255,0.01183636}, {256,0.01185455}, {257,0.01189091}, {258,0.01439091}, {259,0.01196364}, {260,0.01195455}, {261,0.01201818}, {262,0.01680000}, {263,0.01204545}, {264,0.01206364}, {265,0.01215455}, {266,0.01222727}, {267,0.01455455}, {268,0.01228182}, {269,0.01240000}, {270,0.01250000}, {271,0.01454545}, {272,0.01266364}, {273,0.01268182}, {274,0.01276364}, {275,0.01664545}, {276,0.01277273}, {277,0.01283636}, {278,0.01293636}, {279,0.01292727}, {280,0.01294545}, {281,0.01299091}, {282,0.01301818}, {283,0.01302727}, {284,0.01390909}, {285,0.01306364}, {286,0.01310909}, {287,0.01317273}, {288,0.01477273}, {289,0.01337273}, {290,0.01337273}, {291,0.01346364}, {292,0.01507273}, {293,0.01364545}, {294,0.01371818}, {295,0.01371818}, {296,0.01515455}, {297,0.01375455}, {298,0.01377273}, {299,0.01379091}, {300,0.01463636}, {301,0.01387273}, {302,0.01402727}, {303,0.01398182}, {304,0.01403636}, {305,0.01404545}, {306,0.01409091}, {307,0.01855455}, {308,0.01418182}, {309,0.01417273}, {310,0.01432727}, {311,0.01783636}, {312,0.01449091}, {313,0.01452727}, {314,0.01462727}, {315,0.01664545}, {316,0.01470909}, {317,0.01472727}, {318,0.01475455}, {319,0.01479091}, {320,0.01481818}, {321,0.01488182}, {322,0.01760909}, {323,0.01486364}, {324,0.01493636}, {325,0.01501818}, {326,0.01685455}, {327,0.01511818}, {328,0.01519091}, {329,0.02069091}, {330,0.01524545}, {331,0.01530000}, {332,0.01546364}, {333,0.01865455}, {334,0.01555455}, {335,0.01570000}, {336,0.02239091}, {337,0.01569091}, {338,0.01570909}, {339,0.01578182}, {340,0.01829091}, {341,0.01575455}, {342,0.01587273}, {343,0.01903636}, {344,0.01589091}, {345,0.01586364}, {346,0.01598182}, {347,0.02016364}, {348,0.01602727}, {349,0.01613636}, {350,0.01855455}, {351,0.01619091}, {352,0.01632727}, {353,0.02328182}, {354,0.01642727}, {355,0.01647273}, {356,0.01662727}, {357,0.01871818}, {358,0.01662727}, {359,0.01674545}, {360,0.01952727}, {361,0.01675455}, {362,0.01683636}, {363,0.01979091}, {364,0.01682727}, {365,0.01679091}, {366,0.01686364}, {367,0.01695455}, {368,0.01700000}, {369,0.01713636}, {370,0.01704545}, {371,0.01719091}, {372,0.01724545}, {373,0.01963636}, {374,0.01736364}, {375,0.01748182}, {376,0.02018182}, {377,0.01754545}, {378,0.01764545}, {379,0.01988182}, {380,0.01770909}, {381,0.01779091}, {382,0.02059091}, {383,0.01779091}, {384,0.01785455}, {385,0.02090000}, {386,0.01781818}, {387,0.01800000}, {388,0.02140909}, {389,0.01800909}, {390,0.01823636}, {391,0.02162727}, {392,0.01807273}, {393,0.01834545}, {394,0.02177273}, {395,0.01836364}, {396,0.01850909}, {397,0.02172727}, {398,0.01863636}, {399,0.01875455}, {400,0.02176364}, {401,0.01870909}, {402,0.01884545}, {403,0.02160000}, {404,0.01874545}, {405,0.01881818}, {406,0.02133636}, {407,0.01882727}, {408,0.01889091}, {409,0.02181818}, {410,0.01895455}, {411,0.01902727}, {412,0.02146364}, {413,0.01907273}, {414,0.01924545}, {415,0.01990909}, {416,0.01929091}, {417,0.01940909}, {418,0.01958182}, {419,0.01957273}, {420,0.02301818}, {421,0.01965455}, {422,0.06085455}, {423,0.02561818}, {424,0.01974545}, {425,0.01986364}, {426,0.02257273}, {427,0.01981818}, {428,0.01990909}, {429,0.01981818}, {430,0.01991818}, {431,0.02760909}, {432,0.02004545}, {433,0.02018182}, {434,0.02459091}, {435,0.02022727}, {436,0.02041818}, {437,0.02279091}, {438,0.02042727}, {439,0.02054545}, {440,0.02054545}, {441,0.02084545}, {442,0.02418182}, {443,0.02069091}, {444,0.02084545}, {445,0.02337273}, {446,0.02079091}, {447,0.02083636}, {448,0.02081818}, {449,0.02100000}, {450,0.85396364}, {451,0.02092727}, {452,0.02105455}, {453,0.02402727}, {454,0.02104545}, {455,0.02780000}, {456,0.02116364}, {457,0.02133636}, {458,0.02749091}, {459,0.02144545}, {460,0.02150000}, {461,0.02153636}, {462,0.02168182}, {463,0.02507273}, {464,0.02166364}, {465,0.02182727}, {466,0.02175455}, {467,0.02194545}, {468,0.02563636}, {469,0.02184545}, {470,0.02191818}, {471,0.02287273}, {472,0.02199091}, {473,0.02602727}, {474,0.02199091}, {475,0.02215455}, {476,0.02310000}, {477,0.02235455}, {478,0.02610000}, {479,0.02234545}, {480,0.02242727}, {481,0.02242727}, {482,0.02270000}, {483,0.02610000}, {484,0.02267273}, {485,0.02276364}, {486,0.02270909}, {487,0.02281818}, {488,0.02700909}, {489,0.02280909}, {490,0.03044545}, {491,0.02283636}, {492,0.02292727}, {493,0.02839091}, {494,0.02290909}, {495,0.02692727}, {496,0.02307273}, {497,0.02317273}, {498,0.02321818}, {499,0.02329091}, {500,0.02686364}, {505,0.02367273}, {510,0.02794545}, {515,0.02399091}, {520,0.02434545}, {525,0.02457273}, {530,0.02488182}, {535,0.02778182}, {540,0.02539091}, {545,0.02951818}, {550,0.02570000}, {555,0.02981818}, {560,0.02616364}, {565,0.03112727}, {570,0.02664545}, {575,0.03401818}, {580,0.02704545}, {585,0.04011818}, {590,0.02763636}, {595,0.04010000}, {600,0.02802727}, {605,0.03899091}, {610,0.02857273}, {615,0.03657273}, {620,0.02897273}, {625,0.03820909}, {630,0.02950000}, {635,0.03373636}, {640,0.03007273}, {645,0.03465455}, {650,0.03051818}, {655,0.03399091}, {660,0.03100000}, {665,0.03112727}, {670,0.04657273}, {675,0.03162727}, {680,0.03922727}, {685,0.03224545}, {690,0.03751818}, {695,0.03265455}, {700,0.03274545}, {705,0.04092727}, {710,0.03333636}, {715,0.04341818}, {720,0.03385455}, {725,0.03487273}, {730,0.03906364}, {735,0.03462727}, {740,0.04510000}, {745,0.03502727}, {750,0.03520909}, {755,0.04042727}, {760,0.03576364}, {765,0.03807273}, {770,0.04209091}, {775,0.03649091}, {780,0.04026364}, {785,0.04273636}, {790,0.03738182}, {795,0.04753636}, {800,0.04400000}, {805,0.03799091}, {810,0.04789091}, {815,0.04500909}, {820,0.03860000}, {825,1.14299091}, {830,0.04646364}, {835,0.03937273}, {840,0.03942727}, {845,0.04508182}, {850,0.06007273}, {855,0.04054545}, {860,0.04679091}, {865,0.04803636}, {870,0.04097273}, {875,0.04116364}, {880,0.04863636}, {885,0.04930909}, {890,0.04204545}, {895,0.04160909}, {900,0.04834545}, {905,0.04911818}, {910,0.04300000}, {915,0.04310909}, {920,0.05020000}, {925,0.05015455}, {930,0.04380909}, {935,0.04431818}, {940,0.04840909}, {945,0.04947273}, {950,0.05288182}, {955,0.04514545}, {960,0.04533636}, {965,0.05053636}, {970,0.05085455}, {975,0.05343636}, {980,0.04645455}, {985,0.04664545}, {990,0.05130909}, {995,0.05461818}, {1000,0.05510000}, {1010,0.05814545}, {1020,0.04811818}, {1030,0.04865455}, {1040,0.05084545}, {1050,0.05435455}, {1060,0.05652727}, {1070,0.05636364}, {1080,0.05822727}, {1090,0.06012727}, {1100,0.06902727}, {1110,0.05257273}, {1120,0.05313636}, {1130,0.05360909}, {1140,0.05417273}, {1150,0.05400909}, {1160,0.05940909}, {1170,0.06010000}, {1180,0.06059091}, {1190,0.06114545}, {1200,0.06175455}, {1210,0.06250909}, {1220,0.06288182}, {1230,0.06362727}, {1240,0.06385455}, {1250,0.06240000}, {1260,0.05940000}, {1270,0.06038182}, {1280,0.06089091}, {1290,0.08349091}, {1300,0.07665455}, {1310,0.08012727}, {1320,0.07092727}, {1330,0.07015455}, {1340,0.07180909}, {1350,0.07068182}, {1360,0.07002727}, {1370,0.06490000}, {1380,0.08505455}, {1390,0.08122727}, {1400,0.07442727}, {1410,0.07582727}, {1420,0.07432727}, {1430,0.06624545}, {1440,0.08150909}, {1450,0.08745455}, {1460,0.07890000}, {1470,0.07686364}, {1480,0.09996364}, {1490,0.08250000}, {1500,0.07974545}, {1510,0.07767273}, {1520,0.10080909}, {1530,0.08483636}, {1540,0.08368182}, {1550,0.08059091}, {1560,0.08868182}, {1570,0.09380909}, {1580,0.08320909}, {1590,0.09590000}, {1600,0.09199091}, {1610,0.08548182}, {1620,0.09769091}, {1630,0.09448182}, {1640,0.08650000}, {1650,0.09060000}, {1660,0.10068182}, {1670,0.08630000}, {1680,0.09164545}, {1690,0.09010000}, {1700,0.09186364}, {1710,0.10162727}, {1720,0.11091818}, {1730,0.09413636}, {1740,0.09068182}, {1750,0.09628182}, {1760,0.09378182}, {1770,0.09735455}, {1780,0.09424545}, {1790,0.09997273}, {1800,0.09892727}, {1810,0.10058182}, {1820,0.09992727}, {1830,0.10029091}, {1840,0.09806364}, {1850,0.10060000}, {1860,0.09790000}, {1870,0.10137273}, {1880,0.12213636}, {1890,0.10340909}, {1900,0.10878182}, {1910,0.11411818}, {1920,0.10395455}, {1930,0.10177273}, {1940,0.10368182}, {1950,0.10900000}, {1960,0.11346364}, {1970,0.10619091}, {1980,0.12600000}, {1990,0.11318182}, {2000,0.11073636}, {2050,0.12838182}, {2100,0.11850909}, {2150,0.11523636}, {2200,0.11872727}, {2250,0.11940000}, {2300,0.13600000}, {2350,0.15776364}, {2400,0.15821818}, {2450,0.15767273}, {2500,0.15095455}, {2550,0.15286364}, {2600,0.13817273}, {2650,0.14230909}, {2700,0.14191818}, {2750,0.16700909}, {2800,0.16264545}, {2850,0.15164545}, {2900,0.16986364}, {2950,0.17357273}, {3000,0.18718182}, {3050,0.17112727}, {3100,0.18270909}, {3150,0.18605455}, {3200,0.17531818}, {3250,0.20028182}, {3300,0.18918182}, {3350,0.18443636}, {3400,0.18940000}, {3450,0.19238182}, {3500,0.23314545}, {3550,0.23985455}, {3600,0.23595455}, {3650,0.23579091}, {3700,0.23490000}, {3750,0.22905455}, {3800,0.20352727}, {3850,0.21170000}, {3900,0.21149091}, {3950,0.25102727}, {4000,0.23502727}, {4050,0.22127273}, {4100,0.25259091}, {4150,0.25114545}, {4200,0.27523636}, {4250,0.25130909}, {4300,0.27181818}, {4350,0.27662727}, {4400,0.24648182}, {4450,0.29229091}, {4500,0.25909091}, {4550,0.24411818}, {4600,0.26823636}, {4650,0.28990909}, {4700,0.30285455}, {4750,0.33461818}, {4800,0.34114545}, {4850,0.34388182}, {4900,0.33876364}, {4950,0.33099091}, {5000,0.30117273}, {5050,0.28997273}, {5100,0.27837273}, {5150,0.29887273}, {5200,0.33854545}, {5250,0.29047273}, {5300,0.30391818}, {5350,0.32885455}, {5400,0.29549091}, {5450,0.33802727}, {5500,0.29797273}, {5550,0.32994545}, {5600,0.37804545}, {5650,0.30208182}, {5700,0.33892727}, {5750,0.36889091}, {5800,0.39359091}, {5850,0.31138182}, {5900,0.33022727}, {5950,0.33355455}, {6000,0.33405455}, {6050,0.33893636}, {6100,0.33943636}, {6150,0.34620000}, {6200,0.34408182}, {6250,0.42727273}, {6300,0.40241818}, {6350,0.37915455}, {6400,0.35545455}, {6450,0.43314545}, {6500,0.38689091}, {6550,0.38120909}, {6600,0.39919091}, {6650,0.36768182}, {6700,0.39298182}, {6750,0.47870909}, {6800,0.39691818}, {6850,0.45105455}, {6900,0.39787273}, {6950,0.39360000}, {7000,0.42494545}, {7050,0.46461818}, {7100,0.47144545}, {7150,0.48500000}, {7200,0.49412727}, {7250,0.50169091}, {7300,0.49843636}, {7350,0.49271818}, {7400,0.48271818}, {7450,0.46467273}, {7500,0.45806364}, {7550,0.42149091}, {7600,0.51141818}, {7650,0.47708182}, {7700,0.44928182}, {7750,0.50896364}, {7800,0.45971818}, {7850,0.51149091}, {7900,0.46622727}, {7950,0.51045455}, {8000,0.44805455}, {8050,0.49774545}, {8100,0.55370909}, {8150,0.51942727}, {8200,0.47915455}, {8250,0.49925455}, {8300,0.52847273}, {8350,0.55114545}, {8400,0.57280909}, {8450,0.58660909}, {8500,0.58235455}, {8550,0.56954545}, {8600,0.56230000}, {8650,0.54436364}, {8700,0.49503636}, {8750,0.61061818}, {8800,0.58889091}, {8850,0.55670000}, {8900,0.56900909}, {8950,0.59063636}, {9000,0.53941818}};
data["big"]["TemplateCoq"]["reif"]["user"] = {{1,0.00051818}, {2,0.00017273}, {3,0.00038182}, {4,0.00037273}, {5,0.00057273}, {6,0.00058182}, {7,0.00031818}, {8,0.00052727}, {9,0.00060000}, {10,0.00060000}, {11,0.00068182}, {12,0.00074545}, {13,0.00079091}, {14,0.00088182}, {15,0.00084545}, {16,0.00080909}, {17,0.00099091}, {18,0.00086364}, {19,0.00103636}, {20,0.00090000}, {21,0.00081818}, {22,0.00121818}, {23,0.00132727}, {24,0.00094545}, {25,0.00114545}, {26,0.00165455}, {27,0.00120909}, {28,0.00112727}, {29,0.00140909}, {30,0.00172727}, {31,0.00135455}, {32,0.00130000}, {33,0.00145455}, {34,0.00162727}, {35,0.00188182}, {36,0.00184545}, {37,0.00190909}, {38,0.00173636}, {39,0.00191818}, {40,0.00204545}, {41,0.00209091}, {42,0.00197273}, {43,0.00190000}, {44,0.00198182}, {45,0.00202727}, {46,0.00202727}, {47,0.00210000}, {48,0.00219091}, {49,0.00225455}, {50,0.00200909}, {51,0.00213636}, {52,0.00214545}, {53,0.00226364}, {54,0.00227273}, {55,0.00219091}, {56,0.00240000}, {57,0.00382727}, {58,0.00240909}, {59,0.00276364}, {60,0.00237273}, {61,0.00268182}, {62,0.00263636}, {63,0.00270909}, {64,0.00260000}, {65,0.00254545}, {66,0.00280909}, {67,0.00305455}, {68,0.00260000}, {69,0.00296364}, {70,0.00295455}, {71,0.00302727}, {72,0.00303636}, {73,0.00427273}, {74,0.00307273}, {75,0.00319091}, {76,0.00306364}, {77,0.00321818}, {78,0.00320000}, {79,0.00327273}, {80,0.00342727}, {81,0.00332727}, {82,0.00331818}, {83,0.00359091}, {84,0.00360909}, {85,0.00352727}, {86,0.00370000}, {87,0.00388182}, {88,0.00355455}, {89,0.00395455}, {90,0.00368182}, {91,0.00372727}, {92,0.00398182}, {93,0.00420909}, {94,0.00391818}, {95,0.00411818}, {96,0.00397273}, {97,0.00432727}, {98,0.00562727}, {99,0.00415455}, {100,0.00464545}, {101,0.00433636}, {102,0.00434545}, {103,0.00471818}, {104,0.00480909}, {105,0.00484545}, {106,0.00465455}, {107,0.00461818}, {108,0.00448182}, {109,0.00471818}, {110,0.00477273}, {111,0.00449091}, {112,0.00459091}, {113,0.00512727}, {114,0.00527273}, {115,0.00524545}, {116,0.00530909}, {117,0.00510909}, {118,0.00751818}, {119,0.00558182}, {120,0.00530909}, {121,0.00535455}, {122,0.00516364}, {123,0.00552727}, {124,0.00605455}, {125,0.00540000}, {126,0.00539091}, {127,0.00890909}, {128,0.00598182}, {129,0.00591818}, {130,0.00595455}, {131,0.00619091}, {132,0.00573636}, {133,0.00579091}, {134,0.00647273}, {135,0.00617273}, {136,0.00789091}, {137,0.00616364}, {138,0.00640909}, {139,0.00645455}, {140,0.00625455}, {141,0.00645455}, {142,0.00667273}, {143,0.00650909}, {144,0.00805455}, {145,0.00669091}, {146,0.00650909}, {147,0.00684545}, {148,0.00673636}, {149,0.00679091}, {150,0.00687273}, {151,0.00722727}, {152,0.00695455}, {153,0.00708182}, {154,0.00720909}, {155,0.00692727}, {156,0.00720000}, {157,0.00740909}, {158,0.00691818}, {159,0.00836364}, {160,0.00748182}, {161,0.00744545}, {162,0.00754545}, {163,0.00764545}, {164,0.00770909}, {165,0.00770909}, {166,0.00870909}, {167,0.00771818}, {168,0.00771818}, {169,0.00779091}, {170,0.00787273}, {171,0.00809091}, {172,0.01222727}, {173,0.00809091}, {174,0.00802727}, {175,0.00795455}, {176,0.00817273}, {177,0.00819091}, {178,0.00810909}, {179,0.00983636}, {180,0.00830000}, {181,0.00872727}, {182,0.00858182}, {183,0.00855455}, {184,0.00895455}, {185,0.01051818}, {186,0.00890000}, {187,0.00881818}, {188,0.00874545}, {189,0.00890909}, {190,0.00879091}, {191,0.01131818}, {192,0.00930000}, {193,0.00867273}, {194,0.00914545}, {195,0.00920909}, {196,0.00908182}, {197,0.01108182}, {198,0.00940909}, {199,0.00936364}, {200,0.00917273}, {201,0.00933636}, {202,0.00972727}, {203,0.01094545}, {204,0.00990909}, {205,0.00944545}, {206,0.01000909}, {207,0.00978182}, {208,0.01417273}, {209,0.00990909}, {210,0.01006364}, {211,0.00980000}, {212,0.01037273}, {213,0.00980000}, {214,0.01177273}, {215,0.01044545}, {216,0.01000909}, {217,0.01019091}, {218,0.01045455}, {219,0.01220000}, {220,0.01048182}, {221,0.01037273}, {222,0.01050000}, {223,0.01117273}, {224,0.01370000}, {225,0.01102727}, {226,0.01078182}, {227,0.01086364}, {228,0.01075455}, {229,0.01085455}, {230,0.01071818}, {231,0.01103636}, {232,0.01117273}, {233,0.01110909}, {234,0.01574545}, {235,0.01116364}, {236,0.01129091}, {237,0.01128182}, {238,0.01121818}, {239,0.01361818}, {240,0.01151818}, {241,0.01136364}, {242,0.01155455}, {243,0.01140000}, {244,0.01498182}, {245,0.01174545}, {246,0.01179091}, {247,0.01191818}, {248,0.01175455}, {249,0.01342727}, {250,0.01200909}, {251,0.01192727}, {252,0.01202727}, {253,0.01664545}, {254,0.01209091}, {255,0.01223636}, {256,0.01201818}, {257,0.01242727}, {258,0.01439091}, {259,0.01231818}, {260,0.01229091}, {261,0.01239091}, {262,0.01684545}, {263,0.01252727}, {264,0.01246364}, {265,0.01268182}, {266,0.01239091}, {267,0.01436364}, {268,0.01294545}, {269,0.01240000}, {270,0.01274545}, {271,0.01412727}, {272,0.01284545}, {273,0.01293636}, {274,0.01292727}, {275,0.01631818}, {276,0.01317273}, {277,0.01310000}, {278,0.01300000}, {279,0.01329091}, {280,0.01323636}, {281,0.01312727}, {282,0.01316364}, {283,0.01346364}, {284,0.01385455}, {285,0.01311818}, {286,0.01371818}, {287,0.01341818}, {288,0.01472727}, {289,0.01340909}, {290,0.01351818}, {291,0.01365455}, {292,0.01500000}, {293,0.01370909}, {294,0.01361818}, {295,0.01372727}, {296,0.01488182}, {297,0.01379091}, {298,0.01365455}, {299,0.01346364}, {300,0.01440909}, {301,0.01406364}, {302,0.01393636}, {303,0.01381818}, {304,0.01405455}, {305,0.01419091}, {306,0.01427273}, {307,0.01864545}, {308,0.01421818}, {309,0.01413636}, {310,0.01433636}, {311,0.01762727}, {312,0.01400000}, {313,0.01430000}, {314,0.01467273}, {315,0.01648182}, {316,0.01452727}, {317,0.01464545}, {318,0.01478182}, {319,0.01470000}, {320,0.01459091}, {321,0.01480909}, {322,0.01766364}, {323,0.01459091}, {324,0.01467273}, {325,0.01494545}, {326,0.01670000}, {327,0.01506364}, {328,0.01505455}, {329,0.02110000}, {330,0.01510909}, {331,0.01513636}, {332,0.01518182}, {333,0.01861818}, {334,0.01528182}, {335,0.01524545}, {336,0.02251818}, {337,0.01540000}, {338,0.01552727}, {339,0.01556364}, {340,0.01813636}, {341,0.01557273}, {342,0.01567273}, {343,0.01918182}, {344,0.01607273}, {345,0.01587273}, {346,0.01580000}, {347,0.02036364}, {348,0.01605455}, {349,0.01594545}, {350,0.01847273}, {351,0.01621818}, {352,0.01639091}, {353,0.02332727}, {354,0.01610909}, {355,0.01645455}, {356,0.01637273}, {357,0.01862727}, {358,0.01656364}, {359,0.01653636}, {360,0.01959091}, {361,0.01627273}, {362,0.01667273}, {363,0.01993636}, {364,0.01674545}, {365,0.01670000}, {366,0.01636364}, {367,0.01691818}, {368,0.01688182}, {369,0.01690909}, {370,0.01706364}, {371,0.01736364}, {372,0.01753636}, {373,0.01988182}, {374,0.01723636}, {375,0.01726364}, {376,0.02028182}, {377,0.01736364}, {378,0.01774545}, {379,0.02010000}, {380,0.01706364}, {381,0.01756364}, {382,0.02080000}, {383,0.01771818}, {384,0.01806364}, {385,0.02129091}, {386,0.01800000}, {387,0.01821818}, {388,0.02176364}, {389,0.01822727}, {390,0.01830000}, {391,0.02194545}, {392,0.01793636}, {393,0.01821818}, {394,0.02211818}, {395,0.01844545}, {396,0.01841818}, {397,0.02200000}, {398,0.01847273}, {399,0.01863636}, {400,0.02158182}, {401,0.01845455}, {402,0.01872727}, {403,0.02148182}, {404,0.01882727}, {405,0.01873636}, {406,0.02110909}, {407,0.01908182}, {408,0.01890000}, {409,0.02201818}, {410,0.01896364}, {411,0.01936364}, {412,0.02195455}, {413,0.01930000}, {414,0.01933636}, {415,0.02017273}, {416,0.01919091}, {417,0.01960909}, {418,0.01953636}, {419,0.01961818}, {420,0.02354545}, {421,0.01967273}, {422,0.06093636}, {423,0.02573636}, {424,0.01982727}, {425,0.02004545}, {426,0.02280909}, {427,0.02003636}, {428,0.02035455}, {429,0.02022727}, {430,0.02030000}, {431,0.02781818}, {432,0.02029091}, {433,0.02040909}, {434,0.02480000}, {435,0.02038182}, {436,0.02067273}, {437,0.02307273}, {438,0.02041818}, {439,0.02082727}, {440,0.02058182}, {441,0.02100909}, {442,0.02430909}, {443,0.02062727}, {444,0.02071818}, {445,0.02368182}, {446,0.02092727}, {447,0.02090909}, {448,0.02087273}, {449,0.02133636}, {450,0.85339091}, {451,0.02146364}, {452,0.02099091}, {453,0.02425455}, {454,0.02162727}, {455,0.02785455}, {456,0.02128182}, {457,0.02129091}, {458,0.02764545}, {459,0.02140909}, {460,0.02151818}, {461,0.02148182}, {462,0.02185455}, {463,0.02510000}, {464,0.02146364}, {465,0.02188182}, {466,0.02201818}, {467,0.02237273}, {468,0.02586364}, {469,0.02228182}, {470,0.02209091}, {471,0.02311818}, {472,0.02229091}, {473,0.02599091}, {474,0.02254545}, {475,0.02257273}, {476,0.02345455}, {477,0.02312727}, {478,0.02608182}, {479,0.02281818}, {480,0.02293636}, {481,0.02248182}, {482,0.02283636}, {483,0.02601818}, {484,0.02265455}, {485,0.02320000}, {486,0.02314545}, {487,0.02294545}, {488,0.02683636}, {489,0.02318182}, {490,0.03064545}, {491,0.02343636}, {492,0.02333636}, {493,0.02814545}, {494,0.02341818}, {495,0.02682727}, {496,0.02347273}, {497,0.02351818}, {498,0.02373636}, {499,0.02370909}, {500,0.02683636}, {505,0.02394545}, {510,0.02781818}, {515,0.02440909}, {520,0.02452727}, {525,0.02487273}, {530,0.02497273}, {535,0.02759091}, {540,0.02575455}, {545,0.02934545}, {550,0.02581818}, {555,0.02970000}, {560,0.02610000}, {565,0.03102727}, {570,0.02656364}, {575,0.03430000}, {580,0.02705455}, {585,0.03976364}, {590,0.02710000}, {595,0.03990909}, {600,0.02775455}, {605,0.03880909}, {610,0.02822727}, {615,0.03676364}, {620,0.02856364}, {625,0.03796364}, {630,0.02947273}, {635,0.03418182}, {640,0.03008182}, {645,0.03494545}, {650,0.03082727}, {655,0.03438182}, {660,0.03089091}, {665,0.03128182}, {670,0.04665455}, {675,0.03182727}, {680,0.03922727}, {685,0.03262727}, {690,0.03748182}, {695,0.03264545}, {700,0.03298182}, {705,0.04110000}, {710,0.03350000}, {715,0.04313636}, {720,0.03383636}, {725,0.03515455}, {730,0.03866364}, {735,0.03450000}, {740,0.04536364}, {745,0.03513636}, {750,0.03528182}, {755,0.04037273}, {760,0.03594545}, {765,0.03815455}, {770,0.04190909}, {775,0.03688182}, {780,0.04005455}, {785,0.04267273}, {790,0.03715455}, {795,0.04790000}, {800,0.04387273}, {805,0.03789091}, {810,0.04796364}, {815,0.04530000}, {820,0.03857273}, {825,1.14141818}, {830,0.04650000}, {835,0.03898182}, {840,0.03930909}, {845,0.04485455}, {850,0.06009091}, {855,0.04075455}, {860,0.04696364}, {865,0.04790000}, {870,0.04115455}, {875,0.04136364}, {880,0.04870909}, {885,0.04955455}, {890,0.04200000}, {895,0.04136364}, {900,0.04830000}, {905,0.04921818}, {910,0.04312727}, {915,0.04328182}, {920,0.05002727}, {925,0.05009091}, {930,0.04416364}, {935,0.04407273}, {940,0.04853636}, {945,0.04921818}, {950,0.05257273}, {955,0.04576364}, {960,0.04580000}, {965,0.05067273}, {970,0.05093636}, {975,0.05329091}, {980,0.04691818}, {985,0.04690909}, {990,0.05114545}, {995,0.05432727}, {1000,0.05503636}, {1010,0.05817273}, {1020,0.04850000}, {1030,0.04861818}, {1040,0.05047273}, {1050,0.05420909}, {1060,0.05662727}, {1070,0.05670000}, {1080,0.05846364}, {1090,0.06062727}, {1100,0.06919091}, {1110,0.05213636}, {1120,0.05287273}, {1130,0.05324545}, {1140,0.05438182}, {1150,0.05376364}, {1160,0.05959091}, {1170,0.06043636}, {1180,0.06057273}, {1190,0.06138182}, {1200,0.06172727}, {1210,0.06246364}, {1220,0.06298182}, {1230,0.06353636}, {1240,0.06352727}, {1250,0.06246364}, {1260,0.05984545}, {1270,0.06069091}, {1280,0.06122727}, {1290,0.08351818}, {1300,0.07625455}, {1310,0.08007273}, {1320,0.07118182}, {1330,0.07028182}, {1340,0.07194545}, {1350,0.07091818}, {1360,0.07034545}, {1370,0.06454545}, {1380,0.08513636}, {1390,0.08098182}, {1400,0.07412727}, {1410,0.07581818}, {1420,0.07413636}, {1430,0.06587273}, {1440,0.08185455}, {1450,0.08739091}, {1460,0.07887273}, {1470,0.07693636}, {1480,0.09981818}, {1490,0.08269091}, {1500,0.07926364}, {1510,0.07770909}, {1520,0.10067273}, {1530,0.08472727}, {1540,0.08415455}, {1550,0.08065455}, {1560,0.08841818}, {1570,0.09368182}, {1580,0.08353636}, {1590,0.09595455}, {1600,0.09207273}, {1610,0.08540909}, {1620,0.09780000}, {1630,0.09450000}, {1640,0.08661818}, {1650,0.09018182}, {1660,0.10051818}, {1670,0.08586364}, {1680,0.09178182}, {1690,0.08983636}, {1700,0.09176364}, {1710,0.10181818}, {1720,0.11076364}, {1730,0.09432727}, {1740,0.09110000}, {1750,0.09618182}, {1760,0.09394545}, {1770,0.09694545}, {1780,0.09444545}, {1790,0.09974545}, {1800,0.09880000}, {1810,0.10075455}, {1820,0.10000000}, {1830,0.10016364}, {1840,0.09798182}, {1850,0.10034545}, {1860,0.09763636}, {1870,0.10128182}, {1880,0.12209091}, {1890,0.10347273}, {1900,0.10898182}, {1910,0.11408182}, {1920,0.10398182}, {1930,0.10163636}, {1940,0.10364545}, {1950,0.10870000}, {1960,0.11352727}, {1970,0.10629091}, {1980,0.12584545}, {1990,0.11329091}, {2000,0.11102727}, {2050,0.12872727}, {2100,0.11855455}, {2150,0.11512727}, {2200,0.11861818}, {2250,0.11933636}, {2300,0.13580909}, {2350,0.15728182}, {2400,0.15787273}, {2450,0.15728182}, {2500,0.15077273}, {2550,0.15293636}, {2600,0.13783636}, {2650,0.14208182}, {2700,0.14184545}, {2750,0.16697273}, {2800,0.16270000}, {2850,0.15152727}, {2900,0.16954545}, {2950,0.17330000}, {3000,0.18731818}, {3050,0.17107273}, {3100,0.18213636}, {3150,0.18590909}, {3200,0.17477273}, {3250,0.20023636}, {3300,0.18855455}, {3350,0.18403636}, {3400,0.18913636}, {3450,0.19208182}, {3500,0.23258182}, {3550,0.23874545}, {3600,0.23489091}, {3650,0.23492727}, {3700,0.23404545}, {3750,0.22855455}, {3800,0.20340000}, {3850,0.21148182}, {3900,0.21173636}, {3950,0.25052727}, {4000,0.23425455}, {4050,0.22103636}, {4100,0.25209091}, {4150,0.25050909}, {4200,0.27454545}, {4250,0.25121818}, {4300,0.27144545}, {4350,0.27637273}, {4400,0.24632727}, {4450,0.29186364}, {4500,0.25843636}, {4550,0.24310909}, {4600,0.26780909}, {4650,0.28906364}, {4700,0.30237273}, {4750,0.33368182}, {4800,0.34035455}, {4850,0.34310909}, {4900,0.33781818}, {4950,0.33015455}, {5000,0.30090909}, {5050,0.28954545}, {5100,0.27813636}, {5150,0.29856364}, {5200,0.33831818}, {5250,0.29058182}, {5300,0.30360909}, {5350,0.32870000}, {5400,0.29545455}, {5450,0.33730909}, {5500,0.29761818}, {5550,0.32931818}, {5600,0.37715455}, {5650,0.30189091}, {5700,0.33853636}, {5750,0.36778182}, {5800,0.39349091}, {5850,0.31127273}, {5900,0.33024545}, {5950,0.33354545}, {6000,0.33395455}, {6050,0.33882727}, {6100,0.33941818}, {6150,0.34587273}, {6200,0.34410000}, {6250,0.42692727}, {6300,0.40203636}, {6350,0.37872727}, {6400,0.35540000}, {6450,0.43295455}, {6500,0.38634545}, {6550,0.38080909}, {6600,0.39881818}, {6650,0.36751818}, {6700,0.39280000}, {6750,0.47809091}, {6800,0.39620909}, {6850,0.45065455}, {6900,0.39799091}, {6950,0.39335455}, {7000,0.42461818}, {7050,0.46459091}, {7100,0.47103636}, {7150,0.48463636}, {7200,0.49385455}, {7250,0.50164545}, {7300,0.49831818}, {7350,0.49270909}, {7400,0.48220909}, {7450,0.46435455}, {7500,0.45768182}, {7550,0.42121818}, {7600,0.51140909}, {7650,0.47677273}, {7700,0.44941818}, {7750,0.50900000}, {7800,0.45970909}, {7850,0.51108182}, {7900,0.46606364}, {7950,0.51022727}, {8000,0.44783636}, {8050,0.49753636}, {8100,0.55350909}, {8150,0.51934545}, {8200,0.47904545}, {8250,0.49916364}, {8300,0.52846364}, {8350,0.55105455}, {8400,0.57263636}, {8450,0.58677273}, {8500,0.58222727}, {8550,0.56922727}, {8600,0.56177273}, {8650,0.54414545}, {8700,0.49462727}, {8750,0.61064545}, {8800,0.58891818}, {8850,0.55674545}, {8900,0.56867273}, {8950,0.59017273}, {9000,0.53872727}};
data["big"]["TemplateCoq"]["reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003636}, {4,0.00000000}, {5,0.00003636}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00003636}, {10,0.00003636}, {11,0.00003636}, {12,0.00003636}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00007273}, {17,0.00000000}, {18,0.00000000}, {19,0.00002727}, {20,0.00010909}, {21,0.00007273}, {22,0.00003636}, {23,0.00000000}, {24,0.00000000}, {25,0.00003636}, {26,0.00000000}, {27,0.00000000}, {28,0.00003636}, {29,0.00000000}, {30,0.00003636}, {31,0.00000000}, {32,0.00000000}, {33,0.00006364}, {34,0.00000000}, {35,0.00003636}, {36,0.00000000}, {37,0.00000000}, {38,0.00007273}, {39,0.00003636}, {40,0.00000000}, {41,0.00003636}, {42,0.00003636}, {43,0.00003636}, {44,0.00000000}, {45,0.00000000}, {46,0.00010909}, {47,0.00007273}, {48,0.00007273}, {49,0.00000000}, {50,0.00000000}, {51,0.00003636}, {52,0.00003636}, {53,0.00000000}, {54,0.00000000}, {55,0.00002727}, {56,0.00007273}, {57,0.00000000}, {58,0.00003636}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00003636}, {65,0.00000000}, {66,0.00002727}, {67,0.00007273}, {68,0.00007273}, {69,0.00000000}, {70,0.00007273}, {71,0.00003636}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00003636}, {76,0.00007273}, {77,0.00003636}, {78,0.00003636}, {79,0.00010909}, {80,0.00003636}, {81,0.00000000}, {82,0.00000000}, {83,0.00003636}, {84,0.00003636}, {85,0.00000000}, {86,0.00003636}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00003636}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00007273}, {96,0.00007273}, {97,0.00000000}, {98,0.00000000}, {99,0.00003636}, {100,0.00000000}, {101,0.00007273}, {102,0.00003636}, {103,0.00000000}, {104,0.00000000}, {105,0.00003636}, {106,0.00007273}, {107,0.00007273}, {108,0.00010909}, {109,0.00003636}, {110,0.00003636}, {111,0.00003636}, {112,0.00010000}, {113,0.00003636}, {114,0.00003636}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00007273}, {119,0.00003636}, {120,0.00013636}, {121,0.00010909}, {122,0.00000000}, {123,0.00010909}, {124,0.00003636}, {125,0.00003636}, {126,0.00003636}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00007273}, {132,0.00003636}, {133,0.00000000}, {134,0.00007273}, {135,0.00003636}, {136,0.00000000}, {137,0.00003636}, {138,0.00003636}, {139,0.00007273}, {140,0.00003636}, {141,0.00007273}, {142,0.00000000}, {143,0.00007273}, {144,0.00000000}, {145,0.00002727}, {146,0.00003636}, {147,0.00000000}, {148,0.00007273}, {149,0.00003636}, {150,0.00003636}, {151,0.00000000}, {152,0.00003636}, {153,0.00007273}, {154,0.00003636}, {155,0.00003636}, {156,0.00003636}, {157,0.00000000}, {158,0.00000000}, {159,0.00007273}, {160,0.00003636}, {161,0.00003636}, {162,0.00003636}, {163,0.00000000}, {164,0.00000000}, {165,0.00003636}, {166,0.00014545}, {167,0.00000000}, {168,0.00000000}, {169,0.00003636}, {170,0.00000000}, {171,0.00007273}, {172,0.00000000}, {173,0.00003636}, {174,0.00000000}, {175,0.00003636}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00003636}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00003636}, {184,0.00000000}, {185,0.00003636}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00010909}, {190,0.00002727}, {191,0.00003636}, {192,0.00003636}, {193,0.00010000}, {194,0.00003636}, {195,0.00003636}, {196,0.00010909}, {197,0.00000000}, {198,0.00000000}, {199,0.00007273}, {200,0.00006364}, {201,0.00003636}, {202,0.00000000}, {203,0.00002727}, {204,0.00000000}, {205,0.00010909}, {206,0.00002727}, {207,0.00003636}, {208,0.00003636}, {209,0.00000000}, {210,0.00000000}, {211,0.00003636}, {212,0.00000000}, {213,0.00003636}, {214,0.00007273}, {215,0.00003636}, {216,0.00007273}, {217,0.00007273}, {218,0.00003636}, {219,0.00003636}, {220,0.00007273}, {221,0.00000000}, {222,0.00007273}, {223,0.00000000}, {224,0.00000000}, {225,0.00003636}, {226,0.00003636}, {227,0.00003636}, {228,0.00003636}, {229,0.00010909}, {230,0.00003636}, {231,0.00007273}, {232,0.00000000}, {233,0.00007273}, {234,0.00007273}, {235,0.00003636}, {236,0.00007273}, {237,0.00003636}, {238,0.00003636}, {239,0.00000000}, {240,0.00002727}, {241,0.00003636}, {242,0.00003636}, {243,0.00003636}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00003636}, {248,0.00007273}, {249,0.00000000}, {250,0.00003636}, {251,0.00006364}, {252,0.00007273}, {253,0.00000000}, {254,0.00000000}, {255,0.00003636}, {256,0.00010909}, {257,0.00003636}, {258,0.00000000}, {259,0.00000000}, {260,0.00003636}, {261,0.00003636}, {262,0.00003636}, {263,0.00000000}, {264,0.00003636}, {265,0.00007273}, {266,0.00014545}, {267,0.00014545}, {268,0.00000000}, {269,0.00014545}, {270,0.00003636}, {271,0.00007273}, {272,0.00000000}, {273,0.00000000}, {274,0.00003636}, {275,0.00003636}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00007273}, {280,0.00003636}, {281,0.00003636}, {282,0.00000000}, {283,0.00003636}, {284,0.00003636}, {285,0.00007273}, {286,0.00000000}, {287,0.00010909}, {288,0.00003636}, {289,0.00007273}, {290,0.00000000}, {291,0.00010909}, {292,0.00007273}, {293,0.00007273}, {294,0.00007273}, {295,0.00003636}, {296,0.00003636}, {297,0.00003636}, {298,0.00007273}, {299,0.00000000}, {300,0.00003636}, {301,0.00006364}, {302,0.00000000}, {303,0.00000000}, {304,0.00003636}, {305,0.00000000}, {306,0.00003636}, {307,0.00007273}, {308,0.00014545}, {309,0.00010909}, {310,0.00000000}, {311,0.00000000}, {312,0.00003636}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00014545}, {317,0.00003636}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00010000}, {324,0.00010909}, {325,0.00007273}, {326,0.00007273}, {327,0.00007273}, {328,0.00003636}, {329,0.00007273}, {330,0.00003636}, {331,0.00000000}, {332,0.00010909}, {333,0.00007273}, {334,0.00003636}, {335,0.00007273}, {336,0.00010909}, {337,0.00003636}, {338,0.00007273}, {339,0.00000000}, {340,0.00007273}, {341,0.00007273}, {342,0.00003636}, {343,0.00003636}, {344,0.00000000}, {345,0.00003636}, {346,0.00007273}, {347,0.00003636}, {348,0.00000000}, {349,0.00003636}, {350,0.00007273}, {351,0.00003636}, {352,0.00007273}, {353,0.00007273}, {354,0.00007273}, {355,0.00003636}, {356,0.00007273}, {357,0.00003636}, {358,0.00002727}, {359,0.00007273}, {360,0.00007273}, {361,0.00010909}, {362,0.00003636}, {363,0.00007273}, {364,0.00000000}, {365,0.00003636}, {366,0.00010909}, {367,0.00000000}, {368,0.00006364}, {369,0.00003636}, {370,0.00003636}, {371,0.00000000}, {372,0.00003636}, {373,0.00000000}, {374,0.00003636}, {375,0.00007273}, {376,0.00007273}, {377,0.00000000}, {378,0.00003636}, {379,0.00007273}, {380,0.00010909}, {381,0.00003636}, {382,0.00003636}, {383,0.00007273}, {384,0.00003636}, {385,0.00010909}, {386,0.00007273}, {387,0.00010000}, {388,0.00000000}, {389,0.00000000}, {390,0.00007273}, {391,0.00003636}, {392,0.00003636}, {393,0.00000000}, {394,0.00000000}, {395,0.00003636}, {396,0.00003636}, {397,0.00000000}, {398,0.00003636}, {399,0.00014545}, {400,0.00000000}, {401,0.00003636}, {402,0.00000000}, {403,0.00006364}, {404,0.00002727}, {405,0.00002727}, {406,0.00007273}, {407,0.00003636}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00003636}, {412,0.00003636}, {413,0.00003636}, {414,0.00007273}, {415,0.00000000}, {416,0.00014545}, {417,0.00003636}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00007273}, {423,0.00003636}, {424,0.00007273}, {425,0.00010909}, {426,0.00010000}, {427,0.00003636}, {428,0.00000000}, {429,0.00003636}, {430,0.00007273}, {431,0.00000000}, {432,0.00003636}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00003636}, {438,0.00003636}, {439,0.00000000}, {440,0.00007273}, {441,0.00007273}, {442,0.00007273}, {443,0.00003636}, {444,0.00014545}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00003636}, {449,0.00003636}, {450,0.00081818}, {451,0.00000000}, {452,0.00000000}, {453,0.00003636}, {454,0.00000000}, {455,0.00003636}, {456,0.00007273}, {457,0.00007273}, {458,0.00007273}, {459,0.00007273}, {460,0.00003636}, {461,0.00007273}, {462,0.00003636}, {463,0.00003636}, {464,0.00000000}, {465,0.00000000}, {466,0.00003636}, {467,0.00003636}, {468,0.00003636}, {469,0.00003636}, {470,0.00010909}, {471,0.00003636}, {472,0.00010909}, {473,0.00003636}, {474,0.00010909}, {475,0.00000000}, {476,0.00013636}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00002727}, {482,0.00003636}, {483,0.00007273}, {484,0.00014545}, {485,0.00000000}, {486,0.00000000}, {487,0.00003636}, {488,0.00003636}, {489,0.00003636}, {490,0.00006364}, {491,0.00007273}, {492,0.00003636}, {493,0.00002727}, {494,0.00003636}, {495,0.00003636}, {496,0.00003636}, {497,0.00007273}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00003636}, {510,0.00007273}, {515,0.00003636}, {520,0.00003636}, {525,0.00000000}, {530,0.00003636}, {535,0.00007273}, {540,0.00002727}, {545,0.00003636}, {550,0.00013636}, {555,0.00000000}, {560,0.00000000}, {565,0.00003636}, {570,0.00010909}, {575,0.00003636}, {580,0.00013636}, {585,0.00010909}, {590,0.00017273}, {595,0.00003636}, {600,0.00007273}, {605,0.00003636}, {610,0.00007273}, {615,0.00003636}, {620,0.00000000}, {625,0.00007273}, {630,0.00007273}, {635,0.00003636}, {640,0.00003636}, {645,0.00003636}, {650,0.00003636}, {655,0.00010000}, {660,0.00007273}, {665,0.00000000}, {670,0.00003636}, {675,0.00007273}, {680,0.00003636}, {685,0.00003636}, {690,0.00010909}, {695,0.00000000}, {700,0.00003636}, {705,0.00002727}, {710,0.00021818}, {715,0.00003636}, {720,0.00003636}, {725,0.00014545}, {730,0.00007273}, {735,0.00018182}, {740,0.00006364}, {745,0.00010909}, {750,0.00007273}, {755,0.00014545}, {760,0.00007273}, {765,0.00000000}, {770,0.00010000}, {775,0.00000000}, {780,0.00014545}, {785,0.00010909}, {790,0.00014545}, {795,0.00007273}, {800,0.00003636}, {805,0.00003636}, {810,0.00003636}, {815,0.00010909}, {820,0.00003636}, {825,0.00137273}, {830,0.00007273}, {835,0.00003636}, {840,0.00003636}, {845,0.00007273}, {850,0.00000000}, {855,0.00000000}, {860,0.00007273}, {865,0.00007273}, {870,0.00007273}, {875,0.00002727}, {880,0.00003636}, {885,0.00000000}, {890,0.00003636}, {895,0.00010000}, {900,0.00000000}, {905,0.00007273}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00006364}, {930,0.00000000}, {935,0.00014545}, {940,0.00000000}, {945,0.00010909}, {950,0.00000000}, {955,0.00007273}, {960,0.00000000}, {965,0.00007273}, {970,0.00000000}, {975,0.00003636}, {980,0.00003636}, {985,0.00000000}, {990,0.00003636}, {995,0.00007273}, {1000,0.00007273}, {1010,0.00014545}, {1020,0.00000000}, {1030,0.00007273}, {1040,0.00010909}, {1050,0.00007273}, {1060,0.00003636}, {1070,0.00010909}, {1080,0.00003636}, {1090,0.00003636}, {1100,0.00006364}, {1110,0.00003636}, {1120,0.00000000}, {1130,0.00007273}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00003636}, {1190,0.00007273}, {1200,0.00000000}, {1210,0.00003636}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00010909}, {1250,0.00003636}, {1260,0.00007273}, {1270,0.00000000}, {1280,0.00003636}, {1290,0.00003636}, {1300,0.00021818}, {1310,0.00003636}, {1320,0.00003636}, {1330,0.00000000}, {1340,0.00002727}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00007273}, {1400,0.00003636}, {1410,0.00000000}, {1420,0.00007273}, {1430,0.00003636}, {1440,0.00003636}, {1450,0.00010909}, {1460,0.00007273}, {1470,0.00000000}, {1480,0.00003636}, {1490,0.00000000}, {1500,0.00007273}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00003636}, {1540,0.00000000}, {1550,0.00010909}, {1560,0.00000000}, {1570,0.00010909}, {1580,0.00000000}, {1590,0.00003636}, {1600,0.00003636}, {1610,0.00007273}, {1620,0.00003636}, {1630,0.00014545}, {1640,0.00003636}, {1650,0.00007273}, {1660,0.00003636}, {1670,0.00007273}, {1680,0.00010000}, {1690,0.00000000}, {1700,0.00003636}, {1710,0.00007273}, {1720,0.00010909}, {1730,0.00007273}, {1740,0.00007273}, {1750,0.00003636}, {1760,0.00007273}, {1770,0.00000000}, {1780,0.00007273}, {1790,0.00007273}, {1800,0.00003636}, {1810,0.00007273}, {1820,0.00003636}, {1830,0.00003636}, {1840,0.00007273}, {1850,0.00010909}, {1860,0.00014545}, {1870,0.00007273}, {1880,0.00010909}, {1890,0.00000000}, {1900,0.00003636}, {1910,0.00000000}, {1920,0.00007273}, {1930,0.00010909}, {1940,0.00014545}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00003636}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00003636}, {2100,0.00003636}, {2150,0.00000000}, {2200,0.00006364}, {2250,0.00007273}, {2300,0.00003636}, {2350,0.00003636}, {2400,0.00010909}, {2450,0.00003636}, {2500,0.00010909}, {2550,0.00000000}, {2600,0.00007273}, {2650,0.00003636}, {2700,0.00000000}, {2750,0.00003636}, {2800,0.00007273}, {2850,0.00006364}, {2900,0.00000000}, {2950,0.00010909}, {3000,0.00003636}, {3050,0.00003636}, {3100,0.00007273}, {3150,0.00032727}, {3200,0.00025455}, {3250,0.00029091}, {3300,0.00021818}, {3350,0.00007273}, {3400,0.00021818}, {3450,0.00010000}, {3500,0.00067273}, {3550,0.00120000}, {3600,0.00086364}, {3650,0.00071818}, {3700,0.00064545}, {3750,0.00028182}, {3800,0.00010909}, {3850,0.00031818}, {3900,0.00014545}, {3950,0.00039091}, {4000,0.00050000}, {4050,0.00013636}, {4100,0.00060909}, {4150,0.00046364}, {4200,0.00064545}, {4250,0.00029091}, {4300,0.00031818}, {4350,0.00036364}, {4400,0.00038182}, {4450,0.00053636}, {4500,0.00040000}, {4550,0.00043636}, {4600,0.00050000}, {4650,0.00082727}, {4700,0.00044545}, {4750,0.00079091}, {4800,0.00083636}, {4850,0.00070909}, {4900,0.00109091}, {4950,0.00070909}, {5000,0.00032727}, {5050,0.00040000}, {5100,0.00024545}, {5150,0.00025455}, {5200,0.00002727}, {5250,0.00007273}, {5300,0.00021818}, {5350,0.00018182}, {5400,0.00018182}, {5450,0.00038182}, {5500,0.00038182}, {5550,0.00056364}, {5600,0.00085455}, {5650,0.00010909}, {5700,0.00040000}, {5750,0.00079091}, {5800,0.00018182}, {5850,0.00010909}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00007273}, {6050,0.00039091}, {6100,0.00003636}, {6150,0.00025455}, {6200,0.00010909}, {6250,0.00024545}, {6300,0.00007273}, {6350,0.00007273}, {6400,0.00003636}, {6450,0.00007273}, {6500,0.00024545}, {6550,0.00003636}, {6600,0.00010909}, {6650,0.00007273}, {6700,0.00007273}, {6750,0.00020909}, {6800,0.00018182}, {6850,0.00014545}, {6900,0.00007273}, {6950,0.00003636}, {7000,0.00007273}, {7050,0.00006364}, {7100,0.00024545}, {7150,0.00014545}, {7200,0.00007273}, {7250,0.00020909}, {7300,0.00007273}, {7350,0.00007273}, {7400,0.00014545}, {7450,0.00014545}, {7500,0.00014545}, {7550,0.00007273}, {7600,0.00014545}, {7650,0.00014545}, {7700,0.00003636}, {7750,0.00003636}, {7800,0.00013636}, {7850,0.00010000}, {7900,0.00003636}, {7950,0.00010909}, {8000,0.00007273}, {8050,0.00010909}, {8100,0.00010909}, {8150,0.00018182}, {8200,0.00018182}, {8250,0.00010000}, {8300,0.00007273}, {8350,0.00010909}, {8400,0.00014545}, {8450,0.00010909}, {8500,0.00016364}, {8550,0.00014545}, {8600,0.00021818}, {8650,0.00025455}, {8700,0.00014545}, {8750,0.00007273}, {8800,0.00007273}, {8850,0.00014545}, {8900,0.00010000}, {8950,0.00032727}, {9000,0.00077273}};
data["big"]["TypeClasses"]["Aggregate"]["real"] = {{1,0.001066667}, {2,0.002000000}, {3,0.002693333}, {4,0.003524444}, {5,0.004546667}, {6,0.005604444}, {7,0.006906667}, {8,0.008177778}, {9,0.009742222}, {10,0.030648889}, {11,0.012902222}, {12,0.014728889}, {13,0.016844444}, {14,0.019195556}, {15,0.021422222}, {16,0.024835556}, {17,0.026937778}, {18,0.029617778}, {19,0.032564444}, {20,0.038453333}, {21,0.039226667}, {22,0.042813333}, {23,0.049657778}, {24,0.050511111}, {25,0.056706667}, {26,0.059613333}, {27,0.067186667}, {28,0.070124444}, {29,0.080111111}, {30,0.080155556}, {31,0.088546667}, {32,0.098817778}, {33,0.102164444}, {34,0.106240000}, {35,0.116151111}, {36,0.126702222}, {37,0.132413333}, {38,0.140395556}, {39,0.148831111}, {40,0.161484444}, {41,0.168448889}, {42,0.172955556}, {43,0.187253333}, {44,0.198791111}, {45,0.206000000}, {46,0.221831111}, {47,0.234133333}, {48,0.243782222}, {49,0.262591111}, {50,0.269884444}, {51,0.277235556}, {52,0.289386667}, {53,0.304826667}, {54,0.321640000}, {55,0.340217778}, {56,0.355035556}, {57,0.374733333}, {58,0.388462222}, {59,0.404168889}, {60,0.424511111}, {61,0.440720000}, {62,0.457693333}, {63,0.479186667}, {64,0.500782222}, {65,0.523733333}, {66,0.542368889}, {67,0.563106667}, {68,0.591093333}, {69,0.605426667}, {70,0.636777778}, {71,0.659151111}, {72,0.683915556}, {73,0.737702222}, {74,0.895893333}, {75,0.879573333}, {76,0.796031111}, {77,0.835386667}, {78,0.911235556}, {79,0.884977778}, {80,0.921626667}, {81,0.942435556}, {82,0.973133333}, {83,1.024902222}, {84,1.072595556}, {85,1.081128889}, {86,1.113333}, {87,1.125222}, {88,1.165111}, {89,1.206722}, {90,1.244111}, {91,1.293611}, {92,1.328222}, {93,1.373333}, {94,1.421722}, {95,1.469333}, {96,1.509167}, {97,1.557333}, {98,1.607222}, {99,1.653500}, {100,1.708889}, {101,1.766222}, {102,1.825056}, {103,1.873722}, {104,1.930722}, {105,1.990222}, {106,2.046722}, {107,2.108056}, {108,2.165278}, {109,2.235000}, {110,2.383222}, {111,2.389111}, {112,2.557667}, {113,2.535222}, {114,2.671056}, {115,2.704056}, {116,2.788556}, {117,2.847278}, {118,2.872944}, {119,2.945278}, {120,3.069000}, {121,3.104000}, {122,3.192611}, {123,3.263222}, {124,3.367500}, {125,3.437444}, {126,3.523167}, {127,3.627278}, {128,3.720889}, {129,3.802278}, {130,3.909333}, {131,4.003556}, {132,4.095778}, {133,4.199944}, {134,4.321444}, {135,4.410778}, {136,4.506667}, {137,4.617222}, {138,4.730333}, {139,4.853167}, {140,4.960778}, {141,5.079444}, {142,5.196333}, {143,5.314056}, {144,5.444444}, {145,5.565111}, {146,5.693222}, {147,5.824389}, {148,5.953444}, {149,6.094944}, {150,6.217056}, {151,6.351833}, {152,6.520278}, {153,6.658722}, {154,6.807389}, {155,6.940722}, {156,7.092167}, {157,7.253833}, {158,7.422556}, {159,7.563667}, {160,7.719556}, {161,7.887833}, {162,8.049889}, {163,8.221722}, {164,8.400111}, {165,8.561833}, {166,8.751722}, {167,8.961611}, {168,9.117500}, {169,9.279500}, {170,9.472778}, {171,9.687000}, {172,9.869556}, {173,10.113000}, {174,10.307944}, {175,10.473000}, {176,10.662833}, {177,10.951111}, {178,11.110611}, {179,11.345722}, {180,11.538611}, {181,11.730222}, {182,11.942667}, {183,12.150833}, {184,12.387111}, {185,12.597056}, {186,12.795722}, {187,13.060278}, {188,13.269167}, {189,13.603333}, {190,13.824056}, {191,14.141667}, {192,14.303222}, {193,14.686333}, {194,14.907111}, {195,15.173778}, {196,15.410722}, {197,15.666389}, {198,15.987722}, {199,16.279611}, {200,16.491278}, {201,16.754444}, {202,17.028111}, {203,17.271222}, {204,17.610167}, {205,17.921000}, {206,18.214722}, {207,18.522167}, {208,18.789111}, {209,19.031778}, {210,19.379667}, {211,19.710667}, {212,19.996889}, {213,20.392833}, {214,20.683500}, {215,20.974833}, {216,21.367167}, {217,21.697056}, {218,21.980333}, {219,22.447056}, {220,22.686333}, {221,23.124222}, {222,23.444333}, {223,23.746056}, {224,24.171889}, {225,24.570500}, {226,24.957167}, {227,25.270778}, {228,25.614722}, {229,26.105722}, {230,26.541611}, {231,26.921444}, {232,27.336833}, {233,27.708833}, {234,28.195611}, {235,28.787889}, {236,29.059444}, {237,29.665333}, {238,30.043333}, {239,30.514000}, {240,30.759556}, {241,31.308667}, {242,31.848500}, {243,32.200611}, {244,32.723778}, {245,33.177500}, {246,33.728444}, {247,34.152611}, {248,34.626778}, {249,35.272944}, {250,35.712278}, {251,36.331444}, {252,36.721444}, {253,37.115278}, {254,37.752556}, {255,38.322389}, {256,38.766278}, {257,39.412167}, {258,39.730222}, {259,40.410056}, {260,40.859722}, {261,41.571667}, {262,42.148778}, {263,42.923056}, {264,43.454333}, {265,44.109111}, {266,44.729222}, {267,45.090778}, {268,45.994778}, {269,46.691389}, {270,47.161611}, {271,47.609778}, {272,48.478944}, {273,48.908778}, {274,49.757833}, {275,50.512611}, {276,51.025556}, {277,51.770222}, {278,52.410611}, {279,53.136000}, {280,54.052389}, {281,54.679944}, {282,55.455611}, {283,56.110333}, {284,57.112889}, {285,57.906500}, {286,58.357500}, {287,59.307222}, {288,59.825778}, {289,60.760944}, {290,61.328056}, {291,62.199444}, {292,62.713556}, {293,64.045722}, {294,64.899944}, {295,65.692222}, {296,66.851500}, {297,67.619167}, {298,68.612333}, {299,69.173444}, {300,70.014000}, {301,78.9230}, {302,78.7520}, {303,77.8985}, {304,78.6400}, {305,81.905}, {306,83.582}, {307,84.904}, {308,86.126}, {309,86.804}, {310,87.631}, {311,88.62}, {312,90.464}, {313,91.361}, {314,93.105}, {315,94.491}, {316,95.235}, {317,96.296}, {318,96.997}, {319,99.15}, {320,100.03}, {321,101.672}, {322,103.551}, {323,104.049}, {324,105.555}, {325,107.03}, {326,108.112}, {327,110.649}, {328,111.385}, {329,112.848}, {330,114.363}, {331,115.217}, {332,117.426}, {333,118.723}, {334,120.498}, {335,121.907}, {336,123.255}, {337,124.355}, {338,126.217}, {339,127.262}, {340,130.146}, {341,131.914}, {342,133.138}, {343,133.416}, {344,135.574}, {345,137.977}, {346,139.054}, {347,140.947}, {348,143.965}, {349,144.761}, {350,146.112}, {351,148.747}, {352,149.828}, {353,151.981}, {354,154.358}, {355,155.459}, {356,156.706}, {357,158.812}, {358,161.408}, {359,163.085}, {360,164.996}, {361,167.241}, {362,168.211}, {363,170.161}, {364,172.108}, {365,174.948}, {366,176.667}, {367,179.074}, {368,181.298}, {369,182.494}, {370,185.107}, {371,186.611}, {372,189.008}, {373,192.002}, {374,194.022}, {375,195.419}, {376,197.068}, {377,200.283}, {378,202.}, {379,204.018}, {380,204.769}, {381,206.242}, {382,208.018}, {383,211.12}, {384,212.892}, {385,216.65}, {386,218.486}, {387,219.412}, {388,223.31}, {389,224.561}, {390,228.324}, {391,229.955}, {392,231.967}, {393,234.735}, {394,237.994}, {395,241.245}, {396,242.465}, {397,245.037}, {398,247.562}, {399,250.302}, {400,254.77}, {401,255.951}, {402,258.487}, {403,260.193}, {404,263.94}, {405,267.421}, {406,268.823}, {407,271.509}, {408,276.769}, {409,276.091}, {410,281.543}, {411,282.425}, {412,285.144}, {413,287.948}, {414,291.651}, {415,294.669}, {416,299.472}, {417,301.101}, {418,303.552}, {419,306.428}, {420,278.809}, {421,260.828}, {422,263.605}, {423,321.539}, {424,321.101}, {425,324.541}, {426,328.809}, {427,332.421}, {428,334.486}, {429,326.637}, {430,334.779}, {431,336.676}, {432,331.599}, {433,335.695}, {434,338.605}, {435,340.303}, {436,353.364}, {437,353.958}, {438,358.776}, {439,363.202}, {440,364.028}, {441,368.175}, {442,371.455}, {443,375.287}, {444,378.955}, {445,382.624}, {446,387.011}, {447,386.656}, {448,396.635}, {449,399.935}, {450,401.949}, {451,405.224}, {452,409.433}};
data["big"]["TypeClasses"]["Aggregate"]["user"] = {{1,0.001724444}, {2,0.002111111}, {3,0.002982222}, {4,0.003755556}, {5,0.004737778}, {6,0.005644444}, {7,0.006937778}, {8,0.008151111}, {9,0.009857778}, {10,0.030711111}, {11,0.013248889}, {12,0.014791111}, {13,0.016488889}, {14,0.018968889}, {15,0.021368889}, {16,0.025195556}, {17,0.026991111}, {18,0.029551111}, {19,0.032742222}, {20,0.038364444}, {21,0.039062222}, {22,0.042795556}, {23,0.049493333}, {24,0.050488889}, {25,0.056795556}, {26,0.059715556}, {27,0.067062222}, {28,0.070022222}, {29,0.080106667}, {30,0.080315556}, {31,0.088528889}, {32,0.098613333}, {33,0.102151111}, {34,0.106328889}, {35,0.116048889}, {36,0.126484444}, {37,0.132417778}, {38,0.140275556}, {39,0.148564444}, {40,0.161284444}, {41,0.168364444}, {42,0.172564444}, {43,0.187000000}, {44,0.198568889}, {45,0.205875556}, {46,0.221440000}, {47,0.233951111}, {48,0.243595556}, {49,0.262213333}, {50,0.269448889}, {51,0.276911111}, {52,0.288951111}, {53,0.304462222}, {54,0.321111111}, {55,0.339888889}, {56,0.354600000}, {57,0.374448889}, {58,0.388084444}, {59,0.403662222}, {60,0.424062222}, {61,0.440048889}, {62,0.457364444}, {63,0.478404444}, {64,0.500280000}, {65,0.523373333}, {66,0.541826667}, {67,0.562648889}, {68,0.590488889}, {69,0.604955556}, {70,0.636164444}, {71,0.658728889}, {72,0.683275556}, {73,0.737155556}, {74,0.894648889}, {75,0.878666667}, {76,0.795048889}, {77,0.834306667}, {78,0.909906667}, {79,0.884142222}, {80,0.920640000}, {81,0.941431111}, {82,0.972248889}, {83,1.023893333}, {84,1.071471111}, {85,1.080337778}, {86,1.110000}, {87,1.123722}, {88,1.164000}, {89,1.205611}, {90,1.243389}, {91,1.291056}, {92,1.326333}, {93,1.372111}, {94,1.418222}, {95,1.466000}, {96,1.507833}, {97,1.555444}, {98,1.605000}, {99,1.651278}, {100,1.706889}, {101,1.764833}, {102,1.822944}, {103,1.871944}, {104,1.929333}, {105,1.988000}, {106,2.044833}, {107,2.106500}, {108,2.163667}, {109,2.232667}, {110,2.380944}, {111,2.385944}, {112,2.556000}, {113,2.533611}, {114,2.667389}, {115,2.701333}, {116,2.785778}, {117,2.844444}, {118,2.870611}, {119,2.943000}, {120,3.067167}, {121,3.102111}, {122,3.189833}, {123,3.261278}, {124,3.365333}, {125,3.435333}, {126,3.521278}, {127,3.624889}, {128,3.717778}, {129,3.799667}, {130,3.907056}, {131,4.000611}, {132,4.093222}, {133,4.197444}, {134,4.319278}, {135,4.408667}, {136,4.504722}, {137,4.615222}, {138,4.727222}, {139,4.849556}, {140,4.957333}, {141,5.075667}, {142,5.193333}, {143,5.310611}, {144,5.440333}, {145,5.560444}, {146,5.690389}, {147,5.821444}, {148,5.953056}, {149,6.094167}, {150,6.215833}, {151,6.351333}, {152,6.519056}, {153,6.658167}, {154,6.805278}, {155,6.939278}, {156,7.090444}, {157,7.253000}, {158,7.422000}, {159,7.562944}, {160,7.719556}, {161,7.887167}, {162,8.048778}, {163,8.218778}, {164,8.398111}, {165,8.558333}, {166,8.751000}, {167,8.960722}, {168,9.117333}, {169,9.278833}, {170,9.471889}, {171,9.685722}, {172,9.865778}, {173,10.109167}, {174,10.304500}, {175,10.469611}, {176,10.657833}, {177,10.943500}, {178,11.105500}, {179,11.339222}, {180,11.530111}, {181,11.724778}, {182,11.936611}, {183,12.144222}, {184,12.380722}, {185,12.589667}, {186,12.789222}, {187,13.053667}, {188,13.262056}, {189,13.597500}, {190,13.817833}, {191,14.136000}, {192,14.296389}, {193,14.679722}, {194,14.900611}, {195,15.167333}, {196,15.403389}, {197,15.656778}, {198,15.978722}, {199,16.265333}, {200,16.476111}, {201,16.743111}, {202,17.012389}, {203,17.256500}, {204,17.595056}, {205,17.906611}, {206,18.203889}, {207,18.511556}, {208,18.777722}, {209,19.020833}, {210,19.368500}, {211,19.698889}, {212,19.986500}, {213,20.378444}, {214,20.670667}, {215,20.962556}, {216,21.355944}, {217,21.686611}, {218,21.970556}, {219,22.437389}, {220,22.676944}, {221,23.109222}, {222,23.427889}, {223,23.727889}, {224,24.151444}, {225,24.551722}, {226,24.940278}, {227,25.252278}, {228,25.597889}, {229,26.088000}, {230,26.522611}, {231,26.900667}, {232,27.321778}, {233,27.696833}, {234,28.184333}, {235,28.775944}, {236,29.048167}, {237,29.658944}, {238,30.035833}, {239,30.509722}, {240,30.753556}, {241,31.301278}, {242,31.842056}, {243,32.194333}, {244,32.717444}, {245,33.170778}, {246,33.723000}, {247,34.149722}, {248,34.625389}, {249,35.270056}, {250,35.709000}, {251,36.325611}, {252,36.707889}, {253,37.104167}, {254,37.741111}, {255,38.304500}, {256,38.749611}, {257,39.394056}, {258,39.716778}, {259,40.396389}, {260,40.847222}, {261,41.547111}, {262,42.122000}, {263,42.897056}, {264,43.418500}, {265,44.076389}, {266,44.694111}, {267,45.054722}, {268,45.957833}, {269,46.656056}, {270,47.124222}, {271,47.583722}, {272,48.454056}, {273,48.879833}, {274,49.731111}, {275,50.485278}, {276,50.999556}, {277,51.747056}, {278,52.396889}, {279,53.120389}, {280,54.044278}, {281,54.672889}, {282,55.448778}, {283,56.106278}, {284,57.093722}, {285,57.882222}, {286,58.335222}, {287,59.280778}, {288,59.795778}, {289,60.727278}, {290,61.288056}, {291,62.155333}, {292,62.670056}, {293,64.001500}, {294,64.864333}, {295,65.658889}, {296,66.829944}, {297,67.601000}, {298,68.589500}, {299,69.161444}, {300,69.987889}, {301,78.7820}, {302,78.3080}, {303,76.9235}, {304,77.8840}, {305,81.904}, {306,83.579}, {307,84.904}, {308,86.127}, {309,86.804}, {310,87.627}, {311,88.615}, {312,90.463}, {313,91.36}, {314,93.104}, {315,94.488}, {316,95.235}, {317,96.296}, {318,96.996}, {319,99.151}, {320,100.028}, {321,101.667}, {322,103.552}, {323,104.048}, {324,105.556}, {325,107.023}, {326,108.112}, {327,110.648}, {328,111.383}, {329,112.848}, {330,114.359}, {331,115.215}, {332,117.423}, {333,118.723}, {334,120.496}, {335,121.907}, {336,123.256}, {337,124.351}, {338,126.22}, {339,127.259}, {340,130.144}, {341,131.912}, {342,133.135}, {343,133.416}, {344,135.572}, {345,137.975}, {346,139.047}, {347,140.948}, {348,143.963}, {349,144.76}, {350,146.112}, {351,148.743}, {352,149.828}, {353,151.979}, {354,154.355}, {355,155.455}, {356,156.704}, {357,158.811}, {358,161.376}, {359,163.083}, {360,164.996}, {361,167.235}, {362,168.207}, {363,170.159}, {364,172.104}, {365,174.948}, {366,176.663}, {367,179.072}, {368,181.296}, {369,182.492}, {370,185.103}, {371,186.608}, {372,189.003}, {373,192.}, {374,194.019}, {375,195.416}, {376,197.067}, {377,200.28}, {378,202.}, {379,204.015}, {380,204.764}, {381,206.239}, {382,208.015}, {383,211.116}, {384,212.887}, {385,216.648}, {386,218.484}, {387,219.412}, {388,223.307}, {389,224.559}, {390,228.32}, {391,229.951}, {392,231.963}, {393,234.731}, {394,237.992}, {395,241.244}, {396,242.463}, {397,245.032}, {398,247.556}, {399,250.296}, {400,254.768}, {401,255.948}, {402,258.483}, {403,260.188}, {404,263.935}, {405,267.416}, {406,268.82}, {407,271.503}, {408,274.12}, {409,276.031}, {410,281.475}, {411,282.423}, {412,285.144}, {413,287.943}, {414,291.652}, {415,294.655}, {416,299.472}, {417,301.103}, {418,303.551}, {419,306.427}, {420,276.752}, {421,260.828}, {422,263.599}, {423,319.783}, {424,321.1}, {425,324.383}, {426,328.808}, {427,332.423}, {428,334.439}, {429,323.864}, {430,334.727}, {431,336.58}, {432,331.551}, {433,335.672}, {434,338.603}, {435,340.304}, {436,353.312}, {437,353.912}, {438,358.743}, {439,363.204}, {440,364.027}, {441,368.171}, {442,371.452}, {443,375.284}, {444,378.952}, {445,382.628}, {446,387.011}, {447,385.772}, {448,394.531}, {449,399.936}, {450,401.879}, {451,405.016}, {452,409.239}};
data["big"]["TypeClasses"]["Aggregate"]["system"] = {{1,0.000000000}, {2,0.000035556}, {3,0.000053333}, {4,0.000017778}, {5,0.000053333}, {6,0.000017778}, {7,0.000071111}, {8,0.000084444}, {9,0.000035556}, {10,0.000053333}, {11,0.000071111}, {12,0.000017778}, {13,0.000031111}, {14,0.000017778}, {15,0.000035556}, {16,0.000017778}, {17,0.000071111}, {18,0.000053333}, {19,0.000053333}, {20,0.000088889}, {21,0.000066667}, {22,0.000053333}, {23,0.000017778}, {24,0.000017778}, {25,0.000035556}, {26,0.000000000}, {27,0.000124444}, {28,0.000137778}, {29,0.000071111}, {30,0.000071111}, {31,0.000035556}, {32,0.000071111}, {33,0.000071111}, {34,0.000053333}, {35,0.000017778}, {36,0.000106667}, {37,0.000084444}, {38,0.000017778}, {39,0.000031111}, {40,0.000084444}, {41,0.000053333}, {42,0.000137778}, {43,0.000124444}, {44,0.000035556}, {45,0.000102222}, {46,0.000177778}, {47,0.000071111}, {48,0.000071111}, {49,0.000124444}, {50,0.000124444}, {51,0.000053333}, {52,0.000088889}, {53,0.000088889}, {54,0.000066667}, {55,0.000088889}, {56,0.000137778}, {57,0.000088889}, {58,0.000124444}, {59,0.000053333}, {60,0.000053333}, {61,0.000106667}, {62,0.000071111}, {63,0.000124444}, {64,0.000084444}, {65,0.000124444}, {66,0.000160000}, {67,0.000062222}, {68,0.000053333}, {69,0.000088889}, {70,0.000142222}, {71,0.000071111}, {72,0.000155556}, {73,0.000275556}, {74,0.000546667}, {75,0.000413333}, {76,0.000266667}, {77,0.000444444}, {78,0.000640000}, {79,0.000160000}, {80,0.000191111}, {81,0.000102222}, {82,0.000160000}, {83,0.000351111}, {84,0.000391111}, {85,0.000168889}, {86,0.001778}, {87,0.000667}, {88,0.000000}, {89,0.000000}, {90,0.000444}, {91,0.000667}, {92,0.000444}, {93,0.000000}, {94,0.002000}, {95,0.001333}, {96,0.000389}, {97,0.000000}, {98,0.001333}, {99,0.000889}, {100,0.000000}, {101,0.000000}, {102,0.000222}, {103,0.000222}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000222}, {108,0.000000}, {109,0.000222}, {110,0.000889}, {111,0.000833}, {112,0.000889}, {113,0.000889}, {114,0.001111}, {115,0.000889}, {116,0.000889}, {117,0.000667}, {118,0.000444}, {119,0.000000}, {120,0.000222}, {121,0.000222}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000222}, {126,0.000222}, {127,0.000222}, {128,0.000444}, {129,0.000222}, {130,0.000444}, {131,0.000667}, {132,0.000000}, {133,0.000000}, {134,0.000222}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000444}, {139,0.000222}, {140,0.000667}, {141,0.000444}, {142,0.000222}, {143,0.000222}, {144,0.000222}, {145,0.000444}, {146,0.000000}, {147,0.000222}, {148,0.000222}, {149,0.000000}, {150,0.000000}, {151,0.000444}, {152,0.000389}, {153,0.000222}, {154,0.000889}, {155,0.000667}, {156,0.001556}, {157,0.000222}, {158,0.000222}, {159,0.000444}, {160,0.000000}, {161,0.000000}, {162,0.000444}, {163,0.000000}, {164,0.000222}, {165,0.001111}, {166,0.000444}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000222}, {171,0.000000}, {172,0.000444}, {173,0.000222}, {174,0.000444}, {175,0.000444}, {176,0.001556}, {177,0.002389}, {178,0.000667}, {179,0.002222}, {180,0.004222}, {181,0.001111}, {182,0.001111}, {183,0.000444}, {184,0.000444}, {185,0.000889}, {186,0.000444}, {187,0.000222}, {188,0.001111}, {189,0.001111}, {190,0.001111}, {191,0.000889}, {192,0.000889}, {193,0.000889}, {194,0.001722}, {195,0.000667}, {196,0.001500}, {197,0.002889}, {198,0.001500}, {199,0.001944}, {200,0.002222}, {201,0.000833}, {202,0.001333}, {203,0.000444}, {204,0.001778}, {205,0.000889}, {206,0.000889}, {207,0.001111}, {208,0.001111}, {209,0.001556}, {210,0.001111}, {211,0.002000}, {212,0.000667}, {213,0.004389}, {214,0.002167}, {215,0.002444}, {216,0.004222}, {217,0.002444}, {218,0.002167}, {219,0.001778}, {220,0.001333}, {221,0.001111}, {222,0.002000}, {223,0.001333}, {224,0.003111}, {225,0.001778}, {226,0.001778}, {227,0.002889}, {228,0.002000}, {229,0.002444}, {230,0.002889}, {231,0.002333}, {232,0.003056}, {233,0.002889}, {234,0.001722}, {235,0.002667}, {236,0.003500}, {237,0.002833}, {238,0.003778}, {239,0.002000}, {240,0.003333}, {241,0.003611}, {242,0.003056}, {243,0.003556}, {244,0.002889}, {245,0.003333}, {246,0.002889}, {247,0.002000}, {248,0.001333}, {249,0.002000}, {250,0.003222}, {251,0.001778}, {252,0.005556}, {253,0.002000}, {254,0.002000}, {255,0.005111}, {256,0.004222}, {257,0.005500}, {258,0.002889}, {259,0.004778}, {260,0.002667}, {261,0.004000}, {262,0.004222}, {263,0.002000}, {264,0.006611}, {265,0.004611}, {266,0.005333}, {267,0.005944}, {268,0.007722}, {269,0.004167}, {270,0.006167}, {271,0.005944}, {272,0.002833}, {273,0.007778}, {274,0.005556}, {275,0.004833}, {276,0.004667}, {277,0.005333}, {278,0.003722}, {279,0.005889}, {280,0.008111}, {281,0.007333}, {282,0.006389}, {283,0.004444}, {284,0.012000}, {285,0.010889}, {286,0.008667}, {287,0.010667}, {288,0.009667}, {289,0.006889}, {290,0.009500}, {291,0.009556}, {292,0.008778}, {293,0.010000}, {294,0.009833}, {295,0.013056}, {296,0.015222}, {297,0.011500}, {298,0.015389}, {299,0.010444}, {300,0.013944}, {301,0.0870}, {302,0.0000}, {303,0.0520}, {304,0.0120}, {305,0}, {306,0}, {307,0}, {308,0}, {309,0}, {310,0}, {311,0}, {312,0}, {313,0}, {314,0}, {315,0}, {316,0}, {317,0}, {318,0}, {319,0}, {320,0}, {321,0}, {322,0}, {323,0}, {324,0}, {325,0.004}, {326,0}, {327,0}, {328,0}, {329,0}, {330,0}, {331,0}, {332,0}, {333,0}, {334,0}, {335,0}, {336,0}, {337,0}, {338,0}, {339,0}, {340,0}, {341,0}, {342,0}, {343,0}, {344,0.004}, {345,0}, {346,0.004}, {347,0}, {348,0}, {349,0}, {350,0}, {351,0}, {352,0}, {353,0}, {354,0}, {355,0}, {356,0}, {357,0}, {358,0.032}, {359,0}, {360,0}, {361,0}, {362,0}, {363,0}, {364,0}, {365,0}, {366,0}, {367,0}, {368,0}, {369,0}, {370,0}, {371,0}, {372,0}, {373,0}, {374,0}, {375,0}, {376,0}, {377,0}, {378,0}, {379,0}, {380,0}, {381,0}, {382,0}, {383,0}, {384,0}, {385,0}, {386,0}, {387,0}, {388,0}, {389,0}, {390,0}, {391,0}, {392,0}, {393,0}, {394,0}, {395,0}, {396,0}, {397,0}, {398,0}, {399,0}, {400,0}, {401,0}, {402,0}, {403,0}, {404,0}, {405,0}, {406,0}, {407,0}, {408,0.012}, {409,0}, {410,0}, {411,0}, {412,0}, {413,0.004}, {414,0}, {415,0}, {416,0}, {417,0}, {418,0}, {419,0}, {420,0}, {421,0}, {422,0}, {423,0}, {424,0}, {425,0}, {426,0}, {427,0}, {428,0.043}, {429,0.06}, {430,0.052}, {431,0.095}, {432,0.043}, {433,0.02}, {434,0}, {435,0}, {436,0.052}, {437,0.044}, {438,0.031}, {439,0}, {440,0}, {441,0}, {442,0}, {443,0}, {444,0}, {445,0}, {446,0}, {447,0.004}, {448,0.095}, {449,0}, {450,0.052}, {451,0.084}, {452,0.079}};
data["big"]["TypeClasses"]["actual reif"]["real"] = {{1,0.000000000}, {2,0.001000000}, {3,0.002000000}, {4,0.002560000}, {5,0.003542222}, {6,0.004595556}, {7,0.005804444}, {8,0.007106667}, {9,0.008635556}, {10,0.029524444}, {11,0.011822222}, {12,0.013680000}, {13,0.015706667}, {14,0.017960000}, {15,0.020257778}, {16,0.023600000}, {17,0.025680000}, {18,0.028337778}, {19,0.031222222}, {20,0.037142222}, {21,0.037924444}, {22,0.041524444}, {23,0.048311111}, {24,0.049146667}, {25,0.055280000}, {26,0.058222222}, {27,0.065808889}, {28,0.068724444}, {29,0.078688889}, {30,0.078684444}, {31,0.087071111}, {32,0.097288889}, {33,0.100693333}, {34,0.104746667}, {35,0.114693333}, {36,0.125142222}, {37,0.130928889}, {38,0.138853333}, {39,0.147168889}, {40,0.159857778}, {41,0.166880000}, {42,0.171346667}, {43,0.185684444}, {44,0.197151111}, {45,0.204275556}, {46,0.220177778}, {47,0.232422222}, {48,0.242013333}, {49,0.260871111}, {50,0.268120000}, {51,0.275591111}, {52,0.287680000}, {53,0.302977778}, {54,0.319813333}, {55,0.338431111}, {56,0.353248889}, {57,0.372902222}, {58,0.386631111}, {59,0.402293333}, {60,0.422644444}, {61,0.438813333}, {62,0.455755556}, {63,0.477293333}, {64,0.498813333}, {65,0.521808889}, {66,0.540360000}, {67,0.561111111}, {68,0.589040000}, {69,0.603391111}, {70,0.634742222}, {71,0.657115556}, {72,0.681831111}, {73,0.735600000}, {74,0.893835556}, {75,0.877426667}, {76,0.793857778}, {77,0.833217778}, {78,0.909057778}, {79,0.882786667}, {80,0.919453333}, {81,0.940195556}, {82,0.970888889}, {83,1.022657778}, {84,1.070364444}, {85,1.078893333}, {86,1.110889}, {87,1.123056}, {88,1.162944}, {89,1.204556}, {90,1.241722}, {91,1.291111}, {92,1.326000}, {93,1.371111}, {94,1.419444}, {95,1.466889}, {96,1.506778}, {97,1.555000}, {98,1.604833}, {99,1.651000}, {100,1.706389}, {101,1.763667}, {102,1.822333}, {103,1.871056}, {104,1.928444}, {105,1.987444}, {106,2.044278}, {107,2.105389}, {108,2.162944}, {109,2.232333}, {110,2.378944}, {111,2.386500}, {112,2.555000}, {113,2.532389}, {114,2.668000}, {115,2.701389}, {116,2.785611}, {117,2.844556}, {118,2.870222}, {119,2.942556}, {120,3.066333}, {121,3.101500}, {122,3.189944}, {123,3.260500}, {124,3.364556}, {125,3.434722}, {126,3.520500}, {127,3.624667}, {128,3.718000}, {129,3.799389}, {130,3.906389}, {131,4.000722}, {132,4.092944}, {133,4.197111}, {134,4.318389}, {135,4.407833}, {136,4.503611}, {137,4.614333}, {138,4.727333}, {139,4.850000}, {140,4.957833}, {141,5.076389}, {142,5.193167}, {143,5.310833}, {144,5.441167}, {145,5.561722}, {146,5.683889}, {147,5.821167}, {148,5.950278}, {149,6.091722}, {150,6.213722}, {151,6.348667}, {152,6.517167}, {153,6.655444}, {154,6.804333}, {155,6.937444}, {156,7.088778}, {157,7.250500}, {158,7.419278}, {159,7.560389}, {160,7.716333}, {161,7.884556}, {162,8.046389}, {163,8.218056}, {164,8.396722}, {165,8.558278}, {166,8.748444}, {167,8.953111}, {168,9.114111}, {169,9.275944}, {170,9.469056}, {171,9.683333}, {172,9.865833}, {173,10.109500}, {174,10.304333}, {175,10.469167}, {176,10.659056}, {177,10.947333}, {178,11.106889}, {179,11.341667}, {180,11.534556}, {181,11.726167}, {182,11.938889}, {183,12.146944}, {184,12.383222}, {185,12.591444}, {186,12.791778}, {187,13.056333}, {188,13.265167}, {189,13.599278}, {190,13.820056}, {191,14.132389}, {192,14.299167}, {193,14.682222}, {194,14.903000}, {195,15.169889}, {196,15.406444}, {197,15.656500}, {198,15.983556}, {199,16.275389}, {200,16.487111}, {201,16.750222}, {202,17.023889}, {203,17.266944}, {204,17.605778}, {205,17.916556}, {206,18.210333}, {207,18.517722}, {208,18.784667}, {209,19.027333}, {210,19.375111}, {211,19.706167}, {212,19.992333}, {213,20.388111}, {214,20.678833}, {215,20.970278}, {216,21.362333}, {217,21.692278}, {218,21.975722}, {219,22.442333}, {220,22.681722}, {221,23.119333}, {222,23.439611}, {223,23.740611}, {224,24.165722}, {225,24.565722}, {226,24.952556}, {227,25.265889}, {228,25.609944}, {229,26.100889}, {230,26.532167}, {231,26.916389}, {232,27.331778}, {233,27.703722}, {234,28.190611}, {235,28.781333}, {236,29.054500}, {237,29.660222}, {238,30.038222}, {239,30.508889}, {240,30.754389}, {241,31.303389}, {242,31.843500}, {243,32.195389}, {244,32.718667}, {245,33.172333}, {246,33.723167}, {247,34.147389}, {248,34.621333}, {249,35.267444}, {250,35.705611}, {251,36.326056}, {252,36.715889}, {253,37.109778}, {254,37.747000}, {255,38.316778}, {256,38.760667}, {257,39.406667}, {258,39.724722}, {259,40.404444}, {260,40.854222}, {261,41.565944}, {262,42.142944}, {263,42.913111}, {264,43.448333}, {265,44.098556}, {266,44.723444}, {267,45.080444}, {268,45.988722}, {269,46.679333}, {270,47.155611}, {271,47.603833}, {272,48.473056}, {273,48.902722}, {274,49.751833}, {275,50.504944}, {276,51.019611}, {277,51.764111}, {278,52.404333}, {279,53.129944}, {280,54.046167}, {281,54.673889}, {282,55.449278}, {283,56.100444}, {284,57.105278}, {285,57.900000}, {286,58.351222}, {287,59.301000}, {288,59.819333}, {289,60.754333}, {290,61.316278}, {291,62.192833}, {292,62.707056}, {293,64.039167}, {294,64.893444}, {295,65.685611}, {296,66.844944}, {297,67.612611}, {298,68.605667}, {299,69.161167}, {300,70.007333}, {301,78.9155}, {302,78.7450}, {303,77.8915}, {304,78.6325}, {305,81.897}, {306,83.575}, {307,84.897}, {308,86.119}, {309,86.796}, {310,87.623}, {311,88.612}, {312,90.456}, {313,91.353}, {314,93.097}, {315,94.483}, {316,95.228}, {317,96.288}, {318,96.989}, {319,99.135}, {320,100.023}, {321,101.664}, {322,103.543}, {323,104.041}, {324,105.547}, {325,107.022}, {326,108.105}, {327,110.641}, {328,111.376}, {329,112.84}, {330,114.355}, {331,115.209}, {332,117.417}, {333,118.715}, {334,120.49}, {335,121.899}, {336,123.247}, {337,124.347}, {338,126.209}, {339,127.254}, {340,130.138}, {341,131.905}, {342,133.129}, {343,133.408}, {344,135.566}, {345,137.969}, {346,139.046}, {347,140.938}, {348,143.956}, {349,144.753}, {350,146.103}, {351,148.738}, {352,149.819}, {353,151.972}, {354,154.349}, {355,155.45}, {356,156.697}, {357,158.803}, {358,161.399}, {359,163.076}, {360,164.987}, {361,167.232}, {362,168.201}, {363,170.151}, {364,172.098}, {365,174.939}, {366,176.657}, {367,179.064}, {368,181.288}, {369,182.484}, {370,185.098}, {371,186.601}, {372,188.999}, {373,191.992}, {374,194.012}, {375,195.41}, {376,197.058}, {377,200.273}, {378,201.99}, {379,204.008}, {380,204.759}, {381,206.232}, {382,208.009}, {383,211.11}, {384,212.882}, {385,216.64}, {386,218.476}, {387,219.402}, {388,223.3}, {389,224.551}, {390,228.314}, {391,229.945}, {392,231.957}, {393,234.725}, {394,237.984}, {395,241.235}, {396,242.455}, {397,245.027}, {398,247.552}, {399,250.291}, {400,254.76}, {401,255.934}, {402,258.476}, {403,260.183}, {404,263.929}, {405,267.411}, {406,268.812}, {407,271.498}, {408,276.759}, {409,276.081}, {410,281.525}, {411,282.414}, {412,285.133}, {413,287.937}, {414,291.64}, {415,294.658}, {416,299.461}, {417,301.082}, {418,303.541}, {419,306.417}, {420,278.798}, {421,260.817}, {422,263.594}, {423,321.528}, {424,321.09}, {425,324.53}, {426,328.798}, {427,332.409}, {428,334.475}, {429,326.626}, {430,334.768}, {431,336.665}, {432,331.587}, {433,335.683}, {434,338.594}, {435,340.291}, {436,353.353}, {437,353.946}, {438,358.764}, {439,363.19}, {440,364.015}, {441,368.163}, {442,371.444}, {443,375.275}, {444,378.943}, {445,382.612}, {446,386.999}, {447,386.644}, {448,396.623}, {449,399.914}, {450,401.937}, {451,405.212}, {452,409.421}};
data["big"]["TypeClasses"]["actual reif"]["user"] = {{1,0.000866667}, {2,0.001333333}, {3,0.002026667}, {4,0.002924444}, {5,0.003760000}, {6,0.004875556}, {7,0.005888889}, {8,0.007097778}, {9,0.008604444}, {10,0.029408889}, {11,0.012075556}, {12,0.013604444}, {13,0.015604444}, {14,0.017755556}, {15,0.020017778}, {16,0.023875556}, {17,0.025880000}, {18,0.028386667}, {19,0.031373333}, {20,0.037044444}, {21,0.037973333}, {22,0.041342222}, {23,0.048253333}, {24,0.049320000}, {25,0.055391111}, {26,0.058306667}, {27,0.065640000}, {28,0.068773333}, {29,0.078728889}, {30,0.078782222}, {31,0.086911111}, {32,0.096968889}, {33,0.100480000}, {34,0.104813333}, {35,0.114395556}, {36,0.125120000}, {37,0.131040000}, {38,0.138751111}, {39,0.147000000}, {40,0.159564444}, {41,0.166480000}, {42,0.170848889}, {43,0.185160000}, {44,0.196768889}, {45,0.204093333}, {46,0.219644444}, {47,0.232444444}, {48,0.241724444}, {49,0.260515556}, {50,0.267564444}, {51,0.275115556}, {52,0.287471111}, {53,0.302626667}, {54,0.319448889}, {55,0.338226667}, {56,0.352826667}, {57,0.372635556}, {58,0.386444444}, {59,0.401942222}, {60,0.422040000}, {61,0.438373333}, {62,0.455231111}, {63,0.476782222}, {64,0.498466667}, {65,0.521444444}, {66,0.539933333}, {67,0.560800000}, {68,0.588911111}, {69,0.602884444}, {70,0.634288889}, {71,0.656724444}, {72,0.681217778}, {73,0.734662222}, {74,0.892960000}, {75,0.876520000}, {76,0.793222222}, {77,0.832217778}, {78,0.907822222}, {79,0.882173333}, {80,0.918582222}, {81,0.939208889}, {82,0.970271111}, {83,1.021911111}, {84,1.069293333}, {85,1.078026667}, {86,1.107889}, {87,1.121611}, {88,1.162167}, {89,1.203444}, {90,1.239833}, {91,1.289278}, {92,1.324000}, {93,1.370278}, {94,1.416278}, {95,1.464222}, {96,1.505556}, {97,1.553333}, {98,1.602111}, {99,1.648333}, {100,1.705389}, {101,1.762889}, {102,1.820889}, {103,1.869556}, {104,1.926611}, {105,1.985778}, {106,2.042278}, {107,2.103722}, {108,2.161167}, {109,2.231056}, {110,2.376278}, {111,2.384222}, {112,2.553278}, {113,2.529500}, {114,2.664611}, {115,2.698278}, {116,2.782389}, {117,2.841889}, {118,2.867611}, {119,2.940944}, {120,3.064222}, {121,3.098889}, {122,3.188000}, {123,3.258722}, {124,3.363222}, {125,3.433278}, {126,3.518000}, {127,3.622722}, {128,3.715944}, {129,3.796667}, {130,3.903778}, {131,3.998000}, {132,4.090722}, {133,4.194444}, {134,4.315611}, {135,4.404833}, {136,4.501778}, {137,4.612500}, {138,4.725333}, {139,4.847278}, {140,4.953667}, {141,5.074222}, {142,5.189667}, {143,5.308000}, {144,5.437000}, {145,5.557722}, {146,5.681278}, {147,5.818944}, {148,5.948444}, {149,6.091556}, {150,6.213500}, {151,6.347444}, {152,6.516667}, {153,6.655000}, {154,6.802667}, {155,6.936333}, {156,7.086833}, {157,7.249000}, {158,7.419333}, {159,7.559667}, {160,7.715889}, {161,7.884389}, {162,8.045278}, {163,8.215833}, {164,8.393778}, {165,8.554278}, {166,8.748056}, {167,8.952667}, {168,9.113444}, {169,9.276222}, {170,9.468444}, {171,9.681833}, {172,9.863278}, {173,10.106722}, {174,10.300722}, {175,10.465889}, {176,10.653833}, {177,10.940944}, {178,11.100778}, {179,11.334278}, {180,11.526667}, {181,11.720889}, {182,11.933444}, {183,12.141278}, {184,12.377111}, {185,12.584222}, {186,12.785222}, {187,13.050056}, {188,13.257556}, {189,13.593000}, {190,13.814389}, {191,14.126111}, {192,14.292944}, {193,14.676389}, {194,14.895222}, {195,15.163167}, {196,15.398611}, {197,15.647389}, {198,15.974500}, {199,16.261167}, {200,16.472722}, {201,16.738722}, {202,17.008222}, {203,17.251611}, {204,17.590222}, {205,17.902111}, {206,18.199611}, {207,18.507778}, {208,18.773333}, {209,19.015000}, {210,19.364111}, {211,19.694111}, {212,19.982111}, {213,20.374500}, {214,20.665667}, {215,20.958222}, {216,21.351833}, {217,21.683111}, {218,21.965833}, {219,22.432556}, {220,22.672000}, {221,23.104611}, {222,23.423611}, {223,23.723111}, {224,24.146778}, {225,24.547333}, {226,24.935944}, {227,25.247889}, {228,25.593056}, {229,26.083389}, {230,26.512722}, {231,26.895167}, {232,27.317222}, {233,27.691889}, {234,28.179444}, {235,28.769222}, {236,29.043611}, {237,29.654389}, {238,30.031000}, {239,30.503000}, {240,30.748444}, {241,31.296833}, {242,31.836889}, {243,32.188333}, {244,32.711778}, {245,33.165778}, {246,33.717611}, {247,34.145056}, {248,34.620556}, {249,35.265611}, {250,35.701889}, {251,36.320333}, {252,36.702833}, {253,37.099667}, {254,37.735889}, {255,38.299333}, {256,38.744222}, {257,39.388778}, {258,39.710667}, {259,40.390889}, {260,40.841889}, {261,41.540444}, {262,42.116167}, {263,42.888278}, {264,43.413333}, {265,44.065111}, {266,44.689333}, {267,45.045056}, {268,45.950778}, {269,46.644278}, {270,47.118667}, {271,47.577056}, {272,48.448500}, {273,48.874500}, {274,49.724056}, {275,50.478722}, {276,50.993500}, {277,51.741556}, {278,52.391111}, {279,53.114833}, {280,54.038000}, {281,54.666278}, {282,55.443667}, {283,56.096278}, {284,57.086778}, {285,57.875278}, {286,58.329556}, {287,59.274278}, {288,59.789833}, {289,60.721000}, {290,61.276278}, {291,62.148556}, {292,62.663611}, {293,63.994611}, {294,64.858222}, {295,65.652944}, {296,66.823833}, {297,67.595333}, {298,68.584000}, {299,69.147444}, {300,69.981722}, {301,78.7780}, {302,78.2995}, {303,76.9140}, {304,77.8775}, {305,81.896}, {306,83.576}, {307,84.896}, {308,86.115}, {309,86.796}, {310,87.623}, {311,88.611}, {312,90.456}, {313,91.351}, {314,93.096}, {315,94.483}, {316,95.228}, {317,96.288}, {318,96.987}, {319,99.135}, {320,100.024}, {321,101.663}, {322,103.539}, {323,104.04}, {324,105.543}, {325,107.019}, {326,108.103}, {327,110.639}, {328,111.375}, {329,112.84}, {330,114.355}, {331,115.207}, {332,117.415}, {333,118.711}, {334,120.492}, {335,121.896}, {336,123.248}, {337,124.347}, {338,126.208}, {339,127.251}, {340,130.136}, {341,131.903}, {342,133.127}, {343,133.404}, {344,135.56}, {345,137.967}, {346,139.043}, {347,140.935}, {348,143.956}, {349,144.748}, {350,146.1}, {351,148.735}, {352,149.815}, {353,151.967}, {354,154.347}, {355,155.447}, {356,156.692}, {357,158.8}, {358,161.363}, {359,163.076}, {360,164.983}, {361,167.231}, {362,168.199}, {363,170.148}, {364,172.096}, {365,174.936}, {366,176.655}, {367,179.064}, {368,181.288}, {369,182.484}, {370,185.095}, {371,186.599}, {372,188.995}, {373,191.992}, {374,194.011}, {375,195.408}, {376,197.056}, {377,200.272}, {378,201.988}, {379,204.007}, {380,204.76}, {381,206.231}, {382,208.007}, {383,211.108}, {384,212.879}, {385,216.636}, {386,218.472}, {387,219.399}, {388,223.299}, {389,224.547}, {390,228.311}, {391,229.94}, {392,231.956}, {393,234.724}, {394,237.979}, {395,241.231}, {396,242.456}, {397,245.023}, {398,247.548}, {399,250.288}, {400,254.755}, {401,255.927}, {402,258.471}, {403,260.18}, {404,263.927}, {405,267.407}, {406,268.812}, {407,271.495}, {408,274.112}, {409,276.02}, {410,281.459}, {411,282.412}, {412,285.132}, {413,287.932}, {414,291.639}, {415,294.644}, {416,299.459}, {417,301.083}, {418,303.54}, {419,306.416}, {420,276.739}, {421,260.811}, {422,263.587}, {423,319.772}, {424,321.083}, {425,324.371}, {426,328.799}, {427,332.407}, {428,334.432}, {429,323.855}, {430,334.715}, {431,336.567}, {432,331.544}, {433,335.664}, {434,338.596}, {435,340.292}, {436,353.304}, {437,353.903}, {438,358.732}, {439,363.191}, {440,364.015}, {441,368.164}, {442,371.443}, {443,375.276}, {444,378.943}, {445,382.611}, {446,387.}, {447,385.76}, {448,394.52}, {449,399.916}, {450,401.864}, {451,405.}, {452,409.232}};
data["big"]["TypeClasses"]["actual reif"]["system"] = {{1,0.000000000}, {2,0.000035556}, {3,0.000053333}, {4,0.000017778}, {5,0.000053333}, {6,0.000017778}, {7,0.000053333}, {8,0.000071111}, {9,0.000017778}, {10,0.000053333}, {11,0.000053333}, {12,0.000017778}, {13,0.000013333}, {14,0.000000000}, {15,0.000000000}, {16,0.000017778}, {17,0.000053333}, {18,0.000035556}, {19,0.000035556}, {20,0.000071111}, {21,0.000031111}, {22,0.000053333}, {23,0.000017778}, {24,0.000017778}, {25,0.000017778}, {26,0.000000000}, {27,0.000106667}, {28,0.000120000}, {29,0.000053333}, {30,0.000071111}, {31,0.000017778}, {32,0.000053333}, {33,0.000071111}, {34,0.000053333}, {35,0.000017778}, {36,0.000088889}, {37,0.000066667}, {38,0.000017778}, {39,0.000031111}, {40,0.000031111}, {41,0.000053333}, {42,0.000137778}, {43,0.000088889}, {44,0.000035556}, {45,0.000102222}, {46,0.000106667}, {47,0.000035556}, {48,0.000071111}, {49,0.000071111}, {50,0.000124444}, {51,0.000035556}, {52,0.000053333}, {53,0.000071111}, {54,0.000048889}, {55,0.000071111}, {56,0.000102222}, {57,0.000071111}, {58,0.000071111}, {59,0.000035556}, {60,0.000017778}, {61,0.000071111}, {62,0.000053333}, {63,0.000106667}, {64,0.000048889}, {65,0.000088889}, {66,0.000088889}, {67,0.000048889}, {68,0.000053333}, {69,0.000035556}, {70,0.000124444}, {71,0.000017778}, {72,0.000155556}, {73,0.000275556}, {74,0.000475556}, {75,0.000346667}, {76,0.000177778}, {77,0.000408889}, {78,0.000591111}, {79,0.000142222}, {80,0.000173333}, {81,0.000084444}, {82,0.000124444}, {83,0.000315556}, {84,0.000355556}, {85,0.000115556}, {86,0.001778}, {87,0.000667}, {88,0.000000}, {89,0.000000}, {90,0.000444}, {91,0.000444}, {92,0.000444}, {93,0.000000}, {94,0.002000}, {95,0.001333}, {96,0.000389}, {97,0.000000}, {98,0.001111}, {99,0.000889}, {100,0.000000}, {101,0.000000}, {102,0.000222}, {103,0.000222}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000222}, {108,0.000000}, {109,0.000222}, {110,0.000667}, {111,0.000833}, {112,0.000889}, {113,0.000667}, {114,0.000889}, {115,0.000667}, {116,0.000889}, {117,0.000444}, {118,0.000444}, {119,0.000000}, {120,0.000222}, {121,0.000222}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000222}, {127,0.000000}, {128,0.000444}, {129,0.000000}, {130,0.000222}, {131,0.000222}, {132,0.000000}, {133,0.000000}, {134,0.000222}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000444}, {139,0.000000}, {140,0.000444}, {141,0.000444}, {142,0.000222}, {143,0.000222}, {144,0.000222}, {145,0.000444}, {146,0.000000}, {147,0.000222}, {148,0.000222}, {149,0.000000}, {150,0.000000}, {151,0.000222}, {152,0.000167}, {153,0.000222}, {154,0.000889}, {155,0.000667}, {156,0.001333}, {157,0.000222}, {158,0.000222}, {159,0.000444}, {160,0.000000}, {161,0.000000}, {162,0.000222}, {163,0.000000}, {164,0.000222}, {165,0.001111}, {166,0.000444}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000222}, {171,0.000000}, {172,0.000444}, {173,0.000222}, {174,0.000444}, {175,0.000444}, {176,0.001333}, {177,0.002167}, {178,0.000667}, {179,0.002222}, {180,0.004222}, {181,0.001111}, {182,0.001111}, {183,0.000444}, {184,0.000444}, {185,0.000667}, {186,0.000222}, {187,0.000222}, {188,0.001111}, {189,0.000889}, {190,0.001111}, {191,0.000667}, {192,0.000889}, {193,0.000889}, {194,0.001500}, {195,0.000667}, {196,0.001500}, {197,0.002889}, {198,0.001278}, {199,0.001722}, {200,0.002222}, {201,0.000833}, {202,0.001333}, {203,0.000444}, {204,0.001778}, {205,0.000889}, {206,0.000889}, {207,0.001111}, {208,0.001111}, {209,0.001556}, {210,0.001111}, {211,0.002000}, {212,0.000667}, {213,0.004167}, {214,0.002167}, {215,0.002444}, {216,0.004222}, {217,0.002444}, {218,0.002167}, {219,0.001556}, {220,0.001333}, {221,0.001111}, {222,0.001778}, {223,0.001111}, {224,0.003111}, {225,0.001778}, {226,0.001778}, {227,0.002889}, {228,0.002000}, {229,0.002222}, {230,0.002889}, {231,0.002111}, {232,0.003056}, {233,0.002889}, {234,0.001722}, {235,0.002667}, {236,0.003278}, {237,0.002833}, {238,0.003778}, {239,0.002000}, {240,0.003333}, {241,0.003611}, {242,0.003056}, {243,0.003556}, {244,0.002889}, {245,0.003333}, {246,0.002889}, {247,0.002000}, {248,0.001333}, {249,0.002000}, {250,0.003000}, {251,0.001778}, {252,0.005333}, {253,0.002000}, {254,0.002000}, {255,0.005111}, {256,0.004000}, {257,0.005500}, {258,0.002889}, {259,0.004556}, {260,0.002667}, {261,0.004000}, {262,0.004222}, {263,0.002000}, {264,0.006611}, {265,0.004389}, {266,0.005111}, {267,0.005944}, {268,0.007722}, {269,0.004167}, {270,0.006167}, {271,0.005944}, {272,0.002611}, {273,0.007556}, {274,0.005556}, {275,0.004611}, {276,0.004667}, {277,0.005333}, {278,0.003722}, {279,0.005889}, {280,0.008111}, {281,0.007333}, {282,0.006389}, {283,0.004444}, {284,0.011778}, {285,0.010667}, {286,0.008667}, {287,0.010667}, {288,0.009667}, {289,0.006889}, {290,0.009500}, {291,0.009556}, {292,0.008778}, {293,0.010000}, {294,0.009611}, {295,0.013056}, {296,0.015000}, {297,0.011500}, {298,0.015389}, {299,0.010222}, {300,0.013944}, {301,0.0870}, {302,0.0000}, {303,0.0520}, {304,0.0120}, {305,0}, {306,0}, {307,0}, {308,0}, {309,0}, {310,0}, {311,0}, {312,0}, {313,0}, {314,0}, {315,0}, {316,0}, {317,0}, {318,0}, {319,0}, {320,0}, {321,0}, {322,0}, {323,0}, {324,0}, {325,0}, {326,0}, {327,0}, {328,0}, {329,0}, {330,0}, {331,0}, {332,0}, {333,0}, {334,0}, {335,0}, {336,0}, {337,0}, {338,0}, {339,0}, {340,0}, {341,0}, {342,0}, {343,0}, {344,0.004}, {345,0}, {346,0.004}, {347,0}, {348,0}, {349,0}, {350,0}, {351,0}, {352,0}, {353,0}, {354,0}, {355,0}, {356,0}, {357,0}, {358,0.032}, {359,0}, {360,0}, {361,0}, {362,0}, {363,0}, {364,0}, {365,0}, {366,0}, {367,0}, {368,0}, {369,0}, {370,0}, {371,0}, {372,0}, {373,0}, {374,0}, {375,0}, {376,0}, {377,0}, {378,0}, {379,0}, {380,0}, {381,0}, {382,0}, {383,0}, {384,0}, {385,0}, {386,0}, {387,0}, {388,0}, {389,0}, {390,0}, {391,0}, {392,0}, {393,0}, {394,0}, {395,0}, {396,0}, {397,0}, {398,0}, {399,0}, {400,0}, {401,0}, {402,0}, {403,0}, {404,0}, {405,0}, {406,0}, {407,0}, {408,0.008}, {409,0}, {410,0}, {411,0}, {412,0}, {413,0.004}, {414,0}, {415,0}, {416,0}, {417,0}, {418,0}, {419,0}, {420,0}, {421,0}, {422,0}, {423,0}, {424,0}, {425,0}, {426,0}, {427,0}, {428,0.043}, {429,0.06}, {430,0.052}, {431,0.095}, {432,0.043}, {433,0.02}, {434,0}, {435,0}, {436,0.048}, {437,0.044}, {438,0.031}, {439,0}, {440,0}, {441,0}, {442,0}, {443,0}, {444,0}, {445,0}, {446,0}, {447,0.004}, {448,0.095}, {449,0}, {450,0.052}, {451,0.084}, {452,0.079}};
data["big"]["TypeClasses"]["cbv"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000}, {87,0.000000}, {88,0.000000}, {89,0.000000}, {90,0.000000}, {91,0.000000}, {92,0.000000}, {93,0.000000}, {94,0.000000}, {95,0.000000}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.004889}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.005111}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000611}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.004444}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000000}, {237,0.000000}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000000}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.005333}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000000}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.001500}, {300,0.000000}, {301,0.0000}, {302,0.0000}, {303,0.0000}, {304,0.0000}, {305,0.0000}, {306,0}, {307,0}, {308,0}, {309,0}, {310,0}, {311,0}, {312,0}, {313,0}, {314,0}, {315,0}, {316,0}, {317,0}, {318,0}, {319,0}, {320,0}, {321,0}, {322,0}, {323,0}, {324,0}, {325,0}, {326,0}, {327,0}, {328,0}, {329,0}, {330,0}, {331,0}, {332,0}, {333,0}, {334,0}, {335,0}, {336,0}, {337,0}, {338,0}, {339,0}, {340,0}, {341,0}, {342,0}, {343,0}, {344,0}, {345,0}, {346,0}, {347,0}, {348,0}, {349,0}, {350,0}, {351,0}, {352,0}, {353,0}, {354,0}, {355,0}, {356,0}, {357,0}, {358,0}, {359,0}, {360,0}, {361,0}, {362,0}, {363,0}, {364,0}, {365,0}, {366,0}, {367,0}, {368,0}, {369,0}, {370,0}, {371,0}, {372,0}, {373,0}, {374,0}, {375,0}, {376,0}, {377,0}, {378,0}, {379,0}, {380,0}, {381,0}, {382,0}, {383,0}, {384,0}, {385,0}, {386,0}, {387,0}, {388,0}, {389,0}, {390,0}, {391,0}, {392,0}, {393,0}, {394,0}, {395,0}, {396,0}, {397,0}, {398,0}, {399,0}, {400,0}, {401,0.007}, {402,0}, {403,0}, {404,0}, {405,0}, {406,0}, {407,0}, {408,0}, {409,0}, {410,0}, {411,0}, {412,0}, {413,0}, {414,0}, {415,0}, {416,0}, {417,0}, {418,0}, {419,0}, {420,0}, {421,0}, {422,0}, {423,0}, {424,0}, {425,0}, {426,0}, {427,0}, {428,0}, {429,0}, {430,0}, {431,0}, {432,0}, {433,0}, {434,0}, {435,0}, {436,0}, {437,0}, {438,0}, {439,0}, {440,0}, {441,0}, {442,0}, {443,0}, {444,0}, {445,0}, {446,0}, {447,0}, {448,0}, {449,0}, {450,0}, {451,0}, {452,0}, {453,0}};
data["big"]["TypeClasses"]["cbv"]["user"] = {{1,0.000000000}, {2,0.000017778}, {3,0.000035556}, {4,0.000017778}, {5,0.000000000}, {6,0.000048889}, {7,0.000062222}, {8,0.000088889}, {9,0.000031111}, {10,0.000017778}, {11,0.000000000}, {12,0.000080000}, {13,0.000031111}, {14,0.000062222}, {15,0.000066667}, {16,0.000071111}, {17,0.000035556}, {18,0.000071111}, {19,0.000053333}, {20,0.000035556}, {21,0.000031111}, {22,0.000071111}, {23,0.000066667}, {24,0.000097778}, {25,0.000151111}, {26,0.000120000}, {27,0.000115556}, {28,0.000071111}, {29,0.000066667}, {30,0.000048889}, {31,0.000080000}, {32,0.000088889}, {33,0.000133333}, {34,0.000115556}, {35,0.000062222}, {36,0.000048889}, {37,0.000062222}, {38,0.000106667}, {39,0.000177778}, {40,0.000088889}, {41,0.000142222}, {42,0.000151111}, {43,0.000102222}, {44,0.000151111}, {45,0.000168889}, {46,0.000071111}, {47,0.000053333}, {48,0.000164444}, {49,0.000066667}, {50,0.000080000}, {51,0.000048889}, {52,0.000013333}, {53,0.000195556}, {54,0.000084444}, {55,0.000111111}, {56,0.000093333}, {57,0.000097778}, {58,0.000097778}, {59,0.000066667}, {60,0.000186667}, {61,0.000120000}, {62,0.000128889}, {63,0.000084444}, {64,0.000062222}, {65,0.000146667}, {66,0.000164444}, {67,0.000097778}, {68,0.000155556}, {69,0.000200000}, {70,0.000053333}, {71,0.000097778}, {72,0.000226667}, {73,0.000155556}, {74,0.000062222}, {75,0.000222222}, {76,0.000124444}, {77,0.000195556}, {78,0.000168889}, {79,0.000204444}, {80,0.000097778}, {81,0.000173333}, {82,0.000120000}, {83,0.000137778}, {84,0.000160000}, {85,0.000115556}, {86,0.000000}, {87,0.000000}, {88,0.000167}, {89,0.000333}, {90,0.000222}, {91,0.000000}, {92,0.000333}, {93,0.000000}, {94,0.000000}, {95,0.000222}, {96,0.000000}, {97,0.000000}, {98,0.000222}, {99,0.000167}, {100,0.000000}, {101,0.000000}, {102,0.000389}, {103,0.000167}, {104,0.000222}, {105,0.000000}, {106,0.000167}, {107,0.000167}, {108,0.000167}, {109,0.000222}, {110,0.000167}, {111,0.000222}, {112,0.000167}, {113,0.000389}, {114,0.000000}, {115,0.000167}, {116,0.000222}, {117,0.000000}, {118,0.000000}, {119,0.000222}, {120,0.000222}, {121,0.000333}, {122,0.000000}, {123,0.000167}, {124,0.000167}, {125,0.000222}, {126,0.000167}, {127,0.000167}, {128,0.000000}, {129,0.000167}, {130,0.000778}, {131,0.000000}, {132,0.000000}, {133,0.000444}, {134,0.000389}, {135,0.000222}, {136,0.000000}, {137,0.000333}, {138,0.000000}, {139,0.000389}, {140,0.000556}, {141,0.000167}, {142,0.000500}, {143,0.000000}, {144,0.000333}, {145,0.000500}, {146,0.000333}, {147,0.000000}, {148,0.000167}, {149,0.000000}, {150,0.000333}, {151,0.000167}, {152,0.000333}, {153,0.000000}, {154,0.000167}, {155,0.000167}, {156,0.000167}, {157,0.000389}, {158,0.000222}, {159,0.000333}, {160,0.000167}, {161,0.000167}, {162,0.000556}, {163,0.000000}, {164,0.000222}, {165,0.000167}, {166,0.000333}, {167,0.004222}, {168,0.000000}, {169,0.000167}, {170,0.000167}, {171,0.000167}, {172,0.000222}, {173,0.000000}, {174,0.000722}, {175,0.000333}, {176,0.000500}, {177,0.000167}, {178,0.000611}, {179,0.000778}, {180,0.000444}, {181,0.000000}, {182,0.000000}, {183,0.000333}, {184,0.000556}, {185,0.000333}, {186,0.000333}, {187,0.000444}, {188,0.000000}, {189,0.000500}, {190,0.000000}, {191,0.004944}, {192,0.000222}, {193,0.000167}, {194,0.000389}, {195,0.000333}, {196,0.000167}, {197,0.000556}, {198,0.000944}, {199,0.000167}, {200,0.000000}, {201,0.000556}, {202,0.000333}, {203,0.000000}, {204,0.000333}, {205,0.000000}, {206,0.000167}, {207,0.000000}, {208,0.000000}, {209,0.000611}, {210,0.000500}, {211,0.000167}, {212,0.000333}, {213,0.000333}, {214,0.000167}, {215,0.000167}, {216,0.000000}, {217,0.000167}, {218,0.000167}, {219,0.000500}, {220,0.000000}, {221,0.000167}, {222,0.000167}, {223,0.001056}, {224,0.000000}, {225,0.000000}, {226,0.000389}, {227,0.000500}, {228,0.000500}, {229,0.000333}, {230,0.004167}, {231,0.000222}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000500}, {236,0.000333}, {237,0.000000}, {238,0.000333}, {239,0.000167}, {240,0.000389}, {241,0.000000}, {242,0.000889}, {243,0.000500}, {244,0.000000}, {245,0.000389}, {246,0.000167}, {247,0.000167}, {248,0.000000}, {249,0.000333}, {250,0.000167}, {251,0.000167}, {252,0.000333}, {253,0.000000}, {254,0.000167}, {255,0.000556}, {256,0.000000}, {257,0.000556}, {258,0.000556}, {259,0.000556}, {260,0.000556}, {261,0.000500}, {262,0.000333}, {263,0.000167}, {264,0.000000}, {265,0.000722}, {266,0.000167}, {267,0.000167}, {268,0.000833}, {269,0.000500}, {270,0.000333}, {271,0.000167}, {272,0.000000}, {273,0.000333}, {274,0.000000}, {275,0.000167}, {276,0.000333}, {277,0.000167}, {278,0.000389}, {279,0.000333}, {280,0.000389}, {281,0.000889}, {282,0.000333}, {283,0.000167}, {284,0.000333}, {285,0.000556}, {286,0.000389}, {287,0.000389}, {288,0.000167}, {289,0.000167}, {290,0.005222}, {291,0.000500}, {292,0.000667}, {293,0.000500}, {294,0.000333}, {295,0.000389}, {296,0.000389}, {297,0.000333}, {298,0.000500}, {299,0.002389}, {300,0.000000}, {301,0.0000}, {302,0.0000}, {303,0.0000}, {304,0.0000}, {305,0.0000}, {306,0}, {307,0}, {308,0}, {309,0}, {310,0}, {311,0}, {312,0}, {313,0}, {314,0}, {315,0}, {316,0}, {317,0}, {318,0.004}, {319,0}, {320,0}, {321,0}, {322,0}, {323,0.003}, {324,0}, {325,0}, {326,0}, {327,0}, {328,0}, {329,0}, {330,0}, {331,0}, {332,0}, {333,0.003}, {334,0}, {335,0}, {336,0}, {337,0}, {338,0}, {339,0}, {340,0.003}, {341,0}, {342,0}, {343,0}, {344,0}, {345,0}, {346,0}, {347,0}, {348,0}, {349,0.003}, {350,0}, {351,0}, {352,0}, {353,0}, {354,0}, {355,0}, {356,0.003}, {357,0}, {358,0}, {359,0}, {360,0}, {361,0}, {362,0}, {363,0}, {364,0}, {365,0}, {366,0.003}, {367,0}, {368,0}, {369,0}, {370,0}, {371,0.004}, {372,0}, {373,0}, {374,0}, {375,0}, {376,0.003}, {377,0}, {378,0.003}, {379,0}, {380,0}, {381,0}, {382,0}, {383,0}, {384,0}, {385,0}, {386,0}, {387,0}, {388,0}, {389,0}, {390,0}, {391,0}, {392,0}, {393,0}, {394,0.004}, {395,0.004}, {396,0}, {397,0}, {398,0}, {399,0}, {400,0}, {401,0.007}, {402,0}, {403,0}, {404,0}, {405,0}, {406,0}, {407,0}, {408,0.004}, {409,0}, {410,0}, {411,0.004}, {412,0}, {413,0.004}, {414,0}, {415,0}, {416,0}, {417,0}, {418,0.004}, {419,0.004}, {420,0}, {421,0}, {422,0}, {423,0}, {424,0.004}, {425,0}, {426,0}, {427,0}, {428,0}, {429,0}, {430,0}, {431,0}, {432,0}, {433,0}, {434,0}, {435,0.004}, {436,0}, {437,0}, {438,0}, {439,0}, {440,0}, {441,0}, {442,0}, {443,0}, {444,0}, {445,0}, {446,0}, {447,0}, {448,0}, {449,0}, {450,0}, {451,0}, {452,0}, {453,0}};
data["big"]["TypeClasses"]["cbv"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000017778}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000017778}, {61,0.000000000}, {62,0.000017778}, {63,0.000017778}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000017778}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000017778}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000017778}, {83,0.000000000}, {84,0.000017778}, {85,0.000000000}, {86,0.000000}, {87,0.000000}, {88,0.000000}, {89,0.000000}, {90,0.000000}, {91,0.000000}, {92,0.000000}, {93,0.000000}, {94,0.000000}, {95,0.000000}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000222}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000000}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000000}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000000}, {237,0.000000}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000222}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000000}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000000}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.0000}, {302,0.0000}, {303,0.0000}, {304,0.0000}, {305,0.0000}, {306,0}, {307,0}, {308,0}, {309,0}, {310,0}, {311,0}, {312,0}, {313,0}, {314,0}, {315,0}, {316,0}, {317,0}, {318,0}, {319,0}, {320,0}, {321,0}, {322,0}, {323,0}, {324,0}, {325,0.004}, {326,0}, {327,0}, {328,0}, {329,0}, {330,0}, {331,0}, {332,0}, {333,0}, {334,0}, {335,0}, {336,0}, {337,0}, {338,0}, {339,0}, {340,0}, {341,0}, {342,0}, {343,0}, {344,0}, {345,0}, {346,0}, {347,0}, {348,0}, {349,0}, {350,0}, {351,0}, {352,0}, {353,0}, {354,0}, {355,0}, {356,0}, {357,0}, {358,0}, {359,0}, {360,0}, {361,0}, {362,0}, {363,0}, {364,0}, {365,0}, {366,0}, {367,0}, {368,0}, {369,0}, {370,0}, {371,0}, {372,0}, {373,0}, {374,0}, {375,0}, {376,0}, {377,0}, {378,0}, {379,0}, {380,0}, {381,0}, {382,0}, {383,0}, {384,0}, {385,0}, {386,0}, {387,0}, {388,0}, {389,0}, {390,0}, {391,0}, {392,0}, {393,0}, {394,0}, {395,0}, {396,0}, {397,0}, {398,0}, {399,0}, {400,0}, {401,0}, {402,0}, {403,0}, {404,0}, {405,0}, {406,0}, {407,0}, {408,0}, {409,0}, {410,0}, {411,0}, {412,0}, {413,0}, {414,0}, {415,0}, {416,0}, {417,0}, {418,0}, {419,0}, {420,0}, {421,0}, {422,0}, {423,0}, {424,0}, {425,0}, {426,0}, {427,0}, {428,0}, {429,0}, {430,0}, {431,0}, {432,0}, {433,0}, {434,0}, {435,0}, {436,0}, {437,0}, {438,0}, {439,0}, {440,0}, {441,0}, {442,0}, {443,0}, {444,0}, {445,0}, {446,0}, {447,0}, {448,0}, {449,0}, {450,0}, {451,0}, {452,0}, {453,0}};
data["big"]["TypeClasses"]["eval lazy"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000}, {87,0.000000}, {88,0.000000}, {89,0.000000}, {90,0.000000}, {91,0.000000}, {92,0.000000}, {93,0.000000}, {94,0.000000}, {95,0.000000}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000167}, {186,0.000056}, {187,0.000056}, {188,0.000111}, {189,0.000111}, {190,0.000056}, {191,0.000056}, {192,0.000056}, {193,0.000056}, {194,0.000111}, {195,0.000111}, {196,0.000111}, {197,0.000111}, {198,0.000111}, {199,0.000222}, {200,0.000222}, {201,0.000333}, {202,0.000333}, {203,0.000333}, {204,0.000444}, {205,0.000444}, {206,0.001000}, {207,0.001000}, {208,0.001000}, {209,0.001000}, {210,0.001000}, {211,0.001000}, {212,0.001000}, {213,0.001000}, {214,0.001000}, {215,0.001000}, {216,0.001000}, {217,0.001000}, {218,0.001000}, {219,0.001000}, {220,0.001000}, {221,0.001000}, {222,0.001000}, {223,0.001000}, {224,0.001000}, {225,0.001000}, {226,0.001000}, {227,0.001000}, {228,0.001000}, {229,0.001000}, {230,0.001000}, {231,0.001000}, {232,0.001000}, {233,0.001000}, {234,0.001000}, {235,0.001000}, {236,0.001000}, {237,0.001000}, {238,0.001000}, {239,0.001000}, {240,0.001000}, {241,0.001000}, {242,0.001000}, {243,0.001000}, {244,0.001000}, {245,0.001000}, {246,0.001000}, {247,0.001000}, {248,0.001000}, {249,0.001000}, {250,0.001000}, {251,0.001000}, {252,0.001000}, {253,0.001000}, {254,0.001000}, {255,0.001000}, {256,0.001000}, {257,0.001000}, {258,0.001000}, {259,0.001000}, {260,0.001000}, {261,0.001000}, {262,0.001000}, {263,0.001056}, {264,0.001056}, {265,0.001111}, {266,0.001111}, {267,0.001111}, {268,0.001333}, {269,0.007556}, {270,0.001556}, {271,0.001500}, {272,0.001444}, {273,0.001667}, {274,0.001611}, {275,0.001667}, {276,0.001556}, {277,0.001556}, {278,0.001944}, {279,0.001500}, {280,0.001944}, {281,0.001667}, {282,0.001944}, {283,0.001889}, {284,0.001833}, {285,0.002000}, {286,0.001944}, {287,0.001944}, {288,0.002000}, {289,0.002000}, {290,0.002000}, {291,0.002000}, {292,0.002000}, {293,0.002000}, {294,0.002000}, {295,0.002000}, {296,0.002000}, {297,0.002000}, {298,0.002000}, {299,0.002000}, {300,0.002000}, {301,0.0020}, {302,0.0020}, {303,0.0020}, {304,0.0020}, {305,0.002}, {306,0.002}, {307,0.002}, {308,0.002}, {309,0.002}, {310,0.002}, {311,0.002}, {312,0.002}, {313,0.002}, {314,0.002}, {315,0.002}, {316,0.002}, {317,0.002}, {318,0.002}, {319,0.002}, {320,0.002}, {321,0.002}, {322,0.002}, {323,0.002}, {324,0.002}, {325,0.002}, {326,0.002}, {327,0.002}, {328,0.002}, {329,0.002}, {330,0.002}, {331,0.002}, {332,0.002}, {333,0.003}, {334,0.002}, {335,0.003}, {336,0.003}, {337,0.002}, {338,0.003}, {339,0.002}, {340,0.002}, {341,0.003}, {342,0.003}, {343,0.003}, {344,0.003}, {345,0.003}, {346,0.003}, {347,0.003}, {348,0.003}, {349,0.003}, {350,0.003}, {351,0.003}, {352,0.003}, {353,0.003}, {354,0.003}, {355,0.003}, {356,0.003}, {357,0.003}, {358,0.003}, {359,0.003}, {360,0.003}, {361,0.003}, {362,0.003}, {363,0.003}, {364,0.003}, {365,0.003}, {366,0.003}, {367,0.003}, {368,0.003}, {369,0.003}, {370,0.003}, {371,0.003}, {372,0.003}, {373,0.003}, {374,0.003}, {375,0.003}, {376,0.003}, {377,0.003}, {378,0.003}, {379,0.003}, {380,0.003}, {381,0.003}, {382,0.003}, {383,0.003}, {384,0.003}, {385,0.003}, {386,0.004}, {387,0.003}, {388,0.003}, {389,0.003}, {390,0.003}, {391,0.003}, {392,0.004}, {393,0.003}, {394,0.004}, {395,0.004}, {396,0.004}, {397,0.003}, {398,0.004}, {399,0.004}, {400,0.004}, {401,0.004}, {402,0.004}, {403,0.004}, {404,0.004}, {405,0.004}, {406,0.004}, {407,0.004}, {408,0.004}, {409,0.004}, {410,0.004}, {411,0.004}, {412,0.004}, {413,0.004}, {414,0.004}, {415,0.004}, {416,0.004}, {417,0.004}, {418,0.004}, {419,0.004}, {420,0.004}, {421,0.005}, {422,0.005}, {423,0.004}, {424,0.004}, {425,0.004}, {426,0.004}, {427,0.004}, {428,0.004}, {429,0.004}, {430,0.004}, {431,0.004}, {432,0.005}, {433,0.005}, {434,0.004}, {435,0.005}, {436,0.004}, {437,0.004}, {438,0.005}, {439,0.005}, {440,0.005}, {441,0.004}, {442,0.004}, {443,0.005}, {444,0.005}, {445,0.005}, {446,0.005}, {447,0.005}, {448,0.005}, {449,0.006}, {450,0.005}, {451,0.005}, {452,0.005}};
data["big"]["TypeClasses"]["eval lazy"]["user"] = {{1,0.000053333}, {2,0.000031111}, {3,0.000048889}, {4,0.000084444}, {5,0.000048889}, {6,0.000013333}, {7,0.000062222}, {8,0.000044444}, {9,0.000017778}, {10,0.000017778}, {11,0.000053333}, {12,0.000084444}, {13,0.000035556}, {14,0.000031111}, {15,0.000053333}, {16,0.000080000}, {17,0.000035556}, {18,0.000062222}, {19,0.000151111}, {20,0.000080000}, {21,0.000048889}, {22,0.000102222}, {23,0.000031111}, {24,0.000013333}, {25,0.000168889}, {26,0.000048889}, {27,0.000120000}, {28,0.000124444}, {29,0.000084444}, {30,0.000088889}, {31,0.000057778}, {32,0.000133333}, {33,0.000048889}, {34,0.000062222}, {35,0.000155556}, {36,0.000066667}, {37,0.000048889}, {38,0.000111111}, {39,0.000120000}, {40,0.000115556}, {41,0.000111111}, {42,0.000124444}, {43,0.000137778}, {44,0.000097778}, {45,0.000084444}, {46,0.000097778}, {47,0.000062222}, {48,0.000097778}, {49,0.000133333}, {50,0.000111111}, {51,0.000204444}, {52,0.000151111}, {53,0.000088889}, {54,0.000177778}, {55,0.000115556}, {56,0.000120000}, {57,0.000035556}, {58,0.000168889}, {59,0.000124444}, {60,0.000133333}, {61,0.000102222}, {62,0.000253333}, {63,0.000186667}, {64,0.000120000}, {65,0.000115556}, {66,0.000182222}, {67,0.000151111}, {68,0.000124444}, {69,0.000173333}, {70,0.000142222}, {71,0.000164444}, {72,0.000160000}, {73,0.000271111}, {74,0.000177778}, {75,0.000253333}, {76,0.000124444}, {77,0.000168889}, {78,0.000191111}, {79,0.000222222}, {80,0.000213333}, {81,0.000182222}, {82,0.000128889}, {83,0.000164444}, {84,0.000173333}, {85,0.000102222}, {86,0.000667}, {87,0.000333}, {88,0.000389}, {89,0.000222}, {90,0.000167}, {91,0.000167}, {92,0.000167}, {93,0.000389}, {94,0.000000}, {95,0.000333}, {96,0.000167}, {97,0.000222}, {98,0.000222}, {99,0.000389}, {100,0.000556}, {101,0.000167}, {102,0.000167}, {103,0.000389}, {104,0.000389}, {105,0.000389}, {106,0.000000}, {107,0.000167}, {108,0.000333}, {109,0.000500}, {110,0.000000}, {111,0.000000}, {112,0.000167}, {113,0.000389}, {114,0.000000}, {115,0.000000}, {116,0.000500}, {117,0.000222}, {118,0.000167}, {119,0.000167}, {120,0.000556}, {121,0.000333}, {122,0.000222}, {123,0.000167}, {124,0.000222}, {125,0.000167}, {126,0.000167}, {127,0.000000}, {128,0.000167}, {129,0.000500}, {130,0.000389}, {131,0.000333}, {132,0.000389}, {133,0.000222}, {134,0.000000}, {135,0.000611}, {136,0.000389}, {137,0.000000}, {138,0.000389}, {139,0.000167}, {140,0.000333}, {141,0.000000}, {142,0.000333}, {143,0.000000}, {144,0.000222}, {145,0.000500}, {146,0.000167}, {147,0.000500}, {148,0.000944}, {149,0.000556}, {150,0.000389}, {151,0.000167}, {152,0.001000}, {153,0.000167}, {154,0.000167}, {155,0.000389}, {156,0.000167}, {157,0.000944}, {158,0.000389}, {159,0.000722}, {160,0.000722}, {161,0.000333}, {162,0.001111}, {163,0.000389}, {164,0.000556}, {165,0.001167}, {166,0.000167}, {167,0.000500}, {168,0.000333}, {169,0.000167}, {170,0.000778}, {171,0.000167}, {172,0.000333}, {173,0.000222}, {174,0.000167}, {175,0.000500}, {176,0.000389}, {177,0.000000}, {178,0.001111}, {179,0.000333}, {180,0.000222}, {181,0.000222}, {182,0.000389}, {183,0.000889}, {184,0.000611}, {185,0.000778}, {186,0.001056}, {187,0.000667}, {188,0.000778}, {189,0.000222}, {190,0.000889}, {191,0.000667}, {192,0.001056}, {193,0.000333}, {194,0.000833}, {195,0.000889}, {196,0.000500}, {197,0.000833}, {198,0.000556}, {199,0.000167}, {200,0.001111}, {201,0.001000}, {202,0.000667}, {203,0.001111}, {204,0.000778}, {205,0.000833}, {206,0.000667}, {207,0.000667}, {208,0.000833}, {209,0.001111}, {210,0.001444}, {211,0.001056}, {212,0.000889}, {213,0.000667}, {214,0.001111}, {215,0.001000}, {216,0.000778}, {217,0.001111}, {218,0.000833}, {219,0.001222}, {220,0.000778}, {221,0.001000}, {222,0.001389}, {223,0.000333}, {224,0.000333}, {225,0.001611}, {226,0.000667}, {227,0.000889}, {228,0.001056}, {229,0.001056}, {230,0.001167}, {231,0.000944}, {232,0.001111}, {233,0.001611}, {234,0.001444}, {235,0.001000}, {236,0.001167}, {237,0.001722}, {238,0.002111}, {239,0.000722}, {240,0.000889}, {241,0.001278}, {242,0.001000}, {243,0.000667}, {244,0.001500}, {245,0.001167}, {246,0.000667}, {247,0.001556}, {248,0.000667}, {249,0.001500}, {250,0.001667}, {251,0.001222}, {252,0.000833}, {253,0.001667}, {254,0.001389}, {255,0.001000}, {256,0.001167}, {257,0.001167}, {258,0.000722}, {259,0.001278}, {260,0.001722}, {261,0.001611}, {262,0.000833}, {263,0.001278}, {264,0.001389}, {265,0.000889}, {266,0.001222}, {267,0.000889}, {268,0.000833}, {269,0.007389}, {270,0.001000}, {271,0.001833}, {272,0.001389}, {273,0.001889}, {274,0.001500}, {275,0.001056}, {276,0.001500}, {277,0.001056}, {278,0.001333}, {279,0.001500}, {280,0.001333}, {281,0.001167}, {282,0.001333}, {283,0.001333}, {284,0.001667}, {285,0.001833}, {286,0.002167}, {287,0.001889}, {288,0.002444}, {289,0.001889}, {290,0.001611}, {291,0.002500}, {292,0.001833}, {293,0.001611}, {294,0.001333}, {295,0.001556}, {296,0.001056}, {297,0.001611}, {298,0.001500}, {299,0.002111}, {300,0.002111}, {301,0.0020}, {302,0.0040}, {303,0.0035}, {304,0.0035}, {305,0.003}, {306,0}, {307,0}, {308,0.004}, {309,0.004}, {310,0.004}, {311,0.004}, {312,0}, {313,0.004}, {314,0.004}, {315,0.004}, {316,0}, {317,0}, {318,0}, {319,0}, {320,0.003}, {321,0}, {322,0.003}, {323,0}, {324,0.004}, {325,0.003}, {326,0.004}, {327,0.003}, {328,0.003}, {329,0.003}, {330,0.003}, {331,0.004}, {332,0.004}, {333,0.003}, {334,0}, {335,0.003}, {336,0.004}, {337,0}, {338,0.003}, {339,0.003}, {340,0.003}, {341,0.003}, {342,0}, {343,0.003}, {344,0.003}, {345,0.003}, {346,0}, {347,0.003}, {348,0.003}, {349,0.003}, {350,0.003}, {351,0}, {352,0.004}, {353,0.003}, {354,0.003}, {355,0.003}, {356,0.004}, {357,0.003}, {358,0.003}, {359,0.003}, {360,0.004}, {361,0.003}, {362,0.003}, {363,0.003}, {364,0.003}, {365,0.003}, {366,0.003}, {367,0.003}, {368,0.003}, {369,0.003}, {370,0.004}, {371,0.004}, {372,0.004}, {373,0.003}, {374,0.004}, {375,0.003}, {376,0.004}, {377,0.003}, {378,0.003}, {379,0.004}, {380,0.004}, {381,0.004}, {382,0.004}, {383,0.004}, {384,0.004}, {385,0.003}, {386,0.003}, {387,0.004}, {388,0.004}, {389,0.004}, {390,0.004}, {391,0.003}, {392,0.004}, {393,0.004}, {394,0.004}, {395,0.004}, {396,0.004}, {397,0.004}, {398,0.003}, {399,0.004}, {400,0.004}, {401,0.003}, {402,0.007}, {403,0.004}, {404,0.004}, {405,0.008}, {406,0.004}, {407,0.004}, {408,0}, {409,0.004}, {410,0.004}, {411,0.004}, {412,0.004}, {413,0.004}, {414,0.004}, {415,0.003}, {416,0.004}, {417,0.004}, {418,0.003}, {419,0.003}, {420,0.004}, {421,0.008}, {422,0.004}, {423,0.003}, {424,0.004}, {425,0.007}, {426,0.004}, {427,0.007}, {428,0.004}, {429,0.004}, {430,0.004}, {431,0.004}, {432,0.004}, {433,0.004}, {434,0.004}, {435,0.004}, {436,0.004}, {437,0.004}, {438,0.004}, {439,0.004}, {440,0.004}, {441,0.003}, {442,0.004}, {443,0.004}, {444,0.004}, {445,0.004}, {446,0.007}, {447,0.007}, {448,0.003}, {449,0.003}, {450,0.008}, {451,0.008}, {452,0.003}};
data["big"]["TypeClasses"]["eval lazy"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000017778}, {75,0.000017778}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000}, {87,0.000000}, {88,0.000000}, {89,0.000000}, {90,0.000000}, {91,0.000000}, {92,0.000000}, {93,0.000000}, {94,0.000000}, {95,0.000000}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000222}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000000}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000000}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000000}, {237,0.000000}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000222}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000222}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000222}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000000}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000222}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.0000}, {302,0.0000}, {303,0.0000}, {304,0.0000}, {305,0}, {306,0}, {307,0}, {308,0}, {309,0}, {310,0}, {311,0}, {312,0}, {313,0}, {314,0}, {315,0}, {316,0}, {317,0}, {318,0}, {319,0}, {320,0}, {321,0}, {322,0}, {323,0}, {324,0}, {325,0}, {326,0}, {327,0}, {328,0}, {329,0}, {330,0}, {331,0}, {332,0}, {333,0}, {334,0}, {335,0}, {336,0}, {337,0}, {338,0}, {339,0}, {340,0}, {341,0}, {342,0}, {343,0}, {344,0}, {345,0}, {346,0}, {347,0}, {348,0}, {349,0}, {350,0}, {351,0}, {352,0}, {353,0}, {354,0}, {355,0}, {356,0}, {357,0}, {358,0}, {359,0}, {360,0}, {361,0}, {362,0}, {363,0}, {364,0}, {365,0}, {366,0}, {367,0}, {368,0}, {369,0}, {370,0}, {371,0}, {372,0}, {373,0}, {374,0}, {375,0}, {376,0}, {377,0}, {378,0}, {379,0}, {380,0}, {381,0}, {382,0}, {383,0}, {384,0}, {385,0}, {386,0}, {387,0}, {388,0}, {389,0}, {390,0}, {391,0}, {392,0}, {393,0}, {394,0}, {395,0}, {396,0}, {397,0}, {398,0}, {399,0}, {400,0}, {401,0}, {402,0}, {403,0}, {404,0}, {405,0}, {406,0}, {407,0}, {408,0.004}, {409,0}, {410,0}, {411,0}, {412,0}, {413,0}, {414,0}, {415,0}, {416,0}, {417,0}, {418,0}, {419,0}, {420,0}, {421,0}, {422,0}, {423,0}, {424,0}, {425,0}, {426,0}, {427,0}, {428,0}, {429,0}, {430,0}, {431,0}, {432,0}, {433,0}, {434,0}, {435,0}, {436,0}, {437,0}, {438,0}, {439,0}, {440,0}, {441,0}, {442,0}, {443,0}, {444,0}, {445,0}, {446,0}, {447,0}, {448,0}, {449,0}, {450,0}, {451,0}, {452,0}};
data["big"]["TypeClasses"]["lazy beta iota"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000}, {87,0.000000}, {88,0.000000}, {89,0.000000}, {90,0.000000}, {91,0.000000}, {92,0.000000}, {93,0.000000}, {94,0.000000}, {95,0.000000}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000000}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000000}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000000}, {237,0.000000}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000000}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000000}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.0000}, {302,0.0000}, {303,0.0000}, {304,0.0000}, {305,0}, {306,0}, {307,0}, {308,0}, {309,0}, {310,0}, {311,0}, {312,0}, {313,0}, {314,0}, {315,0}, {316,0}, {317,0}, {318,0}, {319,0.007}, {320,0}, {321,0}, {322,0}, {323,0}, {324,0}, {325,0}, {326,0}, {327,0}, {328,0}, {329,0}, {330,0}, {331,0}, {332,0}, {333,0}, {334,0}, {335,0}, {336,0}, {337,0}, {338,0}, {339,0}, {340,0}, {341,0}, {342,0}, {343,0}, {344,0}, {345,0}, {346,0}, {347,0}, {348,0}, {349,0}, {350,0}, {351,0}, {352,0}, {353,0}, {354,0}, {355,0}, {356,0}, {357,0}, {358,0}, {359,0}, {360,0}, {361,0}, {362,0}, {363,0}, {364,0}, {365,0}, {366,0}, {367,0}, {368,0}, {369,0}, {370,0}, {371,0}, {372,0}, {373,0}, {374,0}, {375,0}, {376,0}, {377,0}, {378,0}, {379,0}, {380,0}, {381,0}, {382,0}, {383,0}, {384,0}, {385,0}, {386,0}, {387,0}, {388,0}, {389,0}, {390,0}, {391,0}, {392,0}, {393,0}, {394,0}, {395,0}, {396,0}, {397,0}, {398,0}, {399,0}, {400,0}, {401,0}, {402,0}, {403,0}, {404,0}, {405,0}, {406,0}, {407,0}, {408,0}, {409,0}, {410,0}, {411,0}, {412,0}, {413,0}, {414,0}, {415,0}, {416,0}, {417,0}, {418,0}, {419,0}, {420,0}, {421,0}, {422,0}, {423,0}, {424,0}, {425,0}, {426,0}, {427,0}, {428,0}, {429,0}, {430,0}, {431,0}, {432,0}, {433,0}, {434,0}, {435,0}, {436,0}, {437,0}, {438,0}, {439,0}, {440,0}, {441,0}, {442,0}, {443,0}, {444,0}, {445,0}, {446,0}, {447,0}, {448,0}, {449,0.008}, {450,0}, {451,0}, {452,0}};
data["big"]["TypeClasses"]["lazy beta iota"]["user"] = {{1,0.000000000}, {2,0.000031111}, {3,0.000044444}, {4,0.000013333}, {5,0.000017778}, {6,0.000000000}, {7,0.000000000}, {8,0.000035556}, {9,0.000048889}, {10,0.000031111}, {11,0.000084444}, {12,0.000017778}, {13,0.000026667}, {14,0.000000000}, {15,0.000035556}, {16,0.000013333}, {17,0.000017778}, {18,0.000048889}, {19,0.000000000}, {20,0.000035556}, {21,0.000080000}, {22,0.000093333}, {23,0.000013333}, {24,0.000031111}, {25,0.000017778}, {26,0.000102222}, {27,0.000066667}, {28,0.000031111}, {29,0.000035556}, {30,0.000053333}, {31,0.000053333}, {32,0.000017778}, {33,0.000053333}, {34,0.000088889}, {35,0.000035556}, {36,0.000031111}, {37,0.000088889}, {38,0.000000000}, {39,0.000084444}, {40,0.000097778}, {41,0.000088889}, {42,0.000057778}, {43,0.000071111}, {44,0.000066667}, {45,0.000035556}, {46,0.000035556}, {47,0.000048889}, {48,0.000071111}, {49,0.000071111}, {50,0.000071111}, {51,0.000102222}, {52,0.000013333}, {53,0.000048889}, {54,0.000071111}, {55,0.000106667}, {56,0.000053333}, {57,0.000053333}, {58,0.000071111}, {59,0.000088889}, {60,0.000035556}, {61,0.000031111}, {62,0.000115556}, {63,0.000066667}, {64,0.000035556}, {65,0.000031111}, {66,0.000048889}, {67,0.000102222}, {68,0.000031111}, {69,0.000062222}, {70,0.000084444}, {71,0.000066667}, {72,0.000071111}, {73,0.000102222}, {74,0.000071111}, {75,0.000048889}, {76,0.000048889}, {77,0.000088889}, {78,0.000168889}, {79,0.000075556}, {80,0.000035556}, {81,0.000084444}, {82,0.000044444}, {83,0.000128889}, {84,0.000048889}, {85,0.000071111}, {86,0.000000}, {87,0.000000}, {88,0.000000}, {89,0.000000}, {90,0.000389}, {91,0.000222}, {92,0.000167}, {93,0.000000}, {94,0.000222}, {95,0.000000}, {96,0.000000}, {97,0.000333}, {98,0.000167}, {99,0.000000}, {100,0.000167}, {101,0.000000}, {102,0.000167}, {103,0.000000}, {104,0.000167}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000222}, {110,0.000444}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000222}, {115,0.000167}, {116,0.000167}, {117,0.000167}, {118,0.000000}, {119,0.000000}, {120,0.000167}, {121,0.000000}, {122,0.000000}, {123,0.000167}, {124,0.000000}, {125,0.000389}, {126,0.000000}, {127,0.000167}, {128,0.000000}, {129,0.000000}, {130,0.000222}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000167}, {135,0.000389}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000222}, {142,0.000222}, {143,0.000000}, {144,0.000333}, {145,0.000167}, {146,0.000222}, {147,0.000000}, {148,0.000000}, {149,0.000167}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000167}, {154,0.000222}, {155,0.000000}, {156,0.000000}, {157,0.000167}, {158,0.000167}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000167}, {163,0.000167}, {164,0.000000}, {165,0.000000}, {166,0.000167}, {167,0.000389}, {168,0.000389}, {169,0.000000}, {170,0.000000}, {171,0.000167}, {172,0.000000}, {173,0.000167}, {174,0.000000}, {175,0.000167}, {176,0.000222}, {177,0.000167}, {178,0.000000}, {179,0.000333}, {180,0.000389}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000167}, {186,0.000167}, {187,0.000000}, {188,0.000222}, {189,0.000556}, {190,0.000167}, {191,0.000000}, {192,0.000167}, {193,0.000167}, {194,0.000000}, {195,0.000000}, {196,0.000167}, {197,0.000000}, {198,0.000000}, {199,0.000500}, {200,0.000222}, {201,0.000000}, {202,0.000167}, {203,0.000167}, {204,0.000000}, {205,0.000000}, {206,0.000167}, {207,0.000000}, {208,0.000333}, {209,0.000222}, {210,0.000000}, {211,0.000167}, {212,0.000556}, {213,0.000167}, {214,0.000333}, {215,0.000167}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000167}, {220,0.000167}, {221,0.000333}, {222,0.000000}, {223,0.000167}, {224,0.000167}, {225,0.000000}, {226,0.000333}, {227,0.000556}, {228,0.000000}, {229,0.000222}, {230,0.000333}, {231,0.000333}, {232,0.000444}, {233,0.000000}, {234,0.000000}, {235,0.000389}, {236,0.000000}, {237,0.000000}, {238,0.000000}, {239,0.000389}, {240,0.000000}, {241,0.000167}, {242,0.000167}, {243,0.000389}, {244,0.000167}, {245,0.000333}, {246,0.000167}, {247,0.000000}, {248,0.000000}, {249,0.000167}, {250,0.000000}, {251,0.000389}, {252,0.000167}, {253,0.000000}, {254,0.000000}, {255,0.000167}, {256,0.000000}, {257,0.000500}, {258,0.000722}, {259,0.000722}, {260,0.000167}, {261,0.000167}, {262,0.000167}, {263,0.000167}, {264,0.000333}, {265,0.000000}, {266,0.000333}, {267,0.000000}, {268,0.000389}, {269,0.000000}, {270,0.000333}, {271,0.000167}, {272,0.000167}, {273,0.000000}, {274,0.000500}, {275,0.000167}, {276,0.000167}, {277,0.000556}, {278,0.000000}, {279,0.000000}, {280,0.000611}, {281,0.000167}, {282,0.000389}, {283,0.000167}, {284,0.000500}, {285,0.000167}, {286,0.000000}, {287,0.000333}, {288,0.000000}, {289,0.000500}, {290,0.000500}, {291,0.000000}, {292,0.000000}, {293,0.000167}, {294,0.000000}, {295,0.000167}, {296,0.000000}, {297,0.000000}, {298,0.000167}, {299,0.000333}, {300,0.000389}, {301,0.0015}, {302,0.0000}, {303,0.0000}, {304,0.0000}, {305,0}, {306,0.003}, {307,0}, {308,0}, {309,0}, {310,0}, {311,0}, {312,0.003}, {313,0}, {314,0}, {315,0}, {316,0}, {317,0}, {318,0}, {319,0.008}, {320,0}, {321,0.003}, {322,0}, {323,0.003}, {324,0}, {325,0}, {326,0}, {327,0}, {328,0}, {329,0}, {330,0}, {331,0}, {332,0}, {333,0}, {334,0}, {335,0}, {336,0}, {337,0.003}, {338,0}, {339,0}, {340,0}, {341,0}, {342,0}, {343,0}, {344,0}, {345,0}, {346,0}, {347,0}, {348,0}, {349,0}, {350,0}, {351,0}, {352,0}, {353,0}, {354,0}, {355,0}, {356,0}, {357,0}, {358,0}, {359,0}, {360,0}, {361,0}, {362,0}, {363,0}, {364,0}, {365,0}, {366,0}, {367,0}, {368,0}, {369,0}, {370,0}, {371,0}, {372,0}, {373,0}, {374,0}, {375,0}, {376,0}, {377,0}, {378,0}, {379,0}, {380,0}, {381,0}, {382,0}, {383,0.003}, {384,0}, {385,0}, {386,0}, {387,0}, {388,0}, {389,0}, {390,0}, {391,0}, {392,0}, {393,0}, {394,0}, {395,0}, {396,0}, {397,0.004}, {398,0}, {399,0}, {400,0}, {401,0.004}, {402,0}, {403,0.003}, {404,0}, {405,0}, {406,0}, {407,0}, {408,0}, {409,0}, {410,0}, {411,0}, {412,0}, {413,0}, {414,0}, {415,0}, {416,0}, {417,0}, {418,0}, {419,0}, {420,0}, {421,0}, {422,0}, {423,0}, {424,0}, {425,0}, {426,0}, {427,0}, {428,0.003}, {429,0}, {430,0}, {431,0}, {432,0}, {433,0.004}, {434,0}, {435,0}, {436,0}, {437,0}, {438,0}, {439,0}, {440,0}, {441,0}, {442,0.004}, {443,0}, {444,0}, {445,0}, {446,0}, {447,0}, {448,0}, {449,0.008}, {450,0}, {451,0}, {452,0}};
data["big"]["TypeClasses"]["lazy beta iota"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000017778}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000017778}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000017778}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000}, {87,0.000000}, {88,0.000000}, {89,0.000000}, {90,0.000000}, {91,0.000000}, {92,0.000000}, {93,0.000000}, {94,0.000000}, {95,0.000000}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000222}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000000}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000000}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000000}, {237,0.000000}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000000}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000000}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.0000}, {302,0.0000}, {303,0.0000}, {304,0.0000}, {305,0}, {306,0}, {307,0}, {308,0}, {309,0}, {310,0}, {311,0}, {312,0}, {313,0}, {314,0}, {315,0}, {316,0}, {317,0}, {318,0}, {319,0}, {320,0}, {321,0}, {322,0}, {323,0}, {324,0}, {325,0}, {326,0}, {327,0}, {328,0}, {329,0}, {330,0}, {331,0}, {332,0}, {333,0}, {334,0}, {335,0}, {336,0}, {337,0}, {338,0}, {339,0}, {340,0}, {341,0}, {342,0}, {343,0}, {344,0}, {345,0}, {346,0}, {347,0}, {348,0}, {349,0}, {350,0}, {351,0}, {352,0}, {353,0}, {354,0}, {355,0}, {356,0}, {357,0}, {358,0}, {359,0}, {360,0}, {361,0}, {362,0}, {363,0}, {364,0}, {365,0}, {366,0}, {367,0}, {368,0}, {369,0}, {370,0}, {371,0}, {372,0}, {373,0}, {374,0}, {375,0}, {376,0}, {377,0}, {378,0}, {379,0}, {380,0}, {381,0}, {382,0}, {383,0}, {384,0}, {385,0}, {386,0}, {387,0}, {388,0}, {389,0}, {390,0}, {391,0}, {392,0}, {393,0}, {394,0}, {395,0}, {396,0}, {397,0}, {398,0}, {399,0}, {400,0}, {401,0}, {402,0}, {403,0}, {404,0}, {405,0}, {406,0}, {407,0}, {408,0}, {409,0}, {410,0}, {411,0}, {412,0}, {413,0}, {414,0}, {415,0}, {416,0}, {417,0}, {418,0}, {419,0}, {420,0}, {421,0}, {422,0}, {423,0}, {424,0}, {425,0}, {426,0}, {427,0}, {428,0}, {429,0}, {430,0}, {431,0}, {432,0}, {433,0}, {434,0}, {435,0}, {436,0}, {437,0}, {438,0}, {439,0}, {440,0}, {441,0}, {442,0}, {443,0}, {444,0}, {445,0}, {446,0}, {447,0}, {448,0}, {449,0}, {450,0}, {451,0}, {452,0}};
data["big"]["TypeClasses"]["norm reif"]["real"] = {{1,0.000022222}, {2,0.001000000}, {3,0.002004444}, {4,0.002684444}, {5,0.003617778}, {6,0.004662222}, {7,0.006031111}, {8,0.007164444}, {9,0.008724444}, {10,0.029675556}, {11,0.011871111}, {12,0.013688889}, {13,0.015786667}, {14,0.018111111}, {15,0.020355556}, {16,0.023746667}, {17,0.025808889}, {18,0.028524444}, {19,0.031377778}, {20,0.037253333}, {21,0.038080000}, {22,0.041675556}, {23,0.048475556}, {24,0.049311111}, {25,0.055457778}, {26,0.058368889}, {27,0.065991111}, {28,0.068884444}, {29,0.078880000}, {30,0.078933333}, {31,0.087257778}, {32,0.097546667}, {33,0.100862222}, {34,0.104960000}, {35,0.114942222}, {36,0.125391111}, {37,0.131133333}, {38,0.139097778}, {39,0.147444444}, {40,0.160111111}, {41,0.167075556}, {42,0.171586667}, {43,0.185840000}, {44,0.197373333}, {45,0.204577778}, {46,0.220408889}, {47,0.232657778}, {48,0.242208889}, {49,0.261133333}, {50,0.268391111}, {51,0.275773333}, {52,0.287902222}, {53,0.303257778}, {54,0.320062222}, {55,0.338653333}, {56,0.353560000}, {57,0.373160000}, {58,0.386848889}, {59,0.402591111}, {60,0.422866667}, {61,0.439084444}, {62,0.455995556}, {63,0.477515556}, {64,0.499137778}, {65,0.522088889}, {66,0.540666667}, {67,0.561355556}, {68,0.589337778}, {69,0.603684444}, {70,0.635084444}, {71,0.657395556}, {72,0.682168889}, {73,0.735937778}, {74,0.894151111}, {75,0.877773333}, {76,0.794222222}, {77,0.833524444}, {78,0.909408889}, {79,0.883151111}, {80,0.919800000}, {81,0.940515556}, {82,0.971293333}, {83,1.023026667}, {84,1.070680000}, {85,1.079213333}, {86,1.111389}, {87,1.123389}, {88,1.163278}, {89,1.204833}, {90,1.242278}, {91,1.291667}, {92,1.326333}, {93,1.371389}, {94,1.419833}, {95,1.467389}, {96,1.507167}, {97,1.555500}, {98,1.605389}, {99,1.651389}, {100,1.706778}, {101,1.764278}, {102,1.822889}, {103,1.871722}, {104,1.928722}, {105,1.988111}, {106,2.044722}, {107,2.105944}, {108,2.163278}, {109,2.232889}, {110,2.379389}, {111,2.387111}, {112,2.555556}, {113,2.533056}, {114,2.668444}, {115,2.701944}, {116,2.786111}, {117,2.845056}, {118,2.870778}, {119,2.942889}, {120,3.066444}, {121,3.101889}, {122,3.190333}, {123,3.261056}, {124,3.365278}, {125,3.435167}, {126,3.520722}, {127,3.624833}, {128,3.718556}, {129,3.799944}, {130,3.907000}, {131,4.001278}, {132,4.093444}, {133,4.197667}, {134,4.319000}, {135,4.408278}, {136,4.504222}, {137,4.614889}, {138,4.727778}, {139,4.850722}, {140,4.958278}, {141,5.077056}, {142,5.193833}, {143,5.311500}, {144,5.441833}, {145,5.562722}, {146,5.684778}, {147,5.821833}, {148,5.950833}, {149,6.092333}, {150,6.214389}, {151,6.349222}, {152,6.517778}, {153,6.656167}, {154,6.804833}, {155,6.938167}, {156,7.089500}, {157,7.251278}, {158,7.419889}, {159,7.561056}, {160,7.717111}, {161,7.885333}, {162,8.047111}, {163,8.218944}, {164,8.397500}, {165,8.559167}, {166,8.749167}, {167,8.953778}, {168,9.114778}, {169,9.276667}, {170,9.469889}, {171,9.684222}, {172,9.866667}, {173,10.110167}, {174,10.305000}, {175,10.469944}, {176,10.660000}, {177,10.948056}, {178,11.107889}, {179,11.342667}, {180,11.535611}, {181,11.727167}, {182,11.939833}, {183,12.147889}, {184,12.384222}, {185,12.592444}, {186,12.792833}, {187,13.057333}, {188,13.266111}, {189,13.600278}, {190,13.821000}, {191,14.133333}, {192,14.300167}, {193,14.683278}, {194,14.904056}, {195,15.170833}, {196,15.407556}, {197,15.657611}, {198,15.984667}, {199,16.276444}, {200,16.488167}, {201,16.751444}, {202,17.025000}, {203,17.268167}, {204,17.606944}, {205,17.917722}, {206,18.211444}, {207,18.519056}, {208,18.785889}, {209,19.028556}, {210,19.376389}, {211,19.707444}, {212,19.993611}, {213,20.389556}, {214,20.680222}, {215,20.971611}, {216,21.363778}, {217,21.693667}, {218,21.977111}, {219,22.443611}, {220,22.683056}, {221,23.120889}, {222,23.440944}, {223,23.742056}, {224,24.167111}, {225,24.567167}, {226,24.953944}, {227,25.267500}, {228,25.611444}, {229,26.102278}, {230,26.533556}, {231,26.918000}, {232,27.333389}, {233,27.705444}, {234,28.192111}, {235,28.782778}, {236,29.055833}, {237,29.661889}, {238,30.039722}, {239,30.510556}, {240,30.755889}, {241,31.305111}, {242,31.845167}, {243,32.196778}, {244,32.720222}, {245,33.173944}, {246,33.724944}, {247,34.149111}, {248,34.622889}, {249,35.269278}, {250,35.707500}, {251,36.327833}, {252,36.717722}, {253,37.111500}, {254,37.748833}, {255,38.318667}, {256,38.762444}, {257,39.408500}, {258,39.726611}, {259,40.406389}, {260,40.856222}, {261,41.567944}, {262,42.144833}, {263,42.915111}, {264,43.450333}, {265,44.100500}, {266,44.725500}, {267,45.082389}, {268,45.990778}, {269,46.687611}, {270,47.157667}, {271,47.605944}, {272,48.475222}, {273,48.904833}, {274,49.754000}, {275,50.507111}, {276,51.021611}, {277,51.766222}, {278,52.406778}, {279,53.132167}, {280,54.048389}, {281,54.676000}, {282,55.451722}, {283,56.102556}, {284,57.107444}, {285,57.902556}, {286,58.353389}, {287,59.303278}, {288,59.821778}, {289,60.756833}, {290,61.318556}, {291,62.195333}, {292,62.709556}, {293,64.041611}, {294,64.895722}, {295,65.688056}, {296,66.847444}, {297,67.615000}, {298,68.608000}, {299,69.163500}, {300,70.009889}, {301,78.9175}, {302,78.7475}, {303,77.8940}, {304,78.6350}, {305,81.9}, {306,83.577}, {307,84.899}, {308,86.121}, {309,86.799}, {310,87.626}, {311,88.615}, {312,90.459}, {313,91.356}, {314,93.1}, {315,94.486}, {316,95.23}, {317,96.291}, {318,96.992}, {319,99.138}, {320,100.025}, {321,101.667}, {322,103.546}, {323,104.044}, {324,105.55}, {325,107.025}, {326,108.107}, {327,110.644}, {328,111.379}, {329,112.843}, {330,114.358}, {331,115.212}, {332,117.42}, {333,118.718}, {334,120.493}, {335,121.902}, {336,123.25}, {337,124.35}, {338,126.212}, {339,127.257}, {340,130.141}, {341,131.909}, {342,133.132}, {343,133.411}, {344,135.569}, {345,137.972}, {346,139.049}, {347,140.942}, {348,143.96}, {349,144.756}, {350,146.106}, {351,148.741}, {352,149.823}, {353,151.975}, {354,154.352}, {355,155.453}, {356,156.7}, {357,158.807}, {358,161.402}, {359,163.079}, {360,164.99}, {361,167.235}, {362,168.205}, {363,170.155}, {364,172.102}, {365,174.943}, {366,176.661}, {367,179.068}, {368,181.292}, {369,182.488}, {370,185.101}, {371,186.605}, {372,189.003}, {373,191.996}, {374,194.016}, {375,195.413}, {376,197.062}, {377,200.277}, {378,201.994}, {379,204.012}, {380,204.763}, {381,206.236}, {382,208.013}, {383,211.115}, {384,212.886}, {385,216.644}, {386,218.48}, {387,219.406}, {388,223.304}, {389,224.555}, {390,228.318}, {391,229.949}, {392,231.961}, {393,234.729}, {394,237.988}, {395,241.239}, {396,242.459}, {397,245.031}, {398,247.556}, {399,250.296}, {400,254.764}, {401,255.938}, {402,258.481}, {403,260.187}, {404,263.933}, {405,267.415}, {406,268.817}, {407,271.503}, {408,276.763}, {409,276.085}, {410,281.53}, {411,282.418}, {412,285.137}, {413,287.942}, {414,291.645}, {415,294.662}, {416,299.465}, {417,301.087}, {418,303.546}, {419,306.422}, {420,278.803}, {421,260.822}, {422,263.599}, {423,321.533}, {424,321.095}, {425,324.534}, {426,328.803}, {427,332.415}, {428,334.48}, {429,326.631}, {430,334.772}, {431,336.67}, {432,331.592}, {433,335.689}, {434,338.598}, {435,340.297}, {436,353.358}, {437,353.951}, {438,358.77}, {439,363.195}, {440,364.021}, {441,368.168}, {442,371.449}, {443,375.28}, {444,378.948}, {445,382.618}, {446,387.005}, {447,386.65}, {448,396.628}, {449,399.92}, {450,401.942}, {451,405.217}, {452,409.427}};
data["big"]["TypeClasses"]["norm reif"]["user"] = {{1,0.000991111}, {2,0.001417778}, {3,0.002133333}, {4,0.003044444}, {5,0.003875556}, {6,0.004942222}, {7,0.006040000}, {8,0.007266667}, {9,0.008662222}, {10,0.029480000}, {11,0.012208889}, {12,0.013804444}, {13,0.015715556}, {14,0.017853333}, {15,0.020133333}, {16,0.024088889}, {17,0.026022222}, {18,0.028471111}, {19,0.031626667}, {20,0.037266667}, {21,0.038084444}, {22,0.041488889}, {23,0.048404444}, {24,0.049377778}, {25,0.055657778}, {26,0.058404444}, {27,0.065840000}, {28,0.069017778}, {29,0.078880000}, {30,0.078991111}, {31,0.087035556}, {32,0.097248889}, {33,0.100573333}, {34,0.104955556}, {35,0.114608889}, {36,0.125275556}, {37,0.131275556}, {38,0.138946667}, {39,0.147177778}, {40,0.159782222}, {41,0.166675556}, {42,0.171040000}, {43,0.185404444}, {44,0.197017778}, {45,0.204328889}, {46,0.219786667}, {47,0.232537778}, {48,0.241893333}, {49,0.260804444}, {50,0.267697778}, {51,0.275368889}, {52,0.287786667}, {53,0.302773333}, {54,0.319733333}, {55,0.338524444}, {56,0.353026667}, {57,0.372768889}, {58,0.386688889}, {59,0.402177778}, {60,0.422280000}, {61,0.438484444}, {62,0.455657778}, {63,0.477013333}, {64,0.498715556}, {65,0.521666667}, {66,0.540213333}, {67,0.561040000}, {68,0.589151111}, {69,0.603173333}, {70,0.634591111}, {71,0.657022222}, {72,0.681466667}, {73,0.735062222}, {74,0.893222222}, {75,0.876862222}, {76,0.793471111}, {77,0.832600000}, {78,0.908137778}, {79,0.882515556}, {80,0.918884444}, {81,0.939546667}, {82,0.970488889}, {83,1.022124444}, {84,1.069604444}, {85,1.078257778}, {86,1.108889}, {87,1.122000}, {88,1.162611}, {89,1.204000}, {90,1.240000}, {91,1.289500}, {92,1.324556}, {93,1.370944}, {94,1.416444}, {95,1.464556}, {96,1.506222}, {97,1.553611}, {98,1.602389}, {99,1.648778}, {100,1.706056}, {101,1.763278}, {102,1.821111}, {103,1.870278}, {104,1.927111}, {105,1.986222}, {106,2.042278}, {107,2.103944}, {108,2.162000}, {109,2.231611}, {110,2.376278}, {111,2.384889}, {112,2.553500}, {113,2.530000}, {114,2.664611}, {115,2.698500}, {116,2.783056}, {117,2.842333}, {118,2.867833}, {119,2.941389}, {120,3.064889}, {121,3.099222}, {122,3.188278}, {123,3.259167}, {124,3.363722}, {125,3.433500}, {126,3.519000}, {127,3.622722}, {128,3.716167}, {129,3.797278}, {130,3.904278}, {131,3.998667}, {132,4.091167}, {133,4.194722}, {134,4.315611}, {135,4.405611}, {136,4.502222}, {137,4.612722}, {138,4.725833}, {139,4.847722}, {140,4.954111}, {141,5.074222}, {142,5.190333}, {143,5.308167}, {144,5.437222}, {145,5.558556}, {146,5.681500}, {147,5.819556}, {148,5.950000}, {149,6.092278}, {150,6.214000}, {151,6.348500}, {152,6.517944}, {153,6.655222}, {154,6.803056}, {155,6.936778}, {156,7.087056}, {157,7.250333}, {158,7.419778}, {159,7.560889}, {160,7.717000}, {161,7.884833}, {162,8.046778}, {163,8.216333}, {164,8.394611}, {165,8.555722}, {166,8.748278}, {167,8.953444}, {168,9.114333}, {169,9.276667}, {170,9.469778}, {171,9.682444}, {172,9.863722}, {173,10.107000}, {174,10.300889}, {175,10.466444}, {176,10.654333}, {177,10.941167}, {178,11.102167}, {179,11.334833}, {180,11.526944}, {181,11.721611}, {182,11.933944}, {183,12.142333}, {184,12.377889}, {185,12.585167}, {186,12.786611}, {187,13.050944}, {188,13.258556}, {189,13.593278}, {190,13.815778}, {191,14.126944}, {192,14.294278}, {193,14.677000}, {194,14.896722}, {195,15.164556}, {196,15.399667}, {197,15.648611}, {198,15.975222}, {199,16.261389}, {200,16.474111}, {201,16.740056}, {202,17.009056}, {203,17.253000}, {204,17.592000}, {205,17.903167}, {206,18.200722}, {207,18.508667}, {208,18.774333}, {209,19.016444}, {210,19.366167}, {211,19.695500}, {212,19.983278}, {213,20.375389}, {214,20.667278}, {215,20.959444}, {216,21.353056}, {217,21.684667}, {218,21.967111}, {219,22.434056}, {220,22.673000}, {221,23.105833}, {222,23.425667}, {223,23.723667}, {224,24.147167}, {225,24.549389}, {226,24.936722}, {227,25.249389}, {228,25.594389}, {229,26.084667}, {230,26.514278}, {231,26.896389}, {232,27.318667}, {233,27.694000}, {234,28.181278}, {235,28.770944}, {236,29.045056}, {237,29.656444}, {238,30.033667}, {239,30.504333}, {240,30.750000}, {241,31.298444}, {242,31.838056}, {243,32.189389}, {244,32.713889}, {245,33.167222}, {246,33.718500}, {247,34.147000}, {248,34.621333}, {249,35.267389}, {250,35.704167}, {251,36.321889}, {252,36.703833}, {253,37.101833}, {254,37.737889}, {255,38.300889}, {256,38.746222}, {257,39.390500}, {258,39.711722}, {259,40.392722}, {260,40.844111}, {261,41.542722}, {262,42.117111}, {263,42.889944}, {264,43.415056}, {265,44.066667}, {266,44.690944}, {267,45.046611}, {268,45.951889}, {269,46.652889}, {270,47.120000}, {271,47.579389}, {272,48.450278}, {273,48.876944}, {274,49.726444}, {275,50.480111}, {276,50.995444}, {277,51.742944}, {278,52.392833}, {279,53.117056}, {280,54.039833}, {281,54.667944}, {282,55.445389}, {283,56.098222}, {284,57.089167}, {285,57.877722}, {286,58.332222}, {287,59.276722}, {288,59.793000}, {289,60.723611}, {290,61.278278}, {291,62.151778}, {292,62.666111}, {293,63.997167}, {294,64.860000}, {295,65.655111}, {296,66.825444}, {297,67.597333}, {298,68.586444}, {299,69.150222}, {300,69.984389}, {301,78.7800}, {302,78.3040}, {303,76.9180}, {304,77.8815}, {305,81.899}, {306,83.576}, {307,84.896}, {308,86.12}, {309,86.8}, {310,87.627}, {311,88.615}, {312,90.456}, {313,91.356}, {314,93.1}, {315,94.488}, {316,95.228}, {317,96.288}, {318,96.987}, {319,99.135}, {320,100.028}, {321,101.663}, {322,103.543}, {323,104.04}, {324,105.548}, {325,107.023}, {326,108.108}, {327,110.643}, {328,111.379}, {329,112.844}, {330,114.359}, {331,115.211}, {332,117.42}, {333,118.715}, {334,120.492}, {335,121.9}, {336,123.252}, {337,124.347}, {338,126.211}, {339,127.255}, {340,130.14}, {341,131.907}, {342,133.127}, {343,133.408}, {344,135.564}, {345,137.971}, {346,139.043}, {347,140.939}, {348,143.96}, {349,144.752}, {350,146.104}, {351,148.735}, {352,149.82}, {353,151.971}, {354,154.351}, {355,155.451}, {356,156.696}, {357,158.804}, {358,161.367}, {359,163.079}, {360,164.988}, {361,167.235}, {362,168.203}, {363,170.152}, {364,172.1}, {365,174.94}, {366,176.659}, {367,179.067}, {368,181.291}, {369,182.487}, {370,185.1}, {371,186.603}, {372,189.}, {373,191.995}, {374,194.015}, {375,195.412}, {376,197.06}, {377,200.275}, {378,201.992}, {379,204.012}, {380,204.764}, {381,206.236}, {382,208.012}, {383,211.112}, {384,212.884}, {385,216.639}, {386,218.476}, {387,219.404}, {388,223.304}, {389,224.551}, {390,228.316}, {391,229.943}, {392,231.96}, {393,234.728}, {394,237.984}, {395,241.236}, {396,242.46}, {397,245.028}, {398,247.551}, {399,250.292}, {400,254.76}, {401,255.931}, {402,258.479}, {403,260.184}, {404,263.931}, {405,267.416}, {406,268.816}, {407,271.5}, {408,274.112}, {409,276.024}, {410,281.463}, {411,282.416}, {412,285.136}, {413,287.936}, {414,291.644}, {415,294.647}, {416,299.463}, {417,301.087}, {418,303.543}, {419,306.419}, {420,276.743}, {421,260.819}, {422,263.592}, {423,319.775}, {424,321.092}, {425,324.379}, {426,328.804}, {427,332.415}, {428,334.436}, {429,323.86}, {430,334.719}, {431,336.572}, {432,331.548}, {433,335.668}, {434,338.6}, {435,340.296}, {436,353.308}, {437,353.907}, {438,358.736}, {439,363.195}, {440,364.02}, {441,368.167}, {442,371.448}, {443,375.28}, {444,378.948}, {445,382.615}, {446,387.007}, {447,385.768}, {448,394.523}, {449,399.919}, {450,401.872}, {451,405.008}, {452,409.235}};
data["big"]["TypeClasses"]["norm reif"]["system"] = {{1,0.000000000}, {2,0.000035556}, {3,0.000053333}, {4,0.000017778}, {5,0.000053333}, {6,0.000017778}, {7,0.000053333}, {8,0.000071111}, {9,0.000017778}, {10,0.000053333}, {11,0.000053333}, {12,0.000017778}, {13,0.000013333}, {14,0.000000000}, {15,0.000000000}, {16,0.000017778}, {17,0.000053333}, {18,0.000035556}, {19,0.000035556}, {20,0.000071111}, {21,0.000031111}, {22,0.000053333}, {23,0.000017778}, {24,0.000017778}, {25,0.000017778}, {26,0.000000000}, {27,0.000124444}, {28,0.000120000}, {29,0.000053333}, {30,0.000071111}, {31,0.000017778}, {32,0.000053333}, {33,0.000071111}, {34,0.000053333}, {35,0.000017778}, {36,0.000088889}, {37,0.000066667}, {38,0.000017778}, {39,0.000031111}, {40,0.000031111}, {41,0.000053333}, {42,0.000137778}, {43,0.000088889}, {44,0.000035556}, {45,0.000102222}, {46,0.000124444}, {47,0.000035556}, {48,0.000071111}, {49,0.000088889}, {50,0.000124444}, {51,0.000035556}, {52,0.000053333}, {53,0.000071111}, {54,0.000048889}, {55,0.000071111}, {56,0.000102222}, {57,0.000071111}, {58,0.000071111}, {59,0.000035556}, {60,0.000017778}, {61,0.000071111}, {62,0.000053333}, {63,0.000106667}, {64,0.000048889}, {65,0.000088889}, {66,0.000088889}, {67,0.000048889}, {68,0.000053333}, {69,0.000053333}, {70,0.000124444}, {71,0.000017778}, {72,0.000155556}, {73,0.000275556}, {74,0.000511111}, {75,0.000364444}, {76,0.000177778}, {77,0.000408889}, {78,0.000591111}, {79,0.000160000}, {80,0.000173333}, {81,0.000084444}, {82,0.000124444}, {83,0.000315556}, {84,0.000355556}, {85,0.000115556}, {86,0.001778}, {87,0.000667}, {88,0.000000}, {89,0.000000}, {90,0.000444}, {91,0.000444}, {92,0.000444}, {93,0.000000}, {94,0.002000}, {95,0.001333}, {96,0.000389}, {97,0.000000}, {98,0.001111}, {99,0.000889}, {100,0.000000}, {101,0.000000}, {102,0.000222}, {103,0.000222}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000222}, {108,0.000000}, {109,0.000222}, {110,0.000667}, {111,0.000833}, {112,0.000889}, {113,0.000667}, {114,0.000889}, {115,0.000667}, {116,0.000889}, {117,0.000444}, {118,0.000444}, {119,0.000000}, {120,0.000222}, {121,0.000222}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000222}, {127,0.000000}, {128,0.000444}, {129,0.000000}, {130,0.000222}, {131,0.000222}, {132,0.000000}, {133,0.000000}, {134,0.000222}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000444}, {139,0.000000}, {140,0.000444}, {141,0.000444}, {142,0.000222}, {143,0.000222}, {144,0.000222}, {145,0.000444}, {146,0.000000}, {147,0.000222}, {148,0.000222}, {149,0.000000}, {150,0.000000}, {151,0.000444}, {152,0.000167}, {153,0.000222}, {154,0.000889}, {155,0.000667}, {156,0.001333}, {157,0.000222}, {158,0.000222}, {159,0.000444}, {160,0.000000}, {161,0.000000}, {162,0.000222}, {163,0.000000}, {164,0.000222}, {165,0.001111}, {166,0.000444}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000222}, {171,0.000000}, {172,0.000444}, {173,0.000222}, {174,0.000444}, {175,0.000444}, {176,0.001333}, {177,0.002389}, {178,0.000667}, {179,0.002222}, {180,0.004222}, {181,0.001111}, {182,0.001111}, {183,0.000444}, {184,0.000444}, {185,0.000667}, {186,0.000222}, {187,0.000222}, {188,0.001111}, {189,0.000889}, {190,0.001111}, {191,0.000667}, {192,0.000889}, {193,0.000889}, {194,0.001500}, {195,0.000667}, {196,0.001500}, {197,0.002889}, {198,0.001278}, {199,0.001722}, {200,0.002222}, {201,0.000833}, {202,0.001333}, {203,0.000444}, {204,0.001778}, {205,0.000889}, {206,0.000889}, {207,0.001111}, {208,0.001111}, {209,0.001556}, {210,0.001111}, {211,0.002000}, {212,0.000667}, {213,0.004167}, {214,0.002167}, {215,0.002444}, {216,0.004222}, {217,0.002444}, {218,0.002167}, {219,0.001556}, {220,0.001333}, {221,0.001111}, {222,0.001778}, {223,0.001111}, {224,0.003111}, {225,0.001778}, {226,0.001778}, {227,0.002889}, {228,0.002000}, {229,0.002222}, {230,0.002889}, {231,0.002111}, {232,0.003056}, {233,0.002889}, {234,0.001722}, {235,0.002667}, {236,0.003278}, {237,0.002833}, {238,0.003778}, {239,0.002000}, {240,0.003333}, {241,0.003611}, {242,0.003056}, {243,0.003556}, {244,0.002889}, {245,0.003333}, {246,0.002889}, {247,0.002000}, {248,0.001333}, {249,0.002000}, {250,0.003000}, {251,0.001778}, {252,0.005556}, {253,0.002000}, {254,0.002000}, {255,0.005111}, {256,0.004000}, {257,0.005500}, {258,0.002889}, {259,0.004778}, {260,0.002667}, {261,0.004000}, {262,0.004222}, {263,0.002000}, {264,0.006611}, {265,0.004389}, {266,0.005111}, {267,0.005944}, {268,0.007722}, {269,0.004167}, {270,0.006167}, {271,0.005944}, {272,0.002611}, {273,0.007556}, {274,0.005556}, {275,0.004833}, {276,0.004667}, {277,0.005333}, {278,0.003722}, {279,0.005889}, {280,0.008111}, {281,0.007333}, {282,0.006389}, {283,0.004444}, {284,0.011778}, {285,0.010667}, {286,0.008667}, {287,0.010667}, {288,0.009667}, {289,0.006889}, {290,0.009500}, {291,0.009556}, {292,0.008778}, {293,0.010000}, {294,0.009833}, {295,0.013056}, {296,0.015000}, {297,0.011500}, {298,0.015389}, {299,0.010222}, {300,0.013944}, {301,0.0870}, {302,0.0000}, {303,0.0520}, {304,0.0120}, {305,0}, {306,0}, {307,0}, {308,0}, {309,0}, {310,0}, {311,0}, {312,0}, {313,0}, {314,0}, {315,0}, {316,0}, {317,0}, {318,0}, {319,0}, {320,0}, {321,0}, {322,0}, {323,0}, {324,0}, {325,0}, {326,0}, {327,0}, {328,0}, {329,0}, {330,0}, {331,0}, {332,0}, {333,0}, {334,0}, {335,0}, {336,0}, {337,0}, {338,0}, {339,0}, {340,0}, {341,0}, {342,0}, {343,0}, {344,0.004}, {345,0}, {346,0.004}, {347,0}, {348,0}, {349,0}, {350,0}, {351,0}, {352,0}, {353,0}, {354,0}, {355,0}, {356,0}, {357,0}, {358,0.032}, {359,0}, {360,0}, {361,0}, {362,0}, {363,0}, {364,0}, {365,0}, {366,0}, {367,0}, {368,0}, {369,0}, {370,0}, {371,0}, {372,0}, {373,0}, {374,0}, {375,0}, {376,0}, {377,0}, {378,0}, {379,0}, {380,0}, {381,0}, {382,0}, {383,0}, {384,0}, {385,0}, {386,0}, {387,0}, {388,0}, {389,0}, {390,0}, {391,0}, {392,0}, {393,0}, {394,0}, {395,0}, {396,0}, {397,0}, {398,0}, {399,0}, {400,0}, {401,0}, {402,0}, {403,0}, {404,0}, {405,0}, {406,0}, {407,0}, {408,0.012}, {409,0}, {410,0}, {411,0}, {412,0}, {413,0.004}, {414,0}, {415,0}, {416,0}, {417,0}, {418,0}, {419,0}, {420,0}, {421,0}, {422,0}, {423,0}, {424,0}, {425,0}, {426,0}, {427,0}, {428,0.043}, {429,0.06}, {430,0.052}, {431,0.095}, {432,0.043}, {433,0.02}, {434,0}, {435,0}, {436,0.048}, {437,0.044}, {438,0.031}, {439,0}, {440,0}, {441,0}, {442,0}, {443,0}, {444,0}, {445,0}, {446,0}, {447,0.004}, {448,0.095}, {449,0}, {450,0.052}, {451,0.084}, {452,0.079}};
data["big"]["TypeClasses"]["post"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000}, {87,0.000000}, {88,0.000000}, {89,0.000000}, {90,0.000000}, {91,0.000000}, {92,0.000000}, {93,0.000000}, {94,0.000000}, {95,0.000000}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000000}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000000}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000000}, {237,0.000000}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000000}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000000}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.0000}, {302,0.0000}, {303,0.0000}, {304,0.0000}, {305,0}, {306,0}, {307,0}, {308,0}, {309,0}, {310,0}, {311,0}, {312,0}, {313,0}, {314,0}, {315,0}, {316,0}, {317,0}, {318,0}, {319,0}, {320,0}, {321,0}, {322,0}, {323,0}, {324,0}, {325,0}, {326,0}, {327,0}, {328,0}, {329,0}, {330,0}, {331,0}, {332,0}, {333,0}, {334,0}, {335,0}, {336,0}, {337,0}, {338,0}, {339,0}, {340,0}, {341,0}, {342,0}, {343,0}, {344,0}, {345,0}, {346,0}, {347,0}, {348,0}, {349,0}, {350,0}, {351,0}, {352,0}, {353,0}, {354,0}, {355,0}, {356,0}, {357,0}, {358,0}, {359,0}, {360,0}, {361,0}, {362,0}, {363,0}, {364,0}, {365,0}, {366,0}, {367,0}, {368,0}, {369,0}, {370,0}, {371,0}, {372,0}, {373,0}, {374,0}, {375,0}, {376,0}, {377,0}, {378,0}, {379,0}, {380,0}, {381,0}, {382,0}, {383,0}, {384,0}, {385,0}, {386,0}, {387,0}, {388,0}, {389,0}, {390,0}, {391,0}, {392,0}, {393,0}, {394,0}, {395,0}, {396,0}, {397,0}, {398,0}, {399,0}, {400,0}, {401,0}, {402,0}, {403,0}, {404,0}, {405,0}, {406,0}, {407,0}, {408,0}, {409,0}, {410,0}, {411,0}, {412,0}, {413,0}, {414,0}, {415,0}, {416,0}, {417,0}, {418,0}, {419,0}, {420,0}, {421,0}, {422,0}, {423,0}, {424,0}, {425,0}, {426,0}, {427,0}, {428,0}, {429,0}, {430,0}, {431,0}, {432,0}, {433,0}, {434,0}, {435,0}, {436,0}, {437,0}, {438,0}, {439,0}, {440,0}, {441,0}, {442,0}, {443,0}, {444,0}, {445,0}, {446,0}, {447,0}, {448,0}, {449,0}, {450,0}, {451,0}, {452,0}};
data["big"]["TypeClasses"]["post"]["user"] = {{1,0.000017778}, {2,0.000013333}, {3,0.000044444}, {4,0.000048889}, {5,0.000075556}, {6,0.000000000}, {7,0.000013333}, {8,0.000000000}, {9,0.000031111}, {10,0.000075556}, {11,0.000013333}, {12,0.000053333}, {13,0.000035556}, {14,0.000013333}, {15,0.000017778}, {16,0.000035556}, {17,0.000000000}, {18,0.000053333}, {19,0.000035556}, {20,0.000000000}, {21,0.000000000}, {22,0.000062222}, {23,0.000017778}, {24,0.000106667}, {25,0.000035556}, {26,0.000048889}, {27,0.000035556}, {28,0.000044444}, {29,0.000013333}, {30,0.000053333}, {31,0.000031111}, {32,0.000080000}, {33,0.000048889}, {34,0.000075556}, {35,0.000017778}, {36,0.000031111}, {37,0.000035556}, {38,0.000044444}, {39,0.000000000}, {40,0.000000000}, {41,0.000048889}, {42,0.000084444}, {43,0.000017778}, {44,0.000013333}, {45,0.000071111}, {46,0.000106667}, {47,0.000031111}, {48,0.000035556}, {49,0.000000000}, {50,0.000017778}, {51,0.000035556}, {52,0.000035556}, {53,0.000044444}, {54,0.000035556}, {55,0.000057778}, {56,0.000031111}, {57,0.000035556}, {58,0.000013333}, {59,0.000053333}, {60,0.000026667}, {61,0.000000000}, {62,0.000035556}, {63,0.000017778}, {64,0.000053333}, {65,0.000035556}, {66,0.000053333}, {67,0.000071111}, {68,0.000000000}, {69,0.000035556}, {70,0.000000000}, {71,0.000035556}, {72,0.000031111}, {73,0.000035556}, {74,0.000031111}, {75,0.000053333}, {76,0.000000000}, {77,0.000017778}, {78,0.000062222}, {79,0.000071111}, {80,0.000035556}, {81,0.000088889}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000035556}, {86,0.000000}, {87,0.000167}, {88,0.000000}, {89,0.000000}, {90,0.000000}, {91,0.000000}, {92,0.000000}, {93,0.000000}, {94,0.000000}, {95,0.000167}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000167}, {100,0.000000}, {101,0.000167}, {102,0.000222}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000389}, {109,0.000000}, {110,0.000000}, {111,0.000167}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000167}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000222}, {121,0.000000}, {122,0.000167}, {123,0.000000}, {124,0.000000}, {125,0.000167}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000222}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000167}, {136,0.000000}, {137,0.000167}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000167}, {156,0.000000}, {157,0.000000}, {158,0.000167}, {159,0.000000}, {160,0.000222}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000167}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000222}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000167}, {187,0.000167}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000167}, {202,0.000167}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000167}, {215,0.000167}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000222}, {221,0.000000}, {222,0.000000}, {223,0.000167}, {224,0.000000}, {225,0.000000}, {226,0.000167}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000000}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000167}, {235,0.000000}, {236,0.000000}, {237,0.000167}, {238,0.000167}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000167}, {251,0.000167}, {252,0.000000}, {253,0.000000}, {254,0.000222}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000167}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000167}, {280,0.000000}, {281,0.000167}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000000}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000167}, {294,0.000000}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.0000}, {302,0.0000}, {303,0.0000}, {304,0.0000}, {305,0}, {306,0}, {307,0}, {308,0}, {309,0}, {310,0}, {311,0}, {312,0}, {313,0}, {314,0}, {315,0}, {316,0.003}, {317,0}, {318,0}, {319,0}, {320,0}, {321,0}, {322,0}, {323,0}, {324,0}, {325,0}, {326,0}, {327,0}, {328,0}, {329,0}, {330,0}, {331,0}, {332,0}, {333,0}, {334,0.003}, {335,0}, {336,0}, {337,0}, {338,0}, {339,0}, {340,0}, {341,0}, {342,0}, {343,0}, {344,0}, {345,0}, {346,0}, {347,0}, {348,0}, {349,0}, {350,0}, {351,0}, {352,0}, {353,0}, {354,0}, {355,0}, {356,0}, {357,0}, {358,0}, {359,0}, {360,0}, {361,0}, {362,0}, {363,0}, {364,0}, {365,0}, {366,0}, {367,0}, {368,0}, {369,0}, {370,0}, {371,0}, {372,0.003}, {373,0}, {374,0}, {375,0}, {376,0}, {377,0}, {378,0}, {379,0}, {380,0}, {381,0}, {382,0}, {383,0}, {384,0}, {385,0}, {386,0}, {387,0}, {388,0}, {389,0}, {390,0}, {391,0}, {392,0}, {393,0}, {394,0}, {395,0}, {396,0}, {397,0}, {398,0}, {399,0}, {400,0}, {401,0}, {402,0}, {403,0}, {404,0}, {405,0}, {406,0}, {407,0}, {408,0}, {409,0}, {410,0}, {411,0}, {412,0}, {413,0}, {414,0}, {415,0}, {416,0}, {417,0}, {418,0}, {419,0}, {420,0}, {421,0}, {422,0}, {423,0}, {424,0}, {425,0}, {426,0}, {427,0}, {428,0}, {429,0}, {430,0}, {431,0}, {432,0}, {433,0}, {434,0}, {435,0}, {436,0}, {437,0}, {438,0}, {439,0}, {440,0}, {441,0}, {442,0}, {443,0}, {444,0}, {445,0}, {446,0}, {447,0}, {448,0}, {449,0}, {450,0}, {451,0}, {452,0}};
data["big"]["TypeClasses"]["post"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000017778}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000}, {87,0.000000}, {88,0.000000}, {89,0.000000}, {90,0.000000}, {91,0.000000}, {92,0.000000}, {93,0.000000}, {94,0.000000}, {95,0.000000}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000000}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000000}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000222}, {237,0.000000}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000000}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000000}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.0000}, {302,0.0000}, {303,0.0000}, {304,0.0000}, {305,0}, {306,0}, {307,0}, {308,0}, {309,0}, {310,0}, {311,0}, {312,0}, {313,0}, {314,0}, {315,0}, {316,0}, {317,0}, {318,0}, {319,0}, {320,0}, {321,0}, {322,0}, {323,0}, {324,0}, {325,0}, {326,0}, {327,0}, {328,0}, {329,0}, {330,0}, {331,0}, {332,0}, {333,0}, {334,0}, {335,0}, {336,0}, {337,0}, {338,0}, {339,0}, {340,0}, {341,0}, {342,0}, {343,0}, {344,0}, {345,0}, {346,0}, {347,0}, {348,0}, {349,0}, {350,0}, {351,0}, {352,0}, {353,0}, {354,0}, {355,0}, {356,0}, {357,0}, {358,0}, {359,0}, {360,0}, {361,0}, {362,0}, {363,0}, {364,0}, {365,0}, {366,0}, {367,0}, {368,0}, {369,0}, {370,0}, {371,0}, {372,0}, {373,0}, {374,0}, {375,0}, {376,0}, {377,0}, {378,0}, {379,0}, {380,0}, {381,0}, {382,0}, {383,0}, {384,0}, {385,0}, {386,0}, {387,0}, {388,0}, {389,0}, {390,0}, {391,0}, {392,0}, {393,0}, {394,0}, {395,0}, {396,0}, {397,0}, {398,0}, {399,0}, {400,0}, {401,0}, {402,0}, {403,0}, {404,0}, {405,0}, {406,0}, {407,0}, {408,0}, {409,0}, {410,0}, {411,0}, {412,0}, {413,0}, {414,0}, {415,0}, {416,0}, {417,0}, {418,0}, {419,0}, {420,0}, {421,0}, {422,0}, {423,0}, {424,0}, {425,0}, {426,0}, {427,0}, {428,0}, {429,0}, {430,0}, {431,0}, {432,0}, {433,0}, {434,0}, {435,0}, {436,0}, {437,0}, {438,0}, {439,0}, {440,0}, {441,0}, {442,0}, {443,0}, {444,0}, {445,0}, {446,0}, {447,0}, {448,0}, {449,0}, {450,0}, {451,0}, {452,0}};
data["big"]["TypeClasses"]["pre"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000}, {87,0.000000}, {88,0.000000}, {89,0.000000}, {90,0.000000}, {91,0.000000}, {92,0.000000}, {93,0.000000}, {94,0.000000}, {95,0.000000}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000000}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000000}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000000}, {237,0.000000}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000000}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000000}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.0000}, {302,0.0000}, {303,0.0000}, {304,0.0000}, {305,0.0000}, {306,0}, {307,0}, {308,0}, {309,0}, {310,0}, {311,0}, {312,0}, {313,0}, {314,0}, {315,0}, {316,0}, {317,0}, {318,0}, {319,0}, {320,0}, {321,0}, {322,0}, {323,0}, {324,0}, {325,0}, {326,0}, {327,0}, {328,0}, {329,0}, {330,0}, {331,0}, {332,0}, {333,0}, {334,0}, {335,0}, {336,0}, {337,0}, {338,0}, {339,0}, {340,0}, {341,0}, {342,0}, {343,0}, {344,0}, {345,0}, {346,0}, {347,0}, {348,0}, {349,0}, {350,0}, {351,0}, {352,0}, {353,0}, {354,0}, {355,0}, {356,0}, {357,0}, {358,0}, {359,0}, {360,0}, {361,0}, {362,0}, {363,0}, {364,0}, {365,0}, {366,0}, {367,0}, {368,0}, {369,0}, {370,0}, {371,0}, {372,0}, {373,0}, {374,0}, {375,0}, {376,0}, {377,0}, {378,0}, {379,0}, {380,0}, {381,0}, {382,0}, {383,0}, {384,0}, {385,0}, {386,0}, {387,0}, {388,0}, {389,0}, {390,0}, {391,0}, {392,0}, {393,0}, {394,0}, {395,0}, {396,0}, {397,0}, {398,0}, {399,0}, {400,0}, {401,0}, {402,0}, {403,0}, {404,0}, {405,0}, {406,0}, {407,0}, {408,0}, {409,0}, {410,0}, {411,0}, {412,0}, {413,0}, {414,0}, {415,0}, {416,0}, {417,0}, {418,0}, {419,0}, {420,0}, {421,0}, {422,0}, {423,0}, {424,0}, {425,0}, {426,0}, {427,0}, {428,0}, {429,0}, {430,0}, {431,0}, {432,0}, {433,0}, {434,0}, {435,0}, {436,0}, {437,0}, {438,0}, {439,0}, {440,0}, {441,0}, {442,0}, {443,0}, {444,0}, {445,0}, {446,0}, {447,0}, {448,0}, {449,0}, {450,0}, {451,0}, {452,0}, {453,0}};
data["big"]["TypeClasses"]["pre"]["user"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000013333}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000013333}, {11,0.000000000}, {12,0.000000000}, {13,0.000017778}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000017778}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000017778}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000053333}, {32,0.000000000}, {33,0.000017778}, {34,0.000017778}, {35,0.000000000}, {36,0.000000000}, {37,0.000017778}, {38,0.000000000}, {39,0.000000000}, {40,0.000017778}, {41,0.000000000}, {42,0.000000000}, {43,0.000017778}, {44,0.000000000}, {45,0.000017778}, {46,0.000013333}, {47,0.000000000}, {48,0.000000000}, {49,0.000017778}, {50,0.000048889}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000013333}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000035556}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000013333}, {69,0.000013333}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000017778}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000017778}, {84,0.000000000}, {85,0.000017778}, {86,0.000000}, {87,0.000000}, {88,0.000000}, {89,0.000000}, {90,0.000000}, {91,0.000000}, {92,0.000000}, {93,0.000000}, {94,0.000000}, {95,0.000000}, {96,0.000167}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000167}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000167}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000000}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000000}, {231,0.000000}, {232,0.000167}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000000}, {237,0.000000}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000167}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000000}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000167}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.0000}, {302,0.0000}, {303,0.0000}, {304,0.0000}, {305,0.0000}, {306,0}, {307,0}, {308,0}, {309,0}, {310,0}, {311,0}, {312,0}, {313,0}, {314,0}, {315,0}, {316,0}, {317,0}, {318,0}, {319,0}, {320,0}, {321,0}, {322,0}, {323,0}, {324,0}, {325,0}, {326,0}, {327,0}, {328,0}, {329,0}, {330,0}, {331,0}, {332,0}, {333,0}, {334,0}, {335,0}, {336,0}, {337,0}, {338,0}, {339,0}, {340,0}, {341,0}, {342,0}, {343,0}, {344,0}, {345,0}, {346,0}, {347,0}, {348,0}, {349,0}, {350,0}, {351,0}, {352,0}, {353,0}, {354,0}, {355,0}, {356,0}, {357,0}, {358,0}, {359,0}, {360,0}, {361,0}, {362,0}, {363,0}, {364,0}, {365,0}, {366,0}, {367,0}, {368,0}, {369,0}, {370,0}, {371,0}, {372,0}, {373,0}, {374,0}, {375,0}, {376,0}, {377,0}, {378,0}, {379,0}, {380,0}, {381,0}, {382,0}, {383,0}, {384,0}, {385,0}, {386,0}, {387,0}, {388,0}, {389,0}, {390,0}, {391,0}, {392,0}, {393,0}, {394,0}, {395,0}, {396,0}, {397,0}, {398,0}, {399,0}, {400,0}, {401,0}, {402,0}, {403,0}, {404,0}, {405,0}, {406,0}, {407,0}, {408,0}, {409,0}, {410,0}, {411,0}, {412,0}, {413,0}, {414,0}, {415,0}, {416,0}, {417,0}, {418,0}, {419,0}, {420,0}, {421,0}, {422,0}, {423,0}, {424,0}, {425,0}, {426,0}, {427,0}, {428,0}, {429,0}, {430,0}, {431,0}, {432,0}, {433,0}, {434,0}, {435,0}, {436,0}, {437,0}, {438,0}, {439,0}, {440,0}, {441,0}, {442,0}, {443,0}, {444,0}, {445,0}, {446,0}, {447,0}, {448,0}, {449,0}, {450,0}, {451,0}, {452,0}, {453,0}};
data["big"]["TypeClasses"]["pre"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000}, {87,0.000000}, {88,0.000000}, {89,0.000000}, {90,0.000000}, {91,0.000000}, {92,0.000000}, {93,0.000000}, {94,0.000000}, {95,0.000000}, {96,0.000000}, {97,0.000000}, {98,0.000000}, {99,0.000000}, {100,0.000000}, {101,0.000000}, {102,0.000000}, {103,0.000000}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000000}, {108,0.000000}, {109,0.000000}, {110,0.000000}, {111,0.000000}, {112,0.000000}, {113,0.000000}, {114,0.000000}, {115,0.000000}, {116,0.000000}, {117,0.000000}, {118,0.000000}, {119,0.000000}, {120,0.000000}, {121,0.000000}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000000}, {127,0.000000}, {128,0.000000}, {129,0.000000}, {130,0.000000}, {131,0.000000}, {132,0.000000}, {133,0.000000}, {134,0.000000}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000000}, {139,0.000000}, {140,0.000000}, {141,0.000000}, {142,0.000000}, {143,0.000000}, {144,0.000000}, {145,0.000000}, {146,0.000000}, {147,0.000000}, {148,0.000000}, {149,0.000000}, {150,0.000000}, {151,0.000000}, {152,0.000000}, {153,0.000000}, {154,0.000000}, {155,0.000000}, {156,0.000000}, {157,0.000000}, {158,0.000000}, {159,0.000000}, {160,0.000000}, {161,0.000000}, {162,0.000000}, {163,0.000000}, {164,0.000000}, {165,0.000000}, {166,0.000000}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000000}, {171,0.000000}, {172,0.000000}, {173,0.000000}, {174,0.000000}, {175,0.000000}, {176,0.000000}, {177,0.000000}, {178,0.000000}, {179,0.000000}, {180,0.000000}, {181,0.000000}, {182,0.000000}, {183,0.000000}, {184,0.000000}, {185,0.000000}, {186,0.000000}, {187,0.000000}, {188,0.000000}, {189,0.000000}, {190,0.000000}, {191,0.000000}, {192,0.000000}, {193,0.000000}, {194,0.000000}, {195,0.000000}, {196,0.000000}, {197,0.000000}, {198,0.000000}, {199,0.000000}, {200,0.000000}, {201,0.000000}, {202,0.000000}, {203,0.000000}, {204,0.000000}, {205,0.000000}, {206,0.000000}, {207,0.000000}, {208,0.000000}, {209,0.000000}, {210,0.000000}, {211,0.000000}, {212,0.000000}, {213,0.000000}, {214,0.000000}, {215,0.000000}, {216,0.000000}, {217,0.000000}, {218,0.000000}, {219,0.000000}, {220,0.000000}, {221,0.000000}, {222,0.000000}, {223,0.000000}, {224,0.000000}, {225,0.000000}, {226,0.000000}, {227,0.000000}, {228,0.000000}, {229,0.000000}, {230,0.000000}, {231,0.000000}, {232,0.000000}, {233,0.000000}, {234,0.000000}, {235,0.000000}, {236,0.000000}, {237,0.000000}, {238,0.000000}, {239,0.000000}, {240,0.000000}, {241,0.000000}, {242,0.000000}, {243,0.000000}, {244,0.000000}, {245,0.000000}, {246,0.000000}, {247,0.000000}, {248,0.000000}, {249,0.000000}, {250,0.000000}, {251,0.000000}, {252,0.000000}, {253,0.000000}, {254,0.000000}, {255,0.000000}, {256,0.000000}, {257,0.000000}, {258,0.000000}, {259,0.000000}, {260,0.000000}, {261,0.000000}, {262,0.000000}, {263,0.000000}, {264,0.000000}, {265,0.000000}, {266,0.000000}, {267,0.000000}, {268,0.000000}, {269,0.000000}, {270,0.000000}, {271,0.000000}, {272,0.000000}, {273,0.000000}, {274,0.000000}, {275,0.000000}, {276,0.000000}, {277,0.000000}, {278,0.000000}, {279,0.000000}, {280,0.000000}, {281,0.000000}, {282,0.000000}, {283,0.000000}, {284,0.000000}, {285,0.000000}, {286,0.000000}, {287,0.000000}, {288,0.000000}, {289,0.000000}, {290,0.000000}, {291,0.000000}, {292,0.000000}, {293,0.000000}, {294,0.000000}, {295,0.000000}, {296,0.000000}, {297,0.000000}, {298,0.000000}, {299,0.000000}, {300,0.000000}, {301,0.0000}, {302,0.0000}, {303,0.0000}, {304,0.0000}, {305,0.0000}, {306,0}, {307,0}, {308,0}, {309,0}, {310,0}, {311,0}, {312,0}, {313,0}, {314,0}, {315,0}, {316,0}, {317,0}, {318,0}, {319,0}, {320,0}, {321,0}, {322,0}, {323,0}, {324,0}, {325,0}, {326,0}, {327,0}, {328,0}, {329,0}, {330,0}, {331,0}, {332,0}, {333,0}, {334,0}, {335,0}, {336,0}, {337,0}, {338,0}, {339,0}, {340,0}, {341,0}, {342,0}, {343,0}, {344,0}, {345,0}, {346,0}, {347,0}, {348,0}, {349,0}, {350,0}, {351,0}, {352,0}, {353,0}, {354,0}, {355,0}, {356,0}, {357,0}, {358,0}, {359,0}, {360,0}, {361,0}, {362,0}, {363,0}, {364,0}, {365,0}, {366,0}, {367,0}, {368,0}, {369,0}, {370,0}, {371,0}, {372,0}, {373,0}, {374,0}, {375,0}, {376,0}, {377,0}, {378,0}, {379,0}, {380,0}, {381,0}, {382,0}, {383,0}, {384,0}, {385,0}, {386,0}, {387,0}, {388,0}, {389,0}, {390,0}, {391,0}, {392,0}, {393,0}, {394,0}, {395,0}, {396,0}, {397,0}, {398,0}, {399,0}, {400,0}, {401,0}, {402,0}, {403,0}, {404,0}, {405,0}, {406,0}, {407,0}, {408,0}, {409,0}, {410,0}, {411,0}, {412,0}, {413,0}, {414,0}, {415,0}, {416,0}, {417,0}, {418,0}, {419,0}, {420,0}, {421,0}, {422,0}, {423,0}, {424,0}, {425,0}, {426,0}, {427,0}, {428,0}, {429,0}, {430,0}, {431,0}, {432,0}, {433,0}, {434,0}, {435,0}, {436,0}, {437,0}, {438,0}, {439,0}, {440,0}, {441,0}, {442,0}, {443,0}, {444,0}, {445,0}, {446,0}, {447,0}, {448,0}, {449,0}, {450,0}, {451,0}, {452,0}, {453,0}};
data["big"]["TypeClasses"]["reif"]["real"] = {{1,0.000960000}, {2,0.001000000}, {3,0.002008889}, {4,0.003000000}, {5,0.003848889}, {6,0.004893333}, {7,0.006231111}, {8,0.007413333}, {9,0.008813333}, {10,0.029831111}, {11,0.012093333}, {12,0.013791111}, {13,0.015884444}, {14,0.018262222}, {15,0.020524444}, {16,0.023920000}, {17,0.026000000}, {18,0.028644444}, {19,0.031617778}, {20,0.037471111}, {21,0.038235556}, {22,0.041826667}, {23,0.048671111}, {24,0.049502222}, {25,0.055688889}, {26,0.058591111}, {27,0.066146667}, {28,0.069053333}, {29,0.079044444}, {30,0.079075556}, {31,0.087466667}, {32,0.097715556}, {33,0.100977778}, {34,0.105120000}, {35,0.115057778}, {36,0.125542222}, {37,0.131271111}, {38,0.139275556}, {39,0.147653333}, {40,0.160306667}, {41,0.167297778}, {42,0.171760000}, {43,0.186040000}, {44,0.197551111}, {45,0.204746667}, {46,0.220622222}, {47,0.232848889}, {48,0.242417778}, {49,0.261324444}, {50,0.268582222}, {51,0.275955556}, {52,0.288120000}, {53,0.303453333}, {54,0.320257778}, {55,0.338822222}, {56,0.353711111}, {57,0.373355556}, {58,0.387035556}, {59,0.402804444}, {60,0.423080000}, {61,0.439262222}, {62,0.456262222}, {63,0.477733333}, {64,0.499306667}, {65,0.522266667}, {66,0.540893333}, {67,0.561568889}, {68,0.589542222}, {69,0.603920000}, {70,0.635275556}, {71,0.657595556}, {72,0.682391111}, {73,0.736133333}, {74,0.894364444}, {75,0.878026667}, {76,0.794422222}, {77,0.833746667}, {78,0.909631111}, {79,0.883373333}, {80,0.920004444}, {81,0.940751111}, {82,0.971471111}, {83,1.023182222}, {84,1.070924444}, {85,1.079426667}, {86,1.111667}, {87,1.123611}, {88,1.163500}, {89,1.205167}, {90,1.242444}, {91,1.291944}, {92,1.326556}, {93,1.371722}, {94,1.420056}, {95,1.467556}, {96,1.507500}, {97,1.555667}, {98,1.605556}, {99,1.651722}, {100,1.706944}, {101,1.764444}, {102,1.823278}, {103,1.871833}, {104,1.928833}, {105,1.988278}, {106,2.044889}, {107,2.106278}, {108,2.163500}, {109,2.233000}, {110,2.379667}, {111,2.387167}, {112,2.555667}, {113,2.533278}, {114,2.668667}, {115,2.702278}, {116,2.786500}, {117,2.845167}, {118,2.871000}, {119,2.943389}, {120,3.067000}, {121,3.102056}, {122,3.190556}, {123,3.261167}, {124,3.365444}, {125,3.435444}, {126,3.521056}, {127,3.625167}, {128,3.718722}, {129,3.800222}, {130,3.907222}, {131,4.001500}, {132,4.093778}, {133,4.197889}, {134,4.319389}, {135,4.408611}, {136,4.504556}, {137,4.615111}, {138,4.728167}, {139,4.850944}, {140,4.958444}, {141,5.077167}, {142,5.194167}, {143,5.311722}, {144,5.442167}, {145,5.562944}, {146,5.684944}, {147,5.822167}, {148,5.951056}, {149,6.092611}, {150,6.214556}, {151,6.349611}, {152,6.518111}, {153,6.656444}, {154,6.805167}, {155,6.938333}, {156,7.089778}, {157,7.251556}, {158,7.420167}, {159,7.561333}, {160,7.717389}, {161,7.885500}, {162,8.047222}, {163,8.219056}, {164,8.397667}, {165,8.559444}, {166,8.749333}, {167,8.954111}, {168,9.115111}, {169,9.276944}, {170,9.470056}, {171,9.684444}, {172,9.866944}, {173,10.110556}, {174,10.305333}, {175,10.470222}, {176,10.660111}, {177,10.948389}, {178,11.107944}, {179,11.342944}, {180,11.535722}, {181,11.727500}, {182,11.940000}, {183,12.148000}, {184,12.384444}, {185,12.592611}, {186,12.793000}, {187,13.057611}, {188,13.266500}, {189,13.600556}, {190,13.821278}, {191,14.133611}, {192,14.300389}, {193,14.683778}, {194,14.904333}, {195,15.171056}, {196,15.407889}, {197,15.658000}, {198,15.984889}, {199,16.276778}, {200,16.488556}, {201,16.751833}, {202,17.025222}, {203,17.268556}, {204,17.607222}, {205,17.918056}, {206,18.211667}, {207,18.519444}, {208,18.786167}, {209,19.028833}, {210,19.376833}, {211,19.707722}, {212,19.993778}, {213,20.389889}, {214,20.680500}, {215,20.971889}, {216,21.364167}, {217,21.693944}, {218,21.977278}, {219,22.444000}, {220,22.683278}, {221,23.121278}, {222,23.441167}, {223,23.742278}, {224,24.167556}, {225,24.567500}, {226,24.954111}, {227,25.267611}, {228,25.611667}, {229,26.102500}, {230,26.534056}, {231,26.918278}, {232,27.333667}, {233,27.705667}, {234,28.192444}, {235,28.783167}, {236,29.056389}, {237,29.662167}, {238,30.040278}, {239,30.510833}, {240,30.756389}, {241,31.305389}, {242,31.845500}, {243,32.197167}, {244,32.720611}, {245,33.174111}, {246,33.725167}, {247,34.149333}, {248,34.623444}, {249,35.269556}, {250,35.707667}, {251,36.328167}, {252,36.718056}, {253,37.111944}, {254,37.749222}, {255,38.318889}, {256,38.762778}, {257,39.408889}, {258,39.726778}, {259,40.406778}, {260,40.856333}, {261,41.568278}, {262,42.145278}, {263,42.915556}, {264,43.450889}, {265,44.100667}, {266,44.725667}, {267,45.082778}, {268,45.991278}, {269,46.687889}, {270,47.158056}, {271,47.606278}, {272,48.475444}, {273,48.905167}, {274,49.754167}, {275,50.507611}, {276,51.022111}, {277,51.766611}, {278,52.407056}, {279,53.132389}, {280,54.048667}, {281,54.676333}, {282,55.451944}, {283,56.103000}, {284,57.107944}, {285,57.902833}, {286,58.353833}, {287,59.303667}, {288,59.822111}, {289,60.757167}, {290,61.318778}, {291,62.195611}, {292,62.709722}, {293,64.041889}, {294,64.896222}, {295,65.688444}, {296,66.847722}, {297,67.615389}, {298,68.608500}, {299,69.164111}, {300,70.010222}, {301,78.9185}, {302,78.7480}, {303,77.8945}, {304,78.6355}, {305,81.9}, {306,83.578}, {307,84.9}, {308,86.122}, {309,86.799}, {310,87.626}, {311,88.615}, {312,90.459}, {313,91.356}, {314,93.101}, {315,94.486}, {316,95.231}, {317,96.291}, {318,96.992}, {319,99.146}, {320,100.026}, {321,101.667}, {322,103.546}, {323,104.045}, {324,105.551}, {325,107.026}, {326,108.108}, {327,110.645}, {328,111.38}, {329,112.843}, {330,114.358}, {331,115.213}, {332,117.421}, {333,118.719}, {334,120.494}, {335,121.902}, {336,123.251}, {337,124.351}, {338,126.213}, {339,127.257}, {340,130.141}, {341,131.909}, {342,133.133}, {343,133.411}, {344,135.57}, {345,137.972}, {346,139.049}, {347,140.942}, {348,143.96}, {349,144.756}, {350,146.107}, {351,148.742}, {352,149.823}, {353,151.976}, {354,154.353}, {355,155.454}, {356,156.701}, {357,158.807}, {358,161.403}, {359,163.08}, {360,164.991}, {361,167.236}, {362,168.205}, {363,170.155}, {364,172.102}, {365,174.943}, {366,176.662}, {367,179.068}, {368,181.292}, {369,182.488}, {370,185.102}, {371,186.606}, {372,189.003}, {373,191.997}, {374,194.016}, {375,195.414}, {376,197.063}, {377,200.277}, {378,201.994}, {379,204.012}, {380,204.764}, {381,206.236}, {382,208.013}, {383,211.115}, {384,212.887}, {385,216.644}, {386,218.481}, {387,219.407}, {388,223.305}, {389,224.556}, {390,228.318}, {391,229.949}, {392,231.962}, {393,234.729}, {394,237.989}, {395,241.239}, {396,242.46}, {397,245.032}, {398,247.556}, {399,250.296}, {400,254.765}, {401,255.939}, {402,258.481}, {403,260.188}, {404,263.934}, {405,267.416}, {406,268.817}, {407,271.503}, {408,276.763}, {409,276.086}, {410,281.531}, {411,282.419}, {412,285.138}, {413,287.942}, {414,291.645}, {415,294.663}, {416,299.466}, {417,301.095}, {418,303.546}, {419,306.422}, {420,278.804}, {421,260.823}, {422,263.599}, {423,321.534}, {424,321.095}, {425,324.535}, {426,328.804}, {427,332.415}, {428,334.48}, {429,326.632}, {430,334.773}, {431,336.67}, {432,331.593}, {433,335.689}, {434,338.599}, {435,340.297}, {436,353.358}, {437,353.952}, {438,358.77}, {439,363.196}, {440,364.021}, {441,368.169}, {442,371.449}, {443,375.281}, {444,378.949}, {445,382.618}, {446,387.005}, {447,386.65}, {448,396.629}, {449,399.929}, {450,401.942}, {451,405.218}, {452,409.427}};
data["big"]["TypeClasses"]["reif"]["user"] = {{1,0.001080000}, {2,0.001573333}, {3,0.002280000}, {4,0.003151111}, {5,0.003986667}, {6,0.005013333}, {7,0.006186667}, {8,0.007462222}, {9,0.008920000}, {10,0.029702222}, {11,0.012395556}, {12,0.013893333}, {13,0.015777778}, {14,0.017973333}, {15,0.020351111}, {16,0.024191111}, {17,0.026146667}, {18,0.028626667}, {19,0.031715556}, {20,0.037533333}, {21,0.038235556}, {22,0.041680000}, {23,0.048582222}, {24,0.049586667}, {25,0.055777778}, {26,0.058551111}, {27,0.065991111}, {28,0.069128889}, {29,0.078986667}, {30,0.079173333}, {31,0.087200000}, {32,0.097422222}, {33,0.100715556}, {34,0.105151111}, {35,0.114808889}, {36,0.125466667}, {37,0.131417778}, {38,0.139057778}, {39,0.147351111}, {40,0.159977778}, {41,0.166840000}, {42,0.171248889}, {43,0.185657778}, {44,0.197164444}, {45,0.204493333}, {46,0.220044444}, {47,0.232706667}, {48,0.242035556}, {49,0.261004444}, {50,0.267893333}, {51,0.275591111}, {52,0.287911111}, {53,0.302942222}, {54,0.319977778}, {55,0.338724444}, {56,0.353213333}, {57,0.372955556}, {58,0.386840000}, {59,0.402408889}, {60,0.422533333}, {61,0.438684444}, {62,0.455960000}, {63,0.477186667}, {64,0.498857778}, {65,0.521875556}, {66,0.540386667}, {67,0.561288889}, {68,0.589253333}, {69,0.603360000}, {70,0.634773333}, {71,0.657146667}, {72,0.681635556}, {73,0.735328889}, {74,0.893328889}, {75,0.877048889}, {76,0.793613333}, {77,0.832760000}, {78,0.908435556}, {79,0.882666667}, {80,0.919075556}, {81,0.939835556}, {82,0.970706667}, {83,1.022408889}, {84,1.069808889}, {85,1.078417778}, {86,1.108889}, {87,1.122222}, {88,1.162611}, {89,1.204278}, {90,1.240611}, {91,1.289944}, {92,1.325000}, {93,1.370944}, {94,1.416722}, {95,1.464556}, {96,1.506222}, {97,1.554222}, {98,1.602556}, {99,1.648778}, {100,1.706278}, {101,1.763278}, {102,1.821333}, {103,1.870278}, {104,1.927333}, {105,1.986222}, {106,2.042500}, {107,2.103944}, {108,2.162000}, {109,2.231889}, {110,2.376778}, {111,2.384889}, {112,2.553500}, {113,2.530278}, {114,2.664833}, {115,2.698944}, {116,2.783278}, {117,2.842778}, {118,2.868778}, {119,2.941833}, {120,3.065611}, {121,3.099444}, {122,3.188278}, {123,3.259389}, {124,3.363722}, {125,3.434000}, {126,3.519278}, {127,3.623167}, {128,3.716389}, {129,3.797278}, {130,3.904500}, {131,3.998667}, {132,4.091389}, {133,4.195000}, {134,4.316056}, {135,4.406222}, {136,4.502444}, {137,4.613000}, {138,4.725833}, {139,4.847722}, {140,4.954278}, {141,5.074444}, {142,5.190611}, {143,5.308556}, {144,5.438056}, {145,5.558778}, {146,5.681778}, {147,5.819556}, {148,5.950222}, {149,6.092444}, {150,6.214000}, {151,6.348500}, {152,6.517944}, {153,6.655444}, {154,6.803556}, {155,6.936778}, {156,7.087278}, {157,7.250556}, {158,7.420167}, {159,7.560889}, {160,7.717000}, {161,7.884833}, {162,8.046944}, {163,8.216556}, {164,8.394833}, {165,8.555722}, {166,8.748722}, {167,8.953833}, {168,9.114833}, {169,9.276889}, {170,9.470000}, {171,9.682889}, {172,9.863722}, {173,10.107556}, {174,10.301111}, {175,10.466889}, {176,10.654833}, {177,10.941389}, {178,11.102333}, {179,11.335722}, {180,11.527556}, {181,11.721833}, {182,11.933944}, {183,12.142333}, {184,12.377889}, {185,12.585333}, {186,12.786833}, {187,13.050944}, {188,13.259000}, {189,13.594000}, {190,13.815944}, {191,14.127111}, {192,14.294500}, {193,14.677222}, {194,14.896944}, {195,15.164778}, {196,15.400222}, {197,15.648611}, {198,15.975444}, {199,16.262056}, {200,16.474611}, {201,16.740056}, {202,17.009444}, {203,17.253667}, {204,17.592000}, {205,17.903167}, {206,18.200944}, {207,18.508667}, {208,18.774722}, {209,19.017444}, {210,19.366167}, {211,19.695667}, {212,19.983889}, {213,20.375833}, {214,20.667722}, {215,20.959944}, {216,21.353056}, {217,21.684889}, {218,21.967278}, {219,22.434222}, {220,22.673222}, {221,23.106500}, {222,23.425889}, {223,23.724278}, {224,24.147389}, {225,24.549389}, {226,24.937167}, {227,25.250056}, {228,25.594389}, {229,26.085222}, {230,26.514889}, {231,26.897500}, {232,27.319556}, {233,27.694000}, {234,28.181500}, {235,28.771444}, {236,29.045278}, {237,29.656444}, {238,30.033889}, {239,30.504833}, {240,30.750000}, {241,31.298611}, {242,31.838278}, {243,32.190278}, {244,32.714278}, {245,33.167611}, {246,33.718722}, {247,34.147222}, {248,34.621556}, {249,35.267611}, {250,35.704167}, {251,36.322389}, {252,36.704333}, {253,37.101833}, {254,37.738111}, {255,38.301333}, {256,38.746722}, {257,39.391167}, {258,39.712889}, {259,40.393889}, {260,40.845000}, {261,41.543222}, {262,42.117556}, {263,42.890389}, {264,43.415889}, {265,44.067111}, {266,44.691389}, {267,45.046833}, {268,45.952389}, {269,46.653111}, {270,47.120444}, {271,47.579833}, {272,48.450500}, {273,48.877167}, {274,49.727278}, {275,50.480778}, {276,50.996111}, {277,51.743667}, {278,52.393056}, {279,53.117278}, {280,54.041056}, {281,54.668333}, {282,55.445889}, {283,56.098667}, {284,57.089833}, {285,57.877889}, {286,58.332444}, {287,59.277167}, {288,59.793000}, {289,60.724444}, {290,61.278889}, {291,62.152000}, {292,62.666333}, {293,63.997556}, {294,64.860222}, {295,65.655333}, {296,66.825444}, {297,67.597556}, {298,68.586667}, {299,69.150889}, {300,69.985111}, {301,78.7820}, {302,78.3040}, {303,76.9180}, {304,77.8815}, {305,81.899}, {306,83.579}, {307,84.9}, {308,86.12}, {309,86.8}, {310,87.627}, {311,88.615}, {312,90.459}, {313,91.356}, {314,93.1}, {315,94.488}, {316,95.228}, {317,96.288}, {318,96.991}, {319,99.144}, {320,100.028}, {321,101.667}, {322,103.543}, {323,104.044}, {324,105.548}, {325,107.023}, {326,108.108}, {327,110.643}, {328,111.379}, {329,112.844}, {330,114.359}, {331,115.211}, {332,117.42}, {333,118.715}, {334,120.492}, {335,121.9}, {336,123.252}, {337,124.351}, {338,126.211}, {339,127.255}, {340,130.14}, {341,131.907}, {342,133.127}, {343,133.408}, {344,135.564}, {345,137.971}, {346,139.043}, {347,140.939}, {348,143.96}, {349,144.752}, {350,146.104}, {351,148.739}, {352,149.82}, {353,151.971}, {354,154.351}, {355,155.451}, {356,156.696}, {357,158.804}, {358,161.367}, {359,163.079}, {360,164.992}, {361,167.235}, {362,168.203}, {363,170.152}, {364,172.1}, {365,174.94}, {366,176.659}, {367,179.067}, {368,181.291}, {369,182.487}, {370,185.1}, {371,186.603}, {372,189.}, {373,191.995}, {374,194.015}, {375,195.412}, {376,197.06}, {377,200.275}, {378,201.992}, {379,204.012}, {380,204.764}, {381,206.236}, {382,208.012}, {383,211.116}, {384,212.884}, {385,216.639}, {386,218.476}, {387,219.404}, {388,223.304}, {389,224.551}, {390,228.316}, {391,229.948}, {392,231.96}, {393,234.728}, {394,237.984}, {395,241.236}, {396,242.46}, {397,245.032}, {398,247.556}, {399,250.292}, {400,254.76}, {401,255.935}, {402,258.479}, {403,260.188}, {404,263.931}, {405,267.416}, {406,268.816}, {407,271.5}, {408,274.112}, {409,276.024}, {410,281.463}, {411,282.416}, {412,285.136}, {413,287.936}, {414,291.644}, {415,294.647}, {416,299.463}, {417,301.095}, {418,303.543}, {419,306.419}, {420,276.743}, {421,260.819}, {422,263.595}, {423,319.775}, {424,321.092}, {425,324.379}, {426,328.804}, {427,332.415}, {428,334.439}, {429,323.86}, {430,334.719}, {431,336.572}, {432,331.548}, {433,335.672}, {434,338.6}, {435,340.296}, {436,353.308}, {437,353.907}, {438,358.736}, {439,363.195}, {440,364.02}, {441,368.167}, {442,371.452}, {443,375.284}, {444,378.948}, {445,382.619}, {446,387.007}, {447,385.768}, {448,394.523}, {449,399.927}, {450,401.872}, {451,405.008}, {452,409.235}};
data["big"]["TypeClasses"]["reif"]["system"] = {{1,0.000000000}, {2,0.000035556}, {3,0.000053333}, {4,0.000017778}, {5,0.000053333}, {6,0.000017778}, {7,0.000053333}, {8,0.000071111}, {9,0.000017778}, {10,0.000053333}, {11,0.000053333}, {12,0.000017778}, {13,0.000013333}, {14,0.000000000}, {15,0.000000000}, {16,0.000017778}, {17,0.000053333}, {18,0.000035556}, {19,0.000035556}, {20,0.000071111}, {21,0.000031111}, {22,0.000053333}, {23,0.000017778}, {24,0.000017778}, {25,0.000017778}, {26,0.000000000}, {27,0.000124444}, {28,0.000120000}, {29,0.000053333}, {30,0.000071111}, {31,0.000017778}, {32,0.000053333}, {33,0.000071111}, {34,0.000053333}, {35,0.000017778}, {36,0.000088889}, {37,0.000066667}, {38,0.000017778}, {39,0.000031111}, {40,0.000048889}, {41,0.000053333}, {42,0.000137778}, {43,0.000088889}, {44,0.000035556}, {45,0.000102222}, {46,0.000124444}, {47,0.000035556}, {48,0.000071111}, {49,0.000088889}, {50,0.000124444}, {51,0.000035556}, {52,0.000053333}, {53,0.000071111}, {54,0.000048889}, {55,0.000071111}, {56,0.000102222}, {57,0.000071111}, {58,0.000088889}, {59,0.000035556}, {60,0.000017778}, {61,0.000071111}, {62,0.000053333}, {63,0.000106667}, {64,0.000048889}, {65,0.000106667}, {66,0.000088889}, {67,0.000048889}, {68,0.000053333}, {69,0.000053333}, {70,0.000124444}, {71,0.000017778}, {72,0.000155556}, {73,0.000275556}, {74,0.000511111}, {75,0.000364444}, {76,0.000195556}, {77,0.000408889}, {78,0.000591111}, {79,0.000160000}, {80,0.000173333}, {81,0.000102222}, {82,0.000124444}, {83,0.000315556}, {84,0.000355556}, {85,0.000115556}, {86,0.001778}, {87,0.000667}, {88,0.000000}, {89,0.000000}, {90,0.000444}, {91,0.000667}, {92,0.000444}, {93,0.000000}, {94,0.002000}, {95,0.001333}, {96,0.000389}, {97,0.000000}, {98,0.001111}, {99,0.000889}, {100,0.000000}, {101,0.000000}, {102,0.000222}, {103,0.000222}, {104,0.000000}, {105,0.000000}, {106,0.000000}, {107,0.000222}, {108,0.000000}, {109,0.000222}, {110,0.000667}, {111,0.000833}, {112,0.000889}, {113,0.000667}, {114,0.000889}, {115,0.000667}, {116,0.000889}, {117,0.000667}, {118,0.000444}, {119,0.000000}, {120,0.000222}, {121,0.000222}, {122,0.000000}, {123,0.000000}, {124,0.000000}, {125,0.000000}, {126,0.000222}, {127,0.000000}, {128,0.000444}, {129,0.000000}, {130,0.000222}, {131,0.000667}, {132,0.000000}, {133,0.000000}, {134,0.000222}, {135,0.000000}, {136,0.000000}, {137,0.000000}, {138,0.000444}, {139,0.000000}, {140,0.000444}, {141,0.000444}, {142,0.000222}, {143,0.000222}, {144,0.000222}, {145,0.000444}, {146,0.000000}, {147,0.000222}, {148,0.000222}, {149,0.000000}, {150,0.000000}, {151,0.000444}, {152,0.000389}, {153,0.000222}, {154,0.000889}, {155,0.000667}, {156,0.001333}, {157,0.000222}, {158,0.000222}, {159,0.000444}, {160,0.000000}, {161,0.000000}, {162,0.000222}, {163,0.000000}, {164,0.000222}, {165,0.001111}, {166,0.000444}, {167,0.000000}, {168,0.000000}, {169,0.000000}, {170,0.000222}, {171,0.000000}, {172,0.000444}, {173,0.000222}, {174,0.000444}, {175,0.000444}, {176,0.001333}, {177,0.002389}, {178,0.000667}, {179,0.002222}, {180,0.004222}, {181,0.001111}, {182,0.001111}, {183,0.000444}, {184,0.000444}, {185,0.000667}, {186,0.000222}, {187,0.000222}, {188,0.001111}, {189,0.000889}, {190,0.001111}, {191,0.000667}, {192,0.000889}, {193,0.000889}, {194,0.001500}, {195,0.000667}, {196,0.001500}, {197,0.002889}, {198,0.001278}, {199,0.001722}, {200,0.002222}, {201,0.000833}, {202,0.001333}, {203,0.000444}, {204,0.001778}, {205,0.000889}, {206,0.000889}, {207,0.001111}, {208,0.001111}, {209,0.001556}, {210,0.001111}, {211,0.002000}, {212,0.000667}, {213,0.004167}, {214,0.002167}, {215,0.002444}, {216,0.004222}, {217,0.002444}, {218,0.002167}, {219,0.001556}, {220,0.001333}, {221,0.001111}, {222,0.001778}, {223,0.001111}, {224,0.003111}, {225,0.001778}, {226,0.001778}, {227,0.002889}, {228,0.002000}, {229,0.002222}, {230,0.002889}, {231,0.002111}, {232,0.003056}, {233,0.002889}, {234,0.001722}, {235,0.002667}, {236,0.003278}, {237,0.002833}, {238,0.003778}, {239,0.002000}, {240,0.003333}, {241,0.003611}, {242,0.003056}, {243,0.003556}, {244,0.002889}, {245,0.003333}, {246,0.002889}, {247,0.002000}, {248,0.001333}, {249,0.002000}, {250,0.003000}, {251,0.001778}, {252,0.005556}, {253,0.002000}, {254,0.002000}, {255,0.005111}, {256,0.004000}, {257,0.005500}, {258,0.002889}, {259,0.004778}, {260,0.002667}, {261,0.004000}, {262,0.004222}, {263,0.002000}, {264,0.006611}, {265,0.004389}, {266,0.005111}, {267,0.005944}, {268,0.007722}, {269,0.004167}, {270,0.006167}, {271,0.005944}, {272,0.002611}, {273,0.007556}, {274,0.005556}, {275,0.004833}, {276,0.004667}, {277,0.005333}, {278,0.003722}, {279,0.005889}, {280,0.008111}, {281,0.007333}, {282,0.006389}, {283,0.004444}, {284,0.011778}, {285,0.010667}, {286,0.008667}, {287,0.010667}, {288,0.009667}, {289,0.006889}, {290,0.009500}, {291,0.009556}, {292,0.008778}, {293,0.010000}, {294,0.009833}, {295,0.013056}, {296,0.015000}, {297,0.011500}, {298,0.015389}, {299,0.010222}, {300,0.013944}, {301,0.0870}, {302,0.0000}, {303,0.0520}, {304,0.0120}, {305,0}, {306,0}, {307,0}, {308,0}, {309,0}, {310,0}, {311,0}, {312,0}, {313,0}, {314,0}, {315,0}, {316,0}, {317,0}, {318,0}, {319,0}, {320,0}, {321,0}, {322,0}, {323,0}, {324,0}, {325,0}, {326,0}, {327,0}, {328,0}, {329,0}, {330,0}, {331,0}, {332,0}, {333,0}, {334,0}, {335,0}, {336,0}, {337,0}, {338,0}, {339,0}, {340,0}, {341,0}, {342,0}, {343,0}, {344,0.004}, {345,0}, {346,0.004}, {347,0}, {348,0}, {349,0}, {350,0}, {351,0}, {352,0}, {353,0}, {354,0}, {355,0}, {356,0}, {357,0}, {358,0.032}, {359,0}, {360,0}, {361,0}, {362,0}, {363,0}, {364,0}, {365,0}, {366,0}, {367,0}, {368,0}, {369,0}, {370,0}, {371,0}, {372,0}, {373,0}, {374,0}, {375,0}, {376,0}, {377,0}, {378,0}, {379,0}, {380,0}, {381,0}, {382,0}, {383,0}, {384,0}, {385,0}, {386,0}, {387,0}, {388,0}, {389,0}, {390,0}, {391,0}, {392,0}, {393,0}, {394,0}, {395,0}, {396,0}, {397,0}, {398,0}, {399,0}, {400,0}, {401,0}, {402,0}, {403,0}, {404,0}, {405,0}, {406,0}, {407,0}, {408,0.012}, {409,0}, {410,0}, {411,0}, {412,0}, {413,0.004}, {414,0}, {415,0}, {416,0}, {417,0}, {418,0}, {419,0}, {420,0}, {421,0}, {422,0}, {423,0}, {424,0}, {425,0}, {426,0}, {427,0}, {428,0.043}, {429,0.06}, {430,0.052}, {431,0.095}, {432,0.043}, {433,0.02}, {434,0}, {435,0}, {436,0.048}, {437,0.044}, {438,0.031}, {439,0}, {440,0}, {441,0}, {442,0}, {443,0}, {444,0}, {445,0}, {446,0}, {447,0.004}, {448,0.095}, {449,0}, {450,0.052}, {451,0.084}, {452,0.079}};
data["big"]["TypeClassesBodyHOAS"]["Aggregate"]["real"] = {{1,0.00102632}, {2,0.00100000}, {3,0.00100000}, {4,0.00100000}, {5,0.00128070}, {6,0.00200000}, {7,0.00200000}, {8,0.00200000}, {9,0.00239474}, {10,0.00300000}, {11,0.00300000}, {12,0.00311404}, {13,0.00356140}, {14,0.00400000}, {15,0.02407895}, {16,0.00409649}, {17,0.00482456}, {18,0.00504386}, {19,0.00526316}, {20,0.00579825}, {21,0.00628947}, {22,0.00645614}, {23,0.00713158}, {24,0.00748246}, {25,0.00766667}, {26,0.00857018}, {27,0.00861404}, {28,0.00949123}, {29,0.00950000}, {30,0.01127193}, {31,0.01047368}, {32,0.01076316}, {33,0.01142105}, {34,0.01196491}, {35,0.01243860}, {36,0.01295614}, {37,0.01356140}, {38,0.01400877}, {39,0.01465789}, {40,0.01480702}, {41,0.01568421}, {42,0.01628070}, {43,0.01728947}, {44,0.01758772}, {45,0.02058772}, {46,0.01880702}, {47,0.01943860}, {48,0.01999123}, {49,0.02030702}, {50,0.02408772}, {51,0.02160526}, {52,0.02220175}, {53,0.02319298}, {54,0.02428947}, {55,0.02733333}, {56,0.02517544}, {57,0.02599123}, {58,0.02657018}, {59,0.03191228}, {60,0.02824561}, {61,0.02913158}, {62,0.03001754}, {63,0.03289474}, {64,0.03137719}, {65,0.03248246}, {66,0.03920175}, {67,0.03364912}, {68,0.03495614}, {69,0.04114035}, {70,0.03626316}, {71,0.03752632}, {72,0.04276316}, {73,0.03911404}, {74,0.03984211}, {75,0.04499123}, {76,0.04195614}, {77,0.05280702}, {78,0.04308772}, {79,0.04445614}, {80,0.04806140}, {81,0.04721930}, {82,0.05517544}, {83,0.04874561}, {84,0.07165789}, {85,0.05058772}, {86,0.05829412}, {87,0.05261765}, {88,0.05924510}, {89,0.05473529}, {90,0.06528431}, {91,0.05650980}, {92,0.06426471}, {93,0.05887255}, {94,0.06535294}, {95,0.06173529}, {96,0.06724510}, {97,0.06436275}, {98,0.06948039}, {99,0.07771569}, {100,0.06765686}, {101,0.07198039}, {102,0.08266667}, {103,0.07078431}, {104,0.07486275}, {105,0.08570588}, {106,0.07455882}, {107,0.07884314}, {108,0.08976471}, {109,0.07876471}, {110,0.08267647}, {111,0.09145098}, {112,0.09569608}, {113,0.08403922}, {114,0.08809804}, {115,0.09728431}, {116,0.10067647}, {117,0.10246078}, {118,0.09124510}, {119,0.09486275}, {120,0.10759804}, {121,0.10827451}, {122,0.11213725}, {123,0.11289216}, {124,0.11543137}, {125,0.11644118}, {126,0.11413725}, {127,0.10477451}, {128,0.11496078}, {129,0.11760784}, {130,0.11986275}, {131,0.12071569}, {132,0.12224510}, {133,0.12467647}, {134,0.12616667}, {135,0.13876471}, {136,0.13215686}, {137,0.13138235}, {138,0.13211765}, {139,0.13405882}, {140,0.13578431}, {141,0.18681373}, {142,0.14458824}, {143,0.23769608}, {144,0.15188235}, {145,0.14824510}, {146,0.15006863}, {147,0.15032353}, {148,0.16181373}, {149,0.15106863}, {150,0.15196078}, {151,0.15445098}, {152,0.16872549}, {153,0.15665686}, {154,0.15908824}, {155,0.17229412}, {156,0.16442157}, {157,0.16561765}, {158,0.18564706}, {159,0.17274510}, {160,0.19141176}, {161,0.17570588}, {162,0.19109804}, {163,0.17733333}, {164,0.19298039}, {165,0.17994118}, {166,0.19627451}, {167,0.18466667}, {168,0.19890196}, {169,0.18847059}, {170,0.20446078}, {171,0.21203922}, {172,0.19850000}, {173,0.21602941}, {174,0.21553922}, {175,0.20153922}, {176,0.21734314}, {177,0.21936275}, {178,0.20787255}, {179,0.22292157}, {180,0.22313725}, {181,0.22556863}, {182,0.23278431}, {183,0.21837255}, {184,0.23926471}, {185,0.24148039}, {186,0.24468627}, {187,0.24216667}, {188,0.24445098}, {189,0.24361765}, {190,0.24677451}, {191,0.24835294}, {192,0.24999020}, {193,0.25573529}, {194,0.25867647}, {195,0.26584314}, {196,0.26430392}, {197,0.26661765}, {198,0.26607843}, {199,0.26793137}, {200,0.28125490}, {201,0.27141176}, {202,0.27265686}, {203,0.27962745}, {204,0.29732353}, {205,0.29133333}, {206,0.29135294}, {207,0.28920588}, {208,0.30761765}, {209,0.28979412}, {210,0.29332353}, {211,0.30965686}, {212,0.30137255}, {213,0.31843137}, {214,0.30769608}, {215,0.32850000}, {216,0.31595098}, {217,0.32769608}, {218,0.31670588}, {219,0.33281373}, {220,0.31966667}, {221,0.33961765}, {222,0.34153922}, {223,0.33608824}, {224,0.35434314}, {225,0.34929412}, {226,0.33703922}, {227,0.35141176}, {228,0.35731373}, {229,0.36350980}, {230,0.35234314}, {231,0.36910784}, {232,0.37065686}, {233,0.37557843}, {234,0.37314706}, {235,0.37601961}, {236,0.38520588}, {237,0.38300980}, {238,0.38731373}, {239,0.38809804}, {240,0.39535294}, {241,0.39569608}, {242,0.39578431}, {243,0.40069608}, {244,0.40724510}, {245,0.41205882}, {246,0.42102941}, {247,0.41838235}, {248,0.41632353}, {249,0.41637255}, {250,0.46808824}, {251,0.43459804}, {252,0.43245098}, {253,0.44179412}, {254,0.43666667}, {255,0.44071569}, {256,0.45693137}, {257,0.45685294}, {258,0.46172549}, {259,0.45580392}, {260,0.46184314}, {261,0.47123529}, {262,0.47080392}, {263,0.47888235}, {264,0.48000000}, {265,0.48209804}, {266,0.48744118}, {267,0.49500980}, {268,0.49287255}, {269,0.50322549}, {270,0.50227451}, {271,0.50154902}, {272,0.51324510}, {273,0.51679412}, {274,0.51983333}, {275,0.52528431}, {276,0.52400980}, {277,0.53187255}, {278,0.53868627}, {279,0.53725490}, {280,0.54900000}, {281,0.54765686}, {282,0.55231373}, {283,0.55950000}, {284,0.55505882}, {285,0.56818627}, {286,0.57037255}, {287,0.56775490}, {288,0.58237255}, {289,0.57845098}, {290,0.58818627}, {291,0.58952941}, {292,0.58952941}, {293,0.60282353}, {294,0.59789216}, {295,0.61410784}, {296,0.61517647}, {297,0.61287255}, {298,0.62695098}, {299,0.62180392}, {300,0.63562745}, {301,0.63081188}, {302,0.63535644}, {303,0.64524752}, {304,0.64506931}, {305,0.65678218}, {306,0.65176238}, {307,0.66534653}, {308,0.66170297}, {309,0.67274257}, {310,0.67186139}, {311,0.67586139}, {312,0.68585149}, {313,0.69054455}, {314,0.69600990}, {315,0.69591089}, {316,0.70662376}, {317,0.70859406}, {318,0.71525743}, {319,0.71100000}, {320,0.72511881}, {321,0.72502970}, {322,0.73581188}, {323,0.73280198}, {324,0.74680198}, {325,0.74150495}, {326,0.76437624}, {327,0.75701980}, {328,0.76545545}, {329,0.76163366}, {330,0.77205941}, {331,0.77449505}, {332,0.78737624}, {333,0.78343564}, {334,0.79449505}, {335,0.79301980}, {336,0.80452475}, {337,0.80413861}, {338,0.81042574}, {339,0.81333663}, {340,0.82065347}, {341,0.82808911}, {342,0.83104950}, {343,0.83593069}, {344,0.84413861}, {345,0.84840594}, {346,0.85018812}, {347,0.85576238}, {348,0.86618812}, {349,0.87454455}, {350,0.87626733}, {351,0.87570297}, {352,0.88877228}, {353,0.89037624}, {354,0.89462376}, {355,0.90391089}, {356,0.90874257}, {357,0.95407921}, {358,0.90954455}, {359,0.97785149}, {360,0.92876238}, {361,0.93426733}, {362,0.94073267}, {363,0.94882178}, {364,0.94963366}, {365,0.95165347}, {366,0.97039604}, {367,0.96993069}, {368,0.96792079}, {369,0.98758416}, {370,0.98287129}, {371,0.99074257}, {372,0.99644554}, {373,1.00050495}, {374,1.00858416}, {375,1.00969307}, {376,1.017077}, {377,1.002077}, {378,1.011077}, {379,1.016385}, {380,1.012000}, {381,1.035538}, {382,1.036154}, {383,1.152692}, {384,1.048846}, {385,1.047231}, {386,1.179154}, {387,1.193385}, {388,1.072462}, {389,1.070692}, {390,1.077846}, {391,1.084538}, {392,1.095462}, {393,1.096308}, {394,1.100846}, {395,1.103077}, {396,1.109077}, {397,1.120462}, {398,1.125154}, {399,1.135385}, {400,1.132000}, {401,1.212615}, {402,1.156615}, {403,1.159000}, {404,1.162923}, {405,1.171231}, {406,1.177538}, {407,1.186615}, {408,1.188846}, {409,1.201154}, {410,1.201000}, {411,1.216462}, {412,1.217615}, {413,1.222538}, {414,1.227462}, {415,1.230308}, {416,1.244462}, {417,1.241538}, {418,1.258000}, {419,1.254846}, {420,1.272846}, {421,1.270846}, {422,1.276846}, {423,1.281308}, {424,1.297231}, {425,1.297615}, {426,1.314077}, {427,1.310692}, {428,1.336385}, {429,1.324538}, {430,1.329769}, {431,1.342692}, {432,1.365308}, {433,1.362308}, {434,1.363692}, {435,1.368769}, {436,1.394462}, {437,1.385615}, {438,1.394769}, {439,1.404462}, {440,1.418077}, {441,1.410846}, {442,1.420000}, {443,1.433231}, {444,1.448615}, {445,1.441615}, {446,1.452308}, {447,1.461308}, {448,1.486154}, {449,1.465231}, {450,1.479000}, {451,1.499000}, {452,1.507154}, {453,1.492000}, {454,1.510154}, {455,1.527231}, {456,1.522923}, {457,1.530846}, {458,1.542615}, {459,1.558385}, {460,1.552769}, {461,1.553538}, {462,1.577308}, {463,1.582000}, {464,1.580154}, {465,1.594769}, {466,1.612154}, {467,1.616769}, {468,1.607154}, {469,1.625692}, {470,1.637308}, {471,1.633692}, {472,1.642308}, {473,1.672077}, {474,1.670692}, {475,1.669615}, {476,1.684923}, {477,1.693615}, {478,1.694923}, {479,1.703923}, {480,1.716154}, {481,1.722154}, {482,1.725538}, {483,1.739231}, {484,1.745385}, {485,1.752769}, {486,1.764769}, {487,1.769000}, {488,1.795385}, {489,1.853077}, {490,1.803769}, {491,1.812308}, {492,1.820077}, {493,1.821462}, {494,1.836385}, {495,1.850000}, {496,1.839846}, {497,1.866077}, {498,1.875846}, {499,1.870077}, {500,1.881308}, {505,1.933692}, {510,1.964692}, {515,2.016154}, {520,2.069308}, {525,2.110231}, {530,2.150923}, {535,2.203923}, {540,2.238385}, {545,2.380538}, {550,2.326692}, {555,2.383538}, {560,2.449462}, {565,2.475846}, {570,2.529231}, {575,2.571385}, {580,2.694923}, {585,2.749462}, {590,2.721769}, {595,2.787385}, {600,2.852154}, {605,2.897769}, {610,2.945846}, {615,3.019385}, {620,3.055231}, {625,3.131538}, {630,3.221154}, {635,3.301308}, {640,3.533154}, {645,3.340846}, {650,3.384769}, {655,3.524615}, {660,3.506846}, {665,3.569692}, {670,3.624846}, {675,3.777385}, {680,3.757538}, {685,3.829231}, {690,3.974923}, {695,3.964846}, {700,4.178769}, {705,4.085692}, {710,4.163385}, {715,4.229000}, {720,4.388077}, {725,4.327923}, {730,4.485615}, {735,4.534000}, {740,4.559308}, {745,4.710923}, {750,4.679154}, {755,4.785615}, {760,4.849462}, {765,4.924538}, {770,5.002154}, {775,5.141308}, {780,5.154615}, {785,5.311077}, {790,5.429462}, {795,5.603692}, {800,5.645615}, {805,5.822308}, {810,5.907615}, {815,5.822231}, {820,6.143231}, {825,6.240769}, {830,6.166231}, {835,6.452692}, {840,6.286923}, {845,6.723154}, {850,6.615077}, {855,6.616385}, {860,6.892846}, {865,6.795154}, {870,7.055538}, {875,7.434923}, {880,7.247077}, {885,7.100231}, {890,7.369923}, {895,7.492923}, {900,7.661154}, {905,7.602385}, {910,7.695077}, {915,8.065769}, {920,7.926923}, {925,8.122769}, {930,8.294154}, {935,8.337462}, {940,8.445231}, {945,8.615000}, {950,8.821154}, {955,8.857154}, {960,8.895385}, {965,9.089846}, {970,9.539538}, {975,9.326846}, {980,9.434462}, {985,9.478769}, {990,9.873462}, {995,9.793538}, {1000,9.835154}, {1010,10.080538}, {1020,10.521154}, {1030,10.921769}, {1040,10.991154}, {1050,11.137615}, {1060,11.738769}, {1070,11.937538}, {1080,12.086308}, {1090,12.720538}, {1100,12.826923}, {1110,13.041846}, {1120,13.291923}, {1130,13.596385}, {1140,14.107000}, {1150,14.513000}, {1160,14.765385}, {1170,15.151462}, {1180,15.093385}, {1190,15.710769}, {1200,16.270308}, {1210,16.390077}, {1220,16.603154}, {1230,17.149923}, {1240,17.074846}, {1250,18.132308}, {1260,18.021231}, {1270,18.327846}, {1280,18.790154}, {1290,19.324385}, {1300,19.828769}, {1310,20.199231}, {1320,20.144000}, {1330,20.836231}, {1340,21.370615}, {1350,22.410538}, {1360,22.281000}, {1370,22.565923}, {1380,23.207615}, {1390,23.657846}, {1400,24.706846}, {1410,24.612769}, {1420,24.890308}, {1430,25.493308}, {1440,26.133077}, {1450,26.212692}, {1460,26.694385}, {1470,27.698154}, {1480,27.493846}, {1490,28.553462}, {1500,28.941000}, {1510,29.568308}, {1520,29.861692}, {1530,30.667769}, {1540,30.934000}, {1550,31.515538}, {1560,32.386462}, {1570,33.161308}, {1580,32.961538}, {1590,33.871846}, {1600,34.875538}, {1610,35.779923}, {1620,36.070846}, {1630,35.835923}, {1640,36.712615}, {1650,37.695692}, {1660,37.990231}, {1670,39.224462}, {1680,39.204077}, {1690,40.139846}, {1700,39.985846}, {1710,41.699923}, {1720,42.442231}, {1730,42.485000}, {1740,42.769231}, {1750,44.701462}, {1760,44.756385}, {1770,45.368846}, {1780,45.803462}, {1790,46.998692}, {1800,47.424538}, {1810,48.921462}, {1820,49.092000}, {1830,49.561077}, {1840,50.465154}, {1850,50.572308}, {1860,51.558231}, {1870,52.459769}, {1880,52.626692}, {1890,53.490000}, {1900,54.260692}, {1910,54.708154}, {1920,56.009308}, {1930,56.494923}, {1940,57.987692}, {1950,58.222385}, {1960,59.103692}, {1970,60.179615}, {1980,60.218615}, {1990,61.981846}, {2000,62.388385}};
data["big"]["TypeClassesBodyHOAS"]["Aggregate"]["user"] = {{1,0.00127193}, {2,0.00107018}, {3,0.00162281}, {4,0.00153509}, {5,0.00195614}, {6,0.00182456}, {7,0.00232456}, {8,0.00257895}, {9,0.00258772}, {10,0.00269298}, {11,0.00313158}, {12,0.00353509}, {13,0.00387719}, {14,0.00408772}, {15,0.02430702}, {16,0.00452632}, {17,0.00469298}, {18,0.00532456}, {19,0.00553509}, {20,0.00612281}, {21,0.00661404}, {22,0.00644737}, {23,0.00692982}, {24,0.00772807}, {25,0.00781579}, {26,0.00864912}, {27,0.00871053}, {28,0.00943860}, {29,0.00953509}, {30,0.01122807}, {31,0.01078070}, {32,0.01044737}, {33,0.01157018}, {34,0.01185965}, {35,0.01241228}, {36,0.01274561}, {37,0.01335965}, {38,0.01372807}, {39,0.01438596}, {40,0.01457895}, {41,0.01529825}, {42,0.01575439}, {43,0.01710526}, {44,0.01703509}, {45,0.02044737}, {46,0.01824561}, {47,0.01928070}, {48,0.01987719}, {49,0.02001754}, {50,0.02413158}, {51,0.02151754}, {52,0.02257895}, {53,0.02343860}, {54,0.02441228}, {55,0.02771930}, {56,0.02532456}, {57,0.02595614}, {58,0.02689474}, {59,0.03165789}, {60,0.02828947}, {61,0.02942982}, {62,0.03000000}, {63,0.03309649}, {64,0.03148246}, {65,0.03253509}, {66,0.03895614}, {67,0.03342105}, {68,0.03519298}, {69,0.04115789}, {70,0.03621930}, {71,0.03743860}, {72,0.04271053}, {73,0.03870175}, {74,0.03937719}, {75,0.04494737}, {76,0.04162281}, {77,0.05311404}, {78,0.04280702}, {79,0.04423684}, {80,0.04790351}, {81,0.04702632}, {82,0.05511404}, {83,0.04882456}, {84,0.07148246}, {85,0.05084211}, {86,0.05865686}, {87,0.05292157}, {88,0.05916667}, {89,0.05469608}, {90,0.06505882}, {91,0.05623529}, {92,0.06376471}, {93,0.05868627}, {94,0.06489216}, {95,0.06174510}, {96,0.06700000}, {97,0.06391176}, {98,0.06940196}, {99,0.07776471}, {100,0.06727451}, {101,0.07206863}, {102,0.08239216}, {103,0.07069608}, {104,0.07477451}, {105,0.08558824}, {106,0.07501961}, {107,0.07892157}, {108,0.08941176}, {109,0.07883333}, {110,0.08241176}, {111,0.09117647}, {112,0.09576471}, {113,0.08426471}, {114,0.08745098}, {115,0.09719608}, {116,0.10043137}, {117,0.10228431}, {118,0.09070588}, {119,0.09474510}, {120,0.10744118}, {121,0.10800980}, {122,0.11161765}, {123,0.11258824}, {124,0.11519608}, {125,0.11592157}, {126,0.11350980}, {127,0.10481373}, {128,0.11449020}, {129,0.11724510}, {130,0.11964706}, {131,0.12043137}, {132,0.12187255}, {133,0.12437255}, {134,0.12562745}, {135,0.13758824}, {136,0.13118627}, {137,0.13102941}, {138,0.13133333}, {139,0.13324510}, {140,0.13533333}, {141,0.18597059}, {142,0.14421569}, {143,0.23750000}, {144,0.15163725}, {145,0.14806863}, {146,0.14968627}, {147,0.14996078}, {148,0.16179412}, {149,0.15111765}, {150,0.15171569}, {151,0.15429412}, {152,0.16843137}, {153,0.15631373}, {154,0.15845098}, {155,0.17156863}, {156,0.16396078}, {157,0.16496078}, {158,0.18501961}, {159,0.17248039}, {160,0.19125490}, {161,0.17556863}, {162,0.19051961}, {163,0.17721569}, {164,0.19238235}, {165,0.17944118}, {166,0.19584314}, {167,0.18435294}, {168,0.19889216}, {169,0.18824510}, {170,0.20385294}, {171,0.21154902}, {172,0.19827451}, {173,0.21568627}, {174,0.21530392}, {175,0.20138235}, {176,0.21677451}, {177,0.21906863}, {178,0.20739216}, {179,0.22237255}, {180,0.22291176}, {181,0.22509804}, {182,0.23238235}, {183,0.21794118}, {184,0.23881373}, {185,0.24106863}, {186,0.24393137}, {187,0.24165686}, {188,0.24406863}, {189,0.24350000}, {190,0.24604902}, {191,0.24769608}, {192,0.24921569}, {193,0.25514706}, {194,0.25780392}, {195,0.26568627}, {196,0.26381373}, {197,0.26616667}, {198,0.26583333}, {199,0.26746078}, {200,0.28072549}, {201,0.27084314}, {202,0.27239216}, {203,0.27893137}, {204,0.29663725}, {205,0.29086275}, {206,0.29078431}, {207,0.28863725}, {208,0.30712745}, {209,0.28934314}, {210,0.29272549}, {211,0.30923529}, {212,0.30071569}, {213,0.31818627}, {214,0.30687255}, {215,0.32812745}, {216,0.31554902}, {217,0.32724510}, {218,0.31640196}, {219,0.33216667}, {220,0.31932353}, {221,0.33893137}, {222,0.34088235}, {223,0.33503922}, {224,0.35359804}, {225,0.34870588}, {226,0.33666667}, {227,0.35055882}, {228,0.35701961}, {229,0.36288235}, {230,0.35144118}, {231,0.36842157}, {232,0.36980392}, {233,0.37448039}, {234,0.37225490}, {235,0.37505882}, {236,0.38452941}, {237,0.38222549}, {238,0.38643137}, {239,0.38749020}, {240,0.39464706}, {241,0.39500980}, {242,0.39494118}, {243,0.39986275}, {244,0.40661765}, {245,0.41141176}, {246,0.42020588}, {247,0.41780392}, {248,0.41543137}, {249,0.41524510}, {250,0.46716667}, {251,0.43360784}, {252,0.43197059}, {253,0.44122549}, {254,0.43591176}, {255,0.43961765}, {256,0.45612745}, {257,0.45647059}, {258,0.46077451}, {259,0.45498039}, {260,0.46089216}, {261,0.47051961}, {262,0.47017647}, {263,0.47787255}, {264,0.47929412}, {265,0.48121569}, {266,0.48625490}, {267,0.49415686}, {268,0.49209804}, {269,0.50225490}, {270,0.50141176}, {271,0.50081373}, {272,0.51248039}, {273,0.51606863}, {274,0.51899020}, {275,0.52442157}, {276,0.52314706}, {277,0.53088235}, {278,0.53736275}, {279,0.53649020}, {280,0.54818627}, {281,0.54701961}, {282,0.55127451}, {283,0.55854902}, {284,0.55415686}, {285,0.56697059}, {286,0.56944118}, {287,0.56671569}, {288,0.58146078}, {289,0.57734314}, {290,0.58769608}, {291,0.58878431}, {292,0.58882353}, {293,0.60175490}, {294,0.59716667}, {295,0.61329412}, {296,0.61426471}, {297,0.61211765}, {298,0.62625490}, {299,0.62054902}, {300,0.63488235}, {301,0.62974257}, {302,0.63400000}, {303,0.64442574}, {304,0.64398020}, {305,0.65580198}, {306,0.65049505}, {307,0.66416832}, {308,0.66042574}, {309,0.67192079}, {310,0.67065347}, {311,0.67479208}, {312,0.68461386}, {313,0.68953465}, {314,0.69496040}, {315,0.69460396}, {316,0.70533663}, {317,0.70754455}, {318,0.71389109}, {319,0.71002970}, {320,0.72391089}, {321,0.72396040}, {322,0.73477228}, {323,0.73198020}, {324,0.74590099}, {325,0.74047525}, {326,0.76341584}, {327,0.75593069}, {328,0.76442574}, {329,0.76034653}, {330,0.77076238}, {331,0.77301980}, {332,0.78637624}, {333,0.78193069}, {334,0.79265347}, {335,0.79136634}, {336,0.80310891}, {337,0.80258416}, {338,0.80886139}, {339,0.81154455}, {340,0.81871287}, {341,0.82683168}, {342,0.82952475}, {343,0.83425743}, {344,0.84280198}, {345,0.84700990}, {346,0.84857426}, {347,0.85436634}, {348,0.86433663}, {349,0.87281188}, {350,0.87442574}, {351,0.87447525}, {352,0.88739604}, {353,0.88883168}, {354,0.89310891}, {355,0.90240594}, {356,0.90708911}, {357,0.95224752}, {358,0.90783168}, {359,0.97604950}, {360,0.92713861}, {361,0.93270297}, {362,0.93921782}, {363,0.94720792}, {364,0.94747525}, {365,0.94986139}, {366,0.96848515}, {367,0.96803960}, {368,0.96642574}, {369,0.98644554}, {370,0.98128713}, {371,0.98911881}, {372,0.99476238}, {373,0.99852475}, {374,1.00667327}, {375,1.00822772}, {376,1.016769}, {377,1.001000}, {378,1.011308}, {379,1.015769}, {380,1.010692}, {381,1.032846}, {382,1.033385}, {383,1.150692}, {384,1.048154}, {385,1.046462}, {386,1.178923}, {387,1.192923}, {388,1.071385}, {389,1.070231}, {390,1.076923}, {391,1.083769}, {392,1.094462}, {393,1.095154}, {394,1.099923}, {395,1.102385}, {396,1.108462}, {397,1.120154}, {398,1.124231}, {399,1.135615}, {400,1.130538}, {401,1.211923}, {402,1.156308}, {403,1.157846}, {404,1.163615}, {405,1.170462}, {406,1.177692}, {407,1.185308}, {408,1.188308}, {409,1.201923}, {410,1.200769}, {411,1.214462}, {412,1.216923}, {413,1.221538}, {414,1.226462}, {415,1.230154}, {416,1.244385}, {417,1.240385}, {418,1.256692}, {419,1.253923}, {420,1.272385}, {421,1.270615}, {422,1.276923}, {423,1.280231}, {424,1.295923}, {425,1.298231}, {426,1.312769}, {427,1.309846}, {428,1.336462}, {429,1.323538}, {430,1.328538}, {431,1.342538}, {432,1.363769}, {433,1.361000}, {434,1.363538}, {435,1.367308}, {436,1.394308}, {437,1.386000}, {438,1.394154}, {439,1.402692}, {440,1.417000}, {441,1.410077}, {442,1.419615}, {443,1.431846}, {444,1.447538}, {445,1.440692}, {446,1.451538}, {447,1.460000}, {448,1.484923}, {449,1.464769}, {450,1.479077}, {451,1.498231}, {452,1.506231}, {453,1.490615}, {454,1.509615}, {455,1.526385}, {456,1.522462}, {457,1.530077}, {458,1.542385}, {459,1.558000}, {460,1.552385}, {461,1.553385}, {462,1.577462}, {463,1.581692}, {464,1.580154}, {465,1.593692}, {466,1.611769}, {467,1.616154}, {468,1.606846}, {469,1.623462}, {470,1.637000}, {471,1.633308}, {472,1.641077}, {473,1.670538}, {474,1.669000}, {475,1.668923}, {476,1.682769}, {477,1.691231}, {478,1.694077}, {479,1.702385}, {480,1.714846}, {481,1.720692}, {482,1.724077}, {483,1.737308}, {484,1.743615}, {485,1.751231}, {486,1.763615}, {487,1.767077}, {488,1.793846}, {489,1.851615}, {490,1.801923}, {491,1.809538}, {492,1.818615}, {493,1.819923}, {494,1.834231}, {495,1.848462}, {496,1.839154}, {497,1.864846}, {498,1.874692}, {499,1.868923}, {500,1.879923}, {505,1.933538}, {510,1.962615}, {515,2.014692}, {520,2.067923}, {525,2.107077}, {530,2.149385}, {535,2.202923}, {540,2.236308}, {545,2.378769}, {550,2.324308}, {555,2.381462}, {560,2.447769}, {565,2.474692}, {570,2.527308}, {575,2.568769}, {580,2.693154}, {585,2.748308}, {590,2.721154}, {595,2.786154}, {600,2.851077}, {605,2.895538}, {610,2.943000}, {615,3.017923}, {620,3.052308}, {625,3.130308}, {630,3.221077}, {635,3.300385}, {640,3.531385}, {645,3.336692}, {650,3.382308}, {655,3.522923}, {660,3.503462}, {665,3.565923}, {670,3.622615}, {675,3.775615}, {680,3.755000}, {685,3.828000}, {690,3.973308}, {695,3.960154}, {700,4.176077}, {705,4.083154}, {710,4.160923}, {715,4.226231}, {720,4.385385}, {725,4.326000}, {730,4.481000}, {735,4.532385}, {740,4.556538}, {745,4.706077}, {750,4.675308}, {755,4.781000}, {760,4.846462}, {765,4.921077}, {770,4.999923}, {775,5.138923}, {780,5.151846}, {785,5.309231}, {790,5.427077}, {795,5.600077}, {800,5.642385}, {805,5.817308}, {810,5.904923}, {815,5.819077}, {820,6.139538}, {825,6.236154}, {830,6.163385}, {835,6.447308}, {840,6.281615}, {845,6.715692}, {850,6.607385}, {855,6.613308}, {860,6.889769}, {865,6.790231}, {870,7.051077}, {875,7.429615}, {880,7.243000}, {885,7.095308}, {890,7.363462}, {895,7.487462}, {900,7.656000}, {905,7.597308}, {910,7.690692}, {915,8.059769}, {920,7.921923}, {925,8.114462}, {930,8.289923}, {935,8.333692}, {940,8.440231}, {945,8.610154}, {950,8.814308}, {955,8.847538}, {960,8.880923}, {965,9.081077}, {970,9.532154}, {975,9.319385}, {980,9.424385}, {985,9.471000}, {990,9.866154}, {995,9.788538}, {1000,9.827923}, {1010,10.068769}, {1020,10.514923}, {1030,10.914154}, {1040,10.973769}, {1050,11.122308}, {1060,11.724462}, {1070,11.922231}, {1080,12.069538}, {1090,12.707538}, {1100,12.808615}, {1110,13.028615}, {1120,13.275077}, {1130,13.580769}, {1140,14.092538}, {1150,14.495923}, {1160,14.756154}, {1170,15.138846}, {1180,15.082154}, {1190,15.698615}, {1200,16.259769}, {1210,16.381692}, {1220,16.587231}, {1230,17.136769}, {1240,17.065846}, {1250,18.123923}, {1260,18.012385}, {1270,18.317231}, {1280,18.778769}, {1290,19.312462}, {1300,19.818538}, {1310,20.187615}, {1320,20.131769}, {1330,20.820769}, {1340,21.359538}, {1350,22.407538}, {1360,22.275692}, {1370,22.557385}, {1380,23.194308}, {1390,23.647077}, {1400,24.693385}, {1410,24.601923}, {1420,24.875923}, {1430,25.473769}, {1440,26.115231}, {1450,26.194462}, {1460,26.672769}, {1470,27.669385}, {1480,27.468462}, {1490,28.533231}, {1500,28.918000}, {1510,29.546077}, {1520,29.834154}, {1530,30.644462}, {1540,30.908615}, {1550,31.486538}, {1560,32.352923}, {1570,33.133923}, {1580,32.925846}, {1590,33.834077}, {1600,34.833769}, {1610,35.737769}, {1620,36.034231}, {1630,35.785692}, {1640,36.663615}, {1650,37.637308}, {1660,37.917462}, {1670,39.149462}, {1680,39.133462}, {1690,40.061154}, {1700,39.929231}, {1710,41.637154}, {1720,42.377615}, {1730,42.418077}, {1740,42.692462}, {1750,44.636231}, {1760,44.688462}, {1770,45.320923}, {1780,45.724308}, {1790,46.947769}, {1800,47.368769}, {1810,48.868923}, {1820,49.045385}, {1830,49.504923}, {1840,50.404769}, {1850,50.523000}, {1860,51.499846}, {1870,52.406308}, {1880,52.570846}, {1890,53.430769}, {1900,54.205154}, {1910,54.641154}, {1920,55.948615}, {1930,56.417462}, {1940,57.928308}, {1950,58.143231}, {1960,59.034769}, {1970,60.090000}, {1980,60.111769}, {1990,61.887231}, {2000,62.275231}};
data["big"]["TypeClassesBodyHOAS"]["Aggregate"]["system"] = {{1,0.00000000}, {2,0.00003509}, {3,0.00007018}, {4,0.00000000}, {5,0.00002632}, {6,0.00003509}, {7,0.00000000}, {8,0.00003509}, {9,0.00003509}, {10,0.00003509}, {11,0.00000000}, {12,0.00003509}, {13,0.00007018}, {14,0.00010526}, {15,0.00000000}, {16,0.00010526}, {17,0.00010526}, {18,0.00003509}, {19,0.00000000}, {20,0.00000000}, {21,0.00007018}, {22,0.00006140}, {23,0.00003509}, {24,0.00003509}, {25,0.00010526}, {26,0.00000000}, {27,0.00003509}, {28,0.00000000}, {29,0.00006140}, {30,0.00003509}, {31,0.00000000}, {32,0.00010526}, {33,0.00003509}, {34,0.00000000}, {35,0.00014035}, {36,0.00000000}, {37,0.00017544}, {38,0.00007018}, {39,0.00003509}, {40,0.00000000}, {41,0.00007018}, {42,0.00003509}, {43,0.00003509}, {44,0.00003509}, {45,0.00000000}, {46,0.00007018}, {47,0.00003509}, {48,0.00000000}, {49,0.00006140}, {50,0.00010526}, {51,0.00007018}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00010526}, {57,0.00014035}, {58,0.00000000}, {59,0.00003509}, {60,0.00000000}, {61,0.00000000}, {62,0.00003509}, {63,0.00007018}, {64,0.00003509}, {65,0.00003509}, {66,0.00007018}, {67,0.00009649}, {68,0.00010526}, {69,0.00000000}, {70,0.00000000}, {71,0.00014035}, {72,0.00000000}, {73,0.00000000}, {74,0.00010526}, {75,0.00010526}, {76,0.00003509}, {77,0.00007018}, {78,0.00007018}, {79,0.00007018}, {80,0.00014035}, {81,0.00003509}, {82,0.00014035}, {83,0.00007018}, {84,0.00010526}, {85,0.00003509}, {86,0.00003922}, {87,0.00003922}, {88,0.00003922}, {89,0.00007843}, {90,0.00000000}, {91,0.00007843}, {92,0.00011765}, {93,0.00000000}, {94,0.00011765}, {95,0.00003922}, {96,0.00003922}, {97,0.00000000}, {98,0.00003922}, {99,0.00000000}, {100,0.00019608}, {101,0.00007843}, {102,0.00007843}, {103,0.00007843}, {104,0.00003922}, {105,0.00000000}, {106,0.00000000}, {107,0.00011765}, {108,0.00000000}, {109,0.00006863}, {110,0.00003922}, {111,0.00000000}, {112,0.00003922}, {113,0.00000000}, {114,0.00007843}, {115,0.00011765}, {116,0.00010784}, {117,0.00000000}, {118,0.00011765}, {119,0.00000000}, {120,0.00007843}, {121,0.00000000}, {122,0.00007843}, {123,0.00015686}, {124,0.00000000}, {125,0.00029412}, {126,0.00010784}, {127,0.00007843}, {128,0.00011765}, {129,0.00019608}, {130,0.00018627}, {131,0.00019608}, {132,0.00031373}, {133,0.00023529}, {134,0.00019608}, {135,0.00089216}, {136,0.00053922}, {137,0.00037255}, {138,0.00042157}, {139,0.00027451}, {140,0.00023529}, {141,0.00011765}, {142,0.00003922}, {143,0.00007843}, {144,0.00003922}, {145,0.00003922}, {146,0.00003922}, {147,0.00019608}, {148,0.00003922}, {149,0.00019608}, {150,0.00007843}, {151,0.00007843}, {152,0.00010784}, {153,0.00007843}, {154,0.00003922}, {155,0.00011765}, {156,0.00015686}, {157,0.00007843}, {158,0.00011765}, {159,0.00003922}, {160,0.00000000}, {161,0.00003922}, {162,0.00003922}, {163,0.00000000}, {164,0.00007843}, {165,0.00014706}, {166,0.00011765}, {167,0.00010784}, {168,0.00015686}, {169,0.00000000}, {170,0.00003922}, {171,0.00011765}, {172,0.00003922}, {173,0.00003922}, {174,0.00011765}, {175,0.00003922}, {176,0.00007843}, {177,0.00007843}, {178,0.00000000}, {179,0.00007843}, {180,0.00000000}, {181,0.00003922}, {182,0.00015686}, {183,0.00000000}, {184,0.00007843}, {185,0.00007843}, {186,0.00007843}, {187,0.00019608}, {188,0.00000000}, {189,0.00006863}, {190,0.00015686}, {191,0.00018627}, {192,0.00034314}, {193,0.00019608}, {194,0.00035294}, {195,0.00011765}, {196,0.00015686}, {197,0.00011765}, {198,0.00003922}, {199,0.00015686}, {200,0.00006863}, {201,0.00003922}, {202,0.00003922}, {203,0.00019608}, {204,0.00011765}, {205,0.00000000}, {206,0.00011765}, {207,0.00007843}, {208,0.00007843}, {209,0.00007843}, {210,0.00011765}, {211,0.00003922}, {212,0.00003922}, {213,0.00003922}, {214,0.00011765}, {215,0.00007843}, {216,0.00007843}, {217,0.00000000}, {218,0.00000000}, {219,0.00003922}, {220,0.00007843}, {221,0.00015686}, {222,0.00011765}, {223,0.00003922}, {224,0.00011765}, {225,0.00011765}, {226,0.00000000}, {227,0.00019608}, {228,0.00011765}, {229,0.00002941}, {230,0.00003922}, {231,0.00000000}, {232,0.00011765}, {233,0.00047059}, {234,0.00032353}, {235,0.00027451}, {236,0.00019608}, {237,0.00007843}, {238,0.00003922}, {239,0.00000000}, {240,0.00015686}, {241,0.00006863}, {242,0.00006863}, {243,0.00018627}, {244,0.00014706}, {245,0.00000000}, {246,0.00000000}, {247,0.00003922}, {248,0.00019608}, {249,0.00010784}, {250,0.00023529}, {251,0.00007843}, {252,0.00007843}, {253,0.00011765}, {254,0.00002941}, {255,0.00011765}, {256,0.00015686}, {257,0.00003922}, {258,0.00000000}, {259,0.00007843}, {260,0.00007843}, {261,0.00011765}, {262,0.00003922}, {263,0.00015686}, {264,0.00002941}, {265,0.00011765}, {266,0.00023529}, {267,0.00031373}, {268,0.00034314}, {269,0.00015686}, {270,0.00019608}, {271,0.00011765}, {272,0.00019608}, {273,0.00003922}, {274,0.00015686}, {275,0.00019608}, {276,0.00011765}, {277,0.00027451}, {278,0.00027451}, {279,0.00026471}, {280,0.00015686}, {281,0.00006863}, {282,0.00023529}, {283,0.00023529}, {284,0.00003922}, {285,0.00011765}, {286,0.00014706}, {287,0.00025490}, {288,0.00015686}, {289,0.00019608}, {290,0.00011765}, {291,0.00011765}, {292,0.00006863}, {293,0.00023529}, {294,0.00000000}, {295,0.00007843}, {296,0.00011765}, {297,0.00015686}, {298,0.00006863}, {299,0.00003922}, {300,0.00007843}, {301,0.00007921}, {302,0.00015842}, {303,0.00011881}, {304,0.00007921}, {305,0.00003960}, {306,0.00010891}, {307,0.00010891}, {308,0.00042574}, {309,0.00011881}, {310,0.00019802}, {311,0.00011881}, {312,0.00019802}, {313,0.00015842}, {314,0.00007921}, {315,0.00011881}, {316,0.00007921}, {317,0.00011881}, {318,0.00007921}, {319,0.00007921}, {320,0.00015842}, {321,0.00010891}, {322,0.00000000}, {323,0.00003960}, {324,0.00019802}, {325,0.00011881}, {326,0.00007921}, {327,0.00000000}, {328,0.00011881}, {329,0.00007921}, {330,0.00007921}, {331,0.00015842}, {332,0.00003960}, {333,0.00015842}, {334,0.00073267}, {335,0.00052475}, {336,0.00023762}, {337,0.00019802}, {338,0.00027723}, {339,0.00067327}, {340,0.00071287}, {341,0.00026733}, {342,0.00023762}, {343,0.00023762}, {344,0.00019802}, {345,0.00007921}, {346,0.00003960}, {347,0.00011881}, {348,0.00015842}, {349,0.00023762}, {350,0.00019802}, {351,0.00015842}, {352,0.00019802}, {353,0.00011881}, {354,0.00033663}, {355,0.00023762}, {356,0.00039604}, {357,0.00038614}, {358,0.00035644}, {359,0.00043564}, {360,0.00026733}, {361,0.00015842}, {362,0.00026733}, {363,0.00035644}, {364,0.00052475}, {365,0.00039604}, {366,0.00051485}, {367,0.00022772}, {368,0.00007921}, {369,0.00011881}, {370,0.00022772}, {371,0.00019802}, {372,0.00023762}, {373,0.00038614}, {374,0.00051485}, {375,0.00019802}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000308}, {380,0.000923}, {381,0.002154}, {382,0.002154}, {383,0.001231}, {384,0.000923}, {385,0.000615}, {386,0.000308}, {387,0.000308}, {388,0.000308}, {389,0.000615}, {390,0.000000}, {391,0.000615}, {392,0.000615}, {393,0.000000}, {394,0.000000}, {395,0.000308}, {396,0.000308}, {397,0.000000}, {398,0.000000}, {399,0.000308}, {400,0.000308}, {401,0.000308}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000923}, {412,0.000000}, {413,0.000308}, {414,0.000308}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000308}, {419,0.000000}, {420,0.000000}, {421,0.000308}, {422,0.000000}, {423,0.000000}, {424,0.000308}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000923}, {431,0.000308}, {432,0.000308}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000923}, {439,0.000615}, {440,0.000000}, {441,0.000308}, {442,0.000000}, {443,0.000308}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000308}, {449,0.000000}, {450,0.000000}, {451,0.000000}, {452,0.000000}, {453,0.000000}, {454,0.000000}, {455,0.000000}, {456,0.000000}, {457,0.000000}, {458,0.000000}, {459,0.000000}, {460,0.000000}, {461,0.000308}, {462,0.000000}, {463,0.000000}, {464,0.000000}, {465,0.000000}, {466,0.000000}, {467,0.000000}, {468,0.000000}, {469,0.000615}, {470,0.000308}, {471,0.000000}, {472,0.000000}, {473,0.000000}, {474,0.000000}, {475,0.000000}, {476,0.000308}, {477,0.000308}, {478,0.000000}, {479,0.000000}, {480,0.000000}, {481,0.000000}, {482,0.000308}, {483,0.000308}, {484,0.000000}, {485,0.000308}, {486,0.000000}, {487,0.000308}, {488,0.000000}, {489,0.000308}, {490,0.000615}, {491,0.000923}, {492,0.000000}, {493,0.000000}, {494,0.000923}, {495,0.000000}, {496,0.000000}, {497,0.000308}, {498,0.000308}, {499,0.000000}, {500,0.000000}, {505,0.000000}, {510,0.000308}, {515,0.000000}, {520,0.000000}, {525,0.000846}, {530,0.000000}, {535,0.000000}, {540,0.000308}, {545,0.000000}, {550,0.000308}, {555,0.000308}, {560,0.000000}, {565,0.000000}, {570,0.000308}, {575,0.000923}, {580,0.000615}, {585,0.000308}, {590,0.000000}, {595,0.000615}, {600,0.000000}, {605,0.000923}, {610,0.001231}, {615,0.000308}, {620,0.001231}, {625,0.000000}, {630,0.000000}, {635,0.000000}, {640,0.000923}, {645,0.001846}, {650,0.000923}, {655,0.000308}, {660,0.001231}, {665,0.002462}, {670,0.000615}, {675,0.000615}, {680,0.000308}, {685,0.000000}, {690,0.000000}, {695,0.001846}, {700,0.000615}, {705,0.000308}, {710,0.000308}, {715,0.000615}, {720,0.000308}, {725,0.000308}, {730,0.002769}, {735,0.000615}, {740,0.000308}, {745,0.003077}, {750,0.002462}, {755,0.002769}, {760,0.000923}, {765,0.001231}, {770,0.000308}, {775,0.000538}, {780,0.000308}, {785,0.000308}, {790,0.000308}, {795,0.001538}, {800,0.000923}, {805,0.002154}, {810,0.000615}, {815,0.000308}, {820,0.001538}, {825,0.002154}, {830,0.000615}, {835,0.002462}, {840,0.002462}, {845,0.003923}, {850,0.004923}, {855,0.000308}, {860,0.000923}, {865,0.001769}, {870,0.001231}, {875,0.003385}, {880,0.001231}, {885,0.003077}, {890,0.003692}, {895,0.002769}, {900,0.001538}, {905,0.002769}, {910,0.001538}, {915,0.003077}, {920,0.002154}, {925,0.004846}, {930,0.001231}, {935,0.000923}, {940,0.002154}, {945,0.002154}, {950,0.004000}, {955,0.005462}, {960,0.010462}, {965,0.005154}, {970,0.004000}, {975,0.004000}, {980,0.005462}, {985,0.004308}, {990,0.002769}, {995,0.000923}, {1000,0.003615}, {1010,0.008000}, {1020,0.002692}, {1030,0.000615}, {1040,0.007692}, {1050,0.005538}, {1060,0.005769}, {1070,0.006692}, {1080,0.007385}, {1090,0.003692}, {1100,0.009154}, {1110,0.003692}, {1120,0.007231}, {1130,0.005231}, {1140,0.003077}, {1150,0.007615}, {1160,0.003385}, {1170,0.006769}, {1180,0.004846}, {1190,0.007385}, {1200,0.004308}, {1210,0.001846}, {1220,0.009846}, {1230,0.005231}, {1240,0.002154}, {1250,0.002462}, {1260,0.002154}, {1270,0.004308}, {1280,0.004308}, {1290,0.004923}, {1300,0.003385}, {1310,0.005538}, {1320,0.005462}, {1330,0.007077}, {1340,0.004538}, {1350,0.002769}, {1360,0.004923}, {1370,0.002385}, {1380,0.005231}, {1390,0.002154}, {1400,0.004615}, {1410,0.001846}, {1420,0.002154}, {1430,0.004846}, {1440,0.002769}, {1450,0.004538}, {1460,0.006692}, {1470,0.012231}, {1480,0.008615}, {1490,0.003692}, {1500,0.006769}, {1510,0.005538}, {1520,0.010385}, {1530,0.004923}, {1540,0.007077}, {1550,0.009769}, {1560,0.015385}, {1570,0.008923}, {1580,0.014077}, {1590,0.010154}, {1600,0.014154}, {1610,0.014077}, {1620,0.007615}, {1630,0.016538}, {1640,0.012308}, {1650,0.011000}, {1660,0.016846}, {1670,0.010385}, {1680,0.013846}, {1690,0.019308}, {1700,0.007692}, {1710,0.010462}, {1720,0.009231}, {1730,0.012615}, {1740,0.023231}, {1750,0.017769}, {1760,0.019231}, {1770,0.009538}, {1780,0.044385}, {1790,0.013692}, {1800,0.021692}, {1810,0.019231}, {1820,0.010462}, {1830,0.019385}, {1840,0.014923}, {1850,0.012154}, {1860,0.023308}, {1870,0.016000}, {1880,0.019385}, {1890,0.020846}, {1900,0.017769}, {1910,0.031308}, {1920,0.026692}, {1930,0.036923}, {1940,0.036923}, {1950,0.029692}, {1960,0.018154}, {1970,0.028923}, {1980,0.044154}, {1990,0.033154}, {2000,0.054615}};
data["big"]["TypeClassesBodyHOAS"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00028070}, {6,0.00100000}, {7,0.00100000}, {8,0.00100000}, {9,0.00102632}, {10,0.00185965}, {11,0.00200000}, {12,0.00200000}, {13,0.00250000}, {14,0.00287719}, {15,0.02289474}, {16,0.00301754}, {17,0.00322807}, {18,0.00400000}, {19,0.00414035}, {20,0.00435088}, {21,0.00500000}, {22,0.00535088}, {23,0.00548246}, {24,0.00608772}, {25,0.00653509}, {26,0.00671053}, {27,0.00753509}, {28,0.00758772}, {29,0.00836842}, {30,0.00985965}, {31,0.00897368}, {32,0.00931579}, {33,0.00977193}, {34,0.01042105}, {35,0.01085088}, {36,0.01140351}, {37,0.01189474}, {38,0.01239474}, {39,0.01262281}, {40,0.01335088}, {41,0.01379825}, {42,0.01471930}, {43,0.01528070}, {44,0.01592105}, {45,0.01879825}, {46,0.01689474}, {47,0.01764912}, {48,0.01814912}, {49,0.01856140}, {50,0.02219298}, {51,0.01971930}, {52,0.02027193}, {53,0.02121930}, {54,0.02234211}, {55,0.02539474}, {56,0.02314035}, {57,0.02396491}, {58,0.02450000}, {59,0.02985965}, {60,0.02609649}, {61,0.02695614}, {62,0.02777193}, {63,0.03073684}, {64,0.02923684}, {65,0.03019298}, {66,0.03704386}, {67,0.03124561}, {68,0.03260526}, {69,0.03897368}, {70,0.03387719}, {71,0.03495614}, {72,0.04050000}, {73,0.03663158}, {74,0.03733333}, {75,0.04250877}, {76,0.03935965}, {77,0.05043860}, {78,0.04043860}, {79,0.04175439}, {80,0.04542982}, {81,0.04436842}, {82,0.05270175}, {83,0.04583333}, {84,0.06914035}, {85,0.04765789}, {86,0.05554902}, {87,0.04961765}, {88,0.05653922}, {89,0.05164706}, {90,0.06264706}, {91,0.05332353}, {92,0.06149020}, {93,0.05556863}, {94,0.06243137}, {95,0.05837255}, {96,0.06408824}, {97,0.06091176}, {98,0.06605882}, {99,0.07477451}, {100,0.06408824}, {101,0.06866667}, {102,0.07969608}, {103,0.06720588}, {104,0.07158824}, {105,0.08263725}, {106,0.07078431}, {107,0.07531373}, {108,0.08657843}, {109,0.07480392}, {110,0.07880392}, {111,0.08795098}, {112,0.09242157}, {113,0.07993137}, {114,0.08398039}, {115,0.09361765}, {116,0.09719608}, {117,0.09904902}, {118,0.08686275}, {119,0.09051961}, {120,0.10349020}, {121,0.10431373}, {122,0.10827451}, {123,0.10919608}, {124,0.11169608}, {125,0.11281373}, {126,0.10904902}, {127,0.09991176}, {128,0.11018627}, {129,0.11279412}, {130,0.11501961}, {131,0.11585294}, {132,0.11740196}, {133,0.11973529}, {134,0.12111765}, {135,0.13488235}, {136,0.12830392}, {137,0.12735294}, {138,0.12795098}, {139,0.12965686}, {140,0.13120588}, {141,0.18205882}, {142,0.13957843}, {143,0.23244118}, {144,0.14587255}, {145,0.14376471}, {146,0.14528431}, {147,0.14519608}, {148,0.15747059}, {149,0.14655882}, {150,0.14706863}, {151,0.14892157}, {152,0.16426471}, {153,0.15179412}, {154,0.15375490}, {155,0.16770588}, {156,0.15937255}, {157,0.15991176}, {158,0.16685294}, {159,0.16731373}, {160,0.18662745}, {161,0.17037255}, {162,0.18635294}, {163,0.17202941}, {164,0.18813725}, {165,0.17445098}, {166,0.19132353}, {167,0.17891176}, {168,0.19378431}, {169,0.18238235}, {170,0.19910784}, {171,0.20699020}, {172,0.19261765}, {173,0.21038235}, {174,0.21035294}, {175,0.19557843}, {176,0.21180392}, {177,0.21388235}, {178,0.20153922}, {179,0.20545098}, {180,0.21744118}, {181,0.22002941}, {182,0.22735294}, {183,0.21189216}, {184,0.21882353}, {185,0.23534314}, {186,0.23863725}, {187,0.23618627}, {188,0.23859804}, {189,0.23770588}, {190,0.24091176}, {191,0.24233333}, {192,0.24402941}, {193,0.24975490}, {194,0.25254902}, {195,0.25959804}, {196,0.25802941}, {197,0.26009804}, {198,0.25944118}, {199,0.26100000}, {200,0.27516667}, {201,0.26530392}, {202,0.26626471}, {203,0.27281373}, {204,0.27699020}, {205,0.28488235}, {206,0.28467647}, {207,0.28212745}, {208,0.30129412}, {209,0.28310784}, {210,0.28604902}, {211,0.30301961}, {212,0.29432353}, {213,0.31188235}, {214,0.30068627}, {215,0.32185294}, {216,0.30893137}, {217,0.32101961}, {218,0.30948039}, {219,0.32594118}, {220,0.31206863}, {221,0.33252941}, {222,0.32202941}, {223,0.32858824}, {224,0.34715686}, {225,0.34224510}, {226,0.32940196}, {227,0.34397059}, {228,0.35009804}, {229,0.35627451}, {230,0.34428431}, {231,0.36136275}, {232,0.36305882}, {233,0.36790196}, {234,0.36567647}, {235,0.36848039}, {236,0.37762745}, {237,0.37543137}, {238,0.37964706}, {239,0.38048039}, {240,0.38769608}, {241,0.38788235}, {242,0.38789216}, {243,0.39265686}, {244,0.39902941}, {245,0.40360784}, {246,0.40168627}, {247,0.41043137}, {248,0.40812745}, {249,0.40784314}, {250,0.41164706}, {251,0.42635294}, {252,0.42386275}, {253,0.43371569}, {254,0.42823529}, {255,0.43183333}, {256,0.44852941}, {257,0.44834314}, {258,0.45326471}, {259,0.44731373}, {260,0.45334314}, {261,0.46256863}, {262,0.46219608}, {263,0.47019608}, {264,0.47129412}, {265,0.47331373}, {266,0.47863725}, {267,0.48616667}, {268,0.48391176}, {269,0.49424510}, {270,0.49329412}, {271,0.49253922}, {272,0.50418627}, {273,0.50771569}, {274,0.51065686}, {275,0.51603922}, {276,0.51478431}, {277,0.52255882}, {278,0.52937255}, {279,0.52785294}, {280,0.53949020}, {281,0.53812745}, {282,0.54275490}, {283,0.54979412}, {284,0.54531373}, {285,0.55844118}, {286,0.56058824}, {287,0.55794118}, {288,0.57253922}, {289,0.56851961}, {290,0.57812745}, {291,0.57948039}, {292,0.57947059}, {293,0.59264706}, {294,0.58770588}, {295,0.60391176}, {296,0.60486275}, {297,0.60252941}, {298,0.61658824}, {299,0.61129412}, {300,0.62504902}, {301,0.62034653}, {302,0.62478218}, {303,0.63457426}, {304,0.63439604}, {305,0.64598020}, {306,0.64095050}, {307,0.65448515}, {308,0.65082178}, {309,0.66179208}, {310,0.66086139}, {311,0.66480198}, {312,0.67473267}, {313,0.67935644}, {314,0.68481188}, {315,0.68454455}, {316,0.69524752}, {317,0.69718812}, {318,0.70374257}, {319,0.69956436}, {320,0.71357426}, {321,0.71338614}, {322,0.72417822}, {323,0.72112871}, {324,0.73512871}, {325,0.72964356}, {326,0.75249505}, {327,0.74501980}, {328,0.75349505}, {329,0.74955446}, {330,0.75993069}, {331,0.76224752}, {332,0.77512871}, {333,0.77120792}, {334,0.78217822}, {335,0.78075248}, {336,0.79203960}, {337,0.79162376}, {338,0.79782178}, {339,0.80071287}, {340,0.80804950}, {341,0.81533663}, {342,0.81826733}, {343,0.82300990}, {344,0.83115842}, {345,0.83540594}, {346,0.83709901}, {347,0.84266337}, {348,0.85293069}, {349,0.86134653}, {350,0.86293069}, {351,0.86232673}, {352,0.87538614}, {353,0.87693069}, {354,0.88108911}, {355,0.89032673}, {356,0.89503960}, {357,0.94036634}, {358,0.89584158}, {359,0.96404950}, {360,0.91485149}, {361,0.92031683}, {362,0.92678218}, {363,0.93485149}, {364,0.93555446}, {365,0.93745545}, {366,0.95610891}, {367,0.95567327}, {368,0.95353465}, {369,0.97317822}, {370,0.96837624}, {371,0.97624752}, {372,0.98178218}, {373,0.98579208}, {374,0.99386139}, {375,0.99496040}, {376,1.001462}, {377,0.986462}, {378,0.995692}, {379,1.001462}, {380,0.996692}, {381,1.020231}, {382,1.021231}, {383,1.137077}, {384,1.033615}, {385,1.031846}, {386,1.163769}, {387,1.177923}, {388,1.056923}, {389,1.055308}, {390,1.062077}, {391,1.068769}, {392,1.079615}, {393,1.080231}, {394,1.084846}, {395,1.087077}, {396,1.093154}, {397,1.104462}, {398,1.109231}, {399,1.119308}, {400,1.115692}, {401,1.196462}, {402,1.140308}, {403,1.142462}, {404,1.146462}, {405,1.154692}, {406,1.161000}, {407,1.169846}, {408,1.172077}, {409,1.184462}, {410,1.184385}, {411,1.199462}, {412,1.200385}, {413,1.205308}, {414,1.210154}, {415,1.213000}, {416,1.227077}, {417,1.224154}, {418,1.240692}, {419,1.237308}, {420,1.255154}, {421,1.253154}, {422,1.259000}, {423,1.263615}, {424,1.279462}, {425,1.279846}, {426,1.295923}, {427,1.292769}, {428,1.318538}, {429,1.306385}, {430,1.311154}, {431,1.324154}, {432,1.346692}, {433,1.344077}, {434,1.345231}, {435,1.350231}, {436,1.375769}, {437,1.366846}, {438,1.375769}, {439,1.385154}, {440,1.398846}, {441,1.391846}, {442,1.400769}, {443,1.413846}, {444,1.429692}, {445,1.422308}, {446,1.432846}, {447,1.441615}, {448,1.466538}, {449,1.445769}, {450,1.459385}, {451,1.479308}, {452,1.487077}, {453,1.471923}, {454,1.490077}, {455,1.507154}, {456,1.502923}, {457,1.510615}, {458,1.522385}, {459,1.537769}, {460,1.532308}, {461,1.533077}, {462,1.556692}, {463,1.561462}, {464,1.559538}, {465,1.573923}, {466,1.591462}, {467,1.595692}, {468,1.586154}, {469,1.604462}, {470,1.616000}, {471,1.612385}, {472,1.621077}, {473,1.650615}, {474,1.649154}, {475,1.648000}, {476,1.662846}, {477,1.672077}, {478,1.673231}, {479,1.682000}, {480,1.694231}, {481,1.700077}, {482,1.703385}, {483,1.716923}, {484,1.723000}, {485,1.730692}, {486,1.742462}, {487,1.746615}, {488,1.772462}, {489,1.830308}, {490,1.781154}, {491,1.789308}, {492,1.797308}, {493,1.798385}, {494,1.813385}, {495,1.826769}, {496,1.816538}, {497,1.842846}, {498,1.840462}, {499,1.836077}, {500,1.847231}, {505,1.900154}, {510,1.929077}, {515,1.980846}, {520,2.032538}, {525,2.074308}, {530,2.114462}, {535,2.167231}, {540,2.200923}, {545,2.341000}, {550,2.288231}, {555,2.343692}, {560,2.408923}, {565,2.434846}, {570,2.486154}, {575,2.529308}, {580,2.651923}, {585,2.705308}, {590,2.691462}, {595,2.756385}, {600,2.820692}, {605,2.866077}, {610,2.913308}, {615,2.986385}, {620,3.022000}, {625,3.097846}, {630,3.187077}, {635,3.266769}, {640,3.498154}, {645,3.305231}, {650,3.348846}, {655,3.488077}, {660,3.470077}, {665,3.532538}, {670,3.587077}, {675,3.739000}, {680,3.718615}, {685,3.789846}, {690,3.935000}, {695,3.924462}, {700,4.137846}, {705,4.044308}, {710,4.121462}, {715,4.186538}, {720,4.345308}, {725,4.271538}, {730,4.427923}, {735,4.474769}, {740,4.500846}, {745,4.652000}, {750,4.620615}, {755,4.725231}, {760,4.786308}, {765,4.862000}, {770,4.936769}, {775,5.076462}, {780,5.089385}, {785,5.245000}, {790,5.362077}, {795,5.441000}, {800,5.576462}, {805,5.668000}, {810,5.836308}, {815,5.749769}, {820,6.068615}, {825,6.166308}, {830,6.087385}, {835,6.397231}, {840,6.230462}, {845,6.666000}, {850,6.557385}, {855,6.558231}, {860,6.834154}, {865,6.735692}, {870,6.995538}, {875,7.374462}, {880,7.186231}, {885,7.038615}, {890,7.298769}, {895,7.416077}, {900,7.587077}, {905,7.529231}, {910,7.621385}, {915,7.989462}, {920,7.850385}, {925,8.045385}, {930,8.215846}, {935,8.258846}, {940,8.364538}, {945,8.532923}, {950,8.737077}, {955,8.770077}, {960,8.808615}, {965,9.003077}, {970,9.451615}, {975,9.236538}, {980,9.342231}, {985,9.387846}, {990,9.659615}, {995,9.697692}, {1000,9.737846}, {1010,9.981077}, {1020,10.298846}, {1030,10.840308}, {1040,10.899769}, {1050,11.046615}, {1060,11.645846}, {1070,11.842538}, {1080,11.989000}, {1090,12.620385}, {1100,12.721077}, {1110,12.933846}, {1120,13.180231}, {1130,13.482154}, {1140,13.989923}, {1150,14.395769}, {1160,14.643538}, {1170,15.023538}, {1180,14.963615}, {1190,15.601923}, {1200,16.157923}, {1210,16.273462}, {1220,16.484077}, {1230,17.025308}, {1240,16.948000}, {1250,18.001308}, {1260,17.888692}, {1270,18.191000}, {1280,18.647385}, {1290,19.178231}, {1300,19.679923}, {1310,20.047385}, {1320,19.989538}, {1330,20.702000}, {1340,21.232615}, {1350,22.268385}, {1360,22.134538}, {1370,22.416231}, {1380,23.046846}, {1390,23.499923}, {1400,24.543154}, {1410,24.446923}, {1420,24.717846}, {1430,25.320615}, {1440,25.771538}, {1450,26.055615}, {1460,26.533154}, {1470,27.533154}, {1480,27.322462}, {1490,28.380462}, {1500,28.763462}, {1510,29.387077}, {1520,29.675462}, {1530,30.476154}, {1540,30.741769}, {1550,31.317923}, {1560,32.184846}, {1570,32.975462}, {1580,32.773923}, {1590,33.681385}, {1600,34.680615}, {1610,35.359846}, {1620,35.866692}, {1630,35.626308}, {1640,36.499462}, {1650,37.478769}, {1660,37.768846}, {1670,38.772769}, {1680,38.997000}, {1690,39.928692}, {1700,39.769769}, {1710,41.480154}, {1720,42.215846}, {1730,42.254923}, {1740,42.532692}, {1750,44.461692}, {1760,44.510000}, {1770,45.117385}, {1780,45.573231}, {1790,46.763000}, {1800,47.184231}, {1810,48.676308}, {1820,48.839846}, {1830,49.306462}, {1840,49.977538}, {1850,50.305846}, {1860,51.289615}, {1870,52.186692}, {1880,52.372000}, {1890,53.224538}, {1900,53.993769}, {1910,54.438846}, {1920,55.732538}, {1930,56.213769}, {1940,57.698615}, {1950,57.931923}, {1960,58.497077}, {1970,59.894923}, {1980,59.934615}, {1990,61.689846}, {2000,62.092846}};
data["big"]["TypeClassesBodyHOAS"]["actual reif"]["user"] = {{1,0.00036842}, {2,0.00014035}, {3,0.00057018}, {4,0.00082456}, {5,0.00089474}, {6,0.00075439}, {7,0.00151754}, {8,0.00168421}, {9,0.00153509}, {10,0.00172807}, {11,0.00197368}, {12,0.00220175}, {13,0.00272807}, {14,0.00300877}, {15,0.02319298}, {16,0.00345614}, {17,0.00372807}, {18,0.00393860}, {19,0.00456140}, {20,0.00475439}, {21,0.00499123}, {22,0.00524561}, {23,0.00573684}, {24,0.00621053}, {25,0.00659649}, {26,0.00721053}, {27,0.00759649}, {28,0.00783333}, {29,0.00841228}, {30,0.00985088}, {31,0.00928070}, {32,0.00907018}, {33,0.00989474}, {34,0.01020175}, {35,0.01076316}, {36,0.01147368}, {37,0.01151754}, {38,0.01230702}, {39,0.01230702}, {40,0.01318421}, {41,0.01354386}, {42,0.01433333}, {43,0.01499123}, {44,0.01554386}, {45,0.01870175}, {46,0.01678947}, {47,0.01740351}, {48,0.01800877}, {49,0.01807895}, {50,0.02234211}, {51,0.01930702}, {52,0.02001754}, {53,0.02137719}, {54,0.02239474}, {55,0.02568421}, {56,0.02328070}, {57,0.02417544}, {58,0.02472807}, {59,0.03017544}, {60,0.02644737}, {61,0.02714912}, {62,0.02826316}, {63,0.03072807}, {64,0.02935965}, {65,0.03015789}, {66,0.03700877}, {67,0.03144737}, {68,0.03259649}, {69,0.03878070}, {70,0.03390351}, {71,0.03488596}, {72,0.04030702}, {73,0.03671930}, {74,0.03691228}, {75,0.04224561}, {76,0.03918421}, {77,0.05079825}, {78,0.04006140}, {79,0.04147368}, {80,0.04494737}, {81,0.04439474}, {82,0.05293860}, {83,0.04577193}, {84,0.06922807}, {85,0.04783333}, {86,0.05524510}, {87,0.04996078}, {88,0.05645098}, {89,0.05198039}, {90,0.06245098}, {91,0.05356863}, {92,0.06101961}, {93,0.05547059}, {94,0.06232353}, {95,0.05806863}, {96,0.06373529}, {97,0.06056863}, {98,0.06576471}, {99,0.07492157}, {100,0.06389216}, {101,0.06826471}, {102,0.07970588}, {103,0.06691176}, {104,0.07170588}, {105,0.08239216}, {106,0.07056863}, {107,0.07569608}, {108,0.08648039}, {109,0.07489216}, {110,0.07894118}, {111,0.08797059}, {112,0.09211765}, {113,0.08012745}, {114,0.08355882}, {115,0.09358824}, {116,0.09728431}, {117,0.09899020}, {118,0.08644118}, {119,0.09029412}, {120,0.10324510}, {121,0.10429412}, {122,0.10801961}, {123,0.10890196}, {124,0.11178431}, {125,0.11211765}, {126,0.10872549}, {127,0.10015686}, {128,0.10978431}, {129,0.11251961}, {130,0.11493137}, {131,0.11538235}, {132,0.11695098}, {133,0.11947059}, {134,0.12083333}, {135,0.13362745}, {136,0.12751961}, {137,0.12702941}, {138,0.12745098}, {139,0.12951961}, {140,0.13067647}, {141,0.18147059}, {142,0.13898039}, {143,0.23187255}, {144,0.14583333}, {145,0.14373529}, {146,0.14525490}, {147,0.14493137}, {148,0.15707843}, {149,0.14672549}, {150,0.14699020}, {151,0.14887255}, {152,0.16379412}, {153,0.15144118}, {154,0.15327451}, {155,0.16745098}, {156,0.15925490}, {157,0.15967647}, {158,0.16655882}, {159,0.16671569}, {160,0.18620588}, {161,0.17022549}, {162,0.18593137}, {163,0.17197059}, {164,0.18793137}, {165,0.17414706}, {166,0.19116667}, {167,0.17868627}, {168,0.19377451}, {169,0.18217647}, {170,0.19906863}, {171,0.20646078}, {172,0.19242157}, {173,0.21037255}, {174,0.21000980}, {175,0.19552941}, {176,0.21143137}, {177,0.21344118}, {178,0.20132353}, {179,0.20499020}, {180,0.21682353}, {181,0.21965686}, {182,0.22688235}, {183,0.21154902}, {184,0.21858824}, {185,0.23500980}, {186,0.23845098}, {187,0.23553922}, {188,0.23794118}, {189,0.23712745}, {190,0.24037255}, {191,0.24181373}, {192,0.24345098}, {193,0.24926471}, {194,0.25172549}, {195,0.25913725}, {196,0.25780392}, {197,0.26000980}, {198,0.25901961}, {199,0.26033333}, {200,0.27470588}, {201,0.26487255}, {202,0.26578431}, {203,0.27245098}, {204,0.27651961}, {205,0.28438235}, {206,0.28402941}, {207,0.28180392}, {208,0.30047059}, {209,0.28262745}, {210,0.28573529}, {211,0.30259804}, {212,0.29411765}, {213,0.31121569}, {214,0.30031373}, {215,0.32135294}, {216,0.30823529}, {217,0.32063725}, {218,0.30879412}, {219,0.32555882}, {220,0.31170588}, {221,0.33189216}, {222,0.32171569}, {223,0.32815686}, {224,0.34640196}, {225,0.34157843}, {226,0.32897059}, {227,0.34334314}, {228,0.34957843}, {229,0.35577451}, {230,0.34371569}, {231,0.36064706}, {232,0.36218627}, {233,0.36693137}, {234,0.36480392}, {235,0.36757843}, {236,0.37696078}, {237,0.37482353}, {238,0.37913725}, {239,0.37983333}, {240,0.38713725}, {241,0.38710784}, {242,0.38738235}, {243,0.39165686}, {244,0.39810784}, {245,0.40311765}, {246,0.40113725}, {247,0.40964706}, {248,0.40740196}, {249,0.40740196}, {250,0.41078431}, {251,0.42580392}, {252,0.42281373}, {253,0.43291176}, {254,0.42770588}, {255,0.43103922}, {256,0.44744118}, {257,0.44772549}, {258,0.45294118}, {259,0.44673529}, {260,0.45254902}, {261,0.46185294}, {262,0.46140196}, {263,0.46942157}, {264,0.47053922}, {265,0.47253922}, {266,0.47762745}, {267,0.48506863}, {268,0.48300980}, {269,0.49340196}, {270,0.49239216}, {271,0.49200000}, {272,0.50335294}, {273,0.50707843}, {274,0.50989216}, {275,0.51536275}, {276,0.51415686}, {277,0.52163725}, {278,0.52831373}, {279,0.52677451}, {280,0.53884314}, {281,0.53750980}, {282,0.54204902}, {283,0.54871569}, {284,0.54430392}, {285,0.55762745}, {286,0.55949020}, {287,0.55696078}, {288,0.57181373}, {289,0.56776471}, {290,0.57730392}, {291,0.57875490}, {292,0.57870588}, {293,0.59193137}, {294,0.58686275}, {295,0.60310784}, {296,0.60395098}, {297,0.60160784}, {298,0.61565686}, {299,0.61035294}, {300,0.62378431}, {301,0.61948515}, {302,0.62366337}, {303,0.63342574}, {304,0.63357426}, {305,0.64479208}, {306,0.64009901}, {307,0.65388119}, {308,0.64982178}, {309,0.66076238}, {310,0.66002970}, {311,0.66380198}, {312,0.67366337}, {313,0.67804950}, {314,0.68379208}, {315,0.68365347}, {316,0.69411881}, {317,0.69604950}, {318,0.70284158}, {319,0.69830693}, {320,0.71271287}, {321,0.71218812}, {322,0.72318812}, {323,0.72014851}, {324,0.73380198}, {325,0.72856436}, {326,0.75145545}, {327,0.74405941}, {328,0.75214851}, {329,0.74812871}, {330,0.75889109}, {331,0.76115842}, {332,0.77396040}, {333,0.77020792}, {334,0.78042574}, {335,0.77891089}, {336,0.79048515}, {337,0.79026733}, {338,0.79641584}, {339,0.79900990}, {340,0.80610891}, {341,0.81366337}, {342,0.81700000}, {343,0.82179208}, {344,0.82984158}, {345,0.83424752}, {346,0.83590099}, {347,0.84154455}, {348,0.85171287}, {349,0.85981188}, {350,0.86117822}, {351,0.86053465}, {352,0.87408911}, {353,0.87531683}, {354,0.87943564}, {355,0.88881188}, {356,0.89351485}, {357,0.93874257}, {358,0.89403960}, {359,0.96218812}, {360,0.91306931}, {361,0.91877228}, {362,0.92499010}, {363,0.93352475}, {364,0.93370297}, {365,0.93547525}, {366,0.95453465}, {367,0.95406931}, {368,0.95223762}, {369,0.97175248}, {370,0.96629703}, {371,0.97489109}, {372,0.98033663}, {373,0.98409901}, {374,0.99205941}, {375,0.99366337}, {376,1.001077}, {377,0.986308}, {378,0.995000}, {379,1.000154}, {380,0.995231}, {381,1.017538}, {382,1.018923}, {383,1.135769}, {384,1.031077}, {385,1.030231}, {386,1.163231}, {387,1.177077}, {388,1.056615}, {389,1.054846}, {390,1.061308}, {391,1.067769}, {392,1.078308}, {393,1.080000}, {394,1.085231}, {395,1.086231}, {396,1.092308}, {397,1.103692}, {398,1.108769}, {399,1.118308}, {400,1.114846}, {401,1.195615}, {402,1.140000}, {403,1.142769}, {404,1.145538}, {405,1.154385}, {406,1.160615}, {407,1.170462}, {408,1.172077}, {409,1.183846}, {410,1.183154}, {411,1.198769}, {412,1.199846}, {413,1.204769}, {414,1.209615}, {415,1.212000}, {416,1.227154}, {417,1.224000}, {418,1.240154}, {419,1.236538}, {420,1.254231}, {421,1.251923}, {422,1.258615}, {423,1.262615}, {424,1.277846}, {425,1.280308}, {426,1.294923}, {427,1.292462}, {428,1.318385}, {429,1.305692}, {430,1.311154}, {431,1.323615}, {432,1.345231}, {433,1.344077}, {434,1.343692}, {435,1.350154}, {436,1.375385}, {437,1.366615}, {438,1.375154}, {439,1.384615}, {440,1.397769}, {441,1.391769}, {442,1.401000}, {443,1.413154}, {444,1.428308}, {445,1.421846}, {446,1.431846}, {447,1.441000}, {448,1.465923}, {449,1.444385}, {450,1.457846}, {451,1.479154}, {452,1.487308}, {453,1.471308}, {454,1.488846}, {455,1.506231}, {456,1.502231}, {457,1.510308}, {458,1.521538}, {459,1.536923}, {460,1.531462}, {461,1.532462}, {462,1.556923}, {463,1.561538}, {464,1.558923}, {465,1.573385}, {466,1.590538}, {467,1.594923}, {468,1.585308}, {469,1.603538}, {470,1.615385}, {471,1.612000}, {472,1.619692}, {473,1.650462}, {474,1.648615}, {475,1.647000}, {476,1.661077}, {477,1.670615}, {478,1.672308}, {479,1.680692}, {480,1.693308}, {481,1.699154}, {482,1.702846}, {483,1.715154}, {484,1.721231}, {485,1.728923}, {486,1.741231}, {487,1.745231}, {488,1.770846}, {489,1.828769}, {490,1.780077}, {491,1.786846}, {492,1.796077}, {493,1.797846}, {494,1.812000}, {495,1.825462}, {496,1.815154}, {497,1.841615}, {498,1.838923}, {499,1.835231}, {500,1.846231}, {505,1.898231}, {510,1.926462}, {515,1.979923}, {520,2.030615}, {525,2.071615}, {530,2.113000}, {535,2.165692}, {540,2.198692}, {545,2.339308}, {550,2.287538}, {555,2.341846}, {560,2.407154}, {565,2.432462}, {570,2.484308}, {575,2.527154}, {580,2.650000}, {585,2.703846}, {590,2.690231}, {595,2.754538}, {600,2.820000}, {605,2.863692}, {610,2.910692}, {615,2.985462}, {620,3.019538}, {625,3.096308}, {630,3.185846}, {635,3.264692}, {640,3.496846}, {645,3.302231}, {650,3.346923}, {655,3.486385}, {660,3.467923}, {665,3.529308}, {670,3.584923}, {675,3.736385}, {680,3.716692}, {685,3.788154}, {690,3.932846}, {695,3.921692}, {700,4.135769}, {705,4.042154}, {710,4.120000}, {715,4.184077}, {720,4.343154}, {725,4.269615}, {730,4.422846}, {735,4.472231}, {740,4.498000}, {745,4.647000}, {750,4.616308}, {755,4.720769}, {760,4.784231}, {765,4.860154}, {770,4.934538}, {775,5.074923}, {780,5.086846}, {785,5.242769}, {790,5.359308}, {795,5.437846}, {800,5.573846}, {805,5.663154}, {810,5.832923}, {815,5.746154}, {820,6.064462}, {825,6.161846}, {830,6.084231}, {835,6.392615}, {840,6.225846}, {845,6.658846}, {850,6.549692}, {855,6.554692}, {860,6.831154}, {865,6.730538}, {870,6.991538}, {875,7.368692}, {880,7.182538}, {885,7.033615}, {890,7.292538}, {895,7.410692}, {900,7.582538}, {905,7.524077}, {910,7.616462}, {915,7.983231}, {920,7.845538}, {925,8.037538}, {930,8.211077}, {935,8.255231}, {940,8.359308}, {945,8.527385}, {950,8.730077}, {955,8.760615}, {960,8.794538}, {965,8.993769}, {970,9.443538}, {975,9.228769}, {980,9.333615}, {985,9.380923}, {990,9.653462}, {995,9.693308}, {1000,9.731385}, {1010,9.969231}, {1020,10.291538}, {1030,10.832923}, {1040,10.883462}, {1050,11.031462}, {1060,11.630692}, {1070,11.827077}, {1080,11.972385}, {1090,12.607231}, {1100,12.701154}, {1110,12.920308}, {1120,13.163692}, {1130,13.468308}, {1140,13.977308}, {1150,14.378154}, {1160,14.634231}, {1170,15.011769}, {1180,14.952077}, {1190,15.589462}, {1200,16.147846}, {1210,16.265615}, {1220,16.468615}, {1230,17.012538}, {1240,16.938846}, {1250,17.992462}, {1260,17.880154}, {1270,18.178846}, {1280,18.635923}, {1290,19.165308}, {1300,19.669538}, {1310,20.034308}, {1320,19.976538}, {1330,20.686769}, {1340,21.222000}, {1350,22.266077}, {1360,22.129923}, {1370,22.407000}, {1380,23.033231}, {1390,23.488000}, {1400,24.530077}, {1410,24.436385}, {1420,24.703846}, {1430,25.301154}, {1440,25.753538}, {1450,26.036692}, {1460,26.510692}, {1470,27.505846}, {1480,27.299000}, {1490,28.359308}, {1500,28.739615}, {1510,29.363385}, {1520,29.647538}, {1530,30.451923}, {1540,30.716615}, {1550,31.289615}, {1560,32.150923}, {1570,32.947538}, {1580,32.738923}, {1590,33.643231}, {1600,34.639462}, {1610,35.318538}, {1620,35.830692}, {1630,35.577308}, {1640,36.450846}, {1650,37.421308}, {1660,37.695923}, {1670,38.697077}, {1680,38.926000}, {1690,39.848692}, {1700,39.713000}, {1710,41.418462}, {1720,42.151000}, {1730,42.187846}, {1740,42.457615}, {1750,44.396154}, {1760,44.442846}, {1770,45.070154}, {1780,45.493769}, {1790,46.713308}, {1800,47.128462}, {1810,48.623308}, {1820,48.794308}, {1830,49.251385}, {1840,49.917154}, {1850,50.256923}, {1860,51.231308}, {1870,52.134231}, {1880,52.316462}, {1890,53.165231}, {1900,53.938385}, {1910,54.372154}, {1920,55.672308}, {1930,56.136923}, {1940,57.639077}, {1950,57.852615}, {1960,58.429538}, {1970,59.805000}, {1980,59.827462}, {1990,61.595692}, {2000,61.980538}};
data["big"]["TypeClassesBodyHOAS"]["actual reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003509}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00003509}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00003509}, {14,0.00010526}, {15,0.00000000}, {16,0.00007018}, {17,0.00010526}, {18,0.00003509}, {19,0.00000000}, {20,0.00000000}, {21,0.00007018}, {22,0.00006140}, {23,0.00003509}, {24,0.00000000}, {25,0.00003509}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00002632}, {30,0.00003509}, {31,0.00000000}, {32,0.00010526}, {33,0.00003509}, {34,0.00000000}, {35,0.00003509}, {36,0.00000000}, {37,0.00017544}, {38,0.00007018}, {39,0.00000000}, {40,0.00000000}, {41,0.00007018}, {42,0.00003509}, {43,0.00003509}, {44,0.00003509}, {45,0.00000000}, {46,0.00003509}, {47,0.00003509}, {48,0.00000000}, {49,0.00003509}, {50,0.00003509}, {51,0.00007018}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00007018}, {57,0.00010526}, {58,0.00000000}, {59,0.00003509}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00007018}, {64,0.00000000}, {65,0.00003509}, {66,0.00000000}, {67,0.00003509}, {68,0.00010526}, {69,0.00000000}, {70,0.00000000}, {71,0.00010526}, {72,0.00000000}, {73,0.00000000}, {74,0.00010526}, {75,0.00007018}, {76,0.00003509}, {77,0.00000000}, {78,0.00003509}, {79,0.00003509}, {80,0.00014035}, {81,0.00000000}, {82,0.00010526}, {83,0.00007018}, {84,0.00007018}, {85,0.00003509}, {86,0.00003922}, {87,0.00003922}, {88,0.00003922}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00007843}, {93,0.00000000}, {94,0.00003922}, {95,0.00000000}, {96,0.00003922}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00007843}, {101,0.00000000}, {102,0.00000000}, {103,0.00003922}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00007843}, {108,0.00000000}, {109,0.00006863}, {110,0.00003922}, {111,0.00000000}, {112,0.00003922}, {113,0.00000000}, {114,0.00003922}, {115,0.00003922}, {116,0.00000000}, {117,0.00000000}, {118,0.00003922}, {119,0.00000000}, {120,0.00007843}, {121,0.00000000}, {122,0.00000000}, {123,0.00015686}, {124,0.00000000}, {125,0.00025490}, {126,0.00006863}, {127,0.00003922}, {128,0.00011765}, {129,0.00015686}, {130,0.00018627}, {131,0.00015686}, {132,0.00023529}, {133,0.00023529}, {134,0.00015686}, {135,0.00085294}, {136,0.00050000}, {137,0.00037255}, {138,0.00035294}, {139,0.00019608}, {140,0.00019608}, {141,0.00007843}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00011765}, {148,0.00003922}, {149,0.00003922}, {150,0.00000000}, {151,0.00003922}, {152,0.00010784}, {153,0.00003922}, {154,0.00000000}, {155,0.00011765}, {156,0.00007843}, {157,0.00000000}, {158,0.00003922}, {159,0.00003922}, {160,0.00000000}, {161,0.00003922}, {162,0.00000000}, {163,0.00000000}, {164,0.00007843}, {165,0.00006863}, {166,0.00007843}, {167,0.00010784}, {168,0.00007843}, {169,0.00000000}, {170,0.00003922}, {171,0.00003922}, {172,0.00003922}, {173,0.00000000}, {174,0.00003922}, {175,0.00000000}, {176,0.00003922}, {177,0.00003922}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00003922}, {182,0.00007843}, {183,0.00000000}, {184,0.00000000}, {185,0.00003922}, {186,0.00007843}, {187,0.00019608}, {188,0.00000000}, {189,0.00003922}, {190,0.00011765}, {191,0.00018627}, {192,0.00022549}, {193,0.00007843}, {194,0.00031373}, {195,0.00011765}, {196,0.00011765}, {197,0.00007843}, {198,0.00000000}, {199,0.00011765}, {200,0.00002941}, {201,0.00003922}, {202,0.00003922}, {203,0.00003922}, {204,0.00007843}, {205,0.00000000}, {206,0.00003922}, {207,0.00007843}, {208,0.00003922}, {209,0.00003922}, {210,0.00007843}, {211,0.00003922}, {212,0.00003922}, {213,0.00003922}, {214,0.00007843}, {215,0.00000000}, {216,0.00003922}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00003922}, {221,0.00007843}, {222,0.00007843}, {223,0.00000000}, {224,0.00003922}, {225,0.00007843}, {226,0.00000000}, {227,0.00011765}, {228,0.00003922}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00007843}, {233,0.00035294}, {234,0.00029412}, {235,0.00027451}, {236,0.00011765}, {237,0.00007843}, {238,0.00003922}, {239,0.00000000}, {240,0.00011765}, {241,0.00000000}, {242,0.00006863}, {243,0.00014706}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00003922}, {248,0.00015686}, {249,0.00006863}, {250,0.00023529}, {251,0.00003922}, {252,0.00007843}, {253,0.00003922}, {254,0.00002941}, {255,0.00000000}, {256,0.00007843}, {257,0.00000000}, {258,0.00000000}, {259,0.00003922}, {260,0.00007843}, {261,0.00003922}, {262,0.00000000}, {263,0.00007843}, {264,0.00002941}, {265,0.00007843}, {266,0.00023529}, {267,0.00031373}, {268,0.00018627}, {269,0.00015686}, {270,0.00015686}, {271,0.00003922}, {272,0.00011765}, {273,0.00003922}, {274,0.00011765}, {275,0.00019608}, {276,0.00011765}, {277,0.00023529}, {278,0.00019608}, {279,0.00018627}, {280,0.00007843}, {281,0.00006863}, {282,0.00015686}, {283,0.00019608}, {284,0.00003922}, {285,0.00007843}, {286,0.00006863}, {287,0.00021569}, {288,0.00011765}, {289,0.00011765}, {290,0.00007843}, {291,0.00003922}, {292,0.00003922}, {293,0.00003922}, {294,0.00000000}, {295,0.00003922}, {296,0.00007843}, {297,0.00015686}, {298,0.00003922}, {299,0.00003922}, {300,0.00007843}, {301,0.00003960}, {302,0.00007921}, {303,0.00011881}, {304,0.00003960}, {305,0.00003960}, {306,0.00000000}, {307,0.00003960}, {308,0.00014851}, {309,0.00011881}, {310,0.00003960}, {311,0.00007921}, {312,0.00007921}, {313,0.00011881}, {314,0.00003960}, {315,0.00011881}, {316,0.00003960}, {317,0.00007921}, {318,0.00007921}, {319,0.00007921}, {320,0.00011881}, {321,0.00003960}, {322,0.00000000}, {323,0.00003960}, {324,0.00015842}, {325,0.00007921}, {326,0.00000000}, {327,0.00000000}, {328,0.00011881}, {329,0.00007921}, {330,0.00007921}, {331,0.00011881}, {332,0.00003960}, {333,0.00007921}, {334,0.00067327}, {335,0.00048515}, {336,0.00015842}, {337,0.00015842}, {338,0.00019802}, {339,0.00067327}, {340,0.00055446}, {341,0.00019802}, {342,0.00015842}, {343,0.00011881}, {344,0.00011881}, {345,0.00003960}, {346,0.00000000}, {347,0.00011881}, {348,0.00007921}, {349,0.00015842}, {350,0.00003960}, {351,0.00011881}, {352,0.00015842}, {353,0.00011881}, {354,0.00025743}, {355,0.00019802}, {356,0.00031683}, {357,0.00035644}, {358,0.00027723}, {359,0.00039604}, {360,0.00019802}, {361,0.00011881}, {362,0.00014851}, {363,0.00027723}, {364,0.00052475}, {365,0.00027723}, {366,0.00035644}, {367,0.00018812}, {368,0.00007921}, {369,0.00011881}, {370,0.00018812}, {371,0.00015842}, {372,0.00015842}, {373,0.00035644}, {374,0.00051485}, {375,0.00015842}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000308}, {380,0.000923}, {381,0.001846}, {382,0.001846}, {383,0.000923}, {384,0.000923}, {385,0.000308}, {386,0.000000}, {387,0.000308}, {388,0.000000}, {389,0.000615}, {390,0.000000}, {391,0.000615}, {392,0.000615}, {393,0.000000}, {394,0.000000}, {395,0.000308}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000308}, {400,0.000308}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000615}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000308}, {422,0.000000}, {423,0.000000}, {424,0.000308}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000308}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000923}, {439,0.000615}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000308}, {449,0.000000}, {450,0.000000}, {451,0.000000}, {452,0.000000}, {453,0.000000}, {454,0.000000}, {455,0.000000}, {456,0.000000}, {457,0.000000}, {458,0.000000}, {459,0.000000}, {460,0.000000}, {461,0.000308}, {462,0.000000}, {463,0.000000}, {464,0.000000}, {465,0.000000}, {466,0.000000}, {467,0.000000}, {468,0.000000}, {469,0.000308}, {470,0.000000}, {471,0.000000}, {472,0.000000}, {473,0.000000}, {474,0.000000}, {475,0.000000}, {476,0.000308}, {477,0.000308}, {478,0.000000}, {479,0.000000}, {480,0.000000}, {481,0.000000}, {482,0.000000}, {483,0.000308}, {484,0.000000}, {485,0.000308}, {486,0.000000}, {487,0.000000}, {488,0.000000}, {489,0.000308}, {490,0.000308}, {491,0.000615}, {492,0.000000}, {493,0.000000}, {494,0.000308}, {495,0.000000}, {496,0.000000}, {497,0.000308}, {498,0.000308}, {499,0.000000}, {500,0.000000}, {505,0.000000}, {510,0.000308}, {515,0.000000}, {520,0.000000}, {525,0.000846}, {530,0.000000}, {535,0.000000}, {540,0.000000}, {545,0.000000}, {550,0.000000}, {555,0.000308}, {560,0.000000}, {565,0.000000}, {570,0.000308}, {575,0.000923}, {580,0.000308}, {585,0.000000}, {590,0.000000}, {595,0.000615}, {600,0.000000}, {605,0.000923}, {610,0.000923}, {615,0.000308}, {620,0.001231}, {625,0.000000}, {630,0.000000}, {635,0.000000}, {640,0.000615}, {645,0.001846}, {650,0.000923}, {655,0.000308}, {660,0.000923}, {665,0.002462}, {670,0.000615}, {675,0.000615}, {680,0.000308}, {685,0.000000}, {690,0.000000}, {695,0.001538}, {700,0.000615}, {705,0.000308}, {710,0.000308}, {715,0.000308}, {720,0.000308}, {725,0.000308}, {730,0.002769}, {735,0.000615}, {740,0.000308}, {745,0.003077}, {750,0.002462}, {755,0.002769}, {760,0.000923}, {765,0.001231}, {770,0.000000}, {775,0.000000}, {780,0.000000}, {785,0.000308}, {790,0.000308}, {795,0.001538}, {800,0.000615}, {805,0.002154}, {810,0.000615}, {815,0.000000}, {820,0.001538}, {825,0.002154}, {830,0.000308}, {835,0.002154}, {840,0.002462}, {845,0.003923}, {850,0.004923}, {855,0.000308}, {860,0.000923}, {865,0.001769}, {870,0.001231}, {875,0.003385}, {880,0.001231}, {885,0.003077}, {890,0.003692}, {895,0.002769}, {900,0.001231}, {905,0.002462}, {910,0.001538}, {915,0.003077}, {920,0.002154}, {925,0.004846}, {930,0.001231}, {935,0.000615}, {940,0.002154}, {945,0.002154}, {950,0.004000}, {955,0.005462}, {960,0.010462}, {965,0.005154}, {970,0.004000}, {975,0.003692}, {980,0.005231}, {985,0.004000}, {990,0.002769}, {995,0.000538}, {1000,0.003615}, {1010,0.007692}, {1020,0.002692}, {1030,0.000615}, {1040,0.007692}, {1050,0.005538}, {1060,0.005769}, {1070,0.006692}, {1080,0.007385}, {1090,0.003692}, {1100,0.009154}, {1110,0.003692}, {1120,0.007231}, {1130,0.004923}, {1140,0.002769}, {1150,0.007615}, {1160,0.003385}, {1170,0.006462}, {1180,0.004846}, {1190,0.007385}, {1200,0.004000}, {1210,0.001846}, {1220,0.009846}, {1230,0.005231}, {1240,0.002154}, {1250,0.002462}, {1260,0.001846}, {1270,0.004308}, {1280,0.004308}, {1290,0.004615}, {1300,0.003385}, {1310,0.004923}, {1320,0.005154}, {1330,0.007077}, {1340,0.004538}, {1350,0.002769}, {1360,0.004923}, {1370,0.002385}, {1380,0.005231}, {1390,0.002154}, {1400,0.004615}, {1410,0.001846}, {1420,0.002154}, {1430,0.004846}, {1440,0.002769}, {1450,0.004538}, {1460,0.006692}, {1470,0.011615}, {1480,0.007692}, {1490,0.003692}, {1500,0.006769}, {1510,0.005538}, {1520,0.010077}, {1530,0.004923}, {1540,0.007077}, {1550,0.009769}, {1560,0.015385}, {1570,0.008923}, {1580,0.014077}, {1590,0.010154}, {1600,0.014154}, {1610,0.013769}, {1620,0.007615}, {1630,0.015923}, {1640,0.012308}, {1650,0.011000}, {1660,0.016846}, {1670,0.010385}, {1680,0.013538}, {1690,0.019000}, {1700,0.007692}, {1710,0.010462}, {1720,0.009231}, {1730,0.012615}, {1740,0.023231}, {1750,0.017769}, {1760,0.018923}, {1770,0.009231}, {1780,0.044385}, {1790,0.013385}, {1800,0.021385}, {1810,0.019231}, {1820,0.010154}, {1830,0.019385}, {1840,0.014923}, {1850,0.012154}, {1860,0.023308}, {1870,0.016000}, {1880,0.019385}, {1890,0.020846}, {1900,0.017462}, {1910,0.031000}, {1920,0.026077}, {1930,0.036923}, {1940,0.036923}, {1950,0.029462}, {1960,0.017846}, {1970,0.028615}, {1980,0.044154}, {1990,0.032769}, {2000,0.054000}};
data["big"]["TypeClassesBodyHOAS"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.01361765}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00008824}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00008824}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000000}, {400,0.000000}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}, {451,0.000000}, {452,0.000000}, {453,0.000000}, {454,0.000000}, {455,0.000000}, {456,0.000000}, {457,0.000000}, {458,0.000000}, {459,0.000000}, {460,0.000000}, {461,0.000000}, {462,0.000000}, {463,0.000000}, {464,0.000000}, {465,0.000000}, {466,0.000000}, {467,0.000000}, {468,0.000000}, {469,0.000000}, {470,0.000000}, {471,0.000000}, {472,0.000000}, {473,0.000000}, {474,0.000000}, {475,0.000000}, {476,0.000000}, {477,0.000000}, {478,0.000000}, {479,0.000000}, {480,0.000000}, {481,0.000000}, {482,0.000000}, {483,0.000000}, {484,0.000000}, {485,0.000000}, {486,0.000000}, {487,0.000000}, {488,0.000000}, {489,0.000000}, {490,0.000000}, {491,0.000000}, {492,0.000000}, {493,0.000000}, {494,0.000000}, {495,0.000000}, {496,0.000000}, {497,0.000000}, {498,0.012000}, {499,0.010462}, {500,0.011077}, {505,0.009923}, {510,0.000000}, {515,0.000000}, {520,0.000000}, {525,0.000000}, {530,0.000000}, {535,0.000000}, {540,0.000000}, {545,0.000000}, {550,0.000000}, {555,0.000000}, {560,0.000000}, {565,0.000000}, {570,0.000077}, {575,0.000000}, {580,0.000154}, {585,0.000231}, {590,0.000154}, {595,0.000615}, {600,0.000615}, {605,0.000692}, {610,0.000769}, {615,0.000846}, {620,0.000846}, {625,0.000923}, {630,0.001000}, {635,0.000923}, {640,0.001000}, {645,0.001000}, {650,0.000923}, {655,0.001000}, {660,0.001000}, {665,0.001000}, {670,0.001000}, {675,0.001000}, {680,0.001000}, {685,0.001000}, {690,0.001000}, {695,0.001000}, {700,0.001000}, {705,0.001000}, {710,0.001000}, {715,0.001000}, {720,0.001000}, {725,0.013615}, {730,0.001000}, {735,0.001000}, {740,0.001000}, {745,0.001000}, {750,0.001000}, {755,0.001000}, {760,0.001000}, {765,0.001000}, {770,0.001000}, {775,0.001000}, {780,0.001000}, {785,0.001000}, {790,0.001000}, {795,0.001000}, {800,0.001000}, {805,0.001000}, {810,0.001000}, {815,0.001000}, {820,0.001000}, {825,0.001000}, {830,0.001000}, {835,0.001000}, {840,0.001000}, {845,0.001000}, {850,0.001000}, {855,0.001000}, {860,0.001000}, {865,0.001000}, {870,0.001000}, {875,0.001000}, {880,0.001000}, {885,0.001000}, {890,0.001000}, {895,0.001000}, {900,0.001000}, {905,0.001000}, {910,0.001000}, {915,0.001000}, {920,0.001000}, {925,0.001000}, {930,0.001000}, {935,0.001000}, {940,0.001000}, {945,0.001000}, {950,0.001000}, {955,0.001000}, {960,0.001000}, {965,0.001000}, {970,0.001000}, {975,0.001000}, {980,0.001000}, {985,0.001000}, {990,0.001000}, {995,0.001000}, {1000,0.001000}, {1010,0.001000}, {1020,0.001000}, {1030,0.001000}, {1040,0.004308}, {1050,0.001000}, {1060,0.001000}, {1070,0.001000}, {1080,0.001000}, {1090,0.001000}, {1100,0.001000}, {1110,0.001000}, {1120,0.001000}, {1130,0.001000}, {1140,0.001077}, {1150,0.001000}, {1160,0.001000}, {1170,0.001077}, {1180,0.001231}, {1190,0.001462}, {1200,0.001385}, {1210,0.001769}, {1220,0.001846}, {1230,0.001923}, {1240,0.001923}, {1250,0.001846}, {1260,0.001923}, {1270,0.001923}, {1280,0.001923}, {1290,0.002000}, {1300,0.002000}, {1310,0.002000}, {1320,0.002000}, {1330,0.002000}, {1340,0.002000}, {1350,0.002000}, {1360,0.002000}, {1370,0.002000}, {1380,0.006385}, {1390,0.002000}, {1400,0.002000}, {1410,0.002000}, {1420,0.002000}, {1430,0.002000}, {1440,0.002000}, {1450,0.002000}, {1460,0.002000}, {1470,0.002000}, {1480,0.002000}, {1490,0.002000}, {1500,0.002000}, {1510,0.002000}, {1520,0.002000}, {1530,0.002000}, {1540,0.002000}, {1550,0.002000}, {1560,0.002000}, {1570,0.003692}, {1580,0.002000}, {1590,0.002000}, {1600,0.002000}, {1610,0.002000}, {1620,0.002000}, {1630,0.002000}, {1640,0.002000}, {1650,0.002000}, {1660,0.002000}, {1670,0.002000}, {1680,0.002000}, {1690,0.002077}, {1700,0.002077}, {1710,0.002077}, {1720,0.002000}, {1730,0.002154}, {1740,0.002385}, {1750,0.002385}, {1760,0.002538}, {1770,0.002615}, {1780,0.002538}, {1790,0.002615}, {1800,0.002846}, {1810,0.002846}, {1820,0.002923}, {1830,0.002923}, {1840,0.002923}, {1850,0.002923}, {1860,0.002923}, {1870,0.002923}, {1880,0.002846}, {1890,0.004923}, {1900,0.003000}, {1910,0.003000}, {1920,0.003000}, {1930,0.003000}, {1940,0.003000}, {1950,0.003000}, {1960,0.009308}, {1970,0.003000}, {1980,0.003000}, {1990,0.003000}, {2000,0.003000}};
data["big"]["TypeClassesBodyHOAS"]["cbv"]["user"] = {{1,0.00003509}, {2,0.00007018}, {3,0.00007018}, {4,0.00000000}, {5,0.00006140}, {6,0.00000000}, {7,0.00000000}, {8,0.00003509}, {9,0.00006140}, {10,0.00007018}, {11,0.00005263}, {12,0.00000000}, {13,0.00003509}, {14,0.00003509}, {15,0.00000000}, {16,0.00003509}, {17,0.00009649}, {18,0.00009649}, {19,0.00003509}, {20,0.00016667}, {21,0.00000000}, {22,0.00007018}, {23,0.00003509}, {24,0.00000000}, {25,0.00003509}, {26,0.00010526}, {27,0.00009649}, {28,0.00014035}, {29,0.00000000}, {30,0.00006140}, {31,0.00020175}, {32,0.00009649}, {33,0.00009649}, {34,0.00016667}, {35,0.00010526}, {36,0.00009649}, {37,0.00003509}, {38,0.00014035}, {39,0.00006140}, {40,0.00020175}, {41,0.00010526}, {42,0.00007018}, {43,0.00016667}, {44,0.00000000}, {45,0.00007018}, {46,0.00000000}, {47,0.00006140}, {48,0.00009649}, {49,0.00017544}, {50,0.00003509}, {51,0.00009649}, {52,0.00017544}, {53,0.00012281}, {54,0.00014035}, {55,0.00009649}, {56,0.00006140}, {57,0.00000000}, {58,0.00024561}, {59,0.00010526}, {60,0.00003509}, {61,0.00016667}, {62,0.00010526}, {63,0.00013158}, {64,0.00010526}, {65,0.00014912}, {66,0.00010526}, {67,0.00002632}, {68,0.00003509}, {69,0.00012281}, {70,0.00010526}, {71,0.00009649}, {72,0.00008772}, {73,0.00014035}, {74,0.00003509}, {75,0.00017544}, {76,0.00014035}, {77,0.00017544}, {78,0.00003509}, {79,0.00012281}, {80,0.00027193}, {81,0.00006140}, {82,0.00007018}, {83,0.00015789}, {84,0.00013158}, {85,0.00010526}, {86,0.00009804}, {87,0.00010784}, {88,0.00011765}, {89,0.00014706}, {90,0.00010784}, {91,0.00002941}, {92,0.00006863}, {93,0.00027451}, {94,0.00015686}, {95,0.00022549}, {96,0.00019608}, {97,0.00010784}, {98,0.00018627}, {99,0.00028431}, {100,0.00019608}, {101,0.00006863}, {102,0.00007843}, {103,0.00019608}, {104,0.00010784}, {105,0.00017647}, {106,0.00010784}, {107,0.00029412}, {108,0.00025490}, {109,0.00017647}, {110,0.00012745}, {111,0.00033333}, {112,0.00030392}, {113,0.00047059}, {114,0.00010784}, {115,0.00022549}, {116,0.00015686}, {117,0.00019608}, {118,0.00027451}, {119,0.00011765}, {120,0.00031373}, {121,0.00027451}, {122,0.00021569}, {123,0.00018627}, {124,0.00025490}, {125,0.00022549}, {126,0.00018627}, {127,0.00025490}, {128,0.00035294}, {129,0.00011765}, {130,0.00028431}, {131,0.00038235}, {132,0.00007843}, {133,0.00016667}, {134,0.00019608}, {135,0.00026471}, {136,0.00019608}, {137,0.00026471}, {138,0.00022549}, {139,0.00027451}, {140,0.00034314}, {141,0.00015686}, {142,0.00023529}, {143,0.00029412}, {144,0.00009804}, {145,0.00022549}, {146,0.00029412}, {147,0.00026471}, {148,0.00043137}, {149,0.00014706}, {150,0.00026471}, {151,0.00019608}, {152,0.00029412}, {153,0.00024510}, {154,0.00033333}, {155,0.00010784}, {156,0.00021569}, {157,0.00021569}, {158,0.01346078}, {159,0.00029412}, {160,0.00038235}, {161,0.00037255}, {162,0.00045098}, {163,0.00011765}, {164,0.00011765}, {165,0.00029412}, {166,0.00019608}, {167,0.00033333}, {168,0.00024510}, {169,0.00022549}, {170,0.00018627}, {171,0.00026471}, {172,0.00037255}, {173,0.00026471}, {174,0.00037255}, {175,0.00031373}, {176,0.00011765}, {177,0.00023529}, {178,0.00024510}, {179,0.00038235}, {180,0.00039216}, {181,0.00034314}, {182,0.00021569}, {183,0.00042157}, {184,0.00034314}, {185,0.00021569}, {186,0.00018627}, {187,0.00050980}, {188,0.00050000}, {189,0.00023529}, {190,0.00037255}, {191,0.00047059}, {192,0.00045098}, {193,0.00023529}, {194,0.00039216}, {195,0.00031373}, {196,0.00027451}, {197,0.00033333}, {198,0.00052941}, {199,0.00043137}, {200,0.00045098}, {201,0.00038235}, {202,0.00041176}, {203,0.00034314}, {204,0.00025490}, {205,0.00039216}, {206,0.00038235}, {207,0.00019608}, {208,0.00042157}, {209,0.00042157}, {210,0.00027451}, {211,0.00028431}, {212,0.00038235}, {213,0.00047059}, {214,0.00021569}, {215,0.00042157}, {216,0.00055882}, {217,0.00050980}, {218,0.00052941}, {219,0.00026471}, {220,0.00045098}, {221,0.00032353}, {222,0.00037255}, {223,0.00038235}, {224,0.00032353}, {225,0.00060784}, {226,0.00039216}, {227,0.00030392}, {228,0.00038235}, {229,0.00027451}, {230,0.00034314}, {231,0.00030392}, {232,0.00045098}, {233,0.00034314}, {234,0.00032353}, {235,0.00039216}, {236,0.00011765}, {237,0.00026471}, {238,0.00050000}, {239,0.00067647}, {240,0.00027451}, {241,0.00039216}, {242,0.00032353}, {243,0.00042157}, {244,0.00040196}, {245,0.00061765}, {246,0.00052941}, {247,0.00040196}, {248,0.00040196}, {249,0.00020588}, {250,0.00051961}, {251,0.00044118}, {252,0.00045098}, {253,0.00058824}, {254,0.00048039}, {255,0.00042157}, {256,0.00063725}, {257,0.00043137}, {258,0.00032353}, {259,0.00025490}, {260,0.00026471}, {261,0.00057843}, {262,0.00034314}, {263,0.00026471}, {264,0.00031373}, {265,0.00034314}, {266,0.00060784}, {267,0.00025490}, {268,0.00041176}, {269,0.00034314}, {270,0.00037255}, {271,0.00042157}, {272,0.00050000}, {273,0.00038235}, {274,0.00058824}, {275,0.00056863}, {276,0.00061765}, {277,0.00055882}, {278,0.00065686}, {279,0.00052941}, {280,0.00042157}, {281,0.00063725}, {282,0.00031373}, {283,0.00035294}, {284,0.00040196}, {285,0.00047059}, {286,0.00052941}, {287,0.00040196}, {288,0.00042157}, {289,0.00049020}, {290,0.00065686}, {291,0.00061765}, {292,0.00057843}, {293,0.00026471}, {294,0.00045098}, {295,0.00045098}, {296,0.00057843}, {297,0.00052941}, {298,0.00050000}, {299,0.00026471}, {300,0.00050980}, {301,0.00042574}, {302,0.00053465}, {303,0.00048515}, {304,0.00047525}, {305,0.00053465}, {306,0.00057426}, {307,0.00061386}, {308,0.00053465}, {309,0.00046535}, {310,0.00038614}, {311,0.00055446}, {312,0.00049505}, {313,0.00070297}, {314,0.00063366}, {315,0.00053465}, {316,0.00045545}, {317,0.00058416}, {318,0.00047525}, {319,0.00044554}, {320,0.00036634}, {321,0.00073267}, {322,0.00059406}, {323,0.00062376}, {324,0.00064356}, {325,0.00037624}, {326,0.00029703}, {327,0.00060396}, {328,0.00081188}, {329,0.00052475}, {330,0.00076238}, {331,0.00052475}, {332,0.00031683}, {333,0.00053465}, {334,0.00042574}, {335,0.00058416}, {336,0.00067327}, {337,0.00050495}, {338,0.00055446}, {339,0.00051485}, {340,0.00073267}, {341,0.00069307}, {342,0.00072277}, {343,0.00034653}, {344,0.00078218}, {345,0.00065347}, {346,0.00045545}, {347,0.00060396}, {348,0.00034653}, {349,0.00077228}, {350,0.00089109}, {351,0.00084158}, {352,0.00035644}, {353,0.00065347}, {354,0.00072277}, {355,0.00053465}, {356,0.00055446}, {357,0.00056436}, {358,0.00058416}, {359,0.00049505}, {360,0.00045545}, {361,0.00075248}, {362,0.00082178}, {363,0.00022772}, {364,0.00048515}, {365,0.00073267}, {366,0.00039604}, {367,0.00053465}, {368,0.00055446}, {369,0.00087129}, {370,0.00074257}, {371,0.00059406}, {372,0.00063366}, {373,0.00069307}, {374,0.00055446}, {375,0.00042574}, {376,0.000231}, {377,0.000231}, {378,0.000231}, {379,0.001231}, {380,0.000462}, {381,0.000462}, {382,0.000462}, {383,0.000000}, {384,0.001077}, {385,0.000923}, {386,0.000769}, {387,0.000769}, {388,0.000462}, {389,0.000231}, {390,0.000923}, {391,0.000462}, {392,0.000462}, {393,0.000692}, {394,0.000231}, {395,0.001000}, {396,0.000462}, {397,0.000231}, {398,0.000692}, {399,0.000231}, {400,0.000923}, {401,0.000462}, {402,0.000231}, {403,0.000231}, {404,0.000308}, {405,0.000462}, {406,0.000692}, {407,0.000000}, {408,0.000000}, {409,0.000231}, {410,0.000923}, {411,0.000231}, {412,0.000692}, {413,0.000692}, {414,0.000231}, {415,0.000231}, {416,0.000769}, {417,0.000000}, {418,0.000462}, {419,0.000692}, {420,0.000923}, {421,0.000462}, {422,0.001154}, {423,0.000462}, {424,0.000231}, {425,0.000231}, {426,0.000231}, {427,0.000308}, {428,0.000000}, {429,0.000692}, {430,0.000000}, {431,0.000923}, {432,0.000769}, {433,0.000231}, {434,0.001308}, {435,0.000692}, {436,0.000692}, {437,0.000692}, {438,0.000231}, {439,0.000923}, {440,0.000231}, {441,0.000538}, {442,0.000231}, {443,0.000231}, {444,0.000462}, {445,0.000231}, {446,0.001154}, {447,0.000692}, {448,0.000462}, {449,0.000462}, {450,0.001385}, {451,0.001000}, {452,0.000231}, {453,0.000769}, {454,0.000000}, {455,0.001000}, {456,0.000692}, {457,0.000308}, {458,0.000462}, {459,0.000692}, {460,0.000769}, {461,0.000462}, {462,0.000692}, {463,0.000231}, {464,0.000923}, {465,0.000923}, {466,0.000462}, {467,0.000462}, {468,0.000923}, {469,0.000462}, {470,0.000923}, {471,0.001154}, {472,0.000231}, {473,0.000462}, {474,0.000846}, {475,0.001000}, {476,0.000769}, {477,0.001000}, {478,0.001308}, {479,0.000231}, {480,0.000462}, {481,0.001154}, {482,0.000000}, {483,0.000462}, {484,0.000000}, {485,0.000538}, {486,0.000692}, {487,0.000462}, {488,0.000923}, {489,0.000462}, {490,0.000000}, {491,0.000769}, {492,0.000692}, {493,0.000231}, {494,0.000231}, {495,0.000692}, {496,0.000923}, {497,0.000231}, {498,0.012231}, {499,0.010692}, {500,0.011154}, {505,0.008846}, {510,0.000692}, {515,0.000462}, {520,0.000923}, {525,0.000462}, {530,0.000923}, {535,0.001231}, {540,0.001385}, {545,0.000462}, {550,0.000692}, {555,0.000923}, {560,0.000923}, {565,0.000923}, {570,0.001231}, {575,0.000692}, {580,0.000923}, {585,0.000692}, {590,0.000692}, {595,0.000923}, {600,0.000769}, {605,0.001462}, {610,0.000462}, {615,0.000462}, {620,0.001231}, {625,0.000308}, {630,0.000692}, {635,0.000923}, {640,0.000923}, {645,0.000769}, {650,0.000692}, {655,0.000923}, {660,0.000692}, {665,0.000923}, {670,0.000462}, {675,0.001231}, {680,0.000923}, {685,0.000923}, {690,0.001000}, {695,0.000692}, {700,0.000000}, {705,0.000462}, {710,0.000923}, {715,0.001231}, {720,0.000769}, {725,0.013462}, {730,0.001615}, {735,0.001615}, {740,0.001615}, {745,0.000231}, {750,0.001231}, {755,0.001154}, {760,0.000692}, {765,0.001000}, {770,0.001154}, {775,0.000692}, {780,0.001462}, {785,0.000692}, {790,0.001923}, {795,0.000462}, {800,0.000462}, {805,0.001462}, {810,0.001077}, {815,0.001385}, {820,0.001231}, {825,0.000923}, {830,0.001000}, {835,0.001154}, {840,0.000462}, {845,0.001385}, {850,0.001385}, {855,0.000462}, {860,0.001000}, {865,0.001154}, {870,0.001692}, {875,0.001154}, {880,0.001154}, {885,0.001308}, {890,0.001846}, {895,0.000692}, {900,0.000462}, {905,0.000769}, {910,0.001154}, {915,0.001385}, {920,0.000923}, {925,0.000692}, {930,0.001462}, {935,0.000692}, {940,0.001000}, {945,0.000846}, {950,0.000769}, {955,0.001000}, {960,0.001154}, {965,0.001615}, {970,0.001000}, {975,0.000462}, {980,0.001231}, {985,0.001769}, {990,0.001231}, {995,0.001462}, {1000,0.000462}, {1010,0.000769}, {1020,0.001462}, {1030,0.000769}, {1040,0.004385}, {1050,0.001692}, {1060,0.001692}, {1070,0.000231}, {1080,0.001462}, {1090,0.001154}, {1100,0.000923}, {1110,0.001154}, {1120,0.001462}, {1130,0.001154}, {1140,0.001692}, {1150,0.002231}, {1160,0.001462}, {1170,0.001385}, {1180,0.001462}, {1190,0.001692}, {1200,0.000692}, {1210,0.002231}, {1220,0.001000}, {1230,0.001923}, {1240,0.001923}, {1250,0.001923}, {1260,0.001154}, {1270,0.001385}, {1280,0.002154}, {1290,0.002154}, {1300,0.001462}, {1310,0.001692}, {1320,0.001615}, {1330,0.001615}, {1340,0.002077}, {1350,0.000923}, {1360,0.001231}, {1370,0.001923}, {1380,0.005538}, {1390,0.001692}, {1400,0.002000}, {1410,0.002231}, {1420,0.002154}, {1430,0.002000}, {1440,0.001462}, {1450,0.003000}, {1460,0.002385}, {1470,0.002154}, {1480,0.001462}, {1490,0.002077}, {1500,0.002462}, {1510,0.001923}, {1520,0.002538}, {1530,0.002462}, {1540,0.001846}, {1550,0.001846}, {1560,0.002077}, {1570,0.003462}, {1580,0.002615}, {1590,0.002000}, {1600,0.002692}, {1610,0.002231}, {1620,0.002077}, {1630,0.002692}, {1640,0.002308}, {1650,0.002846}, {1660,0.002692}, {1670,0.002846}, {1680,0.002769}, {1690,0.003231}, {1700,0.002846}, {1710,0.002615}, {1720,0.002308}, {1730,0.002846}, {1740,0.003231}, {1750,0.002231}, {1760,0.003538}, {1770,0.002846}, {1780,0.003462}, {1790,0.002462}, {1800,0.003154}, {1810,0.002846}, {1820,0.003000}, {1830,0.002769}, {1840,0.003077}, {1850,0.002308}, {1860,0.002462}, {1870,0.002769}, {1880,0.003385}, {1890,0.005154}, {1900,0.003154}, {1910,0.002769}, {1920,0.002462}, {1930,0.003077}, {1940,0.002769}, {1950,0.003000}, {1960,0.009231}, {1970,0.002846}, {1980,0.003462}, {1990,0.001923}, {2000,0.003154}};
data["big"]["TypeClassesBodyHOAS"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00003509}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00003509}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00003922}, {92,0.00000000}, {93,0.00000000}, {94,0.00007843}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00003922}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00003922}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00003922}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00003922}, {150,0.00000000}, {151,0.00003922}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00003922}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00003922}, {191,0.00000000}, {192,0.00003922}, {193,0.00003922}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00003922}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00003922}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00003922}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00003922}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00002941}, {242,0.00000000}, {243,0.00000000}, {244,0.00003922}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00003922}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00003922}, {280,0.00003922}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00003922}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00003960}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00003960}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00003960}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000000}, {400,0.000000}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}, {451,0.000000}, {452,0.000000}, {453,0.000000}, {454,0.000000}, {455,0.000000}, {456,0.000000}, {457,0.000000}, {458,0.000000}, {459,0.000000}, {460,0.000000}, {461,0.000000}, {462,0.000000}, {463,0.000000}, {464,0.000000}, {465,0.000000}, {466,0.000000}, {467,0.000000}, {468,0.000000}, {469,0.000000}, {470,0.000000}, {471,0.000000}, {472,0.000000}, {473,0.000000}, {474,0.000000}, {475,0.000000}, {476,0.000000}, {477,0.000000}, {478,0.000000}, {479,0.000000}, {480,0.000000}, {481,0.000000}, {482,0.000000}, {483,0.000000}, {484,0.000000}, {485,0.000000}, {486,0.000000}, {487,0.000308}, {488,0.000000}, {489,0.000000}, {490,0.000000}, {491,0.000000}, {492,0.000000}, {493,0.000000}, {494,0.000000}, {495,0.000000}, {496,0.000000}, {497,0.000000}, {498,0.000000}, {499,0.000000}, {500,0.000000}, {505,0.000000}, {510,0.000000}, {515,0.000000}, {520,0.000000}, {525,0.000000}, {530,0.000000}, {535,0.000000}, {540,0.000000}, {545,0.000000}, {550,0.000000}, {555,0.000000}, {560,0.000000}, {565,0.000000}, {570,0.000000}, {575,0.000000}, {580,0.000000}, {585,0.000000}, {590,0.000000}, {595,0.000000}, {600,0.000000}, {605,0.000000}, {610,0.000000}, {615,0.000000}, {620,0.000000}, {625,0.000000}, {630,0.000000}, {635,0.000000}, {640,0.000308}, {645,0.000000}, {650,0.000000}, {655,0.000000}, {660,0.000000}, {665,0.000000}, {670,0.000000}, {675,0.000000}, {680,0.000000}, {685,0.000000}, {690,0.000000}, {695,0.000000}, {700,0.000000}, {705,0.000000}, {710,0.000000}, {715,0.000000}, {720,0.000000}, {725,0.000000}, {730,0.000000}, {735,0.000000}, {740,0.000000}, {745,0.000000}, {750,0.000000}, {755,0.000000}, {760,0.000000}, {765,0.000000}, {770,0.000000}, {775,0.000000}, {780,0.000000}, {785,0.000000}, {790,0.000000}, {795,0.000000}, {800,0.000000}, {805,0.000000}, {810,0.000000}, {815,0.000000}, {820,0.000000}, {825,0.000000}, {830,0.000000}, {835,0.000000}, {840,0.000000}, {845,0.000000}, {850,0.000000}, {855,0.000000}, {860,0.000000}, {865,0.000000}, {870,0.000000}, {875,0.000000}, {880,0.000000}, {885,0.000000}, {890,0.000000}, {895,0.000000}, {900,0.000000}, {905,0.000000}, {910,0.000000}, {915,0.000000}, {920,0.000000}, {925,0.000000}, {930,0.000000}, {935,0.000000}, {940,0.000000}, {945,0.000000}, {950,0.000000}, {955,0.000000}, {960,0.000000}, {965,0.000000}, {970,0.000000}, {975,0.000000}, {980,0.000000}, {985,0.000000}, {990,0.000000}, {995,0.000000}, {1000,0.000000}, {1010,0.000000}, {1020,0.000000}, {1030,0.000000}, {1040,0.000000}, {1050,0.000000}, {1060,0.000000}, {1070,0.000000}, {1080,0.000000}, {1090,0.000000}, {1100,0.000000}, {1110,0.000000}, {1120,0.000000}, {1130,0.000000}, {1140,0.000000}, {1150,0.000000}, {1160,0.000000}, {1170,0.000000}, {1180,0.000000}, {1190,0.000000}, {1200,0.000000}, {1210,0.000000}, {1220,0.000000}, {1230,0.000000}, {1240,0.000000}, {1250,0.000000}, {1260,0.000000}, {1270,0.000000}, {1280,0.000000}, {1290,0.000000}, {1300,0.000000}, {1310,0.000000}, {1320,0.000000}, {1330,0.000000}, {1340,0.000000}, {1350,0.000000}, {1360,0.000000}, {1370,0.000000}, {1380,0.000000}, {1390,0.000000}, {1400,0.000000}, {1410,0.000000}, {1420,0.000000}, {1430,0.000000}, {1440,0.000000}, {1450,0.000000}, {1460,0.000000}, {1470,0.000000}, {1480,0.000000}, {1490,0.000000}, {1500,0.000000}, {1510,0.000000}, {1520,0.000000}, {1530,0.000000}, {1540,0.000000}, {1550,0.000000}, {1560,0.000000}, {1570,0.000000}, {1580,0.000000}, {1590,0.000000}, {1600,0.000000}, {1610,0.000000}, {1620,0.000000}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000000}, {1680,0.000000}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000000}, {1730,0.000000}, {1740,0.000000}, {1750,0.000000}, {1760,0.000000}, {1770,0.000000}, {1780,0.000000}, {1790,0.000000}, {1800,0.000000}, {1810,0.000000}, {1820,0.000000}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000000}, {1900,0.000000}, {1910,0.000000}, {1920,0.000000}, {1930,0.000000}, {1940,0.000000}, {1950,0.000000}, {1960,0.000000}, {1970,0.000000}, {1980,0.000000}, {1990,0.000000}, {2000,0.000000}};
data["big"]["TypeClassesBodyHOAS"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00001754}, {77,0.00000000}, {78,0.00006140}, {79,0.00020175}, {80,0.00000877}, {81,0.00032456}, {82,0.00000000}, {83,0.00039474}, {84,0.00000000}, {85,0.00042982}, {86,0.00000000}, {87,0.00060784}, {88,0.00000000}, {89,0.00064706}, {90,0.00000000}, {91,0.00080392}, {92,0.00000980}, {93,0.00097059}, {94,0.00008824}, {95,0.00100000}, {96,0.00069608}, {97,0.00099020}, {98,0.00099020}, {99,0.00003922}, {100,0.00100000}, {101,0.00100000}, {102,0.00003922}, {103,0.00100000}, {104,0.00100000}, {105,0.00016667}, {106,0.00099020}, {107,0.00099020}, {108,0.00067647}, {109,0.00100980}, {110,0.00100000}, {111,0.00100000}, {112,0.00096078}, {113,0.00117647}, {114,0.00100000}, {115,0.00100000}, {116,0.00100000}, {117,0.00100000}, {118,0.00187255}, {119,0.00166667}, {120,0.00100980}, {121,0.00100980}, {122,0.00100000}, {123,0.00100000}, {124,0.00100000}, {125,0.00100000}, {126,0.00233333}, {127,0.00200000}, {128,0.00200000}, {129,0.00199020}, {130,0.00199020}, {131,0.00199020}, {132,0.00200000}, {133,0.00200000}, {134,0.00200000}, {135,0.00100000}, {136,0.00100000}, {137,0.00100000}, {138,0.00100000}, {139,0.00103922}, {140,0.00151961}, {141,0.00199020}, {142,0.00199020}, {143,0.00200000}, {144,0.00101961}, {145,0.00107843}, {146,0.00199020}, {147,0.00199020}, {148,0.00100000}, {149,0.00115686}, {150,0.00200000}, {151,0.00211765}, {152,0.00104902}, {153,0.00200000}, {154,0.00200980}, {155,0.00110784}, {156,0.00199020}, {157,0.00243137}, {158,0.00200000}, {159,0.00201961}, {160,0.00190196}, {161,0.00200000}, {162,0.00175490}, {163,0.00200000}, {164,0.00198039}, {165,0.00200980}, {166,0.00200000}, {167,0.00203922}, {168,0.00200980}, {169,0.00310784}, {170,0.00200000}, {171,0.00200000}, {172,0.00244118}, {173,0.00200980}, {174,0.00200000}, {175,0.00284314}, {176,0.00201961}, {177,0.00212745}, {178,0.00299020}, {179,0.00288235}, {180,0.00201961}, {181,0.00200000}, {182,0.00200000}, {183,0.00300000}, {184,0.00300000}, {185,0.00298039}, {186,0.00270588}, {187,0.00221569}, {188,0.00207843}, {189,0.00206863}, {190,0.00205882}, {191,0.00207843}, {192,0.00209804}, {193,0.00224510}, {194,0.00248039}, {195,0.00291176}, {196,0.00300000}, {197,0.00300000}, {198,0.00299020}, {199,0.00304902}, {200,0.00217647}, {201,0.00278431}, {202,0.00300000}, {203,0.00300980}, {204,0.00373529}, {205,0.00296078}, {206,0.00300000}, {207,0.00309804}, {208,0.00300000}, {209,0.00300000}, {210,0.00367647}, {211,0.00300000}, {212,0.00303922}, {213,0.00300000}, {214,0.00303922}, {215,0.00300980}, {216,0.00304902}, {217,0.00300000}, {218,0.00305882}, {219,0.00300000}, {220,0.00393137}, {221,0.00301961}, {222,0.01559804}, {223,0.00384314}, {224,0.00303922}, {225,0.00301961}, {226,0.00399020}, {227,0.00336275}, {228,0.00304902}, {229,0.00301961}, {230,0.00400000}, {231,0.00399020}, {232,0.00398039}, {233,0.00387255}, {234,0.00354902}, {235,0.00338235}, {236,0.00346078}, {237,0.00352941}, {238,0.00362745}, {239,0.00384314}, {240,0.00387255}, {241,0.00400000}, {242,0.00400980}, {243,0.00400980}, {244,0.00400980}, {245,0.00408824}, {246,0.01529412}, {247,0.00400000}, {248,0.00400980}, {249,0.00412745}, {250,0.05226471}, {251,0.00400000}, {252,0.00409804}, {253,0.00400980}, {254,0.00401961}, {255,0.00492157}, {256,0.00402941}, {257,0.00402941}, {258,0.00400000}, {259,0.00402941}, {260,0.00402941}, {261,0.00401961}, {262,0.00404902}, {263,0.00404902}, {264,0.00408824}, {265,0.00417647}, {266,0.00433333}, {267,0.00440196}, {268,0.00474510}, {269,0.00483333}, {270,0.00481373}, {271,0.00493137}, {272,0.00495098}, {273,0.00500000}, {274,0.00500000}, {275,0.00500000}, {276,0.00500000}, {277,0.00500000}, {278,0.00500000}, {279,0.00500980}, {280,0.00500980}, {281,0.00500980}, {282,0.00500980}, {283,0.00500980}, {284,0.00502941}, {285,0.00501961}, {286,0.00500980}, {287,0.00504902}, {288,0.00503922}, {289,0.00500980}, {290,0.00507843}, {291,0.00515686}, {292,0.00533333}, {293,0.00550980}, {294,0.00562745}, {295,0.00576471}, {296,0.00584314}, {297,0.00586275}, {298,0.00596078}, {299,0.00594118}, {300,0.00599020}, {301,0.00600000}, {302,0.00600000}, {303,0.00600000}, {304,0.00600990}, {305,0.00600990}, {306,0.00600990}, {307,0.00601980}, {308,0.00600000}, {309,0.00600000}, {310,0.00601980}, {311,0.00604950}, {312,0.00605941}, {313,0.00604950}, {314,0.00605941}, {315,0.00624752}, {316,0.00638614}, {317,0.00640594}, {318,0.00666337}, {319,0.00675248}, {320,0.00681188}, {321,0.00687129}, {322,0.00688119}, {323,0.00694059}, {324,0.00699010}, {325,0.00700000}, {326,0.00700000}, {327,0.00701980}, {328,0.00700000}, {329,0.00700000}, {330,0.00700990}, {331,0.00701980}, {332,0.00703960}, {333,0.00702970}, {334,0.00705941}, {335,0.00705941}, {336,0.00716832}, {337,0.00719802}, {338,0.00739604}, {339,0.00742574}, {340,0.00769307}, {341,0.00776238}, {342,0.00784158}, {343,0.00785149}, {344,0.00791089}, {345,0.00794059}, {346,0.00795050}, {347,0.00800990}, {348,0.00800990}, {349,0.00800990}, {350,0.00801980}, {351,0.00802970}, {352,0.00800000}, {353,0.00800990}, {354,0.00802970}, {355,0.00809901}, {356,0.00813861}, {357,0.00814851}, {358,0.00828713}, {359,0.00833663}, {360,0.00852475}, {361,0.00858416}, {362,0.00879208}, {363,0.00881188}, {364,0.00889109}, {365,0.00887129}, {366,0.00896040}, {367,0.00895050}, {368,0.00899010}, {369,0.00903960}, {370,0.00902970}, {371,0.00900000}, {372,0.00905941}, {373,0.00901980}, {374,0.00906931}, {375,0.00911881}, {376,0.009846}, {377,0.009846}, {378,0.009923}, {379,0.009692}, {380,0.009769}, {381,0.009846}, {382,0.009615}, {383,0.009923}, {384,0.009692}, {385,0.009692}, {386,0.009846}, {387,0.009692}, {388,0.009923}, {389,0.009923}, {390,0.010077}, {391,0.010077}, {392,0.010231}, {393,0.010308}, {394,0.010231}, {395,0.010308}, {396,0.010308}, {397,0.010231}, {398,0.010231}, {399,0.010462}, {400,0.010615}, {401,0.010615}, {402,0.010615}, {403,0.010615}, {404,0.010615}, {405,0.010692}, {406,0.010692}, {407,0.010692}, {408,0.011154}, {409,0.011000}, {410,0.011077}, {411,0.011308}, {412,0.011385}, {413,0.011231}, {414,0.011308}, {415,0.011385}, {416,0.011385}, {417,0.011308}, {418,0.011615}, {419,0.011615}, {420,0.011615}, {421,0.011692}, {422,0.011846}, {423,0.011692}, {424,0.011692}, {425,0.011846}, {426,0.012077}, {427,0.011846}, {428,0.012000}, {429,0.012231}, {430,0.012308}, {431,0.012462}, {432,0.012462}, {433,0.012462}, {434,0.012462}, {435,0.012462}, {436,0.012538}, {437,0.012769}, {438,0.012769}, {439,0.012923}, {440,0.012923}, {441,0.012769}, {442,0.012769}, {443,0.012769}, {444,0.013077}, {445,0.013231}, {446,0.013308}, {447,0.013462}, {448,0.013308}, {449,0.013385}, {450,0.013462}, {451,0.013615}, {452,0.013692}, {453,0.013769}, {454,0.013769}, {455,0.013769}, {456,0.013846}, {457,0.013692}, {458,0.013769}, {459,0.013846}, {460,0.014077}, {461,0.014000}, {462,0.014462}, {463,0.014308}, {464,0.014308}, {465,0.014231}, {466,0.014538}, {467,0.014692}, {468,0.014692}, {469,0.014692}, {470,0.014846}, {471,0.014769}, {472,0.014769}, {473,0.014923}, {474,0.014846}, {475,0.014769}, {476,0.015154}, {477,0.015077}, {478,0.015154}, {479,0.015385}, {480,0.015615}, {481,0.015538}, {482,0.015692}, {483,0.015692}, {484,0.015769}, {485,0.015615}, {486,0.015769}, {487,0.015769}, {488,0.016000}, {489,0.015923}, {490,0.015923}, {491,0.016077}, {492,0.016000}, {493,0.016154}, {494,0.016385}, {495,0.016385}, {496,0.016769}, {497,0.016692}, {498,0.016769}, {499,0.016769}, {500,0.016769}, {505,0.017000}, {510,0.017538}, {515,0.017846}, {520,0.029769}, {525,0.028846}, {530,0.029231}, {535,0.029769}, {540,0.030000}, {545,0.032385}, {550,0.031385}, {555,0.032385}, {560,0.033000}, {565,0.033385}, {570,0.035462}, {575,0.034462}, {580,0.035385}, {585,0.036846}, {590,0.022846}, {595,0.023308}, {600,0.023769}, {605,0.023923}, {610,0.024692}, {615,0.025077}, {620,0.025231}, {625,0.025846}, {630,0.026000}, {635,0.026615}, {640,0.026769}, {645,0.027077}, {650,0.027538}, {655,0.028077}, {660,0.028538}, {665,0.028769}, {670,0.029231}, {675,0.029846}, {680,0.030154}, {685,0.030538}, {690,0.031308}, {695,0.031692}, {700,0.032154}, {705,0.032385}, {710,0.032923}, {715,0.033538}, {720,0.033615}, {725,0.034154}, {730,0.034462}, {735,0.035231}, {740,0.048846}, {745,0.049385}, {750,0.049231}, {755,0.050769}, {760,0.053615}, {765,0.053000}, {770,0.055769}, {775,0.054846}, {780,0.055538}, {785,0.056077}, {790,0.057462}, {795,0.152692}, {800,0.059154}, {805,0.144308}, {810,0.061154}, {815,0.062462}, {820,0.064308}, {825,0.064231}, {830,0.068769}, {835,0.045385}, {840,0.046077}, {845,0.046615}, {850,0.047000}, {855,0.047615}, {860,0.048154}, {865,0.048846}, {870,0.049231}, {875,0.049923}, {880,0.050231}, {885,0.050769}, {890,0.051538}, {895,0.052154}, {900,0.052923}, {905,0.053154}, {910,0.062538}, {915,0.065154}, {920,0.065154}, {925,0.066154}, {930,0.066846}, {935,0.067000}, {940,0.069385}, {945,0.071000}, {950,0.072538}, {955,0.075308}, {960,0.075000}, {965,0.075231}, {970,0.076154}, {975,0.078538}, {980,0.080231}, {985,0.078846}, {990,0.201769}, {995,0.083769}, {1000,0.085462}, {1010,0.087308}, {1020,0.210231}, {1030,0.068923}, {1040,0.070615}, {1050,0.077923}, {1060,0.080231}, {1070,0.082154}, {1080,0.084462}, {1090,0.087154}, {1100,0.092615}, {1110,0.094846}, {1120,0.098154}, {1130,0.100615}, {1140,0.103462}, {1150,0.103615}, {1160,0.107615}, {1170,0.113154}, {1180,0.115846}, {1190,0.094923}, {1200,0.098077}, {1210,0.102231}, {1220,0.104615}, {1230,0.110154}, {1240,0.111846}, {1250,0.116308}, {1260,0.117462}, {1270,0.121923}, {1280,0.124846}, {1290,0.130846}, {1300,0.133308}, {1310,0.136615}, {1320,0.139000}, {1330,0.118308}, {1340,0.122154}, {1350,0.126077}, {1360,0.130538}, {1370,0.133462}, {1380,0.137538}, {1390,0.140308}, {1400,0.147385}, {1410,0.149538}, {1420,0.155692}, {1430,0.156077}, {1440,0.344692}, {1450,0.140231}, {1460,0.144308}, {1470,0.147538}, {1480,0.151000}, {1490,0.155385}, {1500,0.160000}, {1510,0.163308}, {1520,0.168231}, {1530,0.173846}, {1540,0.174154}, {1550,0.179462}, {1560,0.183385}, {1570,0.163462}, {1580,0.169000}, {1590,0.171923}, {1600,0.176231}, {1610,0.401308}, {1620,0.185308}, {1630,0.190846}, {1640,0.194154}, {1650,0.197692}, {1660,0.201077}, {1670,0.432231}, {1680,0.187538}, {1690,0.191538}, {1700,0.196308}, {1710,0.199846}, {1720,0.206385}, {1730,0.209846}, {1740,0.213615}, {1750,0.219462}, {1760,0.225769}, {1770,0.230692}, {1780,0.209615}, {1790,0.214769}, {1800,0.219615}, {1810,0.224615}, {1820,0.230000}, {1830,0.233615}, {1840,0.466154}, {1850,0.244615}, {1860,0.247154}, {1870,0.251462}, {1880,0.233077}, {1890,0.238308}, {1900,0.244923}, {1910,0.247385}, {1920,0.254462}, {1930,0.259000}, {1940,0.266615}, {1950,0.268231}, {1960,0.574769}, {1970,0.261846}, {1980,0.261231}, {1990,0.269154}, {2000,0.272000}};
data["big"]["TypeClassesBodyHOAS"]["eval lazy"]["user"] = {{1,0.00000000}, {2,0.00002632}, {3,0.00009649}, {4,0.00002632}, {5,0.00003509}, {6,0.00009649}, {7,0.00007018}, {8,0.00012281}, {9,0.00007018}, {10,0.00002632}, {11,0.00010526}, {12,0.00013158}, {13,0.00007018}, {14,0.00010526}, {15,0.00014035}, {16,0.00006140}, {17,0.00003509}, {18,0.00010526}, {19,0.00006140}, {20,0.00007018}, {21,0.00023684}, {22,0.00013158}, {23,0.00014035}, {24,0.00016667}, {25,0.00003509}, {26,0.00014035}, {27,0.00002632}, {28,0.00022807}, {29,0.00017544}, {30,0.00010526}, {31,0.00025439}, {32,0.00003509}, {33,0.00020175}, {34,0.00016667}, {35,0.00014035}, {36,0.00014035}, {37,0.00026316}, {38,0.00024561}, {39,0.00024561}, {40,0.00022807}, {41,0.00021053}, {42,0.00016667}, {43,0.00033333}, {44,0.00029825}, {45,0.00057018}, {46,0.00040351}, {47,0.00011404}, {48,0.00030702}, {49,0.00042105}, {50,0.00031579}, {51,0.00025439}, {52,0.00037719}, {53,0.00011404}, {54,0.00041228}, {55,0.00028947}, {56,0.00043860}, {57,0.00035965}, {58,0.00043860}, {59,0.00028947}, {60,0.00050877}, {61,0.00062281}, {62,0.00033333}, {63,0.00043860}, {64,0.00031579}, {65,0.00042105}, {66,0.00054386}, {67,0.00068421}, {68,0.00059649}, {69,0.00057895}, {70,0.00068421}, {71,0.00065789}, {72,0.00047368}, {73,0.00071930}, {74,0.00075439}, {75,0.00068421}, {76,0.00082456}, {77,0.00074561}, {78,0.00075439}, {79,0.00066667}, {80,0.00075439}, {81,0.00104386}, {82,0.00065789}, {83,0.00105263}, {84,0.00051754}, {85,0.00110526}, {86,0.00108824}, {87,0.00086275}, {88,0.00077451}, {89,0.00107843}, {90,0.00084314}, {91,0.00101961}, {92,0.00081373}, {93,0.00121569}, {94,0.00095098}, {95,0.00150000}, {96,0.00095098}, {97,0.00152941}, {98,0.00150000}, {99,0.00094118}, {100,0.00133333}, {101,0.00137255}, {102,0.00096078}, {103,0.00147059}, {104,0.00127451}, {105,0.00097059}, {106,0.00183333}, {107,0.00122549}, {108,0.00080392}, {109,0.00192157}, {110,0.00181373}, {111,0.00113725}, {112,0.00098039}, {113,0.00175490}, {114,0.00195098}, {115,0.00106863}, {116,0.00102941}, {117,0.00102941}, {118,0.00188235}, {119,0.00221569}, {120,0.00186275}, {121,0.00153922}, {122,0.00153922}, {123,0.00158824}, {124,0.00115686}, {125,0.00147059}, {126,0.00283333}, {127,0.00218627}, {128,0.00232353}, {129,0.00201961}, {130,0.00218627}, {131,0.00254902}, {132,0.00218627}, {133,0.00248039}, {134,0.00282353}, {135,0.00145098}, {136,0.00172549}, {137,0.00123529}, {138,0.00184314}, {139,0.00168627}, {140,0.00166667}, {141,0.00228431}, {142,0.00248039}, {143,0.00243137}, {144,0.00126471}, {145,0.00158824}, {146,0.00201961}, {147,0.00264706}, {148,0.00153922}, {149,0.00158824}, {150,0.00198039}, {151,0.00257843}, {152,0.00192157}, {153,0.00218627}, {154,0.00280392}, {155,0.00183333}, {156,0.00211765}, {157,0.00276471}, {158,0.00193137}, {159,0.00299020}, {160,0.00218627}, {161,0.00254902}, {162,0.00199020}, {163,0.00249020}, {164,0.00216667}, {165,0.00264706}, {166,0.00227451}, {167,0.00287255}, {168,0.00190196}, {169,0.00313725}, {170,0.00226471}, {171,0.00230392}, {172,0.00280392}, {173,0.00227451}, {174,0.00226471}, {175,0.00238235}, {176,0.00275490}, {177,0.00269608}, {178,0.00337255}, {179,0.00309804}, {180,0.00289216}, {181,0.00250980}, {182,0.00231373}, {183,0.00337255}, {184,0.00304902}, {185,0.00288235}, {186,0.00293137}, {187,0.00321569}, {188,0.00306863}, {189,0.00279412}, {190,0.00285294}, {191,0.00262745}, {192,0.00274510}, {193,0.00293137}, {194,0.00282353}, {195,0.00270588}, {196,0.00276471}, {197,0.00311765}, {198,0.00345098}, {199,0.00365686}, {200,0.00291176}, {201,0.00292157}, {202,0.00293137}, {203,0.00345098}, {204,0.00382353}, {205,0.00299020}, {206,0.00323529}, {207,0.00379412}, {208,0.00320588}, {209,0.00307843}, {210,0.00383333}, {211,0.00308824}, {212,0.00368627}, {213,0.00301961}, {214,0.00351961}, {215,0.00329412}, {216,0.00361765}, {217,0.00328431}, {218,0.00343137}, {219,0.00334314}, {220,0.00397059}, {221,0.00345098}, {222,0.01561765}, {223,0.00388235}, {224,0.00370588}, {225,0.00346078}, {226,0.00396078}, {227,0.00381373}, {228,0.00353922}, {229,0.00366667}, {230,0.00423529}, {231,0.00426471}, {232,0.00411765}, {233,0.00391176}, {234,0.00388235}, {235,0.00379412}, {236,0.00373529}, {237,0.00384314}, {238,0.00388235}, {239,0.00386275}, {240,0.00385294}, {241,0.00407843}, {242,0.00417647}, {243,0.00442157}, {244,0.00460784}, {245,0.00458824}, {246,0.01518627}, {247,0.00401961}, {248,0.00414706}, {249,0.00480392}, {250,0.05214706}, {251,0.00438235}, {252,0.00487255}, {253,0.00438235}, {254,0.00457843}, {255,0.00493137}, {256,0.00437255}, {257,0.00429412}, {258,0.00443137}, {259,0.00431373}, {260,0.00448039}, {261,0.00446078}, {262,0.00460784}, {263,0.00462745}, {264,0.00480392}, {265,0.00447059}, {266,0.00468627}, {267,0.00468627}, {268,0.00473529}, {269,0.00502941}, {270,0.00482353}, {271,0.00474510}, {272,0.00497059}, {273,0.00508824}, {274,0.00483333}, {275,0.00490196}, {276,0.00487255}, {277,0.00499020}, {278,0.00544118}, {279,0.00517647}, {280,0.00516667}, {281,0.00526471}, {282,0.00504902}, {283,0.00547059}, {284,0.00563725}, {285,0.00562745}, {286,0.00576471}, {287,0.00543137}, {288,0.00523529}, {289,0.00512745}, {290,0.00543137}, {291,0.00538235}, {292,0.00574510}, {293,0.00564706}, {294,0.00566667}, {295,0.00562745}, {296,0.00581373}, {297,0.00580392}, {298,0.00612745}, {299,0.00587255}, {300,0.00619608}, {301,0.00627723}, {302,0.00621782}, {303,0.00621782}, {304,0.00614851}, {305,0.00648515}, {306,0.00595050}, {307,0.00607921}, {308,0.00600000}, {309,0.00634653}, {310,0.00623762}, {311,0.00659406}, {312,0.00646535}, {313,0.00656436}, {314,0.00633663}, {315,0.00667327}, {316,0.00667327}, {317,0.00682178}, {318,0.00674257}, {319,0.00671287}, {320,0.00671287}, {321,0.00694059}, {322,0.00689109}, {323,0.00668317}, {324,0.00697030}, {325,0.00701980}, {326,0.00679208}, {327,0.00686139}, {328,0.00695050}, {329,0.00735644}, {330,0.00716832}, {331,0.00730693}, {332,0.00736634}, {333,0.00727723}, {334,0.00728713}, {335,0.00749505}, {336,0.00764356}, {337,0.00748515}, {338,0.00767327}, {339,0.00764356}, {340,0.00763366}, {341,0.00768317}, {342,0.00774257}, {343,0.00768317}, {344,0.00786139}, {345,0.00786139}, {346,0.00799010}, {347,0.00790099}, {348,0.00803960}, {349,0.00814851}, {350,0.00824752}, {351,0.00841584}, {352,0.00841584}, {353,0.00845545}, {354,0.00852475}, {355,0.00824752}, {356,0.00844554}, {357,0.00848515}, {358,0.00856436}, {359,0.00845545}, {360,0.00879208}, {361,0.00838614}, {362,0.00878218}, {363,0.00861386}, {364,0.00876238}, {365,0.00897030}, {366,0.00887129}, {367,0.00888119}, {368,0.00864356}, {369,0.00869307}, {370,0.00908911}, {371,0.00908911}, {372,0.00919802}, {373,0.00920792}, {374,0.00936634}, {375,0.00909901}, {376,0.010000}, {377,0.009154}, {378,0.009154}, {379,0.009308}, {380,0.009385}, {381,0.010000}, {382,0.009231}, {383,0.009692}, {384,0.010000}, {385,0.009538}, {386,0.009615}, {387,0.010000}, {388,0.009154}, {389,0.009385}, {390,0.009769}, {391,0.009077}, {392,0.010000}, {393,0.009923}, {394,0.009846}, {395,0.009692}, {396,0.009846}, {397,0.010846}, {398,0.009615}, {399,0.010231}, {400,0.009692}, {401,0.009923}, {402,0.010692}, {403,0.009615}, {404,0.010615}, {405,0.011231}, {406,0.011154}, {407,0.010615}, {408,0.010077}, {409,0.010154}, {410,0.011154}, {411,0.010538}, {412,0.011000}, {413,0.010538}, {414,0.011231}, {415,0.011308}, {416,0.011538}, {417,0.011000}, {418,0.011692}, {419,0.011308}, {420,0.011308}, {421,0.011231}, {422,0.011538}, {423,0.012692}, {424,0.011615}, {425,0.011077}, {426,0.012308}, {427,0.011462}, {428,0.011923}, {429,0.011923}, {430,0.011538}, {431,0.011538}, {432,0.013077}, {433,0.011923}, {434,0.012154}, {435,0.012077}, {436,0.011538}, {437,0.011846}, {438,0.012231}, {439,0.012308}, {440,0.014154}, {441,0.012462}, {442,0.012923}, {443,0.013538}, {444,0.012846}, {445,0.012154}, {446,0.012923}, {447,0.013000}, {448,0.013077}, {449,0.014154}, {450,0.014385}, {451,0.013000}, {452,0.013308}, {453,0.012846}, {454,0.014231}, {455,0.014000}, {456,0.014077}, {457,0.012846}, {458,0.013231}, {459,0.013231}, {460,0.013154}, {461,0.013923}, {462,0.013615}, {463,0.014308}, {464,0.014769}, {465,0.014154}, {466,0.014538}, {467,0.015000}, {468,0.015231}, {469,0.014846}, {470,0.015538}, {471,0.015462}, {472,0.015308}, {473,0.014846}, {474,0.014692}, {475,0.014846}, {476,0.015615}, {477,0.015308}, {478,0.015308}, {479,0.015231}, {480,0.015154}, {481,0.014769}, {482,0.015692}, {483,0.015692}, {484,0.015000}, {485,0.015692}, {486,0.015769}, {487,0.015308}, {488,0.015923}, {489,0.016077}, {490,0.016154}, {491,0.015846}, {492,0.016154}, {493,0.015923}, {494,0.016231}, {495,0.016462}, {496,0.016000}, {497,0.016308}, {498,0.016923}, {499,0.016538}, {500,0.016231}, {505,0.017923}, {510,0.018615}, {515,0.017615}, {520,0.029923}, {525,0.029615}, {530,0.029462}, {535,0.030538}, {540,0.030308}, {545,0.032077}, {550,0.031154}, {555,0.032308}, {560,0.033538}, {565,0.034154}, {570,0.035923}, {575,0.034615}, {580,0.035231}, {585,0.036538}, {590,0.023000}, {595,0.023615}, {600,0.023538}, {605,0.023615}, {610,0.024538}, {615,0.025231}, {620,0.025154}, {625,0.026385}, {630,0.025000}, {635,0.026615}, {640,0.026231}, {645,0.027462}, {650,0.028538}, {655,0.028154}, {660,0.029000}, {665,0.029000}, {670,0.028846}, {675,0.029615}, {680,0.030077}, {685,0.031615}, {690,0.031538}, {695,0.032769}, {700,0.032538}, {705,0.032692}, {710,0.032462}, {715,0.033462}, {720,0.033308}, {725,0.034308}, {730,0.034538}, {735,0.035923}, {740,0.049923}, {745,0.049308}, {750,0.049000}, {755,0.050538}, {760,0.053538}, {765,0.051385}, {770,0.055923}, {775,0.054462}, {780,0.055154}, {785,0.055615}, {790,0.057692}, {795,0.152615}, {800,0.058692}, {805,0.144615}, {810,0.060923}, {815,0.063692}, {820,0.064308}, {825,0.064308}, {830,0.068923}, {835,0.045000}, {840,0.046308}, {845,0.045692}, {850,0.046615}, {855,0.047538}, {860,0.047308}, {865,0.048923}, {870,0.049231}, {875,0.049615}, {880,0.050154}, {885,0.050462}, {890,0.051385}, {895,0.051923}, {900,0.052923}, {905,0.053077}, {910,0.062923}, {915,0.065077}, {920,0.064538}, {925,0.066692}, {930,0.067231}, {935,0.067538}, {940,0.069385}, {945,0.070538}, {950,0.073154}, {955,0.075231}, {960,0.075308}, {965,0.074692}, {970,0.076077}, {975,0.078462}, {980,0.080000}, {985,0.077846}, {990,0.200231}, {995,0.082769}, {1000,0.084231}, {1010,0.087308}, {1020,0.210077}, {1030,0.069615}, {1040,0.071000}, {1050,0.077538}, {1060,0.079615}, {1070,0.080923}, {1080,0.084308}, {1090,0.086923}, {1100,0.092846}, {1110,0.095692}, {1120,0.098385}, {1130,0.100462}, {1140,0.102385}, {1150,0.104308}, {1160,0.108385}, {1170,0.113923}, {1180,0.115692}, {1190,0.094000}, {1200,0.098308}, {1210,0.101462}, {1220,0.104154}, {1230,0.110308}, {1240,0.112538}, {1250,0.115615}, {1260,0.117615}, {1270,0.121385}, {1280,0.124769}, {1290,0.130846}, {1300,0.133538}, {1310,0.136385}, {1320,0.138615}, {1330,0.118692}, {1340,0.121615}, {1350,0.125923}, {1360,0.130385}, {1370,0.133000}, {1380,0.137769}, {1390,0.140231}, {1400,0.147308}, {1410,0.149538}, {1420,0.155538}, {1430,0.155077}, {1440,0.343538}, {1450,0.139000}, {1460,0.145154}, {1470,0.147077}, {1480,0.150923}, {1490,0.155923}, {1500,0.159231}, {1510,0.163692}, {1520,0.168385}, {1530,0.174769}, {1540,0.172923}, {1550,0.178923}, {1560,0.183846}, {1570,0.163923}, {1580,0.167769}, {1590,0.171385}, {1600,0.176077}, {1610,0.401077}, {1620,0.185077}, {1630,0.190154}, {1640,0.194000}, {1650,0.196692}, {1660,0.200615}, {1670,0.432000}, {1680,0.187923}, {1690,0.192231}, {1700,0.195538}, {1710,0.198769}, {1720,0.206308}, {1730,0.209308}, {1740,0.213923}, {1750,0.219692}, {1760,0.226000}, {1770,0.230231}, {1780,0.209923}, {1790,0.214308}, {1800,0.219385}, {1810,0.223538}, {1820,0.229692}, {1830,0.233000}, {1840,0.467231}, {1850,0.244769}, {1860,0.246385}, {1870,0.251077}, {1880,0.232692}, {1890,0.237538}, {1900,0.244538}, {1910,0.246769}, {1920,0.254769}, {1930,0.258538}, {1940,0.267000}, {1950,0.267846}, {1960,0.572846}, {1970,0.262154}, {1980,0.260769}, {1990,0.268769}, {2000,0.270923}};
data["big"]["TypeClassesBodyHOAS"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00003509}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00003509}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00003922}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00003922}, {102,0.00000000}, {103,0.00000000}, {104,0.00003922}, {105,0.00000000}, {106,0.00000000}, {107,0.00003922}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00003922}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00007843}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00003922}, {128,0.00000000}, {129,0.00003922}, {130,0.00000000}, {131,0.00000000}, {132,0.00003922}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00003922}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00003922}, {145,0.00000000}, {146,0.00000000}, {147,0.00003922}, {148,0.00000000}, {149,0.00003922}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00003922}, {154,0.00000000}, {155,0.00000000}, {156,0.00003922}, {157,0.00000000}, {158,0.00003922}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00003922}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00003922}, {175,0.00003922}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00003922}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00003922}, {194,0.00003922}, {195,0.00000000}, {196,0.00003922}, {197,0.00000000}, {198,0.00003922}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00003922}, {204,0.00000000}, {205,0.00000000}, {206,0.00003922}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00003922}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00003922}, {222,0.00000000}, {223,0.00003922}, {224,0.00003922}, {225,0.00003922}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00002941}, {230,0.00003922}, {231,0.00000000}, {232,0.00000000}, {233,0.00003922}, {234,0.00000000}, {235,0.00000000}, {236,0.00003922}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00003922}, {241,0.00003922}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00003922}, {252,0.00000000}, {253,0.00003922}, {254,0.00000000}, {255,0.00007843}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00003922}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00003922}, {264,0.00000000}, {265,0.00003922}, {266,0.00000000}, {267,0.00000000}, {268,0.00003922}, {269,0.00000000}, {270,0.00000000}, {271,0.00003922}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00003922}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00003922}, {283,0.00003922}, {284,0.00000000}, {285,0.00003922}, {286,0.00000000}, {287,0.00000000}, {288,0.00003922}, {289,0.00000000}, {290,0.00003922}, {291,0.00003922}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00006931}, {307,0.00002970}, {308,0.00011881}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00003960}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00007921}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00003960}, {332,0.00000000}, {333,0.00000000}, {334,0.00005941}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00007921}, {341,0.00003960}, {342,0.00007921}, {343,0.00003960}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00007921}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00003960}, {357,0.00002970}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00003960}, {362,0.00007921}, {363,0.00003960}, {364,0.00000000}, {365,0.00000000}, {366,0.00011881}, {367,0.00003960}, {368,0.00000000}, {369,0.00000000}, {370,0.00003960}, {371,0.00003960}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00003960}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000308}, {386,0.000000}, {387,0.000000}, {388,0.000308}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000000}, {400,0.000000}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000000}, {412,0.000000}, {413,0.000308}, {414,0.000308}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000308}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}, {451,0.000000}, {452,0.000000}, {453,0.000000}, {454,0.000000}, {455,0.000000}, {456,0.000000}, {457,0.000000}, {458,0.000000}, {459,0.000000}, {460,0.000000}, {461,0.000000}, {462,0.000000}, {463,0.000000}, {464,0.000000}, {465,0.000000}, {466,0.000000}, {467,0.000000}, {468,0.000000}, {469,0.000000}, {470,0.000000}, {471,0.000000}, {472,0.000000}, {473,0.000000}, {474,0.000000}, {475,0.000000}, {476,0.000000}, {477,0.000000}, {478,0.000000}, {479,0.000000}, {480,0.000000}, {481,0.000000}, {482,0.000308}, {483,0.000000}, {484,0.000000}, {485,0.000000}, {486,0.000000}, {487,0.000000}, {488,0.000000}, {489,0.000000}, {490,0.000308}, {491,0.000000}, {492,0.000000}, {493,0.000000}, {494,0.000000}, {495,0.000000}, {496,0.000000}, {497,0.000000}, {498,0.000000}, {499,0.000000}, {500,0.000000}, {505,0.000000}, {510,0.000000}, {515,0.000000}, {520,0.000000}, {525,0.000000}, {530,0.000000}, {535,0.000000}, {540,0.000000}, {545,0.000000}, {550,0.000308}, {555,0.000000}, {560,0.000000}, {565,0.000000}, {570,0.000000}, {575,0.000000}, {580,0.000308}, {585,0.000308}, {590,0.000000}, {595,0.000000}, {600,0.000000}, {605,0.000000}, {610,0.000308}, {615,0.000000}, {620,0.000000}, {625,0.000000}, {630,0.000000}, {635,0.000000}, {640,0.000000}, {645,0.000000}, {650,0.000000}, {655,0.000000}, {660,0.000000}, {665,0.000000}, {670,0.000000}, {675,0.000000}, {680,0.000000}, {685,0.000000}, {690,0.000000}, {695,0.000308}, {700,0.000000}, {705,0.000000}, {710,0.000000}, {715,0.000000}, {720,0.000000}, {725,0.000000}, {730,0.000000}, {735,0.000000}, {740,0.000000}, {745,0.000000}, {750,0.000000}, {755,0.000000}, {760,0.000000}, {765,0.000000}, {770,0.000000}, {775,0.000538}, {780,0.000000}, {785,0.000000}, {790,0.000000}, {795,0.000000}, {800,0.000000}, {805,0.000000}, {810,0.000000}, {815,0.000308}, {820,0.000000}, {825,0.000000}, {830,0.000000}, {835,0.000000}, {840,0.000000}, {845,0.000000}, {850,0.000000}, {855,0.000000}, {860,0.000000}, {865,0.000000}, {870,0.000000}, {875,0.000000}, {880,0.000000}, {885,0.000000}, {890,0.000000}, {895,0.000000}, {900,0.000000}, {905,0.000000}, {910,0.000000}, {915,0.000000}, {920,0.000000}, {925,0.000000}, {930,0.000000}, {935,0.000308}, {940,0.000000}, {945,0.000000}, {950,0.000000}, {955,0.000000}, {960,0.000000}, {965,0.000000}, {970,0.000000}, {975,0.000308}, {980,0.000231}, {985,0.000308}, {990,0.000000}, {995,0.000000}, {1000,0.000000}, {1010,0.000000}, {1020,0.000000}, {1030,0.000000}, {1040,0.000000}, {1050,0.000000}, {1060,0.000000}, {1070,0.000000}, {1080,0.000000}, {1090,0.000000}, {1100,0.000000}, {1110,0.000000}, {1120,0.000000}, {1130,0.000000}, {1140,0.000308}, {1150,0.000000}, {1160,0.000000}, {1170,0.000000}, {1180,0.000000}, {1190,0.000000}, {1200,0.000000}, {1210,0.000000}, {1220,0.000000}, {1230,0.000000}, {1240,0.000000}, {1250,0.000000}, {1260,0.000000}, {1270,0.000000}, {1280,0.000000}, {1290,0.000308}, {1300,0.000000}, {1310,0.000000}, {1320,0.000000}, {1330,0.000000}, {1340,0.000000}, {1350,0.000000}, {1360,0.000000}, {1370,0.000000}, {1380,0.000000}, {1390,0.000000}, {1400,0.000000}, {1410,0.000000}, {1420,0.000000}, {1430,0.000000}, {1440,0.000000}, {1450,0.000000}, {1460,0.000000}, {1470,0.000308}, {1480,0.000615}, {1490,0.000000}, {1500,0.000000}, {1510,0.000000}, {1520,0.000000}, {1530,0.000000}, {1540,0.000000}, {1550,0.000000}, {1560,0.000000}, {1570,0.000000}, {1580,0.000000}, {1590,0.000000}, {1600,0.000000}, {1610,0.000000}, {1620,0.000000}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000000}, {1680,0.000000}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000000}, {1730,0.000000}, {1740,0.000000}, {1750,0.000000}, {1760,0.000000}, {1770,0.000308}, {1780,0.000000}, {1790,0.000308}, {1800,0.000000}, {1810,0.000000}, {1820,0.000308}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000000}, {1900,0.000000}, {1910,0.000308}, {1920,0.000308}, {1930,0.000000}, {1940,0.000000}, {1950,0.000231}, {1960,0.000308}, {1970,0.000000}, {1980,0.000000}, {1990,0.000308}, {2000,0.000615}};
data["big"]["TypeClassesBodyHOAS"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000000}, {400,0.000000}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}, {451,0.000000}, {452,0.000000}, {453,0.000000}, {454,0.000000}, {455,0.000000}, {456,0.000000}, {457,0.000000}, {458,0.000000}, {459,0.000000}, {460,0.000000}, {461,0.000000}, {462,0.000000}, {463,0.000000}, {464,0.000000}, {465,0.000000}, {466,0.000000}, {467,0.000000}, {468,0.000000}, {469,0.000000}, {470,0.000000}, {471,0.000000}, {472,0.000000}, {473,0.000000}, {474,0.000000}, {475,0.000000}, {476,0.000000}, {477,0.000000}, {478,0.000000}, {479,0.000000}, {480,0.000000}, {481,0.000000}, {482,0.000000}, {483,0.000000}, {484,0.000000}, {485,0.000000}, {486,0.000000}, {487,0.000000}, {488,0.000000}, {489,0.000000}, {490,0.000000}, {491,0.000000}, {492,0.000000}, {493,0.000000}, {494,0.000000}, {495,0.000000}, {496,0.000000}, {497,0.000000}, {498,0.000000}, {499,0.000000}, {500,0.000000}, {505,0.000000}, {510,0.000000}, {515,0.000000}, {520,0.000000}, {525,0.000000}, {530,0.000000}, {535,0.000000}, {540,0.000000}, {545,0.000000}, {550,0.000000}, {555,0.000000}, {560,0.000000}, {565,0.000000}, {570,0.000000}, {575,0.000000}, {580,0.000000}, {585,0.000000}, {590,0.000000}, {595,0.000000}, {600,0.000000}, {605,0.000000}, {610,0.000000}, {615,0.000000}, {620,0.000000}, {625,0.000000}, {630,0.000000}, {635,0.000000}, {640,0.000000}, {645,0.000000}, {650,0.000000}, {655,0.000000}, {660,0.000000}, {665,0.000000}, {670,0.000000}, {675,0.000000}, {680,0.000000}, {685,0.000000}, {690,0.000000}, {695,0.000000}, {700,0.000000}, {705,0.000000}, {710,0.000000}, {715,0.000000}, {720,0.000000}, {725,0.000000}, {730,0.000000}, {735,0.000000}, {740,0.000000}, {745,0.000000}, {750,0.000000}, {755,0.000000}, {760,0.000000}, {765,0.000000}, {770,0.000000}, {775,0.000000}, {780,0.000000}, {785,0.000000}, {790,0.000000}, {795,0.000000}, {800,0.000000}, {805,0.000000}, {810,0.000000}, {815,0.000000}, {820,0.000000}, {825,0.000000}, {830,0.000000}, {835,0.000000}, {840,0.000000}, {845,0.000000}, {850,0.000000}, {855,0.000000}, {860,0.000000}, {865,0.000000}, {870,0.000000}, {875,0.000000}, {880,0.000000}, {885,0.000000}, {890,0.000000}, {895,0.000000}, {900,0.000000}, {905,0.000000}, {910,0.000000}, {915,0.000000}, {920,0.000000}, {925,0.000000}, {930,0.000000}, {935,0.000000}, {940,0.000000}, {945,0.000000}, {950,0.000000}, {955,0.000000}, {960,0.000000}, {965,0.000000}, {970,0.000000}, {975,0.000000}, {980,0.000000}, {985,0.000000}, {990,0.000000}, {995,0.000000}, {1000,0.000000}, {1010,0.000000}, {1020,0.000000}, {1030,0.000000}, {1040,0.000000}, {1050,0.000000}, {1060,0.000000}, {1070,0.000000}, {1080,0.000000}, {1090,0.000000}, {1100,0.000000}, {1110,0.000000}, {1120,0.000000}, {1130,0.000000}, {1140,0.000000}, {1150,0.000000}, {1160,0.000000}, {1170,0.000000}, {1180,0.000000}, {1190,0.000000}, {1200,0.000000}, {1210,0.000000}, {1220,0.000000}, {1230,0.000000}, {1240,0.000000}, {1250,0.000000}, {1260,0.000000}, {1270,0.000000}, {1280,0.000000}, {1290,0.000000}, {1300,0.000000}, {1310,0.000000}, {1320,0.000000}, {1330,0.000000}, {1340,0.000000}, {1350,0.000000}, {1360,0.000000}, {1370,0.000000}, {1380,0.000077}, {1390,0.000000}, {1400,0.000000}, {1410,0.000000}, {1420,0.000000}, {1430,0.000077}, {1440,0.000077}, {1450,0.000000}, {1460,0.000077}, {1470,0.000077}, {1480,0.000077}, {1490,0.000077}, {1500,0.000077}, {1510,0.000077}, {1520,0.000154}, {1530,0.000154}, {1540,0.000154}, {1550,0.000077}, {1560,0.000308}, {1570,0.000154}, {1580,0.000385}, {1590,0.000385}, {1600,0.000462}, {1610,0.000692}, {1620,0.000692}, {1630,0.000692}, {1640,0.000769}, {1650,0.001000}, {1660,0.001000}, {1670,0.001000}, {1680,0.001000}, {1690,0.001000}, {1700,0.001000}, {1710,0.001000}, {1720,0.001000}, {1730,0.001000}, {1740,0.001000}, {1750,0.001000}, {1760,0.001000}, {1770,0.001000}, {1780,0.001000}, {1790,0.001000}, {1800,0.001000}, {1810,0.001000}, {1820,0.001000}, {1830,0.001000}, {1840,0.001000}, {1850,0.001000}, {1860,0.001000}, {1870,0.001000}, {1880,0.001000}, {1890,0.001000}, {1900,0.001000}, {1910,0.001000}, {1920,0.001000}, {1930,0.001000}, {1940,0.001000}, {1950,0.001000}, {1960,0.001000}, {1970,0.001000}, {1980,0.001000}, {1990,0.001000}, {2000,0.001000}};
data["big"]["TypeClassesBodyHOAS"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00002632}, {3,0.00000000}, {4,0.00000000}, {5,0.00003509}, {6,0.00000000}, {7,0.00000000}, {8,0.00003509}, {9,0.00003509}, {10,0.00000000}, {11,0.00007018}, {12,0.00003509}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00003509}, {17,0.00006140}, {18,0.00007018}, {19,0.00003509}, {20,0.00002632}, {21,0.00002632}, {22,0.00007018}, {23,0.00010526}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00003509}, {28,0.00003509}, {29,0.00000000}, {30,0.00002632}, {31,0.00000000}, {32,0.00000000}, {33,0.00003509}, {34,0.00007018}, {35,0.00000000}, {36,0.00003509}, {37,0.00010526}, {38,0.00003509}, {39,0.00003509}, {40,0.00002632}, {41,0.00000000}, {42,0.00003509}, {43,0.00006140}, {44,0.00008772}, {45,0.00002632}, {46,0.00007018}, {47,0.00003509}, {48,0.00000000}, {49,0.00002632}, {50,0.00000000}, {51,0.00007018}, {52,0.00007018}, {53,0.00000000}, {54,0.00003509}, {55,0.00009649}, {56,0.00010526}, {57,0.00010526}, {58,0.00003509}, {59,0.00007018}, {60,0.00010526}, {61,0.00010526}, {62,0.00007018}, {63,0.00000000}, {64,0.00007018}, {65,0.00007018}, {66,0.00000000}, {67,0.00003509}, {68,0.00007018}, {69,0.00000000}, {70,0.00016667}, {71,0.00003509}, {72,0.00013158}, {73,0.00007018}, {74,0.00003509}, {75,0.00003509}, {76,0.00007018}, {77,0.00003509}, {78,0.00006140}, {79,0.00009649}, {80,0.00000000}, {81,0.00007018}, {82,0.00000000}, {83,0.00000000}, {84,0.00009649}, {85,0.00009649}, {86,0.00018627}, {87,0.00011765}, {88,0.00003922}, {89,0.00003922}, {90,0.00019608}, {91,0.00006863}, {92,0.00003922}, {93,0.00007843}, {94,0.00003922}, {95,0.00007843}, {96,0.00003922}, {97,0.00003922}, {98,0.00003922}, {99,0.00000000}, {100,0.00010784}, {101,0.00011765}, {102,0.00015686}, {103,0.00000000}, {104,0.00003922}, {105,0.00002941}, {106,0.00014706}, {107,0.00014706}, {108,0.00014706}, {109,0.00007843}, {110,0.00003922}, {111,0.00014706}, {112,0.00011765}, {113,0.00009804}, {114,0.00007843}, {115,0.00007843}, {116,0.00007843}, {117,0.00007843}, {118,0.00019608}, {119,0.00007843}, {120,0.00006863}, {121,0.00003922}, {122,0.00002941}, {123,0.00010784}, {124,0.00007843}, {125,0.00007843}, {126,0.00013725}, {127,0.00003922}, {128,0.00007843}, {129,0.00006863}, {130,0.00007843}, {131,0.00007843}, {132,0.00021569}, {133,0.00007843}, {134,0.00015686}, {135,0.00018627}, {136,0.00000000}, {137,0.00007843}, {138,0.00003922}, {139,0.00018627}, {140,0.00019608}, {141,0.00021569}, {142,0.00000000}, {143,0.00021569}, {144,0.00011765}, {145,0.00010784}, {146,0.00007843}, {147,0.00003922}, {148,0.00015686}, {149,0.00006863}, {150,0.00011765}, {151,0.00013725}, {152,0.00013725}, {153,0.00007843}, {154,0.00011765}, {155,0.00011765}, {156,0.00007843}, {157,0.00003922}, {158,0.00006863}, {159,0.00018627}, {160,0.00007843}, {161,0.00011765}, {162,0.00003922}, {163,0.00026471}, {164,0.00010784}, {165,0.00003922}, {166,0.00006863}, {167,0.00005882}, {168,0.00018627}, {169,0.00007843}, {170,0.00014706}, {171,0.00011765}, {172,0.00019608}, {173,0.00014706}, {174,0.00014706}, {175,0.00011765}, {176,0.00015686}, {177,0.00018627}, {178,0.00011765}, {179,0.00023529}, {180,0.00018627}, {181,0.00022549}, {182,0.00015686}, {183,0.00026471}, {184,0.00017647}, {185,0.00010784}, {186,0.00022549}, {187,0.00000000}, {188,0.00011765}, {189,0.00003922}, {190,0.00011765}, {191,0.00015686}, {192,0.00014706}, {193,0.00014706}, {194,0.00022549}, {195,0.00021569}, {196,0.00027451}, {197,0.00018627}, {198,0.00027451}, {199,0.00014706}, {200,0.00006863}, {201,0.00007843}, {202,0.00007843}, {203,0.00006863}, {204,0.00007843}, {205,0.00009804}, {206,0.00006863}, {207,0.00003922}, {208,0.00011765}, {209,0.00023529}, {210,0.00011765}, {211,0.00007843}, {212,0.00019608}, {213,0.00022549}, {214,0.00007843}, {215,0.00002941}, {216,0.00018627}, {217,0.00010784}, {218,0.00021569}, {219,0.00011765}, {220,0.00011765}, {221,0.00017647}, {222,0.00010784}, {223,0.00022549}, {224,0.00012745}, {225,0.00007843}, {226,0.00012745}, {227,0.00028431}, {228,0.00011765}, {229,0.00002941}, {230,0.00010784}, {231,0.00014706}, {232,0.00025490}, {233,0.00018627}, {234,0.00011765}, {235,0.00036275}, {236,0.00011765}, {237,0.00026471}, {238,0.00015686}, {239,0.00015686}, {240,0.00014706}, {241,0.00014706}, {242,0.00015686}, {243,0.00015686}, {244,0.00007843}, {245,0.00026471}, {246,0.00015686}, {247,0.00010784}, {248,0.00017647}, {249,0.00002941}, {250,0.00003922}, {251,0.00019608}, {252,0.00006863}, {253,0.00007843}, {254,0.00014706}, {255,0.00018627}, {256,0.00017647}, {257,0.00019608}, {258,0.00015686}, {259,0.00015686}, {260,0.00010784}, {261,0.00017647}, {262,0.00018627}, {263,0.00011765}, {264,0.00019608}, {265,0.00019608}, {266,0.00011765}, {267,0.00026471}, {268,0.00011765}, {269,0.00015686}, {270,0.00003922}, {271,0.00018627}, {272,0.00017647}, {273,0.00026471}, {274,0.00025490}, {275,0.00026471}, {276,0.00016667}, {277,0.00031373}, {278,0.00007843}, {279,0.00019608}, {280,0.00029412}, {281,0.00011765}, {282,0.00015686}, {283,0.00015686}, {284,0.00007843}, {285,0.00018627}, {286,0.00026471}, {287,0.00014706}, {288,0.00018627}, {289,0.00014706}, {290,0.00027451}, {291,0.00027451}, {292,0.00011765}, {293,0.00023529}, {294,0.00011765}, {295,0.00018627}, {296,0.00028431}, {297,0.00029412}, {298,0.00010784}, {299,0.00026471}, {300,0.00031373}, {301,0.00018812}, {302,0.00029703}, {303,0.00015842}, {304,0.00007921}, {305,0.00000000}, {306,0.00017822}, {307,0.00014851}, {308,0.00031683}, {309,0.00036634}, {310,0.00022772}, {311,0.00011881}, {312,0.00023762}, {313,0.00031683}, {314,0.00034653}, {315,0.00026733}, {316,0.00015842}, {317,0.00017822}, {318,0.00022772}, {319,0.00029703}, {320,0.00017822}, {321,0.00009901}, {322,0.00031683}, {323,0.00034653}, {324,0.00019802}, {325,0.00023762}, {326,0.00027723}, {327,0.00023762}, {328,0.00022772}, {329,0.00019802}, {330,0.00025743}, {331,0.00027723}, {332,0.00015842}, {333,0.00022772}, {334,0.00016832}, {335,0.00011881}, {336,0.00018812}, {337,0.00027723}, {338,0.00033663}, {339,0.00015842}, {340,0.00014851}, {341,0.00026733}, {342,0.00031683}, {343,0.00018812}, {344,0.00030693}, {345,0.00023762}, {346,0.00019802}, {347,0.00017822}, {348,0.00015842}, {349,0.00002970}, {350,0.00022772}, {351,0.00025743}, {352,0.00033663}, {353,0.00014851}, {354,0.00037624}, {355,0.00034653}, {356,0.00022772}, {357,0.00027723}, {358,0.00033663}, {359,0.00023762}, {360,0.00017822}, {361,0.00022772}, {362,0.00019802}, {363,0.00018812}, {364,0.00025743}, {365,0.00030693}, {366,0.00015842}, {367,0.00037624}, {368,0.00025743}, {369,0.00026733}, {370,0.00026733}, {371,0.00015842}, {372,0.00022772}, {373,0.00026733}, {374,0.00023762}, {375,0.00007921}, {376,0.000231}, {377,0.000231}, {378,0.000000}, {379,0.000692}, {380,0.000462}, {381,0.000000}, {382,0.000231}, {383,0.000000}, {384,0.000000}, {385,0.000231}, {386,0.000308}, {387,0.000000}, {388,0.000692}, {389,0.000000}, {390,0.000000}, {391,0.000462}, {392,0.000538}, {393,0.000231}, {394,0.000462}, {395,0.000231}, {396,0.000846}, {397,0.000000}, {398,0.000231}, {399,0.000231}, {400,0.000538}, {401,0.000462}, {402,0.000000}, {403,0.000769}, {404,0.000231}, {405,0.000231}, {406,0.000000}, {407,0.000692}, {408,0.000923}, {409,0.000462}, {410,0.000231}, {411,0.000308}, {412,0.000308}, {413,0.000231}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000462}, {418,0.000231}, {419,0.000000}, {420,0.000538}, {421,0.000000}, {422,0.000000}, {423,0.000231}, {424,0.000538}, {425,0.000000}, {426,0.000923}, {427,0.000462}, {428,0.000231}, {429,0.000231}, {430,0.000000}, {431,0.000000}, {432,0.000769}, {433,0.000000}, {434,0.000462}, {435,0.000000}, {436,0.000231}, {437,0.000000}, {438,0.000000}, {439,0.000231}, {440,0.000231}, {441,0.000538}, {442,0.000231}, {443,0.000231}, {444,0.000231}, {445,0.000231}, {446,0.001000}, {447,0.000462}, {448,0.000000}, {449,0.000000}, {450,0.000000}, {451,0.000000}, {452,0.000231}, {453,0.000462}, {454,0.000231}, {455,0.000000}, {456,0.000000}, {457,0.000000}, {458,0.000231}, {459,0.000462}, {460,0.000538}, {461,0.000462}, {462,0.000692}, {463,0.000231}, {464,0.000000}, {465,0.000231}, {466,0.000000}, {467,0.000000}, {468,0.000231}, {469,0.000462}, {470,0.000000}, {471,0.000231}, {472,0.000000}, {473,0.000000}, {474,0.000000}, {475,0.000615}, {476,0.000231}, {477,0.000231}, {478,0.000462}, {479,0.000231}, {480,0.000462}, {481,0.000462}, {482,0.000231}, {483,0.000231}, {484,0.000231}, {485,0.000462}, {486,0.000462}, {487,0.000538}, {488,0.000231}, {489,0.000462}, {490,0.000231}, {491,0.000462}, {492,0.000462}, {493,0.000538}, {494,0.000538}, {495,0.000000}, {496,0.000231}, {497,0.000000}, {498,0.000462}, {499,0.000231}, {500,0.000231}, {505,0.000000}, {510,0.000000}, {515,0.000462}, {520,0.000462}, {525,0.000462}, {530,0.000538}, {535,0.000000}, {540,0.000462}, {545,0.001462}, {550,0.000000}, {555,0.000231}, {560,0.000231}, {565,0.000769}, {570,0.000000}, {575,0.000000}, {580,0.000538}, {585,0.000231}, {590,0.000231}, {595,0.000000}, {600,0.000000}, {605,0.000231}, {610,0.000231}, {615,0.000308}, {620,0.000231}, {625,0.000692}, {630,0.001385}, {635,0.000462}, {640,0.000000}, {645,0.000000}, {650,0.000000}, {655,0.000308}, {660,0.000000}, {665,0.000231}, {670,0.000000}, {675,0.000462}, {680,0.000538}, {685,0.000000}, {690,0.000000}, {695,0.000000}, {700,0.000231}, {705,0.000538}, {710,0.001231}, {715,0.000231}, {720,0.000769}, {725,0.000462}, {730,0.000769}, {735,0.000000}, {740,0.000231}, {745,0.000538}, {750,0.000538}, {755,0.000000}, {760,0.000231}, {765,0.000692}, {770,0.000462}, {775,0.000231}, {780,0.001154}, {785,0.000231}, {790,0.000231}, {795,0.000308}, {800,0.000462}, {805,0.000000}, {810,0.000231}, {815,0.000000}, {820,0.000462}, {825,0.000462}, {830,0.000462}, {835,0.000692}, {840,0.000000}, {845,0.000462}, {850,0.000308}, {855,0.001231}, {860,0.000462}, {865,0.000231}, {870,0.000462}, {875,0.000231}, {880,0.000692}, {885,0.000000}, {890,0.000231}, {895,0.000692}, {900,0.000769}, {905,0.000000}, {910,0.000231}, {915,0.001000}, {920,0.000769}, {925,0.000692}, {930,0.000923}, {935,0.000000}, {940,0.001000}, {945,0.000692}, {950,0.000462}, {955,0.000923}, {960,0.000308}, {965,0.000231}, {970,0.000462}, {975,0.001154}, {980,0.000000}, {985,0.000308}, {990,0.001000}, {995,0.000462}, {1000,0.000462}, {1010,0.000231}, {1020,0.000462}, {1030,0.000692}, {1040,0.000462}, {1050,0.000769}, {1060,0.000231}, {1070,0.000538}, {1080,0.000231}, {1090,0.000538}, {1100,0.000846}, {1110,0.000769}, {1120,0.000692}, {1130,0.000923}, {1140,0.000692}, {1150,0.000231}, {1160,0.000231}, {1170,0.000000}, {1180,0.000692}, {1190,0.001000}, {1200,0.000462}, {1210,0.001615}, {1220,0.000692}, {1230,0.000000}, {1240,0.000538}, {1250,0.000538}, {1260,0.000000}, {1270,0.001231}, {1280,0.000231}, {1290,0.000769}, {1300,0.000769}, {1310,0.001462}, {1320,0.000231}, {1330,0.000231}, {1340,0.000462}, {1350,0.000000}, {1360,0.001000}, {1370,0.000462}, {1380,0.000692}, {1390,0.001077}, {1400,0.000538}, {1410,0.000692}, {1420,0.000538}, {1430,0.000923}, {1440,0.000692}, {1450,0.000538}, {1460,0.000462}, {1470,0.000538}, {1480,0.000308}, {1490,0.000231}, {1500,0.001000}, {1510,0.000846}, {1520,0.000692}, {1530,0.000308}, {1540,0.001846}, {1550,0.000846}, {1560,0.000000}, {1570,0.001154}, {1580,0.001154}, {1590,0.001000}, {1600,0.001538}, {1610,0.001462}, {1620,0.000769}, {1630,0.001231}, {1640,0.000615}, {1650,0.001154}, {1660,0.001231}, {1670,0.000769}, {1680,0.000923}, {1690,0.000615}, {1700,0.001231}, {1710,0.001308}, {1720,0.000769}, {1730,0.001462}, {1740,0.000538}, {1750,0.000538}, {1760,0.001154}, {1770,0.000846}, {1780,0.000538}, {1790,0.001077}, {1800,0.000923}, {1810,0.002000}, {1820,0.000538}, {1830,0.001231}, {1840,0.000462}, {1850,0.001462}, {1860,0.001231}, {1870,0.000462}, {1880,0.001385}, {1890,0.001231}, {1900,0.001462}, {1910,0.001154}, {1920,0.000923}, {1930,0.001615}, {1940,0.001231}, {1950,0.000615}, {1960,0.001538}, {1970,0.001692}, {1980,0.002077}, {1990,0.000462}, {2000,0.001462}};
data["big"]["TypeClassesBodyHOAS"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00003509}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00003922}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00003922}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00003922}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00003922}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000000}, {400,0.000000}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}, {451,0.000000}, {452,0.000000}, {453,0.000000}, {454,0.000000}, {455,0.000000}, {456,0.000000}, {457,0.000000}, {458,0.000000}, {459,0.000000}, {460,0.000000}, {461,0.000000}, {462,0.000000}, {463,0.000000}, {464,0.000000}, {465,0.000000}, {466,0.000000}, {467,0.000000}, {468,0.000000}, {469,0.000000}, {470,0.000000}, {471,0.000000}, {472,0.000000}, {473,0.000000}, {474,0.000000}, {475,0.000000}, {476,0.000000}, {477,0.000000}, {478,0.000000}, {479,0.000000}, {480,0.000000}, {481,0.000000}, {482,0.000000}, {483,0.000000}, {484,0.000000}, {485,0.000000}, {486,0.000000}, {487,0.000000}, {488,0.000000}, {489,0.000000}, {490,0.000000}, {491,0.000000}, {492,0.000000}, {493,0.000000}, {494,0.000000}, {495,0.000000}, {496,0.000000}, {497,0.000000}, {498,0.000000}, {499,0.000000}, {500,0.000000}, {505,0.000000}, {510,0.000000}, {515,0.000000}, {520,0.000000}, {525,0.000000}, {530,0.000000}, {535,0.000000}, {540,0.000000}, {545,0.000000}, {550,0.000000}, {555,0.000000}, {560,0.000000}, {565,0.000000}, {570,0.000000}, {575,0.000000}, {580,0.000000}, {585,0.000000}, {590,0.000000}, {595,0.000000}, {600,0.000000}, {605,0.000000}, {610,0.000000}, {615,0.000000}, {620,0.000000}, {625,0.000000}, {630,0.000000}, {635,0.000000}, {640,0.000000}, {645,0.000000}, {650,0.000000}, {655,0.000000}, {660,0.000000}, {665,0.000000}, {670,0.000000}, {675,0.000000}, {680,0.000000}, {685,0.000000}, {690,0.000000}, {695,0.000000}, {700,0.000000}, {705,0.000000}, {710,0.000000}, {715,0.000000}, {720,0.000000}, {725,0.000000}, {730,0.000000}, {735,0.000000}, {740,0.000000}, {745,0.000000}, {750,0.000000}, {755,0.000000}, {760,0.000000}, {765,0.000000}, {770,0.000000}, {775,0.000000}, {780,0.000000}, {785,0.000000}, {790,0.000000}, {795,0.000000}, {800,0.000000}, {805,0.000000}, {810,0.000000}, {815,0.000000}, {820,0.000000}, {825,0.000000}, {830,0.000000}, {835,0.000000}, {840,0.000000}, {845,0.000000}, {850,0.000000}, {855,0.000000}, {860,0.000000}, {865,0.000000}, {870,0.000000}, {875,0.000000}, {880,0.000000}, {885,0.000000}, {890,0.000000}, {895,0.000000}, {900,0.000000}, {905,0.000000}, {910,0.000000}, {915,0.000000}, {920,0.000000}, {925,0.000000}, {930,0.000000}, {935,0.000000}, {940,0.000000}, {945,0.000000}, {950,0.000000}, {955,0.000000}, {960,0.000000}, {965,0.000000}, {970,0.000000}, {975,0.000000}, {980,0.000000}, {985,0.000000}, {990,0.000000}, {995,0.000308}, {1000,0.000000}, {1010,0.000308}, {1020,0.000000}, {1030,0.000000}, {1040,0.000000}, {1050,0.000000}, {1060,0.000000}, {1070,0.000000}, {1080,0.000000}, {1090,0.000000}, {1100,0.000000}, {1110,0.000000}, {1120,0.000000}, {1130,0.000000}, {1140,0.000000}, {1150,0.000000}, {1160,0.000000}, {1170,0.000000}, {1180,0.000000}, {1190,0.000000}, {1200,0.000000}, {1210,0.000000}, {1220,0.000000}, {1230,0.000000}, {1240,0.000000}, {1250,0.000000}, {1260,0.000000}, {1270,0.000000}, {1280,0.000000}, {1290,0.000000}, {1300,0.000000}, {1310,0.000000}, {1320,0.000000}, {1330,0.000000}, {1340,0.000000}, {1350,0.000000}, {1360,0.000000}, {1370,0.000000}, {1380,0.000000}, {1390,0.000000}, {1400,0.000000}, {1410,0.000000}, {1420,0.000000}, {1430,0.000000}, {1440,0.000000}, {1450,0.000000}, {1460,0.000000}, {1470,0.000000}, {1480,0.000000}, {1490,0.000000}, {1500,0.000000}, {1510,0.000000}, {1520,0.000000}, {1530,0.000000}, {1540,0.000000}, {1550,0.000000}, {1560,0.000000}, {1570,0.000000}, {1580,0.000000}, {1590,0.000000}, {1600,0.000000}, {1610,0.000000}, {1620,0.000000}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000000}, {1680,0.000000}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000000}, {1730,0.000000}, {1740,0.000000}, {1750,0.000000}, {1760,0.000000}, {1770,0.000000}, {1780,0.000000}, {1790,0.000000}, {1800,0.000308}, {1810,0.000000}, {1820,0.000000}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000000}, {1900,0.000000}, {1910,0.000000}, {1920,0.000000}, {1930,0.000000}, {1940,0.000000}, {1950,0.000000}, {1960,0.000000}, {1970,0.000000}, {1980,0.000000}, {1990,0.000000}, {2000,0.000000}};
data["big"]["TypeClassesBodyHOAS"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000877}, {5,0.00100000}, {6,0.00100000}, {7,0.00100000}, {8,0.00100000}, {9,0.00142982}, {10,0.00200000}, {11,0.00200000}, {12,0.00204386}, {13,0.00253509}, {14,0.00300000}, {15,0.02306140}, {16,0.00309649}, {17,0.00376316}, {18,0.00400877}, {19,0.00424561}, {20,0.00462281}, {21,0.00508772}, {22,0.00539474}, {23,0.00584211}, {24,0.00645614}, {25,0.00655263}, {26,0.00728947}, {27,0.00758772}, {28,0.00785965}, {29,0.00847368}, {30,0.01004386}, {31,0.00945614}, {32,0.00940351}, {33,0.01023684}, {34,0.01057018}, {35,0.01114035}, {36,0.01167544}, {37,0.01214912}, {38,0.01266667}, {39,0.01290351}, {40,0.01369298}, {41,0.01410526}, {42,0.01496491}, {43,0.01589474}, {44,0.01601754}, {45,0.01920175}, {46,0.01716667}, {47,0.01797368}, {48,0.01854386}, {49,0.01891228}, {50,0.02264035}, {51,0.01995614}, {52,0.02084211}, {53,0.02167544}, {54,0.02257018}, {55,0.02580702}, {56,0.02370175}, {57,0.02435088}, {58,0.02497368}, {59,0.03039474}, {60,0.02664912}, {61,0.02756140}, {62,0.02846491}, {63,0.03130702}, {64,0.02974561}, {65,0.03072807}, {66,0.03757895}, {67,0.03196491}, {68,0.03330702}, {69,0.03955263}, {70,0.03459649}, {71,0.03576316}, {72,0.04107018}, {73,0.03751754}, {74,0.03812281}, {75,0.04321930}, {76,0.04018421}, {77,0.05102632}, {78,0.04128070}, {79,0.04273684}, {80,0.04631579}, {81,0.04544737}, {82,0.05345614}, {83,0.04690351}, {84,0.06981579}, {85,0.04873684}, {86,0.05628431}, {87,0.05080392}, {88,0.05736275}, {89,0.05287255}, {90,0.06344118}, {91,0.05458824}, {92,0.06237255}, {93,0.05690196}, {94,0.06341176}, {95,0.05976471}, {96,0.06527451}, {97,0.06235294}, {98,0.06750980}, {99,0.07576471}, {100,0.06563725}, {101,0.06994118}, {102,0.08069608}, {103,0.06875490}, {104,0.07281373}, {105,0.08367647}, {106,0.07251961}, {107,0.07674510}, {108,0.08768627}, {109,0.07669608}, {110,0.08057843}, {111,0.08935294}, {112,0.09363725}, {113,0.08194118}, {114,0.08587255}, {115,0.09512745}, {116,0.09853922}, {117,0.10030392}, {118,0.08900000}, {119,0.09268627}, {120,0.10537255}, {121,0.10604902}, {122,0.10994118}, {123,0.11067647}, {124,0.11309804}, {125,0.11423529}, {126,0.11186275}, {127,0.10245098}, {128,0.11268627}, {129,0.11534314}, {130,0.11760784}, {131,0.11850000}, {132,0.11994118}, {133,0.12236275}, {134,0.12381373}, {135,0.13641176}, {136,0.12984314}, {137,0.12903922}, {138,0.12968627}, {139,0.13159804}, {140,0.13328431}, {141,0.18443137}, {142,0.14215686}, {143,0.23528431}, {144,0.14766667}, {145,0.14576471}, {146,0.14758824}, {147,0.14783333}, {148,0.15929412}, {149,0.14858824}, {150,0.14943137}, {151,0.15187255}, {152,0.16624510}, {153,0.15400000}, {154,0.15661765}, {155,0.16972549}, {156,0.16189216}, {157,0.16297059}, {158,0.16908824}, {159,0.17016667}, {160,0.18880392}, {161,0.17314706}, {162,0.18845098}, {163,0.17470588}, {164,0.19029412}, {165,0.17718627}, {166,0.19363725}, {167,0.18191176}, {168,0.19627451}, {169,0.18571569}, {170,0.20179412}, {171,0.20928431}, {172,0.19574510}, {173,0.21309804}, {174,0.21285294}, {175,0.19872549}, {176,0.21457843}, {177,0.21655882}, {178,0.20500000}, {179,0.20866667}, {180,0.22034314}, {181,0.22271569}, {182,0.22988235}, {183,0.21547059}, {184,0.22229412}, {185,0.23855882}, {186,0.24178431}, {187,0.23930392}, {188,0.24156863}, {189,0.24068627}, {190,0.24386275}, {191,0.24529412}, {192,0.24703922}, {193,0.25279412}, {194,0.25569608}, {195,0.26285294}, {196,0.26132353}, {197,0.26361765}, {198,0.26307843}, {199,0.26489216}, {200,0.27819608}, {201,0.26838235}, {202,0.26960784}, {203,0.27653922}, {204,0.28104902}, {205,0.28814706}, {206,0.28824510}, {207,0.28610784}, {208,0.30450000}, {209,0.28665686}, {210,0.29016667}, {211,0.30652941}, {212,0.29826471}, {213,0.31535294}, {214,0.30451961}, {215,0.32533333}, {216,0.31276471}, {217,0.32447059}, {218,0.31342157}, {219,0.32953922}, {220,0.31635294}, {221,0.33638235}, {222,0.33825490}, {223,0.33284314}, {224,0.35097059}, {225,0.34597059}, {226,0.33376471}, {227,0.34806863}, {228,0.35403922}, {229,0.36012745}, {230,0.34887255}, {231,0.36569608}, {232,0.36739216}, {233,0.37218627}, {234,0.36989216}, {235,0.37258824}, {236,0.38172549}, {237,0.37959804}, {238,0.38387255}, {239,0.38466667}, {240,0.39186275}, {241,0.39213725}, {242,0.39223529}, {243,0.39717647}, {244,0.40369608}, {245,0.40858824}, {246,0.41755882}, {247,0.41494118}, {248,0.41281373}, {249,0.41284314}, {250,0.46449020}, {251,0.43094118}, {252,0.42883333}, {253,0.43821569}, {254,0.43309804}, {255,0.43711765}, {256,0.45332353}, {257,0.45308824}, {258,0.45800980}, {259,0.45214706}, {260,0.45816667}, {261,0.46749020}, {262,0.46713725}, {263,0.47516667}, {264,0.47635294}, {265,0.47832353}, {266,0.48365686}, {267,0.49124510}, {268,0.48907843}, {269,0.49938235}, {270,0.49850980}, {271,0.49778431}, {272,0.50949020}, {273,0.51300000}, {274,0.51599020}, {275,0.52150980}, {276,0.52019608}, {277,0.52804902}, {278,0.53486275}, {279,0.53336275}, {280,0.54505882}, {281,0.54373529}, {282,0.54838235}, {283,0.55550980}, {284,0.55109804}, {285,0.56423529}, {286,0.56644118}, {287,0.56378431}, {288,0.57839216}, {289,0.57449020}, {290,0.58410784}, {291,0.58548039}, {292,0.58552941}, {293,0.59877451}, {294,0.59380392}, {295,0.61004902}, {296,0.61112745}, {297,0.60878431}, {298,0.62288235}, {299,0.61768627}, {300,0.63141176}, {301,0.62670297}, {302,0.63117822}, {303,0.64113861}, {304,0.64092079}, {305,0.65256436}, {306,0.64755446}, {307,0.66121782}, {308,0.65749505}, {309,0.66857426}, {310,0.66768317}, {311,0.67158416}, {312,0.68160396}, {313,0.68628713}, {314,0.69177228}, {315,0.69162376}, {316,0.70231683}, {317,0.70431683}, {318,0.71090099}, {319,0.70666337}, {320,0.72075248}, {321,0.72073267}, {322,0.73153465}, {323,0.72847525}, {324,0.74242574}, {325,0.73709901}, {326,0.76000990}, {327,0.75255446}, {328,0.76108911}, {329,0.75728713}, {330,0.76761386}, {331,0.77000990}, {332,0.78282178}, {333,0.77898020}, {334,0.78999010}, {335,0.78860396}, {336,0.80000990}, {337,0.79959406}, {338,0.80589109}, {339,0.80879208}, {340,0.81621782}, {341,0.82352475}, {342,0.82653465}, {343,0.83127723}, {344,0.83945545}, {345,0.84381188}, {346,0.84554455}, {347,0.85116832}, {348,0.86147525}, {349,0.86992079}, {350,0.87156436}, {351,0.87101980}, {352,0.88411881}, {353,0.88566337}, {354,0.88997030}, {355,0.89920792}, {356,0.90398020}, {357,0.94935644}, {358,0.90486139}, {359,0.97311881}, {360,0.92397030}, {361,0.92947525}, {362,0.93598020}, {363,0.94405941}, {364,0.94486139}, {365,0.94680198}, {366,0.96550495}, {367,0.96510891}, {368,0.96303960}, {369,0.98275248}, {370,0.97802970}, {371,0.98586139}, {372,0.99154455}, {373,0.99553465}, {374,1.00366337}, {375,1.00481188}, {376,1.012077}, {377,0.997077}, {378,1.006154}, {379,1.011615}, {380,1.007077}, {381,1.030462}, {382,1.031154}, {383,1.147538}, {384,1.043846}, {385,1.042154}, {386,1.174308}, {387,1.188385}, {388,1.067385}, {389,1.065692}, {390,1.072769}, {391,1.079462}, {392,1.090308}, {393,1.091308}, {394,1.095692}, {395,1.098000}, {396,1.104000}, {397,1.115385}, {398,1.120077}, {399,1.130385}, {400,1.126846}, {401,1.207462}, {402,1.151615}, {403,1.153923}, {404,1.157769}, {405,1.166154}, {406,1.172385}, {407,1.181231}, {408,1.183692}, {409,1.196077}, {410,1.195846}, {411,1.211154}, {412,1.212154}, {413,1.217077}, {414,1.222154}, {415,1.225000}, {416,1.239077}, {417,1.236308}, {418,1.252846}, {419,1.249615}, {420,1.267538}, {421,1.265692}, {422,1.271615}, {423,1.275923}, {424,1.291923}, {425,1.292308}, {426,1.308615}, {427,1.305462}, {428,1.331077}, {429,1.319154}, {430,1.324308}, {431,1.337154}, {432,1.359769}, {433,1.357154}, {434,1.358231}, {435,1.363231}, {436,1.388923}, {437,1.380077}, {438,1.389154}, {439,1.398692}, {440,1.412308}, {441,1.405385}, {442,1.414385}, {443,1.427538}, {444,1.443154}, {445,1.436077}, {446,1.446692}, {447,1.455769}, {448,1.480615}, {449,1.459538}, {450,1.473308}, {451,1.493385}, {452,1.501231}, {453,1.486231}, {454,1.504538}, {455,1.521692}, {456,1.517385}, {457,1.525077}, {458,1.536923}, {459,1.552462}, {460,1.547000}, {461,1.547615}, {462,1.571462}, {463,1.576231}, {464,1.574462}, {465,1.588923}, {466,1.606538}, {467,1.610923}, {468,1.601385}, {469,1.619923}, {470,1.631308}, {471,1.627769}, {472,1.636462}, {473,1.666231}, {474,1.664692}, {475,1.663615}, {476,1.678846}, {477,1.687692}, {478,1.689000}, {479,1.698000}, {480,1.710154}, {481,1.716154}, {482,1.719615}, {483,1.733154}, {484,1.739231}, {485,1.746615}, {486,1.758846}, {487,1.763077}, {488,1.789308}, {489,1.847077}, {490,1.797769}, {491,1.806154}, {492,1.813923}, {493,1.815231}, {494,1.830231}, {495,1.843846}, {496,1.833769}, {497,1.860000}, {498,1.857846}, {499,1.853615}, {500,1.864615}, {505,1.917846}, {510,1.947308}, {515,1.999385}, {520,2.062692}, {525,2.103769}, {530,2.144385}, {535,2.197538}, {540,2.231615}, {545,2.373846}, {550,2.319923}, {555,2.376769}, {560,2.442692}, {565,2.469000}, {570,2.522308}, {575,2.564462}, {580,2.687846}, {585,2.742538}, {590,2.714692}, {595,2.780308}, {600,2.844846}, {605,2.890462}, {610,2.938462}, {615,3.012000}, {620,3.047769}, {625,3.124154}, {630,3.213615}, {635,3.293923}, {640,3.525692}, {645,3.333000}, {650,3.377000}, {655,3.516846}, {660,3.499077}, {665,3.561692}, {670,3.616769}, {675,3.769385}, {680,3.749231}, {685,3.821077}, {690,3.966923}, {695,3.956615}, {700,4.170615}, {705,4.077462}, {710,4.155000}, {715,4.220692}, {720,4.379692}, {725,4.306308}, {730,4.463077}, {735,4.510692}, {740,4.550538}, {745,4.702231}, {750,4.670385}, {755,4.776692}, {760,4.840385}, {765,4.915538}, {770,4.993154}, {775,5.132154}, {780,5.145538}, {785,5.302000}, {790,5.420231}, {795,5.594385}, {800,5.636385}, {805,5.812923}, {810,5.898154}, {815,5.812692}, {820,6.133769}, {825,6.231308}, {830,6.156769}, {835,6.443077}, {840,6.277077}, {845,6.713385}, {850,6.605154}, {855,6.606538}, {860,6.882846}, {865,6.785077}, {870,7.045385}, {875,7.424769}, {880,7.236846}, {885,7.090077}, {890,7.350846}, {895,7.468923}, {900,7.640538}, {905,7.583308}, {910,7.684692}, {915,8.055077}, {920,7.916077}, {925,8.112308}, {930,8.283385}, {935,8.326538}, {940,8.434308}, {945,8.604154}, {950,8.810308}, {955,8.845923}, {960,8.884308}, {965,9.078923}, {970,9.528308}, {975,9.315769}, {980,9.423231}, {985,9.467538}, {990,9.861923}, {995,9.782000}, {1000,9.823615}, {1010,10.068846}, {1020,10.509538}, {1030,10.909923}, {1040,10.970769}, {1050,11.125308}, {1060,11.726615}, {1070,11.925077}, {1080,12.073923}, {1090,12.708154}, {1100,12.814385}, {1110,13.029308}, {1120,13.279077}, {1130,13.583385}, {1140,14.094000}, {1150,14.499692}, {1160,14.751923}, {1170,15.137538}, {1180,15.079923}, {1190,15.697231}, {1200,16.256538}, {1210,16.376385}, {1220,16.589231}, {1230,17.136000}, {1240,17.060692}, {1250,18.118231}, {1260,18.006692}, {1270,18.313385}, {1280,18.772923}, {1290,19.309769}, {1300,19.814000}, {1310,20.184385}, {1320,20.129154}, {1330,20.821000}, {1340,21.355462}, {1350,22.395000}, {1360,22.265538}, {1370,22.550231}, {1380,23.185154}, {1390,23.640769}, {1400,24.691000}, {1410,24.597000}, {1420,24.874231}, {1430,25.477154}, {1440,26.116769}, {1450,26.196462}, {1460,26.677923}, {1470,27.681308}, {1480,27.474000}, {1490,28.536615}, {1500,28.924000}, {1510,29.551231}, {1520,29.844462}, {1530,30.650615}, {1540,30.916615}, {1550,31.498308}, {1560,32.369000}, {1570,33.139615}, {1580,32.943538}, {1590,33.853923}, {1600,34.857462}, {1610,35.761846}, {1620,36.052692}, {1630,35.817692}, {1640,36.694231}, {1650,37.677308}, {1660,37.970538}, {1670,39.205692}, {1680,39.185231}, {1690,40.120769}, {1700,39.966615}, {1710,41.680692}, {1720,42.422923}, {1730,42.465385}, {1740,42.747000}, {1750,44.681769}, {1760,44.736538}, {1770,45.348769}, {1780,45.783308}, {1790,46.978462}, {1800,47.404231}, {1810,48.901385}, {1820,49.070308}, {1830,49.540538}, {1840,50.444462}, {1850,50.551308}, {1860,51.537308}, {1870,52.438923}, {1880,52.605692}, {1890,53.463385}, {1900,54.239231}, {1910,54.686615}, {1920,55.987769}, {1930,56.473385}, {1940,57.965923}, {1950,58.200846}, {1960,59.072308}, {1970,60.157385}, {1980,60.196538}, {1990,61.959462}, {2000,62.365615}};
data["big"]["TypeClassesBodyHOAS"]["norm reif"]["user"] = {{1,0.00045614}, {2,0.00029825}, {3,0.00070175}, {4,0.00099123}, {5,0.00092982}, {6,0.00085088}, {7,0.00162281}, {8,0.00186842}, {9,0.00171053}, {10,0.00178947}, {11,0.00217544}, {12,0.00240351}, {13,0.00296491}, {14,0.00314912}, {15,0.02345614}, {16,0.00357018}, {17,0.00376316}, {18,0.00407895}, {19,0.00465789}, {20,0.00489474}, {21,0.00528947}, {22,0.00540351}, {23,0.00591228}, {24,0.00648246}, {25,0.00672807}, {26,0.00735088}, {27,0.00765789}, {28,0.00809649}, {29,0.00875439}, {30,0.01016667}, {31,0.00956140}, {32,0.00921053}, {33,0.01023684}, {34,0.01043860}, {35,0.01110526}, {36,0.01167544}, {37,0.01186842}, {38,0.01258772}, {39,0.01265789}, {40,0.01347368}, {41,0.01388596}, {42,0.01457018}, {43,0.01539474}, {44,0.01600877}, {45,0.01942982}, {46,0.01726316}, {47,0.01757895}, {48,0.01832456}, {49,0.01863158}, {50,0.02275439}, {51,0.01964035}, {52,0.02068421}, {53,0.02165789}, {54,0.02300000}, {55,0.02602632}, {56,0.02387719}, {57,0.02476316}, {58,0.02532456}, {59,0.03046491}, {60,0.02699123}, {61,0.02783333}, {62,0.02862281}, {63,0.03135965}, {64,0.02980702}, {65,0.03064912}, {66,0.03769298}, {67,0.03216667}, {68,0.03324561}, {69,0.03945614}, {70,0.03471930}, {71,0.03568421}, {72,0.04089474}, {73,0.03746491}, {74,0.03779825}, {75,0.04299123}, {76,0.04011404}, {77,0.05163158}, {78,0.04090351}, {79,0.04230702}, {80,0.04605263}, {81,0.04550877}, {82,0.05369298}, {83,0.04696491}, {84,0.06985088}, {85,0.04924561}, {86,0.05634314}, {87,0.05091176}, {88,0.05727451}, {89,0.05312745}, {90,0.06336275}, {91,0.05467647}, {92,0.06197059}, {93,0.05685294}, {94,0.06342157}, {95,0.05967647}, {96,0.06478431}, {97,0.06216667}, {98,0.06751961}, {99,0.07598039}, {100,0.06529412}, {101,0.06992157}, {102,0.08074510}, {103,0.06863725}, {104,0.07329412}, {105,0.08349020}, {106,0.07275490}, {107,0.07707843}, {108,0.08746078}, {109,0.07703922}, {110,0.08086275}, {111,0.08915686}, {112,0.09322549}, {113,0.08193137}, {114,0.08561765}, {115,0.09498039}, {116,0.09847059}, {117,0.10018627}, {118,0.08842157}, {119,0.09269608}, {120,0.10528431}, {121,0.10593137}, {122,0.10962745}, {123,0.11057843}, {124,0.11302941}, {125,0.11373529}, {126,0.11169608}, {127,0.10255882}, {128,0.11225490}, {129,0.11473529}, {130,0.11736275}, {131,0.11811765}, {132,0.11961765}, {133,0.12218627}, {134,0.12389216}, {135,0.13515686}, {136,0.12929412}, {137,0.12836275}, {138,0.12942157}, {139,0.13132353}, {140,0.13245098}, {141,0.18404902}, {142,0.14170588}, {143,0.23474510}, {144,0.14727451}, {145,0.14557843}, {146,0.14735294}, {147,0.14772549}, {148,0.15873529}, {149,0.14849020}, {150,0.14917647}, {151,0.15170588}, {152,0.16594118}, {153,0.15375490}, {154,0.15615686}, {155,0.16948039}, {156,0.16148039}, {157,0.16273529}, {158,0.16874510}, {159,0.17006863}, {160,0.18853922}, {161,0.17301961}, {162,0.18813725}, {163,0.17459804}, {164,0.19026471}, {165,0.17691176}, {166,0.19364706}, {167,0.18164706}, {168,0.19583333}, {169,0.18547059}, {170,0.20148039}, {171,0.20895098}, {172,0.19539216}, {173,0.21279412}, {174,0.21242157}, {175,0.19804902}, {176,0.21435294}, {177,0.21633333}, {178,0.20487255}, {179,0.20820588}, {180,0.22012745}, {181,0.22224510}, {182,0.22936275}, {183,0.21519608}, {184,0.22184314}, {185,0.23819608}, {186,0.24150980}, {187,0.23891176}, {188,0.24120588}, {189,0.24026471}, {190,0.24354902}, {191,0.24473529}, {192,0.24632353}, {193,0.25236275}, {194,0.25489216}, {195,0.26227451}, {196,0.26090196}, {197,0.26333333}, {198,0.26266667}, {199,0.26441176}, {200,0.27776471}, {201,0.26806863}, {202,0.26900000}, {203,0.27611765}, {204,0.28080392}, {205,0.28765686}, {206,0.28762745}, {207,0.28587255}, {208,0.30405882}, {209,0.28596078}, {210,0.28989216}, {211,0.30595098}, {212,0.29801961}, {213,0.31453922}, {214,0.30405882}, {215,0.32482353}, {216,0.31215686}, {217,0.32415686}, {218,0.31276471}, {219,0.32921569}, {220,0.31600000}, {221,0.33571569}, {222,0.33816667}, {223,0.33230392}, {224,0.35037255}, {225,0.34538235}, {226,0.33318627}, {227,0.34748039}, {228,0.35344118}, {229,0.35968627}, {230,0.34835294}, {231,0.36525490}, {232,0.36664706}, {233,0.37120588}, {234,0.36887255}, {235,0.37150980}, {236,0.38113725}, {237,0.37900980}, {238,0.38322549}, {239,0.38405882}, {240,0.39138235}, {241,0.39150000}, {242,0.39184314}, {243,0.39637255}, {244,0.40301961}, {245,0.40790196}, {246,0.41709804}, {247,0.41393137}, {248,0.41191176}, {249,0.41254902}, {250,0.46345098}, {251,0.43047059}, {252,0.42818627}, {253,0.43762745}, {254,0.43249020}, {255,0.43628431}, {256,0.45216667}, {257,0.45231373}, {258,0.45773529}, {259,0.45142157}, {260,0.45737255}, {261,0.46667647}, {262,0.46652941}, {263,0.47424510}, {264,0.47564706}, {265,0.47728431}, {266,0.48263725}, {267,0.49017647}, {268,0.48825490}, {269,0.49879412}, {270,0.49763725}, {271,0.49720588}, {272,0.50874510}, {273,0.51249020}, {274,0.51496078}, {275,0.52042157}, {276,0.51947059}, {277,0.52687255}, {278,0.53417647}, {279,0.53221569}, {280,0.54424510}, {281,0.54308824}, {282,0.54749020}, {283,0.55458824}, {284,0.55027451}, {285,0.56355882}, {286,0.56550980}, {287,0.56260784}, {288,0.57745098}, {289,0.57342157}, {290,0.58318627}, {291,0.58444118}, {292,0.58467647}, {293,0.59800000}, {294,0.59300980}, {295,0.60914706}, {296,0.61017647}, {297,0.60771569}, {298,0.62209804}, {299,0.61661765}, {300,0.63032353}, {301,0.62607921}, {302,0.63021782}, {303,0.64000990}, {304,0.64011881}, {305,0.65156436}, {306,0.64638614}, {307,0.66027723}, {308,0.65627723}, {309,0.66747525}, {310,0.66657426}, {311,0.67073267}, {312,0.68067327}, {313,0.68500990}, {314,0.69044554}, {315,0.69063366}, {316,0.70120792}, {317,0.70319802}, {318,0.71002970}, {319,0.70553465}, {320,0.71988119}, {321,0.71950495}, {322,0.73044554}, {323,0.72730693}, {324,0.74124752}, {325,0.73593069}, {326,0.75881188}, {327,0.75140594}, {328,0.75967327}, {329,0.75585149}, {330,0.76635644}, {331,0.76878218}, {332,0.78179208}, {333,0.77786139}, {334,0.78814851}, {335,0.78687129}, {336,0.79856436}, {337,0.79808911}, {338,0.80443564}, {339,0.80710891}, {340,0.81422772}, {341,0.82177228}, {342,0.82520792}, {343,0.82987129}, {344,0.83803960}, {345,0.84255446}, {346,0.84440594}, {347,0.84987129}, {348,0.86026733}, {349,0.86840594}, {350,0.86986139}, {351,0.86947525}, {352,0.88292079}, {353,0.88421782}, {354,0.88848515}, {355,0.89752475}, {356,0.90262376}, {357,0.94764356}, {358,0.90306931}, {359,0.97115842}, {360,0.92233663}, {361,0.92757426}, {362,0.93435644}, {363,0.94265347}, {364,0.94297030}, {365,0.94494059}, {366,0.96388119}, {367,0.96349505}, {368,0.96147525}, {369,0.98078218}, {370,0.97605941}, {371,0.98450495}, {372,0.99013861}, {373,0.99383168}, {374,1.00187129}, {375,1.00332673}, {376,1.011923}, {377,0.996308}, {378,1.004846}, {379,1.010385}, {380,1.005308}, {381,1.028462}, {382,1.029308}, {383,1.146077}, {384,1.042154}, {385,1.040692}, {386,1.173615}, {387,1.187692}, {388,1.066462}, {389,1.065000}, {390,1.071923}, {391,1.077615}, {392,1.088923}, {393,1.090538}, {394,1.095538}, {395,1.096846}, {396,1.102846}, {397,1.115385}, {398,1.119231}, {399,1.129538}, {400,1.125692}, {401,1.207154}, {402,1.151538}, {403,1.153308}, {404,1.157077}, {405,1.166385}, {406,1.172385}, {407,1.181769}, {408,1.183308}, {409,1.194769}, {410,1.195154}, {411,1.210077}, {412,1.211538}, {413,1.216308}, {414,1.221462}, {415,1.224077}, {416,1.239462}, {417,1.236000}, {418,1.252462}, {419,1.248692}, {420,1.266231}, {421,1.264077}, {422,1.270923}, {423,1.275846}, {424,1.290231}, {425,1.292000}, {426,1.308385}, {427,1.304462}, {428,1.331154}, {429,1.318385}, {430,1.323231}, {431,1.335846}, {432,1.358692}, {433,1.356692}, {434,1.356538}, {435,1.362846}, {436,1.387538}, {437,1.379462}, {438,1.387923}, {439,1.397462}, {440,1.412538}, {441,1.404846}, {442,1.414462}, {443,1.427615}, {444,1.441692}, {445,1.435769}, {446,1.445308}, {447,1.455154}, {448,1.479923}, {449,1.459231}, {450,1.472692}, {451,1.493154}, {452,1.501231}, {453,1.484692}, {454,1.504154}, {455,1.521000}, {456,1.517154}, {457,1.524077}, {458,1.535692}, {459,1.551154}, {460,1.545385}, {461,1.547462}, {462,1.571077}, {463,1.576231}, {464,1.574154}, {465,1.588615}, {466,1.605769}, {467,1.610462}, {468,1.601385}, {469,1.618846}, {470,1.631615}, {471,1.628000}, {472,1.635692}, {473,1.665769}, {474,1.664077}, {475,1.662538}, {476,1.677385}, {477,1.686538}, {478,1.688154}, {479,1.696538}, {480,1.709000}, {481,1.714308}, {482,1.719231}, {483,1.731385}, {484,1.737538}, {485,1.744923}, {486,1.757615}, {487,1.761231}, {488,1.787231}, {489,1.845385}, {490,1.796769}, {491,1.803615}, {492,1.813000}, {493,1.814231}, {494,1.828615}, {495,1.842462}, {496,1.832154}, {497,1.858538}, {498,1.856308}, {499,1.852154}, {500,1.862846}, {505,1.916692}, {510,1.945769}, {515,1.998385}, {520,2.061154}, {525,2.101385}, {530,2.142769}, {535,2.196385}, {540,2.229538}, {545,2.371462}, {550,2.318846}, {555,2.374385}, {560,2.440923}, {565,2.466769}, {570,2.520385}, {575,2.561923}, {580,2.685538}, {585,2.741077}, {590,2.713692}, {595,2.778615}, {600,2.843846}, {605,2.888077}, {610,2.935846}, {615,3.010846}, {620,3.044923}, {625,3.122846}, {630,3.211231}, {635,3.292154}, {640,3.523615}, {645,3.330154}, {650,3.375615}, {655,3.514923}, {660,3.497308}, {665,3.558538}, {670,3.615462}, {675,3.766154}, {680,3.746923}, {685,3.819923}, {690,3.964846}, {695,3.954692}, {700,4.168846}, {705,4.075000}, {710,4.152846}, {715,4.218000}, {720,4.376846}, {725,4.304154}, {730,4.457615}, {735,4.508308}, {740,4.548615}, {745,4.696923}, {750,4.665846}, {755,4.772154}, {760,4.838231}, {765,4.912000}, {770,4.991000}, {775,5.129692}, {780,5.142615}, {785,5.298769}, {790,5.417769}, {795,5.591231}, {800,5.633000}, {805,5.808769}, {810,5.894154}, {815,5.810231}, {820,6.129308}, {825,6.226385}, {830,6.153692}, {835,6.438308}, {840,6.272692}, {845,6.705615}, {850,6.597154}, {855,6.602846}, {860,6.879154}, {865,6.780231}, {870,7.041692}, {875,7.419231}, {880,7.233846}, {885,7.085000}, {890,7.344923}, {895,7.463462}, {900,7.636000}, {905,7.577923}, {910,7.679769}, {915,8.048615}, {920,7.910846}, {925,8.104615}, {930,8.278538}, {935,8.322923}, {940,8.429000}, {945,8.598154}, {950,8.803615}, {955,8.836000}, {960,8.870385}, {965,9.069462}, {970,9.520538}, {975,9.307846}, {980,9.414462}, {985,9.459615}, {990,9.854308}, {995,9.776692}, {1000,9.816385}, {1010,10.057692}, {1020,10.502538}, {1030,10.902846}, {1040,10.954462}, {1050,11.109462}, {1060,11.710923}, {1070,11.909154}, {1080,12.057462}, {1090,12.694769}, {1100,12.794615}, {1110,13.016538}, {1120,13.262385}, {1130,13.569000}, {1140,14.080538}, {1150,14.482846}, {1160,14.742846}, {1170,15.126308}, {1180,15.068846}, {1190,15.684000}, {1200,16.246769}, {1210,16.367615}, {1220,16.573000}, {1230,17.123308}, {1240,17.051923}, {1250,18.108692}, {1260,17.998769}, {1270,18.301154}, {1280,18.761231}, {1290,19.296692}, {1300,19.803462}, {1310,20.171462}, {1320,20.116000}, {1330,20.806231}, {1340,21.344154}, {1350,22.392462}, {1360,22.261000}, {1370,22.540769}, {1380,23.171846}, {1390,23.628846}, {1400,24.677692}, {1410,24.586154}, {1420,24.859923}, {1430,25.456923}, {1440,26.097846}, {1450,26.176385}, {1460,26.656231}, {1470,27.653692}, {1480,27.450154}, {1490,28.515846}, {1500,28.899615}, {1510,29.527385}, {1520,29.816462}, {1530,30.627231}, {1540,30.890308}, {1550,31.469615}, {1560,32.335462}, {1570,33.112154}, {1580,32.907538}, {1590,33.814923}, {1600,34.815923}, {1610,35.719923}, {1620,36.016308}, {1630,35.768615}, {1640,36.645615}, {1650,37.618538}, {1660,37.897615}, {1670,39.129538}, {1680,39.113923}, {1690,40.042000}, {1700,39.909538}, {1710,41.617923}, {1720,42.357923}, {1730,42.398000}, {1740,42.671923}, {1750,44.616538}, {1760,44.669385}, {1770,45.301385}, {1780,45.704231}, {1790,46.927846}, {1800,47.348538}, {1810,48.848000}, {1820,49.024769}, {1830,49.485000}, {1840,50.384923}, {1850,50.502308}, {1860,51.478154}, {1870,52.385846}, {1880,52.549692}, {1890,53.403462}, {1900,54.184385}, {1910,54.619692}, {1920,55.927462}, {1930,56.395692}, {1940,57.906615}, {1950,58.121000}, {1960,59.003385}, {1970,60.067615}, {1980,60.089000}, {1990,61.864692}, {2000,62.252154}};
data["big"]["TypeClassesBodyHOAS"]["norm reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003509}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00003509}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00003509}, {14,0.00010526}, {15,0.00000000}, {16,0.00007018}, {17,0.00010526}, {18,0.00003509}, {19,0.00000000}, {20,0.00000000}, {21,0.00007018}, {22,0.00006140}, {23,0.00003509}, {24,0.00000000}, {25,0.00003509}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00002632}, {30,0.00003509}, {31,0.00000000}, {32,0.00010526}, {33,0.00003509}, {34,0.00000000}, {35,0.00007018}, {36,0.00000000}, {37,0.00017544}, {38,0.00007018}, {39,0.00000000}, {40,0.00000000}, {41,0.00007018}, {42,0.00003509}, {43,0.00003509}, {44,0.00003509}, {45,0.00000000}, {46,0.00003509}, {47,0.00003509}, {48,0.00000000}, {49,0.00003509}, {50,0.00003509}, {51,0.00007018}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00010526}, {57,0.00014035}, {58,0.00000000}, {59,0.00003509}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00007018}, {64,0.00000000}, {65,0.00003509}, {66,0.00000000}, {67,0.00006140}, {68,0.00010526}, {69,0.00000000}, {70,0.00000000}, {71,0.00010526}, {72,0.00000000}, {73,0.00000000}, {74,0.00010526}, {75,0.00007018}, {76,0.00003509}, {77,0.00000000}, {78,0.00007018}, {79,0.00003509}, {80,0.00014035}, {81,0.00000000}, {82,0.00010526}, {83,0.00007018}, {84,0.00007018}, {85,0.00003509}, {86,0.00003922}, {87,0.00003922}, {88,0.00003922}, {89,0.00003922}, {90,0.00000000}, {91,0.00000000}, {92,0.00007843}, {93,0.00000000}, {94,0.00003922}, {95,0.00000000}, {96,0.00003922}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00007843}, {101,0.00003922}, {102,0.00000000}, {103,0.00003922}, {104,0.00003922}, {105,0.00000000}, {106,0.00000000}, {107,0.00011765}, {108,0.00000000}, {109,0.00006863}, {110,0.00003922}, {111,0.00000000}, {112,0.00003922}, {113,0.00000000}, {114,0.00003922}, {115,0.00007843}, {116,0.00000000}, {117,0.00000000}, {118,0.00003922}, {119,0.00000000}, {120,0.00007843}, {121,0.00000000}, {122,0.00007843}, {123,0.00015686}, {124,0.00000000}, {125,0.00025490}, {126,0.00006863}, {127,0.00007843}, {128,0.00011765}, {129,0.00019608}, {130,0.00018627}, {131,0.00015686}, {132,0.00027451}, {133,0.00023529}, {134,0.00015686}, {135,0.00085294}, {136,0.00050000}, {137,0.00037255}, {138,0.00035294}, {139,0.00023529}, {140,0.00019608}, {141,0.00007843}, {142,0.00000000}, {143,0.00000000}, {144,0.00003922}, {145,0.00000000}, {146,0.00000000}, {147,0.00015686}, {148,0.00003922}, {149,0.00007843}, {150,0.00000000}, {151,0.00003922}, {152,0.00010784}, {153,0.00007843}, {154,0.00000000}, {155,0.00011765}, {156,0.00011765}, {157,0.00000000}, {158,0.00007843}, {159,0.00003922}, {160,0.00000000}, {161,0.00003922}, {162,0.00000000}, {163,0.00000000}, {164,0.00007843}, {165,0.00006863}, {166,0.00011765}, {167,0.00010784}, {168,0.00011765}, {169,0.00000000}, {170,0.00003922}, {171,0.00003922}, {172,0.00003922}, {173,0.00000000}, {174,0.00007843}, {175,0.00003922}, {176,0.00003922}, {177,0.00003922}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00003922}, {182,0.00007843}, {183,0.00000000}, {184,0.00003922}, {185,0.00003922}, {186,0.00007843}, {187,0.00019608}, {188,0.00000000}, {189,0.00003922}, {190,0.00011765}, {191,0.00018627}, {192,0.00022549}, {193,0.00011765}, {194,0.00035294}, {195,0.00011765}, {196,0.00015686}, {197,0.00007843}, {198,0.00003922}, {199,0.00011765}, {200,0.00002941}, {201,0.00003922}, {202,0.00003922}, {203,0.00007843}, {204,0.00007843}, {205,0.00000000}, {206,0.00011765}, {207,0.00007843}, {208,0.00003922}, {209,0.00003922}, {210,0.00007843}, {211,0.00003922}, {212,0.00003922}, {213,0.00003922}, {214,0.00007843}, {215,0.00003922}, {216,0.00003922}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00003922}, {221,0.00011765}, {222,0.00007843}, {223,0.00003922}, {224,0.00007843}, {225,0.00011765}, {226,0.00000000}, {227,0.00011765}, {228,0.00003922}, {229,0.00002941}, {230,0.00003922}, {231,0.00000000}, {232,0.00007843}, {233,0.00039216}, {234,0.00029412}, {235,0.00027451}, {236,0.00015686}, {237,0.00007843}, {238,0.00003922}, {239,0.00000000}, {240,0.00015686}, {241,0.00003922}, {242,0.00006863}, {243,0.00014706}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00003922}, {248,0.00015686}, {249,0.00006863}, {250,0.00023529}, {251,0.00007843}, {252,0.00007843}, {253,0.00007843}, {254,0.00002941}, {255,0.00007843}, {256,0.00007843}, {257,0.00000000}, {258,0.00000000}, {259,0.00007843}, {260,0.00007843}, {261,0.00003922}, {262,0.00000000}, {263,0.00011765}, {264,0.00002941}, {265,0.00011765}, {266,0.00023529}, {267,0.00031373}, {268,0.00022549}, {269,0.00015686}, {270,0.00015686}, {271,0.00007843}, {272,0.00011765}, {273,0.00003922}, {274,0.00011765}, {275,0.00019608}, {276,0.00011765}, {277,0.00027451}, {278,0.00019608}, {279,0.00018627}, {280,0.00007843}, {281,0.00006863}, {282,0.00019608}, {283,0.00023529}, {284,0.00003922}, {285,0.00011765}, {286,0.00006863}, {287,0.00021569}, {288,0.00015686}, {289,0.00011765}, {290,0.00011765}, {291,0.00007843}, {292,0.00003922}, {293,0.00003922}, {294,0.00000000}, {295,0.00003922}, {296,0.00007843}, {297,0.00015686}, {298,0.00003922}, {299,0.00003922}, {300,0.00007843}, {301,0.00003960}, {302,0.00007921}, {303,0.00011881}, {304,0.00003960}, {305,0.00003960}, {306,0.00006931}, {307,0.00006931}, {308,0.00026733}, {309,0.00011881}, {310,0.00003960}, {311,0.00007921}, {312,0.00007921}, {313,0.00011881}, {314,0.00003960}, {315,0.00011881}, {316,0.00003960}, {317,0.00011881}, {318,0.00007921}, {319,0.00007921}, {320,0.00011881}, {321,0.00003960}, {322,0.00000000}, {323,0.00003960}, {324,0.00015842}, {325,0.00007921}, {326,0.00007921}, {327,0.00000000}, {328,0.00011881}, {329,0.00007921}, {330,0.00007921}, {331,0.00015842}, {332,0.00003960}, {333,0.00007921}, {334,0.00073267}, {335,0.00052475}, {336,0.00015842}, {337,0.00015842}, {338,0.00019802}, {339,0.00067327}, {340,0.00063366}, {341,0.00023762}, {342,0.00023762}, {343,0.00015842}, {344,0.00011881}, {345,0.00003960}, {346,0.00000000}, {347,0.00011881}, {348,0.00007921}, {349,0.00015842}, {350,0.00011881}, {351,0.00011881}, {352,0.00015842}, {353,0.00011881}, {354,0.00025743}, {355,0.00019802}, {356,0.00035644}, {357,0.00038614}, {358,0.00027723}, {359,0.00039604}, {360,0.00019802}, {361,0.00015842}, {362,0.00022772}, {363,0.00031683}, {364,0.00052475}, {365,0.00027723}, {366,0.00047525}, {367,0.00022772}, {368,0.00007921}, {369,0.00011881}, {370,0.00022772}, {371,0.00019802}, {372,0.00015842}, {373,0.00035644}, {374,0.00051485}, {375,0.00019802}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000308}, {380,0.000923}, {381,0.001846}, {382,0.001846}, {383,0.000923}, {384,0.000923}, {385,0.000615}, {386,0.000000}, {387,0.000308}, {388,0.000308}, {389,0.000615}, {390,0.000000}, {391,0.000615}, {392,0.000615}, {393,0.000000}, {394,0.000000}, {395,0.000308}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000308}, {400,0.000308}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000615}, {412,0.000000}, {413,0.000308}, {414,0.000308}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000308}, {422,0.000000}, {423,0.000000}, {424,0.000308}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000308}, {431,0.000308}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000923}, {439,0.000615}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000308}, {449,0.000000}, {450,0.000000}, {451,0.000000}, {452,0.000000}, {453,0.000000}, {454,0.000000}, {455,0.000000}, {456,0.000000}, {457,0.000000}, {458,0.000000}, {459,0.000000}, {460,0.000000}, {461,0.000308}, {462,0.000000}, {463,0.000000}, {464,0.000000}, {465,0.000000}, {466,0.000000}, {467,0.000000}, {468,0.000000}, {469,0.000308}, {470,0.000000}, {471,0.000000}, {472,0.000000}, {473,0.000000}, {474,0.000000}, {475,0.000000}, {476,0.000308}, {477,0.000308}, {478,0.000000}, {479,0.000000}, {480,0.000000}, {481,0.000000}, {482,0.000308}, {483,0.000308}, {484,0.000000}, {485,0.000308}, {486,0.000000}, {487,0.000000}, {488,0.000000}, {489,0.000308}, {490,0.000615}, {491,0.000615}, {492,0.000000}, {493,0.000000}, {494,0.000308}, {495,0.000000}, {496,0.000000}, {497,0.000308}, {498,0.000308}, {499,0.000000}, {500,0.000000}, {505,0.000000}, {510,0.000308}, {515,0.000000}, {520,0.000000}, {525,0.000846}, {530,0.000000}, {535,0.000000}, {540,0.000000}, {545,0.000000}, {550,0.000308}, {555,0.000308}, {560,0.000000}, {565,0.000000}, {570,0.000308}, {575,0.000923}, {580,0.000615}, {585,0.000308}, {590,0.000000}, {595,0.000615}, {600,0.000000}, {605,0.000923}, {610,0.001231}, {615,0.000308}, {620,0.001231}, {625,0.000000}, {630,0.000000}, {635,0.000000}, {640,0.000615}, {645,0.001846}, {650,0.000923}, {655,0.000308}, {660,0.000923}, {665,0.002462}, {670,0.000615}, {675,0.000615}, {680,0.000308}, {685,0.000000}, {690,0.000000}, {695,0.001846}, {700,0.000615}, {705,0.000308}, {710,0.000308}, {715,0.000615}, {720,0.000308}, {725,0.000308}, {730,0.002769}, {735,0.000615}, {740,0.000308}, {745,0.003077}, {750,0.002462}, {755,0.002769}, {760,0.000923}, {765,0.001231}, {770,0.000000}, {775,0.000538}, {780,0.000000}, {785,0.000308}, {790,0.000308}, {795,0.001538}, {800,0.000615}, {805,0.002154}, {810,0.000615}, {815,0.000308}, {820,0.001538}, {825,0.002154}, {830,0.000308}, {835,0.002154}, {840,0.002462}, {845,0.003923}, {850,0.004923}, {855,0.000308}, {860,0.000923}, {865,0.001769}, {870,0.001231}, {875,0.003385}, {880,0.001231}, {885,0.003077}, {890,0.003692}, {895,0.002769}, {900,0.001231}, {905,0.002462}, {910,0.001538}, {915,0.003077}, {920,0.002154}, {925,0.004846}, {930,0.001231}, {935,0.000923}, {940,0.002154}, {945,0.002154}, {950,0.004000}, {955,0.005462}, {960,0.010462}, {965,0.005154}, {970,0.004000}, {975,0.004000}, {980,0.005462}, {985,0.004308}, {990,0.002769}, {995,0.000538}, {1000,0.003615}, {1010,0.007692}, {1020,0.002692}, {1030,0.000615}, {1040,0.007692}, {1050,0.005538}, {1060,0.005769}, {1070,0.006692}, {1080,0.007385}, {1090,0.003692}, {1100,0.009154}, {1110,0.003692}, {1120,0.007231}, {1130,0.004923}, {1140,0.003077}, {1150,0.007615}, {1160,0.003385}, {1170,0.006462}, {1180,0.004846}, {1190,0.007385}, {1200,0.004000}, {1210,0.001846}, {1220,0.009846}, {1230,0.005231}, {1240,0.002154}, {1250,0.002462}, {1260,0.001846}, {1270,0.004308}, {1280,0.004308}, {1290,0.004923}, {1300,0.003385}, {1310,0.004923}, {1320,0.005154}, {1330,0.007077}, {1340,0.004538}, {1350,0.002769}, {1360,0.004923}, {1370,0.002385}, {1380,0.005231}, {1390,0.002154}, {1400,0.004615}, {1410,0.001846}, {1420,0.002154}, {1430,0.004846}, {1440,0.002769}, {1450,0.004538}, {1460,0.006692}, {1470,0.011923}, {1480,0.008308}, {1490,0.003692}, {1500,0.006769}, {1510,0.005538}, {1520,0.010077}, {1530,0.004923}, {1540,0.007077}, {1550,0.009769}, {1560,0.015385}, {1570,0.008923}, {1580,0.014077}, {1590,0.010154}, {1600,0.014154}, {1610,0.013769}, {1620,0.007615}, {1630,0.015923}, {1640,0.012308}, {1650,0.011000}, {1660,0.016846}, {1670,0.010385}, {1680,0.013538}, {1690,0.019000}, {1700,0.007692}, {1710,0.010462}, {1720,0.009231}, {1730,0.012615}, {1740,0.023231}, {1750,0.017769}, {1760,0.018923}, {1770,0.009538}, {1780,0.044385}, {1790,0.013692}, {1800,0.021385}, {1810,0.019231}, {1820,0.010462}, {1830,0.019385}, {1840,0.014923}, {1850,0.012154}, {1860,0.023308}, {1870,0.016000}, {1880,0.019385}, {1890,0.020846}, {1900,0.017462}, {1910,0.031308}, {1920,0.026385}, {1930,0.036923}, {1940,0.036923}, {1950,0.029692}, {1960,0.018154}, {1970,0.028615}, {1980,0.044154}, {1990,0.033154}, {2000,0.054615}};
data["big"]["TypeClassesBodyHOAS"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000000}, {400,0.000000}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}, {451,0.000000}, {452,0.000000}, {453,0.000000}, {454,0.000000}, {455,0.000000}, {456,0.000000}, {457,0.000000}, {458,0.000000}, {459,0.000000}, {460,0.000000}, {461,0.000000}, {462,0.000000}, {463,0.000000}, {464,0.000000}, {465,0.000000}, {466,0.000000}, {467,0.000000}, {468,0.000000}, {469,0.000000}, {470,0.000000}, {471,0.000000}, {472,0.000000}, {473,0.000000}, {474,0.000000}, {475,0.000000}, {476,0.000000}, {477,0.000000}, {478,0.000000}, {479,0.000000}, {480,0.000000}, {481,0.000000}, {482,0.000000}, {483,0.000000}, {484,0.000000}, {485,0.000000}, {486,0.000000}, {487,0.000000}, {488,0.000000}, {489,0.000000}, {490,0.000000}, {491,0.000000}, {492,0.000000}, {493,0.000000}, {494,0.000000}, {495,0.000000}, {496,0.000000}, {497,0.000000}, {498,0.000000}, {499,0.000000}, {500,0.000000}, {505,0.000000}, {510,0.000000}, {515,0.000000}, {520,0.000000}, {525,0.000000}, {530,0.000000}, {535,0.000000}, {540,0.000000}, {545,0.000000}, {550,0.000000}, {555,0.000000}, {560,0.000000}, {565,0.000000}, {570,0.000000}, {575,0.000000}, {580,0.000000}, {585,0.000000}, {590,0.000000}, {595,0.000000}, {600,0.000000}, {605,0.000000}, {610,0.000000}, {615,0.000000}, {620,0.000000}, {625,0.000000}, {630,0.000000}, {635,0.000000}, {640,0.000000}, {645,0.000000}, {650,0.000000}, {655,0.000000}, {660,0.000000}, {665,0.000000}, {670,0.000000}, {675,0.000000}, {680,0.000000}, {685,0.000000}, {690,0.000000}, {695,0.000000}, {700,0.000000}, {705,0.000000}, {710,0.000000}, {715,0.000000}, {720,0.000000}, {725,0.000000}, {730,0.000000}, {735,0.000000}, {740,0.000000}, {745,0.000000}, {750,0.000000}, {755,0.000000}, {760,0.000000}, {765,0.000000}, {770,0.000000}, {775,0.000000}, {780,0.000000}, {785,0.000000}, {790,0.000000}, {795,0.000000}, {800,0.000000}, {805,0.000000}, {810,0.000000}, {815,0.000000}, {820,0.000000}, {825,0.000000}, {830,0.000000}, {835,0.000000}, {840,0.000000}, {845,0.000000}, {850,0.000000}, {855,0.000000}, {860,0.000000}, {865,0.000000}, {870,0.000000}, {875,0.000000}, {880,0.000000}, {885,0.000000}, {890,0.000000}, {895,0.000000}, {900,0.000000}, {905,0.000000}, {910,0.000000}, {915,0.000000}, {920,0.000000}, {925,0.000000}, {930,0.000000}, {935,0.000000}, {940,0.000000}, {945,0.000000}, {950,0.000000}, {955,0.000000}, {960,0.000000}, {965,0.000000}, {970,0.000000}, {975,0.000000}, {980,0.000000}, {985,0.000000}, {990,0.000000}, {995,0.000000}, {1000,0.000000}, {1010,0.000000}, {1020,0.000000}, {1030,0.000000}, {1040,0.000000}, {1050,0.000000}, {1060,0.000000}, {1070,0.000000}, {1080,0.000000}, {1090,0.000000}, {1100,0.000000}, {1110,0.000000}, {1120,0.000000}, {1130,0.000000}, {1140,0.000000}, {1150,0.000000}, {1160,0.000000}, {1170,0.000000}, {1180,0.000000}, {1190,0.000000}, {1200,0.000000}, {1210,0.000000}, {1220,0.000000}, {1230,0.000000}, {1240,0.000000}, {1250,0.000000}, {1260,0.000000}, {1270,0.000000}, {1280,0.000000}, {1290,0.000000}, {1300,0.000000}, {1310,0.000000}, {1320,0.000000}, {1330,0.000000}, {1340,0.000000}, {1350,0.000000}, {1360,0.000000}, {1370,0.000000}, {1380,0.000000}, {1390,0.000000}, {1400,0.000000}, {1410,0.000000}, {1420,0.000000}, {1430,0.000000}, {1440,0.000000}, {1450,0.000000}, {1460,0.000000}, {1470,0.000000}, {1480,0.000000}, {1490,0.000000}, {1500,0.000000}, {1510,0.000000}, {1520,0.000000}, {1530,0.000000}, {1540,0.000000}, {1550,0.000000}, {1560,0.000000}, {1570,0.000000}, {1580,0.000000}, {1590,0.000000}, {1600,0.000000}, {1610,0.000000}, {1620,0.000000}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000000}, {1680,0.000000}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000000}, {1730,0.000000}, {1740,0.000000}, {1750,0.000000}, {1760,0.000000}, {1770,0.000000}, {1780,0.000000}, {1790,0.000000}, {1800,0.000000}, {1810,0.000000}, {1820,0.000000}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000000}, {1900,0.000000}, {1910,0.000000}, {1920,0.000000}, {1930,0.000000}, {1940,0.000000}, {1950,0.000000}, {1960,0.000000}, {1970,0.000000}, {1980,0.000000}, {1990,0.000000}, {2000,0.000000}};
data["big"]["TypeClassesBodyHOAS"]["post"]["user"] = {{1,0.00000000}, {2,0.00003509}, {3,0.00006140}, {4,0.00003509}, {5,0.00000000}, {6,0.00003509}, {7,0.00000000}, {8,0.00010526}, {9,0.00003509}, {10,0.00007018}, {11,0.00000000}, {12,0.00003509}, {13,0.00003509}, {14,0.00006140}, {15,0.00003509}, {16,0.00010526}, {17,0.00005263}, {18,0.00000000}, {19,0.00000000}, {20,0.00010526}, {21,0.00007018}, {22,0.00000000}, {23,0.00000000}, {24,0.00009649}, {25,0.00000000}, {26,0.00006140}, {27,0.00000000}, {28,0.00000000}, {29,0.00003509}, {30,0.00003509}, {31,0.00003509}, {32,0.00003509}, {33,0.00014035}, {34,0.00007018}, {35,0.00003509}, {36,0.00002632}, {37,0.00000000}, {38,0.00003509}, {39,0.00000000}, {40,0.00002632}, {41,0.00003509}, {42,0.00003509}, {43,0.00007018}, {44,0.00006140}, {45,0.00000000}, {46,0.00000000}, {47,0.00007018}, {48,0.00003509}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00003509}, {53,0.00002632}, {54,0.00000000}, {55,0.00003509}, {56,0.00000000}, {57,0.00000000}, {58,0.00003509}, {59,0.00000000}, {60,0.00000000}, {61,0.00003509}, {62,0.00000000}, {63,0.00000000}, {64,0.00002632}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00003509}, {69,0.00000000}, {70,0.00003509}, {71,0.00002632}, {72,0.00007018}, {73,0.00000000}, {74,0.00000000}, {75,0.00002632}, {76,0.00006140}, {77,0.00007018}, {78,0.00007018}, {79,0.00009649}, {80,0.00000000}, {81,0.00003509}, {82,0.00003509}, {83,0.00000000}, {84,0.00003509}, {85,0.00003509}, {86,0.00010784}, {87,0.00003922}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00003922}, {92,0.00000000}, {93,0.00007843}, {94,0.00014706}, {95,0.00007843}, {96,0.00003922}, {97,0.00003922}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00003922}, {102,0.00000000}, {103,0.00007843}, {104,0.00003922}, {105,0.00010784}, {106,0.00003922}, {107,0.00010784}, {108,0.00000000}, {109,0.00000000}, {110,0.00002941}, {111,0.00000000}, {112,0.00000000}, {113,0.00003922}, {114,0.00000000}, {115,0.00007843}, {116,0.00003922}, {117,0.00002941}, {118,0.00007843}, {119,0.00006863}, {120,0.00007843}, {121,0.00000000}, {122,0.00006863}, {123,0.00000000}, {124,0.00014706}, {125,0.00000000}, {126,0.00007843}, {127,0.00000000}, {128,0.00002941}, {129,0.00003922}, {130,0.00011765}, {131,0.00003922}, {132,0.00003922}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00003922}, {137,0.00002941}, {138,0.00006863}, {139,0.00000000}, {140,0.00000000}, {141,0.00002941}, {142,0.00000000}, {143,0.00003922}, {144,0.00002941}, {145,0.00000000}, {146,0.00000000}, {147,0.00011765}, {148,0.00007843}, {149,0.00007843}, {150,0.00007843}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00006863}, {155,0.00003922}, {156,0.00007843}, {157,0.00003922}, {158,0.00000000}, {159,0.00003922}, {160,0.00000000}, {161,0.00000000}, {162,0.00003922}, {163,0.00015686}, {164,0.00003922}, {165,0.00000000}, {166,0.00007843}, {167,0.00007843}, {168,0.00003922}, {169,0.00000000}, {170,0.00003922}, {171,0.00003922}, {172,0.00007843}, {173,0.00006863}, {174,0.00013725}, {175,0.00000000}, {176,0.00003922}, {177,0.00000000}, {178,0.00000000}, {179,0.00003922}, {180,0.00000000}, {181,0.00000000}, {182,0.00007843}, {183,0.00000000}, {184,0.00003922}, {185,0.00003922}, {186,0.00000000}, {187,0.00000000}, {188,0.00003922}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00002941}, {193,0.00003922}, {194,0.00000000}, {195,0.00002941}, {196,0.00014706}, {197,0.00007843}, {198,0.00003922}, {199,0.00003922}, {200,0.00006863}, {201,0.00003922}, {202,0.00006863}, {203,0.00003922}, {204,0.00002941}, {205,0.00002941}, {206,0.00007843}, {207,0.00007843}, {208,0.00003922}, {209,0.00000000}, {210,0.00003922}, {211,0.00003922}, {212,0.00007843}, {213,0.00003922}, {214,0.00011765}, {215,0.00007843}, {216,0.00011765}, {217,0.00000000}, {218,0.00000000}, {219,0.00015686}, {220,0.00003922}, {221,0.00000000}, {222,0.00003922}, {223,0.00000000}, {224,0.00003922}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00003922}, {231,0.00003922}, {232,0.00000000}, {233,0.00003922}, {234,0.00003922}, {235,0.00003922}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00007843}, {242,0.00002941}, {243,0.00003922}, {244,0.00007843}, {245,0.00003922}, {246,0.00003922}, {247,0.00000000}, {248,0.00000000}, {249,0.00002941}, {250,0.00019608}, {251,0.00007843}, {252,0.00000000}, {253,0.00007843}, {254,0.00002941}, {255,0.00000000}, {256,0.00011765}, {257,0.00003922}, {258,0.00006863}, {259,0.00003922}, {260,0.00003922}, {261,0.00003922}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00006863}, {266,0.00003922}, {267,0.00010784}, {268,0.00003922}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00003922}, {273,0.00000000}, {274,0.00006863}, {275,0.00000000}, {276,0.00003922}, {277,0.00000000}, {278,0.00003922}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00007843}, {283,0.00011765}, {284,0.00003922}, {285,0.00010784}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00003922}, {291,0.00003922}, {292,0.00003922}, {293,0.00002941}, {294,0.00011765}, {295,0.00000000}, {296,0.00007843}, {297,0.00006863}, {298,0.00007843}, {299,0.00000000}, {300,0.00000000}, {301,0.00003960}, {302,0.00000000}, {303,0.00002970}, {304,0.00000000}, {305,0.00006931}, {306,0.00010891}, {307,0.00000000}, {308,0.00000000}, {309,0.00003960}, {310,0.00003960}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00003960}, {316,0.00007921}, {317,0.00000000}, {318,0.00000000}, {319,0.00002970}, {320,0.00002970}, {321,0.00011881}, {322,0.00003960}, {323,0.00003960}, {324,0.00006931}, {325,0.00000000}, {326,0.00000000}, {327,0.00003960}, {328,0.00003960}, {329,0.00013861}, {330,0.00003960}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00003960}, {335,0.00000000}, {336,0.00011881}, {337,0.00003960}, {338,0.00000000}, {339,0.00003960}, {340,0.00011881}, {341,0.00007921}, {342,0.00000000}, {343,0.00000000}, {344,0.00005941}, {345,0.00002970}, {346,0.00003960}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00002970}, {351,0.00000000}, {352,0.00011881}, {353,0.00003960}, {354,0.00000000}, {355,0.00000000}, {356,0.00002970}, {357,0.00000000}, {358,0.00003960}, {359,0.00000000}, {360,0.00007921}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00002970}, {365,0.00007921}, {366,0.00003960}, {367,0.00003960}, {368,0.00003960}, {369,0.00000000}, {370,0.00003960}, {371,0.00000000}, {372,0.00009901}, {373,0.00000000}, {374,0.00003960}, {375,0.00003960}, {376,0.000000}, {377,0.000000}, {378,0.000231}, {379,0.000000}, {380,0.000231}, {381,0.000000}, {382,0.000231}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000231}, {397,0.000000}, {398,0.000000}, {399,0.000000}, {400,0.000308}, {401,0.000000}, {402,0.000000}, {403,0.000231}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000231}, {409,0.000000}, {410,0.000231}, {411,0.000000}, {412,0.000538}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000231}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000231}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}, {451,0.000231}, {452,0.000000}, {453,0.000000}, {454,0.000000}, {455,0.000000}, {456,0.000000}, {457,0.000000}, {458,0.000000}, {459,0.000000}, {460,0.000000}, {461,0.000000}, {462,0.000000}, {463,0.000000}, {464,0.000000}, {465,0.000000}, {466,0.000000}, {467,0.000231}, {468,0.000000}, {469,0.000000}, {470,0.000000}, {471,0.000000}, {472,0.000000}, {473,0.000000}, {474,0.000000}, {475,0.000000}, {476,0.000000}, {477,0.000000}, {478,0.000000}, {479,0.000000}, {480,0.000000}, {481,0.000000}, {482,0.000000}, {483,0.000000}, {484,0.000000}, {485,0.000000}, {486,0.000000}, {487,0.000000}, {488,0.000000}, {489,0.000000}, {490,0.000000}, {491,0.000000}, {492,0.000000}, {493,0.000231}, {494,0.000000}, {495,0.000000}, {496,0.000000}, {497,0.000000}, {498,0.000000}, {499,0.000000}, {500,0.000000}, {505,0.000000}, {510,0.000000}, {515,0.000000}, {520,0.000000}, {525,0.000000}, {530,0.000000}, {535,0.000000}, {540,0.000000}, {545,0.000000}, {550,0.000000}, {555,0.000000}, {560,0.000000}, {565,0.000000}, {570,0.000000}, {575,0.000000}, {580,0.000000}, {585,0.000000}, {590,0.000000}, {595,0.000000}, {600,0.000000}, {605,0.000231}, {610,0.000000}, {615,0.000000}, {620,0.000000}, {625,0.000000}, {630,0.000000}, {635,0.000000}, {640,0.000000}, {645,0.000000}, {650,0.000000}, {655,0.000000}, {660,0.000000}, {665,0.000000}, {670,0.000000}, {675,0.000308}, {680,0.000000}, {685,0.000000}, {690,0.000000}, {695,0.000000}, {700,0.000000}, {705,0.000231}, {710,0.000000}, {715,0.000000}, {720,0.000000}, {725,0.000000}, {730,0.000000}, {735,0.000000}, {740,0.000000}, {745,0.000000}, {750,0.000000}, {755,0.000000}, {760,0.000231}, {765,0.000000}, {770,0.000000}, {775,0.000000}, {780,0.000000}, {785,0.000000}, {790,0.000000}, {795,0.000000}, {800,0.000000}, {805,0.000000}, {810,0.000308}, {815,0.000000}, {820,0.000000}, {825,0.000000}, {830,0.000231}, {835,0.000000}, {840,0.000000}, {845,0.000000}, {850,0.000000}, {855,0.000231}, {860,0.000231}, {865,0.000000}, {870,0.000000}, {875,0.000000}, {880,0.000000}, {885,0.000000}, {890,0.000000}, {895,0.000231}, {900,0.000000}, {905,0.000000}, {910,0.000000}, {915,0.000000}, {920,0.000000}, {925,0.000000}, {930,0.000000}, {935,0.000000}, {940,0.000000}, {945,0.000231}, {950,0.000000}, {955,0.000000}, {960,0.000000}, {965,0.000000}, {970,0.000000}, {975,0.000000}, {980,0.000000}, {985,0.000231}, {990,0.000000}, {995,0.000231}, {1000,0.000000}, {1010,0.000000}, {1020,0.000000}, {1030,0.000000}, {1040,0.000000}, {1050,0.000000}, {1060,0.000000}, {1070,0.000000}, {1080,0.000000}, {1090,0.000000}, {1100,0.000000}, {1110,0.000000}, {1120,0.000000}, {1130,0.000000}, {1140,0.000000}, {1150,0.000000}, {1160,0.000231}, {1170,0.000000}, {1180,0.000000}, {1190,0.000000}, {1200,0.000000}, {1210,0.000000}, {1220,0.000000}, {1230,0.000000}, {1240,0.000000}, {1250,0.000000}, {1260,0.000231}, {1270,0.000000}, {1280,0.000000}, {1290,0.000231}, {1300,0.000231}, {1310,0.000000}, {1320,0.000000}, {1330,0.000000}, {1340,0.000231}, {1350,0.000000}, {1360,0.000000}, {1370,0.000308}, {1380,0.000000}, {1390,0.000000}, {1400,0.000000}, {1410,0.000000}, {1420,0.000000}, {1430,0.000000}, {1440,0.000000}, {1450,0.000000}, {1460,0.000000}, {1470,0.000000}, {1480,0.000000}, {1490,0.000231}, {1500,0.000000}, {1510,0.000000}, {1520,0.000000}, {1530,0.000000}, {1540,0.000000}, {1550,0.000000}, {1560,0.000000}, {1570,0.000000}, {1580,0.000000}, {1590,0.000000}, {1600,0.000000}, {1610,0.000000}, {1620,0.000000}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000308}, {1670,0.000000}, {1680,0.000000}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000000}, {1730,0.000000}, {1740,0.000000}, {1750,0.000000}, {1760,0.000000}, {1770,0.000000}, {1780,0.000308}, {1790,0.000000}, {1800,0.000000}, {1810,0.000000}, {1820,0.000000}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000231}, {1890,0.000000}, {1900,0.000000}, {1910,0.000000}, {1920,0.000000}, {1930,0.000000}, {1940,0.000000}, {1950,0.000000}, {1960,0.000000}, {1970,0.000000}, {1980,0.000000}, {1990,0.000308}, {2000,0.000000}};
data["big"]["TypeClassesBodyHOAS"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00003922}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00003922}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00003922}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00003922}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000000}, {400,0.000000}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}, {451,0.000000}, {452,0.000000}, {453,0.000000}, {454,0.000000}, {455,0.000000}, {456,0.000000}, {457,0.000000}, {458,0.000000}, {459,0.000000}, {460,0.000000}, {461,0.000000}, {462,0.000000}, {463,0.000000}, {464,0.000000}, {465,0.000000}, {466,0.000000}, {467,0.000000}, {468,0.000000}, {469,0.000000}, {470,0.000000}, {471,0.000000}, {472,0.000000}, {473,0.000000}, {474,0.000000}, {475,0.000000}, {476,0.000000}, {477,0.000000}, {478,0.000000}, {479,0.000000}, {480,0.000000}, {481,0.000000}, {482,0.000000}, {483,0.000000}, {484,0.000000}, {485,0.000000}, {486,0.000000}, {487,0.000000}, {488,0.000000}, {489,0.000000}, {490,0.000000}, {491,0.000000}, {492,0.000000}, {493,0.000000}, {494,0.000000}, {495,0.000000}, {496,0.000000}, {497,0.000000}, {498,0.000000}, {499,0.000000}, {500,0.000000}, {505,0.000000}, {510,0.000000}, {515,0.000000}, {520,0.000000}, {525,0.000000}, {530,0.000000}, {535,0.000000}, {540,0.000000}, {545,0.000000}, {550,0.000000}, {555,0.000000}, {560,0.000000}, {565,0.000000}, {570,0.000000}, {575,0.000000}, {580,0.000000}, {585,0.000000}, {590,0.000000}, {595,0.000000}, {600,0.000000}, {605,0.000000}, {610,0.000000}, {615,0.000000}, {620,0.000000}, {625,0.000000}, {630,0.000000}, {635,0.000000}, {640,0.000000}, {645,0.000000}, {650,0.000000}, {655,0.000000}, {660,0.000000}, {665,0.000000}, {670,0.000000}, {675,0.000000}, {680,0.000000}, {685,0.000000}, {690,0.000000}, {695,0.000000}, {700,0.000000}, {705,0.000000}, {710,0.000000}, {715,0.000000}, {720,0.000000}, {725,0.000000}, {730,0.000000}, {735,0.000000}, {740,0.000000}, {745,0.000000}, {750,0.000000}, {755,0.000000}, {760,0.000000}, {765,0.000000}, {770,0.000000}, {775,0.000000}, {780,0.000000}, {785,0.000000}, {790,0.000000}, {795,0.000000}, {800,0.000000}, {805,0.000000}, {810,0.000000}, {815,0.000000}, {820,0.000000}, {825,0.000000}, {830,0.000000}, {835,0.000000}, {840,0.000000}, {845,0.000000}, {850,0.000000}, {855,0.000000}, {860,0.000000}, {865,0.000000}, {870,0.000000}, {875,0.000000}, {880,0.000000}, {885,0.000000}, {890,0.000000}, {895,0.000000}, {900,0.000000}, {905,0.000000}, {910,0.000000}, {915,0.000000}, {920,0.000000}, {925,0.000000}, {930,0.000000}, {935,0.000000}, {940,0.000000}, {945,0.000000}, {950,0.000000}, {955,0.000000}, {960,0.000000}, {965,0.000000}, {970,0.000000}, {975,0.000000}, {980,0.000000}, {985,0.000000}, {990,0.000000}, {995,0.000000}, {1000,0.000000}, {1010,0.000000}, {1020,0.000000}, {1030,0.000000}, {1040,0.000000}, {1050,0.000000}, {1060,0.000000}, {1070,0.000000}, {1080,0.000000}, {1090,0.000000}, {1100,0.000000}, {1110,0.000000}, {1120,0.000000}, {1130,0.000000}, {1140,0.000000}, {1150,0.000000}, {1160,0.000000}, {1170,0.000000}, {1180,0.000000}, {1190,0.000000}, {1200,0.000000}, {1210,0.000000}, {1220,0.000000}, {1230,0.000000}, {1240,0.000000}, {1250,0.000000}, {1260,0.000000}, {1270,0.000000}, {1280,0.000000}, {1290,0.000000}, {1300,0.000000}, {1310,0.000000}, {1320,0.000000}, {1330,0.000000}, {1340,0.000000}, {1350,0.000000}, {1360,0.000000}, {1370,0.000000}, {1380,0.000000}, {1390,0.000000}, {1400,0.000000}, {1410,0.000000}, {1420,0.000000}, {1430,0.000000}, {1440,0.000000}, {1450,0.000000}, {1460,0.000000}, {1470,0.000000}, {1480,0.000000}, {1490,0.000000}, {1500,0.000000}, {1510,0.000000}, {1520,0.000000}, {1530,0.000000}, {1540,0.000000}, {1550,0.000000}, {1560,0.000000}, {1570,0.000000}, {1580,0.000000}, {1590,0.000000}, {1600,0.000000}, {1610,0.000000}, {1620,0.000000}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000000}, {1680,0.000000}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000000}, {1730,0.000000}, {1740,0.000000}, {1750,0.000000}, {1760,0.000000}, {1770,0.000000}, {1780,0.000000}, {1790,0.000000}, {1800,0.000000}, {1810,0.000000}, {1820,0.000000}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000000}, {1900,0.000000}, {1910,0.000000}, {1920,0.000000}, {1930,0.000000}, {1940,0.000000}, {1950,0.000000}, {1960,0.000000}, {1970,0.000000}, {1980,0.000000}, {1990,0.000000}, {2000,0.000000}};
data["big"]["TypeClassesBodyHOAS"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000000}, {400,0.000000}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}, {451,0.000000}, {452,0.000000}, {453,0.000000}, {454,0.000000}, {455,0.000000}, {456,0.000000}, {457,0.000000}, {458,0.000000}, {459,0.000000}, {460,0.000000}, {461,0.000000}, {462,0.000000}, {463,0.000000}, {464,0.000000}, {465,0.000000}, {466,0.000000}, {467,0.000000}, {468,0.000000}, {469,0.000000}, {470,0.000000}, {471,0.000000}, {472,0.000000}, {473,0.000000}, {474,0.000000}, {475,0.000000}, {476,0.000000}, {477,0.000000}, {478,0.000000}, {479,0.000000}, {480,0.000000}, {481,0.000000}, {482,0.000000}, {483,0.000000}, {484,0.000000}, {485,0.000000}, {486,0.000000}, {487,0.000000}, {488,0.000000}, {489,0.000000}, {490,0.000000}, {491,0.000000}, {492,0.000000}, {493,0.000000}, {494,0.000000}, {495,0.000000}, {496,0.000000}, {497,0.000000}, {498,0.000000}, {499,0.000000}, {500,0.000000}, {505,0.000000}, {510,0.000000}, {515,0.000000}, {520,0.000000}, {525,0.000000}, {530,0.000000}, {535,0.000000}, {540,0.000000}, {545,0.000000}, {550,0.000000}, {555,0.000000}, {560,0.000000}, {565,0.000000}, {570,0.000000}, {575,0.000000}, {580,0.000000}, {585,0.000000}, {590,0.000000}, {595,0.000000}, {600,0.000000}, {605,0.000000}, {610,0.000000}, {615,0.000000}, {620,0.000000}, {625,0.000000}, {630,0.000000}, {635,0.000000}, {640,0.000000}, {645,0.000000}, {650,0.000000}, {655,0.000000}, {660,0.000000}, {665,0.000000}, {670,0.000000}, {675,0.000000}, {680,0.000000}, {685,0.000000}, {690,0.000000}, {695,0.000000}, {700,0.000000}, {705,0.000000}, {710,0.000000}, {715,0.000000}, {720,0.000000}, {725,0.000000}, {730,0.000000}, {735,0.000000}, {740,0.000000}, {745,0.000000}, {750,0.000000}, {755,0.000000}, {760,0.000000}, {765,0.000000}, {770,0.000000}, {775,0.000000}, {780,0.000000}, {785,0.000000}, {790,0.000000}, {795,0.000000}, {800,0.000000}, {805,0.000000}, {810,0.000000}, {815,0.000000}, {820,0.000000}, {825,0.000000}, {830,0.000000}, {835,0.000000}, {840,0.000000}, {845,0.000000}, {850,0.000000}, {855,0.000000}, {860,0.000000}, {865,0.000000}, {870,0.000000}, {875,0.000000}, {880,0.000000}, {885,0.000000}, {890,0.000000}, {895,0.000000}, {900,0.000000}, {905,0.000000}, {910,0.000000}, {915,0.000000}, {920,0.000000}, {925,0.000000}, {930,0.000000}, {935,0.000000}, {940,0.000000}, {945,0.000000}, {950,0.000000}, {955,0.000000}, {960,0.000000}, {965,0.000000}, {970,0.000000}, {975,0.000000}, {980,0.000000}, {985,0.000000}, {990,0.000000}, {995,0.000000}, {1000,0.000000}, {1010,0.000000}, {1020,0.000000}, {1030,0.000000}, {1040,0.000000}, {1050,0.000000}, {1060,0.000000}, {1070,0.000000}, {1080,0.000000}, {1090,0.000000}, {1100,0.000000}, {1110,0.000000}, {1120,0.000000}, {1130,0.000000}, {1140,0.000000}, {1150,0.000000}, {1160,0.000000}, {1170,0.000000}, {1180,0.000000}, {1190,0.000000}, {1200,0.000000}, {1210,0.000000}, {1220,0.000000}, {1230,0.000000}, {1240,0.000000}, {1250,0.000000}, {1260,0.000000}, {1270,0.000000}, {1280,0.000000}, {1290,0.000000}, {1300,0.000000}, {1310,0.000000}, {1320,0.000000}, {1330,0.000000}, {1340,0.000000}, {1350,0.000000}, {1360,0.000000}, {1370,0.000000}, {1380,0.000000}, {1390,0.000000}, {1400,0.000000}, {1410,0.000000}, {1420,0.000000}, {1430,0.000000}, {1440,0.000000}, {1450,0.000000}, {1460,0.000000}, {1470,0.000000}, {1480,0.000000}, {1490,0.000000}, {1500,0.000000}, {1510,0.000000}, {1520,0.000000}, {1530,0.000000}, {1540,0.000000}, {1550,0.000000}, {1560,0.000000}, {1570,0.000000}, {1580,0.000000}, {1590,0.000000}, {1600,0.000000}, {1610,0.000000}, {1620,0.000000}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000000}, {1680,0.000000}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000000}, {1730,0.000000}, {1740,0.000000}, {1750,0.000000}, {1760,0.000000}, {1770,0.000000}, {1780,0.000000}, {1790,0.000000}, {1800,0.000000}, {1810,0.000000}, {1820,0.000000}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000000}, {1900,0.000000}, {1910,0.000000}, {1920,0.000000}, {1930,0.000000}, {1940,0.000000}, {1950,0.000000}, {1960,0.000000}, {1970,0.000000}, {1980,0.000000}, {1990,0.000000}, {2000,0.000000}};
data["big"]["TypeClassesBodyHOAS"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00003509}, {7,0.00000000}, {8,0.00000000}, {9,0.00003509}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00003509}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00003509}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00003509}, {35,0.00000000}, {36,0.00000000}, {37,0.00003509}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00002632}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00003509}, {55,0.00000000}, {56,0.00002632}, {57,0.00003509}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00003509}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00003922}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00003922}, {96,0.00000000}, {97,0.00000000}, {98,0.00003922}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00002941}, {105,0.00000000}, {106,0.00007843}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00003922}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00003922}, {136,0.00003922}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00003922}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00003922}, {160,0.00003922}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00003922}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00003922}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00003922}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00003922}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00003922}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00002941}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00003922}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00003922}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00003922}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00003922}, {295,0.00000000}, {296,0.00000000}, {297,0.00003922}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00003960}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00007921}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00002970}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00003960}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00003960}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00003960}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000000}, {400,0.000000}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}, {451,0.000000}, {452,0.000000}, {453,0.000000}, {454,0.000000}, {455,0.000000}, {456,0.000000}, {457,0.000308}, {458,0.000000}, {459,0.000000}, {460,0.000000}, {461,0.000000}, {462,0.000000}, {463,0.000000}, {464,0.000000}, {465,0.000000}, {466,0.000000}, {467,0.000000}, {468,0.000000}, {469,0.000000}, {470,0.000000}, {471,0.000000}, {472,0.000000}, {473,0.000000}, {474,0.000000}, {475,0.000000}, {476,0.000000}, {477,0.000000}, {478,0.000000}, {479,0.000000}, {480,0.000000}, {481,0.000000}, {482,0.000000}, {483,0.000000}, {484,0.000000}, {485,0.000000}, {486,0.000000}, {487,0.000000}, {488,0.000000}, {489,0.000000}, {490,0.000000}, {491,0.000000}, {492,0.000000}, {493,0.000000}, {494,0.000000}, {495,0.000000}, {496,0.000000}, {497,0.000000}, {498,0.000000}, {499,0.000000}, {500,0.000000}, {505,0.000000}, {510,0.000000}, {515,0.000000}, {520,0.000000}, {525,0.000000}, {530,0.000000}, {535,0.000000}, {540,0.000000}, {545,0.000000}, {550,0.000000}, {555,0.000000}, {560,0.000000}, {565,0.000000}, {570,0.000000}, {575,0.000000}, {580,0.000231}, {585,0.000000}, {590,0.000000}, {595,0.000000}, {600,0.000000}, {605,0.000000}, {610,0.000000}, {615,0.000000}, {620,0.000000}, {625,0.000000}, {630,0.000000}, {635,0.000000}, {640,0.000000}, {645,0.000000}, {650,0.000000}, {655,0.000000}, {660,0.000000}, {665,0.000000}, {670,0.000000}, {675,0.000000}, {680,0.000000}, {685,0.000000}, {690,0.000000}, {695,0.000000}, {700,0.000000}, {705,0.000231}, {710,0.000000}, {715,0.000000}, {720,0.000000}, {725,0.000000}, {730,0.000000}, {735,0.000000}, {740,0.000000}, {745,0.000000}, {750,0.000000}, {755,0.000000}, {760,0.000000}, {765,0.000000}, {770,0.000000}, {775,0.000000}, {780,0.000000}, {785,0.000000}, {790,0.000000}, {795,0.000000}, {800,0.000000}, {805,0.000000}, {810,0.000000}, {815,0.000000}, {820,0.000000}, {825,0.000000}, {830,0.000000}, {835,0.000000}, {840,0.000000}, {845,0.000000}, {850,0.000000}, {855,0.000000}, {860,0.000000}, {865,0.000000}, {870,0.000000}, {875,0.000000}, {880,0.000000}, {885,0.000000}, {890,0.000000}, {895,0.000000}, {900,0.000000}, {905,0.000000}, {910,0.000000}, {915,0.000000}, {920,0.000000}, {925,0.000000}, {930,0.000000}, {935,0.000000}, {940,0.000000}, {945,0.000000}, {950,0.000000}, {955,0.000000}, {960,0.000000}, {965,0.000000}, {970,0.000000}, {975,0.000000}, {980,0.000000}, {985,0.000000}, {990,0.000000}, {995,0.000000}, {1000,0.000000}, {1010,0.000000}, {1020,0.000000}, {1030,0.000000}, {1040,0.000000}, {1050,0.000000}, {1060,0.000000}, {1070,0.000000}, {1080,0.000000}, {1090,0.000000}, {1100,0.000000}, {1110,0.000000}, {1120,0.000000}, {1130,0.000000}, {1140,0.000000}, {1150,0.000000}, {1160,0.000000}, {1170,0.000000}, {1180,0.000000}, {1190,0.000000}, {1200,0.000000}, {1210,0.000000}, {1220,0.000000}, {1230,0.000000}, {1240,0.000000}, {1250,0.000000}, {1260,0.000000}, {1270,0.000000}, {1280,0.000000}, {1290,0.000000}, {1300,0.000000}, {1310,0.000000}, {1320,0.000000}, {1330,0.000000}, {1340,0.000000}, {1350,0.000000}, {1360,0.000000}, {1370,0.000000}, {1380,0.000000}, {1390,0.000000}, {1400,0.000000}, {1410,0.000000}, {1420,0.000000}, {1430,0.000000}, {1440,0.000000}, {1450,0.000000}, {1460,0.000000}, {1470,0.000000}, {1480,0.000000}, {1490,0.000000}, {1500,0.000000}, {1510,0.000000}, {1520,0.000000}, {1530,0.000000}, {1540,0.000000}, {1550,0.000000}, {1560,0.000000}, {1570,0.000000}, {1580,0.000000}, {1590,0.000000}, {1600,0.000000}, {1610,0.000000}, {1620,0.000000}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000000}, {1680,0.000000}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000000}, {1730,0.000000}, {1740,0.000000}, {1750,0.000000}, {1760,0.000000}, {1770,0.000000}, {1780,0.000000}, {1790,0.000000}, {1800,0.000000}, {1810,0.000000}, {1820,0.000000}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000000}, {1900,0.000000}, {1910,0.000000}, {1920,0.000000}, {1930,0.000000}, {1940,0.000000}, {1950,0.000000}, {1960,0.000000}, {1970,0.000000}, {1980,0.000000}, {1990,0.000000}, {2000,0.000000}};
data["big"]["TypeClassesBodyHOAS"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000000}, {380,0.000000}, {381,0.000000}, {382,0.000000}, {383,0.000000}, {384,0.000000}, {385,0.000000}, {386,0.000000}, {387,0.000000}, {388,0.000000}, {389,0.000000}, {390,0.000000}, {391,0.000000}, {392,0.000000}, {393,0.000000}, {394,0.000000}, {395,0.000000}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000000}, {400,0.000000}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000000}, {412,0.000000}, {413,0.000000}, {414,0.000000}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000000}, {422,0.000000}, {423,0.000000}, {424,0.000000}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000000}, {431,0.000000}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000000}, {439,0.000000}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000000}, {449,0.000000}, {450,0.000000}, {451,0.000000}, {452,0.000000}, {453,0.000000}, {454,0.000000}, {455,0.000000}, {456,0.000000}, {457,0.000000}, {458,0.000000}, {459,0.000000}, {460,0.000000}, {461,0.000000}, {462,0.000000}, {463,0.000000}, {464,0.000000}, {465,0.000000}, {466,0.000000}, {467,0.000000}, {468,0.000000}, {469,0.000000}, {470,0.000000}, {471,0.000000}, {472,0.000000}, {473,0.000000}, {474,0.000000}, {475,0.000000}, {476,0.000000}, {477,0.000000}, {478,0.000000}, {479,0.000000}, {480,0.000000}, {481,0.000000}, {482,0.000000}, {483,0.000000}, {484,0.000000}, {485,0.000000}, {486,0.000000}, {487,0.000000}, {488,0.000000}, {489,0.000000}, {490,0.000000}, {491,0.000000}, {492,0.000000}, {493,0.000000}, {494,0.000000}, {495,0.000000}, {496,0.000000}, {497,0.000000}, {498,0.000000}, {499,0.000000}, {500,0.000000}, {505,0.000000}, {510,0.000000}, {515,0.000000}, {520,0.000000}, {525,0.000000}, {530,0.000000}, {535,0.000000}, {540,0.000000}, {545,0.000000}, {550,0.000000}, {555,0.000000}, {560,0.000000}, {565,0.000000}, {570,0.000000}, {575,0.000000}, {580,0.000000}, {585,0.000000}, {590,0.000000}, {595,0.000000}, {600,0.000000}, {605,0.000000}, {610,0.000000}, {615,0.000000}, {620,0.000000}, {625,0.000000}, {630,0.000000}, {635,0.000000}, {640,0.000000}, {645,0.000000}, {650,0.000000}, {655,0.000000}, {660,0.000000}, {665,0.000000}, {670,0.000000}, {675,0.000000}, {680,0.000000}, {685,0.000000}, {690,0.000000}, {695,0.000000}, {700,0.000000}, {705,0.000000}, {710,0.000000}, {715,0.000000}, {720,0.000000}, {725,0.000000}, {730,0.000000}, {735,0.000000}, {740,0.000000}, {745,0.000000}, {750,0.000000}, {755,0.000000}, {760,0.000000}, {765,0.000000}, {770,0.000000}, {775,0.000000}, {780,0.000000}, {785,0.000000}, {790,0.000000}, {795,0.000000}, {800,0.000000}, {805,0.000000}, {810,0.000000}, {815,0.000000}, {820,0.000000}, {825,0.000000}, {830,0.000000}, {835,0.000000}, {840,0.000000}, {845,0.000000}, {850,0.000000}, {855,0.000000}, {860,0.000000}, {865,0.000000}, {870,0.000000}, {875,0.000000}, {880,0.000000}, {885,0.000000}, {890,0.000000}, {895,0.000000}, {900,0.000000}, {905,0.000000}, {910,0.000000}, {915,0.000000}, {920,0.000000}, {925,0.000000}, {930,0.000000}, {935,0.000000}, {940,0.000000}, {945,0.000000}, {950,0.000000}, {955,0.000000}, {960,0.000000}, {965,0.000000}, {970,0.000000}, {975,0.000000}, {980,0.000000}, {985,0.000000}, {990,0.000000}, {995,0.000000}, {1000,0.000000}, {1010,0.000000}, {1020,0.000000}, {1030,0.000000}, {1040,0.000000}, {1050,0.000000}, {1060,0.000000}, {1070,0.000000}, {1080,0.000000}, {1090,0.000000}, {1100,0.000000}, {1110,0.000000}, {1120,0.000000}, {1130,0.000000}, {1140,0.000000}, {1150,0.000000}, {1160,0.000000}, {1170,0.000000}, {1180,0.000000}, {1190,0.000000}, {1200,0.000000}, {1210,0.000000}, {1220,0.000000}, {1230,0.000000}, {1240,0.000000}, {1250,0.000000}, {1260,0.000000}, {1270,0.000000}, {1280,0.000000}, {1290,0.000000}, {1300,0.000000}, {1310,0.000000}, {1320,0.000000}, {1330,0.000000}, {1340,0.000000}, {1350,0.000000}, {1360,0.000000}, {1370,0.000000}, {1380,0.000000}, {1390,0.000000}, {1400,0.000000}, {1410,0.000000}, {1420,0.000000}, {1430,0.000000}, {1440,0.000000}, {1450,0.000000}, {1460,0.000000}, {1470,0.000000}, {1480,0.000000}, {1490,0.000000}, {1500,0.000000}, {1510,0.000000}, {1520,0.000000}, {1530,0.000000}, {1540,0.000000}, {1550,0.000000}, {1560,0.000000}, {1570,0.000000}, {1580,0.000000}, {1590,0.000000}, {1600,0.000000}, {1610,0.000000}, {1620,0.000000}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000000}, {1680,0.000000}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000000}, {1730,0.000000}, {1740,0.000000}, {1750,0.000000}, {1760,0.000000}, {1770,0.000000}, {1780,0.000000}, {1790,0.000000}, {1800,0.000000}, {1810,0.000000}, {1820,0.000000}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000000}, {1900,0.000000}, {1910,0.000000}, {1920,0.000000}, {1930,0.000000}, {1940,0.000000}, {1950,0.000000}, {1960,0.000000}, {1970,0.000000}, {1980,0.000000}, {1990,0.000000}, {2000,0.000000}};
data["big"]["TypeClassesBodyHOAS"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00066667}, {5,0.00100000}, {6,0.00100000}, {7,0.00100000}, {8,0.00106140}, {9,0.00200000}, {10,0.00200000}, {11,0.00200000}, {12,0.00246491}, {13,0.00295614}, {14,0.00300000}, {15,0.02317544}, {16,0.00315789}, {17,0.00400000}, {18,0.00405263}, {19,0.00428070}, {20,0.00500000}, {21,0.00530702}, {22,0.00546491}, {23,0.00607018}, {24,0.00647368}, {25,0.00664035}, {26,0.00755263}, {27,0.00761404}, {28,0.00843860}, {29,0.00850000}, {30,0.01016667}, {31,0.00947368}, {32,0.00960526}, {33,0.01035965}, {34,0.01082456}, {35,0.01136842}, {36,0.01188596}, {37,0.01236842}, {38,0.01283333}, {39,0.01321930}, {40,0.01375439}, {41,0.01442982}, {42,0.01502632}, {43,0.01619298}, {44,0.01612281}, {45,0.01939474}, {46,0.01747368}, {47,0.01815789}, {48,0.01878070}, {49,0.01903509}, {50,0.02274561}, {51,0.02021053}, {52,0.02097368}, {53,0.02195614}, {54,0.02278947}, {55,0.02601754}, {56,0.02398246}, {57,0.02461404}, {58,0.02514912}, {59,0.03052632}, {60,0.02680702}, {61,0.02774561}, {62,0.02862281}, {63,0.03148246}, {64,0.02993860}, {65,0.03100000}, {66,0.03778070}, {67,0.03219298}, {68,0.03347368}, {69,0.03979825}, {70,0.03479825}, {71,0.03594737}, {72,0.04128947}, {73,0.03768421}, {74,0.03835088}, {75,0.04342105}, {76,0.04037719}, {77,0.05131579}, {78,0.04148246}, {79,0.04294737}, {80,0.04648246}, {81,0.04562281}, {82,0.05364912}, {83,0.04714912}, {84,0.07007895}, {85,0.04896491}, {86,0.05651961}, {87,0.05100980}, {88,0.05752941}, {89,0.05311765}, {90,0.06364706}, {91,0.05481373}, {92,0.06260784}, {93,0.05718627}, {94,0.06359804}, {95,0.05999020}, {96,0.06549020}, {97,0.06259804}, {98,0.06773529}, {99,0.07598039}, {100,0.06580392}, {101,0.07017647}, {102,0.08093137}, {103,0.06909804}, {104,0.07305882}, {105,0.08388235}, {106,0.07274510}, {107,0.07702941}, {108,0.08789216}, {109,0.07691176}, {110,0.08080392}, {111,0.08963725}, {112,0.09382353}, {113,0.08213725}, {114,0.08621569}, {115,0.09541176}, {116,0.09879412}, {117,0.10051961}, {118,0.08927451}, {119,0.09287255}, {120,0.10561765}, {121,0.10630392}, {122,0.11013725}, {123,0.11090196}, {124,0.11342157}, {125,0.11445098}, {126,0.11209804}, {127,0.10276471}, {128,0.11295098}, {129,0.11553922}, {130,0.11780392}, {131,0.11868627}, {132,0.12016667}, {133,0.12261765}, {134,0.12404902}, {135,0.13668627}, {136,0.13004902}, {137,0.12925490}, {138,0.12997059}, {139,0.13185294}, {140,0.13355882}, {141,0.18465686}, {142,0.14241176}, {143,0.23558824}, {144,0.14791176}, {145,0.14606863}, {146,0.14787255}, {147,0.14806863}, {148,0.15950980}, {149,0.14883333}, {150,0.14977451}, {151,0.15210784}, {152,0.16646078}, {153,0.15430392}, {154,0.15686275}, {155,0.16995098}, {156,0.16208824}, {157,0.16320588}, {158,0.16946078}, {159,0.17040196}, {160,0.18903922}, {161,0.17342157}, {162,0.18873529}, {163,0.17496078}, {164,0.19056863}, {165,0.17749020}, {166,0.19390196}, {167,0.18214706}, {168,0.19650000}, {169,0.18600980}, {170,0.20201961}, {171,0.20955882}, {172,0.19601961}, {173,0.21333333}, {174,0.21302941}, {175,0.19895098}, {176,0.21490196}, {177,0.21686275}, {178,0.20528431}, {179,0.20888235}, {180,0.22061765}, {181,0.22300980}, {182,0.23023529}, {183,0.21578431}, {184,0.22256863}, {185,0.23884314}, {186,0.24212745}, {187,0.23960784}, {188,0.24180392}, {189,0.24097059}, {190,0.24416667}, {191,0.24554902}, {192,0.24731373}, {193,0.25310784}, {194,0.25591176}, {195,0.26307843}, {196,0.26154902}, {197,0.26393137}, {198,0.26342157}, {199,0.26519608}, {200,0.27845098}, {201,0.26874510}, {202,0.26995098}, {203,0.27687255}, {204,0.28138235}, {205,0.28850000}, {206,0.28855882}, {207,0.28642157}, {208,0.30484314}, {209,0.28699020}, {210,0.29053922}, {211,0.30681373}, {212,0.29849020}, {213,0.31558824}, {214,0.30482353}, {215,0.32554902}, {216,0.31304902}, {217,0.32476471}, {218,0.31377451}, {219,0.32990196}, {220,0.31668627}, {221,0.33662745}, {222,0.33857843}, {223,0.33310784}, {224,0.35134314}, {225,0.34628431}, {226,0.33403922}, {227,0.34835294}, {228,0.35429412}, {229,0.36045098}, {230,0.34924510}, {231,0.36602941}, {232,0.36762745}, {233,0.37248039}, {234,0.37013725}, {235,0.37296078}, {236,0.38208824}, {237,0.37988235}, {238,0.38419608}, {239,0.38497059}, {240,0.39216667}, {241,0.39251961}, {242,0.39256863}, {243,0.39744118}, {244,0.40407843}, {245,0.40888235}, {246,0.41780392}, {247,0.41517647}, {248,0.41305882}, {249,0.41321569}, {250,0.46484314}, {251,0.43121569}, {252,0.42917647}, {253,0.43852941}, {254,0.43332353}, {255,0.43745098}, {256,0.45357843}, {257,0.45348039}, {258,0.45842157}, {259,0.45247059}, {260,0.45850980}, {261,0.46782353}, {262,0.46750980}, {263,0.47545098}, {264,0.47664706}, {265,0.47863725}, {266,0.48404902}, {267,0.49162745}, {268,0.48946078}, {269,0.49977451}, {270,0.49876471}, {271,0.49810784}, {272,0.50983333}, {273,0.51329412}, {274,0.51630392}, {275,0.52182353}, {276,0.52048039}, {277,0.52837255}, {278,0.53522549}, {279,0.53375490}, {280,0.54541176}, {281,0.54410784}, {282,0.54876471}, {283,0.55587255}, {284,0.55149020}, {285,0.56456863}, {286,0.56675490}, {287,0.56418627}, {288,0.57881373}, {289,0.57478431}, {290,0.58441176}, {291,0.58588235}, {292,0.58591176}, {293,0.59909804}, {294,0.59408824}, {295,0.61049020}, {296,0.61143137}, {297,0.60916667}, {298,0.62333333}, {299,0.61800980}, {300,0.63186275}, {301,0.62711881}, {302,0.63155446}, {303,0.64142574}, {304,0.64135644}, {305,0.65291089}, {306,0.64790099}, {307,0.66148515}, {308,0.65792079}, {309,0.66890099}, {310,0.66796040}, {311,0.67201980}, {312,0.68195050}, {313,0.68663366}, {314,0.69209901}, {315,0.69198020}, {316,0.70269307}, {317,0.70464356}, {318,0.71129703}, {319,0.70704950}, {320,0.72113861}, {321,0.72103960}, {322,0.73185149}, {323,0.72887129}, {324,0.74277228}, {325,0.73749505}, {326,0.76037624}, {327,0.75299010}, {328,0.76142574}, {329,0.75756436}, {330,0.76803960}, {331,0.77039604}, {332,0.78335644}, {333,0.77940594}, {334,0.79044554}, {335,0.78894059}, {336,0.80039604}, {337,0.80000990}, {338,0.80625743}, {339,0.80922772}, {340,0.81649505}, {341,0.82393069}, {342,0.82686139}, {343,0.83171287}, {344,0.83989109}, {345,0.84420792}, {346,0.84593069}, {347,0.85153465}, {348,0.86187129}, {349,0.87026733}, {350,0.87198020}, {351,0.87135644}, {352,0.88454455}, {353,0.88608911}, {354,0.89031683}, {355,0.89957426}, {356,0.90439604}, {357,0.94973267}, {358,0.90527723}, {359,0.97355446}, {360,0.92437624}, {361,0.92986139}, {362,0.93639604}, {363,0.94445545}, {364,0.94521782}, {365,0.94716832}, {366,0.96595050}, {367,0.96551485}, {368,0.96349505}, {369,0.98316832}, {370,0.97843564}, {371,0.98625743}, {372,0.99190099}, {373,0.99592079}, {374,1.00406931}, {375,1.00523762}, {376,1.012462}, {377,0.997308}, {378,1.006462}, {379,1.012000}, {380,1.007308}, {381,1.031000}, {382,1.031692}, {383,1.148000}, {384,1.044308}, {385,1.042692}, {386,1.174615}, {387,1.188846}, {388,1.067769}, {389,1.066308}, {390,1.073154}, {391,1.079923}, {392,1.090692}, {393,1.091615}, {394,1.096231}, {395,1.098231}, {396,1.104308}, {397,1.115615}, {398,1.120538}, {399,1.130692}, {400,1.127308}, {401,1.208000}, {402,1.151846}, {403,1.154462}, {404,1.158385}, {405,1.166462}, {406,1.172769}, {407,1.181769}, {408,1.184077}, {409,1.196385}, {410,1.196385}, {411,1.211538}, {412,1.212846}, {413,1.217615}, {414,1.222538}, {415,1.225385}, {416,1.239538}, {417,1.236538}, {418,1.253077}, {419,1.250000}, {420,1.268000}, {421,1.265923}, {422,1.272000}, {423,1.276308}, {424,1.292077}, {425,1.292769}, {426,1.309077}, {427,1.305846}, {428,1.331538}, {429,1.319615}, {430,1.324692}, {431,1.337538}, {432,1.360308}, {433,1.357308}, {434,1.358538}, {435,1.363615}, {436,1.389462}, {437,1.380538}, {438,1.389615}, {439,1.399077}, {440,1.412923}, {441,1.405692}, {442,1.414923}, {443,1.428000}, {444,1.443615}, {445,1.436615}, {446,1.447231}, {447,1.456154}, {448,1.480923}, {449,1.459923}, {450,1.473923}, {451,1.493846}, {452,1.501769}, {453,1.486692}, {454,1.505000}, {455,1.522077}, {456,1.517769}, {457,1.525615}, {458,1.537385}, {459,1.553231}, {460,1.547385}, {461,1.548308}, {462,1.572077}, {463,1.576769}, {464,1.574923}, {465,1.589308}, {466,1.606923}, {467,1.611385}, {468,1.601692}, {469,1.620308}, {470,1.632077}, {471,1.628231}, {472,1.636923}, {473,1.666615}, {474,1.665000}, {475,1.664231}, {476,1.679462}, {477,1.688231}, {478,1.689538}, {479,1.698231}, {480,1.710692}, {481,1.716462}, {482,1.720077}, {483,1.733692}, {484,1.739923}, {485,1.747308}, {486,1.759308}, {487,1.763538}, {488,1.789462}, {489,1.847538}, {490,1.798000}, {491,1.806615}, {492,1.814385}, {493,1.815923}, {494,1.830769}, {495,1.844308}, {496,1.834308}, {497,1.860462}, {498,1.858154}, {499,1.854000}, {500,1.865000}, {505,1.918308}, {510,1.947615}, {515,2.000000}, {520,2.063308}, {525,2.104231}, {530,2.144846}, {535,2.198000}, {540,2.232000}, {545,2.374385}, {550,2.320462}, {555,2.377385}, {560,2.443077}, {565,2.469385}, {570,2.522769}, {575,2.565077}, {580,2.688462}, {585,2.743154}, {590,2.715538}, {595,2.780769}, {600,2.845462}, {605,2.891154}, {610,2.939000}, {615,3.012538}, {620,3.048385}, {625,3.124615}, {630,3.214000}, {635,3.294308}, {640,3.526000}, {645,3.333538}, {650,3.377615}, {655,3.517231}, {660,3.499538}, {665,3.562538}, {670,3.617462}, {675,3.770000}, {680,3.750077}, {685,3.821769}, {690,3.967308}, {695,3.957308}, {700,4.171077}, {705,4.078000}, {710,4.155769}, {715,4.221462}, {720,4.380154}, {725,4.307154}, {730,4.463769}, {735,4.511308}, {740,4.551154}, {745,4.702846}, {750,4.671154}, {755,4.777231}, {760,4.841231}, {765,4.916308}, {770,4.993923}, {775,5.132769}, {780,5.146154}, {785,5.302692}, {790,5.420769}, {795,5.595154}, {800,5.636769}, {805,5.813462}, {810,5.898769}, {815,5.813231}, {820,6.134385}, {825,6.231846}, {830,6.157231}, {835,6.443769}, {840,6.277846}, {845,6.714077}, {850,6.605846}, {855,6.607385}, {860,6.883692}, {865,6.785846}, {870,7.046154}, {875,7.425769}, {880,7.237692}, {885,7.090923}, {890,7.351615}, {895,7.469692}, {900,7.641154}, {905,7.584077}, {910,7.685615}, {915,8.055846}, {920,7.917000}, {925,8.112846}, {930,8.284077}, {935,8.327308}, {940,8.435231}, {945,8.604923}, {950,8.811077}, {955,8.846692}, {960,8.885077}, {965,9.079615}, {970,9.529000}, {975,9.316385}, {980,9.423923}, {985,9.468308}, {990,9.862769}, {995,9.782769}, {1000,9.824462}, {1010,10.069692}, {1020,10.510385}, {1030,10.910769}, {1040,10.971692}, {1050,11.126231}, {1060,11.727385}, {1070,11.925923}, {1080,12.074769}, {1090,12.708923}, {1100,12.815308}, {1110,13.030154}, {1120,13.279923}, {1130,13.584462}, {1140,14.095000}, {1150,14.500615}, {1160,14.752923}, {1170,15.138308}, {1180,15.080846}, {1190,15.698231}, {1200,16.257538}, {1210,16.377231}, {1220,16.590154}, {1230,17.136923}, {1240,17.061692}, {1250,18.119154}, {1260,18.007615}, {1270,18.314308}, {1280,18.773846}, {1290,19.310769}, {1300,19.815000}, {1310,20.185385}, {1320,20.130154}, {1330,20.822077}, {1340,21.356462}, {1350,22.396000}, {1360,22.266538}, {1370,22.551231}, {1380,23.186308}, {1390,23.643154}, {1400,24.692231}, {1410,24.598000}, {1420,24.875308}, {1430,25.478308}, {1440,26.117846}, {1450,26.197462}, {1460,26.678923}, {1470,27.682385}, {1480,27.475000}, {1490,28.537846}, {1500,28.925077}, {1510,29.552308}, {1520,29.845692}, {1530,30.651692}, {1540,30.917692}, {1550,31.499308}, {1560,32.370000}, {1570,33.140769}, {1580,32.944769}, {1590,33.855154}, {1600,34.858692}, {1610,35.763077}, {1620,36.053692}, {1630,35.818846}, {1640,36.695385}, {1650,37.678462}, {1660,37.971615}, {1670,39.206846}, {1680,39.186308}, {1690,40.122154}, {1700,39.967846}, {1710,41.681923}, {1720,42.424077}, {1730,42.466769}, {1740,42.748308}, {1750,44.683077}, {1760,44.737846}, {1770,45.350231}, {1780,45.784615}, {1790,46.979769}, {1800,47.405538}, {1810,48.902538}, {1820,49.071846}, {1830,49.541923}, {1840,50.445615}, {1850,50.552692}, {1860,51.538615}, {1870,52.440077}, {1880,52.607154}, {1890,53.464769}, {1900,54.240615}, {1910,54.688154}, {1920,55.989231}, {1930,56.474538}, {1940,57.967308}, {1950,58.202000}, {1960,59.073923}, {1970,60.158923}, {1980,60.197769}, {1990,61.960923}, {2000,62.367231}};
data["big"]["TypeClassesBodyHOAS"]["reif"]["user"] = {{1,0.00049123}, {2,0.00041228}, {3,0.00080702}, {4,0.00102632}, {5,0.00107018}, {6,0.00094737}, {7,0.00181579}, {8,0.00200000}, {9,0.00184211}, {10,0.00197368}, {11,0.00237719}, {12,0.00264035}, {13,0.00306140}, {14,0.00324561}, {15,0.02360526}, {16,0.00370175}, {17,0.00407018}, {18,0.00424561}, {19,0.00472807}, {20,0.00506140}, {21,0.00563158}, {22,0.00560526}, {23,0.00608772}, {24,0.00654386}, {25,0.00696491}, {26,0.00742105}, {27,0.00790351}, {28,0.00819298}, {29,0.00885965}, {30,0.01029825}, {31,0.00963158}, {32,0.00941228}, {33,0.01041228}, {34,0.01061404}, {35,0.01128070}, {36,0.01185088}, {37,0.01221053}, {38,0.01262281}, {39,0.01292982}, {40,0.01353509}, {41,0.01402632}, {42,0.01464035}, {43,0.01565789}, {44,0.01621053}, {45,0.01952632}, {46,0.01736842}, {47,0.01772807}, {48,0.01857018}, {49,0.01872807}, {50,0.02287719}, {51,0.01975439}, {52,0.02102632}, {53,0.02191228}, {54,0.02313158}, {55,0.02622807}, {56,0.02414035}, {57,0.02491228}, {58,0.02545614}, {59,0.03059649}, {60,0.02720175}, {61,0.02804386}, {62,0.02882456}, {63,0.03142105}, {64,0.03008772}, {65,0.03094737}, {66,0.03793860}, {67,0.03230702}, {68,0.03349123}, {69,0.03964912}, {70,0.03504386}, {71,0.03585965}, {72,0.04124561}, {73,0.03759649}, {74,0.03796491}, {75,0.04309649}, {76,0.04018421}, {77,0.05175439}, {78,0.04111404}, {79,0.04251754}, {80,0.04627193}, {81,0.04571930}, {82,0.05379825}, {83,0.04721930}, {84,0.07008772}, {85,0.04954386}, {86,0.05668627}, {87,0.05110784}, {88,0.05739216}, {89,0.05335294}, {90,0.06371569}, {91,0.05482353}, {92,0.06220588}, {93,0.05708824}, {94,0.06353922}, {95,0.05982353}, {96,0.06498039}, {97,0.06239216}, {98,0.06764706}, {99,0.07617647}, {100,0.06561765}, {101,0.07010784}, {102,0.08096078}, {103,0.06876471}, {104,0.07334314}, {105,0.08363725}, {106,0.07313725}, {107,0.07729412}, {108,0.08778431}, {109,0.07725490}, {110,0.08101961}, {111,0.08936275}, {112,0.09350000}, {113,0.08206863}, {114,0.08580392}, {115,0.09527451}, {116,0.09873529}, {117,0.10026471}, {118,0.08878431}, {119,0.09297059}, {120,0.10546078}, {121,0.10609804}, {122,0.10984314}, {123,0.11089216}, {124,0.11316667}, {125,0.11385294}, {126,0.11196078}, {127,0.10274510}, {128,0.11245098}, {129,0.11496078}, {130,0.11757843}, {131,0.11825490}, {132,0.11998039}, {133,0.12243137}, {134,0.12408824}, {135,0.13534314}, {136,0.12942157}, {137,0.12851961}, {138,0.12961765}, {139,0.13172549}, {140,0.13285294}, {141,0.18427451}, {142,0.14179412}, {143,0.23502941}, {144,0.14750980}, {145,0.14591176}, {146,0.14768627}, {147,0.14784314}, {148,0.15901961}, {149,0.14865686}, {150,0.14968627}, {151,0.15189216}, {152,0.16633333}, {153,0.15395098}, {154,0.15632353}, {155,0.16967647}, {156,0.16171569}, {157,0.16307843}, {158,0.16889216}, {159,0.17029412}, {160,0.18877451}, {161,0.17326471}, {162,0.18832353}, {163,0.17498039}, {164,0.19046078}, {165,0.17699020}, {166,0.19386275}, {167,0.18198039}, {168,0.19606863}, {169,0.18559804}, {170,0.20180392}, {171,0.20922549}, {172,0.19571569}, {173,0.21301961}, {174,0.21266667}, {175,0.19833333}, {176,0.21463725}, {177,0.21665686}, {178,0.20510784}, {179,0.20861765}, {180,0.22044118}, {181,0.22260784}, {182,0.22957843}, {183,0.21556863}, {184,0.22218627}, {185,0.23839216}, {186,0.24174510}, {187,0.23906863}, {188,0.24137255}, {189,0.24035294}, {190,0.24379412}, {191,0.24493137}, {192,0.24657843}, {193,0.25258824}, {194,0.25519608}, {195,0.26256863}, {196,0.26122549}, {197,0.26360784}, {198,0.26306863}, {199,0.26459804}, {200,0.27809804}, {201,0.26826471}, {202,0.26928431}, {203,0.27631373}, {204,0.28088235}, {205,0.28779412}, {206,0.28785294}, {207,0.28602941}, {208,0.30443137}, {209,0.28633333}, {210,0.29015686}, {211,0.30621569}, {212,0.29830392}, {213,0.31485294}, {214,0.30431373}, {215,0.32500000}, {216,0.31244118}, {217,0.32440196}, {218,0.31305882}, {219,0.32941176}, {220,0.31619608}, {221,0.33598039}, {222,0.33831373}, {223,0.33273529}, {224,0.35059804}, {225,0.34550000}, {226,0.33347059}, {227,0.34799020}, {228,0.35380392}, {229,0.35992157}, {230,0.34859804}, {231,0.36548039}, {232,0.36709804}, {233,0.37168627}, {234,0.36906863}, {235,0.37213725}, {236,0.38131373}, {237,0.37954902}, {238,0.38350980}, {239,0.38426471}, {240,0.39160784}, {241,0.39176471}, {242,0.39214706}, {243,0.39661765}, {244,0.40327451}, {245,0.40822549}, {246,0.41737255}, {247,0.41421569}, {248,0.41217647}, {249,0.41270588}, {250,0.46374510}, {251,0.43075490}, {252,0.42828431}, {253,0.43783333}, {254,0.43272549}, {255,0.43662745}, {256,0.45253922}, {257,0.45273529}, {258,0.45797059}, {259,0.45166667}, {260,0.45768627}, {261,0.46705882}, {262,0.46685294}, {263,0.47463725}, {264,0.47594118}, {265,0.47758824}, {266,0.48304902}, {267,0.49059804}, {268,0.48848039}, {269,0.49915686}, {270,0.49783333}, {271,0.49744118}, {272,0.50910784}, {273,0.51291176}, {274,0.51533333}, {275,0.52092157}, {276,0.51972549}, {277,0.52745098}, {278,0.53438235}, {279,0.53257843}, {280,0.54461765}, {281,0.54328431}, {282,0.54776471}, {283,0.55489216}, {284,0.55052941}, {285,0.56377451}, {286,0.56595098}, {287,0.56291176}, {288,0.57776471}, {289,0.57380392}, {290,0.58362745}, {291,0.58485294}, {292,0.58486275}, {293,0.59842157}, {294,0.59318627}, {295,0.60951961}, {296,0.61065686}, {297,0.60820588}, {298,0.62224510}, {299,0.61712745}, {300,0.63079412}, {301,0.62633663}, {302,0.63069307}, {303,0.64029703}, {304,0.64037624}, {305,0.65177228}, {306,0.64665347}, {307,0.66054455}, {308,0.65678218}, {309,0.66806931}, {310,0.66689109}, {311,0.67097030}, {312,0.68103960}, {313,0.68555446}, {314,0.69098020}, {315,0.69102970}, {316,0.70152475}, {317,0.70345545}, {318,0.71034653}, {319,0.70597030}, {320,0.72018812}, {321,0.71968317}, {322,0.73077228}, {323,0.72777228}, {324,0.74164356}, {325,0.73641584}, {326,0.75924752}, {327,0.75178218}, {328,0.76013861}, {329,0.75621782}, {330,0.76685149}, {331,0.76919802}, {332,0.78209901}, {333,0.77838614}, {334,0.78847525}, {335,0.78709901}, {336,0.79884158}, {337,0.79850495}, {338,0.80499010}, {339,0.80746535}, {340,0.81441584}, {341,0.82222772}, {342,0.82556436}, {343,0.83023762}, {344,0.83853465}, {345,0.84291089}, {346,0.84476238}, {347,0.85025743}, {348,0.86056436}, {349,0.86851485}, {350,0.87032673}, {351,0.86996040}, {352,0.88326733}, {353,0.88450495}, {354,0.88889109}, {355,0.89803960}, {356,0.90297030}, {357,0.94796040}, {358,0.90355446}, {359,0.97156436}, {360,0.92270297}, {361,0.92797030}, {362,0.93469307}, {363,0.94293069}, {364,0.94330693}, {365,0.94531683}, {366,0.96413861}, {367,0.96405941}, {368,0.96186139}, {369,0.98127723}, {370,0.97644554}, {371,0.98489109}, {372,0.99055446}, {373,0.99423762}, {374,1.00219802}, {375,1.00366337}, {376,1.012538}, {377,0.996615}, {378,1.004846}, {379,1.011846}, {380,1.005923}, {381,1.028462}, {382,1.029615}, {383,1.146077}, {384,1.042462}, {385,1.041000}, {386,1.174308}, {387,1.187692}, {388,1.067385}, {389,1.065000}, {390,1.071923}, {391,1.078231}, {392,1.089615}, {393,1.090846}, {394,1.096077}, {395,1.097462}, {396,1.103846}, {397,1.115385}, {398,1.119538}, {399,1.129846}, {400,1.126385}, {401,1.207769}, {402,1.151846}, {403,1.154538}, {404,1.157615}, {405,1.166692}, {406,1.172385}, {407,1.182692}, {408,1.184538}, {409,1.195769}, {410,1.195769}, {411,1.210462}, {412,1.211923}, {413,1.216615}, {414,1.221462}, {415,1.224077}, {416,1.239462}, {417,1.236923}, {418,1.252769}, {419,1.248692}, {420,1.267231}, {421,1.264077}, {422,1.271231}, {423,1.276154}, {424,1.291231}, {425,1.292000}, {426,1.309923}, {427,1.305077}, {428,1.331462}, {429,1.319000}, {430,1.323231}, {431,1.336077}, {432,1.360308}, {433,1.356692}, {434,1.357154}, {435,1.362846}, {436,1.387846}, {437,1.379769}, {438,1.387923}, {439,1.397769}, {440,1.412846}, {441,1.405538}, {442,1.415077}, {443,1.428231}, {444,1.442615}, {445,1.436077}, {446,1.446615}, {447,1.455769}, {448,1.479923}, {449,1.459538}, {450,1.472692}, {451,1.493154}, {452,1.501538}, {453,1.485923}, {454,1.504462}, {455,1.521000}, {456,1.517154}, {457,1.524077}, {458,1.536000}, {459,1.551769}, {460,1.546077}, {461,1.548077}, {462,1.571846}, {463,1.576846}, {464,1.574462}, {465,1.588923}, {466,1.605769}, {467,1.610769}, {468,1.602000}, {469,1.619462}, {470,1.631846}, {471,1.628615}, {472,1.635692}, {473,1.666154}, {474,1.664077}, {475,1.663308}, {476,1.678000}, {477,1.687154}, {478,1.688692}, {479,1.696846}, {480,1.709615}, {481,1.714923}, {482,1.719538}, {483,1.732000}, {484,1.738462}, {485,1.745846}, {486,1.758231}, {487,1.761923}, {488,1.787538}, {489,1.846231}, {490,1.797077}, {491,1.804231}, {492,1.813615}, {493,1.814923}, {494,1.829308}, {495,1.842769}, {496,1.832462}, {497,1.858769}, {498,1.856923}, {499,1.852462}, {500,1.863154}, {505,1.916692}, {510,1.945769}, {515,1.999308}, {520,2.061769}, {525,2.102000}, {530,2.143462}, {535,2.196385}, {540,2.230154}, {545,2.373385}, {550,2.319077}, {555,2.375000}, {560,2.441231}, {565,2.467692}, {570,2.520692}, {575,2.562231}, {580,2.686231}, {585,2.741385}, {590,2.714385}, {595,2.778923}, {600,2.843846}, {605,2.888615}, {610,2.936154}, {615,3.011231}, {620,3.045231}, {625,3.124077}, {630,3.213077}, {635,3.293077}, {640,3.523615}, {645,3.330154}, {650,3.375923}, {655,3.515308}, {660,3.497308}, {665,3.558846}, {670,3.615769}, {675,3.767308}, {680,3.747615}, {685,3.819923}, {690,3.965231}, {695,3.954692}, {700,4.169154}, {705,4.076000}, {710,4.154385}, {715,4.218308}, {720,4.377846}, {725,4.304692}, {730,4.458615}, {735,4.508308}, {740,4.548923}, {745,4.697615}, {750,4.666923}, {755,4.772154}, {760,4.838538}, {765,4.912923}, {770,4.991615}, {775,5.130000}, {780,5.144077}, {785,5.299077}, {790,5.418077}, {795,5.591923}, {800,5.634231}, {805,5.809077}, {810,5.895077}, {815,5.810538}, {820,6.130308}, {825,6.227000}, {830,6.154308}, {835,6.439154}, {840,6.273308}, {845,6.706769}, {850,6.597846}, {855,6.604462}, {860,6.880077}, {865,6.780538}, {870,7.042231}, {875,7.419538}, {880,7.234692}, {885,7.085000}, {890,7.345231}, {895,7.464385}, {900,7.637308}, {905,7.577923}, {910,7.680308}, {915,8.049846}, {920,7.911846}, {925,8.105462}, {930,8.279769}, {935,8.323231}, {940,8.430308}, {945,8.599077}, {950,8.804231}, {955,8.837538}, {960,8.870769}, {965,9.070000}, {970,9.521154}, {975,9.309692}, {980,9.414769}, {985,9.460000}, {990,9.855846}, {995,9.777615}, {1000,9.817000}, {1010,10.058308}, {1020,10.503154}, {1030,10.903769}, {1040,10.955077}, {1050,11.110769}, {1060,11.711923}, {1070,11.910077}, {1080,12.057769}, {1090,12.695769}, {1100,12.796615}, {1110,13.017538}, {1120,13.263308}, {1130,13.570231}, {1140,14.081385}, {1150,14.483154}, {1160,14.743077}, {1170,15.126308}, {1180,15.069769}, {1190,15.685308}, {1200,16.247692}, {1210,16.369692}, {1220,16.573846}, {1230,17.123615}, {1240,17.052538}, {1250,18.110000}, {1260,17.999308}, {1270,18.303077}, {1280,18.761538}, {1290,19.297692}, {1300,19.804692}, {1310,20.173385}, {1320,20.116308}, {1330,20.806538}, {1340,21.344769}, {1350,22.392846}, {1360,22.262154}, {1370,22.542000}, {1380,23.172769}, {1390,23.631385}, {1400,24.678385}, {1410,24.587077}, {1420,24.861154}, {1430,25.458077}, {1440,26.099308}, {1450,26.177308}, {1460,26.657000}, {1470,27.654308}, {1480,27.451000}, {1490,28.516154}, {1500,28.900692}, {1510,29.528769}, {1520,29.817692}, {1530,30.627538}, {1540,30.892615}, {1550,31.470769}, {1560,32.335769}, {1570,33.113462}, {1580,32.908846}, {1590,33.816462}, {1600,34.817692}, {1610,35.721538}, {1620,36.017077}, {1630,35.770000}, {1640,36.647077}, {1650,37.619846}, {1660,37.898923}, {1670,39.130385}, {1680,39.115231}, {1690,40.042615}, {1700,39.911231}, {1710,41.619385}, {1720,42.359154}, {1730,42.399615}, {1740,42.672846}, {1750,44.617154}, {1760,44.670692}, {1770,45.302231}, {1780,45.704846}, {1790,46.929000}, {1800,47.349615}, {1810,48.850231}, {1820,49.025308}, {1830,49.486385}, {1840,50.385385}, {1850,50.504154}, {1860,51.479923}, {1870,52.386385}, {1880,52.551154}, {1890,53.404923}, {1900,54.185923}, {1910,54.621538}, {1920,55.928462}, {1930,56.397923}, {1940,57.908615}, {1950,58.122385}, {1960,59.005769}, {1970,60.069538}, {1980,60.091154}, {1990,61.865462}, {2000,62.254231}};
data["big"]["TypeClassesBodyHOAS"]["reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003509}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00003509}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00003509}, {14,0.00010526}, {15,0.00000000}, {16,0.00007018}, {17,0.00010526}, {18,0.00003509}, {19,0.00000000}, {20,0.00000000}, {21,0.00007018}, {22,0.00006140}, {23,0.00003509}, {24,0.00003509}, {25,0.00007018}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00002632}, {30,0.00003509}, {31,0.00000000}, {32,0.00010526}, {33,0.00003509}, {34,0.00000000}, {35,0.00010526}, {36,0.00000000}, {37,0.00017544}, {38,0.00007018}, {39,0.00000000}, {40,0.00000000}, {41,0.00007018}, {42,0.00003509}, {43,0.00003509}, {44,0.00003509}, {45,0.00000000}, {46,0.00003509}, {47,0.00003509}, {48,0.00000000}, {49,0.00003509}, {50,0.00003509}, {51,0.00007018}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00010526}, {57,0.00014035}, {58,0.00000000}, {59,0.00003509}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00007018}, {64,0.00000000}, {65,0.00003509}, {66,0.00000000}, {67,0.00006140}, {68,0.00010526}, {69,0.00000000}, {70,0.00000000}, {71,0.00010526}, {72,0.00000000}, {73,0.00000000}, {74,0.00010526}, {75,0.00007018}, {76,0.00003509}, {77,0.00003509}, {78,0.00007018}, {79,0.00003509}, {80,0.00014035}, {81,0.00000000}, {82,0.00010526}, {83,0.00007018}, {84,0.00007018}, {85,0.00003509}, {86,0.00003922}, {87,0.00003922}, {88,0.00003922}, {89,0.00003922}, {90,0.00000000}, {91,0.00000000}, {92,0.00007843}, {93,0.00000000}, {94,0.00003922}, {95,0.00000000}, {96,0.00003922}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00007843}, {101,0.00003922}, {102,0.00003922}, {103,0.00003922}, {104,0.00003922}, {105,0.00000000}, {106,0.00000000}, {107,0.00011765}, {108,0.00000000}, {109,0.00006863}, {110,0.00003922}, {111,0.00000000}, {112,0.00003922}, {113,0.00000000}, {114,0.00003922}, {115,0.00007843}, {116,0.00000000}, {117,0.00000000}, {118,0.00003922}, {119,0.00000000}, {120,0.00007843}, {121,0.00000000}, {122,0.00007843}, {123,0.00015686}, {124,0.00000000}, {125,0.00029412}, {126,0.00006863}, {127,0.00007843}, {128,0.00011765}, {129,0.00019608}, {130,0.00018627}, {131,0.00015686}, {132,0.00031373}, {133,0.00023529}, {134,0.00015686}, {135,0.00085294}, {136,0.00050000}, {137,0.00037255}, {138,0.00035294}, {139,0.00023529}, {140,0.00019608}, {141,0.00011765}, {142,0.00000000}, {143,0.00000000}, {144,0.00003922}, {145,0.00000000}, {146,0.00000000}, {147,0.00015686}, {148,0.00003922}, {149,0.00011765}, {150,0.00000000}, {151,0.00003922}, {152,0.00010784}, {153,0.00007843}, {154,0.00000000}, {155,0.00011765}, {156,0.00011765}, {157,0.00000000}, {158,0.00007843}, {159,0.00003922}, {160,0.00000000}, {161,0.00003922}, {162,0.00000000}, {163,0.00000000}, {164,0.00007843}, {165,0.00006863}, {166,0.00011765}, {167,0.00010784}, {168,0.00011765}, {169,0.00000000}, {170,0.00003922}, {171,0.00003922}, {172,0.00003922}, {173,0.00000000}, {174,0.00007843}, {175,0.00003922}, {176,0.00003922}, {177,0.00003922}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00003922}, {182,0.00007843}, {183,0.00000000}, {184,0.00003922}, {185,0.00003922}, {186,0.00007843}, {187,0.00019608}, {188,0.00000000}, {189,0.00003922}, {190,0.00011765}, {191,0.00018627}, {192,0.00026471}, {193,0.00011765}, {194,0.00035294}, {195,0.00011765}, {196,0.00015686}, {197,0.00011765}, {198,0.00003922}, {199,0.00011765}, {200,0.00002941}, {201,0.00003922}, {202,0.00003922}, {203,0.00011765}, {204,0.00007843}, {205,0.00000000}, {206,0.00011765}, {207,0.00007843}, {208,0.00003922}, {209,0.00003922}, {210,0.00007843}, {211,0.00003922}, {212,0.00003922}, {213,0.00003922}, {214,0.00007843}, {215,0.00003922}, {216,0.00003922}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00003922}, {221,0.00011765}, {222,0.00007843}, {223,0.00003922}, {224,0.00007843}, {225,0.00011765}, {226,0.00000000}, {227,0.00011765}, {228,0.00003922}, {229,0.00002941}, {230,0.00003922}, {231,0.00000000}, {232,0.00007843}, {233,0.00039216}, {234,0.00029412}, {235,0.00027451}, {236,0.00015686}, {237,0.00007843}, {238,0.00003922}, {239,0.00000000}, {240,0.00015686}, {241,0.00003922}, {242,0.00006863}, {243,0.00014706}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00003922}, {248,0.00015686}, {249,0.00006863}, {250,0.00023529}, {251,0.00007843}, {252,0.00007843}, {253,0.00007843}, {254,0.00002941}, {255,0.00011765}, {256,0.00007843}, {257,0.00000000}, {258,0.00000000}, {259,0.00007843}, {260,0.00007843}, {261,0.00003922}, {262,0.00000000}, {263,0.00011765}, {264,0.00002941}, {265,0.00011765}, {266,0.00023529}, {267,0.00031373}, {268,0.00026471}, {269,0.00015686}, {270,0.00015686}, {271,0.00007843}, {272,0.00011765}, {273,0.00003922}, {274,0.00011765}, {275,0.00019608}, {276,0.00011765}, {277,0.00027451}, {278,0.00019608}, {279,0.00018627}, {280,0.00007843}, {281,0.00006863}, {282,0.00019608}, {283,0.00023529}, {284,0.00003922}, {285,0.00011765}, {286,0.00006863}, {287,0.00021569}, {288,0.00015686}, {289,0.00011765}, {290,0.00011765}, {291,0.00007843}, {292,0.00003922}, {293,0.00003922}, {294,0.00000000}, {295,0.00003922}, {296,0.00007843}, {297,0.00015686}, {298,0.00003922}, {299,0.00003922}, {300,0.00007843}, {301,0.00003960}, {302,0.00007921}, {303,0.00011881}, {304,0.00003960}, {305,0.00003960}, {306,0.00006931}, {307,0.00006931}, {308,0.00026733}, {309,0.00011881}, {310,0.00003960}, {311,0.00007921}, {312,0.00007921}, {313,0.00011881}, {314,0.00003960}, {315,0.00011881}, {316,0.00003960}, {317,0.00011881}, {318,0.00007921}, {319,0.00007921}, {320,0.00011881}, {321,0.00003960}, {322,0.00000000}, {323,0.00003960}, {324,0.00015842}, {325,0.00007921}, {326,0.00007921}, {327,0.00000000}, {328,0.00011881}, {329,0.00007921}, {330,0.00007921}, {331,0.00015842}, {332,0.00003960}, {333,0.00007921}, {334,0.00073267}, {335,0.00052475}, {336,0.00015842}, {337,0.00015842}, {338,0.00019802}, {339,0.00067327}, {340,0.00063366}, {341,0.00023762}, {342,0.00023762}, {343,0.00015842}, {344,0.00011881}, {345,0.00003960}, {346,0.00000000}, {347,0.00011881}, {348,0.00007921}, {349,0.00015842}, {350,0.00011881}, {351,0.00011881}, {352,0.00015842}, {353,0.00011881}, {354,0.00025743}, {355,0.00019802}, {356,0.00035644}, {357,0.00038614}, {358,0.00027723}, {359,0.00039604}, {360,0.00019802}, {361,0.00015842}, {362,0.00022772}, {363,0.00031683}, {364,0.00052475}, {365,0.00027723}, {366,0.00047525}, {367,0.00022772}, {368,0.00007921}, {369,0.00011881}, {370,0.00022772}, {371,0.00019802}, {372,0.00015842}, {373,0.00035644}, {374,0.00051485}, {375,0.00019802}, {376,0.000000}, {377,0.000000}, {378,0.000000}, {379,0.000308}, {380,0.000923}, {381,0.001846}, {382,0.001846}, {383,0.000923}, {384,0.000923}, {385,0.000615}, {386,0.000000}, {387,0.000308}, {388,0.000308}, {389,0.000615}, {390,0.000000}, {391,0.000615}, {392,0.000615}, {393,0.000000}, {394,0.000000}, {395,0.000308}, {396,0.000000}, {397,0.000000}, {398,0.000000}, {399,0.000308}, {400,0.000308}, {401,0.000000}, {402,0.000000}, {403,0.000000}, {404,0.000000}, {405,0.000000}, {406,0.000000}, {407,0.000000}, {408,0.000000}, {409,0.000000}, {410,0.000000}, {411,0.000923}, {412,0.000000}, {413,0.000308}, {414,0.000308}, {415,0.000000}, {416,0.000000}, {417,0.000000}, {418,0.000000}, {419,0.000000}, {420,0.000000}, {421,0.000308}, {422,0.000000}, {423,0.000000}, {424,0.000308}, {425,0.000000}, {426,0.000000}, {427,0.000000}, {428,0.000000}, {429,0.000000}, {430,0.000308}, {431,0.000308}, {432,0.000000}, {433,0.000000}, {434,0.000000}, {435,0.000000}, {436,0.000000}, {437,0.000000}, {438,0.000923}, {439,0.000615}, {440,0.000000}, {441,0.000000}, {442,0.000000}, {443,0.000000}, {444,0.000000}, {445,0.000000}, {446,0.000000}, {447,0.000000}, {448,0.000308}, {449,0.000000}, {450,0.000000}, {451,0.000000}, {452,0.000000}, {453,0.000000}, {454,0.000000}, {455,0.000000}, {456,0.000000}, {457,0.000000}, {458,0.000000}, {459,0.000000}, {460,0.000000}, {461,0.000308}, {462,0.000000}, {463,0.000000}, {464,0.000000}, {465,0.000000}, {466,0.000000}, {467,0.000000}, {468,0.000000}, {469,0.000308}, {470,0.000000}, {471,0.000000}, {472,0.000000}, {473,0.000000}, {474,0.000000}, {475,0.000000}, {476,0.000308}, {477,0.000308}, {478,0.000000}, {479,0.000000}, {480,0.000000}, {481,0.000000}, {482,0.000308}, {483,0.000308}, {484,0.000000}, {485,0.000308}, {486,0.000000}, {487,0.000000}, {488,0.000000}, {489,0.000308}, {490,0.000615}, {491,0.000923}, {492,0.000000}, {493,0.000000}, {494,0.000308}, {495,0.000000}, {496,0.000000}, {497,0.000308}, {498,0.000308}, {499,0.000000}, {500,0.000000}, {505,0.000000}, {510,0.000308}, {515,0.000000}, {520,0.000000}, {525,0.000846}, {530,0.000000}, {535,0.000000}, {540,0.000000}, {545,0.000000}, {550,0.000308}, {555,0.000308}, {560,0.000000}, {565,0.000000}, {570,0.000308}, {575,0.000923}, {580,0.000615}, {585,0.000308}, {590,0.000000}, {595,0.000615}, {600,0.000000}, {605,0.000923}, {610,0.001231}, {615,0.000308}, {620,0.001231}, {625,0.000000}, {630,0.000000}, {635,0.000000}, {640,0.000615}, {645,0.001846}, {650,0.000923}, {655,0.000308}, {660,0.000923}, {665,0.002462}, {670,0.000615}, {675,0.000615}, {680,0.000308}, {685,0.000000}, {690,0.000000}, {695,0.001846}, {700,0.000615}, {705,0.000308}, {710,0.000308}, {715,0.000615}, {720,0.000308}, {725,0.000308}, {730,0.002769}, {735,0.000615}, {740,0.000308}, {745,0.003077}, {750,0.002462}, {755,0.002769}, {760,0.000923}, {765,0.001231}, {770,0.000000}, {775,0.000538}, {780,0.000000}, {785,0.000308}, {790,0.000308}, {795,0.001538}, {800,0.000615}, {805,0.002154}, {810,0.000615}, {815,0.000308}, {820,0.001538}, {825,0.002154}, {830,0.000308}, {835,0.002154}, {840,0.002462}, {845,0.003923}, {850,0.004923}, {855,0.000308}, {860,0.000923}, {865,0.001769}, {870,0.001231}, {875,0.003385}, {880,0.001231}, {885,0.003077}, {890,0.003692}, {895,0.002769}, {900,0.001231}, {905,0.002462}, {910,0.001538}, {915,0.003077}, {920,0.002154}, {925,0.004846}, {930,0.001231}, {935,0.000923}, {940,0.002154}, {945,0.002154}, {950,0.004000}, {955,0.005462}, {960,0.010462}, {965,0.005154}, {970,0.004000}, {975,0.004000}, {980,0.005462}, {985,0.004308}, {990,0.002769}, {995,0.000923}, {1000,0.003615}, {1010,0.008000}, {1020,0.002692}, {1030,0.000615}, {1040,0.007692}, {1050,0.005538}, {1060,0.005769}, {1070,0.006692}, {1080,0.007385}, {1090,0.003692}, {1100,0.009154}, {1110,0.003692}, {1120,0.007231}, {1130,0.004923}, {1140,0.003077}, {1150,0.007615}, {1160,0.003385}, {1170,0.006462}, {1180,0.004846}, {1190,0.007385}, {1200,0.004000}, {1210,0.001846}, {1220,0.009846}, {1230,0.005231}, {1240,0.002154}, {1250,0.002462}, {1260,0.001846}, {1270,0.004308}, {1280,0.004308}, {1290,0.004923}, {1300,0.003385}, {1310,0.004923}, {1320,0.005154}, {1330,0.007077}, {1340,0.004538}, {1350,0.002769}, {1360,0.004923}, {1370,0.002385}, {1380,0.005231}, {1390,0.002154}, {1400,0.004615}, {1410,0.001846}, {1420,0.002154}, {1430,0.004846}, {1440,0.002769}, {1450,0.004538}, {1460,0.006692}, {1470,0.011923}, {1480,0.008308}, {1490,0.003692}, {1500,0.006769}, {1510,0.005538}, {1520,0.010077}, {1530,0.004923}, {1540,0.007077}, {1550,0.009769}, {1560,0.015385}, {1570,0.008923}, {1580,0.014077}, {1590,0.010154}, {1600,0.014154}, {1610,0.013769}, {1620,0.007615}, {1630,0.015923}, {1640,0.012308}, {1650,0.011000}, {1660,0.016846}, {1670,0.010385}, {1680,0.013538}, {1690,0.019000}, {1700,0.007692}, {1710,0.010462}, {1720,0.009231}, {1730,0.012615}, {1740,0.023231}, {1750,0.017769}, {1760,0.018923}, {1770,0.009538}, {1780,0.044385}, {1790,0.013692}, {1800,0.021692}, {1810,0.019231}, {1820,0.010462}, {1830,0.019385}, {1840,0.014923}, {1850,0.012154}, {1860,0.023308}, {1870,0.016000}, {1880,0.019385}, {1890,0.020846}, {1900,0.017462}, {1910,0.031308}, {1920,0.026385}, {1930,0.036923}, {1940,0.036923}, {1950,0.029692}, {1960,0.018154}, {1970,0.028615}, {1980,0.044154}, {1990,0.033154}, {2000,0.054615}};
data["big"]["beta; Parametricity"]["Aggregate"]["real"] = {{1,0.001019048}, {2,0.001000000}, {3,0.001000000}, {4,0.001000000}, {5,0.001000000}, {6,0.001000000}, {7,0.001000000}, {8,0.001000000}, {9,0.001000000}, {10,0.001000000}, {11,0.001000000}, {12,0.001000000}, {13,0.001000000}, {14,0.001347619}, {15,0.001000000}, {16,0.001000000}, {17,0.001000000}, {18,0.001009524}, {19,0.019466667}, {20,0.001004762}, {21,0.001014286}, {22,0.001014286}, {23,0.001028571}, {24,0.001047619}, {25,0.001076190}, {26,0.001152381}, {27,0.008133333}, {28,0.001319048}, {29,0.001442857}, {30,0.001476190}, {31,0.001514286}, {32,0.001547619}, {33,0.001566667}, {34,0.001600000}, {35,0.001633333}, {36,0.001685714}, {37,0.001723810}, {38,0.001776190}, {39,0.001819048}, {40,0.001890476}, {41,0.001971429}, {42,0.002000000}, {43,0.002000000}, {44,0.002000000}, {45,0.002000000}, {46,0.002000000}, {47,0.002000000}, {48,0.002000000}, {49,0.002000000}, {50,0.002023810}, {51,0.002004762}, {52,0.002033333}, {53,0.002047619}, {54,0.002085714}, {55,0.002114286}, {56,0.002166667}, {57,0.002795238}, {58,0.002147619}, {59,0.002209524}, {60,0.002266667}, {61,0.002309524}, {62,0.002385714}, {63,0.002438095}, {64,0.002461905}, {65,0.003004762}, {66,0.002509524}, {67,0.002523810}, {68,0.002523810}, {69,0.002528571}, {70,0.002538095}, {71,0.002547619}, {72,0.002566667}, {73,0.002600000}, {74,0.002661905}, {75,0.002690476}, {76,0.002695238}, {77,0.002704762}, {78,0.002709524}, {79,0.002747619}, {80,0.002790476}, {81,0.002900000}, {82,0.002933333}, {83,0.003557143}, {84,0.002995238}, {85,0.003023810}, {86,0.003061905}, {87,0.003100000}, {88,0.003138095}, {89,0.003157143}, {90,0.003195238}, {91,0.003219048}, {92,0.003271429}, {93,0.003757143}, {94,0.003385714}, {95,0.003404762}, {96,0.003428571}, {97,0.003447619}, {98,0.003485714}, {99,0.003500000}, {100,0.003509524}, {101,0.003504762}, {102,0.003519048}, {103,0.003542857}, {104,0.003533333}, {105,0.003995238}, {106,0.003538095}, {107,0.003538095}, {108,0.003557143}, {109,0.003590476}, {110,0.003609524}, {111,0.003652381}, {112,0.003685714}, {113,0.003766667}, {114,0.003766667}, {115,0.003785714}, {116,0.003823810}, {117,0.003847619}, {118,0.003861905}, {119,0.003909524}, {120,0.003995238}, {121,0.003971429}, {122,0.004033333}, {123,0.004652381}, {124,0.004119048}, {125,0.004242857}, {126,0.004314286}, {127,0.004390476}, {128,0.004433333}, {129,0.004433333}, {130,0.004480952}, {131,0.004485714}, {132,0.004490476}, {133,0.004509524}, {134,0.004514286}, {135,0.004990476}, {136,0.004523810}, {137,0.004519048}, {138,0.004528571}, {139,0.004523810}, {140,0.004533333}, {141,0.004552381}, {142,0.004557143}, {143,0.004580952}, {144,0.004609524}, {145,0.004614286}, {146,0.004623810}, {147,0.004685714}, {148,0.004709524}, {149,0.004690476}, {150,0.004714286}, {151,0.004766667}, {152,0.004814286}, {153,0.005309524}, {154,0.004904762}, {155,0.004966667}, {156,0.005023810}, {157,0.005042857}, {158,0.005128571}, {159,0.005185714}, {160,0.005247619}, {161,0.005300000}, {162,0.005376190}, {163,0.005414286}, {164,0.005461905}, {165,0.005495238}, {166,0.005514286}, {167,0.005533333}, {168,0.006057143}, {169,0.005980952}, {170,0.005528571}, {171,0.005533333}, {172,0.005538095}, {173,0.005576190}, {174,0.005576190}, {175,0.005604762}, {176,0.005633333}, {177,0.005600000}, {178,0.005614286}, {179,0.005623810}, {180,0.005671429}, {181,0.006171429}, {182,0.005714286}, {183,0.005771429}, {184,0.006257143}, {185,0.005790476}, {186,0.005895238}, {187,0.005976190}, {188,0.006052381}, {189,0.006085714}, {190,0.006147619}, {191,0.006161905}, {192,0.006185714}, {193,0.006219048}, {194,0.006214286}, {195,0.006242857}, {196,0.006300000}, {197,0.006304762}, {198,0.006923810}, {199,0.006409524}, {200,0.006438095}, {201,0.006466667}, {202,0.006519048}, {203,0.006538095}, {204,0.006580952}, {205,0.007180952}, {206,0.006590476}, {207,0.006580952}, {208,0.006595238}, {209,0.006604762}, {210,0.006676190}, {211,0.006695238}, {212,0.007261905}, {213,0.006795238}, {214,0.006800000}, {215,0.006842857}, {216,0.007571429}, {217,0.006942857}, {218,0.006980952}, {219,0.007061905}, {220,0.007076190}, {221,0.007076190}, {222,0.007109524}, {223,0.007142857}, {224,0.007704762}, {225,0.007152381}, {226,0.007185714}, {227,0.007614286}, {228,0.007180952}, {229,0.007233333}, {230,0.007290476}, {231,0.007300000}, {232,0.007309524}, {233,0.007342857}, {234,0.007447619}, {235,0.007500000}, {236,0.008057143}, {237,0.008504762}, {238,0.007647619}, {239,0.007685714}, {240,0.007771429}, {241,0.007800000}, {242,0.007828571}, {243,0.007871429}, {244,0.007909524}, {245,0.007942857}, {246,0.007976190}, {247,0.007995238}, {248,0.008509524}, {249,0.008023810}, {250,0.008038095}, {251,0.008080952}, {252,0.008076190}, {253,0.008100000}, {254,0.008171429}, {255,0.008166667}, {256,0.008723810}, {257,0.008147619}, {258,0.008223810}, {259,0.008776190}, {260,0.008271429}, {261,0.008285714}, {262,0.008314286}, {263,0.008357143}, {264,0.008419048}, {265,0.009585714}, {266,0.008547619}, {267,0.008571429}, {268,0.008676190}, {269,0.008704762}, {270,0.009361905}, {271,0.008909524}, {272,0.008900000}, {273,0.008942857}, {274,0.010433333}, {275,0.008995238}, {276,0.009014286}, {277,0.009028571}, {278,0.009047619}, {279,0.009057143}, {280,0.009600000}, {281,0.009076190}, {282,0.009095238}, {283,0.009104762}, {284,0.009166667}, {285,0.009176190}, {286,0.009209524}, {287,0.009200000}, {288,0.009252381}, {289,0.009290476}, {290,0.009919048}, {291,0.010757143}, {292,0.009433333}, {293,0.009500000}, {294,0.009528571}, {295,0.009566667}, {296,0.009561905}, {297,0.009633333}, {298,0.009742857}, {299,0.011738095}, {300,0.010223810}, {301,0.009809524}, {302,0.009828571}, {303,0.009933333}, {304,0.010000000}, {305,0.010009524}, {306,0.010095238}, {307,0.012466667}, {308,0.010085714}, {309,0.010685714}, {310,0.010157143}, {311,0.010176190}, {312,0.010185714}, {313,0.010219048}, {314,0.010328571}, {315,0.012195238}, {316,0.010342857}, {317,0.010423810}, {318,0.011200000}, {319,0.010490476}, {320,0.010504762}, {321,0.010519048}, {322,0.010561905}, {323,0.010580952}, {324,0.010595238}, {325,0.010609524}, {326,0.010647619}, {327,0.011271429}, {328,0.010685714}, {329,0.010804762}, {330,0.014404762}, {331,0.010804762}, {332,0.010847619}, {333,0.010928571}, {334,0.011009524}, {335,0.011085714}, {336,0.011747619}, {337,0.014509524}, {338,0.011261905}, {339,0.011304762}, {340,0.011342857}, {341,0.011385714}, {342,0.011428571}, {343,0.011428571}, {344,0.011552381}, {345,0.011900000}, {346,0.011547619}, {347,0.011542857}, {348,0.011561905}, {349,0.011600000}, {350,0.011609524}, {351,0.011714286}, {352,0.014414286}, {353,0.012323810}, {354,0.011685714}, {355,0.011695238}, {356,0.011766667}, {357,0.011833333}, {358,0.015514286}, {359,0.011871429}, {360,0.011933333}, {361,0.012795238}, {362,0.012095238}, {363,0.012123810}, {364,0.012157143}, {365,0.017528571}, {366,0.012304762}, {367,0.012385714}, {368,0.012423810}, {369,0.013480952}, {370,0.012528571}, {371,0.012614286}, {372,0.016042857}, {373,0.012571429}, {374,0.012614286}, {375,0.012628571}, {376,0.012638095}, {377,0.013823810}, {378,0.012790476}, {379,0.017819048}, {380,0.012800000}, {381,0.012828571}, {382,0.012904762}, {383,0.012923810}, {384,0.012995238}, {385,0.017128571}, {386,0.013000000}, {387,0.013028571}, {388,0.013057143}, {389,0.013095238}, {390,0.013128571}, {391,0.018190476}, {392,0.014185714}, {393,0.013309524}, {394,0.013342857}, {395,0.013404762}, {396,0.013504762}, {397,0.013609524}, {398,0.018542857}, {399,0.013671429}, {400,0.014119048}, {401,0.013709524}, {402,0.013828571}, {403,0.013909524}, {404,0.017471429}, {405,0.013900000}, {406,0.013928571}, {407,0.014666667}, {408,0.014038095}, {409,0.014009524}, {410,0.018352381}, {411,0.014090476}, {412,0.014119048}, {413,0.014166667}, {414,0.014957143}, {415,0.014200000}, {416,0.019928571}, {417,0.014266667}, {418,0.014304762}, {419,0.014352381}, {420,0.014395238}, {421,0.015276190}, {422,0.019995238}, {423,0.014571429}, {424,0.014614286}, {425,0.014728571}, {426,0.014800000}, {427,0.014952381}, {428,0.021009524}, {429,0.015000000}, {430,0.014990476}, {431,0.015080952}, {432,0.015080952}, {433,0.015200000}, {434,0.019023810}, {435,0.015685714}, {436,0.015219048}, {437,0.015214286}, {438,0.015247619}, {439,0.015342857}, {440,0.015309524}, {441,0.015390476}, {442,0.016285714}, {443,0.015433333}, {444,0.015442857}, {445,0.021871429}, {446,0.015576190}, {447,0.015590476}, {448,0.015676190}, {449,0.016404762}, {450,0.016023810}, {451,0.020409524}, {452,0.015909524}, {453,0.015938095}, {454,0.016119048}, {455,0.019614286}, {456,0.030800000}, {457,0.045528571}, {458,0.016380952}, {459,0.016309524}, {460,0.016385714}, {461,0.016566667}, {462,0.021938095}, {463,0.016528571}, {464,0.016547619}, {465,0.016528571}, {466,0.016623810}, {467,0.023038095}, {468,0.017423810}, {469,0.016671429}, {470,0.016771429}, {471,0.016785714}, {472,0.016904762}, {473,0.020985714}, {474,0.016895238}, {475,0.017423810}, {476,0.017038095}, {477,0.017157143}, {478,0.022057143}, {479,0.017276190}, {480,0.017276190}, {481,0.018471429}, {482,0.017471429}, {483,0.023133333}, {484,0.017552381}, {485,0.017600000}, {486,0.017623810}, {487,0.018757143}, {488,0.022690476}, {489,0.017723810}, {490,0.017847619}, {491,0.017833333}, {492,0.017761905}, {493,0.019309524}, {494,0.017890476}, {495,0.017947619}, {496,0.017985714}, {497,0.018061905}, {498,0.018176190}, {499,0.023714286}, {500,0.018161905}, {505,0.019690476}, {510,0.018847619}, {515,0.019119048}, {520,0.024614286}, {525,0.020604762}, {530,0.019828571}, {535,0.020157143}, {540,0.026833333}, {545,0.020600000}, {550,0.020866667}, {555,0.021761905}, {560,0.021428571}, {565,0.027976190}, {570,0.021871429}, {575,0.022157143}, {580,0.023661905}, {585,0.029990476}, {590,0.023014286}, {595,0.023257143}, {600,0.023628571}, {605,0.026133333}, {610,0.029895238}, {615,0.024438095}, {620,0.024752381}, {625,0.025061905}, {630,0.033361905}, {635,0.025523810}, {640,0.025938095}, {645,0.026257143}, {650,0.034523810}, {655,0.028023810}, {660,0.027123810}, {665,0.027580952}, {670,0.034904762}, {675,0.028038095}, {680,0.028419048}, {685,0.028785714}, {690,0.036647619}, {695,0.029371429}, {700,0.030914286}, {705,0.039971429}, {710,0.030252381}, {715,0.030566667}, {720,0.031909524}, {725,0.039300000}, {730,0.031595238}, {735,0.031928571}, {740,0.032338095}, {745,0.032557143}, {750,0.032947619}, {755,0.033223810}, {760,0.042728571}, {765,0.034280952}, {770,0.034309524}, {775,0.045942857}, {780,0.034890476}, {785,0.035509524}, {790,0.035928571}, {795,0.041561905}, {800,0.037900000}, {805,0.036757143}, {810,0.040380952}, {815,0.037457143}, {820,0.038942857}, {825,0.042104762}, {830,0.038452381}, {835,0.038838095}, {840,0.045185714}, {845,0.039557143}, {850,0.039938095}, {855,0.044304762}, {860,0.041385714}, {865,0.041047619}, {870,0.053252381}, {875,0.044823810}, {880,0.042209524}, {885,0.055728571}, {890,0.042876190}, {895,0.043847619}, {900,0.058357143}, {905,0.044061905}, {910,0.045780952}, {915,0.057861905}, {920,0.045176190}, {925,0.045542857}, {930,0.058247619}, {935,0.046361905}, {940,0.047214286}, {945,0.059490476}, {950,0.047771429}, {955,0.062290476}, {960,0.050242857}, {965,0.048919048}, {970,0.064071429}, {975,0.050876190}, {980,0.049257143}, {985,0.059752381}, {990,0.050052381}, {995,0.050647619}, {1000,0.050809524}, {1010,0.051695238}, {1020,0.067966667}, {1030,0.053823810}, {1040,0.054490476}, {1050,0.067271429}, {1060,0.055880952}, {1070,0.073290476}, {1080,0.059042857}, {1090,0.059100000}, {1100,0.072061905}, {1110,0.060242857}, {1120,0.074790476}, {1130,0.065552381}, {1140,0.075890476}, {1150,0.063823810}, {1160,0.066704762}, {1170,0.075500000}, {1180,0.066771429}, {1190,0.079619048}, {1200,0.068623810}, {1210,0.089019048}, {1220,0.070538095}, {1230,0.090333333}, {1240,0.073600000}, {1250,0.088842857}, {1260,0.076371429}, {1270,0.091761905}, {1280,0.076571429}, {1290,0.095800000}, {1300,0.080352381}, {1310,0.083923810}, {1320,0.081252381}, {1330,0.082628571}, {1340,0.084271429}, {1350,0.105719048}, {1360,0.087671429}, {1370,0.108128571}, {1380,0.093885714}, {1390,0.112228571}, {1400,0.092866667}, {1410,0.109138095}, {1420,0.093957143}, {1430,0.125428571}, {1440,0.094709524}, {1450,0.113676190}, {1460,0.097933333}, {1470,0.125371429}, {1480,0.101147619}, {1490,0.136623810}, {1500,0.133228571}, {1510,0.171133333}, {1520,0.143390476}, {1530,0.109852381}, {1540,0.129533333}, {1550,0.113814286}, {1560,0.140819048}, {1570,0.144871429}, {1580,0.114771429}, {1590,0.138466667}, {1600,0.118004762}, {1610,0.140885714}, {1620,0.147490476}, {1630,0.123652381}, {1640,0.140895238}, {1650,0.127028571}, {1660,0.125909524}, {1670,0.158342857}, {1680,0.129138095}, {1690,0.149085714}, {1700,0.140195238}, {1710,0.136509524}, {1720,0.139238095}, {1730,0.145071429}, {1740,0.138833333}, {1750,0.145261905}, {1760,0.187342857}, {1770,0.144000000}, {1780,0.154309524}, {1790,0.155547619}, {1800,0.152771429}, {1810,0.157700000}, {1820,0.171842857}, {1830,0.157900000}, {1840,0.176833333}, {1850,0.196019048}, {1860,0.160357143}, {1870,0.180109524}, {1880,0.199338095}, {1890,0.165428571}, {1900,0.188709524}, {1910,0.190761905}, {1920,0.193428571}, {1930,0.172414286}, {1940,0.186614286}, {1950,0.205438095}, {1960,0.178800000}, {1970,0.180852381}, {1980,0.200957143}, {1990,0.211138095}, {2000,0.186904762}, {2050,0.207314286}, {2100,0.221419048}, {2150,0.228619048}, {2200,0.263271429}, {2250,0.238633333}, {2300,0.281409524}, {2350,0.302761905}, {2400,0.308214286}, {2450,0.339300000}, {2500,0.351366667}, {2550,0.364500000}, {2600,0.370457143}, {2650,0.379590476}, {2700,0.386228571}, {2750,0.382871429}, {2800,0.399614286}, {2850,0.444009524}, {2900,0.426766667}, {2950,0.454633333}, {3000,0.457885714}, {3050,0.476795238}, {3100,0.557428571}, {3150,0.557109524}, {3200,0.561333333}, {3250,0.559914286}, {3300,0.576700000}, {3350,0.653200000}, {3400,0.620600000}, {3450,0.676266667}, {3500,0.687028571}, {3550,0.811633333}, {3600,0.756076190}, {3650,0.725166667}, {3700,0.793742857}, {3750,0.767057143}, {3800,0.787747619}, {3850,0.871238095}, {3900,0.841090476}, {3950,0.936090476}, {4000,0.882685714}, {4050,1.011252381}, {4100,0.948157143}, {4150,1.025266667}, {4200,1.011280952}, {4250,1.115904762}, {4300,1.119438095}, {4350,1.145261905}, {4400,1.135533333}, {4450,1.213114286}, {4500,1.221866667}, {4550,1.307985714}, {4600,1.342166667}, {4650,1.401147619}, {4700,1.425661905}, {4750,1.486790476}, {4800,1.521576190}, {4850,1.507004762}, {4900,1.544123810}, {4950,1.518357143}, {5000,1.615528571}, {5050,1.79457}, {5100,1.81500}, {5150,1.80743}, {5200,1.87557}, {5250,1.92400}, {5300,2.02286}, {5350,2.05900}, {5400,2.07129}, {5450,2.11043}, {5500,2.14329}, {5550,2.74857}, {5600,2.78586}, {5650,2.32986}, {5700,2.36386}, {5750,2.38529}, {5800,2.42100}, {5850,2.45557}, {5900,3.21957}, {5950,2.57057}, {6000,2.63129}, {6050,3.30643}, {6100,2.77657}, {6150,2.82143}, {6200,2.91229}, {6250,2.88529}, {6300,2.99986}, {6350,3.02457}, {6400,3.10514}, {6450,3.12257}, {6500,3.18543}, {6550,3.25586}, {6600,3.33343}, {6650,3.32571}, {6700,3.52343}, {6750,3.52957}, {6800,3.57543}, {6850,3.60329}, {6900,3.72100}, {6950,3.88129}, {7000,3.83243}, {7050,4.03829}, {7100,4.12157}, {7150,4.05586}, {7200,4.10471}, {7250,4.24371}, {7300,4.22029}, {7350,4.29971}, {7400,4.42400}, {7450,4.41771}, {7500,4.55800}, {7550,4.62443}, {7600,4.59729}, {7650,4.69000}, {7700,4.80871}, {7750,4.79771}, {7800,4.87314}, {7850,5.03357}, {7900,6.09514}, {7950,5.13171}, {8000,5.13400}, {8050,5.26457}, {8100,5.29143}, {8150,5.97029}, {8200,5.41386}, {8250,5.39400}, {8300,5.61029}, {8350,5.66300}, {8400,5.78729}, {8450,5.84171}, {8500,5.82286}, {8550,6.04143}, {8600,6.09957}, {8650,6.22343}, {8700,6.25357}, {8750,6.76029}, {8800,6.49271}, {8850,6.49857}, {8900,6.54614}, {8950,6.58729}, {9000,7.78314}, {9050,6.79271}, {9100,7.45971}, {9150,6.78557}, {9200,7.06957}, {9250,7.01243}, {9300,7.22871}, {9350,7.13443}, {9400,7.36743}, {9450,7.27629}, {9500,7.58057}, {9550,7.96257}, {9600,7.72100}, {9650,7.63571}, {9700,7.83271}, {9750,8.46657}, {9800,7.94757}, {9850,8.27343}, {9900,7.95300}, {9950,8.09514}, {10000,8.54886}, {10100,8.17929}, {10200,8.50957}, {10300,8.59886}, {10400,9.00514}, {10500,9.78871}, {10600,9.02643}, {10700,10.60857}, {10800,9.35443}, {10900,10.09557}, {11000,9.77257}, {11100,10.45629}, {11200,10.27743}, {11300,11.75543}, {11400,10.92857}, {11500,10.82100}, {11600,11.71371}, {11700,11.86800}, {11800,11.64929}, {11900,11.88057}, {12000,12.00386}, {12100,12.26586}, {12200,12.44900}, {12300,12.80600}, {12400,12.87986}, {12500,13.06929}, {12600,13.29543}, {12700,13.48786}, {12800,13.69543}, {12900,13.91086}, {13000,14.15571}, {13100,14.35314}, {13200,14.54557}, {13300,14.76571}, {13400,14.99771}, {13500,15.43243}, {13600,15.44771}, {13700,15.64071}, {13800,15.96600}, {13900,16.27071}, {14000,16.21686}, {14100,16.45529}, {14200,16.95743}, {14300,17.71700}, {14400,18.55443}, {14500,17.47314}, {14600,18.82657}, {14700,18.02271}, {14800,18.38629}, {14900,18.81786}, {15000,19.08986}, {15100,19.19700}, {15200,19.18557}, {15300,19.58300}, {15400,19.76743}, {15500,20.11343}, {15600,20.49357}, {15700,20.92900}, {15800,21.29629}, {15900,21.57771}, {16000,21.88471}, {16100,22.07443}, {16200,23.01529}, {16300,22.68686}, {16400,23.21071}, {16500,23.27114}, {16600,23.64571}, {16700,24.06886}, {16800,24.46586}, {16900,24.55914}, {17000,25.21229}, {17100,25.00843}, {17200,25.95700}, {17300,26.02857}, {17400,26.60057}, {17500,26.72729}, {17600,26.53414}, {17700,27.31043}, {17800,27.58357}, {17900,27.95329}, {18000,28.13800}, {18100,28.50300}, {18200,29.28000}, {18300,29.18300}, {18400,29.40214}, {18500,30.05114}, {18600,30.18171}, {18700,29.92529}, {18800,30.67343}, {18900,30.84929}, {19000,31.16071}, {19100,31.55343}, {19200,32.21529}, {19300,33.01643}, {19400,35.83514}, {19500,34.56486}, {19600,33.82171}, {19700,33.90729}, {19800,33.13943}, {19900,33.57071}, {20000,30.48180}};
data["big"]["beta; Parametricity"]["Aggregate"]["user"] = {{1,0.000919048}, {2,0.001019048}, {3,0.000985714}, {4,0.001157143}, {5,0.001176190}, {6,0.001142857}, {7,0.001214286}, {8,0.001038095}, {9,0.001176190}, {10,0.001219048}, {11,0.001090476}, {12,0.001285714}, {13,0.001252381}, {14,0.001800000}, {15,0.001271429}, {16,0.001400000}, {17,0.001233333}, {18,0.001352381}, {19,0.019595238}, {20,0.001309524}, {21,0.001400000}, {22,0.001442857}, {23,0.001414286}, {24,0.001552381}, {25,0.001357143}, {26,0.001757143}, {27,0.007890476}, {28,0.001761905}, {29,0.001371429}, {30,0.001471429}, {31,0.001728571}, {32,0.001723810}, {33,0.001723810}, {34,0.001547619}, {35,0.001814286}, {36,0.001428571}, {37,0.001847619}, {38,0.002128571}, {39,0.001438095}, {40,0.001890476}, {41,0.001947619}, {42,0.001819048}, {43,0.001900000}, {44,0.001942857}, {45,0.001990476}, {46,0.002038095}, {47,0.001885714}, {48,0.001923810}, {49,0.002104762}, {50,0.002076190}, {51,0.001938095}, {52,0.002066667}, {53,0.002104762}, {54,0.002380952}, {55,0.002228571}, {56,0.001961905}, {57,0.002647619}, {58,0.002123810}, {59,0.002300000}, {60,0.002361905}, {61,0.002385714}, {62,0.002523810}, {63,0.002323810}, {64,0.002333333}, {65,0.002766667}, {66,0.002504762}, {67,0.002366667}, {68,0.002466667}, {69,0.002504762}, {70,0.002447619}, {71,0.002457143}, {72,0.002590476}, {73,0.002700000}, {74,0.002657143}, {75,0.002690476}, {76,0.002585714}, {77,0.002652381}, {78,0.002847619}, {79,0.002742857}, {80,0.002852381}, {81,0.002761905}, {82,0.002742857}, {83,0.003261905}, {84,0.002838095}, {85,0.002952381}, {86,0.003066667}, {87,0.003014286}, {88,0.003038095}, {89,0.003133333}, {90,0.003014286}, {91,0.003166667}, {92,0.003133333}, {93,0.003428571}, {94,0.003080952}, {95,0.003090476}, {96,0.003114286}, {97,0.003190476}, {98,0.003123810}, {99,0.003123810}, {100,0.003180952}, {101,0.003495238}, {102,0.003285714}, {103,0.003447619}, {104,0.003261905}, {105,0.003957143}, {106,0.003328571}, {107,0.003561905}, {108,0.003552381}, {109,0.003500000}, {110,0.003466667}, {111,0.003619048}, {112,0.003552381}, {113,0.003747619}, {114,0.003828571}, {115,0.003728571}, {116,0.003766667}, {117,0.003666667}, {118,0.003890476}, {119,0.003847619}, {120,0.003833333}, {121,0.003947619}, {122,0.003914286}, {123,0.004476190}, {124,0.004019048}, {125,0.003995238}, {126,0.004204762}, {127,0.003933333}, {128,0.004161905}, {129,0.003876190}, {130,0.004380952}, {131,0.004157143}, {132,0.004252381}, {133,0.004233333}, {134,0.004447619}, {135,0.004866667}, {136,0.004323810}, {137,0.004509524}, {138,0.004300000}, {139,0.004766667}, {140,0.004295238}, {141,0.004385714}, {142,0.004485714}, {143,0.004428571}, {144,0.004652381}, {145,0.004571429}, {146,0.004790476}, {147,0.004566667}, {148,0.004557143}, {149,0.004900000}, {150,0.004557143}, {151,0.004752381}, {152,0.004952381}, {153,0.004985714}, {154,0.005004762}, {155,0.005142857}, {156,0.004642857}, {157,0.005033333}, {158,0.004995238}, {159,0.004847619}, {160,0.005128571}, {161,0.004876190}, {162,0.005119048}, {163,0.005280952}, {164,0.005247619}, {165,0.005323810}, {166,0.005261905}, {167,0.005357143}, {168,0.005966667}, {169,0.006014286}, {170,0.005395238}, {171,0.005576190}, {172,0.005466667}, {173,0.005542857}, {174,0.005447619}, {175,0.005728571}, {176,0.005676190}, {177,0.005838095}, {178,0.005538095}, {179,0.005914286}, {180,0.005833333}, {181,0.006200000}, {182,0.005842857}, {183,0.005852381}, {184,0.006419048}, {185,0.006009524}, {186,0.006100000}, {187,0.005804762}, {188,0.006009524}, {189,0.005795238}, {190,0.005961905}, {191,0.005957143}, {192,0.006009524}, {193,0.006047619}, {194,0.006152381}, {195,0.006195238}, {196,0.006128571}, {197,0.006347619}, {198,0.007000000}, {199,0.006423810}, {200,0.006328571}, {201,0.006595238}, {202,0.006585714}, {203,0.006623810}, {204,0.006600000}, {205,0.007166667}, {206,0.006523810}, {207,0.006590476}, {208,0.006828571}, {209,0.006519048}, {210,0.006538095}, {211,0.006823810}, {212,0.007414286}, {213,0.006919048}, {214,0.006833333}, {215,0.007014286}, {216,0.007438095}, {217,0.006871429}, {218,0.006995238}, {219,0.007147619}, {220,0.007266667}, {221,0.007119048}, {222,0.007138095}, {223,0.007071429}, {224,0.007776190}, {225,0.007538095}, {226,0.007447619}, {227,0.007790476}, {228,0.007476190}, {229,0.007261905}, {230,0.007157143}, {231,0.007357143}, {232,0.007623810}, {233,0.007471429}, {234,0.007623810}, {235,0.007433333}, {236,0.008257143}, {237,0.008638095}, {238,0.007623810}, {239,0.007680952}, {240,0.007947619}, {241,0.007976190}, {242,0.008028571}, {243,0.008047619}, {244,0.007919048}, {245,0.007985714}, {246,0.007942857}, {247,0.007857143}, {248,0.008652381}, {249,0.008123810}, {250,0.008347619}, {251,0.008147619}, {252,0.008376190}, {253,0.008266667}, {254,0.008347619}, {255,0.008209524}, {256,0.009133333}, {257,0.008209524}, {258,0.008438095}, {259,0.009190476}, {260,0.008447619}, {261,0.008490476}, {262,0.008657143}, {263,0.008742857}, {264,0.008461905}, {265,0.010009524}, {266,0.008609524}, {267,0.008995238}, {268,0.008761905}, {269,0.008800000}, {270,0.009552381}, {271,0.008914286}, {272,0.008804762}, {273,0.009123810}, {274,0.010309524}, {275,0.009085714}, {276,0.009204762}, {277,0.009414286}, {278,0.009152381}, {279,0.009314286}, {280,0.010133333}, {281,0.009300000}, {282,0.009223810}, {283,0.009485714}, {284,0.009561905}, {285,0.009080952}, {286,0.009300000}, {287,0.009390476}, {288,0.009538095}, {289,0.009785714}, {290,0.010328571}, {291,0.011147619}, {292,0.009766667}, {293,0.009857143}, {294,0.009719048}, {295,0.009814286}, {296,0.010100000}, {297,0.009985714}, {298,0.010090476}, {299,0.011904762}, {300,0.010561905}, {301,0.010090476}, {302,0.010200000}, {303,0.010114286}, {304,0.010061905}, {305,0.010161905}, {306,0.010242857}, {307,0.012304762}, {308,0.010300000}, {309,0.011057143}, {310,0.010319048}, {311,0.010666667}, {312,0.010533333}, {313,0.010652381}, {314,0.010576190}, {315,0.012252381}, {316,0.010566667}, {317,0.010761905}, {318,0.011480952}, {319,0.010766667}, {320,0.010785714}, {321,0.010685714}, {322,0.011100000}, {323,0.010966667}, {324,0.010833333}, {325,0.011161905}, {326,0.010928571}, {327,0.011638095}, {328,0.011171429}, {329,0.011204762}, {330,0.014433333}, {331,0.011304762}, {332,0.011147619}, {333,0.011185714}, {334,0.011166667}, {335,0.011319048}, {336,0.011957143}, {337,0.014709524}, {338,0.011519048}, {339,0.011257143}, {340,0.011728571}, {341,0.011580952}, {342,0.011471429}, {343,0.011742857}, {344,0.011647619}, {345,0.012171429}, {346,0.012038095}, {347,0.011490476}, {348,0.011814286}, {349,0.011938095}, {350,0.011919048}, {351,0.011919048}, {352,0.014400000}, {353,0.012509524}, {354,0.011814286}, {355,0.011823810}, {356,0.011890476}, {357,0.012038095}, {358,0.015895238}, {359,0.012128571}, {360,0.012133333}, {361,0.013157143}, {362,0.012385714}, {363,0.012395238}, {364,0.012328571}, {365,0.017695238}, {366,0.012385714}, {367,0.012390476}, {368,0.012471429}, {369,0.013504762}, {370,0.012709524}, {371,0.012709524}, {372,0.016442857}, {373,0.012785714}, {374,0.012714286}, {375,0.012733333}, {376,0.012771429}, {377,0.013766667}, {378,0.012866667}, {379,0.018204762}, {380,0.013004762}, {381,0.012942857}, {382,0.012919048}, {383,0.013047619}, {384,0.013004762}, {385,0.017414286}, {386,0.013042857}, {387,0.013095238}, {388,0.013171429}, {389,0.013185714}, {390,0.013242857}, {391,0.018409524}, {392,0.014128571}, {393,0.013447619}, {394,0.013428571}, {395,0.013480952}, {396,0.013566667}, {397,0.013690476}, {398,0.018723810}, {399,0.013571429}, {400,0.014095238}, {401,0.013671429}, {402,0.013790476}, {403,0.013852381}, {404,0.017704762}, {405,0.013800000}, {406,0.014061905}, {407,0.014542857}, {408,0.014080952}, {409,0.013938095}, {410,0.018623810}, {411,0.014219048}, {412,0.014180952}, {413,0.014233333}, {414,0.014976190}, {415,0.014180952}, {416,0.020071429}, {417,0.014238095}, {418,0.014252381}, {419,0.014490476}, {420,0.014528571}, {421,0.015204762}, {422,0.019919048}, {423,0.014819048}, {424,0.014676190}, {425,0.014952381}, {426,0.014685714}, {427,0.014895238}, {428,0.020990476}, {429,0.014795238}, {430,0.015195238}, {431,0.014785714}, {432,0.015176190}, {433,0.015200000}, {434,0.019080952}, {435,0.015666667}, {436,0.015285714}, {437,0.015023810}, {438,0.015180952}, {439,0.015385714}, {440,0.015147619}, {441,0.015457143}, {442,0.016138095}, {443,0.015485714}, {444,0.015528571}, {445,0.021947619}, {446,0.015752381}, {447,0.015828571}, {448,0.015676190}, {449,0.016280952}, {450,0.016242857}, {451,0.020371429}, {452,0.015966667}, {453,0.015866667}, {454,0.016061905}, {455,0.019428571}, {456,0.030695238}, {457,0.045166667}, {458,0.016376190}, {459,0.016428571}, {460,0.016261905}, {461,0.016290476}, {462,0.021804762}, {463,0.016447619}, {464,0.016271429}, {465,0.016657143}, {466,0.016514286}, {467,0.023142857}, {468,0.017219048}, {469,0.016742857}, {470,0.016461905}, {471,0.016766667}, {472,0.016680952}, {473,0.020861905}, {474,0.016942857}, {475,0.017319048}, {476,0.016847619}, {477,0.017166667}, {478,0.021790476}, {479,0.017100000}, {480,0.017142857}, {481,0.018238095}, {482,0.017176190}, {483,0.022633333}, {484,0.017490476}, {485,0.017323810}, {486,0.017280952}, {487,0.018723810}, {488,0.022300000}, {489,0.017604762}, {490,0.017680952}, {491,0.017704762}, {492,0.017719048}, {493,0.019042857}, {494,0.017776190}, {495,0.018066667}, {496,0.017852381}, {497,0.017814286}, {498,0.018080952}, {499,0.023371429}, {500,0.018133333}, {505,0.019495238}, {510,0.018595238}, {515,0.019052381}, {520,0.024342857}, {525,0.020738095}, {530,0.019771429}, {535,0.019857143}, {540,0.026571429}, {545,0.020580952}, {550,0.020904762}, {555,0.021928571}, {560,0.021576190}, {565,0.027847619}, {570,0.021885714}, {575,0.022100000}, {580,0.023809524}, {585,0.029614286}, {590,0.022700000}, {595,0.023119048}, {600,0.023261905}, {605,0.025885714}, {610,0.029719048}, {615,0.024076190}, {620,0.024452381}, {625,0.024704762}, {630,0.033100000}, {635,0.025161905}, {640,0.025647619}, {645,0.026280952}, {650,0.034557143}, {655,0.027861905}, {660,0.027000000}, {665,0.027280952}, {670,0.034704762}, {675,0.027904762}, {680,0.028142857}, {685,0.028700000}, {690,0.036480952}, {695,0.029461905}, {700,0.030504762}, {705,0.039523810}, {710,0.030147619}, {715,0.030442857}, {720,0.031823810}, {725,0.038657143}, {730,0.031385714}, {735,0.031423810}, {740,0.032014286}, {745,0.031776190}, {750,0.032333333}, {755,0.032519048}, {760,0.041852381}, {765,0.033609524}, {770,0.033452381}, {775,0.045209524}, {780,0.034447619}, {785,0.034742857}, {790,0.035380952}, {795,0.040771429}, {800,0.037447619}, {805,0.035880952}, {810,0.039661905}, {815,0.036957143}, {820,0.038223810}, {825,0.041309524}, {830,0.038014286}, {835,0.038290476}, {840,0.044585714}, {845,0.038871429}, {850,0.039504762}, {855,0.043742857}, {860,0.040833333}, {865,0.040404762}, {870,0.052428571}, {875,0.044066667}, {880,0.041357143}, {885,0.054766667}, {890,0.042247619}, {895,0.043104762}, {900,0.057428571}, {905,0.043438095}, {910,0.044980952}, {915,0.056866667}, {920,0.044371429}, {925,0.044671429}, {930,0.057114286}, {935,0.045547619}, {940,0.046290476}, {945,0.058371429}, {950,0.046504762}, {955,0.061061905}, {960,0.049238095}, {965,0.047833333}, {970,0.062785714}, {975,0.050685714}, {980,0.049157143}, {985,0.059533333}, {990,0.050166667}, {995,0.050814286}, {1000,0.050885714}, {1010,0.051861905}, {1020,0.067942857}, {1030,0.053838095}, {1040,0.054533333}, {1050,0.067395238}, {1060,0.055828571}, {1070,0.073495238}, {1080,0.058828571}, {1090,0.058938095}, {1100,0.072009524}, {1110,0.060352381}, {1120,0.074576190}, {1130,0.065366667}, {1140,0.075676190}, {1150,0.063919048}, {1160,0.066619048}, {1170,0.075338095}, {1180,0.066576190}, {1190,0.079319048}, {1200,0.068352381}, {1210,0.089142857}, {1220,0.070404762}, {1230,0.090342857}, {1240,0.073695238}, {1250,0.088852381}, {1260,0.076471429}, {1270,0.091857143}, {1280,0.076428571}, {1290,0.095600000}, {1300,0.080209524}, {1310,0.083714286}, {1320,0.081133333}, {1330,0.082552381}, {1340,0.084290476}, {1350,0.105647619}, {1360,0.087623810}, {1370,0.107733333}, {1380,0.093780952}, {1390,0.111852381}, {1400,0.092595238}, {1410,0.109042857}, {1420,0.094066667}, {1430,0.125247619}, {1440,0.094523810}, {1450,0.113366667}, {1460,0.097666667}, {1470,0.125095238}, {1480,0.100909524}, {1490,0.136328571}, {1500,0.132971429}, {1510,0.166947619}, {1520,0.141147619}, {1530,0.107642857}, {1540,0.126761905}, {1550,0.111280952}, {1560,0.138471429}, {1570,0.142361905}, {1580,0.112319048}, {1590,0.136261905}, {1600,0.115700000}, {1610,0.138247619}, {1620,0.144752381}, {1630,0.121380952}, {1640,0.138633333}, {1650,0.125261905}, {1660,0.124033333}, {1670,0.155842857}, {1680,0.126952381}, {1690,0.146680952}, {1700,0.137685714}, {1710,0.134552381}, {1720,0.136942857}, {1730,0.142795238}, {1740,0.136852381}, {1750,0.142800000}, {1760,0.184419048}, {1770,0.141442857}, {1780,0.151695238}, {1790,0.152604762}, {1800,0.150214286}, {1810,0.154919048}, {1820,0.168990476}, {1830,0.154876190}, {1840,0.173580952}, {1850,0.192747619}, {1860,0.157171429}, {1870,0.176752381}, {1880,0.196757143}, {1890,0.163547619}, {1900,0.186314286}, {1910,0.188295238}, {1920,0.191057143}, {1930,0.170523810}, {1940,0.184633333}, {1950,0.203438095}, {1960,0.176790476}, {1970,0.179023810}, {1980,0.200614286}, {1990,0.211000000}, {2000,0.186576190}, {2050,0.207166667}, {2100,0.221357143}, {2150,0.228566667}, {2200,0.263209524}, {2250,0.238328571}, {2300,0.281090476}, {2350,0.302590476}, {2400,0.308347619}, {2450,0.338909524}, {2500,0.350942857}, {2550,0.364333333}, {2600,0.370090476}, {2650,0.379104762}, {2700,0.385971429}, {2750,0.382561905}, {2800,0.398904762}, {2850,0.443714286}, {2900,0.426461905}, {2950,0.453895238}, {3000,0.457457143}, {3050,0.476266667}, {3100,0.556480952}, {3150,0.556423810}, {3200,0.561038095}, {3250,0.559323810}, {3300,0.576247619}, {3350,0.652657143}, {3400,0.620114286}, {3450,0.675733333}, {3500,0.686571429}, {3550,0.811100000}, {3600,0.755380952}, {3650,0.724523810}, {3700,0.793309524}, {3750,0.766080952}, {3800,0.787123810}, {3850,0.870419048}, {3900,0.840704762}, {3950,0.935395238}, {4000,0.882033333}, {4050,1.010709524}, {4100,0.947342857}, {4150,1.024566667}, {4200,1.010419048}, {4250,1.115161905}, {4300,1.118680952}, {4350,1.144361905}, {4400,1.134757143}, {4450,1.212547619}, {4500,1.220957143}, {4550,1.306942857}, {4600,1.341214286}, {4650,1.400028571}, {4700,1.424633333}, {4750,1.485952381}, {4800,1.520814286}, {4850,1.506038095}, {4900,1.543100000}, {4950,1.517490476}, {5000,1.614666667}, {5050,1.78543}, {5100,1.80443}, {5150,1.79886}, {5200,1.86529}, {5250,1.91357}, {5300,2.01200}, {5350,2.04943}, {5400,2.06329}, {5450,2.10257}, {5500,2.13629}, {5550,2.74171}, {5600,2.78529}, {5650,2.32743}, {5700,2.36257}, {5750,2.38286}, {5800,2.41743}, {5850,2.44943}, {5900,3.21457}, {5950,2.56471}, {6000,2.62686}, {6050,3.30257}, {6100,2.77571}, {6150,2.81886}, {6200,2.90900}, {6250,2.88014}, {6300,2.99400}, {6350,3.01929}, {6400,3.09586}, {6450,3.11714}, {6500,3.18186}, {6550,3.25429}, {6600,3.33100}, {6650,3.32257}, {6700,3.52086}, {6750,3.52814}, {6800,3.57414}, {6850,3.59871}, {6900,3.71843}, {6950,3.87771}, {7000,3.83086}, {7050,4.03700}, {7100,4.11829}, {7150,4.05329}, {7200,4.10371}, {7250,4.24071}, {7300,4.21629}, {7350,4.29757}, {7400,4.41971}, {7450,4.41486}, {7500,4.55414}, {7550,4.62214}, {7600,4.59386}, {7650,4.68771}, {7700,4.80529}, {7750,4.79457}, {7800,4.86757}, {7850,5.02786}, {7900,6.08429}, {7950,5.12386}, {8000,5.13029}, {8050,5.26114}, {8100,5.27743}, {8150,5.96414}, {8200,5.40843}, {8250,5.38986}, {8300,5.60671}, {8350,5.65357}, {8400,5.78000}, {8450,5.83657}, {8500,5.81757}, {8550,6.03971}, {8600,6.09657}, {8650,6.22043}, {8700,6.24814}, {8750,6.75057}, {8800,6.48671}, {8850,6.49343}, {8900,6.53514}, {8950,6.57657}, {9000,7.76800}, {9050,6.78714}, {9100,7.45443}, {9150,6.77214}, {9200,7.05957}, {9250,6.99614}, {9300,7.22186}, {9350,7.12143}, {9400,7.36200}, {9450,7.26657}, {9500,7.57371}, {9550,7.95071}, {9600,7.71329}, {9650,7.62857}, {9700,7.81700}, {9750,8.45629}, {9800,7.94043}, {9850,8.26557}, {9900,7.94357}, {9950,8.08600}, {10000,8.54000}, {10100,8.17429}, {10200,8.50143}, {10300,8.58643}, {10400,8.99671}, {10500,9.77829}, {10600,9.01686}, {10700,10.59214}, {10800,9.34843}, {10900,10.07814}, {11000,9.76200}, {11100,10.44271}, {11200,10.27043}, {11300,11.72886}, {11400,10.92157}, {11500,10.80400}, {11600,11.68671}, {11700,11.86357}, {11800,11.63543}, {11900,11.86386}, {12000,11.99286}, {12100,12.25900}, {12200,12.44171}, {12300,12.80114}, {12400,12.87157}, {12500,13.05986}, {12600,13.28800}, {12700,13.47957}, {12800,13.68643}, {12900,13.90057}, {13000,14.14571}, {13100,14.33886}, {13200,14.52929}, {13300,14.75114}, {13400,14.98271}, {13500,15.41586}, {13600,15.43257}, {13700,15.62714}, {13800,15.95743}, {13900,16.26157}, {14000,16.20643}, {14100,16.44643}, {14200,16.94643}, {14300,17.70171}, {14400,18.54414}, {14500,17.44557}, {14600,18.81543}, {14700,17.99914}, {14800,18.36400}, {14900,18.80671}, {15000,19.07257}, {15100,19.18429}, {15200,19.16757}, {15300,19.56914}, {15400,19.75471}, {15500,20.10257}, {15600,20.48257}, {15700,20.91771}, {15800,21.28243}, {15900,21.56700}, {16000,21.86900}, {16100,22.06100}, {16200,22.99014}, {16300,22.66114}, {16400,23.18643}, {16500,23.24943}, {16600,23.62529}, {16700,24.03971}, {16800,24.43571}, {16900,24.52800}, {17000,25.17529}, {17100,24.96271}, {17200,25.91543}, {17300,25.98557}, {17400,26.55643}, {17500,26.68114}, {17600,26.48757}, {17700,27.27257}, {17800,27.54129}, {17900,27.91557}, {18000,28.08514}, {18100,28.46514}, {18200,29.24000}, {18300,29.14186}, {18400,29.35829}, {18500,30.00800}, {18600,30.13700}, {18700,29.87571}, {18800,30.63214}, {18900,30.80443}, {19000,31.11257}, {19100,31.50286}, {19200,32.16529}, {19300,32.95029}, {19400,35.74286}, {19500,34.47871}, {19600,33.74771}, {19700,33.85529}, {19800,33.08543}, {19900,33.52314}, {20000,30.42440}};
data["big"]["beta; Parametricity"]["Aggregate"]["system"] = {{1,0.000000000}, {2,0.000038095}, {3,0.000000000}, {4,0.000038095}, {5,0.000019048}, {6,0.000019048}, {7,0.000019048}, {8,0.000019048}, {9,0.000019048}, {10,0.000038095}, {11,0.000076190}, {12,0.000038095}, {13,0.000000000}, {14,0.000038095}, {15,0.000019048}, {16,0.000019048}, {17,0.000057143}, {18,0.000038095}, {19,0.000076190}, {20,0.000057143}, {21,0.000019048}, {22,0.000019048}, {23,0.000000000}, {24,0.000000000}, {25,0.000052381}, {26,0.000038095}, {27,0.000057143}, {28,0.000038095}, {29,0.000057143}, {30,0.000057143}, {31,0.000000000}, {32,0.000014286}, {33,0.000038095}, {34,0.000019048}, {35,0.000038095}, {36,0.000019048}, {37,0.000038095}, {38,0.000000000}, {39,0.000019048}, {40,0.000038095}, {41,0.000057143}, {42,0.000038095}, {43,0.000076190}, {44,0.000038095}, {45,0.000019048}, {46,0.000057143}, {47,0.000038095}, {48,0.000057143}, {49,0.000038095}, {50,0.000019048}, {51,0.000019048}, {52,0.000000000}, {53,0.000057143}, {54,0.000057143}, {55,0.000019048}, {56,0.000038095}, {57,0.000019048}, {58,0.000038095}, {59,0.000033333}, {60,0.000019048}, {61,0.000019048}, {62,0.000033333}, {63,0.000038095}, {64,0.000076190}, {65,0.000057143}, {66,0.000095238}, {67,0.000000000}, {68,0.000109524}, {69,0.000019048}, {70,0.000038095}, {71,0.000038095}, {72,0.000038095}, {73,0.000038095}, {74,0.000038095}, {75,0.000019048}, {76,0.000000000}, {77,0.000071429}, {78,0.000019048}, {79,0.000057143}, {80,0.000038095}, {81,0.000095238}, {82,0.000038095}, {83,0.000038095}, {84,0.000019048}, {85,0.000019048}, {86,0.000019048}, {87,0.000038095}, {88,0.000057143}, {89,0.000019048}, {90,0.000038095}, {91,0.000057143}, {92,0.000019048}, {93,0.000038095}, {94,0.000057143}, {95,0.000038095}, {96,0.000114286}, {97,0.000057143}, {98,0.000019048}, {99,0.000095238}, {100,0.000038095}, {101,0.000019048}, {102,0.000019048}, {103,0.000019048}, {104,0.000057143}, {105,0.000019048}, {106,0.000033333}, {107,0.000019048}, {108,0.000038095}, {109,0.000038095}, {110,0.000047619}, {111,0.000076190}, {112,0.000000000}, {113,0.000057143}, {114,0.000057143}, {115,0.000019048}, {116,0.000000000}, {117,0.000038095}, {118,0.000000000}, {119,0.000038095}, {120,0.000038095}, {121,0.000019048}, {122,0.000019048}, {123,0.000057143}, {124,0.000038095}, {125,0.000076190}, {126,0.000038095}, {127,0.000038095}, {128,0.000038095}, {129,0.000057143}, {130,0.000076190}, {131,0.000057143}, {132,0.000038095}, {133,0.000019048}, {134,0.000038095}, {135,0.000057143}, {136,0.000038095}, {137,0.000057143}, {138,0.000038095}, {139,0.000038095}, {140,0.000038095}, {141,0.000076190}, {142,0.000038095}, {143,0.000095238}, {144,0.000019048}, {145,0.000076190}, {146,0.000095238}, {147,0.000057143}, {148,0.000076190}, {149,0.000038095}, {150,0.000038095}, {151,0.000038095}, {152,0.000057143}, {153,0.000038095}, {154,0.000057143}, {155,0.000019048}, {156,0.000019048}, {157,0.000095238}, {158,0.000038095}, {159,0.000038095}, {160,0.000038095}, {161,0.000057143}, {162,0.000019048}, {163,0.000038095}, {164,0.000057143}, {165,0.000038095}, {166,0.000038095}, {167,0.000019048}, {168,0.000038095}, {169,0.000019048}, {170,0.000038095}, {171,0.000076190}, {172,0.000057143}, {173,0.000052381}, {174,0.000038095}, {175,0.000057143}, {176,0.000033333}, {177,0.000057143}, {178,0.000019048}, {179,0.000057143}, {180,0.000057143}, {181,0.000076190}, {182,0.000076190}, {183,0.000038095}, {184,0.000057143}, {185,0.000057143}, {186,0.000038095}, {187,0.000095238}, {188,0.000076190}, {189,0.000076190}, {190,0.000076190}, {191,0.000133333}, {192,0.000057143}, {193,0.000038095}, {194,0.000000000}, {195,0.000019048}, {196,0.000038095}, {197,0.000038095}, {198,0.000090476}, {199,0.000076190}, {200,0.000057143}, {201,0.000057143}, {202,0.000076190}, {203,0.000019048}, {204,0.000038095}, {205,0.000057143}, {206,0.000038095}, {207,0.000038095}, {208,0.000019048}, {209,0.000038095}, {210,0.000057143}, {211,0.000114286}, {212,0.000038095}, {213,0.000038095}, {214,0.000019048}, {215,0.000038095}, {216,0.000076190}, {217,0.000038095}, {218,0.000038095}, {219,0.000038095}, {220,0.000033333}, {221,0.000076190}, {222,0.000038095}, {223,0.000095238}, {224,0.000038095}, {225,0.000019048}, {226,0.000038095}, {227,0.000019048}, {228,0.000019048}, {229,0.000057143}, {230,0.000090476}, {231,0.000057143}, {232,0.000000000}, {233,0.000052381}, {234,0.000019048}, {235,0.000076190}, {236,0.000038095}, {237,0.000019048}, {238,0.000057143}, {239,0.000038095}, {240,0.000095238}, {241,0.000038095}, {242,0.000038095}, {243,0.000038095}, {244,0.000095238}, {245,0.000057143}, {246,0.000095238}, {247,0.000090476}, {248,0.000038095}, {249,0.000095238}, {250,0.000057143}, {251,0.000076190}, {252,0.000095238}, {253,0.000076190}, {254,0.000019048}, {255,0.000152381}, {256,0.000057143}, {257,0.000095238}, {258,0.000114286}, {259,0.000076190}, {260,0.000109524}, {261,0.000019048}, {262,0.000095238}, {263,0.000057143}, {264,0.000057143}, {265,0.000095238}, {266,0.000076190}, {267,0.000014286}, {268,0.000095238}, {269,0.000019048}, {270,0.000000000}, {271,0.000038095}, {272,0.000057143}, {273,0.000038095}, {274,0.000095238}, {275,0.000019048}, {276,0.000104762}, {277,0.000000000}, {278,0.000133333}, {279,0.000057143}, {280,0.000019048}, {281,0.000076190}, {282,0.000038095}, {283,0.000076190}, {284,0.000076190}, {285,0.000152381}, {286,0.000133333}, {287,0.000095238}, {288,0.000071429}, {289,0.000038095}, {290,0.000038095}, {291,0.000038095}, {292,0.000052381}, {293,0.000071429}, {294,0.000076190}, {295,0.000085714}, {296,0.000019048}, {297,0.000104762}, {298,0.000038095}, {299,0.000033333}, {300,0.000095238}, {301,0.000071429}, {302,0.000066667}, {303,0.000038095}, {304,0.000057143}, {305,0.000038095}, {306,0.000090476}, {307,0.000019048}, {308,0.000038095}, {309,0.000076190}, {310,0.000052381}, {311,0.000057143}, {312,0.000052381}, {313,0.000038095}, {314,0.000033333}, {315,0.000038095}, {316,0.000038095}, {317,0.000019048}, {318,0.000095238}, {319,0.000095238}, {320,0.000095238}, {321,0.000038095}, {322,0.000057143}, {323,0.000019048}, {324,0.000038095}, {325,0.000019048}, {326,0.000076190}, {327,0.000076190}, {328,0.000019048}, {329,0.000038095}, {330,0.000057143}, {331,0.000076190}, {332,0.000133333}, {333,0.000038095}, {334,0.000057143}, {335,0.000114286}, {336,0.000076190}, {337,0.000038095}, {338,0.000071429}, {339,0.000114286}, {340,0.000019048}, {341,0.000057143}, {342,0.000019048}, {343,0.000019048}, {344,0.000057143}, {345,0.000038095}, {346,0.000019048}, {347,0.000114286}, {348,0.000057143}, {349,0.000038095}, {350,0.000076190}, {351,0.000114286}, {352,0.000152381}, {353,0.000090476}, {354,0.000133333}, {355,0.000185714}, {356,0.000095238}, {357,0.000076190}, {358,0.000057143}, {359,0.000038095}, {360,0.000057143}, {361,0.000000000}, {362,0.000057143}, {363,0.000057143}, {364,0.000057143}, {365,0.000038095}, {366,0.000076190}, {367,0.000090476}, {368,0.000095238}, {369,0.000057143}, {370,0.000000000}, {371,0.000095238}, {372,0.000076190}, {373,0.000114286}, {374,0.000057143}, {375,0.000000000}, {376,0.000038095}, {377,0.000057143}, {378,0.000000000}, {379,0.000057143}, {380,0.000057143}, {381,0.000076190}, {382,0.000038095}, {383,0.000057143}, {384,0.000109524}, {385,0.000095238}, {386,0.000114286}, {387,0.000095238}, {388,0.000114286}, {389,0.000076190}, {390,0.000057143}, {391,0.000076190}, {392,0.000076190}, {393,0.000019048}, {394,0.000071429}, {395,0.000152381}, {396,0.000114286}, {397,0.000038095}, {398,0.000038095}, {399,0.000076190}, {400,0.000090476}, {401,0.000057143}, {402,0.000076190}, {403,0.000071429}, {404,0.000057143}, {405,0.000114286}, {406,0.000057143}, {407,0.000076190}, {408,0.000000000}, {409,0.000185714}, {410,0.000076190}, {411,0.000095238}, {412,0.000057143}, {413,0.000114286}, {414,0.000038095}, {415,0.000161905}, {416,0.000019048}, {417,0.000076190}, {418,0.000019048}, {419,0.000038095}, {420,0.000076190}, {421,0.000090476}, {422,0.000095238}, {423,0.000095238}, {424,0.000057143}, {425,0.000076190}, {426,0.000057143}, {427,0.000057143}, {428,0.000057143}, {429,0.000095238}, {430,0.000076190}, {431,0.000114286}, {432,0.000038095}, {433,0.000057143}, {434,0.000076190}, {435,0.000038095}, {436,0.000076190}, {437,0.000095238}, {438,0.000057143}, {439,0.000152381}, {440,0.000038095}, {441,0.000076190}, {442,0.000057143}, {443,0.000095238}, {444,0.000038095}, {445,0.000076190}, {446,0.000019048}, {447,0.000057143}, {448,0.000095238}, {449,0.000090476}, {450,0.000057143}, {451,0.000076190}, {452,0.000095238}, {453,0.000090476}, {454,0.000038095}, {455,0.000114286}, {456,0.000038095}, {457,0.000285714}, {458,0.000114286}, {459,0.000166667}, {460,0.000209524}, {461,0.000171429}, {462,0.000133333}, {463,0.000076190}, {464,0.000152381}, {465,0.000076190}, {466,0.000171429}, {467,0.000133333}, {468,0.000076190}, {469,0.000114286}, {470,0.000295238}, {471,0.000152381}, {472,0.000209524}, {473,0.000114286}, {474,0.000095238}, {475,0.000147619}, {476,0.000204762}, {477,0.000057143}, {478,0.000171429}, {479,0.000242857}, {480,0.000171429}, {481,0.000076190}, {482,0.000209524}, {483,0.000371429}, {484,0.000133333}, {485,0.000095238}, {486,0.000209524}, {487,0.000114286}, {488,0.000190476}, {489,0.000152381}, {490,0.000190476}, {491,0.000114286}, {492,0.000133333}, {493,0.000133333}, {494,0.000171429}, {495,0.000076190}, {496,0.000171429}, {497,0.000285714}, {498,0.000166667}, {499,0.000152381}, {500,0.000152381}, {505,0.000223810}, {510,0.000247619}, {515,0.000209524}, {520,0.000247619}, {525,0.000171429}, {530,0.000190476}, {535,0.000319048}, {540,0.000376190}, {545,0.000266667}, {550,0.000228571}, {555,0.000223810}, {560,0.000209524}, {565,0.000380952}, {570,0.000228571}, {575,0.000095238}, {580,0.000280952}, {585,0.000285714}, {590,0.000495238}, {595,0.000261905}, {600,0.000304762}, {605,0.000266667}, {610,0.000261905}, {615,0.000280952}, {620,0.000333333}, {625,0.000300000}, {630,0.000571429}, {635,0.000280952}, {640,0.000338095}, {645,0.000304762}, {650,0.000476190}, {655,0.000304762}, {660,0.000280952}, {665,0.000304762}, {670,0.000433333}, {675,0.000342857}, {680,0.000433333}, {685,0.000266667}, {690,0.000471429}, {695,0.000304762}, {700,0.000466667}, {705,0.000547619}, {710,0.000414286}, {715,0.000376190}, {720,0.000323810}, {725,0.000476190}, {730,0.000380952}, {735,0.000504762}, {740,0.000490476}, {745,0.000452381}, {750,0.000509524}, {755,0.000604762}, {760,0.000704762}, {765,0.000547619}, {770,0.000676190}, {775,0.000638095}, {780,0.000471429}, {785,0.000647619}, {790,0.000514286}, {795,0.000723810}, {800,0.000571429}, {805,0.000642857}, {810,0.000828571}, {815,0.000566667}, {820,0.000719048}, {825,0.000714286}, {830,0.000590476}, {835,0.000609524}, {840,0.000923810}, {845,0.000661905}, {850,0.000676190}, {855,0.000795238}, {860,0.000685714}, {865,0.000623810}, {870,0.001019048}, {875,0.000642857}, {880,0.000809524}, {885,0.000966667}, {890,0.000738095}, {895,0.000738095}, {900,0.000990476}, {905,0.000785714}, {910,0.000776190}, {915,0.000985714}, {920,0.000776190}, {925,0.000933333}, {930,0.001209524}, {935,0.000909524}, {940,0.000780952}, {945,0.000861905}, {950,0.001052381}, {955,0.001157143}, {960,0.000876190}, {965,0.001066667}, {970,0.001200000}, {975,0.000190476}, {980,0.000076190}, {985,0.000095238}, {990,0.000076190}, {995,0.000057143}, {1000,0.000057143}, {1010,0.000038095}, {1020,0.000114286}, {1030,0.000114286}, {1040,0.000076190}, {1050,0.000057143}, {1060,0.000076190}, {1070,0.000114286}, {1080,0.000152381}, {1090,0.000152381}, {1100,0.000076190}, {1110,0.000095238}, {1120,0.000190476}, {1130,0.000095238}, {1140,0.000095238}, {1150,0.000076190}, {1160,0.000114286}, {1170,0.000152381}, {1180,0.000090476}, {1190,0.000076190}, {1200,0.000190476}, {1210,0.000038095}, {1220,0.000095238}, {1230,0.000095238}, {1240,0.000090476}, {1250,0.000114286}, {1260,0.000057143}, {1270,0.000095238}, {1280,0.000095238}, {1290,0.000133333}, {1300,0.000114286}, {1310,0.000152381}, {1320,0.000133333}, {1330,0.000114286}, {1340,0.000133333}, {1350,0.000057143}, {1360,0.000095238}, {1370,0.000095238}, {1380,0.000095238}, {1390,0.000152381}, {1400,0.000109524}, {1410,0.000076190}, {1420,0.000038095}, {1430,0.000052381}, {1440,0.000095238}, {1450,0.000019048}, {1460,0.000076190}, {1470,0.000076190}, {1480,0.000190476}, {1490,0.000190476}, {1500,0.000038095}, {1510,0.004080952}, {1520,0.002095238}, {1530,0.002214286}, {1540,0.002614286}, {1550,0.002200000}, {1560,0.002333333}, {1570,0.002304762}, {1580,0.002328571}, {1590,0.002376190}, {1600,0.002266667}, {1610,0.002433333}, {1620,0.002466667}, {1630,0.002104762}, {1640,0.002100000}, {1650,0.001771429}, {1660,0.001919048}, {1670,0.002328571}, {1680,0.002147619}, {1690,0.002280952}, {1700,0.002466667}, {1710,0.001952381}, {1720,0.002309524}, {1730,0.002290476}, {1740,0.002038095}, {1750,0.002352381}, {1760,0.002709524}, {1770,0.002338095}, {1780,0.002300000}, {1790,0.002547619}, {1800,0.002442857}, {1810,0.002604762}, {1820,0.002890476}, {1830,0.002733333}, {1840,0.003052381}, {1850,0.003057143}, {1860,0.002847619}, {1870,0.003142857}, {1880,0.002533333}, {1890,0.001914286}, {1900,0.002176190}, {1910,0.002190476}, {1920,0.002195238}, {1930,0.001785714}, {1940,0.001947619}, {1950,0.002171429}, {1960,0.001985714}, {1970,0.001828571}, {1980,0.000166667}, {1990,0.000095238}, {2000,0.000114286}, {2050,0.000057143}, {2100,0.000076190}, {2150,0.000114286}, {2200,0.000019048}, {2250,0.000114286}, {2300,0.000147619}, {2350,0.000171429}, {2400,0.000019048}, {2450,0.000076190}, {2500,0.000152381}, {2550,0.000057143}, {2600,0.000090476}, {2650,0.000114286}, {2700,0.000133333}, {2750,0.000247619}, {2800,0.000209524}, {2850,0.000304762}, {2900,0.000319048}, {2950,0.000333333}, {3000,0.000342857}, {3050,0.000266667}, {3100,0.000504762}, {3150,0.000361905}, {3200,0.000133333}, {3250,0.000190476}, {3300,0.000114286}, {3350,0.000114286}, {3400,0.000190476}, {3450,0.000095238}, {3500,0.000133333}, {3550,0.000228571}, {3600,0.000204762}, {3650,0.000319048}, {3700,0.000266667}, {3750,0.000361905}, {3800,0.000261905}, {3850,0.000266667}, {3900,0.000095238}, {3950,0.000204762}, {4000,0.000228571}, {4050,0.000152381}, {4100,0.000266667}, {4150,0.000185714}, {4200,0.000147619}, {4250,0.000219048}, {4300,0.000171429}, {4350,0.000300000}, {4400,0.000247619}, {4450,0.000247619}, {4500,0.000304762}, {4550,0.000400000}, {4600,0.000295238}, {4650,0.000323810}, {4700,0.000304762}, {4750,0.000133333}, {4800,0.000266667}, {4850,0.000276190}, {4900,0.000319048}, {4950,0.000171429}, {5000,0.000257143}, {5050,0.00686}, {5100,0.00857}, {5150,0.00600}, {5200,0.00957}, {5250,0.00800}, {5300,0.00843}, {5350,0.00843}, {5400,0.00629}, {5450,0.00614}, {5500,0.00514}, {5550,0.00500}, {5600,0.00057}, {5650,0.00100}, {5700,0.00057}, {5750,0.00057}, {5800,0.00214}, {5850,0.00629}, {5900,0.00400}, {5950,0.00443}, {6000,0.00286}, {6050,0.00286}, {6100,0.00000}, {6150,0.00057}, {6200,0.00000}, {6250,0.00400}, {6300,0.00500}, {6350,0.00343}, {6400,0.00786}, {6450,0.00457}, {6500,0.00057}, {6550,0.00000}, {6600,0.00057}, {6650,0.00057}, {6700,0.00057}, {6750,0.00000}, {6800,0.00000}, {6850,0.00229}, {6900,0.00057}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00043}, {7150,0.00057}, {7200,0.00000}, {7250,0.00057}, {7300,0.00114}, {7350,0.00000}, {7400,0.00114}, {7450,0.00000}, {7500,0.00100}, {7550,0.00057}, {7600,0.00057}, {7650,0.00057}, {7700,0.00000}, {7750,0.00171}, {7800,0.00214}, {7850,0.00343}, {7900,0.00857}, {7950,0.00386}, {8000,0.00114}, {8050,0.00114}, {8100,0.01100}, {8150,0.00400}, {8200,0.00114}, {8250,0.00000}, {8300,0.00114}, {8350,0.00514}, {8400,0.00400}, {8450,0.00229}, {8500,0.00229}, {8550,0.00057}, {8600,0.00057}, {8650,0.00000}, {8700,0.00057}, {8750,0.00400}, {8800,0.00114}, {8850,0.00057}, {8900,0.00571}, {8950,0.00614}, {9000,0.00857}, {9050,0.00114}, {9100,0.00057}, {9150,0.00786}, {9200,0.00500}, {9250,0.00943}, {9300,0.00114}, {9350,0.00743}, {9400,0.00057}, {9450,0.00343}, {9500,0.00000}, {9550,0.00571}, {9600,0.00114}, {9650,0.00057}, {9700,0.00843}, {9750,0.00457}, {9800,0.00100}, {9850,0.00171}, {9900,0.00229}, {9950,0.00443}, {10000,0.00514}, {10100,0.00057}, {10200,0.00343}, {10300,0.00743}, {10400,0.00343}, {10500,0.00443}, {10600,0.00400}, {10700,0.00914}, {10800,0.00057}, {10900,0.01243}, {11000,0.00514}, {11100,0.00857}, {11200,0.00157}, {11300,0.02157}, {11400,0.00114}, {11500,0.01071}, {11600,0.02057}, {11700,0.00057}, {11800,0.01029}, {11900,0.01129}, {12000,0.00571}, {12100,0.00057}, {12200,0.00057}, {12300,0.00000}, {12400,0.00114}, {12500,0.00229}, {12600,0.00114}, {12700,0.00157}, {12800,0.00114}, {12900,0.00271}, {13000,0.00114}, {13100,0.00057}, {13200,0.00229}, {13300,0.00171}, {13400,0.00114}, {13500,0.00229}, {13600,0.00114}, {13700,0.00271}, {13800,0.00057}, {13900,0.00057}, {14000,0.00229}, {14100,0.00000}, {14200,0.00171}, {14300,0.00686}, {14400,0.00343}, {14500,0.01929}, {14600,0.00286}, {14700,0.01586}, {14800,0.01371}, {14900,0.00171}, {15000,0.00786}, {15100,0.00400}, {15200,0.00857}, {15300,0.00171}, {15400,0.00171}, {15500,0.00000}, {15600,0.00057}, {15700,0.00171}, {15800,0.00171}, {15900,0.00057}, {16000,0.00514}, {16100,0.00343}, {16200,0.01000}, {16300,0.00843}, {16400,0.00686}, {16500,0.00229}, {16600,0.00229}, {16700,0.00100}, {16800,0.00114}, {16900,0.00229}, {17000,0.00743}, {17100,0.01757}, {17200,0.01243}, {17300,0.01371}, {17400,0.01257}, {17500,0.01414}, {17600,0.01471}, {17700,0.00743}, {17800,0.00971}, {17900,0.00500}, {18000,0.02057}, {18100,0.00514}, {18200,0.00514}, {18300,0.00743}, {18400,0.01029}, {18500,0.00786}, {18600,0.00857}, {18700,0.01286}, {18800,0.00629}, {18900,0.00800}, {19000,0.01143}, {19100,0.01257}, {19200,0.01200}, {19300,0.02729}, {19400,0.05186}, {19500,0.04614}, {19600,0.03400}, {19700,0.01243}, {19800,0.01200}, {19900,0.00743}, {20000,0.00080}};
data["big"]["beta; Parametricity"]["actual reif"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000342857}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.018338095}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.006790476}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000004762}, {47,0.000014286}, {48,0.000023810}, {49,0.000076190}, {50,0.000119048}, {51,0.000133333}, {52,0.000200000}, {53,0.000319048}, {54,0.000385714}, {55,0.000466667}, {56,0.000509524}, {57,0.000514286}, {58,0.000519048}, {59,0.000519048}, {60,0.000519048}, {61,0.000519048}, {62,0.000523810}, {63,0.000519048}, {64,0.000519048}, {65,0.000528571}, {66,0.000528571}, {67,0.000528571}, {68,0.000533333}, {69,0.000542857}, {70,0.000557143}, {71,0.000628571}, {72,0.000666667}, {73,0.000685714}, {74,0.000742857}, {75,0.000752381}, {76,0.000780952}, {77,0.000852381}, {78,0.000938095}, {79,0.000980952}, {80,0.001000000}, {81,0.001000000}, {82,0.001000000}, {83,0.001000000}, {84,0.001000000}, {85,0.001000000}, {86,0.001000000}, {87,0.001000000}, {88,0.001000000}, {89,0.001000000}, {90,0.001000000}, {91,0.001000000}, {92,0.001000000}, {93,0.001366667}, {94,0.001000000}, {95,0.001000000}, {96,0.001000000}, {97,0.001000000}, {98,0.001000000}, {99,0.001000000}, {100,0.001000000}, {101,0.001000000}, {102,0.001000000}, {103,0.001009524}, {104,0.001000000}, {105,0.001000000}, {106,0.001000000}, {107,0.001000000}, {108,0.001000000}, {109,0.001000000}, {110,0.001004762}, {111,0.001019048}, {112,0.001038095}, {113,0.001047619}, {114,0.001076190}, {115,0.001066667}, {116,0.001119048}, {117,0.001128571}, {118,0.001180952}, {119,0.001209524}, {120,0.001261905}, {121,0.001295238}, {122,0.001371429}, {123,0.001961905}, {124,0.001471429}, {125,0.001500000}, {126,0.001514286}, {127,0.001519048}, {128,0.001519048}, {129,0.001519048}, {130,0.001519048}, {131,0.001519048}, {132,0.001519048}, {133,0.001519048}, {134,0.001519048}, {135,0.001519048}, {136,0.001519048}, {137,0.001519048}, {138,0.001528571}, {139,0.001519048}, {140,0.001519048}, {141,0.001519048}, {142,0.001519048}, {143,0.001519048}, {144,0.001519048}, {145,0.001519048}, {146,0.001519048}, {147,0.001519048}, {148,0.001519048}, {149,0.001519048}, {150,0.001523810}, {151,0.001519048}, {152,0.001523810}, {153,0.002057143}, {154,0.001528571}, {155,0.001533333}, {156,0.001547619}, {157,0.001571429}, {158,0.001585714}, {159,0.001642857}, {160,0.001676190}, {161,0.001642857}, {162,0.001666667}, {163,0.001704762}, {164,0.001690476}, {165,0.001719048}, {166,0.001747619}, {167,0.001800000}, {168,0.001819048}, {169,0.001861905}, {170,0.001904762}, {171,0.001938095}, {172,0.001961905}, {173,0.002009524}, {174,0.002038095}, {175,0.002066667}, {176,0.002080952}, {177,0.002095238}, {178,0.002109524}, {179,0.002147619}, {180,0.002204762}, {181,0.002242857}, {182,0.002247619}, {183,0.002328571}, {184,0.002361905}, {185,0.002395238}, {186,0.002480952}, {187,0.002500000}, {188,0.002500000}, {189,0.002519048}, {190,0.002519048}, {191,0.002519048}, {192,0.002519048}, {193,0.002519048}, {194,0.002519048}, {195,0.002519048}, {196,0.002519048}, {197,0.002519048}, {198,0.002519048}, {199,0.002523810}, {200,0.002519048}, {201,0.002519048}, {202,0.002519048}, {203,0.002519048}, {204,0.002533333}, {205,0.003038095}, {206,0.002519048}, {207,0.002519048}, {208,0.002519048}, {209,0.002519048}, {210,0.002519048}, {211,0.002519048}, {212,0.002519048}, {213,0.002519048}, {214,0.002519048}, {215,0.002538095}, {216,0.003333333}, {217,0.002519048}, {218,0.002523810}, {219,0.002519048}, {220,0.002519048}, {221,0.002523810}, {222,0.002523810}, {223,0.002528571}, {224,0.002519048}, {225,0.002519048}, {226,0.002523810}, {227,0.002523810}, {228,0.002542857}, {229,0.002547619}, {230,0.002576190}, {231,0.002604762}, {232,0.002580952}, {233,0.002633333}, {234,0.002666667}, {235,0.002700000}, {236,0.002780952}, {237,0.003600000}, {238,0.002847619}, {239,0.002909524}, {240,0.002985714}, {241,0.003009524}, {242,0.003038095}, {243,0.003114286}, {244,0.003138095}, {245,0.003109524}, {246,0.003147619}, {247,0.003138095}, {248,0.003766667}, {249,0.003152381}, {250,0.003185714}, {251,0.003233333}, {252,0.003295238}, {253,0.003338095}, {254,0.003366667}, {255,0.003395238}, {256,0.003971429}, {257,0.003476190}, {258,0.003490476}, {259,0.003985714}, {260,0.003504762}, {261,0.003519048}, {262,0.003519048}, {263,0.003519048}, {264,0.003519048}, {265,0.004619048}, {266,0.003519048}, {267,0.003519048}, {268,0.003519048}, {269,0.003523810}, {270,0.003533333}, {271,0.003523810}, {272,0.003538095}, {273,0.003557143}, {274,0.005180952}, {275,0.003552381}, {276,0.003552381}, {277,0.003557143}, {278,0.003561905}, {279,0.003600000}, {280,0.004090476}, {281,0.003647619}, {282,0.003695238}, {283,0.003704762}, {284,0.003738095}, {285,0.003776190}, {286,0.003828571}, {287,0.003847619}, {288,0.003919048}, {289,0.003909524}, {290,0.004509524}, {291,0.005266667}, {292,0.003995238}, {293,0.004004762}, {294,0.004028571}, {295,0.004033333}, {296,0.004038095}, {297,0.004038095}, {298,0.004038095}, {299,0.006080952}, {300,0.004619048}, {301,0.004038095}, {302,0.004038095}, {303,0.004038095}, {304,0.004042857}, {305,0.004038095}, {306,0.004038095}, {307,0.006452381}, {308,0.004038095}, {309,0.004038095}, {310,0.004042857}, {311,0.004038095}, {312,0.004042857}, {313,0.004047619}, {314,0.004104762}, {315,0.006100000}, {316,0.004080952}, {317,0.004095238}, {318,0.004109524}, {319,0.004095238}, {320,0.004128571}, {321,0.004176190}, {322,0.004200000}, {323,0.004180952}, {324,0.004290476}, {325,0.004280952}, {326,0.004276190}, {327,0.004366667}, {328,0.004423810}, {329,0.004514286}, {330,0.008195238}, {331,0.004628571}, {332,0.004719048}, {333,0.004819048}, {334,0.004904762}, {335,0.004971429}, {336,0.005490476}, {337,0.005000000}, {338,0.005004762}, {339,0.005019048}, {340,0.005033333}, {341,0.005038095}, {342,0.005038095}, {343,0.005038095}, {344,0.005095238}, {345,0.005038095}, {346,0.005038095}, {347,0.005038095}, {348,0.005038095}, {349,0.005038095}, {350,0.005038095}, {351,0.005095238}, {352,0.005038095}, {353,0.005590476}, {354,0.005038095}, {355,0.005042857}, {356,0.005047619}, {357,0.005052381}, {358,0.005138095}, {359,0.005076190}, {360,0.005076190}, {361,0.005090476}, {362,0.005095238}, {363,0.005119048}, {364,0.005142857}, {365,0.005147619}, {366,0.005214286}, {367,0.005242857}, {368,0.005295238}, {369,0.005347619}, {370,0.005357143}, {371,0.005414286}, {372,0.008914286}, {373,0.005480952}, {374,0.005495238}, {375,0.005519048}, {376,0.005523810}, {377,0.006852381}, {378,0.005600000}, {379,0.005552381}, {380,0.005547619}, {381,0.005561905}, {382,0.005566667}, {383,0.005566667}, {384,0.005571429}, {385,0.009871429}, {386,0.005580952}, {387,0.005566667}, {388,0.005585714}, {389,0.005604762}, {390,0.005619048}, {391,0.005680952}, {392,0.005642857}, {393,0.005609524}, {394,0.005685714}, {395,0.005700000}, {396,0.005680952}, {397,0.005719048}, {398,0.010890476}, {399,0.005800000}, {400,0.006547619}, {401,0.005942857}, {402,0.006000000}, {403,0.006104762}, {404,0.009980952}, {405,0.006309524}, {406,0.006347619}, {407,0.006976190}, {408,0.006480952}, {409,0.006461905}, {410,0.010776190}, {411,0.006519048}, {412,0.006523810}, {413,0.006538095}, {414,0.006542857}, {415,0.006552381}, {416,0.012209524}, {417,0.006552381}, {418,0.006557143}, {419,0.006557143}, {420,0.006557143}, {421,0.006561905}, {422,0.012061905}, {423,0.006557143}, {424,0.006557143}, {425,0.006557143}, {426,0.006566667}, {427,0.006571429}, {428,0.011976190}, {429,0.006580952}, {430,0.006576190}, {431,0.006585714}, {432,0.006614286}, {433,0.006614286}, {434,0.010766667}, {435,0.006666667}, {436,0.006733333}, {437,0.006771429}, {438,0.006761905}, {439,0.006900000}, {440,0.006885714}, {441,0.006938095}, {442,0.007947619}, {443,0.007000000}, {444,0.007047619}, {445,0.007042857}, {446,0.007071429}, {447,0.007090476}, {448,0.007119048}, {449,0.007914286}, {450,0.007271429}, {451,0.011747619}, {452,0.007157143}, {453,0.007147619}, {454,0.007247619}, {455,0.010009524}, {456,0.015823810}, {457,0.036552381}, {458,0.007347619}, {459,0.007314286}, {460,0.007366667}, {461,0.007438095}, {462,0.013338095}, {463,0.007595238}, {464,0.007671429}, {465,0.007661905}, {466,0.007771429}, {467,0.007904762}, {468,0.007795238}, {469,0.007909524}, {470,0.007957143}, {471,0.007961905}, {472,0.008100000}, {473,0.008052381}, {474,0.008057143}, {475,0.008080952}, {476,0.008090476}, {477,0.008047619}, {478,0.013009524}, {479,0.008123810}, {480,0.008114286}, {481,0.009271429}, {482,0.008138095}, {483,0.008209524}, {484,0.008119048}, {485,0.008114286}, {486,0.008152381}, {487,0.009338095}, {488,0.008238095}, {489,0.008147619}, {490,0.008200000}, {491,0.008209524}, {492,0.008161905}, {493,0.008404762}, {494,0.008276190}, {495,0.008271429}, {496,0.008333333}, {497,0.008371429}, {498,0.008519048}, {499,0.008428571}, {500,0.008480952}, {505,0.009847619}, {510,0.008900000}, {515,0.009004762}, {520,0.009247619}, {525,0.009361905}, {530,0.009552381}, {535,0.009680952}, {540,0.009842857}, {545,0.009800000}, {550,0.009923810}, {555,0.010990476}, {560,0.010485714}, {565,0.016985714}, {570,0.010695238}, {575,0.010800000}, {580,0.012319048}, {585,0.011333333}, {590,0.011323810}, {595,0.011400000}, {600,0.011547619}, {605,0.011909524}, {610,0.018023810}, {615,0.012247619}, {620,0.012323810}, {625,0.012438095}, {630,0.019566667}, {635,0.012780952}, {640,0.013023810}, {645,0.013166667}, {650,0.021480952}, {655,0.014861905}, {660,0.013761905}, {665,0.013847619}, {670,0.021380952}, {675,0.014247619}, {680,0.014509524}, {685,0.014690476}, {690,0.014828571}, {695,0.015133333}, {700,0.016671429}, {705,0.015671429}, {710,0.015542857}, {715,0.015666667}, {720,0.015980952}, {725,0.024252381}, {730,0.016438095}, {735,0.016623810}, {740,0.016700000}, {745,0.016866667}, {750,0.017157143}, {755,0.017319048}, {760,0.026809524}, {765,0.017890476}, {770,0.018057143}, {775,0.018514286}, {780,0.018280952}, {785,0.018561905}, {790,0.018723810}, {795,0.018990476}, {800,0.019333333}, {805,0.019528571}, {810,0.023047619}, {815,0.019842857}, {820,0.020004762}, {825,0.024419048}, {830,0.020409524}, {835,0.020747619}, {840,0.022542857}, {845,0.021157143}, {850,0.021376190}, {855,0.021776190}, {860,0.021771429}, {865,0.021971429}, {870,0.022509524}, {875,0.022480952}, {880,0.022695238}, {885,0.023195238}, {890,0.023061905}, {895,0.024052381}, {900,0.023780952}, {905,0.023833333}, {910,0.024066667}, {915,0.037528571}, {920,0.024438095}, {925,0.024619048}, {930,0.037038095}, {935,0.025109524}, {940,0.025423810}, {945,0.038257143}, {950,0.025990476}, {955,0.026214286}, {960,0.028304762}, {965,0.026590476}, {970,0.027147619}, {975,0.026385714}, {980,0.026428571}, {985,0.036919048}, {990,0.026847619}, {995,0.027109524}, {1000,0.027414286}, {1010,0.027866667}, {1020,0.043728571}, {1030,0.029314286}, {1040,0.029357143}, {1050,0.029514286}, {1060,0.030261905}, {1070,0.047771429}, {1080,0.031642857}, {1090,0.032095238}, {1100,0.032361905}, {1110,0.032776190}, {1120,0.047376190}, {1130,0.033833333}, {1140,0.034600000}, {1150,0.034895238}, {1160,0.037152381}, {1170,0.035866667}, {1180,0.036509524}, {1190,0.047852381}, {1200,0.037547619}, {1210,0.056009524}, {1220,0.038576190}, {1230,0.039342857}, {1240,0.041100000}, {1250,0.040395238}, {1260,0.040866667}, {1270,0.041509524}, {1280,0.042019048}, {1290,0.043728571}, {1300,0.044871429}, {1310,0.044238095}, {1320,0.044961905}, {1330,0.045719048}, {1340,0.046533333}, {1350,0.046733333}, {1360,0.049638095}, {1370,0.048528571}, {1380,0.049409524}, {1390,0.050466667}, {1400,0.050471429}, {1410,0.050638095}, {1420,0.052509524}, {1430,0.083152381}, {1440,0.052338095}, {1450,0.071590476}, {1460,0.054419048}, {1470,0.081790476}, {1480,0.056100000}, {1490,0.057190476}, {1500,0.057576190}, {1510,0.122457143}, {1520,0.096895238}, {1530,0.060019048}, {1540,0.081728571}, {1550,0.061371429}, {1560,0.062209524}, {1570,0.063395238}, {1580,0.063514286}, {1590,0.084838095}, {1600,0.064838095}, {1610,0.065361905}, {1620,0.066842857}, {1630,0.066776190}, {1640,0.085861905}, {1650,0.068376190}, {1660,0.068933333}, {1670,0.097757143}, {1680,0.070538095}, {1690,0.090004762}, {1700,0.072804762}, {1710,0.075695238}, {1720,0.078014286}, {1730,0.076538095}, {1740,0.075100000}, {1750,0.081076190}, {1760,0.112109524}, {1770,0.077690476}, {1780,0.084357143}, {1790,0.079414286}, {1800,0.084071429}, {1810,0.088380952}, {1820,0.083195238}, {1830,0.083090476}, {1840,0.104538095}, {1850,0.088080952}, {1860,0.085595238}, {1870,0.105219048}, {1880,0.123057143}, {1890,0.087342857}, {1900,0.088280952}, {1910,0.111766667}, {1920,0.091195238}, {1930,0.090628571}, {1940,0.104485714}, {1950,0.122728571}, {1960,0.093514286}, {1970,0.095395238}, {1980,0.111938095}, {1990,0.094347619}, {2000,0.098061905}, {2050,0.099647619}, {2100,0.122023810}, {2150,0.124490476}, {2200,0.115061905}, {2250,0.121047619}, {2300,0.128647619}, {2350,0.170380952}, {2400,0.173852381}, {2450,0.197547619}, {2500,0.205023810}, {2550,0.211571429}, {2600,0.206852381}, {2650,0.212838095}, {2700,0.211590476}, {2750,0.202814286}, {2800,0.212557143}, {2850,0.249557143}, {2900,0.225347619}, {2950,0.237933333}, {3000,0.237171429}, {3050,0.247190476}, {3100,0.253942857}, {3150,0.272090476}, {3200,0.307152381}, {3250,0.298076190}, {3300,0.307680952}, {3350,0.298000000}, {3400,0.310176190}, {3450,0.372714286}, {3500,0.388195238}, {3550,0.353600000}, {3600,0.439871429}, {3650,0.400033333}, {3700,0.382452381}, {3750,0.416571429}, {3800,0.415376190}, {3850,0.508252381}, {3900,0.468723810}, {3950,0.455700000}, {4000,0.486380952}, {4050,0.489561905}, {4100,0.536600000}, {4150,0.514523810}, {4200,0.568752381}, {4250,0.673223810}, {4300,0.584023810}, {4350,0.672609524}, {4400,0.625909524}, {4450,0.699047619}, {4500,0.724880952}, {4550,0.684052381}, {4600,0.739300000}, {4650,0.871195238}, {4700,0.810261905}, {4750,0.799276190}, {4800,0.825480952}, {4850,0.931600000}, {4900,0.910257143}, {4950,0.896090476}, {5000,0.922480952}, {5050,0.99600}, {5100,1.12271}, {5150,1.13871}, {5200,1.12014}, {5250,1.17343}, {5300,1.26486}, {5350,1.30143}, {5400,1.31814}, {5450,1.35614}, {5500,1.35800}, {5550,1.40257}, {5600,1.40571}, {5650,1.46000}, {5700,1.47643}, {5750,1.51529}, {5800,1.56743}, {5850,1.61586}, {5900,1.67200}, {5950,1.62600}, {6000,1.75471}, {6050,1.85943}, {6100,1.76586}, {6150,1.86171}, {6200,1.87300}, {6250,1.93371}, {6300,1.94057}, {6350,2.04843}, {6400,2.00200}, {6450,2.11414}, {6500,2.06614}, {6550,2.21714}, {6600,2.15500}, {6650,2.24671}, {6700,2.38071}, {6750,2.41057}, {6800,2.45014}, {6850,2.45571}, {6900,2.45929}, {6950,2.65400}, {7000,2.60129}, {7050,2.69686}, {7100,2.81486}, {7150,2.75557}, {7200,2.77886}, {7250,2.88057}, {7300,2.86114}, {7350,2.91771}, {7400,3.01400}, {7450,2.98200}, {7500,3.11243}, {7550,3.15243}, {7600,3.11514}, {7650,3.19171}, {7700,3.28486}, {7750,3.27229}, {7800,3.32014}, {7850,3.42171}, {7900,4.46757}, {7950,3.43129}, {8000,3.50871}, {8050,3.62886}, {8100,3.63371}, {8150,4.15886}, {8200,3.76257}, {8250,3.70829}, {8300,3.91329}, {8350,3.96186}, {8400,4.05571}, {8450,4.08286}, {8500,4.03643}, {8550,4.23843}, {8600,4.27900}, {8650,4.35714}, {8700,4.36457}, {8750,4.34543}, {8800,4.56214}, {8850,4.52600}, {8900,4.57686}, {8950,4.60614}, {9000,5.75500}, {9050,4.77043}, {9100,5.39243}, {9150,4.73557}, {9200,4.99657}, {9250,4.87986}, {9300,5.10557}, {9350,4.94600}, {9400,5.21443}, {9450,4.99914}, {9500,5.31057}, {9550,5.10971}, {9600,5.41914}, {9650,5.20300}, {9700,5.49686}, {9750,6.02300}, {9800,5.48343}, {9850,5.67157}, {9900,5.49000}, {9950,5.71157}, {10000,5.97157}, {10100,5.73543}, {10200,6.03029}, {10300,5.98814}, {10400,6.29743}, {10500,6.54243}, {10600,6.33271}, {10700,7.78957}, {10800,6.52186}, {10900,7.19257}, {11000,6.84443}, {11100,7.11057}, {11200,7.18414}, {11300,8.58657}, {11400,7.82071}, {11500,7.66571}, {11600,8.35543}, {11700,8.59486}, {11800,8.29486}, {11900,8.39400}, {12000,8.58457}, {12100,8.75543}, {12200,8.83243}, {12300,8.97657}, {12400,9.16200}, {12500,9.32443}, {12600,9.47500}, {12700,9.61314}, {12800,9.75571}, {12900,9.91457}, {13000,10.14286}, {13100,10.27357}, {13200,10.39729}, {13300,10.54057}, {13400,10.68371}, {13500,10.83229}, {13600,10.98114}, {13700,11.11529}, {13800,11.47871}, {13900,11.49971}, {14000,11.60443}, {14100,11.78514}, {14200,12.01871}, {14300,12.87943}, {14400,13.36229}, {14500,12.52729}, {14600,13.58300}, {14700,12.87600}, {14800,13.01000}, {14900,13.60729}, {15000,13.70657}, {15100,13.41729}, {15200,13.69771}, {15300,13.99886}, {15400,14.19586}, {15500,14.19757}, {15600,14.65200}, {15700,15.02114}, {15800,15.32257}, {15900,15.50943}, {16000,15.80929}, {16100,15.93057}, {16200,16.20286}, {16300,16.32886}, {16400,16.85786}, {16500,16.76386}, {16600,17.05443}, {16700,17.25371}, {16800,17.45743}, {16900,17.79143}, {17000,18.29571}, {17100,18.06200}, {17200,18.84743}, {17300,18.89529}, {17400,19.19471}, {17500,19.50686}, {17600,19.20157}, {17700,19.95929}, {17800,19.97471}, {17900,20.32443}, {18000,20.32771}, {18100,20.78086}, {18200,21.03629}, {18300,21.22629}, {18400,21.49457}, {18500,21.70686}, {18600,21.93857}, {18700,21.66057}, {18800,22.31257}, {18900,22.38229}, {19000,22.44757}, {19100,22.51443}, {19200,23.03757}, {19300,23.88914}, {19400,25.05971}, {19500,25.06957}, {19600,24.23757}, {19700,24.49671}, {19800,23.99057}, {19900,24.22971}, {20000,21.18900}};
data["big"]["beta; Parametricity"]["actual reif"]["user"] = {{1,0.000266667}, {2,0.000280952}, {3,0.000238095}, {4,0.000314286}, {5,0.000252381}, {6,0.000266667}, {7,0.000247619}, {8,0.000323810}, {9,0.000209524}, {10,0.000238095}, {11,0.000214286}, {12,0.000257143}, {13,0.000300000}, {14,0.000619048}, {15,0.000300000}, {16,0.000261905}, {17,0.000328571}, {18,0.000333333}, {19,0.018504762}, {20,0.000333333}, {21,0.000266667}, {22,0.000400000}, {23,0.000428571}, {24,0.000461905}, {25,0.000404762}, {26,0.000538095}, {27,0.007138095}, {28,0.000576190}, {29,0.000342857}, {30,0.000385714}, {31,0.000447619}, {32,0.000452381}, {33,0.000504762}, {34,0.000680952}, {35,0.000780952}, {36,0.000376190}, {37,0.000585714}, {38,0.000752381}, {39,0.000561905}, {40,0.000647619}, {41,0.000814286}, {42,0.000438095}, {43,0.000680952}, {44,0.000552381}, {45,0.000771429}, {46,0.000785714}, {47,0.000538095}, {48,0.000676190}, {49,0.000876190}, {50,0.000719048}, {51,0.000676190}, {52,0.000785714}, {53,0.000747619}, {54,0.000961905}, {55,0.000719048}, {56,0.000580952}, {57,0.000685714}, {58,0.000852381}, {59,0.000761905}, {60,0.000871429}, {61,0.000995238}, {62,0.000866667}, {63,0.000795238}, {64,0.000671429}, {65,0.000676190}, {66,0.000823810}, {67,0.001114286}, {68,0.000947619}, {69,0.001009524}, {70,0.000966667}, {71,0.001085714}, {72,0.001109524}, {73,0.000961905}, {74,0.000976190}, {75,0.000938095}, {76,0.000852381}, {77,0.000914286}, {78,0.001066667}, {79,0.000976190}, {80,0.001000000}, {81,0.000985714}, {82,0.001128571}, {83,0.001033333}, {84,0.000985714}, {85,0.001066667}, {86,0.001171429}, {87,0.001161905}, {88,0.001185714}, {89,0.001219048}, {90,0.001395238}, {91,0.001338095}, {92,0.001285714}, {93,0.001514286}, {94,0.001157143}, {95,0.001176190}, {96,0.001180952}, {97,0.001119048}, {98,0.001147619}, {99,0.001361905}, {100,0.001342857}, {101,0.001204762}, {102,0.001223810}, {103,0.001357143}, {104,0.001376190}, {105,0.001209524}, {106,0.001252381}, {107,0.001247619}, {108,0.001185714}, {109,0.001309524}, {110,0.001461905}, {111,0.001342857}, {112,0.001400000}, {113,0.001371429}, {114,0.001252381}, {115,0.001409524}, {116,0.001300000}, {117,0.001361905}, {118,0.001557143}, {119,0.001523810}, {120,0.001585714}, {121,0.001285714}, {122,0.001495238}, {123,0.001771429}, {124,0.001495238}, {125,0.001504762}, {126,0.001561905}, {127,0.001633333}, {128,0.001361905}, {129,0.001571429}, {130,0.001485714}, {131,0.001542857}, {132,0.001585714}, {133,0.001847619}, {134,0.001514286}, {135,0.001395238}, {136,0.001852381}, {137,0.001623810}, {138,0.001619048}, {139,0.001509524}, {140,0.001780952}, {141,0.001652381}, {142,0.001695238}, {143,0.001671429}, {144,0.001833333}, {145,0.001738095}, {146,0.001700000}, {147,0.001657143}, {148,0.001876190}, {149,0.001776190}, {150,0.001823810}, {151,0.001728571}, {152,0.001723810}, {153,0.002300000}, {154,0.001733333}, {155,0.001895238}, {156,0.001961905}, {157,0.001642857}, {158,0.001995238}, {159,0.001928571}, {160,0.001652381}, {161,0.002180952}, {162,0.001852381}, {163,0.001904762}, {164,0.001942857}, {165,0.001985714}, {166,0.002009524}, {167,0.002176190}, {168,0.001709524}, {169,0.002057143}, {170,0.001871429}, {171,0.002133333}, {172,0.002109524}, {173,0.002052381}, {174,0.002076190}, {175,0.001885714}, {176,0.002133333}, {177,0.002061905}, {178,0.002309524}, {179,0.002000000}, {180,0.002004762}, {181,0.002252381}, {182,0.001971429}, {183,0.002161905}, {184,0.002071429}, {185,0.001976190}, {186,0.002104762}, {187,0.002271429}, {188,0.002204762}, {189,0.002433333}, {190,0.002300000}, {191,0.002338095}, {192,0.002490476}, {193,0.002323810}, {194,0.002400000}, {195,0.002428571}, {196,0.002557143}, {197,0.002271429}, {198,0.002295238}, {199,0.002495238}, {200,0.002395238}, {201,0.002361905}, {202,0.002319048}, {203,0.002590476}, {204,0.002476190}, {205,0.003095238}, {206,0.002319048}, {207,0.002442857}, {208,0.002571429}, {209,0.002585714}, {210,0.002514286}, {211,0.002338095}, {212,0.002423810}, {213,0.002461905}, {214,0.002595238}, {215,0.002780952}, {216,0.003261905}, {217,0.002638095}, {218,0.002633333}, {219,0.002485714}, {220,0.002747619}, {221,0.002647619}, {222,0.002804762}, {223,0.002719048}, {224,0.002585714}, {225,0.002733333}, {226,0.002676190}, {227,0.002657143}, {228,0.002814286}, {229,0.002838095}, {230,0.002752381}, {231,0.002814286}, {232,0.002876190}, {233,0.002647619}, {234,0.002761905}, {235,0.002895238}, {236,0.002952381}, {237,0.003909524}, {238,0.002857143}, {239,0.003014286}, {240,0.003028571}, {241,0.003004762}, {242,0.003033333}, {243,0.003047619}, {244,0.003014286}, {245,0.002900000}, {246,0.002961905}, {247,0.002942857}, {248,0.003371429}, {249,0.002942857}, {250,0.003009524}, {251,0.003057143}, {252,0.003114286}, {253,0.003152381}, {254,0.003004762}, {255,0.003109524}, {256,0.003814286}, {257,0.003157143}, {258,0.003238095}, {259,0.003704762}, {260,0.003333333}, {261,0.003323810}, {262,0.003238095}, {263,0.003357143}, {264,0.003147619}, {265,0.004423810}, {266,0.003242857}, {267,0.003409524}, {268,0.003366667}, {269,0.003266667}, {270,0.003323810}, {271,0.003385714}, {272,0.003352381}, {273,0.003647619}, {274,0.005028571}, {275,0.003309524}, {276,0.003471429}, {277,0.003671429}, {278,0.003533333}, {279,0.003580952}, {280,0.004104762}, {281,0.003733333}, {282,0.003780952}, {283,0.003804762}, {284,0.004047619}, {285,0.003733333}, {286,0.003409524}, {287,0.003580952}, {288,0.003580952}, {289,0.003666667}, {290,0.004209524}, {291,0.005380952}, {292,0.003804762}, {293,0.003752381}, {294,0.003785714}, {295,0.003785714}, {296,0.003880952}, {297,0.003847619}, {298,0.003838095}, {299,0.006119048}, {300,0.004290476}, {301,0.003933333}, {302,0.003780952}, {303,0.003766667}, {304,0.003761905}, {305,0.003857143}, {306,0.003985714}, {307,0.006761905}, {308,0.004076190}, {309,0.004061905}, {310,0.004052381}, {311,0.004138095}, {312,0.004057143}, {313,0.004080952}, {314,0.003961905}, {315,0.006338095}, {316,0.004176190}, {317,0.004261905}, {318,0.004400000}, {319,0.004266667}, {320,0.004090476}, {321,0.004176190}, {322,0.004476190}, {323,0.004257143}, {324,0.004280952}, {325,0.004576190}, {326,0.004395238}, {327,0.004214286}, {328,0.004590476}, {329,0.004376190}, {330,0.008300000}, {331,0.004557143}, {332,0.004252381}, {333,0.004504762}, {334,0.004457143}, {335,0.004585714}, {336,0.005695238}, {337,0.004561905}, {338,0.004638095}, {339,0.004676190}, {340,0.004538095}, {341,0.004509524}, {342,0.004823810}, {343,0.004652381}, {344,0.005042857}, {345,0.004923810}, {346,0.004652381}, {347,0.004947619}, {348,0.004838095}, {349,0.004990476}, {350,0.004957143}, {351,0.004861905}, {352,0.004828571}, {353,0.005723810}, {354,0.004952381}, {355,0.004923810}, {356,0.004738095}, {357,0.005114286}, {358,0.005066667}, {359,0.005076190}, {360,0.005361905}, {361,0.004942857}, {362,0.005242857}, {363,0.005114286}, {364,0.005185714}, {365,0.005128571}, {366,0.005214286}, {367,0.005209524}, {368,0.005352381}, {369,0.005161905}, {370,0.005300000}, {371,0.005395238}, {372,0.008814286}, {373,0.005166667}, {374,0.005357143}, {375,0.005300000}, {376,0.005566667}, {377,0.006638095}, {378,0.005538095}, {379,0.005500000}, {380,0.005433333}, {381,0.005390476}, {382,0.005538095}, {383,0.005576190}, {384,0.005538095}, {385,0.009938095}, {386,0.005723810}, {387,0.005585714}, {388,0.005514286}, {389,0.005790476}, {390,0.006042857}, {391,0.006042857}, {392,0.005961905}, {393,0.005800000}, {394,0.005966667}, {395,0.005880952}, {396,0.005714286}, {397,0.005766667}, {398,0.011019048}, {399,0.005976190}, {400,0.006519048}, {401,0.006052381}, {402,0.006119048}, {403,0.006033333}, {404,0.009738095}, {405,0.006228571}, {406,0.006285714}, {407,0.007147619}, {408,0.006228571}, {409,0.006133333}, {410,0.010404762}, {411,0.006342857}, {412,0.006371429}, {413,0.006347619}, {414,0.006380952}, {415,0.006500000}, {416,0.012042857}, {417,0.006466667}, {418,0.006557143}, {419,0.006219048}, {420,0.006561905}, {421,0.006433333}, {422,0.012142857}, {423,0.006480952}, {424,0.006776190}, {425,0.006542857}, {426,0.006747619}, {427,0.006542857}, {428,0.011885714}, {429,0.006857143}, {430,0.006509524}, {431,0.006833333}, {432,0.006652381}, {433,0.006857143}, {434,0.010719048}, {435,0.006876190}, {436,0.006823810}, {437,0.006814286}, {438,0.006771429}, {439,0.006966667}, {440,0.007185714}, {441,0.006961905}, {442,0.007938095}, {443,0.007133333}, {444,0.007214286}, {445,0.007004762}, {446,0.007214286}, {447,0.007033333}, {448,0.007361905}, {449,0.007933333}, {450,0.007276190}, {451,0.011700000}, {452,0.007219048}, {453,0.007319048}, {454,0.007585714}, {455,0.010309524}, {456,0.016247619}, {457,0.036542857}, {458,0.007390476}, {459,0.007338095}, {460,0.007328571}, {461,0.007566667}, {462,0.013028571}, {463,0.007819048}, {464,0.007952381}, {465,0.007766667}, {466,0.007723810}, {467,0.007852381}, {468,0.007919048}, {469,0.007895238}, {470,0.007704762}, {471,0.008033333}, {472,0.008261905}, {473,0.008090476}, {474,0.008014286}, {475,0.008166667}, {476,0.008090476}, {477,0.007966667}, {478,0.012942857}, {479,0.008052381}, {480,0.008185714}, {481,0.009604762}, {482,0.008319048}, {483,0.008352381}, {484,0.008523810}, {485,0.008323810}, {486,0.008276190}, {487,0.009780952}, {488,0.008333333}, {489,0.008423810}, {490,0.008433333}, {491,0.008576190}, {492,0.008790476}, {493,0.008676190}, {494,0.008614286}, {495,0.008814286}, {496,0.008657143}, {497,0.008466667}, {498,0.008633333}, {499,0.008528571}, {500,0.008928571}, {505,0.009895238}, {510,0.008780952}, {515,0.009357143}, {520,0.009085714}, {525,0.009461905}, {530,0.009519048}, {535,0.009719048}, {540,0.010109524}, {545,0.009980952}, {550,0.010157143}, {555,0.011057143}, {560,0.010423810}, {565,0.016966667}, {570,0.010538095}, {575,0.010876190}, {580,0.012347619}, {585,0.011200000}, {590,0.011300000}, {595,0.011490476}, {600,0.011523810}, {605,0.011833333}, {610,0.017952381}, {615,0.011919048}, {620,0.012242857}, {625,0.012252381}, {630,0.019628571}, {635,0.012523810}, {640,0.012957143}, {645,0.013028571}, {650,0.021080952}, {655,0.014633333}, {660,0.013761905}, {665,0.014023810}, {670,0.021304762}, {675,0.014204762}, {680,0.014480952}, {685,0.014757143}, {690,0.014647619}, {695,0.014923810}, {700,0.016261905}, {705,0.015728571}, {710,0.015509524}, {715,0.015842857}, {720,0.016071429}, {725,0.024209524}, {730,0.016347619}, {735,0.016495238}, {740,0.016714286}, {745,0.016761905}, {750,0.017123810}, {755,0.017285714}, {760,0.026223810}, {765,0.017600000}, {770,0.017538095}, {775,0.018371429}, {780,0.018200000}, {785,0.018271429}, {790,0.018590476}, {795,0.018766667}, {800,0.018995238}, {805,0.019133333}, {810,0.022357143}, {815,0.019671429}, {820,0.019538095}, {825,0.023671429}, {830,0.019942857}, {835,0.020357143}, {840,0.022019048}, {845,0.020542857}, {850,0.020542857}, {855,0.021247619}, {860,0.021142857}, {865,0.021385714}, {870,0.021642857}, {875,0.021619048}, {880,0.021709524}, {885,0.022133333}, {890,0.022238095}, {895,0.023261905}, {900,0.022947619}, {905,0.023061905}, {910,0.023066667}, {915,0.036614286}, {920,0.023647619}, {925,0.023761905}, {930,0.036119048}, {935,0.024452381}, {940,0.024771429}, {945,0.037509524}, {950,0.025119048}, {955,0.025480952}, {960,0.027833333}, {965,0.025923810}, {970,0.026347619}, {975,0.026171429}, {980,0.026466667}, {985,0.036919048}, {990,0.027180952}, {995,0.027219048}, {1000,0.027671429}, {1010,0.028157143}, {1020,0.043776190}, {1030,0.029461905}, {1040,0.029576190}, {1050,0.029576190}, {1060,0.030233333}, {1070,0.048104762}, {1080,0.031723810}, {1090,0.032233333}, {1100,0.032590476}, {1110,0.032947619}, {1120,0.047747619}, {1130,0.033961905}, {1140,0.034838095}, {1150,0.035014286}, {1160,0.037319048}, {1170,0.036161905}, {1180,0.036738095}, {1190,0.047852381}, {1200,0.037719048}, {1210,0.055871429}, {1220,0.038604762}, {1230,0.039423810}, {1240,0.040876190}, {1250,0.040323810}, {1260,0.040738095}, {1270,0.041266667}, {1280,0.042085714}, {1290,0.044019048}, {1300,0.044795238}, {1310,0.044371429}, {1320,0.045076190}, {1330,0.045785714}, {1340,0.046657143}, {1350,0.047214286}, {1360,0.049685714}, {1370,0.048561905}, {1380,0.049776190}, {1390,0.050319048}, {1400,0.050685714}, {1410,0.050704762}, {1420,0.052400000}, {1430,0.083514286}, {1440,0.052557143}, {1450,0.071495238}, {1460,0.054566667}, {1470,0.081861905}, {1480,0.056228571}, {1490,0.057176190}, {1500,0.057495238}, {1510,0.118328571}, {1520,0.094809524}, {1530,0.057814286}, {1540,0.079342857}, {1550,0.058980952}, {1560,0.059852381}, {1570,0.061390476}, {1580,0.061233333}, {1590,0.082623810}, {1600,0.062947619}, {1610,0.063638095}, {1620,0.064685714}, {1630,0.065009524}, {1640,0.083985714}, {1650,0.066728571}, {1660,0.067138095}, {1670,0.095638095}, {1680,0.068728571}, {1690,0.087919048}, {1700,0.070876190}, {1710,0.073876190}, {1720,0.075861905}, {1730,0.074852381}, {1740,0.073123810}, {1750,0.078861905}, {1760,0.109685714}, {1770,0.075261905}, {1780,0.082057143}, {1790,0.076861905}, {1800,0.081976190}, {1810,0.085852381}, {1820,0.080952381}, {1830,0.080561905}, {1840,0.101642857}, {1850,0.085328571}, {1860,0.083085714}, {1870,0.102285714}, {1880,0.120461905}, {1890,0.085776190}, {1900,0.086476190}, {1910,0.109866667}, {1920,0.089271429}, {1930,0.089166667}, {1940,0.102685714}, {1950,0.120647619}, {1960,0.091709524}, {1970,0.093566667}, {1980,0.111919048}, {1990,0.094242857}, {2000,0.098176190}, {2050,0.099452381}, {2100,0.122071429}, {2150,0.124328571}, {2200,0.114785714}, {2250,0.120947619}, {2300,0.128514286}, {2350,0.170352381}, {2400,0.173700000}, {2450,0.197076190}, {2500,0.204914286}, {2550,0.211476190}, {2600,0.206676190}, {2650,0.212966667}, {2700,0.211438095}, {2750,0.202733333}, {2800,0.212280952}, {2850,0.249280952}, {2900,0.224857143}, {2950,0.237623810}, {3000,0.236785714}, {3050,0.246876190}, {3100,0.253723810}, {3150,0.271666667}, {3200,0.306985714}, {3250,0.297942857}, {3300,0.307442857}, {3350,0.297580952}, {3400,0.309828571}, {3450,0.372509524}, {3500,0.388009524}, {3550,0.353757143}, {3600,0.439561905}, {3650,0.399723810}, {3700,0.381952381}, {3750,0.416152381}, {3800,0.415052381}, {3850,0.508004762}, {3900,0.468676190}, {3950,0.455609524}, {4000,0.486285714}, {4050,0.489285714}, {4100,0.536114286}, {4150,0.514404762}, {4200,0.568671429}, {4250,0.672952381}, {4300,0.583876190}, {4350,0.672180952}, {4400,0.625466667}, {4450,0.698609524}, {4500,0.724438095}, {4550,0.683314286}, {4600,0.738847619}, {4650,0.870614286}, {4700,0.809719048}, {4750,0.799109524}, {4800,0.825128571}, {4850,0.931109524}, {4900,0.909990476}, {4950,0.895766667}, {5000,0.922247619}, {5050,0.99029}, {5100,1.11457}, {5150,1.13257}, {5200,1.11114}, {5250,1.16629}, {5300,1.25786}, {5350,1.29186}, {5400,1.31214}, {5450,1.34943}, {5500,1.35157}, {5550,1.39843}, {5600,1.40500}, {5650,1.45843}, {5700,1.47586}, {5750,1.51443}, {5800,1.56471}, {5850,1.60986}, {5900,1.66729}, {5950,1.62029}, {6000,1.75086}, {6050,1.85743}, {6100,1.76471}, {6150,1.85943}, {6200,1.87129}, {6250,1.93057}, {6300,1.93500}, {6350,2.04329}, {6400,1.99457}, {6450,2.10914}, {6500,2.06414}, {6550,2.21614}, {6600,2.15443}, {6650,2.24500}, {6700,2.37786}, {6750,2.40971}, {6800,2.44914}, {6850,2.45257}, {6900,2.45714}, {6950,2.65214}, {7000,2.60014}, {7050,2.69586}, {7100,2.81329}, {7150,2.75371}, {7200,2.77786}, {7250,2.87786}, {7300,2.86114}, {7350,2.91629}, {7400,3.01243}, {7450,2.98086}, {7500,3.10914}, {7550,3.14957}, {7600,3.11386}, {7650,3.18886}, {7700,3.28314}, {7750,3.27000}, {7800,3.31743}, {7850,3.41600}, {7900,4.45914}, {7950,3.42614}, {8000,3.50586}, {8050,3.62686}, {8100,3.62129}, {8150,4.15586}, {8200,3.76086}, {8250,3.70714}, {8300,3.91157}, {8350,3.95600}, {8400,4.04971}, {8450,4.07886}, {8500,4.03314}, {8550,4.23786}, {8600,4.27771}, {8650,4.35643}, {8700,4.36114}, {8750,4.33871}, {8800,4.55814}, {8850,4.52343}, {8900,4.56857}, {8950,4.59743}, {9000,5.74443}, {9050,4.76700}, {9100,5.38757}, {9150,4.72414}, {9200,4.99100}, {9250,4.86629}, {9300,5.10157}, {9350,4.93600}, {9400,5.21029}, {9450,4.99443}, {9500,5.30757}, {9550,5.10143}, {9600,5.41486}, {9650,5.19829}, {9700,5.48500}, {9750,6.01686}, {9800,5.47914}, {9850,5.66586}, {9900,5.48471}, {9950,5.70371}, {10000,5.96443}, {10100,5.73329}, {10200,6.02543}, {10300,5.97829}, {10400,6.29143}, {10500,6.53500}, {10600,6.32686}, {10700,7.77643}, {10800,6.51829}, {10900,7.17771}, {11000,6.83614}, {11100,7.09857}, {11200,7.17971}, {11300,8.56257}, {11400,7.81600}, {11500,7.65286}, {11600,8.33257}, {11700,8.59229}, {11800,8.28243}, {11900,8.38057}, {12000,8.57543}, {12100,8.75029}, {12200,8.82829}, {12300,8.97186}, {12400,9.15771}, {12500,9.31886}, {12600,9.46986}, {12700,9.60643}, {12800,9.74957}, {12900,9.90843}, {13000,10.13900}, {13100,10.26400}, {13200,10.38671}, {13300,10.52971}, {13400,10.67443}, {13500,10.82186}, {13600,10.97171}, {13700,11.10600}, {13800,11.47143}, {13900,11.49286}, {14000,11.59800}, {14100,11.77886}, {14200,12.01329}, {14300,12.86671}, {14400,13.35571}, {14500,12.50386}, {14600,13.57571}, {14700,12.85543}, {14800,12.99229}, {14900,13.60057}, {15000,13.69343}, {15100,13.40843}, {15200,13.68471}, {15300,13.99029}, {15400,14.18671}, {15500,14.18986}, {15600,14.64471}, {15700,15.01429}, {15800,15.31300}, {15900,15.50243}, {16000,15.80029}, {16100,15.92229}, {16200,16.18786}, {16300,16.30986}, {16400,16.84314}, {16500,16.74986}, {16600,17.04100}, {16700,17.23486}, {16800,17.43814}, {16900,17.77200}, {17000,18.27186}, {17100,18.02643}, {17200,18.82114}, {17300,18.86414}, {17400,19.16343}, {17500,19.47329}, {17600,19.16786}, {17700,19.93343}, {17800,19.94429}, {17900,20.29971}, {18000,20.28943}, {18100,20.75457}, {18200,21.01100}, {18300,21.19657}, {18400,21.46329}, {18500,21.68029}, {18600,21.91100}, {18700,21.62586}, {18800,22.28500}, {18900,22.35186}, {19000,22.41457}, {19100,22.48143}, {19200,23.00486}, {19300,23.84029}, {19400,24.98600}, {19500,25.00157}, {19600,24.17986}, {19700,24.45971}, {19800,23.95100}, {19900,24.19757}, {20000,21.15240}};
data["big"]["beta; Parametricity"]["actual reif"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000019048}, {8,0.000000000}, {9,0.000019048}, {10,0.000000000}, {11,0.000057143}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000019048}, {17,0.000038095}, {18,0.000000000}, {19,0.000019048}, {20,0.000000000}, {21,0.000019048}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000019048}, {28,0.000019048}, {29,0.000000000}, {30,0.000038095}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000019048}, {36,0.000019048}, {37,0.000019048}, {38,0.000000000}, {39,0.000000000}, {40,0.000019048}, {41,0.000000000}, {42,0.000000000}, {43,0.000019048}, {44,0.000019048}, {45,0.000019048}, {46,0.000000000}, {47,0.000038095}, {48,0.000019048}, {49,0.000019048}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000038095}, {54,0.000019048}, {55,0.000000000}, {56,0.000019048}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000019048}, {61,0.000000000}, {62,0.000014286}, {63,0.000038095}, {64,0.000038095}, {65,0.000038095}, {66,0.000000000}, {67,0.000000000}, {68,0.000019048}, {69,0.000000000}, {70,0.000019048}, {71,0.000000000}, {72,0.000000000}, {73,0.000038095}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000071429}, {78,0.000000000}, {79,0.000019048}, {80,0.000000000}, {81,0.000095238}, {82,0.000019048}, {83,0.000038095}, {84,0.000000000}, {85,0.000000000}, {86,0.000019048}, {87,0.000000000}, {88,0.000038095}, {89,0.000019048}, {90,0.000019048}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000019048}, {95,0.000019048}, {96,0.000019048}, {97,0.000000000}, {98,0.000000000}, {99,0.000019048}, {100,0.000019048}, {101,0.000019048}, {102,0.000000000}, {103,0.000019048}, {104,0.000019048}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000038095}, {109,0.000000000}, {110,0.000000000}, {111,0.000038095}, {112,0.000000000}, {113,0.000019048}, {114,0.000057143}, {115,0.000019048}, {116,0.000000000}, {117,0.000019048}, {118,0.000000000}, {119,0.000019048}, {120,0.000019048}, {121,0.000019048}, {122,0.000000000}, {123,0.000057143}, {124,0.000000000}, {125,0.000019048}, {126,0.000019048}, {127,0.000038095}, {128,0.000000000}, {129,0.000038095}, {130,0.000000000}, {131,0.000019048}, {132,0.000000000}, {133,0.000000000}, {134,0.000019048}, {135,0.000019048}, {136,0.000019048}, {137,0.000000000}, {138,0.000019048}, {139,0.000000000}, {140,0.000000000}, {141,0.000038095}, {142,0.000000000}, {143,0.000057143}, {144,0.000000000}, {145,0.000057143}, {146,0.000019048}, {147,0.000019048}, {148,0.000019048}, {149,0.000000000}, {150,0.000019048}, {151,0.000000000}, {152,0.000000000}, {153,0.000019048}, {154,0.000019048}, {155,0.000019048}, {156,0.000019048}, {157,0.000038095}, {158,0.000038095}, {159,0.000000000}, {160,0.000019048}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000019048}, {170,0.000038095}, {171,0.000019048}, {172,0.000000000}, {173,0.000000000}, {174,0.000019048}, {175,0.000019048}, {176,0.000000000}, {177,0.000019048}, {178,0.000000000}, {179,0.000000000}, {180,0.000038095}, {181,0.000000000}, {182,0.000057143}, {183,0.000038095}, {184,0.000000000}, {185,0.000038095}, {186,0.000000000}, {187,0.000019048}, {188,0.000057143}, {189,0.000038095}, {190,0.000019048}, {191,0.000019048}, {192,0.000000000}, {193,0.000019048}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000052381}, {199,0.000000000}, {200,0.000000000}, {201,0.000019048}, {202,0.000000000}, {203,0.000019048}, {204,0.000038095}, {205,0.000019048}, {206,0.000019048}, {207,0.000019048}, {208,0.000019048}, {209,0.000019048}, {210,0.000000000}, {211,0.000019048}, {212,0.000019048}, {213,0.000019048}, {214,0.000000000}, {215,0.000000000}, {216,0.000019048}, {217,0.000019048}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000019048}, {222,0.000019048}, {223,0.000019048}, {224,0.000000000}, {225,0.000019048}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000038095}, {231,0.000019048}, {232,0.000000000}, {233,0.000019048}, {234,0.000000000}, {235,0.000019048}, {236,0.000000000}, {237,0.000000000}, {238,0.000019048}, {239,0.000000000}, {240,0.000057143}, {241,0.000000000}, {242,0.000000000}, {243,0.000019048}, {244,0.000076190}, {245,0.000038095}, {246,0.000057143}, {247,0.000000000}, {248,0.000019048}, {249,0.000057143}, {250,0.000000000}, {251,0.000019048}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000038095}, {256,0.000019048}, {257,0.000019048}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000019048}, {263,0.000000000}, {264,0.000019048}, {265,0.000038095}, {266,0.000057143}, {267,0.000014286}, {268,0.000019048}, {269,0.000019048}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000057143}, {277,0.000000000}, {278,0.000057143}, {279,0.000019048}, {280,0.000000000}, {281,0.000019048}, {282,0.000000000}, {283,0.000019048}, {284,0.000000000}, {285,0.000057143}, {286,0.000038095}, {287,0.000038095}, {288,0.000014286}, {289,0.000000000}, {290,0.000000000}, {291,0.000038095}, {292,0.000000000}, {293,0.000019048}, {294,0.000019048}, {295,0.000000000}, {296,0.000019048}, {297,0.000052381}, {298,0.000000000}, {299,0.000000000}, {300,0.000057143}, {301,0.000019048}, {302,0.000019048}, {303,0.000038095}, {304,0.000000000}, {305,0.000019048}, {306,0.000019048}, {307,0.000019048}, {308,0.000000000}, {309,0.000000000}, {310,0.000019048}, {311,0.000038095}, {312,0.000019048}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000019048}, {317,0.000000000}, {318,0.000019048}, {319,0.000019048}, {320,0.000019048}, {321,0.000038095}, {322,0.000000000}, {323,0.000000000}, {324,0.000019048}, {325,0.000000000}, {326,0.000019048}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000019048}, {331,0.000019048}, {332,0.000057143}, {333,0.000019048}, {334,0.000000000}, {335,0.000057143}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000019048}, {340,0.000000000}, {341,0.000038095}, {342,0.000019048}, {343,0.000000000}, {344,0.000038095}, {345,0.000019048}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000038095}, {352,0.000057143}, {353,0.000033333}, {354,0.000076190}, {355,0.000057143}, {356,0.000038095}, {357,0.000038095}, {358,0.000019048}, {359,0.000000000}, {360,0.000038095}, {361,0.000000000}, {362,0.000019048}, {363,0.000000000}, {364,0.000038095}, {365,0.000019048}, {366,0.000019048}, {367,0.000000000}, {368,0.000019048}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000038095}, {374,0.000000000}, {375,0.000000000}, {376,0.000019048}, {377,0.000019048}, {378,0.000000000}, {379,0.000000000}, {380,0.000019048}, {381,0.000038095}, {382,0.000019048}, {383,0.000000000}, {384,0.000019048}, {385,0.000038095}, {386,0.000038095}, {387,0.000000000}, {388,0.000038095}, {389,0.000038095}, {390,0.000057143}, {391,0.000057143}, {392,0.000019048}, {393,0.000019048}, {394,0.000019048}, {395,0.000076190}, {396,0.000019048}, {397,0.000038095}, {398,0.000019048}, {399,0.000019048}, {400,0.000014286}, {401,0.000019048}, {402,0.000038095}, {403,0.000019048}, {404,0.000019048}, {405,0.000000000}, {406,0.000000000}, {407,0.000038095}, {408,0.000000000}, {409,0.000057143}, {410,0.000000000}, {411,0.000000000}, {412,0.000019048}, {413,0.000000000}, {414,0.000019048}, {415,0.000052381}, {416,0.000019048}, {417,0.000019048}, {418,0.000000000}, {419,0.000000000}, {420,0.000038095}, {421,0.000019048}, {422,0.000019048}, {423,0.000038095}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000038095}, {429,0.000019048}, {430,0.000038095}, {431,0.000000000}, {432,0.000019048}, {433,0.000019048}, {434,0.000038095}, {435,0.000000000}, {436,0.000019048}, {437,0.000038095}, {438,0.000038095}, {439,0.000057143}, {440,0.000019048}, {441,0.000019048}, {442,0.000019048}, {443,0.000038095}, {444,0.000019048}, {445,0.000019048}, {446,0.000000000}, {447,0.000038095}, {448,0.000019048}, {449,0.000019048}, {450,0.000000000}, {451,0.000000000}, {452,0.000019048}, {453,0.000019048}, {454,0.000019048}, {455,0.000038095}, {456,0.000019048}, {457,0.000209524}, {458,0.000038095}, {459,0.000095238}, {460,0.000133333}, {461,0.000114286}, {462,0.000095238}, {463,0.000076190}, {464,0.000076190}, {465,0.000000000}, {466,0.000057143}, {467,0.000038095}, {468,0.000038095}, {469,0.000095238}, {470,0.000223810}, {471,0.000057143}, {472,0.000114286}, {473,0.000076190}, {474,0.000076190}, {475,0.000128571}, {476,0.000133333}, {477,0.000019048}, {478,0.000133333}, {479,0.000133333}, {480,0.000133333}, {481,0.000038095}, {482,0.000095238}, {483,0.000204762}, {484,0.000095238}, {485,0.000038095}, {486,0.000095238}, {487,0.000057143}, {488,0.000057143}, {489,0.000076190}, {490,0.000095238}, {491,0.000095238}, {492,0.000057143}, {493,0.000076190}, {494,0.000114286}, {495,0.000057143}, {496,0.000114286}, {497,0.000190476}, {498,0.000109524}, {499,0.000057143}, {500,0.000095238}, {505,0.000076190}, {510,0.000152381}, {515,0.000114286}, {520,0.000171429}, {525,0.000114286}, {530,0.000171429}, {535,0.000261905}, {540,0.000209524}, {545,0.000171429}, {550,0.000152381}, {555,0.000166667}, {560,0.000171429}, {565,0.000247619}, {570,0.000133333}, {575,0.000076190}, {580,0.000166667}, {585,0.000209524}, {590,0.000285714}, {595,0.000242857}, {600,0.000152381}, {605,0.000209524}, {610,0.000204762}, {615,0.000171429}, {620,0.000261905}, {625,0.000152381}, {630,0.000304762}, {635,0.000223810}, {640,0.000319048}, {645,0.000190476}, {650,0.000304762}, {655,0.000228571}, {660,0.000242857}, {665,0.000209524}, {670,0.000357143}, {675,0.000247619}, {680,0.000357143}, {685,0.000247619}, {690,0.000285714}, {695,0.000247619}, {700,0.000376190}, {705,0.000280952}, {710,0.000338095}, {715,0.000280952}, {720,0.000266667}, {725,0.000342857}, {730,0.000342857}, {735,0.000428571}, {740,0.000357143}, {745,0.000376190}, {750,0.000433333}, {755,0.000495238}, {760,0.000552381}, {765,0.000471429}, {770,0.000585714}, {775,0.000414286}, {780,0.000400000}, {785,0.000495238}, {790,0.000380952}, {795,0.000419048}, {800,0.000457143}, {805,0.000528571}, {810,0.000714286}, {815,0.000509524}, {820,0.000642857}, {825,0.000619048}, {830,0.000533333}, {835,0.000476190}, {840,0.000676190}, {845,0.000566667}, {850,0.000604762}, {855,0.000514286}, {860,0.000647619}, {865,0.000585714}, {870,0.000776190}, {875,0.000585714}, {880,0.000647619}, {885,0.000776190}, {890,0.000661905}, {895,0.000661905}, {900,0.000742857}, {905,0.000657143}, {910,0.000661905}, {915,0.000871429}, {920,0.000738095}, {925,0.000838095}, {930,0.001095238}, {935,0.000776190}, {940,0.000666667}, {945,0.000804762}, {950,0.000957143}, {955,0.000909524}, {960,0.000780952}, {965,0.000842857}, {970,0.000857143}, {975,0.000133333}, {980,0.000038095}, {985,0.000038095}, {990,0.000019048}, {995,0.000019048}, {1000,0.000038095}, {1010,0.000000000}, {1020,0.000057143}, {1030,0.000038095}, {1040,0.000019048}, {1050,0.000019048}, {1060,0.000019048}, {1070,0.000019048}, {1080,0.000038095}, {1090,0.000019048}, {1100,0.000019048}, {1110,0.000038095}, {1120,0.000057143}, {1130,0.000019048}, {1140,0.000019048}, {1150,0.000019048}, {1160,0.000019048}, {1170,0.000000000}, {1180,0.000038095}, {1190,0.000000000}, {1200,0.000076190}, {1210,0.000038095}, {1220,0.000019048}, {1230,0.000000000}, {1240,0.000019048}, {1250,0.000038095}, {1260,0.000019048}, {1270,0.000038095}, {1280,0.000000000}, {1290,0.000038095}, {1300,0.000038095}, {1310,0.000057143}, {1320,0.000038095}, {1330,0.000057143}, {1340,0.000038095}, {1350,0.000019048}, {1360,0.000019048}, {1370,0.000000000}, {1380,0.000019048}, {1390,0.000057143}, {1400,0.000038095}, {1410,0.000000000}, {1420,0.000038095}, {1430,0.000014286}, {1440,0.000038095}, {1450,0.000000000}, {1460,0.000019048}, {1470,0.000057143}, {1480,0.000000000}, {1490,0.000038095}, {1500,0.000000000}, {1510,0.003890476}, {1520,0.001961905}, {1530,0.002157143}, {1540,0.002366667}, {1550,0.002104762}, {1560,0.002123810}, {1570,0.002004762}, {1580,0.002233333}, {1590,0.002242857}, {1600,0.002019048}, {1610,0.002038095}, {1620,0.002142857}, {1630,0.001838095}, {1640,0.001952381}, {1650,0.001676190}, {1660,0.001785714}, {1670,0.002233333}, {1680,0.001961905}, {1690,0.002214286}, {1700,0.002180952}, {1710,0.001876190}, {1720,0.002123810}, {1730,0.001890476}, {1740,0.001885714}, {1750,0.002180952}, {1760,0.002276190}, {1770,0.002166667}, {1780,0.002185714}, {1790,0.002204762}, {1800,0.002214286}, {1810,0.002433333}, {1820,0.002266667}, {1830,0.002657143}, {1840,0.002871429}, {1850,0.002623810}, {1860,0.002714286}, {1870,0.002914286}, {1880,0.002380952}, {1890,0.001857143}, {1900,0.002028571}, {1910,0.002038095}, {1920,0.001857143}, {1930,0.001652381}, {1940,0.001757143}, {1950,0.001957143}, {1960,0.001838095}, {1970,0.001676190}, {1980,0.000033333}, {1990,0.000019048}, {2000,0.000076190}, {2050,0.000038095}, {2100,0.000000000}, {2150,0.000019048}, {2200,0.000019048}, {2250,0.000000000}, {2300,0.000038095}, {2350,0.000019048}, {2400,0.000019048}, {2450,0.000019048}, {2500,0.000019048}, {2550,0.000019048}, {2600,0.000052381}, {2650,0.000019048}, {2700,0.000019048}, {2750,0.000152381}, {2800,0.000114286}, {2850,0.000247619}, {2900,0.000166667}, {2950,0.000200000}, {3000,0.000247619}, {3050,0.000171429}, {3100,0.000219048}, {3150,0.000247619}, {3200,0.000019048}, {3250,0.000057143}, {3300,0.000019048}, {3350,0.000019048}, {3400,0.000038095}, {3450,0.000038095}, {3500,0.000038095}, {3550,0.000095238}, {3600,0.000109524}, {3650,0.000171429}, {3700,0.000095238}, {3750,0.000190476}, {3800,0.000147619}, {3850,0.000095238}, {3900,0.000019048}, {3950,0.000038095}, {4000,0.000076190}, {4050,0.000038095}, {4100,0.000133333}, {4150,0.000033333}, {4200,0.000019048}, {4250,0.000038095}, {4300,0.000057143}, {4350,0.000133333}, {4400,0.000095238}, {4450,0.000076190}, {4500,0.000209524}, {4550,0.000190476}, {4600,0.000076190}, {4650,0.000209524}, {4700,0.000171429}, {4750,0.000057143}, {4800,0.000019048}, {4850,0.000161905}, {4900,0.000076190}, {4950,0.000057143}, {5000,0.000109524}, {5050,0.00514}, {5100,0.00800}, {5150,0.00600}, {5200,0.00843}, {5250,0.00629}, {5300,0.00671}, {5350,0.00786}, {5400,0.00629}, {5450,0.00557}, {5500,0.00514}, {5550,0.00329}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00157}, {5850,0.00629}, {5900,0.00343}, {5950,0.00443}, {6000,0.00229}, {6050,0.00171}, {6100,0.00000}, {6150,0.00057}, {6200,0.00000}, {6250,0.00286}, {6300,0.00443}, {6350,0.00343}, {6400,0.00686}, {6450,0.00457}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00171}, {6900,0.00057}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00057}, {7300,0.00057}, {7350,0.00000}, {7400,0.00057}, {7450,0.00000}, {7500,0.00057}, {7550,0.00057}, {7600,0.00000}, {7650,0.00057}, {7700,0.00000}, {7750,0.00114}, {7800,0.00100}, {7850,0.00343}, {7900,0.00686}, {7950,0.00386}, {8000,0.00057}, {8050,0.00057}, {8100,0.01000}, {8150,0.00171}, {8200,0.00057}, {8250,0.00000}, {8300,0.00000}, {8350,0.00400}, {8400,0.00343}, {8450,0.00114}, {8500,0.00171}, {8550,0.00000}, {8600,0.00057}, {8650,0.00000}, {8700,0.00000}, {8750,0.00343}, {8800,0.00057}, {8850,0.00000}, {8900,0.00457}, {8950,0.00557}, {9000,0.00743}, {9050,0.00057}, {9100,0.00057}, {9150,0.00786}, {9200,0.00343}, {9250,0.00843}, {9300,0.00114}, {9350,0.00629}, {9400,0.00057}, {9450,0.00171}, {9500,0.00000}, {9550,0.00571}, {9600,0.00057}, {9650,0.00057}, {9700,0.00843}, {9750,0.00286}, {9800,0.00043}, {9850,0.00171}, {9900,0.00114}, {9950,0.00443}, {10000,0.00400}, {10100,0.00000}, {10200,0.00343}, {10300,0.00743}, {10400,0.00343}, {10500,0.00443}, {10600,0.00343}, {10700,0.00857}, {10800,0.00000}, {10900,0.01186}, {11000,0.00514}, {11100,0.00800}, {11200,0.00157}, {11300,0.02100}, {11400,0.00114}, {11500,0.00957}, {11600,0.01943}, {11700,0.00000}, {11800,0.00971}, {11900,0.01014}, {12000,0.00514}, {12100,0.00057}, {12200,0.00057}, {12300,0.00000}, {12400,0.00114}, {12500,0.00114}, {12600,0.00114}, {12700,0.00157}, {12800,0.00057}, {12900,0.00100}, {13000,0.00000}, {13100,0.00057}, {13200,0.00229}, {13300,0.00171}, {13400,0.00114}, {13500,0.00114}, {13600,0.00000}, {13700,0.00229}, {13800,0.00057}, {13900,0.00057}, {14000,0.00057}, {14100,0.00000}, {14200,0.00000}, {14300,0.00686}, {14400,0.00286}, {14500,0.01871}, {14600,0.00286}, {14700,0.01529}, {14800,0.01257}, {14900,0.00114}, {15000,0.00671}, {15100,0.00343}, {15200,0.00743}, {15300,0.00114}, {15400,0.00114}, {15500,0.00000}, {15600,0.00000}, {15700,0.00057}, {15800,0.00171}, {15900,0.00057}, {16000,0.00286}, {16100,0.00171}, {16200,0.00671}, {16300,0.00800}, {16400,0.00400}, {16500,0.00171}, {16600,0.00114}, {16700,0.00100}, {16800,0.00114}, {16900,0.00114}, {17000,0.00514}, {17100,0.01700}, {17200,0.00800}, {17300,0.01200}, {17400,0.01200}, {17500,0.01300}, {17600,0.01357}, {17700,0.00686}, {17800,0.00857}, {17900,0.00386}, {18000,0.01771}, {18100,0.00457}, {18200,0.00457}, {18300,0.00743}, {18400,0.00800}, {18500,0.00557}, {18600,0.00686}, {18700,0.01057}, {18800,0.00457}, {18900,0.00686}, {19000,0.00914}, {19100,0.01143}, {19200,0.00971}, {19300,0.02557}, {19400,0.04914}, {19500,0.04443}, {19600,0.03286}, {19700,0.01186}, {19800,0.01143}, {19900,0.00686}, {20000,0.00080}};
data["big"]["beta; Parametricity"]["cbv"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000409524}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000495238}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000019048}, {227,0.000509524}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000009524}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000500000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000047619}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000004762}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000066667}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000095238}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000004762}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000004762}, {469,0.000000000}, {470,0.000004762}, {471,0.000004762}, {472,0.000000000}, {473,0.000004762}, {474,0.000000000}, {475,0.000485714}, {476,0.000000000}, {477,0.000000000}, {478,0.000004762}, {479,0.000004762}, {480,0.000014286}, {481,0.000000000}, {482,0.000004762}, {483,0.000000000}, {484,0.000000000}, {485,0.000009524}, {486,0.000000000}, {487,0.000000000}, {488,0.000014286}, {489,0.000019048}, {490,0.000019048}, {491,0.000014286}, {492,0.000000000}, {493,0.000004762}, {494,0.000014286}, {495,0.000023810}, {496,0.000028571}, {497,0.000009524}, {498,0.000019048}, {499,0.005080952}, {500,0.000033333}, {505,0.000061905}, {510,0.000071429}, {515,0.000142857}, {520,0.005642857}, {525,0.000323810}, {530,0.000376190}, {535,0.000419048}, {540,0.000433333}, {545,0.000461905}, {550,0.000504762}, {555,0.000519048}, {560,0.000533333}, {565,0.000652381}, {570,0.000566667}, {575,0.000638095}, {580,0.000695238}, {585,0.000766667}, {590,0.000828571}, {595,0.000857143}, {600,0.000885714}, {605,0.000900000}, {610,0.000923810}, {615,0.000952381}, {620,0.000971429}, {625,0.000976190}, {630,0.000995238}, {635,0.000990476}, {640,0.000995238}, {645,0.001000000}, {650,0.000990476}, {655,0.000995238}, {660,0.000995238}, {665,0.000995238}, {670,0.001000000}, {675,0.001000000}, {680,0.001000000}, {685,0.001000000}, {690,0.008642857}, {695,0.001000000}, {700,0.001000000}, {705,0.001000000}, {710,0.001000000}, {715,0.001000000}, {720,0.001000000}, {725,0.001214286}, {730,0.001000000}, {735,0.001000000}, {740,0.001000000}, {745,0.001000000}, {750,0.001000000}, {755,0.001000000}, {760,0.001138095}, {765,0.001000000}, {770,0.001000000}, {775,0.001000000}, {780,0.001000000}, {785,0.001000000}, {790,0.001000000}, {795,0.006685714}, {800,0.001000000}, {805,0.001000000}, {810,0.001000000}, {815,0.001000000}, {820,0.001000000}, {825,0.001000000}, {830,0.001000000}, {835,0.001000000}, {840,0.001000000}, {845,0.001000000}, {850,0.001000000}, {855,0.001000000}, {860,0.001619048}, {865,0.001004762}, {870,0.001000000}, {875,0.001000000}, {880,0.001000000}, {885,0.001000000}, {890,0.001000000}, {895,0.001000000}, {900,0.001000000}, {905,0.001000000}, {910,0.001000000}, {915,0.001000000}, {920,0.001000000}, {925,0.001000000}, {930,0.001376190}, {935,0.001004762}, {940,0.001000000}, {945,0.001000000}, {950,0.001000000}, {955,0.001009524}, {960,0.001000000}, {965,0.001004762}, {970,0.001014286}, {975,0.001009524}, {980,0.001019048}, {985,0.001276190}, {990,0.001066667}, {995,0.001095238}, {1000,0.001085714}, {1010,0.001161905}, {1020,0.001223810}, {1030,0.001309524}, {1040,0.001323810}, {1050,0.014266667}, {1060,0.001428571}, {1070,0.001452381}, {1080,0.001480952}, {1090,0.001509524}, {1100,0.001533333}, {1110,0.001561905}, {1120,0.001580952}, {1130,0.001623810}, {1140,0.001647619}, {1150,0.001680952}, {1160,0.001714286}, {1170,0.001785714}, {1180,0.001833333}, {1190,0.003419048}, {1200,0.001890476}, {1210,0.001919048}, {1220,0.001923810}, {1230,0.001980952}, {1240,0.001995238}, {1250,0.002000000}, {1260,0.002000000}, {1270,0.002000000}, {1280,0.002000000}, {1290,0.002000000}, {1300,0.002000000}, {1310,0.002000000}, {1320,0.002000000}, {1330,0.002000000}, {1340,0.002000000}, {1350,0.002000000}, {1360,0.002000000}, {1370,0.002000000}, {1380,0.002000000}, {1390,0.002000000}, {1400,0.002004762}, {1410,0.002000000}, {1420,0.002004762}, {1430,0.002004762}, {1440,0.002014286}, {1450,0.002014286}, {1460,0.002028571}, {1470,0.002333333}, {1480,0.002047619}, {1490,0.002090476}, {1500,0.002138095}, {1510,0.002157143}, {1520,0.002214286}, {1530,0.002271429}, {1540,0.002295238}, {1550,0.002357143}, {1560,0.002361905}, {1570,0.002400000}, {1580,0.002414286}, {1590,0.002457143}, {1600,0.002485714}, {1610,0.021771429}, {1620,0.002514286}, {1630,0.002519048}, {1640,0.002538095}, {1650,0.002561905}, {1660,0.002576190}, {1670,0.002609524}, {1680,0.002623810}, {1690,0.002661905}, {1700,0.002709524}, {1710,0.002747619}, {1720,0.002780952}, {1730,0.002809524}, {1740,0.002852381}, {1750,0.002885714}, {1760,0.002895238}, {1770,0.002909524}, {1780,0.002933333}, {1790,0.002942857}, {1800,0.002947619}, {1810,0.002980952}, {1820,0.007190476}, {1830,0.002990476}, {1840,0.003000000}, {1850,0.003004762}, {1860,0.003004762}, {1870,0.003371429}, {1880,0.003000000}, {1890,0.003004762}, {1900,0.003000000}, {1910,0.003014286}, {1920,0.003014286}, {1930,0.003014286}, {1940,0.003090476}, {1950,0.003033333}, {1960,0.003042857}, {1970,0.003080952}, {1980,0.003080952}, {1990,0.003152381}, {2000,0.003147619}, {2050,0.003361905}, {2100,0.003461905}, {2150,0.003538095}, {2200,0.003604762}, {2250,0.003733333}, {2300,0.003890476}, {2350,0.003938095}, {2400,0.003990476}, {2450,0.004076190}, {2500,0.004209524}, {2550,0.004342857}, {2600,0.004428571}, {2650,0.004495238}, {2700,0.004566667}, {2750,0.004609524}, {2800,0.004785714}, {2850,0.004900000}, {2900,0.004971429}, {2950,0.005057143}, {3000,0.005228571}, {3050,0.006271429}, {3100,0.005395238}, {3150,0.005504762}, {3200,0.005542857}, {3250,0.005604762}, {3300,0.005704762}, {3350,0.043509524}, {3400,0.005966667}, {3450,0.006023810}, {3500,0.006280952}, {3550,0.006371429}, {3600,0.006433333}, {3650,0.006457143}, {3700,0.013495238}, {3750,0.006585714}, {3800,0.007528571}, {3850,0.006819048}, {3900,0.006909524}, {3950,0.007085714}, {4000,0.007190476}, {4050,0.007338095}, {4100,0.007414286}, {4150,0.007461905}, {4200,0.007500000}, {4250,0.007590476}, {4300,0.007619048}, {4350,0.007733333}, {4400,0.023866667}, {4450,0.018504762}, {4500,0.008190476}, {4550,0.043061905}, {4600,0.008376190}, {4650,0.008490476}, {4700,0.052357143}, {4750,0.008561905}, {4800,0.015433333}, {4850,0.008695238}, {4900,0.014590476}, {4950,0.010166667}, {5000,0.009166667}, {5050,0.02857}, {5100,0.00914}, {5150,0.00929}, {5200,0.00943}, {5250,0.00943}, {5300,0.02100}, {5350,0.02014}, {5400,0.01857}, {5450,0.01814}, {5500,0.01543}, {5550,0.01257}, {5600,0.01629}, {5650,0.01043}, {5700,0.01057}, {5750,0.01057}, {5800,0.01943}, {5850,0.01629}, {5900,0.01086}, {5950,0.01114}, {6000,0.01129}, {6050,0.01129}, {6100,0.01529}, {6150,0.02114}, {6200,0.01157}, {6250,0.01171}, {6300,0.01157}, {6350,0.01200}, {6400,0.01200}, {6450,0.01200}, {6500,0.01200}, {6550,0.01229}, {6600,0.01243}, {6650,0.01243}, {6700,0.01257}, {6750,0.02529}, {6800,0.01671}, {6850,0.01300}, {6900,0.01286}, {6950,0.01329}, {7000,0.01314}, {7050,0.01329}, {7100,0.02371}, {7150,0.01343}, {7200,0.01386}, {7250,0.01371}, {7300,0.02871}, {7350,0.01414}, {7400,0.01400}, {7450,0.01414}, {7500,0.02171}, {7550,0.01429}, {7600,0.01457}, {7650,0.01457}, {7700,0.01486}, {7750,0.01486}, {7800,0.01486}, {7850,0.01500}, {7900,0.01486}, {7950,0.01500}, {8000,0.01914}, {8050,0.01557}, {8100,0.01971}, {8150,0.01543}, {8200,0.01571}, {8250,0.01614}, {8300,0.01586}, {8350,0.01571}, {8400,0.01614}, {8450,0.02771}, {8500,0.01643}, {8550,0.01614}, {8600,0.02957}, {8650,0.01657}, {8700,0.01686}, {8750,0.03157}, {8800,0.01700}, {8850,0.01686}, {8900,0.01714}, {8950,0.02929}, {9000,0.01714}, {9050,0.01700}, {9100,0.01729}, {9150,0.01700}, {9200,0.02571}, {9250,0.03757}, {9300,0.01800}, {9350,0.01757}, {9400,0.01786}, {9450,0.03686}, {9500,0.04829}, {9550,0.03800}, {9600,0.04686}, {9650,0.03671}, {9700,0.04043}, {9750,0.01857}, {9800,0.03914}, {9850,0.01900}, {9900,0.03786}, {9950,0.04443}, {10000,0.01900}, {10100,0.03529}, {10200,0.01943}, {10300,0.05743}, {10400,0.04429}, {10500,0.02814}, {10600,0.04029}, {10700,0.05243}, {10800,0.03471}, {10900,0.03314}, {11000,0.04500}, {11100,0.03071}, {11200,0.04129}, {11300,0.02171}, {11400,0.04529}, {11500,0.02200}, {11600,0.03529}, {11700,0.03614}, {11800,0.03514}, {11900,0.05071}, {12000,0.02286}, {12100,0.02329}, {12200,0.03157}, {12300,0.04957}, {12400,0.02386}, {12500,0.02414}, {12600,0.02414}, {12700,0.02443}, {12800,0.02471}, {12900,0.02500}, {13000,0.02500}, {13100,0.02529}, {13200,0.02557}, {13300,0.02557}, {13400,0.02600}, {13500,0.02629}, {13600,0.04914}, {13700,0.03386}, {13800,0.02686}, {13900,0.02729}, {14000,0.04700}, {14100,0.02729}, {14200,0.02757}, {14300,0.04443}, {14400,0.02800}, {14500,0.04757}, {14600,0.02814}, {14700,0.04614}, {14800,0.02857}, {14900,0.03600}, {15000,0.05429}, {15100,0.06343}, {15200,0.07757}, {15300,0.09029}, {15400,0.06486}, {15500,0.03000}, {15600,0.07886}, {15700,0.08043}, {15800,0.08814}, {15900,0.05843}, {16000,0.06129}, {16100,0.05171}, {16200,0.06043}, {16300,0.05914}, {16400,0.04986}, {16500,0.09000}, {16600,0.09229}, {16700,0.07229}, {16800,0.05829}, {16900,0.05500}, {17000,0.04529}, {17100,0.06857}, {17200,0.04457}, {17300,0.03300}, {17400,0.05743}, {17500,0.04400}, {17600,0.09514}, {17700,0.04143}, {17800,0.04129}, {17900,0.03400}, {18000,0.07471}, {18100,0.03543}, {18200,0.05743}, {18300,0.03571}, {18400,0.03586}, {18500,0.05086}, {18600,0.03629}, {18700,0.03643}, {18800,0.03671}, {18900,0.05400}, {19000,0.06157}, {19100,0.07257}, {19200,0.07600}, {19300,0.03743}, {19400,0.03771}, {19500,0.03814}, {19600,0.07786}, {19700,0.07486}, {19800,0.07257}, {19900,0.05657}, {20000,0.05220}};
data["big"]["beta; Parametricity"]["cbv"]["user"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000052381}, {4,0.000061905}, {5,0.000033333}, {6,0.000000000}, {7,0.000061905}, {8,0.000033333}, {9,0.000000000}, {10,0.000066667}, {11,0.000033333}, {12,0.000028571}, {13,0.000052381}, {14,0.000038095}, {15,0.000047619}, {16,0.000028571}, {17,0.000014286}, {18,0.000057143}, {19,0.000042857}, {20,0.000028571}, {21,0.000085714}, {22,0.000076190}, {23,0.000000000}, {24,0.000061905}, {25,0.000033333}, {26,0.000114286}, {27,0.000071429}, {28,0.000066667}, {29,0.000028571}, {30,0.000071429}, {31,0.000057143}, {32,0.000095238}, {33,0.000052381}, {34,0.000080952}, {35,0.000047619}, {36,0.000019048}, {37,0.000061905}, {38,0.000028571}, {39,0.000033333}, {40,0.000114286}, {41,0.000057143}, {42,0.000180952}, {43,0.000100000}, {44,0.000071429}, {45,0.000114286}, {46,0.000119048}, {47,0.000119048}, {48,0.000104762}, {49,0.000061905}, {50,0.000085714}, {51,0.000052381}, {52,0.000114286}, {53,0.000080952}, {54,0.000085714}, {55,0.000085714}, {56,0.000100000}, {57,0.000157143}, {58,0.000047619}, {59,0.000190476}, {60,0.000157143}, {61,0.000147619}, {62,0.000090476}, {63,0.000076190}, {64,0.000176190}, {65,0.000147619}, {66,0.000100000}, {67,0.000133333}, {68,0.000061905}, {69,0.000171429}, {70,0.000161905}, {71,0.000157143}, {72,0.000109524}, {73,0.000119048}, {74,0.000142857}, {75,0.000138095}, {76,0.000147619}, {77,0.000142857}, {78,0.000180952}, {79,0.000109524}, {80,0.000152381}, {81,0.000180952}, {82,0.000119048}, {83,0.000152381}, {84,0.000147619}, {85,0.000161905}, {86,0.000128571}, {87,0.000142857}, {88,0.000123810}, {89,0.000133333}, {90,0.000061905}, {91,0.000142857}, {92,0.000057143}, {93,0.000157143}, {94,0.000061905}, {95,0.000176190}, {96,0.000142857}, {97,0.000133333}, {98,0.000157143}, {99,0.000166667}, {100,0.000200000}, {101,0.000200000}, {102,0.000138095}, {103,0.000223810}, {104,0.000119048}, {105,0.000519048}, {106,0.000161905}, {107,0.000119048}, {108,0.000195238}, {109,0.000166667}, {110,0.000157143}, {111,0.000161905}, {112,0.000180952}, {113,0.000209524}, {114,0.000304762}, {115,0.000228571}, {116,0.000271429}, {117,0.000180952}, {118,0.000290476}, {119,0.000242857}, {120,0.000233333}, {121,0.000171429}, {122,0.000209524}, {123,0.000185714}, {124,0.000176190}, {125,0.000161905}, {126,0.000180952}, {127,0.000138095}, {128,0.000152381}, {129,0.000190476}, {130,0.000204762}, {131,0.000233333}, {132,0.000280952}, {133,0.000195238}, {134,0.000338095}, {135,0.000195238}, {136,0.000228571}, {137,0.000161905}, {138,0.000214286}, {139,0.000219048}, {140,0.000128571}, {141,0.000247619}, {142,0.000290476}, {143,0.000176190}, {144,0.000285714}, {145,0.000261905}, {146,0.000157143}, {147,0.000176190}, {148,0.000238095}, {149,0.000290476}, {150,0.000171429}, {151,0.000228571}, {152,0.000195238}, {153,0.000123810}, {154,0.000233333}, {155,0.000376190}, {156,0.000195238}, {157,0.000271429}, {158,0.000166667}, {159,0.000195238}, {160,0.000276190}, {161,0.000128571}, {162,0.000247619}, {163,0.000219048}, {164,0.000309524}, {165,0.000200000}, {166,0.000190476}, {167,0.000085714}, {168,0.000314286}, {169,0.000247619}, {170,0.000433333}, {171,0.000300000}, {172,0.000285714}, {173,0.000190476}, {174,0.000242857}, {175,0.000438095}, {176,0.000319048}, {177,0.000333333}, {178,0.000323810}, {179,0.000266667}, {180,0.000380952}, {181,0.000333333}, {182,0.000300000}, {183,0.000300000}, {184,0.000195238}, {185,0.000380952}, {186,0.000480952}, {187,0.000252381}, {188,0.000285714}, {189,0.000204762}, {190,0.000200000}, {191,0.000233333}, {192,0.000342857}, {193,0.000233333}, {194,0.000209524}, {195,0.000266667}, {196,0.000261905}, {197,0.000352381}, {198,0.000290476}, {199,0.000271429}, {200,0.000285714}, {201,0.000371429}, {202,0.000342857}, {203,0.000290476}, {204,0.000333333}, {205,0.000280952}, {206,0.000371429}, {207,0.000319048}, {208,0.000323810}, {209,0.000323810}, {210,0.000180952}, {211,0.000385714}, {212,0.000900000}, {213,0.000452381}, {214,0.000457143}, {215,0.000290476}, {216,0.000261905}, {217,0.000400000}, {218,0.000361905}, {219,0.000347619}, {220,0.000204762}, {221,0.000428571}, {222,0.000261905}, {223,0.000242857}, {224,0.000352381}, {225,0.000366667}, {226,0.000319048}, {227,0.000609524}, {228,0.000276190}, {229,0.000276190}, {230,0.000352381}, {231,0.000428571}, {232,0.000228571}, {233,0.000333333}, {234,0.000319048}, {235,0.000390476}, {236,0.000271429}, {237,0.000466667}, {238,0.000314286}, {239,0.000271429}, {240,0.000309524}, {241,0.000300000}, {242,0.000300000}, {243,0.000309524}, {244,0.000409524}, {245,0.000366667}, {246,0.000395238}, {247,0.000295238}, {248,0.000376190}, {249,0.000409524}, {250,0.000361905}, {251,0.000309524}, {252,0.000571429}, {253,0.000347619}, {254,0.000519048}, {255,0.000366667}, {256,0.000423810}, {257,0.000428571}, {258,0.000366667}, {259,0.000500000}, {260,0.000400000}, {261,0.000390476}, {262,0.000509524}, {263,0.000342857}, {264,0.000547619}, {265,0.000466667}, {266,0.000390476}, {267,0.000457143}, {268,0.000561905}, {269,0.000300000}, {270,0.000909524}, {271,0.000390476}, {272,0.000428571}, {273,0.000314286}, {274,0.000471429}, {275,0.000395238}, {276,0.000423810}, {277,0.000442857}, {278,0.000504762}, {279,0.000433333}, {280,0.000566667}, {281,0.000395238}, {282,0.000309524}, {283,0.000647619}, {284,0.000314286}, {285,0.000357143}, {286,0.000342857}, {287,0.000428571}, {288,0.000423810}, {289,0.000395238}, {290,0.000495238}, {291,0.000357143}, {292,0.000414286}, {293,0.000557143}, {294,0.000476190}, {295,0.000485714}, {296,0.000433333}, {297,0.000619048}, {298,0.000685714}, {299,0.000600000}, {300,0.000485714}, {301,0.000538095}, {302,0.000466667}, {303,0.000652381}, {304,0.000457143}, {305,0.000442857}, {306,0.000457143}, {307,0.000328571}, {308,0.000542857}, {309,0.000500000}, {310,0.000480952}, {311,0.000504762}, {312,0.000585714}, {313,0.000390476}, {314,0.000609524}, {315,0.000438095}, {316,0.000471429}, {317,0.000538095}, {318,0.000523810}, {319,0.000585714}, {320,0.000538095}, {321,0.000576190}, {322,0.000480952}, {323,0.000514286}, {324,0.000490476}, {325,0.000452381}, {326,0.000690476}, {327,0.000466667}, {328,0.000485714}, {329,0.000619048}, {330,0.000433333}, {331,0.000509524}, {332,0.000504762}, {333,0.000428571}, {334,0.000647619}, {335,0.000580952}, {336,0.000447619}, {337,0.000390476}, {338,0.000585714}, {339,0.000485714}, {340,0.000542857}, {341,0.000600000}, {342,0.000323810}, {343,0.000447619}, {344,0.000666667}, {345,0.000500000}, {346,0.000585714}, {347,0.000480952}, {348,0.000542857}, {349,0.000519048}, {350,0.000533333}, {351,0.000680952}, {352,0.000576190}, {353,0.000438095}, {354,0.000414286}, {355,0.000523810}, {356,0.000447619}, {357,0.000447619}, {358,0.000623810}, {359,0.000542857}, {360,0.000357143}, {361,0.000576190}, {362,0.000533333}, {363,0.000547619}, {364,0.000533333}, {365,0.000623810}, {366,0.000485714}, {367,0.000580952}, {368,0.000547619}, {369,0.000666667}, {370,0.000595238}, {371,0.000680952}, {372,0.000561905}, {373,0.000628571}, {374,0.000628571}, {375,0.000576190}, {376,0.000509524}, {377,0.000500000}, {378,0.000576190}, {379,0.000709524}, {380,0.000666667}, {381,0.000676190}, {382,0.000647619}, {383,0.000538095}, {384,0.000504762}, {385,0.000661905}, {386,0.000571429}, {387,0.000533333}, {388,0.000576190}, {389,0.000433333}, {390,0.000414286}, {391,0.000476190}, {392,0.000714286}, {393,0.000685714}, {394,0.000485714}, {395,0.000557143}, {396,0.000633333}, {397,0.000657143}, {398,0.000485714}, {399,0.000685714}, {400,0.000628571}, {401,0.000614286}, {402,0.000500000}, {403,0.000600000}, {404,0.000633333}, {405,0.000738095}, {406,0.000528571}, {407,0.000628571}, {408,0.000642857}, {409,0.000571429}, {410,0.000661905}, {411,0.000604762}, {412,0.000466667}, {413,0.000700000}, {414,0.000633333}, {415,0.000585714}, {416,0.000638095}, {417,0.000580952}, {418,0.000800000}, {419,0.000600000}, {420,0.000647619}, {421,0.000695238}, {422,0.000657143}, {423,0.000576190}, {424,0.000652381}, {425,0.000457143}, {426,0.000600000}, {427,0.000776190}, {428,0.000819048}, {429,0.000642857}, {430,0.000514286}, {431,0.000676190}, {432,0.000557143}, {433,0.000638095}, {434,0.000647619}, {435,0.000652381}, {436,0.000580952}, {437,0.000576190}, {438,0.000642857}, {439,0.000971429}, {440,0.000614286}, {441,0.000600000}, {442,0.000666667}, {443,0.000652381}, {444,0.000566667}, {445,0.000733333}, {446,0.000723810}, {447,0.000795238}, {448,0.000790476}, {449,0.000647619}, {450,0.000857143}, {451,0.000752381}, {452,0.000666667}, {453,0.000766667}, {454,0.000695238}, {455,0.000671429}, {456,0.000738095}, {457,0.000595238}, {458,0.000847619}, {459,0.000704762}, {460,0.000771429}, {461,0.000757143}, {462,0.000652381}, {463,0.000761905}, {464,0.000490476}, {465,0.000652381}, {466,0.000771429}, {467,0.000719048}, {468,0.000647619}, {469,0.000738095}, {470,0.000757143}, {471,0.000585714}, {472,0.000657143}, {473,0.000695238}, {474,0.000676190}, {475,0.001028571}, {476,0.000628571}, {477,0.000766667}, {478,0.000628571}, {479,0.000695238}, {480,0.000600000}, {481,0.000842857}, {482,0.000666667}, {483,0.000723810}, {484,0.000528571}, {485,0.000647619}, {486,0.000761905}, {487,0.000542857}, {488,0.000790476}, {489,0.000866667}, {490,0.000704762}, {491,0.000747619}, {492,0.000538095}, {493,0.000657143}, {494,0.000800000}, {495,0.000642857}, {496,0.000690476}, {497,0.000738095}, {498,0.000795238}, {499,0.005757143}, {500,0.000628571}, {505,0.000833333}, {510,0.000619048}, {515,0.000828571}, {520,0.006195238}, {525,0.000685714}, {530,0.000900000}, {535,0.000780952}, {540,0.000785714}, {545,0.000900000}, {550,0.000823810}, {555,0.000757143}, {560,0.000890476}, {565,0.000733333}, {570,0.000866667}, {575,0.000947619}, {580,0.000952381}, {585,0.000928571}, {590,0.000766667}, {595,0.001009524}, {600,0.000914286}, {605,0.000890476}, {610,0.000700000}, {615,0.000966667}, {620,0.000880952}, {625,0.000980952}, {630,0.000828571}, {635,0.001109524}, {640,0.000785714}, {645,0.000966667}, {650,0.001028571}, {655,0.001009524}, {660,0.000776190}, {665,0.000785714}, {670,0.000842857}, {675,0.001071429}, {680,0.000895238}, {685,0.000923810}, {690,0.008614286}, {695,0.001119048}, {700,0.001000000}, {705,0.001090476}, {710,0.001066667}, {715,0.001090476}, {720,0.001047619}, {725,0.001400000}, {730,0.001042857}, {735,0.001061905}, {740,0.000942857}, {745,0.001161905}, {750,0.001104762}, {755,0.001023810}, {760,0.001228571}, {765,0.001123810}, {770,0.001152381}, {775,0.001238095}, {780,0.001152381}, {785,0.001057143}, {790,0.001171429}, {795,0.006895238}, {800,0.001176190}, {805,0.001357143}, {810,0.001033333}, {815,0.001047619}, {820,0.001185714}, {825,0.001223810}, {830,0.001371429}, {835,0.001328571}, {840,0.001209524}, {845,0.001233333}, {850,0.001176190}, {855,0.001200000}, {860,0.001814286}, {865,0.001504762}, {870,0.001357143}, {875,0.001233333}, {880,0.001504762}, {885,0.001433333}, {890,0.001338095}, {895,0.001523810}, {900,0.001523810}, {905,0.001238095}, {910,0.001576190}, {915,0.001266667}, {920,0.001438095}, {925,0.001400000}, {930,0.001661905}, {935,0.001247619}, {940,0.001571429}, {945,0.001504762}, {950,0.001585714}, {955,0.001552381}, {960,0.001461905}, {965,0.001471429}, {970,0.001476190}, {975,0.001542857}, {980,0.001285714}, {985,0.001814286}, {990,0.001247619}, {995,0.001490476}, {1000,0.001547619}, {1010,0.001642857}, {1020,0.001476190}, {1030,0.001490476}, {1040,0.001561905}, {1050,0.014371429}, {1060,0.001676190}, {1070,0.001480952}, {1080,0.001523810}, {1090,0.001700000}, {1100,0.001661905}, {1110,0.001500000}, {1120,0.001604762}, {1130,0.001809524}, {1140,0.001947619}, {1150,0.001752381}, {1160,0.001504762}, {1170,0.001528571}, {1180,0.001842857}, {1190,0.003209524}, {1200,0.001738095}, {1210,0.001876190}, {1220,0.001852381}, {1230,0.001900000}, {1240,0.001766667}, {1250,0.001876190}, {1260,0.001823810}, {1270,0.001852381}, {1280,0.002076190}, {1290,0.001738095}, {1300,0.001795238}, {1310,0.001890476}, {1320,0.001990476}, {1330,0.001942857}, {1340,0.001995238}, {1350,0.001914286}, {1360,0.001861905}, {1370,0.002047619}, {1380,0.002080952}, {1390,0.002109524}, {1400,0.002166667}, {1410,0.002109524}, {1420,0.002319048}, {1430,0.002180952}, {1440,0.002009524}, {1450,0.002019048}, {1460,0.002304762}, {1470,0.002633333}, {1480,0.002352381}, {1490,0.002066667}, {1500,0.002476190}, {1510,0.002204762}, {1520,0.002133333}, {1530,0.002480952}, {1540,0.002366667}, {1550,0.002247619}, {1560,0.002423810}, {1570,0.002366667}, {1580,0.002404762}, {1590,0.002528571}, {1600,0.002700000}, {1610,0.021704762}, {1620,0.002419048}, {1630,0.002590476}, {1640,0.002485714}, {1650,0.002500000}, {1660,0.002628571}, {1670,0.002561905}, {1680,0.002604762}, {1690,0.002676190}, {1700,0.002585714}, {1710,0.002619048}, {1720,0.002571429}, {1730,0.002685714}, {1740,0.002704762}, {1750,0.002666667}, {1760,0.002657143}, {1770,0.002719048}, {1780,0.002780952}, {1790,0.002676190}, {1800,0.002690476}, {1810,0.002823810}, {1820,0.007323810}, {1830,0.002757143}, {1840,0.002938095}, {1850,0.002766667}, {1860,0.002795238}, {1870,0.003319048}, {1880,0.002842857}, {1890,0.003114286}, {1900,0.002909524}, {1910,0.002966667}, {1920,0.002947619}, {1930,0.002985714}, {1940,0.003047619}, {1950,0.003138095}, {1960,0.003104762}, {1970,0.003009524}, {1980,0.003133333}, {1990,0.003166667}, {2000,0.003133333}, {2050,0.003228571}, {2100,0.003314286}, {2150,0.003390476}, {2200,0.003328571}, {2250,0.003561905}, {2300,0.003785714}, {2350,0.003823810}, {2400,0.003909524}, {2450,0.003914286}, {2500,0.004190476}, {2550,0.003976190}, {2600,0.004228571}, {2650,0.004500000}, {2700,0.004661905}, {2750,0.004590476}, {2800,0.004800000}, {2850,0.004866667}, {2900,0.004790476}, {2950,0.004890476}, {3000,0.004980952}, {3050,0.006290476}, {3100,0.005261905}, {3150,0.005333333}, {3200,0.005657143}, {3250,0.005790476}, {3300,0.005738095}, {3350,0.043652381}, {3400,0.006147619}, {3450,0.006085714}, {3500,0.006214286}, {3550,0.006290476}, {3600,0.006428571}, {3650,0.006571429}, {3700,0.013476190}, {3750,0.006528571}, {3800,0.007580952}, {3850,0.007085714}, {3900,0.007204762}, {3950,0.007171429}, {4000,0.007171429}, {4050,0.007338095}, {4100,0.007538095}, {4150,0.007571429}, {4200,0.007566667}, {4250,0.007804762}, {4300,0.007933333}, {4350,0.007857143}, {4400,0.023785714}, {4450,0.018623810}, {4500,0.008476190}, {4550,0.043152381}, {4600,0.008614286}, {4650,0.008690476}, {4700,0.052266667}, {4750,0.008919048}, {4800,0.015476190}, {4850,0.008952381}, {4900,0.014904762}, {4950,0.010366667}, {5000,0.009028571}, {5050,0.02914}, {5100,0.00986}, {5150,0.01043}, {5200,0.00943}, {5250,0.00914}, {5300,0.02114}, {5350,0.02086}, {5400,0.01786}, {5450,0.01857}, {5500,0.01500}, {5550,0.01214}, {5600,0.01600}, {5650,0.01129}, {5700,0.01057}, {5750,0.01071}, {5800,0.01900}, {5850,0.01743}, {5900,0.01057}, {5950,0.01071}, {6000,0.01071}, {6050,0.01186}, {6100,0.01543}, {6150,0.02157}, {6200,0.01200}, {6250,0.01171}, {6300,0.01243}, {6350,0.01300}, {6400,0.01200}, {6450,0.01257}, {6500,0.01257}, {6550,0.01243}, {6600,0.01357}, {6650,0.01286}, {6700,0.01243}, {6750,0.02486}, {6800,0.01686}, {6850,0.01357}, {6900,0.01357}, {6950,0.01343}, {7000,0.01286}, {7050,0.01343}, {7100,0.02343}, {7150,0.01286}, {7200,0.01243}, {7250,0.01471}, {7300,0.02929}, {7350,0.01343}, {7400,0.01357}, {7450,0.01443}, {7500,0.02186}, {7550,0.01486}, {7600,0.01457}, {7650,0.01471}, {7700,0.01457}, {7750,0.01486}, {7800,0.01500}, {7850,0.01429}, {7900,0.01500}, {7950,0.01429}, {8000,0.01786}, {8050,0.01643}, {8100,0.01914}, {8150,0.01629}, {8200,0.01600}, {8250,0.01714}, {8300,0.01629}, {8350,0.01586}, {8400,0.01543}, {8450,0.02700}, {8500,0.01671}, {8550,0.01657}, {8600,0.03000}, {8650,0.01629}, {8700,0.01657}, {8750,0.03157}, {8800,0.01714}, {8850,0.01671}, {8900,0.01743}, {8950,0.02914}, {9000,0.01729}, {9050,0.01671}, {9100,0.01743}, {9150,0.01814}, {9200,0.02429}, {9250,0.03700}, {9300,0.01857}, {9350,0.01800}, {9400,0.01771}, {9450,0.03586}, {9500,0.04829}, {9550,0.03829}, {9600,0.04643}, {9650,0.03786}, {9700,0.04057}, {9750,0.01857}, {9800,0.03957}, {9850,0.01886}, {9900,0.03729}, {9950,0.04386}, {10000,0.01929}, {10100,0.03629}, {10200,0.01871}, {10300,0.05800}, {10400,0.04486}, {10500,0.02857}, {10600,0.04000}, {10700,0.05286}, {10800,0.03414}, {10900,0.03314}, {11000,0.04514}, {11100,0.03014}, {11200,0.04200}, {11300,0.02271}, {11400,0.04557}, {11500,0.02200}, {11600,0.03457}, {11700,0.03529}, {11800,0.03614}, {11900,0.05057}, {12000,0.02329}, {12100,0.02386}, {12200,0.03214}, {12300,0.04900}, {12400,0.02529}, {12500,0.02429}, {12600,0.02500}, {12700,0.02500}, {12800,0.02443}, {12900,0.02571}, {13000,0.02571}, {13100,0.02514}, {13200,0.02571}, {13300,0.02557}, {13400,0.02686}, {13500,0.02686}, {13600,0.05000}, {13700,0.03471}, {13800,0.02686}, {13900,0.02629}, {14000,0.04757}, {14100,0.02829}, {14200,0.02757}, {14300,0.04443}, {14400,0.02800}, {14500,0.04686}, {14600,0.02886}, {14700,0.04629}, {14800,0.02943}, {14900,0.03571}, {15000,0.05514}, {15100,0.06357}, {15200,0.07743}, {15300,0.08943}, {15400,0.06414}, {15500,0.03043}, {15600,0.07843}, {15700,0.08129}, {15800,0.08829}, {15900,0.05900}, {16000,0.06086}, {16100,0.05129}, {16200,0.06014}, {16300,0.05986}, {16400,0.05043}, {16500,0.08986}, {16600,0.09243}, {16700,0.07243}, {16800,0.05800}, {16900,0.05529}, {17000,0.04514}, {17100,0.06857}, {17200,0.04486}, {17300,0.03286}, {17400,0.05729}, {17500,0.04429}, {17600,0.09514}, {17700,0.04243}, {17800,0.04343}, {17900,0.03386}, {18000,0.07400}, {18100,0.03557}, {18200,0.05743}, {18300,0.03614}, {18400,0.03629}, {18500,0.05100}, {18600,0.03529}, {18700,0.03629}, {18800,0.03600}, {18900,0.05386}, {19000,0.06057}, {19100,0.07071}, {19200,0.07600}, {19300,0.03686}, {19400,0.03671}, {19500,0.03743}, {19600,0.07643}, {19700,0.07457}, {19800,0.07214}, {19900,0.05629}, {20000,0.05160}};
data["big"]["beta; Parametricity"]["cbv"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000019048}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000038095}, {67,0.000000000}, {68,0.000019048}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000019048}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000019048}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000019048}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000019048}, {133,0.000000000}, {134,0.000000000}, {135,0.000019048}, {136,0.000019048}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000019048}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000019048}, {155,0.000000000}, {156,0.000000000}, {157,0.000019048}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000019048}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000019048}, {176,0.000000000}, {177,0.000000000}, {178,0.000019048}, {179,0.000019048}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000019048}, {191,0.000019048}, {192,0.000019048}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000019048}, {201,0.000019048}, {202,0.000038095}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000019048}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000019048}, {211,0.000019048}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000019048}, {222,0.000019048}, {223,0.000019048}, {224,0.000019048}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000014286}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000019048}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000038095}, {251,0.000000000}, {252,0.000000000}, {253,0.000019048}, {254,0.000019048}, {255,0.000000000}, {256,0.000000000}, {257,0.000019048}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000019048}, {264,0.000019048}, {265,0.000000000}, {266,0.000019048}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000019048}, {273,0.000000000}, {274,0.000019048}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000019048}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000057143}, {286,0.000019048}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000019048}, {293,0.000033333}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000019048}, {302,0.000000000}, {303,0.000000000}, {304,0.000038095}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000019048}, {309,0.000019048}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000019048}, {320,0.000019048}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000019048}, {325,0.000000000}, {326,0.000000000}, {327,0.000019048}, {328,0.000019048}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000019048}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000038095}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000019048}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000019048}, {386,0.000000000}, {387,0.000019048}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000019048}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000019048}, {399,0.000019048}, {400,0.000000000}, {401,0.000019048}, {402,0.000000000}, {403,0.000000000}, {404,0.000019048}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000019048}, {414,0.000000000}, {415,0.000014286}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000019048}, {420,0.000000000}, {421,0.000000000}, {422,0.000019048}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000019048}, {429,0.000019048}, {430,0.000000000}, {431,0.000019048}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000019048}, {438,0.000000000}, {439,0.000019048}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000019048}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000014286}, {450,0.000000000}, {451,0.000019048}, {452,0.000000000}, {453,0.000000000}, {454,0.000019048}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000019048}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000038095}, {467,0.000019048}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000057143}, {472,0.000019048}, {473,0.000019048}, {474,0.000000000}, {475,0.000000000}, {476,0.000014286}, {477,0.000000000}, {478,0.000000000}, {479,0.000038095}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000019048}, {485,0.000019048}, {486,0.000019048}, {487,0.000000000}, {488,0.000000000}, {489,0.000019048}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000019048}, {495,0.000000000}, {496,0.000000000}, {497,0.000019048}, {498,0.000019048}, {499,0.000019048}, {500,0.000000000}, {505,0.000000000}, {510,0.000038095}, {515,0.000000000}, {520,0.000019048}, {525,0.000000000}, {530,0.000000000}, {535,0.000019048}, {540,0.000019048}, {545,0.000000000}, {550,0.000038095}, {555,0.000000000}, {560,0.000000000}, {565,0.000019048}, {570,0.000000000}, {575,0.000000000}, {580,0.000019048}, {585,0.000000000}, {590,0.000057143}, {595,0.000000000}, {600,0.000019048}, {605,0.000019048}, {610,0.000000000}, {615,0.000000000}, {620,0.000014286}, {625,0.000019048}, {630,0.000019048}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000019048}, {670,0.000000000}, {675,0.000000000}, {680,0.000019048}, {685,0.000000000}, {690,0.000090476}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000019048}, {775,0.000000000}, {780,0.000000000}, {785,0.000019048}, {790,0.000019048}, {795,0.000057143}, {800,0.000019048}, {805,0.000019048}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000019048}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000019048}, {860,0.000019048}, {865,0.000019048}, {870,0.000038095}, {875,0.000000000}, {880,0.000019048}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000019048}, {925,0.000019048}, {930,0.000000000}, {935,0.000019048}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000019048}, {970,0.000038095}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000019048}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000019048}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000038095}, {1130,0.000019048}, {1140,0.000019048}, {1150,0.000000000}, {1160,0.000019048}, {1170,0.000019048}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000019048}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000038095}, {1350,0.000019048}, {1360,0.000019048}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000019048}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000019048}, {1490,0.000076190}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000057143}, {1550,0.000000000}, {1560,0.000019048}, {1570,0.000019048}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000228571}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000038095}, {1650,0.000019048}, {1660,0.000019048}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000019048}, {1720,0.000052381}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000019048}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000038095}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000019048}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000019048}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000019048}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000019048}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000019048}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000019048}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000019048}, {3400,0.000019048}, {3450,0.000019048}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000019048}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000019048}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000019048}, {4450,0.000000000}, {4500,0.000019048}, {4550,0.000019048}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000019048}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000019048}, {4900,0.000000000}, {4950,0.000019048}, {5000,0.000000000}, {5050,0.00000}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00043}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00057}, {7350,0.00000}, {7400,0.00057}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00057}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00057}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00057}, {9250,0.00043}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00057}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00057}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00057}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00057}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00057}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big"]["beta; Parametricity"]["eval lazy"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000009524}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000009524}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000004762}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000004762}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000009524}, {281,0.000000000}, {282,0.000019048}, {283,0.000014286}, {284,0.000033333}, {285,0.000052381}, {286,0.000057143}, {287,0.000100000}, {288,0.000119048}, {289,0.000152381}, {290,0.000152381}, {291,0.000242857}, {292,0.000300000}, {293,0.000376190}, {294,0.000452381}, {295,0.000557143}, {296,0.000690476}, {297,0.000766667}, {298,0.000914286}, {299,0.000938095}, {300,0.001000000}, {301,0.001000000}, {302,0.001000000}, {303,0.001000000}, {304,0.001000000}, {305,0.001000000}, {306,0.001000000}, {307,0.001000000}, {308,0.001000000}, {309,0.001495238}, {310,0.001000000}, {311,0.001000000}, {312,0.001000000}, {313,0.001000000}, {314,0.001000000}, {315,0.001000000}, {316,0.001000000}, {317,0.001000000}, {318,0.001000000}, {319,0.001000000}, {320,0.001000000}, {321,0.001000000}, {322,0.001000000}, {323,0.001000000}, {324,0.001000000}, {325,0.001000000}, {326,0.001000000}, {327,0.001000000}, {328,0.001000000}, {329,0.001000000}, {330,0.001000000}, {331,0.001000000}, {332,0.001000000}, {333,0.001000000}, {334,0.001000000}, {335,0.001000000}, {336,0.001000000}, {337,0.001000000}, {338,0.001000000}, {339,0.001000000}, {340,0.001000000}, {341,0.001000000}, {342,0.001000000}, {343,0.001000000}, {344,0.001000000}, {345,0.001000000}, {346,0.001000000}, {347,0.001000000}, {348,0.001000000}, {349,0.001000000}, {350,0.001000000}, {351,0.001000000}, {352,0.001000000}, {353,0.001000000}, {354,0.001000000}, {355,0.001000000}, {356,0.001000000}, {357,0.001000000}, {358,0.001000000}, {359,0.001000000}, {360,0.001000000}, {361,0.001804762}, {362,0.001000000}, {363,0.001000000}, {364,0.001000000}, {365,0.001000000}, {366,0.001000000}, {367,0.001004762}, {368,0.001000000}, {369,0.002028571}, {370,0.001000000}, {371,0.001000000}, {372,0.001000000}, {373,0.001000000}, {374,0.001000000}, {375,0.001000000}, {376,0.001000000}, {377,0.001000000}, {378,0.001000000}, {379,0.001000000}, {380,0.001000000}, {381,0.001000000}, {382,0.001000000}, {383,0.001000000}, {384,0.001000000}, {385,0.001000000}, {386,0.001000000}, {387,0.001000000}, {388,0.001000000}, {389,0.001000000}, {390,0.001000000}, {391,0.001000000}, {392,0.001000000}, {393,0.001000000}, {394,0.001000000}, {395,0.001000000}, {396,0.001000000}, {397,0.001095238}, {398,0.001000000}, {399,0.001000000}, {400,0.001000000}, {401,0.001000000}, {402,0.001000000}, {403,0.001000000}, {404,0.001000000}, {405,0.001000000}, {406,0.001000000}, {407,0.001004762}, {408,0.001000000}, {409,0.001000000}, {410,0.001000000}, {411,0.001000000}, {412,0.001000000}, {413,0.001000000}, {414,0.001000000}, {415,0.001000000}, {416,0.001000000}, {417,0.001014286}, {418,0.001014286}, {419,0.001009524}, {420,0.001023810}, {421,0.001028571}, {422,0.001023810}, {423,0.001061905}, {424,0.001066667}, {425,0.001095238}, {426,0.001128571}, {427,0.001147619}, {428,0.001142857}, {429,0.001276190}, {430,0.001319048}, {431,0.001338095}, {432,0.001390476}, {433,0.001438095}, {434,0.001371429}, {435,0.001528571}, {436,0.001604762}, {437,0.001657143}, {438,0.001680952}, {439,0.001742857}, {440,0.001852381}, {441,0.001895238}, {442,0.001880952}, {443,0.001990476}, {444,0.002000000}, {445,0.008166667}, {446,0.002000000}, {447,0.002000000}, {448,0.002000000}, {449,0.002000000}, {450,0.002000000}, {451,0.002000000}, {452,0.002000000}, {453,0.002000000}, {454,0.002000000}, {455,0.002000000}, {456,0.002000000}, {457,0.002000000}, {458,0.002000000}, {459,0.002000000}, {460,0.002000000}, {461,0.002000000}, {462,0.002000000}, {463,0.002000000}, {464,0.002000000}, {465,0.002000000}, {466,0.002000000}, {467,0.002000000}, {468,0.002000000}, {469,0.002000000}, {470,0.002000000}, {471,0.002000000}, {472,0.002000000}, {473,0.002000000}, {474,0.002000000}, {475,0.002000000}, {476,0.002000000}, {477,0.002000000}, {478,0.002000000}, {479,0.002000000}, {480,0.002000000}, {481,0.002000000}, {482,0.002000000}, {483,0.007638095}, {484,0.002000000}, {485,0.002000000}, {486,0.002000000}, {487,0.002000000}, {488,0.002000000}, {489,0.002000000}, {490,0.002000000}, {491,0.002000000}, {492,0.002000000}, {493,0.002000000}, {494,0.002000000}, {495,0.002000000}, {496,0.002000000}, {497,0.002000000}, {498,0.002000000}, {499,0.002000000}, {500,0.002000000}, {505,0.002000000}, {510,0.002000000}, {515,0.002123810}, {520,0.002000000}, {525,0.003385714}, {530,0.002133333}, {535,0.002238095}, {540,0.002371429}, {545,0.002580952}, {550,0.002828571}, {555,0.002966667}, {560,0.003000000}, {565,0.003000000}, {570,0.003000000}, {575,0.003000000}, {580,0.003000000}, {585,0.003000000}, {590,0.003000000}, {595,0.003000000}, {600,0.003000000}, {605,0.003004762}, {610,0.003028571}, {615,0.003100000}, {620,0.003200000}, {625,0.003257143}, {630,0.004680952}, {635,0.003452381}, {640,0.003676190}, {645,0.003890476}, {650,0.004000000}, {655,0.004000000}, {660,0.004000000}, {665,0.004000000}, {670,0.004000000}, {675,0.004004762}, {680,0.004009524}, {685,0.004085714}, {690,0.004176190}, {695,0.004261905}, {700,0.004276190}, {705,0.004309524}, {710,0.004323810}, {715,0.004361905}, {720,0.004561905}, {725,0.004680952}, {730,0.004976190}, {735,0.005000000}, {740,0.005180952}, {745,0.005061905}, {750,0.005147619}, {755,0.005242857}, {760,0.005280952}, {765,0.005314286}, {770,0.005314286}, {775,0.005314286}, {780,0.005328571}, {785,0.005338095}, {790,0.005400000}, {795,0.005671429}, {800,0.005990476}, {805,0.006200000}, {810,0.006276190}, {815,0.006304762}, {820,0.006328571}, {825,0.006328571}, {830,0.006328571}, {835,0.006328571}, {840,0.011223810}, {845,0.006409524}, {850,0.006509524}, {855,0.006614286}, {860,0.006795238}, {865,0.007047619}, {870,0.007228571}, {875,0.010404762}, {880,0.007338095}, {885,0.007371429}, {890,0.007495238}, {895,0.007571429}, {900,0.022314286}, {905,0.007661905}, {910,0.008047619}, {915,0.007661905}, {920,0.007738095}, {925,0.007971429}, {930,0.008223810}, {935,0.008538095}, {940,0.008623810}, {945,0.008647619}, {950,0.008638095}, {955,0.008657143}, {960,0.008700000}, {965,0.008804762}, {970,0.023780952}, {975,0.008961905}, {980,0.009071429}, {985,0.009119048}, {990,0.009476190}, {995,0.009704762}, {1000,0.009838095}, {1010,0.009942857}, {1020,0.009966667}, {1030,0.010138095}, {1040,0.010480952}, {1050,0.010914286}, {1060,0.011071429}, {1070,0.011261905}, {1080,0.011319048}, {1090,0.011561905}, {1100,0.012023810}, {1110,0.012333333}, {1120,0.012447619}, {1130,0.012623810}, {1140,0.012785714}, {1150,0.013295238}, {1160,0.013619048}, {1170,0.013738095}, {1180,0.013961905}, {1190,0.014090476}, {1200,0.014738095}, {1210,0.014985714}, {1220,0.015109524}, {1230,0.034438095}, {1240,0.015661905}, {1250,0.016233333}, {1260,0.016347619}, {1270,0.016552381}, {1280,0.016923810}, {1290,0.017309524}, {1300,0.017642857}, {1310,0.021566667}, {1320,0.018195238}, {1330,0.018657143}, {1340,0.018909524}, {1350,0.019133333}, {1360,0.019538095}, {1370,0.020076190}, {1380,0.025657143}, {1390,0.020819048}, {1400,0.021104762}, {1410,0.021461905}, {1420,0.021723810}, {1430,0.022123810}, {1440,0.022609524}, {1450,0.022785714}, {1460,0.023466667}, {1470,0.023790476}, {1480,0.024180952}, {1490,0.028357143}, {1500,0.025490476}, {1510,0.025609524}, {1520,0.026142857}, {1530,0.026509524}, {1540,0.027161905}, {1550,0.027509524}, {1560,0.028228571}, {1570,0.028614286}, {1580,0.029376190}, {1590,0.029676190}, {1600,0.030428571}, {1610,0.030866667}, {1620,0.031595238}, {1630,0.032119048}, {1640,0.032719048}, {1650,0.033404762}, {1660,0.033909524}, {1670,0.038276190}, {1680,0.035242857}, {1690,0.035780952}, {1700,0.036566667}, {1710,0.037080952}, {1720,0.037685714}, {1730,0.038571429}, {1740,0.039333333}, {1750,0.039876190}, {1760,0.040666667}, {1770,0.041542857}, {1780,0.045838095}, {1790,0.042876190}, {1800,0.043676190}, {1810,0.044557143}, {1820,0.045261905}, {1830,0.046071429}, {1840,0.046757143}, {1850,0.048338095}, {1860,0.048504762}, {1870,0.049119048}, {1880,0.050295238}, {1890,0.050861905}, {1900,0.055828571}, {1910,0.052519048}, {1920,0.053385714}, {1930,0.054347619}, {1940,0.055138095}, {1950,0.056004762}, {1960,0.056947619}, {1970,0.057733333}, {1980,0.058571429}, {1990,0.089057143}, {2000,0.060380952}, {2050,0.064961905}, {2100,0.069495238}, {2150,0.074142857}, {2200,0.079176190}, {2250,0.084214286}, {2300,0.089195238}, {2350,0.094552381}, {2400,0.099714286}, {2450,0.105257143}, {2500,0.110600000}, {2550,0.116380952}, {2600,0.122128571}, {2650,0.127909524}, {2700,0.133852381}, {2750,0.139928571}, {2800,0.146171429}, {2850,0.152514286}, {2900,0.158690476}, {2950,0.165433333}, {3000,0.171909524}, {3050,0.178852381}, {3100,0.185700000}, {3150,0.192685714}, {3200,0.199585714}, {3250,0.206728571}, {3300,0.213942857}, {3350,0.221547619}, {3400,0.229047619}, {3450,0.250152381}, {3500,0.244157143}, {3550,0.252080952}, {3600,0.259938095}, {3650,0.267690476}, {3700,0.276261905}, {3750,0.284238095}, {3800,0.292742857}, {3850,0.301261905}, {3900,0.309600000}, {3950,0.391747619}, {4000,0.327385714}, {4050,0.337747619}, {4100,0.345223810}, {4150,0.383809524}, {4200,0.363738095}, {4250,0.373100000}, {4300,0.382519048}, {4350,0.392176190}, {4400,0.403885714}, {4450,0.411857143}, {4500,0.421814286}, {4550,0.433109524}, {4600,0.441828571}, {4650,0.451890476}, {4700,0.490038095}, {4750,0.472852381}, {4800,0.483633333}, {4850,0.493671429}, {4900,0.504695238}, {4950,0.532057143}, {5000,0.526419048}, {5050,0.62871}, {5100,0.54529}, {5150,0.55686}, {5200,0.56757}, {5250,0.59271}, {5300,0.59071}, {5350,0.60243}, {5400,0.63743}, {5450,0.62657}, {5500,0.63786}, {5550,0.65029}, {5600,0.66700}, {5650,0.67957}, {5700,0.69329}, {5750,0.75429}, {5800,0.74014}, {5850,0.73057}, {5900,0.74343}, {5950,0.75671}, {6000,0.77014}, {6050,0.78300}, {6100,0.79657}, {6150,0.83814}, {6200,0.82486}, {6250,0.83757}, {6300,0.85100}, {6350,0.86471}, {6400,0.88029}, {6450,0.89414}, {6500,0.90743}, {6550,0.92343}, {6600,0.93686}, {6650,0.95143}, {6700,1.02171}, {6750,0.98186}, {6800,0.99686}, {6850,1.01114}, {6900,1.03729}, {6950,1.05200}, {7000,1.06686}, {7050,1.15614}, {7100,1.09829}, {7150,1.11571}, {7200,1.13186}, {7250,1.14600}, {7300,1.16329}, {7350,1.18000}, {7400,1.19629}, {7450,1.24600}, {7500,1.22857}, {7550,1.24700}, {7600,1.28743}, {7650,1.28071}, {7700,1.29714}, {7750,1.31429}, {7800,1.33200}, {7850,1.37171}, {7900,1.36714}, {7950,1.41629}, {8000,1.40129}, {8050,1.44257}, {8100,1.43729}, {8150,1.49457}, {8200,1.47514}, {8250,1.50643}, {8300,1.51243}, {8350,1.53157}, {8400,1.54714}, {8450,1.56771}, {8500,1.59329}, {8550,1.60700}, {8600,1.62529}, {8650,1.66500}, {8700,1.66600}, {8750,1.68543}, {8800,1.70300}, {8850,1.76129}, {8900,1.74371}, {8950,1.76500}, {9000,1.78429}, {9050,1.81900}, {9100,1.82443}, {9150,1.82286}, {9200,1.84371}, {9250,1.86443}, {9300,1.88371}, {9350,1.90471}, {9400,1.92729}, {9450,1.97357}, {9500,2.02271}, {9550,2.03657}, {9600,2.04471}, {9650,2.05686}, {9700,2.12629}, {9750,2.18086}, {9800,2.23686}, {9850,2.25043}, {9900,2.14900}, {9950,2.15829}, {10000,2.18300}, {10100,2.22686}, {10200,2.26871}, {10300,2.31714}, {10400,2.47657}, {10500,2.40286}, {10600,2.45043}, {10700,2.49871}, {10800,2.54671}, {10900,2.59271}, {11000,2.68214}, {11100,2.68857}, {11200,2.73843}, {11300,2.78800}, {11400,2.83643}, {11500,2.88686}, {11600,3.10471}, {11700,3.02571}, {11800,3.07929}, {11900,3.20471}, {12000,3.18357}, {12100,3.23657}, {12200,3.29186}, {12300,3.48386}, {12400,3.39871}, {12500,3.45057}, {12600,3.51129}, {12700,3.56529}, {12800,3.62343}, {12900,3.68129}, {13000,3.74714}, {13100,3.79743}, {13200,3.85529}, {13300,3.91443}, {13400,3.97743}, {13500,4.25943}, {13600,4.09143}, {13700,4.16186}, {13800,4.21714}, {13900,4.51329}, {14000,4.33871}, {14100,4.40829}, {14200,4.64457}, {14300,4.52943}, {14400,4.80586}, {14500,4.65814}, {14600,4.93357}, {14700,4.78614}, {14800,5.06014}, {14900,4.91443}, {15000,4.97829}, {15100,5.31657}, {15200,5.11757}, {15300,5.17471}, {15400,5.24900}, {15500,5.58900}, {15600,5.45671}, {15700,5.52057}, {15800,5.59514}, {15900,5.67400}, {16000,5.73729}, {16100,5.80986}, {16200,5.88643}, {16300,5.96957}, {16400,6.03357}, {16500,6.10771}, {16600,6.18500}, {16700,6.40314}, {16800,6.62871}, {16900,6.40343}, {17000,6.47643}, {17100,6.55400}, {17200,6.68443}, {17300,6.70729}, {17400,6.97986}, {17500,6.86229}, {17600,6.94371}, {17700,7.01814}, {17800,7.09914}, {17900,7.18086}, {18000,7.25800}, {18100,7.33486}, {18200,7.80400}, {18300,7.51014}, {18400,7.58314}, {18500,7.97814}, {18600,7.86000}, {18700,7.83986}, {18800,7.93700}, {18900,8.01171}, {19000,8.22657}, {19100,8.57443}, {19200,8.69943}, {19300,8.76686}, {19400,8.85929}, {19500,8.99329}, {19600,9.05643}, {19700,8.96714}, {19800,8.69014}, {19900,8.78971}, {20000,8.81380}};
data["big"]["beta; Parametricity"]["eval lazy"]["user"] = {{1,0.000019048}, {2,0.000033333}, {3,0.000000000}, {4,0.000014286}, {5,0.000066667}, {6,0.000052381}, {7,0.000014286}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000066667}, {12,0.000123810}, {13,0.000042857}, {14,0.000061905}, {15,0.000000000}, {16,0.000047619}, {17,0.000057143}, {18,0.000028571}, {19,0.000047619}, {20,0.000090476}, {21,0.000061905}, {22,0.000047619}, {23,0.000066667}, {24,0.000104762}, {25,0.000028571}, {26,0.000095238}, {27,0.000028571}, {28,0.000033333}, {29,0.000133333}, {30,0.000076190}, {31,0.000090476}, {32,0.000014286}, {33,0.000100000}, {34,0.000071429}, {35,0.000061905}, {36,0.000014286}, {37,0.000080952}, {38,0.000038095}, {39,0.000042857}, {40,0.000100000}, {41,0.000047619}, {42,0.000061905}, {43,0.000123810}, {44,0.000119048}, {45,0.000066667}, {46,0.000100000}, {47,0.000057143}, {48,0.000180952}, {49,0.000061905}, {50,0.000100000}, {51,0.000095238}, {52,0.000042857}, {53,0.000119048}, {54,0.000114286}, {55,0.000109524}, {56,0.000095238}, {57,0.000066667}, {58,0.000047619}, {59,0.000061905}, {60,0.000133333}, {61,0.000066667}, {62,0.000171429}, {63,0.000119048}, {64,0.000119048}, {65,0.000071429}, {66,0.000061905}, {67,0.000028571}, {68,0.000152381}, {69,0.000076190}, {70,0.000014286}, {71,0.000114286}, {72,0.000166667}, {73,0.000152381}, {74,0.000095238}, {75,0.000109524}, {76,0.000095238}, {77,0.000014286}, {78,0.000100000}, {79,0.000204762}, {80,0.000171429}, {81,0.000109524}, {82,0.000061905}, {83,0.000214286}, {84,0.000180952}, {85,0.000180952}, {86,0.000076190}, {87,0.000128571}, {88,0.000176190}, {89,0.000238095}, {90,0.000195238}, {91,0.000100000}, {92,0.000161905}, {93,0.000228571}, {94,0.000195238}, {95,0.000180952}, {96,0.000128571}, {97,0.000195238}, {98,0.000123810}, {99,0.000176190}, {100,0.000238095}, {101,0.000314286}, {102,0.000214286}, {103,0.000147619}, {104,0.000152381}, {105,0.000204762}, {106,0.000247619}, {107,0.000223810}, {108,0.000176190}, {109,0.000123810}, {110,0.000252381}, {111,0.000261905}, {112,0.000152381}, {113,0.000228571}, {114,0.000228571}, {115,0.000266667}, {116,0.000214286}, {117,0.000290476}, {118,0.000304762}, {119,0.000304762}, {120,0.000133333}, {121,0.000347619}, {122,0.000214286}, {123,0.000295238}, {124,0.000233333}, {125,0.000185714}, {126,0.000180952}, {127,0.000138095}, {128,0.000295238}, {129,0.000271429}, {130,0.000114286}, {131,0.000138095}, {132,0.000228571}, {133,0.000076190}, {134,0.000195238}, {135,0.000242857}, {136,0.000233333}, {137,0.000133333}, {138,0.000257143}, {139,0.000195238}, {140,0.000423810}, {141,0.000304762}, {142,0.000309524}, {143,0.000309524}, {144,0.000247619}, {145,0.000190476}, {146,0.000157143}, {147,0.000366667}, {148,0.000266667}, {149,0.000242857}, {150,0.000238095}, {151,0.000314286}, {152,0.000242857}, {153,0.000366667}, {154,0.000285714}, {155,0.000261905}, {156,0.000238095}, {157,0.000476190}, {158,0.000190476}, {159,0.000309524}, {160,0.000252381}, {161,0.000238095}, {162,0.000409524}, {163,0.000300000}, {164,0.000357143}, {165,0.000366667}, {166,0.000300000}, {167,0.000357143}, {168,0.000476190}, {169,0.000347619}, {170,0.000376190}, {171,0.000195238}, {172,0.000252381}, {173,0.000380952}, {174,0.000314286}, {175,0.000338095}, {176,0.000400000}, {177,0.000285714}, {178,0.000309524}, {179,0.000452381}, {180,0.000423810}, {181,0.000338095}, {182,0.000514286}, {183,0.000490476}, {184,0.000380952}, {185,0.000557143}, {186,0.000442857}, {187,0.000314286}, {188,0.000247619}, {189,0.000380952}, {190,0.000442857}, {191,0.000366667}, {192,0.000304762}, {193,0.000442857}, {194,0.000347619}, {195,0.000333333}, {196,0.000371429}, {197,0.000357143}, {198,0.000342857}, {199,0.000266667}, {200,0.000542857}, {201,0.000519048}, {202,0.000447619}, {203,0.000395238}, {204,0.000380952}, {205,0.000519048}, {206,0.000471429}, {207,0.000419048}, {208,0.000466667}, {209,0.000366667}, {210,0.000504762}, {211,0.000519048}, {212,0.000485714}, {213,0.000595238}, {214,0.000419048}, {215,0.000323810}, {216,0.000571429}, {217,0.000566667}, {218,0.000495238}, {219,0.000523810}, {220,0.000676190}, {221,0.000538095}, {222,0.000400000}, {223,0.000566667}, {224,0.000633333}, {225,0.000528571}, {226,0.000628571}, {227,0.000557143}, {228,0.000585714}, {229,0.000490476}, {230,0.000471429}, {231,0.000480952}, {232,0.000685714}, {233,0.000671429}, {234,0.000595238}, {235,0.000447619}, {236,0.000490476}, {237,0.000471429}, {238,0.000500000}, {239,0.000633333}, {240,0.000547619}, {241,0.000638095}, {242,0.000428571}, {243,0.000571429}, {244,0.000661905}, {245,0.000609524}, {246,0.000642857}, {247,0.000628571}, {248,0.000704762}, {249,0.000590476}, {250,0.000623810}, {251,0.000547619}, {252,0.000614286}, {253,0.000557143}, {254,0.000704762}, {255,0.000657143}, {256,0.000552381}, {257,0.000666667}, {258,0.000709524}, {259,0.000604762}, {260,0.000509524}, {261,0.000752381}, {262,0.000647619}, {263,0.000538095}, {264,0.000790476}, {265,0.000752381}, {266,0.000785714}, {267,0.000571429}, {268,0.000747619}, {269,0.000780952}, {270,0.000671429}, {271,0.000800000}, {272,0.000680952}, {273,0.000476190}, {274,0.000933333}, {275,0.000790476}, {276,0.000609524}, {277,0.000600000}, {278,0.000785714}, {279,0.000852381}, {280,0.000733333}, {281,0.000819048}, {282,0.000780952}, {283,0.000661905}, {284,0.000780952}, {285,0.000861905}, {286,0.000961905}, {287,0.000961905}, {288,0.000919048}, {289,0.000652381}, {290,0.000885714}, {291,0.000752381}, {292,0.000842857}, {293,0.000785714}, {294,0.000823810}, {295,0.000847619}, {296,0.000723810}, {297,0.000666667}, {298,0.000685714}, {299,0.000728571}, {300,0.000771429}, {301,0.000852381}, {302,0.000804762}, {303,0.000738095}, {304,0.000885714}, {305,0.000895238}, {306,0.001109524}, {307,0.000966667}, {308,0.000819048}, {309,0.001552381}, {310,0.000914286}, {311,0.000766667}, {312,0.001004762}, {313,0.000780952}, {314,0.000952381}, {315,0.000847619}, {316,0.001042857}, {317,0.000980952}, {318,0.000847619}, {319,0.000842857}, {320,0.001057143}, {321,0.000938095}, {322,0.000833333}, {323,0.001095238}, {324,0.001033333}, {325,0.000952381}, {326,0.000919048}, {327,0.001176190}, {328,0.000952381}, {329,0.000980952}, {330,0.001038095}, {331,0.000842857}, {332,0.001223810}, {333,0.001104762}, {334,0.001057143}, {335,0.001085714}, {336,0.000857143}, {337,0.001142857}, {338,0.001023810}, {339,0.001076190}, {340,0.000971429}, {341,0.001052381}, {342,0.001104762}, {343,0.001166667}, {344,0.000785714}, {345,0.000785714}, {346,0.001371429}, {347,0.001100000}, {348,0.001314286}, {349,0.000947619}, {350,0.001100000}, {351,0.001228571}, {352,0.001438095}, {353,0.001219048}, {354,0.001300000}, {355,0.001214286}, {356,0.001266667}, {357,0.001071429}, {358,0.001114286}, {359,0.001180952}, {360,0.001004762}, {361,0.002009524}, {362,0.001138095}, {363,0.001242857}, {364,0.001466667}, {365,0.001361905}, {366,0.001247619}, {367,0.001271429}, {368,0.001166667}, {369,0.002233333}, {370,0.001104762}, {371,0.001004762}, {372,0.001233333}, {373,0.001290476}, {374,0.001166667}, {375,0.001185714}, {376,0.001233333}, {377,0.001204762}, {378,0.001257143}, {379,0.001395238}, {380,0.001314286}, {381,0.001466667}, {382,0.001319048}, {383,0.001357143}, {384,0.001352381}, {385,0.001338095}, {386,0.001404762}, {387,0.001619048}, {388,0.001723810}, {389,0.001566667}, {390,0.001490476}, {391,0.001461905}, {392,0.000976190}, {393,0.001395238}, {394,0.001561905}, {395,0.001342857}, {396,0.001457143}, {397,0.001647619}, {398,0.001452381}, {399,0.001323810}, {400,0.001523810}, {401,0.001395238}, {402,0.001509524}, {403,0.001490476}, {404,0.001595238}, {405,0.001261905}, {406,0.001395238}, {407,0.001423810}, {408,0.001457143}, {409,0.001590476}, {410,0.001500000}, {411,0.001447619}, {412,0.001595238}, {413,0.001552381}, {414,0.001509524}, {415,0.001433333}, {416,0.001461905}, {417,0.001747619}, {418,0.001295238}, {419,0.001757143}, {420,0.001523810}, {421,0.001576190}, {422,0.001552381}, {423,0.001747619}, {424,0.001433333}, {425,0.001752381}, {426,0.001509524}, {427,0.001728571}, {428,0.001647619}, {429,0.001366667}, {430,0.001938095}, {431,0.001400000}, {432,0.001885714}, {433,0.001528571}, {434,0.001552381}, {435,0.001657143}, {436,0.001652381}, {437,0.001509524}, {438,0.001742857}, {439,0.001828571}, {440,0.001600000}, {441,0.001728571}, {442,0.001823810}, {443,0.001776190}, {444,0.001747619}, {445,0.008033333}, {446,0.001766667}, {447,0.001709524}, {448,0.001676190}, {449,0.001914286}, {450,0.001947619}, {451,0.001771429}, {452,0.001895238}, {453,0.001814286}, {454,0.001709524}, {455,0.001719048}, {456,0.001780952}, {457,0.001814286}, {458,0.001923810}, {459,0.001985714}, {460,0.001919048}, {461,0.001900000}, {462,0.001890476}, {463,0.001809524}, {464,0.001738095}, {465,0.001780952}, {466,0.001871429}, {467,0.001904762}, {468,0.001904762}, {469,0.001961905}, {470,0.001942857}, {471,0.001861905}, {472,0.001861905}, {473,0.001819048}, {474,0.001819048}, {475,0.001947619}, {476,0.001752381}, {477,0.001895238}, {478,0.001952381}, {479,0.001823810}, {480,0.002038095}, {481,0.001957143}, {482,0.001771429}, {483,0.007423810}, {484,0.001857143}, {485,0.002114286}, {486,0.002009524}, {487,0.001966667}, {488,0.002271429}, {489,0.001861905}, {490,0.002080952}, {491,0.001861905}, {492,0.001814286}, {493,0.002133333}, {494,0.001985714}, {495,0.002080952}, {496,0.002228571}, {497,0.002057143}, {498,0.002166667}, {499,0.002180952}, {500,0.002161905}, {505,0.002157143}, {510,0.002423810}, {515,0.002309524}, {520,0.002495238}, {525,0.003552381}, {530,0.002390476}, {535,0.002404762}, {540,0.002300000}, {545,0.002538095}, {550,0.002580952}, {555,0.002680952}, {560,0.002657143}, {565,0.002523810}, {570,0.002695238}, {575,0.002990476}, {580,0.002690476}, {585,0.002857143}, {590,0.002880952}, {595,0.002966667}, {600,0.003028571}, {605,0.003004762}, {610,0.003114286}, {615,0.003195238}, {620,0.003266667}, {625,0.003280952}, {630,0.004395238}, {635,0.003447619}, {640,0.003533333}, {645,0.003576190}, {650,0.003600000}, {655,0.003552381}, {660,0.003609524}, {665,0.003771429}, {670,0.003800000}, {675,0.003885714}, {680,0.003890476}, {685,0.004100000}, {690,0.004090476}, {695,0.004252381}, {700,0.004333333}, {705,0.004309524}, {710,0.004476190}, {715,0.004447619}, {720,0.004490476}, {725,0.004295238}, {730,0.004842857}, {735,0.004661905}, {740,0.005090476}, {745,0.004819048}, {750,0.004857143}, {755,0.005147619}, {760,0.005119048}, {765,0.005300000}, {770,0.005557143}, {775,0.005323810}, {780,0.005400000}, {785,0.005580952}, {790,0.005585714}, {795,0.005866667}, {800,0.006152381}, {805,0.005947619}, {810,0.005785714}, {815,0.006119048}, {820,0.006257143}, {825,0.006352381}, {830,0.006419048}, {835,0.006252381}, {840,0.011104762}, {845,0.006752381}, {850,0.006766667}, {855,0.007076190}, {860,0.006961905}, {865,0.006857143}, {870,0.007109524}, {875,0.010609524}, {880,0.007438095}, {885,0.007447619}, {890,0.007542857}, {895,0.007480952}, {900,0.022304762}, {905,0.007919048}, {910,0.008485714}, {915,0.008057143}, {920,0.008223810}, {925,0.008257143}, {930,0.008328571}, {935,0.008466667}, {940,0.008542857}, {945,0.008547619}, {950,0.008776190}, {955,0.008838095}, {960,0.008938095}, {965,0.009228571}, {970,0.023709524}, {975,0.009395238}, {980,0.009709524}, {985,0.009652381}, {990,0.009785714}, {995,0.009800000}, {1000,0.009909524}, {1010,0.010095238}, {1020,0.010238095}, {1030,0.010252381}, {1040,0.010947619}, {1050,0.011171429}, {1060,0.011328571}, {1070,0.011295238}, {1080,0.011800000}, {1090,0.011928571}, {1100,0.012119048}, {1110,0.012466667}, {1120,0.012590476}, {1130,0.012738095}, {1140,0.013166667}, {1150,0.013395238}, {1160,0.013761905}, {1170,0.013709524}, {1180,0.014342857}, {1190,0.014471429}, {1200,0.014700000}, {1210,0.015066667}, {1220,0.015452381}, {1230,0.034442857}, {1240,0.015957143}, {1250,0.016009524}, {1260,0.016404762}, {1270,0.016823810}, {1280,0.016890476}, {1290,0.017371429}, {1300,0.017780952}, {1310,0.021719048}, {1320,0.018323810}, {1330,0.018676190}, {1340,0.018828571}, {1350,0.019109524}, {1360,0.019428571}, {1370,0.019900000}, {1380,0.025642857}, {1390,0.020900000}, {1400,0.021133333}, {1410,0.021561905}, {1420,0.021928571}, {1430,0.022109524}, {1440,0.022471429}, {1450,0.022809524}, {1460,0.023600000}, {1470,0.023795238}, {1480,0.024114286}, {1490,0.028495238}, {1500,0.025633333}, {1510,0.025723810}, {1520,0.026400000}, {1530,0.027052381}, {1540,0.027471429}, {1550,0.028052381}, {1560,0.028519048}, {1570,0.028780952}, {1580,0.029428571}, {1590,0.029709524}, {1600,0.030147619}, {1610,0.030890476}, {1620,0.031376190}, {1630,0.031828571}, {1640,0.032533333}, {1650,0.033442857}, {1660,0.034000000}, {1670,0.038252381}, {1680,0.035214286}, {1690,0.035919048}, {1700,0.036704762}, {1710,0.037457143}, {1720,0.038014286}, {1730,0.038638095}, {1740,0.039642857}, {1750,0.040228571}, {1760,0.040871429}, {1770,0.041623810}, {1780,0.045933333}, {1790,0.042904762}, {1800,0.043461905}, {1810,0.044161905}, {1820,0.045219048}, {1830,0.045961905}, {1840,0.046795238}, {1850,0.048490476}, {1860,0.048514286}, {1870,0.049285714}, {1880,0.050685714}, {1890,0.051095238}, {1900,0.055857143}, {1910,0.052657143}, {1920,0.053285714}, {1930,0.054028571}, {1940,0.055023810}, {1950,0.055704762}, {1960,0.056614286}, {1970,0.057652381}, {1980,0.058385714}, {1990,0.089133333}, {2000,0.060390476}, {2050,0.064952381}, {2100,0.069228571}, {2150,0.074471429}, {2200,0.079057143}, {2250,0.084209524}, {2300,0.089138095}, {2350,0.094209524}, {2400,0.099957143}, {2450,0.105200000}, {2500,0.110833333}, {2550,0.116342857}, {2600,0.122266667}, {2650,0.127371429}, {2700,0.133966667}, {2750,0.139447619}, {2800,0.146176190}, {2850,0.152447619}, {2900,0.158561905}, {2950,0.165533333}, {3000,0.171433333}, {3050,0.179076190}, {3100,0.185290476}, {3150,0.192547619}, {3200,0.199247619}, {3250,0.206204762}, {3300,0.213785714}, {3350,0.221361905}, {3400,0.228890476}, {3450,0.250161905}, {3500,0.243490476}, {3550,0.251776190}, {3600,0.259752381}, {3650,0.267538095}, {3700,0.276409524}, {3750,0.284076190}, {3800,0.292619048}, {3850,0.301195238}, {3900,0.309723810}, {3950,0.391300000}, {4000,0.327009524}, {4050,0.337771429}, {4100,0.345061905}, {4150,0.383438095}, {4200,0.363304762}, {4250,0.372971429}, {4300,0.382390476}, {4350,0.392100000}, {4400,0.403523810}, {4450,0.411528571}, {4500,0.421366667}, {4550,0.432761905}, {4600,0.441480952}, {4650,0.451690476}, {4700,0.489885714}, {4750,0.472457143}, {4800,0.483057143}, {4850,0.493538095}, {4900,0.504452381}, {4950,0.531928571}, {5000,0.526004762}, {5050,0.62571}, {5100,0.54457}, {5150,0.55543}, {5200,0.56643}, {5250,0.59100}, {5300,0.58914}, {5350,0.60143}, {5400,0.63643}, {5450,0.62686}, {5500,0.63786}, {5550,0.64971}, {5600,0.66671}, {5650,0.67886}, {5700,0.69286}, {5750,0.75429}, {5800,0.73971}, {5850,0.72900}, {5900,0.74314}, {5950,0.75614}, {6000,0.76971}, {6050,0.78214}, {6100,0.79671}, {6150,0.83743}, {6200,0.82414}, {6250,0.83743}, {6300,0.85029}, {6350,0.86357}, {6400,0.87829}, {6450,0.89314}, {6500,0.90771}, {6550,0.92243}, {6600,0.93471}, {6650,0.95100}, {6700,1.02157}, {6750,0.98057}, {6800,0.99657}, {6850,1.01086}, {6900,1.03686}, {6950,1.05157}, {7000,1.06657}, {7050,1.15514}, {7100,1.09729}, {7150,1.11443}, {7200,1.13114}, {7250,1.14571}, {7300,1.16143}, {7350,1.17814}, {7400,1.19557}, {7450,1.24657}, {7500,1.22843}, {7550,1.24700}, {7600,1.28629}, {7650,1.28057}, {7700,1.29643}, {7750,1.31286}, {7800,1.33157}, {7850,1.37086}, {7900,1.36571}, {7950,1.41486}, {8000,1.40043}, {8050,1.44114}, {8100,1.43814}, {8150,1.49286}, {8200,1.47414}, {8250,1.50486}, {8300,1.51043}, {8350,1.53029}, {8400,1.54571}, {8450,1.56800}, {8500,1.59200}, {8550,1.60471}, {8600,1.62400}, {8650,1.66314}, {8700,1.66500}, {8750,1.68357}, {8800,1.70100}, {8850,1.75829}, {8900,1.74043}, {8950,1.76271}, {9000,1.78129}, {9050,1.81643}, {9100,1.82386}, {9150,1.82100}, {9200,1.84071}, {9250,1.86286}, {9300,1.88086}, {9350,1.90200}, {9400,1.92571}, {9450,1.96943}, {9500,2.02086}, {9550,2.03300}, {9600,2.04171}, {9650,2.05571}, {9700,2.12271}, {9750,2.17743}, {9800,2.23300}, {9850,2.24871}, {9900,2.14757}, {9950,2.15743}, {10000,2.18057}, {10100,2.22443}, {10200,2.26671}, {10300,2.31514}, {10400,2.47471}, {10500,2.40257}, {10600,2.44686}, {10700,2.49743}, {10800,2.54457}, {10900,2.59171}, {11000,2.68000}, {11100,2.68857}, {11200,2.73614}, {11300,2.78614}, {11400,2.83457}, {11500,2.88500}, {11600,3.10157}, {11700,3.02471}, {11800,3.07714}, {11900,3.20229}, {12000,3.18186}, {12100,3.23514}, {12200,3.28914}, {12300,3.48186}, {12400,3.39686}, {12500,3.44929}, {12600,3.51043}, {12700,3.56314}, {12800,3.62100}, {12900,3.67629}, {13000,3.74300}, {13100,3.79386}, {13200,3.85129}, {13300,3.91000}, {13400,3.97243}, {13500,4.25243}, {13600,4.08571}, {13700,4.15971}, {13800,4.21571}, {13900,4.51029}, {14000,4.33486}, {14100,4.40629}, {14200,4.64071}, {14300,4.52757}, {14400,4.80271}, {14500,4.65514}, {14600,4.93100}, {14700,4.78386}, {14800,5.05586}, {14900,4.91114}, {15000,4.97557}, {15100,5.31157}, {15200,5.11371}, {15300,5.17243}, {15400,5.24571}, {15500,5.58500}, {15600,5.45257}, {15700,5.51757}, {15800,5.59043}, {15900,5.66971}, {16000,5.73214}, {16100,5.80486}, {16200,5.88029}, {16300,5.96286}, {16400,6.02686}, {16500,6.10200}, {16600,6.17771}, {16700,6.39214}, {16800,6.61871}, {16900,6.39357}, {17000,6.46457}, {17100,6.54443}, {17200,6.67143}, {17300,6.69571}, {17400,6.96814}, {17500,6.85086}, {17600,6.93186}, {17700,7.00614}, {17800,7.08771}, {17900,7.17114}, {18000,7.24557}, {18100,7.32343}, {18200,7.79100}, {18300,7.49971}, {18400,7.57171}, {18500,7.96357}, {18600,7.84657}, {18700,7.82529}, {18800,7.92314}, {18900,7.99857}, {19000,8.21186}, {19100,8.55943}, {19200,8.68457}, {19300,8.75129}, {19400,8.84529}, {19500,8.97671}, {19600,9.04014}, {19700,8.95329}, {19800,8.67771}, {19900,8.77457}, {20000,8.79360}};
data["big"]["beta; Parametricity"]["eval lazy"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000019048}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000019048}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000019048}, {62,0.000000000}, {63,0.000000000}, {64,0.000019048}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000019048}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000019048}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000019048}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000019048}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000019048}, {96,0.000019048}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000019048}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000038095}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000019048}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000019048}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000019048}, {150,0.000019048}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000019048}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000019048}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000019048}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000038095}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000019048}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000019048}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000019048}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000057143}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000014286}, {231,0.000019048}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000019048}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000019048}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000019048}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000019048}, {253,0.000019048}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000019048}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000019048}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000014286}, {277,0.000000000}, {278,0.000019048}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000019048}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000019048}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000019048}, {294,0.000000000}, {295,0.000019048}, {296,0.000000000}, {297,0.000019048}, {298,0.000019048}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000019048}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000019048}, {309,0.000019048}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000019048}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000019048}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000019048}, {327,0.000019048}, {328,0.000000000}, {329,0.000019048}, {330,0.000019048}, {331,0.000000000}, {332,0.000038095}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000038095}, {340,0.000019048}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000019048}, {347,0.000000000}, {348,0.000000000}, {349,0.000019048}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000019048}, {355,0.000038095}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000019048}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000019048}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000019048}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000019048}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000019048}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000019048}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000019048}, {411,0.000057143}, {412,0.000019048}, {413,0.000019048}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000019048}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000019048}, {425,0.000019048}, {426,0.000019048}, {427,0.000000000}, {428,0.000000000}, {429,0.000019048}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000019048}, {435,0.000019048}, {436,0.000019048}, {437,0.000019048}, {438,0.000000000}, {439,0.000019048}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000019048}, {444,0.000000000}, {445,0.000000000}, {446,0.000019048}, {447,0.000019048}, {448,0.000019048}, {449,0.000000000}, {450,0.000019048}, {451,0.000000000}, {452,0.000000000}, {453,0.000057143}, {454,0.000000000}, {455,0.000038095}, {456,0.000000000}, {457,0.000019048}, {458,0.000019048}, {459,0.000014286}, {460,0.000019048}, {461,0.000019048}, {462,0.000019048}, {463,0.000000000}, {464,0.000019048}, {465,0.000019048}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000019048}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000057143}, {483,0.000071429}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000019048}, {488,0.000000000}, {489,0.000019048}, {490,0.000019048}, {491,0.000000000}, {492,0.000000000}, {493,0.000019048}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000038095}, {498,0.000038095}, {499,0.000000000}, {500,0.000000000}, {505,0.000038095}, {510,0.000019048}, {515,0.000019048}, {520,0.000057143}, {525,0.000019048}, {530,0.000000000}, {535,0.000019048}, {540,0.000000000}, {545,0.000019048}, {550,0.000000000}, {555,0.000019048}, {560,0.000019048}, {565,0.000057143}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000057143}, {595,0.000000000}, {600,0.000057143}, {605,0.000019048}, {610,0.000019048}, {615,0.000014286}, {620,0.000000000}, {625,0.000000000}, {630,0.000038095}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000057143}, {655,0.000000000}, {660,0.000000000}, {665,0.000038095}, {670,0.000000000}, {675,0.000038095}, {680,0.000019048}, {685,0.000000000}, {690,0.000038095}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000019048}, {730,0.000000000}, {735,0.000038095}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000038095}, {765,0.000038095}, {770,0.000019048}, {775,0.000038095}, {780,0.000000000}, {785,0.000057143}, {790,0.000057143}, {795,0.000038095}, {800,0.000019048}, {805,0.000038095}, {810,0.000019048}, {815,0.000019048}, {820,0.000000000}, {825,0.000019048}, {830,0.000019048}, {835,0.000000000}, {840,0.000247619}, {845,0.000038095}, {850,0.000019048}, {855,0.000019048}, {860,0.000000000}, {865,0.000000000}, {870,0.000019048}, {875,0.000000000}, {880,0.000090476}, {885,0.000038095}, {890,0.000019048}, {895,0.000019048}, {900,0.000209524}, {905,0.000019048}, {910,0.000019048}, {915,0.000019048}, {920,0.000019048}, {925,0.000000000}, {930,0.000038095}, {935,0.000019048}, {940,0.000057143}, {945,0.000000000}, {950,0.000019048}, {955,0.000000000}, {960,0.000000000}, {965,0.000019048}, {970,0.000228571}, {975,0.000019048}, {980,0.000000000}, {985,0.000019048}, {990,0.000019048}, {995,0.000019048}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000019048}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000038095}, {1070,0.000019048}, {1080,0.000038095}, {1090,0.000038095}, {1100,0.000019048}, {1110,0.000000000}, {1120,0.000038095}, {1130,0.000019048}, {1140,0.000038095}, {1150,0.000000000}, {1160,0.000019048}, {1170,0.000076190}, {1180,0.000000000}, {1190,0.000019048}, {1200,0.000019048}, {1210,0.000000000}, {1220,0.000019048}, {1230,0.000000000}, {1240,0.000019048}, {1250,0.000019048}, {1260,0.000000000}, {1270,0.000019048}, {1280,0.000038095}, {1290,0.000019048}, {1300,0.000019048}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000019048}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000038095}, {1370,0.000038095}, {1380,0.000000000}, {1390,0.000019048}, {1400,0.000033333}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000019048}, {1450,0.000000000}, {1460,0.000019048}, {1470,0.000000000}, {1480,0.000038095}, {1490,0.000000000}, {1500,0.000019048}, {1510,0.000095238}, {1520,0.000076190}, {1530,0.000019048}, {1540,0.000095238}, {1550,0.000000000}, {1560,0.000057143}, {1570,0.000071429}, {1580,0.000057143}, {1590,0.000038095}, {1600,0.000114286}, {1610,0.000038095}, {1620,0.000019048}, {1630,0.000019048}, {1640,0.000033333}, {1650,0.000019048}, {1660,0.000038095}, {1670,0.000057143}, {1680,0.000071429}, {1690,0.000000000}, {1700,0.000038095}, {1710,0.000038095}, {1720,0.000057143}, {1730,0.000033333}, {1740,0.000019048}, {1750,0.000076190}, {1760,0.000076190}, {1770,0.000057143}, {1780,0.000019048}, {1790,0.000000000}, {1800,0.000057143}, {1810,0.000038095}, {1820,0.000076190}, {1830,0.000019048}, {1840,0.000057143}, {1850,0.000038095}, {1860,0.000038095}, {1870,0.000057143}, {1880,0.000038095}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000076190}, {1920,0.000038095}, {1930,0.000057143}, {1940,0.000000000}, {1950,0.000038095}, {1960,0.000038095}, {1970,0.000057143}, {1980,0.000019048}, {1990,0.000038095}, {2000,0.000000000}, {2050,0.000019048}, {2100,0.000038095}, {2150,0.000019048}, {2200,0.000000000}, {2250,0.000114286}, {2300,0.000000000}, {2350,0.000038095}, {2400,0.000000000}, {2450,0.000019048}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000019048}, {2700,0.000038095}, {2750,0.000019048}, {2800,0.000000000}, {2850,0.000038095}, {2900,0.000038095}, {2950,0.000038095}, {3000,0.000019048}, {3050,0.000019048}, {3100,0.000038095}, {3150,0.000019048}, {3200,0.000038095}, {3250,0.000038095}, {3300,0.000019048}, {3350,0.000038095}, {3400,0.000038095}, {3450,0.000019048}, {3500,0.000019048}, {3550,0.000038095}, {3600,0.000019048}, {3650,0.000071429}, {3700,0.000019048}, {3750,0.000038095}, {3800,0.000038095}, {3850,0.000057143}, {3900,0.000038095}, {3950,0.000038095}, {4000,0.000038095}, {4050,0.000038095}, {4100,0.000038095}, {4150,0.000038095}, {4200,0.000019048}, {4250,0.000071429}, {4300,0.000057143}, {4350,0.000052381}, {4400,0.000019048}, {4450,0.000076190}, {4500,0.000000000}, {4550,0.000114286}, {4600,0.000066667}, {4650,0.000019048}, {4700,0.000038095}, {4750,0.000019048}, {4800,0.000076190}, {4850,0.000038095}, {4900,0.000133333}, {4950,0.000038095}, {5000,0.000114286}, {5050,0.00171}, {5100,0.00000}, {5150,0.00000}, {5200,0.00057}, {5250,0.00057}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00057}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00043}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00057}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00057}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00057}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00057}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00057}, {7800,0.00057}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00057}, {8100,0.00000}, {8150,0.00114}, {8200,0.00000}, {8250,0.00000}, {8300,0.00057}, {8350,0.00057}, {8400,0.00057}, {8450,0.00057}, {8500,0.00057}, {8550,0.00057}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00057}, {8950,0.00000}, {9000,0.00057}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00100}, {9250,0.00057}, {9300,0.00000}, {9350,0.00114}, {9400,0.00000}, {9450,0.00114}, {9500,0.00000}, {9550,0.00000}, {9600,0.00057}, {9650,0.00000}, {9700,0.00000}, {9750,0.00114}, {9800,0.00057}, {9850,0.00000}, {9900,0.00114}, {9950,0.00000}, {10000,0.00000}, {10100,0.00057}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00057}, {10700,0.00000}, {10800,0.00057}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00057}, {11700,0.00057}, {11800,0.00057}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00057}, {12900,0.00171}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00114}, {13600,0.00114}, {13700,0.00043}, {13800,0.00000}, {13900,0.00000}, {14000,0.00114}, {14100,0.00000}, {14200,0.00114}, {14300,0.00000}, {14400,0.00057}, {14500,0.00057}, {14600,0.00000}, {14700,0.00057}, {14800,0.00057}, {14900,0.00057}, {15000,0.00000}, {15100,0.00057}, {15200,0.00057}, {15300,0.00000}, {15400,0.00057}, {15500,0.00000}, {15600,0.00057}, {15700,0.00057}, {15800,0.00000}, {15900,0.00000}, {16000,0.00171}, {16100,0.00114}, {16200,0.00043}, {16300,0.00000}, {16400,0.00057}, {16500,0.00000}, {16600,0.00057}, {16700,0.00000}, {16800,0.00000}, {16900,0.00057}, {17000,0.00171}, {17100,0.00000}, {17200,0.00443}, {17300,0.00171}, {17400,0.00057}, {17500,0.00114}, {17600,0.00114}, {17700,0.00057}, {17800,0.00114}, {17900,0.00000}, {18000,0.00114}, {18100,0.00057}, {18200,0.00057}, {18300,0.00000}, {18400,0.00114}, {18500,0.00171}, {18600,0.00114}, {18700,0.00229}, {18800,0.00171}, {18900,0.00114}, {19000,0.00229}, {19100,0.00057}, {19200,0.00057}, {19300,0.00114}, {19400,0.00057}, {19500,0.00171}, {19600,0.00114}, {19700,0.00000}, {19800,0.00000}, {19900,0.00057}, {20000,0.00000}};
data["big"]["beta; Parametricity"]["lazy beta iota"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000009524}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000014286}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.006338095}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.001309524}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000004762}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.002176190}, {610,0.000000000}, {615,0.000004762}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000004762}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000009524}, {665,0.000004762}, {670,0.000000000}, {675,0.000000000}, {680,0.000004762}, {685,0.000004762}, {690,0.000004762}, {695,0.000019048}, {700,0.000019048}, {705,0.000014286}, {710,0.000023810}, {715,0.000023810}, {720,0.000014286}, {725,0.000004762}, {730,0.000038095}, {735,0.000047619}, {740,0.000038095}, {745,0.000057143}, {750,0.000057143}, {755,0.000071429}, {760,0.000004762}, {765,0.000109524}, {770,0.000080952}, {775,0.000128571}, {780,0.000109524}, {785,0.000104762}, {790,0.000133333}, {795,0.000047619}, {800,0.000185714}, {805,0.000166667}, {810,0.000004762}, {815,0.000209524}, {820,0.000261905}, {825,0.000000000}, {830,0.000247619}, {835,0.000280952}, {840,0.000000000}, {845,0.000347619}, {850,0.000352381}, {855,0.000366667}, {860,0.000385714}, {865,0.000380952}, {870,0.000414286}, {875,0.000428571}, {880,0.000480952}, {885,0.000471429}, {890,0.000461905}, {895,0.000480952}, {900,0.000004762}, {905,0.000476190}, {910,0.000485714}, {915,0.000000000}, {920,0.000504762}, {925,0.000509524}, {930,0.000014286}, {935,0.000519048}, {940,0.000523810}, {945,0.000014286}, {950,0.000528571}, {955,0.000514286}, {960,0.000519048}, {965,0.000533333}, {970,0.000019048}, {975,0.000542857}, {980,0.000547619}, {985,0.000023810}, {990,0.000538095}, {995,0.000538095}, {1000,0.000542857}, {1010,0.000566667}, {1020,0.000066667}, {1030,0.000590476}, {1040,0.000628571}, {1050,0.000585714}, {1060,0.000680952}, {1070,0.000185714}, {1080,0.000738095}, {1090,0.000761905}, {1100,0.000785714}, {1110,0.000804762}, {1120,0.000400000}, {1130,0.004304762}, {1140,0.000971429}, {1150,0.000995238}, {1160,0.000528571}, {1170,0.001009524}, {1180,0.001014286}, {1190,0.000771429}, {1200,0.001019048}, {1210,0.000857143}, {1220,0.001019048}, {1230,0.000919048}, {1240,0.000566667}, {1250,0.001033333}, {1260,0.001023810}, {1270,0.001357143}, {1280,0.001038095}, {1290,0.000576190}, {1300,0.001047619}, {1310,0.000614286}, {1320,0.001080952}, {1330,0.001071429}, {1340,0.001104762}, {1350,0.001076190}, {1360,0.000761905}, {1370,0.001223810}, {1380,0.000776190}, {1390,0.001152381}, {1400,0.001185714}, {1410,0.018866667}, {1420,0.001195238}, {1430,0.000676190}, {1440,0.001204762}, {1450,0.000685714}, {1460,0.001180952}, {1470,0.000714286}, {1480,0.001271429}, {1490,0.000985714}, {1500,0.001238095}, {1510,0.001280952}, {1520,0.001000000}, {1530,0.001295238}, {1540,0.001004762}, {1550,0.001333333}, {1560,0.001347619}, {1570,0.001338095}, {1580,0.001371429}, {1590,0.001004762}, {1600,0.001428571}, {1610,0.001338095}, {1620,0.001395238}, {1630,0.001442857}, {1640,0.001000000}, {1650,0.001476190}, {1660,0.001480952}, {1670,0.001000000}, {1680,0.001490476}, {1690,0.001009524}, {1700,0.001485714}, {1710,0.001514286}, {1720,0.001000000}, {1730,0.002338095}, {1740,0.001523810}, {1750,0.001014286}, {1760,0.001547619}, {1770,0.001552381}, {1780,0.001000000}, {1790,0.001566667}, {1800,0.001571429}, {1810,0.001047619}, {1820,0.001566667}, {1830,0.001595238}, {1840,0.001061905}, {1850,0.001580952}, {1860,0.001652381}, {1870,0.001009524}, {1880,0.001066667}, {1890,0.001723810}, {1900,0.001614286}, {1910,0.001076190}, {1920,0.001714286}, {1930,0.001800000}, {1940,0.001119048}, {1950,0.001000000}, {1960,0.001857143}, {1970,0.001728571}, {1980,0.001133333}, {1990,0.001128571}, {2000,0.001795238}, {2050,0.002057143}, {2100,0.001300000}, {2150,0.001014286}, {2200,0.002938095}, {2250,0.002442857}, {2300,0.002028571}, {2350,0.001814286}, {2400,0.001919048}, {2450,0.001995238}, {2500,0.001547619}, {2550,0.001542857}, {2600,0.002166667}, {2650,0.002147619}, {2700,0.002157143}, {2750,0.001590476}, {2800,0.001619048}, {2850,0.001714286}, {2900,0.001733333}, {2950,0.009338095}, {3000,0.002409524}, {3050,0.002471429}, {3100,0.003800000}, {3150,0.004109524}, {3200,0.002576190}, {3250,0.002638095}, {3300,0.002700000}, {3350,0.003795238}, {3400,0.026685714}, {3450,0.002319048}, {3500,0.002409524}, {3550,0.003652381}, {3600,0.002452381}, {3650,0.002576190}, {3700,0.006238095}, {3750,0.003500000}, {3800,0.013033333}, {3850,0.002766667}, {3900,0.002547619}, {3950,0.002571429}, {4000,0.003647619}, {4050,0.063476190}, {4100,0.002628571}, {4150,0.002666667}, {4200,0.011923810}, {4250,0.002690476}, {4300,0.002766667}, {4350,0.011400000}, {4400,0.004138095}, {4450,0.003657143}, {4500,0.003047619}, {4550,0.003885714}, {4600,0.012561905}, {4650,0.003390476}, {4700,0.004633333}, {4750,0.003495238}, {4800,0.004461905}, {4850,0.003514286}, {4900,0.004614286}, {4950,0.003571429}, {5000,0.014376190}, {5050,0.00414}, {5100,0.00357}, {5150,0.00357}, {5200,0.00357}, {5250,0.00357}, {5300,0.00357}, {5350,0.00400}, {5400,0.00400}, {5450,0.00414}, {5500,0.00386}, {5550,0.00429}, {5600,0.00414}, {5650,0.00414}, {5700,0.00429}, {5750,0.00414}, {5800,0.00457}, {5850,0.00429}, {5900,0.00414}, {5950,0.00414}, {6000,0.00429}, {6050,0.00457}, {6100,0.00457}, {6150,0.00500}, {6200,0.01186}, {6250,0.00457}, {6300,0.00457}, {6350,0.00471}, {6400,0.00471}, {6450,0.00457}, {6500,0.00486}, {6550,0.00500}, {6600,0.00529}, {6650,0.01229}, {6700,0.00529}, {6750,0.00629}, {6800,0.00571}, {6850,0.00557}, {6900,0.00571}, {6950,0.00557}, {7000,0.00571}, {7050,0.00600}, {7100,0.00571}, {7150,0.00529}, {7200,0.00543}, {7250,0.01671}, {7300,0.00614}, {7350,0.00543}, {7400,0.00557}, {7450,0.00543}, {7500,0.00557}, {7550,0.00571}, {7600,0.00557}, {7650,0.00586}, {7700,0.00586}, {7750,0.00600}, {7800,0.00600}, {7850,0.00614}, {7900,0.00614}, {7950,0.00629}, {8000,0.00629}, {8050,0.00629}, {8100,0.00629}, {8150,0.00629}, {8200,0.00629}, {8250,0.00629}, {8300,0.00629}, {8350,0.00671}, {8400,0.00686}, {8450,0.00743}, {8500,0.00700}, {8550,0.00686}, {8600,0.00786}, {8650,0.00714}, {8700,0.00729}, {8750,0.00700}, {8800,0.00686}, {8850,0.00700}, {8900,0.00686}, {8950,0.00771}, {9000,0.00729}, {9050,0.00714}, {9100,0.01500}, {9150,0.00714}, {9200,0.00743}, {9250,0.00800}, {9300,0.00729}, {9350,0.00729}, {9400,0.00729}, {9450,0.00843}, {9500,0.00857}, {9550,0.00843}, {9600,0.00843}, {9650,0.00829}, {9700,0.00829}, {9750,0.00743}, {9800,0.00843}, {9850,0.00757}, {9900,0.00800}, {9950,0.00871}, {10000,0.00771}, {10100,0.00829}, {10200,0.00800}, {10300,0.00986}, {10400,0.00929}, {10500,0.00829}, {10600,0.00886}, {10700,0.00871}, {10800,0.00871}, {10900,0.00886}, {11000,0.00900}, {11100,0.00843}, {11200,0.02929}, {11300,0.00914}, {11400,0.02829}, {11500,0.00857}, {11600,0.00986}, {11700,0.01000}, {11800,0.01014}, {11900,0.01071}, {12000,0.00957}, {12100,0.00943}, {12200,0.01014}, {12300,0.01100}, {12400,0.02443}, {12500,0.00986}, {12600,0.00957}, {12700,0.00986}, {12800,0.01000}, {12900,0.01000}, {13000,0.01043}, {13100,0.01043}, {13200,0.01043}, {13300,0.01043}, {13400,0.02386}, {13500,0.01057}, {13600,0.01157}, {13700,0.01086}, {13800,0.01086}, {13900,0.01057}, {14000,0.01186}, {14100,0.01129}, {14200,0.01143}, {14300,0.01157}, {14400,0.01114}, {14500,0.01200}, {14600,0.01143}, {14700,0.01229}, {14800,0.01171}, {14900,0.01157}, {15000,0.01314}, {15100,0.01371}, {15200,0.01400}, {15300,0.01500}, {15400,0.01329}, {15500,0.01229}, {15600,0.03429}, {15700,0.01500}, {15800,0.01571}, {15900,0.01429}, {16000,0.01414}, {16100,0.01400}, {16200,0.01371}, {16300,0.01386}, {16400,0.01400}, {16500,0.01757}, {16600,0.04729}, {16700,0.01557}, {16800,0.01457}, {16900,0.01471}, {17000,0.01371}, {17100,0.01486}, {17200,0.01400}, {17300,0.01371}, {17400,0.01543}, {17500,0.01429}, {17600,0.04214}, {17700,0.01500}, {17800,0.04329}, {17900,0.01443}, {18000,0.03457}, {18100,0.01457}, {18200,0.01557}, {18300,0.04486}, {18400,0.01457}, {18500,0.01571}, {18600,0.01500}, {18700,0.01500}, {18800,0.01529}, {18900,0.01557}, {19000,0.01671}, {19100,0.01700}, {19200,0.01743}, {19300,0.01529}, {19400,0.01543}, {19500,0.01529}, {19600,0.01814}, {19700,0.01771}, {19800,0.01757}, {19900,0.01729}, {20000,0.01600}};
data["big"]["beta; Parametricity"]["lazy beta iota"]["user"] = {{1,0.000019048}, {2,0.000014286}, {3,0.000014286}, {4,0.000033333}, {5,0.000000000}, {6,0.000000000}, {7,0.000014286}, {8,0.000000000}, {9,0.000014286}, {10,0.000028571}, {11,0.000033333}, {12,0.000028571}, {13,0.000028571}, {14,0.000038095}, {15,0.000014286}, {16,0.000014286}, {17,0.000047619}, {18,0.000014286}, {19,0.000047619}, {20,0.000047619}, {21,0.000119048}, {22,0.000047619}, {23,0.000052381}, {24,0.000076190}, {25,0.000033333}, {26,0.000033333}, {27,0.000066667}, {28,0.000014286}, {29,0.000000000}, {30,0.000085714}, {31,0.000028571}, {32,0.000019048}, {33,0.000076190}, {34,0.000061905}, {35,0.000014286}, {36,0.000033333}, {37,0.000019048}, {38,0.000085714}, {39,0.000052381}, {40,0.000014286}, {41,0.000138095}, {42,0.000128571}, {43,0.000066667}, {44,0.000000000}, {45,0.000052381}, {46,0.000047619}, {47,0.000080952}, {48,0.000014286}, {49,0.000076190}, {50,0.000057143}, {51,0.000028571}, {52,0.000028571}, {53,0.000061905}, {54,0.000014286}, {55,0.000057143}, {56,0.000038095}, {57,0.000047619}, {58,0.000076190}, {59,0.000042857}, {60,0.000014286}, {61,0.000000000}, {62,0.000071429}, {63,0.000057143}, {64,0.000047619}, {65,0.000066667}, {66,0.000085714}, {67,0.000042857}, {68,0.000085714}, {69,0.000057143}, {70,0.000047619}, {71,0.000057143}, {72,0.000066667}, {73,0.000119048}, {74,0.000109524}, {75,0.000080952}, {76,0.000076190}, {77,0.000095238}, {78,0.000061905}, {79,0.000066667}, {80,0.000123810}, {81,0.000042857}, {82,0.000142857}, {83,0.000114286}, {84,0.000085714}, {85,0.000066667}, {86,0.000014286}, {87,0.000047619}, {88,0.000133333}, {89,0.000128571}, {90,0.000119048}, {91,0.000161905}, {92,0.000085714}, {93,0.000038095}, {94,0.000123810}, {95,0.000061905}, {96,0.000109524}, {97,0.000100000}, {98,0.000180952}, {99,0.000014286}, {100,0.000028571}, {101,0.000080952}, {102,0.000133333}, {103,0.000090476}, {104,0.000119048}, {105,0.000085714}, {106,0.000080952}, {107,0.000076190}, {108,0.000080952}, {109,0.000123810}, {110,0.000152381}, {111,0.000095238}, {112,0.000114286}, {113,0.000080952}, {114,0.000028571}, {115,0.000128571}, {116,0.000114286}, {117,0.000123810}, {118,0.000100000}, {119,0.000033333}, {120,0.000090476}, {121,0.000138095}, {122,0.000152381}, {123,0.000161905}, {124,0.000085714}, {125,0.000090476}, {126,0.000061905}, {127,0.000114286}, {128,0.000176190}, {129,0.000157143}, {130,0.000152381}, {131,0.000090476}, {132,0.000128571}, {133,0.000095238}, {134,0.000085714}, {135,0.000166667}, {136,0.000085714}, {137,0.000171429}, {138,0.000114286}, {139,0.000071429}, {140,0.000114286}, {141,0.000109524}, {142,0.000109524}, {143,0.000119048}, {144,0.000047619}, {145,0.000114286}, {146,0.000171429}, {147,0.000195238}, {148,0.000176190}, {149,0.000028571}, {150,0.000176190}, {151,0.000095238}, {152,0.000119048}, {153,0.000152381}, {154,0.000180952}, {155,0.000123810}, {156,0.000095238}, {157,0.000238095}, {158,0.000157143}, {159,0.000142857}, {160,0.000300000}, {161,0.000171429}, {162,0.000128571}, {163,0.000185714}, {164,0.000119048}, {165,0.000128571}, {166,0.000171429}, {167,0.000076190}, {168,0.000123810}, {169,0.000233333}, {170,0.000304762}, {171,0.000076190}, {172,0.000190476}, {173,0.000095238}, {174,0.000147619}, {175,0.000190476}, {176,0.000195238}, {177,0.000214286}, {178,0.000176190}, {179,0.000214286}, {180,0.000242857}, {181,0.000204762}, {182,0.000128571}, {183,0.000161905}, {184,0.000185714}, {185,0.000123810}, {186,0.000185714}, {187,0.000261905}, {188,0.000238095}, {189,0.000204762}, {190,0.000157143}, {191,0.000209524}, {192,0.000142857}, {193,0.000123810}, {194,0.000195238}, {195,0.000200000}, {196,0.000119048}, {197,0.000076190}, {198,0.000161905}, {199,0.000200000}, {200,0.000180952}, {201,0.000157143}, {202,0.000133333}, {203,0.000223810}, {204,0.000190476}, {205,0.000195238}, {206,0.000242857}, {207,0.000200000}, {208,0.000190476}, {209,0.000200000}, {210,0.000147619}, {211,0.000204762}, {212,0.000261905}, {213,0.000190476}, {214,0.000185714}, {215,0.000180952}, {216,0.000161905}, {217,0.000176190}, {218,0.000200000}, {219,0.000128571}, {220,0.000214286}, {221,0.000204762}, {222,0.000133333}, {223,0.000123810}, {224,0.000171429}, {225,0.000161905}, {226,0.000214286}, {227,0.000252381}, {228,0.000142857}, {229,0.000190476}, {230,0.000319048}, {231,0.000147619}, {232,0.000166667}, {233,0.000257143}, {234,0.000219048}, {235,0.000295238}, {236,0.000180952}, {237,0.000257143}, {238,0.000152381}, {239,0.000190476}, {240,0.000209524}, {241,0.000200000}, {242,0.000247619}, {243,0.000266667}, {244,0.000242857}, {245,0.000209524}, {246,0.000323810}, {247,0.000300000}, {248,0.000219048}, {249,0.000233333}, {250,0.000223810}, {251,0.000252381}, {252,0.000223810}, {253,0.000342857}, {254,0.000290476}, {255,0.000252381}, {256,0.000176190}, {257,0.000209524}, {258,0.000242857}, {259,0.000228571}, {260,0.000180952}, {261,0.000209524}, {262,0.000180952}, {263,0.000214286}, {264,0.000319048}, {265,0.000228571}, {266,0.000266667}, {267,0.000276190}, {268,0.000214286}, {269,0.000219048}, {270,0.000238095}, {271,0.000252381}, {272,0.000233333}, {273,0.000347619}, {274,0.000295238}, {275,0.000233333}, {276,0.000238095}, {277,0.000338095}, {278,0.000228571}, {279,0.000233333}, {280,0.000209524}, {281,0.000271429}, {282,0.000304762}, {283,0.000233333}, {284,0.000180952}, {285,0.000290476}, {286,0.000352381}, {287,0.000176190}, {288,0.000347619}, {289,0.000280952}, {290,0.000209524}, {291,0.000204762}, {292,0.000280952}, {293,0.000209524}, {294,0.000257143}, {295,0.000200000}, {296,0.000209524}, {297,0.000295238}, {298,0.000195238}, {299,0.000238095}, {300,0.000328571}, {301,0.000261905}, {302,0.000204762}, {303,0.000219048}, {304,0.000271429}, {305,0.000338095}, {306,0.000309524}, {307,0.000266667}, {308,0.000252381}, {309,0.000257143}, {310,0.000295238}, {311,0.000338095}, {312,0.000300000}, {313,0.000471429}, {314,0.000404762}, {315,0.000228571}, {316,0.000404762}, {317,0.000276190}, {318,0.000300000}, {319,0.000314286}, {320,0.000280952}, {321,0.000366667}, {322,0.000214286}, {323,0.000285714}, {324,0.000323810}, {325,0.000185714}, {326,0.000333333}, {327,0.000295238}, {328,0.000257143}, {329,0.000309524}, {330,0.000223810}, {331,0.000271429}, {332,0.000214286}, {333,0.000233333}, {334,0.000400000}, {335,0.000271429}, {336,0.000242857}, {337,0.000266667}, {338,0.000347619}, {339,0.000252381}, {340,0.000319048}, {341,0.000342857}, {342,0.000309524}, {343,0.000319048}, {344,0.000290476}, {345,0.000280952}, {346,0.000138095}, {347,0.000314286}, {348,0.000219048}, {349,0.000376190}, {350,0.000252381}, {351,0.000333333}, {352,0.000238095}, {353,0.000276190}, {354,0.000271429}, {355,0.000333333}, {356,0.000438095}, {357,0.000433333}, {358,0.000309524}, {359,0.000342857}, {360,0.000376190}, {361,0.000185714}, {362,0.000314286}, {363,0.000276190}, {364,0.000176190}, {365,0.000342857}, {366,0.000442857}, {367,0.000300000}, {368,0.000438095}, {369,0.000233333}, {370,0.000385714}, {371,0.000338095}, {372,0.000290476}, {373,0.000480952}, {374,0.000395238}, {375,0.000500000}, {376,0.000395238}, {377,0.000419048}, {378,0.000347619}, {379,0.000300000}, {380,0.000290476}, {381,0.000323810}, {382,0.000423810}, {383,0.000323810}, {384,0.000323810}, {385,0.000271429}, {386,0.000404762}, {387,0.000333333}, {388,0.000219048}, {389,0.000442857}, {390,0.000300000}, {391,0.000290476}, {392,0.000419048}, {393,0.000442857}, {394,0.000390476}, {395,0.000471429}, {396,0.000300000}, {397,0.000366667}, {398,0.000380952}, {399,0.000419048}, {400,0.000285714}, {401,0.000376190}, {402,0.000371429}, {403,0.000409524}, {404,0.000257143}, {405,0.000395238}, {406,0.000452381}, {407,0.000347619}, {408,0.000328571}, {409,0.000385714}, {410,0.000276190}, {411,0.000352381}, {412,0.000385714}, {413,0.000409524}, {414,0.000385714}, {415,0.000361905}, {416,0.000471429}, {417,0.000266667}, {418,0.000480952}, {419,0.000457143}, {420,0.000366667}, {421,0.000423810}, {422,0.000323810}, {423,0.000319048}, {424,0.000371429}, {425,0.000219048}, {426,0.000361905}, {427,0.000400000}, {428,0.000276190}, {429,0.000438095}, {430,0.000371429}, {431,0.000457143}, {432,0.000338095}, {433,0.000352381}, {434,0.000466667}, {435,0.000371429}, {436,0.000461905}, {437,0.000528571}, {438,0.000390476}, {439,0.000276190}, {440,0.000376190}, {441,0.000461905}, {442,0.000242857}, {443,0.000319048}, {444,0.000419048}, {445,0.000328571}, {446,0.000419048}, {447,0.000509524}, {448,0.000395238}, {449,0.000290476}, {450,0.000314286}, {451,0.000338095}, {452,0.000409524}, {453,0.000438095}, {454,0.000495238}, {455,0.000371429}, {456,0.000361905}, {457,0.000419048}, {458,0.000366667}, {459,0.000419048}, {460,0.000519048}, {461,0.000438095}, {462,0.000404762}, {463,0.000566667}, {464,0.000490476}, {465,0.000395238}, {466,0.000395238}, {467,0.006704762}, {468,0.000485714}, {469,0.000514286}, {470,0.000461905}, {471,0.000433333}, {472,0.000400000}, {473,0.000585714}, {474,0.000552381}, {475,0.000414286}, {476,0.000457143}, {477,0.000490476}, {478,0.000357143}, {479,0.000414286}, {480,0.000504762}, {481,0.000452381}, {482,0.000404762}, {483,0.000423810}, {484,0.000466667}, {485,0.000342857}, {486,0.000385714}, {487,0.000419048}, {488,0.000304762}, {489,0.000447619}, {490,0.000466667}, {491,0.000452381}, {492,0.000557143}, {493,0.001376190}, {494,0.000409524}, {495,0.000438095}, {496,0.000404762}, {497,0.000442857}, {498,0.000404762}, {499,0.000309524}, {500,0.000380952}, {505,0.000366667}, {510,0.000409524}, {515,0.000509524}, {520,0.000352381}, {525,0.000314286}, {530,0.000433333}, {535,0.000500000}, {540,0.000466667}, {545,0.000442857}, {550,0.000409524}, {555,0.000423810}, {560,0.000438095}, {565,0.000480952}, {570,0.000514286}, {575,0.000390476}, {580,0.000514286}, {585,0.000514286}, {590,0.000585714}, {595,0.000466667}, {600,0.000533333}, {605,0.002547619}, {610,0.000428571}, {615,0.000495238}, {620,0.000500000}, {625,0.000519048}, {630,0.000490476}, {635,0.000447619}, {640,0.000523810}, {645,0.000500000}, {650,0.000538095}, {655,0.000685714}, {660,0.000633333}, {665,0.000409524}, {670,0.000471429}, {675,0.000585714}, {680,0.000595238}, {685,0.000538095}, {690,0.000633333}, {695,0.000442857}, {700,0.000571429}, {705,0.000609524}, {710,0.000704762}, {715,0.000738095}, {720,0.000585714}, {725,0.000761905}, {730,0.000619048}, {735,0.000657143}, {740,0.000590476}, {745,0.000852381}, {750,0.000914286}, {755,0.000642857}, {760,0.000500000}, {765,0.000714286}, {770,0.000557143}, {775,0.000638095}, {780,0.000733333}, {785,0.000704762}, {790,0.000647619}, {795,0.000700000}, {800,0.000476190}, {805,0.000828571}, {810,0.000719048}, {815,0.000738095}, {820,0.000690476}, {825,0.000580952}, {830,0.000828571}, {835,0.000719048}, {840,0.000528571}, {845,0.000638095}, {850,0.000709524}, {855,0.000657143}, {860,0.000823810}, {865,0.001000000}, {870,0.000676190}, {875,0.000742857}, {880,0.000690476}, {885,0.000814286}, {890,0.000714286}, {895,0.000719048}, {900,0.000566667}, {905,0.000828571}, {910,0.000695238}, {915,0.000719048}, {920,0.000809524}, {925,0.000819048}, {930,0.000604762}, {935,0.000738095}, {940,0.000819048}, {945,0.000580952}, {950,0.000723810}, {955,0.000966667}, {960,0.000828571}, {965,0.000800000}, {970,0.000809524}, {975,0.000828571}, {980,0.000871429}, {985,0.000580952}, {990,0.000876190}, {995,0.001100000}, {1000,0.000919048}, {1010,0.000985714}, {1020,0.000866667}, {1030,0.001009524}, {1040,0.000938095}, {1050,0.000871429}, {1060,0.000947619}, {1070,0.001014286}, {1080,0.001014286}, {1090,0.001009524}, {1100,0.000942857}, {1110,0.001019048}, {1120,0.000833333}, {1130,0.004685714}, {1140,0.001028571}, {1150,0.001109524}, {1160,0.000895238}, {1170,0.001261905}, {1180,0.000909524}, {1190,0.000890476}, {1200,0.001171429}, {1210,0.000852381}, {1220,0.001157143}, {1230,0.001057143}, {1240,0.001042857}, {1250,0.001223810}, {1260,0.001166667}, {1270,0.001290476}, {1280,0.001261905}, {1290,0.000876190}, {1300,0.001242857}, {1310,0.001066667}, {1320,0.001247619}, {1330,0.001271429}, {1340,0.001238095}, {1350,0.001147619}, {1360,0.001085714}, {1370,0.001333333}, {1380,0.000980952}, {1390,0.001323810}, {1400,0.001309524}, {1410,0.018942857}, {1420,0.001371429}, {1430,0.000776190}, {1440,0.001480952}, {1450,0.000995238}, {1460,0.001304762}, {1470,0.001061905}, {1480,0.001476190}, {1490,0.000971429}, {1500,0.001480952}, {1510,0.001647619}, {1520,0.001052381}, {1530,0.001490476}, {1540,0.001028571}, {1550,0.001661905}, {1560,0.001385714}, {1570,0.001323810}, {1580,0.001509524}, {1590,0.001076190}, {1600,0.001542857}, {1610,0.001442857}, {1620,0.001609524}, {1630,0.001633333}, {1640,0.001295238}, {1650,0.001552381}, {1660,0.001600000}, {1670,0.000942857}, {1680,0.001561905}, {1690,0.000990476}, {1700,0.001642857}, {1710,0.001452381}, {1720,0.001319048}, {1730,0.002328571}, {1740,0.001685714}, {1750,0.001157143}, {1760,0.001728571}, {1770,0.001733333}, {1780,0.001147619}, {1790,0.001652381}, {1800,0.001609524}, {1810,0.001271429}, {1820,0.001847619}, {1830,0.002019048}, {1840,0.001338095}, {1850,0.001552381}, {1860,0.001657143}, {1870,0.001247619}, {1880,0.001404762}, {1890,0.002014286}, {1900,0.001780952}, {1910,0.001242857}, {1920,0.002023810}, {1930,0.002080952}, {1940,0.001352381}, {1950,0.001323810}, {1960,0.001966667}, {1970,0.001661905}, {1980,0.001514286}, {1990,0.001419048}, {2000,0.001980952}, {2050,0.002304762}, {2100,0.001714286}, {2150,0.001261905}, {2200,0.002914286}, {2250,0.002514286}, {2300,0.002085714}, {2350,0.001895238}, {2400,0.001757143}, {2450,0.001923810}, {2500,0.001614286}, {2550,0.001661905}, {2600,0.002233333}, {2650,0.002266667}, {2700,0.002214286}, {2750,0.002047619}, {2800,0.001866667}, {2850,0.001942857}, {2900,0.001795238}, {2950,0.009276190}, {3000,0.002409524}, {3050,0.002480952}, {3100,0.003476190}, {3150,0.003785714}, {3200,0.002714286}, {3250,0.002647619}, {3300,0.002995238}, {3350,0.003671429}, {3400,0.026680952}, {3450,0.002352381}, {3500,0.002523810}, {3550,0.003728571}, {3600,0.002533333}, {3650,0.002480952}, {3700,0.006104762}, {3750,0.003261905}, {3800,0.013171429}, {3850,0.002838095}, {3900,0.002476190}, {3950,0.002766667}, {4000,0.003676190}, {4050,0.063419048}, {4100,0.002742857}, {4150,0.002771429}, {4200,0.012161905}, {4250,0.002685714}, {4300,0.002928571}, {4350,0.011447619}, {4400,0.004204762}, {4450,0.003466667}, {4500,0.002890476}, {4550,0.003771429}, {4600,0.012514286}, {4650,0.003076190}, {4700,0.004195238}, {4750,0.003357143}, {4800,0.004338095}, {4850,0.003447619}, {4900,0.004623810}, {4950,0.003552381}, {5000,0.014714286}, {5050,0.00529}, {5100,0.00343}, {5150,0.00371}, {5200,0.00400}, {5250,0.00486}, {5300,0.00471}, {5350,0.00457}, {5400,0.00486}, {5450,0.00371}, {5500,0.00414}, {5550,0.00371}, {5600,0.00514}, {5650,0.00371}, {5700,0.00371}, {5750,0.00371}, {5800,0.00357}, {5850,0.00457}, {5900,0.00443}, {5950,0.00471}, {6000,0.00343}, {6050,0.00471}, {6100,0.00400}, {6150,0.00571}, {6200,0.01357}, {6250,0.00371}, {6300,0.00400}, {6350,0.00414}, {6400,0.00514}, {6450,0.00400}, {6500,0.00500}, {6550,0.00571}, {6600,0.00586}, {6650,0.01314}, {6700,0.00571}, {6750,0.00486}, {6800,0.00414}, {6850,0.00386}, {6900,0.00557}, {6950,0.00657}, {7000,0.00500}, {7050,0.00443}, {7100,0.00543}, {7150,0.00586}, {7200,0.00529}, {7250,0.01743}, {7300,0.00600}, {7350,0.00571}, {7400,0.00571}, {7450,0.00500}, {7500,0.00571}, {7550,0.00514}, {7600,0.00629}, {7650,0.00571}, {7700,0.00429}, {7750,0.00643}, {7800,0.00500}, {7850,0.00686}, {7900,0.00671}, {7950,0.00614}, {8000,0.00600}, {8050,0.00457}, {8100,0.00586}, {8150,0.00614}, {8200,0.00586}, {8250,0.00543}, {8300,0.00671}, {8350,0.00629}, {8400,0.00600}, {8450,0.00729}, {8500,0.00771}, {8550,0.00729}, {8600,0.00743}, {8650,0.00671}, {8700,0.00714}, {8750,0.00743}, {8800,0.00643}, {8850,0.00729}, {8900,0.00814}, {8950,0.00686}, {9000,0.00600}, {9050,0.00714}, {9100,0.01471}, {9150,0.00757}, {9200,0.00743}, {9250,0.00743}, {9300,0.00743}, {9350,0.00671}, {9400,0.00686}, {9450,0.00829}, {9500,0.00800}, {9550,0.00871}, {9600,0.00929}, {9650,0.00786}, {9700,0.00900}, {9750,0.00686}, {9800,0.00900}, {9850,0.00671}, {9900,0.00657}, {9950,0.00857}, {10000,0.00800}, {10100,0.00714}, {10200,0.00786}, {10300,0.01014}, {10400,0.00871}, {10500,0.00757}, {10600,0.01000}, {10700,0.00871}, {10800,0.00957}, {10900,0.00857}, {11000,0.00957}, {11100,0.00786}, {11200,0.03029}, {11300,0.00900}, {11400,0.02871}, {11500,0.00771}, {11600,0.01043}, {11700,0.00943}, {11800,0.01029}, {11900,0.01200}, {12000,0.01014}, {12100,0.00971}, {12200,0.00986}, {12300,0.01114}, {12400,0.02371}, {12500,0.00914}, {12600,0.00886}, {12700,0.01014}, {12800,0.00986}, {12900,0.01100}, {13000,0.01086}, {13100,0.00986}, {13200,0.01029}, {13300,0.01129}, {13400,0.02400}, {13500,0.01057}, {13600,0.01071}, {13700,0.01029}, {13800,0.01000}, {13900,0.01057}, {14000,0.01243}, {14100,0.01000}, {14200,0.01129}, {14300,0.01186}, {14400,0.01114}, {14500,0.01257}, {14600,0.01057}, {14700,0.01200}, {14800,0.01200}, {14900,0.01200}, {15000,0.01314}, {15100,0.01500}, {15200,0.01457}, {15300,0.01371}, {15400,0.01386}, {15500,0.01257}, {15600,0.03400}, {15700,0.01371}, {15800,0.01557}, {15900,0.01414}, {16000,0.01386}, {16100,0.01400}, {16200,0.01414}, {16300,0.01543}, {16400,0.01357}, {16500,0.01700}, {16600,0.04700}, {16700,0.01671}, {16800,0.01400}, {16900,0.01457}, {17000,0.01443}, {17100,0.01443}, {17200,0.01386}, {17300,0.01429}, {17400,0.01514}, {17500,0.01500}, {17600,0.04143}, {17700,0.01514}, {17800,0.04243}, {17900,0.01443}, {18000,0.03486}, {18100,0.01371}, {18200,0.01586}, {18300,0.04429}, {18400,0.01443}, {18500,0.01629}, {18600,0.01429}, {18700,0.01486}, {18800,0.01557}, {18900,0.01557}, {19000,0.01657}, {19100,0.01771}, {19200,0.01729}, {19300,0.01557}, {19400,0.01429}, {19500,0.01471}, {19600,0.01871}, {19700,0.01714}, {19800,0.01571}, {19900,0.01743}, {20000,0.01620}};
data["big"]["beta; Parametricity"]["lazy beta iota"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000019048}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000019048}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000019048}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000019048}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000019048}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000019048}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000019048}, {95,0.000000000}, {96,0.000019048}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000019048}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000019048}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000019048}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000019048}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000019048}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000019048}, {166,0.000000000}, {167,0.000019048}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000019048}, {188,0.000000000}, {189,0.000000000}, {190,0.000019048}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000019048}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000019048}, {230,0.000019048}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000038095}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000014286}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000019048}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000038095}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000038095}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000014286}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000014286}, {307,0.000000000}, {308,0.000000000}, {309,0.000019048}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000019048}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000019048}, {336,0.000000000}, {337,0.000000000}, {338,0.000019048}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000019048}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000019048}, {355,0.000019048}, {356,0.000000000}, {357,0.000000000}, {358,0.000019048}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000019048}, {364,0.000000000}, {365,0.000000000}, {366,0.000038095}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000038095}, {384,0.000019048}, {385,0.000000000}, {386,0.000000000}, {387,0.000019048}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000019048}, {396,0.000019048}, {397,0.000000000}, {398,0.000000000}, {399,0.000019048}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000019048}, {410,0.000019048}, {411,0.000000000}, {412,0.000019048}, {413,0.000000000}, {414,0.000000000}, {415,0.000019048}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000019048}, {422,0.000019048}, {423,0.000000000}, {424,0.000000000}, {425,0.000019048}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000019048}, {440,0.000000000}, {441,0.000000000}, {442,0.000019048}, {443,0.000000000}, {444,0.000000000}, {445,0.000019048}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000038095}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000019048}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000019048}, {466,0.000000000}, {467,0.000019048}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000019048}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000019048}, {486,0.000019048}, {487,0.000000000}, {488,0.000000000}, {489,0.000019048}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000019048}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000019048}, {595,0.000000000}, {600,0.000000000}, {605,0.000019048}, {610,0.000000000}, {615,0.000000000}, {620,0.000019048}, {625,0.000038095}, {630,0.000019048}, {635,0.000000000}, {640,0.000000000}, {645,0.000019048}, {650,0.000019048}, {655,0.000019048}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000019048}, {705,0.000000000}, {710,0.000000000}, {715,0.000019048}, {720,0.000000000}, {725,0.000019048}, {730,0.000000000}, {735,0.000000000}, {740,0.000038095}, {745,0.000019048}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000019048}, {785,0.000000000}, {790,0.000000000}, {795,0.000038095}, {800,0.000000000}, {805,0.000019048}, {810,0.000038095}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000019048}, {885,0.000000000}, {890,0.000019048}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000019048}, {915,0.000000000}, {920,0.000000000}, {925,0.000019048}, {930,0.000000000}, {935,0.000057143}, {940,0.000019048}, {945,0.000019048}, {950,0.000000000}, {955,0.000019048}, {960,0.000019048}, {965,0.000000000}, {970,0.000019048}, {975,0.000000000}, {980,0.000019048}, {985,0.000000000}, {990,0.000000000}, {995,0.000019048}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000019048}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000019048}, {1140,0.000019048}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000019048}, {1180,0.000014286}, {1190,0.000000000}, {1200,0.000019048}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000019048}, {1250,0.000000000}, {1260,0.000019048}, {1270,0.000019048}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000019048}, {1320,0.000019048}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000038095}, {1380,0.000019048}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000019048}, {1450,0.000000000}, {1460,0.000019048}, {1470,0.000000000}, {1480,0.000019048}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000019048}, {1520,0.000000000}, {1530,0.000019048}, {1540,0.000038095}, {1550,0.000038095}, {1560,0.000019048}, {1570,0.000019048}, {1580,0.000019048}, {1590,0.000019048}, {1600,0.000000000}, {1610,0.000038095}, {1620,0.000038095}, {1630,0.000038095}, {1640,0.000000000}, {1650,0.000019048}, {1660,0.000019048}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000033333}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000019048}, {1730,0.000019048}, {1740,0.000019048}, {1750,0.000019048}, {1760,0.000019048}, {1770,0.000019048}, {1780,0.000038095}, {1790,0.000038095}, {1800,0.000000000}, {1810,0.000038095}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000019048}, {1850,0.000019048}, {1860,0.000057143}, {1870,0.000038095}, {1880,0.000019048}, {1890,0.000019048}, {1900,0.000000000}, {1910,0.000019048}, {1920,0.000019048}, {1930,0.000038095}, {1940,0.000019048}, {1950,0.000057143}, {1960,0.000038095}, {1970,0.000000000}, {1980,0.000038095}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000019048}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000038095}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000019048}, {2550,0.000000000}, {2600,0.000019048}, {2650,0.000019048}, {2700,0.000019048}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000019048}, {3000,0.000000000}, {3050,0.000019048}, {3100,0.000038095}, {3150,0.000038095}, {3200,0.000000000}, {3250,0.000019048}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000019048}, {3450,0.000019048}, {3500,0.000000000}, {3550,0.000019048}, {3600,0.000057143}, {3650,0.000000000}, {3700,0.000038095}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000019048}, {3950,0.000019048}, {4000,0.000000000}, {4050,0.000057143}, {4100,0.000019048}, {4150,0.000019048}, {4200,0.000071429}, {4250,0.000038095}, {4300,0.000000000}, {4350,0.000038095}, {4400,0.000057143}, {4450,0.000019048}, {4500,0.000038095}, {4550,0.000000000}, {4600,0.000038095}, {4650,0.000000000}, {4700,0.000038095}, {4750,0.000019048}, {4800,0.000038095}, {4850,0.000000000}, {4900,0.000057143}, {4950,0.000019048}, {5000,0.000000000}, {5050,0.00000}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00057}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00057}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00057}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00057}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00057}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00057}, {19900,0.00000}, {20000,0.00000}};
data["big"]["beta; Parametricity"]["norm reif"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000342857}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000009524}, {19,0.018400000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000004762}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.006838095}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000014286}, {37,0.000047619}, {38,0.000052381}, {39,0.000119048}, {40,0.000171429}, {41,0.000228571}, {42,0.000357143}, {43,0.000461905}, {44,0.000514286}, {45,0.000519048}, {46,0.000523810}, {47,0.000519048}, {48,0.000523810}, {49,0.000523810}, {50,0.000528571}, {51,0.000523810}, {52,0.000557143}, {53,0.000590476}, {54,0.000614286}, {55,0.000671429}, {56,0.000685714}, {57,0.000723810}, {58,0.000771429}, {59,0.000866667}, {60,0.000933333}, {61,0.000985714}, {62,0.001000000}, {63,0.001000000}, {64,0.001000000}, {65,0.001000000}, {66,0.001000000}, {67,0.001000000}, {68,0.001000000}, {69,0.001000000}, {70,0.001000000}, {71,0.001000000}, {72,0.001000000}, {73,0.001000000}, {74,0.001000000}, {75,0.001000000}, {76,0.001000000}, {77,0.001000000}, {78,0.001000000}, {79,0.001000000}, {80,0.001000000}, {81,0.001000000}, {82,0.001000000}, {83,0.001000000}, {84,0.001000000}, {85,0.001000000}, {86,0.001000000}, {87,0.001000000}, {88,0.001000000}, {89,0.001000000}, {90,0.001000000}, {91,0.001000000}, {92,0.001000000}, {93,0.001504762}, {94,0.001047619}, {95,0.001066667}, {96,0.001100000}, {97,0.001128571}, {98,0.001157143}, {99,0.001180952}, {100,0.001223810}, {101,0.001261905}, {102,0.001333333}, {103,0.001452381}, {104,0.001476190}, {105,0.001490476}, {106,0.001509524}, {107,0.001514286}, {108,0.001519048}, {109,0.001519048}, {110,0.001519048}, {111,0.001519048}, {112,0.001519048}, {113,0.001519048}, {114,0.001519048}, {115,0.001519048}, {116,0.001519048}, {117,0.001519048}, {118,0.001523810}, {119,0.001519048}, {120,0.001523810}, {121,0.001523810}, {122,0.001523810}, {123,0.002052381}, {124,0.001538095}, {125,0.001561905}, {126,0.001557143}, {127,0.001552381}, {128,0.001585714}, {129,0.001642857}, {130,0.001690476}, {131,0.001695238}, {132,0.001719048}, {133,0.001738095}, {134,0.001766667}, {135,0.001819048}, {136,0.001828571}, {137,0.001890476}, {138,0.001957143}, {139,0.001995238}, {140,0.001995238}, {141,0.002000000}, {142,0.002000000}, {143,0.002000000}, {144,0.002000000}, {145,0.002004762}, {146,0.002014286}, {147,0.002038095}, {148,0.002071429}, {149,0.002042857}, {150,0.002061905}, {151,0.002090476}, {152,0.002128571}, {153,0.002638095}, {154,0.002204762}, {155,0.002252381}, {156,0.002309524}, {157,0.002366667}, {158,0.002423810}, {159,0.002476190}, {160,0.002514286}, {161,0.002519048}, {162,0.002523810}, {163,0.002519048}, {164,0.002519048}, {165,0.002519048}, {166,0.002519048}, {167,0.002528571}, {168,0.002519048}, {169,0.002519048}, {170,0.002519048}, {171,0.002519048}, {172,0.002519048}, {173,0.002519048}, {174,0.002519048}, {175,0.002523810}, {176,0.002519048}, {177,0.002519048}, {178,0.002519048}, {179,0.002523810}, {180,0.002533333}, {181,0.002519048}, {182,0.002519048}, {183,0.002519048}, {184,0.002519048}, {185,0.002519048}, {186,0.002523810}, {187,0.002519048}, {188,0.002519048}, {189,0.002528571}, {190,0.002523810}, {191,0.002547619}, {192,0.002547619}, {193,0.002571429}, {194,0.002614286}, {195,0.002633333}, {196,0.002657143}, {197,0.002690476}, {198,0.002771429}, {199,0.002723810}, {200,0.002771429}, {201,0.002847619}, {202,0.003000000}, {203,0.003052381}, {204,0.003200000}, {205,0.003942857}, {206,0.003390476}, {207,0.003471429}, {208,0.003495238}, {209,0.003504762}, {210,0.003519048}, {211,0.003519048}, {212,0.003519048}, {213,0.003519048}, {214,0.003519048}, {215,0.003538095}, {216,0.004061905}, {217,0.003519048}, {218,0.003519048}, {219,0.003519048}, {220,0.003519048}, {221,0.003519048}, {222,0.003519048}, {223,0.003519048}, {224,0.003519048}, {225,0.003519048}, {226,0.003519048}, {227,0.003519048}, {228,0.003523810}, {229,0.003519048}, {230,0.003519048}, {231,0.003519048}, {232,0.003519048}, {233,0.003519048}, {234,0.003523810}, {235,0.003519048}, {236,0.003538095}, {237,0.004533333}, {238,0.003557143}, {239,0.003576190}, {240,0.003561905}, {241,0.003604762}, {242,0.003614286}, {243,0.003661905}, {244,0.003695238}, {245,0.003738095}, {246,0.003776190}, {247,0.003847619}, {248,0.004519048}, {249,0.003952381}, {250,0.004000000}, {251,0.004019048}, {252,0.004066667}, {253,0.004090476}, {254,0.004128571}, {255,0.004147619}, {256,0.004638095}, {257,0.004133333}, {258,0.004190476}, {259,0.004947619}, {260,0.004228571}, {261,0.004266667}, {262,0.004304762}, {263,0.004400000}, {264,0.004423810}, {265,0.005557143}, {266,0.004504762}, {267,0.004519048}, {268,0.004519048}, {269,0.004523810}, {270,0.004538095}, {271,0.004523810}, {272,0.004533333}, {273,0.004547619}, {274,0.006152381}, {275,0.004547619}, {276,0.004552381}, {277,0.004547619}, {278,0.004566667}, {279,0.004619048}, {280,0.005104762}, {281,0.004666667}, {282,0.004723810}, {283,0.004761905}, {284,0.004800000}, {285,0.004819048}, {286,0.004885714}, {287,0.004928571}, {288,0.004966667}, {289,0.004995238}, {290,0.005585714}, {291,0.006300000}, {292,0.005038095}, {293,0.005038095}, {294,0.005038095}, {295,0.005038095}, {296,0.005038095}, {297,0.005042857}, {298,0.005038095}, {299,0.007100000}, {300,0.005680952}, {301,0.005038095}, {302,0.005038095}, {303,0.005042857}, {304,0.005057143}, {305,0.005066667}, {306,0.005090476}, {307,0.007600000}, {308,0.005090476}, {309,0.006023810}, {310,0.005152381}, {311,0.005152381}, {312,0.005138095}, {313,0.005190476}, {314,0.005347619}, {315,0.007366667}, {316,0.005438095}, {317,0.005590476}, {318,0.005685714}, {319,0.005800000}, {320,0.005847619}, {321,0.005919048}, {322,0.005957143}, {323,0.005976190}, {324,0.005995238}, {325,0.006004762}, {326,0.006019048}, {327,0.006033333}, {328,0.006038095}, {329,0.006038095}, {330,0.009633333}, {331,0.006042857}, {332,0.006038095}, {333,0.006038095}, {334,0.006038095}, {335,0.006038095}, {336,0.006661905}, {337,0.006038095}, {338,0.006038095}, {339,0.006042857}, {340,0.006052381}, {341,0.006066667}, {342,0.006071429}, {343,0.006085714}, {344,0.006123810}, {345,0.006100000}, {346,0.006109524}, {347,0.006157143}, {348,0.006266667}, {349,0.006266667}, {350,0.006323810}, {351,0.006400000}, {352,0.006385714}, {353,0.007290476}, {354,0.006476190}, {355,0.006533333}, {356,0.006566667}, {357,0.006585714}, {358,0.006690476}, {359,0.006614286}, {360,0.006647619}, {361,0.007528571}, {362,0.006704762}, {363,0.006738095}, {364,0.006742857}, {365,0.006847619}, {366,0.006904762}, {367,0.006957143}, {368,0.007004762}, {369,0.008004762}, {370,0.007042857}, {371,0.007057143}, {372,0.010714286}, {373,0.007057143}, {374,0.007066667}, {375,0.007085714}, {376,0.007138095}, {377,0.008333333}, {378,0.007266667}, {379,0.007266667}, {380,0.007309524}, {381,0.007342857}, {382,0.007409524}, {383,0.007442857}, {384,0.007452381}, {385,0.011561905}, {386,0.007500000}, {387,0.007519048}, {388,0.007533333}, {389,0.007538095}, {390,0.007557143}, {391,0.007619048}, {392,0.007561905}, {393,0.007566667}, {394,0.007561905}, {395,0.007576190}, {396,0.007566667}, {397,0.007671429}, {398,0.012666667}, {399,0.007580952}, {400,0.008223810}, {401,0.007628571}, {402,0.007666667}, {403,0.007695238}, {404,0.011514286}, {405,0.007761905}, {406,0.007852381}, {407,0.008766667}, {408,0.008014286}, {409,0.008085714}, {410,0.012519048}, {411,0.008285714}, {412,0.008433333}, {413,0.008457143}, {414,0.008490476}, {415,0.008528571}, {416,0.014190476}, {417,0.008523810}, {418,0.008533333}, {419,0.008542857}, {420,0.008557143}, {421,0.008571429}, {422,0.014052381}, {423,0.008557143}, {424,0.008561905}, {425,0.008566667}, {426,0.008590476}, {427,0.008600000}, {428,0.014000000}, {429,0.008638095}, {430,0.008661905}, {431,0.008671429}, {432,0.008714286}, {433,0.008757143}, {434,0.012804762}, {435,0.008842857}, {436,0.008923810}, {437,0.008961905}, {438,0.008990476}, {439,0.009090476}, {440,0.009071429}, {441,0.009095238}, {442,0.010042857}, {443,0.009114286}, {444,0.009142857}, {445,0.015476190}, {446,0.009195238}, {447,0.009228571}, {448,0.009266667}, {449,0.010123810}, {450,0.009614286}, {451,0.014123810}, {452,0.009485714}, {453,0.009509524}, {454,0.009676190}, {455,0.012542857}, {456,0.018400000}, {457,0.039085714}, {458,0.009938095}, {459,0.009885714}, {460,0.009928571}, {461,0.009985714}, {462,0.015557143}, {463,0.010028571}, {464,0.010100000}, {465,0.010038095}, {466,0.010109524}, {467,0.010190476}, {468,0.010095238}, {469,0.010109524}, {470,0.010147619}, {471,0.010133333}, {472,0.010261905}, {473,0.010176190}, {474,0.010161905}, {475,0.010180952}, {476,0.010214286}, {477,0.010214286}, {478,0.015295238}, {479,0.010371429}, {480,0.010342857}, {481,0.011728571}, {482,0.010500000}, {483,0.016266667}, {484,0.010638095}, {485,0.010704762}, {486,0.010800000}, {487,0.012014286}, {488,0.010985714}, {489,0.010938095}, {490,0.011038095}, {491,0.011061905}, {492,0.011052381}, {493,0.011266667}, {494,0.011147619}, {495,0.011138095}, {496,0.011128571}, {497,0.011171429}, {498,0.011290476}, {499,0.011166667}, {500,0.011190476}, {505,0.012557143}, {510,0.011628571}, {515,0.011857143}, {520,0.011985714}, {525,0.013371429}, {530,0.012528571}, {535,0.012695238}, {540,0.012890476}, {545,0.012985714}, {550,0.013276190}, {555,0.014171429}, {560,0.013757143}, {565,0.020223810}, {570,0.014038095}, {575,0.014214286}, {580,0.015809524}, {585,0.014871429}, {590,0.015066667}, {595,0.015190476}, {600,0.015347619}, {605,0.015528571}, {610,0.021690476}, {615,0.016114286}, {620,0.016319048}, {625,0.016471429}, {630,0.025009524}, {635,0.016957143}, {640,0.017233333}, {645,0.017504762}, {650,0.025709524}, {655,0.019242857}, {660,0.018109524}, {665,0.018333333}, {670,0.026009524}, {675,0.018961905}, {680,0.019180952}, {685,0.019409524}, {690,0.019628571}, {695,0.019957143}, {700,0.021623810}, {705,0.020723810}, {710,0.020680952}, {715,0.020880952}, {720,0.021209524}, {725,0.029480952}, {730,0.021728571}, {735,0.022019048}, {740,0.022447619}, {745,0.022485714}, {750,0.022871429}, {755,0.023090476}, {760,0.032576190}, {765,0.023647619}, {770,0.023928571}, {775,0.024580952}, {780,0.024452381}, {785,0.024761905}, {790,0.025000000}, {795,0.025352381}, {800,0.025776190}, {805,0.026000000}, {810,0.029571429}, {815,0.026519048}, {820,0.026833333}, {825,0.031328571}, {830,0.027433333}, {835,0.027719048}, {840,0.034385714}, {845,0.028376190}, {850,0.028700000}, {855,0.029166667}, {860,0.029257143}, {865,0.029566667}, {870,0.030219048}, {875,0.033290476}, {880,0.030542857}, {885,0.031147619}, {890,0.031157143}, {895,0.032109524}, {900,0.046676190}, {905,0.032057143}, {910,0.033933333}, {915,0.046052381}, {920,0.033047619}, {925,0.033347619}, {930,0.045838095}, {935,0.034080952}, {940,0.034366667}, {945,0.047385714}, {950,0.035138095}, {955,0.035557143}, {960,0.037633333}, {965,0.036085714}, {970,0.051466667}, {975,0.036057143}, {980,0.036266667}, {985,0.046780952}, {990,0.036866667}, {995,0.037242857}, {1000,0.037666667}, {1010,0.038295238}, {1020,0.054461905}, {1030,0.040176190}, {1040,0.040485714}, {1050,0.040823810}, {1060,0.041890476}, {1070,0.059500000}, {1080,0.043800000}, {1090,0.044357143}, {1100,0.044823810}, {1110,0.045619048}, {1120,0.060371429}, {1130,0.047104762}, {1140,0.048190476}, {1150,0.048709524}, {1160,0.051190476}, {1170,0.050247619}, {1180,0.051095238}, {1190,0.062728571}, {1200,0.052757143}, {1210,0.071366667}, {1220,0.054423810}, {1230,0.074357143}, {1240,0.057385714}, {1250,0.057023810}, {1260,0.057780952}, {1270,0.058785714}, {1280,0.059600000}, {1290,0.061623810}, {1300,0.063104762}, {1310,0.066461905}, {1320,0.063842857}, {1330,0.064914286}, {1340,0.065919048}, {1350,0.066595238}, {1360,0.069785714}, {1370,0.069042857}, {1380,0.075733333}, {1390,0.071923810}, {1400,0.072119048}, {1410,0.072714286}, {1420,0.074900000}, {1430,0.105871429}, {1440,0.075452381}, {1450,0.095028571}, {1460,0.078404762}, {1470,0.106114286}, {1480,0.080904762}, {1490,0.086128571}, {1500,0.083714286}, {1510,0.148680952}, {1520,0.123523810}, {1530,0.087209524}, {1540,0.109366667}, {1550,0.089585714}, {1560,0.090957143}, {1570,0.092709524}, {1580,0.093390476}, {1590,0.115090476}, {1600,0.095742857}, {1610,0.096923810}, {1620,0.098966667}, {1630,0.099490476}, {1640,0.119185714}, {1650,0.102352381}, {1660,0.103457143}, {1670,0.136552381}, {1680,0.106328571}, {1690,0.126438095}, {1700,0.109966667}, {1710,0.113395238}, {1720,0.116376190}, {1730,0.115733333}, {1740,0.114966667}, {1750,0.121590476}, {1760,0.153457143}, {1770,0.119752381}, {1780,0.130747619}, {1790,0.122976190}, {1800,0.128338095}, {1810,0.133400000}, {1820,0.129076190}, {1830,0.129800000}, {1840,0.151985714}, {1850,0.136971429}, {1860,0.134628571}, {1870,0.154952381}, {1880,0.174042857}, {1890,0.138842857}, {1900,0.144780952}, {1910,0.164828571}, {1920,0.145128571}, {1930,0.145500000}, {1940,0.160190476}, {1950,0.179271429}, {1960,0.151061905}, {1970,0.153771429}, {1980,0.171195238}, {1990,0.184085714}, {2000,0.159076190}, {2050,0.165166667}, {2100,0.192057143}, {2150,0.199300000}, {2200,0.194847619}, {2250,0.205933333}, {2300,0.218471429}, {2350,0.265500000}, {2400,0.274161905}, {2450,0.303352381}, {2500,0.316261905}, {2550,0.328585714}, {2600,0.329547619}, {2650,0.341304762}, {2700,0.346076190}, {2750,0.343319048}, {2800,0.359333333}, {2850,0.402595238}, {2900,0.384652381}, {2950,0.403947619}, {3000,0.409666667}, {3050,0.426652381}, {3100,0.440200000}, {3150,0.465385714}, {3200,0.507342857}, {3250,0.505419048}, {3300,0.522200000}, {3350,0.520095238}, {3400,0.539828571}, {3450,0.623419048}, {3500,0.632909524}, {3550,0.606261905}, {3600,0.700414286}, {3650,0.668319048}, {3700,0.659333333}, {3750,0.701400000}, {3800,0.708714286}, {3850,0.810090476}, {3900,0.778919048}, {3950,0.848071429}, {4000,0.814390476}, {4050,0.827938095}, {4100,0.882395238}, {4150,0.898938095}, {4200,0.933071429}, {4250,1.046909524}, {4300,0.967119048}, {4350,1.065385714}, {4400,1.030338095}, {4450,1.111528571}, {4500,1.147366667}, {4550,1.117776190}, {4600,1.181661905}, {4650,1.323680952}, {4700,1.300861905}, {4750,1.272780952}, {4800,1.309742857}, {4850,1.425904762}, {4900,1.415571429}, {4950,1.428776190}, {5000,1.449495238}, {5050,1.62529}, {5100,1.66871}, {5150,1.69657}, {5200,1.68829}, {5250,1.76700}, {5300,1.85600}, {5350,1.90457}, {5400,1.95614}, {5450,1.98371}, {5500,1.99629}, {5550,2.05343}, {5600,2.07314}, {5650,2.14014}, {5700,2.17043}, {5750,2.27029}, {5800,2.30814}, {5850,2.34743}, {5900,2.41614}, {5950,2.38314}, {6000,2.52543}, {6050,2.64314}, {6100,2.56314}, {6150,2.70043}, {6200,2.69829}, {6250,2.77186}, {6300,2.79214}, {6350,2.91371}, {6400,2.88286}, {6450,3.00871}, {6500,2.97414}, {6550,3.14086}, {6600,3.09243}, {6650,3.19886}, {6700,3.40243}, {6750,3.39257}, {6800,3.44786}, {6850,3.46757}, {6900,3.49686}, {6950,3.70614}, {7000,3.66871}, {7050,3.85357}, {7100,3.91371}, {7150,3.87171}, {7200,3.91157}, {7250,4.02714}, {7300,4.02500}, {7350,4.09843}, {7400,4.21100}, {7450,4.22871}, {7500,4.34157}, {7550,4.40014}, {7600,4.40314}, {7650,4.47329}, {7700,4.58243}, {7750,4.58729}, {7800,4.65314}, {7850,4.79414}, {7900,5.83514}, {7950,4.84814}, {8000,4.91071}, {8050,5.07200}, {8100,5.07171}, {8150,5.65386}, {8200,5.23857}, {8250,5.21500}, {8300,5.42629}, {8350,5.49357}, {8400,5.60314}, {8450,5.65114}, {8500,5.63043}, {8550,5.84643}, {8600,5.90514}, {8650,6.02286}, {8700,6.03086}, {8750,6.03157}, {8800,6.26586}, {8850,6.28786}, {8900,6.32100}, {8950,6.37143}, {9000,7.54000}, {9050,6.59014}, {9100,7.21729}, {9150,6.55871}, {9200,6.84114}, {9250,6.74500}, {9300,6.99014}, {9350,6.85129}, {9400,7.14243}, {9450,6.97314}, {9500,7.33386}, {9550,7.14671}, {9600,7.46443}, {9650,7.26043}, {9700,7.62357}, {9750,8.20443}, {9800,7.72086}, {9850,7.92271}, {9900,7.63957}, {9950,7.87057}, {10000,8.15514}, {10100,7.96243}, {10200,8.29971}, {10300,8.30600}, {10400,8.77443}, {10500,8.94614}, {10600,8.78386}, {10700,10.28857}, {10800,9.06914}, {10900,9.78571}, {11000,9.52700}, {11100,9.79957}, {11200,9.92314}, {11300,11.37514}, {11400,10.65757}, {11500,10.55314}, {11600,11.46071}, {11700,11.62129}, {11800,11.37486}, {11900,11.59900}, {12000,11.76857}, {12100,11.99243}, {12200,12.12500}, {12300,12.46129}, {12400,12.56157}, {12500,12.77571}, {12600,12.98700}, {12700,13.17886}, {12800,13.37971}, {12900,13.59657}, {13000,13.89057}, {13100,14.07171}, {13200,14.25314}, {13300,14.45543}, {13400,14.66157}, {13500,15.09243}, {13600,15.07329}, {13700,15.27771}, {13800,15.69643}, {13900,16.01357}, {14000,15.94386}, {14100,16.19414}, {14200,16.66400}, {14300,17.40957}, {14400,18.16857}, {14500,17.18586}, {14600,18.51686}, {14700,17.66286}, {14800,18.07086}, {14900,18.52214}, {15000,18.68543}, {15100,18.73429}, {15200,18.81586}, {15300,19.17414}, {15400,19.44543}, {15500,19.78729}, {15600,20.10929}, {15700,20.54200}, {15800,20.91814}, {15900,21.18371}, {16000,21.54729}, {16100,21.74114}, {16200,22.08986}, {16300,22.29886}, {16400,22.89200}, {16500,22.87229}, {16600,23.23986}, {16700,23.65743}, {16800,24.08657}, {16900,24.19514}, {17000,24.77271}, {17100,24.61671}, {17200,25.53257}, {17300,25.60314}, {17400,26.17571}, {17500,26.37000}, {17600,26.14571}, {17700,26.97800}, {17800,27.07457}, {17900,27.50586}, {18000,27.58629}, {18100,28.11629}, {18200,28.84086}, {18300,28.73700}, {18400,29.07814}, {18500,29.68586}, {18600,29.79943}, {18700,29.50100}, {18800,30.25029}, {18900,30.39457}, {19000,30.67471}, {19100,31.08971}, {19200,31.73757}, {19300,32.65686}, {19400,33.91957}, {19500,34.06371}, {19600,33.29471}, {19700,33.46443}, {19800,32.68157}, {19900,33.01986}, {20000,30.00360}};
data["big"]["beta; Parametricity"]["norm reif"]["user"] = {{1,0.000300000}, {2,0.000390476}, {3,0.000290476}, {4,0.000347619}, {5,0.000361905}, {6,0.000338095}, {7,0.000328571}, {8,0.000371429}, {9,0.000276190}, {10,0.000309524}, {11,0.000371429}, {12,0.000433333}, {13,0.000342857}, {14,0.000747619}, {15,0.000366667}, {16,0.000390476}, {17,0.000419048}, {18,0.000433333}, {19,0.018676190}, {20,0.000490476}, {21,0.000423810}, {22,0.000495238}, {23,0.000557143}, {24,0.000604762}, {25,0.000447619}, {26,0.000733333}, {27,0.007219048}, {28,0.000642857}, {29,0.000504762}, {30,0.000509524}, {31,0.000609524}, {32,0.000523810}, {33,0.000652381}, {34,0.000880952}, {35,0.000885714}, {36,0.000438095}, {37,0.000752381}, {38,0.000833333}, {39,0.000604762}, {40,0.000761905}, {41,0.000876190}, {42,0.000533333}, {43,0.000833333}, {44,0.000704762}, {45,0.000885714}, {46,0.000919048}, {47,0.000671429}, {48,0.000885714}, {49,0.000938095}, {50,0.000847619}, {51,0.000814286}, {52,0.000866667}, {53,0.000914286}, {54,0.001123810}, {55,0.000890476}, {56,0.000728571}, {57,0.000780952}, {58,0.000961905}, {59,0.000885714}, {60,0.001004762}, {61,0.001123810}, {62,0.001119048}, {63,0.000942857}, {64,0.000804762}, {65,0.000780952}, {66,0.000885714}, {67,0.001242857}, {68,0.001119048}, {69,0.001138095}, {70,0.001042857}, {71,0.001219048}, {72,0.001309524}, {73,0.001180952}, {74,0.001166667}, {75,0.001047619}, {76,0.000990476}, {77,0.000980952}, {78,0.001214286}, {79,0.001209524}, {80,0.001190476}, {81,0.001109524}, {82,0.001257143}, {83,0.001295238}, {84,0.001242857}, {85,0.001319048}, {86,0.001309524}, {87,0.001290476}, {88,0.001452381}, {89,0.001533333}, {90,0.001647619}, {91,0.001547619}, {92,0.001485714}, {93,0.001795238}, {94,0.001514286}, {95,0.001371429}, {96,0.001342857}, {97,0.001314286}, {98,0.001338095}, {99,0.001590476}, {100,0.001671429}, {101,0.001547619}, {102,0.001500000}, {103,0.001542857}, {104,0.001576190}, {105,0.001480952}, {106,0.001566667}, {107,0.001500000}, {108,0.001433333}, {109,0.001552381}, {110,0.001780952}, {111,0.001690476}, {112,0.001600000}, {113,0.001690476}, {114,0.001590476}, {115,0.001690476}, {116,0.001561905}, {117,0.001738095}, {118,0.001909524}, {119,0.001895238}, {120,0.001747619}, {121,0.001652381}, {122,0.001823810}, {123,0.002114286}, {124,0.001914286}, {125,0.001780952}, {126,0.001819048}, {127,0.001876190}, {128,0.001742857}, {129,0.001952381}, {130,0.001633333}, {131,0.001742857}, {132,0.001861905}, {133,0.002019048}, {134,0.001761905}, {135,0.001685714}, {136,0.002171429}, {137,0.001857143}, {138,0.001985714}, {139,0.001738095}, {140,0.002219048}, {141,0.002019048}, {142,0.002019048}, {143,0.002014286}, {144,0.002161905}, {145,0.001985714}, {146,0.001890476}, {147,0.002109524}, {148,0.002157143}, {149,0.002109524}, {150,0.002095238}, {151,0.002161905}, {152,0.002033333}, {153,0.002757143}, {154,0.002052381}, {155,0.002219048}, {156,0.002280952}, {157,0.002200000}, {158,0.002304762}, {159,0.002323810}, {160,0.001966667}, {161,0.002466667}, {162,0.002276190}, {163,0.002285714}, {164,0.002333333}, {165,0.002409524}, {166,0.002342857}, {167,0.002609524}, {168,0.002271429}, {169,0.002495238}, {170,0.002276190}, {171,0.002390476}, {172,0.002433333}, {173,0.002519048}, {174,0.002485714}, {175,0.002238095}, {176,0.002600000}, {177,0.002428571}, {178,0.002666667}, {179,0.002538095}, {180,0.002519048}, {181,0.002647619}, {182,0.002519048}, {183,0.002700000}, {184,0.002623810}, {185,0.002628571}, {186,0.002580952}, {187,0.002628571}, {188,0.002500000}, {189,0.002828571}, {190,0.002809524}, {191,0.002747619}, {192,0.002828571}, {193,0.002800000}, {194,0.002761905}, {195,0.002823810}, {196,0.002947619}, {197,0.002642857}, {198,0.002766667}, {199,0.002809524}, {200,0.002980952}, {201,0.002900000}, {202,0.002838095}, {203,0.003047619}, {204,0.002957143}, {205,0.003709524}, {206,0.002823810}, {207,0.003004762}, {208,0.003138095}, {209,0.003000000}, {210,0.003061905}, {211,0.002952381}, {212,0.003014286}, {213,0.003252381}, {214,0.003138095}, {215,0.003233333}, {216,0.004038095}, {217,0.003347619}, {218,0.003166667}, {219,0.003100000}, {220,0.003528571}, {221,0.003352381}, {222,0.003271429}, {223,0.003452381}, {224,0.003342857}, {225,0.003404762}, {226,0.003433333}, {227,0.003361905}, {228,0.003495238}, {229,0.003395238}, {230,0.003409524}, {231,0.003490476}, {232,0.003671429}, {233,0.003442857}, {234,0.003514286}, {235,0.003433333}, {236,0.003628571}, {237,0.004471429}, {238,0.003547619}, {239,0.003800000}, {240,0.003690476}, {241,0.003866667}, {242,0.003661905}, {243,0.003790476}, {244,0.003809524}, {245,0.003623810}, {246,0.003838095}, {247,0.003785714}, {248,0.004385714}, {249,0.003714286}, {250,0.003833333}, {251,0.003771429}, {252,0.003866667}, {253,0.003880952}, {254,0.003823810}, {255,0.003966667}, {256,0.004561905}, {257,0.003995238}, {258,0.004128571}, {259,0.004590476}, {260,0.004071429}, {261,0.004223810}, {262,0.004038095}, {263,0.004123810}, {264,0.004109524}, {265,0.005438095}, {266,0.004200000}, {267,0.004114286}, {268,0.004295238}, {269,0.004366667}, {270,0.004180952}, {271,0.004452381}, {272,0.004271429}, {273,0.004352381}, {274,0.006171429}, {275,0.004333333}, {276,0.004304762}, {277,0.004466667}, {278,0.004595238}, {279,0.004652381}, {280,0.005123810}, {281,0.004809524}, {282,0.004847619}, {283,0.004733333}, {284,0.005104762}, {285,0.004919048}, {286,0.004604762}, {287,0.004804762}, {288,0.004738095}, {289,0.004647619}, {290,0.005438095}, {291,0.006342857}, {292,0.004919048}, {293,0.004771429}, {294,0.004842857}, {295,0.004942857}, {296,0.004871429}, {297,0.004766667}, {298,0.004838095}, {299,0.007104762}, {300,0.005357143}, {301,0.005104762}, {302,0.004852381}, {303,0.004876190}, {304,0.004942857}, {305,0.005195238}, {306,0.005442857}, {307,0.008000000}, {308,0.005238095}, {309,0.006114286}, {310,0.005276190}, {311,0.005238095}, {312,0.005347619}, {313,0.005138095}, {314,0.005257143}, {315,0.007447619}, {316,0.005595238}, {317,0.005557143}, {318,0.005642857}, {319,0.005371429}, {320,0.005542857}, {321,0.005476190}, {322,0.005623810}, {323,0.005723810}, {324,0.005709524}, {325,0.005852381}, {326,0.005657143}, {327,0.005809524}, {328,0.005880952}, {329,0.005733333}, {330,0.009647619}, {331,0.005680952}, {332,0.005914286}, {333,0.006019048}, {334,0.005900000}, {335,0.006128571}, {336,0.006895238}, {337,0.006228571}, {338,0.006057143}, {339,0.006100000}, {340,0.005933333}, {341,0.006100000}, {342,0.006380952}, {343,0.006228571}, {344,0.006123810}, {345,0.006076190}, {346,0.006561905}, {347,0.006509524}, {348,0.006571429}, {349,0.006285714}, {350,0.006457143}, {351,0.006580952}, {352,0.006804762}, {353,0.007438095}, {354,0.006728571}, {355,0.006671429}, {356,0.006500000}, {357,0.006642857}, {358,0.006576190}, {359,0.006642857}, {360,0.006800000}, {361,0.007614286}, {362,0.006738095}, {363,0.006861905}, {364,0.007176190}, {365,0.006995238}, {366,0.006857143}, {367,0.006976190}, {368,0.006933333}, {369,0.008257143}, {370,0.006847619}, {371,0.006823810}, {372,0.010295238}, {373,0.006980952}, {374,0.006957143}, {375,0.006971429}, {376,0.007233333}, {377,0.008200000}, {378,0.007171429}, {379,0.007414286}, {380,0.007290476}, {381,0.007352381}, {382,0.007280952}, {383,0.007428571}, {384,0.007352381}, {385,0.011538095}, {386,0.007666667}, {387,0.007747619}, {388,0.007809524}, {389,0.007928571}, {390,0.008057143}, {391,0.008057143}, {392,0.007304762}, {393,0.007671429}, {394,0.008033333}, {395,0.007752381}, {396,0.007833333}, {397,0.007976190}, {398,0.012919048}, {399,0.007776190}, {400,0.008571429}, {401,0.007966667}, {402,0.008142857}, {403,0.007976190}, {404,0.011742857}, {405,0.007995238}, {406,0.008204762}, {407,0.009100000}, {408,0.008219048}, {409,0.008309524}, {410,0.012428571}, {411,0.008233333}, {412,0.008557143}, {413,0.008419048}, {414,0.008380952}, {415,0.008400000}, {416,0.014023810}, {417,0.008828571}, {418,0.008328571}, {419,0.008538095}, {420,0.008638095}, {421,0.008495238}, {422,0.014195238}, {423,0.008890476}, {424,0.008676190}, {425,0.008923810}, {426,0.008857143}, {427,0.008861905}, {428,0.014314286}, {429,0.008690476}, {430,0.009166667}, {431,0.008780952}, {432,0.009219048}, {433,0.009009524}, {434,0.012752381}, {435,0.009138095}, {436,0.009080952}, {437,0.008900000}, {438,0.009157143}, {439,0.009400000}, {440,0.009319048}, {441,0.009300000}, {442,0.010457143}, {443,0.009538095}, {444,0.009590476}, {445,0.015752381}, {446,0.009604762}, {447,0.009428571}, {448,0.009580952}, {449,0.010438095}, {450,0.009880952}, {451,0.014166667}, {452,0.009766667}, {453,0.009728571}, {454,0.009861905}, {455,0.012580952}, {456,0.018409524}, {457,0.038919048}, {458,0.009947619}, {459,0.009952381}, {460,0.009933333}, {461,0.010061905}, {462,0.015552381}, {463,0.010200000}, {464,0.010257143}, {465,0.010242857}, {466,0.010242857}, {467,0.010342857}, {468,0.010371429}, {469,0.010433333}, {470,0.010261905}, {471,0.010514286}, {472,0.010657143}, {473,0.010471429}, {474,0.010380952}, {475,0.010657143}, {476,0.010342857}, {477,0.010561905}, {478,0.015595238}, {479,0.010442857}, {480,0.010719048}, {481,0.012100000}, {482,0.010657143}, {483,0.016295238}, {484,0.010895238}, {485,0.010995238}, {486,0.010819048}, {487,0.012304762}, {488,0.011161905}, {489,0.010704762}, {490,0.011071429}, {491,0.010990476}, {492,0.011019048}, {493,0.011423810}, {494,0.011095238}, {495,0.011347619}, {496,0.011366667}, {497,0.011019048}, {498,0.011319048}, {499,0.011238095}, {500,0.011604762}, {505,0.012566667}, {510,0.011633333}, {515,0.012085714}, {520,0.012123810}, {525,0.013466667}, {530,0.012352381}, {535,0.012528571}, {540,0.012890476}, {545,0.012923810}, {550,0.013157143}, {555,0.014219048}, {560,0.013557143}, {565,0.020080952}, {570,0.013909524}, {575,0.014561905}, {580,0.015542857}, {585,0.014785714}, {590,0.014852381}, {595,0.015195238}, {600,0.015328571}, {605,0.015623810}, {610,0.021833333}, {615,0.015976190}, {620,0.016280952}, {625,0.016314286}, {630,0.024652381}, {635,0.016842857}, {640,0.017242857}, {645,0.017438095}, {650,0.025419048}, {655,0.018923810}, {660,0.018071429}, {665,0.018495238}, {670,0.025742857}, {675,0.018828571}, {680,0.018942857}, {685,0.019466667}, {690,0.019333333}, {695,0.019733333}, {700,0.021438095}, {705,0.020547619}, {710,0.020509524}, {715,0.020666667}, {720,0.021061905}, {725,0.028676190}, {730,0.021485714}, {735,0.021628571}, {740,0.022147619}, {745,0.022042857}, {750,0.022276190}, {755,0.022661905}, {760,0.031966667}, {765,0.023176190}, {770,0.023461905}, {775,0.024057143}, {780,0.023957143}, {785,0.024190476}, {790,0.024557143}, {795,0.025019048}, {800,0.025538095}, {805,0.025528571}, {810,0.029061905}, {815,0.026319048}, {820,0.026300000}, {825,0.030666667}, {830,0.027023810}, {835,0.027485714}, {840,0.033700000}, {845,0.028090476}, {850,0.028057143}, {855,0.029200000}, {860,0.029085714}, {865,0.029152381}, {870,0.029661905}, {875,0.033061905}, {880,0.030085714}, {885,0.030523810}, {890,0.030638095}, {895,0.031504762}, {900,0.045857143}, {905,0.031642857}, {910,0.033090476}, {915,0.045052381}, {920,0.032276190}, {925,0.032452381}, {930,0.044895238}, {935,0.033266667}, {940,0.033619048}, {945,0.046290476}, {950,0.034138095}, {955,0.034485714}, {960,0.036904762}, {965,0.035219048}, {970,0.050347619}, {975,0.035657143}, {980,0.036338095}, {985,0.046709524}, {990,0.037061905}, {995,0.037176190}, {1000,0.037680952}, {1010,0.038280952}, {1020,0.054238095}, {1030,0.039861905}, {1040,0.040695238}, {1050,0.041019048}, {1060,0.041885714}, {1070,0.059690476}, {1080,0.043780952}, {1090,0.044471429}, {1100,0.045057143}, {1110,0.045742857}, {1120,0.060571429}, {1130,0.047076190}, {1140,0.048257143}, {1150,0.048709524}, {1160,0.051414286}, {1170,0.050100000}, {1180,0.051352381}, {1190,0.062700000}, {1200,0.052780952}, {1210,0.071290476}, {1220,0.054538095}, {1230,0.074452381}, {1240,0.057266667}, {1250,0.056904762}, {1260,0.057690476}, {1270,0.058700000}, {1280,0.059495238}, {1290,0.061995238}, {1300,0.063023810}, {1310,0.066685714}, {1320,0.064042857}, {1330,0.064995238}, {1340,0.065966667}, {1350,0.066719048}, {1360,0.069633333}, {1370,0.069109524}, {1380,0.076038095}, {1390,0.071814286}, {1400,0.072357143}, {1410,0.072847619}, {1420,0.074595238}, {1430,0.105890476}, {1440,0.075433333}, {1450,0.095100000}, {1460,0.078452381}, {1470,0.105895238}, {1480,0.080861905}, {1490,0.086423810}, {1500,0.083804762}, {1510,0.144457143}, {1520,0.121528571}, {1530,0.085071429}, {1540,0.106928571}, {1550,0.087242857}, {1560,0.088690476}, {1570,0.090652381}, {1580,0.091157143}, {1590,0.112838095}, {1600,0.093685714}, {1610,0.095057143}, {1620,0.096704762}, {1630,0.097500000}, {1640,0.116952381}, {1650,0.100580952}, {1660,0.101533333}, {1670,0.134238095}, {1680,0.104280952}, {1690,0.124038095}, {1700,0.107847619}, {1710,0.111438095}, {1720,0.114076190}, {1730,0.113600000}, {1740,0.113000000}, {1750,0.119361905}, {1760,0.150952381}, {1770,0.117409524}, {1780,0.128438095}, {1790,0.120533333}, {1800,0.125990476}, {1810,0.130890476}, {1820,0.126923810}, {1830,0.127066667}, {1840,0.148928571}, {1850,0.134304762}, {1860,0.131723810}, {1870,0.151742857}, {1880,0.171323810}, {1890,0.137071429}, {1900,0.142495238}, {1910,0.162719048}, {1920,0.142947619}, {1930,0.143557143}, {1940,0.158114286}, {1950,0.177042857}, {1960,0.148933333}, {1970,0.151804762}, {1980,0.170957143}, {1990,0.183842857}, {2000,0.158923810}, {2050,0.164866667}, {2100,0.191628571}, {2150,0.198938095}, {2200,0.194619048}, {2250,0.205533333}, {2300,0.218214286}, {2350,0.265147619}, {2400,0.273947619}, {2450,0.302900000}, {2500,0.315995238}, {2550,0.328304762}, {2600,0.329114286}, {2650,0.340847619}, {2700,0.345619048}, {2750,0.342842857}, {2800,0.358966667}, {2850,0.402361905}, {2900,0.384209524}, {2950,0.403742857}, {3000,0.409133333}, {3050,0.426519048}, {3100,0.439938095}, {3150,0.464947619}, {3200,0.507000000}, {3250,0.505104762}, {3300,0.521766667}, {3350,0.519780952}, {3400,0.539480952}, {3450,0.623085714}, {3500,0.632342857}, {3550,0.605914286}, {3600,0.699847619}, {3650,0.667690476}, {3700,0.658823810}, {3750,0.700785714}, {3800,0.708209524}, {3850,0.809519048}, {3900,0.778728571}, {3950,0.847609524}, {4000,0.813961905}, {4050,0.827380952}, {4100,0.881700000}, {4150,0.898495238}, {4200,0.932404762}, {4250,1.046376190}, {4300,0.966519048}, {4350,1.064804762}, {4400,1.029804762}, {4450,1.110876190}, {4500,1.146552381}, {4550,1.116980952}, {4600,1.180890476}, {4650,1.322976190}, {4700,1.300300000}, {4750,1.272209524}, {4800,1.308885714}, {4850,1.425152381}, {4900,1.414885714}, {4950,1.428071429}, {5000,1.448642857}, {5050,1.61671}, {5100,1.66071}, {5150,1.68843}, {5200,1.67857}, {5250,1.75757}, {5300,1.84814}, {5350,1.89386}, {5400,1.94900}, {5450,1.97657}, {5500,1.99014}, {5550,2.04857}, {5600,2.07214}, {5650,2.13814}, {5700,2.16957}, {5750,2.26929}, {5800,2.30500}, {5850,2.34014}, {5900,2.41129}, {5950,2.37671}, {6000,2.52100}, {6050,2.64014}, {6100,2.56171}, {6150,2.69786}, {6200,2.69586}, {6250,2.76843}, {6300,2.78600}, {6350,2.90900}, {6400,2.87329}, {6450,3.00271}, {6500,2.97214}, {6550,3.13886}, {6600,3.08971}, {6650,3.19686}, {6700,3.40000}, {6750,3.39057}, {6800,3.44614}, {6850,3.46414}, {6900,3.49443}, {6950,3.70429}, {7000,3.66700}, {7050,3.85214}, {7100,3.91186}, {7150,3.86943}, {7200,3.90957}, {7250,4.02386}, {7300,4.02357}, {7350,4.09571}, {7400,4.20914}, {7450,4.22771}, {7500,4.33814}, {7550,4.39700}, {7600,4.40043}, {7650,4.47000}, {7700,4.58086}, {7750,4.58329}, {7800,4.64914}, {7850,4.78786}, {7900,5.82557}, {7950,4.84200}, {8000,4.90643}, {8050,5.06857}, {8100,5.05986}, {8150,5.64914}, {8200,5.23614}, {8250,5.21357}, {8300,5.42314}, {8350,5.48671}, {8400,5.59543}, {8450,5.64757}, {8500,5.62543}, {8550,5.84329}, {8600,5.90229}, {8650,6.01986}, {8700,6.02643}, {8750,6.02286}, {8800,6.26071}, {8850,6.28229}, {8900,6.31014}, {8950,6.36086}, {9000,7.52629}, {9050,6.58400}, {9100,7.21171}, {9150,6.54657}, {9200,6.83200}, {9250,6.72971}, {9300,6.98357}, {9350,6.83886}, {9400,7.13671}, {9450,6.96457}, {9500,7.32857}, {9550,7.13514}, {9600,7.45714}, {9650,7.25457}, {9700,7.60871}, {9750,8.19457}, {9800,7.71271}, {9850,7.91514}, {9900,7.63257}, {9950,7.86143}, {10000,8.14629}, {10100,7.95814}, {10200,8.29271}, {10300,8.29400}, {10400,8.76786}, {10500,8.93786}, {10600,8.77429}, {10700,10.27471}, {10800,9.06371}, {10900,9.76971}, {11000,9.51686}, {11100,9.78771}, {11200,9.91629}, {11300,11.34914}, {11400,10.65114}, {11500,10.53843}, {11600,11.43500}, {11700,11.61729}, {11800,11.35971}, {11900,11.58329}, {12000,11.75786}, {12100,11.98571}, {12200,12.11786}, {12300,12.45471}, {12400,12.55529}, {12500,12.76871}, {12600,12.98086}, {12700,13.17014}, {12800,13.37143}, {12900,13.58557}, {13000,13.88243}, {13100,14.05857}, {13200,14.23843}, {13300,14.44014}, {13400,14.64757}, {13500,15.07543}, {13600,15.05814}, {13700,15.26600}, {13800,15.68843}, {13900,16.00386}, {14000,15.93371}, {14100,16.18571}, {14200,16.65443}, {14300,17.39514}, {14400,18.15886}, {14500,17.15957}, {14600,18.50714}, {14700,17.63957}, {14800,18.04871}, {14900,18.51200}, {15000,18.66914}, {15100,18.72029}, {15200,18.79871}, {15300,19.16286}, {15400,19.43300}, {15500,19.77543}, {15600,20.09829}, {15700,20.53243}, {15800,20.90386}, {15900,21.17286}, {16000,21.53271}, {16100,21.72757}, {16200,22.06843}, {16300,22.27314}, {16400,22.87043}, {16500,22.85200}, {16600,23.21971}, {16700,23.62729}, {16800,24.05743}, {16900,24.16586}, {17000,24.73771}, {17100,24.57143}, {17200,25.49329}, {17300,25.56014}, {17400,26.13200}, {17500,26.32471}, {17600,26.10043}, {17700,26.94000}, {17800,27.03300}, {17900,27.47129}, {18000,27.53557}, {18100,28.07900}, {18200,28.80229}, {18300,28.69686}, {18400,29.03557}, {18500,29.64457}, {18600,29.75829}, {18700,29.45200}, {18800,30.20886}, {18900,30.35086}, {19000,30.62771}, {19100,31.04114}, {19200,31.69000}, {19300,32.59200}, {19400,33.83157}, {19500,33.97886}, {19600,33.22071}, {19700,33.41371}, {19800,32.62914}, {19900,32.97343}, {20000,29.94760}};
data["big"]["beta; Parametricity"]["norm reif"]["system"] = {{1,0.000000000}, {2,0.000019048}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000019048}, {8,0.000019048}, {9,0.000019048}, {10,0.000000000}, {11,0.000057143}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000019048}, {17,0.000057143}, {18,0.000000000}, {19,0.000019048}, {20,0.000019048}, {21,0.000019048}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000019048}, {28,0.000019048}, {29,0.000019048}, {30,0.000038095}, {31,0.000000000}, {32,0.000014286}, {33,0.000000000}, {34,0.000000000}, {35,0.000019048}, {36,0.000019048}, {37,0.000019048}, {38,0.000000000}, {39,0.000000000}, {40,0.000019048}, {41,0.000000000}, {42,0.000000000}, {43,0.000019048}, {44,0.000019048}, {45,0.000019048}, {46,0.000000000}, {47,0.000038095}, {48,0.000019048}, {49,0.000019048}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000038095}, {54,0.000019048}, {55,0.000000000}, {56,0.000019048}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000019048}, {61,0.000019048}, {62,0.000014286}, {63,0.000038095}, {64,0.000076190}, {65,0.000038095}, {66,0.000019048}, {67,0.000000000}, {68,0.000038095}, {69,0.000000000}, {70,0.000019048}, {71,0.000000000}, {72,0.000019048}, {73,0.000038095}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000071429}, {78,0.000000000}, {79,0.000019048}, {80,0.000019048}, {81,0.000095238}, {82,0.000019048}, {83,0.000038095}, {84,0.000000000}, {85,0.000000000}, {86,0.000019048}, {87,0.000000000}, {88,0.000038095}, {89,0.000019048}, {90,0.000019048}, {91,0.000019048}, {92,0.000000000}, {93,0.000000000}, {94,0.000019048}, {95,0.000038095}, {96,0.000038095}, {97,0.000000000}, {98,0.000000000}, {99,0.000019048}, {100,0.000019048}, {101,0.000019048}, {102,0.000000000}, {103,0.000019048}, {104,0.000038095}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000038095}, {109,0.000000000}, {110,0.000000000}, {111,0.000076190}, {112,0.000000000}, {113,0.000019048}, {114,0.000057143}, {115,0.000019048}, {116,0.000000000}, {117,0.000019048}, {118,0.000000000}, {119,0.000019048}, {120,0.000019048}, {121,0.000019048}, {122,0.000000000}, {123,0.000057143}, {124,0.000000000}, {125,0.000019048}, {126,0.000019048}, {127,0.000038095}, {128,0.000000000}, {129,0.000038095}, {130,0.000019048}, {131,0.000019048}, {132,0.000000000}, {133,0.000000000}, {134,0.000019048}, {135,0.000019048}, {136,0.000019048}, {137,0.000019048}, {138,0.000019048}, {139,0.000000000}, {140,0.000000000}, {141,0.000038095}, {142,0.000000000}, {143,0.000057143}, {144,0.000000000}, {145,0.000057143}, {146,0.000019048}, {147,0.000019048}, {148,0.000019048}, {149,0.000019048}, {150,0.000038095}, {151,0.000000000}, {152,0.000019048}, {153,0.000019048}, {154,0.000019048}, {155,0.000019048}, {156,0.000019048}, {157,0.000038095}, {158,0.000038095}, {159,0.000019048}, {160,0.000019048}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000019048}, {170,0.000038095}, {171,0.000019048}, {172,0.000000000}, {173,0.000000000}, {174,0.000038095}, {175,0.000019048}, {176,0.000000000}, {177,0.000019048}, {178,0.000000000}, {179,0.000000000}, {180,0.000038095}, {181,0.000000000}, {182,0.000057143}, {183,0.000038095}, {184,0.000000000}, {185,0.000038095}, {186,0.000000000}, {187,0.000019048}, {188,0.000057143}, {189,0.000038095}, {190,0.000019048}, {191,0.000019048}, {192,0.000019048}, {193,0.000019048}, {194,0.000000000}, {195,0.000000000}, {196,0.000038095}, {197,0.000000000}, {198,0.000052381}, {199,0.000000000}, {200,0.000000000}, {201,0.000019048}, {202,0.000000000}, {203,0.000019048}, {204,0.000038095}, {205,0.000038095}, {206,0.000019048}, {207,0.000019048}, {208,0.000019048}, {209,0.000019048}, {210,0.000019048}, {211,0.000019048}, {212,0.000019048}, {213,0.000019048}, {214,0.000019048}, {215,0.000000000}, {216,0.000019048}, {217,0.000019048}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000019048}, {222,0.000019048}, {223,0.000076190}, {224,0.000000000}, {225,0.000019048}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000052381}, {231,0.000038095}, {232,0.000000000}, {233,0.000019048}, {234,0.000000000}, {235,0.000019048}, {236,0.000000000}, {237,0.000019048}, {238,0.000019048}, {239,0.000000000}, {240,0.000057143}, {241,0.000019048}, {242,0.000000000}, {243,0.000019048}, {244,0.000076190}, {245,0.000038095}, {246,0.000057143}, {247,0.000000000}, {248,0.000038095}, {249,0.000057143}, {250,0.000000000}, {251,0.000019048}, {252,0.000019048}, {253,0.000019048}, {254,0.000000000}, {255,0.000038095}, {256,0.000019048}, {257,0.000019048}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000038095}, {263,0.000000000}, {264,0.000019048}, {265,0.000038095}, {266,0.000057143}, {267,0.000014286}, {268,0.000019048}, {269,0.000019048}, {270,0.000000000}, {271,0.000019048}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000071429}, {277,0.000000000}, {278,0.000076190}, {279,0.000019048}, {280,0.000000000}, {281,0.000019048}, {282,0.000019048}, {283,0.000019048}, {284,0.000000000}, {285,0.000057143}, {286,0.000038095}, {287,0.000038095}, {288,0.000014286}, {289,0.000019048}, {290,0.000000000}, {291,0.000038095}, {292,0.000000000}, {293,0.000038095}, {294,0.000019048}, {295,0.000019048}, {296,0.000019048}, {297,0.000071429}, {298,0.000019048}, {299,0.000000000}, {300,0.000057143}, {301,0.000019048}, {302,0.000038095}, {303,0.000038095}, {304,0.000000000}, {305,0.000019048}, {306,0.000019048}, {307,0.000019048}, {308,0.000019048}, {309,0.000019048}, {310,0.000019048}, {311,0.000038095}, {312,0.000019048}, {313,0.000000000}, {314,0.000014286}, {315,0.000019048}, {316,0.000019048}, {317,0.000000000}, {318,0.000019048}, {319,0.000019048}, {320,0.000038095}, {321,0.000038095}, {322,0.000000000}, {323,0.000000000}, {324,0.000019048}, {325,0.000000000}, {326,0.000038095}, {327,0.000019048}, {328,0.000000000}, {329,0.000019048}, {330,0.000038095}, {331,0.000019048}, {332,0.000114286}, {333,0.000019048}, {334,0.000000000}, {335,0.000057143}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000076190}, {340,0.000019048}, {341,0.000038095}, {342,0.000019048}, {343,0.000000000}, {344,0.000038095}, {345,0.000019048}, {346,0.000019048}, {347,0.000000000}, {348,0.000000000}, {349,0.000019048}, {350,0.000000000}, {351,0.000057143}, {352,0.000057143}, {353,0.000033333}, {354,0.000095238}, {355,0.000095238}, {356,0.000038095}, {357,0.000038095}, {358,0.000019048}, {359,0.000019048}, {360,0.000038095}, {361,0.000000000}, {362,0.000019048}, {363,0.000000000}, {364,0.000038095}, {365,0.000019048}, {366,0.000019048}, {367,0.000000000}, {368,0.000038095}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000019048}, {373,0.000038095}, {374,0.000000000}, {375,0.000000000}, {376,0.000019048}, {377,0.000019048}, {378,0.000000000}, {379,0.000000000}, {380,0.000019048}, {381,0.000038095}, {382,0.000038095}, {383,0.000000000}, {384,0.000019048}, {385,0.000038095}, {386,0.000057143}, {387,0.000000000}, {388,0.000038095}, {389,0.000038095}, {390,0.000057143}, {391,0.000057143}, {392,0.000019048}, {393,0.000019048}, {394,0.000019048}, {395,0.000076190}, {396,0.000019048}, {397,0.000038095}, {398,0.000019048}, {399,0.000019048}, {400,0.000033333}, {401,0.000019048}, {402,0.000038095}, {403,0.000019048}, {404,0.000019048}, {405,0.000000000}, {406,0.000000000}, {407,0.000038095}, {408,0.000000000}, {409,0.000071429}, {410,0.000019048}, {411,0.000057143}, {412,0.000038095}, {413,0.000019048}, {414,0.000019048}, {415,0.000052381}, {416,0.000019048}, {417,0.000038095}, {418,0.000000000}, {419,0.000000000}, {420,0.000038095}, {421,0.000019048}, {422,0.000038095}, {423,0.000038095}, {424,0.000019048}, {425,0.000019048}, {426,0.000019048}, {427,0.000000000}, {428,0.000038095}, {429,0.000038095}, {430,0.000038095}, {431,0.000000000}, {432,0.000019048}, {433,0.000019048}, {434,0.000057143}, {435,0.000019048}, {436,0.000038095}, {437,0.000057143}, {438,0.000038095}, {439,0.000076190}, {440,0.000019048}, {441,0.000019048}, {442,0.000019048}, {443,0.000057143}, {444,0.000019048}, {445,0.000019048}, {446,0.000019048}, {447,0.000057143}, {448,0.000038095}, {449,0.000019048}, {450,0.000038095}, {451,0.000000000}, {452,0.000019048}, {453,0.000076190}, {454,0.000019048}, {455,0.000076190}, {456,0.000019048}, {457,0.000228571}, {458,0.000057143}, {459,0.000109524}, {460,0.000152381}, {461,0.000133333}, {462,0.000114286}, {463,0.000076190}, {464,0.000095238}, {465,0.000019048}, {466,0.000057143}, {467,0.000038095}, {468,0.000038095}, {469,0.000095238}, {470,0.000242857}, {471,0.000057143}, {472,0.000114286}, {473,0.000076190}, {474,0.000076190}, {475,0.000128571}, {476,0.000133333}, {477,0.000019048}, {478,0.000133333}, {479,0.000133333}, {480,0.000133333}, {481,0.000038095}, {482,0.000152381}, {483,0.000276190}, {484,0.000095238}, {485,0.000038095}, {486,0.000095238}, {487,0.000076190}, {488,0.000057143}, {489,0.000095238}, {490,0.000114286}, {491,0.000095238}, {492,0.000057143}, {493,0.000095238}, {494,0.000114286}, {495,0.000057143}, {496,0.000114286}, {497,0.000228571}, {498,0.000147619}, {499,0.000057143}, {500,0.000095238}, {505,0.000114286}, {510,0.000171429}, {515,0.000133333}, {520,0.000228571}, {525,0.000133333}, {530,0.000171429}, {535,0.000280952}, {540,0.000209524}, {545,0.000190476}, {550,0.000152381}, {555,0.000185714}, {560,0.000190476}, {565,0.000304762}, {570,0.000133333}, {575,0.000076190}, {580,0.000166667}, {585,0.000209524}, {590,0.000342857}, {595,0.000242857}, {600,0.000209524}, {605,0.000228571}, {610,0.000223810}, {615,0.000185714}, {620,0.000261905}, {625,0.000152381}, {630,0.000361905}, {635,0.000223810}, {640,0.000319048}, {645,0.000190476}, {650,0.000361905}, {655,0.000228571}, {660,0.000242857}, {665,0.000247619}, {670,0.000357143}, {675,0.000285714}, {680,0.000376190}, {685,0.000247619}, {690,0.000323810}, {695,0.000247619}, {700,0.000376190}, {705,0.000280952}, {710,0.000338095}, {715,0.000280952}, {720,0.000266667}, {725,0.000361905}, {730,0.000342857}, {735,0.000466667}, {740,0.000357143}, {745,0.000376190}, {750,0.000433333}, {755,0.000495238}, {760,0.000590476}, {765,0.000509524}, {770,0.000604762}, {775,0.000452381}, {780,0.000419048}, {785,0.000552381}, {790,0.000438095}, {795,0.000476190}, {800,0.000476190}, {805,0.000566667}, {810,0.000733333}, {815,0.000528571}, {820,0.000642857}, {825,0.000657143}, {830,0.000552381}, {835,0.000476190}, {840,0.000923810}, {845,0.000604762}, {850,0.000623810}, {855,0.000533333}, {860,0.000647619}, {865,0.000585714}, {870,0.000795238}, {875,0.000585714}, {880,0.000738095}, {885,0.000852381}, {890,0.000680952}, {895,0.000680952}, {900,0.000952381}, {905,0.000676190}, {910,0.000700000}, {915,0.000890476}, {920,0.000757143}, {925,0.000838095}, {930,0.001133333}, {935,0.000795238}, {940,0.000723810}, {945,0.000804762}, {950,0.000976190}, {955,0.000909524}, {960,0.000780952}, {965,0.000861905}, {970,0.001085714}, {975,0.000152381}, {980,0.000038095}, {985,0.000057143}, {990,0.000038095}, {995,0.000038095}, {1000,0.000038095}, {1010,0.000000000}, {1020,0.000057143}, {1030,0.000057143}, {1040,0.000019048}, {1050,0.000019048}, {1060,0.000057143}, {1070,0.000038095}, {1080,0.000076190}, {1090,0.000076190}, {1100,0.000038095}, {1110,0.000038095}, {1120,0.000095238}, {1130,0.000038095}, {1140,0.000057143}, {1150,0.000019048}, {1160,0.000038095}, {1170,0.000076190}, {1180,0.000038095}, {1190,0.000019048}, {1200,0.000095238}, {1210,0.000038095}, {1220,0.000038095}, {1230,0.000000000}, {1240,0.000038095}, {1250,0.000057143}, {1260,0.000019048}, {1270,0.000057143}, {1280,0.000038095}, {1290,0.000057143}, {1300,0.000057143}, {1310,0.000057143}, {1320,0.000038095}, {1330,0.000076190}, {1340,0.000038095}, {1350,0.000019048}, {1360,0.000057143}, {1370,0.000038095}, {1380,0.000019048}, {1390,0.000076190}, {1400,0.000071429}, {1410,0.000000000}, {1420,0.000038095}, {1430,0.000014286}, {1440,0.000057143}, {1450,0.000000000}, {1460,0.000038095}, {1470,0.000057143}, {1480,0.000038095}, {1490,0.000038095}, {1500,0.000019048}, {1510,0.003985714}, {1520,0.002038095}, {1530,0.002176190}, {1540,0.002461905}, {1550,0.002104762}, {1560,0.002180952}, {1570,0.002076190}, {1580,0.002290476}, {1590,0.002280952}, {1600,0.002152381}, {1610,0.002095238}, {1620,0.002161905}, {1630,0.001876190}, {1640,0.001985714}, {1650,0.001695238}, {1660,0.001823810}, {1670,0.002290476}, {1680,0.002033333}, {1690,0.002214286}, {1700,0.002238095}, {1710,0.001914286}, {1720,0.002180952}, {1730,0.001923810}, {1740,0.001904762}, {1750,0.002276190}, {1760,0.002371429}, {1770,0.002223810}, {1780,0.002223810}, {1790,0.002223810}, {1800,0.002271429}, {1810,0.002471429}, {1820,0.002342857}, {1830,0.002676190}, {1840,0.002928571}, {1850,0.002661905}, {1860,0.002752381}, {1870,0.002971429}, {1880,0.002438095}, {1890,0.001857143}, {1900,0.002047619}, {1910,0.002114286}, {1920,0.001895238}, {1930,0.001709524}, {1940,0.001776190}, {1950,0.001995238}, {1960,0.001876190}, {1970,0.001733333}, {1980,0.000052381}, {1990,0.000057143}, {2000,0.000076190}, {2050,0.000057143}, {2100,0.000038095}, {2150,0.000038095}, {2200,0.000019048}, {2250,0.000114286}, {2300,0.000057143}, {2350,0.000057143}, {2400,0.000019048}, {2450,0.000038095}, {2500,0.000019048}, {2550,0.000019048}, {2600,0.000052381}, {2650,0.000038095}, {2700,0.000057143}, {2750,0.000171429}, {2800,0.000114286}, {2850,0.000285714}, {2900,0.000204762}, {2950,0.000238095}, {3000,0.000266667}, {3050,0.000190476}, {3100,0.000257143}, {3150,0.000266667}, {3200,0.000057143}, {3250,0.000095238}, {3300,0.000038095}, {3350,0.000057143}, {3400,0.000076190}, {3450,0.000057143}, {3500,0.000057143}, {3550,0.000152381}, {3600,0.000128571}, {3650,0.000242857}, {3700,0.000114286}, {3750,0.000228571}, {3800,0.000185714}, {3850,0.000152381}, {3900,0.000057143}, {3950,0.000095238}, {4000,0.000133333}, {4050,0.000076190}, {4100,0.000171429}, {4150,0.000071429}, {4200,0.000038095}, {4250,0.000109524}, {4300,0.000114286}, {4350,0.000185714}, {4400,0.000114286}, {4450,0.000152381}, {4500,0.000209524}, {4550,0.000304762}, {4600,0.000142857}, {4650,0.000228571}, {4700,0.000209524}, {4750,0.000076190}, {4800,0.000095238}, {4850,0.000200000}, {4900,0.000209524}, {4950,0.000095238}, {5000,0.000223810}, {5050,0.00686}, {5100,0.00800}, {5150,0.00600}, {5200,0.00900}, {5250,0.00743}, {5300,0.00671}, {5350,0.00786}, {5400,0.00629}, {5450,0.00614}, {5500,0.00514}, {5550,0.00329}, {5600,0.00000}, {5650,0.00043}, {5700,0.00000}, {5750,0.00000}, {5800,0.00157}, {5850,0.00629}, {5900,0.00343}, {5950,0.00443}, {6000,0.00286}, {6050,0.00171}, {6100,0.00000}, {6150,0.00057}, {6200,0.00000}, {6250,0.00286}, {6300,0.00500}, {6350,0.00343}, {6400,0.00686}, {6450,0.00457}, {6500,0.00000}, {6550,0.00000}, {6600,0.00057}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00171}, {6900,0.00057}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00057}, {7200,0.00000}, {7250,0.00057}, {7300,0.00057}, {7350,0.00000}, {7400,0.00057}, {7450,0.00000}, {7500,0.00057}, {7550,0.00057}, {7600,0.00000}, {7650,0.00057}, {7700,0.00000}, {7750,0.00171}, {7800,0.00157}, {7850,0.00343}, {7900,0.00686}, {7950,0.00386}, {8000,0.00057}, {8050,0.00114}, {8100,0.01000}, {8150,0.00286}, {8200,0.00057}, {8250,0.00000}, {8300,0.00057}, {8350,0.00457}, {8400,0.00400}, {8450,0.00171}, {8500,0.00229}, {8550,0.00057}, {8600,0.00057}, {8650,0.00000}, {8700,0.00000}, {8750,0.00343}, {8800,0.00057}, {8850,0.00000}, {8900,0.00514}, {8950,0.00557}, {9000,0.00800}, {9050,0.00057}, {9100,0.00057}, {9150,0.00786}, {9200,0.00443}, {9250,0.00900}, {9300,0.00114}, {9350,0.00743}, {9400,0.00057}, {9450,0.00286}, {9500,0.00000}, {9550,0.00571}, {9600,0.00114}, {9650,0.00057}, {9700,0.00843}, {9750,0.00400}, {9800,0.00100}, {9850,0.00171}, {9900,0.00229}, {9950,0.00443}, {10000,0.00400}, {10100,0.00057}, {10200,0.00343}, {10300,0.00743}, {10400,0.00343}, {10500,0.00443}, {10600,0.00400}, {10700,0.00857}, {10800,0.00057}, {10900,0.01186}, {11000,0.00514}, {11100,0.00800}, {11200,0.00157}, {11300,0.02100}, {11400,0.00114}, {11500,0.00957}, {11600,0.02000}, {11700,0.00057}, {11800,0.01029}, {11900,0.01014}, {12000,0.00514}, {12100,0.00057}, {12200,0.00057}, {12300,0.00000}, {12400,0.00114}, {12500,0.00114}, {12600,0.00114}, {12700,0.00157}, {12800,0.00114}, {12900,0.00271}, {13000,0.00000}, {13100,0.00057}, {13200,0.00229}, {13300,0.00171}, {13400,0.00114}, {13500,0.00229}, {13600,0.00114}, {13700,0.00271}, {13800,0.00057}, {13900,0.00057}, {14000,0.00171}, {14100,0.00000}, {14200,0.00114}, {14300,0.00686}, {14400,0.00343}, {14500,0.01929}, {14600,0.00286}, {14700,0.01586}, {14800,0.01314}, {14900,0.00171}, {15000,0.00671}, {15100,0.00400}, {15200,0.00800}, {15300,0.00114}, {15400,0.00171}, {15500,0.00000}, {15600,0.00057}, {15700,0.00114}, {15800,0.00171}, {15900,0.00057}, {16000,0.00457}, {16100,0.00286}, {16200,0.00714}, {16300,0.00800}, {16400,0.00457}, {16500,0.00171}, {16600,0.00171}, {16700,0.00100}, {16800,0.00114}, {16900,0.00171}, {17000,0.00686}, {17100,0.01700}, {17200,0.01243}, {17300,0.01371}, {17400,0.01257}, {17500,0.01414}, {17600,0.01471}, {17700,0.00743}, {17800,0.00971}, {17900,0.00386}, {18000,0.01886}, {18100,0.00514}, {18200,0.00514}, {18300,0.00743}, {18400,0.00914}, {18500,0.00729}, {18600,0.00800}, {18700,0.01286}, {18800,0.00629}, {18900,0.00800}, {19000,0.01143}, {19100,0.01200}, {19200,0.01029}, {19300,0.02671}, {19400,0.04971}, {19500,0.04614}, {19600,0.03400}, {19700,0.01243}, {19800,0.01143}, {19900,0.00743}, {20000,0.00080}};
data["big"]["beta; Parametricity"]["post"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.00000}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big"]["beta; Parametricity"]["post"]["user"] = {{1,0.000061905}, {2,0.000028571}, {3,0.000014286}, {4,0.000028571}, {5,0.000028571}, {6,0.000047619}, {7,0.000000000}, {8,0.000033333}, {9,0.000028571}, {10,0.000090476}, {11,0.000047619}, {12,0.000042857}, {13,0.000028571}, {14,0.000047619}, {15,0.000019048}, {16,0.000028571}, {17,0.000019048}, {18,0.000066667}, {19,0.000000000}, {20,0.000047619}, {21,0.000014286}, {22,0.000000000}, {23,0.000047619}, {24,0.000028571}, {25,0.000066667}, {26,0.000028571}, {27,0.000014286}, {28,0.000000000}, {29,0.000019048}, {30,0.000014286}, {31,0.000014286}, {32,0.000019048}, {33,0.000033333}, {34,0.000028571}, {35,0.000014286}, {36,0.000019048}, {37,0.000100000}, {38,0.000047619}, {39,0.000000000}, {40,0.000014286}, {41,0.000028571}, {42,0.000042857}, {43,0.000033333}, {44,0.000042857}, {45,0.000014286}, {46,0.000033333}, {47,0.000028571}, {48,0.000014286}, {49,0.000028571}, {50,0.000028571}, {51,0.000028571}, {52,0.000042857}, {53,0.000033333}, {54,0.000019048}, {55,0.000076190}, {56,0.000028571}, {57,0.000019048}, {58,0.000000000}, {59,0.000076190}, {60,0.000000000}, {61,0.000033333}, {62,0.000000000}, {63,0.000019048}, {64,0.000047619}, {65,0.000038095}, {66,0.000019048}, {67,0.000033333}, {68,0.000042857}, {69,0.000000000}, {70,0.000019048}, {71,0.000028571}, {72,0.000033333}, {73,0.000038095}, {74,0.000000000}, {75,0.000014286}, {76,0.000014286}, {77,0.000033333}, {78,0.000033333}, {79,0.000019048}, {80,0.000033333}, {81,0.000066667}, {82,0.000014286}, {83,0.000014286}, {84,0.000047619}, {85,0.000028571}, {86,0.000000000}, {87,0.000071429}, {88,0.000061905}, {89,0.000028571}, {90,0.000038095}, {91,0.000047619}, {92,0.000014286}, {93,0.000042857}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000014286}, {98,0.000014286}, {99,0.000014286}, {100,0.000014286}, {101,0.000047619}, {102,0.000057143}, {103,0.000047619}, {104,0.000033333}, {105,0.000028571}, {106,0.000000000}, {107,0.000052381}, {108,0.000052381}, {109,0.000066667}, {110,0.000014286}, {111,0.000000000}, {112,0.000028571}, {113,0.000028571}, {114,0.000047619}, {115,0.000028571}, {116,0.000033333}, {117,0.000000000}, {118,0.000019048}, {119,0.000042857}, {120,0.000052381}, {121,0.000014286}, {122,0.000019048}, {123,0.000028571}, {124,0.000000000}, {125,0.000042857}, {126,0.000071429}, {127,0.000071429}, {128,0.000000000}, {129,0.000061905}, {130,0.000061905}, {131,0.000104762}, {132,0.000000000}, {133,0.000014286}, {134,0.000000000}, {135,0.000000000}, {136,0.000028571}, {137,0.000028571}, {138,0.000014286}, {139,0.000104762}, {140,0.000028571}, {141,0.000038095}, {142,0.000000000}, {143,0.000042857}, {144,0.000014286}, {145,0.000061905}, {146,0.000028571}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000014286}, {151,0.000042857}, {152,0.000033333}, {153,0.000038095}, {154,0.000033333}, {155,0.000014286}, {156,0.000019048}, {157,0.000028571}, {158,0.000028571}, {159,0.000066667}, {160,0.000042857}, {161,0.000028571}, {162,0.000028571}, {163,0.000057143}, {164,0.000019048}, {165,0.000047619}, {166,0.000033333}, {167,0.000014286}, {168,0.000066667}, {169,0.000000000}, {170,0.000014286}, {171,0.000061905}, {172,0.000014286}, {173,0.000000000}, {174,0.000000000}, {175,0.000014286}, {176,0.000042857}, {177,0.000052381}, {178,0.000028571}, {179,0.000052381}, {180,0.000000000}, {181,0.000014286}, {182,0.000014286}, {183,0.000000000}, {184,0.000047619}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000028571}, {189,0.000080952}, {190,0.000033333}, {191,0.000000000}, {192,0.000028571}, {193,0.000042857}, {194,0.000028571}, {195,0.000014286}, {196,0.000033333}, {197,0.000028571}, {198,0.000057143}, {199,0.000000000}, {200,0.000028571}, {201,0.000047619}, {202,0.000000000}, {203,0.000028571}, {204,0.000000000}, {205,0.000014286}, {206,0.000014286}, {207,0.000019048}, {208,0.000033333}, {209,0.000033333}, {210,0.000000000}, {211,0.000042857}, {212,0.000057143}, {213,0.000066667}, {214,0.000028571}, {215,0.000014286}, {216,0.000000000}, {217,0.000033333}, {218,0.000000000}, {219,0.000014286}, {220,0.000019048}, {221,0.000033333}, {222,0.000019048}, {223,0.000014286}, {224,0.000014286}, {225,0.000071429}, {226,0.000038095}, {227,0.000014286}, {228,0.000014286}, {229,0.000033333}, {230,0.000014286}, {231,0.000000000}, {232,0.000042857}, {233,0.000052381}, {234,0.000000000}, {235,0.000019048}, {236,0.000052381}, {237,0.000033333}, {238,0.000052381}, {239,0.000028571}, {240,0.000014286}, {241,0.000014286}, {242,0.000047619}, {243,0.000000000}, {244,0.000033333}, {245,0.000042857}, {246,0.000042857}, {247,0.000033333}, {248,0.000047619}, {249,0.000042857}, {250,0.000019048}, {251,0.000047619}, {252,0.000019048}, {253,0.000047619}, {254,0.000000000}, {255,0.000047619}, {256,0.000028571}, {257,0.000061905}, {258,0.000028571}, {259,0.000000000}, {260,0.000014286}, {261,0.000042857}, {262,0.000033333}, {263,0.000014286}, {264,0.000014286}, {265,0.000061905}, {266,0.000000000}, {267,0.000042857}, {268,0.000014286}, {269,0.000061905}, {270,0.000061905}, {271,0.000038095}, {272,0.000028571}, {273,0.000000000}, {274,0.000028571}, {275,0.000071429}, {276,0.000028571}, {277,0.000052381}, {278,0.000076190}, {279,0.000014286}, {280,0.000028571}, {281,0.000000000}, {282,0.000028571}, {283,0.000000000}, {284,0.000033333}, {285,0.000014286}, {286,0.000028571}, {287,0.000000000}, {288,0.000014286}, {289,0.000028571}, {290,0.000019048}, {291,0.000000000}, {292,0.000047619}, {293,0.000038095}, {294,0.000000000}, {295,0.000052381}, {296,0.000000000}, {297,0.000047619}, {298,0.000014286}, {299,0.000014286}, {300,0.000014286}, {301,0.000033333}, {302,0.000014286}, {303,0.000014286}, {304,0.000014286}, {305,0.000000000}, {306,0.000033333}, {307,0.000000000}, {308,0.000061905}, {309,0.000000000}, {310,0.000014286}, {311,0.000033333}, {312,0.000028571}, {313,0.000052381}, {314,0.000052381}, {315,0.000033333}, {316,0.000014286}, {317,0.000052381}, {318,0.000090476}, {319,0.000042857}, {320,0.000000000}, {321,0.000000000}, {322,0.000066667}, {323,0.000095238}, {324,0.000057143}, {325,0.000000000}, {326,0.000014286}, {327,0.000042857}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000033333}, {332,0.000028571}, {333,0.000028571}, {334,0.000052381}, {335,0.000000000}, {336,0.000033333}, {337,0.000028571}, {338,0.000014286}, {339,0.000028571}, {340,0.000033333}, {341,0.000019048}, {342,0.000061905}, {343,0.000057143}, {344,0.000028571}, {345,0.000000000}, {346,0.000028571}, {347,0.000057143}, {348,0.000014286}, {349,0.000014286}, {350,0.000033333}, {351,0.000047619}, {352,0.000000000}, {353,0.000028571}, {354,0.000038095}, {355,0.000033333}, {356,0.000033333}, {357,0.000038095}, {358,0.000033333}, {359,0.000080952}, {360,0.000019048}, {361,0.000042857}, {362,0.000047619}, {363,0.000014286}, {364,0.000014286}, {365,0.000033333}, {366,0.000061905}, {367,0.000019048}, {368,0.000014286}, {369,0.000071429}, {370,0.000000000}, {371,0.000042857}, {372,0.000000000}, {373,0.000052381}, {374,0.000033333}, {375,0.000042857}, {376,0.000052381}, {377,0.000028571}, {378,0.000047619}, {379,0.000057143}, {380,0.000019048}, {381,0.000000000}, {382,0.000080952}, {383,0.000028571}, {384,0.000033333}, {385,0.000052381}, {386,0.000000000}, {387,0.000038095}, {388,0.000071429}, {389,0.000014286}, {390,0.000014286}, {391,0.000000000}, {392,0.000076190}, {393,0.000014286}, {394,0.000061905}, {395,0.000014286}, {396,0.000014286}, {397,0.000000000}, {398,0.000028571}, {399,0.000019048}, {400,0.000033333}, {401,0.000033333}, {402,0.000014286}, {403,0.000066667}, {404,0.000000000}, {405,0.000066667}, {406,0.000014286}, {407,0.000014286}, {408,0.000042857}, {409,0.000038095}, {410,0.000047619}, {411,0.000033333}, {412,0.000047619}, {413,0.000000000}, {414,0.000000000}, {415,0.000047619}, {416,0.000014286}, {417,0.000014286}, {418,0.000033333}, {419,0.000052381}, {420,0.000000000}, {421,0.000052381}, {422,0.000000000}, {423,0.000014286}, {424,0.000033333}, {425,0.000019048}, {426,0.000019048}, {427,0.000028571}, {428,0.000000000}, {429,0.000028571}, {430,0.000019048}, {431,0.000085714}, {432,0.000057143}, {433,0.000014286}, {434,0.000033333}, {435,0.000014286}, {436,0.000104762}, {437,0.000052381}, {438,0.000000000}, {439,0.000014286}, {440,0.000028571}, {441,0.000047619}, {442,0.000061905}, {443,0.000052381}, {444,0.000028571}, {445,0.000061905}, {446,0.000014286}, {447,0.000000000}, {448,0.000019048}, {449,0.000014286}, {450,0.000014286}, {451,0.000000000}, {452,0.000028571}, {453,0.000042857}, {454,0.000014286}, {455,0.000019048}, {456,0.000057143}, {457,0.000033333}, {458,0.000014286}, {459,0.000047619}, {460,0.000042857}, {461,0.000019048}, {462,0.000014286}, {463,0.000042857}, {464,0.000076190}, {465,0.000019048}, {466,0.000000000}, {467,0.000028571}, {468,0.000014286}, {469,0.000028571}, {470,0.000019048}, {471,0.000028571}, {472,0.000028571}, {473,0.000000000}, {474,0.000033333}, {475,0.000061905}, {476,0.000033333}, {477,0.000028571}, {478,0.000028571}, {479,0.000047619}, {480,0.000019048}, {481,0.000014286}, {482,0.000047619}, {483,0.000014286}, {484,0.000014286}, {485,0.000028571}, {486,0.000042857}, {487,0.000033333}, {488,0.000000000}, {489,0.000033333}, {490,0.000014286}, {491,0.000028571}, {492,0.000047619}, {493,0.000047619}, {494,0.000019048}, {495,0.000052381}, {496,0.000000000}, {497,0.000028571}, {498,0.000014286}, {499,0.000061905}, {500,0.000042857}, {505,0.000057143}, {510,0.000000000}, {515,0.000000000}, {520,0.000033333}, {525,0.000033333}, {530,0.000033333}, {535,0.000014286}, {540,0.000038095}, {545,0.000000000}, {550,0.000000000}, {555,0.000038095}, {560,0.000047619}, {565,0.000052381}, {570,0.000066667}, {575,0.000028571}, {580,0.000014286}, {585,0.000014286}, {590,0.000047619}, {595,0.000061905}, {600,0.000033333}, {605,0.000014286}, {610,0.000000000}, {615,0.000028571}, {620,0.000000000}, {625,0.000000000}, {630,0.000042857}, {635,0.000047619}, {640,0.000033333}, {645,0.000033333}, {650,0.000028571}, {655,0.000028571}, {660,0.000019048}, {665,0.000047619}, {670,0.000038095}, {675,0.000047619}, {680,0.000014286}, {685,0.000066667}, {690,0.000014286}, {695,0.000019048}, {700,0.000028571}, {705,0.000000000}, {710,0.000014286}, {715,0.000033333}, {720,0.000014286}, {725,0.000019048}, {730,0.000028571}, {735,0.000066667}, {740,0.000000000}, {745,0.000014286}, {750,0.000033333}, {755,0.000014286}, {760,0.000066667}, {765,0.000019048}, {770,0.000028571}, {775,0.000033333}, {780,0.000066667}, {785,0.000052381}, {790,0.000028571}, {795,0.000047619}, {800,0.000019048}, {805,0.000014286}, {810,0.000019048}, {815,0.000033333}, {820,0.000014286}, {825,0.000033333}, {830,0.000000000}, {835,0.000019048}, {840,0.000061905}, {845,0.000014286}, {850,0.000028571}, {855,0.000042857}, {860,0.000019048}, {865,0.000000000}, {870,0.000057143}, {875,0.000000000}, {880,0.000033333}, {885,0.000000000}, {890,0.000028571}, {895,0.000033333}, {900,0.000047619}, {905,0.000000000}, {910,0.000061905}, {915,0.000061905}, {920,0.000014286}, {925,0.000033333}, {930,0.000000000}, {935,0.000033333}, {940,0.000033333}, {945,0.000033333}, {950,0.000047619}, {955,0.000057143}, {960,0.000014286}, {965,0.000014286}, {970,0.000042857}, {975,0.000000000}, {980,0.000028571}, {985,0.000028571}, {990,0.000000000}, {995,0.000033333}, {1000,0.000052381}, {1010,0.000028571}, {1020,0.000019048}, {1030,0.000014286}, {1040,0.000000000}, {1050,0.000033333}, {1060,0.000038095}, {1070,0.000019048}, {1080,0.000038095}, {1090,0.000014286}, {1100,0.000000000}, {1110,0.000047619}, {1120,0.000019048}, {1130,0.000047619}, {1140,0.000019048}, {1150,0.000047619}, {1160,0.000014286}, {1170,0.000028571}, {1180,0.000000000}, {1190,0.000014286}, {1200,0.000014286}, {1210,0.000014286}, {1220,0.000014286}, {1230,0.000014286}, {1240,0.000071429}, {1250,0.000014286}, {1260,0.000047619}, {1270,0.000061905}, {1280,0.000028571}, {1290,0.000038095}, {1300,0.000028571}, {1310,0.000047619}, {1320,0.000033333}, {1330,0.000033333}, {1340,0.000038095}, {1350,0.000033333}, {1360,0.000057143}, {1370,0.000014286}, {1380,0.000033333}, {1390,0.000019048}, {1400,0.000047619}, {1410,0.000014286}, {1420,0.000014286}, {1430,0.000038095}, {1440,0.000014286}, {1450,0.000061905}, {1460,0.000028571}, {1470,0.000042857}, {1480,0.000076190}, {1490,0.000104762}, {1500,0.000014286}, {1510,0.000042857}, {1520,0.000000000}, {1530,0.000014286}, {1540,0.000028571}, {1550,0.000019048}, {1560,0.000095238}, {1570,0.000014286}, {1580,0.000000000}, {1590,0.000042857}, {1600,0.000033333}, {1610,0.000000000}, {1620,0.000028571}, {1630,0.000000000}, {1640,0.000014286}, {1650,0.000019048}, {1660,0.000019048}, {1670,0.000033333}, {1680,0.000014286}, {1690,0.000014286}, {1700,0.000028571}, {1710,0.000028571}, {1720,0.000028571}, {1730,0.000033333}, {1740,0.000014286}, {1750,0.000028571}, {1760,0.000061905}, {1770,0.000047619}, {1780,0.000028571}, {1790,0.000014286}, {1800,0.000042857}, {1810,0.000019048}, {1820,0.000033333}, {1830,0.000033333}, {1840,0.000038095}, {1850,0.000071429}, {1860,0.000019048}, {1870,0.000000000}, {1880,0.000028571}, {1890,0.000071429}, {1900,0.000047619}, {1910,0.000014286}, {1920,0.000076190}, {1930,0.000057143}, {1940,0.000042857}, {1950,0.000014286}, {1960,0.000033333}, {1970,0.000042857}, {1980,0.000014286}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000033333}, {2100,0.000047619}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000033333}, {2300,0.000028571}, {2350,0.000014286}, {2400,0.000047619}, {2450,0.000028571}, {2500,0.000042857}, {2550,0.000028571}, {2600,0.000061905}, {2650,0.000014286}, {2700,0.000028571}, {2750,0.000014286}, {2800,0.000019048}, {2850,0.000033333}, {2900,0.000052381}, {2950,0.000000000}, {3000,0.000019048}, {3050,0.000033333}, {3100,0.000076190}, {3150,0.000028571}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000042857}, {3350,0.000000000}, {3400,0.000080952}, {3450,0.000076190}, {3500,0.000047619}, {3550,0.000052381}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000061905}, {3750,0.000019048}, {3800,0.000000000}, {3850,0.000019048}, {3900,0.000033333}, {3950,0.000057143}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000019048}, {4150,0.000014286}, {4200,0.000019048}, {4250,0.000076190}, {4300,0.000033333}, {4350,0.000038095}, {4400,0.000085714}, {4450,0.000019048}, {4500,0.000047619}, {4550,0.000047619}, {4600,0.000047619}, {4650,0.000014286}, {4700,0.000047619}, {4750,0.000014286}, {4800,0.000061905}, {4850,0.000033333}, {4900,0.000000000}, {4950,0.000033333}, {5000,0.000038095}, {5050,0.00000}, {5100,0.00057}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00043}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00057}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00057}, {8750,0.00000}, {8800,0.00100}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00057}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00057}, {11700,0.00057}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00057}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00057}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00057}, {14900,0.00057}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00043}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00043}, {18200,0.00000}, {18300,0.00043}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big"]["beta; Parametricity"]["post"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000019048}, {140,0.000000000}, {141,0.000019048}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000019048}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000019048}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000019048}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000014286}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000019048}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000019048}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000019048}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000028571}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.00000}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big"]["beta; Parametricity"]["pre"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.00000}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big"]["beta; Parametricity"]["pre"]["user"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000014286}, {6,0.000014286}, {7,0.000000000}, {8,0.000019048}, {9,0.000000000}, {10,0.000000000}, {11,0.000014286}, {12,0.000000000}, {13,0.000000000}, {14,0.000028571}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000014286}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000019048}, {24,0.000000000}, {25,0.000000000}, {26,0.000014286}, {27,0.000000000}, {28,0.000000000}, {29,0.000014286}, {30,0.000000000}, {31,0.000000000}, {32,0.000019048}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000014286}, {39,0.000014286}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000019048}, {48,0.000019048}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000014286}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000014286}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000014286}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000014286}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000019048}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000014286}, {87,0.000000000}, {88,0.000014286}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000014286}, {95,0.000014286}, {96,0.000014286}, {97,0.000000000}, {98,0.000014286}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000019048}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000019048}, {112,0.000014286}, {113,0.000019048}, {114,0.000000000}, {115,0.000014286}, {116,0.000000000}, {117,0.000000000}, {118,0.000019048}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000014286}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000019048}, {128,0.000000000}, {129,0.000000000}, {130,0.000033333}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000014286}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000014286}, {146,0.000033333}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000014286}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000019048}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000019048}, {172,0.000000000}, {173,0.000000000}, {174,0.000033333}, {175,0.000000000}, {176,0.000014286}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000014286}, {181,0.000000000}, {182,0.000014286}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000014286}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000014286}, {200,0.000000000}, {201,0.000014286}, {202,0.000014286}, {203,0.000000000}, {204,0.000019048}, {205,0.000000000}, {206,0.000019048}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000019048}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000019048}, {217,0.000000000}, {218,0.000014286}, {219,0.000019048}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000019048}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000014286}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000014286}, {246,0.000000000}, {247,0.000033333}, {248,0.000014286}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000014286}, {253,0.000014286}, {254,0.000014286}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000014286}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000014286}, {268,0.000019048}, {269,0.000000000}, {270,0.000019048}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000014286}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000019048}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000038095}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000047619}, {300,0.000000000}, {301,0.000000000}, {302,0.000014286}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000014286}, {308,0.000014286}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000014286}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000019048}, {322,0.000000000}, {323,0.000014286}, {324,0.000000000}, {325,0.000000000}, {326,0.000014286}, {327,0.000014286}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000019048}, {336,0.000019048}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000028571}, {341,0.000000000}, {342,0.000033333}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000014286}, {348,0.000000000}, {349,0.000014286}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000033333}, {357,0.000000000}, {358,0.000000000}, {359,0.000014286}, {360,0.000014286}, {361,0.000000000}, {362,0.000014286}, {363,0.000014286}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000019048}, {372,0.000000000}, {373,0.000000000}, {374,0.000014286}, {375,0.000014286}, {376,0.000019048}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000014286}, {382,0.000019048}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000014286}, {387,0.000000000}, {388,0.000000000}, {389,0.000014286}, {390,0.000000000}, {391,0.000000000}, {392,0.000019048}, {393,0.000000000}, {394,0.000014286}, {395,0.000019048}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000028571}, {401,0.000052381}, {402,0.000000000}, {403,0.000019048}, {404,0.000014286}, {405,0.000014286}, {406,0.000047619}, {407,0.000000000}, {408,0.000000000}, {409,0.000014286}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000014286}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000014286}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000014286}, {436,0.000014286}, {437,0.000019048}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000028571}, {442,0.000019048}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000019048}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000019048}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000038095}, {460,0.000014286}, {461,0.000014286}, {462,0.000000000}, {463,0.000019048}, {464,0.000000000}, {465,0.000000000}, {466,0.000014286}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000014286}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000014286}, {481,0.000000000}, {482,0.000000000}, {483,0.000014286}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000014286}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000014286}, {525,0.000019048}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000014286}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000028571}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000014286}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000014286}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000014286}, {705,0.000000000}, {710,0.000000000}, {715,0.000019048}, {720,0.000019048}, {725,0.000014286}, {730,0.000000000}, {735,0.000000000}, {740,0.000014286}, {745,0.000014286}, {750,0.000019048}, {755,0.000014286}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000014286}, {800,0.000000000}, {805,0.000000000}, {810,0.000019048}, {815,0.000000000}, {820,0.000000000}, {825,0.000014286}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000014286}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000047619}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000019048}, {955,0.000000000}, {960,0.000019048}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000014286}, {995,0.000014286}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000019048}, {1040,0.000000000}, {1050,0.000014286}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000014286}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000019048}, {1180,0.000014286}, {1190,0.000014286}, {1200,0.000000000}, {1210,0.000014286}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000014286}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000019048}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000019048}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000014286}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000033333}, {1450,0.000042857}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000014286}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000014286}, {1580,0.000014286}, {1590,0.000019048}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000033333}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000014286}, {1700,0.000033333}, {1710,0.000014286}, {1720,0.000000000}, {1730,0.000019048}, {1740,0.000000000}, {1750,0.000038095}, {1760,0.000014286}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000014286}, {1810,0.000000000}, {1820,0.000019048}, {1830,0.000000000}, {1840,0.000014286}, {1850,0.000014286}, {1860,0.000014286}, {1870,0.000014286}, {1880,0.000000000}, {1890,0.000028571}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000033333}, {1980,0.000014286}, {1990,0.000014286}, {2000,0.000019048}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000052381}, {2400,0.000000000}, {2450,0.000019048}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000028571}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000014286}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000019048}, {4050,0.000014286}, {4100,0.000000000}, {4150,0.000019048}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000014286}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000014286}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000028571}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000019048}, {4850,0.000000000}, {4900,0.000019048}, {4950,0.000014286}, {5000,0.000000000}, {5050,0.00000}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00057}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00057}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00057}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00057}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big"]["beta; Parametricity"]["pre"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000019048}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000019048}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.00000}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big"]["beta; Parametricity"]["reif"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000347619}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000009524}, {19,0.018457143}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000009524}, {24,0.000000000}, {25,0.000000000}, {26,0.000009524}, {27,0.006885714}, {28,0.000033333}, {29,0.000071429}, {30,0.000133333}, {31,0.000252381}, {32,0.000395238}, {33,0.000476190}, {34,0.000514286}, {35,0.000519048}, {36,0.000519048}, {37,0.000523810}, {38,0.000523810}, {39,0.000552381}, {40,0.000561905}, {41,0.000633333}, {42,0.000680952}, {43,0.000690476}, {44,0.000709524}, {45,0.000752381}, {46,0.000838095}, {47,0.000890476}, {48,0.000980952}, {49,0.001000000}, {50,0.001004762}, {51,0.001000000}, {52,0.001000000}, {53,0.001000000}, {54,0.001000000}, {55,0.001000000}, {56,0.001000000}, {57,0.001509524}, {58,0.001000000}, {59,0.001000000}, {60,0.001000000}, {61,0.001000000}, {62,0.001000000}, {63,0.001000000}, {64,0.001000000}, {65,0.001000000}, {66,0.001000000}, {67,0.001000000}, {68,0.001000000}, {69,0.001000000}, {70,0.001000000}, {71,0.001000000}, {72,0.001000000}, {73,0.001000000}, {74,0.001000000}, {75,0.001000000}, {76,0.001000000}, {77,0.001000000}, {78,0.001000000}, {79,0.001004762}, {80,0.001033333}, {81,0.001042857}, {82,0.001085714}, {83,0.001114286}, {84,0.001052381}, {85,0.001100000}, {86,0.001171429}, {87,0.001261905}, {88,0.001333333}, {89,0.001361905}, {90,0.001423810}, {91,0.001476190}, {92,0.001509524}, {93,0.001980952}, {94,0.001509524}, {95,0.001514286}, {96,0.001519048}, {97,0.001519048}, {98,0.001519048}, {99,0.001519048}, {100,0.001519048}, {101,0.001519048}, {102,0.001519048}, {103,0.001533333}, {104,0.001519048}, {105,0.001519048}, {106,0.001519048}, {107,0.001519048}, {108,0.001533333}, {109,0.001552381}, {110,0.001547619}, {111,0.001566667}, {112,0.001595238}, {113,0.001652381}, {114,0.001704762}, {115,0.001700000}, {116,0.001742857}, {117,0.001771429}, {118,0.001757143}, {119,0.001795238}, {120,0.001833333}, {121,0.001861905}, {122,0.001919048}, {123,0.002500000}, {124,0.001995238}, {125,0.002000000}, {126,0.002000000}, {127,0.002000000}, {128,0.002000000}, {129,0.002004762}, {130,0.002009524}, {131,0.002014286}, {132,0.002033333}, {133,0.002052381}, {134,0.002080952}, {135,0.002119048}, {136,0.002104762}, {137,0.002123810}, {138,0.002185714}, {139,0.002252381}, {140,0.002300000}, {141,0.002361905}, {142,0.002438095}, {143,0.002457143}, {144,0.002490476}, {145,0.002509524}, {146,0.002514286}, {147,0.002519048}, {148,0.002519048}, {149,0.002514286}, {150,0.002519048}, {151,0.002519048}, {152,0.002519048}, {153,0.003014286}, {154,0.002519048}, {155,0.002519048}, {156,0.002519048}, {157,0.002519048}, {158,0.002519048}, {159,0.002519048}, {160,0.002519048}, {161,0.002519048}, {162,0.002523810}, {163,0.002519048}, {164,0.002519048}, {165,0.002523810}, {166,0.002519048}, {167,0.002528571}, {168,0.002519048}, {169,0.002528571}, {170,0.002533333}, {171,0.002538095}, {172,0.002528571}, {173,0.002576190}, {174,0.002561905}, {175,0.002580952}, {176,0.002623810}, {177,0.002633333}, {178,0.002671429}, {179,0.002714286}, {180,0.002757143}, {181,0.002757143}, {182,0.002780952}, {183,0.002895238}, {184,0.002971429}, {185,0.002952381}, {186,0.003114286}, {187,0.003200000}, {188,0.003304762}, {189,0.003371429}, {190,0.003447619}, {191,0.003500000}, {192,0.003504762}, {193,0.003514286}, {194,0.003519048}, {195,0.003523810}, {196,0.003519048}, {197,0.003519048}, {198,0.003519048}, {199,0.003523810}, {200,0.003519048}, {201,0.003519048}, {202,0.003519048}, {203,0.003523810}, {204,0.003533333}, {205,0.004038095}, {206,0.003519048}, {207,0.003519048}, {208,0.003519048}, {209,0.003519048}, {210,0.003519048}, {211,0.003519048}, {212,0.003519048}, {213,0.003523810}, {214,0.003523810}, {215,0.003538095}, {216,0.004352381}, {217,0.003523810}, {218,0.003528571}, {219,0.003528571}, {220,0.003552381}, {221,0.003542857}, {222,0.003566667}, {223,0.003590476}, {224,0.003609524}, {225,0.003619048}, {226,0.003642857}, {227,0.003685714}, {228,0.003742857}, {229,0.003733333}, {230,0.003852381}, {231,0.003909524}, {232,0.003961905}, {233,0.004019048}, {234,0.004080952}, {235,0.004147619}, {236,0.004171429}, {237,0.004804762}, {238,0.004133333}, {239,0.004185714}, {240,0.004228571}, {241,0.004247619}, {242,0.004328571}, {243,0.004352381}, {244,0.004390476}, {245,0.004480952}, {246,0.004480952}, {247,0.004500000}, {248,0.004919048}, {249,0.004519048}, {250,0.004519048}, {251,0.004519048}, {252,0.004523810}, {253,0.004519048}, {254,0.004533333}, {255,0.004547619}, {256,0.005209524}, {257,0.004528571}, {258,0.004547619}, {259,0.005028571}, {260,0.004590476}, {261,0.004604762}, {262,0.004633333}, {263,0.004633333}, {264,0.004685714}, {265,0.005895238}, {266,0.004761905}, {267,0.004814286}, {268,0.004842857}, {269,0.004895238}, {270,0.004942857}, {271,0.004976190}, {272,0.004990476}, {273,0.005033333}, {274,0.006433333}, {275,0.005038095}, {276,0.005038095}, {277,0.005038095}, {278,0.005038095}, {279,0.005038095}, {280,0.005695238}, {281,0.005038095}, {282,0.005061905}, {283,0.005052381}, {284,0.005066667}, {285,0.005085714}, {286,0.005123810}, {287,0.005104762}, {288,0.005152381}, {289,0.005128571}, {290,0.005914286}, {291,0.006761905}, {292,0.005180952}, {293,0.005238095}, {294,0.005300000}, {295,0.005371429}, {296,0.005452381}, {297,0.005533333}, {298,0.005590476}, {299,0.007819048}, {300,0.005947619}, {301,0.005780952}, {302,0.005800000}, {303,0.005838095}, {304,0.005895238}, {305,0.005914286}, {306,0.005942857}, {307,0.008228571}, {308,0.006009524}, {309,0.006595238}, {310,0.006028571}, {311,0.006033333}, {312,0.006038095}, {313,0.006038095}, {314,0.006085714}, {315,0.007914286}, {316,0.006038095}, {317,0.006038095}, {318,0.006038095}, {319,0.006052381}, {320,0.006038095}, {321,0.006042857}, {322,0.006076190}, {323,0.006047619}, {324,0.006061905}, {325,0.006076190}, {326,0.006095238}, {327,0.006076190}, {328,0.006104762}, {329,0.006190476}, {330,0.009880952}, {331,0.006233333}, {332,0.006247619}, {333,0.006319048}, {334,0.006390476}, {335,0.006438095}, {336,0.007376190}, {337,0.006519048}, {338,0.006542857}, {339,0.006590476}, {340,0.006600000}, {341,0.006638095}, {342,0.006709524}, {343,0.006800000}, {344,0.006933333}, {345,0.006919048}, {346,0.006923810}, {347,0.006995238}, {348,0.007038095}, {349,0.007042857}, {350,0.007042857}, {351,0.007104762}, {352,0.007052381}, {353,0.007542857}, {354,0.007061905}, {355,0.007057143}, {356,0.007085714}, {357,0.007100000}, {358,0.007200000}, {359,0.007119048}, {360,0.007180952}, {361,0.007938095}, {362,0.007238095}, {363,0.007323810}, {364,0.007357143}, {365,0.007385714}, {366,0.007404762}, {367,0.007466667}, {368,0.007471429}, {369,0.008566667}, {370,0.007519048}, {371,0.007538095}, {372,0.010938095}, {373,0.007557143}, {374,0.007566667}, {375,0.007557143}, {376,0.007566667}, {377,0.008866667}, {378,0.007652381}, {379,0.007614286}, {380,0.007623810}, {381,0.007614286}, {382,0.007661905}, {383,0.007719048}, {384,0.007728571}, {385,0.012138095}, {386,0.007766667}, {387,0.007819048}, {388,0.007923810}, {389,0.007990476}, {390,0.008119048}, {391,0.008252381}, {392,0.008342857}, {393,0.008366667}, {394,0.008423810}, {395,0.008452381}, {396,0.008480952}, {397,0.008604762}, {398,0.013352381}, {399,0.008514286}, {400,0.009019048}, {401,0.008538095}, {402,0.008557143}, {403,0.008557143}, {404,0.012171429}, {405,0.008566667}, {406,0.008566667}, {407,0.009352381}, {408,0.008571429}, {409,0.008571429}, {410,0.013000000}, {411,0.008590476}, {412,0.008595238}, {413,0.008623810}, {414,0.008666667}, {415,0.008700000}, {416,0.014457143}, {417,0.008804762}, {418,0.008866667}, {419,0.008904762}, {420,0.008966667}, {421,0.009004762}, {422,0.014366667}, {423,0.009080952}, {424,0.009123810}, {425,0.009133333}, {426,0.009214286}, {427,0.009228571}, {428,0.014471429}, {429,0.009304762}, {430,0.009361905}, {431,0.009400000}, {432,0.009476190}, {433,0.009614286}, {434,0.013504762}, {435,0.009561905}, {436,0.009590476}, {437,0.009619048}, {438,0.009633333}, {439,0.009714286}, {440,0.009676190}, {441,0.009719048}, {442,0.010528571}, {443,0.009785714}, {444,0.009857143}, {445,0.016157143}, {446,0.009914286}, {447,0.009980952}, {448,0.010019048}, {449,0.010619048}, {450,0.010171429}, {451,0.014585714}, {452,0.010090476}, {453,0.010080952}, {454,0.010185714}, {455,0.012947619}, {456,0.018795238}, {457,0.039457143}, {458,0.010261905}, {459,0.010223810}, {460,0.010300000}, {461,0.010328571}, {462,0.016066667}, {463,0.010442857}, {464,0.010528571}, {465,0.010538095}, {466,0.010633333}, {467,0.017123810}, {468,0.010747619}, {469,0.010852381}, {470,0.010990476}, {471,0.010985714}, {472,0.011119048}, {473,0.011095238}, {474,0.011100000}, {475,0.011100000}, {476,0.011123810}, {477,0.011085714}, {478,0.016057143}, {479,0.011147619}, {480,0.011138095}, {481,0.012328571}, {482,0.011190476}, {483,0.016966667}, {484,0.011247619}, {485,0.011238095}, {486,0.011295238}, {487,0.012514286}, {488,0.011476190}, {489,0.011390476}, {490,0.011528571}, {491,0.011542857}, {492,0.011523810}, {493,0.013166667}, {494,0.011680952}, {495,0.011666667}, {496,0.011728571}, {497,0.011804762}, {498,0.011938095}, {499,0.011838095}, {500,0.011852381}, {505,0.013280952}, {510,0.012400000}, {515,0.012647619}, {520,0.012709524}, {525,0.013957143}, {530,0.013033333}, {535,0.013447619}, {540,0.013800000}, {545,0.013795238}, {550,0.013900000}, {555,0.014890476}, {560,0.014385714}, {565,0.020857143}, {570,0.014828571}, {575,0.015080952}, {580,0.016485714}, {585,0.015557143}, {590,0.015690476}, {595,0.015980952}, {600,0.016204762}, {605,0.018485714}, {610,0.022395238}, {615,0.016847619}, {620,0.017104762}, {625,0.017304762}, {630,0.025628571}, {635,0.017752381}, {640,0.018042857}, {645,0.018257143}, {650,0.026404762}, {655,0.019971429}, {660,0.019042857}, {665,0.019147619}, {670,0.026752381}, {675,0.019780952}, {680,0.020080952}, {685,0.020323810}, {690,0.020476190}, {695,0.020842857}, {700,0.022380952}, {705,0.021623810}, {710,0.021638095}, {715,0.021795238}, {720,0.022147619}, {725,0.030228571}, {730,0.022628571}, {735,0.022990476}, {740,0.023338095}, {745,0.023423810}, {750,0.023771429}, {755,0.024085714}, {760,0.033414286}, {765,0.024676190}, {770,0.024923810}, {775,0.025523810}, {780,0.025419048}, {785,0.025761905}, {790,0.025990476}, {795,0.026333333}, {800,0.026742857}, {805,0.027038095}, {810,0.030438095}, {815,0.027571429}, {820,0.027847619}, {825,0.032200000}, {830,0.028523810}, {835,0.028795238}, {840,0.035228571}, {845,0.029342857}, {850,0.029752381}, {855,0.030257143}, {860,0.030376190}, {865,0.030628571}, {870,0.031266667}, {875,0.034352381}, {880,0.031604762}, {885,0.032219048}, {890,0.032200000}, {895,0.033152381}, {900,0.047614286}, {905,0.033190476}, {910,0.034909524}, {915,0.046966667}, {920,0.034190476}, {925,0.034495238}, {930,0.046809524}, {935,0.035219048}, {940,0.035566667}, {945,0.048176190}, {950,0.036300000}, {955,0.037095238}, {960,0.038714286}, {965,0.037328571}, {970,0.052495238}, {975,0.037295238}, {980,0.037461905}, {985,0.047790476}, {990,0.038180952}, {995,0.038509524}, {1000,0.038866667}, {1010,0.039500000}, {1020,0.055509524}, {1030,0.041433333}, {1040,0.041752381}, {1050,0.042080952}, {1060,0.043204762}, {1070,0.060590476}, {1080,0.045080952}, {1090,0.045733333}, {1100,0.046214286}, {1110,0.047023810}, {1120,0.061476190}, {1130,0.052057143}, {1140,0.049642857}, {1150,0.050166667}, {1160,0.052533333}, {1170,0.051728571}, {1180,0.052552381}, {1190,0.063914286}, {1200,0.054295238}, {1210,0.072538095}, {1220,0.055923810}, {1230,0.075642857}, {1240,0.058842857}, {1250,0.058595238}, {1260,0.059323810}, {1270,0.060647619}, {1280,0.061190476}, {1290,0.063047619}, {1300,0.064714286}, {1310,0.067938095}, {1320,0.065409524}, {1330,0.066561905}, {1340,0.067657143}, {1350,0.068242857}, {1360,0.071309524}, {1370,0.070923810}, {1380,0.077266667}, {1390,0.073714286}, {1400,0.073928571}, {1410,0.092123810}, {1420,0.076704762}, {1430,0.107128571}, {1440,0.077233333}, {1450,0.096300000}, {1460,0.080228571}, {1470,0.107400000}, {1480,0.082800000}, {1490,0.087866667}, {1500,0.085600000}, {1510,0.150580952}, {1520,0.125052381}, {1530,0.089147619}, {1540,0.110890476}, {1550,0.091538095}, {1560,0.092904762}, {1570,0.094671429}, {1580,0.095390476}, {1590,0.116700000}, {1600,0.097795238}, {1610,0.098847619}, {1620,0.101014286}, {1630,0.101547619}, {1640,0.120828571}, {1650,0.104466667}, {1660,0.105619048}, {1670,0.137966667}, {1680,0.108519048}, {1690,0.127866667}, {1700,0.112076190}, {1710,0.115338095}, {1720,0.118057143}, {1730,0.118600000}, {1740,0.117204762}, {1750,0.123314286}, {1760,0.155733333}, {1770,0.122004762}, {1780,0.132238095}, {1790,0.125280952}, {1800,0.130409524}, {1810,0.135147619}, {1820,0.131366667}, {1830,0.132152381}, {1840,0.153790476}, {1850,0.139171429}, {1860,0.137061905}, {1870,0.156509524}, {1880,0.175876190}, {1890,0.141352381}, {1900,0.146961905}, {1910,0.166757143}, {1920,0.147590476}, {1930,0.148047619}, {1940,0.162152381}, {1950,0.180928571}, {1960,0.153647619}, {1970,0.156076190}, {1980,0.173119048}, {1990,0.186033333}, {2000,0.161366667}, {2050,0.167857143}, {2100,0.194133333}, {2150,0.201038095}, {2200,0.198361905}, {2250,0.208957143}, {2300,0.221171429}, {2350,0.267933333}, {2400,0.276542857}, {2450,0.305771429}, {2500,0.318409524}, {2550,0.330676190}, {2600,0.332228571}, {2650,0.344014286}, {2700,0.348771429}, {2750,0.345619048}, {2800,0.361609524}, {2850,0.405080952}, {2900,0.387033333}, {2950,0.414057143}, {3000,0.412838095}, {3050,0.429914286}, {3100,0.444685714}, {3150,0.470085714}, {3200,0.510723810}, {3250,0.508819048}, {3300,0.525785714}, {3350,0.524614286}, {3400,0.567123810}, {3450,0.626233333}, {3500,0.635809524}, {3550,0.610571429}, {3600,0.703390476}, {3650,0.671414286}, {3700,0.666128571}, {3750,0.705485714}, {3800,0.722328571}, {3850,0.813538095}, {3900,0.782209524}, {3950,0.851328571}, {4000,0.818723810}, {4050,0.892142857}, {4100,0.885833333}, {4150,0.902357143}, {4200,0.945757143}, {4250,1.050433333}, {4300,0.970676190}, {4350,1.077580952}, {4400,1.050900000}, {4450,1.115928571}, {4500,1.151061905}, {4550,1.122176190}, {4600,1.194804762}, {4650,1.327500000}, {4700,1.306138095}, {4750,1.276695238}, {4800,1.314723810}, {4850,1.429880952}, {4900,1.420847619}, {4950,1.432890476}, {5000,1.464509524}, {5050,1.63014}, {5100,1.67271}, {5150,1.70057}, {5200,1.69286}, {5250,1.77157}, {5300,1.86057}, {5350,1.90900}, {5400,1.96100}, {5450,1.98829}, {5500,2.00100}, {5550,2.05857}, {5600,2.07757}, {5650,2.14486}, {5700,2.17500}, {5750,2.27500}, {5800,2.31314}, {5850,2.35257}, {5900,2.42114}, {5950,2.38800}, {6000,2.53043}, {6050,2.64814}, {6100,2.56814}, {6150,2.70586}, {6200,2.71100}, {6250,2.77743}, {6300,2.79757}, {6350,2.91914}, {6400,2.88843}, {6450,3.01414}, {6500,2.97971}, {6550,3.14657}, {6600,3.09843}, {6650,3.21200}, {6700,3.40871}, {6750,3.39957}, {6800,3.45400}, {6850,3.47386}, {6900,3.50329}, {6950,3.71300}, {7000,3.67543}, {7050,3.86029}, {7100,3.92014}, {7150,3.87771}, {7200,3.91743}, {7250,4.04457}, {7300,4.03186}, {7350,4.10471}, {7400,4.21729}, {7450,4.23486}, {7500,4.34800}, {7550,4.40643}, {7600,4.40971}, {7650,4.47986}, {7700,4.58900}, {7750,4.59371}, {7800,4.65971}, {7850,4.80071}, {7900,5.84186}, {7950,4.85514}, {8000,4.91714}, {8050,5.07886}, {8100,5.07900}, {8150,5.66086}, {8200,5.24586}, {8250,5.22200}, {8300,5.43314}, {8350,5.50129}, {8400,5.61086}, {8450,5.65900}, {8500,5.63800}, {8550,5.85371}, {8600,5.91357}, {8650,6.03086}, {8700,6.03871}, {8750,6.03943}, {8800,6.27314}, {8850,6.29571}, {8900,6.32843}, {8950,6.37986}, {9000,7.54757}, {9050,6.59771}, {9100,7.23286}, {9150,6.56671}, {9200,6.84900}, {9250,6.75386}, {9300,6.99814}, {9350,6.85929}, {9400,7.15029}, {9450,6.98214}, {9500,7.34343}, {9550,7.15614}, {9600,7.47357}, {9650,7.26986}, {9700,7.63257}, {9750,8.21257}, {9800,7.72986}, {9850,7.93086}, {9900,7.64843}, {9950,7.87971}, {10000,8.16343}, {10100,7.97157}, {10200,8.30814}, {10300,8.31643}, {10400,8.78414}, {10500,8.95514}, {10600,8.79343}, {10700,10.29829}, {10800,9.07843}, {10900,9.79529}, {11000,9.53657}, {11100,9.80886}, {11200,9.95329}, {11300,11.38486}, {11400,10.68671}, {11500,10.56243}, {11600,11.47129}, {11700,11.63200}, {11800,11.38571}, {11900,11.61057}, {12000,11.77900}, {12100,12.00243}, {12200,12.13614}, {12300,12.47286}, {12400,12.58671}, {12500,12.78643}, {12600,12.99743}, {12700,13.18957}, {12800,13.39043}, {12900,13.60714}, {13000,13.90143}, {13100,14.08271}, {13200,14.26429}, {13300,14.46686}, {13400,14.68600}, {13500,15.10357}, {13600,15.08571}, {13700,15.28929}, {13800,15.70786}, {13900,16.02514}, {14000,15.95657}, {14100,16.20600}, {14200,16.67600}, {14300,17.42186}, {14400,18.18071}, {14500,17.19900}, {14600,18.52914}, {14700,17.67571}, {14800,18.08300}, {14900,18.53457}, {15000,18.69986}, {15100,18.74900}, {15200,18.83029}, {15300,19.18971}, {15400,19.45971}, {15500,19.80043}, {15600,20.14443}, {15700,20.55800}, {15800,20.93471}, {15900,21.19843}, {16000,21.56200}, {16100,21.75571}, {16200,22.10429}, {16300,22.31329}, {16400,22.90657}, {16500,22.89057}, {16600,23.28814}, {16700,23.67357}, {16800,24.10186}, {16900,24.21071}, {17000,24.78714}, {17100,24.64700}, {17200,25.54700}, {17300,25.61757}, {17400,26.19200}, {17500,26.38457}, {17600,26.18829}, {17700,26.99371}, {17800,27.11829}, {17900,27.52114}, {18000,27.62157}, {18100,28.13143}, {18200,28.85714}, {18300,28.78243}, {18400,29.09357}, {18500,29.70214}, {18600,29.81486}, {18700,29.51643}, {18800,30.26629}, {18900,30.41086}, {19000,30.69243}, {19100,31.10714}, {19200,31.75586}, {19300,32.67286}, {19400,33.93586}, {19500,34.08000}, {19600,33.31329}, {19700,33.48314}, {19800,32.69971}, {19900,33.03800}, {20000,30.02000}};
data["big"]["beta; Parametricity"]["reif"]["user"] = {{1,0.000366667}, {2,0.000504762}, {3,0.000395238}, {4,0.000485714}, {5,0.000461905}, {6,0.000423810}, {7,0.000547619}, {8,0.000476190}, {9,0.000423810}, {10,0.000414286}, {11,0.000480952}, {12,0.000571429}, {13,0.000438095}, {14,0.000876190}, {15,0.000480952}, {16,0.000547619}, {17,0.000509524}, {18,0.000557143}, {19,0.018819048}, {20,0.000585714}, {21,0.000628571}, {22,0.000671429}, {23,0.000652381}, {24,0.000809524}, {25,0.000538095}, {26,0.000876190}, {27,0.007314286}, {28,0.000719048}, {29,0.000652381}, {30,0.000752381}, {31,0.000733333}, {32,0.000590476}, {33,0.000761905}, {34,0.000976190}, {35,0.000995238}, {36,0.000571429}, {37,0.000871429}, {38,0.000990476}, {39,0.000700000}, {40,0.000890476}, {41,0.001095238}, {42,0.000676190}, {43,0.000980952}, {44,0.000790476}, {45,0.001004762}, {46,0.001076190}, {47,0.000780952}, {48,0.000957143}, {49,0.001042857}, {50,0.001009524}, {51,0.000947619}, {52,0.001009524}, {53,0.001080952}, {54,0.001195238}, {55,0.001042857}, {56,0.000909524}, {57,0.001390476}, {58,0.001095238}, {59,0.000990476}, {60,0.001128571}, {61,0.001261905}, {62,0.001352381}, {63,0.001090476}, {64,0.000909524}, {65,0.000933333}, {66,0.001095238}, {67,0.001404762}, {68,0.001295238}, {69,0.001261905}, {70,0.001166667}, {71,0.001357143}, {72,0.001476190}, {73,0.001442857}, {74,0.001338095}, {75,0.001209524}, {76,0.001166667}, {77,0.001209524}, {78,0.001371429}, {79,0.001352381}, {80,0.001385714}, {81,0.001280952}, {82,0.001452381}, {83,0.001495238}, {84,0.001552381}, {85,0.001480952}, {86,0.001400000}, {87,0.001461905}, {88,0.001638095}, {89,0.001776190}, {90,0.001847619}, {91,0.001795238}, {92,0.001647619}, {93,0.001909524}, {94,0.001780952}, {95,0.001547619}, {96,0.001538095}, {97,0.001514286}, {98,0.001633333}, {99,0.001723810}, {100,0.001776190}, {101,0.001700000}, {102,0.001742857}, {103,0.001676190}, {104,0.001761905}, {105,0.001657143}, {106,0.001752381}, {107,0.001723810}, {108,0.001657143}, {109,0.001780952}, {110,0.002014286}, {111,0.001904762}, {112,0.001790476}, {113,0.001885714}, {114,0.001785714}, {115,0.001861905}, {116,0.001861905}, {117,0.001976190}, {118,0.002042857}, {119,0.001980952}, {120,0.001895238}, {121,0.001890476}, {122,0.002047619}, {123,0.002428571}, {124,0.002095238}, {125,0.002000000}, {126,0.001952381}, {127,0.002066667}, {128,0.002033333}, {129,0.002171429}, {130,0.001895238}, {131,0.001938095}, {132,0.002104762}, {133,0.002280952}, {134,0.001942857}, {135,0.001966667}, {136,0.002319048}, {137,0.002080952}, {138,0.002209524}, {139,0.001909524}, {140,0.002442857}, {141,0.002223810}, {142,0.002242857}, {143,0.002214286}, {144,0.002414286}, {145,0.002142857}, {146,0.002109524}, {147,0.002419048}, {148,0.002480952}, {149,0.002233333}, {150,0.002419048}, {151,0.002338095}, {152,0.002257143}, {153,0.002961905}, {154,0.002276190}, {155,0.002385714}, {156,0.002480952}, {157,0.002519048}, {158,0.002566667}, {159,0.002547619}, {160,0.002390476}, {161,0.002700000}, {162,0.002480952}, {163,0.002590476}, {164,0.002528571}, {165,0.002638095}, {166,0.002619048}, {167,0.002780952}, {168,0.002490476}, {169,0.002776190}, {170,0.002657143}, {171,0.002614286}, {172,0.002709524}, {173,0.002676190}, {174,0.002704762}, {175,0.002619048}, {176,0.002900000}, {177,0.002719048}, {178,0.002923810}, {179,0.002795238}, {180,0.002890476}, {181,0.002995238}, {182,0.002747619}, {183,0.002923810}, {184,0.002900000}, {185,0.002828571}, {186,0.002919048}, {187,0.003028571}, {188,0.002809524}, {189,0.003123810}, {190,0.003028571}, {191,0.003042857}, {192,0.003014286}, {193,0.003014286}, {194,0.003042857}, {195,0.003061905}, {196,0.003133333}, {197,0.002804762}, {198,0.003000000}, {199,0.003171429}, {200,0.003285714}, {201,0.003123810}, {202,0.003133333}, {203,0.003357143}, {204,0.003323810}, {205,0.004023810}, {206,0.003304762}, {207,0.003338095}, {208,0.003480952}, {209,0.003328571}, {210,0.003404762}, {211,0.003280952}, {212,0.003457143}, {213,0.003580952}, {214,0.003447619}, {215,0.003490476}, {216,0.004414286}, {217,0.003604762}, {218,0.003490476}, {219,0.003328571}, {220,0.003842857}, {221,0.003709524}, {222,0.003566667}, {223,0.003633333}, {224,0.003800000}, {225,0.003642857}, {226,0.003700000}, {227,0.003785714}, {228,0.003738095}, {229,0.003700000}, {230,0.003923810}, {231,0.003804762}, {232,0.003947619}, {233,0.003876190}, {234,0.003928571}, {235,0.003952381}, {236,0.003976190}, {237,0.004790476}, {238,0.003866667}, {239,0.004100000}, {240,0.003961905}, {241,0.004166667}, {242,0.004004762}, {243,0.004252381}, {244,0.004171429}, {245,0.003980952}, {246,0.004323810}, {247,0.004247619}, {248,0.004747619}, {249,0.004180952}, {250,0.004238095}, {251,0.004161905}, {252,0.004266667}, {253,0.004500000}, {254,0.004309524}, {255,0.004442857}, {256,0.004900000}, {257,0.004404762}, {258,0.004547619}, {259,0.005057143}, {260,0.004380952}, {261,0.004614286}, {262,0.004357143}, {263,0.004538095}, {264,0.004733333}, {265,0.005847619}, {266,0.004666667}, {267,0.004571429}, {268,0.004657143}, {269,0.004771429}, {270,0.004657143}, {271,0.004866667}, {272,0.004661905}, {273,0.004942857}, {274,0.006657143}, {275,0.004780952}, {276,0.004671429}, {277,0.005004762}, {278,0.004961905}, {279,0.005114286}, {280,0.005495238}, {281,0.005276190}, {282,0.005338095}, {283,0.005214286}, {284,0.005533333}, {285,0.005428571}, {286,0.005252381}, {287,0.005152381}, {288,0.005285714}, {289,0.005176190}, {290,0.005890476}, {291,0.006747619}, {292,0.005523810}, {293,0.005142857}, {294,0.005195238}, {295,0.005433333}, {296,0.005252381}, {297,0.005314286}, {298,0.005152381}, {299,0.007542857}, {300,0.005890476}, {301,0.005633333}, {302,0.005400000}, {303,0.005385714}, {304,0.005433333}, {305,0.005771429}, {306,0.005904762}, {307,0.008485714}, {308,0.005657143}, {309,0.006509524}, {310,0.005833333}, {311,0.005757143}, {312,0.005942857}, {313,0.005842857}, {314,0.005909524}, {315,0.007928571}, {316,0.006171429}, {317,0.005995238}, {318,0.006138095}, {319,0.005957143}, {320,0.006085714}, {321,0.006123810}, {322,0.006038095}, {323,0.006247619}, {324,0.006309524}, {325,0.006233333}, {326,0.006266667}, {327,0.006323810}, {328,0.006333333}, {329,0.006357143}, {330,0.009976190}, {331,0.006171429}, {332,0.006280952}, {333,0.006414286}, {334,0.006457143}, {335,0.006542857}, {336,0.007390476}, {337,0.006709524}, {338,0.006685714}, {339,0.006647619}, {340,0.006414286}, {341,0.006666667}, {342,0.006933333}, {343,0.006723810}, {344,0.006685714}, {345,0.006619048}, {346,0.006823810}, {347,0.007104762}, {348,0.006980952}, {349,0.006900000}, {350,0.006942857}, {351,0.007095238}, {352,0.007314286}, {353,0.007961905}, {354,0.007228571}, {355,0.007304762}, {356,0.007247619}, {357,0.007247619}, {358,0.007038095}, {359,0.007223810}, {360,0.007390476}, {361,0.008023810}, {362,0.007285714}, {363,0.007304762}, {364,0.007585714}, {365,0.007547619}, {366,0.007657143}, {367,0.007452381}, {368,0.007666667}, {369,0.008676190}, {370,0.007461905}, {371,0.007395238}, {372,0.010771429}, {373,0.007714286}, {374,0.007614286}, {375,0.007723810}, {376,0.007766667}, {377,0.008952381}, {378,0.007723810}, {379,0.007904762}, {380,0.007871429}, {381,0.007942857}, {382,0.008000000}, {383,0.008052381}, {384,0.007966667}, {385,0.012147619}, {386,0.008376190}, {387,0.008328571}, {388,0.008176190}, {389,0.008600000}, {390,0.008647619}, {391,0.008528571}, {392,0.007995238}, {393,0.008390476}, {394,0.008580952}, {395,0.008442857}, {396,0.008452381}, {397,0.008571429}, {398,0.013480952}, {399,0.008461905}, {400,0.009019048}, {401,0.008514286}, {402,0.008661905}, {403,0.008709524}, {404,0.012138095}, {405,0.008609524}, {406,0.008876190}, {407,0.009742857}, {408,0.008809524}, {409,0.008971429}, {410,0.012914286}, {411,0.008995238}, {412,0.009176190}, {413,0.009100000}, {414,0.009047619}, {415,0.009057143}, {416,0.014757143}, {417,0.009280952}, {418,0.009138095}, {419,0.009209524}, {420,0.009238095}, {421,0.009280952}, {422,0.014733333}, {423,0.009385714}, {424,0.009309524}, {425,0.009266667}, {426,0.009514286}, {427,0.009533333}, {428,0.014776190}, {429,0.009457143}, {430,0.009747619}, {431,0.009485714}, {432,0.009795238}, {433,0.009780952}, {434,0.013504762}, {435,0.009714286}, {436,0.009719048}, {437,0.009747619}, {438,0.009800000}, {439,0.009914286}, {440,0.009895238}, {441,0.009957143}, {442,0.010861905}, {443,0.010076190}, {444,0.010209524}, {445,0.016295238}, {446,0.010271429}, {447,0.010166667}, {448,0.010252381}, {449,0.010904762}, {450,0.010314286}, {451,0.014719048}, {452,0.010352381}, {453,0.010300000}, {454,0.010533333}, {455,0.013219048}, {456,0.019071429}, {457,0.039585714}, {458,0.010466667}, {459,0.010480952}, {460,0.010695238}, {461,0.010661905}, {462,0.016347619}, {463,0.010952381}, {464,0.010909524}, {465,0.010714286}, {466,0.010766667}, {467,0.017214286}, {468,0.011109524}, {469,0.011128571}, {470,0.011042857}, {471,0.011185714}, {472,0.011214286}, {473,0.011252381}, {474,0.011057143}, {475,0.011195238}, {476,0.010980952}, {477,0.011242857}, {478,0.016157143}, {479,0.011033333}, {480,0.011380952}, {481,0.012633333}, {482,0.011219048}, {483,0.017033333}, {484,0.011519048}, {485,0.011500000}, {486,0.011328571}, {487,0.012871429}, {488,0.011561905}, {489,0.011342857}, {490,0.011714286}, {491,0.011642857}, {492,0.011838095}, {493,0.013219048}, {494,0.011661905}, {495,0.012033333}, {496,0.011957143}, {497,0.011619048}, {498,0.011809524}, {499,0.011723810}, {500,0.012147619}, {505,0.013161905}, {510,0.012366667}, {515,0.012795238}, {520,0.012652381}, {525,0.013885714}, {530,0.012985714}, {535,0.013233333}, {540,0.013647619}, {545,0.013642857}, {550,0.013904762}, {555,0.014776190}, {560,0.014252381}, {565,0.020814286}, {570,0.014709524}, {575,0.015123810}, {580,0.016323810}, {585,0.015485714}, {590,0.015642857}, {595,0.015828571}, {600,0.016057143}, {605,0.018414286}, {610,0.022395238}, {615,0.016785714}, {620,0.016947619}, {625,0.017066667}, {630,0.025485714}, {635,0.017538095}, {640,0.018033333}, {645,0.018190476}, {650,0.026066667}, {655,0.020028571}, {660,0.018980952}, {665,0.019142857}, {670,0.026385714}, {675,0.019652381}, {680,0.019723810}, {685,0.020266667}, {690,0.020214286}, {695,0.020461905}, {700,0.022200000}, {705,0.021371429}, {710,0.021385714}, {715,0.021628571}, {720,0.021785714}, {725,0.029766667}, {730,0.022400000}, {735,0.022500000}, {740,0.022980952}, {745,0.023152381}, {750,0.023561905}, {755,0.023614286}, {760,0.032738095}, {765,0.024195238}, {770,0.024285714}, {775,0.025142857}, {780,0.025185714}, {785,0.025219048}, {790,0.025480952}, {795,0.025976190}, {800,0.026252381}, {805,0.026800000}, {810,0.030076190}, {815,0.027419048}, {820,0.027342857}, {825,0.031414286}, {830,0.028180952}, {835,0.028695238}, {840,0.034376190}, {845,0.029104762}, {850,0.029233333}, {855,0.030061905}, {860,0.030204762}, {865,0.030447619}, {870,0.030628571}, {875,0.033985714}, {880,0.030938095}, {885,0.031528571}, {890,0.031542857}, {895,0.032347619}, {900,0.046547619}, {905,0.032638095}, {910,0.033928571}, {915,0.046057143}, {920,0.033285714}, {925,0.033490476}, {930,0.045666667}, {935,0.034290476}, {940,0.034861905}, {945,0.047076190}, {950,0.035333333}, {955,0.036090476}, {960,0.038119048}, {965,0.036290476}, {970,0.051480952}, {975,0.036890476}, {980,0.037585714}, {985,0.047552381}, {990,0.038338095}, {995,0.038728571}, {1000,0.039047619}, {1010,0.039752381}, {1020,0.055476190}, {1030,0.041252381}, {1040,0.041990476}, {1050,0.042142857}, {1060,0.043100000}, {1070,0.060966667}, {1080,0.045095238}, {1090,0.045795238}, {1100,0.046390476}, {1110,0.047152381}, {1120,0.061666667}, {1130,0.052147619}, {1140,0.049519048}, {1150,0.050152381}, {1160,0.052690476}, {1170,0.051704762}, {1180,0.052576190}, {1190,0.064038095}, {1200,0.054204762}, {1210,0.072609524}, {1220,0.056071429}, {1230,0.075842857}, {1240,0.058723810}, {1250,0.058580952}, {1260,0.059323810}, {1270,0.060395238}, {1280,0.061328571}, {1290,0.063271429}, {1300,0.064733333}, {1310,0.068004762}, {1320,0.065590476}, {1330,0.066580952}, {1340,0.067476190}, {1350,0.068219048}, {1360,0.071147619}, {1370,0.070742857}, {1380,0.077342857}, {1390,0.073619048}, {1400,0.074085714}, {1410,0.092166667}, {1420,0.076466667}, {1430,0.107042857}, {1440,0.077338095}, {1450,0.096342857}, {1460,0.080285714}, {1470,0.107347619}, {1480,0.082838095}, {1490,0.087609524}, {1500,0.085528571}, {1510,0.146466667}, {1520,0.122914286}, {1530,0.086933333}, {1540,0.108342857}, {1550,0.089466667}, {1560,0.090657143}, {1570,0.092576190}, {1580,0.093261905}, {1590,0.114352381}, {1600,0.095538095}, {1610,0.096900000}, {1620,0.098738095}, {1630,0.099552381}, {1640,0.118580952}, {1650,0.102561905}, {1660,0.103671429}, {1670,0.135490476}, {1680,0.106352381}, {1690,0.125371429}, {1700,0.109957143}, {1710,0.113333333}, {1720,0.115861905}, {1730,0.116490476}, {1740,0.115228571}, {1750,0.120985714}, {1760,0.153357143}, {1770,0.119661905}, {1780,0.129876190}, {1790,0.122714286}, {1800,0.128128571}, {1810,0.132538095}, {1820,0.129171429}, {1830,0.129490476}, {1840,0.150604762}, {1850,0.136295238}, {1860,0.134019048}, {1870,0.153380952}, {1880,0.173180952}, {1890,0.139519048}, {1900,0.144733333}, {1910,0.164357143}, {1920,0.145628571}, {1930,0.146166667}, {1940,0.159938095}, {1950,0.178733333}, {1960,0.151571429}, {1970,0.153985714}, {1980,0.172961905}, {1990,0.185761905}, {2000,0.161414286}, {2050,0.167804762}, {2100,0.193923810}, {2150,0.200652381}, {2200,0.198242857}, {2250,0.208647619}, {2300,0.221066667}, {2350,0.267480952}, {2400,0.276285714}, {2450,0.305404762}, {2500,0.318004762}, {2550,0.330404762}, {2600,0.332042857}, {2650,0.343776190}, {2700,0.348409524}, {2750,0.345390476}, {2800,0.361247619}, {2850,0.404809524}, {2900,0.386514286}, {2950,0.413761905}, {3000,0.412300000}, {3050,0.429590476}, {3100,0.444071429}, {3150,0.469342857}, {3200,0.510285714}, {3250,0.508314286}, {3300,0.525457143}, {3350,0.524019048}, {3400,0.566880952}, {3450,0.625942857}, {3500,0.635533333}, {3550,0.610238095}, {3600,0.703000000}, {3650,0.670714286}, {3700,0.665633333}, {3750,0.704904762}, {3800,0.721990476}, {3850,0.813019048}, {3900,0.781833333}, {3950,0.850980952}, {4000,0.818328571}, {4050,0.891500000}, {4100,0.885138095}, {4150,0.901942857}, {4200,0.945185714}, {4250,1.049738095}, {4300,0.970171429}, {4350,1.076847619}, {4400,1.050357143}, {4450,1.115019048}, {4500,1.150147619}, {4550,1.121242857}, {4600,1.193985714}, {4650,1.326623810}, {4700,1.305223810}, {4750,1.276185714}, {4800,1.313904762}, {4850,1.429276190}, {4900,1.420133333}, {4950,1.432366667}, {5000,1.463885714}, {5050,1.62243}, {5100,1.66500}, {5150,1.69257}, {5200,1.68286}, {5250,1.76314}, {5300,1.85329}, {5350,1.89943}, {5400,1.95414}, {5450,1.98086}, {5500,1.99443}, {5550,2.05314}, {5600,2.07843}, {5650,2.14243}, {5700,2.17386}, {5750,2.27371}, {5800,2.30986}, {5850,2.34500}, {5900,2.41629}, {5950,2.38271}, {6000,2.52514}, {6050,2.64600}, {6100,2.56686}, {6150,2.70400}, {6200,2.70986}, {6250,2.77257}, {6300,2.79043}, {6350,2.91371}, {6400,2.87900}, {6450,3.00743}, {6500,2.97757}, {6550,3.14543}, {6600,3.09643}, {6650,3.21043}, {6700,3.40643}, {6750,3.39657}, {6800,3.45143}, {6850,3.46843}, {6900,3.50100}, {6950,3.71129}, {7000,3.67314}, {7050,3.85714}, {7100,3.91757}, {7150,3.87600}, {7200,3.91557}, {7250,4.04186}, {7300,4.03014}, {7350,4.10243}, {7400,4.21557}, {7450,4.23329}, {7500,4.34486}, {7550,4.40300}, {7600,4.40743}, {7650,4.47686}, {7700,4.58571}, {7750,4.59000}, {7800,4.65500}, {7850,4.79543}, {7900,5.83271}, {7950,4.84871}, {8000,4.91314}, {8050,5.07429}, {8100,5.06614}, {8150,5.65600}, {8200,5.24257}, {8250,5.21971}, {8300,5.43029}, {8350,5.49371}, {8400,5.60329}, {8450,5.65514}, {8500,5.63414}, {8550,5.85171}, {8600,5.91129}, {8650,6.02714}, {8700,6.03471}, {8750,6.03100}, {8800,6.26757}, {8850,6.29014}, {8900,6.31886}, {8950,6.36857}, {9000,7.53343}, {9050,6.59186}, {9100,7.22700}, {9150,6.55471}, {9200,6.84014}, {9250,6.73829}, {9300,6.99143}, {9350,6.84571}, {9400,7.14386}, {9450,6.97329}, {9500,7.33714}, {9550,7.14429}, {9600,7.46686}, {9650,7.26357}, {9700,7.61814}, {9750,8.20157}, {9800,7.72200}, {9850,7.92243}, {9900,7.63957}, {9950,7.87043}, {10000,8.15457}, {10100,7.96557}, {10200,8.30214}, {10300,8.30457}, {10400,8.77700}, {10500,8.94657}, {10600,8.78457}, {10700,10.28400}, {10800,9.07357}, {10900,9.77900}, {11000,9.52714}, {11100,9.79586}, {11200,9.94686}, {11300,11.35857}, {11400,10.68000}, {11500,10.54643}, {11600,11.44557}, {11700,11.62729}, {11800,11.37057}, {11900,11.59586}, {12000,11.76814}, {12100,11.99600}, {12200,12.12914}, {12300,12.46629}, {12400,12.57943}, {12500,12.77814}, {12600,12.98971}, {12700,13.18086}, {12800,13.38171}, {12900,13.59714}, {13000,13.89371}, {13100,14.06900}, {13200,14.24929}, {13300,14.45186}, {13400,14.67214}, {13500,15.08629}, {13600,15.07043}, {13700,15.27686}, {13800,15.69957}, {13900,16.01500}, {14000,15.94657}, {14100,16.19643}, {14200,16.66700}, {14300,17.40729}, {14400,18.17043}, {14500,17.17286}, {14600,18.51886}, {14700,17.65229}, {14800,18.06143}, {14900,18.52443}, {15000,18.68357}, {15100,18.73614}, {15200,18.81371}, {15300,19.17714}, {15400,19.44729}, {15500,19.78857}, {15600,20.13300}, {15700,20.54629}, {15800,20.92071}, {15900,21.18771}, {16000,21.54829}, {16100,21.74343}, {16200,22.08343}, {16300,22.28943}, {16400,22.88471}, {16500,22.86986}, {16600,23.26714}, {16700,23.64571}, {16800,24.07243}, {16900,24.18043}, {17000,24.75271}, {17100,24.60029}, {17200,25.50743}, {17300,25.57500}, {17400,26.14786}, {17500,26.34029}, {17600,26.14214}, {17700,26.95629}, {17800,27.07600}, {17900,27.48586}, {18000,27.57157}, {18100,28.09300}, {18200,28.81857}, {18300,28.74114}, {18400,29.05086}, {18500,29.66129}, {18600,29.77314}, {18700,29.46757}, {18800,30.22500}, {18900,30.36729}, {19000,30.64471}, {19100,31.06014}, {19200,31.70829}, {19300,32.60886}, {19400,33.84686}, {19500,33.99443}, {19600,33.24014}, {19700,33.43143}, {19800,32.64614}, {19900,32.99143}, {20000,29.96440}};
data["big"]["beta; Parametricity"]["reif"]["system"] = {{1,0.000000000}, {2,0.000019048}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000019048}, {8,0.000019048}, {9,0.000019048}, {10,0.000019048}, {11,0.000057143}, {12,0.000019048}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000019048}, {17,0.000057143}, {18,0.000038095}, {19,0.000019048}, {20,0.000019048}, {21,0.000019048}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000019048}, {27,0.000019048}, {28,0.000019048}, {29,0.000019048}, {30,0.000038095}, {31,0.000000000}, {32,0.000014286}, {33,0.000000000}, {34,0.000000000}, {35,0.000019048}, {36,0.000019048}, {37,0.000019048}, {38,0.000000000}, {39,0.000000000}, {40,0.000019048}, {41,0.000000000}, {42,0.000000000}, {43,0.000019048}, {44,0.000019048}, {45,0.000019048}, {46,0.000038095}, {47,0.000038095}, {48,0.000038095}, {49,0.000019048}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000038095}, {54,0.000019048}, {55,0.000019048}, {56,0.000038095}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000019048}, {61,0.000019048}, {62,0.000014286}, {63,0.000038095}, {64,0.000076190}, {65,0.000038095}, {66,0.000019048}, {67,0.000000000}, {68,0.000057143}, {69,0.000000000}, {70,0.000019048}, {71,0.000000000}, {72,0.000038095}, {73,0.000038095}, {74,0.000038095}, {75,0.000000000}, {76,0.000000000}, {77,0.000071429}, {78,0.000000000}, {79,0.000019048}, {80,0.000019048}, {81,0.000095238}, {82,0.000019048}, {83,0.000038095}, {84,0.000000000}, {85,0.000000000}, {86,0.000019048}, {87,0.000019048}, {88,0.000057143}, {89,0.000019048}, {90,0.000019048}, {91,0.000019048}, {92,0.000000000}, {93,0.000000000}, {94,0.000038095}, {95,0.000038095}, {96,0.000057143}, {97,0.000000000}, {98,0.000000000}, {99,0.000019048}, {100,0.000019048}, {101,0.000019048}, {102,0.000000000}, {103,0.000019048}, {104,0.000038095}, {105,0.000000000}, {106,0.000019048}, {107,0.000019048}, {108,0.000038095}, {109,0.000000000}, {110,0.000000000}, {111,0.000076190}, {112,0.000000000}, {113,0.000019048}, {114,0.000057143}, {115,0.000019048}, {116,0.000000000}, {117,0.000019048}, {118,0.000000000}, {119,0.000038095}, {120,0.000019048}, {121,0.000019048}, {122,0.000000000}, {123,0.000057143}, {124,0.000000000}, {125,0.000038095}, {126,0.000019048}, {127,0.000038095}, {128,0.000000000}, {129,0.000038095}, {130,0.000019048}, {131,0.000019048}, {132,0.000000000}, {133,0.000000000}, {134,0.000019048}, {135,0.000019048}, {136,0.000019048}, {137,0.000019048}, {138,0.000019048}, {139,0.000000000}, {140,0.000000000}, {141,0.000038095}, {142,0.000000000}, {143,0.000076190}, {144,0.000000000}, {145,0.000057143}, {146,0.000019048}, {147,0.000019048}, {148,0.000019048}, {149,0.000019048}, {150,0.000038095}, {151,0.000000000}, {152,0.000057143}, {153,0.000019048}, {154,0.000019048}, {155,0.000019048}, {156,0.000019048}, {157,0.000038095}, {158,0.000038095}, {159,0.000019048}, {160,0.000019048}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000019048}, {166,0.000000000}, {167,0.000019048}, {168,0.000000000}, {169,0.000019048}, {170,0.000038095}, {171,0.000019048}, {172,0.000000000}, {173,0.000000000}, {174,0.000038095}, {175,0.000019048}, {176,0.000000000}, {177,0.000019048}, {178,0.000000000}, {179,0.000000000}, {180,0.000038095}, {181,0.000000000}, {182,0.000057143}, {183,0.000038095}, {184,0.000000000}, {185,0.000038095}, {186,0.000000000}, {187,0.000038095}, {188,0.000057143}, {189,0.000038095}, {190,0.000038095}, {191,0.000019048}, {192,0.000019048}, {193,0.000019048}, {194,0.000000000}, {195,0.000000000}, {196,0.000038095}, {197,0.000000000}, {198,0.000052381}, {199,0.000000000}, {200,0.000000000}, {201,0.000019048}, {202,0.000000000}, {203,0.000019048}, {204,0.000038095}, {205,0.000038095}, {206,0.000019048}, {207,0.000019048}, {208,0.000019048}, {209,0.000019048}, {210,0.000019048}, {211,0.000019048}, {212,0.000019048}, {213,0.000019048}, {214,0.000019048}, {215,0.000000000}, {216,0.000019048}, {217,0.000019048}, {218,0.000019048}, {219,0.000000000}, {220,0.000000000}, {221,0.000019048}, {222,0.000019048}, {223,0.000076190}, {224,0.000000000}, {225,0.000019048}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000019048}, {230,0.000071429}, {231,0.000038095}, {232,0.000000000}, {233,0.000019048}, {234,0.000000000}, {235,0.000057143}, {236,0.000019048}, {237,0.000019048}, {238,0.000019048}, {239,0.000000000}, {240,0.000057143}, {241,0.000019048}, {242,0.000000000}, {243,0.000019048}, {244,0.000076190}, {245,0.000038095}, {246,0.000057143}, {247,0.000014286}, {248,0.000038095}, {249,0.000057143}, {250,0.000000000}, {251,0.000019048}, {252,0.000038095}, {253,0.000019048}, {254,0.000000000}, {255,0.000038095}, {256,0.000019048}, {257,0.000038095}, {258,0.000000000}, {259,0.000000000}, {260,0.000019048}, {261,0.000019048}, {262,0.000038095}, {263,0.000000000}, {264,0.000019048}, {265,0.000038095}, {266,0.000057143}, {267,0.000014286}, {268,0.000038095}, {269,0.000019048}, {270,0.000000000}, {271,0.000019048}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000071429}, {277,0.000000000}, {278,0.000114286}, {279,0.000019048}, {280,0.000000000}, {281,0.000019048}, {282,0.000019048}, {283,0.000019048}, {284,0.000000000}, {285,0.000057143}, {286,0.000038095}, {287,0.000057143}, {288,0.000014286}, {289,0.000019048}, {290,0.000000000}, {291,0.000038095}, {292,0.000000000}, {293,0.000038095}, {294,0.000057143}, {295,0.000019048}, {296,0.000019048}, {297,0.000071429}, {298,0.000019048}, {299,0.000000000}, {300,0.000057143}, {301,0.000033333}, {302,0.000038095}, {303,0.000038095}, {304,0.000000000}, {305,0.000019048}, {306,0.000033333}, {307,0.000019048}, {308,0.000019048}, {309,0.000038095}, {310,0.000033333}, {311,0.000038095}, {312,0.000019048}, {313,0.000000000}, {314,0.000014286}, {315,0.000019048}, {316,0.000019048}, {317,0.000019048}, {318,0.000019048}, {319,0.000019048}, {320,0.000038095}, {321,0.000038095}, {322,0.000000000}, {323,0.000000000}, {324,0.000019048}, {325,0.000000000}, {326,0.000038095}, {327,0.000019048}, {328,0.000000000}, {329,0.000019048}, {330,0.000038095}, {331,0.000019048}, {332,0.000114286}, {333,0.000019048}, {334,0.000000000}, {335,0.000076190}, {336,0.000000000}, {337,0.000000000}, {338,0.000019048}, {339,0.000076190}, {340,0.000019048}, {341,0.000038095}, {342,0.000019048}, {343,0.000000000}, {344,0.000038095}, {345,0.000019048}, {346,0.000019048}, {347,0.000038095}, {348,0.000000000}, {349,0.000019048}, {350,0.000019048}, {351,0.000057143}, {352,0.000057143}, {353,0.000052381}, {354,0.000114286}, {355,0.000114286}, {356,0.000038095}, {357,0.000038095}, {358,0.000038095}, {359,0.000019048}, {360,0.000038095}, {361,0.000000000}, {362,0.000019048}, {363,0.000019048}, {364,0.000038095}, {365,0.000019048}, {366,0.000057143}, {367,0.000019048}, {368,0.000038095}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000019048}, {373,0.000057143}, {374,0.000000000}, {375,0.000000000}, {376,0.000019048}, {377,0.000019048}, {378,0.000000000}, {379,0.000000000}, {380,0.000019048}, {381,0.000038095}, {382,0.000038095}, {383,0.000038095}, {384,0.000038095}, {385,0.000038095}, {386,0.000057143}, {387,0.000019048}, {388,0.000057143}, {389,0.000038095}, {390,0.000057143}, {391,0.000057143}, {392,0.000019048}, {393,0.000019048}, {394,0.000019048}, {395,0.000095238}, {396,0.000057143}, {397,0.000038095}, {398,0.000019048}, {399,0.000038095}, {400,0.000033333}, {401,0.000019048}, {402,0.000038095}, {403,0.000019048}, {404,0.000019048}, {405,0.000000000}, {406,0.000000000}, {407,0.000038095}, {408,0.000000000}, {409,0.000090476}, {410,0.000038095}, {411,0.000057143}, {412,0.000057143}, {413,0.000038095}, {414,0.000019048}, {415,0.000071429}, {416,0.000019048}, {417,0.000038095}, {418,0.000000000}, {419,0.000000000}, {420,0.000038095}, {421,0.000038095}, {422,0.000057143}, {423,0.000038095}, {424,0.000019048}, {425,0.000038095}, {426,0.000019048}, {427,0.000000000}, {428,0.000038095}, {429,0.000038095}, {430,0.000038095}, {431,0.000019048}, {432,0.000019048}, {433,0.000019048}, {434,0.000057143}, {435,0.000019048}, {436,0.000038095}, {437,0.000057143}, {438,0.000038095}, {439,0.000114286}, {440,0.000019048}, {441,0.000038095}, {442,0.000038095}, {443,0.000057143}, {444,0.000019048}, {445,0.000038095}, {446,0.000019048}, {447,0.000057143}, {448,0.000038095}, {449,0.000019048}, {450,0.000038095}, {451,0.000038095}, {452,0.000019048}, {453,0.000076190}, {454,0.000019048}, {455,0.000076190}, {456,0.000019048}, {457,0.000247619}, {458,0.000057143}, {459,0.000109524}, {460,0.000152381}, {461,0.000133333}, {462,0.000114286}, {463,0.000076190}, {464,0.000095238}, {465,0.000038095}, {466,0.000057143}, {467,0.000057143}, {468,0.000038095}, {469,0.000095238}, {470,0.000261905}, {471,0.000057143}, {472,0.000114286}, {473,0.000076190}, {474,0.000076190}, {475,0.000128571}, {476,0.000133333}, {477,0.000019048}, {478,0.000133333}, {479,0.000133333}, {480,0.000152381}, {481,0.000038095}, {482,0.000152381}, {483,0.000276190}, {484,0.000095238}, {485,0.000057143}, {486,0.000114286}, {487,0.000076190}, {488,0.000057143}, {489,0.000114286}, {490,0.000114286}, {491,0.000095238}, {492,0.000057143}, {493,0.000095238}, {494,0.000114286}, {495,0.000057143}, {496,0.000133333}, {497,0.000228571}, {498,0.000147619}, {499,0.000057143}, {500,0.000095238}, {505,0.000114286}, {510,0.000190476}, {515,0.000133333}, {520,0.000228571}, {525,0.000133333}, {530,0.000171429}, {535,0.000280952}, {540,0.000228571}, {545,0.000190476}, {550,0.000152381}, {555,0.000185714}, {560,0.000190476}, {565,0.000304762}, {570,0.000133333}, {575,0.000076190}, {580,0.000185714}, {585,0.000209524}, {590,0.000361905}, {595,0.000242857}, {600,0.000209524}, {605,0.000247619}, {610,0.000223810}, {615,0.000185714}, {620,0.000280952}, {625,0.000190476}, {630,0.000380952}, {635,0.000223810}, {640,0.000319048}, {645,0.000209524}, {650,0.000380952}, {655,0.000247619}, {660,0.000242857}, {665,0.000247619}, {670,0.000357143}, {675,0.000285714}, {680,0.000376190}, {685,0.000247619}, {690,0.000342857}, {695,0.000247619}, {700,0.000414286}, {705,0.000280952}, {710,0.000338095}, {715,0.000300000}, {720,0.000266667}, {725,0.000400000}, {730,0.000342857}, {735,0.000466667}, {740,0.000395238}, {745,0.000395238}, {750,0.000433333}, {755,0.000514286}, {760,0.000590476}, {765,0.000509524}, {770,0.000604762}, {775,0.000452381}, {780,0.000438095}, {785,0.000552381}, {790,0.000438095}, {795,0.000514286}, {800,0.000495238}, {805,0.000585714}, {810,0.000771429}, {815,0.000528571}, {820,0.000642857}, {825,0.000676190}, {830,0.000552381}, {835,0.000476190}, {840,0.000923810}, {845,0.000604762}, {850,0.000623810}, {855,0.000533333}, {860,0.000647619}, {865,0.000585714}, {870,0.000795238}, {875,0.000604762}, {880,0.000757143}, {885,0.000852381}, {890,0.000700000}, {895,0.000680952}, {900,0.000971429}, {905,0.000676190}, {910,0.000719048}, {915,0.000890476}, {920,0.000757143}, {925,0.000857143}, {930,0.001133333}, {935,0.000852381}, {940,0.000742857}, {945,0.000823810}, {950,0.000976190}, {955,0.000928571}, {960,0.000800000}, {965,0.000861905}, {970,0.001104762}, {975,0.000152381}, {980,0.000057143}, {985,0.000057143}, {990,0.000038095}, {995,0.000057143}, {1000,0.000038095}, {1010,0.000000000}, {1020,0.000057143}, {1030,0.000057143}, {1040,0.000019048}, {1050,0.000019048}, {1060,0.000057143}, {1070,0.000057143}, {1080,0.000076190}, {1090,0.000095238}, {1100,0.000038095}, {1110,0.000038095}, {1120,0.000095238}, {1130,0.000057143}, {1140,0.000076190}, {1150,0.000019048}, {1160,0.000038095}, {1170,0.000095238}, {1180,0.000052381}, {1190,0.000019048}, {1200,0.000114286}, {1210,0.000038095}, {1220,0.000038095}, {1230,0.000000000}, {1240,0.000057143}, {1250,0.000057143}, {1260,0.000038095}, {1270,0.000076190}, {1280,0.000038095}, {1290,0.000057143}, {1300,0.000057143}, {1310,0.000076190}, {1320,0.000057143}, {1330,0.000076190}, {1340,0.000038095}, {1350,0.000019048}, {1360,0.000057143}, {1370,0.000076190}, {1380,0.000038095}, {1390,0.000076190}, {1400,0.000071429}, {1410,0.000000000}, {1420,0.000038095}, {1430,0.000014286}, {1440,0.000076190}, {1450,0.000000000}, {1460,0.000057143}, {1470,0.000057143}, {1480,0.000076190}, {1490,0.000038095}, {1500,0.000019048}, {1510,0.004023810}, {1520,0.002038095}, {1530,0.002195238}, {1540,0.002500000}, {1550,0.002142857}, {1560,0.002200000}, {1570,0.002095238}, {1580,0.002309524}, {1590,0.002319048}, {1600,0.002171429}, {1610,0.002133333}, {1620,0.002200000}, {1630,0.001933333}, {1640,0.002004762}, {1650,0.001714286}, {1660,0.001842857}, {1670,0.002290476}, {1680,0.002033333}, {1690,0.002247619}, {1700,0.002257143}, {1710,0.001914286}, {1720,0.002200000}, {1730,0.001961905}, {1740,0.001942857}, {1750,0.002295238}, {1760,0.002404762}, {1770,0.002242857}, {1780,0.002261905}, {1790,0.002261905}, {1800,0.002271429}, {1810,0.002528571}, {1820,0.002361905}, {1830,0.002695238}, {1840,0.002947619}, {1850,0.002680952}, {1860,0.002809524}, {1870,0.003009524}, {1880,0.002457143}, {1890,0.001876190}, {1900,0.002047619}, {1910,0.002152381}, {1920,0.001914286}, {1930,0.001747619}, {1940,0.001795238}, {1950,0.002057143}, {1960,0.001914286}, {1970,0.001733333}, {1980,0.000090476}, {1990,0.000057143}, {2000,0.000076190}, {2050,0.000057143}, {2100,0.000057143}, {2150,0.000038095}, {2200,0.000019048}, {2250,0.000114286}, {2300,0.000095238}, {2350,0.000057143}, {2400,0.000019048}, {2450,0.000038095}, {2500,0.000038095}, {2550,0.000019048}, {2600,0.000071429}, {2650,0.000057143}, {2700,0.000076190}, {2750,0.000171429}, {2800,0.000114286}, {2850,0.000285714}, {2900,0.000204762}, {2950,0.000257143}, {3000,0.000266667}, {3050,0.000209524}, {3100,0.000314286}, {3150,0.000304762}, {3200,0.000057143}, {3250,0.000114286}, {3300,0.000038095}, {3350,0.000057143}, {3400,0.000095238}, {3450,0.000076190}, {3500,0.000057143}, {3550,0.000171429}, {3600,0.000185714}, {3650,0.000242857}, {3700,0.000152381}, {3750,0.000228571}, {3800,0.000185714}, {3850,0.000171429}, {3900,0.000076190}, {3950,0.000114286}, {4000,0.000152381}, {4050,0.000133333}, {4100,0.000190476}, {4150,0.000090476}, {4200,0.000109524}, {4250,0.000147619}, {4300,0.000114286}, {4350,0.000223810}, {4400,0.000190476}, {4450,0.000171429}, {4500,0.000247619}, {4550,0.000304762}, {4600,0.000180952}, {4650,0.000228571}, {4700,0.000247619}, {4750,0.000095238}, {4800,0.000133333}, {4850,0.000200000}, {4900,0.000266667}, {4950,0.000114286}, {5000,0.000223810}, {5050,0.00686}, {5100,0.00800}, {5150,0.00600}, {5200,0.00900}, {5250,0.00743}, {5300,0.00671}, {5350,0.00786}, {5400,0.00629}, {5450,0.00614}, {5500,0.00514}, {5550,0.00329}, {5600,0.00000}, {5650,0.00043}, {5700,0.00000}, {5750,0.00000}, {5800,0.00214}, {5850,0.00629}, {5900,0.00343}, {5950,0.00443}, {6000,0.00286}, {6050,0.00171}, {6100,0.00000}, {6150,0.00057}, {6200,0.00000}, {6250,0.00286}, {6300,0.00500}, {6350,0.00343}, {6400,0.00686}, {6450,0.00457}, {6500,0.00000}, {6550,0.00000}, {6600,0.00057}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00229}, {6900,0.00057}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00057}, {7200,0.00000}, {7250,0.00057}, {7300,0.00057}, {7350,0.00000}, {7400,0.00057}, {7450,0.00000}, {7500,0.00057}, {7550,0.00057}, {7600,0.00000}, {7650,0.00057}, {7700,0.00000}, {7750,0.00171}, {7800,0.00157}, {7850,0.00343}, {7900,0.00686}, {7950,0.00386}, {8000,0.00057}, {8050,0.00114}, {8100,0.01000}, {8150,0.00286}, {8200,0.00057}, {8250,0.00000}, {8300,0.00057}, {8350,0.00457}, {8400,0.00400}, {8450,0.00171}, {8500,0.00229}, {8550,0.00057}, {8600,0.00057}, {8650,0.00000}, {8700,0.00000}, {8750,0.00343}, {8800,0.00057}, {8850,0.00000}, {8900,0.00514}, {8950,0.00557}, {9000,0.00800}, {9050,0.00057}, {9100,0.00057}, {9150,0.00786}, {9200,0.00443}, {9250,0.00900}, {9300,0.00114}, {9350,0.00743}, {9400,0.00057}, {9450,0.00286}, {9500,0.00000}, {9550,0.00571}, {9600,0.00114}, {9650,0.00057}, {9700,0.00843}, {9750,0.00400}, {9800,0.00100}, {9850,0.00171}, {9900,0.00229}, {9950,0.00443}, {10000,0.00400}, {10100,0.00057}, {10200,0.00343}, {10300,0.00743}, {10400,0.00343}, {10500,0.00443}, {10600,0.00400}, {10700,0.00857}, {10800,0.00057}, {10900,0.01186}, {11000,0.00514}, {11100,0.00800}, {11200,0.00157}, {11300,0.02100}, {11400,0.00114}, {11500,0.01014}, {11600,0.02000}, {11700,0.00057}, {11800,0.01029}, {11900,0.01014}, {12000,0.00514}, {12100,0.00057}, {12200,0.00057}, {12300,0.00000}, {12400,0.00114}, {12500,0.00114}, {12600,0.00114}, {12700,0.00157}, {12800,0.00114}, {12900,0.00271}, {13000,0.00057}, {13100,0.00057}, {13200,0.00229}, {13300,0.00171}, {13400,0.00114}, {13500,0.00229}, {13600,0.00114}, {13700,0.00271}, {13800,0.00057}, {13900,0.00057}, {14000,0.00171}, {14100,0.00000}, {14200,0.00114}, {14300,0.00686}, {14400,0.00343}, {14500,0.01929}, {14600,0.00286}, {14700,0.01586}, {14800,0.01314}, {14900,0.00171}, {15000,0.00671}, {15100,0.00400}, {15200,0.00800}, {15300,0.00114}, {15400,0.00171}, {15500,0.00000}, {15600,0.00057}, {15700,0.00114}, {15800,0.00171}, {15900,0.00057}, {16000,0.00457}, {16100,0.00286}, {16200,0.00714}, {16300,0.00800}, {16400,0.00457}, {16500,0.00229}, {16600,0.00171}, {16700,0.00100}, {16800,0.00114}, {16900,0.00229}, {17000,0.00686}, {17100,0.01757}, {17200,0.01243}, {17300,0.01371}, {17400,0.01257}, {17500,0.01414}, {17600,0.01471}, {17700,0.00743}, {17800,0.00971}, {17900,0.00386}, {18000,0.01886}, {18100,0.00514}, {18200,0.00514}, {18300,0.00743}, {18400,0.00914}, {18500,0.00729}, {18600,0.00800}, {18700,0.01286}, {18800,0.00629}, {18900,0.00800}, {19000,0.01143}, {19100,0.01200}, {19200,0.01029}, {19300,0.02671}, {19400,0.04971}, {19500,0.04614}, {19600,0.03400}, {19700,0.01243}, {19800,0.01200}, {19900,0.00743}, {20000,0.00080}};
data["big"]["cbn Denote"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000909}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00006364}, {32,0.00015455}, {33,0.00018182}, {34,0.00023636}, {35,0.00020909}, {36,0.00023636}, {37,0.00067273}, {38,0.00100000}, {39,0.00100000}, {40,0.00100000}, {41,0.00100000}, {42,0.00100000}, {43,0.00100000}, {44,0.00100000}, {45,0.00100000}, {46,0.00100000}, {47,0.00100000}, {48,0.00100000}, {49,0.00100000}, {50,0.00100000}, {51,0.00100000}, {52,0.00100000}, {53,0.00100000}, {54,0.00100000}, {55,0.00100000}, {56,0.00100000}, {57,0.00100000}, {58,0.00100000}, {59,0.00112727}, {60,0.00110000}, {61,0.00110909}, {62,0.00115455}, {63,0.00120909}, {64,0.00124545}, {65,0.00139091}, {66,0.00142727}, {67,0.00151818}, {68,0.00163636}, {69,0.00236364}, {70,0.00196364}, {71,0.00200000}, {72,0.00200000}, {73,0.00200909}, {74,0.00200000}, {75,0.00200000}, {76,0.00200000}, {77,0.00200000}, {78,0.00200000}, {79,0.00200000}, {80,0.00200000}, {81,0.00200000}, {82,0.00200000}, {83,0.00201818}, {84,0.00210909}, {85,0.00208182}, {86,0.00207273}, {87,0.00205455}, {88,0.00210909}, {89,0.00212727}, {90,0.00215455}, {91,0.00223636}, {92,0.00225455}, {93,0.00234545}, {94,0.00243636}, {95,0.00249091}, {96,0.00260000}, {97,0.00278182}, {98,0.00295455}, {99,0.00300000}, {100,0.00300000}, {101,0.00300000}, {102,0.00300000}, {103,0.00300000}, {104,0.00300909}, {105,0.00304545}, {106,0.00306364}, {107,0.00310000}, {108,0.00307273}, {109,0.00310000}, {110,0.00309091}, {111,0.00309091}, {112,0.00309091}, {113,0.00312727}, {114,0.00311818}, {115,0.00317273}, {116,0.00315455}, {117,0.00317273}, {118,0.00328182}, {119,0.00329091}, {120,0.00342727}, {121,0.00349091}, {122,0.00379091}, {123,0.00394545}, {124,0.00400000}, {125,0.00401818}, {126,0.00406364}, {127,0.00410909}, {128,0.00406364}, {129,0.00408182}, {130,0.00408182}, {131,0.00407273}, {132,0.00405455}, {133,0.00407273}, {134,0.00405455}, {135,0.00405455}, {136,0.00410000}, {137,0.00407273}, {138,0.00408182}, {139,0.00417273}, {140,0.00422727}, {141,0.00425455}, {142,0.00428182}, {143,0.00439091}, {144,0.00453636}, {145,0.00482727}, {146,0.00495455}, {147,0.00506364}, {148,0.00505455}, {149,0.00508182}, {150,0.00505455}, {151,0.00602727}, {152,0.00506364}, {153,0.00508182}, {154,0.00510000}, {155,0.00508182}, {156,0.00506364}, {157,0.00510000}, {158,0.00510909}, {159,0.00509091}, {160,0.00510909}, {161,0.00519091}, {162,0.00527273}, {163,0.00531818}, {164,0.00542727}, {165,0.00560000}, {166,0.00585455}, {167,0.00600000}, {168,0.00607273}, {169,0.00602727}, {170,0.00606364}, {171,0.00610000}, {172,0.00606364}, {173,0.00607273}, {174,0.00604545}, {175,0.00600909}, {176,0.00607273}, {177,0.00610000}, {178,0.00611818}, {179,0.00612727}, {180,0.00619091}, {181,0.00628182}, {182,0.00627273}, {183,0.00631818}, {184,0.00640909}, {185,0.00677273}, {186,0.00700000}, {187,0.00703636}, {188,0.00703636}, {189,0.00707273}, {190,0.00707273}, {191,0.00703636}, {192,0.00710000}, {193,0.00710000}, {194,0.00709091}, {195,0.00709091}, {196,0.00712727}, {197,0.00717273}, {198,0.00710909}, {199,0.00718182}, {200,0.00718182}, {201,0.00730000}, {202,0.00742727}, {203,0.00771818}, {204,0.00791818}, {205,0.00800000}, {206,0.00802727}, {207,0.00803636}, {208,0.00809091}, {209,0.00973636}, {210,0.00807273}, {211,0.00813636}, {212,0.00809091}, {213,0.00815455}, {214,0.00812727}, {215,0.00809091}, {216,0.00815455}, {217,0.00823636}, {218,0.00823636}, {219,0.00835455}, {220,0.00859091}, {221,0.00886364}, {222,0.00892727}, {223,0.00897273}, {224,0.00910909}, {225,0.00910000}, {226,0.00910000}, {227,0.01090000}, {228,0.00911818}, {229,0.00910000}, {230,0.00914545}, {231,0.00917273}, {232,0.00911818}, {233,0.00910909}, {234,0.00914545}, {235,0.00919091}, {236,0.00940909}, {237,0.00978182}, {238,0.00990000}, {239,0.01002727}, {240,0.01006364}, {241,0.01013636}, {242,0.01012727}, {243,0.01009091}, {244,0.01012727}, {245,0.01012727}, {246,0.01008182}, {247,0.01016364}, {248,0.01014545}, {249,0.01013636}, {250,0.01028182}, {251,0.01021818}, {252,0.01049091}, {253,0.01074545}, {254,0.01092727}, {255,0.01099091}, {256,0.01110909}, {257,0.01106364}, {258,0.01109091}, {259,0.01105455}, {260,0.01110000}, {261,0.01110000}, {262,0.01109091}, {263,0.01118182}, {264,0.01119091}, {265,0.01120000}, {266,0.01137273}, {267,0.01143636}, {268,0.01184545}, {269,0.01189091}, {270,0.01204545}, {271,0.01215455}, {272,0.01210000}, {273,0.01210909}, {274,0.01215455}, {275,0.01223636}, {276,0.01211818}, {277,0.01210909}, {278,0.01208182}, {279,0.01221818}, {280,0.01222727}, {281,0.01230000}, {282,0.01260909}, {283,0.01282727}, {284,0.01292727}, {285,0.01304545}, {286,0.01316364}, {287,0.01313636}, {288,0.01316364}, {289,0.01313636}, {290,0.01309091}, {291,0.01321818}, {292,0.01313636}, {293,0.01318182}, {294,0.01318182}, {295,0.01335455}, {296,0.01368182}, {297,0.01392727}, {298,0.01400909}, {299,0.01404545}, {300,0.01412727}, {301,0.01409091}, {302,0.01409091}, {303,0.01410909}, {304,0.01421818}, {305,0.01415455}, {306,0.01418182}, {307,0.01411818}, {308,0.01430000}, {309,0.01455455}, {310,0.01480000}, {311,0.01493636}, {312,0.01508182}, {313,0.01514545}, {314,0.01509091}, {315,0.01515455}, {316,0.01511818}, {317,0.01511818}, {318,0.01513636}, {319,0.01512727}, {320,0.01527273}, {321,0.01524545}, {322,0.01541818}, {323,0.01587273}, {324,0.01589091}, {325,0.01595455}, {326,0.01606364}, {327,0.01613636}, {328,0.01619091}, {329,0.01612727}, {330,0.01608182}, {331,0.01608182}, {332,0.01611818}, {333,0.01621818}, {334,0.01633636}, {335,0.01665455}, {336,0.01673636}, {337,0.01719091}, {338,0.01697273}, {339,0.01704545}, {340,0.01721818}, {341,0.01716364}, {342,0.01720000}, {343,0.01709091}, {344,0.01715455}, {345,0.01723636}, {346,0.01738182}, {347,0.01749091}, {348,0.01761818}, {349,0.01781818}, {350,0.01794545}, {351,0.01809091}, {352,0.01929091}, {353,0.01816364}, {354,0.01810909}, {355,0.01812727}, {356,0.01822727}, {357,0.01832727}, {358,0.01829091}, {359,0.01867273}, {360,0.01878182}, {361,0.01879091}, {362,0.01895455}, {363,0.01899091}, {364,0.01909091}, {365,0.01915455}, {366,0.01905455}, {367,0.01913636}, {368,0.01915455}, {369,0.01916364}, {370,0.01941818}, {371,0.01956364}, {372,0.02173636}, {373,0.01978182}, {374,0.01998182}, {375,0.02003636}, {376,0.02013636}, {377,0.02010909}, {378,0.02018182}, {379,0.02019091}, {380,0.02022727}, {381,0.02032727}, {382,0.02047273}, {383,0.02080000}, {384,0.02088182}, {385,0.02085455}, {386,0.02093636}, {387,0.02105455}, {388,0.02109091}, {389,0.02112727}, {390,0.02115455}, {391,0.02135455}, {392,0.02163636}, {393,0.02179091}, {394,0.02176364}, {395,0.02180000}, {396,0.02190909}, {397,0.02209091}, {398,0.02200000}, {399,0.02211818}, {400,0.02214545}, {401,0.02280000}, {402,0.02212727}, {403,0.02231818}, {404,0.02250000}, {405,0.02270909}, {406,0.02260909}, {407,0.02281818}, {408,0.02304545}, {409,0.02300000}, {410,0.02310000}, {411,0.02319091}, {412,0.02315455}, {413,0.02325455}, {414,0.02510909}, {415,0.02360000}, {416,0.02370000}, {417,0.02387273}, {418,0.02390909}, {419,0.02396364}, {420,0.02404545}, {421,0.02411818}, {422,0.02417273}, {423,0.02427273}, {424,0.02440909}, {425,0.02670000}, {426,0.02463636}, {427,0.02469091}, {428,0.02477273}, {429,0.02493636}, {430,0.02506364}, {431,0.02510000}, {432,0.02515455}, {433,0.02513636}, {434,0.02531818}, {435,0.02534545}, {436,0.02563636}, {437,0.02586364}, {438,0.02583636}, {439,0.02596364}, {440,0.02600909}, {441,0.02600000}, {442,0.02608182}, {443,0.02617273}, {444,0.02623636}, {445,0.02648182}, {446,0.02666364}, {447,0.02689091}, {448,0.02688182}, {449,0.02695455}, {450,0.02706364}, {451,0.02703636}, {452,0.02711818}, {453,0.02719091}, {454,0.02731818}, {455,0.02750909}, {456,0.02772727}, {457,0.02790909}, {458,0.02784545}, {459,0.02781818}, {460,0.02801818}, {461,0.02819091}, {462,0.02806364}, {463,0.02831818}, {464,0.02835455}, {465,0.02861818}, {466,0.02867273}, {467,0.02870000}, {468,0.02895455}, {469,0.02888182}, {470,0.02900000}, {471,0.02905455}, {472,0.02930909}, {473,0.02925455}, {474,0.02940000}, {475,0.02958182}, {476,0.02985455}, {477,0.02965455}, {478,0.02980000}, {479,0.02997273}, {480,0.03002727}, {481,0.03004545}, {482,0.03027273}, {483,0.03045455}, {484,0.03056364}, {485,0.03080000}, {486,0.03063636}, {487,0.03086364}, {488,0.03089091}, {489,0.03097273}, {490,0.03342727}, {491,0.03107273}, {492,0.03121818}, {493,0.03139091}, {494,0.03172727}, {495,0.03177273}, {496,0.03185455}, {497,0.03180909}, {498,0.03194545}, {499,0.03227273}, {500,0.03227273}, {505,0.03272727}, {510,0.03521818}, {515,0.03383636}, {520,0.03444545}, {525,0.03495455}, {530,0.03553636}, {535,0.03605455}, {540,0.03683636}, {545,0.03724545}, {550,0.03775455}, {555,0.03838182}, {560,0.03891818}, {565,0.03962727}, {570,0.04038182}, {575,0.04080909}, {580,0.04160909}, {585,0.04187273}, {590,0.04260000}, {595,0.04343636}, {600,0.04386364}, {605,0.04770000}, {610,0.04524545}, {615,0.04570000}, {620,0.04651818}, {625,0.04704545}, {630,0.04780000}, {635,0.04852727}, {640,0.04897273}, {645,0.04969091}, {650,0.05043636}, {655,0.05105455}, {660,0.05166364}, {665,0.05251818}, {670,0.05300000}, {675,0.05366364}, {680,0.05456364}, {685,0.05507273}, {690,0.05572727}, {695,0.05675455}, {700,0.05754545}, {705,0.05797273}, {710,0.05883636}, {715,0.05953636}, {720,0.06031818}, {725,0.06313636}, {730,0.06176364}, {735,0.06240909}, {740,0.06310909}, {745,0.06365455}, {750,0.06481818}, {755,0.06541818}, {760,0.06701818}, {765,0.07025455}, {770,0.06753636}, {775,0.06845455}, {780,0.06925455}, {785,0.06993636}, {790,0.07070000}, {795,0.07150000}, {800,0.07240909}, {805,0.07307273}, {810,0.07390000}, {815,0.07480000}, {820,0.07573636}, {825,0.07622727}, {830,0.07753636}, {835,0.07806364}, {840,0.07868182}, {845,0.07966364}, {850,0.08063636}, {855,0.08142727}, {860,0.08230000}, {865,0.08317273}, {870,0.08382727}, {875,0.08468182}, {880,0.08551818}, {885,0.08641818}, {890,0.08724545}, {895,0.08835455}, {900,0.08930909}, {905,0.08993636}, {910,0.09088182}, {915,0.09162727}, {920,0.09271818}, {925,0.09347273}, {930,0.09445455}, {935,0.09534545}, {940,0.09633636}, {945,0.09727273}, {950,0.09825455}, {955,0.09901818}, {960,0.10006364}, {965,0.10095455}, {970,0.10180000}, {975,0.10657273}, {980,0.10368182}, {985,0.10470000}, {990,0.10576364}, {995,0.10715455}, {1000,0.10746364}, {1010,0.10942727}, {1020,0.11140909}, {1030,0.11741818}, {1040,0.11544545}, {1050,0.11730909}, {1060,0.11950000}, {1070,0.12130909}, {1080,0.12346364}, {1090,0.12552727}, {1100,0.12760000}, {1110,0.12980000}, {1120,0.13174545}, {1130,0.13385455}, {1140,0.13609091}, {1150,0.13840000}, {1160,0.14049091}, {1170,0.14272727}, {1180,0.14485455}, {1190,0.14720000}, {1200,0.14950000}, {1210,0.15215455}, {1220,0.15403636}, {1230,0.16267273}, {1240,0.15862727}, {1250,0.16080000}, {1260,0.16345455}, {1270,0.16582727}, {1280,0.16800000}, {1290,0.17022727}, {1300,0.17265455}, {1310,0.17518182}, {1320,0.17770909}, {1330,0.18001818}, {1340,0.18258182}, {1350,0.18499091}, {1360,0.18755455}, {1370,0.19020000}, {1380,0.19253636}, {1390,0.19532727}, {1400,0.19798182}, {1410,0.20045455}, {1420,0.20311818}, {1430,0.20594545}, {1440,0.21172727}, {1450,0.21100909}, {1460,0.21373636}, {1470,0.21629091}, {1480,0.21903636}, {1490,0.22502727}, {1500,0.22473636}, {1510,0.22769091}, {1520,0.23028182}, {1530,0.23312727}, {1540,0.23580000}, {1550,0.24053636}, {1560,0.24123636}, {1570,0.24436364}, {1580,0.24719091}, {1590,0.24980909}, {1600,0.25278182}, {1610,0.26057273}, {1620,0.25832727}, {1630,0.26152727}, {1640,0.26479091}, {1650,0.26753636}, {1660,0.27070909}, {1670,0.27386364}, {1680,0.27676364}, {1690,0.28014545}, {1700,0.28287273}, {1710,0.29507273}, {1720,0.28930909}, {1730,0.29249091}, {1740,0.29552727}, {1750,0.29877273}, {1760,0.30997273}, {1770,0.30535455}, {1780,0.30870000}, {1790,0.31940000}, {1800,0.31520000}, {1810,0.31817273}, {1820,0.32162727}, {1830,0.32973636}, {1840,0.32811818}, {1850,0.33142727}, {1860,0.33481818}, {1870,0.34684545}, {1880,0.34174545}, {1890,0.34504545}, {1900,0.34835455}, {1910,0.35192727}, {1920,0.35516364}, {1930,0.36189091}, {1940,0.37044545}, {1950,0.36618182}, {1960,0.36954545}, {1970,0.37380000}, {1980,0.37712727}, {1990,0.38056364}, {2000,0.38400909}, {2050,0.40250000}, {2100,0.42110909}, {2150,0.44620909}, {2200,0.45940909}, {2250,0.47965455}, {2300,0.50864545}, {2350,0.52180909}, {2400,0.54976364}, {2450,0.56376364}, {2500,0.58570909}, {2550,0.60950909}, {2600,0.64234545}, {2650,0.65418182}, {2700,0.67777273}, {2750,0.71370000}, {2800,0.74055455}, {2850,0.75057273}, {2900,0.77514545}, {2950,0.81223636}, {3000,0.82729091}, {3050,0.85275}, {3100,0.88625}, {3150,0.90675}, {3200,0.93425}, {3250,0.96575}, {3300,0.99900}, {3350,1.02800}, {3400,1.05800}, {3450,1.09000}, {3500,1.11650}, {3550,1.15550}, {3600,1.18500}, {3650,1.21225}, {3700,1.25400}, {3750,1.27625}, {3800,1.30775}, {3850,1.35575}, {3900,1.38125}, {3950,1.43325}, {4000,1.44050}, {4050,1.47775}, {4100,1.52075}, {4150,1.55100}, {4200,1.61200}, {4250,1.62050}, {4300,1.66725}, {4350,1.69600}, {4400,1.74400}, {4450,1.77100}, {4500,1.82850}, {4550,1.91000}, {4600,1.92150}, {4650,1.95450}, {4700,1.99650}, {4750,2.05000}, {4800,2.09600}, {4850,2.28950}, {4900,2.17800}, {4950,2.22150}, {5000,2.25725}, {5050,2.31050}, {5100,2.36675}, {5150,2.41675}, {5200,2.45775}, {5250,2.51550}, {5300,2.56800}, {5350,2.61075}, {5400,2.65125}, {5450,2.69825}, {5500,2.76225}, {5550,2.82800}, {5600,2.90925}, {5650,3.43700}, {5700,2.98100}, {5750,3.05550}, {5800,3.18775}, {5850,3.90050}, {5900,3.22275}, {5950,3.26575}, {6000,3.28275}, {6050,3.34150}, {6100,3.43500}, {6150,3.50800}, {6200,3.94050}, {6250,3.65450}, {6300,3.67950}, {6350,3.75875}, {6400,3.82275}, {6450,3.86625}, {6500,4.01525}, {6550,4.28100}, {6600,4.05800}, {6650,4.28575}, {6700,5.33425}, {6750,4.44525}, {6800,4.64200}, {6850,5.20900}, {6900,4.67975}, {6950,4.63050}, {7000,6.03775}, {7050,5.21375}, {7100,5.06000}, {7150,6.64650}, {7200,5.32875}, {7250,5.26375}, {7300,6.59425}, {7350,5.47200}, {7400,5.57725}, {7450,6.99875}, {7500,5.95550}, {7550,6.02975}, {7600,7.18825}, {7650,6.13550}, {7700,6.37575}, {7750,8.08900}, {7800,6.17425}, {7850,6.79225}, {7900,7.24975}, {7950,7.14125}, {8000,7.13100}, {8050,7.11675}, {8100,6.98975}, {8150,8.48675}, {8200,6.98725}, {8250,7.20325}, {8300,7.93500}, {8350,6.78100}, {8400,7.19375}, {8450,7.54600}, {8500,7.30625}, {8550,10.07225}, {8600,7.63950}, {8650,7.45525}, {8700,7.65575}, {8750,7.50275}, {8800,8.78825}, {8850,7.97350}, {8900,8.12950}, {8950,8.58350}, {9000,8.16375}, {9050,11.17350}, {9100,8.31100}, {9150,8.39700}, {9200,8.36325}, {9250,8.61900}, {9300,10.56525}, {9350,9.65275}, {9400,11.60550}, {9450,9.92875}, {9500,9.38900}, {9550,9.44625}, {9600,9.83150}, {9650,11.10575}, {9700,10.27800}, {9750,11.67650}, {9800,10.53450}, {9850,10.68725}, {9900,10.31250}, {9950,10.60750}, {10000,10.47125}, {10100,9.6065}, {10200,10.1925}, {10300,10.1660}, {10400,17.562}, {10500,10.8}, {10600,12.451}, {10700,11.921}, {10800,13.001}, {10900,11.571}, {11000,13.156}, {11100,12.285}, {11200,12.246}, {11300,18.507}, {11400,12.73}, {11500,13.969}, {11600,12.812}, {11700,14.884}, {11800,14.2}, {11900,13.758}, {12000,16.476}, {12100,15.061}, {12200,14.845}, {12300,18.088}, {12400,16.459}, {12500,17.992}, {12600,17.611}, {12700,17.519}, {12800,23.675}, {12900,18.294}, {13000,19.55}, {13100,28.071}, {13200,20.222}, {13300,19.762}, {13400,28.81}, {13500,21.187}, {13600,21.891}, {13700,18.427}, {13800,22.185}, {13900,24.092}, {14000,21.739}, {14100,23.527}, {14200,24.581}, {14300,23.47}, {14400,23.763}, {14500,24.568}, {14600,24.882}, {14700,23.285}, {14800,25.99}, {14900,26.985}, {15000,25.412}, {15100,26.407}, {15200,26.996}, {15300,27.768}, {15400,26.697}, {15500,28.666}, {15600,30.1}, {15700,31.193}, {15800,28.806}, {15900,29.542}, {16000,30.211}, {16100,30.692}, {16200,30.947}, {16300,26.472}, {16400,33.269}, {16500,33.84}, {16600,34.007}, {16700,31.963}, {16800,31.122}, {16900,35.038}, {17000,35.543}, {17100,36.08}, {17200,34.887}, {17300,32.015}, {17400,37.493}, {17500,51.322}, {17600,51.566}, {17700,38.357}, {17800,38.967}, {17900,33.021}, {18000,39.472}, {18100,41.618}, {18200,40.951}, {18300,42.146}, {18400,40.516}, {18500,40.863}, {18600,40.331}, {18700,38.869}, {18800,43.278}, {18900,44.042}, {19000,44.155}, {19100,51.569}, {19200,62.179}, {19300,64.922}, {19400,48.521}, {19500,48.625}, {19600,46.261}, {19700,45.388}, {19800,41.693}, {19900,48.648}};
data["big"]["cbn Denote"]["Stats"]["user"] = {{1,0.00002727}, {2,0.00010000}, {3,0.00002727}, {4,0.00021818}, {5,0.00031818}, {6,0.00020909}, {7,0.00036364}, {8,0.00027273}, {9,0.00006364}, {10,0.00009091}, {11,0.00018182}, {12,0.00016364}, {13,0.00042727}, {14,0.00032727}, {15,0.00044545}, {16,0.00027273}, {17,0.00036364}, {18,0.00040909}, {19,0.00047273}, {20,0.00050000}, {21,0.00060000}, {22,0.00066364}, {23,0.00045455}, {24,0.00052727}, {25,0.00041818}, {26,0.00069091}, {27,0.00060909}, {28,0.00058182}, {29,0.00091818}, {30,0.00059091}, {31,0.00082727}, {32,0.00066364}, {33,0.00070000}, {34,0.00074545}, {35,0.00080909}, {36,0.00091818}, {37,0.00094545}, {38,0.00078182}, {39,0.00074545}, {40,0.00086364}, {41,0.00093636}, {42,0.00100909}, {43,0.00113636}, {44,0.00094545}, {45,0.00077273}, {46,0.00084545}, {47,0.00125455}, {48,0.00096364}, {49,0.00100909}, {50,0.00152727}, {51,0.00130000}, {52,0.00101818}, {53,0.00162727}, {54,0.00101818}, {55,0.00144545}, {56,0.00135455}, {57,0.00123636}, {58,0.00135455}, {59,0.00140909}, {60,0.00154545}, {61,0.00156364}, {62,0.00164545}, {63,0.00149091}, {64,0.00155455}, {65,0.00163636}, {66,0.00172727}, {67,0.00166364}, {68,0.00189091}, {69,0.00211818}, {70,0.00179091}, {71,0.00222727}, {72,0.00170000}, {73,0.00170909}, {74,0.00208182}, {75,0.00169091}, {76,0.00230909}, {77,0.00187273}, {78,0.00170000}, {79,0.00206364}, {80,0.00220000}, {81,0.00194545}, {82,0.00181818}, {83,0.00226364}, {84,0.00240909}, {85,0.00241818}, {86,0.00245455}, {87,0.00239091}, {88,0.00247273}, {89,0.00239091}, {90,0.00236364}, {91,0.00208182}, {92,0.00263636}, {93,0.00246364}, {94,0.00233636}, {95,0.00256364}, {96,0.00260909}, {97,0.00245455}, {98,0.00273636}, {99,0.00264545}, {100,0.00254545}, {101,0.00264545}, {102,0.00293636}, {103,0.00269091}, {104,0.00291818}, {105,0.00277273}, {106,0.00300909}, {107,0.00286364}, {108,0.00303636}, {109,0.00317273}, {110,0.00306364}, {111,0.00303636}, {112,0.00302727}, {113,0.00308182}, {114,0.00336364}, {115,0.00318182}, {116,0.00312727}, {117,0.00320909}, {118,0.00330000}, {119,0.00340000}, {120,0.00328182}, {121,0.00332727}, {122,0.00345455}, {123,0.00365455}, {124,0.00361818}, {125,0.00368182}, {126,0.00373636}, {127,0.00372727}, {128,0.00369091}, {129,0.00378182}, {130,0.00380000}, {131,0.00376364}, {132,0.00413636}, {133,0.00390000}, {134,0.00407273}, {135,0.00410909}, {136,0.00400909}, {137,0.00403636}, {138,0.00422727}, {139,0.00436364}, {140,0.00404545}, {141,0.00429091}, {142,0.00473636}, {143,0.00475455}, {144,0.00460000}, {145,0.00452727}, {146,0.00438182}, {147,0.00470000}, {148,0.00465455}, {149,0.00486364}, {150,0.00470909}, {151,0.00634545}, {152,0.00456364}, {153,0.00500909}, {154,0.00510000}, {155,0.00505455}, {156,0.00499091}, {157,0.00534545}, {158,0.00513636}, {159,0.00531818}, {160,0.00560000}, {161,0.00548182}, {162,0.00526364}, {163,0.00570000}, {164,0.00535455}, {165,0.00558182}, {166,0.00542727}, {167,0.00560909}, {168,0.00562727}, {169,0.00517273}, {170,0.00591818}, {171,0.00592727}, {172,0.00579091}, {173,0.00631818}, {174,0.00603636}, {175,0.00618182}, {176,0.00612727}, {177,0.00614545}, {178,0.00621818}, {179,0.00609091}, {180,0.00662727}, {181,0.00639091}, {182,0.00660909}, {183,0.00672727}, {184,0.00663636}, {185,0.00677273}, {186,0.00684545}, {187,0.00677273}, {188,0.00670000}, {189,0.00667273}, {190,0.00722727}, {191,0.00719091}, {192,0.00703636}, {193,0.00712727}, {194,0.00745455}, {195,0.00729091}, {196,0.00738182}, {197,0.00748182}, {198,0.00737273}, {199,0.00738182}, {200,0.00763636}, {201,0.00758182}, {202,0.00799091}, {203,0.00779091}, {204,0.00798182}, {205,0.00761818}, {206,0.00806364}, {207,0.00780000}, {208,0.00829091}, {209,0.01051818}, {210,0.00821818}, {211,0.00850000}, {212,0.00820909}, {213,0.00842727}, {214,0.00858182}, {215,0.00823636}, {216,0.00867273}, {217,0.00858182}, {218,0.00842727}, {219,0.00898182}, {220,0.00918182}, {221,0.00868182}, {222,0.00900909}, {223,0.00901818}, {224,0.00917273}, {225,0.00929091}, {226,0.00952727}, {227,0.01134545}, {228,0.00974545}, {229,0.00943636}, {230,0.00973636}, {231,0.00977273}, {232,0.00958182}, {233,0.00955455}, {234,0.00979091}, {235,0.00998182}, {236,0.01038182}, {237,0.00996364}, {238,0.00976364}, {239,0.01006364}, {240,0.00994545}, {241,0.01016364}, {242,0.01046364}, {243,0.01012727}, {244,0.01030909}, {245,0.01073636}, {246,0.01068182}, {247,0.01056364}, {248,0.01078182}, {249,0.01052727}, {250,0.01102727}, {251,0.01092727}, {252,0.01093636}, {253,0.01098182}, {254,0.01119091}, {255,0.01124545}, {256,0.01123636}, {257,0.01139091}, {258,0.01097273}, {259,0.01129091}, {260,0.01143636}, {261,0.01146364}, {262,0.01136364}, {263,0.01182727}, {264,0.01183636}, {265,0.01176364}, {266,0.01215455}, {267,0.01205455}, {268,0.01218182}, {269,0.01218182}, {270,0.01215455}, {271,0.01228182}, {272,0.01245455}, {273,0.01247273}, {274,0.01240909}, {275,0.01257273}, {276,0.01247273}, {277,0.01250909}, {278,0.01262727}, {279,0.01248182}, {280,0.01263636}, {281,0.01282727}, {282,0.01265455}, {283,0.01290000}, {284,0.01291818}, {285,0.01342727}, {286,0.01306364}, {287,0.01317273}, {288,0.01332727}, {289,0.01340909}, {290,0.01306364}, {291,0.01338182}, {292,0.01347273}, {293,0.01340000}, {294,0.01377273}, {295,0.01372727}, {296,0.01350000}, {297,0.01382727}, {298,0.01390909}, {299,0.01372727}, {300,0.01400000}, {301,0.01407273}, {302,0.01396364}, {303,0.01399091}, {304,0.01445455}, {305,0.01400000}, {306,0.01434545}, {307,0.01432727}, {308,0.01404545}, {309,0.01467273}, {310,0.01466364}, {311,0.01479091}, {312,0.01491818}, {313,0.01490000}, {314,0.01479091}, {315,0.01483636}, {316,0.01507273}, {317,0.01483636}, {318,0.01516364}, {319,0.01516364}, {320,0.01521818}, {321,0.01529091}, {322,0.01522727}, {323,0.01560909}, {324,0.01559091}, {325,0.01566364}, {326,0.01559091}, {327,0.01566364}, {328,0.01597273}, {329,0.01599091}, {330,0.01609091}, {331,0.01594545}, {332,0.01627273}, {333,0.01602727}, {334,0.01630909}, {335,0.01673636}, {336,0.01665455}, {337,0.01681818}, {338,0.01707273}, {339,0.01676364}, {340,0.01694545}, {341,0.01715455}, {342,0.01720000}, {343,0.01699091}, {344,0.01722727}, {345,0.01736364}, {346,0.01720909}, {347,0.01766364}, {348,0.01774545}, {349,0.01754545}, {350,0.01752727}, {351,0.01786364}, {352,0.01945455}, {353,0.01798182}, {354,0.01819091}, {355,0.01792727}, {356,0.01860000}, {357,0.01891818}, {358,0.01883636}, {359,0.01872727}, {360,0.01901818}, {361,0.01900909}, {362,0.01895455}, {363,0.01888182}, {364,0.01924545}, {365,0.01926364}, {366,0.01940909}, {367,0.01949091}, {368,0.01932727}, {369,0.01940000}, {370,0.01958182}, {371,0.01972727}, {372,0.02190909}, {373,0.01964545}, {374,0.01995455}, {375,0.02013636}, {376,0.02017273}, {377,0.02035455}, {378,0.02043636}, {379,0.02039091}, {380,0.02037273}, {381,0.02049091}, {382,0.02061818}, {383,0.02092727}, {384,0.02069091}, {385,0.02100909}, {386,0.02116364}, {387,0.02119091}, {388,0.02140909}, {389,0.02125455}, {390,0.02143636}, {391,0.02150000}, {392,0.02208182}, {393,0.02241818}, {394,0.02220000}, {395,0.02216364}, {396,0.02181818}, {397,0.02235455}, {398,0.02227273}, {399,0.02254545}, {400,0.02250909}, {401,0.02284545}, {402,0.02262727}, {403,0.02278182}, {404,0.02273636}, {405,0.02308182}, {406,0.02320000}, {407,0.02290909}, {408,0.02357273}, {409,0.02343636}, {410,0.02342727}, {411,0.02331818}, {412,0.02363636}, {413,0.02356364}, {414,0.02531818}, {415,0.02388182}, {416,0.02388182}, {417,0.02418182}, {418,0.02412727}, {419,0.02460909}, {420,0.02428182}, {421,0.02437273}, {422,0.02460909}, {423,0.02459091}, {424,0.02478182}, {425,0.02641818}, {426,0.02489091}, {427,0.02490909}, {428,0.02500000}, {429,0.02492727}, {430,0.02524545}, {431,0.02518182}, {432,0.02524545}, {433,0.02534545}, {434,0.02538182}, {435,0.02547273}, {436,0.02579091}, {437,0.02598182}, {438,0.02570000}, {439,0.02612727}, {440,0.02584545}, {441,0.02580909}, {442,0.02623636}, {443,0.02628182}, {444,0.02622727}, {445,0.02655455}, {446,0.02657273}, {447,0.02667273}, {448,0.02665455}, {449,0.02686364}, {450,0.02700909}, {451,0.02671818}, {452,0.02710909}, {453,0.02716364}, {454,0.02723636}, {455,0.02729091}, {456,0.02749091}, {457,0.02772727}, {458,0.02750909}, {459,0.02760909}, {460,0.02787273}, {461,0.02803636}, {462,0.02811818}, {463,0.02810909}, {464,0.02837273}, {465,0.02806364}, {466,0.02829091}, {467,0.02828182}, {468,0.02850000}, {469,0.02840000}, {470,0.02882727}, {471,0.02877273}, {472,0.02900000}, {473,0.02940909}, {474,0.02944545}, {475,0.02944545}, {476,0.02934545}, {477,0.02927273}, {478,0.02974545}, {479,0.03024545}, {480,0.03010909}, {481,0.03000909}, {482,0.03051818}, {483,0.03057273}, {484,0.03038182}, {485,0.03079091}, {486,0.03072727}, {487,0.03050909}, {488,0.03122727}, {489,0.03079091}, {490,0.03357273}, {491,0.03125455}, {492,0.03150000}, {493,0.03146364}, {494,0.03161818}, {495,0.03174545}, {496,0.03225455}, {497,0.03208182}, {498,0.03214545}, {499,0.03261818}, {500,0.03260909}, {505,0.03284545}, {510,0.03554545}, {515,0.03390909}, {520,0.03455455}, {525,0.03534545}, {530,0.03591818}, {535,0.03637273}, {540,0.03711818}, {545,0.03740000}, {550,0.03807273}, {555,0.03837273}, {560,0.03903636}, {565,0.03959091}, {570,0.04047273}, {575,0.04060000}, {580,0.04125455}, {585,0.04170909}, {590,0.04228182}, {595,0.04310909}, {600,0.04390000}, {605,0.04788182}, {610,0.04523636}, {615,0.04608182}, {620,0.04650000}, {625,0.04747273}, {630,0.04811818}, {635,0.04860909}, {640,0.04941818}, {645,0.04970000}, {650,0.05038182}, {655,0.05133636}, {660,0.05182727}, {665,0.05262727}, {670,0.05318182}, {675,0.05366364}, {680,0.05402727}, {685,0.05497273}, {690,0.05584545}, {695,0.05659091}, {700,0.05780000}, {705,0.05791818}, {710,0.05896364}, {715,0.05997273}, {720,0.06066364}, {725,0.06312727}, {730,0.06187273}, {735,0.06261818}, {740,0.06300000}, {745,0.06378182}, {750,0.06472727}, {755,0.06541818}, {760,0.06682727}, {765,0.07044545}, {770,0.06760909}, {775,0.06813636}, {780,0.06934545}, {785,0.06993636}, {790,0.07088182}, {795,0.07184545}, {800,0.07280909}, {805,0.07361818}, {810,0.07392727}, {815,0.07490909}, {820,0.07575455}, {825,0.07636364}, {830,0.07738182}, {835,0.07808182}, {840,0.07854545}, {845,0.07980000}, {850,0.08052727}, {855,0.08124545}, {860,0.08194545}, {865,0.08332727}, {870,0.08424545}, {875,0.08520909}, {880,0.08591818}, {885,0.08671818}, {890,0.08731818}, {895,0.08825455}, {900,0.08900909}, {905,0.08979091}, {910,0.09089091}, {915,0.09157273}, {920,0.09254545}, {925,0.09326364}, {930,0.09452727}, {935,0.09564545}, {940,0.09680000}, {945,0.09750909}, {950,0.09831818}, {955,0.09897273}, {960,0.10031818}, {965,0.10091818}, {970,0.10178182}, {975,0.10681818}, {980,0.10357273}, {985,0.10471818}, {990,0.10562727}, {995,0.10735455}, {1000,0.10783636}, {1010,0.10956364}, {1020,0.11156364}, {1030,0.11690000}, {1040,0.11550909}, {1050,0.11729091}, {1060,0.11999091}, {1070,0.12129091}, {1080,0.12349091}, {1090,0.12533636}, {1100,0.12740909}, {1110,0.12980909}, {1120,0.13172727}, {1130,0.13410909}, {1140,0.13569091}, {1150,0.13809091}, {1160,0.14016364}, {1170,0.14286364}, {1180,0.14491818}, {1190,0.14704545}, {1200,0.14942727}, {1210,0.15150909}, {1220,0.15427273}, {1230,0.16212727}, {1240,0.15865455}, {1250,0.16074545}, {1260,0.16343636}, {1270,0.16606364}, {1280,0.16826364}, {1290,0.17038182}, {1300,0.17286364}, {1310,0.17511818}, {1320,0.17797273}, {1330,0.17990000}, {1340,0.18261818}, {1350,0.18480000}, {1360,0.18714545}, {1370,0.19016364}, {1380,0.19248182}, {1390,0.19503636}, {1400,0.19799091}, {1410,0.20027273}, {1420,0.20296364}, {1430,0.20586364}, {1440,0.21146364}, {1450,0.21032727}, {1460,0.21406364}, {1470,0.21640000}, {1480,0.21878182}, {1490,0.22525455}, {1500,0.22477273}, {1510,0.22759091}, {1520,0.23013636}, {1530,0.23280000}, {1540,0.23583636}, {1550,0.24074545}, {1560,0.24133636}, {1570,0.24411818}, {1580,0.24718182}, {1590,0.25000000}, {1600,0.25261818}, {1610,0.26030909}, {1620,0.25849091}, {1630,0.26150909}, {1640,0.26455455}, {1650,0.26761818}, {1660,0.27060909}, {1670,0.27411818}, {1680,0.27661818}, {1690,0.27960909}, {1700,0.28281818}, {1710,0.29465455}, {1720,0.28926364}, {1730,0.29228182}, {1740,0.29565455}, {1750,0.29873636}, {1760,0.30963636}, {1770,0.30495455}, {1780,0.30880000}, {1790,0.31951818}, {1800,0.31503636}, {1810,0.31797273}, {1820,0.32167273}, {1830,0.32950909}, {1840,0.32790909}, {1850,0.33156364}, {1860,0.33464545}, {1870,0.34672727}, {1880,0.34163636}, {1890,0.34486364}, {1900,0.34832727}, {1910,0.35172727}, {1920,0.35528182}, {1930,0.36172727}, {1940,0.37032727}, {1950,0.36617273}, {1960,0.36963636}, {1970,0.37354545}, {1980,0.37676364}, {1990,0.38063636}, {2000,0.38422727}, {2050,0.40235455}, {2100,0.42096364}, {2150,0.44581818}, {2200,0.45913636}, {2250,0.47970909}, {2300,0.50901818}, {2350,0.52228182}, {2400,0.54987273}, {2450,0.56364545}, {2500,0.58591818}, {2550,0.60945455}, {2600,0.64197273}, {2650,0.65396364}, {2700,0.67767273}, {2750,0.71335455}, {2800,0.74016364}, {2850,0.75030000}, {2900,0.77505455}, {2950,0.81191818}, {3000,0.82730000}, {3050,0.85250}, {3100,0.88300}, {3150,0.90500}, {3200,0.93375}, {3250,0.96450}, {3300,1.00100}, {3350,1.02950}, {3400,1.05750}, {3450,1.08950}, {3500,1.11550}, {3550,1.15500}, {3600,1.18400}, {3650,1.21175}, {3700,1.24950}, {3750,1.27650}, {3800,1.30775}, {3850,1.35650}, {3900,1.38150}, {3950,1.43450}, {4000,1.44075}, {4050,1.47875}, {4100,1.51875}, {4150,1.55050}, {4200,1.61250}, {4250,1.62025}, {4300,1.66650}, {4350,1.69650}, {4400,1.74400}, {4450,1.77075}, {4500,1.82725}, {4550,1.91000}, {4600,1.92025}, {4650,1.95350}, {4700,1.99475}, {4750,2.05100}, {4800,2.09650}, {4850,2.28825}, {4900,2.17675}, {4950,2.22050}, {5000,2.25625}, {5050,2.31025}, {5100,2.36550}, {5150,2.41300}, {5200,2.45775}, {5250,2.51375}, {5300,2.56875}, {5350,2.61075}, {5400,2.65025}, {5450,2.69850}, {5500,2.76000}, {5550,2.82750}, {5600,2.90575}, {5650,3.43450}, {5700,2.97950}, {5750,3.05575}, {5800,3.18775}, {5850,3.89900}, {5900,3.21950}, {5950,3.26450}, {6000,3.28075}, {6050,3.34050}, {6100,3.43550}, {6150,3.50650}, {6200,3.93950}, {6250,3.65325}, {6300,3.67850}, {6350,3.75850}, {6400,3.82150}, {6450,3.86525}, {6500,4.01350}, {6550,4.27950}, {6600,4.05650}, {6650,4.28525}, {6700,5.33500}, {6750,4.44450}, {6800,4.63950}, {6850,5.20525}, {6900,4.67550}, {6950,4.62550}, {7000,6.03725}, {7050,5.21275}, {7100,5.05825}, {7150,6.64175}, {7200,5.32650}, {7250,5.26200}, {7300,6.59250}, {7350,5.47300}, {7400,5.57600}, {7450,6.99725}, {7500,5.95500}, {7550,6.02625}, {7600,7.18775}, {7650,6.13500}, {7700,6.37575}, {7750,8.08600}, {7800,6.17225}, {7850,6.79250}, {7900,7.25000}, {7950,7.14150}, {8000,7.13000}, {8050,7.11625}, {8100,6.98900}, {8150,8.48675}, {8200,6.98875}, {8250,7.20375}, {8300,7.93375}, {8350,6.77800}, {8400,7.19250}, {8450,7.54550}, {8500,7.30400}, {8550,10.06700}, {8600,7.63775}, {8650,7.45225}, {8700,7.65300}, {8750,7.49750}, {8800,8.78025}, {8850,7.96950}, {8900,8.12750}, {8950,8.57925}, {9000,8.15675}, {9050,11.16575}, {9100,8.30650}, {9150,8.39150}, {9200,8.35650}, {9250,8.61375}, {9300,10.56150}, {9350,9.64900}, {9400,11.60000}, {9450,9.92575}, {9500,9.38750}, {9550,9.44025}, {9600,9.82575}, {9650,11.10150}, {9700,10.27250}, {9750,11.67150}, {9800,10.52950}, {9850,10.68250}, {9900,10.30725}, {9950,10.59975}, {10000,10.46800}, {10100,9.5940}, {10200,10.1035}, {10300,10.1535}, {10400,17.563}, {10500,10.8}, {10600,12.451}, {10700,11.92}, {10800,13.}, {10900,11.572}, {11000,13.155}, {11100,12.283}, {11200,12.243}, {11300,18.508}, {11400,12.727}, {11500,13.968}, {11600,12.812}, {11700,14.884}, {11800,14.203}, {11900,13.759}, {12000,16.476}, {12100,15.063}, {12200,14.844}, {12300,18.079}, {12400,16.455}, {12500,17.991}, {12600,17.611}, {12700,17.519}, {12800,23.675}, {12900,18.292}, {13000,19.548}, {13100,28.072}, {13200,20.215}, {13300,19.763}, {13400,28.807}, {13500,21.184}, {13600,21.887}, {13700,18.423}, {13800,22.184}, {13900,24.091}, {14000,21.739}, {14100,23.527}, {14200,24.579}, {14300,23.471}, {14400,23.764}, {14500,24.567}, {14600,24.88}, {14700,23.284}, {14800,25.991}, {14900,26.983}, {15000,25.416}, {15100,26.407}, {15200,26.996}, {15300,27.771}, {15400,26.696}, {15500,28.664}, {15600,30.099}, {15700,31.195}, {15800,28.807}, {15900,29.543}, {16000,30.211}, {16100,30.692}, {16200,30.948}, {16300,26.471}, {16400,33.271}, {16500,33.84}, {16600,34.007}, {16700,31.963}, {16800,31.119}, {16900,35.039}, {17000,35.543}, {17100,36.079}, {17200,34.887}, {17300,32.015}, {17400,37.496}, {17500,51.324}, {17600,51.568}, {17700,38.356}, {17800,38.967}, {17900,33.023}, {18000,39.471}, {18100,41.619}, {18200,40.952}, {18300,42.148}, {18400,40.515}, {18500,40.864}, {18600,40.331}, {18700,38.867}, {18800,43.28}, {18900,44.043}, {19000,44.156}, {19100,51.572}, {19200,62.18}, {19300,64.92}, {19400,48.523}, {19500,48.623}, {19600,46.26}, {19700,45.387}, {19800,41.692}, {19900,48.647}};
data["big"]["cbn Denote"]["Stats"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00003636}, {14,0.00000000}, {15,0.00003636}, {16,0.00000000}, {17,0.00000000}, {18,0.00002727}, {19,0.00000000}, {20,0.00003636}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00003636}, {28,0.00000000}, {29,0.00000000}, {30,0.00002727}, {31,0.00003636}, {32,0.00007273}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00002727}, {41,0.00000000}, {42,0.00000000}, {43,0.00003636}, {44,0.00007273}, {45,0.00003636}, {46,0.00000000}, {47,0.00003636}, {48,0.00000000}, {49,0.00002727}, {50,0.00000000}, {51,0.00007273}, {52,0.00010000}, {53,0.00000000}, {54,0.00002727}, {55,0.00000000}, {56,0.00000000}, {57,0.00003636}, {58,0.00003636}, {59,0.00007273}, {60,0.00003636}, {61,0.00000000}, {62,0.00003636}, {63,0.00013636}, {64,0.00000000}, {65,0.00007273}, {66,0.00003636}, {67,0.00003636}, {68,0.00002727}, {69,0.00000000}, {70,0.00003636}, {71,0.00007273}, {72,0.00003636}, {73,0.00007273}, {74,0.00010909}, {75,0.00000000}, {76,0.00003636}, {77,0.00000000}, {78,0.00000000}, {79,0.00006364}, {80,0.00003636}, {81,0.00003636}, {82,0.00003636}, {83,0.00000000}, {84,0.00003636}, {85,0.00000000}, {86,0.00000000}, {87,0.00007273}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00003636}, {92,0.00003636}, {93,0.00003636}, {94,0.00003636}, {95,0.00000000}, {96,0.00007273}, {97,0.00007273}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00010909}, {106,0.00007273}, {107,0.00003636}, {108,0.00000000}, {109,0.00000000}, {110,0.00006364}, {111,0.00000000}, {112,0.00000000}, {113,0.00002727}, {114,0.00000000}, {115,0.00000000}, {116,0.00013636}, {117,0.00003636}, {118,0.00003636}, {119,0.00000000}, {120,0.00003636}, {121,0.00003636}, {122,0.00003636}, {123,0.00003636}, {124,0.00014545}, {125,0.00003636}, {126,0.00003636}, {127,0.00000000}, {128,0.00000000}, {129,0.00003636}, {130,0.00003636}, {131,0.00000000}, {132,0.00003636}, {133,0.00002727}, {134,0.00003636}, {135,0.00000000}, {136,0.00003636}, {137,0.00003636}, {138,0.00003636}, {139,0.00010909}, {140,0.00007273}, {141,0.00000000}, {142,0.00002727}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00002727}, {147,0.00000000}, {148,0.00000000}, {149,0.00003636}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00003636}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00003636}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00006364}, {163,0.00000000}, {164,0.00003636}, {165,0.00003636}, {166,0.00000000}, {167,0.00007273}, {168,0.00007273}, {169,0.00000000}, {170,0.00003636}, {171,0.00000000}, {172,0.00000000}, {173,0.00002727}, {174,0.00000000}, {175,0.00003636}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00003636}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00003636}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00003636}, {188,0.00003636}, {189,0.00013636}, {190,0.00000000}, {191,0.00000000}, {192,0.00003636}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00003636}, {203,0.00000000}, {204,0.00000000}, {205,0.00007273}, {206,0.00000000}, {207,0.00003636}, {208,0.00000000}, {209,0.00006364}, {210,0.00000000}, {211,0.00000000}, {212,0.00007273}, {213,0.00000000}, {214,0.00000000}, {215,0.00003636}, {216,0.00003636}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00003636}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00010909}, {228,0.00000000}, {229,0.00007273}, {230,0.00000000}, {231,0.00003636}, {232,0.00000000}, {233,0.00003636}, {234,0.00007273}, {235,0.00000000}, {236,0.00000000}, {237,0.00003636}, {238,0.00003636}, {239,0.00000000}, {240,0.00003636}, {241,0.00000000}, {242,0.00000000}, {243,0.00010909}, {244,0.00000000}, {245,0.00000000}, {246,0.00010909}, {247,0.00003636}, {248,0.00000000}, {249,0.00007273}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00003636}, {254,0.00000000}, {255,0.00003636}, {256,0.00003636}, {257,0.00000000}, {258,0.00010000}, {259,0.00003636}, {260,0.00003636}, {261,0.00000000}, {262,0.00007273}, {263,0.00000000}, {264,0.00003636}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00007273}, {272,0.00000000}, {273,0.00000000}, {274,0.00003636}, {275,0.00000000}, {276,0.00003636}, {277,0.00003636}, {278,0.00003636}, {279,0.00010909}, {280,0.00000000}, {281,0.00007273}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00003636}, {291,0.00000000}, {292,0.00000000}, {293,0.00003636}, {294,0.00000000}, {295,0.00003636}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00007273}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00003636}, {304,0.00000000}, {305,0.00003636}, {306,0.00000000}, {307,0.00003636}, {308,0.00000000}, {309,0.00000000}, {310,0.00003636}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00003636}, {318,0.00000000}, {319,0.00003636}, {320,0.00006364}, {321,0.00000000}, {322,0.00007273}, {323,0.00003636}, {324,0.00007273}, {325,0.00003636}, {326,0.00000000}, {327,0.00006364}, {328,0.00000000}, {329,0.00003636}, {330,0.00003636}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00007273}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00003636}, {340,0.00000000}, {341,0.00000000}, {342,0.00007273}, {343,0.00000000}, {344,0.00003636}, {345,0.00007273}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00003636}, {351,0.00003636}, {352,0.00007273}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00006364}, {357,0.00003636}, {358,0.00003636}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00003636}, {364,0.00003636}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00002727}, {369,0.00000000}, {370,0.00003636}, {371,0.00000000}, {372,0.00003636}, {373,0.00003636}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00003636}, {381,0.00003636}, {382,0.00003636}, {383,0.00000000}, {384,0.00002727}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00003636}, {390,0.00010000}, {391,0.00003636}, {392,0.00000000}, {393,0.00002727}, {394,0.00000000}, {395,0.00003636}, {396,0.00000000}, {397,0.00000000}, {398,0.00003636}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00007273}, {403,0.00000000}, {404,0.00000000}, {405,0.00003636}, {406,0.00000000}, {407,0.00003636}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00010000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00003636}, {418,0.00003636}, {419,0.00000000}, {420,0.00003636}, {421,0.00000000}, {422,0.00002727}, {423,0.00003636}, {424,0.00002727}, {425,0.00010000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00007273}, {432,0.00003636}, {433,0.00000000}, {434,0.00007273}, {435,0.00000000}, {436,0.00003636}, {437,0.00000000}, {438,0.00003636}, {439,0.00000000}, {440,0.00000000}, {441,0.00003636}, {442,0.00000000}, {443,0.00003636}, {444,0.00007273}, {445,0.00003636}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00003636}, {452,0.00000000}, {453,0.00003636}, {454,0.00003636}, {455,0.00010909}, {456,0.00000000}, {457,0.00003636}, {458,0.00003636}, {459,0.00007273}, {460,0.00000000}, {461,0.00003636}, {462,0.00003636}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00003636}, {472,0.00000000}, {473,0.00000000}, {474,0.00003636}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00003636}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00003636}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00010909}, {490,0.00014545}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00003636}, {495,0.00000000}, {496,0.00000000}, {497,0.00003636}, {498,0.00000000}, {499,0.00000000}, {500,0.00003636}, {505,0.00003636}, {510,0.00002727}, {515,0.00000000}, {520,0.00000000}, {525,0.00010000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00003636}, {565,0.00003636}, {570,0.00003636}, {575,0.00003636}, {580,0.00007273}, {585,0.00007273}, {590,0.00003636}, {595,0.00000000}, {600,0.00003636}, {605,0.00014545}, {610,0.00000000}, {615,0.00003636}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00007273}, {665,0.00000000}, {670,0.00003636}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00003636}, {725,0.00003636}, {730,0.00003636}, {735,0.00000000}, {740,0.00002727}, {745,0.00000000}, {750,0.00006364}, {755,0.00002727}, {760,0.00003636}, {765,0.00007273}, {770,0.00000000}, {775,0.00007273}, {780,0.00003636}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00003636}, {825,0.00003636}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00003636}, {860,0.00003636}, {865,0.00003636}, {870,0.00007273}, {875,0.00003636}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00007273}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00003636}, {940,0.00000000}, {945,0.00003636}, {950,0.00000000}, {955,0.00000000}, {960,0.00003636}, {965,0.00003636}, {970,0.00003636}, {975,0.00003636}, {980,0.00006364}, {985,0.00003636}, {990,0.00003636}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00021818}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00010909}, {1100,0.00010909}, {1110,0.00000000}, {1120,0.00007273}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00007273}, {1210,0.00003636}, {1220,0.00000000}, {1230,0.00010909}, {1240,0.00006364}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00010909}, {1310,0.00003636}, {1320,0.00007273}, {1330,0.00003636}, {1340,0.00003636}, {1350,0.00003636}, {1360,0.00010909}, {1370,0.00003636}, {1380,0.00000000}, {1390,0.00003636}, {1400,0.00007273}, {1410,0.00000000}, {1420,0.00003636}, {1430,0.00000000}, {1440,0.00013636}, {1450,0.00003636}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00007273}, {1490,0.00000000}, {1500,0.00003636}, {1510,0.00003636}, {1520,0.00000000}, {1530,0.00007273}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00007273}, {1590,0.00007273}, {1600,0.00000000}, {1610,0.00021818}, {1620,0.00006364}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00003636}, {1660,0.00003636}, {1670,0.00003636}, {1680,0.00000000}, {1690,0.00003636}, {1700,0.00003636}, {1710,0.00018182}, {1720,0.00003636}, {1730,0.00007273}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00010909}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00003636}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00007273}, {1840,0.00010909}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00003636}, {1890,0.00003636}, {1900,0.00006364}, {1910,0.00003636}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00002727}, {1950,0.00003636}, {1960,0.00002727}, {1970,0.00000000}, {1980,0.00010909}, {1990,0.00007273}, {2000,0.00000000}, {2050,0.00003636}, {2100,0.00003636}, {2150,0.00003636}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00003636}, {2350,0.00003636}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00007273}, {2550,0.00002727}, {2600,0.00018182}, {2650,0.00010909}, {2700,0.00003636}, {2750,0.00003636}, {2800,0.00006364}, {2850,0.00003636}, {2900,0.00003636}, {2950,0.00003636}, {3000,0.00003636}, {3050,0.00000}, {3100,0.00100}, {3150,0.00000}, {3200,0.00000}, {3250,0.00100}, {3300,0.00000}, {3350,0.00000}, {3400,0.00000}, {3450,0.00000}, {3500,0.00000}, {3550,0.00000}, {3600,0.00000}, {3650,0.00000}, {3700,0.00200}, {3750,0.00000}, {3800,0.00000}, {3850,0.00000}, {3900,0.00000}, {3950,0.00000}, {4000,0.00000}, {4050,0.00000}, {4100,0.00100}, {4150,0.00000}, {4200,0.00000}, {4250,0.00000}, {4300,0.00000}, {4350,0.00000}, {4400,0.00000}, {4450,0.00000}, {4500,0.00000}, {4550,0.00000}, {4600,0.00000}, {4650,0.00000}, {4700,0.00100}, {4750,0.00000}, {4800,0.00000}, {4850,0.00000}, {4900,0.00000}, {4950,0.00000}, {5000,0.00100}, {5050,0.00000}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00200}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00200}, {5550,0.00000}, {5600,0.00100}, {5650,0.00100}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00100}, {5950,0.00000}, {6000,0.00100}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00100}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00075}, {6850,0.00000}, {6900,0.00000}, {6950,0.00300}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00300}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00100}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00275}, {8850,0.00000}, {8900,0.00000}, {8950,0.00100}, {9000,0.00100}, {9050,0.00100}, {9100,0.00000}, {9150,0.00000}, {9200,0.00100}, {9250,0.00100}, {9300,0.00000}, {9350,0.00000}, {9400,0.00200}, {9450,0.00100}, {9500,0.00000}, {9550,0.00100}, {9600,0.00300}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00100}, {9900,0.00100}, {9950,0.00400}, {10000,0.00000}, {10100,0.0000}, {10200,0.0000}, {10300,0.0000}, {10400,0}, {10500,0}, {10600,0}, {10700,0}, {10800,0}, {10900,0}, {11000,0}, {11100,0}, {11200,0}, {11300,0}, {11400,0}, {11500,0}, {11600,0}, {11700,0}, {11800,0}, {11900,0}, {12000,0}, {12100,0}, {12200,0}, {12300,0.008}, {12400,0.004}, {12500,0}, {12600,0}, {12700,0}, {12800,0}, {12900,0}, {13000,0}, {13100,0}, {13200,0.004}, {13300,0}, {13400,0}, {13500,0}, {13600,0}, {13700,0}, {13800,0}, {13900,0}, {14000,0}, {14100,0}, {14200,0}, {14300,0}, {14400,0}, {14500,0}, {14600,0}, {14700,0}, {14800,0}, {14900,0}, {15000,0}, {15100,0}, {15200,0}, {15300,0}, {15400,0}, {15500,0}, {15600,0}, {15700,0}, {15800,0}, {15900,0}, {16000,0}, {16100,0}, {16200,0}, {16300,0}, {16400,0}, {16500,0}, {16600,0}, {16700,0}, {16800,0}, {16900,0}, {17000,0}, {17100,0}, {17200,0}, {17300,0}, {17400,0}, {17500,0}, {17600,0}, {17700,0}, {17800,0}, {17900,0}, {18000,0}, {18100,0}, {18200,0}, {18300,0}, {18400,0}, {18500,0}, {18600,0}, {18700,0}, {18800,0}, {18900,0}, {19000,0}, {19100,0}, {19200,0}, {19300,0}, {19400,0}, {19500,0}, {19600,0}, {19700,0}, {19800,0}, {19900,0}};
data["big"]["cbv Denote"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00001818}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00002727}, {181,0.00002727}, {182,0.00004545}, {183,0.00009091}, {184,0.00012727}, {185,0.00021818}, {186,0.00030000}, {187,0.00044545}, {188,0.00065455}, {189,0.00075455}, {190,0.00082727}, {191,0.00090909}, {192,0.00099091}, {193,0.00100000}, {194,0.00100000}, {195,0.00100000}, {196,0.00100000}, {197,0.00100000}, {198,0.00100000}, {199,0.00100000}, {200,0.00100000}, {201,0.00100000}, {202,0.00100000}, {203,0.00100000}, {204,0.00100000}, {205,0.00100000}, {206,0.00100000}, {207,0.00100000}, {208,0.00100000}, {209,0.00100000}, {210,0.00100000}, {211,0.00100000}, {212,0.00100000}, {213,0.00100000}, {214,0.00100000}, {215,0.00100000}, {216,0.00100000}, {217,0.00100000}, {218,0.00100000}, {219,0.00100000}, {220,0.00100000}, {221,0.00100000}, {222,0.00100000}, {223,0.00100000}, {224,0.00100000}, {225,0.00100000}, {226,0.00100000}, {227,0.00100000}, {228,0.00100000}, {229,0.00100000}, {230,0.00100000}, {231,0.00100000}, {232,0.00100000}, {233,0.00100000}, {234,0.00100000}, {235,0.00100000}, {236,0.00100000}, {237,0.00100000}, {238,0.00100000}, {239,0.00100000}, {240,0.00100000}, {241,0.00100000}, {242,0.00100000}, {243,0.00100000}, {244,0.00100000}, {245,0.00100000}, {246,0.00100000}, {247,0.00100000}, {248,0.00100000}, {249,0.00100000}, {250,0.00100000}, {251,0.00100000}, {252,0.00100000}, {253,0.00100000}, {254,0.00100000}, {255,0.00100000}, {256,0.00100000}, {257,0.00100000}, {258,0.00100000}, {259,0.00100000}, {260,0.00100000}, {261,0.00100000}, {262,0.00278182}, {263,0.00100909}, {264,0.00101818}, {265,0.00100000}, {266,0.00100000}, {267,0.00100000}, {268,0.00101818}, {269,0.00106364}, {270,0.00115455}, {271,0.00129091}, {272,0.00146364}, {273,0.00167273}, {274,0.00170000}, {275,0.00180000}, {276,0.00185455}, {277,0.00192727}, {278,0.00194545}, {279,0.00299091}, {280,0.00200000}, {281,0.00200000}, {282,0.00200000}, {283,0.00200000}, {284,0.00200000}, {285,0.00200000}, {286,0.00200000}, {287,0.00200000}, {288,0.00200000}, {289,0.00200000}, {290,0.00200000}, {291,0.00200000}, {292,0.00200000}, {293,0.00200000}, {294,0.00200000}, {295,0.00200000}, {296,0.00200000}, {297,0.00200000}, {298,0.00200000}, {299,0.00200000}, {300,0.00200000}, {301,0.00200000}, {302,0.00200000}, {303,0.00200000}, {304,0.00200000}, {305,0.00200000}, {306,0.00332727}, {307,0.00200000}, {308,0.00200000}, {309,0.00200000}, {310,0.00200000}, {311,0.00200000}, {312,0.00200000}, {313,0.00200000}, {314,0.00200000}, {315,0.00200000}, {316,0.00200000}, {317,0.00200000}, {318,0.00200000}, {319,0.00200000}, {320,0.00200000}, {321,0.00200000}, {322,0.00200000}, {323,0.00200000}, {324,0.00200000}, {325,0.00200000}, {326,0.00200000}, {327,0.00200000}, {328,0.00200000}, {329,0.00200000}, {330,0.00200000}, {331,0.00200000}, {332,0.00200000}, {333,0.00200000}, {334,0.00201818}, {335,0.00202727}, {336,0.00204545}, {337,0.00215455}, {338,0.00220909}, {339,0.00230000}, {340,0.00237273}, {341,0.00259091}, {342,0.00263636}, {343,0.00271818}, {344,0.00272727}, {345,0.00272727}, {346,0.00290000}, {347,0.00293636}, {348,0.00295455}, {349,0.00294545}, {350,0.00295455}, {351,0.00299091}, {352,0.00300000}, {353,0.00300000}, {354,0.00300000}, {355,0.00300000}, {356,0.00300000}, {357,0.00300000}, {358,0.00300000}, {359,0.00300000}, {360,0.00300000}, {361,0.00300000}, {362,0.00300000}, {363,0.00300000}, {364,0.00300000}, {365,0.00300000}, {366,0.00300000}, {367,0.00300000}, {368,0.00300000}, {369,0.00300000}, {370,0.00300000}, {371,0.00300000}, {372,0.00300000}, {373,0.00300000}, {374,0.00300000}, {375,0.00300000}, {376,0.00300000}, {377,0.00305455}, {378,0.00300000}, {379,0.00300000}, {380,0.00300000}, {381,0.00300000}, {382,0.00300000}, {383,0.00300000}, {384,0.00300000}, {385,0.00300000}, {386,0.00302727}, {387,0.00300000}, {388,0.00300000}, {389,0.00300909}, {390,0.00300909}, {391,0.00301818}, {392,0.00303636}, {393,0.00307273}, {394,0.00309091}, {395,0.00320909}, {396,0.00323636}, {397,0.00340909}, {398,0.00350909}, {399,0.00351818}, {400,0.00358182}, {401,0.00362727}, {402,0.00360000}, {403,0.00368182}, {404,0.00373636}, {405,0.00381818}, {406,0.00389091}, {407,0.00388182}, {408,0.00390000}, {409,0.00391818}, {410,0.00391818}, {411,0.00392727}, {412,0.00395455}, {413,0.00399091}, {414,0.00400000}, {415,0.00400000}, {416,0.00400000}, {417,0.00400000}, {418,0.00400000}, {419,0.00400000}, {420,0.00400000}, {421,0.00400000}, {422,0.00400000}, {423,0.00400000}, {424,0.00400000}, {425,0.00400000}, {426,0.00400000}, {427,0.00400000}, {428,0.00400000}, {429,0.00400000}, {430,0.00400000}, {431,0.00400000}, {432,0.00400000}, {433,0.00400000}, {434,0.00403636}, {435,0.00400000}, {436,0.00400000}, {437,0.00400000}, {438,0.00400000}, {439,0.00400000}, {440,0.00400000}, {441,0.00400909}, {442,0.00404545}, {443,0.00405455}, {444,0.00406364}, {445,0.00411818}, {446,0.00427273}, {447,0.00433636}, {448,0.00439091}, {449,0.00444545}, {450,0.00451818}, {451,0.00459091}, {452,0.00461818}, {453,0.00464545}, {454,0.00464545}, {455,0.00465455}, {456,0.00480000}, {457,0.00479091}, {458,0.00721818}, {459,0.00486364}, {460,0.00490909}, {461,0.00490909}, {462,0.00491818}, {463,0.00490909}, {464,0.00491818}, {465,0.00492727}, {466,0.00496364}, {467,0.00498182}, {468,0.00661818}, {469,0.00500000}, {470,0.00499091}, {471,0.00500000}, {472,0.00500000}, {473,0.00500000}, {474,0.00500000}, {475,0.00811818}, {476,0.00500000}, {477,0.00500000}, {478,0.00500000}, {479,0.00500000}, {480,0.00500000}, {481,0.00500000}, {482,0.00500000}, {483,0.00505455}, {484,0.00500000}, {485,0.00500000}, {486,0.00500000}, {487,0.00502727}, {488,0.00502727}, {489,0.00503636}, {490,0.00507273}, {491,0.00514545}, {492,0.00522727}, {493,0.00526364}, {494,0.00537273}, {495,0.00549091}, {496,0.00555455}, {497,0.00558182}, {498,0.00561818}, {499,0.00564545}, {500,0.00563636}, {505,0.00578182}, {510,0.00590909}, {515,0.00600000}, {520,0.00600000}, {525,0.00600000}, {530,0.00601818}, {535,0.00629091}, {540,0.00658182}, {545,0.00675455}, {550,0.00692727}, {555,0.00697273}, {560,0.00877273}, {565,0.00701818}, {570,0.00709091}, {575,0.00742727}, {580,0.00760909}, {585,0.00779091}, {590,0.00790000}, {595,0.00796364}, {600,0.01056364}, {605,0.00803636}, {610,0.00830000}, {615,0.00856364}, {620,0.00868182}, {625,0.00879091}, {630,0.00896364}, {635,0.00899091}, {640,0.00903636}, {645,0.00928182}, {650,0.00958182}, {655,0.00968182}, {660,0.00982727}, {665,0.00995455}, {670,0.00996364}, {675,0.01014545}, {680,0.01050909}, {685,0.01063636}, {690,0.01077273}, {695,0.01080000}, {700,0.01094545}, {705,0.01110000}, {710,0.01147273}, {715,0.01164545}, {720,0.01171818}, {725,0.01179091}, {730,0.01188182}, {735,0.01207273}, {740,0.01248182}, {745,0.01262727}, {750,0.01271818}, {755,0.01277273}, {760,0.01292727}, {765,0.01311818}, {770,0.01345455}, {775,0.01360909}, {780,0.01373636}, {785,0.01376364}, {790,0.01397273}, {795,0.01429091}, {800,0.01449091}, {805,0.01465455}, {810,0.01474545}, {815,0.01490909}, {820,0.01511818}, {825,0.01546364}, {830,0.01554545}, {835,0.01570909}, {840,0.01575455}, {845,0.01600000}, {850,0.01637273}, {855,0.01650000}, {860,0.01666364}, {865,0.01679091}, {870,0.01703636}, {875,0.01735455}, {880,0.01750909}, {885,0.01766364}, {890,0.01782727}, {895,0.01803636}, {900,0.01840000}, {905,0.01850000}, {910,0.01870000}, {915,0.01895455}, {920,0.01921818}, {925,0.01953636}, {930,0.02374545}, {935,0.01978182}, {940,0.02012727}, {945,0.02042727}, {950,0.02061818}, {955,0.02071818}, {960,0.02099091}, {965,0.02129091}, {970,0.02157273}, {975,0.02174545}, {980,0.02196364}, {985,0.02230909}, {990,0.02259091}, {995,0.02280000}, {1000,0.02293636}, {1010,0.02366364}, {1020,0.02405455}, {1030,0.02476364}, {1040,0.02520000}, {1050,0.03019091}, {1060,0.02636364}, {1070,0.02720000}, {1080,0.02797273}, {1090,0.02853636}, {1100,0.02931818}, {1110,0.03009091}, {1120,0.03082727}, {1130,0.03166364}, {1140,0.03261818}, {1150,0.03338182}, {1160,0.03414545}, {1170,0.03765455}, {1180,0.03595455}, {1190,0.03694545}, {1200,0.03791818}, {1210,0.03897273}, {1220,0.04019091}, {1230,0.04120909}, {1240,0.04236364}, {1250,0.04346364}, {1260,0.04471818}, {1270,0.04605455}, {1280,0.04741818}, {1290,0.04881818}, {1300,0.05012727}, {1310,0.05164545}, {1320,0.05314545}, {1330,0.05465455}, {1340,0.05606364}, {1350,0.05774545}, {1360,0.05930000}, {1370,0.06075455}, {1380,0.06229091}, {1390,0.06401818}, {1400,0.06570000}, {1410,0.06710000}, {1420,0.06894545}, {1430,0.07072727}, {1440,0.07250000}, {1450,0.07417273}, {1460,0.07603636}, {1470,0.07789091}, {1480,0.07973636}, {1490,0.08149091}, {1500,0.08312727}, {1510,0.08504545}, {1520,0.08686364}, {1530,0.08878182}, {1540,0.09070909}, {1550,0.09267273}, {1560,0.09457273}, {1570,0.09657273}, {1580,0.09848182}, {1590,0.09765455}, {1600,0.10228182}, {1610,0.10433636}, {1620,0.10620909}, {1630,0.10824545}, {1640,0.11024545}, {1650,0.11222727}, {1660,0.11430909}, {1670,0.11630000}, {1680,0.11819091}, {1690,0.12032727}, {1700,0.12230909}, {1710,0.12450000}, {1720,0.12650909}, {1730,0.12871818}, {1740,0.13079091}, {1750,0.13283636}, {1760,0.13507273}, {1770,0.13720909}, {1780,0.13930000}, {1790,0.14160909}, {1800,0.14382727}, {1810,0.14595455}, {1820,0.14810909}, {1830,0.15037273}, {1840,0.15260909}, {1850,0.15480909}, {1860,0.15712727}, {1870,0.15946364}, {1880,0.16175455}, {1890,0.16405455}, {1900,0.16628182}, {1910,0.16878182}, {1920,0.17090909}, {1930,0.17333636}, {1940,0.17584545}, {1950,0.17815455}, {1960,0.18051818}, {1970,0.18310909}, {1980,0.18571818}, {1990,0.18814545}, {2000,0.19042727}, {2050,0.20292727}, {2100,0.21561818}, {2150,0.22832727}, {2200,0.21308182}, {2250,0.25595455}, {2300,0.27021818}, {2350,0.28427273}, {2400,0.29883636}, {2450,0.31321818}, {2500,0.33416364}, {2550,0.34250000}, {2600,0.35910909}, {2650,0.37486364}, {2700,0.39130909}, {2750,0.40620909}, {2800,0.42335455}, {2850,0.41499091}, {2900,0.45577273}, {2950,0.47350000}, {3000,0.49217273}, {3050,0.50125}, {3100,0.51925}, {3150,0.53725}, {3200,0.55650}, {3250,0.56900}, {3300,0.59525}, {3350,0.61300}, {3400,0.63425}, {3450,0.63150}, {3500,0.68350}, {3550,0.71450}, {3600,0.73575}, {3650,0.72425}, {3700,0.77900}, {3750,0.79850}, {3800,0.82775}, {3850,0.82700}, {3900,0.87250}, {3950,0.87325}, {4000,0.81800}, {4050,0.86525}, {4100,0.94300}, {4150,0.96650}, {4200,0.99300}, {4250,1.01725}, {4300,1.03950}, {4350,1.06000}, {4400,1.09175}, {4450,1.11675}, {4500,1.14250}, {4550,1.24475}, {4600,1.27325}, {4650,1.26300}, {4700,1.29200}, {4750,1.32100}, {4800,1.38975}, {4850,1.41875}, {4900,1.44150}, {4950,1.48100}, {5000,1.50950}, {5050,1.54025}, {5100,1.55075}, {5150,1.60500}, {5200,1.63850}, {5250,1.64375}, {5300,1.70775}, {5350,1.74500}, {5400,1.77550}, {5450,1.67000}, {5500,1.78650}, {5550,1.87425}, {5600,1.89625}, {5650,1.94450}, {5700,1.94600}, {5750,2.02075}, {5800,2.02825}, {5850,2.09875}, {5900,2.12675}, {5950,2.09750}, {6000,2.06400}, {6050,2.17125}, {6100,2.20675}, {6150,2.24325}, {6200,2.19475}, {6250,2.24025}, {6300,2.27775}, {6350,2.19075}, {6400,2.34975}, {6450,2.30775}, {6500,2.44000}, {6550,2.54800}, {6600,2.58750}, {6650,2.62950}, {6700,2.66925}, {6750,2.71225}, {6800,2.83875}, {6850,2.72575}, {6900,2.82475}, {6950,2.86475}, {7000,2.97775}, {7050,2.95425}, {7100,2.91950}, {7150,2.98925}, {7200,3.09025}, {7250,3.12800}, {7300,3.17000}, {7350,3.21625}, {7400,3.37800}, {7450,3.41900}, {7500,3.47125}, {7550,3.47275}, {7600,3.45550}, {7650,3.61300}, {7700,3.61525}, {7750,3.71000}, {7800,3.75625}, {7850,3.73750}, {7900,3.79300}, {7950,3.86375}, {8000,3.99075}, {8050,3.99675}, {8100,3.96725}, {8150,4.05375}, {8200,4.15925}, {8250,4.20325}, {8300,4.09150}, {8350,4.16900}, {8400,3.92525}, {8450,4.39025}, {8500,4.30725}, {8550,4.25425}, {8600,4.14200}, {8650,3.95750}, {8700,3.99725}, {8750,4.25525}, {8800,4.22675}, {8850,4.50200}, {8900,4.56725}, {8950,4.73600}, {9000,4.81925}, {9050,4.77050}, {9100,4.43925}, {9150,4.48850}, {9200,4.39150}, {9250,4.20900}, {9300,5.00400}, {9350,5.20875}, {9400,5.24525}, {9450,5.19525}, {9500,4.58750}, {9550,5.06825}, {9600,5.30575}, {9650,4.89775}, {9700,5.40775}, {9750,5.16600}, {9800,5.60075}, {9850,5.57675}, {9900,5.63275}, {9950,5.65000}, {10000,5.65525}, {10100,5.8905}, {10200,5.7860}, {10300,6.0945}, {10400,6.714}, {10500,6.82}, {10600,6.749}, {10700,6.793}, {10800,7.052}, {10900,6.33}, {11000,6.434}, {11100,6.561}, {11200,5.52}, {11300,6.795}, {11400,6.941}, {11500,6.039}, {11600,7.167}, {11700,7.287}, {11800,7.436}, {11900,6.267}, {12000,7.439}, {12100,7.097}, {12200,6.578}, {12300,9.44}, {12400,9.283}, {12500,9.683}, {12600,9.831}, {12700,9.989}, {12800,10.141}, {12900,10.305}, {13000,10.044}, {13100,10.633}, {13200,10.559}, {13300,10.5}, {13400,10.595}, {13500,10.96}, {13600,11.487}, {13700,11.434}, {13800,11.841}, {13900,11.727}, {14000,11.573}, {14100,11.824}, {14200,12.586}, {14300,12.724}, {14400,12.378}, {14500,13.052}, {14600,13.261}, {14700,13.547}, {14800,13.653}, {14900,13.811}, {15000,13.728}, {15100,15.088}, {15200,17.715}, {15300,14.569}, {15400,14.672}, {15500,15.12}, {15600,15.145}, {15700,14.663}, {15800,15.574}, {15900,15.809}, {16000,16.138}, {16100,16.111}, {16200,16.38}, {16300,16.464}, {16400,16.79}, {16500,26.089}, {16600,17.861}, {16700,17.465}, {16800,17.185}, {16900,17.092}, {17000,20.798}, {17100,17.342}, {17200,39.319}, {17300,20.986}, {17400,47.655}, {17500,19.353}, {17600,18.353}, {17700,19.651}, {17800,19.086}, {17900,20.344}, {18000,21.067}, {18100,40.297}, {18200,20.407}, {18300,20.337}, {18400,21.759}, {18500,23.661}, {18600,20.946}, {18700,21.243}, {18800,29.137}, {18900,55.873}, {19000,36.671}, {19100,23.82}, {19200,24.029}, {19300,22.815}, {19400,22.868}, {19500,23.522}, {19600,23.832}, {19700,28.511}, {19800,39.44}, {19900,24.383}};
data["big"]["cbv Denote"]["Stats"]["user"] = {{1,0.00005455}, {2,0.00002727}, {3,0.00006364}, {4,0.00006364}, {5,0.00003636}, {6,0.00002727}, {7,0.00005455}, {8,0.00005455}, {9,0.00009091}, {10,0.00011818}, {11,0.00009091}, {12,0.00002727}, {13,0.00009091}, {14,0.00007273}, {15,0.00002727}, {16,0.00010000}, {17,0.00008182}, {18,0.00011818}, {19,0.00008182}, {20,0.00006364}, {21,0.00008182}, {22,0.00012727}, {23,0.00011818}, {24,0.00014545}, {25,0.00003636}, {26,0.00017273}, {27,0.00012727}, {28,0.00014545}, {29,0.00011818}, {30,0.00010909}, {31,0.00005455}, {32,0.00014545}, {33,0.00011818}, {34,0.00017273}, {35,0.00023636}, {36,0.00020909}, {37,0.00021818}, {38,0.00002727}, {39,0.00015455}, {40,0.00013636}, {41,0.00013636}, {42,0.00018182}, {43,0.00011818}, {44,0.00012727}, {45,0.00020909}, {46,0.00017273}, {47,0.00005455}, {48,0.00026364}, {49,0.00016364}, {50,0.00012727}, {51,0.00034545}, {52,0.00040000}, {53,0.00018182}, {54,0.00015455}, {55,0.00021818}, {56,0.00028182}, {57,0.00018182}, {58,0.00010909}, {59,0.00009091}, {60,0.00018182}, {61,0.00021818}, {62,0.00010909}, {63,0.00014545}, {64,0.00015455}, {65,0.00012727}, {66,0.00022727}, {67,0.00023636}, {68,0.00017273}, {69,0.00027273}, {70,0.00019091}, {71,0.00013636}, {72,0.00042727}, {73,0.00021818}, {74,0.00018182}, {75,0.00012727}, {76,0.00024545}, {77,0.00033636}, {78,0.00018182}, {79,0.00041818}, {80,0.00020000}, {81,0.00028182}, {82,0.00037273}, {83,0.00030000}, {84,0.00019091}, {85,0.00041818}, {86,0.00014545}, {87,0.00030909}, {88,0.00027273}, {89,0.00023636}, {90,0.00034545}, {91,0.00029091}, {92,0.00030909}, {93,0.00031818}, {94,0.00040909}, {95,0.00040909}, {96,0.00040000}, {97,0.00033636}, {98,0.00035455}, {99,0.00036364}, {100,0.00037273}, {101,0.00036364}, {102,0.00043636}, {103,0.00034545}, {104,0.00030000}, {105,0.00029091}, {106,0.00033636}, {107,0.00044545}, {108,0.00034545}, {109,0.00033636}, {110,0.00030000}, {111,0.00040909}, {112,0.00032727}, {113,0.00062727}, {114,0.00030000}, {115,0.00020000}, {116,0.00061818}, {117,0.00028182}, {118,0.00047273}, {119,0.00053636}, {120,0.00039091}, {121,0.00051818}, {122,0.00031818}, {123,0.00039091}, {124,0.00037273}, {125,0.00045455}, {126,0.00053636}, {127,0.00057273}, {128,0.00049091}, {129,0.00055455}, {130,0.00047273}, {131,0.00047273}, {132,0.00051818}, {133,0.00040909}, {134,0.00033636}, {135,0.00061818}, {136,0.00073636}, {137,0.00050909}, {138,0.00059091}, {139,0.00056364}, {140,0.00049091}, {141,0.00060909}, {142,0.00037273}, {143,0.00038182}, {144,0.00049091}, {145,0.00045455}, {146,0.00064545}, {147,0.00054545}, {148,0.00056364}, {149,0.00070909}, {150,0.00064545}, {151,0.00057273}, {152,0.00054545}, {153,0.00031818}, {154,0.00071818}, {155,0.00062727}, {156,0.00086364}, {157,0.00048182}, {158,0.00082727}, {159,0.00051818}, {160,0.00050909}, {161,0.00050909}, {162,0.00072727}, {163,0.00070909}, {164,0.00064545}, {165,0.00077273}, {166,0.00079091}, {167,0.00061818}, {168,0.00055455}, {169,0.00110000}, {170,0.00076364}, {171,0.00047273}, {172,0.00079091}, {173,0.00068182}, {174,0.00075455}, {175,0.00061818}, {176,0.00076364}, {177,0.00070909}, {178,0.00070000}, {179,0.00085455}, {180,0.00080000}, {181,0.00091818}, {182,0.00088182}, {183,0.00094545}, {184,0.00070000}, {185,0.00074545}, {186,0.00083636}, {187,0.00072727}, {188,0.00087273}, {189,0.00096364}, {190,0.00076364}, {191,0.00090909}, {192,0.00075455}, {193,0.00056364}, {194,0.00093636}, {195,0.00090000}, {196,0.00094545}, {197,0.00079091}, {198,0.00074545}, {199,0.00086364}, {200,0.00072727}, {201,0.00109091}, {202,0.00103636}, {203,0.00113636}, {204,0.00073636}, {205,0.00092727}, {206,0.00100000}, {207,0.00101818}, {208,0.00069091}, {209,0.00109091}, {210,0.00095455}, {211,0.00111818}, {212,0.00125455}, {213,0.00128182}, {214,0.00104545}, {215,0.00111818}, {216,0.00117273}, {217,0.00109091}, {218,0.00157273}, {219,0.00113636}, {220,0.00083636}, {221,0.00091818}, {222,0.00099091}, {223,0.00093636}, {224,0.00111818}, {225,0.00111818}, {226,0.00119091}, {227,0.00144545}, {228,0.00121818}, {229,0.00152727}, {230,0.00102727}, {231,0.00106364}, {232,0.00117273}, {233,0.00131818}, {234,0.00117273}, {235,0.00110000}, {236,0.00124545}, {237,0.00110909}, {238,0.00131818}, {239,0.00110909}, {240,0.00126364}, {241,0.00141818}, {242,0.00156364}, {243,0.00117273}, {244,0.00144545}, {245,0.00140000}, {246,0.00171818}, {247,0.00118182}, {248,0.00140000}, {249,0.00146364}, {250,0.00159091}, {251,0.00149091}, {252,0.00158182}, {253,0.00141818}, {254,0.00142727}, {255,0.00143636}, {256,0.00142727}, {257,0.00163636}, {258,0.00150000}, {259,0.00127273}, {260,0.00159091}, {261,0.00140000}, {262,0.00260000}, {263,0.00165455}, {264,0.00180909}, {265,0.00157273}, {266,0.00148182}, {267,0.00188182}, {268,0.00165455}, {269,0.00150909}, {270,0.00149091}, {271,0.00160000}, {272,0.00195455}, {273,0.00168182}, {274,0.00165455}, {275,0.00175455}, {276,0.00168182}, {277,0.00137273}, {278,0.00181818}, {279,0.00290000}, {280,0.00157273}, {281,0.00181818}, {282,0.00173636}, {283,0.00170909}, {284,0.00164545}, {285,0.00207273}, {286,0.00197273}, {287,0.00194545}, {288,0.00166364}, {289,0.00200000}, {290,0.00190909}, {291,0.00170909}, {292,0.00202727}, {293,0.00180909}, {294,0.00190000}, {295,0.00168182}, {296,0.00189091}, {297,0.00191818}, {298,0.00202727}, {299,0.00185455}, {300,0.00188182}, {301,0.00190909}, {302,0.00188182}, {303,0.00204545}, {304,0.00197273}, {305,0.00216364}, {306,0.00306364}, {307,0.00182727}, {308,0.00225455}, {309,0.00205455}, {310,0.00207273}, {311,0.00182727}, {312,0.00232727}, {313,0.00183636}, {314,0.00230909}, {315,0.00221818}, {316,0.00184545}, {317,0.00225455}, {318,0.00220000}, {319,0.00231818}, {320,0.00218182}, {321,0.00231818}, {322,0.00218182}, {323,0.00228182}, {324,0.00210000}, {325,0.00232727}, {326,0.00236364}, {327,0.00229091}, {328,0.00229091}, {329,0.00262727}, {330,0.00230000}, {331,0.00213636}, {332,0.00220000}, {333,0.00242727}, {334,0.00218182}, {335,0.00241818}, {336,0.00244545}, {337,0.00237273}, {338,0.00272727}, {339,0.00252727}, {340,0.00238182}, {341,0.00264545}, {342,0.00256364}, {343,0.00266364}, {344,0.00246364}, {345,0.00229091}, {346,0.00249091}, {347,0.00253636}, {348,0.00238182}, {349,0.00259091}, {350,0.00280909}, {351,0.00263636}, {352,0.00266364}, {353,0.00253636}, {354,0.00270909}, {355,0.00257273}, {356,0.00271818}, {357,0.00259091}, {358,0.00277273}, {359,0.00270000}, {360,0.00253636}, {361,0.00274545}, {362,0.00300909}, {363,0.00267273}, {364,0.00269091}, {365,0.00282727}, {366,0.00283636}, {367,0.00281818}, {368,0.00285455}, {369,0.00303636}, {370,0.00265455}, {371,0.00286364}, {372,0.00300909}, {373,0.00293636}, {374,0.00281818}, {375,0.00289091}, {376,0.00290909}, {377,0.00288182}, {378,0.00328182}, {379,0.00290909}, {380,0.00302727}, {381,0.00293636}, {382,0.00300000}, {383,0.00309091}, {384,0.00319091}, {385,0.00296364}, {386,0.00312727}, {387,0.00311818}, {388,0.00318182}, {389,0.00303636}, {390,0.00316364}, {391,0.00314545}, {392,0.00310000}, {393,0.00331818}, {394,0.00333636}, {395,0.00325455}, {396,0.00331818}, {397,0.00321818}, {398,0.00334545}, {399,0.00336364}, {400,0.00320909}, {401,0.00330000}, {402,0.00340909}, {403,0.00337273}, {404,0.00338182}, {405,0.00349091}, {406,0.00357273}, {407,0.00345455}, {408,0.00344545}, {409,0.00342727}, {410,0.00373636}, {411,0.00363636}, {412,0.00336364}, {413,0.00363636}, {414,0.00384545}, {415,0.00364545}, {416,0.00367273}, {417,0.00370909}, {418,0.00361818}, {419,0.00341818}, {420,0.00392727}, {421,0.00361818}, {422,0.00365455}, {423,0.00354545}, {424,0.00378182}, {425,0.00377273}, {426,0.00375455}, {427,0.00403636}, {428,0.00359091}, {429,0.00392727}, {430,0.00380909}, {431,0.00390909}, {432,0.00390909}, {433,0.00390909}, {434,0.00412727}, {435,0.00388182}, {436,0.00380909}, {437,0.00403636}, {438,0.00430909}, {439,0.00378182}, {440,0.00415455}, {441,0.00435455}, {442,0.00392727}, {443,0.00423636}, {444,0.00414545}, {445,0.00409091}, {446,0.00425455}, {447,0.00419091}, {448,0.00452727}, {449,0.00450909}, {450,0.00417273}, {451,0.00460909}, {452,0.00447273}, {453,0.00470909}, {454,0.00447273}, {455,0.00478182}, {456,0.00418182}, {457,0.00434545}, {458,0.00728182}, {459,0.00444545}, {460,0.00499091}, {461,0.00474545}, {462,0.00471818}, {463,0.00505455}, {464,0.00497273}, {465,0.00490909}, {466,0.00465455}, {467,0.00496364}, {468,0.00662727}, {469,0.00489091}, {470,0.00467273}, {471,0.00468182}, {472,0.00460909}, {473,0.00466364}, {474,0.00501818}, {475,0.00820909}, {476,0.00489091}, {477,0.00473636}, {478,0.00481818}, {479,0.00507273}, {480,0.00510909}, {481,0.00535455}, {482,0.00518182}, {483,0.00550000}, {484,0.00488182}, {485,0.00555455}, {486,0.00504545}, {487,0.00553636}, {488,0.00521818}, {489,0.00515455}, {490,0.00528182}, {491,0.00517273}, {492,0.00520000}, {493,0.00520909}, {494,0.00530909}, {495,0.00576364}, {496,0.00568182}, {497,0.00526364}, {498,0.00523636}, {499,0.00564545}, {500,0.00599091}, {505,0.00560000}, {510,0.00574545}, {515,0.00585455}, {520,0.00595455}, {525,0.00612727}, {530,0.00612727}, {535,0.00661818}, {540,0.00633636}, {545,0.00656364}, {550,0.00683636}, {555,0.00695455}, {560,0.00887273}, {565,0.00717273}, {570,0.00714545}, {575,0.00730909}, {580,0.00765455}, {585,0.00784545}, {590,0.00788182}, {595,0.00767273}, {600,0.01095455}, {605,0.00829091}, {610,0.00838182}, {615,0.00844545}, {620,0.00903636}, {625,0.00868182}, {630,0.00942727}, {635,0.00925455}, {640,0.00956364}, {645,0.00941818}, {650,0.00966364}, {655,0.01020000}, {660,0.01004545}, {665,0.01040909}, {670,0.01059091}, {675,0.01076364}, {680,0.01082727}, {685,0.01089091}, {690,0.01133636}, {695,0.01146364}, {700,0.01131818}, {705,0.01165455}, {710,0.01166364}, {715,0.01194545}, {720,0.01208182}, {725,0.01220909}, {730,0.01250000}, {735,0.01270000}, {740,0.01292727}, {745,0.01276364}, {750,0.01283636}, {755,0.01330000}, {760,0.01340909}, {765,0.01369091}, {770,0.01362727}, {775,0.01425455}, {780,0.01358182}, {785,0.01411818}, {790,0.01390000}, {795,0.01441818}, {800,0.01473636}, {805,0.01473636}, {810,0.01479091}, {815,0.01530000}, {820,0.01530000}, {825,0.01538182}, {830,0.01570909}, {835,0.01603636}, {840,0.01590000}, {845,0.01633636}, {850,0.01628182}, {855,0.01630000}, {860,0.01674545}, {865,0.01695455}, {870,0.01702727}, {875,0.01735455}, {880,0.01726364}, {885,0.01725455}, {890,0.01776364}, {895,0.01791818}, {900,0.01820909}, {905,0.01818182}, {910,0.01876364}, {915,0.01869091}, {920,0.01910000}, {925,0.01929091}, {930,0.02374545}, {935,0.01960000}, {940,0.02019091}, {945,0.02060000}, {950,0.02046364}, {955,0.02086364}, {960,0.02117273}, {965,0.02128182}, {970,0.02136364}, {975,0.02199091}, {980,0.02211818}, {985,0.02280909}, {990,0.02270000}, {995,0.02325455}, {1000,0.02358182}, {1010,0.02412727}, {1020,0.02465455}, {1030,0.02540000}, {1040,0.02560909}, {1050,0.03004545}, {1060,0.02691818}, {1070,0.02763636}, {1080,0.02800000}, {1090,0.02852727}, {1100,0.02884545}, {1110,0.02980909}, {1120,0.03083636}, {1130,0.03131818}, {1140,0.03250909}, {1150,0.03342727}, {1160,0.03443636}, {1170,0.03805455}, {1180,0.03625455}, {1190,0.03712727}, {1200,0.03770000}, {1210,0.03908182}, {1220,0.04008182}, {1230,0.04130000}, {1240,0.04247273}, {1250,0.04334545}, {1260,0.04465455}, {1270,0.04610000}, {1280,0.04788182}, {1290,0.04909091}, {1300,0.05015455}, {1310,0.05159091}, {1320,0.05331818}, {1330,0.05462727}, {1340,0.05606364}, {1350,0.05769091}, {1360,0.05943636}, {1370,0.06095455}, {1380,0.06235455}, {1390,0.06385455}, {1400,0.06585455}, {1410,0.06705455}, {1420,0.06895455}, {1430,0.07076364}, {1440,0.07296364}, {1450,0.07408182}, {1460,0.07610000}, {1470,0.07773636}, {1480,0.07946364}, {1490,0.08171818}, {1500,0.08322727}, {1510,0.08529091}, {1520,0.08700909}, {1530,0.08888182}, {1540,0.09041818}, {1550,0.09268182}, {1560,0.09498182}, {1570,0.09678182}, {1580,0.09861818}, {1590,0.09768182}, {1600,0.10231818}, {1610,0.10415455}, {1620,0.10633636}, {1630,0.10886364}, {1640,0.11024545}, {1650,0.11214545}, {1660,0.11411818}, {1670,0.11598182}, {1680,0.11839091}, {1690,0.12060909}, {1700,0.12238182}, {1710,0.12453636}, {1720,0.12607273}, {1730,0.12912727}, {1740,0.13119091}, {1750,0.13305455}, {1760,0.13543636}, {1770,0.13721818}, {1780,0.13915455}, {1790,0.14140000}, {1800,0.14412727}, {1810,0.14582727}, {1820,0.14805455}, {1830,0.15042727}, {1840,0.15275455}, {1850,0.15497273}, {1860,0.15740909}, {1870,0.15933636}, {1880,0.16205455}, {1890,0.16406364}, {1900,0.16629091}, {1910,0.16882727}, {1920,0.17071818}, {1930,0.17330000}, {1940,0.17603636}, {1950,0.17854545}, {1960,0.18048182}, {1970,0.18288182}, {1980,0.18544545}, {1990,0.18821818}, {2000,0.19050000}, {2050,0.20288182}, {2100,0.21544545}, {2150,0.22822727}, {2200,0.21342727}, {2250,0.25599091}, {2300,0.27015455}, {2350,0.28400000}, {2400,0.29889091}, {2450,0.31294545}, {2500,0.33407273}, {2550,0.34236364}, {2600,0.35909091}, {2650,0.37473636}, {2700,0.39090909}, {2750,0.40590909}, {2800,0.42324545}, {2850,0.41449091}, {2900,0.45546364}, {2950,0.47324545}, {3000,0.49187273}, {3050,0.50150}, {3100,0.51850}, {3150,0.53550}, {3200,0.55525}, {3250,0.56925}, {3300,0.59450}, {3350,0.61225}, {3400,0.63525}, {3450,0.63150}, {3500,0.68175}, {3550,0.71450}, {3600,0.73450}, {3650,0.72375}, {3700,0.77850}, {3750,0.79750}, {3800,0.82800}, {3850,0.82750}, {3900,0.87250}, {3950,0.87250}, {4000,0.81750}, {4050,0.86550}, {4100,0.94175}, {4150,0.96650}, {4200,0.99450}, {4250,1.01725}, {4300,1.03900}, {4350,1.06000}, {4400,1.09125}, {4450,1.11850}, {4500,1.14200}, {4550,1.24375}, {4600,1.27325}, {4650,1.26275}, {4700,1.29150}, {4750,1.32050}, {4800,1.39125}, {4850,1.41850}, {4900,1.44025}, {4950,1.48050}, {5000,1.50925}, {5050,1.53975}, {5100,1.55025}, {5150,1.60350}, {5200,1.63875}, {5250,1.64150}, {5300,1.70650}, {5350,1.74550}, {5400,1.77425}, {5450,1.66800}, {5500,1.78600}, {5550,1.87250}, {5600,1.89575}, {5650,1.94325}, {5700,1.94250}, {5750,2.02175}, {5800,2.02650}, {5850,2.09825}, {5900,2.12675}, {5950,2.09675}, {6000,2.06350}, {6050,2.17225}, {6100,2.20550}, {6150,2.24125}, {6200,2.19450}, {6250,2.23975}, {6300,2.27800}, {6350,2.19075}, {6400,2.34925}, {6450,2.30650}, {6500,2.43900}, {6550,2.54675}, {6600,2.58675}, {6650,2.62675}, {6700,2.66900}, {6750,2.71250}, {6800,2.83775}, {6850,2.72475}, {6900,2.82325}, {6950,2.86350}, {7000,2.97725}, {7050,2.95150}, {7100,2.91975}, {7150,2.98825}, {7200,3.09025}, {7250,3.12775}, {7300,3.16975}, {7350,3.21675}, {7400,3.37725}, {7450,3.41775}, {7500,3.47250}, {7550,3.47200}, {7600,3.45350}, {7650,3.61200}, {7700,3.61425}, {7750,3.71150}, {7800,3.75400}, {7850,3.73850}, {7900,3.79125}, {7950,3.86475}, {8000,3.99150}, {8050,3.99675}, {8100,3.96725}, {8150,4.05450}, {8200,4.15950}, {8250,4.20375}, {8300,4.09350}, {8350,4.16650}, {8400,3.92575}, {8450,4.38725}, {8500,4.30675}, {8550,4.25275}, {8600,4.14150}, {8650,3.95475}, {8700,3.99325}, {8750,4.25125}, {8800,4.22300}, {8850,4.50000}, {8900,4.56550}, {8950,4.73550}, {9000,4.81475}, {9050,4.76925}, {9100,4.43675}, {9150,4.48525}, {9200,4.38975}, {9250,4.20700}, {9300,5.00375}, {9350,5.20750}, {9400,5.24150}, {9450,5.19300}, {9500,4.58550}, {9550,5.06525}, {9600,5.30450}, {9650,4.89650}, {9700,5.40500}, {9750,5.16475}, {9800,5.59650}, {9850,5.57375}, {9900,5.62925}, {9950,5.64825}, {10000,5.65225}, {10100,5.8755}, {10200,5.7750}, {10300,6.0880}, {10400,6.712}, {10500,6.819}, {10600,6.752}, {10700,6.788}, {10800,7.052}, {10900,6.327}, {11000,6.432}, {11100,6.563}, {11200,5.519}, {11300,6.795}, {11400,6.94}, {11500,6.04}, {11600,7.168}, {11700,7.288}, {11800,7.436}, {11900,6.267}, {12000,7.44}, {12100,7.096}, {12200,6.579}, {12300,9.44}, {12400,9.279}, {12500,9.683}, {12600,9.832}, {12700,9.992}, {12800,10.144}, {12900,10.304}, {13000,10.043}, {13100,10.632}, {13200,10.559}, {13300,10.496}, {13400,10.596}, {13500,10.959}, {13600,11.487}, {13700,11.436}, {13800,11.844}, {13900,11.728}, {14000,11.572}, {14100,11.824}, {14200,12.583}, {14300,12.723}, {14400,12.375}, {14500,13.056}, {14600,13.26}, {14700,13.548}, {14800,13.652}, {14900,13.812}, {15000,13.728}, {15100,15.088}, {15200,17.711}, {15300,14.567}, {15400,14.672}, {15500,15.124}, {15600,15.144}, {15700,14.663}, {15800,15.576}, {15900,15.807}, {16000,16.135}, {16100,16.111}, {16200,16.384}, {16300,16.467}, {16400,16.787}, {16500,26.087}, {16600,17.864}, {16700,17.463}, {16800,17.18}, {16900,17.091}, {17000,20.8}, {17100,17.344}, {17200,39.315}, {17300,20.987}, {17400,47.655}, {17500,19.355}, {17600,18.351}, {17700,19.652}, {17800,19.083}, {17900,20.344}, {18000,21.068}, {18100,40.299}, {18200,20.408}, {18300,20.335}, {18400,21.76}, {18500,23.663}, {18600,20.944}, {18700,21.243}, {18800,29.14}, {18900,55.876}, {19000,36.672}, {19100,23.819}, {19200,24.028}, {19300,22.815}, {19400,22.871}, {19500,23.524}, {19600,23.835}, {19700,28.511}, {19800,39.44}, {19900,24.384}};
data["big"]["cbv Denote"]["Stats"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00003636}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00003636}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00002727}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00003636}, {68,0.00003636}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00003636}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00003636}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00003636}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00003636}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00003636}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00003636}, {108,0.00000000}, {109,0.00003636}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00002727}, {121,0.00000000}, {122,0.00003636}, {123,0.00007273}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00002727}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00003636}, {134,0.00000000}, {135,0.00000000}, {136,0.00003636}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00003636}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00003636}, {154,0.00000000}, {155,0.00002727}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00003636}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00003636}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00007273}, {172,0.00000000}, {173,0.00000000}, {174,0.00003636}, {175,0.00007273}, {176,0.00003636}, {177,0.00003636}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00003636}, {185,0.00003636}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00002727}, {192,0.00000000}, {193,0.00003636}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00003636}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00003636}, {205,0.00000000}, {206,0.00003636}, {207,0.00000000}, {208,0.00000000}, {209,0.00007273}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00003636}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00003636}, {221,0.00000000}, {222,0.00003636}, {223,0.00003636}, {224,0.00003636}, {225,0.00003636}, {226,0.00003636}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00003636}, {231,0.00000000}, {232,0.00003636}, {233,0.00000000}, {234,0.00000000}, {235,0.00003636}, {236,0.00007273}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00003636}, {242,0.00000000}, {243,0.00003636}, {244,0.00000000}, {245,0.00014545}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00003636}, {256,0.00002727}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00007273}, {263,0.00000000}, {264,0.00003636}, {265,0.00000000}, {266,0.00003636}, {267,0.00000000}, {268,0.00007273}, {269,0.00000000}, {270,0.00000000}, {271,0.00003636}, {272,0.00000000}, {273,0.00007273}, {274,0.00003636}, {275,0.00003636}, {276,0.00003636}, {277,0.00003636}, {278,0.00000000}, {279,0.00003636}, {280,0.00000000}, {281,0.00002727}, {282,0.00000000}, {283,0.00007273}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00003636}, {292,0.00003636}, {293,0.00003636}, {294,0.00000000}, {295,0.00007273}, {296,0.00000000}, {297,0.00003636}, {298,0.00000000}, {299,0.00000000}, {300,0.00003636}, {301,0.00000000}, {302,0.00000000}, {303,0.00002727}, {304,0.00010909}, {305,0.00003636}, {306,0.00009091}, {307,0.00007273}, {308,0.00003636}, {309,0.00003636}, {310,0.00003636}, {311,0.00000000}, {312,0.00000000}, {313,0.00003636}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00003636}, {318,0.00003636}, {319,0.00000000}, {320,0.00000000}, {321,0.00003636}, {322,0.00003636}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00002727}, {328,0.00000000}, {329,0.00003636}, {330,0.00002727}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00003636}, {335,0.00000000}, {336,0.00007273}, {337,0.00003636}, {338,0.00003636}, {339,0.00000000}, {340,0.00003636}, {341,0.00007273}, {342,0.00000000}, {343,0.00003636}, {344,0.00002727}, {345,0.00000000}, {346,0.00003636}, {347,0.00000000}, {348,0.00000000}, {349,0.00003636}, {350,0.00000000}, {351,0.00000000}, {352,0.00003636}, {353,0.00000000}, {354,0.00000000}, {355,0.00006364}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00002727}, {360,0.00003636}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00007273}, {365,0.00000000}, {366,0.00000000}, {367,0.00010909}, {368,0.00003636}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00002727}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00003636}, {385,0.00000000}, {386,0.00003636}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00002727}, {391,0.00003636}, {392,0.00003636}, {393,0.00003636}, {394,0.00003636}, {395,0.00003636}, {396,0.00000000}, {397,0.00003636}, {398,0.00000000}, {399,0.00000000}, {400,0.00007273}, {401,0.00006364}, {402,0.00000000}, {403,0.00003636}, {404,0.00000000}, {405,0.00003636}, {406,0.00000000}, {407,0.00003636}, {408,0.00000000}, {409,0.00002727}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00003636}, {415,0.00000000}, {416,0.00003636}, {417,0.00000000}, {418,0.00000000}, {419,0.00007273}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00006364}, {424,0.00000000}, {425,0.00006364}, {426,0.00000000}, {427,0.00003636}, {428,0.00003636}, {429,0.00003636}, {430,0.00003636}, {431,0.00000000}, {432,0.00003636}, {433,0.00003636}, {434,0.00000000}, {435,0.00007273}, {436,0.00003636}, {437,0.00007273}, {438,0.00003636}, {439,0.00003636}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00007273}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00003636}, {455,0.00000000}, {456,0.00003636}, {457,0.00000000}, {458,0.00000000}, {459,0.00003636}, {460,0.00000000}, {461,0.00003636}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00003636}, {468,0.00000000}, {469,0.00003636}, {470,0.00007273}, {471,0.00003636}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00010909}, {476,0.00000000}, {477,0.00002727}, {478,0.00007273}, {479,0.00007273}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00003636}, {484,0.00003636}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00007273}, {494,0.00000000}, {495,0.00000000}, {496,0.00006364}, {497,0.00002727}, {498,0.00000000}, {499,0.00002727}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00003636}, {525,0.00003636}, {530,0.00003636}, {535,0.00000000}, {540,0.00003636}, {545,0.00003636}, {550,0.00003636}, {555,0.00000000}, {560,0.00003636}, {565,0.00000000}, {570,0.00003636}, {575,0.00003636}, {580,0.00000000}, {585,0.00003636}, {590,0.00006364}, {595,0.00000000}, {600,0.00010000}, {605,0.00000000}, {610,0.00003636}, {615,0.00000000}, {620,0.00003636}, {625,0.00003636}, {630,0.00000000}, {635,0.00003636}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00007273}, {665,0.00007273}, {670,0.00000000}, {675,0.00000000}, {680,0.00007273}, {685,0.00003636}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00002727}, {715,0.00003636}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00003636}, {745,0.00007273}, {750,0.00003636}, {755,0.00003636}, {760,0.00000000}, {765,0.00000000}, {770,0.00003636}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00010909}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00003636}, {820,0.00000000}, {825,0.00000000}, {830,0.00007273}, {835,0.00000000}, {840,0.00000000}, {845,0.00003636}, {850,0.00003636}, {855,0.00003636}, {860,0.00003636}, {865,0.00000000}, {870,0.00003636}, {875,0.00000000}, {880,0.00007273}, {885,0.00000000}, {890,0.00007273}, {895,0.00002727}, {900,0.00000000}, {905,0.00002727}, {910,0.00000000}, {915,0.00000000}, {920,0.00003636}, {925,0.00000000}, {930,0.00002727}, {935,0.00000000}, {940,0.00000000}, {945,0.00002727}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00007273}, {970,0.00003636}, {975,0.00007273}, {980,0.00003636}, {985,0.00000000}, {990,0.00003636}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00007273}, {1090,0.00000000}, {1100,0.00010000}, {1110,0.00000000}, {1120,0.00003636}, {1130,0.00000000}, {1140,0.00007273}, {1150,0.00003636}, {1160,0.00000000}, {1170,0.00003636}, {1180,0.00007273}, {1190,0.00003636}, {1200,0.00000000}, {1210,0.00007273}, {1220,0.00003636}, {1230,0.00000000}, {1240,0.00007273}, {1250,0.00003636}, {1260,0.00000000}, {1270,0.00003636}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00003636}, {1310,0.00000000}, {1320,0.00003636}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00003636}, {1360,0.00003636}, {1370,0.00006364}, {1380,0.00010909}, {1390,0.00000000}, {1400,0.00003636}, {1410,0.00000000}, {1420,0.00003636}, {1430,0.00006364}, {1440,0.00003636}, {1450,0.00007273}, {1460,0.00003636}, {1470,0.00000000}, {1480,0.00007273}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00006364}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00003636}, {1580,0.00003636}, {1590,0.00007273}, {1600,0.00000000}, {1610,0.00003636}, {1620,0.00006364}, {1630,0.00000000}, {1640,0.00007273}, {1650,0.00000000}, {1660,0.00007273}, {1670,0.00000000}, {1680,0.00003636}, {1690,0.00003636}, {1700,0.00000000}, {1710,0.00002727}, {1720,0.00002727}, {1730,0.00000000}, {1740,0.00003636}, {1750,0.00003636}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00003636}, {1800,0.00000000}, {1810,0.00003636}, {1820,0.00000000}, {1830,0.00003636}, {1840,0.00003636}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00002727}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00006364}, {1930,0.00003636}, {1940,0.00000000}, {1950,0.00003636}, {1960,0.00003636}, {1970,0.00000000}, {1980,0.00007273}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00003636}, {2100,0.00003636}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00003636}, {2300,0.00003636}, {2350,0.00000000}, {2400,0.00007273}, {2450,0.00003636}, {2500,0.00007273}, {2550,0.00006364}, {2600,0.00003636}, {2650,0.00000000}, {2700,0.00003636}, {2750,0.00000000}, {2800,0.00010000}, {2850,0.00007273}, {2900,0.00003636}, {2950,0.00000000}, {3000,0.00003636}, {3050,0.00000}, {3100,0.00000}, {3150,0.00000}, {3200,0.00000}, {3250,0.00000}, {3300,0.00000}, {3350,0.00000}, {3400,0.00000}, {3450,0.00000}, {3500,0.00000}, {3550,0.00000}, {3600,0.00000}, {3650,0.00000}, {3700,0.00000}, {3750,0.00000}, {3800,0.00000}, {3850,0.00000}, {3900,0.00000}, {3950,0.00000}, {4000,0.00000}, {4050,0.00000}, {4100,0.00000}, {4150,0.00000}, {4200,0.00000}, {4250,0.00000}, {4300,0.00000}, {4350,0.00000}, {4400,0.00000}, {4450,0.00000}, {4500,0.00000}, {4550,0.00000}, {4600,0.00000}, {4650,0.00000}, {4700,0.00000}, {4750,0.00000}, {4800,0.00000}, {4850,0.00000}, {4900,0.00000}, {4950,0.00000}, {5000,0.00000}, {5050,0.00000}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00100}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00100}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00200}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00100}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00100}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00100}, {8600,0.00000}, {8650,0.00000}, {8700,0.00100}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00100}, {8950,0.00000}, {9000,0.00100}, {9050,0.00000}, {9100,0.00100}, {9150,0.00100}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00075}, {9850,0.00000}, {9900,0.00100}, {9950,0.00000}, {10000,0.00100}, {10100,0.0000}, {10200,0.0000}, {10300,0.0000}, {10400,0}, {10500,0}, {10600,0}, {10700,0.008}, {10800,0}, {10900,0.003}, {11000,0}, {11100,0}, {11200,0}, {11300,0}, {11400,0}, {11500,0}, {11600,0}, {11700,0}, {11800,0}, {11900,0}, {12000,0}, {12100,0.004}, {12200,0}, {12300,0}, {12400,0}, {12500,0}, {12600,0}, {12700,0}, {12800,0}, {12900,0}, {13000,0}, {13100,0}, {13200,0}, {13300,0.004}, {13400,0}, {13500,0}, {13600,0}, {13700,0}, {13800,0}, {13900,0}, {14000,0}, {14100,0}, {14200,0}, {14300,0}, {14400,0}, {14500,0}, {14600,0}, {14700,0}, {14800,0}, {14900,0}, {15000,0}, {15100,0}, {15200,0}, {15300,0}, {15400,0}, {15500,0}, {15600,0}, {15700,0}, {15800,0}, {15900,0}, {16000,0}, {16100,0}, {16200,0}, {16300,0}, {16400,0}, {16500,0}, {16600,0}, {16700,0}, {16800,0.004}, {16900,0}, {17000,0}, {17100,0}, {17200,0}, {17300,0}, {17400,0}, {17500,0}, {17600,0}, {17700,0}, {17800,0}, {17900,0}, {18000,0}, {18100,0}, {18200,0}, {18300,0}, {18400,0}, {18500,0}, {18600,0}, {18700,0}, {18800,0}, {18900,0}, {19000,0}, {19100,0}, {19200,0}, {19300,0}, {19400,0}, {19500,0}, {19600,0}, {19700,0}, {19800,0}, {19900,0}};
data["big"]["identity cbn"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00001818}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00001818}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00100909}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00003636}, {265,0.00000000}, {266,0.00000000}, {267,0.00170000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00011818}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000909}, {295,0.00001818}, {296,0.00000000}, {297,0.00000000}, {298,0.00000909}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000909}, {304,0.00001818}, {305,0.00001818}, {306,0.00002727}, {307,0.00003636}, {308,0.00002727}, {309,0.00005455}, {310,0.00005455}, {311,0.00008182}, {312,0.00007273}, {313,0.00010000}, {314,0.00010000}, {315,0.00011818}, {316,0.00020909}, {317,0.00025455}, {318,0.00026364}, {319,0.00034545}, {320,0.00031818}, {321,0.00035455}, {322,0.00048182}, {323,0.00047273}, {324,0.00060909}, {325,0.00051818}, {326,0.00057273}, {327,0.00058182}, {328,0.00064545}, {329,0.00070000}, {330,0.00072727}, {331,0.00073636}, {332,0.00079091}, {333,0.00078182}, {334,0.00080909}, {335,0.00080000}, {336,0.00080909}, {337,0.00084545}, {338,0.00083636}, {339,0.00089091}, {340,0.00084545}, {341,0.00091818}, {342,0.00090909}, {343,0.00092727}, {344,0.00095455}, {345,0.00097273}, {346,0.00098182}, {347,0.00098182}, {348,0.00098182}, {349,0.00100000}, {350,0.00098182}, {351,0.00100000}, {352,0.00100000}, {353,0.00100000}, {354,0.00100000}, {355,0.00100000}, {356,0.00100000}, {357,0.00100000}, {358,0.00100000}, {359,0.00100000}, {360,0.00100000}, {361,0.00100000}, {362,0.00100000}, {363,0.00100000}, {364,0.00100000}, {365,0.00100000}, {366,0.00100000}, {367,0.00100000}, {368,0.00100000}, {369,0.00100000}, {370,0.00100000}, {371,0.00100000}, {372,0.00100000}, {373,0.00100000}, {374,0.00100000}, {375,0.00100000}, {376,0.00100000}, {377,0.00100000}, {378,0.00100000}, {379,0.00100000}, {380,0.00100000}, {381,0.00100000}, {382,0.00100000}, {383,0.00100000}, {384,0.00100000}, {385,0.00100000}, {386,0.00100000}, {387,0.00100000}, {388,0.00100000}, {389,0.00100000}, {390,0.00100000}, {391,0.00100000}, {392,0.00100000}, {393,0.00100000}, {394,0.00100000}, {395,0.00100000}, {396,0.00100000}, {397,0.00100000}, {398,0.00100000}, {399,0.00100000}, {400,0.00100000}, {401,0.00100000}, {402,0.00100000}, {403,0.00100000}, {404,0.00100000}, {405,0.00100000}, {406,0.00100000}, {407,0.00100000}, {408,0.00100000}, {409,0.00100000}, {410,0.00100000}, {411,0.00100000}, {412,0.00100000}, {413,0.00100000}, {414,0.00101818}, {415,0.00100000}, {416,0.00100000}, {417,0.00100000}, {418,0.00100000}, {419,0.00100000}, {420,0.00100000}, {421,0.00100000}, {422,0.00270909}, {423,0.00100000}, {424,0.00100000}, {425,0.00100000}, {426,0.00100000}, {427,0.00100000}, {428,0.00100000}, {429,0.00100000}, {430,0.00100000}, {431,0.00100000}, {432,0.00100000}, {433,0.00100000}, {434,0.00100000}, {435,0.00100000}, {436,0.00100000}, {437,0.00100000}, {438,0.00100000}, {439,0.00100000}, {440,0.00100000}, {441,0.00100000}, {442,0.00101818}, {443,0.00100000}, {444,0.00100000}, {445,0.00100000}, {446,0.00100000}, {447,0.00100000}, {448,0.00100000}, {449,0.00102727}, {450,0.00100000}, {451,0.00100000}, {452,0.00100000}, {453,0.00100000}, {454,0.00100000}, {455,0.00100000}, {456,0.00100000}, {457,0.00100000}, {458,0.00100000}, {459,0.00100000}, {460,0.00100000}, {461,0.00100000}, {462,0.00100000}, {463,0.00100000}, {464,0.00100000}, {465,0.00100000}, {466,0.00100000}, {467,0.00100000}, {468,0.00100000}, {469,0.00100000}, {470,0.00100000}, {471,0.00100000}, {472,0.00100000}, {473,0.00100909}, {474,0.00100909}, {475,0.00100909}, {476,0.00100909}, {477,0.00100909}, {478,0.00100909}, {479,0.00100000}, {480,0.00105455}, {481,0.00102727}, {482,0.00101818}, {483,0.00112727}, {484,0.00113636}, {485,0.00117273}, {486,0.00119091}, {487,0.00123636}, {488,0.00128182}, {489,0.00135455}, {490,0.00140000}, {491,0.00147273}, {492,0.00152727}, {493,0.00164545}, {494,0.00167273}, {495,0.00168182}, {496,0.00170909}, {497,0.00178182}, {498,0.00178182}, {499,0.00176364}, {500,0.00181818}, {505,0.00184545}, {510,0.00195455}, {515,0.00200000}, {520,0.00200000}, {525,0.00200000}, {530,0.00200000}, {535,0.00200000}, {540,0.00200000}, {545,0.00200000}, {550,0.00200000}, {555,0.00200000}, {560,0.00200000}, {565,0.00200000}, {570,0.00200000}, {575,0.00200000}, {580,0.00202727}, {585,0.00236364}, {590,0.00268182}, {595,0.00282727}, {600,0.00287273}, {605,0.00300000}, {610,0.00304545}, {615,0.00300000}, {620,0.00300000}, {625,0.00300000}, {630,0.00300000}, {635,0.00300000}, {640,0.00300000}, {645,0.00300000}, {650,0.00300000}, {655,0.00300909}, {660,0.00311818}, {665,0.00346364}, {670,0.00378182}, {675,0.00382727}, {680,0.00393636}, {685,0.00400000}, {690,0.00400000}, {695,0.00400000}, {700,0.00400000}, {705,0.00400000}, {710,0.00400000}, {715,0.00400000}, {720,0.00400000}, {725,0.00400909}, {730,0.00681818}, {735,0.00450909}, {740,0.00469091}, {745,0.00483636}, {750,0.00490909}, {755,0.00500000}, {760,0.00500000}, {765,0.00500909}, {770,0.00501818}, {775,0.00500000}, {780,0.00500000}, {785,0.00500000}, {790,0.00500000}, {795,0.00507273}, {800,0.00540000}, {805,0.00570000}, {810,0.00582727}, {815,0.00590000}, {820,0.00920909}, {825,0.00601818}, {830,0.00600000}, {835,0.00601818}, {840,0.00961818}, {845,0.00600000}, {850,0.00600000}, {855,0.00604545}, {860,0.00632727}, {865,0.00667273}, {870,0.00680000}, {875,0.00690000}, {880,0.00699091}, {885,0.00700000}, {890,0.01041818}, {895,0.00700000}, {900,0.00701818}, {905,0.00700000}, {910,0.00701818}, {915,0.00722727}, {920,0.00751818}, {925,0.00777273}, {930,0.00786364}, {935,0.00797273}, {940,0.00800000}, {945,0.00800000}, {950,0.00800000}, {955,0.00800909}, {960,0.00800000}, {965,0.00802727}, {970,0.00821818}, {975,0.00855455}, {980,0.00877273}, {985,0.00895455}, {990,0.00898182}, {995,0.00909091}, {1000,0.00900000}, {1010,0.00909091}, {1020,0.00910000}, {1030,0.00972727}, {1040,0.00993636}, {1050,0.01000000}, {1060,0.01000000}, {1070,0.01009091}, {1080,0.01068182}, {1090,0.01093636}, {1100,0.01100000}, {1110,0.01100000}, {1120,0.01122727}, {1130,0.01171818}, {1140,0.01199091}, {1150,0.01200000}, {1160,0.01202727}, {1170,0.01259091}, {1180,0.01285455}, {1190,0.01300000}, {1200,0.01300000}, {1210,0.01305455}, {1220,0.01379091}, {1230,0.01398182}, {1240,0.01400000}, {1250,0.01406364}, {1260,0.01462727}, {1270,0.01497273}, {1280,0.01500000}, {1290,0.01500000}, {1300,0.01545455}, {1310,0.02030000}, {1320,0.02340000}, {1330,0.02213636}, {1340,0.02345455}, {1350,0.02220000}, {1360,0.01700000}, {1370,0.01700000}, {1380,0.01742727}, {1390,0.01792727}, {1400,0.01800909}, {1410,0.01804545}, {1420,0.01868182}, {1430,0.01892727}, {1440,0.01902727}, {1450,0.02426364}, {1460,0.01975455}, {1470,0.01997273}, {1480,0.02000909}, {1490,0.02048182}, {1500,0.02077273}, {1510,0.02100000}, {1520,0.02110000}, {1530,0.02169091}, {1540,0.02194545}, {1550,0.02211818}, {1560,0.02240909}, {1570,0.02279091}, {1580,0.02300000}, {1590,0.02309091}, {1600,0.02369091}, {1610,0.02391818}, {1620,0.02400909}, {1630,0.02447273}, {1640,0.02480000}, {1650,0.02501818}, {1660,0.03080000}, {1670,0.02576364}, {1680,0.02597273}, {1690,0.02622727}, {1700,0.02660909}, {1710,0.02697273}, {1720,0.02709091}, {1730,0.02766364}, {1740,0.02791818}, {1750,0.02801818}, {1760,0.02858182}, {1770,0.02890000}, {1780,0.04109091}, {1790,0.02958182}, {1800,0.02990000}, {1810,0.03001818}, {1820,0.03063636}, {1830,0.03098182}, {1840,0.03109091}, {1850,0.03142727}, {1860,0.03190909}, {1870,0.03206364}, {1880,0.03258182}, {1890,0.03289091}, {1900,0.03305455}, {1910,0.05190000}, {1920,0.03390909}, {1930,0.03467273}, {1940,0.03470000}, {1950,0.03496364}, {1960,0.03534545}, {1970,0.03572727}, {1980,0.03603636}, {1990,0.03648182}, {2000,0.03678182}, {2050,0.03870909}, {2100,0.04053636}, {2150,0.04250000}, {2200,0.04452727}, {2250,0.04638182}, {2300,0.04860000}, {2350,0.05065455}, {2400,0.05278182}, {2450,0.05483636}, {2500,0.05740000}, {2550,0.05959091}, {2600,0.06192727}, {2650,0.06446364}, {2700,0.06668182}, {2750,0.06937273}, {2800,0.07198182}, {2850,0.07440909}, {2900,0.07672727}, {2950,0.07959091}, {3000,0.14434545}, {3050,0.12175}, {3100,0.08800}, {3150,0.09375}, {3200,0.13500}, {3250,0.09675}, {3300,0.09975}, {3350,0.10275}, {3400,0.10600}, {3450,0.10925}, {3500,0.13400}, {3550,0.11650}, {3600,0.12000}, {3650,0.12750}, {3700,0.12825}, {3750,0.13225}, {3800,0.13675}, {3850,0.14050}, {3900,0.21025}, {3950,0.15025}, {4000,0.15825}, {4050,0.16000}, {4100,0.22900}, {4150,0.17175}, {4200,0.17925}, {4250,0.19500}, {4300,0.20750}, {4350,0.20750}, {4400,0.22325}, {4450,0.27850}, {4500,0.24350}, {4550,0.25700}, {4600,0.44150}, {4650,0.29825}, {4700,0.30875}, {4750,0.45350}, {4800,0.33350}, {4850,0.35100}, {4900,0.36725}, {4950,0.54525}, {5000,0.40325}, {5050,0.49975}, {5100,0.43925}, {5150,0.45750}, {5200,0.55400}, {5250,0.66200}, {5300,0.52600}, {5350,0.53350}, {5400,0.56200}, {5450,0.75350}, {5500,0.68025}, {5550,0.61200}, {5600,0.63225}, {5650,0.82175}, {5700,0.67250}, {5750,0.76150}, {5800,0.76275}, {5850,0.73725}, {5900,0.75675}, {5950,0.79600}, {6000,0.92950}, {6050,0.97075}, {6100,0.84175}, {6150,0.86450}, {6200,0.88550}, {6250,0.92150}, {6300,0.93050}, {6350,0.98475}, {6400,0.97550}, {6450,0.98025}, {6500,1.02450}, {6550,1.04650}, {6600,1.07075}, {6650,1.10200}, {6700,1.12625}, {6750,1.14250}, {6800,1.16500}, {6850,1.18925}, {6900,1.31025}, {6950,1.23725}, {7000,1.27775}, {7050,1.28825}, {7100,1.45150}, {7150,1.34175}, {7200,1.36575}, {7250,1.45475}, {7300,1.38525}, {7350,1.48750}, {7400,1.41175}, {7450,1.66675}, {7500,1.52325}, {7550,1.55150}, {7600,1.74925}, {7650,1.60825}, {7700,1.71475}, {7750,1.66300}, {7800,1.72125}, {7850,1.72550}, {7900,1.74725}, {7950,1.77975}, {8000,1.80675}, {8050,1.83450}, {8100,1.86150}, {8150,1.89100}, {8200,2.10900}, {8250,1.96450}, {8300,1.97650}, {8350,2.13025}, {8400,2.03100}, {8450,2.06000}, {8500,2.15800}, {8550,2.05950}, {8600,2.15025}, {8650,2.18125}, {8700,2.21425}, {8750,2.24225}, {8800,2.22400}, {8850,2.36850}, {8900,2.34950}, {8950,2.38225}, {9000,2.28325}, {9050,2.43850}, {9100,2.49100}, {9150,2.26775}, {9200,2.53075}, {9250,2.56775}, {9300,2.59850}, {9350,2.63375}, {9400,2.67025}, {9450,2.70525}, {9500,2.72875}, {9550,2.74125}, {9600,2.81000}, {9650,2.85275}, {9700,2.89500}, {9750,2.91325}, {9800,2.95150}, {9850,2.94400}, {9900,3.00475}, {9950,2.91350}, {10000,2.98100}, {10100,3.1555}, {10200,3.2295}, {10300,3.2780}, {10400,3.3830}, {10500,3.469}, {10600,3.54}, {10700,3.621}, {10800,3.693}, {10900,3.145}, {11000,3.785}, {11100,3.731}, {11200,3.948}, {11300,4.052}, {11400,4.12}, {11500,4.189}, {11600,4.274}, {11700,4.284}, {11800,4.449}, {11900,4.522}, {12000,4.599}, {12100,4.722}, {12200,4.791}, {12300,4.966}, {12400,5.02}, {12500,5.108}, {12600,5.227}, {12700,5.3}, {12800,5.411}, {12900,5.459}, {13000,5.573}, {13100,5.657}, {13200,5.756}, {13300,5.87}, {13400,5.964}, {13500,6.043}, {13600,6.159}, {13700,6.276}, {13800,6.358}, {13900,6.426}, {14000,6.56}, {14100,6.642}, {14200,6.781}, {14300,6.852}, {14400,6.94}, {14500,7.217}, {14600,7.157}, {14700,7.285}, {14800,7.362}, {14900,7.778}, {15000,7.583}, {15100,7.73}, {15200,7.798}, {15300,7.9}, {15400,8.003}, {15500,8.168}, {15600,8.235}, {15700,8.351}, {15800,8.445}, {15900,8.598}, {16000,8.713}, {16100,8.796}, {16200,8.902}, {16300,9.347}, {16400,9.159}, {16500,9.31}, {16600,9.368}, {16700,9.508}, {16800,9.63}, {16900,9.762}, {17000,9.897}, {17100,10.229}, {17200,10.1}, {17300,10.243}, {17400,10.373}, {17500,10.46}, {17600,10.875}, {17700,10.725}, {17800,11.209}, {17900,10.972}, {18000,11.111}, {18100,11.223}, {18200,11.354}, {18300,11.554}, {18400,11.59}, {18500,11.789}, {18600,12.056}, {18700,12.372}, {18800,12.259}, {18900,12.315}, {19000,12.406}, {19100,12.59}, {19200,12.794}, {19300,12.816}, {19400,12.957}, {19500,13.119}, {19600,13.265}, {19700,13.39}, {19800,13.604}, {19900,13.776}};
data["big"]["identity cbn"]["Stats"]["user"] = {{1,0.00000000}, {2,0.00002727}, {3,0.00000000}, {4,0.00003636}, {5,0.00003636}, {6,0.00011818}, {7,0.00002727}, {8,0.00005455}, {9,0.00002727}, {10,0.00009091}, {11,0.00003636}, {12,0.00006364}, {13,0.00000000}, {14,0.00006364}, {15,0.00000000}, {16,0.00005455}, {17,0.00005455}, {18,0.00009091}, {19,0.00011818}, {20,0.00005455}, {21,0.00003636}, {22,0.00010000}, {23,0.00012727}, {24,0.00002727}, {25,0.00009091}, {26,0.00012727}, {27,0.00006364}, {28,0.00000000}, {29,0.00008182}, {30,0.00008182}, {31,0.00008182}, {32,0.00003636}, {33,0.00006364}, {34,0.00020000}, {35,0.00010000}, {36,0.00010909}, {37,0.00005455}, {38,0.00012727}, {39,0.00009091}, {40,0.00005455}, {41,0.00009091}, {42,0.00016364}, {43,0.00030000}, {44,0.00018182}, {45,0.00006364}, {46,0.00012727}, {47,0.00002727}, {48,0.00012727}, {49,0.00002727}, {50,0.00015455}, {51,0.00003636}, {52,0.00011818}, {53,0.00005455}, {54,0.00020000}, {55,0.00012727}, {56,0.00012727}, {57,0.00028182}, {58,0.00023636}, {59,0.00018182}, {60,0.00014545}, {61,0.00017273}, {62,0.00015455}, {63,0.00025455}, {64,0.00020909}, {65,0.00024545}, {66,0.00009091}, {67,0.00002727}, {68,0.00026364}, {69,0.00019091}, {70,0.00021818}, {71,0.00002727}, {72,0.00022727}, {73,0.00015455}, {74,0.00010909}, {75,0.00022727}, {76,0.00016364}, {77,0.00015455}, {78,0.00020909}, {79,0.00009091}, {80,0.00019091}, {81,0.00014545}, {82,0.00012727}, {83,0.00014545}, {84,0.00019091}, {85,0.00005455}, {86,0.00020909}, {87,0.00012727}, {88,0.00008182}, {89,0.00019091}, {90,0.00009091}, {91,0.00019091}, {92,0.00038182}, {93,0.00018182}, {94,0.00018182}, {95,0.00020000}, {96,0.00013636}, {97,0.00020000}, {98,0.00018182}, {99,0.00024545}, {100,0.00011818}, {101,0.00018182}, {102,0.00019091}, {103,0.00017273}, {104,0.00021818}, {105,0.00037273}, {106,0.00026364}, {107,0.00022727}, {108,0.00034545}, {109,0.00018182}, {110,0.00038182}, {111,0.00020909}, {112,0.00027273}, {113,0.00028182}, {114,0.00017273}, {115,0.00013636}, {116,0.00027273}, {117,0.00016364}, {118,0.00025455}, {119,0.00033636}, {120,0.00037273}, {121,0.00017273}, {122,0.00027273}, {123,0.00027273}, {124,0.00026364}, {125,0.00036364}, {126,0.00039091}, {127,0.00019091}, {128,0.00015455}, {129,0.00028182}, {130,0.00020909}, {131,0.00020909}, {132,0.00021818}, {133,0.00045455}, {134,0.00023636}, {135,0.00024545}, {136,0.00005455}, {137,0.00028182}, {138,0.00030909}, {139,0.00036364}, {140,0.00043636}, {141,0.00028182}, {142,0.00032727}, {143,0.00026364}, {144,0.00025455}, {145,0.00027273}, {146,0.00030909}, {147,0.00020000}, {148,0.00033636}, {149,0.00028182}, {150,0.00052727}, {151,0.00038182}, {152,0.00040909}, {153,0.00048182}, {154,0.00034545}, {155,0.00029091}, {156,0.00043636}, {157,0.00046364}, {158,0.00037273}, {159,0.00034545}, {160,0.00020909}, {161,0.00048182}, {162,0.00039091}, {163,0.00006364}, {164,0.00039091}, {165,0.00029091}, {166,0.00049091}, {167,0.00031818}, {168,0.00027273}, {169,0.00032727}, {170,0.00032727}, {171,0.00045455}, {172,0.00036364}, {173,0.00044545}, {174,0.00017273}, {175,0.00034545}, {176,0.00030000}, {177,0.00022727}, {178,0.00039091}, {179,0.00041818}, {180,0.00030000}, {181,0.00027273}, {182,0.00030909}, {183,0.00055455}, {184,0.00040000}, {185,0.00047273}, {186,0.00028182}, {187,0.00082727}, {188,0.00049091}, {189,0.00018182}, {190,0.00038182}, {191,0.00042727}, {192,0.00037273}, {193,0.00035455}, {194,0.00037273}, {195,0.00052727}, {196,0.00057273}, {197,0.00066364}, {198,0.00042727}, {199,0.00035455}, {200,0.00042727}, {201,0.00036364}, {202,0.00047273}, {203,0.00057273}, {204,0.00063636}, {205,0.00049091}, {206,0.00046364}, {207,0.00066364}, {208,0.00042727}, {209,0.00049091}, {210,0.00057273}, {211,0.00055455}, {212,0.00050000}, {213,0.00062727}, {214,0.00056364}, {215,0.00037273}, {216,0.00056364}, {217,0.00038182}, {218,0.00035455}, {219,0.00072727}, {220,0.00040909}, {221,0.00026364}, {222,0.00058182}, {223,0.00051818}, {224,0.00051818}, {225,0.00067273}, {226,0.00060909}, {227,0.00043636}, {228,0.00054545}, {229,0.00037273}, {230,0.00128182}, {231,0.00060909}, {232,0.00063636}, {233,0.00050000}, {234,0.00064545}, {235,0.00059091}, {236,0.00056364}, {237,0.00065455}, {238,0.00048182}, {239,0.00070909}, {240,0.00043636}, {241,0.00045455}, {242,0.00041818}, {243,0.00054545}, {244,0.00051818}, {245,0.00046364}, {246,0.00054545}, {247,0.00077273}, {248,0.00075455}, {249,0.00062727}, {250,0.00050000}, {251,0.00076364}, {252,0.00057273}, {253,0.00073636}, {254,0.00052727}, {255,0.00049091}, {256,0.00053636}, {257,0.00047273}, {258,0.00064545}, {259,0.00062727}, {260,0.00061818}, {261,0.00070909}, {262,0.00072727}, {263,0.00069091}, {264,0.00054545}, {265,0.00052727}, {266,0.00058182}, {267,0.00145455}, {268,0.00071818}, {269,0.00071818}, {270,0.00051818}, {271,0.00045455}, {272,0.00052727}, {273,0.00052727}, {274,0.00045455}, {275,0.00060909}, {276,0.00053636}, {277,0.00074545}, {278,0.00045455}, {279,0.00068182}, {280,0.00070000}, {281,0.00074545}, {282,0.00059091}, {283,0.00047273}, {284,0.00081818}, {285,0.00060000}, {286,0.00068182}, {287,0.00054545}, {288,0.00079091}, {289,0.00082727}, {290,0.00072727}, {291,0.00073636}, {292,0.00071818}, {293,0.00069091}, {294,0.00052727}, {295,0.00071818}, {296,0.00074545}, {297,0.00070909}, {298,0.00060000}, {299,0.00076364}, {300,0.00075455}, {301,0.00069091}, {302,0.00070909}, {303,0.00075455}, {304,0.00090000}, {305,0.00053636}, {306,0.00050909}, {307,0.00089091}, {308,0.00066364}, {309,0.00066364}, {310,0.00085455}, {311,0.00097273}, {312,0.00078182}, {313,0.00097273}, {314,0.00081818}, {315,0.00098182}, {316,0.00088182}, {317,0.00072727}, {318,0.00094545}, {319,0.00070909}, {320,0.00088182}, {321,0.00070909}, {322,0.00096364}, {323,0.00072727}, {324,0.00110909}, {325,0.00070000}, {326,0.00074545}, {327,0.00099091}, {328,0.00086364}, {329,0.00055455}, {330,0.00080909}, {331,0.00099091}, {332,0.00092727}, {333,0.00076364}, {334,0.00097273}, {335,0.00074545}, {336,0.00083636}, {337,0.00085455}, {338,0.00062727}, {339,0.00093636}, {340,0.00085455}, {341,0.00064545}, {342,0.00087273}, {343,0.00069091}, {344,0.00087273}, {345,0.00099091}, {346,0.00072727}, {347,0.00085455}, {348,0.00102727}, {349,0.00080000}, {350,0.00085455}, {351,0.00089091}, {352,0.00080909}, {353,0.00097273}, {354,0.00073636}, {355,0.00094545}, {356,0.00111818}, {357,0.00122727}, {358,0.00088182}, {359,0.00092727}, {360,0.00114545}, {361,0.00101818}, {362,0.00102727}, {363,0.00087273}, {364,0.00095455}, {365,0.00134545}, {366,0.00081818}, {367,0.00101818}, {368,0.00100000}, {369,0.00091818}, {370,0.00094545}, {371,0.00103636}, {372,0.00084545}, {373,0.00099091}, {374,0.00097273}, {375,0.00121818}, {376,0.00093636}, {377,0.00121818}, {378,0.00106364}, {379,0.00111818}, {380,0.00102727}, {381,0.00104545}, {382,0.00098182}, {383,0.00101818}, {384,0.00089091}, {385,0.00105455}, {386,0.00097273}, {387,0.00100909}, {388,0.00102727}, {389,0.00099091}, {390,0.00094545}, {391,0.00100000}, {392,0.00117273}, {393,0.00096364}, {394,0.00112727}, {395,0.00102727}, {396,0.00111818}, {397,0.00088182}, {398,0.00100000}, {399,0.00082727}, {400,0.00107273}, {401,0.00123636}, {402,0.00101818}, {403,0.00126364}, {404,0.00130000}, {405,0.00112727}, {406,0.00108182}, {407,0.00122727}, {408,0.00100909}, {409,0.00114545}, {410,0.00151818}, {411,0.00117273}, {412,0.00115455}, {413,0.00114545}, {414,0.00122727}, {415,0.00124545}, {416,0.00111818}, {417,0.00112727}, {418,0.00142727}, {419,0.00105455}, {420,0.00138182}, {421,0.00121818}, {422,0.00269091}, {423,0.00130909}, {424,0.00114545}, {425,0.00114545}, {426,0.00106364}, {427,0.00138182}, {428,0.00128182}, {429,0.00132727}, {430,0.00108182}, {431,0.00120000}, {432,0.00120000}, {433,0.00134545}, {434,0.00139091}, {435,0.00130909}, {436,0.00132727}, {437,0.00148182}, {438,0.00130909}, {439,0.00145455}, {440,0.00154545}, {441,0.00122727}, {442,0.00149091}, {443,0.00139091}, {444,0.00115455}, {445,0.00129091}, {446,0.00139091}, {447,0.00153636}, {448,0.00119091}, {449,0.00130909}, {450,0.00175455}, {451,0.00125455}, {452,0.00123636}, {453,0.00105455}, {454,0.00144545}, {455,0.00139091}, {456,0.00143636}, {457,0.00140909}, {458,0.00137273}, {459,0.00154545}, {460,0.00134545}, {461,0.00146364}, {462,0.00174545}, {463,0.00120000}, {464,0.00137273}, {465,0.00102727}, {466,0.00153636}, {467,0.00131818}, {468,0.00162727}, {469,0.00141818}, {470,0.00141818}, {471,0.00138182}, {472,0.00166364}, {473,0.00190909}, {474,0.00140000}, {475,0.00169091}, {476,0.00160909}, {477,0.00166364}, {478,0.00157273}, {479,0.00160000}, {480,0.00136364}, {481,0.00141818}, {482,0.00154545}, {483,0.00152727}, {484,0.00166364}, {485,0.00150000}, {486,0.00160909}, {487,0.00134545}, {488,0.00173636}, {489,0.00173636}, {490,0.00152727}, {491,0.00177273}, {492,0.00193636}, {493,0.00185455}, {494,0.00177273}, {495,0.00143636}, {496,0.00138182}, {497,0.00170909}, {498,0.00155455}, {499,0.00158182}, {500,0.00145455}, {505,0.00173636}, {510,0.00190909}, {515,0.00190909}, {520,0.00169091}, {525,0.00200000}, {530,0.00211818}, {535,0.00187273}, {540,0.00193636}, {545,0.00214545}, {550,0.00210909}, {555,0.00217273}, {560,0.00239091}, {565,0.00226364}, {570,0.00243636}, {575,0.00254545}, {580,0.00237273}, {585,0.00277273}, {590,0.00273636}, {595,0.00295455}, {600,0.00260909}, {605,0.00293636}, {610,0.00287273}, {615,0.00298182}, {620,0.00297273}, {625,0.00297273}, {630,0.00314545}, {635,0.00312727}, {640,0.00329091}, {645,0.00318182}, {650,0.00346364}, {655,0.00348182}, {660,0.00353636}, {665,0.00355455}, {670,0.00352727}, {675,0.00371818}, {680,0.00364545}, {685,0.00388182}, {690,0.00385455}, {695,0.00390909}, {700,0.00411818}, {705,0.00395455}, {710,0.00443636}, {715,0.00427273}, {720,0.00442727}, {725,0.00447273}, {730,0.00647273}, {735,0.00447273}, {740,0.00477273}, {745,0.00500000}, {750,0.00479091}, {755,0.00485455}, {760,0.00481818}, {765,0.00450000}, {770,0.00506364}, {775,0.00495455}, {780,0.00540909}, {785,0.00556364}, {790,0.00524545}, {795,0.00542727}, {800,0.00562727}, {805,0.00558182}, {810,0.00508182}, {815,0.00569091}, {820,0.00940909}, {825,0.00580909}, {830,0.00592727}, {835,0.00619091}, {840,0.00957273}, {845,0.00595455}, {850,0.00639091}, {855,0.00643636}, {860,0.00640909}, {865,0.00638182}, {870,0.00641818}, {875,0.00634545}, {880,0.00662727}, {885,0.00680000}, {890,0.01104545}, {895,0.00707273}, {900,0.00695455}, {905,0.00709091}, {910,0.00725455}, {915,0.00728182}, {920,0.00730909}, {925,0.00751818}, {930,0.00757273}, {935,0.00755455}, {940,0.00770000}, {945,0.00771818}, {950,0.00810000}, {955,0.00774545}, {960,0.00814545}, {965,0.00840000}, {970,0.00869091}, {975,0.00852727}, {980,0.00856364}, {985,0.00850000}, {990,0.00895455}, {995,0.00938182}, {1000,0.00878182}, {1010,0.00897273}, {1020,0.00930909}, {1030,0.00956364}, {1040,0.00980000}, {1050,0.01024545}, {1060,0.01087273}, {1070,0.01092727}, {1080,0.01088182}, {1090,0.01142727}, {1100,0.01154545}, {1110,0.01137273}, {1120,0.01187273}, {1130,0.01209091}, {1140,0.01231818}, {1150,0.01252727}, {1160,0.01285455}, {1170,0.01280909}, {1180,0.01355455}, {1190,0.01349091}, {1200,0.01405455}, {1210,0.01369091}, {1220,0.01374545}, {1230,0.01426364}, {1240,0.01436364}, {1250,0.01462727}, {1260,0.01527273}, {1270,0.01515455}, {1280,0.01516364}, {1290,0.01542727}, {1300,0.01553636}, {1310,0.02001818}, {1320,0.02377273}, {1330,0.02224545}, {1340,0.02344545}, {1350,0.02228182}, {1360,0.01702727}, {1370,0.01694545}, {1380,0.01762727}, {1390,0.01750000}, {1400,0.01785455}, {1410,0.01793636}, {1420,0.01832727}, {1430,0.01867273}, {1440,0.01891818}, {1450,0.02482727}, {1460,0.01950000}, {1470,0.01984545}, {1480,0.02052727}, {1490,0.02046364}, {1500,0.02086364}, {1510,0.02100909}, {1520,0.02134545}, {1530,0.02176364}, {1540,0.02218182}, {1550,0.02230909}, {1560,0.02260000}, {1570,0.02280909}, {1580,0.02340000}, {1590,0.02353636}, {1600,0.02410000}, {1610,0.02431818}, {1620,0.02451818}, {1630,0.02482727}, {1640,0.02486364}, {1650,0.02544545}, {1660,0.03036364}, {1670,0.02590909}, {1680,0.02567273}, {1690,0.02653636}, {1700,0.02681818}, {1710,0.02711818}, {1720,0.02750000}, {1730,0.02773636}, {1740,0.02808182}, {1750,0.02828182}, {1760,0.02852727}, {1770,0.02848182}, {1780,0.04095455}, {1790,0.02945455}, {1800,0.03017273}, {1810,0.03013636}, {1820,0.03027273}, {1830,0.03081818}, {1840,0.03100000}, {1850,0.03127273}, {1860,0.03159091}, {1870,0.03204545}, {1880,0.03255455}, {1890,0.03325455}, {1900,0.03308182}, {1910,0.05207273}, {1920,0.03397273}, {1930,0.03487273}, {1940,0.03486364}, {1950,0.03535455}, {1960,0.03580909}, {1970,0.03618182}, {1980,0.03659091}, {1990,0.03690000}, {2000,0.03710000}, {2050,0.03879091}, {2100,0.04073636}, {2150,0.04199091}, {2200,0.04431818}, {2250,0.04681818}, {2300,0.04885455}, {2350,0.05078182}, {2400,0.05304545}, {2450,0.05475455}, {2500,0.05710000}, {2550,0.06000000}, {2600,0.06245455}, {2650,0.06441818}, {2700,0.06650000}, {2750,0.06960909}, {2800,0.07264545}, {2850,0.07444545}, {2900,0.07699091}, {2950,0.07924545}, {3000,0.14388182}, {3050,0.12125}, {3100,0.08725}, {3150,0.09475}, {3200,0.13350}, {3250,0.09775}, {3300,0.09925}, {3350,0.10175}, {3400,0.10675}, {3450,0.10875}, {3500,0.13350}, {3550,0.11800}, {3600,0.12075}, {3650,0.12650}, {3700,0.12775}, {3750,0.13200}, {3800,0.13825}, {3850,0.14050}, {3900,0.21025}, {3950,0.14825}, {4000,0.15675}, {4050,0.16075}, {4100,0.22950}, {4150,0.17150}, {4200,0.18000}, {4250,0.19475}, {4300,0.20750}, {4350,0.20725}, {4400,0.22275}, {4450,0.27925}, {4500,0.24350}, {4550,0.25600}, {4600,0.43950}, {4650,0.29650}, {4700,0.30850}, {4750,0.45175}, {4800,0.33475}, {4850,0.35300}, {4900,0.36600}, {4950,0.54550}, {5000,0.40300}, {5050,0.50050}, {5100,0.43925}, {5150,0.45750}, {5200,0.55475}, {5250,0.66125}, {5300,0.52550}, {5350,0.53475}, {5400,0.56125}, {5450,0.75250}, {5500,0.68025}, {5550,0.61200}, {5600,0.63250}, {5650,0.82025}, {5700,0.67050}, {5750,0.76150}, {5800,0.76350}, {5850,0.73700}, {5900,0.75625}, {5950,0.79450}, {6000,0.92750}, {6050,0.97050}, {6100,0.84175}, {6150,0.86375}, {6200,0.88575}, {6250,0.92150}, {6300,0.92900}, {6350,0.98225}, {6400,0.97450}, {6450,0.98150}, {6500,1.02350}, {6550,1.04650}, {6600,1.07075}, {6650,1.10125}, {6700,1.12525}, {6750,1.14225}, {6800,1.16575}, {6850,1.18800}, {6900,1.31025}, {6950,1.23550}, {7000,1.27800}, {7050,1.28850}, {7100,1.45175}, {7150,1.34275}, {7200,1.36625}, {7250,1.45375}, {7300,1.38575}, {7350,1.48800}, {7400,1.41100}, {7450,1.66550}, {7500,1.52175}, {7550,1.54925}, {7600,1.74725}, {7650,1.60725}, {7700,1.71350}, {7750,1.66075}, {7800,1.71900}, {7850,1.72575}, {7900,1.74750}, {7950,1.77950}, {8000,1.80600}, {8050,1.83325}, {8100,1.86125}, {8150,1.89175}, {8200,2.10925}, {8250,1.96300}, {8300,1.97350}, {8350,2.12950}, {8400,2.03075}, {8450,2.05850}, {8500,2.15650}, {8550,2.05850}, {8600,2.14975}, {8650,2.18125}, {8700,2.21350}, {8750,2.24050}, {8800,2.22450}, {8850,2.36650}, {8900,2.34800}, {8950,2.38250}, {9000,2.28200}, {9050,2.43725}, {9100,2.49100}, {9150,2.26450}, {9200,2.52750}, {9250,2.56650}, {9300,2.59525}, {9350,2.63350}, {9400,2.67000}, {9450,2.70400}, {9500,2.72825}, {9550,2.74000}, {9600,2.80850}, {9650,2.85150}, {9700,2.89375}, {9750,2.91000}, {9800,2.95050}, {9850,2.94375}, {9900,3.00250}, {9950,2.91150}, {10000,2.98275}, {10100,3.1540}, {10200,3.2255}, {10300,3.2760}, {10400,3.3810}, {10500,3.472}, {10600,3.539}, {10700,3.62}, {10800,3.696}, {10900,3.139}, {11000,3.788}, {11100,3.731}, {11200,3.947}, {11300,4.052}, {11400,4.123}, {11500,4.187}, {11600,4.271}, {11700,4.283}, {11800,4.447}, {11900,4.523}, {12000,4.599}, {12100,4.72}, {12200,4.792}, {12300,4.968}, {12400,5.019}, {12500,5.107}, {12600,5.228}, {12700,5.299}, {12800,5.412}, {12900,5.46}, {13000,5.571}, {13100,5.659}, {13200,5.755}, {13300,5.868}, {13400,5.963}, {13500,6.043}, {13600,6.159}, {13700,6.275}, {13800,6.36}, {13900,6.428}, {14000,6.559}, {14100,6.639}, {14200,6.78}, {14300,6.851}, {14400,6.939}, {14500,7.215}, {14600,7.155}, {14700,7.284}, {14800,7.36}, {14900,7.775}, {15000,7.579}, {15100,7.728}, {15200,7.8}, {15300,7.899}, {15400,8.003}, {15500,8.168}, {15600,8.235}, {15700,8.351}, {15800,8.444}, {15900,8.6}, {16000,8.716}, {16100,8.795}, {16200,8.903}, {16300,9.347}, {16400,9.159}, {16500,9.307}, {16600,9.367}, {16700,9.507}, {16800,9.631}, {16900,9.764}, {17000,9.899}, {17100,10.228}, {17200,10.1}, {17300,10.24}, {17400,10.372}, {17500,10.46}, {17600,10.875}, {17700,10.724}, {17800,11.212}, {17900,10.971}, {18000,11.112}, {18100,11.219}, {18200,11.355}, {18300,11.555}, {18400,11.592}, {18500,11.787}, {18600,12.055}, {18700,12.372}, {18800,12.26}, {18900,12.316}, {19000,12.407}, {19100,12.591}, {19200,12.796}, {19300,12.815}, {19400,12.956}, {19500,13.119}, {19600,13.264}, {19700,13.388}, {19800,13.603}, {19900,13.775}};
data["big"]["identity cbn"]["Stats"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00003636}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00003636}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00006364}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00002727}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00003636}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00006364}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00003636}, {150,0.00000000}, {151,0.00003636}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00003636}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00003636}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00003636}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00003636}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00003636}, {207,0.00003636}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00003636}, {218,0.00000000}, {219,0.00007273}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00007273}, {229,0.00000000}, {230,0.00003636}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00003636}, {239,0.00000000}, {240,0.00003636}, {241,0.00003636}, {242,0.00007273}, {243,0.00000000}, {244,0.00000000}, {245,0.00003636}, {246,0.00003636}, {247,0.00003636}, {248,0.00000000}, {249,0.00003636}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00003636}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00003636}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00007273}, {266,0.00003636}, {267,0.00003636}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00003636}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00003636}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00002727}, {283,0.00002727}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00002727}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00002727}, {293,0.00000000}, {294,0.00000000}, {295,0.00003636}, {296,0.00007273}, {297,0.00003636}, {298,0.00003636}, {299,0.00000000}, {300,0.00000000}, {301,0.00007273}, {302,0.00007273}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00003636}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00003636}, {321,0.00007273}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00003636}, {347,0.00003636}, {348,0.00002727}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00003636}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00003636}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00003636}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00003636}, {382,0.00003636}, {383,0.00003636}, {384,0.00006364}, {385,0.00003636}, {386,0.00000000}, {387,0.00000000}, {388,0.00003636}, {389,0.00003636}, {390,0.00000000}, {391,0.00002727}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00003636}, {400,0.00003636}, {401,0.00003636}, {402,0.00000000}, {403,0.00003636}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00003636}, {412,0.00000000}, {413,0.00000000}, {414,0.00003636}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00003636}, {421,0.00003636}, {422,0.00003636}, {423,0.00000000}, {424,0.00003636}, {425,0.00003636}, {426,0.00000000}, {427,0.00003636}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00003636}, {440,0.00000000}, {441,0.00003636}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00003636}, {454,0.00000000}, {455,0.00000000}, {456,0.00003636}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003636}, {469,0.00002727}, {470,0.00003636}, {471,0.00000000}, {472,0.00000000}, {473,0.00003636}, {474,0.00002727}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00003636}, {483,0.00003636}, {484,0.00000000}, {485,0.00000000}, {486,0.00007273}, {487,0.00003636}, {488,0.00000000}, {489,0.00003636}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00002727}, {497,0.00003636}, {498,0.00000000}, {499,0.00003636}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00003636}, {540,0.00003636}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00003636}, {570,0.00000000}, {575,0.00000000}, {580,0.00007273}, {585,0.00003636}, {590,0.00000000}, {595,0.00000000}, {600,0.00003636}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00003636}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00003636}, {685,0.00000000}, {690,0.00000000}, {695,0.00003636}, {700,0.00000000}, {705,0.00007273}, {710,0.00000000}, {715,0.00000000}, {720,0.00003636}, {725,0.00000000}, {730,0.00007273}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00003636}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00003636}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00003636}, {805,0.00003636}, {810,0.00007273}, {815,0.00007273}, {820,0.00000000}, {825,0.00003636}, {830,0.00000000}, {835,0.00000000}, {840,0.00007273}, {845,0.00003636}, {850,0.00003636}, {855,0.00000000}, {860,0.00000000}, {865,0.00003636}, {870,0.00003636}, {875,0.00002727}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00007273}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00003636}, {930,0.00000000}, {935,0.00003636}, {940,0.00003636}, {945,0.00000000}, {950,0.00003636}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00003636}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00007273}, {1010,0.00003636}, {1020,0.00007273}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00003636}, {1090,0.00003636}, {1100,0.00000000}, {1110,0.00003636}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00003636}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00003636}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00007273}, {1290,0.00000000}, {1300,0.00003636}, {1310,0.00010909}, {1320,0.00006364}, {1330,0.00010909}, {1340,0.00025455}, {1350,0.00010909}, {1360,0.00003636}, {1370,0.00000000}, {1380,0.00007273}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00003636}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00007273}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00003636}, {1530,0.00000000}, {1540,0.00002727}, {1550,0.00000000}, {1560,0.00002727}, {1570,0.00000000}, {1580,0.00003636}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00002727}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003636}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00003636}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00003636}, {1780,0.00003636}, {1790,0.00006364}, {1800,0.00000000}, {1810,0.00007273}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00003636}, {1890,0.00002727}, {1900,0.00003636}, {1910,0.00000000}, {1920,0.00003636}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00003636}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00010909}, {2250,0.00003636}, {2300,0.00000000}, {2350,0.00003636}, {2400,0.00003636}, {2450,0.00003636}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00003636}, {3000,0.00010000}, {3050,0.00100}, {3100,0.00000}, {3150,0.00000}, {3200,0.00100}, {3250,0.00000}, {3300,0.00000}, {3350,0.00000}, {3400,0.00000}, {3450,0.00000}, {3500,0.00000}, {3550,0.00000}, {3600,0.00000}, {3650,0.00100}, {3700,0.00000}, {3750,0.00000}, {3800,0.00000}, {3850,0.00000}, {3900,0.00000}, {3950,0.00000}, {4000,0.00100}, {4050,0.00000}, {4100,0.00000}, {4150,0.00000}, {4200,0.00000}, {4250,0.00100}, {4300,0.00000}, {4350,0.00000}, {4400,0.00000}, {4450,0.00000}, {4500,0.00000}, {4550,0.00000}, {4600,0.00000}, {4650,0.00000}, {4700,0.00000}, {4750,0.00100}, {4800,0.00000}, {4850,0.00000}, {4900,0.00000}, {4950,0.00000}, {5000,0.00000}, {5050,0.00000}, {5100,0.00000}, {5150,0.00100}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00100}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00100}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00100}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00075}, {7500,0.00000}, {7550,0.00000}, {7600,0.00100}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00100}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00100}, {9100,0.00000}, {9150,0.00100}, {9200,0.00100}, {9250,0.00000}, {9300,0.00100}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00100}, {9600,0.00100}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00100}, {9950,0.00100}, {10000,0.00000}, {10100,0.0000}, {10200,0.0000}, {10300,0.0000}, {10400,0.0000}, {10500,0}, {10600,0}, {10700,0}, {10800,0}, {10900,0.004}, {11000,0}, {11100,0}, {11200,0}, {11300,0}, {11400,0}, {11500,0}, {11600,0}, {11700,0}, {11800,0}, {11900,0}, {12000,0}, {12100,0}, {12200,0}, {12300,0}, {12400,0}, {12500,0}, {12600,0}, {12700,0}, {12800,0}, {12900,0}, {13000,0}, {13100,0}, {13200,0}, {13300,0}, {13400,0}, {13500,0}, {13600,0}, {13700,0}, {13800,0}, {13900,0}, {14000,0}, {14100,0}, {14200,0}, {14300,0}, {14400,0}, {14500,0}, {14600,0}, {14700,0}, {14800,0}, {14900,0}, {15000,0}, {15100,0}, {15200,0}, {15300,0}, {15400,0}, {15500,0}, {15600,0}, {15700,0}, {15800,0}, {15900,0}, {16000,0}, {16100,0}, {16200,0}, {16300,0}, {16400,0}, {16500,0}, {16600,0}, {16700,0}, {16800,0}, {16900,0}, {17000,0}, {17100,0}, {17200,0}, {17300,0}, {17400,0}, {17500,0}, {17600,0}, {17700,0}, {17800,0}, {17900,0}, {18000,0}, {18100,0}, {18200,0}, {18300,0}, {18400,0}, {18500,0}, {18600,0}, {18700,0}, {18800,0}, {18900,0}, {19000,0}, {19100,0}, {19200,0}, {19300,0}, {19400,0}, {19500,0}, {19600,0}, {19700,0}, {19800,0}, {19900,0}};
data["big"]["identity cbv"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000909}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00096364}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00001818}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00001818}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00153636}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00001818}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00003636}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00001818}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00003636}, {925,0.00000000}, {930,0.00000000}, {935,0.00001818}, {940,0.00001818}, {945,0.00001818}, {950,0.00002727}, {955,0.00003636}, {960,0.00004545}, {965,0.00006364}, {970,0.00007273}, {975,0.00003636}, {980,0.00012727}, {985,0.00015455}, {990,0.00020000}, {995,0.00058182}, {1000,0.00020000}, {1010,0.00036364}, {1020,0.00047273}, {1030,0.00053636}, {1040,0.00060000}, {1050,0.00064545}, {1060,0.00070909}, {1070,0.00071818}, {1080,0.00074545}, {1090,0.00075455}, {1100,0.00079091}, {1110,0.00081818}, {1120,0.00085455}, {1130,0.00085455}, {1140,0.00087273}, {1150,0.00090000}, {1160,0.00094545}, {1170,0.00094545}, {1180,0.00096364}, {1190,0.00098182}, {1200,0.00100000}, {1210,0.00100000}, {1220,0.00103636}, {1230,0.00100000}, {1240,0.00100000}, {1250,0.00100000}, {1260,0.00100000}, {1270,0.00100000}, {1280,0.00100000}, {1290,0.00100000}, {1300,0.00100000}, {1310,0.00100000}, {1320,0.00100000}, {1330,0.00100000}, {1340,0.00100000}, {1350,0.00100000}, {1360,0.00100000}, {1370,0.00100000}, {1380,0.00470909}, {1390,0.00100000}, {1400,0.00100000}, {1410,0.00100000}, {1420,0.00100000}, {1430,0.00100000}, {1440,0.00100000}, {1450,0.00100000}, {1460,0.00100000}, {1470,0.00100000}, {1480,0.00100000}, {1490,0.00100000}, {1500,0.00100000}, {1510,0.00100000}, {1520,0.00100000}, {1530,0.00100000}, {1540,0.00100000}, {1550,0.00100000}, {1560,0.00100000}, {1570,0.00100000}, {1580,0.00100000}, {1590,0.00100000}, {1600,0.00100000}, {1610,0.00100000}, {1620,0.00348182}, {1630,0.00100000}, {1640,0.00100000}, {1650,0.00100000}, {1660,0.00100000}, {1670,0.00100000}, {1680,0.00100000}, {1690,0.00100000}, {1700,0.00100000}, {1710,0.00100000}, {1720,0.00100000}, {1730,0.00100000}, {1740,0.00100000}, {1750,0.00101818}, {1760,0.00100000}, {1770,0.00100000}, {1780,0.00100000}, {1790,0.00101818}, {1800,0.00100000}, {1810,0.00100000}, {1820,0.00100000}, {1830,0.00118182}, {1840,0.00100000}, {1850,0.00100000}, {1860,0.00100000}, {1870,0.00100000}, {1880,0.00100000}, {1890,0.00101818}, {1900,0.00100000}, {1910,0.00108182}, {1920,0.00100909}, {1930,0.00101818}, {1940,0.00100909}, {1950,0.00106364}, {1960,0.00106364}, {1970,0.00110909}, {1980,0.00107273}, {1990,0.00113636}, {2000,0.00111818}, {2050,0.00135455}, {2100,0.00140000}, {2150,0.00150909}, {2200,0.00164545}, {2250,0.00817273}, {2300,0.00190000}, {2350,0.00192727}, {2400,0.00192727}, {2450,0.00195455}, {2500,0.00200000}, {2550,0.00200000}, {2600,0.00200000}, {2650,0.00200909}, {2700,0.00200909}, {2750,0.00200909}, {2800,0.00229091}, {2850,0.00200000}, {2900,0.00203636}, {2950,0.00206364}, {3000,0.00220909}, {3050,0.00225}, {3100,0.00200}, {3150,0.00250}, {3200,0.00250}, {3250,0.00250}, {3300,0.00250}, {3350,0.00275}, {3400,0.00275}, {3450,0.00275}, {3500,0.00300}, {3550,0.00300}, {3600,0.00300}, {3650,0.00300}, {3700,0.00300}, {3750,0.00300}, {3800,0.00300}, {3850,0.00300}, {3900,0.00300}, {3950,0.00350}, {4000,0.00300}, {4050,0.00325}, {4100,0.00325}, {4150,0.00350}, {4200,0.00400}, {4250,0.00350}, {4300,0.00375}, {4350,0.00350}, {4400,0.00350}, {4450,0.00400}, {4500,0.00375}, {4550,0.00375}, {4600,0.00400}, {4650,0.00425}, {4700,0.00400}, {4750,0.00400}, {4800,0.00400}, {4850,0.00450}, {4900,0.00400}, {4950,0.00425}, {5000,0.00425}, {5050,0.00475}, {5100,0.00900}, {5150,0.00500}, {5200,0.00500}, {5250,0.00500}, {5300,0.00500}, {5350,0.00500}, {5400,0.00500}, {5450,0.00500}, {5500,0.00475}, {5550,0.00500}, {5600,0.01000}, {5650,0.00550}, {5700,0.00500}, {5750,0.00525}, {5800,0.00500}, {5850,0.00600}, {5900,0.00550}, {5950,0.00525}, {6000,0.00575}, {6050,0.00500}, {6100,0.00550}, {6150,0.00575}, {6200,0.00625}, {6250,0.00575}, {6300,0.00550}, {6350,0.00550}, {6400,0.00550}, {6450,0.00525}, {6500,0.00550}, {6550,0.00650}, {6600,0.00575}, {6650,0.00575}, {6700,0.00675}, {6750,0.00625}, {6800,0.00650}, {6850,0.00675}, {6900,0.00625}, {6950,0.00625}, {7000,0.00725}, {7050,0.00700}, {7100,0.01100}, {7150,0.00725}, {7200,0.00675}, {7250,0.00675}, {7300,0.00775}, {7350,0.00675}, {7400,0.00675}, {7450,0.00775}, {7500,0.00725}, {7550,0.00700}, {7600,0.01075}, {7650,0.00700}, {7700,0.00725}, {7750,0.00850}, {7800,0.00800}, {7850,0.00750}, {7900,0.00775}, {7950,0.00800}, {8000,0.00775}, {8050,0.00800}, {8100,0.00800}, {8150,0.01725}, {8200,0.02000}, {8250,0.00800}, {8300,0.00850}, {8350,0.00775}, {8400,0.00750}, {8450,0.00775}, {8500,0.01825}, {8550,0.01875}, {8600,0.00750}, {8650,0.00750}, {8700,0.00825}, {8750,0.00775}, {8800,0.00825}, {8850,0.00775}, {8900,0.00800}, {8950,0.00825}, {9000,0.01100}, {9050,0.01025}, {9100,0.00825}, {9150,0.01350}, {9200,0.00800}, {9250,0.00800}, {9300,0.00850}, {9350,0.00875}, {9400,0.00975}, {9450,0.00900}, {9500,0.00825}, {9550,0.01300}, {9600,0.00875}, {9650,0.01000}, {9700,0.01325}, {9750,0.00950}, {9800,0.00850}, {9850,0.01725}, {9900,0.01425}, {9950,0.00925}, {10000,0.00950}, {10100,0.0090}, {10200,0.0085}, {10300,0.0090}, {10400,0.0115}, {10500,0.01}, {10600,0.011}, {10700,0.01}, {10800,0.01}, {10900,0.01}, {11000,0.009}, {11100,0.01}, {11200,0.009}, {11300,0.011}, {11400,0.02}, {11500,0.01}, {11600,0.01}, {11700,0.01}, {11800,0.01}, {11900,0.01}, {12000,0.018}, {12100,0.019}, {12200,0.01}, {12300,0.011}, {12400,0.023}, {12500,0.013}, {12600,0.012}, {12700,0.012}, {12800,0.014}, {12900,0.012}, {13000,0.038}, {13100,0.014}, {13200,0.012}, {13300,0.035}, {13400,0.043}, {13500,0.012}, {13600,0.013}, {13700,0.013}, {13800,0.013}, {13900,0.024}, {14000,0.048}, {14100,0.042}, {14200,0.014}, {14300,0.014}, {14400,0.045}, {14500,0.015}, {14600,0.014}, {14700,0.014}, {14800,0.014}, {14900,0.015}, {15000,0.065}, {15100,0.015}, {15200,0.014}, {15300,0.057}, {15400,0.056}, {15500,0.025}, {15600,0.016}, {15700,0.016}, {15800,0.016}, {15900,0.025}, {16000,0.015}, {16100,0.061}, {16200,0.025}, {16300,0.016}, {16400,0.016}, {16500,0.016}, {16600,0.016}, {16700,0.017}, {16800,0.017}, {16900,0.017}, {17000,0.017}, {17100,0.017}, {17200,0.032}, {17300,0.064}, {17400,0.017}, {17500,0.042}, {17600,0.02}, {17700,0.017}, {17800,0.018}, {17900,0.037}, {18000,0.061}, {18100,0.06}, {18200,0.031}, {18300,0.018}, {18400,0.074}, {18500,0.018}, {18600,0.019}, {18700,0.018}, {18800,0.018}, {18900,0.018}, {19000,0.063}, {19100,0.02}, {19200,0.039}, {19300,0.066}, {19400,0.106}, {19500,0.032}, {19600,0.019}, {19700,0.019}, {19800,0.02}, {19900,0.032}};
data["big"]["identity cbv"]["Stats"]["user"] = {{1,0.00000000}, {2,0.00005455}, {3,0.00000000}, {4,0.00003636}, {5,0.00006364}, {6,0.00000000}, {7,0.00009091}, {8,0.00000000}, {9,0.00003636}, {10,0.00000000}, {11,0.00002727}, {12,0.00005455}, {13,0.00015455}, {14,0.00000000}, {15,0.00000000}, {16,0.00003636}, {17,0.00003636}, {18,0.00008182}, {19,0.00000000}, {20,0.00011818}, {21,0.00008182}, {22,0.00002727}, {23,0.00006364}, {24,0.00000000}, {25,0.00005455}, {26,0.00000000}, {27,0.00010000}, {28,0.00003636}, {29,0.00012727}, {30,0.00005455}, {31,0.00002727}, {32,0.00011818}, {33,0.00011818}, {34,0.00007273}, {35,0.00009091}, {36,0.00006364}, {37,0.00006364}, {38,0.00007273}, {39,0.00008182}, {40,0.00012727}, {41,0.00002727}, {42,0.00019091}, {43,0.00011818}, {44,0.00013636}, {45,0.00008182}, {46,0.00002727}, {47,0.00009091}, {48,0.00012727}, {49,0.00025455}, {50,0.00013636}, {51,0.00008182}, {52,0.00003636}, {53,0.00005455}, {54,0.00008182}, {55,0.00003636}, {56,0.00008182}, {57,0.00008182}, {58,0.00002727}, {59,0.00019091}, {60,0.00002727}, {61,0.00015455}, {62,0.00008182}, {63,0.00012727}, {64,0.00031818}, {65,0.00005455}, {66,0.00008182}, {67,0.00009091}, {68,0.00003636}, {69,0.00012727}, {70,0.00018182}, {71,0.00010000}, {72,0.00008182}, {73,0.00029091}, {74,0.00016364}, {75,0.00019091}, {76,0.00006364}, {77,0.00012727}, {78,0.00013636}, {79,0.00010909}, {80,0.00020000}, {81,0.00018182}, {82,0.00012727}, {83,0.00021818}, {84,0.00010909}, {85,0.00014545}, {86,0.00009091}, {87,0.00003636}, {88,0.00018182}, {89,0.00012727}, {90,0.00007273}, {91,0.00019091}, {92,0.00010909}, {93,0.00008182}, {94,0.00009091}, {95,0.00018182}, {96,0.00008182}, {97,0.00014545}, {98,0.00014545}, {99,0.00005455}, {100,0.00021818}, {101,0.00006364}, {102,0.00018182}, {103,0.00010909}, {104,0.00009091}, {105,0.00023636}, {106,0.00009091}, {107,0.00010000}, {108,0.00011818}, {109,0.00013636}, {110,0.00008182}, {111,0.00005455}, {112,0.00026364}, {113,0.00010000}, {114,0.00015455}, {115,0.00006364}, {116,0.00008182}, {117,0.00022727}, {118,0.00011818}, {119,0.00015455}, {120,0.00010000}, {121,0.00016364}, {122,0.00006364}, {123,0.00005455}, {124,0.00014545}, {125,0.00016364}, {126,0.00014545}, {127,0.00011818}, {128,0.00017273}, {129,0.00017273}, {130,0.00008182}, {131,0.00028182}, {132,0.00020909}, {133,0.00008182}, {134,0.00024545}, {135,0.00025455}, {136,0.00020909}, {137,0.00016364}, {138,0.00009091}, {139,0.00027273}, {140,0.00011818}, {141,0.00009091}, {142,0.00025455}, {143,0.00032727}, {144,0.00010000}, {145,0.00014545}, {146,0.00019091}, {147,0.00023636}, {148,0.00011818}, {149,0.00014545}, {150,0.00015455}, {151,0.00031818}, {152,0.00012727}, {153,0.00010909}, {154,0.00014545}, {155,0.00008182}, {156,0.00014545}, {157,0.00010909}, {158,0.00017273}, {159,0.00025455}, {160,0.00024545}, {161,0.00011818}, {162,0.00022727}, {163,0.00015455}, {164,0.00023636}, {165,0.00010000}, {166,0.00030000}, {167,0.00027273}, {168,0.00014545}, {169,0.00014545}, {170,0.00014545}, {171,0.00039091}, {172,0.00012727}, {173,0.00003636}, {174,0.00013636}, {175,0.00016364}, {176,0.00036364}, {177,0.00026364}, {178,0.00020909}, {179,0.00022727}, {180,0.00012727}, {181,0.00016364}, {182,0.00017273}, {183,0.00010000}, {184,0.00019091}, {185,0.00018182}, {186,0.00098182}, {187,0.00020909}, {188,0.00005455}, {189,0.00024545}, {190,0.00009091}, {191,0.00018182}, {192,0.00008182}, {193,0.00003636}, {194,0.00026364}, {195,0.00019091}, {196,0.00000000}, {197,0.00023636}, {198,0.00026364}, {199,0.00016364}, {200,0.00023636}, {201,0.00036364}, {202,0.00027273}, {203,0.00019091}, {204,0.00027273}, {205,0.00017273}, {206,0.00032727}, {207,0.00034545}, {208,0.00021818}, {209,0.00029091}, {210,0.00040000}, {211,0.00014545}, {212,0.00036364}, {213,0.00025455}, {214,0.00028182}, {215,0.00031818}, {216,0.00023636}, {217,0.00023636}, {218,0.00032727}, {219,0.00024545}, {220,0.00016364}, {221,0.00013636}, {222,0.00014545}, {223,0.00028182}, {224,0.00030000}, {225,0.00010000}, {226,0.00014545}, {227,0.00027273}, {228,0.00024545}, {229,0.00031818}, {230,0.00034545}, {231,0.00022727}, {232,0.00026364}, {233,0.00030000}, {234,0.00019091}, {235,0.00017273}, {236,0.00028182}, {237,0.00017273}, {238,0.00014545}, {239,0.00011818}, {240,0.00025455}, {241,0.00029091}, {242,0.00014545}, {243,0.00011818}, {244,0.00028182}, {245,0.00020000}, {246,0.00025455}, {247,0.00023636}, {248,0.00021818}, {249,0.00029091}, {250,0.00022727}, {251,0.00026364}, {252,0.00027273}, {253,0.00031818}, {254,0.00020909}, {255,0.00028182}, {256,0.00010909}, {257,0.00032727}, {258,0.00015455}, {259,0.00011818}, {260,0.00021818}, {261,0.00019091}, {262,0.00019091}, {263,0.00027273}, {264,0.00033636}, {265,0.00018182}, {266,0.00034545}, {267,0.00024545}, {268,0.00024545}, {269,0.00015455}, {270,0.00021818}, {271,0.00032727}, {272,0.00022727}, {273,0.00016364}, {274,0.00019091}, {275,0.00025455}, {276,0.00049091}, {277,0.00012727}, {278,0.00040909}, {279,0.00020000}, {280,0.00029091}, {281,0.00020909}, {282,0.00027273}, {283,0.00030909}, {284,0.00021818}, {285,0.00012727}, {286,0.00011818}, {287,0.00015455}, {288,0.00025455}, {289,0.00017273}, {290,0.00017273}, {291,0.00030909}, {292,0.00024545}, {293,0.00020909}, {294,0.00005455}, {295,0.00053636}, {296,0.00020909}, {297,0.00026364}, {298,0.00017273}, {299,0.00038182}, {300,0.00019091}, {301,0.00031818}, {302,0.00027273}, {303,0.00041818}, {304,0.00042727}, {305,0.00029091}, {306,0.00011818}, {307,0.00047273}, {308,0.00033636}, {309,0.00021818}, {310,0.00033636}, {311,0.00036364}, {312,0.00036364}, {313,0.00041818}, {314,0.00038182}, {315,0.00017273}, {316,0.00030909}, {317,0.00014545}, {318,0.00038182}, {319,0.00030000}, {320,0.00022727}, {321,0.00020000}, {322,0.00020000}, {323,0.00021818}, {324,0.00048182}, {325,0.00014545}, {326,0.00036364}, {327,0.00035455}, {328,0.00026364}, {329,0.00020909}, {330,0.00031818}, {331,0.00038182}, {332,0.00035455}, {333,0.00027273}, {334,0.00022727}, {335,0.00020909}, {336,0.00034545}, {337,0.00040000}, {338,0.00020909}, {339,0.00033636}, {340,0.00024545}, {341,0.00031818}, {342,0.00040909}, {343,0.00029091}, {344,0.00038182}, {345,0.00024545}, {346,0.00020000}, {347,0.00033636}, {348,0.00036364}, {349,0.00028182}, {350,0.00034545}, {351,0.00027273}, {352,0.00040000}, {353,0.00031818}, {354,0.00011818}, {355,0.00037273}, {356,0.00035455}, {357,0.00034545}, {358,0.00016364}, {359,0.00022727}, {360,0.00022727}, {361,0.00040000}, {362,0.00043636}, {363,0.00021818}, {364,0.00022727}, {365,0.00040909}, {366,0.00022727}, {367,0.00035455}, {368,0.00024545}, {369,0.00040000}, {370,0.00038182}, {371,0.00042727}, {372,0.00030909}, {373,0.00040909}, {374,0.00035455}, {375,0.00042727}, {376,0.00028182}, {377,0.00038182}, {378,0.00037273}, {379,0.00031818}, {380,0.00041818}, {381,0.00050000}, {382,0.00027273}, {383,0.00019091}, {384,0.00039091}, {385,0.00042727}, {386,0.00033636}, {387,0.00043636}, {388,0.00035455}, {389,0.00053636}, {390,0.00029091}, {391,0.00032727}, {392,0.00030909}, {393,0.00047273}, {394,0.00034545}, {395,0.00037273}, {396,0.00032727}, {397,0.00063636}, {398,0.00065455}, {399,0.00050909}, {400,0.00034545}, {401,0.00035455}, {402,0.00047273}, {403,0.00031818}, {404,0.00050909}, {405,0.00046364}, {406,0.00051818}, {407,0.00029091}, {408,0.00051818}, {409,0.00034545}, {410,0.00025455}, {411,0.00020909}, {412,0.00043636}, {413,0.00030909}, {414,0.00032727}, {415,0.00034545}, {416,0.00031818}, {417,0.00023636}, {418,0.00023636}, {419,0.00047273}, {420,0.00028182}, {421,0.00030909}, {422,0.00023636}, {423,0.00043636}, {424,0.00035455}, {425,0.00038182}, {426,0.00033636}, {427,0.00037273}, {428,0.00024545}, {429,0.00036364}, {430,0.00060909}, {431,0.00040909}, {432,0.00051818}, {433,0.00045455}, {434,0.00028182}, {435,0.00037273}, {436,0.00037273}, {437,0.00041818}, {438,0.00031818}, {439,0.00040000}, {440,0.00036364}, {441,0.00035455}, {442,0.00030000}, {443,0.00050000}, {444,0.00027273}, {445,0.00033636}, {446,0.00032727}, {447,0.00041818}, {448,0.00016364}, {449,0.00044545}, {450,0.00027273}, {451,0.00053636}, {452,0.00036364}, {453,0.00040909}, {454,0.00036364}, {455,0.00044545}, {456,0.00035455}, {457,0.00028182}, {458,0.00044545}, {459,0.00041818}, {460,0.00050000}, {461,0.00033636}, {462,0.00040000}, {463,0.00046364}, {464,0.00033636}, {465,0.00036364}, {466,0.00021818}, {467,0.00035455}, {468,0.00036364}, {469,0.00050000}, {470,0.00031818}, {471,0.00042727}, {472,0.00040909}, {473,0.00036364}, {474,0.00066364}, {475,0.00026364}, {476,0.00032727}, {477,0.00025455}, {478,0.00035455}, {479,0.00035455}, {480,0.00050000}, {481,0.00043636}, {482,0.00036364}, {483,0.00038182}, {484,0.00053636}, {485,0.00035455}, {486,0.00054545}, {487,0.00035455}, {488,0.00033636}, {489,0.00030909}, {490,0.00048182}, {491,0.00042727}, {492,0.00042727}, {493,0.00033636}, {494,0.00044545}, {495,0.00067273}, {496,0.00032727}, {497,0.00049091}, {498,0.00062727}, {499,0.00038182}, {500,0.00024545}, {505,0.00054545}, {510,0.00050000}, {515,0.00036364}, {520,0.00041818}, {525,0.00042727}, {530,0.00183636}, {535,0.00054545}, {540,0.00055455}, {545,0.00026364}, {550,0.00050909}, {555,0.00040000}, {560,0.00062727}, {565,0.00026364}, {570,0.00057273}, {575,0.00055455}, {580,0.00058182}, {585,0.00063636}, {590,0.00055455}, {595,0.00050909}, {600,0.00053636}, {605,0.00070909}, {610,0.00039091}, {615,0.00047273}, {620,0.00074545}, {625,0.00034545}, {630,0.00048182}, {635,0.00060000}, {640,0.00038182}, {645,0.00060000}, {650,0.00071818}, {655,0.00060000}, {660,0.00060909}, {665,0.00050000}, {670,0.00042727}, {675,0.00070909}, {680,0.00079091}, {685,0.00039091}, {690,0.00065455}, {695,0.00070000}, {700,0.00068182}, {705,0.00060909}, {710,0.00051818}, {715,0.00060909}, {720,0.00059091}, {725,0.00041818}, {730,0.00074545}, {735,0.00080909}, {740,0.00085455}, {745,0.00059091}, {750,0.00091818}, {755,0.00074545}, {760,0.00070000}, {765,0.00043636}, {770,0.00063636}, {775,0.00076364}, {780,0.00080909}, {785,0.00082727}, {790,0.00044545}, {795,0.00066364}, {800,0.00071818}, {805,0.00084545}, {810,0.00096364}, {815,0.00053636}, {820,0.00096364}, {825,0.00067273}, {830,0.00072727}, {835,0.00070000}, {840,0.00062727}, {845,0.00080909}, {850,0.00067273}, {855,0.00089091}, {860,0.00072727}, {865,0.00071818}, {870,0.00103636}, {875,0.00094545}, {880,0.00096364}, {885,0.00070909}, {890,0.00069091}, {895,0.00102727}, {900,0.00100000}, {905,0.00095455}, {910,0.00071818}, {915,0.00060909}, {920,0.00070909}, {925,0.00082727}, {930,0.00074545}, {935,0.00097273}, {940,0.00079091}, {945,0.00056364}, {950,0.00096364}, {955,0.00106364}, {960,0.00089091}, {965,0.00098182}, {970,0.00088182}, {975,0.00079091}, {980,0.00088182}, {985,0.00108182}, {990,0.00075455}, {995,0.00096364}, {1000,0.00120000}, {1010,0.00097273}, {1020,0.00095455}, {1030,0.00088182}, {1040,0.00088182}, {1050,0.00117273}, {1060,0.00077273}, {1070,0.00099091}, {1080,0.00100909}, {1090,0.00075455}, {1100,0.00104545}, {1110,0.00106364}, {1120,0.00134545}, {1130,0.00118182}, {1140,0.00096364}, {1150,0.00110000}, {1160,0.00090909}, {1170,0.00109091}, {1180,0.00095455}, {1190,0.00089091}, {1200,0.00112727}, {1210,0.00098182}, {1220,0.00103636}, {1230,0.00127273}, {1240,0.00095455}, {1250,0.00112727}, {1260,0.00103636}, {1270,0.00102727}, {1280,0.00127273}, {1290,0.00140000}, {1300,0.00083636}, {1310,0.00115455}, {1320,0.00075455}, {1330,0.00140909}, {1340,0.00137273}, {1350,0.00116364}, {1360,0.00073636}, {1370,0.00129091}, {1380,0.00445455}, {1390,0.00143636}, {1400,0.00135455}, {1410,0.00130909}, {1420,0.00136364}, {1430,0.00162727}, {1440,0.00100909}, {1450,0.00120000}, {1460,0.00112727}, {1470,0.00135455}, {1480,0.00111818}, {1490,0.00141818}, {1500,0.00122727}, {1510,0.00170000}, {1520,0.00140909}, {1530,0.00106364}, {1540,0.00123636}, {1550,0.00120000}, {1560,0.00120000}, {1570,0.00138182}, {1580,0.00147273}, {1590,0.00159091}, {1600,0.00120909}, {1610,0.00164545}, {1620,0.00330000}, {1630,0.00138182}, {1640,0.00150000}, {1650,0.00158182}, {1660,0.00122727}, {1670,0.00117273}, {1680,0.00166364}, {1690,0.00151818}, {1700,0.00121818}, {1710,0.00140000}, {1720,0.00160909}, {1730,0.00149091}, {1740,0.00159091}, {1750,0.00157273}, {1760,0.00170909}, {1770,0.00154545}, {1780,0.00191818}, {1790,0.00157273}, {1800,0.00151818}, {1810,0.00138182}, {1820,0.00181818}, {1830,0.00160909}, {1840,0.00160000}, {1850,0.00164545}, {1860,0.00159091}, {1870,0.00152727}, {1880,0.00175455}, {1890,0.00162727}, {1900,0.00156364}, {1910,0.00178182}, {1920,0.00172727}, {1930,0.00152727}, {1940,0.00191818}, {1950,0.00166364}, {1960,0.00153636}, {1970,0.00152727}, {1980,0.00174545}, {1990,0.00161818}, {2000,0.00158182}, {2050,0.00160909}, {2100,0.00165455}, {2150,0.00215455}, {2200,0.00200909}, {2250,0.00844545}, {2300,0.00170909}, {2350,0.00217273}, {2400,0.00215455}, {2450,0.00217273}, {2500,0.00193636}, {2550,0.00192727}, {2600,0.00210909}, {2650,0.00211818}, {2700,0.00206364}, {2750,0.00261818}, {2800,0.00247273}, {2850,0.00268182}, {2900,0.00262727}, {2950,0.00233636}, {3000,0.00249091}, {3050,0.00150}, {3100,0.00250}, {3150,0.00400}, {3200,0.00250}, {3250,0.00350}, {3300,0.00225}, {3350,0.00225}, {3400,0.00225}, {3450,0.00175}, {3500,0.00300}, {3550,0.00300}, {3600,0.00300}, {3650,0.00325}, {3700,0.00375}, {3750,0.00325}, {3800,0.00275}, {3850,0.00350}, {3900,0.00350}, {3950,0.00325}, {4000,0.00275}, {4050,0.00325}, {4100,0.00350}, {4150,0.00350}, {4200,0.00350}, {4250,0.00325}, {4300,0.00350}, {4350,0.00350}, {4400,0.00350}, {4450,0.00375}, {4500,0.00425}, {4550,0.00550}, {4600,0.00400}, {4650,0.00475}, {4700,0.00400}, {4750,0.00450}, {4800,0.00375}, {4850,0.00375}, {4900,0.00650}, {4950,0.00425}, {5000,0.00525}, {5050,0.00475}, {5100,0.00975}, {5150,0.00500}, {5200,0.00550}, {5250,0.00475}, {5300,0.00400}, {5350,0.00475}, {5400,0.00375}, {5450,0.00475}, {5500,0.00400}, {5550,0.00475}, {5600,0.01050}, {5650,0.00525}, {5700,0.00600}, {5750,0.00475}, {5800,0.00375}, {5850,0.00650}, {5900,0.00675}, {5950,0.00600}, {6000,0.00675}, {6050,0.00500}, {6100,0.00600}, {6150,0.00500}, {6200,0.00575}, {6250,0.00500}, {6300,0.00600}, {6350,0.00775}, {6400,0.00575}, {6450,0.00575}, {6500,0.00600}, {6550,0.00600}, {6600,0.00550}, {6650,0.00575}, {6700,0.00775}, {6750,0.00550}, {6800,0.00575}, {6850,0.00675}, {6900,0.00750}, {6950,0.00550}, {7000,0.00775}, {7050,0.00700}, {7100,0.01075}, {7150,0.00800}, {7200,0.00650}, {7250,0.00800}, {7300,0.00775}, {7350,0.00650}, {7400,0.00775}, {7450,0.00850}, {7500,0.00800}, {7550,0.00800}, {7600,0.01075}, {7650,0.00750}, {7700,0.00775}, {7750,0.01025}, {7800,0.00850}, {7850,0.00775}, {7900,0.00775}, {7950,0.00800}, {8000,0.00800}, {8050,0.00775}, {8100,0.00800}, {8150,0.01800}, {8200,0.01975}, {8250,0.00850}, {8300,0.00825}, {8350,0.00775}, {8400,0.00750}, {8450,0.00875}, {8500,0.01950}, {8550,0.01850}, {8600,0.00775}, {8650,0.00775}, {8700,0.00800}, {8750,0.00800}, {8800,0.00950}, {8850,0.00775}, {8900,0.00800}, {8950,0.00800}, {9000,0.00950}, {9050,0.01050}, {9100,0.00775}, {9150,0.01350}, {9200,0.00725}, {9250,0.00850}, {9300,0.00750}, {9350,0.00875}, {9400,0.00925}, {9450,0.00825}, {9500,0.00900}, {9550,0.01350}, {9600,0.00875}, {9650,0.01075}, {9700,0.01500}, {9750,0.01075}, {9800,0.00950}, {9850,0.01750}, {9900,0.01525}, {9950,0.00975}, {10000,0.00975}, {10100,0.0095}, {10200,0.0120}, {10300,0.0070}, {10400,0.0120}, {10500,0.012}, {10600,0.012}, {10700,0.012}, {10800,0.007}, {10900,0.012}, {11000,0.012}, {11100,0.007}, {11200,0.008}, {11300,0.011}, {11400,0.019}, {11500,0.011}, {11600,0.011}, {11700,0.011}, {11800,0.008}, {11900,0.011}, {12000,0.016}, {12100,0.019}, {12200,0.007}, {12300,0.011}, {12400,0.024}, {12500,0.012}, {12600,0.011}, {12700,0.011}, {12800,0.015}, {12900,0.011}, {13000,0.039}, {13100,0.015}, {13200,0.015}, {13300,0.036}, {13400,0.044}, {13500,0.012}, {13600,0.011}, {13700,0.012}, {13800,0.016}, {13900,0.023}, {14000,0.047}, {14100,0.043}, {14200,0.011}, {14300,0.015}, {14400,0.043}, {14500,0.011}, {14600,0.015}, {14700,0.016}, {14800,0.016}, {14900,0.012}, {15000,0.063}, {15100,0.016}, {15200,0.016}, {15300,0.059}, {15400,0.056}, {15500,0.027}, {15600,0.016}, {15700,0.016}, {15800,0.015}, {15900,0.024}, {16000,0.015}, {16100,0.059}, {16200,0.028}, {16300,0.016}, {16400,0.016}, {16500,0.02}, {16600,0.015}, {16700,0.016}, {16800,0.019}, {16900,0.015}, {17000,0.015}, {17100,0.02}, {17200,0.032}, {17300,0.064}, {17400,0.019}, {17500,0.043}, {17600,0.019}, {17700,0.015}, {17800,0.016}, {17900,0.039}, {18000,0.059}, {18100,0.059}, {18200,0.032}, {18300,0.019}, {18400,0.072}, {18500,0.016}, {18600,0.019}, {18700,0.019}, {18800,0.02}, {18900,0.015}, {19000,0.064}, {19100,0.023}, {19200,0.039}, {19300,0.064}, {19400,0.108}, {19500,0.032}, {19600,0.02}, {19700,0.02}, {19800,0.02}, {19900,0.032}};
data["big"]["identity cbv"]["Stats"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00003636}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00003636}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00003636}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00003636}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00002727}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00003636}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00003636}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00003636}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00003636}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00003636}, {175,0.00000000}, {176,0.00003636}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00007273}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00002727}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00003636}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00002727}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00002727}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00003636}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00003636}, {334,0.00003636}, {335,0.00003636}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00003636}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00007273}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00003636}, {389,0.00002727}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00003636}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00003636}, {409,0.00000000}, {410,0.00003636}, {411,0.00000000}, {412,0.00000000}, {413,0.00003636}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00003636}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00003636}, {447,0.00000000}, {448,0.00000000}, {449,0.00003636}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00002727}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00003636}, {461,0.00000000}, {462,0.00003636}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00003636}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00003636}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00003636}, {485,0.00000000}, {486,0.00000000}, {487,0.00002727}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00003636}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00007273}, {510,0.00003636}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00003636}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00003636}, {595,0.00003636}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00003636}, {665,0.00000000}, {670,0.00003636}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00002727}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00003636}, {725,0.00003636}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00003636}, {755,0.00000000}, {760,0.00000000}, {765,0.00003636}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00003636}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00003636}, {845,0.00000000}, {850,0.00003636}, {855,0.00000000}, {860,0.00003636}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00003636}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00003636}, {985,0.00003636}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00003636}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00003636}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00003636}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00003636}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00003636}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00003636}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00003636}, {1380,0.00018182}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00003636}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003636}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00014545}, {1630,0.00000000}, {1640,0.00003636}, {1650,0.00000000}, {1660,0.00007273}, {1670,0.00003636}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00002727}, {1740,0.00003636}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00003636}, {1820,0.00000000}, {1830,0.00003636}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00003636}, {1900,0.00003636}, {1910,0.00003636}, {1920,0.00000000}, {1930,0.00007273}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00007273}, {2050,0.00000000}, {2100,0.00002727}, {2150,0.00003636}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00003636}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00006364}, {2600,0.00007273}, {2650,0.00010909}, {2700,0.00002727}, {2750,0.00003636}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000}, {3100,0.00000}, {3150,0.00000}, {3200,0.00000}, {3250,0.00000}, {3300,0.00000}, {3350,0.00000}, {3400,0.00000}, {3450,0.00000}, {3500,0.00000}, {3550,0.00000}, {3600,0.00000}, {3650,0.00000}, {3700,0.00000}, {3750,0.00000}, {3800,0.00000}, {3850,0.00000}, {3900,0.00000}, {3950,0.00000}, {4000,0.00000}, {4050,0.00000}, {4100,0.00000}, {4150,0.00000}, {4200,0.00000}, {4250,0.00000}, {4300,0.00000}, {4350,0.00000}, {4400,0.00000}, {4450,0.00000}, {4500,0.00000}, {4550,0.00000}, {4600,0.00000}, {4650,0.00000}, {4700,0.00000}, {4750,0.00000}, {4800,0.00000}, {4850,0.00000}, {4900,0.00000}, {4950,0.00000}, {5000,0.00000}, {5050,0.00000}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00100}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00100}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.0000}, {10200,0.0000}, {10300,0.0000}, {10400,0.0000}, {10500,0}, {10600,0}, {10700,0}, {10800,0}, {10900,0}, {11000,0}, {11100,0}, {11200,0}, {11300,0}, {11400,0}, {11500,0}, {11600,0}, {11700,0}, {11800,0}, {11900,0}, {12000,0}, {12100,0}, {12200,0}, {12300,0}, {12400,0}, {12500,0}, {12600,0}, {12700,0}, {12800,0}, {12900,0}, {13000,0}, {13100,0}, {13200,0}, {13300,0}, {13400,0}, {13500,0}, {13600,0}, {13700,0}, {13800,0}, {13900,0}, {14000,0}, {14100,0}, {14200,0}, {14300,0}, {14400,0}, {14500,0}, {14600,0}, {14700,0}, {14800,0}, {14900,0}, {15000,0}, {15100,0}, {15200,0}, {15300,0}, {15400,0}, {15500,0}, {15600,0}, {15700,0}, {15800,0}, {15900,0}, {16000,0}, {16100,0}, {16200,0}, {16300,0}, {16400,0}, {16500,0}, {16600,0}, {16700,0}, {16800,0}, {16900,0}, {17000,0}, {17100,0}, {17200,0}, {17300,0}, {17400,0}, {17500,0}, {17600,0}, {17700,0}, {17800,0}, {17900,0}, {18000,0}, {18100,0}, {18200,0}, {18300,0}, {18400,0}, {18500,0.004}, {18600,0}, {18700,0}, {18800,0}, {18900,0}, {19000,0}, {19100,0}, {19200,0}, {19300,0}, {19400,0}, {19500,0}, {19600,0}, {19700,0}, {19800,0}, {19900,0}};
data["big"]["identity lazy"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00001818}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00001818}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00001818}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000909}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00004545}, {735,0.00002727}, {740,0.00007273}, {745,0.00007273}, {750,0.00007273}, {755,0.00009091}, {760,0.00020909}, {765,0.00016364}, {770,0.00019091}, {775,0.00033636}, {780,0.00037273}, {785,0.00040000}, {790,0.00050000}, {795,0.00050000}, {800,0.00058182}, {805,0.00060000}, {810,0.00069091}, {815,0.00068182}, {820,0.00067273}, {825,0.00074545}, {830,0.00074545}, {835,0.00080000}, {840,0.00082727}, {845,0.00083636}, {850,0.00090000}, {855,0.00090000}, {860,0.00091818}, {865,0.00091818}, {870,0.00094545}, {875,0.00093636}, {880,0.00096364}, {885,0.00099091}, {890,0.00099091}, {895,0.00100000}, {900,0.00100000}, {905,0.00100000}, {910,0.00100000}, {915,0.00100000}, {920,0.00100000}, {925,0.00100000}, {930,0.00100000}, {935,0.00100000}, {940,0.00100000}, {945,0.00100000}, {950,0.00100000}, {955,0.00100000}, {960,0.00100000}, {965,0.00100000}, {970,0.00100000}, {975,0.00100000}, {980,0.00100000}, {985,0.00100000}, {990,0.00100000}, {995,0.00100000}, {1000,0.00100909}, {1010,0.00100000}, {1020,0.00100000}, {1030,0.00100000}, {1040,0.00100000}, {1050,0.00100000}, {1060,0.00100000}, {1070,0.00100000}, {1080,0.00100000}, {1090,0.00100000}, {1100,0.00100000}, {1110,0.00100000}, {1120,0.00100000}, {1130,0.00100000}, {1140,0.00100000}, {1150,0.00100000}, {1160,0.00100000}, {1170,0.00100000}, {1180,0.00100000}, {1190,0.00100000}, {1200,0.00100000}, {1210,0.00100000}, {1220,0.00100000}, {1230,0.00100000}, {1240,0.00100000}, {1250,0.00100000}, {1260,0.00101818}, {1270,0.00100000}, {1280,0.00100000}, {1290,0.00665455}, {1300,0.00100000}, {1310,0.00100000}, {1320,0.00100000}, {1330,0.00100000}, {1340,0.00100909}, {1350,0.00100000}, {1360,0.00100000}, {1370,0.00100000}, {1380,0.00101818}, {1390,0.00100909}, {1400,0.00100000}, {1410,0.00100909}, {1420,0.00109091}, {1430,0.00106364}, {1440,0.00111818}, {1450,0.00110000}, {1460,0.00105455}, {1470,0.00116364}, {1480,0.00126364}, {1490,0.00130909}, {1500,0.00130000}, {1510,0.00136364}, {1520,0.00142727}, {1530,0.00144545}, {1540,0.00146364}, {1550,0.00163636}, {1560,0.00151818}, {1570,0.00150909}, {1580,0.00151818}, {1590,0.00156364}, {1600,0.00160000}, {1610,0.00159091}, {1620,0.00156364}, {1630,0.00167273}, {1640,0.00168182}, {1650,0.00175455}, {1660,0.00170909}, {1670,0.00172727}, {1680,0.00172727}, {1690,0.00172727}, {1700,0.00180909}, {1710,0.00180909}, {1720,0.00188182}, {1730,0.00190909}, {1740,0.00190909}, {1750,0.00190909}, {1760,0.00191818}, {1770,0.00189091}, {1780,0.00191818}, {1790,0.00196364}, {1800,0.00195455}, {1810,0.00198182}, {1820,0.00200000}, {1830,0.00200000}, {1840,0.00200000}, {1850,0.00200000}, {1860,0.00200000}, {1870,0.00200000}, {1880,0.00200000}, {1890,0.00200000}, {1900,0.00200000}, {1910,0.00200000}, {1920,0.00200000}, {1930,0.00200000}, {1940,0.00200000}, {1950,0.00200000}, {1960,0.00200000}, {1970,0.00200000}, {1980,0.00200000}, {1990,0.00200000}, {2000,0.00200000}, {2050,0.00200000}, {2100,0.00201818}, {2150,0.00210000}, {2200,0.00219091}, {2250,0.00209091}, {2300,0.00245455}, {2350,0.00267273}, {2400,0.00267273}, {2450,0.00449091}, {2500,0.00273636}, {2550,0.00289091}, {2600,0.00294545}, {2650,0.00297273}, {2700,0.00300909}, {2750,0.00300909}, {2800,0.00330000}, {2850,0.00302727}, {2900,0.00314545}, {2950,0.00330000}, {3000,0.00331818}, {3050,0.00350}, {3100,0.00375}, {3150,0.00775}, {3200,0.00375}, {3250,0.00375}, {3300,0.00400}, {3350,0.00400}, {3400,0.00400}, {3450,0.00400}, {3500,0.00400}, {3550,0.01025}, {3600,0.00400}, {3650,0.00400}, {3700,0.01025}, {3750,0.00475}, {3800,0.00475}, {3850,0.00450}, {3900,0.00475}, {3950,0.00500}, {4000,0.00500}, {4050,0.00500}, {4100,0.00500}, {4150,0.01300}, {4200,0.01200}, {4250,0.00500}, {4300,0.00500}, {4350,0.00525}, {4400,0.00525}, {4450,0.00550}, {4500,0.01325}, {4550,0.01500}, {4600,0.00600}, {4650,0.00600}, {4700,0.00600}, {4750,0.00575}, {4800,0.00600}, {4850,0.00650}, {4900,0.00600}, {4950,0.00600}, {5000,0.01500}, {5050,0.00600}, {5100,0.00600}, {5150,0.01900}, {5200,0.00700}, {5250,0.00700}, {5300,0.00700}, {5350,0.00700}, {5400,0.00700}, {5450,0.00700}, {5500,0.00675}, {5550,0.01600}, {5600,0.00700}, {5650,0.00750}, {5700,0.01550}, {5750,0.00700}, {5800,0.00700}, {5850,0.00800}, {5900,0.00775}, {5950,0.00775}, {6000,0.00775}, {6050,0.00750}, {6100,0.00775}, {6150,0.01550}, {6200,0.01550}, {6250,0.00775}, {6300,0.00775}, {6350,0.00775}, {6400,0.00800}, {6450,0.00800}, {6500,0.01575}, {6550,0.01650}, {6600,0.00850}, {6650,0.00875}, {6700,0.00925}, {6750,0.00875}, {6800,0.00900}, {6850,0.00900}, {6900,0.00900}, {6950,0.00875}, {7000,0.01450}, {7050,0.00900}, {7100,0.00875}, {7150,0.01325}, {7200,0.00900}, {7250,0.00875}, {7300,0.01000}, {7350,0.00925}, {7400,0.00975}, {7450,0.01025}, {7500,0.01000}, {7550,0.01350}, {7600,0.01025}, {7650,0.01000}, {7700,0.01375}, {7750,0.01075}, {7800,0.01000}, {7850,0.02325}, {7900,0.02125}, {7950,0.01025}, {8000,0.01025}, {8050,0.01050}, {8100,0.01050}, {8150,0.01075}, {8200,0.01050}, {8250,0.01100}, {8300,0.01775}, {8350,0.01075}, {8400,0.01675}, {8450,0.01075}, {8500,0.01075}, {8550,0.01175}, {8600,0.02775}, {8650,0.01050}, {8700,0.01100}, {8750,0.01075}, {8800,0.01525}, {8850,0.01450}, {8900,0.01100}, {8950,0.02650}, {9000,0.01150}, {9050,0.01325}, {9100,0.01125}, {9150,0.01100}, {9200,0.01100}, {9250,0.01100}, {9300,0.01200}, {9350,0.01175}, {9400,0.01300}, {9450,0.01250}, {9500,0.01175}, {9550,0.02500}, {9600,0.01250}, {9650,0.03575}, {9700,0.01200}, {9750,0.02325}, {9800,0.01250}, {9850,0.01225}, {9900,0.03150}, {9950,0.01925}, {10000,0.02075}, {10100,0.0125}, {10200,0.0125}, {10300,0.0125}, {10400,0.0145}, {10500,0.013}, {10600,0.014}, {10700,0.014}, {10800,0.014}, {10900,0.014}, {11000,0.013}, {11100,0.014}, {11200,0.013}, {11300,0.015}, {11400,0.013}, {11500,0.014}, {11600,0.014}, {11700,0.025}, {11800,0.014}, {11900,0.014}, {12000,0.015}, {12100,0.014}, {12200,0.014}, {12300,0.015}, {12400,0.015}, {12500,0.017}, {12600,0.016}, {12700,0.016}, {12800,0.017}, {12900,0.017}, {13000,0.016}, {13100,0.019}, {13200,0.017}, {13300,0.017}, {13400,0.018}, {13500,0.016}, {13600,0.018}, {13700,0.056}, {13800,0.018}, {13900,0.017}, {14000,0.018}, {14100,0.017}, {14200,0.018}, {14300,0.019}, {14400,0.018}, {14500,0.019}, {14600,0.019}, {14700,0.019}, {14800,0.019}, {14900,0.02}, {15000,0.018}, {15100,0.021}, {15200,0.019}, {15300,0.019}, {15400,0.019}, {15500,0.019}, {15600,0.021}, {15700,0.092}, {15800,0.02}, {15900,0.02}, {16000,0.035}, {16100,0.02}, {16200,0.02}, {16300,0.021}, {16400,0.032}, {16500,0.022}, {16600,0.021}, {16700,0.022}, {16800,0.022}, {16900,0.022}, {17000,0.031}, {17100,0.023}, {17200,0.021}, {17300,0.021}, {17400,0.03}, {17500,0.025}, {17600,0.026}, {17700,0.095}, {17800,0.023}, {17900,0.022}, {18000,0.022}, {18100,0.022}, {18200,0.022}, {18300,0.024}, {18400,0.023}, {18500,0.024}, {18600,0.025}, {18700,0.024}, {18800,0.024}, {18900,0.024}, {19000,0.024}, {19100,0.026}, {19200,0.027}, {19300,0.028}, {19400,0.024}, {19500,0.024}, {19600,0.026}, {19700,0.085}, {19800,0.026}, {19900,0.025}};
data["big"]["identity lazy"]["Stats"]["user"] = {{1,0.00003636}, {2,0.00003636}, {3,0.00002727}, {4,0.00006364}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00010000}, {9,0.00009091}, {10,0.00006364}, {11,0.00000000}, {12,0.00007273}, {13,0.00002727}, {14,0.00008182}, {15,0.00003636}, {16,0.00002727}, {17,0.00000000}, {18,0.00002727}, {19,0.00009091}, {20,0.00005455}, {21,0.00000000}, {22,0.00010909}, {23,0.00009091}, {24,0.00011818}, {25,0.00008182}, {26,0.00002727}, {27,0.00006364}, {28,0.00005455}, {29,0.00008182}, {30,0.00012727}, {31,0.00006364}, {32,0.00010909}, {33,0.00014545}, {34,0.00010909}, {35,0.00012727}, {36,0.00005455}, {37,0.00009091}, {38,0.00005455}, {39,0.00002727}, {40,0.00015455}, {41,0.00012727}, {42,0.00013636}, {43,0.00012727}, {44,0.00003636}, {45,0.00006364}, {46,0.00003636}, {47,0.00003636}, {48,0.00009091}, {49,0.00009091}, {50,0.00002727}, {51,0.00011818}, {52,0.00002727}, {53,0.00005455}, {54,0.00008182}, {55,0.00006364}, {56,0.00013636}, {57,0.00020000}, {58,0.00011818}, {59,0.00005455}, {60,0.00011818}, {61,0.00006364}, {62,0.00018182}, {63,0.00009091}, {64,0.00006364}, {65,0.00012727}, {66,0.00009091}, {67,0.00019091}, {68,0.00007273}, {69,0.00009091}, {70,0.00008182}, {71,0.00006364}, {72,0.00008182}, {73,0.00021818}, {74,0.00009091}, {75,0.00006364}, {76,0.00008182}, {77,0.00015455}, {78,0.00002727}, {79,0.00013636}, {80,0.00013636}, {81,0.00017273}, {82,0.00006364}, {83,0.00003636}, {84,0.00009091}, {85,0.00008182}, {86,0.00002727}, {87,0.00012727}, {88,0.00010000}, {89,0.00015455}, {90,0.00014545}, {91,0.00009091}, {92,0.00011818}, {93,0.00018182}, {94,0.00020909}, {95,0.00005455}, {96,0.00017273}, {97,0.00011818}, {98,0.00006364}, {99,0.00010000}, {100,0.00013636}, {101,0.00012727}, {102,0.00011818}, {103,0.00019091}, {104,0.00024545}, {105,0.00013636}, {106,0.00006364}, {107,0.00016364}, {108,0.00006364}, {109,0.00000000}, {110,0.00015455}, {111,0.00011818}, {112,0.00002727}, {113,0.00018182}, {114,0.00009091}, {115,0.00014545}, {116,0.00021818}, {117,0.00018182}, {118,0.00020000}, {119,0.00011818}, {120,0.00005455}, {121,0.00013636}, {122,0.00012727}, {123,0.00024545}, {124,0.00012727}, {125,0.00011818}, {126,0.00013636}, {127,0.00016364}, {128,0.00008182}, {129,0.00020909}, {130,0.00010909}, {131,0.00029091}, {132,0.00020909}, {133,0.00025455}, {134,0.00022727}, {135,0.00017273}, {136,0.00011818}, {137,0.00016364}, {138,0.00034545}, {139,0.00018182}, {140,0.00015455}, {141,0.00019091}, {142,0.00022727}, {143,0.00020000}, {144,0.00011818}, {145,0.00022727}, {146,0.00024545}, {147,0.00018182}, {148,0.00023636}, {149,0.00018182}, {150,0.00012727}, {151,0.00020909}, {152,0.00019091}, {153,0.00014545}, {154,0.00018182}, {155,0.00008182}, {156,0.00016364}, {157,0.00020000}, {158,0.00024545}, {159,0.00023636}, {160,0.00019091}, {161,0.00030909}, {162,0.00020909}, {163,0.00022727}, {164,0.00023636}, {165,0.00010909}, {166,0.00014545}, {167,0.00015455}, {168,0.00028182}, {169,0.00008182}, {170,0.00020000}, {171,0.00019091}, {172,0.00022727}, {173,0.00015455}, {174,0.00024545}, {175,0.00020909}, {176,0.00026364}, {177,0.00009091}, {178,0.00027273}, {179,0.00024545}, {180,0.00017273}, {181,0.00017273}, {182,0.00029091}, {183,0.00030000}, {184,0.00024545}, {185,0.00027273}, {186,0.00027273}, {187,0.00017273}, {188,0.00010000}, {189,0.00012727}, {190,0.00020000}, {191,0.00010909}, {192,0.00028182}, {193,0.00033636}, {194,0.00035455}, {195,0.00024545}, {196,0.00018182}, {197,0.00025455}, {198,0.00025455}, {199,0.00023636}, {200,0.00040000}, {201,0.00024545}, {202,0.00022727}, {203,0.00023636}, {204,0.00011818}, {205,0.00040000}, {206,0.00013636}, {207,0.00035455}, {208,0.00015455}, {209,0.00023636}, {210,0.00025455}, {211,0.00013636}, {212,0.00027273}, {213,0.00033636}, {214,0.00025455}, {215,0.00019091}, {216,0.00022727}, {217,0.00031818}, {218,0.00048182}, {219,0.00021818}, {220,0.00029091}, {221,0.00035455}, {222,0.00025455}, {223,0.00022727}, {224,0.00029091}, {225,0.00035455}, {226,0.00024545}, {227,0.00039091}, {228,0.00023636}, {229,0.00032727}, {230,0.00036364}, {231,0.00005455}, {232,0.00022727}, {233,0.00035455}, {234,0.00027273}, {235,0.00022727}, {236,0.00038182}, {237,0.00029091}, {238,0.00019091}, {239,0.00022727}, {240,0.00024545}, {241,0.00021818}, {242,0.00030000}, {243,0.00020909}, {244,0.00030909}, {245,0.00036364}, {246,0.00032727}, {247,0.00021818}, {248,0.00024545}, {249,0.00024545}, {250,0.00034545}, {251,0.00020909}, {252,0.00026364}, {253,0.00025455}, {254,0.00015455}, {255,0.00028182}, {256,0.00024545}, {257,0.00021818}, {258,0.00015455}, {259,0.00037273}, {260,0.00057273}, {261,0.00021818}, {262,0.00037273}, {263,0.00025455}, {264,0.00052727}, {265,0.00017273}, {266,0.00047273}, {267,0.00026364}, {268,0.00033636}, {269,0.00029091}, {270,0.00025455}, {271,0.00026364}, {272,0.00044545}, {273,0.00036364}, {274,0.00018182}, {275,0.00046364}, {276,0.00026364}, {277,0.00018182}, {278,0.00035455}, {279,0.00032727}, {280,0.00021818}, {281,0.00017273}, {282,0.00030909}, {283,0.00039091}, {284,0.00034545}, {285,0.00034545}, {286,0.00043636}, {287,0.00049091}, {288,0.00031818}, {289,0.00019091}, {290,0.00035455}, {291,0.00020909}, {292,0.00040000}, {293,0.00035455}, {294,0.00040000}, {295,0.00020000}, {296,0.00051818}, {297,0.00030909}, {298,0.00043636}, {299,0.00040000}, {300,0.00039091}, {301,0.00042727}, {302,0.00032727}, {303,0.00024545}, {304,0.00013636}, {305,0.00037273}, {306,0.00045455}, {307,0.00047273}, {308,0.00035455}, {309,0.00022727}, {310,0.00039091}, {311,0.00034545}, {312,0.00022727}, {313,0.00039091}, {314,0.00046364}, {315,0.00023636}, {316,0.00042727}, {317,0.00042727}, {318,0.00034545}, {319,0.00027273}, {320,0.00041818}, {321,0.00048182}, {322,0.00039091}, {323,0.00040000}, {324,0.00052727}, {325,0.00044545}, {326,0.00041818}, {327,0.00030909}, {328,0.00050000}, {329,0.00036364}, {330,0.00036364}, {331,0.00020909}, {332,0.00050000}, {333,0.00036364}, {334,0.00046364}, {335,0.00039091}, {336,0.00037273}, {337,0.00029091}, {338,0.00021818}, {339,0.00047273}, {340,0.00045455}, {341,0.00023636}, {342,0.00041818}, {343,0.00029091}, {344,0.00024545}, {345,0.00054545}, {346,0.00039091}, {347,0.00030000}, {348,0.00039091}, {349,0.00030000}, {350,0.00021818}, {351,0.00042727}, {352,0.00034545}, {353,0.00040909}, {354,0.00042727}, {355,0.00028182}, {356,0.00037273}, {357,0.00048182}, {358,0.00053636}, {359,0.00050000}, {360,0.00052727}, {361,0.00041818}, {362,0.00042727}, {363,0.00040909}, {364,0.00028182}, {365,0.00027273}, {366,0.00038182}, {367,0.00040909}, {368,0.00065455}, {369,0.00053636}, {370,0.00032727}, {371,0.00043636}, {372,0.00035455}, {373,0.00060909}, {374,0.00036364}, {375,0.00034545}, {376,0.00042727}, {377,0.00036364}, {378,0.00046364}, {379,0.00042727}, {380,0.00043636}, {381,0.00060909}, {382,0.00038182}, {383,0.00028182}, {384,0.00053636}, {385,0.00030000}, {386,0.00036364}, {387,0.00044545}, {388,0.00035455}, {389,0.00033636}, {390,0.00038182}, {391,0.00039091}, {392,0.00037273}, {393,0.00040000}, {394,0.00030000}, {395,0.00027273}, {396,0.00036364}, {397,0.00035455}, {398,0.00042727}, {399,0.00032727}, {400,0.00058182}, {401,0.00054545}, {402,0.00050000}, {403,0.00043636}, {404,0.00041818}, {405,0.00049091}, {406,0.00040909}, {407,0.00028182}, {408,0.00034545}, {409,0.00045455}, {410,0.00040000}, {411,0.00030000}, {412,0.00065455}, {413,0.00025455}, {414,0.00057273}, {415,0.00061818}, {416,0.00038182}, {417,0.00041818}, {418,0.00037273}, {419,0.00060000}, {420,0.00055455}, {421,0.00027273}, {422,0.00045455}, {423,0.00047273}, {424,0.00053636}, {425,0.00043636}, {426,0.00051818}, {427,0.00047273}, {428,0.00067273}, {429,0.00039091}, {430,0.00050909}, {431,0.00023636}, {432,0.00039091}, {433,0.00041818}, {434,0.00030000}, {435,0.00062727}, {436,0.00050909}, {437,0.00041818}, {438,0.00037273}, {439,0.00050909}, {440,0.00047273}, {441,0.00045455}, {442,0.00060000}, {443,0.00042727}, {444,0.00050000}, {445,0.00060909}, {446,0.00032727}, {447,0.00055455}, {448,0.00051818}, {449,0.00053636}, {450,0.00038182}, {451,0.00036364}, {452,0.00053636}, {453,0.00067273}, {454,0.00063636}, {455,0.00043636}, {456,0.00050909}, {457,0.00061818}, {458,0.00030000}, {459,0.00044545}, {460,0.00044545}, {461,0.00053636}, {462,0.00041818}, {463,0.00056364}, {464,0.00062727}, {465,0.00061818}, {466,0.00059091}, {467,0.00069091}, {468,0.00032727}, {469,0.00063636}, {470,0.00054545}, {471,0.00048182}, {472,0.00048182}, {473,0.00036364}, {474,0.00048182}, {475,0.00059091}, {476,0.00046364}, {477,0.00060909}, {478,0.00068182}, {479,0.00061818}, {480,0.00045455}, {481,0.00059091}, {482,0.00052727}, {483,0.00051818}, {484,0.00038182}, {485,0.00054545}, {486,0.00057273}, {487,0.00075455}, {488,0.00041818}, {489,0.00050909}, {490,0.00058182}, {491,0.00043636}, {492,0.00054545}, {493,0.00041818}, {494,0.00042727}, {495,0.00051818}, {496,0.00070909}, {497,0.00061818}, {498,0.00027273}, {499,0.00060000}, {500,0.00080909}, {505,0.00067273}, {510,0.00055455}, {515,0.00072727}, {520,0.00060000}, {525,0.00060909}, {530,0.00058182}, {535,0.00053636}, {540,0.00035455}, {545,0.00050909}, {550,0.00093636}, {555,0.00060000}, {560,0.00063636}, {565,0.00073636}, {570,0.00065455}, {575,0.00063636}, {580,0.00070909}, {585,0.00075455}, {590,0.00044545}, {595,0.00059091}, {600,0.00085455}, {605,0.00074545}, {610,0.00067273}, {615,0.00074545}, {620,0.00076364}, {625,0.00086364}, {630,0.00056364}, {635,0.00060000}, {640,0.00081818}, {645,0.00060909}, {650,0.00078182}, {655,0.00050000}, {660,0.00073636}, {665,0.00076364}, {670,0.00062727}, {675,0.00070000}, {680,0.00073636}, {685,0.00084545}, {690,0.00092727}, {695,0.00091818}, {700,0.00083636}, {705,0.00078182}, {710,0.00072727}, {715,0.00097273}, {720,0.00084545}, {725,0.00094545}, {730,0.00075455}, {735,0.00090000}, {740,0.00093636}, {745,0.00094545}, {750,0.00056364}, {755,0.00078182}, {760,0.00098182}, {765,0.00096364}, {770,0.00080000}, {775,0.00067273}, {780,0.00096364}, {785,0.00112727}, {790,0.00116364}, {795,0.00089091}, {800,0.00100909}, {805,0.00103636}, {810,0.00069091}, {815,0.00094545}, {820,0.00076364}, {825,0.00109091}, {830,0.00079091}, {835,0.00102727}, {840,0.00090000}, {845,0.00106364}, {850,0.00108182}, {855,0.00082727}, {860,0.00093636}, {865,0.00108182}, {870,0.00102727}, {875,0.00097273}, {880,0.00100909}, {885,0.00109091}, {890,0.00087273}, {895,0.00094545}, {900,0.00096364}, {905,0.00096364}, {910,0.00112727}, {915,0.00092727}, {920,0.00128182}, {925,0.00102727}, {930,0.00100000}, {935,0.00095455}, {940,0.00109091}, {945,0.00123636}, {950,0.00108182}, {955,0.00098182}, {960,0.00120909}, {965,0.00112727}, {970,0.00131818}, {975,0.00114545}, {980,0.00141818}, {985,0.00092727}, {990,0.00111818}, {995,0.00119091}, {1000,0.00107273}, {1010,0.00114545}, {1020,0.00121818}, {1030,0.00117273}, {1040,0.00137273}, {1050,0.00083636}, {1060,0.00101818}, {1070,0.00104545}, {1080,0.00118182}, {1090,0.00139091}, {1100,0.00126364}, {1110,0.00122727}, {1120,0.00087273}, {1130,0.00122727}, {1140,0.00118182}, {1150,0.00138182}, {1160,0.00138182}, {1170,0.00131818}, {1180,0.00131818}, {1190,0.00121818}, {1200,0.00111818}, {1210,0.00126364}, {1220,0.00163636}, {1230,0.00140000}, {1240,0.00160909}, {1250,0.00130909}, {1260,0.00151818}, {1270,0.00175455}, {1280,0.00132727}, {1290,0.00618182}, {1300,0.00145455}, {1310,0.00143636}, {1320,0.00193636}, {1330,0.00140000}, {1340,0.00118182}, {1350,0.00158182}, {1360,0.00185455}, {1370,0.00160909}, {1380,0.00171818}, {1390,0.00120000}, {1400,0.00137273}, {1410,0.00160909}, {1420,0.00163636}, {1430,0.00130000}, {1440,0.00189091}, {1450,0.00162727}, {1460,0.00180909}, {1470,0.00155455}, {1480,0.00172727}, {1490,0.00173636}, {1500,0.00199091}, {1510,0.00151818}, {1520,0.00162727}, {1530,0.00224545}, {1540,0.00187273}, {1550,0.00205455}, {1560,0.00217273}, {1570,0.00160000}, {1580,0.00186364}, {1590,0.00167273}, {1600,0.00182727}, {1610,0.00167273}, {1620,0.00186364}, {1630,0.00189091}, {1640,0.00186364}, {1650,0.00157273}, {1660,0.00200909}, {1670,0.00226364}, {1680,0.00171818}, {1690,0.00198182}, {1700,0.00213636}, {1710,0.00193636}, {1720,0.00173636}, {1730,0.00189091}, {1740,0.00180909}, {1750,0.00197273}, {1760,0.00192727}, {1770,0.00210909}, {1780,0.00160909}, {1790,0.00214545}, {1800,0.00210000}, {1810,0.00230909}, {1820,0.00182727}, {1830,0.00231818}, {1840,0.00229091}, {1850,0.00221818}, {1860,0.00208182}, {1870,0.00223636}, {1880,0.00192727}, {1890,0.00211818}, {1900,0.00230000}, {1910,0.00217273}, {1920,0.00237273}, {1930,0.00209091}, {1940,0.00201818}, {1950,0.00235455}, {1960,0.00237273}, {1970,0.00247273}, {1980,0.00228182}, {1990,0.00252727}, {2000,0.00240909}, {2050,0.00268182}, {2100,0.00255455}, {2150,0.00231818}, {2200,0.00252727}, {2250,0.00231818}, {2300,0.00270909}, {2350,0.00287273}, {2400,0.00293636}, {2450,0.00460000}, {2500,0.00300000}, {2550,0.00301818}, {2600,0.00310000}, {2650,0.00312727}, {2700,0.00330909}, {2750,0.00316364}, {2800,0.00344545}, {2850,0.00312727}, {2900,0.00328182}, {2950,0.00331818}, {3000,0.00337273}, {3050,0.00375}, {3100,0.00325}, {3150,0.00650}, {3200,0.00350}, {3250,0.00350}, {3300,0.00475}, {3350,0.00325}, {3400,0.00325}, {3450,0.00425}, {3500,0.00400}, {3550,0.00950}, {3600,0.00300}, {3650,0.00400}, {3700,0.00925}, {3750,0.00450}, {3800,0.00425}, {3850,0.00425}, {3900,0.00325}, {3950,0.00350}, {4000,0.00450}, {4050,0.00575}, {4100,0.00550}, {4150,0.01250}, {4200,0.01250}, {4250,0.00600}, {4300,0.00500}, {4350,0.00525}, {4400,0.00450}, {4450,0.00525}, {4500,0.01275}, {4550,0.01575}, {4600,0.00600}, {4650,0.00625}, {4700,0.00600}, {4750,0.00650}, {4800,0.00550}, {4850,0.00725}, {4900,0.00450}, {4950,0.00675}, {5000,0.01500}, {5050,0.00625}, {5100,0.00625}, {5150,0.01900}, {5200,0.00650}, {5250,0.00625}, {5300,0.00775}, {5350,0.00725}, {5400,0.00725}, {5450,0.00525}, {5500,0.00700}, {5550,0.01550}, {5600,0.00675}, {5650,0.00675}, {5700,0.01550}, {5750,0.00725}, {5800,0.00775}, {5850,0.00650}, {5900,0.00775}, {5950,0.00750}, {6000,0.00750}, {6050,0.00800}, {6100,0.00750}, {6150,0.01675}, {6200,0.01600}, {6250,0.00775}, {6300,0.00750}, {6350,0.00675}, {6400,0.00775}, {6450,0.00875}, {6500,0.01525}, {6550,0.01750}, {6600,0.00875}, {6650,0.00875}, {6700,0.00875}, {6750,0.00900}, {6800,0.00975}, {6850,0.00875}, {6900,0.00775}, {6950,0.01000}, {7000,0.01525}, {7050,0.00950}, {7100,0.01025}, {7150,0.01350}, {7200,0.00850}, {7250,0.01025}, {7300,0.00975}, {7350,0.01075}, {7400,0.00775}, {7450,0.01100}, {7500,0.00925}, {7550,0.01325}, {7600,0.01100}, {7650,0.01050}, {7700,0.01425}, {7750,0.01050}, {7800,0.01050}, {7850,0.02250}, {7900,0.02050}, {7950,0.00950}, {8000,0.01125}, {8050,0.01150}, {8100,0.00950}, {8150,0.01050}, {8200,0.01125}, {8250,0.01125}, {8300,0.01875}, {8350,0.01025}, {8400,0.01750}, {8450,0.01025}, {8500,0.01025}, {8550,0.01100}, {8600,0.02775}, {8650,0.01050}, {8700,0.01125}, {8750,0.01025}, {8800,0.01425}, {8850,0.01450}, {8900,0.01100}, {8950,0.02600}, {9000,0.01125}, {9050,0.01200}, {9100,0.01050}, {9150,0.01100}, {9200,0.01175}, {9250,0.01150}, {9300,0.01275}, {9350,0.01275}, {9400,0.01300}, {9450,0.01275}, {9500,0.01325}, {9550,0.02425}, {9600,0.01125}, {9650,0.03525}, {9700,0.01175}, {9750,0.02350}, {9800,0.01275}, {9850,0.01275}, {9900,0.03175}, {9950,0.01950}, {10000,0.02025}, {10100,0.0135}, {10200,0.0120}, {10300,0.0140}, {10400,0.0155}, {10500,0.012}, {10600,0.016}, {10700,0.015}, {10800,0.016}, {10900,0.011}, {11000,0.011}, {11100,0.016}, {11200,0.015}, {11300,0.015}, {11400,0.015}, {11500,0.012}, {11600,0.012}, {11700,0.024}, {11800,0.015}, {11900,0.012}, {12000,0.015}, {12100,0.015}, {12200,0.016}, {12300,0.016}, {12400,0.016}, {12500,0.015}, {12600,0.019}, {12700,0.016}, {12800,0.016}, {12900,0.016}, {13000,0.016}, {13100,0.019}, {13200,0.016}, {13300,0.015}, {13400,0.016}, {13500,0.016}, {13600,0.019}, {13700,0.056}, {13800,0.016}, {13900,0.019}, {14000,0.019}, {14100,0.019}, {14200,0.02}, {14300,0.019}, {14400,0.02}, {14500,0.019}, {14600,0.016}, {14700,0.019}, {14800,0.019}, {14900,0.019}, {15000,0.019}, {15100,0.019}, {15200,0.019}, {15300,0.019}, {15400,0.019}, {15500,0.016}, {15600,0.023}, {15700,0.092}, {15800,0.024}, {15900,0.023}, {16000,0.036}, {16100,0.02}, {16200,0.019}, {16300,0.019}, {16400,0.036}, {16500,0.019}, {16600,0.02}, {16700,0.024}, {16800,0.02}, {16900,0.024}, {17000,0.032}, {17100,0.023}, {17200,0.019}, {17300,0.023}, {17400,0.028}, {17500,0.024}, {17600,0.028}, {17700,0.096}, {17800,0.023}, {17900,0.02}, {18000,0.024}, {18100,0.024}, {18200,0.023}, {18300,0.024}, {18400,0.024}, {18500,0.023}, {18600,0.024}, {18700,0.024}, {18800,0.023}, {18900,0.028}, {19000,0.023}, {19100,0.024}, {19200,0.028}, {19300,0.028}, {19400,0.023}, {19500,0.023}, {19600,0.028}, {19700,0.084}, {19800,0.028}, {19900,0.027}};
data["big"]["identity lazy"]["Stats"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00002727}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00002727}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00003636}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00003636}, {130,0.00003636}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00003636}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00003636}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00003636}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00002727}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00003636}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00003636}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00003636}, {225,0.00000000}, {226,0.00000000}, {227,0.00003636}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00003636}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00003636}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00003636}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00007273}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00003636}, {278,0.00000000}, {279,0.00003636}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00003636}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00007273}, {303,0.00003636}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00003636}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00003636}, {348,0.00000000}, {349,0.00000000}, {350,0.00003636}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00003636}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00003636}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00003636}, {395,0.00000000}, {396,0.00003636}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00003636}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00003636}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00003636}, {445,0.00000000}, {446,0.00000000}, {447,0.00003636}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00003636}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00003636}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00003636}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00003636}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00003636}, {545,0.00003636}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00003636}, {575,0.00003636}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00003636}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00003636}, {635,0.00000000}, {640,0.00006364}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00003636}, {665,0.00000000}, {670,0.00000000}, {675,0.00003636}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00003636}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00003636}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00003636}, {780,0.00003636}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00003636}, {825,0.00000000}, {830,0.00000000}, {835,0.00003636}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00003636}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00003636}, {880,0.00007273}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00003636}, {935,0.00003636}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00003636}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00007273}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00007273}, {1060,0.00007273}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00003636}, {1140,0.00000000}, {1150,0.00003636}, {1160,0.00003636}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00003636}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00003636}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00024545}, {1300,0.00000000}, {1310,0.00003636}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00003636}, {1350,0.00000000}, {1360,0.00003636}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00003636}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00007273}, {1510,0.00003636}, {1520,0.00003636}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00003636}, {1560,0.00003636}, {1570,0.00000000}, {1580,0.00003636}, {1590,0.00000000}, {1600,0.00006364}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00002727}, {1740,0.00007273}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00003636}, {1800,0.00002727}, {1810,0.00002727}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00003636}, {1880,0.00000000}, {1890,0.00002727}, {1900,0.00003636}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00007273}, {2050,0.00000000}, {2100,0.00003636}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00003636}, {2300,0.00007273}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00007273}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00003636}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000}, {3100,0.00000}, {3150,0.00100}, {3200,0.00000}, {3250,0.00000}, {3300,0.00000}, {3350,0.00000}, {3400,0.00000}, {3450,0.00000}, {3500,0.00000}, {3550,0.00000}, {3600,0.00000}, {3650,0.00000}, {3700,0.00000}, {3750,0.00000}, {3800,0.00000}, {3850,0.00000}, {3900,0.00000}, {3950,0.00000}, {4000,0.00000}, {4050,0.00000}, {4100,0.00000}, {4150,0.00000}, {4200,0.00000}, {4250,0.00000}, {4300,0.00000}, {4350,0.00000}, {4400,0.00000}, {4450,0.00000}, {4500,0.00000}, {4550,0.00000}, {4600,0.00000}, {4650,0.00000}, {4700,0.00000}, {4750,0.00000}, {4800,0.00075}, {4850,0.00000}, {4900,0.00000}, {4950,0.00000}, {5000,0.00000}, {5050,0.00000}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.0000}, {10200,0.0000}, {10300,0.0000}, {10400,0.0000}, {10500,0}, {10600,0}, {10700,0}, {10800,0}, {10900,0}, {11000,0}, {11100,0}, {11200,0}, {11300,0}, {11400,0}, {11500,0}, {11600,0}, {11700,0}, {11800,0}, {11900,0}, {12000,0}, {12100,0}, {12200,0}, {12300,0}, {12400,0}, {12500,0}, {12600,0}, {12700,0}, {12800,0}, {12900,0}, {13000,0}, {13100,0}, {13200,0}, {13300,0}, {13400,0}, {13500,0}, {13600,0}, {13700,0}, {13800,0}, {13900,0}, {14000,0}, {14100,0}, {14200,0}, {14300,0}, {14400,0}, {14500,0}, {14600,0}, {14700,0}, {14800,0}, {14900,0}, {15000,0}, {15100,0}, {15200,0}, {15300,0}, {15400,0}, {15500,0}, {15600,0}, {15700,0}, {15800,0}, {15900,0}, {16000,0}, {16100,0}, {16200,0}, {16300,0}, {16400,0}, {16500,0}, {16600,0}, {16700,0}, {16800,0}, {16900,0}, {17000,0}, {17100,0}, {17200,0}, {17300,0}, {17400,0}, {17500,0}, {17600,0}, {17700,0}, {17800,0}, {17900,0}, {18000,0}, {18100,0}, {18200,0}, {18300,0}, {18400,0}, {18500,0}, {18600,0}, {18700,0}, {18800,0}, {18900,0}, {19000,0}, {19100,0}, {19200,0}, {19300,0}, {19400,0}, {19500,0}, {19600,0}, {19700,0}, {19800,0}, {19900,0}};
data["big"]["identity native_compute"]["Stats"]["real"] = {{1,0.32199091}, {2,0.32247273}, {3,0.32204545}, {4,0.32355455}, {5,0.32263636}, {6,0.32270000}, {7,0.32259091}, {8,0.32349091}, {9,0.32341818}, {10,0.32457273}, {11,0.32410000}, {12,0.32498182}, {13,0.32406364}, {14,0.32508182}, {15,0.32531818}, {16,0.32605455}, {17,0.32610909}, {18,0.32602727}, {19,0.32685455}, {20,0.32741818}, {21,0.32815455}, {22,0.32748182}, {23,0.32841818}, {24,0.32879091}, {25,0.32840909}, {26,0.32872727}, {27,0.33085455}, {28,0.32946364}, {29,0.33007273}, {30,0.33119091}, {31,0.33042727}, {32,0.33075455}, {33,0.33103636}, {34,0.33155455}, {35,0.33127273}, {36,0.33160000}, {37,0.33135455}, {38,0.33230000}, {39,0.33309091}, {40,0.33311818}, {41,0.33372727}, {42,0.33264545}, {43,0.33348182}, {44,0.33470909}, {45,0.33500000}, {46,0.33669091}, {47,0.33480909}, {48,0.33618182}, {49,0.33685455}, {50,0.33734545}, {51,0.41715455}, {52,0.33678182}, {53,0.33802727}, {54,0.33912727}, {55,0.33967273}, {56,0.33804545}, {57,0.34004545}, {58,0.33867273}, {59,0.34006364}, {60,0.33942727}, {61,0.33973636}, {62,0.34072727}, {63,0.34046364}, {64,0.34153636}, {65,0.34251818}, {66,0.34230909}, {67,0.34343636}, {68,0.34256364}, {69,0.34300909}, {70,0.34440909}, {71,0.34426364}, {72,0.34331818}, {73,0.34406364}, {74,0.34428182}, {75,0.34453636}, {76,0.34576364}, {77,0.34624545}, {78,0.34657273}, {79,0.34678182}, {80,0.34763636}, {81,0.34847273}, {82,0.34734545}, {83,0.34696364}, {84,0.34828182}, {85,0.34904545}, {86,0.34837273}, {87,0.34924545}, {88,0.34832727}, {89,0.34967273}, {90,0.35060909}, {91,0.35121818}, {92,0.35097273}, {93,0.35102727}, {94,0.35078182}, {95,0.35192727}, {96,0.35168182}, {97,0.35172727}, {98,0.35141818}, {99,0.35222727}, {100,0.35312727}, {101,0.35310909}, {102,0.41409091}, {103,0.35533636}, {104,0.35484545}, {105,0.35525455}, {106,0.35550000}, {107,0.35591818}, {108,0.35569091}, {109,0.35631818}, {110,0.35560909}, {111,0.35719091}, {112,0.35678182}, {113,0.35706364}, {114,0.35732727}, {115,0.35755455}, {116,0.35940000}, {117,0.36037273}, {118,0.36059091}, {119,0.35967273}, {120,0.36085455}, {121,0.36137273}, {122,0.35989091}, {123,0.35998182}, {124,0.36158182}, {125,0.36229091}, {126,0.36213636}, {127,0.36210909}, {128,0.36306364}, {129,0.36338182}, {130,0.36390000}, {131,0.36414545}, {132,0.36470909}, {133,0.36399091}, {134,0.36530000}, {135,0.36666364}, {136,0.36530000}, {137,0.36616364}, {138,0.36726364}, {139,0.36782727}, {140,0.36740000}, {141,0.36793636}, {142,0.36822727}, {143,0.36909091}, {144,0.36955455}, {145,0.37014545}, {146,0.36984545}, {147,0.42141818}, {148,0.37170000}, {149,0.37220909}, {150,0.37043636}, {151,0.37206364}, {152,0.37365455}, {153,0.37171818}, {154,0.37168182}, {155,0.37243636}, {156,0.37324545}, {157,0.37453636}, {158,0.37431818}, {159,0.37409091}, {160,0.37504545}, {161,0.37556364}, {162,0.37708182}, {163,0.37612727}, {164,0.37626364}, {165,0.37745455}, {166,0.37886364}, {167,0.37802727}, {168,0.37850909}, {169,0.38005455}, {170,0.37857273}, {171,0.38130909}, {172,0.38116364}, {173,0.38127273}, {174,0.38022727}, {175,0.38211818}, {176,0.38333636}, {177,0.38200000}, {178,0.38319091}, {179,0.38396364}, {180,0.38443636}, {181,0.38270000}, {182,0.41813636}, {183,0.38525455}, {184,0.38782727}, {185,0.38866364}, {186,0.38770909}, {187,0.38801818}, {188,0.38702727}, {189,0.38946364}, {190,0.38739091}, {191,0.38843636}, {192,0.38807273}, {193,0.39040909}, {194,0.39115455}, {195,0.39128182}, {196,0.39252727}, {197,0.39300000}, {198,0.39211818}, {199,0.39030000}, {200,0.39390000}, {201,0.39200000}, {202,0.39414545}, {203,0.39420909}, {204,0.39245455}, {205,0.39321818}, {206,0.39558182}, {207,0.39619091}, {208,0.39543636}, {209,0.39822727}, {210,0.39780909}, {211,0.43406364}, {212,0.39693636}, {213,0.39740909}, {214,0.39720000}, {215,0.39777273}, {216,0.39994545}, {217,0.39902727}, {218,0.40036364}, {219,0.39981818}, {220,0.40094545}, {221,0.40072727}, {222,0.40220909}, {223,0.40439091}, {224,0.40395455}, {225,0.40420000}, {226,0.40458182}, {227,0.40730000}, {228,0.40530909}, {229,0.40743636}, {230,0.40917273}, {231,0.40906364}, {232,0.40693636}, {233,0.40898182}, {234,0.40943636}, {235,0.40769091}, {236,0.40973636}, {237,0.44465455}, {238,0.40857273}, {239,0.41189091}, {240,0.41222727}, {241,0.41080909}, {242,0.41086364}, {243,0.41538182}, {244,0.41283636}, {245,0.41559091}, {246,0.41374545}, {247,0.41669091}, {248,0.41692727}, {249,0.41525455}, {250,0.41617273}, {251,0.41817273}, {252,0.41789091}, {253,0.41919091}, {254,0.41800000}, {255,0.41898182}, {256,0.41705455}, {257,0.41980909}, {258,0.41827273}, {259,0.42102727}, {260,0.45014545}, {261,0.42496364}, {262,0.42204545}, {263,0.42483636}, {264,0.42439091}, {265,0.42150909}, {266,0.42667273}, {267,0.42629091}, {268,0.42690909}, {269,0.42404545}, {270,0.42795455}, {271,0.42710000}, {272,0.42766364}, {273,0.42931818}, {274,0.42863636}, {275,0.42875455}, {276,0.42706364}, {277,0.43039091}, {278,0.43113636}, {279,0.43098182}, {280,0.43179091}, {281,0.45916364}, {282,0.43450000}, {283,0.43346364}, {284,0.43598182}, {285,0.43454545}, {286,0.43350000}, {287,0.43640909}, {288,0.43775455}, {289,0.43745455}, {290,0.43555455}, {291,0.43982727}, {292,0.43856364}, {293,0.43809091}, {294,0.44022727}, {295,0.44130000}, {296,0.44265455}, {297,0.43934545}, {298,0.44258182}, {299,0.44381818}, {300,0.44075455}, {301,0.47388182}, {302,0.44632727}, {303,0.44470909}, {304,0.44600909}, {305,0.44794545}, {306,0.44675455}, {307,0.44883636}, {308,0.44526364}, {309,0.44918182}, {310,0.44967273}, {311,0.44665455}, {312,0.44890000}, {313,0.44739091}, {314,0.44992727}, {315,0.44941818}, {316,0.44930909}, {317,0.44800909}, {318,0.44800000}, {319,0.45170000}, {320,0.48205455}, {321,0.45090909}, {322,0.45439091}, {323,0.45424545}, {324,0.45475455}, {325,0.45540000}, {326,0.45432727}, {327,0.45816364}, {328,0.45805455}, {329,0.45716364}, {330,0.45831818}, {331,0.45949091}, {332,0.46006364}, {333,0.45978182}, {334,0.45958182}, {335,0.46078182}, {336,0.46129091}, {337,0.46057273}, {338,0.49118182}, {339,0.46155455}, {340,0.46256364}, {341,0.46430909}, {342,0.46530909}, {343,0.46637273}, {344,0.46606364}, {345,0.46572727}, {346,0.46879091}, {347,0.46663636}, {348,0.46828182}, {349,0.46849091}, {350,0.47028182}, {351,0.46827273}, {352,0.47099091}, {353,0.47067273}, {354,0.47035455}, {355,0.49751818}, {356,0.47325455}, {357,0.47407273}, {358,0.47344545}, {359,0.47463636}, {360,0.47625455}, {361,0.47314545}, {362,0.47954545}, {363,0.47857273}, {364,0.47945455}, {365,0.47710909}, {366,0.48072727}, {367,0.47962727}, {368,0.47975455}, {369,0.48557273}, {370,0.48289091}, {371,0.51033636}, {372,0.48522727}, {373,0.48511818}, {374,0.48230909}, {375,0.48470000}, {376,0.48293636}, {377,0.48682727}, {378,0.48652727}, {379,0.49200909}, {380,0.48726364}, {381,0.48502727}, {382,0.49080909}, {383,0.48922727}, {384,0.49072727}, {385,0.49213636}, {386,0.52202727}, {387,0.49179091}, {388,0.49044545}, {389,0.49223636}, {390,0.49327273}, {391,0.49378182}, {392,0.49381818}, {393,0.49500000}, {394,0.49500909}, {395,0.49620909}, {396,0.49395455}, {397,0.49594545}, {398,0.49745455}, {399,0.49883636}, {400,0.50093636}, {401,0.53254545}, {402,0.50550909}, {403,0.50118182}, {404,0.50680909}, {405,0.50430909}, {406,0.50720000}, {407,0.50683636}, {408,0.50763636}, {409,0.50907273}, {410,0.50980000}, {411,0.51088182}, {412,0.50582727}, {413,0.51179091}, {414,0.51360000}, {415,0.54583636}, {416,0.51300000}, {417,0.50976364}, {418,0.51240909}, {419,0.51031818}, {420,0.51444545}, {421,0.51689091}, {422,0.51741818}, {423,0.51775455}, {424,0.51928182}, {425,0.51967273}, {426,0.51905455}, {427,0.52051818}, {428,0.52211818}, {429,0.55278182}, {430,0.52187273}, {431,0.52208182}, {432,0.52221818}, {433,0.52578182}, {434,0.52505455}, {435,0.52520000}, {436,0.52513636}, {437,0.52618182}, {438,0.52688182}, {439,0.52667273}, {440,0.52900909}, {441,0.53257273}, {442,0.52904545}, {443,0.53180000}, {444,0.53113636}, {445,0.53061818}, {446,0.53268182}, {447,0.53441818}, {448,0.53170000}, {449,0.53100909}, {450,0.53319091}, {451,0.53610909}, {452,0.53685455}, {453,0.53556364}, {454,0.53680000}, {455,0.53673636}, {456,0.56814545}, {457,0.53777273}, {458,0.53790909}, {459,0.53943636}, {460,0.53945455}, {461,0.54580000}, {462,0.54237273}, {463,0.54443636}, {464,0.54429091}, {465,0.54462727}, {466,0.54541818}, {467,0.54578182}, {468,0.58209091}, {469,0.54810000}, {470,0.54579091}, {471,0.54771818}, {472,0.55130909}, {473,0.55107273}, {474,0.55350909}, {475,0.55328182}, {476,0.55188182}, {477,0.55183636}, {478,0.55398182}, {479,0.55485455}, {480,0.55559091}, {481,0.59100909}, {482,0.56034545}, {483,0.55886364}, {484,0.56018182}, {485,0.56220000}, {486,0.56364545}, {487,0.56057273}, {488,0.56133636}, {489,0.56333636}, {490,0.55962727}, {491,0.56538182}, {492,0.57070000}, {493,0.61176364}, {494,0.56565455}, {495,0.57130000}, {496,0.57812727}, {497,0.56832727}, {498,0.56637273}, {499,0.56702727}, {500,0.57012727}, {505,0.57371818}, {510,0.57835455}, {515,0.57942727}, {520,0.60355455}, {525,0.58810909}, {530,0.59005455}, {535,0.59740909}, {540,0.60268182}, {545,0.60126364}, {550,0.60991818}, {555,0.61440909}, {560,0.61694545}, {565,0.62800909}, {570,0.62363636}, {575,0.65641818}, {580,0.64006364}, {585,0.63504545}, {590,0.64422727}, {595,0.64412727}, {600,0.65208182}, {605,0.65460000}, {610,0.65911818}, {615,0.66227273}, {620,0.66904545}, {625,0.69071818}, {630,0.67299091}, {635,0.67883636}, {640,0.69388182}, {645,0.69434545}, {650,0.69420909}, {655,0.70248182}, {660,0.70527273}, {665,0.71220909}, {670,0.73313636}, {675,0.71895455}, {680,0.72614545}, {685,0.72281818}, {690,0.73191818}, {695,0.73500000}, {700,0.74881818}, {705,0.74419091}, {710,0.77116364}, {715,0.76230909}, {720,0.76744545}, {725,0.76099091}, {730,0.77450000}, {735,0.77942727}, {740,0.78790909}, {745,0.79169091}, {750,0.80771818}, {755,0.79760000}, {760,0.80637273}, {765,0.81088182}, {770,0.81331818}, {775,0.82319091}, {780,0.82967273}, {785,0.83607273}, {790,0.86150909}, {795,0.84927273}, {800,0.84895455}, {805,0.60575}, {810,0.62600}, {815,0.64350}, {820,0.64400}, {825,0.65125}, {830,0.64475}, {835,0.64925}, {840,0.65600}, {845,0.66475}, {850,0.66925}, {855,0.67250}, {860,0.68375}, {865,0.69825}, {870,0.68675}, {875,0.69475}, {880,0.72250}, {885,0.75550}, {890,0.79050}, {895,0.73325}, {900,0.71950}, {905,0.73225}, {910,0.72975}, {915,0.76750}, {920,0.76775}, {925,0.76500}, {930,0.76350}, {935,0.78100}, {940,0.80375}, {945,0.80600}, {950,0.83975}, {955,0.82075}, {960,0.81750}, {965,0.82175}, {970,0.81700}, {975,0.82475}, {980,0.83250}, {985,0.87450}, {990,0.87100}, {995,0.84450}, {1000,0.86450}, {1010,0.88850}, {1020,0.88725}, {1030,0.97375}, {1040,0.92750}, {1050,1.03700}, {1060,0.94475}, {1070,0.99875}, {1080,0.98350}, {1090,1.00725}, {1100,1.02650}, {1110,1.04875}, {1120,1.05750}, {1130,1.06200}, {1140,1.06725}, {1150,1.08225}, {1160,1.10350}, {1170,1.11325}, {1180,1.16300}, {1190,1.30350}, {1200,1.16525}, {1210,1.19450}, {1220,1.20875}, {1230,1.18150}, {1240,1.25750}, {1250,1.25825}, {1260,1.30150}, {1270,1.32675}, {1280,1.35350}, {1290,1.37125}, {1300,1.35600}, {1310,1.40350}, {1320,1.45750}, {1330,1.45100}, {1340,1.43150}, {1350,1.52250}, {1360,1.49175}, {1370,1.59400}, {1380,1.74275}, {1390,1.57775}, {1400,1.71125}, {1410,1.64875}, {1420,1.68125}, {1430,1.65975}, {1440,1.64975}, {1450,1.68050}, {1460,1.71850}, {1470,1.71050}, {1480,1.69300}, {1490,1.73250}, {1500,1.73575}, {1510,1.81650}, {1520,1.73275}, {1530,1.91900}, {1540,1.95025}, {1550,2.04750}, {1560,1.98150}, {1570,1.98450}, {1580,2.43150}, {1590,2.35050}, {1600,2.07200}, {1610,2.33375}, {1620,2.08100}, {1630,2.21350}, {1640,2.11875}, {1650,2.29175}, {1660,2.22975}, {1670,2.33025}, {1680,2.22175}, {1690,2.30375}, {1700,2.18400}, {1710,2.39700}, {1720,2.17375}, {1730,2.45850}, {1740,2.43350}, {1750,2.49225}, {1760,2.43850}, {1770,2.42825}, {1780,2.54675}, {1790,2.48500}, {1800,2.64250}, {1810,2.64125}, {1820,2.56050}, {1830,2.69225}, {1840,2.60400}, {1850,2.71575}, {1860,2.62500}, {1870,2.75925}, {1880,2.59025}, {1890,2.76025}, {1900,2.72050}, {1910,2.80225}, {1920,2.79525}, {1930,2.95650}, {1940,2.72775}, {1950,2.90525}, {1960,2.79575}, {1970,2.94125}, {1980,2.89425}, {1990,2.97675}, {2000,2.99700}, {2050,3.17300}, {2100,3.77875}, {2150,3.39125}, {2200,3.71300}, {2250,3.82800}, {2300,3.94025}, {2350,4.14225}, {2400,4.88325}, {2450,4.45275}, {2500,4.70925}, {2550,4.75425}, {2600,4.91425}, {2650,5.19025}, {2700,5.29825}, {2750,5.57975}, {2800,5.76950}, {2850,6.36575}, {2900,5.99375}, {2950,6.09125}, {3000,6.31725}, {3050,6.58375}, {3100,6.88075}, {3150,7.32525}, {3200,7.39050}, {3250,7.78925}, {3300,7.74775}, {3350,8.37250}, {3400,8.41575}, {3450,8.92150}, {3500,9.11575}, {3550,9.36475}, {3600,10.44750}, {3650,10.66675}, {3700,10.11375}, {3750,10.34150}, {3800,10.63125}, {3850,11.10825}, {3900,11.58450}, {3950,11.33100}, {4000,11.60525}, {4050,10.95}, {4100,12.046}, {4150,12.604}, {4200,14.271}, {4250,14.579}, {4300,13.487}, {4350,13.452}, {4400,14.044}, {4450,14.493}, {4500,14.319}, {4550,14.877}, {4600,14.487}, {4650,15.78}, {4700,16.234}, {4750,17.34}, {4800,17.647}, {4850,17.647}, {4900,17.667}, {4950,18.048}, {5000,18.411}};
data["big"]["identity native_compute"]["Stats"]["user"] = {{1,0.00130000}, {2,0.00121818}, {3,0.00112727}, {4,0.00096364}, {5,0.00133636}, {6,0.00156364}, {7,0.00120909}, {8,0.00124545}, {9,0.00116364}, {10,0.00126364}, {11,0.00144545}, {12,0.00143636}, {13,0.00140909}, {14,0.00163636}, {15,0.00169091}, {16,0.00209091}, {17,0.00173636}, {18,0.00160000}, {19,0.00205455}, {20,0.00233636}, {21,0.00203636}, {22,0.00188182}, {23,0.00220000}, {24,0.00250909}, {25,0.00235455}, {26,0.00230000}, {27,0.00239091}, {28,0.00241818}, {29,0.00265455}, {30,0.00275455}, {31,0.00204545}, {32,0.00290000}, {33,0.00262727}, {34,0.00269091}, {35,0.00291818}, {36,0.00323636}, {37,0.00294545}, {38,0.00340000}, {39,0.00293636}, {40,0.00363636}, {41,0.00340909}, {42,0.00327273}, {43,0.00351818}, {44,0.00333636}, {45,0.00334545}, {46,0.00310000}, {47,0.00399091}, {48,0.00390909}, {49,0.00380000}, {50,0.00404545}, {51,0.08206364}, {52,0.00408182}, {53,0.00360000}, {54,0.00428182}, {55,0.00415455}, {56,0.00438182}, {57,0.00504545}, {58,0.00456364}, {59,0.00439091}, {60,0.00460909}, {61,0.00440000}, {62,0.00422727}, {63,0.00439091}, {64,0.00421818}, {65,0.00474545}, {66,0.00493636}, {67,0.00468182}, {68,0.00496364}, {69,0.00431818}, {70,0.00486364}, {71,0.00509091}, {72,0.00520909}, {73,0.00543636}, {74,0.00497273}, {75,0.00524545}, {76,0.00578182}, {77,0.00568182}, {78,0.00560000}, {79,0.00580000}, {80,0.00558182}, {81,0.00576364}, {82,0.00580000}, {83,0.00570000}, {84,0.00575455}, {85,0.00560909}, {86,0.00616364}, {87,0.00601818}, {88,0.00654545}, {89,0.00678182}, {90,0.00609091}, {91,0.00604545}, {92,0.00660000}, {93,0.00638182}, {94,0.00661818}, {95,0.00714545}, {96,0.00703636}, {97,0.00651818}, {98,0.00625455}, {99,0.00719091}, {100,0.00705455}, {101,0.00704545}, {102,0.06606364}, {103,0.00699091}, {104,0.00759091}, {105,0.00708182}, {106,0.00705455}, {107,0.00730909}, {108,0.00740909}, {109,0.00788182}, {110,0.00788182}, {111,0.00771818}, {112,0.00768182}, {113,0.00786364}, {114,0.00801818}, {115,0.00860909}, {116,0.00816364}, {117,0.00820000}, {118,0.00828182}, {119,0.00857273}, {120,0.00919091}, {121,0.00849091}, {122,0.00834545}, {123,0.00903636}, {124,0.00867273}, {125,0.00914545}, {126,0.00889091}, {127,0.00901818}, {128,0.00902727}, {129,0.00894545}, {130,0.01016364}, {131,0.00905455}, {132,0.00936364}, {133,0.00991818}, {134,0.00938182}, {135,0.00959091}, {136,0.01008182}, {137,0.01008182}, {138,0.01052727}, {139,0.00985455}, {140,0.01040000}, {141,0.01005455}, {142,0.01030000}, {143,0.01066364}, {144,0.01038182}, {145,0.01137273}, {146,0.01071818}, {147,0.06176364}, {148,0.01115455}, {149,0.01070909}, {150,0.01121818}, {151,0.01077273}, {152,0.01105455}, {153,0.01157273}, {154,0.01124545}, {155,0.01100909}, {156,0.01088182}, {157,0.01178182}, {158,0.01155455}, {159,0.01100909}, {160,0.01255455}, {161,0.01162727}, {162,0.01170000}, {163,0.01180000}, {164,0.01185455}, {165,0.01195455}, {166,0.01240000}, {167,0.01251818}, {168,0.01283636}, {169,0.01203636}, {170,0.01296364}, {171,0.01254545}, {172,0.01242727}, {173,0.01311818}, {174,0.01294545}, {175,0.01275455}, {176,0.01265455}, {177,0.01335455}, {178,0.01299091}, {179,0.01335455}, {180,0.01293636}, {181,0.01347273}, {182,0.04576364}, {183,0.01303636}, {184,0.01370909}, {185,0.01369091}, {186,0.01353636}, {187,0.01387273}, {188,0.01350000}, {189,0.01433636}, {190,0.01420909}, {191,0.01395455}, {192,0.01395455}, {193,0.01479091}, {194,0.01442727}, {195,0.01457273}, {196,0.01421818}, {197,0.01468182}, {198,0.01490000}, {199,0.01464545}, {200,0.01442727}, {201,0.01490000}, {202,0.01548182}, {203,0.01530000}, {204,0.01536364}, {205,0.01559091}, {206,0.01505455}, {207,0.01530000}, {208,0.01558182}, {209,0.01515455}, {210,0.01595455}, {211,0.05177273}, {212,0.01567273}, {213,0.01564545}, {214,0.01600000}, {215,0.01562727}, {216,0.01618182}, {217,0.01591818}, {218,0.01630000}, {219,0.01630909}, {220,0.01654545}, {221,0.01591818}, {222,0.01699091}, {223,0.01664545}, {224,0.01673636}, {225,0.01674545}, {226,0.01687273}, {227,0.01710000}, {228,0.01751818}, {229,0.01734545}, {230,0.01683636}, {231,0.01741818}, {232,0.01740000}, {233,0.01727273}, {234,0.01730000}, {235,0.01724545}, {236,0.01775455}, {237,0.05029091}, {238,0.01813636}, {239,0.01821818}, {240,0.01838182}, {241,0.01773636}, {242,0.01810000}, {243,0.01826364}, {244,0.01787273}, {245,0.01893636}, {246,0.01903636}, {247,0.01900000}, {248,0.01900909}, {249,0.01888182}, {250,0.01888182}, {251,0.01878182}, {252,0.01916364}, {253,0.01917273}, {254,0.01863636}, {255,0.01900909}, {256,0.01899091}, {257,0.01947273}, {258,0.02000000}, {259,0.01999091}, {260,0.04954545}, {261,0.02033636}, {262,0.02026364}, {263,0.02028182}, {264,0.02033636}, {265,0.02072727}, {266,0.01976364}, {267,0.02050000}, {268,0.02070000}, {269,0.02053636}, {270,0.02095455}, {271,0.02079091}, {272,0.02086364}, {273,0.02083636}, {274,0.02080000}, {275,0.02119091}, {276,0.02090000}, {277,0.02160000}, {278,0.02155455}, {279,0.02127273}, {280,0.02178182}, {281,0.04866364}, {282,0.02208182}, {283,0.02219091}, {284,0.02171818}, {285,0.02234545}, {286,0.02226364}, {287,0.02280909}, {288,0.02220000}, {289,0.02257273}, {290,0.02269091}, {291,0.02263636}, {292,0.02293636}, {293,0.02312727}, {294,0.02302727}, {295,0.02312727}, {296,0.02343636}, {297,0.02369091}, {298,0.02358182}, {299,0.02337273}, {300,0.02348182}, {301,0.05330909}, {302,0.02352727}, {303,0.02366364}, {304,0.02380000}, {305,0.02345455}, {306,0.02450909}, {307,0.02414545}, {308,0.02422727}, {309,0.02458182}, {310,0.02422727}, {311,0.02483636}, {312,0.02483636}, {313,0.02519091}, {314,0.02453636}, {315,0.02546364}, {316,0.02520909}, {317,0.02548182}, {318,0.02549091}, {319,0.02492727}, {320,0.05461818}, {321,0.02516364}, {322,0.02574545}, {323,0.02564545}, {324,0.02555455}, {325,0.02538182}, {326,0.02631818}, {327,0.02606364}, {328,0.02562727}, {329,0.02609091}, {330,0.02598182}, {331,0.02654545}, {332,0.02646364}, {333,0.02670000}, {334,0.02664545}, {335,0.02683636}, {336,0.02690000}, {337,0.02679091}, {338,0.05384545}, {339,0.02713636}, {340,0.02742727}, {341,0.02708182}, {342,0.02732727}, {343,0.02785455}, {344,0.02745455}, {345,0.02770000}, {346,0.02735455}, {347,0.02758182}, {348,0.02751818}, {349,0.02803636}, {350,0.02795455}, {351,0.02817273}, {352,0.02803636}, {353,0.02800909}, {354,0.02806364}, {355,0.05526364}, {356,0.02870909}, {357,0.02841818}, {358,0.02880909}, {359,0.02875455}, {360,0.02945455}, {361,0.02933636}, {362,0.02927273}, {363,0.02948182}, {364,0.02933636}, {365,0.02920000}, {366,0.02991818}, {367,0.02939091}, {368,0.02971818}, {369,0.03014545}, {370,0.02985455}, {371,0.05720909}, {372,0.03025455}, {373,0.03030000}, {374,0.03050909}, {375,0.03053636}, {376,0.03106364}, {377,0.03119091}, {378,0.03084545}, {379,0.03086364}, {380,0.03068182}, {381,0.03133636}, {382,0.03090909}, {383,0.03092727}, {384,0.03120000}, {385,0.03141818}, {386,0.06180000}, {387,0.03139091}, {388,0.03185455}, {389,0.03230909}, {390,0.03190000}, {391,0.03238182}, {392,0.03183636}, {393,0.03223636}, {394,0.03166364}, {395,0.03279091}, {396,0.03277273}, {397,0.03225455}, {398,0.03318182}, {399,0.03285455}, {400,0.03276364}, {401,0.06358182}, {402,0.03288182}, {403,0.03322727}, {404,0.03360000}, {405,0.03348182}, {406,0.03403636}, {407,0.03402727}, {408,0.03383636}, {409,0.03352727}, {410,0.03440000}, {411,0.03431818}, {412,0.03440909}, {413,0.03420000}, {414,0.03434545}, {415,0.06670909}, {416,0.03460000}, {417,0.03484545}, {418,0.03520000}, {419,0.03502727}, {420,0.03577273}, {421,0.03510000}, {422,0.03525455}, {423,0.03515455}, {424,0.03537273}, {425,0.03533636}, {426,0.03570909}, {427,0.03606364}, {428,0.03558182}, {429,0.06770000}, {430,0.03563636}, {431,0.03628182}, {432,0.03689091}, {433,0.03647273}, {434,0.03663636}, {435,0.03740000}, {436,0.03720000}, {437,0.03641818}, {438,0.03733636}, {439,0.03691818}, {440,0.03723636}, {441,0.03710000}, {442,0.03772727}, {443,0.03848182}, {444,0.03687273}, {445,0.03743636}, {446,0.03747273}, {447,0.03815455}, {448,0.03830909}, {449,0.03850909}, {450,0.03852727}, {451,0.03814545}, {452,0.03789091}, {453,0.03873636}, {454,0.03851818}, {455,0.03847273}, {456,0.06910909}, {457,0.03883636}, {458,0.03943636}, {459,0.03880909}, {460,0.04002727}, {461,0.03939091}, {462,0.03935455}, {463,0.03964545}, {464,0.03939091}, {465,0.03941818}, {466,0.03945455}, {467,0.03998182}, {468,0.07455455}, {469,0.04007273}, {470,0.04063636}, {471,0.04050000}, {472,0.04051818}, {473,0.04077273}, {474,0.04058182}, {475,0.04078182}, {476,0.04090909}, {477,0.04080909}, {478,0.04153636}, {479,0.04130000}, {480,0.04117273}, {481,0.07487273}, {482,0.04133636}, {483,0.04140909}, {484,0.04184545}, {485,0.04255455}, {486,0.04190000}, {487,0.04198182}, {488,0.04230000}, {489,0.04212727}, {490,0.04210909}, {491,0.04180909}, {492,0.04308182}, {493,0.08047273}, {494,0.04278182}, {495,0.04304545}, {496,0.04307273}, {497,0.04349091}, {498,0.04319091}, {499,0.04367273}, {500,0.04356364}, {505,0.04383636}, {510,0.04449091}, {515,0.04492727}, {520,0.06100000}, {525,0.04604545}, {530,0.04614545}, {535,0.04661818}, {540,0.04729091}, {545,0.04696364}, {550,0.04819091}, {555,0.04860909}, {560,0.04910909}, {565,0.04970000}, {570,0.04969091}, {575,0.06693636}, {580,0.05082727}, {585,0.05116364}, {590,0.05210000}, {595,0.05230909}, {600,0.05259091}, {605,0.05296364}, {610,0.05337273}, {615,0.05430000}, {620,0.05438182}, {625,0.07187273}, {630,0.05600000}, {635,0.05580000}, {640,0.05602727}, {645,0.05634545}, {650,0.05740909}, {655,0.05787273}, {660,0.05790909}, {665,0.05810909}, {670,0.07430909}, {675,0.05925455}, {680,0.05970909}, {685,0.06025455}, {690,0.06086364}, {695,0.06150909}, {700,0.06162727}, {705,0.06253636}, {710,0.07679091}, {715,0.06325455}, {720,0.06395455}, {725,0.06442727}, {730,0.06487273}, {735,0.06538182}, {740,0.06550909}, {745,0.06656364}, {750,0.08138182}, {755,0.06720909}, {760,0.06773636}, {765,0.06872727}, {770,0.06857273}, {775,0.06846364}, {780,0.06940909}, {785,0.06982727}, {790,0.08611818}, {795,0.07116364}, {800,0.07109091}, {805,0.01900}, {810,0.01625}, {815,0.03075}, {820,0.01900}, {825,0.02625}, {830,0.02050}, {835,0.01850}, {840,0.01925}, {845,0.02025}, {850,0.02700}, {855,0.01950}, {860,0.02675}, {865,0.02000}, {870,0.01925}, {875,0.02125}, {880,0.01925}, {885,0.02650}, {890,0.02325}, {895,0.02575}, {900,0.02400}, {905,0.02325}, {910,0.01975}, {915,0.02850}, {920,0.02125}, {925,0.02575}, {930,0.01925}, {935,0.02450}, {940,0.02400}, {945,0.02350}, {950,0.02850}, {955,0.02300}, {960,0.02225}, {965,0.02150}, {970,0.02750}, {975,0.02450}, {980,0.02825}, {985,0.02275}, {990,0.02825}, {995,0.02300}, {1000,0.02675}, {1010,0.02225}, {1020,0.02950}, {1030,0.02950}, {1040,0.02825}, {1050,0.02650}, {1060,0.02550}, {1070,0.03250}, {1080,0.02950}, {1090,0.03050}, {1100,0.02625}, {1110,0.02675}, {1120,0.02925}, {1130,0.03375}, {1140,0.03450}, {1150,0.02950}, {1160,0.02875}, {1170,0.02825}, {1180,0.03400}, {1190,0.03525}, {1200,0.03175}, {1210,0.02975}, {1220,0.03025}, {1230,0.03675}, {1240,0.04075}, {1250,0.03350}, {1260,0.02950}, {1270,0.03350}, {1280,0.03725}, {1290,0.03950}, {1300,0.03225}, {1310,0.03225}, {1320,0.03775}, {1330,0.04075}, {1340,0.03850}, {1350,0.03775}, {1360,0.03450}, {1370,0.03225}, {1380,0.04075}, {1390,0.03575}, {1400,0.03775}, {1410,0.04025}, {1420,0.04575}, {1430,0.03575}, {1440,0.03925}, {1450,0.04200}, {1460,0.04800}, {1470,0.03650}, {1480,0.03850}, {1490,0.04325}, {1500,0.04800}, {1510,0.04150}, {1520,0.04025}, {1530,0.04425}, {1540,0.05150}, {1550,0.04175}, {1560,0.04150}, {1570,0.04625}, {1580,0.05550}, {1590,0.04375}, {1600,0.05075}, {1610,0.05150}, {1620,0.04325}, {1630,0.04450}, {1640,0.05350}, {1650,0.05550}, {1660,0.04625}, {1670,0.04650}, {1680,0.05375}, {1690,0.05875}, {1700,0.04300}, {1710,0.05300}, {1720,0.05125}, {1730,0.04750}, {1740,0.04750}, {1750,0.04825}, {1760,0.04700}, {1770,0.04650}, {1780,0.05250}, {1790,0.05325}, {1800,0.04825}, {1810,0.05550}, {1820,0.05550}, {1830,0.05250}, {1840,0.05475}, {1850,0.05425}, {1860,0.05150}, {1870,0.05250}, {1880,0.06100}, {1890,0.05350}, {1900,0.05400}, {1910,0.05725}, {1920,0.05825}, {1930,0.05450}, {1940,0.06025}, {1950,0.05950}, {1960,0.05650}, {1970,0.06350}, {1980,0.05725}, {1990,0.05775}, {2000,0.06150}, {2050,0.06400}, {2100,0.05700}, {2150,0.06725}, {2200,0.06425}, {2250,0.06950}, {2300,0.07175}, {2350,0.06875}, {2400,0.07375}, {2450,0.07450}, {2500,0.07350}, {2550,0.07975}, {2600,0.07475}, {2650,0.08850}, {2700,0.07675}, {2750,0.09350}, {2800,0.08200}, {2850,0.08825}, {2900,0.08675}, {2950,0.09750}, {3000,0.09075}, {3050,0.09775}, {3100,0.09400}, {3150,0.11100}, {3200,0.09425}, {3250,0.10850}, {3300,0.09650}, {3350,0.11225}, {3400,0.10575}, {3450,0.11175}, {3500,0.11550}, {3550,0.10950}, {3600,0.12400}, {3650,0.11425}, {3700,0.11975}, {3750,0.13550}, {3800,0.11700}, {3850,0.12550}, {3900,0.12750}, {3950,0.11750}, {4000,0.13875}, {4050,0.087}, {4100,0.091}, {4150,0.108}, {4200,0.104}, {4250,0.092}, {4300,0.115}, {4350,0.112}, {4400,0.12}, {4450,0.1}, {4500,0.111}, {4550,0.119}, {4600,0.123}, {4650,0.103}, {4700,0.131}, {4750,0.139}, {4800,0.14}, {4850,0.14}, {4900,0.104}, {4950,0.139}, {5000,0.128}};
data["big"]["identity native_compute"]["Stats"]["system"] = {{1,0.00440909}, {2,0.00507273}, {3,0.00520909}, {4,0.00496364}, {5,0.00505455}, {6,0.00479091}, {7,0.00509091}, {8,0.00553636}, {9,0.00520909}, {10,0.00528182}, {11,0.00490909}, {12,0.00502727}, {13,0.00541818}, {14,0.00519091}, {15,0.00494545}, {16,0.00488182}, {17,0.00530000}, {18,0.00498182}, {19,0.00503636}, {20,0.00478182}, {21,0.00502727}, {22,0.00543636}, {23,0.00498182}, {24,0.00485455}, {25,0.00510000}, {26,0.00520909}, {27,0.00517273}, {28,0.00497273}, {29,0.00500000}, {30,0.00494545}, {31,0.00549091}, {32,0.00459091}, {33,0.00541818}, {34,0.00488182}, {35,0.00500000}, {36,0.00474545}, {37,0.00501818}, {38,0.00481818}, {39,0.00511818}, {40,0.00454545}, {41,0.00487273}, {42,0.00510000}, {43,0.00534545}, {44,0.00483636}, {45,0.00520000}, {46,0.00560909}, {47,0.00484545}, {48,0.00497273}, {49,0.00483636}, {50,0.00477273}, {51,0.00579091}, {52,0.00517273}, {53,0.00509091}, {54,0.00520000}, {55,0.00499091}, {56,0.00496364}, {57,0.00541818}, {58,0.00488182}, {59,0.00497273}, {60,0.00495455}, {61,0.00509091}, {62,0.00556364}, {63,0.00518182}, {64,0.00543636}, {65,0.00500909}, {66,0.00510000}, {67,0.00540000}, {68,0.00524545}, {69,0.00570909}, {70,0.00522727}, {71,0.00542727}, {72,0.00499091}, {73,0.00519091}, {74,0.00519091}, {75,0.00513636}, {76,0.00503636}, {77,0.00489091}, {78,0.00507273}, {79,0.00505455}, {80,0.00513636}, {81,0.00530909}, {82,0.00520000}, {83,0.00517273}, {84,0.00552727}, {85,0.00544545}, {86,0.00515455}, {87,0.00520000}, {88,0.00513636}, {89,0.00486364}, {90,0.00531818}, {91,0.00544545}, {92,0.00520909}, {93,0.00545455}, {94,0.00536364}, {95,0.00485455}, {96,0.00524545}, {97,0.00548182}, {98,0.00591818}, {99,0.00507273}, {100,0.00538182}, {101,0.00544545}, {102,0.00628182}, {103,0.00530000}, {104,0.00531818}, {105,0.00550909}, {106,0.00576364}, {107,0.00541818}, {108,0.00524545}, {109,0.00526364}, {110,0.00550909}, {111,0.00515455}, {112,0.00562727}, {113,0.00540909}, {114,0.00513636}, {115,0.00493636}, {116,0.00540000}, {117,0.00557273}, {118,0.00543636}, {119,0.00533636}, {120,0.00556364}, {121,0.00535455}, {122,0.00576364}, {123,0.00519091}, {124,0.00533636}, {125,0.00535455}, {126,0.00521818}, {127,0.00572727}, {128,0.00537273}, {129,0.00527273}, {130,0.00501818}, {131,0.00556364}, {132,0.00562727}, {133,0.00515455}, {134,0.00570000}, {135,0.00537273}, {136,0.00504545}, {137,0.00529091}, {138,0.00513636}, {139,0.00540909}, {140,0.00508182}, {141,0.00565455}, {142,0.00525455}, {143,0.00527273}, {144,0.00544545}, {145,0.00462727}, {146,0.00530000}, {147,0.00619091}, {148,0.00524545}, {149,0.00545455}, {150,0.00530909}, {151,0.00559091}, {152,0.00534545}, {153,0.00506364}, {154,0.00561818}, {155,0.00562727}, {156,0.00584545}, {157,0.00561818}, {158,0.00562727}, {159,0.00573636}, {160,0.00525455}, {161,0.00560909}, {162,0.00559091}, {163,0.00568182}, {164,0.00564545}, {165,0.00576364}, {166,0.00522727}, {167,0.00515455}, {168,0.00499091}, {169,0.00574545}, {170,0.00515455}, {171,0.00542727}, {172,0.00577273}, {173,0.00530909}, {174,0.00547273}, {175,0.00557273}, {176,0.00603636}, {177,0.00520909}, {178,0.00580909}, {179,0.00542727}, {180,0.00565455}, {181,0.00559091}, {182,0.00616364}, {183,0.00602727}, {184,0.00549091}, {185,0.00554545}, {186,0.00548182}, {187,0.00558182}, {188,0.00578182}, {189,0.00504545}, {190,0.00550000}, {191,0.00570909}, {192,0.00572727}, {193,0.00545455}, {194,0.00567273}, {195,0.00554545}, {196,0.00565455}, {197,0.00580909}, {198,0.00558182}, {199,0.00548182}, {200,0.00616364}, {201,0.00550000}, {202,0.00493636}, {203,0.00541818}, {204,0.00557273}, {205,0.00520000}, {206,0.00581818}, {207,0.00593636}, {208,0.00584545}, {209,0.00580909}, {210,0.00549091}, {211,0.00670000}, {212,0.00582727}, {213,0.00562727}, {214,0.00572727}, {215,0.00608182}, {216,0.00553636}, {217,0.00564545}, {218,0.00588182}, {219,0.00586364}, {220,0.00549091}, {221,0.00644545}, {222,0.00524545}, {223,0.00584545}, {224,0.00557273}, {225,0.00564545}, {226,0.00570000}, {227,0.00544545}, {228,0.00537273}, {229,0.00564545}, {230,0.00581818}, {231,0.00568182}, {232,0.00587273}, {233,0.00590909}, {234,0.00608182}, {235,0.00606364}, {236,0.00568182}, {237,0.00654545}, {238,0.00546364}, {239,0.00571818}, {240,0.00563636}, {241,0.00597273}, {242,0.00588182}, {243,0.00579091}, {244,0.00604545}, {245,0.00580000}, {246,0.00552727}, {247,0.00540000}, {248,0.00572727}, {249,0.00589091}, {250,0.00569091}, {251,0.00595455}, {252,0.00561818}, {253,0.00617273}, {254,0.00626364}, {255,0.00633636}, {256,0.00608182}, {257,0.00610000}, {258,0.00557273}, {259,0.00549091}, {260,0.00634545}, {261,0.00543636}, {262,0.00570909}, {263,0.00546364}, {264,0.00570909}, {265,0.00558182}, {266,0.00623636}, {267,0.00621818}, {268,0.00620909}, {269,0.00597273}, {270,0.00567273}, {271,0.00603636}, {272,0.00563636}, {273,0.00633636}, {274,0.00609091}, {275,0.00594545}, {276,0.00599091}, {277,0.00572727}, {278,0.00566364}, {279,0.00607273}, {280,0.00593636}, {281,0.00640909}, {282,0.00621818}, {283,0.00586364}, {284,0.00603636}, {285,0.00578182}, {286,0.00595455}, {287,0.00582727}, {288,0.00601818}, {289,0.00589091}, {290,0.00570000}, {291,0.00576364}, {292,0.00603636}, {293,0.00578182}, {294,0.00641818}, {295,0.00599091}, {296,0.00588182}, {297,0.00567273}, {298,0.00597273}, {299,0.00608182}, {300,0.00580909}, {301,0.00668182}, {302,0.00637273}, {303,0.00604545}, {304,0.00602727}, {305,0.00630909}, {306,0.00580000}, {307,0.00595455}, {308,0.00665455}, {309,0.00563636}, {310,0.00614545}, {311,0.00578182}, {312,0.00574545}, {313,0.00592727}, {314,0.00610000}, {315,0.00564545}, {316,0.00590909}, {317,0.00571818}, {318,0.00568182}, {319,0.00653636}, {320,0.00694545}, {321,0.00633636}, {322,0.00595455}, {323,0.00620000}, {324,0.00627273}, {325,0.00628182}, {326,0.00600909}, {327,0.00598182}, {328,0.00612727}, {329,0.00637273}, {330,0.00639091}, {331,0.00610000}, {332,0.00587273}, {333,0.00602727}, {334,0.00601818}, {335,0.00602727}, {336,0.00608182}, {337,0.00636364}, {338,0.00710000}, {339,0.00590909}, {340,0.00620909}, {341,0.00610000}, {342,0.00630000}, {343,0.00575455}, {344,0.00630909}, {345,0.00576364}, {346,0.00680909}, {347,0.00620909}, {348,0.00616364}, {349,0.00629091}, {350,0.00614545}, {351,0.00603636}, {352,0.00627273}, {353,0.00657273}, {354,0.00651818}, {355,0.00634545}, {356,0.00623636}, {357,0.00642727}, {358,0.00606364}, {359,0.00640909}, {360,0.00604545}, {361,0.00576364}, {362,0.00629091}, {363,0.00613636}, {364,0.00596364}, {365,0.00650000}, {366,0.00614545}, {367,0.00655455}, {368,0.00648182}, {369,0.00608182}, {370,0.00614545}, {371,0.00696364}, {372,0.00606364}, {373,0.00594545}, {374,0.00644545}, {375,0.00605455}, {376,0.00587273}, {377,0.00597273}, {378,0.00608182}, {379,0.00610909}, {380,0.00661818}, {381,0.00601818}, {382,0.00641818}, {383,0.00658182}, {384,0.00635455}, {385,0.00616364}, {386,0.00663636}, {387,0.00615455}, {388,0.00610000}, {389,0.00608182}, {390,0.00621818}, {391,0.00652727}, {392,0.00643636}, {393,0.00651818}, {394,0.00678182}, {395,0.00630909}, {396,0.00610000}, {397,0.00647273}, {398,0.00594545}, {399,0.00608182}, {400,0.00661818}, {401,0.00656364}, {402,0.00634545}, {403,0.00660909}, {404,0.00609091}, {405,0.00615455}, {406,0.00610909}, {407,0.00609091}, {408,0.00600909}, {409,0.00683636}, {410,0.00627273}, {411,0.00612727}, {412,0.00616364}, {413,0.00670000}, {414,0.00630909}, {415,0.00672727}, {416,0.00652727}, {417,0.00629091}, {418,0.00594545}, {419,0.00623636}, {420,0.00610000}, {421,0.00626364}, {422,0.00623636}, {423,0.00686364}, {424,0.00657273}, {425,0.00672727}, {426,0.00629091}, {427,0.00630000}, {428,0.00691818}, {429,0.00666364}, {430,0.00685455}, {431,0.00608182}, {432,0.00610909}, {433,0.00626364}, {434,0.00683636}, {435,0.00580909}, {436,0.00596364}, {437,0.00638182}, {438,0.00624545}, {439,0.00629091}, {440,0.00666364}, {441,0.00647273}, {442,0.00605455}, {443,0.00685455}, {444,0.00706364}, {445,0.00683636}, {446,0.00655455}, {447,0.00657273}, {448,0.00629091}, {449,0.00638182}, {450,0.00643636}, {451,0.00654545}, {452,0.00674545}, {453,0.00629091}, {454,0.00668182}, {455,0.00670909}, {456,0.00715455}, {457,0.00654545}, {458,0.00624545}, {459,0.00649091}, {460,0.00643636}, {461,0.00644545}, {462,0.00680909}, {463,0.00660000}, {464,0.00676364}, {465,0.00672727}, {466,0.00690909}, {467,0.00667273}, {468,0.00727273}, {469,0.00637273}, {470,0.00640000}, {471,0.00660000}, {472,0.00662727}, {473,0.00685455}, {474,0.00700909}, {475,0.00654545}, {476,0.00705455}, {477,0.00651818}, {478,0.00641818}, {479,0.00645455}, {480,0.00681818}, {481,0.00650000}, {482,0.00675455}, {483,0.00675455}, {484,0.00643636}, {485,0.00670000}, {486,0.00665455}, {487,0.00669091}, {488,0.00668182}, {489,0.00669091}, {490,0.00685455}, {491,0.00688182}, {492,0.00589091}, {493,0.00704545}, {494,0.00668182}, {495,0.00649091}, {496,0.00682727}, {497,0.00684545}, {498,0.00670000}, {499,0.00647273}, {500,0.00677273}, {505,0.00671818}, {510,0.00645455}, {515,0.00670909}, {520,0.00762727}, {525,0.00630000}, {530,0.00696364}, {535,0.00675455}, {540,0.00683636}, {545,0.00732727}, {550,0.00653636}, {555,0.00668182}, {560,0.00641818}, {565,0.00668182}, {570,0.00683636}, {575,0.00765455}, {580,0.00690000}, {585,0.00700909}, {590,0.00647273}, {595,0.00677273}, {600,0.00665455}, {605,0.00709091}, {610,0.00680000}, {615,0.00660909}, {620,0.00661818}, {625,0.00678182}, {630,0.00646364}, {635,0.00672727}, {640,0.00710000}, {645,0.00700000}, {650,0.00649091}, {655,0.00681818}, {660,0.00707273}, {665,0.00705455}, {670,0.00766364}, {675,0.00719091}, {680,0.00708182}, {685,0.00702727}, {690,0.00689091}, {695,0.00694545}, {700,0.00715455}, {705,0.00667273}, {710,0.00770000}, {715,0.00698182}, {720,0.00697273}, {725,0.00702727}, {730,0.00693636}, {735,0.00696364}, {740,0.00729091}, {745,0.00677273}, {750,0.00756364}, {755,0.00708182}, {760,0.00680000}, {765,0.00641818}, {770,0.00726364}, {775,0.00717273}, {780,0.00725455}, {785,0.00726364}, {790,0.00723636}, {795,0.00665455}, {800,0.00744545}, {805,0.00200}, {810,0.00700}, {815,0.00500}, {820,0.00300}, {825,0.00675}, {830,0.00200}, {835,0.00400}, {840,0.00400}, {845,0.00400}, {850,0.00300}, {855,0.00400}, {860,0.00300}, {865,0.00300}, {870,0.00500}, {875,0.00300}, {880,0.00400}, {885,0.00500}, {890,0.00300}, {895,0.00400}, {900,0.00300}, {905,0.00175}, {910,0.00600}, {915,0.00300}, {920,0.00400}, {925,0.00475}, {930,0.00500}, {935,0.00300}, {940,0.00300}, {945,0.00300}, {950,0.00300}, {955,0.00400}, {960,0.00500}, {965,0.00500}, {970,0.00075}, {975,0.00300}, {980,0.00500}, {985,0.00700}, {990,0.00300}, {995,0.00400}, {1000,0.00300}, {1010,0.00600}, {1020,0.00400}, {1030,0.00600}, {1040,0.00300}, {1050,0.00300}, {1060,0.00400}, {1070,0.00400}, {1080,0.00300}, {1090,0.00600}, {1100,0.00600}, {1110,0.00500}, {1120,0.00500}, {1130,0.00400}, {1140,0.00300}, {1150,0.00400}, {1160,0.00600}, {1170,0.00600}, {1180,0.00675}, {1190,0.00400}, {1200,0.00375}, {1210,0.00475}, {1220,0.00400}, {1230,0.00600}, {1240,0.00200}, {1250,0.00300}, {1260,0.00600}, {1270,0.00400}, {1280,0.00500}, {1290,0.00500}, {1300,0.00500}, {1310,0.00400}, {1320,0.00600}, {1330,0.00375}, {1340,0.00300}, {1350,0.00300}, {1360,0.00600}, {1370,0.00700}, {1380,0.00800}, {1390,0.00500}, {1400,0.00500}, {1410,0.00700}, {1420,0.00500}, {1430,0.00700}, {1440,0.00400}, {1450,0.00500}, {1460,0.00600}, {1470,0.00575}, {1480,0.00400}, {1490,0.00600}, {1500,0.00700}, {1510,0.00300}, {1520,0.00500}, {1530,0.00600}, {1540,0.00400}, {1550,0.00500}, {1560,0.00500}, {1570,0.00600}, {1580,0.00300}, {1590,0.00400}, {1600,0.00400}, {1610,0.00775}, {1620,0.00375}, {1630,0.00375}, {1640,0.00500}, {1650,0.00400}, {1660,0.00200}, {1670,0.00500}, {1680,0.00500}, {1690,0.00400}, {1700,0.00900}, {1710,0.00400}, {1720,0.00600}, {1730,0.00400}, {1740,0.00500}, {1750,0.00700}, {1760,0.00600}, {1770,0.00700}, {1780,0.00700}, {1790,0.00600}, {1800,0.00600}, {1810,0.00500}, {1820,0.00600}, {1830,0.00400}, {1840,0.00700}, {1850,0.00600}, {1860,0.00600}, {1870,0.00400}, {1880,0.00300}, {1890,0.00400}, {1900,0.00475}, {1910,0.00600}, {1920,0.00600}, {1930,0.00400}, {1940,0.00400}, {1950,0.00700}, {1960,0.00400}, {1970,0.00300}, {1980,0.00800}, {1990,0.00500}, {2000,0.00500}, {2050,0.00500}, {2100,0.00900}, {2150,0.00600}, {2200,0.00400}, {2250,0.00500}, {2300,0.00600}, {2350,0.00600}, {2400,0.00900}, {2450,0.00700}, {2500,0.00900}, {2550,0.00700}, {2600,0.00600}, {2650,0.00800}, {2700,0.00700}, {2750,0.00800}, {2800,0.00700}, {2850,0.00750}, {2900,0.00900}, {2950,0.00400}, {3000,0.00800}, {3050,0.00600}, {3100,0.00800}, {3150,0.00400}, {3200,0.00700}, {3250,0.01075}, {3300,0.00775}, {3350,0.00700}, {3400,0.00800}, {3450,0.00500}, {3500,0.00875}, {3550,0.00400}, {3600,0.00700}, {3650,0.00800}, {3700,0.00775}, {3750,0.00500}, {3800,0.00600}, {3850,0.01000}, {3900,0.00800}, {3950,0.00700}, {4000,0.00700}, {4050,0.007}, {4100,0}, {4150,0.004}, {4200,0.004}, {4250,0.008}, {4300,0}, {4350,0.008}, {4400,0.004}, {4450,0.004}, {4500,0.004}, {4550,0.016}, {4600,0.008}, {4650,0.008}, {4700,0.004}, {4750,0}, {4800,0.004}, {4850,0.004}, {4900,0.011}, {4950,0.008}, {5000,0.02}};
data["big"]["identity simpl"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000909}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00001818}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00001818}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00028182}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000909}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00001818}, {311,0.00000000}, {312,0.00005455}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00002727}, {317,0.00002727}, {318,0.00003636}, {319,0.00003636}, {320,0.00004545}, {321,0.00006364}, {322,0.00015455}, {323,0.00019091}, {324,0.00020000}, {325,0.00021818}, {326,0.00034545}, {327,0.00041818}, {328,0.00039091}, {329,0.00051818}, {330,0.00064545}, {331,0.00058182}, {332,0.00067273}, {333,0.00072727}, {334,0.00073636}, {335,0.00079091}, {336,0.00080000}, {337,0.00082727}, {338,0.00080909}, {339,0.00082727}, {340,0.00085455}, {341,0.00086364}, {342,0.00087273}, {343,0.00087273}, {344,0.00087273}, {345,0.00088182}, {346,0.00090000}, {347,0.00090909}, {348,0.00090909}, {349,0.00092727}, {350,0.00096364}, {351,0.00098182}, {352,0.00099091}, {353,0.00100000}, {354,0.00100000}, {355,0.00100000}, {356,0.00100000}, {357,0.00100000}, {358,0.00100000}, {359,0.00100000}, {360,0.00100000}, {361,0.00100000}, {362,0.00100000}, {363,0.00100000}, {364,0.00100000}, {365,0.00100000}, {366,0.00100000}, {367,0.00100000}, {368,0.00100000}, {369,0.00100000}, {370,0.00102727}, {371,0.00100000}, {372,0.00100000}, {373,0.00100000}, {374,0.00100000}, {375,0.00100000}, {376,0.00100000}, {377,0.00100000}, {378,0.00100000}, {379,0.00100000}, {380,0.00100000}, {381,0.00100000}, {382,0.00100000}, {383,0.00100000}, {384,0.00102727}, {385,0.00100000}, {386,0.00100000}, {387,0.00100000}, {388,0.00100000}, {389,0.00100000}, {390,0.00100000}, {391,0.00100000}, {392,0.00100000}, {393,0.00100000}, {394,0.00100000}, {395,0.00100000}, {396,0.00100000}, {397,0.00100000}, {398,0.00100000}, {399,0.00100000}, {400,0.00100000}, {401,0.00100000}, {402,0.00100000}, {403,0.00100000}, {404,0.00100000}, {405,0.00100000}, {406,0.00100000}, {407,0.00100000}, {408,0.00100000}, {409,0.00100000}, {410,0.00100000}, {411,0.00100000}, {412,0.00100000}, {413,0.00100000}, {414,0.00100000}, {415,0.00100000}, {416,0.00100909}, {417,0.00100000}, {418,0.00100000}, {419,0.00100000}, {420,0.00100000}, {421,0.00100000}, {422,0.00100000}, {423,0.00100000}, {424,0.00100000}, {425,0.00100000}, {426,0.00100000}, {427,0.00100000}, {428,0.00100000}, {429,0.00100000}, {430,0.00100000}, {431,0.00100000}, {432,0.00100000}, {433,0.00100000}, {434,0.00100000}, {435,0.00100000}, {436,0.00100000}, {437,0.00100000}, {438,0.00100000}, {439,0.00100000}, {440,0.00100000}, {441,0.00100000}, {442,0.00100000}, {443,0.00100000}, {444,0.00100000}, {445,0.00100000}, {446,0.00100000}, {447,0.00100000}, {448,0.00100000}, {449,0.00100000}, {450,0.00100000}, {451,0.00100000}, {452,0.00100000}, {453,0.00100000}, {454,0.00100000}, {455,0.00100000}, {456,0.00100000}, {457,0.00100000}, {458,0.00100000}, {459,0.00100000}, {460,0.00100000}, {461,0.00100000}, {462,0.00100000}, {463,0.00100000}, {464,0.00100000}, {465,0.00100000}, {466,0.00100909}, {467,0.00100000}, {468,0.00100000}, {469,0.00100909}, {470,0.00100000}, {471,0.00102727}, {472,0.00101818}, {473,0.00103636}, {474,0.00107273}, {475,0.00103636}, {476,0.00109091}, {477,0.00109091}, {478,0.00116364}, {479,0.00119091}, {480,0.00120909}, {481,0.00119091}, {482,0.00120000}, {483,0.00120909}, {484,0.00120000}, {485,0.00120000}, {486,0.00120000}, {487,0.00120909}, {488,0.00121818}, {489,0.00122727}, {490,0.00124545}, {491,0.00126364}, {492,0.00128182}, {493,0.00129091}, {494,0.00128182}, {495,0.00128182}, {496,0.00132727}, {497,0.00130000}, {498,0.00132727}, {499,0.00138182}, {500,0.00135455}, {505,0.00163636}, {510,0.00184545}, {515,0.00191818}, {520,0.00195455}, {525,0.00200000}, {530,0.00200000}, {535,0.00200000}, {540,0.00200000}, {545,0.00200000}, {550,0.00200000}, {555,0.00200000}, {560,0.00200000}, {565,0.00200000}, {570,0.00200909}, {575,0.00211818}, {580,0.00222727}, {585,0.00221818}, {590,0.00223636}, {595,0.00227273}, {600,0.00261818}, {605,0.00282727}, {610,0.00285455}, {615,0.00299091}, {620,0.00300000}, {625,0.00300000}, {630,0.00300000}, {635,0.00300000}, {640,0.00300000}, {645,0.00300000}, {650,0.00300909}, {655,0.00307273}, {660,0.00320000}, {665,0.00320000}, {670,0.00321818}, {675,0.00331818}, {680,0.00379091}, {685,0.00389091}, {690,0.00396364}, {695,0.00400000}, {700,0.00400000}, {705,0.00400000}, {710,0.00400000}, {715,0.00400000}, {720,0.00404545}, {725,0.00401818}, {730,0.00413636}, {735,0.00418182}, {740,0.00422727}, {745,0.00439091}, {750,0.00479091}, {755,0.00487273}, {760,0.00496364}, {765,0.00500000}, {770,0.00741818}, {775,0.00500000}, {780,0.00500000}, {785,0.00500000}, {790,0.00500909}, {795,0.00511818}, {800,0.00518182}, {805,0.00519091}, {810,0.00540000}, {815,0.00580909}, {820,0.00591818}, {825,0.00599091}, {830,0.00600000}, {835,0.00600000}, {840,0.00600909}, {845,0.00600000}, {850,0.00600000}, {855,0.00612727}, {860,0.00616364}, {865,0.00618182}, {870,0.00629091}, {875,0.01044545}, {880,0.00688182}, {885,0.00694545}, {890,0.00700000}, {895,0.00700000}, {900,0.00700000}, {905,0.00700000}, {910,0.00700000}, {915,0.00710909}, {920,0.00716364}, {925,0.00721818}, {930,0.00745455}, {935,0.00783636}, {940,0.00790000}, {945,0.00800909}, {950,0.00800000}, {955,0.00817273}, {960,0.00800909}, {965,0.00800909}, {970,0.00810000}, {975,0.00815455}, {980,0.00822727}, {985,0.00856364}, {990,0.00885455}, {995,0.00897273}, {1000,0.00897273}, {1010,0.00900000}, {1020,0.00903636}, {1030,0.00916364}, {1040,0.00977273}, {1050,0.00997273}, {1060,0.01000909}, {1070,0.01012727}, {1080,0.01017273}, {1090,0.01080909}, {1100,0.01570000}, {1110,0.01101818}, {1120,0.01110000}, {1130,0.01120000}, {1140,0.01189091}, {1150,0.01200000}, {1160,0.01205455}, {1170,0.01216364}, {1180,0.01251818}, {1190,0.01289091}, {1200,0.01301818}, {1210,0.01311818}, {1220,0.01321818}, {1230,0.01382727}, {1240,0.01400909}, {1250,0.01410000}, {1260,0.01417273}, {1270,0.01469091}, {1280,0.01500000}, {1290,0.01509091}, {1300,0.01970909}, {1310,0.01560909}, {1320,0.01594545}, {1330,0.01616364}, {1340,0.01620000}, {1350,0.01659091}, {1360,0.02234545}, {1370,0.01712727}, {1380,0.01719091}, {1390,0.01762727}, {1400,0.01797273}, {1410,0.01814545}, {1420,0.01825455}, {1430,0.01878182}, {1440,0.01915455}, {1450,0.01913636}, {1460,0.01929091}, {1470,0.01988182}, {1480,0.02011818}, {1490,0.02028182}, {1500,0.02040000}, {1510,0.02096364}, {1520,0.02115455}, {1530,0.02129091}, {1540,0.02180000}, {1550,0.02215455}, {1560,0.02229091}, {1570,0.02249091}, {1580,0.02301818}, {1590,0.02324545}, {1600,0.02343636}, {1610,0.02390000}, {1620,0.02420909}, {1630,0.02437273}, {1640,0.02919091}, {1650,0.02513636}, {1660,0.02530000}, {1670,0.02567273}, {1680,0.03309091}, {1690,0.02630909}, {1700,0.02641818}, {1710,0.02697273}, {1720,0.02733636}, {1730,0.02756364}, {1740,0.02792727}, {1750,0.03526364}, {1760,0.02840909}, {1770,0.02891818}, {1780,0.02931818}, {1790,0.02942727}, {1800,0.02990909}, {1810,0.03021818}, {1820,0.03043636}, {1830,0.03117273}, {1840,0.03132727}, {1850,0.03930909}, {1860,0.03215455}, {1870,0.03233636}, {1880,0.03255455}, {1890,0.03309091}, {1900,0.03334545}, {1910,0.03371818}, {1920,0.03427273}, {1930,0.03459091}, {1940,0.03483636}, {1950,0.03526364}, {1960,0.03566364}, {1970,0.03592727}, {1980,0.03642727}, {1990,0.03674545}, {2000,0.03716364}, {2050,0.03913636}, {2100,0.04116364}, {2150,0.04335455}, {2200,0.04557273}, {2250,0.04765455}, {2300,0.05000000}, {2350,0.06165455}, {2400,0.05492727}, {2450,0.05760909}, {2500,0.06039091}, {2550,0.06352727}, {2600,0.06613636}, {2650,0.06932727}, {2700,0.07232727}, {2750,0.07598182}, {2800,0.07988182}, {2850,0.08310909}, {2900,0.08710000}, {2950,0.09074545}, {3000,0.09366364}, {3050,0.11075}, {3100,0.11450}, {3150,0.11825}, {3200,0.12400}, {3250,0.12800}, {3300,0.13350}, {3350,0.13925}, {3400,0.14325}, {3450,0.14800}, {3500,0.13175}, {3550,0.15425}, {3600,0.14025}, {3650,0.14675}, {3700,0.15050}, {3750,0.16975}, {3800,0.15975}, {3850,0.19250}, {3900,0.17050}, {3950,0.21775}, {4000,0.21525}, {4050,0.29025}, {4100,0.22725}, {4150,0.25100}, {4200,0.24300}, {4250,0.25425}, {4300,0.26200}, {4350,0.27200}, {4400,0.28450}, {4450,0.29750}, {4500,0.31250}, {4550,0.32250}, {4600,0.27075}, {4650,0.35950}, {4700,0.39475}, {4750,0.35950}, {4800,0.38200}, {4850,0.35400}, {4900,0.36950}, {4950,0.38700}, {5000,0.40575}, {5050,0.46475}, {5100,0.44150}, {5150,0.46575}, {5200,0.52475}, {5250,0.49625}, {5300,0.51725}, {5350,0.53525}, {5400,0.55575}, {5450,0.57475}, {5500,0.65075}, {5550,0.61350}, {5600,0.63400}, {5650,0.65475}, {5700,0.67350}, {5750,0.69625}, {5800,0.71800}, {5850,0.73875}, {5900,0.78525}, {5950,0.81450}, {6000,0.83650}, {6050,0.89425}, {6100,0.88900}, {6150,0.90350}, {6200,0.92475}, {6250,0.94700}, {6300,1.00200}, {6350,1.02825}, {6400,1.05100}, {6450,1.10100}, {6500,1.09625}, {6550,1.08525}, {6600,1.26300}, {6650,1.13175}, {6700,1.15925}, {6750,1.23075}, {6800,1.16700}, {6850,1.19050}, {6900,1.21600}, {6950,1.30600}, {7000,1.26700}, {7050,1.29675}, {7100,1.35200}, {7150,1.37575}, {7200,1.34850}, {7250,1.45875}, {7300,1.45600}, {7350,1.48175}, {7400,1.51800}, {7450,1.55925}, {7500,1.61975}, {7550,1.55525}, {7600,1.57925}, {7650,1.66750}, {7700,1.63500}, {7750,1.67500}, {7800,1.70000}, {7850,1.72225}, {7900,1.75000}, {7950,1.77825}, {8000,1.83575}, {8050,1.84650}, {8100,1.86150}, {8150,1.89175}, {8200,1.92100}, {8250,1.94600}, {8300,1.97450}, {8350,1.99300}, {8400,2.10575}, {8450,2.11725}, {8500,2.09300}, {8550,2.15875}, {8600,2.21925}, {8650,2.25575}, {8700,2.28850}, {8750,2.31500}, {8800,2.34450}, {8850,2.38100}, {8900,2.40975}, {8950,2.44975}, {9000,2.45025}, {9050,2.47125}, {9100,2.56425}, {9150,2.64425}, {9200,2.67525}, {9250,2.70825}, {9300,2.58625}, {9350,2.68900}, {9400,2.60925}, {9450,2.74300}, {9500,2.83700}, {9550,2.87750}, {9600,2.87125}, {9650,2.90600}, {9700,3.07450}, {9750,2.97750}, {9800,2.78450}, {9850,2.92200}, {9900,3.08175}, {9950,3.12475}, {10000,3.12275}, {10100,2.9965}, {10200,3.2940}, {10300,3.3540}, {10400,3.4140}, {10500,3.455}, {10600,3.524}, {10700,3.62}, {10800,3.693}, {10900,3.765}, {11000,3.461}, {11100,4.027}, {11200,4.124}, {11300,3.487}, {11400,3.667}, {11500,4.028}, {11600,4.396}, {11700,4.49}, {11800,4.575}, {11900,4.374}, {12000,4.02}, {12100,3.991}, {12200,4.913}, {12300,5.029}, {12400,5.047}, {12500,5.112}, {12600,5.193}, {12700,5.287}, {12800,5.355}, {12900,5.461}, {13000,5.581}, {13100,5.647}, {13200,5.743}, {13300,5.891}, {13400,5.964}, {13500,6.112}, {13600,6.134}, {13700,6.228}, {13800,6.345}, {13900,6.444}, {14000,6.562}, {14100,6.704}, {14200,6.762}, {14300,6.821}, {14400,6.935}, {14500,7.044}, {14600,7.137}, {14700,7.263}, {14800,7.329}, {14900,7.459}, {15000,7.722}, {15100,7.695}, {15200,7.785}, {15300,8.036}, {15400,8.338}, {15500,8.127}, {15600,8.238}, {15700,8.368}, {15800,8.453}, {15900,8.569}, {16000,8.84}, {16100,8.823}, {16200,8.887}, {16300,9.043}, {16400,9.192}, {16500,9.259}, {16600,9.384}, {16700,9.492}, {16800,9.627}, {16900,9.73}, {17000,9.85}, {17100,9.98}, {17200,10.091}, {17300,10.229}, {17400,10.364}, {17500,10.459}, {17600,10.6}, {17700,10.72}, {17800,10.819}, {17900,10.964}, {18000,11.116}, {18100,11.222}, {18200,11.385}, {18300,11.523}, {18400,11.629}, {18500,11.772}, {18600,11.889}, {18700,12.016}, {18800,12.204}, {18900,12.285}, {19000,12.425}, {19100,12.563}, {19200,12.717}, {19300,12.857}, {19400,12.974}, {19500,13.101}, {19600,13.348}, {19700,13.394}, {19800,13.605}, {19900,13.66}};
data["big"]["identity simpl"]["Stats"]["user"] = {{1,0.00000000}, {2,0.00002727}, {3,0.00000000}, {4,0.00005455}, {5,0.00002727}, {6,0.00008182}, {7,0.00002727}, {8,0.00000000}, {9,0.00009091}, {10,0.00016364}, {11,0.00008182}, {12,0.00016364}, {13,0.00003636}, {14,0.00006364}, {15,0.00005455}, {16,0.00002727}, {17,0.00008182}, {18,0.00000000}, {19,0.00002727}, {20,0.00006364}, {21,0.00007273}, {22,0.00008182}, {23,0.00010909}, {24,0.00002727}, {25,0.00010000}, {26,0.00005455}, {27,0.00011818}, {28,0.00013636}, {29,0.00003636}, {30,0.00016364}, {31,0.00002727}, {32,0.00006364}, {33,0.00009091}, {34,0.00006364}, {35,0.00010000}, {36,0.00011818}, {37,0.00000000}, {38,0.00006364}, {39,0.00006364}, {40,0.00006364}, {41,0.00021818}, {42,0.00009091}, {43,0.00006364}, {44,0.00016364}, {45,0.00000000}, {46,0.00008182}, {47,0.00013636}, {48,0.00010000}, {49,0.00020000}, {50,0.00012727}, {51,0.00002727}, {52,0.00011818}, {53,0.00024545}, {54,0.00022727}, {55,0.00010000}, {56,0.00005455}, {57,0.00008182}, {58,0.00012727}, {59,0.00015455}, {60,0.00012727}, {61,0.00008182}, {62,0.00011818}, {63,0.00020909}, {64,0.00022727}, {65,0.00012727}, {66,0.00012727}, {67,0.00014545}, {68,0.00011818}, {69,0.00018182}, {70,0.00014545}, {71,0.00009091}, {72,0.00016364}, {73,0.00013636}, {74,0.00016364}, {75,0.00017273}, {76,0.00021818}, {77,0.00009091}, {78,0.00018182}, {79,0.00017273}, {80,0.00016364}, {81,0.00023636}, {82,0.00019091}, {83,0.00009091}, {84,0.00008182}, {85,0.00005455}, {86,0.00014545}, {87,0.00016364}, {88,0.00019091}, {89,0.00015455}, {90,0.00018182}, {91,0.00028182}, {92,0.00030909}, {93,0.00023636}, {94,0.00008182}, {95,0.00009091}, {96,0.00018182}, {97,0.00038182}, {98,0.00011818}, {99,0.00029091}, {100,0.00039091}, {101,0.00024545}, {102,0.00027273}, {103,0.00025455}, {104,0.00024545}, {105,0.00018182}, {106,0.00020909}, {107,0.00010909}, {108,0.00023636}, {109,0.00044545}, {110,0.00016364}, {111,0.00027273}, {112,0.00011818}, {113,0.00016364}, {114,0.00029091}, {115,0.00025455}, {116,0.00029091}, {117,0.00036364}, {118,0.00032727}, {119,0.00027273}, {120,0.00038182}, {121,0.00039091}, {122,0.00032727}, {123,0.00020000}, {124,0.00032727}, {125,0.00025455}, {126,0.00022727}, {127,0.00029091}, {128,0.00034545}, {129,0.00034545}, {130,0.00030909}, {131,0.00020909}, {132,0.00019091}, {133,0.00035455}, {134,0.00030000}, {135,0.00021818}, {136,0.00025455}, {137,0.00029091}, {138,0.00018182}, {139,0.00020000}, {140,0.00026364}, {141,0.00015455}, {142,0.00043636}, {143,0.00034545}, {144,0.00033636}, {145,0.00032727}, {146,0.00038182}, {147,0.00047273}, {148,0.00027273}, {149,0.00032727}, {150,0.00020909}, {151,0.00034545}, {152,0.00045455}, {153,0.00036364}, {154,0.00045455}, {155,0.00025455}, {156,0.00030000}, {157,0.00024545}, {158,0.00034545}, {159,0.00035455}, {160,0.00031818}, {161,0.00030000}, {162,0.00008182}, {163,0.00037273}, {164,0.00041818}, {165,0.00043636}, {166,0.00031818}, {167,0.00039091}, {168,0.00032727}, {169,0.00031818}, {170,0.00060000}, {171,0.00033636}, {172,0.00020909}, {173,0.00040909}, {174,0.00034545}, {175,0.00034545}, {176,0.00034545}, {177,0.00040000}, {178,0.00050000}, {179,0.00022727}, {180,0.00029091}, {181,0.00049091}, {182,0.00027273}, {183,0.00043636}, {184,0.00041818}, {185,0.00046364}, {186,0.00035455}, {187,0.00025455}, {188,0.00042727}, {189,0.00046364}, {190,0.00040000}, {191,0.00035455}, {192,0.00030000}, {193,0.00058182}, {194,0.00047273}, {195,0.00033636}, {196,0.00042727}, {197,0.00046364}, {198,0.00044545}, {199,0.00060000}, {200,0.00051818}, {201,0.00040000}, {202,0.00032727}, {203,0.00016364}, {204,0.00052727}, {205,0.00022727}, {206,0.00050909}, {207,0.00048182}, {208,0.00070000}, {209,0.00063636}, {210,0.00054545}, {211,0.00052727}, {212,0.00033636}, {213,0.00053636}, {214,0.00041818}, {215,0.00040000}, {216,0.00030909}, {217,0.00043636}, {218,0.00058182}, {219,0.00056364}, {220,0.00080909}, {221,0.00053636}, {222,0.00065455}, {223,0.00050000}, {224,0.00036364}, {225,0.00030909}, {226,0.00054545}, {227,0.00049091}, {228,0.00039091}, {229,0.00059091}, {230,0.00070909}, {231,0.00039091}, {232,0.00050909}, {233,0.00056364}, {234,0.00058182}, {235,0.00059091}, {236,0.00046364}, {237,0.00073636}, {238,0.00070909}, {239,0.00062727}, {240,0.00058182}, {241,0.00050000}, {242,0.00040909}, {243,0.00069091}, {244,0.00062727}, {245,0.00049091}, {246,0.00043636}, {247,0.00046364}, {248,0.00047273}, {249,0.00066364}, {250,0.00070909}, {251,0.00053636}, {252,0.00040000}, {253,0.00058182}, {254,0.00060909}, {255,0.00056364}, {256,0.00064545}, {257,0.00068182}, {258,0.00063636}, {259,0.00070000}, {260,0.00047273}, {261,0.00042727}, {262,0.00055455}, {263,0.00057273}, {264,0.00055455}, {265,0.00070000}, {266,0.00072727}, {267,0.00090909}, {268,0.00049091}, {269,0.00060909}, {270,0.00076364}, {271,0.00078182}, {272,0.00061818}, {273,0.00075455}, {274,0.00085455}, {275,0.00050000}, {276,0.00053636}, {277,0.00074545}, {278,0.00070909}, {279,0.00050000}, {280,0.00075455}, {281,0.00060909}, {282,0.00063636}, {283,0.00060000}, {284,0.00058182}, {285,0.00043636}, {286,0.00076364}, {287,0.00064545}, {288,0.00070000}, {289,0.00058182}, {290,0.00063636}, {291,0.00080909}, {292,0.00061818}, {293,0.00084545}, {294,0.00083636}, {295,0.00080909}, {296,0.00058182}, {297,0.00080909}, {298,0.00085455}, {299,0.00056364}, {300,0.00072727}, {301,0.00067273}, {302,0.00070000}, {303,0.00052727}, {304,0.00073636}, {305,0.00080000}, {306,0.00062727}, {307,0.00060909}, {308,0.00071818}, {309,0.00104545}, {310,0.00065455}, {311,0.00062727}, {312,0.00062727}, {313,0.00080909}, {314,0.00066364}, {315,0.00086364}, {316,0.00090000}, {317,0.00075455}, {318,0.00103636}, {319,0.00096364}, {320,0.00077273}, {321,0.00069091}, {322,0.00076364}, {323,0.00086364}, {324,0.00075455}, {325,0.00096364}, {326,0.00066364}, {327,0.00068182}, {328,0.00064545}, {329,0.00100909}, {330,0.00087273}, {331,0.00076364}, {332,0.00079091}, {333,0.00059091}, {334,0.00060000}, {335,0.00090000}, {336,0.00102727}, {337,0.00082727}, {338,0.00122727}, {339,0.00077273}, {340,0.00079091}, {341,0.00097273}, {342,0.00103636}, {343,0.00095455}, {344,0.00090000}, {345,0.00070909}, {346,0.00110000}, {347,0.00094545}, {348,0.00072727}, {349,0.00108182}, {350,0.00096364}, {351,0.00097273}, {352,0.00100000}, {353,0.00108182}, {354,0.00070909}, {355,0.00092727}, {356,0.00064545}, {357,0.00078182}, {358,0.00068182}, {359,0.00071818}, {360,0.00084545}, {361,0.00106364}, {362,0.00089091}, {363,0.00068182}, {364,0.00070909}, {365,0.00076364}, {366,0.00087273}, {367,0.00092727}, {368,0.00098182}, {369,0.00110000}, {370,0.00090000}, {371,0.00100000}, {372,0.00116364}, {373,0.00107273}, {374,0.00090000}, {375,0.00112727}, {376,0.00088182}, {377,0.00087273}, {378,0.00097273}, {379,0.00091818}, {380,0.00118182}, {381,0.00094545}, {382,0.00105455}, {383,0.00118182}, {384,0.00122727}, {385,0.00107273}, {386,0.00107273}, {387,0.00104545}, {388,0.00107273}, {389,0.00121818}, {390,0.00096364}, {391,0.00113636}, {392,0.00096364}, {393,0.00102727}, {394,0.00113636}, {395,0.00108182}, {396,0.00100909}, {397,0.00131818}, {398,0.00120000}, {399,0.00120000}, {400,0.00106364}, {401,0.00121818}, {402,0.00102727}, {403,0.00104545}, {404,0.00119091}, {405,0.00126364}, {406,0.00123636}, {407,0.00107273}, {408,0.00133636}, {409,0.00129091}, {410,0.00082727}, {411,0.00081818}, {412,0.00140000}, {413,0.00093636}, {414,0.00103636}, {415,0.00114545}, {416,0.00113636}, {417,0.00104545}, {418,0.00096364}, {419,0.00133636}, {420,0.00096364}, {421,0.00135455}, {422,0.00101818}, {423,0.00119091}, {424,0.00116364}, {425,0.00111818}, {426,0.00126364}, {427,0.00112727}, {428,0.00138182}, {429,0.00105455}, {430,0.00150909}, {431,0.00133636}, {432,0.00142727}, {433,0.00126364}, {434,0.00120000}, {435,0.00133636}, {436,0.00128182}, {437,0.00127273}, {438,0.00115455}, {439,0.00129091}, {440,0.00115455}, {441,0.00136364}, {442,0.00128182}, {443,0.00133636}, {444,0.00144545}, {445,0.00120000}, {446,0.00110000}, {447,0.00132727}, {448,0.00118182}, {449,0.00130909}, {450,0.00111818}, {451,0.00150909}, {452,0.00158182}, {453,0.00171818}, {454,0.00150909}, {455,0.00141818}, {456,0.00140000}, {457,0.00129091}, {458,0.00141818}, {459,0.00127273}, {460,0.00142727}, {461,0.00131818}, {462,0.00110909}, {463,0.00174545}, {464,0.00148182}, {465,0.00153636}, {466,0.00148182}, {467,0.00155455}, {468,0.00123636}, {469,0.00158182}, {470,0.00146364}, {471,0.00158182}, {472,0.00139091}, {473,0.00127273}, {474,0.00177273}, {475,0.00130000}, {476,0.00147273}, {477,0.00130000}, {478,0.00150000}, {479,0.00150000}, {480,0.00160000}, {481,0.00161818}, {482,0.00160909}, {483,0.00154545}, {484,0.00153636}, {485,0.00166364}, {486,0.00158182}, {487,0.00185455}, {488,0.00150000}, {489,0.00144545}, {490,0.00175455}, {491,0.00142727}, {492,0.00139091}, {493,0.00150909}, {494,0.00155455}, {495,0.00177273}, {496,0.00183636}, {497,0.00162727}, {498,0.00170000}, {499,0.00167273}, {500,0.00191818}, {505,0.00184545}, {510,0.00157273}, {515,0.00172727}, {520,0.00206364}, {525,0.00170909}, {530,0.00188182}, {535,0.00210909}, {540,0.00205455}, {545,0.00205455}, {550,0.00230000}, {555,0.00212727}, {560,0.00219091}, {565,0.00240000}, {570,0.00226364}, {575,0.00233636}, {580,0.00230000}, {585,0.00237273}, {590,0.00257273}, {595,0.00278182}, {600,0.00274545}, {605,0.00250909}, {610,0.00284545}, {615,0.00274545}, {620,0.00273636}, {625,0.00307273}, {630,0.00302727}, {635,0.00305455}, {640,0.00303636}, {645,0.00320000}, {650,0.00329091}, {655,0.00350909}, {660,0.00341818}, {665,0.00351818}, {670,0.00350000}, {675,0.00369091}, {680,0.00373636}, {685,0.00361818}, {690,0.00382727}, {695,0.00418182}, {700,0.00385455}, {705,0.00396364}, {710,0.00396364}, {715,0.00429091}, {720,0.00406364}, {725,0.00417273}, {730,0.00460909}, {735,0.00422727}, {740,0.00426364}, {745,0.00441818}, {750,0.00486364}, {755,0.00469091}, {760,0.00471818}, {765,0.00503636}, {770,0.00730909}, {775,0.00511818}, {780,0.00489091}, {785,0.00489091}, {790,0.00502727}, {795,0.00519091}, {800,0.00517273}, {805,0.00527273}, {810,0.00588182}, {815,0.00538182}, {820,0.00557273}, {825,0.00562727}, {830,0.00552727}, {835,0.00555455}, {840,0.00616364}, {845,0.00617273}, {850,0.00585455}, {855,0.00630000}, {860,0.00625455}, {865,0.00619091}, {870,0.00676364}, {875,0.01090000}, {880,0.00647273}, {885,0.00670909}, {890,0.00660000}, {895,0.00660909}, {900,0.00676364}, {905,0.00673636}, {910,0.00691818}, {915,0.00705455}, {920,0.00728182}, {925,0.00716364}, {930,0.00735455}, {935,0.00740000}, {940,0.00746364}, {945,0.00747273}, {950,0.00752727}, {955,0.00801818}, {960,0.00795455}, {965,0.00799091}, {970,0.00828182}, {975,0.00824545}, {980,0.00863636}, {985,0.00905455}, {990,0.00823636}, {995,0.00881818}, {1000,0.00916364}, {1010,0.00937273}, {1020,0.00933636}, {1030,0.00977273}, {1040,0.00987273}, {1050,0.00989091}, {1060,0.00977273}, {1070,0.01002727}, {1080,0.01050000}, {1090,0.01084545}, {1100,0.01574545}, {1110,0.01150909}, {1120,0.01170000}, {1130,0.01193636}, {1140,0.01213636}, {1150,0.01221818}, {1160,0.01248182}, {1170,0.01262727}, {1180,0.01270909}, {1190,0.01290909}, {1200,0.01283636}, {1210,0.01328182}, {1220,0.01393636}, {1230,0.01388182}, {1240,0.01400909}, {1250,0.01453636}, {1260,0.01435455}, {1270,0.01473636}, {1280,0.01519091}, {1290,0.01520000}, {1300,0.01964545}, {1310,0.01581818}, {1320,0.01606364}, {1330,0.01607273}, {1340,0.01660000}, {1350,0.01664545}, {1360,0.02236364}, {1370,0.01696364}, {1380,0.01720909}, {1390,0.01811818}, {1400,0.01812727}, {1410,0.01819091}, {1420,0.01820000}, {1430,0.01870909}, {1440,0.01890909}, {1450,0.01880909}, {1460,0.01905455}, {1470,0.01961818}, {1480,0.01975455}, {1490,0.02020909}, {1500,0.02060000}, {1510,0.02088182}, {1520,0.02110000}, {1530,0.02135455}, {1540,0.02179091}, {1550,0.02217273}, {1560,0.02266364}, {1570,0.02284545}, {1580,0.02333636}, {1590,0.02344545}, {1600,0.02384545}, {1610,0.02421818}, {1620,0.02437273}, {1630,0.02501818}, {1640,0.02916364}, {1650,0.02528182}, {1660,0.02589091}, {1670,0.02621818}, {1680,0.03308182}, {1690,0.02659091}, {1700,0.02685455}, {1710,0.02698182}, {1720,0.02720909}, {1730,0.02786364}, {1740,0.02790909}, {1750,0.03551818}, {1760,0.02868182}, {1770,0.02905455}, {1780,0.02918182}, {1790,0.02936364}, {1800,0.02942727}, {1810,0.02990000}, {1820,0.03041818}, {1830,0.03113636}, {1840,0.03129091}, {1850,0.03952727}, {1860,0.03191818}, {1870,0.03205455}, {1880,0.03270909}, {1890,0.03275455}, {1900,0.03335455}, {1910,0.03410000}, {1920,0.03458182}, {1930,0.03488182}, {1940,0.03510909}, {1950,0.03534545}, {1960,0.03610909}, {1970,0.03622727}, {1980,0.03673636}, {1990,0.03722727}, {2000,0.03731818}, {2050,0.03929091}, {2100,0.04105455}, {2150,0.04361818}, {2200,0.04554545}, {2250,0.04738182}, {2300,0.05037273}, {2350,0.06174545}, {2400,0.05510000}, {2450,0.05754545}, {2500,0.06076364}, {2550,0.06422727}, {2600,0.06618182}, {2650,0.06930000}, {2700,0.07239091}, {2750,0.07592727}, {2800,0.08015455}, {2850,0.08343636}, {2900,0.08717273}, {2950,0.09048182}, {3000,0.09432727}, {3050,0.11000}, {3100,0.11425}, {3150,0.11625}, {3200,0.12450}, {3250,0.12750}, {3300,0.13325}, {3350,0.13925}, {3400,0.14350}, {3450,0.14675}, {3500,0.13100}, {3550,0.15450}, {3600,0.14000}, {3650,0.14625}, {3700,0.15000}, {3750,0.16925}, {3800,0.15775}, {3850,0.19225}, {3900,0.17100}, {3950,0.21850}, {4000,0.21550}, {4050,0.28950}, {4100,0.22600}, {4150,0.25050}, {4200,0.24250}, {4250,0.25350}, {4300,0.26200}, {4350,0.27025}, {4400,0.28325}, {4450,0.29625}, {4500,0.31175}, {4550,0.32325}, {4600,0.27125}, {4650,0.35900}, {4700,0.39450}, {4750,0.35925}, {4800,0.38150}, {4850,0.35250}, {4900,0.36950}, {4950,0.38650}, {5000,0.40550}, {5050,0.46450}, {5100,0.44100}, {5150,0.46500}, {5200,0.52250}, {5250,0.49675}, {5300,0.51750}, {5350,0.53475}, {5400,0.55575}, {5450,0.57450}, {5500,0.65150}, {5550,0.61425}, {5600,0.63350}, {5650,0.65475}, {5700,0.67350}, {5750,0.69450}, {5800,0.71675}, {5850,0.73975}, {5900,0.78650}, {5950,0.81425}, {6000,0.83650}, {6050,0.89450}, {6100,0.88850}, {6150,0.90350}, {6200,0.92450}, {6250,0.94650}, {6300,1.00250}, {6350,1.02875}, {6400,1.05050}, {6450,1.10075}, {6500,1.09550}, {6550,1.08450}, {6600,1.26250}, {6650,1.13175}, {6700,1.15875}, {6750,1.23000}, {6800,1.16625}, {6850,1.19150}, {6900,1.21475}, {6950,1.30575}, {7000,1.26650}, {7050,1.29550}, {7100,1.35050}, {7150,1.37525}, {7200,1.34850}, {7250,1.45925}, {7300,1.45550}, {7350,1.48025}, {7400,1.51725}, {7450,1.56075}, {7500,1.61925}, {7550,1.55475}, {7600,1.58050}, {7650,1.66800}, {7700,1.63575}, {7750,1.67550}, {7800,1.70075}, {7850,1.72225}, {7900,1.75025}, {7950,1.77650}, {8000,1.83475}, {8050,1.84750}, {8100,1.86025}, {8150,1.89025}, {8200,1.92050}, {8250,1.94625}, {8300,1.97550}, {8350,1.99250}, {8400,2.10425}, {8450,2.11750}, {8500,2.09175}, {8550,2.15750}, {8600,2.21725}, {8650,2.25375}, {8700,2.28825}, {8750,2.31575}, {8800,2.34375}, {8850,2.38150}, {8900,2.40850}, {8950,2.44875}, {9000,2.44750}, {9050,2.47000}, {9100,2.56375}, {9150,2.64225}, {9200,2.67425}, {9250,2.70550}, {9300,2.58550}, {9350,2.68875}, {9400,2.60850}, {9450,2.74225}, {9500,2.83675}, {9550,2.87625}, {9600,2.86850}, {9650,2.90350}, {9700,3.07275}, {9750,2.97700}, {9800,2.78250}, {9850,2.91925}, {9900,3.08000}, {9950,3.12425}, {10000,3.12175}, {10100,2.9935}, {10200,3.2900}, {10300,3.3455}, {10400,3.4060}, {10500,3.451}, {10600,3.524}, {10700,3.62}, {10800,3.692}, {10900,3.764}, {11000,3.459}, {11100,4.024}, {11200,4.124}, {11300,3.483}, {11400,3.663}, {11500,4.028}, {11600,4.396}, {11700,4.491}, {11800,4.576}, {11900,4.376}, {12000,4.019}, {12100,3.992}, {12200,4.912}, {12300,5.028}, {12400,5.044}, {12500,5.111}, {12600,5.192}, {12700,5.288}, {12800,5.355}, {12900,5.459}, {13000,5.584}, {13100,5.644}, {13200,5.744}, {13300,5.891}, {13400,5.964}, {13500,6.112}, {13600,6.136}, {13700,6.228}, {13800,6.347}, {13900,6.443}, {14000,6.559}, {14100,6.703}, {14200,6.763}, {14300,6.824}, {14400,6.936}, {14500,7.048}, {14600,7.135}, {14700,7.264}, {14800,7.331}, {14900,7.46}, {15000,7.724}, {15100,7.695}, {15200,7.784}, {15300,8.036}, {15400,8.336}, {15500,8.127}, {15600,8.236}, {15700,8.367}, {15800,8.451}, {15900,8.568}, {16000,8.84}, {16100,8.824}, {16200,8.887}, {16300,9.043}, {16400,9.192}, {16500,9.259}, {16600,9.388}, {16700,9.492}, {16800,9.628}, {16900,9.728}, {17000,9.852}, {17100,9.979}, {17200,10.091}, {17300,10.231}, {17400,10.363}, {17500,10.46}, {17600,10.6}, {17700,10.719}, {17800,10.815}, {17900,10.963}, {18000,11.115}, {18100,11.22}, {18200,11.384}, {18300,11.524}, {18400,11.631}, {18500,11.771}, {18600,11.892}, {18700,12.015}, {18800,12.203}, {18900,12.283}, {19000,12.424}, {19100,12.559}, {19200,12.716}, {19300,12.856}, {19400,12.976}, {19500,13.1}, {19600,13.347}, {19700,13.396}, {19800,13.603}, {19900,13.659}};
data["big"]["identity simpl"]["Stats"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00003636}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00003636}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00002727}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00003636}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00002727}, {113,0.00003636}, {114,0.00003636}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00003636}, {134,0.00003636}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00003636}, {147,0.00002727}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00003636}, {159,0.00000000}, {160,0.00000000}, {161,0.00003636}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00003636}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00002727}, {185,0.00000000}, {186,0.00003636}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00003636}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00003636}, {206,0.00003636}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00003636}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00003636}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00007273}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00003636}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00007273}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00003636}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00003636}, {263,0.00000000}, {264,0.00000000}, {265,0.00003636}, {266,0.00000000}, {267,0.00003636}, {268,0.00003636}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00003636}, {275,0.00000000}, {276,0.00000000}, {277,0.00003636}, {278,0.00003636}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00003636}, {284,0.00003636}, {285,0.00003636}, {286,0.00003636}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00003636}, {292,0.00007273}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00003636}, {300,0.00003636}, {301,0.00000000}, {302,0.00010909}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00003636}, {307,0.00003636}, {308,0.00002727}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00003636}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00007273}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00003636}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00003636}, {334,0.00003636}, {335,0.00003636}, {336,0.00007273}, {337,0.00002727}, {338,0.00007273}, {339,0.00000000}, {340,0.00000000}, {341,0.00003636}, {342,0.00000000}, {343,0.00003636}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00002727}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00003636}, {360,0.00000000}, {361,0.00003636}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00003636}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00007273}, {372,0.00000000}, {373,0.00000000}, {374,0.00002727}, {375,0.00000000}, {376,0.00003636}, {377,0.00003636}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00007273}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00003636}, {386,0.00000000}, {387,0.00000000}, {388,0.00003636}, {389,0.00003636}, {390,0.00000000}, {391,0.00003636}, {392,0.00003636}, {393,0.00000000}, {394,0.00003636}, {395,0.00003636}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00003636}, {401,0.00003636}, {402,0.00000000}, {403,0.00000000}, {404,0.00007273}, {405,0.00003636}, {406,0.00000000}, {407,0.00002727}, {408,0.00000000}, {409,0.00000000}, {410,0.00003636}, {411,0.00000000}, {412,0.00007273}, {413,0.00003636}, {414,0.00003636}, {415,0.00003636}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00003636}, {420,0.00000000}, {421,0.00000000}, {422,0.00002727}, {423,0.00000000}, {424,0.00003636}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00003636}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00002727}, {437,0.00007273}, {438,0.00003636}, {439,0.00000000}, {440,0.00003636}, {441,0.00007273}, {442,0.00000000}, {443,0.00003636}, {444,0.00000000}, {445,0.00003636}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00003636}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00003636}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00003636}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00003636}, {465,0.00003636}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00007273}, {471,0.00003636}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00006364}, {478,0.00000000}, {479,0.00000000}, {480,0.00002727}, {481,0.00000000}, {482,0.00003636}, {483,0.00003636}, {484,0.00000000}, {485,0.00000000}, {486,0.00002727}, {487,0.00003636}, {488,0.00000000}, {489,0.00000000}, {490,0.00003636}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00007273}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00003636}, {515,0.00007273}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00003636}, {540,0.00000000}, {545,0.00003636}, {550,0.00002727}, {555,0.00003636}, {560,0.00000000}, {565,0.00000000}, {570,0.00007273}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00003636}, {595,0.00000000}, {600,0.00003636}, {605,0.00000000}, {610,0.00000000}, {615,0.00003636}, {620,0.00000000}, {625,0.00003636}, {630,0.00000000}, {635,0.00003636}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00003636}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00003636}, {690,0.00000000}, {695,0.00003636}, {700,0.00000000}, {705,0.00000000}, {710,0.00003636}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00003636}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00014545}, {775,0.00000000}, {780,0.00000000}, {785,0.00002727}, {790,0.00003636}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00003636}, {820,0.00000000}, {825,0.00000000}, {830,0.00007273}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00003636}, {880,0.00003636}, {885,0.00000000}, {890,0.00000000}, {895,0.00003636}, {900,0.00003636}, {905,0.00003636}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00007273}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00007273}, {995,0.00000000}, {1000,0.00002727}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00003636}, {1040,0.00000000}, {1050,0.00003636}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00003636}, {1100,0.00003636}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00003636}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00003636}, {1190,0.00003636}, {1200,0.00003636}, {1210,0.00003636}, {1220,0.00003636}, {1230,0.00000000}, {1240,0.00007273}, {1250,0.00002727}, {1260,0.00000000}, {1270,0.00010000}, {1280,0.00000000}, {1290,0.00003636}, {1300,0.00002727}, {1310,0.00000000}, {1320,0.00002727}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00019091}, {1370,0.00003636}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00003636}, {1420,0.00003636}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00007273}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00003636}, {1530,0.00003636}, {1540,0.00007273}, {1550,0.00003636}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00007273}, {1590,0.00003636}, {1600,0.00000000}, {1610,0.00003636}, {1620,0.00003636}, {1630,0.00000000}, {1640,0.00003636}, {1650,0.00003636}, {1660,0.00000000}, {1670,0.00002727}, {1680,0.00020000}, {1690,0.00003636}, {1700,0.00002727}, {1710,0.00000000}, {1720,0.00007273}, {1730,0.00002727}, {1740,0.00003636}, {1750,0.00014545}, {1760,0.00000000}, {1770,0.00003636}, {1780,0.00000000}, {1790,0.00003636}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00003636}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00010909}, {1950,0.00003636}, {1960,0.00000000}, {1970,0.00002727}, {1980,0.00000000}, {1990,0.00003636}, {2000,0.00000000}, {2050,0.00003636}, {2100,0.00000000}, {2150,0.00007273}, {2200,0.00000000}, {2250,0.00010909}, {2300,0.00003636}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00006364}, {2500,0.00003636}, {2550,0.00000000}, {2600,0.00007273}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00007273}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00003636}, {3000,0.00003636}, {3050,0.00000}, {3100,0.00000}, {3150,0.00000}, {3200,0.00000}, {3250,0.00000}, {3300,0.00000}, {3350,0.00000}, {3400,0.00000}, {3450,0.00100}, {3500,0.00000}, {3550,0.00000}, {3600,0.00000}, {3650,0.00000}, {3700,0.00000}, {3750,0.00000}, {3800,0.00100}, {3850,0.00000}, {3900,0.00000}, {3950,0.00000}, {4000,0.00000}, {4050,0.00000}, {4100,0.00000}, {4150,0.00000}, {4200,0.00000}, {4250,0.00000}, {4300,0.00000}, {4350,0.00000}, {4400,0.00000}, {4450,0.00000}, {4500,0.00000}, {4550,0.00000}, {4600,0.00000}, {4650,0.00000}, {4700,0.00000}, {4750,0.00000}, {4800,0.00000}, {4850,0.00000}, {4900,0.00000}, {4950,0.00000}, {5000,0.00000}, {5050,0.00000}, {5100,0.00000}, {5150,0.00000}, {5200,0.00100}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00100}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00100}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00100}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00100}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00100}, {9800,0.00100}, {9850,0.00075}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.0000}, {10200,0.0000}, {10300,0.0000}, {10400,0.0040}, {10500,0}, {10600,0}, {10700,0}, {10800,0}, {10900,0}, {11000,0}, {11100,0}, {11200,0}, {11300,0}, {11400,0}, {11500,0}, {11600,0}, {11700,0}, {11800,0}, {11900,0}, {12000,0}, {12100,0}, {12200,0}, {12300,0}, {12400,0.004}, {12500,0}, {12600,0}, {12700,0}, {12800,0}, {12900,0}, {13000,0}, {13100,0}, {13200,0}, {13300,0}, {13400,0}, {13500,0}, {13600,0}, {13700,0}, {13800,0}, {13900,0}, {14000,0}, {14100,0}, {14200,0}, {14300,0}, {14400,0}, {14500,0}, {14600,0}, {14700,0}, {14800,0}, {14900,0}, {15000,0}, {15100,0}, {15200,0}, {15300,0}, {15400,0}, {15500,0}, {15600,0}, {15700,0}, {15800,0}, {15900,0}, {16000,0}, {16100,0}, {16200,0}, {16300,0}, {16400,0}, {16500,0}, {16600,0}, {16700,0}, {16800,0}, {16900,0}, {17000,0}, {17100,0}, {17200,0}, {17300,0}, {17400,0}, {17500,0}, {17600,0}, {17700,0}, {17800,0}, {17900,0}, {18000,0}, {18100,0}, {18200,0}, {18300,0}, {18400,0}, {18500,0}, {18600,0}, {18700,0}, {18800,0}, {18900,0}, {19000,0}, {19100,0}, {19200,0}, {19300,0}, {19400,0}, {19500,0}, {19600,0}, {19700,0}, {19800,0}, {19900,0}};
data["big"]["identity vm_compute"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000909}, {141,0.00000000}, {142,0.00010000}, {143,0.00000909}, {144,0.00000000}, {145,0.00001818}, {146,0.00000000}, {147,0.00000909}, {148,0.00001818}, {149,0.00000000}, {150,0.00000909}, {151,0.00001818}, {152,0.00001818}, {153,0.00001818}, {154,0.00000909}, {155,0.00001818}, {156,0.00000909}, {157,0.00000909}, {158,0.00000909}, {159,0.00001818}, {160,0.00000909}, {161,0.00001818}, {162,0.00001818}, {163,0.00000909}, {164,0.00000000}, {165,0.00002727}, {166,0.00001818}, {167,0.00030909}, {168,0.00017273}, {169,0.00020000}, {170,0.00031818}, {171,0.00038182}, {172,0.00051818}, {173,0.00066364}, {174,0.00078182}, {175,0.00087273}, {176,0.00087273}, {177,0.00095455}, {178,0.00099091}, {179,0.00100000}, {180,0.00100000}, {181,0.00100000}, {182,0.00100000}, {183,0.00100000}, {184,0.00100000}, {185,0.00100000}, {186,0.00100000}, {187,0.00100000}, {188,0.00100000}, {189,0.00100000}, {190,0.00100000}, {191,0.00100000}, {192,0.00100000}, {193,0.00100000}, {194,0.00100000}, {195,0.00100000}, {196,0.00100000}, {197,0.00100000}, {198,0.00100000}, {199,0.00100000}, {200,0.00100000}, {201,0.00100000}, {202,0.00100000}, {203,0.00100000}, {204,0.00100000}, {205,0.00100000}, {206,0.00185455}, {207,0.00100000}, {208,0.00100000}, {209,0.00100000}, {210,0.00100000}, {211,0.00100000}, {212,0.00100000}, {213,0.00100000}, {214,0.00100000}, {215,0.00100000}, {216,0.00100000}, {217,0.00100000}, {218,0.00100000}, {219,0.00100000}, {220,0.00100000}, {221,0.00100000}, {222,0.00100000}, {223,0.00100000}, {224,0.00100000}, {225,0.00100000}, {226,0.00100000}, {227,0.00100000}, {228,0.00100000}, {229,0.00100000}, {230,0.00100000}, {231,0.00100000}, {232,0.00100000}, {233,0.00100000}, {234,0.00100000}, {235,0.00100000}, {236,0.00100000}, {237,0.00100000}, {238,0.00100000}, {239,0.00100000}, {240,0.00100000}, {241,0.00100000}, {242,0.00100000}, {243,0.00100000}, {244,0.00100909}, {245,0.00100000}, {246,0.00100000}, {247,0.00100000}, {248,0.00100000}, {249,0.00100000}, {250,0.00100000}, {251,0.00100000}, {252,0.00100000}, {253,0.00100000}, {254,0.00100000}, {255,0.00100000}, {256,0.00100000}, {257,0.00227273}, {258,0.00100000}, {259,0.00100000}, {260,0.00100000}, {261,0.00100000}, {262,0.00100000}, {263,0.00100000}, {264,0.00100000}, {265,0.00100000}, {266,0.00100000}, {267,0.00100000}, {268,0.00100000}, {269,0.00100000}, {270,0.00100000}, {271,0.00100000}, {272,0.00100000}, {273,0.00100000}, {274,0.00100000}, {275,0.00100000}, {276,0.00100000}, {277,0.00100000}, {278,0.00100000}, {279,0.00100000}, {280,0.00100000}, {281,0.00100000}, {282,0.00100000}, {283,0.00100000}, {284,0.00100000}, {285,0.00100000}, {286,0.00100000}, {287,0.00100000}, {288,0.00100000}, {289,0.00100000}, {290,0.00100000}, {291,0.00100000}, {292,0.00100000}, {293,0.00100000}, {294,0.00100000}, {295,0.00100000}, {296,0.00100000}, {297,0.00100000}, {298,0.00100000}, {299,0.00100000}, {300,0.00100000}, {301,0.00100000}, {302,0.00100909}, {303,0.00100000}, {304,0.00100000}, {305,0.00100000}, {306,0.00100000}, {307,0.00100000}, {308,0.00100000}, {309,0.00100000}, {310,0.00100000}, {311,0.00100000}, {312,0.00100909}, {313,0.00100000}, {314,0.00100000}, {315,0.00100000}, {316,0.00100000}, {317,0.00101818}, {318,0.00100000}, {319,0.00100909}, {320,0.00101818}, {321,0.00100000}, {322,0.00100000}, {323,0.00100000}, {324,0.00101818}, {325,0.00101818}, {326,0.00100000}, {327,0.00100000}, {328,0.00100909}, {329,0.00100909}, {330,0.00100000}, {331,0.00100909}, {332,0.00101818}, {333,0.00102727}, {334,0.00100909}, {335,0.00113636}, {336,0.00132727}, {337,0.00105455}, {338,0.00102727}, {339,0.00101818}, {340,0.00104545}, {341,0.00105455}, {342,0.00108182}, {343,0.00119091}, {344,0.00117273}, {345,0.00118182}, {346,0.00122727}, {347,0.00123636}, {348,0.00132727}, {349,0.00130000}, {350,0.00144545}, {351,0.00146364}, {352,0.00146364}, {353,0.00147273}, {354,0.00213636}, {355,0.00160000}, {356,0.00160000}, {357,0.00170909}, {358,0.00167273}, {359,0.00172727}, {360,0.00170000}, {361,0.00176364}, {362,0.00180000}, {363,0.00181818}, {364,0.00188182}, {365,0.00325455}, {366,0.00183636}, {367,0.00185455}, {368,0.00191818}, {369,0.00196364}, {370,0.00194545}, {371,0.00195455}, {372,0.00195455}, {373,0.00196364}, {374,0.00196364}, {375,0.00196364}, {376,0.00199091}, {377,0.00200000}, {378,0.00200000}, {379,0.00200000}, {380,0.00200000}, {381,0.00200000}, {382,0.00200000}, {383,0.00200000}, {384,0.00200000}, {385,0.00200000}, {386,0.00200000}, {387,0.00200000}, {388,0.00200909}, {389,0.00200000}, {390,0.00200000}, {391,0.00200000}, {392,0.00200000}, {393,0.00200000}, {394,0.00200000}, {395,0.00200000}, {396,0.00200000}, {397,0.00200000}, {398,0.00200000}, {399,0.00200000}, {400,0.00200000}, {401,0.00200000}, {402,0.00200000}, {403,0.00200000}, {404,0.00200000}, {405,0.00200000}, {406,0.00200000}, {407,0.00200000}, {408,0.00200000}, {409,0.00201818}, {410,0.00200000}, {411,0.00200000}, {412,0.00200000}, {413,0.00200000}, {414,0.00200000}, {415,0.00200000}, {416,0.00200000}, {417,0.00201818}, {418,0.00200000}, {419,0.00200000}, {420,0.00200000}, {421,0.00200000}, {422,0.00200000}, {423,0.00200000}, {424,0.00201818}, {425,0.00200000}, {426,0.00200000}, {427,0.00200000}, {428,0.00200000}, {429,0.00200000}, {430,0.00200000}, {431,0.00205455}, {432,0.00206364}, {433,0.00200000}, {434,0.00200000}, {435,0.00200000}, {436,0.00200000}, {437,0.00200000}, {438,0.00200000}, {439,0.00200000}, {440,0.00200000}, {441,0.00200000}, {442,0.00200000}, {443,0.00200000}, {444,0.00200000}, {445,0.00200000}, {446,0.00200000}, {447,0.00200000}, {448,0.00200000}, {449,0.00200000}, {450,0.00200000}, {451,0.00200909}, {452,0.00200000}, {453,0.00200000}, {454,0.00200000}, {455,0.00200000}, {456,0.00200000}, {457,0.00200000}, {458,0.00200000}, {459,0.00200000}, {460,0.00200000}, {461,0.00200000}, {462,0.00200000}, {463,0.00200000}, {464,0.00200000}, {465,0.00200000}, {466,0.00200000}, {467,0.00200000}, {468,0.00200000}, {469,0.00200000}, {470,0.00200000}, {471,0.00200000}, {472,0.00204545}, {473,0.00206364}, {474,0.00200000}, {475,0.00200000}, {476,0.00200000}, {477,0.00200000}, {478,0.00200000}, {479,0.00201818}, {480,0.00200000}, {481,0.00200909}, {482,0.00298182}, {483,0.00200909}, {484,0.00200000}, {485,0.00200000}, {486,0.00200909}, {487,0.00200000}, {488,0.00200000}, {489,0.00201818}, {490,0.00200000}, {491,0.00200000}, {492,0.00201818}, {493,0.00202727}, {494,0.00200909}, {495,0.00200909}, {496,0.00201818}, {497,0.00204545}, {498,0.00206364}, {499,0.00203636}, {500,0.00200000}, {505,0.00206364}, {510,0.00215455}, {515,0.00247273}, {520,0.00230909}, {525,0.00246364}, {530,0.00256364}, {535,0.00263636}, {540,0.00276364}, {545,0.00282727}, {550,0.00284545}, {555,0.00284545}, {560,0.00296364}, {565,0.00302727}, {570,0.00298182}, {575,0.00300000}, {580,0.00303636}, {585,0.00300000}, {590,0.00300000}, {595,0.00300000}, {600,0.00300000}, {605,0.00300000}, {610,0.00300000}, {615,0.00300000}, {620,0.00300000}, {625,0.00300000}, {630,0.00300000}, {635,0.00300000}, {640,0.00300000}, {645,0.00300000}, {650,0.00301818}, {655,0.00300000}, {660,0.00302727}, {665,0.00302727}, {670,0.00302727}, {675,0.00305455}, {680,0.00307273}, {685,0.00320000}, {690,0.00328182}, {695,0.00337273}, {700,0.00346364}, {705,0.00366364}, {710,0.00361818}, {715,0.00369091}, {720,0.00376364}, {725,0.00380909}, {730,0.00381818}, {735,0.00381818}, {740,0.00386364}, {745,0.00386364}, {750,0.00389091}, {755,0.00394545}, {760,0.00394545}, {765,0.00396364}, {770,0.00400000}, {775,0.00400000}, {780,0.00400909}, {785,0.00400000}, {790,0.00400000}, {795,0.00400000}, {800,0.00400000}, {805,0.00400000}, {810,0.00400000}, {815,0.00400000}, {820,0.00400909}, {825,0.00400000}, {830,0.00401818}, {835,0.00404545}, {840,0.00407273}, {845,0.00410000}, {850,0.00420000}, {855,0.00420000}, {860,0.00437273}, {865,0.00452727}, {870,0.00447273}, {875,0.00451818}, {880,0.00457273}, {885,0.00463636}, {890,0.00468182}, {895,0.00475455}, {900,0.00476364}, {905,0.00887273}, {910,0.00479091}, {915,0.00481818}, {920,0.00482727}, {925,0.00482727}, {930,0.00483636}, {935,0.00485455}, {940,0.00496364}, {945,0.00495455}, {950,0.00494545}, {955,0.01133636}, {960,0.00497273}, {965,0.00500000}, {970,0.00500000}, {975,0.00510000}, {980,0.00501818}, {985,0.00500000}, {990,0.00501818}, {995,0.00505455}, {1000,0.00506364}, {1010,0.00512727}, {1020,0.00519091}, {1030,0.00564545}, {1040,0.00545455}, {1050,0.00561818}, {1060,0.00571818}, {1070,0.00573636}, {1080,0.00577273}, {1090,0.00578182}, {1100,0.00582727}, {1110,0.00581818}, {1120,0.00586364}, {1130,0.01294545}, {1140,0.00592727}, {1150,0.00596364}, {1160,0.00603636}, {1170,0.00605455}, {1180,0.00614545}, {1190,0.00616364}, {1200,0.00627273}, {1210,0.00784545}, {1220,0.00652727}, {1230,0.00659091}, {1240,0.00664545}, {1250,0.00672727}, {1260,0.00678182}, {1270,0.00680000}, {1280,0.00680000}, {1290,0.00690909}, {1300,0.00684545}, {1310,0.00692727}, {1320,0.00700909}, {1330,0.00706364}, {1340,0.00705455}, {1350,0.00707273}, {1360,0.00713636}, {1370,0.01339091}, {1380,0.00728182}, {1390,0.00763636}, {1400,0.00751818}, {1410,0.00761818}, {1420,0.00770000}, {1430,0.00766364}, {1440,0.00773636}, {1450,0.00780909}, {1460,0.00778182}, {1470,0.00780000}, {1480,0.00781818}, {1490,0.00794545}, {1500,0.01559091}, {1510,0.00810909}, {1520,0.00815455}, {1530,0.00832727}, {1540,0.00838182}, {1550,0.00851818}, {1560,0.00844545}, {1570,0.00850909}, {1580,0.00854545}, {1590,0.00860909}, {1600,0.00868182}, {1610,0.00869091}, {1620,0.00869091}, {1630,0.00872727}, {1640,0.00873636}, {1650,0.00878182}, {1660,0.00890909}, {1670,0.00898182}, {1680,0.00905455}, {1690,0.00912727}, {1700,0.01531818}, {1710,0.00924545}, {1720,0.00935455}, {1730,0.00945455}, {1740,0.00950000}, {1750,0.00954545}, {1760,0.00955455}, {1770,0.00994545}, {1780,0.00966364}, {1790,0.00972727}, {1800,0.00971818}, {1810,0.02053636}, {1820,0.00985455}, {1830,0.00997273}, {1840,0.00992727}, {1850,0.01002727}, {1860,0.01010000}, {1870,0.01019091}, {1880,0.01023636}, {1890,0.01029091}, {1900,0.01422727}, {1910,0.01040000}, {1920,0.01049091}, {1930,0.01050000}, {1940,0.01050909}, {1950,0.01068182}, {1960,0.01062727}, {1970,0.01073636}, {1980,0.01077273}, {1990,0.01077273}, {2000,0.01085455}, {2050,0.01131818}, {2100,0.01144545}, {2150,0.01174545}, {2200,0.01216364}, {2250,0.01228182}, {2300,0.01265455}, {2350,0.01304545}, {2400,0.01328182}, {2450,0.01340000}, {2500,0.01409091}, {2550,0.01407273}, {2600,0.01440909}, {2650,0.01466364}, {2700,0.01494545}, {2750,0.01520909}, {2800,0.01581818}, {2850,0.01585455}, {2900,0.03139091}, {2950,0.01636364}, {3000,0.01685455}, {3050,0.01750}, {3100,0.01750}, {3150,0.01750}, {3200,0.01800}, {3250,0.01850}, {3300,0.01850}, {3350,0.01900}, {3400,0.01925}, {3450,0.01925}, {3500,0.02050}, {3550,0.02000}, {3600,0.02075}, {3650,0.02075}, {3700,0.02125}, {3750,0.02150}, {3800,0.02175}, {3850,0.02700}, {3900,0.02725}, {3950,0.02325}, {4000,0.02275}, {4050,0.02300}, {4100,0.03575}, {4150,0.02925}, {4200,0.02475}, {4250,0.02450}, {4300,0.03000}, {4350,0.02575}, {4400,0.03100}, {4450,0.02550}, {4500,0.02575}, {4550,0.02675}, {4600,0.04175}, {4650,0.02775}, {4700,0.02775}, {4750,0.02750}, {4800,0.03325}, {4850,0.03600}, {4900,0.02900}, {4950,0.05050}, {5000,0.03000}, {5050,0.04075}, {5100,0.03000}, {5150,0.03050}, {5200,0.03075}, {5250,0.03100}, {5300,0.03175}, {5350,0.03200}, {5400,0.03250}, {5450,0.03225}, {5500,0.03225}, {5550,0.04925}, {5600,0.03325}, {5650,0.04625}, {5700,0.03425}, {5750,0.04825}, {5800,0.03450}, {5850,0.04200}, {5900,0.03825}, {5950,0.04800}, {6000,0.05275}, {6050,0.05175}, {6100,0.04600}, {6150,0.05250}, {6200,0.03800}, {6250,0.03675}, {6300,0.05225}, {6350,0.03675}, {6400,0.05825}, {6450,0.03725}, {6500,0.03800}, {6550,0.04725}, {6600,0.04850}, {6650,0.05275}, {6700,0.05650}, {6750,0.05025}, {6800,0.06400}, {6850,0.04425}, {6900,0.04150}, {6950,0.05225}, {7000,0.04275}, {7050,0.06275}, {7100,0.04225}, {7150,0.05675}, {7200,0.05925}, {7250,0.04300}, {7300,0.04475}, {7350,0.04350}, {7400,0.04400}, {7450,0.04625}, {7500,0.05900}, {7550,0.05650}, {7600,0.04675}, {7650,0.05350}, {7700,0.04600}, {7750,0.05750}, {7800,0.04725}, {7850,0.04700}, {7900,0.06075}, {7950,0.08050}, {8000,0.05875}, {8050,0.05800}, {8100,0.06850}, {8150,0.05825}, {8200,0.04975}, {8250,0.07350}, {8300,0.06250}, {8350,0.04900}, {8400,0.06125}, {8450,0.06450}, {8500,0.05500}, {8550,0.05725}, {8600,0.06525}, {8650,0.07875}, {8700,0.08275}, {8750,0.07425}, {8800,0.06150}, {8850,0.05100}, {8900,0.07350}, {8950,0.06950}, {9000,0.05325}, {9050,0.08075}, {9100,0.05250}, {9150,0.05400}, {9200,0.07425}, {9250,0.06800}, {9300,0.07450}, {9350,0.08975}, {9400,0.07950}, {9450,0.07325}, {9500,0.07425}, {9550,0.05475}, {9600,0.07825}, {9650,0.07250}, {9700,0.05725}, {9750,0.07025}, {9800,0.07775}, {9850,0.05750}, {9900,0.05725}, {9950,0.07075}, {10000,0.07475}, {10100,0.0610}, {10200,0.1150}, {10300,0.0825}, {10400,0.0740}, {10500,0.072}, {10600,0.11}, {10700,0.127}, {10800,0.099}, {10900,0.07}, {11000,0.062}, {11100,0.084}, {11200,0.079}, {11300,0.067}, {11400,0.063}, {11500,0.066}, {11600,0.121}, {11700,0.065}, {11800,0.122}, {11900,0.067}, {12000,0.131}, {12100,0.068}, {12200,0.146}, {12300,0.132}, {12400,0.072}, {12500,0.084}, {12600,0.127}, {12700,0.199}, {12800,0.134}, {12900,0.115}, {13000,0.077}, {13100,0.134}, {13200,0.156}, {13300,0.079}, {13400,0.083}, {13500,0.079}, {13600,0.137}, {13700,0.08}, {13800,0.14}, {13900,0.081}, {14000,0.084}, {14100,0.083}, {14200,0.16}, {14300,0.134}, {14400,0.085}, {14500,0.128}, {14600,0.136}, {14700,0.14}, {14800,0.139}, {14900,0.129}, {15000,0.088}, {15100,0.138}, {15200,0.162}, {15300,0.089}, {15400,0.09}, {15500,0.188}, {15600,0.143}, {15700,0.093}, {15800,0.139}, {15900,0.186}, {16000,0.094}, {16100,0.095}, {16200,0.169}, {16300,0.138}, {16400,0.097}, {16500,0.125}, {16600,0.143}, {16700,0.164}, {16800,0.144}, {16900,0.128}, {17000,0.1}, {17100,0.14}, {17200,0.182}, {17300,0.198}, {17400,0.181}, {17500,0.206}, {17600,0.149}, {17700,0.104}, {17800,0.145}, {17900,0.189}, {18000,0.195}, {18100,0.196}, {18200,0.166}, {18300,0.129}, {18400,0.201}, {18500,0.135}, {18600,0.167}, {18700,0.145}, {18800,0.164}, {18900,0.137}, {19000,0.199}, {19100,0.136}, {19200,0.173}, {19300,0.204}, {19400,0.212}, {19500,0.202}, {19600,0.171}, {19700,0.222}, {19800,0.167}, {19900,0.2}};
data["big"]["identity vm_compute"]["Stats"]["user"] = {{1,0.00002727}, {2,0.00002727}, {3,0.00016364}, {4,0.00002727}, {5,0.00003636}, {6,0.00000000}, {7,0.00009091}, {8,0.00010000}, {9,0.00018182}, {10,0.00007273}, {11,0.00011818}, {12,0.00010000}, {13,0.00003636}, {14,0.00019091}, {15,0.00009091}, {16,0.00018182}, {17,0.00007273}, {18,0.00006364}, {19,0.00009091}, {20,0.00010909}, {21,0.00009091}, {22,0.00015455}, {23,0.00011818}, {24,0.00006364}, {25,0.00011818}, {26,0.00015455}, {27,0.00019091}, {28,0.00020000}, {29,0.00024545}, {30,0.00012727}, {31,0.00030909}, {32,0.00009091}, {33,0.00018182}, {34,0.00014545}, {35,0.00012727}, {36,0.00011818}, {37,0.00022727}, {38,0.00024545}, {39,0.00034545}, {40,0.00030909}, {41,0.00013636}, {42,0.00026364}, {43,0.00020909}, {44,0.00030000}, {45,0.00045455}, {46,0.00040000}, {47,0.00026364}, {48,0.00020000}, {49,0.00012727}, {50,0.00029091}, {51,0.00042727}, {52,0.00026364}, {53,0.00013636}, {54,0.00030909}, {55,0.00046364}, {56,0.00045455}, {57,0.00020909}, {58,0.00019091}, {59,0.00040909}, {60,0.00050909}, {61,0.00020909}, {62,0.00032727}, {63,0.00020909}, {64,0.00020909}, {65,0.00029091}, {66,0.00049091}, {67,0.00033636}, {68,0.00021818}, {69,0.00030909}, {70,0.00035455}, {71,0.00026364}, {72,0.00030000}, {73,0.00047273}, {74,0.00030000}, {75,0.00053636}, {76,0.00032727}, {77,0.00062727}, {78,0.00051818}, {79,0.00033636}, {80,0.00043636}, {81,0.00042727}, {82,0.00040000}, {83,0.00020909}, {84,0.00047273}, {85,0.00054545}, {86,0.00051818}, {87,0.00057273}, {88,0.00051818}, {89,0.00032727}, {90,0.00044545}, {91,0.00034545}, {92,0.00047273}, {93,0.00039091}, {94,0.00034545}, {95,0.00061818}, {96,0.00052727}, {97,0.00021818}, {98,0.00065455}, {99,0.00052727}, {100,0.00035455}, {101,0.00044545}, {102,0.00042727}, {103,0.00053636}, {104,0.00044545}, {105,0.00035455}, {106,0.00059091}, {107,0.00047273}, {108,0.00055455}, {109,0.00043636}, {110,0.00066364}, {111,0.00068182}, {112,0.00062727}, {113,0.00056364}, {114,0.00070909}, {115,0.00054545}, {116,0.00042727}, {117,0.00063636}, {118,0.00052727}, {119,0.00030909}, {120,0.00051818}, {121,0.00056364}, {122,0.00064545}, {123,0.00070000}, {124,0.00060909}, {125,0.00053636}, {126,0.00070000}, {127,0.00058182}, {128,0.00078182}, {129,0.00051818}, {130,0.00089091}, {131,0.00074545}, {132,0.00045455}, {133,0.00057273}, {134,0.00073636}, {135,0.00055455}, {136,0.00080000}, {137,0.00076364}, {138,0.00068182}, {139,0.00077273}, {140,0.00074545}, {141,0.00060000}, {142,0.00062727}, {143,0.00075455}, {144,0.00092727}, {145,0.00060909}, {146,0.00056364}, {147,0.00074545}, {148,0.00060000}, {149,0.00065455}, {150,0.00089091}, {151,0.00074545}, {152,0.00057273}, {153,0.00076364}, {154,0.00070000}, {155,0.00090909}, {156,0.00072727}, {157,0.00097273}, {158,0.00060000}, {159,0.00076364}, {160,0.00094545}, {161,0.00072727}, {162,0.00081818}, {163,0.00101818}, {164,0.00056364}, {165,0.00060000}, {166,0.00070909}, {167,0.00075455}, {168,0.00080909}, {169,0.00059091}, {170,0.00065455}, {171,0.00082727}, {172,0.00090000}, {173,0.00098182}, {174,0.00098182}, {175,0.00070000}, {176,0.00075455}, {177,0.00100909}, {178,0.00090000}, {179,0.00087273}, {180,0.00115455}, {181,0.00076364}, {182,0.00092727}, {183,0.00079091}, {184,0.00087273}, {185,0.00103636}, {186,0.00088182}, {187,0.00063636}, {188,0.00118182}, {189,0.00100000}, {190,0.00094545}, {191,0.00090909}, {192,0.00130909}, {193,0.00115455}, {194,0.00070909}, {195,0.00090909}, {196,0.00087273}, {197,0.00072727}, {198,0.00090909}, {199,0.00100909}, {200,0.00092727}, {201,0.00078182}, {202,0.00098182}, {203,0.00099091}, {204,0.00094545}, {205,0.00113636}, {206,0.00170909}, {207,0.00060909}, {208,0.00127273}, {209,0.00066364}, {210,0.00080909}, {211,0.00088182}, {212,0.00085455}, {213,0.00077273}, {214,0.00104545}, {215,0.00126364}, {216,0.00106364}, {217,0.00095455}, {218,0.00067273}, {219,0.00093636}, {220,0.00093636}, {221,0.00130909}, {222,0.00085455}, {223,0.00111818}, {224,0.00096364}, {225,0.00111818}, {226,0.00097273}, {227,0.00101818}, {228,0.00097273}, {229,0.00104545}, {230,0.00097273}, {231,0.00144545}, {232,0.00125455}, {233,0.00104545}, {234,0.00105455}, {235,0.00104545}, {236,0.00096364}, {237,0.00089091}, {238,0.00139091}, {239,0.00099091}, {240,0.00103636}, {241,0.00116364}, {242,0.00134545}, {243,0.00139091}, {244,0.00108182}, {245,0.00118182}, {246,0.00140000}, {247,0.00108182}, {248,0.00121818}, {249,0.00101818}, {250,0.00127273}, {251,0.00099091}, {252,0.00137273}, {253,0.00100000}, {254,0.00140000}, {255,0.00129091}, {256,0.00135455}, {257,0.00229091}, {258,0.00128182}, {259,0.00127273}, {260,0.00103636}, {261,0.00144545}, {262,0.00104545}, {263,0.00142727}, {264,0.00113636}, {265,0.00140909}, {266,0.00097273}, {267,0.00119091}, {268,0.00123636}, {269,0.00125455}, {270,0.00122727}, {271,0.00125455}, {272,0.00141818}, {273,0.00135455}, {274,0.00137273}, {275,0.00138182}, {276,0.00132727}, {277,0.00121818}, {278,0.00132727}, {279,0.00145455}, {280,0.00129091}, {281,0.00159091}, {282,0.00133636}, {283,0.00130000}, {284,0.00126364}, {285,0.00160909}, {286,0.00138182}, {287,0.00154545}, {288,0.00129091}, {289,0.00159091}, {290,0.00136364}, {291,0.00120909}, {292,0.00136364}, {293,0.00122727}, {294,0.00130909}, {295,0.00130000}, {296,0.00121818}, {297,0.00133636}, {298,0.00126364}, {299,0.00146364}, {300,0.00130000}, {301,0.00133636}, {302,0.00130000}, {303,0.00166364}, {304,0.00139091}, {305,0.00157273}, {306,0.00172727}, {307,0.00133636}, {308,0.00147273}, {309,0.00142727}, {310,0.00135455}, {311,0.00134545}, {312,0.00169091}, {313,0.00120909}, {314,0.00147273}, {315,0.00139091}, {316,0.00108182}, {317,0.00149091}, {318,0.00118182}, {319,0.00138182}, {320,0.00132727}, {321,0.00160000}, {322,0.00144545}, {323,0.00150000}, {324,0.00132727}, {325,0.00139091}, {326,0.00158182}, {327,0.00153636}, {328,0.00157273}, {329,0.00161818}, {330,0.00162727}, {331,0.00140000}, {332,0.00160000}, {333,0.00190000}, {334,0.00165455}, {335,0.00169091}, {336,0.00142727}, {337,0.00158182}, {338,0.00147273}, {339,0.00146364}, {340,0.00178182}, {341,0.00162727}, {342,0.00132727}, {343,0.00174545}, {344,0.00157273}, {345,0.00164545}, {346,0.00148182}, {347,0.00167273}, {348,0.00168182}, {349,0.00163636}, {350,0.00175455}, {351,0.00145455}, {352,0.00147273}, {353,0.00154545}, {354,0.00276364}, {355,0.00170000}, {356,0.00187273}, {357,0.00181818}, {358,0.00185455}, {359,0.00174545}, {360,0.00173636}, {361,0.00160000}, {362,0.00170000}, {363,0.00206364}, {364,0.00212727}, {365,0.00309091}, {366,0.00187273}, {367,0.00179091}, {368,0.00157273}, {369,0.00147273}, {370,0.00175455}, {371,0.00157273}, {372,0.00159091}, {373,0.00146364}, {374,0.00188182}, {375,0.00154545}, {376,0.00200000}, {377,0.00199091}, {378,0.00174545}, {379,0.00191818}, {380,0.00166364}, {381,0.00152727}, {382,0.00176364}, {383,0.00192727}, {384,0.00137273}, {385,0.00193636}, {386,0.00178182}, {387,0.00174545}, {388,0.00183636}, {389,0.00156364}, {390,0.00193636}, {391,0.00174545}, {392,0.00198182}, {393,0.00195455}, {394,0.00190909}, {395,0.00201818}, {396,0.00182727}, {397,0.00165455}, {398,0.00167273}, {399,0.00184545}, {400,0.00187273}, {401,0.00171818}, {402,0.00185455}, {403,0.00188182}, {404,0.00179091}, {405,0.00176364}, {406,0.00178182}, {407,0.00202727}, {408,0.00186364}, {409,0.00183636}, {410,0.00220909}, {411,0.00233636}, {412,0.00157273}, {413,0.00215455}, {414,0.00194545}, {415,0.00190000}, {416,0.00209091}, {417,0.00209091}, {418,0.00222727}, {419,0.00182727}, {420,0.00215455}, {421,0.00195455}, {422,0.00205455}, {423,0.00196364}, {424,0.00203636}, {425,0.00200000}, {426,0.00180000}, {427,0.00200000}, {428,0.00190909}, {429,0.00216364}, {430,0.00186364}, {431,0.00207273}, {432,0.00188182}, {433,0.00196364}, {434,0.00217273}, {435,0.00201818}, {436,0.00199091}, {437,0.00206364}, {438,0.00214545}, {439,0.00208182}, {440,0.00211818}, {441,0.00199091}, {442,0.00203636}, {443,0.00203636}, {444,0.00198182}, {445,0.00209091}, {446,0.00231818}, {447,0.00196364}, {448,0.00230000}, {449,0.00207273}, {450,0.00239091}, {451,0.00193636}, {452,0.00200000}, {453,0.00179091}, {454,0.00186364}, {455,0.00199091}, {456,0.00220000}, {457,0.00223636}, {458,0.00220909}, {459,0.00220000}, {460,0.00195455}, {461,0.00213636}, {462,0.00227273}, {463,0.00184545}, {464,0.00195455}, {465,0.00202727}, {466,0.00224545}, {467,0.00210909}, {468,0.00232727}, {469,0.00201818}, {470,0.00213636}, {471,0.00226364}, {472,0.00237273}, {473,0.00250000}, {474,0.00193636}, {475,0.00240000}, {476,0.00248182}, {477,0.00230000}, {478,0.00212727}, {479,0.00225455}, {480,0.00220909}, {481,0.00199091}, {482,0.00286364}, {483,0.00227273}, {484,0.00229091}, {485,0.00220000}, {486,0.00210909}, {487,0.00207273}, {488,0.00251818}, {489,0.00236364}, {490,0.00218182}, {491,0.00240000}, {492,0.00225455}, {493,0.00246364}, {494,0.00242727}, {495,0.00220909}, {496,0.00227273}, {497,0.00221818}, {498,0.00245455}, {499,0.00230909}, {500,0.00210000}, {505,0.00207273}, {510,0.00246364}, {515,0.00237273}, {520,0.00241818}, {525,0.00244545}, {530,0.00235455}, {535,0.00245455}, {540,0.00251818}, {545,0.00266364}, {550,0.00235455}, {555,0.00270000}, {560,0.00262727}, {565,0.00268182}, {570,0.00267273}, {575,0.00272727}, {580,0.00285455}, {585,0.00281818}, {590,0.00308182}, {595,0.00299091}, {600,0.00269091}, {605,0.00289091}, {610,0.00291818}, {615,0.00290000}, {620,0.00289091}, {625,0.00307273}, {630,0.00322727}, {635,0.00334545}, {640,0.00313636}, {645,0.00334545}, {650,0.00306364}, {655,0.00325455}, {660,0.00322727}, {665,0.00334545}, {670,0.00339091}, {675,0.00330000}, {680,0.00330000}, {685,0.00347273}, {690,0.00349091}, {695,0.00353636}, {700,0.00356364}, {705,0.00378182}, {710,0.00363636}, {715,0.00361818}, {720,0.00375455}, {725,0.00385455}, {730,0.00370000}, {735,0.00388182}, {740,0.00369091}, {745,0.00377273}, {750,0.00381818}, {755,0.00394545}, {760,0.00398182}, {765,0.00408182}, {770,0.00406364}, {775,0.00388182}, {780,0.00404545}, {785,0.00405455}, {790,0.00425455}, {795,0.00426364}, {800,0.00415455}, {805,0.00403636}, {810,0.00380000}, {815,0.00439091}, {820,0.00425455}, {825,0.00425455}, {830,0.00464545}, {835,0.00445455}, {840,0.00428182}, {845,0.00418182}, {850,0.00452727}, {855,0.00439091}, {860,0.00446364}, {865,0.00460909}, {870,0.00416364}, {875,0.00440909}, {880,0.00457273}, {885,0.00449091}, {890,0.00478182}, {895,0.00465455}, {900,0.00466364}, {905,0.00878182}, {910,0.00475455}, {915,0.00488182}, {920,0.00474545}, {925,0.00480909}, {930,0.00459091}, {935,0.00480909}, {940,0.00480909}, {945,0.00518182}, {950,0.00488182}, {955,0.01178182}, {960,0.00486364}, {965,0.00503636}, {970,0.00488182}, {975,0.00517273}, {980,0.00474545}, {985,0.00502727}, {990,0.00532727}, {995,0.00500000}, {1000,0.00489091}, {1010,0.00519091}, {1020,0.00500909}, {1030,0.00539091}, {1040,0.00529091}, {1050,0.00559091}, {1060,0.00565455}, {1070,0.00576364}, {1080,0.00557273}, {1090,0.00550909}, {1100,0.00577273}, {1110,0.00580000}, {1120,0.00602727}, {1130,0.01284545}, {1140,0.00601818}, {1150,0.00580909}, {1160,0.00595455}, {1170,0.00615455}, {1180,0.00632727}, {1190,0.00625455}, {1200,0.00648182}, {1210,0.00788182}, {1220,0.00605455}, {1230,0.00640000}, {1240,0.00655455}, {1250,0.00659091}, {1260,0.00661818}, {1270,0.00636364}, {1280,0.00671818}, {1290,0.00676364}, {1300,0.00680000}, {1310,0.00682727}, {1320,0.00669091}, {1330,0.00717273}, {1340,0.00708182}, {1350,0.00704545}, {1360,0.00701818}, {1370,0.01379091}, {1380,0.00705455}, {1390,0.00720909}, {1400,0.00709091}, {1410,0.00748182}, {1420,0.00754545}, {1430,0.00734545}, {1440,0.00742727}, {1450,0.00778182}, {1460,0.00780000}, {1470,0.00779091}, {1480,0.00776364}, {1490,0.00775455}, {1500,0.01505455}, {1510,0.00813636}, {1520,0.00822727}, {1530,0.00803636}, {1540,0.00826364}, {1550,0.00839091}, {1560,0.00813636}, {1570,0.00864545}, {1580,0.00831818}, {1590,0.00860909}, {1600,0.00862727}, {1610,0.00870000}, {1620,0.00871818}, {1630,0.00870909}, {1640,0.00895455}, {1650,0.00920000}, {1660,0.00890909}, {1670,0.00864545}, {1680,0.00936364}, {1690,0.00912727}, {1700,0.01520000}, {1710,0.00944545}, {1720,0.00960909}, {1730,0.00956364}, {1740,0.00962727}, {1750,0.00953636}, {1760,0.00980909}, {1770,0.01013636}, {1780,0.01001818}, {1790,0.00999091}, {1800,0.01026364}, {1810,0.02028182}, {1820,0.01034545}, {1830,0.01026364}, {1840,0.00990000}, {1850,0.01004545}, {1860,0.01068182}, {1870,0.01035455}, {1880,0.01063636}, {1890,0.01075455}, {1900,0.01437273}, {1910,0.01046364}, {1920,0.01049091}, {1930,0.01090000}, {1940,0.01088182}, {1950,0.01094545}, {1960,0.01117273}, {1970,0.01105455}, {1980,0.01117273}, {1990,0.01095455}, {2000,0.01125455}, {2050,0.01152727}, {2100,0.01193636}, {2150,0.01215455}, {2200,0.01268182}, {2250,0.01269091}, {2300,0.01302727}, {2350,0.01339091}, {2400,0.01330909}, {2450,0.01350000}, {2500,0.01407273}, {2550,0.01422727}, {2600,0.01465455}, {2650,0.01489091}, {2700,0.01514545}, {2750,0.01518182}, {2800,0.01575455}, {2850,0.01587273}, {2900,0.03123636}, {2950,0.01671818}, {3000,0.01664545}, {3050,0.01850}, {3100,0.01800}, {3150,0.01725}, {3200,0.01725}, {3250,0.01825}, {3300,0.01850}, {3350,0.01975}, {3400,0.01975}, {3450,0.01950}, {3500,0.02100}, {3550,0.01950}, {3600,0.02100}, {3650,0.02100}, {3700,0.02300}, {3750,0.02175}, {3800,0.02200}, {3850,0.02800}, {3900,0.02675}, {3950,0.02400}, {4000,0.02300}, {4050,0.02250}, {4100,0.03600}, {4150,0.03000}, {4200,0.02575}, {4250,0.02475}, {4300,0.02975}, {4350,0.02750}, {4400,0.03175}, {4450,0.02575}, {4500,0.02625}, {4550,0.02475}, {4600,0.04150}, {4650,0.02775}, {4700,0.02775}, {4750,0.02650}, {4800,0.03350}, {4850,0.03550}, {4900,0.02950}, {4950,0.04950}, {5000,0.02950}, {5050,0.04050}, {5100,0.02975}, {5150,0.02900}, {5200,0.03025}, {5250,0.03125}, {5300,0.03100}, {5350,0.03150}, {5400,0.03250}, {5450,0.03400}, {5500,0.03275}, {5550,0.04875}, {5600,0.03350}, {5650,0.04550}, {5700,0.03475}, {5750,0.05000}, {5800,0.03550}, {5850,0.04250}, {5900,0.03725}, {5950,0.04750}, {6000,0.05375}, {6050,0.05225}, {6100,0.04650}, {6150,0.05225}, {6200,0.03800}, {6250,0.03825}, {6300,0.05225}, {6350,0.03650}, {6400,0.05850}, {6450,0.03625}, {6500,0.03875}, {6550,0.04850}, {6600,0.04775}, {6650,0.05225}, {6700,0.05625}, {6750,0.05000}, {6800,0.06375}, {6850,0.04450}, {6900,0.04200}, {6950,0.05100}, {7000,0.04200}, {7050,0.06325}, {7100,0.04025}, {7150,0.05525}, {7200,0.05850}, {7250,0.04150}, {7300,0.04550}, {7350,0.04350}, {7400,0.04550}, {7450,0.04550}, {7500,0.05850}, {7550,0.05750}, {7600,0.04575}, {7650,0.05225}, {7700,0.04575}, {7750,0.05750}, {7800,0.04800}, {7850,0.04700}, {7900,0.06200}, {7950,0.08250}, {8000,0.05875}, {8050,0.05750}, {8100,0.06900}, {8150,0.05925}, {8200,0.04875}, {8250,0.07275}, {8300,0.06275}, {8350,0.05075}, {8400,0.06075}, {8450,0.06350}, {8500,0.05450}, {8550,0.05775}, {8600,0.06550}, {8650,0.07775}, {8700,0.08275}, {8750,0.07225}, {8800,0.06025}, {8850,0.05050}, {8900,0.07275}, {8950,0.07075}, {9000,0.05500}, {9050,0.07900}, {9100,0.05250}, {9150,0.05300}, {9200,0.07375}, {9250,0.06850}, {9300,0.07475}, {9350,0.08825}, {9400,0.08025}, {9450,0.07200}, {9500,0.07375}, {9550,0.05500}, {9600,0.07950}, {9650,0.07325}, {9700,0.05525}, {9750,0.06900}, {9800,0.07750}, {9850,0.05750}, {9900,0.05775}, {9950,0.06975}, {10000,0.07575}, {10100,0.0600}, {10200,0.1155}, {10300,0.0815}, {10400,0.0735}, {10500,0.075}, {10600,0.108}, {10700,0.127}, {10800,0.099}, {10900,0.067}, {11000,0.064}, {11100,0.083}, {11200,0.08}, {11300,0.068}, {11400,0.064}, {11500,0.067}, {11600,0.123}, {11700,0.064}, {11800,0.12}, {11900,0.067}, {12000,0.132}, {12100,0.067}, {12200,0.147}, {12300,0.127}, {12400,0.071}, {12500,0.088}, {12600,0.124}, {12700,0.2}, {12800,0.135}, {12900,0.115}, {13000,0.076}, {13100,0.136}, {13200,0.155}, {13300,0.08}, {13400,0.083}, {13500,0.079}, {13600,0.135}, {13700,0.083}, {13800,0.139}, {13900,0.079}, {14000,0.084}, {14100,0.084}, {14200,0.155}, {14300,0.132}, {14400,0.083}, {14500,0.128}, {14600,0.14}, {14700,0.139}, {14800,0.135}, {14900,0.128}, {15000,0.087}, {15100,0.139}, {15200,0.163}, {15300,0.088}, {15400,0.091}, {15500,0.192}, {15600,0.143}, {15700,0.096}, {15800,0.14}, {15900,0.184}, {16000,0.091}, {16100,0.095}, {16200,0.168}, {16300,0.14}, {16400,0.095}, {16500,0.128}, {16600,0.143}, {16700,0.163}, {16800,0.139}, {16900,0.127}, {17000,0.099}, {17100,0.14}, {17200,0.184}, {17300,0.195}, {17400,0.184}, {17500,0.207}, {17600,0.148}, {17700,0.1}, {17800,0.148}, {17900,0.192}, {18000,0.195}, {18100,0.195}, {18200,0.164}, {18300,0.127}, {18400,0.199}, {18500,0.132}, {18600,0.167}, {18700,0.148}, {18800,0.164}, {18900,0.136}, {19000,0.199}, {19100,0.136}, {19200,0.175}, {19300,0.203}, {19400,0.211}, {19500,0.203}, {19600,0.171}, {19700,0.223}, {19800,0.167}, {19900,0.2}};
data["big"]["identity vm_compute"]["Stats"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003636}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00003636}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00003636}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00003636}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00003636}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00003636}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00003636}, {102,0.00000000}, {103,0.00003636}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00003636}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00003636}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00003636}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00003636}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00003636}, {155,0.00000000}, {156,0.00003636}, {157,0.00002727}, {158,0.00000000}, {159,0.00000000}, {160,0.00007273}, {161,0.00003636}, {162,0.00007273}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00003636}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00003636}, {193,0.00003636}, {194,0.00000000}, {195,0.00000000}, {196,0.00007273}, {197,0.00000000}, {198,0.00002727}, {199,0.00000000}, {200,0.00002727}, {201,0.00003636}, {202,0.00000000}, {203,0.00000000}, {204,0.00003636}, {205,0.00003636}, {206,0.00000000}, {207,0.00000000}, {208,0.00003636}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00003636}, {215,0.00003636}, {216,0.00000000}, {217,0.00003636}, {218,0.00003636}, {219,0.00000000}, {220,0.00003636}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00003636}, {225,0.00000000}, {226,0.00003636}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00003636}, {237,0.00000000}, {238,0.00000000}, {239,0.00002727}, {240,0.00003636}, {241,0.00000000}, {242,0.00003636}, {243,0.00000000}, {244,0.00002727}, {245,0.00003636}, {246,0.00000000}, {247,0.00010909}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00003636}, {252,0.00003636}, {253,0.00003636}, {254,0.00000000}, {255,0.00003636}, {256,0.00000000}, {257,0.00006364}, {258,0.00000000}, {259,0.00000000}, {260,0.00003636}, {261,0.00003636}, {262,0.00007273}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00002727}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00003636}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00002727}, {282,0.00002727}, {283,0.00006364}, {284,0.00000000}, {285,0.00003636}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00003636}, {291,0.00002727}, {292,0.00000000}, {293,0.00003636}, {294,0.00003636}, {295,0.00003636}, {296,0.00003636}, {297,0.00000000}, {298,0.00000000}, {299,0.00003636}, {300,0.00000000}, {301,0.00002727}, {302,0.00003636}, {303,0.00000000}, {304,0.00003636}, {305,0.00000000}, {306,0.00000000}, {307,0.00003636}, {308,0.00006364}, {309,0.00003636}, {310,0.00000000}, {311,0.00000000}, {312,0.00003636}, {313,0.00000000}, {314,0.00000000}, {315,0.00003636}, {316,0.00002727}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00003636}, {324,0.00000000}, {325,0.00000000}, {326,0.00007273}, {327,0.00000000}, {328,0.00003636}, {329,0.00003636}, {330,0.00000000}, {331,0.00003636}, {332,0.00003636}, {333,0.00000000}, {334,0.00003636}, {335,0.00007273}, {336,0.00000000}, {337,0.00000000}, {338,0.00007273}, {339,0.00002727}, {340,0.00000000}, {341,0.00003636}, {342,0.00007273}, {343,0.00000000}, {344,0.00003636}, {345,0.00013636}, {346,0.00003636}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00003636}, {352,0.00007273}, {353,0.00000000}, {354,0.00003636}, {355,0.00000000}, {356,0.00003636}, {357,0.00000000}, {358,0.00007273}, {359,0.00007273}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00003636}, {365,0.00010909}, {366,0.00010909}, {367,0.00003636}, {368,0.00003636}, {369,0.00000000}, {370,0.00000000}, {371,0.00010909}, {372,0.00003636}, {373,0.00000000}, {374,0.00007273}, {375,0.00003636}, {376,0.00000000}, {377,0.00003636}, {378,0.00000000}, {379,0.00003636}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00003636}, {384,0.00000000}, {385,0.00003636}, {386,0.00007273}, {387,0.00010909}, {388,0.00003636}, {389,0.00003636}, {390,0.00003636}, {391,0.00000000}, {392,0.00000000}, {393,0.00002727}, {394,0.00000000}, {395,0.00002727}, {396,0.00010909}, {397,0.00000000}, {398,0.00007273}, {399,0.00003636}, {400,0.00002727}, {401,0.00000000}, {402,0.00007273}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00007273}, {407,0.00002727}, {408,0.00003636}, {409,0.00003636}, {410,0.00003636}, {411,0.00003636}, {412,0.00000000}, {413,0.00007273}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00003636}, {418,0.00000000}, {419,0.00002727}, {420,0.00000000}, {421,0.00002727}, {422,0.00003636}, {423,0.00003636}, {424,0.00000000}, {425,0.00006364}, {426,0.00003636}, {427,0.00007273}, {428,0.00003636}, {429,0.00006364}, {430,0.00007273}, {431,0.00000000}, {432,0.00010000}, {433,0.00003636}, {434,0.00000000}, {435,0.00003636}, {436,0.00006364}, {437,0.00007273}, {438,0.00007273}, {439,0.00007273}, {440,0.00000000}, {441,0.00000000}, {442,0.00003636}, {443,0.00000000}, {444,0.00003636}, {445,0.00002727}, {446,0.00000000}, {447,0.00007273}, {448,0.00003636}, {449,0.00000000}, {450,0.00000000}, {451,0.00003636}, {452,0.00000000}, {453,0.00003636}, {454,0.00000000}, {455,0.00003636}, {456,0.00000000}, {457,0.00003636}, {458,0.00007273}, {459,0.00007273}, {460,0.00003636}, {461,0.00000000}, {462,0.00007273}, {463,0.00003636}, {464,0.00021818}, {465,0.00010909}, {466,0.00000000}, {467,0.00000000}, {468,0.00010000}, {469,0.00007273}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00007273}, {474,0.00007273}, {475,0.00000000}, {476,0.00003636}, {477,0.00003636}, {478,0.00000000}, {479,0.00000000}, {480,0.00003636}, {481,0.00007273}, {482,0.00002727}, {483,0.00003636}, {484,0.00003636}, {485,0.00000000}, {486,0.00000000}, {487,0.00003636}, {488,0.00003636}, {489,0.00003636}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00007273}, {494,0.00000000}, {495,0.00000000}, {496,0.00006364}, {497,0.00003636}, {498,0.00007273}, {499,0.00003636}, {500,0.00003636}, {505,0.00003636}, {510,0.00000000}, {515,0.00002727}, {520,0.00000000}, {525,0.00003636}, {530,0.00013636}, {535,0.00000000}, {540,0.00000000}, {545,0.00006364}, {550,0.00003636}, {555,0.00000000}, {560,0.00003636}, {565,0.00010909}, {570,0.00010909}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00002727}, {595,0.00003636}, {600,0.00007273}, {605,0.00003636}, {610,0.00000000}, {615,0.00007273}, {620,0.00007273}, {625,0.00007273}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00003636}, {650,0.00014545}, {655,0.00010909}, {660,0.00003636}, {665,0.00002727}, {670,0.00021818}, {675,0.00003636}, {680,0.00010909}, {685,0.00003636}, {690,0.00000000}, {695,0.00000000}, {700,0.00010909}, {705,0.00003636}, {710,0.00002727}, {715,0.00003636}, {720,0.00003636}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00003636}, {750,0.00003636}, {755,0.00003636}, {760,0.00003636}, {765,0.00000000}, {770,0.00003636}, {775,0.00007273}, {780,0.00006364}, {785,0.00000000}, {790,0.00010909}, {795,0.00003636}, {800,0.00000000}, {805,0.00007273}, {810,0.00018182}, {815,0.00000000}, {820,0.00010909}, {825,0.00003636}, {830,0.00000000}, {835,0.00003636}, {840,0.00007273}, {845,0.00003636}, {850,0.00000000}, {855,0.00006364}, {860,0.00000000}, {865,0.00007273}, {870,0.00000000}, {875,0.00003636}, {880,0.00003636}, {885,0.00003636}, {890,0.00007273}, {895,0.00000000}, {900,0.00003636}, {905,0.00010000}, {910,0.00006364}, {915,0.00000000}, {920,0.00000000}, {925,0.00010000}, {930,0.00010909}, {935,0.00000000}, {940,0.00010909}, {945,0.00000000}, {950,0.00003636}, {955,0.00020909}, {960,0.00014545}, {965,0.00000000}, {970,0.00010909}, {975,0.00000000}, {980,0.00003636}, {985,0.00003636}, {990,0.00003636}, {995,0.00007273}, {1000,0.00010909}, {1010,0.00000000}, {1020,0.00003636}, {1030,0.00013636}, {1040,0.00003636}, {1050,0.00003636}, {1060,0.00010909}, {1070,0.00014545}, {1080,0.00007273}, {1090,0.00003636}, {1100,0.00018182}, {1110,0.00007273}, {1120,0.00003636}, {1130,0.00020909}, {1140,0.00003636}, {1150,0.00007273}, {1160,0.00018182}, {1170,0.00007273}, {1180,0.00000000}, {1190,0.00003636}, {1200,0.00007273}, {1210,0.00017273}, {1220,0.00007273}, {1230,0.00006364}, {1240,0.00002727}, {1250,0.00000000}, {1260,0.00003636}, {1270,0.00000000}, {1280,0.00003636}, {1290,0.00003636}, {1300,0.00000000}, {1310,0.00007273}, {1320,0.00002727}, {1330,0.00003636}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00003636}, {1370,0.00018182}, {1380,0.00018182}, {1390,0.00003636}, {1400,0.00010909}, {1410,0.00000000}, {1420,0.00007273}, {1430,0.00013636}, {1440,0.00010000}, {1450,0.00007273}, {1460,0.00003636}, {1470,0.00003636}, {1480,0.00006364}, {1490,0.00010000}, {1500,0.00036364}, {1510,0.00003636}, {1520,0.00003636}, {1530,0.00003636}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00003636}, {1570,0.00017273}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00003636}, {1610,0.00007273}, {1620,0.00000000}, {1630,0.00010000}, {1640,0.00003636}, {1650,0.00017273}, {1660,0.00003636}, {1670,0.00006364}, {1680,0.00000000}, {1690,0.00003636}, {1700,0.00010909}, {1710,0.00010909}, {1720,0.00010909}, {1730,0.00007273}, {1740,0.00007273}, {1750,0.00003636}, {1760,0.00007273}, {1770,0.00003636}, {1780,0.00010909}, {1790,0.00003636}, {1800,0.00000000}, {1810,0.00007273}, {1820,0.00003636}, {1830,0.00000000}, {1840,0.00003636}, {1850,0.00007273}, {1860,0.00007273}, {1870,0.00000000}, {1880,0.00003636}, {1890,0.00000000}, {1900,0.00003636}, {1910,0.00000000}, {1920,0.00007273}, {1930,0.00003636}, {1940,0.00000000}, {1950,0.00003636}, {1960,0.00000000}, {1970,0.00003636}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00010909}, {2050,0.00006364}, {2100,0.00002727}, {2150,0.00000000}, {2200,0.00003636}, {2250,0.00007273}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00003636}, {2500,0.00002727}, {2550,0.00003636}, {2600,0.00003636}, {2650,0.00003636}, {2700,0.00003636}, {2750,0.00006364}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00007273}, {2950,0.00000000}, {3000,0.00003636}, {3050,0.00000}, {3100,0.00000}, {3150,0.00000}, {3200,0.00000}, {3250,0.00000}, {3300,0.00000}, {3350,0.00000}, {3400,0.00000}, {3450,0.00000}, {3500,0.00000}, {3550,0.00000}, {3600,0.00000}, {3650,0.00000}, {3700,0.00000}, {3750,0.00000}, {3800,0.00000}, {3850,0.00000}, {3900,0.00000}, {3950,0.00000}, {4000,0.00000}, {4050,0.00100}, {4100,0.00200}, {4150,0.00000}, {4200,0.00000}, {4250,0.00000}, {4300,0.00100}, {4350,0.00000}, {4400,0.00000}, {4450,0.00100}, {4500,0.00000}, {4550,0.00000}, {4600,0.00000}, {4650,0.00000}, {4700,0.00000}, {4750,0.00000}, {4800,0.00000}, {4850,0.00000}, {4900,0.00000}, {4950,0.00000}, {5000,0.00000}, {5050,0.00100}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00100}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00100}, {7200,0.00100}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00100}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00100}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00100}, {8700,0.00000}, {8750,0.00100}, {8800,0.00100}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00100}, {9100,0.00000}, {9150,0.00100}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00100}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.0000}, {10200,0.0000}, {10300,0.0000}, {10400,0.0000}, {10500,0}, {10600,0.004}, {10700,0}, {10800,0}, {10900,0.004}, {11000,0}, {11100,0}, {11200,0}, {11300,0}, {11400,0}, {11500,0}, {11600,0}, {11700,0}, {11800,0.004}, {11900,0}, {12000,0}, {12100,0}, {12200,0}, {12300,0.004}, {12400,0}, {12500,0}, {12600,0}, {12700,0}, {12800,0}, {12900,0}, {13000,0}, {13100,0}, {13200,0}, {13300,0}, {13400,0}, {13500,0}, {13600,0}, {13700,0}, {13800,0}, {13900,0}, {14000,0}, {14100,0}, {14200,0.004}, {14300,0}, {14400,0}, {14500,0}, {14600,0}, {14700,0}, {14800,0}, {14900,0}, {15000,0}, {15100,0}, {15200,0}, {15300,0}, {15400,0}, {15500,0}, {15600,0}, {15700,0}, {15800,0}, {15900,0}, {16000,0}, {16100,0}, {16200,0}, {16300,0}, {16400,0}, {16500,0}, {16600,0}, {16700,0}, {16800,0.004}, {16900,0}, {17000,0}, {17100,0}, {17200,0}, {17300,0}, {17400,0}, {17500,0}, {17600,0}, {17700,0.004}, {17800,0}, {17900,0}, {18000,0}, {18100,0}, {18200,0}, {18300,0}, {18400,0}, {18500,0.004}, {18600,0}, {18700,0}, {18800,0}, {18900,0}, {19000,0}, {19100,0.004}, {19200,0}, {19300,0}, {19400,0}, {19500,0}, {19600,0}, {19700,0}, {19800,0}, {19900,0}};
data["big"]["lazy Denote"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00001818}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00001818}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00001818}, {168,0.00000909}, {169,0.00000000}, {170,0.00001818}, {171,0.00001818}, {172,0.00012727}, {173,0.00015455}, {174,0.00024545}, {175,0.00213636}, {176,0.00051818}, {177,0.00067273}, {178,0.00073636}, {179,0.00085455}, {180,0.00092727}, {181,0.00092727}, {182,0.00100000}, {183,0.00100000}, {184,0.00100000}, {185,0.00100000}, {186,0.00100000}, {187,0.00100000}, {188,0.00100000}, {189,0.00100000}, {190,0.00100000}, {191,0.00100000}, {192,0.00100000}, {193,0.00100000}, {194,0.00100000}, {195,0.00100000}, {196,0.00100000}, {197,0.00100000}, {198,0.00100000}, {199,0.00100000}, {200,0.00100000}, {201,0.00100000}, {202,0.00100000}, {203,0.00100000}, {204,0.00100000}, {205,0.00100000}, {206,0.00100000}, {207,0.00100000}, {208,0.00100000}, {209,0.00100000}, {210,0.00100000}, {211,0.00100000}, {212,0.00100000}, {213,0.00100000}, {214,0.00100000}, {215,0.00100000}, {216,0.00100000}, {217,0.00100000}, {218,0.00100000}, {219,0.00100000}, {220,0.00100000}, {221,0.00100000}, {222,0.00100000}, {223,0.00100000}, {224,0.00100000}, {225,0.00100000}, {226,0.00100000}, {227,0.00100000}, {228,0.00100000}, {229,0.00100000}, {230,0.00100000}, {231,0.00100000}, {232,0.00100000}, {233,0.00100000}, {234,0.00100000}, {235,0.00103636}, {236,0.00100000}, {237,0.00100000}, {238,0.00100000}, {239,0.00100000}, {240,0.00100000}, {241,0.00100000}, {242,0.00100000}, {243,0.00100000}, {244,0.00100000}, {245,0.00100000}, {246,0.00100000}, {247,0.00100000}, {248,0.00100000}, {249,0.00100000}, {250,0.00100000}, {251,0.00100000}, {252,0.00100000}, {253,0.00100000}, {254,0.00100000}, {255,0.00100000}, {256,0.00100000}, {257,0.00100000}, {258,0.00100000}, {259,0.00100000}, {260,0.00100000}, {261,0.00101818}, {262,0.00100909}, {263,0.00105455}, {264,0.00106364}, {265,0.00110909}, {266,0.00120000}, {267,0.00123636}, {268,0.00140909}, {269,0.00153636}, {270,0.00161818}, {271,0.00173636}, {272,0.00179091}, {273,0.00177273}, {274,0.00182727}, {275,0.00183636}, {276,0.00185455}, {277,0.00186364}, {278,0.00190000}, {279,0.00200000}, {280,0.00199091}, {281,0.00200000}, {282,0.00200000}, {283,0.00200000}, {284,0.00200000}, {285,0.00200000}, {286,0.00200000}, {287,0.00200000}, {288,0.00200000}, {289,0.00200000}, {290,0.00200000}, {291,0.00200000}, {292,0.00200000}, {293,0.00200000}, {294,0.00200000}, {295,0.00469091}, {296,0.00200000}, {297,0.00200000}, {298,0.00200000}, {299,0.00201818}, {300,0.00200000}, {301,0.00200000}, {302,0.00200000}, {303,0.00200000}, {304,0.00200000}, {305,0.00200000}, {306,0.00200000}, {307,0.00200000}, {308,0.00200000}, {309,0.00200000}, {310,0.00200000}, {311,0.00200000}, {312,0.00200000}, {313,0.00200000}, {314,0.00200000}, {315,0.00200000}, {316,0.00200000}, {317,0.00200000}, {318,0.00200000}, {319,0.00200000}, {320,0.00200000}, {321,0.00200000}, {322,0.00200000}, {323,0.00200000}, {324,0.00200000}, {325,0.00200909}, {326,0.00200000}, {327,0.00200000}, {328,0.00200000}, {329,0.00200000}, {330,0.00200000}, {331,0.00200000}, {332,0.00200000}, {333,0.00200000}, {334,0.00200000}, {335,0.00200909}, {336,0.00200000}, {337,0.00214545}, {338,0.00203636}, {339,0.00204545}, {340,0.00207273}, {341,0.00216364}, {342,0.00220909}, {343,0.00244545}, {344,0.00250909}, {345,0.00255455}, {346,0.00260000}, {347,0.00263636}, {348,0.00265455}, {349,0.00272727}, {350,0.00278182}, {351,0.00279091}, {352,0.00282727}, {353,0.00284545}, {354,0.00286364}, {355,0.00291818}, {356,0.00295455}, {357,0.00297273}, {358,0.00297273}, {359,0.00298182}, {360,0.00297273}, {361,0.00299091}, {362,0.00299091}, {363,0.00300000}, {364,0.00300000}, {365,0.00300000}, {366,0.00300000}, {367,0.00300000}, {368,0.00300000}, {369,0.00300000}, {370,0.00300000}, {371,0.00300000}, {372,0.00300000}, {373,0.00300000}, {374,0.00300000}, {375,0.00300000}, {376,0.00300000}, {377,0.00300000}, {378,0.00300000}, {379,0.00300000}, {380,0.00300000}, {381,0.00300000}, {382,0.00300000}, {383,0.00300000}, {384,0.00300000}, {385,0.00300000}, {386,0.00463636}, {387,0.00300000}, {388,0.00300000}, {389,0.00300000}, {390,0.00300000}, {391,0.00300000}, {392,0.00300000}, {393,0.00300000}, {394,0.00301818}, {395,0.00300000}, {396,0.00300000}, {397,0.00300000}, {398,0.00300000}, {399,0.00300000}, {400,0.00300000}, {401,0.00308182}, {402,0.00300909}, {403,0.00301818}, {404,0.00302727}, {405,0.00307273}, {406,0.00500909}, {407,0.00324545}, {408,0.00337273}, {409,0.00345455}, {410,0.00354545}, {411,0.00358182}, {412,0.00358182}, {413,0.00359091}, {414,0.00368182}, {415,0.00367273}, {416,0.00375455}, {417,0.00379091}, {418,0.00382727}, {419,0.00383636}, {420,0.00388182}, {421,0.00391818}, {422,0.00390000}, {423,0.00392727}, {424,0.00392727}, {425,0.00393636}, {426,0.00393636}, {427,0.00395455}, {428,0.00398182}, {429,0.00399091}, {430,0.00399091}, {431,0.00400000}, {432,0.00400000}, {433,0.00400000}, {434,0.00400000}, {435,0.00400000}, {436,0.00400000}, {437,0.00405455}, {438,0.00400000}, {439,0.00400000}, {440,0.00407273}, {441,0.00400000}, {442,0.00400000}, {443,0.00406364}, {444,0.00400000}, {445,0.00400000}, {446,0.00400000}, {447,0.00400000}, {448,0.00400000}, {449,0.00400000}, {450,0.00400000}, {451,0.00400000}, {452,0.00400000}, {453,0.00400000}, {454,0.00400000}, {455,0.00400000}, {456,0.00400000}, {457,0.00400000}, {458,0.00405455}, {459,0.00401818}, {460,0.00404545}, {461,0.00406364}, {462,0.00413636}, {463,0.00417273}, {464,0.00423636}, {465,0.00438182}, {466,0.00443636}, {467,0.00451818}, {468,0.00455455}, {469,0.00460000}, {470,0.00460000}, {471,0.00463636}, {472,0.00465455}, {473,0.00466364}, {474,0.00470909}, {475,0.00482727}, {476,0.00480000}, {477,0.00480909}, {478,0.00486364}, {479,0.00489091}, {480,0.00490909}, {481,0.00492727}, {482,0.00492727}, {483,0.00493636}, {484,0.00493636}, {485,0.00493636}, {486,0.00669091}, {487,0.00497273}, {488,0.00498182}, {489,0.00499091}, {490,0.00500000}, {491,0.00500000}, {492,0.00500000}, {493,0.00500000}, {494,0.00500000}, {495,0.00500000}, {496,0.00500000}, {497,0.00500000}, {498,0.00500000}, {499,0.00500000}, {500,0.00500000}, {505,0.00500000}, {510,0.00501818}, {515,0.00522727}, {520,0.00552727}, {525,0.00562727}, {530,0.00577273}, {535,0.00595455}, {540,0.00597273}, {545,0.00600000}, {550,0.00600000}, {555,0.00600000}, {560,0.00601818}, {565,0.00626364}, {570,0.00654545}, {575,0.00667273}, {580,0.00692727}, {585,0.00698182}, {590,0.00700000}, {595,0.00700000}, {600,0.00700000}, {605,0.00706364}, {610,0.00730909}, {615,0.00755455}, {620,0.00765455}, {625,0.00789091}, {630,0.00798182}, {635,0.00800000}, {640,0.00800000}, {645,0.00802727}, {650,0.00811818}, {655,0.00844545}, {660,0.00859091}, {665,0.00877273}, {670,0.00897273}, {675,0.00898182}, {680,0.00900000}, {685,0.00903636}, {690,0.00914545}, {695,0.00947273}, {700,0.00960909}, {705,0.00975455}, {710,0.00994545}, {715,0.01002727}, {720,0.01001818}, {725,0.01006364}, {730,0.01029091}, {735,0.01058182}, {740,0.01070909}, {745,0.01085455}, {750,0.01094545}, {755,0.01100909}, {760,0.01119091}, {765,0.01130000}, {770,0.01150909}, {775,0.01169091}, {780,0.01180909}, {785,0.01192727}, {790,0.01209091}, {795,0.01861818}, {800,0.01236364}, {805,0.01260909}, {810,0.01269091}, {815,0.01280909}, {820,0.01289091}, {825,0.01292727}, {830,0.01310909}, {835,0.01359091}, {840,0.01360909}, {845,0.01364545}, {850,0.01382727}, {855,0.01392727}, {860,0.01405455}, {865,0.01427273}, {870,0.01472727}, {875,0.01466364}, {880,0.01478182}, {885,0.01493636}, {890,0.01500909}, {895,0.01530909}, {900,0.01558182}, {905,0.01566364}, {910,0.01577273}, {915,0.01592727}, {920,0.01602727}, {925,0.01630000}, {930,0.01653636}, {935,0.01669091}, {940,0.01680000}, {945,0.01697273}, {950,0.01705455}, {955,0.01732727}, {960,0.01763636}, {965,0.02223636}, {970,0.01780909}, {975,0.01798182}, {980,0.01818182}, {985,0.01848182}, {990,0.01868182}, {995,0.01880000}, {1000,0.01884545}, {1010,0.01937273}, {1020,0.01973636}, {1030,0.02004545}, {1040,0.02063636}, {1050,0.02083636}, {1060,0.02128182}, {1070,0.02171818}, {1080,0.02193636}, {1090,0.02259091}, {1100,0.02284545}, {1110,0.02348182}, {1120,0.02383636}, {1130,0.02403636}, {1140,0.02470909}, {1150,0.02505455}, {1160,0.02558182}, {1170,0.02598182}, {1180,0.02641818}, {1190,0.02696364}, {1200,0.02731818}, {1210,0.02799091}, {1220,0.03219091}, {1230,0.02901818}, {1240,0.02938182}, {1250,0.02998182}, {1260,0.03048182}, {1270,0.03103636}, {1280,0.03168182}, {1290,0.03202727}, {1300,0.03270909}, {1310,0.03330000}, {1320,0.03406364}, {1330,0.03454545}, {1340,0.03531818}, {1350,0.03599091}, {1360,0.03666364}, {1370,0.03715455}, {1380,0.03799091}, {1390,0.03872727}, {1400,0.03939091}, {1410,0.04011818}, {1420,0.04073636}, {1430,0.04172727}, {1440,0.04240909}, {1450,0.04317273}, {1460,0.04400909}, {1470,0.04492727}, {1480,0.04592727}, {1490,0.04657273}, {1500,0.04704545}, {1510,0.04781818}, {1520,0.04870000}, {1530,0.05650000}, {1540,0.05078182}, {1550,0.05190000}, {1560,0.06030909}, {1570,0.05429091}, {1580,0.05549091}, {1590,0.05623636}, {1600,0.05754545}, {1610,0.05898182}, {1620,0.05994545}, {1630,0.06141818}, {1640,0.06229091}, {1650,0.06358182}, {1660,0.06459091}, {1670,0.06556364}, {1680,0.06682727}, {1690,0.06803636}, {1700,0.06914545}, {1710,0.07087273}, {1720,0.07184545}, {1730,0.07941818}, {1740,0.07451818}, {1750,0.07609091}, {1760,0.07764545}, {1770,0.07923636}, {1780,0.08050909}, {1790,0.08226364}, {1800,0.08363636}, {1810,0.08534545}, {1820,0.09918182}, {1830,0.08902727}, {1840,0.09035455}, {1850,0.09196364}, {1860,0.10097273}, {1870,0.09535455}, {1880,0.09676364}, {1890,0.09885455}, {1900,0.10006364}, {1910,0.10193636}, {1920,0.11049091}, {1930,0.10515455}, {1940,0.10727273}, {1950,0.10892727}, {1960,0.11039091}, {1970,0.11192727}, {1980,0.11343636}, {1990,0.11530909}, {2000,0.11704545}, {2050,0.12617273}, {2100,0.13547273}, {2150,0.14488182}, {2200,0.15438182}, {2250,0.16443636}, {2300,0.17487273}, {2350,0.18501818}, {2400,0.19603636}, {2450,0.20626364}, {2500,0.21740000}, {2550,0.22870909}, {2600,0.24057273}, {2650,0.25159091}, {2700,0.26337273}, {2750,0.27533636}, {2800,0.28740000}, {2850,0.29929091}, {2900,0.31092727}, {2950,0.32504545}, {3000,0.33703636}, {3050,0.35800}, {3100,0.35950}, {3150,0.37325}, {3200,0.38875}, {3250,0.39925}, {3300,0.43500}, {3350,0.47475}, {3400,0.46275}, {3450,0.46825}, {3500,0.48350}, {3550,0.49875}, {3600,0.55275}, {3650,0.53100}, {3700,0.54800}, {3750,0.56425}, {3800,0.56850}, {3850,0.57925}, {3900,0.61475}, {3950,0.61325}, {4000,0.62925}, {4050,0.64800}, {4100,0.66150}, {4150,0.68100}, {4200,0.74900}, {4250,0.71250}, {4300,0.73200}, {4350,0.76725}, {4400,0.76725}, {4450,0.78750}, {4500,0.90675}, {4550,0.89000}, {4600,0.90750}, {4650,0.89450}, {4700,0.91775}, {4750,0.93975}, {4800,0.99550}, {4850,1.08675}, {4900,1.09375}, {4950,1.06175}, {5000,1.10950}, {5050,1.10675}, {5100,1.21300}, {5150,1.15575}, {5200,1.17625}, {5250,1.20325}, {5300,1.24150}, {5350,1.29175}, {5400,1.27950}, {5450,1.25500}, {5500,1.27500}, {5550,1.44775}, {5600,1.43075}, {5650,1.40475}, {5700,1.57150}, {5750,1.45600}, {5800,1.48200}, {5850,1.58800}, {5900,1.60150}, {5950,1.50100}, {6000,1.46475}, {6050,1.55250}, {6100,1.62600}, {6150,1.64500}, {6200,1.61375}, {6250,1.58650}, {6300,1.66150}, {6350,1.63925}, {6400,1.70625}, {6450,1.62500}, {6500,1.73500}, {6550,1.97775}, {6600,1.93325}, {6650,1.94650}, {6700,1.95925}, {6750,1.98350}, {6800,2.17750}, {6850,2.03600}, {6900,2.02750}, {6950,2.19875}, {7000,2.18625}, {7050,2.27125}, {7100,2.15650}, {7150,2.23950}, {7200,2.33275}, {7250,2.31375}, {7300,2.27950}, {7350,2.30750}, {7400,2.44475}, {7450,2.58900}, {7500,2.67850}, {7550,2.60475}, {7600,2.47975}, {7650,2.84250}, {7700,2.65725}, {7750,2.88125}, {7800,2.69375}, {7850,2.76700}, {7900,2.82575}, {7950,2.99300}, {8000,3.07500}, {8050,3.10450}, {8100,3.05850}, {8150,2.97775}, {8200,3.01650}, {8250,3.35000}, {8300,2.95500}, {8350,3.06250}, {8400,2.90425}, {8450,3.46450}, {8500,3.18450}, {8550,3.13325}, {8600,3.03750}, {8650,3.12050}, {8700,3.16100}, {8750,3.13450}, {8800,3.17475}, {8850,3.29675}, {8900,3.39700}, {8950,3.44425}, {9000,3.45525}, {9050,3.36150}, {9100,3.19350}, {9150,3.11500}, {9200,3.15675}, {9250,3.36400}, {9300,3.78800}, {9350,4.00950}, {9400,3.70300}, {9450,3.70400}, {9500,3.54375}, {9550,3.85475}, {9600,3.92675}, {9650,3.81725}, {9700,4.01850}, {9750,3.90325}, {9800,4.21975}, {9850,4.22850}, {9900,4.39575}, {9950,4.11875}, {10000,4.29900}, {10100,4.3425}, {10200,4.2570}, {10300,4.3365}, {10400,5.114}, {10500,4.987}, {10600,5.042}, {10700,5.162}, {10800,5.254}, {10900,4.392}, {11000,4.427}, {11100,4.579}, {11200,4.622}, {11300,4.718}, {11400,4.81}, {11500,4.87}, {11600,4.967}, {11700,4.998}, {11800,5.139}, {11900,5.23}, {12000,5.312}, {12100,5.422}, {12200,5.496}, {12300,7.977}, {12400,6.905}, {12500,8.308}, {12600,7.939}, {12700,7.438}, {12800,8.369}, {12900,7.87}, {13000,7.588}, {13100,8.245}, {13200,7.956}, {13300,7.953}, {13400,8.105}, {13500,8.211}, {13600,8.826}, {13700,8.47}, {13800,10.181}, {13900,8.959}, {14000,8.859}, {14100,8.947}, {14200,10.027}, {14300,10.255}, {14400,9.614}, {14500,9.495}, {14600,10.077}, {14700,10.35}, {14800,11.29}, {14900,10.004}, {15000,11.344}, {15100,10.357}, {15200,12.325}, {15300,11.165}, {15400,12.364}, {15500,7.428}, {15600,11.227}, {15700,22.952}, {15800,11.55}, {15900,12.884}, {16000,13.604}, {16100,13.81}, {16200,13.332}, {16300,11.977}, {16400,13.963}, {16500,12.819}, {16600,12.429}, {16700,12.593}, {16800,12.737}, {16900,14.388}, {17000,14.019}, {17100,13.912}, {17200,13.475}, {17300,14.054}, {17400,14.25}, {17500,13.944}, {17600,14.359}, {17700,15.214}, {17800,14.985}, {17900,14.448}, {18000,15.051}, {18100,17.253}, {18200,14.955}, {18300,17.861}, {18400,15.265}, {18500,17.329}, {18600,17.033}, {18700,21.975}, {18800,18.834}, {18900,21.273}, {19000,16.359}, {19100,18.966}, {19200,18.199}, {19300,18.855}, {19400,26.958}, {19500,50.854}, {19600,20.753}, {19700,17.539}, {19800,19.887}, {19900,31.279}};
data["big"]["lazy Denote"]["Stats"]["user"] = {{1,0.00005455}, {2,0.00000000}, {3,0.00000000}, {4,0.00006364}, {5,0.00008182}, {6,0.00002727}, {7,0.00000000}, {8,0.00005455}, {9,0.00008182}, {10,0.00002727}, {11,0.00009091}, {12,0.00006364}, {13,0.00009091}, {14,0.00012727}, {15,0.00021818}, {16,0.00003636}, {17,0.00014545}, {18,0.00017273}, {19,0.00006364}, {20,0.00005455}, {21,0.00010909}, {22,0.00006364}, {23,0.00010000}, {24,0.00013636}, {25,0.00015455}, {26,0.00008182}, {27,0.00009091}, {28,0.00010909}, {29,0.00002727}, {30,0.00009091}, {31,0.00022727}, {32,0.00017273}, {33,0.00009091}, {34,0.00014545}, {35,0.00014545}, {36,0.00018182}, {37,0.00010909}, {38,0.00010909}, {39,0.00012727}, {40,0.00005455}, {41,0.00024545}, {42,0.00018182}, {43,0.00020000}, {44,0.00029091}, {45,0.00017273}, {46,0.00017273}, {47,0.00017273}, {48,0.00020000}, {49,0.00012727}, {50,0.00011818}, {51,0.00015455}, {52,0.00009091}, {53,0.00021818}, {54,0.00016364}, {55,0.00030909}, {56,0.00012727}, {57,0.00038182}, {58,0.00031818}, {59,0.00030000}, {60,0.00015455}, {61,0.00022727}, {62,0.00030000}, {63,0.00023636}, {64,0.00021818}, {65,0.00017273}, {66,0.00009091}, {67,0.00030909}, {68,0.00027273}, {69,0.00035455}, {70,0.00020909}, {71,0.00011818}, {72,0.00027273}, {73,0.00026364}, {74,0.00026364}, {75,0.00034545}, {76,0.00008182}, {77,0.00028182}, {78,0.00040000}, {79,0.00026364}, {80,0.00022727}, {81,0.00039091}, {82,0.00044545}, {83,0.00025455}, {84,0.00031818}, {85,0.00028182}, {86,0.00031818}, {87,0.00029091}, {88,0.00029091}, {89,0.00042727}, {90,0.00024545}, {91,0.00070909}, {92,0.00015455}, {93,0.00039091}, {94,0.00033636}, {95,0.00020909}, {96,0.00032727}, {97,0.00034545}, {98,0.00022727}, {99,0.00030909}, {100,0.00047273}, {101,0.00040909}, {102,0.00021818}, {103,0.00058182}, {104,0.00043636}, {105,0.00039091}, {106,0.00037273}, {107,0.00055455}, {108,0.00040000}, {109,0.00036364}, {110,0.00033636}, {111,0.00030909}, {112,0.00054545}, {113,0.00040000}, {114,0.00041818}, {115,0.00053636}, {116,0.00040000}, {117,0.00030000}, {118,0.00035455}, {119,0.00020909}, {120,0.00053636}, {121,0.00050000}, {122,0.00045455}, {123,0.00044545}, {124,0.00044545}, {125,0.00039091}, {126,0.00037273}, {127,0.00046364}, {128,0.00040909}, {129,0.00046364}, {130,0.00035455}, {131,0.00046364}, {132,0.00049091}, {133,0.00040000}, {134,0.00044545}, {135,0.00051818}, {136,0.00044545}, {137,0.00050000}, {138,0.00045455}, {139,0.00047273}, {140,0.00054545}, {141,0.00080909}, {142,0.00050000}, {143,0.00057273}, {144,0.00046364}, {145,0.00051818}, {146,0.00058182}, {147,0.00063636}, {148,0.00070000}, {149,0.00047273}, {150,0.00064545}, {151,0.00054545}, {152,0.00089091}, {153,0.00073636}, {154,0.00066364}, {155,0.00073636}, {156,0.00050000}, {157,0.00071818}, {158,0.00051818}, {159,0.00087273}, {160,0.00088182}, {161,0.00077273}, {162,0.00058182}, {163,0.00072727}, {164,0.00087273}, {165,0.00081818}, {166,0.00076364}, {167,0.00080909}, {168,0.00092727}, {169,0.00080909}, {170,0.00071818}, {171,0.00097273}, {172,0.00085455}, {173,0.00054545}, {174,0.00090909}, {175,0.00221818}, {176,0.00090000}, {177,0.00083636}, {178,0.00089091}, {179,0.00102727}, {180,0.00074545}, {181,0.00100000}, {182,0.00078182}, {183,0.00065455}, {184,0.00089091}, {185,0.00079091}, {186,0.00097273}, {187,0.00090000}, {188,0.00078182}, {189,0.00095455}, {190,0.00073636}, {191,0.00080000}, {192,0.00108182}, {193,0.00105455}, {194,0.00080000}, {195,0.00082727}, {196,0.00088182}, {197,0.00082727}, {198,0.00119091}, {199,0.00100909}, {200,0.00130909}, {201,0.00096364}, {202,0.00075455}, {203,0.00108182}, {204,0.00100909}, {205,0.00148182}, {206,0.00097273}, {207,0.00084545}, {208,0.00120000}, {209,0.00077273}, {210,0.00097273}, {211,0.00092727}, {212,0.00102727}, {213,0.00080909}, {214,0.00099091}, {215,0.00134545}, {216,0.00112727}, {217,0.00110909}, {218,0.00085455}, {219,0.00109091}, {220,0.00107273}, {221,0.00155455}, {222,0.00113636}, {223,0.00132727}, {224,0.00114545}, {225,0.00131818}, {226,0.00113636}, {227,0.00106364}, {228,0.00109091}, {229,0.00104545}, {230,0.00126364}, {231,0.00127273}, {232,0.00136364}, {233,0.00129091}, {234,0.00131818}, {235,0.00124545}, {236,0.00116364}, {237,0.00140909}, {238,0.00156364}, {239,0.00139091}, {240,0.00152727}, {241,0.00146364}, {242,0.00130000}, {243,0.00148182}, {244,0.00137273}, {245,0.00119091}, {246,0.00112727}, {247,0.00142727}, {248,0.00151818}, {249,0.00141818}, {250,0.00132727}, {251,0.00133636}, {252,0.00147273}, {253,0.00140000}, {254,0.00143636}, {255,0.00151818}, {256,0.00155455}, {257,0.00147273}, {258,0.00149091}, {259,0.00165455}, {260,0.00144545}, {261,0.00149091}, {262,0.00173636}, {263,0.00151818}, {264,0.00134545}, {265,0.00169091}, {266,0.00163636}, {267,0.00139091}, {268,0.00171818}, {269,0.00171818}, {270,0.00167273}, {271,0.00173636}, {272,0.00145455}, {273,0.00169091}, {274,0.00172727}, {275,0.00160909}, {276,0.00176364}, {277,0.00188182}, {278,0.00161818}, {279,0.00184545}, {280,0.00187273}, {281,0.00150000}, {282,0.00173636}, {283,0.00170909}, {284,0.00190909}, {285,0.00161818}, {286,0.00181818}, {287,0.00170000}, {288,0.00192727}, {289,0.00179091}, {290,0.00190000}, {291,0.00194545}, {292,0.00198182}, {293,0.00199091}, {294,0.00188182}, {295,0.00459091}, {296,0.00217273}, {297,0.00190909}, {298,0.00195455}, {299,0.00204545}, {300,0.00203636}, {301,0.00199091}, {302,0.00220000}, {303,0.00211818}, {304,0.00188182}, {305,0.00201818}, {306,0.00224545}, {307,0.00203636}, {308,0.00224545}, {309,0.00191818}, {310,0.00220000}, {311,0.00233636}, {312,0.00196364}, {313,0.00220000}, {314,0.00213636}, {315,0.00218182}, {316,0.00215455}, {317,0.00222727}, {318,0.00210000}, {319,0.00196364}, {320,0.00217273}, {321,0.00230909}, {322,0.00223636}, {323,0.00220909}, {324,0.00222727}, {325,0.00202727}, {326,0.00245455}, {327,0.00226364}, {328,0.00243636}, {329,0.00200909}, {330,0.00224545}, {331,0.00249091}, {332,0.00232727}, {333,0.00266364}, {334,0.00270909}, {335,0.00226364}, {336,0.00224545}, {337,0.00260909}, {338,0.00212727}, {339,0.00240909}, {340,0.00251818}, {341,0.00212727}, {342,0.00240000}, {343,0.00238182}, {344,0.00259091}, {345,0.00263636}, {346,0.00253636}, {347,0.00241818}, {348,0.00260000}, {349,0.00253636}, {350,0.00259091}, {351,0.00258182}, {352,0.00243636}, {353,0.00270000}, {354,0.00278182}, {355,0.00266364}, {356,0.00240909}, {357,0.00254545}, {358,0.00262727}, {359,0.00279091}, {360,0.00262727}, {361,0.00258182}, {362,0.00249091}, {363,0.00279091}, {364,0.00276364}, {365,0.00230000}, {366,0.00269091}, {367,0.00269091}, {368,0.00284545}, {369,0.00283636}, {370,0.00289091}, {371,0.00280000}, {372,0.00283636}, {373,0.00295455}, {374,0.00271818}, {375,0.00285455}, {376,0.00291818}, {377,0.00273636}, {378,0.00274545}, {379,0.00294545}, {380,0.00297273}, {381,0.00312727}, {382,0.00309091}, {383,0.00291818}, {384,0.00301818}, {385,0.00282727}, {386,0.00456364}, {387,0.00314545}, {388,0.00287273}, {389,0.00312727}, {390,0.00318182}, {391,0.00302727}, {392,0.00302727}, {393,0.00319091}, {394,0.00309091}, {395,0.00306364}, {396,0.00318182}, {397,0.00329091}, {398,0.00318182}, {399,0.00303636}, {400,0.00310000}, {401,0.00319091}, {402,0.00322727}, {403,0.00330000}, {404,0.00330000}, {405,0.00313636}, {406,0.00469091}, {407,0.00324545}, {408,0.00325455}, {409,0.00331818}, {410,0.00334545}, {411,0.00321818}, {412,0.00339091}, {413,0.00329091}, {414,0.00333636}, {415,0.00347273}, {416,0.00342727}, {417,0.00346364}, {418,0.00343636}, {419,0.00347273}, {420,0.00341818}, {421,0.00355455}, {422,0.00352727}, {423,0.00354545}, {424,0.00367273}, {425,0.00350000}, {426,0.00375455}, {427,0.00350000}, {428,0.00372727}, {429,0.00365455}, {430,0.00385455}, {431,0.00369091}, {432,0.00404545}, {433,0.00382727}, {434,0.00373636}, {435,0.00372727}, {436,0.00365455}, {437,0.00389091}, {438,0.00390000}, {439,0.00387273}, {440,0.00400909}, {441,0.00357273}, {442,0.00409091}, {443,0.00398182}, {444,0.00394545}, {445,0.00409091}, {446,0.00396364}, {447,0.00412727}, {448,0.00389091}, {449,0.00401818}, {450,0.00378182}, {451,0.00407273}, {452,0.00412727}, {453,0.00415455}, {454,0.00429091}, {455,0.00381818}, {456,0.00433636}, {457,0.00416364}, {458,0.00412727}, {459,0.00419091}, {460,0.00407273}, {461,0.00410909}, {462,0.00404545}, {463,0.00424545}, {464,0.00405455}, {465,0.00440909}, {466,0.00466364}, {467,0.00459091}, {468,0.00454545}, {469,0.00443636}, {470,0.00455455}, {471,0.00472727}, {472,0.00487273}, {473,0.00452727}, {474,0.00452727}, {475,0.00438182}, {476,0.00475455}, {477,0.00474545}, {478,0.00441818}, {479,0.00452727}, {480,0.00460000}, {481,0.00460000}, {482,0.00465455}, {483,0.00449091}, {484,0.00490000}, {485,0.00448182}, {486,0.00690000}, {487,0.00470000}, {488,0.00473636}, {489,0.00495455}, {490,0.00482727}, {491,0.00488182}, {492,0.00489091}, {493,0.00493636}, {494,0.00499091}, {495,0.00454545}, {496,0.00448182}, {497,0.00486364}, {498,0.00490909}, {499,0.00459091}, {500,0.00468182}, {505,0.00528182}, {510,0.00546364}, {515,0.00560000}, {520,0.00560909}, {525,0.00542727}, {530,0.00555455}, {535,0.00570909}, {540,0.00604545}, {545,0.00612727}, {550,0.00600000}, {555,0.00657273}, {560,0.00627273}, {565,0.00621818}, {570,0.00662727}, {575,0.00665455}, {580,0.00670909}, {585,0.00667273}, {590,0.00697273}, {595,0.00730000}, {600,0.00698182}, {605,0.00722727}, {610,0.00737273}, {615,0.00737273}, {620,0.00759091}, {625,0.00777273}, {630,0.00778182}, {635,0.00803636}, {640,0.00802727}, {645,0.00836364}, {650,0.00830909}, {655,0.00842727}, {660,0.00863636}, {665,0.00848182}, {670,0.00867273}, {675,0.00875455}, {680,0.00914545}, {685,0.00948182}, {690,0.00919091}, {695,0.00939091}, {700,0.00940000}, {705,0.01002727}, {710,0.01002727}, {715,0.01007273}, {720,0.01036364}, {725,0.01087273}, {730,0.01056364}, {735,0.01067273}, {740,0.01094545}, {745,0.01134545}, {750,0.01126364}, {755,0.01132727}, {760,0.01181818}, {765,0.01162727}, {770,0.01181818}, {775,0.01200909}, {780,0.01225455}, {785,0.01258182}, {790,0.01279091}, {795,0.01816364}, {800,0.01251818}, {805,0.01283636}, {810,0.01332727}, {815,0.01266364}, {820,0.01326364}, {825,0.01347273}, {830,0.01336364}, {835,0.01340000}, {840,0.01389091}, {845,0.01358182}, {850,0.01420909}, {855,0.01424545}, {860,0.01460000}, {865,0.01465455}, {870,0.01468182}, {875,0.01457273}, {880,0.01501818}, {885,0.01523636}, {890,0.01532727}, {895,0.01537273}, {900,0.01565455}, {905,0.01580909}, {910,0.01578182}, {915,0.01633636}, {920,0.01624545}, {925,0.01657273}, {930,0.01648182}, {935,0.01662727}, {940,0.01656364}, {945,0.01697273}, {950,0.01709091}, {955,0.01736364}, {960,0.01733636}, {965,0.02222727}, {970,0.01792727}, {975,0.01783636}, {980,0.01825455}, {985,0.01803636}, {990,0.01856364}, {995,0.01863636}, {1000,0.01882727}, {1010,0.01921818}, {1020,0.01947273}, {1030,0.02010909}, {1040,0.02010000}, {1050,0.02077273}, {1060,0.02099091}, {1070,0.02183636}, {1080,0.02242727}, {1090,0.02288182}, {1100,0.02304545}, {1110,0.02396364}, {1120,0.02425455}, {1130,0.02464545}, {1140,0.02545455}, {1150,0.02549091}, {1160,0.02600909}, {1170,0.02627273}, {1180,0.02655455}, {1190,0.02711818}, {1200,0.02769091}, {1210,0.02790909}, {1220,0.03228182}, {1230,0.02898182}, {1240,0.02926364}, {1250,0.02998182}, {1260,0.03042727}, {1270,0.03099091}, {1280,0.03146364}, {1290,0.03189091}, {1300,0.03252727}, {1310,0.03350000}, {1320,0.03403636}, {1330,0.03507273}, {1340,0.03530909}, {1350,0.03602727}, {1360,0.03677273}, {1370,0.03740000}, {1380,0.03864545}, {1390,0.03943636}, {1400,0.03941818}, {1410,0.04038182}, {1420,0.04116364}, {1430,0.04209091}, {1440,0.04235455}, {1450,0.04331818}, {1460,0.04386364}, {1470,0.04491818}, {1480,0.04600000}, {1490,0.04636364}, {1500,0.04681818}, {1510,0.04791818}, {1520,0.04860909}, {1530,0.05666364}, {1540,0.05117273}, {1550,0.05214545}, {1560,0.06009091}, {1570,0.05452727}, {1580,0.05542727}, {1590,0.05613636}, {1600,0.05730000}, {1610,0.05903636}, {1620,0.05995455}, {1630,0.06142727}, {1640,0.06240909}, {1650,0.06360909}, {1660,0.06440000}, {1670,0.06579091}, {1680,0.06702727}, {1690,0.06816364}, {1700,0.06914545}, {1710,0.07075455}, {1720,0.07203636}, {1730,0.07900909}, {1740,0.07453636}, {1750,0.07617273}, {1760,0.07772727}, {1770,0.07923636}, {1780,0.08043636}, {1790,0.08229091}, {1800,0.08357273}, {1810,0.08595455}, {1820,0.09944545}, {1830,0.08927273}, {1840,0.09018182}, {1850,0.09177273}, {1860,0.10118182}, {1870,0.09528182}, {1880,0.09665455}, {1890,0.09934545}, {1900,0.10040000}, {1910,0.10204545}, {1920,0.11059091}, {1930,0.10507273}, {1940,0.10705455}, {1950,0.10874545}, {1960,0.11051818}, {1970,0.11207273}, {1980,0.11352727}, {1990,0.11531818}, {2000,0.11711818}, {2050,0.12594545}, {2100,0.13561818}, {2150,0.14498182}, {2200,0.15453636}, {2250,0.16431818}, {2300,0.17459091}, {2350,0.18506364}, {2400,0.19579091}, {2450,0.20636364}, {2500,0.21710909}, {2550,0.22867273}, {2600,0.24079091}, {2650,0.25160909}, {2700,0.26327273}, {2750,0.27544545}, {2800,0.28723636}, {2850,0.29939091}, {2900,0.31083636}, {2950,0.32509091}, {3000,0.33700909}, {3050,0.35750}, {3100,0.36075}, {3150,0.37450}, {3200,0.38925}, {3250,0.39950}, {3300,0.43450}, {3350,0.47475}, {3400,0.46225}, {3450,0.46900}, {3500,0.48375}, {3550,0.49875}, {3600,0.55350}, {3650,0.53125}, {3700,0.54850}, {3750,0.56500}, {3800,0.56775}, {3850,0.57750}, {3900,0.61425}, {3950,0.61350}, {4000,0.62925}, {4050,0.64800}, {4100,0.66250}, {4150,0.68050}, {4200,0.74825}, {4250,0.71175}, {4300,0.73175}, {4350,0.76625}, {4400,0.76575}, {4450,0.78650}, {4500,0.90650}, {4550,0.88925}, {4600,0.90675}, {4650,0.89425}, {4700,0.91825}, {4750,0.93825}, {4800,0.99275}, {4850,1.08575}, {4900,1.09575}, {4950,1.06025}, {5000,1.10700}, {5050,1.10575}, {5100,1.21150}, {5150,1.15700}, {5200,1.17525}, {5250,1.20250}, {5300,1.24075}, {5350,1.29075}, {5400,1.28075}, {5450,1.25375}, {5500,1.27425}, {5550,1.44675}, {5600,1.42825}, {5650,1.40350}, {5700,1.56925}, {5750,1.45500}, {5800,1.48225}, {5850,1.58700}, {5900,1.60025}, {5950,1.50125}, {6000,1.46300}, {6050,1.55250}, {6100,1.62425}, {6150,1.64575}, {6200,1.61300}, {6250,1.58650}, {6300,1.66050}, {6350,1.63825}, {6400,1.70550}, {6450,1.62575}, {6500,1.73575}, {6550,1.97750}, {6600,1.93350}, {6650,1.94675}, {6700,1.95775}, {6750,1.98075}, {6800,2.17700}, {6850,2.03525}, {6900,2.02750}, {6950,2.19850}, {7000,2.18425}, {7050,2.27250}, {7100,2.15550}, {7150,2.23975}, {7200,2.33275}, {7250,2.31225}, {7300,2.27850}, {7350,2.30625}, {7400,2.44425}, {7450,2.58825}, {7500,2.67750}, {7550,2.60475}, {7600,2.47925}, {7650,2.84150}, {7700,2.65650}, {7750,2.87950}, {7800,2.69400}, {7850,2.76650}, {7900,2.82550}, {7950,2.99250}, {8000,3.07575}, {8050,3.10450}, {8100,3.05875}, {8150,2.97850}, {8200,3.01525}, {8250,3.34925}, {8300,2.95250}, {8350,3.06375}, {8400,2.90325}, {8450,3.46250}, {8500,3.18350}, {8550,3.13150}, {8600,3.03500}, {8650,3.12025}, {8700,3.15875}, {8750,3.13275}, {8800,3.17300}, {8850,3.29225}, {8900,3.39575}, {8950,3.44175}, {9000,3.45425}, {9050,3.36050}, {9100,3.19050}, {9150,3.11450}, {9200,3.15475}, {9250,3.36125}, {9300,3.78550}, {9350,4.00750}, {9400,3.70150}, {9450,3.70125}, {9500,3.54250}, {9550,3.85475}, {9600,3.92425}, {9650,3.81550}, {9700,4.01875}, {9750,3.90275}, {9800,4.21975}, {9850,4.22700}, {9900,4.39475}, {9950,4.11575}, {10000,4.29775}, {10100,4.3375}, {10200,4.2495}, {10300,4.3330}, {10400,5.115}, {10500,4.988}, {10600,5.039}, {10700,5.159}, {10800,5.255}, {10900,4.392}, {11000,4.427}, {11100,4.576}, {11200,4.624}, {11300,4.72}, {11400,4.812}, {11500,4.867}, {11600,4.967}, {11700,5.}, {11800,5.139}, {11900,5.228}, {12000,5.311}, {12100,5.42}, {12200,5.496}, {12300,7.98}, {12400,6.903}, {12500,8.307}, {12600,7.94}, {12700,7.435}, {12800,8.368}, {12900,7.871}, {13000,7.592}, {13100,8.243}, {13200,7.956}, {13300,7.951}, {13400,8.107}, {13500,8.208}, {13600,8.828}, {13700,8.472}, {13800,10.179}, {13900,8.96}, {14000,8.86}, {14100,8.947}, {14200,10.028}, {14300,10.256}, {14400,9.615}, {14500,9.496}, {14600,10.079}, {14700,10.351}, {14800,11.292}, {14900,10.003}, {15000,11.343}, {15100,10.36}, {15200,12.327}, {15300,11.164}, {15400,12.363}, {15500,7.427}, {15600,11.228}, {15700,22.952}, {15800,11.547}, {15900,12.884}, {16000,13.608}, {16100,13.812}, {16200,13.332}, {16300,11.976}, {16400,13.963}, {16500,12.819}, {16600,12.427}, {16700,12.596}, {16800,12.739}, {16900,14.387}, {17000,14.019}, {17100,13.911}, {17200,13.476}, {17300,14.052}, {17400,14.248}, {17500,13.943}, {17600,14.355}, {17700,15.215}, {17800,14.988}, {17900,14.448}, {18000,15.051}, {18100,17.252}, {18200,14.955}, {18300,17.86}, {18400,15.268}, {18500,17.327}, {18600,17.036}, {18700,21.976}, {18800,18.831}, {18900,21.272}, {19000,16.355}, {19100,18.967}, {19200,18.199}, {19300,18.856}, {19400,26.956}, {19500,50.855}, {19600,20.752}, {19700,17.54}, {19800,19.887}, {19900,31.28}};
data["big"]["lazy Denote"]["Stats"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00003636}, {21,0.00000000}, {22,0.00000000}, {23,0.00003636}, {24,0.00003636}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00003636}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00003636}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00003636}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00003636}, {89,0.00000000}, {90,0.00002727}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00003636}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00003636}, {112,0.00003636}, {113,0.00000000}, {114,0.00000000}, {115,0.00003636}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00003636}, {125,0.00003636}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00003636}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00003636}, {137,0.00000000}, {138,0.00003636}, {139,0.00000000}, {140,0.00003636}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00007273}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00003636}, {157,0.00000000}, {158,0.00000000}, {159,0.00002727}, {160,0.00002727}, {161,0.00000000}, {162,0.00003636}, {163,0.00003636}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00003636}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00007273}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00003636}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00002727}, {183,0.00000000}, {184,0.00003636}, {185,0.00000000}, {186,0.00003636}, {187,0.00002727}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00003636}, {192,0.00000000}, {193,0.00000000}, {194,0.00003636}, {195,0.00003636}, {196,0.00002727}, {197,0.00014545}, {198,0.00000000}, {199,0.00000000}, {200,0.00007273}, {201,0.00000000}, {202,0.00000000}, {203,0.00003636}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00003636}, {208,0.00003636}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00003636}, {214,0.00003636}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00003636}, {220,0.00006364}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00003636}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00007273}, {230,0.00000000}, {231,0.00003636}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00003636}, {242,0.00000000}, {243,0.00003636}, {244,0.00003636}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00003636}, {261,0.00002727}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003636}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00003636}, {276,0.00000000}, {277,0.00003636}, {278,0.00000000}, {279,0.00003636}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00003636}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00003636}, {289,0.00000000}, {290,0.00000000}, {291,0.00003636}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00003636}, {296,0.00003636}, {297,0.00000000}, {298,0.00006364}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00003636}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00003636}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00003636}, {314,0.00000000}, {315,0.00000000}, {316,0.00003636}, {317,0.00000000}, {318,0.00007273}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00003636}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00003636}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00003636}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00003636}, {348,0.00003636}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00003636}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00003636}, {364,0.00000000}, {365,0.00000000}, {366,0.00003636}, {367,0.00003636}, {368,0.00000000}, {369,0.00000000}, {370,0.00003636}, {371,0.00000000}, {372,0.00003636}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00003636}, {389,0.00003636}, {390,0.00000000}, {391,0.00000000}, {392,0.00002727}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00003636}, {401,0.00003636}, {402,0.00003636}, {403,0.00000000}, {404,0.00007273}, {405,0.00007273}, {406,0.00003636}, {407,0.00003636}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00003636}, {412,0.00000000}, {413,0.00003636}, {414,0.00000000}, {415,0.00000000}, {416,0.00007273}, {417,0.00003636}, {418,0.00003636}, {419,0.00000000}, {420,0.00003636}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00003636}, {430,0.00000000}, {431,0.00000000}, {432,0.00003636}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00003636}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00003636}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00006364}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00003636}, {462,0.00006364}, {463,0.00003636}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00003636}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00003636}, {484,0.00000000}, {485,0.00003636}, {486,0.00007273}, {487,0.00003636}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00003636}, {496,0.00000000}, {497,0.00000000}, {498,0.00003636}, {499,0.00003636}, {500,0.00000000}, {505,0.00000000}, {510,0.00003636}, {515,0.00000000}, {520,0.00000000}, {525,0.00003636}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00003636}, {570,0.00000000}, {575,0.00003636}, {580,0.00000000}, {585,0.00000000}, {590,0.00007273}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00003636}, {615,0.00000000}, {620,0.00003636}, {625,0.00003636}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00007273}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00002727}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00006364}, {725,0.00000000}, {730,0.00003636}, {735,0.00003636}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00003636}, {785,0.00000000}, {790,0.00003636}, {795,0.00023636}, {800,0.00000000}, {805,0.00003636}, {810,0.00003636}, {815,0.00003636}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00003636}, {840,0.00003636}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00007273}, {865,0.00000000}, {870,0.00003636}, {875,0.00000000}, {880,0.00003636}, {885,0.00000000}, {890,0.00003636}, {895,0.00000000}, {900,0.00003636}, {905,0.00003636}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00007273}, {930,0.00003636}, {935,0.00000000}, {940,0.00000000}, {945,0.00003636}, {950,0.00007273}, {955,0.00000000}, {960,0.00006364}, {965,0.00010909}, {970,0.00000000}, {975,0.00000000}, {980,0.00003636}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00003636}, {1040,0.00007273}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00003636}, {1110,0.00003636}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00003636}, {1160,0.00000000}, {1170,0.00003636}, {1180,0.00003636}, {1190,0.00003636}, {1200,0.00003636}, {1210,0.00000000}, {1220,0.00003636}, {1230,0.00003636}, {1240,0.00000000}, {1250,0.00003636}, {1260,0.00007273}, {1270,0.00000000}, {1280,0.00003636}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00002727}, {1320,0.00007273}, {1330,0.00003636}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00003636}, {1410,0.00002727}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00003636}, {1450,0.00003636}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00007273}, {1510,0.00000000}, {1520,0.00003636}, {1530,0.00003636}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00010909}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00003636}, {1600,0.00003636}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00007273}, {1650,0.00000000}, {1660,0.00003636}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00007273}, {1700,0.00003636}, {1710,0.00006364}, {1720,0.00000000}, {1730,0.00021818}, {1740,0.00000000}, {1750,0.00003636}, {1760,0.00000000}, {1770,0.00003636}, {1780,0.00000000}, {1790,0.00003636}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00018182}, {1830,0.00003636}, {1840,0.00007273}, {1850,0.00003636}, {1860,0.00003636}, {1870,0.00007273}, {1880,0.00010909}, {1890,0.00003636}, {1900,0.00000000}, {1910,0.00003636}, {1920,0.00003636}, {1930,0.00000000}, {1940,0.00003636}, {1950,0.00000000}, {1960,0.00002727}, {1970,0.00003636}, {1980,0.00000000}, {1990,0.00007273}, {2000,0.00003636}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00002727}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00003636}, {2450,0.00003636}, {2500,0.00003636}, {2550,0.00002727}, {2600,0.00003636}, {2650,0.00010000}, {2700,0.00010000}, {2750,0.00000000}, {2800,0.00003636}, {2850,0.00000000}, {2900,0.00003636}, {2950,0.00002727}, {3000,0.00000000}, {3050,0.00000}, {3100,0.00000}, {3150,0.00000}, {3200,0.00000}, {3250,0.00000}, {3300,0.00000}, {3350,0.00000}, {3400,0.00000}, {3450,0.00000}, {3500,0.00000}, {3550,0.00000}, {3600,0.00000}, {3650,0.00000}, {3700,0.00000}, {3750,0.00000}, {3800,0.00100}, {3850,0.00000}, {3900,0.00000}, {3950,0.00000}, {4000,0.00000}, {4050,0.00000}, {4100,0.00000}, {4150,0.00000}, {4200,0.00000}, {4250,0.00100}, {4300,0.00000}, {4350,0.00000}, {4400,0.00000}, {4450,0.00000}, {4500,0.00000}, {4550,0.00000}, {4600,0.00000}, {4650,0.00000}, {4700,0.00000}, {4750,0.00000}, {4800,0.00100}, {4850,0.00000}, {4900,0.00000}, {4950,0.00000}, {5000,0.00100}, {5050,0.00000}, {5100,0.00100}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00100}, {5650,0.00000}, {5700,0.00300}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00100}, {8900,0.00100}, {8950,0.00000}, {9000,0.00000}, {9050,0.00100}, {9100,0.00100}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00100}, {9450,0.00200}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00200}, {10000,0.00100}, {10100,0.0000}, {10200,0.0020}, {10300,0.0000}, {10400,0}, {10500,0}, {10600,0}, {10700,0}, {10800,0}, {10900,0}, {11000,0}, {11100,0.004}, {11200,0}, {11300,0}, {11400,0}, {11500,0}, {11600,0}, {11700,0}, {11800,0}, {11900,0}, {12000,0}, {12100,0}, {12200,0}, {12300,0}, {12400,0.004}, {12500,0}, {12600,0}, {12700,0}, {12800,0}, {12900,0}, {13000,0}, {13100,0}, {13200,0}, {13300,0}, {13400,0}, {13500,0}, {13600,0}, {13700,0}, {13800,0}, {13900,0}, {14000,0}, {14100,0}, {14200,0}, {14300,0}, {14400,0}, {14500,0}, {14600,0}, {14700,0}, {14800,0}, {14900,0}, {15000,0}, {15100,0}, {15200,0}, {15300,0}, {15400,0}, {15500,0}, {15600,0}, {15700,0}, {15800,0}, {15900,0}, {16000,0}, {16100,0}, {16200,0}, {16300,0}, {16400,0}, {16500,0}, {16600,0}, {16700,0}, {16800,0}, {16900,0}, {17000,0}, {17100,0}, {17200,0}, {17300,0}, {17400,0}, {17500,0}, {17600,0.004}, {17700,0}, {17800,0}, {17900,0}, {18000,0}, {18100,0}, {18200,0}, {18300,0}, {18400,0}, {18500,0}, {18600,0}, {18700,0}, {18800,0}, {18900,0}, {19000,0}, {19100,0}, {19200,0}, {19300,0}, {19400,0}, {19500,0}, {19600,0}, {19700,0}, {19800,0}, {19900,0}};
data["big"]["parsing"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00016379}, {6,0.00071552}, {7,0.00100000}, {8,0.00100862}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00102586}, {13,0.00165517}, {14,0.00189655}, {15,0.00200000}, {16,0.00200000}, {17,0.00200862}, {18,0.00200862}, {19,0.00216379}, {20,0.00276724}, {21,0.00300000}, {22,0.00300000}, {23,0.00300000}, {24,0.00341379}, {25,0.00399138}, {26,0.00381897}, {27,0.00400000}, {28,0.00400000}, {29,0.00400000}, {30,0.04643966}, {31,0.00400000}, {32,0.00402586}, {33,0.00496552}, {34,0.00500000}, {35,0.00500862}, {36,0.00501724}, {37,0.00539655}, {38,0.00647414}, {39,0.00600862}, {40,0.00606897}, {41,0.00693966}, {42,0.00700000}, {43,0.00700862}, {44,0.00720690}, {45,0.00799138}, {46,0.00800862}, {47,0.02368966}, {48,0.00822414}, {49,0.00929310}, {50,0.00903448}, {51,0.00968103}, {52,0.00993966}, {53,0.01003448}, {54,0.01056034}, {55,0.01203448}, {56,0.01100862}, {57,0.03189655}, {58,0.01195690}, {59,0.01212069}, {60,0.01286207}, {61,0.01300862}, {62,0.01305172}, {63,0.01362931}, {64,0.01398276}, {65,0.02893966}, {66,0.01494828}, {67,0.01527586}, {68,0.01546552}, {69,0.01615517}, {70,0.01658621}, {71,0.01693103}, {72,0.02760345}, {73,0.01775862}, {74,0.01802586}, {75,0.01869828}, {76,0.01891379}, {77,0.03437931}, {78,0.02002586}, {79,0.02000862}, {80,0.02363793}, {81,0.02174138}, {82,0.04206897}, {83,0.02243966}, {84,0.02289655}, {85,0.02361207}, {86,0.02385345}, {87,0.03440517}, {88,0.02491379}, {89,0.02532759}, {90,0.02584483}, {91,0.04040517}, {92,0.02688793}, {93,0.02713793}, {94,0.02792241}, {95,0.03797414}, {96,0.02888793}, {97,0.02979310}, {98,0.04817241}, {99,0.03073276}, {100,0.03161207}, {101,0.04655172}, {102,0.03222414}, {103,0.03300862}, {104,0.03393966}, {105,0.03962931}, {106,0.03489655}, {107,0.03569828}, {108,0.04852586}, {109,0.03697414}, {110,0.05002586}, {111,0.03809483}, {112,0.03874138}, {113,0.05308621}, {114,0.03999138}, {115,0.04611207}, {116,0.05357759}, {117,0.04202586}, {118,0.05815517}, {119,0.04297414}, {120,0.04357759}, {121,0.05036207}, {122,0.04548276}, {123,0.05425000}, {124,0.04697414}, {125,0.06701724}, {126,0.04814655}, {127,0.06799138}, {128,0.04972414}, {129,0.06942241}, {130,0.05080172}, {131,0.07197414}, {132,0.05203448}, {133,0.07444828}, {134,0.05360345}, {135,0.07416379}, {136,0.05523276}, {137,0.07307759}, {138,0.05661207}, {139,0.06725000}, {140,0.05790517}, {141,0.08779310}, {142,0.10888793}, {143,0.06069828}, {144,0.08905172}, {145,0.06221552}, {146,0.07608621}, {147,0.09384483}, {148,0.06499138}, {149,0.08151724}, {150,0.06662069}, {151,0.07774138}, {152,0.11343103}, {153,0.06859483}, {154,0.07979310}, {155,0.09928448}, {156,0.07125862}, {157,0.07964655}, {158,0.08737069}, {159,0.10489655}, {160,0.07520690}, {161,0.08588793}, {162,0.11070690}, {163,0.10554310}, {164,0.07844828}, {165,0.11143103}, {166,0.11620690}, {167,0.11592241}, {168,0.08257759}, {169,0.08700862}, {170,0.09406034}, {171,0.10294828}, {172,0.14537931}, {173,0.13128448}, {174,0.08805172}, {175,0.09647414}, {176,0.10385345}, {177,0.12375862}, {178,0.12368966}, {179,0.12924138}, {180,0.12893103}, {181,0.11861207}, {182,0.12556897}, {183,0.12691379}, {184,0.13208621}, {185,0.09939655}, {186,0.10482759}, {187,0.10521552}, {188,0.13260345}, {189,0.13331034}, {190,0.13562069}, {191,0.13793103}, {192,0.13775000}, {193,0.15653448}, {194,0.17031034}, {195,0.16329310}, {196,0.14937931}, {197,0.14436207}, {198,0.14512931}, {199,0.14765517}, {200,0.14155172}, {201,0.13616379}, {202,0.14720690}, {203,0.18070690}, {204,0.15656897}, {205,0.15644828}, {206,0.15187931}, {207,0.15373276}, {208,0.15588793}, {209,0.18001724}, {210,0.19883621}, {211,0.17704310}, {212,0.16223276}, {213,0.18609483}, {214,0.17294828}, {215,0.16350862}, {216,0.16295690}, {217,0.20098276}, {218,0.16779310}, {219,0.16575000}, {220,0.20215517}, {221,0.17107759}, {222,0.17168966}, {223,0.20416379}, {224,0.20498276}, {225,0.23233621}, {226,0.18091379}, {227,0.17514655}, {228,0.21998276}, {229,0.16861207}, {230,0.21800000}, {231,0.17994828}, {232,0.21620690}, {233,0.18384483}, {234,0.21988793}, {235,0.18876724}, {236,0.24360345}, {237,0.21575862}, {238,0.24927586}, {239,0.21581897}, {240,0.21172414}, {241,0.22820690}, {242,0.18620690}, {243,0.23551724}, {244,0.22625000}, {245,0.20531034}, {246,0.23567241}, {247,0.23156034}, {248,0.21035345}, {249,0.22000862}, {250,0.28968103}, {251,0.24512069}, {252,0.21885345}, {253,0.25187069}, {254,0.24195690}, {255,0.24037931}, {256,0.24182759}, {257,0.24379310}, {258,0.24612069}, {259,0.25325862}, {260,0.23978448}, {261,0.27772414}, {262,0.25658621}, {263,0.30446552}, {264,0.26656034}, {265,0.26255172}, {266,0.26370690}, {267,0.26610345}, {268,0.26570690}, {269,0.27495690}, {270,0.26147414}, {271,0.30000862}, {272,0.28976724}, {273,0.32273276}, {274,0.28269828}, {275,0.28731897}, {276,0.28737931}, {277,0.28916379}, {278,0.29318103}, {279,0.29880172}, {280,0.32027586}, {281,0.33312931}, {282,0.32607759}, {283,0.30154310}, {284,0.30552586}, {285,0.30957759}, {286,0.31326724}, {287,0.31780172}, {288,0.33358621}, {289,0.34433621}, {290,0.36674138}, {291,0.33893103}, {292,0.32984483}, {293,0.33474138}, {294,0.33255172}, {295,0.34025862}, {296,0.37635345}, {297,0.36848276}, {298,0.38446552}, {299,0.35470690}, {300,0.35162931}, {301,0.35156034}, {302,0.35306897}, {303,0.36061207}, {304,0.43051724}, {305,0.37981034}, {306,0.38068103}, {307,0.36963793}, {308,0.37133621}, {309,0.37210345}, {310,0.37846552}, {311,0.41542241}, {312,0.40479310}, {313,0.41432759}, {314,0.37447414}, {315,0.38815517}, {316,0.38893103}, {317,0.39517241}, {318,0.46696552}, {319,0.42437931}, {320,0.43065517}, {321,0.40849138}, {322,0.40713793}, {323,0.40893966}, {324,0.42141379}, {325,0.44181034}, {326,0.49893966}, {327,0.42818103}, {328,0.42333621}, {329,0.42644828}, {330,0.43520690}, {331,0.52037069}, {332,0.45621552}, {333,0.46043966}, {334,0.44743966}, {335,0.44531034}, {336,0.59821552}, {337,0.47893966}, {338,0.48765517}, {339,0.45749138}, {340,0.45795690}, {341,0.46181897}, {342,0.52011207}, {343,0.50100000}, {344,0.51802586}, {345,0.47411207}, {346,0.47993966}, {347,0.47961207}, {348,0.56842241}, {349,0.51955172}, {350,0.51161207}, {351,0.49366379}, {352,0.49293103}, {353,0.50147414}, {354,0.58658621}, {355,0.52748276}, {356,0.52358621}, {357,0.51057759}, {358,0.51204310}, {359,0.52670690}, {360,0.58151724}, {361,0.59718966}, {362,0.53009483}, {363,0.52621552}, {364,0.53725862}, {365,0.64332759}, {366,0.56501724}, {367,0.55523276}, {368,0.54686207}, {369,0.55095690}, {370,0.66543103}, {371,0.58725862}, {372,0.57566379}, {373,0.56227586}, {374,0.56455172}, {375,0.68571552}, {376,0.60250000}, {377,0.59040517}, {378,0.57752586}, {379,0.58660345}, {380,0.70692241}, {381,0.61939655}, {382,0.59679310}, {383,0.59057759}, {384,0.60030172}, {385,0.70950000}, {386,0.63718966}, {387,0.61837069}, {388,0.61606897}, {389,0.61839655}, {390,0.72638793}, {391,0.65411207}, {392,0.62347414}, {393,0.62461207}, {394,0.63491379}, {395,0.76786207}, {396,0.67445690}, {397,0.64368103}, {398,0.64827586}, {399,0.65306034}, {400,0.78156897}, {401,0.69831897}, {402,0.65248276}, {403,0.66241379}, {404,0.67049138}, {405,0.79116379}, {406,0.72000000}, {407,0.68036207}, {408,0.67832759}, {409,0.73330172}, {410,0.80743966}, {411,0.72334483}, {412,0.69690517}, {413,0.70263793}, {414,0.85483621}, {415,0.75069828}, {416,0.70596552}, {417,0.71092241}, {418,0.75591379}, {419,0.85040517}, {420,0.75895690}, {421,0.72612069}, {422,0.73706034}, {423,0.88468103}, {424,0.79330172}, {425,0.75481897}, {426,0.74950862}, {427,0.90346552}, {428,0.79478448}, {429,0.75959483}, {430,0.76346552}, {431,0.77306897}, {432,0.90829310}, {433,0.82555172}, {434,0.78126724}, {435,0.77904310}, {436,0.92806897}, {437,0.84236207}, {438,0.80833621}, {439,0.79717241}, {440,0.81116379}, {441,0.98537931}, {442,0.84942241}, {443,0.81491379}, {444,0.81555172}, {445,0.99207759}, {446,0.87845690}, {447,0.84063793}, {448,0.82992241}, {449,1.00599138}, {450,0.89548276}, {451,0.84661207}, {452,0.84837931}, {453,0.93685345}, {454,0.98471552}, {455,0.89302586}, {456,0.86554310}, {457,0.90068966}, {458,1.05226724}, {459,0.91553448}, {460,0.87848276}, {461,0.90520690}, {462,1.07014655}, {463,0.93393966}, {464,0.89681034}, {465,0.91997414}, {466,1.09322414}, {467,0.95885345}, {468,0.91593103}, {469,1.55359483}, {470,1.10892241}, {471,0.97508621}, {472,0.94010345}, {473,1.04424138}, {474,1.06549138}, {475,0.96917241}, {476,0.95136207}, {477,1.25598276}, {478,1.03934483}, {479,0.97814655}, {480,0.97258621}, {481,1.07418103}, {482,1.09011207}, {483,1.00189655}, {484,0.98724138}, {485,1.08092241}, {486,1.12894828}, {487,1.02448276}, {488,1.01554310}, {489,1.11826724}, {490,1.14107759}, {491,1.04342241}, {492,1.04113793}, {493,1.14325862}, {494,1.14377586}, {495,1.06670690}, {496,1.09757759}, {497,1.19381034}, {498,1.12700000}, {499,1.06385345}, {500,1.10082759}, {505,1.16967}, {510,1.17700}, {515,1.17800}, {520,1.20800}, {525,1.22600}, {530,1.22433}, {535,1.30033}, {540,1.31967}, {545,1.33567}, {550,1.31867}, {555,1.36967}, {560,1.39933}, {565,1.42567}, {570,1.40500}, {575,1.47533}, {580,1.50133}, {585,1.49667}, {590,1.45533}, {595,1.53967}, {600,1.54875}, {605,1.61233}, {610,1.61800}, {615,1.65067}, {620,1.71267}, {625,1.68700}, {630,2.28467}, {635,1.97333}, {640,1.74533}, {645,1.78200}, {650,2.37400}, {655,1.80133}, {660,1.87267}, {665,2.47533}, {670,1.96000}, {675,2.04600}, {680,2.65800}, {685,2.08100}, {690,2.10133}, {695,2.14267}, {700,2.77650}, {705,2.18733}, {710,2.23467}, {715,2.58933}, {720,2.67633}, {725,2.72833}, {730,2.40867}, {735,2.43733}, {740,2.42333}, {745,2.83600}, {750,2.84567}, {755,2.92400}, {760,2.58100}, {765,2.69667}, {770,3.16067}, {775,3.20467}, {780,2.86000}, {785,3.31933}, {790,2.98033}, {795,3.05967}, {800,3.31075}, {805,3.10533}, {810,3.11867}, {815,3.55400}, {820,3.20067}, {825,3.25133}, {830,3.24533}, {835,3.78167}, {840,3.39833}, {845,3.43233}, {850,3.50833}, {855,3.58267}, {860,3.67333}, {865,4.15167}, {870,3.66467}, {875,4.27800}, {880,3.56533}, {885,3.62167}, {890,3.77333}, {895,3.78933}, {900,4.04375}, {905,4.33067}, {910,3.97000}, {915,3.95367}, {920,3.95600}, {925,3.94867}, {930,4.54800}, {935,4.05167}, {940,4.09067}, {945,4.16933}, {950,4.35500}, {955,4.38867}, {960,5.26067}, {965,4.48233}, {970,4.55467}, {975,4.61067}, {980,4.66233}, {985,5.65967}, {990,4.73833}, {995,4.75567}, {1000,4.84900}, {1010,4.92233}, {1020,5.04833}, {1030,5.21833}, {1040,5.31433}, {1050,5.44767}, {1060,5.53200}, {1070,6.53467}, {1080,5.64000}, {1090,6.72933}, {1100,5.92367}, {1110,6.16433}, {1120,6.16600}, {1130,6.21333}, {1140,6.28300}, {1150,7.57267}, {1160,6.58500}, {1170,7.82600}, {1180,6.91300}, {1190,7.02233}, {1200,7.13900}, {1210,7.26233}, {1220,7.41400}, {1230,7.46533}, {1240,7.72100}, {1250,7.77333}, {1260,8.00400}, {1270,8.08267}, {1280,8.22167}, {1290,9.63033}, {1300,9.72133}, {1310,10.03933}, {1320,8.67200}, {1330,10.27067}, {1340,10.52667}, {1350,10.64600}, {1360,10.68867}, {1370,9.60367}, {1380,9.63967}, {1390,9.80400}, {1400,10.33633}, {1410,10.17600}, {1420,12.08333}, {1430,12.03267}, {1440,12.31133}, {1450,12.20100}, {1460,12.20533}, {1470,14.22067}, {1480,11.21133}, {1490,11.66433}, {1500,13.91525}, {1510,11.76800}, {1520,11.99533}, {1530,13.55133}, {1540,15.50300}, {1550,14.19967}, {1560,12.66767}, {1570,15.51933}, {1580,12.42867}, {1590,14.15633}, {1600,15.86133}, {1610,14.72400}, {1620,14.61067}, {1630,16.74633}, {1640,16.88300}, {1650,16.82033}, {1660,18.53967}, {1670,19.26667}, {1680,17.37967}, {1690,16.75467}, {1700,16.05100}, {1710,18.43867}, {1720,14.60000}, {1730,16.72767}, {1740,17.30733}, {1750,17.65000}, {1760,16.81333}, {1770,19.01633}, {1780,21.70167}, {1790,18.14800}, {1800,18.43133}, {1810,17.78500}, {1820,18.83133}, {1830,20.47700}, {1840,20.94733}, {1850,23.24467}, {1860,21.80667}, {1870,22.33200}, {1880,23.96033}, {1890,20.36500}, {1900,21.93000}, {1910,23.67933}, {1920,21.85500}, {1930,24.82067}, {1940,18.65333}, {1950,22.25867}, {1960,22.75333}, {1970,23.19667}, {1980,25.25867}, {1990,21.00633}, {2000,25.92825}, {2050,29.03900}, {2100,27.13533}, {2150,28.06567}, {2200,28.41233}, {2250,32.33933}, {2300,33.50633}, {2350,35.11900}, {2400,36.73300}, {2450,43.15733}, {2500,39.10450}, {2550,43.93633}, {2600,42.73400}, {2650,45.39667}, {2700,45.19633}, {2750,52.12967}, {2800,52.59700}, {2850,56.88600}, {2900,58.95167}, {2950,61.93633}, {3000,63.46225}, {3050,66.17433}, {3100,68.71767}, {3150,65.34767}, {3200,65.45767}, {3250,68.79500}, {3300,66.97367}, {3350,73.11267}, {3400,76.03800}, {3450,73.97900}, {3500,81.82600}, {3550,89.81367}, {3600,91.38833}, {3650,87.02433}, {3700,91.82533}, {3750,93.77200}, {3800,106.21667}, {3850,99.64867}, {3900,102.3630}, {3950,99.7130}, {4000,110.80600}, {4050,110.5535}, {4100,111.5150}, {4150,134.291}, {4500,140.227}};
data["big"]["parsing"]["Stats"]["user"] = {{1,0.00012931}, {2,0.00023276}, {3,0.00041379}, {4,0.00062069}, {5,0.00054310}, {6,0.00097414}, {7,0.00090517}, {8,0.00120690}, {9,0.00124138}, {10,0.00128448}, {11,0.00156897}, {12,0.00162931}, {13,0.00150862}, {14,0.00211207}, {15,0.00198276}, {16,0.00191379}, {17,0.00222414}, {18,0.00260345}, {19,0.00242241}, {20,0.00225862}, {21,0.00269828}, {22,0.00288793}, {23,0.00300000}, {24,0.00355172}, {25,0.00343966}, {26,0.00352586}, {27,0.00352586}, {28,0.00374138}, {29,0.00413793}, {30,0.04378448}, {31,0.00437069}, {32,0.00454310}, {33,0.00539655}, {34,0.00503448}, {35,0.00548276}, {36,0.00550000}, {37,0.00622414}, {38,0.00658621}, {39,0.00601724}, {40,0.00671552}, {41,0.00714655}, {42,0.00740517}, {43,0.00762069}, {44,0.00775862}, {45,0.00820690}, {46,0.00841379}, {47,0.02350862}, {48,0.00862069}, {49,0.00985345}, {50,0.00950862}, {51,0.01014655}, {52,0.01024138}, {53,0.01040517}, {54,0.01050000}, {55,0.01239655}, {56,0.01120690}, {57,0.03184483}, {58,0.01241379}, {59,0.01289655}, {60,0.01300000}, {61,0.01354310}, {62,0.01337069}, {63,0.01418103}, {64,0.01431034}, {65,0.02913793}, {66,0.01541379}, {67,0.01587069}, {68,0.01588793}, {69,0.01610345}, {70,0.01668966}, {71,0.01744828}, {72,0.02755172}, {73,0.01817241}, {74,0.01812069}, {75,0.01864655}, {76,0.01912931}, {77,0.03436207}, {78,0.02033621}, {79,0.02055172}, {80,0.02393103}, {81,0.02200000}, {82,0.04195690}, {83,0.02245690}, {84,0.02296552}, {85,0.02358621}, {86,0.02423276}, {87,0.03468966}, {88,0.02524138}, {89,0.02600000}, {90,0.02602586}, {91,0.03999138}, {92,0.02714655}, {93,0.02773276}, {94,0.02862069}, {95,0.03806897}, {96,0.02893103}, {97,0.03041379}, {98,0.04806897}, {99,0.03068966}, {100,0.03180172}, {101,0.04592241}, {102,0.03274138}, {103,0.03320690}, {104,0.03337931}, {105,0.03987931}, {106,0.03506897}, {107,0.03593966}, {108,0.04855172}, {109,0.03768966}, {110,0.05031034}, {111,0.03817241}, {112,0.03906897}, {113,0.05289655}, {114,0.03992241}, {115,0.04616379}, {116,0.05356034}, {117,0.04251724}, {118,0.05810345}, {119,0.04351724}, {120,0.04406897}, {121,0.05079310}, {122,0.04609483}, {123,0.05404310}, {124,0.04720690}, {125,0.06656034}, {126,0.04856034}, {127,0.06797414}, {128,0.05002586}, {129,0.06962069}, {130,0.05137069}, {131,0.07158621}, {132,0.05219828}, {133,0.07380172}, {134,0.05375000}, {135,0.07424138}, {136,0.05569828}, {137,0.07319828}, {138,0.05696552}, {139,0.06687931}, {140,0.05801724}, {141,0.08731897}, {142,0.10852586}, {143,0.06079310}, {144,0.08884483}, {145,0.06262069}, {146,0.07591379}, {147,0.09341379}, {148,0.06485345}, {149,0.08090517}, {150,0.06652586}, {151,0.07794828}, {152,0.11261207}, {153,0.06829310}, {154,0.08005172}, {155,0.09801724}, {156,0.07144828}, {157,0.07947414}, {158,0.08721552}, {159,0.10422414}, {160,0.07513793}, {161,0.08585345}, {162,0.10995690}, {163,0.10487069}, {164,0.07829310}, {165,0.11095690}, {166,0.11580172}, {167,0.11589655}, {168,0.08260345}, {169,0.08721552}, {170,0.09434483}, {171,0.10286207}, {172,0.14530172}, {173,0.13126724}, {174,0.08814655}, {175,0.09633621}, {176,0.10378448}, {177,0.12367241}, {178,0.12400862}, {179,0.12851724}, {180,0.12814655}, {181,0.11798276}, {182,0.12497414}, {183,0.12590517}, {184,0.13131034}, {185,0.09944828}, {186,0.10500862}, {187,0.10515517}, {188,0.13254310}, {189,0.13326724}, {190,0.13532759}, {191,0.13793103}, {192,0.13772414}, {193,0.15695690}, {194,0.17056897}, {195,0.16288793}, {196,0.14941379}, {197,0.14419828}, {198,0.14496552}, {199,0.14738793}, {200,0.14088793}, {201,0.13522414}, {202,0.14680172}, {203,0.17884483}, {204,0.15539655}, {205,0.15565517}, {206,0.15196552}, {207,0.15373276}, {208,0.15592241}, {209,0.17980172}, {210,0.19880172}, {211,0.17676724}, {212,0.16181034}, {213,0.18636207}, {214,0.17275862}, {215,0.16350000}, {216,0.16235345}, {217,0.20106897}, {218,0.16775862}, {219,0.16562069}, {220,0.20237069}, {221,0.17099138}, {222,0.17187069}, {223,0.20451724}, {224,0.20501724}, {225,0.23212069}, {226,0.18096552}, {227,0.17523276}, {228,0.22001724}, {229,0.16881034}, {230,0.21819828}, {231,0.17948276}, {232,0.21612931}, {233,0.18346552}, {234,0.21997414}, {235,0.18901724}, {236,0.24344828}, {237,0.21538793}, {238,0.24954310}, {239,0.21553448}, {240,0.21138793}, {241,0.22717241}, {242,0.18527586}, {243,0.23360345}, {244,0.22418966}, {245,0.20420690}, {246,0.23524138}, {247,0.23122414}, {248,0.20991379}, {249,0.21986207}, {250,0.28964655}, {251,0.24500862}, {252,0.21850000}, {253,0.25190517}, {254,0.24187931}, {255,0.23986207}, {256,0.24155172}, {257,0.24362069}, {258,0.24582759}, {259,0.25322414}, {260,0.23950000}, {261,0.27738793}, {262,0.25616379}, {263,0.30441379}, {264,0.26638793}, {265,0.26222414}, {266,0.26388793}, {267,0.26597414}, {268,0.26543966}, {269,0.27462931}, {270,0.26143103}, {271,0.29964655}, {272,0.28933621}, {273,0.32237069}, {274,0.28133621}, {275,0.28496552}, {276,0.28492241}, {277,0.28687069}, {278,0.29262931}, {279,0.29817241}, {280,0.31978448}, {281,0.33268103}, {282,0.32542241}, {283,0.29987931}, {284,0.30418103}, {285,0.30908621}, {286,0.31275862}, {287,0.31662069}, {288,0.33239655}, {289,0.34323276}, {290,0.36557759}, {291,0.33868966}, {292,0.32937931}, {293,0.33404310}, {294,0.33250000}, {295,0.33956034}, {296,0.37583621}, {297,0.36775862}, {298,0.38403448}, {299,0.35426724}, {300,0.35163793}, {301,0.35122414}, {302,0.35300862}, {303,0.36024138}, {304,0.43029310}, {305,0.37984483}, {306,0.38050000}, {307,0.36918966}, {308,0.37131034}, {309,0.37191379}, {310,0.37846552}, {311,0.41510345}, {312,0.40450000}, {313,0.41403448}, {314,0.37429310}, {315,0.38806034}, {316,0.38891379}, {317,0.39461207}, {318,0.46639655}, {319,0.42418966}, {320,0.42992241}, {321,0.40813793}, {322,0.40684483}, {323,0.40874138}, {324,0.42111207}, {325,0.44197414}, {326,0.49898276}, {327,0.42761207}, {328,0.42318966}, {329,0.42606034}, {330,0.43513793}, {331,0.52015517}, {332,0.45601724}, {333,0.45818103}, {334,0.44327586}, {335,0.44250862}, {336,0.59724138}, {337,0.47830172}, {338,0.48753448}, {339,0.45718966}, {340,0.45762069}, {341,0.46168103}, {342,0.51988793}, {343,0.50107759}, {344,0.51789655}, {345,0.47384483}, {346,0.47967241}, {347,0.47946552}, {348,0.56838793}, {349,0.51927586}, {350,0.51123276}, {351,0.49343103}, {352,0.49265517}, {353,0.50156897}, {354,0.58606034}, {355,0.52745690}, {356,0.52309483}, {357,0.51049138}, {358,0.51193103}, {359,0.52612931}, {360,0.58125000}, {361,0.59686207}, {362,0.52970690}, {363,0.52619828}, {364,0.53710345}, {365,0.64320690}, {366,0.56485345}, {367,0.55489655}, {368,0.54640517}, {369,0.55080172}, {370,0.66525862}, {371,0.58667241}, {372,0.57557759}, {373,0.56208621}, {374,0.56425862}, {375,0.68542241}, {376,0.60229310}, {377,0.58992241}, {378,0.57711207}, {379,0.58624138}, {380,0.70660345}, {381,0.61935345}, {382,0.59651724}, {383,0.59012931}, {384,0.59946552}, {385,0.70929310}, {386,0.63686207}, {387,0.61312069}, {388,0.60964655}, {389,0.61750862}, {390,0.72578448}, {391,0.65387069}, {392,0.62325000}, {393,0.62412931}, {394,0.63466379}, {395,0.76745690}, {396,0.67447414}, {397,0.64343103}, {398,0.64798276}, {399,0.65284483}, {400,0.78135345}, {401,0.69787069}, {402,0.65223276}, {403,0.66180172}, {404,0.67009483}, {405,0.79097414}, {406,0.71975862}, {407,0.67993966}, {408,0.67811207}, {409,0.73293966}, {410,0.80694828}, {411,0.72287069}, {412,0.69631034}, {413,0.70226724}, {414,0.85464655}, {415,0.75025862}, {416,0.70599138}, {417,0.71025862}, {418,0.75578448}, {419,0.85015517}, {420,0.75850862}, {421,0.72575862}, {422,0.73661207}, {423,0.88448276}, {424,0.79261207}, {425,0.74821552}, {426,0.74419828}, {427,0.90283621}, {428,0.79435345}, {429,0.75963793}, {430,0.76312069}, {431,0.77270690}, {432,0.90788793}, {433,0.82503448}, {434,0.78086207}, {435,0.77867241}, {436,0.92756034}, {437,0.84196552}, {438,0.80781034}, {439,0.79662069}, {440,0.81105172}, {441,0.98497414}, {442,0.84912931}, {443,0.81472414}, {444,0.81512069}, {445,0.99168966}, {446,0.87801724}, {447,0.84040517}, {448,0.82961207}, {449,1.00559483}, {450,0.89529310}, {451,0.84625000}, {452,0.84785345}, {453,0.93605172}, {454,0.98412931}, {455,0.89278448}, {456,0.86513793}, {457,0.90029310}, {458,1.05181897}, {459,0.91506897}, {460,0.87821552}, {461,0.90468103}, {462,1.06972414}, {463,0.93375000}, {464,0.89629310}, {465,0.91962931}, {466,1.09294828}, {467,0.95715517}, {468,0.91217241}, {469,1.55218966}, {470,1.10848276}, {471,0.97125862}, {472,0.93381034}, {473,1.04341379}, {474,1.06481897}, {475,0.96872414}, {476,0.95076724}, {477,1.25527586}, {478,1.03893966}, {479,0.97767241}, {480,0.97226724}, {481,1.07362931}, {482,1.08996552}, {483,1.00140517}, {484,0.98706897}, {485,1.08044828}, {486,1.12839655}, {487,1.02395690}, {488,1.01520690}, {489,1.11760345}, {490,1.14065517}, {491,1.04325000}, {492,1.04107759}, {493,1.14260345}, {494,1.14343966}, {495,1.06447414}, {496,1.09522414}, {497,1.19342241}, {498,1.12615517}, {499,1.06350000}, {500,1.10050000}, {505,1.14500}, {510,1.16400}, {515,1.17800}, {520,1.20633}, {525,1.22467}, {530,1.22133}, {535,1.29233}, {540,1.32000}, {545,1.33400}, {550,1.31800}, {555,1.37033}, {560,1.39800}, {565,1.42200}, {570,1.40367}, {575,1.47667}, {580,1.50067}, {585,1.49533}, {590,1.45700}, {595,1.53800}, {600,1.54975}, {605,1.61167}, {610,1.61867}, {615,1.65000}, {620,1.69633}, {625,1.68367}, {630,2.28200}, {635,1.97367}, {640,1.74100}, {645,1.77533}, {650,2.37467}, {655,1.80167}, {660,1.85833}, {665,2.47367}, {670,1.95133}, {675,2.03167}, {680,2.65400}, {685,2.07133}, {690,2.08867}, {695,2.13967}, {700,2.77550}, {705,2.18633}, {710,2.22233}, {715,2.58700}, {720,2.66900}, {725,2.72267}, {730,2.40267}, {735,2.42067}, {740,2.41733}, {745,2.82733}, {750,2.84233}, {755,2.91633}, {760,2.56467}, {765,2.69600}, {770,3.15533}, {775,3.19800}, {780,2.84700}, {785,3.31567}, {790,2.97033}, {795,3.05600}, {800,3.30625}, {805,3.09733}, {810,3.11367}, {815,3.55033}, {820,3.19833}, {825,3.25033}, {830,3.24367}, {835,3.78267}, {840,3.39267}, {845,3.42867}, {850,3.50600}, {855,3.57400}, {860,3.67333}, {865,4.14833}, {870,3.64333}, {875,4.27433}, {880,3.56667}, {885,3.62167}, {890,3.75700}, {895,3.78300}, {900,4.04175}, {905,4.31800}, {910,3.95800}, {915,3.95600}, {920,3.94967}, {925,3.94600}, {930,4.54733}, {935,4.04367}, {940,4.08900}, {945,4.16733}, {950,4.35433}, {955,4.38467}, {960,5.25433}, {965,4.48333}, {970,4.55433}, {975,4.61000}, {980,4.65967}, {985,5.65400}, {990,4.73833}, {995,4.75533}, {1000,4.84650}, {1010,4.92100}, {1020,5.04700}, {1030,5.21867}, {1040,5.30433}, {1050,5.44767}, {1060,5.53200}, {1070,6.52567}, {1080,5.63933}, {1090,6.73033}, {1100,5.92167}, {1110,6.16500}, {1120,6.14833}, {1130,6.21167}, {1140,6.28200}, {1150,7.57100}, {1160,6.57600}, {1170,7.82733}, {1180,6.91067}, {1190,7.01667}, {1200,7.13833}, {1210,7.25933}, {1220,7.41333}, {1230,7.46667}, {1240,7.71800}, {1250,7.77167}, {1260,7.99133}, {1270,8.07133}, {1280,8.21133}, {1290,9.63133}, {1300,9.72000}, {1310,10.03633}, {1320,8.66067}, {1330,10.26900}, {1340,10.52367}, {1350,10.63667}, {1360,10.68900}, {1370,9.60233}, {1380,9.63333}, {1390,9.80167}, {1400,10.33600}, {1410,10.14233}, {1420,12.08333}, {1430,12.02833}, {1440,12.30800}, {1450,12.19000}, {1460,12.20067}, {1470,14.20067}, {1480,11.20900}, {1490,11.65667}, {1500,13.86175}, {1510,11.74733}, {1520,11.97967}, {1530,13.54900}, {1540,15.50200}, {1550,14.19833}, {1560,12.65300}, {1570,15.49167}, {1580,12.41167}, {1590,14.13433}, {1600,15.84767}, {1610,14.70867}, {1620,14.59433}, {1630,16.73167}, {1640,16.88233}, {1650,16.81967}, {1660,18.53933}, {1670,19.26367}, {1680,17.37767}, {1690,16.73033}, {1700,16.00500}, {1710,18.41233}, {1720,14.56100}, {1730,16.71200}, {1740,17.30067}, {1750,17.64633}, {1760,16.81400}, {1770,18.99567}, {1780,21.70100}, {1790,18.12067}, {1800,18.42367}, {1810,17.77967}, {1820,18.79067}, {1830,20.46833}, {1840,20.93967}, {1850,23.24233}, {1860,21.76967}, {1870,22.31333}, {1880,23.94367}, {1890,20.32467}, {1900,21.92600}, {1910,23.67733}, {1920,21.82567}, {1930,24.81433}, {1940,18.60133}, {1950,22.22200}, {1960,22.69800}, {1970,23.12100}, {1980,25.20200}, {1990,20.98467}, {2000,25.86175}, {2050,28.98600}, {2100,27.13267}, {2150,28.01333}, {2200,28.35300}, {2250,32.26233}, {2300,33.50500}, {2350,35.02933}, {2400,36.69500}, {2450,43.04467}, {2500,39.03950}, {2550,43.93000}, {2600,42.65967}, {2650,45.38333}, {2700,45.09100}, {2750,51.99667}, {2800,52.56100}, {2850,56.81267}, {2900,58.92667}, {2950,61.86633}, {3000,63.34550}, {3050,66.13400}, {3100,68.65000}, {3150,65.34267}, {3200,65.41233}, {3250,68.71300}, {3300,66.93667}, {3350,72.99567}, {3400,75.96867}, {3450,73.90867}, {3500,81.63650}, {3550,89.64267}, {3600,91.34500}, {3650,87.02100}, {3700,91.68633}, {3750,93.62800}, {3800,106.05033}, {3850,99.60467}, {3900,102.2180}, {3950,99.5255}, {4000,110.51567}, {4050,110.4440}, {4100,111.3010}, {4150,134.048}, {4500,139.88}};
data["big"]["parsing"]["Stats"]["system"] = {{1,0.00018103}, {2,0.00041379}, {3,0.00031897}, {4,0.00009483}, {5,0.00012069}, {6,0.00009483}, {7,0.00016379}, {8,0.00012069}, {9,0.00010345}, {10,0.00008621}, {11,0.00006897}, {12,0.00021552}, {13,0.00048276}, {14,0.00023276}, {15,0.00035345}, {16,0.00018966}, {17,0.00034483}, {18,0.00020690}, {19,0.00038793}, {20,0.00044828}, {21,0.00035345}, {22,0.00027586}, {23,0.00037069}, {24,0.00041379}, {25,0.00077586}, {26,0.00055172}, {27,0.00047414}, {28,0.00069828}, {29,0.00083621}, {30,0.00223276}, {31,0.00010345}, {32,0.00016379}, {33,0.00002586}, {34,0.00000000}, {35,0.00002586}, {36,0.00003448}, {37,0.00000000}, {38,0.00003448}, {39,0.00012069}, {40,0.00000000}, {41,0.00003448}, {42,0.00003448}, {43,0.00006034}, {44,0.00003448}, {45,0.00002586}, {46,0.00000000}, {47,0.00020690}, {48,0.00002586}, {49,0.00012931}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00003448}, {55,0.00003448}, {56,0.00000000}, {57,0.00025000}, {58,0.00008621}, {59,0.00003448}, {60,0.00006034}, {61,0.00003448}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00026724}, {66,0.00006897}, {67,0.00000000}, {68,0.00000000}, {69,0.00002586}, {70,0.00003448}, {71,0.00006034}, {72,0.00006897}, {73,0.00012931}, {74,0.00003448}, {75,0.00006034}, {76,0.00003448}, {77,0.00021552}, {78,0.00010345}, {79,0.00010345}, {80,0.00008621}, {81,0.00013793}, {82,0.00022414}, {83,0.00002586}, {84,0.00005172}, {85,0.00006034}, {86,0.00000000}, {87,0.00020690}, {88,0.00010345}, {89,0.00006034}, {90,0.00002586}, {91,0.00012931}, {92,0.00000000}, {93,0.00006897}, {94,0.00013793}, {95,0.00027586}, {96,0.00010345}, {97,0.00006034}, {98,0.00043103}, {99,0.00012931}, {100,0.00003448}, {101,0.00021552}, {102,0.00009483}, {103,0.00002586}, {104,0.00013793}, {105,0.00006034}, {106,0.00000000}, {107,0.00002586}, {108,0.00026724}, {109,0.00008621}, {110,0.00013793}, {111,0.00006897}, {112,0.00006897}, {113,0.00050862}, {114,0.00006897}, {115,0.00013793}, {116,0.00033621}, {117,0.00018103}, {118,0.00056897}, {119,0.00000000}, {120,0.00009483}, {121,0.00012069}, {122,0.00012069}, {123,0.00023276}, {124,0.00012069}, {125,0.00027586}, {126,0.00017241}, {127,0.00033621}, {128,0.00000000}, {129,0.00037069}, {130,0.00006897}, {131,0.00062069}, {132,0.00024138}, {133,0.00056897}, {134,0.00018966}, {135,0.00036207}, {136,0.00006897}, {137,0.00050862}, {138,0.00009483}, {139,0.00044828}, {140,0.00008621}, {141,0.00076724}, {142,0.00055172}, {143,0.00027586}, {144,0.00037931}, {145,0.00006897}, {146,0.00013793}, {147,0.00084483}, {148,0.00033621}, {149,0.00049138}, {150,0.00015517}, {151,0.00012931}, {152,0.00077586}, {153,0.00016379}, {154,0.00032759}, {155,0.00097414}, {156,0.00018966}, {157,0.00042241}, {158,0.00060345}, {159,0.00078448}, {160,0.00031034}, {161,0.00028448}, {162,0.00073276}, {163,0.00069828}, {164,0.00024138}, {165,0.00058621}, {166,0.00006897}, {167,0.00012931}, {168,0.00009483}, {169,0.00006034}, {170,0.00003448}, {171,0.00006897}, {172,0.00009483}, {173,0.00016379}, {174,0.00012069}, {175,0.00023276}, {176,0.00003448}, {177,0.00006034}, {178,0.00008621}, {179,0.00077586}, {180,0.00064655}, {181,0.00100862}, {182,0.00090517}, {183,0.00087931}, {184,0.00068966}, {185,0.00006897}, {186,0.00022414}, {187,0.00003448}, {188,0.00006897}, {189,0.00013793}, {190,0.00016379}, {191,0.00012069}, {192,0.00010345}, {193,0.00010345}, {194,0.00012069}, {195,0.00009483}, {196,0.00009483}, {197,0.00010345}, {198,0.00002586}, {199,0.00016379}, {200,0.00087069}, {201,0.00076724}, {202,0.00061207}, {203,0.00145690}, {204,0.00096552}, {205,0.00100000}, {206,0.00016379}, {207,0.00009483}, {208,0.00012931}, {209,0.00010345}, {210,0.00009483}, {211,0.00006897}, {212,0.00002586}, {213,0.00010345}, {214,0.00003448}, {215,0.00003448}, {216,0.00009483}, {217,0.00010345}, {218,0.00002586}, {219,0.00003448}, {220,0.00003448}, {221,0.00012069}, {222,0.00000000}, {223,0.00002586}, {224,0.00009483}, {225,0.00016379}, {226,0.00010345}, {227,0.00000000}, {228,0.00013793}, {229,0.00006897}, {230,0.00017241}, {231,0.00003448}, {232,0.00003448}, {233,0.00031034}, {234,0.00002586}, {235,0.00006034}, {236,0.00016379}, {237,0.00012931}, {238,0.00013793}, {239,0.00018966}, {240,0.00000000}, {241,0.00063793}, {242,0.00087069}, {243,0.00182759}, {244,0.00209483}, {245,0.00094828}, {246,0.00062931}, {247,0.00012931}, {248,0.00026724}, {249,0.00020690}, {250,0.00027586}, {251,0.00023276}, {252,0.00006034}, {253,0.00020690}, {254,0.00010345}, {255,0.00010345}, {256,0.00017241}, {257,0.00006034}, {258,0.00012931}, {259,0.00006897}, {260,0.00017241}, {261,0.00019828}, {262,0.00019828}, {263,0.00009483}, {264,0.00006897}, {265,0.00017241}, {266,0.00009483}, {267,0.00013793}, {268,0.00010345}, {269,0.00006897}, {270,0.00003448}, {271,0.00010345}, {272,0.00018966}, {273,0.00029310}, {274,0.00145690}, {275,0.00236207}, {276,0.00268103}, {277,0.00210345}, {278,0.00065517}, {279,0.00036207}, {280,0.00043966}, {281,0.00030172}, {282,0.00069828}, {283,0.00135345}, {284,0.00118103}, {285,0.00091379}, {286,0.00050000}, {287,0.00113793}, {288,0.00067241}, {289,0.00103448}, {290,0.00089655}, {291,0.00018966}, {292,0.00023276}, {293,0.00063793}, {294,0.00044828}, {295,0.00052586}, {296,0.00026724}, {297,0.00036207}, {298,0.00006897}, {299,0.00012069}, {300,0.00020690}, {301,0.00020690}, {302,0.00023276}, {303,0.00017241}, {304,0.00020690}, {305,0.00006897}, {306,0.00006034}, {307,0.00017241}, {308,0.00010345}, {309,0.00009483}, {310,0.00023276}, {311,0.00013793}, {312,0.00024138}, {313,0.00022414}, {314,0.00020690}, {315,0.00012931}, {316,0.00020690}, {317,0.00026724}, {318,0.00019828}, {319,0.00006897}, {320,0.00027586}, {321,0.00016379}, {322,0.00024138}, {323,0.00018966}, {324,0.00027586}, {325,0.00017241}, {326,0.00027586}, {327,0.00019828}, {328,0.00010345}, {329,0.00017241}, {330,0.00012931}, {331,0.00012931}, {332,0.00010345}, {333,0.00212931}, {334,0.00406897}, {335,0.00276724}, {336,0.00087069}, {337,0.00026724}, {338,0.00010345}, {339,0.00027586}, {340,0.00032759}, {341,0.00012069}, {342,0.00031034}, {343,0.00009483}, {344,0.00006897}, {345,0.00023276}, {346,0.00017241}, {347,0.00006897}, {348,0.00020690}, {349,0.00017241}, {350,0.00012931}, {351,0.00010345}, {352,0.00017241}, {353,0.00026724}, {354,0.00032759}, {355,0.00014655}, {356,0.00039655}, {357,0.00016379}, {358,0.00020690}, {359,0.00013793}, {360,0.00017241}, {361,0.00013793}, {362,0.00013793}, {363,0.00013793}, {364,0.00033621}, {365,0.00016379}, {366,0.00019828}, {367,0.00003448}, {368,0.00019828}, {369,0.00010345}, {370,0.00023276}, {371,0.00013793}, {372,0.00009483}, {373,0.00012931}, {374,0.00019828}, {375,0.00028448}, {376,0.00020690}, {377,0.00015517}, {378,0.00027586}, {379,0.00026724}, {380,0.00016379}, {381,0.00031897}, {382,0.00024138}, {383,0.00036207}, {384,0.00041379}, {385,0.00030172}, {386,0.00027586}, {387,0.00506034}, {388,0.00624138}, {389,0.00093103}, {390,0.00029310}, {391,0.00030172}, {392,0.00022414}, {393,0.00024138}, {394,0.00020690}, {395,0.00032759}, {396,0.00016379}, {397,0.00031034}, {398,0.00017241}, {399,0.00018103}, {400,0.00034483}, {401,0.00041379}, {402,0.00017241}, {403,0.00050862}, {404,0.00034483}, {405,0.00002586}, {406,0.00020690}, {407,0.00019828}, {408,0.00020690}, {409,0.00012931}, {410,0.00027586}, {411,0.00026724}, {412,0.00030172}, {413,0.00019828}, {414,0.00017241}, {415,0.00031034}, {416,0.00019828}, {417,0.00034483}, {418,0.00026724}, {419,0.00020690}, {420,0.00036207}, {421,0.00027586}, {422,0.00033621}, {423,0.00033621}, {424,0.00056897}, {425,0.00631034}, {426,0.00519828}, {427,0.00041379}, {428,0.00037069}, {429,0.00019828}, {430,0.00020690}, {431,0.00015517}, {432,0.00024138}, {433,0.00018966}, {434,0.00048276}, {435,0.00047414}, {436,0.00019828}, {437,0.00037069}, {438,0.00003448}, {439,0.00026724}, {440,0.00012931}, {441,0.00027586}, {442,0.00012931}, {443,0.00020690}, {444,0.00024138}, {445,0.00022414}, {446,0.00017241}, {447,0.00026724}, {448,0.00020690}, {449,0.00026724}, {450,0.00034483}, {451,0.00010345}, {452,0.00017241}, {453,0.00039655}, {454,0.00030172}, {455,0.00036207}, {456,0.00031034}, {457,0.00030172}, {458,0.00041379}, {459,0.00030172}, {460,0.00017241}, {461,0.00020690}, {462,0.00020690}, {463,0.00030172}, {464,0.00017241}, {465,0.00031034}, {466,0.00030172}, {467,0.00124138}, {468,0.00360345}, {469,0.00136207}, {470,0.00042241}, {471,0.00337931}, {472,0.00596552}, {473,0.00074138}, {474,0.00042241}, {475,0.00019828}, {476,0.00034483}, {477,0.00062931}, {478,0.00034483}, {479,0.00024138}, {480,0.00037931}, {481,0.00037069}, {482,0.00037931}, {483,0.00023276}, {484,0.00006897}, {485,0.00031034}, {486,0.00020690}, {487,0.00019828}, {488,0.00048276}, {489,0.00034483}, {490,0.00030172}, {491,0.00019828}, {492,0.00006897}, {493,0.00032759}, {494,0.00031034}, {495,0.00197414}, {496,0.00225000}, {497,0.00034483}, {498,0.00031897}, {499,0.00020690}, {500,0.00023276}, {505,0.02367}, {510,0.01433}, {515,0.00000}, {520,0.00133}, {525,0.00133}, {530,0.00233}, {535,0.00667}, {540,0.00133}, {545,0.00000}, {550,0.00000}, {555,0.00000}, {560,0.00100}, {565,0.00267}, {570,0.00133}, {575,0.00000}, {580,0.00000}, {585,0.00000}, {590,0.00000}, {595,0.00000}, {600,0.00000}, {605,0.00133}, {610,0.00000}, {615,0.00000}, {620,0.01600}, {625,0.00400}, {630,0.00233}, {635,0.00000}, {640,0.00500}, {645,0.00667}, {650,0.00000}, {655,0.00000}, {660,0.01533}, {665,0.00000}, {670,0.00667}, {675,0.01400}, {680,0.00400}, {685,0.00800}, {690,0.01300}, {695,0.00367}, {700,0.00100}, {705,0.00133}, {710,0.01200}, {715,0.00133}, {720,0.00900}, {725,0.00533}, {730,0.00667}, {735,0.01433}, {740,0.00533}, {745,0.00767}, {750,0.00500}, {755,0.00533}, {760,0.01733}, {765,0.00133}, {770,0.00367}, {775,0.00667}, {780,0.01300}, {785,0.00400}, {790,0.01067}, {795,0.00367}, {800,0.00500}, {805,0.00900}, {810,0.00400}, {815,0.00400}, {820,0.00133}, {825,0.00133}, {830,0.00133}, {835,0.00000}, {840,0.00533}, {845,0.00267}, {850,0.00133}, {855,0.00800}, {860,0.00100}, {865,0.00400}, {870,0.01967}, {875,0.00400}, {880,0.00000}, {885,0.00000}, {890,0.01467}, {895,0.00533}, {900,0.00200}, {905,0.01167}, {910,0.01167}, {915,0.00000}, {920,0.00667}, {925,0.00133}, {930,0.00000}, {935,0.00900}, {940,0.00267}, {945,0.00267}, {950,0.00133}, {955,0.00400}, {960,0.00667}, {965,0.00000}, {970,0.00000}, {975,0.00133}, {980,0.00133}, {985,0.00400}, {990,0.00000}, {995,0.00000}, {1000,0.00200}, {1010,0.00000}, {1020,0.00000}, {1030,0.00000}, {1040,0.00800}, {1050,0.00000}, {1060,0.00000}, {1070,0.00667}, {1080,0.00000}, {1090,0.00000}, {1100,0.00133}, {1110,0.00000}, {1120,0.01600}, {1130,0.00133}, {1140,0.00000}, {1150,0.00000}, {1160,0.01067}, {1170,0.00000}, {1180,0.00267}, {1190,0.00400}, {1200,0.00133}, {1210,0.00133}, {1220,0.00133}, {1230,0.00000}, {1240,0.00133}, {1250,0.00367}, {1260,0.01200}, {1270,0.01067}, {1280,0.01033}, {1290,0.00000}, {1300,0.00133}, {1310,0.00133}, {1320,0.00933}, {1330,0.00000}, {1340,0.00400}, {1350,0.01067}, {1360,0.00000}, {1370,0.00000}, {1380,0.00533}, {1390,0.00133}, {1400,0.00133}, {1410,0.03167}, {1420,0.00000}, {1430,0.00400}, {1440,0.00267}, {1450,0.01200}, {1460,0.00400}, {1470,0.01833}, {1480,0.00267}, {1490,0.00633}, {1500,0.05100}, {1510,0.01967}, {1520,0.01467}, {1530,0.00133}, {1540,0.00133}, {1550,0.00133}, {1560,0.01600}, {1570,0.02933}, {1580,0.01600}, {1590,0.02100}, {1600,0.01333}, {1610,0.01600}, {1620,0.01567}, {1630,0.01433}, {1640,0.00133}, {1650,0.00000}, {1660,0.00000}, {1670,0.00267}, {1680,0.00000}, {1690,0.02400}, {1700,0.04633}, {1710,0.02400}, {1720,0.03733}, {1730,0.01700}, {1740,0.00533}, {1750,0.00267}, {1760,0.00100}, {1770,0.02000}, {1780,0.00000}, {1790,0.02533}, {1800,0.00667}, {1810,0.00400}, {1820,0.04000}, {1830,0.00667}, {1840,0.00633}, {1850,0.00133}, {1860,0.03600}, {1870,0.01833}, {1880,0.01600}, {1890,0.04000}, {1900,0.00133}, {1910,0.00133}, {1920,0.02800}, {1930,0.00533}, {1940,0.05167}, {1950,0.03467}, {1960,0.05567}, {1970,0.07700}, {1980,0.05733}, {1990,0.02133}, {2000,0.06100}, {2050,0.05300}, {2100,0.00267}, {2150,0.05300}, {2200,0.05833}, {2250,0.07733}, {2300,0.00267}, {2350,0.09067}, {2400,0.03833}, {2450,0.11167}, {2500,0.05600}, {2550,0.00533}, {2600,0.07433}, {2650,0.01200}, {2700,0.10400}, {2750,0.13300}, {2800,0.03467}, {2850,0.07300}, {2900,0.02400}, {2950,0.07067}, {3000,0.10400}, {3050,0.04000}, {3100,0.06767}, {3150,0.00533}, {3200,0.04400}, {3250,0.08100}, {3300,0.03533}, {3350,0.11600}, {3400,0.06800}, {3450,0.06933}, {3500,0.17175}, {3550,0.16900}, {3600,0.04267}, {3650,0.00267}, {3700,0.13800}, {3750,0.14267}, {3800,0.16467}, {3850,0.04267}, {3900,0.1435}, {3950,0.1875}, {4000,0.28733}, {4050,0.1095}, {4100,0.2115}, {4150,0.243}, {4500,0.344}};
data["big"]["parsing elaborated"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000870}, {6,0.00004348}, {7,0.00078261}, {8,0.00081739}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00197391}, {16,0.00131304}, {17,0.00152174}, {18,0.00184348}, {19,0.00200000}, {20,0.00200000}, {21,0.00200000}, {22,0.00298261}, {23,0.00200000}, {24,0.00200000}, {25,0.00200000}, {26,0.00206087}, {27,0.00233913}, {28,0.00296522}, {29,0.00298261}, {30,0.00300000}, {31,0.00300000}, {32,0.00408696}, {33,0.00300000}, {34,0.00300000}, {35,0.00300000}, {36,0.00306087}, {37,0.00336522}, {38,0.00371304}, {39,0.00398261}, {40,0.05750435}, {41,0.00387826}, {42,0.00396522}, {43,0.00398261}, {44,0.00400000}, {45,0.00400000}, {46,0.00400000}, {47,0.00697391}, {48,0.00401739}, {49,0.00400000}, {50,0.00408696}, {51,0.00434783}, {52,0.00463478}, {53,0.00494783}, {54,0.00500000}, {55,0.00500000}, {56,0.00501739}, {57,0.00505217}, {58,0.00506087}, {59,0.00513913}, {60,0.00541739}, {61,0.00573043}, {62,0.00592174}, {63,0.00600000}, {64,0.00600000}, {65,0.00600000}, {66,0.00600870}, {67,0.01191304}, {68,0.00611304}, {69,0.00652174}, {70,0.07798261}, {71,0.00699130}, {72,0.00698261}, {73,0.00700000}, {74,0.00712174}, {75,0.00700870}, {76,0.00706087}, {77,0.00725217}, {78,0.00776522}, {79,0.00780000}, {80,0.00775652}, {81,0.00798261}, {82,0.00809565}, {83,0.00800000}, {84,0.00800870}, {85,0.00802609}, {86,0.00813913}, {87,0.00853043}, {88,0.00883478}, {89,0.00887826}, {90,0.00890435}, {91,0.00894783}, {92,0.06572174}, {93,0.00911304}, {94,0.00900870}, {95,0.00906957}, {96,0.02132174}, {97,0.00907826}, {98,0.00916522}, {99,0.00946957}, {100,0.00983478}, {101,0.00991304}, {102,0.00993913}, {103,0.00998261}, {104,0.01000000}, {105,0.01000870}, {106,0.01002609}, {107,0.01020870}, {108,0.01067826}, {109,0.06221739}, {110,0.01100000}, {111,0.01100870}, {112,0.01100870}, {113,0.01114783}, {114,0.01130435}, {115,0.01153913}, {116,0.01166087}, {117,0.01167826}, {118,0.01168696}, {119,0.01197391}, {120,0.01200000}, {121,0.01200870}, {122,0.01206087}, {123,0.01203478}, {124,0.05059130}, {125,0.01278261}, {126,0.01293043}, {127,0.01296522}, {128,0.01294783}, {129,0.01297391}, {130,0.01317391}, {131,0.01302609}, {132,0.01312174}, {133,0.01328696}, {134,0.01367826}, {135,0.01389565}, {136,0.01388696}, {137,0.09320870}, {138,0.01375652}, {139,0.01372174}, {140,0.01388696}, {141,0.01393043}, {142,0.01400000}, {143,0.01413913}, {144,0.01406087}, {145,0.01404348}, {146,0.01431304}, {147,0.01414783}, {148,0.01435652}, {149,0.05273913}, {150,0.01493043}, {151,0.01492174}, {152,0.01497391}, {153,0.01509565}, {154,0.01506087}, {155,0.01514783}, {156,0.01532174}, {157,0.01544348}, {158,0.01559130}, {159,0.01540000}, {160,0.05324348}, {161,0.01600000}, {162,0.01604348}, {163,0.01615652}, {164,0.01602609}, {165,0.01612174}, {166,0.01634783}, {167,0.01666957}, {168,0.01689565}, {169,0.01693913}, {170,0.01696522}, {171,0.05917391}, {172,0.01714783}, {173,0.01703478}, {174,0.01706957}, {175,0.01708696}, {176,0.01733043}, {177,0.01772174}, {178,0.01791304}, {179,0.01794783}, {180,0.01798261}, {181,0.05982609}, {182,0.01806957}, {183,0.01813043}, {184,0.01812174}, {185,0.01815652}, {186,0.01839130}, {187,0.01888696}, {188,0.01893913}, {189,0.01901739}, {190,0.06019130}, {191,0.01903478}, {192,0.01913913}, {193,0.01916522}, {194,0.01910435}, {195,0.07034783}, {196,0.01996522}, {197,0.01989565}, {198,0.02000870}, {199,0.07963478}, {200,0.02003478}, {201,0.02013043}, {202,0.02042609}, {203,0.02074783}, {204,0.02085217}, {205,0.02080870}, {206,0.02073043}, {207,0.09565217}, {208,0.02176522}, {209,0.02194783}, {210,0.02206957}, {211,0.02205217}, {212,0.02210435}, {213,0.02208696}, {214,0.02219130}, {215,0.02259130}, {216,0.08388696}, {217,0.02292174}, {218,0.02293913}, {219,0.02300000}, {220,0.02300870}, {221,0.02310435}, {222,0.02315652}, {223,0.02350435}, {224,0.07128696}, {225,0.02386957}, {226,0.02388696}, {227,0.02384348}, {228,0.02393913}, {229,0.02401739}, {230,0.02462609}, {231,0.02423478}, {232,0.06054783}, {233,0.02482609}, {234,0.02493043}, {235,0.02510435}, {236,0.02489565}, {237,0.02506087}, {238,0.02622609}, {239,0.06938261}, {240,0.02550435}, {241,0.02558261}, {242,0.02592174}, {243,0.02585217}, {244,0.02598261}, {245,0.02601739}, {246,0.07409565}, {247,0.02633043}, {248,0.02629565}, {249,0.02661739}, {250,0.02673043}, {251,0.02660000}, {252,0.02673043}, {253,0.10032174}, {254,0.02720870}, {255,0.02736522}, {256,0.02726087}, {257,0.02711304}, {258,0.02722609}, {259,0.02772174}, {260,0.07811304}, {261,0.02779130}, {262,0.02790435}, {263,0.02800000}, {264,0.02799130}, {265,0.02814783}, {266,0.02815652}, {267,0.07135652}, {268,0.02880000}, {269,0.02885217}, {270,0.02888696}, {271,0.02893043}, {272,0.02900000}, {273,0.02912174}, {274,0.06224348}, {275,0.02830435}, {276,0.12993043}, {277,0.02891304}, {278,0.02893043}, {279,0.12380000}, {280,0.02906957}, {281,0.02905217}, {282,0.02911304}, {283,0.02918261}, {284,0.02945217}, {285,0.06961739}, {286,0.02984348}, {287,0.02998261}, {288,0.03004348}, {289,0.03003478}, {290,0.03009565}, {291,0.03026087}, {292,0.06969565}, {293,0.03064348}, {294,0.03080870}, {295,0.03087826}, {296,0.03095652}, {297,0.03106957}, {298,0.07166087}, {299,0.03115652}, {300,0.03123478}, {301,0.03142609}, {302,0.03162609}, {303,0.07556522}, {304,0.03194783}, {305,0.03196522}, {306,0.03203478}, {307,0.03210435}, {308,0.03235652}, {309,0.09420870}, {310,0.03246957}, {311,0.03279130}, {312,0.03286957}, {313,0.03300870}, {314,0.03302609}, {315,0.07620870}, {316,0.03319130}, {317,0.03340000}, {318,0.03355652}, {319,0.03382609}, {320,0.03375652}, {321,0.06021739}, {322,0.03397391}, {323,0.03401739}, {324,0.03407826}, {325,0.03421739}, {326,0.12957391}, {327,0.03580870}, {328,0.03592174}, {329,0.03606087}, {330,0.03606087}, {331,0.09406957}, {332,0.03650435}, {333,0.03661739}, {334,0.03664348}, {335,0.03673913}, {336,0.03691304}, {337,0.08888696}, {338,0.04012174}, {339,0.03724348}, {340,0.03735652}, {341,0.03755652}, {342,0.07744348}, {343,0.03785217}, {344,0.03797391}, {345,0.03802609}, {346,0.03815652}, {347,0.08401739}, {348,0.03836522}, {349,0.03865217}, {350,0.03934783}, {351,0.03883478}, {352,0.09401739}, {353,0.03916522}, {354,0.03925217}, {355,0.03931304}, {356,0.03946087}, {357,0.11413913}, {358,0.03972174}, {359,0.03973043}, {360,0.04002609}, {361,0.04013913}, {362,0.12025217}, {363,0.04021739}, {364,0.04058261}, {365,0.04049565}, {366,0.04074783}, {367,0.11944348}, {368,0.04114783}, {369,0.04126957}, {370,0.04128696}, {371,0.04118261}, {372,0.10452174}, {373,0.04137391}, {374,0.04153043}, {375,0.04180000}, {376,0.04202609}, {377,0.07629565}, {378,0.04218261}, {379,0.04230435}, {380,0.04235652}, {381,0.08732174}, {382,0.04266957}, {383,0.04286087}, {384,0.04300000}, {385,0.04299130}, {386,0.08564348}, {387,0.04338261}, {388,0.04353043}, {389,0.04352174}, {390,0.09686957}, {391,0.04373913}, {392,0.24049565}, {393,0.04288696}, {394,0.13680870}, {395,0.04281739}, {396,0.04289565}, {397,0.04300870}, {398,0.08079130}, {399,0.04336522}, {400,0.04343478}, {401,0.04354783}, {402,0.04380000}, {403,0.09373043}, {404,0.04384348}, {405,0.04398261}, {406,0.04400870}, {407,0.08357391}, {408,0.04426087}, {409,0.04446957}, {410,0.04465217}, {411,0.08453043}, {412,0.04488696}, {413,0.04495652}, {414,0.04510435}, {415,0.04510435}, {416,0.08679130}, {417,0.04556522}, {418,0.04553043}, {419,0.04568696}, {420,0.08420870}, {421,0.04600870}, {422,0.04612174}, {423,0.04618261}, {424,0.08418261}, {425,0.04645217}, {426,0.04680000}, {427,0.04679130}, {428,0.08763478}, {429,0.04699130}, {430,0.04706957}, {431,0.04722609}, {432,0.08836522}, {433,0.04768696}, {434,0.04769565}, {435,0.04785217}, {436,0.04793913}, {437,0.08656522}, {438,0.04811304}, {439,0.04819130}, {440,0.04828696}, {441,0.08716522}, {442,0.04873043}, {443,0.04885217}, {444,0.04894783}, {445,0.08641739}, {446,0.04905217}, {447,0.04919130}, {448,0.04940000}, {449,0.08880870}, {450,0.04966087}, {451,0.04978261}, {452,0.04994783}, {453,0.09040000}, {454,0.05015652}, {455,0.05023478}, {456,0.09540000}, {457,0.05046957}, {458,0.05075652}, {459,0.05080000}, {460,0.11756522}, {461,0.05102609}, {462,0.05114783}, {463,0.05125217}, {464,0.15617391}, {465,0.05319130}, {466,0.05335652}, {467,0.05360000}, {468,0.11586957}, {469,0.05385217}, {470,0.05406087}, {471,0.05407826}, {472,0.10232174}, {473,0.05433913}, {474,0.05451304}, {475,0.05462609}, {476,0.08709565}, {477,0.05495652}, {478,0.05497391}, {479,0.09901739}, {480,0.05520000}, {481,0.05547826}, {482,0.05560870}, {483,0.10692174}, {484,0.05580000}, {485,0.05593913}, {486,0.05600000}, {487,0.12169565}, {488,0.05641739}, {489,0.05667826}, {490,0.13707826}, {491,0.05685217}, {492,0.05693043}, {493,0.05703478}, {494,0.14198261}, {495,0.05723478}, {496,0.05756522}, {497,0.13182609}, {498,0.05781739}, {499,0.05798261}, {500,0.103528384}, {505,0.05889474}, {510,0.05950000}, {515,0.06007895}, {520,0.12678070}, {525,0.06152632}, {530,0.06221053}, {535,0.17248246}, {540,0.06369298}, {545,0.06445614}, {550,0.14132456}, {555,0.06589474}, {560,0.06658772}, {565,0.11584211}, {570,0.06799123}, {575,0.06871930}, {580,0.11538596}, {585,0.07014912}, {590,0.07084211}, {595,0.11857018}, {600,0.07226087}, {605,0.07300877}, {610,0.12071053}, {615,0.07468421}, {620,0.07535965}, {625,0.12393860}, {630,0.07689474}, {635,0.07759649}, {640,0.12514035}, {645,0.07913158}, {650,0.07995614}, {655,0.12137719}, {660,0.08155263}, {665,0.12123684}, {670,0.08313158}, {675,0.08392982}, {680,0.13475439}, {685,0.08539474}, {690,0.08612281}, {695,0.12594737}, {700,0.08513043}, {705,0.12587719}, {710,0.08663158}, {715,0.08742105}, {720,0.14843860}, {725,0.08901754}, {730,0.63685965}, {735,0.25885965}, {740,0.09173684}, {745,0.09258772}, {750,0.13750877}, {755,0.09412281}, {760,0.13366667}, {765,0.09582456}, {770,0.13929825}, {775,0.09747368}, {780,0.09816667}, {785,0.14649123}, {790,0.09994737}, {795,0.14467544}, {800,0.10154783}, {805,0.14591228}, {810,0.10322807}, {815,0.14406140}, {820,0.10494737}, {825,0.10573684}, {830,0.19558772}, {835,0.11049123}, {840,0.21104386}, {845,0.11213158}, {850,0.16114912}, {855,0.11405263}, {860,0.15431579}, {865,0.11580702}, {870,0.15660526}, {875,0.11788596}, {880,0.17031579}, {885,0.11959649}, {890,0.16334211}, {895,0.12142105}, {900,0.16434783}, {905,0.12340351}, {910,0.16663158}, {915,0.12528070}, {920,0.16809649}, {925,0.12740351}, {930,0.16608772}, {935,0.12904386}, {940,0.16287719}, {945,0.13178070}, {950,0.16789474}, {955,0.18628947}, {960,0.13558772}, {965,0.18960526}, {970,0.13715789}, {975,0.19213158}, {980,0.13942982}, {985,0.18803509}, {990,0.14387719}, {995,0.17930702}, {1000,0.18301739}, {1010,0.20450}, {1020,0.14425}, {1030,0.22925}, {1040,0.14725}, {1050,0.22925}, {1060,0.15325}, {1070,0.17675}, {1080,0.20625}, {1090,0.15925}, {1100,0.23450}, {1110,0.19425}, {1120,0.16300}, {1130,0.21450}, {1140,0.16675}, {1150,0.19450}, {1160,0.22875}, {1170,0.17350}, {1180,0.25600}, {1190,0.23875}, {1200,0.18025}, {1210,0.20975}, {1220,0.26125}, {1230,0.23275}, {1240,0.19425}, {1250,0.25075}, {1260,0.24025}, {1270,0.20100}, {1280,0.25600}, {1290,0.25975}, {1300,0.27125}, {1310,0.21125}, {1320,0.26525}, {1330,0.24125}, {1340,0.41000}, {1350,0.21625}, {1360,0.25700}, {1370,0.26975}, {1380,0.27000}, {1390,0.22800}, {1400,0.27300}, {1410,0.27600}, {1420,0.31800}, {1430,0.30300}, {1440,0.24400}, {1450,0.28675}, {1460,0.29850}, {1470,0.29475}, {1480,0.32450}, {1490,0.34825}, {1500,0.27540}, {1510,0.33800}, {1520,0.35300}, {1530,0.31000}, {1540,0.31500}, {1550,0.32325}, {1560,0.34450}, {1570,0.27950}, {1580,0.29925}, {1590,0.31250}, {1600,0.56900}, {1610,0.39225}, {1620,0.32975}, {1630,0.33050}, {1640,0.33375}, {1650,0.33875}, {1660,0.34725}, {1670,0.33625}, {1680,0.40350}, {1690,0.38250}, {1700,0.37425}, {1710,0.37325}, {1720,0.38400}, {1730,0.43050}, {1740,0.45425}, {1750,0.44100}, {1760,0.44300}, {1770,0.43950}, {1780,0.40225}, {1790,0.40525}, {1800,0.40900}, {1810,0.41400}, {1820,0.43325}, {1830,0.41900}, {1840,0.39825}, {1850,0.41325}, {1860,0.41425}, {1870,0.41650}, {1880,0.41800}, {1890,0.42200}, {1900,0.42175}, {1910,0.41825}, {1920,0.42050}, {1930,0.42275}, {1940,0.41350}, {1950,0.41025}, {1960,0.47200}, {1970,0.45525}, {1980,0.45700}, {1990,0.46100}, {2000,0.47740}, {2050,0.48100}, {2100,0.54125}, {2150,1.73475}, {2200,0.59725}, {2250,0.58925}, {2300,0.60225}, {2350,0.60575}, {2400,0.64250}, {2450,0.66225}, {2500,0.67780}, {2550,0.70850}, {2600,0.72175}, {2650,0.74775}, {2700,0.78225}, {2750,0.78425}, {2800,0.78200}, {2850,0.82250}, {2900,0.86625}, {2950,0.87175}, {3000,0.89640}, {3050,0.93175}, {3100,0.91850}, {3150,0.96125}, {3200,0.97500}, {3250,0.98750}, {3300,1.03850}, {3350,1.12825}, {3400,1.13000}, {3450,1.17675}, {3500,1.21040}, {3550,1.29400}, {3600,1.33025}, {3650,1.34500}, {3700,1.41125}, {3750,1.45450}, {3800,1.42750}, {3850,1.39250}, {3900,1.40075}, {3950,1.42100}, {4000,1.46800}, {4050,1.51825}, {4100,1.50325}, {4150,1.54825}, {4200,1.58625}, {4250,1.56675}, {4300,1.65725}, {4350,1.62325}, {4400,1.68975}, {4450,1.69050}, {4500,3.11880}, {4550,1.83225}, {4600,1.91650}, {4650,2.01000}, {4700,1.96525}, {4750,2.07150}, {4800,2.22050}, {4850,2.16375}, {4900,2.06050}, {4950,2.09825}, {5000,2.13020}, {5050,2.3340}, {5100,2.3470}, {5150,2.3755}};
data["big"]["parsing elaborated"]["Stats"]["user"] = {{1,0.00011304}, {2,0.00024348}, {3,0.00023478}, {4,0.00060000}, {5,0.00073913}, {6,0.00095652}, {7,0.00090435}, {8,0.00092174}, {9,0.00110435}, {10,0.00125217}, {11,0.00119130}, {12,0.00174783}, {13,0.00133913}, {14,0.00164348}, {15,0.00173913}, {16,0.00177391}, {17,0.00188696}, {18,0.00186087}, {19,0.00190435}, {20,0.00208696}, {21,0.00225217}, {22,0.00306957}, {23,0.00228696}, {24,0.00260000}, {25,0.00226087}, {26,0.00246087}, {27,0.00273043}, {28,0.00271304}, {29,0.00266087}, {30,0.00272174}, {31,0.00295652}, {32,0.00439130}, {33,0.00347826}, {34,0.00320870}, {35,0.00345217}, {36,0.00343478}, {37,0.00348696}, {38,0.00364348}, {39,0.00363478}, {40,0.05470435}, {41,0.00412174}, {42,0.00417391}, {43,0.00399130}, {44,0.00424348}, {45,0.00402609}, {46,0.00440000}, {47,0.00710435}, {48,0.00458261}, {49,0.00447826}, {50,0.00447826}, {51,0.00495652}, {52,0.00493913}, {53,0.00506957}, {54,0.00545217}, {55,0.00542609}, {56,0.00562609}, {57,0.00579130}, {58,0.00587826}, {59,0.00575652}, {60,0.00583478}, {61,0.00588696}, {62,0.00593913}, {63,0.00607826}, {64,0.00581739}, {65,0.00613043}, {66,0.00635652}, {67,0.01212174}, {68,0.00692174}, {69,0.00684348}, {70,0.07733913}, {71,0.00713043}, {72,0.00707826}, {73,0.00722609}, {74,0.00744348}, {75,0.00757391}, {76,0.00778261}, {77,0.00785217}, {78,0.00793043}, {79,0.00803478}, {80,0.00802609}, {81,0.00795652}, {82,0.00825217}, {83,0.00853913}, {84,0.00843478}, {85,0.00833913}, {86,0.00876522}, {87,0.00869565}, {88,0.00884348}, {89,0.00937391}, {90,0.00886957}, {91,0.00920870}, {92,0.06488696}, {93,0.00943478}, {94,0.00962609}, {95,0.00942609}, {96,0.02181739}, {97,0.00933913}, {98,0.00997391}, {99,0.00973913}, {100,0.01019130}, {101,0.01019130}, {102,0.01008696}, {103,0.01022609}, {104,0.01074783}, {105,0.01043478}, {106,0.01041739}, {107,0.01070435}, {108,0.01115652}, {109,0.06082609}, {110,0.01132174}, {111,0.01144348}, {112,0.01163478}, {113,0.01182609}, {114,0.01175652}, {115,0.01175652}, {116,0.01179130}, {117,0.01193043}, {118,0.01192174}, {119,0.01209565}, {120,0.01241739}, {121,0.01226087}, {122,0.01254783}, {123,0.01231304}, {124,0.05033913}, {125,0.01293043}, {126,0.01313913}, {127,0.01327826}, {128,0.01348696}, {129,0.01339130}, {130,0.01360000}, {131,0.01324348}, {132,0.01384348}, {133,0.01370435}, {134,0.01405217}, {135,0.01401739}, {136,0.01384348}, {137,0.09227826}, {138,0.01353913}, {139,0.01367826}, {140,0.01399130}, {141,0.01417391}, {142,0.01411304}, {143,0.01483478}, {144,0.01459130}, {145,0.01475652}, {146,0.01444348}, {147,0.01436522}, {148,0.01470435}, {149,0.05213043}, {150,0.01507826}, {151,0.01498261}, {152,0.01529565}, {153,0.01550435}, {154,0.01547826}, {155,0.01589565}, {156,0.01589565}, {157,0.01582609}, {158,0.01582609}, {159,0.01586087}, {160,0.05313913}, {161,0.01620870}, {162,0.01620870}, {163,0.01655652}, {164,0.01638261}, {165,0.01674783}, {166,0.01676522}, {167,0.01708696}, {168,0.01679130}, {169,0.01662609}, {170,0.01721739}, {171,0.05787826}, {172,0.01757391}, {173,0.01731304}, {174,0.01758261}, {175,0.01753043}, {176,0.01793043}, {177,0.01791304}, {178,0.01790435}, {179,0.01840000}, {180,0.01825217}, {181,0.05965217}, {182,0.01835652}, {183,0.01860870}, {184,0.01849565}, {185,0.01858261}, {186,0.01888696}, {187,0.01928696}, {188,0.01891304}, {189,0.01876522}, {190,0.05973913}, {191,0.01901739}, {192,0.01922609}, {193,0.01956522}, {194,0.01966087}, {195,0.07020000}, {196,0.02004348}, {197,0.02000000}, {198,0.02033913}, {199,0.07797391}, {200,0.02000000}, {201,0.02033913}, {202,0.02058261}, {203,0.02086087}, {204,0.02091304}, {205,0.02093913}, {206,0.02087826}, {207,0.09441739}, {208,0.02193913}, {209,0.02211304}, {210,0.02207826}, {211,0.02269565}, {212,0.02246957}, {213,0.02246957}, {214,0.02284348}, {215,0.02263478}, {216,0.08340870}, {217,0.02316522}, {218,0.02319130}, {219,0.02344348}, {220,0.02309565}, {221,0.02323478}, {222,0.02360000}, {223,0.02375652}, {224,0.07073043}, {225,0.02386957}, {226,0.02414783}, {227,0.02385217}, {228,0.02433043}, {229,0.02446957}, {230,0.02473913}, {231,0.02437391}, {232,0.05973913}, {233,0.02488696}, {234,0.02494783}, {235,0.02482609}, {236,0.02523478}, {237,0.02500000}, {238,0.02671304}, {239,0.06878261}, {240,0.02521739}, {241,0.02566957}, {242,0.02598261}, {243,0.02577391}, {244,0.02603478}, {245,0.02628696}, {246,0.07306087}, {247,0.02622609}, {248,0.02591304}, {249,0.02622609}, {250,0.02671304}, {251,0.02662609}, {252,0.02695652}, {253,0.09986957}, {254,0.02695652}, {255,0.02721739}, {256,0.02722609}, {257,0.02690435}, {258,0.02721739}, {259,0.02741739}, {260,0.07741739}, {261,0.02740000}, {262,0.02754783}, {263,0.02794783}, {264,0.02773913}, {265,0.02779130}, {266,0.02815652}, {267,0.07064348}, {268,0.02866087}, {269,0.02842609}, {270,0.02881739}, {271,0.02906957}, {272,0.02917391}, {273,0.02888696}, {274,0.06172174}, {275,0.02812174}, {276,0.12941739}, {277,0.02828696}, {278,0.02896522}, {279,0.12146087}, {280,0.02853913}, {281,0.02893913}, {282,0.02898261}, {283,0.02928696}, {284,0.02935652}, {285,0.06876522}, {286,0.02992174}, {287,0.03017391}, {288,0.02996522}, {289,0.03002609}, {290,0.03040000}, {291,0.03057391}, {292,0.06918261}, {293,0.03076522}, {294,0.03070435}, {295,0.03076522}, {296,0.03110435}, {297,0.03109565}, {298,0.07126957}, {299,0.03127826}, {300,0.03145217}, {301,0.03180000}, {302,0.03171304}, {303,0.07539130}, {304,0.03195652}, {305,0.03204348}, {306,0.03208696}, {307,0.03246957}, {308,0.03232174}, {309,0.09389565}, {310,0.03250435}, {311,0.03263478}, {312,0.03316522}, {313,0.03314783}, {314,0.03330435}, {315,0.07589565}, {316,0.03314783}, {317,0.03344348}, {318,0.03336522}, {319,0.03355652}, {320,0.03400870}, {321,0.05964348}, {322,0.03348696}, {323,0.03422609}, {324,0.03386087}, {325,0.03401739}, {326,0.12833913}, {327,0.03544348}, {328,0.03558261}, {329,0.03577391}, {330,0.03574783}, {331,0.09311304}, {332,0.03614783}, {333,0.03633043}, {334,0.03640000}, {335,0.03625217}, {336,0.03651304}, {337,0.08806087}, {338,0.03934783}, {339,0.03693043}, {340,0.03671304}, {341,0.03693043}, {342,0.07651304}, {343,0.03723478}, {344,0.03746957}, {345,0.03742609}, {346,0.03774783}, {347,0.08299130}, {348,0.03828696}, {349,0.03821739}, {350,0.03882609}, {351,0.03833043}, {352,0.09328696}, {353,0.03882609}, {354,0.03891304}, {355,0.03914783}, {356,0.03926087}, {357,0.11301739}, {358,0.03933043}, {359,0.03948696}, {360,0.03958261}, {361,0.04017391}, {362,0.11904348}, {363,0.03985217}, {364,0.04028696}, {365,0.04031304}, {366,0.04033043}, {367,0.11898261}, {368,0.04094783}, {369,0.04095652}, {370,0.04106957}, {371,0.04088696}, {372,0.10380000}, {373,0.04089565}, {374,0.04109565}, {375,0.04190435}, {376,0.04154783}, {377,0.07596522}, {378,0.04197391}, {379,0.04184348}, {380,0.04212174}, {381,0.08653043}, {382,0.04271304}, {383,0.04253043}, {384,0.04302609}, {385,0.04291304}, {386,0.08472174}, {387,0.04330435}, {388,0.04340870}, {389,0.04320870}, {390,0.09536522}, {391,0.04365217}, {392,0.23926957}, {393,0.04271304}, {394,0.13080000}, {395,0.04238261}, {396,0.04271304}, {397,0.04270435}, {398,0.07976522}, {399,0.04335652}, {400,0.04337391}, {401,0.04321739}, {402,0.04373043}, {403,0.09237391}, {404,0.04385217}, {405,0.04387826}, {406,0.04396522}, {407,0.08252174}, {408,0.04421739}, {409,0.04460000}, {410,0.04431304}, {411,0.08333043}, {412,0.04519130}, {413,0.04473043}, {414,0.04520000}, {415,0.04474783}, {416,0.08657391}, {417,0.04523478}, {418,0.04560870}, {419,0.04565217}, {420,0.08258261}, {421,0.04600870}, {422,0.04620870}, {423,0.04635652}, {424,0.08330435}, {425,0.04615652}, {426,0.04646087}, {427,0.04663478}, {428,0.08673913}, {429,0.04682609}, {430,0.04732174}, {431,0.04737391}, {432,0.08700870}, {433,0.04763478}, {434,0.04787826}, {435,0.04793043}, {436,0.04800870}, {437,0.08582609}, {438,0.04800870}, {439,0.04840000}, {440,0.04829565}, {441,0.08618261}, {442,0.04878261}, {443,0.04866087}, {444,0.04858261}, {445,0.08510435}, {446,0.04873913}, {447,0.04905217}, {448,0.04912174}, {449,0.08855652}, {450,0.04943478}, {451,0.04968696}, {452,0.04986087}, {453,0.09012174}, {454,0.04980000}, {455,0.04993913}, {456,0.09505217}, {457,0.05016522}, {458,0.05010435}, {459,0.05049565}, {460,0.11712174}, {461,0.05075652}, {462,0.05066087}, {463,0.05075652}, {464,0.15477391}, {465,0.05271304}, {466,0.05270435}, {467,0.05302609}, {468,0.11456522}, {469,0.05349565}, {470,0.05347826}, {471,0.05381739}, {472,0.10102609}, {473,0.05394783}, {474,0.05400870}, {475,0.05427826}, {476,0.08643478}, {477,0.05447826}, {478,0.05479130}, {479,0.09772174}, {480,0.05513043}, {481,0.05544348}, {482,0.05552174}, {483,0.10587826}, {484,0.05561739}, {485,0.05573043}, {486,0.05601739}, {487,0.12074783}, {488,0.05606087}, {489,0.05617391}, {490,0.13663478}, {491,0.05648696}, {492,0.05646957}, {493,0.05702609}, {494,0.14040870}, {495,0.05678261}, {496,0.05760000}, {497,0.13053913}, {498,0.05719130}, {499,0.05774783}, {500,0.102925764}, {505,0.05843860}, {510,0.05894737}, {515,0.05970175}, {520,0.12618421}, {525,0.06126316}, {530,0.06206140}, {535,0.17107018}, {540,0.06351754}, {545,0.06409649}, {550,0.14019298}, {555,0.06599123}, {560,0.06614035}, {565,0.11453509}, {570,0.06754386}, {575,0.06837719}, {580,0.11372807}, {585,0.06950877}, {590,0.06991228}, {595,0.11718421}, {600,0.07158261}, {605,0.07231579}, {610,0.11930702}, {615,0.07445614}, {620,0.07516667}, {625,0.12219298}, {630,0.07683333}, {635,0.07735965}, {640,0.12414035}, {645,0.07837719}, {650,0.07944737}, {655,0.12025439}, {660,0.08094737}, {665,0.11987719}, {670,0.08212281}, {675,0.08287719}, {680,0.13373684}, {685,0.08450000}, {690,0.08528947}, {695,0.12527193}, {700,0.08434783}, {705,0.12467544}, {710,0.08635088}, {715,0.08717544}, {720,0.14633333}, {725,0.08839474}, {730,0.62993860}, {735,0.25164035}, {740,0.09111404}, {745,0.09200877}, {750,0.13668421}, {755,0.09367544}, {760,0.13307895}, {765,0.09598246}, {770,0.13921930}, {775,0.09692982}, {780,0.09784211}, {785,0.14592982}, {790,0.09966667}, {795,0.14421930}, {800,0.10105217}, {805,0.14530702}, {810,0.10240351}, {815,0.14315789}, {820,0.10415789}, {825,0.10507018}, {830,0.19421053}, {835,0.10978070}, {840,0.20927193}, {845,0.11149123}, {850,0.15995614}, {855,0.11323684}, {860,0.15231579}, {865,0.11453509}, {870,0.15547368}, {875,0.11671930}, {880,0.16913158}, {885,0.11887719}, {890,0.16235965}, {895,0.12028070}, {900,0.16298261}, {905,0.12266667}, {910,0.16492105}, {915,0.12449123}, {920,0.16655263}, {925,0.12707018}, {930,0.16427193}, {935,0.12807018}, {940,0.16136842}, {945,0.13065789}, {950,0.16437719}, {955,0.18203509}, {960,0.13399123}, {965,0.18785965}, {970,0.13604386}, {975,0.18896491}, {980,0.13836842}, {985,0.18505263}, {990,0.14124561}, {995,0.17738596}, {1000,0.18164348}, {1010,0.18875}, {1020,0.14400}, {1030,0.22750}, {1040,0.14675}, {1050,0.22200}, {1060,0.15325}, {1070,0.17675}, {1080,0.20200}, {1090,0.15650}, {1100,0.22875}, {1110,0.19425}, {1120,0.16100}, {1130,0.21300}, {1140,0.16600}, {1150,0.19275}, {1160,0.22650}, {1170,0.17275}, {1180,0.25125}, {1190,0.23650}, {1200,0.18000}, {1210,0.20850}, {1220,0.26125}, {1230,0.23325}, {1240,0.19275}, {1250,0.24900}, {1260,0.23725}, {1270,0.20050}, {1280,0.25050}, {1290,0.25950}, {1300,0.26675}, {1310,0.20750}, {1320,0.26425}, {1330,0.23825}, {1340,0.40575}, {1350,0.21550}, {1360,0.25550}, {1370,0.26650}, {1380,0.26875}, {1390,0.22550}, {1400,0.27175}, {1410,0.27475}, {1420,0.31575}, {1430,0.29925}, {1440,0.23925}, {1450,0.28625}, {1460,0.29650}, {1470,0.29250}, {1480,0.32200}, {1490,0.34625}, {1500,0.27160}, {1510,0.33725}, {1520,0.34975}, {1530,0.30825}, {1540,0.31350}, {1550,0.32150}, {1560,0.34175}, {1570,0.27725}, {1580,0.29575}, {1590,0.31025}, {1600,0.56450}, {1610,0.38775}, {1620,0.32750}, {1630,0.32925}, {1640,0.33125}, {1650,0.33550}, {1660,0.34650}, {1670,0.32900}, {1680,0.40250}, {1690,0.37950}, {1700,0.37375}, {1710,0.37125}, {1720,0.38350}, {1730,0.42925}, {1740,0.45125}, {1750,0.43850}, {1760,0.43850}, {1770,0.43625}, {1780,0.39850}, {1790,0.40525}, {1800,0.40650}, {1810,0.41275}, {1820,0.43000}, {1830,0.41450}, {1840,0.39725}, {1850,0.41075}, {1860,0.41075}, {1870,0.41625}, {1880,0.41375}, {1890,0.41725}, {1900,0.41575}, {1910,0.41750}, {1920,0.41875}, {1930,0.42175}, {1940,0.41350}, {1950,0.40950}, {1960,0.47200}, {1970,0.45225}, {1980,0.45450}, {1990,0.46050}, {2000,0.47640}, {2050,0.47975}, {2100,0.53975}, {2150,1.63700}, {2200,0.58750}, {2250,0.57175}, {2300,0.58825}, {2350,0.59675}, {2400,0.62825}, {2450,0.65075}, {2500,0.66500}, {2550,0.69250}, {2600,0.70875}, {2650,0.73100}, {2700,0.76250}, {2750,0.76700}, {2800,0.76875}, {2850,0.81000}, {2900,0.84425}, {2950,0.85475}, {3000,0.88320}, {3050,0.91625}, {3100,0.90050}, {3150,0.94825}, {3200,0.96775}, {3250,0.98550}, {3300,1.03625}, {3350,1.12175}, {3400,1.12750}, {3450,1.16500}, {3500,1.19320}, {3550,1.27450}, {3600,1.31075}, {3650,1.32125}, {3700,1.39150}, {3750,1.42850}, {3800,1.41075}, {3850,1.37250}, {3900,1.38325}, {3950,1.39950}, {4000,1.45060}, {4050,1.49425}, {4100,1.48050}, {4150,1.51850}, {4200,1.56175}, {4250,1.54500}, {4300,1.63100}, {4350,1.61675}, {4400,1.68725}, {4450,1.68500}, {4500,2.94600}, {4550,1.81425}, {4600,1.91175}, {4650,2.00575}, {4700,1.95925}, {4750,2.06725}, {4800,2.18900}, {4850,2.13725}, {4900,2.02725}, {4950,2.06475}, {5000,2.11180}, {5050,2.2555}, {5100,2.2490}, {5150,2.2635}};
data["big"]["parsing elaborated"]["Stats"]["system"] = {{1,0.00024348}, {2,0.00036522}, {3,0.00020000}, {4,0.00016522}, {5,0.00010435}, {6,0.00013913}, {7,0.00026087}, {8,0.00003478}, {9,0.00016522}, {10,0.00018261}, {11,0.00013043}, {12,0.00006957}, {13,0.00006957}, {14,0.00023478}, {15,0.00016522}, {16,0.00015652}, {17,0.00020870}, {18,0.00013043}, {19,0.00043478}, {20,0.00023478}, {21,0.00009565}, {22,0.00026957}, {23,0.00029565}, {24,0.00024348}, {25,0.00028696}, {26,0.00027826}, {27,0.00023478}, {28,0.00041739}, {29,0.00039130}, {30,0.00040870}, {31,0.00040870}, {32,0.00035652}, {33,0.00022609}, {34,0.00046957}, {35,0.00025217}, {36,0.00038261}, {37,0.00034783}, {38,0.00037391}, {39,0.00038261}, {40,0.00243478}, {41,0.00006957}, {42,0.00000000}, {43,0.00003478}, {44,0.00009565}, {45,0.00006087}, {46,0.00000000}, {47,0.00003478}, {48,0.00003478}, {49,0.00003478}, {50,0.00000000}, {51,0.00000000}, {52,0.00006957}, {53,0.00018261}, {54,0.00000000}, {55,0.00002609}, {56,0.00009565}, {57,0.00006957}, {58,0.00000000}, {59,0.00012174}, {60,0.00000000}, {61,0.00000000}, {62,0.00002609}, {63,0.00009565}, {64,0.00009565}, {65,0.00006087}, {66,0.00009565}, {67,0.00013043}, {68,0.00006957}, {69,0.00006087}, {70,0.00060000}, {71,0.00010435}, {72,0.00008696}, {73,0.00003478}, {74,0.00013043}, {75,0.00006957}, {76,0.00002609}, {77,0.00003478}, {78,0.00006087}, {79,0.00009565}, {80,0.00003478}, {81,0.00009565}, {82,0.00003478}, {83,0.00006957}, {84,0.00002609}, {85,0.00006957}, {86,0.00008696}, {87,0.00000000}, {88,0.00020870}, {89,0.00003478}, {90,0.00006957}, {91,0.00010435}, {92,0.00075652}, {93,0.00013913}, {94,0.00006957}, {95,0.00006087}, {96,0.00013043}, {97,0.00016522}, {98,0.00008696}, {99,0.00017391}, {100,0.00006957}, {101,0.00016522}, {102,0.00006087}, {103,0.00002609}, {104,0.00006957}, {105,0.00002609}, {106,0.00006087}, {107,0.00006957}, {108,0.00000000}, {109,0.00108696}, {110,0.00010435}, {111,0.00006087}, {112,0.00000000}, {113,0.00010435}, {114,0.00013913}, {115,0.00010435}, {116,0.00006087}, {117,0.00010435}, {118,0.00003478}, {119,0.00006087}, {120,0.00026087}, {121,0.00006957}, {122,0.00006957}, {123,0.00006957}, {124,0.00050435}, {125,0.00022609}, {126,0.00009565}, {127,0.00009565}, {128,0.00006087}, {129,0.00015652}, {130,0.00006087}, {131,0.00006957}, {132,0.00009565}, {133,0.00000000}, {134,0.00024348}, {135,0.00006087}, {136,0.00013913}, {137,0.00125217}, {138,0.00038261}, {139,0.00027826}, {140,0.00006957}, {141,0.00020870}, {142,0.00013043}, {143,0.00002609}, {144,0.00003478}, {145,0.00000000}, {146,0.00013043}, {147,0.00008696}, {148,0.00014783}, {149,0.00080870}, {150,0.00006957}, {151,0.00023478}, {152,0.00013043}, {153,0.00010435}, {154,0.00013913}, {155,0.00003478}, {156,0.00003478}, {157,0.00006957}, {158,0.00009565}, {159,0.00013043}, {160,0.00057391}, {161,0.00026957}, {162,0.00020870}, {163,0.00009565}, {164,0.00013913}, {165,0.00013913}, {166,0.00009565}, {167,0.00012174}, {168,0.00009565}, {169,0.00017391}, {170,0.00017391}, {171,0.00131304}, {172,0.00020000}, {173,0.00010435}, {174,0.00037391}, {175,0.00006087}, {176,0.00026087}, {177,0.00016522}, {178,0.00016522}, {179,0.00017391}, {180,0.00020870}, {181,0.00032174}, {182,0.00038261}, {183,0.00022609}, {184,0.00020000}, {185,0.00010435}, {186,0.00020870}, {187,0.00010435}, {188,0.00012174}, {189,0.00010435}, {190,0.00073913}, {191,0.00012174}, {192,0.00010435}, {193,0.00013913}, {194,0.00010435}, {195,0.00058261}, {196,0.00013043}, {197,0.00017391}, {198,0.00013913}, {199,0.00156522}, {200,0.00042609}, {201,0.00029565}, {202,0.00003478}, {203,0.00036522}, {204,0.00017391}, {205,0.00006957}, {206,0.00026087}, {207,0.00098261}, {208,0.00026957}, {209,0.00016522}, {210,0.00016522}, {211,0.00013913}, {212,0.00021739}, {213,0.00017391}, {214,0.00002609}, {215,0.00006087}, {216,0.00084348}, {217,0.00019130}, {218,0.00016522}, {219,0.00013043}, {220,0.00020870}, {221,0.00017391}, {222,0.00010435}, {223,0.00020000}, {224,0.00100870}, {225,0.00017391}, {226,0.00006957}, {227,0.00022609}, {228,0.00017391}, {229,0.00010435}, {230,0.00010435}, {231,0.00020870}, {232,0.00083478}, {233,0.00013913}, {234,0.00012174}, {235,0.00020870}, {236,0.00013913}, {237,0.00017391}, {238,0.00026957}, {239,0.00091304}, {240,0.00029565}, {241,0.00017391}, {242,0.00026087}, {243,0.00009565}, {244,0.00023478}, {245,0.00015652}, {246,0.00084348}, {247,0.00052174}, {248,0.00031304}, {249,0.00020870}, {250,0.00017391}, {251,0.00024348}, {252,0.00010435}, {253,0.00080870}, {254,0.00022609}, {255,0.00017391}, {256,0.00013913}, {257,0.00009565}, {258,0.00002609}, {259,0.00009565}, {260,0.00076522}, {261,0.00033913}, {262,0.00030435}, {263,0.00006957}, {264,0.00016522}, {265,0.00036522}, {266,0.00010435}, {267,0.00099130}, {268,0.00016522}, {269,0.00027826}, {270,0.00010435}, {271,0.00009565}, {272,0.00016522}, {273,0.00033043}, {274,0.00070435}, {275,0.00026957}, {276,0.00072174}, {277,0.00043478}, {278,0.00024348}, {279,0.00226087}, {280,0.00059130}, {281,0.00023478}, {282,0.00036522}, {283,0.00022609}, {284,0.00038261}, {285,0.00093043}, {286,0.00009565}, {287,0.00006087}, {288,0.00031304}, {289,0.00033913}, {290,0.00013043}, {291,0.00020870}, {292,0.00066087}, {293,0.00020870}, {294,0.00020000}, {295,0.00025217}, {296,0.00017391}, {297,0.00027826}, {298,0.00031304}, {299,0.00015652}, {300,0.00023478}, {301,0.00010435}, {302,0.00028696}, {303,0.00020870}, {304,0.00029565}, {305,0.00020870}, {306,0.00013043}, {307,0.00020870}, {308,0.00052174}, {309,0.00042609}, {310,0.00028696}, {311,0.00045217}, {312,0.00010435}, {313,0.00013913}, {314,0.00010435}, {315,0.00046087}, {316,0.00029565}, {317,0.00020870}, {318,0.00036522}, {319,0.00027826}, {320,0.00006957}, {321,0.00033913}, {322,0.00036522}, {323,0.00023478}, {324,0.00016522}, {325,0.00020870}, {326,0.00163478}, {327,0.00015652}, {328,0.00041739}, {329,0.00020000}, {330,0.00029565}, {331,0.00080000}, {332,0.00040870}, {333,0.00026087}, {334,0.00013913}, {335,0.00020870}, {336,0.00020870}, {337,0.00086957}, {338,0.00053913}, {339,0.00042609}, {340,0.00033913}, {341,0.00034783}, {342,0.00094783}, {343,0.00046087}, {344,0.00030435}, {345,0.00036522}, {346,0.00031304}, {347,0.00093043}, {348,0.00020870}, {349,0.00046957}, {350,0.00033913}, {351,0.00044348}, {352,0.00106087}, {353,0.00017391}, {354,0.00044348}, {355,0.00017391}, {356,0.00020000}, {357,0.00095652}, {358,0.00041739}, {359,0.00021739}, {360,0.00029565}, {361,0.00023478}, {362,0.00101739}, {363,0.00047826}, {364,0.00032174}, {365,0.00024348}, {366,0.00031304}, {367,0.00081739}, {368,0.00044348}, {369,0.00031304}, {370,0.00034783}, {371,0.00020870}, {372,0.00089565}, {373,0.00030435}, {374,0.00037391}, {375,0.00024348}, {376,0.00027826}, {377,0.00100000}, {378,0.00042609}, {379,0.00028696}, {380,0.00023478}, {381,0.00089565}, {382,0.00024348}, {383,0.00020870}, {384,0.00017391}, {385,0.00026957}, {386,0.00081739}, {387,0.00039130}, {388,0.00033913}, {389,0.00026957}, {390,0.00135652}, {391,0.00036522}, {392,0.00151304}, {393,0.00033043}, {394,0.00586957}, {395,0.00033043}, {396,0.00040870}, {397,0.00030435}, {398,0.00102609}, {399,0.00020870}, {400,0.00020000}, {401,0.00033043}, {402,0.00019130}, {403,0.00141739}, {404,0.00016522}, {405,0.00029565}, {406,0.00022609}, {407,0.00073913}, {408,0.00029565}, {409,0.00029565}, {410,0.00033043}, {411,0.00103478}, {412,0.00013043}, {413,0.00030435}, {414,0.00044348}, {415,0.00027826}, {416,0.00061739}, {417,0.00034783}, {418,0.00030435}, {419,0.00033913}, {420,0.00126957}, {421,0.00036522}, {422,0.00041739}, {423,0.00006957}, {424,0.00078261}, {425,0.00024348}, {426,0.00034783}, {427,0.00035652}, {428,0.00104348}, {429,0.00044348}, {430,0.00013913}, {431,0.00024348}, {432,0.00118261}, {433,0.00037391}, {434,0.00022609}, {435,0.00031304}, {436,0.00030435}, {437,0.00100870}, {438,0.00034783}, {439,0.00030435}, {440,0.00040000}, {441,0.00124348}, {442,0.00027826}, {443,0.00043478}, {444,0.00037391}, {445,0.00131304}, {446,0.00039130}, {447,0.00037391}, {448,0.00040870}, {449,0.00038261}, {450,0.00031304}, {451,0.00037391}, {452,0.00020000}, {453,0.00013913}, {454,0.00030435}, {455,0.00024348}, {456,0.00040870}, {457,0.00031304}, {458,0.00033913}, {459,0.00020000}, {460,0.00060000}, {461,0.00020000}, {462,0.00026957}, {463,0.00023478}, {464,0.00139130}, {465,0.00044348}, {466,0.00037391}, {467,0.00036522}, {468,0.00139130}, {469,0.00038261}, {470,0.00031304}, {471,0.00034783}, {472,0.00132174}, {473,0.00034783}, {474,0.00050435}, {475,0.00033913}, {476,0.00069565}, {477,0.00023478}, {478,0.00024348}, {479,0.00154783}, {480,0.00026087}, {481,0.00013913}, {482,0.00017391}, {483,0.00110435}, {484,0.00029565}, {485,0.00034783}, {486,0.00017391}, {487,0.00086087}, {488,0.00054783}, {489,0.00053913}, {490,0.00072174}, {491,0.00044348}, {492,0.00031304}, {493,0.00031304}, {494,0.00141739}, {495,0.00027826}, {496,0.00055652}, {497,0.00100870}, {498,0.00040870}, {499,0.00024348}, {500,0.000676856}, {505,0.00041228}, {510,0.00036842}, {515,0.00059649}, {520,0.00081579}, {525,0.00040351}, {530,0.00052632}, {535,0.00144737}, {540,0.00062281}, {545,0.00073684}, {550,0.00131579}, {555,0.00028070}, {560,0.00049123}, {565,0.00094737}, {570,0.00044737}, {575,0.00035088}, {580,0.00141228}, {585,0.00041228}, {590,0.00059649}, {595,0.00131579}, {600,0.00069565}, {605,0.00065789}, {610,0.00118421}, {615,0.00041228}, {620,0.00035088}, {625,0.00181579}, {630,0.00024561}, {635,0.00034211}, {640,0.00112281}, {645,0.00056140}, {650,0.00035965}, {655,0.00099123}, {660,0.00042982}, {665,0.00152632}, {670,0.00064035}, {675,0.00051754}, {680,0.00116667}, {685,0.00035088}, {690,0.00069298}, {695,0.00107018}, {700,0.00054783}, {705,0.00131579}, {710,0.00037719}, {715,0.00055263}, {720,0.00174561}, {725,0.00055263}, {730,0.00678947}, {735,0.00701754}, {740,0.00057895}, {745,0.00068421}, {750,0.00116667}, {755,0.00077193}, {760,0.00047368}, {765,0.00035088}, {770,0.00038596}, {775,0.00051754}, {780,0.00052632}, {785,0.00031579}, {790,0.00024561}, {795,0.00056140}, {800,0.00062609}, {805,0.00031579}, {810,0.00055263}, {815,0.00075439}, {820,0.00056140}, {825,0.00086842}, {830,0.00130702}, {835,0.00062281}, {840,0.00138596}, {845,0.00059649}, {850,0.00145614}, {855,0.00084211}, {860,0.00171053}, {865,0.00090351}, {870,0.00151754}, {875,0.00091228}, {880,0.00113158}, {885,0.00062281}, {890,0.00114912}, {895,0.00082456}, {900,0.00157391}, {905,0.00079825}, {910,0.00147368}, {915,0.00093860}, {920,0.00154386}, {925,0.00070175}, {930,0.00192982}, {935,0.00088596}, {940,0.00164035}, {945,0.00079825}, {950,0.00127193}, {955,0.00155263}, {960,0.00062281}, {965,0.00171053}, {970,0.00116667}, {975,0.00207018}, {980,0.00096491}, {985,0.00168421}, {990,0.00062281}, {995,0.00135088}, {1000,0.00155652}, {1010,0.01575}, {1020,0.00000}, {1030,0.00175}, {1040,0.00175}, {1050,0.00675}, {1060,0.00000}, {1070,0.00000}, {1080,0.00400}, {1090,0.00300}, {1100,0.00475}, {1110,0.00000}, {1120,0.00175}, {1130,0.00175}, {1140,0.00100}, {1150,0.00300}, {1160,0.00100}, {1170,0.00200}, {1180,0.00375}, {1190,0.00175}, {1200,0.00100}, {1210,0.00200}, {1220,0.00000}, {1230,0.00075}, {1240,0.00100}, {1250,0.00200}, {1260,0.00400}, {1270,0.00000}, {1280,0.00375}, {1290,0.00100}, {1300,0.00500}, {1310,0.00275}, {1320,0.00100}, {1330,0.00200}, {1340,0.00500}, {1350,0.00000}, {1360,0.00275}, {1370,0.00200}, {1380,0.00200}, {1390,0.00200}, {1400,0.00100}, {1410,0.00200}, {1420,0.00200}, {1430,0.00175}, {1440,0.00300}, {1450,0.00000}, {1460,0.00200}, {1470,0.00200}, {1480,0.00250}, {1490,0.00200}, {1500,0.00400}, {1510,0.00000}, {1520,0.00300}, {1530,0.00200}, {1540,0.00275}, {1550,0.00000}, {1560,0.00200}, {1570,0.00100}, {1580,0.00400}, {1590,0.00200}, {1600,0.00350}, {1610,0.00500}, {1620,0.00200}, {1630,0.00175}, {1640,0.00100}, {1650,0.00475}, {1660,0.00100}, {1670,0.00600}, {1680,0.00100}, {1690,0.00300}, {1700,0.00200}, {1710,0.00200}, {1720,0.00100}, {1730,0.00000}, {1740,0.00175}, {1750,0.00200}, {1760,0.00375}, {1770,0.00300}, {1780,0.00300}, {1790,0.00000}, {1800,0.00200}, {1810,0.00175}, {1820,0.00200}, {1830,0.00500}, {1840,0.00000}, {1850,0.00400}, {1860,0.00200}, {1870,0.00100}, {1880,0.00500}, {1890,0.00300}, {1900,0.00575}, {1910,0.00075}, {1920,0.00200}, {1930,0.00100}, {1940,0.00000}, {1950,0.00100}, {1960,0.00100}, {1970,0.00000}, {1980,0.00100}, {1990,0.00000}, {2000,0.00160}, {2050,0.00000}, {2100,0.00300}, {2150,0.09550}, {2200,0.01000}, {2250,0.01700}, {2300,0.01175}, {2350,0.00875}, {2400,0.01400}, {2450,0.01075}, {2500,0.01120}, {2550,0.01475}, {2600,0.01275}, {2650,0.01500}, {2700,0.02000}, {2750,0.01800}, {2800,0.01275}, {2850,0.01200}, {2900,0.02100}, {2950,0.01600}, {3000,0.01260}, {3050,0.01500}, {3100,0.01675}, {3150,0.01200}, {3200,0.00575}, {3250,0.00300}, {3300,0.00175}, {3350,0.00600}, {3400,0.00200}, {3450,0.01300}, {3500,0.01660}, {3550,0.01775}, {3600,0.02000}, {3650,0.02175}, {3700,0.02000}, {3750,0.02500}, {3800,0.01775}, {3850,0.01900}, {3900,0.01800}, {3950,0.02175}, {4000,0.01660}, {4050,0.02200}, {4100,0.02300}, {4150,0.02800}, {4200,0.02400}, {4250,0.02200}, {4300,0.02575}, {4350,0.00675}, {4400,0.00200}, {4450,0.00400}, {4500,0.17100}, {4550,0.01600}, {4600,0.00475}, {4650,0.00300}, {4700,0.00575}, {4750,0.00300}, {4800,0.03075}, {4850,0.02500}, {4900,0.02975}, {4950,0.03200}, {5000,0.01900}, {5050,0.0695}, {5100,0.0675}, {5150,0.0435}};
data["big"]["printing"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00004587}, {35,0.00030275}, {36,0.00100000}, {37,0.00100000}, {38,0.00100000}, {39,0.00100000}, {40,0.00100000}, {41,0.00100000}, {42,0.00100000}, {43,0.00100000}, {44,0.00100000}, {45,0.00100000}, {46,0.00100000}, {47,0.00100000}, {48,0.00100000}, {49,0.00100000}, {50,0.00100000}, {51,0.00100000}, {52,0.00111009}, {53,0.00169725}, {54,0.00200000}, {55,0.00200000}, {56,0.00200000}, {57,0.00200000}, {58,0.00200000}, {59,0.00200000}, {60,0.00200000}, {61,0.00243119}, {62,0.00200000}, {63,0.00200000}, {64,0.00200000}, {65,0.00202752}, {66,0.00241284}, {67,0.00300000}, {68,0.00300000}, {69,0.00300000}, {70,0.00300000}, {71,0.00300000}, {72,0.00300000}, {73,0.00300000}, {74,0.00300000}, {75,0.01464220}, {76,0.00305505}, {77,0.00340367}, {78,0.00400000}, {79,0.00400000}, {80,0.00400000}, {81,0.00400000}, {82,0.00400000}, {83,0.00400000}, {84,0.00400917}, {85,0.00401835}, {86,0.00417431}, {87,0.00491743}, {88,0.00500000}, {89,0.00500000}, {90,0.00500000}, {91,0.00500000}, {92,0.00500000}, {93,0.00500000}, {94,0.00501835}, {95,0.00563303}, {96,0.00600000}, {97,0.00600000}, {98,0.00600000}, {99,0.00600000}, {100,0.00600000}, {101,0.00604587}, {102,0.00614679}, {103,0.00688073}, {104,0.00700000}, {105,0.00700000}, {106,0.00700000}, {107,0.00700000}, {108,0.00864220}, {109,0.00715596}, {110,0.00785321}, {111,0.00800000}, {112,0.00800000}, {113,0.00800000}, {114,0.00800917}, {115,0.00808257}, {116,0.00853211}, {117,0.00900000}, {118,0.00900000}, {119,0.00900000}, {120,0.00900000}, {121,0.00903670}, {122,0.00959633}, {123,0.00999083}, {124,0.01003670}, {125,0.01000000}, {126,0.01000000}, {127,0.01019266}, {128,0.01085321}, {129,0.01208257}, {130,0.01100000}, {131,0.01100917}, {132,0.01108257}, {133,0.01167890}, {134,0.01200000}, {135,0.01200000}, {136,0.01200000}, {137,0.01204587}, {138,0.01252294}, {139,0.01299083}, {140,0.01300000}, {141,0.01300917}, {142,0.01311927}, {143,0.01370642}, {144,0.01400000}, {145,0.01400000}, {146,0.01524771}, {147,0.01433028}, {148,0.01479817}, {149,0.01500000}, {150,0.01500000}, {151,0.01507339}, {152,0.01551376}, {153,0.01599083}, {154,0.01600917}, {155,0.01604587}, {156,0.01655046}, {157,0.01695413}, {158,0.01700917}, {159,0.01703670}, {160,0.01886239}, {161,0.01787156}, {162,0.01800000}, {163,0.01802752}, {164,0.01832110}, {165,0.01885321}, {166,0.01900000}, {167,0.01903670}, {168,0.01939450}, {169,0.01996330}, {170,0.02000917}, {171,0.02015596}, {172,0.02187156}, {173,0.02097248}, {174,0.02101835}, {175,0.02123853}, {176,0.02166055}, {177,0.02196330}, {178,0.02202752}, {179,0.02232110}, {180,0.02290826}, {181,0.02301835}, {182,0.02550459}, {183,0.02361468}, {184,0.02398165}, {185,0.02404587}, {186,0.02446789}, {187,0.02493578}, {188,0.02506422}, {189,0.02537615}, {190,0.02582569}, {191,0.02603670}, {192,0.02769725}, {193,0.02672477}, {194,0.02696330}, {195,0.02714679}, {196,0.02752294}, {197,0.02798165}, {198,0.02819266}, {199,0.02869725}, {200,0.02895413}, {201,0.03080734}, {202,0.02947706}, {203,0.02994495}, {204,0.03012844}, {205,0.03053211}, {206,0.03095413}, {207,0.03121101}, {208,0.03161468}, {209,0.03357798}, {210,0.03213761}, {211,0.03278899}, {212,0.03299083}, {213,0.03326606}, {214,0.03381651}, {215,0.03401835}, {216,0.03636697}, {217,0.03476147}, {218,0.03504587}, {219,0.03555046}, {220,0.03594495}, {221,0.03613761}, {222,0.03662385}, {223,0.03692661}, {224,0.03852294}, {225,0.03778899}, {226,0.03811009}, {227,0.03838532}, {228,0.03890826}, {229,0.03933028}, {230,0.04185321}, {231,0.03998165}, {232,0.04049541}, {233,0.04094495}, {234,0.04116514}, {235,0.04169725}, {236,0.04202752}, {237,0.04377982}, {238,0.04294495}, {239,0.04319266}, {240,0.04366972}, {241,0.04420183}, {242,0.04440367}, {243,0.04685321}, {244,0.04540367}, {245,0.04588991}, {246,0.04613761}, {247,0.04668807}, {248,0.04995413}, {249,0.04744037}, {250,0.04798165}, {251,0.04840367}, {252,0.04900917}, {253,0.04932110}, {254,0.05120183}, {255,0.05015596}, {256,0.05082569}, {257,0.05119266}, {258,0.05190826}, {259,0.05440367}, {260,0.05258716}, {261,0.05318349}, {262,0.05349541}, {263,0.05409174}, {264,0.05762385}, {265,0.05517431}, {266,0.05544954}, {267,0.05596330}, {268,0.05633945}, {269,0.05995413}, {270,0.05745872}, {271,0.05811927}, {272,0.05844037}, {273,0.05913761}, {274,0.06105505}, {275,0.06011009}, {276,0.06046789}, {277,0.06200917}, {278,0.06169725}, {279,0.06407339}, {280,0.06273394}, {281,0.06316514}, {282,0.06380734}, {283,0.06671560}, {284,0.06470642}, {285,0.06635780}, {286,0.06588991}, {287,0.06650459}, {288,0.06844037}, {289,0.06755963}, {290,0.06816514}, {291,0.06877064}, {292,0.07164220}, {293,0.07172477}, {294,0.07041284}, {295,0.07075229}, {296,0.07368807}, {297,0.07222936}, {298,0.07280734}, {299,0.07327523}, {300,0.07598165}, {301,0.08825}, {302,0.08500}, {303,0.07500}, {304,0.07575}, {305,0.07700}, {306,0.07725}, {307,0.07700}, {308,0.07775}, {309,0.08175}, {310,0.08075}, {311,0.07975}, {312,0.08075}, {313,0.08400}, {314,0.08125}, {315,0.08225}, {316,0.08400}, {317,0.08600}, {318,0.08525}, {319,0.08450}, {320,0.08675}, {321,0.08750}, {322,0.08725}, {323,0.08825}, {324,0.08950}, {325,0.09325}, {326,0.09050}, {327,0.09175}, {328,0.09125}, {329,0.09275}, {330,0.09350}, {331,0.09400}, {332,0.09325}, {333,0.09875}, {334,0.09725}, {335,0.09575}, {336,0.09725}, {337,0.09850}, {338,0.09775}, {339,0.09975}, {340,0.09975}, {341,0.10575}, {342,0.10275}, {343,0.10350}, {344,0.10200}, {345,0.10400}, {346,0.10700}, {347,0.10475}, {348,0.10450}, {349,0.11575}, {350,0.10975}, {351,0.10825}, {352,0.10875}, {353,0.11075}, {354,0.11075}, {355,0.11150}, {356,0.11175}, {357,0.12000}, {358,0.11575}, {359,0.11300}, {360,0.11400}, {361,0.11825}, {362,0.11550}, {363,0.11875}, {364,0.11725}, {365,0.12775}, {366,0.12375}, {367,0.12000}, {368,0.12100}, {369,0.12400}, {370,0.12225}, {371,0.12600}, {372,0.12350}, {373,0.13475}, {374,0.12975}, {375,0.12600}, {376,0.12800}, {377,0.13150}, {378,0.13050}, {379,0.13100}, {380,0.13150}, {381,0.13700}, {382,0.13800}, {383,0.13550}, {384,0.13600}, {385,0.13825}, {386,0.13975}, {387,0.13725}, {388,0.14025}, {389,0.14775}, {390,0.14575}, {391,0.14375}, {392,0.14300}, {393,0.14475}, {394,0.14525}, {395,0.14700}, {396,0.14775}, {397,0.15700}, {398,0.15350}, {399,0.14850}, {400,0.15200}, {401,0.15300}, {402,0.15200}, {403,0.15400}, {404,0.15600}, {405,0.16225}, {406,0.16050}, {407,0.15850}, {408,0.15800}, {409,0.16375}, {410,0.16000}, {411,0.16400}, {412,0.16325}, {413,0.16900}, {414,0.17075}, {415,0.16700}, {416,0.16825}, {417,0.17075}, {418,0.17050}, {419,0.17150}, {420,0.17200}, {421,0.18350}, {422,0.17850}, {423,0.17550}, {424,0.17575}, {425,0.18050}, {426,0.17775}, {427,0.18175}, {428,0.18025}, {429,0.19200}, {430,0.18650}, {431,0.18575}, {432,0.18625}, {433,0.18825}, {434,0.18825}, {435,0.18825}, {436,0.19050}, {437,0.19350}, {438,0.19775}, {439,0.19375}, {440,0.19350}, {441,0.19825}, {442,0.19575}, {443,0.19925}, {444,0.19900}, {445,0.20575}, {446,0.21075}, {447,0.20250}, {448,0.20475}, {449,0.20875}, {450,0.20675}, {451,0.20700}, {452,0.21025}, {453,0.21775}, {454,0.21400}, {455,0.21475}, {456,0.21375}, {457,0.21375}, {458,0.21775}, {459,0.21675}, {460,0.22000}, {461,0.22600}, {462,0.22950}, {463,0.22425}, {464,0.22450}, {465,0.22775}, {466,0.22650}, {467,0.22975}, {468,0.22975}, {469,0.23950}, {470,0.23875}, {471,0.23275}, {472,0.23500}, {473,0.23825}, {474,0.23650}, {475,0.23875}, {476,0.23925}, {477,0.24750}, {478,0.24950}, {479,0.24350}, {480,0.24925}, {481,0.25325}, {482,0.24925}, {483,0.25275}, {484,0.24975}, {485,0.26075}, {486,0.26300}, {487,0.25425}, {488,0.25725}, {489,0.26000}, {490,0.25975}, {491,0.26125}, {492,0.26350}, {493,0.26925}, {494,0.27375}, {495,0.26800}, {496,0.26800}, {497,0.27250}, {498,0.27275}, {499,0.27525}, {500,0.27200}, {505,0.28925}, {510,0.29500}, {515,0.29575}, {520,0.30600}, {525,0.32775}, {530,0.32300}, {535,0.32725}, {540,0.33750}, {545,0.35200}, {550,0.36600}, {555,0.36525}, {560,0.37225}, {565,0.38625}, {570,0.39075}, {575,0.40325}, {580,0.42225}, {585,0.42925}, {590,0.44150}, {595,0.45150}, {600,0.46250}, {605,0.48200}, {610,0.48325}, {615,0.98825}, {620,0.50300}, {625,1.03125}, {630,0.52350}, {635,0.53225}, {640,0.53525}, {645,0.55050}, {650,0.56275}, {655,0.58250}, {660,0.60200}, {665,0.61775}, {670,0.61275}, {675,0.62425}, {680,0.65025}, {685,0.66625}, {690,0.66325}, {695,0.68600}, {700,0.70925}, {705,0.71175}, {710,0.73300}, {715,0.74175}, {720,0.74900}, {725,0.78575}, {730,0.77975}, {735,0.81675}, {740,0.81575}, {745,0.84000}, {750,0.85275}, {755,0.86625}, {760,0.87825}, {765,0.91450}, {770,0.92650}, {775,0.94050}, {780,0.95750}, {785,0.96675}, {790,0.99900}, {795,1.00975}, {800,1.02525}, {805,1.06975}, {810,1.06825}, {815,1.08225}, {820,1.10225}, {825,1.12375}, {830,1.15275}, {835,1.15875}, {840,1.18625}, {845,1.21750}, {850,1.22350}, {855,1.24275}, {860,1.26725}, {865,1.29025}, {870,1.30475}, {875,1.33000}, {880,1.35650}, {885,1.37625}, {890,1.38475}, {895,1.40550}, {900,1.43525}, {905,1.46625}, {910,1.48750}, {915,1.49750}, {920,1.53625}, {925,1.57400}, {930,1.57600}, {935,1.60275}, {940,1.62575}, {945,1.63950}, {950,1.69475}, {955,1.69475}, {960,1.75200}, {965,1.76650}, {970,1.79900}, {975,1.81700}, {980,1.83475}, {985,1.87575}, {990,1.89075}, {995,1.92525}, {1000,1.95075}, {1010,2.02975}, {1020,2.06900}, {1030,2.13225}, {1040,2.17075}, {1050,2.26675}, {1060,2.30575}, {1070,2.40125}, {1080,2.48400}, {1090,2.52300}, {1100,2.59200}, {1110,2.68375}, {1120,2.73100}, {1130,2.79425}, {1140,2.89750}, {1150,2.97675}, {1160,3.03700}, {1170,3.15525}, {1180,3.18675}, {1190,3.27675}, {1200,3.36425}, {1210,3.45875}, {1220,3.54225}, {1230,3.63375}, {1240,3.73000}, {1250,3.81450}, {1260,3.90725}, {1270,3.98825}, {1280,4.10900}, {1290,4.19625}, {1300,4.35025}, {1310,4.40300}, {1320,4.46225}, {1330,4.59100}, {1340,4.76825}, {1350,4.87975}, {1360,4.97325}, {1370,5.06175}, {1380,5.10825}, {1390,5.23150}, {1400,5.37700}, {1410,5.48225}, {1420,5.58650}, {1430,5.70825}, {1440,5.84050}, {1450,5.96550}, {1460,6.05450}, {1470,6.33200}, {1480,6.38600}, {1490,6.46050}, {1500,6.64125}, {1510,6.79025}, {1520,6.94125}, {1530,7.07125}, {1540,7.26400}, {1550,7.49250}, {1560,7.51025}, {1570,7.63300}, {1580,7.84375}, {1590,7.96850}, {1600,8.32425}, {1610,8.27475}, {1620,8.54550}, {1630,8.67075}, {1640,8.94625}, {1650,9.04800}, {1660,9.21375}, {1670,9.35075}, {1680,9.65525}, {1690,9.77800}, {1700,10.29525}, {1710,10.42175}, {1720,10.46275}, {1730,10.78100}, {1740,10.75000}, {1750,11.08675}, {1760,11.31400}, {1770,11.39000}, {1780,11.56975}, {1790,11.76100}, {1800,12.32475}, {1810,12.33850}, {1820,12.56925}, {1830,12.67925}, {1840,13.07975}, {1850,13.19025}, {1860,13.80750}, {1870,13.59025}, {1880,14.12125}, {1890,13.86175}, {1900,14.29375}, {1910,14.70800}, {1920,15.15525}, {1930,15.27350}, {1940,15.44850}, {1950,15.57625}, {1960,15.78450}, {1970,16.15625}, {1980,16.80275}, {1990,16.74800}, {2000,16.98150}, {2050,16.482}, {2100,22.472}, {2150,24.449}, {2200,26.68}, {2250,28.387}, {2300,30.375}, {2350,32.865}, {2400,34.707}, {2450,37.016}, {2500,40.434}, {2550,42.605}, {2600,45.553}, {2650,48.327}, {2700,51.431}, {2750,54.223}, {2800,57.466}, {2850,60.979}, {2900,65.906}, {2950,67.278}, {3000,72.833}, {3050,79.344}, {3100,79.446}, {3150,84.166}, {3200,95.285}, {3250,100.087}, {3300,106.386}, {3350,110.155}, {3400,120.855}, {3450,125.589}, {3500,133.586}, {3550,134.522}, {3600,131.082}, {3650,136.702}, {3700,143.563}};
data["big"]["printing"]["Stats"]["user"] = {{1,0.00008257}, {2,0.00008257}, {3,0.00008257}, {4,0.00002752}, {5,0.00009174}, {6,0.00002752}, {7,0.00017431}, {8,0.00002752}, {9,0.00013761}, {10,0.00031193}, {11,0.00024771}, {12,0.00019266}, {13,0.00030275}, {14,0.00020183}, {15,0.00025688}, {16,0.00021101}, {17,0.00027523}, {18,0.00035780}, {19,0.00044954}, {20,0.00038532}, {21,0.00040367}, {22,0.00029358}, {23,0.00053211}, {24,0.00047706}, {25,0.00042202}, {26,0.00051376}, {27,0.00045872}, {28,0.00061468}, {29,0.00068807}, {30,0.00055963}, {31,0.00051376}, {32,0.00075229}, {33,0.00079817}, {34,0.00077064}, {35,0.00077982}, {36,0.00088073}, {37,0.00088991}, {38,0.00086239}, {39,0.00115596}, {40,0.00086239}, {41,0.00125688}, {42,0.00111009}, {43,0.00090826}, {44,0.00124771}, {45,0.00111009}, {46,0.00154128}, {47,0.00122018}, {48,0.00167890}, {49,0.00133028}, {50,0.00163303}, {51,0.00142202}, {52,0.00177064}, {53,0.00155046}, {54,0.00164220}, {55,0.00184404}, {56,0.00171560}, {57,0.00204587}, {58,0.00200917}, {59,0.00181651}, {60,0.00217431}, {61,0.00258716}, {62,0.00216514}, {63,0.00218349}, {64,0.00241284}, {65,0.00253211}, {66,0.00253211}, {67,0.00246789}, {68,0.00242202}, {69,0.00270642}, {70,0.00276147}, {71,0.00282569}, {72,0.00274312}, {73,0.00280734}, {74,0.00293578}, {75,0.01461468}, {76,0.00324771}, {77,0.00328440}, {78,0.00344037}, {79,0.00354128}, {80,0.00360550}, {81,0.00382569}, {82,0.00376147}, {83,0.00395413}, {84,0.00385321}, {85,0.00436697}, {86,0.00441284}, {87,0.00409174}, {88,0.00481651}, {89,0.00469725}, {90,0.00467890}, {91,0.00526606}, {92,0.00478899}, {93,0.00540367}, {94,0.00513761}, {95,0.00544037}, {96,0.00601835}, {97,0.00549541}, {98,0.00619266}, {99,0.00650459}, {100,0.00588073}, {101,0.00615596}, {102,0.00645872}, {103,0.00649541}, {104,0.00685321}, {105,0.00711009}, {106,0.00721101}, {107,0.00755963}, {108,0.00867890}, {109,0.00754128}, {110,0.00775229}, {111,0.00782569}, {112,0.00823853}, {113,0.00810092}, {114,0.00834862}, {115,0.00836697}, {116,0.00878899}, {117,0.00903670}, {118,0.00934862}, {119,0.00900917}, {120,0.00955963}, {121,0.00939450}, {122,0.00996330}, {123,0.00986239}, {124,0.01003670}, {125,0.01044037}, {126,0.01057798}, {127,0.01058716}, {128,0.01122018}, {129,0.01254128}, {130,0.01134862}, {131,0.01154128}, {132,0.01168807}, {133,0.01204587}, {134,0.01212844}, {135,0.01233945}, {136,0.01242202}, {137,0.01248624}, {138,0.01298165}, {139,0.01291743}, {140,0.01324771}, {141,0.01324771}, {142,0.01331193}, {143,0.01356881}, {144,0.01393578}, {145,0.01423853}, {146,0.01508257}, {147,0.01450459}, {148,0.01424771}, {149,0.01441284}, {150,0.01467890}, {151,0.01490826}, {152,0.01531193}, {153,0.01540367}, {154,0.01565138}, {155,0.01583486}, {156,0.01661468}, {157,0.01622936}, {158,0.01664220}, {159,0.01692661}, {160,0.01850459}, {161,0.01740367}, {162,0.01785321}, {163,0.01823853}, {164,0.01815596}, {165,0.01870642}, {166,0.01911927}, {167,0.01912844}, {168,0.01962385}, {169,0.01977064}, {170,0.02028440}, {171,0.02035780}, {172,0.02216514}, {173,0.02052294}, {174,0.02148624}, {175,0.02146789}, {176,0.02185321}, {177,0.02201835}, {178,0.02216514}, {179,0.02274312}, {180,0.02306422}, {181,0.02356881}, {182,0.02565138}, {183,0.02388073}, {184,0.02413761}, {185,0.02425688}, {186,0.02470642}, {187,0.02496330}, {188,0.02533945}, {189,0.02539450}, {190,0.02576147}, {191,0.02586239}, {192,0.02727523}, {193,0.02642202}, {194,0.02673394}, {195,0.02682569}, {196,0.02719266}, {197,0.02758716}, {198,0.02792661}, {199,0.02859633}, {200,0.02834862}, {201,0.03064220}, {202,0.02922018}, {203,0.02977982}, {204,0.03018349}, {205,0.03009174}, {206,0.03073394}, {207,0.03111927}, {208,0.03132110}, {209,0.03374312}, {210,0.03200000}, {211,0.03327523}, {212,0.03251376}, {213,0.03398165}, {214,0.03377982}, {215,0.03408257}, {216,0.03661468}, {217,0.03488991}, {218,0.03539450}, {219,0.03573394}, {220,0.03593578}, {221,0.03639450}, {222,0.03652294}, {223,0.03690826}, {224,0.03844954}, {225,0.03738532}, {226,0.03798165}, {227,0.03836697}, {228,0.03875229}, {229,0.03909174}, {230,0.04144954}, {231,0.03970642}, {232,0.04004587}, {233,0.04060550}, {234,0.04098165}, {235,0.04149541}, {236,0.04222018}, {237,0.04366972}, {238,0.04274312}, {239,0.04293578}, {240,0.04351376}, {241,0.04430275}, {242,0.04438532}, {243,0.04704587}, {244,0.04560550}, {245,0.04570642}, {246,0.04623853}, {247,0.04714679}, {248,0.04977982}, {249,0.04752294}, {250,0.04792661}, {251,0.04845872}, {252,0.04896330}, {253,0.04915596}, {254,0.05077064}, {255,0.05022018}, {256,0.05049541}, {257,0.05076147}, {258,0.05133945}, {259,0.05431193}, {260,0.05209174}, {261,0.05286239}, {262,0.05297248}, {263,0.05377064}, {264,0.05751376}, {265,0.05493578}, {266,0.05512844}, {267,0.05582569}, {268,0.05618349}, {269,0.06041284}, {270,0.05733945}, {271,0.05847706}, {272,0.05864220}, {273,0.05933945}, {274,0.06158716}, {275,0.06022018}, {276,0.06066055}, {277,0.06206422}, {278,0.06221101}, {279,0.06426606}, {280,0.06297248}, {281,0.06349541}, {282,0.06426606}, {283,0.06669725}, {284,0.06491743}, {285,0.06650459}, {286,0.06613761}, {287,0.06640367}, {288,0.06829358}, {289,0.06735780}, {290,0.06812844}, {291,0.06858716}, {292,0.07162385}, {293,0.07174312}, {294,0.07057798}, {295,0.07066972}, {296,0.07418349}, {297,0.07222936}, {298,0.07306422}, {299,0.07368807}, {300,0.07624771}, {301,0.08650}, {302,0.08450}, {303,0.07475}, {304,0.07650}, {305,0.07550}, {306,0.07625}, {307,0.07650}, {308,0.07775}, {309,0.08275}, {310,0.08000}, {311,0.08075}, {312,0.08075}, {313,0.08425}, {314,0.08200}, {315,0.08250}, {316,0.08350}, {317,0.08675}, {318,0.08475}, {319,0.08650}, {320,0.08700}, {321,0.08675}, {322,0.08700}, {323,0.08900}, {324,0.08975}, {325,0.09325}, {326,0.09075}, {327,0.09250}, {328,0.09075}, {329,0.09125}, {330,0.09475}, {331,0.09475}, {332,0.09300}, {333,0.09850}, {334,0.09750}, {335,0.09600}, {336,0.09675}, {337,0.09850}, {338,0.09825}, {339,0.09950}, {340,0.09900}, {341,0.10550}, {342,0.10250}, {343,0.10350}, {344,0.10050}, {345,0.10450}, {346,0.10550}, {347,0.10575}, {348,0.10550}, {349,0.11500}, {350,0.10850}, {351,0.10775}, {352,0.10975}, {353,0.10975}, {354,0.11075}, {355,0.10975}, {356,0.11100}, {357,0.11800}, {358,0.11525}, {359,0.11300}, {360,0.11275}, {361,0.11800}, {362,0.11500}, {363,0.11825}, {364,0.11600}, {365,0.12800}, {366,0.12150}, {367,0.11975}, {368,0.12050}, {369,0.12275}, {370,0.12025}, {371,0.12700}, {372,0.12400}, {373,0.13550}, {374,0.12850}, {375,0.12800}, {376,0.12675}, {377,0.13050}, {378,0.13025}, {379,0.13025}, {380,0.13125}, {381,0.13650}, {382,0.13875}, {383,0.13650}, {384,0.13650}, {385,0.13650}, {386,0.13925}, {387,0.13800}, {388,0.14175}, {389,0.14800}, {390,0.14650}, {391,0.14375}, {392,0.14275}, {393,0.14275}, {394,0.14575}, {395,0.14600}, {396,0.14800}, {397,0.15550}, {398,0.15250}, {399,0.14800}, {400,0.15175}, {401,0.15225}, {402,0.15175}, {403,0.15375}, {404,0.15775}, {405,0.16250}, {406,0.16075}, {407,0.15875}, {408,0.15675}, {409,0.16250}, {410,0.16100}, {411,0.16350}, {412,0.16200}, {413,0.17000}, {414,0.17200}, {415,0.16625}, {416,0.16775}, {417,0.17175}, {418,0.16950}, {419,0.17075}, {420,0.17375}, {421,0.18300}, {422,0.17725}, {423,0.17550}, {424,0.17650}, {425,0.18025}, {426,0.17625}, {427,0.18125}, {428,0.18175}, {429,0.19275}, {430,0.18575}, {431,0.18625}, {432,0.18700}, {433,0.18825}, {434,0.18950}, {435,0.18875}, {436,0.19075}, {437,0.19250}, {438,0.19850}, {439,0.19225}, {440,0.19400}, {441,0.19950}, {442,0.19525}, {443,0.19850}, {444,0.19800}, {445,0.20525}, {446,0.21025}, {447,0.20375}, {448,0.20600}, {449,0.20725}, {450,0.20625}, {451,0.20725}, {452,0.21025}, {453,0.21775}, {454,0.21525}, {455,0.21450}, {456,0.21325}, {457,0.21325}, {458,0.21725}, {459,0.21775}, {460,0.21925}, {461,0.22600}, {462,0.22950}, {463,0.22475}, {464,0.22425}, {465,0.22750}, {466,0.22475}, {467,0.23050}, {468,0.22925}, {469,0.23950}, {470,0.23925}, {471,0.23375}, {472,0.23375}, {473,0.23950}, {474,0.23550}, {475,0.23750}, {476,0.23925}, {477,0.24900}, {478,0.24950}, {479,0.24250}, {480,0.24850}, {481,0.25275}, {482,0.25075}, {483,0.25225}, {484,0.25075}, {485,0.26100}, {486,0.26175}, {487,0.25425}, {488,0.25775}, {489,0.25925}, {490,0.25975}, {491,0.26075}, {492,0.26450}, {493,0.27075}, {494,0.27500}, {495,0.26650}, {496,0.26725}, {497,0.27300}, {498,0.27100}, {499,0.27750}, {500,0.26950}, {505,0.28750}, {510,0.29525}, {515,0.29475}, {520,0.30425}, {525,0.32975}, {530,0.32250}, {535,0.32775}, {540,0.33775}, {545,0.35275}, {550,0.36525}, {555,0.36450}, {560,0.37150}, {565,0.38650}, {570,0.39025}, {575,0.40225}, {580,0.42150}, {585,0.42925}, {590,0.44250}, {595,0.45150}, {600,0.46125}, {605,0.48275}, {610,0.48225}, {615,0.98650}, {620,0.50275}, {625,1.03125}, {630,0.52275}, {635,0.53300}, {640,0.53525}, {645,0.55050}, {650,0.56275}, {655,0.58175}, {660,0.60125}, {665,0.61725}, {670,0.61275}, {675,0.62450}, {680,0.65050}, {685,0.66700}, {690,0.66300}, {695,0.68550}, {700,0.70925}, {705,0.71200}, {710,0.73225}, {715,0.74175}, {720,0.74950}, {725,0.78675}, {730,0.77850}, {735,0.81675}, {740,0.81650}, {745,0.84025}, {750,0.85275}, {755,0.86525}, {760,0.87775}, {765,0.91375}, {770,0.92775}, {775,0.93950}, {780,0.95800}, {785,0.96600}, {790,0.99875}, {795,1.00825}, {800,1.02450}, {805,1.06875}, {810,1.06725}, {815,1.08125}, {820,1.10225}, {825,1.12300}, {830,1.15400}, {835,1.15950}, {840,1.18525}, {845,1.21675}, {850,1.22150}, {855,1.24050}, {860,1.26725}, {865,1.29000}, {870,1.30475}, {875,1.33050}, {880,1.35650}, {885,1.37525}, {890,1.38500}, {895,1.40550}, {900,1.43450}, {905,1.46575}, {910,1.48750}, {915,1.49775}, {920,1.53675}, {925,1.57425}, {930,1.57450}, {935,1.60350}, {940,1.62475}, {945,1.63775}, {950,1.69450}, {955,1.69450}, {960,1.75225}, {965,1.76675}, {970,1.79825}, {975,1.81675}, {980,1.83475}, {985,1.87525}, {990,1.88950}, {995,1.92350}, {1000,1.95025}, {1010,2.02950}, {1020,2.06750}, {1030,2.12975}, {1040,2.17050}, {1050,2.26575}, {1060,2.30525}, {1070,2.40175}, {1080,2.48300}, {1090,2.52275}, {1100,2.59175}, {1110,2.68525}, {1120,2.72950}, {1130,2.79150}, {1140,2.89525}, {1150,2.97525}, {1160,3.03675}, {1170,3.15475}, {1180,3.18675}, {1190,3.27575}, {1200,3.36525}, {1210,3.45825}, {1220,3.54000}, {1230,3.63225}, {1240,3.73025}, {1250,3.81475}, {1260,3.90750}, {1270,3.98750}, {1280,4.10675}, {1290,4.19550}, {1300,4.35075}, {1310,4.40275}, {1320,4.46075}, {1330,4.59050}, {1340,4.76650}, {1350,4.88000}, {1360,4.97125}, {1370,5.05700}, {1380,5.10675}, {1390,5.23150}, {1400,5.37600}, {1410,5.48075}, {1420,5.58625}, {1430,5.70675}, {1440,5.84025}, {1450,5.96675}, {1460,6.05500}, {1470,6.33125}, {1480,6.38775}, {1490,6.46050}, {1500,6.64150}, {1510,6.78925}, {1520,6.94125}, {1530,7.07050}, {1540,7.26175}, {1550,7.49225}, {1560,7.51150}, {1570,7.63325}, {1580,7.84550}, {1590,7.96875}, {1600,8.32525}, {1610,8.27525}, {1620,8.54700}, {1630,8.67050}, {1640,8.94675}, {1650,9.04750}, {1660,9.21275}, {1670,9.35150}, {1680,9.65575}, {1690,9.77750}, {1700,10.29600}, {1710,10.42150}, {1720,10.46100}, {1730,10.77975}, {1740,10.75025}, {1750,11.08750}, {1760,11.31475}, {1770,11.38975}, {1780,11.56825}, {1790,11.76025}, {1800,12.32425}, {1810,12.33750}, {1820,12.56650}, {1830,12.67900}, {1840,13.07975}, {1850,13.19025}, {1860,13.80650}, {1870,13.58950}, {1880,14.12150}, {1890,13.86350}, {1900,14.29225}, {1910,14.70725}, {1920,15.15425}, {1930,15.27500}, {1940,15.44925}, {1950,15.57575}, {1960,15.78325}, {1970,16.15575}, {1980,16.80325}, {1990,16.74675}, {2000,16.97950}, {2050,16.472}, {2100,22.444}, {2150,24.448}, {2200,26.676}, {2250,28.36}, {2300,30.352}, {2350,32.84}, {2400,34.676}, {2450,36.984}, {2500,40.396}, {2550,42.572}, {2600,45.504}, {2650,48.283}, {2700,51.376}, {2750,54.2}, {2800,57.415}, {2850,60.932}, {2900,65.851}, {2950,67.216}, {3000,72.775}, {3050,79.283}, {3100,79.379}, {3150,84.087}, {3200,95.203}, {3250,100.011}, {3300,106.304}, {3350,110.079}, {3400,120.755}, {3450,125.484}, {3500,133.503}, {3550,134.399}, {3600,130.971}, {3650,136.592}, {3700,143.463}};
data["big"]["printing"]["Stats"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00003670}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00003670}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00003670}, {27,0.00003670}, {28,0.00000000}, {29,0.00003670}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00003670}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00003670}, {56,0.00000000}, {57,0.00000000}, {58,0.00003670}, {59,0.00003670}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00003670}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00003670}, {74,0.00000000}, {75,0.00003670}, {76,0.00003670}, {77,0.00003670}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00007339}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00003670}, {88,0.00003670}, {89,0.00000000}, {90,0.00003670}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00003670}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003670}, {105,0.00003670}, {106,0.00003670}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00003670}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00003670}, {116,0.00000000}, {117,0.00000000}, {118,0.00003670}, {119,0.00003670}, {120,0.00000000}, {121,0.00003670}, {122,0.00000000}, {123,0.00000000}, {124,0.00007339}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00003670}, {129,0.00000000}, {130,0.00000000}, {131,0.00003670}, {132,0.00003670}, {133,0.00000000}, {134,0.00003670}, {135,0.00003670}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00007339}, {143,0.00000000}, {144,0.00007339}, {145,0.00007339}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00003670}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00007339}, {156,0.00000000}, {157,0.00002752}, {158,0.00003670}, {159,0.00000000}, {160,0.00003670}, {161,0.00003670}, {162,0.00000000}, {163,0.00000000}, {164,0.00007339}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00003670}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00003670}, {181,0.00003670}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00003670}, {186,0.00000000}, {187,0.00000000}, {188,0.00003670}, {189,0.00000000}, {190,0.00010092}, {191,0.00000000}, {192,0.00007339}, {193,0.00000000}, {194,0.00000000}, {195,0.00007339}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00007339}, {200,0.00003670}, {201,0.00000000}, {202,0.00007339}, {203,0.00003670}, {204,0.00000000}, {205,0.00007339}, {206,0.00000000}, {207,0.00000000}, {208,0.00003670}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00003670}, {214,0.00007339}, {215,0.00000000}, {216,0.00003670}, {217,0.00003670}, {218,0.00000000}, {219,0.00000000}, {220,0.00011009}, {221,0.00007339}, {222,0.00007339}, {223,0.00000000}, {224,0.00000000}, {225,0.00007339}, {226,0.00000000}, {227,0.00003670}, {228,0.00010092}, {229,0.00000000}, {230,0.00011009}, {231,0.00000000}, {232,0.00009174}, {233,0.00002752}, {234,0.00000000}, {235,0.00007339}, {236,0.00003670}, {237,0.00011009}, {238,0.00002752}, {239,0.00007339}, {240,0.00000000}, {241,0.00003670}, {242,0.00003670}, {243,0.00000000}, {244,0.00003670}, {245,0.00002752}, {246,0.00003670}, {247,0.00003670}, {248,0.00003670}, {249,0.00000000}, {250,0.00007339}, {251,0.00003670}, {252,0.00007339}, {253,0.00000000}, {254,0.00007339}, {255,0.00000000}, {256,0.00007339}, {257,0.00003670}, {258,0.00007339}, {259,0.00000000}, {260,0.00000000}, {261,0.00003670}, {262,0.00003670}, {263,0.00000000}, {264,0.00000000}, {265,0.00003670}, {266,0.00000000}, {267,0.00003670}, {268,0.00000000}, {269,0.00000000}, {270,0.00003670}, {271,0.00000000}, {272,0.00003670}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00007339}, {279,0.00000000}, {280,0.00003670}, {281,0.00007339}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00003670}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00007339}, {291,0.00007339}, {292,0.00000000}, {293,0.00003670}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00003670}, {298,0.00003670}, {299,0.00000000}, {300,0.00000000}, {301,0.00000}, {302,0.00000}, {303,0.00000}, {304,0.00000}, {305,0.00175}, {306,0.00000}, {307,0.00000}, {308,0.00000}, {309,0.00000}, {310,0.00000}, {311,0.00000}, {312,0.00000}, {313,0.00000}, {314,0.00100}, {315,0.00000}, {316,0.00000}, {317,0.00000}, {318,0.00000}, {319,0.00000}, {320,0.00000}, {321,0.00000}, {322,0.00000}, {323,0.00000}, {324,0.00000}, {325,0.00000}, {326,0.00000}, {327,0.00000}, {328,0.00000}, {329,0.00000}, {330,0.00000}, {331,0.00000}, {332,0.00000}, {333,0.00000}, {334,0.00000}, {335,0.00000}, {336,0.00000}, {337,0.00000}, {338,0.00000}, {339,0.00100}, {340,0.00000}, {341,0.00000}, {342,0.00000}, {343,0.00000}, {344,0.00000}, {345,0.00000}, {346,0.00000}, {347,0.00000}, {348,0.00000}, {349,0.00000}, {350,0.00000}, {351,0.00000}, {352,0.00000}, {353,0.00000}, {354,0.00000}, {355,0.00000}, {356,0.00000}, {357,0.00000}, {358,0.00000}, {359,0.00100}, {360,0.00000}, {361,0.00000}, {362,0.00000}, {363,0.00000}, {364,0.00000}, {365,0.00000}, {366,0.00100}, {367,0.00000}, {368,0.00000}, {369,0.00000}, {370,0.00000}, {371,0.00000}, {372,0.00000}, {373,0.00000}, {374,0.00000}, {375,0.00000}, {376,0.00100}, {377,0.00000}, {378,0.00000}, {379,0.00000}, {380,0.00000}, {381,0.00000}, {382,0.00000}, {383,0.00000}, {384,0.00000}, {385,0.00000}, {386,0.00000}, {387,0.00000}, {388,0.00000}, {389,0.00000}, {390,0.00000}, {391,0.00000}, {392,0.00000}, {393,0.00000}, {394,0.00000}, {395,0.00000}, {396,0.00000}, {397,0.00000}, {398,0.00000}, {399,0.00000}, {400,0.00000}, {401,0.00000}, {402,0.00000}, {403,0.00000}, {404,0.00000}, {405,0.00000}, {406,0.00000}, {407,0.00000}, {408,0.00000}, {409,0.00000}, {410,0.00000}, {411,0.00000}, {412,0.00000}, {413,0.00000}, {414,0.00000}, {415,0.00000}, {416,0.00000}, {417,0.00000}, {418,0.00000}, {419,0.00000}, {420,0.00000}, {421,0.00000}, {422,0.00000}, {423,0.00000}, {424,0.00000}, {425,0.00000}, {426,0.00000}, {427,0.00000}, {428,0.00000}, {429,0.00000}, {430,0.00000}, {431,0.00000}, {432,0.00000}, {433,0.00000}, {434,0.00000}, {435,0.00000}, {436,0.00000}, {437,0.00000}, {438,0.00000}, {439,0.00000}, {440,0.00000}, {441,0.00000}, {442,0.00000}, {443,0.00000}, {444,0.00000}, {445,0.00000}, {446,0.00000}, {447,0.00000}, {448,0.00000}, {449,0.00000}, {450,0.00000}, {451,0.00000}, {452,0.00000}, {453,0.00000}, {454,0.00000}, {455,0.00000}, {456,0.00000}, {457,0.00000}, {458,0.00000}, {459,0.00000}, {460,0.00000}, {461,0.00000}, {462,0.00000}, {463,0.00000}, {464,0.00000}, {465,0.00000}, {466,0.00075}, {467,0.00000}, {468,0.00000}, {469,0.00000}, {470,0.00000}, {471,0.00000}, {472,0.00100}, {473,0.00000}, {474,0.00000}, {475,0.00000}, {476,0.00000}, {477,0.00000}, {478,0.00100}, {479,0.00000}, {480,0.00000}, {481,0.00000}, {482,0.00000}, {483,0.00000}, {484,0.00000}, {485,0.00000}, {486,0.00000}, {487,0.00000}, {488,0.00000}, {489,0.00000}, {490,0.00000}, {491,0.00000}, {492,0.00000}, {493,0.00000}, {494,0.00000}, {495,0.00000}, {496,0.00000}, {497,0.00000}, {498,0.00000}, {499,0.00000}, {500,0.00000}, {505,0.00000}, {510,0.00000}, {515,0.00000}, {520,0.00000}, {525,0.00000}, {530,0.00000}, {535,0.00000}, {540,0.00000}, {545,0.00000}, {550,0.00100}, {555,0.00100}, {560,0.00000}, {565,0.00000}, {570,0.00000}, {575,0.00000}, {580,0.00000}, {585,0.00000}, {590,0.00000}, {595,0.00000}, {600,0.00000}, {605,0.00000}, {610,0.00000}, {615,0.00000}, {620,0.00000}, {625,0.00000}, {630,0.00075}, {635,0.00000}, {640,0.00000}, {645,0.00000}, {650,0.00000}, {655,0.00000}, {660,0.00000}, {665,0.00000}, {670,0.00000}, {675,0.00000}, {680,0.00000}, {685,0.00000}, {690,0.00000}, {695,0.00000}, {700,0.00100}, {705,0.00000}, {710,0.00000}, {715,0.00000}, {720,0.00000}, {725,0.00000}, {730,0.00100}, {735,0.00000}, {740,0.00000}, {745,0.00000}, {750,0.00000}, {755,0.00000}, {760,0.00000}, {765,0.00000}, {770,0.00000}, {775,0.00000}, {780,0.00000}, {785,0.00000}, {790,0.00000}, {795,0.00000}, {800,0.00000}, {805,0.00075}, {810,0.00000}, {815,0.00000}, {820,0.00000}, {825,0.00000}, {830,0.00000}, {835,0.00000}, {840,0.00000}, {845,0.00000}, {850,0.00000}, {855,0.00000}, {860,0.00000}, {865,0.00000}, {870,0.00000}, {875,0.00000}, {880,0.00000}, {885,0.00100}, {890,0.00000}, {895,0.00000}, {900,0.00000}, {905,0.00000}, {910,0.00000}, {915,0.00000}, {920,0.00000}, {925,0.00000}, {930,0.00000}, {935,0.00000}, {940,0.00000}, {945,0.00100}, {950,0.00000}, {955,0.00000}, {960,0.00000}, {965,0.00000}, {970,0.00000}, {975,0.00000}, {980,0.00000}, {985,0.00000}, {990,0.00000}, {995,0.00000}, {1000,0.00000}, {1010,0.00000}, {1020,0.00000}, {1030,0.00075}, {1040,0.00000}, {1050,0.00000}, {1060,0.00000}, {1070,0.00000}, {1080,0.00000}, {1090,0.00000}, {1100,0.00000}, {1110,0.00000}, {1120,0.00000}, {1130,0.00000}, {1140,0.00000}, {1150,0.00000}, {1160,0.00000}, {1170,0.00000}, {1180,0.00000}, {1190,0.00000}, {1200,0.00000}, {1210,0.00000}, {1220,0.00000}, {1230,0.00000}, {1240,0.00000}, {1250,0.00000}, {1260,0.00000}, {1270,0.00000}, {1280,0.00100}, {1290,0.00000}, {1300,0.00000}, {1310,0.00000}, {1320,0.00000}, {1330,0.00000}, {1340,0.00000}, {1350,0.00000}, {1360,0.00000}, {1370,0.00200}, {1380,0.00100}, {1390,0.00000}, {1400,0.00000}, {1410,0.00100}, {1420,0.00000}, {1430,0.00075}, {1440,0.00000}, {1450,0.00000}, {1460,0.00000}, {1470,0.00100}, {1480,0.00000}, {1490,0.00000}, {1500,0.00000}, {1510,0.00000}, {1520,0.00000}, {1530,0.00000}, {1540,0.00000}, {1550,0.00000}, {1560,0.00000}, {1570,0.00000}, {1580,0.00000}, {1590,0.00000}, {1600,0.00000}, {1610,0.00000}, {1620,0.00000}, {1630,0.00000}, {1640,0.00000}, {1650,0.00000}, {1660,0.00100}, {1670,0.00000}, {1680,0.00000}, {1690,0.00100}, {1700,0.00000}, {1710,0.00000}, {1720,0.00100}, {1730,0.00000}, {1740,0.00000}, {1750,0.00000}, {1760,0.00100}, {1770,0.00100}, {1780,0.00000}, {1790,0.00000}, {1800,0.00000}, {1810,0.00175}, {1820,0.00200}, {1830,0.00000}, {1840,0.00000}, {1850,0.00000}, {1860,0.00000}, {1870,0.00100}, {1880,0.00000}, {1890,0.00000}, {1900,0.00100}, {1910,0.00000}, {1920,0.00100}, {1930,0.00000}, {1940,0.00100}, {1950,0.00175}, {1960,0.00075}, {1970,0.00100}, {1980,0.00100}, {1990,0.00200}, {2000,0.00200}, {2050,0}, {2100,0.024}, {2150,0}, {2200,0}, {2250,0.004}, {2300,0}, {2350,0}, {2400,0.003}, {2450,0.004}, {2500,0.008}, {2550,0}, {2600,0.012}, {2650,0.007}, {2700,0.02}, {2750,0.004}, {2800,0.008}, {2850,0}, {2900,0.004}, {2950,0.011}, {3000,0.004}, {3050,0.012}, {3100,0.008}, {3150,0.016}, {3200,0.012}, {3250,0}, {3300,0.019}, {3350,0.004}, {3400,0.008}, {3450,0.012}, {3500,0.027}, {3550,0.02}, {3600,0.012}, {3650,0.024}, {3700,0.007}};
data["big"]["refine let"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00098182}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00001818}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000909}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000909}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000909}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000909}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000909}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000909}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000909}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000909}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000909}, {990,0.00000000}, {995,0.00001818}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00001818}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00003636}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00001818}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00001818}, {1220,0.00000000}, {1230,0.00007273}, {1240,0.00001818}, {1250,0.00001818}, {1260,0.00000909}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00001818}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00001818}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00001818}, {1360,0.00000000}, {1370,0.00001818}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00001818}, {1410,0.00001818}, {1420,0.00000909}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00001818}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00003636}, {1560,0.00001818}, {1570,0.00000000}, {1580,0.00003636}, {1590,0.00001818}, {1600,0.00000000}, {1610,0.00003636}, {1620,0.00000000}, {1630,0.00001818}, {1640,0.00003636}, {1650,0.00000000}, {1660,0.00003636}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00002727}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00002727}, {1770,0.00001818}, {1780,0.00000000}, {1790,0.00001818}, {1800,0.00006364}, {1810,0.00000000}, {1820,0.00010000}, {1830,0.00070909}, {1840,0.00014545}, {1850,0.00000000}, {1860,0.00017273}, {1870,0.00019091}, {1880,0.00021818}, {1890,0.00028182}, {1900,0.00001818}, {1910,0.00005455}, {1920,0.00031818}, {1930,0.00034545}, {1940,0.00040000}, {1950,0.00044545}, {1960,0.00041818}, {1970,0.00048182}, {1980,0.00059091}, {1990,0.00054545}, {2000,0.00046364}, {2050,0.00068182}, {2100,0.00079091}, {2150,0.00084545}, {2200,0.00090000}, {2250,0.00055455}, {2300,0.00093636}, {2350,0.00094545}, {2400,0.00101818}, {2450,0.00087273}, {2500,0.00100000}, {2550,0.00100000}, {2600,0.00100909}, {2650,0.00100909}, {2700,0.00100000}, {2750,0.00103636}, {2800,0.00100909}, {2850,0.00100909}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100}, {3100,0.00100}, {3150,0.00100}, {3200,0.00100}, {3250,0.00100}, {3300,0.00100}, {3350,0.00100}, {3400,0.00100}, {3450,0.00100}, {3500,0.00100}, {3550,0.00100}, {3600,0.00100}, {3650,0.00100}, {3700,0.00150}, {3750,0.00100}, {3800,0.00100}, {3850,0.00100}, {3900,0.00125}, {3950,0.00575}, {4000,0.00100}, {4050,0.00100}, {4100,0.00100}, {4150,0.00100}, {4200,0.00200}, {4250,0.00125}, {4300,0.00125}, {4350,0.00150}, {4400,0.00150}, {4450,0.00150}, {4500,0.00150}, {4550,0.00200}, {4600,0.00200}, {4650,0.00175}, {4700,0.00150}, {4750,0.00175}, {4800,0.00250}, {4850,0.00250}, {4900,0.00200}, {4950,0.00200}, {5000,0.00200}, {5050,0.00200}, {5100,0.00200}, {5150,0.00200}, {5200,0.00200}, {5250,0.00200}, {5300,0.00200}, {5350,0.00200}, {5400,0.00200}, {5450,0.00225}, {5500,0.00200}, {5550,0.00200}, {5600,0.00200}, {5650,0.00250}, {5700,0.00200}, {5750,0.00200}, {5800,0.00225}, {5850,0.00250}, {5900,0.00200}, {5950,0.00200}, {6000,0.00200}, {6050,0.00200}, {6100,0.00200}, {6150,0.00225}, {6200,0.00300}, {6250,0.00200}, {6300,0.00200}, {6350,0.00200}, {6400,0.00200}, {6450,0.00200}, {6500,0.00225}, {6550,0.00250}, {6600,0.00250}, {6650,0.00200}, {6700,0.00325}, {6750,0.00200}, {6800,0.00250}, {6850,0.00300}, {6900,0.01175}, {6950,0.00225}, {7000,0.00350}, {7050,0.00275}, {7100,0.00275}, {7150,0.00325}, {7200,0.00275}, {7250,0.00275}, {7300,0.00325}, {7350,0.00300}, {7400,0.00300}, {7450,0.00375}, {7500,0.00325}, {7550,0.00325}, {7600,0.00350}, {7650,0.00300}, {7700,0.00300}, {7750,0.00350}, {7800,0.00300}, {7850,0.00300}, {7900,0.00350}, {7950,0.00300}, {8000,0.00300}, {8050,0.00300}, {8100,0.00300}, {8150,0.00950}, {8200,0.00300}, {8250,0.00300}, {8300,0.00375}, {8350,0.00325}, {8400,0.01300}, {8450,0.00300}, {8500,0.00350}, {8550,0.00450}, {8600,0.00300}, {8650,0.00300}, {8700,0.00300}, {8750,0.00300}, {8800,0.00375}, {8850,0.00300}, {8900,0.00325}, {8950,0.00325}, {9000,0.00300}, {9050,0.00475}, {9100,0.00300}, {9150,0.00300}, {9200,0.00300}, {9250,0.00325}, {9300,0.00400}, {9350,0.00350}, {9400,0.00400}, {9450,0.00375}, {9500,0.00975}, {9550,0.00325}, {9600,0.00350}, {9650,0.00425}, {9700,0.00350}, {9750,0.00400}, {9800,0.00475}, {9850,0.00350}, {9900,0.00350}, {9950,0.00350}, {10000,0.00375}, {10100,0.0035}, {10200,0.0035}, {10300,0.0075}, {10400,0.0060}, {10500,0.004}, {10600,0.005}, {10700,0.004}, {10800,0.004}, {10900,0.004}, {11000,0.004}, {11100,0.004}, {11200,0.004}, {11300,0.006}, {11400,0.004}, {11500,0.004}, {11600,0.004}, {11700,0.004}, {11800,0.004}, {11900,0.004}, {12000,0.005}, {12100,0.004}, {12200,0.004}, {12300,0.005}, {12400,0.005}, {12500,0.005}, {12600,0.005}, {12700,0.005}, {12800,0.006}, {12900,0.005}, {13000,0.005}, {13100,0.007}, {13200,0.005}, {13300,0.005}, {13400,0.007}, {13500,0.005}, {13600,0.005}, {13700,0.005}, {13800,0.005}, {13900,0.005}, {14000,0.005}, {14100,0.005}, {14200,0.017}, {14300,0.005}, {14400,0.005}, {14500,0.005}, {14600,0.006}, {14700,0.006}, {14800,0.006}, {14900,0.006}, {15000,0.006}, {15100,0.006}, {15200,0.006}, {15300,0.006}, {15400,0.006}, {15500,0.006}, {15600,0.006}, {15700,0.006}, {15800,0.006}, {15900,0.006}, {16000,0.024}, {16100,0.01}, {16200,0.006}, {16300,0.006}, {16400,0.006}, {16500,0.007}, {16600,0.007}, {16700,0.006}, {16800,0.007}, {16900,0.006}, {17000,0.007}, {17100,0.007}, {17200,0.007}, {17300,0.007}, {17400,0.007}, {17500,0.01}, {17600,0.01}, {17700,0.024}, {17800,0.007}, {17900,0.007}, {18000,0.007}, {18100,0.007}, {18200,0.007}, {18300,0.007}, {18400,0.007}, {18500,0.007}, {18600,0.007}, {18700,0.007}, {18800,0.007}, {18900,0.022}, {19000,0.007}, {19100,0.009}, {19200,0.011}, {19300,0.011}, {19400,0.008}, {19500,0.008}, {19600,0.008}, {19700,0.008}, {19800,0.008}, {19900,0.008}};
data["big"]["refine let"]["Stats"]["user"] = {{1,0.00018182}, {2,0.00006364}, {3,0.00005455}, {4,0.00007273}, {5,0.00011818}, {6,0.00005455}, {7,0.00011818}, {8,0.00009091}, {9,0.00011818}, {10,0.00010000}, {11,0.00008182}, {12,0.00009091}, {13,0.00000000}, {14,0.00012727}, {15,0.00003636}, {16,0.00015455}, {17,0.00007273}, {18,0.00002727}, {19,0.00002727}, {20,0.00003636}, {21,0.00005455}, {22,0.00002727}, {23,0.00011818}, {24,0.00006364}, {25,0.00010909}, {26,0.00008182}, {27,0.00009091}, {28,0.00005455}, {29,0.00016364}, {30,0.00003636}, {31,0.00007273}, {32,0.00002727}, {33,0.00014545}, {34,0.00003636}, {35,0.00009091}, {36,0.00006364}, {37,0.00008182}, {38,0.00021818}, {39,0.00005455}, {40,0.00016364}, {41,0.00015455}, {42,0.00020000}, {43,0.00010909}, {44,0.00006364}, {45,0.00019091}, {46,0.00012727}, {47,0.00007273}, {48,0.00025455}, {49,0.00009091}, {50,0.00006364}, {51,0.00015455}, {52,0.00006364}, {53,0.00010909}, {54,0.00010000}, {55,0.00008182}, {56,0.00011818}, {57,0.00000000}, {58,0.00013636}, {59,0.00000000}, {60,0.00005455}, {61,0.00008182}, {62,0.00005455}, {63,0.00005455}, {64,0.00009091}, {65,0.00010000}, {66,0.00002727}, {67,0.00002727}, {68,0.00003636}, {69,0.00010909}, {70,0.00006364}, {71,0.00016364}, {72,0.00010909}, {73,0.00010909}, {74,0.00008182}, {75,0.00022727}, {76,0.00009091}, {77,0.00012727}, {78,0.00010000}, {79,0.00005455}, {80,0.00012727}, {81,0.00020000}, {82,0.00014545}, {83,0.00006364}, {84,0.00009091}, {85,0.00006364}, {86,0.00011818}, {87,0.00011818}, {88,0.00011818}, {89,0.00002727}, {90,0.00017273}, {91,0.00005455}, {92,0.00016364}, {93,0.00015455}, {94,0.00017273}, {95,0.00014545}, {96,0.00010909}, {97,0.00019091}, {98,0.00006364}, {99,0.00006364}, {100,0.00010000}, {101,0.00015455}, {102,0.00010909}, {103,0.00013636}, {104,0.00019091}, {105,0.00009091}, {106,0.00009091}, {107,0.00016364}, {108,0.00018182}, {109,0.00010909}, {110,0.00006364}, {111,0.00015455}, {112,0.00010000}, {113,0.00014545}, {114,0.00012727}, {115,0.00012727}, {116,0.00014545}, {117,0.00011818}, {118,0.00022727}, {119,0.00008182}, {120,0.00005455}, {121,0.00009091}, {122,0.00015455}, {123,0.00010909}, {124,0.00010000}, {125,0.00010000}, {126,0.00009091}, {127,0.00022727}, {128,0.00025455}, {129,0.00015455}, {130,0.00014545}, {131,0.00008182}, {132,0.00009091}, {133,0.00017273}, {134,0.00015455}, {135,0.00020909}, {136,0.00024545}, {137,0.00017273}, {138,0.00014545}, {139,0.00006364}, {140,0.00010909}, {141,0.00012727}, {142,0.00011818}, {143,0.00016364}, {144,0.00019091}, {145,0.00026364}, {146,0.00017273}, {147,0.00014545}, {148,0.00012727}, {149,0.00017273}, {150,0.00002727}, {151,0.00009091}, {152,0.00022727}, {153,0.00011818}, {154,0.00002727}, {155,0.00012727}, {156,0.00016364}, {157,0.00010000}, {158,0.00009091}, {159,0.00003636}, {160,0.00005455}, {161,0.00012727}, {162,0.00015455}, {163,0.00010909}, {164,0.00015455}, {165,0.00011818}, {166,0.00012727}, {167,0.00015455}, {168,0.00012727}, {169,0.00010000}, {170,0.00017273}, {171,0.00013636}, {172,0.00014545}, {173,0.00017273}, {174,0.00009091}, {175,0.00019091}, {176,0.00014545}, {177,0.00020909}, {178,0.00005455}, {179,0.00010909}, {180,0.00014545}, {181,0.00013636}, {182,0.00025455}, {183,0.00011818}, {184,0.00014545}, {185,0.00007273}, {186,0.00021818}, {187,0.00017273}, {188,0.00016364}, {189,0.00021818}, {190,0.00029091}, {191,0.00019091}, {192,0.00010909}, {193,0.00017273}, {194,0.00015455}, {195,0.00015455}, {196,0.00015455}, {197,0.00012727}, {198,0.00023636}, {199,0.00020000}, {200,0.00008182}, {201,0.00026364}, {202,0.00020909}, {203,0.00013636}, {204,0.00015455}, {205,0.00006364}, {206,0.00010000}, {207,0.00022727}, {208,0.00015455}, {209,0.00020000}, {210,0.00015455}, {211,0.00019091}, {212,0.00009091}, {213,0.00010909}, {214,0.00017273}, {215,0.00012727}, {216,0.00010909}, {217,0.00020000}, {218,0.00015455}, {219,0.00003636}, {220,0.00017273}, {221,0.00020000}, {222,0.00019091}, {223,0.00018182}, {224,0.00026364}, {225,0.00014545}, {226,0.00008182}, {227,0.00009091}, {228,0.00022727}, {229,0.00012727}, {230,0.00025455}, {231,0.00022727}, {232,0.00011818}, {233,0.00015455}, {234,0.00027273}, {235,0.00030000}, {236,0.00019091}, {237,0.00021818}, {238,0.00000000}, {239,0.00018182}, {240,0.00017273}, {241,0.00016364}, {242,0.00016364}, {243,0.00020000}, {244,0.00022727}, {245,0.00023636}, {246,0.00008182}, {247,0.00029091}, {248,0.00009091}, {249,0.00017273}, {250,0.00013636}, {251,0.00017273}, {252,0.00020000}, {253,0.00019091}, {254,0.00021818}, {255,0.00022727}, {256,0.00019091}, {257,0.00015455}, {258,0.00014545}, {259,0.00022727}, {260,0.00017273}, {261,0.00035455}, {262,0.00015455}, {263,0.00011818}, {264,0.00015455}, {265,0.00010909}, {266,0.00017273}, {267,0.00018182}, {268,0.00008182}, {269,0.00023636}, {270,0.00022727}, {271,0.00012727}, {272,0.00008182}, {273,0.00011818}, {274,0.00016364}, {275,0.00015455}, {276,0.00029091}, {277,0.00018182}, {278,0.00030000}, {279,0.00020000}, {280,0.00026364}, {281,0.00010000}, {282,0.00031818}, {283,0.00030909}, {284,0.00022727}, {285,0.00012727}, {286,0.00099091}, {287,0.00014545}, {288,0.00014545}, {289,0.00005455}, {290,0.00028182}, {291,0.00022727}, {292,0.00009091}, {293,0.00012727}, {294,0.00024545}, {295,0.00026364}, {296,0.00030000}, {297,0.00024545}, {298,0.00011818}, {299,0.00031818}, {300,0.00030909}, {301,0.00035455}, {302,0.00028182}, {303,0.00018182}, {304,0.00012727}, {305,0.00017273}, {306,0.00030000}, {307,0.00030000}, {308,0.00018182}, {309,0.00019091}, {310,0.00019091}, {311,0.00033636}, {312,0.00010000}, {313,0.00022727}, {314,0.00023636}, {315,0.00003636}, {316,0.00044545}, {317,0.00030909}, {318,0.00011818}, {319,0.00027273}, {320,0.00020909}, {321,0.00027273}, {322,0.00020909}, {323,0.00023636}, {324,0.00015455}, {325,0.00028182}, {326,0.00019091}, {327,0.00010909}, {328,0.00024545}, {329,0.00019091}, {330,0.00022727}, {331,0.00018182}, {332,0.00036364}, {333,0.00017273}, {334,0.00024545}, {335,0.00028182}, {336,0.00020000}, {337,0.00020000}, {338,0.00014545}, {339,0.00024545}, {340,0.00025455}, {341,0.00023636}, {342,0.00014545}, {343,0.00026364}, {344,0.00027273}, {345,0.00028182}, {346,0.00032727}, {347,0.00029091}, {348,0.00017273}, {349,0.00022727}, {350,0.00008182}, {351,0.00024545}, {352,0.00026364}, {353,0.00019091}, {354,0.00013636}, {355,0.00015455}, {356,0.00018182}, {357,0.00020909}, {358,0.00034545}, {359,0.00026364}, {360,0.00027273}, {361,0.00020000}, {362,0.00017273}, {363,0.00031818}, {364,0.00019091}, {365,0.00017273}, {366,0.00030000}, {367,0.00014545}, {368,0.00022727}, {369,0.00015455}, {370,0.00041818}, {371,0.00029091}, {372,0.00022727}, {373,0.00027273}, {374,0.00036364}, {375,0.00027273}, {376,0.00019091}, {377,0.00033636}, {378,0.00011818}, {379,0.00025455}, {380,0.00024545}, {381,0.00033636}, {382,0.00022727}, {383,0.00011818}, {384,0.00014545}, {385,0.00039091}, {386,0.00030909}, {387,0.00027273}, {388,0.00033636}, {389,0.00033636}, {390,0.00020909}, {391,0.00034545}, {392,0.00044545}, {393,0.00017273}, {394,0.00010000}, {395,0.00023636}, {396,0.00023636}, {397,0.00026364}, {398,0.00025455}, {399,0.00041818}, {400,0.00024545}, {401,0.00032727}, {402,0.00018182}, {403,0.00008182}, {404,0.00016364}, {405,0.00026364}, {406,0.00028182}, {407,0.00020909}, {408,0.00013636}, {409,0.00030000}, {410,0.00020000}, {411,0.00040909}, {412,0.00014545}, {413,0.00027273}, {414,0.00023636}, {415,0.00020000}, {416,0.00023636}, {417,0.00030000}, {418,0.00037273}, {419,0.00022727}, {420,0.00032727}, {421,0.00023636}, {422,0.00018182}, {423,0.00026364}, {424,0.00031818}, {425,0.00027273}, {426,0.00034545}, {427,0.00013636}, {428,0.00039091}, {429,0.00024545}, {430,0.00019091}, {431,0.00040909}, {432,0.00008182}, {433,0.00021818}, {434,0.00020909}, {435,0.00017273}, {436,0.00030909}, {437,0.00012727}, {438,0.00013636}, {439,0.00024545}, {440,0.00014545}, {441,0.00025455}, {442,0.00032727}, {443,0.00015455}, {444,0.00038182}, {445,0.00035455}, {446,0.00026364}, {447,0.00015455}, {448,0.00036364}, {449,0.00037273}, {450,0.00021818}, {451,0.00020000}, {452,0.00032727}, {453,0.00021818}, {454,0.00005455}, {455,0.00026364}, {456,0.00030909}, {457,0.00042727}, {458,0.00040000}, {459,0.00037273}, {460,0.00022727}, {461,0.00029091}, {462,0.00018182}, {463,0.00014545}, {464,0.00017273}, {465,0.00044545}, {466,0.00025455}, {467,0.00017273}, {468,0.00029091}, {469,0.00023636}, {470,0.00030909}, {471,0.00023636}, {472,0.00023636}, {473,0.00008182}, {474,0.00024545}, {475,0.00023636}, {476,0.00017273}, {477,0.00033636}, {478,0.00030000}, {479,0.00021818}, {480,0.00032727}, {481,0.00027273}, {482,0.00030000}, {483,0.00027273}, {484,0.00024545}, {485,0.00020000}, {486,0.00040000}, {487,0.00027273}, {488,0.00014545}, {489,0.00030000}, {490,0.00025455}, {491,0.00034545}, {492,0.00028182}, {493,0.00020909}, {494,0.00024545}, {495,0.00026364}, {496,0.00038182}, {497,0.00044545}, {498,0.00047273}, {499,0.00031818}, {500,0.00021818}, {505,0.00023636}, {510,0.00024545}, {515,0.00020909}, {520,0.00042727}, {525,0.00043636}, {530,0.00030000}, {535,0.00027273}, {540,0.00048182}, {545,0.00033636}, {550,0.00029091}, {555,0.00024545}, {560,0.00043636}, {565,0.00036364}, {570,0.00034545}, {575,0.00044545}, {580,0.00029091}, {585,0.00020909}, {590,0.00016364}, {595,0.00039091}, {600,0.00036364}, {605,0.00022727}, {610,0.00045455}, {615,0.00041818}, {620,0.00030000}, {625,0.00037273}, {630,0.00025455}, {635,0.00040909}, {640,0.00024545}, {645,0.00046364}, {650,0.00033636}, {655,0.00013636}, {660,0.00037273}, {665,0.00034545}, {670,0.00036364}, {675,0.00024545}, {680,0.00038182}, {685,0.00033636}, {690,0.00033636}, {695,0.00026364}, {700,0.00049091}, {705,0.00058182}, {710,0.00060909}, {715,0.00036364}, {720,0.00041818}, {725,0.00025455}, {730,0.00050909}, {735,0.00040000}, {740,0.00033636}, {745,0.00029091}, {750,0.00040000}, {755,0.00026364}, {760,0.00050909}, {765,0.00068182}, {770,0.00029091}, {775,0.00050000}, {780,0.00058182}, {785,0.00028182}, {790,0.00066364}, {795,0.00041818}, {800,0.00037273}, {805,0.00050909}, {810,0.00066364}, {815,0.00048182}, {820,0.00033636}, {825,0.00044545}, {830,0.00050000}, {835,0.00043636}, {840,0.00041818}, {845,0.00050000}, {850,0.00039091}, {855,0.00059091}, {860,0.00035455}, {865,0.00046364}, {870,0.00050909}, {875,0.00051818}, {880,0.00044545}, {885,0.00046364}, {890,0.00031818}, {895,0.00053636}, {900,0.00052727}, {905,0.00044545}, {910,0.00042727}, {915,0.00054545}, {920,0.00029091}, {925,0.00049091}, {930,0.00053636}, {935,0.00076364}, {940,0.00057273}, {945,0.00037273}, {950,0.00060000}, {955,0.00030000}, {960,0.00054545}, {965,0.00044545}, {970,0.00034545}, {975,0.00050909}, {980,0.00050909}, {985,0.00054545}, {990,0.00054545}, {995,0.00042727}, {1000,0.00041818}, {1010,0.00060000}, {1020,0.00050909}, {1030,0.00040909}, {1040,0.00074545}, {1050,0.00073636}, {1060,0.00032727}, {1070,0.00030909}, {1080,0.00050000}, {1090,0.00031818}, {1100,0.00033636}, {1110,0.00086364}, {1120,0.00055455}, {1130,0.00060909}, {1140,0.00034545}, {1150,0.00055455}, {1160,0.00031818}, {1170,0.00046364}, {1180,0.00042727}, {1190,0.00060000}, {1200,0.00062727}, {1210,0.00063636}, {1220,0.00085455}, {1230,0.00060909}, {1240,0.00050000}, {1250,0.00066364}, {1260,0.00030909}, {1270,0.00049091}, {1280,0.00054545}, {1290,0.00060000}, {1300,0.00074545}, {1310,0.00077273}, {1320,0.00047273}, {1330,0.00059091}, {1340,0.00060000}, {1350,0.00072727}, {1360,0.00051818}, {1370,0.00071818}, {1380,0.00037273}, {1390,0.00090000}, {1400,0.00056364}, {1410,0.00085455}, {1420,0.00088182}, {1430,0.00072727}, {1440,0.00055455}, {1450,0.00062727}, {1460,0.00062727}, {1470,0.00068182}, {1480,0.00065455}, {1490,0.00066364}, {1500,0.00060909}, {1510,0.00063636}, {1520,0.00090000}, {1530,0.00057273}, {1540,0.00069091}, {1550,0.00090000}, {1560,0.00071818}, {1570,0.00087273}, {1580,0.00078182}, {1590,0.00096364}, {1600,0.00082727}, {1610,0.00080909}, {1620,0.00077273}, {1630,0.00055455}, {1640,0.00083636}, {1650,0.00091818}, {1660,0.00100000}, {1670,0.00088182}, {1680,0.00098182}, {1690,0.00080909}, {1700,0.00061818}, {1710,0.00083636}, {1720,0.00090000}, {1730,0.00037273}, {1740,0.00051818}, {1750,0.00072727}, {1760,0.00068182}, {1770,0.00097273}, {1780,0.00078182}, {1790,0.00098182}, {1800,0.00063636}, {1810,0.00060909}, {1820,0.00090000}, {1830,0.00074545}, {1840,0.00074545}, {1850,0.00070000}, {1860,0.00054545}, {1870,0.00096364}, {1880,0.00062727}, {1890,0.00063636}, {1900,0.00090000}, {1910,0.00072727}, {1920,0.00098182}, {1930,0.00091818}, {1940,0.00095455}, {1950,0.00079091}, {1960,0.00069091}, {1970,0.00097273}, {1980,0.00100000}, {1990,0.00072727}, {2000,0.00079091}, {2050,0.00104545}, {2100,0.00106364}, {2150,0.00140909}, {2200,0.00063636}, {2250,0.00076364}, {2300,0.00108182}, {2350,0.00100000}, {2400,0.00078182}, {2450,0.00119091}, {2500,0.00133636}, {2550,0.00092727}, {2600,0.00087273}, {2650,0.00099091}, {2700,0.00140909}, {2750,0.00124545}, {2800,0.00128182}, {2850,0.00139091}, {2900,0.00097273}, {2950,0.00141818}, {3000,0.00140000}, {3050,0.00175}, {3100,0.00150}, {3150,0.00175}, {3200,0.00250}, {3250,0.00100}, {3300,0.00150}, {3350,0.00150}, {3400,0.00000}, {3450,0.00150}, {3500,0.00250}, {3550,0.00000}, {3600,0.00150}, {3650,0.00175}, {3700,0.00075}, {3750,0.00325}, {3800,0.00100}, {3850,0.00175}, {3900,0.00175}, {3950,0.00800}, {4000,0.00300}, {4050,0.00100}, {4100,0.00175}, {4150,0.00275}, {4200,0.00075}, {4250,0.00150}, {4300,0.00150}, {4350,0.00075}, {4400,0.00275}, {4450,0.00000}, {4500,0.00250}, {4550,0.00200}, {4600,0.00275}, {4650,0.00350}, {4700,0.00200}, {4750,0.00175}, {4800,0.00075}, {4850,0.00175}, {4900,0.00200}, {4950,0.00175}, {5000,0.00200}, {5050,0.00175}, {5100,0.00100}, {5150,0.00250}, {5200,0.00200}, {5250,0.00300}, {5300,0.00275}, {5350,0.00150}, {5400,0.00300}, {5450,0.00300}, {5500,0.00200}, {5550,0.00225}, {5600,0.00275}, {5650,0.00400}, {5700,0.00300}, {5750,0.00100}, {5800,0.00375}, {5850,0.00275}, {5900,0.00100}, {5950,0.00300}, {6000,0.00300}, {6050,0.00100}, {6100,0.00275}, {6150,0.00300}, {6200,0.00275}, {6250,0.00200}, {6300,0.00200}, {6350,0.00400}, {6400,0.00375}, {6450,0.00175}, {6500,0.00400}, {6550,0.00300}, {6600,0.00350}, {6650,0.00375}, {6700,0.00400}, {6750,0.00300}, {6800,0.00150}, {6850,0.00300}, {6900,0.01175}, {6950,0.00400}, {7000,0.00375}, {7050,0.00400}, {7100,0.00350}, {7150,0.00275}, {7200,0.00200}, {7250,0.00375}, {7300,0.00325}, {7350,0.00175}, {7400,0.00375}, {7450,0.00275}, {7500,0.00325}, {7550,0.00300}, {7600,0.00375}, {7650,0.00325}, {7700,0.00350}, {7750,0.00350}, {7800,0.00350}, {7850,0.00275}, {7900,0.00350}, {7950,0.00350}, {8000,0.00375}, {8050,0.00350}, {8100,0.00350}, {8150,0.00850}, {8200,0.00225}, {8250,0.00275}, {8300,0.00375}, {8350,0.00350}, {8400,0.01200}, {8450,0.00275}, {8500,0.00325}, {8550,0.00325}, {8600,0.00275}, {8650,0.00250}, {8700,0.00250}, {8750,0.00350}, {8800,0.00375}, {8850,0.00225}, {8900,0.00325}, {8950,0.00350}, {9000,0.00375}, {9050,0.00400}, {9100,0.00150}, {9150,0.00350}, {9200,0.00250}, {9250,0.00300}, {9300,0.00325}, {9350,0.00225}, {9400,0.00400}, {9450,0.00300}, {9500,0.01025}, {9550,0.00300}, {9600,0.00325}, {9650,0.00350}, {9700,0.00325}, {9750,0.00325}, {9800,0.00325}, {9850,0.00400}, {9900,0.00325}, {9950,0.00275}, {10000,0.00325}, {10100,0.0030}, {10200,0.0060}, {10300,0.0070}, {10400,0.0055}, {10500,0.003}, {10600,0.004}, {10700,0.004}, {10800,0.003}, {10900,0.004}, {11000,0.004}, {11100,0.004}, {11200,0.004}, {11300,0.008}, {11400,0.004}, {11500,0.007}, {11600,0.004}, {11700,0.004}, {11800,0.004}, {11900,0.004}, {12000,0.004}, {12100,0.003}, {12200,0.003}, {12300,0.003}, {12400,0.008}, {12500,0.004}, {12600,0.003}, {12700,0.003}, {12800,0.003}, {12900,0.008}, {13000,0.004}, {13100,0.008}, {13200,0.008}, {13300,0.007}, {13400,0.008}, {13500,0.008}, {13600,0.003}, {13700,0.003}, {13800,0.003}, {13900,0.003}, {14000,0.007}, {14100,0.008}, {14200,0.019}, {14300,0.004}, {14400,0.008}, {14500,0.003}, {14600,0.007}, {14700,0.003}, {14800,0.007}, {14900,0.007}, {15000,0.008}, {15100,0.007}, {15200,0.007}, {15300,0.008}, {15400,0.008}, {15500,0.003}, {15600,0.007}, {15700,0.004}, {15800,0.007}, {15900,0.007}, {16000,0.024}, {16100,0.008}, {16200,0.003}, {16300,0.003}, {16400,0.008}, {16500,0.008}, {16600,0.003}, {16700,0.007}, {16800,0.007}, {16900,0.007}, {17000,0.003}, {17100,0.008}, {17200,0.007}, {17300,0.007}, {17400,0.007}, {17500,0.008}, {17600,0.012}, {17700,0.024}, {17800,0.007}, {17900,0.007}, {18000,0.003}, {18100,0.008}, {18200,0.007}, {18300,0.008}, {18400,0.003}, {18500,0.008}, {18600,0.007}, {18700,0.007}, {18800,0.007}, {18900,0.019}, {19000,0.007}, {19100,0.008}, {19200,0.012}, {19300,0.012}, {19400,0.007}, {19500,0.007}, {19600,0.007}, {19700,0.007}, {19800,0.008}, {19900,0.007}};
data["big"]["refine let"]["Stats"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00003636}, {10,0.00000000}, {11,0.00000000}, {12,0.00003636}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00003636}, {21,0.00003636}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00003636}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00003636}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00003636}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00003636}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00003636}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00003636}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00003636}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00002727}, {135,0.00000000}, {136,0.00003636}, {137,0.00003636}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00003636}, {173,0.00000000}, {174,0.00003636}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00003636}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00002727}, {187,0.00007273}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00003636}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00003636}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00003636}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00002727}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00002727}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00003636}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00003636}, {274,0.00003636}, {275,0.00006364}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00003636}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00003636}, {310,0.00003636}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00003636}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00003636}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00003636}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00003636}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00003636}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00002727}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00003636}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00002727}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00003636}, {413,0.00003636}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00003636}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00003636}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00003636}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00007273}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00003636}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00003636}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00003636}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00003636}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00006364}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00003636}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00003636}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00003636}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00003636}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00003636}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00003636}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00003636}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00003636}, {2750,0.00000000}, {2800,0.00003636}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000}, {3100,0.00000}, {3150,0.00000}, {3200,0.00000}, {3250,0.00000}, {3300,0.00000}, {3350,0.00000}, {3400,0.00000}, {3450,0.00000}, {3500,0.00000}, {3550,0.00000}, {3600,0.00000}, {3650,0.00000}, {3700,0.00000}, {3750,0.00000}, {3800,0.00000}, {3850,0.00000}, {3900,0.00000}, {3950,0.00000}, {4000,0.00000}, {4050,0.00000}, {4100,0.00000}, {4150,0.00000}, {4200,0.00000}, {4250,0.00000}, {4300,0.00000}, {4350,0.00100}, {4400,0.00000}, {4450,0.00000}, {4500,0.00000}, {4550,0.00000}, {4600,0.00000}, {4650,0.00000}, {4700,0.00000}, {4750,0.00000}, {4800,0.00000}, {4850,0.00000}, {4900,0.00000}, {4950,0.00000}, {5000,0.00000}, {5050,0.00000}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00100}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.0000}, {10200,0.0000}, {10300,0.0000}, {10400,0.0000}, {10500,0}, {10600,0}, {10700,0}, {10800,0}, {10900,0}, {11000,0}, {11100,0}, {11200,0}, {11300,0}, {11400,0}, {11500,0}, {11600,0}, {11700,0}, {11800,0}, {11900,0}, {12000,0}, {12100,0}, {12200,0}, {12300,0}, {12400,0}, {12500,0}, {12600,0}, {12700,0}, {12800,0}, {12900,0}, {13000,0}, {13100,0}, {13200,0}, {13300,0}, {13400,0}, {13500,0}, {13600,0}, {13700,0}, {13800,0}, {13900,0}, {14000,0}, {14100,0}, {14200,0}, {14300,0}, {14400,0}, {14500,0}, {14600,0}, {14700,0}, {14800,0}, {14900,0}, {15000,0}, {15100,0}, {15200,0}, {15300,0}, {15400,0}, {15500,0}, {15600,0}, {15700,0}, {15800,0}, {15900,0}, {16000,0}, {16100,0}, {16200,0}, {16300,0}, {16400,0}, {16500,0}, {16600,0}, {16700,0}, {16800,0}, {16900,0}, {17000,0}, {17100,0}, {17200,0}, {17300,0}, {17400,0}, {17500,0}, {17600,0}, {17700,0}, {17800,0}, {17900,0}, {18000,0}, {18100,0}, {18200,0}, {18300,0}, {18400,0}, {18500,0}, {18600,0}, {18700,0}, {18800,0}, {18900,0}, {19000,0}, {19100,0}, {19200,0}, {19300,0}, {19400,0}, {19500,0}, {19600,0}, {19700,0}, {19800,0}, {19900,0}};
data["big"]["simpl Denote"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00001818}, {8,0.00016364}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00100000}, {16,0.00100909}, {17,0.00102727}, {18,0.00174545}, {19,0.00200000}, {20,0.00200000}, {21,0.00200000}, {22,0.00200000}, {23,0.00200000}, {24,0.00201818}, {25,0.00203636}, {26,0.00203636}, {27,0.00226364}, {28,0.00316364}, {29,0.00300000}, {30,0.00300000}, {31,0.00300000}, {32,0.00620000}, {33,0.00301818}, {34,0.00301818}, {35,0.00308182}, {36,0.00324545}, {37,0.00386364}, {38,0.00398182}, {39,0.00400000}, {40,0.00400000}, {41,0.00402727}, {42,0.00404545}, {43,0.00409091}, {44,0.00407273}, {45,0.00421818}, {46,0.00476364}, {47,0.00594545}, {48,0.00500000}, {49,0.00502727}, {50,0.00504545}, {51,0.00502727}, {52,0.00511818}, {53,0.00508182}, {54,0.00535455}, {55,0.00576364}, {56,0.00596364}, {57,0.00605455}, {58,0.00604545}, {59,0.00700909}, {60,0.00607273}, {61,0.00606364}, {62,0.00613636}, {63,0.00643636}, {64,0.00682727}, {65,0.00694545}, {66,0.00705455}, {67,0.00706364}, {68,0.00704545}, {69,0.00700000}, {70,0.00709091}, {71,0.00712727}, {72,0.00760000}, {73,0.00793636}, {74,0.00796364}, {75,0.00804545}, {76,0.00803636}, {77,0.00907273}, {78,0.00806364}, {79,0.00810909}, {80,0.00833636}, {81,0.00881818}, {82,0.00893636}, {83,0.00901818}, {84,0.00908182}, {85,0.01000909}, {86,0.00905455}, {87,0.00906364}, {88,0.00927273}, {89,0.00960000}, {90,0.00989091}, {91,0.00996364}, {92,0.01102727}, {93,0.01005455}, {94,0.01006364}, {95,0.01009091}, {96,0.01017273}, {97,0.01044545}, {98,0.01080000}, {99,0.01197273}, {100,0.01098182}, {101,0.01105455}, {102,0.01105455}, {103,0.01110909}, {104,0.01121818}, {105,0.01281818}, {106,0.01170909}, {107,0.01197273}, {108,0.01199091}, {109,0.01204545}, {110,0.01209091}, {111,0.01327273}, {112,0.01217273}, {113,0.01246364}, {114,0.01268182}, {115,0.01290000}, {116,0.01300909}, {117,0.01398182}, {118,0.01305455}, {119,0.01307273}, {120,0.01314545}, {121,0.01333636}, {122,0.01501818}, {123,0.01379091}, {124,0.01394545}, {125,0.01404545}, {126,0.01410909}, {127,0.01575455}, {128,0.01420000}, {129,0.01453636}, {130,0.01477273}, {131,0.01485455}, {132,0.01623636}, {133,0.01504545}, {134,0.01508182}, {135,0.01506364}, {136,0.01527273}, {137,0.01680909}, {138,0.01576364}, {139,0.01599091}, {140,0.01598182}, {141,0.01604545}, {142,0.01702727}, {143,0.01612727}, {144,0.01627273}, {145,0.01654545}, {146,0.01801818}, {147,0.01685455}, {148,0.01702727}, {149,0.01710000}, {150,0.01711818}, {151,0.01719091}, {152,0.01746364}, {153,0.01769091}, {154,0.01790000}, {155,0.01896364}, {156,0.01802727}, {157,0.01809091}, {158,0.01824545}, {159,0.01973636}, {160,0.01850000}, {161,0.01881818}, {162,0.01893636}, {163,0.02021818}, {164,0.01907273}, {165,0.01920000}, {166,0.01918182}, {167,0.02077273}, {168,0.01959091}, {169,0.01971818}, {170,0.01993636}, {171,0.02109091}, {172,0.02009091}, {173,0.02020909}, {174,0.02035455}, {175,0.02055455}, {176,0.02073636}, {177,0.02086364}, {178,0.02242727}, {179,0.02106364}, {180,0.02121818}, {181,0.02136364}, {182,0.02275455}, {183,0.02172727}, {184,0.02182727}, {185,0.02198182}, {186,0.02201818}, {187,0.02212727}, {188,0.02221818}, {189,0.02368182}, {190,0.02272727}, {191,0.02271818}, {192,0.02298182}, {193,0.02299091}, {194,0.02313636}, {195,0.02326364}, {196,0.02455455}, {197,0.02371818}, {198,0.02380000}, {199,0.02535455}, {200,0.02396364}, {201,0.02416364}, {202,0.02582727}, {203,0.02447273}, {204,0.02463636}, {205,0.02473636}, {206,0.02486364}, {207,0.02502727}, {208,0.02515455}, {209,0.02532727}, {210,0.02553636}, {211,0.02570000}, {212,0.02670909}, {213,0.02581818}, {214,0.02591818}, {215,0.02752727}, {216,0.02629091}, {217,0.02651818}, {218,0.02783636}, {219,0.02678182}, {220,0.02690909}, {221,0.02837273}, {222,0.02707273}, {223,0.02735455}, {224,0.02874545}, {225,0.02774545}, {226,0.02779091}, {227,0.02781818}, {228,0.02800000}, {229,0.02816364}, {230,0.02833636}, {231,0.02852727}, {232,0.02869091}, {233,0.02878182}, {234,0.02882727}, {235,0.03072727}, {236,0.02923636}, {237,0.02945455}, {238,0.03088182}, {239,0.02969091}, {240,0.02986364}, {241,0.03105455}, {242,0.03018182}, {243,0.03028182}, {244,0.03042727}, {245,0.03057273}, {246,0.03237273}, {247,0.03085455}, {248,0.03097273}, {249,0.03235455}, {250,0.03144545}, {251,0.03357273}, {252,0.03170000}, {253,0.03170000}, {254,0.03341818}, {255,0.03200000}, {256,0.03222727}, {257,0.03245455}, {258,0.03260000}, {259,0.03456364}, {260,0.03274545}, {261,0.03291818}, {262,0.03312727}, {263,0.03329091}, {264,0.03509091}, {265,0.03359091}, {266,0.03382727}, {267,0.03380909}, {268,0.03396364}, {269,0.03580000}, {270,0.03442727}, {271,0.03470000}, {272,0.03463636}, {273,0.03476364}, {274,0.03647273}, {275,0.03517273}, {276,0.03729091}, {277,0.03545455}, {278,0.03561818}, {279,0.03576364}, {280,0.03580000}, {281,0.03751818}, {282,0.03620000}, {283,0.03835455}, {284,0.03662727}, {285,0.03669091}, {286,0.03683636}, {287,0.03700909}, {288,0.03837273}, {289,0.03747273}, {290,0.03930909}, {291,0.03774545}, {292,0.03776364}, {293,0.03791818}, {294,0.03810909}, {295,0.03831818}, {296,0.03856364}, {297,0.03974545}, {298,0.03866364}, {299,0.04060909}, {300,0.03901818}, {301,0.04121818}, {302,0.03944545}, {303,0.03970000}, {304,0.03967273}, {305,0.03985455}, {306,0.03996364}, {307,0.04025455}, {308,0.04156364}, {309,0.04056364}, {310,0.04240000}, {311,0.04075455}, {312,0.04259091}, {313,0.04120000}, {314,0.04317273}, {315,0.04155455}, {316,0.04362727}, {317,0.04179091}, {318,0.04391818}, {319,0.04200000}, {320,0.04444545}, {321,0.04250000}, {322,0.04467273}, {323,0.04293636}, {324,0.04498182}, {325,0.04309091}, {326,0.04332727}, {327,0.04354545}, {328,0.04377273}, {329,0.04367273}, {330,0.04382727}, {331,0.04406364}, {332,0.04431818}, {333,0.04447273}, {334,0.04694545}, {335,0.04476364}, {336,0.04694545}, {337,0.04558182}, {338,0.04740000}, {339,0.04538182}, {340,0.04755455}, {341,0.04570000}, {342,0.04800000}, {343,0.04601818}, {344,0.04825455}, {345,0.04642727}, {346,0.04825455}, {347,0.04664545}, {348,0.04833636}, {349,0.04721818}, {350,0.04861818}, {351,0.04740909}, {352,0.04757273}, {353,0.04772727}, {354,0.04784545}, {355,0.05018182}, {356,0.04826364}, {357,0.05041818}, {358,0.04856364}, {359,0.05047273}, {360,0.04889091}, {361,0.05065455}, {362,0.04933636}, {363,0.05058182}, {364,0.04960909}, {365,0.04962727}, {366,0.05254545}, {367,0.05012727}, {368,0.05215455}, {369,0.05056364}, {370,0.05212727}, {371,0.05073636}, {372,0.05090909}, {373,0.05115455}, {374,0.05132727}, {375,0.05360000}, {376,0.05168182}, {377,0.05350909}, {378,0.05203636}, {379,0.05337273}, {380,0.05237273}, {381,0.05257273}, {382,0.05479091}, {383,0.05282727}, {384,0.05450909}, {385,0.05326364}, {386,0.05348182}, {387,0.05591818}, {388,0.05369091}, {389,0.05553636}, {390,0.05414545}, {391,0.05557273}, {392,0.05726364}, {393,0.05516364}, {394,0.05690909}, {395,0.05505455}, {396,0.05655455}, {397,0.05536364}, {398,0.05543636}, {399,0.05762727}, {400,0.05575455}, {401,0.05827273}, {402,0.05846364}, {403,0.05629091}, {404,0.05883636}, {405,0.05665455}, {406,0.05690909}, {407,0.05940000}, {408,0.05718182}, {409,0.05873636}, {410,0.05755455}, {411,0.05775455}, {412,0.06065455}, {413,0.05816364}, {414,0.05829091}, {415,0.06065455}, {416,0.05863636}, {417,0.06031818}, {418,0.05905455}, {419,0.05919091}, {420,0.06116364}, {421,0.05960000}, {422,0.05970000}, {423,0.06213636}, {424,0.06038182}, {425,0.06031818}, {426,0.06269091}, {427,0.06062727}, {428,0.06223636}, {429,0.06370000}, {430,0.06125455}, {431,0.06280909}, {432,0.06450000}, {433,0.06166364}, {434,0.06345455}, {435,0.06213636}, {436,0.06240909}, {437,0.06427273}, {438,0.06270909}, {439,0.06277273}, {440,0.06475455}, {441,0.06320000}, {442,0.06337273}, {443,0.06528182}, {444,0.06377273}, {445,0.06401818}, {446,0.06570909}, {447,0.06714545}, {448,0.06450909}, {449,0.06617273}, {450,0.06764545}, {451,0.06521818}, {452,0.06713636}, {453,0.06817273}, {454,0.06564545}, {455,0.06700909}, {456,0.06865455}, {457,0.06631818}, {458,0.06635455}, {459,0.06840000}, {460,0.06674545}, {461,0.06690909}, {462,0.06878182}, {463,0.07016364}, {464,0.06740000}, {465,0.06893636}, {466,0.07047273}, {467,0.06816364}, {468,0.06821818}, {469,0.07027273}, {470,0.06877273}, {471,0.06879091}, {472,0.07606364}, {473,0.07213636}, {474,0.06930909}, {475,0.06950000}, {476,0.07145455}, {477,0.07290909}, {478,0.07009091}, {479,0.07165455}, {480,0.07318182}, {481,0.07070909}, {482,0.07108182}, {483,0.07273636}, {484,0.07423636}, {485,0.07158182}, {486,0.07170909}, {487,0.07391818}, {488,0.07506364}, {489,0.07222727}, {490,0.07241818}, {491,0.07459091}, {492,0.07578182}, {493,0.07301818}, {494,0.07449091}, {495,0.07590909}, {496,0.07663636}, {497,0.07370909}, {498,0.07517273}, {499,0.07677273}, {500,0.07757273}, {505,0.07531818}, {510,0.07629091}, {515,0.07914545}, {520,0.08114545}, {525,0.07926364}, {530,0.08030909}, {535,0.08302727}, {540,0.08462727}, {545,0.08616364}, {550,0.08760909}, {555,0.08528182}, {560,0.08637273}, {565,0.08853636}, {570,0.09055455}, {575,0.09213636}, {580,0.09355455}, {585,0.09470909}, {590,0.09257273}, {595,0.09367273}, {600,0.09461818}, {605,0.09568182}, {610,0.09804545}, {615,0.09995455}, {620,0.10130000}, {625,0.10250909}, {630,0.10380909}, {635,0.10491818}, {640,0.10622727}, {645,0.10720000}, {650,0.10847273}, {655,0.10959091}, {660,0.11096364}, {665,0.11176364}, {670,0.11317273}, {675,0.11408182}, {680,0.11445455}, {685,0.11603636}, {690,0.11719091}, {695,0.11836364}, {700,0.11930909}, {705,0.12023636}, {710,0.12134545}, {715,0.12214545}, {720,0.12316364}, {725,0.12253636}, {730,0.12353636}, {735,0.12941818}, {740,0.12923636}, {745,0.13010909}, {750,0.13098182}, {755,0.13161818}, {760,0.13312727}, {765,0.13165455}, {770,0.13274545}, {775,0.13817273}, {780,0.13837273}, {785,0.13926364}, {790,0.13971818}, {795,0.13879091}, {800,0.14555455}, {805,0.14476364}, {810,0.14524545}, {815,0.14570909}, {820,0.14846364}, {825,0.14979091}, {830,0.15053636}, {835,0.15079091}, {840,0.15310000}, {845,0.15469091}, {850,0.15525455}, {855,0.15562727}, {860,0.15932727}, {865,0.15941818}, {870,0.15975455}, {875,0.16190000}, {880,0.16353636}, {885,0.16384545}, {890,0.16610909}, {895,0.16737273}, {900,0.16759091}, {905,0.17049091}, {910,0.17100909}, {915,0.17118182}, {920,0.17500909}, {925,0.17472727}, {930,0.17680000}, {935,0.17800000}, {940,0.17795455}, {945,0.18140000}, {950,0.18120000}, {955,0.18310909}, {960,0.18422727}, {965,0.18670000}, {970,0.18713636}, {975,0.18906364}, {980,0.19007273}, {985,0.19390000}, {990,0.19290909}, {995,0.19623636}, {1000,0.19587273}, {1010,0.19990909}, {1020,0.20142727}, {1030,0.20440000}, {1040,0.20671818}, {1050,0.20982727}, {1060,0.21193636}, {1070,0.21726364}, {1080,0.21980909}, {1090,0.22098182}, {1100,0.22391818}, {1110,0.22898182}, {1120,0.22990000}, {1130,0.23284545}, {1140,0.23752727}, {1150,0.23871818}, {1160,0.24285455}, {1170,0.24532727}, {1180,0.24980909}, {1190,0.25086364}, {1200,0.25514545}, {1210,0.25803636}, {1220,0.26004545}, {1230,0.26409091}, {1240,0.26907273}, {1250,0.27270000}, {1260,0.27371818}, {1270,0.27710000}, {1280,0.28210000}, {1290,0.28360000}, {1300,0.28510909}, {1310,0.28919091}, {1320,0.29236364}, {1330,0.29545455}, {1340,0.29878182}, {1350,0.30234545}, {1360,0.30504545}, {1370,0.30970909}, {1380,0.31339091}, {1390,0.31693636}, {1400,0.32315455}, {1410,0.32558182}, {1420,0.32882727}, {1430,0.33153636}, {1440,0.33285455}, {1450,0.33666364}, {1460,0.34484545}, {1470,0.34631818}, {1480,0.34873636}, {1490,0.35035455}, {1500,0.35440909}, {1510,0.36170909}, {1520,0.36379091}, {1530,0.36641818}, {1540,0.37378182}, {1550,0.37669091}, {1560,0.37622727}, {1570,0.38389091}, {1580,0.38500000}, {1590,0.38737273}, {1600,0.39452727}, {1610,0.39548182}, {1620,0.40317273}, {1630,0.40412727}, {1640,0.40746364}, {1650,0.41225455}, {1660,0.41689091}, {1670,0.42002727}, {1680,0.42358182}, {1690,0.42790000}, {1700,0.43360909}, {1710,0.43417273}, {1720,0.44358182}, {1730,0.44147273}, {1740,0.44897273}, {1750,0.45219091}, {1760,0.45387273}, {1770,0.46086364}, {1780,0.46442727}, {1790,0.46640000}, {1800,0.47267273}, {1810,0.47578182}, {1820,0.48048182}, {1830,0.48837273}, {1840,0.48960000}, {1850,0.49328182}, {1860,0.49818182}, {1870,0.49919091}, {1880,0.50610000}, {1890,0.51054545}, {1900,0.51694545}, {1910,0.51832727}, {1920,0.52426364}, {1930,0.52801818}, {1940,0.53223636}, {1950,0.53749091}, {1960,0.53951818}, {1970,0.54471818}, {1980,0.55035455}, {1990,0.55390000}, {2000,0.55760909}, {2050,0.58080000}, {2100,0.60660909}, {2150,0.62742727}, {2200,0.65029091}, {2250,0.67816364}, {2300,0.69980909}, {2350,0.72864545}, {2400,0.74996364}, {2450,0.78016364}, {2500,0.80342727}, {2550,0.82802727}, {2600,0.85499091}, {2650,0.88360909}, {2700,0.91204545}, {2750,0.93705455}, {2800,0.98078182}, {2850,0.99523636}, {2900,1.02540909}, {2950,1.05793636}, {3000,1.08312727}, {3050,1.11400}, {3100,1.14450}, {3150,1.17450}, {3200,1.20775}, {3250,1.23775}, {3300,1.27100}, {3350,1.30425}, {3400,1.33950}, {3450,1.37925}, {3500,1.41250}, {3550,1.45000}, {3600,1.48600}, {3650,1.51925}, {3700,1.55975}, {3750,1.59275}, {3800,1.62300}, {3850,1.67400}, {3900,1.70150}, {3950,1.76200}, {4000,1.77725}, {4050,1.81825}, {4100,1.87250}, {4150,1.90075}, {4200,1.96225}, {4250,1.98500}, {4300,2.05375}, {4350,2.06525}, {4400,2.10900}, {4450,2.15225}, {4500,2.20975}, {4550,2.28475}, {4600,2.30625}, {4650,2.34825}, {4700,2.38525}, {4750,2.44700}, {4800,2.49700}, {4850,2.70175}, {4900,2.59200}, {4950,2.66250}, {5000,2.70125}, {5050,2.74525}, {5100,2.82500}, {5150,2.84275}, {5200,2.91050}, {5250,2.97475}, {5300,3.02600}, {5350,3.05850}, {5400,3.14325}, {5450,3.17550}, {5500,3.28450}, {5550,3.35250}, {5600,3.36300}, {5650,4.01750}, {5700,3.49950}, {5750,3.66200}, {5800,3.63575}, {5850,4.32625}, {5900,3.73725}, {5950,3.83975}, {6000,3.88675}, {6050,3.97750}, {6100,4.08400}, {6150,4.17375}, {6200,4.49300}, {6250,4.30475}, {6300,4.24375}, {6350,4.39400}, {6400,4.32250}, {6450,4.51025}, {6500,4.62525}, {6550,4.79800}, {6600,4.76675}, {6650,4.84450}, {6700,5.96500}, {6750,5.07075}, {6800,5.94050}, {6850,6.15250}, {6900,5.31025}, {6950,5.46050}, {7000,6.60900}, {7050,5.43350}, {7100,5.66400}, {7150,8.15100}, {7200,6.02200}, {7250,6.15475}, {7300,7.94575}, {7350,6.16650}, {7400,6.48800}, {7450,7.59150}, {7500,6.65950}, {7550,6.71775}, {7600,7.64150}, {7650,6.73150}, {7700,6.95325}, {7750,8.70675}, {7800,6.94550}, {7850,7.25200}, {7900,7.55175}, {7950,7.49250}, {8000,7.72625}, {8050,7.67500}, {8100,7.74325}, {8150,8.93075}, {8200,7.85450}, {8250,8.20000}, {8300,8.68375}, {8350,7.68375}, {8400,8.02025}, {8450,8.17800}, {8500,7.99000}, {8550,10.81525}, {8600,8.13475}, {8650,8.15700}, {8700,8.55675}, {8750,8.53675}, {8800,9.48550}, {8850,8.64025}, {8900,8.90300}, {8950,9.19650}, {9000,9.19225}, {9050,12.39000}, {9100,9.34450}, {9150,9.33975}, {9200,10.36225}, {9250,9.52250}, {9300,11.56150}, {9350,9.99175}, {9400,13.76925}, {9450,10.24075}, {9500,10.11800}, {9550,10.51225}, {9600,10.68175}, {9650,13.83225}, {9700,12.35100}, {9750,12.69925}, {9800,11.09425}, {9850,11.30125}, {9900,11.89150}, {9950,11.43900}, {10000,11.59550}, {10100,10.5190}, {10200,10.7080}, {10300,10.8635}, {10400,16.749}, {10500,11.487}, {10600,13.648}, {10700,12.49}, {10800,12.974}, {10900,12.279}, {11000,13.666}, {11100,12.871}, {11200,13.137}, {11300,19.943}, {11400,13.471}, {11500,14.457}, {11600,14.113}, {11700,15.49}, {11800,15.389}, {11900,14.577}, {12000,17.164}, {12100,15.974}, {12200,17.33}, {12300,16.944}, {12400,17.271}, {12500,18.647}, {12600,21.9}, {12700,17.946}, {12800,21.797}, {12900,18.129}, {13000,20.055}, {13100,27.24}, {13200,21.84}, {13300,20.648}, {13400,30.809}, {13500,21.474}, {13600,21.949}, {13700,20.171}, {13800,22.329}, {13900,24.076}, {14000,21.646}, {14100,24.919}, {14200,24.253}, {14300,23.73}, {14400,24.959}, {14500,25.568}, {14600,24.888}, {14700,23.018}, {14800,28.091}, {14900,27.222}, {15000,27.982}, {15100,28.142}, {15200,26.67}, {15300,28.447}, {15400,26.534}, {15500,28.756}, {15600,30.427}, {15700,29.813}, {15800,30.121}, {15900,29.976}, {16000,29.812}, {16100,30.338}, {16200,32.938}, {16300,27.703}, {16400,33.604}, {16500,33.706}, {16600,35.742}, {16700,34.224}, {16800,34.442}, {16900,35.528}, {17000,35.61}, {17100,35.775}, {17200,37.361}, {17300,33.11}, {17400,38.466}, {17500,51.891}, {17600,50.756}, {17700,37.789}, {17800,38.966}, {17900,36.133}, {18000,39.559}, {18100,42.768}, {18200,41.164}, {18300,40.897}, {18400,41.809}, {18500,44.541}, {18600,40.234}, {18700,39.117}, {18800,43.16}, {18900,44.872}, {19000,43.663}, {19100,52.407}, {19200,63.821}, {19300,65.762}, {19400,47.891}, {19500,47.841}, {19600,46.06}, {19700,44.134}, {19800,42.744}, {19900,50.138}};
data["big"]["simpl Denote"]["Stats"]["user"] = {{1,0.00032727}, {2,0.00019091}, {3,0.00042727}, {4,0.00053636}, {5,0.00042727}, {6,0.00070909}, {7,0.00058182}, {8,0.00070909}, {9,0.00080909}, {10,0.00126364}, {11,0.00103636}, {12,0.00109091}, {13,0.00123636}, {14,0.00134545}, {15,0.00151818}, {16,0.00149091}, {17,0.00159091}, {18,0.00156364}, {19,0.00180909}, {20,0.00176364}, {21,0.00190000}, {22,0.00183636}, {23,0.00206364}, {24,0.00234545}, {25,0.00235455}, {26,0.00215455}, {27,0.00250909}, {28,0.00294545}, {29,0.00240000}, {30,0.00279091}, {31,0.00263636}, {32,0.00626364}, {33,0.00294545}, {34,0.00311818}, {35,0.00296364}, {36,0.00330909}, {37,0.00343636}, {38,0.00356364}, {39,0.00355455}, {40,0.00363636}, {41,0.00352727}, {42,0.00376364}, {43,0.00389091}, {44,0.00400000}, {45,0.00465455}, {46,0.00470909}, {47,0.00574545}, {48,0.00467273}, {49,0.00520000}, {50,0.00496364}, {51,0.00484545}, {52,0.00563636}, {53,0.00495455}, {54,0.00583636}, {55,0.00546364}, {56,0.00578182}, {57,0.00591818}, {58,0.00586364}, {59,0.00697273}, {60,0.00617273}, {61,0.00629091}, {62,0.00627273}, {63,0.00660000}, {64,0.00671818}, {65,0.00678182}, {66,0.00704545}, {67,0.00717273}, {68,0.00706364}, {69,0.00742727}, {70,0.00738182}, {71,0.00761818}, {72,0.00772727}, {73,0.00787273}, {74,0.00790000}, {75,0.00820909}, {76,0.00798182}, {77,0.00944545}, {78,0.00881818}, {79,0.00830909}, {80,0.00865455}, {81,0.00891818}, {82,0.00914545}, {83,0.00885455}, {84,0.00897273}, {85,0.01022727}, {86,0.00928182}, {87,0.00938182}, {88,0.00974545}, {89,0.01016364}, {90,0.01036364}, {91,0.01029091}, {92,0.01117273}, {93,0.01032727}, {94,0.01068182}, {95,0.01062727}, {96,0.01074545}, {97,0.01082727}, {98,0.01129091}, {99,0.01214545}, {100,0.01130000}, {101,0.01132727}, {102,0.01156364}, {103,0.01161818}, {104,0.01183636}, {105,0.01310000}, {106,0.01213636}, {107,0.01211818}, {108,0.01233636}, {109,0.01227273}, {110,0.01247273}, {111,0.01351818}, {112,0.01278182}, {113,0.01282727}, {114,0.01263636}, {115,0.01350000}, {116,0.01305455}, {117,0.01440909}, {118,0.01312727}, {119,0.01361818}, {120,0.01360000}, {121,0.01370909}, {122,0.01475455}, {123,0.01372727}, {124,0.01393636}, {125,0.01426364}, {126,0.01423636}, {127,0.01543636}, {128,0.01444545}, {129,0.01452727}, {130,0.01480000}, {131,0.01483636}, {132,0.01625455}, {133,0.01496364}, {134,0.01501818}, {135,0.01485455}, {136,0.01523636}, {137,0.01674545}, {138,0.01546364}, {139,0.01575455}, {140,0.01553636}, {141,0.01579091}, {142,0.01691818}, {143,0.01610909}, {144,0.01615455}, {145,0.01634545}, {146,0.01823636}, {147,0.01674545}, {148,0.01670000}, {149,0.01715455}, {150,0.01739091}, {151,0.01710000}, {152,0.01762727}, {153,0.01759091}, {154,0.01789091}, {155,0.01908182}, {156,0.01805455}, {157,0.01814545}, {158,0.01850000}, {159,0.01990000}, {160,0.01837273}, {161,0.01875455}, {162,0.01937273}, {163,0.02044545}, {164,0.01916364}, {165,0.01928182}, {166,0.01932727}, {167,0.02105455}, {168,0.01960000}, {169,0.02007273}, {170,0.01989091}, {171,0.02130000}, {172,0.02025455}, {173,0.02047273}, {174,0.02067273}, {175,0.02066364}, {176,0.02085455}, {177,0.02112727}, {178,0.02289091}, {179,0.02160909}, {180,0.02146364}, {181,0.02165455}, {182,0.02302727}, {183,0.02180000}, {184,0.02223636}, {185,0.02252727}, {186,0.02200000}, {187,0.02242727}, {188,0.02289091}, {189,0.02390909}, {190,0.02312727}, {191,0.02332727}, {192,0.02331818}, {193,0.02340909}, {194,0.02353636}, {195,0.02362727}, {196,0.02469091}, {197,0.02419091}, {198,0.02417273}, {199,0.02558182}, {200,0.02425455}, {201,0.02454545}, {202,0.02608182}, {203,0.02437273}, {204,0.02492727}, {205,0.02475455}, {206,0.02502727}, {207,0.02551818}, {208,0.02508182}, {209,0.02510909}, {210,0.02566364}, {211,0.02580000}, {212,0.02670000}, {213,0.02607273}, {214,0.02615455}, {215,0.02731818}, {216,0.02648182}, {217,0.02659091}, {218,0.02796364}, {219,0.02655455}, {220,0.02678182}, {221,0.02804545}, {222,0.02682727}, {223,0.02708182}, {224,0.02870000}, {225,0.02747273}, {226,0.02752727}, {227,0.02758182}, {228,0.02787273}, {229,0.02815455}, {230,0.02812727}, {231,0.02817273}, {232,0.02838182}, {233,0.02854545}, {234,0.02846364}, {235,0.03054545}, {236,0.02898182}, {237,0.02930909}, {238,0.03082727}, {239,0.02980909}, {240,0.02988182}, {241,0.03121818}, {242,0.02994545}, {243,0.03030909}, {244,0.03043636}, {245,0.03059091}, {246,0.03221818}, {247,0.03104545}, {248,0.03109091}, {249,0.03267273}, {250,0.03130000}, {251,0.03367273}, {252,0.03184545}, {253,0.03173636}, {254,0.03320000}, {255,0.03188182}, {256,0.03231818}, {257,0.03230909}, {258,0.03280909}, {259,0.03510909}, {260,0.03313636}, {261,0.03355455}, {262,0.03350909}, {263,0.03365455}, {264,0.03532727}, {265,0.03400000}, {266,0.03422727}, {267,0.03458182}, {268,0.03417273}, {269,0.03608182}, {270,0.03483636}, {271,0.03518182}, {272,0.03498182}, {273,0.03521818}, {274,0.03669091}, {275,0.03561818}, {276,0.03727273}, {277,0.03585455}, {278,0.03601818}, {279,0.03600000}, {280,0.03624545}, {281,0.03745455}, {282,0.03671818}, {283,0.03825455}, {284,0.03670000}, {285,0.03671818}, {286,0.03691818}, {287,0.03720000}, {288,0.03811818}, {289,0.03747273}, {290,0.03918182}, {291,0.03801818}, {292,0.03783636}, {293,0.03802727}, {294,0.03817273}, {295,0.03806364}, {296,0.03855455}, {297,0.03961818}, {298,0.03847273}, {299,0.04046364}, {300,0.03894545}, {301,0.04106364}, {302,0.03913636}, {303,0.03949091}, {304,0.03942727}, {305,0.03974545}, {306,0.03998182}, {307,0.04003636}, {308,0.04162727}, {309,0.04037273}, {310,0.04227273}, {311,0.04060909}, {312,0.04270909}, {313,0.04090000}, {314,0.04318182}, {315,0.04160000}, {316,0.04348182}, {317,0.04187273}, {318,0.04401818}, {319,0.04216364}, {320,0.04441818}, {321,0.04212727}, {322,0.04466364}, {323,0.04299091}, {324,0.04510000}, {325,0.04313636}, {326,0.04337273}, {327,0.04350909}, {328,0.04380000}, {329,0.04378182}, {330,0.04378182}, {331,0.04419091}, {332,0.04460909}, {333,0.04435455}, {334,0.04727273}, {335,0.04504545}, {336,0.04719091}, {337,0.04612727}, {338,0.04744545}, {339,0.04547273}, {340,0.04807273}, {341,0.04606364}, {342,0.04836364}, {343,0.04649091}, {344,0.04853636}, {345,0.04684545}, {346,0.04864545}, {347,0.04683636}, {348,0.04849091}, {349,0.04779091}, {350,0.04901818}, {351,0.04772727}, {352,0.04781818}, {353,0.04819091}, {354,0.04828182}, {355,0.05032727}, {356,0.04830909}, {357,0.05013636}, {358,0.04854545}, {359,0.05034545}, {360,0.04899091}, {361,0.05031818}, {362,0.04947273}, {363,0.05050000}, {364,0.04967273}, {365,0.04996364}, {366,0.05206364}, {367,0.04997273}, {368,0.05203636}, {369,0.05033636}, {370,0.05196364}, {371,0.05055455}, {372,0.05072727}, {373,0.05087273}, {374,0.05122727}, {375,0.05336364}, {376,0.05165455}, {377,0.05336364}, {378,0.05170909}, {379,0.05327273}, {380,0.05227273}, {381,0.05225455}, {382,0.05480909}, {383,0.05270909}, {384,0.05457273}, {385,0.05293636}, {386,0.05313636}, {387,0.05586364}, {388,0.05315455}, {389,0.05546364}, {390,0.05387273}, {391,0.05576364}, {392,0.05754545}, {393,0.05511818}, {394,0.05718182}, {395,0.05490000}, {396,0.05679091}, {397,0.05518182}, {398,0.05520909}, {399,0.05775455}, {400,0.05581818}, {401,0.05878182}, {402,0.05870000}, {403,0.05619091}, {404,0.05898182}, {405,0.05676364}, {406,0.05710909}, {407,0.05992727}, {408,0.05742727}, {409,0.05905455}, {410,0.05735455}, {411,0.05746364}, {412,0.06096364}, {413,0.05871818}, {414,0.05849091}, {415,0.06094545}, {416,0.05915455}, {417,0.06054545}, {418,0.05949091}, {419,0.05940909}, {420,0.06124545}, {421,0.05987273}, {422,0.06006364}, {423,0.06230909}, {424,0.06052727}, {425,0.06075455}, {426,0.06263636}, {427,0.06078182}, {428,0.06223636}, {429,0.06360000}, {430,0.06122727}, {431,0.06262727}, {432,0.06433636}, {433,0.06176364}, {434,0.06317273}, {435,0.06225455}, {436,0.06230000}, {437,0.06393636}, {438,0.06256364}, {439,0.06264545}, {440,0.06461818}, {441,0.06323636}, {442,0.06303636}, {443,0.06519091}, {444,0.06344545}, {445,0.06368182}, {446,0.06567273}, {447,0.06721818}, {448,0.06420909}, {449,0.06590909}, {450,0.06774545}, {451,0.06513636}, {452,0.06692727}, {453,0.06820000}, {454,0.06530000}, {455,0.06700000}, {456,0.06865455}, {457,0.06620000}, {458,0.06641818}, {459,0.06845455}, {460,0.06692727}, {461,0.06685455}, {462,0.06874545}, {463,0.07050000}, {464,0.06730000}, {465,0.06918182}, {466,0.07078182}, {467,0.06815455}, {468,0.06866364}, {469,0.07060909}, {470,0.06896364}, {471,0.06918182}, {472,0.07616364}, {473,0.07219091}, {474,0.06921818}, {475,0.06988182}, {476,0.07190000}, {477,0.07294545}, {478,0.07023636}, {479,0.07167273}, {480,0.07307273}, {481,0.07073636}, {482,0.07130909}, {483,0.07277273}, {484,0.07416364}, {485,0.07178182}, {486,0.07190909}, {487,0.07406364}, {488,0.07466364}, {489,0.07254545}, {490,0.07261818}, {491,0.07444545}, {492,0.07550000}, {493,0.07299091}, {494,0.07432727}, {495,0.07575455}, {496,0.07619091}, {497,0.07364545}, {498,0.07477273}, {499,0.07660000}, {500,0.07750909}, {505,0.07514545}, {510,0.07607273}, {515,0.07919091}, {520,0.08114545}, {525,0.07923636}, {530,0.08040909}, {535,0.08338182}, {540,0.08464545}, {545,0.08612727}, {550,0.08724545}, {555,0.08537273}, {560,0.08625455}, {565,0.08811818}, {570,0.09024545}, {575,0.09202727}, {580,0.09406364}, {585,0.09491818}, {590,0.09258182}, {595,0.09411818}, {600,0.09479091}, {605,0.09589091}, {610,0.09791818}, {615,0.09974545}, {620,0.10114545}, {625,0.10219091}, {630,0.10353636}, {635,0.10491818}, {640,0.10628182}, {645,0.10769091}, {650,0.10849091}, {655,0.10932727}, {660,0.11077273}, {665,0.11163636}, {670,0.11307273}, {675,0.11369091}, {680,0.11443636}, {685,0.11550000}, {690,0.11711818}, {695,0.11873636}, {700,0.11934545}, {705,0.12055455}, {710,0.12139091}, {715,0.12208182}, {720,0.12309091}, {725,0.12279091}, {730,0.12356364}, {735,0.12941818}, {740,0.12950909}, {745,0.13004545}, {750,0.13086364}, {755,0.13162727}, {760,0.13332727}, {765,0.13188182}, {770,0.13250909}, {775,0.13780909}, {780,0.13776364}, {785,0.13892727}, {790,0.13968182}, {795,0.13863636}, {800,0.14558182}, {805,0.14440909}, {810,0.14549091}, {815,0.14592727}, {820,0.14834545}, {825,0.14945455}, {830,0.15035455}, {835,0.15042727}, {840,0.15274545}, {845,0.15466364}, {850,0.15510000}, {855,0.15569091}, {860,0.15957273}, {865,0.15943636}, {870,0.15943636}, {875,0.16169091}, {880,0.16327273}, {885,0.16385455}, {890,0.16611818}, {895,0.16743636}, {900,0.16764545}, {905,0.17071818}, {910,0.17058182}, {915,0.17096364}, {920,0.17487273}, {925,0.17475455}, {930,0.17684545}, {935,0.17800909}, {940,0.17789091}, {945,0.18124545}, {950,0.18099091}, {955,0.18300909}, {960,0.18411818}, {965,0.18653636}, {970,0.18687273}, {975,0.18871818}, {980,0.18998182}, {985,0.19358182}, {990,0.19299091}, {995,0.19585455}, {1000,0.19563636}, {1010,0.19995455}, {1020,0.20128182}, {1030,0.20419091}, {1040,0.20654545}, {1050,0.20974545}, {1060,0.21162727}, {1070,0.21723636}, {1080,0.21978182}, {1090,0.22047273}, {1100,0.22384545}, {1110,0.22878182}, {1120,0.22989091}, {1130,0.23248182}, {1140,0.23773636}, {1150,0.23847273}, {1160,0.24253636}, {1170,0.24494545}, {1180,0.24958182}, {1190,0.25105455}, {1200,0.25476364}, {1210,0.25769091}, {1220,0.25971818}, {1230,0.26443636}, {1240,0.26867273}, {1250,0.27237273}, {1260,0.27337273}, {1270,0.27690000}, {1280,0.28175455}, {1290,0.28352727}, {1300,0.28469091}, {1310,0.28927273}, {1320,0.29160000}, {1330,0.29554545}, {1340,0.29862727}, {1350,0.30204545}, {1360,0.30480000}, {1370,0.30970909}, {1380,0.31318182}, {1390,0.31643636}, {1400,0.32292727}, {1410,0.32540000}, {1420,0.32838182}, {1430,0.33104545}, {1440,0.33269091}, {1450,0.33673636}, {1460,0.34451818}, {1470,0.34608182}, {1480,0.34850909}, {1490,0.34960909}, {1500,0.35431818}, {1510,0.36162727}, {1520,0.36360000}, {1530,0.36601818}, {1540,0.37323636}, {1550,0.37595455}, {1560,0.37592727}, {1570,0.38339091}, {1580,0.38460000}, {1590,0.38693636}, {1600,0.39439091}, {1610,0.39529091}, {1620,0.40248182}, {1630,0.40391818}, {1640,0.40698182}, {1650,0.41162727}, {1660,0.41674545}, {1670,0.41937273}, {1680,0.42340909}, {1690,0.42767273}, {1700,0.43330909}, {1710,0.43392727}, {1720,0.44318182}, {1730,0.44120909}, {1740,0.44820909}, {1750,0.45200909}, {1760,0.45370000}, {1770,0.46062727}, {1780,0.46411818}, {1790,0.46608182}, {1800,0.47234545}, {1810,0.47551818}, {1820,0.48010909}, {1830,0.48804545}, {1840,0.48962727}, {1850,0.49313636}, {1860,0.49802727}, {1870,0.49883636}, {1880,0.50617273}, {1890,0.51087273}, {1900,0.51699091}, {1910,0.51840909}, {1920,0.52397273}, {1930,0.52826364}, {1940,0.53220000}, {1950,0.53742727}, {1960,0.53946364}, {1970,0.54476364}, {1980,0.55038182}, {1990,0.55355455}, {2000,0.55742727}, {2050,0.58086364}, {2100,0.60644545}, {2150,0.62706364}, {2200,0.65042727}, {2250,0.67774545}, {2300,0.69961818}, {2350,0.72821818}, {2400,0.74969091}, {2450,0.78017273}, {2500,0.80323636}, {2550,0.82809091}, {2600,0.85475455}, {2650,0.88321818}, {2700,0.91190909}, {2750,0.93705455}, {2800,0.98065455}, {2850,0.99494545}, {2900,1.02541818}, {2950,1.05792727}, {3000,1.08309091}, {3050,1.11325}, {3100,1.14450}, {3150,1.17600}, {3200,1.20650}, {3250,1.23775}, {3300,1.27125}, {3350,1.30350}, {3400,1.33950}, {3450,1.37975}, {3500,1.41325}, {3550,1.44900}, {3600,1.48600}, {3650,1.51725}, {3700,1.56200}, {3750,1.59000}, {3800,1.62250}, {3850,1.67400}, {3900,1.70125}, {3950,1.76150}, {4000,1.77700}, {4050,1.81900}, {4100,1.87225}, {4150,1.90150}, {4200,1.96150}, {4250,1.98350}, {4300,2.05375}, {4350,2.06375}, {4400,2.10875}, {4450,2.15125}, {4500,2.20800}, {4550,2.28500}, {4600,2.30650}, {4650,2.34650}, {4700,2.38425}, {4750,2.44500}, {4800,2.49775}, {4850,2.70150}, {4900,2.58950}, {4950,2.66250}, {5000,2.70100}, {5050,2.74250}, {5100,2.82450}, {5150,2.84350}, {5200,2.90875}, {5250,2.97275}, {5300,3.02450}, {5350,3.05775}, {5400,3.14275}, {5450,3.17400}, {5500,3.28300}, {5550,3.35150}, {5600,3.36250}, {5650,4.01525}, {5700,3.49725}, {5750,3.66175}, {5800,3.63300}, {5850,4.32475}, {5900,3.73525}, {5950,3.83825}, {6000,3.88425}, {6050,3.97550}, {6100,4.08250}, {6150,4.16975}, {6200,4.49350}, {6250,4.30325}, {6300,4.24450}, {6350,4.39350}, {6400,4.32150}, {6450,4.50975}, {6500,4.62225}, {6550,4.79775}, {6600,4.76750}, {6650,4.84275}, {6700,5.96350}, {6750,5.06725}, {6800,5.93700}, {6850,6.14975}, {6900,5.30950}, {6950,5.45850}, {7000,6.60675}, {7050,5.43175}, {7100,5.66250}, {7150,8.14450}, {7200,6.02125}, {7250,6.15475}, {7300,7.94475}, {7350,6.16425}, {7400,6.48725}, {7450,7.58900}, {7500,6.65625}, {7550,6.71650}, {7600,7.63975}, {7650,6.73025}, {7700,6.95125}, {7750,8.70700}, {7800,6.94400}, {7850,7.25125}, {7900,7.55250}, {7950,7.49225}, {8000,7.72575}, {8050,7.67500}, {8100,7.74350}, {8150,8.93075}, {8200,7.85450}, {8250,8.19950}, {8300,8.68125}, {8350,7.68175}, {8400,8.01775}, {8450,8.17250}, {8500,7.98850}, {8550,10.81050}, {8600,8.12925}, {8650,8.15250}, {8700,8.55050}, {8750,8.52850}, {8800,9.47900}, {8850,8.63400}, {8900,8.89925}, {8950,9.19150}, {9000,9.18550}, {9050,12.38150}, {9100,9.33725}, {9150,9.33075}, {9200,10.35475}, {9250,9.51675}, {9300,11.55375}, {9350,9.98400}, {9400,13.76350}, {9450,10.23750}, {9500,10.11350}, {9550,10.50775}, {9600,10.67550}, {9650,13.82550}, {9700,12.34550}, {9750,12.69450}, {9800,11.08750}, {9850,11.29625}, {9900,11.88550}, {9950,11.43225}, {10000,11.59250}, {10100,10.5055}, {10200,10.6895}, {10300,10.8475}, {10400,16.748}, {10500,11.488}, {10600,13.644}, {10700,12.491}, {10800,12.976}, {10900,12.279}, {11000,13.668}, {11100,12.872}, {11200,13.14}, {11300,19.943}, {11400,13.467}, {11500,14.456}, {11600,14.115}, {11700,15.487}, {11800,15.388}, {11900,14.576}, {12000,17.163}, {12100,15.971}, {12200,17.331}, {12300,16.94}, {12400,17.271}, {12500,18.644}, {12600,21.9}, {12700,17.948}, {12800,21.799}, {12900,18.131}, {13000,20.051}, {13100,27.24}, {13200,21.839}, {13300,20.648}, {13400,30.807}, {13500,21.476}, {13600,21.951}, {13700,20.171}, {13800,22.331}, {13900,24.08}, {14000,21.648}, {14100,24.916}, {14200,24.251}, {14300,23.731}, {14400,24.96}, {14500,25.568}, {14600,24.887}, {14700,23.019}, {14800,28.092}, {14900,27.224}, {15000,27.98}, {15100,28.139}, {15200,26.672}, {15300,28.443}, {15400,26.536}, {15500,28.755}, {15600,30.427}, {15700,29.811}, {15800,30.12}, {15900,29.975}, {16000,29.811}, {16100,30.339}, {16200,32.935}, {16300,27.703}, {16400,33.604}, {16500,33.708}, {16600,35.743}, {16700,34.223}, {16800,34.444}, {16900,35.528}, {17000,35.608}, {17100,35.776}, {17200,37.359}, {17300,33.112}, {17400,38.463}, {17500,51.887}, {17600,50.756}, {17700,37.787}, {17800,38.963}, {17900,36.132}, {18000,39.56}, {18100,42.768}, {18200,41.163}, {18300,40.899}, {18400,41.807}, {18500,44.539}, {18600,40.231}, {18700,39.119}, {18800,43.159}, {18900,44.871}, {19000,43.663}, {19100,52.404}, {19200,63.819}, {19300,65.763}, {19400,47.891}, {19500,47.84}, {19600,46.059}, {19700,44.136}, {19800,42.744}, {19900,50.14}};
data["big"]["simpl Denote"]["Stats"]["system"] = {{1,0.00000000}, {2,0.00003636}, {3,0.00000000}, {4,0.00000000}, {5,0.00003636}, {6,0.00003636}, {7,0.00003636}, {8,0.00003636}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00003636}, {14,0.00003636}, {15,0.00000000}, {16,0.00007273}, {17,0.00003636}, {18,0.00003636}, {19,0.00000000}, {20,0.00006364}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00003636}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00006364}, {32,0.00010000}, {33,0.00003636}, {34,0.00000000}, {35,0.00007273}, {36,0.00000000}, {37,0.00003636}, {38,0.00007273}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00003636}, {43,0.00000000}, {44,0.00003636}, {45,0.00000000}, {46,0.00007273}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00003636}, {52,0.00000000}, {53,0.00000000}, {54,0.00007273}, {55,0.00000000}, {56,0.00000000}, {57,0.00003636}, {58,0.00003636}, {59,0.00003636}, {60,0.00000000}, {61,0.00000000}, {62,0.00003636}, {63,0.00002727}, {64,0.00000000}, {65,0.00003636}, {66,0.00000000}, {67,0.00007273}, {68,0.00002727}, {69,0.00002727}, {70,0.00000000}, {71,0.00007273}, {72,0.00000000}, {73,0.00003636}, {74,0.00003636}, {75,0.00003636}, {76,0.00002727}, {77,0.00003636}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00003636}, {82,0.00000000}, {83,0.00003636}, {84,0.00003636}, {85,0.00003636}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00003636}, {91,0.00003636}, {92,0.00007273}, {93,0.00002727}, {94,0.00002727}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00002727}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003636}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00003636}, {111,0.00003636}, {112,0.00007273}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00007273}, {120,0.00000000}, {121,0.00000000}, {122,0.00010909}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00007273}, {127,0.00014545}, {128,0.00000000}, {129,0.00003636}, {130,0.00000000}, {131,0.00000000}, {132,0.00003636}, {133,0.00003636}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00003636}, {138,0.00003636}, {139,0.00000000}, {140,0.00007273}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00003636}, {147,0.00000000}, {148,0.00010909}, {149,0.00003636}, {150,0.00003636}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00002727}, {155,0.00003636}, {156,0.00003636}, {157,0.00003636}, {158,0.00000000}, {159,0.00003636}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00003636}, {164,0.00000000}, {165,0.00000000}, {166,0.00003636}, {167,0.00003636}, {168,0.00003636}, {169,0.00000000}, {170,0.00003636}, {171,0.00007273}, {172,0.00003636}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00002727}, {179,0.00000000}, {180,0.00003636}, {181,0.00003636}, {182,0.00000000}, {183,0.00000000}, {184,0.00003636}, {185,0.00000000}, {186,0.00003636}, {187,0.00000000}, {188,0.00000000}, {189,0.00007273}, {190,0.00003636}, {191,0.00000000}, {192,0.00003636}, {193,0.00000000}, {194,0.00000000}, {195,0.00007273}, {196,0.00003636}, {197,0.00000000}, {198,0.00003636}, {199,0.00010909}, {200,0.00000000}, {201,0.00003636}, {202,0.00003636}, {203,0.00000000}, {204,0.00000000}, {205,0.00010909}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00010909}, {214,0.00003636}, {215,0.00003636}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00010000}, {224,0.00007273}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00003636}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00003636}, {235,0.00017273}, {236,0.00000000}, {237,0.00000000}, {238,0.00003636}, {239,0.00000000}, {240,0.00000000}, {241,0.00007273}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00003636}, {247,0.00000000}, {248,0.00007273}, {249,0.00003636}, {250,0.00000000}, {251,0.00003636}, {252,0.00003636}, {253,0.00000000}, {254,0.00010909}, {255,0.00002727}, {256,0.00000000}, {257,0.00000000}, {258,0.00003636}, {259,0.00003636}, {260,0.00000000}, {261,0.00002727}, {262,0.00000000}, {263,0.00003636}, {264,0.00010000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00002727}, {269,0.00002727}, {270,0.00000000}, {271,0.00003636}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00010000}, {277,0.00002727}, {278,0.00000000}, {279,0.00003636}, {280,0.00000000}, {281,0.00010909}, {282,0.00003636}, {283,0.00007273}, {284,0.00000000}, {285,0.00000000}, {286,0.00002727}, {287,0.00000000}, {288,0.00010909}, {289,0.00003636}, {290,0.00010909}, {291,0.00000000}, {292,0.00007273}, {293,0.00000000}, {294,0.00000000}, {295,0.00003636}, {296,0.00000000}, {297,0.00000000}, {298,0.00003636}, {299,0.00010909}, {300,0.00000000}, {301,0.00007273}, {302,0.00002727}, {303,0.00007273}, {304,0.00003636}, {305,0.00003636}, {306,0.00000000}, {307,0.00000000}, {308,0.00010000}, {309,0.00000000}, {310,0.00007273}, {311,0.00003636}, {312,0.00003636}, {313,0.00007273}, {314,0.00003636}, {315,0.00003636}, {316,0.00010909}, {317,0.00010909}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00010909}, {323,0.00006364}, {324,0.00003636}, {325,0.00003636}, {326,0.00003636}, {327,0.00003636}, {328,0.00003636}, {329,0.00000000}, {330,0.00002727}, {331,0.00003636}, {332,0.00000000}, {333,0.00003636}, {334,0.00007273}, {335,0.00007273}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00003636}, {340,0.00003636}, {341,0.00000000}, {342,0.00000000}, {343,0.00003636}, {344,0.00003636}, {345,0.00003636}, {346,0.00003636}, {347,0.00007273}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00010000}, {354,0.00000000}, {355,0.00000000}, {356,0.00007273}, {357,0.00003636}, {358,0.00000000}, {359,0.00003636}, {360,0.00000000}, {361,0.00006364}, {362,0.00000000}, {363,0.00003636}, {364,0.00000000}, {365,0.00003636}, {366,0.00007273}, {367,0.00000000}, {368,0.00003636}, {369,0.00000000}, {370,0.00007273}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00006364}, {379,0.00007273}, {380,0.00000000}, {381,0.00003636}, {382,0.00000000}, {383,0.00010000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00007273}, {388,0.00007273}, {389,0.00007273}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00003636}, {394,0.00000000}, {395,0.00000000}, {396,0.00003636}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00003636}, {401,0.00000000}, {402,0.00007273}, {403,0.00003636}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00007273}, {408,0.00003636}, {409,0.00000000}, {410,0.00003636}, {411,0.00007273}, {412,0.00010000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00003636}, {418,0.00000000}, {419,0.00007273}, {420,0.00000000}, {421,0.00003636}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00003636}, {426,0.00000000}, {427,0.00003636}, {428,0.00007273}, {429,0.00003636}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00003636}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00003636}, {440,0.00003636}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00006364}, {445,0.00000000}, {446,0.00000000}, {447,0.00003636}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00003636}, {455,0.00000000}, {456,0.00003636}, {457,0.00003636}, {458,0.00000000}, {459,0.00003636}, {460,0.00000000}, {461,0.00010909}, {462,0.00003636}, {463,0.00000000}, {464,0.00003636}, {465,0.00007273}, {466,0.00000000}, {467,0.00003636}, {468,0.00003636}, {469,0.00000000}, {470,0.00000000}, {471,0.00003636}, {472,0.00003636}, {473,0.00014545}, {474,0.00003636}, {475,0.00006364}, {476,0.00007273}, {477,0.00014545}, {478,0.00003636}, {479,0.00007273}, {480,0.00006364}, {481,0.00003636}, {482,0.00000000}, {483,0.00007273}, {484,0.00014545}, {485,0.00000000}, {486,0.00000000}, {487,0.00003636}, {488,0.00003636}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00007273}, {493,0.00003636}, {494,0.00003636}, {495,0.00003636}, {496,0.00007273}, {497,0.00003636}, {498,0.00014545}, {499,0.00003636}, {500,0.00010909}, {505,0.00000000}, {510,0.00003636}, {515,0.00000000}, {520,0.00014545}, {525,0.00003636}, {530,0.00003636}, {535,0.00007273}, {540,0.00007273}, {545,0.00013636}, {550,0.00006364}, {555,0.00000000}, {560,0.00000000}, {565,0.00003636}, {570,0.00007273}, {575,0.00010909}, {580,0.00000000}, {585,0.00014545}, {590,0.00000000}, {595,0.00000000}, {600,0.00007273}, {605,0.00000000}, {610,0.00014545}, {615,0.00007273}, {620,0.00006364}, {625,0.00003636}, {630,0.00010909}, {635,0.00010909}, {640,0.00007273}, {645,0.00003636}, {650,0.00007273}, {655,0.00003636}, {660,0.00002727}, {665,0.00018182}, {670,0.00007273}, {675,0.00010909}, {680,0.00018182}, {685,0.00017273}, {690,0.00010909}, {695,0.00003636}, {700,0.00014545}, {705,0.00003636}, {710,0.00007273}, {715,0.00007273}, {720,0.00003636}, {725,0.00000000}, {730,0.00000000}, {735,0.00017273}, {740,0.00010909}, {745,0.00007273}, {750,0.00018182}, {755,0.00014545}, {760,0.00007273}, {765,0.00003636}, {770,0.00007273}, {775,0.00010000}, {780,0.00032727}, {785,0.00018182}, {790,0.00000000}, {795,0.00000000}, {800,0.00007273}, {805,0.00009091}, {810,0.00010000}, {815,0.00003636}, {820,0.00000000}, {825,0.00007273}, {830,0.00007273}, {835,0.00014545}, {840,0.00007273}, {845,0.00003636}, {850,0.00010909}, {855,0.00010909}, {860,0.00003636}, {865,0.00000000}, {870,0.00021818}, {875,0.00000000}, {880,0.00007273}, {885,0.00010909}, {890,0.00007273}, {895,0.00010000}, {900,0.00010909}, {905,0.00007273}, {910,0.00018182}, {915,0.00006364}, {920,0.00021818}, {925,0.00000000}, {930,0.00010909}, {935,0.00007273}, {940,0.00003636}, {945,0.00006364}, {950,0.00014545}, {955,0.00000000}, {960,0.00003636}, {965,0.00017273}, {970,0.00003636}, {975,0.00010909}, {980,0.00007273}, {985,0.00020000}, {990,0.00007273}, {995,0.00007273}, {1000,0.00017273}, {1010,0.00003636}, {1020,0.00007273}, {1030,0.00006364}, {1040,0.00007273}, {1050,0.00007273}, {1060,0.00014545}, {1070,0.00014545}, {1080,0.00017273}, {1090,0.00025455}, {1100,0.00010909}, {1110,0.00024545}, {1120,0.00006364}, {1130,0.00014545}, {1140,0.00007273}, {1150,0.00014545}, {1160,0.00020909}, {1170,0.00018182}, {1180,0.00019091}, {1190,0.00003636}, {1200,0.00007273}, {1210,0.00018182}, {1220,0.00010909}, {1230,0.00003636}, {1240,0.00020909}, {1250,0.00010909}, {1260,0.00017273}, {1270,0.00013636}, {1280,0.00013636}, {1290,0.00014545}, {1300,0.00003636}, {1310,0.00000000}, {1320,0.00021818}, {1330,0.00010000}, {1340,0.00003636}, {1350,0.00006364}, {1360,0.00010909}, {1370,0.00010000}, {1380,0.00006364}, {1390,0.00029091}, {1400,0.00007273}, {1410,0.00013636}, {1420,0.00014545}, {1430,0.00014545}, {1440,0.00003636}, {1450,0.00010909}, {1460,0.00007273}, {1470,0.00014545}, {1480,0.00021818}, {1490,0.00013636}, {1500,0.00000000}, {1510,0.00031818}, {1520,0.00007273}, {1530,0.00021818}, {1540,0.00025455}, {1550,0.00018182}, {1560,0.00010909}, {1570,0.00010909}, {1580,0.00014545}, {1590,0.00006364}, {1600,0.00026364}, {1610,0.00007273}, {1620,0.00027273}, {1630,0.00017273}, {1640,0.00034545}, {1650,0.00024545}, {1660,0.00010909}, {1670,0.00025455}, {1680,0.00006364}, {1690,0.00014545}, {1700,0.00018182}, {1710,0.00010909}, {1720,0.00025455}, {1730,0.00018182}, {1740,0.00018182}, {1750,0.00017273}, {1760,0.00006364}, {1770,0.00016364}, {1780,0.00000000}, {1790,0.00007273}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00007273}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00010909}, {1860,0.00007273}, {1870,0.00014545}, {1880,0.00003636}, {1890,0.00003636}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00007273}, {1930,0.00003636}, {1940,0.00000000}, {1950,0.00003636}, {1960,0.00014545}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00003636}, {2050,0.00005455}, {2100,0.00013636}, {2150,0.00003636}, {2200,0.00003636}, {2250,0.00003636}, {2300,0.00003636}, {2350,0.00010909}, {2400,0.00003636}, {2450,0.00000000}, {2500,0.00010909}, {2550,0.00000000}, {2600,0.00006364}, {2650,0.00010000}, {2700,0.00003636}, {2750,0.00003636}, {2800,0.00000000}, {2850,0.00007273}, {2900,0.00006364}, {2950,0.00014545}, {3000,0.00007273}, {3050,0.00000}, {3100,0.00000}, {3150,0.00000}, {3200,0.00100}, {3250,0.00000}, {3300,0.00000}, {3350,0.00000}, {3400,0.00100}, {3450,0.00000}, {3500,0.00000}, {3550,0.00000}, {3600,0.00000}, {3650,0.00000}, {3700,0.00000}, {3750,0.00100}, {3800,0.00000}, {3850,0.00000}, {3900,0.00000}, {3950,0.00000}, {4000,0.00000}, {4050,0.00000}, {4100,0.00000}, {4150,0.00000}, {4200,0.00000}, {4250,0.00175}, {4300,0.00000}, {4350,0.00100}, {4400,0.00000}, {4450,0.00000}, {4500,0.00100}, {4550,0.00000}, {4600,0.00000}, {4650,0.00100}, {4700,0.00000}, {4750,0.00000}, {4800,0.00000}, {4850,0.00000}, {4900,0.00000}, {4950,0.00000}, {5000,0.00000}, {5050,0.00100}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00100}, {5300,0.00100}, {5350,0.00000}, {5400,0.00000}, {5450,0.00100}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00100}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00200}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00100}, {6900,0.00000}, {6950,0.00100}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00500}, {7200,0.00100}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00100}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00200}, {8500,0.00000}, {8550,0.00100}, {8600,0.00200}, {8650,0.00100}, {8700,0.00000}, {8750,0.00300}, {8800,0.00100}, {8850,0.00000}, {8900,0.00100}, {8950,0.00000}, {9000,0.00100}, {9050,0.00100}, {9100,0.00000}, {9150,0.00200}, {9200,0.00000}, {9250,0.00000}, {9300,0.00200}, {9350,0.00200}, {9400,0.00000}, {9450,0.00000}, {9500,0.00200}, {9550,0.00200}, {9600,0.00000}, {9650,0.00000}, {9700,0.00300}, {9750,0.00100}, {9800,0.00100}, {9850,0.00100}, {9900,0.00100}, {9950,0.00300}, {10000,0.00100}, {10100,0.0020}, {10200,0.0020}, {10300,0.0000}, {10400,0}, {10500,0}, {10600,0.004}, {10700,0}, {10800,0}, {10900,0}, {11000,0}, {11100,0}, {11200,0}, {11300,0}, {11400,0.004}, {11500,0.004}, {11600,0}, {11700,0}, {11800,0}, {11900,0}, {12000,0}, {12100,0}, {12200,0}, {12300,0.004}, {12400,0}, {12500,0.003}, {12600,0}, {12700,0}, {12800,0}, {12900,0}, {13000,0.004}, {13100,0}, {13200,0}, {13300,0}, {13400,0}, {13500,0}, {13600,0}, {13700,0}, {13800,0}, {13900,0}, {14000,0}, {14100,0}, {14200,0}, {14300,0}, {14400,0}, {14500,0}, {14600,0}, {14700,0}, {14800,0}, {14900,0}, {15000,0}, {15100,0}, {15200,0}, {15300,0}, {15400,0}, {15500,0}, {15600,0}, {15700,0}, {15800,0}, {15900,0}, {16000,0}, {16100,0}, {16200,0}, {16300,0}, {16400,0}, {16500,0}, {16600,0}, {16700,0}, {16800,0}, {16900,0}, {17000,0}, {17100,0}, {17200,0}, {17300,0}, {17400,0}, {17500,0}, {17600,0}, {17700,0}, {17800,0}, {17900,0}, {18000,0}, {18100,0}, {18200,0}, {18300,0}, {18400,0}, {18500,0}, {18600,0}, {18700,0}, {18800,0}, {18900,0}, {19000,0}, {19100,0}, {19200,0}, {19300,0}, {19400,0}, {19500,0}, {19600,0}, {19700,0}, {19800,0}, {19900,0}};
data["big"]["transitivity"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00001818}, {45,0.00001818}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000909}, {66,0.00000000}, {67,0.00000909}, {68,0.00000909}, {69,0.00001818}, {70,0.00001818}, {71,0.00004545}, {72,0.00016364}, {73,0.00024545}, {74,0.00036364}, {75,0.00045455}, {76,0.00063636}, {77,0.00068182}, {78,0.00080000}, {79,0.00087273}, {80,0.00090909}, {81,0.00094545}, {82,0.00098182}, {83,0.00099091}, {84,0.00100000}, {85,0.00100000}, {86,0.00100000}, {87,0.00100000}, {88,0.00100000}, {89,0.00100000}, {90,0.00100000}, {91,0.00100000}, {92,0.00100000}, {93,0.00100000}, {94,0.00100000}, {95,0.00100000}, {96,0.00100000}, {97,0.00100000}, {98,0.00100000}, {99,0.00100000}, {100,0.00100000}, {101,0.00100000}, {102,0.00100000}, {103,0.00100000}, {104,0.00100000}, {105,0.00100000}, {106,0.00100000}, {107,0.00100000}, {108,0.00100000}, {109,0.00100000}, {110,0.00100000}, {111,0.00100000}, {112,0.00100000}, {113,0.00100000}, {114,0.00100000}, {115,0.00100000}, {116,0.00100000}, {117,0.00100000}, {118,0.00100000}, {119,0.00100000}, {120,0.00100000}, {121,0.00100000}, {122,0.00100000}, {123,0.00100000}, {124,0.00100000}, {125,0.00101818}, {126,0.00100000}, {127,0.00100000}, {128,0.00100000}, {129,0.00100000}, {130,0.00100000}, {131,0.00100000}, {132,0.00100000}, {133,0.00100000}, {134,0.00100000}, {135,0.00100000}, {136,0.00100000}, {137,0.00100000}, {138,0.00100000}, {139,0.00100000}, {140,0.00100000}, {141,0.00100000}, {142,0.00100909}, {143,0.00100000}, {144,0.00100000}, {145,0.00100000}, {146,0.00100909}, {147,0.00100000}, {148,0.00100000}, {149,0.00100000}, {150,0.00100000}, {151,0.00100000}, {152,0.00100000}, {153,0.00100000}, {154,0.00100909}, {155,0.00100000}, {156,0.00100909}, {157,0.00100909}, {158,0.00100000}, {159,0.00100000}, {160,0.00100000}, {161,0.00100000}, {162,0.00100000}, {163,0.00100909}, {164,0.00100000}, {165,0.00100909}, {166,0.00100000}, {167,0.00101818}, {168,0.00100909}, {169,0.00100909}, {170,0.00100909}, {171,0.00101818}, {172,0.00101818}, {173,0.00104545}, {174,0.00102727}, {175,0.00103636}, {176,0.00108182}, {177,0.00110000}, {178,0.00114545}, {179,0.00121818}, {180,0.00132727}, {181,0.00130909}, {182,0.00147273}, {183,0.00154545}, {184,0.00157273}, {185,0.00160000}, {186,0.00167273}, {187,0.00172727}, {188,0.00171818}, {189,0.00176364}, {190,0.00182727}, {191,0.00182727}, {192,0.00266364}, {193,0.00190909}, {194,0.00192727}, {195,0.00198182}, {196,0.00198182}, {197,0.00200000}, {198,0.00200000}, {199,0.00200000}, {200,0.00200000}, {201,0.00200000}, {202,0.00200000}, {203,0.00200000}, {204,0.00200000}, {205,0.00200000}, {206,0.00200000}, {207,0.00200000}, {208,0.00200000}, {209,0.00200000}, {210,0.00200000}, {211,0.00200000}, {212,0.00200000}, {213,0.00200000}, {214,0.00200000}, {215,0.00200000}, {216,0.00200000}, {217,0.00200000}, {218,0.00200000}, {219,0.00200000}, {220,0.00200000}, {221,0.00200000}, {222,0.00200000}, {223,0.00200000}, {224,0.00200000}, {225,0.00200000}, {226,0.00200000}, {227,0.00200000}, {228,0.00200000}, {229,0.00200000}, {230,0.00200000}, {231,0.00200909}, {232,0.00298182}, {233,0.00200000}, {234,0.00200000}, {235,0.00200000}, {236,0.00200000}, {237,0.00201818}, {238,0.00200000}, {239,0.00200000}, {240,0.00200000}, {241,0.00200000}, {242,0.00200000}, {243,0.00299091}, {244,0.00200000}, {245,0.00200000}, {246,0.00200000}, {247,0.00200000}, {248,0.00200000}, {249,0.00200000}, {250,0.00200000}, {251,0.00200000}, {252,0.00200000}, {253,0.00201818}, {254,0.00200000}, {255,0.00200000}, {256,0.00200000}, {257,0.00201818}, {258,0.00200909}, {259,0.00200909}, {260,0.00200000}, {261,0.00200000}, {262,0.00200909}, {263,0.00200000}, {264,0.00200000}, {265,0.00201818}, {266,0.00200000}, {267,0.00200000}, {268,0.00200000}, {269,0.00201818}, {270,0.00201818}, {271,0.00390909}, {272,0.00200909}, {273,0.00200000}, {274,0.00200000}, {275,0.00200909}, {276,0.00200000}, {277,0.00201818}, {278,0.00200909}, {279,0.00202727}, {280,0.00206364}, {281,0.00201818}, {282,0.00205455}, {283,0.00210000}, {284,0.00217273}, {285,0.00215455}, {286,0.00217273}, {287,0.00229091}, {288,0.00221818}, {289,0.00239091}, {290,0.00239091}, {291,0.00244545}, {292,0.00366364}, {293,0.00250909}, {294,0.00257273}, {295,0.00262727}, {296,0.00267273}, {297,0.00261818}, {298,0.00266364}, {299,0.00267273}, {300,0.00271818}, {301,0.00270000}, {302,0.00277273}, {303,0.00398182}, {304,0.00280909}, {305,0.00289091}, {306,0.00287273}, {307,0.00294545}, {308,0.00294545}, {309,0.00298182}, {310,0.00295455}, {311,0.00297273}, {312,0.00298182}, {313,0.00298182}, {314,0.00297273}, {315,0.00298182}, {316,0.00298182}, {317,0.00298182}, {318,0.00298182}, {319,0.00298182}, {320,0.00300000}, {321,0.00300909}, {322,0.00300000}, {323,0.00300909}, {324,0.00299091}, {325,0.00300000}, {326,0.00398182}, {327,0.00300000}, {328,0.00400909}, {329,0.00300000}, {330,0.00408182}, {331,0.00300000}, {332,0.00400000}, {333,0.00300000}, {334,0.00300000}, {335,0.00300909}, {336,0.00300000}, {337,0.00300000}, {338,0.00300000}, {339,0.00300000}, {340,0.00300000}, {341,0.00300000}, {342,0.00300000}, {343,0.00300000}, {344,0.00300000}, {345,0.00300000}, {346,0.00300000}, {347,0.00300000}, {348,0.00300000}, {349,0.00300000}, {350,0.00300000}, {351,0.00301818}, {352,0.00300000}, {353,0.00300000}, {354,0.00300000}, {355,0.00300000}, {356,0.00300000}, {357,0.00300000}, {358,0.00300000}, {359,0.00300000}, {360,0.00300000}, {361,0.00300000}, {362,0.00300000}, {363,0.00300000}, {364,0.00300909}, {365,0.00300000}, {366,0.00300000}, {367,0.00300000}, {368,0.00300000}, {369,0.00300000}, {370,0.00301818}, {371,0.00301818}, {372,0.00300000}, {373,0.00453636}, {374,0.00305455}, {375,0.00301818}, {376,0.00301818}, {377,0.00303636}, {378,0.00301818}, {379,0.00300000}, {380,0.00491818}, {381,0.00302727}, {382,0.00302727}, {383,0.00303636}, {384,0.00301818}, {385,0.00306364}, {386,0.00301818}, {387,0.00301818}, {388,0.00309091}, {389,0.00301818}, {390,0.00309091}, {391,0.00307273}, {392,0.00331818}, {393,0.00338182}, {394,0.00328182}, {395,0.00321818}, {396,0.00326364}, {397,0.00489091}, {398,0.00330909}, {399,0.00333636}, {400,0.00340000}, {401,0.00360909}, {402,0.00340909}, {403,0.00353636}, {404,0.00346364}, {405,0.00350000}, {406,0.00347273}, {407,0.00356364}, {408,0.00356364}, {409,0.00359091}, {410,0.00498182}, {411,0.00365455}, {412,0.00359091}, {413,0.00365455}, {414,0.00364545}, {415,0.00363636}, {416,0.00375455}, {417,0.00370000}, {418,0.00496364}, {419,0.00378182}, {420,0.00373636}, {421,0.00383636}, {422,0.00383636}, {423,0.00382727}, {424,0.00387273}, {425,0.00389091}, {426,0.00388182}, {427,0.00393636}, {428,0.00390000}, {429,0.00392727}, {430,0.00393636}, {431,0.00390909}, {432,0.00393636}, {433,0.00394545}, {434,0.00393636}, {435,0.00509091}, {436,0.00394545}, {437,0.00394545}, {438,0.00512727}, {439,0.00395455}, {440,0.00394545}, {441,0.00525455}, {442,0.00398182}, {443,0.00397273}, {444,0.00541818}, {445,0.00400000}, {446,0.00398182}, {447,0.00400000}, {448,0.00401818}, {449,0.00400000}, {450,0.00400000}, {451,0.00400000}, {452,0.00400000}, {453,0.00400000}, {454,0.00401818}, {455,0.00401818}, {456,0.00400000}, {457,0.00401818}, {458,0.00400000}, {459,0.00400000}, {460,0.00690909}, {461,0.00400000}, {462,0.00400909}, {463,0.00401818}, {464,0.00404545}, {465,0.00400000}, {466,0.00400909}, {467,0.00400000}, {468,0.00400000}, {469,0.00403636}, {470,0.00575455}, {471,0.00400000}, {472,0.00400000}, {473,0.00400000}, {474,0.00402727}, {475,0.00400000}, {476,0.00400000}, {477,0.00401818}, {478,0.00407273}, {479,0.00400000}, {480,0.00400000}, {481,0.00401818}, {482,0.00400000}, {483,0.00405455}, {484,0.00400909}, {485,0.00402727}, {486,0.00402727}, {487,0.00401818}, {488,0.00405455}, {489,0.00405455}, {490,0.00400909}, {491,0.00401818}, {492,0.00402727}, {493,0.00406364}, {494,0.00403636}, {495,0.00408182}, {496,0.00404545}, {497,0.00415455}, {498,0.00410000}, {499,0.00410000}, {500,0.00412727}, {505,0.00432727}, {510,0.00441818}, {515,0.00450000}, {520,0.00452727}, {525,0.00463636}, {530,0.00473636}, {535,0.00477273}, {540,0.00490000}, {545,0.00498182}, {550,0.00498182}, {555,0.00498182}, {560,0.00499091}, {565,0.00500909}, {570,0.00500000}, {575,0.00502727}, {580,0.00500000}, {585,0.00501818}, {590,0.00504545}, {595,0.00508182}, {600,0.00514545}, {605,0.00515455}, {610,0.00524545}, {615,0.00531818}, {620,0.00549091}, {625,0.00551818}, {630,0.00555455}, {635,0.00563636}, {640,0.00570000}, {645,0.00574545}, {650,0.00589091}, {655,0.00591818}, {660,0.00598182}, {665,0.00598182}, {670,0.00600909}, {675,0.00602727}, {680,0.00600000}, {685,0.00604545}, {690,0.00610909}, {695,0.00610909}, {700,0.00616364}, {705,0.00622727}, {710,0.00628182}, {715,0.00634545}, {720,0.00648182}, {725,0.00650000}, {730,0.00953636}, {735,0.00662727}, {740,0.00667273}, {745,0.00668182}, {750,0.00672727}, {755,0.00674545}, {760,0.00690909}, {765,0.00688182}, {770,0.00737273}, {775,0.00702727}, {780,0.00705455}, {785,0.00708182}, {790,0.00707273}, {795,0.00893636}, {800,0.00720909}, {805,0.00736364}, {810,0.00740909}, {815,0.00746364}, {820,0.00756364}, {825,0.00755455}, {830,0.00762727}, {835,0.00770909}, {840,0.00768182}, {845,0.00776364}, {850,0.00775455}, {855,0.00789091}, {860,0.00789091}, {865,0.00796364}, {870,0.00803636}, {875,0.00818182}, {880,0.00817273}, {885,0.00833636}, {890,0.00831818}, {895,0.00840909}, {900,0.00845455}, {905,0.00840000}, {910,0.00851818}, {915,0.01003636}, {920,0.00864545}, {925,0.00872727}, {930,0.00880909}, {935,0.00885455}, {940,0.01106364}, {945,0.00896364}, {950,0.00895455}, {955,0.00898182}, {960,0.00925455}, {965,0.00915455}, {970,0.00918182}, {975,0.00924545}, {980,0.00929091}, {985,0.00929091}, {990,0.00944545}, {995,0.00975455}, {1000,0.00954545}, {1010,0.00962727}, {1020,0.00977273}, {1030,0.00980000}, {1040,0.01007273}, {1050,0.01019091}, {1060,0.01367273}, {1070,0.01031818}, {1080,0.01039091}, {1090,0.01048182}, {1100,0.01064545}, {1110,0.01082727}, {1120,0.01088182}, {1130,0.01106364}, {1140,0.01108182}, {1150,0.01301818}, {1160,0.01142727}, {1170,0.01155455}, {1180,0.01160000}, {1190,0.01336364}, {1200,0.01179091}, {1210,0.01190000}, {1220,0.01199091}, {1230,0.01218182}, {1240,0.01235455}, {1250,0.01248182}, {1260,0.01437273}, {1270,0.01821818}, {1280,0.01270909}, {1290,0.01282727}, {1300,0.01300909}, {1310,0.01302727}, {1320,0.01321818}, {1330,0.01332727}, {1340,0.01345455}, {1350,0.01350909}, {1360,0.01361818}, {1370,0.01382727}, {1380,0.01646364}, {1390,0.01657273}, {1400,0.01402727}, {1410,0.01408182}, {1420,0.01420909}, {1430,0.01449091}, {1440,0.01450000}, {1450,0.02049091}, {1460,0.01474545}, {1470,0.01477273}, {1480,0.01488182}, {1490,0.01506364}, {1500,0.01804545}, {1510,0.01530000}, {1520,0.01540909}, {1530,0.02144545}, {1540,0.01551818}, {1550,0.01642727}, {1560,0.02222727}, {1570,0.01587273}, {1580,0.01601818}, {1590,0.01749091}, {1600,0.01618182}, {1610,0.01627273}, {1620,0.01629091}, {1630,0.01646364}, {1640,0.01649091}, {1650,0.01683636}, {1660,0.01670000}, {1670,0.01698182}, {1680,0.01699091}, {1690,0.01709091}, {1700,0.01719091}, {1710,0.02532727}, {1720,0.01731818}, {1730,0.01927273}, {1740,0.01771818}, {1750,0.01773636}, {1760,0.02166364}, {1770,0.01814545}, {1780,0.01813636}, {1790,0.02020909}, {1800,0.01845455}, {1810,0.01833636}, {1820,0.01847273}, {1830,0.02275455}, {1840,0.01877273}, {1850,0.01894545}, {1860,0.01916364}, {1870,0.02060000}, {1880,0.02157273}, {1890,0.01938182}, {1900,0.01936364}, {1910,0.01953636}, {1920,0.01964545}, {1930,0.01976364}, {1940,0.01986364}, {1950,0.02002727}, {1960,0.02231818}, {1970,0.02167273}, {1980,0.02252727}, {1990,0.02264545}, {2000,0.02261818}, {2050,0.02290000}, {2100,0.02165455}, {2150,0.02227273}, {2200,0.02309091}, {2250,0.02340000}, {2300,0.02410000}, {2350,0.02511818}, {2400,0.02510000}, {2450,0.02567273}, {2500,0.02623636}, {2550,0.02926364}, {2600,0.02987273}, {2650,0.03154545}, {2700,0.03026364}, {2750,0.03184545}, {2800,0.03165455}, {2850,0.03000000}, {2900,0.03299091}, {2950,0.03095455}, {3000,0.03410000}, {3050,0.03500}, {3100,0.03400}, {3150,0.03450}, {3200,0.03550}, {3250,0.03950}, {3300,0.04050}, {3350,0.04000}, {3400,0.03850}, {3450,0.03975}, {3500,0.03900}, {3550,0.04025}, {3600,0.04225}, {3650,0.04300}, {3700,0.04325}, {3750,0.05175}, {3800,0.05250}, {3850,0.04325}, {3900,0.04475}, {3950,0.04725}, {4000,0.04525}, {4050,0.04625}, {4100,0.04550}, {4150,0.05350}, {4200,0.05325}, {4250,0.04900}, {4300,0.04925}, {4350,0.04925}, {4400,0.05225}, {4450,0.05450}, {4500,0.05200}, {4550,0.05375}, {4600,0.05725}, {4650,0.05825}, {4700,0.05550}, {4750,0.05875}, {4800,0.05550}, {4850,0.07725}, {4900,0.06050}, {4950,0.06475}, {5000,0.06575}, {5050,0.06025}, {5100,0.06225}, {5150,0.06425}, {5200,0.07125}, {5250,0.07900}, {5300,0.06600}, {5350,0.06550}, {5400,0.07525}, {5450,0.06800}, {5500,0.06800}, {5550,0.07275}, {5600,0.07150}, {5650,0.08575}, {5700,0.07100}, {5750,0.07125}, {5800,0.06975}, {5850,0.08050}, {5900,0.07400}, {5950,0.07200}, {6000,0.07100}, {6050,0.07800}, {6100,0.07300}, {6150,0.08675}, {6200,0.09200}, {6250,0.07400}, {6300,0.07350}, {6350,0.07675}, {6400,0.08425}, {6450,0.08950}, {6500,0.07850}, {6550,0.08200}, {6600,0.08025}, {6650,0.08125}, {6700,0.09150}, {6750,0.08775}, {6800,0.08400}, {6850,0.09000}, {6900,0.08500}, {6950,0.10125}, {7000,0.09600}, {7050,0.09350}, {7100,0.08625}, {7150,0.09825}, {7200,0.09925}, {7250,0.08800}, {7300,0.09800}, {7350,0.08950}, {7400,0.10625}, {7450,0.10450}, {7500,0.09600}, {7550,0.10275}, {7600,0.10300}, {7650,0.11050}, {7700,0.09700}, {7750,0.12725}, {7800,0.09525}, {7850,0.09975}, {7900,0.10375}, {7950,0.10350}, {8000,0.10450}, {8050,0.09875}, {8100,0.10575}, {8150,0.12575}, {8200,0.11500}, {8250,0.09875}, {8300,0.10700}, {8350,0.09775}, {8400,0.11425}, {8450,0.12975}, {8500,0.10850}, {8550,0.11425}, {8600,0.10600}, {8650,0.10775}, {8700,0.10450}, {8750,0.09925}, {8800,0.11025}, {8850,0.12200}, {8900,0.10575}, {8950,0.12600}, {9000,0.11575}, {9050,0.13075}, {9100,0.10500}, {9150,0.10850}, {9200,0.11525}, {9250,0.12350}, {9300,0.13950}, {9350,0.13250}, {9400,0.13500}, {9450,0.11500}, {9500,0.11200}, {9550,0.12200}, {9600,0.12100}, {9650,0.13225}, {9700,0.11725}, {9750,0.14000}, {9800,0.14025}, {9850,0.11375}, {9900,0.11900}, {9950,0.12450}, {10000,0.12700}, {10100,0.1530}, {10200,0.1160}, {10300,0.1200}, {10400,0.147}, {10500,0.125}, {10600,0.162}, {10700,0.134}, {10800,0.136}, {10900,0.121}, {11000,0.13}, {11100,0.166}, {11200,0.123}, {11300,0.145}, {11400,0.122}, {11500,0.157}, {11600,0.123}, {11700,0.161}, {11800,0.129}, {11900,0.139}, {12000,0.153}, {12100,0.197}, {12200,0.158}, {12300,0.159}, {12400,0.173}, {12500,0.205}, {12600,0.193}, {12700,0.176}, {12800,0.185}, {12900,0.151}, {13000,0.196}, {13100,0.192}, {13200,0.161}, {13300,0.156}, {13400,0.2}, {13500,5.163}, {13600,0.177}, {13700,0.212}, {13800,0.158}, {13900,0.185}, {14000,0.179}, {14100,0.184}, {14200,0.227}, {14300,0.182}, {14400,0.211}, {14500,0.236}, {14600,0.247}, {14700,0.264}, {14800,0.223}, {14900,0.196}, {15000,0.229}, {15100,0.196}, {15200,0.205}, {15300,0.209}, {15400,0.198}, {15500,0.27}, {15600,0.203}, {15700,0.275}, {15800,0.204}, {15900,0.229}, {16000,0.221}, {16100,0.205}, {16200,0.258}, {16300,0.229}, {16400,0.275}, {16500,0.301}, {16600,0.209}, {16700,0.308}, {16800,0.241}, {16900,0.23}, {17000,0.289}, {17100,0.223}, {17200,0.243}, {17300,0.242}, {17400,0.239}, {17500,0.248}, {17600,0.27}, {17700,0.217}, {17800,0.248}, {17900,0.242}, {18000,0.239}, {18100,0.245}, {18200,0.305}, {18300,0.234}, {18400,0.301}, {18500,0.247}, {18600,0.252}, {18700,0.251}, {18800,0.299}, {18900,0.255}, {19000,0.309}, {19100,0.263}, {19200,0.286}, {19300,0.299}, {19400,0.265}, {19500,0.263}, {19600,0.312}, {19700,0.266}, {19800,0.263}, {19900,0.253}};
data["big"]["transitivity"]["Stats"]["user"] = {{1,0.00014545}, {2,0.00041818}, {3,0.00010909}, {4,0.00023636}, {5,0.00029091}, {6,0.00017273}, {7,0.00027273}, {8,0.00028182}, {9,0.00025455}, {10,0.00018182}, {11,0.00030000}, {12,0.00042727}, {13,0.00013636}, {14,0.00027273}, {15,0.00016364}, {16,0.00044545}, {17,0.00048182}, {18,0.00045455}, {19,0.00040909}, {20,0.00040909}, {21,0.00020000}, {22,0.00048182}, {23,0.00051818}, {24,0.00034545}, {25,0.00045455}, {26,0.00058182}, {27,0.00046364}, {28,0.00035455}, {29,0.00051818}, {30,0.00049091}, {31,0.00057273}, {32,0.00050000}, {33,0.00054545}, {34,0.00054545}, {35,0.00048182}, {36,0.00048182}, {37,0.00046364}, {38,0.00055455}, {39,0.00080909}, {40,0.00061818}, {41,0.00050909}, {42,0.00041818}, {43,0.00053636}, {44,0.00061818}, {45,0.00060909}, {46,0.00059091}, {47,0.00049091}, {48,0.00074545}, {49,0.00059091}, {50,0.00035455}, {51,0.00083636}, {52,0.00059091}, {53,0.00077273}, {54,0.00052727}, {55,0.00074545}, {56,0.00063636}, {57,0.00066364}, {58,0.00066364}, {59,0.00066364}, {60,0.00076364}, {61,0.00075455}, {62,0.00091818}, {63,0.00058182}, {64,0.00077273}, {65,0.00081818}, {66,0.00087273}, {67,0.00086364}, {68,0.00068182}, {69,0.00096364}, {70,0.00094545}, {71,0.00047273}, {72,0.00066364}, {73,0.00079091}, {74,0.00059091}, {75,0.00088182}, {76,0.00064545}, {77,0.00080909}, {78,0.00075455}, {79,0.00109091}, {80,0.00067273}, {81,0.00086364}, {82,0.00086364}, {83,0.00117273}, {84,0.00104545}, {85,0.00100909}, {86,0.00108182}, {87,0.00092727}, {88,0.00095455}, {89,0.00084545}, {90,0.00079091}, {91,0.00085455}, {92,0.00104545}, {93,0.00105455}, {94,0.00091818}, {95,0.00104545}, {96,0.00094545}, {97,0.00115455}, {98,0.00091818}, {99,0.00096364}, {100,0.00105455}, {101,0.00114545}, {102,0.00091818}, {103,0.00107273}, {104,0.00096364}, {105,0.00104545}, {106,0.00100000}, {107,0.00115455}, {108,0.00103636}, {109,0.00119091}, {110,0.00105455}, {111,0.00123636}, {112,0.00106364}, {113,0.00083636}, {114,0.00133636}, {115,0.00096364}, {116,0.00111818}, {117,0.00084545}, {118,0.00133636}, {119,0.00108182}, {120,0.00109091}, {121,0.00124545}, {122,0.00126364}, {123,0.00124545}, {124,0.00111818}, {125,0.00093636}, {126,0.00116364}, {127,0.00117273}, {128,0.00106364}, {129,0.00104545}, {130,0.00100000}, {131,0.00132727}, {132,0.00114545}, {133,0.00108182}, {134,0.00132727}, {135,0.00144545}, {136,0.00132727}, {137,0.00138182}, {138,0.00121818}, {139,0.00129091}, {140,0.00169091}, {141,0.00110909}, {142,0.00119091}, {143,0.00124545}, {144,0.00146364}, {145,0.00142727}, {146,0.00135455}, {147,0.00140909}, {148,0.00144545}, {149,0.00126364}, {150,0.00114545}, {151,0.00150000}, {152,0.00141818}, {153,0.00140909}, {154,0.00150000}, {155,0.00147273}, {156,0.00132727}, {157,0.00159091}, {158,0.00144545}, {159,0.00132727}, {160,0.00128182}, {161,0.00163636}, {162,0.00127273}, {163,0.00156364}, {164,0.00181818}, {165,0.00169091}, {166,0.00160909}, {167,0.00150909}, {168,0.00180909}, {169,0.00174545}, {170,0.00142727}, {171,0.00166364}, {172,0.00170000}, {173,0.00138182}, {174,0.00167273}, {175,0.00155455}, {176,0.00170909}, {177,0.00150909}, {178,0.00165455}, {179,0.00158182}, {180,0.00175455}, {181,0.00161818}, {182,0.00189091}, {183,0.00166364}, {184,0.00160909}, {185,0.00153636}, {186,0.00200000}, {187,0.00175455}, {188,0.00152727}, {189,0.00180000}, {190,0.00185455}, {191,0.00129091}, {192,0.00245455}, {193,0.00196364}, {194,0.00171818}, {195,0.00198182}, {196,0.00178182}, {197,0.00176364}, {198,0.00161818}, {199,0.00145455}, {200,0.00164545}, {201,0.00196364}, {202,0.00164545}, {203,0.00194545}, {204,0.00131818}, {205,0.00185455}, {206,0.00188182}, {207,0.00167273}, {208,0.00211818}, {209,0.00200000}, {210,0.00179091}, {211,0.00181818}, {212,0.00188182}, {213,0.00170000}, {214,0.00169091}, {215,0.00174545}, {216,0.00170000}, {217,0.00171818}, {218,0.00204545}, {219,0.00202727}, {220,0.00188182}, {221,0.00215455}, {222,0.00200000}, {223,0.00191818}, {224,0.00188182}, {225,0.00200000}, {226,0.00166364}, {227,0.00195455}, {228,0.00170000}, {229,0.00180000}, {230,0.00204545}, {231,0.00208182}, {232,0.00286364}, {233,0.00209091}, {234,0.00199091}, {235,0.00200909}, {236,0.00213636}, {237,0.00210000}, {238,0.00227273}, {239,0.00203636}, {240,0.00202727}, {241,0.00192727}, {242,0.00223636}, {243,0.00308182}, {244,0.00208182}, {245,0.00184545}, {246,0.00230909}, {247,0.00230000}, {248,0.00209091}, {249,0.00209091}, {250,0.00230000}, {251,0.00214545}, {252,0.00220000}, {253,0.00251818}, {254,0.00225455}, {255,0.00238182}, {256,0.00233636}, {257,0.00247273}, {258,0.00220909}, {259,0.00186364}, {260,0.00216364}, {261,0.00205455}, {262,0.00228182}, {263,0.00204545}, {264,0.00241818}, {265,0.00219091}, {266,0.00240000}, {267,0.00212727}, {268,0.00246364}, {269,0.00229091}, {270,0.00241818}, {271,0.00341818}, {272,0.00237273}, {273,0.00237273}, {274,0.00238182}, {275,0.00221818}, {276,0.00241818}, {277,0.00239091}, {278,0.00240000}, {279,0.00235455}, {280,0.00241818}, {281,0.00249091}, {282,0.00219091}, {283,0.00229091}, {284,0.00266364}, {285,0.00249091}, {286,0.00247273}, {287,0.00240000}, {288,0.00245455}, {289,0.00224545}, {290,0.00240909}, {291,0.00240000}, {292,0.00317273}, {293,0.00244545}, {294,0.00239091}, {295,0.00237273}, {296,0.00249091}, {297,0.00247273}, {298,0.00239091}, {299,0.00250909}, {300,0.00245455}, {301,0.00257273}, {302,0.00253636}, {303,0.00374545}, {304,0.00263636}, {305,0.00275455}, {306,0.00236364}, {307,0.00258182}, {308,0.00287273}, {309,0.00244545}, {310,0.00249091}, {311,0.00265455}, {312,0.00240909}, {313,0.00247273}, {314,0.00267273}, {315,0.00263636}, {316,0.00271818}, {317,0.00266364}, {318,0.00284545}, {319,0.00258182}, {320,0.00281818}, {321,0.00271818}, {322,0.00278182}, {323,0.00246364}, {324,0.00290000}, {325,0.00286364}, {326,0.00361818}, {327,0.00277273}, {328,0.00403636}, {329,0.00285455}, {330,0.00407273}, {331,0.00280909}, {332,0.00363636}, {333,0.00292727}, {334,0.00281818}, {335,0.00277273}, {336,0.00280000}, {337,0.00270909}, {338,0.00278182}, {339,0.00295455}, {340,0.00264545}, {341,0.00271818}, {342,0.00277273}, {343,0.00262727}, {344,0.00272727}, {345,0.00280000}, {346,0.00273636}, {347,0.00288182}, {348,0.00303636}, {349,0.00286364}, {350,0.00289091}, {351,0.00267273}, {352,0.00289091}, {353,0.00300000}, {354,0.00279091}, {355,0.00290000}, {356,0.00297273}, {357,0.00309091}, {358,0.00310000}, {359,0.00294545}, {360,0.00300000}, {361,0.00295455}, {362,0.00278182}, {363,0.00313636}, {364,0.00295455}, {365,0.00288182}, {366,0.00305455}, {367,0.00296364}, {368,0.00311818}, {369,0.00320000}, {370,0.00290909}, {371,0.00320000}, {372,0.00293636}, {373,0.00423636}, {374,0.00304545}, {375,0.00310909}, {376,0.00309091}, {377,0.00310909}, {378,0.00298182}, {379,0.00317273}, {380,0.00466364}, {381,0.00317273}, {382,0.00319091}, {383,0.00313636}, {384,0.00315455}, {385,0.00312727}, {386,0.00319091}, {387,0.00310000}, {388,0.00323636}, {389,0.00325455}, {390,0.00327273}, {391,0.00322727}, {392,0.00318182}, {393,0.00327273}, {394,0.00319091}, {395,0.00320909}, {396,0.00323636}, {397,0.00450909}, {398,0.00333636}, {399,0.00332727}, {400,0.00328182}, {401,0.00339091}, {402,0.00332727}, {403,0.00325455}, {404,0.00334545}, {405,0.00338182}, {406,0.00337273}, {407,0.00327273}, {408,0.00328182}, {409,0.00328182}, {410,0.00532727}, {411,0.00350000}, {412,0.00341818}, {413,0.00335455}, {414,0.00335455}, {415,0.00343636}, {416,0.00329091}, {417,0.00330909}, {418,0.00460000}, {419,0.00346364}, {420,0.00329091}, {421,0.00350909}, {422,0.00353636}, {423,0.00340000}, {424,0.00357273}, {425,0.00335455}, {426,0.00350000}, {427,0.00342727}, {428,0.00344545}, {429,0.00353636}, {430,0.00355455}, {431,0.00349091}, {432,0.00348182}, {433,0.00350909}, {434,0.00369091}, {435,0.00491818}, {436,0.00345455}, {437,0.00386364}, {438,0.00540909}, {439,0.00370909}, {440,0.00361818}, {441,0.00533636}, {442,0.00350909}, {443,0.00356364}, {444,0.00566364}, {445,0.00388182}, {446,0.00377273}, {447,0.00382727}, {448,0.00389091}, {449,0.00381818}, {450,0.00362727}, {451,0.00397273}, {452,0.00364545}, {453,0.00368182}, {454,0.00390909}, {455,0.00385455}, {456,0.00387273}, {457,0.00395455}, {458,0.00377273}, {459,0.00362727}, {460,0.00713636}, {461,0.00379091}, {462,0.00389091}, {463,0.00377273}, {464,0.00387273}, {465,0.00395455}, {466,0.00381818}, {467,0.00417273}, {468,0.00373636}, {469,0.00390909}, {470,0.00562727}, {471,0.00389091}, {472,0.00401818}, {473,0.00388182}, {474,0.00430909}, {475,0.00392727}, {476,0.00391818}, {477,0.00410909}, {478,0.00419091}, {479,0.00401818}, {480,0.00410000}, {481,0.00439091}, {482,0.00393636}, {483,0.00398182}, {484,0.00406364}, {485,0.00407273}, {486,0.00398182}, {487,0.00400000}, {488,0.00414545}, {489,0.00399091}, {490,0.00408182}, {491,0.00434545}, {492,0.00432727}, {493,0.00428182}, {494,0.00397273}, {495,0.00410909}, {496,0.00424545}, {497,0.00410909}, {498,0.00422727}, {499,0.00443636}, {500,0.00400909}, {505,0.00435455}, {510,0.00400000}, {515,0.00439091}, {520,0.00423636}, {525,0.00420909}, {530,0.00461818}, {535,0.00434545}, {540,0.00447273}, {545,0.00448182}, {550,0.00487273}, {555,0.00470000}, {560,0.00483636}, {565,0.00500909}, {570,0.00487273}, {575,0.00498182}, {580,0.00466364}, {585,0.00502727}, {590,0.00549091}, {595,0.00472727}, {600,0.00510000}, {605,0.00520000}, {610,0.00550909}, {615,0.00527273}, {620,0.00535455}, {625,0.00565455}, {630,0.00563636}, {635,0.00580909}, {640,0.00576364}, {645,0.00540909}, {650,0.00576364}, {655,0.00600000}, {660,0.00590909}, {665,0.00588182}, {670,0.00571818}, {675,0.00606364}, {680,0.00593636}, {685,0.00617273}, {690,0.00610909}, {695,0.00596364}, {700,0.00609091}, {705,0.00641818}, {710,0.00650909}, {715,0.00631818}, {720,0.00639091}, {725,0.00637273}, {730,0.00972727}, {735,0.00600909}, {740,0.00632727}, {745,0.00676364}, {750,0.00669091}, {755,0.00666364}, {760,0.00670909}, {765,0.00663636}, {770,0.00740000}, {775,0.00688182}, {780,0.00699091}, {785,0.00700000}, {790,0.00703636}, {795,0.00883636}, {800,0.00716364}, {805,0.00705455}, {810,0.00719091}, {815,0.00738182}, {820,0.00723636}, {825,0.00745455}, {830,0.00746364}, {835,0.00754545}, {840,0.00760909}, {845,0.00775455}, {850,0.00765455}, {855,0.00785455}, {860,0.00776364}, {865,0.00785455}, {870,0.00804545}, {875,0.00800000}, {880,0.00836364}, {885,0.00802727}, {890,0.00829091}, {895,0.00825455}, {900,0.00834545}, {905,0.00838182}, {910,0.00879091}, {915,0.01036364}, {920,0.00866364}, {925,0.00872727}, {930,0.00861818}, {935,0.00882727}, {940,0.01155455}, {945,0.00908182}, {950,0.00930000}, {955,0.00907273}, {960,0.00908182}, {965,0.00935455}, {970,0.00929091}, {975,0.00963636}, {980,0.00920909}, {985,0.01000000}, {990,0.00985455}, {995,0.01006364}, {1000,0.00964545}, {1010,0.00983636}, {1020,0.01029091}, {1030,0.01020000}, {1040,0.00980909}, {1050,0.01043636}, {1060,0.01381818}, {1070,0.01068182}, {1080,0.01045455}, {1090,0.01095455}, {1100,0.01109091}, {1110,0.01114545}, {1120,0.01140909}, {1130,0.01122727}, {1140,0.01131818}, {1150,0.01333636}, {1160,0.01191818}, {1170,0.01158182}, {1180,0.01204545}, {1190,0.01320000}, {1200,0.01205455}, {1210,0.01260000}, {1220,0.01245455}, {1230,0.01244545}, {1240,0.01270909}, {1250,0.01284545}, {1260,0.01448182}, {1270,0.01794545}, {1280,0.01287273}, {1290,0.01305455}, {1300,0.01350000}, {1310,0.01339091}, {1320,0.01361818}, {1330,0.01326364}, {1340,0.01364545}, {1350,0.01404545}, {1360,0.01411818}, {1370,0.01381818}, {1380,0.01633636}, {1390,0.01662727}, {1400,0.01439091}, {1410,0.01437273}, {1420,0.01425455}, {1430,0.01466364}, {1440,0.01472727}, {1450,0.02056364}, {1460,0.01500909}, {1470,0.01489091}, {1480,0.01497273}, {1490,0.01537273}, {1500,0.01787273}, {1510,0.01515455}, {1520,0.01576364}, {1530,0.02131818}, {1540,0.01573636}, {1550,0.01660909}, {1560,0.02226364}, {1570,0.01605455}, {1580,0.01601818}, {1590,0.01754545}, {1600,0.01616364}, {1610,0.01632727}, {1620,0.01648182}, {1630,0.01650000}, {1640,0.01640909}, {1650,0.01696364}, {1660,0.01663636}, {1670,0.01687273}, {1680,0.01709091}, {1690,0.01722727}, {1700,0.01712727}, {1710,0.02550909}, {1720,0.01724545}, {1730,0.01937273}, {1740,0.01799091}, {1750,0.01760000}, {1760,0.02177273}, {1770,0.01790000}, {1780,0.01820909}, {1790,0.02023636}, {1800,0.01840909}, {1810,0.01822727}, {1820,0.01846364}, {1830,0.02278182}, {1840,0.01842727}, {1850,0.01877273}, {1860,0.01914545}, {1870,0.02094545}, {1880,0.02202727}, {1890,0.01900000}, {1900,0.01922727}, {1910,0.01916364}, {1920,0.01972727}, {1930,0.01977273}, {1940,0.01994545}, {1950,0.02007273}, {1960,0.02230909}, {1970,0.02181818}, {1980,0.02279091}, {1990,0.02305455}, {2000,0.02273636}, {2050,0.02291818}, {2100,0.02196364}, {2150,0.02255455}, {2200,0.02314545}, {2250,0.02353636}, {2300,0.02439091}, {2350,0.02532727}, {2400,0.02529091}, {2450,0.02566364}, {2500,0.02610000}, {2550,0.02913636}, {2600,0.02988182}, {2650,0.03154545}, {2700,0.03025455}, {2750,0.03177273}, {2800,0.03179091}, {2850,0.02981818}, {2900,0.03325455}, {2950,0.03102727}, {3000,0.03424545}, {3050,0.03675}, {3100,0.03400}, {3150,0.03450}, {3200,0.03600}, {3250,0.04050}, {3300,0.03900}, {3350,0.03925}, {3400,0.03700}, {3450,0.03925}, {3500,0.03850}, {3550,0.04100}, {3600,0.04200}, {3650,0.04200}, {3700,0.04075}, {3750,0.05250}, {3800,0.05225}, {3850,0.04275}, {3900,0.04450}, {3950,0.04625}, {4000,0.04500}, {4050,0.04550}, {4100,0.04575}, {4150,0.05350}, {4200,0.05500}, {4250,0.04650}, {4300,0.04975}, {4350,0.04950}, {4400,0.05200}, {4450,0.05500}, {4500,0.05100}, {4550,0.05325}, {4600,0.05750}, {4650,0.05875}, {4700,0.05475}, {4750,0.05875}, {4800,0.05425}, {4850,0.07550}, {4900,0.06100}, {4950,0.06450}, {5000,0.06525}, {5050,0.06075}, {5100,0.06200}, {5150,0.06175}, {5200,0.07100}, {5250,0.07900}, {5300,0.06575}, {5350,0.06550}, {5400,0.07600}, {5450,0.06875}, {5500,0.06725}, {5550,0.07350}, {5600,0.07275}, {5650,0.08575}, {5700,0.07075}, {5750,0.07075}, {5800,0.06825}, {5850,0.08075}, {5900,0.07350}, {5950,0.07175}, {6000,0.07275}, {6050,0.07850}, {6100,0.07250}, {6150,0.08675}, {6200,0.09000}, {6250,0.07475}, {6300,0.07275}, {6350,0.07675}, {6400,0.08475}, {6450,0.08975}, {6500,0.07875}, {6550,0.08250}, {6600,0.07875}, {6650,0.08275}, {6700,0.09175}, {6750,0.08850}, {6800,0.08475}, {6850,0.09100}, {6900,0.08475}, {6950,0.09925}, {7000,0.09575}, {7050,0.09425}, {7100,0.08550}, {7150,0.09825}, {7200,0.10000}, {7250,0.08775}, {7300,0.09725}, {7350,0.08850}, {7400,0.10650}, {7450,0.10525}, {7500,0.09575}, {7550,0.10250}, {7600,0.10275}, {7650,0.11100}, {7700,0.09750}, {7750,0.12550}, {7800,0.09675}, {7850,0.10075}, {7900,0.10150}, {7950,0.10075}, {8000,0.10450}, {8050,0.09925}, {8100,0.10550}, {8150,0.12550}, {8200,0.11550}, {8250,0.09850}, {8300,0.10600}, {8350,0.09775}, {8400,0.11350}, {8450,0.12900}, {8500,0.10975}, {8550,0.11375}, {8600,0.10500}, {8650,0.10675}, {8700,0.10425}, {8750,0.10050}, {8800,0.11050}, {8850,0.12175}, {8900,0.10550}, {8950,0.12600}, {9000,0.11550}, {9050,0.13125}, {9100,0.10425}, {9150,0.10925}, {9200,0.11525}, {9250,0.12250}, {9300,0.14050}, {9350,0.13100}, {9400,0.13525}, {9450,0.11475}, {9500,0.11225}, {9550,0.12050}, {9600,0.12200}, {9650,0.13225}, {9700,0.11675}, {9750,0.14000}, {9800,0.14025}, {9850,0.11175}, {9900,0.11950}, {9950,0.12475}, {10000,0.12675}, {10100,0.1515}, {10200,0.1155}, {10300,0.1195}, {10400,0.147}, {10500,0.124}, {10600,0.156}, {10700,0.128}, {10800,0.135}, {10900,0.12}, {11000,0.128}, {11100,0.168}, {11200,0.123}, {11300,0.144}, {11400,0.124}, {11500,0.155}, {11600,0.124}, {11700,0.163}, {11800,0.127}, {11900,0.14}, {12000,0.155}, {12100,0.196}, {12200,0.16}, {12300,0.152}, {12400,0.172}, {12500,0.208}, {12600,0.192}, {12700,0.175}, {12800,0.183}, {12900,0.152}, {13000,0.195}, {13100,0.192}, {13200,0.164}, {13300,0.155}, {13400,0.204}, {13500,5.159}, {13600,0.175}, {13700,0.216}, {13800,0.155}, {13900,0.183}, {14000,0.179}, {14100,0.184}, {14200,0.228}, {14300,0.18}, {14400,0.211}, {14500,0.235}, {14600,0.248}, {14700,0.264}, {14800,0.224}, {14900,0.195}, {15000,0.228}, {15100,0.195}, {15200,0.203}, {15300,0.211}, {15400,0.199}, {15500,0.271}, {15600,0.204}, {15700,0.276}, {15800,0.207}, {15900,0.228}, {16000,0.22}, {16100,0.204}, {16200,0.26}, {16300,0.228}, {16400,0.275}, {16500,0.299}, {16600,0.208}, {16700,0.304}, {16800,0.239}, {16900,0.228}, {17000,0.292}, {17100,0.223}, {17200,0.243}, {17300,0.243}, {17400,0.239}, {17500,0.251}, {17600,0.271}, {17700,0.22}, {17800,0.252}, {17900,0.243}, {18000,0.239}, {18100,0.243}, {18200,0.304}, {18300,0.231}, {18400,0.304}, {18500,0.247}, {18600,0.248}, {18700,0.252}, {18800,0.3}, {18900,0.256}, {19000,0.308}, {19100,0.263}, {19200,0.288}, {19300,0.299}, {19400,0.264}, {19500,0.263}, {19600,0.311}, {19700,0.268}, {19800,0.263}, {19900,0.251}};
data["big"]["transitivity"]["Stats"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00003636}, {9,0.00000000}, {10,0.00000000}, {11,0.00002727}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00003636}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00003636}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00003636}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00003636}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00003636}, {54,0.00000000}, {55,0.00000000}, {56,0.00003636}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00003636}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00010909}, {102,0.00000000}, {103,0.00000000}, {104,0.00003636}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00003636}, {114,0.00000000}, {115,0.00003636}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00003636}, {127,0.00000000}, {128,0.00002727}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00003636}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00003636}, {154,0.00000000}, {155,0.00000000}, {156,0.00003636}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00003636}, {169,0.00000000}, {170,0.00003636}, {171,0.00003636}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00003636}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00003636}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00003636}, {191,0.00003636}, {192,0.00007273}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00003636}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00003636}, {205,0.00000000}, {206,0.00002727}, {207,0.00000000}, {208,0.00000000}, {209,0.00002727}, {210,0.00003636}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00003636}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00003636}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00003636}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00003636}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00003636}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00003636}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00003636}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00003636}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003636}, {282,0.00000000}, {283,0.00000000}, {284,0.00003636}, {285,0.00000000}, {286,0.00003636}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00003636}, {291,0.00000000}, {292,0.00010000}, {293,0.00007273}, {294,0.00000000}, {295,0.00002727}, {296,0.00000000}, {297,0.00000000}, {298,0.00003636}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00003636}, {307,0.00003636}, {308,0.00000000}, {309,0.00003636}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00003636}, {314,0.00000000}, {315,0.00003636}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00002727}, {326,0.00003636}, {327,0.00000000}, {328,0.00003636}, {329,0.00000000}, {330,0.00010909}, {331,0.00000000}, {332,0.00006364}, {333,0.00000000}, {334,0.00000000}, {335,0.00003636}, {336,0.00003636}, {337,0.00000000}, {338,0.00000000}, {339,0.00003636}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00003636}, {351,0.00003636}, {352,0.00006364}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00003636}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00010909}, {363,0.00003636}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00002727}, {368,0.00003636}, {369,0.00000000}, {370,0.00003636}, {371,0.00000000}, {372,0.00003636}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00003636}, {377,0.00000000}, {378,0.00003636}, {379,0.00003636}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00003636}, {385,0.00000000}, {386,0.00000000}, {387,0.00003636}, {388,0.00003636}, {389,0.00003636}, {390,0.00003636}, {391,0.00007273}, {392,0.00003636}, {393,0.00000000}, {394,0.00000000}, {395,0.00002727}, {396,0.00000000}, {397,0.00007273}, {398,0.00003636}, {399,0.00003636}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00003636}, {408,0.00000000}, {409,0.00000000}, {410,0.00003636}, {411,0.00000000}, {412,0.00007273}, {413,0.00000000}, {414,0.00003636}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00003636}, {419,0.00000000}, {420,0.00002727}, {421,0.00003636}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00007273}, {426,0.00003636}, {427,0.00000000}, {428,0.00000000}, {429,0.00003636}, {430,0.00000000}, {431,0.00003636}, {432,0.00002727}, {433,0.00000000}, {434,0.00000000}, {435,0.00002727}, {436,0.00003636}, {437,0.00000000}, {438,0.00000000}, {439,0.00003636}, {440,0.00000000}, {441,0.00003636}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00007273}, {446,0.00000000}, {447,0.00003636}, {448,0.00000000}, {449,0.00000000}, {450,0.00003636}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00003636}, {455,0.00002727}, {456,0.00002727}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00003636}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00006364}, {471,0.00000000}, {472,0.00000000}, {473,0.00003636}, {474,0.00010909}, {475,0.00000000}, {476,0.00003636}, {477,0.00003636}, {478,0.00000000}, {479,0.00003636}, {480,0.00000000}, {481,0.00003636}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00003636}, {486,0.00003636}, {487,0.00003636}, {488,0.00000000}, {489,0.00000000}, {490,0.00003636}, {491,0.00003636}, {492,0.00003636}, {493,0.00003636}, {494,0.00003636}, {495,0.00007273}, {496,0.00002727}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00007273}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00003636}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00003636}, {555,0.00000000}, {560,0.00000000}, {565,0.00003636}, {570,0.00000000}, {575,0.00003636}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00003636}, {600,0.00003636}, {605,0.00000000}, {610,0.00000000}, {615,0.00003636}, {620,0.00003636}, {625,0.00003636}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00003636}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00003636}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00003636}, {695,0.00000000}, {700,0.00007273}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00018182}, {735,0.00000000}, {740,0.00007273}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00010909}, {780,0.00000000}, {785,0.00003636}, {790,0.00000000}, {795,0.00007273}, {800,0.00003636}, {805,0.00003636}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00003636}, {840,0.00007273}, {845,0.00000000}, {850,0.00003636}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00003636}, {880,0.00000000}, {885,0.00003636}, {890,0.00000000}, {895,0.00007273}, {900,0.00007273}, {905,0.00000000}, {910,0.00000000}, {915,0.00003636}, {920,0.00003636}, {925,0.00000000}, {930,0.00003636}, {935,0.00003636}, {940,0.00003636}, {945,0.00003636}, {950,0.00000000}, {955,0.00003636}, {960,0.00000000}, {965,0.00010909}, {970,0.00000000}, {975,0.00003636}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00003636}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00007273}, {1050,0.00003636}, {1060,0.00010909}, {1070,0.00000000}, {1080,0.00003636}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00003636}, {1140,0.00007273}, {1150,0.00003636}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00007273}, {1200,0.00003636}, {1210,0.00000000}, {1220,0.00007273}, {1230,0.00003636}, {1240,0.00003636}, {1250,0.00000000}, {1260,0.00003636}, {1270,0.00013636}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00003636}, {1320,0.00000000}, {1330,0.00003636}, {1340,0.00000000}, {1350,0.00007273}, {1360,0.00000000}, {1370,0.00003636}, {1380,0.00007273}, {1390,0.00003636}, {1400,0.00003636}, {1410,0.00000000}, {1420,0.00003636}, {1430,0.00010909}, {1440,0.00000000}, {1450,0.00012727}, {1460,0.00000000}, {1470,0.00003636}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00010909}, {1510,0.00003636}, {1520,0.00003636}, {1530,0.00014545}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00013636}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00003636}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00007273}, {1630,0.00003636}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003636}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00002727}, {1700,0.00003636}, {1710,0.00000000}, {1720,0.00002727}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00003636}, {1760,0.00017273}, {1770,0.00007273}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00003636}, {1810,0.00003636}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00007273}, {1860,0.00000000}, {1870,0.00003636}, {1880,0.00000000}, {1890,0.00003636}, {1900,0.00003636}, {1910,0.00003636}, {1920,0.00003636}, {1930,0.00007273}, {1940,0.00007273}, {1950,0.00000000}, {1960,0.00003636}, {1970,0.00003636}, {1980,0.00000000}, {1990,0.00002727}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00003636}, {2250,0.00003636}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00010909}, {2450,0.00013636}, {2500,0.00003636}, {2550,0.00003636}, {2600,0.00003636}, {2650,0.00003636}, {2700,0.00002727}, {2750,0.00003636}, {2800,0.00000000}, {2850,0.00007273}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000}, {3100,0.00000}, {3150,0.00000}, {3200,0.00000}, {3250,0.00000}, {3300,0.00000}, {3350,0.00000}, {3400,0.00100}, {3450,0.00000}, {3500,0.00000}, {3550,0.00000}, {3600,0.00000}, {3650,0.00000}, {3700,0.00000}, {3750,0.00000}, {3800,0.00100}, {3850,0.00000}, {3900,0.00000}, {3950,0.00000}, {4000,0.00100}, {4050,0.00000}, {4100,0.00000}, {4150,0.00000}, {4200,0.00000}, {4250,0.00100}, {4300,0.00000}, {4350,0.00000}, {4400,0.00000}, {4450,0.00000}, {4500,0.00000}, {4550,0.00000}, {4600,0.00000}, {4650,0.00000}, {4700,0.00000}, {4750,0.00100}, {4800,0.00000}, {4850,0.00000}, {4900,0.00000}, {4950,0.00000}, {5000,0.00000}, {5050,0.00000}, {5100,0.00000}, {5150,0.00100}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00100}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00100}, {7950,0.00100}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.0020}, {10200,0.0000}, {10300,0.0000}, {10400,0}, {10500,0}, {10600,0.008}, {10700,0.004}, {10800,0}, {10900,0}, {11000,0}, {11100,0}, {11200,0}, {11300,0}, {11400,0}, {11500,0}, {11600,0}, {11700,0}, {11800,0}, {11900,0}, {12000,0}, {12100,0.004}, {12200,0}, {12300,0.008}, {12400,0}, {12500,0}, {12600,0}, {12700,0}, {12800,0}, {12900,0}, {13000,0}, {13100,0}, {13200,0}, {13300,0}, {13400,0}, {13500,0.004}, {13600,0}, {13700,0}, {13800,0}, {13900,0}, {14000,0}, {14100,0}, {14200,0}, {14300,0}, {14400,0}, {14500,0}, {14600,0}, {14700,0}, {14800,0}, {14900,0}, {15000,0}, {15100,0}, {15200,0}, {15300,0}, {15400,0}, {15500,0}, {15600,0}, {15700,0}, {15800,0}, {15900,0}, {16000,0}, {16100,0}, {16200,0}, {16300,0}, {16400,0}, {16500,0}, {16600,0}, {16700,0.004}, {16800,0}, {16900,0}, {17000,0}, {17100,0}, {17200,0}, {17300,0}, {17400,0}, {17500,0}, {17600,0}, {17700,0}, {17800,0}, {17900,0}, {18000,0}, {18100,0}, {18200,0}, {18300,0}, {18400,0}, {18500,0}, {18600,0.004}, {18700,0}, {18800,0}, {18900,0}, {19000,0}, {19100,0}, {19200,0}, {19300,0}, {19400,0}, {19500,0}, {19600,0}, {19700,0}, {19800,0}, {19900,0}};
KindsSortedFor["big_flat"]["Aggregate"] = {"Mtac2", "TypeClasses", "CanonicalStructuresPHOAS", "Ltac2", "TypeClassesBodyFlatPHOAS", "LtacTacInTermExplicitCtx", "LtacTCExplicitCtx", "LtacPrimUncurry", "LtacTacInTermPrimPair", "LtacTCPrimPair", "TypeClassesBodyHOAS", "LtacTacInTermGallinaCtx", "LtacTCGallinaCtx", "CanonicalStructuresHOAS", "CanonicalStructuresFlatHOAS", "CanonicalStructuresFlatPHOAS", "Ltac2LowLevel", "TemplateCoq", "beta; Parametricity", "QuoteFlat", "OCaml", "Parametricity; beta", "Parsing", "ParsingElaborated", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};
KindsSortedFor["big_flat"]["Stats"] = {"parsing elaborated", "parsing", "simpl Denote", "identity native_compute", "cbn Denote", "transitivity", "printing", "cbv Denote", "identity vm_compute", "lazy Denote", "identity cbn", "identity simpl", "identity cbv", "identity lazy", "refine let", "CanonicalStructuresFlatHOAS", "CanonicalStructuresFlatPHOAS", "CanonicalStructuresHOAS", "CanonicalStructuresPHOAS", "Ltac2", "Ltac2LowLevel", "LtacPrimUncurry", "LtacTCExplicitCtx", "LtacTCGallinaCtx", "LtacTCPrimPair", "LtacTacInTermExplicitCtx", "LtacTacInTermGallinaCtx", "LtacTacInTermPrimPair", "Mtac2", "OCaml", "Parametricity; beta", "Parsing", "ParsingElaborated", "QuoteFlat", "TemplateCoq", "TypeClasses", "TypeClassesBodyFlatPHOAS", "TypeClassesBodyHOAS", "beta; Parametricity"};
KindsSortedFor["big_flat"]["actual reif"] = {"ParsingElaborated", "Parsing", "Mtac2", "TypeClasses", "CanonicalStructuresPHOAS", "Ltac2", "TypeClassesBodyFlatPHOAS", "LtacTacInTermExplicitCtx", "LtacTCExplicitCtx", "LtacPrimUncurry", "LtacTacInTermPrimPair", "TypeClassesBodyHOAS", "LtacTCPrimPair", "LtacTacInTermGallinaCtx", "LtacTCGallinaCtx", "CanonicalStructuresHOAS", "CanonicalStructuresFlatPHOAS", "CanonicalStructuresFlatHOAS", "Ltac2LowLevel", "TemplateCoq", "beta; Parametricity", "QuoteFlat", "Parametricity; beta", "OCaml", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};
KindsSortedFor["big_flat"]["cbv"] = {"TemplateCoq", "Mtac2", "LtacTCPrimPair", "LtacPrimUncurry", "beta; Parametricity", "TypeClassesBodyFlatPHOAS", "CanonicalStructuresHOAS", "Ltac2", "CanonicalStructuresFlatPHOAS", "OCaml", "CanonicalStructuresFlatHOAS", "QuoteFlat", "LtacTacInTermPrimPair", "LtacTCExplicitCtx", "LtacTacInTermGallinaCtx", "Ltac2LowLevel", "LtacTCGallinaCtx", "CanonicalStructuresPHOAS", "TypeClasses", "LtacTacInTermExplicitCtx", "TypeClassesBodyHOAS", "Parametricity; beta", "Parsing", "ParsingElaborated", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};
KindsSortedFor["big_flat"]["eval lazy"] = {"TemplateCoq", "Parametricity; beta", "CanonicalStructuresPHOAS", "TypeClassesBodyFlatPHOAS", "TypeClassesBodyHOAS", "CanonicalStructuresHOAS", "CanonicalStructuresFlatPHOAS", "QuoteFlat", "CanonicalStructuresFlatHOAS", "LtacPrimUncurry", "Ltac2", "beta; Parametricity", "LtacTCExplicitCtx", "LtacTCGallinaCtx", "LtacTacInTermExplicitCtx", "LtacTCPrimPair", "LtacTacInTermPrimPair", "LtacTacInTermGallinaCtx", "OCaml", "TypeClasses", "Mtac2", "Ltac2LowLevel", "Parsing", "ParsingElaborated", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};
KindsSortedFor["big_flat"]["intros _"] = {"CanonicalStructuresPHOAS", "CanonicalStructuresFlatPHOAS", "CanonicalStructuresFlatHOAS", "CanonicalStructuresHOAS", "Ltac2", "Ltac2LowLevel", "LtacPrimUncurry", "LtacTCExplicitCtx", "LtacTCGallinaCtx", "LtacTCPrimPair", "LtacTacInTermExplicitCtx", "LtacTacInTermGallinaCtx", "LtacTacInTermPrimPair", "Mtac2", "OCaml", "Parametricity; beta", "Parsing", "ParsingElaborated", "QuoteFlat", "TemplateCoq", "TypeClasses", "TypeClassesBodyFlatPHOAS", "TypeClassesBodyHOAS", "beta; Parametricity", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};
KindsSortedFor["big_flat"]["lazy beta iota"] = {"Ltac2", "TemplateCoq", "QuoteFlat", "OCaml", "CanonicalStructuresFlatPHOAS", "TypeClasses", "beta; Parametricity", "LtacTacInTermExplicitCtx", "LtacTCExplicitCtx", "LtacPrimUncurry", "LtacTacInTermGallinaCtx", "LtacTacInTermPrimPair", "CanonicalStructuresFlatHOAS", "LtacTCGallinaCtx", "LtacTCPrimPair", "CanonicalStructuresPHOAS", "CanonicalStructuresHOAS", "TypeClassesBodyHOAS", "Mtac2", "TypeClassesBodyFlatPHOAS", "Ltac2LowLevel", "Parametricity; beta", "Parsing", "ParsingElaborated", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};
KindsSortedFor["big_flat"]["norm reif"] = {"ParsingElaborated", "Parsing", "Mtac2", "TypeClasses", "CanonicalStructuresPHOAS", "Ltac2", "TypeClassesBodyFlatPHOAS", "LtacTacInTermExplicitCtx", "LtacTCExplicitCtx", "LtacPrimUncurry", "TypeClassesBodyHOAS", "LtacTacInTermPrimPair", "LtacTCPrimPair", "LtacTacInTermGallinaCtx", "LtacTCGallinaCtx", "CanonicalStructuresHOAS", "CanonicalStructuresFlatPHOAS", "CanonicalStructuresFlatHOAS", "TemplateCoq", "beta; Parametricity", "Parametricity; beta", "QuoteFlat", "OCaml", "Ltac2LowLevel", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};
KindsSortedFor["big_flat"]["post"] = {"CanonicalStructuresHOAS", "beta; Parametricity", "LtacPrimUncurry", "Ltac2LowLevel", "TemplateCoq", "OCaml", "QuoteFlat", "CanonicalStructuresFlatHOAS", "CanonicalStructuresFlatPHOAS", "CanonicalStructuresPHOAS", "Ltac2", "LtacTCExplicitCtx", "LtacTCGallinaCtx", "LtacTCPrimPair", "LtacTacInTermExplicitCtx", "LtacTacInTermGallinaCtx", "LtacTacInTermPrimPair", "Mtac2", "Parametricity; beta", "TypeClasses", "TypeClassesBodyFlatPHOAS", "TypeClassesBodyHOAS", "Parsing", "ParsingElaborated", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};
KindsSortedFor["big_flat"]["postprocess"] = {"CanonicalStructuresPHOAS", "CanonicalStructuresFlatHOAS", "CanonicalStructuresFlatPHOAS", "CanonicalStructuresHOAS", "Ltac2", "Ltac2LowLevel", "LtacPrimUncurry", "LtacTCExplicitCtx", "LtacTCGallinaCtx", "LtacTCPrimPair", "LtacTacInTermExplicitCtx", "LtacTacInTermGallinaCtx", "LtacTacInTermPrimPair", "Mtac2", "OCaml", "Parametricity; beta", "Parsing", "ParsingElaborated", "QuoteFlat", "TemplateCoq", "TypeClasses", "TypeClassesBodyFlatPHOAS", "TypeClassesBodyHOAS", "beta; Parametricity", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};
KindsSortedFor["big_flat"]["pre"] = {"CanonicalStructuresPHOAS", "CanonicalStructuresHOAS", "CanonicalStructuresFlatHOAS", "CanonicalStructuresFlatPHOAS", "Parametricity; beta", "Ltac2", "Ltac2LowLevel", "LtacPrimUncurry", "LtacTCExplicitCtx", "LtacTCGallinaCtx", "LtacTCPrimPair", "LtacTacInTermExplicitCtx", "LtacTacInTermGallinaCtx", "LtacTacInTermPrimPair", "Mtac2", "OCaml", "QuoteFlat", "TemplateCoq", "TypeClasses", "TypeClassesBodyFlatPHOAS", "TypeClassesBodyHOAS", "beta; Parametricity", "Parsing", "ParsingElaborated", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};
KindsSortedFor["big_flat"]["reif"] = {"ParsingElaborated", "Parsing", "Mtac2", "TypeClasses", "CanonicalStructuresPHOAS", "Ltac2", "TypeClassesBodyFlatPHOAS", "LtacTacInTermExplicitCtx", "LtacTCExplicitCtx", "LtacPrimUncurry", "TypeClassesBodyHOAS", "LtacTacInTermPrimPair", "LtacTCPrimPair", "LtacTacInTermGallinaCtx", "LtacTCGallinaCtx", "CanonicalStructuresHOAS", "CanonicalStructuresFlatPHOAS", "CanonicalStructuresFlatHOAS", "Ltac2LowLevel", "TemplateCoq", "beta; Parametricity", "Parametricity; beta", "QuoteFlat", "OCaml", "cbn Denote", "cbv Denote", "identity cbn", "identity cbv", "identity lazy", "identity native_compute", "identity simpl", "identity vm_compute", "lazy Denote", "parsing", "parsing elaborated", "printing", "refine let", "simpl Denote", "transitivity"};

data["big_flat"]["CanonicalStructuresFlatHOAS"]["Aggregate"]["real"] = {{1,0.00100000}, {2,0.00100000}, {3,0.00101802}, {4,0.00100000}, {5,0.00118018}, {6,0.00155856}, {7,0.00200000}, {8,0.00200000}, {9,0.00200000}, {10,0.00200000}, {11,0.00200000}, {12,0.00200000}, {13,0.00200000}, {14,0.00200000}, {15,0.00211712}, {16,0.00218919}, {17,0.00256757}, {18,0.00294595}, {19,0.00300000}, {20,0.00300000}, {21,0.00300000}, {22,0.00300000}, {23,0.00301802}, {24,0.00300000}, {25,0.00302703}, {26,0.00307207}, {27,0.00319820}, {28,0.00325225}, {29,0.00381081}, {30,0.00397297}, {31,0.00400000}, {32,0.00400000}, {33,0.00400000}, {34,0.00400901}, {35,0.00400000}, {36,0.00401802}, {37,0.00415315}, {38,0.00409910}, {39,0.00422523}, {40,0.00421622}, {41,0.00483784}, {42,0.00499099}, {43,0.00500000}, {44,0.00500000}, {45,0.00500000}, {46,0.00500901}, {47,0.00503604}, {48,0.00503604}, {49,0.00517117}, {50,0.00514414}, {51,0.00516216}, {52,0.00529730}, {53,0.00574775}, {54,0.00598198}, {55,0.00600000}, {56,0.00600000}, {57,0.00601802}, {58,0.00690991}, {59,0.00607207}, {60,0.00611712}, {61,0.00609910}, {62,0.00618018}, {63,0.00643243}, {64,0.00635135}, {65,0.00673874}, {66,0.00692793}, {67,0.00700901}, {68,0.00699099}, {69,0.00706306}, {70,0.00705405}, {71,0.00709009}, {72,0.00799099}, {73,0.00706306}, {74,0.00713514}, {75,0.00732432}, {76,0.00750450}, {77,0.00789189}, {78,0.00868468}, {79,0.00801802}, {80,0.00800901}, {81,0.00807207}, {82,0.00810811}, {83,0.00805405}, {84,0.00900901}, {85,0.00810811}, {86,0.00819820}, {87,0.00857658}, {88,0.00843243}, {89,0.00885586}, {90,0.00900901}, {91,0.00904505}, {92,0.00902703}, {93,0.00909009}, {94,0.00906306}, {95,0.00914414}, {96,0.00908108}, {97,0.00916216}, {98,0.00926126}, {99,0.00948649}, {100,0.00956757}, {101,0.00988288}, {102,0.01000901}, {103,0.01007207}, {104,0.01094595}, {105,0.01004505}, {106,0.01004505}, {107,0.01006306}, {108,0.01012613}, {109,0.01021622}, {110,0.01038739}, {111,0.01073874}, {112,0.01057658}, {113,0.01146847}, {114,0.01098198}, {115,0.01106306}, {116,0.01110811}, {117,0.01103604}, {118,0.01110811}, {119,0.01112613}, {120,0.01112613}, {121,0.01128829}, {122,0.01145946}, {123,0.01176577}, {124,0.01187387}, {125,0.01197297}, {126,0.01202703}, {127,0.01204505}, {128,0.01203604}, {129,0.01208108}, {130,0.01210811}, {131,0.01218919}, {132,0.01221622}, {133,0.01345045}, {134,0.01260360}, {135,0.01289189}, {136,0.01278378}, {137,0.01354955}, {138,0.01302703}, {139,0.01310811}, {140,0.01307207}, {141,0.01310811}, {142,0.01324324}, {143,0.01333333}, {144,0.01423423}, {145,0.01336036}, {146,0.01348649}, {147,0.01389189}, {148,0.01390991}, {149,0.01409009}, {150,0.01406306}, {151,0.01504505}, {152,0.01408108}, {153,0.01412613}, {154,0.01515315}, {155,0.01442342}, {156,0.01439640}, {157,0.01474775}, {158,0.01485586}, {159,0.01503604}, {160,0.01471171}, {161,0.01498198}, {162,0.01502703}, {163,0.01517117}, {164,0.01502703}, {165,0.01515315}, {166,0.01522523}, {167,0.01630631}, {168,0.01532432}, {169,0.01573874}, {170,0.01609910}, {171,0.01596396}, {172,0.01591892}, {173,0.01634234}, {174,0.01609009}, {175,0.01622523}, {176,0.01612613}, {177,0.01620721}, {178,0.01631532}, {179,0.01667568}, {180,0.01651351}, {181,0.01688288}, {182,0.01693694}, {183,0.01712613}, {184,0.01836937}, {185,0.01707207}, {186,0.01713514}, {187,0.01821622}, {188,0.01710811}, {189,0.01742342}, {190,0.01758559}, {191,0.01788288}, {192,0.01739640}, {193,0.01771171}, {194,0.01769369}, {195,0.01913514}, {196,0.01795495}, {197,0.01804505}, {198,0.01809009}, {199,0.01816216}, {200,0.01817117}, {201,0.01827928}, {202,0.01832432}, {203,0.01971171}, {204,0.01869369}, {205,0.01900000}, {206,0.01903604}, {207,0.01917117}, {208,0.02000000}, {209,0.01901802}, {210,0.01911712}, {211,0.01925225}, {212,0.01926126}, {213,0.02050450}, {214,0.01963964}, {215,0.02116216}, {216,0.01980180}, {217,0.01997297}, {218,0.02004505}, {219,0.02013514}, {220,0.02118018}, {221,0.02025225}, {222,0.02027027}, {223,0.02063964}, {224,0.02017117}, {225,0.02033333}, {226,0.02048649}, {227,0.02175676}, {228,0.02073874}, {229,0.02097297}, {230,0.02109009}, {231,0.02120721}, {232,0.02106306}, {233,0.02115315}, {234,0.02121622}, {235,0.02155856}, {236,0.02240541}, {237,0.02181081}, {238,0.02298198}, {239,0.02201802}, {240,0.02190991}, {241,0.02199099}, {242,0.02205405}, {243,0.02217117}, {244,0.02218018}, {245,0.02232432}, {246,0.02242342}, {247,0.02320721}, {248,0.02261261}, {249,0.02368468}, {250,0.02294595}, {251,0.02447748}, {252,0.02305405}, {253,0.02451351}, {254,0.02327027}, {255,0.02490090}, {256,0.02298198}, {257,0.02431532}, {258,0.02320721}, {259,0.02468468}, {260,0.02341441}, {261,0.02540541}, {262,0.02381081}, {263,0.02590991}, {264,0.02381982}, {265,0.02521622}, {266,0.02406306}, {267,0.02607207}, {268,0.02428829}, {269,0.02558559}, {270,0.02452252}, {271,0.02596396}, {272,0.02440541}, {273,0.02584685}, {274,0.02480180}, {275,0.02618018}, {276,0.02509910}, {277,0.02627928}, {278,0.02518018}, {279,0.02547748}, {280,0.02522523}, {281,0.02545946}, {282,0.02568468}, {283,0.02598198}, {284,0.02581982}, {285,0.02605405}, {286,0.02787387}, {287,0.02631532}, {288,0.02684685}, {289,0.02607207}, {290,0.02726126}, {291,0.02629730}, {292,0.02627027}, {293,0.02658559}, {294,0.02669369}, {295,0.02694595}, {296,0.02672973}, {297,0.02894595}, {298,0.02710811}, {299,0.02874775}, {300,0.02713514}, {301,0.02727928}, {302,0.02755856}, {303,0.02773874}, {304,0.02990090}, {305,0.02764865}, {306,0.02892793}, {307,0.02799099}, {308,0.02784685}, {309,0.03100901}, {310,0.02809009}, {311,0.03034234}, {312,0.02818018}, {313,0.02837838}, {314,0.02849550}, {315,0.02879279}, {316,0.03132432}, {317,0.02900000}, {318,0.02904505}, {319,0.02941441}, {320,0.02869369}, {321,0.03046847}, {322,0.02892793}, {323,0.02913514}, {324,0.02909910}, {325,0.02933333}, {326,0.03066667}, {327,0.02977477}, {328,0.02944144}, {329,0.03111712}, {330,0.02991892}, {331,0.03012613}, {332,0.03000000}, {333,0.03012613}, {334,0.03192793}, {335,0.03063063}, {336,0.03003604}, {337,0.03196396}, {338,0.03042342}, {339,0.03081081}, {340,0.03249550}, {341,0.03099099}, {342,0.03164865}, {343,0.03122523}, {344,0.03101802}, {345,0.03293694}, {346,0.03129730}, {347,0.03163964}, {348,0.03308108}, {349,0.03187387}, {350,0.03192793}, {351,0.03372072}, {352,0.03149550}, {353,0.03180180}, {354,0.03343243}, {355,0.03210811}, {356,0.03203604}, {357,0.03381081}, {358,0.03244144}, {359,0.03272973}, {360,0.03389189}, {361,0.03270270}, {362,0.03282883}, {363,0.03447748}, {364,0.03296396}, {365,0.03318919}, {366,0.03470270}, {367,0.03363063}, {368,0.03310811}, {369,0.03336036}, {370,0.03494595}, {371,0.03384685}, {372,0.03363964}, {373,0.03522523}, {374,0.03409910}, {375,0.03429730}, {376,0.03541441}, {377,0.03428829}, {378,0.03425225}, {379,0.03469369}, {380,0.03576577}, {381,0.03485586}, {382,0.03494595}, {383,0.03667568}, {384,0.03419820}, {385,0.03441441}, {386,0.03461261}, {387,0.03630631}, {388,0.03472072}, {389,0.03501802}, {390,0.03687387}, {391,0.03735135}, {392,0.03507207}, {393,0.03536937}, {394,0.03685586}, {395,0.03899099}, {396,0.03562162}, {397,0.03589189}, {398,0.03734234}, {399,0.03627928}, {400,0.03569369}, {401,0.03600901}, {402,0.03762162}, {403,0.03651351}, {404,0.03634234}, {405,0.03668468}, {406,0.03807207}, {407,0.03971171}, {408,0.03663063}, {409,0.03698198}, {410,0.03845045}, {411,0.03976577}, {412,0.03726126}, {413,0.03762162}, {414,0.03763964}, {415,0.03935135}, {416,0.03723423}, {417,0.03737838}, {418,0.03750450}, {419,0.03938739}, {420,0.03993694}, {421,0.03793694}, {422,0.03823423}, {423,0.03843243}, {424,0.03927928}, {425,0.04153153}, {426,0.03839640}, {427,0.03873874}, {428,0.03868468}, {429,0.04033333}, {430,0.04231532}, {431,0.03945946}, {432,0.03877477}, {433,0.03909009}, {434,0.04048649}, {435,0.04173874}, {436,0.03933333}, {437,0.03966667}, {438,0.03974775}, {439,0.04133333}, {440,0.04181081}, {441,0.03999099}, {442,0.04019820}, {443,0.04045946}, {444,0.04020721}, {445,0.04179279}, {446,0.04291892}, {447,0.04109009}, {448,0.03990090}, {449,0.04024324}, {450,0.04027027}, {451,0.04181982}, {452,0.04272973}, {453,0.04391892}, {454,0.04090090}, {455,0.04115315}, {456,0.04072973}, {457,0.04212613}, {458,0.04253153}, {459,0.04359459}, {460,0.04148649}, {461,0.04170270}, {462,0.04181081}, {463,0.04212613}, {464,0.04175676}, {465,0.04315315}, {466,0.04410811}, {467,0.04514414}, {468,0.04211712}, {469,0.04252252}, {470,0.04255856}, {471,0.04289189}, {472,0.04345946}, {473,0.04443243}, {474,0.04495495}, {475,0.04524324}, {476,0.04298198}, {477,0.04337838}, {478,0.04341441}, {479,0.04376577}, {480,0.04282883}, {481,0.04390991}, {482,0.04463063}, {483,0.04572072}, {484,0.04537838}, {485,0.04672072}, {486,0.04379279}, {487,0.04433333}, {488,0.04368468}, {489,0.04416216}, {490,0.04418919}, {491,0.04459459}, {492,0.04540541}, {493,0.04682883}, {494,0.04669369}, {495,0.04718018}, {496,0.04614414}, {497,0.04484685}, {498,0.04493694}, {499,0.04526126}, {500,0.04515315}, {505,0.04566667}, {510,0.04653153}, {515,0.04606306}, {520,0.04621622}, {525,0.04722523}, {530,0.04746847}, {535,0.04851351}, {540,0.04853153}, {545,0.04853153}, {550,0.04944144}, {555,0.05022523}, {560,0.04989189}, {565,0.05097297}, {570,0.05150450}, {575,0.05270270}, {580,0.05159459}, {585,0.05232432}, {590,0.05338739}, {595,0.05527027}, {600,0.05533333}, {605,0.05655856}, {610,0.05647748}, {615,0.05591892}, {620,0.05585586}, {625,0.05615315}, {630,0.06111712}, {635,0.06085586}, {640,0.05818018}, {645,0.05779279}, {650,0.05810811}, {655,0.05946847}, {660,0.06072072}, {665,0.06143243}, {670,0.06069369}, {675,0.06075676}, {680,0.06365766}, {685,0.06370270}, {690,0.06214414}, {695,0.06357658}, {700,0.06483784}, {705,0.06475676}, {710,0.06398198}, {715,0.06745045}, {720,0.06590991}, {725,0.06567568}, {730,0.06997297}, {735,0.06943243}, {740,0.06653153}, {745,0.06921622}, {750,0.06928829}, {755,0.07177477}, {760,0.07025225}, {765,0.07020721}, {770,0.07140541}, {775,0.06986486}, {780,0.07229730}, {785,0.07163964}, {790,0.07602703}, {795,0.07405405}, {800,0.07107207}, {805,0.07388288}, {810,0.07280180}, {815,0.07643243}, {820,0.07377477}, {825,0.07712613}, {830,0.07601802}, {835,0.07648649}, {840,0.07782883}, {845,0.07794595}, {850,0.07901802}, {855,0.07909009}, {860,0.08045946}, {865,0.07768468}, {870,0.08057658}, {875,0.08202703}, {880,0.08016216}, {885,0.08386486}, {890,0.08572973}, {895,0.08465766}, {900,0.08328829}, {905,0.08142342}, {910,0.08393694}, {915,0.08581081}, {920,0.08713514}, {925,0.08563063}, {930,0.08655856}, {935,0.08763964}, {940,0.08501802}, {945,0.08887387}, {950,0.08926126}, {955,0.08967568}, {960,0.08545045}, {965,0.08898198}, {970,0.09063964}, {975,0.09185586}, {980,0.09306306}, {985,0.09232432}, {990,0.09450450}, {995,0.09342342}, {1000,0.09296396}, {1010,0.09416216}, {1020,0.09831532}, {1030,0.09225225}, {1040,0.09528829}, {1050,0.09814414}, {1060,0.09835135}, {1070,0.10055856}, {1080,0.10046847}, {1090,0.10058559}, {1100,0.10242342}, {1110,0.10391892}, {1120,0.10353153}, {1130,0.10595495}, {1140,0.10697297}, {1150,0.10977477}, {1160,0.11023423}, {1170,0.10743243}, {1180,0.10889189}, {1190,0.11085586}, {1200,0.11136036}, {1210,0.11445045}, {1220,0.11289189}, {1230,0.11498198}, {1240,0.11537838}, {1250,0.11706306}, {1260,0.11727027}, {1270,0.11963964}, {1280,0.11727928}, {1290,0.11818919}, {1300,0.11979279}, {1310,0.12802703}, {1320,0.12300901}, {1330,0.12532432}, {1340,0.12615315}, {1350,0.12735135}, {1360,0.12741441}, {1370,0.12990991}, {1380,0.12706306}, {1390,0.13101802}, {1400,0.12987387}, {1410,0.13375676}, {1420,0.13090991}, {1430,0.13851351}, {1440,0.13227027}, {1450,0.13455856}, {1460,0.13745045}, {1470,0.13933333}, {1480,0.13809910}, {1490,0.14576577}, {1500,0.14557658}, {1510,0.14199099}, {1520,0.14102703}, {1530,0.14407207}, {1540,0.14227027}, {1550,0.14836036}, {1560,0.14388288}, {1570,0.14449550}, {1580,0.14606306}, {1590,0.14981081}, {1600,0.14609910}, {1610,0.15447748}, {1620,0.15228829}, {1630,0.15558559}, {1640,0.15305405}, {1650,0.15572072}, {1660,0.15770270}, {1670,0.15961261}, {1680,0.15582883}, {1690,0.15748649}, {1700,0.16209910}, {1710,0.16060360}, {1720,0.16080180}, {1730,0.16497297}, {1740,0.16321622}, {1750,0.16984685}, {1760,0.16491892}, {1770,0.16658559}, {1780,0.16863063}, {1790,0.17238739}, {1800,0.16543243}, {1810,0.17235135}, {1820,0.17007207}, {1830,0.17111712}, {1840,0.17608108}, {1850,0.17628829}, {1860,0.17228829}, {1870,0.17655856}, {1880,0.17628829}, {1890,0.17790090}, {1900,0.18072973}, {1910,0.18305405}, {1920,0.17842342}, {1930,0.18145045}, {1940,0.18065766}, {1950,0.18483784}, {1960,0.18517117}, {1970,0.18572072}, {1980,0.19206306}, {1990,0.18889189}, {2000,0.18715315}, {2050,0.19379279}, {2100,0.19618018}, {2150,0.20408108}, {2200,0.20672973}, {2250,0.21384685}, {2300,0.22628829}, {2350,0.22916216}, {2400,0.22443243}, {2450,0.23979279}, {2500,1.49990991}, {2550,0.25156757}, {2600,0.25838739}, {2650,0.25422523}, {2700,0.25335135}, {2750,0.26889189}, {2800,0.26534234}, {2850,0.26756757}, {2900,0.27563063}, {2950,0.28645946}, {3000,0.29078378}, {3050,0.30159459}, {3100,0.29409910}, {3150,0.30331532}, {3200,0.30000000}, {3250,0.31145045}, {3300,0.31770270}, {3350,0.32046847}, {3400,0.32359459}, {3450,0.33949550}, {3500,0.33599099}, {3550,0.34999099}, {3600,0.33862162}, {3650,0.34695495}, {3700,0.36069369}, {3750,0.35974775}, {3800,0.36603604}, {3850,0.36787387}, {3900,0.37781081}, {3950,0.39094595}, {4000,0.38582883}, {4050,0.38855856}, {4100,0.39369369}, {4150,0.40674775}, {4200,0.40207207}, {4250,0.42054054}, {4300,0.41905405}, {4350,0.43539640}, {4400,0.42638739}, {4450,0.43672072}, {4500,0.44475676}, {4550,0.44400901}, {4600,0.45616216}, {4650,0.45091892}, {4700,0.46509009}, {4750,0.46501802}, {4800,0.46771171}, {4850,0.48013514}, {4900,0.48198198}, {4950,0.49084685}, {5000,0.48681982}, {5050,0.50503604}, {5100,0.51392793}, {5150,0.50845045}, {5200,0.50230631}, {5250,0.50872973}, {5300,0.53490090}, {5350,0.52786486}, {5400,0.53342342}, {5450,0.53987387}, {5500,0.55949550}, {5550,0.57273874}, {5600,0.57448649}, {5650,0.56717117}, {5700,0.56191892}, {5750,0.58024324}, {5800,0.58658559}, {5850,0.60398198}, {5900,0.58485586}, {5950,0.60981982}, {6000,0.61483784}, {6050,0.61975}, {6100,0.61125}, {6150,0.60000}, {6200,0.60450}, {6250,0.63500}, {6300,0.61725}, {6350,0.64650}, {6400,0.62250}, {6450,0.63200}, {6500,0.63125}, {6550,0.64700}, {6600,0.64925}, {6650,0.67275}, {6700,0.67225}, {6750,0.68800}, {6800,0.66350}, {6850,0.70250}, {6900,0.71000}, {6950,0.69550}, {7000,0.71525}, {7050,0.72400}, {7100,0.72575}, {7150,0.73325}, {7200,0.71950}, {7250,0.72650}, {7300,0.72500}, {7350,0.76575}, {7400,0.75125}, {7450,0.75800}, {7500,0.82175}, {7550,0.79425}, {7600,0.79150}, {7650,0.79600}, {7700,0.79800}, {7750,0.82875}, {7800,0.80500}, {7850,0.81675}, {7900,0.81575}, {7950,0.81600}, {8000,0.78525}, {8050,0.84675}, {8100,0.86675}, {8150,0.86750}, {8200,0.85700}, {8250,0.87400}, {8300,0.82500}, {8350,0.87175}, {8400,0.84750}, {8450,0.86450}, {8500,0.86450}, {8550,0.87500}, {8600,0.92075}, {8650,0.89175}, {8700,0.92925}, {8750,0.94000}, {8800,0.92400}, {8850,0.90000}, {8900,0.90975}, {8950,0.94300}, {9000,0.92825}, {9050,0.97300}, {9100,0.94400}, {9150,0.98275}, {9200,0.97175}, {9250,0.94500}, {9300,0.94875}, {9350,0.96525}, {9400,0.96850}, {9450,0.99500}, {9500,0.96700}, {9550,1.00075}, {9600,0.94875}, {9650,1.04525}, {9700,1.02500}, {9750,1.03300}, {9800,1.01250}, {9850,1.06775}, {9900,1.05775}, {9950,1.06700}, {10000,1.08300}, {10100,1.11150}, {10200,1.11325}, {10300,1.08625}, {10400,1.07825}, {10500,1.09525}, {10600,1.11975}, {10700,1.11600}, {10800,1.11825}, {10900,1.17275}, {11000,1.19100}, {11100,1.15900}, {11200,1.17125}, {11300,1.20000}, {11400,1.14625}, {11500,1.22325}, {11600,1.22175}, {11700,1.26000}, {11800,1.24375}, {11900,1.27325}, {12000,1.25875}, {12100,1.27200}, {12200,1.33700}, {12300,1.26275}, {12400,1.30950}, {12500,1.35575}, {12600,1.35500}, {12700,1.35050}, {12800,1.32275}, {12900,1.39525}, {13000,1.39200}, {13100,1.38525}, {13200,1.41875}, {13300,1.43550}, {13400,1.43350}, {13500,1.43950}, {13600,1.41250}, {13700,1.41525}, {13800,1.50100}, {13900,1.45825}, {14000,1.51350}, {14100,1.52175}, {14200,1.56175}, {14300,1.59675}, {14400,1.50850}, {14500,1.54575}, {14600,1.52900}, {14700,1.55200}, {14800,1.63575}, {14900,1.58625}, {15000,1.60675}, {15100,1.63475}, {15200,1.62275}, {15300,1.64250}, {15400,1.63300}, {15500,1.65475}, {15600,1.68475}, {15700,1.67350}, {15800,1.68600}, {15900,1.76000}, {16000,1.66625}, {16100,1.78300}, {16200,1.73375}, {16300,1.81575}, {16400,1.72250}, {16500,1.84250}, {16600,1.75400}, {16700,1.82375}, {16800,1.79000}, {16900,1.76525}, {17000,1.80675}, {17100,1.89200}, {17200,1.78000}, {17300,1.82400}, {17400,1.83225}, {17500,1.94925}, {17600,1.86575}, {17700,1.86700}, {17800,1.89425}, {17900,1.95250}, {18000,1.95025}, {18100,2.00250}, {18200,1.97725}, {18300,1.95900}, {18400,1.90950}, {18500,1.93225}, {18600,1.99600}, {18700,2.09650}, {18800,2.02550}, {18900,2.00475}, {19000,2.01700}, {19100,2.11600}, {19200,2.10300}, {19300,2.13225}, {19400,2.06400}, {19500,2.06275}, {19600,2.05725}, {19700,2.25750}, {19800,2.06650}, {19900,2.19025}, {20000,2.0775}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["Aggregate"]["user"] = {{1,0.00063063}, {2,0.00145045}, {3,0.00152252}, {4,0.00153153}, {5,0.00156757}, {6,0.00174775}, {7,0.00187387}, {8,0.00192793}, {9,0.00218018}, {10,0.00205405}, {11,0.00225225}, {12,0.00239640}, {13,0.00229730}, {14,0.00238739}, {15,0.00252252}, {16,0.00263964}, {17,0.00265766}, {18,0.00274775}, {19,0.00296396}, {20,0.00281982}, {21,0.00284685}, {22,0.00301802}, {23,0.00311712}, {24,0.00325225}, {25,0.00325225}, {26,0.00324324}, {27,0.00336937}, {28,0.00342342}, {29,0.00351351}, {30,0.00375676}, {31,0.00354054}, {32,0.00383784}, {33,0.00389189}, {34,0.00409910}, {35,0.00423423}, {36,0.00419820}, {37,0.00400901}, {38,0.00442342}, {39,0.00460360}, {40,0.00465766}, {41,0.00472072}, {42,0.00469369}, {43,0.00479279}, {44,0.00481982}, {45,0.00520721}, {46,0.00509910}, {47,0.00524324}, {48,0.00495495}, {49,0.00513514}, {50,0.00538739}, {51,0.00564865}, {52,0.00577477}, {53,0.00541441}, {54,0.00638739}, {55,0.00554054}, {56,0.00631532}, {57,0.00554955}, {58,0.00705405}, {59,0.00604505}, {60,0.00672072}, {61,0.00668468}, {62,0.00636937}, {63,0.00693694}, {64,0.00681982}, {65,0.00664865}, {66,0.00690991}, {67,0.00723423}, {68,0.00745045}, {69,0.00761261}, {70,0.00761261}, {71,0.00753153}, {72,0.00837838}, {73,0.00760360}, {74,0.00769369}, {75,0.00786486}, {76,0.00780180}, {77,0.00798198}, {78,0.00847748}, {79,0.00815315}, {80,0.00815315}, {81,0.00827027}, {82,0.00839640}, {83,0.00876577}, {84,0.00935135}, {85,0.00861261}, {86,0.00858559}, {87,0.00874775}, {88,0.00863964}, {89,0.00921622}, {90,0.00892793}, {91,0.00938739}, {92,0.00921622}, {93,0.00944144}, {94,0.00946847}, {95,0.00963964}, {96,0.00957658}, {97,0.00954955}, {98,0.00951351}, {99,0.00963964}, {100,0.00960360}, {101,0.00965766}, {102,0.01004505}, {103,0.01009910}, {104,0.01079279}, {105,0.01003604}, {106,0.01027928}, {107,0.00991892}, {108,0.01040541}, {109,0.01051351}, {110,0.01045045}, {111,0.01062162}, {112,0.01054955}, {113,0.01146847}, {114,0.01073874}, {115,0.01083784}, {116,0.01103604}, {117,0.01109910}, {118,0.01115315}, {119,0.01129730}, {120,0.01143243}, {121,0.01127928}, {122,0.01128829}, {123,0.01143243}, {124,0.01140541}, {125,0.01162162}, {126,0.01190991}, {127,0.01221622}, {128,0.01199099}, {129,0.01218919}, {130,0.01211712}, {131,0.01230631}, {132,0.01220721}, {133,0.01366667}, {134,0.01254955}, {135,0.01270270}, {136,0.01261261}, {137,0.01351351}, {138,0.01281982}, {139,0.01310811}, {140,0.01324324}, {141,0.01347748}, {142,0.01347748}, {143,0.01363063}, {144,0.01461261}, {145,0.01364865}, {146,0.01374775}, {147,0.01397297}, {148,0.01394595}, {149,0.01423423}, {150,0.01422523}, {151,0.01513514}, {152,0.01415315}, {153,0.01464865}, {154,0.01555856}, {155,0.01491892}, {156,0.01487387}, {157,0.01508108}, {158,0.01488288}, {159,0.01498198}, {160,0.01502703}, {161,0.01532432}, {162,0.01524324}, {163,0.01538739}, {164,0.01525225}, {165,0.01542342}, {166,0.01555856}, {167,0.01676577}, {168,0.01582883}, {169,0.01601802}, {170,0.01618018}, {171,0.01649550}, {172,0.01627027}, {173,0.01651351}, {174,0.01645946}, {175,0.01672072}, {176,0.01654955}, {177,0.01663964}, {178,0.01652252}, {179,0.01679279}, {180,0.01657658}, {181,0.01683784}, {182,0.01715315}, {183,0.01734234}, {184,0.01831532}, {185,0.01710811}, {186,0.01734234}, {187,0.01816216}, {188,0.01730631}, {189,0.01722523}, {190,0.01758559}, {191,0.01809009}, {192,0.01732432}, {193,0.01789189}, {194,0.01755856}, {195,0.01892793}, {196,0.01797297}, {197,0.01790090}, {198,0.01806306}, {199,0.01818018}, {200,0.01812613}, {201,0.01826126}, {202,0.01829730}, {203,0.01929730}, {204,0.01821622}, {205,0.01854955}, {206,0.01872973}, {207,0.01900901}, {208,0.01963964}, {209,0.01835135}, {210,0.01878378}, {211,0.01909910}, {212,0.01896396}, {213,0.02021622}, {214,0.01921622}, {215,0.02083784}, {216,0.01932432}, {217,0.01940541}, {218,0.01981081}, {219,0.01985586}, {220,0.02104505}, {221,0.01989189}, {222,0.01989189}, {223,0.02009009}, {224,0.01990090}, {225,0.02031532}, {226,0.02070270}, {227,0.02171171}, {228,0.02031532}, {229,0.02066667}, {230,0.02093694}, {231,0.02117117}, {232,0.02089189}, {233,0.02129730}, {234,0.02119820}, {235,0.02138739}, {236,0.02241441}, {237,0.02155856}, {238,0.02320721}, {239,0.02163063}, {240,0.02145045}, {241,0.02175676}, {242,0.02181982}, {243,0.02224324}, {244,0.02200000}, {245,0.02222523}, {246,0.02239640}, {247,0.02290090}, {248,0.02257658}, {249,0.02343243}, {250,0.02302703}, {251,0.02445946}, {252,0.02302703}, {253,0.02443243}, {254,0.02323423}, {255,0.02457658}, {256,0.02287387}, {257,0.02406306}, {258,0.02337838}, {259,0.02482883}, {260,0.02335135}, {261,0.02519820}, {262,0.02366667}, {263,0.02602703}, {264,0.02366667}, {265,0.02527928}, {266,0.02415315}, {267,0.02603604}, {268,0.02400000}, {269,0.02554054}, {270,0.02450450}, {271,0.02586486}, {272,0.02443243}, {273,0.02607207}, {274,0.02503604}, {275,0.02603604}, {276,0.02500000}, {277,0.02615315}, {278,0.02547748}, {279,0.02561261}, {280,0.02501802}, {281,0.02557658}, {282,0.02579279}, {283,0.02604505}, {284,0.02599099}, {285,0.02613514}, {286,0.02769369}, {287,0.02645045}, {288,0.02695495}, {289,0.02619820}, {290,0.02733333}, {291,0.02636937}, {292,0.02630631}, {293,0.02665766}, {294,0.02673874}, {295,0.02726126}, {296,0.02663964}, {297,0.02904505}, {298,0.02737838}, {299,0.02890991}, {300,0.02735135}, {301,0.02760360}, {302,0.02781982}, {303,0.02771171}, {304,0.02991892}, {305,0.02774775}, {306,0.02916216}, {307,0.02827928}, {308,0.02795495}, {309,0.03140541}, {310,0.02827027}, {311,0.03019820}, {312,0.02831532}, {313,0.02851351}, {314,0.02886486}, {315,0.02893694}, {316,0.03162162}, {317,0.02931532}, {318,0.02920721}, {319,0.02980180}, {320,0.02884685}, {321,0.03071171}, {322,0.02915315}, {323,0.02966667}, {324,0.02906306}, {325,0.02967568}, {326,0.03101802}, {327,0.02971171}, {328,0.02970270}, {329,0.03132432}, {330,0.03013514}, {331,0.03032432}, {332,0.03016216}, {333,0.03017117}, {334,0.03236036}, {335,0.03090991}, {336,0.02997297}, {337,0.03221622}, {338,0.03025225}, {339,0.03108108}, {340,0.03263063}, {341,0.03142342}, {342,0.03199099}, {343,0.03163964}, {344,0.03136036}, {345,0.03302703}, {346,0.03161261}, {347,0.03207207}, {348,0.03309009}, {349,0.03202703}, {350,0.03221622}, {351,0.03411712}, {352,0.03189189}, {353,0.03216216}, {354,0.03366667}, {355,0.03215315}, {356,0.03237838}, {357,0.03375676}, {358,0.03255856}, {359,0.03312613}, {360,0.03392793}, {361,0.03280180}, {362,0.03295495}, {363,0.03481982}, {364,0.03312613}, {365,0.03327027}, {366,0.03459459}, {367,0.03396396}, {368,0.03336036}, {369,0.03363063}, {370,0.03500000}, {371,0.03408108}, {372,0.03398198}, {373,0.03545045}, {374,0.03402703}, {375,0.03440541}, {376,0.03554054}, {377,0.03449550}, {378,0.03431532}, {379,0.03483784}, {380,0.03558559}, {381,0.03482883}, {382,0.03477477}, {383,0.03645946}, {384,0.03402703}, {385,0.03478378}, {386,0.03478378}, {387,0.03608108}, {388,0.03471171}, {389,0.03514414}, {390,0.03677477}, {391,0.03718018}, {392,0.03519820}, {393,0.03527928}, {394,0.03637838}, {395,0.03854054}, {396,0.03578378}, {397,0.03579279}, {398,0.03736036}, {399,0.03602703}, {400,0.03579279}, {401,0.03576577}, {402,0.03722523}, {403,0.03664865}, {404,0.03632432}, {405,0.03652252}, {406,0.03792793}, {407,0.03939640}, {408,0.03643243}, {409,0.03671171}, {410,0.03798198}, {411,0.03932432}, {412,0.03722523}, {413,0.03746847}, {414,0.03748649}, {415,0.03900000}, {416,0.03714414}, {417,0.03706306}, {418,0.03756757}, {419,0.03873874}, {420,0.03946847}, {421,0.03779279}, {422,0.03802703}, {423,0.03821622}, {424,0.03870270}, {425,0.04101802}, {426,0.03835135}, {427,0.03852252}, {428,0.03847748}, {429,0.04027027}, {430,0.04193694}, {431,0.03904505}, {432,0.03847748}, {433,0.03884685}, {434,0.04004505}, {435,0.04144144}, {436,0.03912613}, {437,0.03923423}, {438,0.03925225}, {439,0.04180180}, {440,0.04193694}, {441,0.03965766}, {442,0.04027027}, {443,0.04012613}, {444,0.04020721}, {445,0.04172973}, {446,0.04289189}, {447,0.04081982}, {448,0.03957658}, {449,0.03990991}, {450,0.03973874}, {451,0.04227027}, {452,0.04287387}, {453,0.04383784}, {454,0.04091892}, {455,0.04102703}, {456,0.04031532}, {457,0.04177477}, {458,0.04253153}, {459,0.04335135}, {460,0.04170270}, {461,0.04176577}, {462,0.04166667}, {463,0.04209009}, {464,0.04159459}, {465,0.04316216}, {466,0.04423423}, {467,0.04522523}, {468,0.04231532}, {469,0.04272973}, {470,0.04253153}, {471,0.04299099}, {472,0.04373874}, {473,0.04441441}, {474,0.04520721}, {475,0.04518018}, {476,0.04300901}, {477,0.04340541}, {478,0.04341441}, {479,0.04370270}, {480,0.04273874}, {481,0.04433333}, {482,0.04503604}, {483,0.04548649}, {484,0.04541441}, {485,0.04663964}, {486,0.04414414}, {487,0.04432432}, {488,0.04382883}, {489,0.04431532}, {490,0.04453153}, {491,0.04470270}, {492,0.04528829}, {493,0.04627027}, {494,0.04662162}, {495,0.04711712}, {496,0.04591892}, {497,0.04525225}, {498,0.04498198}, {499,0.04552252}, {500,0.04522523}, {505,0.04581982}, {510,0.04656757}, {515,0.04618018}, {520,0.04646847}, {525,0.04745946}, {530,0.04749550}, {535,0.04824324}, {540,0.04813514}, {545,0.04862162}, {550,0.04924324}, {555,0.04979279}, {560,0.04974775}, {565,0.05043243}, {570,0.05090991}, {575,0.05245045}, {580,0.05123423}, {585,0.05184685}, {590,0.05321622}, {595,0.05535135}, {600,0.05552252}, {605,0.05621622}, {610,0.05630631}, {615,0.05597297}, {620,0.05597297}, {625,0.05608108}, {630,0.06088288}, {635,0.06089189}, {640,0.05799099}, {645,0.05738739}, {650,0.05777477}, {655,0.05968468}, {660,0.06053153}, {665,0.06154955}, {670,0.06100000}, {675,0.06099099}, {680,0.06372072}, {685,0.06415315}, {690,0.06233333}, {695,0.06387387}, {700,0.06508108}, {705,0.06494595}, {710,0.06398198}, {715,0.06712613}, {720,0.06564865}, {725,0.06567568}, {730,0.06968468}, {735,0.06906306}, {740,0.06633333}, {745,0.06901802}, {750,0.06927928}, {755,0.07138739}, {760,0.06962162}, {765,0.07018018}, {770,0.07131532}, {775,0.06991892}, {780,0.07230631}, {785,0.07180180}, {790,0.07611712}, {795,0.07431532}, {800,0.07095495}, {805,0.07388288}, {810,0.07253153}, {815,0.07636937}, {820,0.07384685}, {825,0.07745946}, {830,0.07589189}, {835,0.07661261}, {840,0.07763063}, {845,0.07756757}, {850,0.07872072}, {855,0.07895495}, {860,0.08009009}, {865,0.07740541}, {870,0.08039640}, {875,0.08142342}, {880,0.07992793}, {885,0.08351351}, {890,0.08589189}, {895,0.08457658}, {900,0.08282883}, {905,0.08098198}, {910,0.08403604}, {915,0.08572973}, {920,0.08727027}, {925,0.08558559}, {930,0.08660360}, {935,0.08779279}, {940,0.08488288}, {945,0.08837838}, {950,0.08916216}, {955,0.08976577}, {960,0.08561261}, {965,0.08878378}, {970,0.09036036}, {975,0.09164865}, {980,0.09274775}, {985,0.09237838}, {990,0.09380180}, {995,0.09309910}, {1000,0.09279279}, {1010,0.09384685}, {1020,0.09818919}, {1030,0.09209009}, {1040,0.09500000}, {1050,0.09800901}, {1060,0.09818919}, {1070,0.10031532}, {1080,0.10025225}, {1090,0.10043243}, {1100,0.10224324}, {1110,0.10333333}, {1120,0.10319820}, {1130,0.10540541}, {1140,0.10644144}, {1150,0.10981081}, {1160,0.10981982}, {1170,0.10737838}, {1180,0.10895495}, {1190,0.11076577}, {1200,0.11095495}, {1210,0.11433333}, {1220,0.11251351}, {1230,0.11440541}, {1240,0.11457658}, {1250,0.11671171}, {1260,0.11732432}, {1270,0.11898198}, {1280,0.11673874}, {1290,0.11775676}, {1300,0.11943243}, {1310,0.12799099}, {1320,0.12304505}, {1330,0.12517117}, {1340,0.12591892}, {1350,0.12755856}, {1360,0.12743243}, {1370,0.12972973}, {1380,0.12685586}, {1390,0.13068468}, {1400,0.12948649}, {1410,0.13355856}, {1420,0.13087387}, {1430,0.13887387}, {1440,0.13194595}, {1450,0.13422523}, {1460,0.13747748}, {1470,0.13918018}, {1480,0.13837838}, {1490,0.14562162}, {1500,0.14548649}, {1510,0.14187387}, {1520,0.14092793}, {1530,0.14386486}, {1540,0.14218919}, {1550,0.14812613}, {1560,0.14339640}, {1570,0.14434234}, {1580,0.14555856}, {1590,0.14968468}, {1600,0.14573874}, {1610,0.15409910}, {1620,0.15184685}, {1630,0.15509009}, {1640,0.15288288}, {1650,0.15525225}, {1660,0.15735135}, {1670,0.15921622}, {1680,0.15567568}, {1690,0.15708108}, {1700,0.16200000}, {1710,0.16029730}, {1720,0.16097297}, {1730,0.16503604}, {1740,0.16264865}, {1750,0.16917117}, {1760,0.16461261}, {1770,0.16623423}, {1780,0.16799099}, {1790,0.17224324}, {1800,0.16554955}, {1810,0.17178378}, {1820,0.17015315}, {1830,0.17090991}, {1840,0.17620721}, {1850,0.17645946}, {1860,0.17212613}, {1870,0.17625225}, {1880,0.17603604}, {1890,0.17807207}, {1900,0.18050450}, {1910,0.18276577}, {1920,0.17832432}, {1930,0.18109910}, {1940,0.18059459}, {1950,0.18429730}, {1960,0.18500901}, {1970,0.18563063}, {1980,0.19194595}, {1990,0.18852252}, {2000,0.18672973}, {2050,0.19333333}, {2100,0.19612613}, {2150,0.20387387}, {2200,0.20629730}, {2250,0.21345946}, {2300,0.22587387}, {2350,0.22836036}, {2400,0.22410811}, {2450,0.23981982}, {2500,1.49746847}, {2550,0.25133333}, {2600,0.25827027}, {2650,0.25398198}, {2700,0.25309009}, {2750,0.26862162}, {2800,0.26512613}, {2850,0.26745946}, {2900,0.27555856}, {2950,0.28633333}, {3000,0.29061261}, {3050,0.30149550}, {3100,0.29403604}, {3150,0.30294595}, {3200,0.29974775}, {3250,0.31113514}, {3300,0.31748649}, {3350,0.32041441}, {3400,0.32340541}, {3450,0.33951351}, {3500,0.33544144}, {3550,0.35000901}, {3600,0.33855856}, {3650,0.34669369}, {3700,0.36071171}, {3750,0.35953153}, {3800,0.36550450}, {3850,0.36744144}, {3900,0.37761261}, {3950,0.39094595}, {4000,0.38590991}, {4050,0.38836937}, {4100,0.39363063}, {4150,0.40633333}, {4200,0.40168468}, {4250,0.42041441}, {4300,0.41902703}, {4350,0.43518919}, {4400,0.42621622}, {4450,0.43633333}, {4500,0.44455856}, {4550,0.44367568}, {4600,0.45565766}, {4650,0.45054955}, {4700,0.46489189}, {4750,0.46461261}, {4800,0.46710811}, {4850,0.47947748}, {4900,0.48150450}, {4950,0.49030631}, {5000,0.48643243}, {5050,0.50463063}, {5100,0.51373874}, {5150,0.50814414}, {5200,0.50199099}, {5250,0.50815315}, {5300,0.53488288}, {5350,0.52763964}, {5400,0.53327027}, {5450,0.53972072}, {5500,0.55936036}, {5550,0.57219820}, {5600,0.57406306}, {5650,0.56660360}, {5700,0.56163063}, {5750,0.57938739}, {5800,0.58555856}, {5850,0.60295495}, {5900,0.58417117}, {5950,0.60920721}, {6000,0.61396396}, {6050,0.61650}, {6100,0.61075}, {6150,0.59975}, {6200,0.60375}, {6250,0.63425}, {6300,0.61725}, {6350,0.64625}, {6400,0.61950}, {6450,0.63175}, {6500,0.63150}, {6550,0.64650}, {6600,0.64925}, {6650,0.67300}, {6700,0.67150}, {6750,0.68625}, {6800,0.66150}, {6850,0.70075}, {6900,0.70750}, {6950,0.69475}, {7000,0.71250}, {7050,0.72250}, {7100,0.72375}, {7150,0.73225}, {7200,0.71950}, {7250,0.72450}, {7300,0.72375}, {7350,0.76575}, {7400,0.75150}, {7450,0.75725}, {7500,0.82175}, {7550,0.79350}, {7600,0.79050}, {7650,0.79500}, {7700,0.79950}, {7750,0.82850}, {7800,0.80550}, {7850,0.81675}, {7900,0.81625}, {7950,0.81575}, {8000,0.78475}, {8050,0.84725}, {8100,0.86575}, {8150,0.86675}, {8200,0.85750}, {8250,0.87325}, {8300,0.82450}, {8350,0.87200}, {8400,0.84525}, {8450,0.86325}, {8500,0.86425}, {8550,0.87550}, {8600,0.92050}, {8650,0.89050}, {8700,0.92850}, {8750,0.93975}, {8800,0.92250}, {8850,0.89975}, {8900,0.90975}, {8950,0.94175}, {9000,0.92725}, {9050,0.97175}, {9100,0.94125}, {9150,0.98250}, {9200,0.97050}, {9250,0.94425}, {9300,0.94825}, {9350,0.96425}, {9400,0.96950}, {9450,0.99450}, {9500,0.96650}, {9550,1.00025}, {9600,0.94825}, {9650,1.04325}, {9700,1.02450}, {9750,1.03175}, {9800,1.01350}, {9850,1.06650}, {9900,1.05650}, {9950,1.06650}, {10000,1.08300}, {10100,1.11125}, {10200,1.11400}, {10300,1.08575}, {10400,1.07850}, {10500,1.09450}, {10600,1.12000}, {10700,1.11650}, {10800,1.11875}, {10900,1.17225}, {11000,1.19100}, {11100,1.15850}, {11200,1.17025}, {11300,1.20050}, {11400,1.14450}, {11500,1.22225}, {11600,1.22025}, {11700,1.26050}, {11800,1.24175}, {11900,1.27250}, {12000,1.25975}, {12100,1.27200}, {12200,1.33750}, {12300,1.26225}, {12400,1.30975}, {12500,1.35425}, {12600,1.35450}, {12700,1.34750}, {12800,1.32350}, {12900,1.39550}, {13000,1.39025}, {13100,1.38250}, {13200,1.41850}, {13300,1.43500}, {13400,1.43425}, {13500,1.43650}, {13600,1.41175}, {13700,1.41425}, {13800,1.50050}, {13900,1.45525}, {14000,1.51275}, {14100,1.52275}, {14200,1.56075}, {14300,1.59750}, {14400,1.50600}, {14500,1.54450}, {14600,1.53000}, {14700,1.55075}, {14800,1.63575}, {14900,1.58575}, {15000,1.60550}, {15100,1.63450}, {15200,1.62200}, {15300,1.64275}, {15400,1.63150}, {15500,1.65350}, {15600,1.68350}, {15700,1.67375}, {15800,1.68625}, {15900,1.75850}, {16000,1.66475}, {16100,1.78225}, {16200,1.73375}, {16300,1.81675}, {16400,1.72275}, {16500,1.84125}, {16600,1.75225}, {16700,1.82350}, {16800,1.79025}, {16900,1.76400}, {17000,1.80550}, {17100,1.89125}, {17200,1.77800}, {17300,1.82150}, {17400,1.83025}, {17500,1.94925}, {17600,1.86550}, {17700,1.86725}, {17800,1.89325}, {17900,1.95325}, {18000,1.94925}, {18100,2.00150}, {18200,1.97675}, {18300,1.95900}, {18400,1.90625}, {18500,1.93150}, {18600,1.99675}, {18700,2.09450}, {18800,2.02475}, {18900,2.00525}, {19000,2.01675}, {19100,2.11525}, {19200,2.10275}, {19300,2.13150}, {19400,2.06350}, {19500,2.06250}, {19600,2.05700}, {19700,2.25775}, {19800,2.06900}, {19900,2.18825}, {20000,2.0770}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["Aggregate"]["system"] = {{1,0.00084685}, {2,0.00002703}, {3,0.00003604}, {4,0.00003604}, {5,0.00006306}, {6,0.00003604}, {7,0.00000000}, {8,0.00003604}, {9,0.00003604}, {10,0.00003604}, {11,0.00003604}, {12,0.00003604}, {13,0.00000000}, {14,0.00000000}, {15,0.00006306}, {16,0.00005405}, {17,0.00006306}, {18,0.00000000}, {19,0.00007207}, {20,0.00007207}, {21,0.00000000}, {22,0.00002703}, {23,0.00000000}, {24,0.00002703}, {25,0.00003604}, {26,0.00000000}, {27,0.00003604}, {28,0.00003604}, {29,0.00007207}, {30,0.00007207}, {31,0.00003604}, {32,0.00005405}, {33,0.00007207}, {34,0.00000000}, {35,0.00007207}, {36,0.00003604}, {37,0.00003604}, {38,0.00007207}, {39,0.00006306}, {40,0.00003604}, {41,0.00005405}, {42,0.00003604}, {43,0.00003604}, {44,0.00000000}, {45,0.00003604}, {46,0.00003604}, {47,0.00000000}, {48,0.00003604}, {49,0.00000000}, {50,0.00010811}, {51,0.00003604}, {52,0.00003604}, {53,0.00003604}, {54,0.00000000}, {55,0.00009910}, {56,0.00003604}, {57,0.00007207}, {58,0.00009910}, {59,0.00007207}, {60,0.00010811}, {61,0.00003604}, {62,0.00008108}, {63,0.00009910}, {64,0.00000000}, {65,0.00006306}, {66,0.00007207}, {67,0.00002703}, {68,0.00003604}, {69,0.00000000}, {70,0.00003604}, {71,0.00003604}, {72,0.00003604}, {73,0.00013514}, {74,0.00007207}, {75,0.00009910}, {76,0.00003604}, {77,0.00000000}, {78,0.00009009}, {79,0.00003604}, {80,0.00006306}, {81,0.00007207}, {82,0.00002703}, {83,0.00002703}, {84,0.00003604}, {85,0.00000000}, {86,0.00007207}, {87,0.00002703}, {88,0.00009910}, {89,0.00006306}, {90,0.00010811}, {91,0.00007207}, {92,0.00006306}, {93,0.00000000}, {94,0.00009009}, {95,0.00003604}, {96,0.00007207}, {97,0.00003604}, {98,0.00006306}, {99,0.00006306}, {100,0.00009910}, {101,0.00003604}, {102,0.00002703}, {103,0.00003604}, {104,0.00010811}, {105,0.00002703}, {106,0.00007207}, {107,0.00009910}, {108,0.00007207}, {109,0.00007207}, {110,0.00010811}, {111,0.00003604}, {112,0.00000000}, {113,0.00008108}, {114,0.00003604}, {115,0.00007207}, {116,0.00009910}, {117,0.00000000}, {118,0.00009910}, {119,0.00003604}, {120,0.00003604}, {121,0.00010811}, {122,0.00009910}, {123,0.00002703}, {124,0.00007207}, {125,0.00002703}, {126,0.00009009}, {127,0.00010811}, {128,0.00007207}, {129,0.00012613}, {130,0.00006306}, {131,0.00006306}, {132,0.00014414}, {133,0.00009910}, {134,0.00003604}, {135,0.00000000}, {136,0.00007207}, {137,0.00002703}, {138,0.00007207}, {139,0.00002703}, {140,0.00007207}, {141,0.00014414}, {142,0.00002703}, {143,0.00000000}, {144,0.00010811}, {145,0.00003604}, {146,0.00003604}, {147,0.00007207}, {148,0.00007207}, {149,0.00007207}, {150,0.00007207}, {151,0.00007207}, {152,0.00006306}, {153,0.00010811}, {154,0.00009009}, {155,0.00003604}, {156,0.00014414}, {157,0.00000000}, {158,0.00010811}, {159,0.00007207}, {160,0.00007207}, {161,0.00003604}, {162,0.00003604}, {163,0.00007207}, {164,0.00006306}, {165,0.00003604}, {166,0.00010811}, {167,0.00017117}, {168,0.00010811}, {169,0.00003604}, {170,0.00007207}, {171,0.00000000}, {172,0.00007207}, {173,0.00014414}, {174,0.00003604}, {175,0.00002703}, {176,0.00007207}, {177,0.00009009}, {178,0.00009910}, {179,0.00007207}, {180,0.00003604}, {181,0.00006306}, {182,0.00009910}, {183,0.00003604}, {184,0.00014414}, {185,0.00007207}, {186,0.00007207}, {187,0.00014414}, {188,0.00003604}, {189,0.00009910}, {190,0.00003604}, {191,0.00003604}, {192,0.00009910}, {193,0.00003604}, {194,0.00003604}, {195,0.00006306}, {196,0.00000000}, {197,0.00003604}, {198,0.00010811}, {199,0.00009009}, {200,0.00000000}, {201,0.00007207}, {202,0.00007207}, {203,0.00000000}, {204,0.00003604}, {205,0.00010811}, {206,0.00013514}, {207,0.00009009}, {208,0.00018919}, {209,0.00009009}, {210,0.00003604}, {211,0.00007207}, {212,0.00003604}, {213,0.00010811}, {214,0.00009910}, {215,0.00007207}, {216,0.00000000}, {217,0.00021622}, {218,0.00003604}, {219,0.00007207}, {220,0.00003604}, {221,0.00014414}, {222,0.00010811}, {223,0.00009910}, {224,0.00014414}, {225,0.00012613}, {226,0.00000000}, {227,0.00010811}, {228,0.00013514}, {229,0.00007207}, {230,0.00000000}, {231,0.00006306}, {232,0.00000000}, {233,0.00003604}, {234,0.00012613}, {235,0.00007207}, {236,0.00007207}, {237,0.00010811}, {238,0.00007207}, {239,0.00007207}, {240,0.00006306}, {241,0.00018018}, {242,0.00010811}, {243,0.00010811}, {244,0.00000000}, {245,0.00010811}, {246,0.00003604}, {247,0.00010811}, {248,0.00000000}, {249,0.00007207}, {250,0.00010811}, {251,0.00012613}, {252,0.00010811}, {253,0.00009009}, {254,0.00002703}, {255,0.00010811}, {256,0.00007207}, {257,0.00014414}, {258,0.00006306}, {259,0.00000000}, {260,0.00013514}, {261,0.00014414}, {262,0.00009910}, {263,0.00007207}, {264,0.00007207}, {265,0.00016216}, {266,0.00014414}, {267,0.00023423}, {268,0.00018018}, {269,0.00010811}, {270,0.00009910}, {271,0.00010811}, {272,0.00007207}, {273,0.00003604}, {274,0.00018018}, {275,0.00014414}, {276,0.00009910}, {277,0.00017117}, {278,0.00006306}, {279,0.00020721}, {280,0.00006306}, {281,0.00003604}, {282,0.00007207}, {283,0.00007207}, {284,0.00010811}, {285,0.00003604}, {286,0.00023423}, {287,0.00007207}, {288,0.00007207}, {289,0.00021622}, {290,0.00018018}, {291,0.00003604}, {292,0.00010811}, {293,0.00007207}, {294,0.00010811}, {295,0.00003604}, {296,0.00003604}, {297,0.00010811}, {298,0.00003604}, {299,0.00014414}, {300,0.00003604}, {301,0.00010811}, {302,0.00007207}, {303,0.00007207}, {304,0.00011712}, {305,0.00010811}, {306,0.00007207}, {307,0.00009910}, {308,0.00020721}, {309,0.00010811}, {310,0.00000000}, {311,0.00031532}, {312,0.00013514}, {313,0.00014414}, {314,0.00003604}, {315,0.00014414}, {316,0.00009910}, {317,0.00003604}, {318,0.00010811}, {319,0.00010811}, {320,0.00002703}, {321,0.00010811}, {322,0.00002703}, {323,0.00002703}, {324,0.00006306}, {325,0.00007207}, {326,0.00003604}, {327,0.00021622}, {328,0.00007207}, {329,0.00017117}, {330,0.00007207}, {331,0.00014414}, {332,0.00006306}, {333,0.00010811}, {334,0.00007207}, {335,0.00007207}, {336,0.00000000}, {337,0.00007207}, {338,0.00003604}, {339,0.00003604}, {340,0.00010811}, {341,0.00003604}, {342,0.00006306}, {343,0.00003604}, {344,0.00003604}, {345,0.00022523}, {346,0.00000000}, {347,0.00010811}, {348,0.00010811}, {349,0.00009009}, {350,0.00009910}, {351,0.00005405}, {352,0.00010811}, {353,0.00010811}, {354,0.00010811}, {355,0.00032432}, {356,0.00009910}, {357,0.00020721}, {358,0.00009910}, {359,0.00007207}, {360,0.00007207}, {361,0.00003604}, {362,0.00014414}, {363,0.00003604}, {364,0.00010811}, {365,0.00010811}, {366,0.00016216}, {367,0.00007207}, {368,0.00007207}, {369,0.00002703}, {370,0.00014414}, {371,0.00014414}, {372,0.00007207}, {373,0.00007207}, {374,0.00003604}, {375,0.00010811}, {376,0.00019820}, {377,0.00010811}, {378,0.00021622}, {379,0.00003604}, {380,0.00018018}, {381,0.00013514}, {382,0.00007207}, {383,0.00016216}, {384,0.00009910}, {385,0.00007207}, {386,0.00010811}, {387,0.00013514}, {388,0.00014414}, {389,0.00014414}, {390,0.00013514}, {391,0.00007207}, {392,0.00007207}, {393,0.00007207}, {394,0.00013514}, {395,0.00027027}, {396,0.00003604}, {397,0.00014414}, {398,0.00003604}, {399,0.00009009}, {400,0.00007207}, {401,0.00002703}, {402,0.00009910}, {403,0.00000000}, {404,0.00003604}, {405,0.00013514}, {406,0.00006306}, {407,0.00007207}, {408,0.00003604}, {409,0.00010811}, {410,0.00019820}, {411,0.00020721}, {412,0.00018018}, {413,0.00003604}, {414,0.00006306}, {415,0.00014414}, {416,0.00010811}, {417,0.00010811}, {418,0.00003604}, {419,0.00014414}, {420,0.00014414}, {421,0.00010811}, {422,0.00003604}, {423,0.00007207}, {424,0.00018018}, {425,0.00016216}, {426,0.00000000}, {427,0.00006306}, {428,0.00007207}, {429,0.00000000}, {430,0.00038739}, {431,0.00003604}, {432,0.00007207}, {433,0.00014414}, {434,0.00018018}, {435,0.00010811}, {436,0.00006306}, {437,0.00015315}, {438,0.00014414}, {439,0.00007207}, {440,0.00009910}, {441,0.00003604}, {442,0.00010811}, {443,0.00009910}, {444,0.00009910}, {445,0.00003604}, {446,0.00007207}, {447,0.00009910}, {448,0.00024324}, {449,0.00006306}, {450,0.00014414}, {451,0.00003604}, {452,0.00014414}, {453,0.00023423}, {454,0.00003604}, {455,0.00000000}, {456,0.00002703}, {457,0.00024324}, {458,0.00024324}, {459,0.00020721}, {460,0.00007207}, {461,0.00003604}, {462,0.00018018}, {463,0.00014414}, {464,0.00009910}, {465,0.00010811}, {466,0.00007207}, {467,0.00035135}, {468,0.00014414}, {469,0.00018018}, {470,0.00007207}, {471,0.00007207}, {472,0.00018018}, {473,0.00014414}, {474,0.00007207}, {475,0.00014414}, {476,0.00010811}, {477,0.00009910}, {478,0.00010811}, {479,0.00018018}, {480,0.00017117}, {481,0.00010811}, {482,0.00018018}, {483,0.00027928}, {484,0.00018018}, {485,0.00027027}, {486,0.00003604}, {487,0.00013514}, {488,0.00007207}, {489,0.00013514}, {490,0.00007207}, {491,0.00010811}, {492,0.00013514}, {493,0.00033333}, {494,0.00024324}, {495,0.00010811}, {496,0.00027027}, {497,0.00010811}, {498,0.00006306}, {499,0.00003604}, {500,0.00013514}, {505,0.00007207}, {510,0.00003604}, {515,0.00003604}, {520,0.00009910}, {525,0.00003604}, {530,0.00010811}, {535,0.00003604}, {540,0.00013514}, {545,0.00010811}, {550,0.00003604}, {555,0.00017117}, {560,0.00003604}, {565,0.00013514}, {570,0.00021622}, {575,0.00014414}, {580,0.00010811}, {585,0.00014414}, {590,0.00003604}, {595,0.00018018}, {600,0.00010811}, {605,0.00020721}, {610,0.00018018}, {615,0.00020721}, {620,0.00014414}, {625,0.00020721}, {630,0.00035135}, {635,0.00020721}, {640,0.00024324}, {645,0.00018018}, {650,0.00021622}, {655,0.00010811}, {660,0.00013514}, {665,0.00014414}, {670,0.00002703}, {675,0.00014414}, {680,0.00023423}, {685,0.00007207}, {690,0.00010811}, {695,0.00017117}, {700,0.00007207}, {705,0.00018018}, {710,0.00003604}, {715,0.00021622}, {720,0.00024324}, {725,0.00007207}, {730,0.00018018}, {735,0.00018018}, {740,0.00014414}, {745,0.00009910}, {750,0.00017117}, {755,0.00012613}, {760,0.00045946}, {765,0.00009910}, {770,0.00027928}, {775,0.00007207}, {780,0.00027928}, {785,0.00013514}, {790,0.00014414}, {795,0.00013514}, {800,0.00020721}, {805,0.00017117}, {810,0.00003604}, {815,0.00014414}, {820,0.00016216}, {825,0.00010811}, {830,0.00007207}, {835,0.00007207}, {840,0.00027027}, {845,0.00029730}, {850,0.00025225}, {855,0.00006306}, {860,0.00031532}, {865,0.00027928}, {870,0.00013514}, {875,0.00049550}, {880,0.00017117}, {885,0.00025225}, {890,0.00014414}, {895,0.00021622}, {900,0.00032432}, {905,0.00021622}, {910,0.00010811}, {915,0.00025225}, {920,0.00018018}, {925,0.00010811}, {930,0.00021622}, {935,0.00021622}, {940,0.00027928}, {945,0.00036937}, {950,0.00035135}, {955,0.00003604}, {960,0.00002703}, {965,0.00010811}, {970,0.00009910}, {975,0.00018018}, {980,0.00007207}, {985,0.00000000}, {990,0.00043243}, {995,0.00010811}, {1000,0.00017117}, {1010,0.00024324}, {1020,0.00032432}, {1030,0.00013514}, {1040,0.00024324}, {1050,0.00025225}, {1060,0.00025225}, {1070,0.00036036}, {1080,0.00024324}, {1090,0.00032432}, {1100,0.00028829}, {1110,0.00027928}, {1120,0.00018018}, {1130,0.00027928}, {1140,0.00020721}, {1150,0.00007207}, {1160,0.00034234}, {1170,0.00006306}, {1180,0.00013514}, {1190,0.00025225}, {1200,0.00024324}, {1210,0.00007207}, {1220,0.00035135}, {1230,0.00031532}, {1240,0.00031532}, {1250,0.00021622}, {1260,0.00018018}, {1270,0.00032432}, {1280,0.00031532}, {1290,0.00028829}, {1300,0.00036036}, {1310,0.00025225}, {1320,0.00010811}, {1330,0.00037838}, {1340,0.00017117}, {1350,0.00014414}, {1360,0.00024324}, {1370,0.00014414}, {1380,0.00032432}, {1390,0.00020721}, {1400,0.00025225}, {1410,0.00020721}, {1420,0.00018018}, {1430,0.00016216}, {1440,0.00028829}, {1450,0.00014414}, {1460,0.00024324}, {1470,0.00032432}, {1480,0.00006306}, {1490,0.00027928}, {1500,0.00021622}, {1510,0.00018018}, {1520,0.00036036}, {1530,0.00025225}, {1540,0.00025225}, {1550,0.00036036}, {1560,0.00025225}, {1570,0.00014414}, {1580,0.00028829}, {1590,0.00031532}, {1600,0.00020721}, {1610,0.00027027}, {1620,0.00041441}, {1630,0.00025225}, {1640,0.00038739}, {1650,0.00021622}, {1660,0.00028829}, {1670,0.00031532}, {1680,0.00035135}, {1690,0.00021622}, {1700,0.00039640}, {1710,0.00028829}, {1720,0.00013514}, {1730,0.00017117}, {1740,0.00025225}, {1750,0.00036036}, {1760,0.00028829}, {1770,0.00018018}, {1780,0.00039640}, {1790,0.00020721}, {1800,0.00010811}, {1810,0.00024324}, {1820,0.00021622}, {1830,0.00028829}, {1840,0.00014414}, {1850,0.00010811}, {1860,0.00014414}, {1870,0.00014414}, {1880,0.00025225}, {1890,0.00003604}, {1900,0.00003604}, {1910,0.00017117}, {1920,0.00006306}, {1930,0.00010811}, {1940,0.00021622}, {1950,0.00018018}, {1960,0.00019820}, {1970,0.00021622}, {1980,0.00006306}, {1990,0.00025225}, {2000,0.00020721}, {2050,0.00014414}, {2100,0.00014414}, {2150,0.00027928}, {2200,0.00018018}, {2250,0.00014414}, {2300,0.00025225}, {2350,0.00025225}, {2400,0.00018018}, {2450,0.00003604}, {2500,0.00219820}, {2550,0.00018018}, {2600,0.00010811}, {2650,0.00010811}, {2700,0.00023423}, {2750,0.00010811}, {2800,0.00036036}, {2850,0.00025225}, {2900,0.00020721}, {2950,0.00025225}, {3000,0.00009910}, {3050,0.00021622}, {3100,0.00014414}, {3150,0.00014414}, {3200,0.00020721}, {3250,0.00020721}, {3300,0.00014414}, {3350,0.00009910}, {3400,0.00020721}, {3450,0.00010811}, {3500,0.00007207}, {3550,0.00014414}, {3600,0.00003604}, {3650,0.00010811}, {3700,0.00021622}, {3750,0.00014414}, {3800,0.00010811}, {3850,0.00014414}, {3900,0.00020721}, {3950,0.00025225}, {4000,0.00027928}, {4050,0.00028829}, {4100,0.00007207}, {4150,0.00035135}, {4200,0.00007207}, {4250,0.00018018}, {4300,0.00009910}, {4350,0.00007207}, {4400,0.00012613}, {4450,0.00010811}, {4500,0.00007207}, {4550,0.00013514}, {4600,0.00025225}, {4650,0.00010811}, {4700,0.00014414}, {4750,0.00014414}, {4800,0.00025225}, {4850,0.00012613}, {4900,0.00035135}, {4950,0.00041441}, {5000,0.00056757}, {5050,0.00032432}, {5100,0.00024324}, {5150,0.00017117}, {5200,0.00020721}, {5250,0.00036036}, {5300,0.00021622}, {5350,0.00021622}, {5400,0.00007207}, {5450,0.00028829}, {5500,0.00003604}, {5550,0.00025225}, {5600,0.00003604}, {5650,0.00036036}, {5700,0.00023423}, {5750,0.00074775}, {5800,0.00067568}, {5850,0.00097297}, {5900,0.00074775}, {5950,0.00063964}, {6000,0.00081081}, {6050,0.00200}, {6100,0.00200}, {6150,0.00100}, {6200,0.00200}, {6250,0.00000}, {6300,0.00000}, {6350,0.00100}, {6400,0.00200}, {6450,0.00000}, {6500,0.00000}, {6550,0.00100}, {6600,0.00000}, {6650,0.00000}, {6700,0.00100}, {6750,0.00100}, {6800,0.00175}, {6850,0.00200}, {6900,0.00200}, {6950,0.00100}, {7000,0.00200}, {7050,0.00000}, {7100,0.00175}, {7150,0.00000}, {7200,0.00000}, {7250,0.00200}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00100}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00100}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00100}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00100}, {9050,0.00000}, {9100,0.00100}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00100}, {9700,0.00100}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00100}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00100}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00100}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00100}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00075}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00200}, {14000,0.00100}, {14100,0.00000}, {14200,0.00100}, {14300,0.00000}, {14400,0.00100}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00100}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00100}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00100}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00200}, {18500,0.00000}, {18600,0.00000}, {18700,0.00075}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00100}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000901}, {13,0.00024324}, {14,0.00073874}, {15,0.00100000}, {16,0.00100000}, {17,0.00100000}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00100000}, {23,0.00100000}, {24,0.00100000}, {25,0.00100000}, {26,0.00108108}, {27,0.00118018}, {28,0.00118018}, {29,0.00196396}, {30,0.00200000}, {31,0.00200000}, {32,0.00200000}, {33,0.00200000}, {34,0.00200000}, {35,0.00200000}, {36,0.00200000}, {37,0.00200000}, {38,0.00200000}, {39,0.00207207}, {40,0.00208108}, {41,0.00216216}, {42,0.00216216}, {43,0.00259459}, {44,0.00299099}, {45,0.00300000}, {46,0.00300000}, {47,0.00300000}, {48,0.00300000}, {49,0.00300000}, {50,0.00300000}, {51,0.00300901}, {52,0.00301802}, {53,0.00309910}, {54,0.00310811}, {55,0.00311712}, {56,0.00310811}, {57,0.00336937}, {58,0.00381081}, {59,0.00400000}, {60,0.00400000}, {61,0.00400000}, {62,0.00400000}, {63,0.00400000}, {64,0.00400000}, {65,0.00403604}, {66,0.00405405}, {67,0.00408108}, {68,0.00411712}, {69,0.00409910}, {70,0.00410811}, {71,0.00439640}, {72,0.00517117}, {73,0.00493694}, {74,0.00500000}, {75,0.00500000}, {76,0.00500000}, {77,0.00500901}, {78,0.00599099}, {79,0.00505405}, {80,0.00509910}, {81,0.00508108}, {82,0.00510811}, {83,0.00509009}, {84,0.00600901}, {85,0.00526126}, {86,0.00563964}, {87,0.00598198}, {88,0.00592793}, {89,0.00600000}, {90,0.00601802}, {91,0.00605405}, {92,0.00601802}, {93,0.00605405}, {94,0.00606306}, {95,0.00610811}, {96,0.00605405}, {97,0.00613514}, {98,0.00613514}, {99,0.00622523}, {100,0.00624324}, {101,0.00682883}, {102,0.00699099}, {103,0.00703604}, {104,0.00790090}, {105,0.00703604}, {106,0.00702703}, {107,0.00704505}, {108,0.00704505}, {109,0.00704505}, {110,0.00709009}, {111,0.00711712}, {112,0.00710811}, {113,0.00812613}, {114,0.00728829}, {115,0.00780180}, {116,0.00785586}, {117,0.00800000}, {118,0.00802703}, {119,0.00803604}, {120,0.00803604}, {121,0.00806306}, {122,0.00803604}, {123,0.00807207}, {124,0.00807207}, {125,0.00807207}, {126,0.00817117}, {127,0.00855856}, {128,0.00816216}, {129,0.00843243}, {130,0.00872072}, {131,0.00903604}, {132,0.00903604}, {133,0.01004505}, {134,0.00909009}, {135,0.00903604}, {136,0.00903604}, {137,0.01001802}, {138,0.00906306}, {139,0.00915315}, {140,0.00914414}, {141,0.00933333}, {142,0.00954955}, {143,0.00998198}, {144,0.01054955}, {145,0.00995495}, {146,0.01000901}, {147,0.01005405}, {148,0.01001802}, {149,0.01010811}, {150,0.01005405}, {151,0.01012613}, {152,0.01008108}, {153,0.01012613}, {154,0.01116216}, {155,0.01051351}, {156,0.01041441}, {157,0.01085586}, {158,0.01094595}, {159,0.01104505}, {160,0.01079279}, {161,0.01101802}, {162,0.01103604}, {163,0.01112613}, {164,0.01102703}, {165,0.01107207}, {166,0.01113514}, {167,0.01114414}, {168,0.01111712}, {169,0.01124324}, {170,0.01137838}, {171,0.01187387}, {172,0.01178378}, {173,0.01201802}, {174,0.01204505}, {175,0.01209910}, {176,0.01206306}, {177,0.01207207}, {178,0.01209009}, {179,0.01212613}, {180,0.01206306}, {181,0.01218018}, {182,0.01229730}, {183,0.01275676}, {184,0.01227027}, {185,0.01272973}, {186,0.01288288}, {187,0.01404505}, {188,0.01300901}, {189,0.01304505}, {190,0.01309009}, {191,0.01308108}, {192,0.01306306}, {193,0.01312613}, {194,0.01303604}, {195,0.01459459}, {196,0.01312613}, {197,0.01318018}, {198,0.01331532}, {199,0.01375676}, {200,0.01340541}, {201,0.01389189}, {202,0.01394595}, {203,0.01504505}, {204,0.01406306}, {205,0.01417117}, {206,0.01412613}, {207,0.01423423}, {208,0.01513514}, {209,0.01409910}, {210,0.01414414}, {211,0.01442342}, {212,0.01433333}, {213,0.01483784}, {214,0.01484685}, {215,0.01505405}, {216,0.01495495}, {217,0.01504505}, {218,0.01506306}, {219,0.01512613}, {220,0.01613514}, {221,0.01519820}, {222,0.01518018}, {223,0.01558559}, {224,0.01509910}, {225,0.01517117}, {226,0.01518919}, {227,0.01680180}, {228,0.01549550}, {229,0.01597297}, {230,0.01604505}, {231,0.01611712}, {232,0.01602703}, {233,0.01611712}, {234,0.01610811}, {235,0.01618919}, {236,0.01719820}, {237,0.01631532}, {238,0.01792793}, {239,0.01687387}, {240,0.01625225}, {241,0.01654955}, {242,0.01676577}, {243,0.01708108}, {244,0.01703604}, {245,0.01710811}, {246,0.01706306}, {247,0.01718018}, {248,0.01710811}, {249,0.01809009}, {250,0.01721622}, {251,0.01908108}, {252,0.01745045}, {253,0.01909910}, {254,0.01791892}, {255,0.01924324}, {256,0.01724324}, {257,0.01898198}, {258,0.01772072}, {259,0.01911712}, {260,0.01804505}, {261,0.01810811}, {262,0.01810811}, {263,0.01817117}, {264,0.01808108}, {265,0.01810811}, {266,0.01819820}, {267,0.02049550}, {268,0.01847748}, {269,0.02002703}, {270,0.01889189}, {271,0.02011712}, {272,0.01862162}, {273,0.02012613}, {274,0.01903604}, {275,0.02036036}, {276,0.01918919}, {277,0.02051351}, {278,0.01919820}, {279,0.01958559}, {280,0.01924324}, {281,0.01951351}, {282,0.01972072}, {283,0.02005405}, {284,0.01987387}, {285,0.02009009}, {286,0.02198198}, {287,0.02014414}, {288,0.02099099}, {289,0.02008108}, {290,0.02120721}, {291,0.02016216}, {292,0.02015315}, {293,0.02023423}, {294,0.02037838}, {295,0.02085586}, {296,0.02036937}, {297,0.02287387}, {298,0.02089189}, {299,0.02110811}, {300,0.02104505}, {301,0.02112613}, {302,0.02123423}, {303,0.02121622}, {304,0.02364865}, {305,0.02117117}, {306,0.02124324}, {307,0.02152252}, {308,0.02131532}, {309,0.02178378}, {310,0.02184685}, {311,0.02401802}, {312,0.02185586}, {313,0.02207207}, {314,0.02206306}, {315,0.02214414}, {316,0.02498198}, {317,0.02229730}, {318,0.02241441}, {319,0.02292793}, {320,0.02214414}, {321,0.02408108}, {322,0.02218919}, {323,0.02241441}, {324,0.02234234}, {325,0.02274775}, {326,0.02411712}, {327,0.02309009}, {328,0.02278378}, {329,0.02455856}, {330,0.02311712}, {331,0.02322523}, {332,0.02315315}, {333,0.02328829}, {334,0.02517117}, {335,0.02383784}, {336,0.02312613}, {337,0.02511712}, {338,0.02355856}, {339,0.02402703}, {340,0.02374775}, {341,0.02412613}, {342,0.02407207}, {343,0.02419820}, {344,0.02408108}, {345,0.02609009}, {346,0.02426126}, {347,0.02464865}, {348,0.02620721}, {349,0.02486486}, {350,0.02492793}, {351,0.02681081}, {352,0.02430631}, {353,0.02471171}, {354,0.02636036}, {355,0.02510811}, {356,0.02499099}, {357,0.02681081}, {358,0.02519820}, {359,0.02536036}, {360,0.02681982}, {361,0.02532432}, {362,0.02549550}, {363,0.02731532}, {364,0.02568468}, {365,0.02601802}, {366,0.02738739}, {367,0.02617117}, {368,0.02574775}, {369,0.02613514}, {370,0.02784685}, {371,0.02635135}, {372,0.02619820}, {373,0.02800901}, {374,0.02656757}, {375,0.02696396}, {376,0.02809910}, {377,0.02689189}, {378,0.02684685}, {379,0.02720721}, {380,0.02831532}, {381,0.02726126}, {382,0.02729730}, {383,0.02918919}, {384,0.02654955}, {385,0.02690991}, {386,0.02701802}, {387,0.02879279}, {388,0.02712613}, {389,0.02721622}, {390,0.02735135}, {391,0.02973874}, {392,0.02721622}, {393,0.02758559}, {394,0.02920721}, {395,0.02809910}, {396,0.02784685}, {397,0.02813514}, {398,0.02973874}, {399,0.02843243}, {400,0.02792793}, {401,0.02812613}, {402,0.02987387}, {403,0.02854054}, {404,0.02832432}, {405,0.02871171}, {406,0.03023423}, {407,0.02908108}, {408,0.02864865}, {409,0.02906306}, {410,0.03050450}, {411,0.03184685}, {412,0.02923423}, {413,0.02943243}, {414,0.02951351}, {415,0.03140541}, {416,0.02912613}, {417,0.02925225}, {418,0.02935135}, {419,0.03134234}, {420,0.03193694}, {421,0.02988288}, {422,0.03012613}, {423,0.03019820}, {424,0.03118018}, {425,0.03013514}, {426,0.03009009}, {427,0.03044144}, {428,0.03026126}, {429,0.03217117}, {430,0.03070270}, {431,0.03119820}, {432,0.03033333}, {433,0.03081081}, {434,0.03223423}, {435,0.03336937}, {436,0.03092793}, {437,0.03114414}, {438,0.03131532}, {439,0.03307207}, {440,0.03354955}, {441,0.03144144}, {442,0.03163063}, {443,0.03195495}, {444,0.03171171}, {445,0.03343243}, {446,0.03445045}, {447,0.03247748}, {448,0.03127027}, {449,0.03159459}, {450,0.03163964}, {451,0.03330631}, {452,0.03425225}, {453,0.03208108}, {454,0.03216216}, {455,0.03248649}, {456,0.03204505}, {457,0.03243243}, {458,0.03394595}, {459,0.03500901}, {460,0.03271171}, {461,0.03298198}, {462,0.03300901}, {463,0.03328829}, {464,0.03255856}, {465,0.03444144}, {466,0.03539640}, {467,0.03337838}, {468,0.03319820}, {469,0.03360360}, {470,0.03354054}, {471,0.03397297}, {472,0.03339640}, {473,0.03567568}, {474,0.03621622}, {475,0.03645045}, {476,0.03399099}, {477,0.03435135}, {478,0.03426126}, {479,0.03478378}, {480,0.03374775}, {481,0.03414414}, {482,0.03563964}, {483,0.03685586}, {484,0.03638739}, {485,0.03472973}, {486,0.03478378}, {487,0.03511712}, {488,0.03456757}, {489,0.03495495}, {490,0.03504505}, {491,0.03525225}, {492,0.03629730}, {493,0.03777477}, {494,0.03763063}, {495,0.03810811}, {496,0.03696396}, {497,0.03550450}, {498,0.03558559}, {499,0.03597297}, {500,0.03573874}, {505,0.03624324}, {510,0.03701802}, {515,0.03645045}, {520,0.03649550}, {525,0.03745946}, {530,0.03754955}, {535,0.03854955}, {540,0.03858559}, {545,0.03845946}, {550,0.03928829}, {555,0.03998198}, {560,0.03955856}, {565,0.04063964}, {570,0.04106306}, {575,0.04214414}, {580,0.04093694}, {585,0.04174775}, {590,0.04260360}, {595,0.04462162}, {600,0.04464865}, {605,0.04582883}, {610,0.04555856}, {615,0.04472973}, {620,0.04467568}, {625,0.04492793}, {630,0.04576577}, {635,0.04962162}, {640,0.04687387}, {645,0.04614414}, {650,0.04642342}, {655,0.04763964}, {660,0.04916216}, {665,0.04975676}, {670,0.04870270}, {675,0.04869369}, {680,0.05175676}, {685,0.05170270}, {690,0.04982883}, {695,0.05115315}, {700,0.05264865}, {705,0.05054054}, {710,0.05136036}, {715,0.05506306}, {720,0.05327928}, {725,0.05290090}, {730,0.05739640}, {735,0.05664865}, {740,0.05336937}, {745,0.05629730}, {750,0.05509910}, {755,0.05864865}, {760,0.05701802}, {765,0.05672072}, {770,0.05803604}, {775,0.05617117}, {780,0.05885586}, {785,0.05812613}, {790,0.05716216}, {795,0.06027928}, {800,0.05705405}, {805,0.06005405}, {810,0.05863063}, {815,0.06240541}, {820,0.05932432}, {825,0.06296396}, {830,0.06145045}, {835,0.06213514}, {840,0.06346847}, {845,0.06338739}, {850,0.06458559}, {855,0.06322523}, {860,0.06578378}, {865,0.06259459}, {870,0.06577477}, {875,0.06723423}, {880,0.06370270}, {885,0.06875676}, {890,0.06576577}, {895,0.06936937}, {900,0.06801802}, {905,0.06568468}, {910,0.06840541}, {915,0.07027928}, {920,0.06681081}, {925,0.06985586}, {930,0.07082883}, {935,0.07193694}, {940,0.06872072}, {945,0.07286486}, {950,0.07325225}, {955,0.07360360}, {960,0.06875676}, {965,0.07251351}, {970,0.07429730}, {975,0.07549550}, {980,0.07165766}, {985,0.07293694}, {990,0.07772072}, {995,0.07669369}, {1000,0.07622523}, {1010,0.07734234}, {1020,0.07605405}, {1030,0.07454054}, {1040,0.07479279}, {1050,0.08038739}, {1060,0.08046847}, {1070,0.08258559}, {1080,0.08236937}, {1090,0.08232432}, {1100,0.08398198}, {1110,0.08543243}, {1120,0.08476577}, {1130,0.08707207}, {1140,0.08786486}, {1150,0.08664865}, {1160,0.08405405}, {1170,0.08806306}, {1180,0.08945045}, {1190,0.09104505}, {1200,0.09137838}, {1210,0.09418018}, {1220,0.09284685}, {1230,0.09464865}, {1240,0.09477477}, {1250,0.09610811}, {1260,0.09659459}, {1270,0.09865766}, {1280,0.09593694}, {1290,0.09694595}, {1300,0.09836036}, {1310,0.09781081}, {1320,0.10122523}, {1330,0.10323423}, {1340,0.10419820}, {1350,0.10492793}, {1360,0.10514414}, {1370,0.10722523}, {1380,0.10450450}, {1390,0.10790991}, {1400,0.10692793}, {1410,0.10654955}, {1420,0.10749550}, {1430,0.11011712}, {1440,0.10842342}, {1450,0.11072973}, {1460,0.11356757}, {1470,0.11499099}, {1480,0.11383784}, {1490,0.11609910}, {1500,0.11681081}, {1510,0.11707207}, {1520,0.11609910}, {1530,0.11906306}, {1540,0.11714414}, {1550,0.11851351}, {1560,0.11812613}, {1570,0.11865766}, {1580,0.12013514}, {1590,0.12368468}, {1600,0.11980180}, {1610,0.12230631}, {1620,0.12173874}, {1630,0.12468468}, {1640,0.12259459}, {1650,0.12436036}, {1660,0.12664865}, {1670,0.12645045}, {1680,0.12519820}, {1690,0.12953153}, {1700,0.13400901}, {1710,0.13228829}, {1720,0.13225225}, {1730,0.13182883}, {1740,0.13456757}, {1750,0.13481982}, {1760,0.13581081}, {1770,0.13706306}, {1780,0.13942342}, {1790,0.13895495}, {1800,0.13543243}, {1810,0.13752252}, {1820,0.14010811}, {1830,0.14071171}, {1840,0.14009009}, {1850,0.14136036}, {1860,0.14124324}, {1870,0.14563964}, {1880,0.14490090}, {1890,0.14665766}, {1900,0.14605405}, {1910,0.15132432}, {1920,0.14333333}, {1930,0.14945045}, {1940,0.14822523}, {1950,0.15246847}, {1960,0.15224324}, {1970,0.15298198}, {1980,0.15436036}, {1990,0.15254955}, {2000,0.15373874}, {2050,0.15339640}, {2100,0.16044144}, {2150,0.16401802}, {2200,0.16525225}, {2250,0.17105405}, {2300,0.17963964}, {2350,0.18914414}, {2400,0.18312613}, {2450,0.18775676}, {2500,1.45648649}, {2550,0.20328829}, {2600,0.21279279}, {2650,0.20787387}, {2700,0.20629730}, {2750,0.22063964}, {2800,0.21599099}, {2850,0.21736036}, {2900,0.22486486}, {2950,0.22996396}, {3000,0.23433333}, {3050,0.23941441}, {3100,0.23946847}, {3150,0.24509009}, {3200,0.23950450}, {3250,0.24896396}, {3300,0.25373874}, {3350,0.25658559}, {3400,0.25837838}, {3450,0.27344144}, {3500,0.27317117}, {3550,0.27994595}, {3600,0.27354955}, {3650,0.28094595}, {3700,0.28512613}, {3750,0.29139640}, {3800,0.29676577}, {3850,0.29729730}, {3900,0.30627928}, {3950,0.31201802}, {4000,0.30804505}, {4050,0.31358559}, {4100,0.31066667}, {4150,0.32936036}, {4200,0.32088288}, {4250,0.33110811}, {4300,0.33461261}, {4350,0.35018919}, {4400,0.33996396}, {4450,0.34894595}, {4500,0.35954054}, {4550,0.35289189}, {4600,0.36335135}, {4650,0.36222523}, {4700,0.36811712}, {4750,0.36836937}, {4800,0.37501802}, {4850,0.38646847}, {4900,0.38648649}, {4950,0.39512613}, {5000,0.38932432}, {5050,0.40581982}, {5100,0.40327928}, {5150,0.40746847}, {5200,0.39152252}, {5250,0.40570270}, {5300,0.41654054}, {5350,0.42415315}, {5400,0.42111712}, {5450,0.43087387}, {5500,0.44250450}, {5550,0.44583784}, {5600,0.43745946}, {5650,0.44025225}, {5700,0.44396396}, {5750,0.45586486}, {5800,0.45930631}, {5850,0.47158559}, {5900,0.45852252}, {5950,0.46755856}, {6000,0.47125225}, {6050,0.47525}, {6100,0.48450}, {6150,0.48475}, {6200,0.49000}, {6250,0.49025}, {6300,0.49800}, {6350,0.50900}, {6400,0.48200}, {6450,0.50875}, {6500,0.50800}, {6550,0.51400}, {6600,0.51775}, {6650,0.53775}, {6700,0.51950}, {6750,0.54350}, {6800,0.53050}, {6850,0.53525}, {6900,0.55725}, {6950,0.55150}, {7000,0.55625}, {7050,0.55300}, {7100,0.56350}, {7150,0.58200}, {7200,0.55875}, {7250,0.57675}, {7300,0.56350}, {7350,0.59250}, {7400,0.58375}, {7450,0.59825}, {7500,0.60325}, {7550,0.61725}, {7600,0.60575}, {7650,0.61000}, {7700,0.60350}, {7750,0.62125}, {7800,0.62650}, {7850,0.62475}, {7900,0.63725}, {7950,0.63350}, {8000,0.62975}, {8050,0.65475}, {8100,0.65375}, {8150,0.66700}, {8200,0.63175}, {8250,0.65975}, {8300,0.65500}, {8350,0.68675}, {8400,0.65600}, {8450,0.65950}, {8500,0.67225}, {8550,0.68950}, {8600,0.68325}, {8650,0.68800}, {8700,0.71675}, {8750,0.70625}, {8800,0.70000}, {8850,0.70400}, {8900,0.70750}, {8950,0.73250}, {9000,0.72525}, {9050,0.74300}, {9100,0.72725}, {9150,0.75700}, {9200,0.74700}, {9250,0.73000}, {9300,0.74300}, {9350,0.73500}, {9400,0.75725}, {9450,0.76475}, {9500,0.74425}, {9550,0.77975}, {9600,0.74125}, {9650,0.78000}, {9700,0.78325}, {9750,0.78425}, {9800,0.77950}, {9850,0.80550}, {9900,0.80150}, {9950,0.80825}, {10000,0.79725}, {10100,0.83450}, {10200,0.84850}, {10300,0.83125}, {10400,0.82250}, {10500,0.83025}, {10600,0.86200}, {10700,0.86550}, {10800,0.84650}, {10900,0.87825}, {11000,0.90900}, {11100,0.90775}, {11200,0.89625}, {11300,0.89600}, {11400,0.90050}, {11500,0.93150}, {11600,0.93150}, {11700,0.96475}, {11800,0.94225}, {11900,0.98625}, {12000,0.96900}, {12100,0.98175}, {12200,1.00500}, {12300,0.96750}, {12400,0.99475}, {12500,1.01350}, {12600,1.02600}, {12700,1.04200}, {12800,0.99300}, {12900,1.05550}, {13000,1.05775}, {13100,1.06775}, {13200,1.07400}, {13300,1.08500}, {13400,1.08350}, {13500,1.11450}, {13600,1.07900}, {13700,1.10475}, {13800,1.13650}, {13900,1.12725}, {14000,1.14375}, {14100,1.15075}, {14200,1.19175}, {14300,1.21300}, {14400,1.12900}, {14500,1.15000}, {14600,1.16900}, {14700,1.21125}, {14800,1.21400}, {14900,1.20800}, {15000,1.21425}, {15100,1.26925}, {15200,1.23050}, {15300,1.25200}, {15400,1.23450}, {15500,1.25325}, {15600,1.28725}, {15700,1.29400}, {15800,1.31325}, {15900,1.31875}, {16000,1.26975}, {16100,1.34175}, {16200,1.32475}, {16300,1.37325}, {16400,1.27650}, {16500,1.34700}, {16600,1.34000}, {16700,1.38700}, {16800,1.34950}, {16900,1.32925}, {17000,1.37775}, {17100,1.40200}, {17200,1.38725}, {17300,1.41325}, {17400,1.45625}, {17500,1.44500}, {17600,1.39650}, {17700,1.43025}, {17800,1.43600}, {17900,1.50775}, {18000,1.46300}, {18100,1.49725}, {18200,1.49850}, {18300,1.55375}, {18400,1.51575}, {18500,1.48200}, {18600,1.50975}, {18700,1.50850}, {18800,1.54825}, {18900,1.56075}, {19000,1.54950}, {19100,1.58000}, {19200,1.52975}, {19300,1.58950}, {19400,1.60725}, {19500,1.59725}, {19600,1.59000}, {19700,1.66125}, {19800,1.63100}, {19900,1.67075}, {20000,1.5845}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["actual reif"]["user"] = {{1,0.00005405}, {2,0.00020721}, {3,0.00018919}, {4,0.00018919}, {5,0.00029730}, {6,0.00038739}, {7,0.00033333}, {8,0.00055856}, {9,0.00054054}, {10,0.00050450}, {11,0.00061261}, {12,0.00069369}, {13,0.00061261}, {14,0.00088288}, {15,0.00086486}, {16,0.00101802}, {17,0.00103604}, {18,0.00141441}, {19,0.00115315}, {20,0.00120721}, {21,0.00129730}, {22,0.00131532}, {23,0.00142342}, {24,0.00154054}, {25,0.00146847}, {26,0.00161261}, {27,0.00188288}, {28,0.00179279}, {29,0.00172072}, {30,0.00193694}, {31,0.00200901}, {32,0.00172973}, {33,0.00200000}, {34,0.00206306}, {35,0.00237838}, {36,0.00178378}, {37,0.00245045}, {38,0.00240541}, {39,0.00221622}, {40,0.00230631}, {41,0.00261261}, {42,0.00263964}, {43,0.00262162}, {44,0.00281982}, {45,0.00292793}, {46,0.00285586}, {47,0.00298198}, {48,0.00284685}, {49,0.00319820}, {50,0.00305405}, {51,0.00313514}, {52,0.00316216}, {53,0.00328829}, {54,0.00338739}, {55,0.00347748}, {56,0.00333333}, {57,0.00350450}, {58,0.00349550}, {59,0.00355856}, {60,0.00367568}, {61,0.00395495}, {62,0.00376577}, {63,0.00396396}, {64,0.00401802}, {65,0.00420721}, {66,0.00408108}, {67,0.00427027}, {68,0.00436937}, {69,0.00443243}, {70,0.00461261}, {71,0.00472973}, {72,0.00555856}, {73,0.00473874}, {74,0.00465766}, {75,0.00490991}, {76,0.00517117}, {77,0.00482883}, {78,0.00634234}, {79,0.00483784}, {80,0.00533333}, {81,0.00487387}, {82,0.00561261}, {83,0.00548649}, {84,0.00620721}, {85,0.00573874}, {86,0.00595495}, {87,0.00621622}, {88,0.00595495}, {89,0.00609009}, {90,0.00606306}, {91,0.00610811}, {92,0.00600901}, {93,0.00606306}, {94,0.00648649}, {95,0.00679279}, {96,0.00625225}, {97,0.00684685}, {98,0.00663063}, {99,0.00672973}, {100,0.00667568}, {101,0.00709009}, {102,0.00691892}, {103,0.00727928}, {104,0.00805405}, {105,0.00725225}, {106,0.00680180}, {107,0.00741441}, {108,0.00715315}, {109,0.00748649}, {110,0.00763063}, {111,0.00780180}, {112,0.00782883}, {113,0.00873874}, {114,0.00795495}, {115,0.00811712}, {116,0.00821622}, {117,0.00826126}, {118,0.00813514}, {119,0.00864865}, {120,0.00817117}, {121,0.00844144}, {122,0.00848649}, {123,0.00844144}, {124,0.00852252}, {125,0.00851351}, {126,0.00874775}, {127,0.00894595}, {128,0.00885586}, {129,0.00877477}, {130,0.00892793}, {131,0.00926126}, {132,0.00901802}, {133,0.01020721}, {134,0.00961261}, {135,0.00954955}, {136,0.00953153}, {137,0.01035135}, {138,0.00956757}, {139,0.00972973}, {140,0.00955856}, {141,0.00953153}, {142,0.00988288}, {143,0.01009009}, {144,0.01054955}, {145,0.00982883}, {146,0.00978378}, {147,0.00999099}, {148,0.00998198}, {149,0.01028829}, {150,0.01006306}, {151,0.01030631}, {152,0.01047748}, {153,0.01043243}, {154,0.01127027}, {155,0.01060360}, {156,0.01045045}, {157,0.01084685}, {158,0.01074775}, {159,0.01087387}, {160,0.01091892}, {161,0.01084685}, {162,0.01082883}, {163,0.01125225}, {164,0.01127027}, {165,0.01129730}, {166,0.01146847}, {167,0.01138739}, {168,0.01114414}, {169,0.01175676}, {170,0.01192793}, {171,0.01200000}, {172,0.01181982}, {173,0.01212613}, {174,0.01209009}, {175,0.01229730}, {176,0.01209910}, {177,0.01202703}, {178,0.01259459}, {179,0.01272973}, {180,0.01245045}, {181,0.01250450}, {182,0.01279279}, {183,0.01312613}, {184,0.01250450}, {185,0.01279279}, {186,0.01282883}, {187,0.01394595}, {188,0.01313514}, {189,0.01350450}, {190,0.01370270}, {191,0.01321622}, {192,0.01337838}, {193,0.01318919}, {194,0.01344144}, {195,0.01482883}, {196,0.01351351}, {197,0.01392793}, {198,0.01390090}, {199,0.01382883}, {200,0.01398198}, {201,0.01400000}, {202,0.01409910}, {203,0.01532432}, {204,0.01426126}, {205,0.01463063}, {206,0.01463964}, {207,0.01475676}, {208,0.01567568}, {209,0.01464865}, {210,0.01515315}, {211,0.01486486}, {212,0.01501802}, {213,0.01508108}, {214,0.01529730}, {215,0.01517117}, {216,0.01525225}, {217,0.01534234}, {218,0.01551351}, {219,0.01554054}, {220,0.01649550}, {221,0.01583784}, {222,0.01582883}, {223,0.01602703}, {224,0.01553153}, {225,0.01577477}, {226,0.01593694}, {227,0.01675676}, {228,0.01613514}, {229,0.01618018}, {230,0.01621622}, {231,0.01642342}, {232,0.01619820}, {233,0.01637838}, {234,0.01653153}, {235,0.01665766}, {236,0.01720721}, {237,0.01666667}, {238,0.01762162}, {239,0.01696396}, {240,0.01696396}, {241,0.01667568}, {242,0.01677477}, {243,0.01692793}, {244,0.01718018}, {245,0.01725225}, {246,0.01709910}, {247,0.01757658}, {248,0.01695495}, {249,0.01799099}, {250,0.01735135}, {251,0.01867568}, {252,0.01744144}, {253,0.01880180}, {254,0.01782883}, {255,0.01913514}, {256,0.01756757}, {257,0.01861261}, {258,0.01774775}, {259,0.01898198}, {260,0.01782883}, {261,0.01793694}, {262,0.01799099}, {263,0.01809910}, {264,0.01821622}, {265,0.01839640}, {266,0.01817117}, {267,0.02016216}, {268,0.01832432}, {269,0.01993694}, {270,0.01847748}, {271,0.01975676}, {272,0.01863964}, {273,0.01976577}, {274,0.01868468}, {275,0.02029730}, {276,0.01892793}, {277,0.02037838}, {278,0.01919820}, {279,0.01935135}, {280,0.01900901}, {281,0.01944144}, {282,0.01928829}, {283,0.01952252}, {284,0.01950450}, {285,0.01967568}, {286,0.02125225}, {287,0.01983784}, {288,0.02091892}, {289,0.01976577}, {290,0.02084685}, {291,0.02002703}, {292,0.01962162}, {293,0.02018018}, {294,0.02009910}, {295,0.02008108}, {296,0.02035135}, {297,0.02253153}, {298,0.02041441}, {299,0.02072973}, {300,0.02114414}, {301,0.02075676}, {302,0.02126126}, {303,0.02124324}, {304,0.02337838}, {305,0.02081081}, {306,0.02108108}, {307,0.02154054}, {308,0.02126126}, {309,0.02185586}, {310,0.02139640}, {311,0.02369369}, {312,0.02196396}, {313,0.02193694}, {314,0.02196396}, {315,0.02202703}, {316,0.02487387}, {317,0.02194595}, {318,0.02262162}, {319,0.02291892}, {320,0.02182883}, {321,0.02386486}, {322,0.02209009}, {323,0.02271171}, {324,0.02229730}, {325,0.02289189}, {326,0.02404505}, {327,0.02286486}, {328,0.02247748}, {329,0.02466667}, {330,0.02336036}, {331,0.02356757}, {332,0.02309009}, {333,0.02351351}, {334,0.02527027}, {335,0.02393694}, {336,0.02332432}, {337,0.02503604}, {338,0.02369369}, {339,0.02401802}, {340,0.02378378}, {341,0.02437838}, {342,0.02413514}, {343,0.02445045}, {344,0.02417117}, {345,0.02580180}, {346,0.02485586}, {347,0.02481982}, {348,0.02595495}, {349,0.02489189}, {350,0.02481982}, {351,0.02658559}, {352,0.02463063}, {353,0.02495495}, {354,0.02638739}, {355,0.02453153}, {356,0.02489189}, {357,0.02667568}, {358,0.02504505}, {359,0.02563063}, {360,0.02672973}, {361,0.02512613}, {362,0.02556757}, {363,0.02709910}, {364,0.02580180}, {365,0.02568468}, {366,0.02745946}, {367,0.02629730}, {368,0.02568468}, {369,0.02601802}, {370,0.02755856}, {371,0.02651351}, {372,0.02627027}, {373,0.02808108}, {374,0.02643243}, {375,0.02662162}, {376,0.02782883}, {377,0.02692793}, {378,0.02682883}, {379,0.02715315}, {380,0.02846847}, {381,0.02707207}, {382,0.02703604}, {383,0.02944144}, {384,0.02636036}, {385,0.02693694}, {386,0.02669369}, {387,0.02889189}, {388,0.02704505}, {389,0.02709009}, {390,0.02735135}, {391,0.02977477}, {392,0.02718919}, {393,0.02730631}, {394,0.02893694}, {395,0.02785586}, {396,0.02770270}, {397,0.02775676}, {398,0.02971171}, {399,0.02816216}, {400,0.02761261}, {401,0.02783784}, {402,0.02972973}, {403,0.02898198}, {404,0.02832432}, {405,0.02874775}, {406,0.03055856}, {407,0.02918018}, {408,0.02858559}, {409,0.02881982}, {410,0.03105405}, {411,0.03221622}, {412,0.02927928}, {413,0.02960360}, {414,0.02955856}, {415,0.03183784}, {416,0.02926126}, {417,0.02939640}, {418,0.02974775}, {419,0.03165766}, {420,0.03225225}, {421,0.03013514}, {422,0.03015315}, {423,0.03054955}, {424,0.03159459}, {425,0.02996396}, {426,0.03030631}, {427,0.03077477}, {428,0.03063063}, {429,0.03255856}, {430,0.03071171}, {431,0.03145045}, {432,0.03058559}, {433,0.03094595}, {434,0.03237838}, {435,0.03356757}, {436,0.03147748}, {437,0.03152252}, {438,0.03156757}, {439,0.03376577}, {440,0.03363964}, {441,0.03201802}, {442,0.03200000}, {443,0.03227027}, {444,0.03209910}, {445,0.03351351}, {446,0.03478378}, {447,0.03289189}, {448,0.03161261}, {449,0.03213514}, {450,0.03218919}, {451,0.03371171}, {452,0.03432432}, {453,0.03235135}, {454,0.03240541}, {455,0.03285586}, {456,0.03237838}, {457,0.03277477}, {458,0.03417117}, {459,0.03500000}, {460,0.03281982}, {461,0.03349550}, {462,0.03321622}, {463,0.03362162}, {464,0.03300901}, {465,0.03446847}, {466,0.03553153}, {467,0.03336937}, {468,0.03375676}, {469,0.03400000}, {470,0.03367568}, {471,0.03391892}, {472,0.03403604}, {473,0.03566667}, {474,0.03627027}, {475,0.03631532}, {476,0.03410811}, {477,0.03427027}, {478,0.03411712}, {479,0.03484685}, {480,0.03409910}, {481,0.03429730}, {482,0.03552252}, {483,0.03654054}, {484,0.03628829}, {485,0.03467568}, {486,0.03516216}, {487,0.03534234}, {488,0.03495495}, {489,0.03501802}, {490,0.03518919}, {491,0.03544144}, {492,0.03616216}, {493,0.03727027}, {494,0.03765766}, {495,0.03768468}, {496,0.03668468}, {497,0.03550450}, {498,0.03579279}, {499,0.03611712}, {500,0.03576577}, {505,0.03608108}, {510,0.03680180}, {515,0.03645045}, {520,0.03657658}, {525,0.03745946}, {530,0.03770270}, {535,0.03832432}, {540,0.03853153}, {545,0.03808108}, {550,0.03881982}, {555,0.03968468}, {560,0.03932432}, {565,0.04014414}, {570,0.04075676}, {575,0.04209009}, {580,0.04092793}, {585,0.04154955}, {590,0.04298198}, {595,0.04488288}, {600,0.04461261}, {605,0.04611712}, {610,0.04563964}, {615,0.04476577}, {620,0.04464865}, {625,0.04472973}, {630,0.04599099}, {635,0.04915315}, {640,0.04703604}, {645,0.04653153}, {650,0.04643243}, {655,0.04804505}, {660,0.04899099}, {665,0.04963063}, {670,0.04853153}, {675,0.04895495}, {680,0.05130631}, {685,0.05109009}, {690,0.04951351}, {695,0.05090090}, {700,0.05227928}, {705,0.05021622}, {710,0.05067568}, {715,0.05500901}, {720,0.05290090}, {725,0.05253153}, {730,0.05739640}, {735,0.05657658}, {740,0.05329730}, {745,0.05644144}, {750,0.05477477}, {755,0.05892793}, {760,0.05688288}, {765,0.05667568}, {770,0.05800000}, {775,0.05594595}, {780,0.05920721}, {785,0.05791892}, {790,0.05722523}, {795,0.06028829}, {800,0.05688288}, {805,0.06027928}, {810,0.05861261}, {815,0.06262162}, {820,0.05947748}, {825,0.06316216}, {830,0.06144144}, {835,0.06212613}, {840,0.06386486}, {845,0.06358559}, {850,0.06463063}, {855,0.06387387}, {860,0.06545946}, {865,0.06300000}, {870,0.06568468}, {875,0.06689189}, {880,0.06398198}, {885,0.06839640}, {890,0.06600901}, {895,0.06911712}, {900,0.06779279}, {905,0.06593694}, {910,0.06832432}, {915,0.07028829}, {920,0.06677477}, {925,0.06981081}, {930,0.07063964}, {935,0.07173874}, {940,0.06833333}, {945,0.07275676}, {950,0.07331532}, {955,0.07391892}, {960,0.06863063}, {965,0.07269369}, {970,0.07454955}, {975,0.07596396}, {980,0.07164865}, {985,0.07335135}, {990,0.07736036}, {995,0.07690090}, {1000,0.07645045}, {1010,0.07718919}, {1020,0.07611712}, {1030,0.07481982}, {1040,0.07518919}, {1050,0.07991892}, {1060,0.08028829}, {1070,0.08236036}, {1080,0.08208108}, {1090,0.08245946}, {1100,0.08380180}, {1110,0.08534234}, {1120,0.08501802}, {1130,0.08722523}, {1140,0.08793694}, {1150,0.08661261}, {1160,0.08409910}, {1170,0.08804505}, {1180,0.08923423}, {1190,0.09101802}, {1200,0.09097297}, {1210,0.09380180}, {1220,0.09242342}, {1230,0.09469369}, {1240,0.09454955}, {1250,0.09597297}, {1260,0.09625225}, {1270,0.09904505}, {1280,0.09583784}, {1290,0.09686486}, {1300,0.09843243}, {1310,0.09765766}, {1320,0.10111712}, {1330,0.10289189}, {1340,0.10354054}, {1350,0.10441441}, {1360,0.10456757}, {1370,0.10671171}, {1380,0.10417117}, {1390,0.10776577}, {1400,0.10658559}, {1410,0.10618018}, {1420,0.10713514}, {1430,0.10992793}, {1440,0.10825225}, {1450,0.11064865}, {1460,0.11332432}, {1470,0.11452252}, {1480,0.11370270}, {1490,0.11551351}, {1500,0.11649550}, {1510,0.11679279}, {1520,0.11551351}, {1530,0.11865766}, {1540,0.11672072}, {1550,0.11807207}, {1560,0.11804505}, {1570,0.11816216}, {1580,0.11966667}, {1590,0.12347748}, {1600,0.11945946}, {1610,0.12228829}, {1620,0.12227928}, {1630,0.12529730}, {1640,0.12229730}, {1650,0.12446847}, {1660,0.12676577}, {1670,0.12674775}, {1680,0.12512613}, {1690,0.12970270}, {1700,0.13363063}, {1710,0.13193694}, {1720,0.13199099}, {1730,0.13165766}, {1740,0.13467568}, {1750,0.13477477}, {1760,0.13543243}, {1770,0.13709009}, {1780,0.13926126}, {1790,0.13902703}, {1800,0.13545045}, {1810,0.13787387}, {1820,0.14022523}, {1830,0.14094595}, {1840,0.14019820}, {1850,0.14154955}, {1860,0.14142342}, {1870,0.14542342}, {1880,0.14478378}, {1890,0.14673874}, {1900,0.14598198}, {1910,0.15138739}, {1920,0.14347748}, {1930,0.14938739}, {1940,0.14825225}, {1950,0.15268468}, {1960,0.15230631}, {1970,0.15324324}, {1980,0.15454955}, {1990,0.15280180}, {2000,0.15379279}, {2050,0.15369369}, {2100,0.16033333}, {2150,0.16398198}, {2200,0.16559459}, {2250,0.17099099}, {2300,0.17954054}, {2350,0.18914414}, {2400,0.18267568}, {2450,0.18770270}, {2500,1.45411712}, {2550,0.20320721}, {2600,0.21261261}, {2650,0.20716216}, {2700,0.20582883}, {2750,0.22019820}, {2800,0.21561261}, {2850,0.21695495}, {2900,0.22497297}, {2950,0.22965766}, {3000,0.23405405}, {3050,0.23892793}, {3100,0.23939640}, {3150,0.24512613}, {3200,0.23945946}, {3250,0.24895495}, {3300,0.25382883}, {3350,0.25663964}, {3400,0.25845045}, {3450,0.27356757}, {3500,0.27322523}, {3550,0.28007207}, {3600,0.27331532}, {3650,0.28096396}, {3700,0.28500901}, {3750,0.29137838}, {3800,0.29700000}, {3850,0.29705405}, {3900,0.30632432}, {3950,0.31165766}, {4000,0.30763063}, {4050,0.31343243}, {4100,0.31062162}, {4150,0.32917117}, {4200,0.32078378}, {4250,0.33119820}, {4300,0.33443243}, {4350,0.34986486}, {4400,0.33978378}, {4450,0.34871171}, {4500,0.35927928}, {4550,0.35258559}, {4600,0.36317117}, {4650,0.36198198}, {4700,0.36754955}, {4750,0.36801802}, {4800,0.37484685}, {4850,0.38626126}, {4900,0.38651351}, {4950,0.39500901}, {5000,0.38915315}, {5050,0.40554054}, {5100,0.40340541}, {5150,0.40749550}, {5200,0.39127928}, {5250,0.40586486}, {5300,0.41645045}, {5350,0.42374775}, {5400,0.42114414}, {5450,0.43052252}, {5500,0.44240541}, {5550,0.44584685}, {5600,0.43726126}, {5650,0.44014414}, {5700,0.44366667}, {5750,0.45505405}, {5800,0.45877477}, {5850,0.47066667}, {5900,0.45781982}, {5950,0.46677477}, {6000,0.47095495}, {6050,0.47550}, {6100,0.48200}, {6150,0.48325}, {6200,0.48975}, {6250,0.48975}, {6300,0.49825}, {6350,0.50850}, {6400,0.48200}, {6450,0.50775}, {6500,0.50800}, {6550,0.51575}, {6600,0.51850}, {6650,0.53650}, {6700,0.51875}, {6750,0.54275}, {6800,0.52950}, {6850,0.53550}, {6900,0.55700}, {6950,0.54950}, {7000,0.55775}, {7050,0.55250}, {7100,0.56250}, {7150,0.58175}, {7200,0.55775}, {7250,0.57675}, {7300,0.56275}, {7350,0.59175}, {7400,0.58425}, {7450,0.59725}, {7500,0.60125}, {7550,0.61750}, {7600,0.60600}, {7650,0.61000}, {7700,0.60275}, {7750,0.62100}, {7800,0.62575}, {7850,0.62350}, {7900,0.63750}, {7950,0.63425}, {8000,0.63000}, {8050,0.65475}, {8100,0.65325}, {8150,0.66750}, {8200,0.63175}, {8250,0.65900}, {8300,0.65550}, {8350,0.68650}, {8400,0.65550}, {8450,0.65800}, {8500,0.67025}, {8550,0.69025}, {8600,0.68125}, {8650,0.68875}, {8700,0.71575}, {8750,0.70575}, {8800,0.69925}, {8850,0.70475}, {8900,0.70625}, {8950,0.73150}, {9000,0.72575}, {9050,0.74450}, {9100,0.72625}, {9150,0.75650}, {9200,0.74525}, {9250,0.72925}, {9300,0.74225}, {9350,0.73475}, {9400,0.75700}, {9450,0.76425}, {9500,0.74450}, {9550,0.77875}, {9600,0.73925}, {9650,0.78000}, {9700,0.78175}, {9750,0.78450}, {9800,0.78025}, {9850,0.80350}, {9900,0.80150}, {9950,0.81000}, {10000,0.79675}, {10100,0.83375}, {10200,0.84775}, {10300,0.83175}, {10400,0.82250}, {10500,0.83050}, {10600,0.86225}, {10700,0.86550}, {10800,0.84625}, {10900,0.87825}, {11000,0.90850}, {11100,0.90775}, {11200,0.89600}, {11300,0.89525}, {11400,0.90000}, {11500,0.93150}, {11600,0.93050}, {11700,0.96450}, {11800,0.94150}, {11900,0.98525}, {12000,0.96875}, {12100,0.98150}, {12200,1.00450}, {12300,0.96625}, {12400,0.99525}, {12500,1.01250}, {12600,1.02575}, {12700,1.04225}, {12800,0.99450}, {12900,1.05475}, {13000,1.05775}, {13100,1.06875}, {13200,1.07425}, {13300,1.08475}, {13400,1.08250}, {13500,1.11325}, {13600,1.07800}, {13700,1.10625}, {13800,1.13650}, {13900,1.12775}, {14000,1.14325}, {14100,1.14925}, {14200,1.19150}, {14300,1.21275}, {14400,1.12875}, {14500,1.15025}, {14600,1.16850}, {14700,1.21150}, {14800,1.21325}, {14900,1.20850}, {15000,1.21450}, {15100,1.26875}, {15200,1.23050}, {15300,1.25175}, {15400,1.23450}, {15500,1.25475}, {15600,1.28675}, {15700,1.29450}, {15800,1.31125}, {15900,1.31750}, {16000,1.26975}, {16100,1.34000}, {16200,1.32450}, {16300,1.37450}, {16400,1.27675}, {16500,1.34675}, {16600,1.33950}, {16700,1.38625}, {16800,1.34975}, {16900,1.32850}, {17000,1.37825}, {17100,1.40150}, {17200,1.38600}, {17300,1.41325}, {17400,1.45525}, {17500,1.44450}, {17600,1.39675}, {17700,1.43000}, {17800,1.43625}, {17900,1.50675}, {18000,1.46325}, {18100,1.49650}, {18200,1.49925}, {18300,1.55450}, {18400,1.51600}, {18500,1.48150}, {18600,1.50775}, {18700,1.50850}, {18800,1.54750}, {18900,1.56025}, {19000,1.55100}, {19100,1.57975}, {19200,1.52950}, {19300,1.58775}, {19400,1.60675}, {19500,1.59775}, {19600,1.58975}, {19700,1.66050}, {19800,1.63175}, {19900,1.67175}, {20000,1.5850}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["actual reif"]["system"] = {{1,0.00013514}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00002703}, {6,0.00003604}, {7,0.00000000}, {8,0.00003604}, {9,0.00003604}, {10,0.00003604}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00003604}, {16,0.00002703}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00002703}, {25,0.00003604}, {26,0.00000000}, {27,0.00000000}, {28,0.00003604}, {29,0.00003604}, {30,0.00003604}, {31,0.00000000}, {32,0.00002703}, {33,0.00003604}, {34,0.00000000}, {35,0.00003604}, {36,0.00000000}, {37,0.00003604}, {38,0.00000000}, {39,0.00006306}, {40,0.00003604}, {41,0.00005405}, {42,0.00003604}, {43,0.00003604}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00003604}, {51,0.00000000}, {52,0.00003604}, {53,0.00000000}, {54,0.00000000}, {55,0.00003604}, {56,0.00000000}, {57,0.00003604}, {58,0.00003604}, {59,0.00000000}, {60,0.00007207}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00003604}, {66,0.00000000}, {67,0.00002703}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00002703}, {74,0.00000000}, {75,0.00003604}, {76,0.00003604}, {77,0.00000000}, {78,0.00002703}, {79,0.00000000}, {80,0.00000000}, {81,0.00003604}, {82,0.00002703}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00003604}, {87,0.00002703}, {88,0.00007207}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00002703}, {93,0.00000000}, {94,0.00003604}, {95,0.00000000}, {96,0.00003604}, {97,0.00003604}, {98,0.00000000}, {99,0.00002703}, {100,0.00006306}, {101,0.00003604}, {102,0.00000000}, {103,0.00000000}, {104,0.00003604}, {105,0.00000000}, {106,0.00003604}, {107,0.00002703}, {108,0.00003604}, {109,0.00000000}, {110,0.00007207}, {111,0.00000000}, {112,0.00000000}, {113,0.00002703}, {114,0.00000000}, {115,0.00000000}, {116,0.00003604}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00003604}, {122,0.00003604}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00002703}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00007207}, {133,0.00006306}, {134,0.00000000}, {135,0.00000000}, {136,0.00003604}, {137,0.00002703}, {138,0.00003604}, {139,0.00000000}, {140,0.00007207}, {141,0.00007207}, {142,0.00000000}, {143,0.00000000}, {144,0.00007207}, {145,0.00000000}, {146,0.00000000}, {147,0.00003604}, {148,0.00000000}, {149,0.00003604}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00007207}, {154,0.00002703}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00003604}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00003604}, {163,0.00000000}, {164,0.00000000}, {165,0.00003604}, {166,0.00003604}, {167,0.00007207}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00003604}, {173,0.00003604}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00003604}, {178,0.00000000}, {179,0.00003604}, {180,0.00003604}, {181,0.00003604}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00007207}, {186,0.00000000}, {187,0.00007207}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00003604}, {194,0.00000000}, {195,0.00006306}, {196,0.00000000}, {197,0.00003604}, {198,0.00003604}, {199,0.00002703}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00007207}, {206,0.00002703}, {207,0.00000000}, {208,0.00007207}, {209,0.00002703}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00003604}, {216,0.00000000}, {217,0.00007207}, {218,0.00003604}, {219,0.00007207}, {220,0.00000000}, {221,0.00000000}, {222,0.00003604}, {223,0.00003604}, {224,0.00003604}, {225,0.00000000}, {226,0.00000000}, {227,0.00003604}, {228,0.00000000}, {229,0.00003604}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00003604}, {235,0.00003604}, {236,0.00007207}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00010811}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00003604}, {250,0.00007207}, {251,0.00009910}, {252,0.00003604}, {253,0.00006306}, {254,0.00000000}, {255,0.00007207}, {256,0.00000000}, {257,0.00010811}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00003604}, {262,0.00002703}, {263,0.00003604}, {264,0.00000000}, {265,0.00000000}, {266,0.00007207}, {267,0.00009910}, {268,0.00007207}, {269,0.00003604}, {270,0.00000000}, {271,0.00007207}, {272,0.00000000}, {273,0.00000000}, {274,0.00007207}, {275,0.00010811}, {276,0.00003604}, {277,0.00003604}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003604}, {282,0.00003604}, {283,0.00000000}, {284,0.00003604}, {285,0.00000000}, {286,0.00014414}, {287,0.00003604}, {288,0.00007207}, {289,0.00000000}, {290,0.00010811}, {291,0.00003604}, {292,0.00003604}, {293,0.00003604}, {294,0.00007207}, {295,0.00000000}, {296,0.00000000}, {297,0.00007207}, {298,0.00000000}, {299,0.00007207}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00002703}, {305,0.00000000}, {306,0.00000000}, {307,0.00006306}, {308,0.00003604}, {309,0.00003604}, {310,0.00000000}, {311,0.00020721}, {312,0.00003604}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00003604}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00007207}, {322,0.00000000}, {323,0.00000000}, {324,0.00002703}, {325,0.00000000}, {326,0.00003604}, {327,0.00010811}, {328,0.00000000}, {329,0.00013514}, {330,0.00003604}, {331,0.00000000}, {332,0.00003604}, {333,0.00000000}, {334,0.00003604}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00003604}, {341,0.00000000}, {342,0.00002703}, {343,0.00000000}, {344,0.00000000}, {345,0.00009910}, {346,0.00000000}, {347,0.00007207}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00002703}, {352,0.00000000}, {353,0.00000000}, {354,0.00007207}, {355,0.00018018}, {356,0.00003604}, {357,0.00006306}, {358,0.00000000}, {359,0.00000000}, {360,0.00003604}, {361,0.00000000}, {362,0.00003604}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00003604}, {367,0.00000000}, {368,0.00003604}, {369,0.00000000}, {370,0.00007207}, {371,0.00000000}, {372,0.00003604}, {373,0.00003604}, {374,0.00000000}, {375,0.00003604}, {376,0.00002703}, {377,0.00000000}, {378,0.00003604}, {379,0.00000000}, {380,0.00007207}, {381,0.00003604}, {382,0.00000000}, {383,0.00006306}, {384,0.00006306}, {385,0.00000000}, {386,0.00007207}, {387,0.00003604}, {388,0.00003604}, {389,0.00000000}, {390,0.00002703}, {391,0.00000000}, {392,0.00003604}, {393,0.00003604}, {394,0.00013514}, {395,0.00002703}, {396,0.00000000}, {397,0.00000000}, {398,0.00003604}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00009910}, {403,0.00000000}, {404,0.00000000}, {405,0.00003604}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00010811}, {412,0.00007207}, {413,0.00003604}, {414,0.00000000}, {415,0.00014414}, {416,0.00000000}, {417,0.00003604}, {418,0.00003604}, {419,0.00003604}, {420,0.00003604}, {421,0.00003604}, {422,0.00000000}, {423,0.00000000}, {424,0.00007207}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00014414}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00010811}, {435,0.00003604}, {436,0.00000000}, {437,0.00002703}, {438,0.00003604}, {439,0.00003604}, {440,0.00007207}, {441,0.00000000}, {442,0.00003604}, {443,0.00003604}, {444,0.00003604}, {445,0.00003604}, {446,0.00000000}, {447,0.00000000}, {448,0.00003604}, {449,0.00000000}, {450,0.00000000}, {451,0.00003604}, {452,0.00010811}, {453,0.00003604}, {454,0.00003604}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00013514}, {459,0.00007207}, {460,0.00007207}, {461,0.00000000}, {462,0.00007207}, {463,0.00003604}, {464,0.00002703}, {465,0.00000000}, {466,0.00000000}, {467,0.00003604}, {468,0.00003604}, {469,0.00000000}, {470,0.00003604}, {471,0.00003604}, {472,0.00000000}, {473,0.00007207}, {474,0.00003604}, {475,0.00010811}, {476,0.00000000}, {477,0.00002703}, {478,0.00007207}, {479,0.00003604}, {480,0.00000000}, {481,0.00000000}, {482,0.00010811}, {483,0.00024324}, {484,0.00003604}, {485,0.00002703}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00006306}, {490,0.00003604}, {491,0.00000000}, {492,0.00006306}, {493,0.00013514}, {494,0.00003604}, {495,0.00007207}, {496,0.00023423}, {497,0.00003604}, {498,0.00000000}, {499,0.00000000}, {500,0.00003604}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00003604}, {530,0.00003604}, {535,0.00000000}, {540,0.00000000}, {545,0.00007207}, {550,0.00003604}, {555,0.00006306}, {560,0.00000000}, {565,0.00003604}, {570,0.00003604}, {575,0.00003604}, {580,0.00007207}, {585,0.00007207}, {590,0.00000000}, {595,0.00018018}, {600,0.00007207}, {605,0.00010811}, {610,0.00010811}, {615,0.00009910}, {620,0.00007207}, {625,0.00007207}, {630,0.00000000}, {635,0.00013514}, {640,0.00006306}, {645,0.00003604}, {650,0.00010811}, {655,0.00003604}, {660,0.00006306}, {665,0.00007207}, {670,0.00002703}, {675,0.00000000}, {680,0.00013514}, {685,0.00007207}, {690,0.00000000}, {695,0.00003604}, {700,0.00007207}, {705,0.00007207}, {710,0.00003604}, {715,0.00007207}, {720,0.00000000}, {725,0.00000000}, {730,0.00010811}, {735,0.00014414}, {740,0.00003604}, {745,0.00003604}, {750,0.00000000}, {755,0.00012613}, {760,0.00018018}, {765,0.00003604}, {770,0.00010811}, {775,0.00000000}, {780,0.00010811}, {785,0.00006306}, {790,0.00000000}, {795,0.00007207}, {800,0.00003604}, {805,0.00002703}, {810,0.00003604}, {815,0.00000000}, {820,0.00002703}, {825,0.00003604}, {830,0.00000000}, {835,0.00003604}, {840,0.00009910}, {845,0.00014414}, {850,0.00010811}, {855,0.00000000}, {860,0.00024324}, {865,0.00003604}, {870,0.00000000}, {875,0.00021622}, {880,0.00003604}, {885,0.00010811}, {890,0.00003604}, {895,0.00010811}, {900,0.00012613}, {905,0.00000000}, {910,0.00007207}, {915,0.00018018}, {920,0.00003604}, {925,0.00003604}, {930,0.00010811}, {935,0.00010811}, {940,0.00002703}, {945,0.00019820}, {950,0.00018018}, {955,0.00003604}, {960,0.00000000}, {965,0.00000000}, {970,0.00003604}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00036036}, {995,0.00010811}, {1000,0.00006306}, {1010,0.00009910}, {1020,0.00010811}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00014414}, {1060,0.00018018}, {1070,0.00018919}, {1080,0.00006306}, {1090,0.00014414}, {1100,0.00014414}, {1110,0.00014414}, {1120,0.00000000}, {1130,0.00014414}, {1140,0.00013514}, {1150,0.00003604}, {1160,0.00000000}, {1170,0.00003604}, {1180,0.00009910}, {1190,0.00010811}, {1200,0.00017117}, {1210,0.00003604}, {1220,0.00024324}, {1230,0.00009910}, {1240,0.00018018}, {1250,0.00007207}, {1260,0.00014414}, {1270,0.00014414}, {1280,0.00010811}, {1290,0.00010811}, {1300,0.00018018}, {1310,0.00007207}, {1320,0.00007207}, {1330,0.00016216}, {1340,0.00007207}, {1350,0.00007207}, {1360,0.00020721}, {1370,0.00003604}, {1380,0.00014414}, {1390,0.00007207}, {1400,0.00010811}, {1410,0.00007207}, {1420,0.00007207}, {1430,0.00009910}, {1440,0.00014414}, {1450,0.00010811}, {1460,0.00013514}, {1470,0.00014414}, {1480,0.00000000}, {1490,0.00009910}, {1500,0.00007207}, {1510,0.00010811}, {1520,0.00021622}, {1530,0.00014414}, {1540,0.00010811}, {1550,0.00010811}, {1560,0.00021622}, {1570,0.00007207}, {1580,0.00014414}, {1590,0.00018018}, {1600,0.00017117}, {1610,0.00006306}, {1620,0.00009910}, {1630,0.00007207}, {1640,0.00009910}, {1650,0.00003604}, {1660,0.00014414}, {1670,0.00013514}, {1680,0.00010811}, {1690,0.00010811}, {1700,0.00028829}, {1710,0.00010811}, {1720,0.00009910}, {1730,0.00002703}, {1740,0.00010811}, {1750,0.00014414}, {1760,0.00018018}, {1770,0.00010811}, {1780,0.00021622}, {1790,0.00007207}, {1800,0.00007207}, {1810,0.00006306}, {1820,0.00010811}, {1830,0.00007207}, {1840,0.00010811}, {1850,0.00010811}, {1860,0.00000000}, {1870,0.00003604}, {1880,0.00003604}, {1890,0.00003604}, {1900,0.00003604}, {1910,0.00007207}, {1920,0.00002703}, {1930,0.00010811}, {1940,0.00007207}, {1950,0.00010811}, {1960,0.00009910}, {1970,0.00003604}, {1980,0.00003604}, {1990,0.00010811}, {2000,0.00014414}, {2050,0.00010811}, {2100,0.00007207}, {2150,0.00007207}, {2200,0.00007207}, {2250,0.00010811}, {2300,0.00014414}, {2350,0.00014414}, {2400,0.00003604}, {2450,0.00000000}, {2500,0.00191892}, {2550,0.00003604}, {2600,0.00003604}, {2650,0.00003604}, {2700,0.00003604}, {2750,0.00007207}, {2800,0.00010811}, {2850,0.00010811}, {2900,0.00006306}, {2950,0.00014414}, {3000,0.00000000}, {3050,0.00003604}, {3100,0.00003604}, {3150,0.00007207}, {3200,0.00003604}, {3250,0.00009910}, {3300,0.00007207}, {3350,0.00003604}, {3400,0.00007207}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00003604}, {3600,0.00003604}, {3650,0.00003604}, {3700,0.00003604}, {3750,0.00003604}, {3800,0.00000000}, {3850,0.00003604}, {3900,0.00000000}, {3950,0.00018018}, {4000,0.00020721}, {4050,0.00014414}, {4100,0.00003604}, {4150,0.00017117}, {4200,0.00000000}, {4250,0.00010811}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00003604}, {4450,0.00003604}, {4500,0.00007207}, {4550,0.00002703}, {4600,0.00007207}, {4650,0.00000000}, {4700,0.00003604}, {4750,0.00007207}, {4800,0.00007207}, {4850,0.00000000}, {4900,0.00020721}, {4950,0.00016216}, {5000,0.00038739}, {5050,0.00010811}, {5100,0.00003604}, {5150,0.00007207}, {5200,0.00006306}, {5250,0.00000000}, {5300,0.00003604}, {5350,0.00010811}, {5400,0.00000000}, {5450,0.00003604}, {5500,0.00003604}, {5550,0.00007207}, {5600,0.00000000}, {5650,0.00010811}, {5700,0.00009910}, {5750,0.00031532}, {5800,0.00038739}, {5850,0.00036036}, {5900,0.00049550}, {5950,0.00032432}, {6000,0.00032432}, {6050,0.00000}, {6100,0.00100}, {6150,0.00100}, {6200,0.00100}, {6250,0.00000}, {6300,0.00000}, {6350,0.00100}, {6400,0.00100}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00100}, {6800,0.00075}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00100}, {7150,0.00000}, {7200,0.00000}, {7250,0.00100}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00100}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00100}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00100}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00075}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00005405}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00001802}, {246,0.00000000}, {247,0.00009009}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00098198}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000901}, {389,0.00000000}, {390,0.00198198}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000901}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000901}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000901}, {417,0.00000901}, {418,0.00000000}, {419,0.00000901}, {420,0.00000901}, {421,0.00000901}, {422,0.00002703}, {423,0.00003604}, {424,0.00001802}, {425,0.00004505}, {426,0.00003604}, {427,0.00003604}, {428,0.00002703}, {429,0.00003604}, {430,0.00006306}, {431,0.00016216}, {432,0.00012613}, {433,0.00017117}, {434,0.00012613}, {435,0.00026126}, {436,0.00023423}, {437,0.00036937}, {438,0.00034234}, {439,0.00036036}, {440,0.00040541}, {441,0.00041441}, {442,0.00045946}, {443,0.00048649}, {444,0.00043243}, {445,0.00048649}, {446,0.00051351}, {447,0.00054955}, {448,0.00055856}, {449,0.00057658}, {450,0.00057658}, {451,0.00060360}, {452,0.00058559}, {453,0.00063063}, {454,0.00063964}, {455,0.00061261}, {456,0.00063964}, {457,0.00072973}, {458,0.00070270}, {459,0.00070270}, {460,0.00072072}, {461,0.00075676}, {462,0.00081081}, {463,0.00081982}, {464,0.00086486}, {465,0.00082883}, {466,0.00083784}, {467,0.00087387}, {468,0.00086486}, {469,0.00090991}, {470,0.00092793}, {471,0.00093694}, {472,0.00196396}, {473,0.00094595}, {474,0.00096396}, {475,0.00099099}, {476,0.00100000}, {477,0.00096396}, {478,0.00100000}, {479,0.00100000}, {480,0.00099099}, {481,0.00100000}, {482,0.00100000}, {483,0.00099099}, {484,0.00099099}, {485,0.00100000}, {486,0.00100000}, {487,0.00100000}, {488,0.00100000}, {489,0.00100000}, {490,0.00100000}, {491,0.00100000}, {492,0.00100000}, {493,0.00100000}, {494,0.00100000}, {495,0.00100000}, {496,0.00100000}, {497,0.00100000}, {498,0.00100000}, {499,0.00100000}, {500,0.00100000}, {505,0.00100000}, {510,0.00100000}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00108108}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00101802}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00103604}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00104505}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100901}, {810,0.00100000}, {815,0.00100000}, {820,0.00100901}, {825,0.00100901}, {830,0.00104505}, {835,0.00108108}, {840,0.00107207}, {845,0.00108108}, {850,0.00114414}, {855,0.00114414}, {860,0.00121622}, {865,0.00124324}, {870,0.00136036}, {875,0.00141441}, {880,0.00288288}, {885,0.00160360}, {890,0.00157658}, {895,0.00168468}, {900,0.00170270}, {905,0.00169369}, {910,0.00177477}, {915,0.00183784}, {920,0.00184685}, {925,0.00192793}, {930,0.00192793}, {935,0.00197297}, {940,0.00199099}, {945,0.00199099}, {950,0.00199099}, {955,0.00200000}, {960,0.00206306}, {965,0.00200000}, {970,0.00200000}, {975,0.00200000}, {980,0.00200000}, {985,0.00447748}, {990,0.00200000}, {995,0.00200000}, {1000,0.00200000}, {1010,0.00200000}, {1020,0.00200000}, {1030,0.00206306}, {1040,0.00200000}, {1050,0.00200000}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200000}, {1140,0.00200000}, {1150,0.00200000}, {1160,0.00200000}, {1170,0.00200000}, {1180,0.00200901}, {1190,0.00200901}, {1200,0.00200000}, {1210,0.00200901}, {1220,0.00200901}, {1230,0.00202703}, {1240,0.00202703}, {1250,0.00207207}, {1260,0.00203604}, {1270,0.00215315}, {1280,0.00216216}, {1290,0.00245045}, {1300,0.00242342}, {1310,0.00256757}, {1320,0.00266667}, {1330,0.00274775}, {1340,0.00277477}, {1350,0.00279279}, {1360,0.00284685}, {1370,0.00290991}, {1380,0.00296396}, {1390,0.00295495}, {1400,0.00300000}, {1410,0.00300000}, {1420,0.00300000}, {1430,0.00794595}, {1440,0.00300000}, {1450,0.00300000}, {1460,0.00300000}, {1470,0.00300000}, {1480,0.00300000}, {1490,0.00855856}, {1500,0.00300000}, {1510,0.00300000}, {1520,0.00300000}, {1530,0.00307207}, {1540,0.00300000}, {1550,0.00300000}, {1560,0.00300901}, {1570,0.00300000}, {1580,0.00300000}, {1590,0.00300000}, {1600,0.00300901}, {1610,0.00937838}, {1620,0.00300000}, {1630,0.00301802}, {1640,0.00309910}, {1650,0.00313514}, {1660,0.00315315}, {1670,0.00927027}, {1680,0.00335135}, {1690,0.00336036}, {1700,0.00342342}, {1710,0.00353153}, {1720,0.00359459}, {1730,0.00363964}, {1740,0.00371171}, {1750,0.00959459}, {1760,0.00379279}, {1770,0.00378378}, {1780,0.00382883}, {1790,0.00389189}, {1800,0.00388288}, {1810,0.00396396}, {1820,0.00396396}, {1830,0.00400000}, {1840,0.00399099}, {1850,0.00400000}, {1860,0.00400000}, {1870,0.00400000}, {1880,0.00400000}, {1890,0.00400000}, {1900,0.00409910}, {1910,0.00400901}, {1920,0.00411712}, {1930,0.00400000}, {1940,0.00409009}, {1950,0.00400901}, {1960,0.00400901}, {1970,0.00400000}, {1980,0.00401802}, {1990,0.00411712}, {2000,0.00407207}, {2050,0.00414414}, {2100,0.00448649}, {2150,0.00845946}, {2200,0.00488288}, {2250,0.00499099}, {2300,0.00515315}, {2350,0.00501802}, {2400,0.00515315}, {2450,0.01216216}, {2500,0.00556757}, {2550,0.00594595}, {2600,0.00592793}, {2650,0.00598198}, {2700,0.00602703}, {2750,0.00608108}, {2800,0.00621622}, {2850,0.00641441}, {2900,0.00665766}, {2950,0.00690090}, {3000,0.00691892}, {3050,0.01567568}, {3100,0.00705405}, {3150,0.00723423}, {3200,0.00740541}, {3250,0.00757658}, {3300,0.00772072}, {3350,0.00781982}, {3400,0.00800000}, {3450,0.00814414}, {3500,0.00817117}, {3550,0.00842342}, {3600,0.00852252}, {3650,0.00856757}, {3700,0.00884685}, {3750,0.00888288}, {3800,0.00901802}, {3850,0.00918018}, {3900,0.00936937}, {3950,0.00940541}, {4000,0.01418919}, {4050,0.00980180}, {4100,0.00984685}, {4150,0.01000901}, {4200,0.01011712}, {4250,0.01031532}, {4300,0.01038739}, {4350,0.01055856}, {4400,0.01062162}, {4450,0.01081081}, {4500,0.01091892}, {4550,0.01110811}, {4600,0.01117117}, {4650,0.01137838}, {4700,0.01146847}, {4750,0.01166667}, {4800,0.01182883}, {4850,0.01183784}, {4900,0.01207207}, {4950,0.01216216}, {5000,0.01237838}, {5050,0.01252252}, {5100,0.01263964}, {5150,0.01276577}, {5200,0.01291892}, {5250,0.01309009}, {5300,0.01317117}, {5350,0.01333333}, {5400,0.01354955}, {5450,0.01365766}, {5500,0.01375676}, {5550,0.01381081}, {5600,0.01404505}, {5650,0.02714414}, {5700,0.01427928}, {5750,0.01446847}, {5800,0.01462162}, {5850,0.02272072}, {5900,0.01485586}, {5950,0.01492793}, {6000,0.01516216}, {6050,0.04700}, {6100,0.01450}, {6150,0.01475}, {6200,0.01450}, {6250,0.02725}, {6300,0.01525}, {6350,0.02875}, {6400,0.01525}, {6450,0.01575}, {6500,0.01575}, {6550,0.01625}, {6600,0.01600}, {6650,0.01625}, {6700,0.01675}, {6750,0.02900}, {6800,0.01675}, {6850,0.04725}, {6900,0.01725}, {6950,0.01725}, {7000,0.03325}, {7050,0.04850}, {7100,0.04250}, {7150,0.03300}, {7200,0.01825}, {7250,0.01825}, {7300,0.01825}, {7350,0.02725}, {7400,0.01875}, {7450,0.01875}, {7500,0.06250}, {7550,0.01900}, {7600,0.01925}, {7650,0.01925}, {7700,0.04425}, {7750,0.06375}, {7800,0.01975}, {7850,0.02000}, {7900,0.01975}, {7950,0.02025}, {8000,0.02025}, {8050,0.02975}, {8100,0.05725}, {8150,0.04125}, {8200,0.05975}, {8250,0.05125}, {8300,0.02050}, {8350,0.02125}, {8400,0.02125}, {8450,0.02150}, {8500,0.02200}, {8550,0.02150}, {8600,0.05575}, {8650,0.03875}, {8700,0.02250}, {8750,0.05125}, {8800,0.05625}, {8850,0.02250}, {8900,0.02250}, {8950,0.03650}, {9000,0.02325}, {9050,0.05300}, {9100,0.02275}, {9150,0.02350}, {9200,0.02375}, {9250,0.02350}, {9300,0.02325}, {9350,0.02375}, {9400,0.02375}, {9450,0.04950}, {9500,0.02425}, {9550,0.04325}, {9600,0.02425}, {9650,0.02475}, {9700,0.04900}, {9750,0.06075}, {9800,0.04825}, {9850,0.04850}, {9900,0.02600}, {9950,0.02600}, {10000,0.06050}, {10100,0.02675}, {10200,0.05825}, {10300,0.04600}, {10400,0.04450}, {10500,0.05025}, {10600,0.04300}, {10700,0.02825}, {10800,0.02825}, {10900,0.02875}, {11000,0.02875}, {11100,0.02925}, {11200,0.02900}, {11300,0.04800}, {11400,0.03025}, {11500,0.03000}, {11600,0.04800}, {11700,0.02975}, {11800,0.04900}, {11900,0.03125}, {12000,0.03150}, {12100,0.03175}, {12200,0.05350}, {12300,0.03225}, {12400,0.05250}, {12500,0.06725}, {12600,0.06700}, {12700,0.03325}, {12800,0.03350}, {12900,0.06125}, {13000,0.05700}, {13100,0.05200}, {13200,0.07275}, {13300,0.03550}, {13400,0.07225}, {13500,0.03575}, {13600,0.03650}, {13700,0.03650}, {13800,0.06425}, {13900,0.03725}, {14000,0.06825}, {14100,0.07200}, {14200,0.07400}, {14300,0.03750}, {14400,0.06950}, {14500,0.03750}, {14600,0.07575}, {14700,0.03975}, {14800,0.07800}, {14900,0.03950}, {15000,0.06950}, {15100,0.04050}, {15200,0.04075}, {15300,0.04100}, {15400,0.07475}, {15500,0.05900}, {15600,0.06575}, {15700,0.04225}, {15800,0.04275}, {15900,0.08375}, {16000,0.04225}, {16100,0.07200}, {16200,0.04375}, {16300,0.04400}, {16400,0.08550}, {16500,0.08100}, {16600,0.04475}, {16700,0.09350}, {16800,0.08250}, {16900,0.07750}, {17000,0.07625}, {17100,0.07550}, {17200,0.07675}, {17300,0.04650}, {17400,0.04700}, {17500,0.08550}, {17600,0.07150}, {17700,0.04775}, {17800,0.07700}, {17900,0.09600}, {18000,0.06500}, {18100,0.04800}, {18200,0.09875}, {18300,0.04950}, {18400,0.06550}, {18500,0.07900}, {18600,0.08050}, {18700,0.09075}, {18800,0.05100}, {18900,0.04900}, {19000,0.05000}, {19100,0.05200}, {19200,0.09225}, {19300,0.09100}, {19400,0.09775}, {19500,0.08475}, {19600,0.08800}, {19700,0.11125}, {19800,0.05400}, {19900,0.08650}, {20000,0.0755}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00006306}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00003604}, {8,0.00000000}, {9,0.00002703}, {10,0.00002703}, {11,0.00007207}, {12,0.00014414}, {13,0.00000000}, {14,0.00003604}, {15,0.00000000}, {16,0.00003604}, {17,0.00006306}, {18,0.00009009}, {19,0.00000000}, {20,0.00003604}, {21,0.00002703}, {22,0.00009009}, {23,0.00016216}, {24,0.00006306}, {25,0.00011712}, {26,0.00006306}, {27,0.00005405}, {28,0.00007207}, {29,0.00016216}, {30,0.00009009}, {31,0.00007207}, {32,0.00012613}, {33,0.00015315}, {34,0.00002703}, {35,0.00010811}, {36,0.00014414}, {37,0.00000000}, {38,0.00006306}, {39,0.00013514}, {40,0.00006306}, {41,0.00017117}, {42,0.00009910}, {43,0.00023423}, {44,0.00014414}, {45,0.00027928}, {46,0.00005405}, {47,0.00018018}, {48,0.00009009}, {49,0.00010811}, {50,0.00009910}, {51,0.00024324}, {52,0.00010811}, {53,0.00005405}, {54,0.00009009}, {55,0.00021622}, {56,0.00005405}, {57,0.00015315}, {58,0.00019820}, {59,0.00012613}, {60,0.00018919}, {61,0.00011712}, {62,0.00010811}, {63,0.00014414}, {64,0.00009009}, {65,0.00019820}, {66,0.00012613}, {67,0.00025225}, {68,0.00013514}, {69,0.00026126}, {70,0.00012613}, {71,0.00009009}, {72,0.00012613}, {73,0.00023423}, {74,0.00011712}, {75,0.00014414}, {76,0.00010811}, {77,0.00012613}, {78,0.00007207}, {79,0.00038739}, {80,0.00016216}, {81,0.00025225}, {82,0.00012613}, {83,0.00018018}, {84,0.00013514}, {85,0.00017117}, {86,0.00018919}, {87,0.00019820}, {88,0.00013514}, {89,0.00045045}, {90,0.00014414}, {91,0.00017117}, {92,0.00010811}, {93,0.00012613}, {94,0.00016216}, {95,0.00009009}, {96,0.00020721}, {97,0.00040541}, {98,0.00019820}, {99,0.00020721}, {100,0.00015315}, {101,0.00016216}, {102,0.00013514}, {103,0.00017117}, {104,0.00015315}, {105,0.00015315}, {106,0.00020721}, {107,0.00017117}, {108,0.00015315}, {109,0.00020721}, {110,0.00016216}, {111,0.00030631}, {112,0.00006306}, {113,0.00027928}, {114,0.00022523}, {115,0.00031532}, {116,0.00020721}, {117,0.00027928}, {118,0.00026126}, {119,0.00016216}, {120,0.00021622}, {121,0.00025225}, {122,0.00018018}, {123,0.00025225}, {124,0.00024324}, {125,0.00036937}, {126,0.00016216}, {127,0.00019820}, {128,0.00028829}, {129,0.00032432}, {130,0.00036937}, {131,0.00017117}, {132,0.00031532}, {133,0.00022523}, {134,0.00023423}, {135,0.00027027}, {136,0.00022523}, {137,0.00022523}, {138,0.00027928}, {139,0.00010811}, {140,0.00045045}, {141,0.00019820}, {142,0.00018018}, {143,0.00019820}, {144,0.00045045}, {145,0.00015315}, {146,0.00020721}, {147,0.00039640}, {148,0.00035135}, {149,0.00027928}, {150,0.00028829}, {151,0.00032432}, {152,0.00031532}, {153,0.00033333}, {154,0.00035135}, {155,0.00037838}, {156,0.00026126}, {157,0.00027928}, {158,0.00020721}, {159,0.00015315}, {160,0.00010811}, {161,0.00027928}, {162,0.00024324}, {163,0.00020721}, {164,0.00024324}, {165,0.00030631}, {166,0.00028829}, {167,0.00031532}, {168,0.00027027}, {169,0.00046847}, {170,0.00090090}, {171,0.00034234}, {172,0.00027928}, {173,0.00027928}, {174,0.00025225}, {175,0.00030631}, {176,0.00019820}, {177,0.00024324}, {178,0.00038739}, {179,0.00039640}, {180,0.00032432}, {181,0.00039640}, {182,0.00048649}, {183,0.00043243}, {184,0.00054955}, {185,0.00028829}, {186,0.00028829}, {187,0.00035135}, {188,0.00050450}, {189,0.00028829}, {190,0.00050450}, {191,0.00029730}, {192,0.00026126}, {193,0.00019820}, {194,0.00041441}, {195,0.00038739}, {196,0.00023423}, {197,0.00027027}, {198,0.00027928}, {199,0.00044144}, {200,0.00035135}, {201,0.00036036}, {202,0.00014414}, {203,0.00043243}, {204,0.00039640}, {205,0.00049550}, {206,0.00030631}, {207,0.00035135}, {208,0.00041441}, {209,0.00034234}, {210,0.00050450}, {211,0.00041441}, {212,0.00035135}, {213,0.00043243}, {214,0.00045045}, {215,0.00027027}, {216,0.00018919}, {217,0.00040541}, {218,0.00028829}, {219,0.00043243}, {220,0.00050450}, {221,0.00030631}, {222,0.00036937}, {223,0.00043243}, {224,0.00060360}, {225,0.00046847}, {226,0.00052252}, {227,0.00045946}, {228,0.00054054}, {229,0.00027928}, {230,0.00065766}, {231,0.00048649}, {232,0.00043243}, {233,0.00038739}, {234,0.00054955}, {235,0.00040541}, {236,0.00045946}, {237,0.00027928}, {238,0.00040541}, {239,0.00037838}, {240,0.00030631}, {241,0.00051351}, {242,0.00045045}, {243,0.00061261}, {244,0.00030631}, {245,0.00038739}, {246,0.00046847}, {247,0.00055856}, {248,0.00050450}, {249,0.00041441}, {250,0.00048649}, {251,0.00051351}, {252,0.00049550}, {253,0.00053153}, {254,0.00061261}, {255,0.00053153}, {256,0.00045946}, {257,0.00040541}, {258,0.00045946}, {259,0.00035135}, {260,0.00054054}, {261,0.00063964}, {262,0.00032432}, {263,0.00054955}, {264,0.00056757}, {265,0.00048649}, {266,0.00039640}, {267,0.00058559}, {268,0.00036937}, {269,0.00057658}, {270,0.00046847}, {271,0.00039640}, {272,0.00054955}, {273,0.00047748}, {274,0.00052252}, {275,0.00039640}, {276,0.00063964}, {277,0.00040541}, {278,0.00045045}, {279,0.00067568}, {280,0.00045045}, {281,0.00047748}, {282,0.00051351}, {283,0.00057658}, {284,0.00072072}, {285,0.00042342}, {286,0.00039640}, {287,0.00039640}, {288,0.00030631}, {289,0.00041441}, {290,0.00055856}, {291,0.00060360}, {292,0.00060360}, {293,0.00045045}, {294,0.00064865}, {295,0.00090991}, {296,0.00033333}, {297,0.00037838}, {298,0.00052252}, {299,0.00048649}, {300,0.00037838}, {301,0.00062162}, {302,0.00054955}, {303,0.00072973}, {304,0.00060360}, {305,0.00071171}, {306,0.00058559}, {307,0.00069369}, {308,0.00052252}, {309,0.00067568}, {310,0.00038739}, {311,0.00045946}, {312,0.00090090}, {313,0.00063063}, {314,0.00077477}, {315,0.00058559}, {316,0.00043243}, {317,0.00054955}, {318,0.00051351}, {319,0.00054955}, {320,0.00088288}, {321,0.00064865}, {322,0.00051351}, {323,0.00036937}, {324,0.00049550}, {325,0.00070270}, {326,0.00044144}, {327,0.00063063}, {328,0.00042342}, {329,0.00067568}, {330,0.00083784}, {331,0.00085586}, {332,0.00072072}, {333,0.00038739}, {334,0.00053153}, {335,0.00079279}, {336,0.00056757}, {337,0.00065766}, {338,0.00064865}, {339,0.00061261}, {340,0.00081081}, {341,0.00066667}, {342,0.00133333}, {343,0.00076577}, {344,0.00071171}, {345,0.00054955}, {346,0.00080180}, {347,0.00087387}, {348,0.00047748}, {349,0.00067568}, {350,0.00053153}, {351,0.00063063}, {352,0.00027928}, {353,0.00045946}, {354,0.00067568}, {355,0.00068468}, {356,0.00046847}, {357,0.00054955}, {358,0.00062162}, {359,0.00062162}, {360,0.00062162}, {361,0.00070270}, {362,0.00072973}, {363,0.00090991}, {364,0.00075676}, {365,0.00071171}, {366,0.00047748}, {367,0.00072072}, {368,0.00072072}, {369,0.00094595}, {370,0.00094595}, {371,0.00101802}, {372,0.00063063}, {373,0.00073874}, {374,0.00071171}, {375,0.00098198}, {376,0.00107207}, {377,0.00050450}, {378,0.00059459}, {379,0.00075676}, {380,0.00071171}, {381,0.00077477}, {382,0.00084685}, {383,0.00069369}, {384,0.00052252}, {385,0.00073874}, {386,0.00080180}, {387,0.00063964}, {388,0.00086486}, {389,0.00110811}, {390,0.00220721}, {391,0.00090090}, {392,0.00072072}, {393,0.00084685}, {394,0.00066667}, {395,0.00078378}, {396,0.00073874}, {397,0.00087387}, {398,0.00071171}, {399,0.00076577}, {400,0.00089189}, {401,0.00098198}, {402,0.00067568}, {403,0.00118018}, {404,0.00061261}, {405,0.00054955}, {406,0.00058559}, {407,0.00123423}, {408,0.00100000}, {409,0.00057658}, {410,0.00086486}, {411,0.00087387}, {412,0.00084685}, {413,0.00084685}, {414,0.00044144}, {415,0.00095495}, {416,0.00104505}, {417,0.00092793}, {418,0.00078378}, {419,0.00068468}, {420,0.00077477}, {421,0.00090991}, {422,0.00072072}, {423,0.00102703}, {424,0.00117117}, {425,0.00073874}, {426,0.00071171}, {427,0.00092793}, {428,0.00095495}, {429,0.00102703}, {430,0.00077477}, {431,0.00077477}, {432,0.00081982}, {433,0.00084685}, {434,0.00091892}, {435,0.00063964}, {436,0.00074775}, {437,0.00073874}, {438,0.00071171}, {439,0.00094595}, {440,0.00066667}, {441,0.00111712}, {442,0.00090090}, {443,0.00089189}, {444,0.00063964}, {445,0.00082883}, {446,0.00083784}, {447,0.00098198}, {448,0.00063063}, {449,0.00103604}, {450,0.00081081}, {451,0.00112613}, {452,0.00094595}, {453,0.00072072}, {454,0.00089189}, {455,0.00118919}, {456,0.00079279}, {457,0.00074775}, {458,0.00095495}, {459,0.00100901}, {460,0.00088288}, {461,0.00108108}, {462,0.00100901}, {463,0.00083784}, {464,0.00096396}, {465,0.00094595}, {466,0.00112613}, {467,0.00083784}, {468,0.00125225}, {469,0.00115315}, {470,0.00103604}, {471,0.00085586}, {472,0.00221622}, {473,0.00108108}, {474,0.00096396}, {475,0.00119820}, {476,0.00086486}, {477,0.00086486}, {478,0.00100000}, {479,0.00076577}, {480,0.00099099}, {481,0.00083784}, {482,0.00090090}, {483,0.00088288}, {484,0.00115315}, {485,0.00102703}, {486,0.00091892}, {487,0.00089189}, {488,0.00093694}, {489,0.00099099}, {490,0.00101802}, {491,0.00085586}, {492,0.00110811}, {493,0.00081982}, {494,0.00090991}, {495,0.00075676}, {496,0.00091892}, {497,0.00064865}, {498,0.00117117}, {499,0.00126126}, {500,0.00072973}, {505,0.00101802}, {510,0.00111712}, {515,0.00137838}, {520,0.00139640}, {525,0.00111712}, {530,0.00134234}, {535,0.00067568}, {540,0.00113514}, {545,0.00117117}, {550,0.00110811}, {555,0.00073874}, {560,0.00117117}, {565,0.00102703}, {570,0.00081982}, {575,0.00101802}, {580,0.00119820}, {585,0.00108108}, {590,0.00115315}, {595,0.00142342}, {600,0.00125225}, {605,0.00127928}, {610,0.00116216}, {615,0.00127027}, {620,0.00129730}, {625,0.00100901}, {630,0.00125225}, {635,0.00113514}, {640,0.00110811}, {645,0.00108108}, {650,0.00131532}, {655,0.00143243}, {660,0.00118919}, {665,0.00139640}, {670,0.00133333}, {675,0.00125225}, {680,0.00138739}, {685,0.00129730}, {690,0.00116216}, {695,0.00115315}, {700,0.00132432}, {705,0.00117117}, {710,0.00138739}, {715,0.00126126}, {720,0.00124324}, {725,0.00148649}, {730,0.00136937}, {735,0.00138739}, {740,0.00129730}, {745,0.00144144}, {750,0.00136036}, {755,0.00119820}, {760,0.00133333}, {765,0.00129730}, {770,0.00119820}, {775,0.00137838}, {780,0.00149550}, {785,0.00163964}, {790,0.00184685}, {795,0.00168468}, {800,0.00139640}, {805,0.00119820}, {810,0.00166667}, {815,0.00154054}, {820,0.00130631}, {825,0.00144144}, {830,0.00173874}, {835,0.00170270}, {840,0.00145946}, {845,0.00177477}, {850,0.00157658}, {855,0.00136937}, {860,0.00182883}, {865,0.00167568}, {870,0.00194595}, {875,0.00160360}, {880,0.00263964}, {885,0.00179279}, {890,0.00173874}, {895,0.00163063}, {900,0.00189189}, {905,0.00145045}, {910,0.00136937}, {915,0.00175676}, {920,0.00144144}, {925,0.00175676}, {930,0.00203604}, {935,0.00202703}, {940,0.00192793}, {945,0.00195495}, {950,0.00163964}, {955,0.00153153}, {960,0.00186486}, {965,0.00159459}, {970,0.00192793}, {975,0.00181081}, {980,0.00186486}, {985,0.00391892}, {990,0.00185586}, {995,0.00163964}, {1000,0.00157658}, {1010,0.00211712}, {1020,0.00202703}, {1030,0.00191892}, {1040,0.00218018}, {1050,0.00202703}, {1060,0.00195495}, {1070,0.00193694}, {1080,0.00211712}, {1090,0.00225225}, {1100,0.00217117}, {1110,0.00186486}, {1120,0.00223423}, {1130,0.00189189}, {1140,0.00209009}, {1150,0.00201802}, {1160,0.00212613}, {1170,0.00200000}, {1180,0.00218018}, {1190,0.00243243}, {1200,0.00226126}, {1210,0.00246847}, {1220,0.00227027}, {1230,0.00238739}, {1240,0.00237838}, {1250,0.00237838}, {1260,0.00213514}, {1270,0.00243243}, {1280,0.00237838}, {1290,0.00241441}, {1300,0.00228829}, {1310,0.00244144}, {1320,0.00252252}, {1330,0.00252252}, {1340,0.00247748}, {1350,0.00239640}, {1360,0.00247748}, {1370,0.00253153}, {1380,0.00244144}, {1390,0.00260360}, {1400,0.00239640}, {1410,0.00271171}, {1420,0.00275676}, {1430,0.00787387}, {1440,0.00278378}, {1450,0.00281982}, {1460,0.00282883}, {1470,0.00306306}, {1480,0.00273874}, {1490,0.00866667}, {1500,0.00286486}, {1510,0.00289189}, {1520,0.00290991}, {1530,0.00307207}, {1540,0.00305405}, {1550,0.00314414}, {1560,0.00290090}, {1570,0.00314414}, {1580,0.00296396}, {1590,0.00302703}, {1600,0.00303604}, {1610,0.00939640}, {1620,0.00310811}, {1630,0.00305405}, {1640,0.00328829}, {1650,0.00322523}, {1660,0.00331532}, {1670,0.00946847}, {1680,0.00335135}, {1690,0.00328829}, {1700,0.00341441}, {1710,0.00327027}, {1720,0.00343243}, {1730,0.00334234}, {1740,0.00341441}, {1750,0.01002703}, {1760,0.00347748}, {1770,0.00361261}, {1780,0.00382883}, {1790,0.00366667}, {1800,0.00383784}, {1810,0.00393694}, {1820,0.00391892}, {1830,0.00400000}, {1840,0.00403604}, {1850,0.00393694}, {1860,0.00410811}, {1870,0.00388288}, {1880,0.00390991}, {1890,0.00417117}, {1900,0.00415315}, {1910,0.00418018}, {1920,0.00437838}, {1930,0.00421622}, {1940,0.00443243}, {1950,0.00434234}, {1960,0.00429730}, {1970,0.00439640}, {1980,0.00437838}, {1990,0.00411712}, {2000,0.00404505}, {2050,0.00454054}, {2100,0.00450450}, {2150,0.00889189}, {2200,0.00492793}, {2250,0.00503604}, {2300,0.00511712}, {2350,0.00511712}, {2400,0.00502703}, {2450,0.01253153}, {2500,0.00548649}, {2550,0.00555856}, {2600,0.00545045}, {2650,0.00608108}, {2700,0.00628829}, {2750,0.00627027}, {2800,0.00626126}, {2850,0.00620721}, {2900,0.00646847}, {2950,0.00660360}, {3000,0.00680180}, {3050,0.01580180}, {3100,0.00697297}, {3150,0.00715315}, {3200,0.00739640}, {3250,0.00750450}, {3300,0.00775676}, {3350,0.00754054}, {3400,0.00818919}, {3450,0.00814414}, {3500,0.00819820}, {3550,0.00844144}, {3600,0.00855856}, {3650,0.00840541}, {3700,0.00894595}, {3750,0.00887387}, {3800,0.00892793}, {3850,0.00911712}, {3900,0.00927928}, {3950,0.00989189}, {4000,0.01450450}, {4050,0.01005405}, {4100,0.01033333}, {4150,0.01001802}, {4200,0.01010811}, {4250,0.01057658}, {4300,0.01063063}, {4350,0.01102703}, {4400,0.01099099}, {4450,0.01114414}, {4500,0.01137838}, {4550,0.01163964}, {4600,0.01159459}, {4650,0.01177477}, {4700,0.01190090}, {4750,0.01216216}, {4800,0.01231532}, {4850,0.01235135}, {4900,0.01252252}, {4950,0.01255856}, {5000,0.01287387}, {5050,0.01292793}, {5100,0.01278378}, {5150,0.01328829}, {5200,0.01305405}, {5250,0.01363964}, {5300,0.01383784}, {5350,0.01348649}, {5400,0.01381081}, {5450,0.01361261}, {5500,0.01395495}, {5550,0.01434234}, {5600,0.01436036}, {5650,0.02704505}, {5700,0.01435135}, {5750,0.01431532}, {5800,0.01463063}, {5850,0.02286486}, {5900,0.01511712}, {5950,0.01497297}, {6000,0.01515315}, {6050,0.04675}, {6100,0.01500}, {6150,0.01575}, {6200,0.01575}, {6250,0.02750}, {6300,0.01550}, {6350,0.02975}, {6400,0.01550}, {6450,0.01575}, {6500,0.01550}, {6550,0.01800}, {6600,0.01775}, {6650,0.01575}, {6700,0.01675}, {6750,0.02925}, {6800,0.01550}, {6850,0.04450}, {6900,0.01650}, {6950,0.01825}, {7000,0.03275}, {7050,0.04950}, {7100,0.04175}, {7150,0.03475}, {7200,0.01850}, {7250,0.01600}, {7300,0.01950}, {7350,0.02700}, {7400,0.01850}, {7450,0.01950}, {7500,0.06300}, {7550,0.01925}, {7600,0.02000}, {7650,0.01950}, {7700,0.04325}, {7750,0.06375}, {7800,0.01950}, {7850,0.01975}, {7900,0.01850}, {7950,0.01900}, {8000,0.01950}, {8050,0.02925}, {8100,0.05525}, {8150,0.04175}, {8200,0.06025}, {8250,0.05050}, {8300,0.02075}, {8350,0.02025}, {8400,0.02275}, {8450,0.02150}, {8500,0.02400}, {8550,0.02150}, {8600,0.05675}, {8650,0.03725}, {8700,0.02275}, {8750,0.05125}, {8800,0.05625}, {8850,0.02150}, {8900,0.02375}, {8950,0.03600}, {9000,0.02375}, {9050,0.05325}, {9100,0.02275}, {9150,0.02400}, {9200,0.02400}, {9250,0.02350}, {9300,0.02475}, {9350,0.02475}, {9400,0.02400}, {9450,0.05000}, {9500,0.02400}, {9550,0.04350}, {9600,0.02400}, {9650,0.02400}, {9700,0.04775}, {9750,0.06175}, {9800,0.04800}, {9850,0.04875}, {9900,0.02600}, {9950,0.02500}, {10000,0.06075}, {10100,0.02625}, {10200,0.05900}, {10300,0.04450}, {10400,0.04350}, {10500,0.05075}, {10600,0.04200}, {10700,0.02950}, {10800,0.02825}, {10900,0.02950}, {11000,0.03025}, {11100,0.02925}, {11200,0.02900}, {11300,0.04750}, {11400,0.03000}, {11500,0.02975}, {11600,0.04800}, {11700,0.02950}, {11800,0.05075}, {11900,0.03125}, {12000,0.03125}, {12100,0.03175}, {12200,0.05425}, {12300,0.03375}, {12400,0.05225}, {12500,0.06800}, {12600,0.06650}, {12700,0.03375}, {12800,0.03300}, {12900,0.06175}, {13000,0.05775}, {13100,0.05200}, {13200,0.07375}, {13300,0.03600}, {13400,0.07200}, {13500,0.03600}, {13600,0.03650}, {13700,0.03675}, {13800,0.06325}, {13900,0.03600}, {14000,0.06675}, {14100,0.07300}, {14200,0.07550}, {14300,0.03675}, {14400,0.06950}, {14500,0.03850}, {14600,0.07450}, {14700,0.03875}, {14800,0.07825}, {14900,0.04025}, {15000,0.06975}, {15100,0.03925}, {15200,0.04125}, {15300,0.04275}, {15400,0.07575}, {15500,0.05925}, {15600,0.06625}, {15700,0.04050}, {15800,0.04225}, {15900,0.08375}, {16000,0.04300}, {16100,0.07175}, {16200,0.04425}, {16300,0.04350}, {16400,0.08675}, {16500,0.08075}, {16600,0.04550}, {16700,0.09375}, {16800,0.08275}, {16900,0.07825}, {17000,0.07550}, {17100,0.07475}, {17200,0.07675}, {17300,0.04575}, {17400,0.04800}, {17500,0.08475}, {17600,0.07200}, {17700,0.04775}, {17800,0.07825}, {17900,0.09600}, {18000,0.06475}, {18100,0.04900}, {18200,0.09875}, {18300,0.05075}, {18400,0.06425}, {18500,0.07975}, {18600,0.07850}, {18700,0.09025}, {18800,0.04950}, {18900,0.04900}, {19000,0.04875}, {19100,0.05300}, {19200,0.09275}, {19300,0.09050}, {19400,0.09825}, {19500,0.08450}, {19600,0.08750}, {19700,0.11075}, {19800,0.05525}, {19900,0.08650}, {20000,0.0775}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["cbv"]["system"] = {{1,0.00002703}, {2,0.00002703}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00003604}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00003604}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00003604}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00003604}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00003604}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00003604}, {151,0.00003604}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00003604}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00003604}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00003604}, {169,0.00003604}, {170,0.00003604}, {171,0.00000000}, {172,0.00000000}, {173,0.00003604}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00002703}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00003604}, {185,0.00000000}, {186,0.00007207}, {187,0.00000000}, {188,0.00000000}, {189,0.00003604}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00003604}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00007207}, {207,0.00003604}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00003604}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00002703}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00003604}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00006306}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00003604}, {242,0.00003604}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00003604}, {251,0.00000000}, {252,0.00007207}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00003604}, {267,0.00000000}, {268,0.00003604}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00003604}, {273,0.00000000}, {274,0.00000000}, {275,0.00003604}, {276,0.00000000}, {277,0.00000000}, {278,0.00002703}, {279,0.00003604}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00003604}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00003604}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00002703}, {305,0.00000000}, {306,0.00000000}, {307,0.00003604}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00003604}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00003604}, {319,0.00000000}, {320,0.00000000}, {321,0.00003604}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00007207}, {328,0.00003604}, {329,0.00000000}, {330,0.00000000}, {331,0.00003604}, {332,0.00000000}, {333,0.00003604}, {334,0.00000000}, {335,0.00003604}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00003604}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00003604}, {349,0.00000000}, {350,0.00006306}, {351,0.00002703}, {352,0.00000000}, {353,0.00003604}, {354,0.00000000}, {355,0.00003604}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00003604}, {360,0.00000000}, {361,0.00000000}, {362,0.00003604}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00002703}, {370,0.00003604}, {371,0.00003604}, {372,0.00000000}, {373,0.00003604}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00003604}, {379,0.00000000}, {380,0.00003604}, {381,0.00003604}, {382,0.00003604}, {383,0.00000000}, {384,0.00000000}, {385,0.00003604}, {386,0.00000000}, {387,0.00000000}, {388,0.00003604}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00002703}, {400,0.00003604}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00003604}, {410,0.00000000}, {411,0.00000000}, {412,0.00003604}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00006306}, {431,0.00003604}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00003604}, {439,0.00000000}, {440,0.00002703}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00007207}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00003604}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00007207}, {465,0.00003604}, {466,0.00000000}, {467,0.00003604}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00003604}, {473,0.00000000}, {474,0.00000000}, {475,0.00003604}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00003604}, {480,0.00003604}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00003604}, {485,0.00003604}, {486,0.00003604}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00003604}, {492,0.00000000}, {493,0.00000000}, {494,0.00006306}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00007207}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00003604}, {565,0.00000000}, {570,0.00003604}, {575,0.00000000}, {580,0.00003604}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00003604}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00003604}, {645,0.00000000}, {650,0.00000000}, {655,0.00003604}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00003604}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00002703}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00003604}, {720,0.00003604}, {725,0.00003604}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00003604}, {755,0.00000000}, {760,0.00003604}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00003604}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00010811}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00003604}, {835,0.00000000}, {840,0.00000000}, {845,0.00002703}, {850,0.00007207}, {855,0.00000000}, {860,0.00000000}, {865,0.00003604}, {870,0.00000000}, {875,0.00000000}, {880,0.00006306}, {885,0.00003604}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00003604}, {955,0.00000000}, {960,0.00002703}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00003604}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00003604}, {1080,0.00000000}, {1090,0.00007207}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00007207}, {1130,0.00002703}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00003604}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00003604}, {1310,0.00003604}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00003604}, {1390,0.00002703}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00003604}, {1430,0.00002703}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00003604}, {1500,0.00003604}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00003604}, {1600,0.00000000}, {1610,0.00017117}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00007207}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00003604}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00010811}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00003604}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00003604}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00003604}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00003604}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00002703}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00003604}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00003604}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00007207}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00003604}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00021622}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00100}, {6100,0.00100}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00100}, {6900,0.00000}, {6950,0.00000}, {7000,0.00100}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00100}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00100}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00192793}, {262,0.00000000}, {263,0.00196396}, {264,0.00000000}, {265,0.00127928}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00003604}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00358559}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00390991}, {431,0.00000000}, {432,0.00000000}, {433,0.00001802}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00001802}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000901}, {451,0.00000901}, {452,0.00000000}, {453,0.00000901}, {454,0.00000000}, {455,0.00000000}, {456,0.00001802}, {457,0.00000901}, {458,0.00001802}, {459,0.00000000}, {460,0.00001802}, {461,0.00000901}, {462,0.00000000}, {463,0.00002703}, {464,0.00000000}, {465,0.00000901}, {466,0.00000901}, {467,0.00003604}, {468,0.00006306}, {469,0.00004505}, {470,0.00003604}, {471,0.00003604}, {472,0.00003604}, {473,0.00004505}, {474,0.00000901}, {475,0.00000000}, {476,0.00007207}, {477,0.00009009}, {478,0.00006306}, {479,0.00007207}, {480,0.00011712}, {481,0.00015315}, {482,0.00005405}, {483,0.00003604}, {484,0.00005405}, {485,0.00018919}, {486,0.00020721}, {487,0.00033333}, {488,0.00031532}, {489,0.00028829}, {490,0.00037838}, {491,0.00026126}, {492,0.00035135}, {493,0.00024324}, {494,0.00015315}, {495,0.00004505}, {496,0.00001802}, {497,0.00054955}, {498,0.00054955}, {499,0.00052252}, {500,0.00057658}, {505,0.00062162}, {510,0.00072973}, {515,0.00087387}, {520,0.00092793}, {525,0.00098198}, {530,0.00098198}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00491892}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00649550}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00100000}, {830,0.00100000}, {835,0.00100000}, {840,0.00100000}, {845,0.00100000}, {850,0.00100000}, {855,0.00100000}, {860,0.00100000}, {865,0.00100000}, {870,0.00100000}, {875,0.00100000}, {880,0.00100000}, {885,0.00100000}, {890,0.00100000}, {895,0.00100901}, {900,0.00100000}, {905,0.00100901}, {910,0.00100901}, {915,0.00100000}, {920,0.00103604}, {925,0.00102703}, {930,0.00100000}, {935,0.00100000}, {940,0.00117117}, {945,0.00107207}, {950,0.00100000}, {955,0.00109910}, {960,0.00122523}, {965,0.00118919}, {970,0.00106306}, {975,0.00100000}, {980,0.00145045}, {985,0.00157658}, {990,0.00158559}, {995,0.00118018}, {1000,0.00109009}, {1010,0.00100901}, {1020,0.00185586}, {1030,0.00193694}, {1040,0.00197297}, {1050,0.00198198}, {1060,0.00197297}, {1070,0.00200000}, {1080,0.00198198}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200000}, {1140,0.00200000}, {1150,0.00200000}, {1160,0.00854054}, {1170,0.00200000}, {1180,0.00200000}, {1190,0.00200000}, {1200,0.00200000}, {1210,0.00200000}, {1220,0.00200000}, {1230,0.00200000}, {1240,0.00200000}, {1250,0.00200000}, {1260,0.00200000}, {1270,0.00200000}, {1280,0.00200000}, {1290,0.00200000}, {1300,0.00200000}, {1310,0.00204505}, {1320,0.00200000}, {1330,0.00200000}, {1340,0.00200000}, {1350,0.00201802}, {1360,0.00200000}, {1370,0.00200901}, {1380,0.00200000}, {1390,0.00205405}, {1400,0.00200000}, {1410,0.00222523}, {1420,0.00200901}, {1430,0.00200000}, {1440,0.00217117}, {1450,0.00201802}, {1460,0.00206306}, {1470,0.00236937}, {1480,0.00206306}, {1490,0.00200000}, {1500,0.00282883}, {1510,0.00258559}, {1520,0.00223423}, {1530,0.00206306}, {1540,0.00203604}, {1550,0.00294595}, {1560,0.00294595}, {1570,0.00287387}, {1580,0.00280180}, {1590,0.00273874}, {1600,0.00272973}, {1610,0.00268468}, {1620,0.00266667}, {1630,0.00271171}, {1640,0.00275676}, {1650,0.00280180}, {1660,0.00293694}, {1670,0.00298198}, {1680,0.00300000}, {1690,0.00300000}, {1700,0.00300000}, {1710,0.00300000}, {1720,0.00300000}, {1730,0.00750450}, {1740,0.00300000}, {1750,0.00300000}, {1760,0.00300000}, {1770,0.00300000}, {1780,0.00300000}, {1790,0.00300000}, {1800,0.00300000}, {1810,0.00305405}, {1820,0.00300000}, {1830,0.00300000}, {1840,0.00860360}, {1850,0.00300000}, {1860,0.00302703}, {1870,0.00300000}, {1880,0.00300000}, {1890,0.00306306}, {1900,0.00300901}, {1910,0.00310811}, {1920,0.00303604}, {1930,0.00306306}, {1940,0.00305405}, {1950,0.00300000}, {1960,0.00320721}, {1970,0.00300000}, {1980,0.00771171}, {1990,0.00319820}, {2000,0.00300901}, {2050,0.00957658}, {2100,0.00390090}, {2150,0.00397297}, {2200,0.00400000}, {2250,0.00400000}, {2300,0.00400901}, {2350,0.00400000}, {2400,0.00400000}, {2450,0.00436937}, {2500,0.00407207}, {2550,0.00400901}, {2600,0.00486486}, {2650,0.00478378}, {2700,0.00482883}, {2750,0.00495495}, {2800,0.00500000}, {2850,0.00501802}, {2900,0.00510811}, {2950,0.00500000}, {3000,0.00540541}, {3050,0.00501802}, {3100,0.00517117}, {3150,0.00577477}, {3200,0.00576577}, {3250,0.00581982}, {3300,0.00593694}, {3350,0.00599099}, {3400,0.00604505}, {3450,0.00983784}, {3500,0.00600901}, {3550,0.00650450}, {3600,0.00623423}, {3650,0.00620721}, {3700,0.00683784}, {3750,0.00684685}, {3800,0.00690991}, {3850,0.00697297}, {3900,0.00700901}, {3950,0.00716216}, {4000,0.00698198}, {4050,0.00712613}, {4100,0.00721622}, {4150,0.00745045}, {4200,0.00725225}, {4250,0.01778378}, {4300,0.00795495}, {4350,0.00796396}, {4400,0.00804505}, {4450,0.00814414}, {4500,0.00801802}, {4550,0.00801802}, {4600,0.00849550}, {4650,0.00817117}, {4700,0.00879279}, {4750,0.00860360}, {4800,0.00860360}, {4850,0.00871171}, {4900,0.00879279}, {4950,0.00882883}, {5000,0.00893694}, {5050,0.00901802}, {5100,0.00947748}, {5150,0.00909910}, {5200,0.00963964}, {5250,0.00942342}, {5300,0.01650450}, {5350,0.00981081}, {5400,0.00990090}, {5450,0.00990991}, {5500,0.00995495}, {5550,0.02527928}, {5600,0.00995495}, {5650,0.01018919}, {5700,0.01058559}, {5750,0.01027027}, {5800,0.01768468}, {5850,0.01077477}, {5900,0.01076577}, {5950,0.01078378}, {6000,0.01090090}, {6050,0.01075}, {6100,0.02025}, {6150,0.01050}, {6200,0.01100}, {6250,0.02475}, {6300,0.01100}, {6350,0.01100}, {6400,0.01125}, {6450,0.01125}, {6500,0.01125}, {6550,0.01150}, {6600,0.01150}, {6650,0.01200}, {6700,0.02150}, {6750,0.01200}, {6800,0.01250}, {6850,0.01225}, {6900,0.02200}, {6950,0.01250}, {7000,0.01275}, {7050,0.01250}, {7100,0.01275}, {7150,0.01275}, {7200,0.02550}, {7250,0.01300}, {7300,0.01325}, {7350,0.02575}, {7400,0.01325}, {7450,0.01375}, {7500,0.02875}, {7550,0.01375}, {7600,0.01375}, {7650,0.03250}, {7700,0.02150}, {7750,0.01400}, {7800,0.01400}, {7850,0.02950}, {7900,0.01425}, {7950,0.01450}, {8000,0.01475}, {8050,0.01475}, {8100,0.01475}, {8150,0.01475}, {8200,0.01475}, {8250,0.01475}, {8300,0.01500}, {8350,0.01525}, {8400,0.01475}, {8450,0.03425}, {8500,0.01525}, {8550,0.01550}, {8600,0.03525}, {8650,0.01575}, {8700,0.01575}, {8750,0.03125}, {8800,0.01575}, {8850,0.01600}, {8900,0.01650}, {8950,0.02050}, {9000,0.01650}, {9050,0.01675}, {9100,0.03000}, {9150,0.03800}, {9200,0.03800}, {9250,0.01675}, {9300,0.01650}, {9350,0.03250}, {9400,0.01675}, {9450,0.01700}, {9500,0.01775}, {9550,0.01750}, {9600,0.01725}, {9650,0.03375}, {9700,0.01775}, {9750,0.01775}, {9800,0.01800}, {9850,0.03425}, {9900,0.01800}, {9950,0.01800}, {10000,0.03975}, {10100,0.01875}, {10200,0.01900}, {10300,0.01900}, {10400,0.01900}, {10500,0.01950}, {10600,0.01950}, {10700,0.02000}, {10800,0.02875}, {10900,0.03550}, {11000,0.02000}, {11100,0.02025}, {11200,0.02075}, {11300,0.04525}, {11400,0.02100}, {11500,0.02100}, {11600,0.02450}, {11700,0.02200}, {11800,0.02200}, {11900,0.02225}, {12000,0.02200}, {12100,0.02225}, {12200,0.05075}, {12300,0.02275}, {12400,0.03350}, {12500,0.04300}, {12600,0.03050}, {12700,0.02350}, {12800,0.05450}, {12900,0.02400}, {13000,0.02400}, {13100,0.02450}, {13200,0.02450}, {13300,0.03925}, {13400,0.02500}, {13500,0.02500}, {13600,0.02500}, {13700,0.02600}, {13800,0.04525}, {13900,0.02600}, {14000,0.02575}, {14100,0.02600}, {14200,0.02600}, {14300,0.05875}, {14400,0.02675}, {14500,0.06200}, {14600,0.02725}, {14700,0.02725}, {14800,0.06300}, {14900,0.02775}, {15000,0.04625}, {15100,0.02800}, {15200,0.02800}, {15300,0.05700}, {15400,0.02900}, {15500,0.02925}, {15600,0.02900}, {15700,0.02925}, {15800,0.02925}, {15900,0.06725}, {16000,0.02950}, {16100,0.06550}, {16200,0.03000}, {16300,0.06775}, {16400,0.05275}, {16500,0.03775}, {16600,0.03075}, {16700,0.03100}, {16800,0.03150}, {16900,0.03125}, {17000,0.03175}, {17100,0.06525}, {17200,0.03175}, {17300,0.03225}, {17400,0.03225}, {17500,0.06650}, {17600,0.03300}, {17700,0.03300}, {17800,0.03325}, {17900,0.03325}, {18000,0.03350}, {18100,0.05575}, {18200,0.03400}, {18300,0.03425}, {18400,0.03425}, {18500,0.03500}, {18600,0.03475}, {18700,0.05300}, {18800,0.03500}, {18900,0.03525}, {19000,0.03525}, {19100,0.07650}, {19200,0.04325}, {19300,0.03625}, {19400,0.03625}, {19500,0.03650}, {19600,0.03625}, {19700,0.07375}, {19800,0.03700}, {19900,0.03700}, {20000,0.0370}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["eval lazy"]["user"] = {{1,0.00003604}, {2,0.00000000}, {3,0.00009009}, {4,0.00006306}, {5,0.00005405}, {6,0.00000000}, {7,0.00002703}, {8,0.00003604}, {9,0.00006306}, {10,0.00000000}, {11,0.00009009}, {12,0.00003604}, {13,0.00005405}, {14,0.00003604}, {15,0.00015315}, {16,0.00006306}, {17,0.00009910}, {18,0.00006306}, {19,0.00007207}, {20,0.00009009}, {21,0.00009009}, {22,0.00005405}, {23,0.00014414}, {24,0.00007207}, {25,0.00011712}, {26,0.00009009}, {27,0.00000000}, {28,0.00003604}, {29,0.00006306}, {30,0.00006306}, {31,0.00009009}, {32,0.00015315}, {33,0.00007207}, {34,0.00006306}, {35,0.00003604}, {36,0.00010811}, {37,0.00013514}, {38,0.00016216}, {39,0.00014414}, {40,0.00003604}, {41,0.00009009}, {42,0.00002703}, {43,0.00016216}, {44,0.00018919}, {45,0.00016216}, {46,0.00009910}, {47,0.00011712}, {48,0.00006306}, {49,0.00002703}, {50,0.00020721}, {51,0.00010811}, {52,0.00019820}, {53,0.00010811}, {54,0.00022523}, {55,0.00009009}, {56,0.00018018}, {57,0.00014414}, {58,0.00011712}, {59,0.00012613}, {60,0.00015315}, {61,0.00011712}, {62,0.00009910}, {63,0.00015315}, {64,0.00022523}, {65,0.00012613}, {66,0.00012613}, {67,0.00006306}, {68,0.00015315}, {69,0.00009910}, {70,0.00015315}, {71,0.00027027}, {72,0.00019820}, {73,0.00016216}, {74,0.00024324}, {75,0.00013514}, {76,0.00017117}, {77,0.00009910}, {78,0.00007207}, {79,0.00020721}, {80,0.00013514}, {81,0.00014414}, {82,0.00009009}, {83,0.00017117}, {84,0.00029730}, {85,0.00007207}, {86,0.00009910}, {87,0.00009009}, {88,0.00033333}, {89,0.00017117}, {90,0.00032432}, {91,0.00027928}, {92,0.00014414}, {93,0.00022523}, {94,0.00011712}, {95,0.00009910}, {96,0.00024324}, {97,0.00019820}, {98,0.00024324}, {99,0.00017117}, {100,0.00014414}, {101,0.00025225}, {102,0.00016216}, {103,0.00034234}, {104,0.00022523}, {105,0.00021622}, {106,0.00027027}, {107,0.00022523}, {108,0.00031532}, {109,0.00027928}, {110,0.00024324}, {111,0.00027928}, {112,0.00018919}, {113,0.00025225}, {114,0.00027027}, {115,0.00034234}, {116,0.00035135}, {117,0.00036036}, {118,0.00019820}, {119,0.00009910}, {120,0.00038739}, {121,0.00015315}, {122,0.00031532}, {123,0.00031532}, {124,0.00040541}, {125,0.00039640}, {126,0.00011712}, {127,0.00018018}, {128,0.00027027}, {129,0.00021622}, {130,0.00009910}, {131,0.00023423}, {132,0.00038739}, {133,0.00023423}, {134,0.00029730}, {135,0.00022523}, {136,0.00012613}, {137,0.00019820}, {138,0.00016216}, {139,0.00012613}, {140,0.00021622}, {141,0.00036937}, {142,0.00029730}, {143,0.00018018}, {144,0.00022523}, {145,0.00024324}, {146,0.00029730}, {147,0.00021622}, {148,0.00040541}, {149,0.00031532}, {150,0.00024324}, {151,0.00026126}, {152,0.00027027}, {153,0.00022523}, {154,0.00015315}, {155,0.00017117}, {156,0.00045045}, {157,0.00018919}, {158,0.00021622}, {159,0.00029730}, {160,0.00022523}, {161,0.00034234}, {162,0.00036937}, {163,0.00038739}, {164,0.00020721}, {165,0.00019820}, {166,0.00022523}, {167,0.00033333}, {168,0.00039640}, {169,0.00018018}, {170,0.00019820}, {171,0.00030631}, {172,0.00030631}, {173,0.00027027}, {174,0.00042342}, {175,0.00025225}, {176,0.00028829}, {177,0.00032432}, {178,0.00024324}, {179,0.00037838}, {180,0.00045946}, {181,0.00043243}, {182,0.00032432}, {183,0.00020721}, {184,0.00020721}, {185,0.00035135}, {186,0.00043243}, {187,0.00036937}, {188,0.00044144}, {189,0.00026126}, {190,0.00034234}, {191,0.00045045}, {192,0.00041441}, {193,0.00047748}, {194,0.00017117}, {195,0.00036036}, {196,0.00036937}, {197,0.00040541}, {198,0.00038739}, {199,0.00025225}, {200,0.00033333}, {201,0.00030631}, {202,0.00021622}, {203,0.00039640}, {204,0.00036036}, {205,0.00034234}, {206,0.00048649}, {207,0.00044144}, {208,0.00038739}, {209,0.00038739}, {210,0.00034234}, {211,0.00033333}, {212,0.00036036}, {213,0.00039640}, {214,0.00028829}, {215,0.00046847}, {216,0.00025225}, {217,0.00028829}, {218,0.00040541}, {219,0.00041441}, {220,0.00045045}, {221,0.00036036}, {222,0.00029730}, {223,0.00027928}, {224,0.00034234}, {225,0.00043243}, {226,0.00046847}, {227,0.00040541}, {228,0.00039640}, {229,0.00055856}, {230,0.00034234}, {231,0.00029730}, {232,0.00032432}, {233,0.00037838}, {234,0.00041441}, {235,0.00040541}, {236,0.00046847}, {237,0.00061261}, {238,0.00050450}, {239,0.00035135}, {240,0.00037838}, {241,0.00055856}, {242,0.00054955}, {243,0.00036036}, {244,0.00038739}, {245,0.00032432}, {246,0.00046847}, {247,0.00060360}, {248,0.00050450}, {249,0.00065766}, {250,0.00050450}, {251,0.00041441}, {252,0.00059459}, {253,0.00048649}, {254,0.00037838}, {255,0.00031532}, {256,0.00030631}, {257,0.00035135}, {258,0.00030631}, {259,0.00042342}, {260,0.00054955}, {261,0.00178378}, {262,0.00041441}, {263,0.00192793}, {264,0.00038739}, {265,0.00156757}, {266,0.00058559}, {267,0.00044144}, {268,0.00051351}, {269,0.00031532}, {270,0.00064865}, {271,0.00054955}, {272,0.00030631}, {273,0.00039640}, {274,0.00048649}, {275,0.00047748}, {276,0.00027027}, {277,0.00047748}, {278,0.00030631}, {279,0.00045946}, {280,0.00057658}, {281,0.00029730}, {282,0.00033333}, {283,0.00067568}, {284,0.00036937}, {285,0.00041441}, {286,0.00036937}, {287,0.00058559}, {288,0.00032432}, {289,0.00054054}, {290,0.00063063}, {291,0.00062162}, {292,0.00057658}, {293,0.00062162}, {294,0.00039640}, {295,0.00045045}, {296,0.00044144}, {297,0.00054955}, {298,0.00048649}, {299,0.00055856}, {300,0.00050450}, {301,0.00041441}, {302,0.00053153}, {303,0.00046847}, {304,0.00014414}, {305,0.00063964}, {306,0.00037838}, {307,0.00061261}, {308,0.00030631}, {309,0.00059459}, {310,0.00071171}, {311,0.00036937}, {312,0.00044144}, {313,0.00054054}, {314,0.00046847}, {315,0.00054955}, {316,0.00053153}, {317,0.00075676}, {318,0.00044144}, {319,0.00042342}, {320,0.00054054}, {321,0.00065766}, {322,0.00076577}, {323,0.00054955}, {324,0.00054054}, {325,0.00041441}, {326,0.00052252}, {327,0.00059459}, {328,0.00075676}, {329,0.00055856}, {330,0.00037838}, {331,0.00039640}, {332,0.00058559}, {333,0.00054955}, {334,0.00051351}, {335,0.00064865}, {336,0.00046847}, {337,0.00064865}, {338,0.00077477}, {339,0.00048649}, {340,0.00050450}, {341,0.00059459}, {342,0.00065766}, {343,0.00050450}, {344,0.00070270}, {345,0.00060360}, {346,0.00065766}, {347,0.00091892}, {348,0.00085586}, {349,0.00067568}, {350,0.00044144}, {351,0.00090991}, {352,0.00039640}, {353,0.00032432}, {354,0.00059459}, {355,0.00071171}, {356,0.00046847}, {357,0.00064865}, {358,0.00093694}, {359,0.00061261}, {360,0.00068468}, {361,0.00100901}, {362,0.00053153}, {363,0.00081081}, {364,0.00073874}, {365,0.00079279}, {366,0.00059459}, {367,0.00072072}, {368,0.00076577}, {369,0.00069369}, {370,0.00052252}, {371,0.00061261}, {372,0.00049550}, {373,0.00063063}, {374,0.00074775}, {375,0.00058559}, {376,0.00090991}, {377,0.00046847}, {378,0.00054054}, {379,0.00070270}, {380,0.00054054}, {381,0.00046847}, {382,0.00094595}, {383,0.00045045}, {384,0.00064865}, {385,0.00066667}, {386,0.00072973}, {387,0.00068468}, {388,0.00058559}, {389,0.00078378}, {390,0.00064865}, {391,0.00079279}, {392,0.00081081}, {393,0.00081982}, {394,0.00104505}, {395,0.00076577}, {396,0.00095495}, {397,0.00085586}, {398,0.00083784}, {399,0.00085586}, {400,0.00059459}, {401,0.00075676}, {402,0.00080180}, {403,0.00075676}, {404,0.00068468}, {405,0.00067568}, {406,0.00079279}, {407,0.00071171}, {408,0.00087387}, {409,0.00093694}, {410,0.00063964}, {411,0.00081982}, {412,0.00079279}, {413,0.00044144}, {414,0.00079279}, {415,0.00056757}, {416,0.00066667}, {417,0.00067568}, {418,0.00059459}, {419,0.00070270}, {420,0.00079279}, {421,0.00048649}, {422,0.00083784}, {423,0.00070270}, {424,0.00087387}, {425,0.00369369}, {426,0.00075676}, {427,0.00062162}, {428,0.00066667}, {429,0.00084685}, {430,0.00384685}, {431,0.00081982}, {432,0.00088288}, {433,0.00095495}, {434,0.00103604}, {435,0.00081982}, {436,0.00080180}, {437,0.00072973}, {438,0.00082883}, {439,0.00038739}, {440,0.00090090}, {441,0.00096396}, {442,0.00086486}, {443,0.00070270}, {444,0.00070270}, {445,0.00094595}, {446,0.00065766}, {447,0.00106306}, {448,0.00076577}, {449,0.00081982}, {450,0.00066667}, {451,0.00063964}, {452,0.00089189}, {453,0.00071171}, {454,0.00086486}, {455,0.00104505}, {456,0.00093694}, {457,0.00086486}, {458,0.00076577}, {459,0.00106306}, {460,0.00099099}, {461,0.00064865}, {462,0.00072072}, {463,0.00063964}, {464,0.00072973}, {465,0.00089189}, {466,0.00086486}, {467,0.00100000}, {468,0.00068468}, {469,0.00078378}, {470,0.00099099}, {471,0.00102703}, {472,0.00070270}, {473,0.00099099}, {474,0.00081982}, {475,0.00087387}, {476,0.00084685}, {477,0.00125225}, {478,0.00103604}, {479,0.00091892}, {480,0.00083784}, {481,0.00098198}, {482,0.00075676}, {483,0.00100901}, {484,0.00090090}, {485,0.00098198}, {486,0.00089189}, {487,0.00081982}, {488,0.00081982}, {489,0.00094595}, {490,0.00098198}, {491,0.00070270}, {492,0.00098198}, {493,0.00100901}, {494,0.00084685}, {495,0.00097297}, {496,0.00080180}, {497,0.00081081}, {498,0.00081982}, {499,0.00107207}, {500,0.00093694}, {505,0.00096396}, {510,0.00096396}, {515,0.00109910}, {520,0.00110811}, {525,0.00113514}, {530,0.00078378}, {535,0.00079279}, {540,0.00081081}, {545,0.00124324}, {550,0.00111712}, {555,0.00086486}, {560,0.00140541}, {565,0.00127928}, {570,0.00118919}, {575,0.00109910}, {580,0.00097297}, {585,0.00108108}, {590,0.00083784}, {595,0.00090090}, {600,0.00101802}, {605,0.00081982}, {610,0.00100901}, {615,0.00119820}, {620,0.00108108}, {625,0.00107207}, {630,0.00461261}, {635,0.00113514}, {640,0.00086486}, {645,0.00127027}, {650,0.00098198}, {655,0.00091892}, {660,0.00098198}, {665,0.00091892}, {670,0.00111712}, {675,0.00130631}, {680,0.00105405}, {685,0.00117117}, {690,0.00138739}, {695,0.00103604}, {700,0.00108108}, {705,0.00125225}, {710,0.00139640}, {715,0.00093694}, {720,0.00118018}, {725,0.00109009}, {730,0.00128829}, {735,0.00127027}, {740,0.00102703}, {745,0.00101802}, {750,0.00167568}, {755,0.00094595}, {760,0.00126126}, {765,0.00131532}, {770,0.00146847}, {775,0.00139640}, {780,0.00099099}, {785,0.00157658}, {790,0.00615315}, {795,0.00132432}, {800,0.00128829}, {805,0.00145946}, {810,0.00129730}, {815,0.00141441}, {820,0.00141441}, {825,0.00149550}, {830,0.00135135}, {835,0.00159459}, {840,0.00143243}, {845,0.00139640}, {850,0.00139640}, {855,0.00139640}, {860,0.00143243}, {865,0.00109910}, {870,0.00133333}, {875,0.00131532}, {880,0.00142342}, {885,0.00138739}, {890,0.00140541}, {895,0.00151351}, {900,0.00127027}, {905,0.00148649}, {910,0.00169369}, {915,0.00111712}, {920,0.00143243}, {925,0.00130631}, {930,0.00152252}, {935,0.00157658}, {940,0.00163964}, {945,0.00161261}, {950,0.00130631}, {955,0.00161261}, {960,0.00150450}, {965,0.00149550}, {970,0.00137838}, {975,0.00130631}, {980,0.00166667}, {985,0.00154054}, {990,0.00165766}, {995,0.00154955}, {1000,0.00174775}, {1010,0.00155856}, {1020,0.00172973}, {1030,0.00179279}, {1040,0.00160360}, {1050,0.00192793}, {1060,0.00176577}, {1070,0.00175676}, {1080,0.00201802}, {1090,0.00178378}, {1100,0.00150450}, {1110,0.00195495}, {1120,0.00176577}, {1130,0.00169369}, {1140,0.00190090}, {1150,0.00204505}, {1160,0.00876577}, {1170,0.00199099}, {1180,0.00162162}, {1190,0.00190090}, {1200,0.00182883}, {1210,0.00215315}, {1220,0.00202703}, {1230,0.00180180}, {1240,0.00203604}, {1250,0.00237838}, {1260,0.00214414}, {1270,0.00192793}, {1280,0.00222523}, {1290,0.00205405}, {1300,0.00200901}, {1310,0.00226126}, {1320,0.00224324}, {1330,0.00216216}, {1340,0.00218018}, {1350,0.00232432}, {1360,0.00217117}, {1370,0.00238739}, {1380,0.00200000}, {1390,0.00216216}, {1400,0.00218018}, {1410,0.00246847}, {1420,0.00225225}, {1430,0.00229730}, {1440,0.00228829}, {1450,0.00216216}, {1460,0.00214414}, {1470,0.00259459}, {1480,0.00227027}, {1490,0.00222523}, {1500,0.00238739}, {1510,0.00254955}, {1520,0.00242342}, {1530,0.00255856}, {1540,0.00235135}, {1550,0.00244144}, {1560,0.00238739}, {1570,0.00257658}, {1580,0.00250450}, {1590,0.00259459}, {1600,0.00254955}, {1610,0.00248649}, {1620,0.00209910}, {1630,0.00200901}, {1640,0.00275676}, {1650,0.00266667}, {1660,0.00262162}, {1670,0.00273874}, {1680,0.00266667}, {1690,0.00244144}, {1700,0.00269369}, {1710,0.00288288}, {1720,0.00283784}, {1730,0.00763964}, {1740,0.00272973}, {1750,0.00280180}, {1760,0.00312613}, {1770,0.00299099}, {1780,0.00317117}, {1790,0.00293694}, {1800,0.00334234}, {1810,0.00318018}, {1820,0.00330631}, {1830,0.00331532}, {1840,0.00836036}, {1850,0.00333333}, {1860,0.00341441}, {1870,0.00300000}, {1880,0.00310811}, {1890,0.00323423}, {1900,0.00335135}, {1910,0.00320721}, {1920,0.00334234}, {1930,0.00335135}, {1940,0.00352252}, {1950,0.00334234}, {1960,0.00363063}, {1970,0.00332432}, {1980,0.00761261}, {1990,0.00339640}, {2000,0.00350450}, {2050,0.00954054}, {2100,0.00384685}, {2150,0.00386486}, {2200,0.00388288}, {2250,0.00401802}, {2300,0.00402703}, {2350,0.00413514}, {2400,0.00425225}, {2450,0.00485586}, {2500,0.00447748}, {2550,0.00427027}, {2600,0.00491892}, {2650,0.00486486}, {2700,0.00472072}, {2750,0.00473874}, {2800,0.00497297}, {2850,0.00528829}, {2900,0.00452252}, {2950,0.00502703}, {3000,0.00546847}, {3050,0.00545045}, {3100,0.00534234}, {3150,0.00553153}, {3200,0.00552252}, {3250,0.00557658}, {3300,0.00554054}, {3350,0.00615315}, {3400,0.00607207}, {3450,0.01010811}, {3500,0.00602703}, {3550,0.00619820}, {3600,0.00639640}, {3650,0.00635135}, {3700,0.00676577}, {3750,0.00649550}, {3800,0.00651351}, {3850,0.00681081}, {3900,0.00681081}, {3950,0.00700901}, {4000,0.00706306}, {4050,0.00727027}, {4100,0.00709009}, {4150,0.00717117}, {4200,0.00707207}, {4250,0.01763063}, {4300,0.00782883}, {4350,0.00764865}, {4400,0.00806306}, {4450,0.00814414}, {4500,0.00794595}, {4550,0.00797297}, {4600,0.00850450}, {4650,0.00816216}, {4700,0.00908108}, {4750,0.00839640}, {4800,0.00826126}, {4850,0.00896396}, {4900,0.00867568}, {4950,0.00893694}, {5000,0.00871171}, {5050,0.00912613}, {5100,0.00973874}, {5150,0.00899099}, {5200,0.00994595}, {5250,0.00936036}, {5300,0.01679279}, {5350,0.01021622}, {5400,0.01013514}, {5450,0.01008108}, {5500,0.01029730}, {5550,0.02557658}, {5600,0.01018018}, {5650,0.01007207}, {5700,0.01072072}, {5750,0.01084685}, {5800,0.01755856}, {5850,0.01127027}, {5900,0.01107207}, {5950,0.01144144}, {6000,0.01131532}, {6050,0.01050}, {6100,0.02000}, {6150,0.01200}, {6200,0.01075}, {6250,0.02575}, {6300,0.01200}, {6350,0.01175}, {6400,0.01175}, {6450,0.01200}, {6500,0.01175}, {6550,0.01200}, {6600,0.01200}, {6650,0.01300}, {6700,0.02100}, {6750,0.01175}, {6800,0.01175}, {6850,0.01300}, {6900,0.02000}, {6950,0.01425}, {7000,0.01200}, {7050,0.01300}, {7100,0.01275}, {7150,0.01375}, {7200,0.02625}, {7250,0.01325}, {7300,0.01275}, {7350,0.02625}, {7400,0.01400}, {7450,0.01275}, {7500,0.02850}, {7550,0.01450}, {7600,0.01300}, {7650,0.03175}, {7700,0.02125}, {7750,0.01475}, {7800,0.01450}, {7850,0.02750}, {7900,0.01475}, {7950,0.01400}, {8000,0.01500}, {8050,0.01400}, {8100,0.01475}, {8150,0.01550}, {8200,0.01425}, {8250,0.01325}, {8300,0.01575}, {8350,0.01575}, {8400,0.01525}, {8450,0.03450}, {8500,0.01575}, {8550,0.01550}, {8600,0.03675}, {8650,0.01500}, {8700,0.01725}, {8750,0.03075}, {8800,0.01575}, {8850,0.01525}, {8900,0.01775}, {8950,0.02025}, {9000,0.01525}, {9050,0.01525}, {9100,0.03050}, {9150,0.03775}, {9200,0.03950}, {9250,0.01675}, {9300,0.01675}, {9350,0.03250}, {9400,0.01725}, {9450,0.01675}, {9500,0.01725}, {9550,0.01725}, {9600,0.01875}, {9650,0.03375}, {9700,0.01825}, {9750,0.01775}, {9800,0.01700}, {9850,0.03600}, {9900,0.01800}, {9950,0.01750}, {10000,0.04050}, {10100,0.01950}, {10200,0.01850}, {10300,0.01950}, {10400,0.01950}, {10500,0.02000}, {10600,0.01950}, {10700,0.02000}, {10800,0.03075}, {10900,0.03675}, {11000,0.02100}, {11100,0.02050}, {11200,0.02175}, {11300,0.04600}, {11400,0.01950}, {11500,0.02075}, {11600,0.02475}, {11700,0.02150}, {11800,0.02250}, {11900,0.02275}, {12000,0.02150}, {12100,0.02075}, {12200,0.05100}, {12300,0.02300}, {12400,0.03275}, {12500,0.04400}, {12600,0.03050}, {12700,0.02400}, {12800,0.05525}, {12900,0.02500}, {13000,0.02400}, {13100,0.02400}, {13200,0.02525}, {13300,0.03975}, {13400,0.02575}, {13500,0.02575}, {13600,0.02500}, {13700,0.02500}, {13800,0.04475}, {13900,0.02375}, {14000,0.02650}, {14100,0.02625}, {14200,0.02475}, {14300,0.06075}, {14400,0.02650}, {14500,0.06250}, {14600,0.02675}, {14700,0.02650}, {14800,0.06375}, {14900,0.02750}, {15000,0.04525}, {15100,0.02825}, {15200,0.02775}, {15300,0.05500}, {15400,0.02950}, {15500,0.02850}, {15600,0.02925}, {15700,0.02850}, {15800,0.03075}, {15900,0.06575}, {16000,0.02925}, {16100,0.06550}, {16200,0.03125}, {16300,0.06700}, {16400,0.05225}, {16500,0.03700}, {16600,0.03050}, {16700,0.03150}, {16800,0.03125}, {16900,0.03075}, {17000,0.03075}, {17100,0.06475}, {17200,0.03250}, {17300,0.03275}, {17400,0.03150}, {17500,0.06725}, {17600,0.03350}, {17700,0.03375}, {17800,0.03400}, {17900,0.03350}, {18000,0.03150}, {18100,0.05550}, {18200,0.03225}, {18300,0.03475}, {18400,0.03475}, {18500,0.03475}, {18600,0.03575}, {18700,0.05250}, {18800,0.03600}, {18900,0.03500}, {19000,0.03600}, {19100,0.07675}, {19200,0.04325}, {19300,0.03800}, {19400,0.03700}, {19500,0.03700}, {19600,0.03600}, {19700,0.07450}, {19800,0.03800}, {19900,0.03700}, {20000,0.0360}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["eval lazy"]["system"] = {{1,0.00007207}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003604}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00003604}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00003604}, {92,0.00003604}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00003604}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00003604}, {131,0.00002703}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00003604}, {146,0.00003604}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00003604}, {184,0.00003604}, {185,0.00000000}, {186,0.00000000}, {187,0.00003604}, {188,0.00000000}, {189,0.00003604}, {190,0.00000000}, {191,0.00003604}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00003604}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00003604}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00003604}, {223,0.00003604}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00003604}, {261,0.00007207}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003604}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00003604}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00002703}, {287,0.00000000}, {288,0.00000000}, {289,0.00003604}, {290,0.00000000}, {291,0.00000000}, {292,0.00003604}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00003604}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00003604}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00003604}, {313,0.00000000}, {314,0.00000000}, {315,0.00003604}, {316,0.00000000}, {317,0.00003604}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00003604}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00003604}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00003604}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00003604}, {358,0.00002703}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00002703}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00003604}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00003604}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00003604}, {417,0.00003604}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00002703}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00007207}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00003604}, {444,0.00003604}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00002703}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00003604}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00007207}, {458,0.00003604}, {459,0.00002703}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00003604}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00003604}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00003604}, {485,0.00000000}, {486,0.00000000}, {487,0.00003604}, {488,0.00003604}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00003604}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00003604}, {550,0.00000000}, {555,0.00003604}, {560,0.00000000}, {565,0.00000000}, {570,0.00003604}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00003604}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00013514}, {635,0.00000000}, {640,0.00000000}, {645,0.00003604}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00003604}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00003604}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00002703}, {785,0.00000000}, {790,0.00010811}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00003604}, {845,0.00003604}, {850,0.00000000}, {855,0.00002703}, {860,0.00003604}, {865,0.00007207}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00003604}, {925,0.00007207}, {930,0.00000000}, {935,0.00000000}, {940,0.00010811}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00002703}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00003604}, {1040,0.00003604}, {1050,0.00003604}, {1060,0.00003604}, {1070,0.00003604}, {1080,0.00003604}, {1090,0.00000000}, {1100,0.00003604}, {1110,0.00003604}, {1120,0.00003604}, {1130,0.00003604}, {1140,0.00003604}, {1150,0.00000000}, {1160,0.00024324}, {1170,0.00000000}, {1180,0.00003604}, {1190,0.00003604}, {1200,0.00003604}, {1210,0.00000000}, {1220,0.00003604}, {1230,0.00010811}, {1240,0.00007207}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003604}, {1290,0.00000000}, {1300,0.00003604}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00003604}, {1340,0.00002703}, {1350,0.00003604}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00003604}, {1410,0.00002703}, {1420,0.00003604}, {1430,0.00000000}, {1440,0.00003604}, {1450,0.00003604}, {1460,0.00000000}, {1470,0.00003604}, {1480,0.00003604}, {1490,0.00000000}, {1500,0.00003604}, {1510,0.00000000}, {1520,0.00003604}, {1530,0.00003604}, {1540,0.00003604}, {1550,0.00007207}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00003604}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00003604}, {1620,0.00000000}, {1630,0.00003604}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003604}, {1670,0.00003604}, {1680,0.00000000}, {1690,0.00003604}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00003604}, {1730,0.00003604}, {1740,0.00003604}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00003604}, {1790,0.00007207}, {1800,0.00000000}, {1810,0.00003604}, {1820,0.00000000}, {1830,0.00003604}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00003604}, {1870,0.00003604}, {1880,0.00003604}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00003604}, {1920,0.00003604}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00007207}, {1960,0.00000000}, {1970,0.00003604}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00003604}, {2200,0.00003604}, {2250,0.00000000}, {2300,0.00003604}, {2350,0.00003604}, {2400,0.00003604}, {2450,0.00000000}, {2500,0.00014414}, {2550,0.00007207}, {2600,0.00000000}, {2650,0.00003604}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00003604}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00002703}, {3050,0.00007207}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00003604}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00003604}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00007207}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00003604}, {3950,0.00003604}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00003604}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00002703}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00003604}, {5250,0.00003604}, {5300,0.00007207}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00010811}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00010811}, {5700,0.00000000}, {5750,0.00003604}, {5800,0.00014414}, {5850,0.00000000}, {5900,0.00007207}, {5950,0.00000000}, {6000,0.00002703}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00100}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00200}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00100}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["intros _"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00004505}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000901}, {2350,0.00000000}, {2400,0.00000901}, {2450,0.00003604}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00005405}, {2650,0.00002703}, {2700,0.00002703}, {2750,0.00003604}, {2800,0.00006306}, {2850,0.00030631}, {2900,0.00000000}, {2950,0.00003604}, {3000,0.00057658}, {3050,0.00019820}, {3100,0.00002703}, {3150,0.00066667}, {3200,0.00061261}, {3250,0.00055856}, {3300,0.00065766}, {3350,0.00074775}, {3400,0.00079279}, {3450,0.00059459}, {3500,0.00069369}, {3550,0.00091892}, {3600,0.00081982}, {3650,0.00072973}, {3700,0.00100000}, {3750,0.00092793}, {3800,0.00094595}, {3850,0.00099099}, {3900,0.00100000}, {3950,0.00100000}, {4000,0.00094595}, {4050,0.00100000}, {4100,0.00100000}, {4150,0.00100000}, {4200,0.00100000}, {4250,0.00100000}, {4300,0.00100000}, {4350,0.00100000}, {4400,0.00100000}, {4450,0.00100000}, {4500,0.00100000}, {4550,0.00100000}, {4600,0.00100000}, {4650,0.00100000}, {4700,0.00100000}, {4750,0.00100000}, {4800,0.00100000}, {4850,0.00100000}, {4900,0.00100000}, {4950,0.00100000}, {5000,0.00100000}, {5050,0.00100000}, {5100,0.00100901}, {5150,0.00100000}, {5200,0.00100000}, {5250,0.00100000}, {5300,0.00100000}, {5350,0.00101802}, {5400,0.00100000}, {5450,0.00100901}, {5500,0.00100000}, {5550,0.00100000}, {5600,0.00100000}, {5650,0.00104505}, {5700,0.00105405}, {5750,0.00114414}, {5800,0.00103604}, {5850,0.00111712}, {5900,0.00113514}, {5950,0.00108108}, {6000,0.00118919}, {6050,0.00100}, {6100,0.00100}, {6150,0.00100}, {6200,0.00100}, {6250,0.00125}, {6300,0.00100}, {6350,0.00100}, {6400,0.00150}, {6450,0.00125}, {6500,0.00100}, {6550,0.00100}, {6600,0.00125}, {6650,0.00125}, {6700,0.00125}, {6750,0.00125}, {6800,0.00150}, {6850,0.00150}, {6900,0.00150}, {6950,0.00150}, {7000,0.00150}, {7050,0.00150}, {7100,0.00150}, {7150,0.00175}, {7200,0.00175}, {7250,0.00175}, {7300,0.00200}, {7350,0.00175}, {7400,0.00200}, {7450,0.00175}, {7500,0.00175}, {7550,0.00200}, {7600,0.00200}, {7650,0.00200}, {7700,0.00175}, {7750,0.00200}, {7800,0.00200}, {7850,0.00200}, {7900,0.00200}, {7950,0.00200}, {8000,0.00200}, {8050,0.00200}, {8100,0.00200}, {8150,0.00200}, {8200,0.00200}, {8250,0.00200}, {8300,0.00200}, {8350,0.00200}, {8400,0.00200}, {8450,0.00200}, {8500,0.00200}, {8550,0.00200}, {8600,0.00200}, {8650,0.00200}, {8700,0.00200}, {8750,0.00200}, {8800,0.00200}, {8850,0.00200}, {8900,0.00225}, {8950,0.00225}, {9000,0.00225}, {9050,0.00225}, {9100,0.00225}, {9150,0.00200}, {9200,0.00200}, {9250,0.00225}, {9300,0.00225}, {9350,0.00200}, {9400,0.00225}, {9450,0.00225}, {9500,0.00200}, {9550,0.00250}, {9600,0.00225}, {9650,0.00225}, {9700,0.00700}, {9750,0.00225}, {9800,0.00275}, {9850,0.00250}, {9900,0.00250}, {9950,0.00275}, {10000,0.00300}, {10100,0.00300}, {10200,0.00300}, {10300,0.00300}, {10400,0.00300}, {10500,0.00300}, {10600,0.00300}, {10700,0.00300}, {10800,0.00300}, {10900,0.00300}, {11000,0.00300}, {11100,0.00300}, {11200,0.00300}, {11300,0.00300}, {11400,0.00300}, {11500,0.00350}, {11600,0.00300}, {11700,0.00300}, {11800,0.00325}, {11900,0.00375}, {12000,0.00350}, {12100,0.00325}, {12200,0.00325}, {12300,0.00375}, {12400,0.00325}, {12500,0.00325}, {12600,0.00325}, {12700,0.00350}, {12800,0.00400}, {12900,0.00400}, {13000,0.00400}, {13100,0.00400}, {13200,0.00400}, {13300,0.00400}, {13400,0.00400}, {13500,0.00400}, {13600,0.00400}, {13700,0.00400}, {13800,0.00400}, {13900,0.00450}, {14000,0.00400}, {14100,0.00400}, {14200,0.00400}, {14300,0.00425}, {14400,0.00400}, {14500,0.00400}, {14600,0.00400}, {14700,0.00400}, {14800,0.00500}, {14900,0.00475}, {15000,0.01075}, {15100,0.00475}, {15200,0.00450}, {15300,0.00475}, {15400,0.00475}, {15500,0.00475}, {15600,0.00500}, {15700,0.00500}, {15800,0.00500}, {15900,0.00450}, {16000,0.00525}, {16100,0.00500}, {16200,0.00500}, {16300,0.00500}, {16400,0.00500}, {16500,0.00500}, {16600,0.00525}, {16700,0.00500}, {16800,0.00500}, {16900,0.00500}, {17000,0.00500}, {17100,0.00500}, {17200,0.00500}, {17300,0.00525}, {17400,0.00525}, {17500,0.00525}, {17600,0.00600}, {17700,0.00575}, {17800,0.00625}, {17900,0.00550}, {18000,0.00600}, {18100,0.00550}, {18200,0.00575}, {18300,0.00600}, {18400,0.00600}, {18500,0.00600}, {18600,0.00600}, {18700,0.00600}, {18800,0.00600}, {18900,0.00625}, {19000,0.00600}, {19100,0.00600}, {19200,0.00600}, {19300,0.00675}, {19400,0.00600}, {19500,0.00600}, {19600,0.00600}, {19700,0.00600}, {19800,0.00600}, {19900,0.00700}, {20000,0.0060}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["intros _"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003604}, {4,0.00000000}, {5,0.00003604}, {6,0.00006306}, {7,0.00002703}, {8,0.00000000}, {9,0.00005405}, {10,0.00000000}, {11,0.00000000}, {12,0.00006306}, {13,0.00002703}, {14,0.00000000}, {15,0.00000000}, {16,0.00006306}, {17,0.00000000}, {18,0.00000000}, {19,0.00002703}, {20,0.00005405}, {21,0.00003604}, {22,0.00005405}, {23,0.00000000}, {24,0.00002703}, {25,0.00003604}, {26,0.00006306}, {27,0.00009009}, {28,0.00002703}, {29,0.00003604}, {30,0.00003604}, {31,0.00002703}, {32,0.00000000}, {33,0.00006306}, {34,0.00003604}, {35,0.00000000}, {36,0.00002703}, {37,0.00002703}, {38,0.00018919}, {39,0.00002703}, {40,0.00006306}, {41,0.00003604}, {42,0.00002703}, {43,0.00005405}, {44,0.00000000}, {45,0.00009009}, {46,0.00003604}, {47,0.00006306}, {48,0.00003604}, {49,0.00010811}, {50,0.00002703}, {51,0.00003604}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00003604}, {56,0.00009910}, {57,0.00003604}, {58,0.00011712}, {59,0.00006306}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00009910}, {65,0.00003604}, {66,0.00000000}, {67,0.00009910}, {68,0.00009009}, {69,0.00005405}, {70,0.00000000}, {71,0.00000000}, {72,0.00009009}, {73,0.00006306}, {74,0.00002703}, {75,0.00000000}, {76,0.00002703}, {77,0.00002703}, {78,0.00000000}, {79,0.00009009}, {80,0.00000000}, {81,0.00009910}, {82,0.00006306}, {83,0.00000000}, {84,0.00007207}, {85,0.00003604}, {86,0.00006306}, {87,0.00000000}, {88,0.00009910}, {89,0.00003604}, {90,0.00005405}, {91,0.00002703}, {92,0.00009009}, {93,0.00003604}, {94,0.00000000}, {95,0.00002703}, {96,0.00007207}, {97,0.00003604}, {98,0.00002703}, {99,0.00009009}, {100,0.00007207}, {101,0.00005405}, {102,0.00018919}, {103,0.00003604}, {104,0.00000000}, {105,0.00007207}, {106,0.00005405}, {107,0.00000000}, {108,0.00007207}, {109,0.00009910}, {110,0.00003604}, {111,0.00007207}, {112,0.00003604}, {113,0.00003604}, {114,0.00007207}, {115,0.00010811}, {116,0.00012613}, {117,0.00012613}, {118,0.00010811}, {119,0.00005405}, {120,0.00003604}, {121,0.00002703}, {122,0.00006306}, {123,0.00003604}, {124,0.00000000}, {125,0.00003604}, {126,0.00009910}, {127,0.00010811}, {128,0.00009910}, {129,0.00005405}, {130,0.00005405}, {131,0.00006306}, {132,0.00002703}, {133,0.00006306}, {134,0.00003604}, {135,0.00006306}, {136,0.00006306}, {137,0.00000000}, {138,0.00010811}, {139,0.00002703}, {140,0.00009910}, {141,0.00017117}, {142,0.00013514}, {143,0.00003604}, {144,0.00006306}, {145,0.00003604}, {146,0.00006306}, {147,0.00008108}, {148,0.00009009}, {149,0.00012613}, {150,0.00002703}, {151,0.00000000}, {152,0.00006306}, {153,0.00015315}, {154,0.00003604}, {155,0.00006306}, {156,0.00010811}, {157,0.00000000}, {158,0.00006306}, {159,0.00009009}, {160,0.00000000}, {161,0.00002703}, {162,0.00006306}, {163,0.00006306}, {164,0.00002703}, {165,0.00003604}, {166,0.00000000}, {167,0.00015315}, {168,0.00012613}, {169,0.00011712}, {170,0.00009009}, {171,0.00023423}, {172,0.00003604}, {173,0.00009009}, {174,0.00013514}, {175,0.00000000}, {176,0.00005405}, {177,0.00005405}, {178,0.00002703}, {179,0.00006306}, {180,0.00002703}, {181,0.00011712}, {182,0.00010811}, {183,0.00005405}, {184,0.00005405}, {185,0.00006306}, {186,0.00014414}, {187,0.00002703}, {188,0.00014414}, {189,0.00006306}, {190,0.00005405}, {191,0.00002703}, {192,0.00000000}, {193,0.00008108}, {194,0.00002703}, {195,0.00002703}, {196,0.00008108}, {197,0.00002703}, {198,0.00010811}, {199,0.00009009}, {200,0.00009009}, {201,0.00000000}, {202,0.00012613}, {203,0.00003604}, {204,0.00002703}, {205,0.00005405}, {206,0.00002703}, {207,0.00013514}, {208,0.00008108}, {209,0.00005405}, {210,0.00006306}, {211,0.00013514}, {212,0.00011712}, {213,0.00007207}, {214,0.00000000}, {215,0.00019820}, {216,0.00008108}, {217,0.00002703}, {218,0.00003604}, {219,0.00000000}, {220,0.00005405}, {221,0.00009910}, {222,0.00008108}, {223,0.00006306}, {224,0.00002703}, {225,0.00011712}, {226,0.00002703}, {227,0.00009009}, {228,0.00012613}, {229,0.00003604}, {230,0.00012613}, {231,0.00017117}, {232,0.00011712}, {233,0.00012613}, {234,0.00005405}, {235,0.00007207}, {236,0.00006306}, {237,0.00006306}, {238,0.00005405}, {239,0.00005405}, {240,0.00018919}, {241,0.00008108}, {242,0.00006306}, {243,0.00000000}, {244,0.00011712}, {245,0.00012613}, {246,0.00014414}, {247,0.00005405}, {248,0.00002703}, {249,0.00002703}, {250,0.00014414}, {251,0.00009009}, {252,0.00002703}, {253,0.00002703}, {254,0.00005405}, {255,0.00009009}, {256,0.00013514}, {257,0.00008108}, {258,0.00010811}, {259,0.00016216}, {260,0.00000000}, {261,0.00005405}, {262,0.00010811}, {263,0.00009910}, {264,0.00015315}, {265,0.00009009}, {266,0.00013514}, {267,0.00009009}, {268,0.00009009}, {269,0.00002703}, {270,0.00012613}, {271,0.00011712}, {272,0.00006306}, {273,0.00002703}, {274,0.00009009}, {275,0.00002703}, {276,0.00016216}, {277,0.00005405}, {278,0.00014414}, {279,0.00002703}, {280,0.00015315}, {281,0.00008108}, {282,0.00005405}, {283,0.00008108}, {284,0.00009009}, {285,0.00012613}, {286,0.00011712}, {287,0.00002703}, {288,0.00005405}, {289,0.00010811}, {290,0.00005405}, {291,0.00006306}, {292,0.00008108}, {293,0.00008108}, {294,0.00018018}, {295,0.00015315}, {296,0.00005405}, {297,0.00009009}, {298,0.00006306}, {299,0.00002703}, {300,0.00010811}, {301,0.00015315}, {302,0.00012613}, {303,0.00010811}, {304,0.00010811}, {305,0.00010811}, {306,0.00008108}, {307,0.00014414}, {308,0.00029730}, {309,0.00010811}, {310,0.00015315}, {311,0.00006306}, {312,0.00010811}, {313,0.00006306}, {314,0.00016216}, {315,0.00014414}, {316,0.00010811}, {317,0.00018018}, {318,0.00006306}, {319,0.00017117}, {320,0.00017117}, {321,0.00002703}, {322,0.00009009}, {323,0.00011712}, {324,0.00013514}, {325,0.00011712}, {326,0.00008108}, {327,0.00013514}, {328,0.00009009}, {329,0.00002703}, {330,0.00005405}, {331,0.00018018}, {332,0.00012613}, {333,0.00019820}, {334,0.00014414}, {335,0.00009009}, {336,0.00014414}, {337,0.00009910}, {338,0.00017117}, {339,0.00010811}, {340,0.00020721}, {341,0.00027027}, {342,0.00009910}, {343,0.00010811}, {344,0.00012613}, {345,0.00007207}, {346,0.00018919}, {347,0.00009009}, {348,0.00007207}, {349,0.00006306}, {350,0.00007207}, {351,0.00003604}, {352,0.00002703}, {353,0.00018919}, {354,0.00003604}, {355,0.00017117}, {356,0.00025225}, {357,0.00006306}, {358,0.00013514}, {359,0.00028829}, {360,0.00013514}, {361,0.00009009}, {362,0.00020721}, {363,0.00012613}, {364,0.00002703}, {365,0.00009910}, {366,0.00025225}, {367,0.00007207}, {368,0.00003604}, {369,0.00021622}, {370,0.00016216}, {371,0.00003604}, {372,0.00023423}, {373,0.00006306}, {374,0.00007207}, {375,0.00012613}, {376,0.00003604}, {377,0.00018919}, {378,0.00024324}, {379,0.00018919}, {380,0.00012613}, {381,0.00023423}, {382,0.00014414}, {383,0.00017117}, {384,0.00020721}, {385,0.00003604}, {386,0.00022523}, {387,0.00009910}, {388,0.00009910}, {389,0.00017117}, {390,0.00009009}, {391,0.00013514}, {392,0.00000000}, {393,0.00030631}, {394,0.00008108}, {395,0.00010811}, {396,0.00006306}, {397,0.00020721}, {398,0.00017117}, {399,0.00008108}, {400,0.00027928}, {401,0.00017117}, {402,0.00006306}, {403,0.00013514}, {404,0.00023423}, {405,0.00015315}, {406,0.00007207}, {407,0.00009910}, {408,0.00027928}, {409,0.00006306}, {410,0.00003604}, {411,0.00005405}, {412,0.00018018}, {413,0.00033333}, {414,0.00007207}, {415,0.00013514}, {416,0.00020721}, {417,0.00035135}, {418,0.00034234}, {419,0.00015315}, {420,0.00007207}, {421,0.00027027}, {422,0.00019820}, {423,0.00022523}, {424,0.00014414}, {425,0.00002703}, {426,0.00020721}, {427,0.00014414}, {428,0.00024324}, {429,0.00003604}, {430,0.00007207}, {431,0.00017117}, {432,0.00016216}, {433,0.00016216}, {434,0.00020721}, {435,0.00010811}, {436,0.00007207}, {437,0.00014414}, {438,0.00018018}, {439,0.00016216}, {440,0.00013514}, {441,0.00016216}, {442,0.00022523}, {443,0.00015315}, {444,0.00025225}, {445,0.00007207}, {446,0.00013514}, {447,0.00024324}, {448,0.00012613}, {449,0.00010811}, {450,0.00013514}, {451,0.00009009}, {452,0.00012613}, {453,0.00030631}, {454,0.00007207}, {455,0.00016216}, {456,0.00016216}, {457,0.00013514}, {458,0.00009910}, {459,0.00003604}, {460,0.00008108}, {461,0.00019820}, {462,0.00019820}, {463,0.00035135}, {464,0.00012613}, {465,0.00020721}, {466,0.00017117}, {467,0.00016216}, {468,0.00019820}, {469,0.00014414}, {470,0.00009910}, {471,0.00031532}, {472,0.00010811}, {473,0.00006306}, {474,0.00008108}, {475,0.00007207}, {476,0.00012613}, {477,0.00018018}, {478,0.00015315}, {479,0.00014414}, {480,0.00012613}, {481,0.00019820}, {482,0.00011712}, {483,0.00007207}, {484,0.00000000}, {485,0.00014414}, {486,0.00009910}, {487,0.00013514}, {488,0.00014414}, {489,0.00012613}, {490,0.00017117}, {491,0.00009910}, {492,0.00009910}, {493,0.00013514}, {494,0.00015315}, {495,0.00010811}, {496,0.00015315}, {497,0.00007207}, {498,0.00018018}, {499,0.00013514}, {500,0.00026126}, {505,0.00010811}, {510,0.00030631}, {515,0.00016216}, {520,0.00016216}, {525,0.00009910}, {530,0.00022523}, {535,0.00026126}, {540,0.00034234}, {545,0.00027928}, {550,0.00036036}, {555,0.00021622}, {560,0.00013514}, {565,0.00019820}, {570,0.00016216}, {575,0.00024324}, {580,0.00020721}, {585,0.00027027}, {590,0.00021622}, {595,0.00018018}, {600,0.00017117}, {605,0.00018018}, {610,0.00010811}, {615,0.00027928}, {620,0.00009009}, {625,0.00030631}, {630,0.00014414}, {635,0.00015315}, {640,0.00024324}, {645,0.00009910}, {650,0.00015315}, {655,0.00018018}, {660,0.00018919}, {665,0.00014414}, {670,0.00029730}, {675,0.00010811}, {680,0.00030631}, {685,0.00023423}, {690,0.00023423}, {695,0.00021622}, {700,0.00035135}, {705,0.00019820}, {710,0.00027928}, {715,0.00032432}, {720,0.00034234}, {725,0.00030631}, {730,0.00005405}, {735,0.00009910}, {740,0.00039640}, {745,0.00023423}, {750,0.00027027}, {755,0.00011712}, {760,0.00010811}, {765,0.00011712}, {770,0.00022523}, {775,0.00051351}, {780,0.00036036}, {785,0.00018919}, {790,0.00034234}, {795,0.00036937}, {800,0.00045946}, {805,0.00014414}, {810,0.00017117}, {815,0.00021622}, {820,0.00037838}, {825,0.00036937}, {830,0.00044144}, {835,0.00025225}, {840,0.00019820}, {845,0.00029730}, {850,0.00020721}, {855,0.00056757}, {860,0.00039640}, {865,0.00027928}, {870,0.00037838}, {875,0.00023423}, {880,0.00042342}, {885,0.00029730}, {890,0.00030631}, {895,0.00034234}, {900,0.00036036}, {905,0.00031532}, {910,0.00018919}, {915,0.00024324}, {920,0.00049550}, {925,0.00024324}, {930,0.00021622}, {935,0.00037838}, {940,0.00040541}, {945,0.00026126}, {950,0.00032432}, {955,0.00034234}, {960,0.00042342}, {965,0.00048649}, {970,0.00020721}, {975,0.00008108}, {980,0.00035135}, {985,0.00032432}, {990,0.00026126}, {995,0.00019820}, {1000,0.00036937}, {1010,0.00031532}, {1020,0.00054054}, {1030,0.00025225}, {1040,0.00043243}, {1050,0.00031532}, {1060,0.00036937}, {1070,0.00023423}, {1080,0.00042342}, {1090,0.00037838}, {1100,0.00043243}, {1110,0.00036036}, {1120,0.00036036}, {1130,0.00032432}, {1140,0.00022523}, {1150,0.00038739}, {1160,0.00010811}, {1170,0.00023423}, {1180,0.00023423}, {1190,0.00023423}, {1200,0.00039640}, {1210,0.00020721}, {1220,0.00030631}, {1230,0.00060360}, {1240,0.00051351}, {1250,0.00027928}, {1260,0.00029730}, {1270,0.00053153}, {1280,0.00042342}, {1290,0.00026126}, {1300,0.00058559}, {1310,0.00044144}, {1320,0.00014414}, {1330,0.00043243}, {1340,0.00028829}, {1350,0.00045045}, {1360,0.00035135}, {1370,0.00045946}, {1380,0.00026126}, {1390,0.00063063}, {1400,0.00041441}, {1410,0.00043243}, {1420,0.00050450}, {1430,0.00030631}, {1440,0.00049550}, {1450,0.00045946}, {1460,0.00063964}, {1470,0.00036036}, {1480,0.00041441}, {1490,0.00035135}, {1500,0.00053153}, {1510,0.00040541}, {1520,0.00032432}, {1530,0.00020721}, {1540,0.00043243}, {1550,0.00053153}, {1560,0.00062162}, {1570,0.00042342}, {1580,0.00044144}, {1590,0.00024324}, {1600,0.00030631}, {1610,0.00043243}, {1620,0.00060360}, {1630,0.00070270}, {1640,0.00025225}, {1650,0.00040541}, {1660,0.00030631}, {1670,0.00033333}, {1680,0.00040541}, {1690,0.00079279}, {1700,0.00049550}, {1710,0.00054054}, {1720,0.00056757}, {1730,0.00037838}, {1740,0.00040541}, {1750,0.00054054}, {1760,0.00054054}, {1770,0.00047748}, {1780,0.00034234}, {1790,0.00066667}, {1800,0.00045946}, {1810,0.00065766}, {1820,0.00028829}, {1830,0.00026126}, {1840,0.00085586}, {1850,0.00050450}, {1860,0.00056757}, {1870,0.00071171}, {1880,0.00079279}, {1890,0.00037838}, {1900,0.00036036}, {1910,0.00061261}, {1920,0.00069369}, {1930,0.00042342}, {1940,0.00038739}, {1950,0.00026126}, {1960,0.00080180}, {1970,0.00058559}, {1980,0.00036036}, {1990,0.00079279}, {2000,0.00049550}, {2050,0.00044144}, {2100,0.00071171}, {2150,0.00067568}, {2200,0.00058559}, {2250,0.00070270}, {2300,0.00047748}, {2350,0.00031532}, {2400,0.00089189}, {2450,0.00044144}, {2500,0.00058559}, {2550,0.00062162}, {2600,0.00081081}, {2650,0.00079279}, {2700,0.00067568}, {2750,0.00105405}, {2800,0.00100000}, {2850,0.00065766}, {2900,0.00081982}, {2950,0.00071171}, {3000,0.00084685}, {3050,0.00056757}, {3100,0.00103604}, {3150,0.00109910}, {3200,0.00069369}, {3250,0.00103604}, {3300,0.00107207}, {3350,0.00064865}, {3400,0.00099099}, {3450,0.00095495}, {3500,0.00087387}, {3550,0.00102703}, {3600,0.00094595}, {3650,0.00087387}, {3700,0.00095495}, {3750,0.00104505}, {3800,0.00108108}, {3850,0.00128829}, {3900,0.00144144}, {3950,0.00117117}, {4000,0.00098198}, {4050,0.00082883}, {4100,0.00116216}, {4150,0.00110811}, {4200,0.00141441}, {4250,0.00112613}, {4300,0.00085586}, {4350,0.00123423}, {4400,0.00127027}, {4450,0.00141441}, {4500,0.00097297}, {4550,0.00125225}, {4600,0.00115315}, {4650,0.00128829}, {4700,0.00129730}, {4750,0.00158559}, {4800,0.00131532}, {4850,0.00102703}, {4900,0.00136036}, {4950,0.00127027}, {5000,0.00155856}, {5050,0.00130631}, {5100,0.00139640}, {5150,0.00167568}, {5200,0.00123423}, {5250,0.00160360}, {5300,0.00120721}, {5350,0.00122523}, {5400,0.00141441}, {5450,0.00135135}, {5500,0.00145045}, {5550,0.00154054}, {5600,0.00141441}, {5650,0.00145946}, {5700,0.00158559}, {5750,0.00139640}, {5800,0.00142342}, {5850,0.00150450}, {5900,0.00153153}, {5950,0.00133333}, {6000,0.00118018}, {6050,0.00150}, {6100,0.00250}, {6150,0.00075}, {6200,0.00100}, {6250,0.00100}, {6300,0.00100}, {6350,0.00000}, {6400,0.00100}, {6450,0.00250}, {6500,0.00225}, {6550,0.00075}, {6600,0.00150}, {6650,0.00200}, {6700,0.00275}, {6750,0.00175}, {6800,0.00100}, {6850,0.00250}, {6900,0.00100}, {6950,0.00000}, {7000,0.00175}, {7050,0.00225}, {7100,0.00075}, {7150,0.00075}, {7200,0.00200}, {7250,0.00175}, {7300,0.00225}, {7350,0.00075}, {7400,0.00175}, {7450,0.00250}, {7500,0.00375}, {7550,0.00175}, {7600,0.00275}, {7650,0.00325}, {7700,0.00300}, {7750,0.00175}, {7800,0.00175}, {7850,0.00275}, {7900,0.00175}, {7950,0.00175}, {8000,0.00275}, {8050,0.00200}, {8100,0.00200}, {8150,0.00175}, {8200,0.00300}, {8250,0.00175}, {8300,0.00175}, {8350,0.00175}, {8400,0.00100}, {8450,0.00250}, {8500,0.00275}, {8550,0.00175}, {8600,0.00175}, {8650,0.00100}, {8700,0.00075}, {8750,0.00175}, {8800,0.00250}, {8850,0.00375}, {8900,0.00150}, {8950,0.00200}, {9000,0.00400}, {9050,0.00300}, {9100,0.00200}, {9150,0.00350}, {9200,0.00300}, {9250,0.00275}, {9300,0.00275}, {9350,0.00150}, {9400,0.00275}, {9450,0.00275}, {9500,0.00375}, {9550,0.00275}, {9600,0.00075}, {9650,0.00250}, {9700,0.00850}, {9750,0.00225}, {9800,0.00300}, {9850,0.00250}, {9900,0.00225}, {9950,0.00225}, {10000,0.00225}, {10100,0.00350}, {10200,0.00275}, {10300,0.00225}, {10400,0.00350}, {10500,0.00225}, {10600,0.00350}, {10700,0.00300}, {10800,0.00150}, {10900,0.00250}, {11000,0.00225}, {11100,0.00250}, {11200,0.00225}, {11300,0.00225}, {11400,0.00325}, {11500,0.00325}, {11600,0.00325}, {11700,0.00375}, {11800,0.00325}, {11900,0.00350}, {12000,0.00350}, {12100,0.00325}, {12200,0.00300}, {12300,0.00325}, {12400,0.00325}, {12500,0.00300}, {12600,0.00350}, {12700,0.00325}, {12800,0.00375}, {12900,0.00425}, {13000,0.00400}, {13100,0.00350}, {13200,0.00375}, {13300,0.00300}, {13400,0.00325}, {13500,0.00350}, {13600,0.00425}, {13700,0.00325}, {13800,0.00425}, {13900,0.00500}, {14000,0.00450}, {14100,0.00350}, {14200,0.00450}, {14300,0.00350}, {14400,0.00375}, {14500,0.00375}, {14600,0.00450}, {14700,0.00475}, {14800,0.00475}, {14900,0.00450}, {15000,0.01300}, {15100,0.00475}, {15200,0.00425}, {15300,0.00400}, {15400,0.00475}, {15500,0.00500}, {15600,0.00575}, {15700,0.00650}, {15800,0.00425}, {15900,0.00525}, {16000,0.00575}, {16100,0.00450}, {16200,0.00375}, {16300,0.00475}, {16400,0.00650}, {16500,0.00475}, {16600,0.00650}, {16700,0.00350}, {16800,0.00375}, {16900,0.00525}, {17000,0.00450}, {17100,0.00450}, {17200,0.00550}, {17300,0.00550}, {17400,0.00650}, {17500,0.00375}, {17600,0.00625}, {17700,0.00550}, {17800,0.00525}, {17900,0.00550}, {18000,0.00700}, {18100,0.00525}, {18200,0.00625}, {18300,0.00450}, {18400,0.00575}, {18500,0.00625}, {18600,0.00625}, {18700,0.00475}, {18800,0.00450}, {18900,0.00400}, {19000,0.00425}, {19100,0.00550}, {19200,0.00750}, {19300,0.00725}, {19400,0.00525}, {19500,0.00600}, {19600,0.00525}, {19700,0.00625}, {19800,0.00600}, {19900,0.00725}, {20000,0.0060}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["intros _"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00002703}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00003604}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00002703}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00003604}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00003604}, {354,0.00000000}, {355,0.00000000}, {356,0.00002703}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00003604}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00003604}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00003604}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00003604}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00003604}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00003604}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00003604}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00003604}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00002703}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00003604}, {1100,0.00003604}, {1110,0.00002703}, {1120,0.00000000}, {1130,0.00003604}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00003604}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00003604}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00003604}, {1500,0.00000000}, {1510,0.00003604}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00003604}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00003604}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00003604}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00007207}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00003604}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00003604}, {3150,0.00000000}, {3200,0.00003604}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00003604}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00003604}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00003604}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00003604}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00007207}, {5800,0.00000000}, {5850,0.00003604}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00100}, {7000,0.00000}, {7050,0.00000}, {7100,0.00075}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00075}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00100}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00100}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00463964}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00432432}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00461261}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000901}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00001802}, {2300,0.00003604}, {2350,0.00007207}, {2400,0.00019820}, {2450,0.00047748}, {2500,0.00070270}, {2550,0.00076577}, {2600,0.00090090}, {2650,0.00099099}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00100000}, {3150,0.00100000}, {3200,0.00100000}, {3250,0.00100000}, {3300,0.00100000}, {3350,0.00100000}, {3400,0.00100000}, {3450,0.00100000}, {3500,0.00100000}, {3550,0.00100000}, {3600,0.00100000}, {3650,0.00100000}, {3700,0.00100000}, {3750,0.00100000}, {3800,0.00100000}, {3850,0.00100000}, {3900,0.00100000}, {3950,0.00344144}, {4000,0.00100000}, {4050,0.00100000}, {4100,0.00103604}, {4150,0.00101802}, {4200,0.00101802}, {4250,0.00104505}, {4300,0.00103604}, {4350,0.00107207}, {4400,0.00110811}, {4450,0.00119820}, {4500,0.00133333}, {4550,0.00129730}, {4600,0.00145946}, {4650,0.00151351}, {4700,0.00168468}, {4750,0.00173874}, {4800,0.00174775}, {4850,0.00181982}, {4900,0.00181982}, {4950,0.00185586}, {5000,0.00192793}, {5050,0.00195495}, {5100,0.00820721}, {5150,0.00199099}, {5200,0.00200000}, {5250,0.00200000}, {5300,0.00200000}, {5350,0.00200000}, {5400,0.00200000}, {5450,0.00200000}, {5500,0.00200000}, {5550,0.00200000}, {5600,0.00200000}, {5650,0.00200000}, {5700,0.00200000}, {5750,0.00206306}, {5800,0.00200901}, {5850,0.00200000}, {5900,0.00200901}, {5950,0.00200000}, {6000,0.00202703}, {6050,0.00200}, {6100,0.00200}, {6150,0.00200}, {6200,0.00200}, {6250,0.00200}, {6300,0.00200}, {6350,0.00200}, {6400,0.00200}, {6450,0.00200}, {6500,0.00225}, {6550,0.00200}, {6600,0.00200}, {6650,0.00225}, {6700,0.00225}, {6750,0.00200}, {6800,0.00225}, {6850,0.00275}, {6900,0.00250}, {6950,0.00250}, {7000,0.00275}, {7050,0.00250}, {7100,0.00300}, {7150,0.00250}, {7200,0.00300}, {7250,0.00300}, {7300,0.00300}, {7350,0.00300}, {7400,0.00300}, {7450,0.00300}, {7500,0.00300}, {7550,0.01075}, {7600,0.01325}, {7650,0.00300}, {7700,0.00300}, {7750,0.00300}, {7800,0.00300}, {7850,0.00325}, {7900,0.00300}, {7950,0.00300}, {8000,0.00300}, {8050,0.00300}, {8100,0.00300}, {8150,0.00325}, {8200,0.00300}, {8250,0.00300}, {8300,0.00325}, {8350,0.00325}, {8400,0.00325}, {8450,0.00350}, {8500,0.00375}, {8550,0.00325}, {8600,0.00325}, {8650,0.00325}, {8700,0.01875}, {8750,0.00350}, {8800,0.00350}, {8850,0.00350}, {8900,0.00350}, {8950,0.00375}, {9000,0.00375}, {9050,0.00375}, {9100,0.00400}, {9150,0.00400}, {9200,0.00375}, {9250,0.01575}, {9300,0.01275}, {9350,0.00375}, {9400,0.00400}, {9450,0.00400}, {9500,0.00400}, {9550,0.00375}, {9600,0.00400}, {9650,0.00400}, {9700,0.00850}, {9750,0.00400}, {9800,0.00425}, {9850,0.00400}, {9900,0.00400}, {9950,0.00400}, {10000,0.00450}, {10100,0.00450}, {10200,0.00425}, {10300,0.00400}, {10400,0.00425}, {10500,0.00475}, {10600,0.00475}, {10700,0.00500}, {10800,0.00475}, {10900,0.00500}, {11000,0.00500}, {11100,0.00500}, {11200,0.00500}, {11300,0.00500}, {11400,0.00525}, {11500,0.02050}, {11600,0.00500}, {11700,0.00500}, {11800,0.00500}, {11900,0.00575}, {12000,0.00550}, {12100,0.00525}, {12200,0.00525}, {12300,0.00575}, {12400,0.00550}, {12500,0.00550}, {12600,0.00550}, {12700,0.00575}, {12800,0.00600}, {12900,0.00600}, {13000,0.00600}, {13100,0.00600}, {13200,0.00600}, {13300,0.00600}, {13400,0.00600}, {13500,0.00600}, {13600,0.00600}, {13700,0.00650}, {13800,0.00600}, {13900,0.00700}, {14000,0.00600}, {14100,0.00675}, {14200,0.00625}, {14300,0.00700}, {14400,0.00675}, {14500,0.00700}, {14600,0.00700}, {14700,0.00700}, {14800,0.00725}, {14900,0.00700}, {15000,0.00700}, {15100,0.00750}, {15200,0.03425}, {15300,0.00700}, {15400,0.00725}, {15500,0.00700}, {15600,0.00700}, {15700,0.00725}, {15800,0.00700}, {15900,0.00725}, {16000,0.00775}, {16100,0.00750}, {16200,0.03500}, {16300,0.00800}, {16400,0.00800}, {16500,0.00800}, {16600,0.00850}, {16700,0.00800}, {16800,0.00800}, {16900,0.00800}, {17000,0.00800}, {17100,0.00800}, {17200,0.00800}, {17300,0.00825}, {17400,0.00900}, {17500,0.00825}, {17600,0.00925}, {17700,0.02575}, {17800,0.00950}, {17900,0.00800}, {18000,0.03625}, {18100,0.00875}, {18200,0.00900}, {18300,0.00900}, {18400,0.00900}, {18500,0.00900}, {18600,0.03175}, {18700,0.00900}, {18800,0.03900}, {18900,0.01000}, {19000,0.01000}, {19100,0.00925}, {19200,0.00900}, {19300,0.04025}, {19400,0.00900}, {19500,0.00925}, {19600,0.00900}, {19700,0.00925}, {19800,0.00975}, {19900,0.01000}, {20000,0.0100}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00002703}, {7,0.00002703}, {8,0.00000000}, {9,0.00000000}, {10,0.00002703}, {11,0.00000000}, {12,0.00003604}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00002703}, {22,0.00003604}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00002703}, {29,0.00000000}, {30,0.00003604}, {31,0.00005405}, {32,0.00006306}, {33,0.00003604}, {34,0.00000000}, {35,0.00000000}, {36,0.00006306}, {37,0.00000000}, {38,0.00000000}, {39,0.00003604}, {40,0.00002703}, {41,0.00008108}, {42,0.00006306}, {43,0.00003604}, {44,0.00006306}, {45,0.00000000}, {46,0.00000000}, {47,0.00006306}, {48,0.00003604}, {49,0.00000000}, {50,0.00003604}, {51,0.00002703}, {52,0.00000000}, {53,0.00000000}, {54,0.00002703}, {55,0.00005405}, {56,0.00003604}, {57,0.00000000}, {58,0.00003604}, {59,0.00003604}, {60,0.00000000}, {61,0.00002703}, {62,0.00003604}, {63,0.00002703}, {64,0.00003604}, {65,0.00000000}, {66,0.00003604}, {67,0.00002703}, {68,0.00000000}, {69,0.00009009}, {70,0.00003604}, {71,0.00000000}, {72,0.00003604}, {73,0.00003604}, {74,0.00000000}, {75,0.00003604}, {76,0.00000000}, {77,0.00003604}, {78,0.00003604}, {79,0.00000000}, {80,0.00005405}, {81,0.00000000}, {82,0.00003604}, {83,0.00000000}, {84,0.00005405}, {85,0.00000000}, {86,0.00009910}, {87,0.00000000}, {88,0.00003604}, {89,0.00009009}, {90,0.00009009}, {91,0.00003604}, {92,0.00009009}, {93,0.00000000}, {94,0.00006306}, {95,0.00000000}, {96,0.00002703}, {97,0.00000000}, {98,0.00009910}, {99,0.00013514}, {100,0.00015315}, {101,0.00003604}, {102,0.00002703}, {103,0.00008108}, {104,0.00019820}, {105,0.00006306}, {106,0.00015315}, {107,0.00002703}, {108,0.00002703}, {109,0.00002703}, {110,0.00006306}, {111,0.00009009}, {112,0.00007207}, {113,0.00006306}, {114,0.00007207}, {115,0.00009009}, {116,0.00003604}, {117,0.00006306}, {118,0.00005405}, {119,0.00002703}, {120,0.00003604}, {121,0.00002703}, {122,0.00009009}, {123,0.00002703}, {124,0.00009009}, {125,0.00000000}, {126,0.00006306}, {127,0.00003604}, {128,0.00010811}, {129,0.00002703}, {130,0.00000000}, {131,0.00012613}, {132,0.00009009}, {133,0.00006306}, {134,0.00007207}, {135,0.00002703}, {136,0.00005405}, {137,0.00006306}, {138,0.00003604}, {139,0.00000000}, {140,0.00000000}, {141,0.00003604}, {142,0.00008108}, {143,0.00008108}, {144,0.00007207}, {145,0.00011712}, {146,0.00007207}, {147,0.00008108}, {148,0.00006306}, {149,0.00003604}, {150,0.00013514}, {151,0.00006306}, {152,0.00000000}, {153,0.00011712}, {154,0.00013514}, {155,0.00009009}, {156,0.00007207}, {157,0.00011712}, {158,0.00000000}, {159,0.00007207}, {160,0.00011712}, {161,0.00006306}, {162,0.00006306}, {163,0.00002703}, {164,0.00002703}, {165,0.00015315}, {166,0.00008108}, {167,0.00012613}, {168,0.00008108}, {169,0.00020721}, {170,0.00005405}, {171,0.00002703}, {172,0.00011712}, {173,0.00011712}, {174,0.00010811}, {175,0.00002703}, {176,0.00006306}, {177,0.00002703}, {178,0.00005405}, {179,0.00000000}, {180,0.00011712}, {181,0.00009009}, {182,0.00002703}, {183,0.00002703}, {184,0.00008108}, {185,0.00011712}, {186,0.00007207}, {187,0.00009910}, {188,0.00005405}, {189,0.00008108}, {190,0.00002703}, {191,0.00006306}, {192,0.00009009}, {193,0.00010811}, {194,0.00008108}, {195,0.00005405}, {196,0.00000000}, {197,0.00014414}, {198,0.00005405}, {199,0.00006306}, {200,0.00009009}, {201,0.00022523}, {202,0.00011712}, {203,0.00002703}, {204,0.00015315}, {205,0.00011712}, {206,0.00007207}, {207,0.00005405}, {208,0.00010811}, {209,0.00002703}, {210,0.00002703}, {211,0.00009009}, {212,0.00018018}, {213,0.00003604}, {214,0.00008108}, {215,0.00002703}, {216,0.00017117}, {217,0.00012613}, {218,0.00014414}, {219,0.00009009}, {220,0.00014414}, {221,0.00027027}, {222,0.00003604}, {223,0.00008108}, {224,0.00003604}, {225,0.00005405}, {226,0.00009009}, {227,0.00010811}, {228,0.00002703}, {229,0.00014414}, {230,0.00005405}, {231,0.00008108}, {232,0.00005405}, {233,0.00011712}, {234,0.00006306}, {235,0.00012613}, {236,0.00009910}, {237,0.00012613}, {238,0.00017117}, {239,0.00002703}, {240,0.00011712}, {241,0.00017117}, {242,0.00009009}, {243,0.00011712}, {244,0.00006306}, {245,0.00005405}, {246,0.00018919}, {247,0.00012613}, {248,0.00009910}, {249,0.00002703}, {250,0.00009910}, {251,0.00010811}, {252,0.00017117}, {253,0.00005405}, {254,0.00002703}, {255,0.00009910}, {256,0.00013514}, {257,0.00008108}, {258,0.00011712}, {259,0.00014414}, {260,0.00018919}, {261,0.00007207}, {262,0.00009009}, {263,0.00018919}, {264,0.00000000}, {265,0.00002703}, {266,0.00002703}, {267,0.00008108}, {268,0.00006306}, {269,0.00014414}, {270,0.00021622}, {271,0.00009009}, {272,0.00008108}, {273,0.00009009}, {274,0.00008108}, {275,0.00010811}, {276,0.00000000}, {277,0.00006306}, {278,0.00009910}, {279,0.00014414}, {280,0.00012613}, {281,0.00019820}, {282,0.00006306}, {283,0.00009910}, {284,0.00016216}, {285,0.00011712}, {286,0.00011712}, {287,0.00005405}, {288,0.00011712}, {289,0.00013514}, {290,0.00008108}, {291,0.00011712}, {292,0.00022523}, {293,0.00005405}, {294,0.00003604}, {295,0.00017117}, {296,0.00012613}, {297,0.00011712}, {298,0.00021622}, {299,0.00014414}, {300,0.00017117}, {301,0.00005405}, {302,0.00011712}, {303,0.00002703}, {304,0.00015315}, {305,0.00017117}, {306,0.00018919}, {307,0.00005405}, {308,0.00018919}, {309,0.00014414}, {310,0.00013514}, {311,0.00000000}, {312,0.00017117}, {313,0.00011712}, {314,0.00014414}, {315,0.00009910}, {316,0.00009009}, {317,0.00021622}, {318,0.00005405}, {319,0.00026126}, {320,0.00012613}, {321,0.00010811}, {322,0.00008108}, {323,0.00010811}, {324,0.00009009}, {325,0.00025225}, {326,0.00026126}, {327,0.00024324}, {328,0.00007207}, {329,0.00020721}, {330,0.00016216}, {331,0.00016216}, {332,0.00009009}, {333,0.00009910}, {334,0.00017117}, {335,0.00005405}, {336,0.00015315}, {337,0.00009910}, {338,0.00015315}, {339,0.00013514}, {340,0.00012613}, {341,0.00022523}, {342,0.00006306}, {343,0.00010811}, {344,0.00019820}, {345,0.00020721}, {346,0.00005405}, {347,0.00012613}, {348,0.00015315}, {349,0.00009009}, {350,0.00010811}, {351,0.00018919}, {352,0.00013514}, {353,0.00017117}, {354,0.00017117}, {355,0.00014414}, {356,0.00018919}, {357,0.00029730}, {358,0.00015315}, {359,0.00013514}, {360,0.00009009}, {361,0.00014414}, {362,0.00018919}, {363,0.00013514}, {364,0.00009009}, {365,0.00019820}, {366,0.00018919}, {367,0.00010811}, {368,0.00025225}, {369,0.00009009}, {370,0.00007207}, {371,0.00026126}, {372,0.00019820}, {373,0.00019820}, {374,0.00012613}, {375,0.00022523}, {376,0.00025225}, {377,0.00030631}, {378,0.00018919}, {379,0.00009009}, {380,0.00019820}, {381,0.00013514}, {382,0.00019820}, {383,0.00027027}, {384,0.00009910}, {385,0.00025225}, {386,0.00019820}, {387,0.00009910}, {388,0.00009910}, {389,0.00015315}, {390,0.00009009}, {391,0.00012613}, {392,0.00014414}, {393,0.00017117}, {394,0.00008108}, {395,0.00018018}, {396,0.00009009}, {397,0.00012613}, {398,0.00027928}, {399,0.00027928}, {400,0.00027928}, {401,0.00027928}, {402,0.00027027}, {403,0.00026126}, {404,0.00013514}, {405,0.00017117}, {406,0.00012613}, {407,0.00010811}, {408,0.00009910}, {409,0.00006306}, {410,0.00031532}, {411,0.00012613}, {412,0.00014414}, {413,0.00013514}, {414,0.00015315}, {415,0.00025225}, {416,0.00006306}, {417,0.00006306}, {418,0.00020721}, {419,0.00002703}, {420,0.00021622}, {421,0.00026126}, {422,0.00009910}, {423,0.00016216}, {424,0.00013514}, {425,0.00033333}, {426,0.00020721}, {427,0.00023423}, {428,0.00014414}, {429,0.00038739}, {430,0.00027928}, {431,0.00022523}, {432,0.00021622}, {433,0.00015315}, {434,0.00009910}, {435,0.00018919}, {436,0.00016216}, {437,0.00018919}, {438,0.00016216}, {439,0.00020721}, {440,0.00016216}, {441,0.00026126}, {442,0.00002703}, {443,0.00034234}, {444,0.00012613}, {445,0.00023423}, {446,0.00036036}, {447,0.00010811}, {448,0.00024324}, {449,0.00026126}, {450,0.00019820}, {451,0.00015315}, {452,0.00006306}, {453,0.00027928}, {454,0.00036036}, {455,0.00015315}, {456,0.00033333}, {457,0.00021622}, {458,0.00016216}, {459,0.00023423}, {460,0.00008108}, {461,0.00006306}, {462,0.00035135}, {463,0.00027928}, {464,0.00027027}, {465,0.00005405}, {466,0.00009910}, {467,0.00013514}, {468,0.00013514}, {469,0.00012613}, {470,0.00007207}, {471,0.00020721}, {472,0.00018018}, {473,0.00020721}, {474,0.00023423}, {475,0.00002703}, {476,0.00032432}, {477,0.00016216}, {478,0.00016216}, {479,0.00021622}, {480,0.00026126}, {481,0.00007207}, {482,0.00006306}, {483,0.00010811}, {484,0.00026126}, {485,0.00023423}, {486,0.00032432}, {487,0.00018919}, {488,0.00016216}, {489,0.00013514}, {490,0.00012613}, {491,0.00018018}, {492,0.00025225}, {493,0.00016216}, {494,0.00018919}, {495,0.00028829}, {496,0.00007207}, {497,0.00017117}, {498,0.00028829}, {499,0.00015315}, {500,0.00003604}, {505,0.00025225}, {510,0.00031532}, {515,0.00022523}, {520,0.00024324}, {525,0.00017117}, {530,0.00027027}, {535,0.00018919}, {540,0.00030631}, {545,0.00045045}, {550,0.00012613}, {555,0.00013514}, {560,0.00023423}, {565,0.00036036}, {570,0.00018018}, {575,0.00027928}, {580,0.00032432}, {585,0.00022523}, {590,0.00025225}, {595,0.00021622}, {600,0.00027928}, {605,0.00027027}, {610,0.00025225}, {615,0.00022523}, {620,0.00027928}, {625,0.00021622}, {630,0.00030631}, {635,0.00024324}, {640,0.00024324}, {645,0.00008108}, {650,0.00030631}, {655,0.00029730}, {660,0.00030631}, {665,0.00027027}, {670,0.00043243}, {675,0.00014414}, {680,0.00022523}, {685,0.00023423}, {690,0.00028829}, {695,0.00039640}, {700,0.00014414}, {705,0.00025225}, {710,0.00036036}, {715,0.00022523}, {720,0.00013514}, {725,0.00006306}, {730,0.00030631}, {735,0.00036036}, {740,0.00015315}, {745,0.00019820}, {750,0.00022523}, {755,0.00034234}, {760,0.00032432}, {765,0.00035135}, {770,0.00012613}, {775,0.00033333}, {780,0.00019820}, {785,0.00025225}, {790,0.00024324}, {795,0.00032432}, {800,0.00029730}, {805,0.00029730}, {810,0.00016216}, {815,0.00032432}, {820,0.00033333}, {825,0.00027928}, {830,0.00029730}, {835,0.00036937}, {840,0.00018018}, {845,0.00017117}, {850,0.00026126}, {855,0.00027928}, {860,0.00036937}, {865,0.00035135}, {870,0.00033333}, {875,0.00026126}, {880,0.00023423}, {885,0.00029730}, {890,0.00028829}, {895,0.00043243}, {900,0.00036036}, {905,0.00042342}, {910,0.00038739}, {915,0.00033333}, {920,0.00027027}, {925,0.00026126}, {930,0.00022523}, {935,0.00042342}, {940,0.00026126}, {945,0.00030631}, {950,0.00026126}, {955,0.00025225}, {960,0.00045045}, {965,0.00041441}, {970,0.00036036}, {975,0.00032432}, {980,0.00024324}, {985,0.00037838}, {990,0.00029730}, {995,0.00027928}, {1000,0.00035135}, {1010,0.00023423}, {1020,0.00471171}, {1030,0.00029730}, {1040,0.00038739}, {1050,0.00033333}, {1060,0.00035135}, {1070,0.00036937}, {1080,0.00013514}, {1090,0.00045045}, {1100,0.00054054}, {1110,0.00029730}, {1120,0.00051351}, {1130,0.00029730}, {1140,0.00045946}, {1150,0.00027928}, {1160,0.00036937}, {1170,0.00029730}, {1180,0.00037838}, {1190,0.00040541}, {1200,0.00048649}, {1210,0.00046847}, {1220,0.00039640}, {1230,0.00032432}, {1240,0.00038739}, {1250,0.00032432}, {1260,0.00023423}, {1270,0.00055856}, {1280,0.00044144}, {1290,0.00054054}, {1300,0.00045946}, {1310,0.00438739}, {1320,0.00043243}, {1330,0.00061261}, {1340,0.00047748}, {1350,0.00045045}, {1360,0.00034234}, {1370,0.00026126}, {1380,0.00049550}, {1390,0.00032432}, {1400,0.00039640}, {1410,0.00044144}, {1420,0.00035135}, {1430,0.00040541}, {1440,0.00053153}, {1450,0.00048649}, {1460,0.00034234}, {1470,0.00051351}, {1480,0.00044144}, {1490,0.00055856}, {1500,0.00043243}, {1510,0.00044144}, {1520,0.00064865}, {1530,0.00049550}, {1540,0.00048649}, {1550,0.00039640}, {1560,0.00054054}, {1570,0.00057658}, {1580,0.00054054}, {1590,0.00072072}, {1600,0.00070270}, {1610,0.00039640}, {1620,0.00068468}, {1630,0.00048649}, {1640,0.00059459}, {1650,0.00055856}, {1660,0.00066667}, {1670,0.00058559}, {1680,0.00046847}, {1690,0.00043243}, {1700,0.00060360}, {1710,0.00030631}, {1720,0.00080180}, {1730,0.00063964}, {1740,0.00036036}, {1750,0.00049550}, {1760,0.00051351}, {1770,0.00064865}, {1780,0.00055856}, {1790,0.00092793}, {1800,0.00066667}, {1810,0.00446847}, {1820,0.00078378}, {1830,0.00086486}, {1840,0.00045045}, {1850,0.00064865}, {1860,0.00072973}, {1870,0.00078378}, {1880,0.00065766}, {1890,0.00045045}, {1900,0.00065766}, {1910,0.00065766}, {1920,0.00073874}, {1930,0.00069369}, {1940,0.00054054}, {1950,0.00084685}, {1960,0.00058559}, {1970,0.00061261}, {1980,0.00079279}, {1990,0.00071171}, {2000,0.00087387}, {2050,0.00079279}, {2100,0.00069369}, {2150,0.00075676}, {2200,0.00088288}, {2250,0.00089189}, {2300,0.00097297}, {2350,0.00083784}, {2400,0.00105405}, {2450,0.00097297}, {2500,0.00082883}, {2550,0.00087387}, {2600,0.00072072}, {2650,0.00081982}, {2700,0.00106306}, {2750,0.00094595}, {2800,0.00095495}, {2850,0.00110811}, {2900,0.00136036}, {2950,0.00112613}, {3000,0.00113514}, {3050,0.00107207}, {3100,0.00116216}, {3150,0.00119820}, {3200,0.00131532}, {3250,0.00110811}, {3300,0.00124324}, {3350,0.00136937}, {3400,0.00126126}, {3450,0.00128829}, {3500,0.00146847}, {3550,0.00132432}, {3600,0.00135135}, {3650,0.00145045}, {3700,0.00146847}, {3750,0.00140541}, {3800,0.00148649}, {3850,0.00145045}, {3900,0.00110811}, {3950,0.00370270}, {4000,0.00158559}, {4050,0.00153153}, {4100,0.00155856}, {4150,0.00179279}, {4200,0.00143243}, {4250,0.00168468}, {4300,0.00186486}, {4350,0.00172973}, {4400,0.00142342}, {4450,0.00169369}, {4500,0.00191892}, {4550,0.00175676}, {4600,0.00167568}, {4650,0.00182883}, {4700,0.00180180}, {4750,0.00159459}, {4800,0.00193694}, {4850,0.00199099}, {4900,0.00205405}, {4950,0.00198198}, {5000,0.00186486}, {5050,0.00211712}, {5100,0.00802703}, {5150,0.00190090}, {5200,0.00218919}, {5250,0.00203604}, {5300,0.00238739}, {5350,0.00244144}, {5400,0.00219820}, {5450,0.00244144}, {5500,0.00228829}, {5550,0.00205405}, {5600,0.00203604}, {5650,0.00242342}, {5700,0.00240541}, {5750,0.00235135}, {5800,0.00206306}, {5850,0.00240541}, {5900,0.00207207}, {5950,0.00218018}, {6000,0.00256757}, {6050,0.00200}, {6100,0.00100}, {6150,0.00275}, {6200,0.00300}, {6250,0.00250}, {6300,0.00275}, {6350,0.00375}, {6400,0.00350}, {6450,0.00175}, {6500,0.00100}, {6550,0.00250}, {6600,0.00275}, {6650,0.00275}, {6700,0.00200}, {6750,0.00150}, {6800,0.00325}, {6850,0.00150}, {6900,0.00375}, {6950,0.00325}, {7000,0.00300}, {7050,0.00250}, {7100,0.00150}, {7150,0.00325}, {7200,0.00150}, {7250,0.00275}, {7300,0.00150}, {7350,0.00350}, {7400,0.00325}, {7450,0.00300}, {7500,0.00150}, {7550,0.01075}, {7600,0.01350}, {7650,0.00325}, {7700,0.00225}, {7750,0.00300}, {7800,0.00250}, {7850,0.00350}, {7900,0.00350}, {7950,0.00325}, {8000,0.00325}, {8050,0.00350}, {8100,0.00350}, {8150,0.00375}, {8200,0.00400}, {8250,0.00400}, {8300,0.00350}, {8350,0.00350}, {8400,0.00400}, {8450,0.00400}, {8500,0.00325}, {8550,0.00350}, {8600,0.00375}, {8650,0.00400}, {8700,0.02075}, {8750,0.00350}, {8800,0.00375}, {8850,0.00375}, {8900,0.00475}, {8950,0.00325}, {9000,0.00350}, {9050,0.00350}, {9100,0.00450}, {9150,0.00375}, {9200,0.00325}, {9250,0.01575}, {9300,0.01300}, {9350,0.00400}, {9400,0.00400}, {9450,0.00350}, {9500,0.00375}, {9550,0.00350}, {9600,0.00425}, {9650,0.00450}, {9700,0.00800}, {9750,0.00425}, {9800,0.00300}, {9850,0.00300}, {9900,0.00325}, {9950,0.00450}, {10000,0.00475}, {10100,0.00325}, {10200,0.00300}, {10300,0.00475}, {10400,0.00350}, {10500,0.00425}, {10600,0.00325}, {10700,0.00450}, {10800,0.00550}, {10900,0.00450}, {11000,0.00550}, {11100,0.00550}, {11200,0.00550}, {11300,0.00350}, {11400,0.00450}, {11500,0.02200}, {11600,0.00450}, {11700,0.00600}, {11800,0.00350}, {11900,0.00525}, {12000,0.00525}, {12100,0.00775}, {12200,0.00675}, {12300,0.00575}, {12400,0.00650}, {12500,0.00800}, {12600,0.00550}, {12700,0.00675}, {12800,0.00325}, {12900,0.00550}, {13000,0.00700}, {13100,0.00750}, {13200,0.00525}, {13300,0.00650}, {13400,0.00550}, {13500,0.00650}, {13600,0.00675}, {13700,0.00775}, {13800,0.00675}, {13900,0.00675}, {14000,0.00650}, {14100,0.00750}, {14200,0.00575}, {14300,0.00725}, {14400,0.00725}, {14500,0.00650}, {14600,0.00550}, {14700,0.00625}, {14800,0.00725}, {14900,0.00750}, {15000,0.00700}, {15100,0.00625}, {15200,0.03475}, {15300,0.00700}, {15400,0.00700}, {15500,0.00700}, {15600,0.00725}, {15700,0.00725}, {15800,0.00675}, {15900,0.00750}, {16000,0.00700}, {16100,0.00650}, {16200,0.03600}, {16300,0.00700}, {16400,0.00725}, {16500,0.00725}, {16600,0.00825}, {16700,0.00750}, {16800,0.00850}, {16900,0.00725}, {17000,0.00825}, {17100,0.00975}, {17200,0.00725}, {17300,0.00725}, {17400,0.00825}, {17500,0.00950}, {17600,0.00950}, {17700,0.02550}, {17800,0.01200}, {17900,0.00750}, {18000,0.03700}, {18100,0.00875}, {18200,0.00900}, {18300,0.00975}, {18400,0.00950}, {18500,0.00875}, {18600,0.03125}, {18700,0.01075}, {18800,0.03975}, {18900,0.01200}, {19000,0.01075}, {19100,0.00950}, {19200,0.00725}, {19300,0.04050}, {19400,0.00950}, {19500,0.00825}, {19600,0.01000}, {19700,0.00950}, {19800,0.00850}, {19900,0.00975}, {20000,0.0120}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00003604}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00003604}, {61,0.00000000}, {62,0.00000000}, {63,0.00002703}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00002703}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00003604}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00003604}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00003604}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00003604}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00003604}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00002703}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00003604}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00003604}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00002703}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00003604}, {336,0.00000000}, {337,0.00003604}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00003604}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00003604}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00003604}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00003604}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00003604}, {429,0.00000000}, {430,0.00003604}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00003604}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00003604}, {462,0.00000000}, {463,0.00003604}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00003604}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00002703}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00003604}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00003604}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00006306}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00003604}, {870,0.00000000}, {875,0.00003604}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00003604}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00007207}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00010811}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00003604}, {1080,0.00003604}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00003604}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00003604}, {1260,0.00003604}, {1270,0.00003604}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00003604}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00003604}, {1450,0.00000000}, {1460,0.00003604}, {1470,0.00000000}, {1480,0.00002703}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00003604}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00003604}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00003604}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00007207}, {1820,0.00003604}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00003604}, {2050,0.00000000}, {2100,0.00003604}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00003604}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00003604}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00005405}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00003604}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00003604}, {3750,0.00000000}, {3800,0.00003604}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00003604}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00003604}, {4800,0.00003604}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00003604}, {5100,0.00000000}, {5150,0.00003604}, {5200,0.00000000}, {5250,0.00003604}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00003604}, {5500,0.00000000}, {5550,0.00003604}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00003604}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00100}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00100}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00013514}, {11,0.00064865}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00100000}, {16,0.00100000}, {17,0.00100000}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00103604}, {23,0.00123423}, {24,0.00118919}, {25,0.00178378}, {26,0.00200000}, {27,0.00200000}, {28,0.00200000}, {29,0.00200000}, {30,0.00200000}, {31,0.00200000}, {32,0.00200000}, {33,0.00200000}, {34,0.00201802}, {35,0.00206306}, {36,0.00216216}, {37,0.00220721}, {38,0.00215315}, {39,0.00279279}, {40,0.00293694}, {41,0.00300000}, {42,0.00300000}, {43,0.00300000}, {44,0.00300000}, {45,0.00300000}, {46,0.00300000}, {47,0.00300901}, {48,0.00301802}, {49,0.00314414}, {50,0.00311712}, {51,0.00309009}, {52,0.00311712}, {53,0.00358559}, {54,0.00399099}, {55,0.00400000}, {56,0.00400000}, {57,0.00400000}, {58,0.00400000}, {59,0.00400000}, {60,0.00402703}, {61,0.00403604}, {62,0.00411712}, {63,0.00416216}, {64,0.00412613}, {65,0.00414414}, {66,0.00417117}, {67,0.00463964}, {68,0.00489189}, {69,0.00501802}, {70,0.00500901}, {71,0.00500000}, {72,0.00596396}, {73,0.00500901}, {74,0.00501802}, {75,0.00503604}, {76,0.00504505}, {77,0.00508108}, {78,0.00607207}, {79,0.00516216}, {80,0.00515315}, {81,0.00550450}, {82,0.00585586}, {83,0.00600000}, {84,0.00622523}, {85,0.00600000}, {86,0.00601802}, {87,0.00604505}, {88,0.00605405}, {89,0.00609009}, {90,0.00609009}, {91,0.00608108}, {92,0.00609009}, {93,0.00621622}, {94,0.00649550}, {95,0.00690991}, {96,0.00661261}, {97,0.00700000}, {98,0.00700901}, {99,0.00701802}, {100,0.00704505}, {101,0.00703604}, {102,0.00706306}, {103,0.00714414}, {104,0.00809009}, {105,0.00708108}, {106,0.00707207}, {107,0.00726126}, {108,0.00733333}, {109,0.00778378}, {110,0.00795495}, {111,0.00801802}, {112,0.00800000}, {113,0.00888288}, {114,0.00805405}, {115,0.00808108}, {116,0.00809009}, {117,0.00804505}, {118,0.00810811}, {119,0.00812613}, {120,0.00812613}, {121,0.00823423}, {122,0.00851351}, {123,0.00890991}, {124,0.00898198}, {125,0.00900000}, {126,0.00902703}, {127,0.00904505}, {128,0.00902703}, {129,0.00906306}, {130,0.00904505}, {131,0.00911712}, {132,0.00909910}, {133,0.01027928}, {134,0.00915315}, {135,0.00948649}, {136,0.00925225}, {137,0.01021622}, {138,0.00989189}, {139,0.01003604}, {140,0.01005405}, {141,0.01004505}, {142,0.01011712}, {143,0.01009910}, {144,0.01101802}, {145,0.01010811}, {146,0.01008108}, {147,0.01016216}, {148,0.01012613}, {149,0.01061261}, {150,0.01069369}, {151,0.01104505}, {152,0.01088288}, {153,0.01104505}, {154,0.01200901}, {155,0.01108108}, {156,0.01108108}, {157,0.01111712}, {158,0.01109009}, {159,0.01120721}, {160,0.01108108}, {161,0.01111712}, {162,0.01116216}, {163,0.01154955}, {164,0.01135135}, {165,0.01189189}, {166,0.01202703}, {167,0.01205405}, {168,0.01201802}, {169,0.01210811}, {170,0.01203604}, {171,0.01209910}, {172,0.01203604}, {173,0.01214414}, {174,0.01220721}, {175,0.01259459}, {176,0.01218919}, {177,0.01251351}, {178,0.01272072}, {179,0.01301802}, {180,0.01296396}, {181,0.01305405}, {182,0.01306306}, {183,0.01314414}, {184,0.01308108}, {185,0.01308108}, {186,0.01314414}, {187,0.01437838}, {188,0.01314414}, {189,0.01355856}, {190,0.01375676}, {191,0.01402703}, {192,0.01336036}, {193,0.01376577}, {194,0.01381081}, {195,0.01509009}, {196,0.01401802}, {197,0.01405405}, {198,0.01408108}, {199,0.01407207}, {200,0.01413514}, {201,0.01409910}, {202,0.01410811}, {203,0.01570270}, {204,0.01432432}, {205,0.01492793}, {206,0.01498198}, {207,0.01509910}, {208,0.01600901}, {209,0.01501802}, {210,0.01504505}, {211,0.01508108}, {212,0.01512613}, {213,0.01516216}, {214,0.01509910}, {215,0.01544144}, {216,0.01519820}, {217,0.01554955}, {218,0.01570270}, {219,0.01602703}, {220,0.01702703}, {221,0.01608108}, {222,0.01604505}, {223,0.01614414}, {224,0.01600901}, {225,0.01603604}, {226,0.01606306}, {227,0.01718018}, {228,0.01609910}, {229,0.01624324}, {230,0.01636036}, {231,0.01691892}, {232,0.01643243}, {233,0.01689189}, {234,0.01692793}, {235,0.01711712}, {236,0.01801802}, {237,0.01714414}, {238,0.01856757}, {239,0.01728829}, {240,0.01716216}, {241,0.01712613}, {242,0.01720721}, {243,0.01751351}, {244,0.01740541}, {245,0.01787387}, {246,0.01796396}, {247,0.01809910}, {248,0.01796396}, {249,0.01900901}, {250,0.01807207}, {251,0.01981081}, {252,0.01818018}, {253,0.01987387}, {254,0.01835135}, {255,0.02007207}, {256,0.01812613}, {257,0.01962162}, {258,0.01818919}, {259,0.01989189}, {260,0.01845045}, {261,0.02058559}, {262,0.01894595}, {263,0.02105405}, {264,0.01890090}, {265,0.02029730}, {266,0.01907207}, {267,0.02115315}, {268,0.01916216}, {269,0.02072072}, {270,0.01939640}, {271,0.02103604}, {272,0.01922523}, {273,0.02090991}, {274,0.01970270}, {275,0.02118018}, {276,0.02004505}, {277,0.02123423}, {278,0.02010811}, {279,0.02029730}, {280,0.02009910}, {281,0.02018018}, {282,0.02029730}, {283,0.02070270}, {284,0.02046847}, {285,0.02087387}, {286,0.02272973}, {287,0.02108108}, {288,0.02175676}, {289,0.02091892}, {290,0.02211712}, {291,0.02110811}, {292,0.02107207}, {293,0.02111712}, {294,0.02120721}, {295,0.02149550}, {296,0.02117117}, {297,0.02354955}, {298,0.02154955}, {299,0.02192793}, {300,0.02179279}, {301,0.02203604}, {302,0.02218919}, {303,0.02209009}, {304,0.02436937}, {305,0.02208108}, {306,0.02217117}, {307,0.02218919}, {308,0.02215315}, {309,0.02237838}, {310,0.02245946}, {311,0.02482883}, {312,0.02254955}, {313,0.02295495}, {314,0.02290991}, {315,0.02309910}, {316,0.02567568}, {317,0.02320721}, {318,0.02326126}, {319,0.02368468}, {320,0.02299099}, {321,0.02492793}, {322,0.02309910}, {323,0.02327027}, {324,0.02321622}, {325,0.02347748}, {326,0.02498198}, {327,0.02397297}, {328,0.02354054}, {329,0.02529730}, {330,0.02402703}, {331,0.02418919}, {332,0.02409910}, {333,0.02411712}, {334,0.02607207}, {335,0.02464865}, {336,0.02408108}, {337,0.02606306}, {338,0.02430631}, {339,0.02482883}, {340,0.02453153}, {341,0.02500901}, {342,0.02502703}, {343,0.02515315}, {344,0.02500000}, {345,0.02698198}, {346,0.02518919}, {347,0.02542342}, {348,0.02714414}, {349,0.02566667}, {350,0.02575676}, {351,0.02768468}, {352,0.02519820}, {353,0.02547748}, {354,0.02722523}, {355,0.02605405}, {356,0.02586486}, {357,0.02763063}, {358,0.02618018}, {359,0.02625225}, {360,0.02764865}, {361,0.02626126}, {362,0.02637838}, {363,0.02824324}, {364,0.02655856}, {365,0.02693694}, {366,0.02832432}, {367,0.02712613}, {368,0.02665766}, {369,0.02708108}, {370,0.02867568}, {371,0.02729730}, {372,0.02716216}, {373,0.02897297}, {374,0.02750450}, {375,0.02786486}, {376,0.02907207}, {377,0.02780180}, {378,0.02778378}, {379,0.02814414}, {380,0.02922523}, {381,0.02820721}, {382,0.02823423}, {383,0.03015315}, {384,0.02750450}, {385,0.02785586}, {386,0.02797297}, {387,0.02972072}, {388,0.02807207}, {389,0.02819820}, {390,0.02836036}, {391,0.03064865}, {392,0.02823423}, {393,0.02858559}, {394,0.03020721}, {395,0.02908108}, {396,0.02881081}, {397,0.02911712}, {398,0.03072973}, {399,0.02941441}, {400,0.02890090}, {401,0.02911712}, {402,0.03085586}, {403,0.02954054}, {404,0.02934234}, {405,0.02969369}, {406,0.03126126}, {407,0.03009009}, {408,0.02965766}, {409,0.03006306}, {410,0.03154054}, {411,0.03283784}, {412,0.03025225}, {413,0.03047748}, {414,0.03054955}, {415,0.03245045}, {416,0.03015315}, {417,0.03028829}, {418,0.03036036}, {419,0.03237838}, {420,0.03294595}, {421,0.03089189}, {422,0.03114414}, {423,0.03120721}, {424,0.03218919}, {425,0.03441441}, {426,0.03111712}, {427,0.03153153}, {428,0.03129730}, {429,0.03320721}, {430,0.03519820}, {431,0.03220721}, {432,0.03137838}, {433,0.03187387}, {434,0.03327027}, {435,0.03438739}, {436,0.03200901}, {437,0.03219820}, {438,0.03234234}, {439,0.03412613}, {440,0.03457658}, {441,0.03254955}, {442,0.03271171}, {443,0.03303604}, {444,0.03276577}, {445,0.03450450}, {446,0.03554054}, {447,0.03360360}, {448,0.03234234}, {449,0.03268468}, {450,0.03273874}, {451,0.03439640}, {452,0.03528829}, {453,0.03320721}, {454,0.03322523}, {455,0.03357658}, {456,0.03311712}, {457,0.03356757}, {458,0.03507207}, {459,0.03605405}, {460,0.03385586}, {461,0.03406306}, {462,0.03416216}, {463,0.03437838}, {464,0.03366667}, {465,0.03555856}, {466,0.03648649}, {467,0.03450450}, {468,0.03432432}, {469,0.03480180}, {470,0.03480180}, {471,0.03504505}, {472,0.03460360}, {473,0.03677477}, {474,0.03733333}, {475,0.03754054}, {476,0.03511712}, {477,0.03548649}, {478,0.03544144}, {479,0.03597297}, {480,0.03493694}, {481,0.03526126}, {482,0.03681982}, {483,0.03795495}, {484,0.03754054}, {485,0.03591892}, {486,0.03600000}, {487,0.03628829}, {488,0.03573874}, {489,0.03615315}, {490,0.03612613}, {491,0.03641441}, {492,0.03747748}, {493,0.03891892}, {494,0.03876577}, {495,0.03923423}, {496,0.03810811}, {497,0.03671171}, {498,0.03676577}, {499,0.03713514}, {500,0.03696396}, {505,0.03741441}, {510,0.03818919}, {515,0.03773874}, {520,0.03784685}, {525,0.03872973}, {530,0.03882883}, {535,0.03984685}, {540,0.03980180}, {545,0.03980180}, {550,0.04061261}, {555,0.04127928}, {560,0.04096396}, {565,0.04198198}, {570,0.04238739}, {575,0.04347748}, {580,0.04238739}, {585,0.04305405}, {590,0.04397297}, {595,0.04600000}, {600,0.04597297}, {605,0.04722523}, {610,0.04700901}, {615,0.04617117}, {620,0.04609009}, {625,0.04633333}, {630,0.05136937}, {635,0.05102703}, {640,0.04836937}, {645,0.04768468}, {650,0.04787387}, {655,0.04916216}, {660,0.05061261}, {665,0.05122523}, {670,0.05019820}, {675,0.05014414}, {680,0.05328829}, {685,0.05330631}, {690,0.05136036}, {695,0.05270270}, {700,0.05417117}, {705,0.05217117}, {710,0.05294595}, {715,0.05658559}, {720,0.05500000}, {725,0.05445045}, {730,0.05893694}, {735,0.05830631}, {740,0.05506306}, {745,0.05794595}, {750,0.05679279}, {755,0.06030631}, {760,0.05872072}, {765,0.05840541}, {770,0.05981081}, {775,0.05790090}, {780,0.06064865}, {785,0.05987387}, {790,0.06418018}, {795,0.06211712}, {800,0.05887387}, {805,0.06183784}, {810,0.06044144}, {815,0.06418919}, {820,0.06120721}, {825,0.06480180}, {830,0.06329730}, {835,0.06396396}, {840,0.06523423}, {845,0.06530631}, {850,0.06639640}, {855,0.06514414}, {860,0.06769369}, {865,0.06452252}, {870,0.06769369}, {875,0.06904505}, {880,0.06568468}, {885,0.07068468}, {890,0.06775676}, {895,0.07136937}, {900,0.06994595}, {905,0.06769369}, {910,0.07045045}, {915,0.07226126}, {920,0.06888288}, {925,0.07191892}, {930,0.07282883}, {935,0.07390991}, {940,0.07083784}, {945,0.07498198}, {950,0.07524324}, {955,0.07568468}, {960,0.07088288}, {965,0.07467568}, {970,0.07639640}, {975,0.07749550}, {980,0.07382883}, {985,0.07515315}, {990,0.07988288}, {995,0.07881982}, {1000,0.07828829}, {1010,0.07942342}, {1020,0.07827027}, {1030,0.07681081}, {1040,0.07711712}, {1050,0.08271171}, {1060,0.08275676}, {1070,0.08500901}, {1080,0.08468468}, {1090,0.08463964}, {1100,0.08637838}, {1110,0.08782883}, {1120,0.08713514}, {1130,0.08949550}, {1140,0.09039640}, {1150,0.08918919}, {1160,0.09332432}, {1170,0.09042342}, {1180,0.09181982}, {1190,0.09368468}, {1200,0.09395495}, {1210,0.09681982}, {1220,0.09533333}, {1230,0.09725225}, {1240,0.09749550}, {1250,0.09884685}, {1260,0.09920721}, {1270,0.10136036}, {1280,0.09875676}, {1290,0.09961261}, {1300,0.10113514}, {1310,0.10076577}, {1320,0.10404505}, {1330,0.10618018}, {1340,0.10688288}, {1350,0.10786486}, {1360,0.10790991}, {1370,0.11017117}, {1380,0.10736036}, {1390,0.11093694}, {1400,0.10975676}, {1410,0.10969369}, {1420,0.11048649}, {1430,0.11293694}, {1440,0.11151351}, {1450,0.11372072}, {1460,0.11651351}, {1470,0.11813514}, {1480,0.11690090}, {1490,0.11902703}, {1500,0.12016216}, {1510,0.12037838}, {1520,0.11925225}, {1530,0.12211712}, {1540,0.12021622}, {1550,0.12181982}, {1560,0.12144144}, {1570,0.12192793}, {1580,0.12345045}, {1590,0.12685586}, {1600,0.12297297}, {1610,0.12556757}, {1620,0.12505405}, {1630,0.12790991}, {1640,0.12581982}, {1650,0.12764865}, {1660,0.12994595}, {1670,0.12980180}, {1680,0.12859459}, {1690,0.13298198}, {1700,0.13757658}, {1710,0.13588288}, {1720,0.13590991}, {1730,0.13992793}, {1740,0.13807207}, {1750,0.13838739}, {1760,0.13946847}, {1770,0.14079279}, {1780,0.14290090}, {1790,0.14254955}, {1800,0.13922523}, {1810,0.14142342}, {1820,0.14367568}, {1830,0.14442342}, {1840,0.14932432}, {1850,0.14506306}, {1860,0.14515315}, {1870,0.14928829}, {1880,0.14873874}, {1890,0.15048649}, {1900,0.14990991}, {1910,0.15506306}, {1920,0.14726126}, {1930,0.15325225}, {1940,0.15226126}, {1950,0.15628829}, {1960,0.15640541}, {1970,0.15689189}, {1980,0.16285586}, {1990,0.15668468}, {2000,0.15766667}, {2050,0.16357658}, {2100,0.16481081}, {2150,0.16845946}, {2200,0.16972072}, {2250,0.17573874}, {2300,0.18445045}, {2350,0.19371171}, {2400,0.18792793}, {2450,0.19288288}, {2500,1.46147748}, {2550,0.20823423}, {2600,0.21817117}, {2650,0.21320721}, {2700,0.21163063}, {2750,0.22609910}, {2800,0.22154054}, {2850,0.22311712}, {2900,0.23051351}, {2950,0.23570270}, {3000,0.24043243}, {3050,0.24534234}, {3100,0.24546847}, {3150,0.25145045}, {3200,0.24584685}, {3250,0.25536036}, {3300,0.26018919}, {3350,0.26318919}, {3400,0.26522523}, {3450,0.28401802}, {3500,0.28000901}, {3550,0.28721622}, {3600,0.28057658}, {3650,0.28810811}, {3700,0.29253153}, {3750,0.29877477}, {3800,0.30423423}, {3850,0.30484685}, {3900,0.31399099}, {3950,0.31993694}, {4000,0.31574775}, {4050,0.32159459}, {4100,0.31863063}, {4150,0.33753153}, {4200,0.32890991}, {4250,0.34960360}, {4300,0.34315315}, {4350,0.35885586}, {4400,0.34876577}, {4450,0.35791892}, {4500,0.36820721}, {4550,0.36163964}, {4600,0.37253153}, {4650,0.37120721}, {4700,0.37757658}, {4750,0.37767568}, {4800,0.38430631}, {4850,0.39583784}, {4900,0.39597297}, {4950,0.40455856}, {5000,0.39894595}, {5050,0.41568468}, {5100,0.41341441}, {5150,0.41739640}, {5200,0.40179279}, {5250,0.41581081}, {5300,0.43371171}, {5350,0.43468468}, {5400,0.43161261}, {5450,0.44148649}, {5500,0.45330631}, {5550,0.47182883}, {5600,0.44804505}, {5650,0.45118018}, {5700,0.45517117}, {5750,0.46687387}, {5800,0.47770270}, {5850,0.48304505}, {5900,0.46986486}, {5950,0.47900901}, {6000,0.48287387}, {6050,0.48650}, {6100,0.50550}, {6150,0.49575}, {6200,0.50150}, {6250,0.51575}, {6300,0.50975}, {6350,0.52075}, {6400,0.49425}, {6450,0.52075}, {6500,0.51975}, {6550,0.52625}, {6600,0.53000}, {6650,0.55025}, {6700,0.54175}, {6750,0.55600}, {6800,0.54400}, {6850,0.54825}, {6900,0.57925}, {6950,0.56500}, {7000,0.56950}, {7050,0.56600}, {7100,0.57700}, {7150,0.59550}, {7200,0.58500}, {7250,0.59050}, {7300,0.57725}, {7350,0.61900}, {7400,0.59750}, {7450,0.61250}, {7500,0.63250}, {7550,0.63200}, {7600,0.62050}, {7650,0.64350}, {7700,0.62600}, {7750,0.63575}, {7800,0.64150}, {7850,0.65500}, {7900,0.65200}, {7950,0.64850}, {8000,0.64500}, {8050,0.67000}, {8100,0.66950}, {8150,0.68250}, {8200,0.64700}, {8250,0.67550}, {8300,0.67100}, {8350,0.70300}, {8400,0.67200}, {8450,0.69400}, {8500,0.68825}, {8550,0.70600}, {8600,0.71900}, {8650,0.70425}, {8700,0.73350}, {8750,0.73775}, {8800,0.71650}, {8850,0.72075}, {8900,0.72425}, {8950,0.75375}, {9000,0.74250}, {9050,0.76050}, {9100,0.75750}, {9150,0.79575}, {9200,0.78575}, {9250,0.74775}, {9300,0.76050}, {9350,0.76850}, {9400,0.77500}, {9450,0.78225}, {9500,0.76275}, {9550,0.79750}, {9600,0.75925}, {9650,0.81400}, {9700,0.80175}, {9750,0.80275}, {9800,0.79825}, {9850,0.84075}, {9900,0.82050}, {9950,0.82725}, {10000,0.83725}, {10100,0.85400}, {10200,0.86800}, {10300,0.85100}, {10400,0.84250}, {10500,0.85000}, {10600,0.88250}, {10700,0.88600}, {10800,0.87600}, {10900,0.91475}, {11000,0.93050}, {11100,0.92875}, {11200,0.91725}, {11300,0.94225}, {11400,0.92200}, {11500,0.95300}, {11600,0.95675}, {11700,0.98750}, {11800,0.96475}, {11900,1.00900}, {12000,0.99175}, {12100,1.00475}, {12200,1.05650}, {12300,0.99075}, {12400,1.02925}, {12500,1.05725}, {12600,1.05700}, {12700,1.06625}, {12800,1.04800}, {12900,1.08025}, {13000,1.08250}, {13100,1.09300}, {13200,1.09950}, {13300,1.12500}, {13400,1.10875}, {13500,1.13975}, {13600,1.10450}, {13700,1.13125}, {13800,1.18225}, {13900,1.15350}, {14000,1.17050}, {14100,1.17775}, {14200,1.21850}, {14300,1.27200}, {14400,1.15600}, {14500,1.21300}, {14600,1.19700}, {14700,1.23925}, {14800,1.27775}, {14900,1.23675}, {15000,1.26100}, {15100,1.29775}, {15200,1.25900}, {15300,1.30925}, {15400,1.26400}, {15500,1.28275}, {15600,1.31700}, {15700,1.32375}, {15800,1.34300}, {15900,1.38600}, {16000,1.29975}, {16100,1.40800}, {16200,1.35575}, {16300,1.44150}, {16400,1.33000}, {16500,1.38550}, {16600,1.37150}, {16700,1.41900}, {16800,1.38175}, {16900,1.36150}, {17000,1.41000}, {17100,1.46775}, {17200,1.41975}, {17300,1.44650}, {17400,1.48925}, {17500,1.51200}, {17600,1.43025}, {17700,1.46375}, {17800,1.47000}, {17900,1.54150}, {18000,1.49750}, {18100,1.55350}, {18200,1.53325}, {18300,1.58875}, {18400,1.55075}, {18500,1.51750}, {18600,1.54500}, {18700,1.56250}, {18800,1.58425}, {18900,1.59700}, {19000,1.58550}, {19100,1.65750}, {19200,1.57300}, {19300,1.62650}, {19400,1.64425}, {19500,1.63450}, {19600,1.62675}, {19700,1.73575}, {19800,1.66850}, {19900,1.70825}, {20000,1.6225}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["norm reif"]["user"] = {{1,0.00018919}, {2,0.00020721}, {3,0.00036937}, {4,0.00044144}, {5,0.00048649}, {6,0.00050450}, {7,0.00044144}, {8,0.00067568}, {9,0.00072973}, {10,0.00054054}, {11,0.00088288}, {12,0.00079279}, {13,0.00094595}, {14,0.00102703}, {15,0.00110811}, {16,0.00127928}, {17,0.00132432}, {18,0.00157658}, {19,0.00150450}, {20,0.00148649}, {21,0.00153153}, {22,0.00153153}, {23,0.00168468}, {24,0.00172072}, {25,0.00174775}, {26,0.00178378}, {27,0.00204505}, {28,0.00194595}, {29,0.00199099}, {30,0.00209910}, {31,0.00230631}, {32,0.00202703}, {33,0.00223423}, {34,0.00225225}, {35,0.00262162}, {36,0.00195495}, {37,0.00277477}, {38,0.00266667}, {39,0.00245045}, {40,0.00246847}, {41,0.00291892}, {42,0.00281081}, {43,0.00301802}, {44,0.00306306}, {45,0.00319820}, {46,0.00318919}, {47,0.00318919}, {48,0.00309910}, {49,0.00326126}, {50,0.00336036}, {51,0.00347748}, {52,0.00354054}, {53,0.00350450}, {54,0.00377477}, {55,0.00359459}, {56,0.00368468}, {57,0.00390991}, {58,0.00388288}, {59,0.00383784}, {60,0.00395495}, {61,0.00438739}, {62,0.00413514}, {63,0.00424324}, {64,0.00443243}, {65,0.00455856}, {66,0.00428829}, {67,0.00456757}, {68,0.00464865}, {69,0.00472973}, {70,0.00504505}, {71,0.00516216}, {72,0.00600901}, {73,0.00506306}, {74,0.00506306}, {75,0.00523423}, {76,0.00565766}, {77,0.00512613}, {78,0.00665766}, {79,0.00541441}, {80,0.00562162}, {81,0.00533333}, {82,0.00580180}, {83,0.00592793}, {84,0.00682883}, {85,0.00595495}, {86,0.00645045}, {87,0.00636937}, {88,0.00654955}, {89,0.00651351}, {90,0.00652252}, {91,0.00658559}, {92,0.00630631}, {93,0.00652252}, {94,0.00681081}, {95,0.00712613}, {96,0.00670270}, {97,0.00726126}, {98,0.00721622}, {99,0.00701802}, {100,0.00701802}, {101,0.00760360}, {102,0.00727928}, {103,0.00782883}, {104,0.00844144}, {105,0.00768468}, {106,0.00736937}, {107,0.00780180}, {108,0.00772973}, {109,0.00795495}, {110,0.00799099}, {111,0.00824324}, {112,0.00825225}, {113,0.00905405}, {114,0.00832432}, {115,0.00854955}, {116,0.00869369}, {117,0.00881982}, {118,0.00844144}, {119,0.00883784}, {120,0.00871171}, {121,0.00876577}, {122,0.00887387}, {123,0.00890991}, {124,0.00927928}, {125,0.00910811}, {126,0.00896396}, {127,0.00926126}, {128,0.00915315}, {129,0.00914414}, {130,0.00927027}, {131,0.00962162}, {132,0.00954054}, {133,0.01063063}, {134,0.00996396}, {135,0.00986486}, {136,0.00981982}, {137,0.01070270}, {138,0.00978378}, {139,0.00988288}, {140,0.00987387}, {141,0.01000000}, {142,0.01043243}, {143,0.01030631}, {144,0.01092793}, {145,0.01021622}, {146,0.01022523}, {147,0.01030631}, {148,0.01054054}, {149,0.01088288}, {150,0.01054054}, {151,0.01081982}, {152,0.01085586}, {153,0.01075676}, {154,0.01177477}, {155,0.01093694}, {156,0.01116216}, {157,0.01118018}, {158,0.01105405}, {159,0.01138739}, {160,0.01125225}, {161,0.01159459}, {162,0.01157658}, {163,0.01186486}, {164,0.01165766}, {165,0.01169369}, {166,0.01190090}, {167,0.01195495}, {168,0.01194595}, {169,0.01207207}, {170,0.01222523}, {171,0.01243243}, {172,0.01230631}, {173,0.01272072}, {174,0.01278378}, {175,0.01299099}, {176,0.01273874}, {177,0.01252252}, {178,0.01299099}, {179,0.01326126}, {180,0.01313514}, {181,0.01313514}, {182,0.01329730}, {183,0.01365766}, {184,0.01311712}, {185,0.01340541}, {186,0.01356757}, {187,0.01469369}, {188,0.01392793}, {189,0.01395495}, {190,0.01423423}, {191,0.01405405}, {192,0.01414414}, {193,0.01411712}, {194,0.01385586}, {195,0.01568468}, {196,0.01410811}, {197,0.01459459}, {198,0.01462162}, {199,0.01427928}, {200,0.01453153}, {201,0.01457658}, {202,0.01454955}, {203,0.01617117}, {204,0.01495495}, {205,0.01518919}, {206,0.01548649}, {207,0.01545045}, {208,0.01619820}, {209,0.01535135}, {210,0.01574775}, {211,0.01552252}, {212,0.01559459}, {213,0.01578378}, {214,0.01575676}, {215,0.01586486}, {216,0.01575676}, {217,0.01599099}, {218,0.01609910}, {219,0.01619820}, {220,0.01700901}, {221,0.01634234}, {222,0.01635135}, {223,0.01644144}, {224,0.01608108}, {225,0.01638739}, {226,0.01647748}, {227,0.01733333}, {228,0.01683784}, {229,0.01685586}, {230,0.01661261}, {231,0.01683784}, {232,0.01659459}, {233,0.01698198}, {234,0.01718919}, {235,0.01712613}, {236,0.01784685}, {237,0.01738739}, {238,0.01824324}, {239,0.01745946}, {240,0.01748649}, {241,0.01734234}, {242,0.01741441}, {243,0.01744144}, {244,0.01765766}, {245,0.01766667}, {246,0.01770270}, {247,0.01823423}, {248,0.01760360}, {249,0.01885586}, {250,0.01806306}, {251,0.01930631}, {252,0.01818919}, {253,0.01946847}, {254,0.01838739}, {255,0.01962162}, {256,0.01794595}, {257,0.01918018}, {258,0.01826126}, {259,0.01959459}, {260,0.01850450}, {261,0.02008108}, {262,0.01855856}, {263,0.02050450}, {264,0.01871171}, {265,0.02020721}, {266,0.01895495}, {267,0.02100901}, {268,0.01895495}, {269,0.02065766}, {270,0.01927928}, {271,0.02068468}, {272,0.01918919}, {273,0.02051351}, {274,0.01941441}, {275,0.02106306}, {276,0.01959459}, {277,0.02107207}, {278,0.01970270}, {279,0.02002703}, {280,0.01980180}, {281,0.02003604}, {282,0.01989189}, {283,0.02064865}, {284,0.02009910}, {285,0.02029730}, {286,0.02205405}, {287,0.02083784}, {288,0.02154054}, {289,0.02063063}, {290,0.02192793}, {291,0.02095495}, {292,0.02057658}, {293,0.02115315}, {294,0.02075676}, {295,0.02093694}, {296,0.02107207}, {297,0.02339640}, {298,0.02128829}, {299,0.02161261}, {300,0.02198198}, {301,0.02149550}, {302,0.02210811}, {303,0.02208108}, {304,0.02401802}, {305,0.02179279}, {306,0.02175676}, {307,0.02245045}, {308,0.02185586}, {309,0.02278378}, {310,0.02240541}, {311,0.02448649}, {312,0.02263063}, {313,0.02283784}, {314,0.02276577}, {315,0.02301802}, {316,0.02583784}, {317,0.02310811}, {318,0.02336036}, {319,0.02362162}, {320,0.02289189}, {321,0.02488288}, {322,0.02319820}, {323,0.02354054}, {324,0.02315315}, {325,0.02351351}, {326,0.02500000}, {327,0.02383784}, {328,0.02367568}, {329,0.02544144}, {330,0.02398198}, {331,0.02422523}, {332,0.02412613}, {333,0.02432432}, {334,0.02600000}, {335,0.02482883}, {336,0.02414414}, {337,0.02582883}, {338,0.02453153}, {339,0.02460360}, {340,0.02443243}, {341,0.02509910}, {342,0.02500901}, {343,0.02508108}, {344,0.02512613}, {345,0.02657658}, {346,0.02567568}, {347,0.02584685}, {348,0.02708108}, {349,0.02556757}, {350,0.02535135}, {351,0.02761261}, {352,0.02520721}, {353,0.02542342}, {354,0.02722523}, {355,0.02546847}, {356,0.02549550}, {357,0.02750450}, {358,0.02612613}, {359,0.02644144}, {360,0.02764865}, {361,0.02624324}, {362,0.02625225}, {363,0.02826126}, {364,0.02673874}, {365,0.02681081}, {366,0.02844144}, {367,0.02718018}, {368,0.02663063}, {369,0.02693694}, {370,0.02847748}, {371,0.02735135}, {372,0.02709910}, {373,0.02900901}, {374,0.02739640}, {375,0.02748649}, {376,0.02914414}, {377,0.02761261}, {378,0.02750450}, {379,0.02818919}, {380,0.02926126}, {381,0.02783784}, {382,0.02839640}, {383,0.03032432}, {384,0.02730631}, {385,0.02791892}, {386,0.02763964}, {387,0.02984685}, {388,0.02772973}, {389,0.02835135}, {390,0.02827027}, {391,0.03081081}, {392,0.02828829}, {393,0.02860360}, {394,0.03047748}, {395,0.02903604}, {396,0.02919820}, {397,0.02906306}, {398,0.03092793}, {399,0.02948649}, {400,0.02863063}, {401,0.02924324}, {402,0.03100901}, {403,0.03010811}, {404,0.02960360}, {405,0.02983784}, {406,0.03180180}, {407,0.03041441}, {408,0.02997297}, {409,0.03017117}, {410,0.03209910}, {411,0.03320721}, {412,0.03052252}, {413,0.03037838}, {414,0.03071171}, {415,0.03253153}, {416,0.03013514}, {417,0.03054054}, {418,0.03051351}, {419,0.03245045}, {420,0.03320721}, {421,0.03102703}, {422,0.03149550}, {423,0.03160360}, {424,0.03262162}, {425,0.03434234}, {426,0.03142342}, {427,0.03198198}, {428,0.03169369}, {429,0.03365766}, {430,0.03500901}, {431,0.03275676}, {432,0.03183784}, {433,0.03221622}, {434,0.03352252}, {435,0.03457658}, {436,0.03245946}, {437,0.03263964}, {438,0.03269369}, {439,0.03432432}, {440,0.03474775}, {441,0.03315315}, {442,0.03307207}, {443,0.03310811}, {444,0.03303604}, {445,0.03458559}, {446,0.03553153}, {447,0.03409009}, {448,0.03251351}, {449,0.03300901}, {450,0.03312613}, {451,0.03438739}, {452,0.03536937}, {453,0.03328829}, {454,0.03350450}, {455,0.03406306}, {456,0.03349550}, {457,0.03376577}, {458,0.03511712}, {459,0.03614414}, {460,0.03405405}, {461,0.03431532}, {462,0.03412613}, {463,0.03441441}, {464,0.03384685}, {465,0.03551351}, {466,0.03646847}, {467,0.03445946}, {468,0.03459459}, {469,0.03497297}, {470,0.03496396}, {471,0.03506306}, {472,0.03486486}, {473,0.03690090}, {474,0.03725225}, {475,0.03739640}, {476,0.03511712}, {477,0.03576577}, {478,0.03557658}, {479,0.03590090}, {480,0.03510811}, {481,0.03537838}, {482,0.03650450}, {483,0.03775676}, {484,0.03745045}, {485,0.03585586}, {486,0.03611712}, {487,0.03633333}, {488,0.03588288}, {489,0.03612613}, {490,0.03635135}, {491,0.03632432}, {492,0.03744144}, {493,0.03854054}, {494,0.03868468}, {495,0.03897297}, {496,0.03768468}, {497,0.03640541}, {498,0.03679279}, {499,0.03725225}, {500,0.03679279}, {505,0.03716216}, {510,0.03783784}, {515,0.03765766}, {520,0.03792793}, {525,0.03871171}, {530,0.03860360}, {535,0.03936937}, {540,0.03956757}, {545,0.03955856}, {550,0.04037838}, {555,0.04093694}, {560,0.04107207}, {565,0.04199099}, {570,0.04255856}, {575,0.04369369}, {580,0.04252252}, {585,0.04308108}, {590,0.04425225}, {595,0.04595495}, {600,0.04572973}, {605,0.04711712}, {610,0.04691892}, {615,0.04625225}, {620,0.04624324}, {625,0.04615315}, {630,0.05081081}, {635,0.05044144}, {640,0.04828829}, {645,0.04804505}, {650,0.04781081}, {655,0.04910811}, {660,0.05022523}, {665,0.05084685}, {670,0.04980180}, {675,0.05040541}, {680,0.05285586}, {685,0.05257658}, {690,0.05098198}, {695,0.05247748}, {700,0.05393694}, {705,0.05172072}, {710,0.05242342}, {715,0.05645946}, {720,0.05463063}, {725,0.05436937}, {730,0.05925225}, {735,0.05834234}, {740,0.05493694}, {745,0.05799099}, {750,0.05716216}, {755,0.06039640}, {760,0.05868468}, {765,0.05859459}, {770,0.06009009}, {775,0.05787387}, {780,0.06070270}, {785,0.06009009}, {790,0.06435135}, {795,0.06237838}, {800,0.05872072}, {805,0.06225225}, {810,0.06056757}, {815,0.06445045}, {820,0.06155856}, {825,0.06506306}, {830,0.06337838}, {835,0.06426126}, {840,0.06548649}, {845,0.06528829}, {850,0.06619820}, {855,0.06547748}, {860,0.06727928}, {865,0.06455856}, {870,0.06721622}, {875,0.06870270}, {880,0.06566667}, {885,0.07042342}, {890,0.06777477}, {895,0.07143243}, {900,0.06954955}, {905,0.06771171}, {910,0.07073874}, {915,0.07195495}, {920,0.06875676}, {925,0.07175676}, {930,0.07289189}, {935,0.07390991}, {940,0.07063063}, {945,0.07499099}, {950,0.07520721}, {955,0.07591892}, {960,0.07076577}, {965,0.07490090}, {970,0.07651351}, {975,0.07765766}, {980,0.07419820}, {985,0.07567568}, {990,0.07937838}, {995,0.07890090}, {1000,0.07836937}, {1010,0.07902703}, {1020,0.07798198}, {1030,0.07697297}, {1040,0.07719820}, {1050,0.08248649}, {1060,0.08268468}, {1070,0.08476577}, {1080,0.08485586}, {1090,0.08489189}, {1100,0.08589189}, {1110,0.08788288}, {1120,0.08734234}, {1130,0.08927928}, {1140,0.09010811}, {1150,0.08920721}, {1160,0.09316216}, {1170,0.09021622}, {1180,0.09149550}, {1190,0.09346847}, {1200,0.09341441}, {1210,0.09687387}, {1220,0.09506306}, {1230,0.09715315}, {1240,0.09726126}, {1250,0.09920721}, {1260,0.09918919}, {1270,0.10126126}, {1280,0.09881982}, {1290,0.09968468}, {1300,0.10085586}, {1310,0.10058559}, {1320,0.10373874}, {1330,0.10569369}, {1340,0.10655856}, {1350,0.10753153}, {1360,0.10763063}, {1370,0.11002703}, {1380,0.10722523}, {1390,0.11069369}, {1400,0.10960360}, {1410,0.10964865}, {1420,0.11031532}, {1430,0.11282883}, {1440,0.11141441}, {1450,0.11331532}, {1460,0.11593694}, {1470,0.11772973}, {1480,0.11666667}, {1490,0.11853153}, {1500,0.11973874}, {1510,0.12023423}, {1520,0.11881081}, {1530,0.12211712}, {1540,0.11991892}, {1550,0.12162162}, {1560,0.12142342}, {1570,0.12180180}, {1580,0.12318018}, {1590,0.12696396}, {1600,0.12292793}, {1610,0.12573874}, {1620,0.12516216}, {1630,0.12809910}, {1640,0.12602703}, {1650,0.12785586}, {1660,0.12989189}, {1670,0.12995495}, {1680,0.12859459}, {1690,0.13258559}, {1700,0.13727027}, {1710,0.13567568}, {1720,0.13581081}, {1730,0.14000901}, {1740,0.13827027}, {1750,0.13857658}, {1760,0.13942342}, {1770,0.14097297}, {1780,0.14281982}, {1790,0.14243243}, {1800,0.13964865}, {1810,0.14176577}, {1820,0.14391892}, {1830,0.14456757}, {1840,0.14921622}, {1850,0.14505405}, {1860,0.14501802}, {1870,0.14905405}, {1880,0.14845946}, {1890,0.15067568}, {1900,0.14993694}, {1910,0.15497297}, {1920,0.14706306}, {1930,0.15344144}, {1940,0.15260360}, {1950,0.15632432}, {1960,0.15621622}, {1970,0.15672973}, {1980,0.16304505}, {1990,0.15655856}, {2000,0.15750450}, {2050,0.16378378}, {2100,0.16494595}, {2150,0.16818919}, {2200,0.16975676}, {2250,0.17595495}, {2300,0.18400000}, {2350,0.19373874}, {2400,0.18768468}, {2450,0.19300901}, {2500,1.45919820}, {2550,0.20789189}, {2600,0.21794595}, {2650,0.21292793}, {2700,0.21144144}, {2750,0.22574775}, {2800,0.22111712}, {2850,0.22313514}, {2900,0.22989189}, {2950,0.23567568}, {3000,0.24009009}, {3050,0.24505405}, {3100,0.24524324}, {3150,0.25142342}, {3200,0.24577477}, {3250,0.25563063}, {3300,0.26007207}, {3350,0.26336937}, {3400,0.26516216}, {3450,0.28424324}, {3500,0.28016216}, {3550,0.28714414}, {3600,0.28058559}, {3650,0.28792793}, {3700,0.29270270}, {3750,0.29869369}, {3800,0.30438739}, {3850,0.30473874}, {3900,0.31379279}, {3950,0.31947748}, {4000,0.31547748}, {4050,0.32146847}, {4100,0.31863063}, {4150,0.33718919}, {4200,0.32871171}, {4250,0.34953153}, {4300,0.34334234}, {4350,0.35829730}, {4400,0.34859459}, {4450,0.35749550}, {4500,0.36795495}, {4550,0.36134234}, {4600,0.37248649}, {4650,0.37081081}, {4700,0.37750450}, {4750,0.37740541}, {4800,0.38420721}, {4850,0.39595495}, {4900,0.39585586}, {4950,0.40460360}, {5000,0.39852252}, {5050,0.41530631}, {5100,0.41367568}, {5150,0.41705405}, {5200,0.40171171}, {5250,0.41561261}, {5300,0.43391892}, {5350,0.43448649}, {5400,0.43177477}, {5450,0.44105405}, {5500,0.45310811}, {5550,0.47169369}, {5600,0.44787387}, {5650,0.45069369}, {5700,0.45465766}, {5750,0.46627027}, {5800,0.47702703}, {5850,0.48213514}, {5900,0.46927027}, {5950,0.47841441}, {6000,0.48240541}, {6050,0.48625}, {6100,0.50250}, {6150,0.49550}, {6200,0.50075}, {6250,0.51575}, {6300,0.51025}, {6350,0.52025}, {6400,0.49375}, {6450,0.51975}, {6500,0.51975}, {6550,0.52775}, {6600,0.53075}, {6650,0.54950}, {6700,0.54050}, {6750,0.55450}, {6800,0.54225}, {6850,0.54850}, {6900,0.57750}, {6950,0.56450}, {7000,0.56975}, {7050,0.56575}, {7100,0.57525}, {7150,0.59575}, {7200,0.58500}, {7250,0.59050}, {7300,0.57700}, {7350,0.61850}, {7400,0.59850}, {7450,0.61025}, {7500,0.63050}, {7550,0.63250}, {7600,0.61950}, {7650,0.64275}, {7700,0.62425}, {7750,0.63675}, {7800,0.64175}, {7850,0.65350}, {7900,0.65275}, {7950,0.64850}, {8000,0.64500}, {8050,0.66875}, {8100,0.66825}, {8150,0.68325}, {8200,0.64600}, {8250,0.67350}, {8300,0.67175}, {8350,0.70250}, {8400,0.67125}, {8450,0.69250}, {8500,0.68675}, {8550,0.70625}, {8600,0.71825}, {8650,0.70450}, {8700,0.73350}, {8750,0.73700}, {8800,0.71550}, {8850,0.72025}, {8900,0.72450}, {8950,0.75350}, {9000,0.74125}, {9050,0.76150}, {9100,0.75750}, {9150,0.79475}, {9200,0.78500}, {9250,0.74625}, {9300,0.76050}, {9350,0.76800}, {9400,0.77450}, {9450,0.78125}, {9500,0.76250}, {9550,0.79625}, {9600,0.76000}, {9650,0.81475}, {9700,0.80000}, {9750,0.80275}, {9800,0.79800}, {9850,0.83950}, {9900,0.81975}, {9950,0.82800}, {10000,0.83775}, {10100,0.85350}, {10200,0.86725}, {10300,0.85125}, {10400,0.84300}, {10500,0.85050}, {10600,0.88250}, {10700,0.88600}, {10800,0.87750}, {10900,0.91525}, {11000,0.92950}, {11100,0.92950}, {11200,0.91775}, {11300,0.94225}, {11400,0.92075}, {11500,0.95250}, {11600,0.95550}, {11700,0.98600}, {11800,0.96525}, {11900,1.00850}, {12000,0.99025}, {12100,1.00300}, {12200,1.05575}, {12300,0.98950}, {12400,1.02875}, {12500,1.05700}, {12600,1.05675}, {12700,1.06625}, {12800,1.05050}, {12900,1.08000}, {13000,1.08175}, {13100,1.09275}, {13200,1.10000}, {13300,1.12475}, {13400,1.10950}, {13500,1.13950}, {13600,1.10325}, {13700,1.13125}, {13800,1.18150}, {13900,1.15150}, {14000,1.17025}, {14100,1.17625}, {14200,1.21625}, {14300,1.27375}, {14400,1.15625}, {14500,1.21325}, {14600,1.19525}, {14700,1.23825}, {14800,1.27725}, {14900,1.23650}, {15000,1.26025}, {15100,1.29725}, {15200,1.25850}, {15300,1.30725}, {15400,1.26475}, {15500,1.28350}, {15600,1.31625}, {15700,1.32325}, {15800,1.34275}, {15900,1.38475}, {16000,1.29950}, {16100,1.40750}, {16200,1.35625}, {16300,1.44200}, {16400,1.32950}, {16500,1.38450}, {16600,1.37075}, {16700,1.41825}, {16800,1.38150}, {16900,1.36075}, {17000,1.41150}, {17100,1.46650}, {17200,1.41925}, {17300,1.44600}, {17400,1.48750}, {17500,1.51275}, {17600,1.43050}, {17700,1.46400}, {17800,1.47025}, {17900,1.54075}, {18000,1.49575}, {18100,1.55300}, {18200,1.53200}, {18300,1.58925}, {18400,1.55075}, {18500,1.51700}, {18600,1.54350}, {18700,1.56175}, {18800,1.58350}, {18900,1.59700}, {19000,1.58700}, {19100,1.65800}, {19200,1.57325}, {19300,1.62575}, {19400,1.64400}, {19500,1.63500}, {19600,1.62675}, {19700,1.73550}, {19800,1.66975}, {19900,1.70875}, {20000,1.6230}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["norm reif"]["system"] = {{1,0.00020721}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00002703}, {6,0.00003604}, {7,0.00000000}, {8,0.00003604}, {9,0.00003604}, {10,0.00003604}, {11,0.00000000}, {12,0.00003604}, {13,0.00000000}, {14,0.00000000}, {15,0.00003604}, {16,0.00002703}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00002703}, {25,0.00003604}, {26,0.00000000}, {27,0.00003604}, {28,0.00003604}, {29,0.00003604}, {30,0.00003604}, {31,0.00000000}, {32,0.00002703}, {33,0.00003604}, {34,0.00000000}, {35,0.00003604}, {36,0.00003604}, {37,0.00003604}, {38,0.00000000}, {39,0.00006306}, {40,0.00003604}, {41,0.00005405}, {42,0.00003604}, {43,0.00003604}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00003604}, {51,0.00000000}, {52,0.00003604}, {53,0.00000000}, {54,0.00000000}, {55,0.00003604}, {56,0.00000000}, {57,0.00003604}, {58,0.00003604}, {59,0.00000000}, {60,0.00007207}, {61,0.00000000}, {62,0.00002703}, {63,0.00000000}, {64,0.00000000}, {65,0.00003604}, {66,0.00000000}, {67,0.00002703}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00003604}, {73,0.00006306}, {74,0.00000000}, {75,0.00003604}, {76,0.00003604}, {77,0.00000000}, {78,0.00002703}, {79,0.00000000}, {80,0.00000000}, {81,0.00003604}, {82,0.00002703}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00003604}, {87,0.00002703}, {88,0.00009910}, {89,0.00000000}, {90,0.00007207}, {91,0.00003604}, {92,0.00006306}, {93,0.00000000}, {94,0.00003604}, {95,0.00000000}, {96,0.00003604}, {97,0.00003604}, {98,0.00000000}, {99,0.00002703}, {100,0.00006306}, {101,0.00003604}, {102,0.00000000}, {103,0.00000000}, {104,0.00003604}, {105,0.00000000}, {106,0.00003604}, {107,0.00002703}, {108,0.00003604}, {109,0.00003604}, {110,0.00007207}, {111,0.00000000}, {112,0.00000000}, {113,0.00002703}, {114,0.00000000}, {115,0.00000000}, {116,0.00003604}, {117,0.00000000}, {118,0.00000000}, {119,0.00003604}, {120,0.00000000}, {121,0.00003604}, {122,0.00003604}, {123,0.00000000}, {124,0.00003604}, {125,0.00000000}, {126,0.00002703}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00003604}, {131,0.00002703}, {132,0.00007207}, {133,0.00006306}, {134,0.00000000}, {135,0.00000000}, {136,0.00003604}, {137,0.00002703}, {138,0.00003604}, {139,0.00000000}, {140,0.00007207}, {141,0.00007207}, {142,0.00000000}, {143,0.00000000}, {144,0.00007207}, {145,0.00003604}, {146,0.00003604}, {147,0.00007207}, {148,0.00000000}, {149,0.00003604}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00007207}, {154,0.00002703}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00003604}, {159,0.00000000}, {160,0.00003604}, {161,0.00000000}, {162,0.00003604}, {163,0.00000000}, {164,0.00000000}, {165,0.00003604}, {166,0.00003604}, {167,0.00007207}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00003604}, {173,0.00003604}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00003604}, {178,0.00000000}, {179,0.00003604}, {180,0.00003604}, {181,0.00003604}, {182,0.00000000}, {183,0.00003604}, {184,0.00007207}, {185,0.00007207}, {186,0.00000000}, {187,0.00010811}, {188,0.00000000}, {189,0.00003604}, {190,0.00000000}, {191,0.00003604}, {192,0.00000000}, {193,0.00003604}, {194,0.00000000}, {195,0.00006306}, {196,0.00000000}, {197,0.00003604}, {198,0.00003604}, {199,0.00002703}, {200,0.00000000}, {201,0.00000000}, {202,0.00003604}, {203,0.00000000}, {204,0.00000000}, {205,0.00007207}, {206,0.00002703}, {207,0.00000000}, {208,0.00007207}, {209,0.00002703}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00003604}, {214,0.00000000}, {215,0.00003604}, {216,0.00000000}, {217,0.00007207}, {218,0.00003604}, {219,0.00007207}, {220,0.00000000}, {221,0.00000000}, {222,0.00007207}, {223,0.00007207}, {224,0.00003604}, {225,0.00000000}, {226,0.00000000}, {227,0.00003604}, {228,0.00000000}, {229,0.00003604}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00003604}, {235,0.00007207}, {236,0.00007207}, {237,0.00000000}, {238,0.00000000}, {239,0.00003604}, {240,0.00000000}, {241,0.00010811}, {242,0.00000000}, {243,0.00003604}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00007207}, {250,0.00007207}, {251,0.00009910}, {252,0.00003604}, {253,0.00006306}, {254,0.00000000}, {255,0.00007207}, {256,0.00000000}, {257,0.00014414}, {258,0.00000000}, {259,0.00000000}, {260,0.00003604}, {261,0.00010811}, {262,0.00002703}, {263,0.00003604}, {264,0.00000000}, {265,0.00003604}, {266,0.00007207}, {267,0.00009910}, {268,0.00007207}, {269,0.00003604}, {270,0.00000000}, {271,0.00007207}, {272,0.00000000}, {273,0.00000000}, {274,0.00010811}, {275,0.00010811}, {276,0.00003604}, {277,0.00010811}, {278,0.00000000}, {279,0.00000000}, {280,0.00003604}, {281,0.00003604}, {282,0.00003604}, {283,0.00000000}, {284,0.00003604}, {285,0.00003604}, {286,0.00017117}, {287,0.00003604}, {288,0.00007207}, {289,0.00003604}, {290,0.00014414}, {291,0.00003604}, {292,0.00007207}, {293,0.00003604}, {294,0.00007207}, {295,0.00000000}, {296,0.00000000}, {297,0.00007207}, {298,0.00000000}, {299,0.00010811}, {300,0.00000000}, {301,0.00003604}, {302,0.00000000}, {303,0.00000000}, {304,0.00002703}, {305,0.00000000}, {306,0.00003604}, {307,0.00006306}, {308,0.00003604}, {309,0.00003604}, {310,0.00000000}, {311,0.00020721}, {312,0.00007207}, {313,0.00000000}, {314,0.00000000}, {315,0.00007207}, {316,0.00003604}, {317,0.00003604}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00007207}, {322,0.00000000}, {323,0.00000000}, {324,0.00006306}, {325,0.00000000}, {326,0.00003604}, {327,0.00010811}, {328,0.00003604}, {329,0.00013514}, {330,0.00003604}, {331,0.00000000}, {332,0.00003604}, {333,0.00000000}, {334,0.00003604}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00003604}, {341,0.00000000}, {342,0.00002703}, {343,0.00000000}, {344,0.00000000}, {345,0.00016216}, {346,0.00000000}, {347,0.00007207}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00002703}, {352,0.00000000}, {353,0.00000000}, {354,0.00007207}, {355,0.00018018}, {356,0.00003604}, {357,0.00013514}, {358,0.00002703}, {359,0.00000000}, {360,0.00003604}, {361,0.00000000}, {362,0.00003604}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00003604}, {367,0.00000000}, {368,0.00003604}, {369,0.00000000}, {370,0.00007207}, {371,0.00000000}, {372,0.00003604}, {373,0.00003604}, {374,0.00000000}, {375,0.00003604}, {376,0.00005405}, {377,0.00000000}, {378,0.00003604}, {379,0.00000000}, {380,0.00010811}, {381,0.00007207}, {382,0.00000000}, {383,0.00006306}, {384,0.00006306}, {385,0.00000000}, {386,0.00007207}, {387,0.00003604}, {388,0.00003604}, {389,0.00000000}, {390,0.00002703}, {391,0.00000000}, {392,0.00003604}, {393,0.00003604}, {394,0.00013514}, {395,0.00002703}, {396,0.00000000}, {397,0.00007207}, {398,0.00003604}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00009910}, {403,0.00000000}, {404,0.00000000}, {405,0.00003604}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00010811}, {412,0.00007207}, {413,0.00003604}, {414,0.00000000}, {415,0.00014414}, {416,0.00003604}, {417,0.00007207}, {418,0.00003604}, {419,0.00003604}, {420,0.00003604}, {421,0.00003604}, {422,0.00000000}, {423,0.00000000}, {424,0.00007207}, {425,0.00002703}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00021622}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00010811}, {435,0.00007207}, {436,0.00000000}, {437,0.00002703}, {438,0.00003604}, {439,0.00003604}, {440,0.00007207}, {441,0.00000000}, {442,0.00003604}, {443,0.00007207}, {444,0.00007207}, {445,0.00003604}, {446,0.00000000}, {447,0.00000000}, {448,0.00003604}, {449,0.00002703}, {450,0.00000000}, {451,0.00003604}, {452,0.00010811}, {453,0.00007207}, {454,0.00003604}, {455,0.00000000}, {456,0.00000000}, {457,0.00007207}, {458,0.00017117}, {459,0.00009910}, {460,0.00007207}, {461,0.00000000}, {462,0.00007207}, {463,0.00003604}, {464,0.00002703}, {465,0.00000000}, {466,0.00000000}, {467,0.00003604}, {468,0.00007207}, {469,0.00000000}, {470,0.00003604}, {471,0.00003604}, {472,0.00000000}, {473,0.00007207}, {474,0.00007207}, {475,0.00010811}, {476,0.00000000}, {477,0.00002703}, {478,0.00007207}, {479,0.00007207}, {480,0.00000000}, {481,0.00000000}, {482,0.00010811}, {483,0.00024324}, {484,0.00007207}, {485,0.00002703}, {486,0.00000000}, {487,0.00003604}, {488,0.00003604}, {489,0.00006306}, {490,0.00003604}, {491,0.00000000}, {492,0.00006306}, {493,0.00013514}, {494,0.00003604}, {495,0.00007207}, {496,0.00023423}, {497,0.00003604}, {498,0.00000000}, {499,0.00000000}, {500,0.00007207}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00003604}, {525,0.00003604}, {530,0.00003604}, {535,0.00000000}, {540,0.00000000}, {545,0.00010811}, {550,0.00003604}, {555,0.00009910}, {560,0.00000000}, {565,0.00003604}, {570,0.00007207}, {575,0.00003604}, {580,0.00007207}, {585,0.00007207}, {590,0.00000000}, {595,0.00018018}, {600,0.00007207}, {605,0.00010811}, {610,0.00014414}, {615,0.00009910}, {620,0.00007207}, {625,0.00010811}, {630,0.00013514}, {635,0.00013514}, {640,0.00006306}, {645,0.00007207}, {650,0.00010811}, {655,0.00003604}, {660,0.00006306}, {665,0.00007207}, {670,0.00002703}, {675,0.00000000}, {680,0.00013514}, {685,0.00007207}, {690,0.00003604}, {695,0.00003604}, {700,0.00007207}, {705,0.00007207}, {710,0.00003604}, {715,0.00007207}, {720,0.00003604}, {725,0.00000000}, {730,0.00010811}, {735,0.00014414}, {740,0.00003604}, {745,0.00003604}, {750,0.00000000}, {755,0.00012613}, {760,0.00018018}, {765,0.00003604}, {770,0.00010811}, {775,0.00000000}, {780,0.00013514}, {785,0.00006306}, {790,0.00010811}, {795,0.00007207}, {800,0.00003604}, {805,0.00002703}, {810,0.00003604}, {815,0.00000000}, {820,0.00002703}, {825,0.00007207}, {830,0.00000000}, {835,0.00003604}, {840,0.00013514}, {845,0.00018018}, {850,0.00010811}, {855,0.00002703}, {860,0.00027928}, {865,0.00010811}, {870,0.00000000}, {875,0.00021622}, {880,0.00003604}, {885,0.00010811}, {890,0.00003604}, {895,0.00010811}, {900,0.00012613}, {905,0.00000000}, {910,0.00007207}, {915,0.00018018}, {920,0.00010811}, {925,0.00010811}, {930,0.00010811}, {935,0.00010811}, {940,0.00013514}, {945,0.00023423}, {950,0.00018018}, {955,0.00003604}, {960,0.00000000}, {965,0.00000000}, {970,0.00006306}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00036036}, {995,0.00010811}, {1000,0.00006306}, {1010,0.00009910}, {1020,0.00010811}, {1030,0.00007207}, {1040,0.00003604}, {1050,0.00018018}, {1060,0.00021622}, {1070,0.00022523}, {1080,0.00009910}, {1090,0.00014414}, {1100,0.00021622}, {1110,0.00018018}, {1120,0.00003604}, {1130,0.00018018}, {1140,0.00017117}, {1150,0.00003604}, {1160,0.00024324}, {1170,0.00003604}, {1180,0.00013514}, {1190,0.00014414}, {1200,0.00020721}, {1210,0.00003604}, {1220,0.00027928}, {1230,0.00020721}, {1240,0.00028829}, {1250,0.00007207}, {1260,0.00014414}, {1270,0.00014414}, {1280,0.00014414}, {1290,0.00014414}, {1300,0.00021622}, {1310,0.00007207}, {1320,0.00007207}, {1330,0.00019820}, {1340,0.00009910}, {1350,0.00010811}, {1360,0.00020721}, {1370,0.00003604}, {1380,0.00014414}, {1390,0.00007207}, {1400,0.00014414}, {1410,0.00009910}, {1420,0.00010811}, {1430,0.00009910}, {1440,0.00018018}, {1450,0.00014414}, {1460,0.00013514}, {1470,0.00018018}, {1480,0.00003604}, {1490,0.00009910}, {1500,0.00010811}, {1510,0.00010811}, {1520,0.00025225}, {1530,0.00018018}, {1540,0.00014414}, {1550,0.00018018}, {1560,0.00021622}, {1570,0.00007207}, {1580,0.00018018}, {1590,0.00018018}, {1600,0.00017117}, {1610,0.00009910}, {1620,0.00009910}, {1630,0.00010811}, {1640,0.00009910}, {1650,0.00003604}, {1660,0.00018018}, {1670,0.00017117}, {1680,0.00010811}, {1690,0.00014414}, {1700,0.00028829}, {1710,0.00010811}, {1720,0.00013514}, {1730,0.00006306}, {1740,0.00014414}, {1750,0.00014414}, {1760,0.00018018}, {1770,0.00010811}, {1780,0.00025225}, {1790,0.00014414}, {1800,0.00007207}, {1810,0.00009910}, {1820,0.00010811}, {1830,0.00010811}, {1840,0.00010811}, {1850,0.00010811}, {1860,0.00003604}, {1870,0.00007207}, {1880,0.00010811}, {1890,0.00003604}, {1900,0.00003604}, {1910,0.00010811}, {1920,0.00006306}, {1930,0.00010811}, {1940,0.00007207}, {1950,0.00018018}, {1960,0.00012613}, {1970,0.00007207}, {1980,0.00003604}, {1990,0.00010811}, {2000,0.00014414}, {2050,0.00010811}, {2100,0.00007207}, {2150,0.00010811}, {2200,0.00010811}, {2250,0.00010811}, {2300,0.00018018}, {2350,0.00018018}, {2400,0.00007207}, {2450,0.00000000}, {2500,0.00206306}, {2550,0.00010811}, {2600,0.00003604}, {2650,0.00007207}, {2700,0.00003604}, {2750,0.00007207}, {2800,0.00010811}, {2850,0.00014414}, {2900,0.00006306}, {2950,0.00014414}, {3000,0.00002703}, {3050,0.00010811}, {3100,0.00003604}, {3150,0.00007207}, {3200,0.00007207}, {3250,0.00009910}, {3300,0.00007207}, {3350,0.00007207}, {3400,0.00007207}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00003604}, {3600,0.00003604}, {3650,0.00003604}, {3700,0.00003604}, {3750,0.00010811}, {3800,0.00000000}, {3850,0.00003604}, {3900,0.00003604}, {3950,0.00021622}, {4000,0.00020721}, {4050,0.00014414}, {4100,0.00003604}, {4150,0.00020721}, {4200,0.00000000}, {4250,0.00010811}, {4300,0.00003604}, {4350,0.00000000}, {4400,0.00003604}, {4450,0.00003604}, {4500,0.00007207}, {4550,0.00002703}, {4600,0.00007207}, {4650,0.00003604}, {4700,0.00003604}, {4750,0.00007207}, {4800,0.00007207}, {4850,0.00002703}, {4900,0.00020721}, {4950,0.00016216}, {5000,0.00038739}, {5050,0.00010811}, {5100,0.00003604}, {5150,0.00007207}, {5200,0.00009910}, {5250,0.00007207}, {5300,0.00010811}, {5350,0.00010811}, {5400,0.00000000}, {5450,0.00014414}, {5500,0.00003604}, {5550,0.00007207}, {5600,0.00000000}, {5650,0.00021622}, {5700,0.00009910}, {5750,0.00035135}, {5800,0.00053153}, {5850,0.00036036}, {5900,0.00056757}, {5950,0.00032432}, {6000,0.00035135}, {6050,0.00000}, {6100,0.00100}, {6150,0.00100}, {6200,0.00200}, {6250,0.00000}, {6300,0.00000}, {6350,0.00100}, {6400,0.00100}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00100}, {6800,0.00075}, {6850,0.00000}, {6900,0.00200}, {6950,0.00000}, {7000,0.00100}, {7050,0.00000}, {7100,0.00100}, {7150,0.00000}, {7200,0.00000}, {7250,0.00100}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00100}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00100}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00100}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00100}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00075}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000901}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00197297}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["post"]["user"] = {{1,0.00003604}, {2,0.00007207}, {3,0.00000000}, {4,0.00002703}, {5,0.00000000}, {6,0.00015315}, {7,0.00006306}, {8,0.00002703}, {9,0.00003604}, {10,0.00002703}, {11,0.00000000}, {12,0.00005405}, {13,0.00000000}, {14,0.00002703}, {15,0.00003604}, {16,0.00002703}, {17,0.00002703}, {18,0.00006306}, {19,0.00000000}, {20,0.00009009}, {21,0.00002703}, {22,0.00003604}, {23,0.00002703}, {24,0.00002703}, {25,0.00009009}, {26,0.00000000}, {27,0.00008108}, {28,0.00012613}, {29,0.00002703}, {30,0.00003604}, {31,0.00006306}, {32,0.00002703}, {33,0.00003604}, {34,0.00002703}, {35,0.00006306}, {36,0.00000000}, {37,0.00000000}, {38,0.00002703}, {39,0.00006306}, {40,0.00009910}, {41,0.00002703}, {42,0.00002703}, {43,0.00002703}, {44,0.00002703}, {45,0.00002703}, {46,0.00002703}, {47,0.00002703}, {48,0.00000000}, {49,0.00000000}, {50,0.00003604}, {51,0.00006306}, {52,0.00002703}, {53,0.00000000}, {54,0.00010811}, {55,0.00006306}, {56,0.00000000}, {57,0.00000000}, {58,0.00003604}, {59,0.00003604}, {60,0.00000000}, {61,0.00009009}, {62,0.00005405}, {63,0.00009910}, {64,0.00003604}, {65,0.00000000}, {66,0.00009910}, {67,0.00003604}, {68,0.00000000}, {69,0.00000000}, {70,0.00003604}, {71,0.00012613}, {72,0.00000000}, {73,0.00002703}, {74,0.00000000}, {75,0.00007207}, {76,0.00000000}, {77,0.00009009}, {78,0.00000000}, {79,0.00000000}, {80,0.00002703}, {81,0.00000000}, {82,0.00000000}, {83,0.00007207}, {84,0.00000000}, {85,0.00000000}, {86,0.00006306}, {87,0.00002703}, {88,0.00000000}, {89,0.00009009}, {90,0.00002703}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00006306}, {95,0.00003604}, {96,0.00007207}, {97,0.00002703}, {98,0.00003604}, {99,0.00005405}, {100,0.00000000}, {101,0.00000000}, {102,0.00005405}, {103,0.00003604}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00002703}, {110,0.00003604}, {111,0.00000000}, {112,0.00006306}, {113,0.00002703}, {114,0.00003604}, {115,0.00002703}, {116,0.00000000}, {117,0.00012613}, {118,0.00003604}, {119,0.00007207}, {120,0.00003604}, {121,0.00005405}, {122,0.00000000}, {123,0.00002703}, {124,0.00002703}, {125,0.00003604}, {126,0.00002703}, {127,0.00000000}, {128,0.00000000}, {129,0.00002703}, {130,0.00002703}, {131,0.00003604}, {132,0.00003604}, {133,0.00000000}, {134,0.00005405}, {135,0.00006306}, {136,0.00000000}, {137,0.00003604}, {138,0.00002703}, {139,0.00003604}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00006306}, {145,0.00002703}, {146,0.00000000}, {147,0.00005405}, {148,0.00006306}, {149,0.00000000}, {150,0.00006306}, {151,0.00006306}, {152,0.00007207}, {153,0.00000000}, {154,0.00000000}, {155,0.00003604}, {156,0.00002703}, {157,0.00012613}, {158,0.00007207}, {159,0.00000000}, {160,0.00003604}, {161,0.00003604}, {162,0.00003604}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00009009}, {167,0.00009910}, {168,0.00006306}, {169,0.00000000}, {170,0.00009910}, {171,0.00006306}, {172,0.00005405}, {173,0.00003604}, {174,0.00005405}, {175,0.00006306}, {176,0.00000000}, {177,0.00002703}, {178,0.00002703}, {179,0.00008108}, {180,0.00000000}, {181,0.00005405}, {182,0.00002703}, {183,0.00002703}, {184,0.00000000}, {185,0.00005405}, {186,0.00005405}, {187,0.00002703}, {188,0.00000000}, {189,0.00000000}, {190,0.00008108}, {191,0.00005405}, {192,0.00000000}, {193,0.00003604}, {194,0.00000000}, {195,0.00002703}, {196,0.00002703}, {197,0.00003604}, {198,0.00009009}, {199,0.00011712}, {200,0.00007207}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00002703}, {205,0.00006306}, {206,0.00000000}, {207,0.00000000}, {208,0.00005405}, {209,0.00002703}, {210,0.00000000}, {211,0.00002703}, {212,0.00000000}, {213,0.00000000}, {214,0.00015315}, {215,0.00000000}, {216,0.00002703}, {217,0.00002703}, {218,0.00000000}, {219,0.00006306}, {220,0.00000000}, {221,0.00002703}, {222,0.00005405}, {223,0.00000000}, {224,0.00005405}, {225,0.00006306}, {226,0.00000000}, {227,0.00005405}, {228,0.00002703}, {229,0.00002703}, {230,0.00002703}, {231,0.00008108}, {232,0.00006306}, {233,0.00002703}, {234,0.00005405}, {235,0.00009009}, {236,0.00000000}, {237,0.00000000}, {238,0.00002703}, {239,0.00000000}, {240,0.00002703}, {241,0.00005405}, {242,0.00000000}, {243,0.00002703}, {244,0.00000000}, {245,0.00003604}, {246,0.00000000}, {247,0.00003604}, {248,0.00003604}, {249,0.00003604}, {250,0.00000000}, {251,0.00002703}, {252,0.00005405}, {253,0.00005405}, {254,0.00003604}, {255,0.00003604}, {256,0.00002703}, {257,0.00000000}, {258,0.00002703}, {259,0.00002703}, {260,0.00002703}, {261,0.00002703}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00005405}, {268,0.00011712}, {269,0.00002703}, {270,0.00000000}, {271,0.00000000}, {272,0.00002703}, {273,0.00005405}, {274,0.00003604}, {275,0.00002703}, {276,0.00000000}, {277,0.00000000}, {278,0.00002703}, {279,0.00002703}, {280,0.00006306}, {281,0.00006306}, {282,0.00006306}, {283,0.00009910}, {284,0.00000000}, {285,0.00005405}, {286,0.00008108}, {287,0.00003604}, {288,0.00000000}, {289,0.00002703}, {290,0.00003604}, {291,0.00002703}, {292,0.00000000}, {293,0.00000000}, {294,0.00005405}, {295,0.00002703}, {296,0.00000000}, {297,0.00000000}, {298,0.00003604}, {299,0.00002703}, {300,0.00000000}, {301,0.00000000}, {302,0.00002703}, {303,0.00002703}, {304,0.00000000}, {305,0.00002703}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00002703}, {310,0.00008108}, {311,0.00002703}, {312,0.00005405}, {313,0.00003604}, {314,0.00003604}, {315,0.00002703}, {316,0.00002703}, {317,0.00002703}, {318,0.00000000}, {319,0.00002703}, {320,0.00003604}, {321,0.00002703}, {322,0.00005405}, {323,0.00002703}, {324,0.00000000}, {325,0.00000000}, {326,0.00002703}, {327,0.00000000}, {328,0.00000000}, {329,0.00003604}, {330,0.00005405}, {331,0.00003604}, {332,0.00003604}, {333,0.00000000}, {334,0.00003604}, {335,0.00003604}, {336,0.00003604}, {337,0.00000000}, {338,0.00003604}, {339,0.00006306}, {340,0.00006306}, {341,0.00002703}, {342,0.00002703}, {343,0.00013514}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00007207}, {349,0.00007207}, {350,0.00003604}, {351,0.00006306}, {352,0.00003604}, {353,0.00013514}, {354,0.00000000}, {355,0.00003604}, {356,0.00000000}, {357,0.00002703}, {358,0.00000000}, {359,0.00000000}, {360,0.00002703}, {361,0.00000000}, {362,0.00002703}, {363,0.00000000}, {364,0.00002703}, {365,0.00003604}, {366,0.00000000}, {367,0.00006306}, {368,0.00003604}, {369,0.00000000}, {370,0.00009910}, {371,0.00003604}, {372,0.00003604}, {373,0.00003604}, {374,0.00012613}, {375,0.00009009}, {376,0.00000000}, {377,0.00002703}, {378,0.00000000}, {379,0.00003604}, {380,0.00000000}, {381,0.00006306}, {382,0.00002703}, {383,0.00000000}, {384,0.00007207}, {385,0.00003604}, {386,0.00013514}, {387,0.00002703}, {388,0.00000000}, {389,0.00002703}, {390,0.00000000}, {391,0.00006306}, {392,0.00003604}, {393,0.00002703}, {394,0.00003604}, {395,0.00003604}, {396,0.00002703}, {397,0.00000000}, {398,0.00000000}, {399,0.00007207}, {400,0.00002703}, {401,0.00000000}, {402,0.00000000}, {403,0.00009009}, {404,0.00000000}, {405,0.00003604}, {406,0.00000000}, {407,0.00268468}, {408,0.00000000}, {409,0.00003604}, {410,0.00007207}, {411,0.00003604}, {412,0.00003604}, {413,0.00010811}, {414,0.00000000}, {415,0.00003604}, {416,0.00007207}, {417,0.00006306}, {418,0.00002703}, {419,0.00003604}, {420,0.00007207}, {421,0.00000000}, {422,0.00010811}, {423,0.00003604}, {424,0.00006306}, {425,0.00010811}, {426,0.00003604}, {427,0.00003604}, {428,0.00003604}, {429,0.00000000}, {430,0.00005405}, {431,0.00003604}, {432,0.00000000}, {433,0.00000000}, {434,0.00002703}, {435,0.00007207}, {436,0.00006306}, {437,0.00000000}, {438,0.00003604}, {439,0.00000000}, {440,0.00003604}, {441,0.00007207}, {442,0.00005405}, {443,0.00002703}, {444,0.00005405}, {445,0.00009910}, {446,0.00003604}, {447,0.00002703}, {448,0.00000000}, {449,0.00006306}, {450,0.00006306}, {451,0.00002703}, {452,0.00000000}, {453,0.00003604}, {454,0.00000000}, {455,0.00002703}, {456,0.00002703}, {457,0.00000000}, {458,0.00003604}, {459,0.00000000}, {460,0.00002703}, {461,0.00005405}, {462,0.00000000}, {463,0.00002703}, {464,0.00010811}, {465,0.00006306}, {466,0.00007207}, {467,0.00000000}, {468,0.00000000}, {469,0.00003604}, {470,0.00002703}, {471,0.00007207}, {472,0.00012613}, {473,0.00000000}, {474,0.00000000}, {475,0.00002703}, {476,0.00007207}, {477,0.00000000}, {478,0.00003604}, {479,0.00000000}, {480,0.00006306}, {481,0.00000000}, {482,0.00000000}, {483,0.00006306}, {484,0.00000000}, {485,0.00006306}, {486,0.00000000}, {487,0.00003604}, {488,0.00003604}, {489,0.00009910}, {490,0.00006306}, {491,0.00000000}, {492,0.00002703}, {493,0.00003604}, {494,0.00003604}, {495,0.00003604}, {496,0.00007207}, {497,0.00003604}, {498,0.00005405}, {499,0.00003604}, {500,0.00003604}, {505,0.00002703}, {510,0.00002703}, {515,0.00000000}, {520,0.00003604}, {525,0.00003604}, {530,0.00000000}, {535,0.00003604}, {540,0.00002703}, {545,0.00006306}, {550,0.00000000}, {555,0.00006306}, {560,0.00002703}, {565,0.00000000}, {570,0.00000000}, {575,0.00002703}, {580,0.00000000}, {585,0.00000000}, {590,0.00010811}, {595,0.00000000}, {600,0.00000000}, {605,0.00002703}, {610,0.00000000}, {615,0.00002703}, {620,0.00000000}, {625,0.00003604}, {630,0.00007207}, {635,0.00000000}, {640,0.00000000}, {645,0.00008108}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00003604}, {670,0.00003604}, {675,0.00000000}, {680,0.00005405}, {685,0.00003604}, {690,0.00009910}, {695,0.00000000}, {700,0.00000000}, {705,0.00002703}, {710,0.00003604}, {715,0.00002703}, {720,0.00000000}, {725,0.00005405}, {730,0.00000000}, {735,0.00002703}, {740,0.00006306}, {745,0.00000000}, {750,0.00005405}, {755,0.00002703}, {760,0.00003604}, {765,0.00009009}, {770,0.00000000}, {775,0.00000000}, {780,0.00006306}, {785,0.00000000}, {790,0.00006306}, {795,0.00000000}, {800,0.00002703}, {805,0.00006306}, {810,0.00003604}, {815,0.00003604}, {820,0.00000000}, {825,0.00005405}, {830,0.00000000}, {835,0.00002703}, {840,0.00002703}, {845,0.00002703}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00011712}, {870,0.00006306}, {875,0.00006306}, {880,0.00002703}, {885,0.00002703}, {890,0.00000000}, {895,0.00005405}, {900,0.00002703}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00003604}, {925,0.00002703}, {930,0.00009910}, {935,0.00003604}, {940,0.00005405}, {945,0.00000000}, {950,0.00003604}, {955,0.00005405}, {960,0.00000000}, {965,0.00008108}, {970,0.00002703}, {975,0.00000000}, {980,0.00002703}, {985,0.00000000}, {990,0.00003604}, {995,0.00000000}, {1000,0.00006306}, {1010,0.00009910}, {1020,0.00005405}, {1030,0.00003604}, {1040,0.00002703}, {1050,0.00000000}, {1060,0.00003604}, {1070,0.00006306}, {1080,0.00006306}, {1090,0.00003604}, {1100,0.00000000}, {1110,0.00002703}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00002703}, {1150,0.00003604}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00009009}, {1200,0.00000000}, {1210,0.00002703}, {1220,0.00000000}, {1230,0.00009910}, {1240,0.00000000}, {1250,0.00002703}, {1260,0.00006306}, {1270,0.00002703}, {1280,0.00003604}, {1290,0.00009009}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00002703}, {1330,0.00000000}, {1340,0.00009009}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00005405}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00009009}, {1420,0.00009009}, {1430,0.00000000}, {1440,0.00002703}, {1450,0.00006306}, {1460,0.00006306}, {1470,0.00002703}, {1480,0.00003604}, {1490,0.00002703}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00012613}, {1560,0.00002703}, {1570,0.00002703}, {1580,0.00000000}, {1590,0.00002703}, {1600,0.00003604}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00003604}, {1660,0.00003604}, {1670,0.00006306}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00005405}, {1710,0.00005405}, {1720,0.00002703}, {1730,0.00000000}, {1740,0.00006306}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00006306}, {1800,0.00005405}, {1810,0.00002703}, {1820,0.00007207}, {1830,0.00000000}, {1840,0.00003604}, {1850,0.00003604}, {1860,0.00007207}, {1870,0.00002703}, {1880,0.00006306}, {1890,0.00002703}, {1900,0.00003604}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00006306}, {1940,0.00006306}, {1950,0.00000000}, {1960,0.00006306}, {1970,0.00003604}, {1980,0.00002703}, {1990,0.00009910}, {2000,0.00003604}, {2050,0.00003604}, {2100,0.00000000}, {2150,0.00002703}, {2200,0.00000000}, {2250,0.00003604}, {2300,0.00005405}, {2350,0.00002703}, {2400,0.00002703}, {2450,0.00007207}, {2500,0.00000000}, {2550,0.00013514}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00003604}, {2900,0.00000000}, {2950,0.00002703}, {3000,0.00002703}, {3050,0.00005405}, {3100,0.00000000}, {3150,0.00002703}, {3200,0.00003604}, {3250,0.00009910}, {3300,0.00003604}, {3350,0.00009910}, {3400,0.00006306}, {3450,0.00003604}, {3500,0.00006306}, {3550,0.00000000}, {3600,0.00007207}, {3650,0.00003604}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00003604}, {3950,0.00003604}, {4000,0.00013514}, {4050,0.00006306}, {4100,0.00003604}, {4150,0.00006306}, {4200,0.00006306}, {4250,0.00000000}, {4300,0.00010811}, {4350,0.00002703}, {4400,0.00000000}, {4450,0.00007207}, {4500,0.00006306}, {4550,0.00000000}, {4600,0.00009910}, {4650,0.00000000}, {4700,0.00005405}, {4750,0.00007207}, {4800,0.00003604}, {4850,0.00003604}, {4900,0.00002703}, {4950,0.00003604}, {5000,0.00006306}, {5050,0.00000000}, {5100,0.00007207}, {5150,0.00002703}, {5200,0.00002703}, {5250,0.00000000}, {5300,0.00003604}, {5350,0.00003604}, {5400,0.00003604}, {5450,0.00010811}, {5500,0.00003604}, {5550,0.00003604}, {5600,0.00002703}, {5650,0.00011712}, {5700,0.00003604}, {5750,0.00009910}, {5800,0.00005405}, {5850,0.00002703}, {5900,0.00003604}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00100}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00075}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00100}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00075}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00100}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00100}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00100}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00100}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00003604}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00003604}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00002703}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00003604}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00003604}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00003604}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00003604}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00003604}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00003604}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00003604}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["postprocess"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["postprocess"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00002703}, {4,0.00003604}, {5,0.00006306}, {6,0.00000000}, {7,0.00002703}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00003604}, {14,0.00000000}, {15,0.00002703}, {16,0.00003604}, {17,0.00007207}, {18,0.00002703}, {19,0.00003604}, {20,0.00003604}, {21,0.00000000}, {22,0.00003604}, {23,0.00000000}, {24,0.00000000}, {25,0.00002703}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003604}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00003604}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00002703}, {57,0.00002703}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00009009}, {62,0.00000000}, {63,0.00002703}, {64,0.00000000}, {65,0.00000000}, {66,0.00003604}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00003604}, {77,0.00003604}, {78,0.00000000}, {79,0.00000000}, {80,0.00003604}, {81,0.00002703}, {82,0.00000000}, {83,0.00000000}, {84,0.00002703}, {85,0.00000000}, {86,0.00003604}, {87,0.00000000}, {88,0.00000000}, {89,0.00003604}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00002703}, {96,0.00007207}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00002703}, {103,0.00000000}, {104,0.00003604}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00002703}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00002703}, {121,0.00005405}, {122,0.00000000}, {123,0.00000000}, {124,0.00002703}, {125,0.00003604}, {126,0.00000000}, {127,0.00000000}, {128,0.00002703}, {129,0.00000000}, {130,0.00005405}, {131,0.00000000}, {132,0.00000000}, {133,0.00005405}, {134,0.00000000}, {135,0.00003604}, {136,0.00002703}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00002703}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00003604}, {147,0.00000000}, {148,0.00000000}, {149,0.00007207}, {150,0.00007207}, {151,0.00003604}, {152,0.00000000}, {153,0.00003604}, {154,0.00007207}, {155,0.00006306}, {156,0.00000000}, {157,0.00003604}, {158,0.00002703}, {159,0.00005405}, {160,0.00000000}, {161,0.00002703}, {162,0.00002703}, {163,0.00000000}, {164,0.00005405}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00003604}, {170,0.00002703}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00002703}, {175,0.00000000}, {176,0.00000000}, {177,0.00002703}, {178,0.00000000}, {179,0.00000000}, {180,0.00003604}, {181,0.00000000}, {182,0.00000000}, {183,0.00002703}, {184,0.00008108}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00002703}, {189,0.00002703}, {190,0.00000000}, {191,0.00000000}, {192,0.00005405}, {193,0.00000000}, {194,0.00000000}, {195,0.00003604}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00002703}, {204,0.00000000}, {205,0.00000000}, {206,0.00005405}, {207,0.00002703}, {208,0.00000000}, {209,0.00005405}, {210,0.00000000}, {211,0.00002703}, {212,0.00000000}, {213,0.00002703}, {214,0.00000000}, {215,0.00002703}, {216,0.00000000}, {217,0.00003604}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00002703}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00002703}, {227,0.00006306}, {228,0.00007207}, {229,0.00000000}, {230,0.00002703}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00005405}, {239,0.00000000}, {240,0.00003604}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00002703}, {248,0.00000000}, {249,0.00002703}, {250,0.00002703}, {251,0.00006306}, {252,0.00000000}, {253,0.00000000}, {254,0.00002703}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00003604}, {259,0.00002703}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00002703}, {267,0.00002703}, {268,0.00000000}, {269,0.00002703}, {270,0.00002703}, {271,0.00002703}, {272,0.00008108}, {273,0.00005405}, {274,0.00003604}, {275,0.00000000}, {276,0.00011712}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00002703}, {282,0.00005405}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00006306}, {287,0.00002703}, {288,0.00000000}, {289,0.00000000}, {290,0.00006306}, {291,0.00002703}, {292,0.00003604}, {293,0.00000000}, {294,0.00000000}, {295,0.00002703}, {296,0.00002703}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00002703}, {301,0.00002703}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00002703}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00002703}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00003604}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00002703}, {325,0.00002703}, {326,0.00000000}, {327,0.00006306}, {328,0.00003604}, {329,0.00000000}, {330,0.00003604}, {331,0.00002703}, {332,0.00006306}, {333,0.00002703}, {334,0.00000000}, {335,0.00002703}, {336,0.00006306}, {337,0.00003604}, {338,0.00002703}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00002703}, {343,0.00000000}, {344,0.00007207}, {345,0.00000000}, {346,0.00003604}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00002703}, {352,0.00003604}, {353,0.00000000}, {354,0.00009009}, {355,0.00000000}, {356,0.00000000}, {357,0.00003604}, {358,0.00003604}, {359,0.00005405}, {360,0.00000000}, {361,0.00000000}, {362,0.00003604}, {363,0.00009009}, {364,0.00002703}, {365,0.00000000}, {366,0.00002703}, {367,0.00000000}, {368,0.00000000}, {369,0.00003604}, {370,0.00000000}, {371,0.00000000}, {372,0.00003604}, {373,0.00003604}, {374,0.00000000}, {375,0.00006306}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00003604}, {384,0.00002703}, {385,0.00007207}, {386,0.00000000}, {387,0.00002703}, {388,0.00000000}, {389,0.00006306}, {390,0.00002703}, {391,0.00002703}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00003604}, {397,0.00000000}, {398,0.00000000}, {399,0.00003604}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00002703}, {405,0.00006306}, {406,0.00003604}, {407,0.00000000}, {408,0.00000000}, {409,0.00003604}, {410,0.00005405}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00003604}, {423,0.00002703}, {424,0.00003604}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00003604}, {429,0.00003604}, {430,0.00002703}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00002703}, {435,0.00000000}, {436,0.00000000}, {437,0.00002703}, {438,0.00000000}, {439,0.00003604}, {440,0.00002703}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00003604}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00002703}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00006306}, {457,0.00002703}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00007207}, {471,0.00000000}, {472,0.00000000}, {473,0.00003604}, {474,0.00000000}, {475,0.00003604}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00003604}, {480,0.00003604}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00002703}, {485,0.00000000}, {486,0.00000000}, {487,0.00003604}, {488,0.00000000}, {489,0.00000000}, {490,0.00003604}, {491,0.00000000}, {492,0.00012613}, {493,0.00000000}, {494,0.00003604}, {495,0.00003604}, {496,0.00000000}, {497,0.00002703}, {498,0.00010811}, {499,0.00002703}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00003604}, {540,0.00002703}, {545,0.00000000}, {550,0.00002703}, {555,0.00003604}, {560,0.00000000}, {565,0.00000000}, {570,0.00009009}, {575,0.00000000}, {580,0.00006306}, {585,0.00000000}, {590,0.00000000}, {595,0.00003604}, {600,0.00000000}, {605,0.00007207}, {610,0.00000000}, {615,0.00000000}, {620,0.00003604}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00002703}, {695,0.00005405}, {700,0.00006306}, {705,0.00000000}, {710,0.00000000}, {715,0.00003604}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00005405}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00002703}, {775,0.00000000}, {780,0.00000000}, {785,0.00002703}, {790,0.00002703}, {795,0.00003604}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00002703}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00003604}, {855,0.00000000}, {860,0.00000000}, {865,0.00002703}, {870,0.00002703}, {875,0.00000000}, {880,0.00000000}, {885,0.00002703}, {890,0.00002703}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00007207}, {915,0.00002703}, {920,0.00003604}, {925,0.00002703}, {930,0.00000000}, {935,0.00000000}, {940,0.00002703}, {945,0.00000000}, {950,0.00002703}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00002703}, {985,0.00002703}, {990,0.00000000}, {995,0.00006306}, {1000,0.00000000}, {1010,0.00002703}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00002703}, {1100,0.00003604}, {1110,0.00002703}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00002703}, {1170,0.00000000}, {1180,0.00003604}, {1190,0.00002703}, {1200,0.00002703}, {1210,0.00002703}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00003604}, {1250,0.00003604}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00002703}, {1300,0.00002703}, {1310,0.00000000}, {1320,0.00003604}, {1330,0.00003604}, {1340,0.00000000}, {1350,0.00002703}, {1360,0.00000000}, {1370,0.00003604}, {1380,0.00002703}, {1390,0.00000000}, {1400,0.00003604}, {1410,0.00002703}, {1420,0.00000000}, {1430,0.00002703}, {1440,0.00000000}, {1450,0.00002703}, {1460,0.00005405}, {1470,0.00000000}, {1480,0.00008108}, {1490,0.00003604}, {1500,0.00000000}, {1510,0.00002703}, {1520,0.00002703}, {1530,0.00003604}, {1540,0.00005405}, {1550,0.00005405}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00003604}, {1610,0.00002703}, {1620,0.00002703}, {1630,0.00002703}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00002703}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00006306}, {1780,0.00000000}, {1790,0.00002703}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00003604}, {1850,0.00000000}, {1860,0.00003604}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00003604}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00002703}, {1950,0.00006306}, {1960,0.00000000}, {1970,0.00003604}, {1980,0.00000000}, {1990,0.00003604}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00007207}, {2200,0.00003604}, {2250,0.00002703}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00003604}, {2600,0.00002703}, {2650,0.00000000}, {2700,0.00007207}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00007207}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00002703}, {3150,0.00000000}, {3200,0.00002703}, {3250,0.00003604}, {3300,0.00000000}, {3350,0.00009910}, {3400,0.00000000}, {3450,0.00002703}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00003604}, {3650,0.00003604}, {3700,0.00000000}, {3750,0.00003604}, {3800,0.00000000}, {3850,0.00003604}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00003604}, {4150,0.00002703}, {4200,0.00000000}, {4250,0.00003604}, {4300,0.00000000}, {4350,0.00003604}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00007207}, {4600,0.00000000}, {4650,0.00003604}, {4700,0.00000000}, {4750,0.00003604}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00003604}, {4950,0.00000000}, {5000,0.00002703}, {5050,0.00002703}, {5100,0.00003604}, {5150,0.00003604}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00007207}, {5350,0.00000000}, {5400,0.00002703}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00003604}, {5650,0.00002703}, {5700,0.00002703}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00002703}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00100}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00075}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0015}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["postprocess"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00003604}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00003604}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00003604}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00003604}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00003604}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003604}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000901}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000901}, {149,0.00000901}, {150,0.00000000}, {151,0.00098198}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000901}, {157,0.00000000}, {158,0.00000000}, {159,0.00000901}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000901}, {164,0.00000000}, {165,0.00000901}, {166,0.00001802}, {167,0.00003604}, {168,0.00000901}, {169,0.00000901}, {170,0.00000000}, {171,0.00001802}, {172,0.00000901}, {173,0.00004505}, {174,0.00003604}, {175,0.00004505}, {176,0.00005405}, {177,0.00006306}, {178,0.00009009}, {179,0.00006306}, {180,0.00009910}, {181,0.00014414}, {182,0.00012613}, {183,0.00020721}, {184,0.00029730}, {185,0.00025225}, {186,0.00029730}, {187,0.00039640}, {188,0.00045946}, {189,0.00052252}, {190,0.00059459}, {191,0.00068468}, {192,0.00072072}, {193,0.00074775}, {194,0.00079279}, {195,0.00076577}, {196,0.00087387}, {197,0.00086486}, {198,0.00090991}, {199,0.00094595}, {200,0.00092793}, {201,0.00097297}, {202,0.00097297}, {203,0.00095495}, {204,0.00099099}, {205,0.00097297}, {206,0.00100000}, {207,0.00100000}, {208,0.00100000}, {209,0.00100000}, {210,0.00100000}, {211,0.00100000}, {212,0.00100000}, {213,0.00187387}, {214,0.00100000}, {215,0.00100000}, {216,0.00100000}, {217,0.00100000}, {218,0.00100000}, {219,0.00100000}, {220,0.00100000}, {221,0.00100000}, {222,0.00100000}, {223,0.00100000}, {224,0.00100000}, {225,0.00100000}, {226,0.00100000}, {227,0.00100000}, {228,0.00100000}, {229,0.00100000}, {230,0.00100000}, {231,0.00100000}, {232,0.00100000}, {233,0.00100000}, {234,0.00100000}, {235,0.00100000}, {236,0.00100000}, {237,0.00100000}, {238,0.00100000}, {239,0.00100000}, {240,0.00100000}, {241,0.00100000}, {242,0.00100000}, {243,0.00100000}, {244,0.00100000}, {245,0.00100000}, {246,0.00100000}, {247,0.00100000}, {248,0.00100000}, {249,0.00100000}, {250,0.00100000}, {251,0.00100000}, {252,0.00100000}, {253,0.00100000}, {254,0.00100000}, {255,0.00100000}, {256,0.00100000}, {257,0.00100000}, {258,0.00100000}, {259,0.00100000}, {260,0.00100000}, {261,0.00100000}, {262,0.00100000}, {263,0.00100000}, {264,0.00100000}, {265,0.00100000}, {266,0.00100000}, {267,0.00100000}, {268,0.00100000}, {269,0.00100000}, {270,0.00100000}, {271,0.00100000}, {272,0.00100000}, {273,0.00100000}, {274,0.00100000}, {275,0.00100000}, {276,0.00100000}, {277,0.00100000}, {278,0.00100000}, {279,0.00100000}, {280,0.00100000}, {281,0.00100000}, {282,0.00100000}, {283,0.00100000}, {284,0.00100000}, {285,0.00100000}, {286,0.00100000}, {287,0.00100000}, {288,0.00100000}, {289,0.00100000}, {290,0.00100000}, {291,0.00100000}, {292,0.00100000}, {293,0.00100000}, {294,0.00100000}, {295,0.00100000}, {296,0.00100000}, {297,0.00100000}, {298,0.00100000}, {299,0.00245946}, {300,0.00100000}, {301,0.00100000}, {302,0.00100000}, {303,0.00100000}, {304,0.00100000}, {305,0.00100000}, {306,0.00204505}, {307,0.00100000}, {308,0.00100000}, {309,0.00100000}, {310,0.00100000}, {311,0.00100000}, {312,0.00100000}, {313,0.00100000}, {314,0.00100000}, {315,0.00100000}, {316,0.00100000}, {317,0.00100000}, {318,0.00100000}, {319,0.00100000}, {320,0.00100000}, {321,0.00100000}, {322,0.00100000}, {323,0.00100000}, {324,0.00100000}, {325,0.00100000}, {326,0.00100000}, {327,0.00100000}, {328,0.00100000}, {329,0.00100000}, {330,0.00100000}, {331,0.00100000}, {332,0.00100000}, {333,0.00100000}, {334,0.00100000}, {335,0.00100000}, {336,0.00100000}, {337,0.00100000}, {338,0.00100000}, {339,0.00100000}, {340,0.00100000}, {341,0.00100000}, {342,0.00100000}, {343,0.00100000}, {344,0.00100000}, {345,0.00100000}, {346,0.00100000}, {347,0.00100000}, {348,0.00100000}, {349,0.00100000}, {350,0.00100000}, {351,0.00100000}, {352,0.00100000}, {353,0.00100000}, {354,0.00100000}, {355,0.00100000}, {356,0.00100000}, {357,0.00100000}, {358,0.00100000}, {359,0.00100000}, {360,0.00100000}, {361,0.00100000}, {362,0.00100000}, {363,0.00100000}, {364,0.00100000}, {365,0.00100000}, {366,0.00100000}, {367,0.00100000}, {368,0.00100000}, {369,0.00103604}, {370,0.00100000}, {371,0.00100000}, {372,0.00100000}, {373,0.00100000}, {374,0.00100000}, {375,0.00100000}, {376,0.00100000}, {377,0.00100000}, {378,0.00100000}, {379,0.00100000}, {380,0.00100000}, {381,0.00100000}, {382,0.00100000}, {383,0.00100000}, {384,0.00100000}, {385,0.00100000}, {386,0.00100000}, {387,0.00100000}, {388,0.00100000}, {389,0.00100000}, {390,0.00100000}, {391,0.00100000}, {392,0.00100000}, {393,0.00100000}, {394,0.00100000}, {395,0.00100000}, {396,0.00100000}, {397,0.00100000}, {398,0.00100000}, {399,0.00100000}, {400,0.00100000}, {401,0.00100000}, {402,0.00100000}, {403,0.00100000}, {404,0.00100000}, {405,0.00100000}, {406,0.00100000}, {407,0.00100000}, {408,0.00100000}, {409,0.00100901}, {410,0.00100000}, {411,0.00100000}, {412,0.00100000}, {413,0.00100000}, {414,0.00103604}, {415,0.00100000}, {416,0.00100000}, {417,0.00100000}, {418,0.00100000}, {419,0.00100000}, {420,0.00100000}, {421,0.00100000}, {422,0.00101802}, {423,0.00100000}, {424,0.00100000}, {425,0.00100000}, {426,0.00100000}, {427,0.00100000}, {428,0.00101802}, {429,0.00100000}, {430,0.00100000}, {431,0.00100000}, {432,0.00101802}, {433,0.00100000}, {434,0.00100901}, {435,0.00100901}, {436,0.00100901}, {437,0.00103604}, {438,0.00101802}, {439,0.00102703}, {440,0.00101802}, {441,0.00101802}, {442,0.00102703}, {443,0.00101802}, {444,0.00101802}, {445,0.00103604}, {446,0.00104505}, {447,0.00102703}, {448,0.00105405}, {449,0.00108108}, {450,0.00107207}, {451,0.00108108}, {452,0.00109009}, {453,0.00109009}, {454,0.00109910}, {455,0.00109009}, {456,0.00114414}, {457,0.00118018}, {458,0.00118018}, {459,0.00117117}, {460,0.00125225}, {461,0.00124324}, {462,0.00130631}, {463,0.00132432}, {464,0.00134234}, {465,0.00135135}, {466,0.00142342}, {467,0.00144144}, {468,0.00144144}, {469,0.00145045}, {470,0.00150450}, {471,0.00150450}, {472,0.00156757}, {473,0.00152252}, {474,0.00152252}, {475,0.00160360}, {476,0.00158559}, {477,0.00159459}, {478,0.00162162}, {479,0.00163063}, {480,0.00165766}, {481,0.00101802}, {482,0.00172973}, {483,0.00175676}, {484,0.00178378}, {485,0.00172973}, {486,0.00176577}, {487,0.00175676}, {488,0.00179279}, {489,0.00181081}, {490,0.00187387}, {491,0.00186486}, {492,0.00181982}, {493,0.00188288}, {494,0.00186486}, {495,0.00193694}, {496,0.00195495}, {497,0.00190991}, {498,0.00195495}, {499,0.00195495}, {500,0.00192793}, {505,0.00199099}, {510,0.00200000}, {515,0.00200000}, {520,0.00200000}, {525,0.00200000}, {530,0.00200000}, {535,0.00201802}, {540,0.00201802}, {545,0.00201802}, {550,0.00200000}, {555,0.00200000}, {560,0.00200000}, {565,0.00200000}, {570,0.00200000}, {575,0.00200000}, {580,0.00200000}, {585,0.00200000}, {590,0.00200000}, {595,0.00200000}, {600,0.00200000}, {605,0.00200000}, {610,0.00200000}, {615,0.00200000}, {620,0.00200000}, {625,0.00200000}, {630,0.00200000}, {635,0.00200000}, {640,0.00200000}, {645,0.00203604}, {650,0.00200000}, {655,0.00200000}, {660,0.00200000}, {665,0.00200000}, {670,0.00200000}, {675,0.00200000}, {680,0.00200000}, {685,0.00200901}, {690,0.00200000}, {695,0.00200000}, {700,0.00202703}, {705,0.00404505}, {710,0.00203604}, {715,0.00204505}, {720,0.00208108}, {725,0.00209910}, {730,0.00217117}, {735,0.00225225}, {740,0.00235135}, {745,0.00234234}, {750,0.00249550}, {755,0.00254054}, {760,0.00259459}, {765,0.00266667}, {770,0.00273874}, {775,0.00277477}, {780,0.00276577}, {785,0.00281081}, {790,0.00290090}, {795,0.00290991}, {800,0.00294595}, {805,0.00293694}, {810,0.00300000}, {815,0.00300000}, {820,0.00300000}, {825,0.00300000}, {830,0.00300000}, {835,0.00300000}, {840,0.00300000}, {845,0.00300000}, {850,0.00300000}, {855,0.00302703}, {860,0.00300000}, {865,0.00300000}, {870,0.00300000}, {875,0.00300000}, {880,0.00300000}, {885,0.00300000}, {890,0.00300000}, {895,0.00300000}, {900,0.00300000}, {905,0.00300000}, {910,0.00300000}, {915,0.00300000}, {920,0.00300000}, {925,0.00300000}, {930,0.00300000}, {935,0.00300000}, {940,0.00300000}, {945,0.00300000}, {950,0.00300000}, {955,0.00300000}, {960,0.00300901}, {965,0.00300901}, {970,0.00300901}, {975,0.00301802}, {980,0.00303604}, {985,0.00306306}, {990,0.00310811}, {995,0.00311712}, {1000,0.00320721}, {1010,0.00326126}, {1020,0.00341441}, {1030,0.00355856}, {1040,0.00653153}, {1050,0.00368468}, {1060,0.00374775}, {1070,0.00382883}, {1080,0.00387387}, {1090,0.00395495}, {1100,0.00398198}, {1110,0.00400000}, {1120,0.00400000}, {1130,0.00400000}, {1140,0.00400000}, {1150,0.00771171}, {1160,0.00400000}, {1170,0.00400000}, {1180,0.00400000}, {1190,0.00400901}, {1200,0.00400000}, {1210,0.00400901}, {1220,0.00400901}, {1230,0.00403604}, {1240,0.00400901}, {1250,0.00405405}, {1260,0.00406306}, {1270,0.00418919}, {1280,0.00425225}, {1290,0.00442342}, {1300,0.00444144}, {1310,0.00858559}, {1320,0.00461261}, {1330,0.00472072}, {1340,0.00468468}, {1350,0.00475676}, {1360,0.00482883}, {1370,0.00484685}, {1380,0.00493694}, {1390,0.00494595}, {1400,0.00500000}, {1410,0.00499099}, {1420,0.00500000}, {1430,0.00507207}, {1440,0.00500000}, {1450,0.00500000}, {1460,0.00500000}, {1470,0.00503604}, {1480,0.00502703}, {1490,0.00510811}, {1500,0.00508108}, {1510,0.00508108}, {1520,0.00511712}, {1530,0.00510811}, {1540,0.00521622}, {1550,0.00517117}, {1560,0.00541441}, {1570,0.00541441}, {1580,0.00553153}, {1590,0.00560360}, {1600,0.00564865}, {1610,0.00570270}, {1620,0.00971171}, {1630,0.01000000}, {1640,0.00953153}, {1650,0.01019820}, {1660,0.00962162}, {1670,0.00599099}, {1680,0.00596396}, {1690,0.00597297}, {1700,0.00600000}, {1710,0.00600000}, {1720,0.00600000}, {1730,0.00600901}, {1740,0.00603604}, {1750,0.00611712}, {1760,0.00603604}, {1770,0.00611712}, {1780,0.00613514}, {1790,0.01040541}, {1800,0.00624324}, {1810,0.00629730}, {1820,0.00630631}, {1830,0.00643243}, {1840,0.00646847}, {1850,0.01076577}, {1860,0.00660360}, {1870,0.00663964}, {1880,0.00669369}, {1890,0.00672072}, {1900,0.00676577}, {1910,0.00681081}, {1920,0.00673874}, {1930,0.00686486}, {1940,0.00689189}, {1950,0.00695495}, {1960,0.00700901}, {1970,0.00700901}, {1980,0.00700901}, {1990,0.00701802}, {2000,0.00704505}, {2050,0.00713514}, {2100,0.00746847}, {2150,0.00772072}, {2200,0.01190991}, {2250,0.01245045}, {2300,0.00812613}, {2350,0.00843243}, {2400,0.00870270}, {2450,0.00883784}, {2500,0.00892793}, {2550,0.00915315}, {2600,0.00945045}, {2650,0.00968468}, {2700,0.00977477}, {2750,0.00991892}, {2800,0.01017117}, {2850,0.01040541}, {2900,0.01060360}, {2950,0.01083784}, {3000,0.01100901}, {3050,0.01111712}, {3100,0.01141441}, {3150,0.01163063}, {3200,0.01172072}, {3250,0.01682883}, {3300,0.01768468}, {3350,0.01663063}, {3400,0.01275676}, {3450,0.01303604}, {3500,0.01308108}, {3550,0.01336937}, {3600,0.01354054}, {3650,0.01386486}, {3700,0.01882883}, {3750,0.01436036}, {3800,0.01449550}, {3850,0.01503604}, {3900,0.01496396}, {3950,0.01523423}, {4000,0.01563063}, {4050,0.01575676}, {4100,0.02354955}, {4150,0.01642342}, {4200,0.02010811}, {4250,0.01696396}, {4300,0.01741441}, {4350,0.01723423}, {4400,0.01760360}, {4450,0.01808108}, {4500,0.01818018}, {4550,0.02397297}, {4600,0.01874775}, {4650,0.01923423}, {4700,0.01940541}, {4750,0.02518018}, {4800,0.02003604}, {4850,0.02006306}, {4900,0.02049550}, {4950,0.02090991}, {5000,0.02110811}, {5050,0.02137838}, {5100,0.02627027}, {5150,0.02191892}, {5200,0.02249550}, {5250,0.02252252}, {5300,0.02994595}, {5350,0.02270270}, {5400,0.02383784}, {5450,0.02346847}, {5500,0.02444144}, {5550,0.02441441}, {5600,0.04946847}, {5650,0.02524324}, {5700,0.02603604}, {5750,0.03245946}, {5800,0.02694595}, {5850,0.02681982}, {5900,0.03142342}, {5950,0.02740541}, {6000,0.04527928}, {6050,0.02475}, {6100,0.02375}, {6150,0.02525}, {6200,0.02450}, {6250,0.02750}, {6300,0.02550}, {6350,0.02825}, {6400,0.04200}, {6450,0.02675}, {6500,0.02850}, {6550,0.03075}, {6600,0.02850}, {6650,0.02850}, {6700,0.04225}, {6750,0.02950}, {6800,0.02900}, {6850,0.02950}, {6900,0.03450}, {6950,0.03075}, {7000,0.03050}, {7050,0.03075}, {7100,0.02425}, {7150,0.03250}, {7200,0.03275}, {7250,0.03550}, {7300,0.04425}, {7350,0.03500}, {7400,0.04275}, {7450,0.03500}, {7500,0.03750}, {7550,0.04150}, {7600,0.04875}, {7650,0.04050}, {7700,0.03825}, {7750,0.03800}, {7800,0.03950}, {7850,0.04600}, {7900,0.03825}, {7950,0.05100}, {8000,0.03950}, {8050,0.04275}, {8100,0.04100}, {8150,0.04200}, {8200,0.04200}, {8250,0.04275}, {8300,0.04075}, {8350,0.04400}, {8400,0.04450}, {8450,0.04250}, {8500,0.04950}, {8550,0.04325}, {8600,0.04275}, {8650,0.04300}, {8700,0.04175}, {8750,0.04325}, {8800,0.04450}, {8850,0.04400}, {8900,0.04600}, {8950,0.04100}, {9000,0.04800}, {9050,0.04750}, {9100,0.05050}, {9150,0.04750}, {9200,0.04700}, {9250,0.04800}, {9300,0.04550}, {9350,0.05925}, {9400,0.05425}, {9450,0.04850}, {9500,0.06500}, {9550,0.04675}, {9600,0.05225}, {9650,0.04950}, {9700,0.04900}, {9750,0.04850}, {9800,0.05125}, {9850,0.05150}, {9900,0.05375}, {9950,0.07775}, {10000,0.05425}, {10100,0.05500}, {10200,0.05500}, {10300,0.05650}, {10400,0.05600}, {10500,0.05725}, {10600,0.05725}, {10700,0.06250}, {10800,0.07575}, {10900,0.05975}, {11000,0.05900}, {11100,0.06575}, {11200,0.05975}, {11300,0.06200}, {11400,0.06725}, {11500,0.07575}, {11600,0.06300}, {11700,0.06400}, {11800,0.06325}, {11900,0.07575}, {12000,0.07050}, {12100,0.06875}, {12200,0.06650}, {12300,0.06925}, {12400,0.06675}, {12500,0.06750}, {12600,0.06775}, {12700,0.06825}, {12800,0.07225}, {12900,0.06975}, {13000,0.07100}, {13100,0.05850}, {13200,0.07150}, {13300,0.07175}, {13400,0.07250}, {13500,0.08550}, {13600,0.08900}, {13700,0.08550}, {13800,0.07425}, {13900,0.07850}, {14000,0.07575}, {14100,0.07625}, {14200,0.07675}, {14300,0.08800}, {14400,0.07775}, {14500,0.07900}, {14600,0.07875}, {14700,0.09250}, {14800,0.08075}, {14900,0.09300}, {15000,0.06925}, {15100,0.08350}, {15200,0.08250}, {15300,0.08650}, {15400,0.08275}, {15500,0.11550}, {15600,0.08500}, {15700,0.09050}, {15800,0.07500}, {15900,0.08500}, {16000,0.08825}, {16100,0.08775}, {16200,0.09225}, {16300,0.08900}, {16400,0.08875}, {16500,0.08950}, {16600,0.09400}, {16700,0.09000}, {16800,0.09125}, {16900,0.09150}, {17000,0.09200}, {17100,0.11875}, {17200,0.09325}, {17300,0.09600}, {17400,0.09475}, {17500,0.09525}, {17600,0.11525}, {17700,0.09525}, {17800,0.11450}, {17900,0.09675}, {18000,0.11950}, {18100,0.10125}, {18200,0.09875}, {18300,0.09600}, {18400,0.08025}, {18500,0.10250}, {18600,0.10175}, {18700,0.12275}, {18800,0.10275}, {18900,0.10075}, {19000,0.10575}, {19100,0.10450}, {19200,0.10375}, {19300,0.12325}, {19400,0.10475}, {19500,0.10475}, {19600,0.10650}, {19700,0.10625}, {19800,0.10600}, {19900,0.12600}, {20000,0.1210}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["pre"]["user"] = {{1,0.00018018}, {2,0.00046847}, {3,0.00027027}, {4,0.00032432}, {5,0.00038739}, {6,0.00028829}, {7,0.00064865}, {8,0.00027928}, {9,0.00039640}, {10,0.00028829}, {11,0.00046847}, {12,0.00042342}, {13,0.00042342}, {14,0.00029730}, {15,0.00037838}, {16,0.00037838}, {17,0.00039640}, {18,0.00029730}, {19,0.00031532}, {20,0.00042342}, {21,0.00032432}, {22,0.00031532}, {23,0.00027027}, {24,0.00027027}, {25,0.00046847}, {26,0.00041441}, {27,0.00026126}, {28,0.00047748}, {29,0.00040541}, {30,0.00025225}, {31,0.00036036}, {32,0.00058559}, {33,0.00035135}, {34,0.00049550}, {35,0.00043243}, {36,0.00069369}, {37,0.00039640}, {38,0.00031532}, {39,0.00032432}, {40,0.00062162}, {41,0.00028829}, {42,0.00039640}, {43,0.00042342}, {44,0.00040541}, {45,0.00025225}, {46,0.00037838}, {47,0.00035135}, {48,0.00046847}, {49,0.00024324}, {50,0.00034234}, {51,0.00047748}, {52,0.00056757}, {53,0.00032432}, {54,0.00063964}, {55,0.00035135}, {56,0.00067568}, {57,0.00031532}, {58,0.00047748}, {59,0.00042342}, {60,0.00045946}, {61,0.00043243}, {62,0.00047748}, {63,0.00066667}, {64,0.00056757}, {65,0.00053153}, {66,0.00070270}, {67,0.00060360}, {68,0.00060360}, {69,0.00052252}, {70,0.00041441}, {71,0.00043243}, {72,0.00036036}, {73,0.00045045}, {74,0.00049550}, {75,0.00037838}, {76,0.00066667}, {77,0.00081081}, {78,0.00043243}, {79,0.00059459}, {80,0.00055856}, {81,0.00059459}, {82,0.00054955}, {83,0.00043243}, {84,0.00056757}, {85,0.00086486}, {86,0.00036937}, {87,0.00055856}, {88,0.00054054}, {89,0.00045045}, {90,0.00054955}, {91,0.00072973}, {92,0.00077477}, {93,0.00076577}, {94,0.00074775}, {95,0.00065766}, {96,0.00064865}, {97,0.00037838}, {98,0.00060360}, {99,0.00057658}, {100,0.00057658}, {101,0.00039640}, {102,0.00074775}, {103,0.00062162}, {104,0.00048649}, {105,0.00053153}, {106,0.00060360}, {107,0.00045045}, {108,0.00095495}, {109,0.00085586}, {110,0.00054054}, {111,0.00034234}, {112,0.00070270}, {113,0.00056757}, {114,0.00067568}, {115,0.00053153}, {116,0.00054955}, {117,0.00063964}, {118,0.00084685}, {119,0.00058559}, {120,0.00075676}, {121,0.00067568}, {122,0.00076577}, {123,0.00056757}, {124,0.00052252}, {125,0.00085586}, {126,0.00059459}, {127,0.00082883}, {128,0.00046847}, {129,0.00072072}, {130,0.00068468}, {131,0.00063063}, {132,0.00071171}, {133,0.00056757}, {134,0.00066667}, {135,0.00061261}, {136,0.00063063}, {137,0.00059459}, {138,0.00088288}, {139,0.00094595}, {140,0.00079279}, {141,0.00069369}, {142,0.00045045}, {143,0.00075676}, {144,0.00073874}, {145,0.00086486}, {146,0.00073874}, {147,0.00091892}, {148,0.00074775}, {149,0.00076577}, {150,0.00088288}, {151,0.00138739}, {152,0.00060360}, {153,0.00074775}, {154,0.00080180}, {155,0.00065766}, {156,0.00098198}, {157,0.00063063}, {158,0.00063063}, {159,0.00057658}, {160,0.00076577}, {161,0.00085586}, {162,0.00090090}, {163,0.00081081}, {164,0.00058559}, {165,0.00073874}, {166,0.00095495}, {167,0.00069369}, {168,0.00104505}, {169,0.00063964}, {170,0.00074775}, {171,0.00064865}, {172,0.00097297}, {173,0.00072072}, {174,0.00063063}, {175,0.00073874}, {176,0.00061261}, {177,0.00091892}, {178,0.00087387}, {179,0.00082883}, {180,0.00097297}, {181,0.00087387}, {182,0.00069369}, {183,0.00080180}, {184,0.00083784}, {185,0.00088288}, {186,0.00089189}, {187,0.00089189}, {188,0.00053153}, {189,0.00092793}, {190,0.00059459}, {191,0.00097297}, {192,0.00082883}, {193,0.00089189}, {194,0.00078378}, {195,0.00076577}, {196,0.00095495}, {197,0.00064865}, {198,0.00081081}, {199,0.00103604}, {200,0.00069369}, {201,0.00085586}, {202,0.00087387}, {203,0.00090991}, {204,0.00088288}, {205,0.00073874}, {206,0.00075676}, {207,0.00088288}, {208,0.00085586}, {209,0.00087387}, {210,0.00065766}, {211,0.00088288}, {212,0.00081982}, {213,0.00177477}, {214,0.00071171}, {215,0.00113514}, {216,0.00109910}, {217,0.00078378}, {218,0.00079279}, {219,0.00115315}, {220,0.00076577}, {221,0.00088288}, {222,0.00104505}, {223,0.00109910}, {224,0.00098198}, {225,0.00080180}, {226,0.00055856}, {227,0.00080180}, {228,0.00067568}, {229,0.00089189}, {230,0.00095495}, {231,0.00087387}, {232,0.00112613}, {233,0.00103604}, {234,0.00073874}, {235,0.00087387}, {236,0.00095495}, {237,0.00105405}, {238,0.00116216}, {239,0.00103604}, {240,0.00089189}, {241,0.00067568}, {242,0.00090090}, {243,0.00099099}, {244,0.00111712}, {245,0.00107207}, {246,0.00098198}, {247,0.00069369}, {248,0.00099099}, {249,0.00102703}, {250,0.00096396}, {251,0.00090991}, {252,0.00103604}, {253,0.00087387}, {254,0.00103604}, {255,0.00091892}, {256,0.00102703}, {257,0.00092793}, {258,0.00092793}, {259,0.00101802}, {260,0.00108108}, {261,0.00091892}, {262,0.00099099}, {263,0.00114414}, {264,0.00100901}, {265,0.00101802}, {266,0.00109910}, {267,0.00086486}, {268,0.00092793}, {269,0.00081081}, {270,0.00098198}, {271,0.00095495}, {272,0.00090090}, {273,0.00120721}, {274,0.00085586}, {275,0.00118919}, {276,0.00089189}, {277,0.00106306}, {278,0.00081982}, {279,0.00104505}, {280,0.00112613}, {281,0.00103604}, {282,0.00120721}, {283,0.00089189}, {284,0.00091892}, {285,0.00123423}, {286,0.00126126}, {287,0.00133333}, {288,0.00114414}, {289,0.00109910}, {290,0.00100901}, {291,0.00108108}, {292,0.00120721}, {293,0.00103604}, {294,0.00123423}, {295,0.00120721}, {296,0.00121622}, {297,0.00128829}, {298,0.00128829}, {299,0.00244144}, {300,0.00094595}, {301,0.00118018}, {302,0.00109009}, {303,0.00104505}, {304,0.00128829}, {305,0.00116216}, {306,0.00222523}, {307,0.00101802}, {308,0.00136937}, {309,0.00093694}, {310,0.00125225}, {311,0.00145946}, {312,0.00103604}, {313,0.00116216}, {314,0.00110811}, {315,0.00129730}, {316,0.00128829}, {317,0.00121622}, {318,0.00096396}, {319,0.00088288}, {320,0.00109009}, {321,0.00104505}, {322,0.00127027}, {323,0.00106306}, {324,0.00150450}, {325,0.00100000}, {326,0.00123423}, {327,0.00114414}, {328,0.00134234}, {329,0.00131532}, {330,0.00121622}, {331,0.00144144}, {332,0.00131532}, {333,0.00151351}, {334,0.00121622}, {335,0.00109910}, {336,0.00167568}, {337,0.00132432}, {338,0.00151351}, {339,0.00182883}, {340,0.00174775}, {341,0.00127027}, {342,0.00138739}, {343,0.00152252}, {344,0.00135135}, {345,0.00153153}, {346,0.00100901}, {347,0.00108108}, {348,0.00164865}, {349,0.00160360}, {350,0.00158559}, {351,0.00119820}, {352,0.00159459}, {353,0.00134234}, {354,0.00137838}, {355,0.00138739}, {356,0.00154054}, {357,0.00131532}, {358,0.00155856}, {359,0.00145946}, {360,0.00155856}, {361,0.00165766}, {362,0.00139640}, {363,0.00127027}, {364,0.00145946}, {365,0.00166667}, {366,0.00146847}, {367,0.00113514}, {368,0.00155856}, {369,0.00163964}, {370,0.00141441}, {371,0.00134234}, {372,0.00147748}, {373,0.00142342}, {374,0.00181081}, {375,0.00128829}, {376,0.00136937}, {377,0.00154054}, {378,0.00142342}, {379,0.00139640}, {380,0.00143243}, {381,0.00151351}, {382,0.00134234}, {383,0.00142342}, {384,0.00184685}, {385,0.00129730}, {386,0.00129730}, {387,0.00152252}, {388,0.00172973}, {389,0.00107207}, {390,0.00189189}, {391,0.00163964}, {392,0.00155856}, {393,0.00150450}, {394,0.00166667}, {395,0.00182883}, {396,0.00162162}, {397,0.00163964}, {398,0.00169369}, {399,0.00156757}, {400,0.00163063}, {401,0.00169369}, {402,0.00192793}, {403,0.00135135}, {404,0.00165766}, {405,0.00181081}, {406,0.00166667}, {407,0.00139640}, {408,0.00145045}, {409,0.00165766}, {410,0.00159459}, {411,0.00141441}, {412,0.00142342}, {413,0.00146847}, {414,0.00172072}, {415,0.00170270}, {416,0.00154054}, {417,0.00148649}, {418,0.00170270}, {419,0.00201802}, {420,0.00165766}, {421,0.00168468}, {422,0.00177477}, {423,0.00153153}, {424,0.00147748}, {425,0.00173874}, {426,0.00163964}, {427,0.00168468}, {428,0.00157658}, {429,0.00154054}, {430,0.00154054}, {431,0.00158559}, {432,0.00170270}, {433,0.00163063}, {434,0.00190090}, {435,0.00194595}, {436,0.00172973}, {437,0.00163063}, {438,0.00167568}, {439,0.00159459}, {440,0.00166667}, {441,0.00134234}, {442,0.00153153}, {443,0.00183784}, {444,0.00155856}, {445,0.00187387}, {446,0.00181982}, {447,0.00147748}, {448,0.00210811}, {449,0.00168468}, {450,0.00174775}, {451,0.00179279}, {452,0.00172072}, {453,0.00200901}, {454,0.00176577}, {455,0.00157658}, {456,0.00179279}, {457,0.00178378}, {458,0.00187387}, {459,0.00175676}, {460,0.00188288}, {461,0.00170270}, {462,0.00191892}, {463,0.00173874}, {464,0.00179279}, {465,0.00193694}, {466,0.00159459}, {467,0.00200901}, {468,0.00161261}, {469,0.00153153}, {470,0.00190991}, {471,0.00195495}, {472,0.00162162}, {473,0.00172072}, {474,0.00190090}, {475,0.00168468}, {476,0.00174775}, {477,0.00169369}, {478,0.00157658}, {479,0.00204505}, {480,0.00184685}, {481,0.00183784}, {482,0.00197297}, {483,0.00179279}, {484,0.00188288}, {485,0.00162162}, {486,0.00161261}, {487,0.00168468}, {488,0.00197297}, {489,0.00173874}, {490,0.00165766}, {491,0.00215315}, {492,0.00173874}, {493,0.00209910}, {494,0.00177477}, {495,0.00203604}, {496,0.00206306}, {497,0.00227027}, {498,0.00181982}, {499,0.00160360}, {500,0.00207207}, {505,0.00199099}, {510,0.00192793}, {515,0.00190090}, {520,0.00178378}, {525,0.00182883}, {530,0.00177477}, {535,0.00254054}, {540,0.00172973}, {545,0.00207207}, {550,0.00199099}, {555,0.00263964}, {560,0.00205405}, {565,0.00219820}, {570,0.00232432}, {575,0.00218018}, {580,0.00221622}, {585,0.00227928}, {590,0.00243243}, {595,0.00193694}, {600,0.00227027}, {605,0.00218018}, {610,0.00220721}, {615,0.00212613}, {620,0.00199099}, {625,0.00241441}, {630,0.00193694}, {635,0.00237838}, {640,0.00209009}, {645,0.00210811}, {650,0.00218018}, {655,0.00213514}, {660,0.00218018}, {665,0.00193694}, {670,0.00232432}, {675,0.00215315}, {680,0.00210811}, {685,0.00250450}, {690,0.00231532}, {695,0.00237838}, {700,0.00224324}, {705,0.00404505}, {710,0.00236036}, {715,0.00228829}, {720,0.00250450}, {725,0.00217117}, {730,0.00222523}, {735,0.00218919}, {740,0.00237838}, {745,0.00237838}, {750,0.00245946}, {755,0.00244144}, {760,0.00238739}, {765,0.00251351}, {770,0.00265766}, {775,0.00265766}, {780,0.00256757}, {785,0.00236937}, {790,0.00263063}, {795,0.00274775}, {800,0.00271171}, {805,0.00260360}, {810,0.00250450}, {815,0.00281982}, {820,0.00261261}, {825,0.00268468}, {830,0.00262162}, {835,0.00266667}, {840,0.00269369}, {845,0.00254955}, {850,0.00290991}, {855,0.00292793}, {860,0.00250450}, {865,0.00284685}, {870,0.00280180}, {875,0.00263964}, {880,0.00271171}, {885,0.00294595}, {890,0.00275676}, {895,0.00285586}, {900,0.00282883}, {905,0.00278378}, {910,0.00302703}, {915,0.00297297}, {920,0.00288288}, {925,0.00284685}, {930,0.00301802}, {935,0.00296396}, {940,0.00300000}, {945,0.00307207}, {950,0.00291892}, {955,0.00318018}, {960,0.00309910}, {965,0.00293694}, {970,0.00327928}, {975,0.00318919}, {980,0.00302703}, {985,0.00321622}, {990,0.00320721}, {995,0.00324324}, {1000,0.00325225}, {1010,0.00327027}, {1020,0.00320721}, {1030,0.00337838}, {1040,0.00613514}, {1050,0.00345946}, {1060,0.00342342}, {1070,0.00341441}, {1080,0.00345045}, {1090,0.00353153}, {1100,0.00362162}, {1110,0.00368468}, {1120,0.00354054}, {1130,0.00359459}, {1140,0.00365766}, {1150,0.00822523}, {1160,0.00395495}, {1170,0.00373874}, {1180,0.00393694}, {1190,0.00382883}, {1200,0.00408108}, {1210,0.00400000}, {1220,0.00414414}, {1230,0.00408108}, {1240,0.00397297}, {1250,0.00400000}, {1260,0.00436036}, {1270,0.00409910}, {1280,0.00421622}, {1290,0.00454054}, {1300,0.00445946}, {1310,0.00865766}, {1320,0.00445946}, {1330,0.00445946}, {1340,0.00457658}, {1350,0.00474775}, {1360,0.00439640}, {1370,0.00482883}, {1380,0.00483784}, {1390,0.00478378}, {1400,0.00484685}, {1410,0.00450450}, {1420,0.00472072}, {1430,0.00518919}, {1440,0.00458559}, {1450,0.00480180}, {1460,0.00496396}, {1470,0.00511712}, {1480,0.00494595}, {1490,0.00544144}, {1500,0.00508108}, {1510,0.00484685}, {1520,0.00488288}, {1530,0.00537838}, {1540,0.00539640}, {1550,0.00557658}, {1560,0.00561261}, {1570,0.00518018}, {1580,0.00550450}, {1590,0.00541441}, {1600,0.00510811}, {1610,0.00562162}, {1620,0.00954054}, {1630,0.00984685}, {1640,0.00993694}, {1650,0.01036036}, {1660,0.01031532}, {1670,0.00544144}, {1680,0.00590991}, {1690,0.00570270}, {1700,0.00565766}, {1710,0.00596396}, {1720,0.00617117}, {1730,0.00622523}, {1740,0.00596396}, {1750,0.00621622}, {1760,0.00596396}, {1770,0.00617117}, {1780,0.00590090}, {1790,0.01066667}, {1800,0.00633333}, {1810,0.00617117}, {1820,0.00628829}, {1830,0.00620721}, {1840,0.00632432}, {1850,0.01122523}, {1860,0.00659459}, {1870,0.00658559}, {1880,0.00672072}, {1890,0.00655856}, {1900,0.00652252}, {1910,0.00650450}, {1920,0.00645045}, {1930,0.00649550}, {1940,0.00663063}, {1950,0.00683784}, {1960,0.00663063}, {1970,0.00686486}, {1980,0.00679279}, {1990,0.00702703}, {2000,0.00690991}, {2050,0.00702703}, {2100,0.00712613}, {2150,0.00765766}, {2200,0.01220721}, {2250,0.01249550}, {2300,0.00802703}, {2350,0.00849550}, {2400,0.00861261}, {2450,0.00872973}, {2500,0.00929730}, {2550,0.00940541}, {2600,0.00992793}, {2650,0.00993694}, {2700,0.01006306}, {2750,0.01014414}, {2800,0.01014414}, {2850,0.01061261}, {2900,0.01072072}, {2950,0.01105405}, {3000,0.01146847}, {3050,0.01136036}, {3100,0.01169369}, {3150,0.01188288}, {3200,0.01194595}, {3250,0.01662162}, {3300,0.01777477}, {3350,0.01663063}, {3400,0.01300901}, {3450,0.01327027}, {3500,0.01301802}, {3550,0.01339640}, {3600,0.01376577}, {3650,0.01409910}, {3700,0.01873874}, {3750,0.01480180}, {3800,0.01471171}, {3850,0.01520721}, {3900,0.01500000}, {3950,0.01532432}, {4000,0.01584685}, {4050,0.01581982}, {4100,0.02357658}, {4150,0.01654955}, {4200,0.02015315}, {4250,0.01703604}, {4300,0.01736036}, {4350,0.01682883}, {4400,0.01767568}, {4450,0.01805405}, {4500,0.01817117}, {4550,0.02401802}, {4600,0.01861261}, {4650,0.01959459}, {4700,0.01943243}, {4750,0.02554955}, {4800,0.02010811}, {4850,0.02008108}, {4900,0.02043243}, {4950,0.02082883}, {5000,0.02085586}, {5050,0.02155856}, {5100,0.02624324}, {5150,0.02170270}, {5200,0.02257658}, {5250,0.02267568}, {5300,0.02979279}, {5350,0.02312613}, {5400,0.02364865}, {5450,0.02339640}, {5500,0.02458559}, {5550,0.02464865}, {5600,0.04934234}, {5650,0.02507207}, {5700,0.02600901}, {5750,0.03227928}, {5800,0.02724324}, {5850,0.02721622}, {5900,0.03164865}, {5950,0.02747748}, {6000,0.04512613}, {6050,0.02600}, {6100,0.02275}, {6150,0.02675}, {6200,0.02500}, {6250,0.02875}, {6300,0.02550}, {6350,0.02750}, {6400,0.04025}, {6450,0.02675}, {6500,0.02725}, {6550,0.02975}, {6600,0.02825}, {6650,0.02950}, {6700,0.04350}, {6750,0.03050}, {6800,0.02925}, {6850,0.02975}, {6900,0.03350}, {6950,0.03050}, {7000,0.03050}, {7050,0.02900}, {7100,0.02450}, {7150,0.03100}, {7200,0.03250}, {7250,0.03475}, {7300,0.04475}, {7350,0.03575}, {7400,0.04250}, {7450,0.03450}, {7500,0.03625}, {7550,0.04150}, {7600,0.04725}, {7650,0.04150}, {7700,0.03850}, {7750,0.03775}, {7800,0.04025}, {7850,0.04750}, {7900,0.03850}, {7950,0.05050}, {8000,0.03900}, {8050,0.04150}, {8100,0.03925}, {8150,0.04125}, {8200,0.04300}, {8250,0.04225}, {8300,0.04175}, {8350,0.04575}, {8400,0.04550}, {8450,0.04350}, {8500,0.05075}, {8550,0.04250}, {8600,0.04400}, {8650,0.04250}, {8700,0.03975}, {8750,0.04250}, {8800,0.04575}, {8850,0.04475}, {8900,0.04550}, {8950,0.04175}, {9000,0.04850}, {9050,0.04775}, {9100,0.05050}, {9150,0.04800}, {9200,0.04775}, {9250,0.04725}, {9300,0.04625}, {9350,0.05875}, {9400,0.05325}, {9450,0.04850}, {9500,0.06350}, {9550,0.04775}, {9600,0.05250}, {9650,0.04875}, {9700,0.04875}, {9750,0.04975}, {9800,0.05050}, {9850,0.05150}, {9900,0.05425}, {9950,0.07700}, {10000,0.05575}, {10100,0.05575}, {10200,0.05450}, {10300,0.05675}, {10400,0.05750}, {10500,0.05550}, {10600,0.05550}, {10700,0.06300}, {10800,0.07550}, {10900,0.05900}, {11000,0.05900}, {11100,0.06525}, {11200,0.06150}, {11300,0.06250}, {11400,0.06725}, {11500,0.07550}, {11600,0.06350}, {11700,0.06275}, {11800,0.06250}, {11900,0.07550}, {12000,0.07000}, {12100,0.06775}, {12200,0.06675}, {12300,0.06875}, {12400,0.06675}, {12500,0.06700}, {12600,0.06750}, {12700,0.06875}, {12800,0.07275}, {12900,0.06975}, {13000,0.07200}, {13100,0.05900}, {13200,0.07250}, {13300,0.07275}, {13400,0.07250}, {13500,0.08400}, {13600,0.08800}, {13700,0.08600}, {13800,0.07425}, {13900,0.07650}, {14000,0.07525}, {14100,0.07650}, {14200,0.07650}, {14300,0.08775}, {14400,0.07725}, {14500,0.07975}, {14600,0.07850}, {14700,0.09375}, {14800,0.08025}, {14900,0.09375}, {15000,0.06900}, {15100,0.08375}, {15200,0.08275}, {15300,0.08575}, {15400,0.08400}, {15500,0.11675}, {15600,0.08500}, {15700,0.08950}, {15800,0.07475}, {15900,0.08400}, {16000,0.08850}, {16100,0.08775}, {16200,0.09125}, {16300,0.09000}, {16400,0.08925}, {16500,0.08825}, {16600,0.09600}, {16700,0.08850}, {16800,0.09150}, {16900,0.09050}, {17000,0.09250}, {17100,0.11625}, {17200,0.09225}, {17300,0.09700}, {17400,0.09600}, {17500,0.09575}, {17600,0.11650}, {17700,0.09375}, {17800,0.11550}, {17900,0.09650}, {18000,0.11925}, {18100,0.10025}, {18200,0.10000}, {18300,0.09775}, {18400,0.07975}, {18500,0.10150}, {18600,0.09975}, {18700,0.12375}, {18800,0.10125}, {18900,0.10225}, {19000,0.10550}, {19100,0.10325}, {19200,0.10325}, {19300,0.12350}, {19400,0.10425}, {19500,0.10350}, {19600,0.10800}, {19700,0.10550}, {19800,0.10700}, {19900,0.12525}, {20000,0.1220}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["pre"]["system"] = {{1,0.00021622}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00003604}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00002703}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00003604}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00003604}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00003604}, {47,0.00000000}, {48,0.00003604}, {49,0.00000000}, {50,0.00003604}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00003604}, {57,0.00000000}, {58,0.00002703}, {59,0.00007207}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00007207}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00003604}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00003604}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00003604}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00005405}, {95,0.00003604}, {96,0.00000000}, {97,0.00000000}, {98,0.00006306}, {99,0.00000000}, {100,0.00003604}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00003604}, {107,0.00003604}, {108,0.00000000}, {109,0.00003604}, {110,0.00000000}, {111,0.00003604}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00003604}, {116,0.00006306}, {117,0.00000000}, {118,0.00003604}, {119,0.00000000}, {120,0.00003604}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00003604}, {129,0.00002703}, {130,0.00000000}, {131,0.00003604}, {132,0.00000000}, {133,0.00003604}, {134,0.00000000}, {135,0.00000000}, {136,0.00003604}, {137,0.00000000}, {138,0.00003604}, {139,0.00002703}, {140,0.00000000}, {141,0.00003604}, {142,0.00002703}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00007207}, {149,0.00003604}, {150,0.00003604}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00003604}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00003604}, {164,0.00002703}, {165,0.00000000}, {166,0.00000000}, {167,0.00003604}, {168,0.00003604}, {169,0.00000000}, {170,0.00003604}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00007207}, {177,0.00002703}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00003604}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00002703}, {200,0.00000000}, {201,0.00003604}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00002703}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00003604}, {212,0.00000000}, {213,0.00003604}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00003604}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00007207}, {225,0.00002703}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00003604}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00003604}, {239,0.00003604}, {240,0.00003604}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00003604}, {246,0.00000000}, {247,0.00003604}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00002703}, {252,0.00000000}, {253,0.00000000}, {254,0.00002703}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00003604}, {268,0.00000000}, {269,0.00000000}, {270,0.00003604}, {271,0.00000000}, {272,0.00003604}, {273,0.00003604}, {274,0.00000000}, {275,0.00000000}, {276,0.00003604}, {277,0.00000000}, {278,0.00000000}, {279,0.00003604}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00003604}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00003604}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00003604}, {298,0.00000000}, {299,0.00000000}, {300,0.00003604}, {301,0.00003604}, {302,0.00000000}, {303,0.00003604}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00007207}, {312,0.00000000}, {313,0.00000000}, {314,0.00003604}, {315,0.00003604}, {316,0.00003604}, {317,0.00000000}, {318,0.00000000}, {319,0.00003604}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00003604}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00003604}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00003604}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00003604}, {349,0.00006306}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00003604}, {358,0.00003604}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00003604}, {363,0.00000000}, {364,0.00003604}, {365,0.00003604}, {366,0.00002703}, {367,0.00007207}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00003604}, {376,0.00007207}, {377,0.00000000}, {378,0.00003604}, {379,0.00000000}, {380,0.00003604}, {381,0.00000000}, {382,0.00003604}, {383,0.00007207}, {384,0.00000000}, {385,0.00003604}, {386,0.00000000}, {387,0.00003604}, {388,0.00000000}, {389,0.00003604}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00003604}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00002703}, {407,0.00000000}, {408,0.00003604}, {409,0.00000000}, {410,0.00003604}, {411,0.00002703}, {412,0.00003604}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00003604}, {417,0.00003604}, {418,0.00000000}, {419,0.00003604}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00003604}, {424,0.00007207}, {425,0.00006306}, {426,0.00000000}, {427,0.00002703}, {428,0.00000000}, {429,0.00000000}, {430,0.00003604}, {431,0.00000000}, {432,0.00000000}, {433,0.00003604}, {434,0.00003604}, {435,0.00000000}, {436,0.00002703}, {437,0.00006306}, {438,0.00000000}, {439,0.00003604}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00002703}, {445,0.00000000}, {446,0.00000000}, {447,0.00006306}, {448,0.00006306}, {449,0.00003604}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00003604}, {454,0.00000000}, {455,0.00000000}, {456,0.00002703}, {457,0.00002703}, {458,0.00000000}, {459,0.00007207}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00007207}, {464,0.00000000}, {465,0.00000000}, {466,0.00003604}, {467,0.00000000}, {468,0.00000000}, {469,0.00003604}, {470,0.00000000}, {471,0.00003604}, {472,0.00003604}, {473,0.00007207}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00003604}, {479,0.00003604}, {480,0.00003604}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00003604}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00003604}, {492,0.00003604}, {493,0.00007207}, {494,0.00010811}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00002703}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00007207}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00003604}, {575,0.00003604}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00003604}, {615,0.00007207}, {620,0.00000000}, {625,0.00000000}, {630,0.00007207}, {635,0.00000000}, {640,0.00003604}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00003604}, {665,0.00000000}, {670,0.00000000}, {675,0.00003604}, {680,0.00000000}, {685,0.00000000}, {690,0.00003604}, {695,0.00000000}, {700,0.00000000}, {705,0.00003604}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00003604}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00010811}, {765,0.00000000}, {770,0.00003604}, {775,0.00003604}, {780,0.00003604}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00002703}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00003604}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00002703}, {845,0.00000000}, {850,0.00003604}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00010811}, {880,0.00003604}, {885,0.00000000}, {890,0.00003604}, {895,0.00003604}, {900,0.00002703}, {905,0.00007207}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00003604}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00003604}, {1030,0.00000000}, {1040,0.00006306}, {1050,0.00000000}, {1060,0.00003604}, {1070,0.00003604}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00003604}, {1160,0.00000000}, {1170,0.00002703}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00003604}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00007207}, {1280,0.00003604}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00007207}, {1320,0.00000000}, {1330,0.00003604}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00003604}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00003604}, {1420,0.00000000}, {1430,0.00003604}, {1440,0.00007207}, {1450,0.00000000}, {1460,0.00003604}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00003604}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00003604}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00013514}, {1630,0.00010811}, {1640,0.00014414}, {1650,0.00003604}, {1660,0.00010811}, {1670,0.00003604}, {1680,0.00003604}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00003604}, {1720,0.00000000}, {1730,0.00003604}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00003604}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00006306}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00003604}, {1950,0.00000000}, {1960,0.00003604}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00003604}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00003604}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00003604}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00003604}, {2550,0.00000000}, {2600,0.00003604}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00003604}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00003604}, {3000,0.00000000}, {3050,0.00003604}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00007207}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00002703}, {3450,0.00003604}, {3500,0.00003604}, {3550,0.00003604}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00007207}, {3900,0.00003604}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00003604}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00003604}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00002703}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00007207}, {4600,0.00003604}, {4650,0.00000000}, {4700,0.00003604}, {4750,0.00003604}, {4800,0.00007207}, {4850,0.00003604}, {4900,0.00007207}, {4950,0.00003604}, {5000,0.00003604}, {5050,0.00000000}, {5100,0.00010811}, {5150,0.00003604}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00003604}, {5350,0.00003604}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00007207}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00018018}, {5800,0.00003604}, {5850,0.00003604}, {5900,0.00018018}, {5950,0.00000000}, {6000,0.00042342}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00100}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00100}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00007207}, {9,0.00061261}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00100000}, {16,0.00100000}, {17,0.00100000}, {18,0.00100000}, {19,0.00100000}, {20,0.00101802}, {21,0.00116216}, {22,0.00134234}, {23,0.00198198}, {24,0.00200000}, {25,0.00200000}, {26,0.00200000}, {27,0.00200000}, {28,0.00200000}, {29,0.00200000}, {30,0.00200000}, {31,0.00200000}, {32,0.00200000}, {33,0.00203604}, {34,0.00210811}, {35,0.00213514}, {36,0.00223423}, {37,0.00295495}, {38,0.00300000}, {39,0.00300000}, {40,0.00300000}, {41,0.00300000}, {42,0.00300000}, {43,0.00300000}, {44,0.00300000}, {45,0.00302703}, {46,0.00305405}, {47,0.00310811}, {48,0.00307207}, {49,0.00318919}, {50,0.00343243}, {51,0.00393694}, {52,0.00400000}, {53,0.00400000}, {54,0.00400000}, {55,0.00400000}, {56,0.00400000}, {57,0.00400901}, {58,0.00402703}, {59,0.00408108}, {60,0.00409910}, {61,0.00409009}, {62,0.00417117}, {63,0.00434234}, {64,0.00423423}, {65,0.00487387}, {66,0.00498198}, {67,0.00500000}, {68,0.00500000}, {69,0.00501802}, {70,0.00502703}, {71,0.00507207}, {72,0.00598198}, {73,0.00501802}, {74,0.00505405}, {75,0.00505405}, {76,0.00510811}, {77,0.00531532}, {78,0.00623423}, {79,0.00600000}, {80,0.00596396}, {81,0.00600000}, {82,0.00600901}, {83,0.00600901}, {84,0.00682883}, {85,0.00604505}, {86,0.00603604}, {87,0.00610811}, {88,0.00609009}, {89,0.00609910}, {90,0.00619820}, {91,0.00654955}, {92,0.00663964}, {93,0.00698198}, {94,0.00702703}, {95,0.00703604}, {96,0.00700901}, {97,0.00709009}, {98,0.00704505}, {99,0.00704505}, {100,0.00706306}, {101,0.00708108}, {102,0.00712613}, {103,0.00727928}, {104,0.00814414}, {105,0.00732432}, {106,0.00772973}, {107,0.00800000}, {108,0.00800000}, {109,0.00801802}, {110,0.00802703}, {111,0.00804505}, {112,0.00806306}, {113,0.00900901}, {114,0.00806306}, {115,0.00813514}, {116,0.00814414}, {117,0.00815315}, {118,0.00837838}, {119,0.00884685}, {120,0.00866667}, {121,0.00899099}, {122,0.00900901}, {123,0.00902703}, {124,0.00902703}, {125,0.00901802}, {126,0.00903604}, {127,0.00906306}, {128,0.00904505}, {129,0.00915315}, {130,0.00909910}, {131,0.00927027}, {132,0.00926126}, {133,0.01085586}, {134,0.00987387}, {135,0.01001802}, {136,0.01000901}, {137,0.01081982}, {138,0.01004505}, {139,0.01008108}, {140,0.01007207}, {141,0.01009910}, {142,0.01016216}, {143,0.01027027}, {144,0.01118018}, {145,0.01026126}, {146,0.01037838}, {147,0.01089189}, {148,0.01085586}, {149,0.01108108}, {150,0.01104505}, {151,0.01108108}, {152,0.01106306}, {153,0.01108108}, {154,0.01204505}, {155,0.01113514}, {156,0.01119820}, {157,0.01128829}, {158,0.01145946}, {159,0.01187387}, {160,0.01118919}, {161,0.01174775}, {162,0.01184685}, {163,0.01202703}, {164,0.01199099}, {165,0.01202703}, {166,0.01209009}, {167,0.01206306}, {168,0.01208108}, {169,0.01218018}, {170,0.01214414}, {171,0.01238739}, {172,0.01226126}, {173,0.01277477}, {174,0.01292793}, {175,0.01309009}, {176,0.01282883}, {177,0.01302703}, {178,0.01306306}, {179,0.01309910}, {180,0.01304505}, {181,0.01312613}, {182,0.01316216}, {183,0.01341441}, {184,0.01318018}, {185,0.01341441}, {186,0.01363964}, {187,0.01484685}, {188,0.01383784}, {189,0.01403604}, {190,0.01405405}, {191,0.01406306}, {192,0.01396396}, {193,0.01410811}, {194,0.01401802}, {195,0.01536036}, {196,0.01410811}, {197,0.01413514}, {198,0.01419820}, {199,0.01450450}, {200,0.01425225}, {201,0.01463063}, {202,0.01481982}, {203,0.01599099}, {204,0.01501802}, {205,0.01514414}, {206,0.01512613}, {207,0.01518919}, {208,0.01608108}, {209,0.01507207}, {210,0.01513514}, {211,0.01531532}, {212,0.01527928}, {213,0.01562162}, {214,0.01577477}, {215,0.01603604}, {216,0.01589189}, {217,0.01604505}, {218,0.01606306}, {219,0.01612613}, {220,0.01714414}, {221,0.01618919}, {222,0.01616216}, {223,0.01651351}, {224,0.01609910}, {225,0.01617117}, {226,0.01619820}, {227,0.01770270}, {228,0.01645946}, {229,0.01694595}, {230,0.01704505}, {231,0.01716216}, {232,0.01702703}, {233,0.01711712}, {234,0.01710811}, {235,0.01723423}, {236,0.01818018}, {237,0.01736937}, {238,0.01892793}, {239,0.01790991}, {240,0.01734234}, {241,0.01758559}, {242,0.01784685}, {243,0.01808108}, {244,0.01807207}, {245,0.01812613}, {246,0.01808108}, {247,0.01825225}, {248,0.01810811}, {249,0.01910811}, {250,0.01827027}, {251,0.02009910}, {252,0.01857658}, {253,0.02010811}, {254,0.01900901}, {255,0.02025225}, {256,0.01834234}, {257,0.01998198}, {258,0.01885586}, {259,0.02012613}, {260,0.01909009}, {261,0.02095495}, {262,0.01916216}, {263,0.02140541}, {264,0.01910811}, {265,0.02083784}, {266,0.01934234}, {267,0.02154054}, {268,0.01964865}, {269,0.02104505}, {270,0.02000000}, {271,0.02115315}, {272,0.01981982}, {273,0.02114414}, {274,0.02008108}, {275,0.02146847}, {276,0.02020721}, {277,0.02163964}, {278,0.02036937}, {279,0.02082883}, {280,0.02038739}, {281,0.02079279}, {282,0.02095495}, {283,0.02111712}, {284,0.02100000}, {285,0.02116216}, {286,0.02301802}, {287,0.02132432}, {288,0.02203604}, {289,0.02111712}, {290,0.02231532}, {291,0.02131532}, {292,0.02128829}, {293,0.02163063}, {294,0.02172072}, {295,0.02198198}, {296,0.02171171}, {297,0.02403604}, {298,0.02215315}, {299,0.02217117}, {300,0.02212613}, {301,0.02219820}, {302,0.02240541}, {303,0.02260360}, {304,0.02482883}, {305,0.02236036}, {306,0.02248649}, {307,0.02290090}, {308,0.02270270}, {309,0.02309009}, {310,0.02305405}, {311,0.02514414}, {312,0.02305405}, {313,0.02313514}, {314,0.02317117}, {315,0.02342342}, {316,0.02609910}, {317,0.02365766}, {318,0.02376577}, {319,0.02413514}, {320,0.02322523}, {321,0.02517117}, {322,0.02356757}, {323,0.02381081}, {324,0.02383784}, {325,0.02409009}, {326,0.02526126}, {327,0.02422523}, {328,0.02409009}, {329,0.02581081}, {330,0.02423423}, {331,0.02455856}, {332,0.02428829}, {333,0.02477477}, {334,0.02634234}, {335,0.02509910}, {336,0.02443243}, {337,0.02637838}, {338,0.02495495}, {339,0.02517117}, {340,0.02509009}, {341,0.02526126}, {342,0.02529730}, {343,0.02568468}, {344,0.02527928}, {345,0.02730631}, {346,0.02564865}, {347,0.02606306}, {348,0.02738739}, {349,0.02610811}, {350,0.02613514}, {351,0.02806306}, {352,0.02584685}, {353,0.02609910}, {354,0.02777477}, {355,0.02626126}, {356,0.02621622}, {357,0.02802703}, {358,0.02661261}, {359,0.02694595}, {360,0.02812613}, {361,0.02688288}, {362,0.02701802}, {363,0.02866667}, {364,0.02712613}, {365,0.02719820}, {366,0.02888288}, {367,0.02763063}, {368,0.02712613}, {369,0.02730631}, {370,0.02906306}, {371,0.02786486}, {372,0.02759459}, {373,0.02922523}, {374,0.02805405}, {375,0.02821622}, {376,0.02939640}, {377,0.02823423}, {378,0.02817117}, {379,0.02854054}, {380,0.02970270}, {381,0.02870270}, {382,0.02884685}, {383,0.03049550}, {384,0.02803604}, {385,0.02821622}, {386,0.02830631}, {387,0.03014414}, {388,0.02846847}, {389,0.02886486}, {390,0.02893694}, {391,0.03105405}, {392,0.02890991}, {393,0.02908108}, {394,0.03069369}, {395,0.02951351}, {396,0.02927027}, {397,0.02952252}, {398,0.03111712}, {399,0.02998198}, {400,0.02926126}, {401,0.02969369}, {402,0.03121622}, {403,0.03013514}, {404,0.02997297}, {405,0.03019820}, {406,0.03176577}, {407,0.03054955}, {408,0.03017117}, {409,0.03040541}, {410,0.03207207}, {411,0.03319820}, {412,0.03078378}, {413,0.03109009}, {414,0.03107207}, {415,0.03285586}, {416,0.03061261}, {417,0.03087387}, {418,0.03096396}, {419,0.03280180}, {420,0.03337838}, {421,0.03127928}, {422,0.03155856}, {423,0.03173874}, {424,0.03268468}, {425,0.03487387}, {426,0.03180180}, {427,0.03210811}, {428,0.03198198}, {429,0.03366667}, {430,0.03560360}, {431,0.03273874}, {432,0.03200000}, {433,0.03226126}, {434,0.03372973}, {435,0.03494595}, {436,0.03251351}, {437,0.03286486}, {438,0.03288288}, {439,0.03460360}, {440,0.03507207}, {441,0.03310811}, {442,0.03330631}, {443,0.03353153}, {444,0.03327027}, {445,0.03494595}, {446,0.03600901}, {447,0.03418018}, {448,0.03291892}, {449,0.03319820}, {450,0.03322523}, {451,0.03495495}, {452,0.03577477}, {453,0.03376577}, {454,0.03381982}, {455,0.03414414}, {456,0.03359459}, {457,0.03419820}, {458,0.03555856}, {459,0.03659459}, {460,0.03431532}, {461,0.03461261}, {462,0.03471171}, {463,0.03505405}, {464,0.03416216}, {465,0.03599099}, {466,0.03685586}, {467,0.03508108}, {468,0.03494595}, {469,0.03528829}, {470,0.03527027}, {471,0.03572072}, {472,0.03514414}, {473,0.03723423}, {474,0.03775676}, {475,0.03805405}, {476,0.03572072}, {477,0.03604505}, {478,0.03603604}, {479,0.03648649}, {480,0.03544144}, {481,0.03583784}, {482,0.03732432}, {483,0.03836937}, {484,0.03805405}, {485,0.03637838}, {486,0.03645946}, {487,0.03691892}, {488,0.03627027}, {489,0.03667568}, {490,0.03678378}, {491,0.03705405}, {492,0.03798198}, {493,0.03937838}, {494,0.03928829}, {495,0.03975676}, {496,0.03864865}, {497,0.03732432}, {498,0.03732432}, {499,0.03769369}, {500,0.03757658}, {505,0.03798198}, {510,0.03881081}, {515,0.03832432}, {520,0.03836036}, {525,0.03931532}, {530,0.03938739}, {535,0.04040541}, {540,0.04044144}, {545,0.04037838}, {550,0.04117117}, {555,0.04186486}, {560,0.04148649}, {565,0.04260360}, {570,0.04303604}, {575,0.04412613}, {580,0.04290991}, {585,0.04374775}, {590,0.04463964}, {595,0.04661261}, {600,0.04654955}, {605,0.04781081}, {610,0.04754955}, {615,0.04684685}, {620,0.04676577}, {625,0.04701802}, {630,0.05198198}, {635,0.05161261}, {640,0.04894595}, {645,0.04837838}, {650,0.04865766}, {655,0.04991892}, {660,0.05121622}, {665,0.05189189}, {670,0.05092793}, {675,0.05093694}, {680,0.05390991}, {685,0.05395495}, {690,0.05213514}, {695,0.05347748}, {700,0.05481081}, {705,0.05282883}, {710,0.05375676}, {715,0.05722523}, {720,0.05561261}, {725,0.05526126}, {730,0.05957658}, {735,0.05898198}, {740,0.05587387}, {745,0.05860360}, {750,0.05761261}, {755,0.06091892}, {760,0.05945045}, {765,0.05927027}, {770,0.06049550}, {775,0.05873874}, {780,0.06136036}, {785,0.06061261}, {790,0.06487387}, {795,0.06287387}, {800,0.05973874}, {805,0.06250450}, {810,0.06133333}, {815,0.06494595}, {820,0.06212613}, {825,0.06559459}, {830,0.06421622}, {835,0.06473874}, {840,0.06603604}, {845,0.06608108}, {850,0.06713514}, {855,0.06605405}, {860,0.06845045}, {865,0.06547748}, {870,0.06845946}, {875,0.06981982}, {880,0.06662162}, {885,0.07145946}, {890,0.06875676}, {895,0.07220721}, {900,0.07074775}, {905,0.06868468}, {910,0.07127928}, {915,0.07305405}, {920,0.06986486}, {925,0.07282883}, {930,0.07364865}, {935,0.07470270}, {940,0.07187387}, {945,0.07582883}, {950,0.07614414}, {955,0.07648649}, {960,0.07190991}, {965,0.07564865}, {970,0.07721622}, {975,0.07837838}, {980,0.07485586}, {985,0.07623423}, {990,0.08081982}, {995,0.07968468}, {1000,0.07923423}, {1010,0.08027928}, {1020,0.08422523}, {1030,0.07793694}, {1040,0.07809009}, {1050,0.08371171}, {1060,0.08375676}, {1070,0.08593694}, {1080,0.08564865}, {1090,0.08562162}, {1100,0.08731532}, {1110,0.08879279}, {1120,0.08810811}, {1130,0.09051351}, {1140,0.09140541}, {1150,0.09026126}, {1160,0.09427928}, {1170,0.09143243}, {1180,0.09280180}, {1190,0.09464865}, {1200,0.09505405}, {1210,0.09798198}, {1220,0.09628829}, {1230,0.09829730}, {1240,0.09855856}, {1250,0.10000000}, {1260,0.10023423}, {1270,0.10251351}, {1280,0.09992793}, {1290,0.10065766}, {1300,0.10227027}, {1310,0.10617117}, {1320,0.10509009}, {1330,0.10732432}, {1340,0.10798198}, {1350,0.10909009}, {1360,0.10904505}, {1370,0.11135135}, {1380,0.10841441}, {1390,0.11217117}, {1400,0.11088288}, {1410,0.11095495}, {1420,0.11168468}, {1430,0.11413514}, {1440,0.11278378}, {1450,0.11491892}, {1460,0.11775676}, {1470,0.11944144}, {1480,0.11809910}, {1490,0.12016216}, {1500,0.12143243}, {1510,0.12163063}, {1520,0.12053153}, {1530,0.12333333}, {1540,0.12145045}, {1550,0.12333333}, {1560,0.12279279}, {1570,0.12323423}, {1580,0.12469369}, {1590,0.12819820}, {1600,0.12425225}, {1610,0.12675676}, {1620,0.12628829}, {1630,0.12916216}, {1640,0.12709009}, {1650,0.12904505}, {1660,0.13125225}, {1670,0.13119820}, {1680,0.12996396}, {1690,0.13439640}, {1700,0.13893694}, {1710,0.13728829}, {1720,0.13734234}, {1730,0.14127928}, {1740,0.13943243}, {1750,0.13978378}, {1760,0.14089189}, {1770,0.14235135}, {1780,0.14430631}, {1790,0.14398198}, {1800,0.14068468}, {1810,0.14730631}, {1820,0.14514414}, {1830,0.14600901}, {1840,0.15071171}, {1850,0.14658559}, {1860,0.14666667}, {1870,0.15074775}, {1880,0.15034234}, {1890,0.15182883}, {1900,0.15146847}, {1910,0.15665766}, {1920,0.14877477}, {1930,0.15474775}, {1940,0.15381081}, {1950,0.15774775}, {1960,0.15792793}, {1970,0.15842342}, {1980,0.16431532}, {1990,0.15826126}, {2000,0.15916216}, {2050,0.16509009}, {2100,0.16651351}, {2150,0.17018919}, {2200,0.17150450}, {2250,0.17758559}, {2300,0.18635135}, {2350,0.19549550}, {2400,0.18981081}, {2450,0.19486486}, {2500,1.46343243}, {2550,0.21016216}, {2600,0.22028829}, {2650,0.21527027}, {2700,0.21378378}, {2750,0.22825225}, {2800,0.22381982}, {2850,0.22541441}, {2900,0.23270270}, {2950,0.23797297}, {3000,0.24280180}, {3050,0.24766667}, {3100,0.24778378}, {3150,0.25396396}, {3200,0.24832432}, {3250,0.25783784}, {3300,0.26267568}, {3350,0.26581982}, {3400,0.26778378}, {3450,0.28665766}, {3500,0.28260360}, {3550,0.28987387}, {3600,0.28328829}, {3650,0.29078378}, {3700,0.29543243}, {3750,0.30166667}, {3800,0.30718018}, {3850,0.30788288}, {3900,0.31699099}, {3950,0.32981081}, {4000,0.31873874}, {4050,0.32469369}, {4100,0.32179279}, {4150,0.34073874}, {4200,0.33206306}, {4250,0.35282883}, {4300,0.34653153}, {4350,0.36224324}, {4400,0.35220721}, {4450,0.36136036}, {4500,0.37160360}, {4550,0.36518018}, {4600,0.37614414}, {4650,0.37472072}, {4700,0.38132432}, {4750,0.38137838}, {4800,0.38793694}, {4850,0.39948649}, {4900,0.39966667}, {4950,0.40836937}, {5000,0.40276577}, {5050,0.41954054}, {5100,0.42390090}, {5150,0.42132432}, {5200,0.40588288}, {5250,0.41987387}, {5300,0.43793694}, {5350,0.43888288}, {5400,0.43585586}, {5450,0.44571171}, {5500,0.45754955}, {5550,0.47604505}, {5600,0.45240541}, {5650,0.45559459}, {5700,0.45961261}, {5750,0.47154955}, {5800,0.48219820}, {5850,0.48762162}, {5900,0.47454955}, {5950,0.48363063}, {6000,0.48756757}, {6050,0.49050}, {6100,0.50950}, {6150,0.50000}, {6200,0.50600}, {6250,0.52025}, {6300,0.51400}, {6350,0.52550}, {6400,0.49900}, {6450,0.52550}, {6500,0.52475}, {6550,0.53100}, {6600,0.53500}, {6650,0.55550}, {6700,0.54675}, {6750,0.56100}, {6800,0.54900}, {6850,0.55350}, {6900,0.58475}, {6950,0.57025}, {7000,0.57475}, {7050,0.57150}, {7100,0.58200}, {7150,0.60050}, {7200,0.59075}, {7250,0.59600}, {7300,0.58350}, {7350,0.62450}, {7400,0.60375}, {7450,0.61825}, {7500,0.63850}, {7550,0.64600}, {7600,0.63675}, {7650,0.64950}, {7700,0.63175}, {7750,0.64175}, {7800,0.64725}, {7850,0.66125}, {7900,0.65825}, {7950,0.65475}, {8000,0.65175}, {8050,0.67650}, {8100,0.67575}, {8150,0.68900}, {8200,0.65350}, {8250,0.68175}, {8300,0.67750}, {8350,0.70950}, {8400,0.67875}, {8450,0.70050}, {8500,0.69550}, {8550,0.71225}, {8600,0.72550}, {8650,0.71075}, {8700,0.75575}, {8750,0.74475}, {8800,0.72325}, {8850,0.72750}, {8900,0.73150}, {8950,0.76050}, {9000,0.74950}, {9050,0.76750}, {9100,0.76500}, {9150,0.80300}, {9200,0.79300}, {9250,0.76675}, {9300,0.77675}, {9350,0.77500}, {9400,0.78250}, {9450,0.78975}, {9500,0.76975}, {9550,0.80475}, {9600,0.76625}, {9650,0.82150}, {9700,0.81825}, {9750,0.81000}, {9800,0.80650}, {9850,0.84825}, {9900,0.82825}, {9950,0.83550}, {10000,0.84550}, {10100,0.86200}, {10200,0.87600}, {10300,0.85900}, {10400,0.85125}, {10500,0.85925}, {10600,0.89125}, {10700,0.89475}, {10800,0.88475}, {10900,0.92375}, {11000,0.93950}, {11100,0.93775}, {11200,0.92675}, {11300,0.95150}, {11400,0.93200}, {11500,0.97875}, {11600,0.96625}, {11700,0.99700}, {11800,0.97450}, {11900,1.01975}, {12000,1.00225}, {12100,1.01475}, {12200,1.06650}, {12300,1.00100}, {12400,1.03925}, {12500,1.06725}, {12600,1.06725}, {12700,1.07650}, {12800,1.05900}, {12900,1.09150}, {13000,1.09300}, {13100,1.10375}, {13200,1.11075}, {13300,1.13600}, {13400,1.12000}, {13500,1.15150}, {13600,1.11625}, {13700,1.14275}, {13800,1.19375}, {13900,1.16625}, {14000,1.18175}, {14100,1.18925}, {14200,1.23050}, {14300,1.28450}, {14400,1.16825}, {14500,1.22500}, {14600,1.20925}, {14700,1.25125}, {14800,1.29125}, {14900,1.24950}, {15000,1.28025}, {15100,1.31125}, {15200,1.29900}, {15300,1.32250}, {15400,1.27675}, {15500,1.29600}, {15600,1.32975}, {15700,1.33750}, {15800,1.35625}, {15900,1.39900}, {16000,1.31400}, {16100,1.42150}, {16200,1.39650}, {16300,1.45550}, {16400,1.34375}, {16500,1.39925}, {16600,1.38675}, {16700,1.43275}, {16800,1.39600}, {16900,1.37525}, {17000,1.42450}, {17100,1.48200}, {17200,1.43450}, {17300,1.46125}, {17400,1.50450}, {17500,1.52700}, {17600,1.44700}, {17700,1.49650}, {17800,1.48700}, {17900,1.55625}, {18000,1.54100}, {18100,1.56900}, {18200,1.54875}, {18300,1.60400}, {18400,1.56650}, {18500,1.53325}, {18600,1.58325}, {18700,1.57850}, {18800,1.63050}, {18900,1.61375}, {19000,1.60275}, {19100,1.67400}, {19200,1.58950}, {19300,1.67475}, {19400,1.66075}, {19500,1.65150}, {19600,1.64275}, {19700,1.75275}, {19800,1.68550}, {19900,1.72650}, {20000,1.6395}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["reif"]["user"] = {{1,0.00018919}, {2,0.00027928}, {3,0.00049550}, {4,0.00051351}, {5,0.00062162}, {6,0.00072072}, {7,0.00052252}, {8,0.00084685}, {9,0.00093694}, {10,0.00073874}, {11,0.00094595}, {12,0.00091892}, {13,0.00112613}, {14,0.00109009}, {15,0.00116216}, {16,0.00146847}, {17,0.00139640}, {18,0.00165766}, {19,0.00167568}, {20,0.00160360}, {21,0.00172072}, {22,0.00164865}, {23,0.00181982}, {24,0.00194595}, {25,0.00184685}, {26,0.00191892}, {27,0.00224324}, {28,0.00200000}, {29,0.00206306}, {30,0.00224324}, {31,0.00254054}, {32,0.00209009}, {33,0.00242342}, {34,0.00242342}, {35,0.00268468}, {36,0.00225225}, {37,0.00290090}, {38,0.00299099}, {39,0.00266667}, {40,0.00259459}, {41,0.00313514}, {42,0.00290090}, {43,0.00320721}, {44,0.00316216}, {45,0.00328829}, {46,0.00335135}, {47,0.00334234}, {48,0.00326126}, {49,0.00350450}, {50,0.00358559}, {51,0.00366667}, {52,0.00357658}, {53,0.00357658}, {54,0.00392793}, {55,0.00378378}, {56,0.00406306}, {57,0.00410811}, {58,0.00429730}, {59,0.00403604}, {60,0.00425225}, {61,0.00458559}, {62,0.00421622}, {63,0.00436937}, {64,0.00469369}, {65,0.00468468}, {66,0.00437838}, {67,0.00477477}, {68,0.00500901}, {69,0.00503604}, {70,0.00525225}, {71,0.00520721}, {72,0.00617117}, {73,0.00527928}, {74,0.00522523}, {75,0.00536937}, {76,0.00577477}, {77,0.00531532}, {78,0.00685586}, {79,0.00567568}, {80,0.00581982}, {81,0.00560360}, {82,0.00612613}, {83,0.00600901}, {84,0.00715315}, {85,0.00611712}, {86,0.00669369}, {87,0.00656757}, {88,0.00680180}, {89,0.00667568}, {90,0.00682883}, {91,0.00674775}, {92,0.00658559}, {93,0.00672072}, {94,0.00698198}, {95,0.00724324}, {96,0.00698198}, {97,0.00748649}, {98,0.00742342}, {99,0.00736937}, {100,0.00756757}, {101,0.00772072}, {102,0.00785586}, {103,0.00811712}, {104,0.00872973}, {105,0.00790090}, {106,0.00784685}, {107,0.00786486}, {108,0.00786486}, {109,0.00808108}, {110,0.00821622}, {111,0.00843243}, {112,0.00838739}, {113,0.00918919}, {114,0.00854054}, {115,0.00894595}, {116,0.00889189}, {117,0.00903604}, {118,0.00876577}, {119,0.00903604}, {120,0.00889189}, {121,0.00890991}, {122,0.00909910}, {123,0.00909910}, {124,0.00950450}, {125,0.00920721}, {126,0.00926126}, {127,0.00947748}, {128,0.00938739}, {129,0.00933333}, {130,0.00945946}, {131,0.00988288}, {132,0.00968468}, {133,0.01079279}, {134,0.01007207}, {135,0.01004505}, {136,0.01007207}, {137,0.01076577}, {138,0.00992793}, {139,0.01003604}, {140,0.01004505}, {141,0.01027928}, {142,0.01067568}, {143,0.01051351}, {144,0.01107207}, {145,0.01045946}, {146,0.01043243}, {147,0.01058559}, {148,0.01078378}, {149,0.01114414}, {150,0.01079279}, {151,0.01104505}, {152,0.01094595}, {153,0.01109009}, {154,0.01206306}, {155,0.01118919}, {156,0.01137838}, {157,0.01132432}, {158,0.01125225}, {159,0.01166667}, {160,0.01148649}, {161,0.01178378}, {162,0.01189189}, {163,0.01205405}, {164,0.01182883}, {165,0.01209009}, {166,0.01209009}, {167,0.01245045}, {168,0.01225225}, {169,0.01260360}, {170,0.01245045}, {171,0.01285586}, {172,0.01250450}, {173,0.01302703}, {174,0.01319820}, {175,0.01306306}, {176,0.01303604}, {177,0.01273874}, {178,0.01325225}, {179,0.01337838}, {180,0.01340541}, {181,0.01355856}, {182,0.01354955}, {183,0.01383784}, {184,0.01350450}, {185,0.01391892}, {186,0.01384685}, {187,0.01489189}, {188,0.01429730}, {189,0.01417117}, {190,0.01437838}, {191,0.01424324}, {192,0.01426126}, {193,0.01436937}, {194,0.01427027}, {195,0.01589189}, {196,0.01428829}, {197,0.01486486}, {198,0.01487387}, {199,0.01464865}, {200,0.01488288}, {201,0.01486486}, {202,0.01505405}, {203,0.01629730}, {204,0.01524324}, {205,0.01540541}, {206,0.01564865}, {207,0.01587387}, {208,0.01646847}, {209,0.01562162}, {210,0.01596396}, {211,0.01585586}, {212,0.01599099}, {213,0.01598198}, {214,0.01593694}, {215,0.01624324}, {216,0.01620721}, {217,0.01620721}, {218,0.01634234}, {219,0.01640541}, {220,0.01730631}, {221,0.01685586}, {222,0.01652252}, {223,0.01664865}, {224,0.01618018}, {225,0.01662162}, {226,0.01664865}, {227,0.01764865}, {228,0.01708108}, {229,0.01715315}, {230,0.01685586}, {231,0.01728829}, {232,0.01679279}, {233,0.01737838}, {234,0.01736036}, {235,0.01742342}, {236,0.01817117}, {237,0.01765766}, {238,0.01854955}, {239,0.01762162}, {240,0.01789189}, {241,0.01774775}, {242,0.01768468}, {243,0.01772973}, {244,0.01789189}, {245,0.01800000}, {246,0.01814414}, {247,0.01844144}, {248,0.01790991}, {249,0.01897297}, {250,0.01833333}, {251,0.01969369}, {252,0.01849550}, {253,0.01968468}, {254,0.01850450}, {255,0.02005405}, {256,0.01833333}, {257,0.01954054}, {258,0.01858559}, {259,0.02018018}, {260,0.01875676}, {261,0.02050450}, {262,0.01887387}, {263,0.02091892}, {264,0.01897297}, {265,0.02063964}, {266,0.01917117}, {267,0.02140541}, {268,0.01936937}, {269,0.02098198}, {270,0.01972072}, {271,0.02111712}, {272,0.01945946}, {273,0.02070270}, {274,0.01986486}, {275,0.02130631}, {276,0.02000000}, {277,0.02130631}, {278,0.02017117}, {279,0.02048649}, {280,0.02030631}, {281,0.02051351}, {282,0.02018919}, {283,0.02115315}, {284,0.02042342}, {285,0.02085586}, {286,0.02249550}, {287,0.02112613}, {288,0.02191892}, {289,0.02110811}, {290,0.02227928}, {291,0.02130631}, {292,0.02108108}, {293,0.02137838}, {294,0.02134234}, {295,0.02163063}, {296,0.02141441}, {297,0.02387387}, {298,0.02172072}, {299,0.02191892}, {300,0.02235135}, {301,0.02184685}, {302,0.02254955}, {303,0.02226126}, {304,0.02444144}, {305,0.02224324}, {306,0.02215315}, {307,0.02279279}, {308,0.02249550}, {309,0.02310811}, {310,0.02286486}, {311,0.02472072}, {312,0.02308108}, {313,0.02310811}, {314,0.02331532}, {315,0.02348649}, {316,0.02633333}, {317,0.02369369}, {318,0.02365766}, {319,0.02422523}, {320,0.02342342}, {321,0.02522523}, {322,0.02353153}, {323,0.02403604}, {324,0.02363063}, {325,0.02426126}, {326,0.02554955}, {327,0.02440541}, {328,0.02390090}, {329,0.02571171}, {330,0.02433333}, {331,0.02463063}, {332,0.02444144}, {333,0.02473874}, {334,0.02648649}, {335,0.02518919}, {336,0.02461261}, {337,0.02617117}, {338,0.02494595}, {339,0.02497297}, {340,0.02483784}, {341,0.02559459}, {342,0.02523423}, {343,0.02539640}, {344,0.02552252}, {345,0.02692793}, {346,0.02595495}, {347,0.02607207}, {348,0.02742342}, {349,0.02575676}, {350,0.02572072}, {351,0.02813514}, {352,0.02550450}, {353,0.02588288}, {354,0.02762162}, {355,0.02597297}, {356,0.02615315}, {357,0.02806306}, {358,0.02651351}, {359,0.02692793}, {360,0.02814414}, {361,0.02654955}, {362,0.02664865}, {363,0.02868468}, {364,0.02691892}, {365,0.02728829}, {366,0.02909009}, {367,0.02745045}, {368,0.02701802}, {369,0.02737838}, {370,0.02914414}, {371,0.02778378}, {372,0.02763063}, {373,0.02950450}, {374,0.02768468}, {375,0.02809910}, {376,0.02968468}, {377,0.02831532}, {378,0.02829730}, {379,0.02859459}, {380,0.02991892}, {381,0.02844144}, {382,0.02896396}, {383,0.03092793}, {384,0.02769369}, {385,0.02840541}, {386,0.02825225}, {387,0.03022523}, {388,0.02818018}, {389,0.02890991}, {390,0.02869369}, {391,0.03126126}, {392,0.02867568}, {393,0.02941441}, {394,0.03093694}, {395,0.02961261}, {396,0.02944144}, {397,0.02957658}, {398,0.03166667}, {399,0.03008108}, {400,0.02943243}, {401,0.02991892}, {402,0.03154955}, {403,0.03064865}, {404,0.03014414}, {405,0.03028829}, {406,0.03220721}, {407,0.03072973}, {408,0.03067568}, {409,0.03064865}, {410,0.03250450}, {411,0.03362162}, {412,0.03101802}, {413,0.03118018}, {414,0.03118919}, {415,0.03307207}, {416,0.03062162}, {417,0.03116216}, {418,0.03137838}, {419,0.03275676}, {420,0.03363063}, {421,0.03175676}, {422,0.03200000}, {423,0.03215315}, {424,0.03303604}, {425,0.03485586}, {426,0.03214414}, {427,0.03244144}, {428,0.03225225}, {429,0.03410811}, {430,0.03545946}, {431,0.03328829}, {432,0.03236937}, {433,0.03263063}, {434,0.03391892}, {435,0.03505405}, {436,0.03290090}, {437,0.03303604}, {438,0.03313514}, {439,0.03481982}, {440,0.03515315}, {441,0.03361261}, {442,0.03340541}, {443,0.03370270}, {444,0.03354054}, {445,0.03505405}, {446,0.03611712}, {447,0.03464865}, {448,0.03292793}, {449,0.03354054}, {450,0.03348649}, {451,0.03474775}, {452,0.03566667}, {453,0.03391892}, {454,0.03411712}, {455,0.03445946}, {456,0.03402703}, {457,0.03415315}, {458,0.03540541}, {459,0.03641441}, {460,0.03434234}, {461,0.03484685}, {462,0.03482883}, {463,0.03516216}, {464,0.03430631}, {465,0.03590991}, {466,0.03683784}, {467,0.03491892}, {468,0.03502703}, {469,0.03541441}, {470,0.03525225}, {471,0.03578378}, {472,0.03521622}, {473,0.03720721}, {474,0.03756757}, {475,0.03762162}, {476,0.03574775}, {477,0.03628829}, {478,0.03599099}, {479,0.03633333}, {480,0.03549550}, {481,0.03564865}, {482,0.03692793}, {483,0.03801802}, {484,0.03774775}, {485,0.03632432}, {486,0.03662162}, {487,0.03672973}, {488,0.03636036}, {489,0.03659459}, {490,0.03670270}, {491,0.03677477}, {492,0.03785586}, {493,0.03891892}, {494,0.03918018}, {495,0.03941441}, {496,0.03797297}, {497,0.03676577}, {498,0.03733333}, {499,0.03763964}, {500,0.03721622}, {505,0.03759459}, {510,0.03853153}, {515,0.03814414}, {520,0.03854054}, {525,0.03907207}, {530,0.03915315}, {535,0.04010811}, {540,0.04049550}, {545,0.04056757}, {550,0.04106306}, {555,0.04153153}, {560,0.04170270}, {565,0.04281081}, {570,0.04318919}, {575,0.04440541}, {580,0.04338739}, {585,0.04382883}, {590,0.04485586}, {595,0.04656757}, {600,0.04638739}, {605,0.04763063}, {610,0.04734234}, {615,0.04698198}, {620,0.04690991}, {625,0.04691892}, {630,0.05147748}, {635,0.05099099}, {640,0.04883784}, {645,0.04833333}, {650,0.04843243}, {655,0.04961261}, {660,0.05089189}, {665,0.05143243}, {670,0.05060360}, {675,0.05073874}, {680,0.05369369}, {685,0.05333333}, {690,0.05179279}, {695,0.05343243}, {700,0.05473874}, {705,0.05251351}, {710,0.05332432}, {715,0.05732432}, {720,0.05527928}, {725,0.05491892}, {730,0.05976577}, {735,0.05905405}, {740,0.05579279}, {745,0.05868468}, {750,0.05789189}, {755,0.06115315}, {760,0.05936937}, {765,0.05929730}, {770,0.06064865}, {775,0.05902703}, {780,0.06154054}, {785,0.06079279}, {790,0.06509009}, {795,0.06332432}, {800,0.05981982}, {805,0.06291892}, {810,0.06108108}, {815,0.06521622}, {820,0.06260360}, {825,0.06591892}, {830,0.06444144}, {835,0.06497297}, {840,0.06602703}, {845,0.06588288}, {850,0.06678378}, {855,0.06646847}, {860,0.06826126}, {865,0.06537838}, {870,0.06827027}, {875,0.06953153}, {880,0.06646847}, {885,0.07119820}, {890,0.06865766}, {895,0.07258559}, {900,0.07057658}, {905,0.06881081}, {910,0.07163964}, {915,0.07294595}, {920,0.06990991}, {925,0.07257658}, {930,0.07358559}, {935,0.07492793}, {940,0.07162162}, {945,0.07573874}, {950,0.07625225}, {955,0.07681982}, {960,0.07200901}, {965,0.07598198}, {970,0.07718018}, {975,0.07823423}, {980,0.07499099}, {985,0.07654955}, {990,0.08018919}, {995,0.07964865}, {1000,0.07918919}, {1010,0.07974775}, {1020,0.08422523}, {1030,0.07777477}, {1040,0.07815315}, {1050,0.08350450}, {1060,0.08373874}, {1070,0.08572973}, {1080,0.08561261}, {1090,0.08598198}, {1100,0.08715315}, {1110,0.08874775}, {1120,0.08842342}, {1130,0.08996396}, {1140,0.09091892}, {1150,0.09002703}, {1160,0.09381081}, {1170,0.09093694}, {1180,0.09253153}, {1190,0.09450450}, {1200,0.09478378}, {1210,0.09773874}, {1220,0.09601802}, {1230,0.09845045}, {1240,0.09861261}, {1250,0.10000901}, {1260,0.09990090}, {1270,0.10251351}, {1280,0.09995495}, {1290,0.10061261}, {1300,0.10211712}, {1310,0.10597297}, {1320,0.10460360}, {1330,0.10704505}, {1340,0.10770270}, {1350,0.10872072}, {1360,0.10877477}, {1370,0.11118919}, {1380,0.10824324}, {1390,0.11209009}, {1400,0.11085586}, {1410,0.11098198}, {1420,0.11144144}, {1430,0.11369369}, {1440,0.11266667}, {1450,0.11436036}, {1460,0.11727928}, {1470,0.11896396}, {1480,0.11804505}, {1490,0.11974775}, {1500,0.12120721}, {1510,0.12143243}, {1520,0.12026126}, {1530,0.12303604}, {1540,0.12134234}, {1550,0.12296396}, {1560,0.12298198}, {1570,0.12321622}, {1580,0.12472973}, {1590,0.12831532}, {1600,0.12449550}, {1610,0.12699099}, {1620,0.12691892}, {1630,0.12965766}, {1640,0.12718919}, {1650,0.12910811}, {1660,0.13098198}, {1670,0.13106306}, {1680,0.12975676}, {1690,0.13434234}, {1700,0.13871171}, {1710,0.13697297}, {1720,0.13759459}, {1730,0.14129730}, {1740,0.13933333}, {1750,0.13991892}, {1760,0.14087387}, {1770,0.14229730}, {1780,0.14388288}, {1790,0.14418919}, {1800,0.14104505}, {1810,0.14718018}, {1820,0.14510811}, {1830,0.14588288}, {1840,0.15086486}, {1850,0.14636036}, {1860,0.14636937}, {1870,0.15109910}, {1880,0.15035135}, {1890,0.15180180}, {1900,0.15141441}, {1910,0.15647748}, {1920,0.14878378}, {1930,0.15466667}, {1940,0.15369369}, {1950,0.15744144}, {1960,0.15776577}, {1970,0.15808108}, {1980,0.16445946}, {1990,0.15824324}, {2000,0.15916216}, {2050,0.16533333}, {2100,0.16646847}, {2150,0.16984685}, {2200,0.17133333}, {2250,0.17772973}, {2300,0.18599099}, {2350,0.19514414}, {2400,0.18983784}, {2450,0.19468468}, {2500,1.46090090}, {2550,0.20977477}, {2600,0.21974775}, {2650,0.21468468}, {2700,0.21359459}, {2750,0.22788288}, {2800,0.22345045}, {2850,0.22517117}, {2900,0.23245946}, {2950,0.23778378}, {3000,0.24244144}, {3050,0.24715315}, {3100,0.24794595}, {3150,0.25427027}, {3200,0.24819820}, {3250,0.25800000}, {3300,0.26272973}, {3350,0.26572072}, {3400,0.26786486}, {3450,0.28669369}, {3500,0.28275676}, {3550,0.29009910}, {3600,0.28323423}, {3650,0.29069369}, {3700,0.29555856}, {3750,0.30151351}, {3800,0.30726126}, {3850,0.30788288}, {3900,0.31680180}, {3950,0.32918018}, {4000,0.31837838}, {4050,0.32431532}, {4100,0.32166667}, {4150,0.34041441}, {4200,0.33202703}, {4250,0.35274775}, {4300,0.34642342}, {4350,0.36183784}, {4400,0.35181982}, {4450,0.36102703}, {4500,0.37128829}, {4550,0.36485586}, {4600,0.37577477}, {4650,0.37444144}, {4700,0.38125225}, {4750,0.38109009}, {4800,0.38781982}, {4850,0.39927027}, {4900,0.39958559}, {4950,0.40840541}, {5000,0.40233333}, {5050,0.41919820}, {5100,0.42388288}, {5150,0.42107207}, {5200,0.40581081}, {5250,0.41976577}, {5300,0.43799099}, {5350,0.43866667}, {5400,0.43583784}, {5450,0.44544144}, {5500,0.45723423}, {5550,0.47572973}, {5600,0.45200000}, {5650,0.45537838}, {5700,0.45964865}, {5750,0.47103604}, {5800,0.48136937}, {5850,0.48699099}, {5900,0.47372072}, {5950,0.48278378}, {6000,0.48706306}, {6050,0.49075}, {6100,0.50650}, {6150,0.49975}, {6200,0.50600}, {6250,0.51950}, {6300,0.51425}, {6350,0.52425}, {6400,0.49900}, {6450,0.52425}, {6500,0.52325}, {6550,0.53125}, {6600,0.53550}, {6650,0.55450}, {6700,0.54550}, {6750,0.55825}, {6800,0.54750}, {6850,0.55350}, {6900,0.58400}, {6950,0.56850}, {7000,0.57550}, {7050,0.57175}, {7100,0.57825}, {7150,0.60050}, {7200,0.58850}, {7250,0.59525}, {7300,0.58225}, {7350,0.62350}, {7400,0.60450}, {7450,0.61700}, {7500,0.63700}, {7550,0.64550}, {7600,0.63650}, {7650,0.65025}, {7700,0.63150}, {7750,0.64250}, {7800,0.64725}, {7850,0.66075}, {7900,0.65800}, {7950,0.65525}, {8000,0.65200}, {8050,0.67500}, {8100,0.67425}, {8150,0.68925}, {8200,0.65375}, {8250,0.68000}, {8300,0.67750}, {8350,0.70850}, {8400,0.67625}, {8450,0.70000}, {8500,0.69300}, {8550,0.71200}, {8600,0.72425}, {8650,0.70975}, {8700,0.75575}, {8750,0.74375}, {8800,0.72225}, {8850,0.72850}, {8900,0.73125}, {8950,0.75950}, {9000,0.74950}, {9050,0.76850}, {9100,0.76475}, {9150,0.80250}, {9200,0.79200}, {9250,0.76575}, {9300,0.77650}, {9350,0.77375}, {9400,0.78200}, {9450,0.78825}, {9500,0.77075}, {9550,0.80350}, {9600,0.76550}, {9650,0.82275}, {9700,0.81775}, {9750,0.81025}, {9800,0.80525}, {9850,0.84600}, {9900,0.82750}, {9950,0.83575}, {10000,0.84575}, {10100,0.86150}, {10200,0.87525}, {10300,0.85950}, {10400,0.85100}, {10500,0.85850}, {10600,0.89050}, {10700,0.89450}, {10800,0.88550}, {10900,0.92350}, {11000,0.93850}, {11100,0.93825}, {11200,0.92650}, {11300,0.95025}, {11400,0.92950}, {11500,0.97875}, {11600,0.96450}, {11700,0.99700}, {11800,0.97300}, {11900,1.01850}, {12000,1.00075}, {12100,1.01500}, {12200,1.06650}, {12300,1.00000}, {12400,1.03950}, {12500,1.06900}, {12600,1.06675}, {12700,1.07750}, {12800,1.05875}, {12900,1.09075}, {13000,1.09375}, {13100,1.10475}, {13200,1.11000}, {13300,1.13550}, {13400,1.11950}, {13500,1.15050}, {13600,1.11525}, {13700,1.14325}, {13800,1.19350}, {13900,1.16550}, {14000,1.18225}, {14100,1.18825}, {14200,1.22750}, {14300,1.28550}, {14400,1.16825}, {14500,1.22525}, {14600,1.20725}, {14700,1.25025}, {14800,1.29025}, {14900,1.24975}, {15000,1.28150}, {15100,1.31025}, {15200,1.29800}, {15300,1.31925}, {15400,1.27750}, {15500,1.29750}, {15600,1.33050}, {15700,1.33850}, {15800,1.35575}, {15900,1.39875}, {16000,1.31450}, {16100,1.42025}, {16200,1.39650}, {16300,1.45500}, {16400,1.34450}, {16500,1.39750}, {16600,1.38650}, {16700,1.43250}, {16800,1.39450}, {16900,1.37450}, {17000,1.42525}, {17100,1.48250}, {17200,1.43300}, {17300,1.46025}, {17400,1.50325}, {17500,1.52850}, {17600,1.44725}, {17700,1.49575}, {17800,1.48825}, {17900,1.55475}, {18000,1.54050}, {18100,1.56800}, {18200,1.54850}, {18300,1.60450}, {18400,1.56675}, {18500,1.53275}, {18600,1.58350}, {18700,1.57875}, {18800,1.62875}, {18900,1.61350}, {19000,1.60250}, {19100,1.67375}, {19200,1.58950}, {19300,1.67450}, {19400,1.65925}, {19500,1.65025}, {19600,1.64275}, {19700,1.75225}, {19800,1.68525}, {19900,1.72650}, {20000,1.6415}};
data["big_flat"]["CanonicalStructuresFlatHOAS"]["reif"]["system"] = {{1,0.00024324}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00002703}, {6,0.00003604}, {7,0.00000000}, {8,0.00003604}, {9,0.00003604}, {10,0.00003604}, {11,0.00000000}, {12,0.00003604}, {13,0.00000000}, {14,0.00000000}, {15,0.00003604}, {16,0.00002703}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00002703}, {23,0.00000000}, {24,0.00002703}, {25,0.00003604}, {26,0.00000000}, {27,0.00003604}, {28,0.00003604}, {29,0.00007207}, {30,0.00003604}, {31,0.00000000}, {32,0.00002703}, {33,0.00003604}, {34,0.00000000}, {35,0.00003604}, {36,0.00003604}, {37,0.00003604}, {38,0.00000000}, {39,0.00006306}, {40,0.00003604}, {41,0.00005405}, {42,0.00003604}, {43,0.00003604}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00003604}, {51,0.00000000}, {52,0.00003604}, {53,0.00000000}, {54,0.00000000}, {55,0.00003604}, {56,0.00000000}, {57,0.00003604}, {58,0.00003604}, {59,0.00000000}, {60,0.00010811}, {61,0.00000000}, {62,0.00002703}, {63,0.00002703}, {64,0.00000000}, {65,0.00003604}, {66,0.00000000}, {67,0.00002703}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00003604}, {73,0.00006306}, {74,0.00003604}, {75,0.00003604}, {76,0.00003604}, {77,0.00000000}, {78,0.00005405}, {79,0.00000000}, {80,0.00003604}, {81,0.00003604}, {82,0.00002703}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00003604}, {87,0.00002703}, {88,0.00009910}, {89,0.00000000}, {90,0.00007207}, {91,0.00003604}, {92,0.00006306}, {93,0.00000000}, {94,0.00003604}, {95,0.00000000}, {96,0.00003604}, {97,0.00003604}, {98,0.00000000}, {99,0.00002703}, {100,0.00006306}, {101,0.00003604}, {102,0.00000000}, {103,0.00000000}, {104,0.00003604}, {105,0.00002703}, {106,0.00003604}, {107,0.00002703}, {108,0.00003604}, {109,0.00003604}, {110,0.00007207}, {111,0.00000000}, {112,0.00000000}, {113,0.00002703}, {114,0.00000000}, {115,0.00000000}, {116,0.00003604}, {117,0.00000000}, {118,0.00000000}, {119,0.00003604}, {120,0.00000000}, {121,0.00003604}, {122,0.00003604}, {123,0.00000000}, {124,0.00003604}, {125,0.00002703}, {126,0.00009009}, {127,0.00000000}, {128,0.00003604}, {129,0.00003604}, {130,0.00003604}, {131,0.00002703}, {132,0.00010811}, {133,0.00006306}, {134,0.00000000}, {135,0.00000000}, {136,0.00003604}, {137,0.00002703}, {138,0.00003604}, {139,0.00000000}, {140,0.00007207}, {141,0.00007207}, {142,0.00000000}, {143,0.00000000}, {144,0.00007207}, {145,0.00003604}, {146,0.00003604}, {147,0.00007207}, {148,0.00000000}, {149,0.00003604}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00007207}, {154,0.00002703}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00003604}, {159,0.00000000}, {160,0.00003604}, {161,0.00000000}, {162,0.00003604}, {163,0.00000000}, {164,0.00000000}, {165,0.00003604}, {166,0.00003604}, {167,0.00007207}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00003604}, {173,0.00003604}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00003604}, {178,0.00003604}, {179,0.00003604}, {180,0.00003604}, {181,0.00003604}, {182,0.00000000}, {183,0.00003604}, {184,0.00007207}, {185,0.00007207}, {186,0.00000000}, {187,0.00010811}, {188,0.00000000}, {189,0.00003604}, {190,0.00000000}, {191,0.00003604}, {192,0.00000000}, {193,0.00003604}, {194,0.00000000}, {195,0.00006306}, {196,0.00000000}, {197,0.00003604}, {198,0.00003604}, {199,0.00002703}, {200,0.00000000}, {201,0.00000000}, {202,0.00003604}, {203,0.00000000}, {204,0.00000000}, {205,0.00007207}, {206,0.00002703}, {207,0.00000000}, {208,0.00007207}, {209,0.00006306}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00003604}, {214,0.00000000}, {215,0.00003604}, {216,0.00000000}, {217,0.00007207}, {218,0.00003604}, {219,0.00007207}, {220,0.00000000}, {221,0.00000000}, {222,0.00007207}, {223,0.00007207}, {224,0.00003604}, {225,0.00000000}, {226,0.00000000}, {227,0.00003604}, {228,0.00000000}, {229,0.00003604}, {230,0.00000000}, {231,0.00002703}, {232,0.00000000}, {233,0.00000000}, {234,0.00003604}, {235,0.00007207}, {236,0.00007207}, {237,0.00003604}, {238,0.00000000}, {239,0.00003604}, {240,0.00000000}, {241,0.00010811}, {242,0.00000000}, {243,0.00003604}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00007207}, {250,0.00007207}, {251,0.00009910}, {252,0.00003604}, {253,0.00006306}, {254,0.00000000}, {255,0.00010811}, {256,0.00000000}, {257,0.00014414}, {258,0.00000000}, {259,0.00000000}, {260,0.00003604}, {261,0.00010811}, {262,0.00006306}, {263,0.00003604}, {264,0.00000000}, {265,0.00006306}, {266,0.00007207}, {267,0.00012613}, {268,0.00007207}, {269,0.00003604}, {270,0.00000000}, {271,0.00007207}, {272,0.00000000}, {273,0.00000000}, {274,0.00010811}, {275,0.00010811}, {276,0.00003604}, {277,0.00010811}, {278,0.00000000}, {279,0.00000000}, {280,0.00003604}, {281,0.00003604}, {282,0.00003604}, {283,0.00000000}, {284,0.00003604}, {285,0.00003604}, {286,0.00017117}, {287,0.00003604}, {288,0.00007207}, {289,0.00007207}, {290,0.00014414}, {291,0.00003604}, {292,0.00007207}, {293,0.00003604}, {294,0.00007207}, {295,0.00000000}, {296,0.00000000}, {297,0.00007207}, {298,0.00000000}, {299,0.00010811}, {300,0.00000000}, {301,0.00003604}, {302,0.00000000}, {303,0.00000000}, {304,0.00006306}, {305,0.00003604}, {306,0.00003604}, {307,0.00006306}, {308,0.00007207}, {309,0.00003604}, {310,0.00000000}, {311,0.00020721}, {312,0.00007207}, {313,0.00000000}, {314,0.00000000}, {315,0.00007207}, {316,0.00006306}, {317,0.00003604}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00007207}, {322,0.00000000}, {323,0.00000000}, {324,0.00006306}, {325,0.00000000}, {326,0.00003604}, {327,0.00014414}, {328,0.00003604}, {329,0.00013514}, {330,0.00003604}, {331,0.00000000}, {332,0.00003604}, {333,0.00000000}, {334,0.00003604}, {335,0.00003604}, {336,0.00000000}, {337,0.00003604}, {338,0.00000000}, {339,0.00000000}, {340,0.00003604}, {341,0.00000000}, {342,0.00002703}, {343,0.00000000}, {344,0.00000000}, {345,0.00016216}, {346,0.00000000}, {347,0.00007207}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00002703}, {352,0.00000000}, {353,0.00003604}, {354,0.00007207}, {355,0.00021622}, {356,0.00006306}, {357,0.00013514}, {358,0.00002703}, {359,0.00000000}, {360,0.00003604}, {361,0.00000000}, {362,0.00003604}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00003604}, {367,0.00000000}, {368,0.00003604}, {369,0.00000000}, {370,0.00007207}, {371,0.00000000}, {372,0.00003604}, {373,0.00003604}, {374,0.00000000}, {375,0.00003604}, {376,0.00005405}, {377,0.00000000}, {378,0.00003604}, {379,0.00000000}, {380,0.00010811}, {381,0.00007207}, {382,0.00000000}, {383,0.00006306}, {384,0.00006306}, {385,0.00000000}, {386,0.00007207}, {387,0.00003604}, {388,0.00003604}, {389,0.00003604}, {390,0.00002703}, {391,0.00000000}, {392,0.00003604}, {393,0.00003604}, {394,0.00013514}, {395,0.00006306}, {396,0.00000000}, {397,0.00007207}, {398,0.00003604}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00009910}, {403,0.00000000}, {404,0.00000000}, {405,0.00003604}, {406,0.00000000}, {407,0.00003604}, {408,0.00000000}, {409,0.00000000}, {410,0.00006306}, {411,0.00010811}, {412,0.00007207}, {413,0.00003604}, {414,0.00000000}, {415,0.00014414}, {416,0.00003604}, {417,0.00007207}, {418,0.00003604}, {419,0.00003604}, {420,0.00003604}, {421,0.00003604}, {422,0.00000000}, {423,0.00003604}, {424,0.00007207}, {425,0.00002703}, {426,0.00000000}, {427,0.00000000}, {428,0.00003604}, {429,0.00000000}, {430,0.00025225}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00010811}, {435,0.00007207}, {436,0.00000000}, {437,0.00002703}, {438,0.00003604}, {439,0.00003604}, {440,0.00007207}, {441,0.00000000}, {442,0.00003604}, {443,0.00007207}, {444,0.00007207}, {445,0.00003604}, {446,0.00000000}, {447,0.00003604}, {448,0.00003604}, {449,0.00002703}, {450,0.00000000}, {451,0.00003604}, {452,0.00010811}, {453,0.00009910}, {454,0.00003604}, {455,0.00000000}, {456,0.00000000}, {457,0.00007207}, {458,0.00017117}, {459,0.00009910}, {460,0.00007207}, {461,0.00003604}, {462,0.00007207}, {463,0.00007207}, {464,0.00002703}, {465,0.00000000}, {466,0.00003604}, {467,0.00003604}, {468,0.00007207}, {469,0.00000000}, {470,0.00003604}, {471,0.00003604}, {472,0.00000000}, {473,0.00007207}, {474,0.00007207}, {475,0.00010811}, {476,0.00000000}, {477,0.00002703}, {478,0.00007207}, {479,0.00010811}, {480,0.00000000}, {481,0.00000000}, {482,0.00010811}, {483,0.00024324}, {484,0.00007207}, {485,0.00006306}, {486,0.00000000}, {487,0.00003604}, {488,0.00003604}, {489,0.00006306}, {490,0.00003604}, {491,0.00000000}, {492,0.00006306}, {493,0.00013514}, {494,0.00003604}, {495,0.00007207}, {496,0.00027027}, {497,0.00003604}, {498,0.00002703}, {499,0.00000000}, {500,0.00007207}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00003604}, {525,0.00003604}, {530,0.00003604}, {535,0.00000000}, {540,0.00000000}, {545,0.00010811}, {550,0.00003604}, {555,0.00009910}, {560,0.00000000}, {565,0.00003604}, {570,0.00010811}, {575,0.00003604}, {580,0.00007207}, {585,0.00007207}, {590,0.00003604}, {595,0.00018018}, {600,0.00007207}, {605,0.00010811}, {610,0.00014414}, {615,0.00009910}, {620,0.00007207}, {625,0.00010811}, {630,0.00013514}, {635,0.00013514}, {640,0.00013514}, {645,0.00007207}, {650,0.00010811}, {655,0.00003604}, {660,0.00006306}, {665,0.00010811}, {670,0.00002703}, {675,0.00000000}, {680,0.00013514}, {685,0.00007207}, {690,0.00003604}, {695,0.00010811}, {700,0.00007207}, {705,0.00007207}, {710,0.00003604}, {715,0.00007207}, {720,0.00009910}, {725,0.00000000}, {730,0.00010811}, {735,0.00014414}, {740,0.00003604}, {745,0.00003604}, {750,0.00003604}, {755,0.00012613}, {760,0.00018018}, {765,0.00003604}, {770,0.00014414}, {775,0.00000000}, {780,0.00013514}, {785,0.00006306}, {790,0.00010811}, {795,0.00009910}, {800,0.00003604}, {805,0.00002703}, {810,0.00003604}, {815,0.00000000}, {820,0.00002703}, {825,0.00007207}, {830,0.00000000}, {835,0.00007207}, {840,0.00013514}, {845,0.00018018}, {850,0.00010811}, {855,0.00002703}, {860,0.00027928}, {865,0.00017117}, {870,0.00000000}, {875,0.00025225}, {880,0.00003604}, {885,0.00010811}, {890,0.00003604}, {895,0.00010811}, {900,0.00012613}, {905,0.00000000}, {910,0.00007207}, {915,0.00018018}, {920,0.00010811}, {925,0.00010811}, {930,0.00010811}, {935,0.00010811}, {940,0.00013514}, {945,0.00026126}, {950,0.00021622}, {955,0.00003604}, {960,0.00000000}, {965,0.00000000}, {970,0.00006306}, {975,0.00007207}, {980,0.00000000}, {985,0.00000000}, {990,0.00036036}, {995,0.00010811}, {1000,0.00006306}, {1010,0.00009910}, {1020,0.00021622}, {1030,0.00007207}, {1040,0.00003604}, {1050,0.00018018}, {1060,0.00021622}, {1070,0.00026126}, {1080,0.00013514}, {1090,0.00018018}, {1100,0.00025225}, {1110,0.00020721}, {1120,0.00007207}, {1130,0.00021622}, {1140,0.00020721}, {1150,0.00003604}, {1160,0.00027928}, {1170,0.00003604}, {1180,0.00013514}, {1190,0.00014414}, {1200,0.00020721}, {1210,0.00003604}, {1220,0.00027928}, {1230,0.00024324}, {1240,0.00028829}, {1250,0.00010811}, {1260,0.00018018}, {1270,0.00018018}, {1280,0.00014414}, {1290,0.00014414}, {1300,0.00021622}, {1310,0.00007207}, {1320,0.00007207}, {1330,0.00019820}, {1340,0.00009910}, {1350,0.00010811}, {1360,0.00020721}, {1370,0.00003604}, {1380,0.00018018}, {1390,0.00007207}, {1400,0.00018018}, {1410,0.00009910}, {1420,0.00010811}, {1430,0.00009910}, {1440,0.00021622}, {1450,0.00014414}, {1460,0.00017117}, {1470,0.00018018}, {1480,0.00006306}, {1490,0.00013514}, {1500,0.00010811}, {1510,0.00014414}, {1520,0.00025225}, {1530,0.00018018}, {1540,0.00014414}, {1550,0.00021622}, {1560,0.00021622}, {1570,0.00007207}, {1580,0.00018018}, {1590,0.00018018}, {1600,0.00017117}, {1610,0.00009910}, {1620,0.00013514}, {1630,0.00010811}, {1640,0.00009910}, {1650,0.00007207}, {1660,0.00018018}, {1670,0.00017117}, {1680,0.00010811}, {1690,0.00014414}, {1700,0.00028829}, {1710,0.00010811}, {1720,0.00013514}, {1730,0.00009910}, {1740,0.00014414}, {1750,0.00014414}, {1760,0.00021622}, {1770,0.00010811}, {1780,0.00025225}, {1790,0.00014414}, {1800,0.00007207}, {1810,0.00017117}, {1820,0.00014414}, {1830,0.00010811}, {1840,0.00010811}, {1850,0.00010811}, {1860,0.00007207}, {1870,0.00007207}, {1880,0.00010811}, {1890,0.00003604}, {1900,0.00003604}, {1910,0.00010811}, {1920,0.00006306}, {1930,0.00010811}, {1940,0.00007207}, {1950,0.00018018}, {1960,0.00012613}, {1970,0.00010811}, {1980,0.00003604}, {1990,0.00010811}, {2000,0.00018018}, {2050,0.00010811}, {2100,0.00010811}, {2150,0.00010811}, {2200,0.00010811}, {2250,0.00010811}, {2300,0.00018018}, {2350,0.00018018}, {2400,0.00014414}, {2450,0.00000000}, {2500,0.00213514}, {2550,0.00014414}, {2600,0.00003604}, {2650,0.00007207}, {2700,0.00009009}, {2750,0.00007207}, {2800,0.00014414}, {2850,0.00014414}, {2900,0.00006306}, {2950,0.00014414}, {3000,0.00002703}, {3050,0.00010811}, {3100,0.00010811}, {3150,0.00007207}, {3200,0.00010811}, {3250,0.00009910}, {3300,0.00007207}, {3350,0.00007207}, {3400,0.00010811}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00003604}, {3600,0.00003604}, {3650,0.00003604}, {3700,0.00007207}, {3750,0.00010811}, {3800,0.00003604}, {3850,0.00003604}, {3900,0.00007207}, {3950,0.00021622}, {4000,0.00024324}, {4050,0.00014414}, {4100,0.00007207}, {4150,0.00024324}, {4200,0.00000000}, {4250,0.00010811}, {4300,0.00003604}, {4350,0.00003604}, {4400,0.00003604}, {4450,0.00003604}, {4500,0.00007207}, {4550,0.00002703}, {4600,0.00010811}, {4650,0.00003604}, {4700,0.00003604}, {4750,0.00010811}, {4800,0.00010811}, {4850,0.00002703}, {4900,0.00020721}, {4950,0.00019820}, {5000,0.00038739}, {5050,0.00014414}, {5100,0.00003604}, {5150,0.00010811}, {5200,0.00009910}, {5250,0.00010811}, {5300,0.00010811}, {5350,0.00010811}, {5400,0.00000000}, {5450,0.00018018}, {5500,0.00003604}, {5550,0.00010811}, {5600,0.00000000}, {5650,0.00021622}, {5700,0.00009910}, {5750,0.00045946}, {5800,0.00053153}, {5850,0.00039640}, {5900,0.00056757}, {5950,0.00032432}, {6000,0.00035135}, {6050,0.00000}, {6100,0.00100}, {6150,0.00100}, {6200,0.00200}, {6250,0.00000}, {6300,0.00000}, {6350,0.00100}, {6400,0.00100}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00100}, {6800,0.00075}, {6850,0.00000}, {6900,0.00200}, {6950,0.00100}, {7000,0.00100}, {7050,0.00000}, {7100,0.00175}, {7150,0.00000}, {7200,0.00000}, {7250,0.00100}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00100}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00100}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00100}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00100}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00075}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00100}, {14000,0.00000}, {14100,0.00000}, {14200,0.00100}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00100}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00075}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00100}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["Aggregate"]["real"] = {{1,0.00100000}, {2,0.00100000}, {3,0.00100000}, {4,0.00100000}, {5,0.00119820}, {6,0.00172072}, {7,0.00200000}, {8,0.00200000}, {9,0.00200000}, {10,0.00200000}, {11,0.00200000}, {12,0.00200000}, {13,0.00200000}, {14,0.00200000}, {15,0.00210811}, {16,0.01655856}, {17,0.00293694}, {18,0.00298198}, {19,0.00300000}, {20,0.00300000}, {21,0.00300000}, {22,0.00300000}, {23,0.00300000}, {24,0.00300000}, {25,0.00303604}, {26,0.00311712}, {27,0.00319820}, {28,0.00334234}, {29,0.00386486}, {30,0.00472973}, {31,0.00400000}, {32,0.00400000}, {33,0.00400000}, {34,0.00400000}, {35,0.00400000}, {36,0.00404505}, {37,0.00412613}, {38,0.00418919}, {39,0.00424324}, {40,0.00429730}, {41,0.00489189}, {42,0.00499099}, {43,0.00500000}, {44,0.00500000}, {45,0.00501802}, {46,0.00501802}, {47,0.00505405}, {48,0.00507207}, {49,0.00512613}, {50,0.00598198}, {51,0.00524324}, {52,0.00553153}, {53,0.00589189}, {54,0.00598198}, {55,0.00600000}, {56,0.00600000}, {57,0.00600901}, {58,0.00605405}, {59,0.00608108}, {60,0.00607207}, {61,0.00607207}, {62,0.00627027}, {63,0.00645946}, {64,0.00644144}, {65,0.00722523}, {66,0.00696396}, {67,0.00700000}, {68,0.00703604}, {69,0.00708108}, {70,0.00706306}, {71,0.00709009}, {72,0.00705405}, {73,0.00708108}, {74,0.00713514}, {75,0.00746847}, {76,0.00754955}, {77,0.00792793}, {78,0.00802703}, {79,0.00803604}, {80,0.00802703}, {81,0.00808108}, {82,0.00803604}, {83,0.00809009}, {84,0.00803604}, {85,0.00808108}, {86,0.00832432}, {87,0.00864865}, {88,0.00861261}, {89,0.00927027}, {90,0.00900000}, {91,0.00903604}, {92,0.00902703}, {93,0.00907207}, {94,0.01000901}, {95,0.00909910}, {96,0.00912613}, {97,0.00920721}, {98,0.00930631}, {99,0.01049550}, {100,0.00970270}, {101,0.00996396}, {102,0.01002703}, {103,0.01009910}, {104,0.01000901}, {105,0.01004505}, {106,0.01007207}, {107,0.01013514}, {108,0.01122523}, {109,0.01023423}, {110,0.01046847}, {111,0.01081081}, {112,0.01065766}, {113,0.01094595}, {114,0.01099099}, {115,0.01105405}, {116,0.01106306}, {117,0.01202703}, {118,0.01107207}, {119,0.01118018}, {120,0.01111712}, {121,0.01255856}, {122,0.01151351}, {123,0.01190090}, {124,0.01192793}, {125,0.01297297}, {126,0.01200901}, {127,0.01204505}, {128,0.01207207}, {129,0.01302703}, {130,0.01209910}, {131,0.01216216}, {132,0.01222523}, {133,0.01247748}, {134,0.01271171}, {135,0.01294595}, {136,0.01289189}, {137,0.01302703}, {138,0.01302703}, {139,0.01309910}, {140,0.01413514}, {141,0.01310811}, {142,0.01322523}, {143,0.01341441}, {144,0.01325225}, {145,0.01351351}, {146,0.01374775}, {147,0.01496396}, {148,0.01393694}, {149,0.01405405}, {150,0.01404505}, {151,0.01409910}, {152,0.01409910}, {153,0.01412613}, {154,0.01425225}, {155,0.01446847}, {156,0.01447748}, {157,0.01565766}, {158,0.01500000}, {159,0.01500901}, {160,0.01599099}, {161,0.01500901}, {162,0.01507207}, {163,0.01640541}, {164,0.01506306}, {165,0.01526126}, {166,0.01528829}, {167,0.01564865}, {168,0.01541441}, {169,0.01581081}, {170,0.01590090}, {171,0.01603604}, {172,0.01600000}, {173,0.01609910}, {174,0.01609910}, {175,0.01768468}, {176,0.01611712}, {177,0.01618919}, {178,0.01785586}, {179,0.01665766}, {180,0.01672973}, {181,0.01791892}, {182,0.01703604}, {183,0.01709009}, {184,0.01702703}, {185,0.01705405}, {186,0.01710811}, {187,0.01730631}, {188,0.01724324}, {189,0.01898198}, {190,0.01770270}, {191,0.01797297}, {192,0.01827928}, {193,0.01768468}, {194,0.01778378}, {195,0.01804505}, {196,0.01797297}, {197,0.01936937}, {198,0.01808108}, {199,0.01827928}, {200,0.01978378}, {201,0.01827928}, {202,0.01855856}, {203,0.01872973}, {204,0.01876577}, {205,0.02008108}, {206,0.01896396}, {207,0.01909009}, {208,0.01904505}, {209,0.01907207}, {210,0.02055856}, {211,0.01937838}, {212,0.01928829}, {213,0.01965766}, {214,0.01982883}, {215,0.01997297}, {216,0.01985586}, {217,0.02103604}, {218,0.02006306}, {219,0.02017117}, {220,0.02017117}, {221,0.02036036}, {222,0.02160360}, {223,0.02069369}, {224,0.02189189}, {225,0.02044144}, {226,0.02057658}, {227,0.02094595}, {228,0.02087387}, {229,0.02103604}, {230,0.02108108}, {231,0.02233333}, {232,0.02108108}, {233,0.02123423}, {234,0.02126126}, {235,0.02169369}, {236,0.02161261}, {237,0.02188288}, {238,0.02194595}, {239,0.02207207}, {240,0.02276577}, {241,0.02202703}, {242,0.02362162}, {243,0.02222523}, {244,0.02369369}, {245,0.02234234}, {246,0.02254054}, {247,0.02301802}, {248,0.02269369}, {249,0.02293694}, {250,0.02292793}, {251,0.02312613}, {252,0.02313514}, {253,0.02327928}, {254,0.02325225}, {255,0.02358559}, {256,0.02309009}, {257,0.02318018}, {258,0.02322523}, {259,0.02360360}, {260,0.02349550}, {261,0.02380180}, {262,0.02397297}, {263,0.02409009}, {264,0.02391892}, {265,0.02405405}, {266,0.02417117}, {267,0.02436937}, {268,0.02422523}, {269,0.02454054}, {270,0.02472072}, {271,0.02499099}, {272,0.02447748}, {273,0.02479279}, {274,0.02489189}, {275,0.02511712}, {276,0.02505405}, {277,0.02523423}, {278,0.02766667}, {279,0.02559459}, {280,0.02674775}, {281,0.02568468}, {282,0.02792793}, {283,0.02592793}, {284,0.02717117}, {285,0.02611712}, {286,0.02613514}, {287,0.02630631}, {288,0.02590991}, {289,0.02614414}, {290,0.02617117}, {291,0.02825225}, {292,0.02627027}, {293,0.02781982}, {294,0.02685586}, {295,0.02701802}, {296,0.02679279}, {297,0.02704505}, {298,0.02714414}, {299,0.02736036}, {300,0.02914414}, {301,0.02745045}, {302,0.02907207}, {303,0.02788288}, {304,0.02736937}, {305,0.02770270}, {306,0.02785586}, {307,0.02999099}, {308,0.02790090}, {309,0.02821622}, {310,0.02826126}, {311,0.02854955}, {312,0.03138739}, {313,0.02854054}, {314,0.03016216}, {315,0.02895495}, {316,0.02887387}, {317,0.03181982}, {318,0.02916216}, {319,0.03073874}, {320,0.02866667}, {321,0.02895495}, {322,0.03148649}, {323,0.02927928}, {324,0.02992793}, {325,0.02938739}, {326,0.02949550}, {327,0.03154054}, {328,0.02954054}, {329,0.02981081}, {330,0.02995495}, {331,0.03015315}, {332,0.03118919}, {333,0.03021622}, {334,0.03032432}, {335,0.03243243}, {336,0.03020721}, {337,0.03049550}, {338,0.03213514}, {339,0.03098198}, {340,0.03072973}, {341,0.03102703}, {342,0.03109009}, {343,0.03239640}, {344,0.03111712}, {345,0.03133333}, {346,0.03324324}, {347,0.03173874}, {348,0.03154955}, {349,0.03357658}, {350,0.03202703}, {351,0.03221622}, {352,0.03317117}, {353,0.03188288}, {354,0.03190090}, {355,0.03385586}, {356,0.03211712}, {357,0.03237838}, {358,0.03398198}, {359,0.03277477}, {360,0.03240541}, {361,0.03441441}, {362,0.03286486}, {363,0.03315315}, {364,0.03476577}, {365,0.03329730}, {366,0.03333333}, {367,0.03495495}, {368,0.03530631}, {369,0.03346847}, {370,0.03349550}, {371,0.03520721}, {372,0.03379279}, {373,0.03394595}, {374,0.03572072}, {375,0.03435135}, {376,0.03405405}, {377,0.03586486}, {378,0.03639640}, {379,0.03481081}, {380,0.03463964}, {381,0.03646847}, {382,0.03506306}, {383,0.03527928}, {384,0.03421622}, {385,0.03605405}, {386,0.03473874}, {387,0.03490991}, {388,0.03641441}, {389,0.03515315}, {390,0.03520721}, {391,0.03557658}, {392,0.03682883}, {393,0.03557658}, {394,0.03551351}, {395,0.03590991}, {396,0.03740541}, {397,0.03594595}, {398,0.03605405}, {399,0.03761261}, {400,0.03751351}, {401,0.03611712}, {402,0.03627928}, {403,0.03783784}, {404,0.03796396}, {405,0.03672973}, {406,0.03675676}, {407,0.03722523}, {408,0.03836937}, {409,0.03702703}, {410,0.03709009}, {411,0.03754955}, {412,0.03895495}, {413,0.04053153}, {414,0.03781081}, {415,0.03810811}, {416,0.03869369}, {417,0.03936036}, {418,0.03766667}, {419,0.03797297}, {420,0.03783784}, {421,0.03973874}, {422,0.04062162}, {423,0.03865766}, {424,0.03805405}, {425,0.03849550}, {426,0.04081081}, {427,0.04188288}, {428,0.03870270}, {429,0.03906306}, {430,0.03917117}, {431,0.04168468}, {432,0.04105405}, {433,0.03914414}, {434,0.03925225}, {435,0.03958559}, {436,0.04090090}, {437,0.04207207}, {438,0.03981982}, {439,0.04025225}, {440,0.03976577}, {441,0.04095495}, {442,0.04186486}, {443,0.04279279}, {444,0.04032432}, {445,0.04064865}, {446,0.04081982}, {447,0.04227027}, {448,0.04166667}, {449,0.04264865}, {450,0.04036036}, {451,0.04075676}, {452,0.04060360}, {453,0.04082883}, {454,0.04244144}, {455,0.04361261}, {456,0.04087387}, {457,0.04120721}, {458,0.04135135}, {459,0.04166667}, {460,0.04320721}, {461,0.04394595}, {462,0.04421622}, {463,0.04218919}, {464,0.04154955}, {465,0.04197297}, {466,0.04199099}, {467,0.04239640}, {468,0.04368468}, {469,0.04489189}, {470,0.04484685}, {471,0.04298198}, {472,0.04253153}, {473,0.04291892}, {474,0.04299099}, {475,0.04340541}, {476,0.04403604}, {477,0.04499099}, {478,0.04583784}, {479,0.04593694}, {480,0.04291892}, {481,0.04333333}, {482,0.04336937}, {483,0.04378378}, {484,0.04343243}, {485,0.04390090}, {486,0.04539640}, {487,0.04680180}, {488,0.04612613}, {489,0.04634234}, {490,0.04737838}, {491,0.04469369}, {492,0.04453153}, {493,0.04492793}, {494,0.04503604}, {495,0.04534234}, {496,0.04443243}, {497,0.04549550}, {498,0.04627928}, {499,0.04770270}, {500,0.04727928}, {505,0.04795495}, {510,0.04855856}, {515,0.04810811}, {520,0.04810811}, {525,0.05145045}, {530,0.05064865}, {535,0.05518919}, {540,0.05205405}, {545,0.05176577}, {550,0.05249550}, {555,0.05338739}, {560,0.05172072}, {565,0.05295495}, {570,0.05342342}, {575,0.05454955}, {580,0.05390090}, {585,0.05462162}, {590,0.05343243}, {595,0.05383784}, {600,0.05383784}, {605,0.05501802}, {610,0.05900901}, {615,0.05761261}, {620,0.05765766}, {625,0.05843243}, {630,0.05744144}, {635,0.05820721}, {640,0.05673874}, {645,0.05972072}, {650,0.06008108}, {655,0.05951351}, {660,0.05920721}, {665,0.06433333}, {670,0.06396396}, {675,0.06272973}, {680,0.06099099}, {685,0.06518018}, {690,0.06387387}, {695,0.06509009}, {700,0.06344144}, {705,0.06467568}, {710,0.06566667}, {715,0.06492793}, {720,0.06715315}, {725,0.06744144}, {730,0.06627027}, {735,0.06978378}, {740,0.06857658}, {745,0.06773874}, {750,0.06991892}, {755,0.06903604}, {760,0.07160360}, {765,0.07218919}, {770,0.07290991}, {775,0.07190991}, {780,0.06994595}, {785,0.07340541}, {790,0.07133333}, {795,0.07496396}, {800,0.07231532}, {805,0.07521622}, {810,0.07509009}, {815,0.07705405}, {820,0.07609009}, {825,0.07751351}, {830,0.07619820}, {835,0.07800901}, {840,0.07523423}, {845,0.07951351}, {850,0.07660360}, {855,0.07969369}, {860,0.08031532}, {865,0.07949550}, {870,0.08172072}, {875,0.07995495}, {880,0.08181081}, {885,0.08351351}, {890,0.08144144}, {895,0.08610811}, {900,0.08300901}, {905,0.08146847}, {910,0.08591892}, {915,0.08556757}, {920,0.08280180}, {925,0.08773874}, {930,0.08650450}, {935,0.09032432}, {940,0.08688288}, {945,0.08865766}, {950,0.08946847}, {955,0.09291892}, {960,0.08721622}, {965,0.09063063}, {970,0.09042342}, {975,0.09185586}, {980,0.08882883}, {985,0.09367568}, {990,0.09433333}, {995,0.09371171}, {1000,0.09308108}, {1010,0.09488288}, {1020,0.09366667}, {1030,0.09542342}, {1040,0.09407207}, {1050,0.09821622}, {1060,0.09845045}, {1070,0.10072973}, {1080,0.10077477}, {1090,0.10095495}, {1100,0.10229730}, {1110,0.10428829}, {1120,0.10394595}, {1130,0.10631532}, {1140,0.10698198}, {1150,0.11327027}, {1160,0.10809910}, {1170,0.10746847}, {1180,0.10974775}, {1190,0.11127928}, {1200,0.11198198}, {1210,0.12081982}, {1220,0.11247748}, {1230,0.11540541}, {1240,0.11627928}, {1250,0.11940541}, {1260,0.11730631}, {1270,0.12042342}, {1280,0.11934234}, {1290,0.11870270}, {1300,0.12036036}, {1310,0.12487387}, {1320,0.12342342}, {1330,0.12815315}, {1340,0.12650450}, {1350,0.13321622}, {1360,0.12652252}, {1370,0.13322523}, {1380,0.12754054}, {1390,0.13375676}, {1400,0.13068468}, {1410,0.12939640}, {1420,0.13219820}, {1430,0.13302703}, {1440,0.13491892}, {1450,0.13557658}, {1460,0.13554955}, {1470,0.14236036}, {1480,0.13961261}, {1490,0.14012613}, {1500,0.14083784}, {1510,0.14251351}, {1520,0.14245946}, {1530,0.14499099}, {1540,0.14055856}, {1550,0.14407207}, {1560,0.14495495}, {1570,0.14665766}, {1580,0.15216216}, {1590,0.14933333}, {1600,0.14647748}, {1610,0.14978378}, {1620,0.15042342}, {1630,0.15534234}, {1640,0.15217117}, {1650,0.15446847}, {1660,0.15658559}, {1670,0.15492793}, {1680,0.15932432}, {1690,0.16213514}, {1700,0.15842342}, {1710,0.16188288}, {1720,0.16292793}, {1730,0.16374775}, {1740,0.16299099}, {1750,0.17246847}, {1760,0.16410811}, {1770,0.16832432}, {1780,0.16728829}, {1790,0.17312613}, {1800,0.16668468}, {1810,0.16931532}, {1820,0.17541441}, {1830,0.17163964}, {1840,0.17319820}, {1850,0.17576577}, {1860,0.17930631}, {1870,0.18072973}, {1880,0.17694595}, {1890,0.17705405}, {1900,0.17965766}, {1910,0.18174775}, {1920,0.17738739}, {1930,0.18020721}, {1940,0.18195495}, {1950,0.19297297}, {1960,0.18773874}, {1970,0.18579279}, {1980,0.19341441}, {1990,0.18953153}, {2000,0.18702703}, {2050,0.19804505}, {2100,0.19880180}, {2150,0.20401802}, {2200,0.20773874}, {2250,0.21856757}, {2300,0.22549550}, {2350,0.22309009}, {2400,0.22502703}, {2450,0.23238739}, {2500,0.23920721}, {2550,0.25983784}, {2600,0.24638739}, {2650,0.25519820}, {2700,0.26162162}, {2750,0.26754955}, {2800,0.26922523}, {2850,0.26988288}, {2900,0.27807207}, {2950,0.28377477}, {3000,0.28803604}, {3050,0.29363063}, {3100,0.29741441}, {3150,0.30097297}, {3200,0.30583784}, {3250,0.31239640}, {3300,0.31509910}, {3350,0.32700901}, {3400,0.32574775}, {3450,0.34713514}, {3500,0.33765766}, {3550,0.34876577}, {3600,0.34050450}, {3650,0.34649550}, {3700,0.35821622}, {3750,0.36407207}, {3800,0.37632432}, {3850,0.37493694}, {3900,0.38007207}, {3950,0.38563964}, {4000,0.38202703}, {4050,0.39875676}, {4100,0.39867568}, {4150,0.40236937}, {4200,0.40386486}, {4250,0.41391892}, {4300,0.42904505}, {4350,0.43509009}, {4400,0.42568468}, {4450,0.44972072}, {4500,0.43918919}, {4550,0.44976577}, {4600,0.45770270}, {4650,0.45262162}, {4700,0.46136036}, {4750,0.48314414}, {4800,0.46588288}, {4850,0.48134234}, {4900,0.47711712}, {4950,0.49440541}, {5000,0.49431532}, {5050,0.50657658}, {5100,0.51423423}, {5150,0.51907207}, {5200,0.50385586}, {5250,0.53354955}, {5300,0.54465766}, {5350,0.53363964}, {5400,0.54385586}, {5450,0.54574775}, {5500,0.55290991}, {5550,0.56554054}, {5600,0.55409910}, {5650,0.56158559}, {5700,0.56913514}, {5750,0.59416216}, {5800,0.59536036}, {5850,0.59559459}, {5900,0.60286486}, {5950,0.62358559}, {6000,0.61710811}, {6050,0.58650}, {6100,0.61800}, {6150,0.60425}, {6200,0.59650}, {6250,0.62250}, {6300,0.62100}, {6350,0.64825}, {6400,0.61700}, {6450,0.63075}, {6500,0.64400}, {6550,0.63875}, {6600,0.65500}, {6650,0.67400}, {6700,0.67925}, {6750,0.67325}, {6800,0.67925}, {6850,0.69075}, {6900,0.72050}, {6950,0.69225}, {7000,0.70425}, {7050,0.70800}, {7100,0.71875}, {7150,0.72800}, {7200,0.71875}, {7250,0.74625}, {7300,0.72425}, {7350,0.74500}, {7400,0.75025}, {7450,0.76150}, {7500,0.80675}, {7550,0.81150}, {7600,0.77950}, {7650,0.79500}, {7700,0.80500}, {7750,0.79175}, {7800,0.79000}, {7850,0.81400}, {7900,0.81150}, {7950,0.82300}, {8000,0.80700}, {8050,0.85275}, {8100,0.86600}, {8150,0.86875}, {8200,0.83825}, {8250,0.84200}, {8300,0.85175}, {8350,0.87800}, {8400,0.84750}, {8450,0.86050}, {8500,0.87075}, {8550,0.88250}, {8600,0.91850}, {8650,0.89100}, {8700,0.95575}, {8750,0.94950}, {8800,0.88400}, {8850,0.91750}, {8900,0.91150}, {8950,0.98050}, {9000,0.94600}, {9050,0.93100}, {9100,0.97325}, {9150,0.98775}, {9200,0.98575}, {9250,0.94675}, {9300,0.96850}, {9350,0.98375}, {9400,0.98750}, {9450,0.97225}, {9500,0.99975}, {9550,0.98750}, {9600,0.96100}, {9650,1.04850}, {9700,1.03075}, {9750,1.03325}, {9800,1.03100}, {9850,1.06175}, {9900,1.03725}, {9950,1.05775}, {10000,1.06550}, {10100,1.07750}, {10200,1.05000}, {10300,1.05800}, {10400,1.03650}, {10500,1.11200}, {10600,1.12775}, {10700,1.13725}, {10800,1.17200}, {10900,1.17025}, {11000,1.16525}, {11100,1.21825}, {11200,1.17025}, {11300,1.18950}, {11400,1.19425}, {11500,1.24225}, {11600,1.25650}, {11700,1.28300}, {11800,1.23150}, {11900,1.27650}, {12000,1.26025}, {12100,1.27050}, {12200,1.30450}, {12300,1.27200}, {12400,1.27750}, {12500,1.31850}, {12600,1.31775}, {12700,1.42025}, {12800,1.30075}, {12900,1.38700}, {13000,1.35025}, {13100,1.40650}, {13200,1.42300}, {13300,1.43375}, {13400,1.43300}, {13500,1.48400}, {13600,1.45100}, {13700,1.43775}, {13800,1.47250}, {13900,1.48125}, {14000,1.50350}, {14100,1.51800}, {14200,1.52450}, {14300,1.62275}, {14400,1.50700}, {14500,1.58175}, {14600,1.55150}, {14700,1.63800}, {14800,1.54425}, {14900,1.64150}, {15000,1.56500}, {15100,1.65425}, {15200,1.63575}, {15300,1.68350}, {15400,1.65000}, {15500,1.68050}, {15600,1.74075}, {15700,1.75050}, {15800,1.76625}, {15900,1.63900}, {16000,1.73300}, {16100,1.77100}, {16200,1.73550}, {16300,1.83275}, {16400,1.77425}, {16500,1.78575}, {16600,1.81000}, {16700,1.83150}, {16800,1.80825}, {16900,1.82950}, {17000,1.86300}, {17100,1.86175}, {17200,1.78900}, {17300,1.83450}, {17400,1.93775}, {17500,1.99225}, {17600,1.81200}, {17700,1.96275}, {17800,1.94275}, {17900,1.99925}, {18000,1.91250}, {18100,2.04950}, {18200,1.92775}, {18300,1.95025}, {18400,1.95100}, {18500,1.95025}, {18600,2.08950}, {18700,1.98775}, {18800,2.13500}, {18900,2.13775}, {19000,2.12125}, {19100,2.09675}, {19200,2.10350}, {19300,2.11425}, {19400,2.07300}, {19500,2.07175}, {19600,2.10025}, {19700,2.24250}, {19800,2.24100}, {19900,2.21600}, {20000,2.0640}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["Aggregate"]["user"] = {{1,0.00109910}, {2,0.00136937}, {3,0.00148649}, {4,0.00172973}, {5,0.00154054}, {6,0.00161261}, {7,0.00209009}, {8,0.00200901}, {9,0.00204505}, {10,0.00206306}, {11,0.00197297}, {12,0.00233333}, {13,0.00220721}, {14,0.00247748}, {15,0.00242342}, {16,0.01662162}, {17,0.00290090}, {18,0.00284685}, {19,0.00299099}, {20,0.00281081}, {21,0.00299099}, {22,0.00312613}, {23,0.00313514}, {24,0.00307207}, {25,0.00318919}, {26,0.00315315}, {27,0.00347748}, {28,0.00352252}, {29,0.00355856}, {30,0.00454955}, {31,0.00378378}, {32,0.00399099}, {33,0.00381081}, {34,0.00405405}, {35,0.00397297}, {36,0.00423423}, {37,0.00459459}, {38,0.00410811}, {39,0.00449550}, {40,0.00435135}, {41,0.00451351}, {42,0.00500000}, {43,0.00501802}, {44,0.00510811}, {45,0.00527928}, {46,0.00533333}, {47,0.00515315}, {48,0.00548649}, {49,0.00551351}, {50,0.00542342}, {51,0.00533333}, {52,0.00586486}, {53,0.00584685}, {54,0.00577477}, {55,0.00638739}, {56,0.00600901}, {57,0.00646847}, {58,0.00638739}, {59,0.00610811}, {60,0.00688288}, {61,0.00627027}, {62,0.00689189}, {63,0.00680180}, {64,0.00685586}, {65,0.00779279}, {66,0.00693694}, {67,0.00720721}, {68,0.00749550}, {69,0.00759459}, {70,0.00770270}, {71,0.00754054}, {72,0.00766667}, {73,0.00771171}, {74,0.00761261}, {75,0.00792793}, {76,0.00790090}, {77,0.00799099}, {78,0.00800000}, {79,0.00811712}, {80,0.00813514}, {81,0.00812613}, {82,0.00836036}, {83,0.00834234}, {84,0.00842342}, {85,0.00835135}, {86,0.00904505}, {87,0.00894595}, {88,0.00895495}, {89,0.00978378}, {90,0.00898198}, {91,0.00893694}, {92,0.00923423}, {93,0.00915315}, {94,0.01004505}, {95,0.00955856}, {96,0.00952252}, {97,0.00958559}, {98,0.00954054}, {99,0.01036937}, {100,0.00970270}, {101,0.01007207}, {102,0.00953153}, {103,0.01036036}, {104,0.00964865}, {105,0.01033333}, {106,0.00998198}, {107,0.01042342}, {108,0.01125225}, {109,0.01054955}, {110,0.01072072}, {111,0.01063063}, {112,0.01072973}, {113,0.01064865}, {114,0.01074775}, {115,0.01085586}, {116,0.01104505}, {117,0.01171171}, {118,0.01091892}, {119,0.01139640}, {120,0.01138739}, {121,0.01241441}, {122,0.01158559}, {123,0.01172973}, {124,0.01175676}, {125,0.01300000}, {126,0.01192793}, {127,0.01218919}, {128,0.01168468}, {129,0.01333333}, {130,0.01214414}, {131,0.01209009}, {132,0.01238739}, {133,0.01258559}, {134,0.01304505}, {135,0.01313514}, {136,0.01281982}, {137,0.01308108}, {138,0.01317117}, {139,0.01345045}, {140,0.01446847}, {141,0.01340541}, {142,0.01345946}, {143,0.01361261}, {144,0.01349550}, {145,0.01374775}, {146,0.01370270}, {147,0.01552252}, {148,0.01386486}, {149,0.01429730}, {150,0.01403604}, {151,0.01418018}, {152,0.01426126}, {153,0.01452252}, {154,0.01454054}, {155,0.01511712}, {156,0.01476577}, {157,0.01596396}, {158,0.01496396}, {159,0.01503604}, {160,0.01607207}, {161,0.01512613}, {162,0.01522523}, {163,0.01679279}, {164,0.01530631}, {165,0.01562162}, {166,0.01583784}, {167,0.01611712}, {168,0.01589189}, {169,0.01609009}, {170,0.01603604}, {171,0.01619820}, {172,0.01644144}, {173,0.01636036}, {174,0.01628829}, {175,0.01734234}, {176,0.01616216}, {177,0.01651351}, {178,0.01808108}, {179,0.01685586}, {180,0.01681982}, {181,0.01773874}, {182,0.01695495}, {183,0.01711712}, {184,0.01722523}, {185,0.01742342}, {186,0.01717117}, {187,0.01719820}, {188,0.01754054}, {189,0.01878378}, {190,0.01783784}, {191,0.01776577}, {192,0.01814414}, {193,0.01781081}, {194,0.01754054}, {195,0.01792793}, {196,0.01766667}, {197,0.01913514}, {198,0.01827027}, {199,0.01825225}, {200,0.01956757}, {201,0.01820721}, {202,0.01838739}, {203,0.01840541}, {204,0.01843243}, {205,0.02000901}, {206,0.01873874}, {207,0.01915315}, {208,0.01858559}, {209,0.01886486}, {210,0.02007207}, {211,0.01935135}, {212,0.01916216}, {213,0.01936937}, {214,0.01941441}, {215,0.01969369}, {216,0.01956757}, {217,0.02054054}, {218,0.01956757}, {219,0.01987387}, {220,0.01984685}, {221,0.02006306}, {222,0.02153153}, {223,0.02029730}, {224,0.02136036}, {225,0.02004505}, {226,0.01993694}, {227,0.02068468}, {228,0.02060360}, {229,0.02056757}, {230,0.02075676}, {231,0.02232432}, {232,0.02074775}, {233,0.02100000}, {234,0.02105405}, {235,0.02153153}, {236,0.02126126}, {237,0.02180180}, {238,0.02186486}, {239,0.02148649}, {240,0.02256757}, {241,0.02212613}, {242,0.02328829}, {243,0.02216216}, {244,0.02350450}, {245,0.02203604}, {246,0.02215315}, {247,0.02290090}, {248,0.02237838}, {249,0.02290991}, {250,0.02288288}, {251,0.02300000}, {252,0.02322523}, {253,0.02332432}, {254,0.02319820}, {255,0.02346847}, {256,0.02260360}, {257,0.02312613}, {258,0.02310811}, {259,0.02355856}, {260,0.02350450}, {261,0.02372072}, {262,0.02385586}, {263,0.02397297}, {264,0.02375676}, {265,0.02387387}, {266,0.02403604}, {267,0.02445045}, {268,0.02400000}, {269,0.02476577}, {270,0.02472973}, {271,0.02493694}, {272,0.02444144}, {273,0.02465766}, {274,0.02473874}, {275,0.02501802}, {276,0.02509910}, {277,0.02510811}, {278,0.02769369}, {279,0.02554955}, {280,0.02674775}, {281,0.02600000}, {282,0.02772072}, {283,0.02639640}, {284,0.02716216}, {285,0.02641441}, {286,0.02634234}, {287,0.02622523}, {288,0.02563964}, {289,0.02649550}, {290,0.02638739}, {291,0.02860360}, {292,0.02646847}, {293,0.02793694}, {294,0.02688288}, {295,0.02695495}, {296,0.02663964}, {297,0.02726126}, {298,0.02727928}, {299,0.02760360}, {300,0.02960360}, {301,0.02767568}, {302,0.02926126}, {303,0.02791892}, {304,0.02760360}, {305,0.02791892}, {306,0.02778378}, {307,0.03025225}, {308,0.02775676}, {309,0.02836036}, {310,0.02880180}, {311,0.02872072}, {312,0.03165766}, {313,0.02876577}, {314,0.03058559}, {315,0.02936036}, {316,0.02911712}, {317,0.03204505}, {318,0.02912613}, {319,0.03123423}, {320,0.02892793}, {321,0.02908108}, {322,0.03185586}, {323,0.02974775}, {324,0.03018018}, {325,0.02979279}, {326,0.02955856}, {327,0.03172072}, {328,0.02977477}, {329,0.03012613}, {330,0.02983784}, {331,0.03042342}, {332,0.03138739}, {333,0.03016216}, {334,0.03063964}, {335,0.03288288}, {336,0.03020721}, {337,0.03054054}, {338,0.03243243}, {339,0.03129730}, {340,0.03084685}, {341,0.03141441}, {342,0.03110811}, {343,0.03264865}, {344,0.03118919}, {345,0.03175676}, {346,0.03315315}, {347,0.03206306}, {348,0.03194595}, {349,0.03363063}, {350,0.03205405}, {351,0.03283784}, {352,0.03288288}, {353,0.03220721}, {354,0.03227928}, {355,0.03411712}, {356,0.03231532}, {357,0.03288288}, {358,0.03454955}, {359,0.03308108}, {360,0.03301802}, {361,0.03462162}, {362,0.03302703}, {363,0.03354054}, {364,0.03490991}, {365,0.03372072}, {366,0.03362162}, {367,0.03494595}, {368,0.03532432}, {369,0.03391892}, {370,0.03371171}, {371,0.03518919}, {372,0.03373874}, {373,0.03414414}, {374,0.03544144}, {375,0.03467568}, {376,0.03452252}, {377,0.03591892}, {378,0.03641441}, {379,0.03512613}, {380,0.03468468}, {381,0.03610811}, {382,0.03500901}, {383,0.03517117}, {384,0.03462162}, {385,0.03621622}, {386,0.03476577}, {387,0.03518919}, {388,0.03625225}, {389,0.03508108}, {390,0.03520721}, {391,0.03549550}, {392,0.03630631}, {393,0.03565766}, {394,0.03546847}, {395,0.03572072}, {396,0.03707207}, {397,0.03594595}, {398,0.03606306}, {399,0.03763964}, {400,0.03743243}, {401,0.03628829}, {402,0.03617117}, {403,0.03753153}, {404,0.03765766}, {405,0.03664865}, {406,0.03656757}, {407,0.03737838}, {408,0.03763063}, {409,0.03709009}, {410,0.03700901}, {411,0.03735135}, {412,0.03866667}, {413,0.03978378}, {414,0.03781982}, {415,0.03782883}, {416,0.03842342}, {417,0.03901802}, {418,0.03737838}, {419,0.03774775}, {420,0.03756757}, {421,0.03958559}, {422,0.04037838}, {423,0.03845946}, {424,0.03794595}, {425,0.03821622}, {426,0.04067568}, {427,0.04166667}, {428,0.03855856}, {429,0.03867568}, {430,0.03891892}, {431,0.04132432}, {432,0.04094595}, {433,0.03886486}, {434,0.03906306}, {435,0.03950450}, {436,0.04057658}, {437,0.04219820}, {438,0.03940541}, {439,0.03985586}, {440,0.03943243}, {441,0.04082883}, {442,0.04188288}, {443,0.04256757}, {444,0.04003604}, {445,0.04072072}, {446,0.04069369}, {447,0.04197297}, {448,0.04154054}, {449,0.04257658}, {450,0.04030631}, {451,0.04063964}, {452,0.04059459}, {453,0.04089189}, {454,0.04239640}, {455,0.04370270}, {456,0.04059459}, {457,0.04108108}, {458,0.04082883}, {459,0.04153153}, {460,0.04330631}, {461,0.04418018}, {462,0.04442342}, {463,0.04240541}, {464,0.04140541}, {465,0.04197297}, {466,0.04190090}, {467,0.04246847}, {468,0.04403604}, {469,0.04472072}, {470,0.04474775}, {471,0.04318919}, {472,0.04229730}, {473,0.04293694}, {474,0.04290991}, {475,0.04343243}, {476,0.04438739}, {477,0.04506306}, {478,0.04562162}, {479,0.04591892}, {480,0.04323423}, {481,0.04348649}, {482,0.04349550}, {483,0.04388288}, {484,0.04354955}, {485,0.04428829}, {486,0.04570270}, {487,0.04654955}, {488,0.04613514}, {489,0.04632432}, {490,0.04702703}, {491,0.04519820}, {492,0.04464865}, {493,0.04473874}, {494,0.04506306}, {495,0.04528829}, {496,0.04452252}, {497,0.04578378}, {498,0.04638739}, {499,0.04742342}, {500,0.04705405}, {505,0.04779279}, {510,0.04844144}, {515,0.04804505}, {520,0.04769369}, {525,0.05092793}, {530,0.05000901}, {535,0.05398198}, {540,0.05152252}, {545,0.05129730}, {550,0.05206306}, {555,0.05318018}, {560,0.05117117}, {565,0.05233333}, {570,0.05277477}, {575,0.05434234}, {580,0.05349550}, {585,0.05436937}, {590,0.05351351}, {595,0.05383784}, {600,0.05353153}, {605,0.05497297}, {610,0.05881081}, {615,0.05761261}, {620,0.05796396}, {625,0.05830631}, {630,0.05741441}, {635,0.05780180}, {640,0.05643243}, {645,0.05999099}, {650,0.06018919}, {655,0.05959459}, {660,0.05905405}, {665,0.06466667}, {670,0.06386486}, {675,0.06298198}, {680,0.06136036}, {685,0.06516216}, {690,0.06405405}, {695,0.06511712}, {700,0.06382883}, {705,0.06477477}, {710,0.06553153}, {715,0.06498198}, {720,0.06659459}, {725,0.06708108}, {730,0.06580180}, {735,0.06927928}, {740,0.06817117}, {745,0.06773874}, {750,0.06995495}, {755,0.06893694}, {760,0.07133333}, {765,0.07206306}, {770,0.07307207}, {775,0.07200901}, {780,0.06985586}, {785,0.07327928}, {790,0.07122523}, {795,0.07492793}, {800,0.07251351}, {805,0.07529730}, {810,0.07524324}, {815,0.07680180}, {820,0.07616216}, {825,0.07751351}, {830,0.07625225}, {835,0.07809910}, {840,0.07527027}, {845,0.07928829}, {850,0.07677477}, {855,0.07936937}, {860,0.08009910}, {865,0.07902703}, {870,0.08145045}, {875,0.07966667}, {880,0.08158559}, {885,0.08333333}, {890,0.08119820}, {895,0.08575676}, {900,0.08287387}, {905,0.08183784}, {910,0.08583784}, {915,0.08529730}, {920,0.08271171}, {925,0.08768468}, {930,0.08660360}, {935,0.09023423}, {940,0.08697297}, {945,0.08849550}, {950,0.08940541}, {955,0.09237838}, {960,0.08734234}, {965,0.09034234}, {970,0.09022523}, {975,0.09153153}, {980,0.08886486}, {985,0.09323423}, {990,0.09391892}, {995,0.09340541}, {1000,0.09226126}, {1010,0.09467568}, {1020,0.09335135}, {1030,0.09508108}, {1040,0.09417117}, {1050,0.09790090}, {1060,0.09865766}, {1070,0.10063063}, {1080,0.10052252}, {1090,0.10081982}, {1100,0.10222523}, {1110,0.10368468}, {1120,0.10362162}, {1130,0.10591892}, {1140,0.10683784}, {1150,0.11272973}, {1160,0.10787387}, {1170,0.10727928}, {1180,0.10966667}, {1190,0.11092793}, {1200,0.11195495}, {1210,0.12040541}, {1220,0.11212613}, {1230,0.11480180}, {1240,0.11562162}, {1250,0.11892793}, {1260,0.11719820}, {1270,0.11973874}, {1280,0.11860360}, {1290,0.11821622}, {1300,0.12004505}, {1310,0.12489189}, {1320,0.12333333}, {1330,0.12796396}, {1340,0.12636036}, {1350,0.13281081}, {1360,0.12617117}, {1370,0.13281982}, {1380,0.12779279}, {1390,0.13338739}, {1400,0.13054054}, {1410,0.12931532}, {1420,0.13190090}, {1430,0.13257658}, {1440,0.13457658}, {1450,0.13524324}, {1460,0.13573874}, {1470,0.14202703}, {1480,0.13945946}, {1490,0.14021622}, {1500,0.14054955}, {1510,0.14225225}, {1520,0.14235135}, {1530,0.14481081}, {1540,0.14031532}, {1550,0.14351351}, {1560,0.14462162}, {1570,0.14631532}, {1580,0.15163964}, {1590,0.14917117}, {1600,0.14609910}, {1610,0.14988288}, {1620,0.15015315}, {1630,0.15510811}, {1640,0.15205405}, {1650,0.15397297}, {1660,0.15582883}, {1670,0.15461261}, {1680,0.15892793}, {1690,0.16137838}, {1700,0.15809009}, {1710,0.16197297}, {1720,0.16286486}, {1730,0.16354054}, {1740,0.16254054}, {1750,0.17163964}, {1760,0.16367568}, {1770,0.16787387}, {1780,0.16700000}, {1790,0.17290991}, {1800,0.16666667}, {1810,0.16945946}, {1820,0.17552252}, {1830,0.17172973}, {1840,0.17311712}, {1850,0.17559459}, {1860,0.17902703}, {1870,0.18038739}, {1880,0.17706306}, {1890,0.17713514}, {1900,0.17963964}, {1910,0.18145045}, {1920,0.17723423}, {1930,0.18024324}, {1940,0.18194595}, {1950,0.19260360}, {1960,0.18743243}, {1970,0.18543243}, {1980,0.19315315}, {1990,0.18914414}, {2000,0.18696396}, {2050,0.19771171}, {2100,0.19908108}, {2150,0.20364865}, {2200,0.20759459}, {2250,0.21802703}, {2300,0.22489189}, {2350,0.22299099}, {2400,0.22509910}, {2450,0.23225225}, {2500,0.23863964}, {2550,0.25965766}, {2600,0.24600000}, {2650,0.25521622}, {2700,0.26146847}, {2750,0.26762162}, {2800,0.26883784}, {2850,0.26976577}, {2900,0.27793694}, {2950,0.28341441}, {3000,0.28790090}, {3050,0.29324324}, {3100,0.29728829}, {3150,0.30083784}, {3200,0.30561261}, {3250,0.31187387}, {3300,0.31493694}, {3350,0.32698198}, {3400,0.32547748}, {3450,0.34679279}, {3500,0.33716216}, {3550,0.34838739}, {3600,0.34008108}, {3650,0.34582883}, {3700,0.35772973}, {3750,0.36405405}, {3800,0.37618919}, {3850,0.37470270}, {3900,0.37976577}, {3950,0.38536036}, {4000,0.38181081}, {4050,0.39849550}, {4100,0.39873874}, {4150,0.40198198}, {4200,0.40373874}, {4250,0.41402703}, {4300,0.42887387}, {4350,0.43487387}, {4400,0.42517117}, {4450,0.44920721}, {4500,0.43905405}, {4550,0.44940541}, {4600,0.45720721}, {4650,0.45211712}, {4700,0.46082883}, {4750,0.48279279}, {4800,0.46547748}, {4850,0.48069369}, {4900,0.47632432}, {4950,0.49418018}, {5000,0.49409910}, {5050,0.50644144}, {5100,0.51428829}, {5150,0.51895495}, {5200,0.50338739}, {5250,0.53351351}, {5300,0.54409009}, {5350,0.53315315}, {5400,0.54382883}, {5450,0.54556757}, {5500,0.55281982}, {5550,0.56511712}, {5600,0.55407207}, {5650,0.56137838}, {5700,0.56878378}, {5750,0.59280180}, {5800,0.59422523}, {5850,0.59511712}, {5900,0.60223423}, {5950,0.62282883}, {6000,0.61686486}, {6050,0.58650}, {6100,0.61775}, {6150,0.60475}, {6200,0.59450}, {6250,0.62250}, {6300,0.62075}, {6350,0.64825}, {6400,0.61675}, {6450,0.63075}, {6500,0.64350}, {6550,0.63950}, {6600,0.65325}, {6650,0.67150}, {6700,0.67975}, {6750,0.67100}, {6800,0.67875}, {6850,0.69025}, {6900,0.71850}, {6950,0.69125}, {7000,0.70275}, {7050,0.70650}, {7100,0.71725}, {7150,0.72750}, {7200,0.71750}, {7250,0.74525}, {7300,0.72300}, {7350,0.74300}, {7400,0.75025}, {7450,0.76150}, {7500,0.80650}, {7550,0.81175}, {7600,0.77825}, {7650,0.79425}, {7700,0.80475}, {7750,0.79125}, {7800,0.78950}, {7850,0.81250}, {7900,0.81175}, {7950,0.82475}, {8000,0.80475}, {8050,0.85375}, {8100,0.86675}, {8150,0.86725}, {8200,0.83700}, {8250,0.84275}, {8300,0.85125}, {8350,0.87750}, {8400,0.84450}, {8450,0.86025}, {8500,0.87125}, {8550,0.88225}, {8600,0.91650}, {8650,0.89050}, {8700,0.95525}, {8750,0.94625}, {8800,0.88325}, {8850,0.91850}, {8900,0.91150}, {8950,0.97850}, {9000,0.94450}, {9050,0.93075}, {9100,0.97250}, {9150,0.98625}, {9200,0.98575}, {9250,0.94675}, {9300,0.97025}, {9350,0.98325}, {9400,0.98525}, {9450,0.97225}, {9500,1.00050}, {9550,0.98775}, {9600,0.96075}, {9650,1.04850}, {9700,1.03100}, {9750,1.03375}, {9800,1.02850}, {9850,1.06250}, {9900,1.03550}, {9950,1.05850}, {10000,1.06550}, {10100,1.07800}, {10200,1.05000}, {10300,1.05650}, {10400,1.03700}, {10500,1.11050}, {10600,1.12625}, {10700,1.13750}, {10800,1.17275}, {10900,1.17150}, {11000,1.16525}, {11100,1.21775}, {11200,1.16850}, {11300,1.18725}, {11400,1.19500}, {11500,1.24350}, {11600,1.25675}, {11700,1.28325}, {11800,1.23150}, {11900,1.27550}, {12000,1.25950}, {12100,1.26725}, {12200,1.30650}, {12300,1.27225}, {12400,1.27550}, {12500,1.31875}, {12600,1.31625}, {12700,1.41925}, {12800,1.30000}, {12900,1.38700}, {13000,1.35150}, {13100,1.40675}, {13200,1.42250}, {13300,1.43425}, {13400,1.43250}, {13500,1.48200}, {13600,1.45000}, {13700,1.43600}, {13800,1.47325}, {13900,1.48125}, {14000,1.50175}, {14100,1.51800}, {14200,1.52350}, {14300,1.62250}, {14400,1.50625}, {14500,1.58175}, {14600,1.55050}, {14700,1.63825}, {14800,1.54500}, {14900,1.64150}, {15000,1.56575}, {15100,1.65400}, {15200,1.63650}, {15300,1.68375}, {15400,1.65000}, {15500,1.68175}, {15600,1.73950}, {15700,1.75075}, {15800,1.76425}, {15900,1.63850}, {16000,1.73150}, {16100,1.76950}, {16200,1.73350}, {16300,1.83250}, {16400,1.77425}, {16500,1.78450}, {16600,1.80925}, {16700,1.82925}, {16800,1.80550}, {16900,1.82975}, {17000,1.86250}, {17100,1.86175}, {17200,1.78850}, {17300,1.83450}, {17400,1.93725}, {17500,1.99150}, {17600,1.81225}, {17700,1.96100}, {17800,1.94250}, {17900,2.00075}, {18000,1.91125}, {18100,2.04825}, {18200,1.92675}, {18300,1.95100}, {18400,1.95200}, {18500,1.95025}, {18600,2.08900}, {18700,1.98650}, {18800,2.13350}, {18900,2.13775}, {19000,2.12125}, {19100,2.09625}, {19200,2.10375}, {19300,2.11350}, {19400,2.07275}, {19500,2.07250}, {19600,2.10075}, {19700,2.24150}, {19800,2.24075}, {19900,2.21750}, {20000,2.0635}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["Aggregate"]["system"] = {{1,0.00024324}, {2,0.00000000}, {3,0.00003604}, {4,0.00003604}, {5,0.00007207}, {6,0.00003604}, {7,0.00003604}, {8,0.00000000}, {9,0.00003604}, {10,0.00002703}, {11,0.00010811}, {12,0.00000000}, {13,0.00003604}, {14,0.00009009}, {15,0.00009910}, {16,0.00024324}, {17,0.00000000}, {18,0.00003604}, {19,0.00007207}, {20,0.00002703}, {21,0.00000000}, {22,0.00003604}, {23,0.00009910}, {24,0.00009910}, {25,0.00006306}, {26,0.00003604}, {27,0.00009910}, {28,0.00003604}, {29,0.00007207}, {30,0.00009910}, {31,0.00000000}, {32,0.00007207}, {33,0.00002703}, {34,0.00000000}, {35,0.00000000}, {36,0.00006306}, {37,0.00003604}, {38,0.00000000}, {39,0.00000000}, {40,0.00007207}, {41,0.00008108}, {42,0.00000000}, {43,0.00006306}, {44,0.00007207}, {45,0.00000000}, {46,0.00010811}, {47,0.00017117}, {48,0.00000000}, {49,0.00009910}, {50,0.00024324}, {51,0.00007207}, {52,0.00003604}, {53,0.00013514}, {54,0.00003604}, {55,0.00003604}, {56,0.00002703}, {57,0.00003604}, {58,0.00000000}, {59,0.00006306}, {60,0.00005405}, {61,0.00010811}, {62,0.00003604}, {63,0.00006306}, {64,0.00009910}, {65,0.00002703}, {66,0.00009910}, {67,0.00007207}, {68,0.00003604}, {69,0.00006306}, {70,0.00003604}, {71,0.00003604}, {72,0.00010811}, {73,0.00003604}, {74,0.00007207}, {75,0.00002703}, {76,0.00000000}, {77,0.00007207}, {78,0.00007207}, {79,0.00003604}, {80,0.00009910}, {81,0.00009910}, {82,0.00007207}, {83,0.00003604}, {84,0.00012613}, {85,0.00007207}, {86,0.00007207}, {87,0.00003604}, {88,0.00000000}, {89,0.00009910}, {90,0.00000000}, {91,0.00003604}, {92,0.00003604}, {93,0.00003604}, {94,0.00006306}, {95,0.00003604}, {96,0.00014414}, {97,0.00010811}, {98,0.00010811}, {99,0.00003604}, {100,0.00003604}, {101,0.00007207}, {102,0.00023423}, {103,0.00003604}, {104,0.00020721}, {105,0.00017117}, {106,0.00003604}, {107,0.00003604}, {108,0.00010811}, {109,0.00007207}, {110,0.00003604}, {111,0.00002703}, {112,0.00009910}, {113,0.00006306}, {114,0.00009910}, {115,0.00007207}, {116,0.00003604}, {117,0.00007207}, {118,0.00018018}, {119,0.00000000}, {120,0.00003604}, {121,0.00006306}, {122,0.00003604}, {123,0.00003604}, {124,0.00009910}, {125,0.00002703}, {126,0.00003604}, {127,0.00007207}, {128,0.00000000}, {129,0.00010811}, {130,0.00007207}, {131,0.00018018}, {132,0.00007207}, {133,0.00016216}, {134,0.00003604}, {135,0.00000000}, {136,0.00014414}, {137,0.00003604}, {138,0.00003604}, {139,0.00002703}, {140,0.00003604}, {141,0.00003604}, {142,0.00000000}, {143,0.00007207}, {144,0.00000000}, {145,0.00006306}, {146,0.00000000}, {147,0.00009009}, {148,0.00010811}, {149,0.00014414}, {150,0.00017117}, {151,0.00014414}, {152,0.00002703}, {153,0.00007207}, {154,0.00010811}, {155,0.00003604}, {156,0.00007207}, {157,0.00013514}, {158,0.00007207}, {159,0.00006306}, {160,0.00019820}, {161,0.00017117}, {162,0.00000000}, {163,0.00009009}, {164,0.00012613}, {165,0.00007207}, {166,0.00003604}, {167,0.00003604}, {168,0.00010811}, {169,0.00003604}, {170,0.00006306}, {171,0.00002703}, {172,0.00000000}, {173,0.00006306}, {174,0.00006306}, {175,0.00017117}, {176,0.00010811}, {177,0.00003604}, {178,0.00003604}, {179,0.00007207}, {180,0.00007207}, {181,0.00017117}, {182,0.00000000}, {183,0.00003604}, {184,0.00014414}, {185,0.00002703}, {186,0.00003604}, {187,0.00009910}, {188,0.00014414}, {189,0.00006306}, {190,0.00000000}, {191,0.00009009}, {192,0.00013514}, {193,0.00007207}, {194,0.00010811}, {195,0.00007207}, {196,0.00006306}, {197,0.00013514}, {198,0.00003604}, {199,0.00002703}, {200,0.00009009}, {201,0.00007207}, {202,0.00003604}, {203,0.00000000}, {204,0.00006306}, {205,0.00000000}, {206,0.00003604}, {207,0.00000000}, {208,0.00003604}, {209,0.00002703}, {210,0.00006306}, {211,0.00000000}, {212,0.00003604}, {213,0.00000000}, {214,0.00008108}, {215,0.00003604}, {216,0.00007207}, {217,0.00003604}, {218,0.00013514}, {219,0.00020721}, {220,0.00010811}, {221,0.00002703}, {222,0.00010811}, {223,0.00003604}, {224,0.00010811}, {225,0.00003604}, {226,0.00009910}, {227,0.00013514}, {228,0.00007207}, {229,0.00003604}, {230,0.00003604}, {231,0.00016216}, {232,0.00006306}, {233,0.00006306}, {234,0.00014414}, {235,0.00007207}, {236,0.00006306}, {237,0.00000000}, {238,0.00007207}, {239,0.00006306}, {240,0.00007207}, {241,0.00013514}, {242,0.00021622}, {243,0.00007207}, {244,0.00014414}, {245,0.00010811}, {246,0.00007207}, {247,0.00007207}, {248,0.00009009}, {249,0.00000000}, {250,0.00007207}, {251,0.00007207}, {252,0.00009910}, {253,0.00009910}, {254,0.00010811}, {255,0.00003604}, {256,0.00009910}, {257,0.00010811}, {258,0.00014414}, {259,0.00007207}, {260,0.00010811}, {261,0.00014414}, {262,0.00010811}, {263,0.00007207}, {264,0.00006306}, {265,0.00002703}, {266,0.00003604}, {267,0.00003604}, {268,0.00003604}, {269,0.00003604}, {270,0.00005405}, {271,0.00003604}, {272,0.00020721}, {273,0.00003604}, {274,0.00010811}, {275,0.00007207}, {276,0.00009910}, {277,0.00007207}, {278,0.00011712}, {279,0.00012613}, {280,0.00007207}, {281,0.00010811}, {282,0.00016216}, {283,0.00003604}, {284,0.00017117}, {285,0.00007207}, {286,0.00003604}, {287,0.00007207}, {288,0.00002703}, {289,0.00007207}, {290,0.00000000}, {291,0.00002703}, {292,0.00003604}, {293,0.00027928}, {294,0.00012613}, {295,0.00006306}, {296,0.00000000}, {297,0.00003604}, {298,0.00000000}, {299,0.00000000}, {300,0.00007207}, {301,0.00007207}, {302,0.00003604}, {303,0.00014414}, {304,0.00007207}, {305,0.00003604}, {306,0.00012613}, {307,0.00016216}, {308,0.00010811}, {309,0.00010811}, {310,0.00003604}, {311,0.00003604}, {312,0.00007207}, {313,0.00003604}, {314,0.00003604}, {315,0.00007207}, {316,0.00006306}, {317,0.00007207}, {318,0.00009910}, {319,0.00010811}, {320,0.00007207}, {321,0.00000000}, {322,0.00009910}, {323,0.00006306}, {324,0.00003604}, {325,0.00010811}, {326,0.00014414}, {327,0.00010811}, {328,0.00017117}, {329,0.00000000}, {330,0.00010811}, {331,0.00025225}, {332,0.00009910}, {333,0.00010811}, {334,0.00009910}, {335,0.00003604}, {336,0.00000000}, {337,0.00014414}, {338,0.00013514}, {339,0.00013514}, {340,0.00021622}, {341,0.00003604}, {342,0.00020721}, {343,0.00003604}, {344,0.00009910}, {345,0.00002703}, {346,0.00021622}, {347,0.00013514}, {348,0.00007207}, {349,0.00009009}, {350,0.00014414}, {351,0.00003604}, {352,0.00027928}, {353,0.00009910}, {354,0.00010811}, {355,0.00018018}, {356,0.00003604}, {357,0.00003604}, {358,0.00012613}, {359,0.00010811}, {360,0.00000000}, {361,0.00013514}, {362,0.00010811}, {363,0.00000000}, {364,0.00007207}, {365,0.00009910}, {366,0.00000000}, {367,0.00010811}, {368,0.00003604}, {369,0.00014414}, {370,0.00017117}, {371,0.00007207}, {372,0.00010811}, {373,0.00014414}, {374,0.00024324}, {375,0.00010811}, {376,0.00009910}, {377,0.00007207}, {378,0.00006306}, {379,0.00010811}, {380,0.00000000}, {381,0.00007207}, {382,0.00003604}, {383,0.00013514}, {384,0.00003604}, {385,0.00003604}, {386,0.00007207}, {387,0.00007207}, {388,0.00009910}, {389,0.00013514}, {390,0.00007207}, {391,0.00014414}, {392,0.00014414}, {393,0.00018018}, {394,0.00016216}, {395,0.00021622}, {396,0.00010811}, {397,0.00010811}, {398,0.00010811}, {399,0.00014414}, {400,0.00020721}, {401,0.00003604}, {402,0.00013514}, {403,0.00007207}, {404,0.00009910}, {405,0.00006306}, {406,0.00010811}, {407,0.00010811}, {408,0.00013514}, {409,0.00007207}, {410,0.00007207}, {411,0.00020721}, {412,0.00007207}, {413,0.00035135}, {414,0.00003604}, {415,0.00000000}, {416,0.00010811}, {417,0.00002703}, {418,0.00003604}, {419,0.00014414}, {420,0.00002703}, {421,0.00010811}, {422,0.00013514}, {423,0.00010811}, {424,0.00003604}, {425,0.00019820}, {426,0.00024324}, {427,0.00045946}, {428,0.00009910}, {429,0.00007207}, {430,0.00009910}, {431,0.00016216}, {432,0.00018018}, {433,0.00007207}, {434,0.00006306}, {435,0.00003604}, {436,0.00000000}, {437,0.00007207}, {438,0.00009910}, {439,0.00007207}, {440,0.00010811}, {441,0.00003604}, {442,0.00007207}, {443,0.00031532}, {444,0.00003604}, {445,0.00006306}, {446,0.00009910}, {447,0.00018018}, {448,0.00007207}, {449,0.00009910}, {450,0.00003604}, {451,0.00010811}, {452,0.00010811}, {453,0.00018018}, {454,0.00014414}, {455,0.00014414}, {456,0.00028829}, {457,0.00006306}, {458,0.00010811}, {459,0.00003604}, {460,0.00010811}, {461,0.00012613}, {462,0.00017117}, {463,0.00006306}, {464,0.00010811}, {465,0.00010811}, {466,0.00007207}, {467,0.00007207}, {468,0.00003604}, {469,0.00027928}, {470,0.00017117}, {471,0.00003604}, {472,0.00028829}, {473,0.00010811}, {474,0.00015315}, {475,0.00014414}, {476,0.00010811}, {477,0.00006306}, {478,0.00018018}, {479,0.00010811}, {480,0.00007207}, {481,0.00003604}, {482,0.00005405}, {483,0.00010811}, {484,0.00006306}, {485,0.00010811}, {486,0.00010811}, {487,0.00010811}, {488,0.00016216}, {489,0.00010811}, {490,0.00018018}, {491,0.00000000}, {492,0.00003604}, {493,0.00016216}, {494,0.00010811}, {495,0.00014414}, {496,0.00006306}, {497,0.00002703}, {498,0.00028829}, {499,0.00020721}, {500,0.00031532}, {505,0.00010811}, {510,0.00010811}, {515,0.00009910}, {520,0.00013514}, {525,0.00027928}, {530,0.00024324}, {535,0.00126126}, {540,0.00025225}, {545,0.00010811}, {550,0.00007207}, {555,0.00014414}, {560,0.00013514}, {565,0.00010811}, {570,0.00021622}, {575,0.00014414}, {580,0.00020721}, {585,0.00018018}, {590,0.00017117}, {595,0.00009910}, {600,0.00013514}, {605,0.00014414}, {610,0.00018018}, {615,0.00025225}, {620,0.00000000}, {625,0.00010811}, {630,0.00010811}, {635,0.00014414}, {640,0.00007207}, {645,0.00009910}, {650,0.00013514}, {655,0.00014414}, {660,0.00017117}, {665,0.00013514}, {670,0.00020721}, {675,0.00019820}, {680,0.00009910}, {685,0.00014414}, {690,0.00007207}, {695,0.00010811}, {700,0.00003604}, {705,0.00009910}, {710,0.00024324}, {715,0.00007207}, {720,0.00028829}, {725,0.00019820}, {730,0.00020721}, {735,0.00018018}, {740,0.00017117}, {745,0.00000000}, {750,0.00007207}, {755,0.00010811}, {760,0.00028829}, {765,0.00028829}, {770,0.00009910}, {775,0.00013514}, {780,0.00014414}, {785,0.00041441}, {790,0.00007207}, {795,0.00018018}, {800,0.00013514}, {805,0.00031532}, {810,0.00014414}, {815,0.00024324}, {820,0.00017117}, {825,0.00017117}, {830,0.00014414}, {835,0.00013514}, {840,0.00017117}, {845,0.00014414}, {850,0.00007207}, {855,0.00017117}, {860,0.00017117}, {865,0.00021622}, {870,0.00028829}, {875,0.00014414}, {880,0.00018018}, {885,0.00021622}, {890,0.00010811}, {895,0.00024324}, {900,0.00010811}, {905,0.00007207}, {910,0.00014414}, {915,0.00031532}, {920,0.00010811}, {925,0.00021622}, {930,0.00020721}, {935,0.00025225}, {940,0.00025225}, {945,0.00017117}, {950,0.00025225}, {955,0.00039640}, {960,0.00018018}, {965,0.00007207}, {970,0.00007207}, {975,0.00010811}, {980,0.00007207}, {985,0.00014414}, {990,0.00028829}, {995,0.00040541}, {1000,0.00052252}, {1010,0.00018018}, {1020,0.00013514}, {1030,0.00020721}, {1040,0.00007207}, {1050,0.00025225}, {1060,0.00016216}, {1070,0.00021622}, {1080,0.00021622}, {1090,0.00027928}, {1100,0.00014414}, {1110,0.00021622}, {1120,0.00035135}, {1130,0.00027928}, {1140,0.00014414}, {1150,0.00025225}, {1160,0.00025225}, {1170,0.00009910}, {1180,0.00031532}, {1190,0.00034234}, {1200,0.00018018}, {1210,0.00031532}, {1220,0.00020721}, {1230,0.00032432}, {1240,0.00009910}, {1250,0.00024324}, {1260,0.00018018}, {1270,0.00025225}, {1280,0.00039640}, {1290,0.00018018}, {1300,0.00024324}, {1310,0.00018018}, {1320,0.00018018}, {1330,0.00022523}, {1340,0.00031532}, {1350,0.00042342}, {1360,0.00017117}, {1370,0.00027928}, {1380,0.00028829}, {1390,0.00028829}, {1400,0.00016216}, {1410,0.00017117}, {1420,0.00025225}, {1430,0.00048649}, {1440,0.00020721}, {1450,0.00021622}, {1460,0.00024324}, {1470,0.00032432}, {1480,0.00021622}, {1490,0.00021622}, {1500,0.00025225}, {1510,0.00038739}, {1520,0.00021622}, {1530,0.00003604}, {1540,0.00031532}, {1550,0.00025225}, {1560,0.00025225}, {1570,0.00030631}, {1580,0.00041441}, {1590,0.00021622}, {1600,0.00028829}, {1610,0.00018018}, {1620,0.00028829}, {1630,0.00020721}, {1640,0.00014414}, {1650,0.00025225}, {1660,0.00042342}, {1670,0.00029730}, {1680,0.00036036}, {1690,0.00055856}, {1700,0.00010811}, {1710,0.00023423}, {1720,0.00031532}, {1730,0.00052252}, {1740,0.00042342}, {1750,0.00064865}, {1760,0.00024324}, {1770,0.00031532}, {1780,0.00028829}, {1790,0.00027027}, {1800,0.00007207}, {1810,0.00007207}, {1820,0.00010811}, {1830,0.00007207}, {1840,0.00018018}, {1850,0.00010811}, {1860,0.00003604}, {1870,0.00018018}, {1880,0.00006306}, {1890,0.00009910}, {1900,0.00021622}, {1910,0.00010811}, {1920,0.00007207}, {1930,0.00014414}, {1940,0.00010811}, {1950,0.00010811}, {1960,0.00013514}, {1970,0.00031532}, {1980,0.00014414}, {1990,0.00017117}, {2000,0.00021622}, {2050,0.00017117}, {2100,0.00006306}, {2150,0.00021622}, {2200,0.00014414}, {2250,0.00018018}, {2300,0.00033333}, {2350,0.00016216}, {2400,0.00007207}, {2450,0.00006306}, {2500,0.00014414}, {2550,0.00017117}, {2600,0.00018018}, {2650,0.00007207}, {2700,0.00024324}, {2750,0.00014414}, {2800,0.00032432}, {2850,0.00018018}, {2900,0.00028829}, {2950,0.00020721}, {3000,0.00007207}, {3050,0.00024324}, {3100,0.00000000}, {3150,0.00018018}, {3200,0.00027928}, {3250,0.00028829}, {3300,0.00010811}, {3350,0.00010811}, {3400,0.00021622}, {3450,0.00021622}, {3500,0.00018018}, {3550,0.00013514}, {3600,0.00024324}, {3650,0.00021622}, {3700,0.00018018}, {3750,0.00006306}, {3800,0.00021622}, {3850,0.00014414}, {3900,0.00013514}, {3950,0.00031532}, {4000,0.00025225}, {4050,0.00017117}, {4100,0.00024324}, {4150,0.00014414}, {4200,0.00024324}, {4250,0.00003604}, {4300,0.00010811}, {4350,0.00010811}, {4400,0.00021622}, {4450,0.00021622}, {4500,0.00014414}, {4550,0.00020721}, {4600,0.00007207}, {4650,0.00036036}, {4700,0.00017117}, {4750,0.00018018}, {4800,0.00018018}, {4850,0.00047748}, {4900,0.00045946}, {4950,0.00032432}, {5000,0.00046847}, {5050,0.00024324}, {5100,0.00014414}, {5150,0.00028829}, {5200,0.00043243}, {5250,0.00034234}, {5300,0.00027928}, {5350,0.00036036}, {5400,0.00006306}, {5450,0.00014414}, {5500,0.00014414}, {5550,0.00014414}, {5600,0.00010811}, {5650,0.00010811}, {5700,0.00018018}, {5750,0.00081081}, {5800,0.00079279}, {5850,0.00045045}, {5900,0.00078378}, {5950,0.00072973}, {6000,0.00032432}, {6050,0.00000}, {6100,0.00000}, {6150,0.00200}, {6200,0.00100}, {6250,0.00100}, {6300,0.00000}, {6350,0.00000}, {6400,0.00100}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00175}, {6650,0.00100}, {6700,0.00000}, {6750,0.00200}, {6800,0.00175}, {6850,0.00000}, {6900,0.00100}, {6950,0.00000}, {7000,0.00200}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00100}, {7350,0.00000}, {7400,0.00075}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00200}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00100}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00100}, {8650,0.00100}, {8700,0.00000}, {8750,0.00075}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00200}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00075}, {9850,0.00000}, {9900,0.00200}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00100}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00200}, {12200,0.00000}, {12300,0.00100}, {12400,0.00100}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00075}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00100}, {13500,0.00000}, {13600,0.00100}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00100}, {14100,0.00000}, {14200,0.00100}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00100}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00100}, {16300,0.00000}, {16400,0.00000}, {16500,0.00100}, {16600,0.00000}, {16700,0.00200}, {16800,0.00100}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00100}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00100}, {18200,0.00075}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00100}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00100}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00019820}, {14,0.00057658}, {15,0.00100000}, {16,0.01474775}, {17,0.00118018}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00100000}, {23,0.00100000}, {24,0.00100000}, {25,0.00100901}, {26,0.00109009}, {27,0.00117117}, {28,0.00119820}, {29,0.00190991}, {30,0.00268468}, {31,0.00200000}, {32,0.00200000}, {33,0.00200000}, {34,0.00200000}, {35,0.00200000}, {36,0.00200000}, {37,0.00200000}, {38,0.00200000}, {39,0.00208108}, {40,0.00208108}, {41,0.00208108}, {42,0.00218919}, {43,0.00254054}, {44,0.00295495}, {45,0.00300000}, {46,0.00300000}, {47,0.00300000}, {48,0.00300000}, {49,0.00300000}, {50,0.00300000}, {51,0.00300000}, {52,0.00301802}, {53,0.00309009}, {54,0.00310811}, {55,0.00311712}, {56,0.00310811}, {57,0.00323423}, {58,0.00368468}, {59,0.00400000}, {60,0.00400000}, {61,0.00400000}, {62,0.00400000}, {63,0.00400000}, {64,0.00400000}, {65,0.00498198}, {66,0.00404505}, {67,0.00409910}, {68,0.00408108}, {69,0.00412613}, {70,0.00408108}, {71,0.00428829}, {72,0.00421622}, {73,0.00482883}, {74,0.00500000}, {75,0.00500000}, {76,0.00500000}, {77,0.00500000}, {78,0.00505405}, {79,0.00506306}, {80,0.00504505}, {81,0.00510811}, {82,0.00505405}, {83,0.00510811}, {84,0.00503604}, {85,0.00512613}, {86,0.00545045}, {87,0.00595495}, {88,0.00591892}, {89,0.00600000}, {90,0.00600000}, {91,0.00602703}, {92,0.00603604}, {93,0.00606306}, {94,0.00698198}, {95,0.00608108}, {96,0.00608108}, {97,0.00610811}, {98,0.00607207}, {99,0.00720721}, {100,0.00610811}, {101,0.00665766}, {102,0.00693694}, {103,0.00703604}, {104,0.00700901}, {105,0.00701802}, {106,0.00701802}, {107,0.00701802}, {108,0.00703604}, {109,0.00705405}, {110,0.00710811}, {111,0.00710811}, {112,0.00711712}, {113,0.00712613}, {114,0.00719820}, {115,0.00778378}, {116,0.00773874}, {117,0.00876577}, {118,0.00800901}, {119,0.00803604}, {120,0.00805405}, {121,0.00903604}, {122,0.00804505}, {123,0.00808108}, {124,0.00804505}, {125,0.00919820}, {126,0.00809009}, {127,0.00842342}, {128,0.00815315}, {129,0.00938739}, {130,0.00859459}, {131,0.00899099}, {132,0.00897297}, {133,0.00904505}, {134,0.00906306}, {135,0.00904505}, {136,0.00904505}, {137,0.00905405}, {138,0.00905405}, {139,0.00911712}, {140,0.01037838}, {141,0.00915315}, {142,0.00936937}, {143,0.00987387}, {144,0.00930631}, {145,0.00990090}, {146,0.00998198}, {147,0.01102703}, {148,0.01001802}, {149,0.01007207}, {150,0.01005405}, {151,0.01008108}, {152,0.01008108}, {153,0.01005405}, {154,0.01010811}, {155,0.01029730}, {156,0.01025225}, {157,0.01164865}, {158,0.01098198}, {159,0.01102703}, {160,0.01200000}, {161,0.01097297}, {162,0.01103604}, {163,0.01108108}, {164,0.01102703}, {165,0.01106306}, {166,0.01109910}, {167,0.01112613}, {168,0.01111712}, {169,0.01117117}, {170,0.01118919}, {171,0.01180180}, {172,0.01157658}, {173,0.01199099}, {174,0.01201802}, {175,0.01204505}, {176,0.01200000}, {177,0.01204505}, {178,0.01332432}, {179,0.01204505}, {180,0.01207207}, {181,0.01335135}, {182,0.01219820}, {183,0.01254054}, {184,0.01221622}, {185,0.01251351}, {186,0.01273874}, {187,0.01301802}, {188,0.01298198}, {189,0.01305405}, {190,0.01308108}, {191,0.01309009}, {192,0.01400000}, {193,0.01300901}, {194,0.01302703}, {195,0.01307207}, {196,0.01310811}, {197,0.01317117}, {198,0.01318919}, {199,0.01372973}, {200,0.01327027}, {201,0.01365766}, {202,0.01388288}, {203,0.01400901}, {204,0.01399099}, {205,0.01521622}, {206,0.01406306}, {207,0.01411712}, {208,0.01409910}, {209,0.01408108}, {210,0.01570270}, {211,0.01424324}, {212,0.01418919}, {213,0.01457658}, {214,0.01480180}, {215,0.01504505}, {216,0.01473874}, {217,0.01603604}, {218,0.01504505}, {219,0.01509009}, {220,0.01507207}, {221,0.01514414}, {222,0.01636937}, {223,0.01527928}, {224,0.01692793}, {225,0.01509910}, {226,0.01509910}, {227,0.01551351}, {228,0.01535135}, {229,0.01590090}, {230,0.01599099}, {231,0.01710811}, {232,0.01592793}, {233,0.01609009}, {234,0.01608108}, {235,0.01611712}, {236,0.01618018}, {237,0.01622523}, {238,0.01625225}, {239,0.01678378}, {240,0.01713514}, {241,0.01640541}, {242,0.01809910}, {243,0.01699099}, {244,0.01813514}, {245,0.01705405}, {246,0.01701802}, {247,0.01724324}, {248,0.01708108}, {249,0.01709009}, {250,0.01709009}, {251,0.01749550}, {252,0.01736036}, {253,0.01767568}, {254,0.01780180}, {255,0.01807207}, {256,0.01716216}, {257,0.01736937}, {258,0.01752252}, {259,0.01794595}, {260,0.01788288}, {261,0.01803604}, {262,0.01811712}, {263,0.01814414}, {264,0.01807207}, {265,0.01810811}, {266,0.01824324}, {267,0.01837838}, {268,0.01819820}, {269,0.01864865}, {270,0.01884685}, {271,0.01909009}, {272,0.01843243}, {273,0.01892793}, {274,0.01899099}, {275,0.01909009}, {276,0.01910811}, {277,0.01911712}, {278,0.01913514}, {279,0.01930631}, {280,0.02080180}, {281,0.01941441}, {282,0.02195495}, {283,0.01989189}, {284,0.02109009}, {285,0.02007207}, {286,0.02006306}, {287,0.02009910}, {288,0.01969369}, {289,0.02005405}, {290,0.02005405}, {291,0.02209009}, {292,0.02007207}, {293,0.02166667}, {294,0.02027027}, {295,0.02071171}, {296,0.02024324}, {297,0.02051351}, {298,0.02088288}, {299,0.02108108}, {300,0.02293694}, {301,0.02111712}, {302,0.02284685}, {303,0.02114414}, {304,0.02102703}, {305,0.02110811}, {306,0.02114414}, {307,0.02365766}, {308,0.02118919}, {309,0.02159459}, {310,0.02172973}, {311,0.02207207}, {312,0.02486486}, {313,0.02203604}, {314,0.02364865}, {315,0.02216216}, {316,0.02209910}, {317,0.02509910}, {318,0.02233333}, {319,0.02248649}, {320,0.02201802}, {321,0.02215315}, {322,0.02483784}, {323,0.02230631}, {324,0.02226126}, {325,0.02255856}, {326,0.02263964}, {327,0.02483784}, {328,0.02262162}, {329,0.02298198}, {330,0.02309910}, {331,0.02318919}, {332,0.02422523}, {333,0.02316216}, {334,0.02326126}, {335,0.02546847}, {336,0.02314414}, {337,0.02334234}, {338,0.02512613}, {339,0.02390090}, {340,0.02367568}, {341,0.02403604}, {342,0.02406306}, {343,0.02531532}, {344,0.02410811}, {345,0.02413514}, {346,0.02610811}, {347,0.02436036}, {348,0.02418018}, {349,0.02631532}, {350,0.02487387}, {351,0.02509009}, {352,0.02607207}, {353,0.02452252}, {354,0.02458559}, {355,0.02668468}, {356,0.02486486}, {357,0.02509009}, {358,0.02681982}, {359,0.02527928}, {360,0.02507207}, {361,0.02707207}, {362,0.02530631}, {363,0.02574775}, {364,0.02732432}, {365,0.02595495}, {366,0.02591892}, {367,0.02613514}, {368,0.02546847}, {369,0.02600000}, {370,0.02601802}, {371,0.02785586}, {372,0.02608108}, {373,0.02627027}, {374,0.02811712}, {375,0.02672973}, {376,0.02626126}, {377,0.02666667}, {378,0.02883784}, {379,0.02708108}, {380,0.02694595}, {381,0.02880180}, {382,0.02720721}, {383,0.02745045}, {384,0.02636937}, {385,0.02831532}, {386,0.02689189}, {387,0.02709009}, {388,0.02864865}, {389,0.02718919}, {390,0.02720721}, {391,0.02758559}, {392,0.02900000}, {393,0.02746847}, {394,0.02747748}, {395,0.02796396}, {396,0.02951351}, {397,0.02802703}, {398,0.02804505}, {399,0.02831532}, {400,0.02950450}, {401,0.02809910}, {402,0.02811712}, {403,0.02842342}, {404,0.02998198}, {405,0.02852252}, {406,0.02864865}, {407,0.02909910}, {408,0.03023423}, {409,0.02890090}, {410,0.02896396}, {411,0.02921622}, {412,0.03077477}, {413,0.02922523}, {414,0.02939640}, {415,0.02986486}, {416,0.02906306}, {417,0.03114414}, {418,0.02923423}, {419,0.02954054}, {420,0.02940541}, {421,0.03142342}, {422,0.03233333}, {423,0.03021622}, {424,0.02962162}, {425,0.03004505}, {426,0.03250450}, {427,0.03036937}, {428,0.03016216}, {429,0.03046847}, {430,0.03055856}, {431,0.03322523}, {432,0.03271171}, {433,0.03052252}, {434,0.03063964}, {435,0.03100000}, {436,0.03230631}, {437,0.03363063}, {438,0.03111712}, {439,0.03146847}, {440,0.03101802}, {441,0.03135135}, {442,0.03322523}, {443,0.03424324}, {444,0.03146847}, {445,0.03196396}, {446,0.03200901}, {447,0.03235135}, {448,0.03296396}, {449,0.03390991}, {450,0.03142342}, {451,0.03196396}, {452,0.03168468}, {453,0.03197297}, {454,0.03363063}, {455,0.03491892}, {456,0.03200000}, {457,0.03221622}, {458,0.03227027}, {459,0.03261261}, {460,0.03242342}, {461,0.03511712}, {462,0.03533333}, {463,0.03312613}, {464,0.03243243}, {465,0.03285586}, {466,0.03287387}, {467,0.03314414}, {468,0.03468468}, {469,0.03590991}, {470,0.03586486}, {471,0.03379279}, {472,0.03324324}, {473,0.03367568}, {474,0.03365766}, {475,0.03412613}, {476,0.03363063}, {477,0.03590991}, {478,0.03674775}, {479,0.03675676}, {480,0.03363063}, {481,0.03400000}, {482,0.03402703}, {483,0.03437838}, {484,0.03407207}, {485,0.03432432}, {486,0.03612613}, {487,0.03746847}, {488,0.03690090}, {489,0.03696396}, {490,0.03489189}, {491,0.03518018}, {492,0.03500901}, {493,0.03534234}, {494,0.03537838}, {495,0.03569369}, {496,0.03490991}, {497,0.03543243}, {498,0.03685586}, {499,0.03817117}, {500,0.03782883}, {505,0.03840541}, {510,0.03892793}, {515,0.03832432}, {520,0.03838739}, {525,0.03741441}, {530,0.03733333}, {535,0.03829730}, {540,0.03843243}, {545,0.03845946}, {550,0.03908108}, {555,0.04304505}, {560,0.04135135}, {565,0.04250450}, {570,0.04281081}, {575,0.04390991}, {580,0.04318018}, {585,0.04386486}, {590,0.04238739}, {595,0.04266667}, {600,0.04260360}, {605,0.04372072}, {610,0.04339640}, {615,0.04647748}, {620,0.04635135}, {625,0.04698198}, {630,0.04563063}, {635,0.04638739}, {640,0.04477477}, {645,0.04805405}, {650,0.04822523}, {655,0.04748649}, {660,0.04696396}, {665,0.04761261}, {670,0.05190090}, {675,0.05039640}, {680,0.04844144}, {685,0.05279279}, {690,0.05142342}, {695,0.05091892}, {700,0.05063063}, {705,0.05207207}, {710,0.05287387}, {715,0.05180180}, {720,0.05427027}, {725,0.05446847}, {730,0.05285586}, {735,0.05663964}, {740,0.05322523}, {745,0.05412613}, {750,0.05653153}, {755,0.05523423}, {760,0.05810811}, {765,0.05850450}, {770,0.05467568}, {775,0.05805405}, {780,0.05576577}, {785,0.05939640}, {790,0.05686486}, {795,0.06092793}, {800,0.05675676}, {805,0.06107207}, {810,0.05841441}, {815,0.06265766}, {820,0.05904505}, {825,0.06296396}, {830,0.06108108}, {835,0.06336937}, {840,0.06005405}, {845,0.06461261}, {850,0.06129730}, {855,0.06465766}, {860,0.06527928}, {865,0.06248649}, {870,0.06644144}, {875,0.06423423}, {880,0.06629730}, {885,0.06811712}, {890,0.06549550}, {895,0.07041441}, {900,0.06731532}, {905,0.06530631}, {910,0.06988288}, {915,0.06966667}, {920,0.06636036}, {925,0.07154054}, {930,0.07031532}, {935,0.06896396}, {940,0.07031532}, {945,0.07218919}, {950,0.07304505}, {955,0.07120721}, {960,0.06808108}, {965,0.07371171}, {970,0.07353153}, {975,0.07490991}, {980,0.07127928}, {985,0.07642342}, {990,0.07711712}, {995,0.07651351}, {1000,0.07588288}, {1010,0.07746847}, {1020,0.07565766}, {1030,0.07437838}, {1040,0.07602703}, {1050,0.07989189}, {1060,0.08002703}, {1070,0.08218018}, {1080,0.08209910}, {1090,0.08211712}, {1100,0.08332432}, {1110,0.08514414}, {1120,0.08452252}, {1130,0.08678378}, {1140,0.08727027}, {1150,0.08645045}, {1160,0.08820721}, {1170,0.08755856}, {1180,0.08969369}, {1190,0.09095495}, {1200,0.09138739}, {1210,0.08975676}, {1220,0.09167568}, {1230,0.09439640}, {1240,0.09492793}, {1250,0.09506306}, {1260,0.09597297}, {1270,0.09866667}, {1280,0.09456757}, {1290,0.09685586}, {1300,0.09807207}, {1310,0.10287387}, {1320,0.10087387}, {1330,0.10127928}, {1340,0.10373874}, {1350,0.10429730}, {1360,0.10339640}, {1370,0.10621622}, {1380,0.10415315}, {1390,0.10667568}, {1400,0.10681081}, {1410,0.10557658}, {1420,0.10791892}, {1430,0.10882883}, {1440,0.10665766}, {1450,0.11087387}, {1460,0.11097297}, {1470,0.11357658}, {1480,0.11441441}, {1490,0.11482883}, {1500,0.11559459}, {1510,0.11730631}, {1520,0.11663063}, {1530,0.11899099}, {1540,0.11453153}, {1550,0.11790090}, {1560,0.11508108}, {1570,0.12024324}, {1580,0.12045946}, {1590,0.12212613}, {1600,0.11917117}, {1610,0.12241441}, {1620,0.12295495}, {1630,0.12751351}, {1640,0.12413514}, {1650,0.12625225}, {1660,0.12822523}, {1670,0.12636937}, {1680,0.12613514}, {1690,0.12945045}, {1700,0.12980180}, {1710,0.13301802}, {1720,0.13041441}, {1730,0.13427027}, {1740,0.13309009}, {1750,0.13534234}, {1760,0.13427928}, {1770,0.13515315}, {1780,0.13678378}, {1790,0.14263063}, {1800,0.13607207}, {1810,0.13842342}, {1820,0.13893694}, {1830,0.14050450}, {1840,0.14165766}, {1850,0.14447748}, {1860,0.14046847}, {1870,0.14396396}, {1880,0.14474775}, {1890,0.14442342}, {1900,0.14730631}, {1910,0.14881081}, {1920,0.14454054}, {1930,0.14687387}, {1940,0.14868468}, {1950,0.15128829}, {1960,0.14913514}, {1970,0.15197297}, {1980,0.15907207}, {1990,0.14936036}, {2000,0.15267568}, {2050,0.15724324}, {2100,0.15900000}, {2150,0.16239640}, {2200,0.16464865}, {2250,0.17209009}, {2300,0.18008108}, {2350,0.18175676}, {2400,0.18253153}, {2450,0.18905405}, {2500,0.19436036}, {2550,0.21428829}, {2600,0.19984685}, {2650,0.20276577}, {2700,0.20055856}, {2750,0.21390090}, {2800,0.21330631}, {2850,0.21853153}, {2900,0.22572072}, {2950,0.23063964}, {3000,0.23386486}, {3050,0.23863063}, {3100,0.23761261}, {3150,0.24360360}, {3200,0.23921622}, {3250,0.24768468}, {3300,0.25158559}, {3350,0.25740541}, {3400,0.26037838}, {3450,0.28345045}, {3500,0.26756757}, {3550,0.28334234}, {3600,0.26905405}, {3650,0.27864865}, {3700,0.28968468}, {3750,0.29089189}, {3800,0.29764865}, {3850,0.29714414}, {3900,0.30446847}, {3950,0.31155856}, {4000,0.30697297}, {4050,0.32009009}, {4100,0.31346847}, {4150,0.31971171}, {4200,0.32344144}, {4250,0.33301802}, {4300,0.33986486}, {4350,0.34805405}, {4400,0.33890090}, {4450,0.35183784}, {4500,0.35163063}, {4550,0.35370270}, {4600,0.36761261}, {4650,0.35707207}, {4700,0.36954955}, {4750,0.37065766}, {4800,0.36302703}, {4850,0.37976577}, {4900,0.37983784}, {4950,0.38538739}, {5000,0.38245946}, {5050,0.40195495}, {5100,0.41173874}, {5150,0.40448649}, {5200,0.39928829}, {5250,0.40959459}, {5300,0.43200000}, {5350,0.42317117}, {5400,0.42462162}, {5450,0.42817117}, {5500,0.44131532}, {5550,0.44531532}, {5600,0.43485586}, {5650,0.43656757}, {5700,0.44927027}, {5750,0.46246847}, {5800,0.45168468}, {5850,0.47191892}, {5900,0.46246847}, {5950,0.47876577}, {6000,0.47446847}, {6050,0.47225}, {6100,0.47725}, {6150,0.47150}, {6200,0.47850}, {6250,0.48025}, {6300,0.49225}, {6350,0.50075}, {6400,0.48575}, {6450,0.50425}, {6500,0.51150}, {6550,0.51125}, {6600,0.51800}, {6650,0.53400}, {6700,0.52150}, {6750,0.53125}, {6800,0.52200}, {6850,0.53375}, {6900,0.55550}, {6950,0.54900}, {7000,0.55400}, {7050,0.55575}, {7100,0.57250}, {7150,0.56875}, {7200,0.54425}, {7250,0.56950}, {7300,0.56825}, {7350,0.58325}, {7400,0.59150}, {7450,0.58925}, {7500,0.59475}, {7550,0.60875}, {7600,0.59750}, {7650,0.60450}, {7700,0.59975}, {7750,0.61575}, {7800,0.62250}, {7850,0.62625}, {7900,0.63850}, {7950,0.63750}, {8000,0.62050}, {8050,0.65675}, {8100,0.66050}, {8150,0.66950}, {8200,0.63025}, {8250,0.65750}, {8300,0.65975}, {8350,0.67300}, {8400,0.66050}, {8450,0.65325}, {8500,0.68075}, {8550,0.68150}, {8600,0.68475}, {8650,0.68450}, {8700,0.71725}, {8750,0.70850}, {8800,0.68225}, {8850,0.70725}, {8900,0.69950}, {8950,0.74300}, {9000,0.70725}, {9050,0.72625}, {9100,0.73400}, {9150,0.75875}, {9200,0.75425}, {9250,0.71775}, {9300,0.73275}, {9350,0.74375}, {9400,0.74850}, {9450,0.76050}, {9500,0.75600}, {9550,0.76675}, {9600,0.74350}, {9650,0.77850}, {9700,0.78400}, {9750,0.77300}, {9800,0.77250}, {9850,0.80375}, {9900,0.80300}, {9950,0.81975}, {10000,0.79975}, {10100,0.82025}, {10200,0.82875}, {10300,0.82400}, {10400,0.81025}, {10500,0.81600}, {10600,0.85475}, {10700,0.86600}, {10800,0.85200}, {10900,0.87100}, {11000,0.89375}, {11100,0.90700}, {11200,0.88900}, {11300,0.89900}, {11400,0.90250}, {11500,0.94900}, {11600,0.91775}, {11700,0.96875}, {11800,0.93900}, {11900,0.98475}, {12000,0.96325}, {12100,0.98050}, {12200,0.99625}, {12300,0.96700}, {12400,0.97750}, {12500,0.99775}, {12600,1.01000}, {12700,1.03325}, {12800,0.97725}, {12900,1.03950}, {13000,1.03450}, {13100,1.06475}, {13200,1.06350}, {13300,1.10350}, {13400,1.07875}, {13500,1.12425}, {13600,1.07875}, {13700,1.09175}, {13800,1.13050}, {13900,1.13475}, {14000,1.13375}, {14100,1.14075}, {14200,1.19150}, {14300,1.19575}, {14400,1.13075}, {14500,1.16025}, {14600,1.15375}, {14700,1.20425}, {14800,1.19050}, {14900,1.21525}, {15000,1.20825}, {15100,1.26400}, {15200,1.23075}, {15300,1.24425}, {15400,1.23400}, {15500,1.25350}, {15600,1.26425}, {15700,1.29850}, {15800,1.30350}, {15900,1.29475}, {16000,1.27850}, {16100,1.32650}, {16200,1.32050}, {16300,1.36050}, {16400,1.27550}, {16500,1.35050}, {16600,1.34125}, {16700,1.37025}, {16800,1.32525}, {16900,1.32025}, {17000,1.36575}, {17100,1.40425}, {17200,1.38900}, {17300,1.41550}, {17400,1.45750}, {17500,1.44025}, {17600,1.38850}, {17700,1.43275}, {17800,1.43225}, {17900,1.49100}, {18000,1.44500}, {18100,1.49075}, {18200,1.47575}, {18300,1.53950}, {18400,1.50950}, {18500,1.47125}, {18600,1.50375}, {18700,1.49800}, {18800,1.53900}, {18900,1.56100}, {19000,1.55075}, {19100,1.57475}, {19200,1.53225}, {19300,1.59525}, {19400,1.59550}, {19500,1.58550}, {19600,1.57175}, {19700,1.63550}, {19800,1.63100}, {19900,1.65850}, {20000,1.5840}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["actual reif"]["user"] = {{1,0.00009009}, {2,0.00017117}, {3,0.00017117}, {4,0.00040541}, {5,0.00026126}, {6,0.00063063}, {7,0.00032432}, {8,0.00029730}, {9,0.00077477}, {10,0.00061261}, {11,0.00082883}, {12,0.00098198}, {13,0.00097297}, {14,0.00091892}, {15,0.00088288}, {16,0.01492793}, {17,0.00133333}, {18,0.00127027}, {19,0.00113514}, {20,0.00119820}, {21,0.00131532}, {22,0.00137838}, {23,0.00145946}, {24,0.00142342}, {25,0.00151351}, {26,0.00162162}, {27,0.00172072}, {28,0.00163964}, {29,0.00175676}, {30,0.00247748}, {31,0.00209009}, {32,0.00173874}, {33,0.00219820}, {34,0.00182883}, {35,0.00233333}, {36,0.00222523}, {37,0.00206306}, {38,0.00243243}, {39,0.00247748}, {40,0.00242342}, {41,0.00261261}, {42,0.00236937}, {43,0.00258559}, {44,0.00272973}, {45,0.00276577}, {46,0.00281081}, {47,0.00287387}, {48,0.00296396}, {49,0.00309910}, {50,0.00292793}, {51,0.00311712}, {52,0.00300000}, {53,0.00339640}, {54,0.00332432}, {55,0.00355856}, {56,0.00342342}, {57,0.00344144}, {58,0.00350450}, {59,0.00369369}, {60,0.00362162}, {61,0.00358559}, {62,0.00380180}, {63,0.00400000}, {64,0.00412613}, {65,0.00486486}, {66,0.00417117}, {67,0.00417117}, {68,0.00439640}, {69,0.00437838}, {70,0.00456757}, {71,0.00472973}, {72,0.00448649}, {73,0.00463063}, {74,0.00457658}, {75,0.00484685}, {76,0.00506306}, {77,0.00477477}, {78,0.00500901}, {79,0.00499099}, {80,0.00558559}, {81,0.00517117}, {82,0.00527027}, {83,0.00584685}, {84,0.00574775}, {85,0.00528829}, {86,0.00556757}, {87,0.00572072}, {88,0.00573874}, {89,0.00605405}, {90,0.00610811}, {91,0.00643243}, {92,0.00624324}, {93,0.00665766}, {94,0.00749550}, {95,0.00645946}, {96,0.00603604}, {97,0.00640541}, {98,0.00657658}, {99,0.00779279}, {100,0.00657658}, {101,0.00697297}, {102,0.00707207}, {103,0.00716216}, {104,0.00733333}, {105,0.00678378}, {106,0.00727928}, {107,0.00748649}, {108,0.00739640}, {109,0.00732432}, {110,0.00763964}, {111,0.00787387}, {112,0.00781081}, {113,0.00805405}, {114,0.00782883}, {115,0.00807207}, {116,0.00796396}, {117,0.00919820}, {118,0.00815315}, {119,0.00829730}, {120,0.00836036}, {121,0.00922523}, {122,0.00834234}, {123,0.00846847}, {124,0.00859459}, {125,0.00937838}, {126,0.00867568}, {127,0.00858559}, {128,0.00888288}, {129,0.00975676}, {130,0.00878378}, {131,0.00906306}, {132,0.00901802}, {133,0.00900000}, {134,0.00914414}, {135,0.00920721}, {136,0.00904505}, {137,0.00916216}, {138,0.00933333}, {139,0.00968468}, {140,0.01090991}, {141,0.00954054}, {142,0.00967568}, {143,0.00981982}, {144,0.00966667}, {145,0.00960360}, {146,0.00990090}, {147,0.01111712}, {148,0.01018919}, {149,0.00972973}, {150,0.01009009}, {151,0.01023423}, {152,0.01033333}, {153,0.01044144}, {154,0.01051351}, {155,0.01061261}, {156,0.01040541}, {157,0.01149550}, {158,0.01083784}, {159,0.01076577}, {160,0.01198198}, {161,0.01080180}, {162,0.01076577}, {163,0.01118018}, {164,0.01127928}, {165,0.01119820}, {166,0.01145045}, {167,0.01146847}, {168,0.01138739}, {169,0.01164865}, {170,0.01175676}, {171,0.01170270}, {172,0.01180180}, {173,0.01196396}, {174,0.01200000}, {175,0.01215315}, {176,0.01200000}, {177,0.01231532}, {178,0.01362162}, {179,0.01249550}, {180,0.01232432}, {181,0.01399099}, {182,0.01280180}, {183,0.01306306}, {184,0.01263063}, {185,0.01261261}, {186,0.01300000}, {187,0.01309009}, {188,0.01264865}, {189,0.01335135}, {190,0.01319820}, {191,0.01362162}, {192,0.01419820}, {193,0.01340541}, {194,0.01351351}, {195,0.01344144}, {196,0.01372072}, {197,0.01347748}, {198,0.01351351}, {199,0.01398198}, {200,0.01378378}, {201,0.01389189}, {202,0.01400901}, {203,0.01425225}, {204,0.01425225}, {205,0.01582883}, {206,0.01436937}, {207,0.01452252}, {208,0.01456757}, {209,0.01453153}, {210,0.01618018}, {211,0.01492793}, {212,0.01479279}, {213,0.01493694}, {214,0.01486486}, {215,0.01550450}, {216,0.01496396}, {217,0.01645045}, {218,0.01532432}, {219,0.01557658}, {220,0.01545045}, {221,0.01574775}, {222,0.01667568}, {223,0.01592793}, {224,0.01710811}, {225,0.01559459}, {226,0.01545946}, {227,0.01580180}, {228,0.01600901}, {229,0.01617117}, {230,0.01631532}, {231,0.01717117}, {232,0.01626126}, {233,0.01646847}, {234,0.01637838}, {235,0.01650450}, {236,0.01686486}, {237,0.01674775}, {238,0.01654955}, {239,0.01713514}, {240,0.01749550}, {241,0.01672973}, {242,0.01812613}, {243,0.01704505}, {244,0.01809009}, {245,0.01709910}, {246,0.01724324}, {247,0.01744144}, {248,0.01714414}, {249,0.01726126}, {250,0.01757658}, {251,0.01753153}, {252,0.01747748}, {253,0.01758559}, {254,0.01777477}, {255,0.01803604}, {256,0.01762162}, {257,0.01745946}, {258,0.01765766}, {259,0.01772072}, {260,0.01777477}, {261,0.01795495}, {262,0.01798198}, {263,0.01813514}, {264,0.01786486}, {265,0.01805405}, {266,0.01806306}, {267,0.01836937}, {268,0.01818018}, {269,0.01849550}, {270,0.01867568}, {271,0.01898198}, {272,0.01849550}, {273,0.01834234}, {274,0.01862162}, {275,0.01898198}, {276,0.01894595}, {277,0.01887387}, {278,0.01888288}, {279,0.01928829}, {280,0.02063063}, {281,0.01931532}, {282,0.02126126}, {283,0.01933333}, {284,0.02054054}, {285,0.01958559}, {286,0.01982883}, {287,0.02017117}, {288,0.01941441}, {289,0.01963964}, {290,0.01945946}, {291,0.02216216}, {292,0.01999099}, {293,0.02133333}, {294,0.01982883}, {295,0.02062162}, {296,0.02015315}, {297,0.02023423}, {298,0.02052252}, {299,0.02086486}, {300,0.02281081}, {301,0.02088288}, {302,0.02256757}, {303,0.02096396}, {304,0.02076577}, {305,0.02094595}, {306,0.02075676}, {307,0.02361261}, {308,0.02095495}, {309,0.02145946}, {310,0.02190991}, {311,0.02147748}, {312,0.02506306}, {313,0.02135135}, {314,0.02351351}, {315,0.02232432}, {316,0.02194595}, {317,0.02517117}, {318,0.02222523}, {319,0.02230631}, {320,0.02172072}, {321,0.02206306}, {322,0.02489189}, {323,0.02261261}, {324,0.02235135}, {325,0.02228829}, {326,0.02251351}, {327,0.02500901}, {328,0.02268468}, {329,0.02270270}, {330,0.02265766}, {331,0.02329730}, {332,0.02459459}, {333,0.02318919}, {334,0.02345946}, {335,0.02556757}, {336,0.02342342}, {337,0.02349550}, {338,0.02537838}, {339,0.02386486}, {340,0.02373874}, {341,0.02418018}, {342,0.02429730}, {343,0.02519820}, {344,0.02427027}, {345,0.02424324}, {346,0.02568468}, {347,0.02477477}, {348,0.02500901}, {349,0.02640541}, {350,0.02448649}, {351,0.02518018}, {352,0.02581982}, {353,0.02447748}, {354,0.02469369}, {355,0.02663964}, {356,0.02472072}, {357,0.02511712}, {358,0.02679279}, {359,0.02557658}, {360,0.02531532}, {361,0.02699099}, {362,0.02542342}, {363,0.02575676}, {364,0.02727027}, {365,0.02604505}, {366,0.02554955}, {367,0.02608108}, {368,0.02545946}, {369,0.02597297}, {370,0.02610811}, {371,0.02769369}, {372,0.02615315}, {373,0.02627027}, {374,0.02775676}, {375,0.02680180}, {376,0.02635135}, {377,0.02643243}, {378,0.02875676}, {379,0.02689189}, {380,0.02662162}, {381,0.02850450}, {382,0.02704505}, {383,0.02730631}, {384,0.02656757}, {385,0.02820721}, {386,0.02674775}, {387,0.02702703}, {388,0.02824324}, {389,0.02717117}, {390,0.02718018}, {391,0.02746847}, {392,0.02852252}, {393,0.02722523}, {394,0.02728829}, {395,0.02773874}, {396,0.02953153}, {397,0.02790991}, {398,0.02768468}, {399,0.02865766}, {400,0.03022523}, {401,0.02800000}, {402,0.02828829}, {403,0.02845045}, {404,0.03016216}, {405,0.02864865}, {406,0.02832432}, {407,0.02913514}, {408,0.03021622}, {409,0.02913514}, {410,0.02867568}, {411,0.02954054}, {412,0.03104505}, {413,0.02959459}, {414,0.02998198}, {415,0.03009009}, {416,0.02915315}, {417,0.03154054}, {418,0.02964865}, {419,0.02962162}, {420,0.02952252}, {421,0.03184685}, {422,0.03272973}, {423,0.03053153}, {424,0.02976577}, {425,0.03023423}, {426,0.03300000}, {427,0.03067568}, {428,0.03072973}, {429,0.03078378}, {430,0.03109910}, {431,0.03317117}, {432,0.03279279}, {433,0.03064865}, {434,0.03070270}, {435,0.03117117}, {436,0.03258559}, {437,0.03405405}, {438,0.03145045}, {439,0.03191892}, {440,0.03139640}, {441,0.03173874}, {442,0.03350450}, {443,0.03421622}, {444,0.03190090}, {445,0.03217117}, {446,0.03243243}, {447,0.03286486}, {448,0.03309910}, {449,0.03400901}, {450,0.03174775}, {451,0.03241441}, {452,0.03217117}, {453,0.03257658}, {454,0.03403604}, {455,0.03481081}, {456,0.03224324}, {457,0.03262162}, {458,0.03262162}, {459,0.03280180}, {460,0.03270270}, {461,0.03512613}, {462,0.03545045}, {463,0.03346847}, {464,0.03291892}, {465,0.03318919}, {466,0.03338739}, {467,0.03379279}, {468,0.03477477}, {469,0.03578378}, {470,0.03578378}, {471,0.03381982}, {472,0.03350450}, {473,0.03403604}, {474,0.03418919}, {475,0.03431532}, {476,0.03373874}, {477,0.03582883}, {478,0.03656757}, {479,0.03686486}, {480,0.03402703}, {481,0.03432432}, {482,0.03450450}, {483,0.03445946}, {484,0.03454955}, {485,0.03448649}, {486,0.03621622}, {487,0.03736036}, {488,0.03701802}, {489,0.03691892}, {490,0.03501802}, {491,0.03537838}, {492,0.03502703}, {493,0.03543243}, {494,0.03548649}, {495,0.03564865}, {496,0.03501802}, {497,0.03560360}, {498,0.03681081}, {499,0.03801802}, {500,0.03741441}, {505,0.03830631}, {510,0.03900901}, {515,0.03838739}, {520,0.03836937}, {525,0.03753153}, {530,0.03691892}, {535,0.03814414}, {540,0.03829730}, {545,0.03846847}, {550,0.03890991}, {555,0.04333333}, {560,0.04148649}, {565,0.04268468}, {570,0.04312613}, {575,0.04400000}, {580,0.04339640}, {585,0.04391892}, {590,0.04226126}, {595,0.04296396}, {600,0.04256757}, {605,0.04390991}, {610,0.04363964}, {615,0.04644144}, {620,0.04664865}, {625,0.04716216}, {630,0.04593694}, {635,0.04658559}, {640,0.04466667}, {645,0.04801802}, {650,0.04822523}, {655,0.04756757}, {660,0.04703604}, {665,0.04786486}, {670,0.05155856}, {675,0.05012613}, {680,0.04855856}, {685,0.05257658}, {690,0.05107207}, {695,0.05054955}, {700,0.05042342}, {705,0.05158559}, {710,0.05254955}, {715,0.05151351}, {720,0.05380180}, {725,0.05400901}, {730,0.05263964}, {735,0.05654955}, {740,0.05313514}, {745,0.05380180}, {750,0.05616216}, {755,0.05504505}, {760,0.05808108}, {765,0.05821622}, {770,0.05476577}, {775,0.05794595}, {780,0.05584685}, {785,0.05940541}, {790,0.05698198}, {795,0.06116216}, {800,0.05645045}, {805,0.06119820}, {810,0.05858559}, {815,0.06272973}, {820,0.05909009}, {825,0.06335135}, {830,0.06151351}, {835,0.06367568}, {840,0.06027928}, {845,0.06463063}, {850,0.06162162}, {855,0.06491892}, {860,0.06550450}, {865,0.06301802}, {870,0.06623423}, {875,0.06454955}, {880,0.06636937}, {885,0.06777477}, {890,0.06558559}, {895,0.06997297}, {900,0.06719820}, {905,0.06576577}, {910,0.06972973}, {915,0.06928829}, {920,0.06622523}, {925,0.07164865}, {930,0.06986486}, {935,0.06909009}, {940,0.07032432}, {945,0.07233333}, {950,0.07331532}, {955,0.07122523}, {960,0.06790991}, {965,0.07392793}, {970,0.07376577}, {975,0.07545946}, {980,0.07156757}, {985,0.07657658}, {990,0.07702703}, {995,0.07663964}, {1000,0.07596396}, {1010,0.07748649}, {1020,0.07590090}, {1030,0.07476577}, {1040,0.07646847}, {1050,0.07936036}, {1060,0.07989189}, {1070,0.08198198}, {1080,0.08187387}, {1090,0.08201802}, {1100,0.08320721}, {1110,0.08529730}, {1120,0.08427027}, {1130,0.08668468}, {1140,0.08743243}, {1150,0.08666667}, {1160,0.08821622}, {1170,0.08751351}, {1180,0.08941441}, {1190,0.09036937}, {1200,0.09105405}, {1210,0.08966667}, {1220,0.09129730}, {1230,0.09430631}, {1240,0.09474775}, {1250,0.09436937}, {1260,0.09590991}, {1270,0.09860360}, {1280,0.09439640}, {1290,0.09693694}, {1300,0.09783784}, {1310,0.10236937}, {1320,0.10084685}, {1330,0.10117117}, {1340,0.10311712}, {1350,0.10391892}, {1360,0.10312613}, {1370,0.10572072}, {1380,0.10372973}, {1390,0.10627027}, {1400,0.10644144}, {1410,0.10524324}, {1420,0.10750450}, {1430,0.10879279}, {1440,0.10629730}, {1450,0.11072973}, {1460,0.11096396}, {1470,0.11328829}, {1480,0.11427928}, {1490,0.11438739}, {1500,0.11548649}, {1510,0.11706306}, {1520,0.11597297}, {1530,0.11844144}, {1540,0.11399099}, {1550,0.11756757}, {1560,0.11464865}, {1570,0.11993694}, {1580,0.12045045}, {1590,0.12209910}, {1600,0.11866667}, {1610,0.12205405}, {1620,0.12272072}, {1630,0.12763964}, {1640,0.12408108}, {1650,0.12618919}, {1660,0.12831532}, {1670,0.12641441}, {1680,0.12625225}, {1690,0.12950450}, {1700,0.12956757}, {1710,0.13278378}, {1720,0.13012613}, {1730,0.13384685}, {1740,0.13272973}, {1750,0.13545946}, {1760,0.13410811}, {1770,0.13521622}, {1780,0.13707207}, {1790,0.14268468}, {1800,0.13623423}, {1810,0.13880180}, {1820,0.13936937}, {1830,0.14093694}, {1840,0.14176577}, {1850,0.14429730}, {1860,0.14076577}, {1870,0.14384685}, {1880,0.14477477}, {1890,0.14433333}, {1900,0.14726126}, {1910,0.14898198}, {1920,0.14453153}, {1930,0.14655856}, {1940,0.14849550}, {1950,0.15136036}, {1960,0.14874775}, {1970,0.15211712}, {1980,0.15889189}, {1990,0.14919820}, {2000,0.15291892}, {2050,0.15706306}, {2100,0.15885586}, {2150,0.16230631}, {2200,0.16472973}, {2250,0.17153153}, {2300,0.17987387}, {2350,0.18150450}, {2400,0.18242342}, {2450,0.18924324}, {2500,0.19432432}, {2550,0.21406306}, {2600,0.20000901}, {2650,0.20272973}, {2700,0.20075676}, {2750,0.21397297}, {2800,0.21299099}, {2850,0.21820721}, {2900,0.22590090}, {2950,0.23038739}, {3000,0.23360360}, {3050,0.23845946}, {3100,0.23764865}, {3150,0.24289189}, {3200,0.23880180}, {3250,0.24754054}, {3300,0.25125225}, {3350,0.25766667}, {3400,0.26022523}, {3450,0.28360360}, {3500,0.26750450}, {3550,0.28354054}, {3600,0.26909910}, {3650,0.27881081}, {3700,0.28949550}, {3750,0.29077477}, {3800,0.29749550}, {3850,0.29709910}, {3900,0.30425225}, {3950,0.31124324}, {4000,0.30676577}, {4050,0.31961261}, {4100,0.31328829}, {4150,0.31937838}, {4200,0.32300901}, {4250,0.33293694}, {4300,0.33961261}, {4350,0.34762162}, {4400,0.33880180}, {4450,0.35175676}, {4500,0.35146847}, {4550,0.35351351}, {4600,0.36729730}, {4650,0.35681982}, {4700,0.36944144}, {4750,0.37003604}, {4800,0.36304505}, {4850,0.37963063}, {4900,0.37981982}, {4950,0.38510811}, {5000,0.38207207}, {5050,0.40183784}, {5100,0.41158559}, {5150,0.40446847}, {5200,0.39901802}, {5250,0.40944144}, {5300,0.43156757}, {5350,0.42301802}, {5400,0.42445946}, {5450,0.42804505}, {5500,0.44129730}, {5550,0.44526126}, {5600,0.43482883}, {5650,0.43655856}, {5700,0.44904505}, {5750,0.46174775}, {5800,0.45113514}, {5850,0.47133333}, {5900,0.46163964}, {5950,0.47839640}, {6000,0.47416216}, {6050,0.47375}, {6100,0.47650}, {6150,0.47150}, {6200,0.47850}, {6250,0.48125}, {6300,0.49375}, {6350,0.50175}, {6400,0.48550}, {6450,0.50600}, {6500,0.50900}, {6550,0.51150}, {6600,0.51650}, {6650,0.53375}, {6700,0.52275}, {6750,0.53175}, {6800,0.52100}, {6850,0.53375}, {6900,0.55675}, {6950,0.54825}, {7000,0.55250}, {7050,0.55575}, {7100,0.57300}, {7150,0.57050}, {7200,0.54200}, {7250,0.56950}, {7300,0.56775}, {7350,0.58350}, {7400,0.59025}, {7450,0.58950}, {7500,0.59450}, {7550,0.60975}, {7600,0.59850}, {7650,0.60525}, {7700,0.59825}, {7750,0.61600}, {7800,0.62375}, {7850,0.62675}, {7900,0.63950}, {7950,0.63825}, {8000,0.62050}, {8050,0.65500}, {8100,0.65975}, {8150,0.66975}, {8200,0.62875}, {8250,0.65850}, {8300,0.66075}, {8350,0.67275}, {8400,0.65975}, {8450,0.65375}, {8500,0.68025}, {8550,0.68250}, {8600,0.68375}, {8650,0.68400}, {8700,0.71750}, {8750,0.70650}, {8800,0.68150}, {8850,0.70775}, {8900,0.69850}, {8950,0.74275}, {9000,0.70650}, {9050,0.72525}, {9100,0.73525}, {9150,0.76000}, {9200,0.75550}, {9250,0.71750}, {9300,0.73275}, {9350,0.74450}, {9400,0.74775}, {9450,0.75950}, {9500,0.75425}, {9550,0.76550}, {9600,0.74325}, {9650,0.77950}, {9700,0.78425}, {9750,0.77175}, {9800,0.77375}, {9850,0.80325}, {9900,0.80250}, {9950,0.81850}, {10000,0.79950}, {10100,0.81875}, {10200,0.82975}, {10300,0.82425}, {10400,0.81100}, {10500,0.81575}, {10600,0.85450}, {10700,0.86675}, {10800,0.85125}, {10900,0.86950}, {11000,0.89350}, {11100,0.90700}, {11200,0.89075}, {11300,0.89750}, {11400,0.90225}, {11500,0.94800}, {11600,0.91800}, {11700,0.96825}, {11800,0.94050}, {11900,0.98500}, {12000,0.96350}, {12100,0.97875}, {12200,0.99700}, {12300,0.96725}, {12400,0.97725}, {12500,0.99725}, {12600,1.01100}, {12700,1.03300}, {12800,0.97600}, {12900,1.04050}, {13000,1.03425}, {13100,1.06475}, {13200,1.06400}, {13300,1.10350}, {13400,1.07850}, {13500,1.12475}, {13600,1.07750}, {13700,1.09150}, {13800,1.12975}, {13900,1.13475}, {14000,1.13125}, {14100,1.14150}, {14200,1.19150}, {14300,1.19650}, {14400,1.13100}, {14500,1.16050}, {14600,1.15400}, {14700,1.20600}, {14800,1.18875}, {14900,1.21450}, {15000,1.20775}, {15100,1.26350}, {15200,1.22975}, {15300,1.24300}, {15400,1.23375}, {15500,1.25250}, {15600,1.26325}, {15700,1.29925}, {15800,1.30325}, {15900,1.29500}, {16000,1.27775}, {16100,1.32650}, {16200,1.31875}, {16300,1.36025}, {16400,1.27350}, {16500,1.35000}, {16600,1.34125}, {16700,1.36700}, {16800,1.32475}, {16900,1.31900}, {17000,1.36575}, {17100,1.40400}, {17200,1.38850}, {17300,1.41450}, {17400,1.45725}, {17500,1.44075}, {17600,1.38850}, {17700,1.43175}, {17800,1.43125}, {17900,1.48875}, {18000,1.44550}, {18100,1.48850}, {18200,1.47625}, {18300,1.53900}, {18400,1.51050}, {18500,1.47025}, {18600,1.50350}, {18700,1.49750}, {18800,1.53775}, {18900,1.55975}, {19000,1.54950}, {19100,1.57350}, {19200,1.53025}, {19300,1.59575}, {19400,1.59450}, {19500,1.58600}, {19600,1.57175}, {19700,1.63575}, {19800,1.63225}, {19900,1.65750}, {20000,1.5835}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["actual reif"]["system"] = {{1,0.00003604}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00003604}, {6,0.00003604}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00003604}, {12,0.00000000}, {13,0.00000000}, {14,0.00003604}, {15,0.00007207}, {16,0.00020721}, {17,0.00000000}, {18,0.00000000}, {19,0.00007207}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00002703}, {24,0.00007207}, {25,0.00003604}, {26,0.00000000}, {27,0.00009910}, {28,0.00000000}, {29,0.00000000}, {30,0.00009910}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00005405}, {42,0.00000000}, {43,0.00006306}, {44,0.00000000}, {45,0.00000000}, {46,0.00003604}, {47,0.00003604}, {48,0.00000000}, {49,0.00000000}, {50,0.00009910}, {51,0.00000000}, {52,0.00000000}, {53,0.00007207}, {54,0.00000000}, {55,0.00003604}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00003604}, {62,0.00000000}, {63,0.00000000}, {64,0.00003604}, {65,0.00000000}, {66,0.00003604}, {67,0.00003604}, {68,0.00003604}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00003604}, {73,0.00003604}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00003604}, {79,0.00003604}, {80,0.00000000}, {81,0.00003604}, {82,0.00000000}, {83,0.00000000}, {84,0.00009910}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00006306}, {90,0.00000000}, {91,0.00003604}, {92,0.00003604}, {93,0.00000000}, {94,0.00000000}, {95,0.00003604}, {96,0.00014414}, {97,0.00007207}, {98,0.00007207}, {99,0.00000000}, {100,0.00003604}, {101,0.00000000}, {102,0.00009910}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00003604}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00003604}, {111,0.00000000}, {112,0.00002703}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00003604}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00006306}, {122,0.00000000}, {123,0.00000000}, {124,0.00002703}, {125,0.00002703}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00003604}, {130,0.00003604}, {131,0.00003604}, {132,0.00003604}, {133,0.00000000}, {134,0.00003604}, {135,0.00000000}, {136,0.00003604}, {137,0.00003604}, {138,0.00003604}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00006306}, {146,0.00000000}, {147,0.00002703}, {148,0.00007207}, {149,0.00000000}, {150,0.00003604}, {151,0.00003604}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00003604}, {158,0.00000000}, {159,0.00000000}, {160,0.00003604}, {161,0.00007207}, {162,0.00000000}, {163,0.00000000}, {164,0.00002703}, {165,0.00003604}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00003604}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00003604}, {176,0.00003604}, {177,0.00000000}, {178,0.00000000}, {179,0.00003604}, {180,0.00000000}, {181,0.00002703}, {182,0.00000000}, {183,0.00000000}, {184,0.00003604}, {185,0.00000000}, {186,0.00003604}, {187,0.00000000}, {188,0.00003604}, {189,0.00000000}, {190,0.00000000}, {191,0.00002703}, {192,0.00002703}, {193,0.00000000}, {194,0.00003604}, {195,0.00000000}, {196,0.00000000}, {197,0.00006306}, {198,0.00000000}, {199,0.00000000}, {200,0.00002703}, {201,0.00000000}, {202,0.00003604}, {203,0.00000000}, {204,0.00002703}, {205,0.00000000}, {206,0.00003604}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00002703}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00007207}, {217,0.00000000}, {218,0.00003604}, {219,0.00000000}, {220,0.00007207}, {221,0.00000000}, {222,0.00007207}, {223,0.00000000}, {224,0.00007207}, {225,0.00003604}, {226,0.00006306}, {227,0.00009910}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00010811}, {232,0.00000000}, {233,0.00000000}, {234,0.00003604}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00007207}, {241,0.00003604}, {242,0.00007207}, {243,0.00000000}, {244,0.00003604}, {245,0.00003604}, {246,0.00000000}, {247,0.00000000}, {248,0.00005405}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00003604}, {254,0.00007207}, {255,0.00003604}, {256,0.00000000}, {257,0.00003604}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00003604}, {263,0.00003604}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00009910}, {273,0.00003604}, {274,0.00003604}, {275,0.00000000}, {276,0.00002703}, {277,0.00000000}, {278,0.00002703}, {279,0.00002703}, {280,0.00003604}, {281,0.00003604}, {282,0.00016216}, {283,0.00000000}, {284,0.00013514}, {285,0.00000000}, {286,0.00000000}, {287,0.00003604}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00002703}, {292,0.00003604}, {293,0.00002703}, {294,0.00009009}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00007207}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00003604}, {305,0.00000000}, {306,0.00000000}, {307,0.00009910}, {308,0.00003604}, {309,0.00007207}, {310,0.00000000}, {311,0.00000000}, {312,0.00003604}, {313,0.00003604}, {314,0.00000000}, {315,0.00003604}, {316,0.00000000}, {317,0.00007207}, {318,0.00000000}, {319,0.00003604}, {320,0.00003604}, {321,0.00000000}, {322,0.00003604}, {323,0.00002703}, {324,0.00003604}, {325,0.00007207}, {326,0.00003604}, {327,0.00000000}, {328,0.00003604}, {329,0.00000000}, {330,0.00003604}, {331,0.00003604}, {332,0.00003604}, {333,0.00003604}, {334,0.00000000}, {335,0.00003604}, {336,0.00000000}, {337,0.00003604}, {338,0.00006306}, {339,0.00003604}, {340,0.00003604}, {341,0.00000000}, {342,0.00003604}, {343,0.00000000}, {344,0.00003604}, {345,0.00000000}, {346,0.00007207}, {347,0.00000000}, {348,0.00000000}, {349,0.00002703}, {350,0.00000000}, {351,0.00003604}, {352,0.00003604}, {353,0.00003604}, {354,0.00000000}, {355,0.00014414}, {356,0.00000000}, {357,0.00000000}, {358,0.00005405}, {359,0.00003604}, {360,0.00000000}, {361,0.00003604}, {362,0.00000000}, {363,0.00000000}, {364,0.00003604}, {365,0.00007207}, {366,0.00000000}, {367,0.00003604}, {368,0.00000000}, {369,0.00003604}, {370,0.00007207}, {371,0.00000000}, {372,0.00003604}, {373,0.00003604}, {374,0.00013514}, {375,0.00000000}, {376,0.00006306}, {377,0.00000000}, {378,0.00000000}, {379,0.00003604}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00003604}, {384,0.00003604}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00002703}, {389,0.00000000}, {390,0.00003604}, {391,0.00003604}, {392,0.00010811}, {393,0.00003604}, {394,0.00002703}, {395,0.00000000}, {396,0.00000000}, {397,0.00003604}, {398,0.00007207}, {399,0.00000000}, {400,0.00010811}, {401,0.00000000}, {402,0.00002703}, {403,0.00000000}, {404,0.00002703}, {405,0.00003604}, {406,0.00003604}, {407,0.00000000}, {408,0.00002703}, {409,0.00000000}, {410,0.00003604}, {411,0.00003604}, {412,0.00003604}, {413,0.00003604}, {414,0.00000000}, {415,0.00000000}, {416,0.00007207}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00003604}, {422,0.00003604}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00003604}, {427,0.00006306}, {428,0.00000000}, {429,0.00000000}, {430,0.00003604}, {431,0.00009910}, {432,0.00010811}, {433,0.00000000}, {434,0.00006306}, {435,0.00000000}, {436,0.00000000}, {437,0.00003604}, {438,0.00003604}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00009910}, {444,0.00003604}, {445,0.00003604}, {446,0.00007207}, {447,0.00000000}, {448,0.00003604}, {449,0.00007207}, {450,0.00000000}, {451,0.00000000}, {452,0.00003604}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00018018}, {457,0.00000000}, {458,0.00003604}, {459,0.00000000}, {460,0.00003604}, {461,0.00006306}, {462,0.00010811}, {463,0.00002703}, {464,0.00000000}, {465,0.00007207}, {466,0.00000000}, {467,0.00000000}, {468,0.00003604}, {469,0.00010811}, {470,0.00006306}, {471,0.00000000}, {472,0.00007207}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00003604}, {477,0.00006306}, {478,0.00014414}, {479,0.00003604}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00003604}, {484,0.00003604}, {485,0.00007207}, {486,0.00007207}, {487,0.00003604}, {488,0.00006306}, {489,0.00003604}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00003604}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00010811}, {499,0.00009910}, {500,0.00017117}, {505,0.00010811}, {510,0.00000000}, {515,0.00002703}, {520,0.00007207}, {525,0.00003604}, {530,0.00003604}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00007207}, {560,0.00010811}, {565,0.00003604}, {570,0.00007207}, {575,0.00007207}, {580,0.00007207}, {585,0.00007207}, {590,0.00002703}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00021622}, {620,0.00000000}, {625,0.00003604}, {630,0.00000000}, {635,0.00007207}, {640,0.00000000}, {645,0.00003604}, {650,0.00006306}, {655,0.00000000}, {660,0.00003604}, {665,0.00000000}, {670,0.00007207}, {675,0.00007207}, {680,0.00000000}, {685,0.00007207}, {690,0.00003604}, {695,0.00003604}, {700,0.00000000}, {705,0.00003604}, {710,0.00007207}, {715,0.00003604}, {720,0.00021622}, {725,0.00007207}, {730,0.00007207}, {735,0.00003604}, {740,0.00002703}, {745,0.00000000}, {750,0.00003604}, {755,0.00007207}, {760,0.00014414}, {765,0.00014414}, {770,0.00000000}, {775,0.00003604}, {780,0.00000000}, {785,0.00021622}, {790,0.00000000}, {795,0.00003604}, {800,0.00007207}, {805,0.00013514}, {810,0.00003604}, {815,0.00013514}, {820,0.00007207}, {825,0.00014414}, {830,0.00000000}, {835,0.00007207}, {840,0.00002703}, {845,0.00010811}, {850,0.00000000}, {855,0.00007207}, {860,0.00009910}, {865,0.00003604}, {870,0.00010811}, {875,0.00003604}, {880,0.00003604}, {885,0.00014414}, {890,0.00007207}, {895,0.00010811}, {900,0.00010811}, {905,0.00003604}, {910,0.00007207}, {915,0.00018018}, {920,0.00000000}, {925,0.00010811}, {930,0.00014414}, {935,0.00003604}, {940,0.00014414}, {945,0.00003604}, {950,0.00018018}, {955,0.00000000}, {960,0.00003604}, {965,0.00000000}, {970,0.00003604}, {975,0.00000000}, {980,0.00000000}, {985,0.00003604}, {990,0.00014414}, {995,0.00034234}, {1000,0.00027928}, {1010,0.00018018}, {1020,0.00003604}, {1030,0.00002703}, {1040,0.00003604}, {1050,0.00014414}, {1060,0.00009009}, {1070,0.00021622}, {1080,0.00010811}, {1090,0.00010811}, {1100,0.00007207}, {1110,0.00007207}, {1120,0.00013514}, {1130,0.00007207}, {1140,0.00007207}, {1150,0.00003604}, {1160,0.00007207}, {1170,0.00006306}, {1180,0.00013514}, {1190,0.00027027}, {1200,0.00007207}, {1210,0.00003604}, {1220,0.00010811}, {1230,0.00018018}, {1240,0.00003604}, {1250,0.00014414}, {1260,0.00010811}, {1270,0.00014414}, {1280,0.00003604}, {1290,0.00014414}, {1300,0.00013514}, {1310,0.00018018}, {1320,0.00010811}, {1330,0.00013514}, {1340,0.00027928}, {1350,0.00018018}, {1360,0.00003604}, {1370,0.00020721}, {1380,0.00018018}, {1390,0.00021622}, {1400,0.00005405}, {1410,0.00009910}, {1420,0.00010811}, {1430,0.00034234}, {1440,0.00003604}, {1450,0.00007207}, {1460,0.00020721}, {1470,0.00018018}, {1480,0.00010811}, {1490,0.00014414}, {1500,0.00007207}, {1510,0.00014414}, {1520,0.00007207}, {1530,0.00003604}, {1540,0.00020721}, {1550,0.00010811}, {1560,0.00007207}, {1570,0.00017117}, {1580,0.00013514}, {1590,0.00010811}, {1600,0.00018018}, {1610,0.00010811}, {1620,0.00010811}, {1630,0.00013514}, {1640,0.00010811}, {1650,0.00014414}, {1660,0.00018018}, {1670,0.00013514}, {1680,0.00010811}, {1690,0.00028829}, {1700,0.00003604}, {1710,0.00014414}, {1720,0.00017117}, {1730,0.00035135}, {1740,0.00024324}, {1750,0.00010811}, {1760,0.00017117}, {1770,0.00010811}, {1780,0.00025225}, {1790,0.00014414}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00003604}, {1830,0.00007207}, {1840,0.00003604}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00003604}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00007207}, {1940,0.00003604}, {1950,0.00003604}, {1960,0.00003604}, {1970,0.00007207}, {1980,0.00003604}, {1990,0.00003604}, {2000,0.00014414}, {2050,0.00009910}, {2100,0.00002703}, {2150,0.00003604}, {2200,0.00010811}, {2250,0.00007207}, {2300,0.00009910}, {2350,0.00003604}, {2400,0.00000000}, {2450,0.00006306}, {2500,0.00007207}, {2550,0.00002703}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00003604}, {2750,0.00003604}, {2800,0.00010811}, {2850,0.00014414}, {2900,0.00010811}, {2950,0.00003604}, {3000,0.00000000}, {3050,0.00006306}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00018018}, {3250,0.00007207}, {3300,0.00007207}, {3350,0.00003604}, {3400,0.00000000}, {3450,0.00014414}, {3500,0.00007207}, {3550,0.00003604}, {3600,0.00007207}, {3650,0.00000000}, {3700,0.00003604}, {3750,0.00000000}, {3800,0.00003604}, {3850,0.00003604}, {3900,0.00002703}, {3950,0.00010811}, {4000,0.00014414}, {4050,0.00009910}, {4100,0.00003604}, {4150,0.00010811}, {4200,0.00003604}, {4250,0.00000000}, {4300,0.00003604}, {4350,0.00000000}, {4400,0.00007207}, {4450,0.00007207}, {4500,0.00000000}, {4550,0.00006306}, {4600,0.00000000}, {4650,0.00003604}, {4700,0.00003604}, {4750,0.00010811}, {4800,0.00003604}, {4850,0.00020721}, {4900,0.00024324}, {4950,0.00018018}, {5000,0.00028829}, {5050,0.00017117}, {5100,0.00007207}, {5150,0.00003604}, {5200,0.00014414}, {5250,0.00007207}, {5300,0.00021622}, {5350,0.00010811}, {5400,0.00000000}, {5450,0.00003604}, {5500,0.00000000}, {5550,0.00003604}, {5600,0.00003604}, {5650,0.00000000}, {5700,0.00003604}, {5750,0.00035135}, {5800,0.00028829}, {5850,0.00037838}, {5900,0.00038739}, {5950,0.00031532}, {6000,0.00014414}, {6050,0.00000}, {6100,0.00000}, {6150,0.00100}, {6200,0.00100}, {6250,0.00100}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00100}, {6700,0.00000}, {6750,0.00000}, {6800,0.00100}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00200}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00100}, {8650,0.00100}, {8700,0.00000}, {8750,0.00075}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00200}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00100}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00075}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00100}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00100}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00100}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00100}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00100}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00100}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00152252}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00001802}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00196396}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000901}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000901}, {396,0.00000000}, {397,0.00000000}, {398,0.00000901}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000901}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00001802}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00001802}, {414,0.00000901}, {415,0.00000000}, {416,0.00000901}, {417,0.00000901}, {418,0.00001802}, {419,0.00000901}, {420,0.00000000}, {421,0.00000901}, {422,0.00000901}, {423,0.00002703}, {424,0.00004505}, {425,0.00006306}, {426,0.00003604}, {427,0.00003604}, {428,0.00006306}, {429,0.00009910}, {430,0.00014414}, {431,0.00010811}, {432,0.00010811}, {433,0.00011712}, {434,0.00025225}, {435,0.00019820}, {436,0.00023423}, {437,0.00033333}, {438,0.00030631}, {439,0.00037838}, {440,0.00041441}, {441,0.00046847}, {442,0.00046847}, {443,0.00045946}, {444,0.00047748}, {445,0.00045045}, {446,0.00054955}, {447,0.00056757}, {448,0.00057658}, {449,0.00059459}, {450,0.00058559}, {451,0.00059459}, {452,0.00060360}, {453,0.00057658}, {454,0.00061261}, {455,0.00058559}, {456,0.00064865}, {457,0.00063964}, {458,0.00065766}, {459,0.00072973}, {460,0.00219820}, {461,0.00068468}, {462,0.00080180}, {463,0.00080180}, {464,0.00085586}, {465,0.00084685}, {466,0.00088288}, {467,0.00089189}, {468,0.00089189}, {469,0.00092793}, {470,0.00092793}, {471,0.00095495}, {472,0.00096396}, {473,0.00092793}, {474,0.00097297}, {475,0.00099099}, {476,0.00096396}, {477,0.00099099}, {478,0.00099099}, {479,0.00099099}, {480,0.00100000}, {481,0.00100000}, {482,0.00099099}, {483,0.00100000}, {484,0.00100000}, {485,0.00100000}, {486,0.00100000}, {487,0.00100000}, {488,0.00100000}, {489,0.00099099}, {490,0.00100000}, {491,0.00100000}, {492,0.00100000}, {493,0.00100000}, {494,0.00100000}, {495,0.00100000}, {496,0.00100000}, {497,0.00100000}, {498,0.00100000}, {499,0.00100000}, {500,0.00100000}, {505,0.00100000}, {510,0.00100000}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00100000}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00361261}, {815,0.00100000}, {820,0.00370270}, {825,0.00100000}, {830,0.00107207}, {835,0.00100901}, {840,0.00104505}, {845,0.00103604}, {850,0.00109910}, {855,0.00117117}, {860,0.00120721}, {865,0.00303604}, {870,0.00136036}, {875,0.00146847}, {880,0.00146847}, {885,0.00156757}, {890,0.00161261}, {895,0.00163063}, {900,0.00164865}, {905,0.00176577}, {910,0.00181081}, {915,0.00183784}, {920,0.00189189}, {925,0.00189189}, {930,0.00194595}, {935,0.00191892}, {940,0.00197297}, {945,0.00199099}, {950,0.00199099}, {955,0.00200000}, {960,0.00200000}, {965,0.00200000}, {970,0.00200000}, {975,0.00200000}, {980,0.00200000}, {985,0.00200000}, {990,0.00200000}, {995,0.00200000}, {1000,0.00200000}, {1010,0.00200000}, {1020,0.00200000}, {1030,0.00486486}, {1040,0.00200000}, {1050,0.00200000}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200000}, {1140,0.00200000}, {1150,0.00357658}, {1160,0.00200000}, {1170,0.00200000}, {1180,0.00200000}, {1190,0.00200000}, {1200,0.00200000}, {1210,0.00646847}, {1220,0.00200901}, {1230,0.00200901}, {1240,0.00206306}, {1250,0.00215315}, {1260,0.00204505}, {1270,0.00217117}, {1280,0.00229730}, {1290,0.00236036}, {1300,0.00256757}, {1310,0.00257658}, {1320,0.00266667}, {1330,0.00749550}, {1340,0.00277477}, {1350,0.00282883}, {1360,0.00287387}, {1370,0.00288288}, {1380,0.00294595}, {1390,0.00298198}, {1400,0.00300000}, {1410,0.00299099}, {1420,0.00300000}, {1430,0.00300000}, {1440,0.00300000}, {1450,0.00300000}, {1460,0.00300000}, {1470,0.00300000}, {1480,0.00300000}, {1490,0.00300000}, {1500,0.00300000}, {1510,0.00300000}, {1520,0.00300000}, {1530,0.00300000}, {1540,0.00300000}, {1550,0.00300000}, {1560,0.00300000}, {1570,0.00300000}, {1580,0.00300000}, {1590,0.00300901}, {1600,0.00301802}, {1610,0.00300000}, {1620,0.00301802}, {1630,0.00305405}, {1640,0.00307207}, {1650,0.00309910}, {1660,0.00310811}, {1670,0.00323423}, {1680,0.00335135}, {1690,0.00335135}, {1700,0.00342342}, {1710,0.00355856}, {1720,0.00368468}, {1730,0.00367568}, {1740,0.00372973}, {1750,0.00377477}, {1760,0.00376577}, {1770,0.00393694}, {1780,0.00376577}, {1790,0.00387387}, {1800,0.00391892}, {1810,0.00393694}, {1820,0.00396396}, {1830,0.00399099}, {1840,0.00400000}, {1850,0.00400000}, {1860,0.01095495}, {1870,0.00400000}, {1880,0.00400000}, {1890,0.00400000}, {1900,0.00400000}, {1910,0.00400901}, {1920,0.00400000}, {1930,0.00400000}, {1940,0.00401802}, {1950,0.00400000}, {1960,0.00906306}, {1970,0.00404505}, {1980,0.00401802}, {1990,0.00401802}, {2000,0.00407207}, {2050,0.00426126}, {2100,0.00461261}, {2150,0.00473874}, {2200,0.00490991}, {2250,0.01201802}, {2300,0.00501802}, {2350,0.00502703}, {2400,0.00508108}, {2450,0.00535135}, {2500,0.00557658}, {2550,0.00581982}, {2600,0.00590090}, {2650,0.00596396}, {2700,0.00604505}, {2750,0.00607207}, {2800,0.01215315}, {2850,0.00649550}, {2900,0.00665766}, {2950,0.00681982}, {3000,0.00690090}, {3050,0.00700901}, {3100,0.00709009}, {3150,0.00716216}, {3200,0.01578378}, {3250,0.00755856}, {3300,0.00772072}, {3350,0.01596396}, {3400,0.00799099}, {3450,0.00807207}, {3500,0.00818919}, {3550,0.00829730}, {3600,0.00850450}, {3650,0.00866667}, {3700,0.00883784}, {3750,0.00900901}, {3800,0.01661261}, {3850,0.01527928}, {3900,0.00922523}, {3950,0.00945045}, {4000,0.00963063}, {4050,0.00991892}, {4100,0.00985586}, {4150,0.01015315}, {4200,0.01009009}, {4250,0.01026126}, {4300,0.01045946}, {4350,0.01054955}, {4400,0.01073874}, {4450,0.01088288}, {4500,0.01097297}, {4550,0.01894595}, {4600,0.01126126}, {4650,0.01135135}, {4700,0.01153153}, {4750,0.01172973}, {4800,0.01181982}, {4850,0.01193694}, {4900,0.01208108}, {4950,0.01223423}, {5000,0.01242342}, {5050,0.01250450}, {5100,0.01264865}, {5150,0.02388288}, {5200,0.01289189}, {5250,0.03123423}, {5300,0.01318919}, {5350,0.01328829}, {5400,0.01352252}, {5450,0.01366667}, {5500,0.01378378}, {5550,0.01390090}, {5600,0.01400000}, {5650,0.01402703}, {5700,0.01432432}, {5750,0.02022523}, {5800,0.01457658}, {5850,0.01473874}, {5900,0.01482883}, {5950,0.01492793}, {6000,0.01511712}, {6050,0.01475}, {6100,0.01475}, {6150,0.03125}, {6200,0.01500}, {6250,0.01500}, {6300,0.01525}, {6350,0.01575}, {6400,0.01550}, {6450,0.01525}, {6500,0.01575}, {6550,0.01600}, {6600,0.01650}, {6650,0.01650}, {6700,0.01675}, {6750,0.01675}, {6800,0.01675}, {6850,0.01725}, {6900,0.01700}, {6950,0.01725}, {7000,0.01700}, {7050,0.01750}, {7100,0.01725}, {7150,0.01775}, {7200,0.01800}, {7250,0.03025}, {7300,0.01850}, {7350,0.01850}, {7400,0.01875}, {7450,0.02475}, {7500,0.03325}, {7550,0.01950}, {7600,0.01900}, {7650,0.01975}, {7700,0.05575}, {7750,0.01925}, {7800,0.02000}, {7850,0.04125}, {7900,0.02000}, {7950,0.03200}, {8000,0.02050}, {8050,0.02025}, {8100,0.02050}, {8150,0.02075}, {8200,0.02100}, {8250,0.02075}, {8300,0.02125}, {8350,0.03150}, {8400,0.02125}, {8450,0.04050}, {8500,0.02150}, {8550,0.02175}, {8600,0.05775}, {8650,0.02225}, {8700,0.03850}, {8750,0.05875}, {8800,0.02150}, {8850,0.02250}, {8900,0.02300}, {8950,0.05775}, {9000,0.02300}, {9050,0.02275}, {9100,0.05525}, {9150,0.04575}, {9200,0.04550}, {9250,0.05050}, {9300,0.04850}, {9350,0.05350}, {9400,0.02400}, {9450,0.02400}, {9500,0.02425}, {9550,0.02400}, {9600,0.02450}, {9650,0.05200}, {9700,0.04925}, {9750,0.05675}, {9800,0.05075}, {9850,0.04025}, {9900,0.02575}, {9950,0.02625}, {10000,0.04950}, {10100,0.02650}, {10200,0.02650}, {10300,0.02700}, {10400,0.02725}, {10500,0.02750}, {10600,0.04675}, {10700,0.02800}, {10800,0.02850}, {10900,0.02900}, {11000,0.02850}, {11100,0.05525}, {11200,0.02950}, {11300,0.02975}, {11400,0.05375}, {11500,0.04875}, {11600,0.03125}, {11700,0.06175}, {11800,0.03100}, {11900,0.03150}, {12000,0.03175}, {12100,0.05450}, {12200,0.03225}, {12300,0.05650}, {12400,0.03300}, {12500,0.03325}, {12600,0.03300}, {12700,0.06200}, {12800,0.03425}, {12900,0.06575}, {13000,0.03425}, {13100,0.05775}, {13200,0.05700}, {13300,0.03500}, {13400,0.03600}, {13500,0.05550}, {13600,0.06000}, {13700,0.04075}, {13800,0.03675}, {13900,0.04925}, {14000,0.07150}, {14100,0.06825}, {14200,0.06800}, {14300,0.03850}, {14400,0.07725}, {14500,0.03850}, {14600,0.03900}, {14700,0.03925}, {14800,0.03950}, {14900,0.08050}, {15000,0.03950}, {15100,0.04025}, {15200,0.04050}, {15300,0.04075}, {15400,0.08425}, {15500,0.04150}, {15600,0.06250}, {15700,0.06700}, {15800,0.04275}, {15900,0.04200}, {16000,0.07550}, {16100,0.04275}, {16200,0.04400}, {16300,0.05550}, {16400,0.08425}, {16500,0.08275}, {16600,0.04450}, {16700,0.04475}, {16800,0.04375}, {16900,0.06325}, {17000,0.04550}, {17100,0.08250}, {17200,0.04600}, {17300,0.04625}, {17400,0.04700}, {17500,0.09075}, {17600,0.04625}, {17700,0.08025}, {17800,0.04800}, {17900,0.04800}, {18000,0.07725}, {18100,0.08000}, {18200,0.07150}, {18300,0.04900}, {18400,0.05000}, {18500,0.06450}, {18600,0.09900}, {18700,0.06925}, {18800,0.09700}, {18900,0.07625}, {19000,0.08750}, {19100,0.09325}, {19200,0.05250}, {19300,0.10775}, {19400,0.08325}, {19500,0.08225}, {19600,0.08525}, {19700,0.08975}, {19800,0.08675}, {19900,0.05375}, {20000,0.0530}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00002703}, {3,0.00003604}, {4,0.00007207}, {5,0.00007207}, {6,0.00003604}, {7,0.00000000}, {8,0.00002703}, {9,0.00000000}, {10,0.00003604}, {11,0.00002703}, {12,0.00006306}, {13,0.00008108}, {14,0.00002703}, {15,0.00003604}, {16,0.00013514}, {17,0.00000000}, {18,0.00005405}, {19,0.00014414}, {20,0.00009009}, {21,0.00006306}, {22,0.00003604}, {23,0.00009009}, {24,0.00005405}, {25,0.00003604}, {26,0.00006306}, {27,0.00007207}, {28,0.00005405}, {29,0.00003604}, {30,0.00009009}, {31,0.00003604}, {32,0.00012613}, {33,0.00003604}, {34,0.00023423}, {35,0.00009910}, {36,0.00010811}, {37,0.00019820}, {38,0.00002703}, {39,0.00003604}, {40,0.00016216}, {41,0.00018919}, {42,0.00009009}, {43,0.00000000}, {44,0.00009009}, {45,0.00009009}, {46,0.00006306}, {47,0.00009910}, {48,0.00018919}, {49,0.00021622}, {50,0.00012613}, {51,0.00015315}, {52,0.00009910}, {53,0.00017117}, {54,0.00013514}, {55,0.00011712}, {56,0.00010811}, {57,0.00000000}, {58,0.00006306}, {59,0.00013514}, {60,0.00019820}, {61,0.00012613}, {62,0.00007207}, {63,0.00023423}, {64,0.00007207}, {65,0.00022523}, {66,0.00006306}, {67,0.00015315}, {68,0.00016216}, {69,0.00019820}, {70,0.00027027}, {71,0.00024324}, {72,0.00022523}, {73,0.00017117}, {74,0.00007207}, {75,0.00018919}, {76,0.00013514}, {77,0.00036036}, {78,0.00011712}, {79,0.00008108}, {80,0.00022523}, {81,0.00018018}, {82,0.00025225}, {83,0.00015315}, {84,0.00009009}, {85,0.00009009}, {86,0.00019820}, {87,0.00025225}, {88,0.00011712}, {89,0.00016216}, {90,0.00015315}, {91,0.00011712}, {92,0.00012613}, {93,0.00011712}, {94,0.00038739}, {95,0.00007207}, {96,0.00018919}, {97,0.00029730}, {98,0.00023423}, {99,0.00019820}, {100,0.00024324}, {101,0.00018919}, {102,0.00021622}, {103,0.00027928}, {104,0.00018919}, {105,0.00024324}, {106,0.00011712}, {107,0.00030631}, {108,0.00014414}, {109,0.00023423}, {110,0.00019820}, {111,0.00018018}, {112,0.00035135}, {113,0.00021622}, {114,0.00024324}, {115,0.00032432}, {116,0.00017117}, {117,0.00035135}, {118,0.00018919}, {119,0.00037838}, {120,0.00010811}, {121,0.00020721}, {122,0.00038739}, {123,0.00013514}, {124,0.00009910}, {125,0.00018018}, {126,0.00023423}, {127,0.00018919}, {128,0.00027928}, {129,0.00028829}, {130,0.00021622}, {131,0.00012613}, {132,0.00022523}, {133,0.00027928}, {134,0.00045045}, {135,0.00024324}, {136,0.00031532}, {137,0.00016216}, {138,0.00022523}, {139,0.00028829}, {140,0.00022523}, {141,0.00015315}, {142,0.00035135}, {143,0.00018018}, {144,0.00016216}, {145,0.00042342}, {146,0.00024324}, {147,0.00027928}, {148,0.00018919}, {149,0.00042342}, {150,0.00039640}, {151,0.00031532}, {152,0.00035135}, {153,0.00053153}, {154,0.00027027}, {155,0.00053153}, {156,0.00035135}, {157,0.00030631}, {158,0.00017117}, {159,0.00019820}, {160,0.00009910}, {161,0.00038739}, {162,0.00019820}, {163,0.00028829}, {164,0.00032432}, {165,0.00018919}, {166,0.00026126}, {167,0.00025225}, {168,0.00033333}, {169,0.00024324}, {170,0.00035135}, {171,0.00034234}, {172,0.00027027}, {173,0.00035135}, {174,0.00034234}, {175,0.00020721}, {176,0.00033333}, {177,0.00016216}, {178,0.00048649}, {179,0.00045946}, {180,0.00021622}, {181,0.00025225}, {182,0.00045946}, {183,0.00036937}, {184,0.00028829}, {185,0.00026126}, {186,0.00024324}, {187,0.00034234}, {188,0.00034234}, {189,0.00051351}, {190,0.00045045}, {191,0.00036937}, {192,0.00036036}, {193,0.00053153}, {194,0.00045045}, {195,0.00036937}, {196,0.00026126}, {197,0.00031532}, {198,0.00037838}, {199,0.00043243}, {200,0.00160360}, {201,0.00046847}, {202,0.00047748}, {203,0.00046847}, {204,0.00025225}, {205,0.00047748}, {206,0.00042342}, {207,0.00044144}, {208,0.00045045}, {209,0.00029730}, {210,0.00051351}, {211,0.00046847}, {212,0.00036036}, {213,0.00036036}, {214,0.00027027}, {215,0.00042342}, {216,0.00047748}, {217,0.00039640}, {218,0.00039640}, {219,0.00043243}, {220,0.00050450}, {221,0.00036937}, {222,0.00039640}, {223,0.00042342}, {224,0.00045045}, {225,0.00039640}, {226,0.00056757}, {227,0.00032432}, {228,0.00040541}, {229,0.00035135}, {230,0.00036036}, {231,0.00033333}, {232,0.00032432}, {233,0.00043243}, {234,0.00060360}, {235,0.00047748}, {236,0.00048649}, {237,0.00043243}, {238,0.00047748}, {239,0.00037838}, {240,0.00036036}, {241,0.00048649}, {242,0.00060360}, {243,0.00048649}, {244,0.00035135}, {245,0.00031532}, {246,0.00048649}, {247,0.00062162}, {248,0.00054054}, {249,0.00067568}, {250,0.00055856}, {251,0.00044144}, {252,0.00063964}, {253,0.00048649}, {254,0.00037838}, {255,0.00027928}, {256,0.00038739}, {257,0.00051351}, {258,0.00039640}, {259,0.00045946}, {260,0.00047748}, {261,0.00034234}, {262,0.00039640}, {263,0.00046847}, {264,0.00048649}, {265,0.00036036}, {266,0.00053153}, {267,0.00059459}, {268,0.00056757}, {269,0.00032432}, {270,0.00069369}, {271,0.00058559}, {272,0.00040541}, {273,0.00051351}, {274,0.00047748}, {275,0.00035135}, {276,0.00060360}, {277,0.00045045}, {278,0.00053153}, {279,0.00045946}, {280,0.00056757}, {281,0.00047748}, {282,0.00038739}, {283,0.00052252}, {284,0.00062162}, {285,0.00057658}, {286,0.00062162}, {287,0.00046847}, {288,0.00045946}, {289,0.00055856}, {290,0.00056757}, {291,0.00048649}, {292,0.00061261}, {293,0.00040541}, {294,0.00063063}, {295,0.00040541}, {296,0.00030631}, {297,0.00053153}, {298,0.00048649}, {299,0.00049550}, {300,0.00046847}, {301,0.00059459}, {302,0.00042342}, {303,0.00043243}, {304,0.00052252}, {305,0.00054955}, {306,0.00061261}, {307,0.00041441}, {308,0.00075676}, {309,0.00063964}, {310,0.00043243}, {311,0.00038739}, {312,0.00055856}, {313,0.00039640}, {314,0.00047748}, {315,0.00057658}, {316,0.00065766}, {317,0.00066667}, {318,0.00058559}, {319,0.00079279}, {320,0.00046847}, {321,0.00052252}, {322,0.00070270}, {323,0.00081081}, {324,0.00063063}, {325,0.00071171}, {326,0.00061261}, {327,0.00060360}, {328,0.00054054}, {329,0.00075676}, {330,0.00070270}, {331,0.00070270}, {332,0.00054955}, {333,0.00054955}, {334,0.00067568}, {335,0.00063964}, {336,0.00075676}, {337,0.00061261}, {338,0.00076577}, {339,0.00060360}, {340,0.00056757}, {341,0.00067568}, {342,0.00072072}, {343,0.00064865}, {344,0.00064865}, {345,0.00075676}, {346,0.00041441}, {347,0.00052252}, {348,0.00051351}, {349,0.00102703}, {350,0.00094595}, {351,0.00071171}, {352,0.00077477}, {353,0.00066667}, {354,0.00071171}, {355,0.00070270}, {356,0.00068468}, {357,0.00084685}, {358,0.00088288}, {359,0.00057658}, {360,0.00075676}, {361,0.00072973}, {362,0.00090991}, {363,0.00086486}, {364,0.00061261}, {365,0.00078378}, {366,0.00048649}, {367,0.00063964}, {368,0.00071171}, {369,0.00070270}, {370,0.00075676}, {371,0.00082883}, {372,0.00061261}, {373,0.00068468}, {374,0.00073874}, {375,0.00091892}, {376,0.00079279}, {377,0.00219820}, {378,0.00078378}, {379,0.00075676}, {380,0.00082883}, {381,0.00082883}, {382,0.00069369}, {383,0.00065766}, {384,0.00088288}, {385,0.00087387}, {386,0.00088288}, {387,0.00083784}, {388,0.00084685}, {389,0.00087387}, {390,0.00081081}, {391,0.00083784}, {392,0.00075676}, {393,0.00075676}, {394,0.00051351}, {395,0.00090991}, {396,0.00092793}, {397,0.00091892}, {398,0.00071171}, {399,0.00059459}, {400,0.00094595}, {401,0.00093694}, {402,0.00081081}, {403,0.00117117}, {404,0.00081982}, {405,0.00091892}, {406,0.00084685}, {407,0.00083784}, {408,0.00062162}, {409,0.00088288}, {410,0.00059459}, {411,0.00064865}, {412,0.00089189}, {413,0.00101802}, {414,0.00114414}, {415,0.00069369}, {416,0.00094595}, {417,0.00057658}, {418,0.00096396}, {419,0.00081081}, {420,0.00065766}, {421,0.00086486}, {422,0.00068468}, {423,0.00102703}, {424,0.00065766}, {425,0.00086486}, {426,0.00076577}, {427,0.00089189}, {428,0.00082883}, {429,0.00054054}, {430,0.00090991}, {431,0.00064865}, {432,0.00095495}, {433,0.00075676}, {434,0.00067568}, {435,0.00061261}, {436,0.00102703}, {437,0.00095495}, {438,0.00107207}, {439,0.00091892}, {440,0.00106306}, {441,0.00087387}, {442,0.00089189}, {443,0.00095495}, {444,0.00081982}, {445,0.00073874}, {446,0.00103604}, {447,0.00117117}, {448,0.00090991}, {449,0.00082883}, {450,0.00098198}, {451,0.00086486}, {452,0.00116216}, {453,0.00098198}, {454,0.00094595}, {455,0.00067568}, {456,0.00063063}, {457,0.00105405}, {458,0.00077477}, {459,0.00091892}, {460,0.00263964}, {461,0.00112613}, {462,0.00085586}, {463,0.00106306}, {464,0.00101802}, {465,0.00094595}, {466,0.00081982}, {467,0.00102703}, {468,0.00102703}, {469,0.00100901}, {470,0.00087387}, {471,0.00073874}, {472,0.00117117}, {473,0.00096396}, {474,0.00109910}, {475,0.00090090}, {476,0.00110811}, {477,0.00065766}, {478,0.00077477}, {479,0.00094595}, {480,0.00099099}, {481,0.00088288}, {482,0.00104505}, {483,0.00088288}, {484,0.00098198}, {485,0.00081982}, {486,0.00109009}, {487,0.00098198}, {488,0.00108108}, {489,0.00096396}, {490,0.00107207}, {491,0.00093694}, {492,0.00094595}, {493,0.00100000}, {494,0.00099099}, {495,0.00106306}, {496,0.00118018}, {497,0.00097297}, {498,0.00109009}, {499,0.00096396}, {500,0.00097297}, {505,0.00100901}, {510,0.00100000}, {515,0.00105405}, {520,0.00099099}, {525,0.00101802}, {530,0.00118018}, {535,0.00125225}, {540,0.00110811}, {545,0.00118018}, {550,0.00129730}, {555,0.00110811}, {560,0.00130631}, {565,0.00109910}, {570,0.00110811}, {575,0.00100901}, {580,0.00100901}, {585,0.00106306}, {590,0.00129730}, {595,0.00123423}, {600,0.00122523}, {605,0.00098198}, {610,0.00114414}, {615,0.00121622}, {620,0.00123423}, {625,0.00116216}, {630,0.00117117}, {635,0.00116216}, {640,0.00110811}, {645,0.00115315}, {650,0.00102703}, {655,0.00109910}, {660,0.00115315}, {665,0.00129730}, {670,0.00115315}, {675,0.00109910}, {680,0.00121622}, {685,0.00127027}, {690,0.00153153}, {695,0.00118919}, {700,0.00145946}, {705,0.00131532}, {710,0.00122523}, {715,0.00154054}, {720,0.00147748}, {725,0.00122523}, {730,0.00131532}, {735,0.00138739}, {740,0.00146847}, {745,0.00124324}, {750,0.00133333}, {755,0.00128829}, {760,0.00122523}, {765,0.00132432}, {770,0.00128829}, {775,0.00138739}, {780,0.00141441}, {785,0.00122523}, {790,0.00139640}, {795,0.00146847}, {800,0.00145045}, {805,0.00152252}, {810,0.00316216}, {815,0.00148649}, {820,0.00349550}, {825,0.00127027}, {830,0.00156757}, {835,0.00143243}, {840,0.00148649}, {845,0.00154054}, {850,0.00148649}, {855,0.00140541}, {860,0.00136036}, {865,0.00311712}, {870,0.00161261}, {875,0.00167568}, {880,0.00162162}, {885,0.00164865}, {890,0.00187387}, {895,0.00160360}, {900,0.00172072}, {905,0.00166667}, {910,0.00171171}, {915,0.00201802}, {920,0.00188288}, {925,0.00182883}, {930,0.00181982}, {935,0.00140541}, {940,0.00173874}, {945,0.00212613}, {950,0.00163964}, {955,0.00166667}, {960,0.00177477}, {965,0.00180180}, {970,0.00217117}, {975,0.00170270}, {980,0.00190090}, {985,0.00199099}, {990,0.00185586}, {995,0.00204505}, {1000,0.00165766}, {1010,0.00198198}, {1020,0.00204505}, {1030,0.00454955}, {1040,0.00176577}, {1050,0.00213514}, {1060,0.00190991}, {1070,0.00204505}, {1080,0.00212613}, {1090,0.00203604}, {1100,0.00199099}, {1110,0.00194595}, {1120,0.00216216}, {1130,0.00228829}, {1140,0.00236937}, {1150,0.00342342}, {1160,0.00194595}, {1170,0.00197297}, {1180,0.00202703}, {1190,0.00207207}, {1200,0.00257658}, {1210,0.00645045}, {1220,0.00228829}, {1230,0.00254955}, {1240,0.00247748}, {1250,0.00227928}, {1260,0.00235135}, {1270,0.00250450}, {1280,0.00239640}, {1290,0.00259459}, {1300,0.00234234}, {1310,0.00244144}, {1320,0.00240541}, {1330,0.00733333}, {1340,0.00225225}, {1350,0.00254054}, {1360,0.00265766}, {1370,0.00218919}, {1380,0.00240541}, {1390,0.00282883}, {1400,0.00236036}, {1410,0.00265766}, {1420,0.00299099}, {1430,0.00283784}, {1440,0.00275676}, {1450,0.00258559}, {1460,0.00272072}, {1470,0.00259459}, {1480,0.00283784}, {1490,0.00304505}, {1500,0.00273874}, {1510,0.00284685}, {1520,0.00308108}, {1530,0.00286486}, {1540,0.00295495}, {1550,0.00301802}, {1560,0.00300901}, {1570,0.00303604}, {1580,0.00291892}, {1590,0.00318018}, {1600,0.00296396}, {1610,0.00307207}, {1620,0.00308108}, {1630,0.00324324}, {1640,0.00314414}, {1650,0.00312613}, {1660,0.00320721}, {1670,0.00314414}, {1680,0.00314414}, {1690,0.00331532}, {1700,0.00323423}, {1710,0.00338739}, {1720,0.00349550}, {1730,0.00340541}, {1740,0.00340541}, {1750,0.00341441}, {1760,0.00359459}, {1770,0.00381081}, {1780,0.00381081}, {1790,0.00390991}, {1800,0.00386486}, {1810,0.00391892}, {1820,0.00385586}, {1830,0.00389189}, {1840,0.00383784}, {1850,0.00412613}, {1860,0.01153153}, {1870,0.00410811}, {1880,0.00423423}, {1890,0.00400901}, {1900,0.00419820}, {1910,0.00411712}, {1920,0.00400000}, {1930,0.00407207}, {1940,0.00422523}, {1950,0.00413514}, {1960,0.00944144}, {1970,0.00402703}, {1980,0.00399099}, {1990,0.00418018}, {2000,0.00416216}, {2050,0.00434234}, {2100,0.00456757}, {2150,0.00452252}, {2200,0.00493694}, {2250,0.01271171}, {2300,0.00485586}, {2350,0.00533333}, {2400,0.00537838}, {2450,0.00538739}, {2500,0.00573874}, {2550,0.00537838}, {2600,0.00615315}, {2650,0.00590991}, {2700,0.00631532}, {2750,0.00574775}, {2800,0.01260360}, {2850,0.00662162}, {2900,0.00642342}, {2950,0.00671171}, {3000,0.00659459}, {3050,0.00695495}, {3100,0.00713514}, {3150,0.00682883}, {3200,0.01595495}, {3250,0.00731532}, {3300,0.00751351}, {3350,0.01604505}, {3400,0.00795495}, {3450,0.00812613}, {3500,0.00818919}, {3550,0.00833333}, {3600,0.00860360}, {3650,0.00837838}, {3700,0.00908108}, {3750,0.00917117}, {3800,0.01653153}, {3850,0.01557658}, {3900,0.00913514}, {3950,0.00931532}, {4000,0.00982883}, {4050,0.00978378}, {4100,0.00989189}, {4150,0.01020721}, {4200,0.01038739}, {4250,0.01026126}, {4300,0.01076577}, {4350,0.01089189}, {4400,0.01092793}, {4450,0.01104505}, {4500,0.01128829}, {4550,0.01869369}, {4600,0.01165766}, {4650,0.01170270}, {4700,0.01196396}, {4750,0.01208108}, {4800,0.01240541}, {4850,0.01234234}, {4900,0.01253153}, {4950,0.01288288}, {5000,0.01283784}, {5050,0.01272072}, {5100,0.01294595}, {5150,0.02402703}, {5200,0.01337838}, {5250,0.03106306}, {5300,0.01325225}, {5350,0.01341441}, {5400,0.01358559}, {5450,0.01425225}, {5500,0.01413514}, {5550,0.01442342}, {5600,0.01435135}, {5650,0.01394595}, {5700,0.01411712}, {5750,0.02012613}, {5800,0.01425225}, {5850,0.01471171}, {5900,0.01486486}, {5950,0.01468468}, {6000,0.01521622}, {6050,0.01500}, {6100,0.01375}, {6150,0.03200}, {6200,0.01375}, {6250,0.01650}, {6300,0.01475}, {6350,0.01625}, {6400,0.01600}, {6450,0.01550}, {6500,0.01550}, {6550,0.01525}, {6600,0.01625}, {6650,0.01625}, {6700,0.01600}, {6750,0.01650}, {6800,0.01525}, {6850,0.01600}, {6900,0.01725}, {6950,0.01725}, {7000,0.01775}, {7050,0.01625}, {7100,0.01625}, {7150,0.01775}, {7200,0.02000}, {7250,0.03075}, {7300,0.01800}, {7350,0.01800}, {7400,0.01700}, {7450,0.02475}, {7500,0.03450}, {7550,0.01875}, {7600,0.01950}, {7650,0.01950}, {7700,0.05500}, {7750,0.01900}, {7800,0.02050}, {7850,0.04225}, {7900,0.02050}, {7950,0.03150}, {8000,0.01925}, {8050,0.02175}, {8100,0.02150}, {8150,0.02150}, {8200,0.02175}, {8250,0.01925}, {8300,0.02025}, {8350,0.03100}, {8400,0.02125}, {8450,0.04150}, {8500,0.02150}, {8550,0.02175}, {8600,0.05800}, {8650,0.02175}, {8700,0.03975}, {8750,0.05875}, {8800,0.01925}, {8850,0.02400}, {8900,0.02300}, {8950,0.05650}, {9000,0.02250}, {9050,0.02275}, {9100,0.05650}, {9150,0.04525}, {9200,0.04550}, {9250,0.04975}, {9300,0.04775}, {9350,0.05325}, {9400,0.02600}, {9450,0.02400}, {9500,0.02400}, {9550,0.02400}, {9600,0.02575}, {9650,0.05225}, {9700,0.04900}, {9750,0.05675}, {9800,0.05125}, {9850,0.04050}, {9900,0.02550}, {9950,0.02500}, {10000,0.04950}, {10100,0.02700}, {10200,0.02575}, {10300,0.02750}, {10400,0.02725}, {10500,0.02700}, {10600,0.04800}, {10700,0.02825}, {10800,0.02800}, {10900,0.02850}, {11000,0.02800}, {11100,0.05550}, {11200,0.02925}, {11300,0.02950}, {11400,0.05250}, {11500,0.04950}, {11600,0.02950}, {11700,0.06375}, {11800,0.03175}, {11900,0.03250}, {12000,0.03175}, {12100,0.05450}, {12200,0.03175}, {12300,0.05650}, {12400,0.03400}, {12500,0.03175}, {12600,0.03175}, {12700,0.06100}, {12800,0.03150}, {12900,0.06525}, {13000,0.03375}, {13100,0.05675}, {13200,0.05775}, {13300,0.03600}, {13400,0.03600}, {13500,0.05475}, {13600,0.06150}, {13700,0.04075}, {13800,0.03575}, {13900,0.04950}, {14000,0.07125}, {14100,0.06750}, {14200,0.06775}, {14300,0.03800}, {14400,0.07625}, {14500,0.03875}, {14600,0.03950}, {14700,0.04000}, {14800,0.03950}, {14900,0.08050}, {15000,0.03950}, {15100,0.04050}, {15200,0.04025}, {15300,0.04150}, {15400,0.08475}, {15500,0.04150}, {15600,0.06300}, {15700,0.06625}, {15800,0.04375}, {15900,0.04175}, {16000,0.07575}, {16100,0.04225}, {16200,0.04250}, {16300,0.05525}, {16400,0.08450}, {16500,0.08400}, {16600,0.04450}, {16700,0.04425}, {16800,0.04550}, {16900,0.06375}, {17000,0.04650}, {17100,0.08150}, {17200,0.04575}, {17300,0.04750}, {17400,0.04775}, {17500,0.08925}, {17600,0.04675}, {17700,0.08025}, {17800,0.04900}, {17900,0.04800}, {18000,0.07750}, {18100,0.08050}, {18200,0.07100}, {18300,0.05000}, {18400,0.05100}, {18500,0.06425}, {18600,0.09900}, {18700,0.06950}, {18800,0.09775}, {18900,0.07600}, {19000,0.08750}, {19100,0.09225}, {19200,0.05225}, {19300,0.10775}, {19400,0.08275}, {19500,0.08275}, {19600,0.08600}, {19700,0.08925}, {19800,0.08775}, {19900,0.05425}, {20000,0.0540}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00002703}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00002703}, {61,0.00003604}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00003604}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00006306}, {81,0.00000000}, {82,0.00000000}, {83,0.00003604}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00003604}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00003604}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003604}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00003604}, {132,0.00003604}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00003604}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00002703}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00003604}, {155,0.00000000}, {156,0.00000000}, {157,0.00003604}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00002703}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00003604}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00002703}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00003604}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00003604}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00003604}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00003604}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00003604}, {243,0.00003604}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00002703}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00003604}, {261,0.00007207}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00003604}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00003604}, {278,0.00000000}, {279,0.00002703}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00003604}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00003604}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00003604}, {328,0.00000000}, {329,0.00000000}, {330,0.00003604}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00003604}, {339,0.00000000}, {340,0.00003604}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00002703}, {346,0.00003604}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00003604}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00003604}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00003604}, {368,0.00000000}, {369,0.00003604}, {370,0.00000000}, {371,0.00000000}, {372,0.00003604}, {373,0.00003604}, {374,0.00003604}, {375,0.00003604}, {376,0.00000000}, {377,0.00007207}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00003604}, {390,0.00000000}, {391,0.00000000}, {392,0.00003604}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00003604}, {405,0.00000000}, {406,0.00000000}, {407,0.00003604}, {408,0.00003604}, {409,0.00003604}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00003604}, {415,0.00000000}, {416,0.00000000}, {417,0.00002703}, {418,0.00000000}, {419,0.00003604}, {420,0.00000000}, {421,0.00003604}, {422,0.00003604}, {423,0.00000000}, {424,0.00000000}, {425,0.00003604}, {426,0.00002703}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00002703}, {439,0.00003604}, {440,0.00003604}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00007207}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00007207}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00007207}, {465,0.00003604}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00003604}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00003604}, {480,0.00003604}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00002703}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00002703}, {498,0.00000000}, {499,0.00003604}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00007207}, {595,0.00002703}, {600,0.00000000}, {605,0.00000000}, {610,0.00003604}, {615,0.00000000}, {620,0.00000000}, {625,0.00007207}, {630,0.00003604}, {635,0.00000000}, {640,0.00003604}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00007207}, {665,0.00000000}, {670,0.00003604}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00003604}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00003604}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00003604}, {740,0.00003604}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00002703}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00003604}, {805,0.00000000}, {810,0.00000000}, {815,0.00003604}, {820,0.00007207}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00003604}, {850,0.00000000}, {855,0.00003604}, {860,0.00000000}, {865,0.00007207}, {870,0.00010811}, {875,0.00000000}, {880,0.00007207}, {885,0.00000000}, {890,0.00000000}, {895,0.00003604}, {900,0.00000000}, {905,0.00000000}, {910,0.00003604}, {915,0.00003604}, {920,0.00000000}, {925,0.00003604}, {930,0.00000000}, {935,0.00000000}, {940,0.00003604}, {945,0.00000000}, {950,0.00000000}, {955,0.00007207}, {960,0.00003604}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00003604}, {990,0.00000000}, {995,0.00000000}, {1000,0.00003604}, {1010,0.00000000}, {1020,0.00003604}, {1030,0.00003604}, {1040,0.00000000}, {1050,0.00003604}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00003604}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00003604}, {1190,0.00000000}, {1200,0.00003604}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00003604}, {1240,0.00000000}, {1250,0.00002703}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00009009}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00002703}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003604}, {1490,0.00000000}, {1500,0.00007207}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003604}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00007207}, {1980,0.00003604}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00003604}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00002703}, {2350,0.00003604}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00003604}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00002703}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00003604}, {4450,0.00000000}, {4500,0.00003604}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00003604}, {5100,0.00000000}, {5150,0.00003604}, {5200,0.00000000}, {5250,0.00009910}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00003604}, {5700,0.00003604}, {5750,0.00025225}, {5800,0.00003604}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00100}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00001802}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00100000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00112613}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00118919}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000901}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000901}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000901}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000901}, {362,0.00001802}, {363,0.00000901}, {364,0.00000000}, {365,0.00000000}, {366,0.00001802}, {367,0.00000000}, {368,0.00002703}, {369,0.00000901}, {370,0.00000901}, {371,0.00000000}, {372,0.00000000}, {373,0.00001802}, {374,0.00000901}, {375,0.00001802}, {376,0.00000901}, {377,0.00000901}, {378,0.00000000}, {379,0.00006306}, {380,0.00005405}, {381,0.00001802}, {382,0.00009910}, {383,0.00005405}, {384,0.00008108}, {385,0.00001802}, {386,0.00014414}, {387,0.00010811}, {388,0.00017117}, {389,0.00015315}, {390,0.00027928}, {391,0.00025225}, {392,0.00015315}, {393,0.00036937}, {394,0.00039640}, {395,0.00040541}, {396,0.00010811}, {397,0.00046847}, {398,0.00054054}, {399,0.00053153}, {400,0.00014414}, {401,0.00071171}, {402,0.00067568}, {403,0.00066667}, {404,0.00044144}, {405,0.00077477}, {406,0.00075676}, {407,0.00081982}, {408,0.00060360}, {409,0.00085586}, {410,0.00088288}, {411,0.00090991}, {412,0.00086486}, {413,0.00091892}, {414,0.00090090}, {415,0.00094595}, {416,0.00097297}, {417,0.00074775}, {418,0.00095495}, {419,0.00099099}, {420,0.00098198}, {421,0.00097297}, {422,0.00069369}, {423,0.00097297}, {424,0.00100000}, {425,0.00100000}, {426,0.00100000}, {427,0.00100000}, {428,0.00100000}, {429,0.00100000}, {430,0.00100000}, {431,0.00100000}, {432,0.00091892}, {433,0.00100000}, {434,0.00100000}, {435,0.00100000}, {436,0.00100000}, {437,0.00098198}, {438,0.00100000}, {439,0.00100000}, {440,0.00100000}, {441,0.00100000}, {442,0.00100000}, {443,0.00100000}, {444,0.00100000}, {445,0.00100000}, {446,0.00100000}, {447,0.00100000}, {448,0.00100000}, {449,0.00100000}, {450,0.00100000}, {451,0.00100000}, {452,0.00100000}, {453,0.00100000}, {454,0.00100000}, {455,0.00100000}, {456,0.00100000}, {457,0.00100000}, {458,0.00100000}, {459,0.00100000}, {460,0.00100000}, {461,0.00100000}, {462,0.00100000}, {463,0.00100000}, {464,0.00100000}, {465,0.00100000}, {466,0.00100000}, {467,0.00100000}, {468,0.00100000}, {469,0.00100000}, {470,0.00100000}, {471,0.00100000}, {472,0.00100000}, {473,0.00100000}, {474,0.00100000}, {475,0.00100000}, {476,0.00100000}, {477,0.00100000}, {478,0.00100000}, {479,0.00100000}, {480,0.00100000}, {481,0.00100000}, {482,0.00100000}, {483,0.00100000}, {484,0.00100000}, {485,0.00100000}, {486,0.00100000}, {487,0.00100000}, {488,0.00100000}, {489,0.00100000}, {490,0.00100000}, {491,0.00100000}, {492,0.00100000}, {493,0.00100000}, {494,0.00100000}, {495,0.00100000}, {496,0.00100000}, {497,0.00100000}, {498,0.00100000}, {499,0.00100000}, {500,0.00100000}, {505,0.00100000}, {510,0.00100000}, {515,0.00108108}, {520,0.00100000}, {525,0.00492793}, {530,0.00100000}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00397297}, {555,0.00100000}, {560,0.00103604}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00580180}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100901}, {730,0.00102703}, {735,0.00100000}, {740,0.00101802}, {745,0.00100000}, {750,0.00100000}, {755,0.00106306}, {760,0.00100000}, {765,0.00111712}, {770,0.00113514}, {775,0.00106306}, {780,0.00124324}, {785,0.00107207}, {790,0.00144144}, {795,0.00104505}, {800,0.00157658}, {805,0.00109009}, {810,0.00170270}, {815,0.00119820}, {820,0.00173874}, {825,0.00137838}, {830,0.00190090}, {835,0.00164865}, {840,0.00196396}, {845,0.00182883}, {850,0.00200000}, {855,0.00198198}, {860,0.00168468}, {865,0.00200000}, {870,0.00197297}, {875,0.00200000}, {880,0.00200000}, {885,0.00197297}, {890,0.00200000}, {895,0.00200000}, {900,0.00200000}, {905,0.00200000}, {910,0.00200000}, {915,0.00200000}, {920,0.00200000}, {925,0.00200000}, {930,0.00200000}, {935,0.00200000}, {940,0.00200000}, {945,0.00200000}, {950,0.00200000}, {955,0.00200000}, {960,0.00200000}, {965,0.00200000}, {970,0.00200000}, {975,0.00209009}, {980,0.00200000}, {985,0.00200000}, {990,0.00200000}, {995,0.00200000}, {1000,0.00200000}, {1010,0.00200000}, {1020,0.00200000}, {1030,0.00200000}, {1040,0.00200000}, {1050,0.00200000}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00201802}, {1120,0.00200901}, {1130,0.00203604}, {1140,0.00210811}, {1150,0.00220721}, {1160,0.00214414}, {1170,0.00200000}, {1180,0.00202703}, {1190,0.00216216}, {1200,0.00253153}, {1210,0.00272973}, {1220,0.00206306}, {1230,0.00251351}, {1240,0.00290090}, {1250,0.00215315}, {1260,0.00262162}, {1270,0.00296396}, {1280,0.00255856}, {1290,0.00292793}, {1300,0.00300000}, {1310,0.00278378}, {1320,0.00300000}, {1330,0.00284685}, {1340,0.00300000}, {1350,0.00300000}, {1360,0.00300000}, {1370,0.00300000}, {1380,0.00300000}, {1390,0.00309910}, {1400,0.00300000}, {1410,0.00300000}, {1420,0.00300000}, {1430,0.00300000}, {1440,0.00307207}, {1450,0.00300000}, {1460,0.00300000}, {1470,0.00300000}, {1480,0.00301802}, {1490,0.00300000}, {1500,0.00300000}, {1510,0.00300000}, {1520,0.00309009}, {1530,0.00302703}, {1540,0.00300901}, {1550,0.00300901}, {1560,0.00300000}, {1570,0.00308108}, {1580,0.00346847}, {1590,0.00352252}, {1600,0.00353153}, {1610,0.00344144}, {1620,0.00346847}, {1630,0.00360360}, {1640,0.00364865}, {1650,0.00375676}, {1660,0.00384685}, {1670,0.00391892}, {1680,0.00400000}, {1690,0.00752252}, {1700,0.00343243}, {1710,0.00363063}, {1720,0.00381982}, {1730,0.00398198}, {1740,0.00400000}, {1750,0.01084685}, {1760,0.00387387}, {1770,0.00398198}, {1780,0.00400000}, {1790,0.00407207}, {1800,0.00399099}, {1810,0.00400000}, {1820,0.00400901}, {1830,0.00400000}, {1840,0.00400000}, {1850,0.00408108}, {1860,0.00400000}, {1870,0.00402703}, {1880,0.00400000}, {1890,0.00400901}, {1900,0.00400000}, {1910,0.00402703}, {1920,0.00400000}, {1930,0.00415315}, {1940,0.00400000}, {1950,0.01226126}, {1960,0.00400901}, {1970,0.00400000}, {1980,0.00423423}, {1990,0.00403604}, {2000,0.00400901}, {2050,0.00478378}, {2100,0.00481982}, {2150,0.00495495}, {2200,0.00498198}, {2250,0.00500000}, {2300,0.00984685}, {2350,0.00500000}, {2400,0.00515315}, {2450,0.00501802}, {2500,0.00579279}, {2550,0.00567568}, {2600,0.00571171}, {2650,0.00593694}, {2700,0.01271171}, {2750,0.00611712}, {2800,0.00600000}, {2850,0.00605405}, {2900,0.00653153}, {2950,0.00621622}, {3000,0.00687387}, {3050,0.00672973}, {3100,0.00700000}, {3150,0.00701802}, {3200,0.00700901}, {3250,0.00708108}, {3300,0.00713514}, {3350,0.00760360}, {3400,0.00791892}, {3450,0.00763964}, {3500,0.00791892}, {3550,0.00785586}, {3600,0.00816216}, {3650,0.00806306}, {3700,0.00800000}, {3750,0.00830631}, {3800,0.00858559}, {3850,0.00860360}, {3900,0.00867568}, {3950,0.00895495}, {4000,0.00914414}, {4050,0.00902703}, {4100,0.00942342}, {4150,0.00924324}, {4200,0.00944144}, {4250,0.00981982}, {4300,0.00988288}, {4350,0.00996396}, {4400,0.01006306}, {4450,0.02208108}, {4500,0.01008108}, {4550,0.01034234}, {4600,0.01056757}, {4650,0.01075676}, {4700,0.01061261}, {4750,0.02673874}, {4800,0.01100000}, {4850,0.01106306}, {4900,0.01116216}, {4950,0.01136937}, {5000,0.01172072}, {5050,0.01144144}, {5100,0.01172973}, {5150,0.01181982}, {5200,0.01186486}, {5250,0.01182883}, {5300,0.01226126}, {5350,0.01226126}, {5400,0.01242342}, {5450,0.01253153}, {5500,0.01272973}, {5550,0.01836937}, {5600,0.01272072}, {5650,0.01293694}, {5700,0.01305405}, {5750,0.01321622}, {5800,0.01315315}, {5850,0.01334234}, {5900,0.02989189}, {5950,0.02950450}, {6000,0.02554054}, {6050,0.01325}, {6100,0.01325}, {6150,0.01375}, {6200,0.01350}, {6250,0.01375}, {6300,0.01425}, {6350,0.03200}, {6400,0.01425}, {6450,0.01425}, {6500,0.01450}, {6550,0.01425}, {6600,0.01450}, {6650,0.01500}, {6700,0.01500}, {6750,0.01500}, {6800,0.01975}, {6850,0.01575}, {6900,0.01550}, {6950,0.01550}, {7000,0.02350}, {7050,0.02675}, {7100,0.01600}, {7150,0.01625}, {7200,0.01650}, {7250,0.01675}, {7300,0.01650}, {7350,0.01675}, {7400,0.01675}, {7450,0.02125}, {7500,0.04500}, {7550,0.04650}, {7600,0.01775}, {7650,0.03550}, {7700,0.02175}, {7750,0.01775}, {7800,0.01775}, {7850,0.01775}, {7900,0.01775}, {7950,0.01800}, {8000,0.01950}, {8050,0.03450}, {8100,0.04350}, {8150,0.03125}, {8200,0.03900}, {8250,0.01875}, {8300,0.01875}, {8350,0.01925}, {8400,0.01925}, {8450,0.01975}, {8500,0.01950}, {8550,0.03150}, {8600,0.01975}, {8650,0.01975}, {8700,0.04700}, {8750,0.03100}, {8800,0.02025}, {8850,0.02050}, {8900,0.02075}, {8950,0.02075}, {9000,0.04900}, {9050,0.02075}, {9100,0.02075}, {9150,0.02075}, {9200,0.02125}, {9250,0.02075}, {9300,0.02125}, {9350,0.02125}, {9400,0.04925}, {9450,0.02150}, {9500,0.05275}, {9550,0.02150}, {9600,0.02900}, {9650,0.05175}, {9700,0.02200}, {9750,0.02250}, {9800,0.02275}, {9850,0.03750}, {9900,0.02300}, {9950,0.02300}, {10000,0.02950}, {10100,0.02325}, {10200,0.02400}, {10300,0.02400}, {10400,0.02425}, {10500,0.05800}, {10600,0.02475}, {10700,0.02700}, {10800,0.05700}, {10900,0.04125}, {11000,0.02525}, {11100,0.05550}, {11200,0.02600}, {11300,0.02675}, {11400,0.02700}, {11500,0.02700}, {11600,0.02725}, {11700,0.02725}, {11800,0.03450}, {11900,0.02775}, {12000,0.02800}, {12100,0.02800}, {12200,0.03050}, {12300,0.02850}, {12400,0.02900}, {12500,0.02900}, {12600,0.02900}, {12700,0.03225}, {12800,0.03000}, {12900,0.03000}, {13000,0.03000}, {13100,0.03050}, {13200,0.03075}, {13300,0.03100}, {13400,0.05050}, {13500,0.05050}, {13600,0.05675}, {13700,0.03200}, {13800,0.03200}, {13900,0.03250}, {14000,0.03250}, {14100,0.03275}, {14200,0.03300}, {14300,0.03950}, {14400,0.03400}, {14500,0.03750}, {14600,0.06525}, {14700,0.04075}, {14800,0.03450}, {14900,0.06625}, {15000,0.03475}, {15100,0.03500}, {15200,0.06525}, {15300,0.05850}, {15400,0.03600}, {15500,0.07400}, {15600,0.09175}, {15700,0.08800}, {15800,0.05300}, {15900,0.03650}, {16000,0.07725}, {16100,0.09950}, {16200,0.03800}, {16300,0.06850}, {16400,0.07600}, {16500,0.03875}, {16600,0.06675}, {16700,0.08550}, {16800,0.10000}, {16900,0.10325}, {17000,0.05900}, {17100,0.04000}, {17200,0.04025}, {17300,0.04050}, {17400,0.10725}, {17500,0.06325}, {17600,0.04100}, {17700,0.06750}, {17800,0.09175}, {17900,0.06100}, {18000,0.04300}, {18100,0.10050}, {18200,0.04275}, {18300,0.04275}, {18400,0.04300}, {18500,0.04350}, {18600,0.09725}, {18700,0.04400}, {18800,0.07850}, {18900,0.07200}, {19000,0.05950}, {19100,0.04475}, {19200,0.10450}, {19300,0.04500}, {19400,0.04525}, {19500,0.04525}, {19600,0.04575}, {19700,0.06375}, {19800,0.10600}, {19900,0.10325}, {20000,0.0465}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["eval lazy"]["user"] = {{1,0.00002703}, {2,0.00000000}, {3,0.00006306}, {4,0.00008108}, {5,0.00000000}, {6,0.00003604}, {7,0.00018919}, {8,0.00006306}, {9,0.00018018}, {10,0.00018018}, {11,0.00000000}, {12,0.00007207}, {13,0.00006306}, {14,0.00005405}, {15,0.00009910}, {16,0.00005405}, {17,0.00006306}, {18,0.00013514}, {19,0.00009009}, {20,0.00015315}, {21,0.00009009}, {22,0.00002703}, {23,0.00012613}, {24,0.00009009}, {25,0.00012613}, {26,0.00012613}, {27,0.00007207}, {28,0.00012613}, {29,0.00013514}, {30,0.00012613}, {31,0.00002703}, {32,0.00010811}, {33,0.00018919}, {34,0.00009009}, {35,0.00019820}, {36,0.00012613}, {37,0.00011712}, {38,0.00020721}, {39,0.00014414}, {40,0.00008108}, {41,0.00003604}, {42,0.00012613}, {43,0.00009910}, {44,0.00013514}, {45,0.00009910}, {46,0.00010811}, {47,0.00018018}, {48,0.00009910}, {49,0.00015315}, {50,0.00006306}, {51,0.00018018}, {52,0.00022523}, {53,0.00002703}, {54,0.00017117}, {55,0.00016216}, {56,0.00024324}, {57,0.00009009}, {58,0.00021622}, {59,0.00018919}, {60,0.00014414}, {61,0.00020721}, {62,0.00021622}, {63,0.00016216}, {64,0.00010811}, {65,0.00016216}, {66,0.00012613}, {67,0.00016216}, {68,0.00009910}, {69,0.00022523}, {70,0.00018919}, {71,0.00025225}, {72,0.00026126}, {73,0.00021622}, {74,0.00024324}, {75,0.00049550}, {76,0.00015315}, {77,0.00025225}, {78,0.00018018}, {79,0.00029730}, {80,0.00034234}, {81,0.00027928}, {82,0.00025225}, {83,0.00007207}, {84,0.00018018}, {85,0.00033333}, {86,0.00026126}, {87,0.00022523}, {88,0.00022523}, {89,0.00019820}, {90,0.00027027}, {91,0.00018919}, {92,0.00019820}, {93,0.00009009}, {94,0.00006306}, {95,0.00029730}, {96,0.00027928}, {97,0.00038739}, {98,0.00020721}, {99,0.00023423}, {100,0.00036036}, {101,0.00020721}, {102,0.00023423}, {103,0.00025225}, {104,0.00011712}, {105,0.00039640}, {106,0.00021622}, {107,0.00024324}, {108,0.00024324}, {109,0.00043243}, {110,0.00027027}, {111,0.00025225}, {112,0.00027027}, {113,0.00020721}, {114,0.00025225}, {115,0.00028829}, {116,0.00043243}, {117,0.00017117}, {118,0.00029730}, {119,0.00011712}, {120,0.00036036}, {121,0.00043243}, {122,0.00015315}, {123,0.00010811}, {124,0.00031532}, {125,0.00039640}, {126,0.00027027}, {127,0.00038739}, {128,0.00031532}, {129,0.00023423}, {130,0.00027928}, {131,0.00030631}, {132,0.00021622}, {133,0.00029730}, {134,0.00028829}, {135,0.00035135}, {136,0.00017117}, {137,0.00054955}, {138,0.00036036}, {139,0.00030631}, {140,0.00024324}, {141,0.00027027}, {142,0.00023423}, {143,0.00034234}, {144,0.00032432}, {145,0.00036036}, {146,0.00050450}, {147,0.00024324}, {148,0.00029730}, {149,0.00054955}, {150,0.00039640}, {151,0.00018018}, {152,0.00031532}, {153,0.00036036}, {154,0.00032432}, {155,0.00035135}, {156,0.00026126}, {157,0.00043243}, {158,0.00032432}, {159,0.00039640}, {160,0.00036937}, {161,0.00048649}, {162,0.00058559}, {163,0.00121622}, {164,0.00022523}, {165,0.00043243}, {166,0.00025225}, {167,0.00045946}, {168,0.00026126}, {169,0.00032432}, {170,0.00052252}, {171,0.00048649}, {172,0.00049550}, {173,0.00030631}, {174,0.00040541}, {175,0.00148649}, {176,0.00058559}, {177,0.00040541}, {178,0.00054054}, {179,0.00039640}, {180,0.00026126}, {181,0.00037838}, {182,0.00045045}, {183,0.00044144}, {184,0.00028829}, {185,0.00024324}, {186,0.00053153}, {187,0.00022523}, {188,0.00040541}, {189,0.00058559}, {190,0.00059459}, {191,0.00032432}, {192,0.00045045}, {193,0.00022523}, {194,0.00043243}, {195,0.00052252}, {196,0.00038739}, {197,0.00167568}, {198,0.00057658}, {199,0.00038739}, {200,0.00037838}, {201,0.00055856}, {202,0.00034234}, {203,0.00055856}, {204,0.00037838}, {205,0.00050450}, {206,0.00040541}, {207,0.00063063}, {208,0.00034234}, {209,0.00059459}, {210,0.00037838}, {211,0.00033333}, {212,0.00043243}, {213,0.00056757}, {214,0.00054955}, {215,0.00045045}, {216,0.00046847}, {217,0.00047748}, {218,0.00048649}, {219,0.00051351}, {220,0.00044144}, {221,0.00041441}, {222,0.00060360}, {223,0.00055856}, {224,0.00031532}, {225,0.00062162}, {226,0.00072072}, {227,0.00053153}, {228,0.00047748}, {229,0.00080180}, {230,0.00049550}, {231,0.00044144}, {232,0.00050450}, {233,0.00046847}, {234,0.00040541}, {235,0.00039640}, {236,0.00028829}, {237,0.00042342}, {238,0.00041441}, {239,0.00024324}, {240,0.00055856}, {241,0.00053153}, {242,0.00056757}, {243,0.00027928}, {244,0.00036036}, {245,0.00048649}, {246,0.00051351}, {247,0.00060360}, {248,0.00051351}, {249,0.00067568}, {250,0.00059459}, {251,0.00054054}, {252,0.00064865}, {253,0.00058559}, {254,0.00044144}, {255,0.00054955}, {256,0.00049550}, {257,0.00044144}, {258,0.00044144}, {259,0.00060360}, {260,0.00057658}, {261,0.00059459}, {262,0.00063964}, {263,0.00065766}, {264,0.00045946}, {265,0.00047748}, {266,0.00066667}, {267,0.00054955}, {268,0.00061261}, {269,0.00072072}, {270,0.00052252}, {271,0.00052252}, {272,0.00053153}, {273,0.00078378}, {274,0.00055856}, {275,0.00057658}, {276,0.00058559}, {277,0.00092793}, {278,0.00068468}, {279,0.00047748}, {280,0.00069369}, {281,0.00067568}, {282,0.00069369}, {283,0.00052252}, {284,0.00065766}, {285,0.00062162}, {286,0.00037838}, {287,0.00050450}, {288,0.00072072}, {289,0.00039640}, {290,0.00060360}, {291,0.00054054}, {292,0.00047748}, {293,0.00057658}, {294,0.00035135}, {295,0.00049550}, {296,0.00061261}, {297,0.00054054}, {298,0.00070270}, {299,0.00072072}, {300,0.00054955}, {301,0.00072072}, {302,0.00087387}, {303,0.00061261}, {304,0.00053153}, {305,0.00070270}, {306,0.00065766}, {307,0.00047748}, {308,0.00057658}, {309,0.00067568}, {310,0.00050450}, {311,0.00067568}, {312,0.00052252}, {313,0.00072072}, {314,0.00067568}, {315,0.00065766}, {316,0.00059459}, {317,0.00072072}, {318,0.00076577}, {319,0.00062162}, {320,0.00061261}, {321,0.00069369}, {322,0.00079279}, {323,0.00050450}, {324,0.00055856}, {325,0.00065766}, {326,0.00072973}, {327,0.00085586}, {328,0.00078378}, {329,0.00076577}, {330,0.00100000}, {331,0.00068468}, {332,0.00063964}, {333,0.00078378}, {334,0.00073874}, {335,0.00063964}, {336,0.00071171}, {337,0.00078378}, {338,0.00059459}, {339,0.00049550}, {340,0.00085586}, {341,0.00082883}, {342,0.00057658}, {343,0.00090090}, {344,0.00079279}, {345,0.00105405}, {346,0.00079279}, {347,0.00072973}, {348,0.00069369}, {349,0.00070270}, {350,0.00129730}, {351,0.00111712}, {352,0.00090991}, {353,0.00073874}, {354,0.00065766}, {355,0.00071171}, {356,0.00090090}, {357,0.00076577}, {358,0.00081081}, {359,0.00083784}, {360,0.00064865}, {361,0.00100000}, {362,0.00085586}, {363,0.00096396}, {364,0.00072973}, {365,0.00073874}, {366,0.00101802}, {367,0.00082883}, {368,0.00078378}, {369,0.00093694}, {370,0.00066667}, {371,0.00072973}, {372,0.00071171}, {373,0.00066667}, {374,0.00072973}, {375,0.00062162}, {376,0.00081081}, {377,0.00090991}, {378,0.00095495}, {379,0.00076577}, {380,0.00076577}, {381,0.00098198}, {382,0.00104505}, {383,0.00084685}, {384,0.00082883}, {385,0.00091892}, {386,0.00084685}, {387,0.00081081}, {388,0.00101802}, {389,0.00090991}, {390,0.00075676}, {391,0.00099099}, {392,0.00104505}, {393,0.00098198}, {394,0.00089189}, {395,0.00115315}, {396,0.00095495}, {397,0.00083784}, {398,0.00095495}, {399,0.00066667}, {400,0.00072072}, {401,0.00101802}, {402,0.00081081}, {403,0.00118018}, {404,0.00098198}, {405,0.00098198}, {406,0.00101802}, {407,0.00076577}, {408,0.00122523}, {409,0.00081982}, {410,0.00086486}, {411,0.00072973}, {412,0.00102703}, {413,0.00090090}, {414,0.00076577}, {415,0.00090991}, {416,0.00071171}, {417,0.00092793}, {418,0.00113514}, {419,0.00121622}, {420,0.00115315}, {421,0.00091892}, {422,0.00081982}, {423,0.00095495}, {424,0.00118919}, {425,0.00095495}, {426,0.00087387}, {427,0.00095495}, {428,0.00063964}, {429,0.00112613}, {430,0.00086486}, {431,0.00104505}, {432,0.00102703}, {433,0.00100901}, {434,0.00118018}, {435,0.00108108}, {436,0.00120721}, {437,0.00084685}, {438,0.00088288}, {439,0.00115315}, {440,0.00072072}, {441,0.00092793}, {442,0.00094595}, {443,0.00092793}, {444,0.00089189}, {445,0.00106306}, {446,0.00112613}, {447,0.00136937}, {448,0.00126126}, {449,0.00100901}, {450,0.00090090}, {451,0.00100000}, {452,0.00103604}, {453,0.00085586}, {454,0.00090991}, {455,0.00098198}, {456,0.00085586}, {457,0.00120721}, {458,0.00139640}, {459,0.00106306}, {460,0.00120721}, {461,0.00104505}, {462,0.00100901}, {463,0.00116216}, {464,0.00123423}, {465,0.00092793}, {466,0.00100901}, {467,0.00090991}, {468,0.00100000}, {469,0.00118018}, {470,0.00097297}, {471,0.00104505}, {472,0.00106306}, {473,0.00102703}, {474,0.00099099}, {475,0.00100901}, {476,0.00105405}, {477,0.00093694}, {478,0.00109009}, {479,0.00111712}, {480,0.00088288}, {481,0.00093694}, {482,0.00109910}, {483,0.00093694}, {484,0.00065766}, {485,0.00116216}, {486,0.00100901}, {487,0.00145946}, {488,0.00098198}, {489,0.00103604}, {490,0.00120721}, {491,0.00119820}, {492,0.00108108}, {493,0.00083784}, {494,0.00111712}, {495,0.00122523}, {496,0.00104505}, {497,0.00119820}, {498,0.00090090}, {499,0.00111712}, {500,0.00104505}, {505,0.00101802}, {510,0.00110811}, {515,0.00088288}, {520,0.00096396}, {525,0.00457658}, {530,0.00137838}, {535,0.00124324}, {540,0.00136036}, {545,0.00101802}, {550,0.00398198}, {555,0.00109910}, {560,0.00125225}, {565,0.00123423}, {570,0.00095495}, {575,0.00155856}, {580,0.00102703}, {585,0.00135135}, {590,0.00154054}, {595,0.00110811}, {600,0.00159459}, {605,0.00117117}, {610,0.00114414}, {615,0.00131532}, {620,0.00104505}, {625,0.00124324}, {630,0.00118018}, {635,0.00112613}, {640,0.00134234}, {645,0.00147748}, {650,0.00146847}, {655,0.00128829}, {660,0.00154955}, {665,0.00608108}, {670,0.00117117}, {675,0.00127027}, {680,0.00168468}, {685,0.00123423}, {690,0.00127928}, {695,0.00142342}, {700,0.00164865}, {705,0.00134234}, {710,0.00135135}, {715,0.00129730}, {720,0.00153153}, {725,0.00165766}, {730,0.00128829}, {735,0.00136937}, {740,0.00153153}, {745,0.00161261}, {750,0.00144144}, {755,0.00165766}, {760,0.00147748}, {765,0.00168468}, {770,0.00152252}, {775,0.00179279}, {780,0.00148649}, {785,0.00159459}, {790,0.00149550}, {795,0.00152252}, {800,0.00197297}, {805,0.00162162}, {810,0.00155856}, {815,0.00169369}, {820,0.00156757}, {825,0.00146847}, {830,0.00174775}, {835,0.00159459}, {840,0.00168468}, {845,0.00171171}, {850,0.00163964}, {855,0.00173874}, {860,0.00148649}, {865,0.00167568}, {870,0.00182883}, {875,0.00190991}, {880,0.00169369}, {885,0.00184685}, {890,0.00170270}, {895,0.00221622}, {900,0.00167568}, {905,0.00146847}, {910,0.00198198}, {915,0.00185586}, {920,0.00186486}, {925,0.00167568}, {930,0.00207207}, {935,0.00190090}, {940,0.00188288}, {945,0.00192793}, {950,0.00163964}, {955,0.00208108}, {960,0.00189189}, {965,0.00222523}, {970,0.00183784}, {975,0.00194595}, {980,0.00207207}, {985,0.00201802}, {990,0.00200000}, {995,0.00149550}, {1000,0.00201802}, {1010,0.00213514}, {1020,0.00227027}, {1030,0.00224324}, {1040,0.00196396}, {1050,0.00261261}, {1060,0.00186486}, {1070,0.00195495}, {1080,0.00237838}, {1090,0.00227027}, {1100,0.00204505}, {1110,0.00227027}, {1120,0.00234234}, {1130,0.00246847}, {1140,0.00241441}, {1150,0.00238739}, {1160,0.00232432}, {1170,0.00222523}, {1180,0.00223423}, {1190,0.00267568}, {1200,0.00234234}, {1210,0.00267568}, {1220,0.00231532}, {1230,0.00250450}, {1240,0.00264865}, {1250,0.00278378}, {1260,0.00271171}, {1270,0.00268468}, {1280,0.00259459}, {1290,0.00245045}, {1300,0.00269369}, {1310,0.00247748}, {1320,0.00258559}, {1330,0.00260360}, {1340,0.00287387}, {1350,0.00280180}, {1360,0.00223423}, {1370,0.00283784}, {1380,0.00290090}, {1390,0.00273874}, {1400,0.00291892}, {1410,0.00281081}, {1420,0.00309009}, {1430,0.00275676}, {1440,0.00287387}, {1450,0.00311712}, {1460,0.00300901}, {1470,0.00274775}, {1480,0.00293694}, {1490,0.00301802}, {1500,0.00257658}, {1510,0.00281081}, {1520,0.00323423}, {1530,0.00309009}, {1540,0.00315315}, {1550,0.00298198}, {1560,0.00314414}, {1570,0.00303604}, {1580,0.00324324}, {1590,0.00336036}, {1600,0.00323423}, {1610,0.00342342}, {1620,0.00342342}, {1630,0.00332432}, {1640,0.00341441}, {1650,0.00342342}, {1660,0.00339640}, {1670,0.00350450}, {1680,0.00357658}, {1690,0.00743243}, {1700,0.00321622}, {1710,0.00324324}, {1720,0.00341441}, {1730,0.00350450}, {1740,0.00360360}, {1750,0.01090090}, {1760,0.00367568}, {1770,0.00369369}, {1780,0.00397297}, {1790,0.00391892}, {1800,0.00397297}, {1810,0.00406306}, {1820,0.00429730}, {1830,0.00381982}, {1840,0.00394595}, {1850,0.00396396}, {1860,0.00420721}, {1870,0.00413514}, {1880,0.00405405}, {1890,0.00436036}, {1900,0.00410811}, {1910,0.00422523}, {1920,0.00432432}, {1930,0.00453153}, {1940,0.00409910}, {1950,0.01272072}, {1960,0.00441441}, {1970,0.00421622}, {1980,0.00456757}, {1990,0.00432432}, {2000,0.00422523}, {2050,0.00448649}, {2100,0.00459459}, {2150,0.00489189}, {2200,0.00490991}, {2250,0.00532432}, {2300,0.01022523}, {2350,0.00506306}, {2400,0.00557658}, {2450,0.00526126}, {2500,0.00547748}, {2550,0.00536937}, {2600,0.00550450}, {2650,0.00571171}, {2700,0.01300901}, {2750,0.00569369}, {2800,0.00613514}, {2850,0.00619820}, {2900,0.00636937}, {2950,0.00626126}, {3000,0.00667568}, {3050,0.00627027}, {3100,0.00683784}, {3150,0.00700901}, {3200,0.00685586}, {3250,0.00701802}, {3300,0.00715315}, {3350,0.00734234}, {3400,0.00763964}, {3450,0.00752252}, {3500,0.00756757}, {3550,0.00747748}, {3600,0.00822523}, {3650,0.00778378}, {3700,0.00805405}, {3750,0.00851351}, {3800,0.00836036}, {3850,0.00845045}, {3900,0.00866667}, {3950,0.00897297}, {4000,0.00922523}, {4050,0.00939640}, {4100,0.00982883}, {4150,0.00925225}, {4200,0.00927928}, {4250,0.01006306}, {4300,0.01011712}, {4350,0.01034234}, {4400,0.01052252}, {4450,0.02245045}, {4500,0.01040541}, {4550,0.01067568}, {4600,0.01109009}, {4650,0.01091892}, {4700,0.01065766}, {4750,0.02689189}, {4800,0.01146847}, {4850,0.01145946}, {4900,0.01170270}, {4950,0.01200000}, {5000,0.01210811}, {5050,0.01187387}, {5100,0.01209910}, {5150,0.01224324}, {5200,0.01227027}, {5250,0.01200901}, {5300,0.01263964}, {5350,0.01261261}, {5400,0.01301802}, {5450,0.01317117}, {5500,0.01297297}, {5550,0.01830631}, {5600,0.01273874}, {5650,0.01308108}, {5700,0.01344144}, {5750,0.01333333}, {5800,0.01353153}, {5850,0.01350450}, {5900,0.02990991}, {5950,0.02913514}, {6000,0.02545946}, {6050,0.01300}, {6100,0.01250}, {6150,0.01400}, {6200,0.01400}, {6250,0.01300}, {6300,0.01325}, {6350,0.03300}, {6400,0.01575}, {6450,0.01425}, {6500,0.01475}, {6550,0.01575}, {6600,0.01475}, {6650,0.01550}, {6700,0.01525}, {6750,0.01475}, {6800,0.01825}, {6850,0.01525}, {6900,0.01450}, {6950,0.01525}, {7000,0.02200}, {7050,0.02625}, {7100,0.01500}, {7150,0.01550}, {7200,0.01650}, {7250,0.01625}, {7300,0.01525}, {7350,0.01550}, {7400,0.01750}, {7450,0.02175}, {7500,0.04575}, {7550,0.04525}, {7600,0.01875}, {7650,0.03500}, {7700,0.02300}, {7750,0.01600}, {7800,0.01600}, {7850,0.01600}, {7900,0.01750}, {7950,0.01675}, {8000,0.01850}, {8050,0.03475}, {8100,0.04225}, {8150,0.03025}, {8200,0.03825}, {8250,0.01925}, {8300,0.01700}, {8350,0.01900}, {8400,0.02050}, {8450,0.01900}, {8500,0.01925}, {8550,0.03050}, {8600,0.02025}, {8650,0.01900}, {8700,0.04675}, {8750,0.03025}, {8800,0.02050}, {8850,0.02025}, {8900,0.02150}, {8950,0.02025}, {9000,0.04975}, {9050,0.02300}, {9100,0.02075}, {9150,0.02025}, {9200,0.02075}, {9250,0.02150}, {9300,0.02125}, {9350,0.02100}, {9400,0.04925}, {9450,0.02150}, {9500,0.05375}, {9550,0.02275}, {9600,0.02925}, {9650,0.05050}, {9700,0.02200}, {9750,0.02275}, {9800,0.02075}, {9850,0.03750}, {9900,0.02300}, {9950,0.02175}, {10000,0.03100}, {10100,0.02400}, {10200,0.02400}, {10300,0.02400}, {10400,0.02400}, {10500,0.05775}, {10600,0.02400}, {10700,0.02550}, {10800,0.05800}, {10900,0.04125}, {11000,0.02575}, {11100,0.05575}, {11200,0.02475}, {11300,0.02725}, {11400,0.02675}, {11500,0.02650}, {11600,0.02700}, {11700,0.02550}, {11800,0.03450}, {11900,0.02700}, {12000,0.02700}, {12100,0.02850}, {12200,0.02900}, {12300,0.02725}, {12400,0.02925}, {12500,0.02875}, {12600,0.02825}, {12700,0.03300}, {12800,0.03025}, {12900,0.02950}, {13000,0.03175}, {13100,0.03075}, {13200,0.03025}, {13300,0.03175}, {13400,0.05100}, {13500,0.05125}, {13600,0.05900}, {13700,0.03200}, {13800,0.03250}, {13900,0.03250}, {14000,0.03475}, {14100,0.03150}, {14200,0.03250}, {14300,0.03975}, {14400,0.03600}, {14500,0.03775}, {14600,0.06400}, {14700,0.04050}, {14800,0.03475}, {14900,0.06625}, {15000,0.03575}, {15100,0.03600}, {15200,0.06600}, {15300,0.06000}, {15400,0.03675}, {15500,0.07325}, {15600,0.09150}, {15700,0.08775}, {15800,0.05225}, {15900,0.03700}, {16000,0.07625}, {16100,0.09950}, {16200,0.03875}, {16300,0.06900}, {16400,0.07575}, {16500,0.03875}, {16600,0.06700}, {16700,0.08675}, {16800,0.09950}, {16900,0.10325}, {17000,0.05850}, {17100,0.04150}, {17200,0.03950}, {17300,0.04075}, {17400,0.10800}, {17500,0.06350}, {17600,0.04250}, {17700,0.06700}, {17800,0.09175}, {17900,0.06300}, {18000,0.04325}, {18100,0.10050}, {18200,0.04125}, {18300,0.04200}, {18400,0.04225}, {18500,0.04300}, {18600,0.09750}, {18700,0.04350}, {18800,0.07975}, {18900,0.07300}, {19000,0.06000}, {19100,0.04550}, {19200,0.10450}, {19300,0.04550}, {19400,0.04700}, {19500,0.04325}, {19600,0.04550}, {19700,0.06400}, {19800,0.10550}, {19900,0.10225}, {20000,0.0480}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["eval lazy"]["system"] = {{1,0.00002703}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00002703}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00003604}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00003604}, {63,0.00003604}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00003604}, {83,0.00000000}, {84,0.00000000}, {85,0.00003604}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00003604}, {103,0.00000000}, {104,0.00000000}, {105,0.00003604}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00003604}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00003604}, {114,0.00000000}, {115,0.00003604}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00003604}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00003604}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00003604}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00003604}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00002703}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00003604}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00003604}, {180,0.00000000}, {181,0.00003604}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00007207}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00003604}, {197,0.00000000}, {198,0.00000000}, {199,0.00002703}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00002703}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00003604}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00003604}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00003604}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00003604}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00003604}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00003604}, {258,0.00003604}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00003604}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00003604}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00003604}, {294,0.00000000}, {295,0.00002703}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00003604}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00003604}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00002703}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00003604}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00003604}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00010811}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00003604}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00013514}, {353,0.00002703}, {354,0.00003604}, {355,0.00000000}, {356,0.00003604}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00003604}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00003604}, {373,0.00000000}, {374,0.00000000}, {375,0.00003604}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00003604}, {384,0.00000000}, {385,0.00000000}, {386,0.00003604}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00003604}, {397,0.00000000}, {398,0.00000000}, {399,0.00003604}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00003604}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00003604}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00003604}, {425,0.00003604}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00007207}, {443,0.00003604}, {444,0.00000000}, {445,0.00002703}, {446,0.00000000}, {447,0.00003604}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00003604}, {452,0.00000000}, {453,0.00003604}, {454,0.00003604}, {455,0.00003604}, {456,0.00003604}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00002703}, {462,0.00002703}, {463,0.00000000}, {464,0.00003604}, {465,0.00000000}, {466,0.00003604}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00003604}, {472,0.00000000}, {473,0.00003604}, {474,0.00000000}, {475,0.00003604}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00002703}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00003604}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00003604}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00003604}, {497,0.00000000}, {498,0.00000000}, {499,0.00003604}, {500,0.00003604}, {505,0.00000000}, {510,0.00000000}, {515,0.00003604}, {520,0.00000000}, {525,0.00017117}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00007207}, {555,0.00003604}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00003604}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00003604}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00003604}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00007207}, {660,0.00000000}, {665,0.00006306}, {670,0.00000000}, {675,0.00002703}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00003604}, {700,0.00000000}, {705,0.00000000}, {710,0.00003604}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00003604}, {735,0.00003604}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00003604}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00010811}, {785,0.00000000}, {790,0.00003604}, {795,0.00003604}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00003604}, {820,0.00002703}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00003604}, {870,0.00003604}, {875,0.00000000}, {880,0.00003604}, {885,0.00007207}, {890,0.00003604}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00007207}, {925,0.00000000}, {930,0.00003604}, {935,0.00000000}, {940,0.00003604}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00007207}, {980,0.00003604}, {985,0.00000000}, {990,0.00007207}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00007207}, {1130,0.00000000}, {1140,0.00003604}, {1150,0.00003604}, {1160,0.00003604}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00007207}, {1210,0.00003604}, {1220,0.00003604}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003604}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00003604}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00003604}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00003604}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00003604}, {1510,0.00000000}, {1520,0.00003604}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00003604}, {1560,0.00000000}, {1570,0.00003604}, {1580,0.00002703}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00007207}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00006306}, {1700,0.00000000}, {1710,0.00003604}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00039640}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00002703}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00002703}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00003604}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00003604}, {1970,0.00003604}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00003604}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00009910}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00007207}, {2650,0.00000000}, {2700,0.00003604}, {2750,0.00000000}, {2800,0.00003604}, {2850,0.00000000}, {2900,0.00007207}, {2950,0.00009910}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00003604}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00003604}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00003604}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00007207}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00003604}, {3950,0.00000000}, {4000,0.00003604}, {4050,0.00000000}, {4100,0.00003604}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00003604}, {4350,0.00003604}, {4400,0.00003604}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00003604}, {4600,0.00003604}, {4650,0.00003604}, {4700,0.00003604}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00003604}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00003604}, {5300,0.00000000}, {5350,0.00007207}, {5400,0.00003604}, {5450,0.00000000}, {5500,0.00003604}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00003604}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00021622}, {5950,0.00031532}, {6000,0.00010811}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00100}, {6800,0.00075}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00100}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00075}, {9850,0.00000}, {9900,0.00100}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["intros _"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00009009}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00341441}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00001802}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00003604}, {2900,0.00022523}, {2950,0.00000000}, {3000,0.00022523}, {3050,0.00002703}, {3100,0.00071171}, {3150,0.00054955}, {3200,0.00047748}, {3250,0.00072072}, {3300,0.00072072}, {3350,0.00076577}, {3400,0.00089189}, {3450,0.00058559}, {3500,0.00095495}, {3550,0.00068468}, {3600,0.00099099}, {3650,0.00078378}, {3700,0.00074775}, {3750,0.00079279}, {3800,0.00081982}, {3850,0.00089189}, {3900,0.00089189}, {3950,0.00098198}, {4000,0.00100000}, {4050,0.00099099}, {4100,0.00100000}, {4150,0.00100000}, {4200,0.00100000}, {4250,0.00100000}, {4300,0.00100000}, {4350,0.00100000}, {4400,0.00100000}, {4450,0.00109009}, {4500,0.00100000}, {4550,0.00100000}, {4600,0.00100000}, {4650,0.00100000}, {4700,0.00100000}, {4750,0.00100000}, {4800,0.00100000}, {4850,0.00100000}, {4900,0.00100000}, {4950,0.00100901}, {5000,0.00100000}, {5050,0.00100000}, {5100,0.00100000}, {5150,0.00100000}, {5200,0.00100000}, {5250,0.00100000}, {5300,0.00100901}, {5350,0.00100000}, {5400,0.00100000}, {5450,0.00100901}, {5500,0.00100901}, {5550,0.00100000}, {5600,0.00100901}, {5650,0.00104505}, {5700,0.00101802}, {5750,0.00103604}, {5800,0.00101802}, {5850,0.00101802}, {5900,0.00101802}, {5950,0.00104505}, {6000,0.00108108}, {6050,0.00100}, {6100,0.00100}, {6150,0.00100}, {6200,0.00100}, {6250,0.00100}, {6300,0.00100}, {6350,0.00125}, {6400,0.00100}, {6450,0.00100}, {6500,0.00100}, {6550,0.00100}, {6600,0.00125}, {6650,0.00150}, {6700,0.00125}, {6750,0.00125}, {6800,0.00150}, {6850,0.00150}, {6900,0.00150}, {6950,0.00150}, {7000,0.00150}, {7050,0.00150}, {7100,0.00150}, {7150,0.00175}, {7200,0.00175}, {7250,0.00200}, {7300,0.00175}, {7350,0.00175}, {7400,0.00175}, {7450,0.00175}, {7500,0.00175}, {7550,0.00200}, {7600,0.00525}, {7650,0.00200}, {7700,0.00200}, {7750,0.00200}, {7800,0.00200}, {7850,0.00200}, {7900,0.00175}, {7950,0.00200}, {8000,0.00200}, {8050,0.00200}, {8100,0.00200}, {8150,0.00200}, {8200,0.00200}, {8250,0.00200}, {8300,0.00200}, {8350,0.00200}, {8400,0.00200}, {8450,0.00200}, {8500,0.00200}, {8550,0.00200}, {8600,0.00200}, {8650,0.00200}, {8700,0.00200}, {8750,0.00200}, {8800,0.00200}, {8850,0.00200}, {8900,0.00275}, {8950,0.00225}, {9000,0.00225}, {9050,0.00225}, {9100,0.00200}, {9150,0.00200}, {9200,0.00200}, {9250,0.00200}, {9300,0.00200}, {9350,0.00225}, {9400,0.00225}, {9450,0.00250}, {9500,0.00200}, {9550,0.00225}, {9600,0.00200}, {9650,0.00200}, {9700,0.00250}, {9750,0.00250}, {9800,0.00300}, {9850,0.00300}, {9900,0.00275}, {9950,0.00300}, {10000,0.00300}, {10100,0.00300}, {10200,0.00300}, {10300,0.00300}, {10400,0.00300}, {10500,0.00325}, {10600,0.00300}, {10700,0.00300}, {10800,0.00300}, {10900,0.00300}, {11000,0.00300}, {11100,0.00300}, {11200,0.00300}, {11300,0.00300}, {11400,0.00300}, {11500,0.00300}, {11600,0.00350}, {11700,0.00325}, {11800,0.00350}, {11900,0.00375}, {12000,0.00325}, {12100,0.00350}, {12200,0.00300}, {12300,0.00325}, {12400,0.00375}, {12500,0.00400}, {12600,0.00350}, {12700,0.00350}, {12800,0.00375}, {12900,0.00400}, {13000,0.00400}, {13100,0.00400}, {13200,0.00400}, {13300,0.00400}, {13400,0.00400}, {13500,0.00400}, {13600,0.00400}, {13700,0.00400}, {13800,0.00400}, {13900,0.00400}, {14000,0.00400}, {14100,0.00450}, {14200,0.00400}, {14300,0.00425}, {14400,0.00425}, {14500,0.00450}, {14600,0.00425}, {14700,0.00425}, {14800,0.00475}, {14900,0.00425}, {15000,0.00450}, {15100,0.00475}, {15200,0.01050}, {15300,0.00450}, {15400,0.00475}, {15500,0.00500}, {15600,0.00475}, {15700,0.00500}, {15800,0.00525}, {15900,0.00475}, {16000,0.00500}, {16100,0.00500}, {16200,0.00500}, {16300,0.00500}, {16400,0.00500}, {16500,0.00525}, {16600,0.00500}, {16700,0.00575}, {16800,0.00600}, {16900,0.00600}, {17000,0.00525}, {17100,0.01900}, {17200,0.00500}, {17300,0.00550}, {17400,0.00550}, {17500,0.00525}, {17600,0.00600}, {17700,0.00525}, {17800,0.00575}, {17900,0.00575}, {18000,0.00550}, {18100,0.00575}, {18200,0.00575}, {18300,0.00600}, {18400,0.00600}, {18500,0.00600}, {18600,0.00600}, {18700,0.00600}, {18800,0.00600}, {18900,0.00600}, {19000,0.00600}, {19100,0.00600}, {19200,0.00700}, {19300,0.00600}, {19400,0.00600}, {19500,0.00600}, {19600,0.00600}, {19700,0.00700}, {19800,0.00600}, {19900,0.00600}, {20000,0.0205}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["intros _"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00002703}, {5,0.00000000}, {6,0.00003604}, {7,0.00002703}, {8,0.00000000}, {9,0.00000000}, {10,0.00002703}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00002703}, {15,0.00002703}, {16,0.00002703}, {17,0.00003604}, {18,0.00006306}, {19,0.00002703}, {20,0.00003604}, {21,0.00002703}, {22,0.00008108}, {23,0.00000000}, {24,0.00008108}, {25,0.00006306}, {26,0.00007207}, {27,0.00009910}, {28,0.00000000}, {29,0.00000000}, {30,0.00003604}, {31,0.00013514}, {32,0.00006306}, {33,0.00002703}, {34,0.00002703}, {35,0.00003604}, {36,0.00002703}, {37,0.00005405}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003604}, {42,0.00006306}, {43,0.00005405}, {44,0.00005405}, {45,0.00006306}, {46,0.00011712}, {47,0.00003604}, {48,0.00005405}, {49,0.00007207}, {50,0.00003604}, {51,0.00003604}, {52,0.00002703}, {53,0.00009009}, {54,0.00000000}, {55,0.00005405}, {56,0.00007207}, {57,0.00002703}, {58,0.00000000}, {59,0.00000000}, {60,0.00008108}, {61,0.00000000}, {62,0.00006306}, {63,0.00003604}, {64,0.00005405}, {65,0.00002703}, {66,0.00000000}, {67,0.00003604}, {68,0.00006306}, {69,0.00000000}, {70,0.00007207}, {71,0.00006306}, {72,0.00006306}, {73,0.00000000}, {74,0.00000000}, {75,0.00011712}, {76,0.00000000}, {77,0.00003604}, {78,0.00012613}, {79,0.00002703}, {80,0.00000000}, {81,0.00011712}, {82,0.00000000}, {83,0.00002703}, {84,0.00003604}, {85,0.00010811}, {86,0.00012613}, {87,0.00007207}, {88,0.00009910}, {89,0.00007207}, {90,0.00010811}, {91,0.00005405}, {92,0.00006306}, {93,0.00002703}, {94,0.00000000}, {95,0.00002703}, {96,0.00005405}, {97,0.00006306}, {98,0.00005405}, {99,0.00005405}, {100,0.00002703}, {101,0.00009009}, {102,0.00002703}, {103,0.00009009}, {104,0.00008108}, {105,0.00006306}, {106,0.00006306}, {107,0.00000000}, {108,0.00009910}, {109,0.00014414}, {110,0.00007207}, {111,0.00007207}, {112,0.00009910}, {113,0.00002703}, {114,0.00002703}, {115,0.00012613}, {116,0.00006306}, {117,0.00002703}, {118,0.00003604}, {119,0.00005405}, {120,0.00000000}, {121,0.00003604}, {122,0.00011712}, {123,0.00007207}, {124,0.00000000}, {125,0.00007207}, {126,0.00006306}, {127,0.00012613}, {128,0.00009910}, {129,0.00009910}, {130,0.00006306}, {131,0.00003604}, {132,0.00009910}, {133,0.00003604}, {134,0.00011712}, {135,0.00015315}, {136,0.00012613}, {137,0.00012613}, {138,0.00012613}, {139,0.00003604}, {140,0.00006306}, {141,0.00014414}, {142,0.00008108}, {143,0.00000000}, {144,0.00010811}, {145,0.00007207}, {146,0.00003604}, {147,0.00003604}, {148,0.00006306}, {149,0.00003604}, {150,0.00003604}, {151,0.00009009}, {152,0.00006306}, {153,0.00006306}, {154,0.00006306}, {155,0.00006306}, {156,0.00023423}, {157,0.00005405}, {158,0.00010811}, {159,0.00007207}, {160,0.00005405}, {161,0.00007207}, {162,0.00002703}, {163,0.00005405}, {164,0.00014414}, {165,0.00017117}, {166,0.00000000}, {167,0.00017117}, {168,0.00011712}, {169,0.00007207}, {170,0.00000000}, {171,0.00009009}, {172,0.00000000}, {173,0.00011712}, {174,0.00000000}, {175,0.00000000}, {176,0.00006306}, {177,0.00008108}, {178,0.00002703}, {179,0.00005405}, {180,0.00005405}, {181,0.00013514}, {182,0.00008108}, {183,0.00002703}, {184,0.00013514}, {185,0.00016216}, {186,0.00005405}, {187,0.00002703}, {188,0.00009009}, {189,0.00006306}, {190,0.00005405}, {191,0.00006306}, {192,0.00002703}, {193,0.00011712}, {194,0.00010811}, {195,0.00018919}, {196,0.00000000}, {197,0.00000000}, {198,0.00010811}, {199,0.00002703}, {200,0.00009009}, {201,0.00002703}, {202,0.00013514}, {203,0.00014414}, {204,0.00000000}, {205,0.00002703}, {206,0.00005405}, {207,0.00002703}, {208,0.00003604}, {209,0.00012613}, {210,0.00013514}, {211,0.00006306}, {212,0.00015315}, {213,0.00009910}, {214,0.00007207}, {215,0.00002703}, {216,0.00003604}, {217,0.00002703}, {218,0.00002703}, {219,0.00006306}, {220,0.00002703}, {221,0.00005405}, {222,0.00005405}, {223,0.00014414}, {224,0.00005405}, {225,0.00000000}, {226,0.00012613}, {227,0.00005405}, {228,0.00013514}, {229,0.00010811}, {230,0.00014414}, {231,0.00013514}, {232,0.00006306}, {233,0.00000000}, {234,0.00011712}, {235,0.00013514}, {236,0.00011712}, {237,0.00006306}, {238,0.00000000}, {239,0.00008108}, {240,0.00005405}, {241,0.00013514}, {242,0.00005405}, {243,0.00024324}, {244,0.00014414}, {245,0.00012613}, {246,0.00016216}, {247,0.00000000}, {248,0.00000000}, {249,0.00017117}, {250,0.00005405}, {251,0.00009009}, {252,0.00011712}, {253,0.00009009}, {254,0.00015315}, {255,0.00006306}, {256,0.00011712}, {257,0.00009910}, {258,0.00003604}, {259,0.00014414}, {260,0.00006306}, {261,0.00000000}, {262,0.00017117}, {263,0.00014414}, {264,0.00014414}, {265,0.00013514}, {266,0.00008108}, {267,0.00012613}, {268,0.00013514}, {269,0.00005405}, {270,0.00012613}, {271,0.00015315}, {272,0.00002703}, {273,0.00017117}, {274,0.00005405}, {275,0.00014414}, {276,0.00009009}, {277,0.00011712}, {278,0.00002703}, {279,0.00003604}, {280,0.00011712}, {281,0.00005405}, {282,0.00011712}, {283,0.00011712}, {284,0.00005405}, {285,0.00009910}, {286,0.00006306}, {287,0.00009009}, {288,0.00015315}, {289,0.00011712}, {290,0.00018919}, {291,0.00010811}, {292,0.00009910}, {293,0.00009009}, {294,0.00017117}, {295,0.00011712}, {296,0.00005405}, {297,0.00018919}, {298,0.00009009}, {299,0.00008108}, {300,0.00012613}, {301,0.00009009}, {302,0.00009009}, {303,0.00011712}, {304,0.00012613}, {305,0.00014414}, {306,0.00014414}, {307,0.00009009}, {308,0.00018018}, {309,0.00009009}, {310,0.00008108}, {311,0.00029730}, {312,0.00003604}, {313,0.00018919}, {314,0.00010811}, {315,0.00008108}, {316,0.00016216}, {317,0.00009910}, {318,0.00008108}, {319,0.00017117}, {320,0.00019820}, {321,0.00009009}, {322,0.00008108}, {323,0.00008108}, {324,0.00019820}, {325,0.00015315}, {326,0.00008108}, {327,0.00009910}, {328,0.00006306}, {329,0.00017117}, {330,0.00009910}, {331,0.00019820}, {332,0.00017117}, {333,0.00016216}, {334,0.00027027}, {335,0.00010811}, {336,0.00016216}, {337,0.00007207}, {338,0.00003604}, {339,0.00009009}, {340,0.00021622}, {341,0.00013514}, {342,0.00003604}, {343,0.00010811}, {344,0.00018919}, {345,0.00019820}, {346,0.00021622}, {347,0.00010811}, {348,0.00007207}, {349,0.00005405}, {350,0.00006306}, {351,0.00018018}, {352,0.00005405}, {353,0.00019820}, {354,0.00009009}, {355,0.00014414}, {356,0.00013514}, {357,0.00007207}, {358,0.00009910}, {359,0.00010811}, {360,0.00015315}, {361,0.00009009}, {362,0.00017117}, {363,0.00006306}, {364,0.00012613}, {365,0.00023423}, {366,0.00022523}, {367,0.00016216}, {368,0.00013514}, {369,0.00003604}, {370,0.00003604}, {371,0.00012613}, {372,0.00025225}, {373,0.00022523}, {374,0.00018018}, {375,0.00018018}, {376,0.00026126}, {377,0.00014414}, {378,0.00022523}, {379,0.00010811}, {380,0.00012613}, {381,0.00012613}, {382,0.00014414}, {383,0.00019820}, {384,0.00020721}, {385,0.00016216}, {386,0.00012613}, {387,0.00012613}, {388,0.00007207}, {389,0.00035135}, {390,0.00022523}, {391,0.00009910}, {392,0.00010811}, {393,0.00016216}, {394,0.00022523}, {395,0.00012613}, {396,0.00016216}, {397,0.00026126}, {398,0.00006306}, {399,0.00009910}, {400,0.00007207}, {401,0.00009009}, {402,0.00018919}, {403,0.00002703}, {404,0.00007207}, {405,0.00018919}, {406,0.00007207}, {407,0.00022523}, {408,0.00013514}, {409,0.00012613}, {410,0.00025225}, {411,0.00028829}, {412,0.00018919}, {413,0.00012613}, {414,0.00010811}, {415,0.00006306}, {416,0.00011712}, {417,0.00002703}, {418,0.00009910}, {419,0.00010811}, {420,0.00008108}, {421,0.00012613}, {422,0.00017117}, {423,0.00016216}, {424,0.00009910}, {425,0.00023423}, {426,0.00012613}, {427,0.00024324}, {428,0.00028829}, {429,0.00032432}, {430,0.00009009}, {431,0.00017117}, {432,0.00011712}, {433,0.00019820}, {434,0.00021622}, {435,0.00011712}, {436,0.00009910}, {437,0.00029730}, {438,0.00036937}, {439,0.00030631}, {440,0.00029730}, {441,0.00020721}, {442,0.00006306}, {443,0.00021622}, {444,0.00015315}, {445,0.00012613}, {446,0.00006306}, {447,0.00019820}, {448,0.00014414}, {449,0.00006306}, {450,0.00027027}, {451,0.00014414}, {452,0.00014414}, {453,0.00023423}, {454,0.00012613}, {455,0.00003604}, {456,0.00024324}, {457,0.00015315}, {458,0.00035135}, {459,0.00042342}, {460,0.00009009}, {461,0.00018919}, {462,0.00007207}, {463,0.00017117}, {464,0.00021622}, {465,0.00017117}, {466,0.00019820}, {467,0.00006306}, {468,0.00017117}, {469,0.00015315}, {470,0.00009910}, {471,0.00020721}, {472,0.00009910}, {473,0.00023423}, {474,0.00017117}, {475,0.00019820}, {476,0.00022523}, {477,0.00009009}, {478,0.00008108}, {479,0.00003604}, {480,0.00022523}, {481,0.00019820}, {482,0.00015315}, {483,0.00016216}, {484,0.00030631}, {485,0.00009009}, {486,0.00003604}, {487,0.00017117}, {488,0.00009009}, {489,0.00012613}, {490,0.00016216}, {491,0.00009009}, {492,0.00019820}, {493,0.00022523}, {494,0.00018919}, {495,0.00011712}, {496,0.00021622}, {497,0.00016216}, {498,0.00016216}, {499,0.00018919}, {500,0.00023423}, {505,0.00010811}, {510,0.00010811}, {515,0.00011712}, {520,0.00009009}, {525,0.00021622}, {530,0.00025225}, {535,0.00024324}, {540,0.00006306}, {545,0.00021622}, {550,0.00020721}, {555,0.00018919}, {560,0.00028829}, {565,0.00024324}, {570,0.00023423}, {575,0.00009910}, {580,0.00036036}, {585,0.00016216}, {590,0.00018018}, {595,0.00030631}, {600,0.00037838}, {605,0.00027027}, {610,0.00018919}, {615,0.00024324}, {620,0.00022523}, {625,0.00030631}, {630,0.00033333}, {635,0.00043243}, {640,0.00016216}, {645,0.00009009}, {650,0.00009910}, {655,0.00017117}, {660,0.00022523}, {665,0.00011712}, {670,0.00029730}, {675,0.00014414}, {680,0.00020721}, {685,0.00011712}, {690,0.00029730}, {695,0.00026126}, {700,0.00020721}, {705,0.00015315}, {710,0.00031532}, {715,0.00044144}, {720,0.00026126}, {725,0.00028829}, {730,0.00023423}, {735,0.00016216}, {740,0.00026126}, {745,0.00018018}, {750,0.00036036}, {755,0.00024324}, {760,0.00019820}, {765,0.00011712}, {770,0.00034234}, {775,0.00016216}, {780,0.00027027}, {785,0.00027027}, {790,0.00038739}, {795,0.00020721}, {800,0.00045045}, {805,0.00021622}, {810,0.00027928}, {815,0.00009009}, {820,0.00049550}, {825,0.00031532}, {830,0.00028829}, {835,0.00024324}, {840,0.00039640}, {845,0.00025225}, {850,0.00047748}, {855,0.00011712}, {860,0.00026126}, {865,0.00034234}, {870,0.00011712}, {875,0.00037838}, {880,0.00021622}, {885,0.00018919}, {890,0.00038739}, {895,0.00013514}, {900,0.00045045}, {905,0.00065766}, {910,0.00025225}, {915,0.00014414}, {920,0.00050450}, {925,0.00032432}, {930,0.00017117}, {935,0.00037838}, {940,0.00036937}, {945,0.00033333}, {950,0.00017117}, {955,0.00032432}, {960,0.00024324}, {965,0.00017117}, {970,0.00035135}, {975,0.00017117}, {980,0.00054955}, {985,0.00047748}, {990,0.00020721}, {995,0.00031532}, {1000,0.00023423}, {1010,0.00019820}, {1020,0.00036036}, {1030,0.00050450}, {1040,0.00045045}, {1050,0.00014414}, {1060,0.00036036}, {1070,0.00038739}, {1080,0.00027928}, {1090,0.00035135}, {1100,0.00029730}, {1110,0.00054955}, {1120,0.00028829}, {1130,0.00015315}, {1140,0.00030631}, {1150,0.00036036}, {1160,0.00021622}, {1170,0.00033333}, {1180,0.00032432}, {1190,0.00027928}, {1200,0.00036937}, {1210,0.00046847}, {1220,0.00036036}, {1230,0.00039640}, {1240,0.00038739}, {1250,0.00041441}, {1260,0.00008108}, {1270,0.00044144}, {1280,0.00017117}, {1290,0.00031532}, {1300,0.00046847}, {1310,0.00043243}, {1320,0.00044144}, {1330,0.00030631}, {1340,0.00031532}, {1350,0.00052252}, {1360,0.00045946}, {1370,0.00321622}, {1380,0.00032432}, {1390,0.00039640}, {1400,0.00045045}, {1410,0.00021622}, {1420,0.00039640}, {1430,0.00057658}, {1440,0.00035135}, {1450,0.00031532}, {1460,0.00034234}, {1470,0.00032432}, {1480,0.00054955}, {1490,0.00044144}, {1500,0.00051351}, {1510,0.00045045}, {1520,0.00045946}, {1530,0.00045045}, {1540,0.00036937}, {1550,0.00047748}, {1560,0.00045045}, {1570,0.00038739}, {1580,0.00044144}, {1590,0.00043243}, {1600,0.00040541}, {1610,0.00079279}, {1620,0.00048649}, {1630,0.00056757}, {1640,0.00048649}, {1650,0.00072973}, {1660,0.00033333}, {1670,0.00054054}, {1680,0.00061261}, {1690,0.00026126}, {1700,0.00044144}, {1710,0.00043243}, {1720,0.00035135}, {1730,0.00054054}, {1740,0.00050450}, {1750,0.00040541}, {1760,0.00048649}, {1770,0.00048649}, {1780,0.00058559}, {1790,0.00054955}, {1800,0.00050450}, {1810,0.00033333}, {1820,0.00069369}, {1830,0.00057658}, {1840,0.00059459}, {1850,0.00048649}, {1860,0.00045946}, {1870,0.00061261}, {1880,0.00058559}, {1890,0.00063063}, {1900,0.00042342}, {1910,0.00065766}, {1920,0.00025225}, {1930,0.00036937}, {1940,0.00059459}, {1950,0.00063964}, {1960,0.00063063}, {1970,0.00055856}, {1980,0.00067568}, {1990,0.00077477}, {2000,0.00049550}, {2050,0.00074775}, {2100,0.00052252}, {2150,0.00062162}, {2200,0.00074775}, {2250,0.00065766}, {2300,0.00050450}, {2350,0.00098198}, {2400,0.00052252}, {2450,0.00062162}, {2500,0.00090991}, {2550,0.00087387}, {2600,0.00077477}, {2650,0.00080180}, {2700,0.00083784}, {2750,0.00081081}, {2800,0.00072973}, {2850,0.00067568}, {2900,0.00089189}, {2950,0.00072072}, {3000,0.00093694}, {3050,0.00086486}, {3100,0.00076577}, {3150,0.00091892}, {3200,0.00100901}, {3250,0.00095495}, {3300,0.00090991}, {3350,0.00090090}, {3400,0.00118018}, {3450,0.00085586}, {3500,0.00117117}, {3550,0.00074775}, {3600,0.00092793}, {3650,0.00109009}, {3700,0.00116216}, {3750,0.00098198}, {3800,0.00123423}, {3850,0.00113514}, {3900,0.00101802}, {3950,0.00097297}, {4000,0.00117117}, {4050,0.00087387}, {4100,0.00099099}, {4150,0.00128829}, {4200,0.00136937}, {4250,0.00111712}, {4300,0.00131532}, {4350,0.00123423}, {4400,0.00110811}, {4450,0.00112613}, {4500,0.00118018}, {4550,0.00106306}, {4600,0.00095495}, {4650,0.00114414}, {4700,0.00144144}, {4750,0.00147748}, {4800,0.00109009}, {4850,0.00174775}, {4900,0.00124324}, {4950,0.00177477}, {5000,0.00201802}, {5050,0.00154955}, {5100,0.00118018}, {5150,0.00131532}, {5200,0.00150450}, {5250,0.00163063}, {5300,0.00176577}, {5350,0.00128829}, {5400,0.00140541}, {5450,0.00127027}, {5500,0.00144144}, {5550,0.00133333}, {5600,0.00144144}, {5650,0.00166667}, {5700,0.00123423}, {5750,0.00151351}, {5800,0.00125225}, {5850,0.00137838}, {5900,0.00139640}, {5950,0.00138739}, {6000,0.00151351}, {6050,0.00225}, {6100,0.00275}, {6150,0.00150}, {6200,0.00000}, {6250,0.00300}, {6300,0.00100}, {6350,0.00075}, {6400,0.00000}, {6450,0.00100}, {6500,0.00225}, {6550,0.00175}, {6600,0.00150}, {6650,0.00075}, {6700,0.00000}, {6750,0.00075}, {6800,0.00150}, {6850,0.00150}, {6900,0.00150}, {6950,0.00150}, {7000,0.00300}, {7050,0.00175}, {7100,0.00350}, {7150,0.00250}, {7200,0.00275}, {7250,0.00250}, {7300,0.00200}, {7350,0.00225}, {7400,0.00175}, {7450,0.00175}, {7500,0.00250}, {7550,0.00275}, {7600,0.00450}, {7650,0.00300}, {7700,0.00150}, {7750,0.00325}, {7800,0.00250}, {7850,0.00400}, {7900,0.00275}, {7950,0.00275}, {8000,0.00200}, {8050,0.00200}, {8100,0.00375}, {8150,0.00200}, {8200,0.00400}, {8250,0.00000}, {8300,0.00300}, {8350,0.00200}, {8400,0.00175}, {8450,0.00300}, {8500,0.00150}, {8550,0.00250}, {8600,0.00200}, {8650,0.00175}, {8700,0.00275}, {8750,0.00350}, {8800,0.00175}, {8850,0.00200}, {8900,0.00175}, {8950,0.00300}, {9000,0.00275}, {9050,0.00100}, {9100,0.00175}, {9150,0.00300}, {9200,0.00250}, {9250,0.00275}, {9300,0.00250}, {9350,0.00300}, {9400,0.00200}, {9450,0.00400}, {9500,0.00150}, {9550,0.00250}, {9600,0.00275}, {9650,0.00350}, {9700,0.00225}, {9750,0.00250}, {9800,0.00250}, {9850,0.00275}, {9900,0.00275}, {9950,0.00325}, {10000,0.00225}, {10100,0.00325}, {10200,0.00175}, {10300,0.00275}, {10400,0.00300}, {10500,0.00325}, {10600,0.00375}, {10700,0.00350}, {10800,0.00300}, {10900,0.00275}, {11000,0.00325}, {11100,0.00325}, {11200,0.00325}, {11300,0.00350}, {11400,0.00300}, {11500,0.00350}, {11600,0.00300}, {11700,0.00250}, {11800,0.00275}, {11900,0.00350}, {12000,0.00325}, {12100,0.00225}, {12200,0.00275}, {12300,0.00350}, {12400,0.00325}, {12500,0.00425}, {12600,0.00325}, {12700,0.00300}, {12800,0.00450}, {12900,0.00325}, {13000,0.00325}, {13100,0.00325}, {13200,0.00450}, {13300,0.00325}, {13400,0.00325}, {13500,0.00400}, {13600,0.00325}, {13700,0.00300}, {13800,0.00575}, {13900,0.00375}, {14000,0.00375}, {14100,0.00575}, {14200,0.00475}, {14300,0.00425}, {14400,0.00375}, {14500,0.00500}, {14600,0.00400}, {14700,0.00350}, {14800,0.00425}, {14900,0.00475}, {15000,0.00425}, {15100,0.00500}, {15200,0.01000}, {15300,0.00325}, {15400,0.00350}, {15500,0.00550}, {15600,0.00650}, {15700,0.00500}, {15800,0.00650}, {15900,0.00575}, {16000,0.00650}, {16100,0.00575}, {16200,0.00450}, {16300,0.00500}, {16400,0.00525}, {16500,0.00375}, {16600,0.00450}, {16700,0.00575}, {16800,0.00650}, {16900,0.00475}, {17000,0.00450}, {17100,0.01850}, {17200,0.00550}, {17300,0.00525}, {17400,0.00475}, {17500,0.00575}, {17600,0.00550}, {17700,0.00650}, {17800,0.00525}, {17900,0.00350}, {18000,0.00375}, {18100,0.00650}, {18200,0.00575}, {18300,0.00675}, {18400,0.00475}, {18500,0.00650}, {18600,0.00475}, {18700,0.00700}, {18800,0.00475}, {18900,0.00450}, {19000,0.00650}, {19100,0.00500}, {19200,0.00725}, {19300,0.00550}, {19400,0.00450}, {19500,0.00725}, {19600,0.00450}, {19700,0.00700}, {19800,0.00575}, {19900,0.00725}, {20000,0.0190}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["intros _"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00003604}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00003604}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00003604}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00003604}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00003604}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00002703}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00003604}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00003604}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00003604}, {395,0.00007207}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00003604}, {441,0.00003604}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00003604}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00003604}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00002703}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00003604}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00003604}, {590,0.00000000}, {595,0.00000000}, {600,0.00003604}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00003604}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00003604}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00003604}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00003604}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00002703}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00002703}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00003604}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00003604}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00002703}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003604}, {1290,0.00003604}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00003604}, {1360,0.00000000}, {1370,0.00007207}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00003604}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00003604}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00003604}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00003604}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00003604}, {1950,0.00000000}, {1960,0.00002703}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00003604}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00003604}, {2750,0.00003604}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00003604}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00003604}, {3500,0.00003604}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00007207}, {3750,0.00006306}, {3800,0.00003604}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00002703}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00003604}, {4500,0.00003604}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00002703}, {4750,0.00000000}, {4800,0.00003604}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00003604}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00007207}, {5200,0.00000000}, {5250,0.00003604}, {5300,0.00000000}, {5350,0.00007207}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00003604}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00007207}, {5950,0.00006306}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00100}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00100}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00196396}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00004505}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00008108}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00593694}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00007207}, {1340,0.00000000}, {1350,0.00554054}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00482883}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00544144}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000901}, {2300,0.00012613}, {2350,0.00006306}, {2400,0.00015315}, {2450,0.00044144}, {2500,0.00072973}, {2550,0.00078378}, {2600,0.00090991}, {2650,0.00099099}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00100000}, {3150,0.00100000}, {3200,0.00100000}, {3250,0.00100000}, {3300,0.00100000}, {3350,0.00100000}, {3400,0.00100000}, {3450,0.00100000}, {3500,0.00100000}, {3550,0.00100000}, {3600,0.00100000}, {3650,0.00100000}, {3700,0.00100000}, {3750,0.00100000}, {3800,0.00100000}, {3850,0.00100000}, {3900,0.00100000}, {3950,0.00100000}, {4000,0.00100000}, {4050,0.00100901}, {4100,0.00100000}, {4150,0.00100000}, {4200,0.00102703}, {4250,0.00102703}, {4300,0.00107207}, {4350,0.00109009}, {4400,0.00110811}, {4450,0.00121622}, {4500,0.00130631}, {4550,0.00142342}, {4600,0.00141441}, {4650,0.00154955}, {4700,0.00157658}, {4750,0.00185586}, {4800,0.00179279}, {4850,0.00180180}, {4900,0.00181982}, {4950,0.00195495}, {5000,0.01087387}, {5050,0.00196396}, {5100,0.00197297}, {5150,0.00199099}, {5200,0.00200000}, {5250,0.00200000}, {5300,0.00735135}, {5350,0.00200000}, {5400,0.00200000}, {5450,0.00200000}, {5500,0.00200000}, {5550,0.00200000}, {5600,0.00200000}, {5650,0.00200000}, {5700,0.00200901}, {5750,0.00200000}, {5800,0.00200000}, {5850,0.00200000}, {5900,0.00200901}, {5950,0.00200901}, {6000,0.00201802}, {6050,0.00200}, {6100,0.00200}, {6150,0.00200}, {6200,0.00200}, {6250,0.00200}, {6300,0.00200}, {6350,0.00200}, {6400,0.00200}, {6450,0.00200}, {6500,0.00200}, {6550,0.00200}, {6600,0.00200}, {6650,0.01000}, {6700,0.00250}, {6750,0.00200}, {6800,0.00225}, {6850,0.00250}, {6900,0.00250}, {6950,0.00250}, {7000,0.00250}, {7050,0.00250}, {7100,0.00250}, {7150,0.00275}, {7200,0.00300}, {7250,0.01350}, {7300,0.00300}, {7350,0.00300}, {7400,0.00300}, {7450,0.00300}, {7500,0.00300}, {7550,0.00300}, {7600,0.00650}, {7650,0.00300}, {7700,0.00300}, {7750,0.00300}, {7800,0.00300}, {7850,0.00300}, {7900,0.00300}, {7950,0.00300}, {8000,0.00300}, {8050,0.00300}, {8100,0.00300}, {8150,0.00300}, {8200,0.00300}, {8250,0.00325}, {8300,0.00325}, {8350,0.01100}, {8400,0.00300}, {8450,0.00300}, {8500,0.00325}, {8550,0.00325}, {8600,0.01175}, {8650,0.00350}, {8700,0.00375}, {8750,0.00350}, {8800,0.00350}, {8850,0.00350}, {8900,0.00400}, {8950,0.00375}, {9000,0.00400}, {9050,0.00375}, {9100,0.00375}, {9150,0.00400}, {9200,0.00375}, {9250,0.00350}, {9300,0.00400}, {9350,0.00400}, {9400,0.00375}, {9450,0.00400}, {9500,0.00375}, {9550,0.00400}, {9600,0.00400}, {9650,0.00400}, {9700,0.01250}, {9750,0.01275}, {9800,0.00400}, {9850,0.00400}, {9900,0.00400}, {9950,0.00425}, {10000,0.00425}, {10100,0.01675}, {10200,0.00400}, {10300,0.00425}, {10400,0.00450}, {10500,0.00475}, {10600,0.00450}, {10700,0.00500}, {10800,0.00500}, {10900,0.00475}, {11000,0.00525}, {11100,0.00500}, {11200,0.00525}, {11300,0.00500}, {11400,0.00500}, {11500,0.00500}, {11600,0.01525}, {11700,0.00525}, {11800,0.00550}, {11900,0.00575}, {12000,0.00575}, {12100,0.00550}, {12200,0.00500}, {12300,0.00525}, {12400,0.00600}, {12500,0.00600}, {12600,0.00575}, {12700,0.00575}, {12800,0.00600}, {12900,0.00600}, {13000,0.00600}, {13100,0.00600}, {13200,0.02875}, {13300,0.00600}, {13400,0.00600}, {13500,0.00600}, {13600,0.00600}, {13700,0.00600}, {13800,0.01700}, {13900,0.00650}, {14000,0.00625}, {14100,0.00650}, {14200,0.00625}, {14300,0.00700}, {14400,0.00700}, {14500,0.00700}, {14600,0.00700}, {14700,0.00700}, {14800,0.00750}, {14900,0.00700}, {15000,0.00700}, {15100,0.02250}, {15200,0.00800}, {15300,0.00700}, {15400,0.00700}, {15500,0.00800}, {15600,0.00700}, {15700,0.00700}, {15800,0.00775}, {15900,0.00750}, {16000,0.00800}, {16100,0.00775}, {16200,0.02650}, {16300,0.00800}, {16400,0.00800}, {16500,0.00800}, {16600,0.00800}, {16700,0.00875}, {16800,0.00900}, {16900,0.00900}, {17000,0.00850}, {17100,0.00800}, {17200,0.00800}, {17300,0.00875}, {17400,0.00850}, {17500,0.00800}, {17600,0.00900}, {17700,0.00800}, {17800,0.00875}, {17900,0.00850}, {18000,0.00850}, {18100,0.00875}, {18200,0.00900}, {18300,0.00900}, {18400,0.00900}, {18500,0.00900}, {18600,0.00900}, {18700,0.00975}, {18800,0.00900}, {18900,0.00900}, {19000,0.00900}, {19100,0.00900}, {19200,0.01025}, {19300,0.00900}, {19400,0.00900}, {19500,0.00900}, {19600,0.04300}, {19700,0.01025}, {19800,0.00925}, {19900,0.00925}, {20000,0.0095}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00002703}, {6,0.00000000}, {7,0.00003604}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00002703}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00005405}, {18,0.00000000}, {19,0.00003604}, {20,0.00003604}, {21,0.00000000}, {22,0.00003604}, {23,0.00000000}, {24,0.00003604}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00002703}, {30,0.00003604}, {31,0.00000000}, {32,0.00002703}, {33,0.00003604}, {34,0.00002703}, {35,0.00000000}, {36,0.00003604}, {37,0.00000000}, {38,0.00006306}, {39,0.00000000}, {40,0.00003604}, {41,0.00012613}, {42,0.00005405}, {43,0.00003604}, {44,0.00006306}, {45,0.00003604}, {46,0.00009009}, {47,0.00003604}, {48,0.00002703}, {49,0.00002703}, {50,0.00000000}, {51,0.00007207}, {52,0.00006306}, {53,0.00002703}, {54,0.00006306}, {55,0.00000000}, {56,0.00002703}, {57,0.00003604}, {58,0.00003604}, {59,0.00000000}, {60,0.00006306}, {61,0.00000000}, {62,0.00002703}, {63,0.00002703}, {64,0.00000000}, {65,0.00012613}, {66,0.00000000}, {67,0.00002703}, {68,0.00002703}, {69,0.00000000}, {70,0.00003604}, {71,0.00000000}, {72,0.00003604}, {73,0.00009009}, {74,0.00007207}, {75,0.00000000}, {76,0.00006306}, {77,0.00007207}, {78,0.00003604}, {79,0.00010811}, {80,0.00002703}, {81,0.00007207}, {82,0.00003604}, {83,0.00003604}, {84,0.00006306}, {85,0.00002703}, {86,0.00003604}, {87,0.00006306}, {88,0.00006306}, {89,0.00002703}, {90,0.00000000}, {91,0.00003604}, {92,0.00003604}, {93,0.00002703}, {94,0.00006306}, {95,0.00000000}, {96,0.00007207}, {97,0.00003604}, {98,0.00003604}, {99,0.00000000}, {100,0.00000000}, {101,0.00002703}, {102,0.00002703}, {103,0.00003604}, {104,0.00006306}, {105,0.00005405}, {106,0.00003604}, {107,0.00000000}, {108,0.00011712}, {109,0.00009910}, {110,0.00006306}, {111,0.00000000}, {112,0.00005405}, {113,0.00006306}, {114,0.00009009}, {115,0.00014414}, {116,0.00012613}, {117,0.00015315}, {118,0.00006306}, {119,0.00005405}, {120,0.00006306}, {121,0.00002703}, {122,0.00007207}, {123,0.00017117}, {124,0.00002703}, {125,0.00002703}, {126,0.00016216}, {127,0.00006306}, {128,0.00006306}, {129,0.00000000}, {130,0.00013514}, {131,0.00009009}, {132,0.00006306}, {133,0.00009009}, {134,0.00009910}, {135,0.00006306}, {136,0.00007207}, {137,0.00002703}, {138,0.00002703}, {139,0.00006306}, {140,0.00002703}, {141,0.00000000}, {142,0.00006306}, {143,0.00010811}, {144,0.00002703}, {145,0.00002703}, {146,0.00003604}, {147,0.00014414}, {148,0.00000000}, {149,0.00009910}, {150,0.00000000}, {151,0.00009910}, {152,0.00008108}, {153,0.00008108}, {154,0.00005405}, {155,0.00003604}, {156,0.00005405}, {157,0.00006306}, {158,0.00000000}, {159,0.00005405}, {160,0.00006306}, {161,0.00008108}, {162,0.00005405}, {163,0.00014414}, {164,0.00002703}, {165,0.00008108}, {166,0.00009009}, {167,0.00009910}, {168,0.00003604}, {169,0.00007207}, {170,0.00009910}, {171,0.00005405}, {172,0.00006306}, {173,0.00009009}, {174,0.00005405}, {175,0.00012613}, {176,0.00000000}, {177,0.00005405}, {178,0.00005405}, {179,0.00002703}, {180,0.00012613}, {181,0.00003604}, {182,0.00007207}, {183,0.00000000}, {184,0.00003604}, {185,0.00009009}, {186,0.00011712}, {187,0.00009009}, {188,0.00012613}, {189,0.00002703}, {190,0.00003604}, {191,0.00011712}, {192,0.00012613}, {193,0.00014414}, {194,0.00009009}, {195,0.00002703}, {196,0.00009009}, {197,0.00011712}, {198,0.00002703}, {199,0.00008108}, {200,0.00010811}, {201,0.00012613}, {202,0.00005405}, {203,0.00008108}, {204,0.00016216}, {205,0.00000000}, {206,0.00009009}, {207,0.00002703}, {208,0.00009009}, {209,0.00000000}, {210,0.00009910}, {211,0.00010811}, {212,0.00013514}, {213,0.00002703}, {214,0.00005405}, {215,0.00018919}, {216,0.00016216}, {217,0.00000000}, {218,0.00010811}, {219,0.00006306}, {220,0.00011712}, {221,0.00006306}, {222,0.00005405}, {223,0.00013514}, {224,0.00015315}, {225,0.00005405}, {226,0.00018018}, {227,0.00002703}, {228,0.00002703}, {229,0.00023423}, {230,0.00000000}, {231,0.00009009}, {232,0.00015315}, {233,0.00008108}, {234,0.00005405}, {235,0.00018018}, {236,0.00008108}, {237,0.00009009}, {238,0.00013514}, {239,0.00013514}, {240,0.00012613}, {241,0.00006306}, {242,0.00003604}, {243,0.00005405}, {244,0.00005405}, {245,0.00014414}, {246,0.00011712}, {247,0.00018919}, {248,0.00009009}, {249,0.00015315}, {250,0.00013514}, {251,0.00020721}, {252,0.00019820}, {253,0.00020721}, {254,0.00008108}, {255,0.00006306}, {256,0.00007207}, {257,0.00015315}, {258,0.00006306}, {259,0.00005405}, {260,0.00002703}, {261,0.00002703}, {262,0.00008108}, {263,0.00005405}, {264,0.00008108}, {265,0.00009009}, {266,0.00008108}, {267,0.00008108}, {268,0.00017117}, {269,0.00002703}, {270,0.00012613}, {271,0.00012613}, {272,0.00015315}, {273,0.00009009}, {274,0.00005405}, {275,0.00015315}, {276,0.00008108}, {277,0.00011712}, {278,0.00005405}, {279,0.00015315}, {280,0.00005405}, {281,0.00013514}, {282,0.00018018}, {283,0.00011712}, {284,0.00018018}, {285,0.00011712}, {286,0.00009910}, {287,0.00005405}, {288,0.00006306}, {289,0.00011712}, {290,0.00019820}, {291,0.00011712}, {292,0.00008108}, {293,0.00008108}, {294,0.00037838}, {295,0.00002703}, {296,0.00009009}, {297,0.00015315}, {298,0.00011712}, {299,0.00010811}, {300,0.00019820}, {301,0.00009009}, {302,0.00003604}, {303,0.00012613}, {304,0.00008108}, {305,0.00021622}, {306,0.00022523}, {307,0.00008108}, {308,0.00018919}, {309,0.00003604}, {310,0.00010811}, {311,0.00015315}, {312,0.00020721}, {313,0.00008108}, {314,0.00018018}, {315,0.00012613}, {316,0.00011712}, {317,0.00010811}, {318,0.00022523}, {319,0.00019820}, {320,0.00018018}, {321,0.00010811}, {322,0.00003604}, {323,0.00009009}, {324,0.00009009}, {325,0.00006306}, {326,0.00010811}, {327,0.00006306}, {328,0.00009009}, {329,0.00024324}, {330,0.00006306}, {331,0.00006306}, {332,0.00002703}, {333,0.00010811}, {334,0.00016216}, {335,0.00009910}, {336,0.00017117}, {337,0.00014414}, {338,0.00017117}, {339,0.00013514}, {340,0.00007207}, {341,0.00015315}, {342,0.00009910}, {343,0.00024324}, {344,0.00009910}, {345,0.00025225}, {346,0.00018018}, {347,0.00009910}, {348,0.00017117}, {349,0.00019820}, {350,0.00017117}, {351,0.00003604}, {352,0.00009009}, {353,0.00026126}, {354,0.00019820}, {355,0.00012613}, {356,0.00022523}, {357,0.00010811}, {358,0.00023423}, {359,0.00012613}, {360,0.00012613}, {361,0.00016216}, {362,0.00009009}, {363,0.00006306}, {364,0.00011712}, {365,0.00021622}, {366,0.00016216}, {367,0.00021622}, {368,0.00218919}, {369,0.00012613}, {370,0.00017117}, {371,0.00027027}, {372,0.00036036}, {373,0.00013514}, {374,0.00015315}, {375,0.00027027}, {376,0.00020721}, {377,0.00006306}, {378,0.00006306}, {379,0.00025225}, {380,0.00010811}, {381,0.00003604}, {382,0.00014414}, {383,0.00018919}, {384,0.00012613}, {385,0.00019820}, {386,0.00026126}, {387,0.00007207}, {388,0.00023423}, {389,0.00013514}, {390,0.00018919}, {391,0.00027027}, {392,0.00015315}, {393,0.00010811}, {394,0.00012613}, {395,0.00020721}, {396,0.00009910}, {397,0.00008108}, {398,0.00019820}, {399,0.00009009}, {400,0.00011712}, {401,0.00020721}, {402,0.00013514}, {403,0.00020721}, {404,0.00019820}, {405,0.00018018}, {406,0.00021622}, {407,0.00024324}, {408,0.00023423}, {409,0.00012613}, {410,0.00036036}, {411,0.00027027}, {412,0.00007207}, {413,0.00025225}, {414,0.00029730}, {415,0.00007207}, {416,0.00016216}, {417,0.00016216}, {418,0.00006306}, {419,0.00012613}, {420,0.00012613}, {421,0.00027027}, {422,0.00015315}, {423,0.00013514}, {424,0.00026126}, {425,0.00021622}, {426,0.00014414}, {427,0.00006306}, {428,0.00020721}, {429,0.00013514}, {430,0.00019820}, {431,0.00010811}, {432,0.00008108}, {433,0.00026126}, {434,0.00014414}, {435,0.00009009}, {436,0.00019820}, {437,0.00009910}, {438,0.00015315}, {439,0.00014414}, {440,0.00017117}, {441,0.00014414}, {442,0.00021622}, {443,0.00013514}, {444,0.00032432}, {445,0.00021622}, {446,0.00019820}, {447,0.00016216}, {448,0.00023423}, {449,0.00017117}, {450,0.00018919}, {451,0.00014414}, {452,0.00009009}, {453,0.00012613}, {454,0.00025225}, {455,0.00020721}, {456,0.00017117}, {457,0.00012613}, {458,0.00009910}, {459,0.00018919}, {460,0.00011712}, {461,0.00025225}, {462,0.00021622}, {463,0.00016216}, {464,0.00019820}, {465,0.00024324}, {466,0.00027928}, {467,0.00028829}, {468,0.00013514}, {469,0.00013514}, {470,0.00018018}, {471,0.00034234}, {472,0.00020721}, {473,0.00022523}, {474,0.00012613}, {475,0.00017117}, {476,0.00007207}, {477,0.00009910}, {478,0.00024324}, {479,0.00023423}, {480,0.00033333}, {481,0.00030631}, {482,0.00005405}, {483,0.00020721}, {484,0.00032432}, {485,0.00027027}, {486,0.00027027}, {487,0.00002703}, {488,0.00010811}, {489,0.00030631}, {490,0.00017117}, {491,0.00000000}, {492,0.00020721}, {493,0.00023423}, {494,0.00019820}, {495,0.00020721}, {496,0.00036937}, {497,0.00020721}, {498,0.00025225}, {499,0.00029730}, {500,0.00035135}, {505,0.00028829}, {510,0.00009910}, {515,0.00020721}, {520,0.00033333}, {525,0.00009009}, {530,0.00017117}, {535,0.00021622}, {540,0.00035135}, {545,0.00027928}, {550,0.00027928}, {555,0.00006306}, {560,0.00031532}, {565,0.00009910}, {570,0.00015315}, {575,0.00017117}, {580,0.00013514}, {585,0.00036937}, {590,0.00031532}, {595,0.00009009}, {600,0.00015315}, {605,0.00036036}, {610,0.00036036}, {615,0.00025225}, {620,0.00005405}, {625,0.00029730}, {630,0.00021622}, {635,0.00040541}, {640,0.00034234}, {645,0.00024324}, {650,0.00016216}, {655,0.00044144}, {660,0.00043243}, {665,0.00008108}, {670,0.00034234}, {675,0.00047748}, {680,0.00020721}, {685,0.00041441}, {690,0.00007207}, {695,0.00033333}, {700,0.00016216}, {705,0.00019820}, {710,0.00029730}, {715,0.00033333}, {720,0.00026126}, {725,0.00032432}, {730,0.00034234}, {735,0.00036937}, {740,0.00020721}, {745,0.00021622}, {750,0.00017117}, {755,0.00026126}, {760,0.00030631}, {765,0.00015315}, {770,0.00039640}, {775,0.00028829}, {780,0.00042342}, {785,0.00045946}, {790,0.00032432}, {795,0.00050450}, {800,0.00024324}, {805,0.00034234}, {810,0.00027027}, {815,0.00018919}, {820,0.00033333}, {825,0.00022523}, {830,0.00032432}, {835,0.00038739}, {840,0.00022523}, {845,0.00043243}, {850,0.00044144}, {855,0.00042342}, {860,0.00036036}, {865,0.00027928}, {870,0.00036937}, {875,0.00034234}, {880,0.00042342}, {885,0.00026126}, {890,0.00034234}, {895,0.00017117}, {900,0.00033333}, {905,0.00033333}, {910,0.00032432}, {915,0.00036036}, {920,0.00022523}, {925,0.00031532}, {930,0.00023423}, {935,0.00039640}, {940,0.00012613}, {945,0.00027027}, {950,0.00041441}, {955,0.00046847}, {960,0.00042342}, {965,0.00037838}, {970,0.00041441}, {975,0.00039640}, {980,0.00035135}, {985,0.00028829}, {990,0.00036937}, {995,0.00054054}, {1000,0.00037838}, {1010,0.00038739}, {1020,0.00032432}, {1030,0.00029730}, {1040,0.00043243}, {1050,0.00030631}, {1060,0.00037838}, {1070,0.00056757}, {1080,0.00045946}, {1090,0.00037838}, {1100,0.00037838}, {1110,0.00020721}, {1120,0.00036036}, {1130,0.00038739}, {1140,0.00034234}, {1150,0.00056757}, {1160,0.00035135}, {1170,0.00031532}, {1180,0.00034234}, {1190,0.00033333}, {1200,0.00055856}, {1210,0.00609009}, {1220,0.00039640}, {1230,0.00037838}, {1240,0.00047748}, {1250,0.00009009}, {1260,0.00049550}, {1270,0.00028829}, {1280,0.00024324}, {1290,0.00046847}, {1300,0.00048649}, {1310,0.00055856}, {1320,0.00054054}, {1330,0.00044144}, {1340,0.00050450}, {1350,0.00532432}, {1360,0.00055856}, {1370,0.00063964}, {1380,0.00047748}, {1390,0.00072973}, {1400,0.00050450}, {1410,0.00060360}, {1420,0.00063964}, {1430,0.00038739}, {1440,0.00045946}, {1450,0.00052252}, {1460,0.00036937}, {1470,0.00059459}, {1480,0.00038739}, {1490,0.00063063}, {1500,0.00034234}, {1510,0.00033333}, {1520,0.00070270}, {1530,0.00054054}, {1540,0.00036036}, {1550,0.00050450}, {1560,0.00058559}, {1570,0.00045946}, {1580,0.00483784}, {1590,0.00054955}, {1600,0.00055856}, {1610,0.00052252}, {1620,0.00043243}, {1630,0.00065766}, {1640,0.00045045}, {1650,0.00046847}, {1660,0.00060360}, {1670,0.00042342}, {1680,0.00045946}, {1690,0.00053153}, {1700,0.00056757}, {1710,0.00070270}, {1720,0.00058559}, {1730,0.00056757}, {1740,0.00049550}, {1750,0.00051351}, {1760,0.00045045}, {1770,0.00049550}, {1780,0.00055856}, {1790,0.00070270}, {1800,0.00059459}, {1810,0.00060360}, {1820,0.00534234}, {1830,0.00060360}, {1840,0.00088288}, {1850,0.00072072}, {1860,0.00062162}, {1870,0.00077477}, {1880,0.00063964}, {1890,0.00072072}, {1900,0.00091892}, {1910,0.00063964}, {1920,0.00078378}, {1930,0.00100901}, {1940,0.00066667}, {1950,0.00072072}, {1960,0.00055856}, {1970,0.00065766}, {1980,0.00067568}, {1990,0.00074775}, {2000,0.00081982}, {2050,0.00072973}, {2100,0.00106306}, {2150,0.00086486}, {2200,0.00061261}, {2250,0.00072973}, {2300,0.00100901}, {2350,0.00046847}, {2400,0.00077477}, {2450,0.00090090}, {2500,0.00078378}, {2550,0.00101802}, {2600,0.00090090}, {2650,0.00072973}, {2700,0.00079279}, {2750,0.00107207}, {2800,0.00118919}, {2850,0.00101802}, {2900,0.00089189}, {2950,0.00108108}, {3000,0.00101802}, {3050,0.00089189}, {3100,0.00121622}, {3150,0.00128829}, {3200,0.00134234}, {3250,0.00105405}, {3300,0.00130631}, {3350,0.00116216}, {3400,0.00090991}, {3450,0.00115315}, {3500,0.00117117}, {3550,0.00172973}, {3600,0.00138739}, {3650,0.00141441}, {3700,0.00118018}, {3750,0.00128829}, {3800,0.00144144}, {3850,0.00137838}, {3900,0.00149550}, {3950,0.00160360}, {4000,0.00165766}, {4050,0.00154955}, {4100,0.00176577}, {4150,0.00150450}, {4200,0.00126126}, {4250,0.00149550}, {4300,0.00158559}, {4350,0.00172072}, {4400,0.00199099}, {4450,0.00196396}, {4500,0.00156757}, {4550,0.00183784}, {4600,0.00182883}, {4650,0.00191892}, {4700,0.00179279}, {4750,0.00218919}, {4800,0.00205405}, {4850,0.00160360}, {4900,0.00192793}, {4950,0.00175676}, {5000,0.01126126}, {5050,0.00184685}, {5100,0.00214414}, {5150,0.00193694}, {5200,0.00197297}, {5250,0.00181081}, {5300,0.00726126}, {5350,0.00227928}, {5400,0.00218919}, {5450,0.00231532}, {5500,0.00223423}, {5550,0.00228829}, {5600,0.00209910}, {5650,0.00196396}, {5700,0.00224324}, {5750,0.00222523}, {5800,0.00244144}, {5850,0.00232432}, {5900,0.00212613}, {5950,0.00226126}, {6000,0.00222523}, {6050,0.00175}, {6100,0.00075}, {6150,0.00075}, {6200,0.00300}, {6250,0.00075}, {6300,0.00275}, {6350,0.00250}, {6400,0.00325}, {6450,0.00275}, {6500,0.00000}, {6550,0.00150}, {6600,0.00275}, {6650,0.01200}, {6700,0.00375}, {6750,0.00225}, {6800,0.00250}, {6850,0.00350}, {6900,0.00350}, {6950,0.00250}, {7000,0.00150}, {7050,0.00250}, {7100,0.00250}, {7150,0.00150}, {7200,0.00150}, {7250,0.01175}, {7300,0.00300}, {7350,0.00250}, {7400,0.00325}, {7450,0.00325}, {7500,0.00250}, {7550,0.00325}, {7600,0.00675}, {7650,0.00150}, {7700,0.00225}, {7750,0.00275}, {7800,0.00300}, {7850,0.00350}, {7900,0.00275}, {7950,0.00350}, {8000,0.00375}, {8050,0.00325}, {8100,0.00250}, {8150,0.00350}, {8200,0.00350}, {8250,0.00375}, {8300,0.00450}, {8350,0.01300}, {8400,0.00375}, {8450,0.00350}, {8500,0.00400}, {8550,0.00375}, {8600,0.01175}, {8650,0.00350}, {8700,0.00250}, {8750,0.00375}, {8800,0.00350}, {8850,0.00375}, {8900,0.00450}, {8950,0.00350}, {9000,0.00425}, {9050,0.00450}, {9100,0.00375}, {9150,0.00325}, {9200,0.00350}, {9250,0.00400}, {9300,0.00375}, {9350,0.00400}, {9400,0.00450}, {9450,0.00375}, {9500,0.00350}, {9550,0.00500}, {9600,0.00325}, {9650,0.00300}, {9700,0.01275}, {9750,0.01375}, {9800,0.00350}, {9850,0.00425}, {9900,0.00300}, {9950,0.00475}, {10000,0.00400}, {10100,0.01850}, {10200,0.00550}, {10300,0.00525}, {10400,0.00450}, {10500,0.00450}, {10600,0.00425}, {10700,0.00550}, {10800,0.00450}, {10900,0.00550}, {11000,0.00550}, {11100,0.00325}, {11200,0.00675}, {11300,0.00425}, {11400,0.00450}, {11500,0.00525}, {11600,0.01500}, {11700,0.00675}, {11800,0.00625}, {11900,0.00550}, {12000,0.00575}, {12100,0.00450}, {12200,0.00525}, {12300,0.00450}, {12400,0.00550}, {12500,0.00575}, {12600,0.00775}, {12700,0.00675}, {12800,0.00325}, {12900,0.00525}, {13000,0.00550}, {13100,0.00650}, {13200,0.02725}, {13300,0.00775}, {13400,0.00775}, {13500,0.00700}, {13600,0.00675}, {13700,0.00700}, {13800,0.01625}, {13900,0.00725}, {14000,0.00500}, {14100,0.00625}, {14200,0.00625}, {14300,0.00750}, {14400,0.00725}, {14500,0.00700}, {14600,0.00750}, {14700,0.00750}, {14800,0.00750}, {14900,0.00725}, {15000,0.00750}, {15100,0.02275}, {15200,0.00775}, {15300,0.00775}, {15400,0.00750}, {15500,0.00750}, {15600,0.00650}, {15700,0.00800}, {15800,0.00625}, {15900,0.00725}, {16000,0.00725}, {16100,0.00725}, {16200,0.02675}, {16300,0.00750}, {16400,0.00750}, {16500,0.00600}, {16600,0.00725}, {16700,0.00825}, {16800,0.00850}, {16900,0.00950}, {17000,0.00750}, {17100,0.00750}, {17200,0.00850}, {17300,0.00825}, {17400,0.00950}, {17500,0.00700}, {17600,0.00875}, {17700,0.00850}, {17800,0.00950}, {17900,0.00850}, {18000,0.00975}, {18100,0.00850}, {18200,0.00850}, {18300,0.00850}, {18400,0.01075}, {18500,0.00750}, {18600,0.01075}, {18700,0.00950}, {18800,0.00975}, {18900,0.01100}, {19000,0.00825}, {19100,0.01075}, {19200,0.00975}, {19300,0.00950}, {19400,0.01075}, {19500,0.00850}, {19600,0.04350}, {19700,0.01075}, {19800,0.00950}, {19900,0.00875}, {20000,0.0095}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00003604}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00003604}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00003604}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00002703}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00003604}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00003604}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00003604}, {369,0.00003604}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00003604}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00003604}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00003604}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00003604}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00002703}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00003604}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00003604}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00007207}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00002703}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00003604}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00003604}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00003604}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00003604}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00003604}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00003604}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00003604}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00003604}, {855,0.00000000}, {860,0.00000000}, {865,0.00003604}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00003604}, {950,0.00000000}, {955,0.00000000}, {960,0.00003604}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00003604}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00002703}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00007207}, {1220,0.00000000}, {1230,0.00003604}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00003604}, {1310,0.00000000}, {1320,0.00003604}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00006306}, {1360,0.00003604}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00003604}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003604}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00003604}, {1550,0.00003604}, {1560,0.00003604}, {1570,0.00002703}, {1580,0.00010811}, {1590,0.00003604}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00003604}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003604}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00003604}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00003604}, {1860,0.00000000}, {1870,0.00003604}, {1880,0.00000000}, {1890,0.00003604}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00003604}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00007207}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00003604}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00002703}, {2750,0.00007207}, {2800,0.00003604}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00003604}, {3000,0.00000000}, {3050,0.00003604}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00003604}, {3650,0.00003604}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00007207}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00003604}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00003604}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00007207}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00003604}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00003604}, {5600,0.00000000}, {5650,0.00003604}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00003604}, {5900,0.00000000}, {5950,0.00003604}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00100}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00100}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00100}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00100}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00016216}, {11,0.00070270}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00100000}, {16,0.01509910}, {17,0.00119820}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00103604}, {23,0.00118919}, {24,0.00117117}, {25,0.00185586}, {26,0.00200000}, {27,0.00200000}, {28,0.00200000}, {29,0.00200000}, {30,0.00298198}, {31,0.00200000}, {32,0.00200000}, {33,0.00200000}, {34,0.00200000}, {35,0.00210811}, {36,0.00215315}, {37,0.00218919}, {38,0.00222523}, {39,0.00283784}, {40,0.00299099}, {41,0.00300000}, {42,0.00300000}, {43,0.00300000}, {44,0.00300000}, {45,0.00300000}, {46,0.00301802}, {47,0.00301802}, {48,0.00301802}, {49,0.00312613}, {50,0.00307207}, {51,0.00305405}, {52,0.00318919}, {53,0.00376577}, {54,0.00398198}, {55,0.00400000}, {56,0.00400000}, {57,0.00400000}, {58,0.00400000}, {59,0.00400901}, {60,0.00400000}, {61,0.00402703}, {62,0.00414414}, {63,0.00412613}, {64,0.00409910}, {65,0.00503604}, {66,0.00416216}, {67,0.00476577}, {68,0.00492793}, {69,0.00500000}, {70,0.00500000}, {71,0.00500000}, {72,0.00500901}, {73,0.00501802}, {74,0.00501802}, {75,0.00506306}, {76,0.00504505}, {77,0.00509009}, {78,0.00513514}, {79,0.00520721}, {80,0.00520721}, {81,0.00552252}, {82,0.00595495}, {83,0.00600000}, {84,0.00600901}, {85,0.00600901}, {86,0.00605405}, {87,0.00602703}, {88,0.00604505}, {89,0.00608108}, {90,0.00605405}, {91,0.00609009}, {92,0.00610811}, {93,0.00624324}, {94,0.00724324}, {95,0.00697297}, {96,0.00672072}, {97,0.00700000}, {98,0.00702703}, {99,0.00798198}, {100,0.00704505}, {101,0.00704505}, {102,0.00705405}, {103,0.00712613}, {104,0.00702703}, {105,0.00705405}, {106,0.00712613}, {107,0.00731532}, {108,0.00736937}, {109,0.00790090}, {110,0.00799099}, {111,0.00801802}, {112,0.00803604}, {113,0.00804505}, {114,0.00803604}, {115,0.00806306}, {116,0.00806306}, {117,0.00904505}, {118,0.00806306}, {119,0.00818018}, {120,0.00810811}, {121,0.00972973}, {122,0.00854955}, {123,0.00897297}, {124,0.00898198}, {125,0.00998198}, {126,0.00900901}, {127,0.00904505}, {128,0.00905405}, {129,0.01001802}, {130,0.00909009}, {131,0.00905405}, {132,0.00907207}, {133,0.00916216}, {134,0.00917117}, {135,0.00963063}, {136,0.00929730}, {137,0.00985586}, {138,0.00998198}, {139,0.01006306}, {140,0.01102703}, {141,0.01006306}, {142,0.01007207}, {143,0.01003604}, {144,0.01010811}, {145,0.01005405}, {146,0.01009910}, {147,0.01143243}, {148,0.01020721}, {149,0.01051351}, {150,0.01082883}, {151,0.01100000}, {152,0.01094595}, {153,0.01103604}, {154,0.01105405}, {155,0.01102703}, {156,0.01110811}, {157,0.01203604}, {158,0.01114414}, {159,0.01123423}, {160,0.01236937}, {161,0.01113514}, {162,0.01115315}, {163,0.01300901}, {164,0.01148649}, {165,0.01197297}, {166,0.01200901}, {167,0.01204505}, {168,0.01202703}, {169,0.01207207}, {170,0.01207207}, {171,0.01210811}, {172,0.01209009}, {173,0.01217117}, {174,0.01224324}, {175,0.01400000}, {176,0.01216216}, {177,0.01250450}, {178,0.01401802}, {179,0.01299099}, {180,0.01301802}, {181,0.01405405}, {182,0.01309910}, {183,0.01309910}, {184,0.01308108}, {185,0.01308108}, {186,0.01308108}, {187,0.01332432}, {188,0.01322523}, {189,0.01360360}, {190,0.01386486}, {191,0.01406306}, {192,0.01436036}, {193,0.01376577}, {194,0.01388288}, {195,0.01405405}, {196,0.01403604}, {197,0.01538739}, {198,0.01407207}, {199,0.01413514}, {200,0.01409009}, {201,0.01409910}, {202,0.01417117}, {203,0.01454955}, {204,0.01439640}, {205,0.01602703}, {206,0.01500000}, {207,0.01502703}, {208,0.01490991}, {209,0.01504505}, {210,0.01619820}, {211,0.01509910}, {212,0.01509009}, {213,0.01509910}, {214,0.01518018}, {215,0.01558559}, {216,0.01521622}, {217,0.01696396}, {218,0.01582883}, {219,0.01605405}, {220,0.01597297}, {221,0.01608108}, {222,0.01709910}, {223,0.01612613}, {224,0.01736036}, {225,0.01605405}, {226,0.01606306}, {227,0.01618018}, {228,0.01610811}, {229,0.01631532}, {230,0.01646847}, {231,0.01804505}, {232,0.01639640}, {233,0.01688288}, {234,0.01695495}, {235,0.01706306}, {236,0.01713514}, {237,0.01713514}, {238,0.01710811}, {239,0.01722523}, {240,0.01811712}, {241,0.01717117}, {242,0.01902703}, {243,0.01762162}, {244,0.01902703}, {245,0.01793694}, {246,0.01800000}, {247,0.01817117}, {248,0.01800000}, {249,0.01806306}, {250,0.01805405}, {251,0.01820721}, {252,0.01821622}, {253,0.01839640}, {254,0.01833333}, {255,0.01886486}, {256,0.01813514}, {257,0.01818018}, {258,0.01825225}, {259,0.01866667}, {260,0.01851351}, {261,0.01890090}, {262,0.01904505}, {263,0.01912613}, {264,0.01898198}, {265,0.01907207}, {266,0.01917117}, {267,0.01918919}, {268,0.01910811}, {269,0.01936937}, {270,0.01953153}, {271,0.01996396}, {272,0.01930631}, {273,0.01968468}, {274,0.01982883}, {275,0.02009009}, {276,0.02006306}, {277,0.02009910}, {278,0.02007207}, {279,0.02025225}, {280,0.02157658}, {281,0.02027928}, {282,0.02281982}, {283,0.02069369}, {284,0.02202703}, {285,0.02098198}, {286,0.02102703}, {287,0.02108108}, {288,0.02053153}, {289,0.02098198}, {290,0.02100901}, {291,0.02304505}, {292,0.02107207}, {293,0.02249550}, {294,0.02121622}, {295,0.02154955}, {296,0.02117117}, {297,0.02141441}, {298,0.02170270}, {299,0.02200000}, {300,0.02386486}, {301,0.02208108}, {302,0.02375676}, {303,0.02213514}, {304,0.02196396}, {305,0.02208108}, {306,0.02216216}, {307,0.02458559}, {308,0.02215315}, {309,0.02253153}, {310,0.02267568}, {311,0.02302703}, {312,0.02578378}, {313,0.02297297}, {314,0.02458559}, {315,0.02316216}, {316,0.02309009}, {317,0.02608108}, {318,0.02331532}, {319,0.02345045}, {320,0.02302703}, {321,0.02314414}, {322,0.02580180}, {323,0.02330631}, {324,0.02326126}, {325,0.02356757}, {326,0.02366667}, {327,0.02582883}, {328,0.02363964}, {329,0.02395495}, {330,0.02409910}, {331,0.02418919}, {332,0.02523423}, {333,0.02418018}, {334,0.02430631}, {335,0.02650450}, {336,0.02417117}, {337,0.02441441}, {338,0.02615315}, {339,0.02490991}, {340,0.02475676}, {341,0.02504505}, {342,0.02509009}, {343,0.02634234}, {344,0.02512613}, {345,0.02514414}, {346,0.02714414}, {347,0.02545946}, {348,0.02524324}, {349,0.02743243}, {350,0.02592793}, {351,0.02611712}, {352,0.02710811}, {353,0.02563063}, {354,0.02569369}, {355,0.02781081}, {356,0.02598198}, {357,0.02609910}, {358,0.02790991}, {359,0.02639640}, {360,0.02611712}, {361,0.02811712}, {362,0.02639640}, {363,0.02689189}, {364,0.02841441}, {365,0.02702703}, {366,0.02698198}, {367,0.02718919}, {368,0.02669369}, {369,0.02710811}, {370,0.02708108}, {371,0.02892793}, {372,0.02712613}, {373,0.02745045}, {374,0.02919820}, {375,0.02789189}, {376,0.02740541}, {377,0.02791892}, {378,0.02994595}, {379,0.02815315}, {380,0.02809009}, {381,0.02993694}, {382,0.02836036}, {383,0.02869369}, {384,0.02757658}, {385,0.02947748}, {386,0.02801802}, {387,0.02817117}, {388,0.02981081}, {389,0.02832432}, {390,0.02838739}, {391,0.02888288}, {392,0.03009009}, {393,0.02880180}, {394,0.02876577}, {395,0.02909009}, {396,0.03066667}, {397,0.02913514}, {398,0.02918018}, {399,0.02952252}, {400,0.03076577}, {401,0.02915315}, {402,0.02925225}, {403,0.02969369}, {404,0.03114414}, {405,0.02979279}, {406,0.02986486}, {407,0.03023423}, {408,0.03142342}, {409,0.03009009}, {410,0.03009910}, {411,0.03045045}, {412,0.03203604}, {413,0.03051351}, {414,0.03077477}, {415,0.03106306}, {416,0.03022523}, {417,0.03231532}, {418,0.03051351}, {419,0.03085586}, {420,0.03063964}, {421,0.03268468}, {422,0.03359459}, {423,0.03140541}, {424,0.03094595}, {425,0.03121622}, {426,0.03374775}, {427,0.03474775}, {428,0.03136937}, {429,0.03179279}, {430,0.03194595}, {431,0.03452252}, {432,0.03389189}, {433,0.03186486}, {434,0.03200901}, {435,0.03216216}, {436,0.03367568}, {437,0.03481081}, {438,0.03240541}, {439,0.03285586}, {440,0.03227928}, {441,0.03265766}, {442,0.03450450}, {443,0.03550450}, {444,0.03286486}, {445,0.03318018}, {446,0.03325225}, {447,0.03366667}, {448,0.03425225}, {449,0.03509910}, {450,0.03281982}, {451,0.03319820}, {452,0.03300901}, {453,0.03322523}, {454,0.03504505}, {455,0.03614414}, {456,0.03327928}, {457,0.03351351}, {458,0.03363964}, {459,0.03397297}, {460,0.03389189}, {461,0.03628829}, {462,0.03663964}, {463,0.03450450}, {464,0.03390991}, {465,0.03426126}, {466,0.03423423}, {467,0.03447748}, {468,0.03603604}, {469,0.03727928}, {470,0.03708108}, {471,0.03510811}, {472,0.03461261}, {473,0.03508108}, {474,0.03505405}, {475,0.03547748}, {476,0.03513514}, {477,0.03725225}, {478,0.03816216}, {479,0.03810811}, {480,0.03503604}, {481,0.03543243}, {482,0.03542342}, {483,0.03579279}, {484,0.03548649}, {485,0.03585586}, {486,0.03749550}, {487,0.03887387}, {488,0.03827928}, {489,0.03835135}, {490,0.03622523}, {491,0.03659459}, {492,0.03636937}, {493,0.03683784}, {494,0.03691892}, {495,0.03718919}, {496,0.03626126}, {497,0.03687387}, {498,0.03821622}, {499,0.03969369}, {500,0.03930631}, {505,0.03983784}, {510,0.04038739}, {515,0.03982883}, {520,0.03977477}, {525,0.04301802}, {530,0.03888288}, {535,0.03988288}, {540,0.03997297}, {545,0.03995495}, {550,0.04391892}, {555,0.04453153}, {560,0.04289189}, {565,0.04406306}, {570,0.04446847}, {575,0.04555856}, {580,0.04477477}, {585,0.04542342}, {590,0.04404505}, {595,0.04436937}, {600,0.04433333}, {605,0.04536036}, {610,0.04513514}, {615,0.04809910}, {620,0.04811712}, {625,0.04872973}, {630,0.04741441}, {635,0.04811712}, {640,0.04654955}, {645,0.04975676}, {650,0.04999099}, {655,0.04930631}, {660,0.04874775}, {665,0.05418919}, {670,0.05368468}, {675,0.05234234}, {680,0.05036036}, {685,0.05460360}, {690,0.05332432}, {695,0.05281081}, {700,0.05257658}, {705,0.05394595}, {710,0.05484685}, {715,0.05376577}, {720,0.05618018}, {725,0.05649550}, {730,0.05487387}, {735,0.05858559}, {740,0.05525225}, {745,0.05615315}, {750,0.05854054}, {755,0.05733333}, {760,0.06012613}, {765,0.06062162}, {770,0.05684685}, {775,0.06021622}, {780,0.05790991}, {785,0.06154054}, {790,0.05918018}, {795,0.06301802}, {800,0.05889189}, {805,0.06317117}, {810,0.06063063}, {815,0.06477477}, {820,0.06136036}, {825,0.06518919}, {830,0.06343243}, {835,0.06552252}, {840,0.06236036}, {845,0.06691892}, {850,0.06364865}, {855,0.06692793}, {860,0.06748649}, {865,0.06481081}, {870,0.06867568}, {875,0.06660360}, {880,0.06872072}, {885,0.07036937}, {890,0.06785586}, {895,0.07277477}, {900,0.06966667}, {905,0.06775676}, {910,0.07236937}, {915,0.07203604}, {920,0.06887387}, {925,0.07393694}, {930,0.07277477}, {935,0.07145946}, {940,0.07292793}, {945,0.07471171}, {950,0.07541441}, {955,0.07377477}, {960,0.07073874}, {965,0.07629730}, {970,0.07612613}, {975,0.07746847}, {980,0.07402703}, {985,0.07907207}, {990,0.07970270}, {995,0.07914414}, {1000,0.07843243}, {1010,0.08006306}, {1020,0.07837838}, {1030,0.07712613}, {1040,0.07889189}, {1050,0.08276577}, {1060,0.08291892}, {1070,0.08508108}, {1080,0.08499099}, {1090,0.08503604}, {1100,0.08616216}, {1110,0.08806306}, {1120,0.08748649}, {1130,0.08981982}, {1140,0.09036937}, {1150,0.08948649}, {1160,0.09126126}, {1170,0.09056757}, {1180,0.09273874}, {1190,0.09402703}, {1200,0.09460360}, {1210,0.09305405}, {1220,0.09479279}, {1230,0.09756757}, {1240,0.09822523}, {1250,0.09813514}, {1260,0.09923423}, {1270,0.10204505}, {1280,0.09772973}, {1290,0.10012613}, {1300,0.10159459}, {1310,0.10610811}, {1320,0.10436937}, {1330,0.10454054}, {1340,0.10719820}, {1350,0.10788288}, {1360,0.10685586}, {1370,0.10990090}, {1380,0.10772072}, {1390,0.11027928}, {1400,0.11050450}, {1410,0.10900901}, {1420,0.11167568}, {1430,0.11247748}, {1440,0.11027928}, {1450,0.11468468}, {1460,0.11466667}, {1470,0.11721622}, {1480,0.11825225}, {1490,0.11864865}, {1500,0.11935135}, {1510,0.12100901}, {1520,0.12064865}, {1530,0.12294595}, {1540,0.11842342}, {1550,0.12180180}, {1560,0.11895495}, {1570,0.12413514}, {1580,0.12466667}, {1590,0.12639640}, {1600,0.12335135}, {1610,0.12655856}, {1620,0.12713514}, {1630,0.13165766}, {1640,0.12837838}, {1650,0.13055856}, {1660,0.13253153}, {1670,0.13069369}, {1680,0.13055856}, {1690,0.13755856}, {1700,0.13390090}, {1710,0.13716216}, {1720,0.13472973}, {1730,0.13870270}, {1740,0.13763063}, {1750,0.14694595}, {1760,0.13861261}, {1770,0.13953153}, {1780,0.14136937}, {1790,0.14717117}, {1800,0.14049550}, {1810,0.14300000}, {1820,0.14375676}, {1830,0.14496396}, {1840,0.14629730}, {1850,0.14889189}, {1860,0.14516216}, {1870,0.14881081}, {1880,0.14943243}, {1890,0.14929730}, {1900,0.15200901}, {1910,0.15376577}, {1920,0.14926126}, {1930,0.15189189}, {1940,0.15344144}, {1950,0.16424324}, {1960,0.15402703}, {1970,0.15680180}, {1980,0.16415315}, {1990,0.15436036}, {2000,0.15757658}, {2050,0.16250450}, {2100,0.16433333}, {2150,0.16781982}, {2200,0.17017117}, {2250,0.17779279}, {2300,0.19070270}, {2350,0.18749550}, {2400,0.18852252}, {2450,0.19497297}, {2500,0.20072973}, {2550,0.22051351}, {2600,0.20617117}, {2650,0.20931532}, {2700,0.21404505}, {2750,0.22063063}, {2800,0.22006306}, {2850,0.22550450}, {2900,0.23288288}, {2950,0.23772072}, {3000,0.24119820}, {3050,0.24597297}, {3100,0.24545045}, {3150,0.25132432}, {3200,0.24700000}, {3250,0.25558559}, {3300,0.25957658}, {3350,0.26567568}, {3400,0.26881081}, {3450,0.29171171}, {3500,0.27607207}, {3550,0.29181081}, {3600,0.27790090}, {3650,0.28746847}, {3700,0.29847748}, {3750,0.30001802}, {3800,0.30696396}, {3850,0.30649550}, {3900,0.31375676}, {3950,0.32116216}, {4000,0.31696396}, {4050,0.32982883}, {4100,0.32355856}, {4150,0.32968468}, {4200,0.33370270}, {4250,0.34355856}, {4300,0.35042342}, {4350,0.35872973}, {4400,0.34979279}, {4450,0.37468468}, {4500,0.36239640}, {4550,0.36479279}, {4600,0.37881982}, {4650,0.36845045}, {4700,0.38075676}, {4750,0.39812613}, {4800,0.37479279}, {4850,0.39163964}, {4900,0.39181982}, {4950,0.39745045}, {5000,0.39481982}, {5050,0.41406306}, {5100,0.42415315}, {5150,0.41690090}, {5200,0.41190090}, {5250,0.42216216}, {5300,0.44491892}, {5350,0.43621622}, {5400,0.43768468}, {5450,0.44136036}, {5500,0.45474775}, {5550,0.46441441}, {5600,0.44818919}, {5650,0.45028829}, {5700,0.46309910}, {5750,0.47645946}, {5800,0.46555856}, {5850,0.48597297}, {5900,0.49304505}, {5950,0.50904505}, {6000,0.50070270}, {6050,0.48625}, {6100,0.49150}, {6150,0.48575}, {6200,0.49250}, {6250,0.49475}, {6300,0.50675}, {6350,0.53375}, {6400,0.50100}, {6450,0.51950}, {6500,0.52675}, {6550,0.52600}, {6600,0.53350}, {6650,0.55000}, {6700,0.53725}, {6750,0.54700}, {6800,0.54275}, {6850,0.54975}, {6900,0.57175}, {6950,0.56525}, {7000,0.57850}, {7050,0.58275}, {7100,0.58925}, {7150,0.58575}, {7200,0.56125}, {7250,0.58675}, {7300,0.58525}, {7350,0.60050}, {7400,0.60875}, {7450,0.61100}, {7500,0.64075}, {7550,0.65600}, {7600,0.61575}, {7650,0.64100}, {7700,0.62250}, {7750,0.63375}, {7800,0.64075}, {7850,0.64475}, {7900,0.65725}, {7950,0.65650}, {8000,0.64000}, {8050,0.69150}, {8100,0.70525}, {8150,0.70150}, {8200,0.66950}, {8250,0.67725}, {8300,0.67925}, {8350,0.69275}, {8400,0.68075}, {8450,0.67375}, {8500,0.70075}, {8550,0.71375}, {8600,0.70525}, {8650,0.70525}, {8700,0.76500}, {8750,0.74000}, {8800,0.70325}, {8850,0.72850}, {8900,0.72050}, {8950,0.76450}, {9000,0.75725}, {9050,0.74775}, {9100,0.75575}, {9150,0.78025}, {9200,0.77625}, {9250,0.73925}, {9300,0.75425}, {9350,0.76575}, {9400,0.79850}, {9450,0.78250}, {9500,0.80900}, {9550,0.78900}, {9600,0.77325}, {9650,0.83100}, {9700,0.80700}, {9750,0.79600}, {9800,0.79575}, {9850,0.84200}, {9900,0.82675}, {9950,0.84325}, {10000,0.83000}, {10100,0.84425}, {10200,0.85350}, {10300,0.84825}, {10400,0.83525}, {10500,0.87500}, {10600,0.88000}, {10700,0.89350}, {10800,0.90975}, {10900,0.91300}, {11000,0.91975}, {11100,0.96300}, {11200,0.91575}, {11300,0.92625}, {11400,0.93000}, {11500,0.97650}, {11600,0.94575}, {11700,0.99700}, {11800,0.97425}, {11900,1.01300}, {12000,0.99150}, {12100,1.00925}, {12200,1.02775}, {12300,0.99625}, {12400,1.00650}, {12500,1.02775}, {12600,1.03975}, {12700,1.06625}, {12800,1.00775}, {12900,1.07025}, {13000,1.06550}, {13100,1.09625}, {13200,1.09500}, {13300,1.13525}, {13400,1.13000}, {13500,1.17550}, {13600,1.13625}, {13700,1.12425}, {13800,1.16350}, {13900,1.16800}, {14000,1.16700}, {14100,1.17450}, {14200,1.22525}, {14300,1.23600}, {14400,1.16550}, {14500,1.19850}, {14600,1.21975}, {14700,1.24550}, {14800,1.22550}, {14900,1.28200}, {15000,1.24375}, {15100,1.30025}, {15200,1.29675}, {15300,1.30350}, {15400,1.27075}, {15500,1.32775}, {15600,1.35700}, {15700,1.38700}, {15800,1.35750}, {15900,1.33200}, {16000,1.35625}, {16100,1.42650}, {16200,1.35925}, {16300,1.43000}, {16400,1.35250}, {16500,1.38975}, {16600,1.40875}, {16700,1.45675}, {16800,1.42525}, {16900,1.42425}, {17000,1.42525}, {17100,1.44500}, {17200,1.43000}, {17300,1.45675}, {17400,1.56525}, {17500,1.50450}, {17600,1.43050}, {17700,1.50150}, {17800,1.52475}, {17900,1.55250}, {18000,1.48900}, {18100,1.59150}, {18200,1.51900}, {18300,1.58275}, {18400,1.55325}, {18500,1.51575}, {18600,1.60175}, {18700,1.54200}, {18800,1.61800}, {18900,1.63350}, {19000,1.61050}, {19100,1.62050}, {19200,1.63775}, {19300,1.64125}, {19400,1.64125}, {19500,1.63175}, {19600,1.61825}, {19700,1.70000}, {19800,1.73750}, {19900,1.76225}, {20000,1.6315}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["norm reif"]["user"] = {{1,0.00025225}, {2,0.00029730}, {3,0.00037838}, {4,0.00057658}, {5,0.00026126}, {6,0.00077477}, {7,0.00054955}, {8,0.00044144}, {9,0.00104505}, {10,0.00086486}, {11,0.00091892}, {12,0.00118018}, {13,0.00106306}, {14,0.00108108}, {15,0.00107207}, {16,0.01524324}, {17,0.00145946}, {18,0.00153153}, {19,0.00128829}, {20,0.00147748}, {21,0.00151351}, {22,0.00167568}, {23,0.00164865}, {24,0.00169369}, {25,0.00170270}, {26,0.00187387}, {27,0.00200901}, {28,0.00193694}, {29,0.00201802}, {30,0.00275676}, {31,0.00221622}, {32,0.00206306}, {33,0.00247748}, {34,0.00218018}, {35,0.00258559}, {36,0.00261261}, {37,0.00229730}, {38,0.00275676}, {39,0.00274775}, {40,0.00265766}, {41,0.00290991}, {42,0.00266667}, {43,0.00281982}, {44,0.00302703}, {45,0.00299099}, {46,0.00305405}, {47,0.00313514}, {48,0.00316216}, {49,0.00338739}, {50,0.00317117}, {51,0.00338739}, {52,0.00344144}, {53,0.00350450}, {54,0.00363063}, {55,0.00388288}, {56,0.00386486}, {57,0.00370270}, {58,0.00393694}, {59,0.00400901}, {60,0.00400901}, {61,0.00415315}, {62,0.00416216}, {63,0.00427928}, {64,0.00439640}, {65,0.00510811}, {66,0.00445045}, {67,0.00462162}, {68,0.00471171}, {69,0.00486486}, {70,0.00513514}, {71,0.00513514}, {72,0.00500901}, {73,0.00497297}, {74,0.00500000}, {75,0.00573874}, {76,0.00537838}, {77,0.00523423}, {78,0.00543243}, {79,0.00541441}, {80,0.00601802}, {81,0.00559459}, {82,0.00572072}, {83,0.00627027}, {84,0.00612613}, {85,0.00603604}, {86,0.00597297}, {87,0.00620721}, {88,0.00643243}, {89,0.00643243}, {90,0.00656757}, {91,0.00686486}, {92,0.00674775}, {93,0.00705405}, {94,0.00802703}, {95,0.00695495}, {96,0.00654054}, {97,0.00709910}, {98,0.00711712}, {99,0.00828829}, {100,0.00720721}, {101,0.00739640}, {102,0.00748649}, {103,0.00761261}, {104,0.00752252}, {105,0.00755856}, {106,0.00777477}, {107,0.00787387}, {108,0.00784685}, {109,0.00798198}, {110,0.00815315}, {111,0.00846847}, {112,0.00823423}, {113,0.00836937}, {114,0.00836937}, {115,0.00859459}, {116,0.00855856}, {117,0.00944144}, {118,0.00869369}, {119,0.00872973}, {120,0.00877477}, {121,0.00986486}, {122,0.00857658}, {123,0.00866667}, {124,0.00909910}, {125,0.00996396}, {126,0.00915315}, {127,0.00911712}, {128,0.00940541}, {129,0.01015315}, {130,0.00920721}, {131,0.00943243}, {132,0.00941441}, {133,0.00945045}, {134,0.00958559}, {135,0.00976577}, {136,0.00933333}, {137,0.00987387}, {138,0.00976577}, {139,0.01016216}, {140,0.01124324}, {141,0.00994595}, {142,0.01005405}, {143,0.01028829}, {144,0.01017117}, {145,0.01018018}, {146,0.01054054}, {147,0.01153153}, {148,0.01067568}, {149,0.01054054}, {150,0.01064865}, {151,0.01066667}, {152,0.01079279}, {153,0.01086486}, {154,0.01115315}, {155,0.01107207}, {156,0.01079279}, {157,0.01227928}, {158,0.01136937}, {159,0.01136036}, {160,0.01272973}, {161,0.01149550}, {162,0.01163964}, {163,0.01306306}, {164,0.01172973}, {165,0.01186486}, {166,0.01190991}, {167,0.01224324}, {168,0.01187387}, {169,0.01218018}, {170,0.01247748}, {171,0.01264865}, {172,0.01259459}, {173,0.01239640}, {174,0.01285586}, {175,0.01412613}, {176,0.01309009}, {177,0.01313514}, {178,0.01463063}, {179,0.01317117}, {180,0.01300000}, {181,0.01455856}, {182,0.01360360}, {183,0.01371171}, {184,0.01311712}, {185,0.01322523}, {186,0.01381982}, {187,0.01356757}, {188,0.01337838}, {189,0.01416216}, {190,0.01427928}, {191,0.01412613}, {192,0.01481982}, {193,0.01377477}, {194,0.01418018}, {195,0.01436036}, {196,0.01439640}, {197,0.01593694}, {198,0.01445946}, {199,0.01474775}, {200,0.01446847}, {201,0.01480180}, {202,0.01464865}, {203,0.01509009}, {204,0.01490090}, {205,0.01648649}, {206,0.01518018}, {207,0.01542342}, {208,0.01527928}, {209,0.01549550}, {210,0.01667568}, {211,0.01561261}, {212,0.01549550}, {213,0.01572973}, {214,0.01573874}, {215,0.01609910}, {216,0.01576577}, {217,0.01716216}, {218,0.01609910}, {219,0.01632432}, {220,0.01609910}, {221,0.01634234}, {222,0.01746847}, {223,0.01668468}, {224,0.01755856}, {225,0.01644144}, {226,0.01636937}, {227,0.01653153}, {228,0.01660360}, {229,0.01709009}, {230,0.01690090}, {231,0.01773874}, {232,0.01701802}, {233,0.01709910}, {234,0.01689189}, {235,0.01708108}, {236,0.01727027}, {237,0.01722523}, {238,0.01701802}, {239,0.01757658}, {240,0.01818018}, {241,0.01740541}, {242,0.01888288}, {243,0.01747748}, {244,0.01863063}, {245,0.01772072}, {246,0.01790090}, {247,0.01815315}, {248,0.01772072}, {249,0.01812613}, {250,0.01829730}, {251,0.01822523}, {252,0.01839640}, {253,0.01828829}, {254,0.01836937}, {255,0.01876577}, {256,0.01820721}, {257,0.01804505}, {258,0.01822523}, {259,0.01842342}, {260,0.01859459}, {261,0.01879279}, {262,0.01875676}, {263,0.01892793}, {264,0.01850450}, {265,0.01875676}, {266,0.01895495}, {267,0.01913514}, {268,0.01896396}, {269,0.01936036}, {270,0.01939640}, {271,0.01956757}, {272,0.01917117}, {273,0.01927027}, {274,0.01934234}, {275,0.01981081}, {276,0.01969369}, {277,0.02001802}, {278,0.01978378}, {279,0.02018919}, {280,0.02169369}, {281,0.02029730}, {282,0.02239640}, {283,0.02022523}, {284,0.02155856}, {285,0.02059459}, {286,0.02078378}, {287,0.02095495}, {288,0.02060360}, {289,0.02047748}, {290,0.02036036}, {291,0.02302703}, {292,0.02070270}, {293,0.02231532}, {294,0.02046847}, {295,0.02150450}, {296,0.02111712}, {297,0.02137838}, {298,0.02155856}, {299,0.02199099}, {300,0.02371171}, {301,0.02202703}, {302,0.02381982}, {303,0.02181081}, {304,0.02171171}, {305,0.02207207}, {306,0.02193694}, {307,0.02455856}, {308,0.02189189}, {309,0.02249550}, {310,0.02281081}, {311,0.02260360}, {312,0.02601802}, {313,0.02244144}, {314,0.02455856}, {315,0.02331532}, {316,0.02290991}, {317,0.02634234}, {318,0.02333333}, {319,0.02332432}, {320,0.02276577}, {321,0.02315315}, {322,0.02610811}, {323,0.02346847}, {324,0.02327928}, {325,0.02345946}, {326,0.02361261}, {327,0.02617117}, {328,0.02379279}, {329,0.02380180}, {330,0.02407207}, {331,0.02428829}, {332,0.02543243}, {333,0.02432432}, {334,0.02436937}, {335,0.02649550}, {336,0.02431532}, {337,0.02443243}, {338,0.02617117}, {339,0.02444144}, {340,0.02476577}, {341,0.02518919}, {342,0.02506306}, {343,0.02638739}, {344,0.02524324}, {345,0.02536937}, {346,0.02674775}, {347,0.02560360}, {348,0.02583784}, {349,0.02730631}, {350,0.02587387}, {351,0.02646847}, {352,0.02696396}, {353,0.02540541}, {354,0.02551351}, {355,0.02763964}, {356,0.02584685}, {357,0.02609009}, {358,0.02773874}, {359,0.02652252}, {360,0.02603604}, {361,0.02829730}, {362,0.02643243}, {363,0.02694595}, {364,0.02838739}, {365,0.02695495}, {366,0.02672072}, {367,0.02698198}, {368,0.02637838}, {369,0.02706306}, {370,0.02688288}, {371,0.02887387}, {372,0.02693694}, {373,0.02709009}, {374,0.02900901}, {375,0.02747748}, {376,0.02730631}, {377,0.02764865}, {378,0.03018018}, {379,0.02801802}, {380,0.02787387}, {381,0.03012613}, {382,0.02854054}, {383,0.02851351}, {384,0.02758559}, {385,0.02948649}, {386,0.02781081}, {387,0.02821622}, {388,0.02979279}, {389,0.02845946}, {390,0.02830631}, {391,0.02908108}, {392,0.02996396}, {393,0.02866667}, {394,0.02862162}, {395,0.02931532}, {396,0.03090991}, {397,0.02913514}, {398,0.02911712}, {399,0.02960360}, {400,0.03134234}, {401,0.02950450}, {402,0.02945946}, {403,0.03024324}, {404,0.03153153}, {405,0.03009910}, {406,0.02994595}, {407,0.03019820}, {408,0.03189189}, {409,0.03032432}, {410,0.03001802}, {411,0.03052252}, {412,0.03237838}, {413,0.03100000}, {414,0.03110811}, {415,0.03159459}, {416,0.03037838}, {417,0.03271171}, {418,0.03127928}, {419,0.03132432}, {420,0.03101802}, {421,0.03292793}, {422,0.03364865}, {423,0.03191892}, {424,0.03141441}, {425,0.03158559}, {426,0.03405405}, {427,0.03467568}, {428,0.03180180}, {429,0.03232432}, {430,0.03227027}, {431,0.03433333}, {432,0.03400901}, {433,0.03219820}, {434,0.03224324}, {435,0.03263964}, {436,0.03404505}, {437,0.03500000}, {438,0.03263964}, {439,0.03322523}, {440,0.03235135}, {441,0.03281982}, {442,0.03473874}, {443,0.03540541}, {444,0.03303604}, {445,0.03345045}, {446,0.03373874}, {447,0.03434234}, {448,0.03443243}, {449,0.03529730}, {450,0.03285586}, {451,0.03351351}, {452,0.03340541}, {453,0.03350450}, {454,0.03511712}, {455,0.03591892}, {456,0.03322523}, {457,0.03402703}, {458,0.03409009}, {459,0.03418018}, {460,0.03401802}, {461,0.03635135}, {462,0.03657658}, {463,0.03485586}, {464,0.03430631}, {465,0.03427027}, {466,0.03449550}, {467,0.03493694}, {468,0.03597297}, {469,0.03705405}, {470,0.03689189}, {471,0.03504505}, {472,0.03487387}, {473,0.03520721}, {474,0.03537838}, {475,0.03555856}, {476,0.03491892}, {477,0.03688288}, {478,0.03800000}, {479,0.03814414}, {480,0.03506306}, {481,0.03545045}, {482,0.03567568}, {483,0.03572973}, {484,0.03538739}, {485,0.03587387}, {486,0.03748649}, {487,0.03892793}, {488,0.03818018}, {489,0.03809910}, {490,0.03632432}, {491,0.03686486}, {492,0.03638739}, {493,0.03653153}, {494,0.03673874}, {495,0.03714414}, {496,0.03627027}, {497,0.03699099}, {498,0.03794595}, {499,0.03932432}, {500,0.03863964}, {505,0.03954054}, {510,0.04050450}, {515,0.03960360}, {520,0.03954054}, {525,0.04299099}, {530,0.03842342}, {535,0.03972973}, {540,0.03993694}, {545,0.03964865}, {550,0.04397297}, {555,0.04475676}, {560,0.04313514}, {565,0.04432432}, {570,0.04433333}, {575,0.04571171}, {580,0.04468468}, {585,0.04543243}, {590,0.04434234}, {595,0.04458559}, {600,0.04443243}, {605,0.04525225}, {610,0.04501802}, {615,0.04797297}, {620,0.04811712}, {625,0.04873874}, {630,0.04754054}, {635,0.04806306}, {640,0.04675676}, {645,0.04964865}, {650,0.04997297}, {655,0.04910811}, {660,0.04889189}, {665,0.05412613}, {670,0.05324324}, {675,0.05169369}, {680,0.05031532}, {685,0.05430631}, {690,0.05290991}, {695,0.05238739}, {700,0.05252252}, {705,0.05354054}, {710,0.05441441}, {715,0.05322523}, {720,0.05601802}, {725,0.05629730}, {730,0.05439640}, {735,0.05839640}, {740,0.05525225}, {745,0.05609910}, {750,0.05835135}, {755,0.05746847}, {760,0.06010811}, {765,0.06074775}, {770,0.05680180}, {775,0.06045946}, {780,0.05794595}, {785,0.06154955}, {790,0.05908108}, {795,0.06335135}, {800,0.05908108}, {805,0.06325225}, {810,0.06087387}, {815,0.06488288}, {820,0.06133333}, {825,0.06509009}, {830,0.06389189}, {835,0.06560360}, {840,0.06264865}, {845,0.06650450}, {850,0.06384685}, {855,0.06681081}, {860,0.06736036}, {865,0.06504505}, {870,0.06846847}, {875,0.06668468}, {880,0.06846847}, {885,0.07027027}, {890,0.06756757}, {895,0.07300901}, {900,0.06939640}, {905,0.06738739}, {910,0.07239640}, {915,0.07202703}, {920,0.06849550}, {925,0.07427928}, {930,0.07281081}, {935,0.07171171}, {940,0.07305405}, {945,0.07501802}, {950,0.07557658}, {955,0.07407207}, {960,0.07056757}, {965,0.07672072}, {970,0.07626126}, {975,0.07769369}, {980,0.07439640}, {985,0.07877477}, {990,0.07935135}, {995,0.07846847}, {1000,0.07819820}, {1010,0.07989189}, {1020,0.07837838}, {1030,0.07739640}, {1040,0.07869369}, {1050,0.08280180}, {1060,0.08263964}, {1070,0.08474775}, {1080,0.08503604}, {1090,0.08500901}, {1100,0.08625225}, {1110,0.08818919}, {1120,0.08737838}, {1130,0.08976577}, {1140,0.09031532}, {1150,0.08955856}, {1160,0.09084685}, {1170,0.09019820}, {1180,0.09217117}, {1190,0.09387387}, {1200,0.09417117}, {1210,0.09279279}, {1220,0.09430631}, {1230,0.09771171}, {1240,0.09826126}, {1250,0.09810811}, {1260,0.09956757}, {1270,0.10172973}, {1280,0.09802703}, {1290,0.10015315}, {1300,0.10117117}, {1310,0.10551351}, {1320,0.10391892}, {1330,0.10422523}, {1340,0.10688288}, {1350,0.10759459}, {1360,0.10640541}, {1370,0.10969369}, {1380,0.10758559}, {1390,0.10986486}, {1400,0.11047748}, {1410,0.10905405}, {1420,0.11142342}, {1430,0.11224324}, {1440,0.11021622}, {1450,0.11426126}, {1460,0.11444144}, {1470,0.11678378}, {1480,0.11806306}, {1490,0.11813514}, {1500,0.11916216}, {1510,0.12100901}, {1520,0.12018018}, {1530,0.12290090}, {1540,0.11787387}, {1550,0.12154054}, {1560,0.11862162}, {1570,0.12397297}, {1580,0.12477477}, {1590,0.12645045}, {1600,0.12315315}, {1610,0.12667568}, {1620,0.12726126}, {1630,0.13150450}, {1640,0.12854054}, {1650,0.13017117}, {1660,0.13230631}, {1670,0.13052252}, {1680,0.13036937}, {1690,0.13754054}, {1700,0.13354955}, {1710,0.13709009}, {1720,0.13446847}, {1730,0.13854955}, {1740,0.13745045}, {1750,0.14658559}, {1760,0.13880180}, {1770,0.13986486}, {1780,0.14167568}, {1790,0.14690090}, {1800,0.14102703}, {1810,0.14332432}, {1820,0.14404505}, {1830,0.14496396}, {1840,0.14596396}, {1850,0.14878378}, {1860,0.14523423}, {1870,0.14854054}, {1880,0.14965766}, {1890,0.14926126}, {1900,0.15226126}, {1910,0.15389189}, {1920,0.14950450}, {1930,0.15204505}, {1940,0.15336937}, {1950,0.16420721}, {1960,0.15409910}, {1970,0.15672072}, {1980,0.16434234}, {1990,0.15427027}, {2000,0.15744144}, {2050,0.16241441}, {2100,0.16437838}, {2150,0.16778378}, {2200,0.16992793}, {2250,0.17794595}, {2300,0.19055856}, {2350,0.18741441}, {2400,0.18894595}, {2450,0.19484685}, {2500,0.20063063}, {2550,0.21999099}, {2600,0.20583784}, {2650,0.20907207}, {2700,0.21409009}, {2750,0.22026126}, {2800,0.21955856}, {2850,0.22532432}, {2900,0.23281982}, {2950,0.23762162}, {3000,0.24088288}, {3050,0.24565766}, {3100,0.24537838}, {3150,0.25096396}, {3200,0.24653153}, {3250,0.25577477}, {3300,0.25944144}, {3350,0.26577477}, {3400,0.26884685}, {3450,0.29195495}, {3500,0.27573874}, {3550,0.29181081}, {3600,0.27821622}, {3650,0.28726126}, {3700,0.29806306}, {3750,0.30000000}, {3800,0.30661261}, {3850,0.30631532}, {3900,0.31343243}, {3950,0.32088288}, {4000,0.31658559}, {4050,0.32969369}, {4100,0.32363964}, {4150,0.32927928}, {4200,0.33314414}, {4250,0.34350450}, {4300,0.35028829}, {4350,0.35838739}, {4400,0.34963063}, {4450,0.37445045}, {4500,0.36238739}, {4550,0.36455856}, {4600,0.37896396}, {4650,0.36809009}, {4700,0.38083784}, {4750,0.39772973}, {4800,0.37488288}, {4850,0.39124324}, {4900,0.39177477}, {4950,0.39738739}, {5000,0.39442342}, {5050,0.41402703}, {5100,0.42396396}, {5150,0.41696396}, {5200,0.41156757}, {5250,0.42176577}, {5300,0.44460360}, {5350,0.43586486}, {5400,0.43783784}, {5450,0.44145045}, {5500,0.45465766}, {5550,0.46436036}, {5600,0.44795495}, {5650,0.45002703}, {5700,0.46302703}, {5750,0.47559459}, {5800,0.46520721}, {5850,0.48540541}, {5900,0.49243243}, {5950,0.50848649}, {6000,0.50027928}, {6050,0.48675}, {6100,0.49025}, {6150,0.48550}, {6200,0.49300}, {6250,0.49450}, {6300,0.50825}, {6350,0.53475}, {6400,0.50175}, {6450,0.52025}, {6500,0.52575}, {6550,0.52750}, {6600,0.53200}, {6650,0.54975}, {6700,0.53850}, {6750,0.54700}, {6800,0.53950}, {6850,0.54950}, {6900,0.57150}, {6950,0.56450}, {7000,0.57500}, {7050,0.58275}, {7100,0.58850}, {7150,0.58675}, {7200,0.55925}, {7250,0.58625}, {7300,0.58425}, {7350,0.59925}, {7400,0.60825}, {7450,0.61150}, {7500,0.64050}, {7550,0.65525}, {7600,0.61775}, {7650,0.64075}, {7700,0.62225}, {7750,0.63275}, {7800,0.64075}, {7850,0.64375}, {7900,0.65750}, {7950,0.65575}, {8000,0.63925}, {8050,0.69100}, {8100,0.70225}, {8150,0.70050}, {8200,0.66725}, {8250,0.67850}, {8300,0.67925}, {8350,0.69225}, {8400,0.68100}, {8450,0.67350}, {8500,0.70050}, {8550,0.71375}, {8600,0.70400}, {8650,0.70375}, {8700,0.76450}, {8750,0.73775}, {8800,0.70225}, {8850,0.72850}, {8900,0.72150}, {8950,0.76375}, {9000,0.75675}, {9050,0.74875}, {9100,0.75675}, {9150,0.78100}, {9200,0.77700}, {9250,0.73950}, {9300,0.75450}, {9350,0.76600}, {9400,0.79725}, {9450,0.78150}, {9500,0.80900}, {9550,0.78850}, {9600,0.77350}, {9650,0.83050}, {9700,0.80675}, {9750,0.79475}, {9800,0.79550}, {9850,0.84150}, {9900,0.82550}, {9950,0.84175}, {10000,0.83100}, {10100,0.84275}, {10200,0.85375}, {10300,0.84825}, {10400,0.83500}, {10500,0.87375}, {10600,0.87850}, {10700,0.89350}, {10800,0.90950}, {10900,0.91250}, {11000,0.91975}, {11100,0.96350}, {11200,0.91575}, {11300,0.92575}, {11400,0.92950}, {11500,0.97525}, {11600,0.94550}, {11700,0.99575}, {11800,0.97500}, {11900,1.01400}, {12000,0.99150}, {12100,1.00875}, {12200,1.02625}, {12300,0.99550}, {12400,1.00750}, {12500,1.02700}, {12600,1.04000}, {12700,1.06675}, {12800,1.00700}, {12900,1.07050}, {13000,1.06650}, {13100,1.09600}, {13200,1.09425}, {13300,1.13575}, {13400,1.12975}, {13500,1.17675}, {13600,1.13650}, {13700,1.12475}, {13800,1.16250}, {13900,1.16750}, {14000,1.16625}, {14100,1.17350}, {14200,1.22450}, {14300,1.23675}, {14400,1.16700}, {14500,1.19825}, {14600,1.21800}, {14700,1.24675}, {14800,1.22475}, {14900,1.28125}, {15000,1.24350}, {15100,1.29950}, {15200,1.29700}, {15300,1.30300}, {15400,1.27050}, {15500,1.32650}, {15600,1.35525}, {15700,1.38775}, {15800,1.35625}, {15900,1.33200}, {16000,1.35450}, {16100,1.42625}, {16200,1.35750}, {16300,1.42925}, {16400,1.35050}, {16500,1.39025}, {16600,1.40950}, {16700,1.45400}, {16800,1.42425}, {16900,1.42325}, {17000,1.42550}, {17100,1.44625}, {17200,1.42850}, {17300,1.45575}, {17400,1.56575}, {17500,1.50425}, {17600,1.43125}, {17700,1.49975}, {17800,1.52400}, {17900,1.55200}, {18000,1.48925}, {18100,1.59000}, {18200,1.51900}, {18300,1.58175}, {18400,1.55450}, {18500,1.51550}, {18600,1.60150}, {18700,1.54200}, {18800,1.61750}, {18900,1.63400}, {19000,1.60950}, {19100,1.62025}, {19200,1.63650}, {19300,1.64125}, {19400,1.64175}, {19500,1.62975}, {19600,1.61850}, {19700,1.70000}, {19800,1.73825}, {19900,1.76050}, {20000,1.6315}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["norm reif"]["system"] = {{1,0.00009910}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00007207}, {6,0.00003604}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00003604}, {12,0.00000000}, {13,0.00000000}, {14,0.00006306}, {15,0.00007207}, {16,0.00020721}, {17,0.00000000}, {18,0.00000000}, {19,0.00007207}, {20,0.00002703}, {21,0.00000000}, {22,0.00003604}, {23,0.00006306}, {24,0.00009910}, {25,0.00003604}, {26,0.00000000}, {27,0.00009910}, {28,0.00000000}, {29,0.00000000}, {30,0.00009910}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00005405}, {42,0.00000000}, {43,0.00006306}, {44,0.00000000}, {45,0.00000000}, {46,0.00003604}, {47,0.00003604}, {48,0.00000000}, {49,0.00000000}, {50,0.00009910}, {51,0.00000000}, {52,0.00000000}, {53,0.00009910}, {54,0.00000000}, {55,0.00003604}, {56,0.00000000}, {57,0.00003604}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00007207}, {62,0.00003604}, {63,0.00003604}, {64,0.00003604}, {65,0.00002703}, {66,0.00003604}, {67,0.00003604}, {68,0.00003604}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00003604}, {73,0.00003604}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00003604}, {79,0.00003604}, {80,0.00000000}, {81,0.00003604}, {82,0.00003604}, {83,0.00000000}, {84,0.00009910}, {85,0.00003604}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00006306}, {90,0.00000000}, {91,0.00003604}, {92,0.00003604}, {93,0.00000000}, {94,0.00000000}, {95,0.00003604}, {96,0.00014414}, {97,0.00007207}, {98,0.00007207}, {99,0.00000000}, {100,0.00003604}, {101,0.00000000}, {102,0.00013514}, {103,0.00000000}, {104,0.00000000}, {105,0.00003604}, {106,0.00003604}, {107,0.00000000}, {108,0.00000000}, {109,0.00003604}, {110,0.00003604}, {111,0.00000000}, {112,0.00006306}, {113,0.00003604}, {114,0.00000000}, {115,0.00003604}, {116,0.00000000}, {117,0.00003604}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00006306}, {122,0.00003604}, {123,0.00003604}, {124,0.00002703}, {125,0.00002703}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00007207}, {130,0.00003604}, {131,0.00003604}, {132,0.00003604}, {133,0.00000000}, {134,0.00003604}, {135,0.00000000}, {136,0.00007207}, {137,0.00003604}, {138,0.00003604}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00006306}, {146,0.00000000}, {147,0.00002703}, {148,0.00007207}, {149,0.00000000}, {150,0.00007207}, {151,0.00007207}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00003604}, {158,0.00000000}, {159,0.00000000}, {160,0.00010811}, {161,0.00010811}, {162,0.00000000}, {163,0.00003604}, {164,0.00002703}, {165,0.00003604}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00003604}, {170,0.00000000}, {171,0.00002703}, {172,0.00000000}, {173,0.00002703}, {174,0.00000000}, {175,0.00007207}, {176,0.00003604}, {177,0.00000000}, {178,0.00000000}, {179,0.00007207}, {180,0.00003604}, {181,0.00006306}, {182,0.00000000}, {183,0.00000000}, {184,0.00003604}, {185,0.00000000}, {186,0.00003604}, {187,0.00000000}, {188,0.00003604}, {189,0.00000000}, {190,0.00000000}, {191,0.00002703}, {192,0.00009910}, {193,0.00000000}, {194,0.00003604}, {195,0.00000000}, {196,0.00003604}, {197,0.00006306}, {198,0.00000000}, {199,0.00002703}, {200,0.00002703}, {201,0.00000000}, {202,0.00003604}, {203,0.00000000}, {204,0.00002703}, {205,0.00000000}, {206,0.00003604}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00002703}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00002703}, {215,0.00000000}, {216,0.00007207}, {217,0.00000000}, {218,0.00003604}, {219,0.00000000}, {220,0.00007207}, {221,0.00000000}, {222,0.00007207}, {223,0.00000000}, {224,0.00010811}, {225,0.00003604}, {226,0.00006306}, {227,0.00009910}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00010811}, {232,0.00000000}, {233,0.00003604}, {234,0.00003604}, {235,0.00003604}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00007207}, {241,0.00007207}, {242,0.00010811}, {243,0.00000000}, {244,0.00003604}, {245,0.00003604}, {246,0.00000000}, {247,0.00000000}, {248,0.00009009}, {249,0.00000000}, {250,0.00000000}, {251,0.00003604}, {252,0.00003604}, {253,0.00003604}, {254,0.00007207}, {255,0.00003604}, {256,0.00000000}, {257,0.00007207}, {258,0.00003604}, {259,0.00000000}, {260,0.00000000}, {261,0.00003604}, {262,0.00003604}, {263,0.00003604}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00009910}, {273,0.00003604}, {274,0.00003604}, {275,0.00000000}, {276,0.00002703}, {277,0.00000000}, {278,0.00002703}, {279,0.00002703}, {280,0.00003604}, {281,0.00003604}, {282,0.00016216}, {283,0.00000000}, {284,0.00013514}, {285,0.00003604}, {286,0.00000000}, {287,0.00003604}, {288,0.00000000}, {289,0.00003604}, {290,0.00000000}, {291,0.00002703}, {292,0.00003604}, {293,0.00009910}, {294,0.00009009}, {295,0.00002703}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00007207}, {301,0.00003604}, {302,0.00000000}, {303,0.00003604}, {304,0.00003604}, {305,0.00000000}, {306,0.00000000}, {307,0.00009910}, {308,0.00007207}, {309,0.00007207}, {310,0.00000000}, {311,0.00000000}, {312,0.00003604}, {313,0.00003604}, {314,0.00000000}, {315,0.00003604}, {316,0.00002703}, {317,0.00007207}, {318,0.00003604}, {319,0.00003604}, {320,0.00003604}, {321,0.00000000}, {322,0.00003604}, {323,0.00002703}, {324,0.00003604}, {325,0.00007207}, {326,0.00007207}, {327,0.00007207}, {328,0.00003604}, {329,0.00000000}, {330,0.00003604}, {331,0.00003604}, {332,0.00003604}, {333,0.00007207}, {334,0.00000000}, {335,0.00003604}, {336,0.00000000}, {337,0.00003604}, {338,0.00006306}, {339,0.00007207}, {340,0.00014414}, {341,0.00000000}, {342,0.00007207}, {343,0.00003604}, {344,0.00003604}, {345,0.00000000}, {346,0.00007207}, {347,0.00003604}, {348,0.00000000}, {349,0.00002703}, {350,0.00000000}, {351,0.00003604}, {352,0.00017117}, {353,0.00006306}, {354,0.00003604}, {355,0.00014414}, {356,0.00003604}, {357,0.00000000}, {358,0.00005405}, {359,0.00003604}, {360,0.00000000}, {361,0.00003604}, {362,0.00000000}, {363,0.00000000}, {364,0.00007207}, {365,0.00007207}, {366,0.00000000}, {367,0.00003604}, {368,0.00000000}, {369,0.00003604}, {370,0.00007207}, {371,0.00003604}, {372,0.00007207}, {373,0.00003604}, {374,0.00013514}, {375,0.00003604}, {376,0.00006306}, {377,0.00000000}, {378,0.00000000}, {379,0.00003604}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00007207}, {384,0.00003604}, {385,0.00000000}, {386,0.00007207}, {387,0.00000000}, {388,0.00002703}, {389,0.00003604}, {390,0.00003604}, {391,0.00003604}, {392,0.00010811}, {393,0.00003604}, {394,0.00002703}, {395,0.00000000}, {396,0.00003604}, {397,0.00003604}, {398,0.00007207}, {399,0.00003604}, {400,0.00010811}, {401,0.00000000}, {402,0.00002703}, {403,0.00000000}, {404,0.00002703}, {405,0.00003604}, {406,0.00003604}, {407,0.00000000}, {408,0.00002703}, {409,0.00000000}, {410,0.00003604}, {411,0.00003604}, {412,0.00003604}, {413,0.00007207}, {414,0.00000000}, {415,0.00000000}, {416,0.00007207}, {417,0.00000000}, {418,0.00000000}, {419,0.00007207}, {420,0.00000000}, {421,0.00003604}, {422,0.00003604}, {423,0.00000000}, {424,0.00003604}, {425,0.00003604}, {426,0.00003604}, {427,0.00020721}, {428,0.00000000}, {429,0.00000000}, {430,0.00003604}, {431,0.00009910}, {432,0.00010811}, {433,0.00000000}, {434,0.00006306}, {435,0.00000000}, {436,0.00000000}, {437,0.00003604}, {438,0.00003604}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00007207}, {443,0.00013514}, {444,0.00003604}, {445,0.00006306}, {446,0.00007207}, {447,0.00003604}, {448,0.00003604}, {449,0.00007207}, {450,0.00000000}, {451,0.00003604}, {452,0.00007207}, {453,0.00003604}, {454,0.00007207}, {455,0.00003604}, {456,0.00021622}, {457,0.00000000}, {458,0.00003604}, {459,0.00000000}, {460,0.00003604}, {461,0.00009009}, {462,0.00013514}, {463,0.00002703}, {464,0.00003604}, {465,0.00007207}, {466,0.00003604}, {467,0.00000000}, {468,0.00003604}, {469,0.00010811}, {470,0.00006306}, {471,0.00003604}, {472,0.00010811}, {473,0.00003604}, {474,0.00000000}, {475,0.00003604}, {476,0.00007207}, {477,0.00006306}, {478,0.00014414}, {479,0.00003604}, {480,0.00000000}, {481,0.00003604}, {482,0.00002703}, {483,0.00003604}, {484,0.00003604}, {485,0.00007207}, {486,0.00007207}, {487,0.00007207}, {488,0.00006306}, {489,0.00003604}, {490,0.00000000}, {491,0.00000000}, {492,0.00003604}, {493,0.00007207}, {494,0.00000000}, {495,0.00000000}, {496,0.00003604}, {497,0.00000000}, {498,0.00010811}, {499,0.00013514}, {500,0.00020721}, {505,0.00010811}, {510,0.00000000}, {515,0.00006306}, {520,0.00007207}, {525,0.00020721}, {530,0.00003604}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00007207}, {555,0.00010811}, {560,0.00010811}, {565,0.00003604}, {570,0.00010811}, {575,0.00007207}, {580,0.00010811}, {585,0.00007207}, {590,0.00002703}, {595,0.00000000}, {600,0.00003604}, {605,0.00000000}, {610,0.00000000}, {615,0.00021622}, {620,0.00000000}, {625,0.00003604}, {630,0.00003604}, {635,0.00007207}, {640,0.00000000}, {645,0.00003604}, {650,0.00006306}, {655,0.00007207}, {660,0.00003604}, {665,0.00006306}, {670,0.00007207}, {675,0.00009910}, {680,0.00000000}, {685,0.00007207}, {690,0.00003604}, {695,0.00007207}, {700,0.00000000}, {705,0.00003604}, {710,0.00010811}, {715,0.00003604}, {720,0.00021622}, {725,0.00007207}, {730,0.00010811}, {735,0.00007207}, {740,0.00002703}, {745,0.00000000}, {750,0.00003604}, {755,0.00007207}, {760,0.00018018}, {765,0.00014414}, {770,0.00000000}, {775,0.00003604}, {780,0.00010811}, {785,0.00021622}, {790,0.00003604}, {795,0.00007207}, {800,0.00007207}, {805,0.00013514}, {810,0.00003604}, {815,0.00017117}, {820,0.00009910}, {825,0.00014414}, {830,0.00000000}, {835,0.00007207}, {840,0.00002703}, {845,0.00010811}, {850,0.00000000}, {855,0.00007207}, {860,0.00009910}, {865,0.00007207}, {870,0.00018018}, {875,0.00003604}, {880,0.00007207}, {885,0.00021622}, {890,0.00010811}, {895,0.00010811}, {900,0.00010811}, {905,0.00003604}, {910,0.00007207}, {915,0.00018018}, {920,0.00007207}, {925,0.00010811}, {930,0.00018018}, {935,0.00003604}, {940,0.00018018}, {945,0.00003604}, {950,0.00018018}, {955,0.00000000}, {960,0.00003604}, {965,0.00000000}, {970,0.00003604}, {975,0.00007207}, {980,0.00003604}, {985,0.00003604}, {990,0.00021622}, {995,0.00034234}, {1000,0.00027928}, {1010,0.00018018}, {1020,0.00003604}, {1030,0.00002703}, {1040,0.00003604}, {1050,0.00014414}, {1060,0.00009009}, {1070,0.00021622}, {1080,0.00010811}, {1090,0.00010811}, {1100,0.00007207}, {1110,0.00007207}, {1120,0.00020721}, {1130,0.00007207}, {1140,0.00010811}, {1150,0.00007207}, {1160,0.00010811}, {1170,0.00006306}, {1180,0.00013514}, {1190,0.00027027}, {1200,0.00014414}, {1210,0.00007207}, {1220,0.00014414}, {1230,0.00018018}, {1240,0.00007207}, {1250,0.00014414}, {1260,0.00010811}, {1270,0.00014414}, {1280,0.00007207}, {1290,0.00014414}, {1300,0.00013514}, {1310,0.00018018}, {1320,0.00010811}, {1330,0.00013514}, {1340,0.00027928}, {1350,0.00018018}, {1360,0.00007207}, {1370,0.00020721}, {1380,0.00018018}, {1390,0.00021622}, {1400,0.00005405}, {1410,0.00009910}, {1420,0.00010811}, {1430,0.00034234}, {1440,0.00007207}, {1450,0.00007207}, {1460,0.00020721}, {1470,0.00021622}, {1480,0.00010811}, {1490,0.00014414}, {1500,0.00010811}, {1510,0.00014414}, {1520,0.00010811}, {1530,0.00003604}, {1540,0.00020721}, {1550,0.00014414}, {1560,0.00007207}, {1570,0.00020721}, {1580,0.00016216}, {1590,0.00010811}, {1600,0.00018018}, {1610,0.00010811}, {1620,0.00014414}, {1630,0.00013514}, {1640,0.00010811}, {1650,0.00014414}, {1660,0.00025225}, {1670,0.00017117}, {1680,0.00010811}, {1690,0.00035135}, {1700,0.00003604}, {1710,0.00018018}, {1720,0.00017117}, {1730,0.00035135}, {1740,0.00024324}, {1750,0.00050450}, {1760,0.00017117}, {1770,0.00010811}, {1780,0.00025225}, {1790,0.00017117}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00003604}, {1830,0.00007207}, {1840,0.00003604}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00002703}, {1890,0.00000000}, {1900,0.00003604}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00010811}, {1940,0.00003604}, {1950,0.00003604}, {1960,0.00007207}, {1970,0.00010811}, {1980,0.00003604}, {1990,0.00003604}, {2000,0.00018018}, {2050,0.00009910}, {2100,0.00002703}, {2150,0.00003604}, {2200,0.00010811}, {2250,0.00007207}, {2300,0.00019820}, {2350,0.00003604}, {2400,0.00000000}, {2450,0.00006306}, {2500,0.00007207}, {2550,0.00002703}, {2600,0.00007207}, {2650,0.00000000}, {2700,0.00007207}, {2750,0.00003604}, {2800,0.00014414}, {2850,0.00014414}, {2900,0.00018018}, {2950,0.00013514}, {3000,0.00000000}, {3050,0.00006306}, {3100,0.00000000}, {3150,0.00003604}, {3200,0.00018018}, {3250,0.00007207}, {3300,0.00007207}, {3350,0.00007207}, {3400,0.00003604}, {3450,0.00014414}, {3500,0.00010811}, {3550,0.00003604}, {3600,0.00007207}, {3650,0.00000000}, {3700,0.00010811}, {3750,0.00000000}, {3800,0.00003604}, {3850,0.00003604}, {3900,0.00006306}, {3950,0.00010811}, {4000,0.00018018}, {4050,0.00009910}, {4100,0.00007207}, {4150,0.00010811}, {4200,0.00007207}, {4250,0.00000000}, {4300,0.00007207}, {4350,0.00003604}, {4400,0.00010811}, {4450,0.00007207}, {4500,0.00000000}, {4550,0.00009910}, {4600,0.00003604}, {4650,0.00007207}, {4700,0.00007207}, {4750,0.00010811}, {4800,0.00003604}, {4850,0.00020721}, {4900,0.00027928}, {4950,0.00018018}, {5000,0.00028829}, {5050,0.00017117}, {5100,0.00007207}, {5150,0.00003604}, {5200,0.00014414}, {5250,0.00010811}, {5300,0.00021622}, {5350,0.00018018}, {5400,0.00003604}, {5450,0.00003604}, {5500,0.00003604}, {5550,0.00003604}, {5600,0.00003604}, {5650,0.00003604}, {5700,0.00003604}, {5750,0.00035135}, {5800,0.00032432}, {5850,0.00037838}, {5900,0.00060360}, {5950,0.00063063}, {6000,0.00025225}, {6050,0.00000}, {6100,0.00000}, {6150,0.00100}, {6200,0.00100}, {6250,0.00100}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00100}, {6650,0.00100}, {6700,0.00000}, {6750,0.00100}, {6800,0.00175}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00200}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00100}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00100}, {8650,0.00100}, {8700,0.00000}, {8750,0.00075}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00200}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00075}, {9850,0.00000}, {9900,0.00100}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00100}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00075}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00100}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00100}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00100}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00100}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00100}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00100}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00098198}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["post"]["user"] = {{1,0.00006306}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00002703}, {10,0.00006306}, {11,0.00000000}, {12,0.00006306}, {13,0.00000000}, {14,0.00003604}, {15,0.00007207}, {16,0.00003604}, {17,0.00000000}, {18,0.00003604}, {19,0.00005405}, {20,0.00003604}, {21,0.00000000}, {22,0.00007207}, {23,0.00012613}, {24,0.00006306}, {25,0.00002703}, {26,0.00000000}, {27,0.00003604}, {28,0.00000000}, {29,0.00000000}, {30,0.00003604}, {31,0.00002703}, {32,0.00000000}, {33,0.00003604}, {34,0.00000000}, {35,0.00003604}, {36,0.00006306}, {37,0.00012613}, {38,0.00000000}, {39,0.00005405}, {40,0.00003604}, {41,0.00000000}, {42,0.00011712}, {43,0.00006306}, {44,0.00002703}, {45,0.00000000}, {46,0.00000000}, {47,0.00014414}, {48,0.00003604}, {49,0.00006306}, {50,0.00003604}, {51,0.00003604}, {52,0.00003604}, {53,0.00007207}, {54,0.00003604}, {55,0.00003604}, {56,0.00003604}, {57,0.00000000}, {58,0.00013514}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00003604}, {63,0.00003604}, {64,0.00003604}, {65,0.00006306}, {66,0.00003604}, {67,0.00000000}, {68,0.00009910}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00003604}, {73,0.00006306}, {74,0.00003604}, {75,0.00000000}, {76,0.00010811}, {77,0.00002703}, {78,0.00002703}, {79,0.00012613}, {80,0.00002703}, {81,0.00003604}, {82,0.00003604}, {83,0.00000000}, {84,0.00003604}, {85,0.00003604}, {86,0.00014414}, {87,0.00002703}, {88,0.00000000}, {89,0.00002703}, {90,0.00000000}, {91,0.00003604}, {92,0.00000000}, {93,0.00005405}, {94,0.00002703}, {95,0.00006306}, {96,0.00002703}, {97,0.00000000}, {98,0.00006306}, {99,0.00005405}, {100,0.00007207}, {101,0.00000000}, {102,0.00000000}, {103,0.00002703}, {104,0.00009009}, {105,0.00007207}, {106,0.00009910}, {107,0.00000000}, {108,0.00007207}, {109,0.00002703}, {110,0.00000000}, {111,0.00006306}, {112,0.00000000}, {113,0.00000000}, {114,0.00003604}, {115,0.00007207}, {116,0.00000000}, {117,0.00007207}, {118,0.00007207}, {119,0.00007207}, {120,0.00000000}, {121,0.00002703}, {122,0.00018919}, {123,0.00009009}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00009009}, {128,0.00006306}, {129,0.00006306}, {130,0.00003604}, {131,0.00007207}, {132,0.00000000}, {133,0.00002703}, {134,0.00003604}, {135,0.00000000}, {136,0.00007207}, {137,0.00002703}, {138,0.00006306}, {139,0.00000000}, {140,0.00003604}, {141,0.00007207}, {142,0.00007207}, {143,0.00010811}, {144,0.00000000}, {145,0.00003604}, {146,0.00002703}, {147,0.00002703}, {148,0.00006306}, {149,0.00000000}, {150,0.00007207}, {151,0.00000000}, {152,0.00006306}, {153,0.00002703}, {154,0.00007207}, {155,0.00000000}, {156,0.00000000}, {157,0.00003604}, {158,0.00000000}, {159,0.00002703}, {160,0.00003604}, {161,0.00002703}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00002703}, {166,0.00000000}, {167,0.00006306}, {168,0.00000000}, {169,0.00000000}, {170,0.00002703}, {171,0.00000000}, {172,0.00003604}, {173,0.00000000}, {174,0.00002703}, {175,0.00000000}, {176,0.00000000}, {177,0.00010811}, {178,0.00000000}, {179,0.00000000}, {180,0.00003604}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00002703}, {185,0.00000000}, {186,0.00006306}, {187,0.00000000}, {188,0.00002703}, {189,0.00092793}, {190,0.00006306}, {191,0.00008108}, {192,0.00009009}, {193,0.00006306}, {194,0.00003604}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00006306}, {199,0.00003604}, {200,0.00000000}, {201,0.00000000}, {202,0.00005405}, {203,0.00005405}, {204,0.00005405}, {205,0.00003604}, {206,0.00003604}, {207,0.00007207}, {208,0.00008108}, {209,0.00002703}, {210,0.00000000}, {211,0.00002703}, {212,0.00002703}, {213,0.00000000}, {214,0.00000000}, {215,0.00002703}, {216,0.00000000}, {217,0.00000000}, {218,0.00014414}, {219,0.00003604}, {220,0.00002703}, {221,0.00012613}, {222,0.00006306}, {223,0.00002703}, {224,0.00002703}, {225,0.00005405}, {226,0.00000000}, {227,0.00002703}, {228,0.00000000}, {229,0.00002703}, {230,0.00002703}, {231,0.00000000}, {232,0.00002703}, {233,0.00003604}, {234,0.00002703}, {235,0.00002703}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00006306}, {240,0.00000000}, {241,0.00000000}, {242,0.00002703}, {243,0.00009009}, {244,0.00000000}, {245,0.00000000}, {246,0.00006306}, {247,0.00002703}, {248,0.00005405}, {249,0.00008108}, {250,0.00005405}, {251,0.00000000}, {252,0.00005405}, {253,0.00000000}, {254,0.00000000}, {255,0.00006306}, {256,0.00000000}, {257,0.00002703}, {258,0.00005405}, {259,0.00003604}, {260,0.00000000}, {261,0.00009009}, {262,0.00002703}, {263,0.00002703}, {264,0.00002703}, {265,0.00000000}, {266,0.00006306}, {267,0.00002703}, {268,0.00002703}, {269,0.00002703}, {270,0.00009910}, {271,0.00002703}, {272,0.00005405}, {273,0.00000000}, {274,0.00000000}, {275,0.00003604}, {276,0.00003604}, {277,0.00000000}, {278,0.00000000}, {279,0.00005405}, {280,0.00002703}, {281,0.00002703}, {282,0.00000000}, {283,0.00000000}, {284,0.00005405}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00002703}, {289,0.00005405}, {290,0.00000000}, {291,0.00000000}, {292,0.00003604}, {293,0.00002703}, {294,0.00000000}, {295,0.00005405}, {296,0.00006306}, {297,0.00000000}, {298,0.00005405}, {299,0.00002703}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00003604}, {304,0.00006306}, {305,0.00003604}, {306,0.00002703}, {307,0.00002703}, {308,0.00002703}, {309,0.00002703}, {310,0.00000000}, {311,0.00002703}, {312,0.00006306}, {313,0.00002703}, {314,0.00003604}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00002703}, {320,0.00005405}, {321,0.00000000}, {322,0.00002703}, {323,0.00002703}, {324,0.00002703}, {325,0.00007207}, {326,0.00005405}, {327,0.00012613}, {328,0.00002703}, {329,0.00003604}, {330,0.00000000}, {331,0.00000000}, {332,0.00007207}, {333,0.00002703}, {334,0.00009009}, {335,0.00003604}, {336,0.00000000}, {337,0.00003604}, {338,0.00000000}, {339,0.00007207}, {340,0.00007207}, {341,0.00003604}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00003604}, {346,0.00006306}, {347,0.00007207}, {348,0.00006306}, {349,0.00000000}, {350,0.00002703}, {351,0.00000000}, {352,0.00005405}, {353,0.00000000}, {354,0.00002703}, {355,0.00002703}, {356,0.00003604}, {357,0.00003604}, {358,0.00006306}, {359,0.00002703}, {360,0.00006306}, {361,0.00000000}, {362,0.00000000}, {363,0.00006306}, {364,0.00000000}, {365,0.00000000}, {366,0.00003604}, {367,0.00009910}, {368,0.00003604}, {369,0.00007207}, {370,0.00006306}, {371,0.00000000}, {372,0.00000000}, {373,0.00003604}, {374,0.00005405}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00003604}, {379,0.00000000}, {380,0.00000000}, {381,0.00007207}, {382,0.00006306}, {383,0.00009009}, {384,0.00000000}, {385,0.00002703}, {386,0.00000000}, {387,0.00000000}, {388,0.00010811}, {389,0.00003604}, {390,0.00010811}, {391,0.00006306}, {392,0.00007207}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00003604}, {397,0.00000000}, {398,0.00009910}, {399,0.00013514}, {400,0.00000000}, {401,0.00003604}, {402,0.00009009}, {403,0.00000000}, {404,0.00002703}, {405,0.00000000}, {406,0.00003604}, {407,0.00003604}, {408,0.00002703}, {409,0.00002703}, {410,0.00000000}, {411,0.00002703}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00003604}, {416,0.00007207}, {417,0.00002703}, {418,0.00006306}, {419,0.00002703}, {420,0.00007207}, {421,0.00009009}, {422,0.00007207}, {423,0.00002703}, {424,0.00000000}, {425,0.00006306}, {426,0.00003604}, {427,0.00003604}, {428,0.00002703}, {429,0.00000000}, {430,0.00006306}, {431,0.00005405}, {432,0.00009910}, {433,0.00000000}, {434,0.00000000}, {435,0.00003604}, {436,0.00002703}, {437,0.00000000}, {438,0.00003604}, {439,0.00003604}, {440,0.00000000}, {441,0.00003604}, {442,0.00000000}, {443,0.00012613}, {444,0.00005405}, {445,0.00002703}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00014414}, {450,0.00000000}, {451,0.00000000}, {452,0.00003604}, {453,0.00003604}, {454,0.00000000}, {455,0.00009910}, {456,0.00006306}, {457,0.00003604}, {458,0.00003604}, {459,0.00000000}, {460,0.00010811}, {461,0.00000000}, {462,0.00003604}, {463,0.00002703}, {464,0.00000000}, {465,0.00006306}, {466,0.00006306}, {467,0.00006306}, {468,0.00007207}, {469,0.00003604}, {470,0.00009009}, {471,0.00002703}, {472,0.00000000}, {473,0.00003604}, {474,0.00000000}, {475,0.00006306}, {476,0.00006306}, {477,0.00007207}, {478,0.00000000}, {479,0.00006306}, {480,0.00000000}, {481,0.00009009}, {482,0.00003604}, {483,0.00006306}, {484,0.00000000}, {485,0.00003604}, {486,0.00007207}, {487,0.00009009}, {488,0.00000000}, {489,0.00003604}, {490,0.00000000}, {491,0.00003604}, {492,0.00003604}, {493,0.00000000}, {494,0.00002703}, {495,0.00009910}, {496,0.00009910}, {497,0.00000000}, {498,0.00002703}, {499,0.00002703}, {500,0.00000000}, {505,0.00009009}, {510,0.00000000}, {515,0.00003604}, {520,0.00005405}, {525,0.00006306}, {530,0.00007207}, {535,0.00003604}, {540,0.00003604}, {545,0.00009910}, {550,0.00006306}, {555,0.00007207}, {560,0.00002703}, {565,0.00002703}, {570,0.00000000}, {575,0.00006306}, {580,0.00003604}, {585,0.00000000}, {590,0.00000000}, {595,0.00002703}, {600,0.00000000}, {605,0.00007207}, {610,0.00002703}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00006306}, {640,0.00000000}, {645,0.00000000}, {650,0.00003604}, {655,0.00003604}, {660,0.00000000}, {665,0.00002703}, {670,0.00000000}, {675,0.00002703}, {680,0.00012613}, {685,0.00002703}, {690,0.00006306}, {695,0.00006306}, {700,0.00000000}, {705,0.00002703}, {710,0.00000000}, {715,0.00003604}, {720,0.00007207}, {725,0.00000000}, {730,0.00000000}, {735,0.00006306}, {740,0.00006306}, {745,0.00002703}, {750,0.00005405}, {755,0.00000000}, {760,0.00000000}, {765,0.00006306}, {770,0.00000000}, {775,0.00000000}, {780,0.00005405}, {785,0.00002703}, {790,0.00003604}, {795,0.00000000}, {800,0.00002703}, {805,0.00003604}, {810,0.00003604}, {815,0.00002703}, {820,0.00011712}, {825,0.00002703}, {830,0.00002703}, {835,0.00002703}, {840,0.00000000}, {845,0.00000000}, {850,0.00002703}, {855,0.00002703}, {860,0.00009009}, {865,0.00005405}, {870,0.00006306}, {875,0.00002703}, {880,0.00007207}, {885,0.00002703}, {890,0.00008108}, {895,0.00002703}, {900,0.00000000}, {905,0.00008108}, {910,0.00003604}, {915,0.00000000}, {920,0.00002703}, {925,0.00002703}, {930,0.00003604}, {935,0.00005405}, {940,0.00008108}, {945,0.00003604}, {950,0.00000000}, {955,0.00003604}, {960,0.00009009}, {965,0.00002703}, {970,0.00002703}, {975,0.00000000}, {980,0.00002703}, {985,0.00011712}, {990,0.00002703}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00003604}, {1020,0.00009009}, {1030,0.00002703}, {1040,0.00000000}, {1050,0.00002703}, {1060,0.00002703}, {1070,0.00005405}, {1080,0.00000000}, {1090,0.00002703}, {1100,0.00002703}, {1110,0.00006306}, {1120,0.00006306}, {1130,0.00016216}, {1140,0.00003604}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00003604}, {1180,0.00003604}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00002703}, {1220,0.00000000}, {1230,0.00003604}, {1240,0.00002703}, {1250,0.00005405}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00009009}, {1290,0.00012613}, {1300,0.00000000}, {1310,0.00005405}, {1320,0.00003604}, {1330,0.00002703}, {1340,0.00000000}, {1350,0.00003604}, {1360,0.00000000}, {1370,0.00003604}, {1380,0.00002703}, {1390,0.00002703}, {1400,0.00000000}, {1410,0.00009009}, {1420,0.00007207}, {1430,0.00002703}, {1440,0.00002703}, {1450,0.00005405}, {1460,0.00002703}, {1470,0.00000000}, {1480,0.00002703}, {1490,0.00000000}, {1500,0.00006306}, {1510,0.00006306}, {1520,0.00010811}, {1530,0.00005405}, {1540,0.00003604}, {1550,0.00002703}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00006306}, {1590,0.00009910}, {1600,0.00000000}, {1610,0.00005405}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00008108}, {1680,0.00006306}, {1690,0.00003604}, {1700,0.00002703}, {1710,0.00002703}, {1720,0.00009009}, {1730,0.00002703}, {1740,0.00002703}, {1750,0.00002703}, {1760,0.00000000}, {1770,0.00005405}, {1780,0.00005405}, {1790,0.00003604}, {1800,0.00003604}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00002703}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00007207}, {1870,0.00009910}, {1880,0.00003604}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00002703}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00003604}, {1960,0.00011712}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00006306}, {2000,0.00003604}, {2050,0.00003604}, {2100,0.00000000}, {2150,0.00003604}, {2200,0.00002703}, {2250,0.00000000}, {2300,0.00003604}, {2350,0.00007207}, {2400,0.00000000}, {2450,0.00007207}, {2500,0.00007207}, {2550,0.00003604}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00003604}, {2750,0.00000000}, {2800,0.00006306}, {2850,0.00010811}, {2900,0.00013514}, {2950,0.00003604}, {3000,0.00003604}, {3050,0.00000000}, {3100,0.00002703}, {3150,0.00000000}, {3200,0.00009910}, {3250,0.00006306}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00003604}, {3450,0.00000000}, {3500,0.00009910}, {3550,0.00000000}, {3600,0.00009009}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00006306}, {3800,0.00003604}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00018018}, {4000,0.00003604}, {4050,0.00002703}, {4100,0.00000000}, {4150,0.00003604}, {4200,0.00007207}, {4250,0.00000000}, {4300,0.00003604}, {4350,0.00007207}, {4400,0.00007207}, {4450,0.00003604}, {4500,0.00000000}, {4550,0.00002703}, {4600,0.00002703}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00002703}, {4800,0.00000000}, {4850,0.00010811}, {4900,0.00003604}, {4950,0.00003604}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00002703}, {5150,0.00000000}, {5200,0.00002703}, {5250,0.00003604}, {5300,0.00003604}, {5350,0.00006306}, {5400,0.00009910}, {5450,0.00003604}, {5500,0.00000000}, {5550,0.00002703}, {5600,0.00005405}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00002703}, {5800,0.00005405}, {5850,0.00003604}, {5900,0.00010811}, {5950,0.00002703}, {6000,0.00006306}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00075}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00100}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00100}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00100}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00100}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00075}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00100}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00100}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00003604}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00002703}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00003604}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00003604}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00003604}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00002703}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00003604}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00003604}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00003604}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00002703}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00003604}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["postprocess"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["postprocess"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003604}, {4,0.00003604}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00002703}, {9,0.00002703}, {10,0.00000000}, {11,0.00003604}, {12,0.00002703}, {13,0.00000000}, {14,0.00000000}, {15,0.00002703}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00003604}, {23,0.00000000}, {24,0.00000000}, {25,0.00006306}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00007207}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00002703}, {37,0.00000000}, {38,0.00000000}, {39,0.00002703}, {40,0.00000000}, {41,0.00006306}, {42,0.00000000}, {43,0.00000000}, {44,0.00005405}, {45,0.00000000}, {46,0.00000000}, {47,0.00002703}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00002703}, {52,0.00002703}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00002703}, {69,0.00002703}, {70,0.00007207}, {71,0.00000000}, {72,0.00000000}, {73,0.00002703}, {74,0.00000000}, {75,0.00000000}, {76,0.00003604}, {77,0.00005405}, {78,0.00002703}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00003604}, {83,0.00000000}, {84,0.00008108}, {85,0.00000000}, {86,0.00000000}, {87,0.00003604}, {88,0.00003604}, {89,0.00000000}, {90,0.00003604}, {91,0.00000000}, {92,0.00000000}, {93,0.00002703}, {94,0.00010811}, {95,0.00000000}, {96,0.00000000}, {97,0.00006306}, {98,0.00000000}, {99,0.00002703}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003604}, {105,0.00007207}, {106,0.00000000}, {107,0.00000000}, {108,0.00003604}, {109,0.00000000}, {110,0.00000000}, {111,0.00009910}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00006306}, {116,0.00003604}, {117,0.00000000}, {118,0.00002703}, {119,0.00010811}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00003604}, {128,0.00000000}, {129,0.00002703}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00002703}, {134,0.00003604}, {135,0.00003604}, {136,0.00000000}, {137,0.00002703}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00002703}, {142,0.00006306}, {143,0.00000000}, {144,0.00000000}, {145,0.00002703}, {146,0.00000000}, {147,0.00000000}, {148,0.00003604}, {149,0.00003604}, {150,0.00000000}, {151,0.00005405}, {152,0.00003604}, {153,0.00000000}, {154,0.00002703}, {155,0.00000000}, {156,0.00000000}, {157,0.00003604}, {158,0.00003604}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00003604}, {165,0.00000000}, {166,0.00005405}, {167,0.00003604}, {168,0.00000000}, {169,0.00000000}, {170,0.00002703}, {171,0.00000000}, {172,0.00002703}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00002703}, {177,0.00005405}, {178,0.00005405}, {179,0.00006306}, {180,0.00002703}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00005405}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00005405}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00002703}, {200,0.00003604}, {201,0.00003604}, {202,0.00002703}, {203,0.00000000}, {204,0.00000000}, {205,0.00005405}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00002703}, {212,0.00000000}, {213,0.00000000}, {214,0.00002703}, {215,0.00000000}, {216,0.00000000}, {217,0.00006306}, {218,0.00002703}, {219,0.00002703}, {220,0.00000000}, {221,0.00006306}, {222,0.00005405}, {223,0.00000000}, {224,0.00000000}, {225,0.00003604}, {226,0.00000000}, {227,0.00009910}, {228,0.00003604}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00002703}, {234,0.00003604}, {235,0.00000000}, {236,0.00000000}, {237,0.00002703}, {238,0.00000000}, {239,0.00005405}, {240,0.00000000}, {241,0.00005405}, {242,0.00008108}, {243,0.00000000}, {244,0.00002703}, {245,0.00000000}, {246,0.00000000}, {247,0.00002703}, {248,0.00000000}, {249,0.00003604}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00002703}, {255,0.00000000}, {256,0.00000000}, {257,0.00003604}, {258,0.00000000}, {259,0.00000000}, {260,0.00003604}, {261,0.00002703}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00002703}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00002703}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00002703}, {280,0.00003604}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00003604}, {287,0.00000000}, {288,0.00002703}, {289,0.00002703}, {290,0.00002703}, {291,0.00003604}, {292,0.00000000}, {293,0.00007207}, {294,0.00002703}, {295,0.00005405}, {296,0.00000000}, {297,0.00002703}, {298,0.00000000}, {299,0.00002703}, {300,0.00000000}, {301,0.00003604}, {302,0.00000000}, {303,0.00000000}, {304,0.00002703}, {305,0.00000000}, {306,0.00000000}, {307,0.00002703}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00002703}, {324,0.00003604}, {325,0.00006306}, {326,0.00002703}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00003604}, {337,0.00000000}, {338,0.00000000}, {339,0.00002703}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00003604}, {347,0.00003604}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00003604}, {352,0.00003604}, {353,0.00000000}, {354,0.00000000}, {355,0.00003604}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00003604}, {363,0.00003604}, {364,0.00003604}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00002703}, {372,0.00000000}, {373,0.00000000}, {374,0.00002703}, {375,0.00000000}, {376,0.00000000}, {377,0.00003604}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00003604}, {383,0.00003604}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00003604}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00003604}, {392,0.00002703}, {393,0.00003604}, {394,0.00000000}, {395,0.00002703}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00003604}, {400,0.00003604}, {401,0.00002703}, {402,0.00005405}, {403,0.00000000}, {404,0.00003604}, {405,0.00000000}, {406,0.00003604}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00003604}, {411,0.00000000}, {412,0.00000000}, {413,0.00003604}, {414,0.00000000}, {415,0.00003604}, {416,0.00003604}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00002703}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00002703}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00002703}, {434,0.00000000}, {435,0.00000000}, {436,0.00003604}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00003604}, {443,0.00006306}, {444,0.00002703}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00003604}, {451,0.00000000}, {452,0.00002703}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00003604}, {458,0.00000000}, {459,0.00002703}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00003604}, {464,0.00000000}, {465,0.00007207}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00002703}, {473,0.00003604}, {474,0.00003604}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00007207}, {479,0.00003604}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00002703}, {484,0.00007207}, {485,0.00000000}, {486,0.00000000}, {487,0.00005405}, {488,0.00003604}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00002703}, {494,0.00002703}, {495,0.00000000}, {496,0.00003604}, {497,0.00003604}, {498,0.00000000}, {499,0.00003604}, {500,0.00000000}, {505,0.00003604}, {510,0.00000000}, {515,0.00002703}, {520,0.00000000}, {525,0.00000000}, {530,0.00002703}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00003604}, {555,0.00003604}, {560,0.00000000}, {565,0.00002703}, {570,0.00003604}, {575,0.00000000}, {580,0.00003604}, {585,0.00000000}, {590,0.00000000}, {595,0.00010811}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00002703}, {625,0.00000000}, {630,0.00003604}, {635,0.00002703}, {640,0.00000000}, {645,0.00002703}, {650,0.00006306}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00002703}, {685,0.00000000}, {690,0.00000000}, {695,0.00002703}, {700,0.00002703}, {705,0.00000000}, {710,0.00002703}, {715,0.00000000}, {720,0.00002703}, {725,0.00000000}, {730,0.00000000}, {735,0.00002703}, {740,0.00002703}, {745,0.00000000}, {750,0.00002703}, {755,0.00003604}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00002703}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00003604}, {815,0.00000000}, {820,0.00002703}, {825,0.00000000}, {830,0.00009910}, {835,0.00000000}, {840,0.00002703}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00006306}, {865,0.00000000}, {870,0.00000000}, {875,0.00002703}, {880,0.00002703}, {885,0.00000000}, {890,0.00000000}, {895,0.00002703}, {900,0.00003604}, {905,0.00000000}, {910,0.00000000}, {915,0.00008108}, {920,0.00000000}, {925,0.00003604}, {930,0.00000000}, {935,0.00002703}, {940,0.00002703}, {945,0.00003604}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00002703}, {1000,0.00000000}, {1010,0.00003604}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00003604}, {1070,0.00002703}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00003604}, {1110,0.00006306}, {1120,0.00000000}, {1130,0.00002703}, {1140,0.00000000}, {1150,0.00002703}, {1160,0.00002703}, {1170,0.00006306}, {1180,0.00009009}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00003604}, {1250,0.00002703}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003604}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00002703}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00009009}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00005405}, {1380,0.00002703}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00005405}, {1420,0.00003604}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00006306}, {1490,0.00000000}, {1500,0.00006306}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00002703}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00002703}, {1610,0.00005405}, {1620,0.00003604}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00003604}, {1660,0.00000000}, {1670,0.00009910}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00002703}, {1740,0.00002703}, {1750,0.00003604}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00003604}, {1830,0.00000000}, {1840,0.00003604}, {1850,0.00009910}, {1860,0.00003604}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00003604}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00003604}, {1970,0.00000000}, {1980,0.00007207}, {1990,0.00003604}, {2000,0.00003604}, {2050,0.00009009}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00003604}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00006306}, {3000,0.00000000}, {3050,0.00006306}, {3100,0.00002703}, {3150,0.00000000}, {3200,0.00003604}, {3250,0.00005405}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00003604}, {3650,0.00003604}, {3700,0.00000000}, {3750,0.00003604}, {3800,0.00002703}, {3850,0.00003604}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00003604}, {4050,0.00002703}, {4100,0.00003604}, {4150,0.00000000}, {4200,0.00003604}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00003604}, {4600,0.00003604}, {4650,0.00003604}, {4700,0.00003604}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00003604}, {4950,0.00006306}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00009009}, {5300,0.00009009}, {5350,0.00003604}, {5400,0.00003604}, {5450,0.00000000}, {5500,0.00003604}, {5550,0.00003604}, {5600,0.00009009}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00003604}, {5800,0.00000000}, {5850,0.00006306}, {5900,0.00000000}, {5950,0.00002703}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00075}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00100}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["postprocess"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00003604}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00003604}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00002703}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00003604}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00003604}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00003604}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00098198}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000901}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000901}, {158,0.00000000}, {159,0.00000901}, {160,0.00000901}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00002703}, {166,0.00003604}, {167,0.00003604}, {168,0.00003604}, {169,0.00007207}, {170,0.00005405}, {171,0.00006306}, {172,0.00007207}, {173,0.00002703}, {174,0.00005405}, {175,0.00008108}, {176,0.00013514}, {177,0.00010811}, {178,0.00012613}, {179,0.00019820}, {180,0.00027928}, {181,0.00028829}, {182,0.00035135}, {183,0.00036937}, {184,0.00042342}, {185,0.00045946}, {186,0.00045045}, {187,0.00063964}, {188,0.00065766}, {189,0.00069369}, {190,0.00083784}, {191,0.00082883}, {192,0.00087387}, {193,0.00084685}, {194,0.00091892}, {195,0.00089189}, {196,0.00093694}, {197,0.00094595}, {198,0.00096396}, {199,0.00097297}, {200,0.00100000}, {201,0.00100000}, {202,0.00099099}, {203,0.00099099}, {204,0.00100000}, {205,0.00100000}, {206,0.00100000}, {207,0.00100000}, {208,0.00100000}, {209,0.00100000}, {210,0.00100000}, {211,0.00100000}, {212,0.00100000}, {213,0.00100000}, {214,0.00100000}, {215,0.00100000}, {216,0.00100000}, {217,0.00100000}, {218,0.00100000}, {219,0.00100000}, {220,0.00100000}, {221,0.00100000}, {222,0.00100000}, {223,0.00100000}, {224,0.00100000}, {225,0.00100000}, {226,0.00100000}, {227,0.00100000}, {228,0.00100000}, {229,0.00100000}, {230,0.00100000}, {231,0.00100000}, {232,0.00100000}, {233,0.00100000}, {234,0.00100000}, {235,0.00100000}, {236,0.00100000}, {237,0.00100000}, {238,0.00100901}, {239,0.00100000}, {240,0.00100000}, {241,0.00100000}, {242,0.00100000}, {243,0.00100000}, {244,0.00100000}, {245,0.00100000}, {246,0.00100000}, {247,0.00100000}, {248,0.00100000}, {249,0.00100000}, {250,0.00100000}, {251,0.00100000}, {252,0.00100000}, {253,0.00100000}, {254,0.00100000}, {255,0.00100000}, {256,0.00100000}, {257,0.00100000}, {258,0.00100000}, {259,0.00101802}, {260,0.00100000}, {261,0.00100000}, {262,0.00100000}, {263,0.00100000}, {264,0.00100000}, {265,0.00100000}, {266,0.00100000}, {267,0.00101802}, {268,0.00100000}, {269,0.00100000}, {270,0.00100000}, {271,0.00100000}, {272,0.00100000}, {273,0.00100000}, {274,0.00100000}, {275,0.00100000}, {276,0.00100000}, {277,0.00100000}, {278,0.00100000}, {279,0.00100000}, {280,0.00100000}, {281,0.00100000}, {282,0.00100000}, {283,0.00100000}, {284,0.00100000}, {285,0.00100000}, {286,0.00101802}, {287,0.00100000}, {288,0.00100000}, {289,0.00100000}, {290,0.00100000}, {291,0.00100000}, {292,0.00100000}, {293,0.00100000}, {294,0.00100000}, {295,0.00100000}, {296,0.00100000}, {297,0.00100000}, {298,0.00100000}, {299,0.00100000}, {300,0.00100000}, {301,0.00100000}, {302,0.00100000}, {303,0.00100000}, {304,0.00100000}, {305,0.00100000}, {306,0.00100000}, {307,0.00100000}, {308,0.00100000}, {309,0.00100000}, {310,0.00100000}, {311,0.00100000}, {312,0.00100000}, {313,0.00100000}, {314,0.00100000}, {315,0.00100000}, {316,0.00100000}, {317,0.00100000}, {318,0.00100000}, {319,0.00100000}, {320,0.00100000}, {321,0.00100000}, {322,0.00100000}, {323,0.00100000}, {324,0.00100000}, {325,0.00100000}, {326,0.00100000}, {327,0.00100000}, {328,0.00100000}, {329,0.00100000}, {330,0.00100000}, {331,0.00100000}, {332,0.00100000}, {333,0.00100000}, {334,0.00100000}, {335,0.00100000}, {336,0.00100000}, {337,0.00100000}, {338,0.00100000}, {339,0.00100000}, {340,0.00100000}, {341,0.00100000}, {342,0.00100000}, {343,0.00100000}, {344,0.00100000}, {345,0.00100000}, {346,0.00100000}, {347,0.00100000}, {348,0.00100000}, {349,0.00100000}, {350,0.00100000}, {351,0.00100000}, {352,0.00100000}, {353,0.00100000}, {354,0.00100000}, {355,0.00100000}, {356,0.00100000}, {357,0.00100000}, {358,0.00100000}, {359,0.00100000}, {360,0.00100000}, {361,0.00100000}, {362,0.00100000}, {363,0.00100000}, {364,0.00100000}, {365,0.00100000}, {366,0.00100000}, {367,0.00100000}, {368,0.00100000}, {369,0.00100000}, {370,0.00100000}, {371,0.00100000}, {372,0.00100000}, {373,0.00100000}, {374,0.00100000}, {375,0.00100000}, {376,0.00100000}, {377,0.00100000}, {378,0.00100000}, {379,0.00100000}, {380,0.00100000}, {381,0.00100000}, {382,0.00100000}, {383,0.00100000}, {384,0.00100000}, {385,0.00100000}, {386,0.00100000}, {387,0.00100000}, {388,0.00100000}, {389,0.00100000}, {390,0.00100000}, {391,0.00100000}, {392,0.00100000}, {393,0.00100000}, {394,0.00100000}, {395,0.00100000}, {396,0.00100000}, {397,0.00100000}, {398,0.00100000}, {399,0.00100000}, {400,0.00100000}, {401,0.00100000}, {402,0.00100000}, {403,0.00100000}, {404,0.00100000}, {405,0.00100000}, {406,0.00100000}, {407,0.00103604}, {408,0.00100000}, {409,0.00100000}, {410,0.00100000}, {411,0.00100000}, {412,0.00100000}, {413,0.00100000}, {414,0.00100000}, {415,0.00100000}, {416,0.00296396}, {417,0.00100000}, {418,0.00100901}, {419,0.00100000}, {420,0.00101802}, {421,0.00100000}, {422,0.00100901}, {423,0.00100901}, {424,0.00100901}, {425,0.00100000}, {426,0.00100000}, {427,0.00100000}, {428,0.00100901}, {429,0.00100901}, {430,0.00100901}, {431,0.00101802}, {432,0.00100000}, {433,0.00101802}, {434,0.00101802}, {435,0.00102703}, {436,0.00100901}, {437,0.00100901}, {438,0.00100000}, {439,0.00105405}, {440,0.00105405}, {441,0.00101802}, {442,0.00103604}, {443,0.00103604}, {444,0.00100901}, {445,0.00103604}, {446,0.00103604}, {447,0.00105405}, {448,0.00109009}, {449,0.00110811}, {450,0.00110811}, {451,0.00114414}, {452,0.00117117}, {453,0.00119820}, {454,0.00122523}, {455,0.00127928}, {456,0.00123423}, {457,0.00120721}, {458,0.00127928}, {459,0.00135135}, {460,0.00132432}, {461,0.00136036}, {462,0.00141441}, {463,0.00138739}, {464,0.00145045}, {465,0.00148649}, {466,0.00150450}, {467,0.00153153}, {468,0.00150450}, {469,0.00154054}, {470,0.00158559}, {471,0.00159459}, {472,0.00160360}, {473,0.00163063}, {474,0.00159459}, {475,0.00163063}, {476,0.00168468}, {477,0.00163063}, {478,0.00168468}, {479,0.00172973}, {480,0.00175676}, {481,0.00177477}, {482,0.00174775}, {483,0.00179279}, {484,0.00173874}, {485,0.00179279}, {486,0.00183784}, {487,0.00190991}, {488,0.00187387}, {489,0.00190090}, {490,0.00189189}, {491,0.00191892}, {492,0.00196396}, {493,0.00191892}, {494,0.00193694}, {495,0.00197297}, {496,0.00197297}, {497,0.00195495}, {498,0.00197297}, {499,0.00194595}, {500,0.00198198}, {505,0.00200000}, {510,0.00200000}, {515,0.00200000}, {520,0.00200000}, {525,0.00200000}, {530,0.00200000}, {535,0.00200000}, {540,0.00200000}, {545,0.00200000}, {550,0.00200000}, {555,0.00200000}, {560,0.00200000}, {565,0.00200000}, {570,0.00200000}, {575,0.00200000}, {580,0.00200000}, {585,0.00200000}, {590,0.00203604}, {595,0.00200000}, {600,0.00200000}, {605,0.00200000}, {610,0.00200000}, {615,0.00200000}, {620,0.00200000}, {625,0.00200000}, {630,0.00200000}, {635,0.00200000}, {640,0.00200000}, {645,0.00200000}, {650,0.00200000}, {655,0.00203604}, {660,0.00200901}, {665,0.00200000}, {670,0.00200000}, {675,0.00200000}, {680,0.00200000}, {685,0.00200000}, {690,0.00200901}, {695,0.00207207}, {700,0.00201802}, {705,0.00201802}, {710,0.00202703}, {715,0.00209910}, {720,0.00209910}, {725,0.00210811}, {730,0.00218018}, {735,0.00227027}, {740,0.00460360}, {745,0.00242342}, {750,0.00248649}, {755,0.00255856}, {760,0.00270270}, {765,0.00265766}, {770,0.00272072}, {775,0.00280180}, {780,0.00282883}, {785,0.00290090}, {790,0.00289189}, {795,0.00295495}, {800,0.00300000}, {805,0.00299099}, {810,0.00300000}, {815,0.00300000}, {820,0.00300000}, {825,0.00300000}, {830,0.00300000}, {835,0.00300000}, {840,0.00300000}, {845,0.00300000}, {850,0.00300000}, {855,0.00300000}, {860,0.00300000}, {865,0.00300000}, {870,0.00300000}, {875,0.00300000}, {880,0.00300000}, {885,0.00300000}, {890,0.00300000}, {895,0.00300000}, {900,0.00300000}, {905,0.00300000}, {910,0.00300000}, {915,0.00300000}, {920,0.00300000}, {925,0.00300000}, {930,0.00300000}, {935,0.00300901}, {940,0.00300901}, {945,0.00300000}, {950,0.00301802}, {955,0.00300000}, {960,0.00300901}, {965,0.00302703}, {970,0.00301802}, {975,0.00301802}, {980,0.00306306}, {985,0.00305405}, {990,0.00312613}, {995,0.00313514}, {1000,0.00318919}, {1010,0.00327928}, {1020,0.00336937}, {1030,0.00356757}, {1040,0.00359459}, {1050,0.00369369}, {1060,0.00377477}, {1070,0.00381081}, {1080,0.00388288}, {1090,0.00394595}, {1100,0.00398198}, {1110,0.00400000}, {1120,0.00400000}, {1130,0.00400000}, {1140,0.00400000}, {1150,0.00406306}, {1160,0.00400000}, {1170,0.00400000}, {1180,0.00400000}, {1190,0.00400000}, {1200,0.00400000}, {1210,0.00408108}, {1220,0.00401802}, {1230,0.00401802}, {1240,0.00403604}, {1250,0.00403604}, {1260,0.00408108}, {1270,0.00421622}, {1280,0.00435135}, {1290,0.00439640}, {1300,0.00454955}, {1310,0.00454054}, {1320,0.00463063}, {1330,0.00433333}, {1340,0.00476577}, {1350,0.00477477}, {1360,0.00483784}, {1370,0.00489189}, {1380,0.00494595}, {1390,0.00852252}, {1400,0.00499099}, {1410,0.00500000}, {1420,0.00500000}, {1430,0.00500000}, {1440,0.00902703}, {1450,0.00501802}, {1460,0.00500000}, {1470,0.00933333}, {1480,0.00502703}, {1490,0.00502703}, {1500,0.00505405}, {1510,0.00504505}, {1520,0.00514414}, {1530,0.00512613}, {1540,0.00524324}, {1550,0.00536036}, {1560,0.00500000}, {1570,0.00549550}, {1580,0.00556757}, {1590,0.00559459}, {1600,0.00565766}, {1610,0.00566667}, {1620,0.00567568}, {1630,0.00573874}, {1640,0.00578378}, {1650,0.00583784}, {1660,0.00586486}, {1670,0.00591892}, {1680,0.00597297}, {1690,0.00600901}, {1700,0.00600000}, {1710,0.00600000}, {1720,0.00600000}, {1730,0.00600901}, {1740,0.00603604}, {1750,0.00606306}, {1760,0.00603604}, {1770,0.00610811}, {1780,0.00609910}, {1790,0.00617117}, {1800,0.00634234}, {1810,0.00634234}, {1820,0.00637838}, {1830,0.00644144}, {1840,0.00650450}, {1850,0.00655856}, {1860,0.00664865}, {1870,0.00669369}, {1880,0.00671171}, {1890,0.00672973}, {1900,0.00677477}, {1910,0.00683784}, {1920,0.00683784}, {1930,0.00687387}, {1940,0.00692793}, {1950,0.00692793}, {1960,0.00700901}, {1970,0.00700901}, {1980,0.00701802}, {1990,0.01272973}, {2000,0.00703604}, {2050,0.00716216}, {2100,0.00740541}, {2150,0.01174775}, {2200,0.01257658}, {2250,0.00809009}, {2300,0.00822523}, {2350,0.00850450}, {2400,0.00871171}, {2450,0.00880180}, {2500,0.00898198}, {2550,0.00916216}, {2600,0.00945045}, {2650,0.01473874}, {2700,0.00981081}, {2750,0.01453153}, {2800,0.01019820}, {2850,0.01036036}, {2900,0.01061261}, {2950,0.01081081}, {3000,0.01090090}, {3050,0.01110811}, {3100,0.01145946}, {3150,0.01172072}, {3200,0.01191892}, {3250,0.01741441}, {3300,0.01585586}, {3350,0.01264865}, {3400,0.01279279}, {3450,0.01303604}, {3500,0.01859459}, {3550,0.01336937}, {3600,0.01835135}, {3650,0.01398198}, {3700,0.01414414}, {3750,0.01449550}, {3800,0.01476577}, {3850,0.01478378}, {3900,0.01511712}, {3950,0.01527027}, {4000,0.01558559}, {4050,0.01594595}, {4100,0.01580180}, {4150,0.01627928}, {4200,0.01670270}, {4250,0.01673874}, {4300,0.01734234}, {4350,0.01746847}, {4400,0.01753153}, {4450,0.01790090}, {4500,0.01839640}, {4550,0.01867568}, {4600,0.01864865}, {4650,0.02325225}, {4700,0.01908108}, {4750,0.01994595}, {4800,0.02375676}, {4850,0.02591892}, {4900,0.02034234}, {4950,0.02663063}, {5000,0.02372072}, {5050,0.02157658}, {5100,0.02164865}, {5150,0.02236036}, {5200,0.02239640}, {5250,0.02283784}, {5300,0.02261261}, {5350,0.02296396}, {5400,0.02371171}, {5450,0.02426126}, {5500,0.02403604}, {5550,0.02464865}, {5600,0.02863063}, {5650,0.02520721}, {5700,0.02592793}, {5750,0.02663964}, {5800,0.04852252}, {5850,0.02676577}, {5900,0.02725225}, {5950,0.02763063}, {6000,0.02787387}, {6050,0.02500}, {6100,0.03925}, {6150,0.02500}, {6200,0.02475}, {6250,0.04025}, {6300,0.02475}, {6350,0.03125}, {6400,0.02825}, {6450,0.02650}, {6500,0.02575}, {6550,0.02650}, {6600,0.02925}, {6650,0.02725}, {6700,0.05075}, {6750,0.02825}, {6800,0.04550}, {6850,0.03225}, {6900,0.05100}, {6950,0.03175}, {7000,0.03050}, {7050,0.03100}, {7100,0.03125}, {7150,0.04300}, {7200,0.04850}, {7250,0.03300}, {7300,0.03550}, {7350,0.05025}, {7400,0.03500}, {7450,0.03650}, {7500,0.02525}, {7550,0.04425}, {7600,0.04800}, {7650,0.04400}, {7700,0.03625}, {7750,0.03700}, {7800,0.03900}, {7850,0.03550}, {7900,0.03775}, {7950,0.03950}, {8000,0.04600}, {8050,0.04200}, {8100,0.04050}, {8150,0.04325}, {8200,0.04400}, {8250,0.04275}, {8300,0.04700}, {8350,0.04150}, {8400,0.04125}, {8450,0.04125}, {8500,0.04275}, {8550,0.04075}, {8600,0.04225}, {8650,0.05275}, {8700,0.04375}, {8750,0.04550}, {8800,0.04475}, {8850,0.04575}, {8900,0.05175}, {8950,0.04575}, {9000,0.05325}, {9050,0.04800}, {9100,0.04775}, {9150,0.04750}, {9200,0.04850}, {9250,0.04700}, {9300,0.04625}, {9350,0.04825}, {9400,0.04775}, {9450,0.05175}, {9500,0.04850}, {9550,0.05450}, {9600,0.04900}, {9650,0.04925}, {9700,0.04875}, {9750,0.04925}, {9800,0.05225}, {9850,0.05250}, {9900,0.05350}, {9950,0.05900}, {10000,0.05425}, {10100,0.06125}, {10200,0.05450}, {10300,0.05550}, {10400,0.05675}, {10500,0.07125}, {10600,0.05775}, {10700,0.07600}, {10800,0.05775}, {10900,0.05950}, {11000,0.06925}, {11100,0.05825}, {11200,0.07550}, {11300,0.06125}, {11400,0.06175}, {11500,0.06175}, {11600,0.07275}, {11700,0.06400}, {11800,0.06875}, {11900,0.07575}, {12000,0.07025}, {12100,0.06625}, {12200,0.06600}, {12300,0.06500}, {12400,0.07425}, {12500,0.07075}, {12600,0.07525}, {12700,0.06975}, {12800,0.08450}, {12900,0.07050}, {13000,0.04725}, {13100,0.07200}, {13200,0.07175}, {13300,0.08200}, {13400,0.07200}, {13500,0.07300}, {13600,0.07350}, {13700,0.07400}, {13800,0.08100}, {13900,0.07525}, {14000,0.07500}, {14100,0.07700}, {14200,0.07675}, {14300,0.08300}, {14400,0.07825}, {14500,0.08400}, {14600,0.08950}, {14700,0.08775}, {14800,0.08275}, {14900,0.08075}, {15000,0.08075}, {15100,0.08550}, {15200,0.08350}, {15300,0.08800}, {15400,0.08350}, {15500,0.08925}, {15600,0.09775}, {15700,0.08500}, {15800,0.09300}, {15900,0.08675}, {16000,0.08600}, {16100,0.08800}, {16200,0.08975}, {16300,0.06350}, {16400,0.08825}, {16500,0.08950}, {16600,0.08875}, {16700,0.09425}, {16800,0.09275}, {16900,0.11050}, {17000,0.09550}, {17100,0.09250}, {17200,0.09075}, {17300,0.09550}, {17400,0.09250}, {17500,0.09525}, {17600,0.09850}, {17700,0.09550}, {17800,0.09425}, {17900,0.09500}, {18000,0.09750}, {18100,0.11700}, {18200,0.09700}, {18300,0.09550}, {18400,0.07125}, {18500,0.09400}, {18600,0.10125}, {18700,0.12075}, {18800,0.10200}, {18900,0.10200}, {19000,0.10250}, {19100,0.12475}, {19200,0.10975}, {19300,0.10475}, {19400,0.10450}, {19500,0.10625}, {19600,0.10675}, {19700,0.12575}, {19800,0.10850}, {19900,0.08750}, {20000,0.1015}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["pre"]["user"] = {{1,0.00022523}, {2,0.00030631}, {3,0.00026126}, {4,0.00040541}, {5,0.00035135}, {6,0.00027928}, {7,0.00029730}, {8,0.00055856}, {9,0.00018018}, {10,0.00029730}, {11,0.00028829}, {12,0.00016216}, {13,0.00023423}, {14,0.00021622}, {15,0.00047748}, {16,0.00036937}, {17,0.00039640}, {18,0.00040541}, {19,0.00034234}, {20,0.00037838}, {21,0.00034234}, {22,0.00029730}, {23,0.00035135}, {24,0.00048649}, {25,0.00045946}, {26,0.00036036}, {27,0.00032432}, {28,0.00041441}, {29,0.00039640}, {30,0.00046847}, {31,0.00030631}, {32,0.00045045}, {33,0.00036036}, {34,0.00029730}, {35,0.00038739}, {36,0.00031532}, {37,0.00053153}, {38,0.00043243}, {39,0.00041441}, {40,0.00033333}, {41,0.00031532}, {42,0.00045946}, {43,0.00061261}, {44,0.00038739}, {45,0.00046847}, {46,0.00054955}, {47,0.00049550}, {48,0.00047748}, {49,0.00032432}, {50,0.00028829}, {51,0.00030631}, {52,0.00058559}, {53,0.00041441}, {54,0.00020721}, {55,0.00050450}, {56,0.00021622}, {57,0.00078378}, {58,0.00057658}, {59,0.00047748}, {60,0.00070270}, {61,0.00034234}, {62,0.00036937}, {63,0.00048649}, {64,0.00039640}, {65,0.00054054}, {66,0.00072072}, {67,0.00055856}, {68,0.00054054}, {69,0.00054955}, {70,0.00043243}, {71,0.00041441}, {72,0.00052252}, {73,0.00044144}, {74,0.00060360}, {75,0.00036036}, {76,0.00050450}, {77,0.00044144}, {78,0.00056757}, {79,0.00054054}, {80,0.00046847}, {81,0.00056757}, {82,0.00054955}, {83,0.00052252}, {84,0.00038739}, {85,0.00054955}, {86,0.00075676}, {87,0.00056757}, {88,0.00073874}, {89,0.00111712}, {90,0.00060360}, {91,0.00049550}, {92,0.00068468}, {93,0.00059459}, {94,0.00035135}, {95,0.00055856}, {96,0.00091892}, {97,0.00037838}, {98,0.00053153}, {99,0.00073874}, {100,0.00081982}, {101,0.00064865}, {102,0.00040541}, {103,0.00063964}, {104,0.00036036}, {105,0.00086486}, {106,0.00038739}, {107,0.00061261}, {108,0.00064865}, {109,0.00049550}, {110,0.00055856}, {111,0.00055856}, {112,0.00045946}, {113,0.00056757}, {114,0.00059459}, {115,0.00047748}, {116,0.00048649}, {117,0.00073874}, {118,0.00062162}, {119,0.00052252}, {120,0.00068468}, {121,0.00081081}, {122,0.00068468}, {123,0.00066667}, {124,0.00063964}, {125,0.00063063}, {126,0.00080180}, {127,0.00076577}, {128,0.00063063}, {129,0.00070270}, {130,0.00073874}, {131,0.00086486}, {132,0.00069369}, {133,0.00067568}, {134,0.00059459}, {135,0.00056757}, {136,0.00060360}, {137,0.00085586}, {138,0.00086486}, {139,0.00070270}, {140,0.00054054}, {141,0.00073874}, {142,0.00081081}, {143,0.00074775}, {144,0.00089189}, {145,0.00076577}, {146,0.00078378}, {147,0.00076577}, {148,0.00069369}, {149,0.00081081}, {150,0.00063063}, {151,0.00078378}, {152,0.00080180}, {153,0.00069369}, {154,0.00062162}, {155,0.00052252}, {156,0.00100000}, {157,0.00059459}, {158,0.00063964}, {159,0.00072973}, {160,0.00087387}, {161,0.00093694}, {162,0.00094595}, {163,0.00079279}, {164,0.00054054}, {165,0.00080180}, {166,0.00063964}, {167,0.00096396}, {168,0.00099099}, {169,0.00073874}, {170,0.00069369}, {171,0.00082883}, {172,0.00065766}, {173,0.00085586}, {174,0.00095495}, {175,0.00082883}, {176,0.00074775}, {177,0.00071171}, {178,0.00066667}, {179,0.00061261}, {180,0.00092793}, {181,0.00079279}, {182,0.00074775}, {183,0.00078378}, {184,0.00100901}, {185,0.00092793}, {186,0.00083784}, {187,0.00084685}, {188,0.00091892}, {189,0.00057658}, {190,0.00067568}, {191,0.00081081}, {192,0.00085586}, {193,0.00091892}, {194,0.00084685}, {195,0.00082883}, {196,0.00076577}, {197,0.00075676}, {198,0.00086486}, {199,0.00079279}, {200,0.00079279}, {201,0.00082883}, {202,0.00087387}, {203,0.00079279}, {204,0.00081081}, {205,0.00084685}, {206,0.00081982}, {207,0.00086486}, {208,0.00090991}, {209,0.00097297}, {210,0.00060360}, {211,0.00072072}, {212,0.00089189}, {213,0.00097297}, {214,0.00072072}, {215,0.00065766}, {216,0.00093694}, {217,0.00090991}, {218,0.00085586}, {219,0.00090090}, {220,0.00095495}, {221,0.00106306}, {222,0.00090090}, {223,0.00080180}, {224,0.00081081}, {225,0.00118919}, {226,0.00092793}, {227,0.00100901}, {228,0.00084685}, {229,0.00081081}, {230,0.00087387}, {231,0.00108108}, {232,0.00086486}, {233,0.00093694}, {234,0.00097297}, {235,0.00091892}, {236,0.00081982}, {237,0.00091892}, {238,0.00114414}, {239,0.00087387}, {240,0.00099099}, {241,0.00106306}, {242,0.00093694}, {243,0.00111712}, {244,0.00090090}, {245,0.00107207}, {246,0.00090090}, {247,0.00096396}, {248,0.00109910}, {249,0.00097297}, {250,0.00081982}, {251,0.00127928}, {252,0.00094595}, {253,0.00104505}, {254,0.00109910}, {255,0.00109009}, {256,0.00083784}, {257,0.00114414}, {258,0.00107207}, {259,0.00122523}, {260,0.00100901}, {261,0.00106306}, {262,0.00109009}, {263,0.00117117}, {264,0.00093694}, {265,0.00118919}, {266,0.00095495}, {267,0.00106306}, {268,0.00117117}, {269,0.00119820}, {270,0.00099099}, {271,0.00094595}, {272,0.00095495}, {273,0.00115315}, {274,0.00112613}, {275,0.00109910}, {276,0.00111712}, {277,0.00110811}, {278,0.00131532}, {279,0.00117117}, {280,0.00090090}, {281,0.00095495}, {282,0.00131532}, {283,0.00101802}, {284,0.00115315}, {285,0.00108108}, {286,0.00105405}, {287,0.00098198}, {288,0.00088288}, {289,0.00102703}, {290,0.00123423}, {291,0.00102703}, {292,0.00089189}, {293,0.00118919}, {294,0.00117117}, {295,0.00112613}, {296,0.00131532}, {297,0.00117117}, {298,0.00127027}, {299,0.00118919}, {300,0.00104505}, {301,0.00120721}, {302,0.00116216}, {303,0.00127928}, {304,0.00121622}, {305,0.00105405}, {306,0.00136937}, {307,0.00130631}, {308,0.00117117}, {309,0.00098198}, {310,0.00111712}, {311,0.00134234}, {312,0.00114414}, {313,0.00122523}, {314,0.00117117}, {315,0.00118018}, {316,0.00114414}, {317,0.00101802}, {318,0.00118018}, {319,0.00103604}, {320,0.00129730}, {321,0.00110811}, {322,0.00109910}, {323,0.00124324}, {324,0.00135135}, {325,0.00124324}, {326,0.00124324}, {327,0.00109009}, {328,0.00120721}, {329,0.00108108}, {330,0.00149550}, {331,0.00137838}, {332,0.00132432}, {333,0.00115315}, {334,0.00145946}, {335,0.00120721}, {336,0.00143243}, {337,0.00159459}, {338,0.00116216}, {339,0.00169369}, {340,0.00136036}, {341,0.00136937}, {342,0.00134234}, {343,0.00161261}, {344,0.00147748}, {345,0.00135135}, {346,0.00163063}, {347,0.00149550}, {348,0.00122523}, {349,0.00139640}, {350,0.00152252}, {351,0.00122523}, {352,0.00172072}, {353,0.00163964}, {354,0.00159459}, {355,0.00133333}, {356,0.00139640}, {357,0.00124324}, {358,0.00108108}, {359,0.00143243}, {360,0.00152252}, {361,0.00133333}, {362,0.00145946}, {363,0.00136036}, {364,0.00177477}, {365,0.00129730}, {366,0.00178378}, {367,0.00130631}, {368,0.00145946}, {369,0.00131532}, {370,0.00121622}, {371,0.00137838}, {372,0.00151351}, {373,0.00159459}, {374,0.00172973}, {375,0.00116216}, {376,0.00127027}, {377,0.00141441}, {378,0.00150450}, {379,0.00164865}, {380,0.00163063}, {381,0.00154955}, {382,0.00139640}, {383,0.00196396}, {384,0.00118018}, {385,0.00133333}, {386,0.00155856}, {387,0.00157658}, {388,0.00168468}, {389,0.00137838}, {390,0.00181081}, {391,0.00136036}, {392,0.00183784}, {393,0.00159459}, {394,0.00162162}, {395,0.00144144}, {396,0.00160360}, {397,0.00148649}, {398,0.00170270}, {399,0.00175676}, {400,0.00113514}, {401,0.00139640}, {402,0.00166667}, {403,0.00136937}, {404,0.00162162}, {405,0.00162162}, {406,0.00167568}, {407,0.00144144}, {408,0.00175676}, {409,0.00139640}, {410,0.00191892}, {411,0.00158559}, {412,0.00172973}, {413,0.00147748}, {414,0.00140541}, {415,0.00158559}, {416,0.00295495}, {417,0.00189189}, {418,0.00141441}, {419,0.00176577}, {420,0.00181982}, {421,0.00159459}, {422,0.00170270}, {423,0.00138739}, {424,0.00190991}, {425,0.00154054}, {426,0.00158559}, {427,0.00136036}, {428,0.00149550}, {429,0.00164865}, {430,0.00170270}, {431,0.00200901}, {432,0.00176577}, {433,0.00182883}, {434,0.00200901}, {435,0.00204505}, {436,0.00158559}, {437,0.00168468}, {438,0.00163964}, {439,0.00137838}, {440,0.00190090}, {441,0.00184685}, {442,0.00173874}, {443,0.00143243}, {444,0.00201802}, {445,0.00184685}, {446,0.00169369}, {447,0.00160360}, {448,0.00163964}, {449,0.00180180}, {450,0.00181982}, {451,0.00179279}, {452,0.00173874}, {453,0.00162162}, {454,0.00160360}, {455,0.00208108}, {456,0.00204505}, {457,0.00162162}, {458,0.00172072}, {459,0.00194595}, {460,0.00172973}, {461,0.00172973}, {462,0.00176577}, {463,0.00168468}, {464,0.00168468}, {465,0.00175676}, {466,0.00165766}, {467,0.00151351}, {468,0.00195495}, {469,0.00180180}, {470,0.00174775}, {471,0.00196396}, {472,0.00149550}, {473,0.00188288}, {474,0.00172973}, {475,0.00179279}, {476,0.00184685}, {477,0.00227928}, {478,0.00217117}, {479,0.00178378}, {480,0.00167568}, {481,0.00180180}, {482,0.00162162}, {483,0.00196396}, {484,0.00172072}, {485,0.00194595}, {486,0.00184685}, {487,0.00190991}, {488,0.00165766}, {489,0.00171171}, {490,0.00190991}, {491,0.00167568}, {492,0.00181982}, {493,0.00211712}, {494,0.00196396}, {495,0.00191892}, {496,0.00183784}, {497,0.00190991}, {498,0.00180180}, {499,0.00194595}, {500,0.00192793}, {505,0.00190991}, {510,0.00191892}, {515,0.00193694}, {520,0.00185586}, {525,0.00181081}, {530,0.00200000}, {535,0.00182883}, {540,0.00200901}, {545,0.00195495}, {550,0.00189189}, {555,0.00217117}, {560,0.00193694}, {565,0.00224324}, {570,0.00221622}, {575,0.00200901}, {580,0.00229730}, {585,0.00221622}, {590,0.00213514}, {595,0.00221622}, {600,0.00218919}, {605,0.00254955}, {610,0.00240541}, {615,0.00217117}, {620,0.00208108}, {625,0.00222523}, {630,0.00222523}, {635,0.00211712}, {640,0.00220721}, {645,0.00232432}, {650,0.00235135}, {655,0.00245045}, {660,0.00211712}, {665,0.00204505}, {670,0.00207207}, {675,0.00227928}, {680,0.00242342}, {685,0.00220721}, {690,0.00218919}, {695,0.00230631}, {700,0.00193694}, {705,0.00201802}, {710,0.00232432}, {715,0.00225225}, {720,0.00221622}, {725,0.00238739}, {730,0.00248649}, {735,0.00229730}, {740,0.00424324}, {745,0.00262162}, {750,0.00261261}, {755,0.00245946}, {760,0.00249550}, {765,0.00260360}, {770,0.00262162}, {775,0.00259459}, {780,0.00253153}, {785,0.00280180}, {790,0.00267568}, {795,0.00273874}, {800,0.00278378}, {805,0.00279279}, {810,0.00298198}, {815,0.00279279}, {820,0.00270270}, {825,0.00300901}, {830,0.00278378}, {835,0.00283784}, {840,0.00269369}, {845,0.00284685}, {850,0.00276577}, {855,0.00264865}, {860,0.00284685}, {865,0.00308108}, {870,0.00291892}, {875,0.00273874}, {880,0.00252252}, {885,0.00268468}, {890,0.00304505}, {895,0.00298198}, {900,0.00302703}, {905,0.00279279}, {910,0.00290090}, {915,0.00309009}, {920,0.00301802}, {925,0.00297297}, {930,0.00305405}, {935,0.00309910}, {940,0.00302703}, {945,0.00292793}, {950,0.00309009}, {955,0.00308108}, {960,0.00322523}, {965,0.00317117}, {970,0.00330631}, {975,0.00313514}, {980,0.00324324}, {985,0.00314414}, {990,0.00322523}, {995,0.00324324}, {1000,0.00318018}, {1010,0.00326126}, {1020,0.00337838}, {1030,0.00324324}, {1040,0.00328829}, {1050,0.00329730}, {1060,0.00328829}, {1070,0.00350450}, {1080,0.00363063}, {1090,0.00371171}, {1100,0.00345946}, {1110,0.00367568}, {1120,0.00351351}, {1130,0.00351351}, {1140,0.00363063}, {1150,0.00384685}, {1160,0.00397297}, {1170,0.00404505}, {1180,0.00408108}, {1190,0.00395495}, {1200,0.00387387}, {1210,0.00406306}, {1220,0.00427928}, {1230,0.00384685}, {1240,0.00392793}, {1250,0.00430631}, {1260,0.00424324}, {1270,0.00439640}, {1280,0.00442342}, {1290,0.00391892}, {1300,0.00463063}, {1310,0.00454054}, {1320,0.00445946}, {1330,0.00439640}, {1340,0.00452252}, {1350,0.00465766}, {1360,0.00472973}, {1370,0.00468468}, {1380,0.00452252}, {1390,0.00862162}, {1400,0.00500901}, {1410,0.00492793}, {1420,0.00486486}, {1430,0.00456757}, {1440,0.00909910}, {1450,0.00515315}, {1460,0.00469369}, {1470,0.00961261}, {1480,0.00504505}, {1490,0.00498198}, {1500,0.00500901}, {1510,0.00519820}, {1520,0.00544144}, {1530,0.00549550}, {1540,0.00517117}, {1550,0.00585586}, {1560,0.00503604}, {1570,0.00563063}, {1580,0.00529730}, {1590,0.00573874}, {1600,0.00563964}, {1610,0.00562162}, {1620,0.00566667}, {1630,0.00561261}, {1640,0.00570270}, {1650,0.00511712}, {1660,0.00581081}, {1670,0.00565766}, {1680,0.00565766}, {1690,0.00579279}, {1700,0.00607207}, {1710,0.00599099}, {1720,0.00607207}, {1730,0.00634234}, {1740,0.00613514}, {1750,0.00601802}, {1760,0.00627928}, {1770,0.00617117}, {1780,0.00578378}, {1790,0.00617117}, {1800,0.00590090}, {1810,0.00617117}, {1820,0.00657658}, {1830,0.00640541}, {1840,0.00645045}, {1850,0.00639640}, {1860,0.00642342}, {1870,0.00629730}, {1880,0.00638739}, {1890,0.00667568}, {1900,0.00641441}, {1910,0.00672072}, {1920,0.00689189}, {1930,0.00692793}, {1940,0.00683784}, {1950,0.00691892}, {1960,0.00686486}, {1970,0.00670270}, {1980,0.00677477}, {1990,0.01315315}, {2000,0.00709009}, {2050,0.00701802}, {2100,0.00718018}, {2150,0.01234234}, {2200,0.01264865}, {2250,0.00800901}, {2300,0.00800901}, {2350,0.00818018}, {2400,0.00874775}, {2450,0.00908108}, {2500,0.00874775}, {2550,0.00954955}, {2600,0.00934234}, {2650,0.01489189}, {2700,0.01012613}, {2750,0.01477477}, {2800,0.01031532}, {2850,0.01081982}, {2900,0.01077477}, {2950,0.01126126}, {3000,0.01115315}, {3050,0.01176577}, {3100,0.01194595}, {3150,0.01196396}, {3200,0.01227027}, {3250,0.01748649}, {3300,0.01604505}, {3350,0.01286486}, {3400,0.01317117}, {3450,0.01353153}, {3500,0.01840541}, {3550,0.01384685}, {3600,0.01809009}, {3650,0.01391892}, {3700,0.01448649}, {3750,0.01462162}, {3800,0.01491892}, {3850,0.01525225}, {3900,0.01517117}, {3950,0.01510811}, {4000,0.01566667}, {4050,0.01610811}, {4100,0.01590991}, {4150,0.01652252}, {4200,0.01690090}, {4250,0.01655856}, {4300,0.01742342}, {4350,0.01754054}, {4400,0.01774775}, {4450,0.01765766}, {4500,0.01844144}, {4550,0.01874775}, {4600,0.01837838}, {4650,0.02365766}, {4700,0.01904505}, {4750,0.01995495}, {4800,0.02403604}, {4850,0.02615315}, {4900,0.02043243}, {4950,0.02665766}, {5000,0.02411712}, {5050,0.02164865}, {5100,0.02190991}, {5150,0.02218018}, {5200,0.02236937}, {5250,0.02309910}, {5300,0.02267568}, {5350,0.02291892}, {5400,0.02396396}, {5450,0.02443243}, {5500,0.02422523}, {5550,0.02500901}, {5600,0.02899099}, {5650,0.02545946}, {5700,0.02596396}, {5750,0.02659459}, {5800,0.04810811}, {5850,0.02689189}, {5900,0.02720721}, {5950,0.02767568}, {6000,0.02788288}, {6050,0.02550}, {6100,0.03800}, {6150,0.02575}, {6200,0.02325}, {6250,0.03925}, {6300,0.02350}, {6350,0.03075}, {6400,0.02800}, {6450,0.02775}, {6500,0.02775}, {6550,0.02750}, {6600,0.03050}, {6650,0.02850}, {6700,0.05125}, {6750,0.02850}, {6800,0.04550}, {6850,0.03275}, {6900,0.05050}, {6950,0.03125}, {7000,0.02900}, {7050,0.03050}, {7100,0.03150}, {7150,0.04300}, {7200,0.04825}, {7250,0.03225}, {7300,0.03500}, {7350,0.05050}, {7400,0.03475}, {7450,0.03750}, {7500,0.02650}, {7550,0.04425}, {7600,0.04850}, {7650,0.04450}, {7700,0.03700}, {7750,0.03525}, {7800,0.03950}, {7850,0.03550}, {7900,0.03875}, {7950,0.04050}, {8000,0.04800}, {8050,0.04250}, {8100,0.04025}, {8150,0.04225}, {8200,0.04450}, {8250,0.04150}, {8300,0.04750}, {8350,0.04100}, {8400,0.04200}, {8450,0.04050}, {8500,0.04150}, {8550,0.03975}, {8600,0.04150}, {8650,0.05175}, {8700,0.04250}, {8750,0.04475}, {8800,0.04350}, {8850,0.04625}, {8900,0.05250}, {8950,0.04525}, {9000,0.05225}, {9050,0.04775}, {9100,0.04650}, {9150,0.04750}, {9200,0.04875}, {9250,0.04750}, {9300,0.04550}, {9350,0.04975}, {9400,0.04900}, {9450,0.05125}, {9500,0.04875}, {9550,0.05325}, {9600,0.04875}, {9650,0.04975}, {9700,0.04925}, {9750,0.04900}, {9800,0.05250}, {9850,0.05325}, {9900,0.05250}, {9950,0.05900}, {10000,0.05450}, {10100,0.06150}, {10200,0.05450}, {10300,0.05675}, {10400,0.05775}, {10500,0.06950}, {10600,0.05775}, {10700,0.07600}, {10800,0.05675}, {10900,0.06050}, {11000,0.07175}, {11100,0.05800}, {11200,0.07675}, {11300,0.06150}, {11400,0.06150}, {11500,0.06175}, {11600,0.07275}, {11700,0.06425}, {11800,0.07000}, {11900,0.07525}, {12000,0.06975}, {12100,0.06600}, {12200,0.06775}, {12300,0.06600}, {12400,0.07625}, {12500,0.07075}, {12600,0.07550}, {12700,0.06850}, {12800,0.08475}, {12900,0.07050}, {13000,0.04800}, {13100,0.07350}, {13200,0.07200}, {13300,0.08150}, {13400,0.07200}, {13500,0.07425}, {13600,0.07350}, {13700,0.07450}, {13800,0.08050}, {13900,0.07450}, {14000,0.07575}, {14100,0.07600}, {14200,0.07625}, {14300,0.08350}, {14400,0.07725}, {14500,0.08475}, {14600,0.08925}, {14700,0.08725}, {14800,0.08350}, {14900,0.07925}, {15000,0.08050}, {15100,0.08550}, {15200,0.08500}, {15300,0.08725}, {15400,0.08475}, {15500,0.08950}, {15600,0.09775}, {15700,0.08600}, {15800,0.09350}, {15900,0.08700}, {16000,0.08625}, {16100,0.08875}, {16200,0.08950}, {16300,0.06375}, {16400,0.08775}, {16500,0.09125}, {16600,0.08850}, {16700,0.09475}, {16800,0.09150}, {16900,0.11075}, {17000,0.09575}, {17100,0.09125}, {17200,0.09000}, {17300,0.09600}, {17400,0.09250}, {17500,0.09575}, {17600,0.09975}, {17700,0.09575}, {17800,0.09600}, {17900,0.09450}, {18000,0.09750}, {18100,0.11700}, {18200,0.09800}, {18300,0.09575}, {18400,0.07200}, {18500,0.09350}, {18600,0.10050}, {18700,0.12250}, {18800,0.10350}, {18900,0.10225}, {19000,0.10350}, {19100,0.12400}, {19200,0.11000}, {19300,0.10425}, {19400,0.10425}, {19500,0.10675}, {19600,0.10775}, {19700,0.12600}, {19800,0.10850}, {19900,0.08800}, {20000,0.1030}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["pre"]["system"] = {{1,0.00010811}, {2,0.00000000}, {3,0.00000000}, {4,0.00003604}, {5,0.00000000}, {6,0.00000000}, {7,0.00003604}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00002703}, {15,0.00000000}, {16,0.00003604}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00002703}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00002703}, {42,0.00000000}, {43,0.00000000}, {44,0.00003604}, {45,0.00000000}, {46,0.00003604}, {47,0.00003604}, {48,0.00000000}, {49,0.00000000}, {50,0.00003604}, {51,0.00003604}, {52,0.00003604}, {53,0.00003604}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00003604}, {65,0.00000000}, {66,0.00003604}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00007207}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00003604}, {83,0.00000000}, {84,0.00000000}, {85,0.00003604}, {86,0.00003604}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00002703}, {95,0.00000000}, {96,0.00000000}, {97,0.00003604}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00002703}, {103,0.00000000}, {104,0.00002703}, {105,0.00013514}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00002703}, {114,0.00002703}, {115,0.00003604}, {116,0.00000000}, {117,0.00003604}, {118,0.00007207}, {119,0.00000000}, {120,0.00003604}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00003604}, {125,0.00000000}, {126,0.00000000}, {127,0.00003604}, {128,0.00000000}, {129,0.00003604}, {130,0.00000000}, {131,0.00003604}, {132,0.00000000}, {133,0.00006306}, {134,0.00000000}, {135,0.00000000}, {136,0.00003604}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00007207}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00006306}, {151,0.00003604}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00003604}, {156,0.00003604}, {157,0.00003604}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00003604}, {165,0.00003604}, {166,0.00000000}, {167,0.00000000}, {168,0.00003604}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00003604}, {175,0.00000000}, {176,0.00003604}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00003604}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00003604}, {189,0.00000000}, {190,0.00000000}, {191,0.00006306}, {192,0.00000000}, {193,0.00003604}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00003604}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00003604}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00002703}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00003604}, {237,0.00000000}, {238,0.00000000}, {239,0.00002703}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00003604}, {244,0.00003604}, {245,0.00000000}, {246,0.00003604}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00003604}, {251,0.00000000}, {252,0.00000000}, {253,0.00003604}, {254,0.00000000}, {255,0.00000000}, {256,0.00003604}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00003604}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00003604}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00003604}, {272,0.00000000}, {273,0.00000000}, {274,0.00007207}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00003604}, {279,0.00003604}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00007207}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00003604}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00003604}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00002703}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00003604}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00003604}, {326,0.00003604}, {327,0.00000000}, {328,0.00003604}, {329,0.00000000}, {330,0.00003604}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00002703}, {335,0.00000000}, {336,0.00000000}, {337,0.00003604}, {338,0.00000000}, {339,0.00003604}, {340,0.00000000}, {341,0.00000000}, {342,0.00003604}, {343,0.00000000}, {344,0.00003604}, {345,0.00000000}, {346,0.00000000}, {347,0.00003604}, {348,0.00000000}, {349,0.00000000}, {350,0.00003604}, {351,0.00000000}, {352,0.00003604}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00003604}, {358,0.00000000}, {359,0.00003604}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00003604}, {368,0.00000000}, {369,0.00000000}, {370,0.00002703}, {371,0.00000000}, {372,0.00000000}, {373,0.00007207}, {374,0.00000000}, {375,0.00000000}, {376,0.00003604}, {377,0.00000000}, {378,0.00003604}, {379,0.00003604}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00006306}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00003604}, {388,0.00000000}, {389,0.00000000}, {390,0.00003604}, {391,0.00003604}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00003604}, {397,0.00003604}, {398,0.00000000}, {399,0.00000000}, {400,0.00002703}, {401,0.00000000}, {402,0.00000000}, {403,0.00003604}, {404,0.00003604}, {405,0.00000000}, {406,0.00003604}, {407,0.00000000}, {408,0.00003604}, {409,0.00000000}, {410,0.00000000}, {411,0.00003604}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00002703}, {421,0.00003604}, {422,0.00002703}, {423,0.00000000}, {424,0.00000000}, {425,0.00003604}, {426,0.00003604}, {427,0.00014414}, {428,0.00003604}, {429,0.00003604}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00003604}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00003604}, {444,0.00000000}, {445,0.00000000}, {446,0.00002703}, {447,0.00003604}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00003604}, {452,0.00003604}, {453,0.00000000}, {454,0.00003604}, {455,0.00000000}, {456,0.00000000}, {457,0.00002703}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00003604}, {473,0.00000000}, {474,0.00003604}, {475,0.00003604}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00003604}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00003604}, {489,0.00000000}, {490,0.00003604}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00003604}, {495,0.00003604}, {496,0.00000000}, {497,0.00000000}, {498,0.00003604}, {499,0.00000000}, {500,0.00007207}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00003604}, {530,0.00000000}, {535,0.00003604}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00003604}, {570,0.00003604}, {575,0.00000000}, {580,0.00000000}, {585,0.00003604}, {590,0.00000000}, {595,0.00000000}, {600,0.00003604}, {605,0.00000000}, {610,0.00007207}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00003604}, {640,0.00003604}, {645,0.00002703}, {650,0.00000000}, {655,0.00000000}, {660,0.00002703}, {665,0.00007207}, {670,0.00002703}, {675,0.00002703}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00003604}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00003604}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00003604}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00002703}, {830,0.00003604}, {835,0.00000000}, {840,0.00003604}, {845,0.00000000}, {850,0.00003604}, {855,0.00002703}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00003604}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00007207}, {920,0.00000000}, {925,0.00003604}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00003604}, {950,0.00000000}, {955,0.00003604}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00003604}, {985,0.00003604}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00003604}, {1040,0.00000000}, {1050,0.00003604}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00003604}, {1100,0.00000000}, {1110,0.00007207}, {1120,0.00000000}, {1130,0.00003604}, {1140,0.00000000}, {1150,0.00003604}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00003604}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00002703}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00003604}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00003604}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00003604}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00003604}, {1430,0.00000000}, {1440,0.00007207}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00007207}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00003604}, {1510,0.00003604}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00003604}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00003604}, {1580,0.00000000}, {1590,0.00003604}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00002703}, {1670,0.00007207}, {1680,0.00000000}, {1690,0.00006306}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00003604}, {1730,0.00003604}, {1740,0.00003604}, {1750,0.00003604}, {1760,0.00003604}, {1770,0.00003604}, {1780,0.00000000}, {1790,0.00002703}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00003604}, {1830,0.00000000}, {1840,0.00003604}, {1850,0.00000000}, {1860,0.00003604}, {1870,0.00010811}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00003604}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00003604}, {1960,0.00000000}, {1970,0.00003604}, {1980,0.00000000}, {1990,0.00003604}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00002703}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00003604}, {2550,0.00003604}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00003604}, {2850,0.00000000}, {2900,0.00003604}, {2950,0.00003604}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00006306}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00007207}, {3450,0.00003604}, {3500,0.00000000}, {3550,0.00002703}, {3600,0.00006306}, {3650,0.00010811}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00003604}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00003604}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00003604}, {4500,0.00000000}, {4550,0.00003604}, {4600,0.00000000}, {4650,0.00007207}, {4700,0.00003604}, {4750,0.00000000}, {4800,0.00007207}, {4850,0.00000000}, {4900,0.00003604}, {4950,0.00003604}, {5000,0.00007207}, {5050,0.00000000}, {5100,0.00003604}, {5150,0.00007207}, {5200,0.00003604}, {5250,0.00000000}, {5300,0.00002703}, {5350,0.00000000}, {5400,0.00002703}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00003604}, {5650,0.00000000}, {5700,0.00003604}, {5750,0.00003604}, {5800,0.00039640}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00100}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00100}, {16800,0.00100}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00100}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00005405}, {9,0.00070270}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00100000}, {16,0.01522523}, {17,0.00119820}, {18,0.00100000}, {19,0.00100000}, {20,0.00101802}, {21,0.00115315}, {22,0.00132432}, {23,0.00197297}, {24,0.00200000}, {25,0.00200000}, {26,0.00200000}, {27,0.00200000}, {28,0.00200000}, {29,0.00200000}, {30,0.00298198}, {31,0.00200000}, {32,0.00200000}, {33,0.00207207}, {34,0.00211712}, {35,0.00218018}, {36,0.00230631}, {37,0.00297297}, {38,0.00300000}, {39,0.00300000}, {40,0.00300000}, {41,0.00300000}, {42,0.00300000}, {43,0.00300000}, {44,0.00300000}, {45,0.00304505}, {46,0.00308108}, {47,0.00313514}, {48,0.00312613}, {49,0.00318018}, {50,0.00327928}, {51,0.00398198}, {52,0.00400000}, {53,0.00400901}, {54,0.00400000}, {55,0.00400000}, {56,0.00400000}, {57,0.00400901}, {58,0.00404505}, {59,0.00408108}, {60,0.00407207}, {61,0.00406306}, {62,0.00419820}, {63,0.00436937}, {64,0.00427928}, {65,0.00515315}, {66,0.00499099}, {67,0.00500000}, {68,0.00500901}, {69,0.00500901}, {70,0.00503604}, {71,0.00507207}, {72,0.00504505}, {73,0.00502703}, {74,0.00505405}, {75,0.00509910}, {76,0.00510811}, {77,0.00527027}, {78,0.00582883}, {79,0.00600000}, {80,0.00600000}, {81,0.00600000}, {82,0.00600901}, {83,0.00605405}, {84,0.00602703}, {85,0.00601802}, {86,0.00608108}, {87,0.00609009}, {88,0.00607207}, {89,0.00610811}, {90,0.00617117}, {91,0.00666667}, {92,0.00670270}, {93,0.00701802}, {94,0.00791892}, {95,0.00704505}, {96,0.00701802}, {97,0.00705405}, {98,0.00705405}, {99,0.00799099}, {100,0.00704505}, {101,0.00705405}, {102,0.00708108}, {103,0.00725225}, {104,0.00709910}, {105,0.00746847}, {106,0.00784685}, {107,0.00800901}, {108,0.00801802}, {109,0.00801802}, {110,0.00804505}, {111,0.00804505}, {112,0.00808108}, {113,0.00807207}, {114,0.00809009}, {115,0.00808108}, {116,0.00809910}, {117,0.00910811}, {118,0.00846847}, {119,0.00891892}, {120,0.00871171}, {121,0.00996396}, {122,0.00902703}, {123,0.00904505}, {124,0.00902703}, {125,0.01000901}, {126,0.00903604}, {127,0.00907207}, {128,0.00910811}, {129,0.01007207}, {130,0.00909910}, {131,0.00924324}, {132,0.00935135}, {133,0.00977477}, {134,0.00994595}, {135,0.01000901}, {136,0.01000901}, {137,0.01002703}, {138,0.01002703}, {139,0.01010811}, {140,0.01114414}, {141,0.01008108}, {142,0.01016216}, {143,0.01028829}, {144,0.01015315}, {145,0.01026126}, {146,0.01054054}, {147,0.01197297}, {148,0.01091892}, {149,0.01104505}, {150,0.01103604}, {151,0.01105405}, {152,0.01105405}, {153,0.01103604}, {154,0.01109009}, {155,0.01111712}, {156,0.01117117}, {157,0.01227928}, {158,0.01162162}, {159,0.01192793}, {160,0.01293694}, {161,0.01178378}, {162,0.01191892}, {163,0.01309009}, {164,0.01200901}, {165,0.01204505}, {166,0.01207207}, {167,0.01209910}, {168,0.01209009}, {169,0.01214414}, {170,0.01213514}, {171,0.01254955}, {172,0.01238739}, {173,0.01288288}, {174,0.01294595}, {175,0.01416216}, {176,0.01287387}, {177,0.01301802}, {178,0.01421622}, {179,0.01302703}, {180,0.01309009}, {181,0.01424324}, {182,0.01317117}, {183,0.01342342}, {184,0.01317117}, {185,0.01336937}, {186,0.01363063}, {187,0.01400000}, {188,0.01395495}, {189,0.01405405}, {190,0.01407207}, {191,0.01409009}, {192,0.01491892}, {193,0.01400000}, {194,0.01402703}, {195,0.01407207}, {196,0.01410811}, {197,0.01586486}, {198,0.01418919}, {199,0.01475676}, {200,0.01428829}, {201,0.01468468}, {202,0.01487387}, {203,0.01502703}, {204,0.01500000}, {205,0.01623423}, {206,0.01506306}, {207,0.01512613}, {208,0.01512613}, {209,0.01510811}, {210,0.01672072}, {211,0.01536036}, {212,0.01530631}, {213,0.01578378}, {214,0.01593694}, {215,0.01604505}, {216,0.01588288}, {217,0.01704505}, {218,0.01607207}, {219,0.01611712}, {220,0.01609009}, {221,0.01618919}, {222,0.01747748}, {223,0.01647748}, {224,0.01793694}, {225,0.01618919}, {226,0.01623423}, {227,0.01681081}, {228,0.01668468}, {229,0.01703604}, {230,0.01703604}, {231,0.01815315}, {232,0.01705405}, {233,0.01711712}, {234,0.01711712}, {235,0.01719820}, {236,0.01720721}, {237,0.01745946}, {238,0.01764865}, {239,0.01799099}, {240,0.01822523}, {241,0.01776577}, {242,0.01916216}, {243,0.01809009}, {244,0.01918018}, {245,0.01808108}, {246,0.01803604}, {247,0.01838739}, {248,0.01812613}, {249,0.01828829}, {250,0.01822523}, {251,0.01880180}, {252,0.01870270}, {253,0.01898198}, {254,0.01900000}, {255,0.01910811}, {256,0.01838739}, {257,0.01881982}, {258,0.01890991}, {259,0.01908108}, {260,0.01907207}, {261,0.01905405}, {262,0.01920721}, {263,0.01934234}, {264,0.01916216}, {265,0.01927928}, {266,0.01943243}, {267,0.01987387}, {268,0.01968468}, {269,0.02004505}, {270,0.02008108}, {271,0.02019820}, {272,0.01999099}, {273,0.02009910}, {274,0.02016216}, {275,0.02020721}, {276,0.02018018}, {277,0.02030631}, {278,0.02045946}, {279,0.02091892}, {280,0.02194595}, {281,0.02090991}, {282,0.02309910}, {283,0.02105405}, {284,0.02228829}, {285,0.02116216}, {286,0.02111712}, {287,0.02136036}, {288,0.02103604}, {289,0.02115315}, {290,0.02115315}, {291,0.02331532}, {292,0.02125225}, {293,0.02294595}, {294,0.02183784}, {295,0.02209009}, {296,0.02176577}, {297,0.02209910}, {298,0.02214414}, {299,0.02227928}, {300,0.02418018}, {301,0.02232432}, {302,0.02412613}, {303,0.02282883}, {304,0.02214414}, {305,0.02239640}, {306,0.02258559}, {307,0.02491892}, {308,0.02280180}, {309,0.02315315}, {310,0.02310811}, {311,0.02319820}, {312,0.02610811}, {313,0.02314414}, {314,0.02503604}, {315,0.02354955}, {316,0.02338739}, {317,0.02648649}, {318,0.02395495}, {319,0.02412613}, {320,0.02327928}, {321,0.02348649}, {322,0.02614414}, {323,0.02402703}, {324,0.02386486}, {325,0.02406306}, {326,0.02410811}, {327,0.02618018}, {328,0.02410811}, {329,0.02427928}, {330,0.02426126}, {331,0.02467568}, {332,0.02568468}, {333,0.02481081}, {334,0.02493694}, {335,0.02697297}, {336,0.02467568}, {337,0.02506306}, {338,0.02662162}, {339,0.02521622}, {340,0.02509009}, {341,0.02527928}, {342,0.02535135}, {343,0.02698198}, {344,0.02535135}, {345,0.02572072}, {346,0.02758559}, {347,0.02608108}, {348,0.02593694}, {349,0.02799099}, {350,0.02616216}, {351,0.02647748}, {352,0.02745946}, {353,0.02612613}, {354,0.02613514}, {355,0.02809009}, {356,0.02624324}, {357,0.02655856}, {358,0.02820721}, {359,0.02700901}, {360,0.02654955}, {361,0.02868468}, {362,0.02699099}, {363,0.02720721}, {364,0.02896396}, {365,0.02731532}, {366,0.02733333}, {367,0.02774775}, {368,0.02930631}, {369,0.02746847}, {370,0.02747748}, {371,0.02920721}, {372,0.02773874}, {373,0.02799099}, {374,0.02974775}, {375,0.02818018}, {376,0.02803604}, {377,0.02827027}, {378,0.03027027}, {379,0.02870270}, {380,0.02844144}, {381,0.03027027}, {382,0.02900901}, {383,0.02909910}, {384,0.02809910}, {385,0.02992793}, {386,0.02845045}, {387,0.02876577}, {388,0.03024324}, {389,0.02894595}, {390,0.02900901}, {391,0.02929730}, {392,0.03046847}, {393,0.02916216}, {394,0.02913514}, {395,0.02958559}, {396,0.03109910}, {397,0.02956757}, {398,0.02972973}, {399,0.03014414}, {400,0.03111712}, {401,0.02979279}, {402,0.02988288}, {403,0.03021622}, {404,0.03163063}, {405,0.03018018}, {406,0.03030631}, {407,0.03068468}, {408,0.03186486}, {409,0.03053153}, {410,0.03060360}, {411,0.03100901}, {412,0.03234234}, {413,0.03102703}, {414,0.03123423}, {415,0.03149550}, {416,0.03053153}, {417,0.03281081}, {418,0.03102703}, {419,0.03126126}, {420,0.03117117}, {421,0.03321622}, {422,0.03396396}, {423,0.03199099}, {424,0.03136937}, {425,0.03179279}, {426,0.03422523}, {427,0.03524324}, {428,0.03205405}, {429,0.03227027}, {430,0.03231532}, {431,0.03500000}, {432,0.03433333}, {433,0.03229730}, {434,0.03242342}, {435,0.03282883}, {436,0.03408108}, {437,0.03534234}, {438,0.03304505}, {439,0.03332432}, {440,0.03290090}, {441,0.03319820}, {442,0.03499099}, {443,0.03600000}, {444,0.03334234}, {445,0.03379279}, {446,0.03383784}, {447,0.03427928}, {448,0.03472973}, {449,0.03564865}, {450,0.03334234}, {451,0.03372072}, {452,0.03353153}, {453,0.03381982}, {454,0.03544144}, {455,0.03663063}, {456,0.03382883}, {457,0.03409009}, {458,0.03423423}, {459,0.03445946}, {460,0.03434234}, {461,0.03689189}, {462,0.03718018}, {463,0.03505405}, {464,0.03436937}, {465,0.03474775}, {466,0.03481982}, {467,0.03512613}, {468,0.03649550}, {469,0.03772973}, {470,0.03766667}, {471,0.03576577}, {472,0.03518919}, {473,0.03562162}, {474,0.03560360}, {475,0.03608108}, {476,0.03554054}, {477,0.03768468}, {478,0.03857658}, {479,0.03857658}, {480,0.03560360}, {481,0.03599099}, {482,0.03598198}, {483,0.03637838}, {484,0.03605405}, {485,0.03633333}, {486,0.03800901}, {487,0.03938739}, {488,0.03878378}, {489,0.03886486}, {490,0.03682883}, {491,0.03722523}, {492,0.03700000}, {493,0.03738739}, {494,0.03740541}, {495,0.03772973}, {496,0.03692793}, {497,0.03746847}, {498,0.03882883}, {499,0.04012613}, {500,0.03973874}, {505,0.04036937}, {510,0.04089189}, {515,0.04031532}, {520,0.04029730}, {525,0.04356757}, {530,0.03949550}, {535,0.04043243}, {540,0.04058559}, {545,0.04060360}, {550,0.04434234}, {555,0.04507207}, {560,0.04342342}, {565,0.04459459}, {570,0.04499099}, {575,0.04613514}, {580,0.04536937}, {585,0.04608108}, {590,0.04474775}, {595,0.04502703}, {600,0.04497297}, {605,0.04613514}, {610,0.04575676}, {615,0.04864865}, {620,0.04863063}, {625,0.04931532}, {630,0.04812613}, {635,0.04886486}, {640,0.04730631}, {645,0.05033333}, {650,0.05063063}, {655,0.04999099}, {660,0.04955856}, {665,0.05477477}, {670,0.05434234}, {675,0.05295495}, {680,0.05113514}, {685,0.05529730}, {690,0.05397297}, {695,0.05368468}, {700,0.05339640}, {705,0.05461261}, {710,0.05550450}, {715,0.05464865}, {720,0.05682883}, {725,0.05716216}, {730,0.05573874}, {735,0.05932432}, {740,0.05602703}, {745,0.05697297}, {750,0.05930631}, {755,0.05822523}, {760,0.06080180}, {765,0.06137838}, {770,0.05763063}, {775,0.06094595}, {780,0.05880180}, {785,0.06225225}, {790,0.05997297}, {795,0.06375676}, {800,0.05983784}, {805,0.06393694}, {810,0.06152252}, {815,0.06553153}, {820,0.06221622}, {825,0.06591892}, {830,0.06430631}, {835,0.06626126}, {840,0.06327027}, {845,0.06764865}, {850,0.06459459}, {855,0.06780180}, {860,0.06831532}, {865,0.06577477}, {870,0.06948649}, {875,0.06757658}, {880,0.06957658}, {885,0.07121622}, {890,0.06886486}, {895,0.07360360}, {900,0.07040541}, {905,0.06876577}, {910,0.07322523}, {915,0.07279279}, {920,0.06990090}, {925,0.07481081}, {930,0.07355856}, {935,0.07252252}, {940,0.07375676}, {945,0.07558559}, {950,0.07629730}, {955,0.07486486}, {960,0.07163964}, {965,0.07717117}, {970,0.07701802}, {975,0.07836937}, {980,0.07508108}, {985,0.08000901}, {990,0.08064865}, {995,0.08002703}, {1000,0.07928829}, {1010,0.08097297}, {1020,0.07945946}, {1030,0.07827928}, {1040,0.07985586}, {1050,0.08372072}, {1060,0.08387387}, {1070,0.08601802}, {1080,0.08597297}, {1090,0.08603604}, {1100,0.08718018}, {1110,0.08906306}, {1120,0.08854054}, {1130,0.09088288}, {1140,0.09148649}, {1150,0.09081982}, {1160,0.09226126}, {1170,0.09153153}, {1180,0.09378378}, {1190,0.09505405}, {1200,0.09570270}, {1210,0.10037838}, {1220,0.09579279}, {1230,0.09862162}, {1240,0.09932432}, {1250,0.09924324}, {1260,0.10027928}, {1270,0.10313514}, {1280,0.09874775}, {1290,0.10118919}, {1300,0.10273874}, {1310,0.10718919}, {1320,0.10549550}, {1330,0.10570270}, {1340,0.10835135}, {1350,0.11481081}, {1360,0.10807207}, {1370,0.11460360}, {1380,0.10889189}, {1390,0.11136937}, {1400,0.11171171}, {1410,0.11016216}, {1420,0.11292793}, {1430,0.11372072}, {1440,0.11140541}, {1450,0.11597297}, {1460,0.11585586}, {1470,0.11838739}, {1480,0.11962162}, {1490,0.11990991}, {1500,0.12058559}, {1510,0.12216216}, {1520,0.12195495}, {1530,0.12427027}, {1540,0.11972973}, {1550,0.12304505}, {1560,0.12018919}, {1570,0.12538739}, {1580,0.13065766}, {1590,0.12773874}, {1600,0.12472973}, {1610,0.12796396}, {1620,0.12845946}, {1630,0.13311712}, {1640,0.12972973}, {1650,0.13201802}, {1660,0.13400901}, {1670,0.13218018}, {1680,0.13200000}, {1690,0.13891892}, {1700,0.13527027}, {1710,0.13858559}, {1720,0.13609910}, {1730,0.14010811}, {1740,0.13908108}, {1750,0.14831532}, {1760,0.14000000}, {1770,0.14096396}, {1780,0.14282883}, {1790,0.14845946}, {1800,0.14189189}, {1810,0.14449550}, {1820,0.15039640}, {1830,0.14646847}, {1840,0.14783784}, {1850,0.15041441}, {1860,0.14667568}, {1870,0.15039640}, {1880,0.15089189}, {1890,0.15090090}, {1900,0.15347748}, {1910,0.15541441}, {1920,0.15072072}, {1930,0.15351351}, {1940,0.15501802}, {1950,0.16572973}, {1960,0.15561261}, {1970,0.15832432}, {1980,0.16579279}, {1990,0.15594595}, {2000,0.15905405}, {2050,0.16425225}, {2100,0.16607207}, {2150,0.16951351}, {2200,0.17196396}, {2250,0.17961261}, {2300,0.19249550}, {2350,0.18923423}, {2400,0.19044144}, {2450,0.19684685}, {2500,0.20268468}, {2550,0.22251351}, {2600,0.20809910}, {2650,0.21130631}, {2700,0.21614414}, {2750,0.22269369}, {2800,0.22218018}, {2850,0.22766667}, {2900,0.23518919}, {2950,0.23998198}, {3000,0.24352252}, {3050,0.24821622}, {3100,0.24789189}, {3150,0.25386486}, {3200,0.24945045}, {3250,0.25813514}, {3300,0.26211712}, {3350,0.26822523}, {3400,0.27150450}, {3450,0.29433333}, {3500,0.27890090}, {3550,0.29446847}, {3600,0.28075676}, {3650,0.29025225}, {3700,0.30122523}, {3750,0.30278378}, {3800,0.30981982}, {3850,0.30936937}, {3900,0.31667568}, {3950,0.32416216}, {4000,0.32009910}, {4050,0.33283784}, {4100,0.32683784}, {4150,0.33284685}, {4200,0.33687387}, {4250,0.34690090}, {4300,0.35372973}, {4350,0.36208108}, {4400,0.35320721}, {4450,0.37806306}, {4500,0.36578378}, {4550,0.36832432}, {4600,0.38230631}, {4650,0.37206306}, {4700,0.38438739}, {4750,0.40192793}, {4800,0.37859459}, {4850,0.39538739}, {4900,0.39554955}, {4950,0.40154054}, {5000,0.40811712}, {5050,0.41790090}, {5100,0.42809910}, {5150,0.42085586}, {5200,0.41591892}, {5250,0.42619820}, {5300,0.45463964}, {5350,0.44030631}, {5400,0.44183784}, {5450,0.44558559}, {5500,0.45904505}, {5550,0.46864865}, {5600,0.45249550}, {5650,0.45469369}, {5700,0.46754955}, {5750,0.48090991}, {5800,0.47009009}, {5850,0.49050450}, {5900,0.49753153}, {5950,0.51357658}, {6000,0.50529730}, {6050,0.49050}, {6100,0.49550}, {6150,0.49025}, {6200,0.49725}, {6250,0.49925}, {6300,0.51175}, {6350,0.53825}, {6400,0.50550}, {6450,0.52400}, {6500,0.53150}, {6550,0.53100}, {6600,0.53850}, {6650,0.56250}, {6700,0.54225}, {6750,0.55200}, {6800,0.54775}, {6850,0.55525}, {6900,0.57700}, {6950,0.57025}, {7000,0.58350}, {7050,0.58800}, {7100,0.59450}, {7150,0.59100}, {7200,0.56675}, {7250,0.60300}, {7300,0.59075}, {7350,0.60625}, {7400,0.61450}, {7450,0.61675}, {7500,0.64675}, {7550,0.66225}, {7600,0.62875}, {7650,0.64700}, {7700,0.62825}, {7750,0.64000}, {7800,0.64700}, {7850,0.65075}, {7900,0.66325}, {7950,0.66250}, {8000,0.64700}, {8050,0.69825}, {8100,0.71125}, {8150,0.70800}, {8200,0.67625}, {8250,0.68350}, {8300,0.68600}, {8350,0.70725}, {8400,0.68675}, {8450,0.68025}, {8500,0.70775}, {8550,0.72050}, {8600,0.72000}, {8650,0.71200}, {8700,0.77200}, {8750,0.74725}, {8800,0.71000}, {8850,0.73550}, {8900,0.72825}, {8950,0.77200}, {9000,0.76450}, {9050,0.75450}, {9100,0.76325}, {9150,0.78750}, {9200,0.78300}, {9250,0.74600}, {9300,0.76175}, {9350,0.77300}, {9400,0.80575}, {9450,0.79000}, {9500,0.81625}, {9550,0.79625}, {9600,0.78050}, {9650,0.83825}, {9700,0.82325}, {9750,0.81275}, {9800,0.80400}, {9850,0.85000}, {9900,0.83475}, {9950,0.85200}, {10000,0.83850}, {10100,0.86500}, {10200,0.86175}, {10300,0.85650}, {10400,0.84375}, {10500,0.88400}, {10600,0.88850}, {10700,0.90275}, {10800,0.91900}, {10900,0.92175}, {11000,0.92950}, {11100,0.97200}, {11200,0.92575}, {11300,0.93575}, {11400,0.93950}, {11500,0.98600}, {11600,0.96575}, {11700,1.00650}, {11800,0.98425}, {11900,1.02350}, {12000,1.00200}, {12100,1.01925}, {12200,1.03725}, {12300,1.00625}, {12400,1.01775}, {12500,1.03875}, {12600,1.05075}, {12700,1.07650}, {12800,1.01850}, {12900,1.08075}, {13000,1.07650}, {13100,1.10700}, {13200,1.12875}, {13300,1.14675}, {13400,1.14075}, {13500,1.18725}, {13600,1.14800}, {13700,1.13575}, {13800,1.18575}, {13900,1.17975}, {14000,1.17850}, {14100,1.18675}, {14200,1.23675}, {14300,1.24825}, {14400,1.17750}, {14500,1.21125}, {14600,1.23175}, {14700,1.25800}, {14800,1.23900}, {14900,1.29450}, {15000,1.25700}, {15100,1.32850}, {15200,1.31625}, {15300,1.31650}, {15400,1.28350}, {15500,1.34200}, {15600,1.36975}, {15700,1.40050}, {15800,1.37200}, {15900,1.34525}, {16000,1.37000}, {16100,1.44000}, {16200,1.39200}, {16300,1.44375}, {16400,1.36600}, {16500,1.40400}, {16600,1.42250}, {16700,1.47200}, {16800,1.44100}, {16900,1.44025}, {17000,1.44025}, {17100,1.47325}, {17200,1.44450}, {17300,1.47200}, {17400,1.58025}, {17500,1.51925}, {17600,1.44650}, {17700,1.51625}, {17800,1.54000}, {17900,1.56775}, {18000,1.50400}, {18100,1.60675}, {18200,1.53475}, {18300,1.59800}, {18400,1.56900}, {18500,1.53125}, {18600,1.61775}, {18700,1.55925}, {18800,1.63400}, {18900,1.64950}, {19000,1.62700}, {19100,1.63650}, {19200,1.65600}, {19300,1.65750}, {19400,1.65775}, {19500,1.64825}, {19600,1.66825}, {19700,1.71850}, {19800,1.75400}, {19900,1.77875}, {20000,1.6625}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["reif"]["user"] = {{1,0.00034234}, {2,0.00033333}, {3,0.00049550}, {4,0.00063964}, {5,0.00047748}, {6,0.00081081}, {7,0.00072973}, {8,0.00059459}, {9,0.00117117}, {10,0.00105405}, {11,0.00110811}, {12,0.00124324}, {13,0.00113514}, {14,0.00116216}, {15,0.00116216}, {16,0.01530631}, {17,0.00169369}, {18,0.00159459}, {19,0.00151351}, {20,0.00161261}, {21,0.00168468}, {22,0.00185586}, {23,0.00184685}, {24,0.00188288}, {25,0.00182883}, {26,0.00201802}, {27,0.00224324}, {28,0.00207207}, {29,0.00213514}, {30,0.00289189}, {31,0.00238739}, {32,0.00224324}, {33,0.00266667}, {34,0.00227027}, {35,0.00268468}, {36,0.00277477}, {37,0.00237838}, {38,0.00289189}, {39,0.00281982}, {40,0.00281081}, {41,0.00313514}, {42,0.00291892}, {43,0.00300901}, {44,0.00318018}, {45,0.00315315}, {46,0.00333333}, {47,0.00320721}, {48,0.00327928}, {49,0.00352252}, {50,0.00331532}, {51,0.00363964}, {52,0.00363063}, {53,0.00372973}, {54,0.00378378}, {55,0.00402703}, {56,0.00406306}, {57,0.00390090}, {58,0.00424324}, {59,0.00404505}, {60,0.00431532}, {61,0.00427027}, {62,0.00436036}, {63,0.00459459}, {64,0.00446847}, {65,0.00542342}, {66,0.00457658}, {67,0.00473874}, {68,0.00486486}, {69,0.00506306}, {70,0.00534234}, {71,0.00536937}, {72,0.00521622}, {73,0.00521622}, {74,0.00518018}, {75,0.00608108}, {76,0.00548649}, {77,0.00553153}, {78,0.00574775}, {79,0.00569369}, {80,0.00612613}, {81,0.00603604}, {82,0.00587387}, {83,0.00643243}, {84,0.00641441}, {85,0.00640541}, {86,0.00621622}, {87,0.00650450}, {88,0.00667568}, {89,0.00663063}, {90,0.00681982}, {91,0.00709910}, {92,0.00691892}, {93,0.00720721}, {94,0.00820721}, {95,0.00710811}, {96,0.00688288}, {97,0.00727027}, {98,0.00723423}, {99,0.00844144}, {100,0.00755856}, {101,0.00777477}, {102,0.00759459}, {103,0.00784685}, {104,0.00783784}, {105,0.00774775}, {106,0.00799099}, {107,0.00797297}, {108,0.00831532}, {109,0.00826126}, {110,0.00831532}, {111,0.00864865}, {112,0.00841441}, {113,0.00857658}, {114,0.00863964}, {115,0.00886486}, {116,0.00889189}, {117,0.00965766}, {118,0.00900901}, {119,0.00902703}, {120,0.00897297}, {121,0.00996396}, {122,0.00886486}, {123,0.00900000}, {124,0.00922523}, {125,0.01022523}, {126,0.00945946}, {127,0.00938739}, {128,0.00965766}, {129,0.01044144}, {130,0.00945946}, {131,0.00967568}, {132,0.00963964}, {133,0.00983784}, {134,0.00994595}, {135,0.01004505}, {136,0.00974775}, {137,0.01015315}, {138,0.00997297}, {139,0.01043243}, {140,0.01141441}, {141,0.01018018}, {142,0.01034234}, {143,0.01053153}, {144,0.01036036}, {145,0.01031532}, {146,0.01070270}, {147,0.01182883}, {148,0.01079279}, {149,0.01077477}, {150,0.01071171}, {151,0.01096396}, {152,0.01108108}, {153,0.01104505}, {154,0.01130631}, {155,0.01130631}, {156,0.01127928}, {157,0.01254955}, {158,0.01157658}, {159,0.01154054}, {160,0.01291892}, {161,0.01176577}, {162,0.01187387}, {163,0.01339640}, {164,0.01224324}, {165,0.01227928}, {166,0.01220721}, {167,0.01263063}, {168,0.01210811}, {169,0.01243243}, {170,0.01268468}, {171,0.01287387}, {172,0.01279279}, {173,0.01270270}, {174,0.01297297}, {175,0.01443243}, {176,0.01324324}, {177,0.01345946}, {178,0.01481081}, {179,0.01342342}, {180,0.01336036}, {181,0.01481982}, {182,0.01387387}, {183,0.01390090}, {184,0.01349550}, {185,0.01370270}, {186,0.01410811}, {187,0.01375676}, {188,0.01375676}, {189,0.01439640}, {190,0.01446847}, {191,0.01448649}, {192,0.01512613}, {193,0.01423423}, {194,0.01447748}, {195,0.01471171}, {196,0.01458559}, {197,0.01618919}, {198,0.01463964}, {199,0.01500901}, {200,0.01478378}, {201,0.01507207}, {202,0.01491892}, {203,0.01545946}, {204,0.01515315}, {205,0.01656757}, {206,0.01545045}, {207,0.01563964}, {208,0.01555856}, {209,0.01575676}, {210,0.01697297}, {211,0.01590090}, {212,0.01589189}, {213,0.01594595}, {214,0.01610811}, {215,0.01642342}, {216,0.01609009}, {217,0.01728829}, {218,0.01631532}, {219,0.01645045}, {220,0.01633333}, {221,0.01666667}, {222,0.01767568}, {223,0.01699099}, {224,0.01791892}, {225,0.01652252}, {226,0.01678378}, {227,0.01676577}, {228,0.01679279}, {229,0.01751351}, {230,0.01725225}, {231,0.01808108}, {232,0.01735135}, {233,0.01723423}, {234,0.01717117}, {235,0.01752252}, {236,0.01756757}, {237,0.01747748}, {238,0.01728829}, {239,0.01784685}, {240,0.01847748}, {241,0.01768468}, {242,0.01919820}, {243,0.01793694}, {244,0.01889189}, {245,0.01804505}, {246,0.01823423}, {247,0.01836937}, {248,0.01796396}, {249,0.01851351}, {250,0.01851351}, {251,0.01863063}, {252,0.01872072}, {253,0.01870270}, {254,0.01869369}, {255,0.01892793}, {256,0.01847748}, {257,0.01846847}, {258,0.01851351}, {259,0.01871171}, {260,0.01888288}, {261,0.01885586}, {262,0.01914414}, {263,0.01918919}, {264,0.01888288}, {265,0.01908108}, {266,0.01933333}, {267,0.01944144}, {268,0.01943243}, {269,0.01960360}, {270,0.01988288}, {271,0.02019820}, {272,0.01940541}, {273,0.01970270}, {274,0.01959459}, {275,0.02034234}, {276,0.01999099}, {277,0.02032432}, {278,0.01993694}, {279,0.02046847}, {280,0.02199099}, {281,0.02072973}, {282,0.02280180}, {283,0.02089189}, {284,0.02193694}, {285,0.02094595}, {286,0.02107207}, {287,0.02128829}, {288,0.02092793}, {289,0.02086486}, {290,0.02093694}, {291,0.02339640}, {292,0.02108108}, {293,0.02280180}, {294,0.02127928}, {295,0.02181081}, {296,0.02130631}, {297,0.02185586}, {298,0.02190090}, {299,0.02224324}, {300,0.02429730}, {301,0.02234234}, {302,0.02409910}, {303,0.02223423}, {304,0.02212613}, {305,0.02258559}, {306,0.02254054}, {307,0.02486486}, {308,0.02244144}, {309,0.02276577}, {310,0.02309910}, {311,0.02336937}, {312,0.02640541}, {313,0.02300000}, {314,0.02504505}, {315,0.02365766}, {316,0.02343243}, {317,0.02661261}, {318,0.02389189}, {319,0.02400000}, {320,0.02334234}, {321,0.02353153}, {322,0.02637838}, {323,0.02381081}, {324,0.02376577}, {325,0.02378378}, {326,0.02398198}, {327,0.02645045}, {328,0.02404505}, {329,0.02449550}, {330,0.02428829}, {331,0.02456757}, {332,0.02566667}, {333,0.02471171}, {334,0.02491892}, {335,0.02685586}, {336,0.02472072}, {337,0.02474775}, {338,0.02641441}, {339,0.02473874}, {340,0.02516216}, {341,0.02554054}, {342,0.02530631}, {343,0.02676577}, {344,0.02553153}, {345,0.02589189}, {346,0.02733333}, {347,0.02587387}, {348,0.02615315}, {349,0.02776577}, {350,0.02617117}, {351,0.02679279}, {352,0.02719820}, {353,0.02596396}, {354,0.02590090}, {355,0.02809009}, {356,0.02643243}, {357,0.02644144}, {358,0.02839640}, {359,0.02689189}, {360,0.02638739}, {361,0.02865766}, {362,0.02680180}, {363,0.02717117}, {364,0.02887387}, {365,0.02750450}, {366,0.02720721}, {367,0.02750450}, {368,0.02937838}, {369,0.02737838}, {370,0.02734234}, {371,0.02954054}, {372,0.02778378}, {373,0.02762162}, {374,0.02955856}, {375,0.02826126}, {376,0.02789189}, {377,0.02819820}, {378,0.03054955}, {379,0.02851351}, {380,0.02826126}, {381,0.03042342}, {382,0.02902703}, {383,0.02909009}, {384,0.02800901}, {385,0.03010811}, {386,0.02854955}, {387,0.02860360}, {388,0.03034234}, {389,0.02933333}, {390,0.02888288}, {391,0.02965766}, {392,0.03043243}, {393,0.02918018}, {394,0.02920721}, {395,0.02981982}, {396,0.03140541}, {397,0.02981982}, {398,0.02963063}, {399,0.02997297}, {400,0.03163063}, {401,0.02992793}, {402,0.02990090}, {403,0.03062162}, {404,0.03191892}, {405,0.03090991}, {406,0.03039640}, {407,0.03090090}, {408,0.03237838}, {409,0.03081081}, {410,0.03091892}, {411,0.03146847}, {412,0.03276577}, {413,0.03156757}, {414,0.03179279}, {415,0.03201802}, {416,0.03085586}, {417,0.03299099}, {418,0.03152252}, {419,0.03181982}, {420,0.03148649}, {421,0.03345045}, {422,0.03417117}, {423,0.03225225}, {424,0.03190090}, {425,0.03218018}, {426,0.03436036}, {427,0.03506306}, {428,0.03245045}, {429,0.03294595}, {430,0.03271171}, {431,0.03481081}, {432,0.03436937}, {433,0.03271171}, {434,0.03274775}, {435,0.03290991}, {436,0.03447748}, {437,0.03549550}, {438,0.03325225}, {439,0.03380180}, {440,0.03285586}, {441,0.03343243}, {442,0.03501802}, {443,0.03597297}, {444,0.03354955}, {445,0.03382883}, {446,0.03409009}, {447,0.03481982}, {448,0.03489189}, {449,0.03559459}, {450,0.03361261}, {451,0.03403604}, {452,0.03377477}, {453,0.03392793}, {454,0.03555856}, {455,0.03630631}, {456,0.03367568}, {457,0.03440541}, {458,0.03454054}, {459,0.03486486}, {460,0.03432432}, {461,0.03689189}, {462,0.03691892}, {463,0.03529730}, {464,0.03481982}, {465,0.03475676}, {466,0.03514414}, {467,0.03538739}, {468,0.03634234}, {469,0.03752252}, {470,0.03733333}, {471,0.03573874}, {472,0.03527928}, {473,0.03573874}, {474,0.03581982}, {475,0.03609009}, {476,0.03531532}, {477,0.03720721}, {478,0.03836036}, {479,0.03848649}, {480,0.03569369}, {481,0.03599099}, {482,0.03597297}, {483,0.03620721}, {484,0.03609009}, {485,0.03633333}, {486,0.03792793}, {487,0.03926126}, {488,0.03851351}, {489,0.03864865}, {490,0.03672973}, {491,0.03717117}, {492,0.03707207}, {493,0.03712613}, {494,0.03735135}, {495,0.03760360}, {496,0.03688288}, {497,0.03739640}, {498,0.03843243}, {499,0.04001802}, {500,0.03945045}, {505,0.04012613}, {510,0.04090090}, {515,0.04005405}, {520,0.04023423}, {525,0.04344144}, {530,0.03910811}, {535,0.04039640}, {540,0.04070270}, {545,0.04033333}, {550,0.04466667}, {555,0.04524324}, {560,0.04390991}, {565,0.04488288}, {570,0.04478378}, {575,0.04609910}, {580,0.04533333}, {585,0.04619820}, {590,0.04490991}, {595,0.04505405}, {600,0.04517117}, {605,0.04598198}, {610,0.04569369}, {615,0.04859459}, {620,0.04857658}, {625,0.04934234}, {630,0.04816216}, {635,0.04895495}, {640,0.04743243}, {645,0.05006306}, {650,0.05027027}, {655,0.04981081}, {660,0.04963964}, {665,0.05450450}, {670,0.05418018}, {675,0.05268468}, {680,0.05082883}, {685,0.05509009}, {690,0.05358559}, {695,0.05320721}, {700,0.05310811}, {705,0.05411712}, {710,0.05532432}, {715,0.05428829}, {720,0.05673874}, {725,0.05709910}, {730,0.05528829}, {735,0.05914414}, {740,0.05598198}, {745,0.05676577}, {750,0.05916216}, {755,0.05820721}, {760,0.06081081}, {765,0.06114414}, {770,0.05784685}, {775,0.06108108}, {780,0.05897297}, {785,0.06256757}, {790,0.06009009}, {795,0.06425225}, {800,0.06002703}, {805,0.06403604}, {810,0.06182883}, {815,0.06529730}, {820,0.06261261}, {825,0.06579279}, {830,0.06477477}, {835,0.06637838}, {840,0.06345946}, {845,0.06746847}, {850,0.06488288}, {855,0.06758559}, {860,0.06822523}, {865,0.06579279}, {870,0.06917117}, {875,0.06757658}, {880,0.06940541}, {885,0.07093694}, {890,0.06848649}, {895,0.07353153}, {900,0.07047748}, {905,0.06881982}, {910,0.07318919}, {915,0.07279279}, {920,0.06955856}, {925,0.07513514}, {930,0.07354054}, {935,0.07293694}, {940,0.07372973}, {945,0.07576577}, {950,0.07638739}, {955,0.07514414}, {960,0.07154054}, {965,0.07743243}, {970,0.07712613}, {975,0.07827928}, {980,0.07562162}, {985,0.07975676}, {990,0.08018018}, {995,0.07977477}, {1000,0.07901802}, {1010,0.08070270}, {1020,0.07918919}, {1030,0.07835135}, {1040,0.07974775}, {1050,0.08355856}, {1060,0.08381982}, {1070,0.08615315}, {1080,0.08609910}, {1090,0.08602703}, {1100,0.08725225}, {1110,0.08908108}, {1120,0.08817117}, {1130,0.09040541}, {1140,0.09109009}, {1150,0.09069369}, {1160,0.09170270}, {1170,0.09107207}, {1180,0.09310811}, {1190,0.09468468}, {1200,0.09557658}, {1210,0.10034234}, {1220,0.09552252}, {1230,0.09887387}, {1240,0.09949550}, {1250,0.09901802}, {1260,0.10026126}, {1270,0.10272973}, {1280,0.09863964}, {1290,0.10106306}, {1300,0.10224324}, {1310,0.10685586}, {1320,0.10534234}, {1330,0.10536036}, {1340,0.10813514}, {1350,0.11400901}, {1360,0.10802703}, {1370,0.11416216}, {1380,0.10872072}, {1390,0.11148649}, {1400,0.11169369}, {1410,0.11029730}, {1420,0.11284685}, {1430,0.11331532}, {1440,0.11137838}, {1450,0.11528829}, {1460,0.11538739}, {1470,0.11795495}, {1480,0.11936937}, {1490,0.11960360}, {1500,0.12046847}, {1510,0.12213514}, {1520,0.12189189}, {1530,0.12436937}, {1540,0.11890090}, {1550,0.12290090}, {1560,0.12000000}, {1570,0.12518018}, {1580,0.13063063}, {1590,0.12780180}, {1600,0.12459459}, {1610,0.12835135}, {1620,0.12845946}, {1630,0.13316216}, {1640,0.12976577}, {1650,0.13167568}, {1660,0.13359459}, {1670,0.13181982}, {1680,0.13179279}, {1690,0.13863063}, {1700,0.13497297}, {1710,0.13872072}, {1720,0.13582883}, {1730,0.14002703}, {1740,0.13885586}, {1750,0.14776577}, {1760,0.13995495}, {1770,0.14096396}, {1780,0.14291892}, {1790,0.14834234}, {1800,0.14225225}, {1810,0.14435135}, {1820,0.15087387}, {1830,0.14640541}, {1840,0.14773874}, {1850,0.15031532}, {1860,0.14650450}, {1870,0.15035135}, {1880,0.15129730}, {1890,0.15116216}, {1900,0.15381081}, {1910,0.15526126}, {1920,0.15102703}, {1930,0.15362162}, {1940,0.15479279}, {1950,0.16585586}, {1960,0.15539640}, {1970,0.15809910}, {1980,0.16591892}, {1990,0.15594595}, {2000,0.15899099}, {2050,0.16431532}, {2100,0.16611712}, {2150,0.16935135}, {2200,0.17162162}, {2250,0.17938739}, {2300,0.19229730}, {2350,0.18922523}, {2400,0.19035135}, {2450,0.19670270}, {2500,0.20260360}, {2550,0.22239640}, {2600,0.20785586}, {2650,0.21100000}, {2700,0.21582883}, {2750,0.22258559}, {2800,0.22199099}, {2850,0.22733333}, {2900,0.23488288}, {2950,0.23962162}, {3000,0.24310811}, {3050,0.24768468}, {3100,0.24778378}, {3150,0.25361261}, {3200,0.24935135}, {3250,0.25800901}, {3300,0.26188288}, {3350,0.26827928}, {3400,0.27130631}, {3450,0.29425225}, {3500,0.27859459}, {3550,0.29463964}, {3600,0.28091892}, {3650,0.29037838}, {3700,0.30081081}, {3750,0.30263964}, {3800,0.30964865}, {3850,0.30910811}, {3900,0.31633333}, {3950,0.32384685}, {4000,0.31978378}, {4050,0.33249550}, {4100,0.32704505}, {4150,0.33239640}, {4200,0.33618018}, {4250,0.34645045}, {4300,0.35352252}, {4350,0.36180180}, {4400,0.35311712}, {4450,0.37804505}, {4500,0.36545946}, {4550,0.36802703}, {4600,0.38241441}, {4650,0.37149550}, {4700,0.38447748}, {4750,0.40172973}, {4800,0.37865766}, {4850,0.39512613}, {4900,0.39554955}, {4950,0.40127027}, {5000,0.40809910}, {5050,0.41795495}, {5100,0.42791892}, {5150,0.42068468}, {5200,0.41561261}, {5250,0.42568468}, {5300,0.45463063}, {5350,0.43988288}, {5400,0.44197297}, {5450,0.44552252}, {5500,0.45885586}, {5550,0.46845946}, {5600,0.45231532}, {5650,0.45453153}, {5700,0.46742342}, {5750,0.48009910}, {5800,0.46974775}, {5850,0.49008108}, {5900,0.49672973}, {5950,0.51291892}, {6000,0.50499099}, {6050,0.49150}, {6100,0.49550}, {6150,0.48800}, {6200,0.49600}, {6250,0.49875}, {6300,0.51250}, {6350,0.53850}, {6400,0.50625}, {6450,0.52450}, {6500,0.52900}, {6550,0.53150}, {6600,0.53650}, {6650,0.56275}, {6700,0.54275}, {6750,0.55000}, {6800,0.54575}, {6850,0.55575}, {6900,0.57775}, {6950,0.56950}, {7000,0.58150}, {7050,0.58875}, {7100,0.59575}, {7150,0.59175}, {7200,0.56450}, {7250,0.60100}, {7300,0.59050}, {7350,0.60650}, {7400,0.61425}, {7450,0.61750}, {7500,0.64650}, {7550,0.66250}, {7600,0.63000}, {7650,0.64625}, {7700,0.62850}, {7750,0.64100}, {7800,0.64775}, {7850,0.65250}, {7900,0.66350}, {7950,0.66225}, {8000,0.64575}, {8050,0.69725}, {8100,0.71025}, {8150,0.70650}, {8200,0.67550}, {8250,0.68250}, {8300,0.68725}, {8350,0.70775}, {8400,0.68675}, {8450,0.68075}, {8500,0.70650}, {8550,0.72025}, {8600,0.71850}, {8650,0.70950}, {8700,0.77075}, {8750,0.74575}, {8800,0.70825}, {8850,0.73500}, {8900,0.72825}, {8950,0.77050}, {9000,0.76450}, {9050,0.75450}, {9100,0.76275}, {9150,0.78750}, {9200,0.78350}, {9250,0.74700}, {9300,0.76175}, {9350,0.77375}, {9400,0.80450}, {9450,0.78975}, {9500,0.81450}, {9550,0.79700}, {9600,0.78025}, {9650,0.83850}, {9700,0.82225}, {9750,0.81150}, {9800,0.80350}, {9850,0.84925}, {9900,0.83250}, {9950,0.85175}, {10000,0.83825}, {10100,0.86575}, {10200,0.86150}, {10300,0.85725}, {10400,0.84375}, {10500,0.88250}, {10600,0.88775}, {10700,0.90475}, {10800,0.91825}, {10900,0.92150}, {11000,0.92950}, {11100,0.97125}, {11200,0.92775}, {11300,0.93550}, {11400,0.93825}, {11500,0.98525}, {11600,0.96500}, {11700,1.00775}, {11800,0.98500}, {11900,1.02400}, {12000,1.00150}, {12100,1.01800}, {12200,1.03750}, {12300,1.00550}, {12400,1.01725}, {12500,1.03900}, {12600,1.05200}, {12700,1.07775}, {12800,1.01600}, {12900,1.08025}, {13000,1.07625}, {13100,1.10800}, {13200,1.12750}, {13300,1.14775}, {13400,1.14175}, {13500,1.18875}, {13600,1.14775}, {13700,1.13575}, {13800,1.18575}, {13900,1.17950}, {14000,1.17600}, {14100,1.18625}, {14200,1.23650}, {14300,1.24975}, {14400,1.17900}, {14500,1.21125}, {14600,1.23050}, {14700,1.25875}, {14800,1.23875}, {14900,1.29425}, {15000,1.25625}, {15100,1.32900}, {15200,1.31675}, {15300,1.31500}, {15400,1.28350}, {15500,1.34075}, {15600,1.36950}, {15700,1.40175}, {15800,1.37125}, {15900,1.34625}, {16000,1.36950}, {16100,1.44025}, {16200,1.38950}, {16300,1.44325}, {16400,1.36450}, {16500,1.40200}, {16600,1.42250}, {16700,1.47025}, {16800,1.44025}, {16900,1.43900}, {17000,1.43875}, {17100,1.47350}, {17200,1.44325}, {17300,1.47100}, {17400,1.58050}, {17500,1.51850}, {17600,1.44775}, {17700,1.51575}, {17800,1.53925}, {17900,1.56650}, {18000,1.50350}, {18100,1.60600}, {18200,1.53450}, {18300,1.59875}, {18400,1.57050}, {18500,1.53100}, {18600,1.61750}, {18700,1.55925}, {18800,1.63250}, {18900,1.64975}, {19000,1.62525}, {19100,1.63700}, {19200,1.65475}, {19300,1.65750}, {19400,1.65750}, {19500,1.64675}, {19600,1.66775}, {19700,1.71975}, {19800,1.75425}, {19900,1.77750}, {20000,1.6610}};
data["big_flat"]["CanonicalStructuresFlatPHOAS"]["reif"]["system"] = {{1,0.00009910}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00007207}, {6,0.00003604}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00003604}, {12,0.00000000}, {13,0.00000000}, {14,0.00006306}, {15,0.00007207}, {16,0.00020721}, {17,0.00000000}, {18,0.00000000}, {19,0.00007207}, {20,0.00002703}, {21,0.00000000}, {22,0.00003604}, {23,0.00006306}, {24,0.00009910}, {25,0.00003604}, {26,0.00000000}, {27,0.00009910}, {28,0.00000000}, {29,0.00000000}, {30,0.00009910}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00005405}, {42,0.00000000}, {43,0.00006306}, {44,0.00000000}, {45,0.00000000}, {46,0.00003604}, {47,0.00003604}, {48,0.00000000}, {49,0.00000000}, {50,0.00009910}, {51,0.00003604}, {52,0.00000000}, {53,0.00009910}, {54,0.00000000}, {55,0.00003604}, {56,0.00000000}, {57,0.00003604}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00007207}, {62,0.00003604}, {63,0.00003604}, {64,0.00003604}, {65,0.00002703}, {66,0.00003604}, {67,0.00003604}, {68,0.00003604}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00003604}, {73,0.00003604}, {74,0.00003604}, {75,0.00000000}, {76,0.00000000}, {77,0.00003604}, {78,0.00003604}, {79,0.00003604}, {80,0.00000000}, {81,0.00003604}, {82,0.00003604}, {83,0.00000000}, {84,0.00009910}, {85,0.00003604}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00006306}, {90,0.00000000}, {91,0.00003604}, {92,0.00003604}, {93,0.00000000}, {94,0.00003604}, {95,0.00003604}, {96,0.00014414}, {97,0.00007207}, {98,0.00007207}, {99,0.00003604}, {100,0.00003604}, {101,0.00000000}, {102,0.00013514}, {103,0.00000000}, {104,0.00000000}, {105,0.00003604}, {106,0.00003604}, {107,0.00000000}, {108,0.00003604}, {109,0.00003604}, {110,0.00003604}, {111,0.00000000}, {112,0.00006306}, {113,0.00003604}, {114,0.00000000}, {115,0.00003604}, {116,0.00000000}, {117,0.00003604}, {118,0.00003604}, {119,0.00000000}, {120,0.00000000}, {121,0.00006306}, {122,0.00003604}, {123,0.00003604}, {124,0.00002703}, {125,0.00002703}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00007207}, {130,0.00003604}, {131,0.00003604}, {132,0.00003604}, {133,0.00003604}, {134,0.00003604}, {135,0.00000000}, {136,0.00007207}, {137,0.00003604}, {138,0.00003604}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00006306}, {146,0.00000000}, {147,0.00002703}, {148,0.00007207}, {149,0.00000000}, {150,0.00010811}, {151,0.00007207}, {152,0.00000000}, {153,0.00003604}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00003604}, {158,0.00000000}, {159,0.00002703}, {160,0.00013514}, {161,0.00010811}, {162,0.00000000}, {163,0.00006306}, {164,0.00002703}, {165,0.00003604}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00003604}, {170,0.00000000}, {171,0.00002703}, {172,0.00000000}, {173,0.00002703}, {174,0.00000000}, {175,0.00007207}, {176,0.00003604}, {177,0.00000000}, {178,0.00000000}, {179,0.00007207}, {180,0.00003604}, {181,0.00006306}, {182,0.00000000}, {183,0.00000000}, {184,0.00007207}, {185,0.00000000}, {186,0.00003604}, {187,0.00000000}, {188,0.00007207}, {189,0.00000000}, {190,0.00000000}, {191,0.00002703}, {192,0.00009910}, {193,0.00000000}, {194,0.00003604}, {195,0.00000000}, {196,0.00003604}, {197,0.00006306}, {198,0.00000000}, {199,0.00002703}, {200,0.00002703}, {201,0.00000000}, {202,0.00003604}, {203,0.00000000}, {204,0.00002703}, {205,0.00000000}, {206,0.00003604}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00002703}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00002703}, {215,0.00000000}, {216,0.00007207}, {217,0.00000000}, {218,0.00003604}, {219,0.00000000}, {220,0.00007207}, {221,0.00000000}, {222,0.00010811}, {223,0.00000000}, {224,0.00010811}, {225,0.00003604}, {226,0.00006306}, {227,0.00009910}, {228,0.00003604}, {229,0.00000000}, {230,0.00000000}, {231,0.00010811}, {232,0.00003604}, {233,0.00003604}, {234,0.00003604}, {235,0.00003604}, {236,0.00002703}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00007207}, {241,0.00007207}, {242,0.00010811}, {243,0.00000000}, {244,0.00007207}, {245,0.00003604}, {246,0.00000000}, {247,0.00000000}, {248,0.00009009}, {249,0.00000000}, {250,0.00003604}, {251,0.00003604}, {252,0.00003604}, {253,0.00003604}, {254,0.00007207}, {255,0.00003604}, {256,0.00000000}, {257,0.00007207}, {258,0.00003604}, {259,0.00000000}, {260,0.00000000}, {261,0.00003604}, {262,0.00003604}, {263,0.00003604}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00009910}, {273,0.00003604}, {274,0.00003604}, {275,0.00000000}, {276,0.00002703}, {277,0.00000000}, {278,0.00002703}, {279,0.00002703}, {280,0.00003604}, {281,0.00003604}, {282,0.00016216}, {283,0.00000000}, {284,0.00013514}, {285,0.00003604}, {286,0.00000000}, {287,0.00003604}, {288,0.00000000}, {289,0.00003604}, {290,0.00000000}, {291,0.00002703}, {292,0.00003604}, {293,0.00009910}, {294,0.00009009}, {295,0.00002703}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00007207}, {301,0.00003604}, {302,0.00000000}, {303,0.00003604}, {304,0.00003604}, {305,0.00000000}, {306,0.00000000}, {307,0.00009910}, {308,0.00010811}, {309,0.00007207}, {310,0.00000000}, {311,0.00000000}, {312,0.00003604}, {313,0.00003604}, {314,0.00000000}, {315,0.00003604}, {316,0.00002703}, {317,0.00007207}, {318,0.00003604}, {319,0.00003604}, {320,0.00003604}, {321,0.00000000}, {322,0.00003604}, {323,0.00002703}, {324,0.00003604}, {325,0.00007207}, {326,0.00007207}, {327,0.00007207}, {328,0.00003604}, {329,0.00000000}, {330,0.00003604}, {331,0.00010811}, {332,0.00003604}, {333,0.00007207}, {334,0.00000000}, {335,0.00003604}, {336,0.00000000}, {337,0.00003604}, {338,0.00006306}, {339,0.00007207}, {340,0.00014414}, {341,0.00000000}, {342,0.00007207}, {343,0.00003604}, {344,0.00003604}, {345,0.00000000}, {346,0.00007207}, {347,0.00003604}, {348,0.00000000}, {349,0.00002703}, {350,0.00003604}, {351,0.00003604}, {352,0.00020721}, {353,0.00006306}, {354,0.00003604}, {355,0.00014414}, {356,0.00003604}, {357,0.00000000}, {358,0.00005405}, {359,0.00003604}, {360,0.00000000}, {361,0.00003604}, {362,0.00000000}, {363,0.00000000}, {364,0.00007207}, {365,0.00007207}, {366,0.00000000}, {367,0.00003604}, {368,0.00003604}, {369,0.00007207}, {370,0.00007207}, {371,0.00003604}, {372,0.00007207}, {373,0.00003604}, {374,0.00013514}, {375,0.00003604}, {376,0.00006306}, {377,0.00000000}, {378,0.00000000}, {379,0.00003604}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00007207}, {384,0.00003604}, {385,0.00000000}, {386,0.00007207}, {387,0.00000000}, {388,0.00006306}, {389,0.00003604}, {390,0.00003604}, {391,0.00003604}, {392,0.00010811}, {393,0.00010811}, {394,0.00006306}, {395,0.00007207}, {396,0.00007207}, {397,0.00003604}, {398,0.00007207}, {399,0.00003604}, {400,0.00010811}, {401,0.00000000}, {402,0.00002703}, {403,0.00000000}, {404,0.00002703}, {405,0.00003604}, {406,0.00003604}, {407,0.00000000}, {408,0.00006306}, {409,0.00000000}, {410,0.00003604}, {411,0.00003604}, {412,0.00003604}, {413,0.00007207}, {414,0.00000000}, {415,0.00000000}, {416,0.00007207}, {417,0.00000000}, {418,0.00000000}, {419,0.00007207}, {420,0.00000000}, {421,0.00003604}, {422,0.00003604}, {423,0.00000000}, {424,0.00003604}, {425,0.00003604}, {426,0.00003604}, {427,0.00020721}, {428,0.00000000}, {429,0.00000000}, {430,0.00003604}, {431,0.00009910}, {432,0.00014414}, {433,0.00003604}, {434,0.00006306}, {435,0.00000000}, {436,0.00000000}, {437,0.00003604}, {438,0.00003604}, {439,0.00000000}, {440,0.00003604}, {441,0.00003604}, {442,0.00007207}, {443,0.00020721}, {444,0.00003604}, {445,0.00006306}, {446,0.00007207}, {447,0.00007207}, {448,0.00003604}, {449,0.00009910}, {450,0.00000000}, {451,0.00003604}, {452,0.00007207}, {453,0.00007207}, {454,0.00010811}, {455,0.00003604}, {456,0.00025225}, {457,0.00000000}, {458,0.00003604}, {459,0.00000000}, {460,0.00003604}, {461,0.00009009}, {462,0.00013514}, {463,0.00002703}, {464,0.00003604}, {465,0.00007207}, {466,0.00003604}, {467,0.00000000}, {468,0.00003604}, {469,0.00017117}, {470,0.00006306}, {471,0.00003604}, {472,0.00014414}, {473,0.00003604}, {474,0.00000000}, {475,0.00003604}, {476,0.00007207}, {477,0.00006306}, {478,0.00014414}, {479,0.00003604}, {480,0.00000000}, {481,0.00003604}, {482,0.00002703}, {483,0.00010811}, {484,0.00003604}, {485,0.00007207}, {486,0.00007207}, {487,0.00007207}, {488,0.00006306}, {489,0.00003604}, {490,0.00000000}, {491,0.00000000}, {492,0.00003604}, {493,0.00009910}, {494,0.00000000}, {495,0.00003604}, {496,0.00003604}, {497,0.00000000}, {498,0.00014414}, {499,0.00013514}, {500,0.00020721}, {505,0.00010811}, {510,0.00000000}, {515,0.00006306}, {520,0.00007207}, {525,0.00020721}, {530,0.00003604}, {535,0.00000000}, {540,0.00003604}, {545,0.00000000}, {550,0.00007207}, {555,0.00010811}, {560,0.00010811}, {565,0.00003604}, {570,0.00010811}, {575,0.00007207}, {580,0.00010811}, {585,0.00010811}, {590,0.00002703}, {595,0.00000000}, {600,0.00007207}, {605,0.00003604}, {610,0.00000000}, {615,0.00021622}, {620,0.00000000}, {625,0.00003604}, {630,0.00007207}, {635,0.00007207}, {640,0.00000000}, {645,0.00007207}, {650,0.00006306}, {655,0.00010811}, {660,0.00003604}, {665,0.00006306}, {670,0.00007207}, {675,0.00009910}, {680,0.00000000}, {685,0.00007207}, {690,0.00003604}, {695,0.00007207}, {700,0.00000000}, {705,0.00003604}, {710,0.00010811}, {715,0.00003604}, {720,0.00021622}, {725,0.00010811}, {730,0.00010811}, {735,0.00010811}, {740,0.00006306}, {745,0.00000000}, {750,0.00003604}, {755,0.00007207}, {760,0.00021622}, {765,0.00025225}, {770,0.00000000}, {775,0.00003604}, {780,0.00010811}, {785,0.00021622}, {790,0.00003604}, {795,0.00007207}, {800,0.00007207}, {805,0.00017117}, {810,0.00003604}, {815,0.00017117}, {820,0.00009910}, {825,0.00014414}, {830,0.00000000}, {835,0.00007207}, {840,0.00002703}, {845,0.00010811}, {850,0.00003604}, {855,0.00007207}, {860,0.00009910}, {865,0.00010811}, {870,0.00018018}, {875,0.00007207}, {880,0.00007207}, {885,0.00021622}, {890,0.00010811}, {895,0.00010811}, {900,0.00010811}, {905,0.00003604}, {910,0.00010811}, {915,0.00018018}, {920,0.00010811}, {925,0.00010811}, {930,0.00018018}, {935,0.00003604}, {940,0.00018018}, {945,0.00007207}, {950,0.00018018}, {955,0.00000000}, {960,0.00007207}, {965,0.00000000}, {970,0.00003604}, {975,0.00007207}, {980,0.00003604}, {985,0.00007207}, {990,0.00025225}, {995,0.00036937}, {1000,0.00027928}, {1010,0.00018018}, {1020,0.00006306}, {1030,0.00002703}, {1040,0.00003604}, {1050,0.00014414}, {1060,0.00009009}, {1070,0.00021622}, {1080,0.00010811}, {1090,0.00013514}, {1100,0.00007207}, {1110,0.00007207}, {1120,0.00024324}, {1130,0.00009910}, {1140,0.00010811}, {1150,0.00007207}, {1160,0.00010811}, {1170,0.00006306}, {1180,0.00017117}, {1190,0.00027027}, {1200,0.00014414}, {1210,0.00014414}, {1220,0.00017117}, {1230,0.00021622}, {1240,0.00007207}, {1250,0.00014414}, {1260,0.00010811}, {1270,0.00014414}, {1280,0.00010811}, {1290,0.00018018}, {1300,0.00017117}, {1310,0.00018018}, {1320,0.00014414}, {1330,0.00013514}, {1340,0.00027928}, {1350,0.00027928}, {1360,0.00010811}, {1370,0.00027928}, {1380,0.00018018}, {1390,0.00025225}, {1400,0.00005405}, {1410,0.00009910}, {1420,0.00010811}, {1430,0.00037838}, {1440,0.00007207}, {1450,0.00007207}, {1460,0.00020721}, {1470,0.00021622}, {1480,0.00018018}, {1490,0.00018018}, {1500,0.00010811}, {1510,0.00018018}, {1520,0.00010811}, {1530,0.00003604}, {1540,0.00024324}, {1550,0.00018018}, {1560,0.00010811}, {1570,0.00023423}, {1580,0.00027027}, {1590,0.00014414}, {1600,0.00021622}, {1610,0.00010811}, {1620,0.00018018}, {1630,0.00013514}, {1640,0.00010811}, {1650,0.00014414}, {1660,0.00028829}, {1670,0.00017117}, {1680,0.00014414}, {1690,0.00035135}, {1700,0.00003604}, {1710,0.00018018}, {1720,0.00017117}, {1730,0.00035135}, {1740,0.00027928}, {1750,0.00050450}, {1760,0.00017117}, {1770,0.00014414}, {1780,0.00025225}, {1790,0.00017117}, {1800,0.00000000}, {1810,0.00003604}, {1820,0.00003604}, {1830,0.00007207}, {1840,0.00003604}, {1850,0.00003604}, {1860,0.00000000}, {1870,0.00003604}, {1880,0.00002703}, {1890,0.00003604}, {1900,0.00003604}, {1910,0.00000000}, {1920,0.00003604}, {1930,0.00010811}, {1940,0.00007207}, {1950,0.00003604}, {1960,0.00009910}, {1970,0.00010811}, {1980,0.00003604}, {1990,0.00003604}, {2000,0.00018018}, {2050,0.00009910}, {2100,0.00002703}, {2150,0.00010811}, {2200,0.00010811}, {2250,0.00007207}, {2300,0.00019820}, {2350,0.00003604}, {2400,0.00003604}, {2450,0.00006306}, {2500,0.00010811}, {2550,0.00006306}, {2600,0.00007207}, {2650,0.00000000}, {2700,0.00013514}, {2750,0.00014414}, {2800,0.00021622}, {2850,0.00014414}, {2900,0.00018018}, {2950,0.00017117}, {3000,0.00000000}, {3050,0.00009910}, {3100,0.00000000}, {3150,0.00007207}, {3200,0.00018018}, {3250,0.00010811}, {3300,0.00007207}, {3350,0.00007207}, {3400,0.00003604}, {3450,0.00018018}, {3500,0.00014414}, {3550,0.00003604}, {3600,0.00010811}, {3650,0.00003604}, {3700,0.00018018}, {3750,0.00006306}, {3800,0.00007207}, {3850,0.00003604}, {3900,0.00006306}, {3950,0.00013514}, {4000,0.00018018}, {4050,0.00009910}, {4100,0.00007207}, {4150,0.00010811}, {4200,0.00014414}, {4250,0.00000000}, {4300,0.00007207}, {4350,0.00003604}, {4400,0.00010811}, {4450,0.00010811}, {4500,0.00007207}, {4550,0.00009910}, {4600,0.00003604}, {4650,0.00014414}, {4700,0.00009910}, {4750,0.00010811}, {4800,0.00007207}, {4850,0.00020721}, {4900,0.00035135}, {4950,0.00018018}, {5000,0.00032432}, {5050,0.00017117}, {5100,0.00007207}, {5150,0.00010811}, {5200,0.00014414}, {5250,0.00014414}, {5300,0.00021622}, {5350,0.00028829}, {5400,0.00003604}, {5450,0.00003604}, {5500,0.00007207}, {5550,0.00007207}, {5600,0.00003604}, {5650,0.00007207}, {5700,0.00003604}, {5750,0.00035135}, {5800,0.00032432}, {5850,0.00041441}, {5900,0.00067568}, {5950,0.00072973}, {6000,0.00025225}, {6050,0.00000}, {6100,0.00000}, {6150,0.00200}, {6200,0.00100}, {6250,0.00100}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00100}, {6650,0.00100}, {6700,0.00000}, {6750,0.00100}, {6800,0.00175}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00200}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00100}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00100}, {8650,0.00100}, {8700,0.00000}, {8750,0.00075}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00200}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00075}, {9850,0.00000}, {9900,0.00100}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00100}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00100}, {12200,0.00000}, {12300,0.00100}, {12400,0.00100}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00075}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00100}, {13500,0.00000}, {13600,0.00100}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00100}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00100}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00100}, {16300,0.00000}, {16400,0.00000}, {16500,0.00100}, {16600,0.00000}, {16700,0.00100}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00100}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00100}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresHOAS"]["Aggregate"]["real"] = {{1,0.00100000}, {2,0.00100000}, {3,0.00107207}, {4,0.00153153}, {5,0.00200000}, {6,0.00200000}, {7,0.00200000}, {8,0.00200000}, {9,0.00200000}, {10,0.00200000}, {11,0.00203604}, {12,0.00220721}, {13,0.00265766}, {14,0.01964865}, {15,0.00300000}, {16,0.00300000}, {17,0.00300000}, {18,0.00300000}, {19,0.00300000}, {20,0.00302703}, {21,0.00311712}, {22,0.00331532}, {23,0.00384685}, {24,0.00399099}, {25,0.00400000}, {26,0.00400000}, {27,0.00400000}, {28,0.00400000}, {29,0.00407207}, {30,0.00416216}, {31,0.00422523}, {32,0.00437838}, {33,0.00490090}, {34,0.00500000}, {35,0.00500901}, {36,0.00500000}, {37,0.00500000}, {38,0.00507207}, {39,0.00613514}, {40,0.00513514}, {41,0.00532432}, {42,0.00573874}, {43,0.00598198}, {44,0.00600000}, {45,0.00688288}, {46,0.00600000}, {47,0.00602703}, {48,0.00602703}, {49,0.00609910}, {50,0.00731532}, {51,0.00654955}, {52,0.00679279}, {53,0.00698198}, {54,0.00700901}, {55,0.00793694}, {56,0.00703604}, {57,0.00709009}, {58,0.00709009}, {59,0.00718018}, {60,0.00733333}, {61,0.00769369}, {62,0.00792793}, {63,0.00800901}, {64,0.00802703}, {65,0.00803604}, {66,0.00808108}, {67,0.00809009}, {68,0.00814414}, {69,0.00823423}, {70,0.00860360}, {71,0.01003604}, {72,0.00892793}, {73,0.00902703}, {74,0.00904505}, {75,0.00908108}, {76,0.00908108}, {77,0.00910811}, {78,0.01064865}, {79,0.00954955}, {80,0.00959459}, {81,0.00988288}, {82,0.00997297}, {83,0.01001802}, {84,0.01005405}, {85,0.01003604}, {86,0.01012613}, {87,0.01020721}, {88,0.01018018}, {89,0.01054955}, {90,0.01073874}, {91,0.01098198}, {92,0.01098198}, {93,0.01103604}, {94,0.01109009}, {95,0.01109009}, {96,0.01291892}, {97,0.01122523}, {98,0.01141441}, {99,0.01169369}, {100,0.01177477}, {101,0.01201802}, {102,0.01200901}, {103,0.01206306}, {104,0.01366667}, {105,0.01214414}, {106,0.01224324}, {107,0.01246847}, {108,0.01263063}, {109,0.01389189}, {110,0.01298198}, {111,0.01303604}, {112,0.01302703}, {113,0.01310811}, {114,0.01311712}, {115,0.01322523}, {116,0.01418018}, {117,0.01359459}, {118,0.01378378}, {119,0.01399099}, {120,0.01394595}, {121,0.01400000}, {122,0.01409009}, {123,0.01417117}, {124,0.01418018}, {125,0.01444144}, {126,0.01460360}, {127,0.01578378}, {128,0.01463964}, {129,0.01579279}, {130,0.01499099}, {131,0.01606306}, {132,0.01504505}, {133,0.01613514}, {134,0.01528829}, {135,0.01645045}, {136,0.01541441}, {137,0.01657658}, {138,0.01591892}, {139,0.01697297}, {140,0.01601802}, {141,0.01709009}, {142,0.01619820}, {143,0.01644144}, {144,0.01618919}, {145,0.01650450}, {146,0.01672072}, {147,0.01692793}, {148,0.01690090}, {149,0.01704505}, {150,0.01890991}, {151,0.01721622}, {152,0.01781982}, {153,0.01742342}, {154,0.01755856}, {155,0.01779279}, {156,0.01783784}, {157,0.01966667}, {158,0.01806306}, {159,0.01818919}, {160,0.01803604}, {161,0.01818919}, {162,0.01987387}, {163,0.01845045}, {164,0.01854054}, {165,0.01885586}, {166,0.01890991}, {167,0.02066667}, {168,0.01899099}, {169,0.01907207}, {170,0.01914414}, {171,0.01931532}, {172,0.01936036}, {173,0.01971171}, {174,0.01983784}, {175,0.02143243}, {176,0.01981982}, {177,0.02004505}, {178,0.02157658}, {179,0.02025225}, {180,0.02019820}, {181,0.02212613}, {182,0.02072072}, {183,0.02090090}, {184,0.02208108}, {185,0.02102703}, {186,0.02109009}, {187,0.02124324}, {188,0.02121622}, {189,0.02147748}, {190,0.02149550}, {191,0.02304505}, {192,0.02128829}, {193,0.02163063}, {194,0.02183784}, {195,0.02199099}, {196,0.02199099}, {197,0.02212613}, {198,0.02350450}, {199,0.02245045}, {200,0.02220721}, {201,0.02251351}, {202,0.02379279}, {203,0.02294595}, {204,0.02292793}, {205,0.02314414}, {206,0.02418018}, {207,0.02341441}, {208,0.02321622}, {209,0.02334234}, {210,0.02457658}, {211,0.02377477}, {212,0.02373874}, {213,0.02405405}, {214,0.02414414}, {215,0.02519820}, {216,0.02410811}, {217,0.02428829}, {218,0.02448649}, {219,0.02470270}, {220,0.02567568}, {221,0.02499099}, {222,0.02505405}, {223,0.02518919}, {224,0.02491892}, {225,0.02517117}, {226,0.02626126}, {227,0.02541441}, {228,0.02544144}, {229,0.02573874}, {230,0.02587387}, {231,0.02604505}, {232,0.02693694}, {233,0.02767568}, {234,0.02618018}, {235,0.02637838}, {236,0.02634234}, {237,0.02684685}, {238,0.02681081}, {239,0.02707207}, {240,0.02782883}, {241,0.02863063}, {242,0.02911712}, {243,0.02727027}, {244,0.02722523}, {245,0.02744144}, {246,0.02774775}, {247,0.02796396}, {248,0.02768468}, {249,0.02792793}, {250,0.02803604}, {251,0.02903604}, {252,0.02921622}, {253,0.03003604}, {254,0.03001802}, {255,0.03021622}, {256,0.02991892}, {257,0.02844144}, {258,0.02863964}, {259,0.02890991}, {260,0.02880180}, {261,0.02904505}, {262,0.02922523}, {263,0.02943243}, {264,0.02921622}, {265,0.02935135}, {266,0.02961261}, {267,0.02994595}, {268,0.02984685}, {269,0.03012613}, {270,0.03021622}, {271,0.03055856}, {272,0.03009910}, {273,0.03031532}, {274,0.03046847}, {275,0.03080180}, {276,0.03063063}, {277,0.03110811}, {278,0.03103604}, {279,0.03147748}, {280,0.03105405}, {281,0.03141441}, {282,0.03151351}, {283,0.03183784}, {284,0.03177477}, {285,0.03201802}, {286,0.03209910}, {287,0.03355856}, {288,0.03312613}, {289,0.03337838}, {290,0.03348649}, {291,0.03375676}, {292,0.03248649}, {293,0.03272973}, {294,0.03274775}, {295,0.03318018}, {296,0.03272072}, {297,0.03321622}, {298,0.03327027}, {299,0.03354955}, {300,0.03458559}, {301,0.03502703}, {302,0.03462162}, {303,0.03414414}, {304,0.03372072}, {305,0.03400000}, {306,0.03409009}, {307,0.03437838}, {308,0.03557658}, {309,0.03580180}, {310,0.03482883}, {311,0.03497297}, {312,0.03469369}, {313,0.03507207}, {314,0.03885586}, {315,0.03684685}, {316,0.03524324}, {317,0.03557658}, {318,0.03572072}, {319,0.03613514}, {320,0.03631532}, {321,0.03640541}, {322,0.03555856}, {323,0.03584685}, {324,0.03583784}, {325,0.03907207}, {326,0.03726126}, {327,0.03646847}, {328,0.03621622}, {329,0.03662162}, {330,0.03972072}, {331,0.03798198}, {332,0.03690090}, {333,0.03724324}, {334,0.03734234}, {335,0.03864865}, {336,0.03717117}, {337,0.03736937}, {338,0.03752252}, {339,0.04129730}, {340,0.03772072}, {341,0.03803604}, {342,0.03819820}, {343,0.03957658}, {344,0.03816216}, {345,0.03849550}, {346,0.04176577}, {347,0.03986486}, {348,0.03881081}, {349,0.03922523}, {350,0.04263964}, {351,0.03971171}, {352,0.03880180}, {353,0.04260360}, {354,0.03924324}, {355,0.03954955}, {356,0.04268468}, {357,0.04051351}, {358,0.03988288}, {359,0.04382883}, {360,0.04077477}, {361,0.04016216}, {362,0.04427027}, {363,0.04142342}, {364,0.04050450}, {365,0.04400000}, {366,0.04100901}, {367,0.04123423}, {368,0.04409910}, {369,0.04094595}, {370,0.04109009}, {371,0.04500901}, {372,0.04130631}, {373,0.04558559}, {374,0.04237838}, {375,0.04205405}, {376,0.04527027}, {377,0.04223423}, {378,0.04212613}, {379,0.04348649}, {380,0.04236036}, {381,0.04633333}, {382,0.04293694}, {383,0.04649550}, {384,0.04199099}, {385,0.04224324}, {386,0.04355856}, {387,0.04297297}, {388,0.04584685}, {389,0.04322523}, {390,0.04662162}, {391,0.04354955}, {392,0.04312613}, {393,0.04680180}, {394,0.04349550}, {395,0.04718018}, {396,0.04390090}, {397,0.04722523}, {398,0.04428829}, {399,0.04760360}, {400,0.04392793}, {401,0.04725225}, {402,0.04441441}, {403,0.04479279}, {404,0.04473874}, {405,0.04512613}, {406,0.04516216}, {407,0.04554054}, {408,0.04510811}, {409,0.04548649}, {410,0.04575676}, {411,0.04998198}, {412,0.04587387}, {413,0.04909009}, {414,0.04635135}, {415,0.04972973}, {416,0.04559459}, {417,0.04914414}, {418,0.04619820}, {419,0.04981982}, {420,0.04645045}, {421,0.05020721}, {422,0.04682883}, {423,0.04727928}, {424,0.05094595}, {425,0.04725225}, {426,0.05048649}, {427,0.04764865}, {428,0.05088288}, {429,0.04780180}, {430,0.04811712}, {431,0.05155856}, {432,0.04774775}, {433,0.05154955}, {434,0.04825225}, {435,0.04860360}, {436,0.05142342}, {437,0.04876577}, {438,0.05229730}, {439,0.05220721}, {440,0.04879279}, {441,0.05262162}, {442,0.04941441}, {443,0.04969369}, {444,0.05266667}, {445,0.04993694}, {446,0.05002703}, {447,0.05373874}, {448,0.04907207}, {449,0.04963063}, {450,0.05280180}, {451,0.04996396}, {452,0.04990991}, {453,0.05331532}, {454,0.05034234}, {455,0.05075676}, {456,0.05346847}, {457,0.05051351}, {458,0.05074775}, {459,0.05433333}, {460,0.05099099}, {461,0.05134234}, {462,0.05500000}, {463,0.05480180}, {464,0.05100901}, {465,0.05149550}, {466,0.05487387}, {467,0.05206306}, {468,0.05185586}, {469,0.05591892}, {470,0.05545946}, {471,0.05270270}, {472,0.05210811}, {473,0.05592793}, {474,0.05590991}, {475,0.05317117}, {476,0.05291892}, {477,0.05694595}, {478,0.05680180}, {479,0.05685586}, {480,0.05274775}, {481,0.05325225}, {482,0.05689189}, {483,0.05693694}, {484,0.05350450}, {485,0.05391892}, {486,0.05408108}, {487,0.05797297}, {488,0.05679279}, {489,0.05437838}, {490,0.05436937}, {491,0.05485586}, {492,0.05801802}, {493,0.05826126}, {494,0.05789189}, {495,0.05568468}, {496,0.05477477}, {497,0.05518919}, {498,0.05878378}, {499,0.05926126}, {500,0.05858559}, {505,0.05909910}, {510,0.05743243}, {515,0.05683784}, {520,0.05693694}, {525,0.05834234}, {530,0.05863964}, {535,0.06372973}, {540,0.06368468}, {545,0.06307207}, {550,0.06419820}, {555,0.06523423}, {560,0.06157658}, {565,0.06311712}, {570,0.06346847}, {575,0.06497297}, {580,0.06651351}, {585,0.06772072}, {590,0.06889189}, {595,0.06951351}, {600,0.06650450}, {605,0.07022523}, {610,0.07062162}, {615,0.07241441}, {620,0.06890991}, {625,0.07238739}, {630,0.07398198}, {635,0.07155856}, {640,0.07268468}, {645,0.07456757}, {650,0.07542342}, {655,0.07644144}, {660,0.07303604}, {665,0.07675676}, {670,0.07510811}, {675,0.07779279}, {680,0.07527928}, {685,0.07944144}, {690,0.07679279}, {695,0.08137838}, {700,0.08053153}, {705,0.08118919}, {710,0.08159459}, {715,0.08020721}, {720,0.08289189}, {725,0.08379279}, {730,0.08200901}, {735,0.08681081}, {740,0.08532432}, {745,0.08568468}, {750,0.08779279}, {755,0.08514414}, {760,0.08828829}, {765,0.08962162}, {770,0.08751351}, {775,0.09015315}, {780,0.09071171}, {785,0.09282883}, {790,0.08836937}, {795,0.09341441}, {800,0.09236937}, {805,0.09414414}, {810,0.09367568}, {815,0.09560360}, {820,0.09448649}, {825,0.09565766}, {830,0.09421622}, {835,0.09536937}, {840,0.09500000}, {845,0.09714414}, {850,0.09721622}, {855,0.09960360}, {860,0.09974775}, {865,0.10364865}, {870,0.10085586}, {875,0.10164865}, {880,0.10159459}, {885,0.10553153}, {890,0.10296396}, {895,0.10600000}, {900,0.10189189}, {905,0.10353153}, {910,0.10571171}, {915,0.10492793}, {920,0.10577477}, {925,0.11036036}, {930,0.10644144}, {935,0.10915315}, {940,0.10821622}, {945,0.11483784}, {950,0.11022523}, {955,0.11151351}, {960,0.10938739}, {965,0.11039640}, {970,0.11241441}, {975,0.11334234}, {980,0.11287387}, {985,0.11473874}, {990,0.11527928}, {995,0.11454955}, {1000,0.11945946}, {1010,0.11707207}, {1020,0.11839640}, {1030,0.11792793}, {1040,0.11755856}, {1050,0.12451818}, {1060,0.12119091}, {1070,0.12380909}, {1080,0.12400909}, {1090,0.12425455}, {1100,0.12598182}, {1110,0.12846364}, {1120,0.12875455}, {1130,0.13020909}, {1140,0.13076364}, {1150,0.13418182}, {1160,0.13288182}, {1170,0.13323636}, {1180,0.13567273}, {1190,0.13783636}, {1200,0.13650909}, {1210,0.14156364}, {1220,0.13879091}, {1230,0.14371818}, {1240,0.14274545}, {1250,0.14567273}, {1260,0.14666364}, {1270,0.14844545}, {1280,0.14369091}, {1290,0.14932727}, {1300,0.14912727}, {1310,0.15529091}, {1320,0.15055455}, {1330,0.15225455}, {1340,0.15476364}, {1350,0.15442727}, {1360,0.15501818}, {1370,0.15839091}, {1380,0.15980000}, {1390,0.16221818}, {1400,0.16153636}, {1410,0.15990909}, {1420,0.16756364}, {1430,0.16691818}, {1440,0.17180909}, {1450,0.17221818}, {1460,0.16860909}, {1470,0.17486364}, {1480,0.16894545}, {1490,0.17152727}, {1500,0.17533636}, {1510,0.17608182}, {1520,0.17472727}, {1530,0.17858182}, {1540,0.17462727}, {1550,0.17870000}, {1560,0.17802727}, {1570,0.18274545}, {1580,0.18140000}, {1590,0.18563636}, {1600,0.21586364}, {1610,0.20343636}, {1620,0.18623636}, {1630,0.19036364}, {1640,0.18941818}, {1650,0.19655455}, {1660,0.19430909}, {1670,0.19082727}, {1680,0.19608182}, {1690,0.20003636}, {1700,0.19419091}, {1710,0.19883636}, {1720,0.20104545}, {1730,0.19886364}, {1740,0.20160909}, {1750,0.20403636}, {1760,0.20141818}, {1770,0.21108182}, {1780,0.20708182}, {1790,0.21046364}, {1800,0.20502727}, {1810,0.21191818}, {1820,0.21028182}, {1830,0.21136364}, {1840,0.21131818}, {1850,0.21514545}, {1860,0.21300909}, {1870,0.22197273}, {1880,0.21692727}, {1890,0.21820909}, {1900,0.22078182}, {1910,0.22373636}, {1920,0.22266364}, {1930,0.23247273}, {1940,0.23069091}, {1950,0.22834545}, {1960,0.23582727}, {1970,0.22882727}, {1980,0.23350909}, {1990,0.23170000}, {2000,0.23615455}, {2050,0.23393636}, {2100,0.24734545}, {2150,0.25260000}, {2200,0.25502727}, {2250,0.26259091}, {2300,0.27456364}, {2350,0.27695455}, {2400,0.27865455}, {2450,0.29586364}, {2500,0.29274545}, {2550,0.30391818}, {2600,0.30501818}, {2650,0.31410909}, {2700,0.31628182}, {2750,0.32839091}, {2800,0.33081818}, {2850,0.34488182}, {2900,0.34249091}, {2950,0.34876364}, {3000,0.36414545}, {3050,0.37589091}, {3100,0.36748182}, {3150,0.37277273}, {3200,0.37012727}, {3250,0.39449091}, {3300,0.39744545}, {3350,0.40844545}, {3400,0.40110000}, {3450,0.41619091}, {3500,0.43305455}, {3550,0.42550000}, {3600,0.42053636}, {3650,0.43688182}, {3700,0.44087273}, {3750,0.45798182}, {3800,0.45780000}, {3850,0.45650909}, {3900,0.47325455}, {3950,0.48829091}, {4000,0.47574545}, {4050,0.49998182}, {4100,0.49928182}, {4150,0.50528182}, {4200,0.50991818}, {4250,0.53167273}, {4300,0.51824545}, {4350,0.54166364}, {4400,0.53216364}, {4450,0.53471818}, {4500,0.54215455}, {4550,0.56945455}, {4600,0.57358182}, {4650,0.57020000}, {4700,0.58512727}, {4750,0.59385455}, {4800,0.58237273}, {4850,0.60236364}, {4900,0.60146364}, {4950,0.61324545}, {5000,0.61337273}, {5050,0.63188182}, {5100,0.63252727}, {5150,0.66632727}, {5200,0.62843636}, {5250,0.63823636}, {5300,0.66772727}, {5350,0.66650909}, {5400,0.67186364}, {5450,0.67091818}, {5500,0.68600000}, {5550,0.70882727}, {5600,0.69124545}, {5650,0.69080909}, {5700,0.68320909}, {5750,0.70421818}, {5800,0.70976364}, {5850,0.72577273}, {5900,0.71472727}, {5950,0.71392727}, {6000,0.73960909}, {6050,0.75975}, {6100,0.76650}, {6150,0.74750}, {6200,0.78700}, {6250,0.78425}, {6300,0.77900}, {6350,0.78425}, {6400,0.77325}, {6450,0.81025}, {6500,0.80275}, {6550,0.81400}, {6600,0.80625}, {6650,0.86900}, {6700,0.84700}, {6750,0.87125}, {6800,0.83375}, {6850,0.86425}, {6900,0.87275}, {6950,0.85600}, {7000,0.88700}, {7050,0.87850}, {7100,0.88825}, {7150,0.90775}, {7200,0.91400}, {7250,0.94050}, {7300,0.92025}, {7350,0.91575}, {7400,0.94150}, {7450,0.97250}, {7500,0.94925}, {7550,1.00300}, {7600,0.96725}, {7650,0.99150}, {7700,1.00275}, {7750,0.96700}, {7800,0.99725}, {7850,1.00325}, {7900,1.01100}, {7950,0.98875}, {8000,0.98125}, {8050,1.04525}, {8100,1.01575}, {8150,1.05400}, {8200,1.00300}, {8250,1.04900}, {8300,1.08350}, {8350,1.07900}, {8400,1.02600}, {8450,1.05300}, {8500,1.05550}, {8550,1.04275}, {8600,1.08150}, {8650,1.11875}, {8700,1.10075}, {8750,1.11100}, {8800,1.07850}, {8850,1.11575}, {8900,1.13300}, {8950,1.12275}, {9000,1.11450}, {9050,1.11275}, {9100,1.15100}, {9150,1.17725}, {9200,1.14150}, {9250,1.14275}, {9300,1.16350}, {9350,1.16525}, {9400,1.18700}, {9450,1.17025}, {9500,1.16500}, {9550,1.17450}, {9600,1.20725}, {9650,1.17650}, {9700,1.19500}, {9750,1.19925}, {9800,1.21150}, {9850,1.25800}, {9900,1.24150}, {9950,1.26125}, {10000,1.22450}, {10100,1.25875}, {10200,1.23800}, {10300,1.30075}, {10400,1.26950}, {10500,1.25025}, {10600,1.28850}, {10700,1.33225}, {10800,1.28475}, {10900,1.36975}, {11000,1.38775}, {11100,1.40375}, {11200,1.36875}, {11300,1.41450}, {11400,1.38700}, {11500,1.44100}, {11600,1.38225}, {11700,1.43050}, {11800,1.43650}, {11900,1.50475}, {12000,1.48600}, {12100,1.51400}, {12200,1.52775}, {12300,1.50900}, {12400,1.52200}, {12500,1.54400}, {12600,1.60200}, {12700,1.61275}, {12800,1.58425}, {12900,1.59900}, {13000,1.60800}, {13100,1.65825}, {13200,1.65800}, {13300,1.68150}, {13400,1.64725}, {13500,1.70125}, {13600,1.68000}, {13700,1.71150}, {13800,1.75875}, {13900,1.73525}, {14000,1.74250}, {14100,1.75750}, {14200,1.85425}, {14300,1.86750}, {14400,1.78200}, {14500,1.80975}, {14600,1.83850}, {14700,1.94375}, {14800,1.93400}, {14900,1.89925}, {15000,1.94425}, {15100,1.94875}, {15200,1.94675}, {15300,1.95025}, {15400,1.96100}, {15500,1.94250}, {15600,2.07875}, {15700,1.99200}, {15800,2.06650}, {15900,2.06675}, {16000,2.03550}, {16100,2.09725}, {16200,2.10400}, {16300,2.18025}, {16400,2.05350}, {16500,2.08100}, {16600,2.17975}, {16700,2.20350}, {16800,2.09175}, {16900,2.09750}, {17000,2.19300}, {17100,2.19675}, {17200,2.18100}, {17300,2.24100}, {17400,2.38275}, {17500,2.21750}, {17600,2.15100}, {17700,2.23750}, {17800,2.21725}, {17900,2.38200}, {18000,2.32025}, {18100,2.38775}, {18200,2.41300}, {18300,2.35850}, {18400,2.34900}, {18500,2.34975}, {18600,2.32750}, {18700,2.43025}, {18800,2.46975}, {18900,2.45600}, {19000,2.43025}, {19100,2.52550}, {19200,2.43925}, {19300,2.56050}, {19400,2.53225}, {19500,2.60325}, {19600,2.43925}, {19700,2.63850}, {19800,2.59550}, {19900,2.58175}, {20000,2.5570}};
data["big_flat"]["CanonicalStructuresHOAS"]["Aggregate"]["user"] = {{1,0.00144144}, {2,0.00170270}, {3,0.00141441}, {4,0.00147748}, {5,0.00192793}, {6,0.00171171}, {7,0.00182883}, {8,0.00200000}, {9,0.00220721}, {10,0.00222523}, {11,0.00239640}, {12,0.00256757}, {13,0.00245045}, {14,0.01927928}, {15,0.00262162}, {16,0.00280180}, {17,0.00289189}, {18,0.00299099}, {19,0.00302703}, {20,0.00308108}, {21,0.00317117}, {22,0.00327928}, {23,0.00344144}, {24,0.00354054}, {25,0.00365766}, {26,0.00352252}, {27,0.00407207}, {28,0.00383784}, {29,0.00388288}, {30,0.00434234}, {31,0.00447748}, {32,0.00456757}, {33,0.00455856}, {34,0.00463063}, {35,0.00438739}, {36,0.00476577}, {37,0.00500901}, {38,0.00505405}, {39,0.00641441}, {40,0.00531532}, {41,0.00512613}, {42,0.00536036}, {43,0.00541441}, {44,0.00591892}, {45,0.00664865}, {46,0.00601802}, {47,0.00630631}, {48,0.00611712}, {49,0.00647748}, {50,0.00738739}, {51,0.00649550}, {52,0.00680180}, {53,0.00660360}, {54,0.00680180}, {55,0.00791892}, {56,0.00718919}, {57,0.00736036}, {58,0.00722523}, {59,0.00742342}, {60,0.00761261}, {61,0.00767568}, {62,0.00799099}, {63,0.00797297}, {64,0.00812613}, {65,0.00819820}, {66,0.00832432}, {67,0.00809910}, {68,0.00840541}, {69,0.00872973}, {70,0.00845045}, {71,0.01020721}, {72,0.00910811}, {73,0.00907207}, {74,0.00934234}, {75,0.00970270}, {76,0.00922523}, {77,0.00970270}, {78,0.01061261}, {79,0.00984685}, {80,0.00970270}, {81,0.00989189}, {82,0.00994595}, {83,0.01018919}, {84,0.01019820}, {85,0.01079279}, {86,0.01029730}, {87,0.01090991}, {88,0.01039640}, {89,0.01103604}, {90,0.01075676}, {91,0.01113514}, {92,0.01133333}, {93,0.01161261}, {94,0.01140541}, {95,0.01182883}, {96,0.01276577}, {97,0.01172973}, {98,0.01182883}, {99,0.01186486}, {100,0.01195495}, {101,0.01234234}, {102,0.01225225}, {103,0.01234234}, {104,0.01351351}, {105,0.01258559}, {106,0.01271171}, {107,0.01272072}, {108,0.01288288}, {109,0.01378378}, {110,0.01297297}, {111,0.01297297}, {112,0.01308108}, {113,0.01359459}, {114,0.01328829}, {115,0.01332432}, {116,0.01435135}, {117,0.01331532}, {118,0.01328829}, {119,0.01384685}, {120,0.01387387}, {121,0.01393694}, {122,0.01424324}, {123,0.01436937}, {124,0.01413514}, {125,0.01446847}, {126,0.01461261}, {127,0.01577477}, {128,0.01454054}, {129,0.01553153}, {130,0.01469369}, {131,0.01597297}, {132,0.01481081}, {133,0.01613514}, {134,0.01527928}, {135,0.01629730}, {136,0.01515315}, {137,0.01684685}, {138,0.01576577}, {139,0.01716216}, {140,0.01583784}, {141,0.01717117}, {142,0.01612613}, {143,0.01642342}, {144,0.01601802}, {145,0.01645946}, {146,0.01648649}, {147,0.01693694}, {148,0.01675676}, {149,0.01691892}, {150,0.01874775}, {151,0.01718919}, {152,0.01785586}, {153,0.01720721}, {154,0.01736036}, {155,0.01767568}, {156,0.01761261}, {157,0.01954955}, {158,0.01826126}, {159,0.01815315}, {160,0.01785586}, {161,0.01855856}, {162,0.01998198}, {163,0.01852252}, {164,0.01842342}, {165,0.01889189}, {166,0.01901802}, {167,0.02112613}, {168,0.01892793}, {169,0.01913514}, {170,0.01935135}, {171,0.01964865}, {172,0.01937838}, {173,0.01983784}, {174,0.01969369}, {175,0.02180180}, {176,0.01972973}, {177,0.02038739}, {178,0.02159459}, {179,0.02061261}, {180,0.02049550}, {181,0.02238739}, {182,0.02104505}, {183,0.02113514}, {184,0.02218919}, {185,0.02102703}, {186,0.02127027}, {187,0.02140541}, {188,0.02127027}, {189,0.02138739}, {190,0.02178378}, {191,0.02309910}, {192,0.02180180}, {193,0.02209910}, {194,0.02229730}, {195,0.02200901}, {196,0.02242342}, {197,0.02257658}, {198,0.02371171}, {199,0.02278378}, {200,0.02291892}, {201,0.02284685}, {202,0.02402703}, {203,0.02309009}, {204,0.02303604}, {205,0.02357658}, {206,0.02463964}, {207,0.02396396}, {208,0.02376577}, {209,0.02384685}, {210,0.02472973}, {211,0.02388288}, {212,0.02419820}, {213,0.02421622}, {214,0.02436937}, {215,0.02513514}, {216,0.02418919}, {217,0.02463964}, {218,0.02473874}, {219,0.02498198}, {220,0.02598198}, {221,0.02494595}, {222,0.02506306}, {223,0.02530631}, {224,0.02491892}, {225,0.02527928}, {226,0.02603604}, {227,0.02565766}, {228,0.02557658}, {229,0.02551351}, {230,0.02562162}, {231,0.02578378}, {232,0.02670270}, {233,0.02750450}, {234,0.02635135}, {235,0.02637838}, {236,0.02653153}, {237,0.02689189}, {238,0.02653153}, {239,0.02682883}, {240,0.02755856}, {241,0.02820721}, {242,0.02904505}, {243,0.02713514}, {244,0.02708108}, {245,0.02712613}, {246,0.02741441}, {247,0.02759459}, {248,0.02739640}, {249,0.02769369}, {250,0.02769369}, {251,0.02939640}, {252,0.02913514}, {253,0.02972072}, {254,0.02983784}, {255,0.03022523}, {256,0.02995495}, {257,0.02782883}, {258,0.02809009}, {259,0.02855856}, {260,0.02870270}, {261,0.02870270}, {262,0.02896396}, {263,0.02945946}, {264,0.02904505}, {265,0.02934234}, {266,0.02923423}, {267,0.02963964}, {268,0.02965766}, {269,0.03035135}, {270,0.02990090}, {271,0.03033333}, {272,0.03021622}, {273,0.03014414}, {274,0.03045045}, {275,0.03072072}, {276,0.03068468}, {277,0.03082883}, {278,0.03134234}, {279,0.03146847}, {280,0.03083784}, {281,0.03146847}, {282,0.03163964}, {283,0.03199099}, {284,0.03178378}, {285,0.03250450}, {286,0.03214414}, {287,0.03382883}, {288,0.03330631}, {289,0.03382883}, {290,0.03338739}, {291,0.03371171}, {292,0.03272973}, {293,0.03305405}, {294,0.03285586}, {295,0.03314414}, {296,0.03266667}, {297,0.03332432}, {298,0.03317117}, {299,0.03343243}, {300,0.03495495}, {301,0.03529730}, {302,0.03500000}, {303,0.03438739}, {304,0.03405405}, {305,0.03409009}, {306,0.03436937}, {307,0.03459459}, {308,0.03572973}, {309,0.03613514}, {310,0.03516216}, {311,0.03523423}, {312,0.03470270}, {313,0.03547748}, {314,0.03859459}, {315,0.03709009}, {316,0.03570270}, {317,0.03576577}, {318,0.03611712}, {319,0.03644144}, {320,0.03638739}, {321,0.03665766}, {322,0.03592793}, {323,0.03579279}, {324,0.03592793}, {325,0.03878378}, {326,0.03723423}, {327,0.03654054}, {328,0.03649550}, {329,0.03684685}, {330,0.03936937}, {331,0.03751351}, {332,0.03663063}, {333,0.03747748}, {334,0.03716216}, {335,0.03822523}, {336,0.03732432}, {337,0.03742342}, {338,0.03767568}, {339,0.04136036}, {340,0.03782883}, {341,0.03807207}, {342,0.03787387}, {343,0.03920721}, {344,0.03835135}, {345,0.03838739}, {346,0.04188288}, {347,0.03938739}, {348,0.03872973}, {349,0.03889189}, {350,0.04285586}, {351,0.03943243}, {352,0.03848649}, {353,0.04240541}, {354,0.03917117}, {355,0.03930631}, {356,0.04250450}, {357,0.03994595}, {358,0.03970270}, {359,0.04389189}, {360,0.04091892}, {361,0.03983784}, {362,0.04414414}, {363,0.04122523}, {364,0.04035135}, {365,0.04434234}, {366,0.04067568}, {367,0.04118919}, {368,0.04411712}, {369,0.04065766}, {370,0.04086486}, {371,0.04518018}, {372,0.04127027}, {373,0.04583784}, {374,0.04229730}, {375,0.04186486}, {376,0.04554955}, {377,0.04239640}, {378,0.04207207}, {379,0.04336937}, {380,0.04230631}, {381,0.04666667}, {382,0.04290991}, {383,0.04629730}, {384,0.04212613}, {385,0.04198198}, {386,0.04348649}, {387,0.04281982}, {388,0.04604505}, {389,0.04328829}, {390,0.04718919}, {391,0.04356757}, {392,0.04342342}, {393,0.04713514}, {394,0.04352252}, {395,0.04747748}, {396,0.04427928}, {397,0.04745946}, {398,0.04471171}, {399,0.04773874}, {400,0.04378378}, {401,0.04761261}, {402,0.04425225}, {403,0.04533333}, {404,0.04475676}, {405,0.04557658}, {406,0.04522523}, {407,0.04558559}, {408,0.04522523}, {409,0.04550450}, {410,0.04603604}, {411,0.04980180}, {412,0.04605405}, {413,0.04906306}, {414,0.04654955}, {415,0.05000901}, {416,0.04589189}, {417,0.04919820}, {418,0.04670270}, {419,0.04948649}, {420,0.04667568}, {421,0.04980180}, {422,0.04706306}, {423,0.04764865}, {424,0.05071171}, {425,0.04736036}, {426,0.05044144}, {427,0.04796396}, {428,0.05064865}, {429,0.04817117}, {430,0.04848649}, {431,0.05123423}, {432,0.04779279}, {433,0.05109910}, {434,0.04852252}, {435,0.04866667}, {436,0.05100000}, {437,0.04878378}, {438,0.05205405}, {439,0.05200901}, {440,0.04897297}, {441,0.05211712}, {442,0.04962162}, {443,0.04957658}, {444,0.05234234}, {445,0.04979279}, {446,0.05006306}, {447,0.05389189}, {448,0.04925225}, {449,0.04973874}, {450,0.05222523}, {451,0.05020721}, {452,0.04976577}, {453,0.05326126}, {454,0.05021622}, {455,0.05061261}, {456,0.05310811}, {457,0.05035135}, {458,0.05041441}, {459,0.05438739}, {460,0.05052252}, {461,0.05107207}, {462,0.05487387}, {463,0.05483784}, {464,0.05093694}, {465,0.05127027}, {466,0.05431532}, {467,0.05158559}, {468,0.05170270}, {469,0.05546847}, {470,0.05516216}, {471,0.05236937}, {472,0.05184685}, {473,0.05613514}, {474,0.05571171}, {475,0.05316216}, {476,0.05318018}, {477,0.05719820}, {478,0.05655856}, {479,0.05690991}, {480,0.05246847}, {481,0.05281081}, {482,0.05700901}, {483,0.05647748}, {484,0.05294595}, {485,0.05389189}, {486,0.05427027}, {487,0.05815315}, {488,0.05684685}, {489,0.05419820}, {490,0.05373874}, {491,0.05495495}, {492,0.05794595}, {493,0.05846847}, {494,0.05762162}, {495,0.05557658}, {496,0.05466667}, {497,0.05480180}, {498,0.05876577}, {499,0.05951351}, {500,0.05874775}, {505,0.05895495}, {510,0.05729730}, {515,0.05660360}, {520,0.05746847}, {525,0.05842342}, {530,0.05877477}, {535,0.06355856}, {540,0.06347748}, {545,0.06284685}, {550,0.06394595}, {555,0.06497297}, {560,0.06166667}, {565,0.06262162}, {570,0.06328829}, {575,0.06495495}, {580,0.06641441}, {585,0.06766667}, {590,0.06859459}, {595,0.06952252}, {600,0.06653153}, {605,0.07031532}, {610,0.07087387}, {615,0.07244144}, {620,0.06923423}, {625,0.07228829}, {630,0.07386486}, {635,0.07173874}, {640,0.07277477}, {645,0.07444144}, {650,0.07515315}, {655,0.07623423}, {660,0.07293694}, {665,0.07638739}, {670,0.07518018}, {675,0.07763063}, {680,0.07511712}, {685,0.07931532}, {690,0.07646847}, {695,0.08111712}, {700,0.08044144}, {705,0.08147748}, {710,0.08185586}, {715,0.08041441}, {720,0.08310811}, {725,0.08329730}, {730,0.08229730}, {735,0.08645946}, {740,0.08502703}, {745,0.08572973}, {750,0.08759459}, {755,0.08528829}, {760,0.08806306}, {765,0.08931532}, {770,0.08723423}, {775,0.08989189}, {780,0.09053153}, {785,0.09272072}, {790,0.08811712}, {795,0.09353153}, {800,0.09227928}, {805,0.09437838}, {810,0.09382883}, {815,0.09554955}, {820,0.09475676}, {825,0.09563964}, {830,0.09412613}, {835,0.09552252}, {840,0.09490991}, {845,0.09684685}, {850,0.09694595}, {855,0.09930631}, {860,0.09970270}, {865,0.10358559}, {870,0.10054955}, {875,0.10112613}, {880,0.10118919}, {885,0.10510811}, {890,0.10279279}, {895,0.10612613}, {900,0.10192793}, {905,0.10300000}, {910,0.10571171}, {915,0.10477477}, {920,0.10570270}, {925,0.10994595}, {930,0.10617117}, {935,0.10911712}, {940,0.10835135}, {945,0.11478378}, {950,0.11020721}, {955,0.11138739}, {960,0.10927027}, {965,0.11019820}, {970,0.11210811}, {975,0.11328829}, {980,0.11256757}, {985,0.11463964}, {990,0.11468468}, {995,0.11429730}, {1000,0.11897297}, {1010,0.11710811}, {1020,0.11825225}, {1030,0.11784685}, {1040,0.11746847}, {1050,0.12392727}, {1060,0.12124545}, {1070,0.12329091}, {1080,0.12369091}, {1090,0.12393636}, {1100,0.12555455}, {1110,0.12845455}, {1120,0.12825455}, {1130,0.13020909}, {1140,0.13099091}, {1150,0.13399091}, {1160,0.13229091}, {1170,0.13278182}, {1180,0.13516364}, {1190,0.13762727}, {1200,0.13592727}, {1210,0.14151818}, {1220,0.13837273}, {1230,0.14384545}, {1240,0.14238182}, {1250,0.14507273}, {1260,0.14643636}, {1270,0.14848182}, {1280,0.14353636}, {1290,0.14864545}, {1300,0.14870000}, {1310,0.15484545}, {1320,0.15027273}, {1330,0.15203636}, {1340,0.15492727}, {1350,0.15425455}, {1360,0.15455455}, {1370,0.15830000}, {1380,0.15947273}, {1390,0.16220909}, {1400,0.16083636}, {1410,0.16000909}, {1420,0.16764545}, {1430,0.16691818}, {1440,0.17131818}, {1450,0.17212727}, {1460,0.16859091}, {1470,0.17466364}, {1480,0.16849091}, {1490,0.17137273}, {1500,0.17470909}, {1510,0.17550909}, {1520,0.17443636}, {1530,0.17845455}, {1540,0.17414545}, {1550,0.17870000}, {1560,0.17780000}, {1570,0.18248182}, {1580,0.18133636}, {1590,0.18539091}, {1600,0.21546364}, {1610,0.20311818}, {1620,0.18572727}, {1630,0.19020000}, {1640,0.18921818}, {1650,0.19641818}, {1660,0.19413636}, {1670,0.19078182}, {1680,0.19563636}, {1690,0.19980000}, {1700,0.19387273}, {1710,0.19838182}, {1720,0.20063636}, {1730,0.19872727}, {1740,0.20176364}, {1750,0.20362727}, {1760,0.20125455}, {1770,0.21097273}, {1780,0.20690000}, {1790,0.21004545}, {1800,0.20470000}, {1810,0.21179091}, {1820,0.20991818}, {1830,0.21124545}, {1840,0.21129091}, {1850,0.21504545}, {1860,0.21298182}, {1870,0.22165455}, {1880,0.21671818}, {1890,0.21829091}, {1900,0.22058182}, {1910,0.22356364}, {1920,0.22280909}, {1930,0.23233636}, {1940,0.23071818}, {1950,0.22825455}, {1960,0.23557273}, {1970,0.22901818}, {1980,0.23302727}, {1990,0.23143636}, {2000,0.23600000}, {2050,0.23345455}, {2100,0.24724545}, {2150,0.25247273}, {2200,0.25481818}, {2250,0.26265455}, {2300,0.27428182}, {2350,0.27687273}, {2400,0.27840000}, {2450,0.29570000}, {2500,0.29245455}, {2550,0.30370909}, {2600,0.30506364}, {2650,0.31361818}, {2700,0.31594545}, {2750,0.32820000}, {2800,0.33069091}, {2850,0.34457273}, {2900,0.34224545}, {2950,0.34856364}, {3000,0.36397273}, {3050,0.37546364}, {3100,0.36730909}, {3150,0.37271818}, {3200,0.36978182}, {3250,0.39388182}, {3300,0.39701818}, {3350,0.40808182}, {3400,0.40072727}, {3450,0.41624545}, {3500,0.43250909}, {3550,0.42475455}, {3600,0.42028182}, {3650,0.43650000}, {3700,0.44054545}, {3750,0.45758182}, {3800,0.45750909}, {3850,0.45591818}, {3900,0.47277273}, {3950,0.48817273}, {4000,0.47510909}, {4050,0.49970909}, {4100,0.49923636}, {4150,0.50480909}, {4200,0.50970000}, {4250,0.53152727}, {4300,0.51803636}, {4350,0.54143636}, {4400,0.53221818}, {4450,0.53460000}, {4500,0.54192727}, {4550,0.56930909}, {4600,0.57339091}, {4650,0.56993636}, {4700,0.58510909}, {4750,0.59319091}, {4800,0.58140000}, {4850,0.60201818}, {4900,0.60091818}, {4950,0.61251818}, {5000,0.61298182}, {5050,0.63157273}, {5100,0.63187273}, {5150,0.66603636}, {5200,0.62829091}, {5250,0.63809091}, {5300,0.66760909}, {5350,0.66613636}, {5400,0.67124545}, {5450,0.67043636}, {5500,0.68561818}, {5550,0.70784545}, {5600,0.69123636}, {5650,0.69060909}, {5700,0.68276364}, {5750,0.70424545}, {5800,0.70972727}, {5850,0.72546364}, {5900,0.71454545}, {5950,0.71367273}, {6000,0.73925455}, {6050,0.75825}, {6100,0.76625}, {6150,0.74575}, {6200,0.78550}, {6250,0.78275}, {6300,0.77675}, {6350,0.78225}, {6400,0.77100}, {6450,0.80825}, {6500,0.80125}, {6550,0.81175}, {6600,0.80525}, {6650,0.86925}, {6700,0.84675}, {6750,0.86900}, {6800,0.83250}, {6850,0.86125}, {6900,0.87325}, {6950,0.85525}, {7000,0.88675}, {7050,0.87775}, {7100,0.88750}, {7150,0.90850}, {7200,0.91250}, {7250,0.93675}, {7300,0.91850}, {7350,0.91525}, {7400,0.94025}, {7450,0.96775}, {7500,0.94625}, {7550,1.00250}, {7600,0.96400}, {7650,0.98850}, {7700,1.00250}, {7750,0.96775}, {7800,0.99675}, {7850,1.00375}, {7900,1.00925}, {7950,0.98800}, {8000,0.97900}, {8050,1.04450}, {8100,1.01675}, {8150,1.05250}, {8200,1.00375}, {8250,1.04950}, {8300,1.08250}, {8350,1.07975}, {8400,1.02600}, {8450,1.04975}, {8500,1.05425}, {8550,1.04350}, {8600,1.08125}, {8650,1.12000}, {8700,1.09975}, {8750,1.10800}, {8800,1.07875}, {8850,1.11550}, {8900,1.13125}, {8950,1.12150}, {9000,1.11575}, {9050,1.11150}, {9100,1.15100}, {9150,1.17675}, {9200,1.14175}, {9250,1.14275}, {9300,1.16400}, {9350,1.16425}, {9400,1.18750}, {9450,1.16900}, {9500,1.16525}, {9550,1.17425}, {9600,1.20650}, {9650,1.17525}, {9700,1.19450}, {9750,1.19850}, {9800,1.21150}, {9850,1.25975}, {9900,1.24200}, {9950,1.26075}, {10000,1.22300}, {10100,1.25850}, {10200,1.23775}, {10300,1.30000}, {10400,1.26925}, {10500,1.24975}, {10600,1.28950}, {10700,1.33250}, {10800,1.28550}, {10900,1.36975}, {11000,1.38750}, {11100,1.40350}, {11200,1.36775}, {11300,1.41400}, {11400,1.38625}, {11500,1.44125}, {11600,1.38100}, {11700,1.43075}, {11800,1.43600}, {11900,1.50550}, {12000,1.48550}, {12100,1.51450}, {12200,1.52875}, {12300,1.50850}, {12400,1.52100}, {12500,1.54525}, {12600,1.60225}, {12700,1.61325}, {12800,1.58250}, {12900,1.59925}, {13000,1.60700}, {13100,1.65825}, {13200,1.65725}, {13300,1.68125}, {13400,1.64575}, {13500,1.70125}, {13600,1.67875}, {13700,1.71050}, {13800,1.75975}, {13900,1.73575}, {14000,1.74200}, {14100,1.75825}, {14200,1.85025}, {14300,1.86775}, {14400,1.78275}, {14500,1.80975}, {14600,1.83650}, {14700,1.94125}, {14800,1.93150}, {14900,1.89925}, {15000,1.94225}, {15100,1.94750}, {15200,1.94650}, {15300,1.95025}, {15400,1.96075}, {15500,1.94250}, {15600,2.07900}, {15700,1.99125}, {15800,2.06550}, {15900,2.06650}, {16000,2.03750}, {16100,2.09675}, {16200,2.10375}, {16300,2.17850}, {16400,2.05250}, {16500,2.08075}, {16600,2.17925}, {16700,2.20325}, {16800,2.09125}, {16900,2.09625}, {17000,2.18975}, {17100,2.19525}, {17200,2.18050}, {17300,2.24050}, {17400,2.38225}, {17500,2.21850}, {17600,2.15075}, {17700,2.23775}, {17800,2.21750}, {17900,2.38075}, {18000,2.31875}, {18100,2.38750}, {18200,2.41375}, {18300,2.35825}, {18400,2.34850}, {18500,2.34925}, {18600,2.32875}, {18700,2.43050}, {18800,2.46800}, {18900,2.45525}, {19000,2.42975}, {19100,2.52450}, {19200,2.44125}, {19300,2.55950}, {19400,2.53150}, {19500,2.60175}, {19600,2.43825}, {19700,2.63725}, {19800,2.59500}, {19900,2.58125}, {20000,2.5555}};
data["big_flat"]["CanonicalStructuresHOAS"]["Aggregate"]["system"] = {{1,0.00017117}, {2,0.00003604}, {3,0.00003604}, {4,0.00007207}, {5,0.00010811}, {6,0.00003604}, {7,0.00003604}, {8,0.00003604}, {9,0.00003604}, {10,0.00003604}, {11,0.00003604}, {12,0.00000000}, {13,0.00010811}, {14,0.00032432}, {15,0.00003604}, {16,0.00003604}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00010811}, {21,0.00007207}, {22,0.00007207}, {23,0.00014414}, {24,0.00018018}, {25,0.00000000}, {26,0.00007207}, {27,0.00003604}, {28,0.00010811}, {29,0.00018018}, {30,0.00007207}, {31,0.00003604}, {32,0.00003604}, {33,0.00010811}, {34,0.00003604}, {35,0.00007207}, {36,0.00014414}, {37,0.00003604}, {38,0.00003604}, {39,0.00000000}, {40,0.00007207}, {41,0.00013514}, {42,0.00007207}, {43,0.00003604}, {44,0.00009910}, {45,0.00006306}, {46,0.00003604}, {47,0.00000000}, {48,0.00007207}, {49,0.00007207}, {50,0.00003604}, {51,0.00003604}, {52,0.00000000}, {53,0.00018018}, {54,0.00014414}, {55,0.00003604}, {56,0.00003604}, {57,0.00000000}, {58,0.00007207}, {59,0.00010811}, {60,0.00009009}, {61,0.00010811}, {62,0.00006306}, {63,0.00007207}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00020721}, {68,0.00010811}, {69,0.00007207}, {70,0.00007207}, {71,0.00007207}, {72,0.00000000}, {73,0.00018018}, {74,0.00007207}, {75,0.00003604}, {76,0.00000000}, {77,0.00003604}, {78,0.00014414}, {79,0.00000000}, {80,0.00000000}, {81,0.00003604}, {82,0.00006306}, {83,0.00003604}, {84,0.00007207}, {85,0.00007207}, {86,0.00003604}, {87,0.00010811}, {88,0.00018018}, {89,0.00018018}, {90,0.00014414}, {91,0.00000000}, {92,0.00003604}, {93,0.00003604}, {94,0.00006306}, {95,0.00010811}, {96,0.00007207}, {97,0.00003604}, {98,0.00003604}, {99,0.00003604}, {100,0.00010811}, {101,0.00003604}, {102,0.00003604}, {103,0.00010811}, {104,0.00007207}, {105,0.00009910}, {106,0.00003604}, {107,0.00003604}, {108,0.00010811}, {109,0.00010811}, {110,0.00006306}, {111,0.00007207}, {112,0.00007207}, {113,0.00003604}, {114,0.00006306}, {115,0.00007207}, {116,0.00007207}, {117,0.00002703}, {118,0.00010811}, {119,0.00009910}, {120,0.00003604}, {121,0.00000000}, {122,0.00007207}, {123,0.00007207}, {124,0.00003604}, {125,0.00007207}, {126,0.00003604}, {127,0.00007207}, {128,0.00006306}, {129,0.00000000}, {130,0.00007207}, {131,0.00007207}, {132,0.00007207}, {133,0.00014414}, {134,0.00007207}, {135,0.00003604}, {136,0.00003604}, {137,0.00018018}, {138,0.00009910}, {139,0.00003604}, {140,0.00000000}, {141,0.00021622}, {142,0.00010811}, {143,0.00003604}, {144,0.00014414}, {145,0.00000000}, {146,0.00009910}, {147,0.00003604}, {148,0.00000000}, {149,0.00014414}, {150,0.00021622}, {151,0.00003604}, {152,0.00007207}, {153,0.00010811}, {154,0.00007207}, {155,0.00003604}, {156,0.00010811}, {157,0.00018018}, {158,0.00000000}, {159,0.00014414}, {160,0.00014414}, {161,0.00003604}, {162,0.00013514}, {163,0.00014414}, {164,0.00003604}, {165,0.00003604}, {166,0.00003604}, {167,0.00007207}, {168,0.00010811}, {169,0.00000000}, {170,0.00007207}, {171,0.00000000}, {172,0.00000000}, {173,0.00003604}, {174,0.00018018}, {175,0.00007207}, {176,0.00013514}, {177,0.00000000}, {178,0.00003604}, {179,0.00003604}, {180,0.00000000}, {181,0.00007207}, {182,0.00003604}, {183,0.00000000}, {184,0.00007207}, {185,0.00003604}, {186,0.00003604}, {187,0.00003604}, {188,0.00000000}, {189,0.00007207}, {190,0.00003604}, {191,0.00007207}, {192,0.00009910}, {193,0.00000000}, {194,0.00000000}, {195,0.00014414}, {196,0.00003604}, {197,0.00007207}, {198,0.00003604}, {199,0.00003604}, {200,0.00003604}, {201,0.00013514}, {202,0.00003604}, {203,0.00007207}, {204,0.00009910}, {205,0.00002703}, {206,0.00000000}, {207,0.00003604}, {208,0.00000000}, {209,0.00000000}, {210,0.00003604}, {211,0.00014414}, {212,0.00007207}, {213,0.00009910}, {214,0.00007207}, {215,0.00007207}, {216,0.00009910}, {217,0.00003604}, {218,0.00003604}, {219,0.00000000}, {220,0.00003604}, {221,0.00009910}, {222,0.00007207}, {223,0.00014414}, {224,0.00010811}, {225,0.00003604}, {226,0.00010811}, {227,0.00007207}, {228,0.00007207}, {229,0.00013514}, {230,0.00003604}, {231,0.00007207}, {232,0.00017117}, {233,0.00002703}, {234,0.00000000}, {235,0.00010811}, {236,0.00003604}, {237,0.00007207}, {238,0.00010811}, {239,0.00010811}, {240,0.00016216}, {241,0.00003604}, {242,0.00007207}, {243,0.00003604}, {244,0.00003604}, {245,0.00018018}, {246,0.00014414}, {247,0.00010811}, {248,0.00003604}, {249,0.00007207}, {250,0.00003604}, {251,0.00010811}, {252,0.00007207}, {253,0.00000000}, {254,0.00010811}, {255,0.00007207}, {256,0.00017117}, {257,0.00000000}, {258,0.00007207}, {259,0.00003604}, {260,0.00010811}, {261,0.00003604}, {262,0.00021622}, {263,0.00010811}, {264,0.00014414}, {265,0.00000000}, {266,0.00006306}, {267,0.00007207}, {268,0.00010811}, {269,0.00003604}, {270,0.00010811}, {271,0.00003604}, {272,0.00003604}, {273,0.00014414}, {274,0.00010811}, {275,0.00014414}, {276,0.00006306}, {277,0.00003604}, {278,0.00003604}, {279,0.00000000}, {280,0.00007207}, {281,0.00007207}, {282,0.00010811}, {283,0.00009910}, {284,0.00014414}, {285,0.00003604}, {286,0.00003604}, {287,0.00010811}, {288,0.00010811}, {289,0.00003604}, {290,0.00003604}, {291,0.00000000}, {292,0.00010811}, {293,0.00009910}, {294,0.00003604}, {295,0.00003604}, {296,0.00003604}, {297,0.00014414}, {298,0.00014414}, {299,0.00021622}, {300,0.00003604}, {301,0.00007207}, {302,0.00014414}, {303,0.00010811}, {304,0.00013514}, {305,0.00007207}, {306,0.00007207}, {307,0.00003604}, {308,0.00007207}, {309,0.00003604}, {310,0.00007207}, {311,0.00014414}, {312,0.00013514}, {313,0.00007207}, {314,0.00003604}, {315,0.00010811}, {316,0.00003604}, {317,0.00025225}, {318,0.00000000}, {319,0.00000000}, {320,0.00010811}, {321,0.00007207}, {322,0.00010811}, {323,0.00021622}, {324,0.00018018}, {325,0.00010811}, {326,0.00007207}, {327,0.00007207}, {328,0.00006306}, {329,0.00014414}, {330,0.00007207}, {331,0.00016216}, {332,0.00010811}, {333,0.00003604}, {334,0.00007207}, {335,0.00010811}, {336,0.00000000}, {337,0.00010811}, {338,0.00000000}, {339,0.00003604}, {340,0.00003604}, {341,0.00006306}, {342,0.00003604}, {343,0.00007207}, {344,0.00003604}, {345,0.00003604}, {346,0.00006306}, {347,0.00003604}, {348,0.00003604}, {349,0.00007207}, {350,0.00010811}, {351,0.00000000}, {352,0.00017117}, {353,0.00003604}, {354,0.00000000}, {355,0.00003604}, {356,0.00007207}, {357,0.00007207}, {358,0.00014414}, {359,0.00006306}, {360,0.00007207}, {361,0.00003604}, {362,0.00010811}, {363,0.00002703}, {364,0.00003604}, {365,0.00007207}, {366,0.00014414}, {367,0.00007207}, {368,0.00007207}, {369,0.00010811}, {370,0.00007207}, {371,0.00003604}, {372,0.00014414}, {373,0.00010811}, {374,0.00007207}, {375,0.00007207}, {376,0.00000000}, {377,0.00003604}, {378,0.00014414}, {379,0.00010811}, {380,0.00010811}, {381,0.00018018}, {382,0.00021622}, {383,0.00007207}, {384,0.00000000}, {385,0.00003604}, {386,0.00006306}, {387,0.00010811}, {388,0.00007207}, {389,0.00000000}, {390,0.00010811}, {391,0.00007207}, {392,0.00000000}, {393,0.00003604}, {394,0.00007207}, {395,0.00014414}, {396,0.00003604}, {397,0.00006306}, {398,0.00007207}, {399,0.00020721}, {400,0.00003604}, {401,0.00009910}, {402,0.00010811}, {403,0.00000000}, {404,0.00010811}, {405,0.00000000}, {406,0.00010811}, {407,0.00007207}, {408,0.00010811}, {409,0.00018018}, {410,0.00006306}, {411,0.00014414}, {412,0.00007207}, {413,0.00007207}, {414,0.00014414}, {415,0.00010811}, {416,0.00007207}, {417,0.00010811}, {418,0.00007207}, {419,0.00003604}, {420,0.00000000}, {421,0.00020721}, {422,0.00014414}, {423,0.00003604}, {424,0.00003604}, {425,0.00021622}, {426,0.00007207}, {427,0.00009009}, {428,0.00006306}, {429,0.00007207}, {430,0.00018018}, {431,0.00014414}, {432,0.00013514}, {433,0.00010811}, {434,0.00021622}, {435,0.00010811}, {436,0.00013514}, {437,0.00009009}, {438,0.00018018}, {439,0.00010811}, {440,0.00014414}, {441,0.00018018}, {442,0.00009910}, {443,0.00013514}, {444,0.00003604}, {445,0.00009910}, {446,0.00010811}, {447,0.00009910}, {448,0.00010811}, {449,0.00003604}, {450,0.00020721}, {451,0.00010811}, {452,0.00003604}, {453,0.00010811}, {454,0.00010811}, {455,0.00010811}, {456,0.00007207}, {457,0.00009910}, {458,0.00018018}, {459,0.00003604}, {460,0.00007207}, {461,0.00000000}, {462,0.00010811}, {463,0.00010811}, {464,0.00014414}, {465,0.00007207}, {466,0.00014414}, {467,0.00010811}, {468,0.00018018}, {469,0.00021622}, {470,0.00018018}, {471,0.00018018}, {472,0.00003604}, {473,0.00013514}, {474,0.00025225}, {475,0.00003604}, {476,0.00007207}, {477,0.00014414}, {478,0.00024324}, {479,0.00013514}, {480,0.00007207}, {481,0.00010811}, {482,0.00000000}, {483,0.00031532}, {484,0.00019820}, {485,0.00010811}, {486,0.00007207}, {487,0.00014414}, {488,0.00014414}, {489,0.00010811}, {490,0.00018018}, {491,0.00014414}, {492,0.00014414}, {493,0.00014414}, {494,0.00027027}, {495,0.00014414}, {496,0.00018018}, {497,0.00010811}, {498,0.00010811}, {499,0.00005405}, {500,0.00017117}, {505,0.00021622}, {510,0.00007207}, {515,0.00010811}, {520,0.00010811}, {525,0.00003604}, {530,0.00007207}, {535,0.00021622}, {540,0.00010811}, {545,0.00018018}, {550,0.00014414}, {555,0.00010811}, {560,0.00007207}, {565,0.00025225}, {570,0.00010811}, {575,0.00010811}, {580,0.00018018}, {585,0.00018018}, {590,0.00021622}, {595,0.00010811}, {600,0.00003604}, {605,0.00021622}, {610,0.00018018}, {615,0.00010811}, {620,0.00010811}, {625,0.00018018}, {630,0.00007207}, {635,0.00006306}, {640,0.00010811}, {645,0.00021622}, {650,0.00010811}, {655,0.00010811}, {660,0.00021622}, {665,0.00010811}, {670,0.00002703}, {675,0.00025225}, {680,0.00007207}, {685,0.00010811}, {690,0.00014414}, {695,0.00016216}, {700,0.00010811}, {705,0.00009910}, {710,0.00007207}, {715,0.00007207}, {720,0.00014414}, {725,0.00039640}, {730,0.00000000}, {735,0.00014414}, {740,0.00021622}, {745,0.00003604}, {750,0.00003604}, {755,0.00010811}, {760,0.00007207}, {765,0.00003604}, {770,0.00014414}, {775,0.00007207}, {780,0.00018018}, {785,0.00010811}, {790,0.00017117}, {795,0.00018018}, {800,0.00024324}, {805,0.00018018}, {810,0.00014414}, {815,0.00018018}, {820,0.00010811}, {825,0.00025225}, {830,0.00014414}, {835,0.00006306}, {840,0.00014414}, {845,0.00021622}, {850,0.00021622}, {855,0.00010811}, {860,0.00003604}, {865,0.00010811}, {870,0.00021622}, {875,0.00018018}, {880,0.00007207}, {885,0.00032432}, {890,0.00025225}, {895,0.00017117}, {900,0.00003604}, {905,0.00045045}, {910,0.00018018}, {915,0.00018018}, {920,0.00023423}, {925,0.00018018}, {930,0.00017117}, {935,0.00018018}, {940,0.00014414}, {945,0.00021622}, {950,0.00021622}, {955,0.00010811}, {960,0.00021622}, {965,0.00010811}, {970,0.00007207}, {975,0.00024324}, {980,0.00021622}, {985,0.00023423}, {990,0.00032432}, {995,0.00010811}, {1000,0.00032432}, {1010,0.00025225}, {1020,0.00028829}, {1030,0.00014414}, {1040,0.00018018}, {1050,0.00035455}, {1060,0.00014545}, {1070,0.00014545}, {1080,0.00014545}, {1090,0.00021818}, {1100,0.00029091}, {1110,0.00014545}, {1120,0.00018182}, {1130,0.00014545}, {1140,0.00007273}, {1150,0.00014545}, {1160,0.00028182}, {1170,0.00021818}, {1180,0.00014545}, {1190,0.00040000}, {1200,0.00024545}, {1210,0.00029091}, {1220,0.00007273}, {1230,0.00025455}, {1240,0.00028182}, {1250,0.00024545}, {1260,0.00028182}, {1270,0.00010909}, {1280,0.00021818}, {1290,0.00043636}, {1300,0.00032727}, {1310,0.00040000}, {1320,0.00021818}, {1330,0.00021818}, {1340,0.00010909}, {1350,0.00017273}, {1360,0.00043636}, {1370,0.00017273}, {1380,0.00014545}, {1390,0.00025455}, {1400,0.00025455}, {1410,0.00007273}, {1420,0.00029091}, {1430,0.00025455}, {1440,0.00041818}, {1450,0.00024545}, {1460,0.00020909}, {1470,0.00025455}, {1480,0.00036364}, {1490,0.00021818}, {1500,0.00029091}, {1510,0.00046364}, {1520,0.00000000}, {1530,0.00025455}, {1540,0.00007273}, {1550,0.00000000}, {1560,0.00021818}, {1570,0.00018182}, {1580,0.00007273}, {1590,0.00014545}, {1600,0.00025455}, {1610,0.00013636}, {1620,0.00029091}, {1630,0.00010909}, {1640,0.00010000}, {1650,0.00013636}, {1660,0.00018182}, {1670,0.00007273}, {1680,0.00020909}, {1690,0.00014545}, {1700,0.00010000}, {1710,0.00007273}, {1720,0.00018182}, {1730,0.00010909}, {1740,0.00006364}, {1750,0.00010909}, {1760,0.00013636}, {1770,0.00018182}, {1780,0.00010000}, {1790,0.00017273}, {1800,0.00025455}, {1810,0.00010909}, {1820,0.00014545}, {1830,0.00018182}, {1840,0.00021818}, {1850,0.00014545}, {1860,0.00003636}, {1870,0.00014545}, {1880,0.00020909}, {1890,0.00010000}, {1900,0.00021818}, {1910,0.00017273}, {1920,0.00010909}, {1930,0.00003636}, {1940,0.00014545}, {1950,0.00007273}, {1960,0.00014545}, {1970,0.00014545}, {1980,0.00018182}, {1990,0.00017273}, {2000,0.00003636}, {2050,0.00029091}, {2100,0.00025455}, {2150,0.00018182}, {2200,0.00007273}, {2250,0.00017273}, {2300,0.00024545}, {2350,0.00021818}, {2400,0.00024545}, {2450,0.00007273}, {2500,0.00010909}, {2550,0.00021818}, {2600,0.00003636}, {2650,0.00014545}, {2700,0.00018182}, {2750,0.00007273}, {2800,0.00007273}, {2850,0.00010909}, {2900,0.00021818}, {2950,0.00010909}, {3000,0.00007273}, {3050,0.00021818}, {3100,0.00018182}, {3150,0.00021818}, {3200,0.00014545}, {3250,0.00025455}, {3300,0.00018182}, {3350,0.00010909}, {3400,0.00010909}, {3450,0.00007273}, {3500,0.00010909}, {3550,0.00032727}, {3600,0.00010909}, {3650,0.00007273}, {3700,0.00007273}, {3750,0.00010909}, {3800,0.00007273}, {3850,0.00025455}, {3900,0.00029091}, {3950,0.00014545}, {4000,0.00032727}, {4050,0.00025455}, {4100,0.00017273}, {4150,0.00043636}, {4200,0.00018182}, {4250,0.00017273}, {4300,0.00013636}, {4350,0.00014545}, {4400,0.00010909}, {4450,0.00014545}, {4500,0.00018182}, {4550,0.00020909}, {4600,0.00014545}, {4650,0.00018182}, {4700,0.00018182}, {4750,0.00082727}, {4800,0.00068182}, {4850,0.00061818}, {4900,0.00064545}, {4950,0.00069091}, {5000,0.00043636}, {5050,0.00031818}, {5100,0.00060909}, {5150,0.00036364}, {5200,0.00020909}, {5250,0.00010909}, {5300,0.00007273}, {5350,0.00029091}, {5400,0.00041818}, {5450,0.00029091}, {5500,0.00025455}, {5550,0.00100909}, {5600,0.00021818}, {5650,0.00010909}, {5700,0.00032727}, {5750,0.00003636}, {5800,0.00018182}, {5850,0.00010909}, {5900,0.00025455}, {5950,0.00018182}, {6000,0.00029091}, {6050,0.00200}, {6100,0.00100}, {6150,0.00100}, {6200,0.00075}, {6250,0.00100}, {6300,0.00200}, {6350,0.00075}, {6400,0.00200}, {6450,0.00200}, {6500,0.00100}, {6550,0.00100}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00200}, {6800,0.00100}, {6850,0.00200}, {6900,0.00000}, {6950,0.00000}, {7000,0.00100}, {7050,0.00100}, {7100,0.00100}, {7150,0.00000}, {7200,0.00200}, {7250,0.00400}, {7300,0.00000}, {7350,0.00100}, {7400,0.00100}, {7450,0.00300}, {7500,0.00100}, {7550,0.00100}, {7600,0.00275}, {7650,0.00300}, {7700,0.00000}, {7750,0.00000}, {7800,0.00075}, {7850,0.00000}, {7900,0.00100}, {7950,0.00000}, {8000,0.00100}, {8050,0.00100}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00100}, {8450,0.00100}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00200}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00100}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00100}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00200}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00075}, {12900,0.00000}, {13000,0.00100}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00100}, {13500,0.00000}, {13600,0.00075}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00200}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00100}, {14700,0.00000}, {14800,0.00100}, {14900,0.00000}, {15000,0.00100}, {15100,0.00000}, {15200,0.00100}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00100}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00100}, {16400,0.00000}, {16500,0.00000}, {16600,0.00100}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00100}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00100}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00100}, {19600,0.00100}, {19700,0.00100}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresHOAS"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00031532}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00100000}, {16,0.00100000}, {17,0.00100000}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00103604}, {22,0.00107207}, {23,0.00149550}, {24,0.00200000}, {25,0.00200000}, {26,0.00200000}, {27,0.00200000}, {28,0.00200000}, {29,0.00200000}, {30,0.00200000}, {31,0.00200000}, {32,0.00202703}, {33,0.00206306}, {34,0.00214414}, {35,0.00260360}, {36,0.00298198}, {37,0.00300000}, {38,0.00300000}, {39,0.00300000}, {40,0.00300000}, {41,0.00300000}, {42,0.00300000}, {43,0.00304505}, {44,0.00307207}, {45,0.00403604}, {46,0.00318018}, {47,0.00381982}, {48,0.00393694}, {49,0.00400000}, {50,0.00400000}, {51,0.00400000}, {52,0.00400000}, {53,0.00401802}, {54,0.00402703}, {55,0.00404505}, {56,0.00408108}, {57,0.00414414}, {58,0.00425225}, {59,0.00485586}, {60,0.00499099}, {61,0.00500000}, {62,0.00500000}, {63,0.00500901}, {64,0.00502703}, {65,0.00503604}, {66,0.00503604}, {67,0.00505405}, {68,0.00509910}, {69,0.00511712}, {70,0.00543243}, {71,0.00699099}, {72,0.00597297}, {73,0.00600000}, {74,0.00600901}, {75,0.00606306}, {76,0.00601802}, {77,0.00605405}, {78,0.00733333}, {79,0.00606306}, {80,0.00611712}, {81,0.00619820}, {82,0.00645045}, {83,0.00695495}, {84,0.00697297}, {85,0.00700000}, {86,0.00701802}, {87,0.00701802}, {88,0.00702703}, {89,0.00704505}, {90,0.00704505}, {91,0.00708108}, {92,0.00710811}, {93,0.00748649}, {94,0.00781081}, {95,0.00800901}, {96,0.00927928}, {97,0.00803604}, {98,0.00803604}, {99,0.00803604}, {100,0.00803604}, {101,0.00808108}, {102,0.00804505}, {103,0.00816216}, {104,0.00994595}, {105,0.00844144}, {106,0.00877477}, {107,0.00900000}, {108,0.00903604}, {109,0.01001802}, {110,0.00902703}, {111,0.00905405}, {112,0.00903604}, {113,0.00909009}, {114,0.00906306}, {115,0.00918919}, {116,0.01019820}, {117,0.00971171}, {118,0.00991892}, {119,0.01002703}, {120,0.01001802}, {121,0.01000901}, {122,0.01003604}, {123,0.01007207}, {124,0.01008108}, {125,0.01010811}, {126,0.01019820}, {127,0.01151351}, {128,0.01023423}, {129,0.01157658}, {130,0.01074775}, {131,0.01199099}, {132,0.01099099}, {133,0.01207207}, {134,0.01104505}, {135,0.01214414}, {136,0.01107207}, {137,0.01214414}, {138,0.01117117}, {139,0.01231532}, {140,0.01147748}, {141,0.01255856}, {142,0.01199099}, {143,0.01206306}, {144,0.01200000}, {145,0.01202703}, {146,0.01206306}, {147,0.01211712}, {148,0.01208108}, {149,0.01220721}, {150,0.01418018}, {151,0.01276577}, {152,0.01257658}, {153,0.01291892}, {154,0.01300901}, {155,0.01301802}, {156,0.01302703}, {157,0.01495495}, {158,0.01310811}, {159,0.01319820}, {160,0.01304505}, {161,0.01316216}, {162,0.01509910}, {163,0.01360360}, {164,0.01362162}, {165,0.01395495}, {166,0.01399099}, {167,0.01576577}, {168,0.01400901}, {169,0.01405405}, {170,0.01409910}, {171,0.01412613}, {172,0.01416216}, {173,0.01437838}, {174,0.01465766}, {175,0.01498198}, {176,0.01463063}, {177,0.01494595}, {178,0.01623423}, {179,0.01505405}, {180,0.01504505}, {181,0.01695495}, {182,0.01519820}, {183,0.01535135}, {184,0.01515315}, {185,0.01551351}, {186,0.01572973}, {187,0.01603604}, {188,0.01596396}, {189,0.01609009}, {190,0.01607207}, {191,0.01753153}, {192,0.01599099}, {193,0.01605405}, {194,0.01610811}, {195,0.01615315}, {196,0.01619820}, {197,0.01641441}, {198,0.01799099}, {199,0.01697297}, {200,0.01677477}, {201,0.01697297}, {202,0.01805405}, {203,0.01705405}, {204,0.01709009}, {205,0.01721622}, {206,0.01842342}, {207,0.01759459}, {208,0.01722523}, {209,0.01749550}, {210,0.01887387}, {211,0.01798198}, {212,0.01791892}, {213,0.01807207}, {214,0.01811712}, {215,0.01912613}, {216,0.01810811}, {217,0.01816216}, {218,0.01836937}, {219,0.01860360}, {220,0.01961261}, {221,0.01891892}, {222,0.01901802}, {223,0.01907207}, {224,0.01882883}, {225,0.01908108}, {226,0.02013514}, {227,0.01913514}, {228,0.01913514}, {229,0.01927027}, {230,0.01936937}, {231,0.01964865}, {232,0.01944144}, {233,0.02124324}, {234,0.02000000}, {235,0.02008108}, {236,0.02001802}, {237,0.02027928}, {238,0.02020721}, {239,0.02050450}, {240,0.02022523}, {241,0.02207207}, {242,0.02025225}, {243,0.02074775}, {244,0.02070270}, {245,0.02103604}, {246,0.02109009}, {247,0.02116216}, {248,0.02110811}, {249,0.02111712}, {250,0.02121622}, {251,0.02155856}, {252,0.02238739}, {253,0.02322523}, {254,0.02321622}, {255,0.02336937}, {256,0.02138739}, {257,0.02164865}, {258,0.02181081}, {259,0.02207207}, {260,0.02201802}, {261,0.02204505}, {262,0.02220721}, {263,0.02237838}, {264,0.02218919}, {265,0.02229730}, {266,0.02252252}, {267,0.02287387}, {268,0.02277477}, {269,0.02310811}, {270,0.02306306}, {271,0.02327928}, {272,0.02305405}, {273,0.02317117}, {274,0.02319820}, {275,0.02341441}, {276,0.02332432}, {277,0.02379279}, {278,0.02374775}, {279,0.02408108}, {280,0.02374775}, {281,0.02403604}, {282,0.02408108}, {283,0.02427928}, {284,0.02418018}, {285,0.02448649}, {286,0.02447748}, {287,0.02620721}, {288,0.02572973}, {289,0.02595495}, {290,0.02600901}, {291,0.02509009}, {292,0.02491892}, {293,0.02512613}, {294,0.02509910}, {295,0.02533333}, {296,0.02510811}, {297,0.02541441}, {298,0.02546847}, {299,0.02578378}, {300,0.02696396}, {301,0.02726126}, {302,0.02601802}, {303,0.02622523}, {304,0.02586486}, {305,0.02613514}, {306,0.02618919}, {307,0.02630631}, {308,0.02776577}, {309,0.02794595}, {310,0.02674775}, {311,0.02696396}, {312,0.02662162}, {313,0.02698198}, {314,0.03089189}, {315,0.02881982}, {316,0.02712613}, {317,0.02733333}, {318,0.02745045}, {319,0.02789189}, {320,0.02821622}, {321,0.02831532}, {322,0.02731532}, {323,0.02755856}, {324,0.02753153}, {325,0.03096396}, {326,0.02907207}, {327,0.02818018}, {328,0.02800000}, {329,0.02824324}, {330,0.03144144}, {331,0.02956757}, {332,0.02836937}, {333,0.02871171}, {334,0.02884685}, {335,0.03016216}, {336,0.02862162}, {337,0.02890991}, {338,0.02903604}, {339,0.03283784}, {340,0.02918919}, {341,0.02936937}, {342,0.02946847}, {343,0.03104505}, {344,0.02937838}, {345,0.02977477}, {346,0.03315315}, {347,0.03009910}, {348,0.03001802}, {349,0.03033333}, {350,0.03397297}, {351,0.03068468}, {352,0.03002703}, {353,0.03375676}, {354,0.03034234}, {355,0.03061261}, {356,0.03390090}, {357,0.03073874}, {358,0.03090991}, {359,0.03111712}, {360,0.03100000}, {361,0.03106306}, {362,0.03120721}, {363,0.03153153}, {364,0.03136036}, {365,0.03494595}, {366,0.03180180}, {367,0.03207207}, {368,0.03509009}, {369,0.03177477}, {370,0.03192793}, {371,0.03582883}, {372,0.03207207}, {373,0.03227928}, {374,0.03247748}, {375,0.03268468}, {376,0.03600901}, {377,0.03273874}, {378,0.03278378}, {379,0.03320721}, {380,0.03288288}, {381,0.03685586}, {382,0.03330631}, {383,0.03693694}, {384,0.03256757}, {385,0.03281982}, {386,0.03415315}, {387,0.03332432}, {388,0.03641441}, {389,0.03353153}, {390,0.03348649}, {391,0.03384685}, {392,0.03340541}, {393,0.03720721}, {394,0.03386486}, {395,0.03748649}, {396,0.03414414}, {397,0.03749550}, {398,0.03436036}, {399,0.03773874}, {400,0.03415315}, {401,0.03747748}, {402,0.03452252}, {403,0.03493694}, {404,0.03478378}, {405,0.03509910}, {406,0.03519820}, {407,0.03548649}, {408,0.03513514}, {409,0.03540541}, {410,0.03562162}, {411,0.03586486}, {412,0.03566667}, {413,0.03902703}, {414,0.03608108}, {415,0.03954955}, {416,0.03554955}, {417,0.03909910}, {418,0.03594595}, {419,0.03973874}, {420,0.03615315}, {421,0.04003604}, {422,0.03645045}, {423,0.03692793}, {424,0.04079279}, {425,0.03680180}, {426,0.04018919}, {427,0.03718919}, {428,0.04046847}, {429,0.03727027}, {430,0.03746847}, {431,0.04101802}, {432,0.03722523}, {433,0.04115315}, {434,0.03768468}, {435,0.03792793}, {436,0.04103604}, {437,0.03815315}, {438,0.03808108}, {439,0.04154955}, {440,0.03813514}, {441,0.04196396}, {442,0.03865766}, {443,0.03880180}, {444,0.04205405}, {445,0.03909009}, {446,0.03909910}, {447,0.04287387}, {448,0.03830631}, {449,0.03872072}, {450,0.04209910}, {451,0.03915315}, {452,0.03901802}, {453,0.04253153}, {454,0.03936036}, {455,0.03970270}, {456,0.04261261}, {457,0.03955856}, {458,0.03968468}, {459,0.04330631}, {460,0.03983784}, {461,0.04016216}, {462,0.04397297}, {463,0.04374775}, {464,0.03993694}, {465,0.04036036}, {466,0.04381982}, {467,0.04074775}, {468,0.04058559}, {469,0.04469369}, {470,0.04426126}, {471,0.04132432}, {472,0.04079279}, {473,0.04467568}, {474,0.04471171}, {475,0.04166667}, {476,0.04143243}, {477,0.04194595}, {478,0.04539640}, {479,0.04544144}, {480,0.04129730}, {481,0.04168468}, {482,0.04545946}, {483,0.04546847}, {484,0.04197297}, {485,0.04228829}, {486,0.04242342}, {487,0.04634234}, {488,0.04534234}, {489,0.04259459}, {490,0.04267568}, {491,0.04302703}, {492,0.04636937}, {493,0.04654955}, {494,0.04612613}, {495,0.04367568}, {496,0.04290991}, {497,0.04318919}, {498,0.04342342}, {499,0.04736036}, {500,0.04671171}, {505,0.04718919}, {510,0.04513514}, {515,0.04452252}, {520,0.04464865}, {525,0.04576577}, {530,0.04609910}, {535,0.04711712}, {540,0.04709910}, {545,0.04719820}, {550,0.04803604}, {555,0.04876577}, {560,0.04840541}, {565,0.04965766}, {570,0.05000901}, {575,0.05118018}, {580,0.05309009}, {585,0.05413514}, {590,0.05518018}, {595,0.05240541}, {600,0.05245045}, {605,0.05623423}, {610,0.05649550}, {615,0.05449550}, {620,0.05441441}, {625,0.05796396}, {630,0.05938739}, {635,0.05655856}, {640,0.05817117}, {645,0.05637838}, {650,0.05690991}, {655,0.06136036}, {660,0.05772072}, {665,0.06155856}, {670,0.05940541}, {675,0.06236036}, {680,0.05954054}, {685,0.06363964}, {690,0.06080180}, {695,0.06539640}, {700,0.06454955}, {705,0.06168468}, {710,0.06551351}, {715,0.06352252}, {720,0.06655856}, {725,0.06726126}, {730,0.06506306}, {735,0.06976577}, {740,0.06847748}, {745,0.06880180}, {750,0.06720721}, {755,0.06754955}, {760,0.07097297}, {765,0.07204505}, {770,0.07022523}, {775,0.07256757}, {780,0.07301802}, {785,0.06909910}, {790,0.07007207}, {795,0.07106306}, {800,0.06986486}, {805,0.07579279}, {810,0.07522523}, {815,0.07690090}, {820,0.07271171}, {825,0.07372072}, {830,0.07485586}, {835,0.07658559}, {840,0.07605405}, {845,0.07788288}, {850,0.07800901}, {855,0.08001802}, {860,0.08025225}, {865,0.07675676}, {870,0.08127928}, {875,0.08181982}, {880,0.08165766}, {885,0.07979279}, {890,0.08287387}, {895,0.08549550}, {900,0.08175676}, {905,0.08334234}, {910,0.08516216}, {915,0.08441441}, {920,0.08511712}, {925,0.08350450}, {930,0.08565766}, {935,0.08456757}, {940,0.08707207}, {945,0.08476577}, {950,0.08877477}, {955,0.08992793}, {960,0.08791892}, {965,0.08886486}, {970,0.09050450}, {975,0.09122523}, {980,0.09096396}, {985,0.09239640}, {990,0.09279279}, {995,0.09212613}, {1000,0.08958559}, {1010,0.09418919}, {1020,0.09533333}, {1030,0.09501802}, {1040,0.09436036}, {1050,0.09648214}, {1060,0.09738182}, {1070,0.09955455}, {1080,0.09967273}, {1090,0.09976364}, {1100,0.10123636}, {1110,0.10328182}, {1120,0.10060909}, {1130,0.10492727}, {1140,0.10528182}, {1150,0.10809091}, {1160,0.10413636}, {1170,0.10723636}, {1180,0.10912727}, {1190,0.10824545}, {1200,0.10970909}, {1210,0.11450909}, {1220,0.11163636}, {1230,0.11278182}, {1240,0.11490000}, {1250,0.11766364}, {1260,0.11844545}, {1270,0.11956364}, {1280,0.11544545}, {1290,0.11755455}, {1300,0.12019091}, {1310,0.12221818}, {1320,0.12096364}, {1330,0.12247273}, {1340,0.12443636}, {1350,0.12405455}, {1360,0.12463636}, {1370,0.12743636}, {1380,0.12901818}, {1390,0.13096364}, {1400,0.13010909}, {1410,0.12854545}, {1420,0.13060909}, {1430,0.13138182}, {1440,0.13974545}, {1450,0.13458182}, {1460,0.13350000}, {1470,0.13833636}, {1480,0.13595455}, {1490,0.13818182}, {1500,0.14150000}, {1510,0.13898182}, {1520,0.14080000}, {1530,0.14390909}, {1540,0.14027273}, {1550,0.14401818}, {1560,0.14336364}, {1570,0.14390000}, {1580,0.14581818}, {1590,0.14689091}, {1600,0.16198182}, {1610,0.16443636}, {1620,0.14714545}, {1630,0.15074545}, {1640,0.15240000}, {1650,0.15458182}, {1660,0.15677273}, {1670,0.15345455}, {1680,0.15286364}, {1690,0.15849091}, {1700,0.15602727}, {1710,0.15731818}, {1720,0.16216364}, {1730,0.15679091}, {1740,0.16240000}, {1750,0.16127273}, {1760,0.16202727}, {1770,0.16521818}, {1780,0.16648182}, {1790,0.16951818}, {1800,0.16478182}, {1810,0.16618182}, {1820,0.16899091}, {1830,0.16985455}, {1840,0.16961818}, {1850,0.17297273}, {1860,0.17125455}, {1870,0.17924545}, {1880,0.17424545}, {1890,0.17513636}, {1900,0.17729091}, {1910,0.17963636}, {1920,0.17328182}, {1930,0.17845455}, {1940,0.18642727}, {1950,0.18328182}, {1960,0.18070000}, {1970,0.18363636}, {1980,0.18342727}, {1990,0.18571818}, {2000,0.18292727}, {2050,0.18719091}, {2100,0.19154545}, {2150,0.20007273}, {2200,0.20168182}, {2250,0.20992727}, {2300,0.21800909}, {2350,0.22085455}, {2400,0.22168182}, {2450,0.23740000}, {2500,0.23310000}, {2550,0.24161818}, {2600,0.23960000}, {2650,0.25010000}, {2700,0.25100909}, {2750,0.25874545}, {2800,0.26288182}, {2850,0.26899091}, {2900,0.26880909}, {2950,0.27359091}, {3000,0.28143636}, {3050,0.29982727}, {3100,0.29175455}, {3150,0.29407273}, {3200,0.29104545}, {3250,0.30240909}, {3300,0.31033636}, {3350,0.31529091}, {3400,0.31730909}, {3450,0.32754545}, {3500,0.33824545}, {3550,0.33629091}, {3600,0.32890909}, {3650,0.33870909}, {3700,0.34622727}, {3750,0.35281818}, {3800,0.36149091}, {3850,0.35747273}, {3900,0.37262727}, {3950,0.38595455}, {4000,0.37070000}, {4050,0.38575455}, {4100,0.37732727}, {4150,0.39010909}, {4200,0.38958182}, {4250,0.39900000}, {4300,0.40370909}, {4350,0.42273636}, {4400,0.41437273}, {4450,0.41742727}, {4500,0.42192727}, {4550,0.43432727}, {4600,0.44106364}, {4650,0.44318182}, {4700,0.45056364}, {4750,0.45145455}, {4800,0.45060909}, {4850,0.46162727}, {4900,0.46511818}, {4950,0.47175455}, {5000,0.47180000}, {5050,0.48731818}, {5100,0.49205455}, {5150,0.48797273}, {5200,0.48179091}, {5250,0.49032727}, {5300,0.50651818}, {5350,0.51423636}, {5400,0.51481818}, {5450,0.51440909}, {5500,0.52846364}, {5550,0.53620000}, {5600,0.52188182}, {5650,0.52806364}, {5700,0.52703636}, {5750,0.55193636}, {5800,0.53870000}, {5850,0.55429091}, {5900,0.54556364}, {5950,0.56037273}, {6000,0.55801818}, {6050,0.57075}, {6100,0.58350}, {6150,0.56900}, {6200,0.58950}, {6250,0.59850}, {6300,0.59625}, {6350,0.60375}, {6400,0.58300}, {6450,0.61225}, {6500,0.61250}, {6550,0.62425}, {6600,0.62175}, {6650,0.65050}, {6700,0.64700}, {6750,0.65100}, {6800,0.63400}, {6850,0.65325}, {6900,0.66200}, {6950,0.65875}, {7000,0.67250}, {7050,0.67275}, {7100,0.67975}, {7150,0.69700}, {7200,0.67825}, {7250,0.69325}, {7300,0.68700}, {7350,0.69925}, {7400,0.70500}, {7450,0.71325}, {7500,0.71500}, {7550,0.74675}, {7600,0.72575}, {7650,0.72600}, {7700,0.72725}, {7750,0.73525}, {7800,0.75050}, {7850,0.75300}, {7900,0.76425}, {7950,0.75775}, {8000,0.74925}, {8050,0.77900}, {8100,0.77750}, {8150,0.78575}, {8200,0.75750}, {8250,0.78275}, {8300,0.78875}, {8350,0.79975}, {8400,0.79100}, {8450,0.79300}, {8500,0.80575}, {8550,0.81200}, {8600,0.80825}, {8650,0.82125}, {8700,0.84100}, {8750,0.83625}, {8800,0.82250}, {8850,0.83150}, {8900,0.84300}, {8950,0.86850}, {9000,0.84300}, {9050,0.86275}, {9100,0.86225}, {9150,0.88875}, {9200,0.87600}, {9250,0.86225}, {9300,0.87475}, {9350,0.87650}, {9400,0.88600}, {9450,0.91250}, {9500,0.90425}, {9550,0.91525}, {9600,0.89525}, {9650,0.92175}, {9700,0.92650}, {9750,0.92750}, {9800,0.92200}, {9850,0.94975}, {9900,0.94125}, {9950,0.96450}, {10000,0.94075}, {10100,0.96900}, {10200,0.97050}, {10300,0.98500}, {10400,0.96725}, {10500,0.97300}, {10600,1.00325}, {10700,1.02100}, {10800,1.00650}, {10900,1.03700}, {11000,1.05500}, {11100,1.06225}, {11200,1.04950}, {11300,1.06775}, {11400,1.06900}, {11500,1.10125}, {11600,1.08550}, {11700,1.11850}, {11800,1.10200}, {11900,1.15575}, {12000,1.14250}, {12100,1.14950}, {12200,1.17275}, {12300,1.15400}, {12400,1.17775}, {12500,1.18825}, {12600,1.20250}, {12700,1.21550}, {12800,1.18150}, {12900,1.22700}, {13000,1.22650}, {13100,1.25750}, {13200,1.25775}, {13300,1.30450}, {13400,1.27050}, {13500,1.31100}, {13600,1.27300}, {13700,1.29550}, {13800,1.34525}, {13900,1.32300}, {14000,1.32475}, {14100,1.34250}, {14200,1.38600}, {14300,1.42325}, {14400,1.34525}, {14500,1.38475}, {14600,1.38125}, {14700,1.42925}, {14800,1.42925}, {14900,1.43275}, {15000,1.44925}, {15100,1.50200}, {15200,1.45575}, {15300,1.49025}, {15400,1.46500}, {15500,1.48625}, {15600,1.51550}, {15700,1.52700}, {15800,1.56875}, {15900,1.53875}, {16000,1.52050}, {16100,1.57400}, {16200,1.56475}, {16300,1.60950}, {16400,1.51950}, {16500,1.58800}, {16600,1.59725}, {16700,1.62800}, {16800,1.59825}, {16900,1.59025}, {17000,1.64225}, {17100,1.65125}, {17200,1.65250}, {17300,1.66525}, {17400,1.73200}, {17500,1.69825}, {17600,1.65775}, {17700,1.70900}, {17800,1.70050}, {17900,1.77975}, {18000,1.72325}, {18100,1.77000}, {18200,1.76500}, {18300,1.82450}, {18400,1.79275}, {18500,1.74775}, {18600,1.78200}, {18700,1.78450}, {18800,1.80875}, {18900,1.83100}, {19000,1.83700}, {19100,1.85850}, {19200,1.80450}, {19300,1.88325}, {19400,1.89100}, {19500,1.88825}, {19600,1.86725}, {19700,1.94375}, {19800,1.93650}, {19900,1.97800}, {20000,1.8925}};
data["big_flat"]["CanonicalStructuresHOAS"]["actual reif"]["user"] = {{1,0.00021622}, {2,0.00018919}, {3,0.00022523}, {4,0.00019820}, {5,0.00034234}, {6,0.00045946}, {7,0.00060360}, {8,0.00066667}, {9,0.00070270}, {10,0.00068468}, {11,0.00091892}, {12,0.00097297}, {13,0.00080180}, {14,0.00109009}, {15,0.00102703}, {16,0.00138739}, {17,0.00123423}, {18,0.00142342}, {19,0.00122523}, {20,0.00127027}, {21,0.00161261}, {22,0.00183784}, {23,0.00168468}, {24,0.00139640}, {25,0.00177477}, {26,0.00187387}, {27,0.00167568}, {28,0.00204505}, {29,0.00192793}, {30,0.00220721}, {31,0.00222523}, {32,0.00236937}, {33,0.00223423}, {34,0.00236937}, {35,0.00263964}, {36,0.00253153}, {37,0.00290090}, {38,0.00294595}, {39,0.00302703}, {40,0.00278378}, {41,0.00296396}, {42,0.00290090}, {43,0.00309910}, {44,0.00314414}, {45,0.00411712}, {46,0.00333333}, {47,0.00335135}, {48,0.00343243}, {49,0.00352252}, {50,0.00354955}, {51,0.00348649}, {52,0.00372973}, {53,0.00380180}, {54,0.00406306}, {55,0.00392793}, {56,0.00413514}, {57,0.00410811}, {58,0.00430631}, {59,0.00441441}, {60,0.00460360}, {61,0.00444144}, {62,0.00477477}, {63,0.00502703}, {64,0.00487387}, {65,0.00481081}, {66,0.00529730}, {67,0.00491892}, {68,0.00506306}, {69,0.00522523}, {70,0.00558559}, {71,0.00691892}, {72,0.00551351}, {73,0.00573874}, {74,0.00566667}, {75,0.00577477}, {76,0.00635135}, {77,0.00620721}, {78,0.00747748}, {79,0.00639640}, {80,0.00654955}, {81,0.00654054}, {82,0.00666667}, {83,0.00666667}, {84,0.00697297}, {85,0.00666667}, {86,0.00723423}, {87,0.00672973}, {88,0.00713514}, {89,0.00720721}, {90,0.00723423}, {91,0.00757658}, {92,0.00740541}, {93,0.00778378}, {94,0.00783784}, {95,0.00781982}, {96,0.01000901}, {97,0.00792793}, {98,0.00819820}, {99,0.00789189}, {100,0.00821622}, {101,0.00864865}, {102,0.00857658}, {103,0.00850450}, {104,0.01030631}, {105,0.00855856}, {106,0.00922523}, {107,0.00907207}, {108,0.00892793}, {109,0.01028829}, {110,0.00923423}, {111,0.00955856}, {112,0.00934234}, {113,0.00941441}, {114,0.00942342}, {115,0.00960360}, {116,0.01083784}, {117,0.01016216}, {118,0.01009009}, {119,0.01012613}, {120,0.01033333}, {121,0.01024324}, {122,0.01022523}, {123,0.00993694}, {124,0.01058559}, {125,0.01035135}, {126,0.01112613}, {127,0.01200901}, {128,0.01092793}, {129,0.01199099}, {130,0.01093694}, {131,0.01228829}, {132,0.01125225}, {133,0.01213514}, {134,0.01154054}, {135,0.01263063}, {136,0.01128829}, {137,0.01247748}, {138,0.01187387}, {139,0.01256757}, {140,0.01190090}, {141,0.01287387}, {142,0.01219820}, {143,0.01222523}, {144,0.01223423}, {145,0.01236036}, {146,0.01243243}, {147,0.01241441}, {148,0.01264865}, {149,0.01256757}, {150,0.01436036}, {151,0.01301802}, {152,0.01263964}, {153,0.01310811}, {154,0.01318919}, {155,0.01332432}, {156,0.01332432}, {157,0.01470270}, {158,0.01323423}, {159,0.01355856}, {160,0.01341441}, {161,0.01345946}, {162,0.01500000}, {163,0.01377477}, {164,0.01380180}, {165,0.01361261}, {166,0.01366667}, {167,0.01530631}, {168,0.01395495}, {169,0.01447748}, {170,0.01420721}, {171,0.01427928}, {172,0.01418919}, {173,0.01447748}, {174,0.01454955}, {175,0.01468468}, {176,0.01447748}, {177,0.01465766}, {178,0.01626126}, {179,0.01497297}, {180,0.01516216}, {181,0.01713514}, {182,0.01519820}, {183,0.01522523}, {184,0.01508108}, {185,0.01537838}, {186,0.01534234}, {187,0.01577477}, {188,0.01560360}, {189,0.01590090}, {190,0.01572072}, {191,0.01761261}, {192,0.01558559}, {193,0.01576577}, {194,0.01621622}, {195,0.01620721}, {196,0.01654054}, {197,0.01634234}, {198,0.01790090}, {199,0.01671171}, {200,0.01656757}, {201,0.01664865}, {202,0.01773874}, {203,0.01720721}, {204,0.01721622}, {205,0.01737838}, {206,0.01831532}, {207,0.01738739}, {208,0.01726126}, {209,0.01719820}, {210,0.01901802}, {211,0.01802703}, {212,0.01742342}, {213,0.01814414}, {214,0.01774775}, {215,0.01934234}, {216,0.01825225}, {217,0.01815315}, {218,0.01815315}, {219,0.01873874}, {220,0.01980180}, {221,0.01888288}, {222,0.01887387}, {223,0.01901802}, {224,0.01857658}, {225,0.01901802}, {226,0.02019820}, {227,0.01922523}, {228,0.01932432}, {229,0.01963964}, {230,0.01977477}, {231,0.01972072}, {232,0.01955856}, {233,0.02160360}, {234,0.01994595}, {235,0.02007207}, {236,0.01995495}, {237,0.02047748}, {238,0.02035135}, {239,0.02074775}, {240,0.02050450}, {241,0.02215315}, {242,0.02061261}, {243,0.02082883}, {244,0.02116216}, {245,0.02100901}, {246,0.02106306}, {247,0.02142342}, {248,0.02130631}, {249,0.02151351}, {250,0.02128829}, {251,0.02177477}, {252,0.02247748}, {253,0.02364865}, {254,0.02369369}, {255,0.02390991}, {256,0.02193694}, {257,0.02207207}, {258,0.02200000}, {259,0.02230631}, {260,0.02218018}, {261,0.02227928}, {262,0.02239640}, {263,0.02265766}, {264,0.02254054}, {265,0.02294595}, {266,0.02300000}, {267,0.02290090}, {268,0.02335135}, {269,0.02349550}, {270,0.02351351}, {271,0.02377477}, {272,0.02293694}, {273,0.02360360}, {274,0.02361261}, {275,0.02392793}, {276,0.02375676}, {277,0.02400000}, {278,0.02436036}, {279,0.02437838}, {280,0.02426126}, {281,0.02427027}, {282,0.02451351}, {283,0.02490991}, {284,0.02452252}, {285,0.02482883}, {286,0.02498198}, {287,0.02641441}, {288,0.02587387}, {289,0.02609009}, {290,0.02604505}, {291,0.02544144}, {292,0.02498198}, {293,0.02536036}, {294,0.02498198}, {295,0.02613514}, {296,0.02537838}, {297,0.02561261}, {298,0.02567568}, {299,0.02552252}, {300,0.02676577}, {301,0.02726126}, {302,0.02616216}, {303,0.02631532}, {304,0.02569369}, {305,0.02605405}, {306,0.02586486}, {307,0.02655856}, {308,0.02752252}, {309,0.02757658}, {310,0.02665766}, {311,0.02673874}, {312,0.02645946}, {313,0.02706306}, {314,0.03090991}, {315,0.02863964}, {316,0.02703604}, {317,0.02717117}, {318,0.02746847}, {319,0.02775676}, {320,0.02818919}, {321,0.02815315}, {322,0.02712613}, {323,0.02747748}, {324,0.02740541}, {325,0.03117117}, {326,0.02879279}, {327,0.02801802}, {328,0.02779279}, {329,0.02793694}, {330,0.03152252}, {331,0.02941441}, {332,0.02840541}, {333,0.02859459}, {334,0.02907207}, {335,0.03000901}, {336,0.02878378}, {337,0.02880180}, {338,0.02890090}, {339,0.03300000}, {340,0.02920721}, {341,0.02928829}, {342,0.02947748}, {343,0.03109910}, {344,0.02953153}, {345,0.02982883}, {346,0.03329730}, {347,0.02993694}, {348,0.03012613}, {349,0.03037838}, {350,0.03400000}, {351,0.03062162}, {352,0.03006306}, {353,0.03386486}, {354,0.03047748}, {355,0.03056757}, {356,0.03409009}, {357,0.03040541}, {358,0.03081081}, {359,0.03126126}, {360,0.03104505}, {361,0.03091892}, {362,0.03122523}, {363,0.03163964}, {364,0.03148649}, {365,0.03524324}, {366,0.03193694}, {367,0.03225225}, {368,0.03548649}, {369,0.03179279}, {370,0.03203604}, {371,0.03633333}, {372,0.03241441}, {373,0.03242342}, {374,0.03290090}, {375,0.03283784}, {376,0.03636036}, {377,0.03290090}, {378,0.03271171}, {379,0.03370270}, {380,0.03329730}, {381,0.03693694}, {382,0.03318919}, {383,0.03728829}, {384,0.03286486}, {385,0.03302703}, {386,0.03457658}, {387,0.03379279}, {388,0.03672072}, {389,0.03364865}, {390,0.03339640}, {391,0.03401802}, {392,0.03345946}, {393,0.03698198}, {394,0.03417117}, {395,0.03754054}, {396,0.03445946}, {397,0.03760360}, {398,0.03493694}, {399,0.03784685}, {400,0.03473874}, {401,0.03762162}, {402,0.03492793}, {403,0.03550450}, {404,0.03502703}, {405,0.03568468}, {406,0.03556757}, {407,0.03585586}, {408,0.03543243}, {409,0.03582883}, {410,0.03593694}, {411,0.03633333}, {412,0.03611712}, {413,0.03895495}, {414,0.03640541}, {415,0.03936937}, {416,0.03598198}, {417,0.03894595}, {418,0.03618919}, {419,0.03936937}, {420,0.03642342}, {421,0.03976577}, {422,0.03666667}, {423,0.03695495}, {424,0.04088288}, {425,0.03718018}, {426,0.04002703}, {427,0.03709009}, {428,0.04025225}, {429,0.03736937}, {430,0.03759459}, {431,0.04081982}, {432,0.03734234}, {433,0.04132432}, {434,0.03787387}, {435,0.03796396}, {436,0.04069369}, {437,0.03818018}, {438,0.03788288}, {439,0.04132432}, {440,0.03813514}, {441,0.04175676}, {442,0.03858559}, {443,0.03867568}, {444,0.04160360}, {445,0.03883784}, {446,0.03903604}, {447,0.04313514}, {448,0.03820721}, {449,0.03872072}, {450,0.04175676}, {451,0.03913514}, {452,0.03881081}, {453,0.04271171}, {454,0.03913514}, {455,0.03963063}, {456,0.04254955}, {457,0.03918018}, {458,0.03935135}, {459,0.04349550}, {460,0.03946847}, {461,0.03982883}, {462,0.04386486}, {463,0.04380180}, {464,0.03978378}, {465,0.04012613}, {466,0.04371171}, {467,0.04020721}, {468,0.04081982}, {469,0.04450450}, {470,0.04408108}, {471,0.04109910}, {472,0.04044144}, {473,0.04463063}, {474,0.04479279}, {475,0.04167568}, {476,0.04171171}, {477,0.04211712}, {478,0.04540541}, {479,0.04558559}, {480,0.04124324}, {481,0.04177477}, {482,0.04556757}, {483,0.04540541}, {484,0.04168468}, {485,0.04260360}, {486,0.04269369}, {487,0.04663964}, {488,0.04572973}, {489,0.04281081}, {490,0.04233333}, {491,0.04302703}, {492,0.04634234}, {493,0.04690991}, {494,0.04587387}, {495,0.04383784}, {496,0.04284685}, {497,0.04328829}, {498,0.04345946}, {499,0.04766667}, {500,0.04710811}, {505,0.04728829}, {510,0.04512613}, {515,0.04445045}, {520,0.04509009}, {525,0.04573874}, {530,0.04636036}, {535,0.04724324}, {540,0.04759459}, {545,0.04748649}, {550,0.04816216}, {555,0.04883784}, {560,0.04882883}, {565,0.04975676}, {570,0.05002703}, {575,0.05098198}, {580,0.05280180}, {585,0.05432432}, {590,0.05525225}, {595,0.05191892}, {600,0.05239640}, {605,0.05620721}, {610,0.05687387}, {615,0.05463964}, {620,0.05418018}, {625,0.05853153}, {630,0.05982883}, {635,0.05698198}, {640,0.05836036}, {645,0.05659459}, {650,0.05722523}, {655,0.06143243}, {660,0.05805405}, {665,0.06148649}, {670,0.05943243}, {675,0.06237838}, {680,0.05975676}, {685,0.06359459}, {690,0.06082883}, {695,0.06557658}, {700,0.06445946}, {705,0.06164865}, {710,0.06504505}, {715,0.06321622}, {720,0.06644144}, {725,0.06727928}, {730,0.06483784}, {735,0.07000000}, {740,0.06859459}, {745,0.06895495}, {750,0.06743243}, {755,0.06746847}, {760,0.07133333}, {765,0.07206306}, {770,0.07054054}, {775,0.07283784}, {780,0.07304505}, {785,0.06914414}, {790,0.07009910}, {795,0.07100000}, {800,0.07007207}, {805,0.07545946}, {810,0.07498198}, {815,0.07649550}, {820,0.07281982}, {825,0.07383784}, {830,0.07471171}, {835,0.07616216}, {840,0.07589189}, {845,0.07757658}, {850,0.07772072}, {855,0.07990090}, {860,0.08022523}, {865,0.07653153}, {870,0.08181081}, {875,0.08171171}, {880,0.08191892}, {885,0.07973874}, {890,0.08297297}, {895,0.08545946}, {900,0.08210811}, {905,0.08338739}, {910,0.08509910}, {915,0.08479279}, {920,0.08496396}, {925,0.08382883}, {930,0.08569369}, {935,0.08507207}, {940,0.08695495}, {945,0.08500901}, {950,0.08871171}, {955,0.08956757}, {960,0.08772072}, {965,0.08877477}, {970,0.09009910}, {975,0.09116216}, {980,0.09097297}, {985,0.09296396}, {990,0.09239640}, {995,0.09211712}, {1000,0.08963964}, {1010,0.09428829}, {1020,0.09540541}, {1030,0.09512613}, {1040,0.09471171}, {1050,0.09644643}, {1060,0.09727273}, {1070,0.09907273}, {1080,0.09935455}, {1090,0.09972727}, {1100,0.10126364}, {1110,0.10340909}, {1120,0.10010000}, {1130,0.10500909}, {1140,0.10535455}, {1150,0.10816364}, {1160,0.10420000}, {1170,0.10745455}, {1180,0.10932727}, {1190,0.10850000}, {1200,0.10940909}, {1210,0.11413636}, {1220,0.11109091}, {1230,0.11252727}, {1240,0.11479091}, {1250,0.11789091}, {1260,0.11820000}, {1270,0.11973636}, {1280,0.11523636}, {1290,0.11734545}, {1300,0.12023636}, {1310,0.12225455}, {1320,0.12084545}, {1330,0.12256364}, {1340,0.12434545}, {1350,0.12391818}, {1360,0.12447273}, {1370,0.12708182}, {1380,0.12901818}, {1390,0.13139091}, {1400,0.13003636}, {1410,0.12844545}, {1420,0.13036364}, {1430,0.13160000}, {1440,0.13932727}, {1450,0.13460000}, {1460,0.13387273}, {1470,0.13810909}, {1480,0.13587273}, {1490,0.13798182}, {1500,0.14156364}, {1510,0.13843636}, {1520,0.14064545}, {1530,0.14398182}, {1540,0.14000909}, {1550,0.14425455}, {1560,0.14344545}, {1570,0.14404545}, {1580,0.14594545}, {1590,0.14701818}, {1600,0.16241818}, {1610,0.16457273}, {1620,0.14754545}, {1630,0.15036364}, {1640,0.15247273}, {1650,0.15458182}, {1660,0.15694545}, {1670,0.15330909}, {1680,0.15286364}, {1690,0.15862727}, {1700,0.15612727}, {1710,0.15781818}, {1720,0.16192727}, {1730,0.15698182}, {1740,0.16228182}, {1750,0.16120000}, {1760,0.16173636}, {1770,0.16507273}, {1780,0.16661818}, {1790,0.16975455}, {1800,0.16495455}, {1810,0.16624545}, {1820,0.16870909}, {1830,0.16988182}, {1840,0.16968182}, {1850,0.17287273}, {1860,0.17111818}, {1870,0.17921818}, {1880,0.17384545}, {1890,0.17488182}, {1900,0.17745455}, {1910,0.17969091}, {1920,0.17300909}, {1930,0.17843636}, {1940,0.18640909}, {1950,0.18322727}, {1960,0.18131818}, {1970,0.18358182}, {1980,0.18346364}, {1990,0.18554545}, {2000,0.18291818}, {2050,0.18692727}, {2100,0.19193636}, {2150,0.20011818}, {2200,0.20150909}, {2250,0.20960000}, {2300,0.21790000}, {2350,0.22089091}, {2400,0.22151818}, {2450,0.23734545}, {2500,0.23295455}, {2550,0.24151818}, {2600,0.23988182}, {2650,0.25016364}, {2700,0.25117273}, {2750,0.25840000}, {2800,0.26291818}, {2850,0.26866364}, {2900,0.26855455}, {2950,0.27379091}, {3000,0.28117273}, {3050,0.29980000}, {3100,0.29168182}, {3150,0.29368182}, {3200,0.29106364}, {3250,0.30226364}, {3300,0.31007273}, {3350,0.31511818}, {3400,0.31718182}, {3450,0.32774545}, {3500,0.33786364}, {3550,0.33582727}, {3600,0.32840000}, {3650,0.33883636}, {3700,0.34640909}, {3750,0.35266364}, {3800,0.36091818}, {3850,0.35718182}, {3900,0.37235455}, {3950,0.38582727}, {4000,0.37050000}, {4050,0.38545455}, {4100,0.37719091}, {4150,0.38930909}, {4200,0.38896364}, {4250,0.39889091}, {4300,0.40361818}, {4350,0.42248182}, {4400,0.41414545}, {4450,0.41730909}, {4500,0.42189091}, {4550,0.43369091}, {4600,0.44106364}, {4650,0.44284545}, {4700,0.45037273}, {4750,0.45070000}, {4800,0.44980000}, {4850,0.46129091}, {4900,0.46445455}, {4950,0.47131818}, {5000,0.47137273}, {5050,0.48660909}, {5100,0.49155455}, {5150,0.48787273}, {5200,0.48121818}, {5250,0.49001818}, {5300,0.50696364}, {5350,0.51458182}, {5400,0.51477273}, {5450,0.51430000}, {5500,0.52846364}, {5550,0.53570909}, {5600,0.52168182}, {5650,0.52822727}, {5700,0.52685455}, {5750,0.55191818}, {5800,0.53884545}, {5850,0.55413636}, {5900,0.54566364}, {5950,0.56036364}, {6000,0.55831818}, {6050,0.57150}, {6100,0.58175}, {6150,0.56925}, {6200,0.58950}, {6250,0.59975}, {6300,0.59475}, {6350,0.60325}, {6400,0.58200}, {6450,0.61125}, {6500,0.61125}, {6550,0.62425}, {6600,0.62200}, {6650,0.64975}, {6700,0.64875}, {6750,0.65075}, {6800,0.63550}, {6850,0.65175}, {6900,0.66125}, {6950,0.65925}, {7000,0.66925}, {7050,0.67300}, {7100,0.67850}, {7150,0.69800}, {7200,0.67725}, {7250,0.69050}, {7300,0.68625}, {7350,0.69950}, {7400,0.70375}, {7450,0.70975}, {7500,0.71450}, {7550,0.74675}, {7600,0.72475}, {7650,0.72525}, {7700,0.72675}, {7750,0.73450}, {7800,0.74850}, {7850,0.75150}, {7900,0.76450}, {7950,0.75775}, {8000,0.74875}, {8050,0.77725}, {8100,0.77775}, {8150,0.78600}, {8200,0.75625}, {8250,0.78200}, {8300,0.79000}, {8350,0.79950}, {8400,0.79050}, {8450,0.79375}, {8500,0.80525}, {8550,0.81225}, {8600,0.80725}, {8650,0.81975}, {8700,0.83900}, {8750,0.83475}, {8800,0.82125}, {8850,0.83125}, {8900,0.84350}, {8950,0.86825}, {9000,0.84250}, {9050,0.86150}, {9100,0.86300}, {9150,0.88875}, {9200,0.87425}, {9250,0.86075}, {9300,0.87450}, {9350,0.87575}, {9400,0.88525}, {9450,0.91375}, {9500,0.90350}, {9550,0.91575}, {9600,0.89600}, {9650,0.92150}, {9700,0.92575}, {9750,0.92600}, {9800,0.92250}, {9850,0.94950}, {9900,0.94250}, {9950,0.96325}, {10000,0.94025}, {10100,0.96850}, {10200,0.97050}, {10300,0.98575}, {10400,0.96625}, {10500,0.97275}, {10600,1.00250}, {10700,1.02100}, {10800,1.00800}, {10900,1.03750}, {11000,1.05550}, {11100,1.06275}, {11200,1.04825}, {11300,1.06725}, {11400,1.06825}, {11500,1.10150}, {11600,1.08550}, {11700,1.11850}, {11800,1.10325}, {11900,1.15575}, {12000,1.14250}, {12100,1.15025}, {12200,1.17350}, {12300,1.15500}, {12400,1.17700}, {12500,1.18875}, {12600,1.20150}, {12700,1.21425}, {12800,1.18250}, {12900,1.22650}, {13000,1.22675}, {13100,1.25725}, {13200,1.25725}, {13300,1.30500}, {13400,1.27025}, {13500,1.31075}, {13600,1.27275}, {13700,1.29650}, {13800,1.34575}, {13900,1.32225}, {14000,1.32450}, {14100,1.34200}, {14200,1.38450}, {14300,1.42150}, {14400,1.34425}, {14500,1.38350}, {14600,1.38075}, {14700,1.43050}, {14800,1.42750}, {14900,1.43275}, {15000,1.44950}, {15100,1.50125}, {15200,1.45575}, {15300,1.48925}, {15400,1.46450}, {15500,1.48650}, {15600,1.51475}, {15700,1.52725}, {15800,1.56725}, {15900,1.53750}, {16000,1.52150}, {16100,1.57500}, {16200,1.56525}, {16300,1.60950}, {16400,1.51925}, {16500,1.58750}, {16600,1.59750}, {16700,1.62750}, {16800,1.59750}, {16900,1.59050}, {17000,1.64150}, {17100,1.65000}, {17200,1.65350}, {17300,1.66550}, {17400,1.73075}, {17500,1.69850}, {17600,1.65525}, {17700,1.70975}, {17800,1.69975}, {17900,1.78025}, {18000,1.72375}, {18100,1.76875}, {18200,1.76475}, {18300,1.82600}, {18400,1.79275}, {18500,1.74700}, {18600,1.78250}, {18700,1.78350}, {18800,1.80850}, {18900,1.83025}, {19000,1.83575}, {19100,1.85900}, {19200,1.80500}, {19300,1.88475}, {19400,1.89000}, {19500,1.88675}, {19600,1.86525}, {19700,1.94350}, {19800,1.93550}, {19900,1.97850}, {20000,1.8920}};
data["big_flat"]["CanonicalStructuresHOAS"]["actual reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00007207}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00003604}, {14,0.00003604}, {15,0.00000000}, {16,0.00003604}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00003604}, {21,0.00007207}, {22,0.00003604}, {23,0.00003604}, {24,0.00003604}, {25,0.00000000}, {26,0.00007207}, {27,0.00003604}, {28,0.00003604}, {29,0.00007207}, {30,0.00000000}, {31,0.00003604}, {32,0.00000000}, {33,0.00007207}, {34,0.00000000}, {35,0.00003604}, {36,0.00007207}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00007207}, {41,0.00002703}, {42,0.00007207}, {43,0.00000000}, {44,0.00002703}, {45,0.00003604}, {46,0.00003604}, {47,0.00000000}, {48,0.00000000}, {49,0.00003604}, {50,0.00003604}, {51,0.00003604}, {52,0.00000000}, {53,0.00003604}, {54,0.00000000}, {55,0.00003604}, {56,0.00000000}, {57,0.00000000}, {58,0.00003604}, {59,0.00003604}, {60,0.00005405}, {61,0.00010811}, {62,0.00003604}, {63,0.00003604}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00009910}, {68,0.00000000}, {69,0.00000000}, {70,0.00003604}, {71,0.00007207}, {72,0.00000000}, {73,0.00003604}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00003604}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00003604}, {85,0.00000000}, {86,0.00003604}, {87,0.00007207}, {88,0.00007207}, {89,0.00003604}, {90,0.00003604}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00003604}, {95,0.00007207}, {96,0.00007207}, {97,0.00000000}, {98,0.00000000}, {99,0.00003604}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003604}, {105,0.00000000}, {106,0.00003604}, {107,0.00000000}, {108,0.00003604}, {109,0.00003604}, {110,0.00000000}, {111,0.00003604}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00003604}, {116,0.00003604}, {117,0.00000000}, {118,0.00003604}, {119,0.00000000}, {120,0.00003604}, {121,0.00000000}, {122,0.00000000}, {123,0.00003604}, {124,0.00000000}, {125,0.00007207}, {126,0.00000000}, {127,0.00003604}, {128,0.00000000}, {129,0.00000000}, {130,0.00007207}, {131,0.00000000}, {132,0.00000000}, {133,0.00007207}, {134,0.00000000}, {135,0.00003604}, {136,0.00003604}, {137,0.00003604}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00007207}, {142,0.00000000}, {143,0.00000000}, {144,0.00010811}, {145,0.00000000}, {146,0.00003604}, {147,0.00000000}, {148,0.00000000}, {149,0.00007207}, {150,0.00007207}, {151,0.00000000}, {152,0.00000000}, {153,0.00007207}, {154,0.00000000}, {155,0.00000000}, {156,0.00003604}, {157,0.00018018}, {158,0.00000000}, {159,0.00000000}, {160,0.00003604}, {161,0.00000000}, {162,0.00006306}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00003604}, {168,0.00003604}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00003604}, {174,0.00003604}, {175,0.00003604}, {176,0.00000000}, {177,0.00000000}, {178,0.00003604}, {179,0.00003604}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00007207}, {190,0.00000000}, {191,0.00003604}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00003604}, {196,0.00000000}, {197,0.00003604}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00009910}, {202,0.00000000}, {203,0.00007207}, {204,0.00003604}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00003604}, {213,0.00000000}, {214,0.00003604}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00003604}, {222,0.00003604}, {223,0.00007207}, {224,0.00007207}, {225,0.00000000}, {226,0.00007207}, {227,0.00000000}, {228,0.00000000}, {229,0.00009910}, {230,0.00000000}, {231,0.00000000}, {232,0.00002703}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00003604}, {239,0.00003604}, {240,0.00007207}, {241,0.00003604}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00003604}, {246,0.00010811}, {247,0.00003604}, {248,0.00003604}, {249,0.00003604}, {250,0.00000000}, {251,0.00003604}, {252,0.00000000}, {253,0.00000000}, {254,0.00007207}, {255,0.00003604}, {256,0.00000000}, {257,0.00000000}, {258,0.00003604}, {259,0.00000000}, {260,0.00003604}, {261,0.00000000}, {262,0.00003604}, {263,0.00003604}, {264,0.00003604}, {265,0.00000000}, {266,0.00002703}, {267,0.00003604}, {268,0.00000000}, {269,0.00000000}, {270,0.00003604}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00007207}, {275,0.00007207}, {276,0.00003604}, {277,0.00003604}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003604}, {282,0.00000000}, {283,0.00000000}, {284,0.00003604}, {285,0.00000000}, {286,0.00000000}, {287,0.00003604}, {288,0.00000000}, {289,0.00000000}, {290,0.00003604}, {291,0.00000000}, {292,0.00000000}, {293,0.00007207}, {294,0.00003604}, {295,0.00000000}, {296,0.00003604}, {297,0.00000000}, {298,0.00007207}, {299,0.00014414}, {300,0.00000000}, {301,0.00000000}, {302,0.00003604}, {303,0.00000000}, {304,0.00009910}, {305,0.00003604}, {306,0.00003604}, {307,0.00000000}, {308,0.00000000}, {309,0.00003604}, {310,0.00000000}, {311,0.00000000}, {312,0.00003604}, {313,0.00000000}, {314,0.00000000}, {315,0.00007207}, {316,0.00000000}, {317,0.00010811}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00003604}, {323,0.00007207}, {324,0.00007207}, {325,0.00003604}, {326,0.00000000}, {327,0.00003604}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00003604}, {332,0.00000000}, {333,0.00003604}, {334,0.00003604}, {335,0.00007207}, {336,0.00000000}, {337,0.00003604}, {338,0.00000000}, {339,0.00000000}, {340,0.00003604}, {341,0.00000000}, {342,0.00003604}, {343,0.00000000}, {344,0.00003604}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00003604}, {350,0.00000000}, {351,0.00000000}, {352,0.00010811}, {353,0.00000000}, {354,0.00000000}, {355,0.00003604}, {356,0.00000000}, {357,0.00000000}, {358,0.00003604}, {359,0.00003604}, {360,0.00003604}, {361,0.00003604}, {362,0.00000000}, {363,0.00002703}, {364,0.00000000}, {365,0.00007207}, {366,0.00000000}, {367,0.00003604}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00003604}, {380,0.00000000}, {381,0.00010811}, {382,0.00007207}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00003604}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00007207}, {395,0.00003604}, {396,0.00000000}, {397,0.00002703}, {398,0.00003604}, {399,0.00003604}, {400,0.00000000}, {401,0.00003604}, {402,0.00000000}, {403,0.00000000}, {404,0.00003604}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00002703}, {411,0.00003604}, {412,0.00003604}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00003604}, {418,0.00000000}, {419,0.00003604}, {420,0.00000000}, {421,0.00003604}, {422,0.00003604}, {423,0.00000000}, {424,0.00000000}, {425,0.00003604}, {426,0.00003604}, {427,0.00002703}, {428,0.00003604}, {429,0.00000000}, {430,0.00003604}, {431,0.00007207}, {432,0.00000000}, {433,0.00007207}, {434,0.00003604}, {435,0.00000000}, {436,0.00007207}, {437,0.00002703}, {438,0.00003604}, {439,0.00007207}, {440,0.00007207}, {441,0.00007207}, {442,0.00003604}, {443,0.00003604}, {444,0.00003604}, {445,0.00000000}, {446,0.00003604}, {447,0.00006306}, {448,0.00000000}, {449,0.00000000}, {450,0.00013514}, {451,0.00007207}, {452,0.00000000}, {453,0.00003604}, {454,0.00003604}, {455,0.00003604}, {456,0.00003604}, {457,0.00003604}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00003604}, {463,0.00003604}, {464,0.00000000}, {465,0.00003604}, {466,0.00010811}, {467,0.00007207}, {468,0.00003604}, {469,0.00014414}, {470,0.00010811}, {471,0.00000000}, {472,0.00000000}, {473,0.00006306}, {474,0.00010811}, {475,0.00000000}, {476,0.00003604}, {477,0.00000000}, {478,0.00020721}, {479,0.00006306}, {480,0.00003604}, {481,0.00003604}, {482,0.00000000}, {483,0.00017117}, {484,0.00013514}, {485,0.00003604}, {486,0.00000000}, {487,0.00007207}, {488,0.00000000}, {489,0.00000000}, {490,0.00003604}, {491,0.00007207}, {492,0.00007207}, {493,0.00014414}, {494,0.00013514}, {495,0.00003604}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00005405}, {500,0.00003604}, {505,0.00014414}, {510,0.00000000}, {515,0.00007207}, {520,0.00003604}, {525,0.00000000}, {530,0.00007207}, {535,0.00003604}, {540,0.00000000}, {545,0.00003604}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00007207}, {570,0.00000000}, {575,0.00003604}, {580,0.00014414}, {585,0.00018018}, {590,0.00014414}, {595,0.00003604}, {600,0.00000000}, {605,0.00007207}, {610,0.00014414}, {615,0.00003604}, {620,0.00000000}, {625,0.00007207}, {630,0.00003604}, {635,0.00000000}, {640,0.00003604}, {645,0.00000000}, {650,0.00000000}, {655,0.00007207}, {660,0.00007207}, {665,0.00010811}, {670,0.00000000}, {675,0.00007207}, {680,0.00000000}, {685,0.00003604}, {690,0.00003604}, {695,0.00007207}, {700,0.00003604}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00014414}, {725,0.00014414}, {730,0.00000000}, {735,0.00007207}, {740,0.00007207}, {745,0.00000000}, {750,0.00000000}, {755,0.00003604}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00003604}, {780,0.00010811}, {785,0.00000000}, {790,0.00003604}, {795,0.00003604}, {800,0.00000000}, {805,0.00000000}, {810,0.00010811}, {815,0.00014414}, {820,0.00000000}, {825,0.00000000}, {830,0.00007207}, {835,0.00006306}, {840,0.00007207}, {845,0.00010811}, {850,0.00007207}, {855,0.00003604}, {860,0.00003604}, {865,0.00000000}, {870,0.00003604}, {875,0.00014414}, {880,0.00003604}, {885,0.00003604}, {890,0.00010811}, {895,0.00007207}, {900,0.00000000}, {905,0.00034234}, {910,0.00003604}, {915,0.00000000}, {920,0.00017117}, {925,0.00000000}, {930,0.00003604}, {935,0.00003604}, {940,0.00010811}, {945,0.00003604}, {950,0.00007207}, {955,0.00010811}, {960,0.00007207}, {965,0.00000000}, {970,0.00003604}, {975,0.00009910}, {980,0.00010811}, {985,0.00009910}, {990,0.00014414}, {995,0.00007207}, {1000,0.00007207}, {1010,0.00025225}, {1020,0.00018018}, {1030,0.00010811}, {1040,0.00010811}, {1050,0.00016964}, {1060,0.00010909}, {1070,0.00007273}, {1080,0.00003636}, {1090,0.00014545}, {1100,0.00014545}, {1110,0.00007273}, {1120,0.00003636}, {1130,0.00007273}, {1140,0.00000000}, {1150,0.00007273}, {1160,0.00014545}, {1170,0.00010909}, {1180,0.00003636}, {1190,0.00003636}, {1200,0.00010909}, {1210,0.00014545}, {1220,0.00007273}, {1230,0.00007273}, {1240,0.00010000}, {1250,0.00010909}, {1260,0.00017273}, {1270,0.00007273}, {1280,0.00010909}, {1290,0.00018182}, {1300,0.00018182}, {1310,0.00010909}, {1320,0.00014545}, {1330,0.00003636}, {1340,0.00000000}, {1350,0.00007273}, {1360,0.00029091}, {1370,0.00017273}, {1380,0.00010909}, {1390,0.00010909}, {1400,0.00018182}, {1410,0.00000000}, {1420,0.00003636}, {1430,0.00014545}, {1440,0.00030909}, {1450,0.00013636}, {1460,0.00007273}, {1470,0.00007273}, {1480,0.00014545}, {1490,0.00010909}, {1500,0.00007273}, {1510,0.00010000}, {1520,0.00000000}, {1530,0.00014545}, {1540,0.00003636}, {1550,0.00000000}, {1560,0.00007273}, {1570,0.00003636}, {1580,0.00000000}, {1590,0.00003636}, {1600,0.00007273}, {1610,0.00010000}, {1620,0.00003636}, {1630,0.00003636}, {1640,0.00003636}, {1650,0.00006364}, {1660,0.00000000}, {1670,0.00003636}, {1680,0.00006364}, {1690,0.00003636}, {1700,0.00003636}, {1710,0.00003636}, {1720,0.00007273}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00003636}, {1770,0.00010909}, {1780,0.00000000}, {1790,0.00003636}, {1800,0.00003636}, {1810,0.00003636}, {1820,0.00003636}, {1830,0.00010909}, {1840,0.00007273}, {1850,0.00003636}, {1860,0.00000000}, {1870,0.00003636}, {1880,0.00003636}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00003636}, {1940,0.00010909}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00010909}, {1980,0.00007273}, {1990,0.00007273}, {2000,0.00003636}, {2050,0.00000000}, {2100,0.00003636}, {2150,0.00003636}, {2200,0.00003636}, {2250,0.00010000}, {2300,0.00010000}, {2350,0.00007273}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00003636}, {2600,0.00000000}, {2650,0.00007273}, {2700,0.00010909}, {2750,0.00000000}, {2800,0.00007273}, {2850,0.00000000}, {2900,0.00003636}, {2950,0.00003636}, {3000,0.00000000}, {3050,0.00003636}, {3100,0.00003636}, {3150,0.00003636}, {3200,0.00007273}, {3250,0.00014545}, {3300,0.00007273}, {3350,0.00000000}, {3400,0.00003636}, {3450,0.00007273}, {3500,0.00003636}, {3550,0.00007273}, {3600,0.00003636}, {3650,0.00003636}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00003636}, {3850,0.00003636}, {3900,0.00014545}, {3950,0.00003636}, {4000,0.00010909}, {4050,0.00010909}, {4100,0.00003636}, {4150,0.00018182}, {4200,0.00003636}, {4250,0.00003636}, {4300,0.00000000}, {4350,0.00007273}, {4400,0.00003636}, {4450,0.00003636}, {4500,0.00000000}, {4550,0.00007273}, {4600,0.00000000}, {4650,0.00007273}, {4700,0.00003636}, {4750,0.00047273}, {4800,0.00050000}, {4850,0.00032727}, {4900,0.00046364}, {4950,0.00021818}, {5000,0.00036364}, {5050,0.00013636}, {5100,0.00017273}, {5150,0.00007273}, {5200,0.00006364}, {5250,0.00003636}, {5300,0.00000000}, {5350,0.00003636}, {5400,0.00013636}, {5450,0.00003636}, {5500,0.00007273}, {5550,0.00053636}, {5600,0.00007273}, {5650,0.00003636}, {5700,0.00018182}, {5750,0.00000000}, {5800,0.00003636}, {5850,0.00000000}, {5900,0.00007273}, {5950,0.00010909}, {6000,0.00007273}, {6050,0.00000}, {6100,0.00100}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00100}, {6350,0.00000}, {6400,0.00100}, {6450,0.00000}, {6500,0.00100}, {6550,0.00100}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00100}, {6800,0.00000}, {6850,0.00200}, {6900,0.00000}, {6950,0.00000}, {7000,0.00100}, {7050,0.00000}, {7100,0.00100}, {7150,0.00000}, {7200,0.00000}, {7250,0.00200}, {7300,0.00000}, {7350,0.00000}, {7400,0.00100}, {7450,0.00200}, {7500,0.00100}, {7550,0.00000}, {7600,0.00000}, {7650,0.00100}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00100}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00100}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00100}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00100}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00100}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00100}, {14700,0.00000}, {14800,0.00100}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00100}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00100}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00100}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00100}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00100}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresHOAS"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00108108}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00001802}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00001802}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00001802}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00001802}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00098198}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000901}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000901}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000901}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000901}, {410,0.00000901}, {411,0.00000901}, {412,0.00000000}, {413,0.00000901}, {414,0.00002703}, {415,0.00000000}, {416,0.00001802}, {417,0.00000901}, {418,0.00002703}, {419,0.00005405}, {420,0.00000901}, {421,0.00000901}, {422,0.00004505}, {423,0.00004505}, {424,0.00004505}, {425,0.00004505}, {426,0.00003604}, {427,0.00006306}, {428,0.00006306}, {429,0.00004505}, {430,0.00009009}, {431,0.00009910}, {432,0.00016216}, {433,0.00013514}, {434,0.00014414}, {435,0.00016216}, {436,0.00017117}, {437,0.00014414}, {438,0.00020721}, {439,0.00027027}, {440,0.00027928}, {441,0.00031532}, {442,0.00032432}, {443,0.00045946}, {444,0.00036937}, {445,0.00046847}, {446,0.00044144}, {447,0.00043243}, {448,0.00050450}, {449,0.00054955}, {450,0.00053153}, {451,0.00057658}, {452,0.00063964}, {453,0.00065766}, {454,0.00071171}, {455,0.00067568}, {456,0.00068468}, {457,0.00065766}, {458,0.00072072}, {459,0.00072973}, {460,0.00071171}, {461,0.00071171}, {462,0.00070270}, {463,0.00076577}, {464,0.00080180}, {465,0.00079279}, {466,0.00082883}, {467,0.00081982}, {468,0.00083784}, {469,0.00084685}, {470,0.00088288}, {471,0.00089189}, {472,0.00088288}, {473,0.00092793}, {474,0.00094595}, {475,0.00097297}, {476,0.00097297}, {477,0.00095495}, {478,0.00096396}, {479,0.00099099}, {480,0.00098198}, {481,0.00105405}, {482,0.00099099}, {483,0.00100000}, {484,0.00100000}, {485,0.00100000}, {486,0.00100000}, {487,0.00100000}, {488,0.00100000}, {489,0.00100000}, {490,0.00100000}, {491,0.00100000}, {492,0.00100000}, {493,0.00100000}, {494,0.00100000}, {495,0.00100000}, {496,0.00100000}, {497,0.00100000}, {498,0.00100000}, {499,0.00100000}, {500,0.00100000}, {505,0.00100000}, {510,0.00100000}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00100000}, {535,0.00457658}, {540,0.00454955}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00105405}, {570,0.00100000}, {575,0.00100901}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00568468}, {800,0.00100000}, {805,0.00100901}, {810,0.00100901}, {815,0.00100000}, {820,0.00101802}, {825,0.00100901}, {830,0.00102703}, {835,0.00105405}, {840,0.00112613}, {845,0.00110811}, {850,0.00115315}, {855,0.00122523}, {860,0.00128829}, {865,0.00134234}, {870,0.00146847}, {875,0.00152252}, {880,0.00155856}, {885,0.00163063}, {890,0.00164865}, {895,0.00170270}, {900,0.00175676}, {905,0.00176577}, {910,0.00183784}, {915,0.00183784}, {920,0.00194595}, {925,0.00196396}, {930,0.00197297}, {935,0.00199099}, {940,0.00198198}, {945,0.00569369}, {950,0.00200000}, {955,0.00200000}, {960,0.00200000}, {965,0.00200000}, {970,0.00200000}, {975,0.00200000}, {980,0.00200000}, {985,0.00200000}, {990,0.00200000}, {995,0.00200000}, {1000,0.00200000}, {1010,0.00200000}, {1020,0.00200000}, {1030,0.00200000}, {1040,0.00200000}, {1050,0.00198214}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200909}, {1140,0.00200000}, {1150,0.00200000}, {1160,0.00201818}, {1170,0.00200000}, {1180,0.00200909}, {1190,0.00200000}, {1200,0.00200909}, {1210,0.00200909}, {1220,0.00203636}, {1230,0.00207273}, {1240,0.00210909}, {1250,0.00220909}, {1260,0.00219091}, {1270,0.00229091}, {1280,0.00244545}, {1290,0.00251818}, {1300,0.00263636}, {1310,0.00270909}, {1320,0.00276364}, {1330,0.00281818}, {1340,0.00288182}, {1350,0.00293636}, {1360,0.00290909}, {1370,0.00295455}, {1380,0.00298182}, {1390,0.00300000}, {1400,0.00299091}, {1410,0.00300000}, {1420,0.00300000}, {1430,0.00300000}, {1440,0.00300000}, {1450,0.00300000}, {1460,0.00300000}, {1470,0.00300000}, {1480,0.00300000}, {1490,0.00300000}, {1500,0.00300000}, {1510,0.00300000}, {1520,0.00300000}, {1530,0.00300000}, {1540,0.00308182}, {1550,0.00301818}, {1560,0.00301818}, {1570,0.00300000}, {1580,0.00313636}, {1590,0.00303636}, {1600,0.00302727}, {1610,0.00306364}, {1620,0.00310000}, {1630,0.00313636}, {1640,0.00326364}, {1650,0.00325455}, {1660,0.00326364}, {1670,0.00334545}, {1680,0.00922727}, {1690,0.00347273}, {1700,0.00357273}, {1710,0.00362727}, {1720,0.00370909}, {1730,0.00372727}, {1740,0.00384545}, {1750,0.00386364}, {1760,0.00390000}, {1770,0.00925455}, {1780,0.00397273}, {1790,0.00396364}, {1800,0.00398182}, {1810,0.00863636}, {1820,0.00400000}, {1830,0.00400000}, {1840,0.00400909}, {1850,0.00400000}, {1860,0.00400000}, {1870,0.00400000}, {1880,0.00400909}, {1890,0.00400909}, {1900,0.00400909}, {1910,0.00400000}, {1920,0.00400909}, {1930,0.00770909}, {1940,0.00401818}, {1950,0.00400909}, {1960,0.00960000}, {1970,0.00401818}, {1980,0.00409091}, {1990,0.00410000}, {2000,0.00410909}, {2050,0.00439091}, {2100,0.00470000}, {2150,0.00480909}, {2200,0.00496364}, {2250,0.00508182}, {2300,0.00501818}, {2350,0.00511818}, {2400,0.00536364}, {2450,0.00550909}, {2500,0.00574545}, {2550,0.00590000}, {2600,0.00598182}, {2650,0.00605455}, {2700,0.00610909}, {2750,0.00626364}, {2800,0.00642727}, {2850,0.01153636}, {2900,0.00686364}, {2950,0.00700000}, {3000,0.00701818}, {3050,0.00714545}, {3100,0.00728182}, {3150,0.00740909}, {3200,0.00758182}, {3250,0.00775455}, {3300,0.01360909}, {3350,0.00793636}, {3400,0.00810000}, {3450,0.00819091}, {3500,0.00840000}, {3550,0.00853636}, {3600,0.00868182}, {3650,0.00889091}, {3700,0.00897273}, {3750,0.01519091}, {3800,0.00920000}, {3850,0.00930909}, {3900,0.00954545}, {3950,0.00966364}, {4000,0.00970909}, {4050,0.01850909}, {4100,0.00997273}, {4150,0.01019091}, {4200,0.01037273}, {4250,0.01050000}, {4300,0.01059091}, {4350,0.01084545}, {4400,0.01092727}, {4450,0.01110000}, {4500,0.01118182}, {4550,0.02176364}, {4600,0.01159091}, {4650,0.01170000}, {4700,0.01860000}, {4750,0.01210909}, {4800,0.01204545}, {4850,0.01224545}, {4900,0.01243636}, {4950,0.01830000}, {5000,0.01281818}, {5050,0.01285455}, {5100,0.01284545}, {5150,0.01294545}, {5200,0.01311818}, {5250,0.01338182}, {5300,0.02525455}, {5350,0.01342727}, {5400,0.02192727}, {5450,0.01368182}, {5500,0.01383636}, {5550,0.02619091}, {5600,0.01397273}, {5650,0.01412727}, {5700,0.01410909}, {5750,0.01408182}, {5800,0.01416364}, {5850,0.02520909}, {5900,0.01429091}, {5950,0.01428182}, {6000,0.01426364}, {6050,0.01500}, {6100,0.02075}, {6150,0.01525}, {6200,0.02350}, {6250,0.01575}, {6300,0.01600}, {6350,0.02175}, {6400,0.01600}, {6450,0.01650}, {6500,0.01600}, {6550,0.02025}, {6600,0.01650}, {6650,0.02575}, {6700,0.02125}, {6750,0.04175}, {6800,0.01725}, {6850,0.02300}, {6900,0.01750}, {6950,0.01725}, {7000,0.01800}, {7050,0.01825}, {7100,0.01800}, {7150,0.01800}, {7200,0.04675}, {7250,0.04575}, {7300,0.04550}, {7350,0.01900}, {7400,0.01900}, {7450,0.05800}, {7500,0.03325}, {7550,0.03550}, {7600,0.03575}, {7650,0.04575}, {7700,0.06275}, {7750,0.01975}, {7800,0.02000}, {7850,0.03825}, {7900,0.02025}, {7950,0.02050}, {8000,0.02025}, {8050,0.03650}, {8100,0.02075}, {8150,0.04050}, {8200,0.02075}, {8250,0.02050}, {8300,0.04100}, {8350,0.04200}, {8400,0.03100}, {8450,0.03700}, {8500,0.03450}, {8550,0.02150}, {8600,0.04425}, {8650,0.03750}, {8700,0.03125}, {8750,0.02200}, {8800,0.02250}, {8850,0.04500}, {8900,0.03600}, {8950,0.02200}, {9000,0.03275}, {9050,0.02225}, {9100,0.04525}, {9150,0.02275}, {9200,0.04000}, {9250,0.04350}, {9300,0.02325}, {9350,0.03700}, {9400,0.03550}, {9450,0.02350}, {9500,0.02750}, {9550,0.02325}, {9600,0.03575}, {9650,0.02450}, {9700,0.02350}, {9750,0.02400}, {9800,0.02450}, {9850,0.03775}, {9900,0.04475}, {9950,0.03150}, {10000,0.02475}, {10100,0.03575}, {10200,0.02475}, {10300,0.04625}, {10400,0.04100}, {10500,0.02600}, {10600,0.02625}, {10700,0.03700}, {10800,0.02650}, {10900,0.03225}, {11000,0.02750}, {11100,0.04425}, {11200,0.03650}, {11300,0.04100}, {11400,0.02800}, {11500,0.02875}, {11600,0.02875}, {11700,0.02875}, {11800,0.03750}, {11900,0.03025}, {12000,0.03575}, {12100,0.03000}, {12200,0.03850}, {12300,0.03875}, {12400,0.03900}, {12500,0.03100}, {12600,0.04675}, {12700,0.04650}, {12800,0.05525}, {12900,0.03725}, {13000,0.03300}, {13100,0.05975}, {13200,0.04125}, {13300,0.03400}, {13400,0.03425}, {13500,0.03450}, {13600,0.05900}, {13700,0.04950}, {13800,0.04425}, {13900,0.04200}, {14000,0.05500}, {14100,0.05600}, {14200,0.06525}, {14300,0.03725}, {14400,0.05350}, {14500,0.03850}, {14600,0.05300}, {14700,0.06500}, {14800,0.06900}, {14900,0.05250}, {15000,0.06975}, {15100,0.05250}, {15200,0.05125}, {15300,0.04100}, {15400,0.07550}, {15500,0.04100}, {15600,0.07800}, {15700,0.04075}, {15800,0.05150}, {15900,0.07575}, {16000,0.04200}, {16100,0.04250}, {16200,0.05250}, {16300,0.07675}, {16400,0.06900}, {16500,0.04275}, {16600,0.07600}, {16700,0.05750}, {16800,0.04325}, {16900,0.04450}, {17000,0.07150}, {17100,0.04450}, {17200,0.07050}, {17300,0.07625}, {17400,0.08725}, {17500,0.04650}, {17600,0.04550}, {17700,0.04625}, {17800,0.05525}, {17900,0.05875}, {18000,0.06150}, {18100,0.05475}, {18200,0.08350}, {18300,0.04825}, {18400,0.05775}, {18500,0.07675}, {18600,0.04875}, {18700,0.09600}, {18800,0.08725}, {18900,0.06425}, {19000,0.05700}, {19100,0.07725}, {19200,0.10200}, {19300,0.08100}, {19400,0.07775}, {19500,0.09550}, {19600,0.05200}, {19700,0.06625}, {19800,0.06525}, {19900,0.06175}, {20000,0.0665}};
data["big_flat"]["CanonicalStructuresHOAS"]["cbv"]["user"] = {{1,0.00003604}, {2,0.00000000}, {3,0.00006306}, {4,0.00002703}, {5,0.00000000}, {6,0.00002703}, {7,0.00012613}, {8,0.00002703}, {9,0.00003604}, {10,0.00006306}, {11,0.00002703}, {12,0.00006306}, {13,0.00003604}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00005405}, {18,0.00003604}, {19,0.00006306}, {20,0.00002703}, {21,0.00011712}, {22,0.00000000}, {23,0.00009910}, {24,0.00009009}, {25,0.00002703}, {26,0.00006306}, {27,0.00002703}, {28,0.00006306}, {29,0.00009009}, {30,0.00006306}, {31,0.00003604}, {32,0.00017117}, {33,0.00002703}, {34,0.00008108}, {35,0.00005405}, {36,0.00009009}, {37,0.00009910}, {38,0.00002703}, {39,0.00017117}, {40,0.00005405}, {41,0.00015315}, {42,0.00009009}, {43,0.00002703}, {44,0.00009009}, {45,0.00000000}, {46,0.00009910}, {47,0.00013514}, {48,0.00012613}, {49,0.00005405}, {50,0.00012613}, {51,0.00014414}, {52,0.00002703}, {53,0.00015315}, {54,0.00014414}, {55,0.00009009}, {56,0.00009910}, {57,0.00014414}, {58,0.00008108}, {59,0.00006306}, {60,0.00018919}, {61,0.00011712}, {62,0.00021622}, {63,0.00012613}, {64,0.00012613}, {65,0.00005405}, {66,0.00010811}, {67,0.00005405}, {68,0.00015315}, {69,0.00024324}, {70,0.00008108}, {71,0.00013514}, {72,0.00027027}, {73,0.00009910}, {74,0.00019820}, {75,0.00008108}, {76,0.00022523}, {77,0.00036937}, {78,0.00006306}, {79,0.00022523}, {80,0.00035135}, {81,0.00009009}, {82,0.00015315}, {83,0.00018919}, {84,0.00026126}, {85,0.00005405}, {86,0.00005405}, {87,0.00010811}, {88,0.00018018}, {89,0.00009009}, {90,0.00023423}, {91,0.00018018}, {92,0.00018919}, {93,0.00011712}, {94,0.00029730}, {95,0.00017117}, {96,0.00017117}, {97,0.00026126}, {98,0.00017117}, {99,0.00027027}, {100,0.00032432}, {101,0.00018018}, {102,0.00024324}, {103,0.00009009}, {104,0.00012613}, {105,0.00030631}, {106,0.00017117}, {107,0.00009910}, {108,0.00015315}, {109,0.00017117}, {110,0.00011712}, {111,0.00011712}, {112,0.00009910}, {113,0.00029730}, {114,0.00025225}, {115,0.00032432}, {116,0.00035135}, {117,0.00019820}, {118,0.00010811}, {119,0.00026126}, {120,0.00029730}, {121,0.00003604}, {122,0.00031532}, {123,0.00011712}, {124,0.00018018}, {125,0.00033333}, {126,0.00041441}, {127,0.00036036}, {128,0.00022523}, {129,0.00014414}, {130,0.00023423}, {131,0.00017117}, {132,0.00012613}, {133,0.00018919}, {134,0.00026126}, {135,0.00027928}, {136,0.00010811}, {137,0.00039640}, {138,0.00020721}, {139,0.00041441}, {140,0.00032432}, {141,0.00043243}, {142,0.00032432}, {143,0.00027928}, {144,0.00028829}, {145,0.00036036}, {146,0.00031532}, {147,0.00026126}, {148,0.00020721}, {149,0.00026126}, {150,0.00022523}, {151,0.00034234}, {152,0.00028829}, {153,0.00027928}, {154,0.00021622}, {155,0.00024324}, {156,0.00027928}, {157,0.00026126}, {158,0.00023423}, {159,0.00033333}, {160,0.00026126}, {161,0.00028829}, {162,0.00037838}, {163,0.00027928}, {164,0.00028829}, {165,0.00021622}, {166,0.00051351}, {167,0.00035135}, {168,0.00037838}, {169,0.00028829}, {170,0.00027928}, {171,0.00028829}, {172,0.00026126}, {173,0.00041441}, {174,0.00021622}, {175,0.00021622}, {176,0.00050450}, {177,0.00047748}, {178,0.00030631}, {179,0.00044144}, {180,0.00049550}, {181,0.00034234}, {182,0.00041441}, {183,0.00039640}, {184,0.00146847}, {185,0.00023423}, {186,0.00017117}, {187,0.00026126}, {188,0.00034234}, {189,0.00029730}, {190,0.00045946}, {191,0.00033333}, {192,0.00048649}, {193,0.00032432}, {194,0.00027027}, {195,0.00038739}, {196,0.00044144}, {197,0.00019820}, {198,0.00045946}, {199,0.00058559}, {200,0.00048649}, {201,0.00034234}, {202,0.00030631}, {203,0.00054054}, {204,0.00048649}, {205,0.00049550}, {206,0.00036036}, {207,0.00015315}, {208,0.00051351}, {209,0.00036937}, {210,0.00041441}, {211,0.00043243}, {212,0.00028829}, {213,0.00036937}, {214,0.00032432}, {215,0.00046847}, {216,0.00034234}, {217,0.00048649}, {218,0.00028829}, {219,0.00052252}, {220,0.00026126}, {221,0.00037838}, {222,0.00021622}, {223,0.00038739}, {224,0.00027027}, {225,0.00046847}, {226,0.00030631}, {227,0.00035135}, {228,0.00032432}, {229,0.00039640}, {230,0.00036036}, {231,0.00032432}, {232,0.00058559}, {233,0.00047748}, {234,0.00048649}, {235,0.00033333}, {236,0.00034234}, {237,0.00044144}, {238,0.00038739}, {239,0.00042342}, {240,0.00028829}, {241,0.00039640}, {242,0.00037838}, {243,0.00044144}, {244,0.00055856}, {245,0.00048649}, {246,0.00045045}, {247,0.00050450}, {248,0.00051351}, {249,0.00043243}, {250,0.00027928}, {251,0.00070270}, {252,0.00050450}, {253,0.00036937}, {254,0.00049550}, {255,0.00048649}, {256,0.00054054}, {257,0.00054955}, {258,0.00044144}, {259,0.00048649}, {260,0.00052252}, {261,0.00041441}, {262,0.00054054}, {263,0.00055856}, {264,0.00048649}, {265,0.00046847}, {266,0.00045045}, {267,0.00055856}, {268,0.00062162}, {269,0.00054054}, {270,0.00033333}, {271,0.00056757}, {272,0.00034234}, {273,0.00060360}, {274,0.00060360}, {275,0.00049550}, {276,0.00063063}, {277,0.00047748}, {278,0.00072973}, {279,0.00035135}, {280,0.00051351}, {281,0.00047748}, {282,0.00048649}, {283,0.00055856}, {284,0.00050450}, {285,0.00047748}, {286,0.00057658}, {287,0.00053153}, {288,0.00039640}, {289,0.00051351}, {290,0.00056757}, {291,0.00038739}, {292,0.00053153}, {293,0.00063964}, {294,0.00055856}, {295,0.00071171}, {296,0.00068468}, {297,0.00045045}, {298,0.00056757}, {299,0.00063964}, {300,0.00050450}, {301,0.00056757}, {302,0.00072973}, {303,0.00063063}, {304,0.00042342}, {305,0.00058559}, {306,0.00048649}, {307,0.00039640}, {308,0.00056757}, {309,0.00046847}, {310,0.00060360}, {311,0.00039640}, {312,0.00021622}, {313,0.00066667}, {314,0.00049550}, {315,0.00059459}, {316,0.00034234}, {317,0.00060360}, {318,0.00085586}, {319,0.00045946}, {320,0.00058559}, {321,0.00065766}, {322,0.00071171}, {323,0.00057658}, {324,0.00049550}, {325,0.00047748}, {326,0.00057658}, {327,0.00063964}, {328,0.00055856}, {329,0.00064865}, {330,0.00068468}, {331,0.00054955}, {332,0.00053153}, {333,0.00074775}, {334,0.00047748}, {335,0.00055856}, {336,0.00067568}, {337,0.00071171}, {338,0.00044144}, {339,0.00060360}, {340,0.00064865}, {341,0.00071171}, {342,0.00040541}, {343,0.00049550}, {344,0.00072973}, {345,0.00043243}, {346,0.00078378}, {347,0.00062162}, {348,0.00072072}, {349,0.00063964}, {350,0.00068468}, {351,0.00067568}, {352,0.00066667}, {353,0.00061261}, {354,0.00043243}, {355,0.00058559}, {356,0.00052252}, {357,0.00057658}, {358,0.00062162}, {359,0.00054955}, {360,0.00073874}, {361,0.00081982}, {362,0.00086486}, {363,0.00074775}, {364,0.00066667}, {365,0.00062162}, {366,0.00075676}, {367,0.00084685}, {368,0.00044144}, {369,0.00079279}, {370,0.00070270}, {371,0.00077477}, {372,0.00037838}, {373,0.00100901}, {374,0.00063964}, {375,0.00063063}, {376,0.00054054}, {377,0.00080180}, {378,0.00077477}, {379,0.00117117}, {380,0.00054054}, {381,0.00081081}, {382,0.00091892}, {383,0.00054955}, {384,0.00071171}, {385,0.00058559}, {386,0.00080180}, {387,0.00058559}, {388,0.00062162}, {389,0.00067568}, {390,0.00075676}, {391,0.00077477}, {392,0.00083784}, {393,0.00084685}, {394,0.00075676}, {395,0.00061261}, {396,0.00060360}, {397,0.00075676}, {398,0.00069369}, {399,0.00067568}, {400,0.00071171}, {401,0.00062162}, {402,0.00074775}, {403,0.00081081}, {404,0.00075676}, {405,0.00051351}, {406,0.00051351}, {407,0.00081081}, {408,0.00074775}, {409,0.00058559}, {410,0.00075676}, {411,0.00058559}, {412,0.00052252}, {413,0.00050450}, {414,0.00084685}, {415,0.00070270}, {416,0.00081982}, {417,0.00078378}, {418,0.00079279}, {419,0.00053153}, {420,0.00092793}, {421,0.00065766}, {422,0.00081982}, {423,0.00081982}, {424,0.00062162}, {425,0.00067568}, {426,0.00059459}, {427,0.00094595}, {428,0.00074775}, {429,0.00084685}, {430,0.00093694}, {431,0.00083784}, {432,0.00096396}, {433,0.00085586}, {434,0.00060360}, {435,0.00057658}, {436,0.00074775}, {437,0.00090090}, {438,0.00073874}, {439,0.00094595}, {440,0.00074775}, {441,0.00066667}, {442,0.00106306}, {443,0.00065766}, {444,0.00063063}, {445,0.00077477}, {446,0.00096396}, {447,0.00068468}, {448,0.00104505}, {449,0.00078378}, {450,0.00064865}, {451,0.00103604}, {452,0.00056757}, {453,0.00066667}, {454,0.00084685}, {455,0.00098198}, {456,0.00063063}, {457,0.00075676}, {458,0.00099099}, {459,0.00099099}, {460,0.00054955}, {461,0.00083784}, {462,0.00090090}, {463,0.00090991}, {464,0.00083784}, {465,0.00096396}, {466,0.00067568}, {467,0.00111712}, {468,0.00074775}, {469,0.00116216}, {470,0.00062162}, {471,0.00063964}, {472,0.00100901}, {473,0.00090991}, {474,0.00072973}, {475,0.00081982}, {476,0.00083784}, {477,0.00096396}, {478,0.00070270}, {479,0.00082883}, {480,0.00093694}, {481,0.00082883}, {482,0.00112613}, {483,0.00088288}, {484,0.00094595}, {485,0.00080180}, {486,0.00083784}, {487,0.00093694}, {488,0.00090090}, {489,0.00104505}, {490,0.00082883}, {491,0.00077477}, {492,0.00103604}, {493,0.00096396}, {494,0.00104505}, {495,0.00083784}, {496,0.00117117}, {497,0.00076577}, {498,0.00088288}, {499,0.00088288}, {500,0.00088288}, {505,0.00088288}, {510,0.00068468}, {515,0.00093694}, {520,0.00096396}, {525,0.00113514}, {530,0.00100901}, {535,0.00436937}, {540,0.00443243}, {545,0.00102703}, {550,0.00135135}, {555,0.00099099}, {560,0.00118919}, {565,0.00096396}, {570,0.00111712}, {575,0.00116216}, {580,0.00094595}, {585,0.00105405}, {590,0.00081982}, {595,0.00103604}, {600,0.00110811}, {605,0.00109009}, {610,0.00161261}, {615,0.00115315}, {620,0.00097297}, {625,0.00159459}, {630,0.00122523}, {635,0.00122523}, {640,0.00091892}, {645,0.00120721}, {650,0.00128829}, {655,0.00123423}, {660,0.00141441}, {665,0.00121622}, {670,0.00128829}, {675,0.00119820}, {680,0.00119820}, {685,0.00133333}, {690,0.00145045}, {695,0.00109009}, {700,0.00125225}, {705,0.00105405}, {710,0.00113514}, {715,0.00125225}, {720,0.00141441}, {725,0.00113514}, {730,0.00133333}, {735,0.00154955}, {740,0.00138739}, {745,0.00140541}, {750,0.00143243}, {755,0.00143243}, {760,0.00151351}, {765,0.00143243}, {770,0.00144144}, {775,0.00150450}, {780,0.00158559}, {785,0.00139640}, {790,0.00159459}, {795,0.00600901}, {800,0.00149550}, {805,0.00132432}, {810,0.00154054}, {815,0.00170270}, {820,0.00156757}, {825,0.00151351}, {830,0.00179279}, {835,0.00175676}, {840,0.00153153}, {845,0.00162162}, {850,0.00154955}, {855,0.00165766}, {860,0.00172973}, {865,0.00157658}, {870,0.00162162}, {875,0.00164865}, {880,0.00152252}, {885,0.00193694}, {890,0.00177477}, {895,0.00171171}, {900,0.00163063}, {905,0.00162162}, {910,0.00148649}, {915,0.00178378}, {920,0.00154054}, {925,0.00212613}, {930,0.00199099}, {935,0.00167568}, {940,0.00171171}, {945,0.00545946}, {950,0.00173874}, {955,0.00177477}, {960,0.00153153}, {965,0.00205405}, {970,0.00172072}, {975,0.00157658}, {980,0.00223423}, {985,0.00211712}, {990,0.00202703}, {995,0.00208108}, {1000,0.00209910}, {1010,0.00173874}, {1020,0.00212613}, {1030,0.00228829}, {1040,0.00184685}, {1050,0.00215179}, {1060,0.00203636}, {1070,0.00184545}, {1080,0.00208182}, {1090,0.00220000}, {1100,0.00214545}, {1110,0.00191818}, {1120,0.00230000}, {1130,0.00200000}, {1140,0.00220909}, {1150,0.00228182}, {1160,0.00210909}, {1170,0.00177273}, {1180,0.00207273}, {1190,0.00210909}, {1200,0.00205455}, {1210,0.00210909}, {1220,0.00252727}, {1230,0.00245455}, {1240,0.00251818}, {1250,0.00215455}, {1260,0.00232727}, {1270,0.00251818}, {1280,0.00245455}, {1290,0.00241818}, {1300,0.00268182}, {1310,0.00267273}, {1320,0.00276364}, {1330,0.00282727}, {1340,0.00283636}, {1350,0.00273636}, {1360,0.00292727}, {1370,0.00280000}, {1380,0.00288182}, {1390,0.00301818}, {1400,0.00299091}, {1410,0.00306364}, {1420,0.00317273}, {1430,0.00289091}, {1440,0.00294545}, {1450,0.00305455}, {1460,0.00326364}, {1470,0.00315455}, {1480,0.00303636}, {1490,0.00301818}, {1500,0.00317273}, {1510,0.00317273}, {1520,0.00317273}, {1530,0.00320000}, {1540,0.00346364}, {1550,0.00325455}, {1560,0.00317273}, {1570,0.00325455}, {1580,0.00348182}, {1590,0.00340909}, {1600,0.00334545}, {1610,0.00346364}, {1620,0.00344545}, {1630,0.00340909}, {1640,0.00357273}, {1650,0.00365455}, {1660,0.00360909}, {1670,0.00363636}, {1680,0.00913636}, {1690,0.00361818}, {1700,0.00365455}, {1710,0.00370909}, {1720,0.00373636}, {1730,0.00370909}, {1740,0.00388182}, {1750,0.00364545}, {1760,0.00391818}, {1770,0.00962727}, {1780,0.00389091}, {1790,0.00390000}, {1800,0.00410909}, {1810,0.00859091}, {1820,0.00413636}, {1830,0.00383636}, {1840,0.00414545}, {1850,0.00400000}, {1860,0.00392727}, {1870,0.00409091}, {1880,0.00391818}, {1890,0.00425455}, {1900,0.00418182}, {1910,0.00422727}, {1920,0.00436364}, {1930,0.00774545}, {1940,0.00398182}, {1950,0.00458182}, {1960,0.00928182}, {1970,0.00436364}, {1980,0.00465455}, {1990,0.00423636}, {2000,0.00446364}, {2050,0.00433636}, {2100,0.00483636}, {2150,0.00530909}, {2200,0.00493636}, {2250,0.00518182}, {2300,0.00531818}, {2350,0.00515455}, {2400,0.00535455}, {2450,0.00576364}, {2500,0.00562727}, {2550,0.00560909}, {2600,0.00574545}, {2650,0.00601818}, {2700,0.00622727}, {2750,0.00607273}, {2800,0.00638182}, {2850,0.01215455}, {2900,0.00668182}, {2950,0.00679091}, {3000,0.00699091}, {3050,0.00696364}, {3100,0.00713636}, {3150,0.00730000}, {3200,0.00750909}, {3250,0.00746364}, {3300,0.01380909}, {3350,0.00785455}, {3400,0.00799091}, {3450,0.00790000}, {3500,0.00830909}, {3550,0.00844545}, {3600,0.00875455}, {3650,0.00878182}, {3700,0.00935455}, {3750,0.01557273}, {3800,0.00897273}, {3850,0.00946364}, {3900,0.00993636}, {3950,0.00994545}, {4000,0.00955455}, {4050,0.01847273}, {4100,0.01024545}, {4150,0.01030909}, {4200,0.01055455}, {4250,0.01081818}, {4300,0.01050909}, {4350,0.01125455}, {4400,0.01109091}, {4450,0.01176364}, {4500,0.01146364}, {4550,0.02178182}, {4600,0.01227273}, {4650,0.01218182}, {4700,0.01841818}, {4750,0.01249091}, {4800,0.01247273}, {4850,0.01258182}, {4900,0.01282727}, {4950,0.01825455}, {5000,0.01309091}, {5050,0.01319091}, {5100,0.01337273}, {5150,0.01339091}, {5200,0.01341818}, {5250,0.01379091}, {5300,0.02531818}, {5350,0.01400000}, {5400,0.02202727}, {5450,0.01439091}, {5500,0.01395455}, {5550,0.02633636}, {5600,0.01439091}, {5650,0.01445455}, {5700,0.01459091}, {5750,0.01435455}, {5800,0.01458182}, {5850,0.02554545}, {5900,0.01455455}, {5950,0.01445455}, {6000,0.01463636}, {6050,0.01450}, {6100,0.02150}, {6150,0.01600}, {6200,0.02275}, {6250,0.01575}, {6300,0.01575}, {6350,0.02125}, {6400,0.01650}, {6450,0.01725}, {6500,0.01525}, {6550,0.02150}, {6600,0.01675}, {6650,0.02575}, {6700,0.01950}, {6750,0.04225}, {6800,0.01725}, {6850,0.02350}, {6900,0.01750}, {6950,0.01750}, {7000,0.01725}, {7050,0.01850}, {7100,0.01725}, {7150,0.01725}, {7200,0.04650}, {7250,0.04325}, {7300,0.04575}, {7350,0.01900}, {7400,0.01850}, {7450,0.05650}, {7500,0.03375}, {7550,0.03550}, {7600,0.03200}, {7650,0.04300}, {7700,0.06300}, {7750,0.02050}, {7800,0.01900}, {7850,0.03850}, {7900,0.02025}, {7950,0.01950}, {8000,0.01900}, {8050,0.03750}, {8100,0.01925}, {8150,0.04150}, {8200,0.02050}, {8250,0.01925}, {8300,0.04350}, {8350,0.04275}, {8400,0.03275}, {8450,0.03700}, {8500,0.03475}, {8550,0.02050}, {8600,0.04525}, {8650,0.03725}, {8700,0.02900}, {8750,0.02025}, {8800,0.02175}, {8850,0.04575}, {8900,0.03575}, {8950,0.02275}, {9000,0.03275}, {9050,0.02275}, {9100,0.04575}, {9150,0.02400}, {9200,0.04050}, {9250,0.04275}, {9300,0.02400}, {9350,0.03700}, {9400,0.03475}, {9450,0.02400}, {9500,0.02775}, {9550,0.02400}, {9600,0.03800}, {9650,0.02475}, {9700,0.02400}, {9750,0.02400}, {9800,0.02600}, {9850,0.03700}, {9900,0.04475}, {9950,0.03275}, {10000,0.02600}, {10100,0.03600}, {10200,0.02500}, {10300,0.04650}, {10400,0.04225}, {10500,0.02600}, {10600,0.02575}, {10700,0.03775}, {10800,0.02800}, {10900,0.03275}, {11000,0.02800}, {11100,0.04450}, {11200,0.03800}, {11300,0.04200}, {11400,0.02900}, {11500,0.02975}, {11600,0.03000}, {11700,0.02900}, {11800,0.03650}, {11900,0.03000}, {12000,0.03775}, {12100,0.03125}, {12200,0.03875}, {12300,0.03875}, {12400,0.03875}, {12500,0.03200}, {12600,0.04625}, {12700,0.04775}, {12800,0.05450}, {12900,0.03775}, {13000,0.03125}, {13100,0.05850}, {13200,0.04100}, {13300,0.03500}, {13400,0.03550}, {13500,0.03575}, {13600,0.05975}, {13700,0.05075}, {13800,0.04450}, {13900,0.04350}, {14000,0.05550}, {14100,0.05550}, {14200,0.06550}, {14300,0.03750}, {14400,0.05425}, {14500,0.03825}, {14600,0.05400}, {14700,0.06475}, {14800,0.06875}, {14900,0.05325}, {15000,0.07050}, {15100,0.05125}, {15200,0.05175}, {15300,0.04050}, {15400,0.07550}, {15500,0.04025}, {15600,0.07750}, {15700,0.03925}, {15800,0.05150}, {15900,0.07625}, {16000,0.04350}, {16100,0.04250}, {16200,0.05275}, {16300,0.07700}, {16400,0.06975}, {16500,0.04125}, {16600,0.07650}, {16700,0.05650}, {16800,0.04350}, {16900,0.04600}, {17000,0.07125}, {17100,0.04575}, {17200,0.06950}, {17300,0.07650}, {17400,0.08675}, {17500,0.04675}, {17600,0.04600}, {17700,0.04800}, {17800,0.05675}, {17900,0.05875}, {18000,0.06250}, {18100,0.05525}, {18200,0.08475}, {18300,0.04975}, {18400,0.05650}, {18500,0.07550}, {18600,0.04750}, {18700,0.09550}, {18800,0.08825}, {18900,0.06450}, {19000,0.05750}, {19100,0.07825}, {19200,0.10250}, {19300,0.08125}, {19400,0.07850}, {19500,0.09550}, {19600,0.05350}, {19700,0.06775}, {19800,0.06550}, {19900,0.06300}, {20000,0.0670}};
data["big_flat"]["CanonicalStructuresHOAS"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00003604}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00003604}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00003604}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00003604}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00003604}, {91,0.00000000}, {92,0.00003604}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00003604}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00003604}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00003604}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00003604}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00003604}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00003604}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00003604}, {166,0.00000000}, {167,0.00000000}, {168,0.00003604}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00003604}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00003604}, {212,0.00003604}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00002703}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00003604}, {228,0.00000000}, {229,0.00000000}, {230,0.00003604}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00003604}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00003604}, {260,0.00003604}, {261,0.00000000}, {262,0.00003604}, {263,0.00003604}, {264,0.00003604}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00003604}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00003604}, {288,0.00007207}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00002703}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00003604}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00003604}, {325,0.00000000}, {326,0.00003604}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00003604}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00007207}, {351,0.00000000}, {352,0.00003604}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00003604}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00003604}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00003604}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00003604}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00003604}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00003604}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00003604}, {430,0.00000000}, {431,0.00000000}, {432,0.00003604}, {433,0.00000000}, {434,0.00007207}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00003604}, {439,0.00000000}, {440,0.00003604}, {441,0.00003604}, {442,0.00000000}, {443,0.00003604}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00003604}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00003604}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00003604}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00003604}, {484,0.00003604}, {485,0.00003604}, {486,0.00003604}, {487,0.00000000}, {488,0.00007207}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00003604}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00007207}, {540,0.00003604}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00003604}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00003604}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00003604}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00003604}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00003604}, {750,0.00003604}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00003604}, {775,0.00003604}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00007207}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00003604}, {845,0.00003604}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00007207}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00003604}, {915,0.00003604}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00003604}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00003636}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00003636}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00003636}, {1200,0.00000000}, {1210,0.00003636}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00003636}, {1310,0.00003636}, {1320,0.00003636}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00003636}, {1370,0.00000000}, {1380,0.00003636}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00003636}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003636}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00003636}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00003636}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00003636}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00003636}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00003636}, {1860,0.00000000}, {1870,0.00003636}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00003636}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00003636}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00003636}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00003636}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00003636}, {3900,0.00003636}, {3950,0.00000000}, {4000,0.00003636}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00002727}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00007273}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00018182}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00100}, {6100,0.00000}, {6150,0.00000}, {6200,0.00075}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00200}, {7250,0.00200}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00100}, {7500,0.00000}, {7550,0.00000}, {7600,0.00275}, {7650,0.00200}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresHOAS"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00002703}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00384685}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00007207}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00433333}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000901}, {428,0.00000000}, {429,0.00000000}, {430,0.00000901}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000901}, {436,0.00000000}, {437,0.00000000}, {438,0.00000901}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000901}, {443,0.00000901}, {444,0.00000000}, {445,0.00000901}, {446,0.00001802}, {447,0.00000000}, {448,0.00000901}, {449,0.00001802}, {450,0.00000000}, {451,0.00000000}, {452,0.00001802}, {453,0.00000000}, {454,0.00000901}, {455,0.00000901}, {456,0.00000000}, {457,0.00001802}, {458,0.00004505}, {459,0.00001802}, {460,0.00003604}, {461,0.00001802}, {462,0.00001802}, {463,0.00000000}, {464,0.00003604}, {465,0.00003604}, {466,0.00000000}, {467,0.00005405}, {468,0.00005405}, {469,0.00008108}, {470,0.00000901}, {471,0.00001802}, {472,0.00003604}, {473,0.00004505}, {474,0.00000901}, {475,0.00005405}, {476,0.00011712}, {477,0.00008108}, {478,0.00004505}, {479,0.00001802}, {480,0.00009009}, {481,0.00011712}, {482,0.00014414}, {483,0.00003604}, {484,0.00017117}, {485,0.00016216}, {486,0.00017117}, {487,0.00008108}, {488,0.00004505}, {489,0.00021622}, {490,0.00030631}, {491,0.00027027}, {492,0.00030631}, {493,0.00013514}, {494,0.00003604}, {495,0.00033333}, {496,0.00046847}, {497,0.00045946}, {498,0.00043243}, {499,0.00031532}, {500,0.00010811}, {505,0.00006306}, {510,0.00076577}, {515,0.00081081}, {520,0.00088288}, {525,0.00095495}, {530,0.00094595}, {535,0.00097297}, {540,0.00100000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00107207}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00100000}, {830,0.00100000}, {835,0.00100000}, {840,0.00109910}, {845,0.00100000}, {850,0.00100000}, {855,0.00100000}, {860,0.00100000}, {865,0.00100000}, {870,0.00100000}, {875,0.00100000}, {880,0.00100901}, {885,0.00686486}, {890,0.00100000}, {895,0.00102703}, {900,0.00100000}, {905,0.00100000}, {910,0.00103604}, {915,0.00100000}, {920,0.00102703}, {925,0.00716216}, {930,0.00100000}, {935,0.00110811}, {940,0.00100901}, {945,0.00124324}, {950,0.00104505}, {955,0.00100000}, {960,0.00120721}, {965,0.00100901}, {970,0.00145045}, {975,0.00105405}, {980,0.00100000}, {985,0.00162162}, {990,0.00129730}, {995,0.00103604}, {1000,0.00181982}, {1010,0.00176577}, {1020,0.00163964}, {1030,0.00152252}, {1040,0.00154054}, {1050,0.00198214}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00198182}, {1130,0.00200000}, {1140,0.00200000}, {1150,0.00200000}, {1160,0.00200000}, {1170,0.00200000}, {1180,0.00200000}, {1190,0.00203636}, {1200,0.00200000}, {1210,0.00200000}, {1220,0.00200000}, {1230,0.00200000}, {1240,0.00200000}, {1250,0.00200000}, {1260,0.00200000}, {1270,0.00200000}, {1280,0.00200000}, {1290,0.00200000}, {1300,0.00209091}, {1310,0.00201818}, {1320,0.00200909}, {1330,0.00200000}, {1340,0.00200909}, {1350,0.00201818}, {1360,0.00201818}, {1370,0.00203636}, {1380,0.00200000}, {1390,0.00200000}, {1400,0.00200000}, {1410,0.00204545}, {1420,0.00753636}, {1430,0.00200000}, {1440,0.00206364}, {1450,0.00755455}, {1460,0.00202727}, {1470,0.00263636}, {1480,0.00226364}, {1490,0.00204545}, {1500,0.00245455}, {1510,0.00217273}, {1520,0.00216364}, {1530,0.00287273}, {1540,0.00269091}, {1550,0.00235455}, {1560,0.00224545}, {1570,0.00297273}, {1580,0.00292727}, {1590,0.00290000}, {1600,0.00298182}, {1610,0.00290000}, {1620,0.00298182}, {1630,0.00300000}, {1640,0.00300000}, {1650,0.00300000}, {1660,0.00287273}, {1670,0.00299091}, {1680,0.00300000}, {1690,0.00300000}, {1700,0.00300000}, {1710,0.00300000}, {1720,0.00307273}, {1730,0.00300000}, {1740,0.00300000}, {1750,0.00300000}, {1760,0.00300000}, {1770,0.00300000}, {1780,0.00300000}, {1790,0.00300000}, {1800,0.00300000}, {1810,0.00300000}, {1820,0.00300000}, {1830,0.00300000}, {1840,0.00300000}, {1850,0.00300000}, {1860,0.00300000}, {1870,0.00307273}, {1880,0.00300909}, {1890,0.00300909}, {1900,0.00300000}, {1910,0.00300000}, {1920,0.00315455}, {1930,0.00963636}, {1940,0.00300000}, {1950,0.00303636}, {1960,0.00342727}, {1970,0.00300909}, {1980,0.00330909}, {1990,0.00300909}, {2000,0.00362727}, {2050,0.00321818}, {2100,0.00829091}, {2150,0.00400000}, {2200,0.00391818}, {2250,0.00400000}, {2300,0.00400909}, {2350,0.00401818}, {2400,0.00410000}, {2450,0.00423636}, {2500,0.00400909}, {2550,0.00428182}, {2600,0.00451818}, {2650,0.00452727}, {2700,0.00479091}, {2750,0.00500000}, {2800,0.00499091}, {2850,0.00507273}, {2900,0.00502727}, {2950,0.00517273}, {3000,0.01346364}, {3050,0.00525455}, {3100,0.00524545}, {3150,0.00532727}, {3200,0.00560000}, {3250,0.01453636}, {3300,0.00593636}, {3350,0.01579091}, {3400,0.00603636}, {3450,0.00604545}, {3500,0.01343636}, {3550,0.00611818}, {3600,0.00619091}, {3650,0.00673636}, {3700,0.00676364}, {3750,0.00691818}, {3800,0.00672727}, {3850,0.00701818}, {3900,0.00696364}, {3950,0.00701818}, {4000,0.00734545}, {4050,0.00720000}, {4100,0.00753636}, {4150,0.01380909}, {4200,0.00792727}, {4250,0.00798182}, {4300,0.00787273}, {4350,0.00795455}, {4400,0.00805455}, {4450,0.00802727}, {4500,0.00804545}, {4550,0.00830909}, {4600,0.00818182}, {4650,0.00851818}, {4700,0.00880909}, {4750,0.01740909}, {4800,0.00877273}, {4850,0.00890909}, {4900,0.00890909}, {4950,0.01950909}, {5000,0.00899091}, {5050,0.00902727}, {5100,0.00938182}, {5150,0.01692727}, {5200,0.00973636}, {5250,0.00964545}, {5300,0.00970000}, {5350,0.00990909}, {5400,0.00983636}, {5450,0.01000000}, {5500,0.01001818}, {5550,0.01002727}, {5600,0.01000000}, {5650,0.01033636}, {5700,0.01017273}, {5750,0.01025455}, {5800,0.01035455}, {5850,0.02183636}, {5900,0.01045455}, {5950,0.01034545}, {6000,0.02383636}, {6050,0.01100}, {6100,0.01100}, {6150,0.01500}, {6200,0.01125}, {6250,0.01550}, {6300,0.01850}, {6350,0.01175}, {6400,0.01300}, {6450,0.01200}, {6500,0.02050}, {6550,0.01900}, {6600,0.01200}, {6650,0.01200}, {6700,0.01200}, {6750,0.02300}, {6800,0.01225}, {6850,0.01550}, {6900,0.01275}, {6950,0.01275}, {7000,0.01275}, {7050,0.01300}, {7100,0.01450}, {7150,0.02150}, {7200,0.01325}, {7250,0.01325}, {7300,0.01325}, {7350,0.01400}, {7400,0.01825}, {7450,0.01375}, {7500,0.01400}, {7550,0.01400}, {7600,0.01400}, {7650,0.02200}, {7700,0.02125}, {7750,0.01400}, {7800,0.01425}, {7850,0.01975}, {7900,0.01450}, {7950,0.01450}, {8000,0.01475}, {8050,0.01475}, {8100,0.01650}, {8150,0.01500}, {8200,0.01500}, {8250,0.01525}, {8300,0.01525}, {8350,0.01500}, {8400,0.01525}, {8450,0.01550}, {8500,0.01525}, {8550,0.01525}, {8600,0.01525}, {8650,0.02325}, {8700,0.02450}, {8750,0.01550}, {8800,0.01525}, {8850,0.02250}, {8900,0.01575}, {8950,0.01600}, {9000,0.02225}, {9050,0.02475}, {9100,0.01600}, {9150,0.02450}, {9200,0.01600}, {9250,0.01600}, {9300,0.02725}, {9350,0.01600}, {9400,0.02750}, {9450,0.01675}, {9500,0.01675}, {9550,0.01700}, {9600,0.02250}, {9650,0.01700}, {9700,0.01725}, {9750,0.01700}, {9800,0.01725}, {9850,0.01725}, {9900,0.01800}, {9950,0.02575}, {10000,0.01750}, {10100,0.01775}, {10200,0.01775}, {10300,0.01800}, {10400,0.01825}, {10500,0.01850}, {10600,0.01850}, {10700,0.03025}, {10800,0.01875}, {10900,0.01975}, {11000,0.03000}, {11100,0.01925}, {11200,0.01950}, {11300,0.02000}, {11400,0.02200}, {11500,0.02350}, {11600,0.02025}, {11700,0.02100}, {11800,0.03075}, {11900,0.02125}, {12000,0.03125}, {12100,0.04125}, {12200,0.02175}, {12300,0.02225}, {12400,0.02225}, {12500,0.02225}, {12600,0.03200}, {12700,0.02375}, {12800,0.04125}, {12900,0.02325}, {13000,0.03750}, {13100,0.02325}, {13200,0.03650}, {13300,0.02475}, {13400,0.02625}, {13500,0.02425}, {13600,0.03825}, {13700,0.02900}, {13800,0.02475}, {13900,0.03950}, {14000,0.02525}, {14100,0.02550}, {14200,0.02550}, {14300,0.02625}, {14400,0.02650}, {14500,0.02650}, {14600,0.04575}, {14700,0.04175}, {14800,0.03625}, {14900,0.03575}, {15000,0.02800}, {15100,0.02750}, {15200,0.03775}, {15300,0.02800}, {15400,0.02800}, {15500,0.02825}, {15600,0.03800}, {15700,0.02875}, {15800,0.02875}, {15900,0.02900}, {16000,0.05000}, {16100,0.04575}, {16200,0.05125}, {16300,0.04275}, {16400,0.04350}, {16500,0.03000}, {16600,0.06150}, {16700,0.06225}, {16800,0.04975}, {16900,0.05125}, {17000,0.03100}, {17100,0.04325}, {17200,0.03150}, {17300,0.05075}, {17400,0.05875}, {17500,0.03200}, {17600,0.03200}, {17700,0.03275}, {17800,0.03250}, {17900,0.03625}, {18000,0.05150}, {18100,0.05075}, {18200,0.06800}, {18300,0.03350}, {18400,0.03375}, {18500,0.04375}, {18600,0.05575}, {18700,0.03875}, {18800,0.04000}, {18900,0.03900}, {19000,0.04350}, {19100,0.06625}, {19200,0.03500}, {19300,0.05450}, {19400,0.03950}, {19500,0.05500}, {19600,0.03600}, {19700,0.05425}, {19800,0.05475}, {19900,0.03650}, {20000,0.0405}};
data["big_flat"]["CanonicalStructuresHOAS"]["eval lazy"]["user"] = {{1,0.00006306}, {2,0.00006306}, {3,0.00006306}, {4,0.00002703}, {5,0.00009009}, {6,0.00000000}, {7,0.00000000}, {8,0.00006306}, {9,0.00005405}, {10,0.00003604}, {11,0.00005405}, {12,0.00000000}, {13,0.00002703}, {14,0.00000000}, {15,0.00002703}, {16,0.00005405}, {17,0.00006306}, {18,0.00011712}, {19,0.00009009}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00002703}, {24,0.00002703}, {25,0.00018919}, {26,0.00005405}, {27,0.00008108}, {28,0.00000000}, {29,0.00005405}, {30,0.00014414}, {31,0.00000000}, {32,0.00002703}, {33,0.00008108}, {34,0.00018018}, {35,0.00005405}, {36,0.00005405}, {37,0.00011712}, {38,0.00002703}, {39,0.00009910}, {40,0.00009009}, {41,0.00005405}, {42,0.00014414}, {43,0.00009910}, {44,0.00003604}, {45,0.00005405}, {46,0.00021622}, {47,0.00006306}, {48,0.00011712}, {49,0.00009910}, {50,0.00021622}, {51,0.00020721}, {52,0.00011712}, {53,0.00016216}, {54,0.00011712}, {55,0.00018018}, {56,0.00018018}, {57,0.00015315}, {58,0.00009009}, {59,0.00014414}, {60,0.00009009}, {61,0.00009009}, {62,0.00011712}, {63,0.00022523}, {64,0.00006306}, {65,0.00015315}, {66,0.00009009}, {67,0.00010811}, {68,0.00023423}, {69,0.00008108}, {70,0.00010811}, {71,0.00018919}, {72,0.00021622}, {73,0.00018018}, {74,0.00012613}, {75,0.00024324}, {76,0.00011712}, {77,0.00018919}, {78,0.00016216}, {79,0.00018919}, {80,0.00013514}, {81,0.00017117}, {82,0.00025225}, {83,0.00018018}, {84,0.00020721}, {85,0.00029730}, {86,0.00018018}, {87,0.00031532}, {88,0.00015315}, {89,0.00027027}, {90,0.00020721}, {91,0.00014414}, {92,0.00017117}, {93,0.00018018}, {94,0.00006306}, {95,0.00009009}, {96,0.00003604}, {97,0.00018018}, {98,0.00014414}, {99,0.00013514}, {100,0.00009009}, {101,0.00021622}, {102,0.00013514}, {103,0.00007207}, {104,0.00011712}, {105,0.00017117}, {106,0.00018018}, {107,0.00035135}, {108,0.00034234}, {109,0.00020721}, {110,0.00024324}, {111,0.00027027}, {112,0.00028829}, {113,0.00041441}, {114,0.00026126}, {115,0.00025225}, {116,0.00008108}, {117,0.00018018}, {118,0.00013514}, {119,0.00035135}, {120,0.00011712}, {121,0.00016216}, {122,0.00023423}, {123,0.00048649}, {124,0.00017117}, {125,0.00028829}, {126,0.00024324}, {127,0.00010811}, {128,0.00020721}, {129,0.00035135}, {130,0.00017117}, {131,0.00027928}, {132,0.00025225}, {133,0.00025225}, {134,0.00031532}, {135,0.00031532}, {136,0.00036036}, {137,0.00021622}, {138,0.00024324}, {139,0.00037838}, {140,0.00021622}, {141,0.00018919}, {142,0.00023423}, {143,0.00036036}, {144,0.00017117}, {145,0.00036937}, {146,0.00034234}, {147,0.00026126}, {148,0.00018919}, {149,0.00027027}, {150,0.00027928}, {151,0.00026126}, {152,0.00028829}, {153,0.00021622}, {154,0.00028829}, {155,0.00024324}, {156,0.00023423}, {157,0.00022523}, {158,0.00035135}, {159,0.00017117}, {160,0.00031532}, {161,0.00035135}, {162,0.00018919}, {163,0.00027928}, {164,0.00029730}, {165,0.00022523}, {166,0.00039640}, {167,0.00032432}, {168,0.00039640}, {169,0.00025225}, {170,0.00037838}, {171,0.00021622}, {172,0.00045946}, {173,0.00031532}, {174,0.00024324}, {175,0.00027027}, {176,0.00030631}, {177,0.00024324}, {178,0.00036937}, {179,0.00045946}, {180,0.00027027}, {181,0.00033333}, {182,0.00033333}, {183,0.00027027}, {184,0.00043243}, {185,0.00015315}, {186,0.00041441}, {187,0.00037838}, {188,0.00040541}, {189,0.00026126}, {190,0.00033333}, {191,0.00036937}, {192,0.00042342}, {193,0.00039640}, {194,0.00024324}, {195,0.00019820}, {196,0.00056757}, {197,0.00034234}, {198,0.00031532}, {199,0.00052252}, {200,0.00036036}, {201,0.00031532}, {202,0.00042342}, {203,0.00041441}, {204,0.00025225}, {205,0.00039640}, {206,0.00051351}, {207,0.00036036}, {208,0.00045946}, {209,0.00024324}, {210,0.00038739}, {211,0.00046847}, {212,0.00029730}, {213,0.00042342}, {214,0.00060360}, {215,0.00039640}, {216,0.00046847}, {217,0.00058559}, {218,0.00063964}, {219,0.00035135}, {220,0.00036937}, {221,0.00044144}, {222,0.00041441}, {223,0.00048649}, {224,0.00053153}, {225,0.00034234}, {226,0.00035135}, {227,0.00046847}, {228,0.00031532}, {229,0.00033333}, {230,0.00019820}, {231,0.00049550}, {232,0.00058559}, {233,0.00042342}, {234,0.00048649}, {235,0.00036937}, {236,0.00036036}, {237,0.00037838}, {238,0.00043243}, {239,0.00041441}, {240,0.00057658}, {241,0.00055856}, {242,0.00037838}, {243,0.00045045}, {244,0.00040541}, {245,0.00038739}, {246,0.00055856}, {247,0.00042342}, {248,0.00033333}, {249,0.00034234}, {250,0.00060360}, {251,0.00039640}, {252,0.00058559}, {253,0.00045946}, {254,0.00028829}, {255,0.00022523}, {256,0.00031532}, {257,0.00047748}, {258,0.00052252}, {259,0.00051351}, {260,0.00041441}, {261,0.00040541}, {262,0.00056757}, {263,0.00045946}, {264,0.00041441}, {265,0.00055856}, {266,0.00036036}, {267,0.00036036}, {268,0.00040541}, {269,0.00042342}, {270,0.00040541}, {271,0.00040541}, {272,0.00055856}, {273,0.00060360}, {274,0.00055856}, {275,0.00053153}, {276,0.00035135}, {277,0.00040541}, {278,0.00045045}, {279,0.00032432}, {280,0.00049550}, {281,0.00045946}, {282,0.00036937}, {283,0.00040541}, {284,0.00046847}, {285,0.00047748}, {286,0.00044144}, {287,0.00039640}, {288,0.00036937}, {289,0.00041441}, {290,0.00048649}, {291,0.00047748}, {292,0.00045946}, {293,0.00045946}, {294,0.00048649}, {295,0.00035135}, {296,0.00049550}, {297,0.00052252}, {298,0.00046847}, {299,0.00069369}, {300,0.00057658}, {301,0.00045946}, {302,0.00037838}, {303,0.00058559}, {304,0.00061261}, {305,0.00067568}, {306,0.00067568}, {307,0.00047748}, {308,0.00052252}, {309,0.00051351}, {310,0.00056757}, {311,0.00049550}, {312,0.00051351}, {313,0.00032432}, {314,0.00054054}, {315,0.00044144}, {316,0.00030631}, {317,0.00046847}, {318,0.00066667}, {319,0.00072973}, {320,0.00065766}, {321,0.00049550}, {322,0.00063964}, {323,0.00046847}, {324,0.00058559}, {325,0.00030631}, {326,0.00066667}, {327,0.00056757}, {328,0.00074775}, {329,0.00068468}, {330,0.00049550}, {331,0.00064865}, {332,0.00039640}, {333,0.00044144}, {334,0.00054955}, {335,0.00056757}, {336,0.00036937}, {337,0.00043243}, {338,0.00058559}, {339,0.00062162}, {340,0.00034234}, {341,0.00055856}, {342,0.00078378}, {343,0.00055856}, {344,0.00033333}, {345,0.00057658}, {346,0.00063063}, {347,0.00058559}, {348,0.00071171}, {349,0.00053153}, {350,0.00063964}, {351,0.00063063}, {352,0.00065766}, {353,0.00053153}, {354,0.00060360}, {355,0.00057658}, {356,0.00077477}, {357,0.00081081}, {358,0.00060360}, {359,0.00051351}, {360,0.00044144}, {361,0.00086486}, {362,0.00065766}, {363,0.00054054}, {364,0.00041441}, {365,0.00047748}, {366,0.00054054}, {367,0.00063063}, {368,0.00068468}, {369,0.00063063}, {370,0.00063964}, {371,0.00051351}, {372,0.00048649}, {373,0.00055856}, {374,0.00054955}, {375,0.00070270}, {376,0.00068468}, {377,0.00049550}, {378,0.00068468}, {379,0.00054955}, {380,0.00052252}, {381,0.00058559}, {382,0.00070270}, {383,0.00065766}, {384,0.00040541}, {385,0.00084685}, {386,0.00054054}, {387,0.00064865}, {388,0.00067568}, {389,0.00082883}, {390,0.00357658}, {391,0.00087387}, {392,0.00076577}, {393,0.00090090}, {394,0.00057658}, {395,0.00059459}, {396,0.00064865}, {397,0.00073874}, {398,0.00054955}, {399,0.00055856}, {400,0.00036937}, {401,0.00060360}, {402,0.00072973}, {403,0.00044144}, {404,0.00084685}, {405,0.00064865}, {406,0.00099099}, {407,0.00074775}, {408,0.00079279}, {409,0.00080180}, {410,0.00068468}, {411,0.00427928}, {412,0.00058559}, {413,0.00090991}, {414,0.00063964}, {415,0.00063063}, {416,0.00053153}, {417,0.00060360}, {418,0.00063063}, {419,0.00081081}, {420,0.00067568}, {421,0.00091892}, {422,0.00057658}, {423,0.00070270}, {424,0.00071171}, {425,0.00059459}, {426,0.00077477}, {427,0.00068468}, {428,0.00082883}, {429,0.00049550}, {430,0.00041441}, {431,0.00071171}, {432,0.00099099}, {433,0.00057658}, {434,0.00076577}, {435,0.00066667}, {436,0.00072072}, {437,0.00067568}, {438,0.00065766}, {439,0.00055856}, {440,0.00065766}, {441,0.00086486}, {442,0.00063063}, {443,0.00082883}, {444,0.00077477}, {445,0.00058559}, {446,0.00070270}, {447,0.00050450}, {448,0.00063964}, {449,0.00063063}, {450,0.00083784}, {451,0.00058559}, {452,0.00092793}, {453,0.00050450}, {454,0.00081081}, {455,0.00073874}, {456,0.00083784}, {457,0.00069369}, {458,0.00092793}, {459,0.00055856}, {460,0.00080180}, {461,0.00059459}, {462,0.00064865}, {463,0.00083784}, {464,0.00080180}, {465,0.00099099}, {466,0.00090090}, {467,0.00105405}, {468,0.00065766}, {469,0.00040541}, {470,0.00095495}, {471,0.00092793}, {472,0.00086486}, {473,0.00081081}, {474,0.00090090}, {475,0.00065766}, {476,0.00065766}, {477,0.00094595}, {478,0.00099099}, {479,0.00086486}, {480,0.00068468}, {481,0.00065766}, {482,0.00109910}, {483,0.00090090}, {484,0.00081982}, {485,0.00063964}, {486,0.00063964}, {487,0.00074775}, {488,0.00076577}, {489,0.00072973}, {490,0.00094595}, {491,0.00076577}, {492,0.00078378}, {493,0.00059459}, {494,0.00092793}, {495,0.00067568}, {496,0.00076577}, {497,0.00096396}, {498,0.00092793}, {499,0.00081982}, {500,0.00100000}, {505,0.00088288}, {510,0.00073874}, {515,0.00075676}, {520,0.00079279}, {525,0.00100000}, {530,0.00085586}, {535,0.00086486}, {540,0.00069369}, {545,0.00081982}, {550,0.00080180}, {555,0.00108108}, {560,0.00093694}, {565,0.00079279}, {570,0.00082883}, {575,0.00145946}, {580,0.00083784}, {585,0.00056757}, {590,0.00081982}, {595,0.00122523}, {600,0.00099099}, {605,0.00100901}, {610,0.00101802}, {615,0.00083784}, {620,0.00112613}, {625,0.00085586}, {630,0.00092793}, {635,0.00087387}, {640,0.00121622}, {645,0.00109009}, {650,0.00090090}, {655,0.00109009}, {660,0.00118018}, {665,0.00095495}, {670,0.00125225}, {675,0.00097297}, {680,0.00127027}, {685,0.00129730}, {690,0.00141441}, {695,0.00094595}, {700,0.00086486}, {705,0.00115315}, {710,0.00151351}, {715,0.00122523}, {720,0.00136937}, {725,0.00090991}, {730,0.00118919}, {735,0.00118018}, {740,0.00129730}, {745,0.00110811}, {750,0.00115315}, {755,0.00129730}, {760,0.00104505}, {765,0.00145946}, {770,0.00123423}, {775,0.00115315}, {780,0.00107207}, {785,0.00145946}, {790,0.00131532}, {795,0.00136036}, {800,0.00112613}, {805,0.00163964}, {810,0.00136036}, {815,0.00159459}, {820,0.00132432}, {825,0.00127928}, {830,0.00117117}, {835,0.00130631}, {840,0.00116216}, {845,0.00128829}, {850,0.00136036}, {855,0.00159459}, {860,0.00142342}, {865,0.00154054}, {870,0.00146847}, {875,0.00130631}, {880,0.00153153}, {885,0.00666667}, {890,0.00141441}, {895,0.00154054}, {900,0.00121622}, {905,0.00156757}, {910,0.00180180}, {915,0.00120721}, {920,0.00136937}, {925,0.00718919}, {930,0.00154955}, {935,0.00140541}, {940,0.00150450}, {945,0.00122523}, {950,0.00165766}, {955,0.00147748}, {960,0.00130631}, {965,0.00148649}, {970,0.00161261}, {975,0.00121622}, {980,0.00145946}, {985,0.00130631}, {990,0.00164865}, {995,0.00151351}, {1000,0.00165766}, {1010,0.00138739}, {1020,0.00175676}, {1030,0.00177477}, {1040,0.00162162}, {1050,0.00164286}, {1060,0.00187273}, {1070,0.00207273}, {1080,0.00189091}, {1090,0.00166364}, {1100,0.00184545}, {1110,0.00191818}, {1120,0.00203636}, {1130,0.00163636}, {1140,0.00178182}, {1150,0.00180909}, {1160,0.00173636}, {1170,0.00190909}, {1180,0.00205455}, {1190,0.00204545}, {1200,0.00198182}, {1210,0.00185455}, {1220,0.00225455}, {1230,0.00161818}, {1240,0.00201818}, {1250,0.00185455}, {1260,0.00186364}, {1270,0.00238182}, {1280,0.00220000}, {1290,0.00212727}, {1300,0.00235455}, {1310,0.00230000}, {1320,0.00260909}, {1330,0.00251818}, {1340,0.00248182}, {1350,0.00227273}, {1360,0.00230909}, {1370,0.00245455}, {1380,0.00234545}, {1390,0.00244545}, {1400,0.00231818}, {1410,0.00265455}, {1420,0.00759091}, {1430,0.00213636}, {1440,0.00284545}, {1450,0.00729091}, {1460,0.00268182}, {1470,0.00279091}, {1480,0.00289091}, {1490,0.00250909}, {1500,0.00278182}, {1510,0.00264545}, {1520,0.00285455}, {1530,0.00273636}, {1540,0.00280909}, {1550,0.00264545}, {1560,0.00282727}, {1570,0.00315455}, {1580,0.00304545}, {1590,0.00268182}, {1600,0.00267273}, {1610,0.00267273}, {1620,0.00286364}, {1630,0.00308182}, {1640,0.00309091}, {1650,0.00311818}, {1660,0.00281818}, {1670,0.00294545}, {1680,0.00317273}, {1690,0.00300909}, {1700,0.00293636}, {1710,0.00290909}, {1720,0.00297273}, {1730,0.00322727}, {1740,0.00303636}, {1750,0.00315455}, {1760,0.00308182}, {1770,0.00303636}, {1780,0.00311818}, {1790,0.00310000}, {1800,0.00317273}, {1810,0.00341818}, {1820,0.00333636}, {1830,0.00317273}, {1840,0.00322727}, {1850,0.00318182}, {1860,0.00305455}, {1870,0.00310909}, {1880,0.00326364}, {1890,0.00316364}, {1900,0.00321818}, {1910,0.00350909}, {1920,0.00358182}, {1930,0.00960909}, {1940,0.00340909}, {1950,0.00354545}, {1960,0.00349091}, {1970,0.00338182}, {1980,0.00359091}, {1990,0.00348182}, {2000,0.00378182}, {2050,0.00341818}, {2100,0.00784545}, {2150,0.00390000}, {2200,0.00390000}, {2250,0.00408182}, {2300,0.00450000}, {2350,0.00436364}, {2400,0.00454545}, {2450,0.00431818}, {2500,0.00412727}, {2550,0.00475455}, {2600,0.00437273}, {2650,0.00422727}, {2700,0.00455455}, {2750,0.00494545}, {2800,0.00480000}, {2850,0.00550000}, {2900,0.00530909}, {2950,0.00520000}, {3000,0.01379091}, {3050,0.00529091}, {3100,0.00553636}, {3150,0.00514545}, {3200,0.00568182}, {3250,0.01462727}, {3300,0.00550000}, {3350,0.01607273}, {3400,0.00613636}, {3450,0.00623636}, {3500,0.01389091}, {3550,0.00647273}, {3600,0.00620000}, {3650,0.00642727}, {3700,0.00665455}, {3750,0.00642727}, {3800,0.00649091}, {3850,0.00700909}, {3900,0.00670000}, {3950,0.00709091}, {4000,0.00727273}, {4050,0.00710000}, {4100,0.00741818}, {4150,0.01410909}, {4200,0.00760909}, {4250,0.00791818}, {4300,0.00745455}, {4350,0.00789091}, {4400,0.00794545}, {4450,0.00802727}, {4500,0.00812727}, {4550,0.00840909}, {4600,0.00797273}, {4650,0.00860000}, {4700,0.00851818}, {4750,0.01696364}, {4800,0.00900000}, {4850,0.00876364}, {4900,0.00896364}, {4950,0.01964545}, {5000,0.00890909}, {5050,0.00924545}, {5100,0.00963636}, {5150,0.01695455}, {5200,0.01014545}, {5250,0.00957273}, {5300,0.00926364}, {5350,0.00980909}, {5400,0.00981818}, {5450,0.01011818}, {5500,0.01019091}, {5550,0.01052727}, {5600,0.01050909}, {5650,0.01060000}, {5700,0.01101818}, {5750,0.01060000}, {5800,0.01040909}, {5850,0.02240000}, {5900,0.01091818}, {5950,0.01027273}, {6000,0.02406364}, {6050,0.01000}, {6100,0.01200}, {6150,0.01500}, {6200,0.01200}, {6250,0.01700}, {6300,0.02000}, {6350,0.01175}, {6400,0.01250}, {6450,0.01300}, {6500,0.02100}, {6550,0.01775}, {6600,0.01100}, {6650,0.01300}, {6700,0.01150}, {6750,0.02325}, {6800,0.01150}, {6850,0.01500}, {6900,0.01375}, {6950,0.01275}, {7000,0.01550}, {7050,0.01400}, {7100,0.01425}, {7150,0.02150}, {7200,0.01350}, {7250,0.01250}, {7300,0.01450}, {7350,0.01350}, {7400,0.01850}, {7450,0.01500}, {7500,0.01225}, {7550,0.01400}, {7600,0.01350}, {7650,0.02100}, {7700,0.02175}, {7750,0.01450}, {7800,0.01425}, {7850,0.02000}, {7900,0.01425}, {7950,0.01550}, {8000,0.01525}, {8050,0.01525}, {8100,0.01725}, {8150,0.01425}, {8200,0.01550}, {8250,0.01550}, {8300,0.01425}, {8350,0.01500}, {8400,0.01450}, {8450,0.01575}, {8500,0.01525}, {8550,0.01525}, {8600,0.01450}, {8650,0.02375}, {8700,0.02550}, {8750,0.01600}, {8800,0.01425}, {8850,0.02275}, {8900,0.01625}, {8950,0.01500}, {9000,0.02250}, {9050,0.02600}, {9100,0.01525}, {9150,0.02525}, {9200,0.01650}, {9250,0.01550}, {9300,0.02725}, {9350,0.01625}, {9400,0.02850}, {9450,0.01525}, {9500,0.01525}, {9550,0.01600}, {9600,0.02300}, {9650,0.01700}, {9700,0.01825}, {9750,0.01825}, {9800,0.01700}, {9850,0.01650}, {9900,0.01725}, {9950,0.02575}, {10000,0.01800}, {10100,0.01800}, {10200,0.01550}, {10300,0.01800}, {10400,0.01525}, {10500,0.01825}, {10600,0.01900}, {10700,0.03025}, {10800,0.01800}, {10900,0.01900}, {11000,0.02825}, {11100,0.01925}, {11200,0.02050}, {11300,0.01900}, {11400,0.02250}, {11500,0.02375}, {11600,0.02025}, {11700,0.02300}, {11800,0.03050}, {11900,0.02100}, {12000,0.03225}, {12100,0.04300}, {12200,0.02050}, {12300,0.02200}, {12400,0.02100}, {12500,0.02100}, {12600,0.03200}, {12700,0.02600}, {12800,0.04150}, {12900,0.02150}, {13000,0.03850}, {13100,0.02150}, {13200,0.03650}, {13300,0.02400}, {13400,0.02575}, {13500,0.02475}, {13600,0.03725}, {13700,0.02850}, {13800,0.02475}, {13900,0.04150}, {14000,0.02575}, {14100,0.02675}, {14200,0.02600}, {14300,0.02700}, {14400,0.02700}, {14500,0.02675}, {14600,0.04675}, {14700,0.04050}, {14800,0.03675}, {14900,0.03700}, {15000,0.02875}, {15100,0.02800}, {15200,0.03800}, {15300,0.02875}, {15400,0.02750}, {15500,0.02850}, {15600,0.03775}, {15700,0.02900}, {15800,0.03000}, {15900,0.02975}, {16000,0.04925}, {16100,0.04575}, {16200,0.05200}, {16300,0.04300}, {16400,0.04375}, {16500,0.03050}, {16600,0.06075}, {16700,0.06300}, {16800,0.04925}, {16900,0.05150}, {17000,0.03050}, {17100,0.04375}, {17200,0.03150}, {17300,0.05075}, {17400,0.05825}, {17500,0.03200}, {17600,0.03275}, {17700,0.03125}, {17800,0.03350}, {17900,0.03725}, {18000,0.05050}, {18100,0.05025}, {18200,0.06825}, {18300,0.03200}, {18400,0.03475}, {18500,0.04500}, {18600,0.05550}, {18700,0.03875}, {18800,0.04075}, {18900,0.03850}, {19000,0.04425}, {19100,0.06675}, {19200,0.03500}, {19300,0.05425}, {19400,0.03975}, {19500,0.05425}, {19600,0.03600}, {19700,0.05325}, {19800,0.05575}, {19900,0.03600}, {20000,0.0390}};
data["big_flat"]["CanonicalStructuresHOAS"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00003604}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00003604}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00003604}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00003604}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00003604}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00003604}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00002703}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00003604}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00003604}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00003604}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00003604}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00003604}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00003604}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00003604}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00003604}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00003604}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00007207}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00003604}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00003604}, {388,0.00000000}, {389,0.00000000}, {390,0.00010811}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00003604}, {409,0.00000000}, {410,0.00000000}, {411,0.00003604}, {412,0.00003604}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00003604}, {419,0.00000000}, {420,0.00000000}, {421,0.00003604}, {422,0.00003604}, {423,0.00003604}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00003604}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00003604}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00006306}, {458,0.00000000}, {459,0.00003604}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00003604}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00003604}, {482,0.00000000}, {483,0.00003604}, {484,0.00002703}, {485,0.00000000}, {486,0.00003604}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00003604}, {495,0.00000000}, {496,0.00000000}, {497,0.00003604}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00003604}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00003604}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00003604}, {585,0.00000000}, {590,0.00000000}, {595,0.00003604}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00003604}, {630,0.00000000}, {635,0.00000000}, {640,0.00003604}, {645,0.00000000}, {650,0.00003604}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00003604}, {695,0.00000000}, {700,0.00003604}, {705,0.00000000}, {710,0.00000000}, {715,0.00003604}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00003604}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00003604}, {795,0.00000000}, {800,0.00000000}, {805,0.00003604}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00003604}, {875,0.00000000}, {880,0.00000000}, {885,0.00021622}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00003604}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00010811}, {930,0.00003604}, {935,0.00000000}, {940,0.00000000}, {945,0.00003604}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00003604}, {1030,0.00000000}, {1040,0.00003604}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00003636}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00003636}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00007273}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00003636}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00003636}, {1300,0.00000000}, {1310,0.00003636}, {1320,0.00000000}, {1330,0.00003636}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00003636}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00003636}, {1440,0.00000000}, {1450,0.00007273}, {1460,0.00000000}, {1470,0.00003636}, {1480,0.00000000}, {1490,0.00003636}, {1500,0.00003636}, {1510,0.00003636}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00003636}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00007273}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003636}, {1670,0.00003636}, {1680,0.00000000}, {1690,0.00003636}, {1700,0.00003636}, {1710,0.00003636}, {1720,0.00000000}, {1730,0.00003636}, {1740,0.00000000}, {1750,0.00003636}, {1760,0.00000000}, {1770,0.00003636}, {1780,0.00002727}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00003636}, {1880,0.00006364}, {1890,0.00002727}, {1900,0.00000000}, {1910,0.00002727}, {1920,0.00003636}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00002727}, {2000,0.00000000}, {2050,0.00010909}, {2100,0.00007273}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00003636}, {2450,0.00000000}, {2500,0.00003636}, {2550,0.00003636}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00007273}, {3100,0.00003636}, {3150,0.00010909}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00003636}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00003636}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00003636}, {4200,0.00003636}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00003636}, {4550,0.00003636}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00003636}, {4750,0.00024545}, {4800,0.00003636}, {4850,0.00000000}, {4900,0.00003636}, {4950,0.00010909}, {5000,0.00000000}, {5050,0.00003636}, {5100,0.00010909}, {5150,0.00010909}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00003636}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00003636}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00003636}, {5650,0.00003636}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00007273}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00007273}, {6050,0.00100}, {6100,0.00000}, {6150,0.00100}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00075}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00100}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresHOAS"]["intros _"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00081081}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000909}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000909}, {2750,0.00005455}, {2800,0.00000000}, {2850,0.00041818}, {2900,0.00030909}, {2950,0.00040000}, {3000,0.00008182}, {3050,0.00035455}, {3100,0.00029091}, {3150,0.00021818}, {3200,0.00021818}, {3250,0.00033636}, {3300,0.00059091}, {3350,0.00056364}, {3400,0.00081818}, {3450,0.00078182}, {3500,0.00065455}, {3550,0.00075455}, {3600,0.00075455}, {3650,0.00096364}, {3700,0.00090909}, {3750,0.00100000}, {3800,0.00084545}, {3850,0.00100000}, {3900,0.00097273}, {3950,0.00098182}, {4000,0.00100000}, {4050,0.00100000}, {4100,0.00100000}, {4150,0.00100000}, {4200,0.00100000}, {4250,0.00100000}, {4300,0.00100000}, {4350,0.00100000}, {4400,0.00100000}, {4450,0.00100000}, {4500,0.00100000}, {4550,0.00100000}, {4600,0.00100000}, {4650,0.00100000}, {4700,0.00100000}, {4750,0.00100000}, {4800,0.00100000}, {4850,0.00100000}, {4900,0.00100000}, {4950,0.00100000}, {5000,0.00100000}, {5050,0.00100000}, {5100,0.00101818}, {5150,0.00100000}, {5200,0.00100909}, {5250,0.00100000}, {5300,0.00100000}, {5350,0.00101818}, {5400,0.00100000}, {5450,0.00100000}, {5500,0.00100909}, {5550,0.00101818}, {5600,0.00100909}, {5650,0.00107273}, {5700,0.00100909}, {5750,0.00100909}, {5800,0.00110909}, {5850,0.00100909}, {5900,0.00106364}, {5950,0.00100000}, {6000,0.00102727}, {6050,0.00100}, {6100,0.00100}, {6150,0.00150}, {6200,0.00125}, {6250,0.00125}, {6300,0.00100}, {6350,0.00125}, {6400,0.00150}, {6450,0.00150}, {6500,0.00150}, {6550,0.00125}, {6600,0.00125}, {6650,0.00175}, {6700,0.00700}, {6750,0.00150}, {6800,0.00150}, {6850,0.00175}, {6900,0.00175}, {6950,0.00175}, {7000,0.00175}, {7050,0.00200}, {7100,0.00200}, {7150,0.00175}, {7200,0.00200}, {7250,0.00200}, {7300,0.00200}, {7350,0.00200}, {7400,0.00200}, {7450,0.00200}, {7500,0.00200}, {7550,0.00200}, {7600,0.00200}, {7650,0.00200}, {7700,0.00200}, {7750,0.00200}, {7800,0.00200}, {7850,0.00200}, {7900,0.00200}, {7950,0.00200}, {8000,0.00200}, {8050,0.00200}, {8100,0.00600}, {8150,0.00200}, {8200,0.00200}, {8250,0.00200}, {8300,0.00200}, {8350,0.00200}, {8400,0.00200}, {8450,0.00200}, {8500,0.00200}, {8550,0.00200}, {8600,0.00200}, {8650,0.00200}, {8700,0.00200}, {8750,0.00200}, {8800,0.00200}, {8850,0.00200}, {8900,0.00200}, {8950,0.00200}, {9000,0.00225}, {9050,0.00200}, {9100,0.00200}, {9150,0.00200}, {9200,0.00200}, {9250,0.00200}, {9300,0.00200}, {9350,0.00200}, {9400,0.00200}, {9450,0.00200}, {9500,0.00200}, {9550,0.00200}, {9600,0.00200}, {9650,0.00225}, {9700,0.00225}, {9750,0.00250}, {9800,0.00200}, {9850,0.00200}, {9900,0.00200}, {9950,0.00200}, {10000,0.00250}, {10100,0.00200}, {10200,0.00200}, {10300,0.00200}, {10400,0.00200}, {10500,0.00250}, {10600,0.00275}, {10700,0.00200}, {10800,0.00225}, {10900,0.00250}, {11000,0.00250}, {11100,0.00225}, {11200,0.00225}, {11300,0.00250}, {11400,0.00250}, {11500,0.00250}, {11600,0.00300}, {11700,0.00300}, {11800,0.00300}, {11900,0.00325}, {12000,0.00300}, {12100,0.00300}, {12200,0.00300}, {12300,0.00325}, {12400,0.00300}, {12500,0.00300}, {12600,0.00300}, {12700,0.00300}, {12800,0.00300}, {12900,0.00300}, {13000,0.00350}, {13100,0.00325}, {13200,0.00300}, {13300,0.00350}, {13400,0.00375}, {13500,0.00425}, {13600,0.00300}, {13700,0.00325}, {13800,0.00350}, {13900,0.00325}, {14000,0.00325}, {14100,0.00350}, {14200,0.00375}, {14300,0.00450}, {14400,0.00400}, {14500,0.00425}, {14600,0.00375}, {14700,0.00400}, {14800,0.00400}, {14900,0.00425}, {15000,0.00425}, {15100,0.00425}, {15200,0.01075}, {15300,0.00450}, {15400,0.00425}, {15500,0.00450}, {15600,0.00450}, {15700,0.00450}, {15800,0.00475}, {15900,0.00450}, {16000,0.00450}, {16100,0.00500}, {16200,0.00475}, {16300,0.00475}, {16400,0.00500}, {16500,0.00475}, {16600,0.00450}, {16700,0.00475}, {16800,0.00475}, {16900,0.00550}, {17000,0.00525}, {17100,0.00475}, {17200,0.00475}, {17300,0.00475}, {17400,0.00475}, {17500,0.00500}, {17600,0.00525}, {17700,0.00575}, {17800,0.00525}, {17900,0.00550}, {18000,0.00575}, {18100,0.00575}, {18200,0.00550}, {18300,0.00475}, {18400,0.00575}, {18500,0.00550}, {18600,0.00525}, {18700,0.00525}, {18800,0.00550}, {18900,0.00575}, {19000,0.00550}, {19100,0.00575}, {19200,0.00575}, {19300,0.00575}, {19400,0.00625}, {19500,0.00575}, {19600,0.00600}, {19700,0.00575}, {19800,0.00600}, {19900,0.00575}, {20000,0.0055}};
data["big_flat"]["CanonicalStructuresHOAS"]["intros _"]["user"] = {{1,0.00000000}, {2,0.00005405}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00006306}, {7,0.00000000}, {8,0.00000000}, {9,0.00003604}, {10,0.00006306}, {11,0.00009009}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00008108}, {17,0.00007207}, {18,0.00003604}, {19,0.00009009}, {20,0.00003604}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00002703}, {26,0.00002703}, {27,0.00005405}, {28,0.00000000}, {29,0.00009009}, {30,0.00000000}, {31,0.00007207}, {32,0.00000000}, {33,0.00002703}, {34,0.00005405}, {35,0.00000000}, {36,0.00002703}, {37,0.00002703}, {38,0.00006306}, {39,0.00002703}, {40,0.00002703}, {41,0.00000000}, {42,0.00002703}, {43,0.00002703}, {44,0.00002703}, {45,0.00000000}, {46,0.00000000}, {47,0.00005405}, {48,0.00000000}, {49,0.00015315}, {50,0.00000000}, {51,0.00005405}, {52,0.00000000}, {53,0.00002703}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00002703}, {58,0.00000000}, {59,0.00002703}, {60,0.00006306}, {61,0.00005405}, {62,0.00000000}, {63,0.00010811}, {64,0.00006306}, {65,0.00005405}, {66,0.00002703}, {67,0.00009910}, {68,0.00002703}, {69,0.00006306}, {70,0.00002703}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00007207}, {75,0.00000000}, {76,0.00009009}, {77,0.00000000}, {78,0.00003604}, {79,0.00008108}, {80,0.00003604}, {81,0.00008108}, {82,0.00014414}, {83,0.00005405}, {84,0.00000000}, {85,0.00009009}, {86,0.00002703}, {87,0.00008108}, {88,0.00005405}, {89,0.00005405}, {90,0.00009910}, {91,0.00009009}, {92,0.00000000}, {93,0.00000000}, {94,0.00005405}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00002703}, {99,0.00000000}, {100,0.00000000}, {101,0.00003604}, {102,0.00006306}, {103,0.00005405}, {104,0.00006306}, {105,0.00003604}, {106,0.00005405}, {107,0.00010811}, {108,0.00009009}, {109,0.00007207}, {110,0.00005405}, {111,0.00002703}, {112,0.00006306}, {113,0.00011712}, {114,0.00006306}, {115,0.00003604}, {116,0.00002703}, {117,0.00002703}, {118,0.00000000}, {119,0.00009009}, {120,0.00006306}, {121,0.00009009}, {122,0.00006306}, {123,0.00009009}, {124,0.00012613}, {125,0.00002703}, {126,0.00002703}, {127,0.00003604}, {128,0.00009009}, {129,0.00002703}, {130,0.00005405}, {131,0.00009009}, {132,0.00012613}, {133,0.00005405}, {134,0.00009009}, {135,0.00002703}, {136,0.00000000}, {137,0.00002703}, {138,0.00009009}, {139,0.00002703}, {140,0.00000000}, {141,0.00008108}, {142,0.00000000}, {143,0.00008108}, {144,0.00002703}, {145,0.00006306}, {146,0.00000000}, {147,0.00006306}, {148,0.00002703}, {149,0.00003604}, {150,0.00002703}, {151,0.00002703}, {152,0.00000000}, {153,0.00002703}, {154,0.00005405}, {155,0.00006306}, {156,0.00009910}, {157,0.00002703}, {158,0.00008108}, {159,0.00016216}, {160,0.00008108}, {161,0.00002703}, {162,0.00009910}, {163,0.00011712}, {164,0.00009910}, {165,0.00002703}, {166,0.00009910}, {167,0.00008108}, {168,0.00019820}, {169,0.00009009}, {170,0.00010811}, {171,0.00011712}, {172,0.00002703}, {173,0.00002703}, {174,0.00003604}, {175,0.00000000}, {176,0.00006306}, {177,0.00011712}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00005405}, {182,0.00013514}, {183,0.00005405}, {184,0.00002703}, {185,0.00011712}, {186,0.00008108}, {187,0.00000000}, {188,0.00009009}, {189,0.00015315}, {190,0.00006306}, {191,0.00002703}, {192,0.00009910}, {193,0.00014414}, {194,0.00010811}, {195,0.00006306}, {196,0.00011712}, {197,0.00005405}, {198,0.00002703}, {199,0.00009910}, {200,0.00000000}, {201,0.00008108}, {202,0.00011712}, {203,0.00009910}, {204,0.00006306}, {205,0.00011712}, {206,0.00009910}, {207,0.00011712}, {208,0.00009910}, {209,0.00015315}, {210,0.00006306}, {211,0.00003604}, {212,0.00011712}, {213,0.00011712}, {214,0.00005405}, {215,0.00009910}, {216,0.00003604}, {217,0.00018018}, {218,0.00002703}, {219,0.00002703}, {220,0.00015315}, {221,0.00009009}, {222,0.00015315}, {223,0.00014414}, {224,0.00009910}, {225,0.00005405}, {226,0.00003604}, {227,0.00011712}, {228,0.00014414}, {229,0.00014414}, {230,0.00005405}, {231,0.00003604}, {232,0.00009009}, {233,0.00010811}, {234,0.00008108}, {235,0.00017117}, {236,0.00012613}, {237,0.00017117}, {238,0.00009009}, {239,0.00024324}, {240,0.00009009}, {241,0.00002703}, {242,0.00088288}, {243,0.00018018}, {244,0.00002703}, {245,0.00003604}, {246,0.00012613}, {247,0.00012613}, {248,0.00016216}, {249,0.00002703}, {250,0.00022523}, {251,0.00009009}, {252,0.00009009}, {253,0.00005405}, {254,0.00003604}, {255,0.00017117}, {256,0.00009910}, {257,0.00003604}, {258,0.00002703}, {259,0.00008108}, {260,0.00018018}, {261,0.00009009}, {262,0.00016216}, {263,0.00005405}, {264,0.00002703}, {265,0.00000000}, {266,0.00005405}, {267,0.00016216}, {268,0.00010811}, {269,0.00018919}, {270,0.00015315}, {271,0.00016216}, {272,0.00006306}, {273,0.00012613}, {274,0.00013514}, {275,0.00009009}, {276,0.00009009}, {277,0.00005405}, {278,0.00018018}, {279,0.00000000}, {280,0.00012613}, {281,0.00006306}, {282,0.00002703}, {283,0.00012613}, {284,0.00009009}, {285,0.00013514}, {286,0.00002703}, {287,0.00000000}, {288,0.00005405}, {289,0.00013514}, {290,0.00006306}, {291,0.00005405}, {292,0.00002703}, {293,0.00007207}, {294,0.00010811}, {295,0.00011712}, {296,0.00009009}, {297,0.00014414}, {298,0.00018018}, {299,0.00011712}, {300,0.00002703}, {301,0.00032432}, {302,0.00013514}, {303,0.00012613}, {304,0.00009910}, {305,0.00015315}, {306,0.00019820}, {307,0.00013514}, {308,0.00010811}, {309,0.00000000}, {310,0.00015315}, {311,0.00006306}, {312,0.00003604}, {313,0.00013514}, {314,0.00002703}, {315,0.00005405}, {316,0.00012613}, {317,0.00006306}, {318,0.00022523}, {319,0.00016216}, {320,0.00009009}, {321,0.00008108}, {322,0.00021622}, {323,0.00013514}, {324,0.00000000}, {325,0.00011712}, {326,0.00013514}, {327,0.00023423}, {328,0.00009009}, {329,0.00006306}, {330,0.00003604}, {331,0.00012613}, {332,0.00014414}, {333,0.00017117}, {334,0.00018018}, {335,0.00008108}, {336,0.00015315}, {337,0.00017117}, {338,0.00005405}, {339,0.00006306}, {340,0.00020721}, {341,0.00008108}, {342,0.00012613}, {343,0.00003604}, {344,0.00012613}, {345,0.00005405}, {346,0.00012613}, {347,0.00013514}, {348,0.00016216}, {349,0.00015315}, {350,0.00016216}, {351,0.00009009}, {352,0.00009009}, {353,0.00020721}, {354,0.00010811}, {355,0.00018919}, {356,0.00006306}, {357,0.00006306}, {358,0.00018018}, {359,0.00009910}, {360,0.00018018}, {361,0.00009009}, {362,0.00011712}, {363,0.00000000}, {364,0.00011712}, {365,0.00013514}, {366,0.00017117}, {367,0.00011712}, {368,0.00000000}, {369,0.00023423}, {370,0.00012613}, {371,0.00008108}, {372,0.00009009}, {373,0.00006306}, {374,0.00008108}, {375,0.00020721}, {376,0.00018018}, {377,0.00035135}, {378,0.00027027}, {379,0.00009009}, {380,0.00013514}, {381,0.00017117}, {382,0.00009910}, {383,0.00011712}, {384,0.00008108}, {385,0.00006306}, {386,0.00005405}, {387,0.00021622}, {388,0.00008108}, {389,0.00020721}, {390,0.00005405}, {391,0.00007207}, {392,0.00022523}, {393,0.00027928}, {394,0.00014414}, {395,0.00012613}, {396,0.00017117}, {397,0.00009009}, {398,0.00006306}, {399,0.00011712}, {400,0.00008108}, {401,0.00011712}, {402,0.00014414}, {403,0.00011712}, {404,0.00025225}, {405,0.00014414}, {406,0.00016216}, {407,0.00030631}, {408,0.00005405}, {409,0.00020721}, {410,0.00010811}, {411,0.00016216}, {412,0.00022523}, {413,0.00018919}, {414,0.00011712}, {415,0.00007207}, {416,0.00017117}, {417,0.00020721}, {418,0.00023423}, {419,0.00012613}, {420,0.00011712}, {421,0.00023423}, {422,0.00039640}, {423,0.00024324}, {424,0.00003604}, {425,0.00012613}, {426,0.00009009}, {427,0.00022523}, {428,0.00013514}, {429,0.00027928}, {430,0.00018018}, {431,0.00018919}, {432,0.00012613}, {433,0.00015315}, {434,0.00015315}, {435,0.00023423}, {436,0.00014414}, {437,0.00023423}, {438,0.00026126}, {439,0.00009009}, {440,0.00017117}, {441,0.00010811}, {442,0.00010811}, {443,0.00020721}, {444,0.00028829}, {445,0.00009009}, {446,0.00022523}, {447,0.00014414}, {448,0.00021622}, {449,0.00011712}, {450,0.00015315}, {451,0.00009910}, {452,0.00018919}, {453,0.00006306}, {454,0.00018919}, {455,0.00009910}, {456,0.00009009}, {457,0.00009910}, {458,0.00027027}, {459,0.00013514}, {460,0.00015315}, {461,0.00017117}, {462,0.00011712}, {463,0.00022523}, {464,0.00017117}, {465,0.00021622}, {466,0.00018919}, {467,0.00026126}, {468,0.00011712}, {469,0.00014414}, {470,0.00005405}, {471,0.00012613}, {472,0.00014414}, {473,0.00008108}, {474,0.00009009}, {475,0.00014414}, {476,0.00002703}, {477,0.00006306}, {478,0.00010811}, {479,0.00015315}, {480,0.00018018}, {481,0.00019820}, {482,0.00009009}, {483,0.00024324}, {484,0.00028829}, {485,0.00023423}, {486,0.00012613}, {487,0.00015315}, {488,0.00005405}, {489,0.00018919}, {490,0.00017117}, {491,0.00009009}, {492,0.00012613}, {493,0.00012613}, {494,0.00009009}, {495,0.00002703}, {496,0.00022523}, {497,0.00015315}, {498,0.00024324}, {499,0.00018919}, {500,0.00002703}, {505,0.00015315}, {510,0.00008108}, {515,0.00015315}, {520,0.00018919}, {525,0.00021622}, {530,0.00012613}, {535,0.00009910}, {540,0.00021622}, {545,0.00006306}, {550,0.00012613}, {555,0.00006306}, {560,0.00018018}, {565,0.00026126}, {570,0.00033333}, {575,0.00014414}, {580,0.00009910}, {585,0.00009009}, {590,0.00012613}, {595,0.00019820}, {600,0.00034234}, {605,0.00017117}, {610,0.00014414}, {615,0.00012613}, {620,0.00014414}, {625,0.00014414}, {630,0.00020721}, {635,0.00019820}, {640,0.00017117}, {645,0.00025225}, {650,0.00019820}, {655,0.00026126}, {660,0.00023423}, {665,0.00024324}, {670,0.00030631}, {675,0.00016216}, {680,0.00033333}, {685,0.00018919}, {690,0.00022523}, {695,0.00009009}, {700,0.00019820}, {705,0.00014414}, {710,0.00008108}, {715,0.00027928}, {720,0.00018018}, {725,0.00005405}, {730,0.00022523}, {735,0.00026126}, {740,0.00015315}, {745,0.00011712}, {750,0.00038739}, {755,0.00027027}, {760,0.00026126}, {765,0.00016216}, {770,0.00019820}, {775,0.00014414}, {780,0.00036937}, {785,0.00043243}, {790,0.00045946}, {795,0.00048649}, {800,0.00038739}, {805,0.00022523}, {810,0.00033333}, {815,0.00011712}, {820,0.00029730}, {825,0.00012613}, {830,0.00035135}, {835,0.00015315}, {840,0.00018018}, {845,0.00011712}, {850,0.00020721}, {855,0.00017117}, {860,0.00032432}, {865,0.00037838}, {870,0.00008108}, {875,0.00020721}, {880,0.00037838}, {885,0.00036036}, {890,0.00016216}, {895,0.00042342}, {900,0.00015315}, {905,0.00025225}, {910,0.00020721}, {915,0.00008108}, {920,0.00032432}, {925,0.00020721}, {930,0.00026126}, {935,0.00036036}, {940,0.00020721}, {945,0.00039640}, {950,0.00027027}, {955,0.00028829}, {960,0.00027027}, {965,0.00011712}, {970,0.00049550}, {975,0.00032432}, {980,0.00025225}, {985,0.00036937}, {990,0.00028829}, {995,0.00042342}, {1000,0.00044144}, {1010,0.00023423}, {1020,0.00013514}, {1030,0.00013514}, {1040,0.00036036}, {1050,0.00036364}, {1060,0.00023636}, {1070,0.00035455}, {1080,0.00033636}, {1090,0.00043636}, {1100,0.00030000}, {1110,0.00042727}, {1120,0.00020909}, {1130,0.00021818}, {1140,0.00045455}, {1150,0.00046364}, {1160,0.00026364}, {1170,0.00035455}, {1180,0.00045455}, {1190,0.00019091}, {1200,0.00046364}, {1210,0.00035455}, {1220,0.00034545}, {1230,0.00040000}, {1240,0.00043636}, {1250,0.00039091}, {1260,0.00046364}, {1270,0.00034545}, {1280,0.00020909}, {1290,0.00039091}, {1300,0.00023636}, {1310,0.00042727}, {1320,0.00025455}, {1330,0.00040909}, {1340,0.00040000}, {1350,0.00072727}, {1360,0.00051818}, {1370,0.00039091}, {1380,0.00043636}, {1390,0.00030000}, {1400,0.00058182}, {1410,0.00060000}, {1420,0.00042727}, {1430,0.00038182}, {1440,0.00038182}, {1450,0.00056364}, {1460,0.00040000}, {1470,0.00045455}, {1480,0.00023636}, {1490,0.00044545}, {1500,0.00040000}, {1510,0.00034545}, {1520,0.00053636}, {1530,0.00048182}, {1540,0.00051818}, {1550,0.00053636}, {1560,0.00034545}, {1570,0.00030909}, {1580,0.00044545}, {1590,0.00061818}, {1600,0.00070909}, {1610,0.00048182}, {1620,0.00043636}, {1630,0.00045455}, {1640,0.00053636}, {1650,0.00051818}, {1660,0.00055455}, {1670,0.00048182}, {1680,0.00048182}, {1690,0.00053636}, {1700,0.00050000}, {1710,0.00065455}, {1720,0.00052727}, {1730,0.00036364}, {1740,0.00056364}, {1750,0.00050909}, {1760,0.00051818}, {1770,0.00060909}, {1780,0.00049091}, {1790,0.00040909}, {1800,0.00066364}, {1810,0.00050909}, {1820,0.00061818}, {1830,0.00054545}, {1840,0.00050000}, {1850,0.00042727}, {1860,0.00077273}, {1870,0.00067273}, {1880,0.00050909}, {1890,0.00061818}, {1900,0.00066364}, {1910,0.00054545}, {1920,0.00073636}, {1930,0.00070000}, {1940,0.00040909}, {1950,0.00040000}, {1960,0.00058182}, {1970,0.00056364}, {1980,0.00057273}, {1990,0.00068182}, {2000,0.00071818}, {2050,0.00077273}, {2100,0.00071818}, {2150,0.00070909}, {2200,0.00060909}, {2250,0.00053636}, {2300,0.00061818}, {2350,0.00055455}, {2400,0.00090909}, {2450,0.00053636}, {2500,0.00078182}, {2550,0.00080909}, {2600,0.00070000}, {2650,0.00076364}, {2700,0.00091818}, {2750,0.00079091}, {2800,0.00055455}, {2850,0.00070909}, {2900,0.00090000}, {2950,0.00081818}, {3000,0.00087273}, {3050,0.00113636}, {3100,0.00070000}, {3150,0.00114545}, {3200,0.00083636}, {3250,0.00106364}, {3300,0.00092727}, {3350,0.00092727}, {3400,0.00113636}, {3450,0.00098182}, {3500,0.00079091}, {3550,0.00067273}, {3600,0.00100000}, {3650,0.00104545}, {3700,0.00080909}, {3750,0.00118182}, {3800,0.00115455}, {3850,0.00122727}, {3900,0.00144545}, {3950,0.00103636}, {4000,0.00129091}, {4050,0.00109091}, {4100,0.00070000}, {4150,0.00133636}, {4200,0.00160000}, {4250,0.00155455}, {4300,0.00160909}, {4350,0.00093636}, {4400,0.00130909}, {4450,0.00122727}, {4500,0.00123636}, {4550,0.00116364}, {4600,0.00108182}, {4650,0.00114545}, {4700,0.00180000}, {4750,0.00152727}, {4800,0.00140909}, {4850,0.00138182}, {4900,0.00136364}, {4950,0.00125455}, {5000,0.00155455}, {5050,0.00140909}, {5100,0.00138182}, {5150,0.00128182}, {5200,0.00115455}, {5250,0.00138182}, {5300,0.00176364}, {5350,0.00178182}, {5400,0.00166364}, {5450,0.00158182}, {5500,0.00150909}, {5550,0.00152727}, {5600,0.00167273}, {5650,0.00171818}, {5700,0.00105455}, {5750,0.00158182}, {5800,0.00136364}, {5850,0.00124545}, {5900,0.00182727}, {5950,0.00155455}, {6000,0.00157273}, {6050,0.00250}, {6100,0.00100}, {6150,0.00100}, {6200,0.00075}, {6250,0.00075}, {6300,0.00100}, {6350,0.00200}, {6400,0.00350}, {6450,0.00175}, {6500,0.00100}, {6550,0.00275}, {6600,0.00300}, {6650,0.00100}, {6700,0.00675}, {6750,0.00100}, {6800,0.00200}, {6850,0.00100}, {6900,0.00175}, {6950,0.00200}, {7000,0.00000}, {7050,0.00000}, {7100,0.00200}, {7150,0.00200}, {7200,0.00100}, {7250,0.00275}, {7300,0.00100}, {7350,0.00200}, {7400,0.00300}, {7450,0.00200}, {7500,0.00275}, {7550,0.00200}, {7600,0.00300}, {7650,0.00400}, {7700,0.00275}, {7750,0.00075}, {7800,0.00400}, {7850,0.00150}, {7900,0.00100}, {7950,0.00275}, {8000,0.00100}, {8050,0.00300}, {8100,0.00500}, {8150,0.00300}, {8200,0.00200}, {8250,0.00200}, {8300,0.00175}, {8350,0.00400}, {8400,0.00275}, {8450,0.00250}, {8500,0.00200}, {8550,0.00200}, {8600,0.00100}, {8650,0.00275}, {8700,0.00200}, {8750,0.00200}, {8800,0.00000}, {8850,0.00250}, {8900,0.00100}, {8950,0.00300}, {9000,0.00300}, {9050,0.00100}, {9100,0.00300}, {9150,0.00300}, {9200,0.00300}, {9250,0.00375}, {9300,0.00275}, {9350,0.00300}, {9400,0.00200}, {9450,0.00400}, {9500,0.00400}, {9550,0.00200}, {9600,0.00350}, {9650,0.00300}, {9700,0.00175}, {9750,0.00100}, {9800,0.00200}, {9850,0.00350}, {9900,0.00275}, {9950,0.00375}, {10000,0.00200}, {10100,0.00300}, {10200,0.00375}, {10300,0.00100}, {10400,0.00400}, {10500,0.00400}, {10600,0.00300}, {10700,0.00350}, {10800,0.00300}, {10900,0.00200}, {11000,0.00300}, {11100,0.00300}, {11200,0.00200}, {11300,0.00400}, {11400,0.00300}, {11500,0.00275}, {11600,0.00300}, {11700,0.00250}, {11800,0.00375}, {11900,0.00350}, {12000,0.00175}, {12100,0.00300}, {12200,0.00325}, {12300,0.00375}, {12400,0.00350}, {12500,0.00300}, {12600,0.00300}, {12700,0.00250}, {12800,0.00175}, {12900,0.00175}, {13000,0.00250}, {13100,0.00400}, {13200,0.00350}, {13300,0.00300}, {13400,0.00425}, {13500,0.00400}, {13600,0.00350}, {13700,0.00350}, {13800,0.00325}, {13900,0.00275}, {14000,0.00325}, {14100,0.00325}, {14200,0.00425}, {14300,0.00425}, {14400,0.00325}, {14500,0.00425}, {14600,0.00325}, {14700,0.00325}, {14800,0.00475}, {14900,0.00325}, {15000,0.00400}, {15100,0.00450}, {15200,0.01125}, {15300,0.00475}, {15400,0.00350}, {15500,0.00375}, {15600,0.00675}, {15700,0.00300}, {15800,0.00325}, {15900,0.00350}, {16000,0.00500}, {16100,0.00475}, {16200,0.00550}, {16300,0.00425}, {16400,0.00300}, {16500,0.00550}, {16600,0.00450}, {16700,0.00425}, {16800,0.00525}, {16900,0.00425}, {17000,0.00550}, {17100,0.00475}, {17200,0.00425}, {17300,0.00400}, {17400,0.00675}, {17500,0.00600}, {17600,0.00550}, {17700,0.00775}, {17800,0.00450}, {17900,0.00375}, {18000,0.00750}, {18100,0.00675}, {18200,0.00700}, {18300,0.00700}, {18400,0.00450}, {18500,0.00475}, {18600,0.00675}, {18700,0.00550}, {18800,0.00450}, {18900,0.00600}, {19000,0.00325}, {19100,0.00450}, {19200,0.00525}, {19300,0.00575}, {19400,0.00675}, {19500,0.00700}, {19600,0.00650}, {19700,0.00775}, {19800,0.00425}, {19900,0.00625}, {20000,0.0080}};
data["big_flat"]["CanonicalStructuresHOAS"]["intros _"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00003604}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00003604}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00003604}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00003604}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00003604}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00003604}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00003604}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00003604}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00007207}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00003604}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00003604}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00003604}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00003604}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00003604}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00003604}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00003604}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00003604}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00003604}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00003604}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00003636}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00003636}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00003636}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00003636}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00003636}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00003636}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00003636}, {1840,0.00003636}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00003636}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00003636}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00003636}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00003636}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00003636}, {3550,0.00007273}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00003636}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00003636}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00003636}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00003636}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00003636}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00003636}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00003636}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00100}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00100}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00100}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresHOAS"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00006306}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00009009}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000909}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00516364}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000909}, {2300,0.00005455}, {2350,0.00012727}, {2400,0.00029091}, {2450,0.00051818}, {2500,0.00081818}, {2550,0.00082727}, {2600,0.00097273}, {2650,0.00100000}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00100000}, {3150,0.00100000}, {3200,0.00100000}, {3250,0.00100000}, {3300,0.00100000}, {3350,0.00100000}, {3400,0.00100000}, {3450,0.00100000}, {3500,0.00100000}, {3550,0.00100000}, {3600,0.00100000}, {3650,0.00100000}, {3700,0.00110909}, {3750,0.00100000}, {3800,0.00100000}, {3850,0.00100909}, {3900,0.00100000}, {3950,0.00100000}, {4000,0.00100909}, {4050,0.00100909}, {4100,0.00101818}, {4150,0.00101818}, {4200,0.00986364}, {4250,0.00108182}, {4300,0.00113636}, {4350,0.00120000}, {4400,0.00143636}, {4450,0.00150000}, {4500,0.00168182}, {4550,0.00160909}, {4600,0.00163636}, {4650,0.00180909}, {4700,0.00177273}, {4750,0.00186364}, {4800,0.00184545}, {4850,0.00194545}, {4900,0.00190909}, {4950,0.00196364}, {5000,0.00195455}, {5050,0.00198182}, {5100,0.00199091}, {5150,0.00200000}, {5200,0.00200000}, {5250,0.00200000}, {5300,0.00200000}, {5350,0.00200000}, {5400,0.00200000}, {5450,0.00200000}, {5500,0.00200000}, {5550,0.00200000}, {5600,0.00200000}, {5650,0.00890000}, {5700,0.00200000}, {5750,0.00200000}, {5800,0.00203636}, {5850,0.00200909}, {5900,0.00201818}, {5950,0.00200000}, {6000,0.00201818}, {6050,0.00200}, {6100,0.00200}, {6150,0.00225}, {6200,0.00200}, {6250,0.00200}, {6300,0.00200}, {6350,0.00200}, {6400,0.00775}, {6450,0.00675}, {6500,0.00225}, {6550,0.00225}, {6600,0.00250}, {6650,0.00250}, {6700,0.00300}, {6750,0.00250}, {6800,0.00250}, {6850,0.00250}, {6900,0.00300}, {6950,0.00275}, {7000,0.00300}, {7050,0.00300}, {7100,0.00800}, {7150,0.00300}, {7200,0.00300}, {7250,0.00300}, {7300,0.00300}, {7350,0.00300}, {7400,0.00300}, {7450,0.00300}, {7500,0.00300}, {7550,0.00300}, {7600,0.00300}, {7650,0.00300}, {7700,0.00300}, {7750,0.00300}, {7800,0.00325}, {7850,0.00300}, {7900,0.00300}, {7950,0.00325}, {8000,0.00300}, {8050,0.00300}, {8100,0.00350}, {8150,0.00300}, {8200,0.01000}, {8250,0.00325}, {8300,0.00300}, {8350,0.00900}, {8400,0.00350}, {8450,0.00300}, {8500,0.00300}, {8550,0.00325}, {8600,0.00725}, {8650,0.00325}, {8700,0.00325}, {8750,0.00350}, {8800,0.00325}, {8850,0.00325}, {8900,0.00350}, {8950,0.00350}, {9000,0.00325}, {9050,0.00350}, {9100,0.00300}, {9150,0.00300}, {9200,0.00300}, {9250,0.00300}, {9300,0.00325}, {9350,0.00325}, {9400,0.00325}, {9450,0.00400}, {9500,0.00350}, {9550,0.00400}, {9600,0.01075}, {9650,0.00400}, {9700,0.00375}, {9750,0.00400}, {9800,0.00375}, {9850,0.00400}, {9900,0.00400}, {9950,0.00400}, {10000,0.00400}, {10100,0.00400}, {10200,0.00400}, {10300,0.00400}, {10400,0.00400}, {10500,0.00400}, {10600,0.00425}, {10700,0.00400}, {10800,0.00875}, {10900,0.00425}, {11000,0.00450}, {11100,0.00425}, {11200,0.00425}, {11300,0.01425}, {11400,0.00425}, {11500,0.00425}, {11600,0.00450}, {11700,0.00500}, {11800,0.00500}, {11900,0.01200}, {12000,0.00500}, {12100,0.00500}, {12200,0.00500}, {12300,0.00525}, {12400,0.00500}, {12500,0.00500}, {12600,0.00500}, {12700,0.00500}, {12800,0.00525}, {12900,0.00500}, {13000,0.00550}, {13100,0.00525}, {13200,0.00550}, {13300,0.00575}, {13400,0.00600}, {13500,0.00625}, {13600,0.00525}, {13700,0.00550}, {13800,0.00600}, {13900,0.00575}, {14000,0.00575}, {14100,0.00600}, {14200,0.01550}, {14300,0.00675}, {14400,0.00650}, {14500,0.00675}, {14600,0.00675}, {14700,0.00650}, {14800,0.00675}, {14900,0.00650}, {15000,0.00650}, {15100,0.00675}, {15200,0.00725}, {15300,0.00675}, {15400,0.01625}, {15500,0.00750}, {15600,0.00675}, {15700,0.01950}, {15800,0.02175}, {15900,0.00700}, {16000,0.00725}, {16100,0.00775}, {16200,0.00750}, {16300,0.01500}, {16400,0.01725}, {16500,0.00775}, {16600,0.00750}, {16700,0.00775}, {16800,0.00775}, {16900,0.00825}, {17000,0.02025}, {17100,0.00775}, {17200,0.00775}, {17300,0.00775}, {17400,0.00775}, {17500,0.02125}, {17600,0.00850}, {17700,0.00875}, {17800,0.01700}, {17900,0.00850}, {18000,0.02300}, {18100,0.00875}, {18200,0.00875}, {18300,0.02075}, {18400,0.00875}, {18500,0.00875}, {18600,0.00850}, {18700,0.00850}, {18800,0.00850}, {18900,0.00875}, {19000,0.00875}, {19100,0.00950}, {19200,0.00875}, {19300,0.02500}, {19400,0.00975}, {19500,0.00875}, {19600,0.01750}, {19700,0.00950}, {19800,0.02025}, {19900,0.00925}, {20000,0.0090}};
data["big_flat"]["CanonicalStructuresHOAS"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00003604}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00003604}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00003604}, {14,0.00000000}, {15,0.00000000}, {16,0.00002703}, {17,0.00003604}, {18,0.00000000}, {19,0.00000000}, {20,0.00003604}, {21,0.00003604}, {22,0.00000000}, {23,0.00002703}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00003604}, {28,0.00000000}, {29,0.00006306}, {30,0.00003604}, {31,0.00000000}, {32,0.00008108}, {33,0.00000000}, {34,0.00002703}, {35,0.00009910}, {36,0.00000000}, {37,0.00000000}, {38,0.00002703}, {39,0.00000000}, {40,0.00002703}, {41,0.00003604}, {42,0.00002703}, {43,0.00000000}, {44,0.00008108}, {45,0.00002703}, {46,0.00002703}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00005405}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00006306}, {55,0.00006306}, {56,0.00000000}, {57,0.00005405}, {58,0.00005405}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00012613}, {63,0.00000000}, {64,0.00000000}, {65,0.00003604}, {66,0.00008108}, {67,0.00002703}, {68,0.00000000}, {69,0.00000000}, {70,0.00002703}, {71,0.00008108}, {72,0.00002703}, {73,0.00000000}, {74,0.00000000}, {75,0.00006306}, {76,0.00002703}, {77,0.00009910}, {78,0.00005405}, {79,0.00006306}, {80,0.00005405}, {81,0.00002703}, {82,0.00002703}, {83,0.00006306}, {84,0.00005405}, {85,0.00005405}, {86,0.00003604}, {87,0.00002703}, {88,0.00000000}, {89,0.00000000}, {90,0.00007207}, {91,0.00006306}, {92,0.00000000}, {93,0.00009009}, {94,0.00002703}, {95,0.00005405}, {96,0.00009009}, {97,0.00011712}, {98,0.00002703}, {99,0.00009009}, {100,0.00003604}, {101,0.00009910}, {102,0.00002703}, {103,0.00002703}, {104,0.00006306}, {105,0.00005405}, {106,0.00000000}, {107,0.00000000}, {108,0.00002703}, {109,0.00002703}, {110,0.00002703}, {111,0.00006306}, {112,0.00012613}, {113,0.00005405}, {114,0.00009009}, {115,0.00000000}, {116,0.00000000}, {117,0.00003604}, {118,0.00000000}, {119,0.00021622}, {120,0.00008108}, {121,0.00003604}, {122,0.00012613}, {123,0.00000000}, {124,0.00011712}, {125,0.00025225}, {126,0.00005405}, {127,0.00003604}, {128,0.00009910}, {129,0.00002703}, {130,0.00005405}, {131,0.00011712}, {132,0.00011712}, {133,0.00009009}, {134,0.00002703}, {135,0.00007207}, {136,0.00000000}, {137,0.00015315}, {138,0.00016216}, {139,0.00009009}, {140,0.00009009}, {141,0.00013514}, {142,0.00003604}, {143,0.00003604}, {144,0.00003604}, {145,0.00005405}, {146,0.00006306}, {147,0.00018018}, {148,0.00007207}, {149,0.00002703}, {150,0.00008108}, {151,0.00019820}, {152,0.00008108}, {153,0.00006306}, {154,0.00009009}, {155,0.00000000}, {156,0.00012613}, {157,0.00005405}, {158,0.00017117}, {159,0.00000000}, {160,0.00005405}, {161,0.00005405}, {162,0.00009009}, {163,0.00002703}, {164,0.00002703}, {165,0.00018919}, {166,0.00005405}, {167,0.00014414}, {168,0.00011712}, {169,0.00009910}, {170,0.00009009}, {171,0.00002703}, {172,0.00008108}, {173,0.00012613}, {174,0.00006306}, {175,0.00006306}, {176,0.00009910}, {177,0.00009009}, {178,0.00005405}, {179,0.00005405}, {180,0.00012613}, {181,0.00006306}, {182,0.00009009}, {183,0.00015315}, {184,0.00000000}, {185,0.00009009}, {186,0.00012613}, {187,0.00002703}, {188,0.00005405}, {189,0.00005405}, {190,0.00011712}, {191,0.00005405}, {192,0.00002703}, {193,0.00000000}, {194,0.00013514}, {195,0.00003604}, {196,0.00002703}, {197,0.00005405}, {198,0.00009910}, {199,0.00000000}, {200,0.00006306}, {201,0.00005405}, {202,0.00002703}, {203,0.00006306}, {204,0.00002703}, {205,0.00006306}, {206,0.00009009}, {207,0.00006306}, {208,0.00015315}, {209,0.00009910}, {210,0.00009009}, {211,0.00011712}, {212,0.00006306}, {213,0.00011712}, {214,0.00011712}, {215,0.00000000}, {216,0.00015315}, {217,0.00011712}, {218,0.00009009}, {219,0.00009009}, {220,0.00012613}, {221,0.00007207}, {222,0.00009009}, {223,0.00000000}, {224,0.00015315}, {225,0.00009910}, {226,0.00002703}, {227,0.00012613}, {228,0.00011712}, {229,0.00010811}, {230,0.00002703}, {231,0.00017117}, {232,0.00012613}, {233,0.00013514}, {234,0.00018919}, {235,0.00003604}, {236,0.00009910}, {237,0.00003604}, {238,0.00002703}, {239,0.00002703}, {240,0.00005405}, {241,0.00002703}, {242,0.00008108}, {243,0.00013514}, {244,0.00002703}, {245,0.00015315}, {246,0.00005405}, {247,0.00013514}, {248,0.00016216}, {249,0.00024324}, {250,0.00011712}, {251,0.00006306}, {252,0.00000000}, {253,0.00003604}, {254,0.00005405}, {255,0.00013514}, {256,0.00005405}, {257,0.00016216}, {258,0.00009009}, {259,0.00019820}, {260,0.00010811}, {261,0.00003604}, {262,0.00007207}, {263,0.00013514}, {264,0.00024324}, {265,0.00014414}, {266,0.00003604}, {267,0.00011712}, {268,0.00008108}, {269,0.00000000}, {270,0.00015315}, {271,0.00009910}, {272,0.00009910}, {273,0.00014414}, {274,0.00003604}, {275,0.00012613}, {276,0.00016216}, {277,0.00017117}, {278,0.00008108}, {279,0.00015315}, {280,0.00011712}, {281,0.00013514}, {282,0.00016216}, {283,0.00005405}, {284,0.00009910}, {285,0.00009009}, {286,0.00008108}, {287,0.00013514}, {288,0.00010811}, {289,0.00017117}, {290,0.00009009}, {291,0.00011712}, {292,0.00010811}, {293,0.00002703}, {294,0.00023423}, {295,0.00000000}, {296,0.00010811}, {297,0.00018018}, {298,0.00002703}, {299,0.00014414}, {300,0.00006306}, {301,0.00002703}, {302,0.00016216}, {303,0.00009009}, {304,0.00011712}, {305,0.00008108}, {306,0.00002703}, {307,0.00006306}, {308,0.00013514}, {309,0.00019820}, {310,0.00012613}, {311,0.00021622}, {312,0.00006306}, {313,0.00009009}, {314,0.00018919}, {315,0.00020721}, {316,0.00018018}, {317,0.00014414}, {318,0.00016216}, {319,0.00006306}, {320,0.00005405}, {321,0.00008108}, {322,0.00012613}, {323,0.00013514}, {324,0.00009910}, {325,0.00018018}, {326,0.00017117}, {327,0.00018018}, {328,0.00011712}, {329,0.00018018}, {330,0.00011712}, {331,0.00006306}, {332,0.00022523}, {333,0.00012613}, {334,0.00012613}, {335,0.00015315}, {336,0.00010811}, {337,0.00030631}, {338,0.00016216}, {339,0.00002703}, {340,0.00014414}, {341,0.00012613}, {342,0.00020721}, {343,0.00014414}, {344,0.00020721}, {345,0.00013514}, {346,0.00008108}, {347,0.00014414}, {348,0.00024324}, {349,0.00010811}, {350,0.00021622}, {351,0.00009009}, {352,0.00010811}, {353,0.00022523}, {354,0.00013514}, {355,0.00009009}, {356,0.00006306}, {357,0.00012613}, {358,0.00008108}, {359,0.00029730}, {360,0.00017117}, {361,0.00024324}, {362,0.00021622}, {363,0.00026126}, {364,0.00022523}, {365,0.00009009}, {366,0.00009009}, {367,0.00010811}, {368,0.00005405}, {369,0.00009009}, {370,0.00018919}, {371,0.00013514}, {372,0.00009910}, {373,0.00026126}, {374,0.00018018}, {375,0.00021622}, {376,0.00018919}, {377,0.00014414}, {378,0.00015315}, {379,0.00015315}, {380,0.00019820}, {381,0.00003604}, {382,0.00018919}, {383,0.00006306}, {384,0.00031532}, {385,0.00010811}, {386,0.00006306}, {387,0.00024324}, {388,0.00008108}, {389,0.00014414}, {390,0.00019820}, {391,0.00011712}, {392,0.00012613}, {393,0.00010811}, {394,0.00018919}, {395,0.00015315}, {396,0.00008108}, {397,0.00015315}, {398,0.00011712}, {399,0.00011712}, {400,0.00009009}, {401,0.00018018}, {402,0.00013514}, {403,0.00032432}, {404,0.00014414}, {405,0.00019820}, {406,0.00013514}, {407,0.00019820}, {408,0.00009009}, {409,0.00018919}, {410,0.00025225}, {411,0.00017117}, {412,0.00025225}, {413,0.00010811}, {414,0.00009009}, {415,0.00015315}, {416,0.00016216}, {417,0.00009009}, {418,0.00012613}, {419,0.00015315}, {420,0.00027928}, {421,0.00009910}, {422,0.00014414}, {423,0.00015315}, {424,0.00018018}, {425,0.00008108}, {426,0.00020721}, {427,0.00009009}, {428,0.00007207}, {429,0.00022523}, {430,0.00018018}, {431,0.00028829}, {432,0.00014414}, {433,0.00021622}, {434,0.00009910}, {435,0.00018018}, {436,0.00006306}, {437,0.00009009}, {438,0.00008108}, {439,0.00013514}, {440,0.00032432}, {441,0.00018018}, {442,0.00028829}, {443,0.00014414}, {444,0.00029730}, {445,0.00035135}, {446,0.00032432}, {447,0.00016216}, {448,0.00005405}, {449,0.00017117}, {450,0.00011712}, {451,0.00014414}, {452,0.00027027}, {453,0.00027928}, {454,0.00022523}, {455,0.00026126}, {456,0.00022523}, {457,0.00016216}, {458,0.00011712}, {459,0.00018919}, {460,0.00029730}, {461,0.00020721}, {462,0.00014414}, {463,0.00024324}, {464,0.00009910}, {465,0.00018919}, {466,0.00025225}, {467,0.00011712}, {468,0.00020721}, {469,0.00032432}, {470,0.00011712}, {471,0.00017117}, {472,0.00026126}, {473,0.00015315}, {474,0.00008108}, {475,0.00023423}, {476,0.00027928}, {477,0.00002703}, {478,0.00013514}, {479,0.00011712}, {480,0.00036036}, {481,0.00019820}, {482,0.00012613}, {483,0.00014414}, {484,0.00032432}, {485,0.00015315}, {486,0.00019820}, {487,0.00018018}, {488,0.00016216}, {489,0.00025225}, {490,0.00042342}, {491,0.00020721}, {492,0.00022523}, {493,0.00011712}, {494,0.00019820}, {495,0.00028829}, {496,0.00021622}, {497,0.00022523}, {498,0.00027027}, {499,0.00025225}, {500,0.00022523}, {505,0.00020721}, {510,0.00011712}, {515,0.00017117}, {520,0.00019820}, {525,0.00035135}, {530,0.00036036}, {535,0.00028829}, {540,0.00021622}, {545,0.00023423}, {550,0.00029730}, {555,0.00025225}, {560,0.00020721}, {565,0.00018919}, {570,0.00013514}, {575,0.00020721}, {580,0.00023423}, {585,0.00021622}, {590,0.00015315}, {595,0.00025225}, {600,0.00014414}, {605,0.00018018}, {610,0.00019820}, {615,0.00016216}, {620,0.00026126}, {625,0.00023423}, {630,0.00029730}, {635,0.00032432}, {640,0.00014414}, {645,0.00018919}, {650,0.00024324}, {655,0.00021622}, {660,0.00006306}, {665,0.00029730}, {670,0.00027027}, {675,0.00015315}, {680,0.00035135}, {685,0.00014414}, {690,0.00017117}, {695,0.00035135}, {700,0.00031532}, {705,0.00016216}, {710,0.00018919}, {715,0.00035135}, {720,0.00034234}, {725,0.00043243}, {730,0.00025225}, {735,0.00041441}, {740,0.00042342}, {745,0.00025225}, {750,0.00015315}, {755,0.00027027}, {760,0.00017117}, {765,0.00011712}, {770,0.00034234}, {775,0.00027027}, {780,0.00020721}, {785,0.00030631}, {790,0.00036036}, {795,0.00030631}, {800,0.00023423}, {805,0.00034234}, {810,0.00022523}, {815,0.00032432}, {820,0.00037838}, {825,0.00033333}, {830,0.00031532}, {835,0.00034234}, {840,0.00033333}, {845,0.00030631}, {850,0.00027027}, {855,0.00027027}, {860,0.00027928}, {865,0.00022523}, {870,0.00029730}, {875,0.00027928}, {880,0.00022523}, {885,0.00019820}, {890,0.00036036}, {895,0.00030631}, {900,0.00053153}, {905,0.00027027}, {910,0.00021622}, {915,0.00030631}, {920,0.00043243}, {925,0.00027027}, {930,0.00028829}, {935,0.00031532}, {940,0.00031532}, {945,0.00036937}, {950,0.00018919}, {955,0.00036036}, {960,0.00034234}, {965,0.00050450}, {970,0.00026126}, {975,0.00054955}, {980,0.00029730}, {985,0.00045045}, {990,0.00045946}, {995,0.00045946}, {1000,0.00036036}, {1010,0.00031532}, {1020,0.00036937}, {1030,0.00033333}, {1040,0.00043243}, {1050,0.00063964}, {1060,0.00033636}, {1070,0.00028182}, {1080,0.00035455}, {1090,0.00037273}, {1100,0.00023636}, {1110,0.00035455}, {1120,0.00050000}, {1130,0.00027273}, {1140,0.00028182}, {1150,0.00049091}, {1160,0.00033636}, {1170,0.00036364}, {1180,0.00049091}, {1190,0.00035455}, {1200,0.00046364}, {1210,0.00042727}, {1220,0.00026364}, {1230,0.00063636}, {1240,0.00038182}, {1250,0.00058182}, {1260,0.00045455}, {1270,0.00035455}, {1280,0.00038182}, {1290,0.00050909}, {1300,0.00034545}, {1310,0.00042727}, {1320,0.00049091}, {1330,0.00049091}, {1340,0.00055455}, {1350,0.00060909}, {1360,0.00059091}, {1370,0.00060000}, {1380,0.00060000}, {1390,0.00043636}, {1400,0.00068182}, {1410,0.00037273}, {1420,0.00033636}, {1430,0.00087273}, {1440,0.00049091}, {1450,0.00029091}, {1460,0.00050000}, {1470,0.00064545}, {1480,0.00062727}, {1490,0.00052727}, {1500,0.00057273}, {1510,0.00073636}, {1520,0.00036364}, {1530,0.00052727}, {1540,0.00062727}, {1550,0.00065455}, {1560,0.00053636}, {1570,0.00065455}, {1580,0.00058182}, {1590,0.00053636}, {1600,0.00044545}, {1610,0.00069091}, {1620,0.00062727}, {1630,0.00060909}, {1640,0.00049091}, {1650,0.00070909}, {1660,0.00055455}, {1670,0.00071818}, {1680,0.00040909}, {1690,0.00081818}, {1700,0.00065455}, {1710,0.00048182}, {1720,0.00070909}, {1730,0.00070909}, {1740,0.00066364}, {1750,0.00076364}, {1760,0.00052727}, {1770,0.00065455}, {1780,0.00076364}, {1790,0.00060909}, {1800,0.00062727}, {1810,0.00076364}, {1820,0.00077273}, {1830,0.00066364}, {1840,0.00055455}, {1850,0.00070000}, {1860,0.00089091}, {1870,0.00074545}, {1880,0.00089091}, {1890,0.00055455}, {1900,0.00064545}, {1910,0.00086364}, {1920,0.00070909}, {1930,0.00090909}, {1940,0.00057273}, {1950,0.00080909}, {1960,0.00501818}, {1970,0.00063636}, {1980,0.00076364}, {1990,0.00039091}, {2000,0.00083636}, {2050,0.00074545}, {2100,0.00050909}, {2150,0.00101818}, {2200,0.00055455}, {2250,0.00083636}, {2300,0.00085455}, {2350,0.00099091}, {2400,0.00081818}, {2450,0.00110000}, {2500,0.00117273}, {2550,0.00088182}, {2600,0.00100909}, {2650,0.00100000}, {2700,0.00098182}, {2750,0.00112727}, {2800,0.00132727}, {2850,0.00106364}, {2900,0.00101818}, {2950,0.00122727}, {3000,0.00108182}, {3050,0.00102727}, {3100,0.00112727}, {3150,0.00122727}, {3200,0.00100000}, {3250,0.00128182}, {3300,0.00160000}, {3350,0.00112727}, {3400,0.00122727}, {3450,0.00130000}, {3500,0.00137273}, {3550,0.00152727}, {3600,0.00150909}, {3650,0.00139091}, {3700,0.00162727}, {3750,0.00161818}, {3800,0.00155455}, {3850,0.00155455}, {3900,0.00116364}, {3950,0.00138182}, {4000,0.00171818}, {4050,0.00137273}, {4100,0.00217273}, {4150,0.00149091}, {4200,0.00979091}, {4250,0.00132727}, {4300,0.00162727}, {4350,0.00183636}, {4400,0.00185455}, {4450,0.00185455}, {4500,0.00189091}, {4550,0.00181818}, {4600,0.00205455}, {4650,0.00195455}, {4700,0.00159091}, {4750,0.00166364}, {4800,0.00188182}, {4850,0.00184545}, {4900,0.00191818}, {4950,0.00216364}, {5000,0.00193636}, {5050,0.00194545}, {5100,0.00231818}, {5150,0.00220909}, {5200,0.00250909}, {5250,0.00226364}, {5300,0.00180909}, {5350,0.00189091}, {5400,0.00190909}, {5450,0.00219091}, {5500,0.00223636}, {5550,0.00210909}, {5600,0.00201818}, {5650,0.00891818}, {5700,0.00280909}, {5750,0.00215455}, {5800,0.00260909}, {5850,0.00242727}, {5900,0.00189091}, {5950,0.00215455}, {6000,0.00227273}, {6050,0.00175}, {6100,0.00250}, {6150,0.00225}, {6200,0.00375}, {6250,0.00275}, {6300,0.00250}, {6350,0.00300}, {6400,0.00675}, {6450,0.00550}, {6500,0.00250}, {6550,0.00100}, {6600,0.00300}, {6650,0.00325}, {6700,0.00375}, {6750,0.00300}, {6800,0.00200}, {6850,0.00400}, {6900,0.00250}, {6950,0.00275}, {7000,0.00350}, {7050,0.00400}, {7100,0.00750}, {7150,0.00300}, {7200,0.00375}, {7250,0.00300}, {7300,0.00375}, {7350,0.00275}, {7400,0.00275}, {7450,0.00300}, {7500,0.00400}, {7550,0.00400}, {7600,0.00350}, {7650,0.00325}, {7700,0.00375}, {7750,0.00400}, {7800,0.00175}, {7850,0.00400}, {7900,0.00375}, {7950,0.00300}, {8000,0.00400}, {8050,0.00275}, {8100,0.00375}, {8150,0.00175}, {8200,0.01025}, {8250,0.00350}, {8300,0.00400}, {8350,0.00875}, {8400,0.00375}, {8450,0.00400}, {8500,0.00400}, {8550,0.00375}, {8600,0.00775}, {8650,0.00250}, {8700,0.00350}, {8750,0.00500}, {8800,0.00375}, {8850,0.00400}, {8900,0.00375}, {8950,0.00400}, {9000,0.00375}, {9050,0.00500}, {9100,0.00375}, {9150,0.00275}, {9200,0.00350}, {9250,0.00375}, {9300,0.00375}, {9350,0.00375}, {9400,0.00350}, {9450,0.00375}, {9500,0.00375}, {9550,0.00500}, {9600,0.01000}, {9650,0.00400}, {9700,0.00375}, {9750,0.00375}, {9800,0.00500}, {9850,0.00400}, {9900,0.00375}, {9950,0.00350}, {10000,0.00500}, {10100,0.00375}, {10200,0.00375}, {10300,0.00475}, {10400,0.00375}, {10500,0.00350}, {10600,0.00475}, {10700,0.00400}, {10800,0.00775}, {10900,0.00575}, {11000,0.00475}, {11100,0.00475}, {11200,0.00550}, {11300,0.01500}, {11400,0.00400}, {11500,0.00500}, {11600,0.00475}, {11700,0.00500}, {11800,0.00375}, {11900,0.01225}, {12000,0.00550}, {12100,0.00325}, {12200,0.00675}, {12300,0.00425}, {12400,0.00450}, {12500,0.00425}, {12600,0.00675}, {12700,0.00475}, {12800,0.00575}, {12900,0.00550}, {13000,0.00475}, {13100,0.00600}, {13200,0.00575}, {13300,0.00700}, {13400,0.00700}, {13500,0.00700}, {13600,0.00575}, {13700,0.00550}, {13800,0.00700}, {13900,0.00550}, {14000,0.00575}, {14100,0.00575}, {14200,0.01575}, {14300,0.00775}, {14400,0.00700}, {14500,0.00675}, {14600,0.00675}, {14700,0.00600}, {14800,0.00775}, {14900,0.00675}, {15000,0.00625}, {15100,0.00575}, {15200,0.00675}, {15300,0.00750}, {15400,0.01700}, {15500,0.00750}, {15600,0.00675}, {15700,0.02075}, {15800,0.02250}, {15900,0.00800}, {16000,0.00625}, {16100,0.00775}, {16200,0.00800}, {16300,0.01450}, {16400,0.01800}, {16500,0.00875}, {16600,0.00775}, {16700,0.00800}, {16800,0.00675}, {16900,0.00850}, {17000,0.02075}, {17100,0.00875}, {17200,0.00875}, {17300,0.00800}, {17400,0.00800}, {17500,0.02100}, {17600,0.00775}, {17700,0.00800}, {17800,0.01950}, {17900,0.01025}, {18000,0.02250}, {18100,0.00875}, {18200,0.00750}, {18300,0.01950}, {18400,0.01025}, {18500,0.00850}, {18600,0.00875}, {18700,0.00875}, {18800,0.00950}, {18900,0.00925}, {19000,0.01075}, {19100,0.01025}, {19200,0.00975}, {19300,0.02450}, {19400,0.00975}, {19500,0.00950}, {19600,0.01775}, {19700,0.00775}, {19800,0.02025}, {19900,0.00800}, {20000,0.0090}};
data["big_flat"]["CanonicalStructuresHOAS"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00003604}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00003604}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00003604}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00003604}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00003604}, {201,0.00003604}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00003604}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00003604}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00003604}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00003604}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00002703}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00002703}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003604}, {469,0.00000000}, {470,0.00000000}, {471,0.00003604}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00003604}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00003604}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00003604}, {510,0.00000000}, {515,0.00003604}, {520,0.00003604}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00003604}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00002703}, {700,0.00000000}, {705,0.00000000}, {710,0.00003604}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00003604}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00003636}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00003636}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00003636}, {1240,0.00003636}, {1250,0.00002727}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003636}, {1290,0.00000000}, {1300,0.00003636}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00003636}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00003636}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00003636}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003636}, {1490,0.00000000}, {1500,0.00003636}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00003636}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00007273}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00003636}, {1690,0.00003636}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00003636}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00003636}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00003636}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00003636}, {2150,0.00003636}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00003636}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00003636}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00003636}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00003636}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00010909}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00003636}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00003636}, {4450,0.00007273}, {4500,0.00007273}, {4550,0.00003636}, {4600,0.00003636}, {4650,0.00003636}, {4700,0.00003636}, {4750,0.00000000}, {4800,0.00003636}, {4850,0.00000000}, {4900,0.00003636}, {4950,0.00010909}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00003636}, {5150,0.00003636}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00003636}, {5350,0.00007273}, {5400,0.00002727}, {5450,0.00003636}, {5500,0.00000000}, {5550,0.00003636}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00003636}, {5950,0.00003636}, {6000,0.00003636}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00100}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresHOAS"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00004505}, {9,0.00068468}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00100000}, {16,0.00100000}, {17,0.00100000}, {18,0.00100901}, {19,0.00107207}, {20,0.00128829}, {21,0.00200000}, {22,0.00200000}, {23,0.00200000}, {24,0.00200000}, {25,0.00200000}, {26,0.00200000}, {27,0.00200000}, {28,0.00200000}, {29,0.00208108}, {30,0.00213514}, {31,0.00218018}, {32,0.00236036}, {33,0.00300000}, {34,0.00300000}, {35,0.00300000}, {36,0.00300000}, {37,0.00300000}, {38,0.00300000}, {39,0.00305405}, {40,0.00303604}, {41,0.00309009}, {42,0.00308108}, {43,0.00333333}, {44,0.00383784}, {45,0.00468468}, {46,0.00400000}, {47,0.00400901}, {48,0.00400000}, {49,0.00400000}, {50,0.00508108}, {51,0.00400901}, {52,0.00405405}, {53,0.00406306}, {54,0.00414414}, {55,0.00481982}, {56,0.00489189}, {57,0.00500000}, {58,0.00500000}, {59,0.00500000}, {60,0.00500901}, {61,0.00504505}, {62,0.00504505}, {63,0.00504505}, {64,0.00505405}, {65,0.00512613}, {66,0.00527928}, {67,0.00583784}, {68,0.00596396}, {69,0.00600000}, {70,0.00600901}, {71,0.00754054}, {72,0.00605405}, {73,0.00606306}, {74,0.00604505}, {75,0.00612613}, {76,0.00610811}, {77,0.00625225}, {78,0.00790991}, {79,0.00699099}, {80,0.00697297}, {81,0.00703604}, {82,0.00701802}, {83,0.00703604}, {84,0.00705405}, {85,0.00703604}, {86,0.00710811}, {87,0.00714414}, {88,0.00711712}, {89,0.00745946}, {90,0.00772072}, {91,0.00799099}, {92,0.00800000}, {93,0.00801802}, {94,0.00805405}, {95,0.00803604}, {96,0.00989189}, {97,0.00806306}, {98,0.00808108}, {99,0.00814414}, {100,0.00822523}, {101,0.00873874}, {102,0.00888288}, {103,0.00900901}, {104,0.01024324}, {105,0.00904505}, {106,0.00905405}, {107,0.00904505}, {108,0.00906306}, {109,0.01027928}, {110,0.00916216}, {111,0.00952252}, {112,0.00934234}, {113,0.00981982}, {114,0.00999099}, {115,0.01003604}, {116,0.01091892}, {117,0.01004505}, {118,0.01003604}, {119,0.01005405}, {120,0.01011712}, {121,0.01010811}, {122,0.01028829}, {123,0.01069369}, {124,0.01076577}, {125,0.01100901}, {126,0.01103604}, {127,0.01201802}, {128,0.01104505}, {129,0.01200901}, {130,0.01106306}, {131,0.01221622}, {132,0.01109910}, {133,0.01221622}, {134,0.01149550}, {135,0.01270270}, {136,0.01171171}, {137,0.01280180}, {138,0.01201802}, {139,0.01302703}, {140,0.01201802}, {141,0.01303604}, {142,0.01216216}, {143,0.01227027}, {144,0.01208108}, {145,0.01227928}, {146,0.01255856}, {147,0.01286486}, {148,0.01283784}, {149,0.01301802}, {150,0.01489189}, {151,0.01308108}, {152,0.01309009}, {153,0.01311712}, {154,0.01318919}, {155,0.01339640}, {156,0.01331532}, {157,0.01527928}, {158,0.01388288}, {159,0.01407207}, {160,0.01372973}, {161,0.01404505}, {162,0.01555856}, {163,0.01405405}, {164,0.01411712}, {165,0.01409910}, {166,0.01413514}, {167,0.01611712}, {168,0.01428829}, {169,0.01465766}, {170,0.01494595}, {171,0.01501802}, {172,0.01501802}, {173,0.01504505}, {174,0.01505405}, {175,0.01519820}, {176,0.01512613}, {177,0.01517117}, {178,0.01702703}, {179,0.01563063}, {180,0.01551351}, {181,0.01730631}, {182,0.01605405}, {183,0.01605405}, {184,0.01602703}, {185,0.01608108}, {186,0.01608108}, {187,0.01624324}, {188,0.01623423}, {189,0.01651351}, {190,0.01659459}, {191,0.01809910}, {192,0.01631532}, {193,0.01672973}, {194,0.01694595}, {195,0.01703604}, {196,0.01705405}, {197,0.01709009}, {198,0.01841441}, {199,0.01729730}, {200,0.01714414}, {201,0.01727928}, {202,0.01878378}, {203,0.01785586}, {204,0.01784685}, {205,0.01799099}, {206,0.01907207}, {207,0.01812613}, {208,0.01805405}, {209,0.01808108}, {210,0.01933333}, {211,0.01832432}, {212,0.01834234}, {213,0.01866667}, {214,0.01880180}, {215,0.01991892}, {216,0.01884685}, {217,0.01901802}, {218,0.01910811}, {219,0.01911712}, {220,0.02018018}, {221,0.01930631}, {222,0.01940541}, {223,0.01979279}, {224,0.01926126}, {225,0.01954054}, {226,0.02091892}, {227,0.01993694}, {228,0.01997297}, {229,0.02007207}, {230,0.02009910}, {231,0.02013514}, {232,0.02015315}, {233,0.02200000}, {234,0.02049550}, {235,0.02072072}, {236,0.02062162}, {237,0.02106306}, {238,0.02106306}, {239,0.02115315}, {240,0.02108108}, {241,0.02286486}, {242,0.02107207}, {243,0.02123423}, {244,0.02122523}, {245,0.02143243}, {246,0.02176577}, {247,0.02200901}, {248,0.02171171}, {249,0.02201802}, {250,0.02207207}, {251,0.02217117}, {252,0.02320721}, {253,0.02399099}, {254,0.02401802}, {255,0.02412613}, {256,0.02212613}, {257,0.02223423}, {258,0.02231532}, {259,0.02272072}, {260,0.02260360}, {261,0.02289189}, {262,0.02302703}, {263,0.02310811}, {264,0.02308108}, {265,0.02311712}, {266,0.02323423}, {267,0.02349550}, {268,0.02341441}, {269,0.02378378}, {270,0.02383784}, {271,0.02409009}, {272,0.02364865}, {273,0.02400000}, {274,0.02406306}, {275,0.02421622}, {276,0.02411712}, {277,0.02438739}, {278,0.02441441}, {279,0.02484685}, {280,0.02443243}, {281,0.02479279}, {282,0.02495495}, {283,0.02514414}, {284,0.02500000}, {285,0.02520721}, {286,0.02525225}, {287,0.02696396}, {288,0.02643243}, {289,0.02674775}, {290,0.02680180}, {291,0.02567568}, {292,0.02560360}, {293,0.02599099}, {294,0.02593694}, {295,0.02620721}, {296,0.02591892}, {297,0.02619820}, {298,0.02627027}, {299,0.02649550}, {300,0.02775676}, {301,0.02812613}, {302,0.02678378}, {303,0.02709009}, {304,0.02663063}, {305,0.02697297}, {306,0.02701802}, {307,0.02718018}, {308,0.02852252}, {309,0.02868468}, {310,0.02753153}, {311,0.02772072}, {312,0.02736937}, {313,0.02779279}, {314,0.03166667}, {315,0.02962162}, {316,0.02802703}, {317,0.02819820}, {318,0.02825225}, {319,0.02866667}, {320,0.02916216}, {321,0.02918919}, {322,0.02819820}, {323,0.02837838}, {324,0.02837838}, {325,0.03175676}, {326,0.02994595}, {327,0.02907207}, {328,0.02881081}, {329,0.02909009}, {330,0.03232432}, {331,0.03038739}, {332,0.02929730}, {333,0.02957658}, {334,0.02971171}, {335,0.03106306}, {336,0.02945045}, {337,0.02974775}, {338,0.02987387}, {339,0.03370270}, {340,0.03009009}, {341,0.03026126}, {342,0.03030631}, {343,0.03194595}, {344,0.03030631}, {345,0.03062162}, {346,0.03400000}, {347,0.03099099}, {348,0.03089189}, {349,0.03125225}, {350,0.03480180}, {351,0.03159459}, {352,0.03090090}, {353,0.03467568}, {354,0.03124324}, {355,0.03145045}, {356,0.03471171}, {357,0.03163063}, {358,0.03179279}, {359,0.03205405}, {360,0.03187387}, {361,0.03201802}, {362,0.03215315}, {363,0.03239640}, {364,0.03227027}, {365,0.03584685}, {366,0.03270270}, {367,0.03300000}, {368,0.03604505}, {369,0.03270270}, {370,0.03281081}, {371,0.03675676}, {372,0.03300000}, {373,0.03320721}, {374,0.03340541}, {375,0.03359459}, {376,0.03695495}, {377,0.03365766}, {378,0.03364865}, {379,0.03417117}, {380,0.03385586}, {381,0.03782883}, {382,0.03428829}, {383,0.03785586}, {384,0.03350450}, {385,0.03374775}, {386,0.03510811}, {387,0.03430631}, {388,0.03737838}, {389,0.03449550}, {390,0.03804505}, {391,0.03481982}, {392,0.03440541}, {393,0.03817117}, {394,0.03484685}, {395,0.03846847}, {396,0.03512613}, {397,0.03856757}, {398,0.03534234}, {399,0.03870270}, {400,0.03516216}, {401,0.03843243}, {402,0.03551351}, {403,0.03592793}, {404,0.03578378}, {405,0.03612613}, {406,0.03618919}, {407,0.03647748}, {408,0.03613514}, {409,0.03641441}, {410,0.03663063}, {411,0.04091892}, {412,0.03670270}, {413,0.04001802}, {414,0.03711712}, {415,0.04056757}, {416,0.03655856}, {417,0.04011712}, {418,0.03694595}, {419,0.04074775}, {420,0.03719820}, {421,0.04104505}, {422,0.03749550}, {423,0.03794595}, {424,0.04177477}, {425,0.03783784}, {426,0.04122523}, {427,0.03821622}, {428,0.04151351}, {429,0.03829730}, {430,0.03858559}, {431,0.04203604}, {432,0.03827027}, {433,0.04217117}, {434,0.03872072}, {435,0.03899099}, {436,0.04204505}, {437,0.03918018}, {438,0.03910811}, {439,0.04255856}, {440,0.03923423}, {441,0.04303604}, {442,0.03971171}, {443,0.03986486}, {444,0.04312613}, {445,0.04016216}, {446,0.04015315}, {447,0.04398198}, {448,0.03939640}, {449,0.03982883}, {450,0.04314414}, {451,0.04017117}, {452,0.04008108}, {453,0.04357658}, {454,0.04044144}, {455,0.04078378}, {456,0.04370270}, {457,0.04062162}, {458,0.04076577}, {459,0.04440541}, {460,0.04092793}, {461,0.04123423}, {462,0.04507207}, {463,0.04478378}, {464,0.04107207}, {465,0.04146847}, {466,0.04490991}, {467,0.04185586}, {468,0.04173874}, {469,0.04581982}, {470,0.04536036}, {471,0.04247748}, {472,0.04190991}, {473,0.04581982}, {474,0.04576577}, {475,0.04277477}, {476,0.04257658}, {477,0.04309910}, {478,0.04651351}, {479,0.04648649}, {480,0.04248649}, {481,0.04282883}, {482,0.04657658}, {483,0.04659459}, {484,0.04312613}, {485,0.04338739}, {486,0.04354955}, {487,0.04753153}, {488,0.04645946}, {489,0.04381982}, {490,0.04381081}, {491,0.04410811}, {492,0.04754054}, {493,0.04773874}, {494,0.04733333}, {495,0.04485586}, {496,0.04410811}, {497,0.04438739}, {498,0.04463964}, {499,0.04851351}, {500,0.04789189}, {505,0.04832432}, {510,0.04631532}, {515,0.04578378}, {520,0.04586486}, {525,0.04709910}, {530,0.04730631}, {535,0.04838739}, {540,0.04832432}, {545,0.04839640}, {550,0.04927027}, {555,0.05011712}, {560,0.04968468}, {565,0.05098198}, {570,0.05132432}, {575,0.05254054}, {580,0.05445045}, {585,0.05550450}, {590,0.05651351}, {595,0.05373874}, {600,0.05381081}, {605,0.05748649}, {610,0.05792793}, {615,0.05590090}, {620,0.05587387}, {625,0.05939640}, {630,0.06080180}, {635,0.05813514}, {640,0.05958559}, {645,0.05792793}, {650,0.05848649}, {655,0.06283784}, {660,0.05928829}, {665,0.06302703}, {670,0.06099099}, {675,0.06394595}, {680,0.06103604}, {685,0.06519820}, {690,0.06237838}, {695,0.06692793}, {700,0.06609009}, {705,0.06335135}, {710,0.06708108}, {715,0.06520721}, {720,0.06820721}, {725,0.06882883}, {730,0.06663964}, {735,0.07141441}, {740,0.07010811}, {745,0.07037838}, {750,0.06893694}, {755,0.06926126}, {760,0.07269369}, {765,0.07377477}, {770,0.07190090}, {775,0.07428829}, {780,0.07467568}, {785,0.07095495}, {790,0.07184685}, {795,0.07280180}, {800,0.07169369}, {805,0.07757658}, {810,0.07702703}, {815,0.07872973}, {820,0.07452252}, {825,0.07563063}, {830,0.07672072}, {835,0.07833333}, {840,0.07793694}, {845,0.07968468}, {850,0.07989189}, {855,0.08194595}, {860,0.08219820}, {865,0.07871171}, {870,0.08314414}, {875,0.08371171}, {880,0.08365766}, {885,0.08736036}, {890,0.08481982}, {895,0.08748649}, {900,0.08363964}, {905,0.08528829}, {910,0.08718919}, {915,0.08631532}, {920,0.08717117}, {925,0.09136036}, {930,0.08767568}, {935,0.08668468}, {940,0.08913514}, {945,0.08684685}, {950,0.09084685}, {955,0.09190991}, {960,0.09009910}, {965,0.09090090}, {970,0.09260360}, {975,0.09329730}, {980,0.09297297}, {985,0.09461261}, {990,0.09493694}, {995,0.09418919}, {1000,0.09183784}, {1010,0.09646847}, {1020,0.09755856}, {1030,0.09717117}, {1040,0.09662162}, {1050,0.09881081}, {1060,0.09974545}, {1070,0.10192727}, {1080,0.10209091}, {1090,0.10225455}, {1100,0.10376364}, {1110,0.10580909}, {1120,0.10290000}, {1130,0.10725455}, {1140,0.10769091}, {1150,0.11062727}, {1160,0.10644545}, {1170,0.10970000}, {1180,0.11179091}, {1190,0.11069091}, {1200,0.11230000}, {1210,0.11696364}, {1220,0.11428182}, {1230,0.11530000}, {1240,0.11754545}, {1250,0.12034545}, {1260,0.12108182}, {1270,0.12230909}, {1280,0.11818182}, {1290,0.12020909}, {1300,0.12294545}, {1310,0.12511818}, {1320,0.12391818}, {1330,0.12532727}, {1340,0.12740909}, {1350,0.12699091}, {1360,0.12760909}, {1370,0.13047273}, {1380,0.13176364}, {1390,0.13378182}, {1400,0.13301818}, {1410,0.13161818}, {1420,0.13894545}, {1430,0.13434545}, {1440,0.14282727}, {1450,0.14281818}, {1460,0.13647273}, {1470,0.14159091}, {1480,0.13910000}, {1490,0.14118182}, {1500,0.14469091}, {1510,0.14213636}, {1520,0.14393636}, {1530,0.14721818}, {1540,0.14352727}, {1550,0.14721818}, {1560,0.14652727}, {1570,0.14730909}, {1580,0.14921818}, {1590,0.15022727}, {1600,0.16536364}, {1610,0.16784545}, {1620,0.15053636}, {1630,0.15414545}, {1640,0.15587273}, {1650,0.15814545}, {1660,0.16009091}, {1670,0.15696364}, {1680,0.15643636}, {1690,0.16212727}, {1700,0.15949091}, {1710,0.16091818}, {1720,0.16560909}, {1730,0.16040909}, {1740,0.16590909}, {1750,0.16486364}, {1760,0.16553636}, {1770,0.16890000}, {1780,0.17017273}, {1790,0.17307273}, {1800,0.16839091}, {1810,0.17001818}, {1820,0.17274545}, {1830,0.17350000}, {1840,0.17330000}, {1850,0.17662727}, {1860,0.17498182}, {1870,0.18300909}, {1880,0.17799091}, {1890,0.17893636}, {1900,0.18110909}, {1910,0.18357273}, {1920,0.17733636}, {1930,0.18891818}, {1940,0.19033636}, {1950,0.18720909}, {1960,0.18486364}, {1970,0.18759091}, {1980,0.18755455}, {1990,0.18971818}, {2000,0.18714545}, {2050,0.19122727}, {2100,0.20049091}, {2150,0.20459091}, {2200,0.20603636}, {2250,0.21440909}, {2300,0.22277273}, {2350,0.22571818}, {2400,0.22668182}, {2450,0.24246364}, {2500,0.23798182}, {2550,0.24677273}, {2600,0.24483636}, {2650,0.25530000}, {2700,0.25637273}, {2750,0.26431818}, {2800,0.26833636}, {2850,0.27490909}, {2900,0.27469091}, {2950,0.27959091}, {3000,0.29563636}, {3050,0.30596364}, {3100,0.29783636}, {3150,0.30019091}, {3200,0.29726364}, {3250,0.31771818}, {3300,0.31683636}, {3350,0.33177273}, {3400,0.32420909}, {3450,0.33442727}, {3500,0.35229091}, {3550,0.34320000}, {3600,0.33591818}, {3650,0.34609091}, {3700,0.35352727}, {3750,0.36041818}, {3800,0.36875455}, {3850,0.36520909}, {3900,0.38029091}, {3950,0.39372727}, {4000,0.37883636}, {4050,0.39375455}, {4100,0.38544545}, {4150,0.40460909}, {4200,0.39809091}, {4250,0.40760909}, {4300,0.41222727}, {4350,0.43139091}, {4400,0.42325455}, {4450,0.42626364}, {4500,0.43075455}, {4550,0.44336364}, {4600,0.45003636}, {4650,0.45234545}, {4700,0.46009091}, {4750,0.46951818}, {4800,0.46000000}, {4850,0.47125455}, {4900,0.47475455}, {4950,0.49193636}, {5000,0.48150000}, {5050,0.49710000}, {5100,0.50229091}, {5150,0.50566364}, {5200,0.49221818}, {5250,0.50067273}, {5300,0.51679091}, {5350,0.52483636}, {5400,0.52536364}, {5450,0.52500909}, {5500,0.53916364}, {5550,0.54699091}, {5600,0.53265455}, {5650,0.53908182}, {5700,0.53782727}, {5750,0.56285455}, {5800,0.54971818}, {5850,0.57683636}, {5900,0.55672727}, {5950,0.57141818}, {6000,0.58256364}, {6050,0.58275}, {6100,0.59550}, {6150,0.58450}, {6200,0.60150}, {6250,0.61500}, {6300,0.61525}, {6350,0.61600}, {6400,0.59650}, {6450,0.62500}, {6500,0.63325}, {6550,0.64350}, {6600,0.63450}, {6650,0.66325}, {6700,0.66000}, {6750,0.67500}, {6800,0.64675}, {6850,0.66950}, {6900,0.67500}, {6950,0.67250}, {7000,0.68600}, {7050,0.68650}, {7100,0.69475}, {7150,0.71925}, {7200,0.69175}, {7250,0.70700}, {7300,0.70100}, {7350,0.71400}, {7400,0.72375}, {7450,0.72725}, {7500,0.72900}, {7550,0.76100}, {7600,0.74050}, {7650,0.74900}, {7700,0.74900}, {7750,0.74975}, {7800,0.76550}, {7850,0.77350}, {7900,0.77950}, {7950,0.77325}, {8000,0.76450}, {8050,0.79425}, {8100,0.79450}, {8150,0.80150}, {8200,0.77350}, {8250,0.79825}, {8300,0.80475}, {8350,0.81600}, {8400,0.80725}, {8450,0.80950}, {8500,0.82150}, {8550,0.82750}, {8600,0.82425}, {8650,0.84525}, {8700,0.86625}, {8750,0.85250}, {8800,0.83850}, {8850,0.85475}, {8900,0.85925}, {8950,0.88550}, {9000,0.86575}, {9050,0.88825}, {9100,0.87875}, {9150,0.91400}, {9200,0.89300}, {9250,0.87900}, {9300,0.90250}, {9350,0.89350}, {9400,0.91450}, {9450,0.92975}, {9500,0.92150}, {9550,0.93275}, {9600,0.91800}, {9650,0.93925}, {9700,0.94425}, {9750,0.94525}, {9800,0.93975}, {9850,0.96775}, {9900,0.96025}, {9950,0.99100}, {10000,0.95925}, {10100,0.98750}, {10200,0.98875}, {10300,1.00375}, {10400,0.98600}, {10500,0.99200}, {10600,1.02250}, {10700,1.05200}, {10800,1.02625}, {10900,1.05725}, {11000,1.08525}, {11100,1.08225}, {11200,1.06975}, {11300,1.08850}, {11400,1.09175}, {11500,1.12575}, {11600,1.10625}, {11700,1.14025}, {11800,1.13425}, {11900,1.17775}, {12000,1.17475}, {12100,1.19150}, {12200,1.19525}, {12300,1.17650}, {12400,1.20050}, {12500,1.21125}, {12600,1.23525}, {12700,1.24025}, {12800,1.22375}, {12900,1.25100}, {13000,1.26475}, {13100,1.28100}, {13200,1.29500}, {13300,1.33000}, {13400,1.29750}, {13500,1.33575}, {13600,1.31200}, {13700,1.32500}, {13800,1.37100}, {13900,1.36350}, {14000,1.35075}, {14100,1.36850}, {14200,1.41225}, {14300,1.45000}, {14400,1.37225}, {14500,1.41225}, {14600,1.42800}, {14700,1.47125}, {14800,1.46600}, {14900,1.46900}, {15000,1.47750}, {15100,1.53000}, {15200,1.49450}, {15300,1.51900}, {15400,1.49350}, {15500,1.51525}, {15600,1.55425}, {15700,1.55625}, {15800,1.59850}, {15900,1.56900}, {16000,1.57125}, {16100,1.62050}, {16200,1.61625}, {16300,1.65275}, {16400,1.56375}, {16500,1.61900}, {16600,1.65950}, {16700,1.69125}, {16800,1.64800}, {16900,1.64250}, {17000,1.67425}, {17100,1.69500}, {17200,1.68475}, {17300,1.71675}, {17400,1.79125}, {17500,1.73125}, {17600,1.69050}, {17700,1.74225}, {17800,1.73350}, {17900,1.81700}, {18000,1.77550}, {18100,1.82150}, {18200,1.83375}, {18300,1.85875}, {18400,1.82725}, {18500,1.79250}, {18600,1.83875}, {18700,1.82375}, {18800,1.85000}, {18900,1.87025}, {19000,1.88100}, {19100,1.92550}, {19200,1.84025}, {19300,1.93825}, {19400,1.93100}, {19500,1.94400}, {19600,1.90375}, {19700,1.99875}, {19800,1.99175}, {19900,2.01475}, {20000,1.9340}};
data["big_flat"]["CanonicalStructuresHOAS"]["norm reif"]["user"] = {{1,0.00036036}, {2,0.00030631}, {3,0.00031532}, {4,0.00032432}, {5,0.00059459}, {6,0.00052252}, {7,0.00063964}, {8,0.00086486}, {9,0.00084685}, {10,0.00091892}, {11,0.00106306}, {12,0.00106306}, {13,0.00100901}, {14,0.00127027}, {15,0.00116216}, {16,0.00154054}, {17,0.00143243}, {18,0.00157658}, {19,0.00145045}, {20,0.00140541}, {21,0.00172973}, {22,0.00183784}, {23,0.00181081}, {24,0.00156757}, {25,0.00204505}, {26,0.00212613}, {27,0.00205405}, {28,0.00212613}, {29,0.00204505}, {30,0.00245045}, {31,0.00233333}, {32,0.00248649}, {33,0.00243243}, {34,0.00267568}, {35,0.00275676}, {36,0.00281081}, {37,0.00319820}, {38,0.00305405}, {39,0.00321622}, {40,0.00303604}, {41,0.00312613}, {42,0.00315315}, {43,0.00336036}, {44,0.00332432}, {45,0.00426126}, {46,0.00383784}, {47,0.00369369}, {48,0.00381982}, {49,0.00381081}, {50,0.00517117}, {51,0.00401802}, {52,0.00409009}, {53,0.00424324}, {54,0.00438739}, {55,0.00430631}, {56,0.00476577}, {57,0.00450450}, {58,0.00454054}, {59,0.00480180}, {60,0.00492793}, {61,0.00472072}, {62,0.00496396}, {63,0.00539640}, {64,0.00508108}, {65,0.00528829}, {66,0.00560360}, {67,0.00532432}, {68,0.00563063}, {69,0.00545045}, {70,0.00600901}, {71,0.00737838}, {72,0.00606306}, {73,0.00605405}, {74,0.00596396}, {75,0.00632432}, {76,0.00674775}, {77,0.00663964}, {78,0.00785586}, {79,0.00676577}, {80,0.00690090}, {81,0.00690991}, {82,0.00706306}, {83,0.00709009}, {84,0.00734234}, {85,0.00724324}, {86,0.00754955}, {87,0.00736036}, {88,0.00754054}, {89,0.00769369}, {90,0.00773874}, {91,0.00784685}, {92,0.00809009}, {93,0.00810811}, {94,0.00799099}, {95,0.00809009}, {96,0.01017117}, {97,0.00836036}, {98,0.00850450}, {99,0.00828829}, {100,0.00865766}, {101,0.00904505}, {102,0.00900000}, {103,0.00871171}, {104,0.01070270}, {105,0.00890090}, {106,0.00965766}, {107,0.00964865}, {108,0.00945946}, {109,0.01079279}, {110,0.00966667}, {111,0.00999099}, {112,0.00987387}, {113,0.01014414}, {114,0.00984685}, {115,0.01004505}, {116,0.01131532}, {117,0.01051351}, {118,0.01038739}, {119,0.01070270}, {120,0.01066667}, {121,0.01073874}, {122,0.01072072}, {123,0.01086486}, {124,0.01088288}, {125,0.01100000}, {126,0.01160360}, {127,0.01222523}, {128,0.01134234}, {129,0.01245946}, {130,0.01135135}, {131,0.01262162}, {132,0.01166667}, {133,0.01255856}, {134,0.01208108}, {135,0.01322523}, {136,0.01206306}, {137,0.01276577}, {138,0.01224324}, {139,0.01309910}, {140,0.01229730}, {141,0.01318919}, {142,0.01252252}, {143,0.01272973}, {144,0.01266667}, {145,0.01290090}, {146,0.01290090}, {147,0.01276577}, {148,0.01298198}, {149,0.01306306}, {150,0.01467568}, {151,0.01343243}, {152,0.01304505}, {153,0.01356757}, {154,0.01358559}, {155,0.01374775}, {156,0.01362162}, {157,0.01521622}, {158,0.01379279}, {159,0.01390991}, {160,0.01385586}, {161,0.01406306}, {162,0.01542342}, {163,0.01423423}, {164,0.01422523}, {165,0.01397297}, {166,0.01432432}, {167,0.01580180}, {168,0.01444144}, {169,0.01483784}, {170,0.01487387}, {171,0.01469369}, {172,0.01481982}, {173,0.01500000}, {174,0.01497297}, {175,0.01518018}, {176,0.01494595}, {177,0.01513514}, {178,0.01681982}, {179,0.01553153}, {180,0.01563964}, {181,0.01764865}, {182,0.01567568}, {183,0.01573874}, {184,0.01580180}, {185,0.01575676}, {186,0.01608108}, {187,0.01630631}, {188,0.01643243}, {189,0.01631532}, {190,0.01629730}, {191,0.01829730}, {192,0.01622523}, {193,0.01650450}, {194,0.01663964}, {195,0.01657658}, {196,0.01750450}, {197,0.01694595}, {198,0.01850450}, {199,0.01755856}, {200,0.01725225}, {201,0.01719820}, {202,0.01859459}, {203,0.01781982}, {204,0.01772973}, {205,0.01800901}, {206,0.01923423}, {207,0.01811712}, {208,0.01800901}, {209,0.01762162}, {210,0.01963063}, {211,0.01871171}, {212,0.01823423}, {213,0.01877477}, {214,0.01875676}, {215,0.01993694}, {216,0.01898198}, {217,0.01901802}, {218,0.01913514}, {219,0.01934234}, {220,0.02060360}, {221,0.01964865}, {222,0.01957658}, {223,0.01979279}, {224,0.01934234}, {225,0.01960360}, {226,0.02073874}, {227,0.02008108}, {228,0.01981081}, {229,0.02029730}, {230,0.02006306}, {231,0.02043243}, {232,0.02053153}, {233,0.02236036}, {234,0.02081982}, {235,0.02065766}, {236,0.02062162}, {237,0.02118018}, {238,0.02102703}, {239,0.02152252}, {240,0.02145946}, {241,0.02325225}, {242,0.02125225}, {243,0.02167568}, {244,0.02184685}, {245,0.02171171}, {246,0.02197297}, {247,0.02221622}, {248,0.02197297}, {249,0.02210811}, {250,0.02231532}, {251,0.02236937}, {252,0.02346847}, {253,0.02429730}, {254,0.02415315}, {255,0.02425225}, {256,0.02265766}, {257,0.02295495}, {258,0.02281081}, {259,0.02311712}, {260,0.02306306}, {261,0.02320721}, {262,0.02321622}, {263,0.02345946}, {264,0.02337838}, {265,0.02380180}, {266,0.02373874}, {267,0.02376577}, {268,0.02403604}, {269,0.02418018}, {270,0.02411712}, {271,0.02437838}, {272,0.02397297}, {273,0.02438739}, {274,0.02432432}, {275,0.02468468}, {276,0.02430631}, {277,0.02459459}, {278,0.02490090}, {279,0.02481982}, {280,0.02490090}, {281,0.02488288}, {282,0.02496396}, {283,0.02540541}, {284,0.02505405}, {285,0.02542342}, {286,0.02553153}, {287,0.02689189}, {288,0.02627928}, {289,0.02668468}, {290,0.02667568}, {291,0.02610811}, {292,0.02564865}, {293,0.02602703}, {294,0.02578378}, {295,0.02648649}, {296,0.02596396}, {297,0.02621622}, {298,0.02638739}, {299,0.02634234}, {300,0.02753153}, {301,0.02786486}, {302,0.02660360}, {303,0.02701802}, {304,0.02644144}, {305,0.02685586}, {306,0.02664865}, {307,0.02711712}, {308,0.02829730}, {309,0.02847748}, {310,0.02737838}, {311,0.02753153}, {312,0.02729730}, {313,0.02760360}, {314,0.03181081}, {315,0.02935135}, {316,0.02760360}, {317,0.02795495}, {318,0.02857658}, {319,0.02893694}, {320,0.02918919}, {321,0.02911712}, {322,0.02819820}, {323,0.02823423}, {324,0.02847748}, {325,0.03172072}, {326,0.02991892}, {327,0.02899099}, {328,0.02880180}, {329,0.02904505}, {330,0.03243243}, {331,0.03038739}, {332,0.02924324}, {333,0.02923423}, {334,0.02990991}, {335,0.03097297}, {336,0.02952252}, {337,0.02954955}, {338,0.02985586}, {339,0.03388288}, {340,0.02993694}, {341,0.03014414}, {342,0.03083784}, {343,0.03193694}, {344,0.03016216}, {345,0.03069369}, {346,0.03415315}, {347,0.03103604}, {348,0.03105405}, {349,0.03128829}, {350,0.03498198}, {351,0.03172072}, {352,0.03100901}, {353,0.03479279}, {354,0.03149550}, {355,0.03156757}, {356,0.03527027}, {357,0.03177477}, {358,0.03185586}, {359,0.03216216}, {360,0.03181982}, {361,0.03225225}, {362,0.03227928}, {363,0.03254955}, {364,0.03228829}, {365,0.03591892}, {366,0.03290991}, {367,0.03318919}, {368,0.03647748}, {369,0.03282883}, {370,0.03305405}, {371,0.03709910}, {372,0.03317117}, {373,0.03336937}, {374,0.03373874}, {375,0.03400000}, {376,0.03727928}, {377,0.03358559}, {378,0.03359459}, {379,0.03453153}, {380,0.03412613}, {381,0.03772973}, {382,0.03409910}, {383,0.03815315}, {384,0.03372973}, {385,0.03434234}, {386,0.03545045}, {387,0.03471171}, {388,0.03757658}, {389,0.03491892}, {390,0.03775676}, {391,0.03531532}, {392,0.03464865}, {393,0.03804505}, {394,0.03502703}, {395,0.03836036}, {396,0.03545946}, {397,0.03855856}, {398,0.03574775}, {399,0.03849550}, {400,0.03540541}, {401,0.03831532}, {402,0.03598198}, {403,0.03618018}, {404,0.03611712}, {405,0.03654955}, {406,0.03674775}, {407,0.03678378}, {408,0.03651351}, {409,0.03677477}, {410,0.03680180}, {411,0.04088288}, {412,0.03684685}, {413,0.04022523}, {414,0.03729730}, {415,0.04032432}, {416,0.03681081}, {417,0.03983784}, {418,0.03695495}, {419,0.04069369}, {420,0.03719820}, {421,0.04113514}, {422,0.03753153}, {423,0.03776577}, {424,0.04201802}, {425,0.03789189}, {426,0.04109910}, {427,0.03791892}, {428,0.04163063}, {429,0.03800000}, {430,0.03809009}, {431,0.04193694}, {432,0.03843243}, {433,0.04228829}, {434,0.03882883}, {435,0.03890991}, {436,0.04189189}, {437,0.03908108}, {438,0.03877477}, {439,0.04213514}, {440,0.03895495}, {441,0.04300000}, {442,0.03935135}, {443,0.03972072}, {444,0.04287387}, {445,0.03961261}, {446,0.03990991}, {447,0.04395495}, {448,0.03900901}, {449,0.03958559}, {450,0.04314414}, {451,0.04000901}, {452,0.03990090}, {453,0.04355856}, {454,0.04015315}, {455,0.04063063}, {456,0.04368468}, {457,0.04020721}, {458,0.04060360}, {459,0.04448649}, {460,0.04081081}, {461,0.04087387}, {462,0.04485586}, {463,0.04496396}, {464,0.04096396}, {465,0.04155856}, {466,0.04527928}, {467,0.04189189}, {468,0.04175676}, {469,0.04513514}, {470,0.04565766}, {471,0.04238739}, {472,0.04163964}, {473,0.04586486}, {474,0.04611712}, {475,0.04276577}, {476,0.04275676}, {477,0.04348649}, {478,0.04676577}, {479,0.04688288}, {480,0.04228829}, {481,0.04289189}, {482,0.04712613}, {483,0.04665766}, {484,0.04287387}, {485,0.04353153}, {486,0.04367568}, {487,0.04768468}, {488,0.04697297}, {489,0.04396396}, {490,0.04372973}, {491,0.04418919}, {492,0.04758559}, {493,0.04805405}, {494,0.04739640}, {495,0.04508108}, {496,0.04408108}, {497,0.04474775}, {498,0.04487387}, {499,0.04863063}, {500,0.04842342}, {505,0.04867568}, {510,0.04636036}, {515,0.04570270}, {520,0.04621622}, {525,0.04718018}, {530,0.04756757}, {535,0.04849550}, {540,0.04864865}, {545,0.04867568}, {550,0.04914414}, {555,0.05017117}, {560,0.04988288}, {565,0.05074775}, {570,0.05111712}, {575,0.05305405}, {580,0.05401802}, {585,0.05521622}, {590,0.05663063}, {595,0.05364865}, {600,0.05396396}, {605,0.05759459}, {610,0.05839640}, {615,0.05595495}, {620,0.05577477}, {625,0.05973874}, {630,0.06102703}, {635,0.05816216}, {640,0.06000000}, {645,0.05817117}, {650,0.05851351}, {655,0.06279279}, {660,0.05972072}, {665,0.06260360}, {670,0.06110811}, {675,0.06373874}, {680,0.06130631}, {685,0.06541441}, {690,0.06246847}, {695,0.06682883}, {700,0.06578378}, {705,0.06301802}, {710,0.06708108}, {715,0.06484685}, {720,0.06845946}, {725,0.06865766}, {730,0.06668468}, {735,0.07151351}, {740,0.07044144}, {745,0.07059459}, {750,0.06908108}, {755,0.06944144}, {760,0.07279279}, {765,0.07373874}, {770,0.07234234}, {775,0.07407207}, {780,0.07436937}, {785,0.07109009}, {790,0.07192793}, {795,0.07274775}, {800,0.07184685}, {805,0.07767568}, {810,0.07682883}, {815,0.07869369}, {820,0.07435135}, {825,0.07546847}, {830,0.07638739}, {835,0.07818919}, {840,0.07751351}, {845,0.07954054}, {850,0.07980180}, {855,0.08216216}, {860,0.08240541}, {865,0.07877477}, {870,0.08376577}, {875,0.08361261}, {880,0.08401802}, {885,0.08685586}, {890,0.08469369}, {895,0.08727027}, {900,0.08390090}, {905,0.08514414}, {910,0.08707207}, {915,0.08613514}, {920,0.08669369}, {925,0.09126126}, {930,0.08744144}, {935,0.08663964}, {940,0.08900000}, {945,0.08647748}, {950,0.09090090}, {955,0.09172072}, {960,0.08951351}, {965,0.09090090}, {970,0.09224324}, {975,0.09287387}, {980,0.09308108}, {985,0.09485586}, {990,0.09494595}, {995,0.09418919}, {1000,0.09198198}, {1010,0.09629730}, {1020,0.09747748}, {1030,0.09711712}, {1040,0.09670270}, {1050,0.09825225}, {1060,0.09938182}, {1070,0.10187273}, {1080,0.10172727}, {1090,0.10203636}, {1100,0.10372727}, {1110,0.10606364}, {1120,0.10284545}, {1130,0.10720909}, {1140,0.10796364}, {1150,0.11019091}, {1160,0.10653636}, {1170,0.10976364}, {1180,0.11160000}, {1190,0.11079091}, {1200,0.11171818}, {1210,0.11668182}, {1220,0.11429091}, {1230,0.11491818}, {1240,0.11758182}, {1250,0.12019091}, {1260,0.12060000}, {1270,0.12253636}, {1280,0.11843636}, {1290,0.12001818}, {1300,0.12301818}, {1310,0.12496364}, {1320,0.12370909}, {1330,0.12521818}, {1340,0.12720909}, {1350,0.12650909}, {1360,0.12718182}, {1370,0.13035455}, {1380,0.13200000}, {1390,0.13427273}, {1400,0.13283636}, {1410,0.13180000}, {1420,0.13843636}, {1430,0.13419091}, {1440,0.14290000}, {1450,0.14283636}, {1460,0.13670000}, {1470,0.14140000}, {1480,0.13909091}, {1490,0.14109091}, {1500,0.14504545}, {1510,0.14181818}, {1520,0.14421818}, {1530,0.14727273}, {1540,0.14370909}, {1550,0.14714545}, {1560,0.14658182}, {1570,0.14755455}, {1580,0.14913636}, {1590,0.14991818}, {1600,0.16526364}, {1610,0.16754545}, {1620,0.15059091}, {1630,0.15414545}, {1640,0.15626364}, {1650,0.15801818}, {1660,0.15991818}, {1670,0.15700000}, {1680,0.15672727}, {1690,0.16190000}, {1700,0.15937273}, {1710,0.16089091}, {1720,0.16545455}, {1730,0.16040000}, {1740,0.16605455}, {1750,0.16491818}, {1760,0.16547273}, {1770,0.16894545}, {1780,0.17028182}, {1790,0.17303636}, {1800,0.16880909}, {1810,0.17012727}, {1820,0.17229091}, {1830,0.17324545}, {1840,0.17313636}, {1850,0.17663636}, {1860,0.17449091}, {1870,0.18269091}, {1880,0.17781818}, {1890,0.17900000}, {1900,0.18125455}, {1910,0.18354545}, {1920,0.17713636}, {1930,0.18840000}, {1940,0.19051818}, {1950,0.18702727}, {1960,0.18516364}, {1970,0.18727273}, {1980,0.18738182}, {1990,0.18971818}, {2000,0.18697273}, {2050,0.19120909}, {2100,0.20023636}, {2150,0.20475455}, {2200,0.20606364}, {2250,0.21439091}, {2300,0.22270909}, {2350,0.22598182}, {2400,0.22687273}, {2450,0.24230909}, {2500,0.23767273}, {2550,0.24666364}, {2600,0.24465455}, {2650,0.25510909}, {2700,0.25606364}, {2750,0.26430000}, {2800,0.26815455}, {2850,0.27500000}, {2900,0.27460909}, {2950,0.27963636}, {3000,0.29546364}, {3050,0.30561818}, {3100,0.29789091}, {3150,0.29960000}, {3200,0.29734545}, {3250,0.31722727}, {3300,0.31634545}, {3350,0.33166364}, {3400,0.32417273}, {3450,0.33466364}, {3500,0.35203636}, {3550,0.34302727}, {3600,0.33570909}, {3650,0.34610909}, {3700,0.35373636}, {3750,0.36003636}, {3800,0.36823636}, {3850,0.36499091}, {3900,0.37986364}, {3950,0.39382727}, {4000,0.37843636}, {4050,0.39348182}, {4100,0.38552727}, {4150,0.40387273}, {4200,0.39750909}, {4250,0.40757273}, {4300,0.41190909}, {4350,0.43132727}, {4400,0.42303636}, {4450,0.42590909}, {4500,0.43073636}, {4550,0.44285455}, {4600,0.44979091}, {4650,0.45213636}, {4700,0.45945455}, {4750,0.46837273}, {4800,0.45950000}, {4850,0.47057273}, {4900,0.47397273}, {4950,0.49169091}, {5000,0.48089091}, {5050,0.49675455}, {5100,0.50188182}, {5150,0.50584545}, {5200,0.49204545}, {5250,0.50061818}, {5300,0.51706364}, {5350,0.52480909}, {5400,0.52518182}, {5450,0.52492727}, {5500,0.53918182}, {5550,0.54670000}, {5600,0.53264545}, {5650,0.53917273}, {5700,0.53811818}, {5750,0.56283636}, {5800,0.54973636}, {5850,0.57693636}, {5900,0.55690909}, {5950,0.57106364}, {6000,0.58274545}, {6050,0.58175}, {6100,0.59375}, {6150,0.58475}, {6200,0.60150}, {6250,0.61700}, {6300,0.61475}, {6350,0.61525}, {6400,0.59475}, {6450,0.62475}, {6500,0.63250}, {6550,0.64225}, {6600,0.63325}, {6650,0.66300}, {6700,0.66050}, {6750,0.67475}, {6800,0.64750}, {6850,0.66725}, {6900,0.67575}, {6950,0.67300}, {7000,0.68575}, {7050,0.68725}, {7100,0.69350}, {7150,0.72000}, {7200,0.69125}, {7250,0.70425}, {7300,0.70150}, {7350,0.71350}, {7400,0.72225}, {7450,0.72500}, {7500,0.72725}, {7550,0.76175}, {7600,0.73975}, {7650,0.74675}, {7700,0.75000}, {7750,0.74950}, {7800,0.76475}, {7850,0.77375}, {7900,0.77925}, {7950,0.77375}, {8000,0.76475}, {8050,0.79350}, {8100,0.79575}, {8150,0.80125}, {8200,0.77250}, {8250,0.79850}, {8300,0.80550}, {8350,0.81525}, {8400,0.80550}, {8450,0.81000}, {8500,0.82150}, {8550,0.82825}, {8600,0.82450}, {8650,0.84400}, {8700,0.86500}, {8750,0.85100}, {8800,0.83950}, {8850,0.85475}, {8900,0.86025}, {8950,0.88525}, {9000,0.86575}, {9050,0.88825}, {9100,0.87850}, {9150,0.91425}, {9200,0.89125}, {9250,0.87675}, {9300,0.90275}, {9350,0.89275}, {9400,0.91475}, {9450,0.92950}, {9500,0.91925}, {9550,0.93350}, {9600,0.91950}, {9650,0.93950}, {9700,0.94500}, {9750,0.94625}, {9800,0.94025}, {9850,0.96625}, {9900,0.96050}, {9950,0.98975}, {10000,0.95900}, {10100,0.98700}, {10200,0.98775}, {10300,1.00550}, {10400,0.98400}, {10500,0.99275}, {10600,1.02250}, {10700,1.05300}, {10800,1.02625}, {10900,1.05725}, {11000,1.08475}, {11100,1.08275}, {11200,1.06950}, {11300,1.08725}, {11400,1.09125}, {11500,1.12650}, {11600,1.10650}, {11700,1.14175}, {11800,1.13450}, {11900,1.17725}, {12000,1.17625}, {12100,1.19375}, {12200,1.19475}, {12300,1.17775}, {12400,1.19850}, {12500,1.21100}, {12600,1.23450}, {12700,1.24050}, {12800,1.22525}, {12900,1.25125}, {13000,1.26600}, {13100,1.27975}, {13200,1.29425}, {13300,1.32975}, {13400,1.29675}, {13500,1.33575}, {13600,1.31025}, {13700,1.32550}, {13800,1.37050}, {13900,1.36475}, {14000,1.35075}, {14100,1.36875}, {14200,1.41075}, {14300,1.44875}, {14400,1.37150}, {14500,1.41175}, {14600,1.42775}, {14700,1.47250}, {14800,1.46450}, {14900,1.47000}, {15000,1.47875}, {15100,1.52950}, {15200,1.49375}, {15300,1.51850}, {15400,1.49450}, {15500,1.51525}, {15600,1.55275}, {15700,1.55675}, {15800,1.59775}, {15900,1.56725}, {16000,1.57150}, {16100,1.62125}, {16200,1.61750}, {16300,1.65375}, {16400,1.56350}, {16500,1.61850}, {16600,1.65850}, {16700,1.69150}, {16800,1.64875}, {16900,1.64250}, {17000,1.67250}, {17100,1.69475}, {17200,1.68575}, {17300,1.71675}, {17400,1.79025}, {17500,1.73125}, {17600,1.68875}, {17700,1.74175}, {17800,1.73375}, {17900,1.81800}, {18000,1.77475}, {18100,1.82050}, {18200,1.83350}, {18300,1.85825}, {18400,1.82800}, {18500,1.79225}, {18600,1.83850}, {18700,1.82400}, {18800,1.84950}, {18900,1.87075}, {19000,1.88100}, {19100,1.92600}, {19200,1.84050}, {19300,1.93950}, {19400,1.93100}, {19500,1.94150}, {19600,1.90275}, {19700,1.99750}, {19800,1.99275}, {19900,2.01500}, {20000,1.9320}};
data["big_flat"]["CanonicalStructuresHOAS"]["norm reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00007207}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00010811}, {14,0.00003604}, {15,0.00000000}, {16,0.00003604}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00007207}, {21,0.00007207}, {22,0.00003604}, {23,0.00003604}, {24,0.00003604}, {25,0.00000000}, {26,0.00007207}, {27,0.00003604}, {28,0.00003604}, {29,0.00010811}, {30,0.00003604}, {31,0.00003604}, {32,0.00000000}, {33,0.00007207}, {34,0.00000000}, {35,0.00003604}, {36,0.00007207}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00007207}, {41,0.00006306}, {42,0.00007207}, {43,0.00000000}, {44,0.00002703}, {45,0.00003604}, {46,0.00003604}, {47,0.00000000}, {48,0.00003604}, {49,0.00003604}, {50,0.00003604}, {51,0.00003604}, {52,0.00000000}, {53,0.00003604}, {54,0.00003604}, {55,0.00003604}, {56,0.00000000}, {57,0.00000000}, {58,0.00003604}, {59,0.00003604}, {60,0.00005405}, {61,0.00010811}, {62,0.00003604}, {63,0.00007207}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00009910}, {68,0.00000000}, {69,0.00003604}, {70,0.00003604}, {71,0.00007207}, {72,0.00000000}, {73,0.00003604}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00003604}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00003604}, {85,0.00000000}, {86,0.00003604}, {87,0.00007207}, {88,0.00007207}, {89,0.00003604}, {90,0.00003604}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00003604}, {95,0.00007207}, {96,0.00007207}, {97,0.00000000}, {98,0.00000000}, {99,0.00003604}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003604}, {105,0.00000000}, {106,0.00003604}, {107,0.00000000}, {108,0.00003604}, {109,0.00003604}, {110,0.00000000}, {111,0.00003604}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00007207}, {116,0.00003604}, {117,0.00000000}, {118,0.00003604}, {119,0.00000000}, {120,0.00003604}, {121,0.00000000}, {122,0.00000000}, {123,0.00003604}, {124,0.00000000}, {125,0.00007207}, {126,0.00000000}, {127,0.00003604}, {128,0.00002703}, {129,0.00000000}, {130,0.00007207}, {131,0.00000000}, {132,0.00000000}, {133,0.00007207}, {134,0.00000000}, {135,0.00003604}, {136,0.00003604}, {137,0.00003604}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00007207}, {142,0.00000000}, {143,0.00000000}, {144,0.00010811}, {145,0.00000000}, {146,0.00003604}, {147,0.00000000}, {148,0.00000000}, {149,0.00007207}, {150,0.00007207}, {151,0.00000000}, {152,0.00000000}, {153,0.00007207}, {154,0.00000000}, {155,0.00000000}, {156,0.00003604}, {157,0.00018018}, {158,0.00000000}, {159,0.00000000}, {160,0.00003604}, {161,0.00000000}, {162,0.00006306}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00003604}, {168,0.00003604}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00003604}, {174,0.00003604}, {175,0.00003604}, {176,0.00003604}, {177,0.00000000}, {178,0.00003604}, {179,0.00003604}, {180,0.00000000}, {181,0.00000000}, {182,0.00003604}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00007207}, {190,0.00000000}, {191,0.00003604}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00003604}, {196,0.00000000}, {197,0.00003604}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00009910}, {202,0.00000000}, {203,0.00007207}, {204,0.00006306}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00003604}, {213,0.00000000}, {214,0.00003604}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00007207}, {222,0.00003604}, {223,0.00007207}, {224,0.00007207}, {225,0.00000000}, {226,0.00007207}, {227,0.00000000}, {228,0.00000000}, {229,0.00009910}, {230,0.00000000}, {231,0.00003604}, {232,0.00002703}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00003604}, {238,0.00007207}, {239,0.00007207}, {240,0.00007207}, {241,0.00003604}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00007207}, {246,0.00010811}, {247,0.00003604}, {248,0.00003604}, {249,0.00003604}, {250,0.00000000}, {251,0.00003604}, {252,0.00003604}, {253,0.00000000}, {254,0.00007207}, {255,0.00003604}, {256,0.00000000}, {257,0.00000000}, {258,0.00003604}, {259,0.00000000}, {260,0.00003604}, {261,0.00000000}, {262,0.00003604}, {263,0.00003604}, {264,0.00003604}, {265,0.00000000}, {266,0.00002703}, {267,0.00007207}, {268,0.00000000}, {269,0.00000000}, {270,0.00003604}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00007207}, {275,0.00007207}, {276,0.00003604}, {277,0.00003604}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003604}, {282,0.00000000}, {283,0.00002703}, {284,0.00003604}, {285,0.00000000}, {286,0.00000000}, {287,0.00003604}, {288,0.00000000}, {289,0.00000000}, {290,0.00003604}, {291,0.00000000}, {292,0.00000000}, {293,0.00007207}, {294,0.00003604}, {295,0.00000000}, {296,0.00003604}, {297,0.00000000}, {298,0.00007207}, {299,0.00014414}, {300,0.00000000}, {301,0.00000000}, {302,0.00007207}, {303,0.00000000}, {304,0.00009910}, {305,0.00003604}, {306,0.00003604}, {307,0.00000000}, {308,0.00000000}, {309,0.00003604}, {310,0.00000000}, {311,0.00000000}, {312,0.00003604}, {313,0.00000000}, {314,0.00000000}, {315,0.00007207}, {316,0.00000000}, {317,0.00010811}, {318,0.00000000}, {319,0.00000000}, {320,0.00003604}, {321,0.00000000}, {322,0.00003604}, {323,0.00007207}, {324,0.00007207}, {325,0.00003604}, {326,0.00000000}, {327,0.00003604}, {328,0.00000000}, {329,0.00003604}, {330,0.00000000}, {331,0.00006306}, {332,0.00000000}, {333,0.00003604}, {334,0.00003604}, {335,0.00007207}, {336,0.00000000}, {337,0.00007207}, {338,0.00000000}, {339,0.00000000}, {340,0.00003604}, {341,0.00000000}, {342,0.00003604}, {343,0.00000000}, {344,0.00003604}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00003604}, {350,0.00000000}, {351,0.00000000}, {352,0.00010811}, {353,0.00000000}, {354,0.00000000}, {355,0.00003604}, {356,0.00000000}, {357,0.00000000}, {358,0.00003604}, {359,0.00003604}, {360,0.00007207}, {361,0.00003604}, {362,0.00000000}, {363,0.00002703}, {364,0.00000000}, {365,0.00007207}, {366,0.00000000}, {367,0.00003604}, {368,0.00000000}, {369,0.00007207}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00003604}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00003604}, {380,0.00000000}, {381,0.00010811}, {382,0.00007207}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00003604}, {388,0.00003604}, {389,0.00000000}, {390,0.00010811}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00007207}, {395,0.00003604}, {396,0.00000000}, {397,0.00006306}, {398,0.00003604}, {399,0.00003604}, {400,0.00000000}, {401,0.00003604}, {402,0.00000000}, {403,0.00000000}, {404,0.00003604}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00003604}, {409,0.00000000}, {410,0.00002703}, {411,0.00007207}, {412,0.00007207}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00003604}, {418,0.00003604}, {419,0.00003604}, {420,0.00000000}, {421,0.00007207}, {422,0.00007207}, {423,0.00003604}, {424,0.00000000}, {425,0.00003604}, {426,0.00003604}, {427,0.00002703}, {428,0.00003604}, {429,0.00000000}, {430,0.00010811}, {431,0.00007207}, {432,0.00000000}, {433,0.00007207}, {434,0.00003604}, {435,0.00003604}, {436,0.00007207}, {437,0.00002703}, {438,0.00003604}, {439,0.00007207}, {440,0.00007207}, {441,0.00007207}, {442,0.00003604}, {443,0.00003604}, {444,0.00003604}, {445,0.00000000}, {446,0.00003604}, {447,0.00006306}, {448,0.00000000}, {449,0.00000000}, {450,0.00013514}, {451,0.00007207}, {452,0.00000000}, {453,0.00003604}, {454,0.00003604}, {455,0.00003604}, {456,0.00003604}, {457,0.00009910}, {458,0.00000000}, {459,0.00003604}, {460,0.00000000}, {461,0.00000000}, {462,0.00003604}, {463,0.00003604}, {464,0.00000000}, {465,0.00003604}, {466,0.00010811}, {467,0.00007207}, {468,0.00003604}, {469,0.00014414}, {470,0.00010811}, {471,0.00003604}, {472,0.00000000}, {473,0.00006306}, {474,0.00010811}, {475,0.00000000}, {476,0.00003604}, {477,0.00000000}, {478,0.00020721}, {479,0.00006306}, {480,0.00003604}, {481,0.00010811}, {482,0.00000000}, {483,0.00020721}, {484,0.00016216}, {485,0.00003604}, {486,0.00003604}, {487,0.00007207}, {488,0.00000000}, {489,0.00000000}, {490,0.00003604}, {491,0.00010811}, {492,0.00007207}, {493,0.00014414}, {494,0.00017117}, {495,0.00003604}, {496,0.00000000}, {497,0.00003604}, {498,0.00000000}, {499,0.00005405}, {500,0.00003604}, {505,0.00014414}, {510,0.00000000}, {515,0.00007207}, {520,0.00003604}, {525,0.00003604}, {530,0.00007207}, {535,0.00003604}, {540,0.00000000}, {545,0.00003604}, {550,0.00000000}, {555,0.00000000}, {560,0.00003604}, {565,0.00007207}, {570,0.00000000}, {575,0.00003604}, {580,0.00018018}, {585,0.00018018}, {590,0.00014414}, {595,0.00007207}, {600,0.00003604}, {605,0.00010811}, {610,0.00014414}, {615,0.00003604}, {620,0.00000000}, {625,0.00010811}, {630,0.00003604}, {635,0.00000000}, {640,0.00007207}, {645,0.00000000}, {650,0.00003604}, {655,0.00007207}, {660,0.00007207}, {665,0.00010811}, {670,0.00000000}, {675,0.00007207}, {680,0.00000000}, {685,0.00003604}, {690,0.00007207}, {695,0.00007207}, {700,0.00007207}, {705,0.00000000}, {710,0.00000000}, {715,0.00003604}, {720,0.00014414}, {725,0.00014414}, {730,0.00000000}, {735,0.00007207}, {740,0.00007207}, {745,0.00000000}, {750,0.00000000}, {755,0.00003604}, {760,0.00000000}, {765,0.00000000}, {770,0.00003604}, {775,0.00003604}, {780,0.00010811}, {785,0.00000000}, {790,0.00007207}, {795,0.00003604}, {800,0.00000000}, {805,0.00003604}, {810,0.00014414}, {815,0.00014414}, {820,0.00000000}, {825,0.00000000}, {830,0.00007207}, {835,0.00006306}, {840,0.00007207}, {845,0.00010811}, {850,0.00007207}, {855,0.00003604}, {860,0.00003604}, {865,0.00000000}, {870,0.00007207}, {875,0.00014414}, {880,0.00003604}, {885,0.00025225}, {890,0.00010811}, {895,0.00007207}, {900,0.00000000}, {905,0.00037838}, {910,0.00003604}, {915,0.00000000}, {920,0.00017117}, {925,0.00010811}, {930,0.00007207}, {935,0.00003604}, {940,0.00010811}, {945,0.00007207}, {950,0.00007207}, {955,0.00010811}, {960,0.00007207}, {965,0.00000000}, {970,0.00003604}, {975,0.00009910}, {980,0.00010811}, {985,0.00009910}, {990,0.00014414}, {995,0.00007207}, {1000,0.00007207}, {1010,0.00025225}, {1020,0.00021622}, {1030,0.00010811}, {1040,0.00014414}, {1050,0.00017117}, {1060,0.00010909}, {1070,0.00007273}, {1080,0.00007273}, {1090,0.00014545}, {1100,0.00014545}, {1110,0.00007273}, {1120,0.00003636}, {1130,0.00007273}, {1140,0.00000000}, {1150,0.00007273}, {1160,0.00014545}, {1170,0.00010909}, {1180,0.00007273}, {1190,0.00003636}, {1200,0.00010909}, {1210,0.00021818}, {1220,0.00007273}, {1230,0.00007273}, {1240,0.00013636}, {1250,0.00014545}, {1260,0.00017273}, {1270,0.00007273}, {1280,0.00010909}, {1290,0.00021818}, {1300,0.00018182}, {1310,0.00014545}, {1320,0.00014545}, {1330,0.00007273}, {1340,0.00000000}, {1350,0.00007273}, {1360,0.00029091}, {1370,0.00017273}, {1380,0.00010909}, {1390,0.00014545}, {1400,0.00018182}, {1410,0.00000000}, {1420,0.00007273}, {1430,0.00018182}, {1440,0.00030909}, {1450,0.00020909}, {1460,0.00007273}, {1470,0.00010909}, {1480,0.00014545}, {1490,0.00014545}, {1500,0.00010909}, {1510,0.00013636}, {1520,0.00000000}, {1530,0.00014545}, {1540,0.00003636}, {1550,0.00000000}, {1560,0.00010909}, {1570,0.00003636}, {1580,0.00000000}, {1590,0.00003636}, {1600,0.00007273}, {1610,0.00010000}, {1620,0.00014545}, {1630,0.00003636}, {1640,0.00003636}, {1650,0.00006364}, {1660,0.00003636}, {1670,0.00007273}, {1680,0.00006364}, {1690,0.00007273}, {1700,0.00007273}, {1710,0.00007273}, {1720,0.00007273}, {1730,0.00003636}, {1740,0.00000000}, {1750,0.00003636}, {1760,0.00003636}, {1770,0.00014545}, {1780,0.00002727}, {1790,0.00003636}, {1800,0.00003636}, {1810,0.00003636}, {1820,0.00003636}, {1830,0.00010909}, {1840,0.00007273}, {1850,0.00003636}, {1860,0.00000000}, {1870,0.00007273}, {1880,0.00010000}, {1890,0.00002727}, {1900,0.00003636}, {1910,0.00002727}, {1920,0.00003636}, {1930,0.00003636}, {1940,0.00010909}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00010909}, {1980,0.00007273}, {1990,0.00010000}, {2000,0.00003636}, {2050,0.00010909}, {2100,0.00010909}, {2150,0.00003636}, {2200,0.00003636}, {2250,0.00010000}, {2300,0.00010000}, {2350,0.00007273}, {2400,0.00003636}, {2450,0.00000000}, {2500,0.00003636}, {2550,0.00007273}, {2600,0.00000000}, {2650,0.00007273}, {2700,0.00010909}, {2750,0.00000000}, {2800,0.00007273}, {2850,0.00000000}, {2900,0.00003636}, {2950,0.00003636}, {3000,0.00000000}, {3050,0.00010909}, {3100,0.00007273}, {3150,0.00014545}, {3200,0.00007273}, {3250,0.00014545}, {3300,0.00007273}, {3350,0.00000000}, {3400,0.00003636}, {3450,0.00007273}, {3500,0.00003636}, {3550,0.00010909}, {3600,0.00003636}, {3650,0.00003636}, {3700,0.00000000}, {3750,0.00003636}, {3800,0.00003636}, {3850,0.00003636}, {3900,0.00014545}, {3950,0.00003636}, {4000,0.00010909}, {4050,0.00010909}, {4100,0.00003636}, {4150,0.00021818}, {4200,0.00007273}, {4250,0.00003636}, {4300,0.00000000}, {4350,0.00007273}, {4400,0.00003636}, {4450,0.00003636}, {4500,0.00003636}, {4550,0.00010909}, {4600,0.00000000}, {4650,0.00007273}, {4700,0.00007273}, {4750,0.00071818}, {4800,0.00053636}, {4850,0.00032727}, {4900,0.00050000}, {4950,0.00032727}, {5000,0.00036364}, {5050,0.00017273}, {5100,0.00028182}, {5150,0.00018182}, {5200,0.00006364}, {5250,0.00003636}, {5300,0.00003636}, {5350,0.00003636}, {5400,0.00013636}, {5450,0.00007273}, {5500,0.00007273}, {5550,0.00053636}, {5600,0.00010909}, {5650,0.00007273}, {5700,0.00018182}, {5750,0.00000000}, {5800,0.00010909}, {5850,0.00000000}, {5900,0.00007273}, {5950,0.00010909}, {6000,0.00014545}, {6050,0.00100}, {6100,0.00100}, {6150,0.00100}, {6200,0.00000}, {6250,0.00000}, {6300,0.00100}, {6350,0.00000}, {6400,0.00100}, {6450,0.00000}, {6500,0.00100}, {6550,0.00100}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00100}, {6800,0.00000}, {6850,0.00200}, {6900,0.00000}, {6950,0.00000}, {7000,0.00100}, {7050,0.00000}, {7100,0.00100}, {7150,0.00000}, {7200,0.00000}, {7250,0.00200}, {7300,0.00000}, {7350,0.00000}, {7400,0.00100}, {7450,0.00200}, {7500,0.00100}, {7550,0.00000}, {7600,0.00000}, {7650,0.00100}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00100}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00100}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00100}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00100}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00075}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00100}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00100}, {14700,0.00000}, {14800,0.00100}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00100}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00100}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00100}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00100}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00100}, {19600,0.00100}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresHOAS"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresHOAS"]["post"]["user"] = {{1,0.00002703}, {2,0.00000000}, {3,0.00002703}, {4,0.00006306}, {5,0.00003604}, {6,0.00003604}, {7,0.00002703}, {8,0.00005405}, {9,0.00002703}, {10,0.00002703}, {11,0.00002703}, {12,0.00003604}, {13,0.00003604}, {14,0.00000000}, {15,0.00003604}, {16,0.00002703}, {17,0.00002703}, {18,0.00002703}, {19,0.00005405}, {20,0.00002703}, {21,0.00005405}, {22,0.00000000}, {23,0.00002703}, {24,0.00009009}, {25,0.00003604}, {26,0.00000000}, {27,0.00009009}, {28,0.00002703}, {29,0.00000000}, {30,0.00002703}, {31,0.00003604}, {32,0.00002703}, {33,0.00007207}, {34,0.00002703}, {35,0.00002703}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00007207}, {41,0.00002703}, {42,0.00003604}, {43,0.00000000}, {44,0.00003604}, {45,0.00000000}, {46,0.00002703}, {47,0.00000000}, {48,0.00000000}, {49,0.00002703}, {50,0.00002703}, {51,0.00002703}, {52,0.00009009}, {53,0.00000000}, {54,0.00000000}, {55,0.00009009}, {56,0.00000000}, {57,0.00002703}, {58,0.00006306}, {59,0.00002703}, {60,0.00014414}, {61,0.00003604}, {62,0.00002703}, {63,0.00000000}, {64,0.00005405}, {65,0.00002703}, {66,0.00000000}, {67,0.00000000}, {68,0.00002703}, {69,0.00008108}, {70,0.00003604}, {71,0.00002703}, {72,0.00002703}, {73,0.00003604}, {74,0.00000000}, {75,0.00003604}, {76,0.00002703}, {77,0.00000000}, {78,0.00000000}, {79,0.00005405}, {80,0.00000000}, {81,0.00002703}, {82,0.00000000}, {83,0.00000000}, {84,0.00005405}, {85,0.00002703}, {86,0.00000000}, {87,0.00000000}, {88,0.00002703}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00003604}, {93,0.00000000}, {94,0.00000000}, {95,0.00006306}, {96,0.00005405}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00006306}, {101,0.00005405}, {102,0.00002703}, {103,0.00000000}, {104,0.00003604}, {105,0.00006306}, {106,0.00000000}, {107,0.00002703}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00003604}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00005405}, {118,0.00000000}, {119,0.00002703}, {120,0.00002703}, {121,0.00000000}, {122,0.00005405}, {123,0.00002703}, {124,0.00000000}, {125,0.00002703}, {126,0.00002703}, {127,0.00000000}, {128,0.00003604}, {129,0.00002703}, {130,0.00008108}, {131,0.00000000}, {132,0.00000000}, {133,0.00002703}, {134,0.00006306}, {135,0.00002703}, {136,0.00003604}, {137,0.00007207}, {138,0.00000000}, {139,0.00005405}, {140,0.00009009}, {141,0.00002703}, {142,0.00005405}, {143,0.00005405}, {144,0.00000000}, {145,0.00008108}, {146,0.00002703}, {147,0.00003604}, {148,0.00000000}, {149,0.00002703}, {150,0.00000000}, {151,0.00003604}, {152,0.00005405}, {153,0.00003604}, {154,0.00002703}, {155,0.00002703}, {156,0.00000000}, {157,0.00009910}, {158,0.00000000}, {159,0.00008108}, {160,0.00007207}, {161,0.00008108}, {162,0.00002703}, {163,0.00002703}, {164,0.00008108}, {165,0.00000000}, {166,0.00005405}, {167,0.00002703}, {168,0.00003604}, {169,0.00000000}, {170,0.00000000}, {171,0.00008108}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00003604}, {177,0.00000000}, {178,0.00002703}, {179,0.00002703}, {180,0.00000000}, {181,0.00003604}, {182,0.00000000}, {183,0.00002703}, {184,0.00007207}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00002703}, {189,0.00002703}, {190,0.00006306}, {191,0.00003604}, {192,0.00005405}, {193,0.00002703}, {194,0.00002703}, {195,0.00002703}, {196,0.00000000}, {197,0.00002703}, {198,0.00000000}, {199,0.00003604}, {200,0.00008108}, {201,0.00006306}, {202,0.00000000}, {203,0.00000000}, {204,0.00002703}, {205,0.00003604}, {206,0.00000000}, {207,0.00002703}, {208,0.00000000}, {209,0.00003604}, {210,0.00005405}, {211,0.00000000}, {212,0.00002703}, {213,0.00007207}, {214,0.00000000}, {215,0.00002703}, {216,0.00006306}, {217,0.00000000}, {218,0.00000000}, {219,0.00002703}, {220,0.00006306}, {221,0.00000000}, {222,0.00000000}, {223,0.00002703}, {224,0.00003604}, {225,0.00003604}, {226,0.00000000}, {227,0.00000000}, {228,0.00003604}, {229,0.00000000}, {230,0.00012613}, {231,0.00005405}, {232,0.00006306}, {233,0.00000000}, {234,0.00003604}, {235,0.00002703}, {236,0.00007207}, {237,0.00003604}, {238,0.00002703}, {239,0.00002703}, {240,0.00000000}, {241,0.00002703}, {242,0.00005405}, {243,0.00000000}, {244,0.00002703}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00003604}, {251,0.00002703}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00005405}, {256,0.00003604}, {257,0.00006306}, {258,0.00000000}, {259,0.00000000}, {260,0.00005405}, {261,0.00000000}, {262,0.00002703}, {263,0.00005405}, {264,0.00000000}, {265,0.00005405}, {266,0.00002703}, {267,0.00000000}, {268,0.00000000}, {269,0.00005405}, {270,0.00002703}, {271,0.00002703}, {272,0.00000000}, {273,0.00002703}, {274,0.00000000}, {275,0.00000000}, {276,0.00003604}, {277,0.00009009}, {278,0.00000000}, {279,0.00000000}, {280,0.00005405}, {281,0.00003604}, {282,0.00000000}, {283,0.00005405}, {284,0.00002703}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00002703}, {289,0.00000000}, {290,0.00006306}, {291,0.00000000}, {292,0.00002703}, {293,0.00000000}, {294,0.00007207}, {295,0.00000000}, {296,0.00007207}, {297,0.00002703}, {298,0.00000000}, {299,0.00003604}, {300,0.00003604}, {301,0.00002703}, {302,0.00002703}, {303,0.00002703}, {304,0.00002703}, {305,0.00002703}, {306,0.00000000}, {307,0.00002703}, {308,0.00008108}, {309,0.00002703}, {310,0.00002703}, {311,0.00000000}, {312,0.00002703}, {313,0.00000000}, {314,0.00002703}, {315,0.00005405}, {316,0.00005405}, {317,0.00007207}, {318,0.00002703}, {319,0.00005405}, {320,0.00002703}, {321,0.00005405}, {322,0.00000000}, {323,0.00005405}, {324,0.00009009}, {325,0.00005405}, {326,0.00002703}, {327,0.00000000}, {328,0.00002703}, {329,0.00002703}, {330,0.00003604}, {331,0.00000000}, {332,0.00006306}, {333,0.00000000}, {334,0.00002703}, {335,0.00006306}, {336,0.00002703}, {337,0.00009009}, {338,0.00000000}, {339,0.00009009}, {340,0.00000000}, {341,0.00013514}, {342,0.00000000}, {343,0.00003604}, {344,0.00002703}, {345,0.00003604}, {346,0.00002703}, {347,0.00002703}, {348,0.00006306}, {349,0.00002703}, {350,0.00002703}, {351,0.00006306}, {352,0.00006306}, {353,0.00002703}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00006306}, {358,0.00006306}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00002703}, {367,0.00005405}, {368,0.00002703}, {369,0.00002703}, {370,0.00000000}, {371,0.00002703}, {372,0.00002703}, {373,0.00002703}, {374,0.00002703}, {375,0.00002703}, {376,0.00007207}, {377,0.00002703}, {378,0.00000000}, {379,0.00000000}, {380,0.00003604}, {381,0.00003604}, {382,0.00002703}, {383,0.00000000}, {384,0.00002703}, {385,0.00000000}, {386,0.00005405}, {387,0.00002703}, {388,0.00009910}, {389,0.00006306}, {390,0.00010811}, {391,0.00006306}, {392,0.00003604}, {393,0.00002703}, {394,0.00010811}, {395,0.00012613}, {396,0.00003604}, {397,0.00000000}, {398,0.00006306}, {399,0.00000000}, {400,0.00000000}, {401,0.00006306}, {402,0.00012613}, {403,0.00002703}, {404,0.00002703}, {405,0.00002703}, {406,0.00002703}, {407,0.00003604}, {408,0.00000000}, {409,0.00002703}, {410,0.00008108}, {411,0.00000000}, {412,0.00002703}, {413,0.00002703}, {414,0.00000000}, {415,0.00011712}, {416,0.00002703}, {417,0.00000000}, {418,0.00003604}, {419,0.00000000}, {420,0.00006306}, {421,0.00009009}, {422,0.00002703}, {423,0.00009910}, {424,0.00008108}, {425,0.00006306}, {426,0.00008108}, {427,0.00002703}, {428,0.00000000}, {429,0.00007207}, {430,0.00002703}, {431,0.00000000}, {432,0.00003604}, {433,0.00000000}, {434,0.00000000}, {435,0.00002703}, {436,0.00005405}, {437,0.00009009}, {438,0.00002703}, {439,0.00006306}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00006306}, {444,0.00002703}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00003604}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00006306}, {454,0.00002703}, {455,0.00000000}, {456,0.00006306}, {457,0.00005405}, {458,0.00003604}, {459,0.00005405}, {460,0.00003604}, {461,0.00005405}, {462,0.00000000}, {463,0.00002703}, {464,0.00000000}, {465,0.00002703}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00003604}, {470,0.00010811}, {471,0.00002703}, {472,0.00000000}, {473,0.00002703}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00002703}, {478,0.00000000}, {479,0.00002703}, {480,0.00002703}, {481,0.00005405}, {482,0.00009910}, {483,0.00000000}, {484,0.00000000}, {485,0.00009009}, {486,0.00002703}, {487,0.00002703}, {488,0.00002703}, {489,0.00009910}, {490,0.00002703}, {491,0.00003604}, {492,0.00000000}, {493,0.00012613}, {494,0.00000000}, {495,0.00005405}, {496,0.00002703}, {497,0.00010811}, {498,0.00006306}, {499,0.00008108}, {500,0.00003604}, {505,0.00000000}, {510,0.00006306}, {515,0.00006306}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00002703}, {565,0.00000000}, {570,0.00000000}, {575,0.00002703}, {580,0.00006306}, {585,0.00002703}, {590,0.00000000}, {595,0.00007207}, {600,0.00002703}, {605,0.00006306}, {610,0.00002703}, {615,0.00005405}, {620,0.00000000}, {625,0.00000000}, {630,0.00006306}, {635,0.00002703}, {640,0.00005405}, {645,0.00000000}, {650,0.00003604}, {655,0.00006306}, {660,0.00002703}, {665,0.00006306}, {670,0.00000000}, {675,0.00000000}, {680,0.00002703}, {685,0.00002703}, {690,0.00000000}, {695,0.00000000}, {700,0.00002703}, {705,0.00005405}, {710,0.00000000}, {715,0.00003604}, {720,0.00009009}, {725,0.00002703}, {730,0.00011712}, {735,0.00005405}, {740,0.00002703}, {745,0.00002703}, {750,0.00009009}, {755,0.00002703}, {760,0.00002703}, {765,0.00000000}, {770,0.00016216}, {775,0.00003604}, {780,0.00002703}, {785,0.00000000}, {790,0.00005405}, {795,0.00002703}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00005405}, {820,0.00000000}, {825,0.00003604}, {830,0.00012613}, {835,0.00002703}, {840,0.00005405}, {845,0.00002703}, {850,0.00000000}, {855,0.00000000}, {860,0.00003604}, {865,0.00000000}, {870,0.00012613}, {875,0.00002703}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00009009}, {905,0.00000000}, {910,0.00005405}, {915,0.00019820}, {920,0.00000000}, {925,0.00003604}, {930,0.00000000}, {935,0.00000000}, {940,0.00005405}, {945,0.00009009}, {950,0.00005405}, {955,0.00000000}, {960,0.00000000}, {965,0.00006306}, {970,0.00000000}, {975,0.00006306}, {980,0.00005405}, {985,0.00002703}, {990,0.00006306}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00003604}, {1020,0.00002703}, {1030,0.00002703}, {1040,0.00006306}, {1050,0.00000000}, {1060,0.00002727}, {1070,0.00003636}, {1080,0.00000000}, {1090,0.00006364}, {1100,0.00003636}, {1110,0.00002727}, {1120,0.00009091}, {1130,0.00009091}, {1140,0.00000000}, {1150,0.00005455}, {1160,0.00005455}, {1170,0.00000000}, {1180,0.00005455}, {1190,0.00007273}, {1200,0.00006364}, {1210,0.00000000}, {1220,0.00002727}, {1230,0.00002727}, {1240,0.00002727}, {1250,0.00002727}, {1260,0.00000000}, {1270,0.00005455}, {1280,0.00003636}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00002727}, {1320,0.00009091}, {1330,0.00000000}, {1340,0.00006364}, {1350,0.00000000}, {1360,0.00003636}, {1370,0.00009091}, {1380,0.00003636}, {1390,0.00000000}, {1400,0.00002727}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00010000}, {1450,0.00003636}, {1460,0.00000000}, {1470,0.00003636}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00002727}, {1510,0.00000000}, {1520,0.00002727}, {1530,0.00000000}, {1540,0.00006364}, {1550,0.00003636}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00006364}, {1590,0.00003636}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00003636}, {1630,0.00006364}, {1640,0.00003636}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00006364}, {1690,0.00007273}, {1700,0.00003636}, {1710,0.00002727}, {1720,0.00000000}, {1730,0.00003636}, {1740,0.00003636}, {1750,0.00003636}, {1760,0.00007273}, {1770,0.00011818}, {1780,0.00007273}, {1790,0.00003636}, {1800,0.00014545}, {1810,0.00010909}, {1820,0.00000000}, {1830,0.00010000}, {1840,0.00000000}, {1850,0.00013636}, {1860,0.00003636}, {1870,0.00009091}, {1880,0.00000000}, {1890,0.00010909}, {1900,0.00000000}, {1910,0.00010000}, {1920,0.00003636}, {1930,0.00007273}, {1940,0.00003636}, {1950,0.00003636}, {1960,0.00003636}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00002727}, {2000,0.00000000}, {2050,0.00003636}, {2100,0.00002727}, {2150,0.00003636}, {2200,0.00003636}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00005455}, {2450,0.00003636}, {2500,0.00003636}, {2550,0.00003636}, {2600,0.00006364}, {2650,0.00000000}, {2700,0.00002727}, {2750,0.00003636}, {2800,0.00003636}, {2850,0.00000000}, {2900,0.00007273}, {2950,0.00000000}, {3000,0.00003636}, {3050,0.00003636}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00006364}, {3300,0.00000000}, {3350,0.00003636}, {3400,0.00000000}, {3450,0.00006364}, {3500,0.00002727}, {3550,0.00006364}, {3600,0.00003636}, {3650,0.00000000}, {3700,0.00010000}, {3750,0.00000000}, {3800,0.00010000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00003636}, {4050,0.00010000}, {4100,0.00009091}, {4150,0.00000000}, {4200,0.00006364}, {4250,0.00003636}, {4300,0.00003636}, {4350,0.00000000}, {4400,0.00010000}, {4450,0.00000000}, {4500,0.00002727}, {4550,0.00002727}, {4600,0.00003636}, {4650,0.00003636}, {4700,0.00000000}, {4750,0.00003636}, {4800,0.00002727}, {4850,0.00003636}, {4900,0.00003636}, {4950,0.00003636}, {5000,0.00000000}, {5050,0.00012727}, {5100,0.00007273}, {5150,0.00003636}, {5200,0.00010000}, {5250,0.00010000}, {5300,0.00000000}, {5350,0.00003636}, {5400,0.00006364}, {5450,0.00002727}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00002727}, {5800,0.00000000}, {5850,0.00002727}, {5900,0.00003636}, {5950,0.00002727}, {6000,0.00005455}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00100}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00100}, {8750,0.00000}, {8800,0.00100}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00100}, {9900,0.00000}, {9950,0.00100}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00075}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresHOAS"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00003604}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00003604}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00003604}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00003604}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00003604}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00003604}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00003604}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00003636}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresHOAS"]["postprocess"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00002703}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresHOAS"]["postprocess"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00002703}, {4,0.00000000}, {5,0.00002703}, {6,0.00000000}, {7,0.00000000}, {8,0.00002703}, {9,0.00000000}, {10,0.00002703}, {11,0.00000000}, {12,0.00002703}, {13,0.00000000}, {14,0.00002703}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00002703}, {24,0.00003604}, {25,0.00000000}, {26,0.00003604}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00002703}, {37,0.00002703}, {38,0.00000000}, {39,0.00002703}, {40,0.00002703}, {41,0.00002703}, {42,0.00000000}, {43,0.00007207}, {44,0.00003604}, {45,0.00000000}, {46,0.00002703}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00006306}, {52,0.00002703}, {53,0.00000000}, {54,0.00000000}, {55,0.00002703}, {56,0.00007207}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00005405}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00006306}, {66,0.00006306}, {67,0.00002703}, {68,0.00000000}, {69,0.00002703}, {70,0.00002703}, {71,0.00003604}, {72,0.00002703}, {73,0.00000000}, {74,0.00003604}, {75,0.00000000}, {76,0.00000000}, {77,0.00002703}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00003604}, {84,0.00005405}, {85,0.00006306}, {86,0.00000000}, {87,0.00002703}, {88,0.00000000}, {89,0.00000000}, {90,0.00002703}, {91,0.00000000}, {92,0.00009910}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00002703}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00006306}, {105,0.00000000}, {106,0.00000000}, {107,0.00002703}, {108,0.00000000}, {109,0.00003604}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00003604}, {115,0.00002703}, {116,0.00002703}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00006306}, {122,0.00005405}, {123,0.00002703}, {124,0.00000000}, {125,0.00002703}, {126,0.00000000}, {127,0.00002703}, {128,0.00002703}, {129,0.00000000}, {130,0.00005405}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00006306}, {136,0.00003604}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00002703}, {141,0.00002703}, {142,0.00000000}, {143,0.00009009}, {144,0.00000000}, {145,0.00007207}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00002703}, {152,0.00002703}, {153,0.00000000}, {154,0.00002703}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00003604}, {161,0.00000000}, {162,0.00002703}, {163,0.00000000}, {164,0.00003604}, {165,0.00002703}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00002703}, {170,0.00002703}, {171,0.00002703}, {172,0.00006306}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00002703}, {182,0.00002703}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00002703}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00002703}, {191,0.00000000}, {192,0.00000000}, {193,0.00002703}, {194,0.00000000}, {195,0.00000000}, {196,0.00002703}, {197,0.00000000}, {198,0.00002703}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00008108}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00005405}, {213,0.00003604}, {214,0.00005405}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00002703}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00003604}, {228,0.00000000}, {229,0.00002703}, {230,0.00000000}, {231,0.00002703}, {232,0.00000000}, {233,0.00007207}, {234,0.00003604}, {235,0.00002703}, {236,0.00002703}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00002703}, {242,0.00002703}, {243,0.00002703}, {244,0.00003604}, {245,0.00002703}, {246,0.00000000}, {247,0.00003604}, {248,0.00002703}, {249,0.00002703}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00002703}, {256,0.00000000}, {257,0.00002703}, {258,0.00002703}, {259,0.00000000}, {260,0.00005405}, {261,0.00002703}, {262,0.00000000}, {263,0.00000000}, {264,0.00002703}, {265,0.00003604}, {266,0.00002703}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00003604}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00011712}, {281,0.00000000}, {282,0.00002703}, {283,0.00002703}, {284,0.00006306}, {285,0.00002703}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00002703}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00002703}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00003604}, {311,0.00005405}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00002703}, {316,0.00000000}, {317,0.00006306}, {318,0.00002703}, {319,0.00002703}, {320,0.00005405}, {321,0.00000000}, {322,0.00005405}, {323,0.00002703}, {324,0.00003604}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00002703}, {330,0.00003604}, {331,0.00000000}, {332,0.00002703}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00002703}, {339,0.00000000}, {340,0.00003604}, {341,0.00000000}, {342,0.00002703}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00003604}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00003604}, {355,0.00000000}, {356,0.00000000}, {357,0.00006306}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00002703}, {367,0.00000000}, {368,0.00000000}, {369,0.00002703}, {370,0.00008108}, {371,0.00002703}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00007207}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00002703}, {381,0.00005405}, {382,0.00000000}, {383,0.00000000}, {384,0.00002703}, {385,0.00000000}, {386,0.00002703}, {387,0.00000000}, {388,0.00006306}, {389,0.00002703}, {390,0.00002703}, {391,0.00000000}, {392,0.00000000}, {393,0.00002703}, {394,0.00000000}, {395,0.00000000}, {396,0.00002703}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00002703}, {401,0.00000000}, {402,0.00002703}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00005405}, {414,0.00000000}, {415,0.00003604}, {416,0.00003604}, {417,0.00000000}, {418,0.00000000}, {419,0.00003604}, {420,0.00000000}, {421,0.00000000}, {422,0.00005405}, {423,0.00000000}, {424,0.00003604}, {425,0.00002703}, {426,0.00000000}, {427,0.00003604}, {428,0.00002703}, {429,0.00000000}, {430,0.00002703}, {431,0.00002703}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00002703}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00003604}, {449,0.00003604}, {450,0.00000000}, {451,0.00002703}, {452,0.00000000}, {453,0.00002703}, {454,0.00002703}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00002703}, {459,0.00002703}, {460,0.00000000}, {461,0.00002703}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00002703}, {466,0.00003604}, {467,0.00006306}, {468,0.00000000}, {469,0.00000000}, {470,0.00006306}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00003604}, {475,0.00002703}, {476,0.00002703}, {477,0.00000000}, {478,0.00002703}, {479,0.00000000}, {480,0.00003604}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00002703}, {486,0.00002703}, {487,0.00000000}, {488,0.00002703}, {489,0.00005405}, {490,0.00000000}, {491,0.00000000}, {492,0.00005405}, {493,0.00006306}, {494,0.00002703}, {495,0.00000000}, {496,0.00000000}, {497,0.00007207}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00007207}, {510,0.00000000}, {515,0.00000000}, {520,0.00003604}, {525,0.00002703}, {530,0.00003604}, {535,0.00002703}, {540,0.00006306}, {545,0.00005405}, {550,0.00005405}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00002703}, {575,0.00003604}, {580,0.00000000}, {585,0.00003604}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00003604}, {610,0.00000000}, {615,0.00002703}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00003604}, {640,0.00000000}, {645,0.00002703}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00003604}, {675,0.00003604}, {680,0.00006306}, {685,0.00000000}, {690,0.00003604}, {695,0.00000000}, {700,0.00003604}, {705,0.00003604}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00005405}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00003604}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00002703}, {785,0.00000000}, {790,0.00002703}, {795,0.00003604}, {800,0.00000000}, {805,0.00000000}, {810,0.00002703}, {815,0.00002703}, {820,0.00000000}, {825,0.00002703}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00003604}, {850,0.00006306}, {855,0.00003604}, {860,0.00000000}, {865,0.00000000}, {870,0.00002703}, {875,0.00000000}, {880,0.00000000}, {885,0.00002703}, {890,0.00000000}, {895,0.00002703}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00002703}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00002703}, {945,0.00000000}, {950,0.00000000}, {955,0.00002703}, {960,0.00002703}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00007207}, {985,0.00000000}, {990,0.00000000}, {995,0.00002703}, {1000,0.00002703}, {1010,0.00007207}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00002703}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00002727}, {1080,0.00000000}, {1090,0.00006364}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00006364}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00003636}, {1210,0.00000000}, {1220,0.00003636}, {1230,0.00002727}, {1240,0.00000000}, {1250,0.00003636}, {1260,0.00005455}, {1270,0.00002727}, {1280,0.00002727}, {1290,0.00000000}, {1300,0.00005455}, {1310,0.00003636}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00002727}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00003636}, {1390,0.00007273}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00008182}, {1440,0.00003636}, {1450,0.00003636}, {1460,0.00003636}, {1470,0.00000000}, {1480,0.00002727}, {1490,0.00002727}, {1500,0.00003636}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00003636}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00003636}, {1580,0.00000000}, {1590,0.00002727}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00006364}, {1630,0.00002727}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00002727}, {1700,0.00003636}, {1710,0.00000000}, {1720,0.00003636}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00002727}, {1760,0.00007273}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00002727}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00003636}, {1960,0.00010000}, {1970,0.00002727}, {1980,0.00000000}, {1990,0.00006364}, {2000,0.00002727}, {2050,0.00007273}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00002727}, {2250,0.00003636}, {2300,0.00002727}, {2350,0.00003636}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00003636}, {2600,0.00000000}, {2650,0.00006364}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00006364}, {2850,0.00007273}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00003636}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00003636}, {3550,0.00003636}, {3600,0.00002727}, {3650,0.00002727}, {3700,0.00007273}, {3750,0.00002727}, {3800,0.00003636}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00002727}, {4400,0.00007273}, {4450,0.00000000}, {4500,0.00002727}, {4550,0.00000000}, {4600,0.00009091}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00002727}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00003636}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00007273}, {5200,0.00010000}, {5250,0.00003636}, {5300,0.00003636}, {5350,0.00000000}, {5400,0.00002727}, {5450,0.00000000}, {5500,0.00006364}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00002727}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00100}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00100}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00100}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00075}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00075}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresHOAS"]["postprocess"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00003604}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00003604}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00003636}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresHOAS"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.01699099}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00001802}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00100901}, {56,0.00000000}, {57,0.00000000}, {58,0.00000901}, {59,0.00000000}, {60,0.00000901}, {61,0.00000901}, {62,0.00001802}, {63,0.00003604}, {64,0.00004505}, {65,0.00006306}, {66,0.00007207}, {67,0.00012613}, {68,0.00016216}, {69,0.00022523}, {70,0.00042342}, {71,0.00061261}, {72,0.00061261}, {73,0.00080180}, {74,0.00081982}, {75,0.00096396}, {76,0.00097297}, {77,0.00100000}, {78,0.00100000}, {79,0.00100000}, {80,0.00100000}, {81,0.00100000}, {82,0.00100000}, {83,0.00100000}, {84,0.00100000}, {85,0.00100000}, {86,0.00100000}, {87,0.00100000}, {88,0.00100000}, {89,0.00100000}, {90,0.00100000}, {91,0.00100000}, {92,0.00100000}, {93,0.00100000}, {94,0.00100000}, {95,0.00100000}, {96,0.00100000}, {97,0.00100000}, {98,0.00100000}, {99,0.00100000}, {100,0.00100000}, {101,0.00100000}, {102,0.00100000}, {103,0.00100000}, {104,0.00100000}, {105,0.00100000}, {106,0.00100000}, {107,0.00100000}, {108,0.00100000}, {109,0.00100000}, {110,0.00100000}, {111,0.00100000}, {112,0.00100000}, {113,0.00100000}, {114,0.00100000}, {115,0.00100000}, {116,0.00100000}, {117,0.00100000}, {118,0.00100000}, {119,0.00100000}, {120,0.00100000}, {121,0.00100000}, {122,0.00100000}, {123,0.00100000}, {124,0.00100000}, {125,0.00100000}, {126,0.00100000}, {127,0.00100000}, {128,0.00100000}, {129,0.00100000}, {130,0.00100000}, {131,0.00100000}, {132,0.00100000}, {133,0.00100000}, {134,0.00100000}, {135,0.00100901}, {136,0.00100000}, {137,0.00100000}, {138,0.00100000}, {139,0.00100000}, {140,0.00100000}, {141,0.00100000}, {142,0.00100000}, {143,0.00100000}, {144,0.00100000}, {145,0.00101802}, {146,0.00100000}, {147,0.00100000}, {148,0.00100000}, {149,0.00100000}, {150,0.00100000}, {151,0.00100000}, {152,0.00198198}, {153,0.00100000}, {154,0.00100000}, {155,0.00100000}, {156,0.00100000}, {157,0.00100000}, {158,0.00100000}, {159,0.00100000}, {160,0.00100000}, {161,0.00100000}, {162,0.00100000}, {163,0.00100000}, {164,0.00100000}, {165,0.00100000}, {166,0.00100000}, {167,0.00100000}, {168,0.00100000}, {169,0.00100000}, {170,0.00100901}, {171,0.00101802}, {172,0.00100000}, {173,0.00101802}, {174,0.00102703}, {175,0.00299099}, {176,0.00100000}, {177,0.00101802}, {178,0.00102703}, {179,0.00102703}, {180,0.00105405}, {181,0.00110811}, {182,0.00109009}, {183,0.00120721}, {184,0.00121622}, {185,0.00118919}, {186,0.00133333}, {187,0.00158559}, {188,0.00146847}, {189,0.00161261}, {190,0.00170270}, {191,0.00186486}, {192,0.00125225}, {193,0.00154054}, {194,0.00159459}, {195,0.00181982}, {196,0.00172973}, {197,0.00190991}, {198,0.00192793}, {199,0.00199099}, {200,0.00187387}, {201,0.00194595}, {202,0.00198198}, {203,0.00200000}, {204,0.00199099}, {205,0.00200000}, {206,0.00200000}, {207,0.00200000}, {208,0.00200000}, {209,0.00200000}, {210,0.00200000}, {211,0.00200000}, {212,0.00200000}, {213,0.00200000}, {214,0.00201802}, {215,0.00200000}, {216,0.00200000}, {217,0.00200000}, {218,0.00200000}, {219,0.00201802}, {220,0.00200000}, {221,0.00200000}, {222,0.00200000}, {223,0.00200000}, {224,0.00200000}, {225,0.00200000}, {226,0.00200000}, {227,0.00200000}, {228,0.00200000}, {229,0.00200000}, {230,0.00200000}, {231,0.00201802}, {232,0.00298198}, {233,0.00200000}, {234,0.00200000}, {235,0.00200000}, {236,0.00200000}, {237,0.00200000}, {238,0.00200000}, {239,0.00200000}, {240,0.00298198}, {241,0.00200000}, {242,0.00200000}, {243,0.00200000}, {244,0.00200000}, {245,0.00200000}, {246,0.00200000}, {247,0.00200000}, {248,0.00200000}, {249,0.00200000}, {250,0.00200000}, {251,0.00298198}, {252,0.00200000}, {253,0.00200000}, {254,0.00200000}, {255,0.00200000}, {256,0.00200000}, {257,0.00200000}, {258,0.00200000}, {259,0.00200000}, {260,0.00200000}, {261,0.00200000}, {262,0.00200000}, {263,0.00200000}, {264,0.00200000}, {265,0.00200000}, {266,0.00200000}, {267,0.00200000}, {268,0.00200000}, {269,0.00200000}, {270,0.00200000}, {271,0.00200000}, {272,0.00200000}, {273,0.00200000}, {274,0.00200901}, {275,0.00200901}, {276,0.00200000}, {277,0.00200000}, {278,0.00200000}, {279,0.00200901}, {280,0.00200901}, {281,0.00200000}, {282,0.00200901}, {283,0.00202703}, {284,0.00200000}, {285,0.00202703}, {286,0.00201802}, {287,0.00207207}, {288,0.00200000}, {289,0.00200000}, {290,0.00201802}, {291,0.00390991}, {292,0.00202703}, {293,0.00207207}, {294,0.00211712}, {295,0.00222523}, {296,0.00204505}, {297,0.00224324}, {298,0.00218919}, {299,0.00243243}, {300,0.00227027}, {301,0.00248649}, {302,0.00258559}, {303,0.00276577}, {304,0.00227928}, {305,0.00249550}, {306,0.00254054}, {307,0.00278378}, {308,0.00271171}, {309,0.00283784}, {310,0.00286486}, {311,0.00297297}, {312,0.00281081}, {313,0.00293694}, {314,0.00297297}, {315,0.00300000}, {316,0.00297297}, {317,0.00300000}, {318,0.00300000}, {319,0.00300000}, {320,0.00284685}, {321,0.00293694}, {322,0.00295495}, {323,0.00300000}, {324,0.00296396}, {325,0.00300000}, {326,0.00300000}, {327,0.00300000}, {328,0.00300000}, {329,0.00300000}, {330,0.00300000}, {331,0.00300000}, {332,0.00300000}, {333,0.00300000}, {334,0.00300000}, {335,0.00300000}, {336,0.00300901}, {337,0.00300000}, {338,0.00300000}, {339,0.00300000}, {340,0.00300000}, {341,0.00300000}, {342,0.00300000}, {343,0.00300000}, {344,0.00300000}, {345,0.00300000}, {346,0.00300000}, {347,0.00398198}, {348,0.00300000}, {349,0.00300000}, {350,0.00300000}, {351,0.00300000}, {352,0.00300000}, {353,0.00300000}, {354,0.00300000}, {355,0.00300000}, {356,0.00300000}, {357,0.00398198}, {358,0.00300000}, {359,0.00300901}, {360,0.00398198}, {361,0.00300000}, {362,0.00302703}, {363,0.00398198}, {364,0.00300000}, {365,0.00300000}, {366,0.00300000}, {367,0.00300000}, {368,0.00300000}, {369,0.00301802}, {370,0.00300000}, {371,0.00300000}, {372,0.00300000}, {373,0.00300000}, {374,0.00398198}, {375,0.00300901}, {376,0.00300000}, {377,0.00300000}, {378,0.00300000}, {379,0.00300901}, {380,0.00300901}, {381,0.00301802}, {382,0.00302703}, {383,0.00304505}, {384,0.00300000}, {385,0.00300901}, {386,0.00300000}, {387,0.00300000}, {388,0.00300000}, {389,0.00302703}, {390,0.00300000}, {391,0.00301802}, {392,0.00300000}, {393,0.00301802}, {394,0.00300901}, {395,0.00303604}, {396,0.00302703}, {397,0.00302703}, {398,0.00308108}, {399,0.00314414}, {400,0.00300000}, {401,0.00307207}, {402,0.00309009}, {403,0.00310811}, {404,0.00305405}, {405,0.00316216}, {406,0.00317117}, {407,0.00342342}, {408,0.00311712}, {409,0.00326126}, {410,0.00332432}, {411,0.00360360}, {412,0.00339640}, {413,0.00361261}, {414,0.00367568}, {415,0.00378378}, {416,0.00315315}, {417,0.00328829}, {418,0.00337838}, {419,0.00362162}, {420,0.00347748}, {421,0.00364865}, {422,0.00366667}, {423,0.00388288}, {424,0.00359459}, {425,0.00372973}, {426,0.00383784}, {427,0.00392793}, {428,0.00387387}, {429,0.00394595}, {430,0.00405405}, {431,0.00400000}, {432,0.00379279}, {433,0.00391892}, {434,0.00394595}, {435,0.00404505}, {436,0.00397297}, {437,0.00400000}, {438,0.00400000}, {439,0.00400000}, {440,0.00399099}, {441,0.00400000}, {442,0.00400000}, {443,0.00400000}, {444,0.00400000}, {445,0.00400000}, {446,0.00405405}, {447,0.00400000}, {448,0.00392793}, {449,0.00405405}, {450,0.00400000}, {451,0.00400000}, {452,0.00400000}, {453,0.00400000}, {454,0.00400000}, {455,0.00400000}, {456,0.00400000}, {457,0.00400000}, {458,0.00405405}, {459,0.00400000}, {460,0.00400000}, {461,0.00400000}, {462,0.00400000}, {463,0.00400000}, {464,0.00400000}, {465,0.00400000}, {466,0.00400000}, {467,0.00400000}, {468,0.00400000}, {469,0.00400000}, {470,0.00400000}, {471,0.00400000}, {472,0.00400000}, {473,0.00400000}, {474,0.00400000}, {475,0.00400000}, {476,0.00400000}, {477,0.00778378}, {478,0.00400000}, {479,0.00401802}, {480,0.00400000}, {481,0.00400000}, {482,0.00400000}, {483,0.00400000}, {484,0.00400000}, {485,0.00400000}, {486,0.00400000}, {487,0.00401802}, {488,0.00400000}, {489,0.00400000}, {490,0.00400000}, {491,0.00408108}, {492,0.00400901}, {493,0.00400000}, {494,0.00400901}, {495,0.00405405}, {496,0.00400000}, {497,0.00401802}, {498,0.00771171}, {499,0.00409009}, {500,0.00400901}, {505,0.00411712}, {510,0.00435135}, {515,0.00409910}, {520,0.00404505}, {525,0.00462162}, {530,0.00440541}, {535,0.00483784}, {540,0.00482883}, {545,0.00775676}, {550,0.00799099}, {555,0.00500000}, {560,0.00503604}, {565,0.00500000}, {570,0.00500901}, {575,0.00502703}, {580,0.00500000}, {585,0.00500000}, {590,0.00500901}, {595,0.00500000}, {600,0.00501802}, {605,0.00507207}, {610,0.00501802}, {615,0.00901802}, {620,0.00521622}, {625,0.00525225}, {630,0.00553153}, {635,0.00576577}, {640,0.00508108}, {645,0.00885586}, {650,0.00569369}, {655,0.00593694}, {660,0.00579279}, {665,0.00596396}, {670,0.00607207}, {675,0.00600000}, {680,0.00606306}, {685,0.00601802}, {690,0.00600000}, {695,0.00601802}, {700,0.00602703}, {705,0.00960360}, {710,0.00603604}, {715,0.00608108}, {720,0.00604505}, {725,0.00624324}, {730,0.00629730}, {735,0.00671171}, {740,0.00645045}, {745,0.00659459}, {750,0.00680180}, {755,0.00694595}, {760,0.00680180}, {765,0.00698198}, {770,0.00663964}, {775,0.00696396}, {780,0.00695495}, {785,0.00692793}, {790,0.00706306}, {795,0.00694595}, {800,0.01137838}, {805,0.00704505}, {810,0.00704505}, {815,0.00725225}, {820,0.01048649}, {825,0.01045045}, {830,0.00759459}, {835,0.00726126}, {840,0.00721622}, {845,0.00761261}, {850,0.00745946}, {855,0.00778378}, {860,0.00778378}, {865,0.00774775}, {870,0.00782883}, {875,0.00795495}, {880,0.00781081}, {885,0.00807207}, {890,0.00800000}, {895,0.00814414}, {900,0.00791892}, {905,0.00800000}, {910,0.00803604}, {915,0.00806306}, {920,0.00804505}, {925,0.00834234}, {930,0.00805405}, {935,0.01172973}, {940,0.00829730}, {945,0.00839640}, {950,0.00867568}, {955,0.00888288}, {960,0.00818018}, {965,0.00868468}, {970,0.00867568}, {975,0.00900000}, {980,0.00881081}, {985,0.00895495}, {990,0.00900901}, {995,0.00898198}, {1000,0.01245045}, {1010,0.00906306}, {1020,0.00923423}, {1030,0.00907207}, {1040,0.00913514}, {1050,0.00943750}, {1060,0.00936364}, {1070,0.00981818}, {1080,0.00975455}, {1090,0.00973636}, {1100,0.00996364}, {1110,0.01005455}, {1120,0.01344545}, {1130,0.01023636}, {1140,0.01026364}, {1150,0.01069091}, {1160,0.01348182}, {1170,0.01049091}, {1180,0.01073636}, {1190,0.01380909}, {1200,0.01077273}, {1210,0.01111818}, {1220,0.01096364}, {1230,0.01477273}, {1240,0.01121818}, {1250,0.01138182}, {1260,0.01165455}, {1270,0.01180000}, {1280,0.01121818}, {1290,0.01175455}, {1300,0.01175455}, {1310,0.01210000}, {1320,0.01190000}, {1330,0.01213636}, {1340,0.01244545}, {1350,0.01235455}, {1360,0.01223636}, {1370,0.01275455}, {1380,0.01270000}, {1390,0.01303636}, {1400,0.01295455}, {1410,0.01274545}, {1420,0.01294545}, {1430,0.01681818}, {1440,0.01300000}, {1450,0.01341818}, {1460,0.01210909}, {1470,0.01396364}, {1480,0.01346364}, {1490,0.01382727}, {1500,0.01399091}, {1510,0.01747273}, {1520,0.01400000}, {1530,0.01446364}, {1540,0.01389091}, {1550,0.01437273}, {1560,0.01427273}, {1570,0.01435455}, {1580,0.01469091}, {1590,0.01490909}, {1600,0.03013636}, {1610,0.01778182}, {1620,0.01780909}, {1630,0.01814545}, {1640,0.01516364}, {1650,0.01550000}, {1660,0.01570909}, {1670,0.01549091}, {1680,0.01529091}, {1690,0.01578182}, {1700,0.01570000}, {1710,0.01890000}, {1720,0.01602727}, {1730,0.01907273}, {1740,0.01622727}, {1750,0.01970000}, {1760,0.01626364}, {1770,0.01681818}, {1780,0.01690000}, {1790,0.01746364}, {1800,0.01654545}, {1810,0.01681818}, {1820,0.01728182}, {1830,0.01725455}, {1840,0.01716364}, {1850,0.01766364}, {1860,0.01724545}, {1870,0.01783636}, {1880,0.01770909}, {1890,0.01782727}, {1900,0.01802727}, {1910,0.01847273}, {1920,0.01973636}, {1930,0.01825455}, {1940,0.01835455}, {1950,0.01879091}, {1960,0.01853636}, {1970,0.01884545}, {1980,0.02331818}, {1990,0.01894545}, {2000,0.02160000}, {2050,0.01892727}, {2100,0.02249091}, {2150,0.02061818}, {2200,0.02305455}, {2250,0.02158182}, {2300,0.02268182}, {2350,0.02305455}, {2400,0.02299091}, {2450,0.02386364}, {2500,0.02433636}, {2550,0.02207273}, {2600,0.02857273}, {2650,0.02655455}, {2700,0.02665455}, {2750,0.03023636}, {2800,0.02807273}, {2850,0.02842727}, {2900,0.03187273}, {2950,0.03253636}, {3000,0.03120909}, {3050,0.03174545}, {3100,0.03104545}, {3150,0.03328182}, {3200,0.03279091}, {3250,0.03621818}, {3300,0.03363636}, {3350,0.03440909}, {3400,0.03433636}, {3450,0.03603636}, {3500,0.03660909}, {3550,0.03772727}, {3600,0.03914545}, {3650,0.03753636}, {3700,0.04013636}, {3750,0.03944545}, {3800,0.04032727}, {3850,0.04129091}, {3900,0.04223636}, {3950,0.04339091}, {4000,0.04196364}, {4050,0.04479091}, {4100,0.05990909}, {4150,0.04609091}, {4200,0.04763636}, {4250,0.06749091}, {4300,0.04846364}, {4350,0.05063636}, {4400,0.04863636}, {4450,0.04769091}, {4500,0.04950000}, {4550,0.05328182}, {4600,0.06021818}, {4650,0.05317273}, {4700,0.05388182}, {4750,0.05558182}, {4800,0.05527273}, {4850,0.06260000}, {4900,0.05740909}, {4950,0.04633636}, {5000,0.05912727}, {5050,0.06147273}, {5100,0.05776364}, {5150,0.08709091}, {5200,0.06608182}, {5250,0.06031818}, {5300,0.06442727}, {5350,0.06501818}, {5400,0.06269091}, {5450,0.07032727}, {5500,0.07087273}, {5550,0.06686364}, {5600,0.08177273}, {5650,0.06402727}, {5700,0.06980909}, {5750,0.06632727}, {5800,0.07930000}, {5850,0.06447273}, {5900,0.08393636}, {5950,0.06962727}, {6000,0.08445455}, {6050,0.09450}, {6100,0.08350}, {6150,0.07850}, {6200,0.08700}, {6250,0.08025}, {6300,0.07875}, {6350,0.07625}, {6400,0.07975}, {6450,0.08800}, {6500,0.07750}, {6550,0.07875}, {6600,0.08050}, {6650,0.10000}, {6700,0.08025}, {6750,0.08150}, {6800,0.08900}, {6850,0.08950}, {6900,0.09425}, {6950,0.08600}, {7000,0.09350}, {7050,0.09150}, {7100,0.08800}, {7150,0.08800}, {7200,0.08475}, {7250,0.09300}, {7300,0.08550}, {7350,0.09425}, {7400,0.10425}, {7450,0.09575}, {7500,0.09225}, {7550,0.10700}, {7600,0.09450}, {7650,0.09450}, {7700,0.10075}, {7750,0.09950}, {7800,0.11150}, {7850,0.09800}, {7900,0.11150}, {7950,0.10100}, {8000,0.10100}, {8050,0.10600}, {8100,0.09875}, {8150,0.11025}, {8200,0.10075}, {8250,0.10625}, {8300,0.10825}, {8350,0.11325}, {8400,0.08550}, {8450,0.10100}, {8500,0.10100}, {8550,0.09425}, {8600,0.11025}, {8650,0.11450}, {8700,0.10700}, {8750,0.11525}, {8800,0.11075}, {8850,0.11525}, {8900,0.11525}, {8950,0.11450}, {9000,0.10575}, {9050,0.10900}, {9100,0.12375}, {9150,0.12050}, {9200,0.10475}, {9250,0.11550}, {9300,0.11975}, {9350,0.11925}, {9400,0.11850}, {9450,0.10725}, {9500,0.10625}, {9550,0.10575}, {9600,0.12125}, {9650,0.10800}, {9700,0.11475}, {9750,0.11600}, {9800,0.11450}, {9850,0.13000}, {9900,0.12700}, {9950,0.12500}, {10000,0.11600}, {10100,0.12325}, {10200,0.11275}, {10300,0.12975}, {10400,0.12750}, {10500,0.11200}, {10600,0.11800}, {10700,0.13250}, {10800,0.10450}, {10900,0.13800}, {11000,0.13000}, {11100,0.14675}, {11200,0.13100}, {11300,0.14150}, {11400,0.12150}, {11500,0.14325}, {11600,0.12400}, {11700,0.13075}, {11800,0.13550}, {11900,0.14825}, {12000,0.13500}, {12100,0.14075}, {12200,0.14950}, {12300,0.14525}, {12400,0.13025}, {12500,0.14025}, {12600,0.16675}, {12700,0.16900}, {12800,0.15600}, {12900,0.15800}, {13000,0.15500}, {13100,0.16275}, {13200,0.16375}, {13300,0.15475}, {13400,0.15250}, {13500,0.15725}, {13600,0.15975}, {13700,0.17000}, {13800,0.17625}, {13900,0.16900}, {14000,0.18225}, {14100,0.15975}, {14200,0.20050}, {14300,0.17275}, {14400,0.17775}, {14500,0.17450}, {14600,0.18075}, {14700,0.18950}, {14800,0.20450}, {14900,0.18800}, {15000,0.20800}, {15100,0.16950}, {15200,0.19475}, {15300,0.18525}, {15400,0.20175}, {15500,0.18225}, {15600,0.21975}, {15700,0.18625}, {15800,0.20050}, {15900,0.21850}, {16000,0.18150}, {16100,0.19450}, {16200,0.20050}, {16300,0.23200}, {16400,0.20500}, {16500,0.19425}, {16600,0.20975}, {16700,0.21025}, {16800,0.18925}, {16900,0.19500}, {17000,0.22600}, {17100,0.20375}, {17200,0.20150}, {17300,0.23650}, {17400,0.25325}, {17500,0.20700}, {17600,0.20000}, {17700,0.20650}, {17800,0.21325}, {17900,0.23650}, {18000,0.22100}, {18100,0.22125}, {18200,0.24025}, {18300,0.21850}, {18400,0.23025}, {18500,0.21550}, {18600,0.19575}, {18700,0.23750}, {18800,0.25300}, {18900,0.23925}, {19000,0.20925}, {19100,0.23625}, {19200,0.25175}, {19300,0.25350}, {19400,0.23850}, {19500,0.25250}, {19600,0.22575}, {19700,0.25475}, {19800,0.24800}, {19900,0.25525}, {20000,0.2100}};
data["big_flat"]["CanonicalStructuresHOAS"]["pre"]["user"] = {{1,0.00041441}, {2,0.00045045}, {3,0.00045045}, {4,0.00040541}, {5,0.00063964}, {6,0.00037838}, {7,0.00042342}, {8,0.00038739}, {9,0.00049550}, {10,0.00028829}, {11,0.00043243}, {12,0.00049550}, {13,0.00042342}, {14,0.01680180}, {15,0.00034234}, {16,0.00045045}, {17,0.00060360}, {18,0.00051351}, {19,0.00053153}, {20,0.00060360}, {21,0.00063063}, {22,0.00055856}, {23,0.00061261}, {24,0.00077477}, {25,0.00072973}, {26,0.00073874}, {27,0.00052252}, {28,0.00058559}, {29,0.00050450}, {30,0.00051351}, {31,0.00067568}, {32,0.00056757}, {33,0.00079279}, {34,0.00067568}, {35,0.00039640}, {36,0.00053153}, {37,0.00050450}, {38,0.00054054}, {39,0.00057658}, {40,0.00073874}, {41,0.00044144}, {42,0.00060360}, {43,0.00065766}, {44,0.00060360}, {45,0.00060360}, {46,0.00063063}, {47,0.00074775}, {48,0.00054955}, {49,0.00062162}, {50,0.00071171}, {51,0.00067568}, {52,0.00066667}, {53,0.00054955}, {54,0.00065766}, {55,0.00141441}, {56,0.00080180}, {57,0.00095495}, {58,0.00072973}, {59,0.00096396}, {60,0.00063964}, {61,0.00081081}, {62,0.00056757}, {63,0.00063063}, {64,0.00057658}, {65,0.00075676}, {66,0.00070270}, {67,0.00086486}, {68,0.00082883}, {69,0.00098198}, {70,0.00073874}, {71,0.00090090}, {72,0.00071171}, {73,0.00082883}, {74,0.00093694}, {75,0.00102703}, {76,0.00065766}, {77,0.00086486}, {78,0.00105405}, {79,0.00103604}, {80,0.00066667}, {81,0.00091892}, {82,0.00087387}, {83,0.00087387}, {84,0.00075676}, {85,0.00133333}, {86,0.00072072}, {87,0.00136937}, {88,0.00068468}, {89,0.00119820}, {90,0.00092793}, {91,0.00091892}, {92,0.00088288}, {93,0.00105405}, {94,0.00094595}, {95,0.00102703}, {96,0.00090090}, {97,0.00104505}, {98,0.00090090}, {99,0.00131532}, {100,0.00134234}, {101,0.00054955}, {102,0.00117117}, {103,0.00128829}, {104,0.00095495}, {105,0.00118018}, {106,0.00084685}, {107,0.00106306}, {108,0.00116216}, {109,0.00109009}, {110,0.00107207}, {111,0.00103604}, {112,0.00108108}, {113,0.00101802}, {114,0.00138739}, {115,0.00112613}, {116,0.00103604}, {117,0.00101802}, {118,0.00107207}, {119,0.00123423}, {120,0.00105405}, {121,0.00107207}, {122,0.00125225}, {123,0.00158559}, {124,0.00107207}, {125,0.00134234}, {126,0.00120721}, {127,0.00109009}, {128,0.00109910}, {129,0.00127027}, {130,0.00094595}, {131,0.00102703}, {132,0.00142342}, {133,0.00122523}, {134,0.00150450}, {135,0.00111712}, {136,0.00154955}, {137,0.00110811}, {138,0.00119820}, {139,0.00122523}, {140,0.00139640}, {141,0.00116216}, {142,0.00143243}, {143,0.00124324}, {144,0.00123423}, {145,0.00126126}, {146,0.00138739}, {147,0.00136937}, {148,0.00137838}, {149,0.00140541}, {150,0.00154054}, {151,0.00134234}, {152,0.00201802}, {153,0.00140541}, {154,0.00110811}, {155,0.00146847}, {156,0.00131532}, {157,0.00142342}, {158,0.00153153}, {159,0.00135135}, {160,0.00130631}, {161,0.00159459}, {162,0.00146847}, {163,0.00134234}, {164,0.00148649}, {165,0.00154955}, {166,0.00169369}, {167,0.00147748}, {168,0.00128829}, {169,0.00135135}, {170,0.00144144}, {171,0.00139640}, {172,0.00148649}, {173,0.00122523}, {174,0.00164865}, {175,0.00292793}, {176,0.00136937}, {177,0.00147748}, {178,0.00160360}, {179,0.00151351}, {180,0.00142342}, {181,0.00155856}, {182,0.00153153}, {183,0.00149550}, {184,0.00169369}, {185,0.00198198}, {186,0.00167568}, {187,0.00181982}, {188,0.00172973}, {189,0.00181081}, {190,0.00174775}, {191,0.00163964}, {192,0.00164865}, {193,0.00162162}, {194,0.00179279}, {195,0.00195495}, {196,0.00138739}, {197,0.00181081}, {198,0.00154054}, {199,0.00154955}, {200,0.00168468}, {201,0.00172973}, {202,0.00179279}, {203,0.00158559}, {204,0.00169369}, {205,0.00163964}, {206,0.00196396}, {207,0.00204505}, {208,0.00181982}, {209,0.00176577}, {210,0.00190090}, {211,0.00196396}, {212,0.00218018}, {213,0.00181982}, {214,0.00179279}, {215,0.00180180}, {216,0.00190991}, {217,0.00181081}, {218,0.00209009}, {219,0.00190991}, {220,0.00180180}, {221,0.00203604}, {222,0.00187387}, {223,0.00193694}, {224,0.00212613}, {225,0.00187387}, {226,0.00218018}, {227,0.00179279}, {228,0.00213514}, {229,0.00200000}, {230,0.00233333}, {231,0.00211712}, {232,0.00275676}, {233,0.00189189}, {234,0.00192793}, {235,0.00215315}, {236,0.00227027}, {237,0.00209009}, {238,0.00204505}, {239,0.00203604}, {240,0.00289189}, {241,0.00219820}, {242,0.00218919}, {243,0.00208108}, {244,0.00198198}, {245,0.00220721}, {246,0.00234234}, {247,0.00209009}, {248,0.00213514}, {249,0.00221622}, {250,0.00244144}, {251,0.00250450}, {252,0.00210811}, {253,0.00220721}, {254,0.00217117}, {255,0.00235135}, {256,0.00209009}, {257,0.00215315}, {258,0.00213514}, {259,0.00218018}, {260,0.00229730}, {261,0.00236937}, {262,0.00232432}, {263,0.00208108}, {264,0.00208108}, {265,0.00224324}, {266,0.00245946}, {267,0.00236937}, {268,0.00205405}, {269,0.00228829}, {270,0.00235135}, {271,0.00242342}, {272,0.00259459}, {273,0.00206306}, {274,0.00221622}, {275,0.00199099}, {276,0.00245045}, {277,0.00248649}, {278,0.00203604}, {279,0.00268468}, {280,0.00231532}, {281,0.00221622}, {282,0.00218018}, {283,0.00210811}, {284,0.00245946}, {285,0.00233333}, {286,0.00227928}, {287,0.00247748}, {288,0.00245946}, {289,0.00228829}, {290,0.00239640}, {291,0.00346847}, {292,0.00236937}, {293,0.00236937}, {294,0.00247748}, {295,0.00245946}, {296,0.00231532}, {297,0.00253153}, {298,0.00255856}, {299,0.00243243}, {300,0.00257658}, {301,0.00261261}, {302,0.00229730}, {303,0.00232432}, {304,0.00248649}, {305,0.00246847}, {306,0.00241441}, {307,0.00274775}, {308,0.00244144}, {309,0.00283784}, {310,0.00253153}, {311,0.00274775}, {312,0.00288288}, {313,0.00245946}, {314,0.00256757}, {315,0.00255856}, {316,0.00279279}, {317,0.00262162}, {318,0.00245045}, {319,0.00265766}, {320,0.00253153}, {321,0.00265766}, {322,0.00240541}, {323,0.00257658}, {324,0.00271171}, {325,0.00254955}, {326,0.00273874}, {327,0.00281982}, {328,0.00267568}, {329,0.00246847}, {330,0.00268468}, {331,0.00288288}, {332,0.00269369}, {333,0.00270270}, {334,0.00275676}, {335,0.00271171}, {336,0.00263063}, {337,0.00270270}, {338,0.00281081}, {339,0.00290090}, {340,0.00265766}, {341,0.00295495}, {342,0.00298198}, {343,0.00299099}, {344,0.00263063}, {345,0.00288288}, {346,0.00263964}, {347,0.00386486}, {348,0.00270270}, {349,0.00286486}, {350,0.00303604}, {351,0.00299099}, {352,0.00270270}, {353,0.00288288}, {354,0.00295495}, {355,0.00312613}, {356,0.00301802}, {357,0.00412613}, {358,0.00301802}, {359,0.00305405}, {360,0.00385586}, {361,0.00266667}, {362,0.00283784}, {363,0.00386486}, {364,0.00312613}, {365,0.00318018}, {366,0.00293694}, {367,0.00307207}, {368,0.00295495}, {369,0.00297297}, {370,0.00303604}, {371,0.00298198}, {372,0.00300901}, {373,0.00296396}, {374,0.00368468}, {375,0.00327027}, {376,0.00316216}, {377,0.00318018}, {378,0.00306306}, {379,0.00305405}, {380,0.00312613}, {381,0.00310811}, {382,0.00309009}, {383,0.00322523}, {384,0.00281982}, {385,0.00318919}, {386,0.00306306}, {387,0.00304505}, {388,0.00306306}, {389,0.00303604}, {390,0.00299099}, {391,0.00328829}, {392,0.00309009}, {393,0.00304505}, {394,0.00318018}, {395,0.00318919}, {396,0.00313514}, {397,0.00321622}, {398,0.00319820}, {399,0.00317117}, {400,0.00303604}, {401,0.00306306}, {402,0.00321622}, {403,0.00336937}, {404,0.00330631}, {405,0.00339640}, {406,0.00327027}, {407,0.00313514}, {408,0.00322523}, {409,0.00330631}, {410,0.00329730}, {411,0.00323423}, {412,0.00345946}, {413,0.00324324}, {414,0.00327027}, {415,0.00349550}, {416,0.00318018}, {417,0.00332432}, {418,0.00339640}, {419,0.00348649}, {420,0.00343243}, {421,0.00324324}, {422,0.00335135}, {423,0.00335135}, {424,0.00333333}, {425,0.00343243}, {426,0.00338739}, {427,0.00344144}, {428,0.00342342}, {429,0.00363063}, {430,0.00368468}, {431,0.00345946}, {432,0.00339640}, {433,0.00348649}, {434,0.00342342}, {435,0.00380180}, {436,0.00363964}, {437,0.00336036}, {438,0.00370270}, {439,0.00361261}, {440,0.00338739}, {441,0.00345045}, {442,0.00341441}, {443,0.00370270}, {444,0.00368468}, {445,0.00403604}, {446,0.00369369}, {447,0.00381081}, {448,0.00351351}, {449,0.00358559}, {450,0.00348649}, {451,0.00372973}, {452,0.00356757}, {453,0.00362162}, {454,0.00350450}, {455,0.00362162}, {456,0.00390991}, {457,0.00387387}, {458,0.00372973}, {459,0.00365766}, {460,0.00389189}, {461,0.00373874}, {462,0.00379279}, {463,0.00373874}, {464,0.00354054}, {465,0.00368468}, {466,0.00383784}, {467,0.00390991}, {468,0.00369369}, {469,0.00420721}, {470,0.00402703}, {471,0.00419820}, {472,0.00400000}, {473,0.00414414}, {474,0.00409009}, {475,0.00413514}, {476,0.00377477}, {477,0.00768468}, {478,0.00400000}, {479,0.00415315}, {480,0.00382883}, {481,0.00389189}, {482,0.00367568}, {483,0.00401802}, {484,0.00404505}, {485,0.00363063}, {486,0.00393694}, {487,0.00390090}, {488,0.00390090}, {489,0.00396396}, {490,0.00422523}, {491,0.00424324}, {492,0.00414414}, {493,0.00402703}, {494,0.00421622}, {495,0.00430631}, {496,0.00402703}, {497,0.00387387}, {498,0.00774775}, {499,0.00415315}, {500,0.00413514}, {505,0.00429730}, {510,0.00475676}, {515,0.00457658}, {520,0.00418018}, {525,0.00476577}, {530,0.00418018}, {535,0.00468468}, {540,0.00446847}, {545,0.00796396}, {550,0.00816216}, {555,0.00489189}, {560,0.00468468}, {565,0.00463063}, {570,0.00488288}, {575,0.00447748}, {580,0.00485586}, {585,0.00527928}, {590,0.00530631}, {595,0.00522523}, {600,0.00466667}, {605,0.00557658}, {610,0.00470270}, {615,0.00942342}, {620,0.00554054}, {625,0.00497297}, {630,0.00537838}, {635,0.00572072}, {640,0.00554955}, {645,0.00907207}, {650,0.00579279}, {655,0.00563063}, {660,0.00536036}, {665,0.00591892}, {670,0.00579279}, {675,0.00596396}, {680,0.00590991}, {685,0.00586486}, {690,0.00581081}, {695,0.00636937}, {700,0.00612613}, {705,0.01017117}, {710,0.00651351}, {715,0.00665766}, {720,0.00600901}, {725,0.00642342}, {730,0.00661261}, {735,0.00655856}, {740,0.00651351}, {745,0.00669369}, {750,0.00666667}, {755,0.00703604}, {760,0.00675676}, {765,0.00698198}, {770,0.00652252}, {775,0.00692793}, {780,0.00671171}, {785,0.00728829}, {790,0.00692793}, {795,0.00690090}, {800,0.01180180}, {805,0.00719820}, {810,0.00742342}, {815,0.00736036}, {820,0.01096396}, {825,0.01049550}, {830,0.00773874}, {835,0.00743243}, {840,0.00740541}, {845,0.00766667}, {850,0.00757658}, {855,0.00781982}, {860,0.00787387}, {865,0.00782883}, {870,0.00787387}, {875,0.00823423}, {880,0.00790991}, {885,0.00815315}, {890,0.00803604}, {895,0.00837838}, {900,0.00790090}, {905,0.00818018}, {910,0.00826126}, {915,0.00810811}, {920,0.00811712}, {925,0.00827928}, {930,0.00834234}, {935,0.01211712}, {940,0.00845045}, {945,0.00872973}, {950,0.00881081}, {955,0.00933333}, {960,0.00870270}, {965,0.00873874}, {970,0.00904505}, {975,0.00937838}, {980,0.00875676}, {985,0.00901802}, {990,0.00941441}, {995,0.00906306}, {1000,0.01254955}, {1010,0.00938739}, {1020,0.00956757}, {1030,0.00927027}, {1040,0.00947748}, {1050,0.00955357}, {1060,0.00996364}, {1070,0.01003636}, {1080,0.01000909}, {1090,0.00981818}, {1100,0.01017273}, {1110,0.01055455}, {1120,0.01352727}, {1130,0.01089091}, {1140,0.01061818}, {1150,0.01112727}, {1160,0.01370000}, {1170,0.01098182}, {1180,0.01129091}, {1190,0.01388182}, {1200,0.01100000}, {1210,0.01146364}, {1220,0.01135455}, {1230,0.01474545}, {1240,0.01173636}, {1250,0.01177273}, {1260,0.01213636}, {1270,0.01236364}, {1280,0.01171818}, {1290,0.01199091}, {1300,0.01213636}, {1310,0.01246364}, {1320,0.01226364}, {1330,0.01244545}, {1340,0.01287273}, {1350,0.01300000}, {1360,0.01273636}, {1370,0.01333636}, {1380,0.01300000}, {1390,0.01320000}, {1400,0.01358182}, {1410,0.01310909}, {1420,0.01336364}, {1430,0.01709091}, {1440,0.01349091}, {1450,0.01353636}, {1460,0.01264545}, {1470,0.01398182}, {1480,0.01398182}, {1490,0.01391818}, {1500,0.01418182}, {1510,0.01700909}, {1520,0.01406364}, {1530,0.01447273}, {1540,0.01432727}, {1550,0.01447273}, {1560,0.01440909}, {1570,0.01450909}, {1580,0.01475455}, {1590,0.01497273}, {1600,0.03060000}, {1610,0.01754545}, {1620,0.01744545}, {1630,0.01815455}, {1640,0.01533636}, {1650,0.01570000}, {1660,0.01601818}, {1670,0.01550000}, {1680,0.01554545}, {1690,0.01591818}, {1700,0.01570000}, {1710,0.01877273}, {1720,0.01600909}, {1730,0.01880000}, {1740,0.01636364}, {1750,0.01952727}, {1760,0.01638182}, {1770,0.01642727}, {1780,0.01671818}, {1790,0.01723636}, {1800,0.01626364}, {1810,0.01673636}, {1820,0.01724545}, {1830,0.01744545}, {1840,0.01733636}, {1850,0.01753636}, {1860,0.01736364}, {1870,0.01803636}, {1880,0.01790000}, {1890,0.01762727}, {1900,0.01783636}, {1910,0.01835455}, {1920,0.01924545}, {1930,0.01804545}, {1940,0.01820909}, {1950,0.01854545}, {1960,0.01843636}, {1970,0.01869091}, {1980,0.02373636}, {1990,0.01885455}, {2000,0.02162727}, {2050,0.01902727}, {2100,0.02299091}, {2150,0.02020909}, {2200,0.02352727}, {2250,0.02181818}, {2300,0.02272727}, {2350,0.02341818}, {2400,0.02356364}, {2450,0.02434545}, {2500,0.02459091}, {2550,0.02266364}, {2600,0.02838182}, {2650,0.02671818}, {2700,0.02689091}, {2750,0.03009091}, {2800,0.02820000}, {2850,0.02856364}, {2900,0.03176364}, {2950,0.03236364}, {3000,0.03120000}, {3050,0.03149091}, {3100,0.03079091}, {3150,0.03390000}, {3200,0.03274545}, {3250,0.03645455}, {3300,0.03399091}, {3350,0.03445455}, {3400,0.03466364}, {3450,0.03630909}, {3500,0.03696364}, {3550,0.03798182}, {3600,0.03950909}, {3650,0.03781818}, {3700,0.04017273}, {3750,0.03960909}, {3800,0.04020909}, {3850,0.04152727}, {3900,0.04201818}, {3950,0.04353636}, {4000,0.04180909}, {4050,0.04479091}, {4100,0.05974545}, {4150,0.04620909}, {4200,0.04812727}, {4250,0.06760909}, {4300,0.04844545}, {4350,0.05078182}, {4400,0.04876364}, {4450,0.04799091}, {4500,0.04953636}, {4550,0.05368182}, {4600,0.05993636}, {4650,0.05348182}, {4700,0.05431818}, {4750,0.05599091}, {4800,0.05559091}, {4850,0.06249091}, {4900,0.05767273}, {4950,0.04676364}, {5000,0.05921818}, {5050,0.06168182}, {5100,0.05758182}, {5150,0.08718182}, {5200,0.06629091}, {5250,0.06030000}, {5300,0.06447273}, {5350,0.06494545}, {5400,0.06283636}, {5450,0.07020909}, {5500,0.07070909}, {5550,0.06681818}, {5600,0.08195455}, {5650,0.06434545}, {5700,0.06978182}, {5750,0.06649091}, {5800,0.07944545}, {5850,0.06460000}, {5900,0.08390000}, {5950,0.06951818}, {6000,0.08434545}, {6050,0.09375}, {6100,0.08375}, {6150,0.07800}, {6200,0.08950}, {6250,0.07975}, {6300,0.07850}, {6350,0.07550}, {6400,0.07750}, {6450,0.08675}, {6500,0.07775}, {6550,0.08000}, {6600,0.08050}, {6650,0.09925}, {6700,0.08000}, {6750,0.08150}, {6800,0.08850}, {6850,0.08850}, {6900,0.09450}, {6950,0.08625}, {7000,0.09325}, {7050,0.09025}, {7100,0.08850}, {7150,0.08750}, {7200,0.08475}, {7250,0.09375}, {7300,0.08475}, {7350,0.09375}, {7400,0.10350}, {7450,0.09550}, {7500,0.09275}, {7550,0.10850}, {7600,0.09450}, {7650,0.09475}, {7700,0.10150}, {7750,0.10000}, {7800,0.11225}, {7850,0.09750}, {7900,0.11050}, {7950,0.10100}, {8000,0.10000}, {8050,0.10550}, {8100,0.09750}, {8150,0.11050}, {8200,0.10075}, {8250,0.10675}, {8300,0.10875}, {8350,0.11325}, {8400,0.08675}, {8450,0.09950}, {8500,0.10200}, {8550,0.09425}, {8600,0.10975}, {8650,0.11225}, {8700,0.10675}, {8750,0.11450}, {8800,0.11000}, {8850,0.11550}, {8900,0.11550}, {8950,0.11475}, {9000,0.10525}, {9050,0.10975}, {9100,0.12350}, {9150,0.12075}, {9200,0.10400}, {9250,0.11450}, {9300,0.12075}, {9350,0.11950}, {9400,0.11750}, {9450,0.10750}, {9500,0.10550}, {9550,0.10550}, {9600,0.12200}, {9650,0.10750}, {9700,0.11450}, {9750,0.11675}, {9800,0.11475}, {9850,0.12925}, {9900,0.12700}, {9950,0.12475}, {10000,0.11575}, {10100,0.12375}, {10200,0.11300}, {10300,0.13075}, {10400,0.12675}, {10500,0.11125}, {10600,0.11850}, {10700,0.13275}, {10800,0.10425}, {10900,0.13850}, {11000,0.12950}, {11100,0.14725}, {11200,0.13150}, {11300,0.14250}, {11400,0.12175}, {11500,0.14375}, {11600,0.12500}, {11700,0.13050}, {11800,0.13475}, {11900,0.14750}, {12000,0.13500}, {12100,0.14150}, {12200,0.14925}, {12300,0.14475}, {12400,0.12825}, {12500,0.14050}, {12600,0.16525}, {12700,0.16925}, {12800,0.15575}, {12900,0.15850}, {13000,0.15525}, {13100,0.16350}, {13200,0.16300}, {13300,0.15475}, {13400,0.15300}, {13500,0.15675}, {13600,0.15975}, {13700,0.16900}, {13800,0.17475}, {13900,0.16950}, {14000,0.18250}, {14100,0.15925}, {14200,0.19925}, {14300,0.17275}, {14400,0.17650}, {14500,0.17475}, {14600,0.18125}, {14700,0.18825}, {14800,0.20450}, {14900,0.18750}, {15000,0.20750}, {15100,0.16875}, {15200,0.19425}, {15300,0.18550}, {15400,0.20225}, {15500,0.18125}, {15600,0.21950}, {15700,0.18475}, {15800,0.20125}, {15900,0.21725}, {16000,0.18150}, {16100,0.19475}, {16200,0.20075}, {16300,0.23275}, {16400,0.20525}, {16500,0.19325}, {16600,0.21075}, {16700,0.20825}, {16800,0.18950}, {16900,0.19325}, {17000,0.22650}, {17100,0.20300}, {17200,0.20275}, {17300,0.23675}, {17400,0.25375}, {17500,0.20800}, {17600,0.19975}, {17700,0.20650}, {17800,0.21375}, {17900,0.23675}, {18000,0.22150}, {18100,0.22075}, {18200,0.24150}, {18300,0.21825}, {18400,0.23025}, {18500,0.21550}, {18600,0.19650}, {18700,0.23725}, {18800,0.25275}, {18900,0.23950}, {19000,0.20950}, {19100,0.23550}, {19200,0.25275}, {19300,0.25450}, {19400,0.23825}, {19500,0.25150}, {19600,0.22625}, {19700,0.25450}, {19800,0.24800}, {19900,0.25575}, {20000,0.2095}};
data["big_flat"]["CanonicalStructuresHOAS"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003604}, {4,0.00000000}, {5,0.00003604}, {6,0.00003604}, {7,0.00000000}, {8,0.00003604}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00025225}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00003604}, {23,0.00000000}, {24,0.00003604}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00003604}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00003604}, {34,0.00000000}, {35,0.00003604}, {36,0.00003604}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003604}, {42,0.00000000}, {43,0.00000000}, {44,0.00003604}, {45,0.00002703}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00007207}, {54,0.00003604}, {55,0.00000000}, {56,0.00003604}, {57,0.00000000}, {58,0.00003604}, {59,0.00003604}, {60,0.00000000}, {61,0.00000000}, {62,0.00002703}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00007207}, {68,0.00000000}, {69,0.00003604}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00010811}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00003604}, {79,0.00000000}, {80,0.00000000}, {81,0.00003604}, {82,0.00006306}, {83,0.00003604}, {84,0.00003604}, {85,0.00007207}, {86,0.00000000}, {87,0.00000000}, {88,0.00007207}, {89,0.00007207}, {90,0.00003604}, {91,0.00000000}, {92,0.00000000}, {93,0.00003604}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00007207}, {101,0.00000000}, {102,0.00000000}, {103,0.00003604}, {104,0.00003604}, {105,0.00006306}, {106,0.00000000}, {107,0.00003604}, {108,0.00000000}, {109,0.00003604}, {110,0.00003604}, {111,0.00000000}, {112,0.00007207}, {113,0.00000000}, {114,0.00002703}, {115,0.00000000}, {116,0.00003604}, {117,0.00000000}, {118,0.00000000}, {119,0.00006306}, {120,0.00000000}, {121,0.00000000}, {122,0.00003604}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00003604}, {129,0.00000000}, {130,0.00000000}, {131,0.00003604}, {132,0.00007207}, {133,0.00007207}, {134,0.00007207}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00003604}, {142,0.00003604}, {143,0.00003604}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00003604}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00007207}, {155,0.00000000}, {156,0.00003604}, {157,0.00000000}, {158,0.00000000}, {159,0.00003604}, {160,0.00007207}, {161,0.00000000}, {162,0.00003604}, {163,0.00007207}, {164,0.00003604}, {165,0.00000000}, {166,0.00000000}, {167,0.00003604}, {168,0.00003604}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00007207}, {175,0.00003604}, {176,0.00002703}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00003604}, {182,0.00000000}, {183,0.00000000}, {184,0.00003604}, {185,0.00003604}, {186,0.00000000}, {187,0.00003604}, {188,0.00000000}, {189,0.00000000}, {190,0.00003604}, {191,0.00003604}, {192,0.00006306}, {193,0.00000000}, {194,0.00000000}, {195,0.00003604}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00003604}, {203,0.00000000}, {204,0.00003604}, {205,0.00002703}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00007207}, {214,0.00003604}, {215,0.00003604}, {216,0.00009910}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00003604}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00003604}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00003604}, {233,0.00000000}, {234,0.00000000}, {235,0.00007207}, {236,0.00000000}, {237,0.00003604}, {238,0.00003604}, {239,0.00000000}, {240,0.00003604}, {241,0.00000000}, {242,0.00003604}, {243,0.00000000}, {244,0.00000000}, {245,0.00007207}, {246,0.00000000}, {247,0.00003604}, {248,0.00000000}, {249,0.00003604}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00003604}, {255,0.00000000}, {256,0.00003604}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00003604}, {261,0.00003604}, {262,0.00010811}, {263,0.00000000}, {264,0.00007207}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00003604}, {269,0.00003604}, {270,0.00003604}, {271,0.00000000}, {272,0.00000000}, {273,0.00003604}, {274,0.00000000}, {275,0.00007207}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00003604}, {281,0.00000000}, {282,0.00003604}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00003604}, {287,0.00000000}, {288,0.00003604}, {289,0.00003604}, {290,0.00000000}, {291,0.00000000}, {292,0.00007207}, {293,0.00000000}, {294,0.00000000}, {295,0.00003604}, {296,0.00000000}, {297,0.00003604}, {298,0.00003604}, {299,0.00000000}, {300,0.00003604}, {301,0.00000000}, {302,0.00003604}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00003604}, {309,0.00000000}, {310,0.00003604}, {311,0.00007207}, {312,0.00002703}, {313,0.00000000}, {314,0.00003604}, {315,0.00003604}, {316,0.00000000}, {317,0.00003604}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00003604}, {322,0.00003604}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00003604}, {330,0.00007207}, {331,0.00000000}, {332,0.00003604}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00002703}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00003604}, {351,0.00000000}, {352,0.00000000}, {353,0.00003604}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00007207}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00003604}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00003604}, {381,0.00000000}, {382,0.00000000}, {383,0.00003604}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00003604}, {394,0.00000000}, {395,0.00003604}, {396,0.00003604}, {397,0.00000000}, {398,0.00000000}, {399,0.00007207}, {400,0.00000000}, {401,0.00000000}, {402,0.00003604}, {403,0.00000000}, {404,0.00003604}, {405,0.00000000}, {406,0.00000000}, {407,0.00003604}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00003604}, {412,0.00000000}, {413,0.00003604}, {414,0.00010811}, {415,0.00000000}, {416,0.00003604}, {417,0.00003604}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00003604}, {423,0.00000000}, {424,0.00000000}, {425,0.00003604}, {426,0.00000000}, {427,0.00000000}, {428,0.00002703}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00002703}, {433,0.00000000}, {434,0.00003604}, {435,0.00007207}, {436,0.00000000}, {437,0.00003604}, {438,0.00003604}, {439,0.00000000}, {440,0.00000000}, {441,0.00007207}, {442,0.00003604}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00003604}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00007207}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00003604}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003604}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00003604}, {475,0.00000000}, {476,0.00000000}, {477,0.00003604}, {478,0.00003604}, {479,0.00000000}, {480,0.00003604}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00003604}, {489,0.00007207}, {490,0.00007207}, {491,0.00000000}, {492,0.00003604}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00003604}, {498,0.00007207}, {499,0.00000000}, {500,0.00002703}, {505,0.00000000}, {510,0.00003604}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00007207}, {540,0.00000000}, {545,0.00010811}, {550,0.00007207}, {555,0.00000000}, {560,0.00000000}, {565,0.00003604}, {570,0.00003604}, {575,0.00003604}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00007207}, {610,0.00003604}, {615,0.00000000}, {620,0.00003604}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00003604}, {645,0.00010811}, {650,0.00000000}, {655,0.00000000}, {660,0.00007207}, {665,0.00000000}, {670,0.00000000}, {675,0.00003604}, {680,0.00000000}, {685,0.00000000}, {690,0.00007207}, {695,0.00000000}, {700,0.00000000}, {705,0.00006306}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00007207}, {730,0.00000000}, {735,0.00003604}, {740,0.00007207}, {745,0.00000000}, {750,0.00000000}, {755,0.00003604}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00007207}, {795,0.00000000}, {800,0.00013514}, {805,0.00003604}, {810,0.00000000}, {815,0.00003604}, {820,0.00010811}, {825,0.00010811}, {830,0.00003604}, {835,0.00000000}, {840,0.00003604}, {845,0.00003604}, {850,0.00003604}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00003604}, {885,0.00000000}, {890,0.00007207}, {895,0.00000000}, {900,0.00000000}, {905,0.00003604}, {910,0.00003604}, {915,0.00003604}, {920,0.00000000}, {925,0.00003604}, {930,0.00003604}, {935,0.00007207}, {940,0.00000000}, {945,0.00003604}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00003604}, {990,0.00000000}, {995,0.00003604}, {1000,0.00003604}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00003571}, {1060,0.00003636}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00003636}, {1110,0.00003636}, {1120,0.00003636}, {1130,0.00003636}, {1140,0.00003636}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00014545}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00007273}, {1240,0.00003636}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00003636}, {1340,0.00003636}, {1350,0.00002727}, {1360,0.00003636}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00003636}, {1420,0.00003636}, {1430,0.00003636}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00014545}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00003636}, {1580,0.00000000}, {1590,0.00003636}, {1600,0.00007273}, {1610,0.00000000}, {1620,0.00003636}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00002727}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00003636}, {1760,0.00003636}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00003636}, {1850,0.00003636}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00003636}, {1890,0.00003636}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00003636}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00003636}, {2350,0.00007273}, {2400,0.00003636}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00003636}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00003636}, {2950,0.00003636}, {3000,0.00003636}, {3050,0.00000000}, {3100,0.00003636}, {3150,0.00007273}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00003636}, {3350,0.00003636}, {3400,0.00003636}, {3450,0.00000000}, {3500,0.00003636}, {3550,0.00003636}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00003636}, {4050,0.00003636}, {4100,0.00010000}, {4150,0.00003636}, {4200,0.00007273}, {4250,0.00007273}, {4300,0.00006364}, {4350,0.00003636}, {4400,0.00000000}, {4450,0.00003636}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00007273}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00003636}, {4800,0.00000000}, {4850,0.00018182}, {4900,0.00003636}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00021818}, {5150,0.00007273}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00003636}, {5400,0.00003636}, {5450,0.00010909}, {5500,0.00010909}, {5550,0.00007273}, {5600,0.00007273}, {5650,0.00003636}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00007273}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00100}, {6300,0.00100}, {6350,0.00075}, {6400,0.00100}, {6450,0.00100}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00100}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00100}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00100}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00100}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00100}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00075}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00100}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresHOAS"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00032432}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00100000}, {16,0.00100000}, {17,0.00109910}, {18,0.00124324}, {19,0.00198198}, {20,0.00200000}, {21,0.00200000}, {22,0.00200000}, {23,0.00200000}, {24,0.00200000}, {25,0.00200000}, {26,0.00200000}, {27,0.00205405}, {28,0.00209910}, {29,0.00215315}, {30,0.00265766}, {31,0.00300000}, {32,0.00300000}, {33,0.00300000}, {34,0.00300000}, {35,0.00300000}, {36,0.00300000}, {37,0.00300000}, {38,0.00308108}, {39,0.00310811}, {40,0.00309910}, {41,0.00331532}, {42,0.00390090}, {43,0.00400000}, {44,0.00400000}, {45,0.00491892}, {46,0.00400000}, {47,0.00400901}, {48,0.00400901}, {49,0.00407207}, {50,0.00517117}, {51,0.00404505}, {52,0.00415315}, {53,0.00471171}, {54,0.00499099}, {55,0.00501802}, {56,0.00500000}, {57,0.00500000}, {58,0.00501802}, {59,0.00503604}, {60,0.00503604}, {61,0.00506306}, {62,0.00514414}, {63,0.00525225}, {64,0.00529730}, {65,0.00588288}, {66,0.00599099}, {67,0.00600000}, {68,0.00602703}, {69,0.00601802}, {70,0.00604505}, {71,0.00782883}, {72,0.00607207}, {73,0.00606306}, {74,0.00613514}, {75,0.00648649}, {76,0.00672072}, {77,0.00698198}, {78,0.00798198}, {79,0.00700901}, {80,0.00702703}, {81,0.00704505}, {82,0.00704505}, {83,0.00705405}, {84,0.00708108}, {85,0.00709910}, {86,0.00736937}, {87,0.00782883}, {88,0.00781081}, {89,0.00800000}, {90,0.00800901}, {91,0.00803604}, {92,0.00800000}, {93,0.00804505}, {94,0.00809009}, {95,0.00807207}, {96,0.00995495}, {97,0.00818018}, {98,0.00843243}, {99,0.00884685}, {100,0.00890090}, {101,0.00903604}, {102,0.00900901}, {103,0.00902703}, {104,0.01064865}, {105,0.00909009}, {106,0.00909910}, {107,0.00917117}, {108,0.00923423}, {109,0.01080180}, {110,0.00987387}, {111,0.01001802}, {112,0.00994595}, {113,0.01005405}, {114,0.01007207}, {115,0.01006306}, {116,0.01100901}, {117,0.01008108}, {118,0.01016216}, {119,0.01032432}, {120,0.01036036}, {121,0.01070270}, {122,0.01090991}, {123,0.01101802}, {124,0.01101802}, {125,0.01106306}, {126,0.01108108}, {127,0.01212613}, {128,0.01109009}, {129,0.01212613}, {130,0.01117117}, {131,0.01248649}, {132,0.01144144}, {133,0.01266667}, {134,0.01202703}, {135,0.01303604}, {136,0.01201802}, {137,0.01303604}, {138,0.01206306}, {139,0.01309910}, {140,0.01209910}, {141,0.01316216}, {142,0.01252252}, {143,0.01287387}, {144,0.01256757}, {145,0.01287387}, {146,0.01302703}, {147,0.01303604}, {148,0.01302703}, {149,0.01308108}, {150,0.01506306}, {151,0.01321622}, {152,0.01318018}, {153,0.01341441}, {154,0.01359459}, {155,0.01389189}, {156,0.01390090}, {157,0.01570270}, {158,0.01406306}, {159,0.01410811}, {160,0.01402703}, {161,0.01409910}, {162,0.01589189}, {163,0.01420721}, {164,0.01425225}, {165,0.01461261}, {166,0.01476577}, {167,0.01640541}, {168,0.01490991}, {169,0.01501802}, {170,0.01508108}, {171,0.01502703}, {172,0.01511712}, {173,0.01517117}, {174,0.01530631}, {175,0.01566667}, {176,0.01529730}, {177,0.01567568}, {178,0.01709910}, {179,0.01601802}, {180,0.01602703}, {181,0.01769369}, {182,0.01615315}, {183,0.01618919}, {184,0.01609910}, {185,0.01627928}, {186,0.01642342}, {187,0.01687387}, {188,0.01677477}, {189,0.01704505}, {190,0.01705405}, {191,0.01831532}, {192,0.01690090}, {193,0.01704505}, {194,0.01709009}, {195,0.01709910}, {196,0.01714414}, {197,0.01728829}, {198,0.01880180}, {199,0.01777477}, {200,0.01754054}, {201,0.01787387}, {202,0.01901802}, {203,0.01803604}, {204,0.01808108}, {205,0.01815315}, {206,0.01925225}, {207,0.01840541}, {208,0.01818018}, {209,0.01838739}, {210,0.01966667}, {211,0.01885586}, {212,0.01881081}, {213,0.01907207}, {214,0.01909910}, {215,0.02007207}, {216,0.01909910}, {217,0.01915315}, {218,0.01933333}, {219,0.01949550}, {220,0.02051351}, {221,0.01981982}, {222,0.02000000}, {223,0.02006306}, {224,0.01979279}, {225,0.02009009}, {226,0.02112613}, {227,0.02013514}, {228,0.02014414}, {229,0.02031532}, {230,0.02036036}, {231,0.02063063}, {232,0.02036937}, {233,0.02220721}, {234,0.02098198}, {235,0.02107207}, {236,0.02102703}, {237,0.02129730}, {238,0.02125225}, {239,0.02154054}, {240,0.02123423}, {241,0.02307207}, {242,0.02372973}, {243,0.02175676}, {244,0.02175676}, {245,0.02203604}, {246,0.02210811}, {247,0.02218919}, {248,0.02213514}, {249,0.02215315}, {250,0.02227928}, {251,0.02262162}, {252,0.02342342}, {253,0.02423423}, {254,0.02424324}, {255,0.02436937}, {256,0.02249550}, {257,0.02272072}, {258,0.02291892}, {259,0.02311712}, {260,0.02306306}, {261,0.02310811}, {262,0.02327027}, {263,0.02349550}, {264,0.02324324}, {265,0.02345045}, {266,0.02370270}, {267,0.02400000}, {268,0.02390090}, {269,0.02414414}, {270,0.02411712}, {271,0.02437838}, {272,0.02413514}, {273,0.02425225}, {274,0.02430631}, {275,0.02462162}, {276,0.02444144}, {277,0.02490991}, {278,0.02493694}, {279,0.02519820}, {280,0.02494595}, {281,0.02509009}, {282,0.02515315}, {283,0.02541441}, {284,0.02535135}, {285,0.02570270}, {286,0.02575676}, {287,0.02724324}, {288,0.02692793}, {289,0.02705405}, {290,0.02714414}, {291,0.02618919}, {292,0.02608108}, {293,0.02624324}, {294,0.02620721}, {295,0.02656757}, {296,0.02621622}, {297,0.02661261}, {298,0.02674775}, {299,0.02704505}, {300,0.02806306}, {301,0.02837838}, {302,0.02720721}, {303,0.02734234}, {304,0.02711712}, {305,0.02730631}, {306,0.02736036}, {307,0.02755856}, {308,0.02887387}, {309,0.02910811}, {310,0.02802703}, {311,0.02812613}, {312,0.02794595}, {313,0.02824324}, {314,0.03200901}, {315,0.03002703}, {316,0.02827928}, {317,0.02863964}, {318,0.02879279}, {319,0.02909910}, {320,0.02946847}, {321,0.02954054}, {322,0.02869369}, {323,0.02894595}, {324,0.02895495}, {325,0.03209910}, {326,0.03027027}, {327,0.02934234}, {328,0.02916216}, {329,0.02940541}, {330,0.03264865}, {331,0.03090090}, {332,0.02972973}, {333,0.03006306}, {334,0.03018919}, {335,0.03145946}, {336,0.03001802}, {337,0.03015315}, {338,0.03026126}, {339,0.03404505}, {340,0.03036937}, {341,0.03069369}, {342,0.03089189}, {343,0.03223423}, {344,0.03078378}, {345,0.03114414}, {346,0.03438739}, {347,0.03128829}, {348,0.03132432}, {349,0.03163063}, {350,0.03519820}, {351,0.03212613}, {352,0.03127027}, {353,0.03507207}, {354,0.03174775}, {355,0.03198198}, {356,0.03515315}, {357,0.03206306}, {358,0.03224324}, {359,0.03242342}, {360,0.03226126}, {361,0.03245045}, {362,0.03265766}, {363,0.03283784}, {364,0.03272973}, {365,0.03620721}, {366,0.03320721}, {367,0.03329730}, {368,0.03638739}, {369,0.03312613}, {370,0.03321622}, {371,0.03712613}, {372,0.03341441}, {373,0.03379279}, {374,0.03387387}, {375,0.03413514}, {376,0.03729730}, {377,0.03420721}, {378,0.03420721}, {379,0.03463063}, {380,0.03431532}, {381,0.03824324}, {382,0.03477477}, {383,0.03838739}, {384,0.03403604}, {385,0.03418919}, {386,0.03552252}, {387,0.03489189}, {388,0.03778378}, {389,0.03503604}, {390,0.03840541}, {391,0.03535135}, {392,0.03497297}, {393,0.03863063}, {394,0.03524324}, {395,0.03891892}, {396,0.03558559}, {397,0.03897297}, {398,0.03592793}, {399,0.03916216}, {400,0.03558559}, {401,0.03892793}, {402,0.03604505}, {403,0.03627928}, {404,0.03633333}, {405,0.03661261}, {406,0.03663063}, {407,0.03700000}, {408,0.03659459}, {409,0.03693694}, {410,0.03711712}, {411,0.04132432}, {412,0.03717117}, {413,0.04046847}, {414,0.03759459}, {415,0.04100000}, {416,0.03697297}, {417,0.04057658}, {418,0.03746847}, {419,0.04109009}, {420,0.03767568}, {421,0.04151351}, {422,0.03812613}, {423,0.03838739}, {424,0.04215315}, {425,0.03840541}, {426,0.04164865}, {427,0.03873874}, {428,0.04200901}, {429,0.03883784}, {430,0.03908108}, {431,0.04255856}, {432,0.03880180}, {433,0.04274775}, {434,0.03926126}, {435,0.03949550}, {436,0.04241441}, {437,0.03969369}, {438,0.03963063}, {439,0.04298198}, {440,0.03971171}, {441,0.04347748}, {442,0.04023423}, {443,0.04045946}, {444,0.04357658}, {445,0.04057658}, {446,0.04064865}, {447,0.04442342}, {448,0.03990991}, {449,0.04037838}, {450,0.04363964}, {451,0.04069369}, {452,0.04062162}, {453,0.04399099}, {454,0.04098198}, {455,0.04138739}, {456,0.04414414}, {457,0.04112613}, {458,0.04122523}, {459,0.04502703}, {460,0.04149550}, {461,0.04178378}, {462,0.04552252}, {463,0.04527928}, {464,0.04154955}, {465,0.04198198}, {466,0.04536036}, {467,0.04238739}, {468,0.04223423}, {469,0.04631532}, {470,0.04574775}, {471,0.04297297}, {472,0.04251351}, {473,0.04627027}, {474,0.04624324}, {475,0.04334234}, {476,0.04313514}, {477,0.04354955}, {478,0.04700901}, {479,0.04700901}, {480,0.04302703}, {481,0.04337838}, {482,0.04710811}, {483,0.04701802}, {484,0.04363063}, {485,0.04396396}, {486,0.04414414}, {487,0.04799099}, {488,0.04694595}, {489,0.04430631}, {490,0.04444144}, {491,0.04475676}, {492,0.04803604}, {493,0.04818018}, {494,0.04777477}, {495,0.04544144}, {496,0.04461261}, {497,0.04498198}, {498,0.04519820}, {499,0.04902703}, {500,0.04837838}, {505,0.04875676}, {510,0.04689189}, {515,0.04636937}, {520,0.04652252}, {525,0.04759459}, {530,0.04790991}, {535,0.04896396}, {540,0.04895495}, {545,0.04900901}, {550,0.04983784}, {555,0.05070270}, {560,0.05035135}, {565,0.05161261}, {570,0.05198198}, {575,0.05319820}, {580,0.05500000}, {585,0.05604505}, {590,0.05710811}, {595,0.05440541}, {600,0.05447748}, {605,0.05809910}, {610,0.05846847}, {615,0.05651351}, {620,0.05654054}, {625,0.05998198}, {630,0.06145946}, {635,0.05873874}, {640,0.06023423}, {645,0.05851351}, {650,0.05919820}, {655,0.06345045}, {660,0.05994595}, {665,0.06365766}, {670,0.06166667}, {675,0.06448649}, {680,0.06185586}, {685,0.06586486}, {690,0.06314414}, {695,0.06755856}, {700,0.06664865}, {705,0.06398198}, {710,0.06769369}, {715,0.06600000}, {720,0.06888288}, {725,0.06950450}, {730,0.06749550}, {735,0.07209910}, {740,0.07078378}, {745,0.07100901}, {750,0.06967568}, {755,0.07009910}, {760,0.07338739}, {765,0.07452252}, {770,0.07254054}, {775,0.07501802}, {780,0.07541441}, {785,0.07176577}, {790,0.07279279}, {795,0.07361261}, {800,0.07245946}, {805,0.07834234}, {810,0.07789189}, {815,0.07957658}, {820,0.07533333}, {825,0.07647748}, {830,0.07764865}, {835,0.07902703}, {840,0.07864865}, {845,0.08044144}, {850,0.08063063}, {855,0.08267568}, {860,0.08304505}, {865,0.07968468}, {870,0.08389189}, {875,0.08445045}, {880,0.08447748}, {885,0.08810811}, {890,0.08555856}, {895,0.08831532}, {900,0.08454054}, {905,0.08603604}, {910,0.08802703}, {915,0.08716216}, {920,0.08795495}, {925,0.09213514}, {930,0.08841441}, {935,0.08760360}, {940,0.08994595}, {945,0.08790090}, {950,0.09169369}, {955,0.09272072}, {960,0.09096396}, {965,0.09170270}, {970,0.09354955}, {975,0.09421622}, {980,0.09382883}, {985,0.09551351}, {990,0.09584685}, {995,0.09511712}, {1000,0.09276577}, {1010,0.09740541}, {1020,0.09849550}, {1030,0.09809009}, {1040,0.09751351}, {1050,0.09983784}, {1060,0.10072727}, {1070,0.10289091}, {1080,0.10310909}, {1090,0.10329091}, {1100,0.10477273}, {1110,0.10684545}, {1120,0.10384545}, {1130,0.10822727}, {1140,0.10866364}, {1150,0.11169091}, {1160,0.10746364}, {1170,0.11071818}, {1180,0.11283636}, {1190,0.11170909}, {1200,0.11334545}, {1210,0.11795455}, {1220,0.11538182}, {1230,0.11630909}, {1240,0.11870000}, {1250,0.12140000}, {1260,0.12210000}, {1270,0.12350000}, {1280,0.11929091}, {1290,0.12130909}, {1300,0.12401818}, {1310,0.12630909}, {1320,0.12506364}, {1330,0.12652727}, {1340,0.12860000}, {1350,0.12826364}, {1360,0.12882727}, {1370,0.13169091}, {1380,0.13291818}, {1390,0.13490000}, {1400,0.13423636}, {1410,0.13282727}, {1420,0.14007273}, {1430,0.13549091}, {1440,0.14406364}, {1450,0.14400909}, {1460,0.13778182}, {1470,0.14289091}, {1480,0.14036364}, {1490,0.14243636}, {1500,0.14596364}, {1510,0.14336364}, {1520,0.14515455}, {1530,0.14855455}, {1540,0.14489091}, {1550,0.14841818}, {1560,0.14780909}, {1570,0.14861818}, {1580,0.15055455}, {1590,0.15156364}, {1600,0.16671818}, {1610,0.16911818}, {1620,0.15192727}, {1630,0.15552727}, {1640,0.15729091}, {1650,0.15951818}, {1660,0.16143636}, {1670,0.15827273}, {1680,0.15780909}, {1690,0.16355455}, {1700,0.16084545}, {1710,0.16229091}, {1720,0.16704545}, {1730,0.16190000}, {1740,0.16729091}, {1750,0.16633636}, {1760,0.16698182}, {1770,0.17043636}, {1780,0.17165455}, {1790,0.17452727}, {1800,0.16981818}, {1810,0.17152727}, {1820,0.17423636}, {1830,0.17505455}, {1840,0.17481818}, {1850,0.17806364}, {1860,0.17641818}, {1870,0.18444545}, {1880,0.17937273}, {1890,0.18040909}, {1900,0.18265455}, {1910,0.18515455}, {1920,0.17900909}, {1930,0.19042727}, {1940,0.19182727}, {1950,0.18877273}, {1960,0.19144545}, {1970,0.18905455}, {1980,0.18919091}, {1990,0.19133636}, {2000,0.18876364}, {2050,0.19290909}, {2100,0.20211818}, {2150,0.20639091}, {2200,0.20777273}, {2250,0.21622727}, {2300,0.22463636}, {2350,0.22765455}, {2400,0.22866364}, {2450,0.24448182}, {2500,0.24003636}, {2550,0.24879091}, {2600,0.24684545}, {2650,0.25730000}, {2700,0.25845455}, {2750,0.26646364}, {2800,0.27054545}, {2850,0.27725455}, {2900,0.27704545}, {2950,0.28198182}, {3000,0.29796364}, {3050,0.30827273}, {3100,0.30018182}, {3150,0.30263636}, {3200,0.29974545}, {3250,0.32018182}, {3300,0.31936364}, {3350,0.33432727}, {3400,0.32680909}, {3450,0.33715455}, {3500,0.35499091}, {3550,0.34590909}, {3600,0.33870000}, {3650,0.34896364}, {3700,0.35650000}, {3750,0.36337273}, {3800,0.37164545}, {3850,0.36839091}, {3900,0.38330909}, {3950,0.39677273}, {4000,0.38205455}, {4050,0.39685455}, {4100,0.38861818}, {4150,0.40777273}, {4200,0.41010909}, {4250,0.41107273}, {4300,0.41550909}, {4350,0.43485455}, {4400,0.42682727}, {4450,0.42970000}, {4500,0.43445455}, {4550,0.44700000}, {4600,0.45360909}, {4650,0.45609091}, {4700,0.46381818}, {4750,0.47320909}, {4800,0.46380909}, {4850,0.47503636}, {4900,0.47857273}, {4950,0.49581818}, {5000,0.48541818}, {5050,0.50104545}, {5100,0.50640909}, {5150,0.50972727}, {5200,0.49639091}, {5250,0.50482727}, {5300,0.52097273}, {5350,0.52907273}, {5400,0.52960000}, {5450,0.52922727}, {5500,0.54341818}, {5550,0.55139091}, {5600,0.53690909}, {5650,0.55047273}, {5700,0.54217273}, {5750,0.56709091}, {5800,0.55426364}, {5850,0.58114545}, {5900,0.56121818}, {5950,0.57567273}, {6000,0.58692727}, {6050,0.58775}, {6100,0.59950}, {6150,0.58975}, {6200,0.60675}, {6250,0.62000}, {6300,0.62025}, {6350,0.62100}, {6400,0.60650}, {6450,0.63450}, {6500,0.63825}, {6550,0.64850}, {6600,0.63950}, {6650,0.66850}, {6700,0.67025}, {6750,0.68025}, {6800,0.65200}, {6850,0.67475}, {6900,0.68050}, {6950,0.67775}, {7000,0.69150}, {7050,0.69175}, {7100,0.70525}, {7150,0.72500}, {7200,0.69775}, {7250,0.71325}, {7300,0.70675}, {7350,0.71975}, {7400,0.73000}, {7450,0.73325}, {7500,0.73525}, {7550,0.76750}, {7600,0.74675}, {7650,0.75475}, {7700,0.75575}, {7750,0.75625}, {7800,0.77175}, {7850,0.78000}, {7900,0.78575}, {7950,0.77950}, {8000,0.77050}, {8050,0.80025}, {8100,0.80525}, {8150,0.80750}, {8200,0.78675}, {8250,0.80500}, {8300,0.81075}, {8350,0.82825}, {8400,0.81400}, {8450,0.81600}, {8500,0.82800}, {8550,0.83375}, {8600,0.83500}, {8650,0.85150}, {8700,0.87250}, {8750,0.85900}, {8800,0.84500}, {8850,0.86125}, {8900,0.86575}, {8950,0.89200}, {9000,0.87275}, {9050,0.89525}, {9100,0.88500}, {9150,0.92050}, {9200,0.89925}, {9250,0.88525}, {9300,0.90925}, {9350,0.90050}, {9400,0.92050}, {9450,0.93725}, {9500,0.92825}, {9550,0.94000}, {9600,0.93175}, {9650,0.94625}, {9700,0.95125}, {9750,0.95250}, {9800,0.94675}, {9850,0.97450}, {9900,0.96750}, {9950,0.99800}, {10000,0.96700}, {10100,0.99450}, {10200,0.99650}, {10300,1.01175}, {10400,0.99350}, {10500,1.00025}, {10600,1.03100}, {10700,1.05925}, {10800,1.03850}, {10900,1.06500}, {11000,1.09350}, {11100,1.09025}, {11200,1.07775}, {11300,1.10650}, {11400,1.10025}, {11500,1.13375}, {11600,1.11475}, {11700,1.14900}, {11800,1.14300}, {11900,1.19375}, {12000,1.18350}, {12100,1.20125}, {12200,1.20425}, {12300,1.18625}, {12400,1.20975}, {12500,1.22050}, {12600,1.24450}, {12700,1.24950}, {12800,1.23300}, {12900,1.26075}, {13000,1.27475}, {13100,1.29075}, {13200,1.30475}, {13300,1.34025}, {13400,1.30825}, {13500,1.34700}, {13600,1.32175}, {13700,1.33500}, {13800,1.38150}, {13900,1.37375}, {14000,1.36100}, {14100,1.37950}, {14200,1.43275}, {14300,1.46225}, {14400,1.38375}, {14500,1.42425}, {14600,1.43975}, {14700,1.48325}, {14800,1.47800}, {14900,1.48075}, {15000,1.48950}, {15100,1.54250}, {15200,1.51375}, {15300,1.53175}, {15400,1.51550}, {15500,1.52825}, {15600,1.56675}, {15700,1.58175}, {15800,1.62625}, {15900,1.58125}, {16000,1.58425}, {16100,1.63475}, {16200,1.63000}, {16300,1.67400}, {16400,1.58725}, {16500,1.63275}, {16600,1.67275}, {16700,1.70500}, {16800,1.66200}, {16900,1.65700}, {17000,1.70075}, {17100,1.70875}, {17200,1.69875}, {17300,1.73050}, {17400,1.80550}, {17500,1.75875}, {17600,1.70525}, {17700,1.75775}, {17800,1.75700}, {17900,1.83175}, {18000,1.80575}, {18100,1.83700}, {18200,1.84900}, {18300,1.88525}, {18400,1.84325}, {18500,1.80800}, {18600,1.85400}, {18700,1.83900}, {18800,1.86450}, {18900,1.88600}, {19000,1.89650}, {19100,1.94225}, {19200,1.85550}, {19300,1.97025}, {19400,1.94825}, {19500,1.96000}, {19600,1.92850}, {19700,2.01475}, {19800,2.01925}, {19900,2.03125}, {20000,1.9505}};
data["big_flat"]["CanonicalStructuresHOAS"]["reif"]["user"] = {{1,0.00036036}, {2,0.00045946}, {3,0.00040541}, {4,0.00040541}, {5,0.00062162}, {6,0.00069369}, {7,0.00072973}, {8,0.00102703}, {9,0.00107207}, {10,0.00109910}, {11,0.00118919}, {12,0.00106306}, {13,0.00112613}, {14,0.00136036}, {15,0.00126126}, {16,0.00171171}, {17,0.00162162}, {18,0.00167568}, {19,0.00163063}, {20,0.00153153}, {21,0.00180180}, {22,0.00193694}, {23,0.00193694}, {24,0.00159459}, {25,0.00207207}, {26,0.00218018}, {27,0.00220721}, {28,0.00218919}, {29,0.00233333}, {30,0.00254054}, {31,0.00256757}, {32,0.00266667}, {33,0.00255856}, {34,0.00296396}, {35,0.00293694}, {36,0.00293694}, {37,0.00325225}, {38,0.00319820}, {39,0.00330631}, {40,0.00327027}, {41,0.00321622}, {42,0.00329730}, {43,0.00342342}, {44,0.00357658}, {45,0.00445946}, {46,0.00395495}, {47,0.00398198}, {48,0.00392793}, {49,0.00413514}, {50,0.00524324}, {51,0.00427027}, {52,0.00420721}, {53,0.00445946}, {54,0.00462162}, {55,0.00457658}, {56,0.00489189}, {57,0.00468468}, {58,0.00488288}, {59,0.00498198}, {60,0.00509009}, {61,0.00509009}, {62,0.00519820}, {63,0.00565766}, {64,0.00532432}, {65,0.00560360}, {66,0.00581982}, {67,0.00570270}, {68,0.00584685}, {69,0.00561261}, {70,0.00611712}, {71,0.00772072}, {72,0.00621622}, {73,0.00625225}, {74,0.00613514}, {75,0.00654955}, {76,0.00694595}, {77,0.00684685}, {78,0.00800901}, {79,0.00695495}, {80,0.00709009}, {81,0.00709009}, {82,0.00748649}, {83,0.00744144}, {84,0.00753153}, {85,0.00763063}, {86,0.00776577}, {87,0.00775676}, {88,0.00769369}, {89,0.00781081}, {90,0.00802703}, {91,0.00808108}, {92,0.00817117}, {93,0.00833333}, {94,0.00820721}, {95,0.00849550}, {96,0.01044144}, {97,0.00874775}, {98,0.00870270}, {99,0.00844144}, {100,0.00878378}, {101,0.00937838}, {102,0.00915315}, {103,0.00897297}, {104,0.01090991}, {105,0.00921622}, {106,0.00985586}, {107,0.00986486}, {108,0.00972973}, {109,0.01108108}, {110,0.00991892}, {111,0.01015315}, {112,0.01011712}, {113,0.01052252}, {114,0.01009009}, {115,0.01027928}, {116,0.01141441}, {117,0.01075676}, {118,0.01042342}, {119,0.01118919}, {120,0.01089189}, {121,0.01098198}, {122,0.01104505}, {123,0.01110811}, {124,0.01123423}, {125,0.01147748}, {126,0.01174775}, {127,0.01236036}, {128,0.01181982}, {129,0.01259459}, {130,0.01160360}, {131,0.01302703}, {132,0.01200901}, {133,0.01272973}, {134,0.01222523}, {135,0.01336036}, {136,0.01215315}, {137,0.01297297}, {138,0.01253153}, {139,0.01333333}, {140,0.01255856}, {141,0.01349550}, {142,0.01273874}, {143,0.01292793}, {144,0.01286486}, {145,0.01310811}, {146,0.01301802}, {147,0.01309009}, {148,0.01310811}, {149,0.01318018}, {150,0.01489189}, {151,0.01371171}, {152,0.01320721}, {153,0.01378378}, {154,0.01385586}, {155,0.01390090}, {156,0.01390090}, {157,0.01542342}, {158,0.01411712}, {159,0.01412613}, {160,0.01405405}, {161,0.01435135}, {162,0.01569369}, {163,0.01447748}, {164,0.01440541}, {165,0.01435135}, {166,0.01463063}, {167,0.01616216}, {168,0.01481982}, {169,0.01502703}, {170,0.01512613}, {171,0.01495495}, {172,0.01492793}, {173,0.01524324}, {174,0.01518919}, {175,0.01535135}, {176,0.01523423}, {177,0.01541441}, {178,0.01696396}, {179,0.01572072}, {180,0.01591892}, {181,0.01783784}, {182,0.01612613}, {183,0.01612613}, {184,0.01590991}, {185,0.01614414}, {186,0.01649550}, {187,0.01653153}, {188,0.01672973}, {189,0.01670270}, {190,0.01672072}, {191,0.01845045}, {192,0.01642342}, {193,0.01681982}, {194,0.01695495}, {195,0.01678378}, {196,0.01777477}, {197,0.01709009}, {198,0.01873874}, {199,0.01780180}, {200,0.01748649}, {201,0.01754054}, {202,0.01878378}, {203,0.01811712}, {204,0.01808108}, {205,0.01836036}, {206,0.01951351}, {207,0.01847748}, {208,0.01849550}, {209,0.01807207}, {210,0.01987387}, {211,0.01900000}, {212,0.01857658}, {213,0.01927928}, {214,0.01905405}, {215,0.02023423}, {216,0.01922523}, {217,0.01947748}, {218,0.01944144}, {219,0.01962162}, {220,0.02119820}, {221,0.01997297}, {222,0.02013514}, {223,0.02018018}, {224,0.01990991}, {225,0.01987387}, {226,0.02106306}, {227,0.02051351}, {228,0.02029730}, {229,0.02066667}, {230,0.02033333}, {231,0.02073874}, {232,0.02092793}, {233,0.02272973}, {234,0.02137838}, {235,0.02092793}, {236,0.02090991}, {237,0.02153153}, {238,0.02133333}, {239,0.02195495}, {240,0.02181081}, {241,0.02338739}, {242,0.02400000}, {243,0.02224324}, {244,0.02209910}, {245,0.02202703}, {246,0.02231532}, {247,0.02265766}, {248,0.02249550}, {249,0.02259459}, {250,0.02283784}, {251,0.02275676}, {252,0.02372973}, {253,0.02454955}, {254,0.02443243}, {255,0.02462162}, {256,0.02307207}, {257,0.02327027}, {258,0.02312613}, {259,0.02360360}, {260,0.02349550}, {261,0.02351351}, {262,0.02362162}, {263,0.02376577}, {264,0.02379279}, {265,0.02400901}, {266,0.02398198}, {267,0.02418018}, {268,0.02435135}, {269,0.02442342}, {270,0.02454955}, {271,0.02472973}, {272,0.02421622}, {273,0.02468468}, {274,0.02465766}, {275,0.02497297}, {276,0.02468468}, {277,0.02492793}, {278,0.02519820}, {279,0.02500000}, {280,0.02525225}, {281,0.02517117}, {282,0.02527027}, {283,0.02572072}, {284,0.02538739}, {285,0.02579279}, {286,0.02572072}, {287,0.02706306}, {288,0.02655856}, {289,0.02705405}, {290,0.02697297}, {291,0.02641441}, {292,0.02583784}, {293,0.02627928}, {294,0.02624324}, {295,0.02665766}, {296,0.02627027}, {297,0.02667568}, {298,0.02659459}, {299,0.02676577}, {300,0.02775676}, {301,0.02832432}, {302,0.02700000}, {303,0.02727027}, {304,0.02680180}, {305,0.02715315}, {306,0.02700901}, {307,0.02738739}, {308,0.02869369}, {309,0.02890090}, {310,0.02772973}, {311,0.02791892}, {312,0.02744144}, {313,0.02811712}, {314,0.03225225}, {315,0.02972973}, {316,0.02803604}, {317,0.02838739}, {318,0.02911712}, {319,0.02940541}, {320,0.02954955}, {321,0.02945045}, {322,0.02879279}, {323,0.02877477}, {324,0.02872072}, {325,0.03218018}, {326,0.03042342}, {327,0.02956757}, {328,0.02910811}, {329,0.02947748}, {330,0.03266667}, {331,0.03085586}, {332,0.02984685}, {333,0.02975676}, {334,0.03037838}, {335,0.03143243}, {336,0.02990090}, {337,0.03024324}, {338,0.03017117}, {339,0.03411712}, {340,0.03042342}, {341,0.03053153}, {342,0.03135135}, {343,0.03225225}, {344,0.03074775}, {345,0.03114414}, {346,0.03462162}, {347,0.03149550}, {348,0.03164865}, {349,0.03173874}, {350,0.03554955}, {351,0.03212613}, {352,0.03133333}, {353,0.03549550}, {354,0.03189189}, {355,0.03196396}, {356,0.03550450}, {357,0.03209910}, {358,0.03227928}, {359,0.03272072}, {360,0.03232432}, {361,0.03287387}, {362,0.03287387}, {363,0.03294595}, {364,0.03276577}, {365,0.03628829}, {366,0.03345946}, {367,0.03363063}, {368,0.03671171}, {369,0.03335135}, {370,0.03349550}, {371,0.03735135}, {372,0.03360360}, {373,0.03386486}, {374,0.03420721}, {375,0.03466667}, {376,0.03767568}, {377,0.03444144}, {378,0.03426126}, {379,0.03504505}, {380,0.03465766}, {381,0.03801802}, {382,0.03465766}, {383,0.03839640}, {384,0.03423423}, {385,0.03480180}, {386,0.03563964}, {387,0.03542342}, {388,0.03779279}, {389,0.03563964}, {390,0.03811712}, {391,0.03565766}, {392,0.03526126}, {393,0.03845946}, {394,0.03554955}, {395,0.03880180}, {396,0.03580180}, {397,0.03883784}, {398,0.03601802}, {399,0.03891892}, {400,0.03568468}, {401,0.03862162}, {402,0.03636937}, {403,0.03674775}, {404,0.03662162}, {405,0.03700901}, {406,0.03710811}, {407,0.03735135}, {408,0.03672973}, {409,0.03731532}, {410,0.03729730}, {411,0.04145946}, {412,0.03754054}, {413,0.04076577}, {414,0.03759459}, {415,0.04075676}, {416,0.03720721}, {417,0.04030631}, {418,0.03737838}, {419,0.04119820}, {420,0.03768468}, {421,0.04160360}, {422,0.03816216}, {423,0.03822523}, {424,0.04229730}, {425,0.03812613}, {426,0.04156757}, {427,0.03832432}, {428,0.04189189}, {429,0.03870270}, {430,0.03847748}, {431,0.04265766}, {432,0.03881081}, {433,0.04284685}, {434,0.03927027}, {435,0.03939640}, {436,0.04231532}, {437,0.03958559}, {438,0.03922523}, {439,0.04253153}, {440,0.03963964}, {441,0.04356757}, {442,0.04002703}, {443,0.04028829}, {444,0.04371171}, {445,0.04029730}, {446,0.04064865}, {447,0.04453153}, {448,0.03949550}, {449,0.04002703}, {450,0.04366667}, {451,0.04048649}, {452,0.04054955}, {453,0.04408108}, {454,0.04090090}, {455,0.04122523}, {456,0.04426126}, {457,0.04076577}, {458,0.04118018}, {459,0.04517117}, {460,0.04139640}, {461,0.04162162}, {462,0.04540541}, {463,0.04556757}, {464,0.04142342}, {465,0.04208108}, {466,0.04598198}, {467,0.04241441}, {468,0.04228829}, {469,0.04595495}, {470,0.04591892}, {471,0.04286486}, {472,0.04234234}, {473,0.04629730}, {474,0.04644144}, {475,0.04334234}, {476,0.04318919}, {477,0.04367568}, {478,0.04718919}, {479,0.04738739}, {480,0.04314414}, {481,0.04363063}, {482,0.04748649}, {483,0.04751351}, {484,0.04378378}, {485,0.04414414}, {486,0.04427928}, {487,0.04822523}, {488,0.04736937}, {489,0.04464865}, {490,0.04468468}, {491,0.04462162}, {492,0.04803604}, {493,0.04854955}, {494,0.04784685}, {495,0.04560360}, {496,0.04472072}, {497,0.04543243}, {498,0.04581081}, {499,0.04909910}, {500,0.04874775}, {505,0.04913514}, {510,0.04672973}, {515,0.04619820}, {520,0.04681081}, {525,0.04801802}, {530,0.04819820}, {535,0.04894595}, {540,0.04918018}, {545,0.04913514}, {550,0.04972072}, {555,0.05060360}, {560,0.05030631}, {565,0.05142342}, {570,0.05166667}, {575,0.05362162}, {580,0.05455856}, {585,0.05569369}, {590,0.05708108}, {595,0.05431532}, {600,0.05459459}, {605,0.05810811}, {610,0.05897297}, {615,0.05652252}, {620,0.05630631}, {625,0.06019820}, {630,0.06166667}, {635,0.05918919}, {640,0.06046847}, {645,0.05888288}, {650,0.05916216}, {655,0.06334234}, {660,0.06025225}, {665,0.06329730}, {670,0.06176577}, {675,0.06412613}, {680,0.06211712}, {685,0.06603604}, {690,0.06301802}, {695,0.06746847}, {700,0.06660360}, {705,0.06344144}, {710,0.06759459}, {715,0.06579279}, {720,0.06925225}, {725,0.06936937}, {730,0.06735135}, {735,0.07240541}, {740,0.07133333}, {745,0.07116216}, {750,0.06990991}, {755,0.07021622}, {760,0.07328829}, {765,0.07413514}, {770,0.07295495}, {775,0.07467568}, {780,0.07521622}, {785,0.07218018}, {790,0.07288288}, {795,0.07370270}, {800,0.07251351}, {805,0.07855856}, {810,0.07764865}, {815,0.07941441}, {820,0.07512613}, {825,0.07619820}, {830,0.07735135}, {835,0.07897297}, {840,0.07830631}, {845,0.08016216}, {850,0.08059459}, {855,0.08295495}, {860,0.08319820}, {865,0.07977477}, {870,0.08438739}, {875,0.08430631}, {880,0.08485586}, {885,0.08756757}, {890,0.08526126}, {895,0.08826126}, {900,0.08469369}, {905,0.08569369}, {910,0.08770270}, {915,0.08672072}, {920,0.08767568}, {925,0.09203604}, {930,0.08827928}, {935,0.08759459}, {940,0.08987387}, {945,0.08746847}, {950,0.09165766}, {955,0.09258559}, {960,0.09053153}, {965,0.09181081}, {970,0.09363063}, {975,0.09420721}, {980,0.09401802}, {985,0.09581982}, {990,0.09587387}, {995,0.09557658}, {1000,0.09319820}, {1010,0.09699099}, {1020,0.09807207}, {1030,0.09772072}, {1040,0.09759459}, {1050,0.09960360}, {1060,0.10039091}, {1070,0.10277273}, {1080,0.10279091}, {1090,0.10338182}, {1100,0.10464545}, {1110,0.10706364}, {1120,0.10388182}, {1130,0.10812727}, {1140,0.10890909}, {1150,0.11130000}, {1160,0.10746364}, {1170,0.11061818}, {1180,0.11280909}, {1190,0.11149091}, {1200,0.11308182}, {1210,0.11778182}, {1220,0.11515455}, {1230,0.11634545}, {1240,0.11883636}, {1250,0.12128182}, {1260,0.12160909}, {1270,0.12337273}, {1280,0.11923636}, {1290,0.12107273}, {1300,0.12383636}, {1310,0.12600000}, {1320,0.12470909}, {1330,0.12630000}, {1340,0.12854545}, {1350,0.12804545}, {1360,0.12860909}, {1370,0.13161818}, {1380,0.13324545}, {1390,0.13508182}, {1400,0.13424545}, {1410,0.13290909}, {1420,0.13949091}, {1430,0.13555455}, {1440,0.14393636}, {1450,0.14383636}, {1460,0.13768182}, {1470,0.14283636}, {1480,0.14012727}, {1490,0.14233636}, {1500,0.14615455}, {1510,0.14334545}, {1520,0.14522727}, {1530,0.14835455}, {1540,0.14508182}, {1550,0.14865455}, {1560,0.14766364}, {1570,0.14859091}, {1580,0.15036364}, {1590,0.15159091}, {1600,0.16653636}, {1610,0.16906364}, {1620,0.15175455}, {1630,0.15553636}, {1640,0.15742727}, {1650,0.15941818}, {1660,0.16125455}, {1670,0.15831818}, {1680,0.15780909}, {1690,0.16344545}, {1700,0.16069091}, {1710,0.16220000}, {1720,0.16702727}, {1730,0.16160000}, {1740,0.16770909}, {1750,0.16668182}, {1760,0.16698182}, {1770,0.17042727}, {1780,0.17161818}, {1790,0.17424545}, {1800,0.17020909}, {1810,0.17150909}, {1820,0.17380000}, {1830,0.17467273}, {1840,0.17439091}, {1850,0.17809091}, {1860,0.17638182}, {1870,0.18418182}, {1880,0.17948182}, {1890,0.18046364}, {1900,0.18280000}, {1910,0.18501818}, {1920,0.17900909}, {1930,0.19040909}, {1940,0.19171818}, {1950,0.18862727}, {1960,0.19170000}, {1970,0.18880000}, {1980,0.18896364}, {1990,0.19105455}, {2000,0.18892727}, {2050,0.19314545}, {2100,0.20208182}, {2150,0.20667273}, {2200,0.20734545}, {2250,0.21600909}, {2300,0.22445455}, {2350,0.22781818}, {2400,0.22885455}, {2450,0.24425455}, {2500,0.24013636}, {2550,0.24866364}, {2600,0.24663636}, {2650,0.25713636}, {2700,0.25828182}, {2750,0.26657273}, {2800,0.27036364}, {2850,0.27701818}, {2900,0.27690000}, {2950,0.28192727}, {3000,0.29792727}, {3050,0.30810000}, {3100,0.30020909}, {3150,0.30242727}, {3200,0.29954545}, {3250,0.32008182}, {3300,0.31910000}, {3350,0.33407273}, {3400,0.32685455}, {3450,0.33730909}, {3500,0.35463636}, {3550,0.34557273}, {3600,0.33851818}, {3650,0.34911818}, {3700,0.35676364}, {3750,0.36320909}, {3800,0.37132727}, {3850,0.36817273}, {3900,0.38276364}, {3950,0.39653636}, {4000,0.38200000}, {4050,0.39647273}, {4100,0.38862727}, {4150,0.40707273}, {4200,0.40967273}, {4250,0.41079091}, {4300,0.41565455}, {4350,0.43443636}, {4400,0.42658182}, {4450,0.42951818}, {4500,0.43434545}, {4550,0.44627273}, {4600,0.45350909}, {4650,0.45573636}, {4700,0.46340909}, {4750,0.47210909}, {4800,0.46334545}, {4850,0.47437273}, {4900,0.47781818}, {4950,0.49548182}, {5000,0.48471818}, {5050,0.50068182}, {5100,0.50604545}, {5150,0.50982727}, {5200,0.49653636}, {5250,0.50470000}, {5300,0.52113636}, {5350,0.52897273}, {5400,0.52931818}, {5450,0.52917273}, {5500,0.54344545}, {5550,0.55085455}, {5600,0.53684545}, {5650,0.55055455}, {5700,0.54234545}, {5750,0.56720909}, {5800,0.55433636}, {5850,0.58118182}, {5900,0.56110909}, {5950,0.57540909}, {6000,0.58704545}, {6050,0.58650}, {6100,0.59750}, {6150,0.58825}, {6200,0.60600}, {6250,0.62075}, {6300,0.61825}, {6350,0.62100}, {6400,0.60575}, {6450,0.63225}, {6500,0.63600}, {6550,0.64725}, {6600,0.63950}, {6650,0.66750}, {6700,0.67150}, {6750,0.67875}, {6800,0.65175}, {6850,0.67275}, {6900,0.68025}, {6950,0.67775}, {7000,0.69025}, {7050,0.69125}, {7100,0.70325}, {7150,0.72575}, {7200,0.69625}, {7250,0.71025}, {7300,0.70650}, {7350,0.71950}, {7400,0.72850}, {7450,0.73175}, {7500,0.73425}, {7550,0.76775}, {7600,0.74650}, {7650,0.75400}, {7700,0.75650}, {7750,0.75425}, {7800,0.77050}, {7850,0.77950}, {7900,0.78425}, {7950,0.77975}, {8000,0.77000}, {8050,0.79925}, {8100,0.80475}, {8150,0.80700}, {8200,0.78525}, {8250,0.80400}, {8300,0.81175}, {8350,0.82850}, {8400,0.81225}, {8450,0.81700}, {8500,0.82750}, {8550,0.83400}, {8600,0.83450}, {8650,0.84925}, {8700,0.87100}, {8750,0.85875}, {8800,0.84325}, {8850,0.86150}, {8900,0.86550}, {8950,0.89225}, {9000,0.87250}, {9050,0.89550}, {9100,0.88600}, {9150,0.92125}, {9200,0.89825}, {9250,0.88475}, {9300,0.90925}, {9350,0.89975}, {9400,0.92025}, {9450,0.93775}, {9500,0.92750}, {9550,0.94075}, {9600,0.93400}, {9650,0.94675}, {9700,0.95050}, {9750,0.95200}, {9800,0.94750}, {9850,0.97475}, {9900,0.96725}, {9950,0.99750}, {10000,0.96625}, {10100,0.99450}, {10200,0.99550}, {10300,1.01175}, {10400,0.99225}, {10500,1.00050}, {10600,1.03075}, {10700,1.06075}, {10800,1.03775}, {10900,1.06550}, {11000,1.09250}, {11100,1.09075}, {11200,1.07800}, {11300,1.10675}, {11400,1.09950}, {11500,1.13450}, {11600,1.11425}, {11700,1.14950}, {11800,1.14250}, {11900,1.19425}, {12000,1.18425}, {12100,1.20125}, {12200,1.20525}, {12300,1.18650}, {12400,1.20750}, {12500,1.21925}, {12600,1.24500}, {12700,1.24850}, {12800,1.23350}, {12900,1.26100}, {13000,1.27400}, {13100,1.29175}, {13200,1.30575}, {13300,1.34075}, {13400,1.30800}, {13500,1.34750}, {13600,1.32050}, {13700,1.33550}, {13800,1.38175}, {13900,1.37350}, {14000,1.36050}, {14100,1.37875}, {14200,1.43150}, {14300,1.46150}, {14400,1.38250}, {14500,1.42300}, {14600,1.43950}, {14700,1.48300}, {14800,1.47775}, {14900,1.48075}, {15000,1.48950}, {15100,1.54050}, {15200,1.51300}, {15300,1.53125}, {15400,1.51600}, {15500,1.52850}, {15600,1.56650}, {15700,1.58125}, {15800,1.62550}, {15900,1.57975}, {16000,1.58400}, {16100,1.63400}, {16200,1.63150}, {16300,1.67325}, {16400,1.58625}, {16500,1.63350}, {16600,1.67250}, {16700,1.70450}, {16800,1.66250}, {16900,1.65625}, {17000,1.69925}, {17100,1.70900}, {17200,1.69950}, {17300,1.72925}, {17400,1.80575}, {17500,1.75900}, {17600,1.70225}, {17700,1.75775}, {17800,1.75850}, {17900,1.83375}, {18000,1.80525}, {18100,1.83625}, {18200,1.84850}, {18300,1.88575}, {18400,1.84400}, {18500,1.80725}, {18600,1.85425}, {18700,1.83850}, {18800,1.86450}, {18900,1.88650}, {19000,1.89650}, {19100,1.94200}, {19200,1.85625}, {19300,1.97025}, {19400,1.94825}, {19500,1.95875}, {19600,1.92750}, {19700,2.01325}, {19800,2.01850}, {19900,2.03100}, {20000,1.9490}};
data["big_flat"]["CanonicalStructuresHOAS"]["reif"]["system"] = {{1,0.00003604}, {2,0.00000000}, {3,0.00000000}, {4,0.00007207}, {5,0.00003604}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00003604}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00010811}, {14,0.00007207}, {15,0.00000000}, {16,0.00003604}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00007207}, {21,0.00007207}, {22,0.00003604}, {23,0.00003604}, {24,0.00003604}, {25,0.00000000}, {26,0.00007207}, {27,0.00003604}, {28,0.00003604}, {29,0.00010811}, {30,0.00003604}, {31,0.00003604}, {32,0.00003604}, {33,0.00007207}, {34,0.00000000}, {35,0.00003604}, {36,0.00007207}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00007207}, {41,0.00006306}, {42,0.00007207}, {43,0.00000000}, {44,0.00002703}, {45,0.00003604}, {46,0.00003604}, {47,0.00000000}, {48,0.00003604}, {49,0.00003604}, {50,0.00003604}, {51,0.00003604}, {52,0.00000000}, {53,0.00003604}, {54,0.00003604}, {55,0.00003604}, {56,0.00000000}, {57,0.00000000}, {58,0.00003604}, {59,0.00003604}, {60,0.00005405}, {61,0.00010811}, {62,0.00003604}, {63,0.00007207}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00009910}, {68,0.00000000}, {69,0.00003604}, {70,0.00003604}, {71,0.00007207}, {72,0.00000000}, {73,0.00003604}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00007207}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00003604}, {85,0.00000000}, {86,0.00003604}, {87,0.00007207}, {88,0.00007207}, {89,0.00003604}, {90,0.00003604}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00003604}, {95,0.00007207}, {96,0.00007207}, {97,0.00000000}, {98,0.00000000}, {99,0.00003604}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003604}, {105,0.00003604}, {106,0.00003604}, {107,0.00000000}, {108,0.00007207}, {109,0.00003604}, {110,0.00000000}, {111,0.00003604}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00007207}, {116,0.00003604}, {117,0.00000000}, {118,0.00010811}, {119,0.00000000}, {120,0.00003604}, {121,0.00000000}, {122,0.00000000}, {123,0.00003604}, {124,0.00000000}, {125,0.00007207}, {126,0.00000000}, {127,0.00003604}, {128,0.00002703}, {129,0.00000000}, {130,0.00007207}, {131,0.00000000}, {132,0.00000000}, {133,0.00007207}, {134,0.00000000}, {135,0.00003604}, {136,0.00003604}, {137,0.00007207}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00007207}, {142,0.00000000}, {143,0.00000000}, {144,0.00010811}, {145,0.00000000}, {146,0.00003604}, {147,0.00000000}, {148,0.00000000}, {149,0.00007207}, {150,0.00007207}, {151,0.00000000}, {152,0.00000000}, {153,0.00007207}, {154,0.00000000}, {155,0.00000000}, {156,0.00003604}, {157,0.00018018}, {158,0.00000000}, {159,0.00000000}, {160,0.00003604}, {161,0.00000000}, {162,0.00006306}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00003604}, {168,0.00003604}, {169,0.00000000}, {170,0.00003604}, {171,0.00000000}, {172,0.00000000}, {173,0.00003604}, {174,0.00003604}, {175,0.00003604}, {176,0.00007207}, {177,0.00000000}, {178,0.00003604}, {179,0.00003604}, {180,0.00000000}, {181,0.00000000}, {182,0.00003604}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00007207}, {190,0.00000000}, {191,0.00003604}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00003604}, {196,0.00000000}, {197,0.00003604}, {198,0.00000000}, {199,0.00000000}, {200,0.00003604}, {201,0.00013514}, {202,0.00000000}, {203,0.00007207}, {204,0.00006306}, {205,0.00000000}, {206,0.00000000}, {207,0.00003604}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00003604}, {212,0.00003604}, {213,0.00000000}, {214,0.00003604}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00007207}, {222,0.00003604}, {223,0.00007207}, {224,0.00007207}, {225,0.00000000}, {226,0.00007207}, {227,0.00000000}, {228,0.00000000}, {229,0.00009910}, {230,0.00000000}, {231,0.00003604}, {232,0.00006306}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00003604}, {238,0.00007207}, {239,0.00007207}, {240,0.00007207}, {241,0.00003604}, {242,0.00000000}, {243,0.00003604}, {244,0.00000000}, {245,0.00007207}, {246,0.00010811}, {247,0.00003604}, {248,0.00003604}, {249,0.00003604}, {250,0.00000000}, {251,0.00003604}, {252,0.00003604}, {253,0.00000000}, {254,0.00007207}, {255,0.00003604}, {256,0.00000000}, {257,0.00000000}, {258,0.00003604}, {259,0.00000000}, {260,0.00003604}, {261,0.00000000}, {262,0.00003604}, {263,0.00003604}, {264,0.00003604}, {265,0.00000000}, {266,0.00006306}, {267,0.00007207}, {268,0.00000000}, {269,0.00000000}, {270,0.00003604}, {271,0.00000000}, {272,0.00000000}, {273,0.00003604}, {274,0.00007207}, {275,0.00007207}, {276,0.00003604}, {277,0.00003604}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003604}, {282,0.00000000}, {283,0.00002703}, {284,0.00003604}, {285,0.00000000}, {286,0.00000000}, {287,0.00003604}, {288,0.00000000}, {289,0.00000000}, {290,0.00003604}, {291,0.00000000}, {292,0.00000000}, {293,0.00007207}, {294,0.00003604}, {295,0.00000000}, {296,0.00003604}, {297,0.00000000}, {298,0.00007207}, {299,0.00014414}, {300,0.00000000}, {301,0.00000000}, {302,0.00007207}, {303,0.00000000}, {304,0.00009910}, {305,0.00003604}, {306,0.00003604}, {307,0.00000000}, {308,0.00000000}, {309,0.00003604}, {310,0.00000000}, {311,0.00000000}, {312,0.00003604}, {313,0.00000000}, {314,0.00000000}, {315,0.00007207}, {316,0.00000000}, {317,0.00010811}, {318,0.00000000}, {319,0.00000000}, {320,0.00003604}, {321,0.00000000}, {322,0.00003604}, {323,0.00010811}, {324,0.00007207}, {325,0.00003604}, {326,0.00000000}, {327,0.00003604}, {328,0.00000000}, {329,0.00003604}, {330,0.00000000}, {331,0.00009910}, {332,0.00000000}, {333,0.00003604}, {334,0.00007207}, {335,0.00007207}, {336,0.00000000}, {337,0.00007207}, {338,0.00000000}, {339,0.00000000}, {340,0.00003604}, {341,0.00000000}, {342,0.00003604}, {343,0.00000000}, {344,0.00003604}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00003604}, {350,0.00000000}, {351,0.00000000}, {352,0.00010811}, {353,0.00000000}, {354,0.00000000}, {355,0.00003604}, {356,0.00000000}, {357,0.00000000}, {358,0.00007207}, {359,0.00003604}, {360,0.00007207}, {361,0.00003604}, {362,0.00003604}, {363,0.00002703}, {364,0.00000000}, {365,0.00007207}, {366,0.00000000}, {367,0.00003604}, {368,0.00000000}, {369,0.00007207}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00003604}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00003604}, {380,0.00000000}, {381,0.00010811}, {382,0.00007207}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00003604}, {388,0.00003604}, {389,0.00000000}, {390,0.00010811}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00007207}, {395,0.00003604}, {396,0.00000000}, {397,0.00006306}, {398,0.00003604}, {399,0.00003604}, {400,0.00000000}, {401,0.00003604}, {402,0.00000000}, {403,0.00000000}, {404,0.00003604}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00003604}, {409,0.00000000}, {410,0.00002703}, {411,0.00007207}, {412,0.00007207}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00003604}, {418,0.00003604}, {419,0.00003604}, {420,0.00000000}, {421,0.00014414}, {422,0.00007207}, {423,0.00003604}, {424,0.00000000}, {425,0.00003604}, {426,0.00003604}, {427,0.00005405}, {428,0.00003604}, {429,0.00000000}, {430,0.00010811}, {431,0.00007207}, {432,0.00000000}, {433,0.00007207}, {434,0.00003604}, {435,0.00003604}, {436,0.00007207}, {437,0.00002703}, {438,0.00003604}, {439,0.00007207}, {440,0.00007207}, {441,0.00007207}, {442,0.00003604}, {443,0.00003604}, {444,0.00003604}, {445,0.00002703}, {446,0.00007207}, {447,0.00006306}, {448,0.00000000}, {449,0.00000000}, {450,0.00013514}, {451,0.00007207}, {452,0.00000000}, {453,0.00003604}, {454,0.00003604}, {455,0.00003604}, {456,0.00003604}, {457,0.00009910}, {458,0.00000000}, {459,0.00003604}, {460,0.00000000}, {461,0.00000000}, {462,0.00003604}, {463,0.00003604}, {464,0.00000000}, {465,0.00003604}, {466,0.00010811}, {467,0.00007207}, {468,0.00007207}, {469,0.00014414}, {470,0.00010811}, {471,0.00007207}, {472,0.00000000}, {473,0.00006306}, {474,0.00010811}, {475,0.00000000}, {476,0.00003604}, {477,0.00000000}, {478,0.00020721}, {479,0.00009910}, {480,0.00003604}, {481,0.00010811}, {482,0.00000000}, {483,0.00024324}, {484,0.00016216}, {485,0.00007207}, {486,0.00003604}, {487,0.00007207}, {488,0.00000000}, {489,0.00000000}, {490,0.00003604}, {491,0.00014414}, {492,0.00007207}, {493,0.00014414}, {494,0.00017117}, {495,0.00003604}, {496,0.00000000}, {497,0.00003604}, {498,0.00000000}, {499,0.00005405}, {500,0.00007207}, {505,0.00018018}, {510,0.00000000}, {515,0.00010811}, {520,0.00007207}, {525,0.00003604}, {530,0.00007207}, {535,0.00003604}, {540,0.00000000}, {545,0.00003604}, {550,0.00000000}, {555,0.00000000}, {560,0.00003604}, {565,0.00014414}, {570,0.00000000}, {575,0.00003604}, {580,0.00018018}, {585,0.00018018}, {590,0.00014414}, {595,0.00007207}, {600,0.00003604}, {605,0.00010811}, {610,0.00014414}, {615,0.00003604}, {620,0.00003604}, {625,0.00010811}, {630,0.00003604}, {635,0.00000000}, {640,0.00007207}, {645,0.00003604}, {650,0.00003604}, {655,0.00007207}, {660,0.00007207}, {665,0.00010811}, {670,0.00000000}, {675,0.00007207}, {680,0.00000000}, {685,0.00007207}, {690,0.00007207}, {695,0.00009910}, {700,0.00007207}, {705,0.00000000}, {710,0.00003604}, {715,0.00003604}, {720,0.00014414}, {725,0.00018018}, {730,0.00000000}, {735,0.00007207}, {740,0.00007207}, {745,0.00000000}, {750,0.00000000}, {755,0.00003604}, {760,0.00000000}, {765,0.00000000}, {770,0.00003604}, {775,0.00003604}, {780,0.00010811}, {785,0.00000000}, {790,0.00007207}, {795,0.00007207}, {800,0.00000000}, {805,0.00003604}, {810,0.00014414}, {815,0.00014414}, {820,0.00000000}, {825,0.00000000}, {830,0.00010811}, {835,0.00006306}, {840,0.00007207}, {845,0.00010811}, {850,0.00007207}, {855,0.00003604}, {860,0.00003604}, {865,0.00003604}, {870,0.00007207}, {875,0.00014414}, {880,0.00003604}, {885,0.00025225}, {890,0.00010811}, {895,0.00007207}, {900,0.00000000}, {905,0.00037838}, {910,0.00003604}, {915,0.00003604}, {920,0.00017117}, {925,0.00010811}, {930,0.00007207}, {935,0.00003604}, {940,0.00010811}, {945,0.00007207}, {950,0.00007207}, {955,0.00010811}, {960,0.00010811}, {965,0.00003604}, {970,0.00003604}, {975,0.00009910}, {980,0.00014414}, {985,0.00009910}, {990,0.00014414}, {995,0.00007207}, {1000,0.00010811}, {1010,0.00025225}, {1020,0.00021622}, {1030,0.00010811}, {1040,0.00014414}, {1050,0.00017117}, {1060,0.00010909}, {1070,0.00007273}, {1080,0.00010909}, {1090,0.00014545}, {1100,0.00014545}, {1110,0.00007273}, {1120,0.00003636}, {1130,0.00007273}, {1140,0.00003636}, {1150,0.00010909}, {1160,0.00018182}, {1170,0.00010909}, {1180,0.00007273}, {1190,0.00003636}, {1200,0.00010909}, {1210,0.00021818}, {1220,0.00007273}, {1230,0.00010909}, {1240,0.00020909}, {1250,0.00017273}, {1260,0.00017273}, {1270,0.00007273}, {1280,0.00014545}, {1290,0.00021818}, {1300,0.00021818}, {1310,0.00014545}, {1320,0.00014545}, {1330,0.00010909}, {1340,0.00003636}, {1350,0.00007273}, {1360,0.00029091}, {1370,0.00017273}, {1380,0.00010909}, {1390,0.00018182}, {1400,0.00018182}, {1410,0.00000000}, {1420,0.00014545}, {1430,0.00018182}, {1440,0.00030909}, {1450,0.00020909}, {1460,0.00007273}, {1470,0.00010909}, {1480,0.00018182}, {1490,0.00018182}, {1500,0.00014545}, {1510,0.00017273}, {1520,0.00000000}, {1530,0.00014545}, {1540,0.00003636}, {1550,0.00000000}, {1560,0.00010909}, {1570,0.00003636}, {1580,0.00003636}, {1590,0.00003636}, {1600,0.00007273}, {1610,0.00010000}, {1620,0.00014545}, {1630,0.00010909}, {1640,0.00003636}, {1650,0.00010000}, {1660,0.00003636}, {1670,0.00007273}, {1680,0.00010000}, {1690,0.00010909}, {1700,0.00007273}, {1710,0.00007273}, {1720,0.00010909}, {1730,0.00003636}, {1740,0.00000000}, {1750,0.00003636}, {1760,0.00003636}, {1770,0.00014545}, {1780,0.00006364}, {1790,0.00007273}, {1800,0.00003636}, {1810,0.00003636}, {1820,0.00007273}, {1830,0.00014545}, {1840,0.00010909}, {1850,0.00003636}, {1860,0.00000000}, {1870,0.00007273}, {1880,0.00013636}, {1890,0.00002727}, {1900,0.00003636}, {1910,0.00002727}, {1920,0.00003636}, {1930,0.00003636}, {1940,0.00010909}, {1950,0.00000000}, {1960,0.00010909}, {1970,0.00010909}, {1980,0.00007273}, {1990,0.00010000}, {2000,0.00003636}, {2050,0.00014545}, {2100,0.00014545}, {2150,0.00007273}, {2200,0.00007273}, {2250,0.00010000}, {2300,0.00013636}, {2350,0.00007273}, {2400,0.00003636}, {2450,0.00000000}, {2500,0.00003636}, {2550,0.00007273}, {2600,0.00000000}, {2650,0.00010909}, {2700,0.00010909}, {2750,0.00000000}, {2800,0.00007273}, {2850,0.00003636}, {2900,0.00003636}, {2950,0.00003636}, {3000,0.00000000}, {3050,0.00014545}, {3100,0.00007273}, {3150,0.00014545}, {3200,0.00007273}, {3250,0.00014545}, {3300,0.00007273}, {3350,0.00000000}, {3400,0.00003636}, {3450,0.00007273}, {3500,0.00007273}, {3550,0.00018182}, {3600,0.00003636}, {3650,0.00003636}, {3700,0.00000000}, {3750,0.00003636}, {3800,0.00003636}, {3850,0.00007273}, {3900,0.00025455}, {3950,0.00003636}, {4000,0.00014545}, {4050,0.00010909}, {4100,0.00007273}, {4150,0.00025455}, {4200,0.00007273}, {4250,0.00003636}, {4300,0.00000000}, {4350,0.00007273}, {4400,0.00007273}, {4450,0.00010909}, {4500,0.00010909}, {4550,0.00014545}, {4600,0.00007273}, {4650,0.00010909}, {4700,0.00010909}, {4750,0.00071818}, {4800,0.00060909}, {4850,0.00032727}, {4900,0.00053636}, {4950,0.00047273}, {5000,0.00036364}, {5050,0.00017273}, {5100,0.00031818}, {5150,0.00025455}, {5200,0.00006364}, {5250,0.00003636}, {5300,0.00007273}, {5350,0.00010909}, {5400,0.00016364}, {5450,0.00010909}, {5500,0.00007273}, {5550,0.00057273}, {5600,0.00010909}, {5650,0.00007273}, {5700,0.00018182}, {5750,0.00000000}, {5800,0.00010909}, {5850,0.00000000}, {5900,0.00014545}, {5950,0.00014545}, {6000,0.00018182}, {6050,0.00100}, {6100,0.00100}, {6150,0.00100}, {6200,0.00000}, {6250,0.00000}, {6300,0.00100}, {6350,0.00000}, {6400,0.00100}, {6450,0.00100}, {6500,0.00100}, {6550,0.00100}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00100}, {6800,0.00100}, {6850,0.00200}, {6900,0.00000}, {6950,0.00000}, {7000,0.00100}, {7050,0.00000}, {7100,0.00100}, {7150,0.00000}, {7200,0.00000}, {7250,0.00200}, {7300,0.00000}, {7350,0.00000}, {7400,0.00100}, {7450,0.00200}, {7500,0.00100}, {7550,0.00000}, {7600,0.00000}, {7650,0.00100}, {7700,0.00000}, {7750,0.00000}, {7800,0.00075}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00100}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00100}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00100}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00100}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00100}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00075}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00100}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00100}, {14700,0.00000}, {14800,0.00100}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00100}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00100}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00100}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00100}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00100}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00100}, {19600,0.00100}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresPHOAS"]["Aggregate"]["real"] = {{1,0.00103604}, {2,0.00200000}, {3,0.00200000}, {4,0.00200000}, {5,0.00224324}, {6,0.00300000}, {7,0.00301802}, {8,0.00300000}, {9,0.00330631}, {10,0.00400000}, {11,0.00400000}, {12,0.00405405}, {13,0.00443243}, {14,0.00499099}, {15,0.00522523}, {16,0.00509009}, {17,0.00556757}, {18,0.00600000}, {19,0.00609910}, {20,0.00609009}, {21,0.00691892}, {22,0.00703604}, {23,0.00721622}, {24,0.00836937}, {25,0.00800000}, {26,0.00805405}, {27,0.00825225}, {28,0.00822523}, {29,0.00906306}, {30,0.00914414}, {31,0.00990991}, {32,0.01058559}, {33,0.01008108}, {34,0.01006306}, {35,0.01081982}, {36,0.01065766}, {37,0.01109910}, {38,0.01136036}, {39,0.01206306}, {40,0.01158559}, {41,0.01210811}, {42,0.01227027}, {43,0.01314414}, {44,0.01308108}, {45,0.01358559}, {46,0.01404505}, {47,0.01461261}, {48,0.01382883}, {49,0.01429730}, {50,0.01468468}, {51,0.01523423}, {52,0.01508108}, {53,0.01600901}, {54,0.01610811}, {55,0.01707207}, {56,0.01613514}, {57,0.01713514}, {58,0.01712613}, {59,0.01909910}, {60,0.01761261}, {61,0.01839640}, {62,0.01884685}, {63,0.02154955}, {64,0.01818018}, {65,0.01905405}, {66,0.01918919}, {67,0.02167568}, {68,0.01982883}, {69,0.02061261}, {70,0.02098198}, {71,0.02200901}, {72,0.02083784}, {73,0.02174775}, {74,0.02345045}, {75,0.02304505}, {76,0.02233333}, {77,0.02347748}, {78,0.02383784}, {79,0.02497297}, {80,0.02297297}, {81,0.02512613}, {82,0.02412613}, {83,0.02525225}, {84,0.02663964}, {85,0.02578378}, {86,0.02613514}, {87,0.02919820}, {88,0.02560360}, {89,0.02689189}, {90,0.02885586}, {91,0.02832432}, {92,0.02760360}, {93,0.03055856}, {94,0.02908108}, {95,0.03050450}, {96,0.02723423}, {97,0.02854955}, {98,0.03038739}, {99,0.03003604}, {100,0.02920721}, {101,0.03198198}, {102,0.03080180}, {103,0.03220721}, {104,0.03027928}, {105,0.03166667}, {106,0.03312613}, {107,0.03336036}, {108,0.03239640}, {109,0.03388288}, {110,0.03414414}, {111,0.03698198}, {112,0.03235135}, {113,0.03566667}, {114,0.03415315}, {115,0.03569369}, {116,0.03459459}, {117,0.03621622}, {118,0.03729730}, {119,0.03825225}, {120,0.03736036}, {121,0.03726126}, {122,0.03912613}, {123,0.03925225}, {124,0.04011712}, {125,0.03984685}, {126,0.04010811}, {127,0.04207207}, {128,0.03646847}, {129,0.03813514}, {130,0.03825225}, {131,0.04013514}, {132,0.03880180}, {133,0.04067568}, {134,0.04100000}, {135,0.04287387}, {136,0.03981081}, {137,0.04181982}, {138,0.04196396}, {139,0.04390090}, {140,0.04228829}, {141,0.04454054}, {142,0.04637838}, {143,0.04697297}, {144,0.04309009}, {145,0.04385586}, {146,0.04551351}, {147,0.04626126}, {148,0.04618018}, {149,0.04669369}, {150,0.04714414}, {151,0.04931532}, {152,0.04572973}, {153,0.04925225}, {154,0.04824324}, {155,0.05172072}, {156,0.04872072}, {157,0.05104505}, {158,0.05255856}, {159,0.05380180}, {160,0.04739640}, {161,0.04857658}, {162,0.04881982}, {163,0.05252252}, {164,0.04917117}, {165,0.05270270}, {166,0.05172973}, {167,0.05436036}, {168,0.05185586}, {169,0.05269369}, {170,0.05368468}, {171,0.05815315}, {172,0.05346847}, {173,0.05701802}, {174,0.05634234}, {175,0.05918919}, {176,0.05355856}, {177,0.05497297}, {178,0.05518018}, {179,0.05917117}, {180,0.05561261}, {181,0.05840541}, {182,0.06004505}, {183,0.06148649}, {184,0.05672072}, {185,0.06061261}, {186,0.06207207}, {187,0.06267568}, {188,0.06091892}, {189,0.06455856}, {190,0.06339640}, {191,0.06652252}, {192,0.05690090}, {193,0.06110811}, {194,0.05833333}, {195,0.06219820}, {196,0.06145946}, {197,0.06182883}, {198,0.06191892}, {199,0.06609910}, {200,0.06232432}, {201,0.06285586}, {202,0.06312613}, {203,0.06736937}, {204,0.06606306}, {205,0.06673874}, {206,0.06709009}, {207,0.07159459}, {208,0.06453153}, {209,0.06501802}, {210,0.06527027}, {211,0.06952252}, {212,0.06727027}, {213,0.07124324}, {214,0.06936937}, {215,0.07279279}, {216,0.06790090}, {217,0.07268468}, {218,0.07261261}, {219,0.07395495}, {220,0.07090090}, {221,0.07460360}, {222,0.07572973}, {223,0.08107207}, {224,0.07009009}, {225,0.06963063}, {226,0.06985586}, {227,0.07437838}, {228,0.07191892}, {229,0.07644144}, {230,0.07717117}, {231,0.07793694}, {232,0.07154955}, {233,0.07497297}, {234,0.07640541}, {235,0.08291892}, {236,0.07939640}, {237,0.08323423}, {238,0.08279279}, {239,0.08393694}, {240,0.07361261}, {241,0.07732432}, {242,0.07754955}, {243,0.08275676}, {244,0.08130631}, {245,0.08477477}, {246,0.08465766}, {247,0.08846847}, {248,0.08131532}, {249,0.08513514}, {250,0.08335135}, {251,0.08745045}, {252,0.08381982}, {253,0.08798198}, {254,0.08824324}, {255,0.09282883}, {256,0.07513514}, {257,0.07970270}, {258,0.08181982}, {259,0.08547748}, {260,0.08220721}, {261,0.08582883}, {262,0.08600901}, {263,0.09011712}, {264,0.08285586}, {265,0.08657658}, {266,0.08699099}, {267,0.09099099}, {268,0.08734234}, {269,0.09169369}, {270,0.09177477}, {271,0.09645045}, {272,0.08490090}, {273,0.08889189}, {274,0.08909009}, {275,0.09343243}, {276,0.08975676}, {277,0.09405405}, {278,0.09447748}, {279,0.09919820}, {280,0.09097297}, {281,0.09547748}, {282,0.09577477}, {283,0.10033333}, {284,0.09626126}, {285,0.10118919}, {286,0.10127027}, {287,0.10364865}, {288,0.08725225}, {289,0.09138739}, {290,0.09152252}, {291,0.09858559}, {292,0.09412613}, {293,0.09851351}, {294,0.09908108}, {295,0.10418018}, {296,0.09551351}, {297,0.10034234}, {298,0.10078378}, {299,0.10301802}, {300,0.09859459}, {301,0.10363063}, {302,0.10549550}, {303,0.11045045}, {304,0.09748649}, {305,0.10244144}, {306,0.10300000}, {307,0.10814414}, {308,0.10092793}, {309,0.10853153}, {310,0.10791892}, {311,0.11332432}, {312,0.10429730}, {313,0.10965766}, {314,0.10722523}, {315,0.11590991}, {316,0.10935135}, {317,0.11474775}, {318,0.11560360}, {319,0.12139640}, {320,0.09650450}, {321,0.10334234}, {322,0.10288288}, {323,0.10827027}, {324,0.10420721}, {325,0.10696396}, {326,0.10954955}, {327,0.11409009}, {328,0.10483784}, {329,0.11047748}, {330,0.10822523}, {331,0.11589189}, {332,0.11042342}, {333,0.11639640}, {334,0.11674775}, {335,0.12249550}, {336,0.10678378}, {337,0.11227928}, {338,0.11251351}, {339,0.11832432}, {340,0.11270270}, {341,0.11904505}, {342,0.11971171}, {343,0.12475676}, {344,0.11372973}, {345,0.12003604}, {346,0.11771171}, {347,0.12536036}, {348,0.12038739}, {349,0.12636937}, {350,0.12664865}, {351,0.13285586}, {352,0.11158559}, {353,0.11882883}, {354,0.11827027}, {355,0.12284685}, {356,0.11586486}, {357,0.12293694}, {358,0.12404505}, {359,0.12783784}, {360,0.11827027}, {361,0.12480180}, {362,0.12284685}, {363,0.13036937}, {364,0.12570270}, {365,0.12948649}, {366,0.13147748}, {367,0.13863964}, {368,0.12143243}, {369,0.12646847}, {370,0.12733333}, {371,0.13341441}, {372,0.12745946}, {373,0.13198198}, {374,0.13345045}, {375,0.14100901}, {376,0.12866667}, {377,0.13466667}, {378,0.13338739}, {379,0.14161261}, {380,0.13573874}, {381,0.14261261}, {382,0.14300000}, {383,0.15005405}, {384,0.11801802}, {385,0.12368468}, {386,0.12393694}, {387,0.12950450}, {388,0.12458559}, {389,0.13031532}, {390,0.13346847}, {391,0.13661261}, {392,0.12571171}, {393,0.13171171}, {394,0.13165766}, {395,0.13815315}, {396,0.13197297}, {397,0.13863964}, {398,0.13875676}, {399,0.14557658}, {400,0.12710811}, {401,0.13416216}, {402,0.13354054}, {403,0.14427027}, {404,0.13422523}, {405,0.14543243}, {406,0.14112613}, {407,0.15391892}, {408,0.13576577}, {409,0.14483784}, {410,0.14336937}, {411,0.15017117}, {412,0.14260360}, {413,0.14982883}, {414,0.15000000}, {415,0.15776577}, {416,0.13179279}, {417,0.13828829}, {418,0.13841441}, {419,0.14509009}, {420,0.13920721}, {421,0.14604505}, {422,0.14954955}, {423,0.15337838}, {424,0.13971171}, {425,0.14669369}, {426,0.14716216}, {427,0.15475676}, {428,0.14781982}, {429,0.15709910}, {430,0.15536036}, {431,0.16339640}, {432,0.14218018}, {433,0.14945946}, {434,0.15155856}, {435,0.15668468}, {436,0.15023423}, {437,0.15739640}, {438,0.15736937}, {439,0.16548649}, {440,0.15089189}, {441,0.15853153}, {442,0.16139640}, {443,0.16661261}, {444,0.15950450}, {445,0.16955856}, {446,0.16721622}, {447,0.17654054}, {448,0.14325225}, {449,0.14778378}, {450,0.14866667}, {451,0.15889189}, {452,0.14840541}, {453,0.15612613}, {454,0.15963964}, {455,0.16379279}, {456,0.15000000}, {457,0.15843243}, {458,0.15707207}, {459,0.16518018}, {460,0.15945946}, {461,0.16558559}, {462,0.16649550}, {463,0.17431532}, {464,0.15703604}, {465,0.15961261}, {466,0.15968468}, {467,0.16944144}, {468,0.15972072}, {469,0.16878378}, {470,0.16845946}, {471,0.17769369}, {472,0.16082883}, {473,0.16953153}, {474,0.16972072}, {475,0.17945946}, {476,0.16961261}, {477,0.17846847}, {478,0.17916216}, {479,0.18827928}, {480,0.15756757}, {481,0.16409910}, {482,0.16480180}, {483,0.17258559}, {484,0.16694595}, {485,0.17293694}, {486,0.17294595}, {487,0.18251351}, {488,0.16563964}, {489,0.17549550}, {490,0.17776577}, {491,0.18478378}, {492,0.17500901}, {493,0.18361261}, {494,0.18373874}, {495,0.19519820}, {496,0.16937838}, {497,0.17616216}, {498,0.17631532}, {499,0.18609910}, {500,0.17732432}, {505,0.18730631}, {510,0.19884685}, {515,0.17553153}, {520,0.16963964}, {525,0.18929730}, {530,0.17862162}, {535,0.19861261}, {540,0.19032432}, {545,0.18277477}, {550,0.19354054}, {555,0.20769369}, {560,0.19095495}, {565,0.20802703}, {570,0.20885586}, {575,0.23312613}, {580,0.19416216}, {585,0.20487387}, {590,0.21689189}, {595,0.21800901}, {600,0.20899099}, {605,0.23215315}, {610,0.21262162}, {615,0.23569369}, {620,0.22601802}, {625,0.22681081}, {630,0.24094595}, {635,0.25361261}, {640,0.20435135}, {645,0.22590090}, {650,0.22695495}, {655,0.25415315}, {660,0.23036937}, {665,0.24620721}, {670,0.25709009}, {675,0.25208108}, {680,0.23655856}, {685,0.26367568}, {690,0.25060360}, {695,0.27876577}, {700,0.26577477}, {705,0.24370270}, {710,0.25901802}, {715,0.27223423}, {720,0.24875676}, {725,0.27667568}, {730,0.27675676}, {735,0.30887387}, {740,0.26705405}, {745,0.28261261}, {750,0.29700000}, {755,0.29682883}, {760,0.28600000}, {765,0.31790991}, {770,0.26155856}, {775,0.28986486}, {780,0.27711712}, {785,0.28114414}, {790,0.29215315}, {795,0.30677477}, {800,0.26750450}, {805,0.29635135}, {810,0.29718018}, {815,0.33055856}, {820,0.29824324}, {825,0.32070270}, {830,0.33686486}, {835,0.30545946}, {840,0.29210811}, {845,0.32400901}, {850,0.30968468}, {855,0.34480180}, {860,0.33715315}, {865,0.31741441}, {870,0.33256757}, {875,0.35181982}, {880,0.32259459}, {885,0.35446847}, {890,0.35613514}, {895,0.39819820}, {900,0.31221622}, {905,0.33008108}, {910,0.34871171}, {915,0.34962162}, {920,0.33433333}, {925,0.37110811}, {930,0.33672072}, {935,0.37415315}, {940,0.35736036}, {945,0.35908108}, {950,0.38372973}, {955,0.40053153}, {960,0.33162162}, {965,0.36552252}, {970,0.36832432}, {975,0.41303604}, {980,0.36968468}, {985,0.38917117}, {990,0.41500901}, {995,0.39376577}, {1000,0.37556757}, {1010,0.39811712}, {1020,0.42437838}, {1030,0.37519820}, {1040,0.35400000}, {1050,0.39533636}, {1060,0.37970909}, {1070,0.42424545}, {1080,0.40520000}, {1090,0.39654545}, {1100,0.41280909}, {1110,0.43639091}, {1120,0.39642727}, {1130,0.44414545}, {1140,0.44592727}, {1150,0.49516364}, {1160,0.41290909}, {1170,0.43532727}, {1180,0.45950000}, {1190,0.46610909}, {1200,0.44415455}, {1210,0.49790909}, {1220,0.45149091}, {1230,0.50472727}, {1240,0.49055455}, {1250,0.48444545}, {1260,0.51334545}, {1270,0.55128182}, {1280,0.43215455}, {1290,0.47986364}, {1300,0.48191818}, {1310,0.53995455}, {1320,0.49134545}, {1330,0.52106364}, {1340,0.55056364}, {1350,0.52667273}, {1360,0.50367273}, {1370,0.56037273}, {1380,0.53409091}, {1390,0.60255455}, {1400,0.56979091}, {1410,0.51944545}, {1420,0.54873636}, {1430,0.58568182}, {1440,0.52824545}, {1450,0.59143636}, {1460,0.59207273}, {1470,0.66541818}, {1480,0.56621818}, {1490,0.61014545}, {1500,0.63997273}, {1510,0.64105455}, {1520,0.61030000}, {1530,0.69355455}, {1540,0.54895455}, {1550,0.61288182}, {1560,0.58416364}, {1570,0.58915455}, {1580,0.62238182}, {1590,0.66069091}, {1600,0.56636364}, {1610,0.63019091}, {1620,0.63240000}, {1630,2.35572727}, {1640,0.65222727}, {1650,0.68610000}, {1660,0.72240000}, {1670,0.65260000}, {1680,0.62960909}, {1690,0.69741818}, {1700,0.66102727}, {1710,0.75297273}, {1720,0.70682727}, {1730,0.67490000}, {1740,0.71215455}, {1750,0.76240909}, {1760,0.68050000}, {1770,0.77024545}, {1780,0.76530909}, {1790,0.86679091}, {1800,0.66453636}, {1810,0.70598182}, {1820,0.75039091}, {1830,0.75210909}, {1840,0.71523636}, {1850,0.80552727}, {1860,0.72838182}, {1870,0.81401818}, {1880,0.76884545}, {1890,0.77145455}, {1900,0.81665455}, {1910,0.87350000}, {1920,0.70097273}, {1930,0.79280909}, {1940,0.79070000}, {1950,0.88074545}, {1960,0.79768182}, {1970,0.84446364}, {1980,0.90679091}, {1990,0.85289091}, {2000,0.81131818}, {2050,0.74886364}, {2100,0.85894545}, {2150,0.92315455}, {2200,0.88720909}, {2250,0.95524545}, {2300,1.10201818}, {2350,1.06719091}, {2400,0.96803636}, {2450,1.03998182}, {2500,1.05038182}, {2550,1.28942727}, {2600,1.05457273}, {2650,1.19523636}, {2700,1.13902727}, {2750,1.39770909}, {2800,1.24595455}, {2850,1.20350909}, {2900,1.30184545}, {2950,1.31586364}, {3000,1.41960000}, {3050,1.51530909}, {3100,1.34080000}, {3150,1.43620000}, {3200,1.21533636}, {3250,1.46998182}, {3300,1.49140909}, {3350,1.50811818}, {3400,1.43869091}, {3450,1.77110909}, {3500,1.66181818}, {3550,1.90141818}, {3600,1.43037273}, {3650,1.53813636}, {3700,1.76992727}, {3750,1.77420000}, {3800,1.79886364}, {3850,1.72857273}, {3900,1.96257273}, {3950,2.10712727}, {4000,1.75105455}, {4050,2.01716364}, {4100,1.62083636}, {4150,1.94571818}, {4200,1.84836364}, {4250,1.98235455}, {4300,2.01971818}, {4350,2.44004545}, {4400,1.93156364}, {4450,2.06637273}, {4500,2.09978182}, {4550,2.23988182}, {4600,2.41489091}, {4650,2.16997273}, {4700,2.29620909}, {4750,2.36388182}, {4800,2.08441818}, {4850,2.55017273}, {4900,2.25417273}, {4950,2.60030909}, {5000,2.28773636}, {5050,2.76591818}, {5100,2.80552727}, {5150,2.58935455}, {5200,2.26180000}, {5250,2.28620000}, {5300,2.60468182}, {5350,2.79009091}, {5400,2.48700000}, {5450,2.63790000}, {5500,2.99627273}, {5550,3.05814545}, {5600,2.65781818}, {5650,2.57764545}, {5700,2.54189091}, {5750,3.08196364}, {5800,2.70279091}, {5850,3.10939091}, {5900,2.74951818}, {5950,3.26562727}, {6000,2.92851818}, {6050,3.05950}, {6100,3.23725}, {6150,2.71100}, {6200,2.88625}, {6250,3.11475}, {6300,3.08575}, {6350,3.27625}, {6400,2.61075}, {6450,3.14375}, {6500,3.15075}, {6550,3.39100}, {6600,3.19850}, {6650,3.88750}, {6700,3.26375}, {6750,3.69475}, {6800,3.09150}, {6850,3.32650}, {6900,3.76675}, {6950,3.58400}, {7000,3.64425}, {7050,3.63000}, {7100,4.08650}, {7150,4.36850}, {7200,3.09025}, {7250,3.55450}, {7300,3.32275}, {7350,3.95800}, {7400,3.82725}, {7450,3.82450}, {7500,3.86150}, {7550,4.70050}, {7600,3.87225}, {7650,4.11225}, {7700,3.68900}, {7750,3.96475}, {7800,4.23375}, {7850,4.20425}, {7900,4.54325}, {7950,4.25400}, {8000,3.74950}, {8050,4.62975}, {8100,4.30925}, {8150,4.83000}, {8200,3.44100}, {8250,4.18325}, {8300,4.15750}, {8350,4.40650}, {8400,3.99900}, {8450,3.74700}, {8500,4.18500}, {8550,4.50775}, {8600,4.21575}, {8650,4.55425}, {8700,5.06950}, {8750,4.61925}, {8800,4.08975}, {8850,4.42725}, {8900,4.39950}, {8950,5.20725}, {9000,4.40375}, {9050,4.95850}, {9100,4.69625}, {9150,5.64725}, {9200,5.02050}, {9250,4.26625}, {9300,4.58675}, {9350,4.51725}, {9400,4.87700}, {9450,5.16150}, {9500,4.82725}, {9550,5.20275}, {9600,4.42825}, {9650,5.18375}, {9700,5.19050}, {9750,4.99000}, {9800,4.70850}, {9850,5.70500}, {9900,5.35625}, {9950,6.08000}, {10000,4.77375}, {10100,5.72650}, {10200,5.77475}, {10300,5.34675}, {10400,4.73300}, {10500,4.73900}, {10600,5.44975}, {10700,5.87475}, {10800,5.20125}, {10900,5.57200}, {11000,6.32150}, {11100,6.31525}, {11200,5.56900}, {11300,5.50750}, {11400,5.42600}, {11500,6.44750}, {11600,5.92200}, {11700,6.69850}, {11800,5.97475}, {11900,7.18450}, {12000,6.35925}, {12100,6.37775}, {12200,6.93600}, {12300,5.76975}, {12400,6.10575}, {12500,6.48075}, {12600,6.52925}, {12700,7.01900}, {12800,5.49050}, {12900,6.68900}, {13000,6.63750}, {13100,7.14675}, {13200,6.76300}, {13300,8.22625}, {13400,6.92775}, {13500,7.90100}, {13600,6.52850}, {13700,7.01850}, {13800,7.99500}, {13900,7.51275}, {14000,7.51375}, {14100,7.68600}, {14200,8.68000}, {14300,9.40650}, {14400,6.58575}, {14500,7.49025}, {14600,7.12225}, {14700,8.65300}, {14800,8.12825}, {14900,8.15425}, {15000,8.17800}, {15100,9.79125}, {15200,8.27725}, {15300,8.86300}, {15400,7.80875}, {15500,8.44250}, {15600,8.84050}, {15700,9.03475}, {15800,9.68075}, {15900,9.12425}, {16000,8.03625}, {16100,9.74100}, {16200,9.18075}, {16300,10.35100}, {16400,7.37575}, {16500,8.98150}, {16600,8.89450}, {16700,9.56225}, {16800,8.41500}, {16900,8.07850}, {17000,9.03900}, {17100,9.83700}, {17200,9.14450}, {17300,9.70775}, {17400,11.21175}, {17500,9.84475}, {17600,8.81775}, {17700,9.40925}, {17800,9.33025}, {17900,11.49650}, {18000,9.56750}, {18100,10.96425}, {18200,10.39075}, {18300,12.28250}, {18400,10.87625}, {18500,9.23125}, {18600,9.87050}, {18700,9.84900}, {18800,10.42075}, {18900,11.14700}, {19000,10.63475}, {19100,11.32125}, {19200,9.49775}, {19300,11.58800}, {19400,11.39875}, {19500,10.89825}, {19600,10.34175}, {19700,12.42650}, {19800,11.75775}, {19900,13.36550}, {20000,10.3390}};
data["big_flat"]["CanonicalStructuresPHOAS"]["Aggregate"]["user"] = {{1,0.00140541}, {2,0.00157658}, {3,0.00220721}, {4,0.00195495}, {5,0.00260360}, {6,0.00232432}, {7,0.00284685}, {8,0.00285586}, {9,0.00318018}, {10,0.00359459}, {11,0.00354054}, {12,0.00406306}, {13,0.00461261}, {14,0.00475676}, {15,0.00518018}, {16,0.00518018}, {17,0.00527928}, {18,0.00533333}, {19,0.00585586}, {20,0.00603604}, {21,0.00670270}, {22,0.00701802}, {23,0.00751351}, {24,0.00868468}, {25,0.00803604}, {26,0.00814414}, {27,0.00881081}, {28,0.00885586}, {29,0.00913514}, {30,0.00943243}, {31,0.00985586}, {32,0.01081081}, {33,0.01030631}, {34,0.01037838}, {35,0.01100000}, {36,0.01087387}, {37,0.01154054}, {38,0.01192793}, {39,0.01236036}, {40,0.01203604}, {41,0.01278378}, {42,0.01283784}, {43,0.01340541}, {44,0.01298198}, {45,0.01374775}, {46,0.01382883}, {47,0.01459459}, {48,0.01356757}, {49,0.01447748}, {50,0.01448649}, {51,0.01536036}, {52,0.01499099}, {53,0.01550450}, {54,0.01563964}, {55,0.01705405}, {56,0.01590090}, {57,0.01686486}, {58,0.01709009}, {59,0.01944144}, {60,0.01741441}, {61,0.01829730}, {62,0.01866667}, {63,0.02150450}, {64,0.01780180}, {65,0.01896396}, {66,0.01934234}, {67,0.02174775}, {68,0.01993694}, {69,0.02097297}, {70,0.02121622}, {71,0.02194595}, {72,0.02111712}, {73,0.02183784}, {74,0.02379279}, {75,0.02321622}, {76,0.02287387}, {77,0.02389189}, {78,0.02393694}, {79,0.02513514}, {80,0.02317117}, {81,0.02546847}, {82,0.02452252}, {83,0.02533333}, {84,0.02634234}, {85,0.02578378}, {86,0.02626126}, {87,0.02893694}, {88,0.02580180}, {89,0.02645946}, {90,0.02836036}, {91,0.02836036}, {92,0.02751351}, {93,0.03040541}, {94,0.02906306}, {95,0.03077477}, {96,0.02718018}, {97,0.02836036}, {98,0.03024324}, {99,0.03000000}, {100,0.02916216}, {101,0.03204505}, {102,0.03061261}, {103,0.03278378}, {104,0.03028829}, {105,0.03187387}, {106,0.03349550}, {107,0.03358559}, {108,0.03238739}, {109,0.03392793}, {110,0.03429730}, {111,0.03699099}, {112,0.03241441}, {113,0.03588288}, {114,0.03418018}, {115,0.03594595}, {116,0.03484685}, {117,0.03654054}, {118,0.03718919}, {119,0.03827027}, {120,0.03728829}, {121,0.03745045}, {122,0.03863063}, {123,0.03921622}, {124,0.03983784}, {125,0.03945045}, {126,0.03986486}, {127,0.04157658}, {128,0.03699099}, {129,0.03793694}, {130,0.03797297}, {131,0.03989189}, {132,0.03862162}, {133,0.04029730}, {134,0.04098198}, {135,0.04300000}, {136,0.03935135}, {137,0.04127928}, {138,0.04151351}, {139,0.04380180}, {140,0.04235135}, {141,0.04463964}, {142,0.04635135}, {143,0.04724324}, {144,0.04327928}, {145,0.04354054}, {146,0.04565766}, {147,0.04654955}, {148,0.04628829}, {149,0.04727027}, {150,0.04739640}, {151,0.04950450}, {152,0.04574775}, {153,0.04910811}, {154,0.04833333}, {155,0.05154054}, {156,0.04893694}, {157,0.05102703}, {158,0.05199099}, {159,0.05354955}, {160,0.04754955}, {161,0.04881982}, {162,0.04879279}, {163,0.05240541}, {164,0.04936937}, {165,0.05250450}, {166,0.05154054}, {167,0.05390991}, {168,0.05149550}, {169,0.05238739}, {170,0.05321622}, {171,0.05815315}, {172,0.05314414}, {173,0.05695495}, {174,0.05628829}, {175,0.05963063}, {176,0.05330631}, {177,0.05479279}, {178,0.05530631}, {179,0.05918018}, {180,0.05525225}, {181,0.05860360}, {182,0.06013514}, {183,0.06154955}, {184,0.05700901}, {185,0.06070270}, {186,0.06191892}, {187,0.06247748}, {188,0.06121622}, {189,0.06454955}, {190,0.06298198}, {191,0.06651351}, {192,0.05683784}, {193,0.06104505}, {194,0.05845045}, {195,0.06172072}, {196,0.06186486}, {197,0.06154955}, {198,0.06173874}, {199,0.06600901}, {200,0.06212613}, {201,0.06247748}, {202,0.06286486}, {203,0.06711712}, {204,0.06598198}, {205,0.06692793}, {206,0.06731532}, {207,0.07190991}, {208,0.06424324}, {209,0.06474775}, {210,0.06518018}, {211,0.07039640}, {212,0.06742342}, {213,0.07139640}, {214,0.06963964}, {215,0.07290991}, {216,0.06784685}, {217,0.07277477}, {218,0.07312613}, {219,0.07366667}, {220,0.07148649}, {221,0.07427928}, {222,0.07550450}, {223,0.08136036}, {224,0.07026126}, {225,0.06995495}, {226,0.06970270}, {227,0.07436937}, {228,0.07190991}, {229,0.07617117}, {230,0.07682883}, {231,0.07784685}, {232,0.07181982}, {233,0.07470270}, {234,0.07605405}, {235,0.08320721}, {236,0.07932432}, {237,0.08355856}, {238,0.08292793}, {239,0.08408108}, {240,0.07363063}, {241,0.07709910}, {242,0.07756757}, {243,0.08293694}, {244,0.08146847}, {245,0.08500000}, {246,0.08466667}, {247,0.08837838}, {248,0.08141441}, {249,0.08532432}, {250,0.08336036}, {251,0.08715315}, {252,0.08422523}, {253,0.08779279}, {254,0.08795495}, {255,0.09293694}, {256,0.07497297}, {257,0.07949550}, {258,0.08194595}, {259,0.08535135}, {260,0.08255856}, {261,0.08589189}, {262,0.08560360}, {263,0.08987387}, {264,0.08327027}, {265,0.08638739}, {266,0.08683784}, {267,0.09087387}, {268,0.08727928}, {269,0.09166667}, {270,0.09177477}, {271,0.09645045}, {272,0.08500000}, {273,0.08886486}, {274,0.08887387}, {275,0.09355856}, {276,0.08936937}, {277,0.09377477}, {278,0.09486486}, {279,0.09873874}, {280,0.09064865}, {281,0.09559459}, {282,0.09580180}, {283,0.10000000}, {284,0.09647748}, {285,0.10061261}, {286,0.10124324}, {287,0.10330631}, {288,0.08718919}, {289,0.09141441}, {290,0.09120721}, {291,0.09826126}, {292,0.09452252}, {293,0.09818018}, {294,0.09893694}, {295,0.10406306}, {296,0.09570270}, {297,0.09988288}, {298,0.10068468}, {299,0.10298198}, {300,0.09839640}, {301,0.10362162}, {302,0.10547748}, {303,0.11023423}, {304,0.09714414}, {305,0.10222523}, {306,0.10298198}, {307,0.10807207}, {308,0.10070270}, {309,0.10859459}, {310,0.10802703}, {311,0.11293694}, {312,0.10420721}, {313,0.10942342}, {314,0.10705405}, {315,0.11565766}, {316,0.10904505}, {317,0.11464865}, {318,0.11598198}, {319,0.12126126}, {320,0.09657658}, {321,0.10327928}, {322,0.10282883}, {323,0.10828829}, {324,0.10426126}, {325,0.10669369}, {326,0.10949550}, {327,0.11381982}, {328,0.10472072}, {329,0.11002703}, {330,0.10818919}, {331,0.11563964}, {332,0.11026126}, {333,0.11644144}, {334,0.11655856}, {335,0.12236937}, {336,0.10681982}, {337,0.11189189}, {338,0.11214414}, {339,0.11845946}, {340,0.11207207}, {341,0.11901802}, {342,0.11976577}, {343,0.12458559}, {344,0.11332432}, {345,0.12012613}, {346,0.11791892}, {347,0.12504505}, {348,0.12037838}, {349,0.12627928}, {350,0.12635135}, {351,0.13292793}, {352,0.11107207}, {353,0.11909009}, {354,0.11832432}, {355,0.12244144}, {356,0.11607207}, {357,0.12277477}, {358,0.12382883}, {359,0.12779279}, {360,0.11833333}, {361,0.12478378}, {362,0.12257658}, {363,0.13024324}, {364,0.12521622}, {365,0.12936937}, {366,0.13132432}, {367,0.13834234}, {368,0.12138739}, {369,0.12631532}, {370,0.12718919}, {371,0.13305405}, {372,0.12747748}, {373,0.13200901}, {374,0.13331532}, {375,0.14133333}, {376,0.12859459}, {377,0.13452252}, {378,0.13331532}, {379,0.14147748}, {380,0.13545045}, {381,0.14251351}, {382,0.14301802}, {383,0.14951351}, {384,0.11771171}, {385,0.12340541}, {386,0.12360360}, {387,0.12943243}, {388,0.12415315}, {389,0.13036937}, {390,0.13320721}, {391,0.13644144}, {392,0.12527027}, {393,0.13185586}, {394,0.13163964}, {395,0.13756757}, {396,0.13202703}, {397,0.13768468}, {398,0.13837838}, {399,0.14528829}, {400,0.12691892}, {401,0.13421622}, {402,0.13338739}, {403,0.14418018}, {404,0.13402703}, {405,0.14518018}, {406,0.14101802}, {407,0.15386486}, {408,0.13537838}, {409,0.14484685}, {410,0.14351351}, {411,0.14960360}, {412,0.14254054}, {413,0.14958559}, {414,0.14957658}, {415,0.15751351}, {416,0.13177477}, {417,0.13800000}, {418,0.13832432}, {419,0.14492793}, {420,0.13894595}, {421,0.14570270}, {422,0.14923423}, {423,0.15313514}, {424,0.13954955}, {425,0.14640541}, {426,0.14700901}, {427,0.15447748}, {428,0.14759459}, {429,0.15709009}, {430,0.15546847}, {431,0.16307207}, {432,0.14209910}, {433,0.14913514}, {434,0.15133333}, {435,0.15673874}, {436,0.14985586}, {437,0.15719820}, {438,0.15728829}, {439,0.16547748}, {440,0.15082883}, {441,0.15820721}, {442,0.16117117}, {443,0.16696396}, {444,0.15919820}, {445,0.16908108}, {446,0.16710811}, {447,0.17668468}, {448,0.14323423}, {449,0.14746847}, {450,0.14847748}, {451,0.15867568}, {452,0.14816216}, {453,0.15644144}, {454,0.15932432}, {455,0.16369369}, {456,0.14967568}, {457,0.15822523}, {458,0.15666667}, {459,0.16516216}, {460,0.15939640}, {461,0.16554054}, {462,0.16655856}, {463,0.17383784}, {464,0.15674775}, {465,0.15886486}, {466,0.15919820}, {467,0.16894595}, {468,0.15943243}, {469,0.16869369}, {470,0.16839640}, {471,0.17754054}, {472,0.16073874}, {473,0.16925225}, {474,0.16929730}, {475,0.17919820}, {476,0.16938739}, {477,0.17823423}, {478,0.17883784}, {479,0.18789189}, {480,0.15701802}, {481,0.16350450}, {482,0.16444144}, {483,0.17186486}, {484,0.16682883}, {485,0.17241441}, {486,0.17244144}, {487,0.18237838}, {488,0.16545045}, {489,0.17506306}, {490,0.17765766}, {491,0.18463964}, {492,0.17461261}, {493,0.18321622}, {494,0.18318919}, {495,0.19524324}, {496,0.16889189}, {497,0.17599099}, {498,0.17628829}, {499,0.18556757}, {500,0.17712613}, {505,0.18668468}, {510,0.19845946}, {515,0.17528829}, {520,0.16943243}, {525,0.18903604}, {530,0.17875676}, {535,0.19824324}, {540,0.19011712}, {545,0.18265766}, {550,0.19345946}, {555,0.20738739}, {560,0.19068468}, {565,0.20740541}, {570,0.20851351}, {575,0.23218919}, {580,0.19387387}, {585,0.20445946}, {590,0.21666667}, {595,0.21749550}, {600,0.20853153}, {605,0.23218919}, {610,0.21245946}, {615,0.23522523}, {620,0.22595495}, {625,0.22634234}, {630,0.24052252}, {635,0.25330631}, {640,0.20412613}, {645,0.22545045}, {650,0.22640541}, {655,0.25448649}, {660,0.23006306}, {665,0.24571171}, {670,0.25691892}, {675,0.25197297}, {680,0.23609910}, {685,0.26333333}, {690,0.25034234}, {695,0.27883784}, {700,0.26572072}, {705,0.24329730}, {710,0.25901802}, {715,0.27171171}, {720,0.24790991}, {725,0.27664865}, {730,0.27658559}, {735,0.30840541}, {740,0.26712613}, {745,0.28245045}, {750,0.29681982}, {755,0.29678378}, {760,0.28580180}, {765,0.31753153}, {770,0.26102703}, {775,0.28950450}, {780,0.27715315}, {785,0.28092793}, {790,0.29154955}, {795,0.30683784}, {800,0.26731532}, {805,0.29586486}, {810,0.29695495}, {815,0.33037838}, {820,0.29800901}, {825,0.31990090}, {830,0.33627928}, {835,0.30511712}, {840,0.29141441}, {845,0.32371171}, {850,0.30925225}, {855,0.34421622}, {860,0.33698198}, {865,0.31734234}, {870,0.33186486}, {875,0.35127027}, {880,0.32229730}, {885,0.35409910}, {890,0.35563964}, {895,0.39815315}, {900,0.31207207}, {905,0.32962162}, {910,0.34858559}, {915,0.34946847}, {920,0.33391892}, {925,0.37069369}, {930,0.33657658}, {935,0.37389189}, {940,0.35698198}, {945,0.35861261}, {950,0.38348649}, {955,0.40018018}, {960,0.33114414}, {965,0.36533333}, {970,0.36806306}, {975,0.41243243}, {980,0.36905405}, {985,0.38886486}, {990,0.41435135}, {995,0.39321622}, {1000,0.37552252}, {1010,0.39765766}, {1020,0.42343243}, {1030,0.37485586}, {1040,0.35354955}, {1050,0.39496364}, {1060,0.37931818}, {1070,0.42364545}, {1080,0.40478182}, {1090,0.39485455}, {1100,0.41228182}, {1110,0.43589091}, {1120,0.39590000}, {1130,0.44366364}, {1140,0.44552727}, {1150,0.49511818}, {1160,0.41264545}, {1170,0.43481818}, {1180,0.45896364}, {1190,0.46565455}, {1200,0.44369091}, {1210,0.49792727}, {1220,0.45088182}, {1230,0.50438182}, {1240,0.48969091}, {1250,0.48369091}, {1260,0.51268182}, {1270,0.55083636}, {1280,0.43156364}, {1290,0.47926364}, {1300,0.48121818}, {1310,0.53922727}, {1320,0.49091818}, {1330,0.52068182}, {1340,0.55027273}, {1350,0.52643636}, {1360,0.50268182}, {1370,0.55995455}, {1380,0.53348182}, {1390,0.60212727}, {1400,0.56963636}, {1410,0.51896364}, {1420,0.54822727}, {1430,0.58487273}, {1440,0.52782727}, {1450,0.59117273}, {1460,0.59203636}, {1470,0.66516364}, {1480,0.56580909}, {1490,0.60978182}, {1500,0.63908182}, {1510,0.64048182}, {1520,0.61012727}, {1530,0.69314545}, {1540,0.54888182}, {1550,0.61263636}, {1560,0.58391818}, {1570,0.58908182}, {1580,0.62190909}, {1590,0.66054545}, {1600,0.56606364}, {1610,0.63022727}, {1620,0.63172727}, {1630,2.35350000}, {1640,0.65196364}, {1650,0.68592727}, {1660,0.72230909}, {1670,0.65231818}, {1680,0.62915455}, {1690,0.69710000}, {1700,0.66071818}, {1710,0.75250909}, {1720,0.70657273}, {1730,0.67446364}, {1740,0.71165455}, {1750,0.76197273}, {1760,0.68035455}, {1770,0.76990909}, {1780,0.76505455}, {1790,0.86632727}, {1800,0.66404545}, {1810,0.70594545}, {1820,0.74992727}, {1830,0.75181818}, {1840,0.71475455}, {1850,0.80494545}, {1860,0.72817273}, {1870,0.81350000}, {1880,0.76848182}, {1890,0.77106364}, {1900,0.81612727}, {1910,0.87325455}, {1920,0.70088182}, {1930,0.79240909}, {1940,0.79065455}, {1950,0.88045455}, {1960,0.79743636}, {1970,0.84411818}, {1980,0.90626364}, {1990,0.85236364}, {2000,0.81091818}, {2050,0.74880909}, {2100,0.85887273}, {2150,0.92285455}, {2200,0.88696364}, {2250,0.95477273}, {2300,1.10149091}, {2350,1.06682727}, {2400,0.96737273}, {2450,1.04000000}, {2500,1.05005455}, {2550,1.28900000}, {2600,1.05422727}, {2650,1.19479091}, {2700,1.13896364}, {2750,1.39710000}, {2800,1.24553636}, {2850,1.20327273}, {2900,1.30121818}, {2950,1.31501818}, {3000,1.41899091}, {3050,1.51489091}, {3100,1.34052727}, {3150,1.43549091}, {3200,1.21520909}, {3250,1.46947273}, {3300,1.49093636}, {3350,1.50776364}, {3400,1.43813636}, {3450,1.77044545}, {3500,1.66160000}, {3550,1.90072727}, {3600,1.42991818}, {3650,1.53757273}, {3700,1.76954545}, {3750,1.77379091}, {3800,1.79851818}, {3850,1.72817273}, {3900,1.96212727}, {3950,2.10648182}, {4000,1.75041818}, {4050,2.01673636}, {4100,1.62032727}, {4150,1.94521818}, {4200,1.84777273}, {4250,1.98207273}, {4300,2.01932727}, {4350,2.43941818}, {4400,1.93115455}, {4450,2.06618182}, {4500,2.09880000}, {4550,2.23929091}, {4600,2.41438182}, {4650,2.16950909}, {4700,2.29434545}, {4750,2.36207273}, {4800,2.08290909}, {4850,2.54846364}, {4900,2.25260000}, {4950,2.59860909}, {5000,2.28626364}, {5050,2.76430000}, {5100,2.80442727}, {5150,2.58890909}, {5200,2.26140909}, {5250,2.28573636}, {5300,2.60412727}, {5350,2.78947273}, {5400,2.48607273}, {5450,2.63691818}, {5500,2.99551818}, {5550,3.05724545}, {5600,2.65707273}, {5650,2.57731818}, {5700,2.54130000}, {5750,3.08161818}, {5800,2.70207273}, {5850,3.10892727}, {5900,2.74892727}, {5950,3.26530000}, {6000,2.92802727}, {6050,3.05750}, {6100,3.23500}, {6150,2.70850}, {6200,2.88525}, {6250,3.11450}, {6300,3.08350}, {6350,3.27150}, {6400,2.60700}, {6450,3.14425}, {6500,3.15075}, {6550,3.39150}, {6600,3.19800}, {6650,3.88500}, {6700,3.26275}, {6750,3.69475}, {6800,3.08750}, {6850,3.32725}, {6900,3.76550}, {6950,3.58475}, {7000,3.64150}, {7050,3.62600}, {7100,4.08450}, {7150,4.36525}, {7200,3.08875}, {7250,3.55000}, {7300,3.32100}, {7350,3.95725}, {7400,3.82375}, {7450,3.81850}, {7500,3.85900}, {7550,4.69950}, {7600,3.86975}, {7650,4.10500}, {7700,3.68850}, {7750,3.96375}, {7800,4.23350}, {7850,4.20225}, {7900,4.54275}, {7950,4.25300}, {8000,3.74950}, {8050,4.62800}, {8100,4.30900}, {8150,4.82875}, {8200,3.43925}, {8250,4.18275}, {8300,4.15775}, {8350,4.40550}, {8400,3.99750}, {8450,3.74550}, {8500,4.18275}, {8550,4.50625}, {8600,4.21350}, {8650,4.55200}, {8700,5.06950}, {8750,4.61775}, {8800,4.09025}, {8850,4.42675}, {8900,4.39625}, {8950,5.20775}, {9000,4.40150}, {9050,4.95650}, {9100,4.69450}, {9150,5.64800}, {9200,5.01775}, {9250,4.26550}, {9300,4.58450}, {9350,4.51650}, {9400,4.87675}, {9450,5.15850}, {9500,4.82675}, {9550,5.20250}, {9600,4.42900}, {9650,5.18325}, {9700,5.18725}, {9750,4.98650}, {9800,4.70850}, {9850,5.70425}, {9900,5.35675}, {9950,6.08000}, {10000,4.77225}, {10100,5.72550}, {10200,5.77450}, {10300,5.34650}, {10400,4.73325}, {10500,4.73850}, {10600,5.44950}, {10700,5.87225}, {10800,5.20250}, {10900,5.56825}, {11000,6.32300}, {11100,6.31550}, {11200,5.57050}, {11300,5.50825}, {11400,5.42750}, {11500,6.44425}, {11600,5.92050}, {11700,6.69775}, {11800,5.97525}, {11900,7.18425}, {12000,6.35825}, {12100,6.37825}, {12200,6.93675}, {12300,5.76775}, {12400,6.10650}, {12500,6.47800}, {12600,6.52875}, {12700,7.02075}, {12800,5.48975}, {12900,6.68950}, {13000,6.63775}, {13100,7.14575}, {13200,6.76425}, {13300,8.22650}, {13400,6.92575}, {13500,7.89925}, {13600,6.52575}, {13700,7.01750}, {13800,7.99475}, {13900,7.51250}, {14000,7.51275}, {14100,7.68025}, {14200,8.67675}, {14300,9.40350}, {14400,6.58250}, {14500,7.48575}, {14600,7.12275}, {14700,8.65050}, {14800,8.12650}, {14900,8.15500}, {15000,8.17775}, {15100,9.79050}, {15200,8.27725}, {15300,8.86250}, {15400,7.80800}, {15500,8.44250}, {15600,8.84000}, {15700,9.03475}, {15800,9.68125}, {15900,9.12275}, {16000,8.03525}, {16100,9.73775}, {16200,9.17750}, {16300,10.34450}, {16400,7.37450}, {16500,8.98250}, {16600,8.89225}, {16700,9.56375}, {16800,8.41350}, {16900,8.07675}, {17000,9.03575}, {17100,9.83450}, {17200,9.14350}, {17300,9.70750}, {17400,11.21275}, {17500,9.84450}, {17600,8.81525}, {17700,9.40900}, {17800,9.32975}, {17900,11.49500}, {18000,9.56725}, {18100,10.96350}, {18200,10.39050}, {18300,12.28200}, {18400,10.87350}, {18500,9.23075}, {18600,9.87125}, {18700,9.84800}, {18800,10.42100}, {18900,11.14450}, {19000,10.63100}, {19100,11.32075}, {19200,9.49575}, {19300,11.58950}, {19400,11.39550}, {19500,10.89250}, {19600,10.33850}, {19700,12.42450}, {19800,11.75650}, {19900,13.36275}, {20000,10.3340}};
data["big_flat"]["CanonicalStructuresPHOAS"]["Aggregate"]["system"] = {{1,0.00003604}, {2,0.00007207}, {3,0.00007207}, {4,0.00006306}, {5,0.00002703}, {6,0.00003604}, {7,0.00000000}, {8,0.00014414}, {9,0.00013514}, {10,0.00000000}, {11,0.00003604}, {12,0.00000000}, {13,0.00000000}, {14,0.00007207}, {15,0.00007207}, {16,0.00007207}, {17,0.00006306}, {18,0.00007207}, {19,0.00003604}, {20,0.00010811}, {21,0.00010811}, {22,0.00000000}, {23,0.00002703}, {24,0.00007207}, {25,0.00003604}, {26,0.00010811}, {27,0.00000000}, {28,0.00007207}, {29,0.00014414}, {30,0.00003604}, {31,0.00000000}, {32,0.00014414}, {33,0.00000000}, {34,0.00010811}, {35,0.00003604}, {36,0.00003604}, {37,0.00003604}, {38,0.00010811}, {39,0.00009910}, {40,0.00007207}, {41,0.00003604}, {42,0.00003604}, {43,0.00010811}, {44,0.00007207}, {45,0.00010811}, {46,0.00003604}, {47,0.00000000}, {48,0.00014414}, {49,0.00000000}, {50,0.00002703}, {51,0.00000000}, {52,0.00013514}, {53,0.00014414}, {54,0.00003604}, {55,0.00003604}, {56,0.00000000}, {57,0.00010811}, {58,0.00014414}, {59,0.00000000}, {60,0.00007207}, {61,0.00007207}, {62,0.00000000}, {63,0.00010811}, {64,0.00006306}, {65,0.00003604}, {66,0.00003604}, {67,0.00007207}, {68,0.00007207}, {69,0.00000000}, {70,0.00002703}, {71,0.00007207}, {72,0.00003604}, {73,0.00007207}, {74,0.00003604}, {75,0.00003604}, {76,0.00010811}, {77,0.00003604}, {78,0.00010811}, {79,0.00003604}, {80,0.00010811}, {81,0.00000000}, {82,0.00010811}, {83,0.00014414}, {84,0.00014414}, {85,0.00010811}, {86,0.00007207}, {87,0.00014414}, {88,0.00007207}, {89,0.00013514}, {90,0.00009910}, {91,0.00000000}, {92,0.00003604}, {93,0.00003604}, {94,0.00013514}, {95,0.00006306}, {96,0.00003604}, {97,0.00003604}, {98,0.00003604}, {99,0.00000000}, {100,0.00009910}, {101,0.00003604}, {102,0.00021622}, {103,0.00010811}, {104,0.00003604}, {105,0.00014414}, {106,0.00010811}, {107,0.00007207}, {108,0.00007207}, {109,0.00007207}, {110,0.00010811}, {111,0.00014414}, {112,0.00003604}, {113,0.00018018}, {114,0.00013514}, {115,0.00010811}, {116,0.00010811}, {117,0.00010811}, {118,0.00014414}, {119,0.00007207}, {120,0.00009910}, {121,0.00000000}, {122,0.00009910}, {123,0.00003604}, {124,0.00003604}, {125,0.00003604}, {126,0.00003604}, {127,0.00013514}, {128,0.00003604}, {129,0.00013514}, {130,0.00003604}, {131,0.00007207}, {132,0.00007207}, {133,0.00007207}, {134,0.00010811}, {135,0.00007207}, {136,0.00018018}, {137,0.00007207}, {138,0.00007207}, {139,0.00014414}, {140,0.00003604}, {141,0.00000000}, {142,0.00017117}, {143,0.00010811}, {144,0.00000000}, {145,0.00014414}, {146,0.00007207}, {147,0.00000000}, {148,0.00007207}, {149,0.00003604}, {150,0.00000000}, {151,0.00003604}, {152,0.00007207}, {153,0.00010811}, {154,0.00007207}, {155,0.00007207}, {156,0.00003604}, {157,0.00007207}, {158,0.00021622}, {159,0.00013514}, {160,0.00021622}, {161,0.00003604}, {162,0.00007207}, {163,0.00013514}, {164,0.00007207}, {165,0.00010811}, {166,0.00000000}, {167,0.00007207}, {168,0.00010811}, {169,0.00000000}, {170,0.00024324}, {171,0.00009910}, {172,0.00007207}, {173,0.00007207}, {174,0.00007207}, {175,0.00009910}, {176,0.00007207}, {177,0.00003604}, {178,0.00010811}, {179,0.00014414}, {180,0.00010811}, {181,0.00010811}, {182,0.00007207}, {183,0.00007207}, {184,0.00007207}, {185,0.00014414}, {186,0.00017117}, {187,0.00010811}, {188,0.00010811}, {189,0.00007207}, {190,0.00021622}, {191,0.00010811}, {192,0.00007207}, {193,0.00003604}, {194,0.00014414}, {195,0.00014414}, {196,0.00000000}, {197,0.00018018}, {198,0.00003604}, {199,0.00000000}, {200,0.00007207}, {201,0.00006306}, {202,0.00010811}, {203,0.00010811}, {204,0.00007207}, {205,0.00006306}, {206,0.00003604}, {207,0.00010811}, {208,0.00006306}, {209,0.00018018}, {210,0.00014414}, {211,0.00000000}, {212,0.00010811}, {213,0.00018018}, {214,0.00003604}, {215,0.00010811}, {216,0.00003604}, {217,0.00017117}, {218,0.00003604}, {219,0.00014414}, {220,0.00010811}, {221,0.00000000}, {222,0.00003604}, {223,0.00007207}, {224,0.00017117}, {225,0.00000000}, {226,0.00003604}, {227,0.00007207}, {228,0.00000000}, {229,0.00014414}, {230,0.00010811}, {231,0.00018018}, {232,0.00013514}, {233,0.00003604}, {234,0.00010811}, {235,0.00006306}, {236,0.00007207}, {237,0.00007207}, {238,0.00003604}, {239,0.00007207}, {240,0.00017117}, {241,0.00003604}, {242,0.00000000}, {243,0.00014414}, {244,0.00000000}, {245,0.00010811}, {246,0.00020721}, {247,0.00007207}, {248,0.00010811}, {249,0.00021622}, {250,0.00006306}, {251,0.00000000}, {252,0.00007207}, {253,0.00003604}, {254,0.00010811}, {255,0.00000000}, {256,0.00014414}, {257,0.00007207}, {258,0.00010811}, {259,0.00010811}, {260,0.00003604}, {261,0.00007207}, {262,0.00017117}, {263,0.00003604}, {264,0.00006306}, {265,0.00010811}, {266,0.00003604}, {267,0.00009910}, {268,0.00003604}, {269,0.00003604}, {270,0.00010811}, {271,0.00010811}, {272,0.00003604}, {273,0.00010811}, {274,0.00003604}, {275,0.00007207}, {276,0.00014414}, {277,0.00014414}, {278,0.00010811}, {279,0.00007207}, {280,0.00018018}, {281,0.00009910}, {282,0.00007207}, {283,0.00014414}, {284,0.00003604}, {285,0.00018018}, {286,0.00010811}, {287,0.00007207}, {288,0.00013514}, {289,0.00007207}, {290,0.00018018}, {291,0.00024324}, {292,0.00003604}, {293,0.00006306}, {294,0.00020721}, {295,0.00018018}, {296,0.00014414}, {297,0.00014414}, {298,0.00007207}, {299,0.00010811}, {300,0.00014414}, {301,0.00018018}, {302,0.00010811}, {303,0.00010811}, {304,0.00025225}, {305,0.00014414}, {306,0.00003604}, {307,0.00014414}, {308,0.00007207}, {309,0.00007207}, {310,0.00000000}, {311,0.00014414}, {312,0.00010811}, {313,0.00003604}, {314,0.00013514}, {315,0.00018919}, {316,0.00010811}, {317,0.00007207}, {318,0.00003604}, {319,0.00018018}, {320,0.00014414}, {321,0.00016216}, {322,0.00003604}, {323,0.00013514}, {324,0.00013514}, {325,0.00018018}, {326,0.00014414}, {327,0.00021622}, {328,0.00018018}, {329,0.00021622}, {330,0.00010811}, {331,0.00010811}, {332,0.00000000}, {333,0.00009910}, {334,0.00021622}, {335,0.00003604}, {336,0.00010811}, {337,0.00021622}, {338,0.00007207}, {339,0.00017117}, {340,0.00024324}, {341,0.00003604}, {342,0.00014414}, {343,0.00003604}, {344,0.00007207}, {345,0.00014414}, {346,0.00009910}, {347,0.00003604}, {348,0.00010811}, {349,0.00003604}, {350,0.00010811}, {351,0.00007207}, {352,0.00013514}, {353,0.00007207}, {354,0.00002703}, {355,0.00009910}, {356,0.00007207}, {357,0.00007207}, {358,0.00007207}, {359,0.00000000}, {360,0.00006306}, {361,0.00014414}, {362,0.00003604}, {363,0.00007207}, {364,0.00000000}, {365,0.00009910}, {366,0.00025225}, {367,0.00014414}, {368,0.00014414}, {369,0.00010811}, {370,0.00003604}, {371,0.00025225}, {372,0.00003604}, {373,0.00010811}, {374,0.00007207}, {375,0.00010811}, {376,0.00018018}, {377,0.00007207}, {378,0.00009910}, {379,0.00014414}, {380,0.00007207}, {381,0.00010811}, {382,0.00007207}, {383,0.00007207}, {384,0.00017117}, {385,0.00014414}, {386,0.00009910}, {387,0.00007207}, {388,0.00014414}, {389,0.00007207}, {390,0.00025225}, {391,0.00003604}, {392,0.00018018}, {393,0.00007207}, {394,0.00010811}, {395,0.00014414}, {396,0.00010811}, {397,0.00021622}, {398,0.00021622}, {399,0.00018018}, {400,0.00010811}, {401,0.00010811}, {402,0.00018018}, {403,0.00014414}, {404,0.00014414}, {405,0.00020721}, {406,0.00031532}, {407,0.00010811}, {408,0.00013514}, {409,0.00010811}, {410,0.00003604}, {411,0.00014414}, {412,0.00014414}, {413,0.00014414}, {414,0.00021622}, {415,0.00014414}, {416,0.00014414}, {417,0.00007207}, {418,0.00007207}, {419,0.00021622}, {420,0.00010811}, {421,0.00014414}, {422,0.00038739}, {423,0.00003604}, {424,0.00018018}, {425,0.00009910}, {426,0.00021622}, {427,0.00018018}, {428,0.00010811}, {429,0.00010811}, {430,0.00014414}, {431,0.00003604}, {432,0.00007207}, {433,0.00014414}, {434,0.00010811}, {435,0.00007207}, {436,0.00007207}, {437,0.00014414}, {438,0.00010811}, {439,0.00000000}, {440,0.00003604}, {441,0.00009910}, {442,0.00017117}, {443,0.00007207}, {444,0.00014414}, {445,0.00017117}, {446,0.00028829}, {447,0.00010811}, {448,0.00009910}, {449,0.00007207}, {450,0.00007207}, {451,0.00014414}, {452,0.00014414}, {453,0.00014414}, {454,0.00010811}, {455,0.00017117}, {456,0.00018018}, {457,0.00010811}, {458,0.00028829}, {459,0.00021622}, {460,0.00007207}, {461,0.00014414}, {462,0.00010811}, {463,0.00018018}, {464,0.00025225}, {465,0.00036036}, {466,0.00023423}, {467,0.00014414}, {468,0.00010811}, {469,0.00027928}, {470,0.00010811}, {471,0.00021622}, {472,0.00013514}, {473,0.00017117}, {474,0.00020721}, {475,0.00017117}, {476,0.00003604}, {477,0.00007207}, {478,0.00018018}, {479,0.00021622}, {480,0.00046847}, {481,0.00045045}, {482,0.00025225}, {483,0.00028829}, {484,0.00024324}, {485,0.00007207}, {486,0.00021622}, {487,0.00020721}, {488,0.00007207}, {489,0.00014414}, {490,0.00020721}, {491,0.00007207}, {492,0.00018018}, {493,0.00010811}, {494,0.00014414}, {495,0.00010811}, {496,0.00021622}, {497,0.00017117}, {498,0.00003604}, {499,0.00021622}, {500,0.00000000}, {505,0.00006306}, {510,0.00024324}, {515,0.00018018}, {520,0.00018018}, {525,0.00024324}, {530,0.00021622}, {535,0.00014414}, {540,0.00024324}, {545,0.00007207}, {550,0.00010811}, {555,0.00021622}, {560,0.00028829}, {565,0.00025225}, {570,0.00020721}, {575,0.00031532}, {580,0.00014414}, {585,0.00035135}, {590,0.00031532}, {595,0.00021622}, {600,0.00022523}, {605,0.00009009}, {610,0.00003604}, {615,0.00029730}, {620,0.00024324}, {625,0.00053153}, {630,0.00020721}, {635,0.00021622}, {640,0.00013514}, {645,0.00035135}, {650,0.00032432}, {655,0.00018018}, {660,0.00021622}, {665,0.00014414}, {670,0.00021622}, {675,0.00028829}, {680,0.00021622}, {685,0.00025225}, {690,0.00009910}, {695,0.00025225}, {700,0.00020721}, {705,0.00018018}, {710,0.00013514}, {715,0.00020721}, {720,0.00039640}, {725,0.00028829}, {730,0.00027027}, {735,0.00014414}, {740,0.00036036}, {745,0.00027928}, {750,0.00010811}, {755,0.00020721}, {760,0.00000000}, {765,0.00038739}, {770,0.00028829}, {775,0.00020721}, {780,0.00031532}, {785,0.00032432}, {790,0.00036036}, {795,0.00014414}, {800,0.00041441}, {805,0.00035135}, {810,0.00025225}, {815,0.00032432}, {820,0.00027928}, {825,0.00039640}, {830,0.00028829}, {835,0.00043243}, {840,0.00043243}, {845,0.00036036}, {850,0.00036036}, {855,0.00036036}, {860,0.00039640}, {865,0.00014414}, {870,0.00046847}, {875,0.00045045}, {880,0.00046847}, {885,0.00007207}, {890,0.00043243}, {895,0.00035135}, {900,0.00024324}, {905,0.00050450}, {910,0.00028829}, {915,0.00021622}, {920,0.00021622}, {925,0.00032432}, {930,0.00043243}, {935,0.00050450}, {940,0.00014414}, {945,0.00053153}, {950,0.00035135}, {955,0.00035135}, {960,0.00031532}, {965,0.00028829}, {970,0.00028829}, {975,0.00045946}, {980,0.00032432}, {985,0.00035135}, {990,0.00025225}, {995,0.00021622}, {1000,0.00025225}, {1010,0.00027027}, {1020,0.00050450}, {1030,0.00025225}, {1040,0.00024324}, {1050,0.00020909}, {1060,0.00025455}, {1070,0.00058182}, {1080,0.00039091}, {1090,0.00182727}, {1100,0.00029091}, {1110,0.00025455}, {1120,0.00020909}, {1130,0.00042727}, {1140,0.00029091}, {1150,0.00014545}, {1160,0.00029091}, {1170,0.00042727}, {1180,0.00041818}, {1190,0.00036364}, {1200,0.00025455}, {1210,0.00018182}, {1220,0.00039091}, {1230,0.00031818}, {1240,0.00043636}, {1250,0.00046364}, {1260,0.00058182}, {1270,0.00058182}, {1280,0.00041818}, {1290,0.00058182}, {1300,0.00040000}, {1310,0.00060000}, {1320,0.00050909}, {1330,0.00050000}, {1340,0.00043636}, {1350,0.00043636}, {1360,0.00050909}, {1370,0.00047273}, {1380,0.00036364}, {1390,0.00060909}, {1400,0.00045455}, {1410,0.00047273}, {1420,0.00047273}, {1430,0.00063636}, {1440,0.00058182}, {1450,0.00043636}, {1460,0.00025455}, {1470,0.00028182}, {1480,0.00053636}, {1490,0.00025455}, {1500,0.00049091}, {1510,0.00040000}, {1520,0.00007273}, {1530,0.00032727}, {1540,0.00018182}, {1550,0.00017273}, {1560,0.00018182}, {1570,0.00010000}, {1580,0.00018182}, {1590,0.00018182}, {1600,0.00021818}, {1610,0.00014545}, {1620,0.00036364}, {1630,0.00163636}, {1640,0.00018182}, {1650,0.00018182}, {1660,0.00025455}, {1670,0.00040000}, {1680,0.00029091}, {1690,0.00025455}, {1700,0.00013636}, {1710,0.00020909}, {1720,0.00031818}, {1730,0.00042727}, {1740,0.00021818}, {1750,0.00036364}, {1760,0.00017273}, {1770,0.00029091}, {1780,0.00020909}, {1790,0.00036364}, {1800,0.00025455}, {1810,0.00032727}, {1820,0.00047273}, {1830,0.00035455}, {1840,0.00029091}, {1850,0.00029091}, {1860,0.00018182}, {1870,0.00032727}, {1880,0.00014545}, {1890,0.00018182}, {1900,0.00029091}, {1910,0.00017273}, {1920,0.00025455}, {1930,0.00031818}, {1940,0.00013636}, {1950,0.00010909}, {1960,0.00025455}, {1970,0.00021818}, {1980,0.00025455}, {1990,0.00017273}, {2000,0.00010909}, {2050,0.00013636}, {2100,0.00018182}, {2150,0.00017273}, {2200,0.00000000}, {2250,0.00035455}, {2300,0.00064545}, {2350,0.00018182}, {2400,0.00014545}, {2450,0.00018182}, {2500,0.00032727}, {2550,0.00046364}, {2600,0.00021818}, {2650,0.00018182}, {2700,0.00021818}, {2750,0.00020909}, {2800,0.00018182}, {2850,0.00018182}, {2900,0.00021818}, {2950,0.00018182}, {3000,0.00029091}, {3050,0.00017273}, {3100,0.00014545}, {3150,0.00021818}, {3200,0.00021818}, {3250,0.00020909}, {3300,0.00018182}, {3350,0.00025455}, {3400,0.00025455}, {3450,0.00021818}, {3500,0.00025455}, {3550,0.00050000}, {3600,0.00021818}, {3650,0.00028182}, {3700,0.00031818}, {3750,0.00021818}, {3800,0.00014545}, {3850,0.00017273}, {3900,0.00025455}, {3950,0.00029091}, {4000,0.00040000}, {4050,0.00024545}, {4100,0.00029091}, {4150,0.00014545}, {4200,0.00040000}, {4250,0.00021818}, {4300,0.00020000}, {4350,0.00032727}, {4400,0.00024545}, {4450,0.00029091}, {4500,0.00042727}, {4550,0.00047273}, {4600,0.00029091}, {4650,0.00021818}, {4700,0.00144545}, {4750,0.00157273}, {4800,0.00138182}, {4850,0.00160000}, {4900,0.00122727}, {4950,0.00131818}, {5000,0.00134545}, {5050,0.00130000}, {5100,0.00087273}, {5150,0.00010909}, {5200,0.00024545}, {5250,0.00018182}, {5300,0.00029091}, {5350,0.00018182}, {5400,0.00031818}, {5450,0.00058182}, {5500,0.00060909}, {5550,0.00069091}, {5600,0.00065455}, {5650,0.00032727}, {5700,0.00028182}, {5750,0.00036364}, {5800,0.00034545}, {5850,0.00036364}, {5900,0.00032727}, {5950,0.00010909}, {6000,0.00013636}, {6050,0.00200}, {6100,0.00300}, {6150,0.00200}, {6200,0.00100}, {6250,0.00000}, {6300,0.00200}, {6350,0.00400}, {6400,0.00300}, {6450,0.00000}, {6500,0.00100}, {6550,0.00000}, {6600,0.00000}, {6650,0.00075}, {6700,0.00100}, {6750,0.00200}, {6800,0.00300}, {6850,0.00000}, {6900,0.00100}, {6950,0.00000}, {7000,0.00275}, {7050,0.00300}, {7100,0.00100}, {7150,0.00200}, {7200,0.00200}, {7250,0.00400}, {7300,0.00100}, {7350,0.00000}, {7400,0.00200}, {7450,0.00450}, {7500,0.00200}, {7550,0.00100}, {7600,0.00200}, {7650,0.00500}, {7700,0.00100}, {7750,0.00000}, {7800,0.00000}, {7850,0.00100}, {7900,0.00100}, {7950,0.00000}, {8000,0.00000}, {8050,0.00100}, {8100,0.00000}, {8150,0.00100}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00100}, {8550,0.00000}, {8600,0.00000}, {8650,0.00100}, {8700,0.00000}, {8750,0.00100}, {8800,0.00000}, {8850,0.00000}, {8900,0.00100}, {8950,0.00000}, {9000,0.00100}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00100}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00100}, {9450,0.00200}, {9500,0.00100}, {9550,0.00000}, {9600,0.00100}, {9650,0.00000}, {9700,0.00100}, {9750,0.00100}, {9800,0.00000}, {9850,0.00100}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00100}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00100}, {10600,0.00000}, {10700,0.00200}, {10800,0.00000}, {10900,0.00200}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00200}, {11600,0.00100}, {11700,0.00100}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00100}, {12400,0.00000}, {12500,0.00100}, {12600,0.00100}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00100}, {13100,0.00100}, {13200,0.00000}, {13300,0.00000}, {13400,0.00200}, {13500,0.00100}, {13600,0.00100}, {13700,0.00000}, {13800,0.00100}, {13900,0.00000}, {14000,0.00200}, {14100,0.00300}, {14200,0.00200}, {14300,0.00000}, {14400,0.00075}, {14500,0.00300}, {14600,0.00000}, {14700,0.00200}, {14800,0.00200}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00100}, {16000,0.00100}, {16100,0.00100}, {16200,0.00000}, {16300,0.00300}, {16400,0.00000}, {16500,0.00000}, {16600,0.00100}, {16700,0.00000}, {16800,0.00100}, {16900,0.00000}, {17000,0.00200}, {17100,0.00100}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00100}, {17700,0.00100}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00100}, {18200,0.00000}, {18300,0.00000}, {18400,0.00175}, {18500,0.00000}, {18600,0.00000}, {18700,0.00100}, {18800,0.00000}, {18900,0.00200}, {19000,0.00300}, {19100,0.00000}, {19200,0.00200}, {19300,0.00000}, {19400,0.00100}, {19500,0.00200}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresPHOAS"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00100000}, {6,0.00100000}, {7,0.00100000}, {8,0.00100000}, {9,0.00189189}, {10,0.00200000}, {11,0.00200000}, {12,0.00201802}, {13,0.00229730}, {14,0.00300000}, {15,0.00318919}, {16,0.00300901}, {17,0.00318919}, {18,0.00400000}, {19,0.00405405}, {20,0.00402703}, {21,0.00419820}, {22,0.00500000}, {23,0.00509009}, {24,0.00608108}, {25,0.00519820}, {26,0.00592793}, {27,0.00609009}, {28,0.00606306}, {29,0.00655856}, {30,0.00705405}, {31,0.00714414}, {32,0.00811712}, {33,0.00719820}, {34,0.00782883}, {35,0.00807207}, {36,0.00809910}, {37,0.00890090}, {38,0.00912613}, {39,0.00921622}, {40,0.00906306}, {41,0.00965766}, {42,0.01004505}, {43,0.01034234}, {44,0.01015315}, {45,0.01105405}, {46,0.01112613}, {47,0.01205405}, {48,0.01103604}, {49,0.01168468}, {50,0.01202703}, {51,0.01250450}, {52,0.01212613}, {53,0.01305405}, {54,0.01310811}, {55,0.01409910}, {56,0.01312613}, {57,0.01411712}, {58,0.01411712}, {59,0.01608108}, {60,0.01459459}, {61,0.01531532}, {62,0.01579279}, {63,0.01840541}, {64,0.01512613}, {65,0.01601802}, {66,0.01609009}, {67,0.01840541}, {68,0.01638739}, {69,0.01724324}, {70,0.01756757}, {71,0.01859459}, {72,0.01731532}, {73,0.01820721}, {74,0.02013514}, {75,0.01966667}, {76,0.01909910}, {77,0.02010811}, {78,0.02017117}, {79,0.02134234}, {80,0.01927027}, {81,0.02170270}, {82,0.02054955}, {83,0.02187387}, {84,0.02306306}, {85,0.02209009}, {86,0.02234234}, {87,0.02572072}, {88,0.02207207}, {89,0.02314414}, {90,0.02513514}, {91,0.02471171}, {92,0.02392793}, {93,0.02689189}, {94,0.02521622}, {95,0.02683784}, {96,0.02333333}, {97,0.02469369}, {98,0.02664865}, {99,0.02614414}, {100,0.02522523}, {101,0.02806306}, {102,0.02684685}, {103,0.02821622}, {104,0.02624324}, {105,0.02761261}, {106,0.02912613}, {107,0.02924324}, {108,0.02827027}, {109,0.02977477}, {110,0.03004505}, {111,0.03287387}, {112,0.02819820}, {113,0.03149550}, {114,0.02994595}, {115,0.03136036}, {116,0.03031532}, {117,0.03199099}, {118,0.03304505}, {119,0.03393694}, {120,0.03303604}, {121,0.03286486}, {122,0.03483784}, {123,0.03496396}, {124,0.03358559}, {125,0.03523423}, {126,0.03556757}, {127,0.03758559}, {128,0.03204505}, {129,0.03354054}, {130,0.03377477}, {131,0.03554054}, {132,0.03420721}, {133,0.03612613}, {134,0.03627027}, {135,0.03815315}, {136,0.03514414}, {137,0.03709009}, {138,0.03718919}, {139,0.03910811}, {140,0.03754955}, {141,0.03965766}, {142,0.04159459}, {143,0.04209009}, {144,0.03828829}, {145,0.03892793}, {146,0.04066667}, {147,0.04132432}, {148,0.04121622}, {149,0.04172072}, {150,0.04212613}, {151,0.04425225}, {152,0.04066667}, {153,0.04420721}, {154,0.04309910}, {155,0.04666667}, {156,0.04351351}, {157,0.04588288}, {158,0.04742342}, {159,0.04851351}, {160,0.04227027}, {161,0.04339640}, {162,0.04351351}, {163,0.04733333}, {164,0.04386486}, {165,0.04746847}, {166,0.04633333}, {167,0.04894595}, {168,0.04646847}, {169,0.04726126}, {170,0.04829730}, {171,0.05277477}, {172,0.04789189}, {173,0.05153153}, {174,0.05076577}, {175,0.05352252}, {176,0.04806306}, {177,0.04928829}, {178,0.04949550}, {179,0.05361261}, {180,0.04996396}, {181,0.05263063}, {182,0.05440541}, {183,0.05572973}, {184,0.05092793}, {185,0.05487387}, {186,0.05636937}, {187,0.05678378}, {188,0.05438739}, {189,0.05869369}, {190,0.05744144}, {191,0.06050450}, {192,0.05102703}, {193,0.05216216}, {194,0.05227928}, {195,0.05618919}, {196,0.05551351}, {197,0.05576577}, {198,0.05583784}, {199,0.06007207}, {200,0.05627027}, {201,0.05663964}, {202,0.05699099}, {203,0.06116216}, {204,0.05989189}, {205,0.06048649}, {206,0.06073874}, {207,0.06526126}, {208,0.05829730}, {209,0.05872973}, {210,0.05889189}, {211,0.06223423}, {212,0.06100000}, {213,0.06488288}, {214,0.06295495}, {215,0.06627928}, {216,0.06143243}, {217,0.06617117}, {218,0.06611712}, {219,0.06732432}, {220,0.06424324}, {221,0.06789189}, {222,0.06912613}, {223,0.07449550}, {224,0.06359459}, {225,0.06296396}, {226,0.06309009}, {227,0.06647748}, {228,0.06524324}, {229,0.06972973}, {230,0.07048649}, {231,0.07099099}, {232,0.06469369}, {233,0.06802703}, {234,0.06957658}, {235,0.07606306}, {236,0.07251351}, {237,0.07632432}, {238,0.07593694}, {239,0.07679279}, {240,0.06650450}, {241,0.07020721}, {242,0.07045045}, {243,0.07562162}, {244,0.07427027}, {245,0.07767568}, {246,0.07749550}, {247,0.08136937}, {248,0.07414414}, {249,0.07801802}, {250,0.07585586}, {251,0.08007207}, {252,0.07642342}, {253,0.08060360}, {254,0.08073874}, {255,0.08534234}, {256,0.06777477}, {257,0.07239640}, {258,0.07443243}, {259,0.07804505}, {260,0.07472973}, {261,0.07832432}, {262,0.07851351}, {263,0.08269369}, {264,0.07546847}, {265,0.07913514}, {266,0.07945946}, {267,0.08348649}, {268,0.07984685}, {269,0.08408108}, {270,0.08413514}, {271,0.08867568}, {272,0.07728829}, {273,0.08121622}, {274,0.08144144}, {275,0.08565766}, {276,0.08205405}, {277,0.08623423}, {278,0.08666667}, {279,0.09127928}, {280,0.08315315}, {281,0.08750450}, {282,0.08783784}, {283,0.09227928}, {284,0.08819820}, {285,0.09308108}, {286,0.09049550}, {287,0.09532432}, {288,0.07909009}, {289,0.08317117}, {290,0.08329730}, {291,0.08766667}, {292,0.08605405}, {293,0.09030631}, {294,0.09091892}, {295,0.09596396}, {296,0.08725225}, {297,0.09202703}, {298,0.09242342}, {299,0.09451351}, {300,0.09006306}, {301,0.09501802}, {302,0.09715315}, {303,0.10205405}, {304,0.08909009}, {305,0.09404505}, {306,0.09437838}, {307,0.09690991}, {308,0.09218919}, {309,0.10009910}, {310,0.09941441}, {311,0.10465766}, {312,0.09560360}, {313,0.10081982}, {314,0.09833333}, {315,0.10355856}, {316,0.10066667}, {317,0.10607207}, {318,0.10679279}, {319,0.11002703}, {320,0.08760360}, {321,0.09463964}, {322,0.09414414}, {323,0.09945045}, {324,0.09527928}, {325,0.09791892}, {326,0.10078378}, {327,0.10518919}, {328,0.09585586}, {329,0.10128829}, {330,0.09898198}, {331,0.10681081}, {332,0.10145045}, {333,0.10726126}, {334,0.10518018}, {335,0.11336937}, {336,0.09769369}, {337,0.10300000}, {338,0.10323423}, {339,0.10913514}, {340,0.10350450}, {341,0.10972072}, {342,0.10770270}, {343,0.11545946}, {344,0.10440541}, {345,0.11062162}, {346,0.10817117}, {347,0.11589189}, {348,0.11092793}, {349,0.11681982}, {350,0.11714414}, {351,0.12327027}, {352,0.10205405}, {353,0.10498198}, {354,0.10876577}, {355,0.11321622}, {356,0.10592793}, {357,0.11336937}, {358,0.11426126}, {359,0.11784685}, {360,0.10865766}, {361,0.11500000}, {362,0.11281982}, {363,0.12061261}, {364,0.11586486}, {365,0.11936937}, {366,0.12163063}, {367,0.12855856}, {368,0.11171171}, {369,0.11653153}, {370,0.11725225}, {371,0.12343243}, {372,0.11742342}, {373,0.12165766}, {374,0.12343243}, {375,0.13081081}, {376,0.11856757}, {377,0.12446847}, {378,0.12300901}, {379,0.13139640}, {380,0.12538739}, {381,0.13236937}, {382,0.13267568}, {383,0.13973874}, {384,0.10784685}, {385,0.11105405}, {386,0.11377477}, {387,0.11909910}, {388,0.11428829}, {389,0.11997297}, {390,0.11809910}, {391,0.12621622}, {392,0.11512613}, {393,0.12134234}, {394,0.12107207}, {395,0.12766667}, {396,0.12140541}, {397,0.12810811}, {398,0.12811712}, {399,0.13493694}, {400,0.11647748}, {401,0.12368468}, {402,0.12289189}, {403,0.12772072}, {404,0.12351351}, {405,0.12818919}, {406,0.13035135}, {407,0.13560360}, {408,0.12499099}, {409,0.12929730}, {410,0.13249550}, {411,0.13934234}, {412,0.13161261}, {413,0.13890991}, {414,0.13895495}, {415,0.14677477}, {416,0.12074775}, {417,0.12733333}, {418,0.12734234}, {419,0.13409910}, {420,0.12800901}, {421,0.13487387}, {422,0.13295495}, {423,0.14205405}, {424,0.12860360}, {425,0.13541441}, {426,0.13611712}, {427,0.14327928}, {428,0.13663063}, {429,0.14396396}, {430,0.14390991}, {431,0.15202703}, {432,0.13081982}, {433,0.13809009}, {434,0.13829730}, {435,0.14523423}, {436,0.13886486}, {437,0.14568468}, {438,0.14578378}, {439,0.15393694}, {440,0.13924324}, {441,0.14696396}, {442,0.14749550}, {443,0.15489189}, {444,0.14786486}, {445,0.15596396}, {446,0.15535135}, {447,0.16469369}, {448,0.12995495}, {449,0.13597297}, {450,0.13707207}, {451,0.14355856}, {452,0.13657658}, {453,0.14439640}, {454,0.14423423}, {455,0.15181081}, {456,0.13818919}, {457,0.14671171}, {458,0.14503604}, {459,0.15328829}, {460,0.14578378}, {461,0.15330631}, {462,0.15438739}, {463,0.16217117}, {464,0.13971171}, {465,0.14737838}, {466,0.14763063}, {467,0.15518919}, {468,0.14744144}, {469,0.15649550}, {470,0.15630631}, {471,0.16351351}, {472,0.14839640}, {473,0.15714414}, {474,0.15744144}, {475,0.16509910}, {476,0.15708108}, {477,0.16588288}, {478,0.16667568}, {479,0.17572072}, {480,0.14538739}, {481,0.15145045}, {482,0.15231532}, {483,0.16012613}, {484,0.15233333}, {485,0.16010811}, {486,0.16018018}, {487,0.16976577}, {488,0.15309009}, {489,0.16115315}, {490,0.16116216}, {491,0.17183784}, {492,0.16217117}, {493,0.17081081}, {494,0.17094595}, {495,0.17985586}, {496,0.15672973}, {497,0.16316216}, {498,0.16337838}, {499,0.17306306}, {500,0.16442342}, {505,0.17421622}, {510,0.18378378}, {515,0.16247748}, {520,0.15653153}, {525,0.17217117}, {530,0.16488288}, {535,0.18459459}, {540,0.17628829}, {545,0.16873874}, {550,0.17918919}, {555,0.18994595}, {560,0.17689189}, {565,0.19366667}, {570,0.19445045}, {575,0.21708108}, {580,0.17941441}, {585,0.18990090}, {590,0.20163964}, {595,0.20300000}, {600,0.19400000}, {605,0.21659459}, {610,0.19706306}, {615,0.22017117}, {620,0.20905405}, {625,0.21094595}, {630,0.22510811}, {635,0.23635135}, {640,0.18826126}, {645,0.20979279}, {650,0.21070270}, {655,0.23770270}, {660,0.21247748}, {665,0.22589189}, {670,0.24015315}, {675,0.22895495}, {680,0.21939640}, {685,0.24643243}, {690,0.23193694}, {695,0.26138739}, {700,0.24792793}, {705,0.22618919}, {710,0.24141441}, {715,0.25301802}, {720,0.23089189}, {725,0.25862162}, {730,0.25730631}, {735,0.29017117}, {740,0.24870270}, {745,0.26391892}, {750,0.27784685}, {755,0.27768468}, {760,0.26695495}, {765,0.29861261}, {770,0.24263964}, {775,0.27065766}, {780,0.25789189}, {785,0.25653153}, {790,0.27035135}, {795,0.28665766}, {800,0.24763063}, {805,0.27618018}, {810,0.27692793}, {815,0.30986486}, {820,0.27755856}, {825,0.29434234}, {830,0.31500000}, {835,0.28481982}, {840,0.27139640}, {845,0.30305405}, {850,0.28860360}, {855,0.32323423}, {860,0.30634234}, {865,0.29615315}, {870,0.31105405}, {875,0.32982883}, {880,0.29661261}, {885,0.33245946}, {890,0.33386486}, {895,0.37587387}, {900,0.29020721}, {905,0.30763964}, {910,0.32631532}, {915,0.32691892}, {920,0.31134234}, {925,0.34822523}, {930,0.31363063}, {935,0.35030631}, {940,0.33390090}, {945,0.33578378}, {950,0.35590991}, {955,0.37669369}, {960,0.30827027}, {965,0.34158559}, {970,0.34142342}, {975,0.38443243}, {980,0.34545946}, {985,0.36483784}, {990,0.39053153}, {995,0.36886486}, {1000,0.35095495}, {1010,0.37323423}, {1020,0.39922523}, {1030,0.34566667}, {1040,0.32833333}, {1050,0.36930909}, {1060,0.35114545}, {1070,0.39475455}, {1080,0.37580909}, {1090,0.36690909}, {1100,0.38273636}, {1110,0.40873636}, {1120,0.36875455}, {1130,0.41630909}, {1140,0.41793636}, {1150,0.46649091}, {1160,0.38471818}, {1170,0.40666364}, {1180,0.42661818}, {1190,0.43697273}, {1200,0.41469091}, {1210,0.46814545}, {1220,0.42138182}, {1230,0.47437273}, {1240,0.44895455}, {1250,0.45350000}, {1260,0.48227273}, {1270,0.51519091}, {1280,0.40073636}, {1290,0.44809091}, {1300,0.45005455}, {1310,0.50756364}, {1320,0.45661818}, {1330,0.48541818}, {1340,0.51466364}, {1350,0.49093636}, {1360,0.46696364}, {1370,0.52660909}, {1380,0.49996364}, {1390,0.56402727}, {1400,0.53527273}, {1410,0.48192727}, {1420,0.51358182}, {1430,0.54719091}, {1440,0.48966364}, {1450,0.55538182}, {1460,0.55599091}, {1470,0.62837273}, {1480,0.52997273}, {1490,0.56414545}, {1500,0.59948182}, {1510,0.60370000}, {1520,0.57286364}, {1530,0.64698182}, {1540,0.50795455}, {1550,0.57465455}, {1560,0.54572727}, {1570,0.54697273}, {1580,0.57993636}, {1590,0.61784545}, {1600,0.52385455}, {1610,0.59012727}, {1620,0.59212727}, {1630,2.31040000}, {1640,0.60470000}, {1650,0.64496364}, {1660,0.68081818}, {1670,0.61100000}, {1680,0.57672727}, {1690,0.65530000}, {1700,0.61874545}, {1710,0.70600000}, {1720,0.66375455}, {1730,0.62727273}, {1740,0.66883636}, {1750,0.71520000}, {1760,0.63632727}, {1770,0.72163636}, {1780,0.72070000}, {1790,0.82141818}, {1800,0.61982727}, {1810,0.65825455}, {1820,0.70139091}, {1830,0.70604545}, {1840,0.66929091}, {1850,0.75887273}, {1860,0.67354545}, {1870,0.76661818}, {1880,0.72160000}, {1890,0.72402727}, {1900,0.76864545}, {1910,0.82163636}, {1920,0.65292727}, {1930,0.73763636}, {1940,0.74194545}, {1950,0.83090000}, {1960,0.74813636}, {1970,0.79428182}, {1980,0.85325455}, {1990,0.80207273}, {2000,0.76050000}, {2050,0.69683636}, {2100,0.80525455}, {2150,0.86777273}, {2200,0.83054545}, {2250,0.89726364}, {2300,1.04157273}, {2350,1.00550000}, {2400,0.89699091}, {2450,0.97578182}, {2500,0.98454545}, {2550,1.21779091}, {2600,0.98135455}, {2650,1.12438182}, {2700,1.06690909}, {2750,1.32010909}, {2800,1.17088182}, {2850,1.12691818}, {2900,1.21932727}, {2950,1.23230909}, {3000,1.32852727}, {3050,1.42944545}, {3100,1.25362727}, {3150,1.35069091}, {3200,1.12937273}, {3250,1.38170909}, {3300,1.39929091}, {3350,1.41590000}, {3400,1.34479091}, {3450,1.65481818}, {3500,1.56540909}, {3550,1.80275455}, {3600,1.33040000}, {3650,1.43762727}, {3700,1.65765455}, {3750,1.66877273}, {3800,1.69033636}, {3850,1.60150000}, {3900,1.84023636}, {3950,1.98464545}, {4000,1.63830909}, {4050,1.89298182}, {4100,1.50644545}, {4150,1.80786364}, {4200,1.71535455}, {4250,1.85991818}, {4300,1.89171818}, {4350,2.30410909}, {4400,1.80239091}, {4450,1.93964545}, {4500,1.96050000}, {4550,2.09659091}, {4600,2.27245455}, {4650,2.02943636}, {4700,2.15489091}, {4750,2.21099091}, {4800,1.93447273}, {4850,2.38695455}, {4900,2.10891818}, {4950,2.43711818}, {5000,2.13835455}, {5050,2.61691818}, {5100,2.64542727}, {5150,2.39884545}, {5200,2.10041818}, {5250,2.12366364}, {5300,2.42464545}, {5350,2.62407273}, {5400,2.29534545}, {5450,2.48278182}, {5500,2.83460000}, {5550,2.87175455}, {5600,2.48928182}, {5650,2.38000000}, {5700,2.37390909}, {5750,2.90836364}, {5800,2.53160000}, {5850,2.92957273}, {5900,2.58147273}, {5950,3.09220909}, {6000,2.76339091}, {6050,2.86675}, {6100,3.04025}, {6150,2.50925}, {6200,2.68875}, {6250,2.90175}, {6300,2.89075}, {6350,3.07850}, {6400,2.41500}, {6450,2.95050}, {6500,2.95800}, {6550,3.18625}, {6600,2.97925}, {6650,3.67350}, {6700,3.05775}, {6750,3.48800}, {6800,2.87275}, {6850,3.09575}, {6900,3.53925}, {6950,3.36350}, {7000,3.40250}, {7050,3.38425}, {7100,3.84150}, {7150,4.12925}, {7200,2.85500}, {7250,3.30100}, {7300,3.08300}, {7350,3.70450}, {7400,3.55725}, {7450,3.57300}, {7500,3.59875}, {7550,4.43650}, {7600,3.62525}, {7650,3.85175}, {7700,3.44325}, {7750,3.70550}, {7800,3.95575}, {7850,3.92600}, {7900,4.28625}, {7950,3.99775}, {8000,3.49275}, {8050,4.36550}, {8100,4.02575}, {8150,4.57225}, {8200,3.18575}, {8250,3.90500}, {8300,3.88800}, {8350,4.14875}, {8400,3.71425}, {8450,3.47125}, {8500,3.93775}, {8550,4.23375}, {8600,3.94250}, {8650,4.25550}, {8700,4.79250}, {8750,4.33775}, {8800,3.80500}, {8850,4.11400}, {8900,4.11625}, {8950,4.92525}, {9000,4.11275}, {9050,4.66175}, {9100,4.41950}, {9150,5.33475}, {9200,4.72875}, {9250,3.98425}, {9300,4.26625}, {9350,4.21225}, {9400,4.58525}, {9450,4.88650}, {9500,4.55875}, {9550,4.89225}, {9600,4.10650}, {9650,4.88775}, {9700,4.90825}, {9750,4.69700}, {9800,4.40450}, {9850,5.38675}, {9900,5.03750}, {9950,5.74825}, {10000,4.47700}, {10100,5.42300}, {10200,5.45775}, {10300,5.02400}, {10400,4.41650}, {10500,4.43375}, {10600,5.13325}, {10700,5.51275}, {10800,4.84625}, {10900,5.24000}, {11000,5.96100}, {11100,5.99575}, {11200,5.22800}, {11300,5.09975}, {11400,5.04025}, {11500,6.08650}, {11600,5.50775}, {11700,6.28150}, {11800,5.55575}, {11900,6.76800}, {12000,5.95850}, {12100,5.97100}, {12200,6.53875}, {12300,5.35150}, {12400,5.67375}, {12500,6.08650}, {12600,6.13175}, {12700,6.63000}, {12800,5.09750}, {12900,6.23675}, {13000,6.19875}, {13100,6.71200}, {13200,6.31875}, {13300,7.76950}, {13400,6.48425}, {13500,7.34550}, {13600,6.11825}, {13700,6.58200}, {13800,7.45800}, {13900,7.05600}, {14000,6.99425}, {14100,7.11350}, {14200,8.18800}, {14300,8.82275}, {14400,6.07525}, {14500,6.92275}, {14600,6.59450}, {14700,8.06200}, {14800,7.54350}, {14900,7.56675}, {15000,7.64450}, {15100,9.21575}, {15200,7.74525}, {15300,8.27075}, {15400,7.32600}, {15500,7.83700}, {15600,8.28150}, {15700,8.49575}, {15800,9.06925}, {15900,8.57400}, {16000,7.44525}, {16100,9.06925}, {16200,8.52850}, {16300,9.70100}, {16400,6.79400}, {16500,8.35075}, {16600,8.28125}, {16700,8.91975}, {16800,7.83825}, {16900,7.43325}, {17000,8.47175}, {17100,9.19775}, {17200,8.54800}, {17300,9.08150}, {17400,10.54125}, {17500,9.19375}, {17600,8.16625}, {17700,8.75525}, {17800,8.70100}, {17900,10.79625}, {18000,8.83825}, {18100,10.24450}, {18200,9.66075}, {18300,11.55600}, {18400,10.17075}, {18500,8.53775}, {18600,9.15725}, {18700,9.20450}, {18800,9.76950}, {18900,10.44475}, {19000,9.90275}, {19100,10.61700}, {19200,8.81225}, {19300,10.78625}, {19400,10.71250}, {19500,10.13475}, {19600,9.55800}, {19700,11.65300}, {19800,10.95825}, {19900,12.59200}, {20000,9.5900}};
data["big_flat"]["CanonicalStructuresPHOAS"]["actual reif"]["user"] = {{1,0.00010811}, {2,0.00036937}, {3,0.00081982}, {4,0.00049550}, {5,0.00131532}, {6,0.00078378}, {7,0.00148649}, {8,0.00156757}, {9,0.00171171}, {10,0.00194595}, {11,0.00208108}, {12,0.00236937}, {13,0.00237838}, {14,0.00243243}, {15,0.00312613}, {16,0.00295495}, {17,0.00317117}, {18,0.00338739}, {19,0.00364865}, {20,0.00394595}, {21,0.00438739}, {22,0.00492793}, {23,0.00475676}, {24,0.00599099}, {25,0.00578378}, {26,0.00538739}, {27,0.00633333}, {28,0.00593694}, {29,0.00657658}, {30,0.00687387}, {31,0.00763964}, {32,0.00820721}, {33,0.00762162}, {34,0.00776577}, {35,0.00841441}, {36,0.00837838}, {37,0.00906306}, {38,0.00910811}, {39,0.00975676}, {40,0.00911712}, {41,0.00969369}, {42,0.00994595}, {43,0.01089189}, {44,0.01078378}, {45,0.01113514}, {46,0.01165766}, {47,0.01235135}, {48,0.01118919}, {49,0.01203604}, {50,0.01227928}, {51,0.01269369}, {52,0.01247748}, {53,0.01306306}, {54,0.01345946}, {55,0.01414414}, {56,0.01336036}, {57,0.01399099}, {58,0.01414414}, {59,0.01607207}, {60,0.01433333}, {61,0.01525225}, {62,0.01547748}, {63,0.01866667}, {64,0.01488288}, {65,0.01571171}, {66,0.01598198}, {67,0.01875676}, {68,0.01663964}, {69,0.01736937}, {70,0.01740541}, {71,0.01870270}, {72,0.01751351}, {73,0.01838739}, {74,0.02051351}, {75,0.01984685}, {76,0.01875676}, {77,0.02041441}, {78,0.02058559}, {79,0.02183784}, {80,0.01928829}, {81,0.02199099}, {82,0.02074775}, {83,0.02218018}, {84,0.02345946}, {85,0.02219820}, {86,0.02299099}, {87,0.02564865}, {88,0.02229730}, {89,0.02333333}, {90,0.02525225}, {91,0.02479279}, {92,0.02434234}, {93,0.02669369}, {94,0.02527928}, {95,0.02658559}, {96,0.02386486}, {97,0.02482883}, {98,0.02676577}, {99,0.02640541}, {100,0.02492793}, {101,0.02777477}, {102,0.02653153}, {103,0.02802703}, {104,0.02646847}, {105,0.02714414}, {106,0.02881081}, {107,0.02907207}, {108,0.02837838}, {109,0.02977477}, {110,0.03000000}, {111,0.03291892}, {112,0.02803604}, {113,0.03136036}, {114,0.02951351}, {115,0.03159459}, {116,0.03026126}, {117,0.03176577}, {118,0.03346847}, {119,0.03418919}, {120,0.03325225}, {121,0.03305405}, {122,0.03523423}, {123,0.03483784}, {124,0.03395495}, {125,0.03582883}, {126,0.03605405}, {127,0.03806306}, {128,0.03200000}, {129,0.03377477}, {130,0.03409009}, {131,0.03596396}, {132,0.03483784}, {133,0.03645045}, {134,0.03645946}, {135,0.03794595}, {136,0.03546847}, {137,0.03711712}, {138,0.03743243}, {139,0.03879279}, {140,0.03774775}, {141,0.03945946}, {142,0.04149550}, {143,0.04182883}, {144,0.03836036}, {145,0.03875676}, {146,0.04063063}, {147,0.04125225}, {148,0.04125225}, {149,0.04143243}, {150,0.04225225}, {151,0.04443243}, {152,0.04054955}, {153,0.04427027}, {154,0.04313514}, {155,0.04667568}, {156,0.04345946}, {157,0.04608108}, {158,0.04759459}, {159,0.04874775}, {160,0.04205405}, {161,0.04345946}, {162,0.04375676}, {163,0.04757658}, {164,0.04383784}, {165,0.04758559}, {166,0.04639640}, {167,0.04913514}, {168,0.04691892}, {169,0.04779279}, {170,0.04840541}, {171,0.05270270}, {172,0.04843243}, {173,0.05118919}, {174,0.05054955}, {175,0.05355856}, {176,0.04846847}, {177,0.04928829}, {178,0.04964865}, {179,0.05363964}, {180,0.04998198}, {181,0.05260360}, {182,0.05451351}, {183,0.05588288}, {184,0.05064865}, {185,0.05496396}, {186,0.05647748}, {187,0.05687387}, {188,0.05456757}, {189,0.05872072}, {190,0.05753153}, {191,0.06047748}, {192,0.05072973}, {193,0.05208108}, {194,0.05201802}, {195,0.05641441}, {196,0.05580180}, {197,0.05588288}, {198,0.05587387}, {199,0.06043243}, {200,0.05631532}, {201,0.05680180}, {202,0.05715315}, {203,0.06140541}, {204,0.06020721}, {205,0.06065766}, {206,0.06106306}, {207,0.06497297}, {208,0.05865766}, {209,0.05883784}, {210,0.05900901}, {211,0.06199099}, {212,0.06118018}, {213,0.06475676}, {214,0.06281081}, {215,0.06593694}, {216,0.06181081}, {217,0.06614414}, {218,0.06593694}, {219,0.06727928}, {220,0.06405405}, {221,0.06807207}, {222,0.06971171}, {223,0.07447748}, {224,0.06349550}, {225,0.06290991}, {226,0.06286486}, {227,0.06616216}, {228,0.06486486}, {229,0.06986486}, {230,0.07063964}, {231,0.07136937}, {232,0.06439640}, {233,0.06805405}, {234,0.06964865}, {235,0.07567568}, {236,0.07256757}, {237,0.07613514}, {238,0.07576577}, {239,0.07653153}, {240,0.06677477}, {241,0.07074775}, {242,0.07059459}, {243,0.07536937}, {244,0.07429730}, {245,0.07764865}, {246,0.07729730}, {247,0.08158559}, {248,0.07427027}, {249,0.07768468}, {250,0.07580180}, {251,0.08018018}, {252,0.07639640}, {253,0.08042342}, {254,0.08081081}, {255,0.08522523}, {256,0.06764865}, {257,0.07245946}, {258,0.07446847}, {259,0.07790090}, {260,0.07479279}, {261,0.07843243}, {262,0.07826126}, {263,0.08303604}, {264,0.07504505}, {265,0.07922523}, {266,0.07945045}, {267,0.08376577}, {268,0.07993694}, {269,0.08431532}, {270,0.08438739}, {271,0.08853153}, {272,0.07706306}, {273,0.08141441}, {274,0.08136036}, {275,0.08577477}, {276,0.08243243}, {277,0.08619820}, {278,0.08652252}, {279,0.09118018}, {280,0.08329730}, {281,0.08726126}, {282,0.08754955}, {283,0.09235135}, {284,0.08790991}, {285,0.09292793}, {286,0.09045946}, {287,0.09546847}, {288,0.07890090}, {289,0.08332432}, {290,0.08345946}, {291,0.08748649}, {292,0.08595495}, {293,0.09036036}, {294,0.09090090}, {295,0.09597297}, {296,0.08712613}, {297,0.09215315}, {298,0.09259459}, {299,0.09493694}, {300,0.09002703}, {301,0.09514414}, {302,0.09741441}, {303,0.10194595}, {304,0.08876577}, {305,0.09391892}, {306,0.09447748}, {307,0.09715315}, {308,0.09254955}, {309,0.09973874}, {310,0.09942342}, {311,0.10470270}, {312,0.09581982}, {313,0.10064865}, {314,0.09836036}, {315,0.10377477}, {316,0.10036937}, {317,0.10635135}, {318,0.10681081}, {319,0.11018919}, {320,0.08737838}, {321,0.09456757}, {322,0.09406306}, {323,0.09936036}, {324,0.09541441}, {325,0.09807207}, {326,0.10045045}, {327,0.10510811}, {328,0.09593694}, {329,0.10097297}, {330,0.09883784}, {331,0.10696396}, {332,0.10079279}, {333,0.10745045}, {334,0.10548649}, {335,0.11298198}, {336,0.09784685}, {337,0.10272072}, {338,0.10324324}, {339,0.10927027}, {340,0.10349550}, {341,0.10967568}, {342,0.10780180}, {343,0.11553153}, {344,0.10459459}, {345,0.11042342}, {346,0.10829730}, {347,0.11588288}, {348,0.11072973}, {349,0.11686486}, {350,0.11720721}, {351,0.12312613}, {352,0.10178378}, {353,0.10509009}, {354,0.10900901}, {355,0.11304505}, {356,0.10671171}, {357,0.11300901}, {358,0.11400901}, {359,0.11813514}, {360,0.10895495}, {361,0.11486486}, {362,0.11278378}, {363,0.12077477}, {364,0.11618018}, {365,0.11947748}, {366,0.12150450}, {367,0.12890991}, {368,0.11135135}, {369,0.11647748}, {370,0.11768468}, {371,0.12315315}, {372,0.11743243}, {373,0.12146847}, {374,0.12317117}, {375,0.13118018}, {376,0.11892793}, {377,0.12409009}, {378,0.12284685}, {379,0.13146847}, {380,0.12531532}, {381,0.13236937}, {382,0.13245946}, {383,0.13983784}, {384,0.10754054}, {385,0.11076577}, {386,0.11347748}, {387,0.11906306}, {388,0.11390991}, {389,0.12037838}, {390,0.11831532}, {391,0.12612613}, {392,0.11469369}, {393,0.12122523}, {394,0.12112613}, {395,0.12737838}, {396,0.12133333}, {397,0.12795495}, {398,0.12833333}, {399,0.13462162}, {400,0.11636937}, {401,0.12346847}, {402,0.12264865}, {403,0.12765766}, {404,0.12293694}, {405,0.12791892}, {406,0.13058559}, {407,0.13539640}, {408,0.12481081}, {409,0.12930631}, {410,0.13248649}, {411,0.13925225}, {412,0.13151351}, {413,0.13867568}, {414,0.13889189}, {415,0.14650450}, {416,0.12078378}, {417,0.12741441}, {418,0.12705405}, {419,0.13399099}, {420,0.12787387}, {421,0.13484685}, {422,0.13272973}, {423,0.14198198}, {424,0.12873874}, {425,0.13509009}, {426,0.13592793}, {427,0.14321622}, {428,0.13639640}, {429,0.14411712}, {430,0.14364865}, {431,0.15212613}, {432,0.13078378}, {433,0.13762162}, {434,0.13825225}, {435,0.14519820}, {436,0.13874775}, {437,0.14574775}, {438,0.14556757}, {439,0.15405405}, {440,0.13919820}, {441,0.14698198}, {442,0.14699099}, {443,0.15490991}, {444,0.14771171}, {445,0.15599099}, {446,0.15539640}, {447,0.16480180}, {448,0.12990991}, {449,0.13551351}, {450,0.13709910}, {451,0.14356757}, {452,0.13645045}, {453,0.14433333}, {454,0.14395495}, {455,0.15141441}, {456,0.13806306}, {457,0.14645045}, {458,0.14485586}, {459,0.15319820}, {460,0.14556757}, {461,0.15334234}, {462,0.15447748}, {463,0.16221622}, {464,0.13937838}, {465,0.14700000}, {466,0.14727928}, {467,0.15530631}, {468,0.14690991}, {469,0.15609009}, {470,0.15627027}, {471,0.16323423}, {472,0.14817117}, {473,0.15698198}, {474,0.15704505}, {475,0.16525225}, {476,0.15700000}, {477,0.16572072}, {478,0.16677477}, {479,0.17539640}, {480,0.14520721}, {481,0.15141441}, {482,0.15186486}, {483,0.15972072}, {484,0.15200000}, {485,0.15975676}, {486,0.15963063}, {487,0.16949550}, {488,0.15305405}, {489,0.16072072}, {490,0.16150450}, {491,0.17133333}, {492,0.16202703}, {493,0.17031532}, {494,0.17054955}, {495,0.17958559}, {496,0.15654054}, {497,0.16290991}, {498,0.16347748}, {499,0.17238739}, {500,0.16414414}, {505,0.17372973}, {510,0.18336036}, {515,0.16244144}, {520,0.15643243}, {525,0.17183784}, {530,0.16485586}, {535,0.18448649}, {540,0.17639640}, {545,0.16839640}, {550,0.17904505}, {555,0.18974775}, {560,0.17706306}, {565,0.19327027}, {570,0.19413514}, {575,0.21715315}, {580,0.17972072}, {585,0.19020721}, {590,0.20176577}, {595,0.20295495}, {600,0.19362162}, {605,0.21642342}, {610,0.19705405}, {615,0.21958559}, {620,0.20855856}, {625,0.21057658}, {630,0.22481081}, {635,0.23624324}, {640,0.18817117}, {645,0.20963063}, {650,0.21057658}, {655,0.23748649}, {660,0.21181982}, {665,0.22593694}, {670,0.23981081}, {675,0.22876577}, {680,0.21923423}, {685,0.24624324}, {690,0.23159459}, {695,0.26118919}, {700,0.24750450}, {705,0.22607207}, {710,0.24090090}, {715,0.25298198}, {720,0.23039640}, {725,0.25860360}, {730,0.25728829}, {735,0.28997297}, {740,0.24818018}, {745,0.26407207}, {750,0.27807207}, {755,0.27807207}, {760,0.26736036}, {765,0.29876577}, {770,0.24219820}, {775,0.27072973}, {780,0.25774775}, {785,0.25673874}, {790,0.26985586}, {795,0.28636036}, {800,0.24738739}, {805,0.27605405}, {810,0.27706306}, {815,0.30996396}, {820,0.27787387}, {825,0.29411712}, {830,0.31513514}, {835,0.28468468}, {840,0.27095495}, {845,0.30273874}, {850,0.28862162}, {855,0.32298198}, {860,0.30632432}, {865,0.29622523}, {870,0.31066667}, {875,0.32949550}, {880,0.29627928}, {885,0.33205405}, {890,0.33345045}, {895,0.37549550}, {900,0.29054955}, {905,0.30739640}, {910,0.32609009}, {915,0.32722523}, {920,0.31140541}, {925,0.34836937}, {930,0.31364865}, {935,0.34992793}, {940,0.33381982}, {945,0.33540541}, {950,0.35580180}, {955,0.37628829}, {960,0.30767568}, {965,0.34130631}, {970,0.34114414}, {975,0.38407207}, {980,0.34540541}, {985,0.36436036}, {990,0.39016216}, {995,0.36874775}, {1000,0.35084685}, {1010,0.37303604}, {1020,0.39890090}, {1030,0.34550450}, {1040,0.32827027}, {1050,0.36896364}, {1060,0.35102727}, {1070,0.39444545}, {1080,0.37531818}, {1090,0.36512727}, {1100,0.38212727}, {1110,0.40885455}, {1120,0.36843636}, {1130,0.41578182}, {1140,0.41760000}, {1150,0.46614545}, {1160,0.38465455}, {1170,0.40587273}, {1180,0.42647273}, {1190,0.43639091}, {1200,0.41443636}, {1210,0.46808182}, {1220,0.42139091}, {1230,0.47384545}, {1240,0.44872727}, {1250,0.45291818}, {1260,0.48160909}, {1270,0.51497273}, {1280,0.40035455}, {1290,0.44737273}, {1300,0.44980000}, {1310,0.50715455}, {1320,0.45627273}, {1330,0.48500909}, {1340,0.51464545}, {1350,0.49033636}, {1360,0.46654545}, {1370,0.52621818}, {1380,0.49977273}, {1390,0.56377273}, {1400,0.53514545}, {1410,0.48120000}, {1420,0.51320000}, {1430,0.54701818}, {1440,0.48888182}, {1450,0.55521818}, {1460,0.55572727}, {1470,0.62848182}, {1480,0.52932727}, {1490,0.56389091}, {1500,0.59910909}, {1510,0.60374545}, {1520,0.57283636}, {1530,0.64710909}, {1540,0.50779091}, {1550,0.57455455}, {1560,0.54568182}, {1570,0.54691818}, {1580,0.58005455}, {1590,0.61795455}, {1600,0.52380909}, {1610,0.59019091}, {1620,0.59150909}, {1630,2.30864545}, {1640,0.60460000}, {1650,0.64520909}, {1660,0.68042727}, {1670,0.61079091}, {1680,0.57651818}, {1690,0.65530000}, {1700,0.61884545}, {1710,0.70603636}, {1720,0.66348182}, {1730,0.62718182}, {1740,0.66876364}, {1750,0.71499091}, {1760,0.63616364}, {1770,0.72140000}, {1780,0.72052727}, {1790,0.82128182}, {1800,0.61981818}, {1810,0.65820000}, {1820,0.70117273}, {1830,0.70600000}, {1840,0.66910000}, {1850,0.75851818}, {1860,0.67333636}, {1870,0.76646364}, {1880,0.72135455}, {1890,0.72378182}, {1900,0.76820000}, {1910,0.82146364}, {1920,0.65271818}, {1930,0.73746364}, {1940,0.74179091}, {1950,0.83060000}, {1960,0.74821818}, {1970,0.79430000}, {1980,0.85291818}, {1990,0.80194545}, {2000,0.76037273}, {2050,0.69705455}, {2100,0.80503636}, {2150,0.86754545}, {2200,0.83043636}, {2250,0.89687273}, {2300,1.04095455}, {2350,1.00521818}, {2400,0.89666364}, {2450,0.97547273}, {2500,0.98412727}, {2550,1.21774545}, {2600,0.98110909}, {2650,1.12415455}, {2700,1.06687273}, {2750,1.31964545}, {2800,1.17037273}, {2850,1.12694545}, {2900,1.21917273}, {2950,1.23173636}, {3000,1.32837273}, {3050,1.42901818}, {3100,1.25342727}, {3150,1.35022727}, {3200,1.12933636}, {3250,1.38148182}, {3300,1.39896364}, {3350,1.41536364}, {3400,1.34436364}, {3450,1.65449091}, {3500,1.56515455}, {3550,1.80225455}, {3600,1.33028182}, {3650,1.43738182}, {3700,1.65720909}, {3750,1.66838182}, {3800,1.69003636}, {3850,1.60160000}, {3900,1.83984545}, {3950,1.98451818}, {4000,1.63811818}, {4050,1.89260000}, {4100,1.50610909}, {4150,1.80726364}, {4200,1.71498182}, {4250,1.85923636}, {4300,1.89139091}, {4350,2.30350000}, {4400,1.80169091}, {4450,1.93912727}, {4500,1.95988182}, {4550,2.09606364}, {4600,2.27198182}, {4650,2.02923636}, {4700,2.15355455}, {4750,2.20979091}, {4800,1.93343636}, {4850,2.38549091}, {4900,2.10785455}, {4950,2.43563636}, {5000,2.13709091}, {5050,2.61566364}, {5100,2.64463636}, {5150,2.39821818}, {5200,2.09998182}, {5250,2.12359091}, {5300,2.42410000}, {5350,2.62353636}, {5400,2.29484545}, {5450,2.48208182}, {5500,2.83328182}, {5550,2.87064545}, {5600,2.48858182}, {5650,2.37931818}, {5700,2.37325455}, {5750,2.90816364}, {5800,2.53094545}, {5850,2.92949091}, {5900,2.58127273}, {5950,3.09178182}, {6000,2.76332727}, {6050,2.86725}, {6100,3.03800}, {6150,2.50550}, {6200,2.68875}, {6250,2.90175}, {6300,2.89050}, {6350,3.07775}, {6400,2.41250}, {6450,2.95125}, {6500,2.95675}, {6550,3.18600}, {6600,2.97925}, {6650,3.67175}, {6700,3.05625}, {6750,3.48825}, {6800,2.87050}, {6850,3.09650}, {6900,3.53850}, {6950,3.36250}, {7000,3.39950}, {7050,3.38175}, {7100,3.84000}, {7150,4.12750}, {7200,2.85675}, {7250,3.29750}, {7300,3.08225}, {7350,3.70350}, {7400,3.55650}, {7450,3.57000}, {7500,3.59625}, {7550,4.43375}, {7600,3.62350}, {7650,3.84800}, {7700,3.44225}, {7750,3.70575}, {7800,3.95425}, {7850,3.92325}, {7900,4.28325}, {7950,3.99525}, {8000,3.49225}, {8050,4.36475}, {8100,4.02375}, {8150,4.57025}, {8200,3.18350}, {8250,3.90500}, {8300,3.88775}, {8350,4.14950}, {8400,3.71450}, {8450,3.47150}, {8500,3.93525}, {8550,4.23150}, {8600,3.94150}, {8650,4.25350}, {8700,4.79100}, {8750,4.33550}, {8800,3.80550}, {8850,4.11375}, {8900,4.11425}, {8950,4.92375}, {9000,4.11100}, {9050,4.66150}, {9100,4.41925}, {9150,5.33225}, {9200,4.72650}, {9250,3.98350}, {9300,4.26500}, {9350,4.21075}, {9400,4.58375}, {9450,4.88625}, {9500,4.56000}, {9550,4.89075}, {9600,4.10525}, {9650,4.88650}, {9700,4.90400}, {9750,4.69350}, {9800,4.40500}, {9850,5.38750}, {9900,5.03800}, {9950,5.74875}, {10000,4.47625}, {10100,5.42100}, {10200,5.45850}, {10300,5.02425}, {10400,4.41700}, {10500,4.43350}, {10600,5.13375}, {10700,5.51250}, {10800,4.84550}, {10900,5.23925}, {11000,5.96125}, {11100,5.99550}, {11200,5.22725}, {11300,5.10075}, {11400,5.04150}, {11500,6.08575}, {11600,5.50750}, {11700,6.28125}, {11800,5.55550}, {11900,6.76875}, {12000,5.95875}, {12100,5.97100}, {12200,6.53900}, {12300,5.34925}, {12400,5.67375}, {12500,6.08525}, {12600,6.12975}, {12700,6.63025}, {12800,5.09750}, {12900,6.23825}, {13000,6.20000}, {13100,6.71175}, {13200,6.31975}, {13300,7.77050}, {13400,6.48325}, {13500,7.34350}, {13600,6.11750}, {13700,6.58225}, {13800,7.45825}, {13900,7.05650}, {14000,6.99300}, {14100,7.10875}, {14200,8.18550}, {14300,8.82200}, {14400,6.07275}, {14500,6.91800}, {14600,6.59350}, {14700,8.06225}, {14800,7.54125}, {14900,7.56775}, {15000,7.64375}, {15100,9.21700}, {15200,7.74450}, {15300,8.27050}, {15400,7.32600}, {15500,7.83725}, {15600,8.28125}, {15700,8.49675}, {15800,9.06975}, {15900,8.57300}, {16000,7.44375}, {16100,9.06425}, {16200,8.52550}, {16300,9.69550}, {16400,6.79350}, {16500,8.35100}, {16600,8.28050}, {16700,8.92025}, {16800,7.83975}, {16900,7.43350}, {17000,8.47075}, {17100,9.19750}, {17200,8.54775}, {17300,9.08200}, {17400,10.54175}, {17500,9.19250}, {17600,8.16550}, {17700,8.75625}, {17800,8.70100}, {17900,10.79675}, {18000,8.83850}, {18100,10.24150}, {18200,9.66050}, {18300,11.55500}, {18400,10.16825}, {18500,8.53625}, {18600,9.15650}, {18700,9.20425}, {18800,9.77050}, {18900,10.44450}, {19000,9.90150}, {19100,10.61650}, {19200,8.81200}, {19300,10.78675}, {19400,10.70950}, {19500,10.13075}, {19600,9.55375}, {19700,11.65050}, {19800,10.95625}, {19900,12.58950}, {20000,9.5860}};
data["big_flat"]["CanonicalStructuresPHOAS"]["actual reif"]["system"] = {{1,0.00000000}, {2,0.00003604}, {3,0.00000000}, {4,0.00002703}, {5,0.00002703}, {6,0.00003604}, {7,0.00000000}, {8,0.00007207}, {9,0.00013514}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00007207}, {15,0.00003604}, {16,0.00000000}, {17,0.00006306}, {18,0.00003604}, {19,0.00003604}, {20,0.00010811}, {21,0.00007207}, {22,0.00000000}, {23,0.00002703}, {24,0.00003604}, {25,0.00003604}, {26,0.00003604}, {27,0.00000000}, {28,0.00007207}, {29,0.00007207}, {30,0.00003604}, {31,0.00000000}, {32,0.00007207}, {33,0.00000000}, {34,0.00003604}, {35,0.00003604}, {36,0.00003604}, {37,0.00003604}, {38,0.00007207}, {39,0.00009910}, {40,0.00003604}, {41,0.00000000}, {42,0.00003604}, {43,0.00000000}, {44,0.00003604}, {45,0.00003604}, {46,0.00000000}, {47,0.00000000}, {48,0.00003604}, {49,0.00000000}, {50,0.00002703}, {51,0.00000000}, {52,0.00009910}, {53,0.00007207}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00007207}, {58,0.00007207}, {59,0.00000000}, {60,0.00007207}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00003604}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00003604}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00003604}, {73,0.00000000}, {74,0.00003604}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00003604}, {79,0.00000000}, {80,0.00003604}, {81,0.00000000}, {82,0.00003604}, {83,0.00000000}, {84,0.00003604}, {85,0.00003604}, {86,0.00007207}, {87,0.00010811}, {88,0.00003604}, {89,0.00003604}, {90,0.00007207}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00006306}, {95,0.00006306}, {96,0.00003604}, {97,0.00003604}, {98,0.00000000}, {99,0.00000000}, {100,0.00002703}, {101,0.00003604}, {102,0.00018018}, {103,0.00007207}, {104,0.00003604}, {105,0.00010811}, {106,0.00007207}, {107,0.00007207}, {108,0.00003604}, {109,0.00000000}, {110,0.00000000}, {111,0.00003604}, {112,0.00000000}, {113,0.00014414}, {114,0.00003604}, {115,0.00003604}, {116,0.00000000}, {117,0.00003604}, {118,0.00010811}, {119,0.00003604}, {120,0.00003604}, {121,0.00000000}, {122,0.00007207}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00002703}, {128,0.00003604}, {129,0.00002703}, {130,0.00000000}, {131,0.00000000}, {132,0.00003604}, {133,0.00003604}, {134,0.00003604}, {135,0.00003604}, {136,0.00007207}, {137,0.00003604}, {138,0.00007207}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00007207}, {143,0.00003604}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00003604}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00003604}, {153,0.00007207}, {154,0.00000000}, {155,0.00003604}, {156,0.00000000}, {157,0.00003604}, {158,0.00010811}, {159,0.00006306}, {160,0.00003604}, {161,0.00000000}, {162,0.00000000}, {163,0.00007207}, {164,0.00000000}, {165,0.00003604}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00013514}, {171,0.00002703}, {172,0.00000000}, {173,0.00003604}, {174,0.00003604}, {175,0.00000000}, {176,0.00003604}, {177,0.00003604}, {178,0.00003604}, {179,0.00010811}, {180,0.00003604}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00003604}, {187,0.00003604}, {188,0.00003604}, {189,0.00007207}, {190,0.00010811}, {191,0.00007207}, {192,0.00003604}, {193,0.00003604}, {194,0.00000000}, {195,0.00003604}, {196,0.00000000}, {197,0.00003604}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00003604}, {203,0.00003604}, {204,0.00003604}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00003604}, {209,0.00010811}, {210,0.00010811}, {211,0.00000000}, {212,0.00003604}, {213,0.00007207}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00003604}, {218,0.00000000}, {219,0.00003604}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00003604}, {228,0.00000000}, {229,0.00003604}, {230,0.00003604}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00003604}, {235,0.00000000}, {236,0.00003604}, {237,0.00000000}, {238,0.00003604}, {239,0.00000000}, {240,0.00003604}, {241,0.00000000}, {242,0.00000000}, {243,0.00003604}, {244,0.00000000}, {245,0.00007207}, {246,0.00003604}, {247,0.00000000}, {248,0.00007207}, {249,0.00010811}, {250,0.00006306}, {251,0.00000000}, {252,0.00000000}, {253,0.00003604}, {254,0.00000000}, {255,0.00000000}, {256,0.00003604}, {257,0.00000000}, {258,0.00003604}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00007207}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00007207}, {268,0.00003604}, {269,0.00000000}, {270,0.00003604}, {271,0.00003604}, {272,0.00003604}, {273,0.00003604}, {274,0.00003604}, {275,0.00000000}, {276,0.00003604}, {277,0.00007207}, {278,0.00007207}, {279,0.00003604}, {280,0.00000000}, {281,0.00002703}, {282,0.00003604}, {283,0.00003604}, {284,0.00003604}, {285,0.00018018}, {286,0.00003604}, {287,0.00003604}, {288,0.00006306}, {289,0.00003604}, {290,0.00010811}, {291,0.00003604}, {292,0.00003604}, {293,0.00006306}, {294,0.00010811}, {295,0.00007207}, {296,0.00010811}, {297,0.00003604}, {298,0.00003604}, {299,0.00003604}, {300,0.00003604}, {301,0.00007207}, {302,0.00000000}, {303,0.00003604}, {304,0.00007207}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00003604}, {310,0.00000000}, {311,0.00010811}, {312,0.00003604}, {313,0.00000000}, {314,0.00007207}, {315,0.00002703}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00007207}, {321,0.00002703}, {322,0.00003604}, {323,0.00003604}, {324,0.00007207}, {325,0.00007207}, {326,0.00003604}, {327,0.00014414}, {328,0.00010811}, {329,0.00007207}, {330,0.00007207}, {331,0.00003604}, {332,0.00000000}, {333,0.00003604}, {334,0.00010811}, {335,0.00000000}, {336,0.00003604}, {337,0.00007207}, {338,0.00007207}, {339,0.00007207}, {340,0.00003604}, {341,0.00000000}, {342,0.00007207}, {343,0.00003604}, {344,0.00000000}, {345,0.00000000}, {346,0.00003604}, {347,0.00003604}, {348,0.00003604}, {349,0.00000000}, {350,0.00003604}, {351,0.00000000}, {352,0.00003604}, {353,0.00003604}, {354,0.00000000}, {355,0.00002703}, {356,0.00000000}, {357,0.00003604}, {358,0.00007207}, {359,0.00000000}, {360,0.00000000}, {361,0.00003604}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00010811}, {367,0.00000000}, {368,0.00000000}, {369,0.00003604}, {370,0.00003604}, {371,0.00007207}, {372,0.00000000}, {373,0.00000000}, {374,0.00003604}, {375,0.00000000}, {376,0.00003604}, {377,0.00000000}, {378,0.00000000}, {379,0.00003604}, {380,0.00003604}, {381,0.00003604}, {382,0.00000000}, {383,0.00003604}, {384,0.00006306}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00007207}, {389,0.00000000}, {390,0.00003604}, {391,0.00000000}, {392,0.00007207}, {393,0.00000000}, {394,0.00000000}, {395,0.00003604}, {396,0.00003604}, {397,0.00003604}, {398,0.00007207}, {399,0.00000000}, {400,0.00000000}, {401,0.00003604}, {402,0.00000000}, {403,0.00000000}, {404,0.00007207}, {405,0.00002703}, {406,0.00009910}, {407,0.00000000}, {408,0.00007207}, {409,0.00000000}, {410,0.00003604}, {411,0.00000000}, {412,0.00007207}, {413,0.00007207}, {414,0.00000000}, {415,0.00010811}, {416,0.00007207}, {417,0.00007207}, {418,0.00003604}, {419,0.00003604}, {420,0.00000000}, {421,0.00000000}, {422,0.00014414}, {423,0.00003604}, {424,0.00003604}, {425,0.00003604}, {426,0.00007207}, {427,0.00003604}, {428,0.00003604}, {429,0.00007207}, {430,0.00007207}, {431,0.00003604}, {432,0.00007207}, {433,0.00007207}, {434,0.00000000}, {435,0.00003604}, {436,0.00000000}, {437,0.00003604}, {438,0.00007207}, {439,0.00000000}, {440,0.00003604}, {441,0.00002703}, {442,0.00006306}, {443,0.00000000}, {444,0.00003604}, {445,0.00007207}, {446,0.00000000}, {447,0.00000000}, {448,0.00002703}, {449,0.00000000}, {450,0.00003604}, {451,0.00003604}, {452,0.00007207}, {453,0.00003604}, {454,0.00003604}, {455,0.00003604}, {456,0.00007207}, {457,0.00003604}, {458,0.00007207}, {459,0.00007207}, {460,0.00003604}, {461,0.00010811}, {462,0.00000000}, {463,0.00000000}, {464,0.00007207}, {465,0.00032432}, {466,0.00017117}, {467,0.00003604}, {468,0.00003604}, {469,0.00009910}, {470,0.00007207}, {471,0.00007207}, {472,0.00007207}, {473,0.00013514}, {474,0.00013514}, {475,0.00002703}, {476,0.00003604}, {477,0.00003604}, {478,0.00014414}, {479,0.00007207}, {480,0.00039640}, {481,0.00014414}, {482,0.00014414}, {483,0.00018018}, {484,0.00017117}, {485,0.00003604}, {486,0.00018018}, {487,0.00010811}, {488,0.00003604}, {489,0.00007207}, {490,0.00006306}, {491,0.00007207}, {492,0.00010811}, {493,0.00003604}, {494,0.00007207}, {495,0.00003604}, {496,0.00018018}, {497,0.00007207}, {498,0.00003604}, {499,0.00010811}, {500,0.00000000}, {505,0.00000000}, {510,0.00007207}, {515,0.00014414}, {520,0.00003604}, {525,0.00000000}, {530,0.00014414}, {535,0.00010811}, {540,0.00010811}, {545,0.00007207}, {550,0.00003604}, {555,0.00003604}, {560,0.00014414}, {565,0.00021622}, {570,0.00006306}, {575,0.00020721}, {580,0.00010811}, {585,0.00014414}, {590,0.00017117}, {595,0.00010811}, {600,0.00012613}, {605,0.00000000}, {610,0.00000000}, {615,0.00013514}, {620,0.00010811}, {625,0.00028829}, {630,0.00009910}, {635,0.00010811}, {640,0.00013514}, {645,0.00018018}, {650,0.00014414}, {655,0.00007207}, {660,0.00021622}, {665,0.00003604}, {670,0.00007207}, {675,0.00014414}, {680,0.00018018}, {685,0.00018018}, {690,0.00002703}, {695,0.00010811}, {700,0.00014414}, {705,0.00010811}, {710,0.00007207}, {715,0.00002703}, {720,0.00028829}, {725,0.00018018}, {730,0.00017117}, {735,0.00010811}, {740,0.00018018}, {745,0.00006306}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00013514}, {770,0.00010811}, {775,0.00007207}, {780,0.00024324}, {785,0.00014414}, {790,0.00025225}, {795,0.00003604}, {800,0.00028829}, {805,0.00018018}, {810,0.00010811}, {815,0.00014414}, {820,0.00013514}, {825,0.00014414}, {830,0.00021622}, {835,0.00025225}, {840,0.00025225}, {845,0.00032432}, {850,0.00014414}, {855,0.00028829}, {860,0.00014414}, {865,0.00010811}, {870,0.00028829}, {875,0.00031532}, {880,0.00025225}, {885,0.00003604}, {890,0.00025225}, {895,0.00025225}, {900,0.00009910}, {905,0.00021622}, {910,0.00014414}, {915,0.00014414}, {920,0.00007207}, {925,0.00025225}, {930,0.00021622}, {935,0.00025225}, {940,0.00007207}, {945,0.00035135}, {950,0.00017117}, {955,0.00028829}, {960,0.00027928}, {965,0.00021622}, {970,0.00018018}, {975,0.00027928}, {980,0.00010811}, {985,0.00031532}, {990,0.00018018}, {995,0.00018018}, {1000,0.00018018}, {1010,0.00027027}, {1020,0.00043243}, {1030,0.00010811}, {1040,0.00010811}, {1050,0.00002727}, {1060,0.00014545}, {1070,0.00021818}, {1080,0.00018182}, {1090,0.00153636}, {1100,0.00010909}, {1110,0.00021818}, {1120,0.00017273}, {1130,0.00020909}, {1140,0.00018182}, {1150,0.00007273}, {1160,0.00025455}, {1170,0.00031818}, {1180,0.00020909}, {1190,0.00032727}, {1200,0.00010909}, {1210,0.00010909}, {1220,0.00018182}, {1230,0.00018182}, {1240,0.00003636}, {1250,0.00039091}, {1260,0.00040000}, {1270,0.00032727}, {1280,0.00030909}, {1290,0.00036364}, {1300,0.00014545}, {1310,0.00041818}, {1320,0.00021818}, {1330,0.00020909}, {1340,0.00025455}, {1350,0.00021818}, {1360,0.00021818}, {1370,0.00036364}, {1380,0.00025455}, {1390,0.00031818}, {1400,0.00020909}, {1410,0.00036364}, {1420,0.00036364}, {1430,0.00041818}, {1440,0.00040000}, {1450,0.00036364}, {1460,0.00018182}, {1470,0.00017273}, {1480,0.00039091}, {1490,0.00021818}, {1500,0.00034545}, {1510,0.00021818}, {1520,0.00003636}, {1530,0.00018182}, {1540,0.00007273}, {1550,0.00006364}, {1560,0.00000000}, {1570,0.00003636}, {1580,0.00003636}, {1590,0.00003636}, {1600,0.00007273}, {1610,0.00003636}, {1620,0.00018182}, {1630,0.00149091}, {1640,0.00003636}, {1650,0.00010909}, {1660,0.00018182}, {1670,0.00021818}, {1680,0.00007273}, {1690,0.00007273}, {1700,0.00003636}, {1710,0.00010000}, {1720,0.00010000}, {1730,0.00013636}, {1740,0.00007273}, {1750,0.00014545}, {1760,0.00007273}, {1770,0.00010909}, {1780,0.00013636}, {1790,0.00021818}, {1800,0.00014545}, {1810,0.00007273}, {1820,0.00029091}, {1830,0.00031818}, {1840,0.00018182}, {1850,0.00010909}, {1860,0.00007273}, {1870,0.00010909}, {1880,0.00000000}, {1890,0.00007273}, {1900,0.00007273}, {1910,0.00003636}, {1920,0.00018182}, {1930,0.00024545}, {1940,0.00007273}, {1950,0.00007273}, {1960,0.00007273}, {1970,0.00014545}, {1980,0.00010909}, {1990,0.00003636}, {2000,0.00000000}, {2050,0.00007273}, {2100,0.00003636}, {2150,0.00006364}, {2200,0.00000000}, {2250,0.00028182}, {2300,0.00053636}, {2350,0.00010909}, {2400,0.00003636}, {2450,0.00007273}, {2500,0.00007273}, {2550,0.00029091}, {2600,0.00010909}, {2650,0.00010909}, {2700,0.00014545}, {2750,0.00007273}, {2800,0.00003636}, {2850,0.00010909}, {2900,0.00000000}, {2950,0.00010909}, {3000,0.00014545}, {3050,0.00003636}, {3100,0.00007273}, {3150,0.00007273}, {3200,0.00018182}, {3250,0.00010909}, {3300,0.00014545}, {3350,0.00025455}, {3400,0.00010909}, {3450,0.00014545}, {3500,0.00007273}, {3550,0.00020909}, {3600,0.00010909}, {3650,0.00017273}, {3700,0.00020909}, {3750,0.00018182}, {3800,0.00003636}, {3850,0.00006364}, {3900,0.00014545}, {3950,0.00021818}, {4000,0.00014545}, {4050,0.00010909}, {4100,0.00014545}, {4150,0.00007273}, {4200,0.00018182}, {4250,0.00010909}, {4300,0.00012727}, {4350,0.00021818}, {4400,0.00014545}, {4450,0.00018182}, {4500,0.00018182}, {4550,0.00021818}, {4600,0.00014545}, {4650,0.00010909}, {4700,0.00127273}, {4750,0.00107273}, {4800,0.00076364}, {4850,0.00112727}, {4900,0.00082727}, {4950,0.00084545}, {5000,0.00105455}, {5050,0.00097273}, {5100,0.00047273}, {5150,0.00007273}, {5200,0.00014545}, {5250,0.00007273}, {5300,0.00010909}, {5350,0.00010909}, {5400,0.00017273}, {5450,0.00021818}, {5500,0.00053636}, {5550,0.00040000}, {5600,0.00040000}, {5650,0.00014545}, {5700,0.00020909}, {5750,0.00018182}, {5800,0.00024545}, {5850,0.00018182}, {5900,0.00025455}, {5950,0.00007273}, {6000,0.00007273}, {6050,0.00100}, {6100,0.00300}, {6150,0.00200}, {6200,0.00000}, {6250,0.00000}, {6300,0.00100}, {6350,0.00200}, {6400,0.00300}, {6450,0.00000}, {6500,0.00100}, {6550,0.00000}, {6600,0.00000}, {6650,0.00075}, {6700,0.00100}, {6750,0.00000}, {6800,0.00200}, {6850,0.00000}, {6900,0.00100}, {6950,0.00000}, {7000,0.00275}, {7050,0.00300}, {7100,0.00100}, {7150,0.00000}, {7200,0.00000}, {7250,0.00200}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00100}, {7500,0.00200}, {7550,0.00100}, {7600,0.00200}, {7650,0.00200}, {7700,0.00100}, {7750,0.00000}, {7800,0.00000}, {7850,0.00100}, {7900,0.00100}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00100}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00100}, {8950,0.00000}, {9000,0.00100}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00100}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00100}, {9750,0.00100}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00100}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00100}, {10800,0.00000}, {10900,0.00100}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00100}, {11700,0.00100}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00100}, {12400,0.00000}, {12500,0.00000}, {12600,0.00100}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00100}, {13200,0.00000}, {13300,0.00000}, {13400,0.00100}, {13500,0.00100}, {13600,0.00100}, {13700,0.00000}, {13800,0.00100}, {13900,0.00000}, {14000,0.00200}, {14100,0.00200}, {14200,0.00200}, {14300,0.00000}, {14400,0.00075}, {14500,0.00300}, {14600,0.00000}, {14700,0.00000}, {14800,0.00200}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00100}, {16000,0.00100}, {16100,0.00100}, {16200,0.00000}, {16300,0.00300}, {16400,0.00000}, {16500,0.00000}, {16600,0.00100}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00200}, {17100,0.00100}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00100}, {18200,0.00000}, {18300,0.00000}, {18400,0.00075}, {18500,0.00000}, {18600,0.00000}, {18700,0.00100}, {18800,0.00000}, {18900,0.00000}, {19000,0.00100}, {19100,0.00000}, {19200,0.00100}, {19300,0.00000}, {19400,0.00100}, {19500,0.00200}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresPHOAS"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00098198}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000901}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000901}, {306,0.00000000}, {307,0.00294595}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00001802}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00005405}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000901}, {405,0.00295495}, {406,0.00001802}, {407,0.00254054}, {408,0.00000901}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00001802}, {413,0.00000901}, {414,0.00001802}, {415,0.00001802}, {416,0.00000000}, {417,0.00001802}, {418,0.00000901}, {419,0.00002703}, {420,0.00001802}, {421,0.00000901}, {422,0.00002703}, {423,0.00006306}, {424,0.00003604}, {425,0.00002703}, {426,0.00005405}, {427,0.00007207}, {428,0.00004505}, {429,0.00010811}, {430,0.00008108}, {431,0.00008108}, {432,0.00009910}, {433,0.00014414}, {434,0.00013514}, {435,0.00009009}, {436,0.00018018}, {437,0.00022523}, {438,0.00024324}, {439,0.00025225}, {440,0.00023423}, {441,0.00033333}, {442,0.00294595}, {443,0.00036036}, {444,0.00037838}, {445,0.00049550}, {446,0.00047748}, {447,0.00051351}, {448,0.00267568}, {449,0.00059459}, {450,0.00061261}, {451,0.00063964}, {452,0.00057658}, {453,0.00061261}, {454,0.00066667}, {455,0.00072072}, {456,0.00072973}, {457,0.00067568}, {458,0.00070270}, {459,0.00072973}, {460,0.00076577}, {461,0.00069369}, {462,0.00081081}, {463,0.00072973}, {464,0.00080180}, {465,0.00081982}, {466,0.00081982}, {467,0.00267568}, {468,0.00089189}, {469,0.00083784}, {470,0.00087387}, {471,0.00092793}, {472,0.00090991}, {473,0.00093694}, {474,0.00094595}, {475,0.00095495}, {476,0.00095495}, {477,0.00097297}, {478,0.00098198}, {479,0.00098198}, {480,0.00097297}, {481,0.00100000}, {482,0.00099099}, {483,0.00097297}, {484,0.00296396}, {485,0.00100000}, {486,0.00099099}, {487,0.00100000}, {488,0.00100000}, {489,0.00245045}, {490,0.00100000}, {491,0.00100000}, {492,0.00100000}, {493,0.00100000}, {494,0.00100000}, {495,0.00304505}, {496,0.00100000}, {497,0.00100000}, {498,0.00100000}, {499,0.00100000}, {500,0.00100000}, {505,0.00100000}, {510,0.00272973}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00100000}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00102703}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00102703}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00102703}, {820,0.00102703}, {825,0.00103604}, {830,0.00272973}, {835,0.00104505}, {840,0.00106306}, {845,0.00109910}, {850,0.00118919}, {855,0.00114414}, {860,0.00130631}, {865,0.00135135}, {870,0.00151351}, {875,0.00155856}, {880,0.00160360}, {885,0.00159459}, {890,0.00164865}, {895,0.00161261}, {900,0.00172973}, {905,0.00178378}, {910,0.00183784}, {915,0.00189189}, {920,0.00191892}, {925,0.00198198}, {930,0.00196396}, {935,0.00198198}, {940,0.00198198}, {945,0.00198198}, {950,0.00200000}, {955,0.00200000}, {960,0.00200000}, {965,0.00200000}, {970,0.00200000}, {975,0.00200000}, {980,0.00200000}, {985,0.00200000}, {990,0.00200000}, {995,0.00200000}, {1000,0.00200000}, {1010,0.00200000}, {1020,0.00200000}, {1030,0.00200000}, {1040,0.00200000}, {1050,0.00200000}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200000}, {1140,0.00200000}, {1150,0.00200000}, {1160,0.00200000}, {1170,0.00200000}, {1180,0.00200000}, {1190,0.00200000}, {1200,0.00202727}, {1210,0.00202727}, {1220,0.00202727}, {1230,0.00207273}, {1240,0.00207273}, {1250,0.00214545}, {1260,0.00222727}, {1270,0.00728182}, {1280,0.00247273}, {1290,0.00259091}, {1300,0.00263636}, {1310,0.00279091}, {1320,0.00278182}, {1330,0.00277273}, {1340,0.00285455}, {1350,0.00563636}, {1360,0.00290000}, {1370,0.00297273}, {1380,0.00296364}, {1390,0.00300000}, {1400,0.00300000}, {1410,0.00300000}, {1420,0.00300000}, {1430,0.00300000}, {1440,0.00300000}, {1450,0.00300000}, {1460,0.00300000}, {1470,0.00308182}, {1480,0.00300000}, {1490,0.00300909}, {1500,0.00300000}, {1510,0.00300000}, {1520,0.00300000}, {1530,0.00708182}, {1540,0.00301818}, {1550,0.00300000}, {1560,0.00300000}, {1570,0.00307273}, {1580,0.00300909}, {1590,0.00305455}, {1600,0.00307273}, {1610,0.00308182}, {1620,0.00310909}, {1630,0.00311818}, {1640,0.01046364}, {1650,0.00330909}, {1660,0.00330909}, {1670,0.00340000}, {1680,0.00345455}, {1690,0.00367273}, {1700,0.00362727}, {1710,0.00361818}, {1720,0.00372727}, {1730,0.00379091}, {1740,0.00375455}, {1750,0.00382727}, {1760,0.00389091}, {1770,0.00796364}, {1780,0.00394545}, {1790,0.00393636}, {1800,0.00397273}, {1810,0.00400000}, {1820,0.00400000}, {1830,0.00400000}, {1840,0.00400909}, {1850,0.00400000}, {1860,0.00400000}, {1870,0.00400909}, {1880,0.00400000}, {1890,0.00400000}, {1900,0.00400909}, {1910,0.00402727}, {1920,0.00414545}, {1930,0.00400000}, {1940,0.00402727}, {1950,0.00400909}, {1960,0.00401818}, {1970,0.00404545}, {1980,0.00725455}, {1990,0.00406364}, {2000,0.00417273}, {2050,0.00438182}, {2100,0.00462727}, {2150,0.00483636}, {2200,0.00499091}, {2250,0.00500000}, {2300,0.00502727}, {2350,0.00522727}, {2400,0.00535455}, {2450,0.00570909}, {2500,0.00578182}, {2550,0.00591818}, {2600,0.00595455}, {2650,0.00600909}, {2700,0.00611818}, {2750,0.00631818}, {2800,0.00641818}, {2850,0.00664545}, {2900,0.01108182}, {2950,0.00703636}, {3000,0.00702727}, {3050,0.00712727}, {3100,0.00727273}, {3150,0.00746364}, {3200,0.00761818}, {3250,0.00774545}, {3300,0.00788182}, {3350,0.00798182}, {3400,0.00817273}, {3450,0.01658182}, {3500,0.00829091}, {3550,0.00857273}, {3600,0.00861818}, {3650,0.00880000}, {3700,0.01880909}, {3750,0.00900909}, {3800,0.00917273}, {3850,0.00930000}, {3900,0.00956364}, {3950,0.02018182}, {4000,0.00972727}, {4050,0.00988182}, {4100,0.00993636}, {4150,0.01020909}, {4200,0.01038182}, {4250,0.01058182}, {4300,0.01070909}, {4350,0.01090000}, {4400,0.01090909}, {4450,0.01696364}, {4500,0.01820909}, {4550,0.01138182}, {4600,0.01158182}, {4650,0.01169091}, {4700,0.01181818}, {4750,0.01190000}, {4800,0.01204545}, {4850,0.02238182}, {4900,0.01245455}, {4950,0.01256364}, {5000,0.01265455}, {5050,0.01270000}, {5100,0.01283636}, {5150,0.01300909}, {5200,0.01309091}, {5250,0.01346364}, {5300,0.02919091}, {5350,0.01345455}, {5400,0.01363636}, {5450,0.01368182}, {5500,0.01376364}, {5550,0.01394545}, {5600,0.01834545}, {5650,0.01400909}, {5700,0.01396364}, {5750,0.01410000}, {5800,0.01416364}, {5850,0.01415455}, {5900,0.01426364}, {5950,0.01426364}, {6000,0.01427273}, {6050,0.01500}, {6100,0.02200}, {6150,0.01550}, {6200,0.02075}, {6250,0.01575}, {6300,0.01600}, {6350,0.02350}, {6400,0.01625}, {6450,0.01625}, {6500,0.01600}, {6550,0.01625}, {6600,0.02475}, {6650,0.01700}, {6700,0.01700}, {6750,0.01700}, {6800,0.02375}, {6850,0.02475}, {6900,0.01725}, {6950,0.01775}, {7000,0.01850}, {7050,0.01800}, {7100,0.03600}, {7150,0.02625}, {7200,0.02300}, {7250,0.01875}, {7300,0.02175}, {7350,0.02650}, {7400,0.03350}, {7450,0.01925}, {7500,0.01925}, {7550,0.01975}, {7600,0.01950}, {7650,0.02725}, {7700,0.02950}, {7750,0.01975}, {7800,0.02000}, {7850,0.03775}, {7900,0.02025}, {7950,0.02050}, {8000,0.02000}, {8050,0.02050}, {8100,0.04300}, {8150,0.02075}, {8200,0.02100}, {8250,0.02125}, {8300,0.02100}, {8350,0.02075}, {8400,0.02150}, {8450,0.02150}, {8500,0.02100}, {8550,0.02125}, {8600,0.02675}, {8650,0.03450}, {8700,0.03325}, {8750,0.02150}, {8800,0.02200}, {8850,0.03675}, {8900,0.02275}, {8950,0.02250}, {9000,0.03675}, {9050,0.03675}, {9100,0.02250}, {9150,0.04275}, {9200,0.02250}, {9250,0.02300}, {9300,0.03575}, {9350,0.02975}, {9400,0.03450}, {9450,0.02350}, {9500,0.02300}, {9550,0.02400}, {9600,0.05050}, {9650,0.02925}, {9700,0.02400}, {9750,0.02450}, {9800,0.02450}, {9850,0.02475}, {9900,0.02475}, {9950,0.02425}, {10000,0.03450}, {10100,0.02500}, {10200,0.02550}, {10300,0.02625}, {10400,0.03425}, {10500,0.02550}, {10600,0.03175}, {10700,0.04825}, {10800,0.04325}, {10900,0.02750}, {11000,0.04275}, {11100,0.02750}, {11200,0.02775}, {11300,0.04475}, {11400,0.02825}, {11500,0.02850}, {11600,0.04775}, {11700,0.05300}, {11800,0.04025}, {11900,0.04325}, {12000,0.03025}, {12100,0.03025}, {12200,0.03850}, {12300,0.03875}, {12400,0.04525}, {12500,0.04325}, {12600,0.03225}, {12700,0.03875}, {12800,0.03275}, {12900,0.05525}, {13000,0.03825}, {13100,0.05750}, {13200,0.03375}, {13300,0.04650}, {13400,0.04525}, {13500,0.06100}, {13600,0.03425}, {13700,0.04675}, {13800,0.05825}, {13900,0.03550}, {14000,0.04875}, {14100,0.06375}, {14200,0.03575}, {14300,0.06550}, {14400,0.05250}, {14500,0.05200}, {14600,0.03775}, {14700,0.05100}, {14800,0.07225}, {14900,0.05500}, {15000,0.05275}, {15100,0.06800}, {15200,0.05325}, {15300,0.05575}, {15400,0.04000}, {15500,0.05250}, {15600,0.07550}, {15700,0.04150}, {15800,0.04150}, {15900,0.05150}, {16000,0.07850}, {16100,0.08125}, {16200,0.07675}, {16300,0.05625}, {16400,0.06325}, {16500,0.05500}, {16600,0.07250}, {16700,0.07875}, {16800,0.05275}, {16900,0.05250}, {17000,0.04500}, {17100,0.07650}, {17200,0.04525}, {17300,0.06150}, {17400,0.08125}, {17500,0.05350}, {17600,0.04575}, {17700,0.05700}, {17800,0.06200}, {17900,0.05775}, {18000,0.08250}, {18100,0.07425}, {18200,0.09350}, {18300,0.06350}, {18400,0.04925}, {18500,0.06450}, {18600,0.09100}, {18700,0.04850}, {18800,0.04950}, {18900,0.04900}, {19000,0.06100}, {19100,0.07825}, {19200,0.08175}, {19300,0.09700}, {19400,0.05100}, {19500,0.06425}, {19600,0.10000}, {19700,0.06275}, {19800,0.10050}, {19900,0.06400}, {20000,0.0525}};
data["big_flat"]["CanonicalStructuresPHOAS"]["cbv"]["user"] = {{1,0.00002703}, {2,0.00003604}, {3,0.00002703}, {4,0.00000000}, {5,0.00002703}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00003604}, {10,0.00000000}, {11,0.00003604}, {12,0.00000000}, {13,0.00003604}, {14,0.00006306}, {15,0.00006306}, {16,0.00006306}, {17,0.00009910}, {18,0.00003604}, {19,0.00012613}, {20,0.00002703}, {21,0.00000000}, {22,0.00002703}, {23,0.00008108}, {24,0.00006306}, {25,0.00005405}, {26,0.00005405}, {27,0.00003604}, {28,0.00017117}, {29,0.00006306}, {30,0.00009009}, {31,0.00009910}, {32,0.00017117}, {33,0.00017117}, {34,0.00011712}, {35,0.00002703}, {36,0.00003604}, {37,0.00005405}, {38,0.00010811}, {39,0.00009910}, {40,0.00006306}, {41,0.00026126}, {42,0.00006306}, {43,0.00011712}, {44,0.00005405}, {45,0.00027027}, {46,0.00006306}, {47,0.00009009}, {48,0.00002703}, {49,0.00010811}, {50,0.00018018}, {51,0.00010811}, {52,0.00008108}, {53,0.00011712}, {54,0.00008108}, {55,0.00003604}, {56,0.00000000}, {57,0.00015315}, {58,0.00005405}, {59,0.00014414}, {60,0.00009009}, {61,0.00009910}, {62,0.00009009}, {63,0.00012613}, {64,0.00014414}, {65,0.00018919}, {66,0.00011712}, {67,0.00027928}, {68,0.00013514}, {69,0.00009009}, {70,0.00011712}, {71,0.00016216}, {72,0.00021622}, {73,0.00009009}, {74,0.00005405}, {75,0.00011712}, {76,0.00010811}, {77,0.00013514}, {78,0.00005405}, {79,0.00005405}, {80,0.00027027}, {81,0.00016216}, {82,0.00014414}, {83,0.00027027}, {84,0.00021622}, {85,0.00012613}, {86,0.00021622}, {87,0.00005405}, {88,0.00023423}, {89,0.00010811}, {90,0.00017117}, {91,0.00022523}, {92,0.00028829}, {93,0.00009009}, {94,0.00030631}, {95,0.00021622}, {96,0.00024324}, {97,0.00028829}, {98,0.00016216}, {99,0.00028829}, {100,0.00040541}, {101,0.00005405}, {102,0.00026126}, {103,0.00019820}, {104,0.00020721}, {105,0.00032432}, {106,0.00018018}, {107,0.00036036}, {108,0.00030631}, {109,0.00022523}, {110,0.00017117}, {111,0.00021622}, {112,0.00019820}, {113,0.00014414}, {114,0.00028829}, {115,0.00010811}, {116,0.00015315}, {117,0.00033333}, {118,0.00010811}, {119,0.00033333}, {120,0.00027027}, {121,0.00021622}, {122,0.00017117}, {123,0.00018018}, {124,0.00018018}, {125,0.00016216}, {126,0.00024324}, {127,0.00027027}, {128,0.00027928}, {129,0.00014414}, {130,0.00025225}, {131,0.00030631}, {132,0.00035135}, {133,0.00015315}, {134,0.00035135}, {135,0.00021622}, {136,0.00012613}, {137,0.00025225}, {138,0.00031532}, {139,0.00021622}, {140,0.00025225}, {141,0.00031532}, {142,0.00017117}, {143,0.00035135}, {144,0.00029730}, {145,0.00018018}, {146,0.00016216}, {147,0.00040541}, {148,0.00018919}, {149,0.00029730}, {150,0.00024324}, {151,0.00038739}, {152,0.00027027}, {153,0.00026126}, {154,0.00029730}, {155,0.00046847}, {156,0.00039640}, {157,0.00035135}, {158,0.00038739}, {159,0.00027027}, {160,0.00031532}, {161,0.00005405}, {162,0.00021622}, {163,0.00034234}, {164,0.00032432}, {165,0.00043243}, {166,0.00030631}, {167,0.00029730}, {168,0.00031532}, {169,0.00038739}, {170,0.00038739}, {171,0.00037838}, {172,0.00028829}, {173,0.00024324}, {174,0.00030631}, {175,0.00039640}, {176,0.00020721}, {177,0.00022523}, {178,0.00037838}, {179,0.00019820}, {180,0.00037838}, {181,0.00045946}, {182,0.00036937}, {183,0.00030631}, {184,0.00036937}, {185,0.00053153}, {186,0.00032432}, {187,0.00025225}, {188,0.00022523}, {189,0.00048649}, {190,0.00036937}, {191,0.00036937}, {192,0.00021622}, {193,0.00018018}, {194,0.00026126}, {195,0.00029730}, {196,0.00049550}, {197,0.00059459}, {198,0.00034234}, {199,0.00025225}, {200,0.00041441}, {201,0.00033333}, {202,0.00021622}, {203,0.00057658}, {204,0.00032432}, {205,0.00042342}, {206,0.00041441}, {207,0.00042342}, {208,0.00027928}, {209,0.00048649}, {210,0.00045045}, {211,0.00056757}, {212,0.00049550}, {213,0.00035135}, {214,0.00041441}, {215,0.00034234}, {216,0.00050450}, {217,0.00042342}, {218,0.00063964}, {219,0.00033333}, {220,0.00056757}, {221,0.00027928}, {222,0.00035135}, {223,0.00053153}, {224,0.00036937}, {225,0.00037838}, {226,0.00038739}, {227,0.00153153}, {228,0.00036036}, {229,0.00038739}, {230,0.00030631}, {231,0.00043243}, {232,0.00038739}, {233,0.00033333}, {234,0.00044144}, {235,0.00040541}, {236,0.00048649}, {237,0.00048649}, {238,0.00040541}, {239,0.00043243}, {240,0.00071171}, {241,0.00077477}, {242,0.00041441}, {243,0.00048649}, {244,0.00037838}, {245,0.00035135}, {246,0.00043243}, {247,0.00048649}, {248,0.00031532}, {249,0.00039640}, {250,0.00073874}, {251,0.00031532}, {252,0.00068468}, {253,0.00047748}, {254,0.00027027}, {255,0.00022523}, {256,0.00051351}, {257,0.00054054}, {258,0.00047748}, {259,0.00040541}, {260,0.00046847}, {261,0.00055856}, {262,0.00045946}, {263,0.00048649}, {264,0.00055856}, {265,0.00053153}, {266,0.00045946}, {267,0.00048649}, {268,0.00053153}, {269,0.00054054}, {270,0.00045045}, {271,0.00054955}, {272,0.00047748}, {273,0.00074775}, {274,0.00049550}, {275,0.00044144}, {276,0.00034234}, {277,0.00058559}, {278,0.00048649}, {279,0.00024324}, {280,0.00044144}, {281,0.00054054}, {282,0.00043243}, {283,0.00056757}, {284,0.00064865}, {285,0.00053153}, {286,0.00048649}, {287,0.00037838}, {288,0.00050450}, {289,0.00071171}, {290,0.00038739}, {291,0.00037838}, {292,0.00046847}, {293,0.00031532}, {294,0.00069369}, {295,0.00031532}, {296,0.00045045}, {297,0.00062162}, {298,0.00045946}, {299,0.00072973}, {300,0.00046847}, {301,0.00059459}, {302,0.00045045}, {303,0.00039640}, {304,0.00045045}, {305,0.00065766}, {306,0.00052252}, {307,0.00261261}, {308,0.00066667}, {309,0.00048649}, {310,0.00048649}, {311,0.00054955}, {312,0.00042342}, {313,0.00070270}, {314,0.00071171}, {315,0.00053153}, {316,0.00044144}, {317,0.00058559}, {318,0.00065766}, {319,0.00067568}, {320,0.00048649}, {321,0.00055856}, {322,0.00065766}, {323,0.00076577}, {324,0.00066667}, {325,0.00072973}, {326,0.00079279}, {327,0.00079279}, {328,0.00046847}, {329,0.00052252}, {330,0.00066667}, {331,0.00065766}, {332,0.00074775}, {333,0.00081982}, {334,0.00065766}, {335,0.00079279}, {336,0.00059459}, {337,0.00079279}, {338,0.00060360}, {339,0.00058559}, {340,0.00059459}, {341,0.00058559}, {342,0.00049550}, {343,0.00072973}, {344,0.00071171}, {345,0.00076577}, {346,0.00078378}, {347,0.00050450}, {348,0.00072973}, {349,0.00070270}, {350,0.00066667}, {351,0.00073874}, {352,0.00055856}, {353,0.00048649}, {354,0.00062162}, {355,0.00041441}, {356,0.00061261}, {357,0.00068468}, {358,0.00065766}, {359,0.00063063}, {360,0.00037838}, {361,0.00071171}, {362,0.00072973}, {363,0.00064865}, {364,0.00066667}, {365,0.00056757}, {366,0.00081081}, {367,0.00063964}, {368,0.00071171}, {369,0.00069369}, {370,0.00066667}, {371,0.00055856}, {372,0.00101802}, {373,0.00076577}, {374,0.00072973}, {375,0.00042342}, {376,0.00061261}, {377,0.00096396}, {378,0.00073874}, {379,0.00079279}, {380,0.00073874}, {381,0.00064865}, {382,0.00096396}, {383,0.00063964}, {384,0.00089189}, {385,0.00066667}, {386,0.00088288}, {387,0.00069369}, {388,0.00074775}, {389,0.00036937}, {390,0.00060360}, {391,0.00085586}, {392,0.00082883}, {393,0.00064865}, {394,0.00073874}, {395,0.00066667}, {396,0.00081982}, {397,0.00060360}, {398,0.00063964}, {399,0.00071171}, {400,0.00114414}, {401,0.00085586}, {402,0.00071171}, {403,0.00058559}, {404,0.00077477}, {405,0.00281982}, {406,0.00069369}, {407,0.00237838}, {408,0.00081081}, {409,0.00076577}, {410,0.00079279}, {411,0.00074775}, {412,0.00077477}, {413,0.00072973}, {414,0.00076577}, {415,0.00072973}, {416,0.00094595}, {417,0.00072973}, {418,0.00072072}, {419,0.00063964}, {420,0.00082883}, {421,0.00036036}, {422,0.00063063}, {423,0.00091892}, {424,0.00073874}, {425,0.00094595}, {426,0.00077477}, {427,0.00096396}, {428,0.00099099}, {429,0.00068468}, {430,0.00084685}, {431,0.00068468}, {432,0.00072973}, {433,0.00074775}, {434,0.00082883}, {435,0.00072973}, {436,0.00075676}, {437,0.00053153}, {438,0.00077477}, {439,0.00092793}, {440,0.00070270}, {441,0.00090090}, {442,0.00292793}, {443,0.00066667}, {444,0.00086486}, {445,0.00088288}, {446,0.00080180}, {447,0.00098198}, {448,0.00260360}, {449,0.00082883}, {450,0.00072973}, {451,0.00096396}, {452,0.00080180}, {453,0.00120721}, {454,0.00095495}, {455,0.00113514}, {456,0.00072072}, {457,0.00099099}, {458,0.00078378}, {459,0.00109009}, {460,0.00106306}, {461,0.00090991}, {462,0.00098198}, {463,0.00081982}, {464,0.00076577}, {465,0.00090991}, {466,0.00070270}, {467,0.00247748}, {468,0.00099099}, {469,0.00092793}, {470,0.00089189}, {471,0.00076577}, {472,0.00073874}, {473,0.00083784}, {474,0.00098198}, {475,0.00082883}, {476,0.00136036}, {477,0.00093694}, {478,0.00092793}, {479,0.00074775}, {480,0.00084685}, {481,0.00097297}, {482,0.00093694}, {483,0.00079279}, {484,0.00278378}, {485,0.00079279}, {486,0.00115315}, {487,0.00069369}, {488,0.00111712}, {489,0.00239640}, {490,0.00056757}, {491,0.00090991}, {492,0.00102703}, {493,0.00100901}, {494,0.00064865}, {495,0.00306306}, {496,0.00109009}, {497,0.00077477}, {498,0.00072973}, {499,0.00088288}, {500,0.00090991}, {505,0.00065766}, {510,0.00252252}, {515,0.00097297}, {520,0.00105405}, {525,0.00087387}, {530,0.00085586}, {535,0.00076577}, {540,0.00104505}, {545,0.00109009}, {550,0.00080180}, {555,0.00093694}, {560,0.00103604}, {565,0.00109009}, {570,0.00080180}, {575,0.00135135}, {580,0.00114414}, {585,0.00111712}, {590,0.00111712}, {595,0.00126126}, {600,0.00138739}, {605,0.00121622}, {610,0.00125225}, {615,0.00114414}, {620,0.00116216}, {625,0.00113514}, {630,0.00120721}, {635,0.00111712}, {640,0.00145045}, {645,0.00133333}, {650,0.00100901}, {655,0.00127928}, {660,0.00134234}, {665,0.00120721}, {670,0.00128829}, {675,0.00117117}, {680,0.00165766}, {685,0.00141441}, {690,0.00139640}, {695,0.00107207}, {700,0.00109009}, {705,0.00111712}, {710,0.00164865}, {715,0.00138739}, {720,0.00147748}, {725,0.00118919}, {730,0.00142342}, {735,0.00163964}, {740,0.00118919}, {745,0.00096396}, {750,0.00144144}, {755,0.00126126}, {760,0.00139640}, {765,0.00128829}, {770,0.00163063}, {775,0.00127027}, {780,0.00154955}, {785,0.00121622}, {790,0.00154054}, {795,0.00170270}, {800,0.00157658}, {805,0.00141441}, {810,0.00143243}, {815,0.00143243}, {820,0.00151351}, {825,0.00159459}, {830,0.00257658}, {835,0.00137838}, {840,0.00193694}, {845,0.00176577}, {850,0.00162162}, {855,0.00168468}, {860,0.00155856}, {865,0.00201802}, {870,0.00154955}, {875,0.00185586}, {880,0.00154054}, {885,0.00157658}, {890,0.00167568}, {895,0.00150450}, {900,0.00159459}, {905,0.00156757}, {910,0.00181982}, {915,0.00219820}, {920,0.00193694}, {925,0.00187387}, {930,0.00176577}, {935,0.00153153}, {940,0.00185586}, {945,0.00161261}, {950,0.00198198}, {955,0.00175676}, {960,0.00183784}, {965,0.00206306}, {970,0.00172973}, {975,0.00174775}, {980,0.00197297}, {985,0.00163964}, {990,0.00200901}, {995,0.00172072}, {1000,0.00159459}, {1010,0.00181081}, {1020,0.00190090}, {1030,0.00189189}, {1040,0.00194595}, {1050,0.00200909}, {1060,0.00195455}, {1070,0.00219091}, {1080,0.00213636}, {1090,0.00227273}, {1100,0.00220909}, {1110,0.00208182}, {1120,0.00227273}, {1130,0.00202727}, {1140,0.00230000}, {1150,0.00232727}, {1160,0.00220000}, {1170,0.00247273}, {1180,0.00241818}, {1190,0.00229091}, {1200,0.00214545}, {1210,0.00239091}, {1220,0.00193636}, {1230,0.00266364}, {1240,0.00244545}, {1250,0.00265455}, {1260,0.00268182}, {1270,0.00696364}, {1280,0.00223636}, {1290,0.00256364}, {1300,0.00235455}, {1310,0.00272727}, {1320,0.00272727}, {1330,0.00270000}, {1340,0.00269091}, {1350,0.00571818}, {1360,0.00280000}, {1370,0.00294545}, {1380,0.00269091}, {1390,0.00297273}, {1400,0.00294545}, {1410,0.00298182}, {1420,0.00307273}, {1430,0.00294545}, {1440,0.00318182}, {1450,0.00330909}, {1460,0.00331818}, {1470,0.00320909}, {1480,0.00320000}, {1490,0.00329091}, {1500,0.00314545}, {1510,0.00315455}, {1520,0.00350000}, {1530,0.00714545}, {1540,0.00331818}, {1550,0.00356364}, {1560,0.00342727}, {1570,0.00335455}, {1580,0.00339091}, {1590,0.00360000}, {1600,0.00342727}, {1610,0.00352727}, {1620,0.00348182}, {1630,0.00360909}, {1640,0.01086364}, {1650,0.00370000}, {1660,0.00363636}, {1670,0.00350909}, {1680,0.00366364}, {1690,0.00381818}, {1700,0.00357273}, {1710,0.00375455}, {1720,0.00384545}, {1730,0.00380000}, {1740,0.00368182}, {1750,0.00379091}, {1760,0.00388182}, {1770,0.00787273}, {1780,0.00384545}, {1790,0.00408182}, {1800,0.00379091}, {1810,0.00388182}, {1820,0.00390909}, {1830,0.00397273}, {1840,0.00397273}, {1850,0.00393636}, {1860,0.00413636}, {1870,0.00394545}, {1880,0.00411818}, {1890,0.00417273}, {1900,0.00428182}, {1910,0.00424545}, {1920,0.00430000}, {1930,0.00435455}, {1940,0.00449091}, {1950,0.00416364}, {1960,0.00416364}, {1970,0.00427273}, {1980,0.00714545}, {1990,0.00439091}, {2000,0.00424545}, {2050,0.00457273}, {2100,0.00475455}, {2150,0.00489091}, {2200,0.00493636}, {2250,0.00514545}, {2300,0.00514545}, {2350,0.00540000}, {2400,0.00542727}, {2450,0.00594545}, {2500,0.00583636}, {2550,0.00561818}, {2600,0.00604545}, {2650,0.00615455}, {2700,0.00634545}, {2750,0.00625455}, {2800,0.00683636}, {2850,0.00654545}, {2900,0.01165455}, {2950,0.00700000}, {3000,0.00679091}, {3050,0.00703636}, {3100,0.00701818}, {3150,0.00730909}, {3200,0.00744545}, {3250,0.00742727}, {3300,0.00756364}, {3350,0.00777273}, {3400,0.00798182}, {3450,0.01659091}, {3500,0.00827273}, {3550,0.00859091}, {3600,0.00851818}, {3650,0.00892727}, {3700,0.01856364}, {3750,0.00940000}, {3800,0.00943636}, {3850,0.00934545}, {3900,0.00955455}, {3950,0.02039091}, {4000,0.00970909}, {4050,0.00971818}, {4100,0.00980000}, {4150,0.01031818}, {4200,0.01060909}, {4250,0.01094545}, {4300,0.01090909}, {4350,0.01130909}, {4400,0.01139091}, {4450,0.01740000}, {4500,0.01803636}, {4550,0.01180909}, {4600,0.01216364}, {4650,0.01207273}, {4700,0.01232727}, {4750,0.01230909}, {4800,0.01280000}, {4850,0.02248182}, {4900,0.01290909}, {4950,0.01289091}, {5000,0.01342727}, {5050,0.01343636}, {5100,0.01330000}, {5150,0.01322727}, {5200,0.01350000}, {5250,0.01389091}, {5300,0.02926364}, {5350,0.01377273}, {5400,0.01385455}, {5450,0.01400000}, {5500,0.01420909}, {5550,0.01411818}, {5600,0.01813636}, {5650,0.01412727}, {5700,0.01414545}, {5750,0.01433636}, {5800,0.01470909}, {5850,0.01431818}, {5900,0.01438182}, {5950,0.01425455}, {6000,0.01454545}, {6050,0.01575}, {6100,0.02150}, {6150,0.01575}, {6200,0.02150}, {6250,0.01550}, {6300,0.01575}, {6350,0.02225}, {6400,0.01750}, {6450,0.01575}, {6500,0.01550}, {6550,0.01550}, {6600,0.02550}, {6650,0.01725}, {6700,0.01625}, {6750,0.01500}, {6800,0.02325}, {6850,0.02350}, {6900,0.01825}, {6950,0.01725}, {7000,0.01900}, {7050,0.01800}, {7100,0.03525}, {7150,0.02650}, {7200,0.02275}, {7250,0.01800}, {7300,0.02275}, {7350,0.02575}, {7400,0.03250}, {7450,0.01925}, {7500,0.01925}, {7550,0.01900}, {7600,0.01825}, {7650,0.02600}, {7700,0.02900}, {7750,0.01925}, {7800,0.02050}, {7850,0.03750}, {7900,0.02025}, {7950,0.02025}, {8000,0.01900}, {8050,0.02050}, {8100,0.04150}, {8150,0.02025}, {8200,0.02275}, {8250,0.01925}, {8300,0.02175}, {8350,0.02200}, {8400,0.02075}, {8450,0.02025}, {8500,0.01950}, {8550,0.02025}, {8600,0.02625}, {8650,0.03600}, {8700,0.03350}, {8750,0.02175}, {8800,0.02275}, {8850,0.03675}, {8900,0.02400}, {8950,0.02275}, {9000,0.03575}, {9050,0.03675}, {9100,0.02400}, {9150,0.04450}, {9200,0.02400}, {9250,0.02275}, {9300,0.03800}, {9350,0.03175}, {9400,0.03475}, {9450,0.02400}, {9500,0.02275}, {9550,0.02400}, {9600,0.04975}, {9650,0.02950}, {9700,0.02500}, {9750,0.02500}, {9800,0.02575}, {9850,0.02400}, {9900,0.02600}, {9950,0.02400}, {10000,0.03375}, {10100,0.02500}, {10200,0.02675}, {10300,0.02500}, {10400,0.03550}, {10500,0.02800}, {10600,0.03350}, {10700,0.04825}, {10800,0.04375}, {10900,0.02800}, {11000,0.04400}, {11100,0.02900}, {11200,0.02800}, {11300,0.04425}, {11400,0.02775}, {11500,0.02975}, {11600,0.04825}, {11700,0.05300}, {11800,0.04300}, {11900,0.04275}, {12000,0.02950}, {12100,0.02875}, {12200,0.03975}, {12300,0.04050}, {12400,0.04500}, {12500,0.04350}, {12600,0.03150}, {12700,0.03775}, {12800,0.03250}, {12900,0.05475}, {13000,0.03825}, {13100,0.05675}, {13200,0.03225}, {13300,0.04650}, {13400,0.04450}, {13500,0.06100}, {13600,0.03350}, {13700,0.04750}, {13800,0.05750}, {13900,0.03500}, {14000,0.04825}, {14100,0.06325}, {14200,0.03550}, {14300,0.06675}, {14400,0.05325}, {14500,0.05350}, {14600,0.03850}, {14700,0.05025}, {14800,0.07100}, {14900,0.05375}, {15000,0.05250}, {15100,0.06875}, {15200,0.05225}, {15300,0.05425}, {15400,0.03900}, {15500,0.05150}, {15600,0.07450}, {15700,0.04250}, {15800,0.04125}, {15900,0.05025}, {16000,0.07900}, {16100,0.08050}, {16200,0.07750}, {16300,0.05625}, {16400,0.06325}, {16500,0.05450}, {16600,0.07150}, {16700,0.08050}, {16800,0.05350}, {16900,0.05275}, {17000,0.04450}, {17100,0.07500}, {17200,0.04575}, {17300,0.06150}, {17400,0.08150}, {17500,0.05275}, {17600,0.04475}, {17700,0.05775}, {17800,0.06300}, {17900,0.05675}, {18000,0.08250}, {18100,0.07450}, {18200,0.09350}, {18300,0.06450}, {18400,0.04950}, {18500,0.06450}, {18600,0.09050}, {18700,0.04975}, {18800,0.05025}, {18900,0.05075}, {19000,0.06275}, {19100,0.07725}, {19200,0.08050}, {19300,0.09725}, {19400,0.05175}, {19500,0.06500}, {19600,0.10025}, {19700,0.06225}, {19800,0.10125}, {19900,0.06475}, {20000,0.0540}};
data["big_flat"]["CanonicalStructuresPHOAS"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00003604}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00007207}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00003604}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00002703}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00003604}, {101,0.00000000}, {102,0.00000000}, {103,0.00003604}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00002703}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00003604}, {134,0.00000000}, {135,0.00000000}, {136,0.00003604}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00003604}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00003604}, {158,0.00003604}, {159,0.00003604}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00003604}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00003604}, {188,0.00003604}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00007207}, {198,0.00000000}, {199,0.00000000}, {200,0.00003604}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00002703}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00003604}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00010811}, {230,0.00003604}, {231,0.00007207}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00003604}, {253,0.00000000}, {254,0.00003604}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00003604}, {263,0.00000000}, {264,0.00002703}, {265,0.00000000}, {266,0.00003604}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00003604}, {276,0.00003604}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00003604}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00003604}, {295,0.00000000}, {296,0.00003604}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00007207}, {301,0.00000000}, {302,0.00003604}, {303,0.00000000}, {304,0.00003604}, {305,0.00003604}, {306,0.00000000}, {307,0.00007207}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00003604}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00002703}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00003604}, {351,0.00000000}, {352,0.00000000}, {353,0.00003604}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00003604}, {358,0.00000000}, {359,0.00000000}, {360,0.00003604}, {361,0.00003604}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00007207}, {367,0.00000000}, {368,0.00000000}, {369,0.00003604}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00003604}, {388,0.00000000}, {389,0.00000000}, {390,0.00007207}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00003604}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00003604}, {405,0.00000000}, {406,0.00010811}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00003604}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00003604}, {420,0.00000000}, {421,0.00000000}, {422,0.00002703}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00003604}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00003604}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00003604}, {442,0.00003604}, {443,0.00000000}, {444,0.00000000}, {445,0.00003604}, {446,0.00000000}, {447,0.00010811}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00003604}, {463,0.00000000}, {464,0.00007207}, {465,0.00000000}, {466,0.00000000}, {467,0.00003604}, {468,0.00000000}, {469,0.00007207}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00003604}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00003604}, {485,0.00000000}, {486,0.00003604}, {487,0.00003604}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00003604}, {495,0.00003604}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00003604}, {515,0.00000000}, {520,0.00000000}, {525,0.00003604}, {530,0.00000000}, {535,0.00000000}, {540,0.00006306}, {545,0.00000000}, {550,0.00003604}, {555,0.00007207}, {560,0.00007207}, {565,0.00000000}, {570,0.00003604}, {575,0.00003604}, {580,0.00000000}, {585,0.00003604}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00003604}, {615,0.00000000}, {620,0.00003604}, {625,0.00000000}, {630,0.00003604}, {635,0.00000000}, {640,0.00000000}, {645,0.00002703}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00003604}, {690,0.00003604}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00003604}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00003604}, {775,0.00003604}, {780,0.00000000}, {785,0.00003604}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00003604}, {810,0.00000000}, {815,0.00007207}, {820,0.00000000}, {825,0.00000000}, {830,0.00003604}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00003604}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00003604}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00003604}, {925,0.00003604}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00003604}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00003604}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00003636}, {1060,0.00000000}, {1070,0.00003636}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00003636}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00003636}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00014545}, {1280,0.00003636}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00003636}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00010909}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00007273}, {1390,0.00000000}, {1400,0.00003636}, {1410,0.00003636}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00003636}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003636}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00003636}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003636}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00003636}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00003636}, {1990,0.00000000}, {2000,0.00003636}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00003636}, {2450,0.00000000}, {2500,0.00007273}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00003636}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00003636}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00003636}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00007273}, {3750,0.00003636}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00007273}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00003636}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00007273}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00003636}, {5350,0.00000000}, {5400,0.00003636}, {5450,0.00000000}, {5500,0.00003636}, {5550,0.00000000}, {5600,0.00007273}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00100}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00100}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00100}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00100}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresPHOAS"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00200901}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000901}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000901}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000901}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000901}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00002703}, {251,0.00001802}, {252,0.00000901}, {253,0.00000901}, {254,0.00002703}, {255,0.00005405}, {256,0.00000901}, {257,0.00002703}, {258,0.00002703}, {259,0.00001802}, {260,0.00002703}, {261,0.00000000}, {262,0.00000000}, {263,0.00000901}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000901}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000901}, {274,0.00000000}, {275,0.00000000}, {276,0.00001802}, {277,0.00003604}, {278,0.00000901}, {279,0.00004505}, {280,0.00003604}, {281,0.00015315}, {282,0.00011712}, {283,0.00020721}, {284,0.00030631}, {285,0.00054955}, {286,0.00050450}, {287,0.00060360}, {288,0.00066667}, {289,0.00053153}, {290,0.00066667}, {291,0.00319820}, {292,0.00002703}, {293,0.00001802}, {294,0.00013514}, {295,0.00031532}, {296,0.00046847}, {297,0.00075676}, {298,0.00087387}, {299,0.00088288}, {300,0.00095495}, {301,0.00098198}, {302,0.00008108}, {303,0.00026126}, {304,0.00054955}, {305,0.00084685}, {306,0.00099099}, {307,0.00099099}, {308,0.00100000}, {309,0.00021622}, {310,0.00040541}, {311,0.00073874}, {312,0.00098198}, {313,0.00100000}, {314,0.00100000}, {315,0.00100000}, {316,0.00068468}, {317,0.00093694}, {318,0.00100000}, {319,0.00100000}, {320,0.00100000}, {321,0.00067568}, {322,0.00094595}, {323,0.00100000}, {324,0.00100000}, {325,0.00100000}, {326,0.00076577}, {327,0.00097297}, {328,0.00100000}, {329,0.00100000}, {330,0.00100000}, {331,0.00091892}, {332,0.00100000}, {333,0.00100000}, {334,0.00100000}, {335,0.00093694}, {336,0.00100000}, {337,0.00100000}, {338,0.00100000}, {339,0.00100000}, {340,0.00100000}, {341,0.00100000}, {342,0.00100000}, {343,0.00100000}, {344,0.00100000}, {345,0.00100000}, {346,0.00100000}, {347,0.00100000}, {348,0.00100000}, {349,0.00100000}, {350,0.00100000}, {351,0.00100000}, {352,0.00100000}, {353,0.00489189}, {354,0.00100000}, {355,0.00100000}, {356,0.00100000}, {357,0.00100000}, {358,0.00100000}, {359,0.00100000}, {360,0.00100000}, {361,0.00100000}, {362,0.00100000}, {363,0.00100000}, {364,0.00100000}, {365,0.00100000}, {366,0.00100000}, {367,0.00100000}, {368,0.00100000}, {369,0.00100000}, {370,0.00100000}, {371,0.00100000}, {372,0.00100000}, {373,0.00100000}, {374,0.00100000}, {375,0.00100000}, {376,0.00108108}, {377,0.00100000}, {378,0.00100000}, {379,0.00100000}, {380,0.00100000}, {381,0.00100000}, {382,0.00100000}, {383,0.00100000}, {384,0.00100000}, {385,0.00100000}, {386,0.00100000}, {387,0.00100000}, {388,0.00109009}, {389,0.00100000}, {390,0.00100000}, {391,0.00100000}, {392,0.00100000}, {393,0.00100000}, {394,0.00100000}, {395,0.00100000}, {396,0.00100000}, {397,0.00100000}, {398,0.00100000}, {399,0.00100000}, {400,0.00100000}, {401,0.00100000}, {402,0.00100000}, {403,0.00667568}, {404,0.00100000}, {405,0.00100000}, {406,0.00100000}, {407,0.00627928}, {408,0.00100000}, {409,0.00561261}, {410,0.00100000}, {411,0.00100000}, {412,0.00100000}, {413,0.00100000}, {414,0.00100000}, {415,0.00100000}, {416,0.00100000}, {417,0.00100000}, {418,0.00100000}, {419,0.00100000}, {420,0.00100000}, {421,0.00100000}, {422,0.00100000}, {423,0.00100000}, {424,0.00109910}, {425,0.00100000}, {426,0.00100000}, {427,0.00100000}, {428,0.00100000}, {429,0.00100000}, {430,0.00100000}, {431,0.00100000}, {432,0.00100000}, {433,0.00100000}, {434,0.00100000}, {435,0.00100000}, {436,0.00100000}, {437,0.00100000}, {438,0.00100000}, {439,0.00100000}, {440,0.00100000}, {441,0.00100000}, {442,0.00100000}, {443,0.00100000}, {444,0.00100000}, {445,0.00100000}, {446,0.00100000}, {447,0.00100000}, {448,0.00100000}, {449,0.00100000}, {450,0.00100000}, {451,0.00100000}, {452,0.00100901}, {453,0.00100000}, {454,0.00100000}, {455,0.00100000}, {456,0.00100000}, {457,0.00100000}, {458,0.00100000}, {459,0.00100000}, {460,0.00100000}, {461,0.00100901}, {462,0.00100000}, {463,0.00100000}, {464,0.00102703}, {465,0.00100000}, {466,0.00100000}, {467,0.00100000}, {468,0.00100901}, {469,0.00100000}, {470,0.00100000}, {471,0.00100000}, {472,0.00100000}, {473,0.00100000}, {474,0.00100000}, {475,0.00100000}, {476,0.00100000}, {477,0.00100000}, {478,0.00100000}, {479,0.00100000}, {480,0.00100000}, {481,0.00101802}, {482,0.00100000}, {483,0.00100000}, {484,0.00100000}, {485,0.00107207}, {486,0.00100000}, {487,0.00100000}, {488,0.00100000}, {489,0.00100000}, {490,0.00507207}, {491,0.00102703}, {492,0.00100000}, {493,0.00100000}, {494,0.00100000}, {495,0.00100000}, {496,0.00100000}, {497,0.00104505}, {498,0.00100901}, {499,0.00100000}, {500,0.00100000}, {505,0.00100000}, {510,0.00100000}, {515,0.00100000}, {520,0.00100000}, {525,0.00118919}, {530,0.00116216}, {535,0.00121622}, {540,0.00124324}, {545,0.00128829}, {550,0.00136036}, {555,0.00496396}, {560,0.00100901}, {565,0.00101802}, {570,0.00100000}, {575,0.00104505}, {580,0.00121622}, {585,0.00157658}, {590,0.00181982}, {595,0.00100000}, {600,0.00115315}, {605,0.00172973}, {610,0.00193694}, {615,0.00108108}, {620,0.00165766}, {625,0.00197297}, {630,0.00128829}, {635,0.00194595}, {640,0.00200000}, {645,0.00170270}, {650,0.00199099}, {655,0.00175676}, {660,0.00200000}, {665,0.00200000}, {670,0.00200000}, {675,0.00811712}, {680,0.00200000}, {685,0.00198198}, {690,0.00200000}, {695,0.00200000}, {700,0.00200000}, {705,0.00200000}, {710,0.00200000}, {715,0.00200000}, {720,0.00200000}, {725,0.00200000}, {730,0.00200901}, {735,0.00200000}, {740,0.00200000}, {745,0.00217117}, {750,0.00200901}, {755,0.00200000}, {760,0.00200901}, {765,0.00200000}, {770,0.00200000}, {775,0.00200000}, {780,0.00200000}, {785,0.00216216}, {790,0.00213514}, {795,0.00205405}, {800,0.00209009}, {805,0.00205405}, {810,0.00208108}, {815,0.00221622}, {820,0.00222523}, {825,0.00242342}, {830,0.00201802}, {835,0.00200000}, {840,0.00200901}, {845,0.00200901}, {850,0.00204505}, {855,0.00237838}, {860,0.01202703}, {865,0.00200000}, {870,0.00206306}, {875,0.00254955}, {880,0.00288288}, {885,0.00204505}, {890,0.00255856}, {895,0.00204505}, {900,0.00221622}, {905,0.00278378}, {910,0.00217117}, {915,0.00264865}, {920,0.00299099}, {925,0.00253153}, {930,0.00299099}, {935,0.00260360}, {940,0.00299099}, {945,0.00274775}, {950,0.00300000}, {955,0.00295495}, {960,0.00262162}, {965,0.00300000}, {970,0.00285586}, {975,0.00300000}, {980,0.00300000}, {985,0.00297297}, {990,0.00290991}, {995,0.00300000}, {1000,0.00300000}, {1010,0.00300000}, {1020,0.00300000}, {1030,0.00300000}, {1040,0.00300000}, {1050,0.00300000}, {1060,0.00300000}, {1070,0.00300000}, {1080,0.00300909}, {1090,0.00300909}, {1100,0.00300909}, {1110,0.00321818}, {1120,0.00339091}, {1130,0.00311818}, {1140,0.00303636}, {1150,0.00341818}, {1160,0.00303636}, {1170,0.00316364}, {1180,0.00360909}, {1190,0.00310000}, {1200,0.00372727}, {1210,0.00319091}, {1220,0.00391818}, {1230,0.00354545}, {1240,0.01221818}, {1250,0.00393636}, {1260,0.00375455}, {1270,0.00373636}, {1280,0.00400000}, {1290,0.00400000}, {1300,0.00400000}, {1310,0.00398182}, {1320,0.00391818}, {1330,0.00397273}, {1340,0.00400000}, {1350,0.00399091}, {1360,0.00400000}, {1370,0.00401818}, {1380,0.00402727}, {1390,0.00422727}, {1400,0.00400909}, {1410,0.00404545}, {1420,0.00419091}, {1430,0.00739091}, {1440,0.00405455}, {1450,0.00446364}, {1460,0.00410000}, {1470,0.00473636}, {1480,0.00430000}, {1490,0.01426364}, {1500,0.00468182}, {1510,0.00445455}, {1520,0.00445455}, {1530,0.00496364}, {1540,0.00486364}, {1550,0.00470909}, {1560,0.00481818}, {1570,0.00500909}, {1580,0.00499091}, {1590,0.00499091}, {1600,0.00500000}, {1610,0.00500000}, {1620,0.00500909}, {1630,0.00504545}, {1640,0.00499091}, {1650,0.00499091}, {1660,0.00500000}, {1670,0.00506364}, {1680,0.01458182}, {1690,0.00501818}, {1700,0.00513636}, {1710,0.00507273}, {1720,0.00523636}, {1730,0.00509091}, {1740,0.00523636}, {1750,0.00517273}, {1760,0.00565455}, {1770,0.00543636}, {1780,0.00536364}, {1790,0.00556364}, {1800,0.00580909}, {1810,0.00565455}, {1820,0.00556364}, {1830,0.00562727}, {1840,0.00574545}, {1850,0.00577273}, {1860,0.01469091}, {1870,0.00584545}, {1880,0.00598182}, {1890,0.00586364}, {1900,0.00595455}, {1910,0.00600909}, {1920,0.00600909}, {1930,0.01284545}, {1940,0.00598182}, {1950,0.00603636}, {1960,0.00601818}, {1970,0.00600909}, {1980,0.00602727}, {1990,0.00606364}, {2000,0.00604545}, {2050,0.00651818}, {2100,0.00664545}, {2150,0.00685455}, {2200,0.00700000}, {2250,0.00698182}, {2300,0.00718182}, {2350,0.00731818}, {2400,0.01366364}, {2450,0.00777273}, {2500,0.00797273}, {2550,0.00801818}, {2600,0.00818182}, {2650,0.00837273}, {2700,0.00862727}, {2750,0.01043636}, {2800,0.00892727}, {2850,0.00901818}, {2900,0.00912727}, {2950,0.00945455}, {3000,0.01994545}, {3050,0.00975455}, {3100,0.00985455}, {3150,0.01000000}, {3200,0.01011818}, {3250,0.01038182}, {3300,0.01080000}, {3350,0.01076364}, {3400,0.01078182}, {3450,0.02554545}, {3500,0.01110909}, {3550,0.01128182}, {3600,0.01159091}, {3650,0.01170909}, {3700,0.01177273}, {3750,0.01199091}, {3800,0.01205455}, {3850,0.03396364}, {3900,0.02678182}, {3950,0.01270909}, {4000,0.01278182}, {4050,0.01933636}, {4100,0.01306364}, {4150,0.01365455}, {4200,0.02741818}, {4250,0.01373636}, {4300,0.01380000}, {4350,0.01390909}, {4400,0.01422727}, {4450,0.01435455}, {4500,0.01462727}, {4550,0.01474545}, {4600,0.01479091}, {4650,0.01498182}, {4700,0.01526364}, {4750,0.01546364}, {4800,0.01566364}, {4850,0.01579091}, {4900,0.01583636}, {4950,0.01594545}, {5000,0.01616364}, {5050,0.01654545}, {5100,0.01803636}, {5150,0.03933636}, {5200,0.01680000}, {5250,0.01693636}, {5300,0.01708182}, {5350,0.01719091}, {5400,0.04718182}, {5450,0.01764545}, {5500,0.01768182}, {5550,0.03299091}, {5600,0.01775455}, {5650,0.04597273}, {5700,0.01802727}, {5750,0.03390000}, {5800,0.01830909}, {5850,0.02941818}, {5900,0.01844545}, {5950,0.02884545}, {6000,0.01880909}, {6050,0.02225}, {6100,0.02750}, {6150,0.02625}, {6200,0.02000}, {6250,0.03675}, {6300,0.03300}, {6350,0.02025}, {6400,0.02075}, {6450,0.02075}, {6500,0.02100}, {6550,0.02125}, {6600,0.03250}, {6650,0.02150}, {6700,0.03450}, {6750,0.02150}, {6800,0.02175}, {6850,0.02200}, {6900,0.02200}, {6950,0.02225}, {7000,0.02300}, {7050,0.04450}, {7100,0.02300}, {7150,0.03200}, {7200,0.02700}, {7250,0.04275}, {7300,0.02350}, {7350,0.02375}, {7400,0.04000}, {7450,0.03800}, {7500,0.03950}, {7550,0.03900}, {7600,0.02550}, {7650,0.04000}, {7700,0.02500}, {7750,0.02500}, {7800,0.03975}, {7850,0.02525}, {7900,0.02575}, {7950,0.02575}, {8000,0.04500}, {8050,0.02600}, {8100,0.03225}, {8150,0.02600}, {8200,0.03200}, {8250,0.04100}, {8300,0.03575}, {8350,0.02675}, {8400,0.04675}, {8450,0.04775}, {8500,0.02650}, {8550,0.03925}, {8600,0.04125}, {8650,0.05075}, {8700,0.03050}, {8750,0.02750}, {8800,0.04100}, {8850,0.05125}, {8900,0.02800}, {8950,0.05200}, {9000,0.02750}, {9050,0.04025}, {9100,0.02975}, {9150,0.05000}, {9200,0.04650}, {9250,0.03900}, {9300,0.06000}, {9350,0.06025}, {9400,0.02925}, {9450,0.02900}, {9500,0.02900}, {9550,0.06325}, {9600,0.02950}, {9650,0.02975}, {9700,0.03000}, {9750,0.03800}, {9800,0.04775}, {9850,0.05200}, {9900,0.03100}, {9950,0.03750}, {10000,0.03075}, {10100,0.03100}, {10200,0.03175}, {10300,0.06625}, {10400,0.03200}, {10500,0.03300}, {10600,0.03300}, {10700,0.03275}, {10800,0.05175}, {10900,0.04525}, {11000,0.03400}, {11100,0.03450}, {11200,0.06100}, {11300,0.04900}, {11400,0.08225}, {11500,0.04050}, {11600,0.04875}, {11700,0.04100}, {11800,0.07900}, {11900,0.04500}, {12000,0.06650}, {12100,0.04575}, {12200,0.04875}, {12300,0.05425}, {12400,0.08400}, {12500,0.03950}, {12600,0.03950}, {12700,0.03950}, {12800,0.07175}, {12900,0.06225}, {13000,0.04525}, {13100,0.04100}, {13200,0.06675}, {13300,0.06700}, {13400,0.06500}, {13500,0.06125}, {13600,0.04250}, {13700,0.04325}, {13800,0.08500}, {13900,0.04500}, {14000,0.06400}, {14100,0.05800}, {14200,0.08150}, {14300,0.08425}, {14400,0.07600}, {14500,0.09475}, {14600,0.08625}, {14700,0.08375}, {14800,0.10525}, {14900,0.07125}, {15000,0.07875}, {15100,0.05275}, {15200,0.08650}, {15300,0.09850}, {15400,0.05000}, {15500,0.08825}, {15600,0.04975}, {15700,0.05900}, {15800,0.09275}, {15900,0.08550}, {16000,0.05525}, {16100,0.06500}, {16200,0.11150}, {16300,0.08600}, {16400,0.06250}, {16500,0.13025}, {16600,0.10025}, {16700,0.05800}, {16800,0.06325}, {16900,0.10225}, {17000,0.06275}, {17100,0.09625}, {17200,0.09225}, {17300,0.09275}, {17400,0.06175}, {17500,0.07500}, {17600,0.08600}, {17700,0.09175}, {17800,0.06050}, {17900,0.10525}, {18000,0.09700}, {18100,0.13450}, {18200,0.07325}, {18300,0.10725}, {18400,0.12575}, {18500,0.07850}, {18600,0.10175}, {18700,0.06075}, {18800,0.07175}, {18900,0.08600}, {19000,0.14100}, {19100,0.06275}, {19200,0.07075}, {19300,0.14975}, {19400,0.11575}, {19500,0.11075}, {19600,0.09425}, {19700,0.14125}, {19800,0.09825}, {19900,0.08525}, {20000,0.1505}};
data["big_flat"]["CanonicalStructuresPHOAS"]["eval lazy"]["user"] = {{1,0.00002703}, {2,0.00000000}, {3,0.00002703}, {4,0.00005405}, {5,0.00009009}, {6,0.00009009}, {7,0.00000000}, {8,0.00000000}, {9,0.00009910}, {10,0.00000000}, {11,0.00011712}, {12,0.00009009}, {13,0.00009910}, {14,0.00007207}, {15,0.00013514}, {16,0.00014414}, {17,0.00000000}, {18,0.00019820}, {19,0.00011712}, {20,0.00002703}, {21,0.00014414}, {22,0.00011712}, {23,0.00009009}, {24,0.00019820}, {25,0.00006306}, {26,0.00000000}, {27,0.00015315}, {28,0.00012613}, {29,0.00018018}, {30,0.00016216}, {31,0.00010811}, {32,0.00010811}, {33,0.00018919}, {34,0.00021622}, {35,0.00008108}, {36,0.00023423}, {37,0.00015315}, {38,0.00019820}, {39,0.00022523}, {40,0.00019820}, {41,0.00029730}, {42,0.00019820}, {43,0.00017117}, {44,0.00017117}, {45,0.00018018}, {46,0.00005405}, {47,0.00024324}, {48,0.00018919}, {49,0.00027027}, {50,0.00010811}, {51,0.00018919}, {52,0.00018018}, {53,0.00025225}, {54,0.00018018}, {55,0.00020721}, {56,0.00024324}, {57,0.00020721}, {58,0.00011712}, {59,0.00019820}, {60,0.00020721}, {61,0.00020721}, {62,0.00033333}, {63,0.00021622}, {64,0.00014414}, {65,0.00018919}, {66,0.00022523}, {67,0.00020721}, {68,0.00018919}, {69,0.00014414}, {70,0.00021622}, {71,0.00030631}, {72,0.00018919}, {73,0.00024324}, {74,0.00014414}, {75,0.00023423}, {76,0.00039640}, {77,0.00010811}, {78,0.00021622}, {79,0.00014414}, {80,0.00033333}, {81,0.00018018}, {82,0.00031532}, {83,0.00012613}, {84,0.00030631}, {85,0.00031532}, {86,0.00018919}, {87,0.00014414}, {88,0.00023423}, {89,0.00044144}, {90,0.00025225}, {91,0.00033333}, {92,0.00020721}, {93,0.00029730}, {94,0.00036937}, {95,0.00032432}, {96,0.00026126}, {97,0.00040541}, {98,0.00015315}, {99,0.00023423}, {100,0.00050450}, {101,0.00043243}, {102,0.00031532}, {103,0.00051351}, {104,0.00026126}, {105,0.00037838}, {106,0.00037838}, {107,0.00019820}, {108,0.00030631}, {109,0.00043243}, {110,0.00027928}, {111,0.00041441}, {112,0.00026126}, {113,0.00054955}, {114,0.00042342}, {115,0.00037838}, {116,0.00041441}, {117,0.00053153}, {118,0.00031532}, {119,0.00025225}, {120,0.00033333}, {121,0.00034234}, {122,0.00033333}, {123,0.00042342}, {124,0.00223423}, {125,0.00037838}, {126,0.00023423}, {127,0.00033333}, {128,0.00036036}, {129,0.00026126}, {130,0.00036036}, {131,0.00048649}, {132,0.00037838}, {133,0.00056757}, {134,0.00025225}, {135,0.00037838}, {136,0.00044144}, {137,0.00045946}, {138,0.00056757}, {139,0.00037838}, {140,0.00044144}, {141,0.00059459}, {142,0.00038739}, {143,0.00033333}, {144,0.00049550}, {145,0.00041441}, {146,0.00034234}, {147,0.00028829}, {148,0.00044144}, {149,0.00058559}, {150,0.00043243}, {151,0.00067568}, {152,0.00039640}, {153,0.00023423}, {154,0.00056757}, {155,0.00063964}, {156,0.00034234}, {157,0.00059459}, {158,0.00035135}, {159,0.00059459}, {160,0.00052252}, {161,0.00041441}, {162,0.00053153}, {163,0.00050450}, {164,0.00046847}, {165,0.00054955}, {166,0.00053153}, {167,0.00047748}, {168,0.00046847}, {169,0.00046847}, {170,0.00040541}, {171,0.00034234}, {172,0.00032432}, {173,0.00051351}, {174,0.00056757}, {175,0.00055856}, {176,0.00053153}, {177,0.00038739}, {178,0.00062162}, {179,0.00036036}, {180,0.00040541}, {181,0.00060360}, {182,0.00047748}, {183,0.00053153}, {184,0.00074775}, {185,0.00040541}, {186,0.00051351}, {187,0.00048649}, {188,0.00046847}, {189,0.00068468}, {190,0.00043243}, {191,0.00082883}, {192,0.00070270}, {193,0.00056757}, {194,0.00049550}, {195,0.00054054}, {196,0.00044144}, {197,0.00044144}, {198,0.00056757}, {199,0.00060360}, {200,0.00064865}, {201,0.00060360}, {202,0.00061261}, {203,0.00062162}, {204,0.00067568}, {205,0.00056757}, {206,0.00038739}, {207,0.00059459}, {208,0.00056757}, {209,0.00064865}, {210,0.00064865}, {211,0.00058559}, {212,0.00061261}, {213,0.00064865}, {214,0.00060360}, {215,0.00059459}, {216,0.00047748}, {217,0.00042342}, {218,0.00061261}, {219,0.00067568}, {220,0.00063063}, {221,0.00036937}, {222,0.00046847}, {223,0.00051351}, {224,0.00047748}, {225,0.00037838}, {226,0.00074775}, {227,0.00063063}, {228,0.00059459}, {229,0.00051351}, {230,0.00050450}, {231,0.00082883}, {232,0.00083784}, {233,0.00054054}, {234,0.00054955}, {235,0.00062162}, {236,0.00062162}, {237,0.00060360}, {238,0.00072973}, {239,0.00077477}, {240,0.00047748}, {241,0.00072973}, {242,0.00072973}, {243,0.00074775}, {244,0.00061261}, {245,0.00048649}, {246,0.00065766}, {247,0.00063964}, {248,0.00055856}, {249,0.00057658}, {250,0.00097297}, {251,0.00072973}, {252,0.00076577}, {253,0.00069369}, {254,0.00065766}, {255,0.00074775}, {256,0.00054955}, {257,0.00077477}, {258,0.00062162}, {259,0.00079279}, {260,0.00068468}, {261,0.00054955}, {262,0.00091892}, {263,0.00070270}, {264,0.00074775}, {265,0.00055856}, {266,0.00055856}, {267,0.00081081}, {268,0.00060360}, {269,0.00057658}, {270,0.00066667}, {271,0.00056757}, {272,0.00072973}, {273,0.00093694}, {274,0.00105405}, {275,0.00060360}, {276,0.00056757}, {277,0.00086486}, {278,0.00056757}, {279,0.00076577}, {280,0.00089189}, {281,0.00069369}, {282,0.00108108}, {283,0.00064865}, {284,0.00103604}, {285,0.00068468}, {286,0.00077477}, {287,0.00097297}, {288,0.00110811}, {289,0.00087387}, {290,0.00075676}, {291,0.00288288}, {292,0.00076577}, {293,0.00063964}, {294,0.00054955}, {295,0.00064865}, {296,0.00089189}, {297,0.00064865}, {298,0.00085586}, {299,0.00077477}, {300,0.00075676}, {301,0.00093694}, {302,0.00079279}, {303,0.00095495}, {304,0.00088288}, {305,0.00115315}, {306,0.00074775}, {307,0.00068468}, {308,0.00097297}, {309,0.00083784}, {310,0.00081982}, {311,0.00104505}, {312,0.00081081}, {313,0.00093694}, {314,0.00090991}, {315,0.00082883}, {316,0.00096396}, {317,0.00066667}, {318,0.00082883}, {319,0.00086486}, {320,0.00093694}, {321,0.00068468}, {322,0.00097297}, {323,0.00065766}, {324,0.00099099}, {325,0.00096396}, {326,0.00067568}, {327,0.00085586}, {328,0.00089189}, {329,0.00086486}, {330,0.00085586}, {331,0.00064865}, {332,0.00114414}, {333,0.00090090}, {334,0.00078378}, {335,0.00083784}, {336,0.00072973}, {337,0.00098198}, {338,0.00096396}, {339,0.00065766}, {340,0.00102703}, {341,0.00107207}, {342,0.00106306}, {343,0.00076577}, {344,0.00115315}, {345,0.00096396}, {346,0.00085586}, {347,0.00076577}, {348,0.00099099}, {349,0.00080180}, {350,0.00103604}, {351,0.00085586}, {352,0.00100901}, {353,0.00479279}, {354,0.00085586}, {355,0.00128829}, {356,0.00065766}, {357,0.00129730}, {358,0.00113514}, {359,0.00095495}, {360,0.00092793}, {361,0.00095495}, {362,0.00084685}, {363,0.00094595}, {364,0.00100901}, {365,0.00117117}, {366,0.00077477}, {367,0.00107207}, {368,0.00100000}, {369,0.00093694}, {370,0.00098198}, {371,0.00134234}, {372,0.00104505}, {373,0.00120721}, {374,0.00098198}, {375,0.00122523}, {376,0.00088288}, {377,0.00095495}, {378,0.00117117}, {379,0.00115315}, {380,0.00102703}, {381,0.00111712}, {382,0.00145045}, {383,0.00071171}, {384,0.00138739}, {385,0.00129730}, {386,0.00121622}, {387,0.00136036}, {388,0.00119820}, {389,0.00125225}, {390,0.00126126}, {391,0.00071171}, {392,0.00107207}, {393,0.00102703}, {394,0.00114414}, {395,0.00125225}, {396,0.00112613}, {397,0.00133333}, {398,0.00109910}, {399,0.00102703}, {400,0.00123423}, {401,0.00094595}, {402,0.00103604}, {403,0.00698198}, {404,0.00117117}, {405,0.00131532}, {406,0.00109009}, {407,0.00588288}, {408,0.00113514}, {409,0.00586486}, {410,0.00127027}, {411,0.00117117}, {412,0.00143243}, {413,0.00098198}, {414,0.00122523}, {415,0.00108108}, {416,0.00108108}, {417,0.00098198}, {418,0.00147748}, {419,0.00102703}, {420,0.00127027}, {421,0.00115315}, {422,0.00119820}, {423,0.00143243}, {424,0.00124324}, {425,0.00123423}, {426,0.00082883}, {427,0.00128829}, {428,0.00105405}, {429,0.00099099}, {430,0.00131532}, {431,0.00115315}, {432,0.00158559}, {433,0.00117117}, {434,0.00125225}, {435,0.00136937}, {436,0.00127027}, {437,0.00108108}, {438,0.00130631}, {439,0.00108108}, {440,0.00128829}, {441,0.00105405}, {442,0.00111712}, {443,0.00155856}, {444,0.00126126}, {445,0.00132432}, {446,0.00127027}, {447,0.00104505}, {448,0.00126126}, {449,0.00131532}, {450,0.00121622}, {451,0.00109910}, {452,0.00127928}, {453,0.00105405}, {454,0.00152252}, {455,0.00145045}, {456,0.00124324}, {457,0.00130631}, {458,0.00115315}, {459,0.00127027}, {460,0.00118018}, {461,0.00128829}, {462,0.00117117}, {463,0.00102703}, {464,0.00142342}, {465,0.00133333}, {466,0.00139640}, {467,0.00110811}, {468,0.00168468}, {469,0.00169369}, {470,0.00126126}, {471,0.00123423}, {472,0.00144144}, {473,0.00136937}, {474,0.00118018}, {475,0.00090090}, {476,0.00150450}, {477,0.00158559}, {478,0.00108108}, {479,0.00135135}, {480,0.00116216}, {481,0.00133333}, {482,0.00147748}, {483,0.00133333}, {484,0.00129730}, {485,0.00145946}, {486,0.00132432}, {487,0.00122523}, {488,0.00127928}, {489,0.00147748}, {490,0.00468468}, {491,0.00172973}, {492,0.00137838}, {493,0.00169369}, {494,0.00136937}, {495,0.00136036}, {496,0.00136036}, {497,0.00146847}, {498,0.00124324}, {499,0.00160360}, {500,0.00136937}, {505,0.00145946}, {510,0.00152252}, {515,0.00111712}, {520,0.00175676}, {525,0.00154054}, {530,0.00149550}, {535,0.00139640}, {540,0.00158559}, {545,0.00184685}, {550,0.00194595}, {555,0.00486486}, {560,0.00123423}, {565,0.00150450}, {570,0.00169369}, {575,0.00147748}, {580,0.00144144}, {585,0.00133333}, {590,0.00162162}, {595,0.00163964}, {600,0.00165766}, {605,0.00193694}, {610,0.00176577}, {615,0.00153153}, {620,0.00153153}, {625,0.00167568}, {630,0.00186486}, {635,0.00172973}, {640,0.00202703}, {645,0.00185586}, {650,0.00155856}, {655,0.00172072}, {660,0.00202703}, {665,0.00192793}, {670,0.00181982}, {675,0.00796396}, {680,0.00166667}, {685,0.00168468}, {690,0.00193694}, {695,0.00184685}, {700,0.00227027}, {705,0.00187387}, {710,0.00205405}, {715,0.00208108}, {720,0.00195495}, {725,0.00193694}, {730,0.00198198}, {735,0.00219820}, {740,0.00190090}, {745,0.00221622}, {750,0.00220721}, {755,0.00194595}, {760,0.00223423}, {765,0.00184685}, {770,0.00211712}, {775,0.00189189}, {780,0.00187387}, {785,0.00204505}, {790,0.00279279}, {795,0.00241441}, {800,0.00212613}, {805,0.00227027}, {810,0.00212613}, {815,0.00226126}, {820,0.00236937}, {825,0.00227027}, {830,0.00207207}, {835,0.00233333}, {840,0.00238739}, {845,0.00206306}, {850,0.00237838}, {855,0.00254054}, {860,0.01195495}, {865,0.00207207}, {870,0.00237838}, {875,0.00252252}, {880,0.00273874}, {885,0.00261261}, {890,0.00266667}, {895,0.00238739}, {900,0.00247748}, {905,0.00228829}, {910,0.00268468}, {915,0.00236937}, {920,0.00265766}, {925,0.00233333}, {930,0.00269369}, {935,0.00252252}, {940,0.00274775}, {945,0.00247748}, {950,0.00252252}, {955,0.00264865}, {960,0.00267568}, {965,0.00272973}, {970,0.00239640}, {975,0.00284685}, {980,0.00266667}, {985,0.00238739}, {990,0.00269369}, {995,0.00291892}, {1000,0.00277477}, {1010,0.00293694}, {1020,0.00273874}, {1030,0.00310811}, {1040,0.00302703}, {1050,0.00310000}, {1060,0.00296364}, {1070,0.00306364}, {1080,0.00308182}, {1090,0.00290000}, {1100,0.00307273}, {1110,0.00326364}, {1120,0.00335455}, {1130,0.00305455}, {1140,0.00310000}, {1150,0.00335455}, {1160,0.00310909}, {1170,0.00320000}, {1180,0.00355455}, {1190,0.00309091}, {1200,0.00350909}, {1210,0.00328182}, {1220,0.00363636}, {1230,0.00330000}, {1240,0.01228182}, {1250,0.00376364}, {1260,0.00343636}, {1270,0.00352727}, {1280,0.00370909}, {1290,0.00388182}, {1300,0.00359091}, {1310,0.00389091}, {1320,0.00389091}, {1330,0.00391818}, {1340,0.00382727}, {1350,0.00403636}, {1360,0.00401818}, {1370,0.00423636}, {1380,0.00422727}, {1390,0.00466364}, {1400,0.00435455}, {1410,0.00414545}, {1420,0.00483636}, {1430,0.00732727}, {1440,0.00421818}, {1450,0.00422727}, {1460,0.00429091}, {1470,0.00480909}, {1480,0.00464545}, {1490,0.01438182}, {1500,0.00478182}, {1510,0.00434545}, {1520,0.00450909}, {1530,0.00458182}, {1540,0.00466364}, {1550,0.00479091}, {1560,0.00497273}, {1570,0.00503636}, {1580,0.00493636}, {1590,0.00490000}, {1600,0.00516364}, {1610,0.00498182}, {1620,0.00533636}, {1630,0.00521818}, {1640,0.00485455}, {1650,0.00474545}, {1660,0.00539091}, {1670,0.00486364}, {1680,0.01455455}, {1690,0.00503636}, {1700,0.00521818}, {1710,0.00534545}, {1720,0.00564545}, {1730,0.00535455}, {1740,0.00511818}, {1750,0.00528182}, {1760,0.00570909}, {1770,0.00568182}, {1780,0.00524545}, {1790,0.00537273}, {1800,0.00557273}, {1810,0.00582727}, {1820,0.00522727}, {1830,0.00551818}, {1840,0.00549091}, {1850,0.00578182}, {1860,0.01497273}, {1870,0.00558182}, {1880,0.00572727}, {1890,0.00584545}, {1900,0.00592727}, {1910,0.00584545}, {1920,0.00602727}, {1930,0.01312727}, {1940,0.00589091}, {1950,0.00608182}, {1960,0.00548182}, {1970,0.00600000}, {1980,0.00583636}, {1990,0.00639091}, {2000,0.00620909}, {2050,0.00629091}, {2100,0.00633636}, {2150,0.00655455}, {2200,0.00682727}, {2250,0.00683636}, {2300,0.00703636}, {2350,0.00718182}, {2400,0.01374545}, {2450,0.00768182}, {2500,0.00764545}, {2550,0.00795455}, {2600,0.00798182}, {2650,0.00815455}, {2700,0.00830909}, {2750,0.01074545}, {2800,0.00952727}, {2850,0.00922727}, {2900,0.00929091}, {2950,0.00953636}, {3000,0.01989091}, {3050,0.00968182}, {3100,0.01023636}, {3150,0.01012727}, {3200,0.01042727}, {3250,0.01070000}, {3300,0.01104545}, {3350,0.01119091}, {3400,0.01111818}, {3450,0.02593636}, {3500,0.01156364}, {3550,0.01173636}, {3600,0.01198182}, {3650,0.01213636}, {3700,0.01231818}, {3750,0.01246364}, {3800,0.01272727}, {3850,0.03405455}, {3900,0.02690000}, {3950,0.01287273}, {4000,0.01304545}, {4050,0.01891818}, {4100,0.01379091}, {4150,0.01380000}, {4200,0.02759091}, {4250,0.01420000}, {4300,0.01400909}, {4350,0.01424545}, {4400,0.01443636}, {4450,0.01429091}, {4500,0.01482727}, {4550,0.01495455}, {4600,0.01499091}, {4650,0.01526364}, {4700,0.01528182}, {4750,0.01538182}, {4800,0.01565455}, {4850,0.01600000}, {4900,0.01610909}, {4950,0.01618182}, {5000,0.01608182}, {5050,0.01665455}, {5100,0.01787273}, {5150,0.03942727}, {5200,0.01694545}, {5250,0.01700000}, {5300,0.01701818}, {5350,0.01731818}, {5400,0.04742727}, {5450,0.01761818}, {5500,0.01795455}, {5550,0.03294545}, {5600,0.01751818}, {5650,0.04633636}, {5700,0.01822727}, {5750,0.03400000}, {5800,0.01831818}, {5850,0.02943636}, {5900,0.01833636}, {5950,0.02921818}, {6000,0.01844545}, {6050,0.02075}, {6100,0.02750}, {6150,0.03000}, {6200,0.01925}, {6250,0.03825}, {6300,0.03250}, {6350,0.01925}, {6400,0.02150}, {6450,0.02075}, {6500,0.02150}, {6550,0.02275}, {6600,0.03225}, {6650,0.02400}, {6700,0.03475}, {6750,0.02025}, {6800,0.02275}, {6850,0.02050}, {6900,0.02275}, {6950,0.02375}, {7000,0.02275}, {7050,0.04475}, {7100,0.02275}, {7150,0.03175}, {7200,0.02800}, {7250,0.04225}, {7300,0.02400}, {7350,0.02400}, {7400,0.03900}, {7450,0.03900}, {7500,0.04000}, {7550,0.04050}, {7600,0.02675}, {7650,0.03875}, {7700,0.02400}, {7750,0.02500}, {7800,0.03975}, {7850,0.02700}, {7900,0.02600}, {7950,0.02800}, {8000,0.04375}, {8050,0.02675}, {8100,0.03325}, {8150,0.02475}, {8200,0.03400}, {8250,0.04100}, {8300,0.03550}, {8350,0.02500}, {8400,0.04675}, {8450,0.04775}, {8500,0.02700}, {8550,0.04050}, {8600,0.04175}, {8650,0.05200}, {8700,0.03100}, {8750,0.02800}, {8800,0.04075}, {8850,0.05125}, {8900,0.02775}, {8950,0.05300}, {9000,0.02800}, {9050,0.03975}, {9100,0.02975}, {9150,0.05200}, {9200,0.04650}, {9250,0.03875}, {9300,0.06100}, {9350,0.06075}, {9400,0.03000}, {9450,0.02775}, {9500,0.02800}, {9550,0.06400}, {9600,0.02900}, {9650,0.03050}, {9700,0.03150}, {9750,0.03875}, {9800,0.04725}, {9850,0.05200}, {9900,0.03125}, {9950,0.03725}, {10000,0.03175}, {10100,0.03175}, {10200,0.03175}, {10300,0.06675}, {10400,0.03300}, {10500,0.03175}, {10600,0.03350}, {10700,0.03275}, {10800,0.05250}, {10900,0.04600}, {11000,0.03375}, {11100,0.03450}, {11200,0.05975}, {11300,0.04850}, {11400,0.08275}, {11500,0.04250}, {11600,0.04775}, {11700,0.04125}, {11800,0.07950}, {11900,0.04550}, {12000,0.06625}, {12100,0.04675}, {12200,0.04825}, {12300,0.05550}, {12400,0.08475}, {12500,0.03975}, {12600,0.03900}, {12700,0.03900}, {12800,0.07150}, {12900,0.06175}, {13000,0.04350}, {13100,0.04025}, {13200,0.06750}, {13300,0.06650}, {13400,0.06550}, {13500,0.06300}, {13600,0.04125}, {13700,0.04350}, {13800,0.08250}, {13900,0.04600}, {14000,0.06400}, {14100,0.05850}, {14200,0.08050}, {14300,0.08325}, {14400,0.07600}, {14500,0.09575}, {14600,0.08625}, {14700,0.08175}, {14800,0.10650}, {14900,0.07150}, {15000,0.07950}, {15100,0.05200}, {15200,0.08725}, {15300,0.09950}, {15400,0.04975}, {15500,0.08700}, {15600,0.04975}, {15700,0.05900}, {15800,0.09250}, {15900,0.08450}, {16000,0.05500}, {16100,0.06675}, {16200,0.11250}, {16300,0.08625}, {16400,0.06250}, {16500,0.13025}, {16600,0.09975}, {16700,0.05750}, {16800,0.06175}, {16900,0.10350}, {17000,0.06125}, {17100,0.09550}, {17200,0.09275}, {17300,0.09225}, {17400,0.06000}, {17500,0.07500}, {17600,0.08675}, {17700,0.09175}, {17800,0.05975}, {17900,0.10550}, {18000,0.09650}, {18100,0.13575}, {18200,0.07350}, {18300,0.10650}, {18400,0.12400}, {18500,0.08075}, {18600,0.10150}, {18700,0.05950}, {18800,0.07125}, {18900,0.08675}, {19000,0.14075}, {19100,0.06325}, {19200,0.07075}, {19300,0.15025}, {19400,0.11650}, {19500,0.10975}, {19600,0.09475}, {19700,0.14275}, {19800,0.09725}, {19900,0.08650}, {20000,0.1520}};
data["big_flat"]["CanonicalStructuresPHOAS"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00003604}, {84,0.00000000}, {85,0.00003604}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00003604}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00003604}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00003604}, {130,0.00003604}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00003604}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00003604}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00003604}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00003604}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00003604}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00003604}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00003604}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00003604}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00010811}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00003604}, {298,0.00000000}, {299,0.00003604}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00003604}, {305,0.00003604}, {306,0.00003604}, {307,0.00000000}, {308,0.00003604}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00003604}, {313,0.00000000}, {314,0.00000000}, {315,0.00003604}, {316,0.00003604}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00003604}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00003604}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00003604}, {352,0.00002703}, {353,0.00000000}, {354,0.00000000}, {355,0.00003604}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00003604}, {362,0.00000000}, {363,0.00003604}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00003604}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00003604}, {380,0.00000000}, {381,0.00000000}, {382,0.00003604}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00003604}, {398,0.00000000}, {399,0.00000000}, {400,0.00003604}, {401,0.00000000}, {402,0.00000000}, {403,0.00003604}, {404,0.00003604}, {405,0.00003604}, {406,0.00000000}, {407,0.00007207}, {408,0.00006306}, {409,0.00000000}, {410,0.00000000}, {411,0.00003604}, {412,0.00000000}, {413,0.00000000}, {414,0.00010811}, {415,0.00000000}, {416,0.00003604}, {417,0.00000000}, {418,0.00003604}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00007207}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00003604}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00007207}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00003604}, {455,0.00000000}, {456,0.00003604}, {457,0.00000000}, {458,0.00003604}, {459,0.00003604}, {460,0.00000000}, {461,0.00003604}, {462,0.00000000}, {463,0.00007207}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00007207}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00003604}, {481,0.00006306}, {482,0.00003604}, {483,0.00003604}, {484,0.00000000}, {485,0.00003604}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00010811}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00003604}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00007207}, {560,0.00003604}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00003604}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00003604}, {620,0.00002703}, {625,0.00006306}, {630,0.00003604}, {635,0.00000000}, {640,0.00000000}, {645,0.00007207}, {650,0.00003604}, {655,0.00003604}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00010811}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00003604}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00010811}, {745,0.00003604}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00010811}, {770,0.00003604}, {775,0.00002703}, {780,0.00000000}, {785,0.00007207}, {790,0.00000000}, {795,0.00000000}, {800,0.00009009}, {805,0.00000000}, {810,0.00007207}, {815,0.00000000}, {820,0.00000000}, {825,0.00003604}, {830,0.00000000}, {835,0.00007207}, {840,0.00003604}, {845,0.00000000}, {850,0.00000000}, {855,0.00003604}, {860,0.00018018}, {865,0.00000000}, {870,0.00007207}, {875,0.00000000}, {880,0.00003604}, {885,0.00000000}, {890,0.00003604}, {895,0.00003604}, {900,0.00000000}, {905,0.00010811}, {910,0.00003604}, {915,0.00000000}, {920,0.00003604}, {925,0.00003604}, {930,0.00003604}, {935,0.00007207}, {940,0.00003604}, {945,0.00007207}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00003604}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00003604}, {995,0.00003604}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00003604}, {1030,0.00003604}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00003636}, {1080,0.00000000}, {1090,0.00007273}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00003636}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00003636}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00014545}, {1250,0.00003636}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00003636}, {1300,0.00007273}, {1310,0.00000000}, {1320,0.00003636}, {1330,0.00000000}, {1340,0.00007273}, {1350,0.00007273}, {1360,0.00003636}, {1370,0.00000000}, {1380,0.00003636}, {1390,0.00003636}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00010909}, {1440,0.00003636}, {1450,0.00003636}, {1460,0.00007273}, {1470,0.00003636}, {1480,0.00000000}, {1490,0.00003636}, {1500,0.00000000}, {1510,0.00010909}, {1520,0.00000000}, {1530,0.00007273}, {1540,0.00000000}, {1550,0.00003636}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00003636}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00003636}, {1680,0.00014545}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00003636}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00003636}, {1760,0.00000000}, {1770,0.00003636}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00003636}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00003636}, {1860,0.00003636}, {1870,0.00007273}, {1880,0.00007273}, {1890,0.00000000}, {1900,0.00003636}, {1910,0.00003636}, {1920,0.00000000}, {1930,0.00003636}, {1940,0.00000000}, {1950,0.00003636}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00003636}, {1990,0.00002727}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00003636}, {2450,0.00000000}, {2500,0.00007273}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00003636}, {2700,0.00003636}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00007273}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00003636}, {3100,0.00000000}, {3150,0.00003636}, {3200,0.00000000}, {3250,0.00002727}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00003636}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00003636}, {3600,0.00000000}, {3650,0.00003636}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00003636}, {3900,0.00003636}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00003636}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00003636}, {4550,0.00007273}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00003636}, {4750,0.00000000}, {4800,0.00003636}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00003636}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00007273}, {5150,0.00000000}, {5200,0.00002727}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00003636}, {5400,0.00000000}, {5450,0.00003636}, {5500,0.00000000}, {5550,0.00003636}, {5600,0.00003636}, {5650,0.00003636}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00002727}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00100}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00100}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00100}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00100}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00100}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00100}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00100}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00100}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresPHOAS"]["intros _"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000909}, {1580,0.00001818}, {1590,0.00000909}, {1600,0.00000000}, {1610,0.00001818}, {1620,0.00000000}, {1630,0.00000909}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000909}, {1680,0.00000000}, {1690,0.00000909}, {1700,0.00001818}, {1710,0.00000000}, {1720,0.00001818}, {1730,0.00000000}, {1740,0.00000909}, {1750,0.00000000}, {1760,0.00004545}, {1770,0.00001818}, {1780,0.00000909}, {1790,0.00000000}, {1800,0.00002727}, {1810,0.00002727}, {1820,0.00001818}, {1830,0.00000909}, {1840,0.00000909}, {1850,0.00002727}, {1860,0.00003636}, {1870,0.00003636}, {1880,0.00006364}, {1890,0.00006364}, {1900,0.00005455}, {1910,0.00022727}, {1920,0.00025455}, {1930,0.00010909}, {1940,0.00010000}, {1950,0.00030000}, {1960,0.00013636}, {1970,0.00023636}, {1980,0.00015455}, {1990,0.00032727}, {2000,0.00021818}, {2050,0.00053636}, {2100,0.00055455}, {2150,0.00066364}, {2200,0.00070000}, {2250,0.00063636}, {2300,0.00067273}, {2350,0.00070909}, {2400,0.00073636}, {2450,0.00076364}, {2500,0.00089091}, {2550,0.00093636}, {2600,0.00100000}, {2650,0.00097273}, {2700,0.00098182}, {2750,0.00103636}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00100000}, {3150,0.00100000}, {3200,0.00100000}, {3250,0.00100000}, {3300,0.00100000}, {3350,0.00100000}, {3400,0.00100000}, {3450,0.00100000}, {3500,0.00100909}, {3550,0.00100000}, {3600,0.00100000}, {3650,0.00100000}, {3700,0.00100909}, {3750,0.00102727}, {3800,0.00103636}, {3850,0.00104545}, {3900,0.00110909}, {3950,0.00108182}, {4000,0.00116364}, {4050,0.00137273}, {4100,0.00140000}, {4150,0.00151818}, {4200,0.00156364}, {4250,0.00166364}, {4300,0.00167273}, {4350,0.00171818}, {4400,0.00173636}, {4450,0.00172727}, {4500,0.00173636}, {4550,0.00171818}, {4600,0.00171818}, {4650,0.00172727}, {4700,0.00173636}, {4750,0.00173636}, {4800,0.00190000}, {4850,0.00175455}, {4900,0.00191818}, {4950,0.00180909}, {5000,0.00199091}, {5050,0.00193636}, {5100,0.00193636}, {5150,0.00195455}, {5200,0.00197273}, {5250,0.00200000}, {5300,0.00198182}, {5350,0.00198182}, {5400,0.00200000}, {5450,0.00200000}, {5500,0.00200909}, {5550,0.00200909}, {5600,0.00200000}, {5650,0.00198182}, {5700,0.00200000}, {5750,0.00200000}, {5800,0.00200909}, {5850,0.00200000}, {5900,0.00200000}, {5950,0.00200909}, {6000,0.00200000}, {6050,0.00200}, {6100,0.00200}, {6150,0.00250}, {6200,0.00250}, {6250,0.00225}, {6300,0.00200}, {6350,0.00250}, {6400,0.00250}, {6450,0.00225}, {6500,0.00275}, {6550,0.00275}, {6600,0.00300}, {6650,0.00275}, {6700,0.00300}, {6750,0.00300}, {6800,0.00275}, {6850,0.00300}, {6900,0.00300}, {6950,0.00300}, {7000,0.00300}, {7050,0.00300}, {7100,0.00300}, {7150,0.00300}, {7200,0.00300}, {7250,0.00300}, {7300,0.00300}, {7350,0.00300}, {7400,0.00300}, {7450,0.00300}, {7500,0.00300}, {7550,0.00300}, {7600,0.00300}, {7650,0.00325}, {7700,0.00300}, {7750,0.00300}, {7800,0.00300}, {7850,0.00300}, {7900,0.00300}, {7950,0.00325}, {8000,0.00300}, {8050,0.00300}, {8100,0.00300}, {8150,0.00300}, {8200,0.00300}, {8250,0.00325}, {8300,0.00325}, {8350,0.00325}, {8400,0.00325}, {8450,0.00300}, {8500,0.00325}, {8550,0.00600}, {8600,0.00300}, {8650,0.00325}, {8700,0.00325}, {8750,0.00300}, {8800,0.00325}, {8850,0.00325}, {8900,0.00325}, {8950,0.00325}, {9000,0.00300}, {9050,0.00300}, {9100,0.00300}, {9150,0.00300}, {9200,0.00325}, {9250,0.00350}, {9300,0.00300}, {9350,0.00300}, {9400,0.00300}, {9450,0.00325}, {9500,0.00300}, {9550,0.00325}, {9600,0.00300}, {9650,0.00300}, {9700,0.00325}, {9750,0.00375}, {9800,0.00350}, {9850,0.00325}, {9900,0.00325}, {9950,0.00325}, {10000,0.00300}, {10100,0.00350}, {10200,0.00350}, {10300,0.00350}, {10400,0.00375}, {10500,0.00350}, {10600,0.00400}, {10700,0.00375}, {10800,0.00375}, {10900,0.00400}, {11000,0.00375}, {11100,0.00400}, {11200,0.00400}, {11300,0.00400}, {11400,0.00425}, {11500,0.00425}, {11600,0.00400}, {11700,0.00400}, {11800,0.00425}, {11900,0.00425}, {12000,0.00475}, {12100,0.00475}, {12200,0.00450}, {12300,0.00425}, {12400,0.00425}, {12500,0.00450}, {12600,0.00500}, {12700,0.00425}, {12800,0.00475}, {12900,0.00500}, {13000,0.00475}, {13100,0.00500}, {13200,0.00975}, {13300,0.00950}, {13400,0.00500}, {13500,0.00525}, {13600,0.00525}, {13700,0.00500}, {13800,0.00525}, {13900,0.00525}, {14000,0.00500}, {14100,0.00550}, {14200,0.00575}, {14300,0.00575}, {14400,0.00600}, {14500,0.00575}, {14600,0.00675}, {14700,0.00600}, {14800,0.00575}, {14900,0.00625}, {15000,0.00600}, {15100,0.00625}, {15200,0.00650}, {15300,0.00625}, {15400,0.00675}, {15500,0.00650}, {15600,0.00625}, {15700,0.00725}, {15800,0.00650}, {15900,0.00700}, {16000,0.00675}, {16100,0.00675}, {16200,0.00700}, {16300,0.00675}, {16400,0.00700}, {16500,0.00700}, {16600,0.00700}, {16700,0.00675}, {16800,0.00725}, {16900,0.00700}, {17000,0.00700}, {17100,0.00725}, {17200,0.00725}, {17300,0.00775}, {17400,0.00700}, {17500,0.00725}, {17600,0.00750}, {17700,0.00725}, {17800,0.00775}, {17900,0.00825}, {18000,0.00725}, {18100,0.00800}, {18200,0.00775}, {18300,0.00800}, {18400,0.00775}, {18500,0.00800}, {18600,0.01425}, {18700,0.00800}, {18800,0.00825}, {18900,0.00825}, {19000,0.00825}, {19100,0.00825}, {19200,0.00825}, {19300,0.00825}, {19400,0.00850}, {19500,0.00925}, {19600,0.00850}, {19700,0.00875}, {19800,0.00875}, {19900,0.00850}, {20000,0.0085}};
data["big_flat"]["CanonicalStructuresPHOAS"]["intros _"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003604}, {4,0.00000000}, {5,0.00000000}, {6,0.00006306}, {7,0.00000000}, {8,0.00002703}, {9,0.00000000}, {10,0.00002703}, {11,0.00009009}, {12,0.00006306}, {13,0.00006306}, {14,0.00002703}, {15,0.00003604}, {16,0.00000000}, {17,0.00002703}, {18,0.00002703}, {19,0.00002703}, {20,0.00003604}, {21,0.00000000}, {22,0.00000000}, {23,0.00002703}, {24,0.00005405}, {25,0.00002703}, {26,0.00000000}, {27,0.00003604}, {28,0.00000000}, {29,0.00003604}, {30,0.00000000}, {31,0.00003604}, {32,0.00006306}, {33,0.00000000}, {34,0.00002703}, {35,0.00002703}, {36,0.00003604}, {37,0.00002703}, {38,0.00006306}, {39,0.00000000}, {40,0.00005405}, {41,0.00000000}, {42,0.00008108}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00007207}, {47,0.00002703}, {48,0.00000000}, {49,0.00003604}, {50,0.00012613}, {51,0.00005405}, {52,0.00000000}, {53,0.00002703}, {54,0.00006306}, {55,0.00002703}, {56,0.00002703}, {57,0.00003604}, {58,0.00009009}, {59,0.00005405}, {60,0.00003604}, {61,0.00005405}, {62,0.00000000}, {63,0.00005405}, {64,0.00009009}, {65,0.00006306}, {66,0.00000000}, {67,0.00000000}, {68,0.00006306}, {69,0.00000000}, {70,0.00012613}, {71,0.00007207}, {72,0.00002703}, {73,0.00015315}, {74,0.00003604}, {75,0.00012613}, {76,0.00000000}, {77,0.00016216}, {78,0.00000000}, {79,0.00000000}, {80,0.00007207}, {81,0.00002703}, {82,0.00005405}, {83,0.00002703}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00002703}, {88,0.00000000}, {89,0.00000000}, {90,0.00002703}, {91,0.00006306}, {92,0.00000000}, {93,0.00000000}, {94,0.00002703}, {95,0.00000000}, {96,0.00003604}, {97,0.00012613}, {98,0.00003604}, {99,0.00002703}, {100,0.00005405}, {101,0.00002703}, {102,0.00009009}, {103,0.00002703}, {104,0.00000000}, {105,0.00009910}, {106,0.00006306}, {107,0.00017117}, {108,0.00006306}, {109,0.00002703}, {110,0.00010811}, {111,0.00002703}, {112,0.00009910}, {113,0.00000000}, {114,0.00018919}, {115,0.00003604}, {116,0.00005405}, {117,0.00014414}, {118,0.00011712}, {119,0.00000000}, {120,0.00009009}, {121,0.00009009}, {122,0.00000000}, {123,0.00009910}, {124,0.00002703}, {125,0.00000000}, {126,0.00003604}, {127,0.00003604}, {128,0.00015315}, {129,0.00006306}, {130,0.00002703}, {131,0.00005405}, {132,0.00010811}, {133,0.00007207}, {134,0.00000000}, {135,0.00011712}, {136,0.00008108}, {137,0.00005405}, {138,0.00000000}, {139,0.00009910}, {140,0.00005405}, {141,0.00008108}, {142,0.00002703}, {143,0.00009009}, {144,0.00000000}, {145,0.00000000}, {146,0.00009009}, {147,0.00008108}, {148,0.00005405}, {149,0.00006306}, {150,0.00002703}, {151,0.00015315}, {152,0.00012613}, {153,0.00009009}, {154,0.00006306}, {155,0.00000000}, {156,0.00002703}, {157,0.00006306}, {158,0.00012613}, {159,0.00006306}, {160,0.00010811}, {161,0.00006306}, {162,0.00003604}, {163,0.00005405}, {164,0.00005405}, {165,0.00002703}, {166,0.00009009}, {167,0.00008108}, {168,0.00011712}, {169,0.00014414}, {170,0.00005405}, {171,0.00011712}, {172,0.00006306}, {173,0.00016216}, {174,0.00009009}, {175,0.00013514}, {176,0.00005405}, {177,0.00008108}, {178,0.00009009}, {179,0.00002703}, {180,0.00003604}, {181,0.00014414}, {182,0.00000000}, {183,0.00009009}, {184,0.00010811}, {185,0.00006306}, {186,0.00002703}, {187,0.00005405}, {188,0.00008108}, {189,0.00006306}, {190,0.00006306}, {191,0.00006306}, {192,0.00006306}, {193,0.00006306}, {194,0.00014414}, {195,0.00005405}, {196,0.00003604}, {197,0.00010811}, {198,0.00006306}, {199,0.00008108}, {200,0.00008108}, {201,0.00012613}, {202,0.00015315}, {203,0.00009910}, {204,0.00002703}, {205,0.00009009}, {206,0.00014414}, {207,0.00018919}, {208,0.00002703}, {209,0.00005405}, {210,0.00024324}, {211,0.00005405}, {212,0.00002703}, {213,0.00009910}, {214,0.00008108}, {215,0.00009009}, {216,0.00002703}, {217,0.00012613}, {218,0.00012613}, {219,0.00014414}, {220,0.00011712}, {221,0.00003604}, {222,0.00006306}, {223,0.00015315}, {224,0.00014414}, {225,0.00023423}, {226,0.00017117}, {227,0.00015315}, {228,0.00005405}, {229,0.00011712}, {230,0.00018919}, {231,0.00015315}, {232,0.00014414}, {233,0.00013514}, {234,0.00013514}, {235,0.00015315}, {236,0.00002703}, {237,0.00018018}, {238,0.00008108}, {239,0.00023423}, {240,0.00016216}, {241,0.00009009}, {242,0.00015315}, {243,0.00008108}, {244,0.00002703}, {245,0.00020721}, {246,0.00012613}, {247,0.00000000}, {248,0.00009009}, {249,0.00002703}, {250,0.00022523}, {251,0.00010811}, {252,0.00009910}, {253,0.00024324}, {254,0.00015315}, {255,0.00015315}, {256,0.00016216}, {257,0.00000000}, {258,0.00009009}, {259,0.00011712}, {260,0.00012613}, {261,0.00014414}, {262,0.00000000}, {263,0.00013514}, {264,0.00014414}, {265,0.00013514}, {266,0.00009910}, {267,0.00008108}, {268,0.00013514}, {269,0.00011712}, {270,0.00011712}, {271,0.00013514}, {272,0.00013514}, {273,0.00009009}, {274,0.00002703}, {275,0.00014414}, {276,0.00005405}, {277,0.00008108}, {278,0.00006306}, {279,0.00005405}, {280,0.00027928}, {281,0.00010811}, {282,0.00006306}, {283,0.00012613}, {284,0.00014414}, {285,0.00020721}, {286,0.00009009}, {287,0.00021622}, {288,0.00013514}, {289,0.00009910}, {290,0.00016216}, {291,0.00007207}, {292,0.00013514}, {293,0.00009009}, {294,0.00011712}, {295,0.00027027}, {296,0.00012613}, {297,0.00027928}, {298,0.00017117}, {299,0.00011712}, {300,0.00014414}, {301,0.00006306}, {302,0.00009009}, {303,0.00012613}, {304,0.00029730}, {305,0.00008108}, {306,0.00008108}, {307,0.00011712}, {308,0.00006306}, {309,0.00010811}, {310,0.00000000}, {311,0.00000000}, {312,0.00010811}, {313,0.00018018}, {314,0.00019820}, {315,0.00005405}, {316,0.00011712}, {317,0.00025225}, {318,0.00005405}, {319,0.00009910}, {320,0.00009009}, {321,0.00016216}, {322,0.00016216}, {323,0.00021622}, {324,0.00006306}, {325,0.00017117}, {326,0.00009910}, {327,0.00015315}, {328,0.00013514}, {329,0.00022523}, {330,0.00018919}, {331,0.00008108}, {332,0.00005405}, {333,0.00002703}, {334,0.00015315}, {335,0.00014414}, {336,0.00010811}, {337,0.00022523}, {338,0.00005405}, {339,0.00030631}, {340,0.00005405}, {341,0.00005405}, {342,0.00017117}, {343,0.00011712}, {344,0.00009009}, {345,0.00029730}, {346,0.00031532}, {347,0.00011712}, {348,0.00009009}, {349,0.00005405}, {350,0.00005405}, {351,0.00006306}, {352,0.00027928}, {353,0.00028829}, {354,0.00011712}, {355,0.00006306}, {356,0.00008108}, {357,0.00005405}, {358,0.00010811}, {359,0.00023423}, {360,0.00012613}, {361,0.00011712}, {362,0.00025225}, {363,0.00008108}, {364,0.00025225}, {365,0.00027027}, {366,0.00014414}, {367,0.00008108}, {368,0.00018919}, {369,0.00013514}, {370,0.00023423}, {371,0.00015315}, {372,0.00019820}, {373,0.00027027}, {374,0.00017117}, {375,0.00011712}, {376,0.00019820}, {377,0.00014414}, {378,0.00012613}, {379,0.00009009}, {380,0.00015315}, {381,0.00012613}, {382,0.00007207}, {383,0.00017117}, {384,0.00030631}, {385,0.00018919}, {386,0.00009009}, {387,0.00006306}, {388,0.00022523}, {389,0.00011712}, {390,0.00019820}, {391,0.00017117}, {392,0.00024324}, {393,0.00020721}, {394,0.00025225}, {395,0.00022523}, {396,0.00019820}, {397,0.00011712}, {398,0.00018919}, {399,0.00020721}, {400,0.00009009}, {401,0.00002703}, {402,0.00012613}, {403,0.00021622}, {404,0.00027928}, {405,0.00019820}, {406,0.00015315}, {407,0.00019820}, {408,0.00013514}, {409,0.00018018}, {410,0.00025225}, {411,0.00014414}, {412,0.00021622}, {413,0.00014414}, {414,0.00025225}, {415,0.00009910}, {416,0.00020721}, {417,0.00021622}, {418,0.00027027}, {419,0.00014414}, {420,0.00019820}, {421,0.00023423}, {422,0.00011712}, {423,0.00015315}, {424,0.00013514}, {425,0.00010811}, {426,0.00011712}, {427,0.00019820}, {428,0.00024324}, {429,0.00011712}, {430,0.00034234}, {431,0.00024324}, {432,0.00011712}, {433,0.00017117}, {434,0.00020721}, {435,0.00021622}, {436,0.00013514}, {437,0.00010811}, {438,0.00025225}, {439,0.00016216}, {440,0.00022523}, {441,0.00027027}, {442,0.00017117}, {443,0.00019820}, {444,0.00009009}, {445,0.00018018}, {446,0.00020721}, {447,0.00015315}, {448,0.00018919}, {449,0.00020721}, {450,0.00006306}, {451,0.00037838}, {452,0.00018919}, {453,0.00033333}, {454,0.00012613}, {455,0.00028829}, {456,0.00018919}, {457,0.00011712}, {458,0.00023423}, {459,0.00017117}, {460,0.00020721}, {461,0.00015315}, {462,0.00023423}, {463,0.00027027}, {464,0.00028829}, {465,0.00024324}, {466,0.00014414}, {467,0.00022523}, {468,0.00011712}, {469,0.00022523}, {470,0.00015315}, {471,0.00008108}, {472,0.00041441}, {473,0.00016216}, {474,0.00014414}, {475,0.00020721}, {476,0.00030631}, {477,0.00017117}, {478,0.00031532}, {479,0.00023423}, {480,0.00011712}, {481,0.00013514}, {482,0.00018919}, {483,0.00024324}, {484,0.00020721}, {485,0.00031532}, {486,0.00035135}, {487,0.00043243}, {488,0.00017117}, {489,0.00013514}, {490,0.00006306}, {491,0.00011712}, {492,0.00027928}, {493,0.00009009}, {494,0.00015315}, {495,0.00021622}, {496,0.00022523}, {497,0.00008108}, {498,0.00010811}, {499,0.00028829}, {500,0.00025225}, {505,0.00023423}, {510,0.00020721}, {515,0.00023423}, {520,0.00023423}, {525,0.00021622}, {530,0.00026126}, {535,0.00026126}, {540,0.00018919}, {545,0.00018018}, {550,0.00038739}, {555,0.00017117}, {560,0.00027928}, {565,0.00013514}, {570,0.00006306}, {575,0.00038739}, {580,0.00024324}, {585,0.00043243}, {590,0.00036036}, {595,0.00008108}, {600,0.00036036}, {605,0.00008108}, {610,0.00036036}, {615,0.00014414}, {620,0.00040541}, {625,0.00025225}, {630,0.00024324}, {635,0.00018018}, {640,0.00042342}, {645,0.00031532}, {650,0.00024324}, {655,0.00019820}, {660,0.00005405}, {665,0.00045946}, {670,0.00025225}, {675,0.00015315}, {680,0.00033333}, {685,0.00025225}, {690,0.00036937}, {695,0.00025225}, {700,0.00029730}, {705,0.00036036}, {710,0.00017117}, {715,0.00042342}, {720,0.00015315}, {725,0.00018919}, {730,0.00034234}, {735,0.00027928}, {740,0.00050450}, {745,0.00043243}, {750,0.00046847}, {755,0.00059459}, {760,0.00027027}, {765,0.00037838}, {770,0.00041441}, {775,0.00026126}, {780,0.00027928}, {785,0.00049550}, {790,0.00021622}, {795,0.00033333}, {800,0.00052252}, {805,0.00031532}, {810,0.00024324}, {815,0.00047748}, {820,0.00018919}, {825,0.00056757}, {830,0.00013514}, {835,0.00027928}, {840,0.00021622}, {845,0.00054054}, {850,0.00037838}, {855,0.00025225}, {860,0.00036036}, {865,0.00036036}, {870,0.00029730}, {875,0.00045946}, {880,0.00043243}, {885,0.00021622}, {890,0.00037838}, {895,0.00034234}, {900,0.00029730}, {905,0.00047748}, {910,0.00034234}, {915,0.00044144}, {920,0.00034234}, {925,0.00048649}, {930,0.00042342}, {935,0.00040541}, {940,0.00041441}, {945,0.00028829}, {950,0.00045946}, {955,0.00062162}, {960,0.00022523}, {965,0.00055856}, {970,0.00041441}, {975,0.00044144}, {980,0.00044144}, {985,0.00036937}, {990,0.00037838}, {995,0.00040541}, {1000,0.00037838}, {1010,0.00038739}, {1020,0.00037838}, {1030,0.00047748}, {1040,0.00049550}, {1050,0.00066364}, {1060,0.00047273}, {1070,0.00040909}, {1080,0.00040000}, {1090,0.00040909}, {1100,0.00042727}, {1110,0.00040000}, {1120,0.00042727}, {1130,0.00052727}, {1140,0.00041818}, {1150,0.00032727}, {1160,0.00036364}, {1170,0.00026364}, {1180,0.00040909}, {1190,0.00043636}, {1200,0.00043636}, {1210,0.00053636}, {1220,0.00047273}, {1230,0.00060909}, {1240,0.00048182}, {1250,0.00042727}, {1260,0.00031818}, {1270,0.00070000}, {1280,0.00060909}, {1290,0.00051818}, {1300,0.00056364}, {1310,0.00052727}, {1320,0.00055455}, {1330,0.00050000}, {1340,0.00040909}, {1350,0.00049091}, {1360,0.00074545}, {1370,0.00064545}, {1380,0.00050000}, {1390,0.00069091}, {1400,0.00060000}, {1410,0.00073636}, {1420,0.00060000}, {1430,0.00050909}, {1440,0.00065455}, {1450,0.00084545}, {1460,0.00069091}, {1470,0.00098182}, {1480,0.00050909}, {1490,0.00049091}, {1500,0.00065455}, {1510,0.00073636}, {1520,0.00037273}, {1530,0.00065455}, {1540,0.00039091}, {1550,0.00063636}, {1560,0.00058182}, {1570,0.00070909}, {1580,0.00073636}, {1590,0.00066364}, {1600,0.00063636}, {1610,0.00062727}, {1620,0.00080909}, {1630,0.00064545}, {1640,0.00084545}, {1650,0.00086364}, {1660,0.00058182}, {1670,0.00060000}, {1680,0.00090909}, {1690,0.00069091}, {1700,0.00077273}, {1710,0.00075455}, {1720,0.00065455}, {1730,0.00068182}, {1740,0.00095455}, {1750,0.00087273}, {1760,0.00094545}, {1770,0.00067273}, {1780,0.00080000}, {1790,0.00093636}, {1800,0.00079091}, {1810,0.00106364}, {1820,0.00072727}, {1830,0.00066364}, {1840,0.00077273}, {1850,0.00059091}, {1860,0.00082727}, {1870,0.00084545}, {1880,0.00102727}, {1890,0.00089091}, {1900,0.00079091}, {1910,0.00081818}, {1920,0.00087273}, {1930,0.00095455}, {1940,0.00064545}, {1950,0.00095455}, {1960,0.00061818}, {1970,0.00080909}, {1980,0.00080909}, {1990,0.00102727}, {2000,0.00087273}, {2050,0.00084545}, {2100,0.00088182}, {2150,0.00122727}, {2200,0.00105455}, {2250,0.00115455}, {2300,0.00082727}, {2350,0.00090000}, {2400,0.00084545}, {2450,0.00127273}, {2500,0.00084545}, {2550,0.00114545}, {2600,0.00092727}, {2650,0.00085455}, {2700,0.00128182}, {2750,0.00110000}, {2800,0.00152727}, {2850,0.00140909}, {2900,0.00120000}, {2950,0.00116364}, {3000,0.00104545}, {3050,0.00163636}, {3100,0.00116364}, {3150,0.00139091}, {3200,0.00158182}, {3250,0.00136364}, {3300,0.00158182}, {3350,0.00157273}, {3400,0.00134545}, {3450,0.00150000}, {3500,0.00165455}, {3550,0.00137273}, {3600,0.00148182}, {3650,0.00165455}, {3700,0.00130909}, {3750,0.00153636}, {3800,0.00153636}, {3850,0.00152727}, {3900,0.00167273}, {3950,0.00181818}, {4000,0.00176364}, {4050,0.00170000}, {4100,0.00158182}, {4150,0.00172727}, {4200,0.00226364}, {4250,0.00180000}, {4300,0.00217273}, {4350,0.00214545}, {4400,0.00191818}, {4450,0.00202727}, {4500,0.00190000}, {4550,0.00187273}, {4600,0.00220909}, {4650,0.00190909}, {4700,0.00228182}, {4750,0.00196364}, {4800,0.00236364}, {4850,0.00196364}, {4900,0.00208182}, {4950,0.00220909}, {5000,0.00220909}, {5050,0.00230909}, {5100,0.00221818}, {5150,0.00205455}, {5200,0.00237273}, {5250,0.00243636}, {5300,0.00219091}, {5350,0.00222727}, {5400,0.00216364}, {5450,0.00251818}, {5500,0.00260909}, {5550,0.00200000}, {5600,0.00202727}, {5650,0.00212727}, {5700,0.00246364}, {5750,0.00219091}, {5800,0.00206364}, {5850,0.00204545}, {5900,0.00230000}, {5950,0.00223636}, {6000,0.00239091}, {6050,0.00200}, {6100,0.00225}, {6150,0.00275}, {6200,0.00250}, {6250,0.00350}, {6300,0.00350}, {6350,0.00200}, {6400,0.00300}, {6450,0.00400}, {6500,0.00300}, {6550,0.00375}, {6600,0.00175}, {6650,0.00300}, {6700,0.00300}, {6750,0.00250}, {6800,0.00375}, {6850,0.00400}, {6900,0.00300}, {6950,0.00400}, {7000,0.00400}, {7050,0.00200}, {7100,0.00375}, {7150,0.00100}, {7200,0.00200}, {7250,0.00300}, {7300,0.00400}, {7350,0.00350}, {7400,0.00275}, {7450,0.00375}, {7500,0.00200}, {7550,0.00400}, {7600,0.00400}, {7650,0.00350}, {7700,0.00375}, {7750,0.00400}, {7800,0.00400}, {7850,0.00400}, {7900,0.00250}, {7950,0.00375}, {8000,0.00375}, {8050,0.00400}, {8100,0.00200}, {8150,0.00400}, {8200,0.00200}, {8250,0.00250}, {8300,0.00375}, {8350,0.00400}, {8400,0.00400}, {8450,0.00400}, {8500,0.00400}, {8550,0.00700}, {8600,0.00275}, {8650,0.00350}, {8700,0.00200}, {8750,0.00300}, {8800,0.00400}, {8850,0.00300}, {8900,0.00275}, {8950,0.00300}, {9000,0.00300}, {9050,0.00400}, {9100,0.00300}, {9150,0.00375}, {9200,0.00400}, {9250,0.00400}, {9300,0.00350}, {9350,0.00400}, {9400,0.00300}, {9450,0.00375}, {9500,0.00375}, {9550,0.00350}, {9600,0.00375}, {9650,0.00375}, {9700,0.00375}, {9750,0.00375}, {9800,0.00400}, {9850,0.00300}, {9900,0.00300}, {9950,0.00400}, {10000,0.00300}, {10100,0.00400}, {10200,0.00375}, {10300,0.00400}, {10400,0.00400}, {10500,0.00325}, {10600,0.00375}, {10700,0.00375}, {10800,0.00375}, {10900,0.00400}, {11000,0.00475}, {11100,0.00400}, {11200,0.00475}, {11300,0.00500}, {11400,0.00475}, {11500,0.00500}, {11600,0.00450}, {11700,0.00500}, {11800,0.00350}, {11900,0.00300}, {12000,0.00350}, {12100,0.00450}, {12200,0.00450}, {12300,0.00575}, {12400,0.00425}, {12500,0.00425}, {12600,0.00600}, {12700,0.00325}, {12800,0.00675}, {12900,0.00675}, {13000,0.00325}, {13100,0.00475}, {13200,0.00850}, {13300,0.01100}, {13400,0.00450}, {13500,0.00675}, {13600,0.00300}, {13700,0.00650}, {13800,0.00450}, {13900,0.00575}, {14000,0.00525}, {14100,0.00650}, {14200,0.00650}, {14300,0.00450}, {14400,0.00525}, {14500,0.00650}, {14600,0.00575}, {14700,0.00775}, {14800,0.00675}, {14900,0.00775}, {15000,0.00675}, {15100,0.00800}, {15200,0.00600}, {15300,0.00425}, {15400,0.00675}, {15500,0.00650}, {15600,0.00775}, {15700,0.00700}, {15800,0.00675}, {15900,0.00675}, {16000,0.00775}, {16100,0.00900}, {16200,0.00675}, {16300,0.00550}, {16400,0.00750}, {16500,0.00775}, {16600,0.00650}, {16700,0.00550}, {16800,0.00700}, {16900,0.00800}, {17000,0.00750}, {17100,0.00800}, {17200,0.00800}, {17300,0.00775}, {17400,0.00675}, {17500,0.00675}, {17600,0.00775}, {17700,0.00800}, {17800,0.00975}, {17900,0.00700}, {18000,0.00750}, {18100,0.00750}, {18200,0.00700}, {18300,0.00875}, {18400,0.00775}, {18500,0.00700}, {18600,0.01325}, {18700,0.00875}, {18800,0.00875}, {18900,0.00750}, {19000,0.00675}, {19100,0.00775}, {19200,0.00750}, {19300,0.00950}, {19400,0.00800}, {19500,0.00950}, {19600,0.00875}, {19700,0.00900}, {19800,0.01025}, {19900,0.00875}, {20000,0.0080}};
data["big_flat"]["CanonicalStructuresPHOAS"]["intros _"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00003604}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00003604}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00003604}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00003604}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00003604}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00003604}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00003604}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00003604}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00002703}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003604}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00002703}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00003604}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00003604}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00007207}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00003604}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00003604}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00003604}, {470,0.00000000}, {471,0.00000000}, {472,0.00003604}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00003604}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00002703}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00003604}, {580,0.00000000}, {585,0.00002703}, {590,0.00000000}, {595,0.00000000}, {600,0.00003604}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00003604}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00003604}, {690,0.00003604}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00003604}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00003604}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00003604}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00003604}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00003636}, {1080,0.00006364}, {1090,0.00000000}, {1100,0.00003636}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00003636}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00003636}, {1270,0.00000000}, {1280,0.00003636}, {1290,0.00000000}, {1300,0.00003636}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00003636}, {1360,0.00007273}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00003636}, {1410,0.00000000}, {1420,0.00003636}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003636}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00003636}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00003636}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00007273}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00003636}, {1720,0.00000000}, {1730,0.00003636}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00003636}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00003636}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00003636}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00003636}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00003636}, {2600,0.00003636}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00003636}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00003636}, {3450,0.00000000}, {3500,0.00003636}, {3550,0.00003636}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00003636}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00003636}, {4700,0.00003636}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00003636}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00003636}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00007273}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00100}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00100}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00100}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00100}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresPHOAS"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00002703}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00002703}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00025225}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00389189}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00008182}, {1860,0.00000000}, {1870,0.00007273}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00008182}, {1990,0.00000000}, {2000,0.00006364}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000909}, {2250,0.00000909}, {2300,0.00006364}, {2350,0.00010909}, {2400,0.00034545}, {2450,0.00054545}, {2500,0.00073636}, {2550,0.00084545}, {2600,0.00095455}, {2650,0.00100000}, {2700,0.00100000}, {2750,0.00102727}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00100000}, {3150,0.00100000}, {3200,0.00100000}, {3250,0.00100000}, {3300,0.00100000}, {3350,0.00100000}, {3400,0.00100000}, {3450,0.00100000}, {3500,0.00100000}, {3550,0.00100000}, {3600,0.00100000}, {3650,0.00100000}, {3700,0.00100000}, {3750,0.00100000}, {3800,0.00100000}, {3850,0.00100000}, {3900,0.00100000}, {3950,0.00100909}, {4000,0.00100000}, {4050,0.00101818}, {4100,0.00100909}, {4150,0.00105455}, {4200,0.00106364}, {4250,0.00106364}, {4300,0.00119091}, {4350,0.00127273}, {4400,0.00132727}, {4450,0.00147273}, {4500,0.00153636}, {4550,0.00517273}, {4600,0.00170000}, {4650,0.00167273}, {4700,0.00179091}, {4750,0.00183636}, {4800,0.01060000}, {4850,0.00191818}, {4900,0.00195455}, {4950,0.00199091}, {5000,0.00200000}, {5050,0.00200000}, {5100,0.00200000}, {5150,0.00200000}, {5200,0.00200000}, {5250,0.00200000}, {5300,0.00200000}, {5350,0.00200000}, {5400,0.00200000}, {5450,0.00200000}, {5500,0.00200000}, {5550,0.00200000}, {5600,0.00200000}, {5650,0.00200000}, {5700,0.00200000}, {5750,0.00200000}, {5800,0.00200000}, {5850,0.00200000}, {5900,0.00200000}, {5950,0.00200000}, {6000,0.00200000}, {6050,0.00200}, {6100,0.00700}, {6150,0.00250}, {6200,0.00500}, {6250,0.00200}, {6300,0.00200}, {6350,0.00225}, {6400,0.00250}, {6450,0.00225}, {6500,0.00225}, {6550,0.00575}, {6600,0.00225}, {6650,0.00275}, {6700,0.00225}, {6750,0.00250}, {6800,0.00275}, {6850,0.00275}, {6900,0.00300}, {6950,0.00300}, {7000,0.00300}, {7050,0.00300}, {7100,0.00775}, {7150,0.00300}, {7200,0.00300}, {7250,0.00300}, {7300,0.00300}, {7350,0.00300}, {7400,0.00300}, {7450,0.00300}, {7500,0.00300}, {7550,0.00300}, {7600,0.00300}, {7650,0.00300}, {7700,0.00300}, {7750,0.00300}, {7800,0.01050}, {7850,0.00300}, {7900,0.00300}, {7950,0.00325}, {8000,0.00325}, {8050,0.00300}, {8100,0.00300}, {8150,0.00300}, {8200,0.00350}, {8250,0.00325}, {8300,0.00325}, {8350,0.00725}, {8400,0.00350}, {8450,0.00325}, {8500,0.00325}, {8550,0.00325}, {8600,0.00300}, {8650,0.00325}, {8700,0.00350}, {8750,0.00325}, {8800,0.00625}, {8850,0.00325}, {8900,0.00325}, {8950,0.00325}, {9000,0.00325}, {9050,0.00325}, {9100,0.00350}, {9150,0.00300}, {9200,0.00350}, {9250,0.00375}, {9300,0.00300}, {9350,0.00350}, {9400,0.00350}, {9450,0.00375}, {9500,0.00375}, {9550,0.00400}, {9600,0.00375}, {9650,0.00400}, {9700,0.00400}, {9750,0.00425}, {9800,0.00925}, {9850,0.00400}, {9900,0.00400}, {9950,0.00400}, {10000,0.00400}, {10100,0.00400}, {10200,0.00950}, {10300,0.00400}, {10400,0.00400}, {10500,0.00425}, {10600,0.00400}, {10700,0.00400}, {10800,0.00400}, {10900,0.00425}, {11000,0.00400}, {11100,0.00425}, {11200,0.00500}, {11300,0.00425}, {11400,0.00450}, {11500,0.00450}, {11600,0.00425}, {11700,0.00475}, {11800,0.00500}, {11900,0.00500}, {12000,0.00500}, {12100,0.00500}, {12200,0.00500}, {12300,0.00500}, {12400,0.00500}, {12500,0.00500}, {12600,0.00550}, {12700,0.00525}, {12800,0.00550}, {12900,0.01075}, {13000,0.00500}, {13100,0.01100}, {13200,0.00600}, {13300,0.00575}, {13400,0.00575}, {13500,0.00550}, {13600,0.00575}, {13700,0.00600}, {13800,0.00575}, {13900,0.00600}, {14000,0.00575}, {14100,0.00600}, {14200,0.00650}, {14300,0.00650}, {14400,0.00650}, {14500,0.00675}, {14600,0.00700}, {14700,0.00675}, {14800,0.00650}, {14900,0.00650}, {15000,0.00625}, {15100,0.00700}, {15200,0.01850}, {15300,0.00675}, {15400,0.01525}, {15500,0.00725}, {15600,0.02000}, {15700,0.00750}, {15800,0.00750}, {15900,0.00750}, {16000,0.00700}, {16100,0.00750}, {16200,0.00750}, {16300,0.00700}, {16400,0.00750}, {16500,0.00750}, {16600,0.00750}, {16700,0.00775}, {16800,0.00750}, {16900,0.00775}, {17000,0.00775}, {17100,0.02025}, {17200,0.01425}, {17300,0.00775}, {17400,0.00775}, {17500,0.00775}, {17600,0.00875}, {17700,0.00775}, {17800,0.02125}, {17900,0.00875}, {18000,0.00800}, {18100,0.00825}, {18200,0.00825}, {18300,0.00850}, {18400,0.00850}, {18500,0.00875}, {18600,0.00875}, {18700,0.01500}, {18800,0.00875}, {18900,0.00875}, {19000,0.00900}, {19100,0.01650}, {19200,0.02500}, {19300,0.00875}, {19400,0.00900}, {19500,0.01025}, {19600,0.00925}, {19700,0.00975}, {19800,0.00950}, {19900,0.00950}, {20000,0.0090}};
data["big_flat"]["CanonicalStructuresPHOAS"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00003604}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00002703}, {8,0.00002703}, {9,0.00010811}, {10,0.00000000}, {11,0.00002703}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00002703}, {16,0.00002703}, {17,0.00002703}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00003604}, {22,0.00000000}, {23,0.00000000}, {24,0.00002703}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00002703}, {29,0.00002703}, {30,0.00000000}, {31,0.00002703}, {32,0.00002703}, {33,0.00000000}, {34,0.00003604}, {35,0.00005405}, {36,0.00000000}, {37,0.00002703}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00002703}, {43,0.00006306}, {44,0.00003604}, {45,0.00006306}, {46,0.00000000}, {47,0.00005405}, {48,0.00002703}, {49,0.00000000}, {50,0.00000000}, {51,0.00009910}, {52,0.00000000}, {53,0.00006306}, {54,0.00005405}, {55,0.00002703}, {56,0.00000000}, {57,0.00003604}, {58,0.00003604}, {59,0.00000000}, {60,0.00002703}, {61,0.00006306}, {62,0.00002703}, {63,0.00002703}, {64,0.00003604}, {65,0.00005405}, {66,0.00005405}, {67,0.00002703}, {68,0.00002703}, {69,0.00000000}, {70,0.00000000}, {71,0.00006306}, {72,0.00000000}, {73,0.00003604}, {74,0.00000000}, {75,0.00002703}, {76,0.00006306}, {77,0.00000000}, {78,0.00006306}, {79,0.00002703}, {80,0.00002703}, {81,0.00002703}, {82,0.00002703}, {83,0.00006306}, {84,0.00002703}, {85,0.00003604}, {86,0.00009009}, {87,0.00009009}, {88,0.00000000}, {89,0.00006306}, {90,0.00014414}, {91,0.00006306}, {92,0.00017117}, {93,0.00000000}, {94,0.00000000}, {95,0.00009009}, {96,0.00011712}, {97,0.00002703}, {98,0.00003604}, {99,0.00000000}, {100,0.00006306}, {101,0.00006306}, {102,0.00000000}, {103,0.00002703}, {104,0.00011712}, {105,0.00013514}, {106,0.00002703}, {107,0.00006306}, {108,0.00002703}, {109,0.00011712}, {110,0.00000000}, {111,0.00003604}, {112,0.00005405}, {113,0.00002703}, {114,0.00002703}, {115,0.00005405}, {116,0.00009910}, {117,0.00012613}, {118,0.00005405}, {119,0.00008108}, {120,0.00006306}, {121,0.00000000}, {122,0.00012613}, {123,0.00002703}, {124,0.00009009}, {125,0.00006306}, {126,0.00012613}, {127,0.00000000}, {128,0.00009910}, {129,0.00006306}, {130,0.00005405}, {131,0.00014414}, {132,0.00000000}, {133,0.00000000}, {134,0.00006306}, {135,0.00009009}, {136,0.00000000}, {137,0.00009009}, {138,0.00006306}, {139,0.00000000}, {140,0.00006306}, {141,0.00002703}, {142,0.00006306}, {143,0.00012613}, {144,0.00000000}, {145,0.00013514}, {146,0.00006306}, {147,0.00011712}, {148,0.00000000}, {149,0.00002703}, {150,0.00002703}, {151,0.00009910}, {152,0.00005405}, {153,0.00009009}, {154,0.00005405}, {155,0.00002703}, {156,0.00009009}, {157,0.00002703}, {158,0.00005405}, {159,0.00002703}, {160,0.00002703}, {161,0.00005405}, {162,0.00008108}, {163,0.00007207}, {164,0.00006306}, {165,0.00003604}, {166,0.00002703}, {167,0.00007207}, {168,0.00002703}, {169,0.00009009}, {170,0.00002703}, {171,0.00014414}, {172,0.00006306}, {173,0.00011712}, {174,0.00005405}, {175,0.00000000}, {176,0.00009009}, {177,0.00018018}, {178,0.00002703}, {179,0.00012613}, {180,0.00024324}, {181,0.00005405}, {182,0.00016216}, {183,0.00005405}, {184,0.00000000}, {185,0.00010811}, {186,0.00002703}, {187,0.00000000}, {188,0.00005405}, {189,0.00005405}, {190,0.00014414}, {191,0.00000000}, {192,0.00007207}, {193,0.00000000}, {194,0.00005405}, {195,0.00005405}, {196,0.00018919}, {197,0.00002703}, {198,0.00003604}, {199,0.00006306}, {200,0.00006306}, {201,0.00002703}, {202,0.00006306}, {203,0.00005405}, {204,0.00009009}, {205,0.00018919}, {206,0.00009910}, {207,0.00018919}, {208,0.00007207}, {209,0.00018018}, {210,0.00017117}, {211,0.00016216}, {212,0.00005405}, {213,0.00008108}, {214,0.00009009}, {215,0.00005405}, {216,0.00016216}, {217,0.00008108}, {218,0.00016216}, {219,0.00017117}, {220,0.00003604}, {221,0.00016216}, {222,0.00005405}, {223,0.00006306}, {224,0.00006306}, {225,0.00017117}, {226,0.00009009}, {227,0.00023423}, {228,0.00009910}, {229,0.00010811}, {230,0.00000000}, {231,0.00011712}, {232,0.00009009}, {233,0.00013514}, {234,0.00013514}, {235,0.00018018}, {236,0.00033333}, {237,0.00009009}, {238,0.00002703}, {239,0.00017117}, {240,0.00002703}, {241,0.00002703}, {242,0.00009009}, {243,0.00009910}, {244,0.00016216}, {245,0.00009009}, {246,0.00010811}, {247,0.00013514}, {248,0.00021622}, {249,0.00016216}, {250,0.00008108}, {251,0.00002703}, {252,0.00011712}, {253,0.00009009}, {254,0.00007207}, {255,0.00008108}, {256,0.00017117}, {257,0.00002703}, {258,0.00008108}, {259,0.00006306}, {260,0.00006306}, {261,0.00009009}, {262,0.00009009}, {263,0.00009910}, {264,0.00012613}, {265,0.00011712}, {266,0.00009009}, {267,0.00009009}, {268,0.00008108}, {269,0.00014414}, {270,0.00005405}, {271,0.00008108}, {272,0.00009009}, {273,0.00002703}, {274,0.00019820}, {275,0.00009009}, {276,0.00005405}, {277,0.00009009}, {278,0.00009009}, {279,0.00007207}, {280,0.00006306}, {281,0.00009009}, {282,0.00011712}, {283,0.00014414}, {284,0.00026126}, {285,0.00014414}, {286,0.00009009}, {287,0.00014414}, {288,0.00018919}, {289,0.00011712}, {290,0.00006306}, {291,0.00012613}, {292,0.00020721}, {293,0.00005405}, {294,0.00020721}, {295,0.00014414}, {296,0.00011712}, {297,0.00006306}, {298,0.00003604}, {299,0.00010811}, {300,0.00014414}, {301,0.00005405}, {302,0.00020721}, {303,0.00009009}, {304,0.00007207}, {305,0.00012613}, {306,0.00005405}, {307,0.00019820}, {308,0.00016216}, {309,0.00013514}, {310,0.00003604}, {311,0.00008108}, {312,0.00006306}, {313,0.00005405}, {314,0.00021622}, {315,0.00017117}, {316,0.00018919}, {317,0.00014414}, {318,0.00010811}, {319,0.00012613}, {320,0.00017117}, {321,0.00012613}, {322,0.00008108}, {323,0.00009009}, {324,0.00020721}, {325,0.00014414}, {326,0.00035135}, {327,0.00009009}, {328,0.00024324}, {329,0.00018018}, {330,0.00008108}, {331,0.00006306}, {332,0.00027027}, {333,0.00006306}, {334,0.00020721}, {335,0.00015315}, {336,0.00010811}, {337,0.00006306}, {338,0.00026126}, {339,0.00015315}, {340,0.00010811}, {341,0.00006306}, {342,0.00009910}, {343,0.00011712}, {344,0.00009009}, {345,0.00011712}, {346,0.00016216}, {347,0.00016216}, {348,0.00009009}, {349,0.00027027}, {350,0.00010811}, {351,0.00018018}, {352,0.00015315}, {353,0.00008108}, {354,0.00029730}, {355,0.00024324}, {356,0.00020721}, {357,0.00018919}, {358,0.00010811}, {359,0.00018919}, {360,0.00015315}, {361,0.00023423}, {362,0.00005405}, {363,0.00024324}, {364,0.00019820}, {365,0.00018018}, {366,0.00018919}, {367,0.00006306}, {368,0.00016216}, {369,0.00011712}, {370,0.00014414}, {371,0.00016216}, {372,0.00011712}, {373,0.00023423}, {374,0.00019820}, {375,0.00002703}, {376,0.00017117}, {377,0.00010811}, {378,0.00009009}, {379,0.00018018}, {380,0.00013514}, {381,0.00022523}, {382,0.00017117}, {383,0.00021622}, {384,0.00007207}, {385,0.00008108}, {386,0.00018919}, {387,0.00024324}, {388,0.00018919}, {389,0.00028829}, {390,0.00018018}, {391,0.00020721}, {392,0.00018018}, {393,0.00018919}, {394,0.00018018}, {395,0.00005405}, {396,0.00006306}, {397,0.00020721}, {398,0.00023423}, {399,0.00007207}, {400,0.00017117}, {401,0.00012613}, {402,0.00019820}, {403,0.00009009}, {404,0.00020721}, {405,0.00011712}, {406,0.00005405}, {407,0.00020721}, {408,0.00012613}, {409,0.00010811}, {410,0.00023423}, {411,0.00029730}, {412,0.00021622}, {413,0.00002703}, {414,0.00006306}, {415,0.00009009}, {416,0.00025225}, {417,0.00020721}, {418,0.00009009}, {419,0.00016216}, {420,0.00011712}, {421,0.00027027}, {422,0.00018919}, {423,0.00022523}, {424,0.00018018}, {425,0.00005405}, {426,0.00013514}, {427,0.00008108}, {428,0.00005405}, {429,0.00018018}, {430,0.00019820}, {431,0.00015315}, {432,0.00022523}, {433,0.00020721}, {434,0.00017117}, {435,0.00015315}, {436,0.00009009}, {437,0.00031532}, {438,0.00022523}, {439,0.00026126}, {440,0.00018919}, {441,0.00018018}, {442,0.00007207}, {443,0.00005405}, {444,0.00024324}, {445,0.00011712}, {446,0.00013514}, {447,0.00011712}, {448,0.00033333}, {449,0.00023423}, {450,0.00022523}, {451,0.00014414}, {452,0.00021622}, {453,0.00020721}, {454,0.00014414}, {455,0.00015315}, {456,0.00021622}, {457,0.00010811}, {458,0.00023423}, {459,0.00020721}, {460,0.00019820}, {461,0.00029730}, {462,0.00014414}, {463,0.00030631}, {464,0.00019820}, {465,0.00002703}, {466,0.00008108}, {467,0.00014414}, {468,0.00010811}, {469,0.00024324}, {470,0.00020721}, {471,0.00025225}, {472,0.00018919}, {473,0.00022523}, {474,0.00012613}, {475,0.00031532}, {476,0.00017117}, {477,0.00014414}, {478,0.00013514}, {479,0.00012613}, {480,0.00036036}, {481,0.00005405}, {482,0.00025225}, {483,0.00002703}, {484,0.00034234}, {485,0.00015315}, {486,0.00014414}, {487,0.00017117}, {488,0.00013514}, {489,0.00019820}, {490,0.00014414}, {491,0.00015315}, {492,0.00026126}, {493,0.00023423}, {494,0.00011712}, {495,0.00021622}, {496,0.00027027}, {497,0.00020721}, {498,0.00016216}, {499,0.00010811}, {500,0.00010811}, {505,0.00014414}, {510,0.00018919}, {515,0.00027027}, {520,0.00012613}, {525,0.00032432}, {530,0.00017117}, {535,0.00014414}, {540,0.00002703}, {545,0.00021622}, {550,0.00005405}, {555,0.00043243}, {560,0.00017117}, {565,0.00025225}, {570,0.00020721}, {575,0.00017117}, {580,0.00018919}, {585,0.00031532}, {590,0.00032432}, {595,0.00015315}, {600,0.00022523}, {605,0.00011712}, {610,0.00023423}, {615,0.00027928}, {620,0.00014414}, {625,0.00023423}, {630,0.00014414}, {635,0.00014414}, {640,0.00027027}, {645,0.00018919}, {650,0.00027027}, {655,0.00023423}, {660,0.00009910}, {665,0.00016216}, {670,0.00034234}, {675,0.00022523}, {680,0.00027928}, {685,0.00031532}, {690,0.00018919}, {695,0.00022523}, {700,0.00023423}, {705,0.00018018}, {710,0.00016216}, {715,0.00014414}, {720,0.00025225}, {725,0.00026126}, {730,0.00027027}, {735,0.00027928}, {740,0.00005405}, {745,0.00031532}, {750,0.00026126}, {755,0.00037838}, {760,0.00041441}, {765,0.00022523}, {770,0.00035135}, {775,0.00030631}, {780,0.00018919}, {785,0.00027027}, {790,0.00015315}, {795,0.00026126}, {800,0.00026126}, {805,0.00026126}, {810,0.00031532}, {815,0.00021622}, {820,0.00037838}, {825,0.00033333}, {830,0.00043243}, {835,0.00027928}, {840,0.00028829}, {845,0.00030631}, {850,0.00037838}, {855,0.00032432}, {860,0.00030631}, {865,0.00037838}, {870,0.00042342}, {875,0.00039640}, {880,0.00060360}, {885,0.00044144}, {890,0.00038739}, {895,0.00032432}, {900,0.00031532}, {905,0.00035135}, {910,0.00035135}, {915,0.00022523}, {920,0.00045045}, {925,0.00012613}, {930,0.00037838}, {935,0.00055856}, {940,0.00027027}, {945,0.00054054}, {950,0.00034234}, {955,0.00032432}, {960,0.00038739}, {965,0.00021622}, {970,0.00028829}, {975,0.00365766}, {980,0.00013514}, {985,0.00034234}, {990,0.00041441}, {995,0.00035135}, {1000,0.00029730}, {1010,0.00021622}, {1020,0.00036036}, {1030,0.00031532}, {1040,0.00029730}, {1050,0.00022727}, {1060,0.00036364}, {1070,0.00053636}, {1080,0.00058182}, {1090,0.00050000}, {1100,0.00039091}, {1110,0.00054545}, {1120,0.00040000}, {1130,0.00027273}, {1140,0.00043636}, {1150,0.00031818}, {1160,0.00028182}, {1170,0.00024545}, {1180,0.00040000}, {1190,0.00041818}, {1200,0.00041818}, {1210,0.00050000}, {1220,0.00037273}, {1230,0.00035455}, {1240,0.00042727}, {1250,0.00038182}, {1260,0.00048182}, {1270,0.00039091}, {1280,0.00067273}, {1290,0.00038182}, {1300,0.00057273}, {1310,0.00056364}, {1320,0.00055455}, {1330,0.00037273}, {1340,0.00063636}, {1350,0.00050000}, {1360,0.00040000}, {1370,0.00061818}, {1380,0.00065455}, {1390,0.00061818}, {1400,0.00038182}, {1410,0.00032727}, {1420,0.00038182}, {1430,0.00075455}, {1440,0.00052727}, {1450,0.00050000}, {1460,0.00051818}, {1470,0.00067273}, {1480,0.00054545}, {1490,0.00059091}, {1500,0.00061818}, {1510,0.00061818}, {1520,0.00077273}, {1530,0.00080000}, {1540,0.00060909}, {1550,0.00060000}, {1560,0.00041818}, {1570,0.00067273}, {1580,0.00044545}, {1590,0.00064545}, {1600,0.00046364}, {1610,0.00050000}, {1620,0.00056364}, {1630,0.00070000}, {1640,0.00046364}, {1650,0.00039091}, {1660,0.00069091}, {1670,0.00050000}, {1680,0.00064545}, {1690,0.00054545}, {1700,0.00057273}, {1710,0.00038182}, {1720,0.00069091}, {1730,0.00089091}, {1740,0.00039091}, {1750,0.00060000}, {1760,0.00060909}, {1770,0.00059091}, {1780,0.00052727}, {1790,0.00068182}, {1800,0.00053636}, {1810,0.00054545}, {1820,0.00050000}, {1830,0.00056364}, {1840,0.00048182}, {1850,0.00092727}, {1860,0.00069091}, {1870,0.00104545}, {1880,0.00044545}, {1890,0.00070909}, {1900,0.00079091}, {1910,0.00094545}, {1920,0.00059091}, {1930,0.00056364}, {1940,0.00070000}, {1950,0.00051818}, {1960,0.00039091}, {1970,0.00078182}, {1980,0.00069091}, {1990,0.00082727}, {2000,0.00087273}, {2050,0.00077273}, {2100,0.00080909}, {2150,0.00060000}, {2200,0.00090000}, {2250,0.00097273}, {2300,0.00069091}, {2350,0.00108182}, {2400,0.00048182}, {2450,0.00099091}, {2500,0.00123636}, {2550,0.00100000}, {2600,0.00102727}, {2650,0.00097273}, {2700,0.00087273}, {2750,0.00106364}, {2800,0.00102727}, {2850,0.00095455}, {2900,0.00100909}, {2950,0.00120000}, {3000,0.00141818}, {3050,0.00140000}, {3100,0.00110909}, {3150,0.00121818}, {3200,0.00104545}, {3250,0.00124545}, {3300,0.00108182}, {3350,0.00122727}, {3400,0.00145455}, {3450,0.00115455}, {3500,0.00121818}, {3550,0.00152727}, {3600,0.00136364}, {3650,0.00105455}, {3700,0.00185455}, {3750,0.00160909}, {3800,0.00140000}, {3850,0.00157273}, {3900,0.00143636}, {3950,0.00130000}, {4000,0.00151818}, {4050,0.00159091}, {4100,0.00169091}, {4150,0.00176364}, {4200,0.00132727}, {4250,0.00170909}, {4300,0.00146364}, {4350,0.00145455}, {4400,0.00177273}, {4450,0.00173636}, {4500,0.00184545}, {4550,0.00530000}, {4600,0.00162727}, {4650,0.00195455}, {4700,0.00162727}, {4750,0.00187273}, {4800,0.01053636}, {4850,0.00210909}, {4900,0.00220909}, {4950,0.00196364}, {5000,0.00232727}, {5050,0.00197273}, {5100,0.00211818}, {5150,0.00255455}, {5200,0.00205455}, {5250,0.00189091}, {5300,0.00201818}, {5350,0.00222727}, {5400,0.00210909}, {5450,0.00217273}, {5500,0.00200909}, {5550,0.00219091}, {5600,0.00238182}, {5650,0.00232727}, {5700,0.00219091}, {5750,0.00252727}, {5800,0.00225455}, {5850,0.00227273}, {5900,0.00237273}, {5950,0.00229091}, {6000,0.00222727}, {6050,0.00375}, {6100,0.00675}, {6150,0.00175}, {6200,0.00575}, {6250,0.00300}, {6300,0.00275}, {6350,0.00275}, {6400,0.00350}, {6450,0.00300}, {6500,0.00275}, {6550,0.00575}, {6600,0.00400}, {6650,0.00375}, {6700,0.00175}, {6750,0.00375}, {6800,0.00375}, {6850,0.00275}, {6900,0.00275}, {6950,0.00300}, {7000,0.00300}, {7050,0.00300}, {7100,0.00725}, {7150,0.00300}, {7200,0.00350}, {7250,0.00200}, {7300,0.00400}, {7350,0.00400}, {7400,0.00400}, {7450,0.00275}, {7500,0.00300}, {7550,0.00300}, {7600,0.00400}, {7650,0.00375}, {7700,0.00275}, {7750,0.00075}, {7800,0.01025}, {7850,0.00375}, {7900,0.00400}, {7950,0.00250}, {8000,0.00400}, {8050,0.00400}, {8100,0.00400}, {8150,0.00375}, {8200,0.00500}, {8250,0.00400}, {8300,0.00400}, {8350,0.00750}, {8400,0.00400}, {8450,0.00350}, {8500,0.00325}, {8550,0.00350}, {8600,0.00375}, {8650,0.00200}, {8700,0.00325}, {8750,0.00400}, {8800,0.00650}, {8850,0.00425}, {8900,0.00375}, {8950,0.00375}, {9000,0.00375}, {9050,0.00400}, {9100,0.00375}, {9150,0.00400}, {9200,0.00350}, {9250,0.00400}, {9300,0.00400}, {9350,0.00375}, {9400,0.00400}, {9450,0.00300}, {9500,0.00375}, {9550,0.00475}, {9600,0.00375}, {9650,0.00400}, {9700,0.00400}, {9750,0.00500}, {9800,0.00850}, {9850,0.00475}, {9900,0.00400}, {9950,0.00375}, {10000,0.00325}, {10100,0.00500}, {10200,0.00875}, {10300,0.00475}, {10400,0.00350}, {10500,0.00600}, {10600,0.00400}, {10700,0.00375}, {10800,0.00650}, {10900,0.00350}, {11000,0.00475}, {11100,0.00600}, {11200,0.00475}, {11300,0.00575}, {11400,0.00500}, {11500,0.00475}, {11600,0.00400}, {11700,0.00450}, {11800,0.00475}, {11900,0.00500}, {12000,0.00450}, {12100,0.00575}, {12200,0.00450}, {12300,0.00425}, {12400,0.00450}, {12500,0.00500}, {12600,0.00500}, {12700,0.00675}, {12800,0.00475}, {12900,0.01075}, {13000,0.00600}, {13100,0.01100}, {13200,0.00675}, {13300,0.00550}, {13400,0.00550}, {13500,0.00450}, {13600,0.00575}, {13700,0.00450}, {13800,0.00700}, {13900,0.00550}, {14000,0.00575}, {14100,0.00550}, {14200,0.00575}, {14300,0.00525}, {14400,0.00700}, {14500,0.00675}, {14600,0.00750}, {14700,0.00675}, {14800,0.00750}, {14900,0.00650}, {15000,0.00700}, {15100,0.00650}, {15200,0.01950}, {15300,0.00800}, {15400,0.01550}, {15500,0.00775}, {15600,0.01850}, {15700,0.00800}, {15800,0.00800}, {15900,0.00800}, {16000,0.00775}, {16100,0.00725}, {16200,0.00775}, {16300,0.00775}, {16400,0.00800}, {16500,0.00800}, {16600,0.00850}, {16700,0.00750}, {16800,0.00800}, {16900,0.00875}, {17000,0.00800}, {17100,0.02050}, {17200,0.01475}, {17300,0.00750}, {17400,0.00800}, {17500,0.00875}, {17600,0.00875}, {17700,0.00875}, {17800,0.02050}, {17900,0.01025}, {18000,0.00850}, {18100,0.00900}, {18200,0.00750}, {18300,0.00775}, {18400,0.00875}, {18500,0.01050}, {18600,0.00850}, {18700,0.01500}, {18800,0.01050}, {18900,0.00800}, {19000,0.00975}, {19100,0.01750}, {19200,0.02575}, {19300,0.00875}, {19400,0.01100}, {19500,0.01150}, {19600,0.00950}, {19700,0.01000}, {19800,0.00875}, {19900,0.01025}, {20000,0.0110}};
data["big_flat"]["CanonicalStructuresPHOAS"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00003604}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00003604}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00003604}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00003604}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00003604}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00003604}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00003604}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00003604}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00003604}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00003604}, {287,0.00000000}, {288,0.00003604}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00003604}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00003604}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00003604}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00003604}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00003604}, {395,0.00000000}, {396,0.00003604}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00003604}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00003604}, {442,0.00000000}, {443,0.00000000}, {444,0.00003604}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00003604}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00003604}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00003604}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00003604}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00003604}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00003604}, {925,0.00000000}, {930,0.00003604}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00003604}, {975,0.00010811}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00003636}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00003636}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00003636}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00003636}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00003636}, {1370,0.00003636}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00003636}, {1420,0.00003636}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00003636}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00003636}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00002727}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00003636}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00003636}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00003636}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00003636}, {1890,0.00000000}, {1900,0.00003636}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00003636}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00003636}, {2450,0.00000000}, {2500,0.00003636}, {2550,0.00003636}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00003636}, {2750,0.00000000}, {2800,0.00007273}, {2850,0.00000000}, {2900,0.00003636}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00003636}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00003636}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00003636}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00003636}, {4100,0.00003636}, {4150,0.00003636}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00003636}, {4500,0.00002727}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00003636}, {4800,0.00029091}, {4850,0.00003636}, {4900,0.00003636}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00003636}, {5100,0.00003636}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00003636}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00003636}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00100}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresPHOAS"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000901}, {4,0.00100000}, {5,0.00100000}, {6,0.00100000}, {7,0.00105405}, {8,0.00176577}, {9,0.00200000}, {10,0.00200000}, {11,0.00215315}, {12,0.00222523}, {13,0.00300000}, {14,0.00300000}, {15,0.00328829}, {16,0.00317117}, {17,0.00400000}, {18,0.00400000}, {19,0.00412613}, {20,0.00416216}, {21,0.00500000}, {22,0.00509009}, {23,0.00520721}, {24,0.00656757}, {25,0.00604505}, {26,0.00605405}, {27,0.00622523}, {28,0.00620721}, {29,0.00704505}, {30,0.00710811}, {31,0.00782883}, {32,0.00854054}, {33,0.00805405}, {34,0.00803604}, {35,0.00847748}, {36,0.00827928}, {37,0.00909009}, {38,0.00918919}, {39,0.01004505}, {40,0.00916216}, {41,0.01008108}, {42,0.01007207}, {43,0.01105405}, {44,0.01073874}, {45,0.01115315}, {46,0.01137838}, {47,0.01215315}, {48,0.01117117}, {49,0.01209009}, {50,0.01212613}, {51,0.01304505}, {52,0.01289189}, {53,0.01320721}, {54,0.01378378}, {55,0.01435135}, {56,0.01366667}, {57,0.01428829}, {58,0.01468468}, {59,0.01662162}, {60,0.01508108}, {61,0.01603604}, {62,0.01609009}, {63,0.01890991}, {64,0.01527928}, {65,0.01614414}, {66,0.01644144}, {67,0.01897297}, {68,0.01710811}, {69,0.01802703}, {70,0.01809009}, {71,0.01911712}, {72,0.01809910}, {73,0.01902703}, {74,0.02075676}, {75,0.02009910}, {76,0.01944144}, {77,0.02061261}, {78,0.02094595}, {79,0.02201802}, {80,0.02005405}, {81,0.02218018}, {82,0.02111712}, {83,0.02221622}, {84,0.02364865}, {85,0.02276577}, {86,0.02312613}, {87,0.02617117}, {88,0.02243243}, {89,0.02378378}, {90,0.02580180}, {91,0.02516216}, {92,0.02428829}, {93,0.02731532}, {94,0.02598198}, {95,0.02727928}, {96,0.02409009}, {97,0.02523423}, {98,0.02713514}, {99,0.02678378}, {100,0.02592793}, {101,0.02863964}, {102,0.02727027}, {103,0.02900000}, {104,0.02690991}, {105,0.02820721}, {106,0.02977477}, {107,0.02992793}, {108,0.02894595}, {109,0.03031532}, {110,0.03060360}, {111,0.03345045}, {112,0.02887387}, {113,0.03209910}, {114,0.03039640}, {115,0.03210811}, {116,0.03108108}, {117,0.03250450}, {118,0.03367568}, {119,0.03452252}, {120,0.03369369}, {121,0.03353153}, {122,0.03549550}, {123,0.03548649}, {124,0.03633333}, {125,0.03607207}, {126,0.03628829}, {127,0.03821622}, {128,0.03264865}, {129,0.03428829}, {130,0.03440541}, {131,0.03621622}, {132,0.03492793}, {133,0.03675676}, {134,0.03701802}, {135,0.03892793}, {136,0.03589189}, {137,0.03777477}, {138,0.03790991}, {139,0.03986486}, {140,0.03824324}, {141,0.04041441}, {142,0.04232432}, {143,0.04286486}, {144,0.03905405}, {145,0.03968468}, {146,0.04136937}, {147,0.04205405}, {148,0.04202703}, {149,0.04246847}, {150,0.04293694}, {151,0.04510811}, {152,0.04144144}, {153,0.04496396}, {154,0.04389189}, {155,0.04744144}, {156,0.04436036}, {157,0.04663964}, {158,0.04816216}, {159,0.04931532}, {160,0.04307207}, {161,0.04421622}, {162,0.04430631}, {163,0.04811712}, {164,0.04465766}, {165,0.04828829}, {166,0.04717117}, {167,0.04978378}, {168,0.04725225}, {169,0.04815315}, {170,0.04918018}, {171,0.05354054}, {172,0.04881982}, {173,0.05236937}, {174,0.05162162}, {175,0.05436937}, {176,0.04891892}, {177,0.05021622}, {178,0.05036036}, {179,0.05447748}, {180,0.05084685}, {181,0.05351351}, {182,0.05527027}, {183,0.05659459}, {184,0.05183784}, {185,0.05577477}, {186,0.05719820}, {187,0.05772072}, {188,0.05529730}, {189,0.05963063}, {190,0.05836036}, {191,0.06141441}, {192,0.05193694}, {193,0.05312613}, {194,0.05323423}, {195,0.05716216}, {196,0.05642342}, {197,0.05667568}, {198,0.05678378}, {199,0.06103604}, {200,0.05714414}, {201,0.05761261}, {202,0.05794595}, {203,0.06207207}, {204,0.06082883}, {205,0.06146847}, {206,0.06172072}, {207,0.06627027}, {208,0.05921622}, {209,0.05972072}, {210,0.05990090}, {211,0.06325225}, {212,0.06198198}, {213,0.06585586}, {214,0.06395495}, {215,0.06729730}, {216,0.06243243}, {217,0.06716216}, {218,0.06709009}, {219,0.06830631}, {220,0.06528829}, {221,0.06895495}, {222,0.07015315}, {223,0.07550450}, {224,0.06459459}, {225,0.06398198}, {226,0.06416216}, {227,0.06754054}, {228,0.06627027}, {229,0.07078378}, {230,0.07147748}, {231,0.07214414}, {232,0.06578378}, {233,0.06912613}, {234,0.07065766}, {235,0.07710811}, {236,0.07354955}, {237,0.07737838}, {238,0.07697297}, {239,0.07791892}, {240,0.06764865}, {241,0.07133333}, {242,0.07153153}, {243,0.07672072}, {244,0.07536937}, {245,0.07872973}, {246,0.07861261}, {247,0.08241441}, {248,0.07518018}, {249,0.07905405}, {250,0.07704505}, {251,0.08122523}, {252,0.07759459}, {253,0.08172072}, {254,0.08186486}, {255,0.08649550}, {256,0.06887387}, {257,0.07355856}, {258,0.07553153}, {259,0.07923423}, {260,0.07592793}, {261,0.07954955}, {262,0.07969369}, {263,0.08384685}, {264,0.07657658}, {265,0.08028829}, {266,0.08063063}, {267,0.08463063}, {268,0.08098198}, {269,0.08529730}, {270,0.08527928}, {271,0.08986486}, {272,0.07842342}, {273,0.08242342}, {274,0.08258559}, {275,0.08681982}, {276,0.08322523}, {277,0.08749550}, {278,0.08784685}, {279,0.09250450}, {280,0.08444144}, {281,0.08882883}, {282,0.08907207}, {283,0.09359459}, {284,0.08953153}, {285,0.09431532}, {286,0.09181081}, {287,0.09665766}, {288,0.08037838}, {289,0.08445946}, {290,0.08456757}, {291,0.09175676}, {292,0.08725225}, {293,0.09163063}, {294,0.09217117}, {295,0.09721622}, {296,0.08855856}, {297,0.09334234}, {298,0.09378378}, {299,0.09583784}, {300,0.09143243}, {301,0.09637838}, {302,0.09837838}, {303,0.10336937}, {304,0.09034234}, {305,0.09534234}, {306,0.09569369}, {307,0.09833333}, {308,0.09360360}, {309,0.10134234}, {310,0.10063964}, {311,0.10612613}, {312,0.09696396}, {313,0.10228829}, {314,0.09975676}, {315,0.10850450}, {316,0.10199099}, {317,0.10742342}, {318,0.10817117}, {319,0.11145045}, {320,0.08904505}, {321,0.09600000}, {322,0.09548649}, {323,0.10085586}, {324,0.09672072}, {325,0.09931532}, {326,0.10203604}, {327,0.10654054}, {328,0.09731532}, {329,0.10282883}, {330,0.10045045}, {331,0.10822523}, {332,0.10281081}, {333,0.10865766}, {334,0.10670270}, {335,0.11476577}, {336,0.09912613}, {337,0.10449550}, {338,0.10474775}, {339,0.11050450}, {340,0.10491892}, {341,0.11118018}, {342,0.10924324}, {343,0.11690991}, {344,0.10589189}, {345,0.11215315}, {346,0.10969369}, {347,0.11741441}, {348,0.11243243}, {349,0.11830631}, {350,0.11855856}, {351,0.12478378}, {352,0.10359459}, {353,0.11076577}, {354,0.11032432}, {355,0.11472072}, {356,0.10762162}, {357,0.11485586}, {358,0.11583784}, {359,0.11941441}, {360,0.11014414}, {361,0.11660360}, {362,0.11447748}, {363,0.12209910}, {364,0.11747748}, {365,0.12099099}, {366,0.12313514}, {367,0.13018919}, {368,0.11309009}, {369,0.11810811}, {370,0.11886486}, {371,0.12500901}, {372,0.11909009}, {373,0.12332432}, {374,0.12490090}, {375,0.13249550}, {376,0.12019820}, {377,0.12613514}, {378,0.12473874}, {379,0.13300901}, {380,0.12709910}, {381,0.13395495}, {382,0.13429730}, {383,0.14128829}, {384,0.10945946}, {385,0.11282883}, {386,0.11535135}, {387,0.12078378}, {388,0.11601802}, {389,0.12163964}, {390,0.11986486}, {391,0.12784685}, {392,0.11690991}, {393,0.12298198}, {394,0.12284685}, {395,0.12924324}, {396,0.12314414}, {397,0.12975676}, {398,0.12988288}, {399,0.13652252}, {400,0.11820721}, {401,0.12531532}, {402,0.12453153}, {403,0.13532432}, {404,0.12527928}, {405,0.12997297}, {406,0.13209009}, {407,0.14272973}, {408,0.12672072}, {409,0.13572072}, {410,0.13426126}, {411,0.14105405}, {412,0.13346847}, {413,0.14061261}, {414,0.14072072}, {415,0.14854955}, {416,0.12259459}, {417,0.12903604}, {418,0.12918018}, {419,0.13581982}, {420,0.12994595}, {421,0.13661261}, {422,0.13808108}, {423,0.14388288}, {424,0.13040541}, {425,0.13727027}, {426,0.13782883}, {427,0.14520721}, {428,0.13838739}, {429,0.14565766}, {430,0.14579279}, {431,0.15382883}, {432,0.13270270}, {433,0.13992793}, {434,0.14006306}, {435,0.14708108}, {436,0.14061261}, {437,0.14765766}, {438,0.14759459}, {439,0.15572072}, {440,0.14122523}, {441,0.14878378}, {442,0.14922523}, {443,0.15676577}, {444,0.14973874}, {445,0.15764865}, {446,0.15730631}, {447,0.16653153}, {448,0.13170270}, {449,0.13787387}, {450,0.13887387}, {451,0.14558559}, {452,0.13849550}, {453,0.14624324}, {454,0.14630631}, {455,0.15373874}, {456,0.14006306}, {457,0.14852252}, {458,0.14698198}, {459,0.15511712}, {460,0.14764865}, {461,0.15535135}, {462,0.15630631}, {463,0.16401802}, {464,0.14181081}, {465,0.14945045}, {466,0.14956757}, {467,0.15709910}, {468,0.14953153}, {469,0.15850450}, {470,0.15823423}, {471,0.16536937}, {472,0.15044144}, {473,0.15917117}, {474,0.15935135}, {475,0.16696396}, {476,0.15917117}, {477,0.16796396}, {478,0.16865766}, {479,0.17768468}, {480,0.14731532}, {481,0.15357658}, {482,0.15432432}, {483,0.16209009}, {484,0.15428829}, {485,0.16228829}, {486,0.16233333}, {487,0.17179279}, {488,0.15510811}, {489,0.16303604}, {490,0.16714414}, {491,0.17400000}, {492,0.16430631}, {493,0.17288288}, {494,0.17294595}, {495,0.18183784}, {496,0.15867568}, {497,0.16533333}, {498,0.16549550}, {499,0.17520721}, {500,0.16651351}, {505,0.17630631}, {510,0.18587387}, {515,0.16447748}, {520,0.15861261}, {525,0.17453153}, {530,0.16725225}, {535,0.18694595}, {540,0.17860360}, {545,0.17118919}, {550,0.18164865}, {555,0.19587387}, {560,0.17909910}, {565,0.19585586}, {570,0.19669369}, {575,0.21948649}, {580,0.18192793}, {585,0.19243243}, {590,0.20425225}, {595,0.20528829}, {600,0.19640541}, {605,0.21914414}, {610,0.19978378}, {615,0.22265766}, {620,0.21156757}, {625,0.21364865}, {630,0.22763063}, {635,0.23896396}, {640,0.19103604}, {645,0.21245045}, {650,0.21335135}, {655,0.24023423}, {660,0.21519820}, {665,0.22888288}, {670,0.24290090}, {675,0.23794595}, {680,0.22224324}, {685,0.24919820}, {690,0.23481982}, {695,0.26415315}, {700,0.25099099}, {705,0.22903604}, {710,0.24421622}, {715,0.25601802}, {720,0.23388288}, {725,0.26149550}, {730,0.26048649}, {735,0.29327928}, {740,0.25170270}, {745,0.26709009}, {750,0.28108108}, {755,0.28090991}, {760,0.27013514}, {765,0.30180180}, {770,0.24572072}, {775,0.27376577}, {780,0.26096396}, {785,0.25996396}, {790,0.27380180}, {795,0.29009009}, {800,0.25109009}, {805,0.27959459}, {810,0.28037838}, {815,0.31345045}, {820,0.28117117}, {825,0.29802703}, {830,0.31831532}, {835,0.28810811}, {840,0.27478378}, {845,0.30643243}, {850,0.29206306}, {855,0.32690090}, {860,0.31933333}, {865,0.29958559}, {870,0.31448649}, {875,0.33354054}, {880,0.30053153}, {885,0.33602703}, {890,0.33762162}, {895,0.37933333}, {900,0.29385586}, {905,0.31144144}, {910,0.33007207}, {915,0.33070270}, {920,0.31540541}, {925,0.35204505}, {930,0.31767568}, {935,0.35405405}, {940,0.33800901}, {945,0.33957658}, {950,0.36006306}, {955,0.38064865}, {960,0.31209009}, {965,0.34565766}, {970,0.34530631}, {975,0.38868468}, {980,0.34958559}, {985,0.36879279}, {990,0.39442342}, {995,0.37322523}, {1000,0.35512613}, {1010,0.37734234}, {1020,0.40337838}, {1030,0.35009009}, {1040,0.33277477}, {1050,0.37375455}, {1060,0.35554545}, {1070,0.39915455}, {1080,0.38029091}, {1090,0.37142727}, {1100,0.38738182}, {1110,0.41360000}, {1120,0.37360909}, {1130,0.42089091}, {1140,0.42256364}, {1150,0.47130000}, {1160,0.38944545}, {1170,0.41148182}, {1180,0.43171818}, {1190,0.44174545}, {1200,0.41971818}, {1210,0.47300000}, {1220,0.42661818}, {1230,0.47938182}, {1240,0.46217273}, {1250,0.45876364}, {1260,0.48747273}, {1270,0.52033636}, {1280,0.40626364}, {1290,0.45349091}, {1300,0.45539091}, {1310,0.51288182}, {1320,0.46193636}, {1330,0.49086364}, {1340,0.52015455}, {1350,0.49642727}, {1360,0.47256364}, {1370,0.53225455}, {1380,0.50582727}, {1390,0.56996364}, {1400,0.54099091}, {1410,0.48770909}, {1420,0.51960000}, {1430,0.55633636}, {1440,0.49551818}, {1450,0.56156364}, {1460,0.56200909}, {1470,0.63480909}, {1480,0.53605455}, {1490,0.57949091}, {1500,0.60583636}, {1510,0.60994545}, {1520,0.57910000}, {1530,0.65356364}, {1540,0.51445455}, {1550,0.58107273}, {1560,0.55223636}, {1570,0.55381818}, {1580,0.58679091}, {1590,0.62459091}, {1600,0.53070909}, {1610,0.59700909}, {1620,0.59903636}, {1630,2.31751818}, {1640,0.61154545}, {1650,0.65176364}, {1660,0.68780000}, {1670,0.61815455}, {1680,0.59252727}, {1690,0.66229091}, {1700,0.62601818}, {1710,0.71314545}, {1720,0.67101818}, {1730,0.63448182}, {1740,0.67616364}, {1750,0.72245455}, {1760,0.64394545}, {1770,0.72917273}, {1780,0.72806364}, {1790,0.82894545}, {1800,0.62750000}, {1810,0.66583636}, {1820,0.70897273}, {1830,0.71379091}, {1840,0.67692727}, {1850,0.76666364}, {1860,0.68979091}, {1870,0.77441818}, {1880,0.72953636}, {1890,0.73193636}, {1900,0.77663636}, {1910,0.82976364}, {1920,0.66114545}, {1930,0.75220000}, {1940,0.75003636}, {1950,0.83927273}, {1960,0.75630909}, {1970,0.80257273}, {1980,0.86153636}, {1990,0.81047273}, {2000,0.76896364}, {2050,0.70557273}, {2100,0.81414545}, {2150,0.87682727}, {2200,0.83998182}, {2250,0.90676364}, {2300,1.05149091}, {2350,1.01555455}, {2400,0.91293636}, {2450,0.98625455}, {2500,0.99530909}, {2550,1.22869091}, {2600,0.99272727}, {2650,1.13579091}, {2700,1.07857273}, {2750,1.33359091}, {2800,1.18296364}, {2850,1.13917273}, {2900,1.23181818}, {2950,1.24512727}, {3000,1.35087273}, {3050,1.44256364}, {3100,1.26700000}, {3150,1.36420909}, {3200,1.14311818}, {3250,1.39566364}, {3300,1.41364545}, {3350,1.43035455}, {3400,1.35937273}, {3450,1.68261818}, {3500,1.58036364}, {3550,1.81793636}, {3600,1.34571818}, {3650,1.45329091}, {3700,1.67349091}, {3750,1.68493636}, {3800,1.70653636}, {3850,1.63739091}, {3900,1.86960000}, {3950,2.00157273}, {4000,1.65539091}, {4050,1.91614545}, {4100,1.52394545}, {4150,1.82589091}, {4200,1.74601818}, {4250,1.87812727}, {4300,1.91012727}, {4350,2.32278182}, {4400,1.82130909}, {4450,1.95870909}, {4500,1.97980000}, {4550,2.11615455}, {4600,2.29226364}, {4650,2.04941818}, {4700,2.17522727}, {4750,2.23134545}, {4800,1.95515455}, {4850,2.40778182}, {4900,2.12996364}, {4950,2.45830909}, {5000,2.15979091}, {5050,2.63870909}, {5100,2.66856364}, {5150,2.44074545}, {5200,2.12268182}, {5250,2.14609091}, {5300,2.44719091}, {5350,2.64671818}, {5400,2.34496364}, {5450,2.50588182}, {5500,2.85780909}, {5550,2.90874545}, {5600,2.51264545}, {5650,2.42858182}, {5700,2.39761818}, {5750,2.94620000}, {5800,2.55540909}, {5850,2.96328182}, {5900,2.60535455}, {5950,3.12529091}, {6000,2.78756364}, {6050,2.89525}, {6100,3.07325}, {6150,2.54100}, {6200,2.71475}, {6250,2.94275}, {6300,2.92850}, {6350,3.10475}, {6400,2.44200}, {6450,2.97775}, {6500,2.98525}, {6550,3.21400}, {6600,3.01700}, {6650,3.70125}, {6700,3.09725}, {6750,3.51625}, {6800,2.90125}, {6850,3.12475}, {6900,3.56825}, {6950,3.39275}, {7000,3.43225}, {7050,3.43375}, {7100,3.87125}, {7150,4.16725}, {7200,2.88875}, {7250,3.34875}, {7300,3.11350}, {7350,3.73550}, {7400,3.60325}, {7450,3.61650}, {7500,3.64475}, {7550,4.48150}, {7600,3.65850}, {7650,3.89775}, {7700,3.47575}, {7750,3.73775}, {7800,4.00175}, {7850,3.95925}, {7900,4.31925}, {7950,4.03075}, {8000,3.54300}, {8050,4.39925}, {8100,4.06500}, {8150,4.60575}, {8200,3.22500}, {8250,3.95275}, {8300,3.93050}, {8350,4.18300}, {8400,3.76750}, {8450,3.52500}, {8500,3.97200}, {8550,4.27950}, {8600,3.98950}, {8650,4.31175}, {8700,4.83050}, {8750,4.37275}, {8800,3.85275}, {8850,4.17050}, {8900,4.15225}, {8950,4.98325}, {9000,4.14825}, {9050,4.71000}, {9100,4.45650}, {9150,5.39100}, {9200,4.78225}, {9250,4.03000}, {9300,4.33125}, {9350,4.27750}, {9400,4.62275}, {9450,4.92350}, {9500,4.59600}, {9550,4.96025}, {9600,4.14450}, {9650,4.92575}, {9700,4.94675}, {9750,4.74275}, {9800,4.45900}, {9850,5.44525}, {9900,5.07700}, {9950,5.79375}, {10000,4.51600}, {10100,5.46250}, {10200,5.49850}, {10300,5.09625}, {10400,4.45725}, {10500,4.47600}, {10600,5.17500}, {10700,5.55425}, {10800,4.90650}, {10900,5.29375}, {11000,6.00425}, {11100,6.03975}, {11200,5.29550}, {11300,5.15675}, {11400,5.12775}, {11500,6.13675}, {11600,5.56525}, {11700,6.33150}, {11800,5.64100}, {11900,6.82250}, {12000,6.03225}, {12100,6.02650}, {12200,6.59750}, {12300,5.41500}, {12400,5.76400}, {12500,6.13675}, {12600,6.18175}, {12700,6.68025}, {12800,5.17700}, {12900,6.30700}, {13000,6.25450}, {13100,6.76475}, {13200,6.39475}, {13300,7.84500}, {13400,6.56025}, {13500,7.41700}, {13600,6.17200}, {13700,6.63700}, {13800,7.55100}, {13900,7.11300}, {14000,7.06750}, {14100,7.18250}, {14200,8.27800}, {14300,8.91600}, {14400,6.16475}, {14500,7.02600}, {14600,6.69025}, {14700,8.15525}, {14800,7.65625}, {14900,7.64950}, {15000,7.73625}, {15100,9.28200}, {15200,7.84150}, {15300,8.37775}, {15400,7.39000}, {15500,7.93525}, {15600,8.34525}, {15700,8.56750}, {15800,9.17200}, {15900,8.66975}, {16000,7.51425}, {16100,9.14750}, {16200,8.64875}, {16300,9.79825}, {16400,6.87000}, {16500,8.48800}, {16600,8.39200}, {16700,8.99200}, {16800,7.91575}, {16900,7.54575}, {17000,8.54800}, {17100,9.30525}, {17200,8.65125}, {17300,9.18725}, {17400,10.61750}, {17500,9.28225}, {17600,8.26550}, {17700,8.85925}, {17800,8.77750}, {17900,10.91275}, {18000,8.94725}, {18100,10.38725}, {18200,9.74875}, {18300,11.67450}, {18400,10.30550}, {18500,8.63050}, {18600,9.27100}, {18700,9.28100}, {18800,9.85675}, {18900,10.54450}, {19000,10.05300}, {19100,10.69575}, {19200,8.89975}, {19300,10.94500}, {19400,10.84025}, {19500,10.25800}, {19600,9.66625}, {19700,11.80425}, {19800,11.07025}, {19900,12.69325}, {20000,9.7500}};
data["big_flat"]["CanonicalStructuresPHOAS"]["norm reif"]["user"] = {{1,0.00022523}, {2,0.00054955}, {3,0.00088288}, {4,0.00068468}, {5,0.00144144}, {6,0.00098198}, {7,0.00160360}, {8,0.00172973}, {9,0.00204505}, {10,0.00218018}, {11,0.00237838}, {12,0.00261261}, {13,0.00254955}, {14,0.00266667}, {15,0.00342342}, {16,0.00324324}, {17,0.00334234}, {18,0.00375676}, {19,0.00386486}, {20,0.00418018}, {21,0.00478378}, {22,0.00515315}, {23,0.00507207}, {24,0.00645946}, {25,0.00627027}, {26,0.00561261}, {27,0.00677477}, {28,0.00637838}, {29,0.00704505}, {30,0.00728829}, {31,0.00792793}, {32,0.00847748}, {33,0.00799099}, {34,0.00817117}, {35,0.00864865}, {36,0.00887387}, {37,0.00950450}, {38,0.00947748}, {39,0.01015315}, {40,0.00954054}, {41,0.01019820}, {42,0.01038739}, {43,0.01124324}, {44,0.01110811}, {45,0.01162162}, {46,0.01205405}, {47,0.01276577}, {48,0.01181081}, {49,0.01236036}, {50,0.01270270}, {51,0.01315315}, {52,0.01277477}, {53,0.01345045}, {54,0.01376577}, {55,0.01451351}, {56,0.01366667}, {57,0.01430631}, {58,0.01451351}, {59,0.01652252}, {60,0.01470270}, {61,0.01563964}, {62,0.01618018}, {63,0.01902703}, {64,0.01523423}, {65,0.01603604}, {66,0.01643243}, {67,0.01914414}, {68,0.01700000}, {69,0.01792793}, {70,0.01775676}, {71,0.01918018}, {72,0.01794595}, {73,0.01873874}, {74,0.02096396}, {75,0.02034234}, {76,0.01963063}, {77,0.02082883}, {78,0.02106306}, {79,0.02236937}, {80,0.01993694}, {81,0.02233333}, {82,0.02118919}, {83,0.02256757}, {84,0.02397297}, {85,0.02275676}, {86,0.02344144}, {87,0.02584685}, {88,0.02296396}, {89,0.02406306}, {90,0.02563964}, {91,0.02536036}, {92,0.02471171}, {93,0.02713514}, {94,0.02587387}, {95,0.02710811}, {96,0.02418018}, {97,0.02541441}, {98,0.02709910}, {99,0.02698198}, {100,0.02567568}, {101,0.02875676}, {102,0.02699099}, {103,0.02885586}, {104,0.02683784}, {105,0.02784685}, {106,0.02937838}, {107,0.02968468}, {108,0.02891892}, {109,0.03052252}, {110,0.03043243}, {111,0.03365766}, {112,0.02845946}, {113,0.03234234}, {114,0.03036937}, {115,0.03224324}, {116,0.03102703}, {117,0.03257658}, {118,0.03408108}, {119,0.03471171}, {120,0.03392793}, {121,0.03386486}, {122,0.03593694}, {123,0.03569369}, {124,0.03690991}, {125,0.03643243}, {126,0.03649550}, {127,0.03858559}, {128,0.03268468}, {129,0.03426126}, {130,0.03463964}, {131,0.03660360}, {132,0.03547748}, {133,0.03718919}, {134,0.03693694}, {135,0.03863063}, {136,0.03618018}, {137,0.03779279}, {138,0.03818919}, {139,0.03954054}, {140,0.03832432}, {141,0.04051351}, {142,0.04216216}, {143,0.04240541}, {144,0.03894595}, {145,0.03945045}, {146,0.04139640}, {147,0.04204505}, {148,0.04205405}, {149,0.04238739}, {150,0.04309009}, {151,0.04537838}, {152,0.04133333}, {153,0.04478378}, {154,0.04406306}, {155,0.04766667}, {156,0.04434234}, {157,0.04698198}, {158,0.04822523}, {159,0.04954054}, {160,0.04306306}, {161,0.04417117}, {162,0.04464865}, {163,0.04822523}, {164,0.04466667}, {165,0.04852252}, {166,0.04745946}, {167,0.04975676}, {168,0.04775676}, {169,0.04853153}, {170,0.04892793}, {171,0.05326126}, {172,0.04904505}, {173,0.05209009}, {174,0.05143243}, {175,0.05446847}, {176,0.04919820}, {177,0.04981982}, {178,0.05042342}, {179,0.05422523}, {180,0.05070270}, {181,0.05358559}, {182,0.05554955}, {183,0.05681081}, {184,0.05175676}, {185,0.05584685}, {186,0.05739640}, {187,0.05783784}, {188,0.05531532}, {189,0.05990991}, {190,0.05840541}, {191,0.06157658}, {192,0.05181081}, {193,0.05309009}, {194,0.05281982}, {195,0.05754955}, {196,0.05661261}, {197,0.05666667}, {198,0.05681982}, {199,0.06137838}, {200,0.05724324}, {201,0.05783784}, {202,0.05818919}, {203,0.06218919}, {204,0.06115315}, {205,0.06140541}, {206,0.06172072}, {207,0.06602703}, {208,0.05968468}, {209,0.05980180}, {210,0.05993694}, {211,0.06279279}, {212,0.06208108}, {213,0.06570270}, {214,0.06373874}, {215,0.06709910}, {216,0.06237838}, {217,0.06700000}, {218,0.06712613}, {219,0.06840541}, {220,0.06527928}, {221,0.06873874}, {222,0.07062162}, {223,0.07520721}, {224,0.06436036}, {225,0.06349550}, {226,0.06398198}, {227,0.06736937}, {228,0.06580180}, {229,0.07070270}, {230,0.07148649}, {231,0.07255856}, {232,0.06563063}, {233,0.06915315}, {234,0.07072072}, {235,0.07659459}, {236,0.07348649}, {237,0.07709009}, {238,0.07692793}, {239,0.07786486}, {240,0.06781982}, {241,0.07193694}, {242,0.07176577}, {243,0.07659459}, {244,0.07518919}, {245,0.07852252}, {246,0.07835135}, {247,0.08260360}, {248,0.07497297}, {249,0.07869369}, {250,0.07757658}, {251,0.08153153}, {252,0.07759459}, {253,0.08155856}, {254,0.08184685}, {255,0.08629730}, {256,0.06872973}, {257,0.07351351}, {258,0.07538739}, {259,0.07915315}, {260,0.07574775}, {261,0.07935135}, {262,0.07972072}, {263,0.08418018}, {264,0.07635135}, {265,0.08025225}, {266,0.08069369}, {267,0.08485586}, {268,0.08107207}, {269,0.08518919}, {270,0.08524324}, {271,0.08943243}, {272,0.07847748}, {273,0.08295495}, {274,0.08298198}, {275,0.08661261}, {276,0.08338739}, {277,0.08751351}, {278,0.08736036}, {279,0.09260360}, {280,0.08454955}, {281,0.08852252}, {282,0.08911712}, {283,0.09353153}, {284,0.08949550}, {285,0.09418018}, {286,0.09173874}, {287,0.09672072}, {288,0.08048649}, {289,0.08453153}, {290,0.08455856}, {291,0.09158559}, {292,0.08707207}, {293,0.09156757}, {294,0.09192793}, {295,0.09692793}, {296,0.08837838}, {297,0.09318919}, {298,0.09401802}, {299,0.09606306}, {300,0.09123423}, {301,0.09649550}, {302,0.09829730}, {303,0.10342342}, {304,0.09009009}, {305,0.09568468}, {306,0.09559459}, {307,0.09817117}, {308,0.09406306}, {309,0.10108108}, {310,0.10053153}, {311,0.10638739}, {312,0.09705405}, {313,0.10227928}, {314,0.09950450}, {315,0.10863964}, {316,0.10198198}, {317,0.10753153}, {318,0.10813514}, {319,0.11130631}, {320,0.08885586}, {321,0.09582883}, {322,0.09542342}, {323,0.10036036}, {324,0.09680180}, {325,0.09927928}, {326,0.10158559}, {327,0.10672973}, {328,0.09722523}, {329,0.10251351}, {330,0.10019820}, {331,0.10818018}, {332,0.10281081}, {333,0.10864865}, {334,0.10670270}, {335,0.11431532}, {336,0.09891892}, {337,0.10441441}, {338,0.10488288}, {339,0.11026126}, {340,0.10517117}, {341,0.11111712}, {342,0.10944144}, {343,0.11696396}, {344,0.10621622}, {345,0.11176577}, {346,0.10954955}, {347,0.11735135}, {348,0.11217117}, {349,0.11829730}, {350,0.11863063}, {351,0.12434234}, {352,0.10350450}, {353,0.11045045}, {354,0.11019820}, {355,0.11488288}, {356,0.10790991}, {357,0.11485586}, {358,0.11604505}, {359,0.11965766}, {360,0.11019820}, {361,0.11633333}, {362,0.11433333}, {363,0.12197297}, {364,0.11787387}, {365,0.12106306}, {366,0.12254054}, {367,0.13081982}, {368,0.11295495}, {369,0.11805405}, {370,0.11913514}, {371,0.12508108}, {372,0.11907207}, {373,0.12292793}, {374,0.12477477}, {375,0.13272072}, {376,0.12012613}, {377,0.12580180}, {378,0.12466667}, {379,0.13309910}, {380,0.12704505}, {381,0.13374775}, {382,0.13428829}, {383,0.14129730}, {384,0.10929730}, {385,0.11268468}, {386,0.11530631}, {387,0.12098198}, {388,0.11585586}, {389,0.12190991}, {390,0.12016216}, {391,0.12772973}, {392,0.11666667}, {393,0.12263964}, {394,0.12269369}, {395,0.12960360}, {396,0.12288288}, {397,0.13007207}, {398,0.13000000}, {399,0.13618919}, {400,0.11825225}, {401,0.12499099}, {402,0.12429730}, {403,0.13516216}, {404,0.12497297}, {405,0.13026126}, {406,0.13226126}, {407,0.14263964}, {408,0.12644144}, {409,0.13554054}, {410,0.13401802}, {411,0.14118919}, {412,0.13333333}, {413,0.14064865}, {414,0.14073874}, {415,0.14827928}, {416,0.12226126}, {417,0.12903604}, {418,0.12924324}, {419,0.13553153}, {420,0.13026126}, {421,0.13656757}, {422,0.13756757}, {423,0.14414414}, {424,0.13059459}, {425,0.13721622}, {426,0.13739640}, {427,0.14533333}, {428,0.13819820}, {429,0.14545946}, {430,0.14534234}, {431,0.15389189}, {432,0.13281081}, {433,0.13976577}, {434,0.14045045}, {435,0.14709910}, {436,0.14083784}, {437,0.14724324}, {438,0.14735135}, {439,0.15582883}, {440,0.14135135}, {441,0.14890991}, {442,0.14882883}, {443,0.15694595}, {444,0.14965766}, {445,0.15770270}, {446,0.15713514}, {447,0.16652252}, {448,0.13184685}, {449,0.13752252}, {450,0.13890090}, {451,0.14525225}, {452,0.13836036}, {453,0.14589189}, {454,0.14597297}, {455,0.15371171}, {456,0.14002703}, {457,0.14818018}, {458,0.14645946}, {459,0.15542342}, {460,0.14702703}, {461,0.15536937}, {462,0.15621622}, {463,0.16387387}, {464,0.14180180}, {465,0.14909910}, {466,0.14916216}, {467,0.15723423}, {468,0.14959459}, {469,0.15822523}, {470,0.15789189}, {471,0.16514414}, {472,0.15025225}, {473,0.15864865}, {474,0.15898198}, {475,0.16674775}, {476,0.15877477}, {477,0.16793694}, {478,0.16835135}, {479,0.17756757}, {480,0.14685586}, {481,0.15347748}, {482,0.15433333}, {483,0.16173874}, {484,0.15401802}, {485,0.16188288}, {486,0.16163063}, {487,0.17133333}, {488,0.15511712}, {489,0.16311712}, {490,0.16734234}, {491,0.17388288}, {492,0.16420721}, {493,0.17253153}, {494,0.17276577}, {495,0.18136937}, {496,0.15826126}, {497,0.16542342}, {498,0.16572973}, {499,0.17484685}, {500,0.16640541}, {505,0.17637838}, {510,0.18572973}, {515,0.16454955}, {520,0.15868468}, {525,0.17409910}, {530,0.16715315}, {535,0.18691892}, {540,0.17890090}, {545,0.17096396}, {550,0.18156757}, {555,0.19509910}, {560,0.17899099}, {565,0.19533333}, {570,0.19654054}, {575,0.21916216}, {580,0.18177477}, {585,0.19238739}, {590,0.20408108}, {595,0.20532432}, {600,0.19590090}, {605,0.21919820}, {610,0.19986486}, {615,0.22209009}, {620,0.21128829}, {625,0.21312613}, {630,0.22761261}, {635,0.23909009}, {640,0.19103604}, {645,0.21225225}, {650,0.21300000}, {655,0.24006306}, {660,0.21498198}, {665,0.22872973}, {670,0.24247748}, {675,0.23759459}, {680,0.22193694}, {685,0.24905405}, {690,0.23443243}, {695,0.26431532}, {700,0.25078378}, {705,0.22877477}, {710,0.24390991}, {715,0.25601802}, {720,0.23320721}, {725,0.26149550}, {730,0.26040541}, {735,0.29320721}, {740,0.25155856}, {745,0.26713514}, {750,0.28118919}, {755,0.28079279}, {760,0.27015315}, {765,0.30179279}, {770,0.24506306}, {775,0.27369369}, {780,0.26086486}, {785,0.26004505}, {790,0.27349550}, {795,0.29024324}, {800,0.25075676}, {805,0.27955856}, {810,0.28045946}, {815,0.31354054}, {820,0.28132432}, {825,0.29761261}, {830,0.31826126}, {835,0.28813514}, {840,0.27439640}, {845,0.30580180}, {850,0.29218018}, {855,0.32682883}, {860,0.31897297}, {865,0.29963063}, {870,0.31439640}, {875,0.33297297}, {880,0.30024324}, {885,0.33592793}, {890,0.33741441}, {895,0.37902703}, {900,0.29392793}, {905,0.31117117}, {910,0.32965766}, {915,0.33078378}, {920,0.31541441}, {925,0.35190090}, {930,0.31743243}, {935,0.35340541}, {940,0.33811712}, {945,0.33933333}, {950,0.36006306}, {955,0.38017117}, {960,0.31172072}, {965,0.34536036}, {970,0.34482883}, {975,0.38828829}, {980,0.34965766}, {985,0.36819820}, {990,0.39413514}, {995,0.37307207}, {1000,0.35493694}, {1010,0.37695495}, {1020,0.40284685}, {1030,0.35015315}, {1040,0.33248649}, {1050,0.37351818}, {1060,0.35522727}, {1070,0.39892727}, {1080,0.37968182}, {1090,0.36964545}, {1100,0.38710909}, {1110,0.41343636}, {1120,0.37356364}, {1130,0.42074545}, {1140,0.42240909}, {1150,0.47131818}, {1160,0.38917273}, {1170,0.41116364}, {1180,0.43132727}, {1190,0.44125455}, {1200,0.41977273}, {1210,0.47278182}, {1220,0.42633636}, {1230,0.47885455}, {1240,0.46165455}, {1250,0.45849091}, {1260,0.48690000}, {1270,0.51997273}, {1280,0.40559091}, {1290,0.45279091}, {1300,0.45491818}, {1310,0.51249091}, {1320,0.46173636}, {1330,0.49033636}, {1340,0.51980000}, {1350,0.49602727}, {1360,0.47179091}, {1370,0.53207273}, {1380,0.50556364}, {1390,0.56965455}, {1400,0.54092727}, {1410,0.48704545}, {1420,0.51938182}, {1430,0.55572727}, {1440,0.49521818}, {1450,0.56114545}, {1460,0.56168182}, {1470,0.63439091}, {1480,0.53580909}, {1490,0.57916364}, {1500,0.60523636}, {1510,0.60940909}, {1520,0.57918182}, {1530,0.65322727}, {1540,0.51463636}, {1550,0.58076364}, {1560,0.55229091}, {1570,0.55367273}, {1580,0.58674545}, {1590,0.62483636}, {1600,0.53072727}, {1610,0.59721818}, {1620,0.59870000}, {1630,2.31579091}, {1640,0.61130000}, {1650,0.65184545}, {1660,0.68755455}, {1670,0.61804545}, {1680,0.59215455}, {1690,0.66210909}, {1700,0.62600000}, {1710,0.71323636}, {1720,0.67072727}, {1730,0.63420000}, {1740,0.67599091}, {1750,0.72217273}, {1760,0.64367273}, {1770,0.72892727}, {1780,0.72799091}, {1790,0.82870000}, {1800,0.62749091}, {1810,0.66576364}, {1820,0.70885455}, {1830,0.71369091}, {1840,0.67675455}, {1850,0.76650909}, {1860,0.68959091}, {1870,0.77408182}, {1880,0.72920000}, {1890,0.73162727}, {1900,0.77644545}, {1910,0.82947273}, {1920,0.66097273}, {1930,0.75202727}, {1940,0.74980909}, {1950,0.83904545}, {1960,0.75658182}, {1970,0.80245455}, {1980,0.86124545}, {1990,0.81029091}, {2000,0.76871818}, {2050,0.70585455}, {2100,0.81391818}, {2150,0.87663636}, {2200,0.83970909}, {2250,0.90597273}, {2300,1.05113636}, {2350,1.01539091}, {2400,0.91272727}, {2450,0.98579091}, {2500,0.99510909}, {2550,1.22841818}, {2600,0.99251818}, {2650,1.13570909}, {2700,1.07829091}, {2750,1.33328182}, {2800,1.18245455}, {2850,1.13910909}, {2900,1.23180909}, {2950,1.24460909}, {3000,1.35070909}, {3050,1.44205455}, {3100,1.26684545}, {3150,1.36379091}, {3200,1.14290909}, {3250,1.39537273}, {3300,1.41331818}, {3350,1.42976364}, {3400,1.35882727}, {3450,1.68241818}, {3500,1.58010000}, {3550,1.81750000}, {3600,1.34542727}, {3650,1.45303636}, {3700,1.67311818}, {3750,1.68464545}, {3800,1.70639091}, {3850,1.63734545}, {3900,1.86920000}, {3950,2.00137273}, {4000,1.65490000}, {4050,1.91570000}, {4100,1.52384545}, {4150,1.82530909}, {4200,1.74533636}, {4250,1.87762727}, {4300,1.90947273}, {4350,2.32222727}, {4400,1.82070000}, {4450,1.95796364}, {4500,1.97946364}, {4550,2.11557273}, {4600,2.29178182}, {4650,2.04921818}, {4700,2.17341818}, {4750,2.22997273}, {4800,1.95384545}, {4850,2.40601818}, {4900,2.12898182}, {4950,2.45699091}, {5000,2.15858182}, {5050,2.63724545}, {5100,2.66763636}, {5150,2.44004545}, {5200,2.12217273}, {5250,2.14575455}, {5300,2.44663636}, {5350,2.64629091}, {5400,2.34448182}, {5450,2.50515455}, {5500,2.85660000}, {5550,2.90791818}, {5600,2.51191818}, {5650,2.42818182}, {5700,2.39694545}, {5750,2.94579091}, {5800,2.55492727}, {5850,2.96306364}, {5900,2.60514545}, {5950,3.12509091}, {6000,2.78749091}, {6050,2.89425}, {6100,3.07000}, {6150,2.54000}, {6200,2.71450}, {6250,2.94275}, {6300,2.92650}, {6350,3.10300}, {6400,2.43950}, {6450,2.97750}, {6500,2.98500}, {6550,3.21375}, {6600,3.01775}, {6650,3.70025}, {6700,3.09650}, {6750,3.51675}, {6800,2.89750}, {6850,3.12450}, {6900,3.56750}, {6950,3.39200}, {7000,3.42825}, {7050,3.43125}, {7100,3.86950}, {7150,4.16750}, {7200,2.88975}, {7250,3.34650}, {7300,3.11125}, {7350,3.73275}, {7400,3.60125}, {7450,3.61475}, {7500,3.64150}, {7550,4.47950}, {7600,3.65500}, {7650,3.89275}, {7700,3.47450}, {7750,3.73900}, {7800,3.99950}, {7850,3.95625}, {7900,4.31875}, {7950,4.02975}, {8000,3.54275}, {8050,4.39825}, {8100,4.06500}, {8150,4.60350}, {8200,3.22550}, {8250,3.95250}, {8300,3.92850}, {8350,4.18125}, {8400,3.76725}, {8450,3.52475}, {8500,3.96975}, {8550,4.27750}, {8600,3.98950}, {8650,4.31150}, {8700,4.82975}, {8750,4.37150}, {8800,3.85175}, {8850,4.16950}, {8900,4.15075}, {8950,4.98250}, {9000,4.14650}, {9050,4.70925}, {9100,4.45750}, {9150,5.38850}, {9200,4.77950}, {9250,4.02925}, {9300,4.32975}, {9350,4.27625}, {9400,4.62125}, {9450,4.92325}, {9500,4.59550}, {9550,4.95875}, {9600,4.14300}, {9650,4.92500}, {9700,4.94425}, {9750,4.73925}, {9800,4.45975}, {9850,5.44450}, {9900,5.07750}, {9950,5.79425}, {10000,4.51700}, {10100,5.46050}, {10200,5.49975}, {10300,5.09575}, {10400,4.45825}, {10500,4.47400}, {10600,5.17700}, {10700,5.55350}, {10800,4.90575}, {10900,5.29325}, {11000,6.00450}, {11100,6.03900}, {11200,5.29525}, {11300,5.15650}, {11400,5.13000}, {11500,6.13550}, {11600,5.56400}, {11700,6.33125}, {11800,5.64175}, {11900,6.82275}, {12000,6.03250}, {12100,6.02725}, {12200,6.59800}, {12300,5.41325}, {12400,5.76500}, {12500,6.13525}, {12600,6.17975}, {12700,6.68050}, {12800,5.17625}, {12900,6.30650}, {13000,6.25650}, {13100,6.76350}, {13200,6.39675}, {13300,7.84450}, {13400,6.56050}, {13500,7.41500}, {13600,6.17200}, {13700,6.63525}, {13800,7.55100}, {13900,7.11375}, {14000,7.06600}, {14100,7.17800}, {14200,8.27575}, {14300,8.91500}, {14400,6.16275}, {14500,7.02200}, {14600,6.69050}, {14700,8.15350}, {14800,7.65425}, {14900,7.64875}, {15000,7.73675}, {15100,9.28050}, {15200,7.84100}, {15300,8.37850}, {15400,7.38925}, {15500,7.93475}, {15600,8.34475}, {15700,8.56800}, {15800,9.17275}, {15900,8.66950}, {16000,7.51275}, {16100,9.14225}, {16200,8.64650}, {16300,9.79375}, {16400,6.86850}, {16500,8.48675}, {16600,8.39075}, {16700,8.99375}, {16800,7.91525}, {16900,7.54550}, {17000,8.54575}, {17100,9.30350}, {17200,8.65100}, {17300,9.18875}, {17400,10.61875}, {17500,9.28225}, {17600,8.26425}, {17700,8.85925}, {17800,8.77600}, {17900,10.91250}, {18000,8.94675}, {18100,10.38650}, {18200,9.74925}, {18300,11.67325}, {18400,10.30325}, {18500,8.63100}, {18600,9.27050}, {18700,9.28025}, {18800,9.85650}, {18900,10.54550}, {19000,10.05250}, {19100,10.69650}, {19200,8.89875}, {19300,10.94500}, {19400,10.83850}, {19500,10.25250}, {19600,9.66325}, {19700,11.80150}, {19800,11.06775}, {19900,12.69025}, {20000,9.7460}};
data["big_flat"]["CanonicalStructuresPHOAS"]["norm reif"]["system"] = {{1,0.00000000}, {2,0.00003604}, {3,0.00000000}, {4,0.00006306}, {5,0.00002703}, {6,0.00003604}, {7,0.00000000}, {8,0.00007207}, {9,0.00013514}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00007207}, {15,0.00003604}, {16,0.00000000}, {17,0.00006306}, {18,0.00003604}, {19,0.00003604}, {20,0.00010811}, {21,0.00007207}, {22,0.00000000}, {23,0.00002703}, {24,0.00003604}, {25,0.00003604}, {26,0.00003604}, {27,0.00000000}, {28,0.00007207}, {29,0.00007207}, {30,0.00003604}, {31,0.00000000}, {32,0.00007207}, {33,0.00000000}, {34,0.00003604}, {35,0.00003604}, {36,0.00003604}, {37,0.00003604}, {38,0.00007207}, {39,0.00009910}, {40,0.00003604}, {41,0.00000000}, {42,0.00003604}, {43,0.00000000}, {44,0.00003604}, {45,0.00003604}, {46,0.00000000}, {47,0.00000000}, {48,0.00003604}, {49,0.00000000}, {50,0.00002703}, {51,0.00000000}, {52,0.00009910}, {53,0.00007207}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00007207}, {58,0.00007207}, {59,0.00000000}, {60,0.00007207}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00003604}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00003604}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00003604}, {73,0.00000000}, {74,0.00003604}, {75,0.00003604}, {76,0.00000000}, {77,0.00000000}, {78,0.00003604}, {79,0.00000000}, {80,0.00003604}, {81,0.00000000}, {82,0.00003604}, {83,0.00003604}, {84,0.00003604}, {85,0.00007207}, {86,0.00007207}, {87,0.00010811}, {88,0.00003604}, {89,0.00003604}, {90,0.00007207}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00006306}, {95,0.00006306}, {96,0.00003604}, {97,0.00003604}, {98,0.00000000}, {99,0.00000000}, {100,0.00002703}, {101,0.00003604}, {102,0.00021622}, {103,0.00007207}, {104,0.00003604}, {105,0.00010811}, {106,0.00007207}, {107,0.00007207}, {108,0.00003604}, {109,0.00000000}, {110,0.00000000}, {111,0.00003604}, {112,0.00000000}, {113,0.00014414}, {114,0.00003604}, {115,0.00003604}, {116,0.00003604}, {117,0.00003604}, {118,0.00010811}, {119,0.00003604}, {120,0.00003604}, {121,0.00000000}, {122,0.00007207}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00006306}, {128,0.00003604}, {129,0.00006306}, {130,0.00003604}, {131,0.00000000}, {132,0.00003604}, {133,0.00003604}, {134,0.00003604}, {135,0.00007207}, {136,0.00007207}, {137,0.00003604}, {138,0.00007207}, {139,0.00003604}, {140,0.00000000}, {141,0.00000000}, {142,0.00007207}, {143,0.00003604}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00003604}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00003604}, {153,0.00007207}, {154,0.00000000}, {155,0.00003604}, {156,0.00000000}, {157,0.00003604}, {158,0.00010811}, {159,0.00006306}, {160,0.00003604}, {161,0.00000000}, {162,0.00000000}, {163,0.00007207}, {164,0.00000000}, {165,0.00003604}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00013514}, {171,0.00002703}, {172,0.00000000}, {173,0.00003604}, {174,0.00003604}, {175,0.00000000}, {176,0.00003604}, {177,0.00003604}, {178,0.00003604}, {179,0.00010811}, {180,0.00003604}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00003604}, {186,0.00007207}, {187,0.00003604}, {188,0.00003604}, {189,0.00007207}, {190,0.00014414}, {191,0.00007207}, {192,0.00003604}, {193,0.00003604}, {194,0.00000000}, {195,0.00003604}, {196,0.00000000}, {197,0.00007207}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00007207}, {203,0.00003604}, {204,0.00003604}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00003604}, {209,0.00010811}, {210,0.00010811}, {211,0.00000000}, {212,0.00003604}, {213,0.00007207}, {214,0.00000000}, {215,0.00000000}, {216,0.00003604}, {217,0.00003604}, {218,0.00000000}, {219,0.00003604}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00003604}, {224,0.00003604}, {225,0.00000000}, {226,0.00000000}, {227,0.00003604}, {228,0.00000000}, {229,0.00003604}, {230,0.00007207}, {231,0.00000000}, {232,0.00003604}, {233,0.00000000}, {234,0.00003604}, {235,0.00000000}, {236,0.00003604}, {237,0.00000000}, {238,0.00003604}, {239,0.00000000}, {240,0.00003604}, {241,0.00000000}, {242,0.00000000}, {243,0.00003604}, {244,0.00000000}, {245,0.00007207}, {246,0.00003604}, {247,0.00000000}, {248,0.00007207}, {249,0.00010811}, {250,0.00006306}, {251,0.00000000}, {252,0.00000000}, {253,0.00003604}, {254,0.00000000}, {255,0.00000000}, {256,0.00003604}, {257,0.00000000}, {258,0.00007207}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00007207}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00007207}, {268,0.00003604}, {269,0.00000000}, {270,0.00003604}, {271,0.00003604}, {272,0.00003604}, {273,0.00003604}, {274,0.00003604}, {275,0.00003604}, {276,0.00003604}, {277,0.00007207}, {278,0.00007207}, {279,0.00003604}, {280,0.00000000}, {281,0.00002703}, {282,0.00003604}, {283,0.00003604}, {284,0.00003604}, {285,0.00018018}, {286,0.00003604}, {287,0.00003604}, {288,0.00006306}, {289,0.00003604}, {290,0.00010811}, {291,0.00014414}, {292,0.00003604}, {293,0.00006306}, {294,0.00010811}, {295,0.00007207}, {296,0.00010811}, {297,0.00007207}, {298,0.00003604}, {299,0.00007207}, {300,0.00003604}, {301,0.00007207}, {302,0.00000000}, {303,0.00003604}, {304,0.00010811}, {305,0.00003604}, {306,0.00003604}, {307,0.00003604}, {308,0.00003604}, {309,0.00003604}, {310,0.00000000}, {311,0.00010811}, {312,0.00007207}, {313,0.00000000}, {314,0.00007207}, {315,0.00009910}, {316,0.00003604}, {317,0.00000000}, {318,0.00000000}, {319,0.00003604}, {320,0.00007207}, {321,0.00002703}, {322,0.00003604}, {323,0.00003604}, {324,0.00009910}, {325,0.00010811}, {326,0.00003604}, {327,0.00014414}, {328,0.00010811}, {329,0.00010811}, {330,0.00007207}, {331,0.00003604}, {332,0.00000000}, {333,0.00003604}, {334,0.00010811}, {335,0.00000000}, {336,0.00003604}, {337,0.00007207}, {338,0.00007207}, {339,0.00007207}, {340,0.00007207}, {341,0.00000000}, {342,0.00007207}, {343,0.00003604}, {344,0.00000000}, {345,0.00000000}, {346,0.00003604}, {347,0.00003604}, {348,0.00003604}, {349,0.00000000}, {350,0.00003604}, {351,0.00003604}, {352,0.00006306}, {353,0.00003604}, {354,0.00000000}, {355,0.00006306}, {356,0.00000000}, {357,0.00003604}, {358,0.00007207}, {359,0.00000000}, {360,0.00000000}, {361,0.00007207}, {362,0.00000000}, {363,0.00003604}, {364,0.00000000}, {365,0.00000000}, {366,0.00010811}, {367,0.00000000}, {368,0.00000000}, {369,0.00007207}, {370,0.00003604}, {371,0.00007207}, {372,0.00000000}, {373,0.00000000}, {374,0.00003604}, {375,0.00000000}, {376,0.00003604}, {377,0.00003604}, {378,0.00000000}, {379,0.00007207}, {380,0.00003604}, {381,0.00003604}, {382,0.00007207}, {383,0.00003604}, {384,0.00006306}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00007207}, {389,0.00000000}, {390,0.00003604}, {391,0.00000000}, {392,0.00007207}, {393,0.00000000}, {394,0.00000000}, {395,0.00003604}, {396,0.00003604}, {397,0.00010811}, {398,0.00007207}, {399,0.00003604}, {400,0.00003604}, {401,0.00003604}, {402,0.00000000}, {403,0.00003604}, {404,0.00010811}, {405,0.00006306}, {406,0.00009910}, {407,0.00007207}, {408,0.00013514}, {409,0.00000000}, {410,0.00003604}, {411,0.00003604}, {412,0.00007207}, {413,0.00007207}, {414,0.00010811}, {415,0.00010811}, {416,0.00010811}, {417,0.00007207}, {418,0.00007207}, {419,0.00003604}, {420,0.00000000}, {421,0.00000000}, {422,0.00028829}, {423,0.00003604}, {424,0.00003604}, {425,0.00003604}, {426,0.00010811}, {427,0.00003604}, {428,0.00003604}, {429,0.00007207}, {430,0.00007207}, {431,0.00003604}, {432,0.00007207}, {433,0.00007207}, {434,0.00000000}, {435,0.00003604}, {436,0.00000000}, {437,0.00003604}, {438,0.00007207}, {439,0.00000000}, {440,0.00003604}, {441,0.00002703}, {442,0.00006306}, {443,0.00000000}, {444,0.00007207}, {445,0.00007207}, {446,0.00007207}, {447,0.00000000}, {448,0.00002703}, {449,0.00000000}, {450,0.00003604}, {451,0.00003604}, {452,0.00007207}, {453,0.00003604}, {454,0.00007207}, {455,0.00003604}, {456,0.00010811}, {457,0.00003604}, {458,0.00010811}, {459,0.00010811}, {460,0.00003604}, {461,0.00014414}, {462,0.00000000}, {463,0.00007207}, {464,0.00007207}, {465,0.00032432}, {466,0.00017117}, {467,0.00003604}, {468,0.00003604}, {469,0.00009910}, {470,0.00007207}, {471,0.00014414}, {472,0.00007207}, {473,0.00013514}, {474,0.00013514}, {475,0.00006306}, {476,0.00003604}, {477,0.00003604}, {478,0.00014414}, {479,0.00007207}, {480,0.00043243}, {481,0.00020721}, {482,0.00018018}, {483,0.00021622}, {484,0.00017117}, {485,0.00007207}, {486,0.00018018}, {487,0.00010811}, {488,0.00003604}, {489,0.00007207}, {490,0.00017117}, {491,0.00007207}, {492,0.00010811}, {493,0.00003604}, {494,0.00007207}, {495,0.00003604}, {496,0.00018018}, {497,0.00010811}, {498,0.00003604}, {499,0.00010811}, {500,0.00000000}, {505,0.00000000}, {510,0.00010811}, {515,0.00014414}, {520,0.00003604}, {525,0.00000000}, {530,0.00014414}, {535,0.00010811}, {540,0.00010811}, {545,0.00007207}, {550,0.00003604}, {555,0.00010811}, {560,0.00018018}, {565,0.00021622}, {570,0.00006306}, {575,0.00020721}, {580,0.00010811}, {585,0.00018018}, {590,0.00024324}, {595,0.00010811}, {600,0.00012613}, {605,0.00000000}, {610,0.00000000}, {615,0.00017117}, {620,0.00013514}, {625,0.00035135}, {630,0.00013514}, {635,0.00010811}, {640,0.00013514}, {645,0.00025225}, {650,0.00021622}, {655,0.00010811}, {660,0.00021622}, {665,0.00003604}, {670,0.00007207}, {675,0.00025225}, {680,0.00018018}, {685,0.00018018}, {690,0.00002703}, {695,0.00010811}, {700,0.00014414}, {705,0.00014414}, {710,0.00007207}, {715,0.00006306}, {720,0.00028829}, {725,0.00018018}, {730,0.00017117}, {735,0.00010811}, {740,0.00028829}, {745,0.00009910}, {750,0.00000000}, {755,0.00003604}, {760,0.00000000}, {765,0.00031532}, {770,0.00014414}, {775,0.00009910}, {780,0.00024324}, {785,0.00021622}, {790,0.00025225}, {795,0.00003604}, {800,0.00037838}, {805,0.00021622}, {810,0.00018018}, {815,0.00014414}, {820,0.00013514}, {825,0.00018018}, {830,0.00025225}, {835,0.00032432}, {840,0.00028829}, {845,0.00032432}, {850,0.00014414}, {855,0.00032432}, {860,0.00036036}, {865,0.00010811}, {870,0.00036036}, {875,0.00035135}, {880,0.00028829}, {885,0.00003604}, {890,0.00032432}, {895,0.00031532}, {900,0.00013514}, {905,0.00039640}, {910,0.00018018}, {915,0.00014414}, {920,0.00014414}, {925,0.00028829}, {930,0.00028829}, {935,0.00032432}, {940,0.00010811}, {945,0.00042342}, {950,0.00020721}, {955,0.00028829}, {960,0.00027928}, {965,0.00025225}, {970,0.00018018}, {975,0.00027928}, {980,0.00014414}, {985,0.00031532}, {990,0.00021622}, {995,0.00021622}, {1000,0.00018018}, {1010,0.00027027}, {1020,0.00046847}, {1030,0.00014414}, {1040,0.00010811}, {1050,0.00002727}, {1060,0.00014545}, {1070,0.00025455}, {1080,0.00018182}, {1090,0.00168182}, {1100,0.00010909}, {1110,0.00021818}, {1120,0.00017273}, {1130,0.00024545}, {1140,0.00018182}, {1150,0.00007273}, {1160,0.00029091}, {1170,0.00031818}, {1180,0.00020909}, {1190,0.00032727}, {1200,0.00010909}, {1210,0.00014545}, {1220,0.00018182}, {1230,0.00021818}, {1240,0.00021818}, {1250,0.00042727}, {1260,0.00043636}, {1270,0.00036364}, {1280,0.00030909}, {1290,0.00043636}, {1300,0.00025455}, {1310,0.00041818}, {1320,0.00029091}, {1330,0.00024545}, {1340,0.00032727}, {1350,0.00029091}, {1360,0.00025455}, {1370,0.00036364}, {1380,0.00029091}, {1390,0.00035455}, {1400,0.00020909}, {1410,0.00036364}, {1420,0.00036364}, {1430,0.00056364}, {1440,0.00047273}, {1450,0.00040000}, {1460,0.00025455}, {1470,0.00020909}, {1480,0.00042727}, {1490,0.00025455}, {1500,0.00038182}, {1510,0.00032727}, {1520,0.00003636}, {1530,0.00029091}, {1540,0.00010909}, {1550,0.00010000}, {1560,0.00003636}, {1570,0.00006364}, {1580,0.00003636}, {1590,0.00003636}, {1600,0.00010909}, {1610,0.00003636}, {1620,0.00021818}, {1630,0.00156364}, {1640,0.00003636}, {1650,0.00010909}, {1660,0.00021818}, {1670,0.00025455}, {1680,0.00021818}, {1690,0.00007273}, {1700,0.00003636}, {1710,0.00010000}, {1720,0.00013636}, {1730,0.00017273}, {1740,0.00010909}, {1750,0.00021818}, {1760,0.00010000}, {1770,0.00014545}, {1780,0.00013636}, {1790,0.00021818}, {1800,0.00018182}, {1810,0.00014545}, {1820,0.00029091}, {1830,0.00031818}, {1840,0.00018182}, {1850,0.00014545}, {1860,0.00010909}, {1870,0.00018182}, {1880,0.00007273}, {1890,0.00010909}, {1900,0.00010909}, {1910,0.00010000}, {1920,0.00018182}, {1930,0.00028182}, {1940,0.00007273}, {1950,0.00010909}, {1960,0.00007273}, {1970,0.00018182}, {1980,0.00018182}, {1990,0.00006364}, {2000,0.00000000}, {2050,0.00007273}, {2100,0.00003636}, {2150,0.00006364}, {2200,0.00000000}, {2250,0.00028182}, {2300,0.00053636}, {2350,0.00010909}, {2400,0.00007273}, {2450,0.00007273}, {2500,0.00014545}, {2550,0.00035455}, {2600,0.00010909}, {2650,0.00018182}, {2700,0.00018182}, {2750,0.00007273}, {2800,0.00003636}, {2850,0.00010909}, {2900,0.00007273}, {2950,0.00014545}, {3000,0.00014545}, {3050,0.00007273}, {3100,0.00007273}, {3150,0.00010909}, {3200,0.00018182}, {3250,0.00013636}, {3300,0.00014545}, {3350,0.00025455}, {3400,0.00018182}, {3450,0.00014545}, {3500,0.00007273}, {3550,0.00024545}, {3600,0.00010909}, {3650,0.00020909}, {3700,0.00020909}, {3750,0.00018182}, {3800,0.00003636}, {3850,0.00010000}, {3900,0.00018182}, {3950,0.00021818}, {4000,0.00018182}, {4050,0.00014545}, {4100,0.00018182}, {4150,0.00007273}, {4200,0.00021818}, {4250,0.00010909}, {4300,0.00012727}, {4350,0.00025455}, {4400,0.00014545}, {4450,0.00025455}, {4500,0.00021818}, {4550,0.00032727}, {4600,0.00014545}, {4650,0.00010909}, {4700,0.00134545}, {4750,0.00110909}, {4800,0.00083636}, {4850,0.00123636}, {4900,0.00086364}, {4950,0.00088182}, {5000,0.00105455}, {5050,0.00104545}, {5100,0.00061818}, {5150,0.00007273}, {5200,0.00017273}, {5250,0.00007273}, {5300,0.00010909}, {5350,0.00014545}, {5400,0.00017273}, {5450,0.00029091}, {5500,0.00053636}, {5550,0.00043636}, {5600,0.00043636}, {5650,0.00018182}, {5700,0.00024545}, {5750,0.00018182}, {5800,0.00027273}, {5850,0.00021818}, {5900,0.00025455}, {5950,0.00007273}, {6000,0.00007273}, {6050,0.00200}, {6100,0.00300}, {6150,0.00200}, {6200,0.00000}, {6250,0.00000}, {6300,0.00100}, {6350,0.00300}, {6400,0.00300}, {6450,0.00000}, {6500,0.00100}, {6550,0.00000}, {6600,0.00000}, {6650,0.00075}, {6700,0.00100}, {6750,0.00000}, {6800,0.00200}, {6850,0.00000}, {6900,0.00100}, {6950,0.00000}, {7000,0.00275}, {7050,0.00300}, {7100,0.00100}, {7150,0.00000}, {7200,0.00000}, {7250,0.00200}, {7300,0.00000}, {7350,0.00000}, {7400,0.00100}, {7450,0.00100}, {7500,0.00200}, {7550,0.00100}, {7600,0.00200}, {7650,0.00300}, {7700,0.00100}, {7750,0.00000}, {7800,0.00000}, {7850,0.00100}, {7900,0.00100}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00100}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00100}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00100}, {8950,0.00000}, {9000,0.00100}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00100}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00100}, {9750,0.00100}, {9800,0.00000}, {9850,0.00100}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00100}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00100}, {10600,0.00000}, {10700,0.00100}, {10800,0.00000}, {10900,0.00100}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00100}, {11600,0.00100}, {11700,0.00100}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00100}, {12400,0.00000}, {12500,0.00100}, {12600,0.00100}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00100}, {13200,0.00000}, {13300,0.00000}, {13400,0.00100}, {13500,0.00100}, {13600,0.00100}, {13700,0.00000}, {13800,0.00100}, {13900,0.00000}, {14000,0.00200}, {14100,0.00200}, {14200,0.00200}, {14300,0.00000}, {14400,0.00075}, {14500,0.00300}, {14600,0.00000}, {14700,0.00100}, {14800,0.00200}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00100}, {16000,0.00100}, {16100,0.00100}, {16200,0.00000}, {16300,0.00300}, {16400,0.00000}, {16500,0.00000}, {16600,0.00100}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00200}, {17100,0.00100}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00100}, {18200,0.00000}, {18300,0.00000}, {18400,0.00075}, {18500,0.00000}, {18600,0.00000}, {18700,0.00100}, {18800,0.00000}, {18900,0.00000}, {19000,0.00100}, {19100,0.00000}, {19200,0.00100}, {19300,0.00000}, {19400,0.00100}, {19500,0.00200}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresPHOAS"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresPHOAS"]["post"]["user"] = {{1,0.00008108}, {2,0.00005405}, {3,0.00007207}, {4,0.00000000}, {5,0.00005405}, {6,0.00000000}, {7,0.00000000}, {8,0.00006306}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00003604}, {14,0.00003604}, {15,0.00003604}, {16,0.00007207}, {17,0.00008108}, {18,0.00005405}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00002703}, {26,0.00003604}, {27,0.00000000}, {28,0.00008108}, {29,0.00009009}, {30,0.00002703}, {31,0.00000000}, {32,0.00002703}, {33,0.00002703}, {34,0.00003604}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00007207}, {39,0.00000000}, {40,0.00003604}, {41,0.00002703}, {42,0.00002703}, {43,0.00003604}, {44,0.00000000}, {45,0.00000000}, {46,0.00002703}, {47,0.00000000}, {48,0.00000000}, {49,0.00006306}, {50,0.00000000}, {51,0.00007207}, {52,0.00002703}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00002703}, {58,0.00003604}, {59,0.00000000}, {60,0.00008108}, {61,0.00003604}, {62,0.00007207}, {63,0.00002703}, {64,0.00006306}, {65,0.00009009}, {66,0.00003604}, {67,0.00000000}, {68,0.00002703}, {69,0.00003604}, {70,0.00002703}, {71,0.00002703}, {72,0.00003604}, {73,0.00005405}, {74,0.00000000}, {75,0.00002703}, {76,0.00000000}, {77,0.00002703}, {78,0.00000000}, {79,0.00005405}, {80,0.00000000}, {81,0.00007207}, {82,0.00009009}, {83,0.00011712}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00005405}, {90,0.00000000}, {91,0.00000000}, {92,0.00005405}, {93,0.00002703}, {94,0.00005405}, {95,0.00003604}, {96,0.00000000}, {97,0.00000000}, {98,0.00002703}, {99,0.00000000}, {100,0.00009009}, {101,0.00006306}, {102,0.00003604}, {103,0.00000000}, {104,0.00000000}, {105,0.00002703}, {106,0.00002703}, {107,0.00000000}, {108,0.00002703}, {109,0.00000000}, {110,0.00006306}, {111,0.00003604}, {112,0.00000000}, {113,0.00000000}, {114,0.00002703}, {115,0.00005405}, {116,0.00002703}, {117,0.00003604}, {118,0.00002703}, {119,0.00011712}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00005405}, {124,0.00006306}, {125,0.00000000}, {126,0.00003604}, {127,0.00000000}, {128,0.00002703}, {129,0.00006306}, {130,0.00000000}, {131,0.00007207}, {132,0.00000000}, {133,0.00005405}, {134,0.00000000}, {135,0.00002703}, {136,0.00006306}, {137,0.00000000}, {138,0.00002703}, {139,0.00002703}, {140,0.00000000}, {141,0.00007207}, {142,0.00002703}, {143,0.00000000}, {144,0.00002703}, {145,0.00000000}, {146,0.00003604}, {147,0.00000000}, {148,0.00002703}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00005405}, {156,0.00006306}, {157,0.00009009}, {158,0.00006306}, {159,0.00000000}, {160,0.00002703}, {161,0.00002703}, {162,0.00006306}, {163,0.00003604}, {164,0.00002703}, {165,0.00009009}, {166,0.00000000}, {167,0.00002703}, {168,0.00003604}, {169,0.00005405}, {170,0.00000000}, {171,0.00000000}, {172,0.00002703}, {173,0.00000000}, {174,0.00002703}, {175,0.00002703}, {176,0.00002703}, {177,0.00000000}, {178,0.00002703}, {179,0.00002703}, {180,0.00003604}, {181,0.00006306}, {182,0.00003604}, {183,0.00003604}, {184,0.00000000}, {185,0.00006306}, {186,0.00011712}, {187,0.00006306}, {188,0.00000000}, {189,0.00002703}, {190,0.00002703}, {191,0.00003604}, {192,0.00009009}, {193,0.00002703}, {194,0.00002703}, {195,0.00002703}, {196,0.00000000}, {197,0.00010811}, {198,0.00002703}, {199,0.00000000}, {200,0.00005405}, {201,0.00006306}, {202,0.00006306}, {203,0.00000000}, {204,0.00003604}, {205,0.00006306}, {206,0.00005405}, {207,0.00000000}, {208,0.00002703}, {209,0.00002703}, {210,0.00006306}, {211,0.00000000}, {212,0.00006306}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00003604}, {218,0.00000000}, {219,0.00000000}, {220,0.00002703}, {221,0.00006306}, {222,0.00005405}, {223,0.00000000}, {224,0.00006306}, {225,0.00003604}, {226,0.00000000}, {227,0.00005405}, {228,0.00002703}, {229,0.00000000}, {230,0.00000000}, {231,0.00002703}, {232,0.00000000}, {233,0.00003604}, {234,0.00005405}, {235,0.00002703}, {236,0.00002703}, {237,0.00009009}, {238,0.00002703}, {239,0.00006306}, {240,0.00000000}, {241,0.00005405}, {242,0.00010811}, {243,0.00000000}, {244,0.00009009}, {245,0.00002703}, {246,0.00002703}, {247,0.00003604}, {248,0.00000000}, {249,0.00006306}, {250,0.00000000}, {251,0.00002703}, {252,0.00000000}, {253,0.00000000}, {254,0.00008108}, {255,0.00002703}, {256,0.00006306}, {257,0.00000000}, {258,0.00002703}, {259,0.00002703}, {260,0.00005405}, {261,0.00000000}, {262,0.00005405}, {263,0.00005405}, {264,0.00000000}, {265,0.00002703}, {266,0.00005405}, {267,0.00005405}, {268,0.00005405}, {269,0.00002703}, {270,0.00000000}, {271,0.00002703}, {272,0.00002703}, {273,0.00003604}, {274,0.00002703}, {275,0.00000000}, {276,0.00006306}, {277,0.00006306}, {278,0.00000000}, {279,0.00002703}, {280,0.00000000}, {281,0.00000000}, {282,0.00005405}, {283,0.00002703}, {284,0.00002703}, {285,0.00003604}, {286,0.00006306}, {287,0.00006306}, {288,0.00003604}, {289,0.00000000}, {290,0.00009009}, {291,0.00000000}, {292,0.00002703}, {293,0.00006306}, {294,0.00008108}, {295,0.00000000}, {296,0.00002703}, {297,0.00005405}, {298,0.00002703}, {299,0.00003604}, {300,0.00006306}, {301,0.00002703}, {302,0.00002703}, {303,0.00006306}, {304,0.00000000}, {305,0.00006306}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00002703}, {311,0.00003604}, {312,0.00003604}, {313,0.00002703}, {314,0.00002703}, {315,0.00000000}, {316,0.00002703}, {317,0.00000000}, {318,0.00007207}, {319,0.00002703}, {320,0.00002703}, {321,0.00000000}, {322,0.00005405}, {323,0.00000000}, {324,0.00003604}, {325,0.00003604}, {326,0.00006306}, {327,0.00000000}, {328,0.00007207}, {329,0.00002703}, {330,0.00000000}, {331,0.00000000}, {332,0.00002703}, {333,0.00003604}, {334,0.00002703}, {335,0.00002703}, {336,0.00002703}, {337,0.00002703}, {338,0.00000000}, {339,0.00009910}, {340,0.00002703}, {341,0.00003604}, {342,0.00003604}, {343,0.00009910}, {344,0.00000000}, {345,0.00003604}, {346,0.00000000}, {347,0.00009009}, {348,0.00000000}, {349,0.00005405}, {350,0.00000000}, {351,0.00000000}, {352,0.00003604}, {353,0.00000000}, {354,0.00000000}, {355,0.00008108}, {356,0.00003604}, {357,0.00007207}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00002703}, {362,0.00000000}, {363,0.00000000}, {364,0.00002703}, {365,0.00000000}, {366,0.00005405}, {367,0.00003604}, {368,0.00000000}, {369,0.00000000}, {370,0.00005405}, {371,0.00006306}, {372,0.00000000}, {373,0.00002703}, {374,0.00006306}, {375,0.00000000}, {376,0.00005405}, {377,0.00003604}, {378,0.00006306}, {379,0.00000000}, {380,0.00009910}, {381,0.00000000}, {382,0.00002703}, {383,0.00006306}, {384,0.00000000}, {385,0.00000000}, {386,0.00006306}, {387,0.00000000}, {388,0.00000000}, {389,0.00002703}, {390,0.00006306}, {391,0.00002703}, {392,0.00000000}, {393,0.00000000}, {394,0.00002703}, {395,0.00002703}, {396,0.00009910}, {397,0.00002703}, {398,0.00005405}, {399,0.00000000}, {400,0.00006306}, {401,0.00003604}, {402,0.00000000}, {403,0.00002703}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00003604}, {408,0.00000000}, {409,0.00000000}, {410,0.00003604}, {411,0.00008108}, {412,0.00003604}, {413,0.00005405}, {414,0.00002703}, {415,0.00002703}, {416,0.00006306}, {417,0.00000000}, {418,0.00000000}, {419,0.00006306}, {420,0.00000000}, {421,0.00000000}, {422,0.00003604}, {423,0.00012613}, {424,0.00000000}, {425,0.00003604}, {426,0.00002703}, {427,0.00000000}, {428,0.00005405}, {429,0.00005405}, {430,0.00000000}, {431,0.00000000}, {432,0.00005405}, {433,0.00003604}, {434,0.00002703}, {435,0.00006306}, {436,0.00006306}, {437,0.00003604}, {438,0.00002703}, {439,0.00002703}, {440,0.00005405}, {441,0.00000000}, {442,0.00005405}, {443,0.00002703}, {444,0.00006306}, {445,0.00002703}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00008108}, {452,0.00007207}, {453,0.00000000}, {454,0.00000000}, {455,0.00002703}, {456,0.00000000}, {457,0.00009009}, {458,0.00000000}, {459,0.00000000}, {460,0.00009009}, {461,0.00002703}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00002703}, {466,0.00002703}, {467,0.00006306}, {468,0.00000000}, {469,0.00000000}, {470,0.00003604}, {471,0.00000000}, {472,0.00002703}, {473,0.00009009}, {474,0.00000000}, {475,0.00000000}, {476,0.00005405}, {477,0.00009910}, {478,0.00003604}, {479,0.00000000}, {480,0.00002703}, {481,0.00008108}, {482,0.00002703}, {483,0.00005405}, {484,0.00003604}, {485,0.00003604}, {486,0.00006306}, {487,0.00000000}, {488,0.00002703}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00005405}, {493,0.00000000}, {494,0.00002703}, {495,0.00000000}, {496,0.00006306}, {497,0.00003604}, {498,0.00000000}, {499,0.00000000}, {500,0.00002703}, {505,0.00000000}, {510,0.00000000}, {515,0.00002703}, {520,0.00000000}, {525,0.00000000}, {530,0.00003604}, {535,0.00005405}, {540,0.00000000}, {545,0.00002703}, {550,0.00005405}, {555,0.00002703}, {560,0.00006306}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00002703}, {585,0.00000000}, {590,0.00000000}, {595,0.00006306}, {600,0.00000000}, {605,0.00003604}, {610,0.00003604}, {615,0.00000000}, {620,0.00006306}, {625,0.00002703}, {630,0.00006306}, {635,0.00003604}, {640,0.00000000}, {645,0.00006306}, {650,0.00005405}, {655,0.00007207}, {660,0.00002703}, {665,0.00005405}, {670,0.00002703}, {675,0.00002703}, {680,0.00009009}, {685,0.00002703}, {690,0.00007207}, {695,0.00005405}, {700,0.00005405}, {705,0.00006306}, {710,0.00000000}, {715,0.00005405}, {720,0.00005405}, {725,0.00009910}, {730,0.00015315}, {735,0.00005405}, {740,0.00003604}, {745,0.00000000}, {750,0.00003604}, {755,0.00005405}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00009009}, {780,0.00002703}, {785,0.00002703}, {790,0.00000000}, {795,0.00000000}, {800,0.00005405}, {805,0.00003604}, {810,0.00008108}, {815,0.00002703}, {820,0.00002703}, {825,0.00007207}, {830,0.00000000}, {835,0.00000000}, {840,0.00008108}, {845,0.00000000}, {850,0.00003604}, {855,0.00006306}, {860,0.00002703}, {865,0.00006306}, {870,0.00005405}, {875,0.00002703}, {880,0.00002703}, {885,0.00000000}, {890,0.00000000}, {895,0.00008108}, {900,0.00000000}, {905,0.00006306}, {910,0.00000000}, {915,0.00000000}, {920,0.00006306}, {925,0.00006306}, {930,0.00005405}, {935,0.00005405}, {940,0.00003604}, {945,0.00000000}, {950,0.00002703}, {955,0.00005405}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00005405}, {980,0.00005405}, {985,0.00000000}, {990,0.00000000}, {995,0.00002703}, {1000,0.00000000}, {1010,0.00002703}, {1020,0.00013514}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00003636}, {1060,0.00002727}, {1070,0.00010000}, {1080,0.00002727}, {1090,0.00005455}, {1100,0.00006364}, {1110,0.00005455}, {1120,0.00002727}, {1130,0.00003636}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00002727}, {1170,0.00000000}, {1180,0.00009091}, {1190,0.00002727}, {1200,0.00002727}, {1210,0.00003636}, {1220,0.00005455}, {1230,0.00006364}, {1240,0.00009091}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00002727}, {1280,0.00006364}, {1290,0.00000000}, {1300,0.00007273}, {1310,0.00000000}, {1320,0.00003636}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00002727}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00003636}, {1410,0.00007273}, {1420,0.00003636}, {1430,0.00017273}, {1440,0.00003636}, {1450,0.00000000}, {1460,0.00007273}, {1470,0.00003636}, {1480,0.00003636}, {1490,0.00010909}, {1500,0.00006364}, {1510,0.00006364}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00006364}, {1560,0.00010000}, {1570,0.00010000}, {1580,0.00006364}, {1590,0.00000000}, {1600,0.00003636}, {1610,0.00000000}, {1620,0.00002727}, {1630,0.00002727}, {1640,0.00003636}, {1650,0.00003636}, {1660,0.00003636}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00003636}, {1700,0.00000000}, {1710,0.00003636}, {1720,0.00000000}, {1730,0.00006364}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00013636}, {1780,0.00000000}, {1790,0.00003636}, {1800,0.00005455}, {1810,0.00006364}, {1820,0.00000000}, {1830,0.00007273}, {1840,0.00010000}, {1850,0.00000000}, {1860,0.00003636}, {1870,0.00000000}, {1880,0.00003636}, {1890,0.00003636}, {1900,0.00003636}, {1910,0.00003636}, {1920,0.00005455}, {1930,0.00006364}, {1940,0.00002727}, {1950,0.00002727}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00006364}, {2100,0.00008182}, {2150,0.00006364}, {2200,0.00000000}, {2250,0.00003636}, {2300,0.00000000}, {2350,0.00006364}, {2400,0.00007273}, {2450,0.00002727}, {2500,0.00000000}, {2550,0.00006364}, {2600,0.00002727}, {2650,0.00003636}, {2700,0.00002727}, {2750,0.00003636}, {2800,0.00003636}, {2850,0.00006364}, {2900,0.00007273}, {2950,0.00006364}, {3000,0.00010000}, {3050,0.00000000}, {3100,0.00006364}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00003636}, {3300,0.00005455}, {3350,0.00003636}, {3400,0.00000000}, {3450,0.00005455}, {3500,0.00003636}, {3550,0.00007273}, {3600,0.00010000}, {3650,0.00006364}, {3700,0.00010000}, {3750,0.00000000}, {3800,0.00003636}, {3850,0.00000000}, {3900,0.00006364}, {3950,0.00006364}, {4000,0.00007273}, {4050,0.00003636}, {4100,0.00003636}, {4150,0.00003636}, {4200,0.00000000}, {4250,0.00010000}, {4300,0.00013636}, {4350,0.00003636}, {4400,0.00006364}, {4450,0.00003636}, {4500,0.00000000}, {4550,0.00003636}, {4600,0.00007273}, {4650,0.00006364}, {4700,0.00013636}, {4750,0.00000000}, {4800,0.00003636}, {4850,0.00003636}, {4900,0.00006364}, {4950,0.00002727}, {5000,0.00000000}, {5050,0.00010000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00002727}, {5250,0.00000000}, {5300,0.00007273}, {5350,0.00000000}, {5400,0.00003636}, {5450,0.00006364}, {5500,0.00014545}, {5550,0.00003636}, {5600,0.00000000}, {5650,0.00003636}, {5700,0.00007273}, {5750,0.00013636}, {5800,0.00005455}, {5850,0.00000000}, {5900,0.00003636}, {5950,0.00006364}, {6000,0.00006364}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00100}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00100}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00100}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00100}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00075}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00100}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00100}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00075}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00075}, {19700,0.00100}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresPHOAS"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00003604}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00003604}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00003604}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00003604}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00003604}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00003604}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00003604}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00003604}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00003636}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00003636}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresPHOAS"]["postprocess"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00300000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00002703}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00294595}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000901}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00001818}, {1120,0.00000909}, {1130,0.00001818}, {1140,0.00002727}, {1150,0.00001818}, {1160,0.00004545}, {1170,0.00002727}, {1180,0.00003636}, {1190,0.00000909}, {1200,0.00004545}, {1210,0.00005455}, {1220,0.00010000}, {1230,0.00009091}, {1240,0.00000000}, {1250,0.00011818}, {1260,0.00015455}, {1270,0.00012727}, {1280,0.00010000}, {1290,0.00016364}, {1300,0.00015455}, {1310,0.00012727}, {1320,0.00020000}, {1330,0.00023636}, {1340,0.00030909}, {1350,0.00023636}, {1360,0.00030909}, {1370,0.00029091}, {1380,0.00028182}, {1390,0.00028182}, {1400,0.00027273}, {1410,0.00038182}, {1420,0.00033636}, {1430,0.00042727}, {1440,0.00041818}, {1450,0.00041818}, {1460,0.00048182}, {1470,0.00048182}, {1480,0.00048182}, {1490,0.00001818}, {1500,0.00051818}, {1510,0.00050000}, {1520,0.00050000}, {1530,0.00051818}, {1540,0.00053636}, {1550,0.00066364}, {1560,0.00063636}, {1570,0.00070000}, {1580,0.00070909}, {1590,0.00068182}, {1600,0.00076364}, {1610,0.00081818}, {1620,0.00080000}, {1630,0.00085455}, {1640,0.00083636}, {1650,0.00082727}, {1660,0.00088182}, {1670,0.00090000}, {1680,0.00001818}, {1690,0.00090000}, {1700,0.00090909}, {1710,0.00093636}, {1720,0.00095455}, {1730,0.00097273}, {1740,0.00095455}, {1750,0.00097273}, {1760,0.00099091}, {1770,0.00098182}, {1780,0.00095455}, {1790,0.00096364}, {1800,0.00098182}, {1810,0.00099091}, {1820,0.00100000}, {1830,0.00100000}, {1840,0.00100000}, {1850,0.00100000}, {1860,0.00002727}, {1870,0.00100000}, {1880,0.00098182}, {1890,0.00100000}, {1900,0.00100000}, {1910,0.00100000}, {1920,0.00100000}, {1930,0.00043636}, {1940,0.00100909}, {1950,0.00100000}, {1960,0.00100000}, {1970,0.00100000}, {1980,0.00100000}, {1990,0.00100000}, {2000,0.00100000}, {2050,0.00103636}, {2100,0.00109091}, {2150,0.00113636}, {2200,0.00118182}, {2250,0.00128182}, {2300,0.00134545}, {2350,0.00160909}, {2400,0.00101818}, {2450,0.00166364}, {2500,0.00175455}, {2550,0.00180000}, {2600,0.00190909}, {2650,0.00189091}, {2700,0.00191818}, {2750,0.00192727}, {2800,0.00196364}, {2850,0.00195455}, {2900,0.00198182}, {2950,0.00198182}, {3000,0.00103636}, {3050,0.00202727}, {3100,0.00209091}, {3150,0.00217273}, {3200,0.00232727}, {3250,0.00247273}, {3300,0.00255455}, {3350,0.00259091}, {3400,0.00262727}, {3450,0.00103636}, {3500,0.00270000}, {3550,0.00275455}, {3600,0.00280909}, {3650,0.00291818}, {3700,0.00294545}, {3750,0.00297273}, {3800,0.00295455}, {3850,0.00094545}, {3900,0.00136364}, {3950,0.00300000}, {4000,0.00299091}, {4050,0.00275455}, {4100,0.00300909}, {4150,0.00313636}, {4200,0.00201818}, {4250,0.00322727}, {4300,0.00327273}, {4350,0.00354545}, {4400,0.00360000}, {4450,0.00370000}, {4500,0.00371818}, {4550,0.00374545}, {4600,0.00376364}, {4650,0.00376364}, {4700,0.00387273}, {4750,0.00384545}, {4800,0.00394545}, {4850,0.00393636}, {4900,0.00397273}, {4950,0.00398182}, {5000,0.00400000}, {5050,0.00401818}, {5100,0.00395455}, {5150,0.00110000}, {5200,0.00410909}, {5250,0.00413636}, {5300,0.00413636}, {5350,0.00418182}, {5400,0.00112727}, {5450,0.00430909}, {5500,0.00437273}, {5550,0.00290909}, {5600,0.00435455}, {5650,0.00142727}, {5700,0.00444545}, {5750,0.00280000}, {5800,0.00436364}, {5850,0.00315455}, {5900,0.00432727}, {5950,0.00316364}, {6000,0.00427273}, {6050,0.00450}, {6100,0.00425}, {6150,0.00450}, {6200,0.00500}, {6250,0.00350}, {6300,0.00375}, {6350,0.00500}, {6400,0.00500}, {6450,0.00500}, {6500,0.00500}, {6550,0.00500}, {6600,0.00400}, {6650,0.00525}, {6700,0.00375}, {6750,0.00500}, {6800,0.00550}, {6850,0.00575}, {6900,0.00575}, {6950,0.00600}, {7000,0.00600}, {7050,0.00375}, {7100,0.00600}, {7150,0.00500}, {7200,0.00550}, {7250,0.00350}, {7300,0.00600}, {7350,0.00600}, {7400,0.00450}, {7450,0.00475}, {7500,0.00475}, {7550,0.00500}, {7600,0.00600}, {7650,0.00475}, {7700,0.00600}, {7750,0.00600}, {7800,0.00500}, {7850,0.00650}, {7900,0.00625}, {7950,0.00600}, {8000,0.00450}, {8050,0.00650}, {8100,0.00575}, {8150,0.00675}, {8200,0.00625}, {8250,0.00525}, {8300,0.00575}, {8350,0.00675}, {8400,0.00500}, {8450,0.00450}, {8500,0.00625}, {8550,0.00500}, {8600,0.00525}, {8650,0.00400}, {8700,0.00600}, {8750,0.00675}, {8800,0.00525}, {8850,0.00425}, {8900,0.00675}, {8950,0.00450}, {9000,0.00675}, {9050,0.00650}, {9100,0.00675}, {9150,0.00500}, {9200,0.00500}, {9250,0.00600}, {9300,0.00375}, {9350,0.00375}, {9400,0.00700}, {9450,0.00700}, {9500,0.00700}, {9550,0.00375}, {9600,0.00700}, {9650,0.00700}, {9700,0.00700}, {9750,0.00650}, {9800,0.00575}, {9850,0.00525}, {9900,0.00750}, {9950,0.00700}, {10000,0.00725}, {10100,0.00750}, {10200,0.00750}, {10300,0.00475}, {10400,0.00800}, {10500,0.00750}, {10600,0.00800}, {10700,0.00800}, {10800,0.00750}, {10900,0.00700}, {11000,0.00825}, {11100,0.00825}, {11200,0.00550}, {11300,0.00700}, {11400,0.00350}, {11500,0.00800}, {11600,0.00725}, {11700,0.00825}, {11800,0.00475}, {11900,0.00825}, {12000,0.00600}, {12100,0.00850}, {12200,0.00825}, {12300,0.00775}, {12400,0.00500}, {12500,0.00950}, {12600,0.00975}, {12700,0.00925}, {12800,0.00625}, {12900,0.00750}, {13000,0.00925}, {13100,0.01000}, {13200,0.00750}, {13300,0.00775}, {13400,0.00925}, {13500,0.00900}, {13600,0.01025}, {13700,0.01075}, {13800,0.00675}, {13900,0.01075}, {14000,0.00800}, {14100,0.00975}, {14200,0.00775}, {14300,0.00750}, {14400,0.01225}, {14500,0.00725}, {14600,0.00800}, {14700,0.00850}, {14800,0.00625}, {14900,0.01025}, {15000,0.01250}, {15100,0.01225}, {15200,0.00900}, {15300,0.00725}, {15400,0.01250}, {15500,0.00875}, {15600,0.01225}, {15700,0.01200}, {15800,0.00900}, {15900,0.00875}, {16000,0.01250}, {16100,0.01175}, {16200,0.00775}, {16300,0.01025}, {16400,0.01250}, {16500,0.00550}, {16600,0.00900}, {16700,0.01300}, {16800,0.01300}, {16900,0.00900}, {17000,0.01275}, {17100,0.01000}, {17200,0.01075}, {17300,0.01200}, {17400,0.01350}, {17500,0.01200}, {17600,0.01125}, {17700,0.01100}, {17800,0.01475}, {17900,0.00975}, {18000,0.01100}, {18100,0.00725}, {18200,0.01350}, {18300,0.01025}, {18400,0.00825}, {18500,0.01300}, {18600,0.01075}, {18700,0.01475}, {18800,0.01425}, {18900,0.01250}, {19000,0.00750}, {19100,0.01525}, {19200,0.01525}, {19300,0.00750}, {19400,0.01100}, {19500,0.01100}, {19600,0.01350}, {19700,0.00850}, {19800,0.01300}, {19900,0.01425}, {20000,0.0080}};
data["big_flat"]["CanonicalStructuresPHOAS"]["postprocess"]["user"] = {{1,0.00005405}, {2,0.00008108}, {3,0.00003604}, {4,0.00003604}, {5,0.00000000}, {6,0.00000000}, {7,0.00005405}, {8,0.00000000}, {9,0.00002703}, {10,0.00002703}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00009009}, {16,0.00002703}, {17,0.00006306}, {18,0.00002703}, {19,0.00002703}, {20,0.00005405}, {21,0.00000000}, {22,0.00002703}, {23,0.00000000}, {24,0.00006306}, {25,0.00003604}, {26,0.00006306}, {27,0.00003604}, {28,0.00006306}, {29,0.00003604}, {30,0.00007207}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00003604}, {36,0.00006306}, {37,0.00007207}, {38,0.00002703}, {39,0.00000000}, {40,0.00002703}, {41,0.00000000}, {42,0.00006306}, {43,0.00000000}, {44,0.00002703}, {45,0.00003604}, {46,0.00000000}, {47,0.00005405}, {48,0.00002703}, {49,0.00000000}, {50,0.00009910}, {51,0.00006306}, {52,0.00006306}, {53,0.00002703}, {54,0.00000000}, {55,0.00003604}, {56,0.00000000}, {57,0.00002703}, {58,0.00002703}, {59,0.00000000}, {60,0.00002703}, {61,0.00000000}, {62,0.00003604}, {63,0.00003604}, {64,0.00003604}, {65,0.00000000}, {66,0.00000000}, {67,0.00003604}, {68,0.00005405}, {69,0.00010811}, {70,0.00000000}, {71,0.00005405}, {72,0.00006306}, {73,0.00000000}, {74,0.00002703}, {75,0.00002703}, {76,0.00002703}, {77,0.00003604}, {78,0.00002703}, {79,0.00009009}, {80,0.00000000}, {81,0.00002703}, {82,0.00000000}, {83,0.00002703}, {84,0.00002703}, {85,0.00000000}, {86,0.00002703}, {87,0.00002703}, {88,0.00007207}, {89,0.00009009}, {90,0.00007207}, {91,0.00002703}, {92,0.00000000}, {93,0.00002703}, {94,0.00009910}, {95,0.00006306}, {96,0.00000000}, {97,0.00002703}, {98,0.00002703}, {99,0.00005405}, {100,0.00012613}, {101,0.00003604}, {102,0.00003604}, {103,0.00003604}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00003604}, {108,0.00002703}, {109,0.00000000}, {110,0.00000000}, {111,0.00006306}, {112,0.00000000}, {113,0.00008108}, {114,0.00006306}, {115,0.00006306}, {116,0.00005405}, {117,0.00000000}, {118,0.00002703}, {119,0.00005405}, {120,0.00006306}, {121,0.00000000}, {122,0.00006306}, {123,0.00007207}, {124,0.00009910}, {125,0.00005405}, {126,0.00000000}, {127,0.00002703}, {128,0.00009009}, {129,0.00002703}, {130,0.00002703}, {131,0.00000000}, {132,0.00005405}, {133,0.00005405}, {134,0.00000000}, {135,0.00005405}, {136,0.00002703}, {137,0.00000000}, {138,0.00002703}, {139,0.00011712}, {140,0.00002703}, {141,0.00000000}, {142,0.00000000}, {143,0.00002703}, {144,0.00002703}, {145,0.00002703}, {146,0.00009910}, {147,0.00009910}, {148,0.00008108}, {149,0.00006306}, {150,0.00003604}, {151,0.00002703}, {152,0.00008108}, {153,0.00000000}, {154,0.00005405}, {155,0.00000000}, {156,0.00017117}, {157,0.00000000}, {158,0.00005405}, {159,0.00003604}, {160,0.00012613}, {161,0.00000000}, {162,0.00003604}, {163,0.00002703}, {164,0.00011712}, {165,0.00002703}, {166,0.00006306}, {167,0.00006306}, {168,0.00003604}, {169,0.00000000}, {170,0.00002703}, {171,0.00003604}, {172,0.00012613}, {173,0.00007207}, {174,0.00011712}, {175,0.00003604}, {176,0.00002703}, {177,0.00002703}, {178,0.00006306}, {179,0.00002703}, {180,0.00008108}, {181,0.00006306}, {182,0.00009910}, {183,0.00006306}, {184,0.00005405}, {185,0.00011712}, {186,0.00002703}, {187,0.00012613}, {188,0.00002703}, {189,0.00009910}, {190,0.00007207}, {191,0.00006306}, {192,0.00005405}, {193,0.00006306}, {194,0.00000000}, {195,0.00002703}, {196,0.00006306}, {197,0.00002703}, {198,0.00010811}, {199,0.00011712}, {200,0.00000000}, {201,0.00006306}, {202,0.00002703}, {203,0.00003604}, {204,0.00000000}, {205,0.00002703}, {206,0.00009009}, {207,0.00007207}, {208,0.00006306}, {209,0.00000000}, {210,0.00003604}, {211,0.00009910}, {212,0.00011712}, {213,0.00002703}, {214,0.00002703}, {215,0.00009910}, {216,0.00006306}, {217,0.00007207}, {218,0.00006306}, {219,0.00006306}, {220,0.00013514}, {221,0.00002703}, {222,0.00008108}, {223,0.00008108}, {224,0.00012613}, {225,0.00009009}, {226,0.00002703}, {227,0.00009009}, {228,0.00000000}, {229,0.00009009}, {230,0.00009009}, {231,0.00000000}, {232,0.00008108}, {233,0.00012613}, {234,0.00012613}, {235,0.00005405}, {236,0.00009910}, {237,0.00000000}, {238,0.00008108}, {239,0.00013514}, {240,0.00002703}, {241,0.00005405}, {242,0.00015315}, {243,0.00016216}, {244,0.00017117}, {245,0.00003604}, {246,0.00002703}, {247,0.00009009}, {248,0.00005405}, {249,0.00008108}, {250,0.00022523}, {251,0.00008108}, {252,0.00000000}, {253,0.00008108}, {254,0.00009009}, {255,0.00011712}, {256,0.00013514}, {257,0.00003604}, {258,0.00003604}, {259,0.00010811}, {260,0.00005405}, {261,0.00009910}, {262,0.00003604}, {263,0.00011712}, {264,0.00009910}, {265,0.00006306}, {266,0.00008108}, {267,0.00010811}, {268,0.00018018}, {269,0.00007207}, {270,0.00005405}, {271,0.00002703}, {272,0.00019820}, {273,0.00009009}, {274,0.00005405}, {275,0.00011712}, {276,0.00014414}, {277,0.00023423}, {278,0.00000000}, {279,0.00005405}, {280,0.00005405}, {281,0.00020721}, {282,0.00009009}, {283,0.00008108}, {284,0.00007207}, {285,0.00009910}, {286,0.00011712}, {287,0.00002703}, {288,0.00005405}, {289,0.00011712}, {290,0.00002703}, {291,0.00014414}, {292,0.00015315}, {293,0.00015315}, {294,0.00006306}, {295,0.00003604}, {296,0.00005405}, {297,0.00005405}, {298,0.00015315}, {299,0.00003604}, {300,0.00005405}, {301,0.00013514}, {302,0.00000000}, {303,0.00002703}, {304,0.00006306}, {305,0.00008108}, {306,0.00002703}, {307,0.00010811}, {308,0.00014414}, {309,0.00012613}, {310,0.00008108}, {311,0.00009910}, {312,0.00017117}, {313,0.00011712}, {314,0.00005405}, {315,0.00308108}, {316,0.00009910}, {317,0.00009910}, {318,0.00010811}, {319,0.00002703}, {320,0.00018919}, {321,0.00014414}, {322,0.00002703}, {323,0.00008108}, {324,0.00005405}, {325,0.00008108}, {326,0.00005405}, {327,0.00017117}, {328,0.00015315}, {329,0.00015315}, {330,0.00012613}, {331,0.00012613}, {332,0.00008108}, {333,0.00011712}, {334,0.00009910}, {335,0.00007207}, {336,0.00000000}, {337,0.00013514}, {338,0.00018018}, {339,0.00009009}, {340,0.00017117}, {341,0.00014414}, {342,0.00022523}, {343,0.00018018}, {344,0.00003604}, {345,0.00011712}, {346,0.00012613}, {347,0.00014414}, {348,0.00005405}, {349,0.00018919}, {350,0.00002703}, {351,0.00012613}, {352,0.00010811}, {353,0.00005405}, {354,0.00012613}, {355,0.00009009}, {356,0.00025225}, {357,0.00008108}, {358,0.00022523}, {359,0.00018018}, {360,0.00008108}, {361,0.00012613}, {362,0.00020721}, {363,0.00016216}, {364,0.00009009}, {365,0.00022523}, {366,0.00008108}, {367,0.00019820}, {368,0.00009009}, {369,0.00013514}, {370,0.00009009}, {371,0.00007207}, {372,0.00012613}, {373,0.00010811}, {374,0.00015315}, {375,0.00003604}, {376,0.00002703}, {377,0.00024324}, {378,0.00015315}, {379,0.00016216}, {380,0.00020721}, {381,0.00015315}, {382,0.00013514}, {383,0.00023423}, {384,0.00000000}, {385,0.00014414}, {386,0.00010811}, {387,0.00013514}, {388,0.00022523}, {389,0.00011712}, {390,0.00010811}, {391,0.00032432}, {392,0.00022523}, {393,0.00019820}, {394,0.00016216}, {395,0.00026126}, {396,0.00008108}, {397,0.00026126}, {398,0.00011712}, {399,0.00014414}, {400,0.00014414}, {401,0.00014414}, {402,0.00016216}, {403,0.00005405}, {404,0.00018018}, {405,0.00028829}, {406,0.00013514}, {407,0.00019820}, {408,0.00009009}, {409,0.00009009}, {410,0.00006306}, {411,0.00018018}, {412,0.00015315}, {413,0.00022523}, {414,0.00010811}, {415,0.00021622}, {416,0.00014414}, {417,0.00020721}, {418,0.00006306}, {419,0.00023423}, {420,0.00025225}, {421,0.00009009}, {422,0.00287387}, {423,0.00026126}, {424,0.00011712}, {425,0.00018018}, {426,0.00023423}, {427,0.00030631}, {428,0.00018018}, {429,0.00015315}, {430,0.00012613}, {431,0.00015315}, {432,0.00009009}, {433,0.00028829}, {434,0.00024324}, {435,0.00021622}, {436,0.00016216}, {437,0.00018018}, {438,0.00008108}, {439,0.00020721}, {440,0.00021622}, {441,0.00027027}, {442,0.00020721}, {443,0.00011712}, {444,0.00026126}, {445,0.00019820}, {446,0.00017117}, {447,0.00020721}, {448,0.00009009}, {449,0.00019820}, {450,0.00012613}, {451,0.00018018}, {452,0.00011712}, {453,0.00009009}, {454,0.00020721}, {455,0.00021622}, {456,0.00018919}, {457,0.00006306}, {458,0.00014414}, {459,0.00034234}, {460,0.00008108}, {461,0.00017117}, {462,0.00012613}, {463,0.00024324}, {464,0.00023423}, {465,0.00027928}, {466,0.00013514}, {467,0.00032432}, {468,0.00031532}, {469,0.00018018}, {470,0.00016216}, {471,0.00011712}, {472,0.00005405}, {473,0.00015315}, {474,0.00046847}, {475,0.00016216}, {476,0.00005405}, {477,0.00018919}, {478,0.00011712}, {479,0.00020721}, {480,0.00014414}, {481,0.00017117}, {482,0.00021622}, {483,0.00019820}, {484,0.00018919}, {485,0.00011712}, {486,0.00013514}, {487,0.00024324}, {488,0.00018919}, {489,0.00018919}, {490,0.00018919}, {491,0.00019820}, {492,0.00018919}, {493,0.00010811}, {494,0.00015315}, {495,0.00009910}, {496,0.00012613}, {497,0.00032432}, {498,0.00036036}, {499,0.00014414}, {500,0.00009009}, {505,0.00037838}, {510,0.00027027}, {515,0.00036937}, {520,0.00019820}, {525,0.00010811}, {530,0.00018919}, {535,0.00032432}, {540,0.00018018}, {545,0.00027027}, {550,0.00020721}, {555,0.00014414}, {560,0.00027928}, {565,0.00021622}, {570,0.00018919}, {575,0.00018919}, {580,0.00027027}, {585,0.00036937}, {590,0.00023423}, {595,0.00026126}, {600,0.00024324}, {605,0.00037838}, {610,0.00030631}, {615,0.00024324}, {620,0.00043243}, {625,0.00010811}, {630,0.00027027}, {635,0.00038739}, {640,0.00015315}, {645,0.00011712}, {650,0.00019820}, {655,0.00035135}, {660,0.00031532}, {665,0.00031532}, {670,0.00034234}, {675,0.00015315}, {680,0.00037838}, {685,0.00036937}, {690,0.00030631}, {695,0.00041441}, {700,0.00018919}, {705,0.00035135}, {710,0.00047748}, {715,0.00027027}, {720,0.00036036}, {725,0.00039640}, {730,0.00052252}, {735,0.00039640}, {740,0.00043243}, {745,0.00023423}, {750,0.00036937}, {755,0.00029730}, {760,0.00017117}, {765,0.00037838}, {770,0.00017117}, {775,0.00040541}, {780,0.00060360}, {785,0.00052252}, {790,0.00028829}, {795,0.00054054}, {800,0.00039640}, {805,0.00048649}, {810,0.00057658}, {815,0.00037838}, {820,0.00037838}, {825,0.00037838}, {830,0.00054054}, {835,0.00025225}, {840,0.00032432}, {845,0.00044144}, {850,0.00041441}, {855,0.00045045}, {860,0.00018018}, {865,0.00043243}, {870,0.00037838}, {875,0.00032432}, {880,0.00021622}, {885,0.00045946}, {890,0.00042342}, {895,0.00036036}, {900,0.00045946}, {905,0.00053153}, {910,0.00037838}, {915,0.00054955}, {920,0.00036937}, {925,0.00044144}, {930,0.00038739}, {935,0.00043243}, {940,0.00040541}, {945,0.00054955}, {950,0.00063063}, {955,0.00050450}, {960,0.00042342}, {965,0.00052252}, {970,0.00062162}, {975,0.00050450}, {980,0.00060360}, {985,0.00064865}, {990,0.00043243}, {995,0.00038739}, {1000,0.00054054}, {1010,0.00034234}, {1020,0.00057658}, {1030,0.00052252}, {1040,0.00050450}, {1050,0.00046364}, {1060,0.00051818}, {1070,0.00041818}, {1080,0.00060909}, {1090,0.00061818}, {1100,0.00075455}, {1110,0.00051818}, {1120,0.00068182}, {1130,0.00077273}, {1140,0.00059091}, {1150,0.00080000}, {1160,0.00058182}, {1170,0.00094545}, {1180,0.00043636}, {1190,0.00083636}, {1200,0.00071818}, {1210,0.00062727}, {1220,0.00053636}, {1230,0.00062727}, {1240,0.00024545}, {1250,0.00069091}, {1260,0.00083636}, {1270,0.00060000}, {1280,0.00078182}, {1290,0.00076364}, {1300,0.00065455}, {1310,0.00072727}, {1320,0.00088182}, {1330,0.00060909}, {1340,0.00061818}, {1350,0.00072727}, {1360,0.00068182}, {1370,0.00093636}, {1380,0.00090909}, {1390,0.00052727}, {1400,0.00085455}, {1410,0.00099091}, {1420,0.00062727}, {1430,0.00060909}, {1440,0.00111818}, {1450,0.00096364}, {1460,0.00084545}, {1470,0.00061818}, {1480,0.00095455}, {1490,0.00050909}, {1500,0.00069091}, {1510,0.00079091}, {1520,0.00115455}, {1530,0.00083636}, {1540,0.00128182}, {1550,0.00080000}, {1560,0.00083636}, {1570,0.00101818}, {1580,0.00108182}, {1590,0.00107273}, {1600,0.00089091}, {1610,0.00131818}, {1620,0.00109091}, {1630,0.00111818}, {1640,0.00111818}, {1650,0.00123636}, {1660,0.00091818}, {1670,0.00155455}, {1680,0.00049091}, {1690,0.00120909}, {1700,0.00115455}, {1710,0.00115455}, {1720,0.00090000}, {1730,0.00098182}, {1740,0.00137273}, {1750,0.00113636}, {1760,0.00104545}, {1770,0.00111818}, {1780,0.00133636}, {1790,0.00110000}, {1800,0.00127273}, {1810,0.00089091}, {1820,0.00148182}, {1830,0.00132727}, {1840,0.00133636}, {1850,0.00130909}, {1860,0.00072727}, {1870,0.00110000}, {1880,0.00136364}, {1890,0.00121818}, {1900,0.00132727}, {1910,0.00130909}, {1920,0.00133636}, {1930,0.00101818}, {1940,0.00137273}, {1950,0.00140909}, {1960,0.00188182}, {1970,0.00134545}, {1980,0.00152727}, {1990,0.00119091}, {2000,0.00136364}, {2050,0.00157273}, {2100,0.00142727}, {2150,0.00173636}, {2200,0.00143636}, {2250,0.00130909}, {2300,0.00200909}, {2350,0.00195455}, {2400,0.00170909}, {2450,0.00153636}, {2500,0.00213636}, {2550,0.00183636}, {2600,0.00221818}, {2650,0.00244545}, {2700,0.00217273}, {2750,0.00227273}, {2800,0.00188182}, {2850,0.00209091}, {2900,0.00240000}, {2950,0.00250909}, {3000,0.00160000}, {3050,0.00236364}, {3100,0.00257273}, {3150,0.00278182}, {3200,0.00248182}, {3250,0.00252727}, {3300,0.00270000}, {3350,0.00260909}, {3400,0.00274545}, {3450,0.00153636}, {3500,0.00290000}, {3550,0.00281818}, {3600,0.00275455}, {3650,0.00300909}, {3700,0.00308182}, {3750,0.00319091}, {3800,0.00315455}, {3850,0.00111818}, {3900,0.00163636}, {3950,0.00324545}, {4000,0.00324545}, {4050,0.00294545}, {4100,0.00326364}, {4150,0.00350909}, {4200,0.00200909}, {4250,0.00340909}, {4300,0.00348182}, {4350,0.00371818}, {4400,0.00373636}, {4450,0.00367273}, {4500,0.00380000}, {4550,0.00378182}, {4600,0.00380909}, {4650,0.00386364}, {4700,0.00389091}, {4750,0.00410000}, {4800,0.00398182}, {4850,0.00381818}, {4900,0.00399091}, {4950,0.00410000}, {5000,0.00430000}, {5050,0.00400909}, {5100,0.00415455}, {5150,0.00172727}, {5200,0.00415455}, {5250,0.00420909}, {5300,0.00440909}, {5350,0.00440000}, {5400,0.00158182}, {5450,0.00424545}, {5500,0.00424545}, {5550,0.00331818}, {5600,0.00457273}, {5650,0.00205455}, {5700,0.00443636}, {5750,0.00291818}, {5800,0.00442727}, {5850,0.00338182}, {5900,0.00445455}, {5950,0.00313636}, {6000,0.00449091}, {6050,0.00425}, {6100,0.00400}, {6150,0.00400}, {6200,0.00550}, {6250,0.00200}, {6300,0.00275}, {6350,0.00475}, {6400,0.00475}, {6450,0.00450}, {6500,0.00600}, {6550,0.00475}, {6600,0.00500}, {6650,0.00450}, {6700,0.00500}, {6750,0.00700}, {6800,0.00400}, {6850,0.00550}, {6900,0.00600}, {6950,0.00575}, {7000,0.00550}, {7050,0.00425}, {7100,0.00600}, {7150,0.00750}, {7200,0.00450}, {7250,0.00575}, {7300,0.00475}, {7350,0.00500}, {7400,0.00550}, {7450,0.00500}, {7500,0.00475}, {7550,0.00475}, {7600,0.00475}, {7650,0.00500}, {7700,0.00775}, {7750,0.00775}, {7800,0.00500}, {7850,0.00575}, {7900,0.00775}, {7950,0.00575}, {8000,0.00375}, {8050,0.00625}, {8100,0.00700}, {8150,0.00800}, {8200,0.00600}, {8250,0.00575}, {8300,0.00500}, {8350,0.00550}, {8400,0.00550}, {8450,0.00500}, {8500,0.00700}, {8550,0.00500}, {8600,0.00575}, {8650,0.00575}, {8700,0.00700}, {8750,0.00750}, {8800,0.00375}, {8850,0.00400}, {8900,0.00675}, {8950,0.00550}, {9000,0.00750}, {9050,0.00675}, {9100,0.00775}, {9150,0.00375}, {9200,0.00575}, {9250,0.00650}, {9300,0.00375}, {9350,0.00475}, {9400,0.00700}, {9450,0.00775}, {9500,0.00750}, {9550,0.00400}, {9600,0.00775}, {9650,0.00700}, {9700,0.00775}, {9750,0.00550}, {9800,0.00575}, {9850,0.00450}, {9900,0.00775}, {9950,0.00650}, {10000,0.00800}, {10100,0.00725}, {10200,0.00850}, {10300,0.00375}, {10400,0.00750}, {10500,0.00800}, {10600,0.00775}, {10700,0.00750}, {10800,0.00575}, {10900,0.00750}, {11000,0.00850}, {11100,0.00850}, {11200,0.00750}, {11300,0.00650}, {11400,0.00500}, {11500,0.00700}, {11600,0.00775}, {11700,0.00775}, {11800,0.00550}, {11900,0.00800}, {12000,0.00700}, {12100,0.00750}, {12200,0.00950}, {12300,0.00775}, {12400,0.00575}, {12500,0.00950}, {12600,0.00950}, {12700,0.00975}, {12800,0.00550}, {12900,0.00550}, {13000,0.00975}, {13100,0.01050}, {13200,0.00750}, {13300,0.00625}, {13400,0.01075}, {13500,0.00850}, {13600,0.01175}, {13700,0.00875}, {13800,0.00725}, {13900,0.01050}, {14000,0.00800}, {14100,0.01000}, {14200,0.00850}, {14300,0.00900}, {14400,0.01350}, {14500,0.00675}, {14600,0.00875}, {14700,0.00875}, {14800,0.00600}, {14900,0.00875}, {15000,0.01150}, {15100,0.01100}, {15200,0.00825}, {15300,0.00800}, {15400,0.01225}, {15500,0.00950}, {15600,0.01250}, {15700,0.01100}, {15800,0.00775}, {15900,0.01050}, {16000,0.01275}, {16100,0.01025}, {16200,0.00675}, {16300,0.00975}, {16400,0.01150}, {16500,0.00450}, {16600,0.00975}, {16700,0.01475}, {16800,0.01300}, {16900,0.00775}, {17000,0.01250}, {17100,0.00925}, {17200,0.01025}, {17300,0.01375}, {17400,0.01475}, {17500,0.01250}, {17600,0.01125}, {17700,0.01050}, {17800,0.01450}, {17900,0.00950}, {18000,0.01100}, {18100,0.00850}, {18200,0.01325}, {18300,0.01025}, {18400,0.00975}, {18500,0.01225}, {18600,0.01175}, {18700,0.01550}, {18800,0.01350}, {18900,0.01225}, {19000,0.00950}, {19100,0.01500}, {19200,0.01475}, {19300,0.00675}, {19400,0.01150}, {19500,0.00950}, {19600,0.01300}, {19700,0.00750}, {19800,0.01275}, {19900,0.01400}, {20000,0.0075}};
data["big_flat"]["CanonicalStructuresPHOAS"]["postprocess"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00003604}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00003604}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00003604}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00003604}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00003604}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00003604}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00002703}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00003604}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00003604}, {398,0.00000000}, {399,0.00003604}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00007207}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00003604}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00007207}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00007207}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00003604}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00003604}, {865,0.00000000}, {870,0.00000000}, {875,0.00003604}, {880,0.00000000}, {885,0.00000000}, {890,0.00003604}, {895,0.00002703}, {900,0.00003604}, {905,0.00003604}, {910,0.00000000}, {915,0.00000000}, {920,0.00003604}, {925,0.00000000}, {930,0.00003604}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00003604}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00007273}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00003636}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00003636}, {1240,0.00003636}, {1250,0.00000000}, {1260,0.00003636}, {1270,0.00003636}, {1280,0.00000000}, {1290,0.00003636}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00003636}, {1330,0.00003636}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00003636}, {1440,0.00003636}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003636}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00003636}, {1540,0.00003636}, {1550,0.00000000}, {1560,0.00003636}, {1570,0.00002727}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00003636}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003636}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00003636}, {1760,0.00002727}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00003636}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00003636}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00003636}, {1980,0.00003636}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00006364}, {2600,0.00000000}, {2650,0.00003636}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00003636}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00003636}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00003636}, {4050,0.00003636}, {4100,0.00003636}, {4150,0.00000000}, {4200,0.00003636}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00007273}, {4500,0.00000000}, {4550,0.00003636}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00003636}, {4750,0.00003636}, {4800,0.00000000}, {4850,0.00007273}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00007273}, {5100,0.00007273}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00003636}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00003636}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00003636}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00100}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00100}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresPHOAS"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000901}, {54,0.00001802}, {55,0.00001802}, {56,0.00002703}, {57,0.00007207}, {58,0.00007207}, {59,0.00018919}, {60,0.00018919}, {61,0.00039640}, {62,0.00045946}, {63,0.00072072}, {64,0.00061261}, {65,0.00081081}, {66,0.00090991}, {67,0.00097297}, {68,0.00097297}, {69,0.00100000}, {70,0.00100000}, {71,0.00100000}, {72,0.00100000}, {73,0.00100000}, {74,0.00100000}, {75,0.00100000}, {76,0.00100000}, {77,0.00100000}, {78,0.00100000}, {79,0.00100000}, {80,0.00100000}, {81,0.00100000}, {82,0.00100000}, {83,0.00100000}, {84,0.00100000}, {85,0.00100000}, {86,0.00100000}, {87,0.00100000}, {88,0.00100000}, {89,0.00100000}, {90,0.00100000}, {91,0.00100000}, {92,0.00100000}, {93,0.00100000}, {94,0.00100000}, {95,0.00100000}, {96,0.00100000}, {97,0.00100000}, {98,0.00100000}, {99,0.00100000}, {100,0.00100000}, {101,0.00100000}, {102,0.00100000}, {103,0.00100000}, {104,0.00100000}, {105,0.00100000}, {106,0.00100000}, {107,0.00100000}, {108,0.00100000}, {109,0.00101802}, {110,0.00100000}, {111,0.00100000}, {112,0.00100000}, {113,0.00100000}, {114,0.00100000}, {115,0.00100000}, {116,0.00100000}, {117,0.00100000}, {118,0.00100000}, {119,0.00100000}, {120,0.00100000}, {121,0.00100000}, {122,0.00100000}, {123,0.00100000}, {124,0.00100000}, {125,0.00100000}, {126,0.00100000}, {127,0.00100000}, {128,0.00100000}, {129,0.00100000}, {130,0.00100000}, {131,0.00100000}, {132,0.00100000}, {133,0.00100000}, {134,0.00100000}, {135,0.00100000}, {136,0.00100000}, {137,0.00100000}, {138,0.00100000}, {139,0.00100000}, {140,0.00100000}, {141,0.00100000}, {142,0.00100000}, {143,0.00100000}, {144,0.00100000}, {145,0.00100000}, {146,0.00100000}, {147,0.00100000}, {148,0.00100000}, {149,0.00100000}, {150,0.00100000}, {151,0.00100000}, {152,0.00100000}, {153,0.00100000}, {154,0.00100000}, {155,0.00100000}, {156,0.00101802}, {157,0.00100000}, {158,0.00100000}, {159,0.00100901}, {160,0.00100000}, {161,0.00100000}, {162,0.00100000}, {163,0.00100000}, {164,0.00100000}, {165,0.00100000}, {166,0.00101802}, {167,0.00100000}, {168,0.00100901}, {169,0.00103604}, {170,0.00100901}, {171,0.00100901}, {172,0.00104505}, {173,0.00108108}, {174,0.00113514}, {175,0.00126126}, {176,0.00115315}, {177,0.00120721}, {178,0.00120721}, {179,0.00138739}, {180,0.00128829}, {181,0.00161261}, {182,0.00159459}, {183,0.00179279}, {184,0.00159459}, {185,0.00182883}, {186,0.00181081}, {187,0.00197297}, {188,0.00205405}, {189,0.00197297}, {190,0.00200000}, {191,0.00200000}, {192,0.00182883}, {193,0.00195495}, {194,0.00194595}, {195,0.00200000}, {196,0.00200000}, {197,0.00200000}, {198,0.00200000}, {199,0.00200000}, {200,0.00200000}, {201,0.00200000}, {202,0.00201802}, {203,0.00200000}, {204,0.00200000}, {205,0.00200000}, {206,0.00200000}, {207,0.00200000}, {208,0.00200000}, {209,0.00200000}, {210,0.00200000}, {211,0.00298198}, {212,0.00200000}, {213,0.00200000}, {214,0.00200000}, {215,0.00200000}, {216,0.00200000}, {217,0.00200000}, {218,0.00200000}, {219,0.00200000}, {220,0.00200000}, {221,0.00200000}, {222,0.00200000}, {223,0.00200000}, {224,0.00200000}, {225,0.00200000}, {226,0.00200000}, {227,0.00200000}, {228,0.00200000}, {229,0.00200000}, {230,0.00200000}, {231,0.00200000}, {232,0.00200000}, {233,0.00201802}, {234,0.00200000}, {235,0.00200000}, {236,0.00200000}, {237,0.00200000}, {238,0.00200000}, {239,0.00200000}, {240,0.00200000}, {241,0.00200000}, {242,0.00200000}, {243,0.00200000}, {244,0.00200000}, {245,0.00200000}, {246,0.00200000}, {247,0.00200000}, {248,0.00200000}, {249,0.00200000}, {250,0.00200000}, {251,0.00200000}, {252,0.00200000}, {253,0.00200000}, {254,0.00201802}, {255,0.00200000}, {256,0.00200000}, {257,0.00200000}, {258,0.00200000}, {259,0.00200000}, {260,0.00200000}, {261,0.00200000}, {262,0.00200000}, {263,0.00200000}, {264,0.00200000}, {265,0.00200000}, {266,0.00200000}, {267,0.00200000}, {268,0.00200000}, {269,0.00200000}, {270,0.00200000}, {271,0.00200901}, {272,0.00200000}, {273,0.00200000}, {274,0.00200000}, {275,0.00202703}, {276,0.00200000}, {277,0.00201802}, {278,0.00200901}, {279,0.00205405}, {280,0.00202703}, {281,0.00206306}, {282,0.00205405}, {283,0.00209009}, {284,0.00209910}, {285,0.00218919}, {286,0.00201802}, {287,0.00241441}, {288,0.00202703}, {289,0.00206306}, {290,0.00210811}, {291,0.00228829}, {292,0.00218018}, {293,0.00232432}, {294,0.00241441}, {295,0.00267568}, {296,0.00227928}, {297,0.00254054}, {298,0.00260360}, {299,0.00286486}, {300,0.00274775}, {301,0.00289189}, {302,0.00292793}, {303,0.00295495}, {304,0.00274775}, {305,0.00286486}, {306,0.00288288}, {307,0.00295495}, {308,0.00292793}, {309,0.00298198}, {310,0.00300000}, {311,0.00300000}, {312,0.00299099}, {313,0.00300000}, {314,0.00300000}, {315,0.00300000}, {316,0.00300000}, {317,0.00300000}, {318,0.00300000}, {319,0.00513514}, {320,0.00299099}, {321,0.00300000}, {322,0.00300000}, {323,0.00300000}, {324,0.00300000}, {325,0.00300000}, {326,0.00300000}, {327,0.00300000}, {328,0.00300000}, {329,0.00300000}, {330,0.00304505}, {331,0.00300000}, {332,0.00300000}, {333,0.00300000}, {334,0.00300000}, {335,0.00300000}, {336,0.00300000}, {337,0.00300000}, {338,0.00300000}, {339,0.00300000}, {340,0.00300000}, {341,0.00300000}, {342,0.00562162}, {343,0.00300000}, {344,0.00300000}, {345,0.00300000}, {346,0.00300000}, {347,0.00300000}, {348,0.00300000}, {349,0.00300000}, {350,0.00300000}, {351,0.00300000}, {352,0.00300000}, {353,0.00300000}, {354,0.00300000}, {355,0.00300000}, {356,0.00300000}, {357,0.00300000}, {358,0.00300000}, {359,0.00300000}, {360,0.00300000}, {361,0.00300000}, {362,0.00300000}, {363,0.00300000}, {364,0.00300000}, {365,0.00303604}, {366,0.00300901}, {367,0.00300901}, {368,0.00300000}, {369,0.00300000}, {370,0.00300000}, {371,0.00300000}, {372,0.00300000}, {373,0.00300000}, {374,0.00300000}, {375,0.00300901}, {376,0.00300000}, {377,0.00300901}, {378,0.00300901}, {379,0.00303604}, {380,0.00300901}, {381,0.00305405}, {382,0.00301802}, {383,0.00309009}, {384,0.00300000}, {385,0.00552252}, {386,0.00300000}, {387,0.00300000}, {388,0.00301802}, {389,0.00302703}, {390,0.00301802}, {391,0.00304505}, {392,0.00301802}, {393,0.00303604}, {394,0.00309009}, {395,0.00315315}, {396,0.00310811}, {397,0.00318919}, {398,0.00319820}, {399,0.00340541}, {400,0.00303604}, {401,0.00309009}, {402,0.00316216}, {403,0.00338739}, {404,0.00315315}, {405,0.00338739}, {406,0.00348649}, {407,0.00369369}, {408,0.00330631}, {409,0.00359459}, {410,0.00355856}, {411,0.00381081}, {412,0.00363063}, {413,0.00387387}, {414,0.00384685}, {415,0.00397297}, {416,0.00339640}, {417,0.00363964}, {418,0.00368468}, {419,0.00383784}, {420,0.00374775}, {421,0.00394595}, {422,0.00593694}, {423,0.00399099}, {424,0.00378378}, {425,0.00394595}, {426,0.00398198}, {427,0.00399099}, {428,0.00396396}, {429,0.00574775}, {430,0.00400000}, {431,0.00400000}, {432,0.00395495}, {433,0.00400000}, {434,0.00572072}, {435,0.00400000}, {436,0.00400000}, {437,0.00400000}, {438,0.00400000}, {439,0.00403604}, {440,0.00400000}, {441,0.00400000}, {442,0.00400000}, {443,0.00400000}, {444,0.00400000}, {445,0.00597297}, {446,0.00400000}, {447,0.00400000}, {448,0.00380180}, {449,0.00400000}, {450,0.00400000}, {451,0.00400000}, {452,0.00400000}, {453,0.00400000}, {454,0.00400000}, {455,0.00400000}, {456,0.00400000}, {457,0.00400000}, {458,0.00400000}, {459,0.00400000}, {460,0.00400000}, {461,0.00400000}, {462,0.00400000}, {463,0.00400000}, {464,0.00400000}, {465,0.00400000}, {466,0.00400901}, {467,0.00400000}, {468,0.00400000}, {469,0.00400000}, {470,0.00400000}, {471,0.00600901}, {472,0.00400000}, {473,0.00400000}, {474,0.00400901}, {475,0.00609009}, {476,0.00400000}, {477,0.00400000}, {478,0.00400000}, {479,0.00408108}, {480,0.00400901}, {481,0.00400000}, {482,0.00400901}, {483,0.00400901}, {484,0.00400000}, {485,0.00400000}, {486,0.00402703}, {487,0.00405405}, {488,0.00400901}, {489,0.00401802}, {490,0.00401802}, {491,0.00402703}, {492,0.00403604}, {493,0.00407207}, {494,0.00408108}, {495,0.00417117}, {496,0.00403604}, {497,0.00405405}, {498,0.00401802}, {499,0.00416216}, {500,0.00407207}, {505,0.00430631}, {510,0.00425225}, {515,0.00427928}, {520,0.00426126}, {525,0.00473874}, {530,0.00469369}, {535,0.00499099}, {540,0.00495495}, {545,0.00490090}, {550,0.00500000}, {555,0.00500000}, {560,0.00500000}, {565,0.00500901}, {570,0.00500000}, {575,0.00503604}, {580,0.00500000}, {585,0.00500000}, {590,0.00501802}, {595,0.00504505}, {600,0.00501802}, {605,0.00518018}, {610,0.00506306}, {615,0.00541441}, {620,0.00681982}, {625,0.00538739}, {630,0.00570270}, {635,0.00690090}, {640,0.00525225}, {645,0.00572072}, {650,0.00584685}, {655,0.00600000}, {660,0.00709009}, {665,0.00600000}, {670,0.00600000}, {675,0.00600000}, {680,0.00600000}, {685,0.00606306}, {690,0.00752252}, {695,0.00611712}, {700,0.00603604}, {705,0.00601802}, {710,0.00607207}, {715,0.00758559}, {720,0.00603604}, {725,0.00641441}, {730,0.00649550}, {735,0.00687387}, {740,0.00650450}, {745,0.00670270}, {750,0.00698198}, {755,0.00695495}, {760,0.00683784}, {765,0.00700901}, {770,0.00679279}, {775,0.00699099}, {780,0.00698198}, {785,0.00701802}, {790,0.00883784}, {795,0.00708108}, {800,0.00700000}, {805,0.00704505}, {810,0.00705405}, {815,0.00740541}, {820,0.00712613}, {825,0.00902703}, {830,0.00770270}, {835,0.00736036}, {840,0.00727928}, {845,0.00772072}, {850,0.00761261}, {855,0.00788288}, {860,0.00785586}, {865,0.00781982}, {870,0.00789189}, {875,0.00800000}, {880,0.00790991}, {885,0.00801802}, {890,0.00805405}, {895,0.00826126}, {900,0.00799099}, {905,0.00802703}, {910,0.00807207}, {915,0.00815315}, {920,0.00807207}, {925,0.00830631}, {930,0.00810811}, {935,0.00859459}, {940,0.00845045}, {945,0.00862162}, {950,0.00870270}, {955,0.00885586}, {960,0.00828829}, {965,0.00871171}, {970,0.01187387}, {975,0.00900000}, {980,0.00883784}, {985,0.00901802}, {990,0.00902703}, {995,0.00903604}, {1000,0.00903604}, {1010,0.00906306}, {1020,0.00940541}, {1030,0.00913514}, {1040,0.00912613}, {1050,0.00963636}, {1060,0.01210000}, {1070,0.01280909}, {1080,0.01264545}, {1090,0.01261818}, {1100,0.01280000}, {1110,0.01018182}, {1120,0.01002727}, {1130,0.01034545}, {1140,0.01044545}, {1150,0.01080000}, {1160,0.01032727}, {1170,0.01065455}, {1180,0.01084545}, {1190,0.01093636}, {1200,0.01080909}, {1210,0.01119091}, {1220,0.01102727}, {1230,0.01141818}, {1240,0.01446364}, {1250,0.01146364}, {1260,0.01168182}, {1270,0.01199091}, {1280,0.01135455}, {1290,0.01185455}, {1300,0.01183636}, {1310,0.01228182}, {1320,0.01208182}, {1330,0.01542727}, {1340,0.01555455}, {1350,0.01217273}, {1360,0.01247273}, {1370,0.01285455}, {1380,0.01268182}, {1390,0.01306364}, {1400,0.01302727}, {1410,0.01588182}, {1420,0.01307273}, {1430,0.01324545}, {1440,0.01661818}, {1450,0.01352727}, {1460,0.01362727}, {1470,0.01405455}, {1480,0.01357273}, {1490,0.01386364}, {1500,0.01749091}, {1510,0.01425455}, {1520,0.01403636}, {1530,0.01464545}, {1540,0.01736364}, {1550,0.01444545}, {1560,0.01435455}, {1570,0.01445455}, {1580,0.01787273}, {1590,0.01837273}, {1600,0.01773636}, {1610,0.01490909}, {1620,0.01500909}, {1630,0.01557273}, {1640,0.01522727}, {1650,0.01548182}, {1660,0.01583636}, {1670,0.01554545}, {1680,0.01822727}, {1690,0.01587273}, {1700,0.01584545}, {1710,0.02068182}, {1720,0.01625455}, {1730,0.02079091}, {1740,0.01631818}, {1750,0.02000909}, {1760,0.01630909}, {1770,0.01687273}, {1780,0.01696364}, {1790,0.01744545}, {1800,0.01660909}, {1810,0.01695455}, {1820,0.02071818}, {1830,0.01742727}, {1840,0.01731818}, {1850,0.01775455}, {1860,0.01740000}, {1870,0.01792727}, {1880,0.01780000}, {1890,0.01789091}, {1900,0.01812727}, {1910,0.02173636}, {1920,0.01766364}, {1930,0.01828182}, {1940,0.01840000}, {1950,0.01888182}, {1960,0.01860909}, {1970,0.01891818}, {1980,0.01921818}, {1990,0.01916364}, {2000,0.01887273}, {2050,0.01905455}, {2100,0.01990909}, {2150,0.02076364}, {2200,0.02090000}, {2250,0.02177273}, {2300,0.02275455}, {2350,0.02334545}, {2400,0.02306364}, {2450,0.02390909}, {2500,0.02448182}, {2550,0.02938182}, {2600,0.02988182}, {2650,0.02656364}, {2700,0.02684545}, {2750,0.02976364}, {2800,0.02809091}, {2850,0.02863636}, {2900,0.02956364}, {2950,0.03015455}, {3000,0.03093636}, {3050,0.03437273}, {3100,0.03464545}, {3150,0.03220000}, {3200,0.03158182}, {3250,0.03309091}, {3300,0.03607273}, {3350,0.03452727}, {3400,0.03425455}, {3450,0.03645455}, {3500,0.03657273}, {3550,0.03823636}, {3600,0.03896364}, {3650,0.03748182}, {3700,0.03913636}, {3750,0.03962727}, {3800,0.04312727}, {3850,0.04066364}, {3900,0.04188182}, {3950,0.04352727}, {4000,0.04273636}, {4050,0.04728182}, {4100,0.04244545}, {4150,0.04481818}, {4200,0.04554545}, {4250,0.04651818}, {4300,0.05060000}, {4350,0.05000000}, {4400,0.04910909}, {4450,0.03987273}, {4500,0.05103636}, {4550,0.05267273}, {4600,0.05520909}, {4650,0.05592727}, {4700,0.05455455}, {4750,0.06568182}, {4800,0.05240000}, {4850,0.05876364}, {4900,0.05365455}, {4950,0.07125455}, {5000,0.05674545}, {5050,0.05548182}, {5100,0.06434545}, {5150,0.07590000}, {5200,0.06450909}, {5250,0.06072727}, {5300,0.06283636}, {5350,0.06810000}, {5400,0.06288182}, {5450,0.06113636}, {5500,0.06187273}, {5550,0.07300909}, {5600,0.06503636}, {5650,0.07268182}, {5700,0.06339091}, {5750,0.06070909}, {5800,0.07311818}, {5850,0.07230000}, {5900,0.06690000}, {5950,0.06508182}, {6000,0.06779091}, {6050,0.07900}, {6100,0.06900}, {6150,0.07850}, {6200,0.07200}, {6250,0.08250}, {6300,0.07050}, {6350,0.07275}, {6400,0.07325}, {6450,0.07600}, {6500,0.07525}, {6550,0.07875}, {6600,0.07750}, {6650,0.08975}, {6700,0.07025}, {6750,0.08025}, {6800,0.08100}, {6850,0.09275}, {6900,0.09425}, {6950,0.08525}, {7000,0.10000}, {7050,0.09250}, {7100,0.08975}, {7150,0.08875}, {7200,0.08575}, {7250,0.09675}, {7300,0.09075}, {7350,0.09500}, {7400,0.09575}, {7450,0.09700}, {7500,0.09950}, {7550,0.10400}, {7600,0.09900}, {7650,0.09375}, {7700,0.08450}, {7750,0.10300}, {7800,0.10650}, {7850,0.10350}, {7900,0.10250}, {7950,0.10200}, {8000,0.09050}, {8050,0.11300}, {8100,0.10225}, {8150,0.10075}, {8200,0.09350}, {8250,0.10475}, {8300,0.10325}, {8350,0.09625}, {8400,0.11175}, {8450,0.10700}, {8500,0.10075}, {8550,0.10675}, {8600,0.10000}, {8650,0.10700}, {8700,0.10500}, {8750,0.11425}, {8800,0.10775}, {8850,0.11500}, {8900,0.11425}, {8950,0.10100}, {9000,0.11275}, {9050,0.10900}, {9100,0.10850}, {9150,0.12050}, {9200,0.11050}, {9250,0.10850}, {9300,0.11425}, {9350,0.10650}, {9400,0.11150}, {9450,0.11550}, {9500,0.10250}, {9550,0.10850}, {9600,0.12125}, {9650,0.11550}, {9700,0.10800}, {9750,0.10850}, {9800,0.11000}, {9850,0.12800}, {9900,0.12350}, {9950,0.13525}, {10000,0.11600}, {10100,0.12275}, {10200,0.12750}, {10300,0.11350}, {10400,0.12000}, {10500,0.11725}, {10600,0.11950}, {10700,0.14550}, {10800,0.13150}, {10900,0.12250}, {11000,0.14350}, {11100,0.11225}, {11200,0.12400}, {11300,0.14500}, {11400,0.12250}, {11500,0.12900}, {11600,0.14725}, {11700,0.15625}, {11800,0.14775}, {11900,0.16500}, {12000,0.14550}, {12100,0.14425}, {12200,0.14950}, {12300,0.13500}, {12400,0.15000}, {12500,0.15000}, {12600,0.14950}, {12700,0.14550}, {12800,0.14025}, {12900,0.17000}, {13000,0.15800}, {13100,0.17200}, {13200,0.15975}, {13300,0.17000}, {13400,0.16400}, {13500,0.18725}, {13600,0.15850}, {13700,0.16775}, {13800,0.19025}, {13900,0.15500}, {14000,0.17800}, {14100,0.19275}, {14200,0.17425}, {14300,0.21125}, {14400,0.17875}, {14500,0.18700}, {14600,0.17125}, {14700,0.19300}, {14800,0.18375}, {14900,0.17200}, {15000,0.19200}, {15100,0.21525}, {15200,0.17175}, {15300,0.19925}, {15400,0.17700}, {15500,0.19675}, {15600,0.21475}, {15700,0.18550}, {15800,0.19250}, {15900,0.19575}, {16000,0.20800}, {16100,0.22425}, {16200,0.21925}, {16300,0.21425}, {16400,0.19450}, {16500,0.20200}, {16600,0.21950}, {16700,0.23475}, {16800,0.20100}, {16900,0.20050}, {17000,0.18175}, {17100,0.22325}, {17200,0.19900}, {17300,0.21475}, {17400,0.24950}, {17500,0.20900}, {17600,0.19950}, {17700,0.20175}, {17800,0.21375}, {17900,0.22950}, {18000,0.23975}, {18100,0.22750}, {18200,0.24775}, {18300,0.24350}, {18400,0.21875}, {18500,0.21925}, {18600,0.24500}, {18700,0.21850}, {18800,0.22000}, {18900,0.22775}, {19000,0.22350}, {19100,0.24675}, {19200,0.21650}, {19300,0.25300}, {19400,0.22850}, {19500,0.24900}, {19600,0.24825}, {19700,0.25050}, {19800,0.25525}, {19900,0.25800}, {20000,0.2275}};
data["big_flat"]["CanonicalStructuresPHOAS"]["pre"]["user"] = {{1,0.00026126}, {2,0.00033333}, {3,0.00054054}, {4,0.00044144}, {5,0.00042342}, {6,0.00041441}, {7,0.00053153}, {8,0.00054955}, {9,0.00038739}, {10,0.00041441}, {11,0.00047748}, {12,0.00048649}, {13,0.00072973}, {14,0.00059459}, {15,0.00050450}, {16,0.00043243}, {17,0.00069369}, {18,0.00033333}, {19,0.00054054}, {20,0.00084685}, {21,0.00057658}, {22,0.00077477}, {23,0.00077477}, {24,0.00043243}, {25,0.00031532}, {26,0.00061261}, {27,0.00053153}, {28,0.00048649}, {29,0.00066667}, {30,0.00054955}, {31,0.00058559}, {32,0.00075676}, {33,0.00055856}, {34,0.00067568}, {35,0.00067568}, {36,0.00054054}, {37,0.00060360}, {38,0.00063964}, {39,0.00064865}, {40,0.00088288}, {41,0.00059459}, {42,0.00081982}, {43,0.00073874}, {44,0.00057658}, {45,0.00071171}, {46,0.00068468}, {47,0.00081982}, {48,0.00083784}, {49,0.00090991}, {50,0.00069369}, {51,0.00079279}, {52,0.00080180}, {53,0.00078378}, {54,0.00077477}, {55,0.00087387}, {56,0.00095495}, {57,0.00084685}, {58,0.00090991}, {59,0.00074775}, {60,0.00083784}, {61,0.00055856}, {62,0.00063964}, {63,0.00084685}, {64,0.00082883}, {65,0.00068468}, {66,0.00103604}, {67,0.00067568}, {68,0.00074775}, {69,0.00090090}, {70,0.00103604}, {71,0.00078378}, {72,0.00098198}, {73,0.00090991}, {74,0.00092793}, {75,0.00083784}, {76,0.00102703}, {77,0.00058559}, {78,0.00088288}, {79,0.00099099}, {80,0.00103604}, {81,0.00105405}, {82,0.00113514}, {83,0.00098198}, {84,0.00104505}, {85,0.00106306}, {86,0.00079279}, {87,0.00125225}, {88,0.00095495}, {89,0.00113514}, {90,0.00106306}, {91,0.00103604}, {92,0.00083784}, {93,0.00104505}, {94,0.00103604}, {95,0.00104505}, {96,0.00136036}, {97,0.00100901}, {98,0.00109009}, {99,0.00080180}, {100,0.00138739}, {101,0.00123423}, {102,0.00136937}, {103,0.00098198}, {104,0.00096396}, {105,0.00078378}, {106,0.00150450}, {107,0.00114414}, {108,0.00113514}, {109,0.00100901}, {110,0.00121622}, {111,0.00118018}, {112,0.00133333}, {113,0.00125225}, {114,0.00103604}, {115,0.00131532}, {116,0.00134234}, {117,0.00104505}, {118,0.00088288}, {119,0.00124324}, {120,0.00112613}, {121,0.00114414}, {122,0.00119820}, {123,0.00141441}, {124,0.00130631}, {125,0.00150450}, {126,0.00162162}, {127,0.00079279}, {128,0.00114414}, {129,0.00151351}, {130,0.00100901}, {131,0.00138739}, {132,0.00134234}, {133,0.00098198}, {134,0.00147748}, {135,0.00160360}, {136,0.00157658}, {137,0.00122523}, {138,0.00108108}, {139,0.00159459}, {140,0.00122523}, {141,0.00122523}, {142,0.00132432}, {143,0.00143243}, {144,0.00146847}, {145,0.00129730}, {146,0.00138739}, {147,0.00131532}, {148,0.00143243}, {149,0.00150450}, {150,0.00159459}, {151,0.00138739}, {152,0.00140541}, {153,0.00167568}, {154,0.00149550}, {155,0.00140541}, {156,0.00145045}, {157,0.00155856}, {158,0.00163964}, {159,0.00137838}, {160,0.00164865}, {161,0.00173874}, {162,0.00145045}, {163,0.00154955}, {164,0.00166667}, {165,0.00164865}, {166,0.00185586}, {167,0.00147748}, {168,0.00150450}, {169,0.00132432}, {170,0.00165766}, {171,0.00133333}, {172,0.00159459}, {173,0.00157658}, {174,0.00172973}, {175,0.00154054}, {176,0.00147748}, {177,0.00176577}, {178,0.00161261}, {179,0.00157658}, {180,0.00159459}, {181,0.00147748}, {182,0.00155856}, {183,0.00178378}, {184,0.00157658}, {185,0.00132432}, {186,0.00179279}, {187,0.00158559}, {188,0.00208108}, {189,0.00157658}, {190,0.00178378}, {191,0.00176577}, {192,0.00189189}, {193,0.00186486}, {194,0.00179279}, {195,0.00163063}, {196,0.00178378}, {197,0.00172973}, {198,0.00186486}, {199,0.00181081}, {200,0.00184685}, {201,0.00181081}, {202,0.00184685}, {203,0.00156757}, {204,0.00164865}, {205,0.00186486}, {206,0.00186486}, {207,0.00195495}, {208,0.00172072}, {209,0.00197297}, {210,0.00163964}, {211,0.00263964}, {212,0.00202703}, {213,0.00187387}, {214,0.00199099}, {215,0.00197297}, {216,0.00152252}, {217,0.00186486}, {218,0.00185586}, {219,0.00192793}, {220,0.00190090}, {221,0.00224324}, {222,0.00171171}, {223,0.00192793}, {224,0.00177477}, {225,0.00169369}, {226,0.00204505}, {227,0.00185586}, {228,0.00216216}, {229,0.00184685}, {230,0.00200901}, {231,0.00166667}, {232,0.00202703}, {233,0.00238739}, {234,0.00224324}, {235,0.00228829}, {236,0.00211712}, {237,0.00202703}, {238,0.00206306}, {239,0.00203604}, {240,0.00166667}, {241,0.00190991}, {242,0.00213514}, {243,0.00214414}, {244,0.00198198}, {245,0.00213514}, {246,0.00188288}, {247,0.00213514}, {248,0.00213514}, {249,0.00204505}, {250,0.00200000}, {251,0.00229730}, {252,0.00217117}, {253,0.00254054}, {254,0.00233333}, {255,0.00258559}, {256,0.00245045}, {257,0.00214414}, {258,0.00202703}, {259,0.00232432}, {260,0.00202703}, {261,0.00216216}, {262,0.00203604}, {263,0.00240541}, {264,0.00216216}, {265,0.00215315}, {266,0.00200000}, {267,0.00211712}, {268,0.00218018}, {269,0.00250450}, {270,0.00224324}, {271,0.00227027}, {272,0.00208108}, {273,0.00215315}, {274,0.00233333}, {275,0.00229730}, {276,0.00226126}, {277,0.00254054}, {278,0.00250450}, {279,0.00272973}, {280,0.00206306}, {281,0.00249550}, {282,0.00250450}, {283,0.00252252}, {284,0.00246847}, {285,0.00243243}, {286,0.00236937}, {287,0.00265766}, {288,0.00233333}, {289,0.00236937}, {290,0.00248649}, {291,0.00254955}, {292,0.00249550}, {293,0.00260360}, {294,0.00227928}, {295,0.00278378}, {296,0.00251351}, {297,0.00254054}, {298,0.00266667}, {299,0.00228829}, {300,0.00273874}, {301,0.00242342}, {302,0.00265766}, {303,0.00274775}, {304,0.00245946}, {305,0.00243243}, {306,0.00249550}, {307,0.00238739}, {308,0.00232432}, {309,0.00263063}, {310,0.00272072}, {311,0.00273874}, {312,0.00272072}, {313,0.00248649}, {314,0.00249550}, {315,0.00278378}, {316,0.00274775}, {317,0.00261261}, {318,0.00267568}, {319,0.00490991}, {320,0.00268468}, {321,0.00266667}, {322,0.00255856}, {323,0.00259459}, {324,0.00245045}, {325,0.00245045}, {326,0.00262162}, {327,0.00266667}, {328,0.00287387}, {329,0.00277477}, {330,0.00262162}, {331,0.00272072}, {332,0.00270270}, {333,0.00267568}, {334,0.00257658}, {335,0.00272072}, {336,0.00258559}, {337,0.00266667}, {338,0.00277477}, {339,0.00266667}, {340,0.00277477}, {341,0.00289189}, {342,0.00548649}, {343,0.00281982}, {344,0.00282883}, {345,0.00272973}, {346,0.00265766}, {347,0.00303604}, {348,0.00284685}, {349,0.00285586}, {350,0.00297297}, {351,0.00298198}, {352,0.00280180}, {353,0.00300901}, {354,0.00273874}, {355,0.00297297}, {356,0.00290991}, {357,0.00288288}, {358,0.00285586}, {359,0.00299099}, {360,0.00308108}, {361,0.00326126}, {362,0.00285586}, {363,0.00300000}, {364,0.00297297}, {365,0.00298198}, {366,0.00310811}, {367,0.00313514}, {368,0.00316216}, {369,0.00310811}, {370,0.00300901}, {371,0.00309910}, {372,0.00289189}, {373,0.00293694}, {374,0.00318919}, {375,0.00309910}, {376,0.00298198}, {377,0.00305405}, {378,0.00303604}, {379,0.00312613}, {380,0.00305405}, {381,0.00323423}, {382,0.00326126}, {383,0.00310811}, {384,0.00319820}, {385,0.00521622}, {386,0.00314414}, {387,0.00328829}, {388,0.00312613}, {389,0.00313514}, {390,0.00325225}, {391,0.00322523}, {392,0.00295495}, {393,0.00327027}, {394,0.00309009}, {395,0.00325225}, {396,0.00335135}, {397,0.00316216}, {398,0.00318919}, {399,0.00330631}, {400,0.00319820}, {401,0.00331532}, {402,0.00319820}, {403,0.00338739}, {404,0.00324324}, {405,0.00341441}, {406,0.00330631}, {407,0.00337838}, {408,0.00331532}, {409,0.00332432}, {410,0.00334234}, {411,0.00342342}, {412,0.00353153}, {413,0.00339640}, {414,0.00344144}, {415,0.00345045}, {416,0.00325225}, {417,0.00327928}, {418,0.00331532}, {419,0.00338739}, {420,0.00333333}, {421,0.00337838}, {422,0.00581081}, {423,0.00352252}, {424,0.00339640}, {425,0.00333333}, {426,0.00347748}, {427,0.00341441}, {428,0.00352252}, {429,0.00590090}, {430,0.00368468}, {431,0.00354054}, {432,0.00374775}, {433,0.00357658}, {434,0.00549550}, {435,0.00354054}, {436,0.00350450}, {437,0.00356757}, {438,0.00356757}, {439,0.00363063}, {440,0.00369369}, {441,0.00359459}, {442,0.00363063}, {443,0.00373874}, {444,0.00363964}, {445,0.00584685}, {446,0.00381982}, {447,0.00396396}, {448,0.00329730}, {449,0.00370270}, {450,0.00355856}, {451,0.00387387}, {452,0.00361261}, {453,0.00370270}, {454,0.00385586}, {455,0.00381982}, {456,0.00354054}, {457,0.00364865}, {458,0.00385586}, {459,0.00382883}, {460,0.00381081}, {461,0.00400000}, {462,0.00376577}, {463,0.00393694}, {464,0.00394595}, {465,0.00367568}, {466,0.00388288}, {467,0.00385586}, {468,0.00394595}, {469,0.00394595}, {470,0.00366667}, {471,0.00607207}, {472,0.00373874}, {473,0.00376577}, {474,0.00414414}, {475,0.00605405}, {476,0.00387387}, {477,0.00439640}, {478,0.00420721}, {479,0.00428829}, {480,0.00378378}, {481,0.00398198}, {482,0.00392793}, {483,0.00410811}, {484,0.00397297}, {485,0.00403604}, {486,0.00400000}, {487,0.00412613}, {488,0.00396396}, {489,0.00400901}, {490,0.00392793}, {491,0.00422523}, {492,0.00415315}, {493,0.00413514}, {494,0.00458559}, {495,0.00440541}, {496,0.00411712}, {497,0.00420721}, {498,0.00415315}, {499,0.00434234}, {500,0.00446847}, {505,0.00460360}, {510,0.00439640}, {515,0.00418018}, {520,0.00429730}, {525,0.00458559}, {530,0.00428829}, {535,0.00488288}, {540,0.00430631}, {545,0.00449550}, {550,0.00482883}, {555,0.00492793}, {560,0.00470270}, {565,0.00483784}, {570,0.00472072}, {575,0.00470270}, {580,0.00463063}, {585,0.00473874}, {590,0.00490090}, {595,0.00478378}, {600,0.00509910}, {605,0.00548649}, {610,0.00483784}, {615,0.00510811}, {620,0.00714414}, {625,0.00523423}, {630,0.00569369}, {635,0.00698198}, {640,0.00507207}, {645,0.00527928}, {650,0.00590090}, {655,0.00568468}, {660,0.00741441}, {665,0.00585586}, {670,0.00581081}, {675,0.00600901}, {680,0.00558559}, {685,0.00604505}, {690,0.00745946}, {695,0.00637838}, {700,0.00640541}, {705,0.00614414}, {710,0.00618018}, {715,0.00753153}, {720,0.00610811}, {725,0.00642342}, {730,0.00637838}, {735,0.00663063}, {740,0.00671171}, {745,0.00685586}, {750,0.00697297}, {755,0.00682883}, {760,0.00695495}, {765,0.00708108}, {770,0.00649550}, {775,0.00680180}, {780,0.00709009}, {785,0.00704505}, {790,0.00894595}, {795,0.00752252}, {800,0.00703604}, {805,0.00729730}, {810,0.00733333}, {815,0.00758559}, {820,0.00743243}, {825,0.00927027}, {830,0.00767568}, {835,0.00759459}, {840,0.00738739}, {845,0.00784685}, {850,0.00767568}, {855,0.00800000}, {860,0.00795495}, {865,0.00780180}, {870,0.00794595}, {875,0.00785586}, {880,0.00785586}, {885,0.00837838}, {890,0.00828829}, {895,0.00884685}, {900,0.00805405}, {905,0.00827928}, {910,0.00862162}, {915,0.00806306}, {920,0.00817117}, {925,0.00838739}, {930,0.00838739}, {935,0.00903604}, {940,0.00866667}, {945,0.00899099}, {950,0.00860360}, {955,0.00909910}, {960,0.00854955}, {965,0.00895495}, {970,0.01256757}, {975,0.00939640}, {980,0.00885586}, {985,0.00961261}, {990,0.00932432}, {995,0.00945946}, {1000,0.00918018}, {1010,0.00976577}, {1020,0.00990991}, {1030,0.00997297}, {1040,0.00940541}, {1050,0.00999091}, {1060,0.01218182}, {1070,0.01286364}, {1080,0.01300909}, {1090,0.01257273}, {1100,0.01304545}, {1110,0.01026364}, {1120,0.01046364}, {1130,0.01076364}, {1140,0.01087273}, {1150,0.01143636}, {1160,0.01099091}, {1170,0.01070909}, {1180,0.01139091}, {1190,0.01170000}, {1200,0.01103636}, {1210,0.01157273}, {1220,0.01150909}, {1230,0.01168182}, {1240,0.01420000}, {1250,0.01193636}, {1260,0.01199091}, {1270,0.01230909}, {1280,0.01191818}, {1290,0.01207273}, {1300,0.01231818}, {1310,0.01263636}, {1320,0.01250000}, {1330,0.01531818}, {1340,0.01557273}, {1350,0.01258182}, {1360,0.01278182}, {1370,0.01323636}, {1380,0.01333636}, {1390,0.01336364}, {1400,0.01340909}, {1410,0.01619091}, {1420,0.01340000}, {1430,0.01302727}, {1440,0.01641818}, {1450,0.01370909}, {1460,0.01395455}, {1470,0.01426364}, {1480,0.01374545}, {1490,0.01440909}, {1500,0.01729091}, {1510,0.01451818}, {1520,0.01419091}, {1530,0.01496364}, {1540,0.01732727}, {1550,0.01469091}, {1560,0.01446364}, {1570,0.01480000}, {1580,0.01797273}, {1590,0.01815455}, {1600,0.01760000}, {1610,0.01512727}, {1620,0.01516364}, {1630,0.01560909}, {1640,0.01517273}, {1650,0.01580909}, {1660,0.01600909}, {1670,0.01565455}, {1680,0.01823636}, {1690,0.01603636}, {1700,0.01568182}, {1710,0.02031818}, {1720,0.01612727}, {1730,0.02062727}, {1740,0.01656364}, {1750,0.01990000}, {1760,0.01652727}, {1770,0.01683636}, {1780,0.01690909}, {1790,0.01725455}, {1800,0.01648182}, {1810,0.01692727}, {1820,0.02077273}, {1830,0.01737273}, {1840,0.01715455}, {1850,0.01800000}, {1860,0.01732727}, {1870,0.01793636}, {1880,0.01790000}, {1890,0.01791818}, {1900,0.01814545}, {1910,0.02218182}, {1920,0.01772727}, {1930,0.01805455}, {1940,0.01812727}, {1950,0.01909091}, {1960,0.01853636}, {1970,0.01892727}, {1980,0.01931818}, {1990,0.01908182}, {2000,0.01849091}, {2050,0.01893636}, {2100,0.01976364}, {2150,0.02043636}, {2200,0.02093636}, {2250,0.02200909}, {2300,0.02301818}, {2350,0.02374545}, {2400,0.02354545}, {2450,0.02421818}, {2500,0.02474545}, {2550,0.02913636}, {2600,0.02980909}, {2650,0.02705455}, {2700,0.02715455}, {2750,0.02978182}, {2800,0.02824545}, {2850,0.02867273}, {2900,0.02970909}, {2950,0.02994545}, {3000,0.03063636}, {3050,0.03455455}, {3100,0.03482727}, {3150,0.03252727}, {3200,0.03155455}, {3250,0.03334545}, {3300,0.03637273}, {3350,0.03494545}, {3400,0.03455455}, {3450,0.03678182}, {3500,0.03706364}, {3550,0.03844545}, {3600,0.03910000}, {3650,0.03818182}, {3700,0.03952727}, {3750,0.03952727}, {3800,0.04327273}, {3850,0.04075455}, {3900,0.04186364}, {3950,0.04340909}, {4000,0.04284545}, {4050,0.04737273}, {4100,0.04228182}, {4150,0.04492727}, {4200,0.04557273}, {4250,0.04668182}, {4300,0.05093636}, {4350,0.04992727}, {4400,0.04921818}, {4450,0.04007273}, {4500,0.05108182}, {4550,0.05302727}, {4600,0.05522727}, {4650,0.05608182}, {4700,0.05469091}, {4750,0.06542727}, {4800,0.05226364}, {4850,0.05897273}, {4900,0.05350909}, {4950,0.07110909}, {5000,0.05637273}, {5050,0.05578182}, {5100,0.06439091}, {5150,0.07607273}, {5200,0.06445455}, {5250,0.06070909}, {5300,0.06306364}, {5350,0.06866364}, {5400,0.06291818}, {5450,0.06118182}, {5500,0.06215455}, {5550,0.07307273}, {5600,0.06503636}, {5650,0.07301818}, {5700,0.06332727}, {5750,0.06047273}, {5800,0.07346364}, {5850,0.07258182}, {5900,0.06690000}, {5950,0.06516364}, {6000,0.06780000}, {6050,0.07825}, {6100,0.06750}, {6150,0.07975}, {6200,0.07350}, {6250,0.08250}, {6300,0.07025}, {6350,0.07175}, {6400,0.07475}, {6450,0.07650}, {6500,0.07550}, {6550,0.07850}, {6600,0.07875}, {6650,0.08875}, {6700,0.07175}, {6750,0.07675}, {6800,0.08050}, {6850,0.09375}, {6900,0.09450}, {6950,0.08550}, {7000,0.10075}, {7050,0.09225}, {7100,0.09075}, {7150,0.08850}, {7200,0.08625}, {7250,0.09650}, {7300,0.09025}, {7350,0.09475}, {7400,0.09700}, {7450,0.09350}, {7500,0.09825}, {7550,0.10350}, {7600,0.09875}, {7650,0.09125}, {7700,0.08550}, {7750,0.10250}, {7800,0.10400}, {7850,0.10200}, {7900,0.10375}, {7950,0.10175}, {8000,0.09175}, {8050,0.11250}, {8100,0.10025}, {8150,0.09925}, {8200,0.09425}, {8250,0.10550}, {8300,0.10275}, {8350,0.09700}, {8400,0.11150}, {8450,0.10625}, {8500,0.10075}, {8550,0.10750}, {8600,0.09975}, {8650,0.10625}, {8700,0.10675}, {8750,0.11400}, {8800,0.10825}, {8850,0.11475}, {8900,0.11325}, {8950,0.10200}, {9000,0.11150}, {9050,0.10875}, {9100,0.11025}, {9150,0.11925}, {9200,0.11175}, {9250,0.10950}, {9300,0.11475}, {9350,0.10675}, {9400,0.11175}, {9450,0.11525}, {9500,0.10250}, {9550,0.10725}, {9600,0.12150}, {9650,0.11550}, {9700,0.10900}, {9750,0.10850}, {9800,0.10950}, {9850,0.12750}, {9900,0.12275}, {9950,0.13525}, {10000,0.11550}, {10100,0.12250}, {10200,0.12775}, {10300,0.11325}, {10400,0.12150}, {10500,0.11725}, {10600,0.12050}, {10700,0.14575}, {10800,0.13125}, {10900,0.12275}, {11000,0.14350}, {11100,0.11275}, {11200,0.12450}, {11300,0.14450}, {11400,0.12250}, {11500,0.12975}, {11600,0.14725}, {11700,0.15675}, {11800,0.14850}, {11900,0.16400}, {12000,0.14575}, {12100,0.14450}, {12200,0.15000}, {12300,0.13500}, {12400,0.15125}, {12500,0.14950}, {12600,0.14850}, {12700,0.14550}, {12800,0.14075}, {12900,0.17025}, {13000,0.15975}, {13100,0.17150}, {13200,0.15950}, {13300,0.17025}, {13400,0.16350}, {13500,0.18775}, {13600,0.15775}, {13700,0.16900}, {13800,0.19200}, {13900,0.15400}, {14000,0.17800}, {14100,0.19125}, {14200,0.17425}, {14300,0.21225}, {14400,0.17925}, {14500,0.18700}, {14600,0.17125}, {14700,0.19325}, {14800,0.18475}, {14900,0.17225}, {15000,0.19200}, {15100,0.21525}, {15200,0.17150}, {15300,0.19875}, {15400,0.17650}, {15500,0.19650}, {15600,0.21350}, {15700,0.18675}, {15800,0.19325}, {15900,0.19425}, {16000,0.20675}, {16100,0.22225}, {16200,0.21825}, {16300,0.21475}, {16400,0.19450}, {16500,0.20200}, {16600,0.21950}, {16700,0.23575}, {16800,0.20250}, {16900,0.19975}, {17000,0.18125}, {17100,0.22275}, {17200,0.19975}, {17300,0.21550}, {17400,0.24925}, {17500,0.20975}, {17600,0.19825}, {17700,0.20275}, {17800,0.21350}, {17900,0.22950}, {18000,0.24025}, {18100,0.22650}, {18200,0.24925}, {18300,0.24175}, {18400,0.21850}, {18500,0.22000}, {18600,0.24525}, {18700,0.21975}, {18800,0.22150}, {18900,0.22500}, {19000,0.22250}, {19100,0.24750}, {19200,0.21425}, {19300,0.25450}, {19400,0.22925}, {19500,0.24875}, {19600,0.24900}, {19700,0.25050}, {19800,0.25450}, {19900,0.25700}, {20000,0.2275}};
data["big_flat"]["CanonicalStructuresPHOAS"]["pre"]["system"] = {{1,0.00003604}, {2,0.00000000}, {3,0.00007207}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00003604}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00003604}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00003604}, {27,0.00000000}, {28,0.00000000}, {29,0.00007207}, {30,0.00000000}, {31,0.00000000}, {32,0.00003604}, {33,0.00000000}, {34,0.00003604}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00003604}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00003604}, {53,0.00007207}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00003604}, {59,0.00000000}, {60,0.00000000}, {61,0.00003604}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00007207}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00007207}, {74,0.00000000}, {75,0.00000000}, {76,0.00003604}, {77,0.00003604}, {78,0.00003604}, {79,0.00003604}, {80,0.00003604}, {81,0.00000000}, {82,0.00000000}, {83,0.00007207}, {84,0.00000000}, {85,0.00003604}, {86,0.00000000}, {87,0.00000000}, {88,0.00003604}, {89,0.00007207}, {90,0.00002703}, {91,0.00000000}, {92,0.00003604}, {93,0.00000000}, {94,0.00003604}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00003604}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00003604}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00007207}, {111,0.00007207}, {112,0.00003604}, {113,0.00003604}, {114,0.00009910}, {115,0.00003604}, {116,0.00003604}, {117,0.00003604}, {118,0.00003604}, {119,0.00003604}, {120,0.00000000}, {121,0.00000000}, {122,0.00002703}, {123,0.00003604}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00003604}, {128,0.00000000}, {129,0.00003604}, {130,0.00000000}, {131,0.00003604}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00003604}, {141,0.00000000}, {142,0.00007207}, {143,0.00000000}, {144,0.00000000}, {145,0.00010811}, {146,0.00003604}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00003604}, {153,0.00000000}, {154,0.00007207}, {155,0.00000000}, {156,0.00003604}, {157,0.00000000}, {158,0.00000000}, {159,0.00003604}, {160,0.00007207}, {161,0.00003604}, {162,0.00007207}, {163,0.00002703}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00003604}, {169,0.00000000}, {170,0.00010811}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00003604}, {179,0.00003604}, {180,0.00000000}, {181,0.00003604}, {182,0.00003604}, {183,0.00000000}, {184,0.00000000}, {185,0.00003604}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00003604}, {195,0.00010811}, {196,0.00000000}, {197,0.00003604}, {198,0.00003604}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00003604}, {205,0.00000000}, {206,0.00000000}, {207,0.00003604}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00003604}, {213,0.00003604}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00003604}, {218,0.00000000}, {219,0.00000000}, {220,0.00003604}, {221,0.00000000}, {222,0.00000000}, {223,0.00003604}, {224,0.00006306}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00002703}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00007207}, {238,0.00000000}, {239,0.00007207}, {240,0.00003604}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00009910}, {247,0.00000000}, {248,0.00003604}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00003604}, {257,0.00000000}, {258,0.00000000}, {259,0.00003604}, {260,0.00000000}, {261,0.00003604}, {262,0.00002703}, {263,0.00000000}, {264,0.00003604}, {265,0.00007207}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00003604}, {271,0.00000000}, {272,0.00000000}, {273,0.00003604}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00003604}, {278,0.00000000}, {279,0.00000000}, {280,0.00007207}, {281,0.00000000}, {282,0.00000000}, {283,0.00003604}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00003604}, {289,0.00000000}, {290,0.00003604}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00007207}, {296,0.00000000}, {297,0.00003604}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00007207}, {302,0.00000000}, {303,0.00003604}, {304,0.00010811}, {305,0.00003604}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00002703}, {315,0.00006306}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00003604}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00003604}, {326,0.00007207}, {327,0.00003604}, {328,0.00000000}, {329,0.00003604}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00007207}, {338,0.00000000}, {339,0.00006306}, {340,0.00007207}, {341,0.00003604}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00007207}, {346,0.00003604}, {347,0.00000000}, {348,0.00003604}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00003604}, {363,0.00003604}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00003604}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00003604}, {376,0.00003604}, {377,0.00000000}, {378,0.00006306}, {379,0.00000000}, {380,0.00000000}, {381,0.00003604}, {382,0.00000000}, {383,0.00003604}, {384,0.00003604}, {385,0.00014414}, {386,0.00000000}, {387,0.00000000}, {388,0.00003604}, {389,0.00000000}, {390,0.00003604}, {391,0.00000000}, {392,0.00007207}, {393,0.00000000}, {394,0.00007207}, {395,0.00003604}, {396,0.00000000}, {397,0.00000000}, {398,0.00003604}, {399,0.00003604}, {400,0.00000000}, {401,0.00000000}, {402,0.00010811}, {403,0.00003604}, {404,0.00000000}, {405,0.00003604}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00007207}, {412,0.00003604}, {413,0.00003604}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00003604}, {423,0.00000000}, {424,0.00003604}, {425,0.00002703}, {426,0.00003604}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00003604}, {431,0.00000000}, {432,0.00000000}, {433,0.00003604}, {434,0.00010811}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00003604}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00007207}, {444,0.00000000}, {445,0.00002703}, {446,0.00003604}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00007207}, {457,0.00007207}, {458,0.00010811}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00003604}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00003604}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00003604}, {475,0.00003604}, {476,0.00000000}, {477,0.00003604}, {478,0.00000000}, {479,0.00007207}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00003604}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00003604}, {490,0.00000000}, {491,0.00000000}, {492,0.00003604}, {493,0.00000000}, {494,0.00000000}, {495,0.00003604}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00007207}, {500,0.00000000}, {505,0.00000000}, {510,0.00002703}, {515,0.00000000}, {520,0.00000000}, {525,0.00002703}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00003604}, {565,0.00003604}, {570,0.00000000}, {575,0.00003604}, {580,0.00000000}, {585,0.00000000}, {590,0.00007207}, {595,0.00003604}, {600,0.00003604}, {605,0.00000000}, {610,0.00000000}, {615,0.00002703}, {620,0.00003604}, {625,0.00007207}, {630,0.00000000}, {635,0.00003604}, {640,0.00000000}, {645,0.00003604}, {650,0.00007207}, {655,0.00003604}, {660,0.00000000}, {665,0.00000000}, {670,0.00010811}, {675,0.00000000}, {680,0.00003604}, {685,0.00000000}, {690,0.00000000}, {695,0.00007207}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00010811}, {720,0.00000000}, {725,0.00003604}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00007207}, {750,0.00003604}, {755,0.00003604}, {760,0.00000000}, {765,0.00007207}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00010811}, {795,0.00000000}, {800,0.00000000}, {805,0.00003604}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00003604}, {830,0.00000000}, {835,0.00003604}, {840,0.00007207}, {845,0.00003604}, {850,0.00007207}, {855,0.00003604}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00007207}, {880,0.00000000}, {885,0.00003604}, {890,0.00000000}, {895,0.00000000}, {900,0.00003604}, {905,0.00000000}, {910,0.00007207}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00003604}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00003604}, {975,0.00003604}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00007273}, {1060,0.00007273}, {1070,0.00010909}, {1080,0.00010909}, {1090,0.00010909}, {1100,0.00007273}, {1110,0.00000000}, {1120,0.00003636}, {1130,0.00007273}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00003636}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00007273}, {1210,0.00000000}, {1220,0.00007273}, {1230,0.00000000}, {1240,0.00010909}, {1250,0.00003636}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00003636}, {1300,0.00000000}, {1310,0.00007273}, {1320,0.00003636}, {1330,0.00010909}, {1340,0.00003636}, {1350,0.00000000}, {1360,0.00003636}, {1370,0.00003636}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00002727}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00003636}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00003636}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00010909}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00003636}, {1620,0.00007273}, {1630,0.00000000}, {1640,0.00003636}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00003636}, {1690,0.00003636}, {1700,0.00003636}, {1710,0.00003636}, {1720,0.00003636}, {1730,0.00007273}, {1740,0.00003636}, {1750,0.00003636}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00003636}, {1790,0.00003636}, {1800,0.00000000}, {1810,0.00007273}, {1820,0.00003636}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00003636}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00003636}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00003636}, {2500,0.00003636}, {2550,0.00003636}, {2600,0.00003636}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00003636}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00003636}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00007273}, {3550,0.00003636}, {3600,0.00003636}, {3650,0.00000000}, {3700,0.00003636}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00003636}, {3900,0.00003636}, {3950,0.00003636}, {4000,0.00000000}, {4050,0.00002727}, {4100,0.00003636}, {4150,0.00000000}, {4200,0.00003636}, {4250,0.00007273}, {4300,0.00003636}, {4350,0.00000000}, {4400,0.00002727}, {4450,0.00000000}, {4500,0.00007273}, {4550,0.00007273}, {4600,0.00003636}, {4650,0.00003636}, {4700,0.00000000}, {4750,0.00025455}, {4800,0.00014545}, {4850,0.00000000}, {4900,0.00029091}, {4950,0.00032727}, {5000,0.00025455}, {5050,0.00010909}, {5100,0.00018182}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00007273}, {5350,0.00000000}, {5400,0.00007273}, {5450,0.00010909}, {5500,0.00003636}, {5550,0.00010909}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00100}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00100}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00100}, {7200,0.00000}, {7250,0.00100}, {7300,0.00000}, {7350,0.00000}, {7400,0.00100}, {7450,0.00275}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00100}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00100}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00100}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00100}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00100}, {19000,0.00100}, {19100,0.00000}, {19200,0.00100}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["CanonicalStructuresPHOAS"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00079279}, {4,0.00100000}, {5,0.00100000}, {6,0.00100000}, {7,0.00129730}, {8,0.00200000}, {9,0.00200000}, {10,0.00200000}, {11,0.00223423}, {12,0.00299099}, {13,0.00300000}, {14,0.00300901}, {15,0.00342342}, {16,0.00364865}, {17,0.00400000}, {18,0.00404505}, {19,0.00423423}, {20,0.00466667}, {21,0.00501802}, {22,0.00513514}, {23,0.00570270}, {24,0.00677477}, {25,0.00609910}, {26,0.00609910}, {27,0.00673874}, {28,0.00669369}, {29,0.00710811}, {30,0.00715315}, {31,0.00806306}, {32,0.00877477}, {33,0.00807207}, {34,0.00807207}, {35,0.00900901}, {36,0.00883784}, {37,0.00909910}, {38,0.00932432}, {39,0.01005405}, {40,0.00949550}, {41,0.01009910}, {42,0.01014414}, {43,0.01109009}, {44,0.01107207}, {45,0.01129730}, {46,0.01195495}, {47,0.01223423}, {48,0.01140541}, {49,0.01212613}, {50,0.01229730}, {51,0.01308108}, {52,0.01301802}, {53,0.01364865}, {54,0.01405405}, {55,0.01473874}, {56,0.01403604}, {57,0.01469369}, {58,0.01505405}, {59,0.01689189}, {60,0.01517117}, {61,0.01611712}, {62,0.01614414}, {63,0.01906306}, {64,0.01567568}, {65,0.01631532}, {66,0.01686486}, {67,0.01902703}, {68,0.01720721}, {69,0.01807207}, {70,0.01822523}, {71,0.01916216}, {72,0.01817117}, {73,0.01909910}, {74,0.02092793}, {75,0.02018018}, {76,0.01989189}, {77,0.02092793}, {78,0.02109009}, {79,0.02212613}, {80,0.02019820}, {81,0.02232432}, {82,0.02121622}, {83,0.02245946}, {84,0.02389189}, {85,0.02300901}, {86,0.02323423}, {87,0.02641441}, {88,0.02281081}, {89,0.02402703}, {90,0.02593694}, {91,0.02536937}, {92,0.02470270}, {93,0.02762162}, {94,0.02606306}, {95,0.02750450}, {96,0.02420721}, {97,0.02542342}, {98,0.02737838}, {99,0.02701802}, {100,0.02611712}, {101,0.02891892}, {102,0.02765766}, {103,0.02914414}, {104,0.02717117}, {105,0.02837838}, {106,0.02996396}, {107,0.03018018}, {108,0.02918919}, {109,0.03063964}, {110,0.03086486}, {111,0.03370270}, {112,0.02913514}, {113,0.03235135}, {114,0.03078378}, {115,0.03229730}, {116,0.03124324}, {117,0.03284685}, {118,0.03394595}, {119,0.03485586}, {120,0.03391892}, {121,0.03378378}, {122,0.03573874}, {123,0.03585586}, {124,0.03660360}, {125,0.03618018}, {126,0.03654054}, {127,0.03851351}, {128,0.03299099}, {129,0.03445946}, {130,0.03472072}, {131,0.03653153}, {132,0.03517117}, {133,0.03709009}, {134,0.03727928}, {135,0.03915315}, {136,0.03613514}, {137,0.03806306}, {138,0.03816216}, {139,0.04012613}, {140,0.03854054}, {141,0.04069369}, {142,0.04256757}, {143,0.04314414}, {144,0.03927027}, {145,0.03991892}, {146,0.04167568}, {147,0.04235135}, {148,0.04225225}, {149,0.04278378}, {150,0.04318919}, {151,0.04531532}, {152,0.04171171}, {153,0.04523423}, {154,0.04417117}, {155,0.04771171}, {156,0.04462162}, {157,0.04693694}, {158,0.04846847}, {159,0.04963964}, {160,0.04330631}, {161,0.04446847}, {162,0.04464865}, {163,0.04837838}, {164,0.04500000}, {165,0.04854054}, {166,0.04754054}, {167,0.05007207}, {168,0.04754955}, {169,0.04839640}, {170,0.04936937}, {171,0.05385586}, {172,0.04904505}, {173,0.05265766}, {174,0.05196396}, {175,0.05471171}, {176,0.04919820}, {177,0.05043243}, {178,0.05075676}, {179,0.05473874}, {180,0.05122523}, {181,0.05383784}, {182,0.05559459}, {183,0.05693694}, {184,0.05218919}, {185,0.05602703}, {186,0.05751351}, {187,0.05795495}, {188,0.05559459}, {189,0.05988288}, {190,0.05869369}, {191,0.06178378}, {192,0.05227928}, {193,0.05345045}, {194,0.05357658}, {195,0.05735135}, {196,0.05671171}, {197,0.05700000}, {198,0.05710811}, {199,0.06130631}, {200,0.05745946}, {201,0.05796396}, {202,0.05824324}, {203,0.06245045}, {204,0.06115315}, {205,0.06175676}, {206,0.06210811}, {207,0.06661261}, {208,0.05956757}, {209,0.06002703}, {210,0.06027027}, {211,0.06350450}, {212,0.06220721}, {213,0.06621622}, {214,0.06425225}, {215,0.06765766}, {216,0.06279279}, {217,0.06750450}, {218,0.06743243}, {219,0.06871171}, {220,0.06565766}, {221,0.06933333}, {222,0.07046847}, {223,0.07578378}, {224,0.06491892}, {225,0.06434234}, {226,0.06455856}, {227,0.06795495}, {228,0.06656757}, {229,0.07107207}, {230,0.07179279}, {231,0.07245946}, {232,0.06612613}, {233,0.06954054}, {234,0.07108108}, {235,0.07742342}, {236,0.07395495}, {237,0.07769369}, {238,0.07725225}, {239,0.07829730}, {240,0.06803604}, {241,0.07174775}, {242,0.07188288}, {243,0.07706306}, {244,0.07577477}, {245,0.07909910}, {246,0.07887387}, {247,0.08287387}, {248,0.07562162}, {249,0.07944144}, {250,0.07751351}, {251,0.08163964}, {252,0.07802703}, {253,0.08216216}, {254,0.08230631}, {255,0.08696396}, {256,0.06927928}, {257,0.07390090}, {258,0.07602703}, {259,0.07957658}, {260,0.07636937}, {261,0.07990991}, {262,0.08009910}, {263,0.08415315}, {264,0.07697297}, {265,0.08062162}, {266,0.08093694}, {267,0.08490991}, {268,0.08134234}, {269,0.08564865}, {270,0.08566667}, {271,0.09033333}, {272,0.07883784}, {273,0.08281081}, {274,0.08296396}, {275,0.08722523}, {276,0.08360360}, {277,0.08781982}, {278,0.08822523}, {279,0.09284685}, {280,0.08478378}, {281,0.08913514}, {282,0.08949550}, {283,0.09393694}, {284,0.08991892}, {285,0.09482883}, {286,0.09215315}, {287,0.09711712}, {288,0.08081982}, {289,0.08487387}, {290,0.08511712}, {291,0.09217117}, {292,0.08762162}, {293,0.09190090}, {294,0.09258559}, {295,0.09763964}, {296,0.08897297}, {297,0.09373874}, {298,0.09423423}, {299,0.09630631}, {300,0.09187387}, {301,0.09685586}, {302,0.09880180}, {303,0.10381982}, {304,0.09080180}, {305,0.09580180}, {306,0.09623423}, {307,0.09874775}, {308,0.09410811}, {309,0.10172072}, {310,0.10109009}, {311,0.10646847}, {312,0.09747748}, {313,0.10272072}, {314,0.10023423}, {315,0.10894595}, {316,0.10245045}, {317,0.10772072}, {318,0.10863964}, {319,0.11190991}, {320,0.08950450}, {321,0.09636036}, {322,0.09591892}, {323,0.10129730}, {324,0.09718919}, {325,0.09984685}, {326,0.10247748}, {327,0.10696396}, {328,0.09773874}, {329,0.10328829}, {330,0.10100000}, {331,0.10861261}, {332,0.10329730}, {333,0.10917117}, {334,0.10713514}, {335,0.11511712}, {336,0.09953153}, {337,0.10498198}, {338,0.10526126}, {339,0.11098198}, {340,0.10537838}, {341,0.11170270}, {342,0.10975676}, {343,0.11735135}, {344,0.10627027}, {345,0.11258559}, {346,0.11019820}, {347,0.11776577}, {348,0.11289189}, {349,0.11886486}, {350,0.11895495}, {351,0.12522523}, {352,0.10407207}, {353,0.11127928}, {354,0.11075676}, {355,0.11523423}, {356,0.10812613}, {357,0.11529730}, {358,0.11639640}, {359,0.11996396}, {360,0.11061261}, {361,0.11705405}, {362,0.11502703}, {363,0.12254955}, {364,0.11796396}, {365,0.12149550}, {366,0.12355856}, {367,0.13069369}, {368,0.11366667}, {369,0.11858559}, {370,0.11945045}, {371,0.12542342}, {372,0.11958559}, {373,0.12392793}, {374,0.12541441}, {375,0.13297297}, {376,0.12065766}, {377,0.12656757}, {378,0.12527027}, {379,0.13345946}, {380,0.12765766}, {381,0.13445045}, {382,0.13478378}, {383,0.14176577}, {384,0.10996396}, {385,0.11336036}, {386,0.11587387}, {387,0.12134234}, {388,0.11641441}, {389,0.12210811}, {390,0.12049550}, {391,0.12836937}, {392,0.11742342}, {393,0.12342342}, {394,0.12338739}, {395,0.12977477}, {396,0.12374775}, {397,0.13018018}, {398,0.13031532}, {399,0.13701802}, {400,0.11869369}, {401,0.12578378}, {402,0.12510811}, {403,0.13584685}, {404,0.12582883}, {405,0.13060360}, {406,0.13254955}, {407,0.14324324}, {408,0.12736937}, {409,0.13619820}, {410,0.13482883}, {411,0.14151351}, {412,0.13398198}, {413,0.14106306}, {414,0.14127928}, {415,0.14893694}, {416,0.12318919}, {417,0.12955856}, {418,0.12972072}, {419,0.13636036}, {420,0.13045045}, {421,0.13719820}, {422,0.13866667}, {423,0.14444144}, {424,0.13099099}, {425,0.13777477}, {426,0.13828829}, {427,0.14581982}, {428,0.13894595}, {429,0.14613514}, {430,0.14633333}, {431,0.15421622}, {432,0.13322523}, {433,0.14041441}, {434,0.14053153}, {435,0.14768468}, {436,0.14112613}, {437,0.14821622}, {438,0.14823423}, {439,0.15627928}, {440,0.14179279}, {441,0.14937838}, {442,0.14977477}, {443,0.15732432}, {444,0.15020721}, {445,0.15821622}, {446,0.15787387}, {447,0.16709910}, {448,0.13221622}, {449,0.13848649}, {450,0.13940541}, {451,0.14624324}, {452,0.13919820}, {453,0.14670270}, {454,0.14689189}, {455,0.15436036}, {456,0.14055856}, {457,0.14903604}, {458,0.14758559}, {459,0.15572072}, {460,0.14830631}, {461,0.15600000}, {462,0.15688288}, {463,0.16453153}, {464,0.14245946}, {465,0.15006306}, {466,0.15009009}, {467,0.15765766}, {468,0.15016216}, {469,0.15908108}, {470,0.15873874}, {471,0.16597297}, {472,0.15107207}, {473,0.15975676}, {474,0.15997297}, {475,0.16753153}, {476,0.15979279}, {477,0.16854955}, {478,0.16927027}, {479,0.17825225}, {480,0.14779279}, {481,0.15426126}, {482,0.15499099}, {483,0.16265766}, {484,0.15479279}, {485,0.16297297}, {486,0.16303604}, {487,0.17249550}, {488,0.15566667}, {489,0.16368468}, {490,0.16768468}, {491,0.17465766}, {492,0.16490090}, {493,0.17345946}, {494,0.17354955}, {495,0.18240541}, {496,0.15924324}, {497,0.16599099}, {498,0.16611712}, {499,0.17576577}, {500,0.16713514}, {505,0.17686486}, {510,0.18639640}, {515,0.16508108}, {520,0.15914414}, {525,0.17520721}, {530,0.16789189}, {535,0.18767568}, {540,0.17935135}, {545,0.17184685}, {550,0.18233333}, {555,0.19645946}, {560,0.17974775}, {565,0.19651351}, {570,0.19734234}, {575,0.22016216}, {580,0.18258559}, {585,0.19314414}, {590,0.20504505}, {595,0.20600901}, {600,0.19708108}, {605,0.21985586}, {610,0.20050450}, {615,0.22333333}, {620,0.21229730}, {625,0.21433333}, {630,0.22827928}, {635,0.23970270}, {640,0.19185586}, {645,0.21313514}, {650,0.21408108}, {655,0.24097297}, {660,0.21595495}, {665,0.22974775}, {670,0.24371171}, {675,0.23868468}, {680,0.22299099}, {685,0.24991892}, {690,0.23558559}, {695,0.26488288}, {700,0.25185586}, {705,0.22981982}, {710,0.24500000}, {715,0.25689189}, {720,0.23471171}, {725,0.26224324}, {730,0.26135135}, {735,0.29409910}, {740,0.25251351}, {745,0.26781982}, {750,0.28202703}, {755,0.28178378}, {760,0.27100901}, {765,0.30268468}, {770,0.24655856}, {775,0.27457658}, {780,0.26182883}, {785,0.26091892}, {790,0.27473874}, {795,0.29102703}, {800,0.25203604}, {805,0.28051351}, {810,0.28128829}, {815,0.31435135}, {820,0.28209009}, {825,0.29897297}, {830,0.31922523}, {835,0.28905405}, {840,0.27568468}, {845,0.30734234}, {850,0.29300000}, {855,0.32782883}, {860,0.32024324}, {865,0.30049550}, {870,0.31547748}, {875,0.33450450}, {880,0.30540541}, {885,0.33697297}, {890,0.33860360}, {895,0.38028829}, {900,0.29481982}, {905,0.31247748}, {910,0.33100901}, {915,0.33167568}, {920,0.31646847}, {925,0.35300000}, {930,0.31872973}, {935,0.35501802}, {940,0.33907207}, {945,0.34059459}, {950,0.36111712}, {955,0.38170270}, {960,0.31308108}, {965,0.34669369}, {970,0.34635135}, {975,0.39383784}, {980,0.35063964}, {985,0.36986486}, {990,0.39546847}, {995,0.37424324}, {1000,0.35623423}, {1010,0.37836036}, {1020,0.40439640}, {1030,0.35129730}, {1040,0.33389189}, {1050,0.37491818}, {1060,0.35666364}, {1070,0.40030909}, {1080,0.38141818}, {1090,0.37261818}, {1100,0.38857273}, {1110,0.41478182}, {1120,0.37485455}, {1130,0.42202727}, {1140,0.42374545}, {1150,0.47258182}, {1160,0.39058182}, {1170,0.41260000}, {1180,0.43290909}, {1190,0.44292727}, {1200,0.42100909}, {1210,0.47428182}, {1220,0.42795455}, {1230,0.48061818}, {1240,0.46338182}, {1250,0.46013636}, {1260,0.48875455}, {1270,0.52166364}, {1280,0.40763636}, {1290,0.45480000}, {1300,0.45670909}, {1310,0.51420000}, {1320,0.46320909}, {1330,0.49213636}, {1340,0.52146364}, {1350,0.49777273}, {1360,0.47390909}, {1370,0.53364545}, {1380,0.50726364}, {1390,0.57143636}, {1400,0.54238182}, {1410,0.48911818}, {1420,0.52100909}, {1430,0.55772727}, {1440,0.49698182}, {1450,0.56307273}, {1460,0.56332727}, {1470,0.63625455}, {1480,0.53755455}, {1490,0.58095455}, {1500,0.60727273}, {1510,0.61136364}, {1520,0.58060909}, {1530,0.65508182}, {1540,0.51593636}, {1550,0.58257273}, {1560,0.55379091}, {1570,0.55530909}, {1580,0.58832727}, {1590,0.62624545}, {1600,0.53225455}, {1610,0.59861818}, {1620,0.60066364}, {1630,2.31920000}, {1640,0.61310909}, {1650,0.65339091}, {1660,0.68945455}, {1670,0.61984545}, {1680,0.59415455}, {1690,0.66389091}, {1700,0.62766364}, {1710,0.71477273}, {1720,0.67275455}, {1730,0.63607273}, {1740,0.67789091}, {1750,0.72417273}, {1760,0.64570909}, {1770,0.73076364}, {1780,0.72977273}, {1790,0.83066364}, {1800,0.62924545}, {1810,0.66760000}, {1820,0.71071818}, {1830,0.71550000}, {1840,0.67868182}, {1850,0.76850000}, {1860,0.69162727}, {1870,0.77627273}, {1880,0.73131818}, {1890,0.73370909}, {1900,0.77848182}, {1910,0.83161818}, {1920,0.66300909}, {1930,0.75408182}, {1940,0.75180909}, {1950,0.84120909}, {1960,0.75820909}, {1970,0.80449091}, {1980,0.86347273}, {1990,0.81241818}, {2000,0.77089091}, {2050,0.70753636}, {2100,0.81618182}, {2150,0.87890909}, {2200,0.84205455}, {2250,0.90883636}, {2300,1.05368182}, {2350,1.01780909}, {2400,0.91524545}, {2450,0.98860909}, {2500,0.99766364}, {2550,1.23111818}, {2600,0.99508182}, {2650,1.13825455}, {2700,1.08107273}, {2750,1.33626364}, {2800,1.18558182}, {2850,1.14189091}, {2900,1.23450909}, {2950,1.24791818}, {3000,1.35369091}, {3050,1.44555455}, {3100,1.26982727}, {3150,1.36718182}, {3200,1.14612727}, {3250,1.39870909}, {3300,1.41670909}, {3350,1.43350000}, {3400,1.36248182}, {3450,1.68585455}, {3500,1.58362727}, {3550,1.82122727}, {3600,1.34905455}, {3650,1.45673636}, {3700,1.67692727}, {3750,1.68838182}, {3800,1.71018182}, {3850,1.64091818}, {3900,1.87333636}, {3950,2.00525455}, {4000,1.65913636}, {4050,1.92003636}, {4100,1.52783636}, {4150,1.82985455}, {4200,1.75002727}, {4250,1.88216364}, {4300,1.91422727}, {4350,2.32694545}, {4400,1.82551818}, {4450,1.96296364}, {4500,1.98407273}, {4550,2.12415455}, {4600,2.29657273}, {4650,2.05379091}, {4700,2.17970909}, {4750,2.23589091}, {4800,1.96869091}, {4850,2.41243636}, {4900,2.13476364}, {4950,2.46301818}, {5000,2.16481818}, {5050,2.64352727}, {5100,2.67346364}, {5150,2.44557273}, {5200,2.12761818}, {5250,2.15105455}, {5300,2.45211818}, {5350,2.65173636}, {5400,2.35007273}, {5450,2.51114545}, {5500,2.86314545}, {5550,2.91389091}, {5600,2.51770000}, {5650,2.43379091}, {5700,2.40271818}, {5750,2.95140909}, {5800,2.56055455}, {5850,2.96839091}, {5900,2.61045455}, {5950,3.13040000}, {6000,2.79263636}, {6050,2.90050}, {6100,3.08375}, {6150,2.54725}, {6200,2.72325}, {6250,2.94900}, {6300,2.93450}, {6350,3.11100}, {6400,2.44850}, {6450,2.98375}, {6500,2.99150}, {6550,3.22350}, {6600,3.02325}, {6650,3.70775}, {6700,3.10375}, {6750,3.52300}, {6800,2.90800}, {6850,3.13100}, {6900,3.57475}, {6950,3.39925}, {7000,3.43900}, {7050,3.44050}, {7100,3.88275}, {7150,4.17400}, {7200,2.89625}, {7250,3.35525}, {7300,3.12050}, {7350,3.74250}, {7400,3.61025}, {7450,3.62350}, {7500,3.65175}, {7550,4.48850}, {7600,3.66550}, {7650,3.90525}, {7700,3.48300}, {7750,3.74500}, {7800,4.01675}, {7850,3.96700}, {7900,4.32675}, {7950,4.03850}, {8000,3.55075}, {8050,4.40675}, {8100,4.07275}, {8150,4.61350}, {8200,3.23275}, {8250,3.96050}, {8300,3.93825}, {8350,4.19450}, {8400,3.77525}, {8450,3.53250}, {8500,3.97950}, {8550,4.29000}, {8600,3.99700}, {8650,4.31925}, {8700,4.83825}, {8750,4.38025}, {8800,3.86350}, {8850,4.17825}, {8900,4.16000}, {8950,4.99125}, {9000,4.15575}, {9050,4.71750}, {9100,4.46425}, {9150,5.39850}, {9200,4.79000}, {9250,4.03850}, {9300,4.33850}, {9350,4.28550}, {9400,4.63075}, {9450,4.93150}, {9500,4.60400}, {9550,4.96875}, {9600,4.15250}, {9650,4.93400}, {9700,4.95525}, {9750,4.75175}, {9800,4.47275}, {9850,5.45300}, {9900,5.08525}, {9950,5.80200}, {10000,4.52450}, {10100,5.47075}, {10200,5.51225}, {10300,5.10475}, {10400,4.46600}, {10500,4.48475}, {10600,5.18450}, {10700,5.56300}, {10800,4.91550}, {10900,5.30350}, {11000,6.01350}, {11100,6.04900}, {11200,5.30600}, {11300,5.16600}, {11400,5.13725}, {11500,6.14650}, {11600,5.57475}, {11700,6.34125}, {11800,5.65125}, {11900,6.83225}, {12000,6.04275}, {12100,6.03750}, {12200,6.60850}, {12300,5.42525}, {12400,5.77450}, {12500,6.14750}, {12600,6.19350}, {12700,6.69150}, {12800,5.18875}, {12900,6.32400}, {13000,6.26550}, {13100,6.78175}, {13200,6.41125}, {13300,7.86125}, {13400,6.57200}, {13500,7.42900}, {13600,6.18400}, {13700,6.64925}, {13800,7.56300}, {13900,7.12550}, {14000,7.07975}, {14100,7.19525}, {14200,8.29150}, {14300,8.92925}, {14400,6.17825}, {14500,7.03950}, {14600,6.70475}, {14700,8.16900}, {14800,7.66975}, {14900,7.66350}, {15000,7.75025}, {15100,9.29650}, {15200,7.86775}, {15300,8.39200}, {15400,7.41325}, {15500,7.95025}, {15600,8.37250}, {15700,8.58325}, {15800,9.18750}, {15900,8.68550}, {16000,7.52950}, {16100,9.16250}, {16200,8.66425}, {16300,9.81300}, {16400,6.88550}, {16500,8.50350}, {16600,8.40700}, {16700,9.00775}, {16800,7.93150}, {16900,7.56150}, {17000,8.56375}, {17100,9.33375}, {17200,8.67450}, {17300,9.20375}, {17400,10.63350}, {17500,9.29825}, {17600,8.28225}, {17700,8.87575}, {17800,8.80750}, {17900,10.93075}, {18000,8.96375}, {18100,10.40550}, {18200,9.76575}, {18300,11.69200}, {18400,10.32250}, {18500,8.64875}, {18600,9.29500}, {18700,9.30525}, {18800,9.87500}, {18900,10.56300}, {19000,10.07175}, {19100,10.72200}, {19200,8.93400}, {19300,10.96300}, {19400,10.85925}, {19500,10.27875}, {19600,9.68575}, {19700,11.82350}, {19800,11.08950}, {19900,12.71250}, {20000,9.7690}};
data["big_flat"]["CanonicalStructuresPHOAS"]["reif"]["user"] = {{1,0.00030631}, {2,0.00064865}, {3,0.00103604}, {4,0.00082883}, {5,0.00150450}, {6,0.00107207}, {7,0.00163063}, {8,0.00181081}, {9,0.00220721}, {10,0.00233333}, {11,0.00252252}, {12,0.00270270}, {13,0.00270270}, {14,0.00282883}, {15,0.00351351}, {16,0.00340541}, {17,0.00353153}, {18,0.00382883}, {19,0.00398198}, {20,0.00422523}, {21,0.00494595}, {22,0.00522523}, {23,0.00528829}, {24,0.00684685}, {25,0.00637838}, {26,0.00586486}, {27,0.00690090}, {28,0.00657658}, {29,0.00721622}, {30,0.00740541}, {31,0.00811712}, {32,0.00866667}, {33,0.00828829}, {34,0.00833333}, {35,0.00879279}, {36,0.00900000}, {37,0.00972973}, {38,0.00963964}, {39,0.01026126}, {40,0.00972072}, {41,0.01028829}, {42,0.01056757}, {43,0.01139640}, {44,0.01127027}, {45,0.01189189}, {46,0.01222523}, {47,0.01293694}, {48,0.01198198}, {49,0.01249550}, {50,0.01288288}, {51,0.01334234}, {52,0.01280180}, {53,0.01364865}, {54,0.01394595}, {55,0.01465766}, {56,0.01381982}, {57,0.01449550}, {58,0.01470270}, {59,0.01674775}, {60,0.01479279}, {61,0.01586486}, {62,0.01626126}, {63,0.01920721}, {64,0.01545045}, {65,0.01642342}, {66,0.01654054}, {67,0.01926126}, {68,0.01724324}, {69,0.01804505}, {70,0.01815315}, {71,0.01939640}, {72,0.01823423}, {73,0.01918018}, {74,0.02124324}, {75,0.02068468}, {76,0.01986486}, {77,0.02125225}, {78,0.02118018}, {79,0.02245045}, {80,0.02017117}, {81,0.02249550}, {82,0.02138739}, {83,0.02280180}, {84,0.02414414}, {85,0.02291892}, {86,0.02372973}, {87,0.02612613}, {88,0.02312613}, {89,0.02418018}, {90,0.02595495}, {91,0.02557658}, {92,0.02497297}, {93,0.02726126}, {94,0.02598198}, {95,0.02730631}, {96,0.02436036}, {97,0.02564865}, {98,0.02729730}, {99,0.02714414}, {100,0.02588288}, {101,0.02904505}, {102,0.02718018}, {103,0.02900000}, {104,0.02706306}, {105,0.02830631}, {106,0.02957658}, {107,0.03005405}, {108,0.02921622}, {109,0.03071171}, {110,0.03072973}, {111,0.03381982}, {112,0.02877477}, {113,0.03245946}, {114,0.03082883}, {115,0.03239640}, {116,0.03130631}, {117,0.03296396}, {118,0.03451351}, {119,0.03486486}, {120,0.03427928}, {121,0.03425225}, {122,0.03617117}, {123,0.03599099}, {124,0.03705405}, {125,0.03649550}, {126,0.03665766}, {127,0.03869369}, {128,0.03315315}, {129,0.03455856}, {130,0.03490991}, {131,0.03686486}, {132,0.03561261}, {133,0.03741441}, {134,0.03711712}, {135,0.03904505}, {136,0.03638739}, {137,0.03797297}, {138,0.03830631}, {139,0.03988288}, {140,0.03847748}, {141,0.04077477}, {142,0.04253153}, {143,0.04268468}, {144,0.03902703}, {145,0.03969369}, {146,0.04163964}, {147,0.04230631}, {148,0.04236937}, {149,0.04266667}, {150,0.04342342}, {151,0.04581982}, {152,0.04168468}, {153,0.04501802}, {154,0.04442342}, {155,0.04778378}, {156,0.04461261}, {157,0.04713514}, {158,0.04853153}, {159,0.04972973}, {160,0.04339640}, {161,0.04451351}, {162,0.04487387}, {163,0.04841441}, {164,0.04496396}, {165,0.04877477}, {166,0.04769369}, {167,0.05006306}, {168,0.04809009}, {169,0.04888288}, {170,0.04906306}, {171,0.05375676}, {172,0.04922523}, {173,0.05259459}, {174,0.05171171}, {175,0.05463964}, {176,0.04941441}, {177,0.05014414}, {178,0.05068468}, {179,0.05465766}, {180,0.05107207}, {181,0.05403604}, {182,0.05582883}, {183,0.05711712}, {184,0.05192793}, {185,0.05630631}, {186,0.05770270}, {187,0.05807207}, {188,0.05556757}, {189,0.06011712}, {190,0.05882883}, {191,0.06174775}, {192,0.05200000}, {193,0.05326126}, {194,0.05319820}, {195,0.05772973}, {196,0.05700901}, {197,0.05689189}, {198,0.05710811}, {199,0.06161261}, {200,0.05743243}, {201,0.05807207}, {202,0.05854054}, {203,0.06247748}, {204,0.06143243}, {205,0.06182883}, {206,0.06210811}, {207,0.06675676}, {208,0.05985586}, {209,0.06018018}, {210,0.06050450}, {211,0.06314414}, {212,0.06227928}, {213,0.06609009}, {214,0.06417117}, {215,0.06752252}, {216,0.06263063}, {217,0.06730631}, {218,0.06749550}, {219,0.06893694}, {220,0.06576577}, {221,0.06916216}, {222,0.07088288}, {223,0.07557658}, {224,0.06473874}, {225,0.06407207}, {226,0.06431532}, {227,0.06794595}, {228,0.06610811}, {229,0.07126126}, {230,0.07180180}, {231,0.07303604}, {232,0.06605405}, {233,0.06962162}, {234,0.07122523}, {235,0.07712613}, {236,0.07394595}, {237,0.07771171}, {238,0.07727027}, {239,0.07842342}, {240,0.06820721}, {241,0.07209910}, {242,0.07216216}, {243,0.07689189}, {244,0.07563063}, {245,0.07909910}, {246,0.07880180}, {247,0.08290991}, {248,0.07548649}, {249,0.07901802}, {250,0.07796396}, {251,0.08178378}, {252,0.07794595}, {253,0.08212613}, {254,0.08225225}, {255,0.08674775}, {256,0.06930631}, {257,0.07359459}, {258,0.07585586}, {259,0.07957658}, {260,0.07602703}, {261,0.07978378}, {262,0.08010811}, {263,0.08452252}, {264,0.07684685}, {265,0.08080180}, {266,0.08112613}, {267,0.08516216}, {268,0.08143243}, {269,0.08545045}, {270,0.08552252}, {271,0.08990991}, {272,0.07885586}, {273,0.08327027}, {274,0.08327027}, {275,0.08700000}, {276,0.08362162}, {277,0.08780180}, {278,0.08753153}, {279,0.09295495}, {280,0.08500901}, {281,0.08890991}, {282,0.08943243}, {283,0.09395495}, {284,0.09014414}, {285,0.09479279}, {286,0.09204505}, {287,0.09709009}, {288,0.08094595}, {289,0.08485586}, {290,0.08491892}, {291,0.09187387}, {292,0.08752252}, {293,0.09194595}, {294,0.09250450}, {295,0.09736937}, {296,0.08875676}, {297,0.09377477}, {298,0.09447748}, {299,0.09646847}, {300,0.09164865}, {301,0.09667568}, {302,0.09865766}, {303,0.10381081}, {304,0.09060360}, {305,0.09597297}, {306,0.09598198}, {307,0.09854054}, {308,0.09435135}, {309,0.10155856}, {310,0.10069369}, {311,0.10661261}, {312,0.09727928}, {313,0.10263063}, {314,0.10014414}, {315,0.10903604}, {316,0.10245045}, {317,0.10807207}, {318,0.10845946}, {319,0.11177477}, {320,0.08927027}, {321,0.09633333}, {322,0.09596396}, {323,0.10092793}, {324,0.09714414}, {325,0.09967568}, {326,0.10221622}, {327,0.10706306}, {328,0.09769369}, {329,0.10311712}, {330,0.10059459}, {331,0.10849550}, {332,0.10335135}, {333,0.10896396}, {334,0.10730631}, {335,0.11486486}, {336,0.09924324}, {337,0.10479279}, {338,0.10536937}, {339,0.11079279}, {340,0.10553153}, {341,0.11127928}, {342,0.10979279}, {343,0.11735135}, {344,0.10650450}, {345,0.11231532}, {346,0.11013514}, {347,0.11770270}, {348,0.11245045}, {349,0.11884685}, {350,0.11895495}, {351,0.12480180}, {352,0.10426126}, {353,0.11096396}, {354,0.11081081}, {355,0.11544144}, {356,0.10826126}, {357,0.11532432}, {358,0.11649550}, {359,0.12034234}, {360,0.11057658}, {361,0.11690991}, {362,0.11486486}, {363,0.12254955}, {364,0.11854955}, {365,0.12164865}, {366,0.12295495}, {367,0.13103604}, {368,0.11346847}, {369,0.11845045}, {370,0.11959459}, {371,0.12560360}, {372,0.11957658}, {373,0.12367568}, {374,0.12533333}, {375,0.13309910}, {376,0.12060360}, {377,0.12621622}, {378,0.12518018}, {379,0.13344144}, {380,0.12757658}, {381,0.13412613}, {382,0.13459459}, {383,0.14197297}, {384,0.10973874}, {385,0.11321622}, {386,0.11589189}, {387,0.12139640}, {388,0.11660360}, {389,0.12236036}, {390,0.12060360}, {391,0.12836937}, {392,0.11736937}, {393,0.12311712}, {394,0.12333333}, {395,0.13008108}, {396,0.12323423}, {397,0.13065766}, {398,0.13072072}, {399,0.13659459}, {400,0.11863964}, {401,0.12542342}, {402,0.12501802}, {403,0.13563063}, {404,0.12568468}, {405,0.13095495}, {406,0.13254955}, {407,0.14329730}, {408,0.12690090}, {409,0.13605405}, {410,0.13456757}, {411,0.14181982}, {412,0.13382883}, {413,0.14094595}, {414,0.14123423}, {415,0.14864865}, {416,0.12281982}, {417,0.12978378}, {418,0.12992793}, {419,0.13600901}, {420,0.13084685}, {421,0.13734234}, {422,0.13799099}, {423,0.14456757}, {424,0.13107207}, {425,0.13756757}, {426,0.13779279}, {427,0.14562162}, {428,0.13875676}, {429,0.14589189}, {430,0.14599099}, {431,0.15446847}, {432,0.13318919}, {433,0.14049550}, {434,0.14100000}, {435,0.14754054}, {436,0.14129730}, {437,0.14792793}, {438,0.14804505}, {439,0.15632432}, {440,0.14196396}, {441,0.14955856}, {442,0.14939640}, {443,0.15731532}, {444,0.15013514}, {445,0.15809009}, {446,0.15772973}, {447,0.16699099}, {448,0.13258559}, {449,0.13836937}, {450,0.13945946}, {451,0.14584685}, {452,0.13903604}, {453,0.14652252}, {454,0.14629730}, {455,0.15429730}, {456,0.14062162}, {457,0.14860360}, {458,0.14706306}, {459,0.15590090}, {460,0.14768468}, {461,0.15594595}, {462,0.15680180}, {463,0.16471171}, {464,0.14254955}, {465,0.14962162}, {466,0.14961261}, {467,0.15768468}, {468,0.14991892}, {469,0.15891892}, {470,0.15844144}, {471,0.16568468}, {472,0.15110811}, {473,0.15923423}, {474,0.15936036}, {475,0.16763063}, {476,0.15942342}, {477,0.16835135}, {478,0.16900000}, {479,0.17809009}, {480,0.14748649}, {481,0.15393694}, {482,0.15495495}, {483,0.16227928}, {484,0.15472072}, {485,0.16267568}, {486,0.16237838}, {487,0.17222523}, {488,0.15572973}, {489,0.16360360}, {490,0.16764865}, {491,0.17434234}, {492,0.16494595}, {493,0.17318018}, {494,0.17324324}, {495,0.18199099}, {496,0.15884685}, {497,0.16590090}, {498,0.16613514}, {499,0.17551351}, {500,0.16700901}, {505,0.17692793}, {510,0.18627027}, {515,0.16531532}, {520,0.15912613}, {525,0.17483784}, {530,0.16775676}, {535,0.18763964}, {540,0.17919820}, {545,0.17154054}, {550,0.18218919}, {555,0.19599099}, {560,0.17956757}, {565,0.19608108}, {570,0.19689189}, {575,0.21984685}, {580,0.18233333}, {585,0.19331532}, {590,0.20497297}, {595,0.20571171}, {600,0.19672072}, {605,0.21949550}, {610,0.20078378}, {615,0.22271171}, {620,0.21209009}, {625,0.21387387}, {630,0.22813514}, {635,0.23964865}, {640,0.19190991}, {645,0.21293694}, {650,0.21386486}, {655,0.24070270}, {660,0.21526126}, {665,0.22958559}, {670,0.24318018}, {675,0.23814414}, {680,0.22272973}, {685,0.24983784}, {690,0.23519820}, {695,0.26501802}, {700,0.25155856}, {705,0.22950450}, {710,0.24435135}, {715,0.25689189}, {720,0.23399099}, {725,0.26217117}, {730,0.26128829}, {735,0.29399099}, {740,0.25228829}, {745,0.26817117}, {750,0.28202703}, {755,0.28189189}, {760,0.27094595}, {765,0.30256757}, {770,0.24605405}, {775,0.27449550}, {780,0.26165766}, {785,0.26110811}, {790,0.27411712}, {795,0.29100000}, {800,0.25194595}, {805,0.28033333}, {810,0.28116216}, {815,0.31453153}, {820,0.28221622}, {825,0.29882883}, {830,0.31901802}, {835,0.28893694}, {840,0.27507207}, {845,0.30690090}, {850,0.29312613}, {855,0.32754054}, {860,0.31985586}, {865,0.30081081}, {870,0.31530631}, {875,0.33423423}, {880,0.30493694}, {885,0.33678378}, {890,0.33837838}, {895,0.38013514}, {900,0.29468468}, {905,0.31233333}, {910,0.33056757}, {915,0.33173874}, {920,0.31644144}, {925,0.35273874}, {930,0.31853153}, {935,0.35473874}, {940,0.33927027}, {945,0.34030631}, {950,0.36122523}, {955,0.38136036}, {960,0.31263063}, {965,0.34648649}, {970,0.34572973}, {975,0.39320721}, {980,0.35068468}, {985,0.36932432}, {990,0.39518018}, {995,0.37410811}, {1000,0.35583784}, {1010,0.37774775}, {1020,0.40376577}, {1030,0.35122523}, {1040,0.33363063}, {1050,0.37462727}, {1060,0.35642727}, {1070,0.40015455}, {1080,0.38105455}, {1090,0.37083636}, {1100,0.38814545}, {1110,0.41463636}, {1120,0.37463636}, {1130,0.42184545}, {1140,0.42364545}, {1150,0.47213636}, {1160,0.38996364}, {1170,0.41184545}, {1180,0.43256364}, {1190,0.44238182}, {1200,0.42101818}, {1210,0.47427273}, {1220,0.42745455}, {1230,0.48009091}, {1240,0.46290000}, {1250,0.45956364}, {1260,0.48810909}, {1270,0.52136364}, {1280,0.40725455}, {1290,0.45397273}, {1300,0.45631818}, {1310,0.51387273}, {1320,0.46305455}, {1330,0.49160909}, {1340,0.52095455}, {1350,0.49716364}, {1360,0.47326364}, {1370,0.53360000}, {1380,0.50683636}, {1390,0.57120000}, {1400,0.54212727}, {1410,0.48830000}, {1420,0.52060909}, {1430,0.55720000}, {1440,0.49667273}, {1450,0.56269091}, {1460,0.56311818}, {1470,0.63638182}, {1480,0.53698182}, {1490,0.58052727}, {1500,0.60682727}, {1510,0.61102727}, {1520,0.58072727}, {1530,0.65498182}, {1540,0.51594545}, {1550,0.58230909}, {1560,0.55350909}, {1570,0.55524545}, {1580,0.58818182}, {1590,0.62638182}, {1600,0.53204545}, {1610,0.59848182}, {1620,0.60030000}, {1630,2.31730909}, {1640,0.61286364}, {1650,0.65331818}, {1660,0.68911818}, {1670,0.61933636}, {1680,0.59399091}, {1690,0.66369091}, {1700,0.62760000}, {1710,0.71466364}, {1720,0.67238182}, {1730,0.63615455}, {1740,0.67748182}, {1750,0.72401818}, {1760,0.64566364}, {1770,0.73053636}, {1780,0.72953636}, {1790,0.83049091}, {1800,0.62915455}, {1810,0.66767273}, {1820,0.71035455}, {1830,0.71525455}, {1840,0.67831818}, {1850,0.76818182}, {1860,0.69160909}, {1870,0.77626364}, {1880,0.73084545}, {1890,0.73359091}, {1900,0.77817273}, {1910,0.83162727}, {1920,0.66270000}, {1930,0.75375455}, {1940,0.75136364}, {1950,0.84062727}, {1960,0.75789091}, {1970,0.80443636}, {1980,0.86311818}, {1990,0.81230909}, {2000,0.77060000}, {2050,0.70778182}, {2100,0.81610000}, {2150,0.87868182}, {2200,0.84202727}, {2250,0.90830000}, {2300,1.05300909}, {2350,1.01757273}, {2400,0.91445455}, {2450,0.98845455}, {2500,0.99742727}, {2550,1.23084545}, {2600,0.99474545}, {2650,1.13766364}, {2700,1.08081818}, {2750,1.33588182}, {2800,1.18537273}, {2850,1.14187273}, {2900,1.23430000}, {2950,1.24742727}, {3000,1.35367273}, {3050,1.44542727}, {3100,1.26974545}, {3150,1.36670909}, {3200,1.14596364}, {3250,1.39829091}, {3300,1.41629091}, {3350,1.43298182}, {3400,1.36200000}, {3450,1.68542727}, {3500,1.58341818}, {3550,1.82068182}, {3600,1.34880909}, {3650,1.45606364}, {3700,1.67666364}, {3750,1.68822727}, {3800,1.70987273}, {3850,1.64084545}, {3900,1.87279091}, {3950,2.00500000}, {4000,1.65872727}, {4050,1.91953636}, {4100,1.52756364}, {4150,1.82935455}, {4200,1.74947273}, {4250,1.88148182}, {4300,1.91368182}, {4350,2.32626364}, {4400,1.82489091}, {4450,1.96216364}, {4500,1.98365455}, {4550,2.12364545}, {4600,2.29607273}, {4650,2.05367273}, {4700,2.17792727}, {4750,2.23433636}, {4800,1.96736364}, {4850,2.41069091}, {4900,2.13376364}, {4950,2.46160000}, {5000,2.16360909}, {5050,2.64210909}, {5100,2.67258182}, {5150,2.44535455}, {5200,2.12715455}, {5250,2.15074545}, {5300,2.45153636}, {5350,2.65149091}, {5400,2.34933636}, {5450,2.51047273}, {5500,2.86170909}, {5550,2.91285455}, {5600,2.51702727}, {5650,2.43315455}, {5700,2.40211818}, {5750,2.95107273}, {5800,2.55982727}, {5850,2.96797273}, {5900,2.61018182}, {5950,3.13012727}, {6000,2.79245455}, {6050,2.90050}, {6100,3.07925}, {6150,2.54500}, {6200,2.72350}, {6250,2.94975}, {6300,2.93300}, {6350,3.10875}, {6400,2.44625}, {6450,2.98500}, {6500,2.99075}, {6550,3.22350}, {6600,3.02350}, {6650,3.70725}, {6700,3.10175}, {6750,3.52350}, {6800,2.90575}, {6850,3.13150}, {6900,3.57350}, {6950,3.39975}, {7000,3.43525}, {7050,3.43675}, {7100,3.88100}, {7150,4.17150}, {7200,2.89525}, {7250,3.35150}, {7300,3.11950}, {7350,3.74075}, {7400,3.60850}, {7450,3.62225}, {7500,3.64800}, {7550,4.48750}, {7600,3.66400}, {7650,3.90000}, {7700,3.48125}, {7750,3.74375}, {7800,4.01425}, {7850,3.96475}, {7900,4.32550}, {7950,4.03700}, {8000,3.55050}, {8050,4.40650}, {8100,4.07100}, {8150,4.61150}, {8200,3.23250}, {8250,3.95925}, {8300,3.93650}, {8350,4.19325}, {8400,3.77550}, {8450,3.53250}, {8500,3.97725}, {8550,4.28850}, {8600,3.99650}, {8650,4.31750}, {8700,4.83525}, {8750,4.37875}, {8800,3.86225}, {8850,4.17725}, {8900,4.15825}, {8950,4.99025}, {9000,4.15400}, {9050,4.71775}, {9100,4.46425}, {9150,5.39675}, {9200,4.78725}, {9250,4.03775}, {9300,4.33725}, {9350,4.28400}, {9400,4.62850}, {9450,4.93050}, {9500,4.60400}, {9550,4.96775}, {9600,4.15050}, {9650,4.93275}, {9700,4.95225}, {9750,4.74925}, {9800,4.47475}, {9850,5.45350}, {9900,5.08600}, {9950,5.80250}, {10000,4.52425}, {10100,5.47000}, {10200,5.51375}, {10300,5.10450}, {10400,4.46600}, {10500,4.48375}, {10600,5.18475}, {10700,5.56125}, {10800,4.91725}, {10900,5.30125}, {11000,6.01425}, {11100,6.04950}, {11200,5.30550}, {11300,5.16750}, {11400,5.13975}, {11500,6.14550}, {11600,5.57250}, {11700,6.34125}, {11800,5.65050}, {11900,6.83175}, {12000,6.04300}, {12100,6.03850}, {12200,6.60775}, {12300,5.42425}, {12400,5.77475}, {12500,6.14625}, {12600,6.19125}, {12700,6.69225}, {12800,5.18850}, {12900,6.32500}, {13000,6.26675}, {13100,6.78050}, {13200,6.41325}, {13300,7.86150}, {13400,6.57150}, {13500,7.42725}, {13600,6.18275}, {13700,6.64725}, {13800,7.56350}, {13900,7.12550}, {14000,7.07800}, {14100,7.19075}, {14200,8.28825}, {14300,8.92675}, {14400,6.17575}, {14500,7.03600}, {14600,6.70425}, {14700,8.16850}, {14800,7.66900}, {14900,7.66325}, {15000,7.75100}, {15100,9.29575}, {15200,7.86725}, {15300,8.39150}, {15400,7.41200}, {15500,7.94925}, {15600,8.37150}, {15700,8.58400}, {15800,9.18800}, {15900,8.68475}, {16000,7.52850}, {16100,9.15950}, {16200,8.66150}, {16300,9.80725}, {16400,6.88525}, {16500,8.50275}, {16600,8.40650}, {16700,9.00825}, {16800,7.93075}, {16900,7.56300}, {17000,8.56175}, {17100,9.33275}, {17200,8.67600}, {17300,9.20400}, {17400,10.63375}, {17500,9.29850}, {17600,8.28175}, {17700,8.87650}, {17800,8.80725}, {17900,10.93075}, {18000,8.96350}, {18100,10.40475}, {18200,9.76625}, {18300,11.69000}, {18400,10.32000}, {18500,8.64950}, {18600,9.29325}, {18700,9.30500}, {18800,9.87675}, {18900,10.56225}, {19000,10.06975}, {19100,10.72225}, {19200,8.93275}, {19300,10.96375}, {19400,10.85850}, {19500,10.27475}, {19600,9.68250}, {19700,11.82150}, {19800,11.08800}, {19900,12.71025}, {20000,9.7660}};
data["big_flat"]["CanonicalStructuresPHOAS"]["reif"]["system"] = {{1,0.00000000}, {2,0.00003604}, {3,0.00000000}, {4,0.00006306}, {5,0.00002703}, {6,0.00003604}, {7,0.00000000}, {8,0.00010811}, {9,0.00013514}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00007207}, {15,0.00007207}, {16,0.00000000}, {17,0.00006306}, {18,0.00003604}, {19,0.00003604}, {20,0.00010811}, {21,0.00007207}, {22,0.00000000}, {23,0.00002703}, {24,0.00003604}, {25,0.00003604}, {26,0.00003604}, {27,0.00000000}, {28,0.00007207}, {29,0.00007207}, {30,0.00003604}, {31,0.00000000}, {32,0.00007207}, {33,0.00000000}, {34,0.00003604}, {35,0.00003604}, {36,0.00003604}, {37,0.00003604}, {38,0.00007207}, {39,0.00009910}, {40,0.00003604}, {41,0.00000000}, {42,0.00003604}, {43,0.00000000}, {44,0.00007207}, {45,0.00003604}, {46,0.00000000}, {47,0.00000000}, {48,0.00003604}, {49,0.00000000}, {50,0.00002703}, {51,0.00000000}, {52,0.00009910}, {53,0.00007207}, {54,0.00003604}, {55,0.00000000}, {56,0.00000000}, {57,0.00007207}, {58,0.00007207}, {59,0.00000000}, {60,0.00007207}, {61,0.00003604}, {62,0.00000000}, {63,0.00000000}, {64,0.00003604}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00003604}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00003604}, {73,0.00000000}, {74,0.00003604}, {75,0.00003604}, {76,0.00003604}, {77,0.00000000}, {78,0.00003604}, {79,0.00000000}, {80,0.00003604}, {81,0.00000000}, {82,0.00003604}, {83,0.00003604}, {84,0.00007207}, {85,0.00007207}, {86,0.00007207}, {87,0.00010811}, {88,0.00003604}, {89,0.00003604}, {90,0.00007207}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00006306}, {95,0.00006306}, {96,0.00003604}, {97,0.00003604}, {98,0.00000000}, {99,0.00000000}, {100,0.00002703}, {101,0.00003604}, {102,0.00021622}, {103,0.00007207}, {104,0.00003604}, {105,0.00010811}, {106,0.00007207}, {107,0.00007207}, {108,0.00003604}, {109,0.00000000}, {110,0.00003604}, {111,0.00003604}, {112,0.00000000}, {113,0.00014414}, {114,0.00003604}, {115,0.00003604}, {116,0.00003604}, {117,0.00007207}, {118,0.00010811}, {119,0.00003604}, {120,0.00003604}, {121,0.00000000}, {122,0.00007207}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00006306}, {128,0.00003604}, {129,0.00006306}, {130,0.00003604}, {131,0.00003604}, {132,0.00003604}, {133,0.00003604}, {134,0.00003604}, {135,0.00007207}, {136,0.00007207}, {137,0.00003604}, {138,0.00007207}, {139,0.00003604}, {140,0.00000000}, {141,0.00000000}, {142,0.00007207}, {143,0.00007207}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00003604}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00003604}, {153,0.00007207}, {154,0.00000000}, {155,0.00007207}, {156,0.00000000}, {157,0.00003604}, {158,0.00010811}, {159,0.00006306}, {160,0.00003604}, {161,0.00000000}, {162,0.00000000}, {163,0.00007207}, {164,0.00003604}, {165,0.00003604}, {166,0.00000000}, {167,0.00003604}, {168,0.00000000}, {169,0.00000000}, {170,0.00013514}, {171,0.00002703}, {172,0.00000000}, {173,0.00003604}, {174,0.00007207}, {175,0.00000000}, {176,0.00003604}, {177,0.00003604}, {178,0.00003604}, {179,0.00010811}, {180,0.00003604}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00003604}, {186,0.00007207}, {187,0.00003604}, {188,0.00003604}, {189,0.00007207}, {190,0.00014414}, {191,0.00010811}, {192,0.00003604}, {193,0.00003604}, {194,0.00003604}, {195,0.00003604}, {196,0.00000000}, {197,0.00007207}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00002703}, {202,0.00010811}, {203,0.00003604}, {204,0.00003604}, {205,0.00000000}, {206,0.00000000}, {207,0.00003604}, {208,0.00003604}, {209,0.00010811}, {210,0.00010811}, {211,0.00000000}, {212,0.00003604}, {213,0.00007207}, {214,0.00000000}, {215,0.00000000}, {216,0.00003604}, {217,0.00006306}, {218,0.00000000}, {219,0.00003604}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00003604}, {224,0.00003604}, {225,0.00000000}, {226,0.00000000}, {227,0.00007207}, {228,0.00000000}, {229,0.00003604}, {230,0.00007207}, {231,0.00000000}, {232,0.00007207}, {233,0.00000000}, {234,0.00003604}, {235,0.00000000}, {236,0.00003604}, {237,0.00000000}, {238,0.00003604}, {239,0.00000000}, {240,0.00007207}, {241,0.00000000}, {242,0.00000000}, {243,0.00003604}, {244,0.00000000}, {245,0.00007207}, {246,0.00003604}, {247,0.00000000}, {248,0.00007207}, {249,0.00010811}, {250,0.00006306}, {251,0.00000000}, {252,0.00000000}, {253,0.00003604}, {254,0.00003604}, {255,0.00000000}, {256,0.00003604}, {257,0.00003604}, {258,0.00007207}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00007207}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00007207}, {268,0.00003604}, {269,0.00000000}, {270,0.00003604}, {271,0.00003604}, {272,0.00003604}, {273,0.00003604}, {274,0.00003604}, {275,0.00003604}, {276,0.00003604}, {277,0.00007207}, {278,0.00007207}, {279,0.00007207}, {280,0.00000000}, {281,0.00006306}, {282,0.00003604}, {283,0.00003604}, {284,0.00003604}, {285,0.00018018}, {286,0.00007207}, {287,0.00003604}, {288,0.00009910}, {289,0.00003604}, {290,0.00010811}, {291,0.00018018}, {292,0.00003604}, {293,0.00006306}, {294,0.00010811}, {295,0.00010811}, {296,0.00010811}, {297,0.00007207}, {298,0.00003604}, {299,0.00007207}, {300,0.00003604}, {301,0.00007207}, {302,0.00000000}, {303,0.00003604}, {304,0.00010811}, {305,0.00003604}, {306,0.00003604}, {307,0.00003604}, {308,0.00003604}, {309,0.00003604}, {310,0.00000000}, {311,0.00010811}, {312,0.00007207}, {313,0.00000000}, {314,0.00007207}, {315,0.00009910}, {316,0.00003604}, {317,0.00000000}, {318,0.00000000}, {319,0.00003604}, {320,0.00007207}, {321,0.00005405}, {322,0.00003604}, {323,0.00003604}, {324,0.00009910}, {325,0.00010811}, {326,0.00003604}, {327,0.00014414}, {328,0.00010811}, {329,0.00010811}, {330,0.00007207}, {331,0.00007207}, {332,0.00000000}, {333,0.00003604}, {334,0.00010811}, {335,0.00000000}, {336,0.00003604}, {337,0.00007207}, {338,0.00007207}, {339,0.00007207}, {340,0.00007207}, {341,0.00000000}, {342,0.00007207}, {343,0.00003604}, {344,0.00000000}, {345,0.00000000}, {346,0.00003604}, {347,0.00003604}, {348,0.00007207}, {349,0.00000000}, {350,0.00003604}, {351,0.00003604}, {352,0.00006306}, {353,0.00003604}, {354,0.00000000}, {355,0.00006306}, {356,0.00000000}, {357,0.00003604}, {358,0.00007207}, {359,0.00000000}, {360,0.00002703}, {361,0.00007207}, {362,0.00000000}, {363,0.00003604}, {364,0.00000000}, {365,0.00000000}, {366,0.00010811}, {367,0.00000000}, {368,0.00000000}, {369,0.00007207}, {370,0.00003604}, {371,0.00007207}, {372,0.00000000}, {373,0.00000000}, {374,0.00007207}, {375,0.00000000}, {376,0.00003604}, {377,0.00007207}, {378,0.00000000}, {379,0.00007207}, {380,0.00003604}, {381,0.00003604}, {382,0.00007207}, {383,0.00003604}, {384,0.00006306}, {385,0.00000000}, {386,0.00003604}, {387,0.00000000}, {388,0.00007207}, {389,0.00000000}, {390,0.00007207}, {391,0.00000000}, {392,0.00007207}, {393,0.00000000}, {394,0.00003604}, {395,0.00003604}, {396,0.00007207}, {397,0.00010811}, {398,0.00007207}, {399,0.00003604}, {400,0.00003604}, {401,0.00003604}, {402,0.00000000}, {403,0.00003604}, {404,0.00010811}, {405,0.00006306}, {406,0.00009910}, {407,0.00007207}, {408,0.00013514}, {409,0.00000000}, {410,0.00003604}, {411,0.00007207}, {412,0.00007207}, {413,0.00007207}, {414,0.00010811}, {415,0.00010811}, {416,0.00010811}, {417,0.00007207}, {418,0.00007207}, {419,0.00003604}, {420,0.00000000}, {421,0.00003604}, {422,0.00028829}, {423,0.00003604}, {424,0.00003604}, {425,0.00003604}, {426,0.00010811}, {427,0.00010811}, {428,0.00003604}, {429,0.00007207}, {430,0.00007207}, {431,0.00003604}, {432,0.00007207}, {433,0.00007207}, {434,0.00000000}, {435,0.00003604}, {436,0.00000000}, {437,0.00003604}, {438,0.00007207}, {439,0.00000000}, {440,0.00003604}, {441,0.00006306}, {442,0.00006306}, {443,0.00000000}, {444,0.00010811}, {445,0.00007207}, {446,0.00007207}, {447,0.00000000}, {448,0.00009910}, {449,0.00000000}, {450,0.00003604}, {451,0.00003604}, {452,0.00007207}, {453,0.00003604}, {454,0.00007207}, {455,0.00003604}, {456,0.00010811}, {457,0.00003604}, {458,0.00014414}, {459,0.00010811}, {460,0.00003604}, {461,0.00014414}, {462,0.00003604}, {463,0.00007207}, {464,0.00007207}, {465,0.00032432}, {466,0.00017117}, {467,0.00003604}, {468,0.00003604}, {469,0.00013514}, {470,0.00007207}, {471,0.00014414}, {472,0.00013514}, {473,0.00013514}, {474,0.00013514}, {475,0.00006306}, {476,0.00003604}, {477,0.00003604}, {478,0.00014414}, {479,0.00007207}, {480,0.00043243}, {481,0.00027928}, {482,0.00018018}, {483,0.00021622}, {484,0.00017117}, {485,0.00007207}, {486,0.00018018}, {487,0.00010811}, {488,0.00007207}, {489,0.00007207}, {490,0.00017117}, {491,0.00007207}, {492,0.00010811}, {493,0.00003604}, {494,0.00007207}, {495,0.00003604}, {496,0.00018018}, {497,0.00010811}, {498,0.00003604}, {499,0.00010811}, {500,0.00000000}, {505,0.00002703}, {510,0.00010811}, {515,0.00014414}, {520,0.00003604}, {525,0.00003604}, {530,0.00014414}, {535,0.00010811}, {540,0.00010811}, {545,0.00007207}, {550,0.00003604}, {555,0.00010811}, {560,0.00018018}, {565,0.00021622}, {570,0.00006306}, {575,0.00024324}, {580,0.00010811}, {585,0.00020721}, {590,0.00024324}, {595,0.00010811}, {600,0.00016216}, {605,0.00000000}, {610,0.00000000}, {615,0.00020721}, {620,0.00013514}, {625,0.00038739}, {630,0.00013514}, {635,0.00010811}, {640,0.00013514}, {645,0.00025225}, {650,0.00025225}, {655,0.00010811}, {660,0.00021622}, {665,0.00003604}, {670,0.00007207}, {675,0.00025225}, {680,0.00018018}, {685,0.00021622}, {690,0.00006306}, {695,0.00010811}, {700,0.00018018}, {705,0.00014414}, {710,0.00007207}, {715,0.00006306}, {720,0.00028829}, {725,0.00018018}, {730,0.00017117}, {735,0.00010811}, {740,0.00028829}, {745,0.00009910}, {750,0.00003604}, {755,0.00003604}, {760,0.00000000}, {765,0.00031532}, {770,0.00014414}, {775,0.00017117}, {780,0.00024324}, {785,0.00021622}, {790,0.00025225}, {795,0.00003604}, {800,0.00037838}, {805,0.00025225}, {810,0.00018018}, {815,0.00018018}, {820,0.00017117}, {825,0.00018018}, {830,0.00025225}, {835,0.00036036}, {840,0.00028829}, {845,0.00032432}, {850,0.00014414}, {855,0.00032432}, {860,0.00036036}, {865,0.00010811}, {870,0.00036036}, {875,0.00035135}, {880,0.00043243}, {885,0.00003604}, {890,0.00032432}, {895,0.00031532}, {900,0.00013514}, {905,0.00039640}, {910,0.00018018}, {915,0.00014414}, {920,0.00018018}, {925,0.00028829}, {930,0.00032432}, {935,0.00032432}, {940,0.00010811}, {945,0.00042342}, {950,0.00020721}, {955,0.00028829}, {960,0.00027928}, {965,0.00025225}, {970,0.00021622}, {975,0.00038739}, {980,0.00014414}, {985,0.00031532}, {990,0.00021622}, {995,0.00021622}, {1000,0.00018018}, {1010,0.00027027}, {1020,0.00046847}, {1030,0.00014414}, {1040,0.00010811}, {1050,0.00002727}, {1060,0.00014545}, {1070,0.00029091}, {1080,0.00024545}, {1090,0.00168182}, {1100,0.00014545}, {1110,0.00025455}, {1120,0.00017273}, {1130,0.00024545}, {1140,0.00021818}, {1150,0.00007273}, {1160,0.00029091}, {1170,0.00031818}, {1180,0.00020909}, {1190,0.00036364}, {1200,0.00010909}, {1210,0.00014545}, {1220,0.00021818}, {1230,0.00024545}, {1240,0.00021818}, {1250,0.00042727}, {1260,0.00050909}, {1270,0.00036364}, {1280,0.00034545}, {1290,0.00043636}, {1300,0.00032727}, {1310,0.00041818}, {1320,0.00029091}, {1330,0.00024545}, {1340,0.00032727}, {1350,0.00032727}, {1360,0.00036364}, {1370,0.00040000}, {1380,0.00029091}, {1390,0.00035455}, {1400,0.00024545}, {1410,0.00040000}, {1420,0.00043636}, {1430,0.00056364}, {1440,0.00047273}, {1450,0.00040000}, {1460,0.00025455}, {1470,0.00020909}, {1480,0.00046364}, {1490,0.00025455}, {1500,0.00038182}, {1510,0.00032727}, {1520,0.00003636}, {1530,0.00029091}, {1540,0.00010909}, {1550,0.00010000}, {1560,0.00007273}, {1570,0.00006364}, {1580,0.00003636}, {1590,0.00003636}, {1600,0.00014545}, {1610,0.00003636}, {1620,0.00025455}, {1630,0.00156364}, {1640,0.00007273}, {1650,0.00010909}, {1660,0.00021818}, {1670,0.00032727}, {1680,0.00021818}, {1690,0.00007273}, {1700,0.00006364}, {1710,0.00013636}, {1720,0.00013636}, {1730,0.00020909}, {1740,0.00010909}, {1750,0.00025455}, {1760,0.00010000}, {1770,0.00014545}, {1780,0.00017273}, {1790,0.00021818}, {1800,0.00021818}, {1810,0.00018182}, {1820,0.00029091}, {1830,0.00031818}, {1840,0.00021818}, {1850,0.00018182}, {1860,0.00010909}, {1870,0.00018182}, {1880,0.00010909}, {1890,0.00010909}, {1900,0.00014545}, {1910,0.00010000}, {1920,0.00018182}, {1930,0.00028182}, {1940,0.00007273}, {1950,0.00010909}, {1960,0.00010909}, {1970,0.00018182}, {1980,0.00018182}, {1990,0.00006364}, {2000,0.00000000}, {2050,0.00010909}, {2100,0.00003636}, {2150,0.00006364}, {2200,0.00000000}, {2250,0.00031818}, {2300,0.00053636}, {2350,0.00010909}, {2400,0.00010909}, {2450,0.00007273}, {2500,0.00018182}, {2550,0.00042727}, {2600,0.00014545}, {2650,0.00018182}, {2700,0.00021818}, {2750,0.00007273}, {2800,0.00010909}, {2850,0.00010909}, {2900,0.00010909}, {2950,0.00014545}, {3000,0.00018182}, {3050,0.00007273}, {3100,0.00007273}, {3150,0.00010909}, {3200,0.00018182}, {3250,0.00013636}, {3300,0.00018182}, {3350,0.00025455}, {3400,0.00021818}, {3450,0.00014545}, {3500,0.00010909}, {3550,0.00031818}, {3600,0.00010909}, {3650,0.00020909}, {3700,0.00020909}, {3750,0.00018182}, {3800,0.00010909}, {3850,0.00010000}, {3900,0.00018182}, {3950,0.00021818}, {4000,0.00018182}, {4050,0.00018182}, {4100,0.00021818}, {4150,0.00010909}, {4200,0.00021818}, {4250,0.00010909}, {4300,0.00012727}, {4350,0.00025455}, {4400,0.00014545}, {4450,0.00029091}, {4500,0.00024545}, {4550,0.00032727}, {4600,0.00014545}, {4650,0.00014545}, {4700,0.00138182}, {4750,0.00114545}, {4800,0.00112727}, {4850,0.00127273}, {4900,0.00090000}, {4950,0.00088182}, {5000,0.00105455}, {5050,0.00108182}, {5100,0.00065455}, {5150,0.00007273}, {5200,0.00017273}, {5250,0.00007273}, {5300,0.00014545}, {5350,0.00014545}, {5400,0.00020909}, {5450,0.00032727}, {5500,0.00053636}, {5550,0.00047273}, {5600,0.00047273}, {5650,0.00018182}, {5700,0.00024545}, {5750,0.00025455}, {5800,0.00027273}, {5850,0.00021818}, {5900,0.00025455}, {5950,0.00007273}, {6000,0.00007273}, {6050,0.00200}, {6100,0.00300}, {6150,0.00200}, {6200,0.00000}, {6250,0.00000}, {6300,0.00100}, {6350,0.00300}, {6400,0.00300}, {6450,0.00000}, {6500,0.00100}, {6550,0.00000}, {6600,0.00000}, {6650,0.00075}, {6700,0.00100}, {6750,0.00000}, {6800,0.00200}, {6850,0.00000}, {6900,0.00100}, {6950,0.00000}, {7000,0.00275}, {7050,0.00300}, {7100,0.00100}, {7150,0.00000}, {7200,0.00100}, {7250,0.00200}, {7300,0.00000}, {7350,0.00000}, {7400,0.00100}, {7450,0.00100}, {7500,0.00200}, {7550,0.00100}, {7600,0.00200}, {7650,0.00300}, {7700,0.00100}, {7750,0.00000}, {7800,0.00000}, {7850,0.00100}, {7900,0.00100}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00100}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00100}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00100}, {8950,0.00000}, {9000,0.00100}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00100}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00100}, {9450,0.00100}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00100}, {9750,0.00100}, {9800,0.00000}, {9850,0.00100}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00100}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00100}, {10600,0.00000}, {10700,0.00100}, {10800,0.00000}, {10900,0.00100}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00100}, {11600,0.00100}, {11700,0.00100}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00100}, {12400,0.00000}, {12500,0.00100}, {12600,0.00100}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00100}, {13200,0.00000}, {13300,0.00000}, {13400,0.00100}, {13500,0.00100}, {13600,0.00100}, {13700,0.00000}, {13800,0.00100}, {13900,0.00000}, {14000,0.00200}, {14100,0.00200}, {14200,0.00200}, {14300,0.00000}, {14400,0.00075}, {14500,0.00300}, {14600,0.00000}, {14700,0.00100}, {14800,0.00200}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00100}, {16000,0.00100}, {16100,0.00100}, {16200,0.00000}, {16300,0.00300}, {16400,0.00000}, {16500,0.00000}, {16600,0.00100}, {16700,0.00000}, {16800,0.00100}, {16900,0.00000}, {17000,0.00200}, {17100,0.00100}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00100}, {18200,0.00000}, {18300,0.00000}, {18400,0.00075}, {18500,0.00000}, {18600,0.00000}, {18700,0.00100}, {18800,0.00000}, {18900,0.00000}, {19000,0.00200}, {19100,0.00000}, {19200,0.00100}, {19300,0.00000}, {19400,0.00100}, {19500,0.00200}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["Ltac2"]["Aggregate"]["real"] = {{1,0.00103922}, {2,0.00100000}, {3,0.00100000}, {4,0.00100000}, {5,0.00102941}, {6,0.00123529}, {7,0.00200000}, {8,0.00200000}, {9,0.00200000}, {10,0.00200000}, {11,0.00205882}, {12,0.00218627}, {13,0.00253922}, {14,0.00298039}, {15,0.00300000}, {16,0.00300000}, {17,0.00309804}, {18,0.00319608}, {19,0.00350980}, {20,0.00369608}, {21,0.00419608}, {22,0.01426471}, {23,0.00401961}, {24,0.00400980}, {25,0.00407843}, {26,0.00442157}, {27,0.00500000}, {28,0.00500000}, {29,0.00505882}, {30,0.00509804}, {31,0.00534314}, {32,0.00509804}, {33,0.00570588}, {34,0.00602941}, {35,0.00611765}, {36,0.00610784}, {37,0.00613725}, {38,0.00623529}, {39,0.00769608}, {40,0.00655882}, {41,0.00711765}, {42,0.00708824}, {43,0.00716667}, {44,0.00709804}, {45,0.00804902}, {46,0.00812745}, {47,0.00817647}, {48,0.00810784}, {49,0.00809804}, {50,0.00809804}, {51,0.00894118}, {52,0.00908824}, {53,0.00906863}, {54,0.00904902}, {55,0.00944118}, {56,0.00904902}, {57,0.00942157}, {58,0.00979412}, {59,0.01005882}, {60,0.01005882}, {61,0.01112745}, {62,0.01038235}, {63,0.01105882}, {64,0.01005882}, {65,0.01073529}, {66,0.01094118}, {67,0.01115686}, {68,0.01107843}, {69,0.01143137}, {70,0.01224510}, {71,0.01207843}, {72,0.01134314}, {73,0.01212745}, {74,0.01217647}, {75,0.01304902}, {76,0.01238235}, {77,0.01313725}, {78,0.01375490}, {79,0.01404902}, {80,0.01282353}, {81,0.01316667}, {82,0.01337255}, {83,0.01413725}, {84,0.01425490}, {85,0.01420588}, {86,0.01429412}, {87,0.01506863}, {88,0.01411765}, {89,0.01503922}, {90,0.01507843}, {91,0.01628431}, {92,0.01516667}, {93,0.01605882}, {94,0.01612745}, {95,0.01706863}, {96,0.01508824}, {97,0.01652941}, {98,0.01610784}, {99,0.01681373}, {100,0.01613725}, {101,0.01706863}, {102,0.01799020}, {103,0.01798039}, {104,0.01687255}, {105,0.01744118}, {106,0.01760784}, {107,0.01826471}, {108,0.01845098}, {109,0.01878431}, {110,0.01899020}, {111,0.01965686}, {112,0.01801961}, {113,0.01937255}, {114,0.01900000}, {115,0.01976471}, {116,0.01909804}, {117,0.02100000}, {118,0.02010784}, {119,0.02108824}, {120,0.01959804}, {121,0.02053922}, {122,0.02150000}, {123,0.02140196}, {124,0.02099020}, {125,0.02189216}, {126,0.02285294}, {127,0.02302941}, {128,0.02005882}, {129,0.02100000}, {130,0.02110784}, {131,0.02300000}, {132,0.02129412}, {133,0.02221569}, {134,0.02236275}, {135,0.02422549}, {136,0.02204902}, {137,0.02302941}, {138,0.02308824}, {139,0.02497059}, {140,0.02321569}, {141,0.02421569}, {142,0.02429412}, {143,0.02628431}, {144,0.02315686}, {145,0.02409804}, {146,0.02429412}, {147,0.02618627}, {148,0.02433333}, {149,0.02548039}, {150,0.02673529}, {151,0.02682353}, {152,0.02504902}, {153,0.02606863}, {154,0.02699020}, {155,0.02727451}, {156,0.02641176}, {157,0.02852941}, {158,0.02792157}, {159,0.02910784}, {160,0.02550980}, {161,0.02737255}, {162,0.02677451}, {163,0.02800980}, {164,0.02798039}, {165,0.02819608}, {166,0.02827451}, {167,0.02937255}, {168,0.02804902}, {169,0.02882353}, {170,0.02901961}, {171,0.03083333}, {172,0.02916667}, {173,0.03029412}, {174,0.03135294}, {175,0.03181373}, {176,0.02881373}, {177,0.03093137}, {178,0.03009804}, {179,0.03122549}, {180,0.03119608}, {181,0.03162745}, {182,0.03171569}, {183,0.03389216}, {184,0.03109804}, {185,0.03235294}, {186,0.03328431}, {187,0.03351961}, {188,0.03263725}, {189,0.03479412}, {190,0.03402941}, {191,0.03642157}, {192,0.03043137}, {193,0.03195098}, {194,0.03300000}, {195,0.03324510}, {196,0.03224510}, {197,0.03428431}, {198,0.03371569}, {199,0.03524510}, {200,0.03358824}, {201,0.03415686}, {202,0.03431373}, {203,0.03663725}, {204,0.03455882}, {205,0.03706863}, {206,0.03624510}, {207,0.03760784}, {208,0.03505882}, {209,0.03535294}, {210,0.03547059}, {211,0.03796078}, {212,0.03577451}, {213,0.03821569}, {214,0.03731373}, {215,0.03896078}, {216,0.03719608}, {217,0.03793137}, {218,0.03891176}, {219,0.03942157}, {220,0.03820588}, {221,0.04025490}, {222,0.03983333}, {223,0.04228431}, {224,0.03643137}, {225,0.03879412}, {226,0.03805882}, {227,0.03943137}, {228,0.03917647}, {229,0.03986275}, {230,0.04093137}, {231,0.04156863}, {232,0.03995098}, {233,0.04028431}, {234,0.04055882}, {235,0.04322549}, {236,0.04087255}, {237,0.04340196}, {238,0.04249020}, {239,0.04495098}, {240,0.04018627}, {241,0.04258824}, {242,0.04177451}, {243,0.04345098}, {244,0.04293137}, {245,0.04358824}, {246,0.04507843}, {247,0.04549020}, {248,0.04357843}, {249,0.04419608}, {250,0.04519608}, {251,0.04619608}, {252,0.04532353}, {253,0.04621569}, {254,0.04707843}, {255,0.04830392}, {256,0.04202941}, {257,0.04260784}, {258,0.04393137}, {259,0.04459804}, {260,0.04454902}, {261,0.04491176}, {262,0.04501961}, {263,0.04752941}, {264,0.04354902}, {265,0.04682353}, {266,0.04550000}, {267,0.04851961}, {268,0.04586275}, {269,0.04889216}, {270,0.04789216}, {271,0.05090196}, {272,0.04471569}, {273,0.04791176}, {274,0.04680392}, {275,0.04989216}, {276,0.04715686}, {277,0.05000000}, {278,0.05061765}, {279,0.05101961}, {280,0.04843137}, {281,0.04950000}, {282,0.05033333}, {283,0.05165686}, {284,0.05059804}, {285,0.05186275}, {286,0.05269608}, {287,0.05388235}, {288,0.04844118}, {289,0.04923529}, {290,0.05061765}, {291,0.05314706}, {292,0.04945098}, {293,0.05247059}, {294,0.05160784}, {295,0.05437255}, {296,0.05001961}, {297,0.05301961}, {298,0.05215686}, {299,0.05531373}, {300,0.05437255}, {301,0.05460784}, {302,0.05517647}, {303,0.05670588}, {304,0.05205882}, {305,0.05323529}, {306,0.05451961}, {307,0.05676471}, {308,0.05364706}, {309,0.05653922}, {310,0.05597059}, {311,0.05885294}, {312,0.05571569}, {313,0.05638235}, {314,0.05705882}, {315,0.05862745}, {316,0.05771569}, {317,0.05986275}, {318,0.05890196}, {319,0.06188235}, {320,0.05226471}, {321,0.05553922}, {322,0.05550980}, {323,0.05676471}, {324,0.05550000}, {325,0.05680392}, {326,0.05826471}, {327,0.05996078}, {328,0.05532353}, {329,0.05839216}, {330,0.05758824}, {331,0.06078431}, {332,0.05903922}, {333,0.06011765}, {334,0.06125490}, {335,0.06329412}, {336,0.05647059}, {337,0.05946078}, {338,0.06017647}, {339,0.06111765}, {340,0.05998039}, {341,0.06169608}, {342,0.06243137}, {343,0.06479412}, {344,0.05957843}, {345,0.06298039}, {346,0.06310784}, {347,0.06428431}, {348,0.06300980}, {349,0.06600000}, {350,0.06700000}, {351,0.06704902}, {352,0.05982353}, {353,0.06318627}, {354,0.06131373}, {355,0.06433333}, {356,0.06317647}, {357,0.06400980}, {358,0.06469608}, {359,0.06740196}, {360,0.06216667}, {361,0.06549020}, {362,0.06543137}, {363,0.06732353}, {364,0.06600980}, {365,0.06815686}, {366,0.06751961}, {367,0.07044118}, {368,0.06407843}, {369,0.06667647}, {370,0.06599020}, {371,0.06952941}, {372,0.06699020}, {373,0.06888235}, {374,0.06913725}, {375,0.07200980}, {376,0.06749020}, {377,0.06923529}, {378,0.07033333}, {379,0.07293137}, {380,0.07005882}, {381,0.07216667}, {382,0.07323529}, {383,0.07600000}, {384,0.06356863}, {385,0.06505882}, {386,0.06640196}, {387,0.06890196}, {388,0.06720588}, {389,0.06812745}, {390,0.06907843}, {391,0.07158824}, {392,0.06604902}, {393,0.06973529}, {394,0.07039216}, {395,0.07202941}, {396,0.06905882}, {397,0.07286275}, {398,0.07298039}, {399,0.07500000}, {400,0.06716667}, {401,0.07052941}, {402,0.07129412}, {403,0.07335294}, {404,0.07231373}, {405,0.07303922}, {406,0.07400000}, {407,0.07662745}, {408,0.07149020}, {409,0.07355882}, {410,0.07491176}, {411,0.07757843}, {412,0.07474510}, {413,0.07746078}, {414,0.07666667}, {415,0.08067647}, {416,0.07119608}, {417,0.07329412}, {418,0.07345098}, {419,0.07527451}, {420,0.07400980}, {421,0.07688235}, {422,0.07655882}, {423,0.07940196}, {424,0.07319608}, {425,0.07726471}, {426,0.07740196}, {427,0.07976471}, {428,0.07702941}, {429,0.08063725}, {430,0.07944118}, {431,0.08359804}, {432,0.07578431}, {433,0.07836275}, {434,0.07788235}, {435,0.08129412}, {436,0.07760784}, {437,0.08200980}, {438,0.08224510}, {439,0.08481373}, {440,0.07912745}, {441,0.08150980}, {442,0.08203922}, {443,0.08611765}, {444,0.08170588}, {445,0.08572549}, {446,0.08602941}, {447,0.08862745}, {448,0.07583333}, {449,0.07841176}, {450,0.07861765}, {451,0.08065686}, {452,0.07904902}, {453,0.08244118}, {454,0.08224510}, {455,0.08479412}, {456,0.07923529}, {457,0.08240196}, {458,0.08322549}, {459,0.08476471}, {460,0.08300000}, {461,0.08646078}, {462,0.08620588}, {463,0.08915686}, {464,0.08053922}, {465,0.08327451}, {466,0.08320588}, {467,0.08703922}, {468,0.08543137}, {469,0.08603922}, {470,0.08754902}, {471,0.09119608}, {472,0.08522549}, {473,0.08821569}, {474,0.08793137}, {475,0.09080392}, {476,0.08788235}, {477,0.09069608}, {478,0.09047059}, {479,0.09360784}, {480,0.08251961}, {481,0.08574510}, {482,0.08650980}, {483,0.09037255}, {484,0.08577451}, {485,0.08982353}, {486,0.09078431}, {487,0.09375490}, {488,0.08763725}, {489,0.09098039}, {490,0.09071569}, {491,0.09374510}, {492,0.09064706}, {493,0.09396078}, {494,0.09407843}, {495,0.09744118}, {496,0.08838235}, {497,0.09156863}, {498,0.09166667}, {499,0.09473529}, {500,0.09182353}, {505,0.09540196}, {510,0.09934314}, {515,0.09230392}, {520,0.08978431}, {525,0.09685294}, {530,0.09421569}, {535,0.10258824}, {540,0.09977451}, {545,0.09736275}, {550,0.10179412}, {555,0.10648039}, {560,0.09999020}, {565,0.10844118}, {570,0.10867647}, {575,0.11462745}, {580,0.10290196}, {585,0.10769608}, {590,0.11178431}, {595,0.11325490}, {600,0.11086275}, {605,0.11748039}, {610,0.11087255}, {615,0.11941176}, {620,0.11729412}, {625,0.11941176}, {630,0.12134314}, {635,0.12677451}, {640,0.11011765}, {645,0.11983333}, {650,0.11814706}, {655,0.12765686}, {660,0.12193137}, {665,0.12425490}, {670,0.12962745}, {675,0.12784314}, {680,0.12327451}, {685,0.13242157}, {690,0.13040196}, {695,0.13732353}, {700,0.13611765}, {705,0.12618627}, {710,0.13222549}, {715,0.13752941}, {720,0.12920588}, {725,0.14034314}, {730,0.13863725}, {735,0.15002941}, {740,0.13623529}, {745,0.14324510}, {750,0.14650980}, {755,0.14842157}, {760,0.14424510}, {765,0.15403922}, {770,0.13576471}, {775,0.14522549}, {780,0.14169608}, {785,0.14186275}, {790,0.14810784}, {795,0.15376471}, {800,0.14150980}, {805,0.15077451}, {810,0.15130392}, {815,0.16261765}, {820,0.15315686}, {825,0.15847059}, {830,0.16620588}, {835,0.15500980}, {840,0.15085294}, {845,0.16263725}, {850,0.15805882}, {855,0.16790196}, {860,0.16507843}, {865,0.16047059}, {870,0.16574510}, {875,0.17089216}, {880,0.16246078}, {885,0.17510784}, {890,0.17447059}, {895,0.18613725}, {900,0.16143137}, {905,0.16655882}, {910,0.17401961}, {915,0.17681373}, {920,0.17051961}, {925,0.18193137}, {930,0.17120588}, {935,0.18270588}, {940,0.17727451}, {945,0.17877451}, {950,0.18612745}, {955,0.19203922}, {960,0.17107843}, {965,0.18404902}, {970,0.18572549}, {975,0.19725490}, {980,0.18624510}, {985,0.19266667}, {990,0.19973529}, {995,0.19363725}, {1000,0.18770588}, {1010,0.19482353}, {1020,0.20205882}, {1030,0.18860784}, {1040,0.18390196}, {1050,0.19804902}, {1060,0.19373529}, {1070,0.21061765}, {1080,0.20453922}, {1090,0.19863725}, {1100,0.20591176}, {1110,0.21432353}, {1120,0.20329412}, {1130,0.21977451}, {1140,0.21895098}, {1150,0.23709804}, {1160,0.21034314}, {1170,0.21835294}, {1180,0.22882353}, {1190,0.22862745}, {1200,0.22298039}, {1210,0.23967647}, {1220,0.22700000}, {1230,0.24350980}, {1240,0.23732353}, {1250,0.23985294}, {1260,0.24928431}, {1270,0.25556863}, {1280,0.22344118}, {1290,0.24030392}, {1300,0.24250980}, {1310,0.26031373}, {1320,0.24464706}, {1330,0.25507843}, {1340,0.26473529}, {1350,0.26050980}, {1360,0.25081373}, {1370,0.26928431}, {1380,0.26286275}, {1390,0.28090196}, {1400,0.27566667}, {1410,0.26210784}, {1420,0.26920588}, {1430,0.27976471}, {1440,0.26447059}, {1450,0.28147059}, {1460,0.28282353}, {1470,0.30374510}, {1480,0.28042157}, {1490,0.28956863}, {1500,0.30075490}, {1510,0.30172549}, {1520,0.29290196}, {1530,0.31266667}, {1540,0.28043137}, {1550,0.29849020}, {1560,0.29029412}, {1570,0.29069608}, {1580,0.30073529}, {1590,0.31339216}, {1600,0.28632353}, {1610,0.30701961}, {1620,0.30776471}, {1630,0.33021569}, {1640,0.31112745}, {1650,0.32357843}, {1660,0.33466667}, {1670,0.32013725}, {1680,0.30946078}, {1690,0.33028431}, {1700,0.32245098}, {1710,0.34505882}, {1720,0.33522549}, {1730,0.32705882}, {1740,0.33798039}, {1750,0.35107843}, {1760,0.33242157}, {1770,0.35482353}, {1780,0.35638235}, {1790,0.38075490}, {1800,0.33078431}, {1810,0.34169608}, {1820,0.35408824}, {1830,0.35679412}, {1840,0.34838235}, {1850,0.37143137}, {1860,0.35182353}, {1870,0.37418627}, {1880,0.36323529}, {1890,0.36539216}, {1900,0.38170588}, {1910,0.39296078}, {1920,0.34916667}, {1930,0.37440196}, {1940,0.37475490}, {1950,0.39934314}, {1960,0.38140196}, {1970,0.39233333}, {1980,0.40662745}, {1990,0.39834314}, {2000,0.38496078}, {2050,0.37500000}, {2100,0.40631373}, {2150,0.42807843}, {2200,0.42674510}, {2250,0.44566667}, {2300,0.48039216}, {2350,0.47988235}, {2400,0.45851961}, {2450,0.48255882}, {2500,0.49009804}, {2550,0.54304902}, {2600,0.49888235}, {2650,0.53678431}, {2700,0.53491176}, {2750,0.58879412}, {2800,0.56265686}, {2850,0.56114706}, {2900,0.58762745}, {2950,0.59133333}, {3000,0.61711765}, {3050,0.64542157}, {3100,0.61938235}, {3150,0.64408824}, {3200,0.59332353}, {3250,0.65978431}, {3300,0.66995098}, {3350,0.68348039}, {3400,0.66943137}, {3450,0.74136275}, {3500,0.72666667}, {3550,0.78568627}, {3600,0.68424510}, {3650,0.71611765}, {3700,0.77466667}, {3750,0.77826471}, {3800,0.78830392}, {3850,0.78141176}, {3900,0.82908824}, {3950,0.86620588}, {4000,0.79699020}, {4050,0.85544118}, {4100,0.77261765}, {4150,0.85895098}, {4200,0.84338235}, {4250,0.88087255}, {4300,0.88532353}, {4350,0.98424510}, {4400,0.87837255}, {4450,0.92335294}, {4500,0.92986275}, {4550,0.96200000}, {4600,0.99587255}, {4650,0.96212745}, {4700,0.99749020}, {4750,1.00969608}, {4800,0.95389216}, {4850,1.05326471}, {4900,0.99858824}, {4950,1.06877451}, {5000,1.02347059}, {5050,1.11825490}, {5100,1.12811765}, {5150,1.09467647}, {5200,1.04026471}, {5250,1.04900000}, {5300,1.12164706}, {5350,1.16117647}, {5400,1.11584314}, {5450,1.15495098}, {5500,1.22458824}, {5550,1.23372549}, {5600,1.17943137}, {5650,1.16251961}, {5700,1.18346078}, {5750,1.28331373}, {5800,1.22552941}, {5850,1.30766667}, {5900,1.24441176}, {5950,1.36297059}, {6000,1.29651961}, {6050,1.39325}, {6100,1.40425}, {6150,1.29025}, {6200,1.32600}, {6250,1.38425}, {6300,1.38850}, {6350,1.43450}, {6400,1.28075}, {6450,1.42075}, {6500,1.41450}, {6550,1.47800}, {6600,1.47175}, {6650,1.58400}, {6700,1.47825}, {6750,1.56225}, {6800,1.44175}, {6850,1.51075}, {6900,1.63150}, {6950,1.57850}, {7000,1.61850}, {7050,1.58975}, {7100,1.68800}, {7150,1.72875}, {7200,1.48125}, {7250,1.60175}, {7300,1.54050}, {7350,1.69325}, {7400,1.64925}, {7450,1.66125}, {7500,1.66800}, {7550,1.82750}, {7600,1.67950}, {7650,1.74875}, {7700,1.66975}, {7750,1.73225}, {7800,1.77500}, {7850,1.78350}, {7900,1.87325}, {7950,1.81150}, {8000,1.72325}, {8050,1.88025}, {8100,1.85600}, {8150,1.95300}, {8200,1.65550}, {8250,1.83900}, {8300,1.82900}, {8350,1.89125}, {8400,1.79600}, {8450,1.75900}, {8500,1.85175}, {8550,1.91700}, {8600,1.88025}, {8650,1.93100}, {8700,2.04475}, {8750,1.97675}, {8800,1.85725}, {8850,1.91175}, {8900,1.93100}, {8950,2.10725}, {9000,1.94725}, {9050,2.08050}, {9100,2.03325}, {9150,2.21300}, {9200,2.10075}, {9250,1.93875}, {9300,2.03025}, {9350,2.04000}, {9400,2.10175}, {9450,2.17925}, {9500,2.13350}, {9550,2.18775}, {9600,2.00525}, {9650,2.22975}, {9700,2.21500}, {9750,2.17625}, {9800,2.13000}, {9850,2.33100}, {9900,2.25875}, {9950,2.39350}, {10000,2.17675}, {10100,2.39425}, {10200,2.39225}, {10300,2.32050}, {10400,2.22075}, {10500,2.20725}, {10600,2.40550}, {10700,2.46100}, {10800,2.38225}, {10900,2.45200}, {11000,2.60625}, {11100,2.60900}, {11200,2.47375}, {11300,2.46325}, {11400,2.45925}, {11500,2.69375}, {11600,2.57800}, {11700,2.73375}, {11800,2.59500}, {11900,2.84300}, {12000,2.72925}, {12100,2.74250}, {12200,2.86450}, {12300,2.59450}, {12400,2.71475}, {12500,2.82100}, {12600,2.83075}, {12700,2.94575}, {12800,2.62925}, {12900,2.88350}, {13000,2.88950}, {13100,3.03175}, {13200,2.94250}, {13300,3.23575}, {13400,3.01125}, {13500,3.18950}, {13600,2.95600}, {13700,3.07700}, {13800,3.28175}, {13900,3.21225}, {14000,3.22750}, {14100,3.24625}, {14200,3.43250}, {14300,3.54900}, {14400,3.04075}, {14500,3.24200}, {14600,3.17100}, {14700,3.48900}, {14800,3.38525}, {14900,3.41875}, {15000,3.42525}, {15100,3.75950}, {15200,3.49050}, {15300,3.63450}, {15400,3.43000}, {15500,3.54750}, {15600,3.67950}, {15700,3.70000}, {15800,3.83450}, {15900,3.75075}, {16000,3.54850}, {16100,3.85850}, {16200,3.81375}, {16300,4.01900}, {16400,3.46175}, {16500,3.76875}, {16600,3.82300}, {16700,3.97875}, {16800,3.76675}, {16900,3.66825}, {17000,3.88900}, {17100,4.01850}, {17200,3.90200}, {17300,4.01675}, {17400,4.33125}, {17500,4.14525}, {17600,3.90625}, {17700,4.00775}, {17800,4.06450}, {17900,4.40350}, {18000,4.09700}, {18100,4.36900}, {18200,4.24400}, {18300,4.65275}, {18400,4.40550}, {18500,4.08500}, {18600,4.19625}, {18700,4.25400}, {18800,4.41850}, {18900,4.54700}, {19000,4.46150}, {19100,4.61725}, {19200,4.25250}, {19300,4.63675}, {19400,4.64475}, {19500,4.55425}, {19600,4.46575}, {19700,4.87075}, {19800,4.77050}, {19900,5.02125}, {20000,4.50550}};
data["big_flat"]["Ltac2"]["Aggregate"]["user"] = {{1,0.00093137}, {2,0.00132353}, {3,0.00121569}, {4,0.00164706}, {5,0.00136275}, {6,0.00170588}, {7,0.00179412}, {8,0.00187255}, {9,0.00177451}, {10,0.00210784}, {11,0.00253922}, {12,0.00218627}, {13,0.00220588}, {14,0.00280392}, {15,0.00271569}, {16,0.00287255}, {17,0.00304902}, {18,0.00312745}, {19,0.00320588}, {20,0.00336275}, {21,0.00408824}, {22,0.01425490}, {23,0.00393137}, {24,0.00386275}, {25,0.00413725}, {26,0.00438235}, {27,0.00458824}, {28,0.00473529}, {29,0.00522549}, {30,0.00539216}, {31,0.00521569}, {32,0.00548039}, {33,0.00536275}, {34,0.00571569}, {35,0.00602941}, {36,0.00570588}, {37,0.00619608}, {38,0.00673529}, {39,0.00800980}, {40,0.00678431}, {41,0.00705882}, {42,0.00710784}, {43,0.00737255}, {44,0.00734314}, {45,0.00780392}, {46,0.00806863}, {47,0.00823529}, {48,0.00792157}, {49,0.00832353}, {50,0.00834314}, {51,0.00862745}, {52,0.00946078}, {53,0.00894118}, {54,0.00958824}, {55,0.00980392}, {56,0.00940196}, {57,0.00993137}, {58,0.00956863}, {59,0.01046078}, {60,0.01043137}, {61,0.01141176}, {62,0.01045098}, {63,0.01118627}, {64,0.01046078}, {65,0.01100000}, {66,0.01085294}, {67,0.01180392}, {68,0.01139216}, {69,0.01186275}, {70,0.01266667}, {71,0.01229412}, {72,0.01194118}, {73,0.01272549}, {74,0.01270588}, {75,0.01300000}, {76,0.01273529}, {77,0.01343137}, {78,0.01399020}, {79,0.01384314}, {80,0.01288235}, {81,0.01354902}, {82,0.01394118}, {83,0.01387255}, {84,0.01406863}, {85,0.01472549}, {86,0.01441176}, {87,0.01484314}, {88,0.01416667}, {89,0.01441176}, {90,0.01488235}, {91,0.01621569}, {92,0.01508824}, {93,0.01567647}, {94,0.01574510}, {95,0.01676471}, {96,0.01502941}, {97,0.01649020}, {98,0.01578431}, {99,0.01678431}, {100,0.01594118}, {101,0.01677451}, {102,0.01798039}, {103,0.01746078}, {104,0.01664706}, {105,0.01726471}, {106,0.01755882}, {107,0.01850980}, {108,0.01834314}, {109,0.01862745}, {110,0.01868627}, {111,0.01978431}, {112,0.01807843}, {113,0.01926471}, {114,0.01870588}, {115,0.01976471}, {116,0.01916667}, {117,0.02122549}, {118,0.01988235}, {119,0.02116667}, {120,0.01984314}, {121,0.02109804}, {122,0.02188235}, {123,0.02150980}, {124,0.02107843}, {125,0.02215686}, {126,0.02305882}, {127,0.02303922}, {128,0.02018627}, {129,0.02099020}, {130,0.02148039}, {131,0.02350980}, {132,0.02164706}, {133,0.02251961}, {134,0.02319608}, {135,0.02442157}, {136,0.02208824}, {137,0.02299020}, {138,0.02353922}, {139,0.02502941}, {140,0.02369608}, {141,0.02459804}, {142,0.02457843}, {143,0.02657843}, {144,0.02336275}, {145,0.02436275}, {146,0.02466667}, {147,0.02611765}, {148,0.02462745}, {149,0.02565686}, {150,0.02671569}, {151,0.02677451}, {152,0.02503922}, {153,0.02637255}, {154,0.02684314}, {155,0.02720588}, {156,0.02644118}, {157,0.02835294}, {158,0.02762745}, {159,0.02896078}, {160,0.02538235}, {161,0.02735294}, {162,0.02651961}, {163,0.02758824}, {164,0.02758824}, {165,0.02821569}, {166,0.02805882}, {167,0.02930392}, {168,0.02770588}, {169,0.02879412}, {170,0.02881373}, {171,0.03090196}, {172,0.02883333}, {173,0.03029412}, {174,0.03131373}, {175,0.03174510}, {176,0.02877451}, {177,0.03047059}, {178,0.02989216}, {179,0.03118627}, {180,0.03129412}, {181,0.03180392}, {182,0.03183333}, {183,0.03415686}, {184,0.03066667}, {185,0.03250000}, {186,0.03363725}, {187,0.03332353}, {188,0.03293137}, {189,0.03505882}, {190,0.03368627}, {191,0.03695098}, {192,0.03000000}, {193,0.03196078}, {194,0.03294118}, {195,0.03363725}, {196,0.03200980}, {197,0.03462745}, {198,0.03408824}, {199,0.03538235}, {200,0.03382353}, {201,0.03466667}, {202,0.03457843}, {203,0.03683333}, {204,0.03484314}, {205,0.03725490}, {206,0.03630392}, {207,0.03775490}, {208,0.03533333}, {209,0.03566667}, {210,0.03595098}, {211,0.03764706}, {212,0.03608824}, {213,0.03823529}, {214,0.03722549}, {215,0.03851961}, {216,0.03750000}, {217,0.03798039}, {218,0.03828431}, {219,0.03890196}, {220,0.03827451}, {221,0.04020588}, {222,0.03953922}, {223,0.04216667}, {224,0.03663725}, {225,0.03873529}, {226,0.03794118}, {227,0.03933333}, {228,0.03896078}, {229,0.03965686}, {230,0.04057843}, {231,0.04131373}, {232,0.03965686}, {233,0.03999020}, {234,0.04032353}, {235,0.04314706}, {236,0.04050000}, {237,0.04333333}, {238,0.04297059}, {239,0.04470588}, {240,0.03971569}, {241,0.04221569}, {242,0.04185294}, {243,0.04342157}, {244,0.04283333}, {245,0.04344118}, {246,0.04505882}, {247,0.04554902}, {248,0.04377451}, {249,0.04394118}, {250,0.04554902}, {251,0.04633333}, {252,0.04559804}, {253,0.04641176}, {254,0.04730392}, {255,0.04846078}, {256,0.04174510}, {257,0.04275490}, {258,0.04399020}, {259,0.04508824}, {260,0.04462745}, {261,0.04499020}, {262,0.04497059}, {263,0.04752941}, {264,0.04362745}, {265,0.04699020}, {266,0.04577451}, {267,0.04865686}, {268,0.04634314}, {269,0.04892157}, {270,0.04796078}, {271,0.05074510}, {272,0.04484314}, {273,0.04815686}, {274,0.04691176}, {275,0.04986275}, {276,0.04733333}, {277,0.04987255}, {278,0.05059804}, {279,0.05062745}, {280,0.04862745}, {281,0.04930392}, {282,0.05008824}, {283,0.05154902}, {284,0.05033333}, {285,0.05157843}, {286,0.05270588}, {287,0.05343137}, {288,0.04874510}, {289,0.04933333}, {290,0.05032353}, {291,0.05294118}, {292,0.04959804}, {293,0.05201961}, {294,0.05123529}, {295,0.05409804}, {296,0.05009804}, {297,0.05295098}, {298,0.05180392}, {299,0.05502941}, {300,0.05418627}, {301,0.05437255}, {302,0.05493137}, {303,0.05675490}, {304,0.05193137}, {305,0.05283333}, {306,0.05385294}, {307,0.05713725}, {308,0.05307843}, {309,0.05675490}, {310,0.05624510}, {311,0.05885294}, {312,0.05578431}, {313,0.05639216}, {314,0.05705882}, {315,0.05863725}, {316,0.05795098}, {317,0.06019608}, {318,0.05902941}, {319,0.06191176}, {320,0.05175490}, {321,0.05572549}, {322,0.05553922}, {323,0.05686275}, {324,0.05542157}, {325,0.05666667}, {326,0.05857843}, {327,0.06011765}, {328,0.05525490}, {329,0.05868627}, {330,0.05765686}, {331,0.06094118}, {332,0.05928431}, {333,0.06016667}, {334,0.06135294}, {335,0.06302941}, {336,0.05614706}, {337,0.05971569}, {338,0.06007843}, {339,0.06124510}, {340,0.06015686}, {341,0.06144118}, {342,0.06234314}, {343,0.06435294}, {344,0.05984314}, {345,0.06310784}, {346,0.06297059}, {347,0.06411765}, {348,0.06297059}, {349,0.06589216}, {350,0.06664706}, {351,0.06709804}, {352,0.05997059}, {353,0.06298039}, {354,0.06142157}, {355,0.06409804}, {356,0.06318627}, {357,0.06379412}, {358,0.06422549}, {359,0.06752941}, {360,0.06174510}, {361,0.06551961}, {362,0.06493137}, {363,0.06700980}, {364,0.06612745}, {365,0.06800980}, {366,0.06735294}, {367,0.07056863}, {368,0.06365686}, {369,0.06650980}, {370,0.06559804}, {371,0.06960784}, {372,0.06693137}, {373,0.06875490}, {374,0.06965686}, {375,0.07230392}, {376,0.06738235}, {377,0.06942157}, {378,0.07059804}, {379,0.07295098}, {380,0.07031373}, {381,0.07242157}, {382,0.07305882}, {383,0.07567647}, {384,0.06343137}, {385,0.06468627}, {386,0.06623529}, {387,0.06880392}, {388,0.06726471}, {389,0.06813725}, {390,0.06915686}, {391,0.07170588}, {392,0.06556863}, {393,0.06949020}, {394,0.07055882}, {395,0.07224510}, {396,0.06912745}, {397,0.07288235}, {398,0.07307843}, {399,0.07472549}, {400,0.06690196}, {401,0.07051961}, {402,0.07099020}, {403,0.07349020}, {404,0.07219608}, {405,0.07323529}, {406,0.07380392}, {407,0.07639216}, {408,0.07174510}, {409,0.07371569}, {410,0.07471569}, {411,0.07722549}, {412,0.07463725}, {413,0.07723529}, {414,0.07612745}, {415,0.08076471}, {416,0.07137255}, {417,0.07336275}, {418,0.07337255}, {419,0.07492157}, {420,0.07397059}, {421,0.07657843}, {422,0.07615686}, {423,0.07921569}, {424,0.07314706}, {425,0.07700980}, {426,0.07713725}, {427,0.07977451}, {428,0.07685294}, {429,0.08038235}, {430,0.07931373}, {431,0.08341176}, {432,0.07559804}, {433,0.07820588}, {434,0.07763725}, {435,0.08137255}, {436,0.07740196}, {437,0.08213725}, {438,0.08215686}, {439,0.08490196}, {440,0.07888235}, {441,0.08149020}, {442,0.08200980}, {443,0.08577451}, {444,0.08177451}, {445,0.08544118}, {446,0.08604902}, {447,0.08821569}, {448,0.07556863}, {449,0.07857843}, {450,0.07804902}, {451,0.08061765}, {452,0.07874510}, {453,0.08235294}, {454,0.08304902}, {455,0.08446078}, {456,0.07932353}, {457,0.08278431}, {458,0.08367647}, {459,0.08450000}, {460,0.08294118}, {461,0.08647059}, {462,0.08613725}, {463,0.08881373}, {464,0.08088235}, {465,0.08363725}, {466,0.08326471}, {467,0.08684314}, {468,0.08554902}, {469,0.08579412}, {470,0.08750000}, {471,0.09121569}, {472,0.08533333}, {473,0.08762745}, {474,0.08725490}, {475,0.09051961}, {476,0.08754902}, {477,0.09043137}, {478,0.09035294}, {479,0.09376471}, {480,0.08231373}, {481,0.08550000}, {482,0.08646078}, {483,0.09016667}, {484,0.08585294}, {485,0.08938235}, {486,0.09030392}, {487,0.09383333}, {488,0.08750980}, {489,0.09099020}, {490,0.09046078}, {491,0.09379412}, {492,0.09028431}, {493,0.09372549}, {494,0.09431373}, {495,0.09745098}, {496,0.08809804}, {497,0.09124510}, {498,0.09161765}, {499,0.09440196}, {500,0.09197059}, {505,0.09545098}, {510,0.09922549}, {515,0.09238235}, {520,0.08975490}, {525,0.09670588}, {530,0.09424510}, {535,0.10243137}, {540,0.09959804}, {545,0.09735294}, {550,0.10167647}, {555,0.10664706}, {560,0.09976471}, {565,0.10830392}, {570,0.10877451}, {575,0.11391176}, {580,0.10204902}, {585,0.10765686}, {590,0.11150980}, {595,0.11300000}, {600,0.11061765}, {605,0.11745098}, {610,0.11042157}, {615,0.11935294}, {620,0.11717647}, {625,0.11935294}, {630,0.12101961}, {635,0.12652941}, {640,0.10973529}, {645,0.11946078}, {650,0.11802941}, {655,0.12748039}, {660,0.12207843}, {665,0.12370588}, {670,0.12958824}, {675,0.12769608}, {680,0.12295098}, {685,0.13254902}, {690,0.13028431}, {695,0.13730392}, {700,0.13587255}, {705,0.12550980}, {710,0.13194118}, {715,0.13670588}, {720,0.12900980}, {725,0.14002941}, {730,0.13797059}, {735,0.14992157}, {740,0.13561765}, {745,0.14295098}, {750,0.14629412}, {755,0.14803922}, {760,0.14398039}, {765,0.15376471}, {770,0.13536275}, {775,0.14498039}, {780,0.14160784}, {785,0.14173529}, {790,0.14760784}, {795,0.15363725}, {800,0.14097059}, {805,0.15053922}, {810,0.15099020}, {815,0.16222549}, {820,0.15271569}, {825,0.15809804}, {830,0.16565686}, {835,0.15494118}, {840,0.15057843}, {845,0.16236275}, {850,0.15747059}, {855,0.16776471}, {860,0.16440196}, {865,0.15981373}, {870,0.16550000}, {875,0.17066667}, {880,0.16204902}, {885,0.17465686}, {890,0.17374510}, {895,0.18600000}, {900,0.16115686}, {905,0.16644118}, {910,0.17370588}, {915,0.17655882}, {920,0.16980392}, {925,0.18152941}, {930,0.17073529}, {935,0.18245098}, {940,0.17690196}, {945,0.17862745}, {950,0.18563725}, {955,0.19189216}, {960,0.17063725}, {965,0.18358824}, {970,0.18535294}, {975,0.19635294}, {980,0.18576471}, {985,0.19249020}, {990,0.19938235}, {995,0.19313725}, {1000,0.18734314}, {1010,0.19428431}, {1020,0.20186275}, {1030,0.18800000}, {1040,0.18347059}, {1050,0.19747059}, {1060,0.19354902}, {1070,0.20994118}, {1080,0.20400000}, {1090,0.19817647}, {1100,0.20563725}, {1110,0.21389216}, {1120,0.20310784}, {1130,0.21919608}, {1140,0.21842157}, {1150,0.23673529}, {1160,0.21019608}, {1170,0.21783333}, {1180,0.22847059}, {1190,0.22831373}, {1200,0.22277451}, {1210,0.23920588}, {1220,0.22664706}, {1230,0.24289216}, {1240,0.23707843}, {1250,0.23961765}, {1260,0.24902941}, {1270,0.25548039}, {1280,0.22303922}, {1290,0.24011765}, {1300,0.24213725}, {1310,0.25995098}, {1320,0.24397059}, {1330,0.25481373}, {1340,0.26433333}, {1350,0.26043137}, {1360,0.25052941}, {1370,0.26898039}, {1380,0.26253922}, {1390,0.28059804}, {1400,0.27526471}, {1410,0.26220588}, {1420,0.26914706}, {1430,0.27976471}, {1440,0.26440196}, {1450,0.28107843}, {1460,0.28245098}, {1470,0.30375490}, {1480,0.27999020}, {1490,0.28933333}, {1500,0.30070588}, {1510,0.30182353}, {1520,0.29267647}, {1530,0.31240196}, {1540,0.28012745}, {1550,0.29820588}, {1560,0.29023529}, {1570,0.29052941}, {1580,0.30035294}, {1590,0.31298039}, {1600,0.28626471}, {1610,0.30678431}, {1620,0.30736275}, {1630,0.32985294}, {1640,0.31060784}, {1650,0.32348039}, {1660,0.33462745}, {1670,0.31978431}, {1680,0.30897059}, {1690,0.33005882}, {1700,0.32220588}, {1710,0.34467647}, {1720,0.33488235}, {1730,0.32704902}, {1740,0.33757843}, {1750,0.35064706}, {1760,0.33194118}, {1770,0.35445098}, {1780,0.35595098}, {1790,0.38038235}, {1800,0.33039216}, {1810,0.34120588}, {1820,0.35372549}, {1830,0.35620588}, {1840,0.34805882}, {1850,0.37152941}, {1860,0.35131373}, {1870,0.37362745}, {1880,0.36301961}, {1890,0.36528431}, {1900,0.38113725}, {1910,0.39221569}, {1920,0.34891176}, {1930,0.37403922}, {1940,0.37460784}, {1950,0.39883333}, {1960,0.38053922}, {1970,0.39197059}, {1980,0.40578431}, {1990,0.39777451}, {2000,0.38428431}, {2050,0.37474510}, {2100,0.40536275}, {2150,0.42729412}, {2200,0.42580392}, {2250,0.44512745}, {2300,0.47966667}, {2350,0.47918627}, {2400,0.45793137}, {2450,0.48203922}, {2500,0.48932353}, {2550,0.54248039}, {2600,0.49859804}, {2650,0.53644118}, {2700,0.53440196}, {2750,0.58815686}, {2800,0.56193137}, {2850,0.56061765}, {2900,0.58695098}, {2950,0.59080392}, {3000,0.61636275}, {3050,0.64472549}, {3100,0.61852941}, {3150,0.64352941}, {3200,0.59250000}, {3250,0.65887255}, {3300,0.66911765}, {3350,0.68246078}, {3400,0.66878431}, {3450,0.74050980}, {3500,0.72583333}, {3550,0.78490196}, {3600,0.68300980}, {3650,0.71525490}, {3700,0.77358824}, {3750,0.77746078}, {3800,0.78745098}, {3850,0.78065686}, {3900,0.82842157}, {3950,0.86505882}, {4000,0.79651961}, {4050,0.85436275}, {4100,0.77133333}, {4150,0.85754902}, {4200,0.84238235}, {4250,0.87998039}, {4300,0.88395098}, {4350,0.98307843}, {4400,0.87757843}, {4450,0.92226471}, {4500,0.92855882}, {4550,0.96080392}, {4600,0.99460784}, {4650,0.96095098}, {4700,0.99629412}, {4750,1.00874510}, {4800,0.95275490}, {4850,1.05230392}, {4900,0.99720588}, {4950,1.06780392}, {5000,1.02240196}, {5050,1.11695098}, {5100,1.12717647}, {5150,1.09333333}, {5200,1.03916667}, {5250,1.04812745}, {5300,1.12029412}, {5350,1.15955882}, {5400,1.11406863}, {5450,1.15363725}, {5500,1.22282353}, {5550,1.23216667}, {5600,1.17818627}, {5650,1.16129412}, {5700,1.18173529}, {5750,1.28162745}, {5800,1.22392157}, {5850,1.30606863}, {5900,1.24294118}, {5950,1.36116667}, {6000,1.29492157}, {6050,1.38225}, {6100,1.39650}, {6150,1.28650}, {6200,1.32675}, {6250,1.38350}, {6300,1.38575}, {6350,1.43175}, {6400,1.27925}, {6450,1.41875}, {6500,1.41125}, {6550,1.47575}, {6600,1.45950}, {6650,1.57850}, {6700,1.47275}, {6750,1.55625}, {6800,1.43400}, {6850,1.50350}, {6900,1.58750}, {6950,1.56225}, {7000,1.56450}, {7050,1.57725}, {7100,1.67325}, {7150,1.72425}, {7200,1.47000}, {7250,1.57250}, {7300,1.53625}, {7350,1.69175}, {7400,1.64825}, {7450,1.66100}, {7500,1.66850}, {7550,1.82625}, {7600,1.67950}, {7650,1.74875}, {7700,1.66950}, {7750,1.73225}, {7800,1.77500}, {7850,1.78400}, {7900,1.87275}, {7950,1.81150}, {8000,1.72225}, {8050,1.88075}, {8100,1.85450}, {8150,1.95250}, {8200,1.65550}, {8250,1.83850}, {8300,1.82875}, {8350,1.89150}, {8400,1.79475}, {8450,1.75850}, {8500,1.85250}, {8550,1.91750}, {8600,1.88075}, {8650,1.93100}, {8700,2.04575}, {8750,1.97725}, {8800,1.85750}, {8850,1.91175}, {8900,1.93125}, {8950,2.10625}, {9000,1.94525}, {9050,2.07975}, {9100,2.03350}, {9150,2.21275}, {9200,2.10150}, {9250,1.93800}, {9300,2.03175}, {9350,2.03950}, {9400,2.10250}, {9450,2.17875}, {9500,2.13250}, {9550,2.18750}, {9600,2.00550}, {9650,2.22950}, {9700,2.21350}, {9750,2.17650}, {9800,2.12950}, {9850,2.33025}, {9900,2.25875}, {9950,2.39475}, {10000,2.17175}, {10100,2.37650}, {10200,2.38750}, {10300,2.31500}, {10400,2.21475}, {10500,2.20400}, {10600,2.37350}, {10700,2.45375}, {10800,2.37650}, {10900,2.44900}, {11000,2.60375}, {11100,2.60650}, {11200,2.46975}, {11300,2.46050}, {11400,2.45625}, {11500,2.68925}, {11600,2.57425}, {11700,2.73100}, {11800,2.59150}, {11900,2.84050}, {12000,2.72525}, {12100,2.73950}, {12200,2.86250}, {12300,2.59150}, {12400,2.71375}, {12500,2.81750}, {12600,2.82700}, {12700,2.94125}, {12800,2.62625}, {12900,2.88050}, {13000,2.88625}, {13100,3.02850}, {13200,2.93825}, {13300,3.23125}, {13400,3.00775}, {13500,3.18475}, {13600,2.95200}, {13700,3.07475}, {13800,3.27725}, {13900,3.20875}, {14000,3.22425}, {14100,3.24275}, {14200,3.42700}, {14300,3.54525}, {14400,3.03875}, {14500,3.23875}, {14600,3.16775}, {14700,3.48350}, {14800,3.38025}, {14900,3.41675}, {15000,3.42125}, {15100,3.75650}, {15200,3.48525}, {15300,3.63150}, {15400,3.42400}, {15500,3.54375}, {15600,3.67200}, {15700,3.69525}, {15800,3.82925}, {15900,3.74650}, {16000,3.54350}, {16100,3.85300}, {16200,3.80925}, {16300,4.01350}, {16400,3.45700}, {16500,3.76350}, {16600,3.81775}, {16700,3.97425}, {16800,3.76275}, {16900,3.66425}, {17000,3.88400}, {17100,4.01450}, {17200,3.89800}, {17300,4.01275}, {17400,4.32650}, {17500,4.13825}, {17600,3.90075}, {17700,4.00150}, {17800,4.05925}, {17900,4.39600}, {18000,4.09150}, {18100,4.36425}, {18200,4.23825}, {18300,4.64650}, {18400,4.39825}, {18500,4.07925}, {18600,4.19150}, {18700,4.24825}, {18800,4.41350}, {18900,4.53950}, {19000,4.45250}, {19100,4.61025}, {19200,4.24625}, {19300,4.63100}, {19400,4.63975}, {19500,4.55075}, {19600,4.45950}, {19700,4.86500}, {19800,4.76375}, {19900,5.01575}, {20000,4.49950}};
data["big_flat"]["Ltac2"]["Aggregate"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00003922}, {5,0.00010784}, {6,0.00003922}, {7,0.00003922}, {8,0.00007843}, {9,0.00007843}, {10,0.00003922}, {11,0.00000000}, {12,0.00000000}, {13,0.00003922}, {14,0.00000000}, {15,0.00007843}, {16,0.00003922}, {17,0.00007843}, {18,0.00002941}, {19,0.00013725}, {20,0.00003922}, {21,0.00007843}, {22,0.00000000}, {23,0.00007843}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00003922}, {30,0.00007843}, {31,0.00002941}, {32,0.00003922}, {33,0.00003922}, {34,0.00003922}, {35,0.00007843}, {36,0.00003922}, {37,0.00000000}, {38,0.00003922}, {39,0.00003922}, {40,0.00003922}, {41,0.00011765}, {42,0.00000000}, {43,0.00007843}, {44,0.00000000}, {45,0.00003922}, {46,0.00003922}, {47,0.00015686}, {48,0.00007843}, {49,0.00003922}, {50,0.00003922}, {51,0.00007843}, {52,0.00003922}, {53,0.00011765}, {54,0.00000000}, {55,0.00003922}, {56,0.00003922}, {57,0.00006863}, {58,0.00014706}, {59,0.00000000}, {60,0.00003922}, {61,0.00003922}, {62,0.00003922}, {63,0.00003922}, {64,0.00000000}, {65,0.00000000}, {66,0.00019608}, {67,0.00007843}, {68,0.00007843}, {69,0.00007843}, {70,0.00000000}, {71,0.00003922}, {72,0.00000000}, {73,0.00003922}, {74,0.00007843}, {75,0.00000000}, {76,0.00000000}, {77,0.00003922}, {78,0.00007843}, {79,0.00000000}, {80,0.00002941}, {81,0.00003922}, {82,0.00000000}, {83,0.00003922}, {84,0.00007843}, {85,0.00007843}, {86,0.00000000}, {87,0.00003922}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00003922}, {92,0.00000000}, {93,0.00003922}, {94,0.00010784}, {95,0.00003922}, {96,0.00000000}, {97,0.00011765}, {98,0.00011765}, {99,0.00003922}, {100,0.00003922}, {101,0.00003922}, {102,0.00007843}, {103,0.00007843}, {104,0.00003922}, {105,0.00007843}, {106,0.00003922}, {107,0.00007843}, {108,0.00000000}, {109,0.00007843}, {110,0.00011765}, {111,0.00007843}, {112,0.00003922}, {113,0.00015686}, {114,0.00003922}, {115,0.00007843}, {116,0.00000000}, {117,0.00003922}, {118,0.00014706}, {119,0.00003922}, {120,0.00003922}, {121,0.00000000}, {122,0.00003922}, {123,0.00023529}, {124,0.00003922}, {125,0.00003922}, {126,0.00003922}, {127,0.00000000}, {128,0.00000000}, {129,0.00023529}, {130,0.00003922}, {131,0.00000000}, {132,0.00007843}, {133,0.00007843}, {134,0.00000000}, {135,0.00003922}, {136,0.00015686}, {137,0.00007843}, {138,0.00003922}, {139,0.00003922}, {140,0.00007843}, {141,0.00000000}, {142,0.00003922}, {143,0.00000000}, {144,0.00011765}, {145,0.00000000}, {146,0.00000000}, {147,0.00007843}, {148,0.00000000}, {149,0.00000000}, {150,0.00003922}, {151,0.00000000}, {152,0.00006863}, {153,0.00003922}, {154,0.00000000}, {155,0.00003922}, {156,0.00000000}, {157,0.00007843}, {158,0.00006863}, {159,0.00007843}, {160,0.00000000}, {161,0.00000000}, {162,0.00011765}, {163,0.00003922}, {164,0.00000000}, {165,0.00003922}, {166,0.00010784}, {167,0.00007843}, {168,0.00000000}, {169,0.00003922}, {170,0.00003922}, {171,0.00000000}, {172,0.00019608}, {173,0.00011765}, {174,0.00003922}, {175,0.00000000}, {176,0.00010784}, {177,0.00003922}, {178,0.00011765}, {179,0.00000000}, {180,0.00006863}, {181,0.00000000}, {182,0.00000000}, {183,0.00007843}, {184,0.00019608}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00007843}, {189,0.00000000}, {190,0.00007843}, {191,0.00003922}, {192,0.00000000}, {193,0.00003922}, {194,0.00003922}, {195,0.00007843}, {196,0.00007843}, {197,0.00007843}, {198,0.00000000}, {199,0.00007843}, {200,0.00000000}, {201,0.00003922}, {202,0.00000000}, {203,0.00003922}, {204,0.00003922}, {205,0.00000000}, {206,0.00011765}, {207,0.00003922}, {208,0.00007843}, {209,0.00000000}, {210,0.00000000}, {211,0.00011765}, {212,0.00003922}, {213,0.00003922}, {214,0.00007843}, {215,0.00007843}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00006863}, {220,0.00003922}, {221,0.00007843}, {222,0.00000000}, {223,0.00003922}, {224,0.00003922}, {225,0.00007843}, {226,0.00007843}, {227,0.00000000}, {228,0.00000000}, {229,0.00006863}, {230,0.00003922}, {231,0.00007843}, {232,0.00015686}, {233,0.00003922}, {234,0.00010784}, {235,0.00007843}, {236,0.00000000}, {237,0.00010784}, {238,0.00000000}, {239,0.00007843}, {240,0.00007843}, {241,0.00000000}, {242,0.00011765}, {243,0.00011765}, {244,0.00000000}, {245,0.00003922}, {246,0.00011765}, {247,0.00003922}, {248,0.00003922}, {249,0.00003922}, {250,0.00000000}, {251,0.00011765}, {252,0.00003922}, {253,0.00007843}, {254,0.00003922}, {255,0.00000000}, {256,0.00003922}, {257,0.00003922}, {258,0.00007843}, {259,0.00000000}, {260,0.00015686}, {261,0.00000000}, {262,0.00015686}, {263,0.00007843}, {264,0.00003922}, {265,0.00007843}, {266,0.00003922}, {267,0.00003922}, {268,0.00007843}, {269,0.00007843}, {270,0.00018627}, {271,0.00000000}, {272,0.00007843}, {273,0.00003922}, {274,0.00011765}, {275,0.00007843}, {276,0.00003922}, {277,0.00000000}, {278,0.00003922}, {279,0.00003922}, {280,0.00007843}, {281,0.00007843}, {282,0.00011765}, {283,0.00003922}, {284,0.00006863}, {285,0.00007843}, {286,0.00011765}, {287,0.00007843}, {288,0.00002941}, {289,0.00000000}, {290,0.00007843}, {291,0.00003922}, {292,0.00000000}, {293,0.00003922}, {294,0.00003922}, {295,0.00015686}, {296,0.00003922}, {297,0.00003922}, {298,0.00000000}, {299,0.00007843}, {300,0.00003922}, {301,0.00007843}, {302,0.00010784}, {303,0.00007843}, {304,0.00000000}, {305,0.00007843}, {306,0.00015686}, {307,0.00000000}, {308,0.00015686}, {309,0.00007843}, {310,0.00000000}, {311,0.00000000}, {312,0.00003922}, {313,0.00000000}, {314,0.00000000}, {315,0.00003922}, {316,0.00011765}, {317,0.00000000}, {318,0.00011765}, {319,0.00003922}, {320,0.00003922}, {321,0.00003922}, {322,0.00007843}, {323,0.00003922}, {324,0.00019608}, {325,0.00007843}, {326,0.00000000}, {327,0.00003922}, {328,0.00003922}, {329,0.00007843}, {330,0.00000000}, {331,0.00003922}, {332,0.00003922}, {333,0.00000000}, {334,0.00002941}, {335,0.00003922}, {336,0.00011765}, {337,0.00007843}, {338,0.00003922}, {339,0.00011765}, {340,0.00003922}, {341,0.00003922}, {342,0.00003922}, {343,0.00011765}, {344,0.00011765}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00003922}, {350,0.00002941}, {351,0.00003922}, {352,0.00011765}, {353,0.00011765}, {354,0.00003922}, {355,0.00007843}, {356,0.00003922}, {357,0.00000000}, {358,0.00003922}, {359,0.00002941}, {360,0.00000000}, {361,0.00000000}, {362,0.00003922}, {363,0.00007843}, {364,0.00003922}, {365,0.00003922}, {366,0.00014706}, {367,0.00007843}, {368,0.00007843}, {369,0.00003922}, {370,0.00000000}, {371,0.00014706}, {372,0.00003922}, {373,0.00007843}, {374,0.00003922}, {375,0.00003922}, {376,0.00003922}, {377,0.00003922}, {378,0.00006863}, {379,0.00006863}, {380,0.00003922}, {381,0.00003922}, {382,0.00011765}, {383,0.00007843}, {384,0.00000000}, {385,0.00003922}, {386,0.00003922}, {387,0.00007843}, {388,0.00003922}, {389,0.00011765}, {390,0.00007843}, {391,0.00007843}, {392,0.00007843}, {393,0.00007843}, {394,0.00006863}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00003922}, {399,0.00000000}, {400,0.00011765}, {401,0.00003922}, {402,0.00015686}, {403,0.00000000}, {404,0.00007843}, {405,0.00011765}, {406,0.00000000}, {407,0.00003922}, {408,0.00015686}, {409,0.00003922}, {410,0.00000000}, {411,0.00000000}, {412,0.00006863}, {413,0.00000000}, {414,0.00011765}, {415,0.00011765}, {416,0.00003922}, {417,0.00000000}, {418,0.00000000}, {419,0.00003922}, {420,0.00011765}, {421,0.00000000}, {422,0.00006863}, {423,0.00000000}, {424,0.00003922}, {425,0.00011765}, {426,0.00003922}, {427,0.00007843}, {428,0.00000000}, {429,0.00007843}, {430,0.00003922}, {431,0.00019608}, {432,0.00000000}, {433,0.00007843}, {434,0.00007843}, {435,0.00003922}, {436,0.00011765}, {437,0.00007843}, {438,0.00015686}, {439,0.00000000}, {440,0.00011765}, {441,0.00011765}, {442,0.00010784}, {443,0.00006863}, {444,0.00007843}, {445,0.00007843}, {446,0.00014706}, {447,0.00003922}, {448,0.00007843}, {449,0.00000000}, {450,0.00007843}, {451,0.00000000}, {452,0.00003922}, {453,0.00003922}, {454,0.00000000}, {455,0.00010784}, {456,0.00000000}, {457,0.00000000}, {458,0.00003922}, {459,0.00007843}, {460,0.00003922}, {461,0.00003922}, {462,0.00011765}, {463,0.00011765}, {464,0.00007843}, {465,0.00002941}, {466,0.00000000}, {467,0.00021569}, {468,0.00007843}, {469,0.00003922}, {470,0.00007843}, {471,0.00003922}, {472,0.00000000}, {473,0.00011765}, {474,0.00018627}, {475,0.00003922}, {476,0.00011765}, {477,0.00003922}, {478,0.00000000}, {479,0.00002941}, {480,0.00007843}, {481,0.00010784}, {482,0.00015686}, {483,0.00011765}, {484,0.00003922}, {485,0.00000000}, {486,0.00007843}, {487,0.00011765}, {488,0.00000000}, {489,0.00007843}, {490,0.00003922}, {491,0.00015686}, {492,0.00003922}, {493,0.00003922}, {494,0.00000000}, {495,0.00007843}, {496,0.00003922}, {497,0.00003922}, {498,0.00011765}, {499,0.00007843}, {500,0.00007843}, {505,0.00007843}, {510,0.00002941}, {515,0.00007843}, {520,0.00011765}, {525,0.00003922}, {530,0.00003922}, {535,0.00003922}, {540,0.00003922}, {545,0.00011765}, {550,0.00007843}, {555,0.00007843}, {560,0.00003922}, {565,0.00019608}, {570,0.00003922}, {575,0.00000000}, {580,0.00015686}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00003922}, {605,0.00015686}, {610,0.00003922}, {615,0.00007843}, {620,0.00007843}, {625,0.00003922}, {630,0.00023529}, {635,0.00000000}, {640,0.00007843}, {645,0.00007843}, {650,0.00007843}, {655,0.00002941}, {660,0.00000000}, {665,0.00015686}, {670,0.00003922}, {675,0.00018627}, {680,0.00014706}, {685,0.00007843}, {690,0.00000000}, {695,0.00007843}, {700,0.00003922}, {705,0.00007843}, {710,0.00011765}, {715,0.00007843}, {720,0.00007843}, {725,0.00003922}, {730,0.00023529}, {735,0.00011765}, {740,0.00015686}, {745,0.00019608}, {750,0.00015686}, {755,0.00013725}, {760,0.00011765}, {765,0.00003922}, {770,0.00000000}, {775,0.00007843}, {780,0.00007843}, {785,0.00010784}, {790,0.00011765}, {795,0.00011765}, {800,0.00014706}, {805,0.00007843}, {810,0.00000000}, {815,0.00007843}, {820,0.00015686}, {825,0.00003922}, {830,0.00010784}, {835,0.00003922}, {840,0.00003922}, {845,0.00003922}, {850,0.00007843}, {855,0.00003922}, {860,0.00007843}, {865,0.00011765}, {870,0.00000000}, {875,0.00007843}, {880,0.00007843}, {885,0.00003922}, {890,0.00007843}, {895,0.00007843}, {900,0.00003922}, {905,0.00007843}, {910,0.00007843}, {915,0.00010784}, {920,0.00015686}, {925,0.00007843}, {930,0.00007843}, {935,0.00003922}, {940,0.00019608}, {945,0.00006863}, {950,0.00000000}, {955,0.00007843}, {960,0.00003922}, {965,0.00011765}, {970,0.00019608}, {975,0.00011765}, {980,0.00019608}, {985,0.00003922}, {990,0.00019608}, {995,0.00011765}, {1000,0.00007843}, {1010,0.00011765}, {1020,0.00003922}, {1030,0.00014706}, {1040,0.00010784}, {1050,0.00000000}, {1060,0.00003922}, {1070,0.00007843}, {1080,0.00015686}, {1090,0.00002941}, {1100,0.00011765}, {1110,0.00003922}, {1120,0.00011765}, {1130,0.00015686}, {1140,0.00003922}, {1150,0.00010784}, {1160,0.00007843}, {1170,0.00003922}, {1180,0.00007843}, {1190,0.00011765}, {1200,0.00007843}, {1210,0.00003922}, {1220,0.00015686}, {1230,0.00007843}, {1240,0.00011765}, {1250,0.00007843}, {1260,0.00007843}, {1270,0.00010784}, {1280,0.00003922}, {1290,0.00003922}, {1300,0.00007843}, {1310,0.00003922}, {1320,0.00000000}, {1330,0.00011765}, {1340,0.00007843}, {1350,0.00010784}, {1360,0.00006863}, {1370,0.00013725}, {1380,0.00007843}, {1390,0.00011765}, {1400,0.00026471}, {1410,0.00003922}, {1420,0.00007843}, {1430,0.00007843}, {1440,0.00000000}, {1450,0.00007843}, {1460,0.00007843}, {1470,0.00000000}, {1480,0.00011765}, {1490,0.00015686}, {1500,0.00002941}, {1510,0.00003922}, {1520,0.00010784}, {1530,0.00023529}, {1540,0.00015686}, {1550,0.00011765}, {1560,0.00015686}, {1570,0.00007843}, {1580,0.00007843}, {1590,0.00000000}, {1600,0.00007843}, {1610,0.00006863}, {1620,0.00003922}, {1630,0.00007843}, {1640,0.00003922}, {1650,0.00007843}, {1660,0.00015686}, {1670,0.00000000}, {1680,0.00011765}, {1690,0.00019608}, {1700,0.00003922}, {1710,0.00000000}, {1720,0.00015686}, {1730,0.00003922}, {1740,0.00018627}, {1750,0.00007843}, {1760,0.00007843}, {1770,0.00011765}, {1780,0.00007843}, {1790,0.00011765}, {1800,0.00003922}, {1810,0.00003922}, {1820,0.00015686}, {1830,0.00026471}, {1840,0.00006863}, {1850,0.00003922}, {1860,0.00019608}, {1870,0.00019608}, {1880,0.00030392}, {1890,0.00003922}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00011765}, {1930,0.00003922}, {1940,0.00007843}, {1950,0.00003922}, {1960,0.00018627}, {1970,0.00003922}, {1980,0.00011765}, {1990,0.00007843}, {2000,0.00000000}, {2050,0.00007843}, {2100,0.00015686}, {2150,0.00019608}, {2200,0.00023529}, {2250,0.00007843}, {2300,0.00015686}, {2350,0.00011765}, {2400,0.00008824}, {2450,0.00011765}, {2500,0.00011765}, {2550,0.00007843}, {2600,0.00011765}, {2650,0.00011765}, {2700,0.00022549}, {2750,0.00003922}, {2800,0.00007843}, {2850,0.00007843}, {2900,0.00010784}, {2950,0.00006863}, {3000,0.00006863}, {3050,0.00011765}, {3100,0.00014706}, {3150,0.00000000}, {3200,0.00027451}, {3250,0.00015686}, {3300,0.00007843}, {3350,0.00015686}, {3400,0.00015686}, {3450,0.00015686}, {3500,0.00006863}, {3550,0.00031373}, {3600,0.00015686}, {3650,0.00007843}, {3700,0.00003922}, {3750,0.00015686}, {3800,0.00019608}, {3850,0.00015686}, {3900,0.00007843}, {3950,0.00011765}, {4000,0.00007843}, {4050,0.00010784}, {4100,0.00019608}, {4150,0.00011765}, {4200,0.00023529}, {4250,0.00015686}, {4300,0.00014706}, {4350,0.00007843}, {4400,0.00015686}, {4450,0.00010784}, {4500,0.00003922}, {4550,0.00007843}, {4600,0.00019608}, {4650,0.00015686}, {4700,0.00027451}, {4750,0.00011765}, {4800,0.00023529}, {4850,0.00015686}, {4900,0.00022549}, {4950,0.00011765}, {5000,0.00011765}, {5050,0.00011765}, {5100,0.00018627}, {5150,0.00011765}, {5200,0.00003922}, {5250,0.00014706}, {5300,0.00015686}, {5350,0.00020588}, {5400,0.00027451}, {5450,0.00011765}, {5500,0.00029412}, {5550,0.00030392}, {5600,0.00003922}, {5650,0.00019608}, {5700,0.00019608}, {5750,0.00022549}, {5800,0.00025490}, {5850,0.00019608}, {5900,0.00027451}, {5950,0.00032353}, {6000,0.00033333}, {6050,0.01000}, {6100,0.00675}, {6150,0.00400}, {6200,0.00100}, {6250,0.00000}, {6300,0.00300}, {6350,0.00175}, {6400,0.00100}, {6450,0.00175}, {6500,0.00200}, {6550,0.00300}, {6600,0.01200}, {6650,0.00700}, {6700,0.00675}, {6750,0.00600}, {6800,0.00500}, {6850,0.00700}, {6900,0.00800}, {6950,0.00600}, {7000,0.00900}, {7050,0.00600}, {7100,0.00400}, {7150,0.00100}, {7200,0.00275}, {7250,0.00075}, {7300,0.00200}, {7350,0.00200}, {7400,0.00100}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00075}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00100}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00100}, {10700,0.00000}, {10800,0.00100}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00100}, {11300,0.00000}, {11400,0.00000}, {11500,0.00100}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00100}, {12400,0.00000}, {12500,0.00000}, {12600,0.00200}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00100}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00100}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00100}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00075}, {15300,0.00000}, {15400,0.00100}, {15500,0.00000}, {15600,0.00100}, {15700,0.00000}, {15800,0.00000}, {15900,0.00100}, {16000,0.00100}, {16100,0.00100}, {16200,0.00000}, {16300,0.00000}, {16400,0.00100}, {16500,0.00000}, {16600,0.00100}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00100}, {17600,0.00100}, {17700,0.00000}, {17800,0.00000}, {17900,0.00100}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00175}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00100}, {19000,0.00200}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00100}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["Ltac2"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00015686}, {6,0.00100000}, {7,0.00100000}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00102941}, {12,0.00116667}, {13,0.00164706}, {14,0.00200000}, {15,0.00200000}, {16,0.00200000}, {17,0.00200980}, {18,0.00217647}, {19,0.00227451}, {20,0.00229412}, {21,0.00319608}, {22,0.01317647}, {23,0.00300980}, {24,0.00300000}, {25,0.00303922}, {26,0.00306863}, {27,0.00392157}, {28,0.00379412}, {29,0.00401961}, {30,0.00408824}, {31,0.00407843}, {32,0.00408824}, {33,0.00408824}, {34,0.00420588}, {35,0.00506863}, {36,0.00500980}, {37,0.00511765}, {38,0.00510784}, {39,0.00614706}, {40,0.00513725}, {41,0.00573529}, {42,0.00607843}, {43,0.00609804}, {44,0.00606863}, {45,0.00611765}, {46,0.00624510}, {47,0.00715686}, {48,0.00615686}, {49,0.00707843}, {50,0.00706863}, {51,0.00714706}, {52,0.00790196}, {53,0.00729412}, {54,0.00778431}, {55,0.00809804}, {56,0.00762745}, {57,0.00805882}, {58,0.00808824}, {59,0.00880392}, {60,0.00815686}, {61,0.00992157}, {62,0.00901961}, {63,0.00924510}, {64,0.00842157}, {65,0.00904902}, {66,0.00902941}, {67,0.00990196}, {68,0.00915686}, {69,0.01003922}, {70,0.01098039}, {71,0.01068627}, {72,0.01000980}, {73,0.01032353}, {74,0.01074510}, {75,0.01112745}, {76,0.01104902}, {77,0.01122549}, {78,0.01143137}, {79,0.01213725}, {80,0.01109804}, {81,0.01167647}, {82,0.01199020}, {83,0.01219608}, {84,0.01284314}, {85,0.01261765}, {86,0.01288235}, {87,0.01308824}, {88,0.01223529}, {89,0.01305882}, {90,0.01307843}, {91,0.01467647}, {92,0.01329412}, {93,0.01406863}, {94,0.01414706}, {95,0.01512745}, {96,0.01310784}, {97,0.01485294}, {98,0.01413725}, {99,0.01498039}, {100,0.01414706}, {101,0.01508824}, {102,0.01606863}, {103,0.01606863}, {104,0.01496078}, {105,0.01557843}, {106,0.01578431}, {107,0.01628431}, {108,0.01651961}, {109,0.01688235}, {110,0.01700000}, {111,0.01770588}, {112,0.01604902}, {113,0.01737255}, {114,0.01700980}, {115,0.01769608}, {116,0.01706863}, {117,0.01898039}, {118,0.01808824}, {119,0.01907843}, {120,0.01743137}, {121,0.01839216}, {122,0.01938235}, {123,0.01926471}, {124,0.01888235}, {125,0.01970588}, {126,0.02057843}, {127,0.02074510}, {128,0.01801961}, {129,0.01894118}, {130,0.01905882}, {131,0.02082353}, {132,0.01913725}, {133,0.02009804}, {134,0.02018627}, {135,0.02206863}, {136,0.01976471}, {137,0.02064706}, {138,0.02096078}, {139,0.02254902}, {140,0.02111765}, {141,0.02210784}, {142,0.02210784}, {143,0.02405882}, {144,0.02108824}, {145,0.02194118}, {146,0.02216667}, {147,0.02395098}, {148,0.02204902}, {149,0.02312745}, {150,0.02424510}, {151,0.02417647}, {152,0.02254902}, {153,0.02375490}, {154,0.02455882}, {155,0.02503922}, {156,0.02402941}, {157,0.02612745}, {158,0.02530392}, {159,0.02640196}, {160,0.02309804}, {161,0.02501961}, {162,0.02409804}, {163,0.02528431}, {164,0.02525490}, {165,0.02559804}, {166,0.02584314}, {167,0.02701961}, {168,0.02508824}, {169,0.02615686}, {170,0.02619608}, {171,0.02813725}, {172,0.02644118}, {173,0.02778431}, {174,0.02886275}, {175,0.02919608}, {176,0.02614706}, {177,0.02814706}, {178,0.02727451}, {179,0.02857843}, {180,0.02848039}, {181,0.02903922}, {182,0.02909804}, {183,0.03119608}, {184,0.02827451}, {185,0.02949020}, {186,0.03044118}, {187,0.03080392}, {188,0.02993137}, {189,0.03208824}, {190,0.03111765}, {191,0.03373529}, {192,0.02770588}, {193,0.02909804}, {194,0.03015686}, {195,0.03042157}, {196,0.02930392}, {197,0.03155882}, {198,0.03090196}, {199,0.03231373}, {200,0.03073529}, {201,0.03121569}, {202,0.03136275}, {203,0.03376471}, {204,0.03165686}, {205,0.03413725}, {206,0.03325490}, {207,0.03462745}, {208,0.03210784}, {209,0.03237255}, {210,0.03245098}, {211,0.03499020}, {212,0.03276471}, {213,0.03517647}, {214,0.03427451}, {215,0.03586275}, {216,0.03415686}, {217,0.03487255}, {218,0.03592157}, {219,0.03632353}, {220,0.03516667}, {221,0.03653922}, {222,0.03667647}, {223,0.03920588}, {224,0.03329412}, {225,0.03564706}, {226,0.03490196}, {227,0.03631373}, {228,0.03609804}, {229,0.03659804}, {230,0.03769608}, {231,0.03836275}, {232,0.03673529}, {233,0.03714706}, {234,0.03740196}, {235,0.03988235}, {236,0.03746078}, {237,0.04023529}, {238,0.03933333}, {239,0.04164706}, {240,0.03674510}, {241,0.03936275}, {242,0.03845098}, {243,0.04014706}, {244,0.03954902}, {245,0.04024510}, {246,0.04159804}, {247,0.04219608}, {248,0.04026471}, {249,0.04073529}, {250,0.04192157}, {251,0.04264706}, {252,0.04202941}, {253,0.04282353}, {254,0.04367647}, {255,0.04477451}, {256,0.03853922}, {257,0.03920588}, {258,0.04050000}, {259,0.04130392}, {260,0.03965686}, {261,0.04129412}, {262,0.04137255}, {263,0.04410784}, {264,0.04009804}, {265,0.04322549}, {266,0.04200000}, {267,0.04505882}, {268,0.04232353}, {269,0.04542157}, {270,0.04433333}, {271,0.04739216}, {272,0.04121569}, {273,0.04435294}, {274,0.04322549}, {275,0.04620588}, {276,0.04334314}, {277,0.04636275}, {278,0.04526471}, {279,0.04729412}, {280,0.04484314}, {281,0.04586275}, {282,0.04655882}, {283,0.04793137}, {284,0.04697059}, {285,0.04811765}, {286,0.04904902}, {287,0.05019608}, {288,0.04462745}, {289,0.04542157}, {290,0.04682353}, {291,0.04747059}, {292,0.04556863}, {293,0.04872549}, {294,0.04776471}, {295,0.05058824}, {296,0.04620588}, {297,0.04923529}, {298,0.04825490}, {299,0.05143137}, {300,0.04854902}, {301,0.05067647}, {302,0.05135294}, {303,0.05271569}, {304,0.04819608}, {305,0.04928431}, {306,0.05056863}, {307,0.05285294}, {308,0.04969608}, {309,0.05265686}, {310,0.05197059}, {311,0.05493137}, {312,0.05171569}, {313,0.05232353}, {314,0.05312745}, {315,0.05456863}, {316,0.05368627}, {317,0.05590196}, {318,0.05484314}, {319,0.05789216}, {320,0.04816667}, {321,0.05145098}, {322,0.05149020}, {323,0.05262745}, {324,0.05142157}, {325,0.05268627}, {326,0.05416667}, {327,0.05594118}, {328,0.05114706}, {329,0.05430392}, {330,0.05345098}, {331,0.05654902}, {332,0.05484314}, {333,0.05582353}, {334,0.05710784}, {335,0.05917647}, {336,0.05225490}, {337,0.05530392}, {338,0.05604902}, {339,0.05675490}, {340,0.05571569}, {341,0.05734314}, {342,0.05720588}, {343,0.06050000}, {344,0.05529412}, {345,0.05865686}, {346,0.05882353}, {347,0.05994118}, {348,0.05862745}, {349,0.06170588}, {350,0.06055882}, {351,0.06264706}, {352,0.05547059}, {353,0.05679412}, {354,0.05681373}, {355,0.05995098}, {356,0.05715686}, {357,0.05962745}, {358,0.06029412}, {359,0.06314706}, {360,0.05762745}, {361,0.06101961}, {362,0.06100980}, {363,0.06275490}, {364,0.06150980}, {365,0.06367647}, {366,0.06291176}, {367,0.06548039}, {368,0.05953922}, {369,0.06213725}, {370,0.06144118}, {371,0.06504902}, {372,0.06237255}, {373,0.06422549}, {374,0.06407843}, {375,0.06743137}, {376,0.06300980}, {377,0.06461765}, {378,0.06566667}, {379,0.06836275}, {380,0.06550980}, {381,0.06743137}, {382,0.06863725}, {383,0.07135294}, {384,0.05898039}, {385,0.06030392}, {386,0.06166667}, {387,0.06426471}, {388,0.06084314}, {389,0.06339216}, {390,0.06434314}, {391,0.06688235}, {392,0.06123529}, {393,0.06493137}, {394,0.06563725}, {395,0.06727451}, {396,0.06410784}, {397,0.06799020}, {398,0.06815686}, {399,0.07013725}, {400,0.06231373}, {401,0.06482353}, {402,0.06646078}, {403,0.06849020}, {404,0.06534314}, {405,0.06805882}, {406,0.06915686}, {407,0.07175490}, {408,0.06663725}, {409,0.06856863}, {410,0.06996078}, {411,0.07260784}, {412,0.06977451}, {413,0.07253922}, {414,0.07161765}, {415,0.07571569}, {416,0.06625490}, {417,0.06834314}, {418,0.06852941}, {419,0.07024510}, {420,0.06899020}, {421,0.07183333}, {422,0.07156863}, {423,0.07441176}, {424,0.06799020}, {425,0.07211765}, {426,0.07238235}, {427,0.07467647}, {428,0.07200980}, {429,0.07554902}, {430,0.07429412}, {431,0.07847059}, {432,0.07065686}, {433,0.07320588}, {434,0.07278431}, {435,0.07619608}, {436,0.07233333}, {437,0.07680392}, {438,0.07700000}, {439,0.07962745}, {440,0.07400000}, {441,0.07635294}, {442,0.07684314}, {443,0.08094118}, {444,0.07631373}, {445,0.08042157}, {446,0.08082353}, {447,0.08333333}, {448,0.07055882}, {449,0.07321569}, {450,0.07334314}, {451,0.07517647}, {452,0.07260784}, {453,0.07702941}, {454,0.07692157}, {455,0.07949020}, {456,0.07393137}, {457,0.07701961}, {458,0.07789216}, {459,0.07921569}, {460,0.07750980}, {461,0.08102941}, {462,0.08076471}, {463,0.08364706}, {464,0.07514706}, {465,0.07781373}, {466,0.07782353}, {467,0.08157843}, {468,0.07764706}, {469,0.08041176}, {470,0.08194118}, {471,0.08560784}, {472,0.07971569}, {473,0.08261765}, {474,0.08233333}, {475,0.08530392}, {476,0.08225490}, {477,0.08518627}, {478,0.08497059}, {479,0.08800000}, {480,0.07692157}, {481,0.08014706}, {482,0.08097059}, {483,0.08283333}, {484,0.07997059}, {485,0.08407843}, {486,0.08512745}, {487,0.08809804}, {488,0.08193137}, {489,0.08518627}, {490,0.08495098}, {491,0.08798039}, {492,0.08493137}, {493,0.08816667}, {494,0.08827451}, {495,0.09172549}, {496,0.08269608}, {497,0.08590196}, {498,0.08585294}, {499,0.08893137}, {500,0.08597059}, {505,0.08959804}, {510,0.09346078}, {515,0.08634314}, {520,0.08381373}, {525,0.09083333}, {530,0.08818627}, {535,0.09650000}, {540,0.09360784}, {545,0.09106863}, {550,0.09550000}, {555,0.10018627}, {560,0.09361765}, {565,0.10194118}, {570,0.10222549}, {575,0.10817647}, {580,0.09629412}, {585,0.10108824}, {590,0.10512745}, {595,0.10638235}, {600,0.10406863}, {605,0.11068627}, {610,0.10400980}, {615,0.11249020}, {620,0.11026471}, {625,0.10988235}, {630,0.11434314}, {635,0.11960784}, {640,0.10285294}, {645,0.11028431}, {650,0.11090196}, {655,0.12039216}, {660,0.11460784}, {665,0.11692157}, {670,0.12214706}, {675,0.12039216}, {680,0.11573529}, {685,0.12492157}, {690,0.12277451}, {695,0.12968627}, {700,0.12717647}, {705,0.11847059}, {710,0.12433333}, {715,0.12970588}, {720,0.12120588}, {725,0.13239216}, {730,0.13064706}, {735,0.14197059}, {740,0.12813725}, {745,0.13505882}, {750,0.13831373}, {755,0.14017647}, {760,0.13596078}, {765,0.14572549}, {770,0.12722549}, {775,0.13678431}, {780,0.13311765}, {785,0.13327451}, {790,0.13953922}, {795,0.14514706}, {800,0.13140196}, {805,0.14198039}, {810,0.14252941}, {815,0.15372549}, {820,0.14296078}, {825,0.14955882}, {830,0.15590196}, {835,0.14599020}, {840,0.14174510}, {845,0.15347059}, {850,0.14783333}, {855,0.15876471}, {860,0.15580392}, {865,0.15113725}, {870,0.15638235}, {875,0.16154902}, {880,0.15303922}, {885,0.16560784}, {890,0.16482353}, {895,0.17657843}, {900,0.15181373}, {905,0.15696078}, {910,0.16434314}, {915,0.16702941}, {920,0.16064706}, {925,0.17200000}, {930,0.16118627}, {935,0.17274510}, {940,0.16725490}, {945,0.16867647}, {950,0.17598039}, {955,0.18184314}, {960,0.16089216}, {965,0.17381373}, {970,0.17549020}, {975,0.18691176}, {980,0.17586275}, {985,0.18223529}, {990,0.18916667}, {995,0.18311765}, {1000,0.17708824}, {1010,0.18414706}, {1020,0.19130392}, {1030,0.17764706}, {1040,0.17289216}, {1050,0.18689216}, {1060,0.18240196}, {1070,0.19756863}, {1080,0.19314706}, {1090,0.18707843}, {1100,0.19437255}, {1110,0.20258824}, {1120,0.19143137}, {1130,0.20792157}, {1140,0.20698039}, {1150,0.22310784}, {1160,0.19818627}, {1170,0.20601961}, {1180,0.21553922}, {1190,0.21617647}, {1200,0.21048039}, {1210,0.22701961}, {1220,0.21425490}, {1230,0.23069608}, {1240,0.22439216}, {1250,0.22425490}, {1260,0.23622549}, {1270,0.24233333}, {1280,0.21022549}, {1290,0.22691176}, {1300,0.22901961}, {1310,0.24664706}, {1320,0.23092157}, {1330,0.24126471}, {1340,0.25085294}, {1350,0.24504902}, {1360,0.23679412}, {1370,0.25518627}, {1380,0.24867647}, {1390,0.26663725}, {1400,0.26126471}, {1410,0.24558824}, {1420,0.25465686}, {1430,0.26341176}, {1440,0.24803922}, {1450,0.26652941}, {1460,0.26795098}, {1470,0.28692157}, {1480,0.26435294}, {1490,0.27446078}, {1500,0.28549020}, {1510,0.28637255}, {1520,0.27741176}, {1530,0.29620588}, {1540,0.26369608}, {1550,0.28273529}, {1560,0.27452941}, {1570,0.27481373}, {1580,0.28475490}, {1590,0.29606863}, {1600,0.27009804}, {1610,0.29079412}, {1620,0.29138235}, {1630,0.31376471}, {1640,0.29451961}, {1650,0.30535294}, {1660,0.31791176}, {1670,0.30097059}, {1680,0.29247059}, {1690,0.31328431}, {1700,0.30302941}, {1710,0.32572549}, {1720,0.31796078}, {1730,0.30955882}, {1740,0.32055882}, {1750,0.33347059}, {1760,0.31378431}, {1770,0.33706863}, {1780,0.33540196}, {1790,0.36282353}, {1800,0.31271569}, {1810,0.32351961}, {1820,0.33488235}, {1830,0.33838235}, {1840,0.32991176}, {1850,0.35287255}, {1860,0.33132353}, {1870,0.35423529}, {1880,0.34429412}, {1890,0.34554902}, {1900,0.35898039}, {1910,0.37232353}, {1920,0.32975490}, {1930,0.35305882}, {1940,0.35294118}, {1950,0.37886275}, {1960,0.36159804}, {1970,0.37243137}, {1980,0.38662745}, {1990,0.37688235}, {2000,0.36476471}, {2050,0.35430392}, {2100,0.38520588}, {2150,0.40536275}, {2200,0.40454902}, {2250,0.42305882}, {2300,0.45729412}, {2350,0.45627451}, {2400,0.43440196}, {2450,0.45797059}, {2500,0.46496078}, {2550,0.51488235}, {2600,0.47144118}, {2650,0.51012745}, {2700,0.50056863}, {2750,0.56106863}, {2800,0.53084314}, {2850,0.52680392}, {2900,0.55458824}, {2950,0.56158824}, {3000,0.58675490}, {3050,0.61205882}, {3100,0.58164706}, {3150,0.61218627}, {3200,0.56076471}, {3250,0.62692157}, {3300,0.63640196}, {3350,0.63967647}, {3400,0.63240196}, {3450,0.70199020}, {3500,0.69075490}, {3550,0.73905882}, {3600,0.64741176}, {3650,0.67860784}, {3700,0.72848039}, {3750,0.73960784}, {3800,0.74914706}, {3850,0.73298039}, {3900,0.78866667}, {3950,0.81966667}, {4000,0.75544118}, {4050,0.81322549}, {4100,0.72554902}, {4150,0.81037255}, {4200,0.79441176}, {4250,0.83653922}, {4300,0.84049020}, {4350,0.92594118}, {4400,0.83223529}, {4450,0.86854902}, {4500,0.87609804}, {4550,0.90923529}, {4600,0.94719608}, {4650,0.90361765}, {4700,0.94172549}, {4750,0.95399020}, {4800,0.89818627}, {4850,1.00191176}, {4900,0.94640196}, {4950,1.01135294}, {5000,0.96435294}, {5050,1.06424510}, {5100,1.07388235}, {5150,1.03519608}, {5200,0.98415686}, {5250,0.99220588}, {5300,1.06422549}, {5350,1.10331373}, {5400,1.04878431}, {5450,1.09589216}, {5500,1.16504902}, {5550,1.17332353}, {5600,1.11849020}, {5650,1.09374510}, {5700,1.10965686}, {5750,1.22020588}, {5800,1.15212745}, {5850,1.22613725}, {5900,1.17063725}, {5950,1.29738235}, {6000,1.21505882}, {6050,1.30750}, {6100,1.32275}, {6150,1.20550}, {6200,1.24675}, {6250,1.29175}, {6300,1.29925}, {6350,1.35275}, {6400,1.19075}, {6450,1.32250}, {6500,1.33200}, {6550,1.38625}, {6600,1.36100}, {6650,1.49225}, {6700,1.37625}, {6750,1.47225}, {6800,1.35350}, {6850,1.40375}, {6900,1.53525}, {6950,1.47950}, {7000,1.52075}, {7050,1.49175}, {7100,1.59250}, {7150,1.63700}, {7200,1.37900}, {7250,1.50325}, {7300,1.44350}, {7350,1.58750}, {7400,1.55175}, {7450,1.56075}, {7500,1.56500}, {7550,1.72325}, {7600,1.57600}, {7650,1.63850}, {7700,1.55675}, {7750,1.61825}, {7800,1.67500}, {7850,1.68050}, {7900,1.74350}, {7950,1.70975}, {8000,1.60275}, {8050,1.76250}, {8100,1.72075}, {8150,1.84275}, {8200,1.54900}, {8250,1.72375}, {8300,1.72050}, {8350,1.78000}, {8400,1.68850}, {8450,1.64650}, {8500,1.74500}, {8550,1.81475}, {8600,1.76100}, {8650,1.82475}, {8700,1.93700}, {8750,1.85050}, {8800,1.73725}, {8850,1.80875}, {8900,1.82125}, {8950,2.00050}, {9000,1.83025}, {9050,1.96150}, {9100,1.90125}, {9150,2.08625}, {9200,1.98150}, {9250,1.82150}, {9300,1.90700}, {9350,1.91675}, {9400,1.98625}, {9450,2.04625}, {9500,2.00875}, {9550,2.07200}, {9600,1.87925}, {9650,2.08375}, {9700,2.07875}, {9750,2.05200}, {9800,1.98875}, {9850,2.18625}, {9900,2.12375}, {9950,2.25425}, {10000,2.02975}, {10100,2.25225}, {10200,2.26200}, {10300,2.17950}, {10400,2.05925}, {10500,2.07700}, {10600,2.25725}, {10700,2.32100}, {10800,2.20875}, {10900,2.27500}, {11000,2.44125}, {11100,2.47250}, {11200,2.32775}, {11300,2.27925}, {11400,2.29925}, {11500,2.52975}, {11600,2.41750}, {11700,2.58050}, {11800,2.45125}, {11900,2.68850}, {12000,2.55325}, {12100,2.57125}, {12200,2.67100}, {12300,2.42500}, {12400,2.53275}, {12500,2.63450}, {12600,2.64950}, {12700,2.75475}, {12800,2.43150}, {12900,2.69900}, {13000,2.72050}, {13100,2.83475}, {13200,2.75975}, {13300,3.05875}, {13400,2.82875}, {13500,3.00425}, {13600,2.75075}, {13700,2.87325}, {13800,3.08850}, {13900,2.98425}, {14000,3.02400}, {14100,3.03025}, {14200,3.22300}, {14300,3.33525}, {14400,2.83850}, {14500,3.04425}, {14600,2.96250}, {14700,3.26500}, {14800,3.19350}, {14900,3.20850}, {15000,3.22100}, {15100,3.52775}, {15200,3.27000}, {15300,3.38000}, {15400,3.20075}, {15500,3.32850}, {15600,3.44200}, {15700,3.47200}, {15800,3.58875}, {15900,3.51175}, {16000,3.29825}, {16100,3.62175}, {16200,3.55100}, {16300,3.77825}, {16400,3.18825}, {16500,3.52900}, {16600,3.56725}, {16700,3.70175}, {16800,3.48800}, {16900,3.39950}, {17000,3.63250}, {17100,3.77425}, {17200,3.66000}, {17300,3.78675}, {17400,4.07525}, {17500,3.86675}, {17600,3.64225}, {17700,3.77550}, {17800,3.80175}, {17900,4.16075}, {18000,3.83475}, {18100,4.08475}, {18200,3.97100}, {18300,4.37775}, {18400,4.10675}, {18500,3.80600}, {18600,3.93975}, {18700,3.96450}, {18800,4.12000}, {18900,4.26425}, {19000,4.17975}, {19100,4.30725}, {19200,3.92750}, {19300,4.33900}, {19400,4.35225}, {19500,4.24150}, {19600,4.13200}, {19700,4.53425}, {19800,4.42550}, {19900,4.70975}, {20000,4.20900}};
data["big_flat"]["Ltac2"]["actual reif"]["user"] = {{1,0.00043137}, {2,0.00057843}, {3,0.00066667}, {4,0.00067647}, {5,0.00077451}, {6,0.00098039}, {7,0.00090196}, {8,0.00108824}, {9,0.00093137}, {10,0.00130392}, {11,0.00173529}, {12,0.00150980}, {13,0.00139216}, {14,0.00170588}, {15,0.00201961}, {16,0.00200980}, {17,0.00224510}, {18,0.00236275}, {19,0.00252941}, {20,0.00246078}, {21,0.00287255}, {22,0.01341176}, {23,0.00291176}, {24,0.00274510}, {25,0.00311765}, {26,0.00309804}, {27,0.00351961}, {28,0.00337255}, {29,0.00389216}, {30,0.00376471}, {31,0.00438235}, {32,0.00413725}, {33,0.00436275}, {34,0.00451961}, {35,0.00473529}, {36,0.00444118}, {37,0.00496078}, {38,0.00524510}, {39,0.00690196}, {40,0.00550980}, {41,0.00573529}, {42,0.00580392}, {43,0.00598039}, {44,0.00600980}, {45,0.00647059}, {46,0.00642157}, {47,0.00700980}, {48,0.00652941}, {49,0.00663725}, {50,0.00696078}, {51,0.00748039}, {52,0.00793137}, {53,0.00753922}, {54,0.00782353}, {55,0.00832353}, {56,0.00778431}, {57,0.00830392}, {58,0.00817647}, {59,0.00894118}, {60,0.00867647}, {61,0.00983333}, {62,0.00879412}, {63,0.00953922}, {64,0.00852941}, {65,0.00945098}, {66,0.00950980}, {67,0.00994118}, {68,0.00953922}, {69,0.01013725}, {70,0.01124510}, {71,0.01114706}, {72,0.01031373}, {73,0.01062745}, {74,0.01090196}, {75,0.01160784}, {76,0.01142157}, {77,0.01185294}, {78,0.01199020}, {79,0.01229412}, {80,0.01150000}, {81,0.01209804}, {82,0.01224510}, {83,0.01271569}, {84,0.01287255}, {85,0.01277451}, {86,0.01317647}, {87,0.01334314}, {88,0.01256863}, {89,0.01320588}, {90,0.01337255}, {91,0.01450980}, {92,0.01365686}, {93,0.01424510}, {94,0.01430392}, {95,0.01509804}, {96,0.01356863}, {97,0.01465686}, {98,0.01413725}, {99,0.01446078}, {100,0.01450980}, {101,0.01499020}, {102,0.01574510}, {103,0.01574510}, {104,0.01474510}, {105,0.01527451}, {106,0.01543137}, {107,0.01630392}, {108,0.01639216}, {109,0.01638235}, {110,0.01670588}, {111,0.01800000}, {112,0.01591176}, {113,0.01739216}, {114,0.01655882}, {115,0.01742157}, {116,0.01679412}, {117,0.01874510}, {118,0.01818627}, {119,0.01892157}, {120,0.01756863}, {121,0.01831373}, {122,0.01960784}, {123,0.01914706}, {124,0.01872549}, {125,0.01963725}, {126,0.02022549}, {127,0.02076471}, {128,0.01750000}, {129,0.01881373}, {130,0.01901961}, {131,0.02066667}, {132,0.01942157}, {133,0.02027451}, {134,0.02045098}, {135,0.02242157}, {136,0.01979412}, {137,0.02102941}, {138,0.02106863}, {139,0.02296078}, {140,0.02083333}, {141,0.02196078}, {142,0.02261765}, {143,0.02430392}, {144,0.02106863}, {145,0.02227451}, {146,0.02247059}, {147,0.02417647}, {148,0.02246078}, {149,0.02365686}, {150,0.02482353}, {151,0.02451961}, {152,0.02307843}, {153,0.02389216}, {154,0.02497059}, {155,0.02516667}, {156,0.02422549}, {157,0.02597059}, {158,0.02552941}, {159,0.02620588}, {160,0.02340196}, {161,0.02514706}, {162,0.02438235}, {163,0.02564706}, {164,0.02544118}, {165,0.02584314}, {166,0.02594118}, {167,0.02667647}, {168,0.02539216}, {169,0.02618627}, {170,0.02629412}, {171,0.02785294}, {172,0.02648039}, {173,0.02763725}, {174,0.02874510}, {175,0.02900980}, {176,0.02608824}, {177,0.02813725}, {178,0.02712745}, {179,0.02864706}, {180,0.02867647}, {181,0.02916667}, {182,0.02904902}, {183,0.03097059}, {184,0.02783333}, {185,0.02966667}, {186,0.03043137}, {187,0.03112745}, {188,0.02936275}, {189,0.03236275}, {190,0.03134314}, {191,0.03358824}, {192,0.02728431}, {193,0.02881373}, {194,0.03023529}, {195,0.03046078}, {196,0.02933333}, {197,0.03162745}, {198,0.03084314}, {199,0.03257843}, {200,0.03069608}, {201,0.03131373}, {202,0.03154902}, {203,0.03391176}, {204,0.03165686}, {205,0.03430392}, {206,0.03370588}, {207,0.03484314}, {208,0.03217647}, {209,0.03266667}, {210,0.03268627}, {211,0.03516667}, {212,0.03302941}, {213,0.03530392}, {214,0.03482353}, {215,0.03622549}, {216,0.03412745}, {217,0.03554902}, {218,0.03620588}, {219,0.03662745}, {220,0.03544118}, {221,0.03674510}, {222,0.03697059}, {223,0.03896078}, {224,0.03375490}, {225,0.03576471}, {226,0.03509804}, {227,0.03688235}, {228,0.03640196}, {229,0.03697059}, {230,0.03804902}, {231,0.03834314}, {232,0.03669608}, {233,0.03733333}, {234,0.03748039}, {235,0.03989216}, {236,0.03762745}, {237,0.03983333}, {238,0.03936275}, {239,0.04152941}, {240,0.03690196}, {241,0.03922549}, {242,0.03839216}, {243,0.03989216}, {244,0.03926471}, {245,0.04031373}, {246,0.04146078}, {247,0.04216667}, {248,0.04006863}, {249,0.04045098}, {250,0.04158824}, {251,0.04259804}, {252,0.04218627}, {253,0.04263725}, {254,0.04367647}, {255,0.04500980}, {256,0.03839216}, {257,0.03894118}, {258,0.04035294}, {259,0.04131373}, {260,0.03943137}, {261,0.04138235}, {262,0.04127451}, {263,0.04451961}, {264,0.03980392}, {265,0.04349020}, {266,0.04188235}, {267,0.04541176}, {268,0.04197059}, {269,0.04569608}, {270,0.04439216}, {271,0.04767647}, {272,0.04081373}, {273,0.04454902}, {274,0.04326471}, {275,0.04624510}, {276,0.04353922}, {277,0.04660784}, {278,0.04552941}, {279,0.04750980}, {280,0.04486275}, {281,0.04617647}, {282,0.04663725}, {283,0.04823529}, {284,0.04701961}, {285,0.04839216}, {286,0.04898039}, {287,0.05013725}, {288,0.04456863}, {289,0.04580392}, {290,0.04705882}, {291,0.04783333}, {292,0.04590196}, {293,0.04890196}, {294,0.04819608}, {295,0.05042157}, {296,0.04617647}, {297,0.04957843}, {298,0.04840196}, {299,0.05121569}, {300,0.04876471}, {301,0.05046078}, {302,0.05103922}, {303,0.05261765}, {304,0.04820588}, {305,0.04956863}, {306,0.05056863}, {307,0.05249020}, {308,0.04992157}, {309,0.05253922}, {310,0.05157843}, {311,0.05491176}, {312,0.05150980}, {313,0.05223529}, {314,0.05287255}, {315,0.05489216}, {316,0.05336275}, {317,0.05593137}, {318,0.05453922}, {319,0.05817647}, {320,0.04816667}, {321,0.05126471}, {322,0.05122549}, {323,0.05281373}, {324,0.05132353}, {325,0.05250000}, {326,0.05390196}, {327,0.05617647}, {328,0.05093137}, {329,0.05396078}, {330,0.05331373}, {331,0.05692157}, {332,0.05493137}, {333,0.05618627}, {334,0.05728431}, {335,0.05922549}, {336,0.05180392}, {337,0.05536275}, {338,0.05594118}, {339,0.05657843}, {340,0.05589216}, {341,0.05728431}, {342,0.05733333}, {343,0.06059804}, {344,0.05473529}, {345,0.05855882}, {346,0.05879412}, {347,0.06006863}, {348,0.05874510}, {349,0.06171569}, {350,0.06079412}, {351,0.06274510}, {352,0.05561765}, {353,0.05686275}, {354,0.05685294}, {355,0.06028431}, {356,0.05754902}, {357,0.05970588}, {358,0.06065686}, {359,0.06301961}, {360,0.05806863}, {361,0.06098039}, {362,0.06115686}, {363,0.06268627}, {364,0.06153922}, {365,0.06378431}, {366,0.06253922}, {367,0.06507843}, {368,0.05962745}, {369,0.06202941}, {370,0.06171569}, {371,0.06481373}, {372,0.06235294}, {373,0.06402941}, {374,0.06350980}, {375,0.06727451}, {376,0.06281373}, {377,0.06440196}, {378,0.06530392}, {379,0.06809804}, {380,0.06502941}, {381,0.06719608}, {382,0.06876471}, {383,0.07170588}, {384,0.05920588}, {385,0.06062745}, {386,0.06177451}, {387,0.06391176}, {388,0.06102941}, {389,0.06295098}, {390,0.06425490}, {391,0.06681373}, {392,0.06140196}, {393,0.06484314}, {394,0.06528431}, {395,0.06717647}, {396,0.06391176}, {397,0.06785294}, {398,0.06854902}, {399,0.07037255}, {400,0.06208824}, {401,0.06490196}, {402,0.06638235}, {403,0.06840196}, {404,0.06540196}, {405,0.06789216}, {406,0.06937255}, {407,0.07178431}, {408,0.06618627}, {409,0.06848039}, {410,0.07038235}, {411,0.07281373}, {412,0.06965686}, {413,0.07276471}, {414,0.07201961}, {415,0.07527451}, {416,0.06569608}, {417,0.06812745}, {418,0.06866667}, {419,0.07042157}, {420,0.06868627}, {421,0.07182353}, {422,0.07193137}, {423,0.07440196}, {424,0.06826471}, {425,0.07228431}, {426,0.07237255}, {427,0.07447059}, {428,0.07219608}, {429,0.07550980}, {430,0.07413725}, {431,0.07832353}, {432,0.07113725}, {433,0.07332353}, {434,0.07302941}, {435,0.07588235}, {436,0.07258824}, {437,0.07650980}, {438,0.07699020}, {439,0.07970588}, {440,0.07391176}, {441,0.07576471}, {442,0.07655882}, {443,0.08064706}, {444,0.07599020}, {445,0.08040196}, {446,0.08049020}, {447,0.08349020}, {448,0.07052941}, {449,0.07320588}, {450,0.07340196}, {451,0.07509804}, {452,0.07279412}, {453,0.07675490}, {454,0.07650000}, {455,0.07914706}, {456,0.07355882}, {457,0.07659804}, {458,0.07776471}, {459,0.07940196}, {460,0.07706863}, {461,0.08095098}, {462,0.08080392}, {463,0.08404902}, {464,0.07475490}, {465,0.07756863}, {466,0.07765686}, {467,0.08145098}, {468,0.07733333}, {469,0.08035294}, {470,0.08178431}, {471,0.08549020}, {472,0.07981373}, {473,0.08280392}, {474,0.08259804}, {475,0.08543137}, {476,0.08275490}, {477,0.08514706}, {478,0.08500980}, {479,0.08788235}, {480,0.07671569}, {481,0.08007843}, {482,0.08057843}, {483,0.08299020}, {484,0.07987255}, {485,0.08437255}, {486,0.08515686}, {487,0.08765686}, {488,0.08210784}, {489,0.08511765}, {490,0.08510784}, {491,0.08817647}, {492,0.08497059}, {493,0.08815686}, {494,0.08824510}, {495,0.09147059}, {496,0.08310784}, {497,0.08567647}, {498,0.08597059}, {499,0.08874510}, {500,0.08604902}, {505,0.08973529}, {510,0.09366667}, {515,0.08628431}, {520,0.08374510}, {525,0.09057843}, {530,0.08774510}, {535,0.09643137}, {540,0.09333333}, {545,0.09092157}, {550,0.09585294}, {555,0.09995098}, {560,0.09383333}, {565,0.10176471}, {570,0.10200000}, {575,0.10846078}, {580,0.09627451}, {585,0.10106863}, {590,0.10499020}, {595,0.10652941}, {600,0.10390196}, {605,0.11042157}, {610,0.10394118}, {615,0.11217647}, {620,0.11020588}, {625,0.10983333}, {630,0.11411765}, {635,0.11958824}, {640,0.10260784}, {645,0.10998039}, {650,0.11075490}, {655,0.12038235}, {660,0.11491176}, {665,0.11656863}, {670,0.12194118}, {675,0.12032353}, {680,0.11570588}, {685,0.12475490}, {690,0.12274510}, {695,0.12980392}, {700,0.12738235}, {705,0.11822549}, {710,0.12382353}, {715,0.12935294}, {720,0.12121569}, {725,0.13234314}, {730,0.13050980}, {735,0.14212745}, {740,0.12779412}, {745,0.13469608}, {750,0.13812745}, {755,0.13988235}, {760,0.13570588}, {765,0.14550000}, {770,0.12690196}, {775,0.13640196}, {780,0.13306863}, {785,0.13347059}, {790,0.13935294}, {795,0.14494118}, {800,0.13132353}, {805,0.14206863}, {810,0.14237255}, {815,0.15335294}, {820,0.14285294}, {825,0.14890196}, {830,0.15552941}, {835,0.14603922}, {840,0.14174510}, {845,0.15319608}, {850,0.14768627}, {855,0.15844118}, {860,0.15559804}, {865,0.15054902}, {870,0.15616667}, {875,0.16097059}, {880,0.15292157}, {885,0.16544118}, {890,0.16477451}, {895,0.17675490}, {900,0.15173529}, {905,0.15686275}, {910,0.16407843}, {915,0.16683333}, {920,0.15997059}, {925,0.17129412}, {930,0.16101961}, {935,0.17242157}, {940,0.16730392}, {945,0.16836275}, {950,0.17570588}, {955,0.18175490}, {960,0.16024510}, {965,0.17339216}, {970,0.17501961}, {975,0.18651961}, {980,0.17530392}, {985,0.18205882}, {990,0.18873529}, {995,0.18261765}, {1000,0.17700000}, {1010,0.18363725}, {1020,0.19133333}, {1030,0.17770588}, {1040,0.17238235}, {1050,0.18651961}, {1060,0.18229412}, {1070,0.19713725}, {1080,0.19280392}, {1090,0.18642157}, {1100,0.19378431}, {1110,0.20246078}, {1120,0.19118627}, {1130,0.20746078}, {1140,0.20675490}, {1150,0.22282353}, {1160,0.19775490}, {1170,0.20563725}, {1180,0.21532353}, {1190,0.21599020}, {1200,0.21012745}, {1210,0.22693137}, {1220,0.21379412}, {1230,0.23025490}, {1240,0.22397059}, {1250,0.22348039}, {1260,0.23530392}, {1270,0.24179412}, {1280,0.20979412}, {1290,0.22631373}, {1300,0.22859804}, {1310,0.24633333}, {1320,0.23041176}, {1330,0.24093137}, {1340,0.25088235}, {1350,0.24448039}, {1360,0.23624510}, {1370,0.25519608}, {1380,0.24832353}, {1390,0.26682353}, {1400,0.26095098}, {1410,0.24510784}, {1420,0.25452941}, {1430,0.26348039}, {1440,0.24785294}, {1450,0.26633333}, {1460,0.26793137}, {1470,0.28665686}, {1480,0.26439216}, {1490,0.27430392}, {1500,0.28580392}, {1510,0.28615686}, {1520,0.27750000}, {1530,0.29577451}, {1540,0.26336275}, {1550,0.28285294}, {1560,0.27430392}, {1570,0.27480392}, {1580,0.28447059}, {1590,0.29597059}, {1600,0.27007843}, {1610,0.29061765}, {1620,0.29143137}, {1630,0.31357843}, {1640,0.29452941}, {1650,0.30514706}, {1660,0.31786275}, {1670,0.30092157}, {1680,0.29247059}, {1690,0.31310784}, {1700,0.30288235}, {1710,0.32537255}, {1720,0.31762745}, {1730,0.30942157}, {1740,0.32035294}, {1750,0.33310784}, {1760,0.31382353}, {1770,0.33684314}, {1780,0.33500980}, {1790,0.36251961}, {1800,0.31268627}, {1810,0.32298039}, {1820,0.33469608}, {1830,0.33810784}, {1840,0.32935294}, {1850,0.35249020}, {1860,0.33089216}, {1870,0.35387255}, {1880,0.34378431}, {1890,0.34515686}, {1900,0.35856863}, {1910,0.37196078}, {1920,0.32927451}, {1930,0.35265686}, {1940,0.35281373}, {1950,0.37841176}, {1960,0.36113725}, {1970,0.37200000}, {1980,0.38634314}, {1990,0.37656863}, {2000,0.36450000}, {2050,0.35392157}, {2100,0.38447059}, {2150,0.40473529}, {2200,0.40383333}, {2250,0.42260784}, {2300,0.45684314}, {2350,0.45593137}, {2400,0.43395098}, {2450,0.45725490}, {2500,0.46415686}, {2550,0.51450000}, {2600,0.47070588}, {2650,0.50984314}, {2700,0.49998039}, {2750,0.56018627}, {2800,0.53031373}, {2850,0.52615686}, {2900,0.55408824}, {2950,0.56083333}, {3000,0.58623529}, {3050,0.61158824}, {3100,0.58085294}, {3150,0.61156863}, {3200,0.56039216}, {3250,0.62597059}, {3300,0.63551961}, {3350,0.63905882}, {3400,0.63164706}, {3450,0.70112745}, {3500,0.69012745}, {3550,0.73827451}, {3600,0.64647059}, {3650,0.67793137}, {3700,0.72780392}, {3750,0.73859804}, {3800,0.74791176}, {3850,0.73224510}, {3900,0.78774510}, {3950,0.81883333}, {4000,0.75454902}, {4050,0.81230392}, {4100,0.72490196}, {4150,0.80944118}, {4200,0.79329412}, {4250,0.83567647}, {4300,0.83937255}, {4350,0.92508824}, {4400,0.83129412}, {4450,0.86783333}, {4500,0.87506863}, {4550,0.90825490}, {4600,0.94590196}, {4650,0.90264706}, {4700,0.94059804}, {4750,0.95284314}, {4800,0.89685294}, {4850,1.00059804}, {4900,0.94499020}, {4950,1.01058824}, {5000,0.96292157}, {5050,1.06312745}, {5100,1.07258824}, {5150,1.03419608}, {5200,0.98300000}, {5250,0.99112745}, {5300,1.06337255}, {5350,1.10196078}, {5400,1.04755882}, {5450,1.09489216}, {5500,1.16360784}, {5550,1.17198039}, {5600,1.11748039}, {5650,1.09287255}, {5700,1.10826471}, {5750,1.21883333}, {5800,1.15076471}, {5850,1.22450980}, {5900,1.16920588}, {5950,1.29559804}, {6000,1.21364706}, {6050,1.29875}, {6100,1.31775}, {6150,1.20150}, {6200,1.24575}, {6250,1.29275}, {6300,1.29875}, {6350,1.35150}, {6400,1.18925}, {6450,1.32075}, {6500,1.33175}, {6550,1.38350}, {6600,1.35175}, {6650,1.48775}, {6700,1.36975}, {6750,1.46750}, {6800,1.34725}, {6850,1.39525}, {6900,1.49575}, {6950,1.46450}, {7000,1.46875}, {7050,1.48150}, {7100,1.58150}, {7150,1.63150}, {7200,1.36975}, {7250,1.47575}, {7300,1.44250}, {7350,1.58700}, {7400,1.55150}, {7450,1.56025}, {7500,1.56375}, {7550,1.72225}, {7600,1.57625}, {7650,1.63700}, {7700,1.55750}, {7750,1.61950}, {7800,1.67425}, {7850,1.68075}, {7900,1.74500}, {7950,1.70925}, {8000,1.60375}, {8050,1.76300}, {8100,1.72050}, {8150,1.84325}, {8200,1.54850}, {8250,1.72325}, {8300,1.71950}, {8350,1.77925}, {8400,1.68850}, {8450,1.64675}, {8500,1.74350}, {8550,1.81375}, {8600,1.76250}, {8650,1.82500}, {8700,1.93625}, {8750,1.84975}, {8800,1.73725}, {8850,1.80825}, {8900,1.82225}, {8950,1.99975}, {9000,1.82975}, {9050,1.96225}, {9100,1.90050}, {9150,2.08525}, {9200,1.98000}, {9250,1.82150}, {9300,1.90625}, {9350,1.91675}, {9400,1.98800}, {9450,2.04450}, {9500,2.00975}, {9550,2.07175}, {9600,1.88000}, {9650,2.08350}, {9700,2.07825}, {9750,2.05300}, {9800,1.98950}, {9850,2.18550}, {9900,2.12275}, {9950,2.25325}, {10000,2.02425}, {10100,2.23425}, {10200,2.25650}, {10300,2.17225}, {10400,2.05475}, {10500,2.07550}, {10600,2.22500}, {10700,2.31325}, {10800,2.20525}, {10900,2.27000}, {11000,2.43875}, {11100,2.46950}, {11200,2.32475}, {11300,2.27625}, {11400,2.29700}, {11500,2.52450}, {11600,2.41325}, {11700,2.57700}, {11800,2.44825}, {11900,2.68450}, {12000,2.54975}, {12100,2.56950}, {12200,2.66875}, {12300,2.42175}, {12400,2.53075}, {12500,2.63375}, {12600,2.64525}, {12700,2.75175}, {12800,2.42700}, {12900,2.69650}, {13000,2.71800}, {13100,2.83025}, {13200,2.75575}, {13300,3.05600}, {13400,2.82550}, {13500,3.00125}, {13600,2.74775}, {13700,2.87175}, {13800,3.08375}, {13900,2.97950}, {14000,3.02050}, {14100,3.02675}, {14200,3.21925}, {14300,3.32900}, {14400,2.83550}, {14500,3.04025}, {14600,2.95900}, {14700,3.26125}, {14800,3.18875}, {14900,3.20425}, {15000,3.21650}, {15100,3.52375}, {15200,3.26450}, {15300,3.37500}, {15400,3.19450}, {15500,3.32450}, {15600,3.43625}, {15700,3.46800}, {15800,3.58650}, {15900,3.50850}, {16000,3.29550}, {16100,3.61875}, {16200,3.54675}, {16300,3.77400}, {16400,3.18375}, {16500,3.52450}, {16600,3.56375}, {16700,3.69850}, {16800,3.48475}, {16900,3.39650}, {17000,3.62850}, {17100,3.76975}, {17200,3.65575}, {17300,3.78150}, {17400,4.07025}, {17500,3.86100}, {17600,3.63675}, {17700,3.77050}, {17800,3.79800}, {17900,4.15575}, {18000,3.82900}, {18100,4.07825}, {18200,3.96575}, {18300,4.37200}, {18400,4.10075}, {18500,3.80100}, {18600,3.93400}, {18700,3.95800}, {18800,4.11525}, {18900,4.25725}, {19000,4.17400}, {19100,4.30225}, {19200,3.92350}, {19300,4.33400}, {19400,4.34750}, {19500,4.23425}, {19600,4.12675}, {19700,4.52825}, {19800,4.41875}, {19900,4.70350}, {20000,4.20475}};
data["big_flat"]["Ltac2"]["actual reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00003922}, {5,0.00010784}, {6,0.00003922}, {7,0.00000000}, {8,0.00003922}, {9,0.00007843}, {10,0.00003922}, {11,0.00000000}, {12,0.00000000}, {13,0.00003922}, {14,0.00000000}, {15,0.00003922}, {16,0.00003922}, {17,0.00007843}, {18,0.00002941}, {19,0.00003922}, {20,0.00000000}, {21,0.00007843}, {22,0.00000000}, {23,0.00003922}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00003922}, {30,0.00007843}, {31,0.00002941}, {32,0.00003922}, {33,0.00003922}, {34,0.00000000}, {35,0.00003922}, {36,0.00003922}, {37,0.00000000}, {38,0.00000000}, {39,0.00003922}, {40,0.00003922}, {41,0.00011765}, {42,0.00000000}, {43,0.00007843}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00015686}, {48,0.00003922}, {49,0.00003922}, {50,0.00000000}, {51,0.00003922}, {52,0.00000000}, {53,0.00007843}, {54,0.00000000}, {55,0.00003922}, {56,0.00003922}, {57,0.00003922}, {58,0.00006863}, {59,0.00000000}, {60,0.00003922}, {61,0.00003922}, {62,0.00003922}, {63,0.00003922}, {64,0.00000000}, {65,0.00000000}, {66,0.00019608}, {67,0.00003922}, {68,0.00007843}, {69,0.00003922}, {70,0.00000000}, {71,0.00003922}, {72,0.00000000}, {73,0.00000000}, {74,0.00007843}, {75,0.00000000}, {76,0.00000000}, {77,0.00003922}, {78,0.00000000}, {79,0.00000000}, {80,0.00002941}, {81,0.00003922}, {82,0.00000000}, {83,0.00000000}, {84,0.00003922}, {85,0.00003922}, {86,0.00000000}, {87,0.00003922}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00003922}, {92,0.00000000}, {93,0.00003922}, {94,0.00010784}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00007843}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00007843}, {103,0.00007843}, {104,0.00000000}, {105,0.00003922}, {106,0.00003922}, {107,0.00003922}, {108,0.00000000}, {109,0.00007843}, {110,0.00007843}, {111,0.00003922}, {112,0.00000000}, {113,0.00003922}, {114,0.00003922}, {115,0.00007843}, {116,0.00000000}, {117,0.00000000}, {118,0.00002941}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00019608}, {124,0.00003922}, {125,0.00000000}, {126,0.00003922}, {127,0.00000000}, {128,0.00000000}, {129,0.00011765}, {130,0.00000000}, {131,0.00000000}, {132,0.00003922}, {133,0.00007843}, {134,0.00000000}, {135,0.00003922}, {136,0.00007843}, {137,0.00000000}, {138,0.00003922}, {139,0.00000000}, {140,0.00007843}, {141,0.00000000}, {142,0.00003922}, {143,0.00000000}, {144,0.00003922}, {145,0.00000000}, {146,0.00000000}, {147,0.00003922}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00006863}, {153,0.00003922}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00007843}, {158,0.00002941}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00003922}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00007843}, {173,0.00003922}, {174,0.00003922}, {175,0.00000000}, {176,0.00003922}, {177,0.00000000}, {178,0.00007843}, {179,0.00000000}, {180,0.00002941}, {181,0.00000000}, {182,0.00000000}, {183,0.00003922}, {184,0.00011765}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00003922}, {192,0.00000000}, {193,0.00000000}, {194,0.00003922}, {195,0.00007843}, {196,0.00000000}, {197,0.00007843}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00003922}, {202,0.00000000}, {203,0.00000000}, {204,0.00003922}, {205,0.00000000}, {206,0.00007843}, {207,0.00000000}, {208,0.00003922}, {209,0.00000000}, {210,0.00000000}, {211,0.00007843}, {212,0.00000000}, {213,0.00003922}, {214,0.00003922}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00003922}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00003922}, {226,0.00003922}, {227,0.00000000}, {228,0.00000000}, {229,0.00002941}, {230,0.00000000}, {231,0.00003922}, {232,0.00000000}, {233,0.00000000}, {234,0.00002941}, {235,0.00003922}, {236,0.00000000}, {237,0.00003922}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00007843}, {243,0.00003922}, {244,0.00000000}, {245,0.00003922}, {246,0.00000000}, {247,0.00003922}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00007843}, {252,0.00000000}, {253,0.00003922}, {254,0.00000000}, {255,0.00000000}, {256,0.00003922}, {257,0.00000000}, {258,0.00003922}, {259,0.00000000}, {260,0.00003922}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003922}, {266,0.00000000}, {267,0.00003922}, {268,0.00000000}, {269,0.00000000}, {270,0.00006863}, {271,0.00000000}, {272,0.00003922}, {273,0.00000000}, {274,0.00003922}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00003922}, {279,0.00003922}, {280,0.00003922}, {281,0.00003922}, {282,0.00007843}, {283,0.00003922}, {284,0.00002941}, {285,0.00003922}, {286,0.00003922}, {287,0.00003922}, {288,0.00000000}, {289,0.00000000}, {290,0.00003922}, {291,0.00000000}, {292,0.00000000}, {293,0.00003922}, {294,0.00000000}, {295,0.00003922}, {296,0.00003922}, {297,0.00000000}, {298,0.00000000}, {299,0.00003922}, {300,0.00003922}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00003922}, {306,0.00003922}, {307,0.00000000}, {308,0.00011765}, {309,0.00003922}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00003922}, {316,0.00011765}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00003922}, {322,0.00000000}, {323,0.00000000}, {324,0.00003922}, {325,0.00007843}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00003922}, {332,0.00003922}, {333,0.00000000}, {334,0.00002941}, {335,0.00000000}, {336,0.00003922}, {337,0.00000000}, {338,0.00003922}, {339,0.00003922}, {340,0.00003922}, {341,0.00000000}, {342,0.00000000}, {343,0.00003922}, {344,0.00007843}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00003922}, {353,0.00000000}, {354,0.00000000}, {355,0.00003922}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00003922}, {364,0.00000000}, {365,0.00000000}, {366,0.00007843}, {367,0.00003922}, {368,0.00003922}, {369,0.00003922}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00003922}, {374,0.00003922}, {375,0.00003922}, {376,0.00003922}, {377,0.00000000}, {378,0.00003922}, {379,0.00003922}, {380,0.00000000}, {381,0.00000000}, {382,0.00007843}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00003922}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00003922}, {392,0.00007843}, {393,0.00003922}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00003922}, {399,0.00000000}, {400,0.00011765}, {401,0.00003922}, {402,0.00007843}, {403,0.00000000}, {404,0.00003922}, {405,0.00003922}, {406,0.00000000}, {407,0.00000000}, {408,0.00007843}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00007843}, {415,0.00003922}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00003922}, {420,0.00003922}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00007843}, {430,0.00003922}, {431,0.00015686}, {432,0.00000000}, {433,0.00000000}, {434,0.00007843}, {435,0.00003922}, {436,0.00003922}, {437,0.00007843}, {438,0.00003922}, {439,0.00000000}, {440,0.00003922}, {441,0.00007843}, {442,0.00010784}, {443,0.00006863}, {444,0.00003922}, {445,0.00003922}, {446,0.00003922}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00003922}, {451,0.00000000}, {452,0.00003922}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00003922}, {461,0.00003922}, {462,0.00003922}, {463,0.00007843}, {464,0.00007843}, {465,0.00000000}, {466,0.00000000}, {467,0.00009804}, {468,0.00003922}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00003922}, {474,0.00003922}, {475,0.00003922}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00002941}, {480,0.00000000}, {481,0.00003922}, {482,0.00007843}, {483,0.00003922}, {484,0.00003922}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00003922}, {490,0.00000000}, {491,0.00007843}, {492,0.00003922}, {493,0.00000000}, {494,0.00000000}, {495,0.00007843}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00003922}, {500,0.00000000}, {505,0.00003922}, {510,0.00000000}, {515,0.00003922}, {520,0.00003922}, {525,0.00003922}, {530,0.00000000}, {535,0.00003922}, {540,0.00000000}, {545,0.00003922}, {550,0.00007843}, {555,0.00007843}, {560,0.00000000}, {565,0.00007843}, {570,0.00000000}, {575,0.00000000}, {580,0.00007843}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00007843}, {620,0.00003922}, {625,0.00003922}, {630,0.00000000}, {635,0.00000000}, {640,0.00003922}, {645,0.00000000}, {650,0.00000000}, {655,0.00002941}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00007843}, {680,0.00002941}, {685,0.00007843}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00007843}, {715,0.00000000}, {720,0.00000000}, {725,0.00003922}, {730,0.00003922}, {735,0.00003922}, {740,0.00003922}, {745,0.00007843}, {750,0.00011765}, {755,0.00007843}, {760,0.00011765}, {765,0.00000000}, {770,0.00000000}, {775,0.00003922}, {780,0.00003922}, {785,0.00003922}, {790,0.00000000}, {795,0.00003922}, {800,0.00000000}, {805,0.00003922}, {810,0.00000000}, {815,0.00003922}, {820,0.00003922}, {825,0.00000000}, {830,0.00007843}, {835,0.00003922}, {840,0.00003922}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00003922}, {865,0.00011765}, {870,0.00000000}, {875,0.00003922}, {880,0.00007843}, {885,0.00003922}, {890,0.00007843}, {895,0.00003922}, {900,0.00003922}, {905,0.00003922}, {910,0.00003922}, {915,0.00007843}, {920,0.00003922}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00007843}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00003922}, {965,0.00003922}, {970,0.00000000}, {975,0.00007843}, {980,0.00003922}, {985,0.00000000}, {990,0.00003922}, {995,0.00007843}, {1000,0.00003922}, {1010,0.00003922}, {1020,0.00000000}, {1030,0.00003922}, {1040,0.00003922}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00003922}, {1080,0.00007843}, {1090,0.00000000}, {1100,0.00007843}, {1110,0.00000000}, {1120,0.00003922}, {1130,0.00003922}, {1140,0.00000000}, {1150,0.00006863}, {1160,0.00003922}, {1170,0.00003922}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00011765}, {1230,0.00003922}, {1240,0.00000000}, {1250,0.00007843}, {1260,0.00000000}, {1270,0.00003922}, {1280,0.00003922}, {1290,0.00000000}, {1300,0.00003922}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00003922}, {1350,0.00000000}, {1360,0.00002941}, {1370,0.00010784}, {1380,0.00003922}, {1390,0.00003922}, {1400,0.00011765}, {1410,0.00000000}, {1420,0.00003922}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003922}, {1490,0.00011765}, {1500,0.00000000}, {1510,0.00003922}, {1520,0.00006863}, {1530,0.00003922}, {1540,0.00007843}, {1550,0.00003922}, {1560,0.00000000}, {1570,0.00003922}, {1580,0.00003922}, {1590,0.00000000}, {1600,0.00003922}, {1610,0.00003922}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003922}, {1670,0.00000000}, {1680,0.00003922}, {1690,0.00015686}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00003922}, {1730,0.00000000}, {1740,0.00007843}, {1750,0.00007843}, {1760,0.00000000}, {1770,0.00007843}, {1780,0.00007843}, {1790,0.00003922}, {1800,0.00003922}, {1810,0.00003922}, {1820,0.00007843}, {1830,0.00003922}, {1840,0.00002941}, {1850,0.00000000}, {1860,0.00007843}, {1870,0.00007843}, {1880,0.00018627}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00007843}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00003922}, {1960,0.00007843}, {1970,0.00003922}, {1980,0.00007843}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00007843}, {2100,0.00011765}, {2150,0.00015686}, {2200,0.00011765}, {2250,0.00003922}, {2300,0.00011765}, {2350,0.00003922}, {2400,0.00005882}, {2450,0.00011765}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00003922}, {2650,0.00007843}, {2700,0.00015686}, {2750,0.00003922}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00002941}, {3000,0.00003922}, {3050,0.00003922}, {3100,0.00003922}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00007843}, {3300,0.00007843}, {3350,0.00007843}, {3400,0.00003922}, {3450,0.00007843}, {3500,0.00000000}, {3550,0.00011765}, {3600,0.00003922}, {3650,0.00003922}, {3700,0.00000000}, {3750,0.00007843}, {3800,0.00007843}, {3850,0.00007843}, {3900,0.00003922}, {3950,0.00011765}, {4000,0.00003922}, {4050,0.00007843}, {4100,0.00011765}, {4150,0.00000000}, {4200,0.00015686}, {4250,0.00003922}, {4300,0.00007843}, {4350,0.00003922}, {4400,0.00003922}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00003922}, {4600,0.00007843}, {4650,0.00007843}, {4700,0.00007843}, {4750,0.00007843}, {4800,0.00007843}, {4850,0.00015686}, {4900,0.00014706}, {4950,0.00007843}, {5000,0.00003922}, {5050,0.00007843}, {5100,0.00014706}, {5150,0.00003922}, {5200,0.00003922}, {5250,0.00006863}, {5300,0.00007843}, {5350,0.00010784}, {5400,0.00019608}, {5450,0.00011765}, {5500,0.00025490}, {5550,0.00018627}, {5600,0.00000000}, {5650,0.00003922}, {5700,0.00015686}, {5750,0.00011765}, {5800,0.00010784}, {5850,0.00011765}, {5900,0.00023529}, {5950,0.00028431}, {6000,0.00010784}, {6050,0.00900}, {6100,0.00475}, {6150,0.00300}, {6200,0.00000}, {6250,0.00000}, {6300,0.00100}, {6350,0.00175}, {6400,0.00100}, {6450,0.00075}, {6500,0.00000}, {6550,0.00300}, {6600,0.01000}, {6650,0.00500}, {6700,0.00575}, {6750,0.00500}, {6800,0.00400}, {6850,0.00500}, {6900,0.00500}, {6950,0.00500}, {7000,0.00800}, {7050,0.00600}, {7100,0.00300}, {7150,0.00100}, {7200,0.00200}, {7250,0.00000}, {7300,0.00000}, {7350,0.00100}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00100}, {10700,0.00000}, {10800,0.00100}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00100}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00100}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00100}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00075}, {15300,0.00000}, {15400,0.00100}, {15500,0.00000}, {15600,0.00100}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00100}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00100}, {17700,0.00000}, {17800,0.00000}, {17900,0.00100}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00175}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00100}, {19000,0.00100}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00100}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["Ltac2"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000980}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000980}, {274,0.00000000}, {275,0.00000980}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00100000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000980}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00100000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00002941}, {424,0.00000980}, {425,0.00001961}, {426,0.00000000}, {427,0.00000000}, {428,0.00001961}, {429,0.00000000}, {430,0.00000000}, {431,0.00003922}, {432,0.00001961}, {433,0.00002941}, {434,0.00001961}, {435,0.00000980}, {436,0.00001961}, {437,0.00001961}, {438,0.00000980}, {439,0.00000000}, {440,0.00000000}, {441,0.00002941}, {442,0.00000980}, {443,0.00001961}, {444,0.00000980}, {445,0.00002941}, {446,0.00003922}, {447,0.00002941}, {448,0.00003922}, {449,0.00003922}, {450,0.00006863}, {451,0.00006863}, {452,0.00175490}, {453,0.00009804}, {454,0.00016667}, {455,0.00015686}, {456,0.00021569}, {457,0.00019608}, {458,0.00029412}, {459,0.00029412}, {460,0.00037255}, {461,0.00030392}, {462,0.00031373}, {463,0.00042157}, {464,0.00058824}, {465,0.00059804}, {466,0.00058824}, {467,0.00063725}, {468,0.00063725}, {469,0.00073529}, {470,0.00076471}, {471,0.00079412}, {472,0.00078431}, {473,0.00080392}, {474,0.00079412}, {475,0.00080392}, {476,0.00077451}, {477,0.00079412}, {478,0.00084314}, {479,0.00081373}, {480,0.00080392}, {481,0.00082353}, {482,0.00082353}, {483,0.00084314}, {484,0.00082353}, {485,0.00082353}, {486,0.00088235}, {487,0.00086275}, {488,0.00090196}, {489,0.00088235}, {490,0.00093137}, {491,0.00092157}, {492,0.00094118}, {493,0.00095098}, {494,0.00094118}, {495,0.00098039}, {496,0.00097059}, {497,0.00098039}, {498,0.00097059}, {499,0.00099020}, {500,0.00099020}, {505,0.00100000}, {510,0.00100000}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00100000}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00101961}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00321569}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00308824}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00275490}, {825,0.00100000}, {830,0.00100000}, {835,0.00100000}, {840,0.00100000}, {845,0.00100000}, {850,0.00100000}, {855,0.00100000}, {860,0.00100980}, {865,0.00100000}, {870,0.00102941}, {875,0.00101961}, {880,0.00101961}, {885,0.00102941}, {890,0.00105882}, {895,0.00104902}, {900,0.00110784}, {905,0.00108824}, {910,0.00113725}, {915,0.00109804}, {920,0.00125490}, {925,0.00124510}, {930,0.00131373}, {935,0.00149020}, {940,0.00154902}, {945,0.00172549}, {950,0.00175490}, {955,0.00183333}, {960,0.00182353}, {965,0.00182353}, {970,0.00186275}, {975,0.00187255}, {980,0.00194118}, {985,0.00195098}, {990,0.00195098}, {995,0.00197059}, {1000,0.00197059}, {1010,0.00200000}, {1020,0.00200000}, {1030,0.00200000}, {1040,0.00200000}, {1050,0.00200000}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200980}, {1140,0.00200000}, {1150,0.00200000}, {1160,0.00200000}, {1170,0.00200000}, {1180,0.00200000}, {1190,0.00200000}, {1200,0.00200000}, {1210,0.00200000}, {1220,0.00200000}, {1230,0.00200000}, {1240,0.00200000}, {1250,0.00500980}, {1260,0.00200000}, {1270,0.00200980}, {1280,0.00200000}, {1290,0.00200980}, {1300,0.00201961}, {1310,0.00202941}, {1320,0.00204902}, {1330,0.00206863}, {1340,0.00208824}, {1350,0.00212745}, {1360,0.00211765}, {1370,0.00224510}, {1380,0.00222549}, {1390,0.00231373}, {1400,0.00238235}, {1410,0.00251961}, {1420,0.00271569}, {1430,0.00273529}, {1440,0.00410784}, {1450,0.00281373}, {1460,0.00281373}, {1470,0.00287255}, {1480,0.00291176}, {1490,0.00288235}, {1500,0.00300000}, {1510,0.00300000}, {1520,0.00300000}, {1530,0.00300000}, {1540,0.00300000}, {1550,0.00300000}, {1560,0.00300000}, {1570,0.00300000}, {1580,0.00300000}, {1590,0.00300000}, {1600,0.00300000}, {1610,0.00300000}, {1620,0.00300000}, {1630,0.00300980}, {1640,0.00300000}, {1650,0.00300980}, {1660,0.00300980}, {1670,0.00300000}, {1680,0.00300000}, {1690,0.00300000}, {1700,0.00540196}, {1710,0.00300000}, {1720,0.00300000}, {1730,0.00300000}, {1740,0.00301961}, {1750,0.00302941}, {1760,0.00304902}, {1770,0.00303922}, {1780,0.00643137}, {1790,0.00308824}, {1800,0.00312745}, {1810,0.00311765}, {1820,0.00314706}, {1830,0.00314706}, {1840,0.00326471}, {1850,0.00326471}, {1860,0.00343137}, {1870,0.00348039}, {1880,0.00361765}, {1890,0.00372549}, {1900,0.00729412}, {1910,0.00375490}, {1920,0.00378431}, {1930,0.00574510}, {1940,0.00380392}, {1950,0.00390196}, {1960,0.00392157}, {1970,0.00392157}, {1980,0.00398039}, {1990,0.00405882}, {2000,0.00400000}, {2050,0.00400000}, {2100,0.00400000}, {2150,0.00400980}, {2200,0.00403922}, {2250,0.00413725}, {2300,0.00438235}, {2350,0.00478431}, {2400,0.00486275}, {2450,0.00496078}, {2500,0.00500980}, {2550,0.00500980}, {2600,0.00512745}, {2650,0.00506863}, {2700,0.01261765}, {2750,0.00545098}, {2800,0.00936275}, {2850,0.01145098}, {2900,0.00601961}, {2950,0.00600980}, {3000,0.00602941}, {3050,0.00608824}, {3100,0.01266667}, {3150,0.00633333}, {3200,0.00650000}, {3250,0.00681373}, {3300,0.00688235}, {3350,0.01191176}, {3400,0.00702941}, {3450,0.00706863}, {3500,0.00708824}, {3550,0.01262745}, {3600,0.00740196}, {3650,0.00771569}, {3700,0.00785294}, {3750,0.00795098}, {3800,0.00796078}, {3850,0.01303922}, {3900,0.00812745}, {3950,0.00821569}, {4000,0.00839216}, {4050,0.00850000}, {4100,0.01322549}, {4150,0.00887255}, {4200,0.00895098}, {4250,0.00900000}, {4300,0.00907843}, {4350,0.01779412}, {4400,0.00924510}, {4450,0.00941176}, {4500,0.00954902}, {4550,0.00973529}, {4600,0.00991176}, {4650,0.01955882}, {4700,0.01002941}, {4750,0.01014706}, {4800,0.01024510}, {4850,0.01037255}, {4900,0.01049020}, {4950,0.01077451}, {5000,0.01087255}, {5050,0.01095098}, {5100,0.01102941}, {5150,0.01108824}, {5200,0.01118627}, {5250,0.01139216}, {5300,0.01153922}, {5350,0.01164706}, {5400,0.01200000}, {5450,0.01193137}, {5500,0.01197059}, {5550,0.01204902}, {5600,0.01219608}, {5650,0.01206863}, {5700,0.01243137}, {5750,0.01263725}, {5800,0.02285294}, {5850,0.02123529}, {5900,0.01300980}, {5950,0.01306863}, {6000,0.02315686}, {6050,0.01425}, {6100,0.01425}, {6150,0.01400}, {6200,0.01475}, {6250,0.02050}, {6300,0.01850}, {6350,0.01500}, {6400,0.02500}, {6450,0.02850}, {6500,0.01525}, {6550,0.02575}, {6600,0.02850}, {6650,0.01575}, {6700,0.01575}, {6750,0.01600}, {6800,0.01600}, {6850,0.01575}, {6900,0.01625}, {6950,0.01650}, {7000,0.01675}, {7050,0.01675}, {7100,0.01675}, {7150,0.01725}, {7200,0.02000}, {7250,0.01700}, {7300,0.01700}, {7350,0.02800}, {7400,0.01725}, {7450,0.02075}, {7500,0.02150}, {7550,0.01975}, {7600,0.01800}, {7650,0.02825}, {7700,0.02975}, {7750,0.02900}, {7800,0.01875}, {7850,0.01825}, {7900,0.03625}, {7950,0.01875}, {8000,0.01925}, {8050,0.01875}, {8100,0.03375}, {8150,0.01975}, {8200,0.01975}, {8250,0.01950}, {8300,0.01975}, {8350,0.02150}, {8400,0.02000}, {8450,0.02400}, {8500,0.02325}, {8550,0.01925}, {8600,0.02100}, {8650,0.01975}, {8700,0.02000}, {8750,0.03625}, {8800,0.02050}, {8850,0.02025}, {8900,0.02025}, {8950,0.02025}, {9000,0.02075}, {9050,0.02100}, {9100,0.04075}, {9150,0.03400}, {9200,0.02150}, {9250,0.02100}, {9300,0.02100}, {9350,0.02150}, {9400,0.02200}, {9450,0.02200}, {9500,0.02250}, {9550,0.02225}, {9600,0.02475}, {9650,0.05150}, {9700,0.02825}, {9750,0.02275}, {9800,0.02825}, {9850,0.04600}, {9900,0.03825}, {9950,0.02675}, {10000,0.04725}, {10100,0.02950}, {10200,0.02400}, {10300,0.03125}, {10400,0.04825}, {10500,0.02525}, {10600,0.02500}, {10700,0.02500}, {10800,0.04750}, {10900,0.05350}, {11000,0.04400}, {11100,0.02650}, {11200,0.02600}, {11300,0.05050}, {11400,0.04400}, {11500,0.02700}, {11600,0.04625}, {11700,0.02775}, {11800,0.02775}, {11900,0.02800}, {12000,0.04750}, {12100,0.04325}, {12200,0.05175}, {12300,0.03325}, {12400,0.05000}, {12500,0.05325}, {12600,0.04250}, {12700,0.04525}, {12800,0.05550}, {12900,0.05450}, {13000,0.03075}, {13100,0.03125}, {13200,0.03075}, {13300,0.03200}, {13400,0.03200}, {13500,0.03175}, {13600,0.05325}, {13700,0.03650}, {13800,0.03300}, {13900,0.05575}, {14000,0.03400}, {14100,0.03675}, {14200,0.03375}, {14300,0.03425}, {14400,0.03425}, {14500,0.03475}, {14600,0.04375}, {14700,0.05300}, {14800,0.03575}, {14900,0.04000}, {15000,0.04075}, {15100,0.03950}, {15200,0.03650}, {15300,0.07200}, {15400,0.03700}, {15500,0.03750}, {15600,0.05800}, {15700,0.05375}, {15800,0.06350}, {15900,0.03850}, {16000,0.03800}, {16100,0.03850}, {16200,0.06725}, {16300,0.03900}, {16400,0.03975}, {16500,0.04025}, {16600,0.05900}, {16700,0.07550}, {16800,0.07475}, {16900,0.07550}, {17000,0.07500}, {17100,0.04075}, {17200,0.04100}, {17300,0.04625}, {17400,0.04225}, {17500,0.06325}, {17600,0.08400}, {17700,0.04350}, {17800,0.04275}, {17900,0.06050}, {18000,0.04350}, {18100,0.07150}, {18200,0.05050}, {18300,0.04400}, {18400,0.04975}, {18500,0.08425}, {18600,0.04550}, {18700,0.04550}, {18800,0.07975}, {18900,0.04550}, {19000,0.04675}, {19100,0.04675}, {19200,0.08750}, {19300,0.09875}, {19400,0.06875}, {19500,0.07550}, {19600,0.09425}, {19700,0.09450}, {19800,0.10200}, {19900,0.09650}, {20000,0.06000}};
data["big_flat"]["Ltac2"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00002941}, {4,0.00002941}, {5,0.00002941}, {6,0.00003922}, {7,0.00002941}, {8,0.00009804}, {9,0.00003922}, {10,0.00002941}, {11,0.00002941}, {12,0.00003922}, {13,0.00005882}, {14,0.00002941}, {15,0.00000000}, {16,0.00005882}, {17,0.00005882}, {18,0.00000000}, {19,0.00003922}, {20,0.00012745}, {21,0.00002941}, {22,0.00006863}, {23,0.00010784}, {24,0.00012745}, {25,0.00005882}, {26,0.00013725}, {27,0.00005882}, {28,0.00005882}, {29,0.00016667}, {30,0.00005882}, {31,0.00002941}, {32,0.00000000}, {33,0.00000000}, {34,0.00009804}, {35,0.00009804}, {36,0.00003922}, {37,0.00017647}, {38,0.00011765}, {39,0.00010784}, {40,0.00005882}, {41,0.00005882}, {42,0.00012745}, {43,0.00017647}, {44,0.00006863}, {45,0.00011765}, {46,0.00017647}, {47,0.00007843}, {48,0.00015686}, {49,0.00011765}, {50,0.00010784}, {51,0.00002941}, {52,0.00018627}, {53,0.00015686}, {54,0.00009804}, {55,0.00009804}, {56,0.00022549}, {57,0.00014706}, {58,0.00012745}, {59,0.00012745}, {60,0.00009804}, {61,0.00011765}, {62,0.00005882}, {63,0.00016667}, {64,0.00008824}, {65,0.00017647}, {66,0.00008824}, {67,0.00010784}, {68,0.00009804}, {69,0.00031373}, {70,0.00010784}, {71,0.00005882}, {72,0.00018627}, {73,0.00011765}, {74,0.00022549}, {75,0.00015686}, {76,0.00012745}, {77,0.00012745}, {78,0.00012745}, {79,0.00025490}, {80,0.00014706}, {81,0.00012745}, {82,0.00016667}, {83,0.00013725}, {84,0.00011765}, {85,0.00016667}, {86,0.00010784}, {87,0.00012745}, {88,0.00023529}, {89,0.00021569}, {90,0.00012745}, {91,0.00015686}, {92,0.00020588}, {93,0.00021569}, {94,0.00011765}, {95,0.00017647}, {96,0.00027451}, {97,0.00015686}, {98,0.00011765}, {99,0.00039216}, {100,0.00013725}, {101,0.00022549}, {102,0.00032353}, {103,0.00012745}, {104,0.00011765}, {105,0.00015686}, {106,0.00022549}, {107,0.00021569}, {108,0.00010784}, {109,0.00026471}, {110,0.00031373}, {111,0.00011765}, {112,0.00030392}, {113,0.00022549}, {114,0.00018627}, {115,0.00022549}, {116,0.00016667}, {117,0.00025490}, {118,0.00020588}, {119,0.00023529}, {120,0.00015686}, {121,0.00031373}, {122,0.00037255}, {123,0.00044118}, {124,0.00023529}, {125,0.00032353}, {126,0.00029412}, {127,0.00032353}, {128,0.00020588}, {129,0.00020588}, {130,0.00015686}, {131,0.00030392}, {132,0.00019608}, {133,0.00028431}, {134,0.00026471}, {135,0.00026471}, {136,0.00021569}, {137,0.00025490}, {138,0.00016667}, {139,0.00026471}, {140,0.00054902}, {141,0.00042157}, {142,0.00029412}, {143,0.00025490}, {144,0.00016667}, {145,0.00013725}, {146,0.00035294}, {147,0.00031373}, {148,0.00041176}, {149,0.00034314}, {150,0.00028431}, {151,0.00032353}, {152,0.00031373}, {153,0.00027451}, {154,0.00024510}, {155,0.00040196}, {156,0.00022549}, {157,0.00036275}, {158,0.00021569}, {159,0.00036275}, {160,0.00036275}, {161,0.00030392}, {162,0.00032353}, {163,0.00034314}, {164,0.00031373}, {165,0.00030392}, {166,0.00037255}, {167,0.00036275}, {168,0.00043137}, {169,0.00033333}, {170,0.00008824}, {171,0.00032353}, {172,0.00044118}, {173,0.00022549}, {174,0.00026471}, {175,0.00047059}, {176,0.00033333}, {177,0.00030392}, {178,0.00026471}, {179,0.00026471}, {180,0.00025490}, {181,0.00039216}, {182,0.00040196}, {183,0.00041176}, {184,0.00022549}, {185,0.00016667}, {186,0.00033333}, {187,0.00033333}, {188,0.00042157}, {189,0.00002941}, {190,0.00025490}, {191,0.00046078}, {192,0.00040196}, {193,0.00037255}, {194,0.00017647}, {195,0.00041176}, {196,0.00039216}, {197,0.00028431}, {198,0.00034314}, {199,0.00031373}, {200,0.00043137}, {201,0.00050000}, {202,0.00031373}, {203,0.00036275}, {204,0.00034314}, {205,0.00045098}, {206,0.00022549}, {207,0.00039216}, {208,0.00046078}, {209,0.00026471}, {210,0.00031373}, {211,0.00014706}, {212,0.00038235}, {213,0.00054902}, {214,0.00044118}, {215,0.00032353}, {216,0.00042157}, {217,0.00027451}, {218,0.00039216}, {219,0.00030392}, {220,0.00043137}, {221,0.00046078}, {222,0.00044118}, {223,0.00031373}, {224,0.00052941}, {225,0.00046078}, {226,0.00052941}, {227,0.00025490}, {228,0.00048039}, {229,0.00024510}, {230,0.00045098}, {231,0.00035294}, {232,0.00051961}, {233,0.00018627}, {234,0.00041176}, {235,0.00028431}, {236,0.00041176}, {237,0.00066667}, {238,0.00050980}, {239,0.00052941}, {240,0.00044118}, {241,0.00034314}, {242,0.00053922}, {243,0.00036275}, {244,0.00035294}, {245,0.00049020}, {246,0.00041176}, {247,0.00030392}, {248,0.00037255}, {249,0.00055882}, {250,0.00046078}, {251,0.00036275}, {252,0.00041176}, {253,0.00052941}, {254,0.00045098}, {255,0.00049020}, {256,0.00053922}, {257,0.00042157}, {258,0.00024510}, {259,0.00033333}, {260,0.00043137}, {261,0.00050000}, {262,0.00037255}, {263,0.00027451}, {264,0.00056863}, {265,0.00055882}, {266,0.00051961}, {267,0.00039216}, {268,0.00072549}, {269,0.00048039}, {270,0.00039216}, {271,0.00047059}, {272,0.00054902}, {273,0.00046078}, {274,0.00043137}, {275,0.00042157}, {276,0.00043137}, {277,0.00059804}, {278,0.00053922}, {279,0.00057843}, {280,0.00048039}, {281,0.00032353}, {282,0.00067647}, {283,0.00035294}, {284,0.00041176}, {285,0.00054902}, {286,0.00050000}, {287,0.00042157}, {288,0.00052941}, {289,0.00040196}, {290,0.00062745}, {291,0.00038235}, {292,0.00054902}, {293,0.00056863}, {294,0.00048039}, {295,0.00062745}, {296,0.00076471}, {297,0.00041176}, {298,0.00063725}, {299,0.00038235}, {300,0.00050980}, {301,0.00050000}, {302,0.00049020}, {303,0.00058824}, {304,0.00051961}, {305,0.00060784}, {306,0.00056863}, {307,0.00053922}, {308,0.00034314}, {309,0.00070588}, {310,0.00053922}, {311,0.00055882}, {312,0.00046078}, {313,0.00039216}, {314,0.00058824}, {315,0.00045098}, {316,0.00079412}, {317,0.00059804}, {318,0.00067647}, {319,0.00069608}, {320,0.00070588}, {321,0.00040196}, {322,0.00058824}, {323,0.00025490}, {324,0.00037255}, {325,0.00053922}, {326,0.00063725}, {327,0.00053922}, {328,0.00052941}, {329,0.00076471}, {330,0.00072549}, {331,0.00050000}, {332,0.00042157}, {333,0.00056863}, {334,0.00064706}, {335,0.00067647}, {336,0.00072549}, {337,0.00042157}, {338,0.00084314}, {339,0.00085294}, {340,0.00041176}, {341,0.00067647}, {342,0.00146078}, {343,0.00050980}, {344,0.00068627}, {345,0.00098039}, {346,0.00057843}, {347,0.00092157}, {348,0.00059804}, {349,0.00061765}, {350,0.00063725}, {351,0.00073529}, {352,0.00042157}, {353,0.00054902}, {354,0.00058824}, {355,0.00085294}, {356,0.00031373}, {357,0.00063725}, {358,0.00071569}, {359,0.00055882}, {360,0.00053922}, {361,0.00066667}, {362,0.00066667}, {363,0.00053922}, {364,0.00070588}, {365,0.00054902}, {366,0.00077451}, {367,0.00072549}, {368,0.00067647}, {369,0.00071569}, {370,0.00050000}, {371,0.00074510}, {372,0.00068627}, {373,0.00079412}, {374,0.00074510}, {375,0.00081373}, {376,0.00060784}, {377,0.00074510}, {378,0.00064706}, {379,0.00067647}, {380,0.00080392}, {381,0.00088235}, {382,0.00074510}, {383,0.00064706}, {384,0.00065686}, {385,0.00059804}, {386,0.00062745}, {387,0.00071569}, {388,0.00073529}, {389,0.00076471}, {390,0.00083333}, {391,0.00058824}, {392,0.00054902}, {393,0.00075490}, {394,0.00077451}, {395,0.00080392}, {396,0.00073529}, {397,0.00056863}, {398,0.00062745}, {399,0.00054902}, {400,0.00077451}, {401,0.00128431}, {402,0.00044118}, {403,0.00097059}, {404,0.00081373}, {405,0.00085294}, {406,0.00066667}, {407,0.00066667}, {408,0.00065686}, {409,0.00087255}, {410,0.00074510}, {411,0.00058824}, {412,0.00080392}, {413,0.00077451}, {414,0.00050000}, {415,0.00074510}, {416,0.00076471}, {417,0.00091176}, {418,0.00080392}, {419,0.00057843}, {420,0.00068627}, {421,0.00089216}, {422,0.00073529}, {423,0.00066667}, {424,0.00081373}, {425,0.00075490}, {426,0.00089216}, {427,0.00049020}, {428,0.00079412}, {429,0.00059804}, {430,0.00090196}, {431,0.00081373}, {432,0.00068627}, {433,0.00071569}, {434,0.00046078}, {435,0.00055882}, {436,0.00072549}, {437,0.00082353}, {438,0.00090196}, {439,0.00055882}, {440,0.00100980}, {441,0.00085294}, {442,0.00081373}, {443,0.00073529}, {444,0.00101961}, {445,0.00068627}, {446,0.00112745}, {447,0.00070588}, {448,0.00085294}, {449,0.00087255}, {450,0.00096078}, {451,0.00083333}, {452,0.00192157}, {453,0.00061765}, {454,0.00096078}, {455,0.00062745}, {456,0.00095098}, {457,0.00073529}, {458,0.00086275}, {459,0.00087255}, {460,0.00085294}, {461,0.00063725}, {462,0.00075490}, {463,0.00097059}, {464,0.00068627}, {465,0.00078431}, {466,0.00082353}, {467,0.00103922}, {468,0.00081373}, {469,0.00068627}, {470,0.00084314}, {471,0.00096078}, {472,0.00088235}, {473,0.00084314}, {474,0.00092157}, {475,0.00079412}, {476,0.00062745}, {477,0.00078431}, {478,0.00082353}, {479,0.00086275}, {480,0.00081373}, {481,0.00068627}, {482,0.00096078}, {483,0.00070588}, {484,0.00090196}, {485,0.00084314}, {486,0.00085294}, {487,0.00071569}, {488,0.00058824}, {489,0.00112745}, {490,0.00095098}, {491,0.00058824}, {492,0.00082353}, {493,0.00103922}, {494,0.00097059}, {495,0.00089216}, {496,0.00069608}, {497,0.00110784}, {498,0.00061765}, {499,0.00099020}, {500,0.00081373}, {505,0.00061765}, {510,0.00092157}, {515,0.00071569}, {520,0.00117647}, {525,0.00081373}, {530,0.00096078}, {535,0.00082353}, {540,0.00074510}, {545,0.00073529}, {550,0.00095098}, {555,0.00123529}, {560,0.00096078}, {565,0.00118627}, {570,0.00117647}, {575,0.00090196}, {580,0.00099020}, {585,0.00082353}, {590,0.00114706}, {595,0.00110784}, {600,0.00124510}, {605,0.00099020}, {610,0.00113725}, {615,0.00092157}, {620,0.00100000}, {625,0.00314706}, {630,0.00126471}, {635,0.00118627}, {640,0.00121569}, {645,0.00331373}, {650,0.00092157}, {655,0.00100000}, {660,0.00127451}, {665,0.00129412}, {670,0.00111765}, {675,0.00101961}, {680,0.00108824}, {685,0.00096078}, {690,0.00106863}, {695,0.00111765}, {700,0.00131373}, {705,0.00127451}, {710,0.00121569}, {715,0.00140196}, {720,0.00108824}, {725,0.00104902}, {730,0.00111765}, {735,0.00110784}, {740,0.00140196}, {745,0.00116667}, {750,0.00113725}, {755,0.00109804}, {760,0.00124510}, {765,0.00099020}, {770,0.00129412}, {775,0.00134314}, {780,0.00133333}, {785,0.00150980}, {790,0.00160784}, {795,0.00122549}, {800,0.00145098}, {805,0.00116667}, {810,0.00135294}, {815,0.00150980}, {820,0.00247059}, {825,0.00146078}, {830,0.00160784}, {835,0.00133333}, {840,0.00126471}, {845,0.00158824}, {850,0.00151961}, {855,0.00122549}, {860,0.00153922}, {865,0.00159804}, {870,0.00180392}, {875,0.00145098}, {880,0.00171569}, {885,0.00152941}, {890,0.00164706}, {895,0.00125490}, {900,0.00152941}, {905,0.00162745}, {910,0.00141176}, {915,0.00163725}, {920,0.00183333}, {925,0.00182353}, {930,0.00176471}, {935,0.00147059}, {940,0.00141176}, {945,0.00181373}, {950,0.00165686}, {955,0.00155882}, {960,0.00206863}, {965,0.00157843}, {970,0.00195098}, {975,0.00189216}, {980,0.00183333}, {985,0.00168627}, {990,0.00178431}, {995,0.00199020}, {1000,0.00152941}, {1010,0.00190196}, {1020,0.00182353}, {1030,0.00199020}, {1040,0.00191176}, {1050,0.00200000}, {1060,0.00179412}, {1070,0.00179412}, {1080,0.00230392}, {1090,0.00198039}, {1100,0.00208824}, {1110,0.00192157}, {1120,0.00200980}, {1130,0.00192157}, {1140,0.00206863}, {1150,0.00212745}, {1160,0.00201961}, {1170,0.00167647}, {1180,0.00209804}, {1190,0.00224510}, {1200,0.00195098}, {1210,0.00178431}, {1220,0.00230392}, {1230,0.00240196}, {1240,0.00216667}, {1250,0.00468627}, {1260,0.00210784}, {1270,0.00237255}, {1280,0.00228431}, {1290,0.00224510}, {1300,0.00241176}, {1310,0.00207843}, {1320,0.00237255}, {1330,0.00225490}, {1340,0.00228431}, {1350,0.00240196}, {1360,0.00268627}, {1370,0.00257843}, {1380,0.00242157}, {1390,0.00259804}, {1400,0.00250980}, {1410,0.00260784}, {1420,0.00258824}, {1430,0.00233333}, {1440,0.00383333}, {1450,0.00243137}, {1460,0.00260784}, {1470,0.00258824}, {1480,0.00261765}, {1490,0.00267647}, {1500,0.00267647}, {1510,0.00290196}, {1520,0.00274510}, {1530,0.00269608}, {1540,0.00251961}, {1550,0.00273529}, {1560,0.00279412}, {1570,0.00269608}, {1580,0.00276471}, {1590,0.00286275}, {1600,0.00272549}, {1610,0.00281373}, {1620,0.00279412}, {1630,0.00286275}, {1640,0.00282353}, {1650,0.00308824}, {1660,0.00276471}, {1670,0.00300980}, {1680,0.00279412}, {1690,0.00300000}, {1700,0.00548039}, {1710,0.00300000}, {1720,0.00301961}, {1730,0.00318627}, {1740,0.00321569}, {1750,0.00306863}, {1760,0.00302941}, {1770,0.00304902}, {1780,0.00666667}, {1790,0.00310784}, {1800,0.00319608}, {1810,0.00312745}, {1820,0.00323529}, {1830,0.00336275}, {1840,0.00331373}, {1850,0.00326471}, {1860,0.00327451}, {1870,0.00330392}, {1880,0.00348039}, {1890,0.00347059}, {1900,0.00711765}, {1910,0.00340196}, {1920,0.00363725}, {1930,0.00571569}, {1940,0.00344118}, {1950,0.00364706}, {1960,0.00372549}, {1970,0.00359804}, {1980,0.00350980}, {1990,0.00363725}, {2000,0.00378431}, {2050,0.00354902}, {2100,0.00371569}, {2150,0.00367647}, {2200,0.00404902}, {2250,0.00394118}, {2300,0.00424510}, {2350,0.00439216}, {2400,0.00452941}, {2450,0.00459804}, {2500,0.00538235}, {2550,0.00505882}, {2600,0.00491176}, {2650,0.00526471}, {2700,0.01300980}, {2750,0.00548039}, {2800,0.01004902}, {2850,0.01202941}, {2900,0.00595098}, {2950,0.00587255}, {3000,0.00607843}, {3050,0.00612745}, {3100,0.01295098}, {3150,0.00630392}, {3200,0.00650000}, {3250,0.00672549}, {3300,0.00687255}, {3350,0.01210784}, {3400,0.00722549}, {3450,0.00696078}, {3500,0.00761765}, {3550,0.01268627}, {3600,0.00765686}, {3650,0.00771569}, {3700,0.00781373}, {3750,0.00767647}, {3800,0.00804902}, {3850,0.01344118}, {3900,0.00820588}, {3950,0.00852941}, {4000,0.00845098}, {4050,0.00831373}, {4100,0.01367647}, {4150,0.00838235}, {4200,0.00906863}, {4250,0.00874510}, {4300,0.00900000}, {4350,0.01793137}, {4400,0.00958824}, {4450,0.00962745}, {4500,0.00962745}, {4550,0.00966667}, {4600,0.00990196}, {4650,0.01943137}, {4700,0.01016667}, {4750,0.01019608}, {4800,0.01079412}, {4850,0.01070588}, {4900,0.01050000}, {4950,0.01064706}, {5000,0.01087255}, {5050,0.01146078}, {5100,0.01136275}, {5150,0.01127451}, {5200,0.01175490}, {5250,0.01168627}, {5300,0.01199020}, {5350,0.01206863}, {5400,0.01250000}, {5450,0.01255882}, {5500,0.01250000}, {5550,0.01238235}, {5600,0.01250980}, {5650,0.01247059}, {5700,0.01280392}, {5750,0.01311765}, {5800,0.02333333}, {5850,0.02126471}, {5900,0.01359804}, {5950,0.01347059}, {6000,0.02306863}, {6050,0.01425}, {6100,0.01475}, {6150,0.01375}, {6200,0.01450}, {6250,0.01900}, {6300,0.01825}, {6350,0.01500}, {6400,0.02425}, {6450,0.02750}, {6500,0.01550}, {6550,0.02400}, {6600,0.02875}, {6650,0.01525}, {6700,0.01525}, {6750,0.01600}, {6800,0.01600}, {6850,0.01625}, {6900,0.01600}, {6950,0.01650}, {7000,0.01750}, {7050,0.01850}, {7100,0.01800}, {7150,0.01650}, {7200,0.02025}, {7250,0.01650}, {7300,0.01500}, {7350,0.02550}, {7400,0.01700}, {7450,0.02250}, {7500,0.02075}, {7550,0.01925}, {7600,0.01950}, {7650,0.02850}, {7700,0.02850}, {7750,0.02925}, {7800,0.01950}, {7850,0.01900}, {7900,0.03550}, {7950,0.01925}, {8000,0.01825}, {8050,0.01750}, {8100,0.03400}, {8150,0.01900}, {8200,0.01825}, {8250,0.01800}, {8300,0.02050}, {8350,0.02025}, {8400,0.02050}, {8450,0.02350}, {8500,0.02375}, {8550,0.01900}, {8600,0.02150}, {8650,0.02000}, {8700,0.02025}, {8750,0.03550}, {8800,0.01900}, {8850,0.01925}, {8900,0.02075}, {8950,0.01950}, {9000,0.02125}, {9050,0.02025}, {9100,0.03950}, {9150,0.03475}, {9200,0.02150}, {9250,0.02300}, {9300,0.02175}, {9350,0.02200}, {9400,0.02300}, {9450,0.02400}, {9500,0.02400}, {9550,0.02400}, {9600,0.02550}, {9650,0.05125}, {9700,0.02850}, {9750,0.02175}, {9800,0.03000}, {9850,0.04575}, {9900,0.03850}, {9950,0.02775}, {10000,0.04675}, {10100,0.03075}, {10200,0.02400}, {10300,0.03150}, {10400,0.04725}, {10500,0.02500}, {10600,0.02575}, {10700,0.02475}, {10800,0.04850}, {10900,0.05450}, {11000,0.04475}, {11100,0.02700}, {11200,0.02525}, {11300,0.05050}, {11400,0.04375}, {11500,0.02725}, {11600,0.04525}, {11700,0.02725}, {11800,0.02625}, {11900,0.02725}, {12000,0.04500}, {12100,0.04425}, {12200,0.05050}, {12300,0.03275}, {12400,0.05075}, {12500,0.05450}, {12600,0.04200}, {12700,0.04625}, {12800,0.05675}, {12900,0.05500}, {13000,0.03050}, {13100,0.03025}, {13200,0.02925}, {13300,0.03150}, {13400,0.03175}, {13500,0.03125}, {13600,0.05325}, {13700,0.03550}, {13800,0.03250}, {13900,0.05550}, {14000,0.03350}, {14100,0.03650}, {14200,0.03250}, {14300,0.03375}, {14400,0.03600}, {14500,0.03475}, {14600,0.04500}, {14700,0.05350}, {14800,0.03600}, {14900,0.04075}, {15000,0.04175}, {15100,0.04075}, {15200,0.03700}, {15300,0.07250}, {15400,0.03775}, {15500,0.03775}, {15600,0.05875}, {15700,0.05275}, {15800,0.06275}, {15900,0.03975}, {16000,0.03975}, {16100,0.03850}, {16200,0.06775}, {16300,0.03950}, {16400,0.04075}, {16500,0.03900}, {16600,0.05750}, {16700,0.07475}, {16800,0.07650}, {16900,0.07500}, {17000,0.07525}, {17100,0.04075}, {17200,0.04075}, {17300,0.04625}, {17400,0.04150}, {17500,0.06475}, {17600,0.08325}, {17700,0.04225}, {17800,0.04300}, {17900,0.05925}, {18000,0.04325}, {18100,0.07300}, {18200,0.05075}, {18300,0.04425}, {18400,0.04825}, {18500,0.08475}, {18600,0.04550}, {18700,0.04575}, {18800,0.07700}, {18900,0.04600}, {19000,0.04800}, {19100,0.04800}, {19200,0.08800}, {19300,0.09850}, {19400,0.06975}, {19500,0.07675}, {19600,0.09450}, {19700,0.09400}, {19800,0.10250}, {19900,0.09650}, {20000,0.06050}};
data["big_flat"]["Ltac2"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00003922}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00003922}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00003922}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00003922}, {98,0.00003922}, {99,0.00003922}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00003922}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00003922}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00003922}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00003922}, {167,0.00003922}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00003922}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00003922}, {189,0.00000000}, {190,0.00003922}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00003922}, {212,0.00000000}, {213,0.00000000}, {214,0.00003922}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00003922}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00003922}, {230,0.00000000}, {231,0.00003922}, {232,0.00003922}, {233,0.00000000}, {234,0.00003922}, {235,0.00000000}, {236,0.00000000}, {237,0.00002941}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00003922}, {255,0.00000000}, {256,0.00000000}, {257,0.00003922}, {258,0.00000000}, {259,0.00000000}, {260,0.00007843}, {261,0.00000000}, {262,0.00003922}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00003922}, {270,0.00003922}, {271,0.00000000}, {272,0.00003922}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00003922}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00003922}, {298,0.00000000}, {299,0.00003922}, {300,0.00000000}, {301,0.00003922}, {302,0.00006863}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00003922}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00003922}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00003922}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00003922}, {338,0.00000000}, {339,0.00003922}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00003922}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00003922}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00003922}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00003922}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00002941}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00003922}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00003922}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00003922}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00003922}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00003922}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00003922}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00003922}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00003922}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00003922}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00003922}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00003922}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00007843}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00003922}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00003922}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00003922}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00003922}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00003922}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00003922}, {685,0.00000000}, {690,0.00000000}, {695,0.00003922}, {700,0.00000000}, {705,0.00000000}, {710,0.00003922}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00007843}, {735,0.00003922}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00003922}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00003922}, {820,0.00007843}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00003922}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00003922}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00003922}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00002941}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00003922}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00003922}, {1250,0.00000000}, {1260,0.00003922}, {1270,0.00002941}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00003922}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00003922}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00003922}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00003922}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00006863}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00003922}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00003922}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00003922}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00003922}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00002941}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00010784}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00075}, {7250,0.00000}, {7300,0.00000}, {7350,0.00100}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["Ltac2"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000980}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00182353}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00199020}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00179412}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000980}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000980}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00200980}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00001961}, {1230,0.00000980}, {1240,0.00004902}, {1250,0.00000980}, {1260,0.00000980}, {1270,0.00002941}, {1280,0.00002941}, {1290,0.00023529}, {1300,0.00007843}, {1310,0.00008824}, {1320,0.00063725}, {1330,0.00031373}, {1340,0.00039216}, {1350,0.00091176}, {1360,0.00078431}, {1370,0.00071569}, {1380,0.00074510}, {1390,0.00076471}, {1400,0.00078431}, {1410,0.00100000}, {1420,0.00100000}, {1430,0.00100000}, {1440,0.00100000}, {1450,0.00100000}, {1460,0.00100000}, {1470,0.00100000}, {1480,0.00100000}, {1490,0.00100000}, {1500,0.00100000}, {1510,0.00100000}, {1520,0.00100000}, {1530,0.00172549}, {1540,0.00100000}, {1550,0.00100000}, {1560,0.00100000}, {1570,0.00100000}, {1580,0.00100000}, {1590,0.00100980}, {1600,0.00100000}, {1610,0.00100000}, {1620,0.00100980}, {1630,0.00100000}, {1640,0.00100000}, {1650,0.00100000}, {1660,0.00100000}, {1670,0.00100000}, {1680,0.00100000}, {1690,0.00100000}, {1700,0.00100000}, {1710,0.00100000}, {1720,0.00100000}, {1730,0.00100000}, {1740,0.00100000}, {1750,0.00100000}, {1760,0.00100000}, {1770,0.00100000}, {1780,0.00100000}, {1790,0.00100000}, {1800,0.00100000}, {1810,0.00100000}, {1820,0.00100000}, {1830,0.00100000}, {1840,0.00100000}, {1850,0.00100000}, {1860,0.00100000}, {1870,0.00100980}, {1880,0.00100000}, {1890,0.00100000}, {1900,0.00100000}, {1910,0.00100000}, {1920,0.00100000}, {1930,0.00100000}, {1940,0.00100000}, {1950,0.00100000}, {1960,0.00100000}, {1970,0.00100000}, {1980,0.00100000}, {1990,0.00100000}, {2000,0.00100000}, {2050,0.00100000}, {2100,0.00100000}, {2150,0.00201961}, {2200,0.00100000}, {2250,0.00100000}, {2300,0.00100000}, {2350,0.00100000}, {2400,0.00100980}, {2450,0.00100980}, {2500,0.00103922}, {2550,0.00103922}, {2600,0.00114706}, {2650,0.00109804}, {2700,0.00121569}, {2750,0.00153922}, {2800,0.00180392}, {2850,0.00183333}, {2900,0.00198039}, {2950,0.00200000}, {3000,0.00200980}, {3050,0.00201961}, {3100,0.00200980}, {3150,0.00200000}, {3200,0.00202941}, {3250,0.00203922}, {3300,0.00203922}, {3350,0.00205882}, {3400,0.00212745}, {3450,0.00207843}, {3500,0.00208824}, {3550,0.00207843}, {3600,0.00211765}, {3650,0.00212745}, {3700,0.00217647}, {3750,0.00217647}, {3800,0.00217647}, {3850,0.00228431}, {3900,0.00231373}, {3950,0.00241176}, {4000,0.00248039}, {4050,0.00264706}, {4100,0.00264706}, {4150,0.00275490}, {4200,0.00294118}, {4250,0.00299020}, {4300,0.00300000}, {4350,0.00307843}, {4400,0.00314706}, {4450,0.00324510}, {4500,0.00319608}, {4550,0.00329412}, {4600,0.00323529}, {4650,0.00332353}, {4700,0.00337255}, {4750,0.00337255}, {4800,0.00350000}, {4850,0.00341176}, {4900,0.00347059}, {4950,0.00888235}, {5000,0.00352941}, {5050,0.00354902}, {5100,0.00358824}, {5150,0.00361765}, {5200,0.00379412}, {5250,0.00384314}, {5300,0.00424510}, {5350,0.00391176}, {5400,0.01270588}, {5450,0.00414706}, {5500,0.00412745}, {5550,0.00436275}, {5600,0.00442157}, {5650,0.00441176}, {5700,0.00456863}, {5750,0.00452941}, {5800,0.00452941}, {5850,0.00469608}, {5900,0.01331373}, {5950,0.00469608}, {6000,0.00478431}, {6050,0.00600}, {6100,0.00600}, {6150,0.00600}, {6200,0.00700}, {6250,0.00675}, {6300,0.00675}, {6350,0.00700}, {6400,0.00675}, {6450,0.00675}, {6500,0.00675}, {6550,0.00675}, {6600,0.00675}, {6650,0.01075}, {6700,0.00675}, {6750,0.00700}, {6800,0.00675}, {6850,0.00675}, {6900,0.00675}, {6950,0.00725}, {7000,0.00700}, {7050,0.00725}, {7100,0.00725}, {7150,0.00750}, {7200,0.00750}, {7250,0.00775}, {7300,0.00775}, {7350,0.00775}, {7400,0.00775}, {7450,0.00775}, {7500,0.00775}, {7550,0.00700}, {7600,0.00775}, {7650,0.00775}, {7700,0.00775}, {7750,0.00775}, {7800,0.00800}, {7850,0.01350}, {7900,0.02300}, {7950,0.00800}, {8000,0.01875}, {8050,0.01000}, {8100,0.00825}, {8150,0.00875}, {8200,0.00850}, {8250,0.00875}, {8300,0.00875}, {8350,0.00850}, {8400,0.00875}, {8450,0.00850}, {8500,0.00825}, {8550,0.00850}, {8600,0.00850}, {8650,0.00850}, {8700,0.01350}, {8750,0.00825}, {8800,0.00825}, {8850,0.00825}, {8900,0.00900}, {8950,0.00825}, {9000,0.00850}, {9050,0.01950}, {9100,0.00825}, {9150,0.00825}, {9200,0.00875}, {9250,0.00875}, {9300,0.00900}, {9350,0.00950}, {9400,0.00975}, {9450,0.00975}, {9500,0.00975}, {9550,0.01075}, {9600,0.01475}, {9650,0.00950}, {9700,0.00975}, {9750,0.01400}, {9800,0.02200}, {9850,0.00975}, {9900,0.01150}, {9950,0.00975}, {10000,0.01300}, {10100,0.01025}, {10200,0.00975}, {10300,0.01025}, {10400,0.01050}, {10500,0.01075}, {10600,0.01075}, {10700,0.01075}, {10800,0.01075}, {10900,0.01075}, {11000,0.01075}, {11100,0.01150}, {11200,0.01175}, {11300,0.01125}, {11400,0.01225}, {11500,0.01150}, {11600,0.01150}, {11700,0.01150}, {11800,0.01150}, {11900,0.01175}, {12000,0.01150}, {12100,0.01150}, {12200,0.01225}, {12300,0.01225}, {12400,0.01225}, {12500,0.01250}, {12600,0.01250}, {12700,0.01250}, {12800,0.01250}, {12900,0.01350}, {13000,0.01550}, {13100,0.03675}, {13200,0.01625}, {13300,0.01600}, {13400,0.01325}, {13500,0.01375}, {13600,0.01350}, {13700,0.01850}, {13800,0.01375}, {13900,0.02400}, {14000,0.01425}, {14100,0.01400}, {14200,0.01425}, {14300,0.02475}, {14400,0.02125}, {14500,0.01400}, {14600,0.01475}, {14700,0.02500}, {14800,0.01500}, {14900,0.01500}, {15000,0.01525}, {15100,0.03950}, {15200,0.01525}, {15300,0.02550}, {15400,0.02900}, {15500,0.01925}, {15600,0.01575}, {15700,0.02225}, {15800,0.01600}, {15900,0.01600}, {16000,0.03625}, {16100,0.01600}, {16200,0.04300}, {16300,0.01600}, {16400,0.04750}, {16500,0.01650}, {16600,0.02200}, {16700,0.02175}, {16800,0.02225}, {16900,0.01650}, {17000,0.01700}, {17100,0.01725}, {17200,0.01750}, {17300,0.01775}, {17400,0.01775}, {17500,0.02450}, {17600,0.01800}, {17700,0.01800}, {17800,0.01800}, {17900,0.01800}, {18000,0.01775}, {18100,0.01850}, {18200,0.01850}, {18300,0.01875}, {18400,0.03875}, {18500,0.01925}, {18600,0.01875}, {18700,0.01925}, {18800,0.01925}, {18900,0.01925}, {19000,0.01950}, {19100,0.04450}, {19200,0.01975}, {19300,0.01975}, {19400,0.01975}, {19500,0.01975}, {19600,0.01975}, {19700,0.02050}, {19800,0.02000}, {19900,0.02050}, {20000,0.01975}};
data["big_flat"]["Ltac2"]["eval lazy"]["user"] = {{1,0.00002941}, {2,0.00000000}, {3,0.00000000}, {4,0.00003922}, {5,0.00006863}, {6,0.00006863}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00002941}, {11,0.00000000}, {12,0.00000000}, {13,0.00002941}, {14,0.00009804}, {15,0.00002941}, {16,0.00002941}, {17,0.00009804}, {18,0.00002941}, {19,0.00003922}, {20,0.00000000}, {21,0.00000000}, {22,0.00002941}, {23,0.00006863}, {24,0.00002941}, {25,0.00003922}, {26,0.00008824}, {27,0.00002941}, {28,0.00005882}, {29,0.00007843}, {30,0.00006863}, {31,0.00006863}, {32,0.00006863}, {33,0.00002941}, {34,0.00000000}, {35,0.00009804}, {36,0.00003922}, {37,0.00005882}, {38,0.00013725}, {39,0.00003922}, {40,0.00009804}, {41,0.00010784}, {42,0.00002941}, {43,0.00000000}, {44,0.00005882}, {45,0.00003922}, {46,0.00008824}, {47,0.00005882}, {48,0.00002941}, {49,0.00002941}, {50,0.00003922}, {51,0.00000000}, {52,0.00006863}, {53,0.00011765}, {54,0.00011765}, {55,0.00009804}, {56,0.00000000}, {57,0.00005882}, {58,0.00009804}, {59,0.00005882}, {60,0.00006863}, {61,0.00021569}, {62,0.00015686}, {63,0.00006863}, {64,0.00013725}, {65,0.00000000}, {66,0.00005882}, {67,0.00024510}, {68,0.00008824}, {69,0.00006863}, {70,0.00002941}, {71,0.00010784}, {72,0.00002941}, {73,0.00005882}, {74,0.00009804}, {75,0.00011765}, {76,0.00010784}, {77,0.00011765}, {78,0.00009804}, {79,0.00003922}, {80,0.00002941}, {81,0.00006863}, {82,0.00009804}, {83,0.00003922}, {84,0.00012745}, {85,0.00009804}, {86,0.00006863}, {87,0.00024510}, {88,0.00005882}, {89,0.00009804}, {90,0.00009804}, {91,0.00019608}, {92,0.00011765}, {93,0.00002941}, {94,0.00011765}, {95,0.00009804}, {96,0.00017647}, {97,0.00003922}, {98,0.00019608}, {99,0.00013725}, {100,0.00005882}, {101,0.00003922}, {102,0.00003922}, {103,0.00013725}, {104,0.00017647}, {105,0.00018627}, {106,0.00007843}, {107,0.00011765}, {108,0.00012745}, {109,0.00012745}, {110,0.00013725}, {111,0.00002941}, {112,0.00017647}, {113,0.00009804}, {114,0.00025490}, {115,0.00012745}, {116,0.00006863}, {117,0.00014706}, {118,0.00006863}, {119,0.00022549}, {120,0.00014706}, {121,0.00007843}, {122,0.00009804}, {123,0.00009804}, {124,0.00012745}, {125,0.00021569}, {126,0.00007843}, {127,0.00006863}, {128,0.00015686}, {129,0.00013725}, {130,0.00013725}, {131,0.00019608}, {132,0.00016667}, {133,0.00018627}, {134,0.00006863}, {135,0.00017647}, {136,0.00005882}, {137,0.00008824}, {138,0.00019608}, {139,0.00015686}, {140,0.00023529}, {141,0.00012745}, {142,0.00013725}, {143,0.00010784}, {144,0.00019608}, {145,0.00013725}, {146,0.00011765}, {147,0.00011765}, {148,0.00012745}, {149,0.00013725}, {150,0.00025490}, {151,0.00017647}, {152,0.00013725}, {153,0.00018627}, {154,0.00005882}, {155,0.00005882}, {156,0.00016667}, {157,0.00021569}, {158,0.00021569}, {159,0.00008824}, {160,0.00010784}, {161,0.00012745}, {162,0.00019608}, {163,0.00006863}, {164,0.00002941}, {165,0.00018627}, {166,0.00021569}, {167,0.00016667}, {168,0.00008824}, {169,0.00014706}, {170,0.00018627}, {171,0.00022549}, {172,0.00013725}, {173,0.00030392}, {174,0.00009804}, {175,0.00013725}, {176,0.00019608}, {177,0.00015686}, {178,0.00013725}, {179,0.00024510}, {180,0.00018627}, {181,0.00012745}, {182,0.00006863}, {183,0.00022549}, {184,0.00021569}, {185,0.00029412}, {186,0.00029412}, {187,0.00009804}, {188,0.00019608}, {189,0.00005882}, {190,0.00018627}, {191,0.00010784}, {192,0.00033333}, {193,0.00013725}, {194,0.00009804}, {195,0.00026471}, {196,0.00022549}, {197,0.00022549}, {198,0.00029412}, {199,0.00015686}, {200,0.00024510}, {201,0.00013725}, {202,0.00028431}, {203,0.00016667}, {204,0.00019608}, {205,0.00005882}, {206,0.00016667}, {207,0.00017647}, {208,0.00022549}, {209,0.00027451}, {210,0.00019608}, {211,0.00018627}, {212,0.00018627}, {213,0.00020588}, {214,0.00013725}, {215,0.00022549}, {216,0.00033333}, {217,0.00017647}, {218,0.00015686}, {219,0.00014706}, {220,0.00028431}, {221,0.00016667}, {222,0.00021569}, {223,0.00011765}, {224,0.00021569}, {225,0.00019608}, {226,0.00023529}, {227,0.00019608}, {228,0.00024510}, {229,0.00014706}, {230,0.00024510}, {231,0.00013725}, {232,0.00012745}, {233,0.00033333}, {234,0.00029412}, {235,0.00025490}, {236,0.00022549}, {237,0.00020588}, {238,0.00005882}, {239,0.00027451}, {240,0.00017647}, {241,0.00013725}, {242,0.00034314}, {243,0.00030392}, {244,0.00028431}, {245,0.00028431}, {246,0.00012745}, {247,0.00012745}, {248,0.00019608}, {249,0.00021569}, {250,0.00016667}, {251,0.00047059}, {252,0.00022549}, {253,0.00016667}, {254,0.00026471}, {255,0.00009804}, {256,0.00016667}, {257,0.00024510}, {258,0.00018627}, {259,0.00028431}, {260,0.00016667}, {261,0.00016667}, {262,0.00020588}, {263,0.00017647}, {264,0.00016667}, {265,0.00014706}, {266,0.00025490}, {267,0.00024510}, {268,0.00017647}, {269,0.00018627}, {270,0.00019608}, {271,0.00016667}, {272,0.00037255}, {273,0.00012745}, {274,0.00022549}, {275,0.00035294}, {276,0.00019608}, {277,0.00027451}, {278,0.00033333}, {279,0.00041176}, {280,0.00017647}, {281,0.00024510}, {282,0.00029412}, {283,0.00035294}, {284,0.00019608}, {285,0.00017647}, {286,0.00034314}, {287,0.00022549}, {288,0.00019608}, {289,0.00022549}, {290,0.00017647}, {291,0.00013725}, {292,0.00018627}, {293,0.00023529}, {294,0.00023529}, {295,0.00019608}, {296,0.00017647}, {297,0.00018627}, {298,0.00025490}, {299,0.00028431}, {300,0.00043137}, {301,0.00026471}, {302,0.00008824}, {303,0.00029412}, {304,0.00038235}, {305,0.00022549}, {306,0.00019608}, {307,0.00009804}, {308,0.00027451}, {309,0.00003922}, {310,0.00026471}, {311,0.00034314}, {312,0.00014706}, {313,0.00035294}, {314,0.00023529}, {315,0.00028431}, {316,0.00015686}, {317,0.00024510}, {318,0.00032353}, {319,0.00033333}, {320,0.00029412}, {321,0.00021569}, {322,0.00017647}, {323,0.00023529}, {324,0.00018627}, {325,0.00028431}, {326,0.00024510}, {327,0.00014706}, {328,0.00039216}, {329,0.00032353}, {330,0.00019608}, {331,0.00018627}, {332,0.00017647}, {333,0.00021569}, {334,0.00029412}, {335,0.00022549}, {336,0.00020588}, {337,0.00036275}, {338,0.00029412}, {339,0.00015686}, {340,0.00028431}, {341,0.00035294}, {342,0.00034314}, {343,0.00034314}, {344,0.00045098}, {345,0.00034314}, {346,0.00040196}, {347,0.00027451}, {348,0.00031373}, {349,0.00031373}, {350,0.00024510}, {351,0.00015686}, {352,0.00025490}, {353,0.00029412}, {354,0.00052941}, {355,0.00009804}, {356,0.00027451}, {357,0.00023529}, {358,0.00020588}, {359,0.00021569}, {360,0.00036275}, {361,0.00012745}, {362,0.00024510}, {363,0.00025490}, {364,0.00016667}, {365,0.00026471}, {366,0.00031373}, {367,0.00022549}, {368,0.00028431}, {369,0.00014706}, {370,0.00035294}, {371,0.00018627}, {372,0.00038235}, {373,0.00035294}, {374,0.00030392}, {375,0.00022549}, {376,0.00020588}, {377,0.00036275}, {378,0.00016667}, {379,0.00035294}, {380,0.00025490}, {381,0.00040196}, {382,0.00034314}, {383,0.00028431}, {384,0.00024510}, {385,0.00037255}, {386,0.00021569}, {387,0.00032353}, {388,0.00170588}, {389,0.00064706}, {390,0.00037255}, {391,0.00034314}, {392,0.00019608}, {393,0.00039216}, {394,0.00044118}, {395,0.00023529}, {396,0.00042157}, {397,0.00041176}, {398,0.00022549}, {399,0.00022549}, {400,0.00030392}, {401,0.00027451}, {402,0.00032353}, {403,0.00020588}, {404,0.00032353}, {405,0.00032353}, {406,0.00020588}, {407,0.00031373}, {408,0.00037255}, {409,0.00032353}, {410,0.00026471}, {411,0.00040196}, {412,0.00040196}, {413,0.00019608}, {414,0.00050980}, {415,0.00045098}, {416,0.00049020}, {417,0.00021569}, {418,0.00028431}, {419,0.00043137}, {420,0.00032353}, {421,0.00033333}, {422,0.00020588}, {423,0.00028431}, {424,0.00027451}, {425,0.00046078}, {426,0.00051961}, {427,0.00029412}, {428,0.00022549}, {429,0.00012745}, {430,0.00034314}, {431,0.00042157}, {432,0.00027451}, {433,0.00040196}, {434,0.00023529}, {435,0.00034314}, {436,0.00025490}, {437,0.00032353}, {438,0.00032353}, {439,0.00027451}, {440,0.00038235}, {441,0.00020588}, {442,0.00023529}, {443,0.00036275}, {444,0.00041176}, {445,0.00024510}, {446,0.00029412}, {447,0.00032353}, {448,0.00036275}, {449,0.00013725}, {450,0.00019608}, {451,0.00026471}, {452,0.00051961}, {453,0.00050980}, {454,0.00031373}, {455,0.00045098}, {456,0.00040196}, {457,0.00030392}, {458,0.00023529}, {459,0.00043137}, {460,0.00051961}, {461,0.00066667}, {462,0.00041176}, {463,0.00033333}, {464,0.00036275}, {465,0.00036275}, {466,0.00043137}, {467,0.00015686}, {468,0.00035294}, {469,0.00054902}, {470,0.00042157}, {471,0.00031373}, {472,0.00040196}, {473,0.00043137}, {474,0.00030392}, {475,0.00031373}, {476,0.00026471}, {477,0.00046078}, {478,0.00033333}, {479,0.00025490}, {480,0.00022549}, {481,0.00050980}, {482,0.00030392}, {483,0.00170588}, {484,0.00041176}, {485,0.00039216}, {486,0.00071569}, {487,0.00046078}, {488,0.00028431}, {489,0.00033333}, {490,0.00036275}, {491,0.00024510}, {492,0.00045098}, {493,0.00008824}, {494,0.00020588}, {495,0.00039216}, {496,0.00030392}, {497,0.00053922}, {498,0.00022549}, {499,0.00041176}, {500,0.00035294}, {505,0.00031373}, {510,0.00040196}, {515,0.00022549}, {520,0.00031373}, {525,0.00071569}, {530,0.00052941}, {535,0.00043137}, {540,0.00056863}, {545,0.00053922}, {550,0.00035294}, {555,0.00044118}, {560,0.00032353}, {565,0.00044118}, {570,0.00060784}, {575,0.00050000}, {580,0.00031373}, {585,0.00027451}, {590,0.00050000}, {595,0.00031373}, {600,0.00023529}, {605,0.00037255}, {610,0.00063725}, {615,0.00062745}, {620,0.00039216}, {625,0.00033333}, {630,0.00035294}, {635,0.00052941}, {640,0.00066667}, {645,0.00035294}, {650,0.00038235}, {655,0.00057843}, {660,0.00024510}, {665,0.00044118}, {670,0.00049020}, {675,0.00030392}, {680,0.00021569}, {685,0.00032353}, {690,0.00036275}, {695,0.00033333}, {700,0.00023529}, {705,0.00072549}, {710,0.00070588}, {715,0.00057843}, {720,0.00048039}, {725,0.00050000}, {730,0.00044118}, {735,0.00061765}, {740,0.00040196}, {745,0.00057843}, {750,0.00050980}, {755,0.00046078}, {760,0.00045098}, {765,0.00032353}, {770,0.00073529}, {775,0.00050000}, {780,0.00069608}, {785,0.00041176}, {790,0.00056863}, {795,0.00048039}, {800,0.00148039}, {805,0.00049020}, {810,0.00050980}, {815,0.00073529}, {820,0.00056863}, {825,0.00053922}, {830,0.00046078}, {835,0.00045098}, {840,0.00041176}, {845,0.00080392}, {850,0.00053922}, {855,0.00076471}, {860,0.00050980}, {865,0.00054902}, {870,0.00068627}, {875,0.00068627}, {880,0.00056863}, {885,0.00050980}, {890,0.00065686}, {895,0.00047059}, {900,0.00050000}, {905,0.00041176}, {910,0.00063725}, {915,0.00051961}, {920,0.00059804}, {925,0.00066667}, {930,0.00060784}, {935,0.00077451}, {940,0.00050980}, {945,0.00068627}, {950,0.00058824}, {955,0.00036275}, {960,0.00067647}, {965,0.00038235}, {970,0.00050000}, {975,0.00052941}, {980,0.00067647}, {985,0.00071569}, {990,0.00054902}, {995,0.00068627}, {1000,0.00042157}, {1010,0.00057843}, {1020,0.00045098}, {1030,0.00067647}, {1040,0.00051961}, {1050,0.00085294}, {1060,0.00064706}, {1070,0.00075490}, {1080,0.00066667}, {1090,0.00080392}, {1100,0.00051961}, {1110,0.00088235}, {1120,0.00071569}, {1130,0.00058824}, {1140,0.00057843}, {1150,0.00219608}, {1160,0.00059804}, {1170,0.00078431}, {1180,0.00089216}, {1190,0.00083333}, {1200,0.00060784}, {1210,0.00080392}, {1220,0.00096078}, {1230,0.00072549}, {1240,0.00088235}, {1250,0.00100000}, {1260,0.00121569}, {1270,0.00083333}, {1280,0.00085294}, {1290,0.00072549}, {1300,0.00070588}, {1310,0.00075490}, {1320,0.00094118}, {1330,0.00093137}, {1340,0.00077451}, {1350,0.00100980}, {1360,0.00099020}, {1370,0.00090196}, {1380,0.00093137}, {1390,0.00076471}, {1400,0.00069608}, {1410,0.00104902}, {1420,0.00086275}, {1430,0.00086275}, {1440,0.00102941}, {1450,0.00105882}, {1460,0.00092157}, {1470,0.00094118}, {1480,0.00095098}, {1490,0.00073529}, {1500,0.00065686}, {1510,0.00092157}, {1520,0.00085294}, {1530,0.00206863}, {1540,0.00094118}, {1550,0.00079412}, {1560,0.00091176}, {1570,0.00105882}, {1580,0.00093137}, {1590,0.00097059}, {1600,0.00100000}, {1610,0.00082353}, {1620,0.00079412}, {1630,0.00103922}, {1640,0.00090196}, {1650,0.00095098}, {1660,0.00102941}, {1670,0.00090196}, {1680,0.00078431}, {1690,0.00098039}, {1700,0.00107843}, {1710,0.00104902}, {1720,0.00097059}, {1730,0.00099020}, {1740,0.00106863}, {1750,0.00120588}, {1760,0.00094118}, {1770,0.00103922}, {1780,0.00125490}, {1790,0.00096078}, {1800,0.00100000}, {1810,0.00136275}, {1820,0.00102941}, {1830,0.00100000}, {1840,0.00122549}, {1850,0.00130392}, {1860,0.00120588}, {1870,0.00104902}, {1880,0.00119608}, {1890,0.00115686}, {1900,0.00101961}, {1910,0.00120588}, {1920,0.00131373}, {1930,0.00118627}, {1940,0.00099020}, {1950,0.00103922}, {1960,0.00119608}, {1970,0.00112745}, {1980,0.00112745}, {1990,0.00115686}, {2000,0.00122549}, {2050,0.00130392}, {2100,0.00145098}, {2150,0.00250000}, {2200,0.00150000}, {2250,0.00134314}, {2300,0.00120588}, {2350,0.00101961}, {2400,0.00150000}, {2450,0.00155882}, {2500,0.00160784}, {2550,0.00158824}, {2600,0.00150000}, {2650,0.00164706}, {2700,0.00180392}, {2750,0.00210784}, {2800,0.00163725}, {2850,0.00176471}, {2900,0.00184314}, {2950,0.00182353}, {3000,0.00157843}, {3050,0.00181373}, {3100,0.00206863}, {3150,0.00187255}, {3200,0.00192157}, {3250,0.00191176}, {3300,0.00225490}, {3350,0.00205882}, {3400,0.00228431}, {3450,0.00227451}, {3500,0.00219608}, {3550,0.00194118}, {3600,0.00241176}, {3650,0.00252941}, {3700,0.00272549}, {3750,0.00250000}, {3800,0.00275490}, {3850,0.00255882}, {3900,0.00270588}, {3950,0.00282353}, {4000,0.00256863}, {4050,0.00292157}, {4100,0.00239216}, {4150,0.00282353}, {4200,0.00306863}, {4250,0.00291176}, {4300,0.00307843}, {4350,0.00322549}, {4400,0.00346078}, {4450,0.00342157}, {4500,0.00303922}, {4550,0.00362745}, {4600,0.00345098}, {4650,0.00330392}, {4700,0.00353922}, {4750,0.00352941}, {4800,0.00380392}, {4850,0.00355882}, {4900,0.00387255}, {4950,0.00850980}, {5000,0.00376471}, {5050,0.00367647}, {5100,0.00385294}, {5150,0.00382353}, {5200,0.00412745}, {5250,0.00427451}, {5300,0.00434314}, {5350,0.00417647}, {5400,0.01299020}, {5450,0.00422549}, {5500,0.00399020}, {5550,0.00425490}, {5600,0.00431373}, {5650,0.00425490}, {5700,0.00441176}, {5750,0.00456863}, {5800,0.00444118}, {5850,0.00487255}, {5900,0.01352941}, {5950,0.00493137}, {6000,0.00491176}, {6050,0.00625}, {6100,0.00625}, {6150,0.00625}, {6200,0.00700}, {6250,0.00550}, {6300,0.00650}, {6350,0.00725}, {6400,0.00775}, {6450,0.00775}, {6500,0.00625}, {6550,0.00800}, {6600,0.00725}, {6650,0.01225}, {6700,0.00675}, {6750,0.00675}, {6800,0.00700}, {6850,0.00750}, {6900,0.00750}, {6950,0.00750}, {7000,0.00725}, {7050,0.00775}, {7100,0.00775}, {7150,0.00750}, {7200,0.00625}, {7250,0.00750}, {7300,0.00675}, {7350,0.00775}, {7400,0.00750}, {7450,0.00750}, {7500,0.00725}, {7550,0.00750}, {7600,0.00875}, {7650,0.00800}, {7700,0.00700}, {7750,0.00625}, {7800,0.00875}, {7850,0.01375}, {7900,0.02225}, {7950,0.00850}, {8000,0.01875}, {8050,0.00925}, {8100,0.00825}, {8150,0.00775}, {8200,0.00975}, {8250,0.00875}, {8300,0.00925}, {8350,0.00850}, {8400,0.01075}, {8450,0.00825}, {8500,0.00850}, {8550,0.00975}, {8600,0.00725}, {8650,0.00700}, {8700,0.01475}, {8750,0.00700}, {8800,0.00775}, {8850,0.00750}, {8900,0.00750}, {8950,0.01100}, {9000,0.00950}, {9050,0.01825}, {9100,0.00725}, {9150,0.00900}, {9200,0.01000}, {9250,0.00850}, {9300,0.00875}, {9350,0.01000}, {9400,0.00875}, {9450,0.01100}, {9500,0.01000}, {9550,0.01075}, {9600,0.01525}, {9650,0.00875}, {9700,0.00975}, {9750,0.01375}, {9800,0.02125}, {9850,0.01100}, {9900,0.01300}, {9950,0.01100}, {10000,0.01300}, {10100,0.01100}, {10200,0.01100}, {10300,0.01100}, {10400,0.00950}, {10500,0.01100}, {10600,0.01200}, {10700,0.01175}, {10800,0.01200}, {10900,0.01200}, {11000,0.00950}, {11100,0.01200}, {11200,0.01075}, {11300,0.01100}, {11400,0.01175}, {11500,0.01200}, {11600,0.01200}, {11700,0.01275}, {11800,0.01075}, {11900,0.01075}, {12000,0.01275}, {12100,0.01200}, {12200,0.01200}, {12300,0.01275}, {12400,0.01300}, {12500,0.01200}, {12600,0.01275}, {12700,0.01350}, {12800,0.01375}, {12900,0.01275}, {13000,0.01500}, {13100,0.03675}, {13200,0.01750}, {13300,0.01475}, {13400,0.01375}, {13500,0.01275}, {13600,0.01300}, {13700,0.01850}, {13800,0.01475}, {13900,0.02250}, {14000,0.01450}, {14100,0.01425}, {14200,0.01575}, {14300,0.02675}, {14400,0.02150}, {14500,0.01475}, {14600,0.01575}, {14700,0.02475}, {14800,0.01550}, {14900,0.01550}, {15000,0.01575}, {15100,0.04025}, {15200,0.01550}, {15300,0.02650}, {15400,0.02975}, {15500,0.01850}, {15600,0.01650}, {15700,0.02275}, {15800,0.01575}, {15900,0.01625}, {16000,0.03750}, {16100,0.01375}, {16200,0.04325}, {16300,0.01650}, {16400,0.04750}, {16500,0.01675}, {16600,0.02200}, {16700,0.02125}, {16800,0.02250}, {16900,0.01675}, {17000,0.01675}, {17100,0.01650}, {17200,0.01725}, {17300,0.01750}, {17400,0.01750}, {17500,0.02475}, {17600,0.01825}, {17700,0.01775}, {17800,0.01750}, {17900,0.01625}, {18000,0.01850}, {18100,0.01975}, {18200,0.01975}, {18300,0.01775}, {18400,0.03975}, {18500,0.02000}, {18600,0.01850}, {18700,0.02050}, {18800,0.01925}, {18900,0.01925}, {19000,0.01925}, {19100,0.04425}, {19200,0.02050}, {19300,0.01900}, {19400,0.02000}, {19500,0.02175}, {19600,0.02050}, {19700,0.02050}, {19800,0.02025}, {19900,0.02050}, {20000,0.01925}};
data["big_flat"]["Ltac2"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00003922}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00003922}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00003922}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00003922}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00003922}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00003922}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00003922}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00003922}, {304,0.00000000}, {305,0.00000000}, {306,0.00003922}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00003922}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00003922}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00003922}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00007843}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00003922}, {426,0.00000000}, {427,0.00003922}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00003922}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00003922}, {446,0.00003922}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00003922}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00003922}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00002941}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00007843}, {483,0.00003922}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00003922}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00003922}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00003922}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00007843}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00003922}, {790,0.00003922}, {795,0.00003922}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00003922}, {910,0.00000000}, {915,0.00000000}, {920,0.00003922}, {925,0.00000000}, {930,0.00003922}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00003922}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00003922}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00003922}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00003922}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00003922}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00003922}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00003922}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00003922}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00003922}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00007843}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00003922}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00003922}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00007843}, {2250,0.00003922}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00003922}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00003922}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00003922}, {3250,0.00003922}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00003922}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00003922}, {3800,0.00003922}, {3850,0.00003922}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00003922}, {4050,0.00000000}, {4100,0.00007843}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00006863}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00003922}, {4650,0.00003922}, {4700,0.00007843}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00007843}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00003922}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00003922}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00100}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00100}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00100}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00100}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["Ltac2"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00184314}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00001961}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00200000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00001961}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00002941}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000980}, {2200,0.00000000}, {2250,0.00000980}, {2300,0.00008824}, {2350,0.00007843}, {2400,0.00013725}, {2450,0.00024510}, {2500,0.00039216}, {2550,0.00075490}, {2600,0.00081373}, {2650,0.00090196}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00100000}, {3150,0.00100000}, {3200,0.00100000}, {3250,0.00100000}, {3300,0.00100000}, {3350,0.00100000}, {3400,0.00100000}, {3450,0.00100000}, {3500,0.00100000}, {3550,0.00100000}, {3600,0.00100000}, {3650,0.00100000}, {3700,0.00915686}, {3750,0.00100000}, {3800,0.00100000}, {3850,0.00100000}, {3900,0.00100000}, {3950,0.00100000}, {4000,0.00100000}, {4050,0.00100000}, {4100,0.00100980}, {4150,0.00100980}, {4200,0.00100000}, {4250,0.00100980}, {4300,0.00100980}, {4350,0.00113725}, {4400,0.00104902}, {4450,0.00941176}, {4500,0.00107843}, {4550,0.00116667}, {4600,0.00125490}, {4650,0.00123529}, {4700,0.00141176}, {4750,0.00150980}, {4800,0.00155882}, {4850,0.00174510}, {4900,0.00181373}, {4950,0.00185294}, {5000,0.00185294}, {5050,0.00190196}, {5100,0.00191176}, {5150,0.00197059}, {5200,0.00199020}, {5250,0.00200000}, {5300,0.00200000}, {5350,0.00200000}, {5400,0.00200000}, {5450,0.00200000}, {5500,0.00200000}, {5550,0.00200000}, {5600,0.00200000}, {5650,0.00200000}, {5700,0.01336275}, {5750,0.00200980}, {5800,0.00200980}, {5850,0.01101961}, {5900,0.00200000}, {5950,0.00200000}, {6000,0.00200980}, {6050,0.00200}, {6100,0.00200}, {6150,0.00750}, {6200,0.00200}, {6250,0.00275}, {6300,0.00225}, {6350,0.00275}, {6400,0.00250}, {6450,0.00225}, {6500,0.00250}, {6550,0.00250}, {6600,0.01550}, {6650,0.00275}, {6700,0.01550}, {6750,0.00275}, {6800,0.00275}, {6850,0.00275}, {6900,0.00300}, {6950,0.00300}, {7000,0.00300}, {7050,0.00300}, {7100,0.00300}, {7150,0.00300}, {7200,0.00300}, {7250,0.00275}, {7300,0.00300}, {7350,0.00300}, {7400,0.00300}, {7450,0.00300}, {7500,0.00300}, {7550,0.00300}, {7600,0.00300}, {7650,0.00550}, {7700,0.00650}, {7750,0.00300}, {7800,0.00300}, {7850,0.00350}, {7900,0.00300}, {7950,0.00300}, {8000,0.00300}, {8050,0.00300}, {8100,0.01750}, {8150,0.00350}, {8200,0.00300}, {8250,0.00350}, {8300,0.00300}, {8350,0.00325}, {8400,0.00350}, {8450,0.00325}, {8500,0.00300}, {8550,0.00300}, {8600,0.00325}, {8650,0.00300}, {8700,0.00325}, {8750,0.00325}, {8800,0.00325}, {8850,0.00325}, {8900,0.00350}, {8950,0.00350}, {9000,0.00325}, {9050,0.00300}, {9100,0.00375}, {9150,0.00350}, {9200,0.00350}, {9250,0.00350}, {9300,0.00350}, {9350,0.00375}, {9400,0.00400}, {9450,0.00375}, {9500,0.00400}, {9550,0.00400}, {9600,0.00400}, {9650,0.00400}, {9700,0.00400}, {9750,0.00400}, {9800,0.00400}, {9850,0.00400}, {9900,0.00400}, {9950,0.01625}, {10000,0.00400}, {10100,0.00400}, {10200,0.00750}, {10300,0.00400}, {10400,0.00400}, {10500,0.00400}, {10600,0.00400}, {10700,0.00400}, {10800,0.01700}, {10900,0.02050}, {11000,0.00425}, {11100,0.00425}, {11200,0.00425}, {11300,0.02650}, {11400,0.00400}, {11500,0.02400}, {11600,0.00475}, {11700,0.00475}, {11800,0.00475}, {11900,0.00500}, {12000,0.00500}, {12100,0.00500}, {12200,0.02550}, {12300,0.00500}, {12400,0.00500}, {12500,0.00500}, {12600,0.00500}, {12700,0.00525}, {12800,0.00500}, {12900,0.00500}, {13000,0.01075}, {13100,0.00525}, {13200,0.00525}, {13300,0.00525}, {13400,0.02075}, {13500,0.00550}, {13600,0.00550}, {13700,0.00550}, {13800,0.00550}, {13900,0.01350}, {14000,0.00600}, {14100,0.00575}, {14200,0.02850}, {14300,0.01225}, {14400,0.00600}, {14500,0.00600}, {14600,0.00600}, {14700,0.01125}, {14800,0.00600}, {14900,0.00625}, {15000,0.00600}, {15100,0.00625}, {15200,0.00600}, {15300,0.01350}, {15400,0.01400}, {15500,0.00650}, {15600,0.00650}, {15700,0.00650}, {15800,0.02550}, {15900,0.02525}, {16000,0.00650}, {16100,0.00650}, {16200,0.00650}, {16300,0.00700}, {16400,0.00675}, {16500,0.00700}, {16600,0.00700}, {16700,0.00725}, {16800,0.00725}, {16900,0.00725}, {17000,0.00725}, {17100,0.00725}, {17200,0.00700}, {17300,0.00725}, {17400,0.00750}, {17500,0.00750}, {17600,0.00750}, {17700,0.00750}, {17800,0.03425}, {17900,0.00750}, {18000,0.00750}, {18100,0.00750}, {18200,0.00750}, {18300,0.00775}, {18400,0.00775}, {18500,0.00800}, {18600,0.00800}, {18700,0.03500}, {18800,0.00800}, {18900,0.00850}, {19000,0.00825}, {19100,0.01950}, {19200,0.03225}, {19300,0.00850}, {19400,0.00850}, {19500,0.03175}, {19600,0.03650}, {19700,0.02825}, {19800,0.03575}, {19900,0.00850}, {20000,0.00850}};
data["big_flat"]["Ltac2"]["lazy beta iota"]["user"] = {{1,0.00002941}, {2,0.00003922}, {3,0.00000000}, {4,0.00003922}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00002941}, {12,0.00000000}, {13,0.00002941}, {14,0.00005882}, {15,0.00003922}, {16,0.00002941}, {17,0.00002941}, {18,0.00000000}, {19,0.00000000}, {20,0.00002941}, {21,0.00002941}, {22,0.00003922}, {23,0.00000000}, {24,0.00002941}, {25,0.00000000}, {26,0.00002941}, {27,0.00002941}, {28,0.00002941}, {29,0.00002941}, {30,0.00000000}, {31,0.00002941}, {32,0.00006863}, {33,0.00000000}, {34,0.00000000}, {35,0.00002941}, {36,0.00000000}, {37,0.00000000}, {38,0.00008824}, {39,0.00002941}, {40,0.00000000}, {41,0.00005882}, {42,0.00002941}, {43,0.00000000}, {44,0.00002941}, {45,0.00002941}, {46,0.00000000}, {47,0.00006863}, {48,0.00005882}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00003922}, {53,0.00002941}, {54,0.00007843}, {55,0.00000000}, {56,0.00003922}, {57,0.00006863}, {58,0.00006863}, {59,0.00002941}, {60,0.00002941}, {61,0.00003922}, {62,0.00002941}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00002941}, {67,0.00000000}, {68,0.00006863}, {69,0.00002941}, {70,0.00002941}, {71,0.00006863}, {72,0.00002941}, {73,0.00000000}, {74,0.00002941}, {75,0.00000000}, {76,0.00006863}, {77,0.00003922}, {78,0.00000000}, {79,0.00002941}, {80,0.00000000}, {81,0.00009804}, {82,0.00000000}, {83,0.00002941}, {84,0.00000000}, {85,0.00005882}, {86,0.00009804}, {87,0.00002941}, {88,0.00000000}, {89,0.00002941}, {90,0.00006863}, {91,0.00002941}, {92,0.00003922}, {93,0.00013725}, {94,0.00005882}, {95,0.00002941}, {96,0.00011765}, {97,0.00000000}, {98,0.00002941}, {99,0.00002941}, {100,0.00016667}, {101,0.00002941}, {102,0.00000000}, {103,0.00000000}, {104,0.00007843}, {105,0.00002941}, {106,0.00009804}, {107,0.00008824}, {108,0.00010784}, {109,0.00000000}, {110,0.00006863}, {111,0.00002941}, {112,0.00002941}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00002941}, {117,0.00011765}, {118,0.00000000}, {119,0.00002941}, {120,0.00005882}, {121,0.00012745}, {122,0.00002941}, {123,0.00008824}, {124,0.00005882}, {125,0.00003922}, {126,0.00010784}, {127,0.00006863}, {128,0.00000000}, {129,0.00009804}, {130,0.00006863}, {131,0.00005882}, {132,0.00000000}, {133,0.00013725}, {134,0.00000000}, {135,0.00005882}, {136,0.00015686}, {137,0.00006863}, {138,0.00000000}, {139,0.00003922}, {140,0.00006863}, {141,0.00017647}, {142,0.00009804}, {143,0.00003922}, {144,0.00006863}, {145,0.00003922}, {146,0.00002941}, {147,0.00015686}, {148,0.00014706}, {149,0.00005882}, {150,0.00010784}, {151,0.00020588}, {152,0.00000000}, {153,0.00005882}, {154,0.00008824}, {155,0.00006863}, {156,0.00008824}, {157,0.00007843}, {158,0.00002941}, {159,0.00014706}, {160,0.00017647}, {161,0.00006863}, {162,0.00006863}, {163,0.00005882}, {164,0.00002941}, {165,0.00008824}, {166,0.00012745}, {167,0.00006863}, {168,0.00002941}, {169,0.00012745}, {170,0.00005882}, {171,0.00005882}, {172,0.00005882}, {173,0.00008824}, {174,0.00000000}, {175,0.00011765}, {176,0.00015686}, {177,0.00002941}, {178,0.00002941}, {179,0.00006863}, {180,0.00011765}, {181,0.00010784}, {182,0.00011765}, {183,0.00006863}, {184,0.00011765}, {185,0.00006863}, {186,0.00000000}, {187,0.00000000}, {188,0.00002941}, {189,0.00002941}, {190,0.00010784}, {191,0.00006863}, {192,0.00000000}, {193,0.00005882}, {194,0.00006863}, {195,0.00002941}, {196,0.00013725}, {197,0.00003922}, {198,0.00012745}, {199,0.00003922}, {200,0.00005882}, {201,0.00002941}, {202,0.00002941}, {203,0.00006863}, {204,0.00008824}, {205,0.00005882}, {206,0.00009804}, {207,0.00015686}, {208,0.00011765}, {209,0.00015686}, {210,0.00010784}, {211,0.00016667}, {212,0.00012745}, {213,0.00012745}, {214,0.00010784}, {215,0.00008824}, {216,0.00014706}, {217,0.00003922}, {218,0.00005882}, {219,0.00005882}, {220,0.00002941}, {221,0.00003922}, {222,0.00006863}, {223,0.00005882}, {224,0.00010784}, {225,0.00014706}, {226,0.00000000}, {227,0.00009804}, {228,0.00017647}, {229,0.00003922}, {230,0.00008824}, {231,0.00000000}, {232,0.00011765}, {233,0.00018627}, {234,0.00003922}, {235,0.00013725}, {236,0.00008824}, {237,0.00015686}, {238,0.00010784}, {239,0.00006863}, {240,0.00015686}, {241,0.00018627}, {242,0.00012745}, {243,0.00005882}, {244,0.00014706}, {245,0.00005882}, {246,0.00015686}, {247,0.00006863}, {248,0.00005882}, {249,0.00006863}, {250,0.00025490}, {251,0.00006863}, {252,0.00006863}, {253,0.00013725}, {254,0.00009804}, {255,0.00006863}, {256,0.00015686}, {257,0.00005882}, {258,0.00023529}, {259,0.00012745}, {260,0.00016667}, {261,0.00011765}, {262,0.00006863}, {263,0.00002941}, {264,0.00005882}, {265,0.00005882}, {266,0.00007843}, {267,0.00012745}, {268,0.00029412}, {269,0.00018627}, {270,0.00009804}, {271,0.00008824}, {272,0.00010784}, {273,0.00008824}, {274,0.00003922}, {275,0.00008824}, {276,0.00015686}, {277,0.00014706}, {278,0.00002941}, {279,0.00006863}, {280,0.00005882}, {281,0.00021569}, {282,0.00018627}, {283,0.00008824}, {284,0.00012745}, {285,0.00002941}, {286,0.00005882}, {287,0.00018627}, {288,0.00020588}, {289,0.00009804}, {290,0.00005882}, {291,0.00009804}, {292,0.00010784}, {293,0.00005882}, {294,0.00003922}, {295,0.00015686}, {296,0.00009804}, {297,0.00009804}, {298,0.00006863}, {299,0.00002941}, {300,0.00002941}, {301,0.00010784}, {302,0.00010784}, {303,0.00011765}, {304,0.00028431}, {305,0.00000000}, {306,0.00028431}, {307,0.00016667}, {308,0.00012745}, {309,0.00006863}, {310,0.00015686}, {311,0.00003922}, {312,0.00002941}, {313,0.00021569}, {314,0.00008824}, {315,0.00005882}, {316,0.00013725}, {317,0.00013725}, {318,0.00009804}, {319,0.00002941}, {320,0.00015686}, {321,0.00021569}, {322,0.00011765}, {323,0.00017647}, {324,0.00002941}, {325,0.00009804}, {326,0.00014706}, {327,0.00029412}, {328,0.00014706}, {329,0.00016667}, {330,0.00015686}, {331,0.00005882}, {332,0.00005882}, {333,0.00014706}, {334,0.00015686}, {335,0.00011765}, {336,0.00016667}, {337,0.00017647}, {338,0.00029412}, {339,0.00015686}, {340,0.00013725}, {341,0.00006863}, {342,0.00008824}, {343,0.00011765}, {344,0.00012745}, {345,0.00006863}, {346,0.00015686}, {347,0.00011765}, {348,0.00009804}, {349,0.00003922}, {350,0.00197059}, {351,0.00014706}, {352,0.00003922}, {353,0.00015686}, {354,0.00012745}, {355,0.00011765}, {356,0.00009804}, {357,0.00045098}, {358,0.00021569}, {359,0.00009804}, {360,0.00012745}, {361,0.00014706}, {362,0.00012745}, {363,0.00016667}, {364,0.00012745}, {365,0.00010784}, {366,0.00018627}, {367,0.00015686}, {368,0.00015686}, {369,0.00018627}, {370,0.00021569}, {371,0.00008824}, {372,0.00016667}, {373,0.00016667}, {374,0.00020588}, {375,0.00005882}, {376,0.00011765}, {377,0.00013725}, {378,0.00021569}, {379,0.00012745}, {380,0.00012745}, {381,0.00026471}, {382,0.00019608}, {383,0.00012745}, {384,0.00010784}, {385,0.00011765}, {386,0.00018627}, {387,0.00017647}, {388,0.00006863}, {389,0.00016667}, {390,0.00009804}, {391,0.00000000}, {392,0.00018627}, {393,0.00006863}, {394,0.00016667}, {395,0.00015686}, {396,0.00010784}, {397,0.00018627}, {398,0.00003922}, {399,0.00019608}, {400,0.00022549}, {401,0.00002941}, {402,0.00014706}, {403,0.00006863}, {404,0.00012745}, {405,0.00011765}, {406,0.00006863}, {407,0.00005882}, {408,0.00016667}, {409,0.00008824}, {410,0.00011765}, {411,0.00034314}, {412,0.00019608}, {413,0.00006863}, {414,0.00015686}, {415,0.00012745}, {416,0.00015686}, {417,0.00014706}, {418,0.00016667}, {419,0.00010784}, {420,0.00016667}, {421,0.00023529}, {422,0.00017647}, {423,0.00023529}, {424,0.00012745}, {425,0.00019608}, {426,0.00011765}, {427,0.00018627}, {428,0.00014706}, {429,0.00012745}, {430,0.00016667}, {431,0.00016667}, {432,0.00009804}, {433,0.00012745}, {434,0.00020588}, {435,0.00020588}, {436,0.00015686}, {437,0.00009804}, {438,0.00018627}, {439,0.00016667}, {440,0.00006863}, {441,0.00023529}, {442,0.00016667}, {443,0.00021569}, {444,0.00009804}, {445,0.00008824}, {446,0.00017647}, {447,0.00028431}, {448,0.00028431}, {449,0.00015686}, {450,0.00011765}, {451,0.00013725}, {452,0.00005882}, {453,0.00025490}, {454,0.00010784}, {455,0.00036275}, {456,0.00035294}, {457,0.00022549}, {458,0.00005882}, {459,0.00008824}, {460,0.00012745}, {461,0.00005882}, {462,0.00015686}, {463,0.00018627}, {464,0.00023529}, {465,0.00014706}, {466,0.00002941}, {467,0.00020588}, {468,0.00012745}, {469,0.00041176}, {470,0.00013725}, {471,0.00016667}, {472,0.00006863}, {473,0.00018627}, {474,0.00016667}, {475,0.00025490}, {476,0.00018627}, {477,0.00009804}, {478,0.00021569}, {479,0.00006863}, {480,0.00035294}, {481,0.00014706}, {482,0.00019608}, {483,0.00026471}, {484,0.00000000}, {485,0.00016667}, {486,0.00008824}, {487,0.00021569}, {488,0.00030392}, {489,0.00024510}, {490,0.00021569}, {491,0.00017647}, {492,0.00017647}, {493,0.00017647}, {494,0.00015686}, {495,0.00020588}, {496,0.00003922}, {497,0.00022549}, {498,0.00026471}, {499,0.00017647}, {500,0.00013725}, {505,0.00002941}, {510,0.00011765}, {515,0.00021569}, {520,0.00022549}, {525,0.00021569}, {530,0.00029412}, {535,0.00019608}, {540,0.00035294}, {545,0.00009804}, {550,0.00028431}, {555,0.00018627}, {560,0.00012745}, {565,0.00018627}, {570,0.00008824}, {575,0.00014706}, {580,0.00027451}, {585,0.00024510}, {590,0.00006863}, {595,0.00013725}, {600,0.00030392}, {605,0.00024510}, {610,0.00018627}, {615,0.00014706}, {620,0.00026471}, {625,0.00017647}, {630,0.00026471}, {635,0.00027451}, {640,0.00023529}, {645,0.00026471}, {650,0.00035294}, {655,0.00015686}, {660,0.00013725}, {665,0.00012745}, {670,0.00017647}, {675,0.00018627}, {680,0.00028431}, {685,0.00032353}, {690,0.00025490}, {695,0.00024510}, {700,0.00030392}, {705,0.00018627}, {710,0.00014706}, {715,0.00047059}, {720,0.00022549}, {725,0.00033333}, {730,0.00034314}, {735,0.00016667}, {740,0.00033333}, {745,0.00025490}, {750,0.00014706}, {755,0.00031373}, {760,0.00012745}, {765,0.00028431}, {770,0.00031373}, {775,0.00019608}, {780,0.00026471}, {785,0.00029412}, {790,0.00027451}, {795,0.00018627}, {800,0.00024510}, {805,0.00022549}, {810,0.00032353}, {815,0.00031373}, {820,0.00031373}, {825,0.00040196}, {830,0.00033333}, {835,0.00027451}, {840,0.00031373}, {845,0.00029412}, {850,0.00005882}, {855,0.00015686}, {860,0.00021569}, {865,0.00039216}, {870,0.00021569}, {875,0.00023529}, {880,0.00025490}, {885,0.00027451}, {890,0.00011765}, {895,0.00029412}, {900,0.00035294}, {905,0.00035294}, {910,0.00022549}, {915,0.00027451}, {920,0.00025490}, {925,0.00032353}, {930,0.00023529}, {935,0.00032353}, {940,0.00025490}, {945,0.00027451}, {950,0.00048039}, {955,0.00032353}, {960,0.00033333}, {965,0.00035294}, {970,0.00039216}, {975,0.00019608}, {980,0.00029412}, {985,0.00024510}, {990,0.00042157}, {995,0.00030392}, {1000,0.00027451}, {1010,0.00045098}, {1020,0.00037255}, {1030,0.00023529}, {1040,0.00028431}, {1050,0.00048039}, {1060,0.00041176}, {1070,0.00051961}, {1080,0.00035294}, {1090,0.00030392}, {1100,0.00044118}, {1110,0.00034314}, {1120,0.00049020}, {1130,0.00042157}, {1140,0.00027451}, {1150,0.00032353}, {1160,0.00050000}, {1170,0.00027451}, {1180,0.00048039}, {1190,0.00050980}, {1200,0.00048039}, {1210,0.00050000}, {1220,0.00041176}, {1230,0.00025490}, {1240,0.00046078}, {1250,0.00062745}, {1260,0.00047059}, {1270,0.00047059}, {1280,0.00015686}, {1290,0.00047059}, {1300,0.00033333}, {1310,0.00040196}, {1320,0.00035294}, {1330,0.00047059}, {1340,0.00055882}, {1350,0.00039216}, {1360,0.00047059}, {1370,0.00039216}, {1380,0.00058824}, {1390,0.00043137}, {1400,0.00053922}, {1410,0.00047059}, {1420,0.00060784}, {1430,0.00041176}, {1440,0.00030392}, {1450,0.00036275}, {1460,0.00038235}, {1470,0.00211765}, {1480,0.00040196}, {1490,0.00051961}, {1500,0.00027451}, {1510,0.00043137}, {1520,0.00044118}, {1530,0.00038235}, {1540,0.00060784}, {1550,0.00041176}, {1560,0.00047059}, {1570,0.00053922}, {1580,0.00057843}, {1590,0.00048039}, {1600,0.00063725}, {1610,0.00050980}, {1620,0.00054902}, {1630,0.00086275}, {1640,0.00049020}, {1650,0.00042157}, {1660,0.00040196}, {1670,0.00066667}, {1680,0.00057843}, {1690,0.00050980}, {1700,0.00050980}, {1710,0.00058824}, {1720,0.00054902}, {1730,0.00058824}, {1740,0.00044118}, {1750,0.00054902}, {1760,0.00058824}, {1770,0.00043137}, {1780,0.00037255}, {1790,0.00086275}, {1800,0.00050980}, {1810,0.00062745}, {1820,0.00062745}, {1830,0.00073529}, {1840,0.00051961}, {1850,0.00078431}, {1860,0.00066667}, {1870,0.00053922}, {1880,0.00077451}, {1890,0.00065686}, {1900,0.00064706}, {1910,0.00055882}, {1920,0.00049020}, {1930,0.00066667}, {1940,0.00093137}, {1950,0.00068627}, {1960,0.00060784}, {1970,0.00070588}, {1980,0.00055882}, {1990,0.00077451}, {2000,0.00063725}, {2050,0.00085294}, {2100,0.00072549}, {2150,0.00057843}, {2200,0.00061765}, {2250,0.00072549}, {2300,0.00088235}, {2350,0.00072549}, {2400,0.00082353}, {2450,0.00075490}, {2500,0.00067647}, {2550,0.00099020}, {2600,0.00126471}, {2650,0.00088235}, {2700,0.00074510}, {2750,0.00097059}, {2800,0.00091176}, {2850,0.00077451}, {2900,0.00089216}, {2950,0.00095098}, {3000,0.00118627}, {3050,0.00103922}, {3100,0.00109804}, {3150,0.00108824}, {3200,0.00107843}, {3250,0.00102941}, {3300,0.00098039}, {3350,0.00120588}, {3400,0.00124510}, {3450,0.00098039}, {3500,0.00105882}, {3550,0.00153922}, {3600,0.00106863}, {3650,0.00113725}, {3700,0.00870588}, {3750,0.00111765}, {3800,0.00123529}, {3850,0.00152941}, {3900,0.00149020}, {3950,0.00141176}, {4000,0.00172549}, {4050,0.00111765}, {4100,0.00183333}, {4150,0.00176471}, {4200,0.00159804}, {4250,0.00179412}, {4300,0.00153922}, {4350,0.00161765}, {4400,0.00156863}, {4450,0.00945098}, {4500,0.00161765}, {4550,0.00173529}, {4600,0.00183333}, {4650,0.00207843}, {4700,0.00171569}, {4750,0.00191176}, {4800,0.00166667}, {4850,0.00212745}, {4900,0.00185294}, {4950,0.00222549}, {5000,0.00205882}, {5050,0.00205882}, {5100,0.00207843}, {5150,0.00203922}, {5200,0.00192157}, {5250,0.00170588}, {5300,0.00216667}, {5350,0.00213725}, {5400,0.00237255}, {5450,0.00215686}, {5500,0.00262745}, {5550,0.00251961}, {5600,0.00235294}, {5650,0.00239216}, {5700,0.01373529}, {5750,0.00217647}, {5800,0.00222549}, {5850,0.01141176}, {5900,0.00214706}, {5950,0.00227451}, {6000,0.00222549}, {6050,0.00175}, {6100,0.00250}, {6150,0.00600}, {6200,0.00275}, {6250,0.00375}, {6300,0.00250}, {6350,0.00275}, {6400,0.00250}, {6450,0.00175}, {6500,0.00350}, {6550,0.00225}, {6600,0.01500}, {6650,0.00175}, {6700,0.01500}, {6750,0.00150}, {6800,0.00300}, {6850,0.00350}, {6900,0.00175}, {6950,0.00225}, {7000,0.00250}, {7050,0.00300}, {7100,0.00175}, {7150,0.00175}, {7200,0.00250}, {7250,0.00150}, {7300,0.00225}, {7350,0.00250}, {7400,0.00350}, {7450,0.00350}, {7500,0.00350}, {7550,0.00325}, {7600,0.00275}, {7650,0.00525}, {7700,0.00675}, {7750,0.00375}, {7800,0.00350}, {7850,0.00325}, {7900,0.00350}, {7950,0.00250}, {8000,0.00325}, {8050,0.00275}, {8100,0.01800}, {8150,0.00300}, {8200,0.00300}, {8250,0.00350}, {8300,0.00400}, {8350,0.00375}, {8400,0.00300}, {8450,0.00250}, {8500,0.00375}, {8550,0.00325}, {8600,0.00375}, {8650,0.00400}, {8700,0.00350}, {8750,0.00275}, {8800,0.00325}, {8850,0.00375}, {8900,0.00350}, {8950,0.00350}, {9000,0.00375}, {9050,0.00400}, {9100,0.00375}, {9150,0.00400}, {9200,0.00250}, {9250,0.00375}, {9300,0.00350}, {9350,0.00300}, {9400,0.00325}, {9450,0.00300}, {9500,0.00300}, {9550,0.00325}, {9600,0.00350}, {9650,0.00425}, {9700,0.00475}, {9750,0.00325}, {9800,0.00425}, {9850,0.00300}, {9900,0.00300}, {9950,0.01575}, {10000,0.00450}, {10100,0.00300}, {10200,0.00750}, {10300,0.00325}, {10400,0.00475}, {10500,0.00325}, {10600,0.00300}, {10700,0.00400}, {10800,0.01550}, {10900,0.02100}, {11000,0.00550}, {11100,0.00550}, {11200,0.00575}, {11300,0.02775}, {11400,0.00450}, {11500,0.02325}, {11600,0.00450}, {11700,0.00425}, {11800,0.00675}, {11900,0.00550}, {12000,0.00650}, {12100,0.00450}, {12200,0.02625}, {12300,0.00425}, {12400,0.00400}, {12500,0.00300}, {12600,0.00675}, {12700,0.00525}, {12800,0.00450}, {12900,0.00425}, {13000,0.01175}, {13100,0.00550}, {13200,0.00425}, {13300,0.00675}, {13400,0.01975}, {13500,0.00750}, {13600,0.00700}, {13700,0.00425}, {13800,0.00675}, {13900,0.01400}, {14000,0.00550}, {14100,0.00600}, {14200,0.02650}, {14300,0.01325}, {14400,0.00550}, {14500,0.00625}, {14600,0.00475}, {14700,0.01175}, {14800,0.00750}, {14900,0.00550}, {15000,0.00650}, {15100,0.00575}, {15200,0.00650}, {15300,0.01250}, {15400,0.01375}, {15500,0.00750}, {15600,0.00550}, {15700,0.00550}, {15800,0.02525}, {15900,0.02450}, {16000,0.00475}, {16100,0.00725}, {16200,0.00575}, {16300,0.00725}, {16400,0.00725}, {16500,0.00725}, {16600,0.00700}, {16700,0.00775}, {16800,0.00625}, {16900,0.00700}, {17000,0.00725}, {17100,0.00725}, {17200,0.00575}, {17300,0.00725}, {17400,0.00750}, {17500,0.00750}, {17600,0.00750}, {17700,0.00700}, {17800,0.03425}, {17900,0.00850}, {18000,0.00725}, {18100,0.00700}, {18200,0.00725}, {18300,0.00725}, {18400,0.00650}, {18500,0.00700}, {18600,0.00750}, {18700,0.03450}, {18800,0.00850}, {18900,0.00950}, {19000,0.00875}, {19100,0.01850}, {19200,0.03200}, {19300,0.00875}, {19400,0.00850}, {19500,0.03050}, {19600,0.03650}, {19700,0.02850}, {19800,0.03475}, {19900,0.00725}, {20000,0.00850}};
data["big_flat"]["Ltac2"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00003922}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00003922}, {118,0.00003922}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00003922}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00003922}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00003922}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00003922}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00003922}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00003922}, {283,0.00000000}, {284,0.00000000}, {285,0.00003922}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00003922}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00003922}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00003922}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00003922}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00006863}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00003922}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00002941}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00003922}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00003922}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00003922}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00003922}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00003922}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00003922}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00003922}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00003922}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00003922}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00003922}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00003922}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003922}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00006863}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00003922}, {2350,0.00003922}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00003922}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00003922}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00003922}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00002941}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00003922}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00007843}, {4850,0.00000000}, {4900,0.00003922}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00003922}, {5550,0.00000000}, {5600,0.00003922}, {5650,0.00003922}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00002941}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00100}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00100}, {6800,0.00000}, {6850,0.00000}, {6900,0.00100}, {6950,0.00000}, {7000,0.00100}, {7050,0.00000}, {7100,0.00100}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00100}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["Ltac2"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00003922}, {5,0.00099020}, {6,0.00100000}, {7,0.00100000}, {8,0.00100000}, {9,0.00100000}, {10,0.00101961}, {11,0.00115686}, {12,0.00121569}, {13,0.00200000}, {14,0.00200000}, {15,0.00200000}, {16,0.00200000}, {17,0.00217647}, {18,0.00219608}, {19,0.00263725}, {20,0.00280392}, {21,0.00319608}, {22,0.01325490}, {23,0.00301961}, {24,0.00300980}, {25,0.00304902}, {26,0.00320588}, {27,0.00400000}, {28,0.00400000}, {29,0.00405882}, {30,0.00408824}, {31,0.00412745}, {32,0.00408824}, {33,0.00425490}, {34,0.00486275}, {35,0.00509804}, {36,0.00510784}, {37,0.00512745}, {38,0.00510784}, {39,0.00624510}, {40,0.00514706}, {41,0.00610784}, {42,0.00608824}, {43,0.00609804}, {44,0.00606863}, {45,0.00624510}, {46,0.00680392}, {47,0.00716667}, {48,0.00628431}, {49,0.00708824}, {50,0.00706863}, {51,0.00719608}, {52,0.00803922}, {53,0.00796078}, {54,0.00804902}, {55,0.00809804}, {56,0.00803922}, {57,0.00805882}, {58,0.00809804}, {59,0.00903922}, {60,0.00849020}, {61,0.01003922}, {62,0.00901961}, {63,0.00985294}, {64,0.00899020}, {65,0.00907843}, {66,0.00907843}, {67,0.01005882}, {68,0.00957843}, {69,0.01006863}, {70,0.01106863}, {71,0.01100000}, {72,0.01001961}, {73,0.01082353}, {74,0.01109804}, {75,0.01114706}, {76,0.01107843}, {77,0.01165686}, {78,0.01198039}, {79,0.01218627}, {80,0.01109804}, {81,0.01205882}, {82,0.01215686}, {83,0.01243137}, {84,0.01304902}, {85,0.01309804}, {86,0.01306863}, {87,0.01345098}, {88,0.01276471}, {89,0.01309804}, {90,0.01317647}, {91,0.01494118}, {92,0.01384314}, {93,0.01413725}, {94,0.01434314}, {95,0.01516667}, {96,0.01323529}, {97,0.01505882}, {98,0.01417647}, {99,0.01509804}, {100,0.01430392}, {101,0.01512745}, {102,0.01611765}, {103,0.01611765}, {104,0.01507843}, {105,0.01599020}, {106,0.01602941}, {107,0.01675490}, {108,0.01691176}, {109,0.01706863}, {110,0.01707843}, {111,0.01800980}, {112,0.01608824}, {113,0.01780392}, {114,0.01710784}, {115,0.01805882}, {116,0.01712745}, {117,0.01908824}, {118,0.01812745}, {119,0.01913725}, {120,0.01786275}, {121,0.01882353}, {122,0.01958824}, {123,0.01964706}, {124,0.01903922}, {125,0.01997059}, {126,0.02093137}, {127,0.02103922}, {128,0.01806863}, {129,0.01900000}, {130,0.01912745}, {131,0.02100980}, {132,0.01928431}, {133,0.02021569}, {134,0.02032353}, {135,0.02221569}, {136,0.02005882}, {137,0.02101961}, {138,0.02109804}, {139,0.02293137}, {140,0.02118627}, {141,0.02217647}, {142,0.02223529}, {143,0.02423529}, {144,0.02115686}, {145,0.02204902}, {146,0.02223529}, {147,0.02409804}, {148,0.02216667}, {149,0.02328431}, {150,0.02452941}, {151,0.02448039}, {152,0.02303922}, {153,0.02405882}, {154,0.02492157}, {155,0.02513725}, {156,0.02414706}, {157,0.02626471}, {158,0.02554902}, {159,0.02671569}, {160,0.02320588}, {161,0.02515686}, {162,0.02434314}, {163,0.02558824}, {164,0.02559804}, {165,0.02605882}, {166,0.02614706}, {167,0.02711765}, {168,0.02517647}, {169,0.02634314}, {170,0.02648039}, {171,0.02840196}, {172,0.02682353}, {173,0.02810784}, {174,0.02911765}, {175,0.02934314}, {176,0.02629412}, {177,0.02832353}, {178,0.02759804}, {179,0.02896078}, {180,0.02888235}, {181,0.02918627}, {182,0.02921569}, {183,0.03141176}, {184,0.02848039}, {185,0.02992157}, {186,0.03086275}, {187,0.03107843}, {188,0.03022549}, {189,0.03228431}, {190,0.03140196}, {191,0.03407843}, {192,0.02801961}, {193,0.02925490}, {194,0.03031373}, {195,0.03081373}, {196,0.02965686}, {197,0.03186275}, {198,0.03116667}, {199,0.03251961}, {200,0.03102941}, {201,0.03149020}, {202,0.03171569}, {203,0.03407843}, {204,0.03205882}, {205,0.03432353}, {206,0.03350000}, {207,0.03502941}, {208,0.03230392}, {209,0.03269608}, {210,0.03281373}, {211,0.03525490}, {212,0.03317647}, {213,0.03541176}, {214,0.03456863}, {215,0.03621569}, {216,0.03437255}, {217,0.03529412}, {218,0.03613725}, {219,0.03667647}, {220,0.03538235}, {221,0.03703922}, {222,0.03708824}, {223,0.03940196}, {224,0.03362745}, {225,0.03600980}, {226,0.03516667}, {227,0.03671569}, {228,0.03625490}, {229,0.03702941}, {230,0.03813725}, {231,0.03866667}, {232,0.03707843}, {233,0.03738235}, {234,0.03765686}, {235,0.04027451}, {236,0.03795098}, {237,0.04046078}, {238,0.03956863}, {239,0.04204902}, {240,0.03721569}, {241,0.03970588}, {242,0.03885294}, {243,0.04045098}, {244,0.03999020}, {245,0.04057843}, {246,0.04207843}, {247,0.04247059}, {248,0.04054902}, {249,0.04116667}, {250,0.04216667}, {251,0.04308824}, {252,0.04230392}, {253,0.04313725}, {254,0.04400000}, {255,0.04520588}, {256,0.03893137}, {257,0.03943137}, {258,0.04087255}, {259,0.04150980}, {260,0.04010784}, {261,0.04169608}, {262,0.04187255}, {263,0.04436275}, {264,0.04040196}, {265,0.04368627}, {266,0.04232353}, {267,0.04536275}, {268,0.04261765}, {269,0.04569608}, {270,0.04466667}, {271,0.04772549}, {272,0.04144118}, {273,0.04467647}, {274,0.04347059}, {275,0.04661765}, {276,0.04377451}, {277,0.04672549}, {278,0.04570588}, {279,0.04764706}, {280,0.04526471}, {281,0.04632353}, {282,0.04694118}, {283,0.04834314}, {284,0.04731373}, {285,0.04846078}, {286,0.04939216}, {287,0.05052941}, {288,0.04507843}, {289,0.04582353}, {290,0.04730392}, {291,0.04786275}, {292,0.04601961}, {293,0.04907843}, {294,0.04810784}, {295,0.05089216}, {296,0.04653922}, {297,0.04957843}, {298,0.04865686}, {299,0.05174510}, {300,0.04899020}, {301,0.05110784}, {302,0.05165686}, {303,0.05322549}, {304,0.04849020}, {305,0.04971569}, {306,0.05104902}, {307,0.05326471}, {308,0.05020588}, {309,0.05294118}, {310,0.05235294}, {311,0.05538235}, {312,0.05213725}, {313,0.05264706}, {314,0.05346078}, {315,0.05496078}, {316,0.05413725}, {317,0.05633333}, {318,0.05530392}, {319,0.05832353}, {320,0.04849020}, {321,0.05187255}, {322,0.05181373}, {323,0.05304902}, {324,0.05181373}, {325,0.05314706}, {326,0.05465686}, {327,0.05635294}, {328,0.05154902}, {329,0.05464706}, {330,0.05380392}, {331,0.05708824}, {332,0.05528431}, {333,0.05634314}, {334,0.05744118}, {335,0.05950980}, {336,0.05261765}, {337,0.05567647}, {338,0.05640196}, {339,0.05725490}, {340,0.05613725}, {341,0.05781373}, {342,0.05760784}, {343,0.06091176}, {344,0.05562745}, {345,0.05910784}, {346,0.05925490}, {347,0.06039216}, {348,0.05908824}, {349,0.06207843}, {350,0.06097059}, {351,0.06307843}, {352,0.05587255}, {353,0.05732353}, {354,0.05730392}, {355,0.06037255}, {356,0.05760784}, {357,0.05998039}, {358,0.06070588}, {359,0.06341176}, {360,0.05808824}, {361,0.06144118}, {362,0.06141176}, {363,0.06329412}, {364,0.06198039}, {365,0.06408824}, {366,0.06338235}, {367,0.06584314}, {368,0.05998039}, {369,0.06254902}, {370,0.06187255}, {371,0.06548039}, {372,0.06281373}, {373,0.06474510}, {374,0.06458824}, {375,0.06787255}, {376,0.06335294}, {377,0.06506863}, {378,0.06618627}, {379,0.06872549}, {380,0.06593137}, {381,0.06792157}, {382,0.06908824}, {383,0.07175490}, {384,0.05933333}, {385,0.06080392}, {386,0.06210784}, {387,0.06467647}, {388,0.06295098}, {389,0.06380392}, {390,0.06483333}, {391,0.06729412}, {392,0.06172549}, {393,0.06548039}, {394,0.06604902}, {395,0.06764706}, {396,0.06465686}, {397,0.06846078}, {398,0.06859804}, {399,0.07054902}, {400,0.06275490}, {401,0.06539216}, {402,0.06686275}, {403,0.06894118}, {404,0.06586275}, {405,0.06850980}, {406,0.06961765}, {407,0.07222549}, {408,0.06707843}, {409,0.06911765}, {410,0.07046078}, {411,0.07306863}, {412,0.07026471}, {413,0.07288235}, {414,0.07222549}, {415,0.07618627}, {416,0.06665686}, {417,0.06875490}, {418,0.06896078}, {419,0.07065686}, {420,0.06948039}, {421,0.07233333}, {422,0.07197059}, {423,0.07484314}, {424,0.06850980}, {425,0.07273529}, {426,0.07294118}, {427,0.07514706}, {428,0.07237255}, {429,0.07602941}, {430,0.07476471}, {431,0.07894118}, {432,0.07117647}, {433,0.07370588}, {434,0.07327451}, {435,0.07665686}, {436,0.07292157}, {437,0.07735294}, {438,0.07749020}, {439,0.08003922}, {440,0.07442157}, {441,0.07685294}, {442,0.07734314}, {443,0.08144118}, {444,0.07687255}, {445,0.08092157}, {446,0.08125490}, {447,0.08379412}, {448,0.07101961}, {449,0.07359804}, {450,0.07375490}, {451,0.07572549}, {452,0.07310784}, {453,0.07762745}, {454,0.07742157}, {455,0.07994118}, {456,0.07441176}, {457,0.07750980}, {458,0.07832353}, {459,0.07978431}, {460,0.07801961}, {461,0.08151961}, {462,0.08134314}, {463,0.08424510}, {464,0.07564706}, {465,0.07831373}, {466,0.07830392}, {467,0.08211765}, {468,0.07811765}, {469,0.08101961}, {470,0.08254902}, {471,0.08615686}, {472,0.08025490}, {473,0.08312745}, {474,0.08295098}, {475,0.08574510}, {476,0.08279412}, {477,0.08561765}, {478,0.08542157}, {479,0.08853922}, {480,0.07743137}, {481,0.08066667}, {482,0.08139216}, {483,0.08523529}, {484,0.08057843}, {485,0.08470588}, {486,0.08569608}, {487,0.08864706}, {488,0.08255882}, {489,0.08584314}, {490,0.08556863}, {491,0.08865686}, {492,0.08548039}, {493,0.08883333}, {494,0.08890196}, {495,0.09223529}, {496,0.08313725}, {497,0.08635294}, {498,0.08640196}, {499,0.08950000}, {500,0.08655882}, {505,0.09011765}, {510,0.09404902}, {515,0.08691176}, {520,0.08444118}, {525,0.09135294}, {530,0.08868627}, {535,0.09701961}, {540,0.09422549}, {545,0.09168627}, {550,0.09611765}, {555,0.10078431}, {560,0.09415686}, {565,0.10252941}, {570,0.10275490}, {575,0.10867647}, {580,0.09690196}, {585,0.10165686}, {590,0.10572549}, {595,0.10710784}, {600,0.10463725}, {605,0.11117647}, {610,0.10461765}, {615,0.11318627}, {620,0.11099020}, {625,0.11050980}, {630,0.11493137}, {635,0.12031373}, {640,0.10354902}, {645,0.11082353}, {650,0.11153922}, {655,0.12103922}, {660,0.11522549}, {665,0.11750000}, {670,0.12284314}, {675,0.12102941}, {680,0.11643137}, {685,0.12550000}, {690,0.12340196}, {695,0.13033333}, {700,0.12792157}, {705,0.11904902}, {710,0.12506863}, {715,0.13032353}, {720,0.12196078}, {725,0.13306863}, {730,0.13134314}, {735,0.14271569}, {740,0.12882353}, {745,0.13576471}, {750,0.13902941}, {755,0.14081373}, {760,0.13662745}, {765,0.14639216}, {770,0.12804902}, {775,0.13742157}, {780,0.13390196}, {785,0.13402941}, {790,0.14032353}, {795,0.14586275}, {800,0.13351961}, {805,0.14279412}, {810,0.14327451}, {815,0.15453922}, {820,0.14370588}, {825,0.15024510}, {830,0.15670588}, {835,0.14681373}, {840,0.14251961}, {845,0.15428431}, {850,0.14858824}, {855,0.15949020}, {860,0.15655882}, {865,0.15194118}, {870,0.15714706}, {875,0.16233333}, {880,0.15380392}, {885,0.16638235}, {890,0.16571569}, {895,0.17737255}, {900,0.15265686}, {905,0.15767647}, {910,0.16504902}, {915,0.16783333}, {920,0.16149020}, {925,0.17287255}, {930,0.16207843}, {935,0.17352941}, {940,0.16807843}, {945,0.16952941}, {950,0.17679412}, {955,0.18266667}, {960,0.16180392}, {965,0.17461765}, {970,0.17629412}, {975,0.18770588}, {980,0.17666667}, {985,0.18307843}, {990,0.19004902}, {995,0.18392157}, {1000,0.17785294}, {1010,0.18502941}, {1020,0.19218627}, {1030,0.17856863}, {1040,0.17380392}, {1050,0.18780392}, {1060,0.18339216}, {1070,0.19851961}, {1080,0.19405882}, {1090,0.18800000}, {1100,0.19528431}, {1110,0.20351961}, {1120,0.19243137}, {1130,0.20884314}, {1140,0.20796078}, {1150,0.22590196}, {1160,0.19914706}, {1170,0.20701961}, {1180,0.21658824}, {1190,0.21715686}, {1200,0.21150980}, {1210,0.22803922}, {1220,0.21529412}, {1230,0.23169608}, {1240,0.22542157}, {1250,0.22528431}, {1260,0.23723529}, {1270,0.24337255}, {1280,0.21125490}, {1290,0.22795098}, {1300,0.23005882}, {1310,0.24768627}, {1320,0.23209804}, {1330,0.24238235}, {1340,0.25199020}, {1350,0.24626471}, {1360,0.23796078}, {1370,0.25631373}, {1380,0.24979412}, {1390,0.26774510}, {1400,0.26239216}, {1410,0.24669608}, {1420,0.25581373}, {1430,0.26459804}, {1440,0.24919608}, {1450,0.26773529}, {1460,0.26911765}, {1470,0.28813725}, {1480,0.26560784}, {1490,0.27559804}, {1500,0.28671569}, {1510,0.28757843}, {1520,0.27867647}, {1530,0.29844118}, {1540,0.26504902}, {1550,0.28396078}, {1560,0.27579412}, {1570,0.27604902}, {1580,0.28609804}, {1590,0.29735294}, {1600,0.27137255}, {1610,0.29204902}, {1620,0.29269608}, {1630,0.31506863}, {1640,0.29582353}, {1650,0.30654902}, {1660,0.31910784}, {1670,0.30239216}, {1680,0.29378431}, {1690,0.31453922}, {1700,0.30440196}, {1710,0.32704902}, {1720,0.31928431}, {1730,0.31100000}, {1740,0.32182353}, {1750,0.33473529}, {1760,0.31519608}, {1770,0.33848039}, {1780,0.33689216}, {1790,0.36417647}, {1800,0.31407843}, {1810,0.32490196}, {1820,0.33635294}, {1830,0.33980392}, {1840,0.33132353}, {1850,0.35433333}, {1860,0.33285294}, {1870,0.35573529}, {1880,0.34574510}, {1890,0.34708824}, {1900,0.36040196}, {1910,0.37381373}, {1920,0.33126471}, {1930,0.35455882}, {1940,0.35447059}, {1950,0.38033333}, {1960,0.36302941}, {1970,0.37400980}, {1980,0.38814706}, {1990,0.37842157}, {2000,0.36640196}, {2050,0.35583333}, {2100,0.38678431}, {2150,0.40810784}, {2200,0.40623529}, {2250,0.42478431}, {2300,0.45907843}, {2350,0.45803922}, {2400,0.43621569}, {2450,0.45979412}, {2500,0.46693137}, {2550,0.51685294}, {2600,0.47349020}, {2650,0.51219608}, {2700,0.50268627}, {2750,0.56315686}, {2800,0.53297059}, {2850,0.52898039}, {2900,0.55679412}, {2950,0.56390196}, {3000,0.58907843}, {3050,0.61446078}, {3100,0.58409804}, {3150,0.61454902}, {3200,0.56320588}, {3250,0.62933333}, {3300,0.63900980}, {3350,0.64221569}, {3400,0.63507843}, {3450,0.70471569}, {3500,0.69348039}, {3550,0.74182353}, {3600,0.65023529}, {3650,0.68143137}, {3700,0.73148039}, {3750,0.74252941}, {3800,0.75209804}, {3850,0.73602941}, {3900,0.79176471}, {3950,0.82280392}, {4000,0.75858824}, {4050,0.81654902}, {4100,0.72888235}, {4150,0.81368627}, {4200,0.79774510}, {4250,0.83989216}, {4300,0.84394118}, {4350,0.92946078}, {4400,0.83585294}, {4450,0.87227451}, {4500,0.87970588}, {4550,0.91302941}, {4600,0.95098039}, {4650,0.90743137}, {4700,0.94570588}, {4750,0.95800000}, {4800,0.90226471}, {4850,1.00596078}, {4900,0.95050000}, {4950,1.02075490}, {5000,0.96848039}, {5050,1.06845098}, {5100,1.07817647}, {5150,1.03958824}, {5200,0.98866667}, {5250,0.99683333}, {5300,1.06903922}, {5350,1.10787255}, {5400,1.06208824}, {5450,1.10056863}, {5500,1.16973529}, {5550,1.17812745}, {5600,1.12349020}, {5650,1.09863725}, {5700,1.11479412}, {5750,1.22524510}, {5800,1.15726471}, {5850,1.23150000}, {5900,1.18464706}, {5950,1.30274510}, {6000,1.22048039}, {6050,1.31450}, {6100,1.32975}, {6150,1.21225}, {6200,1.25425}, {6250,1.29925}, {6300,1.30625}, {6350,1.35975}, {6400,1.19850}, {6450,1.32950}, {6500,1.33950}, {6550,1.39400}, {6600,1.36825}, {6650,1.50400}, {6700,1.38325}, {6750,1.48000}, {6800,1.36125}, {6850,1.41150}, {6900,1.54300}, {6950,1.48725}, {7000,1.52900}, {7050,1.49950}, {7100,1.60025}, {7150,1.64475}, {7200,1.38700}, {7250,1.51150}, {7300,1.45150}, {7350,1.59600}, {7400,1.56000}, {7450,1.56850}, {7500,1.57300}, {7550,1.73100}, {7600,1.58425}, {7650,1.64725}, {7700,1.56550}, {7750,1.62650}, {7800,1.68375}, {7850,1.69475}, {7900,1.76725}, {7950,1.71825}, {8000,1.62200}, {8050,1.77300}, {8100,1.72975}, {8150,1.85175}, {8200,1.55800}, {8250,1.73250}, {8300,1.72975}, {8350,1.78925}, {8400,1.69775}, {8450,1.65600}, {8500,1.75325}, {8550,1.82350}, {8600,1.77000}, {8650,1.83400}, {8700,1.95125}, {8750,1.85950}, {8800,1.74600}, {8850,1.81775}, {8900,1.83050}, {8950,2.01000}, {9000,1.83950}, {9050,1.98200}, {9100,1.91750}, {9150,2.09525}, {9200,1.99075}, {9250,1.83100}, {9300,1.91650}, {9350,1.92650}, {9400,1.99625}, {9450,2.05650}, {9500,2.01875}, {9550,2.08325}, {9600,1.89425}, {9650,2.09375}, {9700,2.08900}, {9750,2.06650}, {9800,2.01150}, {9850,2.19675}, {9900,2.13575}, {9950,2.26475}, {10000,2.04275}, {10100,2.26275}, {10200,2.27225}, {10300,2.19025}, {10400,2.07000}, {10500,2.08825}, {10600,2.26900}, {10700,2.33200}, {10800,2.22025}, {10900,2.28650}, {11000,2.45275}, {11100,2.48425}, {11200,2.33950}, {11300,2.29100}, {11400,2.31200}, {11500,2.54175}, {11600,2.42950}, {11700,2.59300}, {11800,2.46350}, {11900,2.70125}, {12000,2.56550}, {12100,2.58375}, {12200,2.68350}, {12300,2.43800}, {12400,2.54550}, {12500,2.64750}, {12600,2.66250}, {12700,2.76800}, {12800,2.44475}, {12900,2.71300}, {13000,2.73650}, {13100,2.87200}, {13200,2.77675}, {13300,3.07575}, {13400,2.84250}, {13500,3.01825}, {13600,2.76525}, {13700,2.89250}, {13800,3.10325}, {13900,3.00850}, {14000,3.03875}, {14100,3.04500}, {14200,3.23825}, {14300,3.36050}, {14400,2.86025}, {14500,3.05900}, {14600,2.97775}, {14700,3.29050}, {14800,3.20925}, {14900,3.22375}, {15000,3.23700}, {15100,3.56800}, {15200,3.28600}, {15300,3.40575}, {15400,3.23025}, {15500,3.34775}, {15600,3.45850}, {15700,3.49500}, {15800,3.60550}, {15900,3.52850}, {16000,3.33575}, {16100,3.63825}, {16200,3.59450}, {16300,3.79500}, {16400,3.23650}, {16500,3.54625}, {16600,3.59025}, {16700,3.72400}, {16800,3.51125}, {16900,3.41650}, {17000,3.65050}, {17100,3.79200}, {17200,3.67800}, {17300,3.80500}, {17400,4.09300}, {17500,3.89175}, {17600,3.66125}, {17700,3.79425}, {17800,3.82025}, {17900,4.17925}, {18000,3.85300}, {18100,4.10400}, {18200,3.99025}, {18300,4.39700}, {18400,4.14650}, {18500,3.82575}, {18600,3.95875}, {18700,3.98400}, {18800,4.13975}, {18900,4.28400}, {19000,4.19950}, {19100,4.35275}, {19200,3.94775}, {19300,4.35975}, {19400,4.37250}, {19500,4.26175}, {19600,4.15225}, {19700,4.55500}, {19800,4.44650}, {19900,4.73025}, {20000,4.22950}};
data["big_flat"]["Ltac2"]["norm reif"]["user"] = {{1,0.00046078}, {2,0.00060784}, {3,0.00066667}, {4,0.00081373}, {5,0.00084314}, {6,0.00113725}, {7,0.00090196}, {8,0.00111765}, {9,0.00097059}, {10,0.00137255}, {11,0.00193137}, {12,0.00154902}, {13,0.00150980}, {14,0.00189216}, {15,0.00210784}, {16,0.00213725}, {17,0.00234314}, {18,0.00250000}, {19,0.00269608}, {20,0.00256863}, {21,0.00287255}, {22,0.01350000}, {23,0.00305882}, {24,0.00280392}, {25,0.00331373}, {26,0.00327451}, {27,0.00359804}, {28,0.00345098}, {29,0.00399020}, {30,0.00415686}, {31,0.00463725}, {32,0.00430392}, {33,0.00448039}, {34,0.00455882}, {35,0.00498039}, {36,0.00469608}, {37,0.00503922}, {38,0.00546078}, {39,0.00695098}, {40,0.00571569}, {41,0.00587255}, {42,0.00589216}, {43,0.00620588}, {44,0.00617647}, {45,0.00666667}, {46,0.00657843}, {47,0.00721569}, {48,0.00666667}, {49,0.00676471}, {50,0.00712745}, {51,0.00752941}, {52,0.00806863}, {53,0.00774510}, {54,0.00815686}, {55,0.00853922}, {56,0.00778431}, {57,0.00850980}, {58,0.00830392}, {59,0.00911765}, {60,0.00886275}, {61,0.01014706}, {62,0.00912745}, {63,0.00971569}, {64,0.00883333}, {65,0.00949020}, {66,0.00958824}, {67,0.01029412}, {68,0.00965686}, {69,0.01027451}, {70,0.01140196}, {71,0.01137255}, {72,0.01039216}, {73,0.01074510}, {74,0.01110784}, {75,0.01188235}, {76,0.01164706}, {77,0.01214706}, {78,0.01214706}, {79,0.01240196}, {80,0.01158824}, {81,0.01219608}, {82,0.01237255}, {83,0.01278431}, {84,0.01302941}, {85,0.01295098}, {86,0.01331373}, {87,0.01363725}, {88,0.01265686}, {89,0.01334314}, {90,0.01353922}, {91,0.01470588}, {92,0.01377451}, {93,0.01427451}, {94,0.01454902}, {95,0.01525490}, {96,0.01380392}, {97,0.01469608}, {98,0.01439216}, {99,0.01462745}, {100,0.01461765}, {101,0.01509804}, {102,0.01593137}, {103,0.01600000}, {104,0.01492157}, {105,0.01554902}, {106,0.01561765}, {107,0.01650000}, {108,0.01669608}, {109,0.01661765}, {110,0.01700980}, {111,0.01803922}, {112,0.01617647}, {113,0.01760784}, {114,0.01697059}, {115,0.01762745}, {116,0.01696078}, {117,0.01908824}, {118,0.01835294}, {119,0.01925490}, {120,0.01790196}, {121,0.01853922}, {122,0.01983333}, {123,0.01937255}, {124,0.01897059}, {125,0.02008824}, {126,0.02049020}, {127,0.02099020}, {128,0.01779412}, {129,0.01903922}, {130,0.01927451}, {131,0.02103922}, {132,0.01967647}, {133,0.02051961}, {134,0.02062745}, {135,0.02267647}, {136,0.01991176}, {137,0.02114706}, {138,0.02140196}, {139,0.02328431}, {140,0.02120588}, {141,0.02228431}, {142,0.02291176}, {143,0.02450980}, {144,0.02135294}, {145,0.02252941}, {146,0.02270588}, {147,0.02434314}, {148,0.02262745}, {149,0.02395098}, {150,0.02511765}, {151,0.02478431}, {152,0.02325490}, {153,0.02414706}, {154,0.02502941}, {155,0.02525490}, {156,0.02443137}, {157,0.02622549}, {158,0.02583333}, {159,0.02651961}, {160,0.02359804}, {161,0.02537255}, {162,0.02457843}, {163,0.02575490}, {164,0.02559804}, {165,0.02605882}, {166,0.02618627}, {167,0.02709804}, {168,0.02557843}, {169,0.02641176}, {170,0.02656863}, {171,0.02822549}, {172,0.02667647}, {173,0.02809804}, {174,0.02896078}, {175,0.02922549}, {176,0.02631373}, {177,0.02846078}, {178,0.02738235}, {179,0.02900000}, {180,0.02903922}, {181,0.02946078}, {182,0.02917647}, {183,0.03130392}, {184,0.02818627}, {185,0.03008824}, {186,0.03093137}, {187,0.03129412}, {188,0.02969608}, {189,0.03252941}, {190,0.03161765}, {191,0.03372549}, {192,0.02774510}, {193,0.02908824}, {194,0.03045098}, {195,0.03080392}, {196,0.02966667}, {197,0.03196078}, {198,0.03122549}, {199,0.03289216}, {200,0.03104902}, {201,0.03165686}, {202,0.03195098}, {203,0.03421569}, {204,0.03199020}, {205,0.03460784}, {206,0.03395098}, {207,0.03516667}, {208,0.03252941}, {209,0.03301961}, {210,0.03303922}, {211,0.03548039}, {212,0.03331373}, {213,0.03567647}, {214,0.03503922}, {215,0.03646078}, {216,0.03463725}, {217,0.03581373}, {218,0.03644118}, {219,0.03685294}, {220,0.03582353}, {221,0.03699020}, {222,0.03718627}, {223,0.03909804}, {224,0.03425490}, {225,0.03609804}, {226,0.03560784}, {227,0.03713725}, {228,0.03664706}, {229,0.03714706}, {230,0.03829412}, {231,0.03851961}, {232,0.03685294}, {233,0.03766667}, {234,0.03780392}, {235,0.04026471}, {236,0.03788235}, {237,0.04016667}, {238,0.03942157}, {239,0.04189216}, {240,0.03710784}, {241,0.03940196}, {242,0.03884314}, {243,0.04053922}, {244,0.03979412}, {245,0.04088235}, {246,0.04171569}, {247,0.04246078}, {248,0.04032353}, {249,0.04083333}, {250,0.04189216}, {251,0.04321569}, {252,0.04252941}, {253,0.04295098}, {254,0.04409804}, {255,0.04521569}, {256,0.03869608}, {257,0.03941176}, {258,0.04058824}, {259,0.04168627}, {260,0.03975490}, {261,0.04167647}, {262,0.04174510}, {263,0.04484314}, {264,0.04010784}, {265,0.04371569}, {266,0.04225490}, {267,0.04588235}, {268,0.04224510}, {269,0.04593137}, {270,0.04476471}, {271,0.04808824}, {272,0.04141176}, {273,0.04476471}, {274,0.04359804}, {275,0.04679412}, {276,0.04383333}, {277,0.04716667}, {278,0.04610784}, {279,0.04813725}, {280,0.04517647}, {281,0.04666667}, {282,0.04705882}, {283,0.04862745}, {284,0.04755882}, {285,0.04862745}, {286,0.04933333}, {287,0.05045098}, {288,0.04486275}, {289,0.04618627}, {290,0.04729412}, {291,0.04803922}, {292,0.04627451}, {293,0.04920588}, {294,0.04856863}, {295,0.05068627}, {296,0.04652941}, {297,0.04987255}, {298,0.04865686}, {299,0.05153922}, {300,0.04925490}, {301,0.05079412}, {302,0.05134314}, {303,0.05311765}, {304,0.04881373}, {305,0.04979412}, {306,0.05082353}, {307,0.05261765}, {308,0.05029412}, {309,0.05270588}, {310,0.05200980}, {311,0.05544118}, {312,0.05173529}, {313,0.05269608}, {314,0.05322549}, {315,0.05526471}, {316,0.05356863}, {317,0.05638235}, {318,0.05512745}, {319,0.05869608}, {320,0.04850000}, {321,0.05152941}, {322,0.05154902}, {323,0.05310784}, {324,0.05155882}, {325,0.05296078}, {326,0.05426471}, {327,0.05640196}, {328,0.05136275}, {329,0.05446078}, {330,0.05365686}, {331,0.05720588}, {332,0.05529412}, {333,0.05655882}, {334,0.05778431}, {335,0.05971569}, {336,0.05215686}, {337,0.05601961}, {338,0.05649020}, {339,0.05686275}, {340,0.05636275}, {341,0.05787255}, {342,0.05776471}, {343,0.06098039}, {344,0.05562745}, {345,0.05906863}, {346,0.05937255}, {347,0.06041176}, {348,0.05916667}, {349,0.06213725}, {350,0.06103922}, {351,0.06295098}, {352,0.05606863}, {353,0.05750000}, {354,0.05753922}, {355,0.06047059}, {356,0.05795098}, {357,0.06005882}, {358,0.06090196}, {359,0.06326471}, {360,0.05863725}, {361,0.06120588}, {362,0.06140196}, {363,0.06302941}, {364,0.06170588}, {365,0.06409804}, {366,0.06287255}, {367,0.06557843}, {368,0.05998039}, {369,0.06220588}, {370,0.06210784}, {371,0.06505882}, {372,0.06275490}, {373,0.06453922}, {374,0.06389216}, {375,0.06761765}, {376,0.06305882}, {377,0.06495098}, {378,0.06560784}, {379,0.06869608}, {380,0.06544118}, {381,0.06785294}, {382,0.06928431}, {383,0.07214706}, {384,0.05957843}, {385,0.06102941}, {386,0.06201961}, {387,0.06450000}, {388,0.06281373}, {389,0.06368627}, {390,0.06475490}, {391,0.06734314}, {392,0.06166667}, {393,0.06534314}, {394,0.06594118}, {395,0.06755882}, {396,0.06448039}, {397,0.06848039}, {398,0.06888235}, {399,0.07065686}, {400,0.06241176}, {401,0.06538235}, {402,0.06688235}, {403,0.06867647}, {404,0.06594118}, {405,0.06844118}, {406,0.06977451}, {407,0.07235294}, {408,0.06683333}, {409,0.06905882}, {410,0.07086275}, {411,0.07329412}, {412,0.07025490}, {413,0.07304902}, {414,0.07258824}, {415,0.07584314}, {416,0.06642157}, {417,0.06866667}, {418,0.06914706}, {419,0.07110784}, {420,0.06929412}, {421,0.07225490}, {422,0.07219608}, {423,0.07477451}, {424,0.06875490}, {425,0.07276471}, {426,0.07297059}, {427,0.07483333}, {428,0.07254902}, {429,0.07581373}, {430,0.07464706}, {431,0.07894118}, {432,0.07153922}, {433,0.07378431}, {434,0.07333333}, {435,0.07640196}, {436,0.07293137}, {437,0.07702941}, {438,0.07745098}, {439,0.08014706}, {440,0.07430392}, {441,0.07606863}, {442,0.07689216}, {443,0.08124510}, {444,0.07654902}, {445,0.08084314}, {446,0.08093137}, {447,0.08399020}, {448,0.07105882}, {449,0.07338235}, {450,0.07363725}, {451,0.07545098}, {452,0.07342157}, {453,0.07751961}, {454,0.07695098}, {455,0.07994118}, {456,0.07399020}, {457,0.07705882}, {458,0.07810784}, {459,0.08000980}, {460,0.07795098}, {461,0.08199020}, {462,0.08139216}, {463,0.08444118}, {464,0.07524510}, {465,0.07808824}, {466,0.07825490}, {467,0.08172549}, {468,0.07783333}, {469,0.08111765}, {470,0.08235294}, {471,0.08582353}, {472,0.08046078}, {473,0.08339216}, {474,0.08298039}, {475,0.08582353}, {476,0.08320588}, {477,0.08579412}, {478,0.08541176}, {479,0.08828431}, {480,0.07717647}, {481,0.08082353}, {482,0.08117647}, {483,0.08515686}, {484,0.08053922}, {485,0.08481373}, {486,0.08604902}, {487,0.08847059}, {488,0.08251961}, {489,0.08550000}, {490,0.08565686}, {491,0.08853922}, {492,0.08547059}, {493,0.08830392}, {494,0.08853922}, {495,0.09206863}, {496,0.08364706}, {497,0.08629412}, {498,0.08621569}, {499,0.08926471}, {500,0.08654902}, {505,0.09021569}, {510,0.09421569}, {515,0.08652941}, {520,0.08419608}, {525,0.09158824}, {530,0.08846078}, {535,0.09693137}, {540,0.09419608}, {545,0.09164706}, {550,0.09627451}, {555,0.10050980}, {560,0.09432353}, {565,0.10244118}, {570,0.10282353}, {575,0.10909804}, {580,0.09676471}, {585,0.10143137}, {590,0.10576471}, {595,0.10699020}, {600,0.10425490}, {605,0.11090196}, {610,0.10485294}, {615,0.11301961}, {620,0.11066667}, {625,0.11021569}, {630,0.11469608}, {635,0.12030392}, {640,0.10366667}, {645,0.11044118}, {650,0.11120588}, {655,0.12105882}, {660,0.11540196}, {665,0.11723529}, {670,0.12259804}, {675,0.12075490}, {680,0.11607843}, {685,0.12525490}, {690,0.12315686}, {695,0.13027451}, {700,0.12772549}, {705,0.11921569}, {710,0.12482353}, {715,0.13025490}, {720,0.12190196}, {725,0.13295098}, {730,0.13103922}, {735,0.14295098}, {740,0.12844118}, {745,0.13540196}, {750,0.13882353}, {755,0.14055882}, {760,0.13635294}, {765,0.14598039}, {770,0.12790196}, {775,0.13707843}, {780,0.13392157}, {785,0.13392157}, {790,0.14020588}, {795,0.14564706}, {800,0.13322549}, {805,0.14272549}, {810,0.14306863}, {815,0.15439216}, {820,0.14358824}, {825,0.14962745}, {830,0.15623529}, {835,0.14654902}, {840,0.14243137}, {845,0.15426471}, {850,0.14845098}, {855,0.15932353}, {860,0.15629412}, {865,0.15124510}, {870,0.15700000}, {875,0.16210784}, {880,0.15376471}, {885,0.16616667}, {890,0.16568627}, {895,0.17744118}, {900,0.15246078}, {905,0.15749020}, {910,0.16505882}, {915,0.16747059}, {920,0.16078431}, {925,0.17211765}, {930,0.16185294}, {935,0.17350000}, {940,0.16792157}, {945,0.16917647}, {950,0.17649020}, {955,0.18228431}, {960,0.16112745}, {965,0.17389216}, {970,0.17569608}, {975,0.18719608}, {980,0.17628431}, {985,0.18287255}, {990,0.18948039}, {995,0.18351961}, {1000,0.17779412}, {1010,0.18440196}, {1020,0.19195098}, {1030,0.17861765}, {1040,0.17308824}, {1050,0.18764706}, {1060,0.18310784}, {1070,0.19808824}, {1080,0.19354902}, {1090,0.18756863}, {1100,0.19447059}, {1110,0.20367647}, {1120,0.19213725}, {1130,0.20821569}, {1140,0.20752941}, {1150,0.22563725}, {1160,0.19854902}, {1170,0.20661765}, {1180,0.21646078}, {1190,0.21694118}, {1200,0.21093137}, {1210,0.22792157}, {1220,0.21498039}, {1230,0.23120588}, {1240,0.22512745}, {1250,0.22477451}, {1260,0.23690196}, {1270,0.24280392}, {1280,0.21087255}, {1290,0.22739216}, {1300,0.22955882}, {1310,0.24746078}, {1320,0.23147059}, {1330,0.24202941}, {1340,0.25189216}, {1350,0.24571569}, {1360,0.23752941}, {1370,0.25635294}, {1380,0.24967647}, {1390,0.26782353}, {1400,0.26186275}, {1410,0.24642157}, {1420,0.25563725}, {1430,0.26458824}, {1440,0.24921569}, {1450,0.26778431}, {1460,0.26910784}, {1470,0.28783333}, {1480,0.26558824}, {1490,0.27529412}, {1500,0.28664706}, {1510,0.28731373}, {1520,0.27864706}, {1530,0.29831373}, {1540,0.26458824}, {1550,0.28395098}, {1560,0.27552941}, {1570,0.27616667}, {1580,0.28574510}, {1590,0.29713725}, {1600,0.27134314}, {1610,0.29166667}, {1620,0.29240196}, {1630,0.31492157}, {1640,0.29564706}, {1650,0.30637255}, {1660,0.31904902}, {1670,0.30218627}, {1680,0.29340196}, {1690,0.31430392}, {1700,0.30433333}, {1710,0.32677451}, {1720,0.31885294}, {1730,0.31090196}, {1740,0.32161765}, {1750,0.33457843}, {1760,0.31498039}, {1770,0.33820588}, {1780,0.33670588}, {1790,0.36377451}, {1800,0.31399020}, {1810,0.32468627}, {1820,0.33600000}, {1830,0.33940196}, {1840,0.33085294}, {1850,0.35405882}, {1860,0.33253922}, {1870,0.35522549}, {1880,0.34525490}, {1890,0.34668627}, {1900,0.36002941}, {1910,0.37347059}, {1920,0.33095098}, {1930,0.35412745}, {1940,0.35417647}, {1950,0.37977451}, {1960,0.36262745}, {1970,0.37354902}, {1980,0.38776471}, {1990,0.37805882}, {2000,0.36595098}, {2050,0.35550980}, {2100,0.38645098}, {2150,0.40783333}, {2200,0.40572549}, {2250,0.42426471}, {2300,0.45841176}, {2350,0.45735294}, {2400,0.43579412}, {2450,0.45926471}, {2500,0.46624510}, {2550,0.51645098}, {2600,0.47256863}, {2650,0.51192157}, {2700,0.50213725}, {2750,0.56260784}, {2800,0.53240196}, {2850,0.52841176}, {2900,0.55638235}, {2950,0.56303922}, {3000,0.58811765}, {3050,0.61383333}, {3100,0.58338235}, {3150,0.61376471}, {3200,0.56273529}, {3250,0.62842157}, {3300,0.63830392}, {3350,0.64166667}, {3400,0.63440196}, {3450,0.70401961}, {3500,0.69278431}, {3550,0.74063725}, {3600,0.64921569}, {3650,0.68092157}, {3700,0.73103922}, {3750,0.74151961}, {3800,0.75113725}, {3850,0.73502941}, {3900,0.79090196}, {3950,0.82212745}, {4000,0.75748039}, {4050,0.81560784}, {4100,0.72778431}, {4150,0.81263725}, {4200,0.79682353}, {4250,0.83909804}, {4300,0.84285294}, {4350,0.92863725}, {4400,0.83521569}, {4450,0.87157843}, {4500,0.87854902}, {4550,0.91222549}, {4600,0.94981373}, {4650,0.90627451}, {4700,0.94450000}, {4750,0.95677451}, {4800,0.90128431}, {4850,1.00450980}, {4900,0.94932353}, {4950,1.01969608}, {5000,0.96718627}, {5050,1.06717647}, {5100,1.07692157}, {5150,1.03845098}, {5200,0.98764706}, {5250,0.99587255}, {5300,1.06818627}, {5350,1.10672549}, {5400,1.06068627}, {5450,1.09957843}, {5500,1.16809804}, {5550,1.17664706}, {5600,1.12235294}, {5650,1.09746078}, {5700,1.11320588}, {5750,1.22399020}, {5800,1.15562745}, {5850,1.22992157}, {5900,1.18312745}, {5950,1.30089216}, {6000,1.21906863}, {6050,1.30550}, {6100,1.32450}, {6150,1.20950}, {6200,1.25325}, {6250,1.29900}, {6300,1.30550}, {6350,1.35975}, {6400,1.19725}, {6450,1.32875}, {6500,1.33850}, {6550,1.39200}, {6600,1.35950}, {6650,1.50050}, {6700,1.37700}, {6750,1.47500}, {6800,1.35475}, {6850,1.40325}, {6900,1.50325}, {6950,1.47225}, {7000,1.47625}, {7050,1.48950}, {7100,1.58975}, {7150,1.63950}, {7200,1.37750}, {7250,1.48350}, {7300,1.44975}, {7350,1.59475}, {7400,1.56000}, {7450,1.56875}, {7500,1.57175}, {7550,1.73075}, {7600,1.58550}, {7650,1.64675}, {7700,1.56500}, {7750,1.62650}, {7800,1.68450}, {7850,1.69475}, {7900,1.76775}, {7950,1.71850}, {8000,1.62275}, {8050,1.77350}, {8100,1.72950}, {8150,1.85200}, {8200,1.55850}, {8250,1.73250}, {8300,1.72900}, {8350,1.78825}, {8400,1.69925}, {8450,1.65525}, {8500,1.75275}, {8550,1.82350}, {8600,1.77025}, {8650,1.83225}, {8700,1.95125}, {8750,1.85875}, {8800,1.74575}, {8850,1.81625}, {8900,1.83050}, {8950,2.01100}, {9000,1.83950}, {9050,1.98125}, {9100,1.91775}, {9150,2.09475}, {9200,1.99025}, {9250,1.83050}, {9300,1.91550}, {9350,1.92675}, {9400,1.99775}, {9450,2.05550}, {9500,2.02000}, {9550,2.08375}, {9600,1.89550}, {9650,2.09350}, {9700,2.08825}, {9750,2.06675}, {9800,2.01125}, {9850,2.19650}, {9900,2.13600}, {9950,2.26450}, {10000,2.03750}, {10100,2.24550}, {10200,2.26750}, {10300,2.18325}, {10400,2.06450}, {10500,2.08650}, {10600,2.23700}, {10700,2.32500}, {10800,2.21725}, {10900,2.28225}, {11000,2.44850}, {11100,2.48150}, {11200,2.33550}, {11300,2.28750}, {11400,2.30875}, {11500,2.53650}, {11600,2.42525}, {11700,2.59000}, {11800,2.45925}, {11900,2.69650}, {12000,2.56275}, {12100,2.58150}, {12200,2.68075}, {12300,2.43450}, {12400,2.54400}, {12500,2.64575}, {12600,2.65825}, {12700,2.76575}, {12800,2.44125}, {12900,2.70950}, {13000,2.73375}, {13100,2.86850}, {13200,2.77375}, {13300,3.07075}, {13400,2.83950}, {13500,3.01425}, {13600,2.76100}, {13700,2.89050}, {13800,3.09850}, {13900,3.00225}, {14000,3.03525}, {14100,3.04100}, {14200,3.23575}, {14300,3.35650}, {14400,2.85725}, {14500,3.05550}, {14600,2.97500}, {14700,3.28750}, {14800,3.20425}, {14900,3.22050}, {15000,3.23275}, {15100,3.56450}, {15200,3.28000}, {15300,3.40250}, {15400,3.22450}, {15500,3.34350}, {15600,3.45325}, {15700,3.49125}, {15800,3.60250}, {15900,3.52550}, {16000,3.33325}, {16100,3.63275}, {16200,3.59050}, {16300,3.79075}, {16400,3.23125}, {16500,3.54175}, {16600,3.58600}, {16700,3.72025}, {16800,3.50775}, {16900,3.41375}, {17000,3.64550}, {17100,3.78675}, {17200,3.67475}, {17300,3.80000}, {17400,4.08825}, {17500,3.88625}, {17600,3.65525}, {17700,3.78875}, {17800,3.81600}, {17900,4.17225}, {18000,3.84825}, {18100,4.09875}, {18200,3.98550}, {18300,4.39050}, {18400,4.14050}, {18500,3.82150}, {18600,3.95425}, {18700,3.97925}, {18800,4.13525}, {18900,4.27750}, {19000,4.19325}, {19100,4.34825}, {19200,3.94525}, {19300,4.35400}, {19400,4.36775}, {19500,4.25650}, {19600,4.14850}, {19700,4.54950}, {19800,4.44025}, {19900,4.72450}, {20000,4.22450}};
data["big_flat"]["Ltac2"]["norm reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00003922}, {5,0.00010784}, {6,0.00003922}, {7,0.00000000}, {8,0.00003922}, {9,0.00007843}, {10,0.00003922}, {11,0.00000000}, {12,0.00000000}, {13,0.00003922}, {14,0.00000000}, {15,0.00007843}, {16,0.00003922}, {17,0.00007843}, {18,0.00002941}, {19,0.00003922}, {20,0.00000000}, {21,0.00007843}, {22,0.00000000}, {23,0.00003922}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00003922}, {30,0.00007843}, {31,0.00002941}, {32,0.00003922}, {33,0.00003922}, {34,0.00000000}, {35,0.00003922}, {36,0.00003922}, {37,0.00000000}, {38,0.00000000}, {39,0.00003922}, {40,0.00003922}, {41,0.00011765}, {42,0.00000000}, {43,0.00007843}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00015686}, {48,0.00003922}, {49,0.00003922}, {50,0.00000000}, {51,0.00003922}, {52,0.00000000}, {53,0.00007843}, {54,0.00000000}, {55,0.00003922}, {56,0.00003922}, {57,0.00003922}, {58,0.00006863}, {59,0.00000000}, {60,0.00003922}, {61,0.00003922}, {62,0.00003922}, {63,0.00003922}, {64,0.00000000}, {65,0.00000000}, {66,0.00019608}, {67,0.00003922}, {68,0.00007843}, {69,0.00003922}, {70,0.00000000}, {71,0.00003922}, {72,0.00000000}, {73,0.00000000}, {74,0.00007843}, {75,0.00000000}, {76,0.00000000}, {77,0.00003922}, {78,0.00000000}, {79,0.00000000}, {80,0.00002941}, {81,0.00003922}, {82,0.00000000}, {83,0.00000000}, {84,0.00003922}, {85,0.00003922}, {86,0.00000000}, {87,0.00003922}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00003922}, {92,0.00000000}, {93,0.00003922}, {94,0.00010784}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00007843}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00007843}, {103,0.00007843}, {104,0.00000000}, {105,0.00003922}, {106,0.00003922}, {107,0.00003922}, {108,0.00000000}, {109,0.00007843}, {110,0.00007843}, {111,0.00003922}, {112,0.00000000}, {113,0.00003922}, {114,0.00003922}, {115,0.00007843}, {116,0.00000000}, {117,0.00000000}, {118,0.00002941}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00019608}, {124,0.00003922}, {125,0.00003922}, {126,0.00003922}, {127,0.00000000}, {128,0.00000000}, {129,0.00015686}, {130,0.00000000}, {131,0.00000000}, {132,0.00003922}, {133,0.00007843}, {134,0.00000000}, {135,0.00003922}, {136,0.00007843}, {137,0.00000000}, {138,0.00003922}, {139,0.00000000}, {140,0.00007843}, {141,0.00000000}, {142,0.00003922}, {143,0.00000000}, {144,0.00003922}, {145,0.00000000}, {146,0.00000000}, {147,0.00003922}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00006863}, {153,0.00003922}, {154,0.00000000}, {155,0.00003922}, {156,0.00000000}, {157,0.00007843}, {158,0.00002941}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00007843}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00011765}, {173,0.00003922}, {174,0.00003922}, {175,0.00000000}, {176,0.00003922}, {177,0.00000000}, {178,0.00011765}, {179,0.00000000}, {180,0.00002941}, {181,0.00000000}, {182,0.00000000}, {183,0.00003922}, {184,0.00015686}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00003922}, {191,0.00003922}, {192,0.00000000}, {193,0.00000000}, {194,0.00003922}, {195,0.00007843}, {196,0.00000000}, {197,0.00007843}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00003922}, {202,0.00000000}, {203,0.00000000}, {204,0.00003922}, {205,0.00000000}, {206,0.00007843}, {207,0.00000000}, {208,0.00003922}, {209,0.00000000}, {210,0.00000000}, {211,0.00007843}, {212,0.00000000}, {213,0.00003922}, {214,0.00003922}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00003922}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00003922}, {226,0.00003922}, {227,0.00000000}, {228,0.00000000}, {229,0.00002941}, {230,0.00000000}, {231,0.00003922}, {232,0.00000000}, {233,0.00000000}, {234,0.00002941}, {235,0.00003922}, {236,0.00000000}, {237,0.00003922}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00007843}, {243,0.00003922}, {244,0.00000000}, {245,0.00003922}, {246,0.00003922}, {247,0.00003922}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00007843}, {252,0.00000000}, {253,0.00003922}, {254,0.00000000}, {255,0.00000000}, {256,0.00003922}, {257,0.00000000}, {258,0.00003922}, {259,0.00000000}, {260,0.00003922}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003922}, {266,0.00000000}, {267,0.00003922}, {268,0.00000000}, {269,0.00000000}, {270,0.00006863}, {271,0.00000000}, {272,0.00003922}, {273,0.00000000}, {274,0.00007843}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00003922}, {279,0.00003922}, {280,0.00003922}, {281,0.00003922}, {282,0.00007843}, {283,0.00003922}, {284,0.00002941}, {285,0.00003922}, {286,0.00003922}, {287,0.00003922}, {288,0.00000000}, {289,0.00000000}, {290,0.00003922}, {291,0.00000000}, {292,0.00000000}, {293,0.00003922}, {294,0.00000000}, {295,0.00003922}, {296,0.00003922}, {297,0.00000000}, {298,0.00000000}, {299,0.00003922}, {300,0.00003922}, {301,0.00000000}, {302,0.00000000}, {303,0.00003922}, {304,0.00000000}, {305,0.00003922}, {306,0.00007843}, {307,0.00000000}, {308,0.00011765}, {309,0.00003922}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00003922}, {316,0.00011765}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00003922}, {322,0.00003922}, {323,0.00000000}, {324,0.00003922}, {325,0.00007843}, {326,0.00000000}, {327,0.00000000}, {328,0.00003922}, {329,0.00000000}, {330,0.00000000}, {331,0.00003922}, {332,0.00003922}, {333,0.00000000}, {334,0.00002941}, {335,0.00000000}, {336,0.00003922}, {337,0.00000000}, {338,0.00003922}, {339,0.00003922}, {340,0.00003922}, {341,0.00000000}, {342,0.00000000}, {343,0.00003922}, {344,0.00007843}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00003922}, {353,0.00000000}, {354,0.00000000}, {355,0.00003922}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00003922}, {364,0.00000000}, {365,0.00000000}, {366,0.00007843}, {367,0.00003922}, {368,0.00003922}, {369,0.00003922}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00003922}, {374,0.00003922}, {375,0.00003922}, {376,0.00003922}, {377,0.00003922}, {378,0.00003922}, {379,0.00003922}, {380,0.00000000}, {381,0.00000000}, {382,0.00007843}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00003922}, {388,0.00000000}, {389,0.00007843}, {390,0.00000000}, {391,0.00003922}, {392,0.00007843}, {393,0.00003922}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00003922}, {399,0.00000000}, {400,0.00011765}, {401,0.00003922}, {402,0.00007843}, {403,0.00000000}, {404,0.00003922}, {405,0.00003922}, {406,0.00000000}, {407,0.00000000}, {408,0.00007843}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00007843}, {415,0.00003922}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00003922}, {420,0.00003922}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00003922}, {426,0.00000000}, {427,0.00003922}, {428,0.00000000}, {429,0.00007843}, {430,0.00003922}, {431,0.00015686}, {432,0.00000000}, {433,0.00003922}, {434,0.00007843}, {435,0.00003922}, {436,0.00003922}, {437,0.00007843}, {438,0.00003922}, {439,0.00000000}, {440,0.00003922}, {441,0.00007843}, {442,0.00010784}, {443,0.00006863}, {444,0.00003922}, {445,0.00007843}, {446,0.00007843}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00007843}, {451,0.00000000}, {452,0.00003922}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00003922}, {461,0.00003922}, {462,0.00003922}, {463,0.00007843}, {464,0.00007843}, {465,0.00000000}, {466,0.00000000}, {467,0.00013725}, {468,0.00003922}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00003922}, {474,0.00006863}, {475,0.00003922}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00002941}, {480,0.00000000}, {481,0.00003922}, {482,0.00015686}, {483,0.00007843}, {484,0.00003922}, {485,0.00000000}, {486,0.00000000}, {487,0.00003922}, {488,0.00000000}, {489,0.00003922}, {490,0.00000000}, {491,0.00007843}, {492,0.00003922}, {493,0.00000000}, {494,0.00000000}, {495,0.00007843}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00003922}, {500,0.00000000}, {505,0.00007843}, {510,0.00000000}, {515,0.00003922}, {520,0.00003922}, {525,0.00003922}, {530,0.00000000}, {535,0.00003922}, {540,0.00000000}, {545,0.00007843}, {550,0.00007843}, {555,0.00007843}, {560,0.00000000}, {565,0.00007843}, {570,0.00000000}, {575,0.00000000}, {580,0.00015686}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00007843}, {620,0.00003922}, {625,0.00003922}, {630,0.00000000}, {635,0.00000000}, {640,0.00003922}, {645,0.00000000}, {650,0.00000000}, {655,0.00002941}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00007843}, {680,0.00002941}, {685,0.00007843}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00007843}, {715,0.00000000}, {720,0.00000000}, {725,0.00003922}, {730,0.00003922}, {735,0.00003922}, {740,0.00003922}, {745,0.00007843}, {750,0.00011765}, {755,0.00007843}, {760,0.00011765}, {765,0.00000000}, {770,0.00000000}, {775,0.00003922}, {780,0.00003922}, {785,0.00007843}, {790,0.00003922}, {795,0.00007843}, {800,0.00000000}, {805,0.00003922}, {810,0.00000000}, {815,0.00003922}, {820,0.00003922}, {825,0.00000000}, {830,0.00007843}, {835,0.00003922}, {840,0.00003922}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00003922}, {865,0.00011765}, {870,0.00000000}, {875,0.00003922}, {880,0.00007843}, {885,0.00003922}, {890,0.00007843}, {895,0.00003922}, {900,0.00003922}, {905,0.00007843}, {910,0.00003922}, {915,0.00007843}, {920,0.00007843}, {925,0.00000000}, {930,0.00003922}, {935,0.00000000}, {940,0.00007843}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00003922}, {965,0.00003922}, {970,0.00003922}, {975,0.00007843}, {980,0.00003922}, {985,0.00000000}, {990,0.00003922}, {995,0.00007843}, {1000,0.00003922}, {1010,0.00003922}, {1020,0.00000000}, {1030,0.00003922}, {1040,0.00003922}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00003922}, {1080,0.00007843}, {1090,0.00000000}, {1100,0.00007843}, {1110,0.00003922}, {1120,0.00003922}, {1130,0.00003922}, {1140,0.00000000}, {1150,0.00006863}, {1160,0.00003922}, {1170,0.00003922}, {1180,0.00000000}, {1190,0.00003922}, {1200,0.00000000}, {1210,0.00003922}, {1220,0.00011765}, {1230,0.00003922}, {1240,0.00000000}, {1250,0.00007843}, {1260,0.00000000}, {1270,0.00003922}, {1280,0.00003922}, {1290,0.00000000}, {1300,0.00003922}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00003922}, {1340,0.00003922}, {1350,0.00000000}, {1360,0.00002941}, {1370,0.00010784}, {1380,0.00003922}, {1390,0.00003922}, {1400,0.00011765}, {1410,0.00000000}, {1420,0.00003922}, {1430,0.00003922}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00003922}, {1470,0.00000000}, {1480,0.00003922}, {1490,0.00011765}, {1500,0.00000000}, {1510,0.00003922}, {1520,0.00006863}, {1530,0.00007843}, {1540,0.00007843}, {1550,0.00003922}, {1560,0.00003922}, {1570,0.00003922}, {1580,0.00003922}, {1590,0.00000000}, {1600,0.00003922}, {1610,0.00003922}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003922}, {1670,0.00000000}, {1680,0.00007843}, {1690,0.00015686}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00011765}, {1730,0.00000000}, {1740,0.00007843}, {1750,0.00007843}, {1760,0.00000000}, {1770,0.00011765}, {1780,0.00007843}, {1790,0.00003922}, {1800,0.00003922}, {1810,0.00003922}, {1820,0.00007843}, {1830,0.00007843}, {1840,0.00002941}, {1850,0.00000000}, {1860,0.00007843}, {1870,0.00007843}, {1880,0.00018627}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00007843}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00003922}, {1960,0.00007843}, {1970,0.00003922}, {1980,0.00007843}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00007843}, {2100,0.00011765}, {2150,0.00015686}, {2200,0.00019608}, {2250,0.00007843}, {2300,0.00011765}, {2350,0.00003922}, {2400,0.00005882}, {2450,0.00011765}, {2500,0.00000000}, {2550,0.00003922}, {2600,0.00003922}, {2650,0.00007843}, {2700,0.00015686}, {2750,0.00003922}, {2800,0.00003922}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00002941}, {3000,0.00003922}, {3050,0.00003922}, {3100,0.00003922}, {3150,0.00000000}, {3200,0.00003922}, {3250,0.00011765}, {3300,0.00007843}, {3350,0.00007843}, {3400,0.00003922}, {3450,0.00007843}, {3500,0.00000000}, {3550,0.00015686}, {3600,0.00003922}, {3650,0.00003922}, {3700,0.00000000}, {3750,0.00011765}, {3800,0.00011765}, {3850,0.00011765}, {3900,0.00003922}, {3950,0.00011765}, {4000,0.00007843}, {4050,0.00007843}, {4100,0.00019608}, {4150,0.00000000}, {4200,0.00015686}, {4250,0.00003922}, {4300,0.00014706}, {4350,0.00003922}, {4400,0.00003922}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00003922}, {4600,0.00011765}, {4650,0.00011765}, {4700,0.00015686}, {4750,0.00007843}, {4800,0.00007843}, {4850,0.00015686}, {4900,0.00014706}, {4950,0.00007843}, {5000,0.00003922}, {5050,0.00007843}, {5100,0.00014706}, {5150,0.00011765}, {5200,0.00003922}, {5250,0.00006863}, {5300,0.00007843}, {5350,0.00010784}, {5400,0.00023529}, {5450,0.00011765}, {5500,0.00025490}, {5550,0.00018627}, {5600,0.00000000}, {5650,0.00003922}, {5700,0.00015686}, {5750,0.00015686}, {5800,0.00010784}, {5850,0.00011765}, {5900,0.00023529}, {5950,0.00028431}, {6000,0.00010784}, {6050,0.00900}, {6100,0.00475}, {6150,0.00300}, {6200,0.00000}, {6250,0.00000}, {6300,0.00100}, {6350,0.00175}, {6400,0.00100}, {6450,0.00075}, {6500,0.00000}, {6550,0.00300}, {6600,0.01000}, {6650,0.00500}, {6700,0.00575}, {6750,0.00500}, {6800,0.00500}, {6850,0.00500}, {6900,0.00500}, {6950,0.00500}, {7000,0.00800}, {7050,0.00600}, {7100,0.00300}, {7150,0.00100}, {7200,0.00200}, {7250,0.00075}, {7300,0.00100}, {7350,0.00100}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00075}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00100}, {10700,0.00000}, {10800,0.00100}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00100}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00100}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00100}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00100}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00075}, {15300,0.00000}, {15400,0.00100}, {15500,0.00000}, {15600,0.00100}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00100}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00100}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00100}, {17700,0.00000}, {17800,0.00000}, {17900,0.00100}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00175}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00100}, {19000,0.00100}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00100}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["Ltac2"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["Ltac2"]["post"]["user"] = {{1,0.00003922}, {2,0.00002941}, {3,0.00000000}, {4,0.00006863}, {5,0.00002941}, {6,0.00006863}, {7,0.00002941}, {8,0.00003922}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00002941}, {15,0.00002941}, {16,0.00000000}, {17,0.00002941}, {18,0.00002941}, {19,0.00005882}, {20,0.00005882}, {21,0.00005882}, {22,0.00003922}, {23,0.00000000}, {24,0.00002941}, {25,0.00002941}, {26,0.00000000}, {27,0.00002941}, {28,0.00010784}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00002941}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00002941}, {39,0.00003922}, {40,0.00000000}, {41,0.00002941}, {42,0.00007843}, {43,0.00000000}, {44,0.00000000}, {45,0.00002941}, {46,0.00002941}, {47,0.00003922}, {48,0.00000000}, {49,0.00000000}, {50,0.00002941}, {51,0.00000000}, {52,0.00002941}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00002941}, {57,0.00002941}, {58,0.00000000}, {59,0.00000000}, {60,0.00003922}, {61,0.00003922}, {62,0.00000000}, {63,0.00009804}, {64,0.00000000}, {65,0.00002941}, {66,0.00000000}, {67,0.00002941}, {68,0.00000000}, {69,0.00010784}, {70,0.00000000}, {71,0.00000000}, {72,0.00002941}, {73,0.00000000}, {74,0.00002941}, {75,0.00006863}, {76,0.00002941}, {77,0.00000000}, {78,0.00002941}, {79,0.00002941}, {80,0.00002941}, {81,0.00006863}, {82,0.00007843}, {83,0.00000000}, {84,0.00002941}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00006863}, {89,0.00002941}, {90,0.00005882}, {91,0.00000000}, {92,0.00013725}, {93,0.00000000}, {94,0.00008824}, {95,0.00000000}, {96,0.00002941}, {97,0.00000000}, {98,0.00006863}, {99,0.00000000}, {100,0.00000000}, {101,0.00003922}, {102,0.00002941}, {103,0.00002941}, {104,0.00000000}, {105,0.00000000}, {106,0.00005882}, {107,0.00012745}, {108,0.00009804}, {109,0.00000000}, {110,0.00002941}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00010784}, {115,0.00006863}, {116,0.00010784}, {117,0.00000000}, {118,0.00003922}, {119,0.00005882}, {120,0.00002941}, {121,0.00000000}, {122,0.00002941}, {123,0.00003922}, {124,0.00000000}, {125,0.00010784}, {126,0.00010784}, {127,0.00000000}, {128,0.00002941}, {129,0.00000000}, {130,0.00006863}, {131,0.00000000}, {132,0.00002941}, {133,0.00000000}, {134,0.00003922}, {135,0.00002941}, {136,0.00007843}, {137,0.00002941}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00002941}, {142,0.00003922}, {143,0.00000000}, {144,0.00000000}, {145,0.00002941}, {146,0.00005882}, {147,0.00005882}, {148,0.00000000}, {149,0.00003922}, {150,0.00000000}, {151,0.00000000}, {152,0.00005882}, {153,0.00005882}, {154,0.00003922}, {155,0.00003922}, {156,0.00012745}, {157,0.00005882}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00002941}, {162,0.00002941}, {163,0.00007843}, {164,0.00005882}, {165,0.00005882}, {166,0.00000000}, {167,0.00005882}, {168,0.00002941}, {169,0.00000000}, {170,0.00014706}, {171,0.00000000}, {172,0.00000000}, {173,0.00002941}, {174,0.00000000}, {175,0.00000000}, {176,0.00006863}, {177,0.00002941}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00003922}, {188,0.00005882}, {189,0.00002941}, {190,0.00002941}, {191,0.00009804}, {192,0.00002941}, {193,0.00000000}, {194,0.00000000}, {195,0.00003922}, {196,0.00002941}, {197,0.00000000}, {198,0.00000000}, {199,0.00005882}, {200,0.00000000}, {201,0.00000000}, {202,0.00003922}, {203,0.00002941}, {204,0.00000000}, {205,0.00002941}, {206,0.00000000}, {207,0.00005882}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00006863}, {213,0.00003922}, {214,0.00000000}, {215,0.00000000}, {216,0.00003922}, {217,0.00000000}, {218,0.00003922}, {219,0.00000000}, {220,0.00000000}, {221,0.00002941}, {222,0.00000000}, {223,0.00002941}, {224,0.00000000}, {225,0.00005882}, {226,0.00009804}, {227,0.00002941}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00003922}, {233,0.00002941}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00008824}, {241,0.00006863}, {242,0.00000000}, {243,0.00000000}, {244,0.00009804}, {245,0.00002941}, {246,0.00007843}, {247,0.00007843}, {248,0.00000000}, {249,0.00005882}, {250,0.00005882}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00002941}, {255,0.00002941}, {256,0.00002941}, {257,0.00000000}, {258,0.00011765}, {259,0.00002941}, {260,0.00000000}, {261,0.00005882}, {262,0.00006863}, {263,0.00002941}, {264,0.00002941}, {265,0.00003922}, {266,0.00000000}, {267,0.00007843}, {268,0.00000000}, {269,0.00003922}, {270,0.00002941}, {271,0.00000000}, {272,0.00000000}, {273,0.00005882}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00006863}, {278,0.00003922}, {279,0.00002941}, {280,0.00000000}, {281,0.00002941}, {282,0.00006863}, {283,0.00002941}, {284,0.00005882}, {285,0.00003922}, {286,0.00000000}, {287,0.00005882}, {288,0.00002941}, {289,0.00006863}, {290,0.00000000}, {291,0.00000000}, {292,0.00005882}, {293,0.00005882}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00003922}, {299,0.00000000}, {300,0.00000000}, {301,0.00002941}, {302,0.00002941}, {303,0.00006863}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00002941}, {308,0.00006863}, {309,0.00008824}, {310,0.00000000}, {311,0.00002941}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00003922}, {316,0.00002941}, {317,0.00003922}, {318,0.00006863}, {319,0.00002941}, {320,0.00002941}, {321,0.00000000}, {322,0.00009804}, {323,0.00009804}, {324,0.00002941}, {325,0.00003922}, {326,0.00000000}, {327,0.00009804}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00005882}, {334,0.00002941}, {335,0.00003922}, {336,0.00009804}, {337,0.00000000}, {338,0.00003922}, {339,0.00002941}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00006863}, {344,0.00002941}, {345,0.00007843}, {346,0.00000000}, {347,0.00007843}, {348,0.00006863}, {349,0.00002941}, {350,0.00003922}, {351,0.00000000}, {352,0.00000000}, {353,0.00002941}, {354,0.00003922}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00002941}, {361,0.00000000}, {362,0.00003922}, {363,0.00002941}, {364,0.00000000}, {365,0.00002941}, {366,0.00000000}, {367,0.00002941}, {368,0.00006863}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00008824}, {373,0.00000000}, {374,0.00009804}, {375,0.00000000}, {376,0.00002941}, {377,0.00002941}, {378,0.00002941}, {379,0.00000000}, {380,0.00005882}, {381,0.00003922}, {382,0.00000000}, {383,0.00000000}, {384,0.00002941}, {385,0.00000000}, {386,0.00002941}, {387,0.00002941}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00002941}, {393,0.00002941}, {394,0.00006863}, {395,0.00002941}, {396,0.00006863}, {397,0.00000000}, {398,0.00002941}, {399,0.00000000}, {400,0.00002941}, {401,0.00000000}, {402,0.00005882}, {403,0.00002941}, {404,0.00002941}, {405,0.00000000}, {406,0.00005882}, {407,0.00003922}, {408,0.00000000}, {409,0.00000000}, {410,0.00002941}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00005882}, {417,0.00000000}, {418,0.00000000}, {419,0.00002941}, {420,0.00003922}, {421,0.00000000}, {422,0.00002941}, {423,0.00005882}, {424,0.00000000}, {425,0.00007843}, {426,0.00000000}, {427,0.00000000}, {428,0.00002941}, {429,0.00002941}, {430,0.00002941}, {431,0.00006863}, {432,0.00000000}, {433,0.00006863}, {434,0.00002941}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00003922}, {439,0.00005882}, {440,0.00000000}, {441,0.00009804}, {442,0.00000000}, {443,0.00005882}, {444,0.00002941}, {445,0.00002941}, {446,0.00002941}, {447,0.00005882}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00003922}, {452,0.00000000}, {453,0.00002941}, {454,0.00002941}, {455,0.00002941}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00003922}, {460,0.00000000}, {461,0.00000000}, {462,0.00012745}, {463,0.00002941}, {464,0.00002941}, {465,0.00005882}, {466,0.00000000}, {467,0.00002941}, {468,0.00006863}, {469,0.00006863}, {470,0.00002941}, {471,0.00002941}, {472,0.00000000}, {473,0.00002941}, {474,0.00002941}, {475,0.00002941}, {476,0.00003922}, {477,0.00003922}, {478,0.00000000}, {479,0.00002941}, {480,0.00002941}, {481,0.00002941}, {482,0.00002941}, {483,0.00003922}, {484,0.00014706}, {485,0.00000000}, {486,0.00002941}, {487,0.00005882}, {488,0.00000000}, {489,0.00000000}, {490,0.00002941}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00005882}, {496,0.00008824}, {497,0.00000000}, {498,0.00000000}, {499,0.00002941}, {500,0.00000000}, {505,0.00000000}, {510,0.00006863}, {515,0.00000000}, {520,0.00008824}, {525,0.00000000}, {530,0.00002941}, {535,0.00006863}, {540,0.00000000}, {545,0.00000000}, {550,0.00002941}, {555,0.00000000}, {560,0.00000000}, {565,0.00005882}, {570,0.00000000}, {575,0.00005882}, {580,0.00000000}, {585,0.00002941}, {590,0.00006863}, {595,0.00005882}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00002941}, {620,0.00000000}, {625,0.00002941}, {630,0.00002941}, {635,0.00005882}, {640,0.00000000}, {645,0.00002941}, {650,0.00000000}, {655,0.00003922}, {660,0.00003922}, {665,0.00000000}, {670,0.00002941}, {675,0.00005882}, {680,0.00002941}, {685,0.00000000}, {690,0.00005882}, {695,0.00007843}, {700,0.00000000}, {705,0.00002941}, {710,0.00002941}, {715,0.00000000}, {720,0.00002941}, {725,0.00003922}, {730,0.00000000}, {735,0.00002941}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00002941}, {770,0.00005882}, {775,0.00002941}, {780,0.00000000}, {785,0.00002941}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00002941}, {810,0.00000000}, {815,0.00000000}, {820,0.00003922}, {825,0.00003922}, {830,0.00006863}, {835,0.00000000}, {840,0.00000000}, {845,0.00002941}, {850,0.00002941}, {855,0.00000000}, {860,0.00005882}, {865,0.00003922}, {870,0.00000000}, {875,0.00002941}, {880,0.00000000}, {885,0.00003922}, {890,0.00006863}, {895,0.00002941}, {900,0.00002941}, {905,0.00000000}, {910,0.00010784}, {915,0.00000000}, {920,0.00000000}, {925,0.00010784}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00002941}, {960,0.00005882}, {965,0.00005882}, {970,0.00006863}, {975,0.00000000}, {980,0.00000000}, {985,0.00002941}, {990,0.00005882}, {995,0.00002941}, {1000,0.00010784}, {1010,0.00007843}, {1020,0.00003922}, {1030,0.00007843}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00003922}, {1070,0.00003922}, {1080,0.00000000}, {1090,0.00002941}, {1100,0.00002941}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00002941}, {1140,0.00000000}, {1150,0.00002941}, {1160,0.00003922}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00009804}, {1200,0.00006863}, {1210,0.00006863}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00006863}, {1270,0.00000000}, {1280,0.00005882}, {1290,0.00006863}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00003922}, {1330,0.00002941}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00002941}, {1370,0.00000000}, {1380,0.00002941}, {1390,0.00000000}, {1400,0.00005882}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00002941}, {1440,0.00006863}, {1450,0.00003922}, {1460,0.00000000}, {1470,0.00002941}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00002941}, {1520,0.00005882}, {1530,0.00000000}, {1540,0.00003922}, {1550,0.00002941}, {1560,0.00003922}, {1570,0.00000000}, {1580,0.00005882}, {1590,0.00000000}, {1600,0.00002941}, {1610,0.00000000}, {1620,0.00002941}, {1630,0.00003922}, {1640,0.00000000}, {1650,0.00003922}, {1660,0.00002941}, {1670,0.00000000}, {1680,0.00002941}, {1690,0.00002941}, {1700,0.00000000}, {1710,0.00006863}, {1720,0.00000000}, {1730,0.00007843}, {1740,0.00002941}, {1750,0.00002941}, {1760,0.00009804}, {1770,0.00000000}, {1780,0.00005882}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00002941}, {1820,0.00000000}, {1830,0.00003922}, {1840,0.00002941}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00005882}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00002941}, {1910,0.00002941}, {1920,0.00000000}, {1930,0.00002941}, {1940,0.00000000}, {1950,0.00002941}, {1960,0.00003922}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00005882}, {2100,0.00002941}, {2150,0.00002941}, {2200,0.00002941}, {2250,0.00000000}, {2300,0.00003922}, {2350,0.00007843}, {2400,0.00002941}, {2450,0.00000000}, {2500,0.00006863}, {2550,0.00002941}, {2600,0.00000000}, {2650,0.00003922}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00002941}, {2950,0.00002941}, {3000,0.00000000}, {3050,0.00002941}, {3100,0.00002941}, {3150,0.00005882}, {3200,0.00000000}, {3250,0.00006863}, {3300,0.00005882}, {3350,0.00010784}, {3400,0.00003922}, {3450,0.00002941}, {3500,0.00003922}, {3550,0.00003922}, {3600,0.00000000}, {3650,0.00002941}, {3700,0.00010784}, {3750,0.00002941}, {3800,0.00006863}, {3850,0.00003922}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00006863}, {4050,0.00003922}, {4100,0.00000000}, {4150,0.00003922}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00003922}, {4400,0.00006863}, {4450,0.00003922}, {4500,0.00007843}, {4550,0.00003922}, {4600,0.00002941}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00003922}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00003922}, {5000,0.00000000}, {5050,0.00005882}, {5100,0.00000000}, {5150,0.00002941}, {5200,0.00000000}, {5250,0.00003922}, {5300,0.00006863}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00002941}, {5650,0.00002941}, {5700,0.00007843}, {5750,0.00002941}, {5800,0.00000000}, {5850,0.00002941}, {5900,0.00007843}, {5950,0.00000000}, {6000,0.00003922}, {6050,0.00100}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00100}, {9200,0.00100}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00100}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["Ltac2"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00002941}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00003922}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00002941}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00003922}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00003922}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00003922}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00003922}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00003922}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00003922}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00003922}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["Ltac2"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["Ltac2"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00002941}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00002941}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00002941}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00002941}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00003922}, {66,0.00000000}, {67,0.00003922}, {68,0.00003922}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00002941}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00002941}, {131,0.00002941}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00006863}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00002941}, {153,0.00002941}, {154,0.00000000}, {155,0.00000000}, {156,0.00002941}, {157,0.00002941}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00002941}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00002941}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00003922}, {196,0.00002941}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00002941}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00003922}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00003922}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00003922}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00003922}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00002941}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00002941}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00002941}, {270,0.00000000}, {271,0.00000000}, {272,0.00003922}, {273,0.00000000}, {274,0.00002941}, {275,0.00002941}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00002941}, {286,0.00000000}, {287,0.00002941}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00002941}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00005882}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00002941}, {324,0.00000000}, {325,0.00000000}, {326,0.00003922}, {327,0.00000000}, {328,0.00000000}, {329,0.00003922}, {330,0.00000000}, {331,0.00000000}, {332,0.00002941}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00002941}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00002941}, {379,0.00003922}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00003922}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00002941}, {403,0.00000000}, {404,0.00002941}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00002941}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00003922}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00003922}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00003922}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003922}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00003922}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00002941}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00002941}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00002941}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00003922}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00002941}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00002941}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00002941}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00002941}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00002941}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00007843}, {785,0.00000000}, {790,0.00000000}, {795,0.00002941}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00009804}, {835,0.00002941}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00002941}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00002941}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00003922}, {1060,0.00002941}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00002941}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00002941}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00003922}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00002941}, {1320,0.00002941}, {1330,0.00005882}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00003922}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00005882}, {1640,0.00003922}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00002941}, {1680,0.00000000}, {1690,0.00002941}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00003922}, {1740,0.00002941}, {1750,0.00002941}, {1760,0.00002941}, {1770,0.00000000}, {1780,0.00002941}, {1790,0.00000000}, {1800,0.00002941}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00003922}, {1930,0.00002941}, {1940,0.00000000}, {1950,0.00003922}, {1960,0.00002941}, {1970,0.00003922}, {1980,0.00003922}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00002941}, {2250,0.00003922}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00002941}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00002941}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00003922}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00003922}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00002941}, {4200,0.00000000}, {4250,0.00003922}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00002941}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00003922}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00003922}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00100}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00075}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["Ltac2"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00003922}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00003922}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["Ltac2"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00004902}, {4,0.00080392}, {5,0.00100000}, {6,0.00100000}, {7,0.00100000}, {8,0.00100000}, {9,0.00100000}, {10,0.00113725}, {11,0.00137255}, {12,0.00189216}, {13,0.00200000}, {14,0.00200000}, {15,0.00200980}, {16,0.00200000}, {17,0.00220588}, {18,0.00230392}, {19,0.00300000}, {20,0.00300980}, {21,0.00321569}, {22,0.01346078}, {23,0.00301961}, {24,0.00301961}, {25,0.00322549}, {26,0.00391176}, {27,0.00400000}, {28,0.00400000}, {29,0.00405882}, {30,0.00409804}, {31,0.00459804}, {32,0.00409804}, {33,0.00494118}, {34,0.00502941}, {35,0.00511765}, {36,0.00510784}, {37,0.00513725}, {38,0.00519608}, {39,0.00661765}, {40,0.00542157}, {41,0.00611765}, {42,0.00608824}, {43,0.00612745}, {44,0.00608824}, {45,0.00683333}, {46,0.00711765}, {47,0.00716667}, {48,0.00686275}, {49,0.00708824}, {50,0.00708824}, {51,0.00752941}, {52,0.00806863}, {53,0.00806863}, {54,0.00804902}, {55,0.00820588}, {56,0.00804902}, {57,0.00813725}, {58,0.00824510}, {59,0.00903922}, {60,0.00901961}, {61,0.01007843}, {62,0.00903922}, {63,0.01000980}, {64,0.00903922}, {65,0.00915686}, {66,0.00929412}, {67,0.01007843}, {68,0.01000000}, {69,0.01008824}, {70,0.01108824}, {71,0.01105882}, {72,0.01003922}, {73,0.01104902}, {74,0.01111765}, {75,0.01139216}, {76,0.01109804}, {77,0.01201961}, {78,0.01213725}, {79,0.01231373}, {80,0.01113725}, {81,0.01211765}, {82,0.01218627}, {83,0.01284314}, {84,0.01310784}, {85,0.01314706}, {86,0.01309804}, {87,0.01386275}, {88,0.01303922}, {89,0.01328431}, {90,0.01353922}, {91,0.01501961}, {92,0.01405882}, {93,0.01446078}, {94,0.01477451}, {95,0.01523529}, {96,0.01364706}, {97,0.01509804}, {98,0.01432353}, {99,0.01512745}, {100,0.01479412}, {101,0.01530392}, {102,0.01627451}, {103,0.01615686}, {104,0.01509804}, {105,0.01611765}, {106,0.01609804}, {107,0.01700980}, {108,0.01703922}, {109,0.01710784}, {110,0.01713725}, {111,0.01810784}, {112,0.01613725}, {113,0.01799020}, {114,0.01713725}, {115,0.01811765}, {116,0.01727451}, {117,0.01922549}, {118,0.01822549}, {119,0.01919608}, {120,0.01802941}, {121,0.01914706}, {122,0.02000000}, {123,0.01998039}, {124,0.01906863}, {125,0.02004902}, {126,0.02100000}, {127,0.02111765}, {128,0.01814706}, {129,0.01903922}, {130,0.01920588}, {131,0.02109804}, {132,0.01956863}, {133,0.02046078}, {134,0.02069608}, {135,0.02239216}, {136,0.02009804}, {137,0.02107843}, {138,0.02115686}, {139,0.02304902}, {140,0.02130392}, {141,0.02230392}, {142,0.02246078}, {143,0.02437255}, {144,0.02118627}, {145,0.02214706}, {146,0.02231373}, {147,0.02423529}, {148,0.02245098}, {149,0.02363725}, {150,0.02486275}, {151,0.02492157}, {152,0.02305882}, {153,0.02406863}, {154,0.02501961}, {155,0.02525490}, {156,0.02441176}, {157,0.02655882}, {158,0.02588235}, {159,0.02710784}, {160,0.02341176}, {161,0.02532353}, {162,0.02467647}, {163,0.02596078}, {164,0.02590196}, {165,0.02614706}, {166,0.02621569}, {167,0.02728431}, {168,0.02538235}, {169,0.02666667}, {170,0.02684314}, {171,0.02868627}, {172,0.02710784}, {173,0.02820588}, {174,0.02924510}, {175,0.02957843}, {176,0.02653922}, {177,0.02867647}, {178,0.02796078}, {179,0.02910784}, {180,0.02909804}, {181,0.02935294}, {182,0.02943137}, {183,0.03156863}, {184,0.02880392}, {185,0.03021569}, {186,0.03108824}, {187,0.03120588}, {188,0.03034314}, {189,0.03249020}, {190,0.03166667}, {191,0.03417647}, {192,0.02814706}, {193,0.02952941}, {194,0.03057843}, {195,0.03102941}, {196,0.02997059}, {197,0.03202941}, {198,0.03129412}, {199,0.03282353}, {200,0.03116667}, {201,0.03179412}, {202,0.03198039}, {203,0.03418627}, {204,0.03217647}, {205,0.03458824}, {206,0.03373529}, {207,0.03528431}, {208,0.03249020}, {209,0.03308824}, {210,0.03305882}, {211,0.03543137}, {212,0.03330392}, {213,0.03571569}, {214,0.03482353}, {215,0.03632353}, {216,0.03465686}, {217,0.03541176}, {218,0.03625490}, {219,0.03700000}, {220,0.03560784}, {221,0.03725490}, {222,0.03724510}, {223,0.03961765}, {224,0.03392157}, {225,0.03616667}, {226,0.03532353}, {227,0.03702941}, {228,0.03653922}, {229,0.03718627}, {230,0.03828431}, {231,0.03901961}, {232,0.03724510}, {233,0.03766667}, {234,0.03799020}, {235,0.04042157}, {236,0.03815686}, {237,0.04069608}, {238,0.03986275}, {239,0.04223529}, {240,0.03739216}, {241,0.03997059}, {242,0.03908824}, {243,0.04059804}, {244,0.04017647}, {245,0.04090196}, {246,0.04227451}, {247,0.04266667}, {248,0.04085294}, {249,0.04131373}, {250,0.04236275}, {251,0.04336275}, {252,0.04257843}, {253,0.04328431}, {254,0.04421569}, {255,0.04537255}, {256,0.03924510}, {257,0.03976471}, {258,0.04108824}, {259,0.04176471}, {260,0.04031373}, {261,0.04200000}, {262,0.04213725}, {263,0.04463725}, {264,0.04067647}, {265,0.04388235}, {266,0.04257843}, {267,0.04558824}, {268,0.04292157}, {269,0.04596078}, {270,0.04492157}, {271,0.04798039}, {272,0.04176471}, {273,0.04494118}, {274,0.04380392}, {275,0.04684314}, {276,0.04411765}, {277,0.04702941}, {278,0.04600000}, {279,0.04795098}, {280,0.04544118}, {281,0.04648039}, {282,0.04724510}, {283,0.04853922}, {284,0.04747059}, {285,0.04872549}, {286,0.04958824}, {287,0.05077451}, {288,0.04527451}, {289,0.04607843}, {290,0.04749020}, {291,0.04811765}, {292,0.04629412}, {293,0.04935294}, {294,0.04842157}, {295,0.05118627}, {296,0.04679412}, {297,0.04978431}, {298,0.04898039}, {299,0.05210784}, {300,0.04935294}, {301,0.05139216}, {302,0.05192157}, {303,0.05348039}, {304,0.04875490}, {305,0.04996078}, {306,0.05129412}, {307,0.05353922}, {308,0.05043137}, {309,0.05325490}, {310,0.05262745}, {311,0.05557843}, {312,0.05240196}, {313,0.05303922}, {314,0.05368627}, {315,0.05519608}, {316,0.05440196}, {317,0.05654902}, {318,0.05554902}, {319,0.05856863}, {320,0.04876471}, {321,0.05214706}, {322,0.05212745}, {323,0.05331373}, {324,0.05209804}, {325,0.05348039}, {326,0.05487255}, {327,0.05652941}, {328,0.05181373}, {329,0.05490196}, {330,0.05412745}, {331,0.05737255}, {332,0.05550980}, {333,0.05656863}, {334,0.05778431}, {335,0.05975490}, {336,0.05287255}, {337,0.05598039}, {338,0.05662745}, {339,0.05750000}, {340,0.05639216}, {341,0.05808824}, {342,0.05786275}, {343,0.06119608}, {344,0.05599020}, {345,0.05942157}, {346,0.05946078}, {347,0.06066667}, {348,0.05936275}, {349,0.06236275}, {350,0.06331373}, {351,0.06342157}, {352,0.05608824}, {353,0.05952941}, {354,0.05762745}, {355,0.06058824}, {356,0.05790196}, {357,0.06027451}, {358,0.06103922}, {359,0.06369608}, {360,0.05835294}, {361,0.06170588}, {362,0.06166667}, {363,0.06355882}, {364,0.06226471}, {365,0.06437255}, {366,0.06363725}, {367,0.06613725}, {368,0.06027451}, {369,0.06280392}, {370,0.06219608}, {371,0.06574510}, {372,0.06310784}, {373,0.06497059}, {374,0.06492157}, {375,0.06814706}, {376,0.06360784}, {377,0.06535294}, {378,0.06641176}, {379,0.06902941}, {380,0.06615686}, {381,0.06819608}, {382,0.06931373}, {383,0.07207843}, {384,0.05960784}, {385,0.06107843}, {386,0.06240196}, {387,0.06495098}, {388,0.06324510}, {389,0.06412745}, {390,0.06509804}, {391,0.06757843}, {392,0.06199020}, {393,0.06572549}, {394,0.06636275}, {395,0.06801961}, {396,0.06498039}, {397,0.06881373}, {398,0.06888235}, {399,0.07091176}, {400,0.06308824}, {401,0.06565686}, {402,0.06716667}, {403,0.06924510}, {404,0.06620588}, {405,0.06888235}, {406,0.06992157}, {407,0.07250980}, {408,0.06737255}, {409,0.06942157}, {410,0.07076471}, {411,0.07335294}, {412,0.07054902}, {413,0.07323529}, {414,0.07243137}, {415,0.07651961}, {416,0.06701961}, {417,0.06907843}, {418,0.06932353}, {419,0.07101961}, {420,0.06970588}, {421,0.07263725}, {422,0.07230392}, {423,0.07516667}, {424,0.06881373}, {425,0.07294118}, {426,0.07321569}, {427,0.07540196}, {428,0.07266667}, {429,0.07629412}, {430,0.07512745}, {431,0.07931373}, {432,0.07148039}, {433,0.07404902}, {434,0.07351961}, {435,0.07694118}, {436,0.07319608}, {437,0.07767647}, {438,0.07775490}, {439,0.08041176}, {440,0.07477451}, {441,0.07715686}, {442,0.07763725}, {443,0.08177451}, {444,0.07713725}, {445,0.08122549}, {446,0.08161765}, {447,0.08409804}, {448,0.07138235}, {449,0.07392157}, {450,0.07411765}, {451,0.07607843}, {452,0.07353922}, {453,0.07790196}, {454,0.07769608}, {455,0.08028431}, {456,0.07474510}, {457,0.07777451}, {458,0.07875490}, {459,0.08008824}, {460,0.07833333}, {461,0.08180392}, {462,0.08163725}, {463,0.08447059}, {464,0.07603922}, {465,0.07862745}, {466,0.07858824}, {467,0.08239216}, {468,0.07856863}, {469,0.08135294}, {470,0.08280392}, {471,0.08648039}, {472,0.08058824}, {473,0.08350980}, {474,0.08316667}, {475,0.08615686}, {476,0.08309804}, {477,0.08593137}, {478,0.08575490}, {479,0.08883333}, {480,0.07774510}, {481,0.08094118}, {482,0.08172549}, {483,0.08557843}, {484,0.08094118}, {485,0.08499020}, {486,0.08600980}, {487,0.08895098}, {488,0.08281373}, {489,0.08609804}, {490,0.08584314}, {491,0.08888235}, {492,0.08576471}, {493,0.08904902}, {494,0.08916667}, {495,0.09255882}, {496,0.08353922}, {497,0.08678431}, {498,0.08669608}, {499,0.08980392}, {500,0.08687255}, {505,0.09040196}, {510,0.09430392}, {515,0.08723529}, {520,0.08472549}, {525,0.09175490}, {530,0.08899020}, {535,0.09741176}, {540,0.09453922}, {545,0.09203922}, {550,0.09643137}, {555,0.10117647}, {560,0.09460784}, {565,0.10290196}, {570,0.10310784}, {575,0.10901961}, {580,0.09723529}, {585,0.10201961}, {590,0.10610784}, {595,0.10742157}, {600,0.10502941}, {605,0.11168627}, {610,0.10500000}, {615,0.11348039}, {620,0.11131373}, {625,0.11085294}, {630,0.11534314}, {635,0.12062745}, {640,0.10392157}, {645,0.11126471}, {650,0.11190196}, {655,0.12142157}, {660,0.11560784}, {665,0.11793137}, {670,0.12318627}, {675,0.12139216}, {680,0.11676471}, {685,0.12598039}, {690,0.12381373}, {695,0.13074510}, {700,0.12830392}, {705,0.11954902}, {710,0.12545098}, {715,0.13076471}, {720,0.12232353}, {725,0.13343137}, {730,0.13178431}, {735,0.14302941}, {740,0.12924510}, {745,0.13620588}, {750,0.13943137}, {755,0.14131373}, {760,0.13716667}, {765,0.14685294}, {770,0.12849020}, {775,0.13791176}, {780,0.13440196}, {785,0.13445098}, {790,0.14072549}, {795,0.14635294}, {800,0.13401961}, {805,0.14321569}, {810,0.14376471}, {815,0.15500980}, {820,0.14419608}, {825,0.15070588}, {830,0.15717647}, {835,0.14721569}, {840,0.14302941}, {845,0.15471569}, {850,0.14905882}, {855,0.15996078}, {860,0.15705882}, {865,0.15242157}, {870,0.15758824}, {875,0.16279412}, {880,0.15429412}, {885,0.16687255}, {890,0.16616667}, {895,0.17786275}, {900,0.15315686}, {905,0.15823529}, {910,0.16562745}, {915,0.16831373}, {920,0.16199020}, {925,0.17333333}, {930,0.16264706}, {935,0.17400000}, {940,0.16855882}, {945,0.17001961}, {950,0.17730392}, {955,0.18321569}, {960,0.16218627}, {965,0.17508824}, {970,0.17678431}, {975,0.18823529}, {980,0.17723529}, {985,0.18357843}, {990,0.19050980}, {995,0.18450980}, {1000,0.17845098}, {1010,0.18550980}, {1020,0.19271569}, {1030,0.17920588}, {1040,0.17439216}, {1050,0.18839216}, {1060,0.18400980}, {1070,0.19909804}, {1080,0.19460784}, {1090,0.18859804}, {1100,0.19584314}, {1110,0.20411765}, {1120,0.19297059}, {1130,0.20939216}, {1140,0.20855882}, {1150,0.22654902}, {1160,0.19968627}, {1170,0.20759804}, {1180,0.21719608}, {1190,0.21774510}, {1200,0.21205882}, {1210,0.22863725}, {1220,0.21595098}, {1230,0.23229412}, {1240,0.22604902}, {1250,0.22588235}, {1260,0.23789216}, {1270,0.24401961}, {1280,0.21182353}, {1290,0.22858824}, {1300,0.23069608}, {1310,0.24840196}, {1320,0.23273529}, {1330,0.24304902}, {1340,0.25266667}, {1350,0.24681373}, {1360,0.23860784}, {1370,0.25695098}, {1380,0.25047059}, {1390,0.26846078}, {1400,0.26309804}, {1410,0.24943137}, {1420,0.25646078}, {1430,0.26531373}, {1440,0.24991176}, {1450,0.26845098}, {1460,0.26980392}, {1470,0.29062745}, {1480,0.26633333}, {1490,0.27633333}, {1500,0.28742157}, {1510,0.28832353}, {1520,0.27934314}, {1530,0.29912745}, {1540,0.26576471}, {1550,0.28472549}, {1560,0.27650000}, {1570,0.27678431}, {1580,0.28673529}, {1590,0.29810784}, {1600,0.27213725}, {1610,0.29280392}, {1620,0.29344118}, {1630,0.31586275}, {1640,0.29657843}, {1650,0.30740196}, {1660,0.31998039}, {1670,0.30310784}, {1680,0.29457843}, {1690,0.31537255}, {1700,0.30519608}, {1710,0.32784314}, {1720,0.32013725}, {1730,0.31178431}, {1740,0.32262745}, {1750,0.33562745}, {1760,0.31598039}, {1770,0.33932353}, {1780,0.33769608}, {1790,0.36503922}, {1800,0.31492157}, {1810,0.32575490}, {1820,0.33717647}, {1830,0.34068627}, {1840,0.33216667}, {1850,0.35518627}, {1860,0.33378431}, {1870,0.35664706}, {1880,0.34662745}, {1890,0.34793137}, {1900,0.36126471}, {1910,0.37470588}, {1920,0.33211765}, {1930,0.35543137}, {1940,0.35537255}, {1950,0.38120588}, {1960,0.36399020}, {1970,0.37486275}, {1980,0.38908824}, {1990,0.37934314}, {2000,0.36732353}, {2050,0.35676471}, {2100,0.38771569}, {2150,0.40910784}, {2200,0.40718627}, {2250,0.42583333}, {2300,0.46014706}, {2350,0.45911765}, {2400,0.43728431}, {2450,0.46089216}, {2500,0.46797059}, {2550,0.51800980}, {2600,0.47465686}, {2650,0.51337255}, {2700,0.50389216}, {2750,0.56443137}, {2800,0.53429412}, {2850,0.53031373}, {2900,0.55809804}, {2950,0.56516667}, {3000,0.59038235}, {3050,0.61577451}, {3100,0.58543137}, {3150,0.61598039}, {3200,0.56466667}, {3250,0.63080392}, {3300,0.64044118}, {3350,0.64372549}, {3400,0.63666667}, {3450,0.70615686}, {3500,0.69507843}, {3550,0.74342157}, {3600,0.65179412}, {3650,0.68306863}, {3700,0.74120588}, {3750,0.74428431}, {3800,0.75383333}, {3850,0.73782353}, {3900,0.79351961}, {3950,0.82458824}, {4000,0.76049020}, {4050,0.81836275}, {4100,0.73071569}, {4150,0.81556863}, {4200,0.79963725}, {4250,0.84186275}, {4300,0.84589216}, {4350,0.93152941}, {4400,0.83783333}, {4450,0.88243137}, {4500,0.88167647}, {4550,0.91504902}, {4600,0.95309804}, {4650,0.90954902}, {4700,0.94773529}, {4750,0.96007843}, {4800,0.90441176}, {4850,1.00812745}, {4900,0.95277451}, {4950,1.02300000}, {5000,0.97076471}, {5050,1.07076471}, {5100,1.08050000}, {5150,1.04188235}, {5200,0.99102941}, {5250,0.99921569}, {5300,1.07148039}, {5350,1.11033333}, {5400,1.06452941}, {5450,1.10297059}, {5500,1.17216667}, {5550,1.18062745}, {5600,1.12607843}, {5650,1.10119608}, {5700,1.12867647}, {5750,1.22788235}, {5800,1.15986275}, {5850,1.24305882}, {5900,1.18722549}, {5950,1.30544118}, {6000,1.22321569}, {6050,1.31750}, {6100,1.33250}, {6150,1.22075}, {6200,1.25725}, {6250,1.30225}, {6300,1.30925}, {6350,1.36275}, {6400,1.20150}, {6450,1.33250}, {6500,1.34275}, {6550,1.39700}, {6600,1.38475}, {6650,1.50700}, {6700,1.39950}, {6750,1.48325}, {6800,1.36450}, {6850,1.41450}, {6900,1.54625}, {6950,1.49075}, {7000,1.53250}, {7050,1.50350}, {7100,1.60400}, {7150,1.64825}, {7200,1.39075}, {7250,1.51475}, {7300,1.45525}, {7350,1.59925}, {7400,1.56300}, {7450,1.57225}, {7500,1.57650}, {7550,1.73425}, {7600,1.58825}, {7650,1.65350}, {7700,1.57250}, {7750,1.63050}, {7800,1.68750}, {7850,1.69875}, {7900,1.77075}, {7950,1.72200}, {8000,1.62600}, {8050,1.77700}, {8100,1.74775}, {8150,1.85575}, {8200,1.56175}, {8250,1.73650}, {8300,1.73375}, {8350,1.79325}, {8400,1.70200}, {8450,1.65975}, {8500,1.75725}, {8550,1.82750}, {8600,1.77425}, {8650,1.83800}, {8700,1.95525}, {8750,1.86350}, {8800,1.75025}, {8850,1.82175}, {8900,1.83475}, {8950,2.01400}, {9000,1.84375}, {9050,1.98600}, {9100,1.92200}, {9150,2.09925}, {9200,1.99475}, {9250,1.83500}, {9300,1.92075}, {9350,1.93075}, {9400,2.00100}, {9450,2.06075}, {9500,2.02350}, {9550,2.08775}, {9600,1.89875}, {9650,2.09800}, {9700,2.09375}, {9750,2.07125}, {9800,2.01625}, {9850,2.20125}, {9900,2.14025}, {9950,2.28175}, {10000,2.04775}, {10100,2.26725}, {10200,2.28050}, {10300,2.19525}, {10400,2.07475}, {10500,2.09300}, {10600,2.27400}, {10700,2.33700}, {10800,2.23800}, {10900,2.30800}, {11000,2.45775}, {11100,2.48950}, {11200,2.34450}, {11300,2.31825}, {11400,2.31700}, {11500,2.56650}, {11600,2.43500}, {11700,2.59825}, {11800,2.46925}, {11900,2.70650}, {12000,2.57100}, {12100,2.58900}, {12200,2.70950}, {12300,2.44350}, {12400,2.55125}, {12500,2.65300}, {12600,2.66850}, {12700,2.77375}, {12800,2.45025}, {12900,2.71875}, {13000,2.74775}, {13100,2.87800}, {13200,2.78300}, {13300,3.08175}, {13400,2.86350}, {13500,3.02425}, {13600,2.77150}, {13700,2.89900}, {13800,3.10925}, {13900,3.02300}, {14000,3.04575}, {14100,3.05150}, {14200,3.26675}, {14300,3.37350}, {14400,2.86675}, {14500,3.06550}, {14600,2.98450}, {14700,3.30225}, {14800,3.21575}, {14900,3.23075}, {15000,3.24375}, {15100,3.57500}, {15200,3.29300}, {15300,3.42025}, {15400,3.24450}, {15500,3.35500}, {15600,3.46550}, {15700,3.50225}, {15800,3.63175}, {15900,3.55450}, {16000,3.34275}, {16100,3.64575}, {16200,3.60175}, {16300,3.80250}, {16400,3.24400}, {16500,3.55375}, {16600,3.59750}, {16700,3.73175}, {16800,3.51875}, {16900,3.42450}, {17000,3.65825}, {17100,3.80000}, {17200,3.68575}, {17300,3.81250}, {17400,4.10100}, {17500,3.89975}, {17600,3.66925}, {17700,3.80225}, {17800,3.85500}, {17900,4.18725}, {18000,3.86150}, {18100,4.11250}, {18200,3.99875}, {18300,4.40550}, {18400,4.15500}, {18500,3.83450}, {18600,3.96750}, {18700,4.01950}, {18800,4.14850}, {18900,4.29300}, {19000,4.20850}, {19100,4.37300}, {19200,3.98075}, {19300,4.36850}, {19400,4.38200}, {19500,4.29475}, {19600,4.18975}, {19700,4.58400}, {19800,4.48300}, {19900,4.73925}, {20000,4.23850}};
data["big_flat"]["Ltac2"]["reif"]["user"] = {{1,0.00054902}, {2,0.00064706}, {3,0.00072549}, {4,0.00102941}, {5,0.00090196}, {6,0.00117647}, {7,0.00097059}, {8,0.00124510}, {9,0.00106863}, {10,0.00143137}, {11,0.00200000}, {12,0.00160784}, {13,0.00162745}, {14,0.00211765}, {15,0.00224510}, {16,0.00226471}, {17,0.00245098}, {18,0.00255882}, {19,0.00280392}, {20,0.00273529}, {21,0.00298039}, {22,0.01363725}, {23,0.00318627}, {24,0.00291176}, {25,0.00338235}, {26,0.00346078}, {27,0.00363725}, {28,0.00365686}, {29,0.00415686}, {30,0.00432353}, {31,0.00467647}, {32,0.00448039}, {33,0.00460784}, {34,0.00478431}, {35,0.00510784}, {36,0.00478431}, {37,0.00507843}, {38,0.00566667}, {39,0.00711765}, {40,0.00580392}, {41,0.00602941}, {42,0.00598039}, {43,0.00633333}, {44,0.00634314}, {45,0.00675490}, {46,0.00670588}, {47,0.00743137}, {48,0.00683333}, {49,0.00684314}, {50,0.00725490}, {51,0.00768627}, {52,0.00830392}, {53,0.00783333}, {54,0.00850000}, {55,0.00867647}, {56,0.00811765}, {57,0.00872549}, {58,0.00855882}, {59,0.00923529}, {60,0.00894118}, {61,0.01032353}, {62,0.00933333}, {63,0.00975490}, {64,0.00887255}, {65,0.00964706}, {66,0.00977451}, {67,0.01038235}, {68,0.00994118}, {69,0.01035294}, {70,0.01150980}, {71,0.01154902}, {72,0.01048039}, {73,0.01086275}, {74,0.01127451}, {75,0.01200980}, {76,0.01183333}, {77,0.01225490}, {78,0.01225490}, {79,0.01273529}, {80,0.01167647}, {81,0.01233333}, {82,0.01250000}, {83,0.01288235}, {84,0.01322549}, {85,0.01309804}, {86,0.01344118}, {87,0.01382353}, {88,0.01274510}, {89,0.01343137}, {90,0.01369608}, {91,0.01476471}, {92,0.01388235}, {93,0.01451961}, {94,0.01463725}, {95,0.01540196}, {96,0.01392157}, {97,0.01492157}, {98,0.01449020}, {99,0.01489216}, {100,0.01486275}, {101,0.01528431}, {102,0.01615686}, {103,0.01607843}, {104,0.01503922}, {105,0.01566667}, {106,0.01578431}, {107,0.01665686}, {108,0.01700000}, {109,0.01674510}, {110,0.01708824}, {111,0.01825490}, {112,0.01625490}, {113,0.01764706}, {114,0.01697059}, {115,0.01780392}, {116,0.01721569}, {117,0.01962745}, {118,0.01864706}, {119,0.01934314}, {120,0.01806863}, {121,0.01875490}, {122,0.01992157}, {123,0.01952941}, {124,0.01917647}, {125,0.02013725}, {126,0.02076471}, {127,0.02107843}, {128,0.01792157}, {129,0.01923529}, {130,0.01948039}, {131,0.02129412}, {132,0.01980392}, {133,0.02077451}, {134,0.02083333}, {135,0.02292157}, {136,0.02020588}, {137,0.02140196}, {138,0.02149020}, {139,0.02345098}, {140,0.02137255}, {141,0.02269608}, {142,0.02313725}, {143,0.02471569}, {144,0.02152941}, {145,0.02279412}, {146,0.02283333}, {147,0.02453922}, {148,0.02289216}, {149,0.02404902}, {150,0.02542157}, {151,0.02507843}, {152,0.02340196}, {153,0.02438235}, {154,0.02518627}, {155,0.02535294}, {156,0.02473529}, {157,0.02637255}, {158,0.02599020}, {159,0.02676471}, {160,0.02385294}, {161,0.02550980}, {162,0.02470588}, {163,0.02591176}, {164,0.02569608}, {165,0.02617647}, {166,0.02635294}, {167,0.02723529}, {168,0.02563725}, {169,0.02656863}, {170,0.02673529}, {171,0.02857843}, {172,0.02683333}, {173,0.02829412}, {174,0.02912745}, {175,0.02946078}, {176,0.02651961}, {177,0.02862745}, {178,0.02750000}, {179,0.02912745}, {180,0.02931373}, {181,0.02967647}, {182,0.02941176}, {183,0.03151961}, {184,0.02843137}, {185,0.03026471}, {186,0.03109804}, {187,0.03138235}, {188,0.02996078}, {189,0.03264706}, {190,0.03192157}, {191,0.03392157}, {192,0.02778431}, {193,0.02934314}, {194,0.03076471}, {195,0.03084314}, {196,0.02998039}, {197,0.03221569}, {198,0.03150980}, {199,0.03315686}, {200,0.03130392}, {201,0.03182353}, {202,0.03219608}, {203,0.03448039}, {204,0.03226471}, {205,0.03480392}, {206,0.03430392}, {207,0.03553922}, {208,0.03272549}, {209,0.03339216}, {210,0.03333333}, {211,0.03578431}, {212,0.03359804}, {213,0.03594118}, {214,0.03521569}, {215,0.03661765}, {216,0.03495098}, {217,0.03596078}, {218,0.03661765}, {219,0.03707843}, {220,0.03604902}, {221,0.03711765}, {222,0.03733333}, {223,0.03922549}, {224,0.03451961}, {225,0.03631373}, {226,0.03577451}, {227,0.03730392}, {228,0.03686275}, {229,0.03724510}, {230,0.03844118}, {231,0.03864706}, {232,0.03704902}, {233,0.03795098}, {234,0.03796078}, {235,0.04060784}, {236,0.03813725}, {237,0.04045098}, {238,0.03960784}, {239,0.04216667}, {240,0.03736275}, {241,0.03968627}, {242,0.03903922}, {243,0.04075490}, {244,0.04010784}, {245,0.04107843}, {246,0.04216667}, {247,0.04267647}, {248,0.04044118}, {249,0.04108824}, {250,0.04238235}, {251,0.04347059}, {252,0.04265686}, {253,0.04322549}, {254,0.04427451}, {255,0.04541176}, {256,0.03891176}, {257,0.03959804}, {258,0.04106863}, {259,0.04197059}, {260,0.04000980}, {261,0.04199020}, {262,0.04219608}, {263,0.04497059}, {264,0.04031373}, {265,0.04392157}, {266,0.04253922}, {267,0.04612745}, {268,0.04283333}, {269,0.04627451}, {270,0.04498039}, {271,0.04835294}, {272,0.04167647}, {273,0.04499020}, {274,0.04377451}, {275,0.04699020}, {276,0.04416667}, {277,0.04735294}, {278,0.04632353}, {279,0.04825490}, {280,0.04537255}, {281,0.04699020}, {282,0.04739216}, {283,0.04891176}, {284,0.04782353}, {285,0.04879412}, {286,0.04943137}, {287,0.05076471}, {288,0.04529412}, {289,0.04639216}, {290,0.04746078}, {291,0.04823529}, {292,0.04646078}, {293,0.04935294}, {294,0.04872549}, {295,0.05091176}, {296,0.04693137}, {297,0.05000000}, {298,0.04885294}, {299,0.05164706}, {300,0.04931373}, {301,0.05104902}, {302,0.05169608}, {303,0.05350000}, {304,0.04912745}, {305,0.04998039}, {306,0.05115686}, {307,0.05296078}, {308,0.05052941}, {309,0.05290196}, {310,0.05237255}, {311,0.05562745}, {312,0.05189216}, {313,0.05298039}, {314,0.05352941}, {315,0.05546078}, {316,0.05387255}, {317,0.05676471}, {318,0.05548039}, {319,0.05882353}, {320,0.04873529}, {321,0.05186275}, {322,0.05178431}, {323,0.05337255}, {324,0.05170588}, {325,0.05326471}, {326,0.05467647}, {327,0.05685294}, {328,0.05165686}, {329,0.05486275}, {330,0.05394118}, {331,0.05736275}, {332,0.05541176}, {333,0.05682353}, {334,0.05803922}, {335,0.05991176}, {336,0.05247059}, {337,0.05640196}, {338,0.05691176}, {339,0.05718627}, {340,0.05662745}, {341,0.05816667}, {342,0.05806863}, {343,0.06128431}, {344,0.05602941}, {345,0.05932353}, {346,0.05974510}, {347,0.06058824}, {348,0.05941176}, {349,0.06226471}, {350,0.06321569}, {351,0.06320588}, {352,0.05633333}, {353,0.05948039}, {354,0.05778431}, {355,0.06062745}, {356,0.05815686}, {357,0.06065686}, {358,0.06119608}, {359,0.06345098}, {360,0.05883333}, {361,0.06149020}, {362,0.06165686}, {363,0.06333333}, {364,0.06203922}, {365,0.06445098}, {366,0.06321569}, {367,0.06587255}, {368,0.06034314}, {369,0.06246078}, {370,0.06236275}, {371,0.06534314}, {372,0.06312745}, {373,0.06488235}, {374,0.06420588}, {375,0.06777451}, {376,0.06334314}, {377,0.06521569}, {378,0.06593137}, {379,0.06894118}, {380,0.06576471}, {381,0.06840196}, {382,0.06952941}, {383,0.07237255}, {384,0.05988235}, {385,0.06124510}, {386,0.06228431}, {387,0.06481373}, {388,0.06304902}, {389,0.06391176}, {390,0.06487255}, {391,0.06747059}, {392,0.06193137}, {393,0.06559804}, {394,0.06628431}, {395,0.06789216}, {396,0.06465686}, {397,0.06884314}, {398,0.06893137}, {399,0.07095098}, {400,0.06282353}, {401,0.06542157}, {402,0.06715686}, {403,0.06885294}, {404,0.06614706}, {405,0.06863725}, {406,0.07007843}, {407,0.07259804}, {408,0.06716667}, {409,0.06939216}, {410,0.07110784}, {411,0.07366667}, {412,0.07063725}, {413,0.07315686}, {414,0.07291176}, {415,0.07609804}, {416,0.06676471}, {417,0.06899020}, {418,0.06940196}, {419,0.07132353}, {420,0.06958824}, {421,0.07273529}, {422,0.07253922}, {423,0.07513725}, {424,0.06907843}, {425,0.07304902}, {426,0.07330392}, {427,0.07523529}, {428,0.07283333}, {429,0.07600980}, {430,0.07502941}, {431,0.07919608}, {432,0.07183333}, {433,0.07404902}, {434,0.07372549}, {435,0.07681373}, {436,0.07320588}, {437,0.07728431}, {438,0.07777451}, {439,0.08050000}, {440,0.07438235}, {441,0.07648039}, {442,0.07723529}, {443,0.08171569}, {444,0.07682353}, {445,0.08100000}, {446,0.08123529}, {447,0.08443137}, {448,0.07153922}, {449,0.07361765}, {450,0.07387255}, {451,0.07573529}, {452,0.07350980}, {453,0.07806863}, {454,0.07717647}, {455,0.08065686}, {456,0.07446078}, {457,0.07753922}, {458,0.07832353}, {459,0.08012745}, {460,0.07819608}, {461,0.08215686}, {462,0.08164706}, {463,0.08472549}, {464,0.07575490}, {465,0.07840196}, {466,0.07837255}, {467,0.08206863}, {468,0.07822549}, {469,0.08175490}, {470,0.08262745}, {471,0.08615686}, {472,0.08067647}, {473,0.08368627}, {474,0.08328431}, {475,0.08610784}, {476,0.08350000}, {477,0.08603922}, {478,0.08563725}, {479,0.08844118}, {480,0.07778431}, {481,0.08105882}, {482,0.08157843}, {483,0.08546078}, {484,0.08063725}, {485,0.08513725}, {486,0.08631373}, {487,0.08878431}, {488,0.08313725}, {489,0.08586275}, {490,0.08602941}, {491,0.08884314}, {492,0.08570588}, {493,0.08863725}, {494,0.08887255}, {495,0.09251961}, {496,0.08377451}, {497,0.08675490}, {498,0.08656863}, {499,0.08962745}, {500,0.08684314}, {505,0.09029412}, {510,0.09451961}, {515,0.08682353}, {520,0.08450980}, {525,0.09198039}, {530,0.08887255}, {535,0.09717647}, {540,0.09467647}, {545,0.09182353}, {550,0.09667647}, {555,0.10081373}, {560,0.09455882}, {565,0.10273529}, {570,0.10306863}, {575,0.10924510}, {580,0.09707843}, {585,0.10195098}, {590,0.10585294}, {595,0.10721569}, {600,0.10477451}, {605,0.11127451}, {610,0.10529412}, {615,0.11330392}, {620,0.11110784}, {625,0.11052941}, {630,0.11508824}, {635,0.12066667}, {640,0.10411765}, {645,0.11076471}, {650,0.11161765}, {655,0.12132353}, {660,0.11566667}, {665,0.11760784}, {670,0.12290196}, {675,0.12103922}, {680,0.11650980}, {685,0.12569608}, {690,0.12351961}, {695,0.13072549}, {700,0.12818627}, {705,0.11950980}, {710,0.12513725}, {715,0.13085294}, {720,0.12224510}, {725,0.13340196}, {730,0.13147059}, {735,0.14313725}, {740,0.12901961}, {745,0.13581373}, {750,0.13904902}, {755,0.14116667}, {760,0.13667647}, {765,0.14641176}, {770,0.12840196}, {775,0.13742157}, {780,0.13434314}, {785,0.13426471}, {790,0.14064706}, {795,0.14605882}, {800,0.13355882}, {805,0.14307843}, {810,0.14361765}, {815,0.15482353}, {820,0.14408824}, {825,0.15029412}, {830,0.15674510}, {835,0.14696078}, {840,0.14300980}, {845,0.15479412}, {850,0.14869608}, {855,0.15952941}, {860,0.15655882}, {865,0.15188235}, {870,0.15726471}, {875,0.16268627}, {880,0.15412745}, {885,0.16667647}, {890,0.16595098}, {895,0.17791176}, {900,0.15308824}, {905,0.15794118}, {910,0.16554902}, {915,0.16805882}, {920,0.16117647}, {925,0.17280392}, {930,0.16224510}, {935,0.17390196}, {940,0.16828431}, {945,0.16964706}, {950,0.17727451}, {955,0.18278431}, {960,0.16168627}, {965,0.17442157}, {970,0.17635294}, {975,0.18769608}, {980,0.17683333}, {985,0.18318627}, {990,0.19013725}, {995,0.18389216}, {1000,0.17836275}, {1010,0.18502941}, {1020,0.19248039}, {1030,0.17907843}, {1040,0.17364706}, {1050,0.18834314}, {1060,0.18366667}, {1070,0.19894118}, {1080,0.19403922}, {1090,0.18815686}, {1100,0.19506863}, {1110,0.20419608}, {1120,0.19274510}, {1130,0.20895098}, {1140,0.20787255}, {1150,0.22622549}, {1160,0.19922549}, {1170,0.20708824}, {1180,0.21710784}, {1190,0.21751961}, {1200,0.21165686}, {1210,0.22864706}, {1220,0.21554902}, {1230,0.23168627}, {1240,0.22579412}, {1250,0.22571569}, {1260,0.23753922}, {1270,0.24347059}, {1280,0.21120588}, {1290,0.22807843}, {1300,0.23002941}, {1310,0.24802941}, {1320,0.23206863}, {1330,0.24265686}, {1340,0.25272549}, {1350,0.24624510}, {1360,0.23816667}, {1370,0.25696078}, {1380,0.25057843}, {1390,0.26837255}, {1400,0.26259804}, {1410,0.24904902}, {1420,0.25645098}, {1430,0.26518627}, {1440,0.24978431}, {1450,0.26845098}, {1460,0.26976471}, {1470,0.29058824}, {1480,0.26627451}, {1490,0.27608824}, {1500,0.28702941}, {1510,0.28796078}, {1520,0.27929412}, {1530,0.29885294}, {1540,0.26550980}, {1550,0.28455882}, {1560,0.27622549}, {1570,0.27689216}, {1580,0.28663725}, {1590,0.29776471}, {1600,0.27233333}, {1610,0.29247059}, {1620,0.29318627}, {1630,0.31608824}, {1640,0.29633333}, {1650,0.30722549}, {1660,0.31961765}, {1670,0.30302941}, {1680,0.29412745}, {1690,0.31503922}, {1700,0.30500980}, {1710,0.32756863}, {1720,0.31959804}, {1730,0.31172549}, {1740,0.32221569}, {1750,0.33543137}, {1760,0.31578431}, {1770,0.33893137}, {1780,0.33724510}, {1790,0.36485294}, {1800,0.31464706}, {1810,0.32557843}, {1820,0.33687255}, {1830,0.34041176}, {1840,0.33162745}, {1850,0.35507843}, {1860,0.33337255}, {1870,0.35589216}, {1880,0.34641176}, {1890,0.34763725}, {1900,0.36092157}, {1910,0.37450000}, {1920,0.33173529}, {1930,0.35505882}, {1940,0.35528431}, {1950,0.38072549}, {1960,0.36362745}, {1970,0.37448039}, {1980,0.38849020}, {1990,0.37913725}, {2000,0.36669608}, {2050,0.35678431}, {2100,0.38750000}, {2150,0.40859804}, {2200,0.40656863}, {2250,0.42518627}, {2300,0.45953922}, {2350,0.45842157}, {2400,0.43681373}, {2450,0.46021569}, {2500,0.46723529}, {2550,0.51772549}, {2600,0.47421569}, {2650,0.51301961}, {2700,0.50307843}, {2750,0.56378431}, {2800,0.53368627}, {2850,0.52954902}, {2900,0.55764706}, {2950,0.56436275}, {3000,0.58953922}, {3050,0.61523529}, {3100,0.58483333}, {3150,0.61525490}, {3200,0.56403922}, {3250,0.62991176}, {3300,0.63964706}, {3350,0.64318627}, {3400,0.63606863}, {3450,0.70540196}, {3500,0.69406863}, {3550,0.74250000}, {3600,0.65063725}, {3650,0.68217647}, {3700,0.74019608}, {3750,0.74292157}, {3800,0.75260784}, {3850,0.73689216}, {3900,0.79262745}, {3950,0.82373529}, {4000,0.75954902}, {4050,0.81692157}, {4100,0.72993137}, {4150,0.81472549}, {4200,0.79872549}, {4250,0.84118627}, {4300,0.84462745}, {4350,0.93054902}, {4400,0.83707843}, {4450,0.88142157}, {4500,0.88045098}, {4550,0.91428431}, {4600,0.95195098}, {4650,0.90865686}, {4700,0.94655882}, {4750,0.95903922}, {4800,0.90328431}, {4850,1.00692157}, {4900,0.95137255}, {4950,1.02219608}, {5000,0.96961765}, {5050,1.06951961}, {5100,1.07927451}, {5150,1.04085294}, {5200,0.99000980}, {5250,0.99791176}, {5300,1.07062745}, {5350,1.10913725}, {5400,1.06350000}, {5450,1.10205882}, {5500,1.17094118}, {5550,1.17945098}, {5600,1.12505882}, {5650,1.10012745}, {5700,1.12726471}, {5750,1.22656863}, {5800,1.15828431}, {5850,1.24149020}, {5900,1.18569608}, {5950,1.30357843}, {6000,1.22170588}, {6050,1.30750}, {6100,1.32725}, {6150,1.21600}, {6200,1.25650}, {6250,1.30300}, {6300,1.30850}, {6350,1.36275}, {6400,1.20025}, {6450,1.33075}, {6500,1.34250}, {6550,1.39475}, {6600,1.37475}, {6650,1.50225}, {6700,1.39225}, {6750,1.47700}, {6800,1.35875}, {6850,1.40725}, {6900,1.50550}, {6950,1.47525}, {7000,1.47925}, {7050,1.49325}, {7100,1.59175}, {7150,1.64250}, {7200,1.38075}, {7250,1.48550}, {7300,1.45325}, {7350,1.59800}, {7400,1.56375}, {7450,1.57225}, {7500,1.57550}, {7550,1.73425}, {7600,1.58850}, {7650,1.65225}, {7700,1.57225}, {7750,1.63025}, {7800,1.68825}, {7850,1.69875}, {7900,1.77125}, {7950,1.72125}, {8000,1.62675}, {8050,1.77650}, {8100,1.74875}, {8150,1.85500}, {8200,1.56175}, {8250,1.73625}, {8300,1.73375}, {8350,1.79250}, {8400,1.70300}, {8450,1.65925}, {8500,1.75700}, {8550,1.82725}, {8600,1.77450}, {8650,1.83700}, {8700,1.95525}, {8750,1.86150}, {8800,1.74925}, {8850,1.82125}, {8900,1.83425}, {8950,2.01450}, {9000,1.84375}, {9050,1.98550}, {9100,1.92150}, {9150,2.09900}, {9200,1.99300}, {9250,1.83575}, {9300,1.91925}, {9350,1.93025}, {9400,2.00175}, {9450,2.05925}, {9500,2.02475}, {9550,2.08800}, {9600,1.89950}, {9650,2.09850}, {9700,2.09350}, {9750,2.07100}, {9800,2.01725}, {9850,2.20025}, {9900,2.13950}, {9950,2.28050}, {10000,2.04275}, {10100,2.24925}, {10200,2.27600}, {10300,2.18725}, {10400,2.07075}, {10500,2.09025}, {10600,2.24050}, {10700,2.32975}, {10800,2.23325}, {10900,2.30525}, {11000,2.45400}, {11100,2.48750}, {11200,2.34150}, {11300,2.31550}, {11400,2.31525}, {11500,2.56050}, {11600,2.43025}, {11700,2.59475}, {11800,2.46650}, {11900,2.70225}, {12000,2.56950}, {12100,2.58675}, {12200,2.70725}, {12300,2.43925}, {12400,2.54875}, {12500,2.64950}, {12600,2.66525}, {12700,2.77125}, {12800,2.44600}, {12900,2.71525}, {13000,2.74575}, {13100,2.87450}, {13200,2.77850}, {13300,3.07750}, {13400,2.85925}, {13500,3.02225}, {13600,2.76825}, {13700,2.89525}, {13800,3.10600}, {13900,3.01675}, {14000,3.04150}, {14100,3.04875}, {14200,3.26225}, {14300,3.37025}, {14400,2.86325}, {14500,3.06200}, {14600,2.98050}, {14700,3.29975}, {14800,3.21275}, {14900,3.22625}, {15000,3.23950}, {15100,3.57175}, {15200,3.28725}, {15300,3.41525}, {15400,3.23875}, {15500,3.35150}, {15600,3.45925}, {15700,3.49750}, {15800,3.62850}, {15900,3.55125}, {16000,3.33850}, {16100,3.64075}, {16200,3.59775}, {16300,3.79875}, {16400,3.23925}, {16500,3.54950}, {16600,3.59375}, {16700,3.72850}, {16800,3.51625}, {16900,3.42150}, {17000,3.65350}, {17100,3.79450}, {17200,3.68100}, {17300,3.80725}, {17400,4.09675}, {17500,3.89550}, {17600,3.66375}, {17700,3.79650}, {17800,3.85100}, {17900,4.18125}, {18000,3.85625}, {18100,4.10625}, {18200,3.99375}, {18300,4.39900}, {18400,4.14875}, {18500,3.82900}, {18600,3.96225}, {18700,4.01475}, {18800,4.14425}, {18900,4.28725}, {19000,4.20275}, {19100,4.36750}, {19200,3.97775}, {19300,4.36350}, {19400,4.37750}, {19500,4.28725}, {19600,4.18525}, {19700,4.57925}, {19800,4.47650}, {19900,4.73225}, {20000,4.23425}};
data["big_flat"]["Ltac2"]["reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00003922}, {5,0.00010784}, {6,0.00003922}, {7,0.00000000}, {8,0.00003922}, {9,0.00007843}, {10,0.00003922}, {11,0.00000000}, {12,0.00000000}, {13,0.00003922}, {14,0.00000000}, {15,0.00007843}, {16,0.00003922}, {17,0.00007843}, {18,0.00002941}, {19,0.00003922}, {20,0.00000000}, {21,0.00007843}, {22,0.00000000}, {23,0.00003922}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00003922}, {30,0.00007843}, {31,0.00002941}, {32,0.00003922}, {33,0.00003922}, {34,0.00000000}, {35,0.00003922}, {36,0.00003922}, {37,0.00000000}, {38,0.00000000}, {39,0.00003922}, {40,0.00003922}, {41,0.00011765}, {42,0.00000000}, {43,0.00007843}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00015686}, {48,0.00003922}, {49,0.00003922}, {50,0.00000000}, {51,0.00003922}, {52,0.00000000}, {53,0.00007843}, {54,0.00000000}, {55,0.00003922}, {56,0.00003922}, {57,0.00003922}, {58,0.00006863}, {59,0.00000000}, {60,0.00003922}, {61,0.00003922}, {62,0.00003922}, {63,0.00003922}, {64,0.00000000}, {65,0.00000000}, {66,0.00019608}, {67,0.00003922}, {68,0.00007843}, {69,0.00007843}, {70,0.00000000}, {71,0.00003922}, {72,0.00000000}, {73,0.00000000}, {74,0.00007843}, {75,0.00000000}, {76,0.00000000}, {77,0.00003922}, {78,0.00000000}, {79,0.00000000}, {80,0.00002941}, {81,0.00003922}, {82,0.00000000}, {83,0.00000000}, {84,0.00003922}, {85,0.00003922}, {86,0.00000000}, {87,0.00003922}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00003922}, {92,0.00000000}, {93,0.00003922}, {94,0.00010784}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00007843}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00007843}, {103,0.00007843}, {104,0.00000000}, {105,0.00003922}, {106,0.00003922}, {107,0.00007843}, {108,0.00000000}, {109,0.00007843}, {110,0.00007843}, {111,0.00003922}, {112,0.00000000}, {113,0.00007843}, {114,0.00003922}, {115,0.00007843}, {116,0.00000000}, {117,0.00003922}, {118,0.00006863}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00019608}, {124,0.00003922}, {125,0.00003922}, {126,0.00003922}, {127,0.00000000}, {128,0.00000000}, {129,0.00015686}, {130,0.00000000}, {131,0.00000000}, {132,0.00003922}, {133,0.00007843}, {134,0.00000000}, {135,0.00003922}, {136,0.00007843}, {137,0.00000000}, {138,0.00003922}, {139,0.00000000}, {140,0.00007843}, {141,0.00000000}, {142,0.00003922}, {143,0.00000000}, {144,0.00003922}, {145,0.00000000}, {146,0.00000000}, {147,0.00003922}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00006863}, {153,0.00003922}, {154,0.00000000}, {155,0.00003922}, {156,0.00000000}, {157,0.00007843}, {158,0.00006863}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00007843}, {163,0.00003922}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00011765}, {173,0.00003922}, {174,0.00003922}, {175,0.00000000}, {176,0.00006863}, {177,0.00000000}, {178,0.00011765}, {179,0.00000000}, {180,0.00006863}, {181,0.00000000}, {182,0.00000000}, {183,0.00003922}, {184,0.00015686}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00003922}, {191,0.00003922}, {192,0.00000000}, {193,0.00003922}, {194,0.00003922}, {195,0.00007843}, {196,0.00000000}, {197,0.00007843}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00003922}, {202,0.00000000}, {203,0.00000000}, {204,0.00003922}, {205,0.00000000}, {206,0.00007843}, {207,0.00000000}, {208,0.00003922}, {209,0.00000000}, {210,0.00000000}, {211,0.00007843}, {212,0.00000000}, {213,0.00003922}, {214,0.00003922}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00003922}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00003922}, {226,0.00003922}, {227,0.00000000}, {228,0.00000000}, {229,0.00002941}, {230,0.00000000}, {231,0.00003922}, {232,0.00000000}, {233,0.00003922}, {234,0.00002941}, {235,0.00003922}, {236,0.00000000}, {237,0.00003922}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00007843}, {243,0.00003922}, {244,0.00000000}, {245,0.00003922}, {246,0.00003922}, {247,0.00003922}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00007843}, {252,0.00003922}, {253,0.00003922}, {254,0.00000000}, {255,0.00000000}, {256,0.00003922}, {257,0.00000000}, {258,0.00007843}, {259,0.00000000}, {260,0.00003922}, {261,0.00000000}, {262,0.00000000}, {263,0.00003922}, {264,0.00000000}, {265,0.00003922}, {266,0.00000000}, {267,0.00003922}, {268,0.00000000}, {269,0.00000000}, {270,0.00006863}, {271,0.00000000}, {272,0.00003922}, {273,0.00003922}, {274,0.00007843}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00003922}, {279,0.00003922}, {280,0.00003922}, {281,0.00003922}, {282,0.00011765}, {283,0.00003922}, {284,0.00002941}, {285,0.00007843}, {286,0.00003922}, {287,0.00003922}, {288,0.00000000}, {289,0.00000000}, {290,0.00003922}, {291,0.00000000}, {292,0.00000000}, {293,0.00003922}, {294,0.00000000}, {295,0.00003922}, {296,0.00003922}, {297,0.00000000}, {298,0.00000000}, {299,0.00003922}, {300,0.00003922}, {301,0.00000000}, {302,0.00000000}, {303,0.00003922}, {304,0.00000000}, {305,0.00003922}, {306,0.00007843}, {307,0.00000000}, {308,0.00015686}, {309,0.00007843}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00003922}, {316,0.00011765}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00003922}, {321,0.00003922}, {322,0.00003922}, {323,0.00000000}, {324,0.00007843}, {325,0.00007843}, {326,0.00000000}, {327,0.00000000}, {328,0.00003922}, {329,0.00003922}, {330,0.00000000}, {331,0.00003922}, {332,0.00003922}, {333,0.00000000}, {334,0.00002941}, {335,0.00000000}, {336,0.00003922}, {337,0.00000000}, {338,0.00003922}, {339,0.00003922}, {340,0.00003922}, {341,0.00000000}, {342,0.00000000}, {343,0.00003922}, {344,0.00007843}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00003922}, {353,0.00007843}, {354,0.00000000}, {355,0.00003922}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00003922}, {364,0.00000000}, {365,0.00000000}, {366,0.00007843}, {367,0.00003922}, {368,0.00003922}, {369,0.00003922}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00003922}, {374,0.00003922}, {375,0.00003922}, {376,0.00003922}, {377,0.00003922}, {378,0.00003922}, {379,0.00003922}, {380,0.00000000}, {381,0.00000000}, {382,0.00007843}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00003922}, {388,0.00000000}, {389,0.00007843}, {390,0.00000000}, {391,0.00003922}, {392,0.00007843}, {393,0.00003922}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00003922}, {399,0.00000000}, {400,0.00011765}, {401,0.00003922}, {402,0.00007843}, {403,0.00000000}, {404,0.00003922}, {405,0.00003922}, {406,0.00000000}, {407,0.00000000}, {408,0.00007843}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00007843}, {415,0.00003922}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00003922}, {420,0.00003922}, {421,0.00000000}, {422,0.00006863}, {423,0.00000000}, {424,0.00000000}, {425,0.00003922}, {426,0.00003922}, {427,0.00003922}, {428,0.00000000}, {429,0.00007843}, {430,0.00003922}, {431,0.00015686}, {432,0.00000000}, {433,0.00003922}, {434,0.00007843}, {435,0.00003922}, {436,0.00003922}, {437,0.00007843}, {438,0.00003922}, {439,0.00000000}, {440,0.00007843}, {441,0.00007843}, {442,0.00010784}, {443,0.00006863}, {444,0.00003922}, {445,0.00007843}, {446,0.00010784}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00007843}, {451,0.00000000}, {452,0.00003922}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00003922}, {461,0.00003922}, {462,0.00007843}, {463,0.00007843}, {464,0.00007843}, {465,0.00000000}, {466,0.00000000}, {467,0.00017647}, {468,0.00003922}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00003922}, {474,0.00010784}, {475,0.00003922}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00002941}, {480,0.00000000}, {481,0.00003922}, {482,0.00015686}, {483,0.00007843}, {484,0.00003922}, {485,0.00000000}, {486,0.00000000}, {487,0.00003922}, {488,0.00000000}, {489,0.00003922}, {490,0.00000000}, {491,0.00007843}, {492,0.00003922}, {493,0.00000000}, {494,0.00000000}, {495,0.00007843}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00003922}, {500,0.00000000}, {505,0.00007843}, {510,0.00000000}, {515,0.00003922}, {520,0.00007843}, {525,0.00003922}, {530,0.00000000}, {535,0.00003922}, {540,0.00000000}, {545,0.00007843}, {550,0.00007843}, {555,0.00007843}, {560,0.00000000}, {565,0.00011765}, {570,0.00000000}, {575,0.00000000}, {580,0.00015686}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00003922}, {610,0.00000000}, {615,0.00007843}, {620,0.00003922}, {625,0.00003922}, {630,0.00003922}, {635,0.00000000}, {640,0.00003922}, {645,0.00000000}, {650,0.00000000}, {655,0.00002941}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00007843}, {680,0.00002941}, {685,0.00007843}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00007843}, {715,0.00003922}, {720,0.00000000}, {725,0.00003922}, {730,0.00003922}, {735,0.00003922}, {740,0.00003922}, {745,0.00007843}, {750,0.00011765}, {755,0.00007843}, {760,0.00011765}, {765,0.00003922}, {770,0.00000000}, {775,0.00003922}, {780,0.00003922}, {785,0.00007843}, {790,0.00003922}, {795,0.00007843}, {800,0.00000000}, {805,0.00007843}, {810,0.00000000}, {815,0.00003922}, {820,0.00003922}, {825,0.00000000}, {830,0.00007843}, {835,0.00003922}, {840,0.00003922}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00003922}, {865,0.00011765}, {870,0.00000000}, {875,0.00003922}, {880,0.00007843}, {885,0.00003922}, {890,0.00007843}, {895,0.00003922}, {900,0.00003922}, {905,0.00007843}, {910,0.00007843}, {915,0.00007843}, {920,0.00007843}, {925,0.00000000}, {930,0.00003922}, {935,0.00000000}, {940,0.00007843}, {945,0.00003922}, {950,0.00000000}, {955,0.00000000}, {960,0.00003922}, {965,0.00003922}, {970,0.00003922}, {975,0.00007843}, {980,0.00007843}, {985,0.00000000}, {990,0.00003922}, {995,0.00007843}, {1000,0.00003922}, {1010,0.00003922}, {1020,0.00000000}, {1030,0.00003922}, {1040,0.00003922}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00003922}, {1080,0.00007843}, {1090,0.00000000}, {1100,0.00007843}, {1110,0.00003922}, {1120,0.00003922}, {1130,0.00003922}, {1140,0.00000000}, {1150,0.00006863}, {1160,0.00003922}, {1170,0.00003922}, {1180,0.00000000}, {1190,0.00003922}, {1200,0.00000000}, {1210,0.00003922}, {1220,0.00011765}, {1230,0.00003922}, {1240,0.00000000}, {1250,0.00007843}, {1260,0.00000000}, {1270,0.00003922}, {1280,0.00003922}, {1290,0.00000000}, {1300,0.00003922}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00007843}, {1340,0.00003922}, {1350,0.00000000}, {1360,0.00002941}, {1370,0.00010784}, {1380,0.00003922}, {1390,0.00003922}, {1400,0.00011765}, {1410,0.00003922}, {1420,0.00003922}, {1430,0.00003922}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00003922}, {1470,0.00000000}, {1480,0.00007843}, {1490,0.00011765}, {1500,0.00000000}, {1510,0.00003922}, {1520,0.00006863}, {1530,0.00007843}, {1540,0.00007843}, {1550,0.00003922}, {1560,0.00003922}, {1570,0.00003922}, {1580,0.00003922}, {1590,0.00000000}, {1600,0.00003922}, {1610,0.00003922}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003922}, {1670,0.00000000}, {1680,0.00007843}, {1690,0.00015686}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00011765}, {1730,0.00000000}, {1740,0.00007843}, {1750,0.00007843}, {1760,0.00000000}, {1770,0.00011765}, {1780,0.00007843}, {1790,0.00003922}, {1800,0.00003922}, {1810,0.00003922}, {1820,0.00007843}, {1830,0.00014706}, {1840,0.00002941}, {1850,0.00000000}, {1860,0.00007843}, {1870,0.00011765}, {1880,0.00018627}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00007843}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00003922}, {1960,0.00007843}, {1970,0.00003922}, {1980,0.00007843}, {1990,0.00003922}, {2000,0.00000000}, {2050,0.00007843}, {2100,0.00011765}, {2150,0.00015686}, {2200,0.00019608}, {2250,0.00007843}, {2300,0.00015686}, {2350,0.00007843}, {2400,0.00005882}, {2450,0.00011765}, {2500,0.00000000}, {2550,0.00003922}, {2600,0.00003922}, {2650,0.00007843}, {2700,0.00015686}, {2750,0.00003922}, {2800,0.00003922}, {2850,0.00003922}, {2900,0.00000000}, {2950,0.00002941}, {3000,0.00003922}, {3050,0.00003922}, {3100,0.00003922}, {3150,0.00000000}, {3200,0.00011765}, {3250,0.00011765}, {3300,0.00007843}, {3350,0.00011765}, {3400,0.00003922}, {3450,0.00007843}, {3500,0.00003922}, {3550,0.00015686}, {3600,0.00003922}, {3650,0.00003922}, {3700,0.00003922}, {3750,0.00011765}, {3800,0.00011765}, {3850,0.00011765}, {3900,0.00003922}, {3950,0.00011765}, {4000,0.00007843}, {4050,0.00010784}, {4100,0.00019608}, {4150,0.00000000}, {4200,0.00015686}, {4250,0.00003922}, {4300,0.00014706}, {4350,0.00003922}, {4400,0.00007843}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00003922}, {4600,0.00011765}, {4650,0.00011765}, {4700,0.00015686}, {4750,0.00007843}, {4800,0.00015686}, {4850,0.00015686}, {4900,0.00018627}, {4950,0.00007843}, {5000,0.00003922}, {5050,0.00007843}, {5100,0.00014706}, {5150,0.00011765}, {5200,0.00003922}, {5250,0.00006863}, {5300,0.00007843}, {5350,0.00010784}, {5400,0.00023529}, {5450,0.00011765}, {5500,0.00029412}, {5550,0.00018627}, {5600,0.00003922}, {5650,0.00011765}, {5700,0.00015686}, {5750,0.00015686}, {5800,0.00017647}, {5850,0.00011765}, {5900,0.00023529}, {5950,0.00028431}, {6000,0.00010784}, {6050,0.00900}, {6100,0.00475}, {6150,0.00300}, {6200,0.00100}, {6250,0.00000}, {6300,0.00100}, {6350,0.00175}, {6400,0.00100}, {6450,0.00075}, {6500,0.00000}, {6550,0.00300}, {6600,0.01000}, {6650,0.00500}, {6700,0.00675}, {6750,0.00600}, {6800,0.00500}, {6850,0.00500}, {6900,0.00600}, {6950,0.00500}, {7000,0.00900}, {7050,0.00600}, {7100,0.00400}, {7150,0.00100}, {7200,0.00200}, {7250,0.00075}, {7300,0.00100}, {7350,0.00100}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00075}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00100}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00100}, {10700,0.00000}, {10800,0.00100}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00100}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00100}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00100}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00100}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00075}, {15300,0.00000}, {15400,0.00100}, {15500,0.00000}, {15600,0.00100}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00100}, {16100,0.00100}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00100}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00100}, {17700,0.00000}, {17800,0.00000}, {17900,0.00100}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00175}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00100}, {19000,0.00100}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00100}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["Ltac2LowLevel"]["Aggregate"]["real"] = {{1,0.00004902}, {2,0.00000000}, {3,0.00000980}, {4,0.00022549}, {5,0.00071569}, {6,0.00100000}, {7,0.00100000}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00100000}, {16,0.00100000}, {17,0.00100000}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00101961}, {22,0.00110784}, {23,0.00111765}, {24,0.00109804}, {25,0.00112745}, {26,0.01864706}, {27,0.00194118}, {28,0.00196078}, {29,0.00211765}, {30,0.00200000}, {31,0.00200000}, {32,0.00200000}, {33,0.00200000}, {34,0.00200000}, {35,0.00200000}, {36,0.00200000}, {37,0.00200000}, {38,0.00200000}, {39,0.00200000}, {40,0.00201961}, {41,0.00205882}, {42,0.00207843}, {43,0.00203922}, {44,0.00203922}, {45,0.00204902}, {46,0.00208824}, {47,0.00219608}, {48,0.00250000}, {49,0.00273529}, {50,0.00294118}, {51,0.00300000}, {52,0.00300000}, {53,0.00300000}, {54,0.00300000}, {55,0.00300000}, {56,0.00300000}, {57,0.00300000}, {58,0.00399020}, {59,0.00300980}, {60,0.00301961}, {61,0.00300980}, {62,0.00300000}, {63,0.00300980}, {64,0.00302941}, {65,0.00304902}, {66,0.00307843}, {67,0.00307843}, {68,0.00312745}, {69,0.00324510}, {70,0.00346078}, {71,0.00372549}, {72,0.00392157}, {73,0.00397059}, {74,0.00400000}, {75,0.00400000}, {76,0.00400000}, {77,0.00400000}, {78,0.00400980}, {79,0.00400980}, {80,0.00496078}, {81,0.00400980}, {82,0.00400000}, {83,0.00400980}, {84,0.00400980}, {85,0.00402941}, {86,0.00401961}, {87,0.00403922}, {88,0.00401961}, {89,0.00407843}, {90,0.00414706}, {91,0.00418627}, {92,0.00437255}, {93,0.00458824}, {94,0.00489216}, {95,0.00495098}, {96,0.00499020}, {97,0.00500000}, {98,0.00531373}, {99,0.00500000}, {100,0.00500000}, {101,0.00500000}, {102,0.00502941}, {103,0.00500000}, {104,0.00500000}, {105,0.00501961}, {106,0.00500980}, {107,0.00500980}, {108,0.00500980}, {109,0.00502941}, {110,0.00501961}, {111,0.00508824}, {112,0.00509804}, {113,0.00600980}, {114,0.00530392}, {115,0.00551961}, {116,0.00571569}, {117,0.00583333}, {118,0.00593137}, {119,0.00598039}, {120,0.00598039}, {121,0.00600000}, {122,0.00600000}, {123,0.00600000}, {124,0.00600000}, {125,0.00600980}, {126,0.00600000}, {127,0.00682353}, {128,0.00600980}, {129,0.00601961}, {130,0.00603922}, {131,0.00600980}, {132,0.00603922}, {133,0.00602941}, {134,0.00606863}, {135,0.00618627}, {136,0.00624510}, {137,0.00640196}, {138,0.00663725}, {139,0.00709804}, {140,0.00689216}, {141,0.00691176}, {142,0.00697059}, {143,0.00699020}, {144,0.00699020}, {145,0.00700000}, {146,0.00700980}, {147,0.00700000}, {148,0.00700980}, {149,0.00700000}, {150,0.00700000}, {151,0.00788235}, {152,0.00700980}, {153,0.00700980}, {154,0.00701961}, {155,0.00705882}, {156,0.00708824}, {157,0.00714706}, {158,0.00722549}, {159,0.00736275}, {160,0.00749020}, {161,0.00806863}, {162,0.00785294}, {163,0.00784314}, {164,0.00794118}, {165,0.00792157}, {166,0.00797059}, {167,0.00799020}, {168,0.00800000}, {169,0.00800000}, {170,0.00800000}, {171,0.00800000}, {172,0.00800980}, {173,0.00800000}, {174,0.00800000}, {175,0.00802941}, {176,0.00801961}, {177,0.00805882}, {178,0.00807843}, {179,0.00814706}, {180,0.00820588}, {181,0.00921569}, {182,0.00845098}, {183,0.00858824}, {184,0.00875490}, {185,0.00884314}, {186,0.00885294}, {187,0.00888235}, {188,0.00894118}, {189,0.00894118}, {190,0.00977451}, {191,0.00900000}, {192,0.00899020}, {193,0.00900000}, {194,0.00900980}, {195,0.00900980}, {196,0.00902941}, {197,0.00902941}, {198,0.00900980}, {199,0.00999020}, {200,0.00908824}, {201,0.00913725}, {202,0.00921569}, {203,0.00927451}, {204,0.00937255}, {205,0.00950980}, {206,0.00970588}, {207,0.01035294}, {208,0.00983333}, {209,0.00988235}, {210,0.00986275}, {211,0.00989216}, {212,0.00993137}, {213,0.00992157}, {214,0.00994118}, {215,0.01001961}, {216,0.01061765}, {217,0.01000980}, {218,0.01000980}, {219,0.01001961}, {220,0.01002941}, {221,0.01004902}, {222,0.01007843}, {223,0.01100980}, {224,0.01020588}, {225,0.01022549}, {226,0.01035294}, {227,0.01054902}, {228,0.01055882}, {229,0.01071569}, {230,0.01077451}, {231,0.01179412}, {232,0.01085294}, {233,0.01082353}, {234,0.01086275}, {235,0.01087255}, {236,0.01090196}, {237,0.01097059}, {238,0.01183333}, {239,0.01100000}, {240,0.01100000}, {241,0.01101961}, {242,0.01102941}, {243,0.01103922}, {244,0.01105882}, {245,0.01214706}, {246,0.01116667}, {247,0.01124510}, {248,0.01136275}, {249,0.01140196}, {250,0.01155882}, {251,0.01169608}, {252,0.01256863}, {253,0.01178431}, {254,0.01182353}, {255,0.01181373}, {256,0.01185294}, {257,0.01188235}, {258,0.01187255}, {259,0.01281373}, {260,0.01195098}, {261,0.01198039}, {262,0.01200000}, {263,0.01200980}, {264,0.01202941}, {265,0.01201961}, {266,0.01290196}, {267,0.01207843}, {268,0.01216667}, {269,0.01215686}, {270,0.01229412}, {271,0.01236275}, {272,0.01326471}, {273,0.01266667}, {274,0.01272549}, {275,0.01276471}, {276,0.01280392}, {277,0.01284314}, {278,0.01287255}, {279,0.01319608}, {280,0.01288235}, {281,0.01289216}, {282,0.01290196}, {283,0.01297059}, {284,0.01300000}, {285,0.01404902}, {286,0.01303922}, {287,0.01308824}, {288,0.01307843}, {289,0.01309804}, {290,0.01314706}, {291,0.01405882}, {292,0.01324510}, {293,0.01332353}, {294,0.01349020}, {295,0.01361765}, {296,0.01373529}, {297,0.01428431}, {298,0.01378431}, {299,0.01382353}, {300,0.01383333}, {301,0.01383333}, {302,0.01386275}, {303,0.01480392}, {304,0.01390196}, {305,0.01392157}, {306,0.01398039}, {307,0.01401961}, {308,0.01531373}, {309,0.01404902}, {310,0.01409804}, {311,0.01409804}, {312,0.01414706}, {313,0.01419608}, {314,0.01510784}, {315,0.01433333}, {316,0.01450980}, {317,0.01461765}, {318,0.01468627}, {319,0.01474510}, {320,0.01480392}, {321,0.01481373}, {322,0.01484314}, {323,0.01482353}, {324,0.01486275}, {325,0.01580392}, {326,0.01488235}, {327,0.01490196}, {328,0.01493137}, {329,0.01498039}, {330,0.01588235}, {331,0.01506863}, {332,0.01509804}, {333,0.01513725}, {334,0.01516667}, {335,0.01522549}, {336,0.01585294}, {337,0.01543137}, {338,0.01550000}, {339,0.01559804}, {340,0.01567647}, {341,0.01636275}, {342,0.01578431}, {343,0.01581373}, {344,0.01583333}, {345,0.01583333}, {346,0.01677451}, {347,0.01586275}, {348,0.01587255}, {349,0.01589216}, {350,0.01594118}, {351,0.01686275}, {352,0.01600000}, {353,0.01602941}, {354,0.01607843}, {355,0.01614706}, {356,0.01705882}, {357,0.01624510}, {358,0.01633333}, {359,0.01639216}, {360,0.01650000}, {361,0.01736275}, {362,0.01663725}, {363,0.01671569}, {364,0.01676471}, {365,0.01678431}, {366,0.01753922}, {367,0.01683333}, {368,0.01685294}, {369,0.01689216}, {370,0.02041176}, {371,0.01693137}, {372,0.01695098}, {373,0.01696078}, {374,0.01700000}, {375,0.01814706}, {376,0.01712745}, {377,0.01713725}, {378,0.01715686}, {379,0.01726471}, {380,0.01825490}, {381,0.01743137}, {382,0.01751961}, {383,0.01759804}, {384,0.01766667}, {385,0.01770588}, {386,0.01776471}, {387,0.01778431}, {388,0.01780392}, {389,0.01880392}, {390,0.01785294}, {391,0.01785294}, {392,0.01787255}, {393,0.01789216}, {394,0.01877451}, {395,0.01791176}, {396,0.01801961}, {397,0.01800000}, {398,0.01907843}, {399,0.01815686}, {400,0.01826471}, {401,0.01829412}, {402,0.01971569}, {403,0.01850000}, {404,0.01850980}, {405,0.01855882}, {406,0.01867647}, {407,0.01962745}, {408,0.01873529}, {409,0.01876471}, {410,0.01879412}, {411,0.01980392}, {412,0.01882353}, {413,0.01882353}, {414,0.01881373}, {415,0.01995098}, {416,0.01886275}, {417,0.01892157}, {418,0.01895098}, {419,0.01900000}, {420,0.01987255}, {421,0.01912745}, {422,0.01920588}, {423,0.01929412}, {424,0.02010784}, {425,0.01944118}, {426,0.01952941}, {427,0.01961765}, {428,0.02064706}, {429,0.01967647}, {430,0.01974510}, {431,0.01976471}, {432,0.02080392}, {433,0.01981373}, {434,0.01980392}, {435,0.01982353}, {436,0.02083333}, {437,0.01987255}, {438,0.01993137}, {439,0.01996078}, {440,0.02106863}, {441,0.02003922}, {442,0.02005882}, {443,0.02012745}, {444,0.02129412}, {445,0.02029412}, {446,0.02038235}, {447,0.02046078}, {448,0.02156863}, {449,0.02059804}, {450,0.02063725}, {451,0.02069608}, {452,0.02175490}, {453,0.02075490}, {454,0.02077451}, {455,0.02079412}, {456,0.02181373}, {457,0.02081373}, {458,0.02084314}, {459,0.02083333}, {460,0.02189216}, {461,0.02089216}, {462,0.02097059}, {463,0.02104902}, {464,0.02195098}, {465,0.02112745}, {466,0.02118627}, {467,0.02130392}, {468,0.02204902}, {469,0.02147059}, {470,0.02151961}, {471,0.02283333}, {472,0.02160784}, {473,0.02168627}, {474,0.02175490}, {475,0.02278431}, {476,0.02175490}, {477,0.02178431}, {478,0.02179412}, {479,0.02280392}, {480,0.02183333}, {481,0.02187255}, {482,0.02191176}, {483,0.02278431}, {484,0.02197059}, {485,0.02200980}, {486,0.02318627}, {487,0.02216667}, {488,0.02225490}, {489,0.02233333}, {490,0.02339216}, {491,0.02249020}, {492,0.02252941}, {493,0.02259804}, {494,0.02338235}, {495,0.02267647}, {496,0.02272549}, {497,0.02438235}, {498,0.02278431}, {499,0.02277451}, {500,0.02281373}, {505,0.02386275}, {510,0.02314706}, {515,0.02355882}, {520,0.02481373}, {525,0.02385294}, {530,0.02399020}, {535,0.02432353}, {540,0.02571569}, {545,0.02480392}, {550,0.02491176}, {555,0.02685294}, {560,0.02559804}, {565,0.02578431}, {570,0.02695098}, {575,0.02608824}, {580,0.02643137}, {585,0.02778431}, {590,0.02681373}, {595,0.02697059}, {600,0.02846078}, {605,0.02752941}, {610,0.02778431}, {615,0.02905882}, {620,0.02812745}, {625,0.02839216}, {630,0.02975490}, {635,0.02885294}, {640,0.02903922}, {645,0.03028431}, {650,0.02959804}, {655,0.02978431}, {660,0.03045098}, {665,0.03008824}, {670,0.03177451}, {675,0.03069608}, {680,0.03086275}, {685,0.03213725}, {690,0.03132353}, {695,0.03348039}, {700,0.03188235}, {705,0.03195098}, {710,0.03349020}, {715,0.03245098}, {720,0.03269608}, {725,0.03341176}, {730,0.03304902}, {735,0.03462745}, {740,0.03356863}, {745,0.03529412}, {750,0.03397059}, {755,0.03418627}, {760,0.03567647}, {765,0.03469608}, {770,0.03624510}, {775,0.03508824}, {780,0.03744118}, {785,0.03559804}, {790,0.03573529}, {795,0.03723529}, {800,0.03621569}, {805,0.03769608}, {810,0.03666667}, {815,0.03836275}, {820,0.03714706}, {825,0.03902941}, {830,0.03759804}, {835,0.03775490}, {840,0.03990196}, {845,0.03823529}, {850,0.04065686}, {855,0.03866667}, {860,0.04015686}, {865,0.03911765}, {870,0.04063725}, {875,0.03961765}, {880,0.04113725}, {885,0.04006863}, {890,0.04160784}, {895,0.04044118}, {900,0.04210784}, {905,0.04091176}, {910,0.04254902}, {915,0.04139216}, {920,0.04305882}, {925,0.04174510}, {930,0.04344118}, {935,0.04227451}, {940,0.04383333}, {945,0.04273529}, {950,0.04423529}, {955,0.04309804}, {960,0.04458824}, {965,0.04360784}, {970,0.04464706}, {975,0.04575490}, {980,0.04435294}, {985,0.04625490}, {990,0.04478431}, {995,0.04659804}, {1000,0.04530392}, {1010,0.04709804}, {1020,0.04614706}, {1030,0.04779412}, {1040,0.04895098}, {1050,0.04748039}, {1060,0.05037255}, {1070,0.04836275}, {1080,0.05027451}, {1090,0.05206863}, {1100,0.04976471}, {1110,0.05198039}, {1120,0.05063725}, {1130,0.05254902}, {1140,0.05340196}, {1150,0.05200000}, {1160,0.05394118}, {1170,0.05606863}, {1180,0.05337255}, {1190,0.05571569}, {1200,0.05421569}, {1210,0.05469608}, {1220,0.05767647}, {1230,0.05855882}, {1240,0.05603922}, {1250,0.05826471}, {1260,0.05900000}, {1270,0.05735294}, {1280,0.05938235}, {1290,0.06017647}, {1300,0.05871569}, {1310,0.06208824}, {1320,0.06248039}, {1330,0.06231373}, {1340,0.06061765}, {1350,0.06261765}, {1360,0.06338235}, {1370,0.06425490}, {1380,0.06237255}, {1390,0.06450980}, {1400,0.06512745}, {1410,0.06578431}, {1420,0.06418627}, {1430,0.06542157}, {1440,0.06692157}, {1450,0.06756863}, {1460,0.06825490}, {1470,0.06644118}, {1480,0.06763725}, {1490,0.06970588}, {1500,0.06981373}, {1510,0.07051961}, {1520,0.07213725}, {1530,0.06914706}, {1540,0.07423529}, {1550,0.07362745}, {1560,0.07237255}, {1570,0.07304902}, {1580,0.07373529}, {1590,0.07501961}, {1600,0.07227451}, {1610,0.07624510}, {1620,0.07497059}, {1630,0.07540196}, {1640,0.07593137}, {1650,0.07654902}, {1660,0.07725490}, {1670,0.07767647}, {1680,0.07832353}, {1690,0.07883333}, {1700,0.08218627}, {1710,0.08150000}, {1720,0.07763725}, {1730,0.07891176}, {1740,0.08098039}, {1750,0.08291176}, {1760,0.08150000}, {1770,0.08190196}, {1780,0.08240196}, {1790,0.08282353}, {1800,0.08332353}, {1810,0.08371569}, {1820,0.08424510}, {1830,0.08464706}, {1840,0.08508824}, {1850,0.08559804}, {1860,0.08609804}, {1870,0.08649020}, {1880,0.08686275}, {1890,0.08727451}, {1900,0.09036275}, {1910,0.08946078}, {1920,0.09201961}, {1930,0.09402941}, {1940,0.09100980}, {1950,0.09103922}, {1960,0.09138235}, {1970,0.09190196}, {1980,0.09223529}, {1990,0.09264706}, {2000,0.09271569}, {2050,0.09494118}, {2100,0.09726471}, {2150,0.10026471}, {2200,0.10276471}, {2250,0.10486275}, {2300,0.10700000}, {2350,0.11251961}, {2400,0.11617647}, {2450,0.11419608}, {2500,0.11699020}, {2550,0.11944118}, {2600,0.12118627}, {2650,0.12627451}, {2700,0.12626471}, {2750,0.12936275}, {2800,0.13100980}, {2850,0.13386275}, {2900,0.13699020}, {2950,0.14114706}, {3000,0.14102941}, {3050,0.14606863}, {3100,0.14659804}, {3150,0.14815686}, {3200,0.15109804}, {3250,0.15714706}, {3300,0.15659804}, {3350,0.16568627}, {3400,0.16081373}, {3450,0.16335294}, {3500,0.16590196}, {3550,0.16866667}, {3600,0.17087255}, {3650,0.17351961}, {3700,0.17570588}, {3750,0.17830392}, {3800,0.18056863}, {3850,0.18294118}, {3900,0.18522549}, {3950,0.18759804}, {4000,0.19644118}, {4050,0.19561765}, {4100,0.20090196}, {4150,0.19777451}, {4200,0.20950980}, {4250,0.20345098}, {4300,0.20533333}, {4350,0.21369608}, {4400,0.21097059}, {4450,0.21197059}, {4500,0.21450000}, {4550,0.21723529}, {4600,0.22012745}, {4650,0.22182353}, {4700,0.22496078}, {4750,0.22801961}, {4800,0.22991176}, {4850,0.24173529}, {4900,0.23764706}, {4950,0.23843137}, {5000,0.24448039}, {5050,0.24253922}, {5100,0.24856863}, {5150,0.24801961}, {5200,0.24772549}, {5250,0.25962745}, {5300,0.25263725}, {5350,0.25556863}, {5400,0.25797059}, {5450,0.25996078}, {5500,0.26193137}, {5550,0.26489216}, {5600,0.26623529}, {5650,0.26907843}, {5700,0.27159804}, {5750,0.28725490}, {5800,0.28291176}, {5850,0.27972549}, {5900,0.28429412}, {5950,0.28655882}, {6000,0.30925490}, {6050,0.31127451}, {6100,0.30440196}, {6150,0.31344118}, {6200,0.31037255}, {6250,0.30429412}, {6300,0.30289216}, {6350,0.30934314}, {6400,0.33167647}, {6450,0.31418627}, {6500,0.32612745}, {6550,0.31994118}, {6600,0.32219608}, {6650,0.32970588}, {6700,0.32842157}, {6750,0.33153922}, {6800,0.33398039}, {6850,0.33623529}, {6900,0.33666667}, {6950,0.34893137}, {7000,0.35364706}, {7050,0.35121569}, {7100,0.35355882}, {7150,0.35075490}, {7200,0.35690196}, {7250,0.35529412}, {7300,0.35548039}, {7350,0.35891176}, {7400,0.36352941}, {7450,0.36412745}, {7500,0.37066667}, {7550,0.37222549}, {7600,0.38961765}, {7650,0.37528431}, {7700,0.39230392}, {7750,0.37905882}, {7800,0.37862745}, {7850,0.38483333}, {7900,0.40338235}, {7950,0.39050980}, {8000,0.39238235}, {8050,0.41111765}, {8100,0.40935294}, {8150,0.40407843}, {8200,0.40425490}, {8250,0.40971569}, {8300,0.41566667}, {8350,0.41535294}, {8400,0.41772549}, {8450,0.43995098}, {8500,0.41823529}, {8550,0.42332353}, {8600,0.44315686}, {8650,0.42806863}, {8700,0.42768627}, {8750,0.45354902}, {8800,0.45032353}, {8850,0.44467647}, {8900,0.44036275}, {8950,0.44582353}, {9000,0.44204902}, {9050,0.44619608}, {9100,0.44943137}, {9150,0.45447059}, {9200,0.45477451}, {9250,0.45750980}, {9300,0.45952941}, {9350,0.45912745}, {9400,0.47475490}, {9450,0.46907843}, {9500,0.48524510}, {9550,0.49537255}, {9600,0.47677451}, {9650,0.48348039}, {9700,0.50426471}, {9750,0.50796078}, {9800,0.49239216}, {9850,0.49536275}, {9900,0.51911765}, {9950,0.48121569}, {10000,0.50917647}, {10100,0.49120588}, {10200,0.51900000}, {10300,0.52259804}, {10400,0.54622549}, {10500,0.52586275}, {10600,0.53746078}, {10700,0.53296078}, {10800,0.55750980}, {10900,0.57189216}, {11000,0.58810784}, {11100,0.59728431}, {11200,0.57328431}, {11300,0.56398039}, {11400,0.57964706}, {11500,0.58094118}, {11600,0.62209804}, {11700,0.60715686}, {11800,0.60209804}, {11900,0.61227451}, {12000,0.62060784}, {12100,0.63055882}, {12200,0.62011765}, {12300,0.64255882}, {12400,0.63132353}, {12500,0.66791176}, {12600,0.65797059}, {12700,0.64532353}, {12800,0.66116667}, {12900,0.66783333}, {13000,0.66998039}, {13100,0.67847059}, {13200,0.68146078}, {13300,0.69715686}, {13400,0.71267647}, {13500,0.68164706}, {13600,0.71212745}, {13700,0.69922549}, {13800,0.73314706}, {13900,0.69801961}, {14000,0.73861765}, {14100,0.74323529}, {14200,0.71767647}, {14300,0.73588235}, {14400,0.76835294}, {14500,0.78701961}, {14600,0.78628431}, {14700,0.78426471}, {14800,0.79996078}, {14900,0.79738235}, {15000,0.75221569}, {15100,0.78672549}, {15200,0.80978431}, {15300,0.81285294}, {15400,0.79038235}, {15500,0.82874510}, {15600,0.83089216}, {15700,0.80328431}, {15800,0.82850000}, {15900,0.86654902}, {16000,0.82368627}, {16100,0.83271569}, {16200,0.89172549}, {16300,0.88964706}, {16400,0.86964706}, {16500,0.88215686}, {16600,0.88966667}, {16700,0.90354902}, {16800,0.90774510}, {16900,0.87402941}, {17000,0.90404902}, {17100,0.88627451}, {17200,0.90621569}, {17300,0.88786275}, {17400,0.92972549}, {17500,0.92222549}, {17600,0.90727451}, {17700,0.90918627}, {17800,0.92904902}, {17900,0.97869608}, {18000,0.88949020}, {18100,0.90752941}, {18200,0.92794118}, {18300,0.94597059}, {18400,0.94718627}, {18500,0.93448039}, {18600,0.94620588}, {18700,1.01111765}, {18800,1.02148039}, {18900,0.99596078}, {19000,1.01561765}, {19100,1.05342157}, {19200,0.99654902}, {19300,1.04122549}, {19400,1.02890196}, {19500,1.04600000}, {19600,1.02118627}, {19700,1.07364706}, {19800,1.09132353}, {19900,1.03231373}, {20000,1.03786275}};
data["big_flat"]["Ltac2LowLevel"]["Aggregate"]["user"] = {{1,0.00040196}, {2,0.00053922}, {3,0.00051961}, {4,0.00083333}, {5,0.00087255}, {6,0.00091176}, {7,0.00084314}, {8,0.00106863}, {9,0.00089216}, {10,0.00116667}, {11,0.00108824}, {12,0.00126471}, {13,0.00125490}, {14,0.00134314}, {15,0.00140196}, {16,0.00142157}, {17,0.00139216}, {18,0.00149020}, {19,0.00131373}, {20,0.00170588}, {21,0.00142157}, {22,0.00164706}, {23,0.00144118}, {24,0.00168627}, {25,0.00163725}, {26,0.01834314}, {27,0.00174510}, {28,0.00199020}, {29,0.00198039}, {30,0.00204902}, {31,0.00185294}, {32,0.00186275}, {33,0.00242157}, {34,0.00206863}, {35,0.00212745}, {36,0.00221569}, {37,0.00223529}, {38,0.00207843}, {39,0.00228431}, {40,0.00254902}, {41,0.00250980}, {42,0.00243137}, {43,0.00226471}, {44,0.00254902}, {45,0.00257843}, {46,0.00269608}, {47,0.00286275}, {48,0.00260784}, {49,0.00257843}, {50,0.00271569}, {51,0.00302941}, {52,0.00290196}, {53,0.00277451}, {54,0.00299020}, {55,0.00300980}, {56,0.00286275}, {57,0.00300000}, {58,0.00398039}, {59,0.00312745}, {60,0.00312745}, {61,0.00318627}, {62,0.00328431}, {63,0.00332353}, {64,0.00322549}, {65,0.00345098}, {66,0.00338235}, {67,0.00344118}, {68,0.00352941}, {69,0.00350000}, {70,0.00350980}, {71,0.00368627}, {72,0.00364706}, {73,0.00366667}, {74,0.00389216}, {75,0.00389216}, {76,0.00379412}, {77,0.00399020}, {78,0.00412745}, {79,0.00373529}, {80,0.00481373}, {81,0.00383333}, {82,0.00410784}, {83,0.00422549}, {84,0.00415686}, {85,0.00408824}, {86,0.00419608}, {87,0.00423529}, {88,0.00444118}, {89,0.00441176}, {90,0.00459804}, {91,0.00430392}, {92,0.00461765}, {93,0.00480392}, {94,0.00445098}, {95,0.00450000}, {96,0.00448039}, {97,0.00468627}, {98,0.00546078}, {99,0.00463725}, {100,0.00511765}, {101,0.00473529}, {102,0.00492157}, {103,0.00497059}, {104,0.00492157}, {105,0.00509804}, {106,0.00501961}, {107,0.00514706}, {108,0.00517647}, {109,0.00516667}, {110,0.00523529}, {111,0.00535294}, {112,0.00539216}, {113,0.00573529}, {114,0.00533333}, {115,0.00540196}, {116,0.00548039}, {117,0.00558824}, {118,0.00545098}, {119,0.00561765}, {120,0.00555882}, {121,0.00565686}, {122,0.00574510}, {123,0.00571569}, {124,0.00592157}, {125,0.00584314}, {126,0.00583333}, {127,0.00638235}, {128,0.00610784}, {129,0.00595098}, {130,0.00592157}, {131,0.00609804}, {132,0.00588235}, {133,0.00611765}, {134,0.00641176}, {135,0.00602941}, {136,0.00634314}, {137,0.00653922}, {138,0.00640196}, {139,0.00700980}, {140,0.00647059}, {141,0.00636275}, {142,0.00634314}, {143,0.00655882}, {144,0.00684314}, {145,0.00657843}, {146,0.00636275}, {147,0.00668627}, {148,0.00647059}, {149,0.00650980}, {150,0.00677451}, {151,0.00747059}, {152,0.00694118}, {153,0.00700000}, {154,0.00700980}, {155,0.00703922}, {156,0.00699020}, {157,0.00719608}, {158,0.00716667}, {159,0.00718627}, {160,0.00716667}, {161,0.00788235}, {162,0.00724510}, {163,0.00737255}, {164,0.00728431}, {165,0.00759804}, {166,0.00741176}, {167,0.00759804}, {168,0.00769608}, {169,0.00756863}, {170,0.00766667}, {171,0.00760784}, {172,0.00756863}, {173,0.00804902}, {174,0.00802941}, {175,0.00800980}, {176,0.00816667}, {177,0.00803922}, {178,0.00812745}, {179,0.00815686}, {180,0.00813725}, {181,0.00927451}, {182,0.00821569}, {183,0.00818627}, {184,0.00850000}, {185,0.00873529}, {186,0.00873529}, {187,0.00853922}, {188,0.00860784}, {189,0.00848039}, {190,0.00943137}, {191,0.00891176}, {192,0.00872549}, {193,0.00887255}, {194,0.00856863}, {195,0.00907843}, {196,0.00881373}, {197,0.00925490}, {198,0.00867647}, {199,0.01025490}, {200,0.00912745}, {201,0.00914706}, {202,0.00951961}, {203,0.00935294}, {204,0.00951961}, {205,0.00969608}, {206,0.00943137}, {207,0.01025490}, {208,0.01049020}, {209,0.00961765}, {210,0.00930392}, {211,0.00998039}, {212,0.01013725}, {213,0.00950980}, {214,0.01000000}, {215,0.01009804}, {216,0.01076471}, {217,0.01030392}, {218,0.01008824}, {219,0.01016667}, {220,0.01015686}, {221,0.01046078}, {222,0.01040196}, {223,0.01145098}, {224,0.01021569}, {225,0.01000000}, {226,0.01032353}, {227,0.01056863}, {228,0.01065686}, {229,0.01093137}, {230,0.01083333}, {231,0.01202941}, {232,0.01108824}, {233,0.01117647}, {234,0.01113725}, {235,0.01138235}, {236,0.01126471}, {237,0.01128431}, {238,0.01203922}, {239,0.01109804}, {240,0.01112745}, {241,0.01136275}, {242,0.01149020}, {243,0.01130392}, {244,0.01122549}, {245,0.01227451}, {246,0.01144118}, {247,0.01179412}, {248,0.01181373}, {249,0.01178431}, {250,0.01168627}, {251,0.01194118}, {252,0.01263725}, {253,0.01184314}, {254,0.01186275}, {255,0.01201961}, {256,0.01215686}, {257,0.01215686}, {258,0.01213725}, {259,0.01305882}, {260,0.01227451}, {261,0.01226471}, {262,0.01255882}, {263,0.01223529}, {264,0.01233333}, {265,0.01271569}, {266,0.01299020}, {267,0.01247059}, {268,0.01265686}, {269,0.01256863}, {270,0.01260784}, {271,0.01307843}, {272,0.01317647}, {273,0.01295098}, {274,0.01286275}, {275,0.01299020}, {276,0.01265686}, {277,0.01322549}, {278,0.01285294}, {279,0.01382353}, {280,0.01296078}, {281,0.01306863}, {282,0.01300000}, {283,0.01308824}, {284,0.01323529}, {285,0.01377451}, {286,0.01342157}, {287,0.01332353}, {288,0.01329412}, {289,0.01353922}, {290,0.01333333}, {291,0.01435294}, {292,0.01355882}, {293,0.01316667}, {294,0.01367647}, {295,0.01348039}, {296,0.01340196}, {297,0.01446078}, {298,0.01392157}, {299,0.01386275}, {300,0.01370588}, {301,0.01428431}, {302,0.01380392}, {303,0.01446078}, {304,0.01386275}, {305,0.01388235}, {306,0.01397059}, {307,0.01425490}, {308,0.01527451}, {309,0.01434314}, {310,0.01434314}, {311,0.01437255}, {312,0.01448039}, {313,0.01404902}, {314,0.01515686}, {315,0.01438235}, {316,0.01446078}, {317,0.01464706}, {318,0.01445098}, {319,0.01471569}, {320,0.01478431}, {321,0.01502941}, {322,0.01489216}, {323,0.01504902}, {324,0.01494118}, {325,0.01559804}, {326,0.01469608}, {327,0.01508824}, {328,0.01505882}, {329,0.01489216}, {330,0.01572549}, {331,0.01506863}, {332,0.01517647}, {333,0.01529412}, {334,0.01517647}, {335,0.01548039}, {336,0.01578431}, {337,0.01555882}, {338,0.01534314}, {339,0.01577451}, {340,0.01539216}, {341,0.01617647}, {342,0.01546078}, {343,0.01563725}, {344,0.01565686}, {345,0.01572549}, {346,0.01669608}, {347,0.01592157}, {348,0.01588235}, {349,0.01600980}, {350,0.01582353}, {351,0.01674510}, {352,0.01599020}, {353,0.01614706}, {354,0.01600000}, {355,0.01603922}, {356,0.01727451}, {357,0.01600000}, {358,0.01613725}, {359,0.01640196}, {360,0.01621569}, {361,0.01702941}, {362,0.01639216}, {363,0.01624510}, {364,0.01636275}, {365,0.01663725}, {366,0.01709804}, {367,0.01673529}, {368,0.01652941}, {369,0.01689216}, {370,0.02002941}, {371,0.01694118}, {372,0.01662745}, {373,0.01672549}, {374,0.01701961}, {375,0.01806863}, {376,0.01679412}, {377,0.01718627}, {378,0.01718627}, {379,0.01695098}, {380,0.01771569}, {381,0.01748039}, {382,0.01694118}, {383,0.01715686}, {384,0.01739216}, {385,0.01704902}, {386,0.01737255}, {387,0.01748039}, {388,0.01733333}, {389,0.01822549}, {390,0.01746078}, {391,0.01744118}, {392,0.01777451}, {393,0.01775490}, {394,0.01812745}, {395,0.01781373}, {396,0.01788235}, {397,0.01753922}, {398,0.01884314}, {399,0.01787255}, {400,0.01777451}, {401,0.01779412}, {402,0.01933333}, {403,0.01802941}, {404,0.01800980}, {405,0.01803922}, {406,0.01809804}, {407,0.01908824}, {408,0.01840196}, {409,0.01851961}, {410,0.01856863}, {411,0.01957843}, {412,0.01867647}, {413,0.01825490}, {414,0.01853922}, {415,0.01958824}, {416,0.01840196}, {417,0.01842157}, {418,0.01857843}, {419,0.01857843}, {420,0.01951961}, {421,0.01883333}, {422,0.01880392}, {423,0.01883333}, {424,0.01999020}, {425,0.01893137}, {426,0.01902941}, {427,0.01919608}, {428,0.01998039}, {429,0.01920588}, {430,0.01909804}, {431,0.01938235}, {432,0.02018627}, {433,0.01949020}, {434,0.01932353}, {435,0.01935294}, {436,0.02103922}, {437,0.01932353}, {438,0.01942157}, {439,0.01967647}, {440,0.02071569}, {441,0.02002941}, {442,0.01981373}, {443,0.01997059}, {444,0.02102941}, {445,0.01989216}, {446,0.02023529}, {447,0.02023529}, {448,0.02139216}, {449,0.01995098}, {450,0.02022549}, {451,0.02022549}, {452,0.02177451}, {453,0.02042157}, {454,0.02051961}, {455,0.02050980}, {456,0.02163725}, {457,0.02057843}, {458,0.02079412}, {459,0.02057843}, {460,0.02204902}, {461,0.02064706}, {462,0.02096078}, {463,0.02084314}, {464,0.02214706}, {465,0.02080392}, {466,0.02145098}, {467,0.02100000}, {468,0.02215686}, {469,0.02107843}, {470,0.02139216}, {471,0.02310784}, {472,0.02139216}, {473,0.02163725}, {474,0.02156863}, {475,0.02259804}, {476,0.02174510}, {477,0.02175490}, {478,0.02147059}, {479,0.02259804}, {480,0.02157843}, {481,0.02194118}, {482,0.02181373}, {483,0.02278431}, {484,0.02233333}, {485,0.02189216}, {486,0.02338235}, {487,0.02221569}, {488,0.02234314}, {489,0.02234314}, {490,0.02354902}, {491,0.02250000}, {492,0.02252941}, {493,0.02278431}, {494,0.02337255}, {495,0.02231373}, {496,0.02272549}, {497,0.02440196}, {498,0.02264706}, {499,0.02279412}, {500,0.02266667}, {505,0.02380392}, {510,0.02324510}, {515,0.02356863}, {520,0.02453922}, {525,0.02418627}, {530,0.02420588}, {535,0.02465686}, {540,0.02561765}, {545,0.02465686}, {550,0.02507843}, {555,0.02680392}, {560,0.02547059}, {565,0.02554902}, {570,0.02672549}, {575,0.02622549}, {580,0.02625490}, {585,0.02750000}, {590,0.02667647}, {595,0.02666667}, {600,0.02831373}, {605,0.02732353}, {610,0.02770588}, {615,0.02867647}, {620,0.02795098}, {625,0.02817647}, {630,0.03003922}, {635,0.02870588}, {640,0.02892157}, {645,0.03056863}, {650,0.03012745}, {655,0.02992157}, {660,0.03066667}, {665,0.03058824}, {670,0.03226471}, {675,0.03108824}, {680,0.03103922}, {685,0.03215686}, {690,0.03146078}, {695,0.03382353}, {700,0.03216667}, {705,0.03248039}, {710,0.03344118}, {715,0.03300000}, {720,0.03279412}, {725,0.03359804}, {730,0.03351961}, {735,0.03479412}, {740,0.03361765}, {745,0.03534314}, {750,0.03390196}, {755,0.03458824}, {760,0.03594118}, {765,0.03487255}, {770,0.03630392}, {775,0.03502941}, {780,0.03751961}, {785,0.03568627}, {790,0.03586275}, {795,0.03719608}, {800,0.03592157}, {805,0.03768627}, {810,0.03676471}, {815,0.03781373}, {820,0.03667647}, {825,0.03830392}, {830,0.03730392}, {835,0.03766667}, {840,0.03972549}, {845,0.03788235}, {850,0.04055882}, {855,0.03824510}, {860,0.03964706}, {865,0.03890196}, {870,0.04038235}, {875,0.03917647}, {880,0.04103922}, {885,0.03983333}, {890,0.04153922}, {895,0.04009804}, {900,0.04191176}, {905,0.04080392}, {910,0.04281373}, {915,0.04154902}, {920,0.04324510}, {925,0.04207843}, {930,0.04379412}, {935,0.04204902}, {940,0.04373529}, {945,0.04269608}, {950,0.04428431}, {955,0.04326471}, {960,0.04448039}, {965,0.04379412}, {970,0.04509804}, {975,0.04581373}, {980,0.04451961}, {985,0.04620588}, {990,0.04488235}, {995,0.04633333}, {1000,0.04522549}, {1010,0.04692157}, {1020,0.04611765}, {1030,0.04740196}, {1040,0.04906863}, {1050,0.04724510}, {1060,0.04978431}, {1070,0.04787255}, {1080,0.04965686}, {1090,0.05166667}, {1100,0.04940196}, {1110,0.05191176}, {1120,0.05015686}, {1130,0.05272549}, {1140,0.05284314}, {1150,0.05171569}, {1160,0.05364706}, {1170,0.05574510}, {1180,0.05305882}, {1190,0.05578431}, {1200,0.05415686}, {1210,0.05448039}, {1220,0.05747059}, {1230,0.05840196}, {1240,0.05599020}, {1250,0.05786275}, {1260,0.05900980}, {1270,0.05739216}, {1280,0.05927451}, {1290,0.06031373}, {1300,0.05854902}, {1310,0.06225490}, {1320,0.06252941}, {1330,0.06228431}, {1340,0.06054902}, {1350,0.06268627}, {1360,0.06359804}, {1370,0.06427451}, {1380,0.06267647}, {1390,0.06432353}, {1400,0.06515686}, {1410,0.06626471}, {1420,0.06456863}, {1430,0.06562745}, {1440,0.06696078}, {1450,0.06753922}, {1460,0.06822549}, {1470,0.06659804}, {1480,0.06757843}, {1490,0.06940196}, {1500,0.06946078}, {1510,0.07017647}, {1520,0.07159804}, {1530,0.06901961}, {1540,0.07431373}, {1550,0.07340196}, {1560,0.07229412}, {1570,0.07297059}, {1580,0.07398039}, {1590,0.07522549}, {1600,0.07209804}, {1610,0.07562745}, {1620,0.07486275}, {1630,0.07536275}, {1640,0.07601961}, {1650,0.07667647}, {1660,0.07717647}, {1670,0.07746078}, {1680,0.07793137}, {1690,0.07857843}, {1700,0.08193137}, {1710,0.08145098}, {1720,0.07747059}, {1730,0.07877451}, {1740,0.08079412}, {1750,0.08284314}, {1760,0.08153922}, {1770,0.08148039}, {1780,0.08226471}, {1790,0.08251961}, {1800,0.08309804}, {1810,0.08367647}, {1820,0.08388235}, {1830,0.08461765}, {1840,0.08504902}, {1850,0.08562745}, {1860,0.08604902}, {1870,0.08633333}, {1880,0.08684314}, {1890,0.08698039}, {1900,0.09007843}, {1910,0.08961765}, {1920,0.09156863}, {1930,0.09398039}, {1940,0.09055882}, {1950,0.09060784}, {1960,0.09088235}, {1970,0.09128431}, {1980,0.09160784}, {1990,0.09227451}, {2000,0.09257843}, {2050,0.09507843}, {2100,0.09690196}, {2150,0.10005882}, {2200,0.10245098}, {2250,0.10432353}, {2300,0.10671569}, {2350,0.11225490}, {2400,0.11545098}, {2450,0.11361765}, {2500,0.11645098}, {2550,0.11900980}, {2600,0.12077451}, {2650,0.12622549}, {2700,0.12607843}, {2750,0.12905882}, {2800,0.13080392}, {2850,0.13362745}, {2900,0.13696078}, {2950,0.14042157}, {3000,0.14039216}, {3050,0.14557843}, {3100,0.14572549}, {3150,0.14793137}, {3200,0.15077451}, {3250,0.15673529}, {3300,0.15598039}, {3350,0.16520588}, {3400,0.16051961}, {3450,0.16293137}, {3500,0.16527451}, {3550,0.16839216}, {3600,0.17060784}, {3650,0.17308824}, {3700,0.17542157}, {3750,0.17781373}, {3800,0.17993137}, {3850,0.18239216}, {3900,0.18491176}, {3950,0.18722549}, {4000,0.19565686}, {4050,0.19517647}, {4100,0.20073529}, {4150,0.19716667}, {4200,0.20866667}, {4250,0.20294118}, {4300,0.20517647}, {4350,0.21300980}, {4400,0.21061765}, {4450,0.21131373}, {4500,0.21399020}, {4550,0.21664706}, {4600,0.21998039}, {4650,0.22114706}, {4700,0.22436275}, {4750,0.22750980}, {4800,0.22929412}, {4850,0.24110784}, {4900,0.23659804}, {4950,0.23794118}, {5000,0.24384314}, {5050,0.24169608}, {5100,0.24821569}, {5150,0.24767647}, {5200,0.24734314}, {5250,0.25900980}, {5300,0.25229412}, {5350,0.25524510}, {5400,0.25753922}, {5450,0.26007843}, {5500,0.26169608}, {5550,0.26457843}, {5600,0.26568627}, {5650,0.26887255}, {5700,0.27137255}, {5750,0.28682353}, {5800,0.28265686}, {5850,0.27909804}, {5900,0.28378431}, {5950,0.28624510}, {6000,0.30888235}, {6050,0.31065686}, {6100,0.30368627}, {6150,0.31298039}, {6200,0.31002941}, {6250,0.30398039}, {6300,0.30279412}, {6350,0.30873529}, {6400,0.32948039}, {6450,0.31322549}, {6500,0.32530392}, {6550,0.31915686}, {6600,0.32181373}, {6650,0.32909804}, {6700,0.32794118}, {6750,0.33090196}, {6800,0.33287255}, {6850,0.33519608}, {6900,0.33609804}, {6950,0.34800000}, {7000,0.35213725}, {7050,0.35037255}, {7100,0.35269608}, {7150,0.35021569}, {7200,0.35579412}, {7250,0.35415686}, {7300,0.35447059}, {7350,0.35811765}, {7400,0.36259804}, {7450,0.36329412}, {7500,0.36932353}, {7550,0.37124510}, {7600,0.38801961}, {7650,0.37434314}, {7700,0.39091176}, {7750,0.37855882}, {7800,0.37735294}, {7850,0.38411765}, {7900,0.40232353}, {7950,0.38957843}, {8000,0.39180392}, {8050,0.41007843}, {8100,0.40854902}, {8150,0.40312745}, {8200,0.40306863}, {8250,0.40854902}, {8300,0.41456863}, {8350,0.41482353}, {8400,0.41701961}, {8450,0.43804902}, {8500,0.41740196}, {8550,0.42208824}, {8600,0.44187255}, {8650,0.42751961}, {8700,0.42700000}, {8750,0.45300980}, {8800,0.44999020}, {8850,0.44395098}, {8900,0.43966667}, {8950,0.44503922}, {9000,0.44134314}, {9050,0.44562745}, {9100,0.44898039}, {9150,0.45411765}, {9200,0.45397059}, {9250,0.45716667}, {9300,0.45889216}, {9350,0.45854902}, {9400,0.47386275}, {9450,0.46850980}, {9500,0.48451961}, {9550,0.49480392}, {9600,0.47625490}, {9650,0.48229412}, {9700,0.50367647}, {9750,0.50768627}, {9800,0.49188235}, {9850,0.49446078}, {9900,0.51814706}, {9950,0.48092157}, {10000,0.50897059}, {10100,0.49049020}, {10200,0.51819608}, {10300,0.52176471}, {10400,0.54575490}, {10500,0.52522549}, {10600,0.53714706}, {10700,0.53227451}, {10800,0.55715686}, {10900,0.57083333}, {11000,0.58750980}, {11100,0.59603922}, {11200,0.57279412}, {11300,0.56326471}, {11400,0.57874510}, {11500,0.58062745}, {11600,0.62122549}, {11700,0.60657843}, {11800,0.60079412}, {11900,0.61165686}, {12000,0.61932353}, {12100,0.62966667}, {12200,0.61962745}, {12300,0.64144118}, {12400,0.63084314}, {12500,0.66705882}, {12600,0.65706863}, {12700,0.64471569}, {12800,0.66039216}, {12900,0.66714706}, {13000,0.66934314}, {13100,0.67721569}, {13200,0.68024510}, {13300,0.69624510}, {13400,0.71168627}, {13500,0.68106863}, {13600,0.71139216}, {13700,0.69845098}, {13800,0.73210784}, {13900,0.69673529}, {14000,0.73763725}, {14100,0.74231373}, {14200,0.71666667}, {14300,0.73475490}, {14400,0.76773529}, {14500,0.78636275}, {14600,0.78541176}, {14700,0.78342157}, {14800,0.79906863}, {14900,0.79643137}, {15000,0.75150000}, {15100,0.78538235}, {15200,0.80900980}, {15300,0.81152941}, {15400,0.78964706}, {15500,0.82781373}, {15600,0.82960784}, {15700,0.80224510}, {15800,0.82706863}, {15900,0.86549020}, {16000,0.82305882}, {16100,0.83178431}, {16200,0.89073529}, {16300,0.88892157}, {16400,0.86839216}, {16500,0.88116667}, {16600,0.88877451}, {16700,0.90245098}, {16800,0.90684314}, {16900,0.87290196}, {17000,0.90298039}, {17100,0.88507843}, {17200,0.90510784}, {17300,0.88702941}, {17400,0.92879412}, {17500,0.92132353}, {17600,0.90631373}, {17700,0.90820588}, {17800,0.92790196}, {17900,0.97704902}, {18000,0.88870588}, {18100,0.90630392}, {18200,0.92715686}, {18300,0.94436275}, {18400,0.94579412}, {18500,0.93337255}, {18600,0.94477451}, {18700,1.01012745}, {18800,1.02074510}, {18900,0.99511765}, {19000,1.01486275}, {19100,1.05214706}, {19200,0.99588235}, {19300,1.04008824}, {19400,1.02795098}, {19500,1.04467647}, {19600,1.02025490}, {19700,1.07254902}, {19800,1.09035294}, {19900,1.03167647}, {20000,1.03681373}};
data["big_flat"]["Ltac2LowLevel"]["Aggregate"]["system"] = {{1,0.00047059}, {2,0.00037255}, {3,0.00014706}, {4,0.00003922}, {5,0.00002941}, {6,0.00000000}, {7,0.00011765}, {8,0.00002941}, {9,0.00000000}, {10,0.00003922}, {11,0.00003922}, {12,0.00000000}, {13,0.00003922}, {14,0.00003922}, {15,0.00000000}, {16,0.00002941}, {17,0.00006863}, {18,0.00000000}, {19,0.00002941}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00011765}, {24,0.00018627}, {25,0.00000000}, {26,0.00022549}, {27,0.00000000}, {28,0.00007843}, {29,0.00003922}, {30,0.00002941}, {31,0.00007843}, {32,0.00003922}, {33,0.00000000}, {34,0.00003922}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00010784}, {39,0.00000000}, {40,0.00000000}, {41,0.00003922}, {42,0.00000000}, {43,0.00007843}, {44,0.00003922}, {45,0.00000000}, {46,0.00003922}, {47,0.00000000}, {48,0.00002941}, {49,0.00007843}, {50,0.00003922}, {51,0.00000000}, {52,0.00000000}, {53,0.00003922}, {54,0.00000000}, {55,0.00000000}, {56,0.00007843}, {57,0.00007843}, {58,0.00003922}, {59,0.00000000}, {60,0.00003922}, {61,0.00000000}, {62,0.00000000}, {63,0.00002941}, {64,0.00003922}, {65,0.00000000}, {66,0.00007843}, {67,0.00003922}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00002941}, {73,0.00003922}, {74,0.00003922}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00007843}, {80,0.00003922}, {81,0.00003922}, {82,0.00003922}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00007843}, {87,0.00007843}, {88,0.00000000}, {89,0.00000000}, {90,0.00003922}, {91,0.00000000}, {92,0.00003922}, {93,0.00000000}, {94,0.00011765}, {95,0.00003922}, {96,0.00003922}, {97,0.00000000}, {98,0.00003922}, {99,0.00003922}, {100,0.00000000}, {101,0.00010784}, {102,0.00011765}, {103,0.00000000}, {104,0.00003922}, {105,0.00000000}, {106,0.00000000}, {107,0.00002941}, {108,0.00000000}, {109,0.00007843}, {110,0.00003922}, {111,0.00000000}, {112,0.00000000}, {113,0.00003922}, {114,0.00003922}, {115,0.00002941}, {116,0.00002941}, {117,0.00003922}, {118,0.00003922}, {119,0.00000000}, {120,0.00014706}, {121,0.00002941}, {122,0.00002941}, {123,0.00010784}, {124,0.00003922}, {125,0.00003922}, {126,0.00000000}, {127,0.00000000}, {128,0.00007843}, {129,0.00003922}, {130,0.00000000}, {131,0.00006863}, {132,0.00003922}, {133,0.00007843}, {134,0.00000000}, {135,0.00000000}, {136,0.00003922}, {137,0.00003922}, {138,0.00007843}, {139,0.00007843}, {140,0.00003922}, {141,0.00003922}, {142,0.00007843}, {143,0.00002941}, {144,0.00000000}, {145,0.00003922}, {146,0.00015686}, {147,0.00003922}, {148,0.00014706}, {149,0.00003922}, {150,0.00000000}, {151,0.00003922}, {152,0.00002941}, {153,0.00000000}, {154,0.00003922}, {155,0.00007843}, {156,0.00006863}, {157,0.00003922}, {158,0.00003922}, {159,0.00000000}, {160,0.00000000}, {161,0.00007843}, {162,0.00010784}, {163,0.00003922}, {164,0.00007843}, {165,0.00003922}, {166,0.00003922}, {167,0.00002941}, {168,0.00000000}, {169,0.00000000}, {170,0.00002941}, {171,0.00010784}, {172,0.00003922}, {173,0.00000000}, {174,0.00003922}, {175,0.00007843}, {176,0.00003922}, {177,0.00006863}, {178,0.00007843}, {179,0.00007843}, {180,0.00007843}, {181,0.00011765}, {182,0.00003922}, {183,0.00000000}, {184,0.00003922}, {185,0.00000000}, {186,0.00003922}, {187,0.00003922}, {188,0.00003922}, {189,0.00007843}, {190,0.00006863}, {191,0.00003922}, {192,0.00000000}, {193,0.00000000}, {194,0.00003922}, {195,0.00000000}, {196,0.00007843}, {197,0.00007843}, {198,0.00007843}, {199,0.00007843}, {200,0.00005882}, {201,0.00000000}, {202,0.00000000}, {203,0.00002941}, {204,0.00002941}, {205,0.00003922}, {206,0.00003922}, {207,0.00003922}, {208,0.00000000}, {209,0.00007843}, {210,0.00003922}, {211,0.00000000}, {212,0.00000000}, {213,0.00010784}, {214,0.00000000}, {215,0.00000000}, {216,0.00003922}, {217,0.00003922}, {218,0.00000000}, {219,0.00003922}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00003922}, {224,0.00010784}, {225,0.00000000}, {226,0.00000000}, {227,0.00007843}, {228,0.00003922}, {229,0.00003922}, {230,0.00010784}, {231,0.00011765}, {232,0.00000000}, {233,0.00000000}, {234,0.00007843}, {235,0.00003922}, {236,0.00003922}, {237,0.00007843}, {238,0.00006863}, {239,0.00000000}, {240,0.00003922}, {241,0.00003922}, {242,0.00006863}, {243,0.00000000}, {244,0.00003922}, {245,0.00011765}, {246,0.00006863}, {247,0.00003922}, {248,0.00000000}, {249,0.00003922}, {250,0.00007843}, {251,0.00009804}, {252,0.00000000}, {253,0.00007843}, {254,0.00007843}, {255,0.00000000}, {256,0.00003922}, {257,0.00003922}, {258,0.00002941}, {259,0.00003922}, {260,0.00000000}, {261,0.00000000}, {262,0.00003922}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00007843}, {268,0.00003922}, {269,0.00000000}, {270,0.00003922}, {271,0.00000000}, {272,0.00007843}, {273,0.00000000}, {274,0.00002941}, {275,0.00000000}, {276,0.00003922}, {277,0.00003922}, {278,0.00003922}, {279,0.00003922}, {280,0.00002941}, {281,0.00015686}, {282,0.00007843}, {283,0.00003922}, {284,0.00003922}, {285,0.00003922}, {286,0.00003922}, {287,0.00003922}, {288,0.00003922}, {289,0.00007843}, {290,0.00000000}, {291,0.00007843}, {292,0.00003922}, {293,0.00003922}, {294,0.00003922}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00003922}, {301,0.00003922}, {302,0.00003922}, {303,0.00007843}, {304,0.00000000}, {305,0.00011765}, {306,0.00007843}, {307,0.00003922}, {308,0.00003922}, {309,0.00010784}, {310,0.00000000}, {311,0.00003922}, {312,0.00000000}, {313,0.00003922}, {314,0.00003922}, {315,0.00000000}, {316,0.00003922}, {317,0.00003922}, {318,0.00003922}, {319,0.00000000}, {320,0.00010784}, {321,0.00003922}, {322,0.00003922}, {323,0.00003922}, {324,0.00003922}, {325,0.00003922}, {326,0.00003922}, {327,0.00003922}, {328,0.00003922}, {329,0.00007843}, {330,0.00003922}, {331,0.00011765}, {332,0.00003922}, {333,0.00011765}, {334,0.00003922}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00007843}, {341,0.00002941}, {342,0.00000000}, {343,0.00003922}, {344,0.00000000}, {345,0.00011765}, {346,0.00010784}, {347,0.00000000}, {348,0.00000000}, {349,0.00006863}, {350,0.00007843}, {351,0.00007843}, {352,0.00000000}, {353,0.00000000}, {354,0.00007843}, {355,0.00000000}, {356,0.00000000}, {357,0.00003922}, {358,0.00011765}, {359,0.00007843}, {360,0.00007843}, {361,0.00007843}, {362,0.00002941}, {363,0.00011765}, {364,0.00007843}, {365,0.00000000}, {366,0.00011765}, {367,0.00000000}, {368,0.00007843}, {369,0.00003922}, {370,0.00019608}, {371,0.00007843}, {372,0.00003922}, {373,0.00000000}, {374,0.00010784}, {375,0.00011765}, {376,0.00014706}, {377,0.00007843}, {378,0.00000000}, {379,0.00003922}, {380,0.00007843}, {381,0.00000000}, {382,0.00000000}, {383,0.00007843}, {384,0.00007843}, {385,0.00006863}, {386,0.00006863}, {387,0.00007843}, {388,0.00003922}, {389,0.00015686}, {390,0.00006863}, {391,0.00007843}, {392,0.00006863}, {393,0.00003922}, {394,0.00007843}, {395,0.00002941}, {396,0.00011765}, {397,0.00015686}, {398,0.00019608}, {399,0.00000000}, {400,0.00003922}, {401,0.00011765}, {402,0.00003922}, {403,0.00011765}, {404,0.00003922}, {405,0.00007843}, {406,0.00000000}, {407,0.00011765}, {408,0.00002941}, {409,0.00000000}, {410,0.00003922}, {411,0.00000000}, {412,0.00003922}, {413,0.00007843}, {414,0.00003922}, {415,0.00003922}, {416,0.00003922}, {417,0.00003922}, {418,0.00000000}, {419,0.00010784}, {420,0.00006863}, {421,0.00000000}, {422,0.00003922}, {423,0.00000000}, {424,0.00003922}, {425,0.00003922}, {426,0.00003922}, {427,0.00000000}, {428,0.00011765}, {429,0.00003922}, {430,0.00000000}, {431,0.00000000}, {432,0.00003922}, {433,0.00003922}, {434,0.00007843}, {435,0.00003922}, {436,0.00003922}, {437,0.00007843}, {438,0.00003922}, {439,0.00000000}, {440,0.00002941}, {441,0.00000000}, {442,0.00006863}, {443,0.00003922}, {444,0.00000000}, {445,0.00003922}, {446,0.00006863}, {447,0.00006863}, {448,0.00006863}, {449,0.00000000}, {450,0.00003922}, {451,0.00000000}, {452,0.00000000}, {453,0.00007843}, {454,0.00003922}, {455,0.00007843}, {456,0.00003922}, {457,0.00000000}, {458,0.00007843}, {459,0.00002941}, {460,0.00003922}, {461,0.00003922}, {462,0.00000000}, {463,0.00011765}, {464,0.00000000}, {465,0.00003922}, {466,0.00002941}, {467,0.00000000}, {468,0.00003922}, {469,0.00011765}, {470,0.00003922}, {471,0.00003922}, {472,0.00003922}, {473,0.00003922}, {474,0.00000000}, {475,0.00003922}, {476,0.00003922}, {477,0.00003922}, {478,0.00011765}, {479,0.00003922}, {480,0.00010784}, {481,0.00003922}, {482,0.00007843}, {483,0.00006863}, {484,0.00007843}, {485,0.00011765}, {486,0.00000000}, {487,0.00023529}, {488,0.00003922}, {489,0.00007843}, {490,0.00003922}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00003922}, {495,0.00007843}, {496,0.00011765}, {497,0.00007843}, {498,0.00003922}, {499,0.00003922}, {500,0.00011765}, {505,0.00003922}, {510,0.00007843}, {515,0.00007843}, {520,0.00003922}, {525,0.00007843}, {530,0.00006863}, {535,0.00000000}, {540,0.00015686}, {545,0.00010784}, {550,0.00015686}, {555,0.00003922}, {560,0.00006863}, {565,0.00007843}, {570,0.00000000}, {575,0.00000000}, {580,0.00003922}, {585,0.00003922}, {590,0.00000000}, {595,0.00003922}, {600,0.00000000}, {605,0.00000000}, {610,0.00002941}, {615,0.00014706}, {620,0.00010784}, {625,0.00000000}, {630,0.00007843}, {635,0.00010784}, {640,0.00000000}, {645,0.00006863}, {650,0.00000000}, {655,0.00000000}, {660,0.00007843}, {665,0.00000000}, {670,0.00003922}, {675,0.00007843}, {680,0.00007843}, {685,0.00002941}, {690,0.00019608}, {695,0.00003922}, {700,0.00011765}, {705,0.00000000}, {710,0.00003922}, {715,0.00000000}, {720,0.00011765}, {725,0.00002941}, {730,0.00003922}, {735,0.00003922}, {740,0.00000000}, {745,0.00015686}, {750,0.00003922}, {755,0.00000000}, {760,0.00007843}, {765,0.00003922}, {770,0.00003922}, {775,0.00003922}, {780,0.00003922}, {785,0.00000000}, {790,0.00003922}, {795,0.00007843}, {800,0.00007843}, {805,0.00010784}, {810,0.00018627}, {815,0.00007843}, {820,0.00015686}, {825,0.00023529}, {830,0.00007843}, {835,0.00003922}, {840,0.00014706}, {845,0.00010784}, {850,0.00011765}, {855,0.00007843}, {860,0.00003922}, {865,0.00000000}, {870,0.00018627}, {875,0.00015686}, {880,0.00002941}, {885,0.00010784}, {890,0.00006863}, {895,0.00011765}, {900,0.00019608}, {905,0.00014706}, {910,0.00000000}, {915,0.00003922}, {920,0.00010784}, {925,0.00000000}, {930,0.00000000}, {935,0.00003922}, {940,0.00015686}, {945,0.00007843}, {950,0.00013725}, {955,0.00006863}, {960,0.00011765}, {965,0.00007843}, {970,0.00003922}, {975,0.00000000}, {980,0.00007843}, {985,0.00027451}, {990,0.00003922}, {995,0.00028431}, {1000,0.00007843}, {1010,0.00007843}, {1020,0.00007843}, {1030,0.00011765}, {1040,0.00007843}, {1050,0.00007843}, {1060,0.00003922}, {1070,0.00006863}, {1080,0.00015686}, {1090,0.00015686}, {1100,0.00011765}, {1110,0.00014706}, {1120,0.00014706}, {1130,0.00000000}, {1140,0.00021569}, {1150,0.00010784}, {1160,0.00014706}, {1170,0.00010784}, {1180,0.00007843}, {1190,0.00003922}, {1200,0.00015686}, {1210,0.00007843}, {1220,0.00014706}, {1230,0.00010784}, {1240,0.00007843}, {1250,0.00018627}, {1260,0.00003922}, {1270,0.00011765}, {1280,0.00003922}, {1290,0.00014706}, {1300,0.00007843}, {1310,0.00015686}, {1320,0.00007843}, {1330,0.00014706}, {1340,0.00007843}, {1350,0.00003922}, {1360,0.00006863}, {1370,0.00010784}, {1380,0.00006863}, {1390,0.00014706}, {1400,0.00011765}, {1410,0.00000000}, {1420,0.00007843}, {1430,0.00007843}, {1440,0.00023529}, {1450,0.00011765}, {1460,0.00011765}, {1470,0.00011765}, {1480,0.00011765}, {1490,0.00006863}, {1500,0.00011765}, {1510,0.00014706}, {1520,0.00012745}, {1530,0.00011765}, {1540,0.00018627}, {1550,0.00031373}, {1560,0.00015686}, {1570,0.00026471}, {1580,0.00011765}, {1590,0.00015686}, {1600,0.00007843}, {1610,0.00044118}, {1620,0.00014706}, {1630,0.00010784}, {1640,0.00019608}, {1650,0.00007843}, {1660,0.00003922}, {1670,0.00022549}, {1680,0.00039216}, {1690,0.00007843}, {1700,0.00015686}, {1710,0.00000000}, {1720,0.00014706}, {1730,0.00022549}, {1740,0.00003922}, {1750,0.00011765}, {1760,0.00018627}, {1770,0.00035294}, {1780,0.00003922}, {1790,0.00026471}, {1800,0.00023529}, {1810,0.00010784}, {1820,0.00022549}, {1830,0.00023529}, {1840,0.00026471}, {1850,0.00007843}, {1860,0.00015686}, {1870,0.00023529}, {1880,0.00011765}, {1890,0.00021569}, {1900,0.00015686}, {1910,0.00011765}, {1920,0.00031373}, {1930,0.00003922}, {1940,0.00014706}, {1950,0.00000000}, {1960,0.00027451}, {1970,0.00000000}, {1980,0.00015686}, {1990,0.00003922}, {2000,0.00019608}, {2050,0.00006863}, {2100,0.00033333}, {2150,0.00011765}, {2200,0.00019608}, {2250,0.00025490}, {2300,0.00019608}, {2350,0.00019608}, {2400,0.00034314}, {2450,0.00015686}, {2500,0.00007843}, {2550,0.00022549}, {2600,0.00011765}, {2650,0.00007843}, {2700,0.00011765}, {2750,0.00031373}, {2800,0.00023529}, {2850,0.00017647}, {2900,0.00019608}, {2950,0.00033333}, {3000,0.00027451}, {3050,0.00038235}, {3100,0.00034314}, {3150,0.00026471}, {3200,0.00026471}, {3250,0.00018627}, {3300,0.00028431}, {3350,0.00037255}, {3400,0.00027451}, {3450,0.00026471}, {3500,0.00017647}, {3550,0.00019608}, {3600,0.00011765}, {3650,0.00025490}, {3700,0.00026471}, {3750,0.00011765}, {3800,0.00018627}, {3850,0.00014706}, {3900,0.00038235}, {3950,0.00030392}, {4000,0.00038235}, {4050,0.00019608}, {4100,0.00043137}, {4150,0.00034314}, {4200,0.00050980}, {4250,0.00038235}, {4300,0.00019608}, {4350,0.00043137}, {4400,0.00035294}, {4450,0.00030392}, {4500,0.00042157}, {4550,0.00030392}, {4600,0.00026471}, {4650,0.00023529}, {4700,0.00050000}, {4750,0.00015686}, {4800,0.00026471}, {4850,0.00057843}, {4900,0.00035294}, {4950,0.00011765}, {5000,0.00019608}, {5050,0.00011765}, {5100,0.00011765}, {5150,0.00011765}, {5200,0.00011765}, {5250,0.00019608}, {5300,0.00006863}, {5350,0.00015686}, {5400,0.00013725}, {5450,0.00003922}, {5500,0.00015686}, {5550,0.00003922}, {5600,0.00015686}, {5650,0.00007843}, {5700,0.00003922}, {5750,0.00011765}, {5800,0.00015686}, {5850,0.00015686}, {5900,0.00015686}, {5950,0.00014706}, {6000,0.00026471}, {6050,0.00019608}, {6100,0.00014706}, {6150,0.00015686}, {6200,0.00003922}, {6250,0.00011765}, {6300,0.00006863}, {6350,0.00015686}, {6400,0.00182353}, {6450,0.00066667}, {6500,0.00042157}, {6550,0.00042157}, {6600,0.00019608}, {6650,0.00026471}, {6700,0.00037255}, {6750,0.00019608}, {6800,0.00070588}, {6850,0.00031373}, {6900,0.00034314}, {6950,0.00060784}, {7000,0.00074510}, {7050,0.00062745}, {7100,0.00038235}, {7150,0.00015686}, {7200,0.00053922}, {7250,0.00061765}, {7300,0.00048039}, {7350,0.00056863}, {7400,0.00061765}, {7450,0.00038235}, {7500,0.00060784}, {7550,0.00050980}, {7600,0.00099020}, {7650,0.00039216}, {7700,0.00084314}, {7750,0.00046078}, {7800,0.00089216}, {7850,0.00019608}, {7900,0.00089216}, {7950,0.00047059}, {8000,0.00031373}, {8050,0.00077451}, {8100,0.00043137}, {8150,0.00059804}, {8200,0.00057843}, {8250,0.00071569}, {8300,0.00102941}, {8350,0.00061765}, {8400,0.00047059}, {8450,0.00126471}, {8500,0.00047059}, {8550,0.00088235}, {8600,0.00076471}, {8650,0.00014706}, {8700,0.00011765}, {8750,0.00018627}, {8800,0.00007843}, {8850,0.00015686}, {8900,0.00023529}, {8950,0.00019608}, {9000,0.00015686}, {9050,0.00019608}, {9100,0.00007843}, {9150,0.00015686}, {9200,0.00007843}, {9250,0.00003922}, {9300,0.00015686}, {9350,0.00015686}, {9400,0.00011765}, {9450,0.00022549}, {9500,0.00015686}, {9550,0.00015686}, {9600,0.00010784}, {9650,0.00019608}, {9700,0.00023529}, {9750,0.00019608}, {9800,0.00018627}, {9850,0.00022549}, {9900,0.00019608}, {9950,0.00021569}, {10000,0.00007843}, {10100,0.00019608}, {10200,0.00015686}, {10300,0.00022549}, {10400,0.00007843}, {10500,0.00019608}, {10600,0.00015686}, {10700,0.00019608}, {10800,0.00015686}, {10900,0.00010784}, {11000,0.00019608}, {11100,0.00027451}, {11200,0.00011765}, {11300,0.00026471}, {11400,0.00011765}, {11500,0.00000000}, {11600,0.00023529}, {11700,0.00015686}, {11800,0.00030392}, {11900,0.00014706}, {12000,0.00014706}, {12100,0.00023529}, {12200,0.00021569}, {12300,0.00019608}, {12400,0.00006863}, {12500,0.00026471}, {12600,0.00023529}, {12700,0.00015686}, {12800,0.00011765}, {12900,0.00019608}, {13000,0.00011765}, {13100,0.00023529}, {13200,0.00007843}, {13300,0.00000000}, {13400,0.00013725}, {13500,0.00010784}, {13600,0.00007843}, {13700,0.00015686}, {13800,0.00027451}, {13900,0.00030392}, {14000,0.00011765}, {14100,0.00019608}, {14200,0.00010784}, {14300,0.00019608}, {14400,0.00007843}, {14500,0.00014706}, {14600,0.00018627}, {14700,0.00023529}, {14800,0.00015686}, {14900,0.00015686}, {15000,0.00007843}, {15100,0.00031373}, {15200,0.00007843}, {15300,0.00011765}, {15400,0.00023529}, {15500,0.00042157}, {15600,0.00031373}, {15700,0.00033333}, {15800,0.00050000}, {15900,0.00031373}, {16000,0.00007843}, {16100,0.00026471}, {16200,0.00041176}, {16300,0.00023529}, {16400,0.00022549}, {16500,0.00014706}, {16600,0.00027451}, {16700,0.00023529}, {16800,0.00007843}, {16900,0.00034314}, {17000,0.00018627}, {17100,0.00000000}, {17200,0.00015686}, {17300,0.00019608}, {17400,0.00014706}, {17500,0.00027451}, {17600,0.00023529}, {17700,0.00015686}, {17800,0.00011765}, {17900,0.00053922}, {18000,0.00007843}, {18100,0.00026471}, {18200,0.00007843}, {18300,0.00046078}, {18400,0.00022549}, {18500,0.00023529}, {18600,0.00037255}, {18700,0.00023529}, {18800,0.00011765}, {18900,0.00011765}, {19000,0.00022549}, {19100,0.00026471}, {19200,0.00015686}, {19300,0.00026471}, {19400,0.00018627}, {19500,0.00035294}, {19600,0.00026471}, {19700,0.00027451}, {19800,0.00026471}, {19900,0.00015686}, {20000,0.00014706}};
data["big_flat"]["Ltac2LowLevel"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00009804}, {23,0.00010784}, {24,0.00006863}, {25,0.00005882}, {26,0.01755882}, {27,0.00035294}, {28,0.00096078}, {29,0.00100000}, {30,0.00100000}, {31,0.00100000}, {32,0.00100000}, {33,0.00100000}, {34,0.00100000}, {35,0.00100000}, {36,0.00100000}, {37,0.00100000}, {38,0.00100000}, {39,0.00100000}, {40,0.00100000}, {41,0.00100000}, {42,0.00100000}, {43,0.00100000}, {44,0.00100000}, {45,0.00100980}, {46,0.00100980}, {47,0.00101961}, {48,0.00104902}, {49,0.00105882}, {50,0.00104902}, {51,0.00103922}, {52,0.00107843}, {53,0.00105882}, {54,0.00105882}, {55,0.00107843}, {56,0.00160784}, {57,0.00186275}, {58,0.00200000}, {59,0.00200000}, {60,0.00200980}, {61,0.00200000}, {62,0.00200000}, {63,0.00200000}, {64,0.00200000}, {65,0.00200000}, {66,0.00200980}, {67,0.00200000}, {68,0.00200000}, {69,0.00200000}, {70,0.00202941}, {71,0.00200980}, {72,0.00200980}, {73,0.00200980}, {74,0.00200000}, {75,0.00200000}, {76,0.00200980}, {77,0.00200000}, {78,0.00201961}, {79,0.00200980}, {80,0.00300980}, {81,0.00204902}, {82,0.00204902}, {83,0.00211765}, {84,0.00232353}, {85,0.00257843}, {86,0.00288235}, {87,0.00296078}, {88,0.00299020}, {89,0.00300000}, {90,0.00300000}, {91,0.00300000}, {92,0.00300000}, {93,0.00300000}, {94,0.00300000}, {95,0.00300000}, {96,0.00300000}, {97,0.00300000}, {98,0.00386275}, {99,0.00300980}, {100,0.00300980}, {101,0.00300000}, {102,0.00302941}, {103,0.00300980}, {104,0.00300000}, {105,0.00300980}, {106,0.00300980}, {107,0.00302941}, {108,0.00302941}, {109,0.00303922}, {110,0.00302941}, {111,0.00309804}, {112,0.00318627}, {113,0.00403922}, {114,0.00372549}, {115,0.00380392}, {116,0.00390196}, {117,0.00395098}, {118,0.00398039}, {119,0.00400000}, {120,0.00400000}, {121,0.00400980}, {122,0.00400000}, {123,0.00400000}, {124,0.00400000}, {125,0.00400980}, {126,0.00400000}, {127,0.00480392}, {128,0.00400980}, {129,0.00400980}, {130,0.00400980}, {131,0.00400000}, {132,0.00400980}, {133,0.00400000}, {134,0.00401961}, {135,0.00400980}, {136,0.00405882}, {137,0.00401961}, {138,0.00404902}, {139,0.00499020}, {140,0.00413725}, {141,0.00423529}, {142,0.00451961}, {143,0.00467647}, {144,0.00478431}, {145,0.00486275}, {146,0.00496078}, {147,0.00498039}, {148,0.00499020}, {149,0.00500000}, {150,0.00500000}, {151,0.00502941}, {152,0.00500980}, {153,0.00500000}, {154,0.00500000}, {155,0.00500000}, {156,0.00500000}, {157,0.00500000}, {158,0.00500000}, {159,0.00500000}, {160,0.00501961}, {161,0.00500980}, {162,0.00502941}, {163,0.00500000}, {164,0.00502941}, {165,0.00502941}, {166,0.00505882}, {167,0.00506863}, {168,0.00510784}, {169,0.00524510}, {170,0.00531373}, {171,0.00548039}, {172,0.00571569}, {173,0.00577451}, {174,0.00585294}, {175,0.00590196}, {176,0.00594118}, {177,0.00598039}, {178,0.00599020}, {179,0.00600000}, {180,0.00600980}, {181,0.00687255}, {182,0.00600000}, {183,0.00600000}, {184,0.00600000}, {185,0.00600980}, {186,0.00600000}, {187,0.00600000}, {188,0.00600980}, {189,0.00600000}, {190,0.00699020}, {191,0.00603922}, {192,0.00601961}, {193,0.00602941}, {194,0.00605882}, {195,0.00604902}, {196,0.00608824}, {197,0.00614706}, {198,0.00621569}, {199,0.00703922}, {200,0.00655882}, {201,0.00673529}, {202,0.00680392}, {203,0.00683333}, {204,0.00686275}, {205,0.00689216}, {206,0.00697059}, {207,0.00698039}, {208,0.00700000}, {209,0.00700980}, {210,0.00700000}, {211,0.00700000}, {212,0.00700000}, {213,0.00700000}, {214,0.00700000}, {215,0.00701961}, {216,0.00700980}, {217,0.00700980}, {218,0.00700980}, {219,0.00701961}, {220,0.00700980}, {221,0.00701961}, {222,0.00704902}, {223,0.00704902}, {224,0.00708824}, {225,0.00707843}, {226,0.00718627}, {227,0.00738235}, {228,0.00745098}, {229,0.00754902}, {230,0.00769608}, {231,0.00881373}, {232,0.00784314}, {233,0.00784314}, {234,0.00789216}, {235,0.00791176}, {236,0.00793137}, {237,0.00798039}, {238,0.00882353}, {239,0.00800000}, {240,0.00800000}, {241,0.00800980}, {242,0.00800980}, {243,0.00800980}, {244,0.00800000}, {245,0.00800000}, {246,0.00801961}, {247,0.00805882}, {248,0.00803922}, {249,0.00804902}, {250,0.00801961}, {251,0.00802941}, {252,0.00804902}, {253,0.00809804}, {254,0.00814706}, {255,0.00824510}, {256,0.00839216}, {257,0.00853922}, {258,0.00863725}, {259,0.00951961}, {260,0.00878431}, {261,0.00884314}, {262,0.00887255}, {263,0.00889216}, {264,0.00888235}, {265,0.00897059}, {266,0.00971569}, {267,0.00898039}, {268,0.00900000}, {269,0.00900000}, {270,0.00900980}, {271,0.00900980}, {272,0.00988235}, {273,0.00903922}, {274,0.00901961}, {275,0.00900980}, {276,0.00900980}, {277,0.00901961}, {278,0.00902941}, {279,0.00904902}, {280,0.00904902}, {281,0.00908824}, {282,0.00909804}, {283,0.00917647}, {284,0.00929412}, {285,0.01074510}, {286,0.00955882}, {287,0.00970588}, {288,0.00972549}, {289,0.00976471}, {290,0.00981373}, {291,0.01055882}, {292,0.00986275}, {293,0.00988235}, {294,0.00991176}, {295,0.00995098}, {296,0.01000000}, {297,0.01081373}, {298,0.01000000}, {299,0.01000000}, {300,0.01000000}, {301,0.01000980}, {302,0.01000980}, {303,0.01001961}, {304,0.01000000}, {305,0.01003922}, {306,0.01003922}, {307,0.01004902}, {308,0.01169608}, {309,0.01005882}, {310,0.01011765}, {311,0.01018627}, {312,0.01026471}, {313,0.01034314}, {314,0.01127451}, {315,0.01053922}, {316,0.01065686}, {317,0.01075490}, {318,0.01081373}, {319,0.01082353}, {320,0.01085294}, {321,0.01085294}, {322,0.01087255}, {323,0.01093137}, {324,0.01093137}, {325,0.01182353}, {326,0.01100000}, {327,0.01098039}, {328,0.01100000}, {329,0.01101961}, {330,0.01194118}, {331,0.01102941}, {332,0.01104902}, {333,0.01105882}, {334,0.01103922}, {335,0.01101961}, {336,0.01104902}, {337,0.01105882}, {338,0.01113725}, {339,0.01110784}, {340,0.01123529}, {341,0.01213725}, {342,0.01143137}, {343,0.01149020}, {344,0.01161765}, {345,0.01162745}, {346,0.01252941}, {347,0.01178431}, {348,0.01182353}, {349,0.01183333}, {350,0.01187255}, {351,0.01281373}, {352,0.01191176}, {353,0.01189216}, {354,0.01195098}, {355,0.01197059}, {356,0.01287255}, {357,0.01200980}, {358,0.01200980}, {359,0.01202941}, {360,0.01201961}, {361,0.01297059}, {362,0.01202941}, {363,0.01201961}, {364,0.01204902}, {365,0.01203922}, {366,0.01301961}, {367,0.01213725}, {368,0.01217647}, {369,0.01226471}, {370,0.01236275}, {371,0.01252941}, {372,0.01259804}, {373,0.01263725}, {374,0.01267647}, {375,0.01381373}, {376,0.01279412}, {377,0.01282353}, {378,0.01282353}, {379,0.01287255}, {380,0.01384314}, {381,0.01288235}, {382,0.01291176}, {383,0.01293137}, {384,0.01297059}, {385,0.01299020}, {386,0.01298039}, {387,0.01301961}, {388,0.01300980}, {389,0.01402941}, {390,0.01303922}, {391,0.01302941}, {392,0.01303922}, {393,0.01305882}, {394,0.01307843}, {395,0.01310784}, {396,0.01318627}, {397,0.01327451}, {398,0.01461765}, {399,0.01343137}, {400,0.01348039}, {401,0.01358824}, {402,0.01360784}, {403,0.01369608}, {404,0.01373529}, {405,0.01376471}, {406,0.01383333}, {407,0.01480392}, {408,0.01383333}, {409,0.01384314}, {410,0.01390196}, {411,0.01488235}, {412,0.01394118}, {413,0.01398039}, {414,0.01399020}, {415,0.01399020}, {416,0.01401961}, {417,0.01402941}, {418,0.01401961}, {419,0.01402941}, {420,0.01496078}, {421,0.01402941}, {422,0.01404902}, {423,0.01413725}, {424,0.01512745}, {425,0.01421569}, {426,0.01428431}, {427,0.01437255}, {428,0.01562745}, {429,0.01448039}, {430,0.01459804}, {431,0.01459804}, {432,0.01574510}, {433,0.01476471}, {434,0.01477451}, {435,0.01482353}, {436,0.01580392}, {437,0.01485294}, {438,0.01484314}, {439,0.01488235}, {440,0.01591176}, {441,0.01492157}, {442,0.01492157}, {443,0.01498039}, {444,0.01604902}, {445,0.01500000}, {446,0.01501961}, {447,0.01500980}, {448,0.01622549}, {449,0.01503922}, {450,0.01506863}, {451,0.01511765}, {452,0.01646078}, {453,0.01518627}, {454,0.01527451}, {455,0.01536275}, {456,0.01657843}, {457,0.01551961}, {458,0.01559804}, {459,0.01560784}, {460,0.01673529}, {461,0.01568627}, {462,0.01576471}, {463,0.01578431}, {464,0.01679412}, {465,0.01584314}, {466,0.01583333}, {467,0.01583333}, {468,0.01675490}, {469,0.01589216}, {470,0.01592157}, {471,0.01595098}, {472,0.01599020}, {473,0.01600000}, {474,0.01601961}, {475,0.01725490}, {476,0.01602941}, {477,0.01607843}, {478,0.01606863}, {479,0.01730392}, {480,0.01618627}, {481,0.01624510}, {482,0.01630392}, {483,0.01705882}, {484,0.01642157}, {485,0.01643137}, {486,0.01775490}, {487,0.01654902}, {488,0.01667647}, {489,0.01662745}, {490,0.01777451}, {491,0.01675490}, {492,0.01678431}, {493,0.01680392}, {494,0.01682353}, {495,0.01683333}, {496,0.01685294}, {497,0.01876471}, {498,0.01693137}, {499,0.01690196}, {500,0.01695098}, {505,0.01798039}, {510,0.01720588}, {515,0.01759804}, {520,0.01882353}, {525,0.01786275}, {530,0.01792157}, {535,0.01808824}, {540,0.01835294}, {545,0.01862745}, {550,0.01877451}, {555,0.02071569}, {560,0.01901961}, {565,0.01914706}, {570,0.02073529}, {575,0.01969608}, {580,0.01978431}, {585,0.02104902}, {590,0.02000980}, {595,0.02023529}, {600,0.02176471}, {605,0.02067647}, {610,0.02080392}, {615,0.02218627}, {620,0.02103922}, {625,0.02135294}, {630,0.02276471}, {635,0.02173529}, {640,0.02186275}, {645,0.02304902}, {650,0.02213725}, {655,0.02242157}, {660,0.02267647}, {665,0.02274510}, {670,0.02442157}, {675,0.02294118}, {680,0.02324510}, {685,0.02476471}, {690,0.02372549}, {695,0.02379412}, {700,0.02390196}, {705,0.02402941}, {710,0.02579412}, {715,0.02453922}, {720,0.02470588}, {725,0.02484314}, {730,0.02491176}, {735,0.02666667}, {740,0.02534314}, {745,0.02559804}, {750,0.02577451}, {755,0.02584314}, {760,0.02734314}, {765,0.02615686}, {770,0.02779412}, {775,0.02660784}, {780,0.02678431}, {785,0.02688235}, {790,0.02692157}, {795,0.02865686}, {800,0.02745098}, {805,0.02891176}, {810,0.02776471}, {815,0.02952941}, {820,0.02802941}, {825,0.02821569}, {830,0.02850980}, {835,0.02865686}, {840,0.02880392}, {845,0.02895098}, {850,0.03151961}, {855,0.02927451}, {860,0.03086275}, {865,0.02970588}, {870,0.03139216}, {875,0.02990196}, {880,0.03172549}, {885,0.03043137}, {890,0.03201961}, {895,0.03073529}, {900,0.03243137}, {905,0.03097059}, {910,0.03284314}, {915,0.03139216}, {920,0.03320588}, {925,0.03176471}, {930,0.03352941}, {935,0.03205882}, {940,0.03383333}, {945,0.03246078}, {950,0.03412745}, {955,0.03279412}, {960,0.03440196}, {965,0.03314706}, {970,0.03337255}, {975,0.03353922}, {980,0.03375490}, {985,0.03572549}, {990,0.03400980}, {995,0.03594118}, {1000,0.03443137}, {1010,0.03634314}, {1020,0.03509804}, {1030,0.03682353}, {1040,0.03580392}, {1050,0.03607843}, {1060,0.03920588}, {1070,0.03682353}, {1080,0.03884314}, {1090,0.03757843}, {1100,0.03785294}, {1110,0.04030392}, {1120,0.03860784}, {1130,0.04066667}, {1140,0.04138235}, {1150,0.03961765}, {1160,0.04173529}, {1170,0.04033333}, {1180,0.04067647}, {1190,0.04319608}, {1200,0.04138235}, {1210,0.04175490}, {1220,0.04489216}, {1230,0.04247059}, {1240,0.04277451}, {1250,0.04513725}, {1260,0.04577451}, {1270,0.04379412}, {1280,0.04598039}, {1290,0.04667647}, {1300,0.04484314}, {1310,0.04518627}, {1320,0.04872549}, {1330,0.04833333}, {1340,0.04626471}, {1350,0.04852941}, {1360,0.04918627}, {1370,0.04986275}, {1380,0.04761765}, {1390,0.04995098}, {1400,0.05051961}, {1410,0.05109804}, {1420,0.04900980}, {1430,0.04936275}, {1440,0.05192157}, {1450,0.05246078}, {1460,0.05299020}, {1470,0.05076471}, {1480,0.05120588}, {1490,0.05427451}, {1500,0.05420588}, {1510,0.05482353}, {1520,0.05253922}, {1530,0.05288235}, {1540,0.05322549}, {1550,0.05753922}, {1560,0.05621569}, {1570,0.05677451}, {1580,0.05724510}, {1590,0.05498039}, {1600,0.05536275}, {1610,0.05562745}, {1620,0.05823529}, {1630,0.05848039}, {1640,0.05894118}, {1650,0.05948039}, {1660,0.06000000}, {1670,0.06038235}, {1680,0.06089216}, {1690,0.06134314}, {1700,0.05872549}, {1710,0.05915686}, {1720,0.05946078}, {1730,0.05985294}, {1740,0.06028431}, {1750,0.06046078}, {1760,0.06322549}, {1770,0.06347059}, {1780,0.06389216}, {1790,0.06430392}, {1800,0.06460784}, {1810,0.06494118}, {1820,0.06527451}, {1830,0.06562745}, {1840,0.06604902}, {1850,0.06643137}, {1860,0.06672549}, {1870,0.06703922}, {1880,0.06738235}, {1890,0.06755882}, {1900,0.06585294}, {1910,0.06610784}, {1920,0.06641176}, {1930,0.06687255}, {1940,0.07074510}, {1950,0.07077451}, {1960,0.07099020}, {1970,0.07136275}, {1980,0.07156863}, {1990,0.07183333}, {2000,0.07193137}, {2050,0.07361765}, {2100,0.07530392}, {2150,0.07682353}, {2200,0.07967647}, {2250,0.08119608}, {2300,0.08273529}, {2350,0.08142157}, {2400,0.09081373}, {2450,0.08816667}, {2500,0.09030392}, {2550,0.09217647}, {2600,0.09336275}, {2650,0.09779412}, {2700,0.09716667}, {2750,0.09813725}, {2800,0.10064706}, {2850,0.10302941}, {2900,0.10417647}, {2950,0.10900980}, {3000,0.10824510}, {3050,0.10967647}, {3100,0.11260784}, {3150,0.11345098}, {3200,0.11558824}, {3250,0.11713725}, {3300,0.11950000}, {3350,0.12069608}, {3400,0.12260784}, {3450,0.12459804}, {3500,0.12648039}, {3550,0.12835294}, {3600,0.13015686}, {3650,0.13201961}, {3700,0.13369608}, {3750,0.13554902}, {3800,0.13723529}, {3850,0.13900980}, {3900,0.14046078}, {3950,0.14219608}, {4000,0.14413725}, {4050,0.14583333}, {4100,0.15345098}, {4150,0.14960784}, {4200,0.14930392}, {4250,0.15390196}, {4300,0.15500980}, {4350,0.15406863}, {4400,0.15965686}, {4450,0.16012745}, {4500,0.16164706}, {4550,0.16377451}, {4600,0.16395098}, {4650,0.16728431}, {4700,0.17033333}, {4750,0.17086275}, {4800,0.17358824}, {4850,0.17493137}, {4900,0.17631373}, {4950,0.17968627}, {5000,0.18052941}, {5050,0.18203922}, {5100,0.18344118}, {5150,0.18637255}, {5200,0.18431373}, {5250,0.18881373}, {5300,0.18388235}, {5350,0.19219608}, {5400,0.19422549}, {5450,0.19579412}, {5500,0.19742157}, {5550,0.19956863}, {5600,0.20076471}, {5650,0.20244118}, {5700,0.20399020}, {5750,0.20593137}, {5800,0.20560784}, {5850,0.21079412}, {5900,0.21236275}, {5950,0.21367647}, {6000,0.21871569}, {6050,0.22506863}, {6100,0.22862745}, {6150,0.22132353}, {6200,0.23266667}, {6250,0.22603922}, {6300,0.22426471}, {6350,0.22943137}, {6400,0.24012745}, {6450,0.23291176}, {6500,0.23497059}, {6550,0.23642157}, {6600,0.23561765}, {6650,0.23975490}, {6700,0.24323529}, {6750,0.24119608}, {6800,0.24549020}, {6850,0.24871569}, {6900,0.24966667}, {6950,0.25185294}, {7000,0.24337255}, {7050,0.25863725}, {7100,0.25713725}, {7150,0.25863725}, {7200,0.26454902}, {7250,0.26221569}, {7300,0.25942157}, {7350,0.26172549}, {7400,0.26400000}, {7450,0.26868627}, {7500,0.27038235}, {7550,0.27378431}, {7600,0.27534314}, {7650,0.27650980}, {7700,0.27593137}, {7750,0.27569608}, {7800,0.28078431}, {7850,0.28303922}, {7900,0.28330392}, {7950,0.28309804}, {8000,0.28909804}, {8050,0.28955882}, {8100,0.29116667}, {8150,0.28269608}, {8200,0.29219608}, {8250,0.30178431}, {8300,0.29332353}, {8350,0.28933333}, {8400,0.30679412}, {8450,0.30345098}, {8500,0.30591176}, {8550,0.30655882}, {8600,0.30653922}, {8650,0.31312745}, {8700,0.31329412}, {8750,0.31569608}, {8800,0.31195098}, {8850,0.32068627}, {8900,0.32099020}, {8950,0.32653922}, {9000,0.31914706}, {9050,0.32132353}, {9100,0.32321569}, {9150,0.32678431}, {9200,0.32605882}, {9250,0.32917647}, {9300,0.33061765}, {9350,0.33128431}, {9400,0.34270588}, {9450,0.34056863}, {9500,0.34250000}, {9550,0.34157843}, {9600,0.34145098}, {9650,0.34715686}, {9700,0.35107843}, {9750,0.35153922}, {9800,0.34813725}, {9850,0.35521569}, {9900,0.35636275}, {9950,0.36224510}, {10000,0.35546078}, {10100,0.36162745}, {10200,0.36225490}, {10300,0.37431373}, {10400,0.37493137}, {10500,0.36470588}, {10600,0.39102941}, {10700,0.38114706}, {10800,0.38390196}, {10900,0.39269608}, {11000,0.39590196}, {11100,0.39953922}, {11200,0.40418627}, {11300,0.40050000}, {11400,0.40895098}, {11500,0.41466667}, {11600,0.42011765}, {11700,0.42094118}, {11800,0.42619608}, {11900,0.42975490}, {12000,0.43150980}, {12100,0.42919608}, {12200,0.42921569}, {12300,0.44167647}, {12400,0.43978431}, {12500,0.44933333}, {12600,0.44400980}, {12700,0.45775490}, {12800,0.47173529}, {12900,0.47467647}, {13000,0.46850000}, {13100,0.46146078}, {13200,0.47428431}, {13300,0.48073529}, {13400,0.47734314}, {13500,0.47094118}, {13600,0.49274510}, {13700,0.49422549}, {13800,0.49946078}, {13900,0.50342157}, {14000,0.50793137}, {14100,0.50249020}, {14200,0.51204902}, {14300,0.51029412}, {14400,0.52146078}, {14500,0.52379412}, {14600,0.52349020}, {14700,0.52549020}, {14800,0.53109804}, {14900,0.53780392}, {15000,0.54265686}, {15100,0.53742157}, {15200,0.55050980}, {15300,0.54792157}, {15400,0.54973529}, {15500,0.54029412}, {15600,0.56430392}, {15700,0.56750980}, {15800,0.56151961}, {15900,0.56845098}, {16000,0.57051961}, {16100,0.57317647}, {16200,0.59280392}, {16300,0.58807843}, {16400,0.58677451}, {16500,0.58790196}, {16600,0.59285294}, {16700,0.59978431}, {16800,0.60689216}, {16900,0.61225490}, {17000,0.60551961}, {17100,0.60334314}, {17200,0.62159804}, {17300,0.61764706}, {17400,0.62393137}, {17500,0.62549020}, {17600,0.63472549}, {17700,0.62981373}, {17800,0.62919608}, {17900,0.64528431}, {18000,0.63571569}, {18100,0.63985294}, {18200,0.64624510}, {18300,0.65310784}, {18400,0.65542157}, {18500,0.65934314}, {18600,0.66382353}, {18700,0.66244118}, {18800,0.67865686}, {18900,0.68543137}, {19000,0.67794118}, {19100,0.68836275}, {19200,0.68487255}, {19300,0.69064706}, {19400,0.69016667}, {19500,0.71248039}, {19600,0.68498039}, {19700,0.69870588}, {19800,0.71545098}, {19900,0.71469608}, {20000,0.71108824}};
data["big_flat"]["Ltac2LowLevel"]["actual reif"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00006863}, {4,0.00024510}, {5,0.00021569}, {6,0.00018627}, {7,0.00034314}, {8,0.00034314}, {9,0.00026471}, {10,0.00034314}, {11,0.00044118}, {12,0.00046078}, {13,0.00044118}, {14,0.00054902}, {15,0.00040196}, {16,0.00074510}, {17,0.00043137}, {18,0.00070588}, {19,0.00058824}, {20,0.00071569}, {21,0.00057843}, {22,0.00064706}, {23,0.00054902}, {24,0.00076471}, {25,0.00076471}, {26,0.01724510}, {27,0.00090196}, {28,0.00103922}, {29,0.00080392}, {30,0.00092157}, {31,0.00098039}, {32,0.00104902}, {33,0.00110784}, {34,0.00105882}, {35,0.00113725}, {36,0.00113725}, {37,0.00140196}, {38,0.00106863}, {39,0.00141176}, {40,0.00139216}, {41,0.00153922}, {42,0.00136275}, {43,0.00136275}, {44,0.00147059}, {45,0.00144118}, {46,0.00159804}, {47,0.00140196}, {48,0.00157843}, {49,0.00155882}, {50,0.00166667}, {51,0.00151961}, {52,0.00172549}, {53,0.00160784}, {54,0.00181373}, {55,0.00181373}, {56,0.00185294}, {57,0.00190196}, {58,0.00189216}, {59,0.00178431}, {60,0.00195098}, {61,0.00208824}, {62,0.00200980}, {63,0.00191176}, {64,0.00192157}, {65,0.00201961}, {66,0.00186275}, {67,0.00182353}, {68,0.00185294}, {69,0.00195098}, {70,0.00197059}, {71,0.00228431}, {72,0.00232353}, {73,0.00255882}, {74,0.00250980}, {75,0.00229412}, {76,0.00225490}, {77,0.00246078}, {78,0.00256863}, {79,0.00272549}, {80,0.00325490}, {81,0.00247059}, {82,0.00256863}, {83,0.00264706}, {84,0.00283333}, {85,0.00259804}, {86,0.00263725}, {87,0.00266667}, {88,0.00283333}, {89,0.00279412}, {90,0.00273529}, {91,0.00292157}, {92,0.00277451}, {93,0.00270588}, {94,0.00302941}, {95,0.00307843}, {96,0.00323529}, {97,0.00311765}, {98,0.00367647}, {99,0.00318627}, {100,0.00325490}, {101,0.00312745}, {102,0.00311765}, {103,0.00340196}, {104,0.00322549}, {105,0.00352941}, {106,0.00333333}, {107,0.00342157}, {108,0.00330392}, {109,0.00342157}, {110,0.00347059}, {111,0.00356863}, {112,0.00361765}, {113,0.00426471}, {114,0.00361765}, {115,0.00368627}, {116,0.00363725}, {117,0.00369608}, {118,0.00377451}, {119,0.00383333}, {120,0.00378431}, {121,0.00371569}, {122,0.00380392}, {123,0.00364706}, {124,0.00391176}, {125,0.00394118}, {126,0.00389216}, {127,0.00469608}, {128,0.00412745}, {129,0.00413725}, {130,0.00415686}, {131,0.00408824}, {132,0.00430392}, {133,0.00421569}, {134,0.00408824}, {135,0.00447059}, {136,0.00436275}, {137,0.00396078}, {138,0.00440196}, {139,0.00500980}, {140,0.00466667}, {141,0.00475490}, {142,0.00441176}, {143,0.00449020}, {144,0.00444118}, {145,0.00430392}, {146,0.00432353}, {147,0.00448039}, {148,0.00449020}, {149,0.00455882}, {150,0.00463725}, {151,0.00455882}, {152,0.00483333}, {153,0.00496078}, {154,0.00514706}, {155,0.00532353}, {156,0.00523529}, {157,0.00524510}, {158,0.00488235}, {159,0.00482353}, {160,0.00500000}, {161,0.00503922}, {162,0.00532353}, {163,0.00539216}, {164,0.00506863}, {165,0.00525490}, {166,0.00510784}, {167,0.00523529}, {168,0.00558824}, {169,0.00534314}, {170,0.00522549}, {171,0.00517647}, {172,0.00565686}, {173,0.00553922}, {174,0.00551961}, {175,0.00570588}, {176,0.00565686}, {177,0.00550000}, {178,0.00566667}, {179,0.00557843}, {180,0.00549020}, {181,0.00654902}, {182,0.00575490}, {183,0.00587255}, {184,0.00580392}, {185,0.00582353}, {186,0.00589216}, {187,0.00588235}, {188,0.00601961}, {189,0.00608824}, {190,0.00669608}, {191,0.00593137}, {192,0.00619608}, {193,0.00610784}, {194,0.00640196}, {195,0.00609804}, {196,0.00632353}, {197,0.00606863}, {198,0.00627451}, {199,0.00700000}, {200,0.00626471}, {201,0.00624510}, {202,0.00629412}, {203,0.00647059}, {204,0.00627451}, {205,0.00623529}, {206,0.00684314}, {207,0.00655882}, {208,0.00628431}, {209,0.00657843}, {210,0.00682353}, {211,0.00665686}, {212,0.00666667}, {213,0.00658824}, {214,0.00690196}, {215,0.00686275}, {216,0.00689216}, {217,0.00699020}, {218,0.00703922}, {219,0.00691176}, {220,0.00701961}, {221,0.00704902}, {222,0.00707843}, {223,0.00705882}, {224,0.00705882}, {225,0.00705882}, {226,0.00715686}, {227,0.00708824}, {228,0.00712745}, {229,0.00728431}, {230,0.00738235}, {231,0.00863725}, {232,0.00741176}, {233,0.00732353}, {234,0.00748039}, {235,0.00753922}, {236,0.00739216}, {237,0.00744118}, {238,0.00850000}, {239,0.00753922}, {240,0.00772549}, {241,0.00763725}, {242,0.00784314}, {243,0.00781373}, {244,0.00745098}, {245,0.00789216}, {246,0.00771569}, {247,0.00789216}, {248,0.00799020}, {249,0.00806863}, {250,0.00836275}, {251,0.00785294}, {252,0.00816667}, {253,0.00847059}, {254,0.00810784}, {255,0.00800000}, {256,0.00815686}, {257,0.00823529}, {258,0.00839216}, {259,0.00938235}, {260,0.00877451}, {261,0.00841176}, {262,0.00856863}, {263,0.00838235}, {264,0.00899020}, {265,0.00871569}, {266,0.00966667}, {267,0.00861765}, {268,0.00871569}, {269,0.00908824}, {270,0.00903922}, {271,0.00868627}, {272,0.01020588}, {273,0.00905882}, {274,0.00933333}, {275,0.00886275}, {276,0.00932353}, {277,0.00875490}, {278,0.00970588}, {279,0.00901961}, {280,0.00978431}, {281,0.00909804}, {282,0.00959804}, {283,0.00950980}, {284,0.00924510}, {285,0.01101961}, {286,0.00924510}, {287,0.00969608}, {288,0.00966667}, {289,0.00944118}, {290,0.00979412}, {291,0.01069608}, {292,0.00977451}, {293,0.00990196}, {294,0.00942157}, {295,0.01013725}, {296,0.01000980}, {297,0.01096078}, {298,0.00982353}, {299,0.01017647}, {300,0.01024510}, {301,0.00983333}, {302,0.01033333}, {303,0.01043137}, {304,0.01069608}, {305,0.01014706}, {306,0.01032353}, {307,0.01001961}, {308,0.01185294}, {309,0.01036275}, {310,0.01058824}, {311,0.01022549}, {312,0.01050000}, {313,0.01119608}, {314,0.01183333}, {315,0.01122549}, {316,0.01051961}, {317,0.01085294}, {318,0.01062745}, {319,0.01089216}, {320,0.01096078}, {321,0.01093137}, {322,0.01118627}, {323,0.01106863}, {324,0.01096078}, {325,0.01211765}, {326,0.01134314}, {327,0.01133333}, {328,0.01136275}, {329,0.01123529}, {330,0.01227451}, {331,0.01156863}, {332,0.01158824}, {333,0.01146078}, {334,0.01136275}, {335,0.01162745}, {336,0.01163725}, {337,0.01158824}, {338,0.01164706}, {339,0.01169608}, {340,0.01178431}, {341,0.01267647}, {342,0.01175490}, {343,0.01184314}, {344,0.01189216}, {345,0.01194118}, {346,0.01241176}, {347,0.01197059}, {348,0.01190196}, {349,0.01198039}, {350,0.01206863}, {351,0.01280392}, {352,0.01204902}, {353,0.01229412}, {354,0.01197059}, {355,0.01224510}, {356,0.01294118}, {357,0.01247059}, {358,0.01240196}, {359,0.01235294}, {360,0.01225490}, {361,0.01324510}, {362,0.01264706}, {363,0.01231373}, {364,0.01255882}, {365,0.01262745}, {366,0.01345098}, {367,0.01255882}, {368,0.01277451}, {369,0.01270588}, {370,0.01273529}, {371,0.01292157}, {372,0.01292157}, {373,0.01275490}, {374,0.01272549}, {375,0.01337255}, {376,0.01300980}, {377,0.01297059}, {378,0.01291176}, {379,0.01297059}, {380,0.01370588}, {381,0.01280392}, {382,0.01354902}, {383,0.01300000}, {384,0.01287255}, {385,0.01311765}, {386,0.01322549}, {387,0.01303922}, {388,0.01337255}, {389,0.01418627}, {390,0.01338235}, {391,0.01359804}, {392,0.01328431}, {393,0.01314706}, {394,0.01336275}, {395,0.01309804}, {396,0.01336275}, {397,0.01369608}, {398,0.01447059}, {399,0.01378431}, {400,0.01389216}, {401,0.01359804}, {402,0.01363725}, {403,0.01387255}, {404,0.01403922}, {405,0.01381373}, {406,0.01379412}, {407,0.01445098}, {408,0.01358824}, {409,0.01355882}, {410,0.01364706}, {411,0.01501961}, {412,0.01406863}, {413,0.01412745}, {414,0.01402941}, {415,0.01416667}, {416,0.01427451}, {417,0.01443137}, {418,0.01450000}, {419,0.01457843}, {420,0.01512745}, {421,0.01416667}, {422,0.01435294}, {423,0.01449020}, {424,0.01519608}, {425,0.01435294}, {426,0.01442157}, {427,0.01469608}, {428,0.01563725}, {429,0.01450000}, {430,0.01457843}, {431,0.01464706}, {432,0.01551961}, {433,0.01471569}, {434,0.01480392}, {435,0.01449020}, {436,0.01547059}, {437,0.01475490}, {438,0.01483333}, {439,0.01500000}, {440,0.01607843}, {441,0.01477451}, {442,0.01497059}, {443,0.01529412}, {444,0.01586275}, {445,0.01496078}, {446,0.01501961}, {447,0.01502941}, {448,0.01635294}, {449,0.01527451}, {450,0.01521569}, {451,0.01525490}, {452,0.01614706}, {453,0.01532353}, {454,0.01533333}, {455,0.01546078}, {456,0.01647059}, {457,0.01551961}, {458,0.01546078}, {459,0.01544118}, {460,0.01649020}, {461,0.01549020}, {462,0.01555882}, {463,0.01550000}, {464,0.01663725}, {465,0.01560784}, {466,0.01564706}, {467,0.01591176}, {468,0.01667647}, {469,0.01577451}, {470,0.01582353}, {471,0.01578431}, {472,0.01617647}, {473,0.01596078}, {474,0.01597059}, {475,0.01701961}, {476,0.01602941}, {477,0.01595098}, {478,0.01619608}, {479,0.01713725}, {480,0.01617647}, {481,0.01628431}, {482,0.01629412}, {483,0.01697059}, {484,0.01631373}, {485,0.01658824}, {486,0.01743137}, {487,0.01607843}, {488,0.01625490}, {489,0.01636275}, {490,0.01708824}, {491,0.01642157}, {492,0.01627451}, {493,0.01612745}, {494,0.01688235}, {495,0.01676471}, {496,0.01669608}, {497,0.01835294}, {498,0.01688235}, {499,0.01714706}, {500,0.01717647}, {505,0.01776471}, {510,0.01686275}, {515,0.01756863}, {520,0.01873529}, {525,0.01738235}, {530,0.01749020}, {535,0.01776471}, {540,0.01820588}, {545,0.01812745}, {550,0.01851961}, {555,0.02028431}, {560,0.01876471}, {565,0.01883333}, {570,0.02061765}, {575,0.01914706}, {580,0.01949020}, {585,0.02114706}, {590,0.01997059}, {595,0.01990196}, {600,0.02186275}, {605,0.02014706}, {610,0.02106863}, {615,0.02213725}, {620,0.02124510}, {625,0.02083333}, {630,0.02295098}, {635,0.02147059}, {640,0.02181373}, {645,0.02347059}, {650,0.02254902}, {655,0.02230392}, {660,0.02258824}, {665,0.02287255}, {670,0.02442157}, {675,0.02300000}, {680,0.02346078}, {685,0.02480392}, {690,0.02373529}, {695,0.02398039}, {700,0.02416667}, {705,0.02444118}, {710,0.02557843}, {715,0.02463725}, {720,0.02442157}, {725,0.02515686}, {730,0.02528431}, {735,0.02628431}, {740,0.02544118}, {745,0.02543137}, {750,0.02539216}, {755,0.02600000}, {760,0.02730392}, {765,0.02631373}, {770,0.02773529}, {775,0.02631373}, {780,0.02660784}, {785,0.02685294}, {790,0.02687255}, {795,0.02851961}, {800,0.02750980}, {805,0.02925490}, {810,0.02751961}, {815,0.02928431}, {820,0.02792157}, {825,0.02819608}, {830,0.02855882}, {835,0.02873529}, {840,0.02878431}, {845,0.02874510}, {850,0.03179412}, {855,0.02945098}, {860,0.03106863}, {865,0.02994118}, {870,0.03140196}, {875,0.03004902}, {880,0.03197059}, {885,0.03058824}, {890,0.03226471}, {895,0.03119608}, {900,0.03279412}, {905,0.03144118}, {910,0.03324510}, {915,0.03182353}, {920,0.03341176}, {925,0.03221569}, {930,0.03374510}, {935,0.03229412}, {940,0.03407843}, {945,0.03276471}, {950,0.03396078}, {955,0.03330392}, {960,0.03426471}, {965,0.03325490}, {970,0.03355882}, {975,0.03379412}, {980,0.03387255}, {985,0.03575490}, {990,0.03450980}, {995,0.03574510}, {1000,0.03470588}, {1010,0.03623529}, {1020,0.03528431}, {1030,0.03683333}, {1040,0.03575490}, {1050,0.03586275}, {1060,0.03892157}, {1070,0.03702941}, {1080,0.03826471}, {1090,0.03756863}, {1100,0.03751961}, {1110,0.03984314}, {1120,0.03830392}, {1130,0.04041176}, {1140,0.04139216}, {1150,0.03957843}, {1160,0.04204902}, {1170,0.04009804}, {1180,0.04049020}, {1190,0.04339216}, {1200,0.04139216}, {1210,0.04140196}, {1220,0.04499020}, {1230,0.04260784}, {1240,0.04270588}, {1250,0.04552941}, {1260,0.04582353}, {1270,0.04409804}, {1280,0.04599020}, {1290,0.04675490}, {1300,0.04512745}, {1310,0.04559804}, {1320,0.04830392}, {1330,0.04800980}, {1340,0.04635294}, {1350,0.04834314}, {1360,0.04878431}, {1370,0.04974510}, {1380,0.04758824}, {1390,0.04950980}, {1400,0.05030392}, {1410,0.05083333}, {1420,0.04886275}, {1430,0.04919608}, {1440,0.05159804}, {1450,0.05194118}, {1460,0.05332353}, {1470,0.05038235}, {1480,0.05056863}, {1490,0.05446078}, {1500,0.05418627}, {1510,0.05461765}, {1520,0.05190196}, {1530,0.05275490}, {1540,0.05296078}, {1550,0.05730392}, {1560,0.05624510}, {1570,0.05661765}, {1580,0.05724510}, {1590,0.05514706}, {1600,0.05554902}, {1610,0.05569608}, {1620,0.05809804}, {1630,0.05830392}, {1640,0.05872549}, {1650,0.05942157}, {1660,0.05987255}, {1670,0.06023529}, {1680,0.06109804}, {1690,0.06132353}, {1700,0.05887255}, {1710,0.05920588}, {1720,0.05955882}, {1730,0.05979412}, {1740,0.06040196}, {1750,0.06051961}, {1760,0.06327451}, {1770,0.06347059}, {1780,0.06412745}, {1790,0.06434314}, {1800,0.06473529}, {1810,0.06502941}, {1820,0.06543137}, {1830,0.06555882}, {1840,0.06598039}, {1850,0.06654902}, {1860,0.06677451}, {1870,0.06707843}, {1880,0.06722549}, {1890,0.06756863}, {1900,0.06586275}, {1910,0.06577451}, {1920,0.06645098}, {1930,0.06658824}, {1940,0.07073529}, {1950,0.07076471}, {1960,0.07051961}, {1970,0.07139216}, {1980,0.07159804}, {1990,0.07158824}, {2000,0.07223529}, {2050,0.07371569}, {2100,0.07546078}, {2150,0.07663725}, {2200,0.07924510}, {2250,0.08093137}, {2300,0.08248039}, {2350,0.08135294}, {2400,0.09028431}, {2450,0.08827451}, {2500,0.09022549}, {2550,0.09139216}, {2600,0.09299020}, {2650,0.09760784}, {2700,0.09716667}, {2750,0.09810784}, {2800,0.10051961}, {2850,0.10271569}, {2900,0.10393137}, {2950,0.10879412}, {3000,0.10800000}, {3050,0.10918627}, {3100,0.11230392}, {3150,0.11302941}, {3200,0.11511765}, {3250,0.11666667}, {3300,0.11892157}, {3350,0.12017647}, {3400,0.12228431}, {3450,0.12469608}, {3500,0.12642157}, {3550,0.12825490}, {3600,0.12986275}, {3650,0.13171569}, {3700,0.13318627}, {3750,0.13571569}, {3800,0.13735294}, {3850,0.13895098}, {3900,0.14028431}, {3950,0.14191176}, {4000,0.14394118}, {4050,0.14555882}, {4100,0.15316667}, {4150,0.14939216}, {4200,0.14906863}, {4250,0.15341176}, {4300,0.15472549}, {4350,0.15379412}, {4400,0.15937255}, {4450,0.15967647}, {4500,0.16143137}, {4550,0.16350000}, {4600,0.16352941}, {4650,0.16668627}, {4700,0.17005882}, {4750,0.17070588}, {4800,0.17353922}, {4850,0.17421569}, {4900,0.17582353}, {4950,0.17901961}, {5000,0.18008824}, {5050,0.18190196}, {5100,0.18318627}, {5150,0.18594118}, {5200,0.18413725}, {5250,0.18888235}, {5300,0.18373529}, {5350,0.19201961}, {5400,0.19409804}, {5450,0.19544118}, {5500,0.19726471}, {5550,0.19923529}, {5600,0.20039216}, {5650,0.20230392}, {5700,0.20392157}, {5750,0.20553922}, {5800,0.20564706}, {5850,0.21039216}, {5900,0.21225490}, {5950,0.21340196}, {6000,0.21819608}, {6050,0.22490196}, {6100,0.22841176}, {6150,0.22121569}, {6200,0.23210784}, {6250,0.22574510}, {6300,0.22415686}, {6350,0.22860784}, {6400,0.23855882}, {6450,0.23208824}, {6500,0.23470588}, {6550,0.23601961}, {6600,0.23544118}, {6650,0.23921569}, {6700,0.24287255}, {6750,0.24070588}, {6800,0.24485294}, {6850,0.24806863}, {6900,0.24891176}, {6950,0.25149020}, {7000,0.24282353}, {7050,0.25810784}, {7100,0.25657843}, {7150,0.25832353}, {7200,0.26412745}, {7250,0.26160784}, {7300,0.25879412}, {7350,0.26140196}, {7400,0.26359804}, {7450,0.26846078}, {7500,0.26995098}, {7550,0.27313725}, {7600,0.27457843}, {7650,0.27594118}, {7700,0.27590196}, {7750,0.27540196}, {7800,0.28004902}, {7850,0.28254902}, {7900,0.28284314}, {7950,0.28271569}, {8000,0.28890196}, {8050,0.28895098}, {8100,0.29099020}, {8150,0.28232353}, {8200,0.29170588}, {8250,0.30100980}, {8300,0.29293137}, {8350,0.28917647}, {8400,0.30600000}, {8450,0.30300980}, {8500,0.30533333}, {8550,0.30576471}, {8600,0.30644118}, {8650,0.31285294}, {8700,0.31305882}, {8750,0.31553922}, {8800,0.31179412}, {8850,0.32041176}, {8900,0.32035294}, {8950,0.32620588}, {9000,0.31882353}, {9050,0.32097059}, {9100,0.32256863}, {9150,0.32650000}, {9200,0.32571569}, {9250,0.32911765}, {9300,0.33021569}, {9350,0.33058824}, {9400,0.34198039}, {9450,0.34025490}, {9500,0.34210784}, {9550,0.34114706}, {9600,0.34124510}, {9650,0.34657843}, {9700,0.35056863}, {9750,0.35139216}, {9800,0.34754902}, {9850,0.35421569}, {9900,0.35576471}, {9950,0.36190196}, {10000,0.35502941}, {10100,0.36113725}, {10200,0.36199020}, {10300,0.37406863}, {10400,0.37477451}, {10500,0.36434314}, {10600,0.39056863}, {10700,0.38074510}, {10800,0.38346078}, {10900,0.39268627}, {11000,0.39555882}, {11100,0.39922549}, {11200,0.40383333}, {11300,0.40026471}, {11400,0.40902941}, {11500,0.41435294}, {11600,0.41969608}, {11700,0.42052941}, {11800,0.42590196}, {11900,0.42919608}, {12000,0.43060784}, {12100,0.42884314}, {12200,0.42868627}, {12300,0.44138235}, {12400,0.43957843}, {12500,0.44860784}, {12600,0.44356863}, {12700,0.45709804}, {12800,0.47135294}, {12900,0.47384314}, {13000,0.46779412}, {13100,0.46091176}, {13200,0.47381373}, {13300,0.48020588}, {13400,0.47662745}, {13500,0.47001961}, {13600,0.49232353}, {13700,0.49377451}, {13800,0.49889216}, {13900,0.50308824}, {14000,0.50707843}, {14100,0.50220588}, {14200,0.51171569}, {14300,0.50954902}, {14400,0.52110784}, {14500,0.52320588}, {14600,0.52260784}, {14700,0.52480392}, {14800,0.53064706}, {14900,0.53739216}, {15000,0.54208824}, {15100,0.53672549}, {15200,0.54988235}, {15300,0.54730392}, {15400,0.54929412}, {15500,0.53996078}, {15600,0.56351961}, {15700,0.56709804}, {15800,0.56115686}, {15900,0.56782353}, {16000,0.57002941}, {16100,0.57260784}, {16200,0.59211765}, {16300,0.58751961}, {16400,0.58619608}, {16500,0.58729412}, {16600,0.59226471}, {16700,0.59962745}, {16800,0.60642157}, {16900,0.61153922}, {17000,0.60504902}, {17100,0.60268627}, {17200,0.62117647}, {17300,0.61710784}, {17400,0.62327451}, {17500,0.62479412}, {17600,0.63435294}, {17700,0.62935294}, {17800,0.62871569}, {17900,0.64454902}, {18000,0.63533333}, {18100,0.63920588}, {18200,0.64549020}, {18300,0.65242157}, {18400,0.65477451}, {18500,0.65854902}, {18600,0.66309804}, {18700,0.66169608}, {18800,0.67823529}, {18900,0.68460784}, {19000,0.67737255}, {19100,0.68762745}, {19200,0.68428431}, {19300,0.69001961}, {19400,0.68957843}, {19500,0.71169608}, {19600,0.68410784}, {19700,0.69796078}, {19800,0.71500000}, {19900,0.71398039}, {20000,0.71050980}};
data["big_flat"]["Ltac2LowLevel"]["actual reif"]["system"] = {{1,0.00000000}, {2,0.00003922}, {3,0.00003922}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00003922}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00003922}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00003922}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00003922}, {24,0.00010784}, {25,0.00000000}, {26,0.00015686}, {27,0.00000000}, {28,0.00003922}, {29,0.00003922}, {30,0.00000000}, {31,0.00003922}, {32,0.00003922}, {33,0.00000000}, {34,0.00003922}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003922}, {42,0.00000000}, {43,0.00007843}, {44,0.00003922}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00002941}, {49,0.00003922}, {50,0.00003922}, {51,0.00000000}, {52,0.00000000}, {53,0.00003922}, {54,0.00000000}, {55,0.00000000}, {56,0.00003922}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00003922}, {61,0.00000000}, {62,0.00000000}, {63,0.00002941}, {64,0.00000000}, {65,0.00000000}, {66,0.00003922}, {67,0.00003922}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00002941}, {73,0.00000000}, {74,0.00003922}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00007843}, {80,0.00003922}, {81,0.00003922}, {82,0.00003922}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00003922}, {87,0.00007843}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00011765}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00003922}, {100,0.00000000}, {101,0.00002941}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00002941}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00002941}, {121,0.00002941}, {122,0.00000000}, {123,0.00006863}, {124,0.00003922}, {125,0.00003922}, {126,0.00000000}, {127,0.00000000}, {128,0.00003922}, {129,0.00000000}, {130,0.00000000}, {131,0.00006863}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00003922}, {138,0.00003922}, {139,0.00003922}, {140,0.00003922}, {141,0.00000000}, {142,0.00003922}, {143,0.00000000}, {144,0.00000000}, {145,0.00003922}, {146,0.00007843}, {147,0.00000000}, {148,0.00003922}, {149,0.00000000}, {150,0.00000000}, {151,0.00003922}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00003922}, {156,0.00000000}, {157,0.00000000}, {158,0.00003922}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00003922}, {163,0.00000000}, {164,0.00007843}, {165,0.00003922}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00003922}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00007843}, {179,0.00007843}, {180,0.00000000}, {181,0.00011765}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00003922}, {189,0.00000000}, {190,0.00002941}, {191,0.00003922}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00003922}, {199,0.00003922}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00002941}, {204,0.00002941}, {205,0.00000000}, {206,0.00003922}, {207,0.00000000}, {208,0.00000000}, {209,0.00003922}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00006863}, {225,0.00000000}, {226,0.00000000}, {227,0.00003922}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00011765}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00003922}, {238,0.00006863}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00003922}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00003922}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00003922}, {260,0.00000000}, {261,0.00000000}, {262,0.00003922}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00003922}, {271,0.00000000}, {272,0.00003922}, {273,0.00000000}, {274,0.00002941}, {275,0.00000000}, {276,0.00003922}, {277,0.00000000}, {278,0.00003922}, {279,0.00000000}, {280,0.00000000}, {281,0.00007843}, {282,0.00000000}, {283,0.00000000}, {284,0.00003922}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00003922}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00003922}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00003922}, {309,0.00006863}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00003922}, {314,0.00000000}, {315,0.00000000}, {316,0.00003922}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00003922}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00003922}, {330,0.00003922}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00003922}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00003922}, {346,0.00002941}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00003922}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00003922}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00003922}, {361,0.00003922}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00003922}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00002941}, {375,0.00011765}, {376,0.00003922}, {377,0.00000000}, {378,0.00000000}, {379,0.00003922}, {380,0.00003922}, {381,0.00000000}, {382,0.00000000}, {383,0.00003922}, {384,0.00007843}, {385,0.00002941}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00007843}, {390,0.00002941}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00003922}, {395,0.00000000}, {396,0.00003922}, {397,0.00003922}, {398,0.00015686}, {399,0.00000000}, {400,0.00003922}, {401,0.00003922}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00007843}, {406,0.00000000}, {407,0.00011765}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00007843}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00003922}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00007843}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00003922}, {437,0.00003922}, {438,0.00000000}, {439,0.00000000}, {440,0.00002941}, {441,0.00000000}, {442,0.00002941}, {443,0.00000000}, {444,0.00000000}, {445,0.00003922}, {446,0.00003922}, {447,0.00006863}, {448,0.00006863}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00003922}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00003922}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00003922}, {479,0.00000000}, {480,0.00003922}, {481,0.00000000}, {482,0.00003922}, {483,0.00000000}, {484,0.00000000}, {485,0.00007843}, {486,0.00000000}, {487,0.00007843}, {488,0.00000000}, {489,0.00000000}, {490,0.00003922}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00007843}, {498,0.00000000}, {499,0.00000000}, {500,0.00003922}, {505,0.00000000}, {510,0.00007843}, {515,0.00003922}, {520,0.00000000}, {525,0.00003922}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00003922}, {550,0.00003922}, {555,0.00003922}, {560,0.00000000}, {565,0.00003922}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00003922}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00002941}, {620,0.00000000}, {625,0.00000000}, {630,0.00007843}, {635,0.00000000}, {640,0.00000000}, {645,0.00002941}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00003922}, {680,0.00000000}, {685,0.00002941}, {690,0.00000000}, {695,0.00000000}, {700,0.00003922}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00003922}, {725,0.00000000}, {730,0.00000000}, {735,0.00003922}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00003922}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00007843}, {800,0.00000000}, {805,0.00006863}, {810,0.00003922}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00002941}, {850,0.00000000}, {855,0.00000000}, {860,0.00003922}, {865,0.00000000}, {870,0.00011765}, {875,0.00000000}, {880,0.00002941}, {885,0.00003922}, {890,0.00002941}, {895,0.00003922}, {900,0.00007843}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00003922}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00011765}, {945,0.00003922}, {950,0.00003922}, {955,0.00003922}, {960,0.00011765}, {965,0.00003922}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00011765}, {990,0.00003922}, {995,0.00006863}, {1000,0.00007843}, {1010,0.00003922}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00007843}, {1060,0.00003922}, {1070,0.00000000}, {1080,0.00015686}, {1090,0.00003922}, {1100,0.00003922}, {1110,0.00007843}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00007843}, {1150,0.00003922}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00007843}, {1230,0.00000000}, {1240,0.00003922}, {1250,0.00000000}, {1260,0.00003922}, {1270,0.00000000}, {1280,0.00003922}, {1290,0.00003922}, {1300,0.00003922}, {1310,0.00000000}, {1320,0.00003922}, {1330,0.00011765}, {1340,0.00003922}, {1350,0.00003922}, {1360,0.00002941}, {1370,0.00006863}, {1380,0.00000000}, {1390,0.00003922}, {1400,0.00003922}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00007843}, {1450,0.00007843}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00003922}, {1500,0.00003922}, {1510,0.00007843}, {1520,0.00002941}, {1530,0.00003922}, {1540,0.00003922}, {1550,0.00015686}, {1560,0.00003922}, {1570,0.00014706}, {1580,0.00003922}, {1590,0.00000000}, {1600,0.00003922}, {1610,0.00006863}, {1620,0.00007843}, {1630,0.00006863}, {1640,0.00003922}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00006863}, {1680,0.00023529}, {1690,0.00003922}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00006863}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00003922}, {1760,0.00010784}, {1770,0.00015686}, {1780,0.00003922}, {1790,0.00011765}, {1800,0.00011765}, {1810,0.00000000}, {1820,0.00007843}, {1830,0.00011765}, {1840,0.00000000}, {1850,0.00003922}, {1860,0.00003922}, {1870,0.00000000}, {1880,0.00007843}, {1890,0.00003922}, {1900,0.00000000}, {1910,0.00003922}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00003922}, {1950,0.00000000}, {1960,0.00007843}, {1970,0.00000000}, {1980,0.00011765}, {1990,0.00003922}, {2000,0.00007843}, {2050,0.00003922}, {2100,0.00017647}, {2150,0.00003922}, {2200,0.00011765}, {2250,0.00006863}, {2300,0.00003922}, {2350,0.00003922}, {2400,0.00022549}, {2450,0.00003922}, {2500,0.00003922}, {2550,0.00014706}, {2600,0.00011765}, {2650,0.00003922}, {2700,0.00007843}, {2750,0.00007843}, {2800,0.00007843}, {2850,0.00007843}, {2900,0.00011765}, {2950,0.00017647}, {3000,0.00003922}, {3050,0.00011765}, {3100,0.00011765}, {3150,0.00018627}, {3200,0.00015686}, {3250,0.00010784}, {3300,0.00014706}, {3350,0.00010784}, {3400,0.00007843}, {3450,0.00010784}, {3500,0.00003922}, {3550,0.00003922}, {3600,0.00007843}, {3650,0.00007843}, {3700,0.00010784}, {3750,0.00000000}, {3800,0.00007843}, {3850,0.00014706}, {3900,0.00011765}, {3950,0.00019608}, {4000,0.00011765}, {4050,0.00011765}, {4100,0.00031373}, {4150,0.00022549}, {4200,0.00007843}, {4250,0.00023529}, {4300,0.00011765}, {4350,0.00007843}, {4400,0.00015686}, {4450,0.00018627}, {4500,0.00018627}, {4550,0.00000000}, {4600,0.00010784}, {4650,0.00007843}, {4700,0.00027451}, {4750,0.00003922}, {4800,0.00014706}, {4850,0.00019608}, {4900,0.00007843}, {4950,0.00011765}, {5000,0.00003922}, {5050,0.00003922}, {5100,0.00003922}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00007843}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00003922}, {5550,0.00000000}, {5600,0.00007843}, {5650,0.00000000}, {5700,0.00003922}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00003922}, {6050,0.00007843}, {6100,0.00002941}, {6150,0.00003922}, {6200,0.00000000}, {6250,0.00003922}, {6300,0.00000000}, {6350,0.00003922}, {6400,0.00124510}, {6450,0.00031373}, {6500,0.00003922}, {6550,0.00019608}, {6600,0.00000000}, {6650,0.00014706}, {6700,0.00022549}, {6750,0.00015686}, {6800,0.00031373}, {6850,0.00027451}, {6900,0.00026471}, {6950,0.00018627}, {7000,0.00011765}, {7050,0.00021569}, {7100,0.00015686}, {7150,0.00007843}, {7200,0.00031373}, {7250,0.00039216}, {7300,0.00029412}, {7350,0.00021569}, {7400,0.00011765}, {7450,0.00026471}, {7500,0.00026471}, {7550,0.00023529}, {7600,0.00032353}, {7650,0.00027451}, {7700,0.00014706}, {7750,0.00014706}, {7800,0.00042157}, {7850,0.00015686}, {7900,0.00011765}, {7950,0.00015686}, {8000,0.00015686}, {8050,0.00007843}, {8100,0.00027451}, {8150,0.00007843}, {8200,0.00026471}, {8250,0.00042157}, {8300,0.00019608}, {8350,0.00010784}, {8400,0.00031373}, {8450,0.00031373}, {8500,0.00027451}, {8550,0.00050980}, {8600,0.00014706}, {8650,0.00010784}, {8700,0.00000000}, {8750,0.00003922}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00011765}, {8950,0.00007843}, {9000,0.00000000}, {9050,0.00007843}, {9100,0.00000000}, {9150,0.00003922}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00003922}, {9350,0.00003922}, {9400,0.00000000}, {9450,0.00003922}, {9500,0.00003922}, {9550,0.00011765}, {9600,0.00000000}, {9650,0.00007843}, {9700,0.00007843}, {9750,0.00003922}, {9800,0.00007843}, {9850,0.00011765}, {9900,0.00011765}, {9950,0.00002941}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00003922}, {10300,0.00007843}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00003922}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00003922}, {11200,0.00000000}, {11300,0.00007843}, {11400,0.00007843}, {11500,0.00000000}, {11600,0.00003922}, {11700,0.00003922}, {11800,0.00007843}, {11900,0.00007843}, {12000,0.00006863}, {12100,0.00007843}, {12200,0.00011765}, {12300,0.00000000}, {12400,0.00002941}, {12500,0.00003922}, {12600,0.00007843}, {12700,0.00003922}, {12800,0.00003922}, {12900,0.00003922}, {13000,0.00003922}, {13100,0.00003922}, {13200,0.00003922}, {13300,0.00000000}, {13400,0.00009804}, {13500,0.00003922}, {13600,0.00000000}, {13700,0.00007843}, {13800,0.00003922}, {13900,0.00003922}, {14000,0.00000000}, {14100,0.00011765}, {14200,0.00003922}, {14300,0.00003922}, {14400,0.00003922}, {14500,0.00000000}, {14600,0.00006863}, {14700,0.00007843}, {14800,0.00007843}, {14900,0.00003922}, {15000,0.00003922}, {15100,0.00000000}, {15200,0.00007843}, {15300,0.00003922}, {15400,0.00007843}, {15500,0.00011765}, {15600,0.00007843}, {15700,0.00002941}, {15800,0.00010784}, {15900,0.00011765}, {16000,0.00000000}, {16100,0.00010784}, {16200,0.00009804}, {16300,0.00003922}, {16400,0.00002941}, {16500,0.00002941}, {16600,0.00003922}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00011765}, {17000,0.00007843}, {17100,0.00000000}, {17200,0.00003922}, {17300,0.00015686}, {17400,0.00003922}, {17500,0.00007843}, {17600,0.00003922}, {17700,0.00003922}, {17800,0.00003922}, {17900,0.00007843}, {18000,0.00003922}, {18100,0.00014706}, {18200,0.00003922}, {18300,0.00011765}, {18400,0.00011765}, {18500,0.00007843}, {18600,0.00006863}, {18700,0.00011765}, {18800,0.00003922}, {18900,0.00003922}, {19000,0.00003922}, {19100,0.00003922}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00007843}, {19600,0.00011765}, {19700,0.00007843}, {19800,0.00000000}, {19900,0.00011765}, {20000,0.00003922}};
data["big_flat"]["Ltac2LowLevel"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00099020}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00100000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000980}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000980}, {408,0.00000980}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000980}, {420,0.00000000}, {421,0.00002941}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000980}, {426,0.00000000}, {427,0.00000000}, {428,0.00003922}, {429,0.00001961}, {430,0.00000980}, {431,0.00003922}, {432,0.00000000}, {433,0.00000000}, {434,0.00002941}, {435,0.00001961}, {436,0.00003922}, {437,0.00002941}, {438,0.00001961}, {439,0.00000000}, {440,0.00002941}, {441,0.00005882}, {442,0.00003922}, {443,0.00008824}, {444,0.00006863}, {445,0.00013725}, {446,0.00005882}, {447,0.00010784}, {448,0.00009804}, {449,0.00013725}, {450,0.00015686}, {451,0.00019608}, {452,0.00019608}, {453,0.00028431}, {454,0.00022549}, {455,0.00034314}, {456,0.00040196}, {457,0.00045098}, {458,0.00051961}, {459,0.00056863}, {460,0.00057843}, {461,0.00061765}, {462,0.00062745}, {463,0.00071569}, {464,0.00073529}, {465,0.00072549}, {466,0.00075490}, {467,0.00074510}, {468,0.00077451}, {469,0.00078431}, {470,0.00078431}, {471,0.00077451}, {472,0.00077451}, {473,0.00078431}, {474,0.00082353}, {475,0.00081373}, {476,0.00079412}, {477,0.00083333}, {478,0.00079412}, {479,0.00083333}, {480,0.00084314}, {481,0.00083333}, {482,0.00088235}, {483,0.00091176}, {484,0.00091176}, {485,0.00094118}, {486,0.00093137}, {487,0.00096078}, {488,0.00095098}, {489,0.00100000}, {490,0.00098039}, {491,0.00099020}, {492,0.00099020}, {493,0.00099020}, {494,0.00121569}, {495,0.00100000}, {496,0.00100000}, {497,0.00100000}, {498,0.00100000}, {499,0.00100000}, {500,0.00099020}, {505,0.00100000}, {510,0.00100000}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00100000}, {535,0.00100000}, {540,0.00200000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00101961}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00100000}, {830,0.00101961}, {835,0.00100000}, {840,0.00325490}, {845,0.00100000}, {850,0.00101961}, {855,0.00100000}, {860,0.00100980}, {865,0.00102941}, {870,0.00102941}, {875,0.00104902}, {880,0.00112745}, {885,0.00112745}, {890,0.00115686}, {895,0.00120588}, {900,0.00128431}, {905,0.00138235}, {910,0.00146078}, {915,0.00157843}, {920,0.00164706}, {925,0.00171569}, {930,0.00175490}, {935,0.00179412}, {940,0.00179412}, {945,0.00184314}, {950,0.00187255}, {955,0.00187255}, {960,0.00192157}, {965,0.00192157}, {970,0.00273529}, {975,0.00196078}, {980,0.00199020}, {985,0.00199020}, {990,0.00200000}, {995,0.00200000}, {1000,0.00200000}, {1010,0.00200000}, {1020,0.00200000}, {1030,0.00200000}, {1040,0.00200000}, {1050,0.00200000}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00201961}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200000}, {1140,0.00200000}, {1150,0.00200000}, {1160,0.00200000}, {1170,0.00200000}, {1180,0.00200980}, {1190,0.00200000}, {1200,0.00200000}, {1210,0.00201961}, {1220,0.00200000}, {1230,0.00200000}, {1240,0.00201961}, {1250,0.00200000}, {1260,0.00200980}, {1270,0.00201961}, {1280,0.00202941}, {1290,0.00210784}, {1300,0.00211765}, {1310,0.00553922}, {1320,0.00219608}, {1330,0.00232353}, {1340,0.00242157}, {1350,0.00255882}, {1360,0.00263725}, {1370,0.00277451}, {1380,0.00281373}, {1390,0.00283333}, {1400,0.00287255}, {1410,0.00288235}, {1420,0.00294118}, {1430,0.00296078}, {1440,0.00296078}, {1450,0.00300000}, {1460,0.00300000}, {1470,0.00300000}, {1480,0.00300000}, {1490,0.00300000}, {1500,0.00300000}, {1510,0.00300000}, {1520,0.00300000}, {1530,0.00300000}, {1540,0.00794118}, {1550,0.00300000}, {1560,0.00300000}, {1570,0.00300000}, {1580,0.00300000}, {1590,0.00300000}, {1600,0.00300000}, {1610,0.00302941}, {1620,0.00300000}, {1630,0.00300000}, {1640,0.00300980}, {1650,0.00300980}, {1660,0.00300000}, {1670,0.00301961}, {1680,0.00300980}, {1690,0.00303922}, {1700,0.00306863}, {1710,0.00305882}, {1720,0.00311765}, {1730,0.00315686}, {1740,0.00612745}, {1750,0.00779412}, {1760,0.00332353}, {1770,0.00348039}, {1780,0.00356863}, {1790,0.00365686}, {1800,0.00375490}, {1810,0.00373529}, {1820,0.00379412}, {1830,0.00383333}, {1840,0.00388235}, {1850,0.00388235}, {1860,0.00391176}, {1870,0.00394118}, {1880,0.00397059}, {1890,0.00398039}, {1900,0.00857843}, {1910,0.00400000}, {1920,0.00400980}, {1930,0.00399020}, {1940,0.00399020}, {1950,0.00400000}, {1960,0.00400000}, {1970,0.00400000}, {1980,0.00400000}, {1990,0.00400000}, {2000,0.00400000}, {2050,0.00400980}, {2100,0.00406863}, {2150,0.00422549}, {2200,0.00450000}, {2250,0.00479412}, {2300,0.00491176}, {2350,0.00885294}, {2400,0.00500000}, {2450,0.00504902}, {2500,0.00508824}, {2550,0.00520588}, {2600,0.00549020}, {2650,0.00571569}, {2700,0.00589216}, {2750,0.00607843}, {2800,0.00600980}, {2850,0.00605882}, {2900,0.00607843}, {2950,0.00621569}, {3000,0.00650000}, {3050,0.00667647}, {3100,0.00684314}, {3150,0.00688235}, {3200,0.00701961}, {3250,0.00709804}, {3300,0.00713725}, {3350,0.01490196}, {3400,0.00747059}, {3450,0.00766667}, {3500,0.00783333}, {3550,0.00793137}, {3600,0.00798039}, {3650,0.00805882}, {3700,0.00827451}, {3750,0.00828431}, {3800,0.00850980}, {3850,0.00864706}, {3900,0.00884314}, {3950,0.00889216}, {4000,0.01536275}, {4050,0.00908824}, {4100,0.00912745}, {4150,0.00931373}, {4200,0.01790196}, {4250,0.00972549}, {4300,0.00982353}, {4350,0.01720588}, {4400,0.00998039}, {4450,0.01011765}, {4500,0.01022549}, {4550,0.01037255}, {4600,0.01047059}, {4650,0.01059804}, {4700,0.01079412}, {4750,0.01096078}, {4800,0.01100000}, {4850,0.02108824}, {4900,0.01119608}, {4950,0.01148039}, {5000,0.01608824}, {5050,0.01178431}, {5100,0.01185294}, {5150,0.01194118}, {5200,0.01202941}, {5250,0.02107843}, {5300,0.01220588}, {5350,0.01233333}, {5400,0.01247059}, {5450,0.01257843}, {5500,0.01260784}, {5550,0.01281373}, {5600,0.01300000}, {5650,0.01301961}, {5700,0.01313725}, {5750,0.02615686}, {5800,0.01354902}, {5850,0.01374510}, {5900,0.01391176}, {5950,0.01396078}, {6000,0.03080392}, {6050,0.01420588}, {6100,0.01441176}, {6150,0.03053922}, {6200,0.01480392}, {6250,0.01488235}, {6300,0.01507843}, {6350,0.01513725}, {6400,0.02777451}, {6450,0.01543137}, {6500,0.02244118}, {6550,0.01569608}, {6600,0.01585294}, {6650,0.01600000}, {6700,0.01606863}, {6750,0.01627451}, {6800,0.01645098}, {6850,0.01657843}, {6900,0.01670588}, {6950,0.02579412}, {7000,0.01686275}, {7050,0.01707843}, {7100,0.01726471}, {7150,0.01732353}, {7200,0.01746078}, {7250,0.01751961}, {7300,0.01768627}, {7350,0.01778431}, {7400,0.01788235}, {7450,0.01800980}, {7500,0.01819608}, {7550,0.01829412}, {7600,0.01841176}, {7650,0.01860784}, {7700,0.03664706}, {7750,0.01883333}, {7800,0.01900000}, {7850,0.01906863}, {7900,0.03834314}, {7950,0.01918627}, {8000,0.01935294}, {8050,0.03764706}, {8100,0.01973529}, {8150,0.01984314}, {8200,0.01991176}, {8250,0.02003922}, {8300,0.02010784}, {8350,0.02032353}, {8400,0.02055882}, {8450,0.04160784}, {8500,0.02082353}, {8550,0.02092157}, {8600,0.04000000}, {8650,0.02118627}, {8700,0.02131373}, {8750,0.02812745}, {8800,0.04222549}, {8850,0.02184314}, {8900,0.02194118}, {8950,0.02200980}, {9000,0.02204902}, {9050,0.02217647}, {9100,0.02238235}, {9150,0.02261765}, {9200,0.02271569}, {9250,0.02275490}, {9300,0.02290196}, {9350,0.02300000}, {9400,0.02300980}, {9450,0.02321569}, {9500,0.02338235}, {9550,0.04925490}, {9600,0.02345098}, {9650,0.02382353}, {9700,0.02400980}, {9750,0.04949020}, {9800,0.02414706}, {9850,0.02431373}, {9900,0.05482353}, {9950,0.02454902}, {10000,0.04406863}, {10100,0.02493137}, {10200,0.04381373}, {10300,0.02549020}, {10400,0.05229412}, {10500,0.02600000}, {10600,0.02634314}, {10700,0.02656863}, {10800,0.02684314}, {10900,0.05250980}, {11000,0.06022549}, {11100,0.04696078}, {11200,0.03961765}, {11300,0.02823529}, {11400,0.02843137}, {11500,0.02871569}, {11600,0.06739216}, {11700,0.02923529}, {11800,0.02952941}, {11900,0.04209804}, {12000,0.03004902}, {12100,0.03012745}, {12200,0.04636275}, {12300,0.03082353}, {12400,0.03077451}, {12500,0.06438235}, {12600,0.05047059}, {12700,0.03204902}, {12800,0.03222549}, {12900,0.03260784}, {13000,0.03283333}, {13100,0.05069608}, {13200,0.06628431}, {13300,0.04546078}, {13400,0.03404902}, {13500,0.05214706}, {13600,0.05117647}, {13700,0.03485294}, {13800,0.06248039}, {13900,0.03540196}, {14000,0.04654902}, {14100,0.06561765}, {14200,0.03630392}, {14300,0.03663725}, {14400,0.05745098}, {14500,0.07509804}, {14600,0.07275490}, {14700,0.06895098}, {14800,0.07321569}, {14900,0.07286275}, {15000,0.05541176}, {15100,0.03871569}, {15200,0.03898039}, {15300,0.07640196}, {15400,0.03962745}, {15500,0.03971569}, {15600,0.06097059}, {15700,0.04017647}, {15800,0.03976471}, {15900,0.07501961}, {16000,0.04112745}, {16100,0.04138235}, {16200,0.07861765}, {16300,0.09337255}, {16400,0.07639216}, {16500,0.08615686}, {16600,0.07494118}, {16700,0.08360784}, {16800,0.08032353}, {16900,0.05936275}, {17000,0.04375490}, {17100,0.05980392}, {17200,0.07835294}, {17300,0.04462745}, {17400,0.08646078}, {17500,0.04511765}, {17600,0.08932353}, {17700,0.04589216}, {17800,0.04433333}, {17900,0.08951961}, {18000,0.06770588}, {18100,0.04681373}, {18200,0.04710784}, {18300,0.04744118}, {18400,0.04758824}, {18500,0.04793137}, {18600,0.04831373}, {18700,0.07221569}, {18800,0.09599020}, {18900,0.07127451}, {19000,0.04939216}, {19100,0.11054902}, {19200,0.04980392}, {19300,0.09565686}, {19400,0.05023529}, {19500,0.08877451}, {19600,0.06847059}, {19700,0.05120588}, {19800,0.08697059}, {19900,0.10832353}, {20000,0.08936275}};
data["big_flat"]["Ltac2LowLevel"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00002941}, {5,0.00011765}, {6,0.00003922}, {7,0.00000000}, {8,0.00003922}, {9,0.00003922}, {10,0.00002941}, {11,0.00000000}, {12,0.00007843}, {13,0.00000000}, {14,0.00009804}, {15,0.00002941}, {16,0.00000000}, {17,0.00000000}, {18,0.00007843}, {19,0.00010784}, {20,0.00011765}, {21,0.00006863}, {22,0.00014706}, {23,0.00003922}, {24,0.00014706}, {25,0.00006863}, {26,0.00014706}, {27,0.00002941}, {28,0.00002941}, {29,0.00022549}, {30,0.00014706}, {31,0.00007843}, {32,0.00009804}, {33,0.00003922}, {34,0.00000000}, {35,0.00017647}, {36,0.00006863}, {37,0.00007843}, {38,0.00006863}, {39,0.00007843}, {40,0.00013725}, {41,0.00007843}, {42,0.00002941}, {43,0.00003922}, {44,0.00011765}, {45,0.00005882}, {46,0.00015686}, {47,0.00006863}, {48,0.00003922}, {49,0.00010784}, {50,0.00014706}, {51,0.00017647}, {52,0.00014706}, {53,0.00009804}, {54,0.00017647}, {55,0.00006863}, {56,0.00016667}, {57,0.00007843}, {58,0.00015686}, {59,0.00021569}, {60,0.00010784}, {61,0.00015686}, {62,0.00017647}, {63,0.00017647}, {64,0.00021569}, {65,0.00014706}, {66,0.00012745}, {67,0.00025490}, {68,0.00021569}, {69,0.00002941}, {70,0.00010784}, {71,0.00002941}, {72,0.00002941}, {73,0.00007843}, {74,0.00013725}, {75,0.00031373}, {76,0.00019608}, {77,0.00023529}, {78,0.00010784}, {79,0.00023529}, {80,0.00017647}, {81,0.00023529}, {82,0.00018627}, {83,0.00017647}, {84,0.00016667}, {85,0.00010784}, {86,0.00013725}, {87,0.00042157}, {88,0.00025490}, {89,0.00022549}, {90,0.00018627}, {91,0.00021569}, {92,0.00027451}, {93,0.00024510}, {94,0.00020588}, {95,0.00021569}, {96,0.00013725}, {97,0.00018627}, {98,0.00037255}, {99,0.00025490}, {100,0.00018627}, {101,0.00027451}, {102,0.00033333}, {103,0.00013725}, {104,0.00029412}, {105,0.00003922}, {106,0.00014706}, {107,0.00015686}, {108,0.00016667}, {109,0.00028431}, {110,0.00027451}, {111,0.00024510}, {112,0.00011765}, {113,0.00016667}, {114,0.00020588}, {115,0.00010784}, {116,0.00020588}, {117,0.00020588}, {118,0.00040196}, {119,0.00024510}, {120,0.00032353}, {121,0.00040196}, {122,0.00039216}, {123,0.00029412}, {124,0.00015686}, {125,0.00013725}, {126,0.00029412}, {127,0.00032353}, {128,0.00024510}, {129,0.00038235}, {130,0.00021569}, {131,0.00030392}, {132,0.00020588}, {133,0.00027451}, {134,0.00033333}, {135,0.00021569}, {136,0.00017647}, {137,0.00048039}, {138,0.00018627}, {139,0.00041176}, {140,0.00029412}, {141,0.00024510}, {142,0.00023529}, {143,0.00015686}, {144,0.00028431}, {145,0.00031373}, {146,0.00038235}, {147,0.00033333}, {148,0.00014706}, {149,0.00031373}, {150,0.00028431}, {151,0.00016667}, {152,0.00038235}, {153,0.00029412}, {154,0.00022549}, {155,0.00026471}, {156,0.00017647}, {157,0.00029412}, {158,0.00041176}, {159,0.00040196}, {160,0.00026471}, {161,0.00022549}, {162,0.00027451}, {163,0.00023529}, {164,0.00048039}, {165,0.00025490}, {166,0.00025490}, {167,0.00048039}, {168,0.00022549}, {169,0.00036275}, {170,0.00052941}, {171,0.00029412}, {172,0.00031373}, {173,0.00042157}, {174,0.00035294}, {175,0.00023529}, {176,0.00030392}, {177,0.00050000}, {178,0.00020588}, {179,0.00048039}, {180,0.00050000}, {181,0.00029412}, {182,0.00044118}, {183,0.00030392}, {184,0.00036275}, {185,0.00025490}, {186,0.00053922}, {187,0.00065686}, {188,0.00036275}, {189,0.00028431}, {190,0.00042157}, {191,0.00059804}, {192,0.00047059}, {193,0.00040196}, {194,0.00038235}, {195,0.00052941}, {196,0.00030392}, {197,0.00052941}, {198,0.00038235}, {199,0.00050980}, {200,0.00045098}, {201,0.00042157}, {202,0.00050000}, {203,0.00035294}, {204,0.00047059}, {205,0.00053922}, {206,0.00026471}, {207,0.00038235}, {208,0.00052941}, {209,0.00056863}, {210,0.00026471}, {211,0.00058824}, {212,0.00039216}, {213,0.00041176}, {214,0.00037255}, {215,0.00038235}, {216,0.00050000}, {217,0.00039216}, {218,0.00032353}, {219,0.00056863}, {220,0.00054902}, {221,0.00023529}, {222,0.00044118}, {223,0.00044118}, {224,0.00036275}, {225,0.00039216}, {226,0.00051961}, {227,0.00048039}, {228,0.00054902}, {229,0.00052941}, {230,0.00046078}, {231,0.00066667}, {232,0.00047059}, {233,0.00041176}, {234,0.00042157}, {235,0.00054902}, {236,0.00043137}, {237,0.00056863}, {238,0.00032353}, {239,0.00059804}, {240,0.00050980}, {241,0.00052941}, {242,0.00036275}, {243,0.00025490}, {244,0.00041176}, {245,0.00050980}, {246,0.00047059}, {247,0.00030392}, {248,0.00032353}, {249,0.00034314}, {250,0.00051961}, {251,0.00046078}, {252,0.00036275}, {253,0.00062745}, {254,0.00059804}, {255,0.00050000}, {256,0.00044118}, {257,0.00058824}, {258,0.00065686}, {259,0.00043137}, {260,0.00056863}, {261,0.00063725}, {262,0.00040196}, {263,0.00064706}, {264,0.00041176}, {265,0.00057843}, {266,0.00057843}, {267,0.00066667}, {268,0.00044118}, {269,0.00054902}, {270,0.00064706}, {271,0.00054902}, {272,0.00050000}, {273,0.00045098}, {274,0.00050980}, {275,0.00063725}, {276,0.00057843}, {277,0.00056863}, {278,0.00055882}, {279,0.00116667}, {280,0.00053922}, {281,0.00061765}, {282,0.00054902}, {283,0.00044118}, {284,0.00074510}, {285,0.00037255}, {286,0.00044118}, {287,0.00083333}, {288,0.00052941}, {289,0.00050000}, {290,0.00048039}, {291,0.00047059}, {292,0.00071569}, {293,0.00059804}, {294,0.00086275}, {295,0.00072549}, {296,0.00074510}, {297,0.00062745}, {298,0.00069608}, {299,0.00046078}, {300,0.00046078}, {301,0.00057843}, {302,0.00066667}, {303,0.00113725}, {304,0.00035294}, {305,0.00068627}, {306,0.00055882}, {307,0.00076471}, {308,0.00053922}, {309,0.00053922}, {310,0.00068627}, {311,0.00056863}, {312,0.00049020}, {313,0.00035294}, {314,0.00055882}, {315,0.00025490}, {316,0.00082353}, {317,0.00062745}, {318,0.00061765}, {319,0.00057843}, {320,0.00064706}, {321,0.00090196}, {322,0.00076471}, {323,0.00061765}, {324,0.00049020}, {325,0.00058824}, {326,0.00071569}, {327,0.00067647}, {328,0.00055882}, {329,0.00058824}, {330,0.00060784}, {331,0.00062745}, {332,0.00056863}, {333,0.00058824}, {334,0.00068627}, {335,0.00051961}, {336,0.00074510}, {337,0.00097059}, {338,0.00060784}, {339,0.00040196}, {340,0.00069608}, {341,0.00052941}, {342,0.00096078}, {343,0.00057843}, {344,0.00084314}, {345,0.00084314}, {346,0.00077451}, {347,0.00060784}, {348,0.00087255}, {349,0.00064706}, {350,0.00064706}, {351,0.00095098}, {352,0.00044118}, {353,0.00071569}, {354,0.00061765}, {355,0.00059804}, {356,0.00082353}, {357,0.00053922}, {358,0.00078431}, {359,0.00061765}, {360,0.00069608}, {361,0.00085294}, {362,0.00058824}, {363,0.00074510}, {364,0.00076471}, {365,0.00064706}, {366,0.00050980}, {367,0.00075490}, {368,0.00040196}, {369,0.00057843}, {370,0.00071569}, {371,0.00062745}, {372,0.00048039}, {373,0.00066667}, {374,0.00070588}, {375,0.00082353}, {376,0.00107843}, {377,0.00065686}, {378,0.00086275}, {379,0.00070588}, {380,0.00072549}, {381,0.00103922}, {382,0.00052941}, {383,0.00052941}, {384,0.00114706}, {385,0.00075490}, {386,0.00087255}, {387,0.00061765}, {388,0.00082353}, {389,0.00068627}, {390,0.00098039}, {391,0.00072549}, {392,0.00079412}, {393,0.00090196}, {394,0.00078431}, {395,0.00061765}, {396,0.00083333}, {397,0.00078431}, {398,0.00082353}, {399,0.00074510}, {400,0.00093137}, {401,0.00080392}, {402,0.00037255}, {403,0.00077451}, {404,0.00074510}, {405,0.00061765}, {406,0.00087255}, {407,0.00072549}, {408,0.00093137}, {409,0.00092157}, {410,0.00091176}, {411,0.00091176}, {412,0.00077451}, {413,0.00086275}, {414,0.00066667}, {415,0.00084314}, {416,0.00084314}, {417,0.00060784}, {418,0.00056863}, {419,0.00068627}, {420,0.00063725}, {421,0.00087255}, {422,0.00082353}, {423,0.00098039}, {424,0.00058824}, {425,0.00079412}, {426,0.00094118}, {427,0.00074510}, {428,0.00060784}, {429,0.00093137}, {430,0.00083333}, {431,0.00094118}, {432,0.00092157}, {433,0.00076471}, {434,0.00060784}, {435,0.00100000}, {436,0.00078431}, {437,0.00090196}, {438,0.00106863}, {439,0.00089216}, {440,0.00085294}, {441,0.00091176}, {442,0.00095098}, {443,0.00082353}, {444,0.00085294}, {445,0.00089216}, {446,0.00065686}, {447,0.00061765}, {448,0.00066667}, {449,0.00094118}, {450,0.00097059}, {451,0.00096078}, {452,0.00101961}, {453,0.00079412}, {454,0.00071569}, {455,0.00088235}, {456,0.00076471}, {457,0.00121569}, {458,0.00084314}, {459,0.00110784}, {460,0.00085294}, {461,0.00111765}, {462,0.00072549}, {463,0.00083333}, {464,0.00096078}, {465,0.00088235}, {466,0.00093137}, {467,0.00102941}, {468,0.00096078}, {469,0.00083333}, {470,0.00097059}, {471,0.00098039}, {472,0.00078431}, {473,0.00112745}, {474,0.00114706}, {475,0.00088235}, {476,0.00099020}, {477,0.00108824}, {478,0.00085294}, {479,0.00068627}, {480,0.00085294}, {481,0.00077451}, {482,0.00054902}, {483,0.00102941}, {484,0.00109804}, {485,0.00089216}, {486,0.00093137}, {487,0.00123529}, {488,0.00106863}, {489,0.00108824}, {490,0.00106863}, {491,0.00100000}, {492,0.00116667}, {493,0.00123529}, {494,0.00183333}, {495,0.00082353}, {496,0.00084314}, {497,0.00093137}, {498,0.00075490}, {499,0.00077451}, {500,0.00085294}, {505,0.00076471}, {510,0.00102941}, {515,0.00064706}, {520,0.00081373}, {525,0.00135294}, {530,0.00115686}, {535,0.00099020}, {540,0.00206863}, {545,0.00082353}, {550,0.00104902}, {555,0.00128431}, {560,0.00119608}, {565,0.00106863}, {570,0.00082353}, {575,0.00114706}, {580,0.00107843}, {585,0.00097059}, {590,0.00112745}, {595,0.00091176}, {600,0.00104902}, {605,0.00119608}, {610,0.00071569}, {615,0.00142157}, {620,0.00069608}, {625,0.00159804}, {630,0.00101961}, {635,0.00122549}, {640,0.00126471}, {645,0.00106863}, {650,0.00112745}, {655,0.00131373}, {660,0.00145098}, {665,0.00150000}, {670,0.00166667}, {675,0.00132353}, {680,0.00148039}, {685,0.00143137}, {690,0.00121569}, {695,0.00123529}, {700,0.00149020}, {705,0.00156863}, {710,0.00162745}, {715,0.00106863}, {720,0.00150980}, {725,0.00144118}, {730,0.00107843}, {735,0.00161765}, {740,0.00150000}, {745,0.00134314}, {750,0.00150980}, {755,0.00148039}, {760,0.00181373}, {765,0.00167647}, {770,0.00157843}, {775,0.00199020}, {780,0.00172549}, {785,0.00177451}, {790,0.00164706}, {795,0.00178431}, {800,0.00175490}, {805,0.00134314}, {810,0.00111765}, {815,0.00227451}, {820,0.00188235}, {825,0.00172549}, {830,0.00200000}, {835,0.00152941}, {840,0.00330392}, {845,0.00175490}, {850,0.00170588}, {855,0.00173529}, {860,0.00191176}, {865,0.00170588}, {870,0.00165686}, {875,0.00152941}, {880,0.00190196}, {885,0.00180392}, {890,0.00174510}, {895,0.00176471}, {900,0.00177451}, {905,0.00171569}, {910,0.00136275}, {915,0.00176471}, {920,0.00174510}, {925,0.00173529}, {930,0.00144118}, {935,0.00207843}, {940,0.00216667}, {945,0.00184314}, {950,0.00200980}, {955,0.00182353}, {960,0.00205882}, {965,0.00200980}, {970,0.00291176}, {975,0.00176471}, {980,0.00189216}, {985,0.00219608}, {990,0.00181373}, {995,0.00214706}, {1000,0.00191176}, {1010,0.00232353}, {1020,0.00201961}, {1030,0.00187255}, {1040,0.00230392}, {1050,0.00179412}, {1060,0.00229412}, {1070,0.00225490}, {1080,0.00245098}, {1090,0.00229412}, {1100,0.00224510}, {1110,0.00223529}, {1120,0.00198039}, {1130,0.00210784}, {1140,0.00206863}, {1150,0.00222549}, {1160,0.00230392}, {1170,0.00249020}, {1180,0.00257843}, {1190,0.00200980}, {1200,0.00217647}, {1210,0.00237255}, {1220,0.00268627}, {1230,0.00230392}, {1240,0.00231373}, {1250,0.00247059}, {1260,0.00238235}, {1270,0.00250000}, {1280,0.00229412}, {1290,0.00266667}, {1300,0.00225490}, {1310,0.00522549}, {1320,0.00239216}, {1330,0.00272549}, {1340,0.00284314}, {1350,0.00256863}, {1360,0.00250980}, {1370,0.00277451}, {1380,0.00284314}, {1390,0.00298039}, {1400,0.00287255}, {1410,0.00284314}, {1420,0.00296078}, {1430,0.00317647}, {1440,0.00289216}, {1450,0.00292157}, {1460,0.00303922}, {1470,0.00316667}, {1480,0.00300000}, {1490,0.00305882}, {1500,0.00304902}, {1510,0.00294118}, {1520,0.00298039}, {1530,0.00306863}, {1540,0.00756863}, {1550,0.00299020}, {1560,0.00313725}, {1570,0.00321569}, {1580,0.00331373}, {1590,0.00319608}, {1600,0.00341176}, {1610,0.00316667}, {1620,0.00328431}, {1630,0.00330392}, {1640,0.00331373}, {1650,0.00309804}, {1660,0.00337255}, {1670,0.00329412}, {1680,0.00323529}, {1690,0.00324510}, {1700,0.00329412}, {1710,0.00313725}, {1720,0.00314706}, {1730,0.00312745}, {1740,0.00631373}, {1750,0.00790196}, {1760,0.00338235}, {1770,0.00327451}, {1780,0.00334314}, {1790,0.00355882}, {1800,0.00343137}, {1810,0.00337255}, {1820,0.00332353}, {1830,0.00343137}, {1840,0.00360784}, {1850,0.00335294}, {1860,0.00339216}, {1870,0.00367647}, {1880,0.00359804}, {1890,0.00362745}, {1900,0.00869608}, {1910,0.00379412}, {1920,0.00373529}, {1930,0.00381373}, {1940,0.00391176}, {1950,0.00372549}, {1960,0.00365686}, {1970,0.00376471}, {1980,0.00371569}, {1990,0.00413725}, {2000,0.00405882}, {2050,0.00400980}, {2100,0.00428431}, {2150,0.00451961}, {2200,0.00423529}, {2250,0.00431373}, {2300,0.00445098}, {2350,0.00875490}, {2400,0.00484314}, {2450,0.00532353}, {2500,0.00535294}, {2550,0.00529412}, {2600,0.00531373}, {2650,0.00552941}, {2700,0.00597059}, {2750,0.00599020}, {2800,0.00614706}, {2850,0.00607843}, {2900,0.00619608}, {2950,0.00648039}, {3000,0.00651961}, {3050,0.00657843}, {3100,0.00656863}, {3150,0.00693137}, {3200,0.00702941}, {3250,0.00716667}, {3300,0.00733333}, {3350,0.01461765}, {3400,0.00770588}, {3450,0.00777451}, {3500,0.00787255}, {3550,0.00784314}, {3600,0.00789216}, {3650,0.00837255}, {3700,0.00863725}, {3750,0.00884314}, {3800,0.00886275}, {3850,0.00877451}, {3900,0.00920588}, {3950,0.00931373}, {4000,0.01507843}, {4050,0.00958824}, {4100,0.00964706}, {4150,0.00989216}, {4200,0.01792157}, {4250,0.00958824}, {4300,0.01000980}, {4350,0.01717647}, {4400,0.01024510}, {4450,0.01050000}, {4500,0.01055882}, {4550,0.01050980}, {4600,0.01072549}, {4650,0.01107843}, {4700,0.01098039}, {4750,0.01115686}, {4800,0.01152941}, {4850,0.02076471}, {4900,0.01161765}, {4950,0.01177451}, {5000,0.01555882}, {5050,0.01208824}, {5100,0.01210784}, {5150,0.01229412}, {5200,0.01235294}, {5250,0.02162745}, {5300,0.01255882}, {5350,0.01271569}, {5400,0.01263725}, {5450,0.01284314}, {5500,0.01277451}, {5550,0.01288235}, {5600,0.01296078}, {5650,0.01328431}, {5700,0.01331373}, {5750,0.02598039}, {5800,0.01374510}, {5850,0.01372549}, {5900,0.01384314}, {5950,0.01397059}, {6000,0.03099020}, {6050,0.01416667}, {6100,0.01455882}, {6150,0.03028431}, {6200,0.01452941}, {6250,0.01493137}, {6300,0.01465686}, {6350,0.01529412}, {6400,0.02737255}, {6450,0.01508824}, {6500,0.02289216}, {6550,0.01544118}, {6600,0.01540196}, {6650,0.01574510}, {6700,0.01599020}, {6750,0.01616667}, {6800,0.01627451}, {6850,0.01667647}, {6900,0.01668627}, {6950,0.02537255}, {7000,0.01657843}, {7050,0.01707843}, {7100,0.01733333}, {7150,0.01704902}, {7200,0.01743137}, {7250,0.01767647}, {7300,0.01742157}, {7350,0.01760784}, {7400,0.01782353}, {7450,0.01803922}, {7500,0.01807843}, {7550,0.01791176}, {7600,0.01863725}, {7650,0.01864706}, {7700,0.03623529}, {7750,0.01862745}, {7800,0.01896078}, {7850,0.01934314}, {7900,0.03793137}, {7950,0.01900000}, {8000,0.01906863}, {8050,0.03762745}, {8100,0.01962745}, {8150,0.01984314}, {8200,0.01956863}, {8250,0.01993137}, {8300,0.01974510}, {8350,0.02024510}, {8400,0.02064706}, {8450,0.04099020}, {8500,0.02068627}, {8550,0.02097059}, {8600,0.03977451}, {8650,0.02080392}, {8700,0.02161765}, {8750,0.02822549}, {8800,0.04182353}, {8850,0.02186275}, {8900,0.02214706}, {8950,0.02210784}, {9000,0.02276471}, {9050,0.02240196}, {9100,0.02260784}, {9150,0.02297059}, {9200,0.02276471}, {9250,0.02279412}, {9300,0.02302941}, {9350,0.02338235}, {9400,0.02345098}, {9450,0.02379412}, {9500,0.02354902}, {9550,0.04942157}, {9600,0.02340196}, {9650,0.02412745}, {9700,0.02447059}, {9750,0.04944118}, {9800,0.02466667}, {9850,0.02440196}, {9900,0.05476471}, {9950,0.02504902}, {10000,0.04415686}, {10100,0.02514706}, {10200,0.04375490}, {10300,0.02572549}, {10400,0.05236275}, {10500,0.02622549}, {10600,0.02652941}, {10700,0.02675490}, {10800,0.02687255}, {10900,0.05249020}, {11000,0.06026471}, {11100,0.04706863}, {11200,0.03957843}, {11300,0.02792157}, {11400,0.02859804}, {11500,0.02877451}, {11600,0.06702941}, {11700,0.02906863}, {11800,0.02955882}, {11900,0.04174510}, {12000,0.02985294}, {12100,0.02967647}, {12200,0.04685294}, {12300,0.03083333}, {12400,0.03035294}, {12500,0.06416667}, {12600,0.05052941}, {12700,0.03171569}, {12800,0.03241176}, {12900,0.03257843}, {13000,0.03221569}, {13100,0.05079412}, {13200,0.06604902}, {13300,0.04530392}, {13400,0.03446078}, {13500,0.05241176}, {13600,0.05124510}, {13700,0.03491176}, {13800,0.06250980}, {13900,0.03554902}, {14000,0.04641176}, {14100,0.06531373}, {14200,0.03668627}, {14300,0.03665686}, {14400,0.05769608}, {14500,0.07515686}, {14600,0.07300000}, {14700,0.06892157}, {14800,0.07282353}, {14900,0.07302941}, {15000,0.05528431}, {15100,0.03900000}, {15200,0.03892157}, {15300,0.07627451}, {15400,0.03955882}, {15500,0.03997059}, {15600,0.06093137}, {15700,0.04010784}, {15800,0.03999020}, {15900,0.07484314}, {16000,0.04115686}, {16100,0.04140196}, {16200,0.07843137}, {16300,0.09302941}, {16400,0.07626471}, {16500,0.08600980}, {16600,0.07513725}, {16700,0.08341176}, {16800,0.08047059}, {16900,0.05930392}, {17000,0.04372549}, {17100,0.05994118}, {17200,0.07828431}, {17300,0.04478431}, {17400,0.08624510}, {17500,0.04531373}, {17600,0.08927451}, {17700,0.04607843}, {17800,0.04439216}, {17900,0.08959804}, {18000,0.06771569}, {18100,0.04735294}, {18200,0.04740196}, {18300,0.04769608}, {18400,0.04773529}, {18500,0.04827451}, {18600,0.04859804}, {18700,0.07224510}, {18800,0.09597059}, {18900,0.07134314}, {19000,0.04957843}, {19100,0.11022549}, {19200,0.04983333}, {19300,0.09552941}, {19400,0.05011765}, {19500,0.08895098}, {19600,0.06849020}, {19700,0.05124510}, {19800,0.08661765}, {19900,0.10822549}, {20000,0.08960784}};
data["big_flat"]["Ltac2LowLevel"]["cbv"]["system"] = {{1,0.00003922}, {2,0.00003922}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00003922}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00003922}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00003922}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00003922}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00003922}, {103,0.00000000}, {104,0.00003922}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00003922}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00003922}, {119,0.00000000}, {120,0.00003922}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00003922}, {133,0.00003922}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00003922}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00003922}, {156,0.00002941}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00003922}, {163,0.00003922}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00002941}, {171,0.00002941}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00003922}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00003922}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00003922}, {230,0.00003922}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00003922}, {235,0.00003922}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00003922}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00003922}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00002941}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00003922}, {280,0.00000000}, {281,0.00007843}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00003922}, {290,0.00000000}, {291,0.00003922}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00003922}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00003922}, {341,0.00000000}, {342,0.00000000}, {343,0.00003922}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00003922}, {359,0.00000000}, {360,0.00000000}, {361,0.00003922}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00003922}, {370,0.00000000}, {371,0.00003922}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00003922}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00003922}, {388,0.00000000}, {389,0.00003922}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00003922}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00003922}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00002941}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00003922}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00003922}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00003922}, {489,0.00007843}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00003922}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00003922}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00002941}, {535,0.00000000}, {540,0.00003922}, {545,0.00000000}, {550,0.00003922}, {555,0.00000000}, {560,0.00000000}, {565,0.00003922}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00006863}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00003922}, {695,0.00003922}, {700,0.00003922}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00003922}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00003922}, {780,0.00000000}, {785,0.00000000}, {790,0.00003922}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00003922}, {835,0.00000000}, {840,0.00010784}, {845,0.00000000}, {850,0.00003922}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00003922}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00003922}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00003922}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00003922}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00003922}, {1110,0.00000000}, {1120,0.00007843}, {1130,0.00000000}, {1140,0.00002941}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00003922}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00007843}, {1280,0.00000000}, {1290,0.00003922}, {1300,0.00000000}, {1310,0.00003922}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00003922}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00003922}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00003922}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00003922}, {1510,0.00003922}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00006863}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00003922}, {1580,0.00003922}, {1590,0.00003922}, {1600,0.00000000}, {1610,0.00003922}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00003922}, {1730,0.00002941}, {1740,0.00003922}, {1750,0.00007843}, {1760,0.00000000}, {1770,0.00003922}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00003922}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00003922}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00003922}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00003922}, {2250,0.00000000}, {2300,0.00003922}, {2350,0.00007843}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00003922}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00003922}, {3150,0.00000000}, {3200,0.00002941}, {3250,0.00000000}, {3300,0.00006863}, {3350,0.00019608}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00002941}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00003922}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00015686}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00003922}, {4200,0.00015686}, {4250,0.00002941}, {4300,0.00003922}, {4350,0.00023529}, {4400,0.00003922}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00006863}, {4600,0.00007843}, {4650,0.00000000}, {4700,0.00003922}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00015686}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00003922}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00003922}, {5250,0.00000000}, {5300,0.00002941}, {5350,0.00003922}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00007843}, {5550,0.00003922}, {5600,0.00000000}, {5650,0.00003922}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00003922}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00003922}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00003922}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00027451}, {6450,0.00000000}, {6500,0.00003922}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00003922}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00014706}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00003922}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00003922}, {7350,0.00000000}, {7400,0.00003922}, {7450,0.00003922}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00003922}, {7650,0.00000000}, {7700,0.00039216}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00039216}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00038235}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00007843}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00061765}, {8500,0.00003922}, {8550,0.00000000}, {8600,0.00035294}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00003922}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00003922}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00003922}, {9250,0.00000000}, {9300,0.00007843}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00003922}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00003922}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00003922}, {10500,0.00000000}, {10600,0.00003922}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00003922}, {11000,0.00003922}, {11100,0.00003922}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00011765}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00003922}, {12400,0.00003922}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00003922}, {13000,0.00003922}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00003922}, {13900,0.00002941}, {14000,0.00003922}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00003922}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00003922}, {15700,0.00003922}, {15800,0.00007843}, {15900,0.00003922}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00003922}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00007843}, {16800,0.00000000}, {16900,0.00003922}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00007843}, {17700,0.00003922}, {17800,0.00000000}, {17900,0.00003922}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00003922}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00003922}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00003922}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["Ltac2LowLevel"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00025490}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000980}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00002941}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00375490}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000980}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000980}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00001961}, {1840,0.00000980}, {1850,0.00001961}, {1860,0.00002941}, {1870,0.00002941}, {1880,0.00005882}, {1890,0.00003922}, {1900,0.00002941}, {1910,0.00004902}, {1920,0.00008824}, {1930,0.00753922}, {1940,0.00005882}, {1950,0.00007843}, {1960,0.00005882}, {1970,0.00011765}, {1980,0.00015686}, {1990,0.00019608}, {2000,0.00017647}, {2050,0.00038235}, {2100,0.00070588}, {2150,0.00088235}, {2200,0.00098039}, {2250,0.00100000}, {2300,0.00100000}, {2350,0.00307843}, {2400,0.00100000}, {2450,0.00100000}, {2500,0.00100000}, {2550,0.00100000}, {2600,0.00100000}, {2650,0.00100000}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00100000}, {3150,0.00100000}, {3200,0.00104902}, {3250,0.00100000}, {3300,0.00100000}, {3350,0.00101961}, {3400,0.00106863}, {3450,0.00103922}, {3500,0.00107843}, {3550,0.00114706}, {3600,0.00115686}, {3650,0.00120588}, {3700,0.00130392}, {3750,0.00139216}, {3800,0.00150980}, {3850,0.00151961}, {3900,0.00168627}, {3950,0.00178431}, {4000,0.00182353}, {4050,0.00446078}, {4100,0.00193137}, {4150,0.00193137}, {4200,0.00196078}, {4250,0.00200000}, {4300,0.00200000}, {4350,0.00200000}, {4400,0.00200000}, {4450,0.00200000}, {4500,0.00200000}, {4550,0.00200000}, {4600,0.00200000}, {4650,0.00200000}, {4700,0.00200000}, {4750,0.00200000}, {4800,0.00200980}, {4850,0.00200000}, {4900,0.00200980}, {4950,0.00202941}, {5000,0.00202941}, {5050,0.00206863}, {5100,0.00213725}, {5150,0.00217647}, {5200,0.00221569}, {5250,0.00221569}, {5300,0.00226471}, {5350,0.00230392}, {5400,0.00230392}, {5450,0.00235294}, {5500,0.00233333}, {5550,0.00240196}, {5600,0.00241176}, {5650,0.00253922}, {5700,0.00268627}, {5750,0.00274510}, {5800,0.00277451}, {5850,0.00284314}, {5900,0.00289216}, {5950,0.00293137}, {6000,0.00292157}, {6050,0.00296078}, {6100,0.00295098}, {6150,0.00298039}, {6200,0.00298039}, {6250,0.00300000}, {6300,0.00300000}, {6350,0.00300000}, {6400,0.00300980}, {6450,0.00300000}, {6500,0.00300980}, {6550,0.00300980}, {6600,0.00300000}, {6650,0.00304902}, {6700,0.00303922}, {6750,0.00309804}, {6800,0.00316667}, {6850,0.00322549}, {6900,0.00330392}, {6950,0.00342157}, {7000,0.00352941}, {7050,0.00361765}, {7100,0.00369608}, {7150,0.00368627}, {7200,0.00376471}, {7250,0.00379412}, {7300,0.00383333}, {7350,0.00379412}, {7400,0.00386275}, {7450,0.00388235}, {7500,0.00394118}, {7550,0.00391176}, {7600,0.01990196}, {7650,0.00397059}, {7700,0.00395098}, {7750,0.00400000}, {7800,0.00399020}, {7850,0.00398039}, {7900,0.00400000}, {7950,0.00398039}, {8000,0.00400000}, {8050,0.00399020}, {8100,0.01748039}, {8150,0.00400000}, {8200,0.00400000}, {8250,0.00400000}, {8300,0.00401961}, {8350,0.00402941}, {8400,0.00403922}, {8450,0.00408824}, {8500,0.00408824}, {8550,0.00400000}, {8600,0.00428431}, {8650,0.00430392}, {8700,0.00430392}, {8750,0.01977451}, {8800,0.00462745}, {8850,0.00473529}, {8900,0.00472549}, {8950,0.00478431}, {9000,0.00480392}, {9050,0.00480392}, {9100,0.00480392}, {9150,0.00485294}, {9200,0.00486275}, {9250,0.00484314}, {9300,0.00493137}, {9350,0.00497059}, {9400,0.00497059}, {9450,0.00498039}, {9500,0.00495098}, {9550,0.00499020}, {9600,0.00497059}, {9650,0.00500000}, {9700,0.02640196}, {9750,0.00499020}, {9800,0.00500000}, {9850,0.01246078}, {9900,0.00500980}, {9950,0.00501961}, {10000,0.00501961}, {10100,0.00503922}, {10200,0.00507843}, {10300,0.01305882}, {10400,0.00532353}, {10500,0.00569608}, {10600,0.00571569}, {10700,0.00591176}, {10800,0.00579412}, {10900,0.00583333}, {11000,0.00589216}, {11100,0.03015686}, {11200,0.00610784}, {11300,0.00599020}, {11400,0.00599020}, {11500,0.00600000}, {11600,0.00615686}, {11700,0.00602941}, {11800,0.00601961}, {11900,0.00607843}, {12000,0.00615686}, {12100,0.00628431}, {12200,0.00644118}, {12300,0.00664706}, {12400,0.00677451}, {12500,0.00680392}, {12600,0.00683333}, {12700,0.00682353}, {12800,0.00682353}, {12900,0.00688235}, {13000,0.00692157}, {13100,0.00698039}, {13200,0.00699020}, {13300,0.01404902}, {13400,0.00702941}, {13500,0.00708824}, {13600,0.00708824}, {13700,0.00718627}, {13800,0.00736275}, {13900,0.00754902}, {14000,0.00761765}, {14100,0.00794118}, {14200,0.00778431}, {14300,0.00780392}, {14400,0.00780392}, {14500,0.00781373}, {14600,0.00788235}, {14700,0.00789216}, {14800,0.00794118}, {14900,0.00797059}, {15000,0.00801961}, {15100,0.02273529}, {15200,0.00808824}, {15300,0.00808824}, {15400,0.00800000}, {15500,0.00835294}, {15600,0.01848039}, {15700,0.00865686}, {15800,0.00875490}, {15900,0.00880392}, {16000,0.00882353}, {16100,0.00884314}, {16200,0.00885294}, {16300,0.00884314}, {16400,0.00898039}, {16500,0.00899020}, {16600,0.00891176}, {16700,0.00896078}, {16800,0.00900000}, {16900,0.00905882}, {17000,0.04350980}, {17100,0.00915686}, {17200,0.00924510}, {17300,0.00963725}, {17400,0.00964706}, {17500,0.00970588}, {17600,0.00974510}, {17700,0.00981373}, {17800,0.00989216}, {17900,0.00985294}, {18000,0.00986275}, {18100,0.00985294}, {18200,0.00987255}, {18300,0.00992157}, {18400,0.00993137}, {18500,0.00999020}, {18600,0.01005882}, {18700,0.03303922}, {18800,0.01015686}, {18900,0.01025490}, {19000,0.04984314}, {19100,0.01051961}, {19200,0.01061765}, {19300,0.01081373}, {19400,0.04331373}, {19500,0.01083333}, {19600,0.01083333}, {19700,0.02487255}, {19800,0.01088235}, {19900,0.01087255}, {20000,0.01087255}};
data["big_flat"]["Ltac2LowLevel"]["eval lazy"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00002941}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00003922}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00003922}, {14,0.00000000}, {15,0.00000000}, {16,0.00002941}, {17,0.00000000}, {18,0.00002941}, {19,0.00003922}, {20,0.00000000}, {21,0.00002941}, {22,0.00006863}, {23,0.00000000}, {24,0.00007843}, {25,0.00003922}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00007843}, {31,0.00003922}, {32,0.00003922}, {33,0.00000000}, {34,0.00011765}, {35,0.00003922}, {36,0.00000000}, {37,0.00003922}, {38,0.00000000}, {39,0.00000000}, {40,0.00003922}, {41,0.00000000}, {42,0.00000000}, {43,0.00008824}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00006863}, {49,0.00003922}, {50,0.00000000}, {51,0.00000000}, {52,0.00003922}, {53,0.00010784}, {54,0.00003922}, {55,0.00009804}, {56,0.00003922}, {57,0.00003922}, {58,0.00009804}, {59,0.00002941}, {60,0.00003922}, {61,0.00003922}, {62,0.00006863}, {63,0.00006863}, {64,0.00003922}, {65,0.00007843}, {66,0.00006863}, {67,0.00000000}, {68,0.00003922}, {69,0.00011765}, {70,0.00010784}, {71,0.00007843}, {72,0.00017647}, {73,0.00007843}, {74,0.00000000}, {75,0.00003922}, {76,0.00014706}, {77,0.00002941}, {78,0.00002941}, {79,0.00006863}, {80,0.00011765}, {81,0.00003922}, {82,0.00010784}, {83,0.00003922}, {84,0.00011765}, {85,0.00003922}, {86,0.00014706}, {87,0.00007843}, {88,0.00011765}, {89,0.00003922}, {90,0.00015686}, {91,0.00003922}, {92,0.00007843}, {93,0.00002941}, {94,0.00006863}, {95,0.00000000}, {96,0.00007843}, {97,0.00000000}, {98,0.00002941}, {99,0.00002941}, {100,0.00003922}, {101,0.00013725}, {102,0.00010784}, {103,0.00002941}, {104,0.00014706}, {105,0.00000000}, {106,0.00000000}, {107,0.00012745}, {108,0.00013725}, {109,0.00019608}, {110,0.00015686}, {111,0.00013725}, {112,0.00011765}, {113,0.00000000}, {114,0.00003922}, {115,0.00000000}, {116,0.00014706}, {117,0.00019608}, {118,0.00006863}, {119,0.00003922}, {120,0.00003922}, {121,0.00006863}, {122,0.00008824}, {123,0.00000000}, {124,0.00011765}, {125,0.00010784}, {126,0.00014706}, {127,0.00007843}, {128,0.00003922}, {129,0.00000000}, {130,0.00010784}, {131,0.00011765}, {132,0.00010784}, {133,0.00010784}, {134,0.00014706}, {135,0.00006863}, {136,0.00020588}, {137,0.00010784}, {138,0.00000000}, {139,0.00006863}, {140,0.00003922}, {141,0.00010784}, {142,0.00019608}, {143,0.00002941}, {144,0.00002941}, {145,0.00011765}, {146,0.00003922}, {147,0.00006863}, {148,0.00003922}, {149,0.00006863}, {150,0.00007843}, {151,0.00021569}, {152,0.00013725}, {153,0.00017647}, {154,0.00006863}, {155,0.00002941}, {156,0.00002941}, {157,0.00002941}, {158,0.00010784}, {159,0.00007843}, {160,0.00007843}, {161,0.00011765}, {162,0.00002941}, {163,0.00005882}, {164,0.00007843}, {165,0.00002941}, {166,0.00022549}, {167,0.00003922}, {168,0.00002941}, {169,0.00019608}, {170,0.00003922}, {171,0.00011765}, {172,0.00006863}, {173,0.00003922}, {174,0.00013725}, {175,0.00000000}, {176,0.00019608}, {177,0.00023529}, {178,0.00018627}, {179,0.00014706}, {180,0.00007843}, {181,0.00000000}, {182,0.00003922}, {183,0.00015686}, {184,0.00009804}, {185,0.00007843}, {186,0.00009804}, {187,0.00016667}, {188,0.00013725}, {189,0.00006863}, {190,0.00007843}, {191,0.00013725}, {192,0.00000000}, {193,0.00000000}, {194,0.00009804}, {195,0.00003922}, {196,0.00015686}, {197,0.00006863}, {198,0.00010784}, {199,0.00010784}, {200,0.00007843}, {201,0.00006863}, {202,0.00009804}, {203,0.00010784}, {204,0.00007843}, {205,0.00014706}, {206,0.00003922}, {207,0.00015686}, {208,0.00014706}, {209,0.00003922}, {210,0.00002941}, {211,0.00010784}, {212,0.00002941}, {213,0.00021569}, {214,0.00014706}, {215,0.00014706}, {216,0.00005882}, {217,0.00007843}, {218,0.00009804}, {219,0.00009804}, {220,0.00010784}, {221,0.00016667}, {222,0.00003922}, {223,0.00076471}, {224,0.00010784}, {225,0.00022549}, {226,0.00010784}, {227,0.00014706}, {228,0.00022549}, {229,0.00006863}, {230,0.00003922}, {231,0.00006863}, {232,0.00003922}, {233,0.00009804}, {234,0.00009804}, {235,0.00009804}, {236,0.00021569}, {237,0.00013725}, {238,0.00006863}, {239,0.00006863}, {240,0.00007843}, {241,0.00016667}, {242,0.00007843}, {243,0.00000000}, {244,0.00029412}, {245,0.00013725}, {246,0.00013725}, {247,0.00015686}, {248,0.00013725}, {249,0.00015686}, {250,0.00009804}, {251,0.00017647}, {252,0.00003922}, {253,0.00013725}, {254,0.00007843}, {255,0.00007843}, {256,0.00010784}, {257,0.00019608}, {258,0.00010784}, {259,0.00022549}, {260,0.00022549}, {261,0.00012745}, {262,0.00003922}, {263,0.00013725}, {264,0.00007843}, {265,0.00014706}, {266,0.00013725}, {267,0.00012745}, {268,0.00007843}, {269,0.00008824}, {270,0.00000000}, {271,0.00010784}, {272,0.00009804}, {273,0.00018627}, {274,0.00003922}, {275,0.00018627}, {276,0.00016667}, {277,0.00011765}, {278,0.00007843}, {279,0.00016667}, {280,0.00013725}, {281,0.00018627}, {282,0.00002941}, {283,0.00013725}, {284,0.00011765}, {285,0.00013725}, {286,0.00019608}, {287,0.00012745}, {288,0.00013725}, {289,0.00015686}, {290,0.00025490}, {291,0.00010784}, {292,0.00015686}, {293,0.00018627}, {294,0.00011765}, {295,0.00010784}, {296,0.00013725}, {297,0.00017647}, {298,0.00017647}, {299,0.00013725}, {300,0.00016667}, {301,0.00009804}, {302,0.00009804}, {303,0.00003922}, {304,0.00019608}, {305,0.00010784}, {306,0.00025490}, {307,0.00016667}, {308,0.00013725}, {309,0.00018627}, {310,0.00011765}, {311,0.00025490}, {312,0.00007843}, {313,0.00010784}, {314,0.00003922}, {315,0.00018627}, {316,0.00016667}, {317,0.00025490}, {318,0.00018627}, {319,0.00007843}, {320,0.00014706}, {321,0.00015686}, {322,0.00007843}, {323,0.00015686}, {324,0.00006863}, {325,0.00014706}, {326,0.00013725}, {327,0.00010784}, {328,0.00006863}, {329,0.00013725}, {330,0.00029412}, {331,0.00002941}, {332,0.00003922}, {333,0.00014706}, {334,0.00024510}, {335,0.00018627}, {336,0.00010784}, {337,0.00017647}, {338,0.00013725}, {339,0.00020588}, {340,0.00015686}, {341,0.00018627}, {342,0.00014706}, {343,0.00024510}, {344,0.00012745}, {345,0.00038235}, {346,0.00015686}, {347,0.00017647}, {348,0.00014706}, {349,0.00018627}, {350,0.00026471}, {351,0.00014706}, {352,0.00021569}, {353,0.00020588}, {354,0.00014706}, {355,0.00037255}, {356,0.00006863}, {357,0.00010784}, {358,0.00015686}, {359,0.00018627}, {360,0.00031373}, {361,0.00018627}, {362,0.00011765}, {363,0.00028431}, {364,0.00020588}, {365,0.00010784}, {366,0.00015686}, {367,0.00011765}, {368,0.00033333}, {369,0.00013725}, {370,0.00018627}, {371,0.00018627}, {372,0.00007843}, {373,0.00017647}, {374,0.00011765}, {375,0.00019608}, {376,0.00028431}, {377,0.00007843}, {378,0.00011765}, {379,0.00015686}, {380,0.00028431}, {381,0.00032353}, {382,0.00018627}, {383,0.00016667}, {384,0.00006863}, {385,0.00018627}, {386,0.00026471}, {387,0.00026471}, {388,0.00010784}, {389,0.00007843}, {390,0.00016667}, {391,0.00021569}, {392,0.00030392}, {393,0.00015686}, {394,0.00023529}, {395,0.00022549}, {396,0.00002941}, {397,0.00018627}, {398,0.00028431}, {399,0.00014706}, {400,0.00014706}, {401,0.00022549}, {402,0.00017647}, {403,0.00010784}, {404,0.00018627}, {405,0.00013725}, {406,0.00026471}, {407,0.00009804}, {408,0.00024510}, {409,0.00032353}, {410,0.00031373}, {411,0.00003922}, {412,0.00010784}, {413,0.00015686}, {414,0.00006863}, {415,0.00021569}, {416,0.00007843}, {417,0.00018627}, {418,0.00013725}, {419,0.00007843}, {420,0.00014706}, {421,0.00024510}, {422,0.00014706}, {423,0.00022549}, {424,0.00020588}, {425,0.00005882}, {426,0.00021569}, {427,0.00016667}, {428,0.00018627}, {429,0.00016667}, {430,0.00020588}, {431,0.00029412}, {432,0.00025490}, {433,0.00027451}, {434,0.00010784}, {435,0.00010784}, {436,0.00018627}, {437,0.00011765}, {438,0.00013725}, {439,0.00017647}, {440,0.00011765}, {441,0.00026471}, {442,0.00020588}, {443,0.00003922}, {444,0.00014706}, {445,0.00031373}, {446,0.00024510}, {447,0.00025490}, {448,0.00010784}, {449,0.00011765}, {450,0.00017647}, {451,0.00017647}, {452,0.00017647}, {453,0.00028431}, {454,0.00024510}, {455,0.00019608}, {456,0.00017647}, {457,0.00010784}, {458,0.00017647}, {459,0.00038235}, {460,0.00010784}, {461,0.00015686}, {462,0.00029412}, {463,0.00029412}, {464,0.00018627}, {465,0.00024510}, {466,0.00022549}, {467,0.00032353}, {468,0.00019608}, {469,0.00022549}, {470,0.00017647}, {471,0.00034314}, {472,0.00008824}, {473,0.00027451}, {474,0.00015686}, {475,0.00018627}, {476,0.00026471}, {477,0.00024510}, {478,0.00014706}, {479,0.00025490}, {480,0.00036275}, {481,0.00030392}, {482,0.00032353}, {483,0.00005882}, {484,0.00022549}, {485,0.00016667}, {486,0.00022549}, {487,0.00020588}, {488,0.00026471}, {489,0.00009804}, {490,0.00026471}, {491,0.00013725}, {492,0.00030392}, {493,0.00018627}, {494,0.00015686}, {495,0.00033333}, {496,0.00021569}, {497,0.00014706}, {498,0.00031373}, {499,0.00042157}, {500,0.00026471}, {505,0.00022549}, {510,0.00032353}, {515,0.00024510}, {520,0.00028431}, {525,0.00036275}, {530,0.00027451}, {535,0.00021569}, {540,0.00018627}, {545,0.00015686}, {550,0.00017647}, {555,0.00020588}, {560,0.00014706}, {565,0.00029412}, {570,0.00017647}, {575,0.00011765}, {580,0.00014706}, {585,0.00030392}, {590,0.00009804}, {595,0.00035294}, {600,0.00019608}, {605,0.00035294}, {610,0.00033333}, {615,0.00038235}, {620,0.00027451}, {625,0.00027451}, {630,0.00033333}, {635,0.00028431}, {640,0.00027451}, {645,0.00017647}, {650,0.00035294}, {655,0.00041176}, {660,0.00035294}, {665,0.00026471}, {670,0.00026471}, {675,0.00040196}, {680,0.00044118}, {685,0.00040196}, {690,0.00040196}, {695,0.00032353}, {700,0.00019608}, {705,0.00031373}, {710,0.00024510}, {715,0.00033333}, {720,0.00032353}, {725,0.00024510}, {730,0.00033333}, {735,0.00024510}, {740,0.00014706}, {745,0.00030392}, {750,0.00043137}, {755,0.00038235}, {760,0.00034314}, {765,0.00028431}, {770,0.00035294}, {775,0.00043137}, {780,0.00036275}, {785,0.00038235}, {790,0.00052941}, {795,0.00037255}, {800,0.00022549}, {805,0.00033333}, {810,0.00060784}, {815,0.00031373}, {820,0.00019608}, {825,0.00020588}, {830,0.00019608}, {835,0.00047059}, {840,0.00040196}, {845,0.00042157}, {850,0.00041176}, {855,0.00020588}, {860,0.00048039}, {865,0.00050980}, {870,0.00040196}, {875,0.00035294}, {880,0.00035294}, {885,0.00031373}, {890,0.00037255}, {895,0.00027451}, {900,0.00024510}, {905,0.00038235}, {910,0.00050000}, {915,0.00047059}, {920,0.00048039}, {925,0.00034314}, {930,0.00037255}, {935,0.00048039}, {940,0.00039216}, {945,0.00033333}, {950,0.00056863}, {955,0.00024510}, {960,0.00060784}, {965,0.00045098}, {970,0.00047059}, {975,0.00051961}, {980,0.00045098}, {985,0.00023529}, {990,0.00037255}, {995,0.00046078}, {1000,0.00035294}, {1010,0.00047059}, {1020,0.00044118}, {1030,0.00057843}, {1040,0.00023529}, {1050,0.00069608}, {1060,0.00032353}, {1070,0.00062745}, {1080,0.00042157}, {1090,0.00044118}, {1100,0.00066667}, {1110,0.00044118}, {1120,0.00044118}, {1130,0.00057843}, {1140,0.00055882}, {1150,0.00061765}, {1160,0.00029412}, {1170,0.00057843}, {1180,0.00053922}, {1190,0.00048039}, {1200,0.00058824}, {1210,0.00049020}, {1220,0.00060784}, {1230,0.00040196}, {1240,0.00067647}, {1250,0.00042157}, {1260,0.00055882}, {1270,0.00056863}, {1280,0.00045098}, {1290,0.00049020}, {1300,0.00045098}, {1310,0.00052941}, {1320,0.00061765}, {1330,0.00065686}, {1340,0.00041176}, {1350,0.00054902}, {1360,0.00057843}, {1370,0.00042157}, {1380,0.00044118}, {1390,0.00072549}, {1400,0.00035294}, {1410,0.00058824}, {1420,0.00060784}, {1430,0.00074510}, {1440,0.00040196}, {1450,0.00051961}, {1460,0.00049020}, {1470,0.00086275}, {1480,0.00062745}, {1490,0.00069608}, {1500,0.00063725}, {1510,0.00068627}, {1520,0.00080392}, {1530,0.00051961}, {1540,0.00050000}, {1550,0.00074510}, {1560,0.00076471}, {1570,0.00077451}, {1580,0.00065686}, {1590,0.00377451}, {1600,0.00076471}, {1610,0.00049020}, {1620,0.00053922}, {1630,0.00083333}, {1640,0.00087255}, {1650,0.00070588}, {1660,0.00055882}, {1670,0.00062745}, {1680,0.00077451}, {1690,0.00053922}, {1700,0.00055882}, {1710,0.00063725}, {1720,0.00075490}, {1730,0.00076471}, {1740,0.00064706}, {1750,0.00098039}, {1760,0.00089216}, {1770,0.00066667}, {1780,0.00081373}, {1790,0.00051961}, {1800,0.00092157}, {1810,0.00071569}, {1820,0.00057843}, {1830,0.00082353}, {1840,0.00077451}, {1850,0.00051961}, {1860,0.00070588}, {1870,0.00088235}, {1880,0.00057843}, {1890,0.00063725}, {1900,0.00082353}, {1910,0.00090196}, {1920,0.00063725}, {1930,0.00749020}, {1940,0.00095098}, {1950,0.00079412}, {1960,0.00091176}, {1970,0.00066667}, {1980,0.00078431}, {1990,0.00091176}, {2000,0.00033333}, {2050,0.00077451}, {2100,0.00074510}, {2150,0.00100980}, {2200,0.00084314}, {2250,0.00083333}, {2300,0.00082353}, {2350,0.00287255}, {2400,0.00118627}, {2450,0.00088235}, {2500,0.00084314}, {2550,0.00132353}, {2600,0.00092157}, {2650,0.00110784}, {2700,0.00121569}, {2750,0.00132353}, {2800,0.00128431}, {2850,0.00127451}, {2900,0.00113725}, {2950,0.00139216}, {3000,0.00125490}, {3050,0.00146078}, {3100,0.00125490}, {3150,0.00142157}, {3200,0.00136275}, {3250,0.00138235}, {3300,0.00147059}, {3350,0.00164706}, {3400,0.00150980}, {3450,0.00146078}, {3500,0.00160784}, {3550,0.00168627}, {3600,0.00140196}, {3650,0.00148039}, {3700,0.00176471}, {3750,0.00176471}, {3800,0.00163725}, {3850,0.00170588}, {3900,0.00185294}, {3950,0.00174510}, {4000,0.00128431}, {4050,0.00457843}, {4100,0.00153922}, {4150,0.00195098}, {4200,0.00177451}, {4250,0.00192157}, {4300,0.00178431}, {4350,0.00208824}, {4400,0.00198039}, {4450,0.00194118}, {4500,0.00171569}, {4550,0.00214706}, {4600,0.00222549}, {4650,0.00226471}, {4700,0.00179412}, {4750,0.00211765}, {4800,0.00194118}, {4850,0.00212745}, {4900,0.00236275}, {4950,0.00220588}, {5000,0.00211765}, {5050,0.00226471}, {5100,0.00247059}, {5150,0.00240196}, {5200,0.00204902}, {5250,0.00236275}, {5300,0.00230392}, {5350,0.00283333}, {5400,0.00246078}, {5450,0.00251961}, {5500,0.00234314}, {5550,0.00240196}, {5600,0.00239216}, {5650,0.00265686}, {5700,0.00259804}, {5750,0.00263725}, {5800,0.00281373}, {5850,0.00268627}, {5900,0.00271569}, {5950,0.00290196}, {6000,0.00291176}, {6050,0.00302941}, {6100,0.00270588}, {6150,0.00294118}, {6200,0.00271569}, {6250,0.00290196}, {6300,0.00298039}, {6350,0.00281373}, {6400,0.00301961}, {6450,0.00285294}, {6500,0.00299020}, {6550,0.00293137}, {6600,0.00284314}, {6650,0.00329412}, {6700,0.00311765}, {6750,0.00311765}, {6800,0.00314706}, {6850,0.00326471}, {6900,0.00327451}, {6950,0.00317647}, {7000,0.00342157}, {7050,0.00327451}, {7100,0.00329412}, {7150,0.00325490}, {7200,0.00344118}, {7250,0.00351961}, {7300,0.00353922}, {7350,0.00334314}, {7400,0.00338235}, {7450,0.00350000}, {7500,0.00359804}, {7550,0.00353922}, {7600,0.01973529}, {7650,0.00370588}, {7700,0.00351961}, {7750,0.00379412}, {7800,0.00371569}, {7850,0.00386275}, {7900,0.00380392}, {7950,0.00412745}, {8000,0.00395098}, {8050,0.00409804}, {8100,0.01683333}, {8150,0.00436275}, {8200,0.00407843}, {8250,0.00448039}, {8300,0.00431373}, {8350,0.00432353}, {8400,0.00437255}, {8450,0.00436275}, {8500,0.00443137}, {8550,0.00399020}, {8600,0.00420588}, {8650,0.00439216}, {8700,0.00421569}, {8750,0.01975490}, {8800,0.00484314}, {8850,0.00451961}, {8900,0.00477451}, {8950,0.00455882}, {9000,0.00434314}, {9050,0.00443137}, {9100,0.00468627}, {9150,0.00480392}, {9200,0.00512745}, {9250,0.00446078}, {9300,0.00485294}, {9350,0.00503922}, {9400,0.00518627}, {9450,0.00474510}, {9500,0.00473529}, {9550,0.00493137}, {9600,0.00477451}, {9650,0.00499020}, {9700,0.02678431}, {9750,0.00478431}, {9800,0.00488235}, {9850,0.01303922}, {9900,0.00511765}, {9950,0.00512745}, {10000,0.00524510}, {10100,0.00496078}, {10200,0.00528431}, {10300,0.01342157}, {10400,0.00516667}, {10500,0.00548039}, {10600,0.00559804}, {10700,0.00580392}, {10800,0.00558824}, {10900,0.00543137}, {11000,0.00584314}, {11100,0.03020588}, {11200,0.00588235}, {11300,0.00572549}, {11400,0.00545098}, {11500,0.00595098}, {11600,0.00602941}, {11700,0.00632353}, {11800,0.00621569}, {11900,0.00636275}, {12000,0.00645098}, {12100,0.00625490}, {12200,0.00636275}, {12300,0.00648039}, {12400,0.00632353}, {12500,0.00631373}, {12600,0.00669608}, {12700,0.00656863}, {12800,0.00654902}, {12900,0.00681373}, {13000,0.00704902}, {13100,0.00684314}, {13200,0.00664706}, {13300,0.01420588}, {13400,0.00693137}, {13500,0.00703922}, {13600,0.00695098}, {13700,0.00709804}, {13800,0.00724510}, {13900,0.00717647}, {14000,0.00736275}, {14100,0.00776471}, {14200,0.00742157}, {14300,0.00735294}, {14400,0.00755882}, {14500,0.00765686}, {14600,0.00793137}, {14700,0.00791176}, {14800,0.00791176}, {14900,0.00764706}, {15000,0.00775490}, {15100,0.02276471}, {15200,0.00802941}, {15300,0.00825490}, {15400,0.00753922}, {15500,0.00830392}, {15600,0.01827451}, {15700,0.00836275}, {15800,0.00822549}, {15900,0.00839216}, {16000,0.00853922}, {16100,0.00871569}, {16200,0.00887255}, {16300,0.00874510}, {16400,0.00895098}, {16500,0.00936275}, {16600,0.00915686}, {16700,0.00909804}, {16800,0.00934314}, {16900,0.00970588}, {17000,0.04359804}, {17100,0.00963725}, {17200,0.00985294}, {17300,0.00960784}, {17400,0.00963725}, {17500,0.00957843}, {17600,0.00990196}, {17700,0.00962745}, {17800,0.00971569}, {17900,0.01022549}, {18000,0.00967647}, {18100,0.00993137}, {18200,0.01048039}, {18300,0.01021569}, {18400,0.01018627}, {18500,0.01065686}, {18600,0.01050000}, {18700,0.03354902}, {18800,0.01043137}, {18900,0.01103922}, {19000,0.04951961}, {19100,0.01082353}, {19200,0.01097059}, {19300,0.01102941}, {19400,0.04323529}, {19500,0.01094118}, {19600,0.01134314}, {19700,0.02514706}, {19800,0.01123529}, {19900,0.01106863}, {20000,0.01119608}};
data["big_flat"]["Ltac2LowLevel"]["eval lazy"]["system"] = {{1,0.00003922}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00003922}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00003922}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00002941}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00003922}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00003922}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00003922}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00002941}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00003922}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00003922}, {436,0.00000000}, {437,0.00003922}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00003922}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00003922}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00003922}, {499,0.00000000}, {500,0.00000000}, {505,0.00003922}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00003922}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00003922}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00003922}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00003922}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00003922}, {820,0.00003922}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00003922}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00003922}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00006863}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00003922}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00002941}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00003922}, {1210,0.00003922}, {1220,0.00002941}, {1230,0.00000000}, {1240,0.00003922}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00003922}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00007843}, {1570,0.00003922}, {1580,0.00003922}, {1590,0.00007843}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00003922}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003922}, {1670,0.00011765}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00003922}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00007843}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00003922}, {1830,0.00000000}, {1840,0.00003922}, {1850,0.00003922}, {1860,0.00000000}, {1870,0.00003922}, {1880,0.00000000}, {1890,0.00003922}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00003922}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00007843}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00003922}, {2250,0.00003922}, {2300,0.00003922}, {2350,0.00000000}, {2400,0.00003922}, {2450,0.00003922}, {2500,0.00000000}, {2550,0.00003922}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00003922}, {2800,0.00003922}, {2850,0.00003922}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00003922}, {3050,0.00000000}, {3100,0.00007843}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00003922}, {3450,0.00003922}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00007843}, {3700,0.00003922}, {3750,0.00000000}, {3800,0.00003922}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00002941}, {4050,0.00003922}, {4100,0.00000000}, {4150,0.00003922}, {4200,0.00000000}, {4250,0.00003922}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00003922}, {4450,0.00000000}, {4500,0.00007843}, {4550,0.00007843}, {4600,0.00000000}, {4650,0.00003922}, {4700,0.00000000}, {4750,0.00003922}, {4800,0.00003922}, {4850,0.00000000}, {4900,0.00007843}, {4950,0.00000000}, {5000,0.00003922}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00003922}, {5400,0.00003922}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00003922}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00007843}, {5850,0.00007843}, {5900,0.00000000}, {5950,0.00003922}, {6000,0.00003922}, {6050,0.00003922}, {6100,0.00003922}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00007843}, {6400,0.00000000}, {6450,0.00003922}, {6500,0.00000000}, {6550,0.00003922}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00003922}, {6800,0.00007843}, {6850,0.00000000}, {6900,0.00003922}, {6950,0.00000000}, {7000,0.00003922}, {7050,0.00000000}, {7100,0.00003922}, {7150,0.00000000}, {7200,0.00003922}, {7250,0.00000000}, {7300,0.00003922}, {7350,0.00003922}, {7400,0.00003922}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00031373}, {7650,0.00000000}, {7700,0.00003922}, {7750,0.00003922}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00006863}, {7950,0.00003922}, {8000,0.00003922}, {8050,0.00011765}, {8100,0.00015686}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00007843}, {8300,0.00003922}, {8350,0.00003922}, {8400,0.00003922}, {8450,0.00000000}, {8500,0.00007843}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00003922}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00003922}, {8950,0.00011765}, {9000,0.00007843}, {9050,0.00003922}, {9100,0.00003922}, {9150,0.00000000}, {9200,0.00003922}, {9250,0.00000000}, {9300,0.00003922}, {9350,0.00003922}, {9400,0.00000000}, {9450,0.00003922}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00003922}, {9800,0.00003922}, {9850,0.00006863}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00007843}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00007843}, {11100,0.00003922}, {11200,0.00003922}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00003922}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00007843}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00006863}, {13600,0.00003922}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00002941}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00007843}, {15800,0.00007843}, {15900,0.00000000}, {16000,0.00003922}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00003922}, {16700,0.00003922}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00003922}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00003922}, {18300,0.00003922}, {18400,0.00003922}, {18500,0.00003922}, {18600,0.00003922}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00006863}, {19100,0.00003922}, {19200,0.00000000}, {19300,0.00003922}, {19400,0.00003922}, {19500,0.00003922}, {19600,0.00003922}, {19700,0.00003922}, {19800,0.00002941}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["Ltac2LowLevel"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00001961}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00377451}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00577451}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00012745}, {1910,0.00009804}, {1920,0.00014706}, {1930,0.00000000}, {1940,0.00005882}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000980}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000980}, {2400,0.00001961}, {2450,0.00000980}, {2500,0.00005882}, {2550,0.00014706}, {2600,0.00020588}, {2650,0.00043137}, {2700,0.00069608}, {2750,0.00083333}, {2800,0.00086275}, {2850,0.00088235}, {2900,0.00096078}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00100000}, {3150,0.00100000}, {3200,0.00100000}, {3250,0.00100000}, {3300,0.00100000}, {3350,0.00100000}, {3400,0.00100000}, {3450,0.00100000}, {3500,0.00100000}, {3550,0.00100000}, {3600,0.00103922}, {3650,0.00104902}, {3700,0.00100000}, {3750,0.00100000}, {3800,0.00100000}, {3850,0.00100000}, {3900,0.00100000}, {3950,0.00100000}, {4000,0.00100000}, {4050,0.00100000}, {4100,0.00100000}, {4150,0.00100000}, {4200,0.00100000}, {4250,0.00100000}, {4300,0.00100000}, {4350,0.00100000}, {4400,0.00100000}, {4450,0.00100000}, {4500,0.00100000}, {4550,0.00100000}, {4600,0.00100000}, {4650,0.00100000}, {4700,0.00100000}, {4750,0.00100000}, {4800,0.00100000}, {4850,0.00101961}, {4900,0.00103922}, {4950,0.00103922}, {5000,0.00106863}, {5050,0.00115686}, {5100,0.00124510}, {5150,0.00128431}, {5200,0.00136275}, {5250,0.00137255}, {5300,0.00147059}, {5350,0.00159804}, {5400,0.00163725}, {5450,0.00175490}, {5500,0.00179412}, {5550,0.00189216}, {5600,0.00187255}, {5650,0.00189216}, {5700,0.00192157}, {5750,0.00194118}, {5800,0.00195098}, {5850,0.00196078}, {5900,0.00200000}, {5950,0.00200000}, {6000,0.00200000}, {6050,0.01383333}, {6100,0.00200000}, {6150,0.00200000}, {6200,0.00205882}, {6250,0.00200000}, {6300,0.00200000}, {6350,0.00200000}, {6400,0.00200000}, {6450,0.00200000}, {6500,0.00200000}, {6550,0.00200000}, {6600,0.00200000}, {6650,0.00200000}, {6700,0.00200000}, {6750,0.00200000}, {6800,0.00200000}, {6850,0.00200000}, {6900,0.00200000}, {6950,0.00200000}, {7000,0.01298039}, {7050,0.00200000}, {7100,0.00200000}, {7150,0.00200980}, {7200,0.00200000}, {7250,0.00200980}, {7300,0.00200980}, {7350,0.00203922}, {7400,0.00206863}, {7450,0.00209804}, {7500,0.00206863}, {7550,0.00214706}, {7600,0.00221569}, {7650,0.00228431}, {7700,0.00234314}, {7750,0.00252941}, {7800,0.00258824}, {7850,0.00263725}, {7900,0.00260784}, {7950,0.00266667}, {8000,0.00275490}, {8050,0.00280392}, {8100,0.00283333}, {8150,0.00283333}, {8200,0.00284314}, {8250,0.00284314}, {8300,0.01322549}, {8350,0.00287255}, {8400,0.00289216}, {8450,0.00293137}, {8500,0.00289216}, {8550,0.00303922}, {8600,0.00296078}, {8650,0.00300000}, {8700,0.00298039}, {8750,0.00299020}, {8800,0.00300000}, {8850,0.00300000}, {8900,0.00300000}, {8950,0.00300000}, {9000,0.00300000}, {9050,0.00300000}, {9100,0.00300000}, {9150,0.00300000}, {9200,0.00300000}, {9250,0.00300000}, {9300,0.00300000}, {9350,0.00300000}, {9400,0.00300000}, {9450,0.00300000}, {9500,0.01847059}, {9550,0.00300980}, {9600,0.00300980}, {9650,0.00300000}, {9700,0.00300980}, {9750,0.00300000}, {9800,0.00301961}, {9850,0.00311765}, {9900,0.00305882}, {9950,0.00306863}, {10000,0.00316667}, {10100,0.00321569}, {10200,0.00338235}, {10300,0.00367647}, {10400,0.00358824}, {10500,0.00369608}, {10600,0.00374510}, {10700,0.00380392}, {10800,0.01720588}, {10900,0.00383333}, {11000,0.00384314}, {11100,0.00384314}, {11200,0.00392157}, {11300,0.00398039}, {11400,0.00396078}, {11500,0.00399020}, {11600,0.00400000}, {11700,0.00400000}, {11800,0.00400000}, {11900,0.00400000}, {12000,0.02041176}, {12100,0.00400980}, {12200,0.00401961}, {12300,0.02676471}, {12400,0.00406863}, {12500,0.00412745}, {12600,0.00417647}, {12700,0.00457843}, {12800,0.00439216}, {12900,0.00453922}, {13000,0.00472549}, {13100,0.00477451}, {13200,0.00477451}, {13300,0.00479412}, {13400,0.00478431}, {13500,0.00481373}, {13600,0.00484314}, {13700,0.00480392}, {13800,0.00488235}, {13900,0.00488235}, {14000,0.00496078}, {14100,0.00497059}, {14200,0.00499020}, {14300,0.00499020}, {14400,0.00500000}, {14500,0.00500000}, {14600,0.00501961}, {14700,0.00502941}, {14800,0.00511765}, {14900,0.00511765}, {15000,0.00518627}, {15100,0.00526471}, {15200,0.00537255}, {15300,0.00549020}, {15400,0.00563725}, {15500,0.00568627}, {15600,0.00578431}, {15700,0.00576471}, {15800,0.00580392}, {15900,0.02941176}, {16000,0.00582353}, {16100,0.00584314}, {16200,0.00583333}, {16300,0.00586275}, {16400,0.00584314}, {16500,0.00583333}, {16600,0.00588235}, {16700,0.00592157}, {16800,0.00594118}, {16900,0.00592157}, {17000,0.00623529}, {17100,0.00599020}, {17200,0.00602941}, {17300,0.00607843}, {17400,0.00606863}, {17500,0.00611765}, {17600,0.00620588}, {17700,0.00631373}, {17800,0.00645098}, {17900,0.02479412}, {18000,0.00662745}, {18100,0.00674510}, {18200,0.00676471}, {18300,0.00677451}, {18400,0.00681373}, {18500,0.00683333}, {18600,0.00682353}, {18700,0.00700000}, {18800,0.00684314}, {18900,0.00685294}, {19000,0.00716667}, {19100,0.00690196}, {19200,0.00685294}, {19300,0.00687255}, {19400,0.00720588}, {19500,0.00696078}, {19600,0.00696078}, {19700,0.00698039}, {19800,0.04601961}, {19900,0.00708824}, {20000,0.00712745}};
data["big_flat"]["Ltac2LowLevel"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00006863}, {3,0.00000000}, {4,0.00007843}, {5,0.00000000}, {6,0.00003922}, {7,0.00000000}, {8,0.00000000}, {9,0.00003922}, {10,0.00003922}, {11,0.00000000}, {12,0.00006863}, {13,0.00003922}, {14,0.00000000}, {15,0.00005882}, {16,0.00006863}, {17,0.00003922}, {18,0.00000000}, {19,0.00002941}, {20,0.00000000}, {21,0.00000000}, {22,0.00007843}, {23,0.00003922}, {24,0.00003922}, {25,0.00000000}, {26,0.00000000}, {27,0.00002941}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00003922}, {32,0.00000000}, {33,0.00006863}, {34,0.00000000}, {35,0.00000000}, {36,0.00002941}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003922}, {42,0.00000000}, {43,0.00003922}, {44,0.00000000}, {45,0.00000000}, {46,0.00007843}, {47,0.00003922}, {48,0.00009804}, {49,0.00002941}, {50,0.00000000}, {51,0.00005882}, {52,0.00006863}, {53,0.00006863}, {54,0.00002941}, {55,0.00000000}, {56,0.00009804}, {57,0.00003922}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00003922}, {62,0.00003922}, {63,0.00003922}, {64,0.00002941}, {65,0.00002941}, {66,0.00000000}, {67,0.00002941}, {68,0.00013725}, {69,0.00000000}, {70,0.00003922}, {71,0.00003922}, {72,0.00003922}, {73,0.00006863}, {74,0.00007843}, {75,0.00010784}, {76,0.00003922}, {77,0.00000000}, {78,0.00002941}, {79,0.00000000}, {80,0.00007843}, {81,0.00000000}, {82,0.00002941}, {83,0.00005882}, {84,0.00003922}, {85,0.00006863}, {86,0.00000000}, {87,0.00003922}, {88,0.00003922}, {89,0.00000000}, {90,0.00003922}, {91,0.00000000}, {92,0.00003922}, {93,0.00015686}, {94,0.00006863}, {95,0.00002941}, {96,0.00002941}, {97,0.00010784}, {98,0.00002941}, {99,0.00003922}, {100,0.00000000}, {101,0.00000000}, {102,0.00002941}, {103,0.00006863}, {104,0.00010784}, {105,0.00003922}, {106,0.00017647}, {107,0.00012745}, {108,0.00013725}, {109,0.00014706}, {110,0.00003922}, {111,0.00007843}, {112,0.00007843}, {113,0.00011765}, {114,0.00013725}, {115,0.00003922}, {116,0.00011765}, {117,0.00007843}, {118,0.00003922}, {119,0.00000000}, {120,0.00007843}, {121,0.00007843}, {122,0.00006863}, {123,0.00007843}, {124,0.00000000}, {125,0.00003922}, {126,0.00010784}, {127,0.00000000}, {128,0.00019608}, {129,0.00003922}, {130,0.00003922}, {131,0.00003922}, {132,0.00000000}, {133,0.00016667}, {134,0.00007843}, {135,0.00005882}, {136,0.00007843}, {137,0.00002941}, {138,0.00000000}, {139,0.00006863}, {140,0.00002941}, {141,0.00002941}, {142,0.00010784}, {143,0.00011765}, {144,0.00014706}, {145,0.00003922}, {146,0.00002941}, {147,0.00000000}, {148,0.00006863}, {149,0.00002941}, {150,0.00005882}, {151,0.00013725}, {152,0.00000000}, {153,0.00013725}, {154,0.00002941}, {155,0.00002941}, {156,0.00009804}, {157,0.00007843}, {158,0.00011765}, {159,0.00003922}, {160,0.00003922}, {161,0.00007843}, {162,0.00009804}, {163,0.00002941}, {164,0.00007843}, {165,0.00005882}, {166,0.00007843}, {167,0.00007843}, {168,0.00016667}, {169,0.00018627}, {170,0.00003922}, {171,0.00006863}, {172,0.00002941}, {173,0.00000000}, {174,0.00006863}, {175,0.00011765}, {176,0.00000000}, {177,0.00009804}, {178,0.00006863}, {179,0.00006863}, {180,0.00020588}, {181,0.00012745}, {182,0.00002941}, {183,0.00020588}, {184,0.00016667}, {185,0.00007843}, {186,0.00003922}, {187,0.00000000}, {188,0.00013725}, {189,0.00006863}, {190,0.00006863}, {191,0.00002941}, {192,0.00006863}, {193,0.00021569}, {194,0.00007843}, {195,0.00014706}, {196,0.00010784}, {197,0.00007843}, {198,0.00015686}, {199,0.00006863}, {200,0.00011765}, {201,0.00003922}, {202,0.00003922}, {203,0.00007843}, {204,0.00015686}, {205,0.00013725}, {206,0.00011765}, {207,0.00003922}, {208,0.00003922}, {209,0.00006863}, {210,0.00010784}, {211,0.00015686}, {212,0.00016667}, {213,0.00010784}, {214,0.00003922}, {215,0.00006863}, {216,0.00022549}, {217,0.00014706}, {218,0.00007843}, {219,0.00006863}, {220,0.00014706}, {221,0.00012745}, {222,0.00014706}, {223,0.00010784}, {224,0.00002941}, {225,0.00003922}, {226,0.00010784}, {227,0.00021569}, {228,0.00007843}, {229,0.00006863}, {230,0.00021569}, {231,0.00009804}, {232,0.00007843}, {233,0.00003922}, {234,0.00003922}, {235,0.00006863}, {236,0.00010784}, {237,0.00021569}, {238,0.00020588}, {239,0.00007843}, {240,0.00007843}, {241,0.00009804}, {242,0.00018627}, {243,0.00007843}, {244,0.00003922}, {245,0.00015686}, {246,0.00028431}, {247,0.00035294}, {248,0.00017647}, {249,0.00025490}, {250,0.00006863}, {251,0.00013725}, {252,0.00015686}, {253,0.00007843}, {254,0.00006863}, {255,0.00012745}, {256,0.00009804}, {257,0.00014706}, {258,0.00005882}, {259,0.00010784}, {260,0.00010784}, {261,0.00007843}, {262,0.00006863}, {263,0.00022549}, {264,0.00008824}, {265,0.00003922}, {266,0.00010784}, {267,0.00008824}, {268,0.00020588}, {269,0.00014706}, {270,0.00002941}, {271,0.00007843}, {272,0.00000000}, {273,0.00006863}, {274,0.00010784}, {275,0.00016667}, {276,0.00011765}, {277,0.00025490}, {278,0.00017647}, {279,0.00014706}, {280,0.00002941}, {281,0.00022549}, {282,0.00006863}, {283,0.00027451}, {284,0.00026471}, {285,0.00020588}, {286,0.00031373}, {287,0.00000000}, {288,0.00018627}, {289,0.00011765}, {290,0.00014706}, {291,0.00021569}, {292,0.00005882}, {293,0.00009804}, {294,0.00012745}, {295,0.00005882}, {296,0.00018627}, {297,0.00010784}, {298,0.00020588}, {299,0.00010784}, {300,0.00026471}, {301,0.00017647}, {302,0.00003922}, {303,0.00010784}, {304,0.00018627}, {305,0.00018627}, {306,0.00011765}, {307,0.00015686}, {308,0.00022549}, {309,0.00003922}, {310,0.00014706}, {311,0.00016667}, {312,0.00015686}, {313,0.00005882}, {314,0.00002941}, {315,0.00009804}, {316,0.00016667}, {317,0.00018627}, {318,0.00015686}, {319,0.00009804}, {320,0.00014706}, {321,0.00008824}, {322,0.00019608}, {323,0.00017647}, {324,0.00007843}, {325,0.00007843}, {326,0.00013725}, {327,0.00009804}, {328,0.00018627}, {329,0.00017647}, {330,0.00021569}, {331,0.00014706}, {332,0.00013725}, {333,0.00011765}, {334,0.00018627}, {335,0.00018627}, {336,0.00018627}, {337,0.00014706}, {338,0.00000000}, {339,0.00010784}, {340,0.00007843}, {341,0.00013725}, {342,0.00009804}, {343,0.00017647}, {344,0.00026471}, {345,0.00018627}, {346,0.00011765}, {347,0.00029412}, {348,0.00020588}, {349,0.00017647}, {350,0.00019608}, {351,0.00006863}, {352,0.00031373}, {353,0.00019608}, {354,0.00003922}, {355,0.00019608}, {356,0.00017647}, {357,0.00021569}, {358,0.00019608}, {359,0.00017647}, {360,0.00019608}, {361,0.00000000}, {362,0.00006863}, {363,0.00016667}, {364,0.00013725}, {365,0.00011765}, {366,0.00006863}, {367,0.00010784}, {368,0.00020588}, {369,0.00023529}, {370,0.00006863}, {371,0.00006863}, {372,0.00019608}, {373,0.00018627}, {374,0.00022549}, {375,0.00033333}, {376,0.00013725}, {377,0.00018627}, {378,0.00014706}, {379,0.00018627}, {380,0.00015686}, {381,0.00016667}, {382,0.00007843}, {383,0.00028431}, {384,0.00015686}, {385,0.00018627}, {386,0.00020588}, {387,0.00006863}, {388,0.00016667}, {389,0.00019608}, {390,0.00009804}, {391,0.00015686}, {392,0.00009804}, {393,0.00026471}, {394,0.00025490}, {395,0.00022549}, {396,0.00016667}, {397,0.00002941}, {398,0.00005882}, {399,0.00017647}, {400,0.00002941}, {401,0.00030392}, {402,0.00034314}, {403,0.00017647}, {404,0.00013725}, {405,0.00017647}, {406,0.00018627}, {407,0.00021569}, {408,0.00021569}, {409,0.00019608}, {410,0.00019608}, {411,0.00027451}, {412,0.00017647}, {413,0.00010784}, {414,0.00038235}, {415,0.00024510}, {416,0.00024510}, {417,0.00020588}, {418,0.00011765}, {419,0.00020588}, {420,0.00027451}, {421,0.00021569}, {422,0.00013725}, {423,0.00026471}, {424,0.00016667}, {425,0.00020588}, {426,0.00011765}, {427,0.00014706}, {428,0.00007843}, {429,0.00014706}, {430,0.00017647}, {431,0.00010784}, {432,0.00014706}, {433,0.00000000}, {434,0.00010784}, {435,0.00037255}, {436,0.00018627}, {437,0.00025490}, {438,0.00014706}, {439,0.00015686}, {440,0.00002941}, {441,0.00020588}, {442,0.00031373}, {443,0.00022549}, {444,0.00022549}, {445,0.00027451}, {446,0.00036275}, {447,0.00035294}, {448,0.00021569}, {449,0.00030392}, {450,0.00006863}, {451,0.00010784}, {452,0.00027451}, {453,0.00023529}, {454,0.00032353}, {455,0.00010784}, {456,0.00007843}, {457,0.00018627}, {458,0.00010784}, {459,0.00013725}, {460,0.00021569}, {461,0.00013725}, {462,0.00014706}, {463,0.00015686}, {464,0.00006863}, {465,0.00033333}, {466,0.00020588}, {467,0.00014706}, {468,0.00023529}, {469,0.00021569}, {470,0.00019608}, {471,0.00027451}, {472,0.00022549}, {473,0.00018627}, {474,0.00013725}, {475,0.00031373}, {476,0.00010784}, {477,0.00019608}, {478,0.00009804}, {479,0.00031373}, {480,0.00010784}, {481,0.00023529}, {482,0.00013725}, {483,0.00026471}, {484,0.00027451}, {485,0.00013725}, {486,0.00020588}, {487,0.00013725}, {488,0.00006863}, {489,0.00029412}, {490,0.00018627}, {491,0.00026471}, {492,0.00026471}, {493,0.00025490}, {494,0.00010784}, {495,0.00021569}, {496,0.00019608}, {497,0.00022549}, {498,0.00023529}, {499,0.00016667}, {500,0.00010784}, {505,0.00031373}, {510,0.00030392}, {515,0.00032353}, {520,0.00006863}, {525,0.00025490}, {530,0.00026471}, {535,0.00039216}, {540,0.00014706}, {545,0.00027451}, {550,0.00014706}, {555,0.00018627}, {560,0.00027451}, {565,0.00015686}, {570,0.00012745}, {575,0.00018627}, {580,0.00045098}, {585,0.00020588}, {590,0.00040196}, {595,0.00025490}, {600,0.00014706}, {605,0.00044118}, {610,0.00034314}, {615,0.00020588}, {620,0.00031373}, {625,0.00025490}, {630,0.00018627}, {635,0.00039216}, {640,0.00036275}, {645,0.00021569}, {650,0.00018627}, {655,0.00017647}, {660,0.00017647}, {665,0.00024510}, {670,0.00016667}, {675,0.00016667}, {680,0.00027451}, {685,0.00023529}, {690,0.00026471}, {695,0.00026471}, {700,0.00017647}, {705,0.00040196}, {710,0.00033333}, {715,0.00041176}, {720,0.00043137}, {725,0.00031373}, {730,0.00033333}, {735,0.00033333}, {740,0.00050000}, {745,0.00047059}, {750,0.00044118}, {755,0.00030392}, {760,0.00025490}, {765,0.00043137}, {770,0.00043137}, {775,0.00046078}, {780,0.00030392}, {785,0.00022549}, {790,0.00042157}, {795,0.00028431}, {800,0.00038235}, {805,0.00016667}, {810,0.00049020}, {815,0.00035294}, {820,0.00028431}, {825,0.00035294}, {830,0.00047059}, {835,0.00028431}, {840,0.00046078}, {845,0.00037255}, {850,0.00037255}, {855,0.00049020}, {860,0.00018627}, {865,0.00027451}, {870,0.00028431}, {875,0.00045098}, {880,0.00025490}, {885,0.00047059}, {890,0.00036275}, {895,0.00026471}, {900,0.00035294}, {905,0.00039216}, {910,0.00023529}, {915,0.00029412}, {920,0.00032353}, {925,0.00050980}, {930,0.00029412}, {935,0.00030392}, {940,0.00029412}, {945,0.00044118}, {950,0.00038235}, {955,0.00035294}, {960,0.00039216}, {965,0.00051961}, {970,0.00035294}, {975,0.00049020}, {980,0.00030392}, {985,0.00055882}, {990,0.00021569}, {995,0.00032353}, {1000,0.00042157}, {1010,0.00027451}, {1020,0.00045098}, {1030,0.00017647}, {1040,0.00047059}, {1050,0.00035294}, {1060,0.00035294}, {1070,0.00037255}, {1080,0.00039216}, {1090,0.00053922}, {1100,0.00073529}, {1110,0.00052941}, {1120,0.00058824}, {1130,0.00027451}, {1140,0.00045098}, {1150,0.00036275}, {1160,0.00052941}, {1170,0.00049020}, {1180,0.00047059}, {1190,0.00041176}, {1200,0.00044118}, {1210,0.00079412}, {1220,0.00036275}, {1230,0.00050980}, {1240,0.00060784}, {1250,0.00022549}, {1260,0.00045098}, {1270,0.00054902}, {1280,0.00067647}, {1290,0.00028431}, {1300,0.00037255}, {1310,0.00040196}, {1320,0.00043137}, {1330,0.00051961}, {1340,0.00069608}, {1350,0.00035294}, {1360,0.00056863}, {1370,0.00049020}, {1380,0.00082353}, {1390,0.00041176}, {1400,0.00034314}, {1410,0.00047059}, {1420,0.00061765}, {1430,0.00062745}, {1440,0.00025490}, {1450,0.00064706}, {1460,0.00033333}, {1470,0.00059804}, {1480,0.00087255}, {1490,0.00039216}, {1500,0.00055882}, {1510,0.00057843}, {1520,0.00368627}, {1530,0.00059804}, {1540,0.00092157}, {1550,0.00038235}, {1560,0.00047059}, {1570,0.00041176}, {1580,0.00054902}, {1590,0.00051961}, {1600,0.00060784}, {1610,0.00058824}, {1620,0.00059804}, {1630,0.00051961}, {1640,0.00037255}, {1650,0.00050000}, {1660,0.00073529}, {1670,0.00055882}, {1680,0.00051961}, {1690,0.00072549}, {1700,0.00585294}, {1710,0.00084314}, {1720,0.00070588}, {1730,0.00067647}, {1740,0.00084314}, {1750,0.00050980}, {1760,0.00043137}, {1770,0.00037255}, {1780,0.00065686}, {1790,0.00045098}, {1800,0.00039216}, {1810,0.00049020}, {1820,0.00067647}, {1830,0.00065686}, {1840,0.00054902}, {1850,0.00060784}, {1860,0.00072549}, {1870,0.00046078}, {1880,0.00064706}, {1890,0.00064706}, {1900,0.00094118}, {1910,0.00087255}, {1920,0.00062745}, {1930,0.00056863}, {1940,0.00072549}, {1950,0.00053922}, {1960,0.00068627}, {1970,0.00066667}, {1980,0.00069608}, {1990,0.00072549}, {2000,0.00077451}, {2050,0.00053922}, {2100,0.00051961}, {2150,0.00058824}, {2200,0.00068627}, {2250,0.00081373}, {2300,0.00060784}, {2350,0.00072549}, {2400,0.00075490}, {2450,0.00075490}, {2500,0.00084314}, {2550,0.00077451}, {2600,0.00091176}, {2650,0.00074510}, {2700,0.00086275}, {2750,0.00067647}, {2800,0.00070588}, {2850,0.00085294}, {2900,0.00080392}, {2950,0.00086275}, {3000,0.00080392}, {3050,0.00080392}, {3100,0.00084314}, {3150,0.00092157}, {3200,0.00082353}, {3250,0.00087255}, {3300,0.00100980}, {3350,0.00072549}, {3400,0.00086275}, {3450,0.00105882}, {3500,0.00099020}, {3550,0.00094118}, {3600,0.00134314}, {3650,0.00122549}, {3700,0.00089216}, {3750,0.00098039}, {3800,0.00113725}, {3850,0.00129412}, {3900,0.00106863}, {3950,0.00109804}, {4000,0.00150980}, {4050,0.00138235}, {4100,0.00154902}, {4150,0.00132353}, {4200,0.00140196}, {4250,0.00119608}, {4300,0.00162745}, {4350,0.00123529}, {4400,0.00113725}, {4450,0.00149020}, {4500,0.00162745}, {4550,0.00115686}, {4600,0.00128431}, {4650,0.00124510}, {4700,0.00160784}, {4750,0.00134314}, {4800,0.00166667}, {4850,0.00157843}, {4900,0.00148039}, {4950,0.00147059}, {5000,0.00145098}, {5050,0.00155882}, {5100,0.00148039}, {5150,0.00154902}, {5200,0.00171569}, {5250,0.00148039}, {5300,0.00153922}, {5350,0.00157843}, {5400,0.00140196}, {5450,0.00175490}, {5500,0.00186275}, {5550,0.00187255}, {5600,0.00180392}, {5650,0.00166667}, {5700,0.00163725}, {5750,0.00190196}, {5800,0.00179412}, {5850,0.00184314}, {5900,0.00205882}, {5950,0.00170588}, {6000,0.00173529}, {6050,0.01359804}, {6100,0.00176471}, {6150,0.00153922}, {6200,0.00235294}, {6250,0.00201961}, {6300,0.00206863}, {6350,0.00213725}, {6400,0.00177451}, {6450,0.00224510}, {6500,0.00205882}, {6550,0.00214706}, {6600,0.00203922}, {6650,0.00222549}, {6700,0.00172549}, {6750,0.00188235}, {6800,0.00224510}, {6850,0.00205882}, {6900,0.00214706}, {6950,0.00211765}, {7000,0.01270588}, {7050,0.00243137}, {7100,0.00252941}, {7150,0.00234314}, {7200,0.00211765}, {7250,0.00223529}, {7300,0.00252941}, {7350,0.00234314}, {7400,0.00256863}, {7450,0.00223529}, {7500,0.00219608}, {7550,0.00246078}, {7600,0.00230392}, {7650,0.00238235}, {7700,0.00243137}, {7750,0.00259804}, {7800,0.00250000}, {7850,0.00260784}, {7900,0.00256863}, {7950,0.00236275}, {8000,0.00265686}, {8050,0.00265686}, {8100,0.00300000}, {8150,0.00255882}, {8200,0.00304902}, {8250,0.00268627}, {8300,0.01302941}, {8350,0.00300980}, {8400,0.00294118}, {8450,0.00300980}, {8500,0.00272549}, {8550,0.00296078}, {8600,0.00302941}, {8650,0.00314706}, {8700,0.00309804}, {8750,0.00304902}, {8800,0.00288235}, {8850,0.00312745}, {8900,0.00305882}, {8950,0.00302941}, {9000,0.00333333}, {9050,0.00327451}, {9100,0.00316667}, {9150,0.00310784}, {9200,0.00318627}, {9250,0.00321569}, {9300,0.00332353}, {9350,0.00311765}, {9400,0.00339216}, {9450,0.00306863}, {9500,0.01832353}, {9550,0.00323529}, {9600,0.00314706}, {9650,0.00343137}, {9700,0.00331373}, {9750,0.00345098}, {9800,0.00341176}, {9850,0.00350000}, {9900,0.00335294}, {9950,0.00329412}, {10000,0.00335294}, {10100,0.00350980}, {10200,0.00363725}, {10300,0.00387255}, {10400,0.00370588}, {10500,0.00370588}, {10600,0.00372549}, {10700,0.00365686}, {10800,0.01722549}, {10900,0.00389216}, {11000,0.00381373}, {11100,0.00373529}, {11200,0.00376471}, {11300,0.00434314}, {11400,0.00423529}, {11500,0.00408824}, {11600,0.00407843}, {11700,0.00386275}, {11800,0.00400980}, {11900,0.00402941}, {12000,0.02011765}, {12100,0.00421569}, {12200,0.00416667}, {12300,0.02690196}, {12400,0.00435294}, {12500,0.00435294}, {12600,0.00423529}, {12700,0.00469608}, {12800,0.00467647}, {12900,0.00450980}, {13000,0.00429412}, {13100,0.00459804}, {13200,0.00473529}, {13300,0.00462745}, {13400,0.00473529}, {13500,0.00478431}, {13600,0.00492157}, {13700,0.00500000}, {13800,0.00514706}, {13900,0.00488235}, {14000,0.00514706}, {14100,0.00473529}, {14200,0.00518627}, {14300,0.00515686}, {14400,0.00499020}, {14500,0.00521569}, {14600,0.00500000}, {14700,0.00533333}, {14800,0.00514706}, {14900,0.00544118}, {15000,0.00550000}, {15100,0.00543137}, {15200,0.00545098}, {15300,0.00534314}, {15400,0.00547059}, {15500,0.00538235}, {15600,0.00549020}, {15700,0.00553922}, {15800,0.00572549}, {15900,0.02947059}, {16000,0.00568627}, {16100,0.00576471}, {16200,0.00577451}, {16300,0.00592157}, {16400,0.00619608}, {16500,0.00595098}, {16600,0.00598039}, {16700,0.00580392}, {16800,0.00630392}, {16900,0.00607843}, {17000,0.00629412}, {17100,0.00615686}, {17200,0.00638235}, {17300,0.00608824}, {17400,0.00645098}, {17500,0.00642157}, {17600,0.00648039}, {17700,0.00638235}, {17800,0.00660784}, {17900,0.02473529}, {18000,0.00698039}, {18100,0.00647059}, {18200,0.00657843}, {18300,0.00688235}, {18400,0.00681373}, {18500,0.00668627}, {18600,0.00691176}, {18700,0.00707843}, {18800,0.00694118}, {18900,0.00659804}, {19000,0.00715686}, {19100,0.00709804}, {19200,0.00689216}, {19300,0.00714706}, {19400,0.00751961}, {19500,0.00698039}, {19600,0.00722549}, {19700,0.00697059}, {19800,0.04638235}, {19900,0.00733333}, {20000,0.00743137}};
data["big_flat"]["Ltac2LowLevel"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00003922}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00003922}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00003922}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00003922}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00003922}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00002941}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00003922}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00003922}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00003922}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00003922}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00003922}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00003922}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00003922}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00002941}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003922}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00003922}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00003922}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00003922}, {695,0.00000000}, {700,0.00003922}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00002941}, {815,0.00000000}, {820,0.00000000}, {825,0.00003922}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00003922}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00003922}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00003922}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00003922}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00002941}, {1150,0.00003922}, {1160,0.00003922}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00003922}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00003922}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003922}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00005882}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00002941}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00007843}, {1690,0.00000000}, {1700,0.00015686}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00003922}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00003922}, {1800,0.00003922}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00003922}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00003922}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00003922}, {1900,0.00000000}, {1910,0.00003922}, {1920,0.00003922}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00003922}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00003922}, {2150,0.00003922}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00003922}, {2350,0.00000000}, {2400,0.00007843}, {2450,0.00003922}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00002941}, {2900,0.00000000}, {2950,0.00007843}, {3000,0.00003922}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00003922}, {3200,0.00003922}, {3250,0.00003922}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00003922}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00003922}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00003922}, {4600,0.00000000}, {4650,0.00003922}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00003922}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00002941}, {6050,0.00000000}, {6100,0.00003922}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00003922}, {6400,0.00007843}, {6450,0.00003922}, {6500,0.00000000}, {6550,0.00007843}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00006863}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00007843}, {7000,0.00035294}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00003922}, {7200,0.00007843}, {7250,0.00003922}, {7300,0.00003922}, {7350,0.00007843}, {7400,0.00003922}, {7450,0.00000000}, {7500,0.00003922}, {7550,0.00003922}, {7600,0.00007843}, {7650,0.00003922}, {7700,0.00007843}, {7750,0.00000000}, {7800,0.00003922}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00007843}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00002941}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00034314}, {8350,0.00000000}, {8400,0.00003922}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00003922}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00002941}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00003922}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00006863}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00007843}, {10000,0.00003922}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00006863}, {10400,0.00000000}, {10500,0.00003922}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00003922}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00003922}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00006863}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00003922}, {12900,0.00003922}, {13000,0.00000000}, {13100,0.00003922}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00003922}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00002941}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00007843}, {14800,0.00000000}, {14900,0.00003922}, {15000,0.00000000}, {15100,0.00007843}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00003922}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00003922}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00003922}, {16600,0.00003922}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00003922}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00003922}, {17300,0.00000000}, {17400,0.00003922}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00003922}, {17800,0.00000000}, {17900,0.00003922}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00003922}, {18600,0.00003922}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00003922}, {19000,0.00003922}, {19100,0.00003922}, {19200,0.00007843}, {19300,0.00002941}, {19400,0.00000000}, {19500,0.00003922}, {19600,0.00000000}, {19700,0.00003922}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["Ltac2LowLevel"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00011765}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000980}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["Ltac2LowLevel"]["post"]["user"] = {{1,0.00000000}, {2,0.00006863}, {3,0.00003922}, {4,0.00002941}, {5,0.00002941}, {6,0.00003922}, {7,0.00000000}, {8,0.00005882}, {9,0.00000000}, {10,0.00002941}, {11,0.00000000}, {12,0.00002941}, {13,0.00002941}, {14,0.00003922}, {15,0.00000000}, {16,0.00000000}, {17,0.00003922}, {18,0.00000000}, {19,0.00000000}, {20,0.00006863}, {21,0.00000000}, {22,0.00009804}, {23,0.00003922}, {24,0.00000000}, {25,0.00000000}, {26,0.00007843}, {27,0.00000000}, {28,0.00000000}, {29,0.00023529}, {30,0.00000000}, {31,0.00000000}, {32,0.00008824}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00010784}, {37,0.00002941}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00006863}, {42,0.00000000}, {43,0.00000000}, {44,0.00003922}, {45,0.00000000}, {46,0.00000000}, {47,0.00010784}, {48,0.00003922}, {49,0.00000000}, {50,0.00000000}, {51,0.00003922}, {52,0.00000000}, {53,0.00002941}, {54,0.00006863}, {55,0.00000000}, {56,0.00003922}, {57,0.00006863}, {58,0.00010784}, {59,0.00002941}, {60,0.00003922}, {61,0.00000000}, {62,0.00003922}, {63,0.00000000}, {64,0.00003922}, {65,0.00003922}, {66,0.00006863}, {67,0.00000000}, {68,0.00002941}, {69,0.00006863}, {70,0.00000000}, {71,0.00003922}, {72,0.00003922}, {73,0.00012745}, {74,0.00002941}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00010784}, {79,0.00000000}, {80,0.00000000}, {81,0.00003922}, {82,0.00014706}, {83,0.00003922}, {84,0.00003922}, {85,0.00003922}, {86,0.00012745}, {87,0.00000000}, {88,0.00000000}, {89,0.00006863}, {90,0.00003922}, {91,0.00000000}, {92,0.00003922}, {93,0.00002941}, {94,0.00006863}, {95,0.00011765}, {96,0.00000000}, {97,0.00000000}, {98,0.00002941}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00002941}, {103,0.00000000}, {104,0.00002941}, {105,0.00002941}, {106,0.00013725}, {107,0.00003922}, {108,0.00003922}, {109,0.00005882}, {110,0.00002941}, {111,0.00002941}, {112,0.00007843}, {113,0.00003922}, {114,0.00000000}, {115,0.00009804}, {116,0.00003922}, {117,0.00005882}, {118,0.00000000}, {119,0.00007843}, {120,0.00000000}, {121,0.00003922}, {122,0.00002941}, {123,0.00002941}, {124,0.00012745}, {125,0.00006863}, {126,0.00002941}, {127,0.00000000}, {128,0.00002941}, {129,0.00000000}, {130,0.00006863}, {131,0.00002941}, {132,0.00006863}, {133,0.00000000}, {134,0.00006863}, {135,0.00002941}, {136,0.00000000}, {137,0.00009804}, {138,0.00000000}, {139,0.00007843}, {140,0.00000000}, {141,0.00006863}, {142,0.00000000}, {143,0.00003922}, {144,0.00000000}, {145,0.00005882}, {146,0.00002941}, {147,0.00000000}, {148,0.00000000}, {149,0.00003922}, {150,0.00002941}, {151,0.00007843}, {152,0.00003922}, {153,0.00000000}, {154,0.00003922}, {155,0.00003922}, {156,0.00002941}, {157,0.00000000}, {158,0.00000000}, {159,0.00003922}, {160,0.00002941}, {161,0.00091176}, {162,0.00000000}, {163,0.00003922}, {164,0.00000000}, {165,0.00000000}, {166,0.00013725}, {167,0.00000000}, {168,0.00000000}, {169,0.00002941}, {170,0.00002941}, {171,0.00009804}, {172,0.00011765}, {173,0.00007843}, {174,0.00003922}, {175,0.00002941}, {176,0.00003922}, {177,0.00007843}, {178,0.00003922}, {179,0.00003922}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00007843}, {185,0.00002941}, {186,0.00002941}, {187,0.00000000}, {188,0.00003922}, {189,0.00010784}, {190,0.00005882}, {191,0.00000000}, {192,0.00007843}, {193,0.00003922}, {194,0.00005882}, {195,0.00005882}, {196,0.00002941}, {197,0.00000000}, {198,0.00003922}, {199,0.00002941}, {200,0.00000000}, {201,0.00000000}, {202,0.00009804}, {203,0.00006863}, {204,0.00000000}, {205,0.00006863}, {206,0.00000000}, {207,0.00005882}, {208,0.00011765}, {209,0.00002941}, {210,0.00003922}, {211,0.00007843}, {212,0.00006863}, {213,0.00000000}, {214,0.00003922}, {215,0.00006863}, {216,0.00005882}, {217,0.00007843}, {218,0.00003922}, {219,0.00002941}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00002941}, {225,0.00000000}, {226,0.00013725}, {227,0.00003922}, {228,0.00006863}, {229,0.00003922}, {230,0.00002941}, {231,0.00006863}, {232,0.00000000}, {233,0.00007843}, {234,0.00007843}, {235,0.00007843}, {236,0.00000000}, {237,0.00011765}, {238,0.00002941}, {239,0.00003922}, {240,0.00000000}, {241,0.00002941}, {242,0.00002941}, {243,0.00015686}, {244,0.00003922}, {245,0.00000000}, {246,0.00000000}, {247,0.00003922}, {248,0.00002941}, {249,0.00000000}, {250,0.00000000}, {251,0.00003922}, {252,0.00007843}, {253,0.00003922}, {254,0.00002941}, {255,0.00002941}, {256,0.00003922}, {257,0.00007843}, {258,0.00003922}, {259,0.00016667}, {260,0.00003922}, {261,0.00003922}, {262,0.00000000}, {263,0.00006863}, {264,0.00003922}, {265,0.00000000}, {266,0.00002941}, {267,0.00003922}, {268,0.00000000}, {269,0.00000000}, {270,0.00002941}, {271,0.00007843}, {272,0.00003922}, {273,0.00000000}, {274,0.00003922}, {275,0.00003922}, {276,0.00002941}, {277,0.00003922}, {278,0.00003922}, {279,0.00000000}, {280,0.00000000}, {281,0.00003922}, {282,0.00003922}, {283,0.00000000}, {284,0.00006863}, {285,0.00000000}, {286,0.00000000}, {287,0.00007843}, {288,0.00002941}, {289,0.00003922}, {290,0.00006863}, {291,0.00000000}, {292,0.00003922}, {293,0.00000000}, {294,0.00006863}, {295,0.00000000}, {296,0.00000000}, {297,0.00006863}, {298,0.00000000}, {299,0.00002941}, {300,0.00014706}, {301,0.00002941}, {302,0.00005882}, {303,0.00003922}, {304,0.00000000}, {305,0.00003922}, {306,0.00003922}, {307,0.00012745}, {308,0.00003922}, {309,0.00011765}, {310,0.00003922}, {311,0.00000000}, {312,0.00000000}, {313,0.00002941}, {314,0.00003922}, {315,0.00000000}, {316,0.00006863}, {317,0.00000000}, {318,0.00003922}, {319,0.00002941}, {320,0.00003922}, {321,0.00003922}, {322,0.00006863}, {323,0.00000000}, {324,0.00010784}, {325,0.00000000}, {326,0.00003922}, {327,0.00000000}, {328,0.00002941}, {329,0.00000000}, {330,0.00003922}, {331,0.00000000}, {332,0.00002941}, {333,0.00007843}, {334,0.00000000}, {335,0.00003922}, {336,0.00006863}, {337,0.00003922}, {338,0.00000000}, {339,0.00007843}, {340,0.00003922}, {341,0.00003922}, {342,0.00002941}, {343,0.00000000}, {344,0.00000000}, {345,0.00006863}, {346,0.00000000}, {347,0.00003922}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00010784}, {352,0.00003922}, {353,0.00000000}, {354,0.00007843}, {355,0.00010784}, {356,0.00003922}, {357,0.00007843}, {358,0.00000000}, {359,0.00002941}, {360,0.00002941}, {361,0.00003922}, {362,0.00007843}, {363,0.00000000}, {364,0.00000000}, {365,0.00006863}, {366,0.00000000}, {367,0.00000000}, {368,0.00003922}, {369,0.00003922}, {370,0.00003922}, {371,0.00000000}, {372,0.00000000}, {373,0.00003922}, {374,0.00000000}, {375,0.00003922}, {376,0.00006863}, {377,0.00000000}, {378,0.00002941}, {379,0.00003922}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00006863}, {384,0.00000000}, {385,0.00005882}, {386,0.00000000}, {387,0.00000000}, {388,0.00006863}, {389,0.00000000}, {390,0.00003922}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00003922}, {395,0.00006863}, {396,0.00000000}, {397,0.00009804}, {398,0.00000000}, {399,0.00003922}, {400,0.00007843}, {401,0.00000000}, {402,0.00003922}, {403,0.00000000}, {404,0.00006863}, {405,0.00007843}, {406,0.00000000}, {407,0.00003922}, {408,0.00003922}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00002941}, {413,0.00003922}, {414,0.00003922}, {415,0.00002941}, {416,0.00000000}, {417,0.00008824}, {418,0.00003922}, {419,0.00000000}, {420,0.00006863}, {421,0.00000000}, {422,0.00006863}, {423,0.00007843}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00002941}, {429,0.00000000}, {430,0.00007843}, {431,0.00000000}, {432,0.00011765}, {433,0.00003922}, {434,0.00006863}, {435,0.00002941}, {436,0.00002941}, {437,0.00007843}, {438,0.00002941}, {439,0.00003922}, {440,0.00000000}, {441,0.00006863}, {442,0.00003922}, {443,0.00007843}, {444,0.00003922}, {445,0.00000000}, {446,0.00003922}, {447,0.00007843}, {448,0.00000000}, {449,0.00000000}, {450,0.00002941}, {451,0.00000000}, {452,0.00005882}, {453,0.00006863}, {454,0.00003922}, {455,0.00003922}, {456,0.00000000}, {457,0.00000000}, {458,0.00007843}, {459,0.00005882}, {460,0.00003922}, {461,0.00002941}, {462,0.00000000}, {463,0.00003922}, {464,0.00007843}, {465,0.00003922}, {466,0.00000000}, {467,0.00003922}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00002941}, {473,0.00002941}, {474,0.00006863}, {475,0.00006863}, {476,0.00000000}, {477,0.00003922}, {478,0.00011765}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00010784}, {485,0.00003922}, {486,0.00000000}, {487,0.00003922}, {488,0.00009804}, {489,0.00003922}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00003922}, {495,0.00000000}, {496,0.00000000}, {497,0.00010784}, {498,0.00002941}, {499,0.00002941}, {500,0.00003922}, {505,0.00009804}, {510,0.00003922}, {515,0.00003922}, {520,0.00007843}, {525,0.00003922}, {530,0.00013725}, {535,0.00000000}, {540,0.00000000}, {545,0.00002941}, {550,0.00002941}, {555,0.00000000}, {560,0.00000000}, {565,0.00003922}, {570,0.00000000}, {575,0.00002941}, {580,0.00000000}, {585,0.00002941}, {590,0.00007843}, {595,0.00000000}, {600,0.00000000}, {605,0.00006863}, {610,0.00007843}, {615,0.00003922}, {620,0.00000000}, {625,0.00006863}, {630,0.00006863}, {635,0.00000000}, {640,0.00014706}, {645,0.00006863}, {650,0.00000000}, {655,0.00011765}, {660,0.00002941}, {665,0.00003922}, {670,0.00005882}, {675,0.00007843}, {680,0.00003922}, {685,0.00007843}, {690,0.00002941}, {695,0.00002941}, {700,0.00000000}, {705,0.00000000}, {710,0.00007843}, {715,0.00006863}, {720,0.00000000}, {725,0.00003922}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00003922}, {755,0.00005882}, {760,0.00011765}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00006863}, {790,0.00007843}, {795,0.00000000}, {800,0.00002941}, {805,0.00007843}, {810,0.00003922}, {815,0.00007843}, {820,0.00000000}, {825,0.00003922}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00007843}, {850,0.00000000}, {855,0.00012745}, {860,0.00010784}, {865,0.00007843}, {870,0.00007843}, {875,0.00000000}, {880,0.00006863}, {885,0.00003922}, {890,0.00006863}, {895,0.00002941}, {900,0.00003922}, {905,0.00000000}, {910,0.00007843}, {915,0.00011765}, {920,0.00002941}, {925,0.00000000}, {930,0.00010784}, {935,0.00000000}, {940,0.00000000}, {945,0.00007843}, {950,0.00006863}, {955,0.00003922}, {960,0.00000000}, {965,0.00003922}, {970,0.00006863}, {975,0.00006863}, {980,0.00000000}, {985,0.00000000}, {990,0.00006863}, {995,0.00006863}, {1000,0.00000000}, {1010,0.00007843}, {1020,0.00003922}, {1030,0.00007843}, {1040,0.00002941}, {1050,0.00002941}, {1060,0.00003922}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00003922}, {1100,0.00007843}, {1110,0.00000000}, {1120,0.00006863}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00006863}, {1160,0.00000000}, {1170,0.00003922}, {1180,0.00007843}, {1190,0.00000000}, {1200,0.00003922}, {1210,0.00006863}, {1220,0.00003922}, {1230,0.00009804}, {1240,0.00000000}, {1250,0.00003922}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003922}, {1290,0.00000000}, {1300,0.00011765}, {1310,0.00000000}, {1320,0.00006863}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00006863}, {1360,0.00003922}, {1370,0.00002941}, {1380,0.00010784}, {1390,0.00007843}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00005882}, {1450,0.00006863}, {1460,0.00007843}, {1470,0.00006863}, {1480,0.00003922}, {1490,0.00009804}, {1500,0.00002941}, {1510,0.00000000}, {1520,0.00002941}, {1530,0.00013725}, {1540,0.00003922}, {1550,0.00006863}, {1560,0.00002941}, {1570,0.00000000}, {1580,0.00006863}, {1590,0.00002941}, {1600,0.00007843}, {1610,0.00002941}, {1620,0.00002941}, {1630,0.00003922}, {1640,0.00003922}, {1650,0.00000000}, {1660,0.00006863}, {1670,0.00003922}, {1680,0.00002941}, {1690,0.00003922}, {1700,0.00002941}, {1710,0.00002941}, {1720,0.00000000}, {1730,0.00002941}, {1740,0.00010784}, {1750,0.00006863}, {1760,0.00003922}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00002941}, {1810,0.00003922}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00002941}, {1850,0.00000000}, {1860,0.00002941}, {1870,0.00006863}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00003922}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00003922}, {1940,0.00000000}, {1950,0.00002941}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00002941}, {1990,0.00002941}, {2000,0.00002941}, {2050,0.00003922}, {2100,0.00003922}, {2150,0.00003922}, {2200,0.00005882}, {2250,0.00000000}, {2300,0.00003922}, {2350,0.00003922}, {2400,0.00005882}, {2450,0.00002941}, {2500,0.00005882}, {2550,0.00006863}, {2600,0.00003922}, {2650,0.00007843}, {2700,0.00002941}, {2750,0.00000000}, {2800,0.00002941}, {2850,0.00003922}, {2900,0.00000000}, {2950,0.00002941}, {3000,0.00003922}, {3050,0.00007843}, {3100,0.00002941}, {3150,0.00000000}, {3200,0.00002941}, {3250,0.00000000}, {3300,0.00002941}, {3350,0.00005882}, {3400,0.00003922}, {3450,0.00006863}, {3500,0.00002941}, {3550,0.00003922}, {3600,0.00000000}, {3650,0.00005882}, {3700,0.00006863}, {3750,0.00000000}, {3800,0.00009804}, {3850,0.00002941}, {3900,0.00002941}, {3950,0.00005882}, {4000,0.00000000}, {4050,0.00005882}, {4100,0.00006863}, {4150,0.00002941}, {4200,0.00005882}, {4250,0.00002941}, {4300,0.00007843}, {4350,0.00000000}, {4400,0.00002941}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00005882}, {4600,0.00000000}, {4650,0.00006863}, {4700,0.00002941}, {4750,0.00002941}, {4800,0.00000000}, {4850,0.00005882}, {4900,0.00003922}, {4950,0.00005882}, {5000,0.00009804}, {5050,0.00000000}, {5100,0.00002941}, {5150,0.00013725}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00005882}, {5500,0.00000000}, {5550,0.00002941}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00002941}, {5750,0.00006863}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00002941}, {6150,0.00013725}, {6200,0.00005882}, {6250,0.00005882}, {6300,0.00002941}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00005882}, {6550,0.00003922}, {6600,0.00000000}, {6650,0.00002941}, {6700,0.00007843}, {6750,0.00010784}, {6800,0.00006863}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00005882}, {7150,0.00006863}, {7200,0.00002941}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00002941}, {7400,0.00000000}, {7450,0.00002941}, {7500,0.00000000}, {7550,0.00003922}, {7600,0.00000000}, {7650,0.00002941}, {7700,0.00002941}, {7750,0.00006863}, {7800,0.00005882}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00002941}, {8000,0.00003922}, {8050,0.00003922}, {8100,0.00003922}, {8150,0.00003922}, {8200,0.00000000}, {8250,0.00003922}, {8300,0.00003922}, {8350,0.00002941}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00003922}, {8550,0.00000000}, {8600,0.00002941}, {8650,0.00006863}, {8700,0.00003922}, {8750,0.00000000}, {8800,0.00009804}, {8850,0.00002941}, {8900,0.00008824}, {8950,0.00003922}, {9000,0.00000000}, {9050,0.00005882}, {9100,0.00000000}, {9150,0.00003922}, {9200,0.00000000}, {9250,0.00010784}, {9300,0.00014706}, {9350,0.00002941}, {9400,0.00003922}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00003922}, {9650,0.00009804}, {9700,0.00002941}, {9750,0.00000000}, {9800,0.00015686}, {9850,0.00003922}, {9900,0.00002941}, {9950,0.00003922}, {10000,0.00006863}, {10100,0.00003922}, {10200,0.00006863}, {10300,0.00002941}, {10400,0.00009804}, {10500,0.00003922}, {10600,0.00006863}, {10700,0.00006863}, {10800,0.00003922}, {10900,0.00007843}, {11000,0.00000000}, {11100,0.00002941}, {11200,0.00006863}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00003922}, {11600,0.00000000}, {11700,0.00002941}, {11800,0.00003922}, {11900,0.00006863}, {12000,0.00003922}, {12100,0.00002941}, {12200,0.00000000}, {12300,0.00003922}, {12400,0.00000000}, {12500,0.00002941}, {12600,0.00005882}, {12700,0.00009804}, {12800,0.00002941}, {12900,0.00002941}, {13000,0.00014706}, {13100,0.00007843}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00002941}, {13500,0.00003922}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00002941}, {13900,0.00000000}, {14000,0.00010784}, {14100,0.00002941}, {14200,0.00010784}, {14300,0.00000000}, {14400,0.00002941}, {14500,0.00000000}, {14600,0.00006863}, {14700,0.00007843}, {14800,0.00003922}, {14900,0.00003922}, {15000,0.00010784}, {15100,0.00000000}, {15200,0.00002941}, {15300,0.00006863}, {15400,0.00002941}, {15500,0.00006863}, {15600,0.00000000}, {15700,0.00009804}, {15800,0.00007843}, {15900,0.00003922}, {16000,0.00002941}, {16100,0.00003922}, {16200,0.00007843}, {16300,0.00000000}, {16400,0.00002941}, {16500,0.00005882}, {16600,0.00008824}, {16700,0.00005882}, {16800,0.00000000}, {16900,0.00009804}, {17000,0.00017647}, {17100,0.00017647}, {17200,0.00000000}, {17300,0.00006863}, {17400,0.00000000}, {17500,0.00003922}, {17600,0.00000000}, {17700,0.00006863}, {17800,0.00002941}, {17900,0.00000000}, {18000,0.00003922}, {18100,0.00003922}, {18200,0.00005882}, {18300,0.00003922}, {18400,0.00005882}, {18500,0.00000000}, {18600,0.00010784}, {18700,0.00014706}, {18800,0.00000000}, {18900,0.00007843}, {19000,0.00002941}, {19100,0.00000000}, {19200,0.00005882}, {19300,0.00002941}, {19400,0.00003922}, {19500,0.00005882}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00012745}, {19900,0.00000000}, {20000,0.00003922}};
data["big_flat"]["Ltac2LowLevel"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00002941}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00002941}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00002941}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00002941}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00007843}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00003922}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00003922}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00003922}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00003922}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00003922}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00003922}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00003922}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00003922}, {11200,0.00000000}, {11300,0.00003922}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00003922}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00003922}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["Ltac2LowLevel"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["Ltac2LowLevel"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00002941}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00006863}, {54,0.00000000}, {55,0.00006863}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00003922}, {68,0.00000000}, {69,0.00000000}, {70,0.00003922}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00003922}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00003922}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00002941}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00003922}, {115,0.00000000}, {116,0.00003922}, {117,0.00003922}, {118,0.00000000}, {119,0.00000000}, {120,0.00011765}, {121,0.00000000}, {122,0.00003922}, {123,0.00003922}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00002941}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00002941}, {146,0.00000000}, {147,0.00002941}, {148,0.00003922}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00003922}, {159,0.00002941}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00002941}, {165,0.00000000}, {166,0.00000000}, {167,0.00002941}, {168,0.00003922}, {169,0.00003922}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00002941}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00003922}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00003922}, {218,0.00002941}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00002941}, {224,0.00000000}, {225,0.00003922}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00003922}, {232,0.00000000}, {233,0.00003922}, {234,0.00002941}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00002941}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00002941}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00003922}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00003922}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00002941}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00003922}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00003922}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00003922}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00002941}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00002941}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00003922}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00003922}, {436,0.00006863}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00003922}, {443,0.00000000}, {444,0.00003922}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00003922}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00003922}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00003922}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00003922}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00003922}, {484,0.00000000}, {485,0.00002941}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00003922}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00003922}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00003922}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00003922}, {660,0.00003922}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00007843}, {715,0.00000000}, {720,0.00000000}, {725,0.00003922}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00003922}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00003922}, {870,0.00002941}, {875,0.00000000}, {880,0.00006863}, {885,0.00003922}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00002941}, {915,0.00000000}, {920,0.00002941}, {925,0.00003922}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00003922}, {970,0.00000000}, {975,0.00003922}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00003922}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00003922}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00003922}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00003922}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00003922}, {1340,0.00000000}, {1350,0.00003922}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00003922}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00003922}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00002941}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00003922}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00003922}, {2100,0.00000000}, {2150,0.00002941}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00002941}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00003922}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00003922}, {4100,0.00000000}, {4150,0.00002941}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00003922}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00003922}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00002941}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00002941}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00002941}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00002941}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00003922}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00003922}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00003922}, {6700,0.00002941}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00002941}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00002941}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00002941}, {7500,0.00002941}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00003922}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00003922}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00003922}, {9300,0.00000000}, {9350,0.00002941}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00002941}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00002941}, {9750,0.00003922}, {9800,0.00003922}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00003922}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00002941}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00002941}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00006863}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00003922}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00002941}, {15200,0.00002941}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00003922}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00003922}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00002941}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00003922}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00002941}, {18400,0.00000000}, {18500,0.00003922}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00002941}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["Ltac2LowLevel"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00003922}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00003922}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00003922}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00003922}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00003922}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00003922}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["Ltac2LowLevel"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000980}, {18,0.00000980}, {19,0.00011765}, {20,0.00019608}, {21,0.00016667}, {22,0.00016667}, {23,0.00035294}, {24,0.00093137}, {25,0.00100000}, {26,0.01769608}, {27,0.00100000}, {28,0.00100000}, {29,0.00100000}, {30,0.00100000}, {31,0.00100000}, {32,0.00100000}, {33,0.00100000}, {34,0.00100000}, {35,0.00100000}, {36,0.00100000}, {37,0.00100000}, {38,0.00100000}, {39,0.00100000}, {40,0.00100000}, {41,0.00102941}, {42,0.00104902}, {43,0.00102941}, {44,0.00101961}, {45,0.00100980}, {46,0.00102941}, {47,0.00101961}, {48,0.00109804}, {49,0.00113725}, {50,0.00127451}, {51,0.00156863}, {52,0.00195098}, {53,0.00199020}, {54,0.00200000}, {55,0.00200000}, {56,0.00200000}, {57,0.00200000}, {58,0.00291176}, {59,0.00200000}, {60,0.00200980}, {61,0.00200000}, {62,0.00200000}, {63,0.00200000}, {64,0.00200980}, {65,0.00200980}, {66,0.00201961}, {67,0.00201961}, {68,0.00200980}, {69,0.00201961}, {70,0.00204902}, {71,0.00200980}, {72,0.00201961}, {73,0.00200980}, {74,0.00203922}, {75,0.00202941}, {76,0.00206863}, {77,0.00216667}, {78,0.00244118}, {79,0.00272549}, {80,0.00309804}, {81,0.00298039}, {82,0.00300000}, {83,0.00300000}, {84,0.00300980}, {85,0.00300000}, {86,0.00300000}, {87,0.00301961}, {88,0.00300000}, {89,0.00300980}, {90,0.00300000}, {91,0.00300000}, {92,0.00300000}, {93,0.00300000}, {94,0.00300980}, {95,0.00300000}, {96,0.00300980}, {97,0.00300980}, {98,0.00400000}, {99,0.00302941}, {100,0.00302941}, {101,0.00300980}, {102,0.00307843}, {103,0.00304902}, {104,0.00309804}, {105,0.00327451}, {106,0.00349020}, {107,0.00375490}, {108,0.00387255}, {109,0.00394118}, {110,0.00398039}, {111,0.00400000}, {112,0.00400000}, {113,0.00451961}, {114,0.00400000}, {115,0.00400000}, {116,0.00400000}, {117,0.00400000}, {118,0.00400000}, {119,0.00400980}, {120,0.00400000}, {121,0.00400980}, {122,0.00402941}, {123,0.00400000}, {124,0.00400980}, {125,0.00400980}, {126,0.00400000}, {127,0.00499020}, {128,0.00403922}, {129,0.00406863}, {130,0.00407843}, {131,0.00410784}, {132,0.00417647}, {133,0.00429412}, {134,0.00454902}, {135,0.00480392}, {136,0.00482353}, {137,0.00492157}, {138,0.00497059}, {139,0.00534314}, {140,0.00500980}, {141,0.00500000}, {142,0.00500000}, {143,0.00500000}, {144,0.00500000}, {145,0.00500000}, {146,0.00500980}, {147,0.00500000}, {148,0.00500980}, {149,0.00500000}, {150,0.00500000}, {151,0.00505882}, {152,0.00500980}, {153,0.00500980}, {154,0.00501961}, {155,0.00503922}, {156,0.00502941}, {157,0.00503922}, {158,0.00506863}, {159,0.00508824}, {160,0.00516667}, {161,0.00539216}, {162,0.00566667}, {163,0.00572549}, {164,0.00583333}, {165,0.00588235}, {166,0.00592157}, {167,0.00599020}, {168,0.00600000}, {169,0.00599020}, {170,0.00600000}, {171,0.00600000}, {172,0.00600000}, {173,0.00600000}, {174,0.00600000}, {175,0.00600000}, {176,0.00600000}, {177,0.00601961}, {178,0.00600980}, {179,0.00600000}, {180,0.00601961}, {181,0.00700980}, {182,0.00603922}, {183,0.00601961}, {184,0.00605882}, {185,0.00607843}, {186,0.00612745}, {187,0.00612745}, {188,0.00622549}, {189,0.00637255}, {190,0.00713725}, {191,0.00672549}, {192,0.00679412}, {193,0.00685294}, {194,0.00690196}, {195,0.00692157}, {196,0.00697059}, {197,0.00699020}, {198,0.00700000}, {199,0.00775490}, {200,0.00700000}, {201,0.00701961}, {202,0.00700000}, {203,0.00700000}, {204,0.00700000}, {205,0.00700980}, {206,0.00700980}, {207,0.00700980}, {208,0.00703922}, {209,0.00703922}, {210,0.00700980}, {211,0.00703922}, {212,0.00702941}, {213,0.00706863}, {214,0.00715686}, {215,0.00717647}, {216,0.00731373}, {217,0.00750000}, {218,0.00757843}, {219,0.00767647}, {220,0.00777451}, {221,0.00785294}, {222,0.00786275}, {223,0.00861765}, {224,0.00793137}, {225,0.00793137}, {226,0.00797059}, {227,0.00799020}, {228,0.00800980}, {229,0.00800000}, {230,0.00800000}, {231,0.00900980}, {232,0.00800000}, {233,0.00800000}, {234,0.00800980}, {235,0.00800980}, {236,0.00802941}, {237,0.00802941}, {238,0.00901961}, {239,0.00803922}, {240,0.00801961}, {241,0.00809804}, {242,0.00810784}, {243,0.00815686}, {244,0.00826471}, {245,0.00844118}, {246,0.00861765}, {247,0.00871569}, {248,0.00881373}, {249,0.00882353}, {250,0.00883333}, {251,0.00887255}, {252,0.00889216}, {253,0.00895098}, {254,0.00895098}, {255,0.00895098}, {256,0.00900980}, {257,0.00900980}, {258,0.00900000}, {259,0.00989216}, {260,0.00901961}, {261,0.00901961}, {262,0.00900980}, {263,0.00903922}, {264,0.00903922}, {265,0.00900980}, {266,0.00998039}, {267,0.00902941}, {268,0.00905882}, {269,0.00910784}, {270,0.00921569}, {271,0.00920588}, {272,0.01016667}, {273,0.00954902}, {274,0.00959804}, {275,0.00968627}, {276,0.00975490}, {277,0.00984314}, {278,0.00987255}, {279,0.00986275}, {280,0.00989216}, {281,0.00991176}, {282,0.00992157}, {283,0.00996078}, {284,0.01000000}, {285,0.01099020}, {286,0.01000000}, {287,0.01000980}, {288,0.01000980}, {289,0.01000980}, {290,0.01000980}, {291,0.01096078}, {292,0.01002941}, {293,0.01002941}, {294,0.01001961}, {295,0.01004902}, {296,0.01010784}, {297,0.01101961}, {298,0.01019608}, {299,0.01035294}, {300,0.01038235}, {301,0.01050980}, {302,0.01061765}, {303,0.01072549}, {304,0.01081373}, {305,0.01081373}, {306,0.01084314}, {307,0.01084314}, {308,0.01195098}, {309,0.01089216}, {310,0.01091176}, {311,0.01095098}, {312,0.01097059}, {313,0.01100000}, {314,0.01187255}, {315,0.01102941}, {316,0.01100000}, {317,0.01101961}, {318,0.01100980}, {319,0.01102941}, {320,0.01102941}, {321,0.01102941}, {322,0.01105882}, {323,0.01106863}, {324,0.01111765}, {325,0.01207843}, {326,0.01124510}, {327,0.01133333}, {328,0.01147059}, {329,0.01154902}, {330,0.01250000}, {331,0.01176471}, {332,0.01175490}, {333,0.01183333}, {334,0.01185294}, {335,0.01186275}, {336,0.01187255}, {337,0.01185294}, {338,0.01191176}, {339,0.01193137}, {340,0.01198039}, {341,0.01282353}, {342,0.01200980}, {343,0.01201961}, {344,0.01200980}, {345,0.01201961}, {346,0.01291176}, {347,0.01202941}, {348,0.01201961}, {349,0.01203922}, {350,0.01206863}, {351,0.01310784}, {352,0.01214706}, {353,0.01217647}, {354,0.01224510}, {355,0.01232353}, {356,0.01332353}, {357,0.01258824}, {358,0.01264706}, {359,0.01270588}, {360,0.01277451}, {361,0.01363725}, {362,0.01281373}, {363,0.01284314}, {364,0.01290196}, {365,0.01289216}, {366,0.01371569}, {367,0.01295098}, {368,0.01295098}, {369,0.01298039}, {370,0.01298039}, {371,0.01302941}, {372,0.01301961}, {373,0.01304902}, {374,0.01302941}, {375,0.01417647}, {376,0.01308824}, {377,0.01307843}, {378,0.01308824}, {379,0.01310784}, {380,0.01418627}, {381,0.01324510}, {382,0.01338235}, {383,0.01340196}, {384,0.01350980}, {385,0.01357843}, {386,0.01370588}, {387,0.01372549}, {388,0.01373529}, {389,0.01479412}, {390,0.01384314}, {391,0.01385294}, {392,0.01385294}, {393,0.01385294}, {394,0.01390196}, {395,0.01390196}, {396,0.01394118}, {397,0.01398039}, {398,0.01499020}, {399,0.01400980}, {400,0.01401961}, {401,0.01403922}, {402,0.01401961}, {403,0.01404902}, {404,0.01402941}, {405,0.01407843}, {406,0.01411765}, {407,0.01518627}, {408,0.01420588}, {409,0.01423529}, {410,0.01438235}, {411,0.01546078}, {412,0.01450000}, {413,0.01463725}, {414,0.01469608}, {415,0.01476471}, {416,0.01477451}, {417,0.01481373}, {418,0.01478431}, {419,0.01482353}, {420,0.01570588}, {421,0.01487255}, {422,0.01487255}, {423,0.01489216}, {424,0.01582353}, {425,0.01493137}, {426,0.01497059}, {427,0.01502941}, {428,0.01596078}, {429,0.01500000}, {430,0.01501961}, {431,0.01503922}, {432,0.01611765}, {433,0.01511765}, {434,0.01513725}, {435,0.01517647}, {436,0.01635294}, {437,0.01534314}, {438,0.01542157}, {439,0.01555882}, {440,0.01671569}, {441,0.01558824}, {442,0.01571569}, {443,0.01569608}, {444,0.01679412}, {445,0.01576471}, {446,0.01576471}, {447,0.01583333}, {448,0.01684314}, {449,0.01583333}, {450,0.01585294}, {451,0.01588235}, {452,0.01690196}, {453,0.01595098}, {454,0.01597059}, {455,0.01599020}, {456,0.01698039}, {457,0.01602941}, {458,0.01605882}, {459,0.01606863}, {460,0.01722549}, {461,0.01613725}, {462,0.01615686}, {463,0.01624510}, {464,0.01727451}, {465,0.01636275}, {466,0.01644118}, {467,0.01654902}, {468,0.01729412}, {469,0.01660784}, {470,0.01665686}, {471,0.01674510}, {472,0.01673529}, {473,0.01679412}, {474,0.01683333}, {475,0.01786275}, {476,0.01686275}, {477,0.01686275}, {478,0.01688235}, {479,0.01785294}, {480,0.01693137}, {481,0.01695098}, {482,0.01695098}, {483,0.01778431}, {484,0.01702941}, {485,0.01703922}, {486,0.01830392}, {487,0.01704902}, {488,0.01714706}, {489,0.01712745}, {490,0.01835294}, {491,0.01729412}, {492,0.01733333}, {493,0.01746078}, {494,0.01750000}, {495,0.01751961}, {496,0.01756863}, {497,0.01924510}, {498,0.01769608}, {499,0.01771569}, {500,0.01777451}, {505,0.01880392}, {510,0.01795098}, {515,0.01807843}, {520,0.01959804}, {525,0.01863725}, {530,0.01876471}, {535,0.01887255}, {540,0.01899020}, {545,0.01922549}, {550,0.01948039}, {555,0.02137255}, {560,0.01983333}, {565,0.01990196}, {570,0.02138235}, {575,0.02035294}, {580,0.02060784}, {585,0.02183333}, {590,0.02086275}, {595,0.02092157}, {600,0.02256863}, {605,0.02149020}, {610,0.02167647}, {615,0.02286275}, {620,0.02190196}, {625,0.02206863}, {630,0.02354902}, {635,0.02255882}, {640,0.02274510}, {645,0.02384314}, {650,0.02292157}, {655,0.02312745}, {660,0.02349020}, {665,0.02367647}, {670,0.02501961}, {675,0.02385294}, {680,0.02400980}, {685,0.02563725}, {690,0.02459804}, {695,0.02475490}, {700,0.02482353}, {705,0.02491176}, {710,0.02664706}, {715,0.02536275}, {720,0.02561765}, {725,0.02581373}, {730,0.02584314}, {735,0.02746078}, {740,0.02621569}, {745,0.02655882}, {750,0.02668627}, {755,0.02679412}, {760,0.02821569}, {765,0.02706863}, {770,0.02874510}, {775,0.02760784}, {780,0.02775490}, {785,0.02785294}, {790,0.02793137}, {795,0.02955882}, {800,0.02844118}, {805,0.02987255}, {810,0.02876471}, {815,0.03046078}, {820,0.02903922}, {825,0.02923529}, {830,0.02953922}, {835,0.02971569}, {840,0.02984314}, {845,0.02998039}, {850,0.03248039}, {855,0.03037255}, {860,0.03186275}, {865,0.03075490}, {870,0.03237255}, {875,0.03100000}, {880,0.03273529}, {885,0.03152941}, {890,0.03304902}, {895,0.03178431}, {900,0.03343137}, {905,0.03211765}, {910,0.03386275}, {915,0.03257843}, {920,0.03424510}, {925,0.03284314}, {930,0.03456863}, {935,0.03324510}, {940,0.03488235}, {945,0.03362745}, {950,0.03524510}, {955,0.03390196}, {960,0.03546078}, {965,0.03430392}, {970,0.03455882}, {975,0.03472549}, {980,0.03487255}, {985,0.03688235}, {990,0.03522549}, {995,0.03709804}, {1000,0.03567647}, {1010,0.03747059}, {1020,0.03633333}, {1030,0.03796078}, {1040,0.03703922}, {1050,0.03741176}, {1060,0.04038235}, {1070,0.03809804}, {1080,0.04006863}, {1090,0.03886275}, {1100,0.03920588}, {1110,0.04154902}, {1120,0.03988235}, {1130,0.04183333}, {1140,0.04262745}, {1150,0.04100980}, {1160,0.04300980}, {1170,0.04163725}, {1180,0.04206863}, {1190,0.04454902}, {1200,0.04279412}, {1210,0.04321569}, {1220,0.04621569}, {1230,0.04392157}, {1240,0.04415686}, {1250,0.04654902}, {1260,0.04713725}, {1270,0.04532353}, {1280,0.04746078}, {1290,0.04806863}, {1300,0.04643137}, {1310,0.04673529}, {1320,0.05007843}, {1330,0.04970588}, {1340,0.04792157}, {1350,0.04994118}, {1360,0.05063725}, {1370,0.05136275}, {1380,0.04932353}, {1390,0.05148039}, {1400,0.05200000}, {1410,0.05261765}, {1420,0.05064706}, {1430,0.05104902}, {1440,0.05347059}, {1450,0.05405882}, {1460,0.05450000}, {1470,0.05246078}, {1480,0.05281373}, {1490,0.05578431}, {1500,0.05583333}, {1510,0.05642157}, {1520,0.05782353}, {1530,0.05468627}, {1540,0.05500000}, {1550,0.05918627}, {1560,0.05784314}, {1570,0.05847059}, {1580,0.05898039}, {1590,0.06018627}, {1600,0.05726471}, {1610,0.05756863}, {1620,0.05991176}, {1630,0.06025490}, {1640,0.06071569}, {1650,0.06122549}, {1660,0.06175490}, {1670,0.06221569}, {1680,0.06265686}, {1690,0.06308824}, {1700,0.06630392}, {1710,0.06114706}, {1720,0.06147059}, {1730,0.06184314}, {1740,0.06227451}, {1750,0.06231373}, {1760,0.06512745}, {1770,0.06543137}, {1780,0.06579412}, {1790,0.06614706}, {1800,0.06655882}, {1810,0.06679412}, {1820,0.06720588}, {1830,0.06759804}, {1840,0.06797059}, {1850,0.06838235}, {1860,0.06871569}, {1870,0.06900980}, {1880,0.06938235}, {1890,0.06954902}, {1900,0.06802941}, {1910,0.06836275}, {1920,0.06866667}, {1930,0.07602941}, {1940,0.07285294}, {1950,0.07283333}, {1960,0.07309804}, {1970,0.07343137}, {1980,0.07371569}, {1990,0.07394118}, {2000,0.07408824}, {2050,0.07578431}, {2100,0.07751961}, {2150,0.07917647}, {2200,0.08205882}, {2250,0.08353922}, {2300,0.08525490}, {2350,0.08644118}, {2400,0.09340196}, {2450,0.09084314}, {2500,0.09300980}, {2550,0.09488235}, {2600,0.09624510}, {2650,0.10065686}, {2700,0.10007843}, {2750,0.10111765}, {2800,0.10380392}, {2850,0.10625490}, {2900,0.10737255}, {2950,0.11229412}, {3000,0.11163725}, {3050,0.11305882}, {3100,0.11608824}, {3150,0.11696078}, {3200,0.11918627}, {3250,0.12082353}, {3300,0.12321569}, {3350,0.12454902}, {3400,0.12641176}, {3450,0.12846078}, {3500,0.13041176}, {3550,0.13239216}, {3600,0.13427451}, {3650,0.13619608}, {3700,0.13801961}, {3750,0.13980392}, {3800,0.14157843}, {3850,0.14333333}, {3900,0.14500980}, {3950,0.14675490}, {4000,0.14867647}, {4050,0.15335294}, {4100,0.15815686}, {4150,0.15441176}, {4200,0.15414706}, {4250,0.15878431}, {4300,0.16001961}, {4350,0.15912745}, {4400,0.16473529}, {4450,0.16526471}, {4500,0.16683333}, {4550,0.16913725}, {4600,0.16916667}, {4650,0.17263725}, {4700,0.17573529}, {4750,0.17639216}, {4800,0.17910784}, {4850,0.18049020}, {4900,0.18196078}, {4950,0.18540196}, {5000,0.18626471}, {5050,0.18796078}, {5100,0.18942157}, {5150,0.19235294}, {5200,0.19028431}, {5250,0.19479412}, {5300,0.18948039}, {5350,0.19837255}, {5400,0.20035294}, {5450,0.20205882}, {5500,0.20365686}, {5550,0.20590196}, {5600,0.20703922}, {5650,0.20892157}, {5700,0.21055882}, {5750,0.21256863}, {5800,0.21236275}, {5850,0.21757843}, {5900,0.21921569}, {5950,0.22061765}, {6000,0.22586275}, {6050,0.24421569}, {6100,0.23581373}, {6150,0.22861765}, {6200,0.24011765}, {6250,0.23347059}, {6300,0.23180392}, {6350,0.23688235}, {6400,0.24773529}, {6450,0.24054902}, {6500,0.24269608}, {6550,0.24417647}, {6600,0.24339216}, {6650,0.24761765}, {6700,0.25114706}, {6750,0.24922549}, {6800,0.25344118}, {6850,0.25681373}, {6900,0.25780392}, {6950,0.26000000}, {7000,0.26194118}, {7050,0.26700000}, {7100,0.26554902}, {7150,0.26708824}, {7200,0.27299020}, {7250,0.27066667}, {7300,0.26802941}, {7350,0.27034314}, {7400,0.27271569}, {7450,0.27736275}, {7500,0.27919608}, {7550,0.28261765}, {7600,0.30039216}, {7650,0.28553922}, {7700,0.28500980}, {7750,0.28478431}, {7800,0.29006863}, {7850,0.29234314}, {7900,0.29252941}, {7950,0.29248039}, {8000,0.29840196}, {8050,0.29895098}, {8100,0.31402941}, {8150,0.29134314}, {8200,0.30184314}, {8250,0.31146078}, {8300,0.31363725}, {8350,0.31525490}, {8400,0.31661765}, {8450,0.31333333}, {8500,0.31580392}, {8550,0.31606863}, {8600,0.31664706}, {8650,0.32327451}, {8700,0.32348039}, {8750,0.34131373}, {8800,0.32235294}, {8850,0.33104902}, {8900,0.33157843}, {8950,0.33702941}, {9000,0.32978431}, {9050,0.33189216}, {9100,0.33386275}, {9150,0.33751961}, {9200,0.33685294}, {9250,0.34000000}, {9300,0.34151961}, {9350,0.34225490}, {9400,0.35372549}, {9450,0.35165686}, {9500,0.36894118}, {9550,0.35279412}, {9600,0.35273529}, {9650,0.35851961}, {9700,0.38384314}, {9750,0.36301961}, {9800,0.35956863}, {9850,0.37415686}, {9900,0.36790196}, {9950,0.37389216}, {10000,0.36712745}, {10100,0.37347059}, {10200,0.37424510}, {10300,0.39416667}, {10400,0.38722549}, {10500,0.37597059}, {10600,0.40346078}, {10700,0.39388235}, {10800,0.41020588}, {10900,0.40550000}, {11000,0.40879412}, {11100,0.43690196}, {11200,0.41742157}, {11300,0.41383333}, {11400,0.42228431}, {11500,0.42821569}, {11600,0.43387255}, {11700,0.43460784}, {11800,0.44000000}, {11900,0.44366667}, {12000,0.46179412}, {12100,0.44328431}, {12200,0.44334314}, {12300,0.47849020}, {12400,0.45429412}, {12500,0.46394118}, {12600,0.45894118}, {12700,0.47263725}, {12800,0.48664706}, {12900,0.48978431}, {13000,0.48373529}, {13100,0.47658824}, {13200,0.48971569}, {13300,0.50326471}, {13400,0.49306863}, {13500,0.48565686}, {13600,0.50869608}, {13700,0.51023529}, {13800,0.51569608}, {13900,0.51967647}, {14000,0.52437255}, {14100,0.51921569}, {14200,0.52870588}, {14300,0.52706863}, {14400,0.53839216}, {14500,0.54078431}, {14600,0.54051961}, {14700,0.54274510}, {14800,0.54845098}, {14900,0.55532353}, {15000,0.56026471}, {15100,0.56971569}, {15200,0.56832353}, {15300,0.56577451}, {15400,0.56737255}, {15500,0.57912745}, {15600,0.59263725}, {15700,0.58584314}, {15800,0.58004902}, {15900,0.61071569}, {16000,0.58918627}, {16100,0.59200980}, {16200,0.61181373}, {16300,0.60722549}, {16400,0.60613725}, {16500,0.60734314}, {16600,0.61236275}, {16700,0.61938235}, {16800,0.62653922}, {16900,0.63208824}, {17000,0.65996078}, {17100,0.62316667}, {17200,0.64176471}, {17300,0.63800980}, {17400,0.64429412}, {17500,0.64597059}, {17600,0.65527451}, {17700,0.65059804}, {17800,0.65006863}, {17900,0.68454902}, {18000,0.65678431}, {18100,0.66103922}, {18200,0.66757843}, {18300,0.67456863}, {18400,0.67699020}, {18500,0.68106863}, {18600,0.68563725}, {18700,0.70736275}, {18800,0.70067647}, {18900,0.70745098}, {19000,0.73990196}, {19100,0.71074510}, {19200,0.70738235}, {19300,0.71332353}, {19400,0.74572549}, {19500,0.73527451}, {19600,0.70597059}, {19700,0.73584314}, {19800,0.77751961}, {19900,0.73787255}, {20000,0.73441176}};
data["big_flat"]["Ltac2LowLevel"]["reif"]["user"] = {{1,0.00000000}, {2,0.00006863}, {3,0.00017647}, {4,0.00040196}, {5,0.00025490}, {6,0.00025490}, {7,0.00041176}, {8,0.00041176}, {9,0.00044118}, {10,0.00045098}, {11,0.00058824}, {12,0.00060784}, {13,0.00055882}, {14,0.00064706}, {15,0.00056863}, {16,0.00091176}, {17,0.00050980}, {18,0.00081373}, {19,0.00065686}, {20,0.00082353}, {21,0.00075490}, {22,0.00083333}, {23,0.00065686}, {24,0.00092157}, {25,0.00087255}, {26,0.01738235}, {27,0.00100000}, {28,0.00116667}, {29,0.00083333}, {30,0.00107843}, {31,0.00120588}, {32,0.00111765}, {33,0.00121569}, {34,0.00127451}, {35,0.00124510}, {36,0.00128431}, {37,0.00158824}, {38,0.00118627}, {39,0.00150000}, {40,0.00160784}, {41,0.00171569}, {42,0.00142157}, {43,0.00151961}, {44,0.00156863}, {45,0.00147059}, {46,0.00182353}, {47,0.00158824}, {48,0.00183333}, {49,0.00166667}, {50,0.00173529}, {51,0.00178431}, {52,0.00190196}, {53,0.00182353}, {54,0.00191176}, {55,0.00209804}, {56,0.00201961}, {57,0.00210784}, {58,0.00287255}, {59,0.00201961}, {60,0.00212745}, {61,0.00226471}, {62,0.00227451}, {63,0.00217647}, {64,0.00212745}, {65,0.00227451}, {66,0.00210784}, {67,0.00189216}, {68,0.00202941}, {69,0.00221569}, {70,0.00230392}, {71,0.00251961}, {72,0.00263725}, {73,0.00270588}, {74,0.00261765}, {75,0.00250980}, {76,0.00267647}, {77,0.00256863}, {78,0.00265686}, {79,0.00290196}, {80,0.00349020}, {81,0.00268627}, {82,0.00280392}, {83,0.00285294}, {84,0.00308824}, {85,0.00301961}, {86,0.00288235}, {87,0.00291176}, {88,0.00319608}, {89,0.00290196}, {90,0.00297059}, {91,0.00301961}, {92,0.00308824}, {93,0.00307843}, {94,0.00319608}, {95,0.00320588}, {96,0.00349020}, {97,0.00333333}, {98,0.00395098}, {99,0.00329412}, {100,0.00340196}, {101,0.00347059}, {102,0.00340196}, {103,0.00361765}, {104,0.00348039}, {105,0.00363725}, {106,0.00354902}, {107,0.00378431}, {108,0.00376471}, {109,0.00380392}, {110,0.00380392}, {111,0.00385294}, {112,0.00391176}, {113,0.00466667}, {114,0.00385294}, {115,0.00390196}, {116,0.00401961}, {117,0.00418627}, {118,0.00391176}, {119,0.00408824}, {120,0.00394118}, {121,0.00393137}, {122,0.00410784}, {123,0.00387255}, {124,0.00413725}, {125,0.00415686}, {126,0.00426471}, {127,0.00492157}, {128,0.00443137}, {129,0.00428431}, {130,0.00440196}, {131,0.00428431}, {132,0.00450980}, {133,0.00459804}, {134,0.00435294}, {135,0.00470588}, {136,0.00479412}, {137,0.00431373}, {138,0.00457843}, {139,0.00520588}, {140,0.00486275}, {141,0.00495098}, {142,0.00491176}, {143,0.00475490}, {144,0.00479412}, {145,0.00446078}, {146,0.00447059}, {147,0.00472549}, {148,0.00471569}, {149,0.00478431}, {150,0.00480392}, {151,0.00508824}, {152,0.00522549}, {153,0.00541176}, {154,0.00540196}, {155,0.00550000}, {156,0.00556863}, {157,0.00559804}, {158,0.00528431}, {159,0.00514706}, {160,0.00514706}, {161,0.00537255}, {162,0.00548039}, {163,0.00564706}, {164,0.00540196}, {165,0.00537255}, {166,0.00544118}, {167,0.00549020}, {168,0.00582353}, {169,0.00580392}, {170,0.00536275}, {171,0.00554902}, {172,0.00589216}, {173,0.00565686}, {174,0.00585294}, {175,0.00593137}, {176,0.00592157}, {177,0.00593137}, {178,0.00602941}, {179,0.00583333}, {180,0.00589216}, {181,0.00675490}, {182,0.00609804}, {183,0.00644118}, {184,0.00621569}, {185,0.00604902}, {186,0.00612745}, {187,0.00617647}, {188,0.00640196}, {189,0.00644118}, {190,0.00702941}, {191,0.00623529}, {192,0.00637255}, {193,0.00640196}, {194,0.00668627}, {195,0.00638235}, {196,0.00669608}, {197,0.00640196}, {198,0.00657843}, {199,0.00736275}, {200,0.00646078}, {201,0.00650000}, {202,0.00652941}, {203,0.00669608}, {204,0.00656863}, {205,0.00681373}, {206,0.00703922}, {207,0.00687255}, {208,0.00668627}, {209,0.00686275}, {210,0.00700000}, {211,0.00702941}, {212,0.00706863}, {213,0.00703922}, {214,0.00715686}, {215,0.00726471}, {216,0.00724510}, {217,0.00730392}, {218,0.00728431}, {219,0.00722549}, {220,0.00747059}, {221,0.00754902}, {222,0.00732353}, {223,0.00831373}, {224,0.00741176}, {225,0.00735294}, {226,0.00753922}, {227,0.00768627}, {228,0.00759804}, {229,0.00768627}, {230,0.00779412}, {231,0.00901961}, {232,0.00770588}, {233,0.00772549}, {234,0.00789216}, {235,0.00775490}, {236,0.00794118}, {237,0.00789216}, {238,0.00901961}, {239,0.00796078}, {240,0.00792157}, {241,0.00819608}, {242,0.00835294}, {243,0.00809804}, {244,0.00811765}, {245,0.00832353}, {246,0.00832353}, {247,0.00876471}, {248,0.00870588}, {249,0.00881373}, {250,0.00870588}, {251,0.00839216}, {252,0.00854902}, {253,0.00888235}, {254,0.00851961}, {255,0.00839216}, {256,0.00859804}, {257,0.00880392}, {258,0.00887255}, {259,0.00989216}, {260,0.00919608}, {261,0.00881373}, {262,0.00878431}, {263,0.00912745}, {264,0.00938235}, {265,0.00895098}, {266,0.01030392}, {267,0.00902941}, {268,0.00926471}, {269,0.00956863}, {270,0.00915686}, {271,0.00900000}, {272,0.01043137}, {273,0.00946078}, {274,0.00961765}, {275,0.00957843}, {276,0.00991176}, {277,0.00941176}, {278,0.01027451}, {279,0.00959804}, {280,0.01009804}, {281,0.00970588}, {282,0.00982353}, {283,0.01008824}, {284,0.00977451}, {285,0.01150000}, {286,0.01006863}, {287,0.00995098}, {288,0.01013725}, {289,0.01008824}, {290,0.01049020}, {291,0.01123529}, {292,0.01018627}, {293,0.01041176}, {294,0.01006863}, {295,0.01049020}, {296,0.01047059}, {297,0.01141176}, {298,0.01053922}, {299,0.01081373}, {300,0.01092157}, {301,0.01030392}, {302,0.01054902}, {303,0.01085294}, {304,0.01127451}, {305,0.01066667}, {306,0.01098039}, {307,0.01069608}, {308,0.01249020}, {309,0.01085294}, {310,0.01113725}, {311,0.01098039}, {312,0.01096078}, {313,0.01153922}, {314,0.01195098}, {315,0.01162745}, {316,0.01100000}, {317,0.01146078}, {318,0.01114706}, {319,0.01152941}, {320,0.01154902}, {321,0.01147059}, {322,0.01152941}, {323,0.01162745}, {324,0.01147059}, {325,0.01252941}, {326,0.01173529}, {327,0.01168627}, {328,0.01173529}, {329,0.01177451}, {330,0.01278431}, {331,0.01186275}, {332,0.01199020}, {333,0.01197059}, {334,0.01200000}, {335,0.01204902}, {336,0.01200980}, {337,0.01222549}, {338,0.01194118}, {339,0.01223529}, {340,0.01221569}, {341,0.01319608}, {342,0.01214706}, {343,0.01235294}, {344,0.01244118}, {345,0.01262745}, {346,0.01284314}, {347,0.01250980}, {348,0.01244118}, {349,0.01249020}, {350,0.01266667}, {351,0.01312745}, {352,0.01260784}, {353,0.01287255}, {354,0.01221569}, {355,0.01299020}, {356,0.01333333}, {357,0.01306863}, {358,0.01287255}, {359,0.01279412}, {360,0.01292157}, {361,0.01350000}, {362,0.01290196}, {363,0.01283333}, {364,0.01307843}, {365,0.01289216}, {366,0.01391176}, {367,0.01293137}, {368,0.01347059}, {369,0.01318627}, {370,0.01308824}, {371,0.01335294}, {372,0.01333333}, {373,0.01343137}, {374,0.01321569}, {375,0.01400980}, {376,0.01349020}, {377,0.01339216}, {378,0.01328431}, {379,0.01337255}, {380,0.01437255}, {381,0.01340196}, {382,0.01393137}, {383,0.01358824}, {384,0.01327451}, {385,0.01372549}, {386,0.01384314}, {387,0.01351961}, {388,0.01378431}, {389,0.01459804}, {390,0.01375490}, {391,0.01403922}, {392,0.01384314}, {393,0.01374510}, {394,0.01404902}, {395,0.01391176}, {396,0.01384314}, {397,0.01405882}, {398,0.01493137}, {399,0.01424510}, {400,0.01406863}, {401,0.01434314}, {402,0.01425490}, {403,0.01427451}, {404,0.01442157}, {405,0.01428431}, {406,0.01435294}, {407,0.01496078}, {408,0.01429412}, {409,0.01436275}, {410,0.01434314}, {411,0.01540196}, {412,0.01451961}, {413,0.01457843}, {414,0.01473529}, {415,0.01470588}, {416,0.01498039}, {417,0.01500980}, {418,0.01498039}, {419,0.01489216}, {420,0.01562745}, {421,0.01480392}, {422,0.01478431}, {423,0.01504902}, {424,0.01571569}, {425,0.01492157}, {426,0.01500000}, {427,0.01512745}, {428,0.01594118}, {429,0.01498039}, {430,0.01505882}, {431,0.01507843}, {432,0.01623529}, {433,0.01509804}, {434,0.01514706}, {435,0.01522549}, {436,0.01603922}, {437,0.01530392}, {438,0.01523529}, {439,0.01540196}, {440,0.01647059}, {441,0.01546078}, {442,0.01559804}, {443,0.01563725}, {444,0.01646078}, {445,0.01569608}, {446,0.01580392}, {447,0.01582353}, {448,0.01686275}, {449,0.01579412}, {450,0.01568627}, {451,0.01564706}, {452,0.01682353}, {453,0.01595098}, {454,0.01602941}, {455,0.01590196}, {456,0.01693137}, {457,0.01592157}, {458,0.01600980}, {459,0.01610784}, {460,0.01701961}, {461,0.01609804}, {462,0.01618627}, {463,0.01633333}, {464,0.01709804}, {465,0.01625490}, {466,0.01622549}, {467,0.01647059}, {468,0.01718627}, {469,0.01642157}, {470,0.01653922}, {471,0.01658824}, {472,0.01659804}, {473,0.01653922}, {474,0.01640196}, {475,0.01762745}, {476,0.01655882}, {477,0.01666667}, {478,0.01657843}, {479,0.01778431}, {480,0.01686275}, {481,0.01696078}, {482,0.01694118}, {483,0.01748039}, {484,0.01693137}, {485,0.01698039}, {486,0.01797059}, {487,0.01652941}, {488,0.01673529}, {489,0.01701961}, {490,0.01776471}, {491,0.01698039}, {492,0.01701961}, {493,0.01683333}, {494,0.01736275}, {495,0.01751961}, {496,0.01729412}, {497,0.01908824}, {498,0.01757843}, {499,0.01780392}, {500,0.01768627}, {505,0.01840196}, {510,0.01759804}, {515,0.01833333}, {520,0.01924510}, {525,0.01814706}, {530,0.01819608}, {535,0.01854902}, {540,0.01856863}, {545,0.01869608}, {550,0.01904902}, {555,0.02100980}, {560,0.01953922}, {565,0.01950980}, {570,0.02128431}, {575,0.01984314}, {580,0.02041176}, {585,0.02207843}, {590,0.02074510}, {595,0.02091176}, {600,0.02245098}, {605,0.02131373}, {610,0.02210784}, {615,0.02292157}, {620,0.02221569}, {625,0.02179412}, {630,0.02360784}, {635,0.02242157}, {640,0.02281373}, {645,0.02401961}, {650,0.02332353}, {655,0.02336275}, {660,0.02334314}, {665,0.02371569}, {670,0.02507843}, {675,0.02384314}, {680,0.02428431}, {685,0.02553922}, {690,0.02469608}, {695,0.02468627}, {700,0.02471569}, {705,0.02522549}, {710,0.02625490}, {715,0.02557843}, {720,0.02534314}, {725,0.02585294}, {730,0.02615686}, {735,0.02711765}, {740,0.02629412}, {745,0.02634314}, {750,0.02649020}, {755,0.02683333}, {760,0.02817647}, {765,0.02709804}, {770,0.02906863}, {775,0.02744118}, {780,0.02745098}, {785,0.02762745}, {790,0.02819608}, {795,0.02953922}, {800,0.02833333}, {805,0.03019608}, {810,0.02907843}, {815,0.03046078}, {820,0.02879412}, {825,0.02909804}, {830,0.02944118}, {835,0.02984314}, {840,0.02992157}, {845,0.02989216}, {850,0.03282353}, {855,0.03052941}, {860,0.03199020}, {865,0.03107843}, {870,0.03250980}, {875,0.03136275}, {880,0.03281373}, {885,0.03183333}, {890,0.03323529}, {895,0.03197059}, {900,0.03354902}, {905,0.03256863}, {910,0.03416667}, {915,0.03277451}, {920,0.03441176}, {925,0.03335294}, {930,0.03467647}, {935,0.03326471}, {940,0.03496078}, {945,0.03366667}, {950,0.03518627}, {955,0.03405882}, {960,0.03541176}, {965,0.03429412}, {970,0.03465686}, {975,0.03500000}, {980,0.03491176}, {985,0.03675490}, {990,0.03536275}, {995,0.03668627}, {1000,0.03568627}, {1010,0.03722549}, {1020,0.03628431}, {1030,0.03776471}, {1040,0.03657843}, {1050,0.03715686}, {1060,0.04004902}, {1070,0.03816667}, {1080,0.03936275}, {1090,0.03879412}, {1100,0.03916667}, {1110,0.04127451}, {1120,0.03974510}, {1130,0.04170588}, {1140,0.04293137}, {1150,0.04097059}, {1160,0.04331373}, {1170,0.04168627}, {1180,0.04192157}, {1190,0.04454902}, {1200,0.04293137}, {1210,0.04335294}, {1220,0.04623529}, {1230,0.04396078}, {1240,0.04441176}, {1250,0.04638235}, {1260,0.04704902}, {1270,0.04559804}, {1280,0.04740196}, {1290,0.04770588}, {1300,0.04640196}, {1310,0.04674510}, {1320,0.04974510}, {1330,0.04945098}, {1340,0.04796078}, {1350,0.04951961}, {1360,0.05028431}, {1370,0.05096078}, {1380,0.04899020}, {1390,0.05100000}, {1400,0.05169608}, {1410,0.05255882}, {1420,0.05038235}, {1430,0.05081373}, {1440,0.05307843}, {1450,0.05363725}, {1460,0.05457843}, {1470,0.05249020}, {1480,0.05274510}, {1490,0.05587255}, {1500,0.05569608}, {1510,0.05643137}, {1520,0.05746078}, {1530,0.05448039}, {1540,0.05515686}, {1550,0.05874510}, {1560,0.05780392}, {1570,0.05818627}, {1580,0.05882353}, {1590,0.06030392}, {1600,0.05722549}, {1610,0.05707843}, {1620,0.05963725}, {1630,0.06022549}, {1640,0.06048039}, {1650,0.06114706}, {1660,0.06174510}, {1670,0.06205882}, {1680,0.06287255}, {1690,0.06338235}, {1700,0.06634314}, {1710,0.06137255}, {1720,0.06154902}, {1730,0.06209804}, {1740,0.06255882}, {1750,0.06299020}, {1760,0.06500980}, {1770,0.06515686}, {1780,0.06607843}, {1790,0.06585294}, {1800,0.06633333}, {1810,0.06647059}, {1820,0.06700980}, {1830,0.06734314}, {1840,0.06765686}, {1850,0.06821569}, {1860,0.06875490}, {1870,0.06900000}, {1880,0.06903922}, {1890,0.06948039}, {1900,0.06809804}, {1910,0.06807843}, {1920,0.06814706}, {1930,0.07617647}, {1940,0.07309804}, {1950,0.07288235}, {1960,0.07302941}, {1970,0.07361765}, {1980,0.07417647}, {1990,0.07414706}, {2000,0.07401961}, {2050,0.07585294}, {2100,0.07706863}, {2150,0.07877451}, {2200,0.08163725}, {2250,0.08339216}, {2300,0.08489216}, {2350,0.08659804}, {2400,0.09298039}, {2450,0.09055882}, {2500,0.09259804}, {2550,0.09482353}, {2600,0.09605882}, {2650,0.10047059}, {2700,0.10007843}, {2750,0.10080392}, {2800,0.10331373}, {2850,0.10568627}, {2900,0.10683333}, {2950,0.11206863}, {3000,0.11146078}, {3050,0.11256863}, {3100,0.11542157}, {3150,0.11621569}, {3200,0.11872549}, {3250,0.12050000}, {3300,0.12284314}, {3350,0.12417647}, {3400,0.12620588}, {3450,0.12830392}, {3500,0.13025490}, {3550,0.13215686}, {3600,0.13426471}, {3650,0.13614706}, {3700,0.13727451}, {3750,0.13961765}, {3800,0.14116667}, {3850,0.14327451}, {3900,0.14435294}, {3950,0.14641176}, {4000,0.14851961}, {4050,0.15310784}, {4100,0.15795098}, {4150,0.15377451}, {4200,0.15393137}, {4250,0.15842157}, {4300,0.15998039}, {4350,0.15892157}, {4400,0.16413725}, {4450,0.16487255}, {4500,0.16627451}, {4550,0.16834314}, {4600,0.16863725}, {4650,0.17228431}, {4700,0.17541176}, {4750,0.17610784}, {4800,0.17869608}, {4850,0.17957843}, {4900,0.18180392}, {4950,0.18503922}, {5000,0.18590196}, {5050,0.18770588}, {5100,0.18929412}, {5150,0.19216667}, {5200,0.19025490}, {5250,0.19457843}, {5300,0.18935294}, {5350,0.19830392}, {5400,0.20034314}, {5450,0.20214706}, {5500,0.20343137}, {5550,0.20571569}, {5600,0.20695098}, {5650,0.20899020}, {5700,0.21022549}, {5750,0.21236275}, {5800,0.21225490}, {5850,0.21740196}, {5900,0.21886275}, {5950,0.22017647}, {6000,0.22512745}, {6050,0.24341176}, {6100,0.23545098}, {6150,0.22785294}, {6200,0.23987255}, {6250,0.23321569}, {6300,0.23126471}, {6350,0.23667647}, {6400,0.24587255}, {6450,0.23970588}, {6500,0.24211765}, {6550,0.24340196}, {6600,0.24282353}, {6650,0.24746078}, {6700,0.25034314}, {6750,0.24863725}, {6800,0.25292157}, {6850,0.25637255}, {6900,0.25732353}, {6950,0.25928431}, {7000,0.26116667}, {7050,0.26648039}, {7100,0.26542157}, {7150,0.26696078}, {7200,0.27214706}, {7250,0.27000000}, {7300,0.26768627}, {7350,0.26995098}, {7400,0.27228431}, {7450,0.27700000}, {7500,0.27850980}, {7550,0.28185294}, {7600,0.29914706}, {7650,0.28482353}, {7700,0.28414706}, {7750,0.28401961}, {7800,0.28946078}, {7850,0.29201961}, {7900,0.29194118}, {7950,0.29163725}, {8000,0.29804902}, {8050,0.29852941}, {8100,0.31319608}, {8150,0.29112745}, {8200,0.30125490}, {8250,0.31048039}, {8300,0.31257843}, {8350,0.31493137}, {8400,0.31620588}, {8450,0.31291176}, {8500,0.31492157}, {8550,0.31509804}, {8600,0.31659804}, {8650,0.32277451}, {8700,0.32326471}, {8750,0.34078431}, {8800,0.32200980}, {8850,0.33024510}, {8900,0.33085294}, {8950,0.33649020}, {9000,0.32944118}, {9050,0.33131373}, {9100,0.33329412}, {9150,0.33728431}, {9200,0.33653922}, {9250,0.33966667}, {9300,0.34120588}, {9350,0.34191176}, {9400,0.35372549}, {9450,0.35096078}, {9500,0.36835294}, {9550,0.35204902}, {9600,0.35204902}, {9650,0.35791176}, {9700,0.38363725}, {9750,0.36231373}, {9800,0.35888235}, {9850,0.37358824}, {9900,0.36742157}, {9950,0.37339216}, {10000,0.36652941}, {10100,0.37288235}, {10200,0.37360784}, {10300,0.39381373}, {10400,0.38677451}, {10500,0.37553922}, {10600,0.40325490}, {10700,0.39341176}, {10800,0.40976471}, {10900,0.40515686}, {11000,0.40869608}, {11100,0.43642157}, {11200,0.41670588}, {11300,0.41367647}, {11400,0.42197059}, {11500,0.42790196}, {11600,0.43341176}, {11700,0.43412745}, {11800,0.43962745}, {11900,0.44329412}, {12000,0.46118627}, {12100,0.44259804}, {12200,0.44257843}, {12300,0.47823529}, {12400,0.45382353}, {12500,0.46310784}, {12600,0.45840196}, {12700,0.47213725}, {12800,0.48593137}, {12900,0.48895098}, {13000,0.48288235}, {13100,0.47574510}, {13200,0.48929412}, {13300,0.50268627}, {13400,0.49238235}, {13500,0.48522549}, {13600,0.50828431}, {13700,0.51014706}, {13800,0.51521569}, {13900,0.51912745}, {14000,0.52400000}, {14100,0.51851961}, {14200,0.52830392}, {14300,0.52642157}, {14400,0.53774510}, {14500,0.54030392}, {14600,0.54008824}, {14700,0.54245098}, {14800,0.54782353}, {14900,0.55501961}, {15000,0.55978431}, {15100,0.56887255}, {15200,0.56772549}, {15300,0.56500980}, {15400,0.56677451}, {15500,0.57846078}, {15600,0.59189216}, {15700,0.58523529}, {15800,0.57932353}, {15900,0.61002941}, {16000,0.58864706}, {16100,0.59119608}, {16200,0.61097059}, {16300,0.60667647}, {16400,0.60553922}, {16500,0.60678431}, {16600,0.61179412}, {16700,0.61857843}, {16800,0.62600000}, {16900,0.63156863}, {17000,0.65938235}, {17100,0.62276471}, {17200,0.64163725}, {17300,0.63698039}, {17400,0.64362745}, {17500,0.64534314}, {17600,0.65470588}, {17700,0.64960784}, {17800,0.64945098}, {17900,0.68354902}, {18000,0.65632353}, {18100,0.66024510}, {18200,0.66687255}, {18300,0.67387255}, {18400,0.67623529}, {18500,0.68034314}, {18600,0.68505882}, {18700,0.70674510}, {18800,0.70010784}, {18900,0.70653922}, {19000,0.73869608}, {19100,0.71016667}, {19200,0.70656863}, {19300,0.71257843}, {19400,0.74520588}, {19500,0.73409804}, {19600,0.70555882}, {19700,0.73478431}, {19800,0.77718627}, {19900,0.73691176}, {20000,0.73343137}};
data["big_flat"]["Ltac2LowLevel"]["reif"]["system"] = {{1,0.00011765}, {2,0.00003922}, {3,0.00003922}, {4,0.00003922}, {5,0.00000000}, {6,0.00000000}, {7,0.00007843}, {8,0.00000000}, {9,0.00000000}, {10,0.00003922}, {11,0.00003922}, {12,0.00000000}, {13,0.00000000}, {14,0.00003922}, {15,0.00000000}, {16,0.00000000}, {17,0.00003922}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00003922}, {24,0.00010784}, {25,0.00000000}, {26,0.00022549}, {27,0.00000000}, {28,0.00007843}, {29,0.00003922}, {30,0.00000000}, {31,0.00003922}, {32,0.00003922}, {33,0.00000000}, {34,0.00003922}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003922}, {42,0.00000000}, {43,0.00007843}, {44,0.00003922}, {45,0.00000000}, {46,0.00003922}, {47,0.00000000}, {48,0.00002941}, {49,0.00003922}, {50,0.00003922}, {51,0.00000000}, {52,0.00000000}, {53,0.00003922}, {54,0.00000000}, {55,0.00000000}, {56,0.00003922}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00003922}, {61,0.00000000}, {62,0.00000000}, {63,0.00002941}, {64,0.00000000}, {65,0.00000000}, {66,0.00003922}, {67,0.00003922}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00002941}, {73,0.00000000}, {74,0.00003922}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00007843}, {80,0.00003922}, {81,0.00003922}, {82,0.00003922}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00003922}, {87,0.00007843}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00011765}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00003922}, {100,0.00000000}, {101,0.00002941}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00002941}, {117,0.00003922}, {118,0.00000000}, {119,0.00000000}, {120,0.00002941}, {121,0.00002941}, {122,0.00000000}, {123,0.00006863}, {124,0.00003922}, {125,0.00003922}, {126,0.00000000}, {127,0.00000000}, {128,0.00003922}, {129,0.00000000}, {130,0.00000000}, {131,0.00006863}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00003922}, {138,0.00003922}, {139,0.00003922}, {140,0.00003922}, {141,0.00000000}, {142,0.00003922}, {143,0.00000000}, {144,0.00000000}, {145,0.00003922}, {146,0.00007843}, {147,0.00000000}, {148,0.00003922}, {149,0.00000000}, {150,0.00000000}, {151,0.00003922}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00003922}, {156,0.00000000}, {157,0.00000000}, {158,0.00003922}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00003922}, {163,0.00000000}, {164,0.00007843}, {165,0.00003922}, {166,0.00000000}, {167,0.00002941}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00003922}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00007843}, {179,0.00007843}, {180,0.00000000}, {181,0.00011765}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00003922}, {189,0.00000000}, {190,0.00002941}, {191,0.00003922}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00003922}, {199,0.00003922}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00002941}, {204,0.00002941}, {205,0.00000000}, {206,0.00003922}, {207,0.00000000}, {208,0.00000000}, {209,0.00003922}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00006863}, {225,0.00000000}, {226,0.00000000}, {227,0.00003922}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00011765}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00007843}, {238,0.00006863}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00003922}, {246,0.00003922}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00003922}, {252,0.00000000}, {253,0.00003922}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00003922}, {258,0.00000000}, {259,0.00003922}, {260,0.00000000}, {261,0.00000000}, {262,0.00003922}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00003922}, {271,0.00000000}, {272,0.00003922}, {273,0.00000000}, {274,0.00002941}, {275,0.00000000}, {276,0.00003922}, {277,0.00000000}, {278,0.00003922}, {279,0.00000000}, {280,0.00000000}, {281,0.00007843}, {282,0.00003922}, {283,0.00000000}, {284,0.00003922}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00003922}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00003922}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00003922}, {306,0.00000000}, {307,0.00000000}, {308,0.00003922}, {309,0.00006863}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00003922}, {314,0.00000000}, {315,0.00000000}, {316,0.00003922}, {317,0.00000000}, {318,0.00003922}, {319,0.00000000}, {320,0.00003922}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00003922}, {326,0.00000000}, {327,0.00003922}, {328,0.00003922}, {329,0.00007843}, {330,0.00003922}, {331,0.00000000}, {332,0.00003922}, {333,0.00003922}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00003922}, {341,0.00002941}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00003922}, {346,0.00006863}, {347,0.00000000}, {348,0.00000000}, {349,0.00002941}, {350,0.00003922}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00007843}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00003922}, {361,0.00003922}, {362,0.00000000}, {363,0.00003922}, {364,0.00000000}, {365,0.00000000}, {366,0.00003922}, {367,0.00000000}, {368,0.00003922}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00003922}, {373,0.00000000}, {374,0.00002941}, {375,0.00011765}, {376,0.00007843}, {377,0.00000000}, {378,0.00000000}, {379,0.00003922}, {380,0.00003922}, {381,0.00000000}, {382,0.00000000}, {383,0.00003922}, {384,0.00007843}, {385,0.00002941}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00011765}, {390,0.00002941}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00003922}, {395,0.00002941}, {396,0.00007843}, {397,0.00003922}, {398,0.00015686}, {399,0.00000000}, {400,0.00003922}, {401,0.00003922}, {402,0.00000000}, {403,0.00003922}, {404,0.00000000}, {405,0.00007843}, {406,0.00000000}, {407,0.00011765}, {408,0.00002941}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00007843}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00003922}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00003922}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00007843}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00003922}, {436,0.00003922}, {437,0.00007843}, {438,0.00000000}, {439,0.00000000}, {440,0.00002941}, {441,0.00000000}, {442,0.00002941}, {443,0.00000000}, {444,0.00000000}, {445,0.00003922}, {446,0.00003922}, {447,0.00006863}, {448,0.00006863}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00003922}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003922}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00003922}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00003922}, {477,0.00000000}, {478,0.00007843}, {479,0.00000000}, {480,0.00007843}, {481,0.00000000}, {482,0.00003922}, {483,0.00000000}, {484,0.00000000}, {485,0.00007843}, {486,0.00000000}, {487,0.00011765}, {488,0.00000000}, {489,0.00000000}, {490,0.00003922}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00007843}, {498,0.00003922}, {499,0.00000000}, {500,0.00003922}, {505,0.00003922}, {510,0.00007843}, {515,0.00003922}, {520,0.00000000}, {525,0.00007843}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00003922}, {550,0.00003922}, {555,0.00003922}, {560,0.00000000}, {565,0.00003922}, {570,0.00000000}, {575,0.00000000}, {580,0.00003922}, {585,0.00003922}, {590,0.00000000}, {595,0.00003922}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00006863}, {620,0.00000000}, {625,0.00000000}, {630,0.00007843}, {635,0.00007843}, {640,0.00000000}, {645,0.00002941}, {650,0.00000000}, {655,0.00000000}, {660,0.00003922}, {665,0.00000000}, {670,0.00000000}, {675,0.00003922}, {680,0.00000000}, {685,0.00002941}, {690,0.00003922}, {695,0.00000000}, {700,0.00007843}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00003922}, {725,0.00000000}, {730,0.00000000}, {735,0.00003922}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00007843}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00007843}, {800,0.00000000}, {805,0.00006863}, {810,0.00006863}, {815,0.00003922}, {820,0.00003922}, {825,0.00003922}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00006863}, {850,0.00003922}, {855,0.00000000}, {860,0.00003922}, {865,0.00000000}, {870,0.00011765}, {875,0.00003922}, {880,0.00002941}, {885,0.00003922}, {890,0.00002941}, {895,0.00003922}, {900,0.00007843}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00003922}, {925,0.00000000}, {930,0.00000000}, {935,0.00003922}, {940,0.00011765}, {945,0.00003922}, {950,0.00003922}, {955,0.00003922}, {960,0.00011765}, {965,0.00003922}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00011765}, {990,0.00003922}, {995,0.00013725}, {1000,0.00007843}, {1010,0.00007843}, {1020,0.00000000}, {1030,0.00007843}, {1040,0.00000000}, {1050,0.00007843}, {1060,0.00003922}, {1070,0.00000000}, {1080,0.00015686}, {1090,0.00003922}, {1100,0.00007843}, {1110,0.00010784}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00010784}, {1150,0.00007843}, {1160,0.00003922}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00003922}, {1200,0.00003922}, {1210,0.00003922}, {1220,0.00010784}, {1230,0.00003922}, {1240,0.00007843}, {1250,0.00000000}, {1260,0.00003922}, {1270,0.00000000}, {1280,0.00003922}, {1290,0.00003922}, {1300,0.00003922}, {1310,0.00003922}, {1320,0.00007843}, {1330,0.00011765}, {1340,0.00003922}, {1350,0.00003922}, {1360,0.00002941}, {1370,0.00006863}, {1380,0.00000000}, {1390,0.00003922}, {1400,0.00007843}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00011765}, {1450,0.00007843}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003922}, {1490,0.00003922}, {1500,0.00003922}, {1510,0.00007843}, {1520,0.00008824}, {1530,0.00007843}, {1540,0.00003922}, {1550,0.00015686}, {1560,0.00011765}, {1570,0.00018627}, {1580,0.00007843}, {1590,0.00007843}, {1600,0.00003922}, {1610,0.00013725}, {1620,0.00011765}, {1630,0.00006863}, {1640,0.00007843}, {1650,0.00003922}, {1660,0.00003922}, {1670,0.00018627}, {1680,0.00031373}, {1690,0.00003922}, {1700,0.00015686}, {1710,0.00000000}, {1720,0.00010784}, {1730,0.00007843}, {1740,0.00000000}, {1750,0.00003922}, {1760,0.00018627}, {1770,0.00023529}, {1780,0.00003922}, {1790,0.00015686}, {1800,0.00015686}, {1810,0.00006863}, {1820,0.00015686}, {1830,0.00015686}, {1840,0.00003922}, {1850,0.00007843}, {1860,0.00007843}, {1870,0.00003922}, {1880,0.00007843}, {1890,0.00011765}, {1900,0.00003922}, {1910,0.00007843}, {1920,0.00011765}, {1930,0.00000000}, {1940,0.00003922}, {1950,0.00000000}, {1960,0.00019608}, {1970,0.00000000}, {1980,0.00015686}, {1990,0.00003922}, {2000,0.00007843}, {2050,0.00003922}, {2100,0.00021569}, {2150,0.00007843}, {2200,0.00015686}, {2250,0.00013725}, {2300,0.00011765}, {2350,0.00003922}, {2400,0.00034314}, {2450,0.00011765}, {2500,0.00003922}, {2550,0.00018627}, {2600,0.00011765}, {2650,0.00003922}, {2700,0.00007843}, {2750,0.00011765}, {2800,0.00011765}, {2850,0.00014706}, {2900,0.00011765}, {2950,0.00029412}, {3000,0.00011765}, {3050,0.00015686}, {3100,0.00019608}, {3150,0.00022549}, {3200,0.00019608}, {3250,0.00014706}, {3300,0.00014706}, {3350,0.00010784}, {3400,0.00019608}, {3450,0.00014706}, {3500,0.00006863}, {3550,0.00011765}, {3600,0.00007843}, {3650,0.00019608}, {3700,0.00014706}, {3750,0.00000000}, {3800,0.00018627}, {3850,0.00014706}, {3900,0.00027451}, {3950,0.00019608}, {4000,0.00018627}, {4050,0.00015686}, {4100,0.00031373}, {4150,0.00026471}, {4200,0.00007843}, {4250,0.00027451}, {4300,0.00011765}, {4350,0.00007843}, {4400,0.00027451}, {4450,0.00018627}, {4500,0.00026471}, {4550,0.00015686}, {4600,0.00014706}, {4650,0.00015686}, {4700,0.00027451}, {4750,0.00007843}, {4800,0.00026471}, {4850,0.00031373}, {4900,0.00015686}, {4950,0.00011765}, {5000,0.00015686}, {5050,0.00003922}, {5100,0.00003922}, {5150,0.00007843}, {5200,0.00007843}, {5250,0.00007843}, {5300,0.00000000}, {5350,0.00003922}, {5400,0.00003922}, {5450,0.00000000}, {5500,0.00007843}, {5550,0.00000000}, {5600,0.00007843}, {5650,0.00003922}, {5700,0.00003922}, {5750,0.00003922}, {5800,0.00007843}, {5850,0.00007843}, {5900,0.00003922}, {5950,0.00003922}, {6000,0.00010784}, {6050,0.00011765}, {6100,0.00010784}, {6150,0.00007843}, {6200,0.00003922}, {6250,0.00003922}, {6300,0.00000000}, {6350,0.00015686}, {6400,0.00136275}, {6450,0.00043137}, {6500,0.00011765}, {6550,0.00038235}, {6600,0.00003922}, {6650,0.00014706}, {6700,0.00033333}, {6750,0.00019608}, {6800,0.00039216}, {6850,0.00027451}, {6900,0.00030392}, {6950,0.00026471}, {7000,0.00050980}, {7050,0.00021569}, {7100,0.00019608}, {7150,0.00011765}, {7200,0.00043137}, {7250,0.00047059}, {7300,0.00037255}, {7350,0.00033333}, {7400,0.00019608}, {7450,0.00026471}, {7500,0.00030392}, {7550,0.00027451}, {7600,0.00079412}, {7650,0.00031373}, {7700,0.00026471}, {7750,0.00026471}, {7800,0.00050000}, {7850,0.00015686}, {7900,0.00030392}, {7950,0.00023529}, {8000,0.00031373}, {8050,0.00027451}, {8100,0.00043137}, {8150,0.00014706}, {8200,0.00026471}, {8250,0.00050000}, {8300,0.00064706}, {8350,0.00046078}, {8400,0.00039216}, {8450,0.00039216}, {8500,0.00035294}, {8550,0.00058824}, {8600,0.00014706}, {8650,0.00010784}, {8700,0.00003922}, {8750,0.00010784}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00015686}, {8950,0.00019608}, {9000,0.00011765}, {9050,0.00011765}, {9100,0.00007843}, {9150,0.00007843}, {9200,0.00003922}, {9250,0.00003922}, {9300,0.00007843}, {9350,0.00007843}, {9400,0.00000000}, {9450,0.00014706}, {9500,0.00003922}, {9550,0.00011765}, {9600,0.00000000}, {9650,0.00007843}, {9700,0.00007843}, {9750,0.00007843}, {9800,0.00011765}, {9850,0.00018627}, {9900,0.00011765}, {9950,0.00010784}, {10000,0.00007843}, {10100,0.00000000}, {10200,0.00003922}, {10300,0.00014706}, {10400,0.00000000}, {10500,0.00003922}, {10600,0.00000000}, {10700,0.00007843}, {10800,0.00003922}, {10900,0.00000000}, {11000,0.00007843}, {11100,0.00011765}, {11200,0.00007843}, {11300,0.00011765}, {11400,0.00007843}, {11500,0.00000000}, {11600,0.00007843}, {11700,0.00007843}, {11800,0.00011765}, {11900,0.00007843}, {12000,0.00010784}, {12100,0.00011765}, {12200,0.00011765}, {12300,0.00000000}, {12400,0.00002941}, {12500,0.00010784}, {12600,0.00007843}, {12700,0.00007843}, {12800,0.00007843}, {12900,0.00007843}, {13000,0.00003922}, {13100,0.00015686}, {13200,0.00003922}, {13300,0.00000000}, {13400,0.00013725}, {13500,0.00010784}, {13600,0.00003922}, {13700,0.00007843}, {13800,0.00003922}, {13900,0.00003922}, {14000,0.00000000}, {14100,0.00011765}, {14200,0.00006863}, {14300,0.00003922}, {14400,0.00003922}, {14500,0.00002941}, {14600,0.00006863}, {14700,0.00015686}, {14800,0.00007843}, {14900,0.00007843}, {15000,0.00003922}, {15100,0.00011765}, {15200,0.00007843}, {15300,0.00007843}, {15400,0.00011765}, {15500,0.00011765}, {15600,0.00011765}, {15700,0.00010784}, {15800,0.00022549}, {15900,0.00015686}, {16000,0.00003922}, {16100,0.00014706}, {16200,0.00013725}, {16300,0.00003922}, {16400,0.00002941}, {16500,0.00006863}, {16600,0.00011765}, {16700,0.00003922}, {16800,0.00000000}, {16900,0.00015686}, {17000,0.00007843}, {17100,0.00000000}, {17200,0.00007843}, {17300,0.00019608}, {17400,0.00007843}, {17500,0.00007843}, {17600,0.00003922}, {17700,0.00011765}, {17800,0.00003922}, {17900,0.00015686}, {18000,0.00003922}, {18100,0.00014706}, {18200,0.00007843}, {18300,0.00023529}, {18400,0.00015686}, {18500,0.00015686}, {18600,0.00014706}, {18700,0.00011765}, {18800,0.00003922}, {18900,0.00007843}, {19000,0.00018627}, {19100,0.00011765}, {19200,0.00007843}, {19300,0.00006863}, {19400,0.00003922}, {19500,0.00019608}, {19600,0.00015686}, {19700,0.00019608}, {19800,0.00002941}, {19900,0.00011765}, {20000,0.00007843}};
data["big_flat"]["LtacPrimUncurry"]["Aggregate"]["real"] = {{1,0.00100990}, {2,0.00100000}, {3,0.00100000}, {4,0.00100000}, {5,0.00100000}, {6,0.00100990}, {7,0.00107921}, {8,0.00173267}, {9,0.00200000}, {10,0.00200990}, {11,0.00200000}, {12,0.00200000}, {13,0.00201980}, {14,0.00214851}, {15,0.00248515}, {16,0.00300990}, {17,0.00300000}, {18,0.00300000}, {19,0.00300990}, {20,0.00302970}, {21,0.00321782}, {22,0.00337624}, {23,0.00397030}, {24,0.00400000}, {25,0.00400000}, {26,0.00400990}, {27,0.00410891}, {28,0.01200000}, {29,0.00422772}, {30,0.00478218}, {31,0.00500000}, {32,0.00500000}, {33,0.00500000}, {34,0.00509901}, {35,0.00517822}, {36,0.00519802}, {37,0.00556436}, {38,0.00598020}, {39,0.00600990}, {40,0.00604950}, {41,0.00614851}, {42,0.00618812}, {43,0.00632673}, {44,0.00720792}, {45,0.00695050}, {46,0.00700990}, {47,0.00711881}, {48,0.00713861}, {49,0.00718812}, {50,0.00721782}, {51,0.00737624}, {52,0.00762376}, {53,0.00801980}, {54,0.00811881}, {55,0.00826733}, {56,0.00914851}, {57,0.00823762}, {58,0.00829703}, {59,0.00862376}, {60,0.00887129}, {61,0.00915842}, {62,0.00930693}, {63,0.00940594}, {64,0.00920792}, {65,0.00932673}, {66,0.01086139}, {67,0.00986139}, {68,0.01011881}, {69,0.01032673}, {70,0.01022772}, {71,0.01028713}, {72,0.01014851}, {73,0.01039604}, {74,0.01170297}, {75,0.01109901}, {76,0.01120792}, {77,0.01117822}, {78,0.01121782}, {79,0.01143564}, {80,0.01154455}, {81,0.01172277}, {82,0.01667327}, {83,0.01205941}, {84,0.01217822}, {85,0.01223762}, {86,0.01234653}, {87,0.01252475}, {88,0.01256436}, {89,0.01304950}, {90,0.01426733}, {91,0.01324752}, {92,0.01331683}, {93,0.01340594}, {94,0.01356436}, {95,0.01382178}, {96,0.01986139}, {97,0.01389109}, {98,0.01418812}, {99,0.01428713}, {100,0.01434653}, {101,0.01426733}, {102,0.01443564}, {103,0.01672277}, {104,0.01479208}, {105,0.01515842}, {106,0.01534653}, {107,0.01548515}, {108,0.01544554}, {109,0.01735644}, {110,0.01585149}, {111,0.01625743}, {112,0.01618812}, {113,0.01639604}, {114,0.02268317}, {115,0.01627723}, {116,0.01634653}, {117,0.01652475}, {118,0.01688119}, {119,0.01727723}, {120,0.01950495}, {121,0.01729703}, {122,0.01743564}, {123,0.01765347}, {124,0.01764356}, {125,0.02112871}, {126,0.01800990}, {127,0.01822772}, {128,0.01814851}, {129,0.01825743}, {130,0.02151485}, {131,0.01854455}, {132,0.01877228}, {133,0.01902970}, {134,0.01922772}, {135,0.02154455}, {136,0.01925743}, {137,0.01942574}, {138,0.01963366}, {139,0.01991089}, {140,0.02039604}, {141,0.02030693}, {142,0.02051485}, {143,0.02071287}, {144,0.02387129}, {145,0.02055446}, {146,0.02082178}, {147,0.02112871}, {148,0.02212871}, {149,0.02141584}, {150,0.02149505}, {151,0.02163366}, {152,0.02159406}, {153,0.02331683}, {154,0.02196040}, {155,0.02229703}, {156,0.02237624}, {157,0.02509901}, {158,0.02263366}, {159,0.02295050}, {160,0.02272277}, {161,0.02586139}, {162,0.02283168}, {163,0.02340594}, {164,0.02340594}, {165,0.02627723}, {166,0.02358416}, {167,0.02376238}, {168,0.02387129}, {169,0.02598020}, {170,0.02426733}, {171,0.02440594}, {172,0.02447525}, {173,0.02542574}, {174,0.02480198}, {175,0.02511881}, {176,0.03046535}, {177,0.02517822}, {178,0.02561386}, {179,0.02571287}, {180,0.02843564}, {181,0.02573267}, {182,0.02601980}, {183,0.03363366}, {184,0.02575248}, {185,0.02628713}, {186,0.02646535}, {187,0.03014851}, {188,0.02662376}, {189,0.02679208}, {190,0.03382178}, {191,0.02719802}, {192,0.02694059}, {193,0.02747525}, {194,0.02924752}, {195,0.02748515}, {196,0.02760396}, {197,0.03245545}, {198,0.02808911}, {199,0.02835644}, {200,0.03532673}, {201,0.02839604}, {202,0.02858416}, {203,0.02882178}, {204,0.02965347}, {205,0.02917822}, {206,0.02934653}, {207,0.03111881}, {208,0.02941584}, {209,0.02953465}, {210,0.03262376}, {211,0.02998020}, {212,0.03009901}, {213,0.03387129}, {214,0.03038614}, {215,0.03076238}, {216,0.03445545}, {217,0.03076238}, {218,0.03099010}, {219,0.03509901}, {220,0.03128713}, {221,0.03172277}, {222,0.03492079}, {223,0.03203960}, {224,0.03169307}, {225,0.03420792}, {226,0.03167327}, {227,0.03201980}, {228,0.03353465}, {229,0.03262376}, {230,0.03419802}, {231,0.03314851}, {232,0.03320792}, {233,0.04092079}, {234,0.03305941}, {235,0.03363366}, {236,0.03928713}, {237,0.03354455}, {238,0.03373267}, {239,0.03696040}, {240,0.03385149}, {241,0.03575248}, {242,0.03446535}, {243,0.03488119}, {244,0.04154455}, {245,0.03484158}, {246,0.03512871}, {247,0.03884158}, {248,0.03509901}, {249,0.04578218}, {250,0.03551485}, {251,0.03594059}, {252,0.04167327}, {253,0.03620792}, {254,0.03646535}, {255,0.03773267}, {256,0.03600000}, {257,0.04360396}, {258,0.03639604}, {259,0.03676238}, {260,0.03854455}, {261,0.03696040}, {262,0.04505941}, {263,0.03741584}, {264,0.03720792}, {265,0.03916832}, {266,0.03765347}, {267,0.04522772}, {268,0.03780198}, {269,0.03859406}, {270,0.03934653}, {271,0.03904950}, {272,0.04383168}, {273,0.03867327}, {274,0.04922772}, {275,0.03890099}, {276,0.03916832}, {277,0.04184158}, {278,0.03938614}, {279,0.04660396}, {280,0.03953465}, {281,0.05120792}, {282,0.03989109}, {283,0.04003960}, {284,0.04362376}, {285,0.04068317}, {286,0.04693069}, {287,0.04115842}, {288,0.05004950}, {289,0.04067327}, {290,0.04108911}, {291,0.04177228}, {292,0.04131683}, {293,0.04440594}, {294,0.04206931}, {295,0.04769307}, {296,0.04179208}, {297,0.05011881}, {298,0.04202970}, {299,0.05286139}, {300,0.04238614}, {301,0.04270297}, {302,0.04386139}, {303,0.04352475}, {304,0.04555446}, {305,0.04303960}, {306,0.04769307}, {307,0.04390099}, {308,0.04965347}, {309,0.04385149}, {310,0.05173267}, {311,0.04459406}, {312,0.05299010}, {313,0.04433663}, {314,0.05447525}, {315,0.04492079}, {316,0.05562376}, {317,0.04505941}, {318,0.05696040}, {319,0.04550495}, {320,0.05761386}, {321,0.04496040}, {322,0.04654455}, {323,0.04574257}, {324,0.04585149}, {325,0.04657426}, {326,0.04624752}, {327,0.04713861}, {328,0.04613861}, {329,0.04732673}, {330,0.04671287}, {331,0.04774257}, {332,0.04862376}, {333,0.04730693}, {334,0.04872277}, {335,0.04841584}, {336,0.05933663}, {337,0.04749505}, {338,0.05906931}, {339,0.04812871}, {340,0.05958416}, {341,0.04847525}, {342,0.05634653}, {343,0.04875248}, {344,0.05622772}, {345,0.04914851}, {346,0.05578218}, {347,0.04934653}, {348,0.05428713}, {349,0.04996040}, {350,0.05306931}, {351,0.05064356}, {352,0.05115842}, {353,0.05147525}, {354,0.05027723}, {355,0.06130693}, {356,0.05023762}, {357,0.05933663}, {358,0.05092079}, {359,0.05793069}, {360,0.05081188}, {361,0.05543564}, {362,0.05118812}, {363,0.05354455}, {364,0.06459406}, {365,0.05203960}, {366,0.06554455}, {367,0.05250495}, {368,0.05872277}, {369,0.05256436}, {370,0.05660396}, {371,0.05313861}, {372,0.05353465}, {373,0.06481188}, {374,0.05315842}, {375,0.06180198}, {376,0.05338614}, {377,0.05794059}, {378,0.05364356}, {379,0.05415842}, {380,0.06519802}, {381,0.05461386}, {382,0.06144554}, {383,0.05498020}, {384,0.05613861}, {385,0.06803960}, {386,0.05433663}, {387,0.06364356}, {388,0.05479208}, {389,0.05909901}, {390,0.07068317}, {391,0.05511881}, {392,0.06487129}, {393,0.05553465}, {394,0.06034653}, {395,0.07249505}, {396,0.05579208}, {397,0.06604950}, {398,0.05682178}, {399,0.06088119}, {400,0.07127723}, {401,0.05657426}, {402,0.06562376}, {403,0.05751485}, {404,0.05994059}, {405,0.07073267}, {406,0.05749505}, {407,0.06489109}, {408,0.05747525}, {409,0.05779208}, {410,0.06801980}, {411,0.05854455}, {412,0.06189109}, {413,0.07231683}, {414,0.05876238}, {415,0.06532673}, {416,0.07611881}, {417,0.05856436}, {418,0.06766337}, {419,0.05960396}, {420,0.06083168}, {421,0.07104950}, {422,0.05977228}, {423,0.06385149}, {424,0.07246535}, {425,0.06034653}, {426,0.06534653}, {427,0.07473267}, {428,0.06043564}, {429,0.06682178}, {430,0.07784158}, {431,0.06132673}, {432,0.06523762}, {433,0.08492079}, {434,0.06103960}, {435,0.07242574}, {436,0.08542574}, {437,0.06234653}, {438,0.07279208}, {439,0.08610891}, {440,0.06200990}, {441,0.07349505}, {442,0.08129703}, {443,0.06306931}, {444,0.06998020}, {445,0.07975248}, {446,0.06359406}, {447,0.07003960}, {448,0.07784158}, {449,0.06339604}, {450,0.06805941}, {451,0.07727723}, {452,0.06356436}, {453,0.06730693}, {454,0.07613861}, {455,0.06470297}, {456,0.06524752}, {457,0.07467327}, {458,0.08373267}, {459,0.06508911}, {460,0.07255446}, {461,0.08084158}, {462,0.06563366}, {463,0.06998020}, {464,0.07779208}, {465,0.06572277}, {466,0.06735644}, {467,0.07515842}, {468,0.07840594}, {469,0.06653465}, {470,0.07127723}, {471,0.07832673}, {472,0.06666337}, {473,0.06834653}, {474,0.07476238}, {475,0.08225743}, {476,0.06733663}, {477,0.07089109}, {478,0.07777228}, {479,0.08699010}, {480,0.06731683}, {481,0.07322772}, {482,0.08005941}, {483,0.06853465}, {484,0.06926733}, {485,0.07499010}, {486,0.08197030}, {487,0.06968317}, {488,0.06983168}, {489,0.07691089}, {490,0.08359406}, {491,0.07030693}, {492,0.07110891}, {493,0.07792079}, {494,0.08404950}, {495,0.07063366}, {496,0.07124752}, {497,0.07769307}, {498,0.08387129}, {499,0.07082178}, {500,0.07240594}, {505,0.07785149}, {510,0.08494059}, {515,0.09068317}, {520,0.07277228}, {525,0.07813861}, {530,0.08433663}, {535,0.09130693}, {540,0.09635644}, {545,0.07657426}, {550,0.07979208}, {555,0.08533663}, {560,0.08979208}, {565,0.09520792}, {570,0.09909901}, {575,0.10396040}, {580,0.08201980}, {585,0.08387129}, {590,0.08825743}, {595,0.09152475}, {600,0.09445545}, {605,0.09825743}, {610,0.10015842}, {615,0.10390099}, {620,0.10588119}, {625,0.10768317}, {630,0.10959406}, {635,0.11072277}, {640,0.11002970}, {645,0.11198020}, {650,1.10386139}, {655,0.12575248}, {660,0.12467327}, {665,0.12604950}, {670,0.12074257}, {675,0.11890099}, {680,0.11816832}, {685,0.11850495}, {690,0.11801980}, {695,0.11799010}, {700,0.11669307}, {705,0.11523762}, {710,0.11389109}, {715,0.11217822}, {720,0.11055446}, {725,0.11001980}, {730,0.10786139}, {735,0.13425743}, {740,0.12863366}, {745,0.12680198}, {750,0.12362376}, {755,0.12031683}, {760,0.11694059}, {765,0.11491089}, {770,0.13418812}, {775,0.12970297}, {780,0.12654455}, {785,0.12013861}, {790,0.11958416}, {795,0.13837624}, {800,0.12613861}, {805,0.12461386}, {810,0.12184158}, {815,0.12604950}, {820,0.15047525}, {825,0.14425743}, {830,0.13643564}, {835,0.12971287}, {840,0.14492079}, {845,0.13864356}, {850,0.13116832}, {855,0.15094059}, {860,0.14441584}, {865,0.13619802}, {870,0.15464356}, {875,0.14357426}, {880,0.13773267}, {885,0.15673267}, {890,0.14902970}, {895,0.14123762}, {900,0.15495050}, {905,0.14641584}, {910,0.13901980}, {915,0.15385149}, {920,0.14467327}, {925,0.15982178}, {930,0.15054455}, {935,0.14500990}, {940,0.15598020}, {945,0.14707921}, {950,0.16039604}, {955,0.15223762}, {960,0.16248515}, {965,0.15028713}, {970,0.16583168}, {975,0.15861386}, {980,0.18459406}, {985,0.16812871}, {990,0.18063366}, {995,0.16373267}, {1000,0.17600000}, {1010,0.16545545}, {1020,0.17822772}, {1030,0.16435644}, {1040,0.17298020}, {1050,0.16485149}, {1060,0.17331683}, {1070,0.18601980}, {1080,0.17100000}, {1090,0.17979208}, {1100,0.18895050}, {1110,0.17526733}, {1120,0.18081188}, {1130,0.19152475}, {1140,0.17942574}, {1150,0.18670297}, {1160,0.19100000}, {1170,0.19845545}, {1180,0.20538614}, {1190,0.19295050}, {1200,0.21100990}, {1210,0.21327723}, {1220,0.21194059}, {1230,0.21537624}, {1240,0.21993069}, {1250,0.22409901}, {1260,0.20158416}, {1270,0.20600000}, {1280,0.20692079}, {1290,0.21005941}, {1300,0.21226733}, {1310,0.21463366}, {1320,0.21390099}, {1330,0.21590099}, {1340,0.21723762}, {1350,0.21725743}, {1360,0.22071287}, {1370,0.22207921}, {1380,0.23959406}, {1390,0.23962376}, {1400,0.25816832}, {1410,0.24967327}, {1420,0.23864356}, {1430,0.23791089}, {1440,0.23579208}, {1450,0.25742574}, {1460,0.24287129}, {1470,0.24900000}, {1480,0.24192079}, {1490,0.26108911}, {1500,0.25402970}, {1510,0.24928713}, {1520,0.26523762}, {1530,0.26157426}, {1540,0.25182178}, {1550,0.26808911}, {1560,0.28295050}, {1570,0.26859406}, {1580,0.27799010}, {1590,0.27042574}, {1600,0.28483168}, {1610,0.27454455}, {1620,0.26825743}, {1630,0.27975248}, {1640,0.26637624}, {1650,0.27955446}, {1660,0.27442574}, {1670,0.27901980}, {1680,0.29398020}, {1690,0.28058416}, {1700,0.31744554}, {1710,0.29367327}, {1720,0.29844554}, {1730,0.31170297}, {1740,0.28982178}, {1750,0.30393069}, {1760,0.29085149}, {1770,0.29523762}, {1780,0.30222772}, {1790,0.31201980}, {1800,0.29382178}, {1810,0.30330693}, {1820,0.32074257}, {1830,0.33948515}, {1840,0.30874257}, {1850,0.31353465}, {1860,0.31940594}, {1870,0.31376238}, {1880,0.32661386}, {1890,0.32985149}, {1900,0.33252475}, {1910,0.32015842}, {1920,0.31349505}, {1930,0.31821782}, {1940,0.32347525}, {1950,0.35222772}, {1960,0.33900000}, {1970,0.33605941}, {1980,0.33803960}, {1990,0.33102970}, {2000,0.34144554}, {2050,0.34581188}, {2100,0.36629703}, {2150,0.36881188}, {2200,0.36894059}, {2250,0.38812871}, {2300,0.42312871}, {2350,0.41963366}, {2400,0.40977228}, {2450,0.41940594}, {2500,0.43570297}, {2550,0.44507921}, {2600,0.44961386}, {2650,0.45984158}, {2700,0.49831683}, {2750,0.48567327}, {2800,0.48495050}, {2850,0.50430693}, {2900,0.49964356}, {2950,0.51861386}, {3000,0.51724752}, {3050,0.56591089}, {3100,0.53800990}, {3150,0.54352475}, {3200,0.55309901}, {3250,0.56973267}, {3300,0.56882178}, {3350,0.57916832}, {3400,0.62415842}, {3450,0.62544554}, {3500,0.61951485}, {3550,0.61759406}, {3600,0.62363366}, {3650,0.63434653}, {3700,0.67081188}, {3750,0.67413861}, {3800,0.68248515}, {3850,0.66962376}, {3900,0.67728713}, {3950,0.72016832}, {4000,0.72657426}, {4050,0.72100990}, {4100,0.71473267}, {4150,0.72650495}, {4200,0.74540594}, {4250,0.77224752}, {4300,0.77110891}, {4350,0.77341584}, {4400,0.76597030}, {4450,0.78581188}, {4500,0.83474257}, {4550,0.81674257}, {4600,0.82490099}, {4650,0.82199010}, {4700,0.84899010}, {4750,0.87629703}, {4800,0.86083168}, {4850,0.85972277}, {4900,0.87117822}, {4950,0.91057426}, {5000,0.90971287}, {5050,0.90153465}, {5100,0.91355446}, {5150,0.93620792}, {5200,0.93774257}, {5250,0.93465347}, {5300,0.94897030}, {5350,0.96610891}, {5400,0.99117822}, {5450,0.97648515}, {5500,0.98712871}, {5550,0.99196040}, {5600,1.03661386}, {5650,1.01152475}, {5700,1.03043564}, {5750,1.06262376}, {5800,1.05620792}, {5850,1.06027723}, {5900,1.05254455}, {5950,1.09846535}, {6000,1.09500000}, {6050,1.1427429}, {6100,1.1416000}, {6150,1.1389714}, {6200,1.1614000}, {6250,1.1887143}, {6300,1.1908000}, {6350,1.1888857}, {6400,1.1358000}, {6450,1.2006857}, {6500,1.2161143}, {6550,1.2254000}, {6600,3.8826571}, {6650,1.2744286}, {6700,1.2528571}, {6750,1.2569714}, {6800,1.2569429}, {6850,1.2459143}, {6900,1.2278857}, {6950,1.3259143}, {7000,1.3110571}, {7050,1.3038857}, {7100,1.3252857}, {7150,1.3379714}, {7200,1.2969143}, {7250,1.3788000}, {7300,1.3538000}, {7350,1.3600571}, {7400,1.3692857}, {7450,1.3763143}, {7500,1.3750286}, {7550,1.4546286}, {7600,1.4173429}, {7650,1.4236286}, {7700,1.4326000}, {7750,1.4230000}, {7800,1.4228571}, {7850,1.4711429}, {7900,1.4813714}, {7950,1.4786286}, {8000,1.4921714}, {8050,1.4931143}, {8100,1.4896571}, {8150,1.5705143}, {8200,1.5203429}, {8250,1.5218286}, {8300,1.5416857}, {8350,1.5418571}, {8400,1.5511429}, {8450,1.6216286}, {8500,1.6148857}, {8550,1.6139429}, {8600,1.6144571}, {8650,1.5912571}, {8700,1.6644571}, {8750,1.6550857}, {8800,1.6104286}, {8850,1.6365714}, {8900,1.6247429}, {8950,1.6865714}, {9000,1.6765429}, {9050,1.6846857}, {9100,1.7058000}, {9150,1.7025714}, {9200,1.7326286}, {9250,1.7253429}, {9300,1.7342857}, {9350,1.7485143}, {9400,1.7508286}, {9450,1.7848000}, {9500,1.7967714}, {9550,1.7743429}, {9600,1.7853429}, {9650,1.8004857}, {9700,1.8260286}, {9750,1.8398000}, {9800,1.8188000}, {9850,1.8457429}, {9900,1.8446571}, {9950,1.9264857}, {10000,1.8780571}, {10100,1.8894000}, {10200,1.9410286}, {10300,1.9595714}, {10400,1.9592000}, {10500,1.9512571}, {10600,1.9869429}, {10700,2.0091143}, {10800,2.0528571}, {10900,2.0505143}, {11000,2.0731714}, {11100,2.0798000}, {11200,2.1141143}, {11300,2.1016000}, {11400,2.1475429}, {11500,2.1752000}, {11600,2.1994571}, {11700,2.2556000}, {11800,2.2196857}, {11900,2.2502857}, {12000,2.2842000}, {12100,2.2650000}, {12200,2.2744857}, {12300,2.2919714}, {12400,2.3838571}, {12500,2.3582857}, {12600,2.4146286}, {12700,2.4116571}, {12800,2.4259143}, {12900,2.4310286}, {13000,2.4656000}, {13100,2.5392857}, {13200,2.5326286}, {13300,2.5362000}, {13400,2.5638000}, {13500,2.5716286}, {13600,2.5502000}, {13700,2.6052571}, {13800,2.6698857}, {13900,2.6341714}, {14000,2.6380000}, {14100,2.7260286}, {14200,2.7034857}, {14300,2.7708857}, {14400,2.7254286}, {14500,2.7557714}, {14600,2.7645143}, {14700,2.8415143}, {14800,2.8632000}, {14900,2.8683714}, {15000,2.8437714}, {15100,2.9826286}, {15200,2.9100857}, {15300,2.9355143}, {15400,2.9143714}, {15500,2.9427714}, {15600,3.0115143}, {15700,3.0237429}, {15800,3.0238857}, {15900,3.0173429}, {16000,3.0720571}, {16100,3.0263143}, {16200,3.0482571}, {16300,3.1531143}, {16400,3.0804857}, {16500,3.1328000}, {16600,3.1994000}, {16700,3.1971143}, {16800,3.2250286}, {16900,3.1866857}, {17000,3.2088571}, {17100,3.2750000}, {17200,3.2967429}, {17300,3.2729714}, {17400,3.4338857}, {17500,3.3880571}, {17600,3.3786286}, {17700,3.3632857}, {17800,3.3958571}, {17900,3.5234571}, {18000,3.4296286}, {18100,3.4715143}, {18200,3.4945714}, {18300,3.4979714}, {18400,3.5511714}, {18500,3.5059143}, {18600,3.5726571}, {18700,3.5746571}, {18800,3.5290000}, {18900,3.6217429}, {19000,3.6011429}, {19100,3.7239429}, {19200,3.5980000}, {19300,7.1257714}, {19400,3.7461714}, {19500,3.6786000}, {19600,3.7045143}, {19700,3.7525714}, {19800,3.7838571}, {19900,3.9181143}, {20000,3.7619429}};
data["big_flat"]["LtacPrimUncurry"]["Aggregate"]["user"] = {{1,0.00046535}, {2,0.00073267}, {3,0.00139604}, {4,0.00126733}, {5,0.00161386}, {6,0.00136634}, {7,0.00177228}, {8,0.00171287}, {9,0.00198020}, {10,0.00205941}, {11,0.00210891}, {12,0.00247525}, {13,0.00229703}, {14,0.00284158}, {15,0.00242574}, {16,0.00252475}, {17,0.00280198}, {18,0.00328713}, {19,0.00317822}, {20,0.00339604}, {21,0.00337624}, {22,0.00352475}, {23,0.00358416}, {24,0.00367327}, {25,0.00385149}, {26,0.00402970}, {27,0.00416832}, {28,0.01184158}, {29,0.00457426}, {30,0.00462376}, {31,0.00470297}, {32,0.00519802}, {33,0.00520792}, {34,0.00542574}, {35,0.00525743}, {36,0.00594059}, {37,0.00541584}, {38,0.00613861}, {39,0.00628713}, {40,0.00632673}, {41,0.00645545}, {42,0.00650495}, {43,0.00684158}, {44,0.00789109}, {45,0.00678218}, {46,0.00719802}, {47,0.00748515}, {48,0.00746535}, {49,0.00758416}, {50,0.00781188}, {51,0.00795050}, {52,0.00805941}, {53,0.00815842}, {54,0.00857426}, {55,0.00845545}, {56,0.00957426}, {57,0.00887129}, {58,0.00858416}, {59,0.00915842}, {60,0.00906931}, {61,0.00922772}, {62,0.00954455}, {63,0.00955446}, {64,0.00960396}, {65,0.00951485}, {66,0.01094059}, {67,0.00965347}, {68,0.01016832}, {69,0.01027723}, {70,0.01041584}, {71,0.01064356}, {72,0.01048515}, {73,0.01071287}, {74,0.01161386}, {75,0.01081188}, {76,0.01112871}, {77,0.01120792}, {78,0.01127723}, {79,0.01163366}, {80,0.01176238}, {81,0.01180198}, {82,0.01684158}, {83,0.01184158}, {84,0.01220792}, {85,0.01268317}, {86,0.01242574}, {87,0.01258416}, {88,0.01271287}, {89,0.01300000}, {90,0.01441584}, {91,0.01320792}, {92,0.01359406}, {93,0.01383168}, {94,0.01399010}, {95,0.01407921}, {96,0.01980198}, {97,0.01362376}, {98,0.01445545}, {99,0.01440594}, {100,0.01449505}, {101,0.01481188}, {102,0.01500000}, {103,0.01686139}, {104,0.01525743}, {105,0.01525743}, {106,0.01539604}, {107,0.01594059}, {108,0.01581188}, {109,0.01711881}, {110,0.01621782}, {111,0.01646535}, {112,0.01637624}, {113,0.01647525}, {114,0.02301980}, {115,0.01657426}, {116,0.01679208}, {117,0.01700000}, {118,0.01709901}, {119,0.01726733}, {120,0.01937624}, {121,0.01750495}, {122,0.01748515}, {123,0.01775248}, {124,0.01780198}, {125,0.02100000}, {126,0.01782178}, {127,0.01823762}, {128,0.01824752}, {129,0.01819802}, {130,0.02187129}, {131,0.01878218}, {132,0.01862376}, {133,0.01895050}, {134,0.01909901}, {135,0.02172277}, {136,0.01906931}, {137,0.01948515}, {138,0.01958416}, {139,0.02004950}, {140,0.02015842}, {141,0.02051485}, {142,0.02048515}, {143,0.02093069}, {144,0.02386139}, {145,0.02091089}, {146,0.02100990}, {147,0.02111881}, {148,0.02248515}, {149,0.02129703}, {150,0.02161386}, {151,0.02155446}, {152,0.02183168}, {153,0.02331683}, {154,0.02199010}, {155,0.02275248}, {156,0.02261386}, {157,0.02506931}, {158,0.02291089}, {159,0.02319802}, {160,0.02262376}, {161,0.02605941}, {162,0.02279208}, {163,0.02303960}, {164,0.02336634}, {165,0.02642574}, {166,0.02358416}, {167,0.02379208}, {168,0.02389109}, {169,0.02611881}, {170,0.02433663}, {171,0.02470297}, {172,0.02416832}, {173,0.02594059}, {174,0.02452475}, {175,0.02559406}, {176,0.03050495}, {177,0.02517822}, {178,0.02558416}, {179,0.02575248}, {180,0.02820792}, {181,0.02630693}, {182,0.02577228}, {183,0.03363366}, {184,0.02612871}, {185,0.02647525}, {186,0.02626733}, {187,0.02994059}, {188,0.02676238}, {189,0.02696040}, {190,0.03359406}, {191,0.02727723}, {192,0.02701980}, {193,0.02785149}, {194,0.02973267}, {195,0.02755446}, {196,0.02755446}, {197,0.03237624}, {198,0.02841584}, {199,0.02857426}, {200,0.03510891}, {201,0.02870297}, {202,0.02870297}, {203,0.02900990}, {204,0.03025743}, {205,0.02978218}, {206,0.02962376}, {207,0.03129703}, {208,0.02964356}, {209,0.02997030}, {210,0.03249505}, {211,0.03029703}, {212,0.03059406}, {213,0.03368317}, {214,0.03047525}, {215,0.03107921}, {216,0.03426733}, {217,0.03081188}, {218,0.03146535}, {219,0.03484158}, {220,0.03150495}, {221,0.03200990}, {222,0.03462376}, {223,0.03230693}, {224,0.03190099}, {225,0.03409901}, {226,0.03189109}, {227,0.03221782}, {228,0.03330693}, {229,0.03268317}, {230,0.03417822}, {231,0.03312871}, {232,0.03332673}, {233,0.04090099}, {234,0.03298020}, {235,0.03389109}, {236,0.03908911}, {237,0.03378218}, {238,0.03384158}, {239,0.03682178}, {240,0.03365347}, {241,0.03521782}, {242,0.03437624}, {243,0.03441584}, {244,0.04122772}, {245,0.03468317}, {246,0.03471287}, {247,0.03814851}, {248,0.03508911}, {249,0.04534653}, {250,0.03498020}, {251,0.03589109}, {252,0.04121782}, {253,0.03601980}, {254,0.03598020}, {255,0.03746535}, {256,0.03598020}, {257,0.04345545}, {258,0.03642574}, {259,0.03647525}, {260,0.03833663}, {261,0.03680198}, {262,0.04528713}, {263,0.03711881}, {264,0.03699010}, {265,0.03874257}, {266,0.03759406}, {267,0.04479208}, {268,0.03770297}, {269,0.03837624}, {270,0.03915842}, {271,0.03917822}, {272,0.04365347}, {273,0.03842574}, {274,0.04888119}, {275,0.03887129}, {276,0.03879208}, {277,0.04203960}, {278,0.03924752}, {279,0.04652475}, {280,0.03940594}, {281,0.05098020}, {282,0.03938614}, {283,0.03973267}, {284,0.04362376}, {285,0.04033663}, {286,0.04685149}, {287,0.04159406}, {288,0.04972277}, {289,0.04069307}, {290,0.04098020}, {291,0.04188119}, {292,0.04135644}, {293,0.04463366}, {294,0.04197030}, {295,0.04782178}, {296,0.04182178}, {297,0.04976238}, {298,0.04226733}, {299,0.05246535}, {300,0.04257426}, {301,0.04306931}, {302,0.04405941}, {303,0.04361386}, {304,0.04580198}, {305,0.04312871}, {306,0.04790099}, {307,0.04401980}, {308,0.04921782}, {309,0.04412871}, {310,0.05105941}, {311,0.04477228}, {312,0.05245545}, {313,0.04461386}, {314,0.05401980}, {315,0.04532673}, {316,0.05539604}, {317,0.04530693}, {318,0.05636634}, {319,0.04596040}, {320,0.05745545}, {321,0.04524752}, {322,0.04673267}, {323,0.04586139}, {324,0.04601980}, {325,0.04723762}, {326,0.04636634}, {327,0.04753465}, {328,0.04642574}, {329,0.04759406}, {330,0.04705941}, {331,0.04800000}, {332,0.04879208}, {333,0.04750495}, {334,0.04876238}, {335,0.04838614}, {336,0.05917822}, {337,0.04768317}, {338,0.05864356}, {339,0.04805941}, {340,0.05946535}, {341,0.04885149}, {342,0.05576238}, {343,0.04895050}, {344,0.05598020}, {345,0.04919802}, {346,0.05532673}, {347,0.04920792}, {348,0.05407921}, {349,0.05001980}, {350,0.05266337}, {351,0.05025743}, {352,0.05051485}, {353,0.05102970}, {354,0.05032673}, {355,0.06126733}, {356,0.05005941}, {357,0.05893069}, {358,0.05068317}, {359,0.05768317}, {360,0.05044554}, {361,0.05551485}, {362,0.05097030}, {363,0.05287129}, {364,0.06425743}, {365,0.05138614}, {366,0.06404950}, {367,0.05214851}, {368,0.05846535}, {369,0.05213861}, {370,0.05645545}, {371,0.05282178}, {372,0.05307921}, {373,0.06462376}, {374,0.05292079}, {375,0.06190099}, {376,0.05316832}, {377,0.05738614}, {378,0.05325743}, {379,0.05408911}, {380,0.06490099}, {381,0.05459406}, {382,0.06112871}, {383,0.05510891}, {384,0.05611881}, {385,0.06733663}, {386,0.05444554}, {387,0.06361386}, {388,0.05465347}, {389,0.05895050}, {390,0.07001980}, {391,0.05487129}, {392,0.06480198}, {393,0.05532673}, {394,0.06000990}, {395,0.07210891}, {396,0.05614851}, {397,0.06564356}, {398,0.05672277}, {399,0.06068317}, {400,0.07111881}, {401,0.05660396}, {402,0.06547525}, {403,0.05745545}, {404,0.05929703}, {405,0.07032673}, {406,0.05712871}, {407,0.06456436}, {408,0.05713861}, {409,0.05761386}, {410,0.06815842}, {411,0.05865347}, {412,0.06150495}, {413,0.07179208}, {414,0.05838614}, {415,0.06559406}, {416,0.07532673}, {417,0.05831683}, {418,0.06761386}, {419,0.05920792}, {420,0.06070297}, {421,0.07068317}, {422,0.05946535}, {423,0.06399010}, {424,0.07174257}, {425,0.06033663}, {426,0.06521782}, {427,0.07501980}, {428,0.06081188}, {429,0.06700990}, {430,0.07738614}, {431,0.06104950}, {432,0.06512871}, {433,0.08457426}, {434,0.06078218}, {435,0.07207921}, {436,0.08479208}, {437,0.06239604}, {438,0.07219802}, {439,0.08523762}, {440,0.06240594}, {441,0.07306931}, {442,0.08085149}, {443,0.06317822}, {444,0.06878218}, {445,0.07922772}, {446,0.06362376}, {447,0.06947525}, {448,0.07776238}, {449,0.06381188}, {450,0.06791089}, {451,0.07689109}, {452,0.06376238}, {453,0.06735644}, {454,0.07579208}, {455,0.06493069}, {456,0.06532673}, {457,0.07466337}, {458,0.08290099}, {459,0.06524752}, {460,0.07207921}, {461,0.08023762}, {462,0.06600000}, {463,0.06957426}, {464,0.07730693}, {465,0.06600000}, {466,0.06727723}, {467,0.07499010}, {468,0.07775248}, {469,0.06654455}, {470,0.07064356}, {471,0.07809901}, {472,0.06700000}, {473,0.06829703}, {474,0.07449505}, {475,0.08205941}, {476,0.06735644}, {477,0.07057426}, {478,0.07771287}, {479,0.08685149}, {480,0.06721782}, {481,0.07306931}, {482,0.07976238}, {483,0.06878218}, {484,0.06931683}, {485,0.07512871}, {486,0.08137624}, {487,0.06929703}, {488,0.06998020}, {489,0.07700990}, {490,0.08309901}, {491,0.07000000}, {492,0.07099010}, {493,0.07762376}, {494,0.08313861}, {495,0.07044554}, {496,0.07084158}, {497,0.07777228}, {498,0.08328713}, {499,0.07076238}, {500,0.07209901}, {505,0.07766337}, {510,0.08421782}, {515,0.08977228}, {520,0.07254455}, {525,0.07804950}, {530,0.08408911}, {535,0.09076238}, {540,0.09582178}, {545,0.07652475}, {550,0.07958416}, {555,0.08492079}, {560,0.08909901}, {565,0.09500990}, {570,0.09847525}, {575,0.10299010}, {580,0.08156436}, {585,0.08346535}, {590,0.08790099}, {595,0.09131683}, {600,0.09424752}, {605,0.09767327}, {610,0.09980198}, {615,0.10316832}, {620,0.10536634}, {625,0.10749505}, {630,0.10893069}, {635,0.11054455}, {640,0.10984158}, {645,0.11153465}, {650,1.09966337}, {655,0.12545545}, {660,0.12469307}, {665,0.12598020}, {670,0.12029703}, {675,0.11886139}, {680,0.11775248}, {685,0.11824752}, {690,0.11752475}, {695,0.11751485}, {700,0.11646535}, {705,0.11486139}, {710,0.11331683}, {715,0.11205941}, {720,0.11028713}, {725,0.10989109}, {730,0.10771287}, {735,0.13407921}, {740,0.12848515}, {745,0.12651485}, {750,0.12346535}, {755,0.12002970}, {760,0.11690099}, {765,0.11451485}, {770,0.13421782}, {775,0.12932673}, {780,0.12654455}, {785,0.11975248}, {790,0.11937624}, {795,0.13828713}, {800,0.12621782}, {805,0.12456436}, {810,0.12144554}, {815,0.12582178}, {820,0.15062376}, {825,0.14412871}, {830,0.13644554}, {835,0.12961386}, {840,0.14412871}, {845,0.13848515}, {850,0.13110891}, {855,0.15075248}, {860,0.14426733}, {865,0.13601980}, {870,0.15456436}, {875,0.14337624}, {880,0.13764356}, {885,0.15648515}, {890,0.14850495}, {895,0.14120792}, {900,0.15465347}, {905,0.14635644}, {910,0.13884158}, {915,0.15334653}, {920,0.14394059}, {925,0.15891089}, {930,0.14980198}, {935,0.14455446}, {940,0.15544554}, {945,0.14688119}, {950,0.15934653}, {955,0.15175248}, {960,0.16185149}, {965,0.14968317}, {970,0.16511881}, {975,0.15831683}, {980,0.18429703}, {985,0.16791089}, {990,0.18005941}, {995,0.16319802}, {1000,0.17550495}, {1010,0.16483168}, {1020,0.17756436}, {1030,0.16374257}, {1040,0.17257426}, {1050,0.16484158}, {1060,0.17249505}, {1070,0.18543564}, {1080,0.17074257}, {1090,0.17898020}, {1100,0.18836634}, {1110,0.17482178}, {1120,0.18032673}, {1130,0.19140594}, {1140,0.17907921}, {1150,0.18657426}, {1160,0.19095050}, {1170,0.19805941}, {1180,0.20499010}, {1190,0.19285149}, {1200,0.21067327}, {1210,0.21325743}, {1220,0.21151485}, {1230,0.21499010}, {1240,0.21978218}, {1250,0.22388119}, {1260,0.20109901}, {1270,0.20589109}, {1280,0.20665347}, {1290,0.20984158}, {1300,0.21224752}, {1310,0.21439604}, {1320,0.21300990}, {1330,0.21545545}, {1340,0.21680198}, {1350,0.21689109}, {1360,0.22018812}, {1370,0.22208911}, {1380,0.23921782}, {1390,0.23919802}, {1400,0.25804950}, {1410,0.24915842}, {1420,0.23827723}, {1430,0.23773267}, {1440,0.23520792}, {1450,0.25686139}, {1460,0.24253465}, {1470,0.24874257}, {1480,0.24143564}, {1490,0.26072277}, {1500,0.25409901}, {1510,0.24910891}, {1520,0.26508911}, {1530,0.26156436}, {1540,0.25143564}, {1550,0.26756436}, {1560,0.28224752}, {1570,0.26810891}, {1580,0.27733663}, {1590,0.26978218}, {1600,0.28393069}, {1610,0.27410891}, {1620,0.26799010}, {1630,0.27942574}, {1640,0.26603960}, {1650,0.27889109}, {1660,0.27423762}, {1670,0.27893069}, {1680,0.29349505}, {1690,0.28061386}, {1700,0.31704950}, {1710,0.29325743}, {1720,0.29775248}, {1730,0.31131683}, {1740,0.28932673}, {1750,0.30343564}, {1760,0.29032673}, {1770,0.29475248}, {1780,0.30205941}, {1790,0.31165347}, {1800,0.29334653}, {1810,0.30289109}, {1820,0.32040594}, {1830,0.33916832}, {1840,0.30810891}, {1850,0.31321782}, {1860,0.31879208}, {1870,0.31331683}, {1880,0.32642574}, {1890,0.32954455}, {1900,0.33220792}, {1910,0.31976238}, {1920,0.31308911}, {1930,0.31794059}, {1940,0.32308911}, {1950,0.35140594}, {1960,0.33861386}, {1970,0.33552475}, {1980,0.33752475}, {1990,0.33047525}, {2000,0.34100990}, {2050,0.34543564}, {2100,0.36565347}, {2150,0.36834653}, {2200,0.36824752}, {2250,0.38783168}, {2300,0.42245545}, {2350,0.41933663}, {2400,0.40930693}, {2450,0.41884158}, {2500,0.43514851}, {2550,0.44423762}, {2600,0.44888119}, {2650,0.45917822}, {2700,0.49766337}, {2750,0.48511881}, {2800,0.48380198}, {2850,0.50344554}, {2900,0.49903960}, {2950,0.51777228}, {3000,0.51635644}, {3050,0.56513861}, {3100,0.53743564}, {3150,0.54279208}, {3200,0.55236634}, {3250,0.56862376}, {3300,0.56811881}, {3350,0.57808911}, {3400,0.62314851}, {3450,0.62466337}, {3500,0.61884158}, {3550,0.61676238}, {3600,0.62265347}, {3650,0.63351485}, {3700,0.66998020}, {3750,0.67323762}, {3800,0.68153465}, {3850,0.66882178}, {3900,0.67644554}, {3950,0.71910891}, {4000,0.72556436}, {4050,0.72025743}, {4100,0.71135644}, {4150,0.72275248}, {4200,0.74318812}, {4250,0.77138614}, {4300,0.77020792}, {4350,0.77262376}, {4400,0.76454455}, {4450,0.78501980}, {4500,0.83354455}, {4550,0.81528713}, {4600,0.82317822}, {4650,0.82094059}, {4700,0.84822772}, {4750,0.87508911}, {4800,0.85969307}, {4850,0.85868317}, {4900,0.87022772}, {4950,0.90949505}, {5000,0.90845545}, {5050,0.90063366}, {5100,0.91249505}, {5150,0.93506931}, {5200,0.93669307}, {5250,0.93329703}, {5300,0.94790099}, {5350,0.96493069}, {5400,0.99006931}, {5450,0.97515842}, {5500,0.98590099}, {5550,0.99066337}, {5600,1.03527723}, {5650,1.01026733}, {5700,1.02953465}, {5750,1.06140594}, {5800,1.05519802}, {5850,1.05904950}, {5900,1.05137624}, {5950,1.09745545}, {6000,1.09339604}, {6050,1.1352000}, {6100,1.1352286}, {6150,1.1310286}, {6200,1.1574857}, {6250,1.1878571}, {6300,1.1847429}, {6350,1.1836000}, {6400,1.1289429}, {6450,1.1985143}, {6500,1.2150571}, {6550,1.2243714}, {6600,3.8782286}, {6650,1.2725429}, {6700,1.2513143}, {6750,1.2553714}, {6800,1.2555714}, {6850,1.2452286}, {6900,1.2272000}, {6950,1.3250000}, {7000,1.3102571}, {7050,1.3025143}, {7100,1.3242286}, {7150,1.3296000}, {7200,1.2896571}, {7250,1.3721429}, {7300,1.3519714}, {7350,1.3584000}, {7400,1.3678286}, {7450,1.3752000}, {7500,1.3742286}, {7550,1.4531714}, {7600,1.4160571}, {7650,1.4217714}, {7700,1.4315714}, {7750,1.4218571}, {7800,1.4215714}, {7850,1.4697429}, {7900,1.4806571}, {7950,1.4776286}, {8000,1.4917429}, {8050,1.4920000}, {8100,1.4889429}, {8150,1.5690571}, {8200,1.5197714}, {8250,1.5206571}, {8300,1.5407714}, {8350,1.5410571}, {8400,1.5501714}, {8450,1.6204571}, {8500,1.6138571}, {8550,1.6125714}, {8600,1.6134000}, {8650,1.5900000}, {8700,1.6633143}, {8750,1.6538857}, {8800,1.6094857}, {8850,1.6359429}, {8900,1.6240286}, {8950,1.6852571}, {9000,1.6753714}, {9050,1.6832000}, {9100,1.7042857}, {9150,1.7014571}, {9200,1.7311429}, {9250,1.7247143}, {9300,1.7329429}, {9350,1.7478571}, {9400,1.7497429}, {9450,1.7825143}, {9500,1.7952286}, {9550,1.7694286}, {9600,1.7805714}, {9650,1.7959143}, {9700,1.8238286}, {9750,1.8370000}, {9800,1.8141714}, {9850,1.8436857}, {9900,1.8404000}, {9950,1.9224000}, {10000,1.8754857}, {10100,1.8876286}, {10200,1.9369143}, {10300,1.9580286}, {10400,1.9540286}, {10500,1.9468571}, {10600,1.9824857}, {10700,2.0068286}, {10800,2.0500571}, {10900,2.0466857}, {11000,2.0703429}, {11100,2.0745429}, {11200,2.1128000}, {11300,2.0997429}, {11400,2.1462571}, {11500,2.1745714}, {11600,2.1981143}, {11700,2.2461429}, {11800,2.2184000}, {11900,2.2493714}, {12000,2.2825143}, {12100,2.2633429}, {12200,2.2731429}, {12300,2.2896571}, {12400,2.3780286}, {12500,2.3563429}, {12600,2.4135429}, {12700,2.4109143}, {12800,2.4246286}, {12900,2.4242571}, {13000,2.4594000}, {13100,2.5281714}, {13200,2.5273714}, {13300,2.5333143}, {13400,2.5604000}, {13500,2.5655143}, {13600,2.5457429}, {13700,2.5968571}, {13800,2.6624000}, {13900,2.6086571}, {14000,2.6310571}, {14100,2.7182571}, {14200,2.6905429}, {14300,2.7536857}, {14400,2.7183143}, {14500,2.7490000}, {14600,2.7616000}, {14700,2.8308000}, {14800,2.8602857}, {14900,2.8483714}, {15000,2.8338286}, {15100,2.9683714}, {15200,2.9029429}, {15300,2.9266857}, {15400,2.9112857}, {15500,2.9377143}, {15600,3.0041429}, {15700,3.0173429}, {15800,3.0156000}, {15900,3.0134571}, {16000,3.0658000}, {16100,3.0241143}, {16200,3.0408571}, {16300,3.1462000}, {16400,3.0751714}, {16500,3.1198857}, {16600,3.1861714}, {16700,3.1905143}, {16800,3.2198286}, {16900,3.1801714}, {17000,3.1929429}, {17100,3.2706286}, {17200,3.2939714}, {17300,3.2705143}, {17400,3.4186571}, {17500,3.3849429}, {17600,3.3760571}, {17700,3.3606571}, {17800,3.3927429}, {17900,3.5180286}, {18000,3.4269143}, {18100,3.4691143}, {18200,3.4909143}, {18300,3.4954000}, {18400,3.5484857}, {18500,3.5026571}, {18600,3.5696286}, {18700,3.5714000}, {18800,3.5221714}, {18900,3.6194000}, {19000,3.5978571}, {19100,3.7210571}, {19200,3.5862286}, {19300,7.1112857}, {19400,3.7428286}, {19500,3.6759714}, {19600,3.7015714}, {19700,3.7494857}, {19800,3.7808571}, {19900,3.9148571}, {20000,3.7594571}};
data["big_flat"]["LtacPrimUncurry"]["Aggregate"]["system"] = {{1,0.00061386}, {2,0.00017822}, {3,0.00007921}, {4,0.00000000}, {5,0.00002970}, {6,0.00000000}, {7,0.00007921}, {8,0.00009901}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00005941}, {14,0.00002970}, {15,0.00000000}, {16,0.00003960}, {17,0.00002970}, {18,0.00000000}, {19,0.00000000}, {20,0.00003960}, {21,0.00002970}, {22,0.00005941}, {23,0.00003960}, {24,0.00000000}, {25,0.00003960}, {26,0.00011881}, {27,0.00000000}, {28,0.00013861}, {29,0.00003960}, {30,0.00000000}, {31,0.00002970}, {32,0.00003960}, {33,0.00002970}, {34,0.00003960}, {35,0.00003960}, {36,0.00000000}, {37,0.00002970}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00007921}, {42,0.00003960}, {43,0.00011881}, {44,0.00003960}, {45,0.00021782}, {46,0.00003960}, {47,0.00000000}, {48,0.00003960}, {49,0.00003960}, {50,0.00000000}, {51,0.00003960}, {52,0.00003960}, {53,0.00000000}, {54,0.00000000}, {55,0.00003960}, {56,0.00003960}, {57,0.00006931}, {58,0.00003960}, {59,0.00003960}, {60,0.00000000}, {61,0.00005941}, {62,0.00000000}, {63,0.00002970}, {64,0.00003960}, {65,0.00000000}, {66,0.00003960}, {67,0.00013861}, {68,0.00000000}, {69,0.00000000}, {70,0.00003960}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00007921}, {76,0.00003960}, {77,0.00000000}, {78,0.00003960}, {79,0.00000000}, {80,0.00000000}, {81,0.00002970}, {82,0.00006931}, {83,0.00000000}, {84,0.00000000}, {85,0.00003960}, {86,0.00007921}, {87,0.00006931}, {88,0.00010891}, {89,0.00003960}, {90,0.00015842}, {91,0.00003960}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00006931}, {97,0.00006931}, {98,0.00002970}, {99,0.00003960}, {100,0.00014851}, {101,0.00003960}, {102,0.00000000}, {103,0.00003960}, {104,0.00003960}, {105,0.00011881}, {106,0.00017822}, {107,0.00007921}, {108,0.00002970}, {109,0.00003960}, {110,0.00003960}, {111,0.00003960}, {112,0.00013861}, {113,0.00003960}, {114,0.00006931}, {115,0.00007921}, {116,0.00007921}, {117,0.00000000}, {118,0.00009901}, {119,0.00003960}, {120,0.00013861}, {121,0.00003960}, {122,0.00000000}, {123,0.00003960}, {124,0.00007921}, {125,0.00010891}, {126,0.00015842}, {127,0.00000000}, {128,0.00002970}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00002970}, {133,0.00006931}, {134,0.00003960}, {135,0.00011881}, {136,0.00010891}, {137,0.00007921}, {138,0.00011881}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00003960}, {144,0.00017822}, {145,0.00002970}, {146,0.00000000}, {147,0.00015842}, {148,0.00003960}, {149,0.00007921}, {150,0.00000000}, {151,0.00013861}, {152,0.00011881}, {153,0.00019802}, {154,0.00000000}, {155,0.00003960}, {156,0.00002970}, {157,0.00011881}, {158,0.00000000}, {159,0.00000000}, {160,0.00003960}, {161,0.00003960}, {162,0.00019802}, {163,0.00003960}, {164,0.00003960}, {165,0.00010891}, {166,0.00009901}, {167,0.00003960}, {168,0.00003960}, {169,0.00000000}, {170,0.00003960}, {171,0.00007921}, {172,0.00002970}, {173,0.00011881}, {174,0.00003960}, {175,0.00003960}, {176,0.00018812}, {177,0.00007921}, {178,0.00003960}, {179,0.00000000}, {180,0.00016832}, {181,0.00006931}, {182,0.00003960}, {183,0.00006931}, {184,0.00000000}, {185,0.00003960}, {186,0.00003960}, {187,0.00002970}, {188,0.00003960}, {189,0.00007921}, {190,0.00009901}, {191,0.00000000}, {192,0.00015842}, {193,0.00005941}, {194,0.00006931}, {195,0.00002970}, {196,0.00000000}, {197,0.00018812}, {198,0.00000000}, {199,0.00003960}, {200,0.00011881}, {201,0.00006931}, {202,0.00000000}, {203,0.00003960}, {204,0.00003960}, {205,0.00018812}, {206,0.00000000}, {207,0.00007921}, {208,0.00003960}, {209,0.00000000}, {210,0.00006931}, {211,0.00003960}, {212,0.00000000}, {213,0.00006931}, {214,0.00002970}, {215,0.00003960}, {216,0.00011881}, {217,0.00007921}, {218,0.00011881}, {219,0.00024752}, {220,0.00006931}, {221,0.00000000}, {222,0.00010891}, {223,0.00002970}, {224,0.00003960}, {225,0.00000000}, {226,0.00007921}, {227,0.00007921}, {228,0.00003960}, {229,0.00007921}, {230,0.00007921}, {231,0.00007921}, {232,0.00003960}, {233,0.00019802}, {234,0.00022772}, {235,0.00002970}, {236,0.00012871}, {237,0.00000000}, {238,0.00007921}, {239,0.00007921}, {240,0.00007921}, {241,0.00014851}, {242,0.00007921}, {243,0.00003960}, {244,0.00011881}, {245,0.00003960}, {246,0.00003960}, {247,0.00023762}, {248,0.00003960}, {249,0.00037624}, {250,0.00013861}, {251,0.00000000}, {252,0.00037624}, {253,0.00007921}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00021782}, {258,0.00000000}, {259,0.00000000}, {260,0.00007921}, {261,0.00000000}, {262,0.00022772}, {263,0.00014851}, {264,0.00003960}, {265,0.00005941}, {266,0.00003960}, {267,0.00021782}, {268,0.00007921}, {269,0.00003960}, {270,0.00010891}, {271,0.00000000}, {272,0.00018812}, {273,0.00003960}, {274,0.00030693}, {275,0.00007921}, {276,0.00006931}, {277,0.00010891}, {278,0.00003960}, {279,0.00021782}, {280,0.00002970}, {281,0.00018812}, {282,0.00003960}, {283,0.00011881}, {284,0.00018812}, {285,0.00007921}, {286,0.00017822}, {287,0.00002970}, {288,0.00018812}, {289,0.00003960}, {290,0.00000000}, {291,0.00011881}, {292,0.00006931}, {293,0.00007921}, {294,0.00000000}, {295,0.00018812}, {296,0.00009901}, {297,0.00015842}, {298,0.00003960}, {299,0.00013861}, {300,0.00000000}, {301,0.00003960}, {302,0.00003960}, {303,0.00003960}, {304,0.00003960}, {305,0.00003960}, {306,0.00011881}, {307,0.00000000}, {308,0.00023762}, {309,0.00007921}, {310,0.00034653}, {311,0.00006931}, {312,0.00019802}, {313,0.00014851}, {314,0.00026733}, {315,0.00003960}, {316,0.00015842}, {317,0.00007921}, {318,0.00029703}, {319,0.00003960}, {320,0.00021782}, {321,0.00003960}, {322,0.00009901}, {323,0.00006931}, {324,0.00010891}, {325,0.00000000}, {326,0.00006931}, {327,0.00015842}, {328,0.00014851}, {329,0.00003960}, {330,0.00003960}, {331,0.00014851}, {332,0.00011881}, {333,0.00007921}, {334,0.00002970}, {335,0.00002970}, {336,0.00031683}, {337,0.00007921}, {338,0.00027723}, {339,0.00002970}, {340,0.00019802}, {341,0.00009901}, {342,0.00038614}, {343,0.00000000}, {344,0.00023762}, {345,0.00010891}, {346,0.00022772}, {347,0.00006931}, {348,0.00002970}, {349,0.00000000}, {350,0.00009901}, {351,0.00007921}, {352,0.00006931}, {353,0.00010891}, {354,0.00007921}, {355,0.00023762}, {356,0.00005941}, {357,0.00030693}, {358,0.00003960}, {359,0.00015842}, {360,0.00007921}, {361,0.00014851}, {362,0.00003960}, {363,0.00027723}, {364,0.00042574}, {365,0.00007921}, {366,0.00139604}, {367,0.00015842}, {368,0.00023762}, {369,0.00002970}, {370,0.00011881}, {371,0.00011881}, {372,0.00007921}, {373,0.00042574}, {374,0.00006931}, {375,0.00014851}, {376,0.00007921}, {377,0.00006931}, {378,0.00010891}, {379,0.00000000}, {380,0.00037624}, {381,0.00009901}, {382,0.00023762}, {383,0.00007921}, {384,0.00011881}, {385,0.00029703}, {386,0.00003960}, {387,0.00021782}, {388,0.00002970}, {389,0.00014851}, {390,0.00036634}, {391,0.00002970}, {392,0.00025743}, {393,0.00003960}, {394,0.00026733}, {395,0.00057426}, {396,0.00003960}, {397,0.00034653}, {398,0.00007921}, {399,0.00015842}, {400,0.00031683}, {401,0.00006931}, {402,0.00022772}, {403,0.00011881}, {404,0.00026733}, {405,0.00010891}, {406,0.00026733}, {407,0.00037624}, {408,0.00003960}, {409,0.00006931}, {410,0.00007921}, {411,0.00003960}, {412,0.00025743}, {413,0.00035644}, {414,0.00002970}, {415,0.00007921}, {416,0.00060396}, {417,0.00006931}, {418,0.00015842}, {419,0.00000000}, {420,0.00006931}, {421,0.00030693}, {422,0.00000000}, {423,0.00007921}, {424,0.00053465}, {425,0.00007921}, {426,0.00016832}, {427,0.00003960}, {428,0.00011881}, {429,0.00003960}, {430,0.00036634}, {431,0.00019802}, {432,0.00015842}, {433,0.00038614}, {434,0.00007921}, {435,0.00014851}, {436,0.00027723}, {437,0.00011881}, {438,0.00024752}, {439,0.00035644}, {440,0.00010891}, {441,0.00018812}, {442,0.00033663}, {443,0.00003960}, {444,0.00025743}, {445,0.00047525}, {446,0.00006931}, {447,0.00030693}, {448,0.00030693}, {449,0.00003960}, {450,0.00011881}, {451,0.00050495}, {452,0.00015842}, {453,0.00007921}, {454,0.00032673}, {455,0.00007921}, {456,0.00011881}, {457,0.00011881}, {458,0.00069307}, {459,0.00011881}, {460,0.00011881}, {461,0.00035644}, {462,0.00010891}, {463,0.00011881}, {464,0.00047525}, {465,0.00000000}, {466,0.00003960}, {467,0.00030693}, {468,0.00044554}, {469,0.00003960}, {470,0.00015842}, {471,0.00034653}, {472,0.00003960}, {473,0.00003960}, {474,0.00030693}, {475,0.00018812}, {476,0.00014851}, {477,0.00022772}, {478,0.00007921}, {479,0.00040594}, {480,0.00003960}, {481,0.00019802}, {482,0.00014851}, {483,0.00000000}, {484,0.00000000}, {485,0.00010891}, {486,0.00043564}, {487,0.00011881}, {488,0.00000000}, {489,0.00017822}, {490,0.00029703}, {491,0.00011881}, {492,0.00003960}, {493,0.00019802}, {494,0.00027723}, {495,0.00025743}, {496,0.00011881}, {497,0.00011881}, {498,0.00041584}, {499,0.00000000}, {500,0.00003960}, {505,0.00024752}, {510,0.00034653}, {515,0.00045545}, {520,0.00007921}, {525,0.00015842}, {530,0.00003960}, {535,0.00045545}, {540,0.00054455}, {545,0.00011881}, {550,0.00007921}, {555,0.00029703}, {560,0.00040594}, {565,0.00028713}, {570,0.00051485}, {575,0.00064356}, {580,0.00015842}, {585,0.00015842}, {590,0.00023762}, {595,0.00030693}, {600,0.00038614}, {605,0.00045545}, {610,0.00030693}, {615,0.00045545}, {620,0.00036634}, {625,0.00045545}, {630,0.00031683}, {635,0.00011881}, {640,0.00003960}, {645,0.00002970}, {650,0.00298020}, {655,0.00030693}, {660,0.00011881}, {665,0.00025743}, {670,0.00023762}, {675,0.00007921}, {680,0.00015842}, {685,0.00007921}, {690,0.00010891}, {695,0.00007921}, {700,0.00003960}, {705,0.00000000}, {710,0.00007921}, {715,0.00010891}, {720,0.00002970}, {725,0.00003960}, {730,0.00007921}, {735,0.00010891}, {740,0.00011881}, {745,0.00007921}, {750,0.00003960}, {755,0.00000000}, {760,0.00000000}, {765,0.00011881}, {770,0.00011881}, {775,0.00010891}, {780,0.00003960}, {785,0.00011881}, {790,0.00002970}, {795,0.00007921}, {800,0.00010891}, {805,0.00006931}, {810,0.00010891}, {815,0.00007921}, {820,0.00000000}, {825,0.00011881}, {830,0.00003960}, {835,0.00002970}, {840,0.00003960}, {845,0.00000000}, {850,0.00007921}, {855,0.00000000}, {860,0.00000000}, {865,0.00003960}, {870,0.00003960}, {875,0.00003960}, {880,0.00003960}, {885,0.00000000}, {890,0.00007921}, {895,0.00007921}, {900,0.00003960}, {905,0.00003960}, {910,0.00003960}, {915,0.00025743}, {920,0.00052475}, {925,0.00079208}, {930,0.00067327}, {935,0.00038614}, {940,0.00033663}, {945,0.00034653}, {950,0.00061386}, {955,0.00054455}, {960,0.00047525}, {965,0.00019802}, {970,0.00038614}, {975,0.00025743}, {980,0.00021782}, {985,0.00030693}, {990,0.00026733}, {995,0.00027723}, {1000,0.00029703}, {1010,0.00017822}, {1020,0.00010891}, {1030,0.00015842}, {1040,0.00027723}, {1050,0.00007921}, {1060,0.00018812}, {1070,0.00014851}, {1080,0.00011881}, {1090,0.00019802}, {1100,0.00018812}, {1110,0.00014851}, {1120,0.00026733}, {1130,0.00007921}, {1140,0.00019802}, {1150,0.00019802}, {1160,0.00007921}, {1170,0.00000000}, {1180,0.00006931}, {1190,0.00000000}, {1200,0.00007921}, {1210,0.00000000}, {1220,0.00015842}, {1230,0.00007921}, {1240,0.00005941}, {1250,0.00015842}, {1260,0.00011881}, {1270,0.00000000}, {1280,0.00002970}, {1290,0.00007921}, {1300,0.00000000}, {1310,0.00014851}, {1320,0.00009901}, {1330,0.00011881}, {1340,0.00011881}, {1350,0.00000000}, {1360,0.00015842}, {1370,0.00003960}, {1380,0.00014851}, {1390,0.00011881}, {1400,0.00000000}, {1410,0.00003960}, {1420,0.00006931}, {1430,0.00003960}, {1440,0.00011881}, {1450,0.00011881}, {1460,0.00007921}, {1470,0.00011881}, {1480,0.00013861}, {1490,0.00015842}, {1500,0.00003960}, {1510,0.00011881}, {1520,0.00019802}, {1530,0.00015842}, {1540,0.00015842}, {1550,0.00009901}, {1560,0.00011881}, {1570,0.00007921}, {1580,0.00014851}, {1590,0.00014851}, {1600,0.00003960}, {1610,0.00003960}, {1620,0.00010891}, {1630,0.00006931}, {1640,0.00003960}, {1650,0.00013861}, {1660,0.00007921}, {1670,0.00007921}, {1680,0.00015842}, {1690,0.00007921}, {1700,0.00007921}, {1710,0.00003960}, {1720,0.00007921}, {1730,0.00015842}, {1740,0.00013861}, {1750,0.00003960}, {1760,0.00015842}, {1770,0.00018812}, {1780,0.00007921}, {1790,0.00011881}, {1800,0.00003960}, {1810,0.00011881}, {1820,0.00002970}, {1830,0.00006931}, {1840,0.00007921}, {1850,0.00000000}, {1860,0.00017822}, {1870,0.00015842}, {1880,0.00006931}, {1890,0.00007921}, {1900,0.00003960}, {1910,0.00013861}, {1920,0.00011881}, {1930,0.00002970}, {1940,0.00007921}, {1950,0.00010891}, {1960,0.00003960}, {1970,0.00011881}, {1980,0.00011881}, {1990,0.00010891}, {2000,0.00011881}, {2050,0.00014851}, {2100,0.00000000}, {2150,0.00011881}, {2200,0.00007921}, {2250,0.00003960}, {2300,0.00023762}, {2350,0.00011881}, {2400,0.00015842}, {2450,0.00007921}, {2500,0.00006931}, {2550,0.00023762}, {2600,0.00010891}, {2650,0.00026733}, {2700,0.00026733}, {2750,0.00007921}, {2800,0.00003960}, {2850,0.00006931}, {2900,0.00015842}, {2950,0.00026733}, {3000,0.00010891}, {3050,0.00014851}, {3100,0.00011881}, {3150,0.00014851}, {3200,0.00023762}, {3250,0.00019802}, {3300,0.00010891}, {3350,0.00015842}, {3400,0.00010891}, {3450,0.00011881}, {3500,0.00011881}, {3550,0.00015842}, {3600,0.00011881}, {3650,0.00000000}, {3700,0.00019802}, {3750,0.00022772}, {3800,0.00011881}, {3850,0.00023762}, {3900,0.00019802}, {3950,0.00014851}, {4000,0.00019802}, {4050,0.00015842}, {4100,0.00243564}, {4150,0.00280198}, {4200,0.00120792}, {4250,0.00010891}, {4300,0.00007921}, {4350,0.00022772}, {4400,0.00039604}, {4450,0.00015842}, {4500,0.00033663}, {4550,0.00051485}, {4600,0.00052475}, {4650,0.00003960}, {4700,0.00011881}, {4750,0.00031683}, {4800,0.00013861}, {4850,0.00007921}, {4900,0.00018812}, {4950,0.00017822}, {5000,0.00019802}, {5050,0.00015842}, {5100,0.00031683}, {5150,0.00019802}, {5200,0.00027723}, {5250,0.00034653}, {5300,0.00007921}, {5350,0.00015842}, {5400,0.00030693}, {5450,0.00007921}, {5500,0.00010891}, {5550,0.00015842}, {5600,0.00018812}, {5650,0.00010891}, {5700,0.00018812}, {5750,0.00010891}, {5800,0.00007921}, {5850,0.00012871}, {5900,0.00014851}, {5950,0.00015842}, {6000,0.00026733}, {6050,0.0069143}, {6100,0.0049143}, {6150,0.0066286}, {6200,0.0030857}, {6250,0.0003429}, {6300,0.0053429}, {6350,0.0042857}, {6400,0.0057143}, {6450,0.0006286}, {6500,0.0001143}, {6550,0.0000000}, {6600,0.0022571}, {6650,0.0006857}, {6700,0.0000000}, {6750,0.0002286}, {6800,0.0003429}, {6850,0.0002286}, {6900,0.0001714}, {6950,0.0000857}, {7000,0.0000857}, {7050,0.0005429}, {7100,0.0003429}, {7150,0.0073429}, {7200,0.0061714}, {7250,0.0049143}, {7300,0.0006857}, {7350,0.0000000}, {7400,0.0002286}, {7450,0.0001143}, {7500,0.0002286}, {7550,0.0002286}, {7600,0.0000857}, {7650,0.0003429}, {7700,0.0000000}, {7750,0.0006571}, {7800,0.0003143}, {7850,0.0004286}, {7900,0.0001143}, {7950,0.0004571}, {8000,0.0002286}, {8050,0.0001143}, {8100,0.0002286}, {8150,0.0003143}, {8200,0.0002286}, {8250,0.0002286}, {8300,0.0001143}, {8350,0.0000000}, {8400,0.0002857}, {8450,0.0000000}, {8500,0.0002286}, {8550,0.0002286}, {8600,0.0005714}, {8650,0.0003429}, {8700,0.0001143}, {8750,0.0004571}, {8800,0.0003429}, {8850,0.0000000}, {8900,0.0004571}, {8950,0.0002286}, {9000,0.0003429}, {9050,0.0002286}, {9100,0.0005714}, {9150,0.0001143}, {9200,0.0006857}, {9250,0.0003429}, {9300,0.0002286}, {9350,0.0000000}, {9400,0.0002286}, {9450,0.0002286}, {9500,0.0002286}, {9550,0.0001143}, {9600,0.0002286}, {9650,0.0003143}, {9700,0.0002286}, {9750,0.0003429}, {9800,0.0002000}, {9850,0.0000000}, {9900,0.0005714}, {9950,0.0004286}, {10000,0.0001143}, {10100,0.0003143}, {10200,0.0003143}, {10300,0.0001143}, {10400,0.0005714}, {10500,0.0006857}, {10600,0.0003429}, {10700,0.0001143}, {10800,0.0003429}, {10900,0.0001143}, {11000,0.0005714}, {11100,0.0003143}, {11200,0.0003143}, {11300,0.0004571}, {11400,0.0003429}, {11500,0.0002286}, {11600,0.0003429}, {11700,0.0001143}, {11800,0.0001143}, {11900,0.0001143}, {12000,0.0005429}, {12100,0.0004286}, {12200,0.0005143}, {12300,0.0002286}, {12400,0.0006571}, {12500,0.0003429}, {12600,0.0004571}, {12700,0.0003429}, {12800,0.0003429}, {12900,0.0002286}, {13000,0.0002286}, {13100,0.0003429}, {13200,0.0003143}, {13300,0.0002286}, {13400,0.0003143}, {13500,0.0001143}, {13600,0.0002286}, {13700,0.0001143}, {13800,0.0005714}, {13900,0.0001143}, {14000,0.0001143}, {14100,0.0005429}, {14200,0.0006857}, {14300,0.0000000}, {14400,0.0004571}, {14500,0.0002000}, {14600,0.0000000}, {14700,0.0011429}, {14800,0.0005714}, {14900,0.0000000}, {15000,0.0004571}, {15100,0.0008000}, {15200,0.0007714}, {15300,0.0007714}, {15400,0.0003429}, {15500,0.0003429}, {15600,0.0006571}, {15700,0.0007714}, {15800,0.0004286}, {15900,0.0004286}, {16000,0.0004571}, {16100,0.0002286}, {16200,0.0005714}, {16300,0.0003429}, {16400,0.0002286}, {16500,0.0010000}, {16600,0.0002286}, {16700,0.0002286}, {16800,0.0004286}, {16900,0.0004571}, {17000,0.0006857}, {17100,0.0005714}, {17200,0.0005714}, {17300,0.0000000}, {17400,0.0004571}, {17500,0.0005714}, {17600,0.0005714}, {17700,0.0003429}, {17800,0.0008857}, {17900,0.0003429}, {18000,0.0002286}, {18100,0.0002000}, {18200,0.0012286}, {18300,0.0002286}, {18400,0.0000000}, {18500,0.0004286}, {18600,0.0004571}, {18700,0.0003429}, {18800,0.0036286}, {18900,0.0002286}, {19000,0.0002286}, {19100,0.0001143}, {19200,0.0090571}, {19300,0.0098000}, {19400,0.0002857}, {19500,0.0001143}, {19600,0.0000857}, {19700,0.0005714}, {19800,0.0001143}, {19900,0.0004571}, {20000,0.0004571}};
data["big_flat"]["LtacPrimUncurry"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00014851}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00103960}, {15,0.00122772}, {16,0.00200000}, {17,0.00200000}, {18,0.00200000}, {19,0.00200000}, {20,0.00200000}, {21,0.00200990}, {22,0.00220792}, {23,0.00244554}, {24,0.00296040}, {25,0.00300000}, {26,0.00300000}, {27,0.00300000}, {28,0.00300990}, {29,0.00304950}, {30,0.00315842}, {31,0.00349505}, {32,0.00389109}, {33,0.00400000}, {34,0.00400000}, {35,0.00400990}, {36,0.00405941}, {37,0.00420792}, {38,0.00430693}, {39,0.00455446}, {40,0.00487129}, {41,0.00500000}, {42,0.00500000}, {43,0.00505941}, {44,0.00605941}, {45,0.00519802}, {46,0.00530693}, {47,0.00558416}, {48,0.00579208}, {49,0.00600000}, {50,0.00600990}, {51,0.00612871}, {52,0.00621782}, {53,0.00627723}, {54,0.00636634}, {55,0.00661386}, {56,0.00781188}, {57,0.00701980}, {58,0.00705941}, {59,0.00718812}, {60,0.00721782}, {61,0.00733663}, {62,0.00745545}, {63,0.00773267}, {64,0.00766337}, {65,0.00806931}, {66,0.00926733}, {67,0.00831683}, {68,0.00835644}, {69,0.00838614}, {70,0.00849505}, {71,0.00868317}, {72,0.00874257}, {73,0.00907921}, {74,0.00920792}, {75,0.00921782}, {76,0.00928713}, {77,0.00923762}, {78,0.00935644}, {79,0.00987129}, {80,0.00987129}, {81,0.01033663}, {82,0.01494059}, {83,0.01008911}, {84,0.01019802}, {85,0.01036634}, {86,0.01057426}, {87,0.01092079}, {88,0.01103960}, {89,0.01131683}, {90,0.01240594}, {91,0.01127723}, {92,0.01136634}, {93,0.01152475}, {94,0.01176238}, {95,0.01213861}, {96,0.01802970}, {97,0.01205941}, {98,0.01221782}, {99,0.01228713}, {100,0.01237624}, {101,0.01231683}, {102,0.01249505}, {103,0.01481188}, {104,0.01298020}, {105,0.01318812}, {106,0.01330693}, {107,0.01343564}, {108,0.01341584}, {109,0.01534653}, {110,0.01379208}, {111,0.01425743}, {112,0.01413861}, {113,0.01434653}, {114,0.02069307}, {115,0.01420792}, {116,0.01426733}, {117,0.01443564}, {118,0.01470297}, {119,0.01515842}, {120,0.01738614}, {121,0.01521782}, {122,0.01533663}, {123,0.01553465}, {124,0.01544554}, {125,0.01900000}, {126,0.01574257}, {127,0.01613861}, {128,0.01585149}, {129,0.01615842}, {130,0.01935644}, {131,0.01636634}, {132,0.01649505}, {133,0.01658416}, {134,0.01689109}, {135,0.01941584}, {136,0.01706931}, {137,0.01723762}, {138,0.01745545}, {139,0.01759406}, {140,0.01738614}, {141,0.01777228}, {142,0.01798020}, {143,0.01841584}, {144,0.02150495}, {145,0.01827723}, {146,0.01850495}, {147,0.01878218}, {148,0.01883168}, {149,0.01879208}, {150,0.01901980}, {151,0.01936634}, {152,0.01927723}, {153,0.02078218}, {154,0.01951485}, {155,0.01963366}, {156,0.01980198}, {157,0.02263366}, {158,0.02019802}, {159,0.02053465}, {160,0.02018812}, {161,0.02338614}, {162,0.02041584}, {163,0.02075248}, {164,0.02078218}, {165,0.02371287}, {166,0.02108911}, {167,0.02131683}, {168,0.02134653}, {169,0.02336634}, {170,0.02155446}, {171,0.02169307}, {172,0.02174257}, {173,0.02199010}, {174,0.02226733}, {175,0.02245545}, {176,0.02773267}, {177,0.02242574}, {178,0.02282178}, {179,0.02292079}, {180,0.02568317}, {181,0.02306931}, {182,0.02330693}, {183,0.03093069}, {184,0.02311881}, {185,0.02344554}, {186,0.02362376}, {187,0.02733663}, {188,0.02376238}, {189,0.02406931}, {190,0.03108911}, {191,0.02433663}, {192,0.02417822}, {193,0.02461386}, {194,0.02649505}, {195,0.02457426}, {196,0.02466337}, {197,0.02953465}, {198,0.02524752}, {199,0.02549505}, {200,0.03249505}, {201,0.02547525}, {202,0.02559406}, {203,0.02584158}, {204,0.02596040}, {205,0.02624752}, {206,0.02640594}, {207,0.02817822}, {208,0.02644554}, {209,0.02653465}, {210,0.02963366}, {211,0.02698020}, {212,0.02707921}, {213,0.03086139}, {214,0.02733663}, {215,0.02758416}, {216,0.03143564}, {217,0.02770297}, {218,0.02790099}, {219,0.03201980}, {220,0.02814851}, {221,0.02863366}, {222,0.03187129}, {223,0.02891089}, {224,0.02855446}, {225,0.03104950}, {226,0.02854455}, {227,0.02882178}, {228,0.03039604}, {229,0.02936634}, {230,0.02972277}, {231,0.02989109}, {232,0.03001980}, {233,0.03780198}, {234,0.02981188}, {235,0.03024752}, {236,0.03606931}, {237,0.03025743}, {238,0.03046535}, {239,0.03367327}, {240,0.03051485}, {241,0.03080198}, {242,0.03098020}, {243,0.03140594}, {244,0.03823762}, {245,0.03146535}, {246,0.03179208}, {247,0.03552475}, {248,0.03184158}, {249,0.04248515}, {250,0.03197030}, {251,0.03251485}, {252,0.03833663}, {253,0.03273267}, {254,0.03301980}, {255,0.03415842}, {256,0.03254455}, {257,0.04028713}, {258,0.03294059}, {259,0.03314851}, {260,0.03505941}, {261,0.03348515}, {262,0.04159406}, {263,0.03383168}, {264,0.03377228}, {265,0.03564356}, {266,0.03401980}, {267,0.04174257}, {268,0.03415842}, {269,0.03505941}, {270,0.03470297}, {271,0.03530693}, {272,0.04026733}, {273,0.03493069}, {274,0.04566337}, {275,0.03527723}, {276,0.03556436}, {277,0.03824752}, {278,0.03570297}, {279,0.04300990}, {280,0.03583168}, {281,0.04764356}, {282,0.03607921}, {283,0.03646535}, {284,0.03991089}, {285,0.03695050}, {286,0.04322772}, {287,0.03730693}, {288,0.04630693}, {289,0.03679208}, {290,0.03723762}, {291,0.03735644}, {292,0.03747525}, {293,0.04064356}, {294,0.03819802}, {295,0.04384158}, {296,0.03793069}, {297,0.04641584}, {298,0.03811881}, {299,0.04906931}, {300,0.03844554}, {301,0.03874257}, {302,0.03999010}, {303,0.03963366}, {304,0.04168317}, {305,0.03906931}, {306,0.04374257}, {307,0.03992079}, {308,0.04577228}, {309,0.03986139}, {310,0.04779208}, {311,0.04055446}, {312,0.04903960}, {313,0.04029703}, {314,0.05050495}, {315,0.04087129}, {316,0.05162376}, {317,0.04100000}, {318,0.05293069}, {319,0.04135644}, {320,0.05363366}, {321,0.04083168}, {322,0.04115842}, {323,0.04163366}, {324,0.04167327}, {325,0.04197030}, {326,0.04208911}, {327,0.04234653}, {328,0.04201980}, {329,0.04248515}, {330,0.04248515}, {331,0.04302970}, {332,0.04318812}, {333,0.04310891}, {334,0.04455446}, {335,0.04407921}, {336,0.05519802}, {337,0.04319802}, {338,0.05493069}, {339,0.04388119}, {340,0.05528713}, {341,0.04410891}, {342,0.05205941}, {343,0.04438614}, {344,0.05200000}, {345,0.04473267}, {346,0.05146535}, {347,0.04500000}, {348,0.04993069}, {349,0.04547525}, {350,0.04874257}, {351,0.04617822}, {352,0.04675248}, {353,0.04551485}, {354,0.04582178}, {355,0.05696040}, {356,0.04579208}, {357,0.05486139}, {358,0.04637624}, {359,0.05342574}, {360,0.04617822}, {361,0.05097030}, {362,0.04667327}, {363,0.04908911}, {364,0.06012871}, {365,0.04746535}, {366,0.06105941}, {367,0.04799010}, {368,0.05419802}, {369,0.04790099}, {370,0.05204950}, {371,0.04851485}, {372,0.04795050}, {373,0.06027723}, {374,0.04853465}, {375,0.05725743}, {376,0.04867327}, {377,0.05329703}, {378,0.04893069}, {379,0.04942574}, {380,0.06058416}, {381,0.04990099}, {382,0.05681188}, {383,0.05023762}, {384,0.05142574}, {385,0.06339604}, {386,0.04955446}, {387,0.05896040}, {388,0.04995050}, {389,0.05444554}, {390,0.06597030}, {391,0.05027723}, {392,0.06018812}, {393,0.05069307}, {394,0.05558416}, {395,0.06777228}, {396,0.05088119}, {397,0.06122772}, {398,0.05187129}, {399,0.05602970}, {400,0.06648515}, {401,0.05163366}, {402,0.06078218}, {403,0.05249505}, {404,0.05503960}, {405,0.06582178}, {406,0.05242574}, {407,0.05996040}, {408,0.05249505}, {409,0.05279208}, {410,0.06312871}, {411,0.05348515}, {412,0.05691089}, {413,0.06736634}, {414,0.05373267}, {415,0.06035644}, {416,0.07115842}, {417,0.05350495}, {418,0.06264356}, {419,0.05441584}, {420,0.05580198}, {421,0.06601980}, {422,0.05461386}, {423,0.05872277}, {424,0.06742574}, {425,0.05515842}, {426,0.06026733}, {427,0.06964356}, {428,0.05520792}, {429,0.06178218}, {430,0.07275248}, {431,0.05613861}, {432,0.06011881}, {433,0.07980198}, {434,0.05576238}, {435,0.06726733}, {436,0.08026733}, {437,0.05699010}, {438,0.06752475}, {439,0.08089109}, {440,0.05668317}, {441,0.06818812}, {442,0.07609901}, {443,0.05769307}, {444,0.06470297}, {445,0.07454455}, {446,0.05819802}, {447,0.06475248}, {448,0.07254455}, {449,0.05796040}, {450,0.06280198}, {451,0.07193069}, {452,0.05812871}, {453,0.06192079}, {454,0.07085149}, {455,0.05928713}, {456,0.05988119}, {457,0.06924752}, {458,0.07838614}, {459,0.05961386}, {460,0.06704950}, {461,0.07546535}, {462,0.06008911}, {463,0.06451485}, {464,0.07235644}, {465,0.06011881}, {466,0.06033663}, {467,0.06971287}, {468,0.07295050}, {469,0.06086139}, {470,0.06572277}, {471,0.07291089}, {472,0.06098020}, {473,0.06121782}, {474,0.06917822}, {475,0.07671287}, {476,0.06161386}, {477,0.06529703}, {478,0.07222772}, {479,0.08152475}, {480,0.06158416}, {481,0.06754455}, {482,0.07445545}, {483,0.06277228}, {484,0.06260396}, {485,0.06932673}, {486,0.07630693}, {487,0.06387129}, {488,0.06409901}, {489,0.07128713}, {490,0.07783168}, {491,0.06443564}, {492,0.06530693}, {493,0.07221782}, {494,0.07832673}, {495,0.06475248}, {496,0.06545545}, {497,0.07191089}, {498,0.07811881}, {499,0.06489109}, {500,0.06546535}, {505,0.07200990}, {510,0.07895050}, {515,0.08474257}, {520,0.06662376}, {525,0.07198020}, {530,0.07823762}, {535,0.08519802}, {540,0.09024752}, {545,0.07022772}, {550,0.07345545}, {555,0.07896040}, {560,0.08340594}, {565,0.08868317}, {570,0.09268317}, {575,0.09744554}, {580,0.07531683}, {585,0.07720792}, {590,0.08167327}, {595,0.08473267}, {600,0.08765347}, {605,0.09138614}, {610,0.09324752}, {615,0.09699010}, {620,0.09887129}, {625,0.10070297}, {630,0.10254455}, {635,0.10364356}, {640,0.10290099}, {645,0.10480198}, {650,1.09667327}, {655,0.11848515}, {660,0.11736634}, {665,0.11872277}, {670,0.11331683}, {675,0.11140594}, {680,0.11061386}, {685,0.11090099}, {690,0.11038614}, {695,0.11027723}, {700,0.10887129}, {705,0.10750495}, {710,0.10595050}, {715,0.10425743}, {720,0.10253465}, {725,0.10196040}, {730,0.09981188}, {735,0.12358416}, {740,0.12050495}, {745,0.11864356}, {750,0.11537624}, {755,0.11205941}, {760,0.10861386}, {765,0.10650495}, {770,0.12394059}, {775,0.12119802}, {780,0.11798020}, {785,0.11148515}, {790,0.11089109}, {795,0.12973267}, {800,0.11742574}, {805,0.11581188}, {810,0.11302970}, {815,0.11713861}, {820,0.14158416}, {825,0.13522772}, {830,0.12740594}, {835,0.11836634}, {840,0.13573267}, {845,0.12943564}, {850,0.12193069}, {855,0.14175248}, {860,0.13505941}, {865,0.12685149}, {870,0.14531683}, {875,0.13407921}, {880,0.12816832}, {885,0.14726733}, {890,0.13942574}, {895,0.13159406}, {900,0.14536634}, {905,0.13660396}, {910,0.12918812}, {915,0.14397030}, {920,0.13478218}, {925,0.14995050}, {930,0.14056436}, {935,0.13298020}, {940,0.14591089}, {945,0.13693069}, {950,0.15015842}, {955,0.14203960}, {960,0.15225743}, {965,0.13989109}, {970,0.15545545}, {975,0.14820792}, {980,0.17416832}, {985,0.15758416}, {990,0.17013861}, {995,0.15308911}, {1000,0.16538614}, {1010,0.15465347}, {1020,0.16734653}, {1030,0.15336634}, {1040,0.16191089}, {1050,0.15162376}, {1060,0.16199010}, {1070,0.17459406}, {1080,0.15958416}, {1090,0.16826733}, {1100,0.17727723}, {1110,0.16352475}, {1120,0.16904950}, {1130,0.17962376}, {1140,0.16559406}, {1150,0.17459406}, {1160,0.17874257}, {1170,0.18611881}, {1180,0.19306931}, {1190,0.18047525}, {1200,0.19294059}, {1210,0.20062376}, {1220,0.19911881}, {1230,0.20248515}, {1240,0.20700000}, {1250,0.21102970}, {1260,0.18522772}, {1270,0.19274257}, {1280,0.19142574}, {1290,0.19655446}, {1300,0.19865347}, {1310,0.20095050}, {1320,0.20021782}, {1330,0.20209901}, {1340,0.20330693}, {1350,0.20319802}, {1360,0.20276238}, {1370,0.20378218}, {1380,0.22522772}, {1390,0.22524752}, {1400,0.24367327}, {1410,0.23504950}, {1420,0.22390099}, {1430,0.22307921}, {1440,0.21807921}, {1450,0.24251485}, {1460,0.22773267}, {1470,0.23382178}, {1480,0.22652475}, {1490,0.24337624}, {1500,0.23858416}, {1510,0.23365347}, {1520,0.24958416}, {1530,0.24581188}, {1540,0.23592079}, {1550,0.25211881}, {1560,0.26693069}, {1570,0.25241584}, {1580,0.25845545}, {1590,0.25408911}, {1600,0.26845545}, {1610,0.25807921}, {1620,0.24864356}, {1630,0.26309901}, {1640,0.24953465}, {1650,0.26268317}, {1660,0.25443564}, {1670,0.26191089}, {1680,0.27692079}, {1690,0.26328713}, {1700,0.30000990}, {1710,0.27619802}, {1720,0.27695050}, {1730,0.29406931}, {1740,0.27202970}, {1750,0.28608911}, {1760,0.26900990}, {1770,0.27721782}, {1780,0.28410891}, {1790,0.29386139}, {1800,0.27538614}, {1810,0.28257426}, {1820,0.30220792}, {1830,0.32090099}, {1840,0.28662376}, {1850,0.29470297}, {1860,0.29575248}, {1870,0.29476238}, {1880,0.30740594}, {1890,0.31055446}, {1900,0.31311881}, {1910,0.29575248}, {1920,0.29389109}, {1930,0.29861386}, {1940,0.30039604}, {1950,0.32609901}, {1960,0.31906931}, {1970,0.31600000}, {1980,0.31789109}, {1990,0.31081188}, {2000,0.31472277}, {2050,0.31733663}, {2100,0.34495050}, {2150,0.34701980}, {2200,0.34663366}, {2250,0.36529703}, {2300,0.39970297}, {2350,0.39569307}, {2400,0.38534653}, {2450,0.39469307}, {2500,0.41015842}, {2550,0.41902970}, {2600,0.42296040}, {2650,0.43275248}, {2700,0.47076238}, {2750,0.45747525}, {2800,0.45614851}, {2850,0.47518812}, {2900,0.46979208}, {2950,0.48827723}, {3000,0.48621782}, {3050,0.52793069}, {3100,0.50209901}, {3150,0.51083168}, {3200,0.51990099}, {3250,0.52609901}, {3300,0.52900000}, {3350,0.53518812}, {3400,0.57437624}, {3450,0.58918812}, {3500,0.58259406}, {3550,0.57579208}, {3600,0.58571287}, {3650,0.59048515}, {3700,0.63140594}, {3750,0.62175248}, {3800,0.64197030}, {3850,0.61918812}, {3900,0.63190099}, {3950,0.66941584}, {4000,0.68339604}, {4050,0.67697030}, {4100,0.67025743}, {4150,0.67399010}, {4200,0.69940594}, {4250,0.72576238}, {4300,0.71749505}, {4350,0.72232673}, {4400,0.71729703}, {4450,0.73061386}, {4500,0.78473267}, {4550,0.76600990}, {4600,0.77321782}, {4650,0.76968317}, {4700,0.79597030}, {4750,0.79903960}, {4800,0.80700000}, {4850,0.80471287}, {4900,0.79799010}, {4950,0.85447525}, {5000,0.84482178}, {5050,0.84028713}, {5100,0.84593069}, {5150,0.87693069}, {5200,0.87096040}, {5250,0.86500990}, {5300,0.87709901}, {5350,0.88804950}, {5400,0.91408911}, {5450,0.91306931}, {5500,0.90404950}, {5550,0.92689109}, {5600,0.96426733}, {5650,0.94539604}, {5700,0.95257426}, {5750,0.98792079}, {5800,0.97915842}, {5850,0.98155446}, {5900,0.97337624}, {5950,1.02102970}, {6000,1.02414851}, {6050,1.0322571}, {6100,1.0528571}, {6150,1.0610286}, {6200,1.0562857}, {6250,1.1104000}, {6300,1.0810857}, {6350,1.0970286}, {6400,1.0552000}, {6450,1.1075429}, {6500,1.1188286}, {6550,1.1429714}, {6600,3.7857143}, {6650,1.1632571}, {6700,1.1491714}, {6750,1.1703714}, {6800,1.1695143}, {6850,1.1430571}, {6900,1.1384857}, {6950,1.2259143}, {7000,1.2025429}, {7050,1.2017143}, {7100,1.2334286}, {7150,1.2339714}, {7200,1.2042857}, {7250,1.2711143}, {7300,1.2479429}, {7350,1.2564000}, {7400,1.2736857}, {7450,1.2614857}, {7500,1.2770571}, {7550,1.3334571}, {7600,1.3180286}, {7650,1.3249714}, {7700,1.3054857}, {7750,1.3208286}, {7800,1.3177429}, {7850,1.3684571}, {7900,1.3682286}, {7950,1.3647429}, {8000,1.3723714}, {8050,1.3712571}, {8100,1.3806857}, {8150,1.4426286}, {8200,1.4107429}, {8250,1.3977429}, {8300,1.4301714}, {8350,1.4302571}, {8400,1.4282000}, {8450,1.4545143}, {8500,1.4604286}, {8550,1.4818286}, {8600,1.4785429}, {8650,1.4661714}, {8700,1.5287429}, {8750,1.5207429}, {8800,1.4754286}, {8850,1.5185429}, {8900,1.4897714}, {8950,1.5395429}, {9000,1.5551714}, {9050,1.5626857}, {9100,1.5720857}, {9150,1.5691429}, {9200,1.5965429}, {9250,1.5891714}, {9300,1.5817714}, {9350,1.6063714}, {9400,1.5895714}, {9450,1.6550571}, {9500,1.6407714}, {9550,1.6429143}, {9600,1.6321714}, {9650,1.6434571}, {9700,1.6744286}, {9750,1.6902286}, {9800,1.6658571}, {9850,1.7080571}, {9900,1.6790000}, {9950,1.7639143}, {10000,1.7281143}, {10100,1.7463429}, {10200,1.7470857}, {10300,1.7734857}, {10400,1.7782000}, {10500,1.7876857}, {10600,1.8310286}, {10700,1.8404000}, {10800,1.8705429}, {10900,1.8781143}, {11000,1.9170000}, {11100,1.9121429}, {11200,1.9407714}, {11300,1.9440571}, {11400,1.9586857}, {11500,1.9656857}, {11600,2.0083714}, {11700,2.0557143}, {11800,2.0170857}, {11900,2.0509429}, {12000,2.0886286}, {12100,2.0563714}, {12200,2.0995429}, {12300,2.0816286}, {12400,2.1661143}, {12500,2.1455143}, {12600,2.1648000}, {12700,2.2036857}, {12800,2.1818571}, {12900,2.2206286}, {13000,2.2284857}, {13100,2.3041714}, {13200,2.2777429}, {13300,2.3176000}, {13400,2.3027714}, {13500,2.3687714}, {13600,2.3163714}, {13700,2.3476571}, {13800,2.4413714}, {13900,2.4139714}, {14000,2.4120571}, {14100,2.4874571}, {14200,2.4873714}, {14300,2.5182000}, {14400,2.4878000}, {14500,2.4895143}, {14600,2.5035429}, {14700,2.5692286}, {14800,2.5797429}, {14900,2.5843714}, {15000,2.5605714}, {15100,2.6993429}, {15200,2.6346000}, {15300,2.6877714}, {15400,2.6697143}, {15500,2.6844571}, {15600,2.7330571}, {15700,2.7612571}, {15800,2.7518857}, {15900,2.7342286}, {16000,2.7721714}, {16100,2.7828571}, {16200,2.8007143}, {16300,2.8704857}, {16400,2.7824571}, {16500,2.8616571}, {16600,2.9006857}, {16700,2.9063143}, {16800,2.9028000}, {16900,2.8999429}, {17000,2.9207714}, {17100,2.9917143}, {17200,2.9725429}, {17300,2.9778571}, {17400,3.0857143}, {17500,3.0234857}, {17600,3.0235429}, {17700,3.0291429}, {17800,3.0604000}, {17900,3.1794857}, {18000,3.0980000}, {18100,3.1609429}, {18200,3.1529714}, {18300,3.1850857}, {18400,3.2410571}, {18500,3.1747143}, {18600,3.2172857}, {18700,3.2241143}, {18800,3.2082571}, {18900,3.3183143}, {19000,3.2418286}, {19100,3.3621143}, {19200,3.2736286}, {19300,6.7796286}, {19400,3.4048857}, {19500,3.3564857}, {19600,3.3733429}, {19700,3.4446571}, {19800,3.4347429}, {19900,3.5186857}, {20000,3.4324571}};
data["big_flat"]["LtacPrimUncurry"]["actual reif"]["user"] = {{1,0.00005941}, {2,0.00010891}, {3,0.00054455}, {4,0.00045545}, {5,0.00101980}, {6,0.00077228}, {7,0.00103960}, {8,0.00086139}, {9,0.00084158}, {10,0.00121782}, {11,0.00142574}, {12,0.00123762}, {13,0.00159406}, {14,0.00156436}, {15,0.00174257}, {16,0.00181188}, {17,0.00195050}, {18,0.00221782}, {19,0.00203960}, {20,0.00233663}, {21,0.00248515}, {22,0.00246535}, {23,0.00260396}, {24,0.00276238}, {25,0.00276238}, {26,0.00289109}, {27,0.00319802}, {28,0.00319802}, {29,0.00320792}, {30,0.00350495}, {31,0.00340594}, {32,0.00364356}, {33,0.00382178}, {34,0.00399010}, {35,0.00421782}, {36,0.00441584}, {37,0.00417822}, {38,0.00456436}, {39,0.00467327}, {40,0.00492079}, {41,0.00488119}, {42,0.00508911}, {43,0.00521782}, {44,0.00642574}, {45,0.00553465}, {46,0.00579208}, {47,0.00600990}, {48,0.00595050}, {49,0.00611881}, {50,0.00614851}, {51,0.00628713}, {52,0.00666337}, {53,0.00677228}, {54,0.00681188}, {55,0.00706931}, {56,0.00800990}, {57,0.00697030}, {58,0.00749505}, {59,0.00760396}, {60,0.00751485}, {61,0.00781188}, {62,0.00800000}, {63,0.00819802}, {64,0.00822772}, {65,0.00815842}, {66,0.00929703}, {67,0.00846535}, {68,0.00843564}, {69,0.00880198}, {70,0.00886139}, {71,0.00917822}, {72,0.00920792}, {73,0.00936634}, {74,0.00904950}, {75,0.00950495}, {76,0.00947525}, {77,0.00967327}, {78,0.00969307}, {79,0.00996040}, {80,0.00989109}, {81,0.01014851}, {82,0.01506931}, {83,0.01015842}, {84,0.01032673}, {85,0.01040594}, {86,0.01092079}, {87,0.01102970}, {88,0.01081188}, {89,0.01114851}, {90,0.01219802}, {91,0.01116832}, {92,0.01133663}, {93,0.01192079}, {94,0.01176238}, {95,0.01192079}, {96,0.01775248}, {97,0.01183168}, {98,0.01248515}, {99,0.01245545}, {100,0.01243564}, {101,0.01256436}, {102,0.01261386}, {103,0.01517822}, {104,0.01320792}, {105,0.01334653}, {106,0.01346535}, {107,0.01358416}, {108,0.01382178}, {109,0.01594059}, {110,0.01409901}, {111,0.01392079}, {112,0.01429703}, {113,0.01471287}, {114,0.02109901}, {115,0.01465347}, {116,0.01441584}, {117,0.01473267}, {118,0.01517822}, {119,0.01543564}, {120,0.01774257}, {121,0.01542574}, {122,0.01600990}, {123,0.01623762}, {124,0.01608911}, {125,0.01901980}, {126,0.01602970}, {127,0.01646535}, {128,0.01621782}, {129,0.01642574}, {130,0.01937624}, {131,0.01684158}, {132,0.01702970}, {133,0.01697030}, {134,0.01736634}, {135,0.01957426}, {136,0.01709901}, {137,0.01728713}, {138,0.01734653}, {139,0.01781188}, {140,0.01798020}, {141,0.01808911}, {142,0.01811881}, {143,0.01833663}, {144,0.02165347}, {145,0.01825743}, {146,0.01874257}, {147,0.01896040}, {148,0.01884158}, {149,0.01892079}, {150,0.01898020}, {151,0.01935644}, {152,0.01910891}, {153,0.02056436}, {154,0.01963366}, {155,0.01976238}, {156,0.01987129}, {157,0.02265347}, {158,0.02026733}, {159,0.02030693}, {160,0.02036634}, {161,0.02340594}, {162,0.02011881}, {163,0.02048515}, {164,0.02061386}, {165,0.02352475}, {166,0.02104950}, {167,0.02111881}, {168,0.02125743}, {169,0.02370297}, {170,0.02135644}, {171,0.02169307}, {172,0.02201980}, {173,0.02181188}, {174,0.02268317}, {175,0.02215842}, {176,0.02796040}, {177,0.02254455}, {178,0.02275248}, {179,0.02307921}, {180,0.02592079}, {181,0.02259406}, {182,0.02331683}, {183,0.03086139}, {184,0.02301980}, {185,0.02346535}, {186,0.02360396}, {187,0.02759406}, {188,0.02347525}, {189,0.02398020}, {190,0.03143564}, {191,0.02463366}, {192,0.02398020}, {193,0.02458416}, {194,0.02657426}, {195,0.02444554}, {196,0.02461386}, {197,0.02962376}, {198,0.02499010}, {199,0.02571287}, {200,0.03280198}, {201,0.02514851}, {202,0.02567327}, {203,0.02619802}, {204,0.02613861}, {205,0.02614851}, {206,0.02669307}, {207,0.02851485}, {208,0.02669307}, {209,0.02643564}, {210,0.03010891}, {211,0.02741584}, {212,0.02713861}, {213,0.03145545}, {214,0.02761386}, {215,0.02786139}, {216,0.03172277}, {217,0.02811881}, {218,0.02801980}, {219,0.03202970}, {220,0.02841584}, {221,0.02891089}, {222,0.03215842}, {223,0.02923762}, {224,0.02859406}, {225,0.03143564}, {226,0.02866337}, {227,0.02902970}, {228,0.03081188}, {229,0.02962376}, {230,0.02980198}, {231,0.03026733}, {232,0.03022772}, {233,0.03732673}, {234,0.03019802}, {235,0.03033663}, {236,0.03599010}, {237,0.03064356}, {238,0.03062376}, {239,0.03364356}, {240,0.03094059}, {241,0.03124752}, {242,0.03130693}, {243,0.03186139}, {244,0.03803960}, {245,0.03146535}, {246,0.03201980}, {247,0.03535644}, {248,0.03198020}, {249,0.04249505}, {250,0.03213861}, {251,0.03287129}, {252,0.03800990}, {253,0.03262376}, {254,0.03328713}, {255,0.03433663}, {256,0.03248515}, {257,0.04003960}, {258,0.03296040}, {259,0.03333663}, {260,0.03490099}, {261,0.03336634}, {262,0.04157426}, {263,0.03391089}, {264,0.03370297}, {265,0.03558416}, {266,0.03385149}, {267,0.04191089}, {268,0.03389109}, {269,0.03520792}, {270,0.03467327}, {271,0.03501980}, {272,0.04032673}, {273,0.03464356}, {274,0.04605941}, {275,0.03510891}, {276,0.03531683}, {277,0.03790099}, {278,0.03550495}, {279,0.04293069}, {280,0.03564356}, {281,0.04754455}, {282,0.03592079}, {283,0.03608911}, {284,0.03983168}, {285,0.03678218}, {286,0.04350495}, {287,0.03734653}, {288,0.04645545}, {289,0.03642574}, {290,0.03688119}, {291,0.03708911}, {292,0.03732673}, {293,0.04043564}, {294,0.03796040}, {295,0.04395050}, {296,0.03728713}, {297,0.04665347}, {298,0.03793069}, {299,0.04912871}, {300,0.03824752}, {301,0.03868317}, {302,0.03966337}, {303,0.03928713}, {304,0.04159406}, {305,0.03914851}, {306,0.04385149}, {307,0.04000000}, {308,0.04590099}, {309,0.03968317}, {310,0.04788119}, {311,0.04057426}, {312,0.04902970}, {313,0.04039604}, {314,0.05054455}, {315,0.04063366}, {316,0.05129703}, {317,0.04112871}, {318,0.05240594}, {319,0.04106931}, {320,0.05330693}, {321,0.04062376}, {322,0.04100990}, {323,0.04148515}, {324,0.04131683}, {325,0.04163366}, {326,0.04217822}, {327,0.04238614}, {328,0.04208911}, {329,0.04284158}, {330,0.04257426}, {331,0.04321782}, {332,0.04329703}, {333,0.04330693}, {334,0.04471287}, {335,0.04441584}, {336,0.05476238}, {337,0.04347525}, {338,0.05460396}, {339,0.04386139}, {340,0.05482178}, {341,0.04404950}, {342,0.05172277}, {343,0.04439604}, {344,0.05152475}, {345,0.04488119}, {346,0.05119802}, {347,0.04507921}, {348,0.04977228}, {349,0.04568317}, {350,0.04878218}, {351,0.04637624}, {352,0.04678218}, {353,0.04559406}, {354,0.04617822}, {355,0.05645545}, {356,0.04618812}, {357,0.05466337}, {358,0.04647525}, {359,0.05304950}, {360,0.04628713}, {361,0.05053465}, {362,0.04656436}, {363,0.04876238}, {364,0.05993069}, {365,0.04745545}, {366,0.05955446}, {367,0.04777228}, {368,0.05393069}, {369,0.04796040}, {370,0.05178218}, {371,0.04850495}, {372,0.04793069}, {373,0.05973267}, {374,0.04847525}, {375,0.05695050}, {376,0.04838614}, {377,0.05324752}, {378,0.04873267}, {379,0.04929703}, {380,0.06038614}, {381,0.04936634}, {382,0.05681188}, {383,0.04949505}, {384,0.05100990}, {385,0.06343564}, {386,0.04899010}, {387,0.05866337}, {388,0.04977228}, {389,0.05438614}, {390,0.06623762}, {391,0.05015842}, {392,0.05999010}, {393,0.05057426}, {394,0.05521782}, {395,0.06739604}, {396,0.05062376}, {397,0.06116832}, {398,0.05194059}, {399,0.05606931}, {400,0.06610891}, {401,0.05110891}, {402,0.06071287}, {403,0.05219802}, {404,0.05473267}, {405,0.06605941}, {406,0.05217822}, {407,0.05957426}, {408,0.05213861}, {409,0.05229703}, {410,0.06324752}, {411,0.05339604}, {412,0.05656436}, {413,0.06711881}, {414,0.05391089}, {415,0.06036634}, {416,0.07099010}, {417,0.05342574}, {418,0.06271287}, {419,0.05464356}, {420,0.05564356}, {421,0.06605941}, {422,0.05468317}, {423,0.05857426}, {424,0.06724752}, {425,0.05535644}, {426,0.06049505}, {427,0.06917822}, {428,0.05497030}, {429,0.06200000}, {430,0.07249505}, {431,0.05637624}, {432,0.05999010}, {433,0.07946535}, {434,0.05564356}, {435,0.06732673}, {436,0.07980198}, {437,0.05666337}, {438,0.06733663}, {439,0.08062376}, {440,0.05662376}, {441,0.06785149}, {442,0.07590099}, {443,0.05788119}, {444,0.06487129}, {445,0.07413861}, {446,0.05802970}, {447,0.06463366}, {448,0.07202970}, {449,0.05775248}, {450,0.06270297}, {451,0.07151485}, {452,0.05800990}, {453,0.06176238}, {454,0.07010891}, {455,0.05901980}, {456,0.05990099}, {457,0.06894059}, {458,0.07819802}, {459,0.05954455}, {460,0.06710891}, {461,0.07514851}, {462,0.06031683}, {463,0.06467327}, {464,0.07169307}, {465,0.06019802}, {466,0.06010891}, {467,0.06937624}, {468,0.07271287}, {469,0.06083168}, {470,0.06597030}, {471,0.07226733}, {472,0.06073267}, {473,0.06111881}, {474,0.06885149}, {475,0.07640594}, {476,0.06131683}, {477,0.06527723}, {478,0.07210891}, {479,0.08093069}, {480,0.06140594}, {481,0.06741584}, {482,0.07408911}, {483,0.06282178}, {484,0.06287129}, {485,0.06891089}, {486,0.07600990}, {487,0.06387129}, {488,0.06434653}, {489,0.07048515}, {490,0.07753465}, {491,0.06466337}, {492,0.06553465}, {493,0.07182178}, {494,0.07794059}, {495,0.06503960}, {496,0.06561386}, {497,0.07157426}, {498,0.07766337}, {499,0.06513861}, {500,0.06550495}, {505,0.07141584}, {510,0.07854455}, {515,0.08441584}, {520,0.06681188}, {525,0.07143564}, {530,0.07817822}, {535,0.08475248}, {540,0.08962376}, {545,0.07000990}, {550,0.07345545}, {555,0.07872277}, {560,0.08285149}, {565,0.08846535}, {570,0.09239604}, {575,0.09705941}, {580,0.07526733}, {585,0.07739604}, {590,0.08113861}, {595,0.08442574}, {600,0.08687129}, {605,0.09088119}, {610,0.09300990}, {615,0.09667327}, {620,0.09873267}, {625,0.10008911}, {630,0.10222772}, {635,0.10354455}, {640,0.10269307}, {645,0.10469307}, {650,1.09298020}, {655,0.11859406}, {660,0.11703960}, {665,0.11854455}, {670,0.11284158}, {675,0.11142574}, {680,0.11020792}, {685,0.11081188}, {690,0.10988119}, {695,0.11010891}, {700,0.10886139}, {705,0.10752475}, {710,0.10584158}, {715,0.10402970}, {720,0.10233663}, {725,0.10173267}, {730,0.09984158}, {735,0.12342574}, {740,0.12026733}, {745,0.11843564}, {750,0.11511881}, {755,0.11144554}, {760,0.10842574}, {765,0.10610891}, {770,0.12392079}, {775,0.12099010}, {780,0.11760396}, {785,0.11119802}, {790,0.11084158}, {795,0.12970297}, {800,0.11698020}, {805,0.11561386}, {810,0.11254455}, {815,0.11616832}, {820,0.14150495}, {825,0.13542574}, {830,0.12764356}, {835,0.11816832}, {840,0.13550495}, {845,0.12944554}, {850,0.12165347}, {855,0.14160396}, {860,0.13497030}, {865,0.12692079}, {870,0.14531683}, {875,0.13422772}, {880,0.12785149}, {885,0.14717822}, {890,0.13913861}, {895,0.13158416}, {900,0.14519802}, {905,0.13647525}, {910,0.12899010}, {915,0.14375248}, {920,0.13429703}, {925,0.14880198}, {930,0.14007921}, {935,0.13276238}, {940,0.14584158}, {945,0.13652475}, {950,0.14972277}, {955,0.14142574}, {960,0.15196040}, {965,0.13990099}, {970,0.15504950}, {975,0.14763366}, {980,0.17412871}, {985,0.15698020}, {990,0.16990099}, {995,0.15249505}, {1000,0.16503960}, {1010,0.15425743}, {1020,0.16703960}, {1030,0.15318812}, {1040,0.16132673}, {1050,0.15151485}, {1060,0.16211881}, {1070,0.17427723}, {1080,0.15945545}, {1090,0.16812871}, {1100,0.17700000}, {1110,0.16311881}, {1120,0.16884158}, {1130,0.17901980}, {1140,0.16536634}, {1150,0.17395050}, {1160,0.17860396}, {1170,0.18628713}, {1180,0.19288119}, {1190,0.18038614}, {1200,0.19250495}, {1210,0.20053465}, {1220,0.19876238}, {1230,0.20234653}, {1240,0.20647525}, {1250,0.21097030}, {1260,0.18510891}, {1270,0.19290099}, {1280,0.19142574}, {1290,0.19641584}, {1300,0.19813861}, {1310,0.20090099}, {1320,0.19989109}, {1330,0.20216832}, {1340,0.20334653}, {1350,0.20324752}, {1360,0.20252475}, {1370,0.20381188}, {1380,0.22488119}, {1390,0.22501980}, {1400,0.24350495}, {1410,0.23500000}, {1420,0.22371287}, {1430,0.22271287}, {1440,0.21792079}, {1450,0.24184158}, {1460,0.22754455}, {1470,0.23332673}, {1480,0.22625743}, {1490,0.24316832}, {1500,0.23819802}, {1510,0.23333663}, {1520,0.24947525}, {1530,0.24551485}, {1540,0.23566337}, {1550,0.25194059}, {1560,0.26634653}, {1570,0.25197030}, {1580,0.25801980}, {1590,0.25358416}, {1600,0.26821782}, {1610,0.25760396}, {1620,0.24831683}, {1630,0.26269307}, {1640,0.24914851}, {1650,0.26235644}, {1660,0.25415842}, {1670,0.26174257}, {1680,0.27667327}, {1690,0.26314851}, {1700,0.29957426}, {1710,0.27611881}, {1720,0.27656436}, {1730,0.29355446}, {1740,0.27186139}, {1750,0.28570297}, {1760,0.26873267}, {1770,0.27690099}, {1780,0.28372277}, {1790,0.29320792}, {1800,0.27506931}, {1810,0.28221782}, {1820,0.30206931}, {1830,0.32051485}, {1840,0.28655446}, {1850,0.29415842}, {1860,0.29530693}, {1870,0.29411881}, {1880,0.30686139}, {1890,0.31031683}, {1900,0.31321782}, {1910,0.29558416}, {1920,0.29353465}, {1930,0.29813861}, {1940,0.30012871}, {1950,0.32560396}, {1960,0.31897030}, {1970,0.31584158}, {1980,0.31733663}, {1990,0.31024752}, {2000,0.31418812}, {2050,0.31692079}, {2100,0.34471287}, {2150,0.34642574}, {2200,0.34619802}, {2250,0.36483168}, {2300,0.39942574}, {2350,0.39534653}, {2400,0.38472277}, {2450,0.39449505}, {2500,0.40975248}, {2550,0.41829703}, {2600,0.42236634}, {2650,0.43203960}, {2700,0.47011881}, {2750,0.45700000}, {2800,0.45541584}, {2850,0.47453465}, {2900,0.46909901}, {2950,0.48754455}, {3000,0.48555446}, {3050,0.52728713}, {3100,0.50188119}, {3150,0.51036634}, {3200,0.51913861}, {3250,0.52550495}, {3300,0.52841584}, {3350,0.53454455}, {3400,0.57334653}, {3450,0.58828713}, {3500,0.58166337}, {3550,0.57500000}, {3600,0.58490099}, {3650,0.58972277}, {3700,0.63079208}, {3750,0.62084158}, {3800,0.64100000}, {3850,0.61859406}, {3900,0.63122772}, {3950,0.66854455}, {4000,0.68283168}, {4050,0.67631683}, {4100,0.66719802}, {4150,0.67103960}, {4200,0.69751485}, {4250,0.72501980}, {4300,0.71653465}, {4350,0.72151485}, {4400,0.71609901}, {4450,0.73000990}, {4500,0.78388119}, {4550,0.76499010}, {4600,0.77202970}, {4650,0.76870297}, {4700,0.79495050}, {4750,0.79816832}, {4800,0.80638614}, {4850,0.80402970}, {4900,0.79712871}, {4950,0.85358416}, {5000,0.84420792}, {5050,0.83934653}, {5100,0.84445545}, {5150,0.87627723}, {5200,0.86995050}, {5250,0.86386139}, {5300,0.87624752}, {5350,0.88715842}, {5400,0.91293069}, {5450,0.91218812}, {5500,0.90298020}, {5550,0.92599010}, {5600,0.96312871}, {5650,0.94426733}, {5700,0.95113861}, {5750,0.98697030}, {5800,0.97798020}, {5850,0.98034653}, {5900,0.97205941}, {5950,1.02000990}, {6000,1.02278218}, {6050,1.0268000}, {6100,1.0482000}, {6150,1.0550857}, {6200,1.0532571}, {6250,1.1092571}, {6300,1.0763714}, {6350,1.0925429}, {6400,1.0493714}, {6450,1.1067714}, {6500,1.1177143}, {6550,1.1422571}, {6600,3.7810571}, {6650,1.1616286}, {6700,1.1482571}, {6750,1.1692000}, {6800,1.1684000}, {6850,1.1420000}, {6900,1.1379714}, {6950,1.2247143}, {7000,1.2015143}, {7050,1.2006000}, {7100,1.2316000}, {7150,1.2264857}, {7200,1.1977714}, {7250,1.2659143}, {7300,1.2466286}, {7350,1.2556571}, {7400,1.2732000}, {7450,1.2604571}, {7500,1.2760571}, {7550,1.3326857}, {7600,1.3171429}, {7650,1.3237143}, {7700,1.3037714}, {7750,1.3196571}, {7800,1.3165429}, {7850,1.3672857}, {7900,1.3674857}, {7950,1.3640857}, {8000,1.3718857}, {8050,1.3704857}, {8100,1.3806571}, {8150,1.4413714}, {8200,1.4096286}, {8250,1.3970286}, {8300,1.4298286}, {8350,1.4298571}, {8400,1.4272000}, {8450,1.4537429}, {8500,1.4592571}, {8550,1.4805143}, {8600,1.4773143}, {8650,1.4654857}, {8700,1.5278571}, {8750,1.5196000}, {8800,1.4748571}, {8850,1.5169714}, {8900,1.4887143}, {8950,1.5389143}, {9000,1.5538857}, {9050,1.5617714}, {9100,1.5706286}, {9150,1.5686000}, {9200,1.5948000}, {9250,1.5876286}, {9300,1.5806857}, {9350,1.6056286}, {9400,1.5884857}, {9450,1.6532857}, {9500,1.6398571}, {9550,1.6389714}, {9600,1.6277143}, {9650,1.6396857}, {9700,1.6724857}, {9750,1.6875714}, {9800,1.6612286}, {9850,1.7064571}, {9900,1.6757714}, {9950,1.7608571}, {10000,1.7262286}, {10100,1.7451714}, {10200,1.7438571}, {10300,1.7719429}, {10400,1.7730286}, {10500,1.7838286}, {10600,1.8268286}, {10700,1.8383429}, {10800,1.8676857}, {10900,1.8743714}, {11000,1.9146857}, {11100,1.9067429}, {11200,1.9401714}, {11300,1.9433143}, {11400,1.9574571}, {11500,1.9653429}, {11600,2.0071143}, {11700,2.0482000}, {11800,2.0163714}, {11900,2.0499143}, {12000,2.0875714}, {12100,2.0550286}, {12200,2.0985143}, {12300,2.0794000}, {12400,2.1604571}, {12500,2.1438286}, {12600,2.1634286}, {12700,2.2024571}, {12800,2.1808571}, {12900,2.2138571}, {13000,2.2226857}, {13100,2.2940000}, {13200,2.2734571}, {13300,2.3145429}, {13400,2.3003429}, {13500,2.3638000}, {13600,2.3134286}, {13700,2.3397143}, {13800,2.4340286}, {13900,2.3915143}, {14000,2.4051143}, {14100,2.4801143}, {14200,2.4760286}, {14300,2.5023429}, {14400,2.4808000}, {14500,2.4817714}, {14600,2.5008286}, {14700,2.5585143}, {14800,2.5780571}, {14900,2.5654857}, {15000,2.5516000}, {15100,2.6859714}, {15200,2.6278000}, {15300,2.6795143}, {15400,2.6666286}, {15500,2.6801143}, {15600,2.7265143}, {15700,2.7544571}, {15800,2.7443714}, {15900,2.7302286}, {16000,2.7682571}, {16100,2.7807714}, {16200,2.7938857}, {16300,2.8663714}, {16400,2.7773143}, {16500,2.8490286}, {16600,2.8879714}, {16700,2.8998857}, {16800,2.8978571}, {16900,2.8939143}, {17000,2.9049429}, {17100,2.9876286}, {17200,2.9700286}, {17300,2.9763429}, {17400,3.0728571}, {17500,3.0202286}, {17600,3.0212286}, {17700,3.0269429}, {17800,3.0578000}, {17900,3.1733714}, {18000,3.0957143}, {18100,3.1580571}, {18200,3.1502286}, {18300,3.1821429}, {18400,3.2380571}, {18500,3.1723714}, {18600,3.2144000}, {18700,3.2209714}, {18800,3.2019429}, {18900,3.3158000}, {19000,3.2389143}, {19100,3.3600000}, {19200,3.2623143}, {19300,6.7660286}, {19400,3.4024571}, {19500,3.3535714}, {19600,3.3704286}, {19700,3.4425429}, {19800,3.4322571}, {19900,3.5166857}, {20000,3.4304857}};
data["big_flat"]["LtacPrimUncurry"]["actual reif"]["system"] = {{1,0.00011881}, {2,0.00006931}, {3,0.00003960}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00002970}, {14,0.00000000}, {15,0.00000000}, {16,0.00003960}, {17,0.00002970}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00002970}, {23,0.00000000}, {24,0.00000000}, {25,0.00003960}, {26,0.00007921}, {27,0.00000000}, {28,0.00000000}, {29,0.00003960}, {30,0.00000000}, {31,0.00002970}, {32,0.00003960}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003960}, {42,0.00003960}, {43,0.00000000}, {44,0.00003960}, {45,0.00009901}, {46,0.00003960}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00000000}, {51,0.00003960}, {52,0.00003960}, {53,0.00000000}, {54,0.00000000}, {55,0.00003960}, {56,0.00003960}, {57,0.00006931}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00002970}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00003960}, {67,0.00010891}, {68,0.00000000}, {69,0.00000000}, {70,0.00003960}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00003960}, {76,0.00003960}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00006931}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00003960}, {87,0.00003960}, {88,0.00003960}, {89,0.00000000}, {90,0.00011881}, {91,0.00003960}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00002970}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00003960}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003960}, {105,0.00003960}, {106,0.00013861}, {107,0.00003960}, {108,0.00000000}, {109,0.00003960}, {110,0.00003960}, {111,0.00003960}, {112,0.00002970}, {113,0.00000000}, {114,0.00003960}, {115,0.00007921}, {116,0.00003960}, {117,0.00000000}, {118,0.00006931}, {119,0.00003960}, {120,0.00006931}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00003960}, {125,0.00006931}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00002970}, {133,0.00000000}, {134,0.00003960}, {135,0.00011881}, {136,0.00000000}, {137,0.00003960}, {138,0.00007921}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00017822}, {145,0.00002970}, {146,0.00000000}, {147,0.00007921}, {148,0.00003960}, {149,0.00007921}, {150,0.00000000}, {151,0.00003960}, {152,0.00003960}, {153,0.00007921}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00007921}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00003960}, {162,0.00007921}, {163,0.00003960}, {164,0.00003960}, {165,0.00010891}, {166,0.00000000}, {167,0.00003960}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00003960}, {174,0.00000000}, {175,0.00000000}, {176,0.00002970}, {177,0.00000000}, {178,0.00003960}, {179,0.00000000}, {180,0.00008911}, {181,0.00000000}, {182,0.00000000}, {183,0.00006931}, {184,0.00000000}, {185,0.00003960}, {186,0.00000000}, {187,0.00002970}, {188,0.00000000}, {189,0.00000000}, {190,0.00002970}, {191,0.00000000}, {192,0.00003960}, {193,0.00002970}, {194,0.00002970}, {195,0.00000000}, {196,0.00000000}, {197,0.00014851}, {198,0.00000000}, {199,0.00003960}, {200,0.00011881}, {201,0.00002970}, {202,0.00000000}, {203,0.00000000}, {204,0.00003960}, {205,0.00003960}, {206,0.00000000}, {207,0.00003960}, {208,0.00000000}, {209,0.00000000}, {210,0.00002970}, {211,0.00000000}, {212,0.00000000}, {213,0.00003960}, {214,0.00000000}, {215,0.00000000}, {216,0.00011881}, {217,0.00000000}, {218,0.00003960}, {219,0.00017822}, {220,0.00002970}, {221,0.00000000}, {222,0.00007921}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00003960}, {228,0.00003960}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00003960}, {233,0.00011881}, {234,0.00011881}, {235,0.00002970}, {236,0.00006931}, {237,0.00000000}, {238,0.00003960}, {239,0.00007921}, {240,0.00000000}, {241,0.00003960}, {242,0.00000000}, {243,0.00003960}, {244,0.00011881}, {245,0.00000000}, {246,0.00003960}, {247,0.00011881}, {248,0.00003960}, {249,0.00027723}, {250,0.00002970}, {251,0.00000000}, {252,0.00029703}, {253,0.00003960}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00014851}, {258,0.00000000}, {259,0.00000000}, {260,0.00003960}, {261,0.00000000}, {262,0.00019802}, {263,0.00010891}, {264,0.00000000}, {265,0.00002970}, {266,0.00000000}, {267,0.00017822}, {268,0.00000000}, {269,0.00000000}, {270,0.00002970}, {271,0.00000000}, {272,0.00010891}, {273,0.00003960}, {274,0.00030693}, {275,0.00003960}, {276,0.00002970}, {277,0.00007921}, {278,0.00000000}, {279,0.00014851}, {280,0.00000000}, {281,0.00018812}, {282,0.00000000}, {283,0.00003960}, {284,0.00006931}, {285,0.00003960}, {286,0.00013861}, {287,0.00000000}, {288,0.00015842}, {289,0.00000000}, {290,0.00000000}, {291,0.00007921}, {292,0.00002970}, {293,0.00003960}, {294,0.00000000}, {295,0.00011881}, {296,0.00002970}, {297,0.00015842}, {298,0.00000000}, {299,0.00009901}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00003960}, {305,0.00003960}, {306,0.00011881}, {307,0.00000000}, {308,0.00015842}, {309,0.00003960}, {310,0.00023762}, {311,0.00002970}, {312,0.00011881}, {313,0.00000000}, {314,0.00018812}, {315,0.00003960}, {316,0.00007921}, {317,0.00000000}, {318,0.00029703}, {319,0.00000000}, {320,0.00013861}, {321,0.00000000}, {322,0.00002970}, {323,0.00003960}, {324,0.00007921}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00002970}, {329,0.00000000}, {330,0.00003960}, {331,0.00003960}, {332,0.00007921}, {333,0.00007921}, {334,0.00000000}, {335,0.00002970}, {336,0.00027723}, {337,0.00000000}, {338,0.00012871}, {339,0.00002970}, {340,0.00011881}, {341,0.00002970}, {342,0.00026733}, {343,0.00000000}, {344,0.00015842}, {345,0.00006931}, {346,0.00007921}, {347,0.00002970}, {348,0.00002970}, {349,0.00000000}, {350,0.00002970}, {351,0.00003960}, {352,0.00006931}, {353,0.00003960}, {354,0.00000000}, {355,0.00013861}, {356,0.00002970}, {357,0.00014851}, {358,0.00003960}, {359,0.00003960}, {360,0.00000000}, {361,0.00010891}, {362,0.00003960}, {363,0.00023762}, {364,0.00035644}, {365,0.00003960}, {366,0.00124752}, {367,0.00007921}, {368,0.00011881}, {369,0.00000000}, {370,0.00011881}, {371,0.00000000}, {372,0.00000000}, {373,0.00042574}, {374,0.00002970}, {375,0.00003960}, {376,0.00000000}, {377,0.00002970}, {378,0.00000000}, {379,0.00000000}, {380,0.00030693}, {381,0.00006931}, {382,0.00011881}, {383,0.00003960}, {384,0.00007921}, {385,0.00021782}, {386,0.00003960}, {387,0.00009901}, {388,0.00002970}, {389,0.00010891}, {390,0.00022772}, {391,0.00000000}, {392,0.00018812}, {393,0.00000000}, {394,0.00007921}, {395,0.00026733}, {396,0.00003960}, {397,0.00026733}, {398,0.00000000}, {399,0.00003960}, {400,0.00019802}, {401,0.00000000}, {402,0.00015842}, {403,0.00000000}, {404,0.00015842}, {405,0.00006931}, {406,0.00003960}, {407,0.00022772}, {408,0.00000000}, {409,0.00000000}, {410,0.00007921}, {411,0.00000000}, {412,0.00011881}, {413,0.00027723}, {414,0.00000000}, {415,0.00003960}, {416,0.00032673}, {417,0.00000000}, {418,0.00015842}, {419,0.00000000}, {420,0.00002970}, {421,0.00022772}, {422,0.00000000}, {423,0.00003960}, {424,0.00030693}, {425,0.00003960}, {426,0.00013861}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00020792}, {431,0.00007921}, {432,0.00007921}, {433,0.00022772}, {434,0.00003960}, {435,0.00010891}, {436,0.00023762}, {437,0.00003960}, {438,0.00016832}, {439,0.00023762}, {440,0.00003960}, {441,0.00014851}, {442,0.00021782}, {443,0.00000000}, {444,0.00007921}, {445,0.00031683}, {446,0.00000000}, {447,0.00015842}, {448,0.00018812}, {449,0.00003960}, {450,0.00003960}, {451,0.00030693}, {452,0.00000000}, {453,0.00007921}, {454,0.00028713}, {455,0.00000000}, {456,0.00003960}, {457,0.00011881}, {458,0.00042574}, {459,0.00000000}, {460,0.00007921}, {461,0.00031683}, {462,0.00003960}, {463,0.00011881}, {464,0.00031683}, {465,0.00000000}, {466,0.00000000}, {467,0.00019802}, {468,0.00028713}, {469,0.00000000}, {470,0.00011881}, {471,0.00018812}, {472,0.00003960}, {473,0.00000000}, {474,0.00018812}, {475,0.00014851}, {476,0.00003960}, {477,0.00014851}, {478,0.00003960}, {479,0.00029703}, {480,0.00000000}, {481,0.00015842}, {482,0.00014851}, {483,0.00000000}, {484,0.00000000}, {485,0.00006931}, {486,0.00035644}, {487,0.00000000}, {488,0.00000000}, {489,0.00010891}, {490,0.00023762}, {491,0.00000000}, {492,0.00003960}, {493,0.00015842}, {494,0.00015842}, {495,0.00010891}, {496,0.00007921}, {497,0.00007921}, {498,0.00023762}, {499,0.00000000}, {500,0.00000000}, {505,0.00024752}, {510,0.00030693}, {515,0.00030693}, {520,0.00003960}, {525,0.00007921}, {530,0.00000000}, {535,0.00033663}, {540,0.00042574}, {545,0.00000000}, {550,0.00000000}, {555,0.00022772}, {560,0.00033663}, {565,0.00024752}, {570,0.00035644}, {575,0.00041584}, {580,0.00007921}, {585,0.00007921}, {590,0.00019802}, {595,0.00015842}, {600,0.00030693}, {605,0.00034653}, {610,0.00022772}, {615,0.00022772}, {620,0.00032673}, {625,0.00030693}, {630,0.00015842}, {635,0.00000000}, {640,0.00000000}, {645,0.00002970}, {650,0.00247525}, {655,0.00003960}, {660,0.00007921}, {665,0.00006931}, {670,0.00015842}, {675,0.00000000}, {680,0.00007921}, {685,0.00000000}, {690,0.00006931}, {695,0.00000000}, {700,0.00003960}, {705,0.00000000}, {710,0.00003960}, {715,0.00007921}, {720,0.00000000}, {725,0.00000000}, {730,0.00003960}, {735,0.00006931}, {740,0.00000000}, {745,0.00003960}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00007921}, {770,0.00003960}, {775,0.00003960}, {780,0.00003960}, {785,0.00007921}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00002970}, {810,0.00002970}, {815,0.00003960}, {820,0.00000000}, {825,0.00003960}, {830,0.00003960}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00003960}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00003960}, {900,0.00000000}, {905,0.00000000}, {910,0.00003960}, {915,0.00022772}, {920,0.00040594}, {925,0.00059406}, {930,0.00047525}, {935,0.00019802}, {940,0.00022772}, {945,0.00022772}, {950,0.00045545}, {955,0.00042574}, {960,0.00035644}, {965,0.00011881}, {970,0.00030693}, {975,0.00017822}, {980,0.00006931}, {985,0.00014851}, {990,0.00018812}, {995,0.00015842}, {1000,0.00025743}, {1010,0.00009901}, {1020,0.00010891}, {1030,0.00007921}, {1040,0.00027723}, {1050,0.00003960}, {1060,0.00007921}, {1070,0.00003960}, {1080,0.00003960}, {1090,0.00003960}, {1100,0.00015842}, {1110,0.00003960}, {1120,0.00014851}, {1130,0.00003960}, {1140,0.00007921}, {1150,0.00011881}, {1160,0.00007921}, {1170,0.00000000}, {1180,0.00003960}, {1190,0.00000000}, {1200,0.00003960}, {1210,0.00000000}, {1220,0.00003960}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00003960}, {1260,0.00007921}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00003960}, {1330,0.00003960}, {1340,0.00007921}, {1350,0.00000000}, {1360,0.00007921}, {1370,0.00003960}, {1380,0.00011881}, {1390,0.00003960}, {1400,0.00000000}, {1410,0.00003960}, {1420,0.00002970}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00003960}, {1460,0.00003960}, {1470,0.00007921}, {1480,0.00003960}, {1490,0.00003960}, {1500,0.00000000}, {1510,0.00007921}, {1520,0.00003960}, {1530,0.00003960}, {1540,0.00000000}, {1550,0.00002970}, {1560,0.00007921}, {1570,0.00003960}, {1580,0.00007921}, {1590,0.00010891}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00003960}, {1660,0.00003960}, {1670,0.00003960}, {1680,0.00007921}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00003960}, {1720,0.00003960}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00003960}, {1760,0.00003960}, {1770,0.00011881}, {1780,0.00000000}, {1790,0.00011881}, {1800,0.00003960}, {1810,0.00003960}, {1820,0.00002970}, {1830,0.00006931}, {1840,0.00003960}, {1850,0.00000000}, {1860,0.00007921}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00003960}, {1900,0.00000000}, {1910,0.00005941}, {1920,0.00003960}, {1930,0.00002970}, {1940,0.00000000}, {1950,0.00010891}, {1960,0.00000000}, {1970,0.00003960}, {1980,0.00007921}, {1990,0.00010891}, {2000,0.00003960}, {2050,0.00007921}, {2100,0.00000000}, {2150,0.00003960}, {2200,0.00003960}, {2250,0.00000000}, {2300,0.00015842}, {2350,0.00003960}, {2400,0.00007921}, {2450,0.00007921}, {2500,0.00002970}, {2550,0.00015842}, {2600,0.00003960}, {2650,0.00010891}, {2700,0.00003960}, {2750,0.00003960}, {2800,0.00003960}, {2850,0.00002970}, {2900,0.00011881}, {2950,0.00014851}, {3000,0.00000000}, {3050,0.00007921}, {3100,0.00003960}, {3150,0.00000000}, {3200,0.00007921}, {3250,0.00007921}, {3300,0.00000000}, {3350,0.00003960}, {3400,0.00006931}, {3450,0.00003960}, {3500,0.00000000}, {3550,0.00007921}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00011881}, {3750,0.00018812}, {3800,0.00007921}, {3850,0.00007921}, {3900,0.00015842}, {3950,0.00010891}, {4000,0.00011881}, {4050,0.00003960}, {4100,0.00221782}, {4150,0.00245545}, {4200,0.00089109}, {4250,0.00007921}, {4300,0.00007921}, {4350,0.00013861}, {4400,0.00011881}, {4450,0.00007921}, {4500,0.00022772}, {4550,0.00047525}, {4600,0.00040594}, {4650,0.00000000}, {4700,0.00003960}, {4750,0.00003960}, {4800,0.00002970}, {4850,0.00003960}, {4900,0.00006931}, {4950,0.00009901}, {5000,0.00007921}, {5050,0.00003960}, {5100,0.00019802}, {5150,0.00007921}, {5200,0.00011881}, {5250,0.00026733}, {5300,0.00000000}, {5350,0.00007921}, {5400,0.00014851}, {5450,0.00007921}, {5500,0.00003960}, {5550,0.00011881}, {5600,0.00014851}, {5650,0.00000000}, {5700,0.00006931}, {5750,0.00000000}, {5800,0.00007921}, {5850,0.00002970}, {5900,0.00002970}, {5950,0.00007921}, {6000,0.00010891}, {6050,0.0040000}, {6100,0.0037714}, {6150,0.0054571}, {6200,0.0024571}, {6250,0.0001143}, {6300,0.0039714}, {6350,0.0037143}, {6400,0.0048000}, {6450,0.0001143}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0021429}, {6650,0.0003429}, {6700,0.0000000}, {6750,0.0002286}, {6800,0.0002286}, {6850,0.0001143}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0001143}, {7100,0.0003429}, {7150,0.0063143}, {7200,0.0060571}, {7250,0.0036857}, {7300,0.0003429}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0002286}, {7550,0.0002286}, {7600,0.0000857}, {7650,0.0002286}, {7700,0.0000000}, {7750,0.0004286}, {7800,0.0003143}, {7850,0.0000857}, {7900,0.0000000}, {7950,0.0003429}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0001143}, {8150,0.0002286}, {8200,0.0001143}, {8250,0.0001143}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0001714}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0002286}, {8600,0.0003429}, {8650,0.0001143}, {8700,0.0001143}, {8750,0.0002286}, {8800,0.0003429}, {8850,0.0000000}, {8900,0.0003429}, {8950,0.0000000}, {9000,0.0003429}, {9050,0.0002286}, {9100,0.0004571}, {9150,0.0000000}, {9200,0.0004571}, {9250,0.0002286}, {9300,0.0002286}, {9350,0.0000000}, {9400,0.0001143}, {9450,0.0002286}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0001143}, {9650,0.0002000}, {9700,0.0001143}, {9750,0.0002286}, {9800,0.0000857}, {9850,0.0000000}, {9900,0.0003429}, {9950,0.0003429}, {10000,0.0001143}, {10100,0.0002000}, {10200,0.0002000}, {10300,0.0001143}, {10400,0.0004571}, {10500,0.0004571}, {10600,0.0001143}, {10700,0.0001143}, {10800,0.0001143}, {10900,0.0001143}, {11000,0.0003429}, {11100,0.0002286}, {11200,0.0002286}, {11300,0.0001143}, {11400,0.0003429}, {11500,0.0000000}, {11600,0.0001143}, {11700,0.0001143}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0002286}, {12100,0.0004286}, {12200,0.0002286}, {12300,0.0000000}, {12400,0.0005429}, {12500,0.0002286}, {12600,0.0004571}, {12700,0.0002286}, {12800,0.0003429}, {12900,0.0001143}, {13000,0.0001143}, {13100,0.0001143}, {13200,0.0002000}, {13300,0.0002286}, {13400,0.0003143}, {13500,0.0001143}, {13600,0.0002286}, {13700,0.0000000}, {13800,0.0005714}, {13900,0.0001143}, {14000,0.0001143}, {14100,0.0004286}, {14200,0.0004571}, {14300,0.0000000}, {14400,0.0003429}, {14500,0.0001143}, {14600,0.0000000}, {14700,0.0009143}, {14800,0.0003429}, {14900,0.0000000}, {15000,0.0003429}, {15100,0.0006857}, {15200,0.0006571}, {15300,0.0003429}, {15400,0.0002286}, {15500,0.0002286}, {15600,0.0003143}, {15700,0.0006571}, {15800,0.0002000}, {15900,0.0003143}, {16000,0.0003429}, {16100,0.0001143}, {16200,0.0004571}, {16300,0.0000000}, {16400,0.0002286}, {16500,0.0008857}, {16600,0.0001143}, {16700,0.0001143}, {16800,0.0002286}, {16900,0.0002286}, {17000,0.0005714}, {17100,0.0004571}, {17200,0.0003429}, {17300,0.0000000}, {17400,0.0002286}, {17500,0.0003429}, {17600,0.0003429}, {17700,0.0002286}, {17800,0.0006857}, {17900,0.0003429}, {18000,0.0000000}, {18100,0.0001143}, {18200,0.0005714}, {18300,0.0002286}, {18400,0.0000000}, {18500,0.0003143}, {18600,0.0003429}, {18700,0.0002286}, {18800,0.0032857}, {18900,0.0002286}, {19000,0.0001143}, {19100,0.0001143}, {19200,0.0084000}, {19300,0.0090286}, {19400,0.0001714}, {19500,0.0001143}, {19600,0.0000857}, {19700,0.0002286}, {19800,0.0000000}, {19900,0.0003429}, {20000,0.0003429}};
data["big_flat"]["LtacPrimUncurry"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00714851}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00100000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00100000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000990}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000990}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000990}, {429,0.00001980}, {430,0.00000000}, {431,0.00001980}, {432,0.00000990}, {433,0.00000990}, {434,0.00001980}, {435,0.00000990}, {436,0.00002970}, {437,0.00001980}, {438,0.00000000}, {439,0.00000990}, {440,0.00001980}, {441,0.00000990}, {442,0.00000990}, {443,0.00000990}, {444,0.00000990}, {445,0.00000990}, {446,0.00002970}, {447,0.00002970}, {448,0.00002970}, {449,0.00005941}, {450,0.00005941}, {451,0.00004950}, {452,0.00007921}, {453,0.00010891}, {454,0.00010891}, {455,0.00012871}, {456,0.00017822}, {457,0.00024752}, {458,0.00026733}, {459,0.00035644}, {460,0.00028713}, {461,0.00038614}, {462,0.00052475}, {463,0.00046535}, {464,0.00060396}, {465,0.00061386}, {466,0.00200000}, {467,0.00068317}, {468,0.00067327}, {469,0.00079208}, {470,0.00068317}, {471,0.00069307}, {472,0.00081188}, {473,0.00200000}, {474,0.00073267}, {475,0.00071287}, {476,0.00080198}, {477,0.00078218}, {478,0.00079208}, {479,0.00079208}, {480,0.00085149}, {481,0.00086139}, {482,0.00088119}, {483,0.00086139}, {484,0.00087129}, {485,0.00092079}, {486,0.00091089}, {487,0.00093069}, {488,0.00095050}, {489,0.00090099}, {490,0.00094059}, {491,0.00098020}, {492,0.00096040}, {493,0.00096040}, {494,0.00094059}, {495,0.00097030}, {496,0.00099010}, {497,0.00096040}, {498,0.00100000}, {499,0.00100000}, {500,0.00100000}, {505,0.00100000}, {510,0.00100000}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00100000}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00386139}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00300000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00100000}, {830,0.00100000}, {835,0.00100000}, {840,0.00100000}, {845,0.00100000}, {850,0.00100000}, {855,0.00100000}, {860,0.00100000}, {865,0.00100000}, {870,0.00101980}, {875,0.00100000}, {880,0.00100000}, {885,0.00101980}, {890,0.00103960}, {895,0.00105941}, {900,0.00107921}, {905,0.00107921}, {910,0.00110891}, {915,0.00114851}, {920,0.00120792}, {925,0.00133663}, {930,0.00156436}, {935,0.00154455}, {940,0.00175248}, {945,0.00176238}, {950,0.00170297}, {955,0.00173267}, {960,0.00180198}, {965,0.00181188}, {970,0.00189109}, {975,0.00191089}, {980,0.00190099}, {985,0.00197030}, {990,0.00199010}, {995,0.00200000}, {1000,0.00200000}, {1010,0.00199010}, {1020,0.00200000}, {1030,0.00200000}, {1040,0.00200000}, {1050,0.00200000}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200000}, {1140,0.00200000}, {1150,0.00200000}, {1160,0.00200000}, {1170,0.00200000}, {1180,0.00200000}, {1190,0.00200000}, {1200,0.00753465}, {1210,0.00200000}, {1220,0.00200000}, {1230,0.00200000}, {1240,0.00200000}, {1250,0.00200000}, {1260,0.00200000}, {1270,0.00200000}, {1280,0.00200990}, {1290,0.00201980}, {1300,0.00200990}, {1310,0.00201980}, {1320,0.00203960}, {1330,0.00205941}, {1340,0.00208911}, {1350,0.00209901}, {1360,0.00617822}, {1370,0.00225743}, {1380,0.00257426}, {1390,0.00273267}, {1400,0.00273267}, {1410,0.00277228}, {1420,0.00279208}, {1430,0.00283168}, {1440,0.00288119}, {1450,0.00293069}, {1460,0.00298020}, {1470,0.00298020}, {1480,0.00300000}, {1490,0.00300000}, {1500,0.00300000}, {1510,0.00300000}, {1520,0.00300000}, {1530,0.00300000}, {1540,0.00300000}, {1550,0.00300000}, {1560,0.00300000}, {1570,0.00300000}, {1580,0.00624752}, {1590,0.00300000}, {1600,0.00300000}, {1610,0.00300000}, {1620,0.00300000}, {1630,0.00300000}, {1640,0.00300000}, {1650,0.00300000}, {1660,0.00300000}, {1670,0.00300000}, {1680,0.00300000}, {1690,0.00300990}, {1700,0.00300000}, {1710,0.00300990}, {1720,0.00300000}, {1730,0.00303960}, {1740,0.00305941}, {1750,0.00306931}, {1760,0.00304950}, {1770,0.00307921}, {1780,0.00308911}, {1790,0.00315842}, {1800,0.00322772}, {1810,0.00335644}, {1820,0.00354455}, {1830,0.00360396}, {1840,0.00370297}, {1850,0.00370297}, {1860,0.00842574}, {1870,0.00374257}, {1880,0.00374257}, {1890,0.00380198}, {1900,0.00389109}, {1910,0.00391089}, {1920,0.00397030}, {1930,0.00399010}, {1940,0.00710891}, {1950,0.01009901}, {1960,0.00400000}, {1970,0.00400000}, {1980,0.00400000}, {1990,0.00400000}, {2000,0.01064356}, {2050,0.00766337}, {2100,0.00400990}, {2150,0.00404950}, {2200,0.00404950}, {2250,0.00438614}, {2300,0.00473267}, {2350,0.00484158}, {2400,0.00500000}, {2450,0.00500000}, {2500,0.00501980}, {2550,0.00503960}, {2600,0.00508911}, {2650,0.00515842}, {2700,0.00565347}, {2750,0.00576238}, {2800,0.00590099}, {2850,0.00600000}, {2900,0.00601980}, {2950,0.00604950}, {3000,0.00606931}, {3050,0.01300990}, {3100,0.00635644}, {3150,0.00672277}, {3200,0.00681188}, {3250,0.01675248}, {3300,0.01271287}, {3350,0.01627723}, {3400,0.00706931}, {3450,0.00712871}, {3500,0.00724752}, {3550,0.00763366}, {3600,0.00776238}, {3650,0.00783168}, {3700,0.00800000}, {3750,0.02069307}, {3800,0.00805941}, {3850,0.00811881}, {3900,0.00831683}, {3950,0.00857426}, {4000,0.00878218}, {4050,0.00878218}, {4100,0.00898020}, {4150,0.00901980}, {4200,0.00905941}, {4250,0.00909901}, {4300,0.00920792}, {4350,0.00945545}, {4400,0.00976238}, {4450,0.00978218}, {4500,0.00989109}, {4550,0.00999010}, {4600,0.01009901}, {4650,0.01011881}, {4700,0.01025743}, {4750,0.02572277}, {4800,0.01077228}, {4850,0.01081188}, {4900,0.02288119}, {4950,0.01094059}, {5000,0.01956436}, {5050,0.01113861}, {5100,0.01132673}, {5150,0.01160396}, {5200,0.01176238}, {5250,0.02117822}, {5300,0.02292079}, {5350,0.01195050}, {5400,0.01205941}, {5450,0.01218812}, {5500,0.01235644}, {5550,0.01261386}, {5600,0.01274257}, {5650,0.01283168}, {5700,0.02497030}, {5750,0.01294059}, {5800,0.01309901}, {5850,0.01322772}, {5900,0.01333663}, {5950,0.01361386}, {6000,0.01378218}, {6050,0.0485143}, {6100,0.0142857}, {6150,0.0144286}, {6200,0.0336286}, {6250,0.0146000}, {6300,0.0335429}, {6350,0.0148857}, {6400,0.0150571}, {6450,0.0270286}, {6500,0.0316571}, {6550,0.0153714}, {6600,0.0290571}, {6650,0.0428571}, {6700,0.0158000}, {6750,0.0160286}, {6800,0.0162000}, {6850,0.0163143}, {6900,0.0164000}, {6950,0.0164571}, {7000,0.0324571}, {7050,0.0168857}, {7100,0.0169429}, {7150,0.0170857}, {7200,0.0172000}, {7250,0.0173714}, {7300,0.0174571}, {7350,0.0176571}, {7400,0.0176857}, {7450,0.0178000}, {7500,0.0179714}, {7550,0.0362571}, {7600,0.0182000}, {7650,0.0184286}, {7700,0.0315143}, {7750,0.0185143}, {7800,0.0187143}, {7850,0.0189143}, {7900,0.0190571}, {7950,0.0294571}, {8000,0.0332857}, {8050,0.0193429}, {8100,0.0195714}, {8150,0.0329429}, {8200,0.0198857}, {8250,0.0342286}, {8300,0.0201714}, {8350,0.0204000}, {8400,0.0204286}, {8450,0.0552000}, {8500,0.0427143}, {8550,0.0404857}, {8600,0.0420571}, {8650,0.0210571}, {8700,0.0210857}, {8750,0.0398000}, {8800,0.0212857}, {8850,0.0215714}, {8900,0.0215429}, {8950,0.0367714}, {9000,0.0219714}, {9050,0.0220286}, {9100,0.0222000}, {9150,0.0222571}, {9200,0.0224286}, {9250,0.0226000}, {9300,0.0226571}, {9350,0.0377143}, {9400,0.0230571}, {9450,0.0234857}, {9500,0.0223143}, {9550,0.0232857}, {9600,0.0235714}, {9650,0.0490000}, {9700,0.0332571}, {9750,0.0238571}, {9800,0.0242571}, {9850,0.0242000}, {9900,0.0363714}, {9950,0.0492571}, {10000,0.0246000}, {10100,0.0248857}, {10200,0.0251714}, {10300,0.0516857}, {10400,0.0258857}, {10500,0.0260000}, {10600,0.0263429}, {10700,0.0430000}, {10800,0.0266286}, {10900,0.0438857}, {11000,0.0272571}, {11100,0.0276571}, {11200,0.0278571}, {11300,0.0280857}, {11400,0.0549714}, {11500,0.0285143}, {11600,0.0411714}, {11700,0.0518571}, {11800,0.0526000}, {11900,0.0602857}, {12000,0.0302571}, {12100,0.0303429}, {12200,0.0305143}, {12300,0.0452286}, {12400,0.0518000}, {12500,0.0502000}, {12600,0.0628000}, {12700,0.0317429}, {12800,0.0528286}, {12900,0.0324000}, {13000,0.0620000}, {13100,0.0623429}, {13200,0.0587143}, {13300,0.0336286}, {13400,0.0580000}, {13500,0.0343429}, {13600,0.0339429}, {13700,0.0705714}, {13800,0.0645143}, {13900,0.0347429}, {14000,0.0352857}, {14100,0.0613143}, {14200,0.0370000}, {14300,0.0367429}, {14400,0.0562286}, {14500,0.0368286}, {14600,0.0686286}, {14700,0.0460000}, {14800,0.0679429}, {14900,0.0382286}, {15000,0.0380000}, {15100,0.0382571}, {15200,0.0706857}, {15300,0.0374286}, {15400,0.0602000}, {15500,0.0394000}, {15600,0.0595143}, {15700,0.0608571}, {15800,0.0402286}, {15900,0.0609714}, {16000,0.0600000}, {16100,0.0411143}, {16200,0.0413714}, {16300,0.0416000}, {16400,0.0421714}, {16500,0.0422571}, {16600,0.0797429}, {16700,0.0430857}, {16800,0.0714571}, {16900,0.0776857}, {17000,0.0435143}, {17100,0.0437143}, {17200,0.0865714}, {17300,0.0442571}, {17400,0.0953714}, {17500,0.0937143}, {17600,0.0775714}, {17700,0.0586571}, {17800,0.0918000}, {17900,0.0710571}, {18000,0.0875714}, {18100,0.0463143}, {18200,0.0466857}, {18300,0.0472571}, {18400,0.0666286}, {18500,0.0756286}, {18600,0.0476857}, {18700,0.1015714}, {18800,0.0482571}, {18900,0.0486571}, {19000,0.0490286}, {19100,0.0876857}, {19200,0.0474000}, {19300,0.0495714}, {19400,0.0499714}, {19500,0.0640000}, {19600,0.0695143}, {19700,0.0693714}, {19800,0.0785143}, {19900,0.0708571}, {20000,0.0845429}};
data["big_flat"]["LtacPrimUncurry"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00002970}, {3,0.00002970}, {4,0.00000000}, {5,0.00002970}, {6,0.00002970}, {7,0.00003960}, {8,0.00000000}, {9,0.00002970}, {10,0.00000000}, {11,0.00000000}, {12,0.00002970}, {13,0.00002970}, {14,0.00010891}, {15,0.00002970}, {16,0.00000000}, {17,0.00003960}, {18,0.00000000}, {19,0.00005941}, {20,0.00013861}, {21,0.00003960}, {22,0.00005941}, {23,0.00003960}, {24,0.00010891}, {25,0.00013861}, {26,0.00005941}, {27,0.00003960}, {28,0.00771287}, {29,0.00018812}, {30,0.00007921}, {31,0.00009901}, {32,0.00007921}, {33,0.00007921}, {34,0.00003960}, {35,0.00006931}, {36,0.00008911}, {37,0.00007921}, {38,0.00002970}, {39,0.00009901}, {40,0.00011881}, {41,0.00006931}, {42,0.00006931}, {43,0.00003960}, {44,0.00002970}, {45,0.00010891}, {46,0.00010891}, {47,0.00011881}, {48,0.00008911}, {49,0.00026733}, {50,0.00033663}, {51,0.00009901}, {52,0.00005941}, {53,0.00023762}, {54,0.00015842}, {55,0.00016832}, {56,0.00010891}, {57,0.00023762}, {58,0.00005941}, {59,0.00017822}, {60,0.00017822}, {61,0.00020792}, {62,0.00014851}, {63,0.00013861}, {64,0.00002970}, {65,0.00011881}, {66,0.00014851}, {67,0.00015842}, {68,0.00015842}, {69,0.00016832}, {70,0.00017822}, {71,0.00017822}, {72,0.00027723}, {73,0.00009901}, {74,0.00026733}, {75,0.00008911}, {76,0.00027723}, {77,0.00005941}, {78,0.00023762}, {79,0.00003960}, {80,0.00018812}, {81,0.00020792}, {82,0.00012871}, {83,0.00011881}, {84,0.00021782}, {85,0.00020792}, {86,0.00013861}, {87,0.00010891}, {88,0.00035644}, {89,0.00016832}, {90,0.00018812}, {91,0.00016832}, {92,0.00019802}, {93,0.00014851}, {94,0.00014851}, {95,0.00014851}, {96,0.00024752}, {97,0.00016832}, {98,0.00013861}, {99,0.00008911}, {100,0.00019802}, {101,0.00027723}, {102,0.00023762}, {103,0.00016832}, {104,0.00026733}, {105,0.00018812}, {106,0.00019802}, {107,0.00018812}, {108,0.00019802}, {109,0.00010891}, {110,0.00015842}, {111,0.00035644}, {112,0.00023762}, {113,0.00018812}, {114,0.00057426}, {115,0.00018812}, {116,0.00030693}, {117,0.00032673}, {118,0.00030693}, {119,0.00012871}, {120,0.00017822}, {121,0.00038614}, {122,0.00021782}, {123,0.00017822}, {124,0.00020792}, {125,0.00029703}, {126,0.00026733}, {127,0.00027723}, {128,0.00038614}, {129,0.00034653}, {130,0.00032673}, {131,0.00019802}, {132,0.00018812}, {133,0.00025743}, {134,0.00040594}, {135,0.00019802}, {136,0.00025743}, {137,0.00032673}, {138,0.00022772}, {139,0.00016832}, {140,0.00023762}, {141,0.00034653}, {142,0.00051485}, {143,0.00042574}, {144,0.00016832}, {145,0.00043564}, {146,0.00024752}, {147,0.00011881}, {148,0.00034653}, {149,0.00042574}, {150,0.00047525}, {151,0.00020792}, {152,0.00024752}, {153,0.00027723}, {154,0.00029703}, {155,0.00030693}, {156,0.00032673}, {157,0.00041584}, {158,0.00030693}, {159,0.00029703}, {160,0.00036634}, {161,0.00012871}, {162,0.00029703}, {163,0.00037624}, {164,0.00029703}, {165,0.00031683}, {166,0.00027723}, {167,0.00031683}, {168,0.00039604}, {169,0.00033663}, {170,0.00023762}, {171,0.00031683}, {172,0.00040594}, {173,0.00097030}, {174,0.00021782}, {175,0.00037624}, {176,0.00018812}, {177,0.00026733}, {178,0.00025743}, {179,0.00026733}, {180,0.00035644}, {181,0.00033663}, {182,0.00024752}, {183,0.00054455}, {184,0.00028713}, {185,0.00021782}, {186,0.00027723}, {187,0.00023762}, {188,0.00061386}, {189,0.00019802}, {190,0.00028713}, {191,0.00027723}, {192,0.00032673}, {193,0.00036634}, {194,0.00035644}, {195,0.00030693}, {196,0.00038614}, {197,0.00028713}, {198,0.00024752}, {199,0.00043564}, {200,0.00047525}, {201,0.00021782}, {202,0.00042574}, {203,0.00038614}, {204,0.00044554}, {205,0.00032673}, {206,0.00039604}, {207,0.00045545}, {208,0.00027723}, {209,0.00032673}, {210,0.00035644}, {211,0.00043564}, {212,0.00030693}, {213,0.00023762}, {214,0.00040594}, {215,0.00046535}, {216,0.00040594}, {217,0.00044554}, {218,0.00039604}, {219,0.00049505}, {220,0.00031683}, {221,0.00033663}, {222,0.00039604}, {223,0.00052475}, {224,0.00053465}, {225,0.00038614}, {226,0.00041584}, {227,0.00034653}, {228,0.00041584}, {229,0.00058416}, {230,0.00054455}, {231,0.00033663}, {232,0.00040594}, {233,0.00033663}, {234,0.00029703}, {235,0.00069307}, {236,0.00035644}, {237,0.00043564}, {238,0.00044554}, {239,0.00047525}, {240,0.00033663}, {241,0.00021782}, {242,0.00047525}, {243,0.00025743}, {244,0.00046535}, {245,0.00052475}, {246,0.00028713}, {247,0.00026733}, {248,0.00046535}, {249,0.00027723}, {250,0.00046535}, {251,0.00029703}, {252,0.00060396}, {253,0.00044554}, {254,0.00023762}, {255,0.00032673}, {256,0.00079208}, {257,0.00039604}, {258,0.00060396}, {259,0.00034653}, {260,0.00047525}, {261,0.00038614}, {262,0.00037624}, {263,0.00049505}, {264,0.00048515}, {265,0.00031683}, {266,0.00067327}, {267,0.00068317}, {268,0.00061386}, {269,0.00035644}, {270,0.00122772}, {271,0.00055446}, {272,0.00042574}, {273,0.00056436}, {274,0.00034653}, {275,0.00064356}, {276,0.00078218}, {277,0.00060396}, {278,0.00043564}, {279,0.00049505}, {280,0.00039604}, {281,0.00047525}, {282,0.00020792}, {283,0.00038614}, {284,0.00049505}, {285,0.00044554}, {286,0.00034653}, {287,0.00046535}, {288,0.00037624}, {289,0.00062376}, {290,0.00048515}, {291,0.00064356}, {292,0.00046535}, {293,0.00052475}, {294,0.00051485}, {295,0.00066337}, {296,0.00060396}, {297,0.00052475}, {298,0.00061386}, {299,0.00050495}, {300,0.00038614}, {301,0.00063366}, {302,0.00070297}, {303,0.00076238}, {304,0.00060396}, {305,0.00039604}, {306,0.00059406}, {307,0.00045545}, {308,0.00078218}, {309,0.00054455}, {310,0.00054455}, {311,0.00039604}, {312,0.00053465}, {313,0.00048515}, {314,0.00046535}, {315,0.00065347}, {316,0.00053465}, {317,0.00062376}, {318,0.00061386}, {319,0.00061386}, {320,0.00063366}, {321,0.00052475}, {322,0.00067327}, {323,0.00050495}, {324,0.00063366}, {325,0.00081188}, {326,0.00069307}, {327,0.00060396}, {328,0.00071287}, {329,0.00060396}, {330,0.00073267}, {331,0.00041584}, {332,0.00057426}, {333,0.00055446}, {334,0.00062376}, {335,0.00050495}, {336,0.00058416}, {337,0.00072277}, {338,0.00042574}, {339,0.00065347}, {340,0.00091089}, {341,0.00053465}, {342,0.00069307}, {343,0.00060396}, {344,0.00052475}, {345,0.00061386}, {346,0.00075248}, {347,0.00045545}, {348,0.00061386}, {349,0.00059406}, {350,0.00063366}, {351,0.00058416}, {352,0.00063366}, {353,0.00076238}, {354,0.00057426}, {355,0.00066337}, {356,0.00042574}, {357,0.00052475}, {358,0.00079208}, {359,0.00066337}, {360,0.00057426}, {361,0.00058416}, {362,0.00069307}, {363,0.00088119}, {364,0.00057426}, {365,0.00043564}, {366,0.00075248}, {367,0.00088119}, {368,0.00080198}, {369,0.00062376}, {370,0.00081188}, {371,0.00055446}, {372,0.00057426}, {373,0.00081188}, {374,0.00079208}, {375,0.00088119}, {376,0.00094059}, {377,0.00072277}, {378,0.00073267}, {379,0.00100990}, {380,0.00028713}, {381,0.00090099}, {382,0.00083168}, {383,0.00089109}, {384,0.00087129}, {385,0.00068317}, {386,0.00074257}, {387,0.00075248}, {388,0.00095050}, {389,0.00061386}, {390,0.00052475}, {391,0.00058416}, {392,0.00102970}, {393,0.00055446}, {394,0.00071287}, {395,0.00087129}, {396,0.00079208}, {397,0.00067327}, {398,0.00060396}, {399,0.00064356}, {400,0.00104950}, {401,0.00104950}, {402,0.00101980}, {403,0.00047525}, {404,0.00087129}, {405,0.00084158}, {406,0.00054455}, {407,0.00083168}, {408,0.00071287}, {409,0.00086139}, {410,0.00102970}, {411,0.00072277}, {412,0.00089109}, {413,0.00073267}, {414,0.00061386}, {415,0.00059406}, {416,0.00061386}, {417,0.00085149}, {418,0.00059406}, {419,0.00073267}, {420,0.00089109}, {421,0.00081188}, {422,0.00046535}, {423,0.00079208}, {424,0.00100990}, {425,0.00067327}, {426,0.00068317}, {427,0.00092079}, {428,0.00099010}, {429,0.00096040}, {430,0.00093069}, {431,0.00077228}, {432,0.00067327}, {433,0.00057426}, {434,0.00100000}, {435,0.00086139}, {436,0.00097030}, {437,0.00098020}, {438,0.00097030}, {439,0.00074257}, {440,0.00067327}, {441,0.00104950}, {442,0.00082178}, {443,0.00098020}, {444,0.00092079}, {445,0.00081188}, {446,0.00082178}, {447,0.00100990}, {448,0.00088119}, {449,0.00100000}, {450,0.00115842}, {451,0.00072277}, {452,0.00091089}, {453,0.00111881}, {454,0.00105941}, {455,0.00095050}, {456,0.00079208}, {457,0.00085149}, {458,0.00092079}, {459,0.00080198}, {460,0.00088119}, {461,0.00095050}, {462,0.00097030}, {463,0.00096040}, {464,0.00091089}, {465,0.00092079}, {466,0.00230693}, {467,0.00088119}, {468,0.00108911}, {469,0.00092079}, {470,0.00083168}, {471,0.00079208}, {472,0.00098020}, {473,0.00234653}, {474,0.00096040}, {475,0.00106931}, {476,0.00113861}, {477,0.00120792}, {478,0.00076238}, {479,0.00087129}, {480,0.00113861}, {481,0.00078218}, {482,0.00083168}, {483,0.00107921}, {484,0.00114851}, {485,0.00108911}, {486,0.00100990}, {487,0.00099010}, {488,0.00075248}, {489,0.00138614}, {490,0.00085149}, {491,0.00076238}, {492,0.00131683}, {493,0.00069307}, {494,0.00126733}, {495,0.00070297}, {496,0.00086139}, {497,0.00087129}, {498,0.00103960}, {499,0.00095050}, {500,0.00092079}, {505,0.00092079}, {510,0.00093069}, {515,0.00129703}, {520,0.00098020}, {525,0.00128713}, {530,0.00122772}, {535,0.00093069}, {540,0.00114851}, {545,0.00099010}, {550,0.00094059}, {555,0.00114851}, {560,0.00079208}, {565,0.00101980}, {570,0.00115842}, {575,0.00109901}, {580,0.00127723}, {585,0.00096040}, {590,0.00117822}, {595,0.00125743}, {600,0.00126733}, {605,0.00123762}, {610,0.00138614}, {615,0.00116832}, {620,0.00113861}, {625,0.00122772}, {630,0.00107921}, {635,0.00100990}, {640,0.00136634}, {645,0.00126733}, {650,0.00133663}, {655,0.00112871}, {660,0.00144554}, {665,0.00139604}, {670,0.00130693}, {675,0.00118812}, {680,0.00151485}, {685,0.00160396}, {690,0.00145545}, {695,0.00115842}, {700,0.00118812}, {705,0.00159406}, {710,0.00130693}, {715,0.00133663}, {720,0.00139604}, {725,0.00127723}, {730,0.00127723}, {735,0.00374257}, {740,0.00145545}, {745,0.00150495}, {750,0.00141584}, {755,0.00164356}, {760,0.00147525}, {765,0.00156436}, {770,0.00302970}, {775,0.00170297}, {780,0.00122772}, {785,0.00142574}, {790,0.00154455}, {795,0.00147525}, {800,0.00154455}, {805,0.00144554}, {810,0.00154455}, {815,0.00173267}, {820,0.00140594}, {825,0.00153465}, {830,0.00137624}, {835,0.00147525}, {840,0.00177228}, {845,0.00154455}, {850,0.00132673}, {855,0.00122772}, {860,0.00124752}, {865,0.00170297}, {870,0.00143564}, {875,0.00140594}, {880,0.00169307}, {885,0.00152475}, {890,0.00183168}, {895,0.00153465}, {900,0.00179208}, {905,0.00157426}, {910,0.00176238}, {915,0.00130693}, {920,0.00158416}, {925,0.00183168}, {930,0.00165347}, {935,0.00179208}, {940,0.00166337}, {945,0.00182178}, {950,0.00154455}, {955,0.00173267}, {960,0.00147525}, {965,0.00199010}, {970,0.00181188}, {975,0.00172277}, {980,0.00155446}, {985,0.00139604}, {990,0.00158416}, {995,0.00189109}, {1000,0.00161386}, {1010,0.00175248}, {1020,0.00194059}, {1030,0.00175248}, {1040,0.00201980}, {1050,0.00156436}, {1060,0.00192079}, {1070,0.00215842}, {1080,0.00201980}, {1090,0.00198020}, {1100,0.00221782}, {1110,0.00221782}, {1120,0.00210891}, {1130,0.00200000}, {1140,0.00178218}, {1150,0.00204950}, {1160,0.00201980}, {1170,0.00189109}, {1180,0.00216832}, {1190,0.00207921}, {1200,0.00780198}, {1210,0.00217822}, {1220,0.00207921}, {1230,0.00216832}, {1240,0.00219802}, {1250,0.00212871}, {1260,0.00222772}, {1270,0.00226733}, {1280,0.00243564}, {1290,0.00230693}, {1300,0.00236634}, {1310,0.00248515}, {1320,0.00211881}, {1330,0.00245545}, {1340,0.00252475}, {1350,0.00247525}, {1360,0.00643564}, {1370,0.00230693}, {1380,0.00273267}, {1390,0.00227723}, {1400,0.00263366}, {1410,0.00265347}, {1420,0.00267327}, {1430,0.00271287}, {1440,0.00249505}, {1450,0.00248515}, {1460,0.00284158}, {1470,0.00254455}, {1480,0.00268317}, {1490,0.00260396}, {1500,0.00253465}, {1510,0.00275248}, {1520,0.00270297}, {1530,0.00275248}, {1540,0.00283168}, {1550,0.00287129}, {1560,0.00265347}, {1570,0.00288119}, {1580,0.00672277}, {1590,0.00281188}, {1600,0.00284158}, {1610,0.00297030}, {1620,0.00274257}, {1630,0.00285149}, {1640,0.00298020}, {1650,0.00303960}, {1660,0.00302970}, {1670,0.00299010}, {1680,0.00296040}, {1690,0.00310891}, {1700,0.00313861}, {1710,0.00316832}, {1720,0.00305941}, {1730,0.00320792}, {1740,0.00311881}, {1750,0.00308911}, {1760,0.00303960}, {1770,0.00321782}, {1780,0.00315842}, {1790,0.00325743}, {1800,0.00336634}, {1810,0.00329703}, {1820,0.00331683}, {1830,0.00322772}, {1840,0.00337624}, {1850,0.00329703}, {1860,0.00885149}, {1870,0.00348515}, {1880,0.00350495}, {1890,0.00341584}, {1900,0.00343564}, {1910,0.00337624}, {1920,0.00371287}, {1930,0.00365347}, {1940,0.00714851}, {1950,0.01067327}, {1960,0.00367327}, {1970,0.00378218}, {1980,0.00408911}, {1990,0.00388119}, {2000,0.01050495}, {2050,0.00745545}, {2100,0.00425743}, {2150,0.00442574}, {2200,0.00454455}, {2250,0.00483168}, {2300,0.00460396}, {2350,0.00456436}, {2400,0.00489109}, {2450,0.00510891}, {2500,0.00495050}, {2550,0.00522772}, {2600,0.00547525}, {2650,0.00550495}, {2700,0.00553465}, {2750,0.00546535}, {2800,0.00639604}, {2850,0.00582178}, {2900,0.00556436}, {2950,0.00612871}, {3000,0.00597030}, {3050,0.01328713}, {3100,0.00641584}, {3150,0.00676238}, {3200,0.00653465}, {3250,0.01705941}, {3300,0.01286139}, {3350,0.01650495}, {3400,0.00710891}, {3450,0.00708911}, {3500,0.00729703}, {3550,0.00734653}, {3600,0.00736634}, {3650,0.00763366}, {3700,0.00762376}, {3750,0.02051485}, {3800,0.00802970}, {3850,0.00817822}, {3900,0.00833663}, {3950,0.00843564}, {4000,0.00860396}, {4050,0.00908911}, {4100,0.00900000}, {4150,0.00897030}, {4200,0.00897030}, {4250,0.00963366}, {4300,0.00948515}, {4350,0.01002970}, {4400,0.00951485}, {4450,0.00972277}, {4500,0.01010891}, {4550,0.01063366}, {4600,0.01048515}, {4650,0.01072277}, {4700,0.01016832}, {4750,0.02612871}, {4800,0.01072277}, {4850,0.01097030}, {4900,0.02311881}, {4950,0.01155446}, {5000,0.01937624}, {5050,0.01163366}, {5100,0.01182178}, {5150,0.01180198}, {5200,0.01207921}, {5250,0.02140594}, {5300,0.02318812}, {5350,0.01227723}, {5400,0.01229703}, {5450,0.01264356}, {5500,0.01305941}, {5550,0.01303960}, {5600,0.01320792}, {5650,0.01291089}, {5700,0.02527723}, {5750,0.01330693}, {5800,0.01366337}, {5850,0.01369307}, {5900,0.01350495}, {5950,0.01402970}, {6000,0.01390099}, {6050,0.0476000}, {6100,0.0146000}, {6150,0.0148000}, {6200,0.0336286}, {6250,0.0149143}, {6300,0.0334286}, {6350,0.0148286}, {6400,0.0150857}, {6450,0.0267714}, {6500,0.0322571}, {6550,0.0150571}, {6600,0.0292286}, {6650,0.0430571}, {6700,0.0158857}, {6750,0.0162571}, {6800,0.0163143}, {6850,0.0161429}, {6900,0.0159143}, {6950,0.0164571}, {7000,0.0322857}, {7050,0.0169143}, {7100,0.0163143}, {7150,0.0171714}, {7200,0.0176286}, {7250,0.0171429}, {7300,0.0173714}, {7350,0.0175714}, {7400,0.0183143}, {7450,0.0176286}, {7500,0.0184000}, {7550,0.0367429}, {7600,0.0186857}, {7650,0.0182000}, {7700,0.0311429}, {7750,0.0182000}, {7800,0.0186571}, {7850,0.0189714}, {7900,0.0189429}, {7950,0.0297143}, {8000,0.0330857}, {8050,0.0191143}, {8100,0.0200571}, {8150,0.0334857}, {8200,0.0196286}, {8250,0.0341429}, {8300,0.0200857}, {8350,0.0199429}, {8400,0.0205714}, {8450,0.0554000}, {8500,0.0419714}, {8550,0.0402000}, {8600,0.0418571}, {8650,0.0213714}, {8700,0.0211143}, {8750,0.0396286}, {8800,0.0214286}, {8850,0.0219143}, {8900,0.0212571}, {8950,0.0369429}, {9000,0.0220571}, {9050,0.0216571}, {9100,0.0224857}, {9150,0.0227714}, {9200,0.0225143}, {9250,0.0232000}, {9300,0.0228286}, {9350,0.0379429}, {9400,0.0232286}, {9450,0.0230286}, {9500,0.0227714}, {9550,0.0237429}, {9600,0.0238571}, {9650,0.0490286}, {9700,0.0332857}, {9750,0.0241143}, {9800,0.0243714}, {9850,0.0242000}, {9900,0.0362571}, {9950,0.0500000}, {10000,0.0249143}, {10100,0.0254857}, {10200,0.0249143}, {10300,0.0517143}, {10400,0.0259143}, {10500,0.0262286}, {10600,0.0262000}, {10700,0.0430857}, {10800,0.0264286}, {10900,0.0438857}, {11000,0.0272571}, {11100,0.0273714}, {11200,0.0278000}, {11300,0.0277714}, {11400,0.0548857}, {11500,0.0291714}, {11600,0.0409143}, {11700,0.0514571}, {11800,0.0528571}, {11900,0.0601714}, {12000,0.0304000}, {12100,0.0307714}, {12200,0.0302571}, {12300,0.0446286}, {12400,0.0518000}, {12500,0.0500857}, {12600,0.0621143}, {12700,0.0318571}, {12800,0.0524286}, {12900,0.0324857}, {13000,0.0617429}, {13100,0.0622857}, {13200,0.0580571}, {13300,0.0336571}, {13400,0.0582571}, {13500,0.0339714}, {13600,0.0330571}, {13700,0.0710571}, {13800,0.0642000}, {13900,0.0343714}, {14000,0.0354000}, {14100,0.0614000}, {14200,0.0365714}, {14300,0.0364286}, {14400,0.0566857}, {14500,0.0372000}, {14600,0.0687429}, {14700,0.0463714}, {14800,0.0679143}, {14900,0.0380571}, {15000,0.0385429}, {15100,0.0384000}, {15200,0.0711143}, {15300,0.0374000}, {15400,0.0604000}, {15500,0.0393143}, {15600,0.0598000}, {15700,0.0606571}, {15800,0.0407143}, {15900,0.0616000}, {16000,0.0587143}, {16100,0.0412286}, {16200,0.0411429}, {16300,0.0413714}, {16400,0.0421429}, {16500,0.0421429}, {16600,0.0805143}, {16700,0.0422286}, {16800,0.0717429}, {16900,0.0772857}, {17000,0.0437143}, {17100,0.0430857}, {17200,0.0868857}, {17300,0.0438857}, {17400,0.0944571}, {17500,0.0944000}, {17600,0.0773714}, {17700,0.0590857}, {17800,0.0921143}, {17900,0.0712571}, {18000,0.0875714}, {18100,0.0468571}, {18200,0.0471143}, {18300,0.0476571}, {18400,0.0669714}, {18500,0.0752000}, {18600,0.0485429}, {18700,0.1012857}, {18800,0.0485143}, {18900,0.0484857}, {19000,0.0495143}, {19100,0.0880857}, {19200,0.0472286}, {19300,0.0498857}, {19400,0.0503429}, {19500,0.0644857}, {19600,0.0698857}, {19700,0.0696000}, {19800,0.0781714}, {19900,0.0710857}, {20000,0.0847429}};
data["big_flat"]["LtacPrimUncurry"]["cbv"]["system"] = {{1,0.00003960}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00005941}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00009901}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00003960}, {98,0.00000000}, {99,0.00003960}, {100,0.00002970}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00003960}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00003960}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00003960}, {161,0.00000000}, {162,0.00003960}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00003960}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00005941}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00003960}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00003960}, {189,0.00003960}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00002970}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00002970}, {206,0.00000000}, {207,0.00000000}, {208,0.00003960}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00003960}, {216,0.00000000}, {217,0.00000000}, {218,0.00007921}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00003960}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00003960}, {241,0.00003960}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00003960}, {250,0.00002970}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00002970}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00003960}, {267,0.00000000}, {268,0.00003960}, {269,0.00003960}, {270,0.00003960}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00003960}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00003960}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00003960}, {297,0.00000000}, {298,0.00000000}, {299,0.00003960}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00003960}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00003960}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00003960}, {366,0.00000000}, {367,0.00003960}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00003960}, {373,0.00000000}, {374,0.00000000}, {375,0.00002970}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00002970}, {382,0.00000000}, {383,0.00003960}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00007921}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00003960}, {399,0.00007921}, {400,0.00000000}, {401,0.00002970}, {402,0.00000000}, {403,0.00000000}, {404,0.00003960}, {405,0.00003960}, {406,0.00003960}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00003960}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00003960}, {417,0.00003960}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00003960}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00003960}, {432,0.00000000}, {433,0.00003960}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00003960}, {438,0.00000000}, {439,0.00000000}, {440,0.00002970}, {441,0.00000000}, {442,0.00000000}, {443,0.00003960}, {444,0.00002970}, {445,0.00003960}, {446,0.00000000}, {447,0.00000000}, {448,0.00003960}, {449,0.00000000}, {450,0.00000000}, {451,0.00003960}, {452,0.00000000}, {453,0.00000000}, {454,0.00003960}, {455,0.00003960}, {456,0.00000000}, {457,0.00000000}, {458,0.00007921}, {459,0.00003960}, {460,0.00000000}, {461,0.00000000}, {462,0.00002970}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00007921}, {469,0.00000000}, {470,0.00003960}, {471,0.00003960}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00003960}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00002970}, {496,0.00000000}, {497,0.00003960}, {498,0.00003960}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00003960}, {525,0.00000000}, {530,0.00000000}, {535,0.00003960}, {540,0.00003960}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00002970}, {600,0.00003960}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00003960}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00003960}, {680,0.00003960}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00003960}, {745,0.00000000}, {750,0.00003960}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00002970}, {840,0.00000000}, {845,0.00000000}, {850,0.00003960}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00006931}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00003960}, {960,0.00000000}, {965,0.00003960}, {970,0.00000000}, {975,0.00000000}, {980,0.00007921}, {985,0.00000000}, {990,0.00000000}, {995,0.00003960}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00006931}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00003960}, {1120,0.00007921}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00002970}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00002970}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00003960}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00003960}, {1480,0.00000000}, {1490,0.00003960}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00003960}, {1540,0.00007921}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00003960}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00002970}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00003960}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00007921}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00007921}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00003960}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00003960}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00003960}, {4050,0.00003960}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00002970}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00003960}, {4800,0.00003960}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00003960}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00003960}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0012000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0002000}, {6250,0.0000000}, {6300,0.0003429}, {6350,0.0000000}, {6400,0.0001143}, {6450,0.0000857}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000857}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0001143}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0001143}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0001143}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0001143}, {8950,0.0001143}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0001143}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0001143}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0001143}, {13200,0.0001143}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0001143}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000857}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0001143}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0001143}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0001143}, {17600,0.0001143}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0001143}, {18600,0.0000000}, {18700,0.0001143}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0001143}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacPrimUncurry"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000990}, {1420,0.00001980}, {1430,0.00000990}, {1440,0.00000990}, {1450,0.00000990}, {1460,0.00002970}, {1470,0.00003960}, {1480,0.00006931}, {1490,0.00001980}, {1500,0.00008911}, {1510,0.00017822}, {1520,0.00008911}, {1530,0.00026733}, {1540,0.00053465}, {1550,0.00041584}, {1560,0.00068317}, {1570,0.00073267}, {1580,0.00073267}, {1590,0.00078218}, {1600,0.00072277}, {1610,0.00087129}, {1620,0.00098020}, {1630,0.00098020}, {1640,0.00100000}, {1650,0.00099010}, {1660,0.00100000}, {1670,0.00100000}, {1680,0.00090099}, {1690,0.00100000}, {1700,0.00100000}, {1710,0.00100000}, {1720,0.00100000}, {1730,0.00100000}, {1740,0.00100000}, {1750,0.00100000}, {1760,0.00455446}, {1770,0.00100000}, {1780,0.00100000}, {1790,0.00100000}, {1800,0.00100000}, {1810,0.00100000}, {1820,0.00100000}, {1830,0.00100000}, {1840,0.00100000}, {1850,0.00100000}, {1860,0.00100000}, {1870,0.00100000}, {1880,0.00100000}, {1890,0.00100000}, {1900,0.00100000}, {1910,0.00100990}, {1920,0.00100000}, {1930,0.00100000}, {1940,0.00100000}, {1950,0.00100000}, {1960,0.00100000}, {1970,0.00100000}, {1980,0.00100000}, {1990,0.00100990}, {2000,0.00100000}, {2050,0.00100000}, {2100,0.00100000}, {2150,0.00100000}, {2200,0.00100990}, {2250,0.00100000}, {2300,0.00100990}, {2350,0.00101980}, {2400,0.00106931}, {2450,0.00100990}, {2500,0.00109901}, {2550,0.00106931}, {2600,0.00109901}, {2650,0.00110891}, {2700,0.00113861}, {2750,0.00113861}, {2800,0.00116832}, {2850,0.00118812}, {2900,0.00123762}, {2950,0.00121782}, {3000,0.00133663}, {3050,0.00144554}, {3100,0.00534653}, {3150,0.00194059}, {3200,0.00213861}, {3250,0.00212871}, {3300,0.00215842}, {3350,0.00218812}, {3400,0.00218812}, {3450,0.00224752}, {3500,0.00225743}, {3550,0.00225743}, {3600,0.00221782}, {3650,0.00225743}, {3700,0.00232673}, {3750,0.00231683}, {3800,0.00229703}, {3850,0.00234653}, {3900,0.00245545}, {3950,0.01049505}, {4000,0.00241584}, {4050,0.00253465}, {4100,0.00255446}, {4150,0.00268317}, {4200,0.00300000}, {4250,0.00302970}, {4300,0.00322772}, {4350,0.00329703}, {4400,0.00337624}, {4450,0.00344554}, {4500,0.00346535}, {4550,0.00347525}, {4600,0.00357426}, {4650,0.00358416}, {4700,0.00356436}, {4750,0.00366337}, {4800,0.00325743}, {4850,0.00377228}, {4900,0.00364356}, {4950,0.00378218}, {5000,0.00402970}, {5050,0.00406931}, {5100,0.00437624}, {5150,0.00447525}, {5200,0.00456436}, {5250,0.00471287}, {5300,0.00465347}, {5350,0.00471287}, {5400,0.01948515}, {5450,0.00496040}, {5500,0.00515842}, {5550,0.00521782}, {5600,0.00528713}, {5650,0.00531683}, {5700,0.00480198}, {5750,0.00570297}, {5800,0.00578218}, {5850,0.00590099}, {5900,0.00600000}, {5950,0.00609901}, {6000,0.00560396}, {6050,0.0068571}, {6100,0.0182000}, {6150,0.0069714}, {6200,0.0069714}, {6250,0.0069429}, {6300,0.0069429}, {6350,0.0070000}, {6400,0.0069714}, {6450,0.0070571}, {6500,0.0070286}, {6550,0.0070857}, {6600,0.0071714}, {6650,0.0072857}, {6700,0.0074571}, {6750,0.0070571}, {6800,0.0078000}, {6850,0.0079143}, {6900,0.0079429}, {6950,0.0079143}, {7000,0.0079429}, {7050,0.0080000}, {7100,0.0080000}, {7150,0.0080286}, {7200,0.0080571}, {7250,0.0080857}, {7300,0.0080857}, {7350,0.0163143}, {7400,0.0081429}, {7450,0.0082571}, {7500,0.0084286}, {7550,0.0084571}, {7600,0.0085143}, {7650,0.0087714}, {7700,0.0233143}, {7750,0.0088857}, {7800,0.0089429}, {7850,0.0089714}, {7900,0.0178571}, {7950,0.0090000}, {8000,0.0090000}, {8050,0.0090000}, {8100,0.0090286}, {8150,0.0089714}, {8200,0.0091714}, {8250,0.0092000}, {8300,0.0093429}, {8350,0.0094857}, {8400,0.0090000}, {8450,0.0278857}, {8500,0.0271429}, {8550,0.0087429}, {8600,0.0099714}, {8650,0.0098857}, {8700,0.0100000}, {8750,0.0100000}, {8800,0.0099714}, {8850,0.0100000}, {8900,0.0100286}, {8950,0.0100857}, {9000,0.0100571}, {9050,0.0101429}, {9100,0.0101429}, {9150,0.0103143}, {9200,0.0106286}, {9250,0.0105429}, {9300,0.0106571}, {9350,0.0103714}, {9400,0.0108000}, {9450,0.0097429}, {9500,0.0108571}, {9550,0.0108857}, {9600,0.0342000}, {9650,0.0110857}, {9700,0.0110286}, {9750,0.0111143}, {9800,0.0111143}, {9850,0.0111714}, {9900,0.0268571}, {9950,0.0112286}, {10000,0.0113714}, {10100,0.0113143}, {10200,0.0118286}, {10300,0.0118857}, {10400,0.0120000}, {10500,0.0120571}, {10600,0.0121143}, {10700,0.0118286}, {10800,0.0123429}, {10900,0.0125429}, {11000,0.0126571}, {11100,0.0128857}, {11200,0.0128857}, {11300,0.0130000}, {11400,0.0119429}, {11500,0.0132286}, {11600,0.0131714}, {11700,0.0137714}, {11800,0.0134857}, {11900,0.0090286}, {12000,0.0138286}, {12100,0.0258286}, {12200,0.0139714}, {12300,0.0141143}, {12400,0.0141429}, {12500,0.0143143}, {12600,0.0477429}, {12700,0.0146857}, {12800,0.0148286}, {12900,0.0148857}, {13000,0.0150000}, {13100,0.0150571}, {13200,0.0151429}, {13300,0.0152000}, {13400,0.0527429}, {13500,0.0157143}, {13600,0.0158571}, {13700,0.0158286}, {13800,0.0158571}, {13900,0.0123714}, {14000,0.0161143}, {14100,0.0148857}, {14200,0.0139143}, {14300,0.0160857}, {14400,0.0149143}, {14500,0.0168571}, {14600,0.0169143}, {14700,0.0165714}, {14800,0.0446286}, {14900,0.0173143}, {15000,0.0174286}, {15100,0.0169429}, {15200,0.0178286}, {15300,0.0150857}, {15400,0.0178857}, {15500,0.0182000}, {15600,0.0181143}, {15700,0.0181429}, {15800,0.0402571}, {15900,0.0184000}, {16000,0.0508000}, {16100,0.0188286}, {16200,0.0188857}, {16300,0.0189429}, {16400,0.0190000}, {16500,0.0163143}, {16600,0.0192857}, {16700,0.0187714}, {16800,0.0527143}, {16900,0.0198286}, {17000,0.0201429}, {17100,0.0157143}, {17200,0.0198571}, {17300,0.0138286}, {17400,0.0467714}, {17500,0.0638000}, {17600,0.0205429}, {17700,0.0636286}, {17800,0.0187143}, {17900,0.0617714}, {18000,0.0209714}, {18100,0.0209143}, {18200,0.0209143}, {18300,0.0211143}, {18400,0.0181714}, {18500,0.0214286}, {18600,0.0785429}, {18700,0.0217429}, {18800,0.0219143}, {18900,0.0218857}, {19000,0.0219714}, {19100,0.0198286}, {19200,0.0221714}, {19300,0.0209143}, {19400,0.0197429}, {19500,0.0193143}, {19600,0.0195429}, {19700,0.0228857}, {19800,0.0187143}, {19900,0.0556857}, {20000,0.0232571}};
data["big_flat"]["LtacPrimUncurry"]["eval lazy"]["user"] = {{1,0.00002970}, {2,0.00002970}, {3,0.00003960}, {4,0.00003960}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00002970}, {10,0.00003960}, {11,0.00003960}, {12,0.00007921}, {13,0.00000000}, {14,0.00007921}, {15,0.00002970}, {16,0.00002970}, {17,0.00003960}, {18,0.00006931}, {19,0.00006931}, {20,0.00011881}, {21,0.00000000}, {22,0.00006931}, {23,0.00010891}, {24,0.00006931}, {25,0.00002970}, {26,0.00003960}, {27,0.00000000}, {28,0.00002970}, {29,0.00003960}, {30,0.00003960}, {31,0.00003960}, {32,0.00005941}, {33,0.00002970}, {34,0.00010891}, {35,0.00002970}, {36,0.00006931}, {37,0.00005941}, {38,0.00003960}, {39,0.00016832}, {40,0.00000000}, {41,0.00002970}, {42,0.00005941}, {43,0.00000000}, {44,0.00003960}, {45,0.00002970}, {46,0.00002970}, {47,0.00005941}, {48,0.00003960}, {49,0.00006931}, {50,0.00003960}, {51,0.00009901}, {52,0.00003960}, {53,0.00006931}, {54,0.00002970}, {55,0.00014851}, {56,0.00003960}, {57,0.00007921}, {58,0.00005941}, {59,0.00009901}, {60,0.00002970}, {61,0.00014851}, {62,0.00009901}, {63,0.00003960}, {64,0.00006931}, {65,0.00006931}, {66,0.00010891}, {67,0.00002970}, {68,0.00003960}, {69,0.00000000}, {70,0.00000000}, {71,0.00016832}, {72,0.00005941}, {73,0.00010891}, {74,0.00006931}, {75,0.00000000}, {76,0.00005941}, {77,0.00009901}, {78,0.00006931}, {79,0.00008911}, {80,0.00007921}, {81,0.00006931}, {82,0.00000000}, {83,0.00005941}, {84,0.00013861}, {85,0.00007921}, {86,0.00000000}, {87,0.00006931}, {88,0.00000000}, {89,0.00015842}, {90,0.00014851}, {91,0.00000000}, {92,0.00002970}, {93,0.00002970}, {94,0.00009901}, {95,0.00017822}, {96,0.00005941}, {97,0.00002970}, {98,0.00020792}, {99,0.00000000}, {100,0.00010891}, {101,0.00003960}, {102,0.00009901}, {103,0.00010891}, {104,0.00003960}, {105,0.00011881}, {106,0.00012871}, {107,0.00012871}, {108,0.00015842}, {109,0.00003960}, {110,0.00002970}, {111,0.00010891}, {112,0.00006931}, {113,0.00013861}, {114,0.00006931}, {115,0.00003960}, {116,0.00013861}, {117,0.00020792}, {118,0.00000000}, {119,0.00009901}, {120,0.00006931}, {121,0.00013861}, {122,0.00011881}, {123,0.00013861}, {124,0.00006931}, {125,0.00007921}, {126,0.00009901}, {127,0.00018812}, {128,0.00013861}, {129,0.00011881}, {130,0.00018812}, {131,0.00014851}, {132,0.00009901}, {133,0.00012871}, {134,0.00010891}, {135,0.00005941}, {136,0.00014851}, {137,0.00010891}, {138,0.00012871}, {139,0.00028713}, {140,0.00018812}, {141,0.00003960}, {142,0.00013861}, {143,0.00021782}, {144,0.00014851}, {145,0.00010891}, {146,0.00013861}, {147,0.00006931}, {148,0.00013861}, {149,0.00009901}, {150,0.00014851}, {151,0.00006931}, {152,0.00011881}, {153,0.00014851}, {154,0.00005941}, {155,0.00034653}, {156,0.00019802}, {157,0.00000000}, {158,0.00016832}, {159,0.00003960}, {160,0.00005941}, {161,0.00017822}, {162,0.00012871}, {163,0.00012871}, {164,0.00012871}, {165,0.00009901}, {166,0.00006931}, {167,0.00011881}, {168,0.00015842}, {169,0.00016832}, {170,0.00002970}, {171,0.00014851}, {172,0.00005941}, {173,0.00000000}, {174,0.00008911}, {175,0.00009901}, {176,0.00013861}, {177,0.00011881}, {178,0.00005941}, {179,0.00008911}, {180,0.00005941}, {181,0.00022772}, {182,0.00005941}, {183,0.00017822}, {184,0.00015842}, {185,0.00029703}, {186,0.00008911}, {187,0.00000000}, {188,0.00012871}, {189,0.00009901}, {190,0.00005941}, {191,0.00013861}, {192,0.00015842}, {193,0.00008911}, {194,0.00008911}, {195,0.00019802}, {196,0.00005941}, {197,0.00007921}, {198,0.00020792}, {199,0.00019802}, {200,0.00000000}, {201,0.00009901}, {202,0.00020792}, {203,0.00019802}, {204,0.00009901}, {205,0.00008911}, {206,0.00005941}, {207,0.00012871}, {208,0.00005941}, {209,0.00016832}, {210,0.00005941}, {211,0.00006931}, {212,0.00019802}, {213,0.00012871}, {214,0.00019802}, {215,0.00017822}, {216,0.00021782}, {217,0.00012871}, {218,0.00010891}, {219,0.00017822}, {220,0.00022772}, {221,0.00019802}, {222,0.00011881}, {223,0.00006931}, {224,0.00009901}, {225,0.00008911}, {226,0.00019802}, {227,0.00011881}, {228,0.00010891}, {229,0.00020792}, {230,0.00009901}, {231,0.00016832}, {232,0.00005941}, {233,0.00015842}, {234,0.00023762}, {235,0.00011881}, {236,0.00012871}, {237,0.00011881}, {238,0.00009901}, {239,0.00015842}, {240,0.00024752}, {241,0.00010891}, {242,0.00009901}, {243,0.00020792}, {244,0.00008911}, {245,0.00019802}, {246,0.00026733}, {247,0.00011881}, {248,0.00012871}, {249,0.00016832}, {250,0.00026733}, {251,0.00007921}, {252,0.00014851}, {253,0.00015842}, {254,0.00005941}, {255,0.00002970}, {256,0.00009901}, {257,0.00008911}, {258,0.00017822}, {259,0.00018812}, {260,0.00012871}, {261,0.00018812}, {262,0.00018812}, {263,0.00018812}, {264,0.00016832}, {265,0.00014851}, {266,0.00021782}, {267,0.00003960}, {268,0.00017822}, {269,0.00012871}, {270,0.00029703}, {271,0.00033663}, {272,0.00009901}, {273,0.00015842}, {274,0.00005941}, {275,0.00012871}, {276,0.00017822}, {277,0.00005941}, {278,0.00012871}, {279,0.00017822}, {280,0.00006931}, {281,0.00028713}, {282,0.00012871}, {283,0.00019802}, {284,0.00007921}, {285,0.00012871}, {286,0.00017822}, {287,0.00009901}, {288,0.00005941}, {289,0.00013861}, {290,0.00011881}, {291,0.00015842}, {292,0.00016832}, {293,0.00016832}, {294,0.00028713}, {295,0.00020792}, {296,0.00029703}, {297,0.00025743}, {298,0.00012871}, {299,0.00009901}, {300,0.00019802}, {301,0.00022772}, {302,0.00030693}, {303,0.00032673}, {304,0.00012871}, {305,0.00015842}, {306,0.00021782}, {307,0.00019802}, {308,0.00017822}, {309,0.00021782}, {310,0.00002970}, {311,0.00006931}, {312,0.00006931}, {313,0.00013861}, {314,0.00015842}, {315,0.00021782}, {316,0.00018812}, {317,0.00018812}, {318,0.00015842}, {319,0.00025743}, {320,0.00011881}, {321,0.00025743}, {322,0.00026733}, {323,0.00021782}, {324,0.00029703}, {325,0.00028713}, {326,0.00023762}, {327,0.00011881}, {328,0.00020792}, {329,0.00023762}, {330,0.00019802}, {331,0.00017822}, {332,0.00020792}, {333,0.00021782}, {334,0.00011881}, {335,0.00027723}, {336,0.00020792}, {337,0.00018812}, {338,0.00014851}, {339,0.00035644}, {340,0.00019802}, {341,0.00016832}, {342,0.00006931}, {343,0.00014851}, {344,0.00030693}, {345,0.00031683}, {346,0.00016832}, {347,0.00018812}, {348,0.00041584}, {349,0.00030693}, {350,0.00023762}, {351,0.00012871}, {352,0.00037624}, {353,0.00014851}, {354,0.00019802}, {355,0.00041584}, {356,0.00014851}, {357,0.00028713}, {358,0.00019802}, {359,0.00005941}, {360,0.00042574}, {361,0.00015842}, {362,0.00030693}, {363,0.00017822}, {364,0.00014851}, {365,0.00033663}, {366,0.00021782}, {367,0.00034653}, {368,0.00016832}, {369,0.00022772}, {370,0.00026733}, {371,0.00017822}, {372,0.00018812}, {373,0.00026733}, {374,0.00016832}, {375,0.00026733}, {376,0.00010891}, {377,0.00036634}, {378,0.00031683}, {379,0.00014851}, {380,0.00018812}, {381,0.00011881}, {382,0.00014851}, {383,0.00024752}, {384,0.00024752}, {385,0.00035644}, {386,0.00031683}, {387,0.00018812}, {388,0.00021782}, {389,0.00043564}, {390,0.00014851}, {391,0.00010891}, {392,0.00009901}, {393,0.00024752}, {394,0.00037624}, {395,0.00009901}, {396,0.00031683}, {397,0.00022772}, {398,0.00025743}, {399,0.00042574}, {400,0.00032673}, {401,0.00010891}, {402,0.00024752}, {403,0.00026733}, {404,0.00020792}, {405,0.00014851}, {406,0.00024752}, {407,0.00025743}, {408,0.00036634}, {409,0.00019802}, {410,0.00020792}, {411,0.00018812}, {412,0.00028713}, {413,0.00021782}, {414,0.00023762}, {415,0.00031683}, {416,0.00010891}, {417,0.00028713}, {418,0.00021782}, {419,0.00030693}, {420,0.00027723}, {421,0.00024752}, {422,0.00038614}, {423,0.00023762}, {424,0.00029703}, {425,0.00030693}, {426,0.00022772}, {427,0.00026733}, {428,0.00036634}, {429,0.00032673}, {430,0.00024752}, {431,0.00031683}, {432,0.00023762}, {433,0.00021782}, {434,0.00029703}, {435,0.00013861}, {436,0.00027723}, {437,0.00041584}, {438,0.00020792}, {439,0.00028713}, {440,0.00029703}, {441,0.00028713}, {442,0.00031683}, {443,0.00021782}, {444,0.00027723}, {445,0.00036634}, {446,0.00030693}, {447,0.00031683}, {448,0.00029703}, {449,0.00040594}, {450,0.00017822}, {451,0.00025743}, {452,0.00015842}, {453,0.00044554}, {454,0.00024752}, {455,0.00049505}, {456,0.00034653}, {457,0.00026733}, {458,0.00009901}, {459,0.00028713}, {460,0.00015842}, {461,0.00041584}, {462,0.00015842}, {463,0.00027723}, {464,0.00032673}, {465,0.00047525}, {466,0.00025743}, {467,0.00014851}, {468,0.00024752}, {469,0.00048515}, {470,0.00039604}, {471,0.00025743}, {472,0.00022772}, {473,0.00017822}, {474,0.00045545}, {475,0.00024752}, {476,0.00027723}, {477,0.00035644}, {478,0.00035644}, {479,0.00024752}, {480,0.00046535}, {481,0.00032673}, {482,0.00027723}, {483,0.00034653}, {484,0.00020792}, {485,0.00010891}, {486,0.00021782}, {487,0.00048515}, {488,0.00018812}, {489,0.00039604}, {490,0.00036634}, {491,0.00017822}, {492,0.00018812}, {493,0.00039604}, {494,0.00040594}, {495,0.00032673}, {496,0.00021782}, {497,0.00024752}, {498,0.00041584}, {499,0.00028713}, {500,0.00035644}, {505,0.00039604}, {510,0.00033663}, {515,0.00025743}, {520,0.00029703}, {525,0.00022772}, {530,0.00040594}, {535,0.00031683}, {540,0.00022772}, {545,0.00032673}, {550,0.00028713}, {555,0.00034653}, {560,0.00034653}, {565,0.00033663}, {570,0.00027723}, {575,0.00026733}, {580,0.00042574}, {585,0.00054455}, {590,0.00047525}, {595,0.00026733}, {600,0.00036634}, {605,0.00042574}, {610,0.00045545}, {615,0.00043564}, {620,0.00019802}, {625,0.00048515}, {630,0.00043564}, {635,0.00020792}, {640,0.00043564}, {645,0.00050495}, {650,0.00016832}, {655,0.00028713}, {660,0.00014851}, {665,0.00033663}, {670,0.00040594}, {675,0.00040594}, {680,0.00044554}, {685,0.00028713}, {690,0.00065347}, {695,0.00031683}, {700,0.00055446}, {705,0.00045545}, {710,0.00029703}, {715,0.00041584}, {720,0.00023762}, {725,0.00049505}, {730,0.00020792}, {735,0.00053465}, {740,0.00073267}, {745,0.00026733}, {750,0.00026733}, {755,0.00052475}, {760,0.00070297}, {765,0.00034653}, {770,0.00052475}, {775,0.00037624}, {780,0.00065347}, {785,0.00061386}, {790,0.00047525}, {795,0.00045545}, {800,0.00055446}, {805,0.00039604}, {810,0.00055446}, {815,0.00053465}, {820,0.00042574}, {825,0.00030693}, {830,0.00026733}, {835,0.00064356}, {840,0.00039604}, {845,0.00055446}, {850,0.00071287}, {855,0.00031683}, {860,0.00048515}, {865,0.00041584}, {870,0.00040594}, {875,0.00026733}, {880,0.00066337}, {885,0.00026733}, {890,0.00060396}, {895,0.00041584}, {900,0.00044554}, {905,0.00049505}, {910,0.00065347}, {915,0.00047525}, {920,0.00040594}, {925,0.00051485}, {930,0.00049505}, {935,0.00036634}, {940,0.00046535}, {945,0.00049505}, {950,0.00027723}, {955,0.00052475}, {960,0.00038614}, {965,0.00041584}, {970,0.00048515}, {975,0.00070297}, {980,0.00047525}, {985,0.00063366}, {990,0.00049505}, {995,0.00055446}, {1000,0.00021782}, {1010,0.00045545}, {1020,0.00048515}, {1030,0.00049505}, {1040,0.00076238}, {1050,0.00051485}, {1060,0.00033663}, {1070,0.00059406}, {1080,0.00051485}, {1090,0.00053465}, {1100,0.00047525}, {1110,0.00081188}, {1120,0.00054455}, {1130,0.00086139}, {1140,0.00036634}, {1150,0.00058416}, {1160,0.00050495}, {1170,0.00068317}, {1180,0.00059406}, {1190,0.00055446}, {1200,0.00088119}, {1210,0.00066337}, {1220,0.00075248}, {1230,0.00094059}, {1240,0.00069307}, {1250,0.00057426}, {1260,0.00062376}, {1270,0.00078218}, {1280,0.00049505}, {1290,0.00058416}, {1300,0.00080198}, {1310,0.00070297}, {1320,0.00088119}, {1330,0.00077228}, {1340,0.00084158}, {1350,0.00073267}, {1360,0.00067327}, {1370,0.00086139}, {1380,0.00082178}, {1390,0.00051485}, {1400,0.00095050}, {1410,0.00068317}, {1420,0.00063366}, {1430,0.00085149}, {1440,0.00086139}, {1450,0.00081188}, {1460,0.00084158}, {1470,0.00097030}, {1480,0.00081188}, {1490,0.00093069}, {1500,0.00068317}, {1510,0.00049505}, {1520,0.00088119}, {1530,0.00087129}, {1540,0.00083168}, {1550,0.00107921}, {1560,0.00085149}, {1570,0.00066337}, {1580,0.00071287}, {1590,0.00082178}, {1600,0.00066337}, {1610,0.00095050}, {1620,0.00075248}, {1630,0.00089109}, {1640,0.00100990}, {1650,0.00092079}, {1660,0.00074257}, {1670,0.00108911}, {1680,0.00086139}, {1690,0.00101980}, {1700,0.00093069}, {1710,0.00079208}, {1720,0.00103960}, {1730,0.00091089}, {1740,0.00083168}, {1750,0.00085149}, {1760,0.00433663}, {1770,0.00104950}, {1780,0.00115842}, {1790,0.00087129}, {1800,0.00109901}, {1810,0.00100990}, {1820,0.00080198}, {1830,0.00110891}, {1840,0.00088119}, {1850,0.00121782}, {1860,0.00096040}, {1870,0.00113861}, {1880,0.00096040}, {1890,0.00104950}, {1900,0.00074257}, {1910,0.00083168}, {1920,0.00096040}, {1930,0.00102970}, {1940,0.00101980}, {1950,0.00100990}, {1960,0.00102970}, {1970,0.00068317}, {1980,0.00132673}, {1990,0.00114851}, {2000,0.00104950}, {2050,0.00108911}, {2100,0.00088119}, {2150,0.00109901}, {2200,0.00123762}, {2250,0.00114851}, {2300,0.00140594}, {2350,0.00138614}, {2400,0.00164356}, {2450,0.00137624}, {2500,0.00145545}, {2550,0.00176238}, {2600,0.00154455}, {2650,0.00135644}, {2700,0.00116832}, {2750,0.00174257}, {2800,0.00186139}, {2850,0.00176238}, {2900,0.00171287}, {2950,0.00169307}, {3000,0.00216832}, {3050,0.00194059}, {3100,0.00516832}, {3150,0.00228713}, {3200,0.00227723}, {3250,0.00225743}, {3300,0.00225743}, {3350,0.00209901}, {3400,0.00239604}, {3450,0.00228713}, {3500,0.00277228}, {3550,0.00240594}, {3600,0.00251485}, {3650,0.00242574}, {3700,0.00255446}, {3750,0.00273267}, {3800,0.00279208}, {3850,0.00264356}, {3900,0.00278218}, {3950,0.01074257}, {4000,0.00279208}, {4050,0.00291089}, {4100,0.00286139}, {4150,0.00267327}, {4200,0.00315842}, {4250,0.00335644}, {4300,0.00313861}, {4350,0.00314851}, {4400,0.00333663}, {4450,0.00320792}, {4500,0.00328713}, {4550,0.00371287}, {4600,0.00355446}, {4650,0.00359406}, {4700,0.00364356}, {4750,0.00383168}, {4800,0.00309901}, {4850,0.00403960}, {4900,0.00389109}, {4950,0.00384158}, {5000,0.00424752}, {5050,0.00419802}, {5100,0.00462376}, {5150,0.00433663}, {5200,0.00461386}, {5250,0.00443564}, {5300,0.00458416}, {5350,0.00463366}, {5400,0.01967327}, {5450,0.00484158}, {5500,0.00515842}, {5550,0.00522772}, {5600,0.00550495}, {5650,0.00523762}, {5700,0.00507921}, {5750,0.00568317}, {5800,0.00608911}, {5850,0.00604950}, {5900,0.00617822}, {5950,0.00590099}, {6000,0.00566337}, {6050,0.0067429}, {6100,0.0174286}, {6150,0.0060571}, {6200,0.0066000}, {6250,0.0068286}, {6300,0.0066000}, {6350,0.0065429}, {6400,0.0068857}, {6450,0.0071429}, {6500,0.0071143}, {6550,0.0070286}, {6600,0.0072000}, {6650,0.0075429}, {6700,0.0072571}, {6750,0.0072857}, {6800,0.0079143}, {6850,0.0078000}, {6900,0.0076000}, {6950,0.0078857}, {7000,0.0083429}, {7050,0.0080857}, {7100,0.0082857}, {7150,0.0080000}, {7200,0.0078571}, {7250,0.0082857}, {7300,0.0086571}, {7350,0.0163714}, {7400,0.0086000}, {7450,0.0085714}, {7500,0.0084857}, {7550,0.0083714}, {7600,0.0085429}, {7650,0.0082286}, {7700,0.0240286}, {7750,0.0089143}, {7800,0.0087714}, {7850,0.0086286}, {7900,0.0181714}, {7950,0.0089143}, {8000,0.0087714}, {8050,0.0097143}, {8100,0.0092857}, {8150,0.0095429}, {8200,0.0092000}, {8250,0.0090286}, {8300,0.0091429}, {8350,0.0097429}, {8400,0.0086286}, {8450,0.0278286}, {8500,0.0271714}, {8550,0.0086286}, {8600,0.0097143}, {8650,0.0103429}, {8700,0.0101143}, {8750,0.0102000}, {8800,0.0092857}, {8850,0.0107714}, {8900,0.0097714}, {8950,0.0107143}, {9000,0.0102857}, {9050,0.0101714}, {9100,0.0102571}, {9150,0.0107714}, {9200,0.0110000}, {9250,0.0111714}, {9300,0.0108857}, {9350,0.0106571}, {9400,0.0108286}, {9450,0.0101429}, {9500,0.0106571}, {9550,0.0108571}, {9600,0.0339429}, {9650,0.0115143}, {9700,0.0112857}, {9750,0.0117143}, {9800,0.0118857}, {9850,0.0116571}, {9900,0.0264571}, {9950,0.0117714}, {10000,0.0119714}, {10100,0.0118000}, {10200,0.0120857}, {10300,0.0122571}, {10400,0.0121714}, {10500,0.0125143}, {10600,0.0121429}, {10700,0.0123143}, {10800,0.0126857}, {10900,0.0129429}, {11000,0.0129714}, {11100,0.0132286}, {11200,0.0131714}, {11300,0.0131143}, {11400,0.0127143}, {11500,0.0131143}, {11600,0.0136286}, {11700,0.0134286}, {11800,0.0134286}, {11900,0.0093714}, {12000,0.0138286}, {12100,0.0260000}, {12200,0.0142000}, {12300,0.0144857}, {12400,0.0146571}, {12500,0.0140857}, {12600,0.0478571}, {12700,0.0143714}, {12800,0.0148000}, {12900,0.0150000}, {13000,0.0149143}, {13100,0.0147714}, {13200,0.0150286}, {13300,0.0153714}, {13400,0.0523143}, {13500,0.0153429}, {13600,0.0156857}, {13700,0.0153429}, {13800,0.0157143}, {13900,0.0124286}, {14000,0.0158286}, {14100,0.0144857}, {14200,0.0139143}, {14300,0.0158000}, {14400,0.0149429}, {14500,0.0166571}, {14600,0.0171143}, {14700,0.0163429}, {14800,0.0447143}, {14900,0.0177143}, {15000,0.0172857}, {15100,0.0170000}, {15200,0.0177143}, {15300,0.0153143}, {15400,0.0180857}, {15500,0.0175143}, {15600,0.0175714}, {15700,0.0186857}, {15800,0.0399143}, {15900,0.0185714}, {16000,0.0510571}, {16100,0.0184286}, {16200,0.0188857}, {16300,0.0185429}, {16400,0.0185429}, {16500,0.0164286}, {16600,0.0190000}, {16700,0.0186286}, {16800,0.0529429}, {16900,0.0197714}, {17000,0.0194857}, {17100,0.0158000}, {17200,0.0198000}, {17300,0.0138571}, {17400,0.0473143}, {17500,0.0647143}, {17600,0.0203143}, {17700,0.0636857}, {17800,0.0184286}, {17900,0.0624857}, {18000,0.0209714}, {18100,0.0212571}, {18200,0.0213714}, {18300,0.0212286}, {18400,0.0184857}, {18500,0.0214286}, {18600,0.0784000}, {18700,0.0218857}, {18800,0.0221143}, {18900,0.0223143}, {19000,0.0222571}, {19100,0.0190000}, {19200,0.0230571}, {19300,0.0212000}, {19400,0.0192286}, {19500,0.0194571}, {19600,0.0192857}, {19700,0.0230286}, {19800,0.0183143}, {19900,0.0556000}, {20000,0.0234571}};
data["big_flat"]["LtacPrimUncurry"]["eval lazy"]["system"] = {{1,0.00003960}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00003960}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00002970}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00002970}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00002970}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00003960}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00003960}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00002970}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00003960}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00003960}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00002970}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00002970}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00003960}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00003960}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00003960}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00002970}, {365,0.00000000}, {366,0.00003960}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00003960}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00003960}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00002970}, {381,0.00000000}, {382,0.00007921}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00003960}, {396,0.00000000}, {397,0.00003960}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00003960}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00006931}, {413,0.00007921}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00003960}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00003960}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00003960}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00003960}, {446,0.00000000}, {447,0.00000000}, {448,0.00003960}, {449,0.00000000}, {450,0.00003960}, {451,0.00000000}, {452,0.00003960}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00003960}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00003960}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00003960}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00003960}, {486,0.00000000}, {487,0.00003960}, {488,0.00000000}, {489,0.00002970}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00007921}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00003960}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00003960}, {570,0.00003960}, {575,0.00002970}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00003960}, {610,0.00000000}, {615,0.00007921}, {620,0.00000000}, {625,0.00000000}, {630,0.00007921}, {635,0.00003960}, {640,0.00000000}, {645,0.00000000}, {650,0.00025743}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00003960}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00003960}, {925,0.00007921}, {930,0.00003960}, {935,0.00003960}, {940,0.00003960}, {945,0.00003960}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00003960}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00003960}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00003960}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00003960}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00003960}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00003960}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00003960}, {1530,0.00000000}, {1540,0.00003960}, {1550,0.00002970}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00003960}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00003960}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00007921}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00007921}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00003960}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00003960}, {1880,0.00003960}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00003960}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00003960}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00003960}, {2450,0.00000000}, {2500,0.00003960}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00007921}, {2700,0.00007921}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00003960}, {2900,0.00000000}, {2950,0.00003960}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00003960}, {3150,0.00000000}, {3200,0.00003960}, {3250,0.00003960}, {3300,0.00003960}, {3350,0.00003960}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00003960}, {3600,0.00003960}, {3650,0.00000000}, {3700,0.00003960}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00003960}, {4050,0.00000000}, {4100,0.00014851}, {4150,0.00014851}, {4200,0.00011881}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00002970}, {4400,0.00003960}, {4450,0.00003960}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00007921}, {4650,0.00000000}, {4700,0.00003960}, {4750,0.00011881}, {4800,0.00002970}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00003960}, {5150,0.00003960}, {5200,0.00003960}, {5250,0.00003960}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00003960}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00003960}, {6000,0.00000000}, {6050,0.0003429}, {6100,0.0008000}, {6150,0.0006000}, {6200,0.0001143}, {6250,0.0001143}, {6300,0.0002286}, {6350,0.0002286}, {6400,0.0002286}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0001143}, {6650,0.0001143}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000857}, {7050,0.0001143}, {7100,0.0000000}, {7150,0.0003429}, {7200,0.0000000}, {7250,0.0000857}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0001143}, {7900,0.0001143}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0001143}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0001143}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0001143}, {9600,0.0001143}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0001143}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0001143}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0001143}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0001143}, {11400,0.0000000}, {11500,0.0002286}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0001143}, {11900,0.0001143}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000857}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0001143}, {12600,0.0000000}, {12700,0.0001143}, {12800,0.0000000}, {12900,0.0001143}, {13000,0.0001143}, {13100,0.0001143}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0001143}, {14300,0.0000000}, {14400,0.0001143}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0001143}, {14900,0.0000000}, {15000,0.0001143}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0001143}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0001143}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0001143}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0001143}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0001143}, {19300,0.0001143}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0001143}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacPrimUncurry"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00511881}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000990}, {2050,0.00000000}, {2100,0.00000990}, {2150,0.00000000}, {2200,0.00004950}, {2250,0.00009901}, {2300,0.00055446}, {2350,0.00071287}, {2400,0.00068317}, {2450,0.00079208}, {2500,0.00100000}, {2550,0.00100000}, {2600,0.00100000}, {2650,0.00100000}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00100000}, {3150,0.00100000}, {3200,0.00100000}, {3250,0.00100000}, {3300,0.00100000}, {3350,0.00100000}, {3400,0.00100000}, {3450,0.00100000}, {3500,0.00100000}, {3550,0.00100000}, {3600,0.00100000}, {3650,0.00100000}, {3700,0.00100000}, {3750,0.00100000}, {3800,0.00100000}, {3850,0.01040594}, {3900,0.00100000}, {3950,0.00100000}, {4000,0.00100000}, {4050,0.00100000}, {4100,0.00100000}, {4150,0.00102970}, {4200,0.00101980}, {4250,0.00102970}, {4300,0.00102970}, {4350,0.00102970}, {4400,0.00104950}, {4450,0.00104950}, {4500,0.00105941}, {4550,0.00116832}, {4600,0.00139604}, {4650,0.00160396}, {4700,0.00175248}, {4750,0.00178218}, {4800,0.00177228}, {4850,0.00180198}, {4900,0.00185149}, {4950,0.00185149}, {5000,0.00194059}, {5050,0.00200000}, {5100,0.00200000}, {5150,0.00200000}, {5200,0.00200000}, {5250,0.00200000}, {5300,0.00200000}, {5350,0.00200000}, {5400,0.00200000}, {5450,0.00200000}, {5500,0.00200000}, {5550,0.00200000}, {5600,0.00200000}, {5650,0.00200000}, {5700,0.00200000}, {5750,0.00200000}, {5800,0.00200000}, {5850,0.00200000}, {5900,0.00200000}, {5950,0.00200000}, {6000,0.00201980}, {6050,0.0020571}, {6100,0.0020571}, {6150,0.0020571}, {6200,0.0020571}, {6250,0.0020857}, {6300,0.0152000}, {6350,0.0022857}, {6400,0.0023143}, {6450,0.0023429}, {6500,0.0024286}, {6550,0.0025143}, {6600,0.0025143}, {6650,0.0025143}, {6700,0.0026857}, {6750,0.0027714}, {6800,0.0028000}, {6850,0.0028571}, {6900,0.0028000}, {6950,0.0028857}, {7000,0.0028857}, {7050,0.0029714}, {7100,0.0028571}, {7150,0.0029429}, {7200,0.0030000}, {7250,0.0029429}, {7300,0.0029714}, {7350,0.0030000}, {7400,0.0030000}, {7450,0.0030000}, {7500,0.0030000}, {7550,0.0030000}, {7600,0.0030000}, {7650,0.0030000}, {7700,0.0030000}, {7750,0.0030000}, {7800,0.0030000}, {7850,0.0030000}, {7900,0.0030000}, {7950,0.0030000}, {8000,0.0030286}, {8050,0.0030571}, {8100,0.0030571}, {8150,0.0031429}, {8200,0.0031429}, {8250,0.0032286}, {8300,0.0032286}, {8350,0.0034571}, {8400,0.0035143}, {8450,0.0035143}, {8500,0.0035429}, {8550,0.0036857}, {8600,0.0037143}, {8650,0.0036286}, {8700,0.0232000}, {8750,0.0037714}, {8800,0.0037143}, {8850,0.0037429}, {8900,0.0037429}, {8950,0.0037429}, {9000,0.0037714}, {9050,0.0037714}, {9100,0.0038286}, {9150,0.0038571}, {9200,0.0038286}, {9250,0.0039143}, {9300,0.0290571}, {9350,0.0039143}, {9400,0.0039429}, {9450,0.0039714}, {9500,0.0040000}, {9550,0.0039714}, {9600,0.0040000}, {9650,0.0040000}, {9700,0.0040000}, {9750,0.0040000}, {9800,0.0040857}, {9850,0.0040571}, {9900,0.0040286}, {9950,0.0040286}, {10000,0.0040000}, {10100,0.0040286}, {10200,0.0274000}, {10300,0.0042286}, {10400,0.0044000}, {10500,0.0045143}, {10600,0.0047143}, {10700,0.0048000}, {10800,0.0048000}, {10900,0.0047714}, {11000,0.0048286}, {11100,0.0048286}, {11200,0.0048571}, {11300,0.0048571}, {11400,0.0048857}, {11500,0.0360286}, {11600,0.0049429}, {11700,0.0050000}, {11800,0.0049714}, {11900,0.0050286}, {12000,0.0050286}, {12100,0.0051714}, {12200,0.0051714}, {12300,0.0052857}, {12400,0.0054857}, {12500,0.0055714}, {12600,0.0056571}, {12700,0.0057143}, {12800,0.0408571}, {12900,0.0057714}, {13000,0.0058286}, {13100,0.0058000}, {13200,0.0395143}, {13300,0.0058000}, {13400,0.0058571}, {13500,0.0058571}, {13600,0.0058571}, {13700,0.0058571}, {13800,0.0058571}, {13900,0.0059714}, {14000,0.0060571}, {14100,0.0060571}, {14200,0.0061714}, {14300,0.0064571}, {14400,0.0063429}, {14500,0.0065429}, {14600,0.0066286}, {14700,0.0067714}, {14800,0.0068286}, {14900,0.0437143}, {15000,0.0528286}, {15100,0.0068286}, {15200,0.0068286}, {15300,0.0068286}, {15400,0.0068857}, {15500,0.0068857}, {15600,0.0068571}, {15700,0.0068571}, {15800,0.0069143}, {15900,0.0069714}, {16000,0.0070000}, {16100,0.0070571}, {16200,0.0071714}, {16300,0.0306286}, {16400,0.0520571}, {16500,0.0075714}, {16600,0.0076857}, {16700,0.0076857}, {16800,0.0077714}, {16900,0.0078286}, {17000,0.0080286}, {17100,0.0078286}, {17200,0.0078000}, {17300,0.0078000}, {17400,0.0078000}, {17500,0.0078000}, {17600,0.0597143}, {17700,0.0078000}, {17800,0.0078000}, {17900,0.0078857}, {18000,0.0078857}, {18100,0.0080286}, {18200,0.0081429}, {18300,0.0081143}, {18400,0.0083143}, {18500,0.0083429}, {18600,0.0085143}, {18700,0.0087714}, {18800,0.0087429}, {18900,0.0088286}, {19000,0.0602000}, {19100,0.0088286}, {19200,0.0088286}, {19300,0.0088286}, {19400,0.0088286}, {19500,0.0088286}, {19600,0.0088286}, {19700,0.0088286}, {19800,0.0088571}, {19900,0.0088857}, {20000,0.0089429}};
data["big_flat"]["LtacPrimUncurry"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00002970}, {6,0.00005941}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003960}, {13,0.00000000}, {14,0.00002970}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00006931}, {20,0.00000000}, {21,0.00002970}, {22,0.00000000}, {23,0.00000000}, {24,0.00002970}, {25,0.00003960}, {26,0.00002970}, {27,0.00003960}, {28,0.00000000}, {29,0.00002970}, {30,0.00003960}, {31,0.00007921}, {32,0.00002970}, {33,0.00000000}, {34,0.00003960}, {35,0.00002970}, {36,0.00009901}, {37,0.00003960}, {38,0.00002970}, {39,0.00003960}, {40,0.00003960}, {41,0.00000000}, {42,0.00005941}, {43,0.00000000}, {44,0.00000000}, {45,0.00003960}, {46,0.00000000}, {47,0.00000000}, {48,0.00002970}, {49,0.00002970}, {50,0.00000000}, {51,0.00003960}, {52,0.00000000}, {53,0.00002970}, {54,0.00003960}, {55,0.00000000}, {56,0.00009901}, {57,0.00005941}, {58,0.00000000}, {59,0.00000000}, {60,0.00006931}, {61,0.00002970}, {62,0.00002970}, {63,0.00000000}, {64,0.00002970}, {65,0.00002970}, {66,0.00003960}, {67,0.00003960}, {68,0.00007921}, {69,0.00011881}, {70,0.00000000}, {71,0.00003960}, {72,0.00000000}, {73,0.00013861}, {74,0.00010891}, {75,0.00002970}, {76,0.00000000}, {77,0.00006931}, {78,0.00003960}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00003960}, {83,0.00010891}, {84,0.00003960}, {85,0.00003960}, {86,0.00007921}, {87,0.00003960}, {88,0.00011881}, {89,0.00006931}, {90,0.00003960}, {91,0.00006931}, {92,0.00006931}, {93,0.00006931}, {94,0.00006931}, {95,0.00008911}, {96,0.00002970}, {97,0.00003960}, {98,0.00000000}, {99,0.00002970}, {100,0.00003960}, {101,0.00011881}, {102,0.00006931}, {103,0.00009901}, {104,0.00005941}, {105,0.00013861}, {106,0.00002970}, {107,0.00016832}, {108,0.00012871}, {109,0.00005941}, {110,0.00003960}, {111,0.00009901}, {112,0.00005941}, {113,0.00000000}, {114,0.00009901}, {115,0.00009901}, {116,0.00007921}, {117,0.00003960}, {118,0.00009901}, {119,0.00002970}, {120,0.00000000}, {121,0.00002970}, {122,0.00009901}, {123,0.00003960}, {124,0.00002970}, {125,0.00003960}, {126,0.00012871}, {127,0.00006931}, {128,0.00011881}, {129,0.00007921}, {130,0.00002970}, {131,0.00011881}, {132,0.00010891}, {133,0.00006931}, {134,0.00002970}, {135,0.00002970}, {136,0.00005941}, {137,0.00006931}, {138,0.00017822}, {139,0.00006931}, {140,0.00000000}, {141,0.00009901}, {142,0.00011881}, {143,0.00017822}, {144,0.00008911}, {145,0.00005941}, {146,0.00009901}, {147,0.00007921}, {148,0.00006931}, {149,0.00013861}, {150,0.00009901}, {151,0.00002970}, {152,0.00010891}, {153,0.00020792}, {154,0.00025743}, {155,0.00000000}, {156,0.00005941}, {157,0.00005941}, {158,0.00002970}, {159,0.00017822}, {160,0.00009901}, {161,0.00011881}, {162,0.00005941}, {163,0.00012871}, {164,0.00005941}, {165,0.00009901}, {166,0.00008911}, {167,0.00013861}, {168,0.00000000}, {169,0.00000000}, {170,0.00008911}, {171,0.00009901}, {172,0.00005941}, {173,0.00013861}, {174,0.00002970}, {175,0.00006931}, {176,0.00005941}, {177,0.00008911}, {178,0.00005941}, {179,0.00009901}, {180,0.00015842}, {181,0.00019802}, {182,0.00011881}, {183,0.00015842}, {184,0.00009901}, {185,0.00008911}, {186,0.00008911}, {187,0.00002970}, {188,0.00018812}, {189,0.00020792}, {190,0.00002970}, {191,0.00005941}, {192,0.00017822}, {193,0.00008911}, {194,0.00006931}, {195,0.00018812}, {196,0.00012871}, {197,0.00002970}, {198,0.00014851}, {199,0.00007921}, {200,0.00000000}, {201,0.00023762}, {202,0.00005941}, {203,0.00011881}, {204,0.00005941}, {205,0.00015842}, {206,0.00008911}, {207,0.00008911}, {208,0.00013861}, {209,0.00018812}, {210,0.00011881}, {211,0.00002970}, {212,0.00005941}, {213,0.00005941}, {214,0.00014851}, {215,0.00023762}, {216,0.00008911}, {217,0.00009901}, {218,0.00009901}, {219,0.00005941}, {220,0.00006931}, {221,0.00016832}, {222,0.00008911}, {223,0.00002970}, {224,0.00015842}, {225,0.00013861}, {226,0.00006931}, {227,0.00017822}, {228,0.00008911}, {229,0.00012871}, {230,0.00012871}, {231,0.00008911}, {232,0.00021782}, {233,0.00008911}, {234,0.00000000}, {235,0.00006931}, {236,0.00023762}, {237,0.00008911}, {238,0.00008911}, {239,0.00019802}, {240,0.00018812}, {241,0.00008911}, {242,0.00012871}, {243,0.00017822}, {244,0.00008911}, {245,0.00006931}, {246,0.00002970}, {247,0.00009901}, {248,0.00028713}, {249,0.00014851}, {250,0.00014851}, {251,0.00021782}, {252,0.00009901}, {253,0.00012871}, {254,0.00022772}, {255,0.00002970}, {256,0.00012871}, {257,0.00005941}, {258,0.00015842}, {259,0.00012871}, {260,0.00002970}, {261,0.00030693}, {262,0.00022772}, {263,0.00000000}, {264,0.00010891}, {265,0.00005941}, {266,0.00006931}, {267,0.00016832}, {268,0.00017822}, {269,0.00006931}, {270,0.00018812}, {271,0.00009901}, {272,0.00015842}, {273,0.00018812}, {274,0.00011881}, {275,0.00005941}, {276,0.00026733}, {277,0.00012871}, {278,0.00010891}, {279,0.00005941}, {280,0.00023762}, {281,0.00009901}, {282,0.00018812}, {283,0.00006931}, {284,0.00009901}, {285,0.00020792}, {286,0.00008911}, {287,0.00012871}, {288,0.00027723}, {289,0.00013861}, {290,0.00015842}, {291,0.00016832}, {292,0.00015842}, {293,0.00016832}, {294,0.00030693}, {295,0.00005941}, {296,0.00027723}, {297,0.00012871}, {298,0.00024752}, {299,0.00015842}, {300,0.00019802}, {301,0.00016832}, {302,0.00014851}, {303,0.00016832}, {304,0.00008911}, {305,0.00014851}, {306,0.00009901}, {307,0.00015842}, {308,0.00005941}, {309,0.00017822}, {310,0.00024752}, {311,0.00020792}, {312,0.00011881}, {313,0.00005941}, {314,0.00021782}, {315,0.00017822}, {316,0.00002970}, {317,0.00016832}, {318,0.00015842}, {319,0.00018812}, {320,0.00011881}, {321,0.00014851}, {322,0.00011881}, {323,0.00014851}, {324,0.00027723}, {325,0.00027723}, {326,0.00005941}, {327,0.00031683}, {328,0.00005941}, {329,0.00023762}, {330,0.00015842}, {331,0.00022772}, {332,0.00008911}, {333,0.00009901}, {334,0.00016832}, {335,0.00015842}, {336,0.00011881}, {337,0.00011881}, {338,0.00019802}, {339,0.00030693}, {340,0.00013861}, {341,0.00027723}, {342,0.00011881}, {343,0.00018812}, {344,0.00025743}, {345,0.00015842}, {346,0.00019802}, {347,0.00018812}, {348,0.00016832}, {349,0.00026733}, {350,0.00015842}, {351,0.00022772}, {352,0.00012871}, {353,0.00011881}, {354,0.00005941}, {355,0.00000000}, {356,0.00003960}, {357,0.00013861}, {358,0.00030693}, {359,0.00005941}, {360,0.00011881}, {361,0.00011881}, {362,0.00020792}, {363,0.00020792}, {364,0.00017822}, {365,0.00029703}, {366,0.00025743}, {367,0.00025743}, {368,0.00009901}, {369,0.00018812}, {370,0.00007921}, {371,0.00027723}, {372,0.00024752}, {373,0.00010891}, {374,0.00021782}, {375,0.00017822}, {376,0.00006931}, {377,0.00010891}, {378,0.00022772}, {379,0.00015842}, {380,0.00017822}, {381,0.00010891}, {382,0.00022772}, {383,0.00036634}, {384,0.00013861}, {385,0.00018812}, {386,0.00032673}, {387,0.00015842}, {388,0.00007921}, {389,0.00011881}, {390,0.00010891}, {391,0.00031683}, {392,0.00009901}, {393,0.00040594}, {394,0.00016832}, {395,0.00028713}, {396,0.00026733}, {397,0.00007921}, {398,0.00017822}, {399,0.00010891}, {400,0.00016832}, {401,0.00026733}, {402,0.00017822}, {403,0.00014851}, {404,0.00018812}, {405,0.00026733}, {406,0.00011881}, {407,0.00022772}, {408,0.00017822}, {409,0.00036634}, {410,0.00006931}, {411,0.00018812}, {412,0.00014851}, {413,0.00024752}, {414,0.00014851}, {415,0.00010891}, {416,0.00010891}, {417,0.00030693}, {418,0.00013861}, {419,0.00021782}, {420,0.00019802}, {421,0.00029703}, {422,0.00023762}, {423,0.00017822}, {424,0.00024752}, {425,0.00013861}, {426,0.00016832}, {427,0.00035644}, {428,0.00029703}, {429,0.00008911}, {430,0.00014851}, {431,0.00021782}, {432,0.00025743}, {433,0.00023762}, {434,0.00029703}, {435,0.00021782}, {436,0.00010891}, {437,0.00017822}, {438,0.00013861}, {439,0.00010891}, {440,0.00014851}, {441,0.00015842}, {442,0.00010891}, {443,0.00014851}, {444,0.00021782}, {445,0.00009901}, {446,0.00026733}, {447,0.00017822}, {448,0.00021782}, {449,0.00025743}, {450,0.00021782}, {451,0.00007921}, {452,0.00007921}, {453,0.00010891}, {454,0.00037624}, {455,0.00017822}, {456,0.00027723}, {457,0.00025743}, {458,0.00017822}, {459,0.00018812}, {460,0.00015842}, {461,0.00010891}, {462,0.00021782}, {463,0.00027723}, {464,0.00043564}, {465,0.00012871}, {466,0.00017822}, {467,0.00023762}, {468,0.00013861}, {469,0.00017822}, {470,0.00026733}, {471,0.00039604}, {472,0.00028713}, {473,0.00020792}, {474,0.00023762}, {475,0.00017822}, {476,0.00010891}, {477,0.00014851}, {478,0.00025743}, {479,0.00003960}, {480,0.00034653}, {481,0.00017822}, {482,0.00019802}, {483,0.00026733}, {484,0.00022772}, {485,0.00028713}, {486,0.00043564}, {487,0.00035644}, {488,0.00030693}, {489,0.00022772}, {490,0.00019802}, {491,0.00029703}, {492,0.00030693}, {493,0.00002970}, {494,0.00025743}, {495,0.00026733}, {496,0.00026733}, {497,0.00024752}, {498,0.00034653}, {499,0.00024752}, {500,0.00030693}, {505,0.00017822}, {510,0.00014851}, {515,0.00030693}, {520,0.00024752}, {525,0.00032673}, {530,0.00011881}, {535,0.00011881}, {540,0.00037624}, {545,0.00035644}, {550,0.00026733}, {555,0.00020792}, {560,0.00021782}, {565,0.00033663}, {570,0.00016832}, {575,0.00035644}, {580,0.00017822}, {585,0.00020792}, {590,0.00018812}, {595,0.00021782}, {600,0.00035644}, {605,0.00038614}, {610,0.00030693}, {615,0.00024752}, {620,0.00011881}, {625,0.00027723}, {630,0.00018812}, {635,0.00020792}, {640,0.00038614}, {645,0.00021782}, {650,0.00025743}, {655,0.00032673}, {660,0.00035644}, {665,0.00023762}, {670,0.00022772}, {675,0.00019802}, {680,0.00039604}, {685,0.00020792}, {690,0.00038614}, {695,0.00040594}, {700,0.00029703}, {705,0.00035644}, {710,0.00030693}, {715,0.00036634}, {720,0.00036634}, {725,0.00032673}, {730,0.00045545}, {735,0.00022772}, {740,0.00026733}, {745,0.00044554}, {750,0.00056436}, {755,0.00032673}, {760,0.00017822}, {765,0.00032673}, {770,0.00023762}, {775,0.00035644}, {780,0.00015842}, {785,0.00022772}, {790,0.00039604}, {795,0.00021782}, {800,0.00023762}, {805,0.00044554}, {810,0.00029703}, {815,0.00035644}, {820,0.00031683}, {825,0.00034653}, {830,0.00037624}, {835,0.00021782}, {840,0.00022772}, {845,0.00030693}, {850,0.00012871}, {855,0.00032673}, {860,0.00041584}, {865,0.00038614}, {870,0.00034653}, {875,0.00031683}, {880,0.00037624}, {885,0.00057426}, {890,0.00039604}, {895,0.00038614}, {900,0.00047525}, {905,0.00038614}, {910,0.00047525}, {915,0.00026733}, {920,0.00045545}, {925,0.00023762}, {930,0.00021782}, {935,0.00025743}, {940,0.00023762}, {945,0.00024752}, {950,0.00025743}, {955,0.00031683}, {960,0.00024752}, {965,0.00019802}, {970,0.00024752}, {975,0.00035644}, {980,0.00044554}, {985,0.00042574}, {990,0.00033663}, {995,0.00051485}, {1000,0.00056436}, {1010,0.00041584}, {1020,0.00035644}, {1030,0.00047525}, {1040,0.00039604}, {1050,0.00038614}, {1060,0.00034653}, {1070,0.00057426}, {1080,0.00037624}, {1090,0.00052475}, {1100,0.00034653}, {1110,0.00025743}, {1120,0.00038614}, {1130,0.00026733}, {1140,0.00036634}, {1150,0.00032673}, {1160,0.00046535}, {1170,0.00036634}, {1180,0.00039604}, {1190,0.00044554}, {1200,0.00054455}, {1210,0.00037624}, {1220,0.00036634}, {1230,0.00036634}, {1240,0.00035644}, {1250,0.00048515}, {1260,0.00047525}, {1270,0.00045545}, {1280,0.00049505}, {1290,0.00046535}, {1300,0.00055446}, {1310,0.00049505}, {1320,0.00068317}, {1330,0.00046535}, {1340,0.00040594}, {1350,0.00045545}, {1360,0.00054455}, {1370,0.00033663}, {1380,0.00020792}, {1390,0.00062376}, {1400,0.00032673}, {1410,0.00049505}, {1420,0.00059406}, {1430,0.00047525}, {1440,0.00043564}, {1450,0.00047525}, {1460,0.00052475}, {1470,0.00042574}, {1480,0.00040594}, {1490,0.00056436}, {1500,0.00038614}, {1510,0.00064356}, {1520,0.00040594}, {1530,0.00044554}, {1540,0.00045545}, {1550,0.00052475}, {1560,0.00035644}, {1570,0.00069307}, {1580,0.00068317}, {1590,0.00067327}, {1600,0.00067327}, {1610,0.00047525}, {1620,0.00071287}, {1630,0.00069307}, {1640,0.00051485}, {1650,0.00066337}, {1660,0.00039604}, {1670,0.00040594}, {1680,0.00073267}, {1690,0.00067327}, {1700,0.00057426}, {1710,0.00051485}, {1720,0.00067327}, {1730,0.00043564}, {1740,0.00078218}, {1750,0.00072277}, {1760,0.00062376}, {1770,0.00056436}, {1780,0.00060396}, {1790,0.00096040}, {1800,0.00050495}, {1810,0.00076238}, {1820,0.00056436}, {1830,0.00055446}, {1840,0.00057426}, {1850,0.00058416}, {1860,0.00057426}, {1870,0.00055446}, {1880,0.00074257}, {1890,0.00078218}, {1900,0.00073267}, {1910,0.00523762}, {1920,0.00056436}, {1930,0.00058416}, {1940,0.00071287}, {1950,0.00058416}, {1960,0.00060396}, {1970,0.00074257}, {1980,0.00072277}, {1990,0.00070297}, {2000,0.00078218}, {2050,0.00100990}, {2100,0.00089109}, {2150,0.00103960}, {2200,0.00060396}, {2250,0.00083168}, {2300,0.00064356}, {2350,0.00081188}, {2400,0.00070297}, {2450,0.00097030}, {2500,0.00110891}, {2550,0.00108911}, {2600,0.00127723}, {2650,0.00122772}, {2700,0.00131683}, {2750,0.00091089}, {2800,0.00120792}, {2850,0.00103960}, {2900,0.00118812}, {2950,0.00151485}, {3000,0.00106931}, {3050,0.00116832}, {3100,0.00113861}, {3150,0.00093069}, {3200,0.00112871}, {3250,0.00116832}, {3300,0.00121782}, {3350,0.00129703}, {3400,0.00133663}, {3450,0.00164356}, {3500,0.00116832}, {3550,0.00135644}, {3600,0.00125743}, {3650,0.00118812}, {3700,0.00126733}, {3750,0.00158416}, {3800,0.00146535}, {3850,0.01082178}, {3900,0.00149505}, {3950,0.00144554}, {4000,0.00119802}, {4050,0.00139604}, {4100,0.00150495}, {4150,0.00167327}, {4200,0.00183168}, {4250,0.00113861}, {4300,0.00169307}, {4350,0.00163366}, {4400,0.00174257}, {4450,0.00162376}, {4500,0.00171287}, {4550,0.00167327}, {4600,0.00170297}, {4650,0.00179208}, {4700,0.00191089}, {4750,0.00167327}, {4800,0.00191089}, {4850,0.00194059}, {4900,0.00168317}, {4950,0.00210891}, {5000,0.00171287}, {5050,0.00206931}, {5100,0.00168317}, {5150,0.00190099}, {5200,0.00201980}, {5250,0.00189109}, {5300,0.00219802}, {5350,0.00214851}, {5400,0.00185149}, {5450,0.00243564}, {5500,0.00232673}, {5550,0.00213861}, {5600,0.00219802}, {5650,0.00219802}, {5700,0.00230693}, {5750,0.00218812}, {5800,0.00229703}, {5850,0.00246535}, {5900,0.00220792}, {5950,0.00236634}, {6000,0.00219802}, {6050,0.0020000}, {6100,0.0021143}, {6150,0.0015714}, {6200,0.0019429}, {6250,0.0024857}, {6300,0.0146286}, {6350,0.0026571}, {6400,0.0024000}, {6450,0.0028857}, {6500,0.0026857}, {6550,0.0022857}, {6600,0.0026286}, {6650,0.0023143}, {6700,0.0028857}, {6750,0.0024000}, {6800,0.0024000}, {6850,0.0026571}, {6900,0.0025714}, {6950,0.0029143}, {7000,0.0027429}, {7050,0.0026857}, {7100,0.0028286}, {7150,0.0024857}, {7200,0.0028857}, {7250,0.0026571}, {7300,0.0027714}, {7350,0.0028571}, {7400,0.0023714}, {7450,0.0028286}, {7500,0.0031714}, {7550,0.0030286}, {7600,0.0030000}, {7650,0.0031429}, {7700,0.0031143}, {7750,0.0030857}, {7800,0.0032857}, {7850,0.0033143}, {7900,0.0032571}, {7950,0.0032857}, {8000,0.0029714}, {8050,0.0030571}, {8100,0.0033429}, {8150,0.0035143}, {8200,0.0033714}, {8250,0.0034571}, {8300,0.0034286}, {8350,0.0034571}, {8400,0.0036000}, {8450,0.0034286}, {8500,0.0035714}, {8550,0.0037429}, {8600,0.0036571}, {8650,0.0035143}, {8700,0.0240000}, {8750,0.0034571}, {8800,0.0038286}, {8850,0.0034857}, {8900,0.0037143}, {8950,0.0036286}, {9000,0.0040000}, {9050,0.0039143}, {9100,0.0035714}, {9150,0.0039714}, {9200,0.0041714}, {9250,0.0036571}, {9300,0.0296286}, {9350,0.0038286}, {9400,0.0038571}, {9450,0.0038571}, {9500,0.0043143}, {9550,0.0042286}, {9600,0.0041714}, {9650,0.0042000}, {9700,0.0038571}, {9750,0.0040571}, {9800,0.0038571}, {9850,0.0042857}, {9900,0.0043143}, {9950,0.0041429}, {10000,0.0039429}, {10100,0.0041714}, {10200,0.0268286}, {10300,0.0047714}, {10400,0.0045429}, {10500,0.0038286}, {10600,0.0045429}, {10700,0.0041143}, {10800,0.0045714}, {10900,0.0041714}, {11000,0.0044857}, {11100,0.0041143}, {11200,0.0040286}, {11300,0.0047429}, {11400,0.0047429}, {11500,0.0361143}, {11600,0.0048857}, {11700,0.0054857}, {11800,0.0046286}, {11900,0.0050857}, {12000,0.0046000}, {12100,0.0051429}, {12200,0.0048000}, {12300,0.0048286}, {12400,0.0051714}, {12500,0.0056857}, {12600,0.0056000}, {12700,0.0060000}, {12800,0.0405714}, {12900,0.0060286}, {13000,0.0053143}, {13100,0.0058571}, {13200,0.0395429}, {13300,0.0060286}, {13400,0.0057143}, {13500,0.0056857}, {13600,0.0054857}, {13700,0.0063429}, {13800,0.0061143}, {13900,0.0064000}, {14000,0.0063143}, {14100,0.0068000}, {14200,0.0064286}, {14300,0.0066000}, {14400,0.0060286}, {14500,0.0066000}, {14600,0.0061143}, {14700,0.0066286}, {14800,0.0067143}, {14900,0.0431143}, {15000,0.0524857}, {15100,0.0064857}, {15200,0.0067143}, {15300,0.0069429}, {15400,0.0066000}, {15500,0.0068286}, {15600,0.0069714}, {15700,0.0068000}, {15800,0.0071143}, {15900,0.0068571}, {16000,0.0072286}, {16100,0.0068857}, {16200,0.0072000}, {16300,0.0304857}, {16400,0.0522571}, {16500,0.0073714}, {16600,0.0068000}, {16700,0.0073714}, {16800,0.0073429}, {16900,0.0074857}, {17000,0.0080857}, {17100,0.0079429}, {17200,0.0075143}, {17300,0.0078000}, {17400,0.0078000}, {17500,0.0074286}, {17600,0.0600286}, {17700,0.0079143}, {17800,0.0078000}, {17900,0.0078571}, {18000,0.0078857}, {18100,0.0080000}, {18200,0.0077143}, {18300,0.0080286}, {18400,0.0076286}, {18500,0.0082571}, {18600,0.0077714}, {18700,0.0082571}, {18800,0.0081714}, {18900,0.0088571}, {19000,0.0608857}, {19100,0.0088571}, {19200,0.0083143}, {19300,0.0086857}, {19400,0.0089714}, {19500,0.0089714}, {19600,0.0090571}, {19700,0.0090857}, {19800,0.0092286}, {19900,0.0090857}, {20000,0.0088857}};
data["big_flat"]["LtacPrimUncurry"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00003960}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00003960}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00003960}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00002970}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00003960}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00002970}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00003960}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00003960}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00002970}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00002970}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00002970}, {314,0.00003960}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00003960}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00002970}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00003960}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00003960}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00003960}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00002970}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00003960}, {400,0.00003960}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00002970}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00002970}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00002970}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00003960}, {431,0.00003960}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00003960}, {440,0.00000000}, {441,0.00003960}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00003960}, {447,0.00003960}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00007921}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00003960}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00007921}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00003960}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00003960}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00003960}, {555,0.00000000}, {560,0.00003960}, {565,0.00000000}, {570,0.00000000}, {575,0.00007921}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00003960}, {615,0.00000000}, {620,0.00000000}, {625,0.00003960}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00018812}, {655,0.00002970}, {660,0.00000000}, {665,0.00000000}, {670,0.00003960}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00003960}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00003960}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00003960}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00003960}, {935,0.00003960}, {940,0.00000000}, {945,0.00000000}, {950,0.00007921}, {955,0.00000000}, {960,0.00003960}, {965,0.00000000}, {970,0.00003960}, {975,0.00000000}, {980,0.00000000}, {985,0.00003960}, {990,0.00003960}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00003960}, {1240,0.00000000}, {1250,0.00003960}, {1260,0.00003960}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00003960}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00002970}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00003960}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00003960}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00003960}, {1700,0.00003960}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00003960}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00003960}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00006931}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00006931}, {3050,0.00003960}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00003960}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00003960}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00003960}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00003960}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00003960}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00003960}, {4200,0.00003960}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00003960}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00003960}, {4750,0.00007921}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00007921}, {5100,0.00000000}, {5150,0.00003960}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00006931}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00003960}, {6000,0.00003960}, {6050,0.0009143}, {6100,0.0001143}, {6150,0.0002286}, {6200,0.0002000}, {6250,0.0001143}, {6300,0.0003429}, {6350,0.0001143}, {6400,0.0004571}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0001143}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0001143}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0001143}, {7100,0.0000000}, {7150,0.0002286}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0001143}, {8050,0.0000000}, {8100,0.0001143}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0001143}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0001143}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0001143}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000857}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0001143}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0001143}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0001143}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0001143}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0001143}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0001143}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0001143}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000857}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacPrimUncurry"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00007921}, {7,0.00100000}, {8,0.00100000}, {9,0.00100000}, {10,0.00101980}, {11,0.00100000}, {12,0.00100000}, {13,0.00100990}, {14,0.00118812}, {15,0.00199010}, {16,0.00200990}, {17,0.00200000}, {18,0.00200000}, {19,0.00200000}, {20,0.00200990}, {21,0.00218812}, {22,0.00228713}, {23,0.00295050}, {24,0.00300000}, {25,0.00300000}, {26,0.00300000}, {27,0.00301980}, {28,0.00300990}, {29,0.00308911}, {30,0.00334653}, {31,0.00399010}, {32,0.00400000}, {33,0.00400000}, {34,0.00400000}, {35,0.00408911}, {36,0.00416832}, {37,0.00423762}, {38,0.00446535}, {39,0.00499010}, {40,0.00500000}, {41,0.00500990}, {42,0.00505941}, {43,0.00519802}, {44,0.00607921}, {45,0.00523762}, {46,0.00553465}, {47,0.00598020}, {48,0.00600000}, {49,0.00600000}, {50,0.00607921}, {51,0.00617822}, {52,0.00623762}, {53,0.00634653}, {54,0.00662376}, {55,0.00698020}, {56,0.00800000}, {57,0.00708911}, {58,0.00716832}, {59,0.00722772}, {60,0.00724752}, {61,0.00739604}, {62,0.00762376}, {63,0.00803960}, {64,0.00805941}, {65,0.00818812}, {66,0.00933663}, {67,0.00835644}, {68,0.00837624}, {69,0.00844554}, {70,0.00871287}, {71,0.00905941}, {72,0.00905941}, {73,0.00918812}, {74,0.00924752}, {75,0.00928713}, {76,0.00931683}, {77,0.00941584}, {78,0.00975248}, {79,0.01022772}, {80,0.01029703}, {81,0.01038614}, {82,0.01503960}, {83,0.01013861}, {84,0.01028713}, {85,0.01053465}, {86,0.01087129}, {87,0.01122772}, {88,0.01123762}, {89,0.01133663}, {90,0.01258416}, {91,0.01131683}, {92,0.01150495}, {93,0.01181188}, {94,0.01211881}, {95,0.01228713}, {96,0.01821782}, {97,0.01209901}, {98,0.01225743}, {99,0.01239604}, {100,0.01247525}, {101,0.01257426}, {102,0.01281188}, {103,0.01504950}, {104,0.01321782}, {105,0.01321782}, {106,0.01337624}, {107,0.01357426}, {108,0.01357426}, {109,0.01545545}, {110,0.01412871}, {111,0.01437624}, {112,0.01437624}, {113,0.01443564}, {114,0.02087129}, {115,0.01431683}, {116,0.01441584}, {117,0.01470297}, {118,0.01502970}, {119,0.01532673}, {120,0.01753465}, {121,0.01529703}, {122,0.01544554}, {123,0.01568317}, {124,0.01567327}, {125,0.01915842}, {126,0.01604950}, {127,0.01623762}, {128,0.01614851}, {129,0.01621782}, {130,0.01952475}, {131,0.01650495}, {132,0.01673267}, {133,0.01694059}, {134,0.01720792}, {135,0.01953465}, {136,0.01724752}, {137,0.01735644}, {138,0.01757426}, {139,0.01769307}, {140,0.01757426}, {141,0.01809901}, {142,0.01836634}, {143,0.01861386}, {144,0.02171287}, {145,0.01839604}, {146,0.01868317}, {147,0.01894059}, {148,0.01894059}, {149,0.01917822}, {150,0.01932673}, {151,0.01949505}, {152,0.01944554}, {153,0.02107921}, {154,0.01961386}, {155,0.01985149}, {156,0.01998020}, {157,0.02279208}, {158,0.02039604}, {159,0.02063366}, {160,0.02048515}, {161,0.02350495}, {162,0.02053465}, {163,0.02091089}, {164,0.02096040}, {165,0.02397030}, {166,0.02135644}, {167,0.02143564}, {168,0.02156436}, {169,0.02360396}, {170,0.02176238}, {171,0.02191089}, {172,0.02196040}, {173,0.02228713}, {174,0.02253465}, {175,0.02263366}, {176,0.02808911}, {177,0.02261386}, {178,0.02300000}, {179,0.02313861}, {180,0.02596040}, {181,0.02333663}, {182,0.02354455}, {183,0.03116832}, {184,0.02322772}, {185,0.02358416}, {186,0.02377228}, {187,0.02748515}, {188,0.02403960}, {189,0.02431683}, {190,0.03134653}, {191,0.02452475}, {192,0.02441584}, {193,0.02480198}, {194,0.02666337}, {195,0.02481188}, {196,0.02494059}, {197,0.02977228}, {198,0.02549505}, {199,0.02566337}, {200,0.03265347}, {201,0.02559406}, {202,0.02578218}, {203,0.02617822}, {204,0.02633663}, {205,0.02656436}, {206,0.02664356}, {207,0.02850495}, {208,0.02658416}, {209,0.02674257}, {210,0.02981188}, {211,0.02727723}, {212,0.02734653}, {213,0.03112871}, {214,0.02759406}, {215,0.02786139}, {216,0.03160396}, {217,0.02789109}, {218,0.02812871}, {219,0.03222772}, {220,0.02846535}, {221,0.02887129}, {222,0.03207921}, {223,0.02910891}, {224,0.02880198}, {225,0.03136634}, {226,0.02874257}, {227,0.02911881}, {228,0.03061386}, {229,0.02967327}, {230,0.02991089}, {231,0.03013861}, {232,0.03020792}, {233,0.03797030}, {234,0.03007921}, {235,0.03065347}, {236,0.03639604}, {237,0.03053465}, {238,0.03071287}, {239,0.03398020}, {240,0.03080198}, {241,0.03107921}, {242,0.03128713}, {243,0.03178218}, {244,0.03852475}, {245,0.03174257}, {246,0.03203960}, {247,0.03579208}, {248,0.03203960}, {249,0.04269307}, {250,0.03233663}, {251,0.03280198}, {252,0.03860396}, {253,0.03302970}, {254,0.03321782}, {255,0.03454455}, {256,0.03289109}, {257,0.04053465}, {258,0.03316832}, {259,0.03351485}, {260,0.03539604}, {261,0.03374257}, {262,0.04189109}, {263,0.03408911}, {264,0.03398020}, {265,0.03591089}, {266,0.03436634}, {267,0.04194059}, {268,0.03452475}, {269,0.03528713}, {270,0.03493069}, {271,0.03557426}, {272,0.04058416}, {273,0.03524752}, {274,0.04596040}, {275,0.03564356}, {276,0.03587129}, {277,0.03858416}, {278,0.03589109}, {279,0.04332673}, {280,0.03610891}, {281,0.04782178}, {282,0.03645545}, {283,0.03669307}, {284,0.04020792}, {285,0.03714851}, {286,0.04355446}, {287,0.03775248}, {288,0.04668317}, {289,0.03704950}, {290,0.03750495}, {291,0.03768317}, {292,0.03777228}, {293,0.04091089}, {294,0.03848515}, {295,0.04423762}, {296,0.03813861}, {297,0.04667327}, {298,0.03859406}, {299,0.04942574}, {300,0.03881188}, {301,0.03906931}, {302,0.04024752}, {303,0.03993069}, {304,0.04191089}, {305,0.03948515}, {306,0.04408911}, {307,0.04028713}, {308,0.04598020}, {309,0.04014851}, {310,0.04800990}, {311,0.04094059}, {312,0.04927723}, {313,0.04073267}, {314,0.05085149}, {315,0.04109901}, {316,0.05190099}, {317,0.04133663}, {318,0.05312871}, {319,0.04173267}, {320,0.05406931}, {321,0.04116832}, {322,0.04148515}, {323,0.04187129}, {324,0.04200000}, {325,0.04227723}, {326,0.04235644}, {327,0.04273267}, {328,0.04228713}, {329,0.04292079}, {330,0.04288119}, {331,0.04335644}, {332,0.04342574}, {333,0.04335644}, {334,0.04494059}, {335,0.04447525}, {336,0.05550495}, {337,0.04354455}, {338,0.05520792}, {339,0.04415842}, {340,0.05570297}, {341,0.04442574}, {342,0.05240594}, {343,0.04471287}, {344,0.05228713}, {345,0.04512871}, {346,0.05181188}, {347,0.04531683}, {348,0.05027723}, {349,0.04584158}, {350,0.04909901}, {351,0.04652475}, {352,0.04716832}, {353,0.04593069}, {354,0.04616832}, {355,0.05726733}, {356,0.04610891}, {357,0.05525743}, {358,0.04675248}, {359,0.05376238}, {360,0.04664356}, {361,0.05130693}, {362,0.04693069}, {363,0.04937624}, {364,0.06039604}, {365,0.04783168}, {366,0.06134653}, {367,0.04828713}, {368,0.05450495}, {369,0.04824752}, {370,0.05235644}, {371,0.04887129}, {372,0.04823762}, {373,0.06062376}, {374,0.04882178}, {375,0.05758416}, {376,0.04906931}, {377,0.05366337}, {378,0.04924752}, {379,0.04979208}, {380,0.06096040}, {381,0.05021782}, {382,0.05720792}, {383,0.05055446}, {384,0.05180198}, {385,0.06369307}, {386,0.05000000}, {387,0.05940594}, {388,0.05033663}, {389,0.05474257}, {390,0.06625743}, {391,0.05072277}, {392,0.06050495}, {393,0.05102970}, {394,0.05589109}, {395,0.06809901}, {396,0.05131683}, {397,0.06153465}, {398,0.05229703}, {399,0.05640594}, {400,0.06687129}, {401,0.05203960}, {402,0.06109901}, {403,0.05287129}, {404,0.05529703}, {405,0.06617822}, {406,0.05281188}, {407,0.06026733}, {408,0.05284158}, {409,0.05315842}, {410,0.06354455}, {411,0.05388119}, {412,0.05726733}, {413,0.06781188}, {414,0.05410891}, {415,0.06078218}, {416,0.07162376}, {417,0.05395050}, {418,0.06300000}, {419,0.05477228}, {420,0.05610891}, {421,0.06643564}, {422,0.05508911}, {423,0.05911881}, {424,0.06773267}, {425,0.05557426}, {426,0.06068317}, {427,0.07001980}, {428,0.05558416}, {429,0.06215842}, {430,0.07314851}, {431,0.05648515}, {432,0.06039604}, {433,0.08017822}, {434,0.05615842}, {435,0.06768317}, {436,0.08063366}, {437,0.05739604}, {438,0.06795050}, {439,0.08126733}, {440,0.05708911}, {441,0.06861386}, {442,0.07646535}, {443,0.05810891}, {444,0.06508911}, {445,0.07491089}, {446,0.05854455}, {447,0.06510891}, {448,0.07295050}, {449,0.05833663}, {450,0.06315842}, {451,0.07237624}, {452,0.05855446}, {453,0.06232673}, {454,0.07117822}, {455,0.05960396}, {456,0.06028713}, {457,0.06969307}, {458,0.07875248}, {459,0.05999010}, {460,0.06750495}, {461,0.07584158}, {462,0.06050495}, {463,0.06489109}, {464,0.07272277}, {465,0.06058416}, {466,0.06069307}, {467,0.07009901}, {468,0.07331683}, {469,0.06123762}, {470,0.06610891}, {471,0.07321782}, {472,0.06145545}, {473,0.06163366}, {474,0.06961386}, {475,0.07708911}, {476,0.06200990}, {477,0.06576238}, {478,0.07261386}, {479,0.08178218}, {480,0.06194059}, {481,0.06793069}, {482,0.07481188}, {483,0.06323762}, {484,0.06311881}, {485,0.06978218}, {486,0.07668317}, {487,0.06423762}, {488,0.06447525}, {489,0.07165347}, {490,0.07829703}, {491,0.06480198}, {492,0.06582178}, {493,0.07255446}, {494,0.07880198}, {495,0.06513861}, {496,0.06593069}, {497,0.07230693}, {498,0.07851485}, {499,0.06533663}, {500,0.06601980}, {505,0.07243564}, {510,0.07944554}, {515,0.08521782}, {520,0.06707921}, {525,0.07249505}, {530,0.07868317}, {535,0.08565347}, {540,0.09066337}, {545,0.07065347}, {550,0.07394059}, {555,0.07942574}, {560,0.08382178}, {565,0.08917822}, {570,0.09306931}, {575,0.09794059}, {580,0.07581188}, {585,0.07768317}, {590,0.08204950}, {595,0.08533663}, {600,0.08820792}, {605,0.09192079}, {610,0.09370297}, {615,0.09750495}, {620,0.09939604}, {625,0.10111881}, {630,0.10306931}, {635,0.10411881}, {640,0.10333663}, {645,0.10527723}, {650,1.09714851}, {655,0.11904950}, {660,0.11783168}, {665,0.11926733}, {670,0.11386139}, {675,0.11192079}, {680,0.11113861}, {685,0.11138614}, {690,0.11097030}, {695,0.11084158}, {700,0.10947525}, {705,0.10803960}, {710,0.10656436}, {715,0.10479208}, {720,0.10323762}, {725,0.10255446}, {730,0.10048515}, {735,0.12414851}, {740,0.12106931}, {745,0.11918812}, {750,0.11600000}, {755,0.11261386}, {760,0.10921782}, {765,0.10709901}, {770,0.12453465}, {775,0.12178218}, {780,0.11860396}, {785,0.11220792}, {790,0.11152475}, {795,0.13034653}, {800,0.11802970}, {805,0.11645545}, {810,0.11372277}, {815,0.11778218}, {820,0.14219802}, {825,0.13592079}, {830,0.12800990}, {835,0.11900990}, {840,0.13638614}, {845,0.13011881}, {850,0.12261386}, {855,0.14235644}, {860,0.13577228}, {865,0.12742574}, {870,0.14594059}, {875,0.13476238}, {880,0.12879208}, {885,0.14786139}, {890,0.14008911}, {895,0.13222772}, {900,0.14598020}, {905,0.13726733}, {910,0.12981188}, {915,0.14466337}, {920,0.13549505}, {925,0.15061386}, {930,0.14130693}, {935,0.13373267}, {940,0.14670297}, {945,0.13766337}, {950,0.15087129}, {955,0.14274257}, {960,0.15297030}, {965,0.14060396}, {970,0.15622772}, {975,0.14898020}, {980,0.17482178}, {985,0.15833663}, {990,0.17079208}, {995,0.15380198}, {1000,0.16603960}, {1010,0.15534653}, {1020,0.16815842}, {1030,0.15408911}, {1040,0.16263366}, {1050,0.15240594}, {1060,0.16281188}, {1070,0.17537624}, {1080,0.16034653}, {1090,0.16912871}, {1100,0.17820792}, {1110,0.16433663}, {1120,0.16982178}, {1130,0.18050495}, {1140,0.16643564}, {1150,0.17550495}, {1160,0.17956436}, {1170,0.18699010}, {1180,0.19396040}, {1190,0.18130693}, {1200,0.19388119}, {1210,0.20144554}, {1220,0.19997030}, {1230,0.20337624}, {1240,0.20786139}, {1250,0.21193069}, {1260,0.18613861}, {1270,0.19363366}, {1280,0.19235644}, {1290,0.19751485}, {1300,0.19957426}, {1310,0.20191089}, {1320,0.20111881}, {1330,0.20303960}, {1340,0.20429703}, {1350,0.20411881}, {1360,0.20371287}, {1370,0.20478218}, {1380,0.22619802}, {1390,0.22620792}, {1400,0.24465347}, {1410,0.23604950}, {1420,0.22494059}, {1430,0.22411881}, {1440,0.21912871}, {1450,0.24351485}, {1460,0.22875248}, {1470,0.23484158}, {1480,0.22758416}, {1490,0.24444554}, {1500,0.23965347}, {1510,0.23468317}, {1520,0.25063366}, {1530,0.24689109}, {1540,0.23701980}, {1550,0.25321782}, {1560,0.26798020}, {1570,0.25358416}, {1580,0.25956436}, {1590,0.25517822}, {1600,0.26957426}, {1610,0.25921782}, {1620,0.24976238}, {1630,0.26420792}, {1640,0.25067327}, {1650,0.26377228}, {1660,0.25554455}, {1670,0.26303960}, {1680,0.27802970}, {1690,0.26446535}, {1700,0.30121782}, {1710,0.27745545}, {1720,0.27813861}, {1730,0.29527723}, {1740,0.27316832}, {1750,0.28734653}, {1760,0.27411881}, {1770,0.27841584}, {1780,0.28531683}, {1790,0.29503960}, {1800,0.27660396}, {1810,0.28383168}, {1820,0.30349505}, {1830,0.32218812}, {1840,0.28794059}, {1850,0.29592079}, {1860,0.29697030}, {1870,0.29603960}, {1880,0.30865347}, {1890,0.31185149}, {1900,0.31444554}, {1910,0.29708911}, {1920,0.29525743}, {1930,0.30000000}, {1940,0.30174257}, {1950,0.32740594}, {1960,0.32048515}, {1970,0.31730693}, {1980,0.31923762}, {1990,0.31219802}, {2000,0.31615842}, {2050,0.31873267}, {2100,0.34638614}, {2150,0.34851485}, {2200,0.34811881}, {2250,0.36683168}, {2300,0.40129703}, {2350,0.39731683}, {2400,0.38709901}, {2450,0.39642574}, {2500,0.41197030}, {2550,0.42082178}, {2600,0.42481188}, {2650,0.43455446}, {2700,0.47263366}, {2750,0.45944554}, {2800,0.45818812}, {2850,0.47722772}, {2900,0.47190099}, {2950,0.49036634}, {3000,0.48838614}, {3050,0.53016832}, {3100,0.50818812}, {3150,0.51310891}, {3200,0.52233663}, {3250,0.52847525}, {3300,0.53150495}, {3350,0.53774257}, {3400,0.57688119}, {3450,0.59180198}, {3500,0.58528713}, {3550,0.57852475}, {3600,0.58841584}, {3650,0.59327723}, {3700,0.63435644}, {3750,0.62471287}, {3800,0.64488119}, {3850,0.62220792}, {3900,0.63507921}, {3950,0.68064356}, {4000,0.68652475}, {4050,0.68031683}, {4100,0.67357426}, {4150,0.67747525}, {4200,0.70294059}, {4250,0.72934653}, {4300,0.72112871}, {4350,0.72595050}, {4400,0.72109901}, {4450,0.73451485}, {4500,0.78861386}, {4550,0.76993069}, {4600,0.77744554}, {4650,0.77388119}, {4700,0.80015842}, {4750,0.80343564}, {4800,0.81090099}, {4850,0.80918812}, {4900,0.80238614}, {4950,0.85895050}, {5000,0.84952475}, {5050,0.84501980}, {5100,0.85079208}, {5150,0.88196040}, {5200,0.87596040}, {5250,0.87024752}, {5300,0.88230693}, {5350,0.89332673}, {5400,0.93406931}, {5450,0.91860396}, {5500,0.90982178}, {5550,0.93275248}, {5600,0.97018812}, {5650,0.95123762}, {5700,0.95793069}, {5750,0.99423762}, {5800,0.98556436}, {5850,0.98813861}, {5900,0.98004950}, {5950,1.02776238}, {6000,1.03029703}, {6050,1.0396571}, {6100,1.0716857}, {6150,1.0684286}, {6200,1.0637714}, {6250,1.1178571}, {6300,1.0886857}, {6350,1.1046857}, {6400,1.0628571}, {6450,1.1154000}, {6500,1.1265714}, {6550,1.1507143}, {6600,3.7936571}, {6650,1.1712571}, {6700,1.1572857}, {6750,1.1782000}, {6800,1.1777143}, {6850,1.1513714}, {6900,1.1468286}, {6950,1.2342857}, {7000,1.2110571}, {7050,1.2102857}, {7100,1.2420286}, {7150,1.2427429}, {7200,1.2130286}, {7250,1.2799143}, {7300,1.2568286}, {7350,1.2733429}, {7400,1.2825714}, {7450,1.2704000}, {7500,1.2860571}, {7550,1.3426571}, {7600,1.3271143}, {7650,1.3342571}, {7700,1.3293429}, {7750,1.3302571}, {7800,1.3270286}, {7850,1.3779143}, {7900,1.3864857}, {7950,1.3741714}, {8000,1.3820857}, {8050,1.3809714}, {8100,1.3904857}, {8150,1.4524286}, {8200,1.4206286}, {8250,1.4076857}, {8300,1.4402286}, {8350,1.4403429}, {8400,1.4380571}, {8450,1.4828286}, {8500,1.4882571}, {8550,1.4909714}, {8600,1.4888286}, {8650,1.4766286}, {8700,1.5391429}, {8750,1.5313429}, {8800,1.4860857}, {8850,1.5291429}, {8900,1.5006000}, {8950,1.5503429}, {9000,1.5660000}, {9050,1.5735143}, {9100,1.5829429}, {9150,1.5800571}, {9200,1.6075714}, {9250,1.6003143}, {9300,1.5930857}, {9350,1.6174286}, {9400,1.6008857}, {9450,1.6653143}, {9500,1.6520857}, {9550,1.6544000}, {9600,1.6668857}, {9650,1.6551714}, {9700,1.6859429}, {9750,1.7020000}, {9800,1.6775429}, {9850,1.7200000}, {9900,1.7064000}, {9950,1.7758286}, {10000,1.7400857}, {10100,1.7582857}, {10200,1.7596571}, {10300,1.7860571}, {10400,1.7906571}, {10500,1.8003714}, {10600,1.8437429}, {10700,1.8527143}, {10800,1.8835143}, {10900,1.8912286}, {11000,1.9302286}, {11100,1.9253143}, {11200,1.9542286}, {11300,1.9575714}, {11400,1.9712571}, {11500,1.9796000}, {11600,2.0222000}, {11700,2.0701429}, {11800,2.0312857}, {11900,2.0607429}, {12000,2.1028857}, {12100,2.0828857}, {12200,2.1142286}, {12300,2.0964000}, {12400,2.1810857}, {12500,2.1606000}, {12600,2.2130857}, {12700,2.2188000}, {12800,2.1972857}, {12900,2.2360857}, {13000,2.2440857}, {13100,2.3198571}, {13200,2.2936857}, {13300,2.3335429}, {13400,2.3560571}, {13500,2.3850571}, {13600,2.3328286}, {13700,2.3638857}, {13800,2.4578857}, {13900,2.4269143}, {14000,2.4288857}, {14100,2.5029714}, {14200,2.5018857}, {14300,2.5349143}, {14400,2.5032571}, {14500,2.5069429}, {14600,2.5210286}, {14700,2.5865143}, {14800,2.6249714}, {14900,2.6023143}, {15000,2.5785714}, {15100,2.7167429}, {15200,2.6528286}, {15300,2.7033429}, {15400,2.6882571}, {15500,2.7032286}, {15600,2.7517143}, {15700,2.7801143}, {15800,2.7928000}, {15900,2.7534000}, {16000,2.8235429}, {16100,2.8021429}, {16200,2.8200286}, {16300,2.8898857}, {16400,2.8020286}, {16500,2.8784571}, {16600,2.9206571}, {16700,2.9255429}, {16800,2.9561714}, {16900,2.9202857}, {17000,2.9414000}, {17100,3.0081429}, {17200,2.9928857}, {17300,2.9921143}, {17400,3.1330857}, {17500,3.0878857}, {17600,3.0446000}, {17700,3.0933714}, {17800,3.0797714}, {17900,3.2418571}, {18000,3.1194857}, {18100,3.1824000}, {18200,3.1746286}, {18300,3.2069143}, {18400,3.2597429}, {18500,3.1967714}, {18600,3.2964857}, {18700,3.2462286}, {18800,3.2307429}, {18900,3.3408000}, {19000,3.2646000}, {19100,3.3827429}, {19200,3.2965429}, {19300,6.8010857}, {19400,3.4250571}, {19500,3.3764857}, {19600,3.3933429}, {19700,3.4680571}, {19800,3.4539429}, {19900,3.5750286}, {20000,3.4564286}};
data["big_flat"]["LtacPrimUncurry"]["norm reif"]["user"] = {{1,0.00008911}, {2,0.00020792}, {3,0.00064356}, {4,0.00052475}, {5,0.00108911}, {6,0.00077228}, {7,0.00111881}, {8,0.00089109}, {9,0.00094059}, {10,0.00129703}, {11,0.00149505}, {12,0.00138614}, {13,0.00166337}, {14,0.00168317}, {15,0.00177228}, {16,0.00190099}, {17,0.00201980}, {18,0.00235644}, {19,0.00213861}, {20,0.00252475}, {21,0.00252475}, {22,0.00257426}, {23,0.00278218}, {24,0.00291089}, {25,0.00282178}, {26,0.00296040}, {27,0.00322772}, {28,0.00325743}, {29,0.00327723}, {30,0.00365347}, {31,0.00353465}, {32,0.00380198}, {33,0.00400990}, {34,0.00425743}, {35,0.00425743}, {36,0.00459406}, {37,0.00434653}, {38,0.00471287}, {39,0.00507921}, {40,0.00497030}, {41,0.00500990}, {42,0.00525743}, {43,0.00535644}, {44,0.00652475}, {45,0.00561386}, {46,0.00592079}, {47,0.00608911}, {48,0.00612871}, {49,0.00624752}, {50,0.00623762}, {51,0.00645545}, {52,0.00689109}, {53,0.00696040}, {54,0.00702970}, {55,0.00729703}, {56,0.00812871}, {57,0.00710891}, {58,0.00769307}, {59,0.00776238}, {60,0.00759406}, {61,0.00802970}, {62,0.00814851}, {63,0.00830693}, {64,0.00836634}, {65,0.00825743}, {66,0.00940594}, {67,0.00849505}, {68,0.00855446}, {69,0.00888119}, {70,0.00890099}, {71,0.00938614}, {72,0.00930693}, {73,0.00951485}, {74,0.00919802}, {75,0.00960396}, {76,0.00965347}, {77,0.00981188}, {78,0.00979208}, {79,0.01019802}, {80,0.01011881}, {81,0.01024752}, {82,0.01515842}, {83,0.01025743}, {84,0.01051485}, {85,0.01051485}, {86,0.01095050}, {87,0.01116832}, {88,0.01084158}, {89,0.01140594}, {90,0.01248515}, {91,0.01132673}, {92,0.01145545}, {93,0.01199010}, {94,0.01196040}, {95,0.01223762}, {96,0.01788119}, {97,0.01192079}, {98,0.01284158}, {99,0.01255446}, {100,0.01257426}, {101,0.01265347}, {102,0.01284158}, {103,0.01539604}, {104,0.01330693}, {105,0.01355446}, {106,0.01363366}, {107,0.01379208}, {108,0.01402970}, {109,0.01610891}, {110,0.01413861}, {111,0.01409901}, {112,0.01462376}, {113,0.01489109}, {114,0.02127723}, {115,0.01470297}, {116,0.01464356}, {117,0.01504950}, {118,0.01533663}, {119,0.01572277}, {120,0.01789109}, {121,0.01560396}, {122,0.01626733}, {123,0.01644554}, {124,0.01618812}, {125,0.01914851}, {126,0.01619802}, {127,0.01671287}, {128,0.01639604}, {129,0.01663366}, {130,0.01960396}, {131,0.01705941}, {132,0.01712871}, {133,0.01709901}, {134,0.01750495}, {135,0.01964356}, {136,0.01728713}, {137,0.01739604}, {138,0.01750495}, {139,0.01812871}, {140,0.01819802}, {141,0.01828713}, {142,0.01832673}, {143,0.01858416}, {144,0.02188119}, {145,0.01852475}, {146,0.01888119}, {147,0.01902970}, {148,0.01911881}, {149,0.01901980}, {150,0.01917822}, {151,0.01952475}, {152,0.01925743}, {153,0.02085149}, {154,0.01970297}, {155,0.02026733}, {156,0.02010891}, {157,0.02283168}, {158,0.02052475}, {159,0.02042574}, {160,0.02044554}, {161,0.02380198}, {162,0.02028713}, {163,0.02073267}, {164,0.02083168}, {165,0.02383168}, {166,0.02113861}, {167,0.02135644}, {168,0.02146535}, {169,0.02400000}, {170,0.02151485}, {171,0.02194059}, {172,0.02213861}, {173,0.02186139}, {174,0.02293069}, {175,0.02237624}, {176,0.02825743}, {177,0.02274257}, {178,0.02287129}, {179,0.02319802}, {180,0.02611881}, {181,0.02293069}, {182,0.02339604}, {183,0.03114851}, {184,0.02330693}, {185,0.02393069}, {186,0.02381188}, {187,0.02763366}, {188,0.02376238}, {189,0.02415842}, {190,0.03160396}, {191,0.02489109}, {192,0.02422772}, {193,0.02474257}, {194,0.02674257}, {195,0.02483168}, {196,0.02490099}, {197,0.02972277}, {198,0.02538614}, {199,0.02605941}, {200,0.03287129}, {201,0.02545545}, {202,0.02601980}, {203,0.02649505}, {204,0.02634653}, {205,0.02631683}, {206,0.02690099}, {207,0.02890099}, {208,0.02677228}, {209,0.02669307}, {210,0.03018812}, {211,0.02762376}, {212,0.02751485}, {213,0.03164356}, {214,0.02791089}, {215,0.02816832}, {216,0.03201980}, {217,0.02828713}, {218,0.02820792}, {219,0.03240594}, {220,0.02883168}, {221,0.02921782}, {222,0.03234653}, {223,0.02937624}, {224,0.02884158}, {225,0.03163366}, {226,0.02897030}, {227,0.02922772}, {228,0.03114851}, {229,0.02993069}, {230,0.02999010}, {231,0.03049505}, {232,0.03046535}, {233,0.03765347}, {234,0.03058416}, {235,0.03057426}, {236,0.03618812}, {237,0.03086139}, {238,0.03099010}, {239,0.03398020}, {240,0.03131683}, {241,0.03141584}, {242,0.03146535}, {243,0.03218812}, {244,0.03819802}, {245,0.03178218}, {246,0.03232673}, {247,0.03560396}, {248,0.03217822}, {249,0.04275248}, {250,0.03246535}, {251,0.03301980}, {252,0.03824752}, {253,0.03288119}, {254,0.03337624}, {255,0.03450495}, {256,0.03264356}, {257,0.04019802}, {258,0.03319802}, {259,0.03361386}, {260,0.03510891}, {261,0.03362376}, {262,0.04194059}, {263,0.03414851}, {264,0.03393069}, {265,0.03585149}, {266,0.03412871}, {267,0.04196040}, {268,0.03414851}, {269,0.03540594}, {270,0.03501980}, {271,0.03549505}, {272,0.04045545}, {273,0.03481188}, {274,0.04618812}, {275,0.03527723}, {276,0.03562376}, {277,0.03813861}, {278,0.03578218}, {279,0.04320792}, {280,0.03577228}, {281,0.04790099}, {282,0.03618812}, {283,0.03647525}, {284,0.03993069}, {285,0.03695050}, {286,0.04378218}, {287,0.03747525}, {288,0.04669307}, {289,0.03672277}, {290,0.03719802}, {291,0.03729703}, {292,0.03763366}, {293,0.04069307}, {294,0.03837624}, {295,0.04434653}, {296,0.03772277}, {297,0.04699010}, {298,0.03817822}, {299,0.04926733}, {300,0.03855446}, {301,0.03906931}, {302,0.04014851}, {303,0.03980198}, {304,0.04186139}, {305,0.03953465}, {306,0.04418812}, {307,0.04033663}, {308,0.04619802}, {309,0.03997030}, {310,0.04798020}, {311,0.04066337}, {312,0.04915842}, {313,0.04066337}, {314,0.05078218}, {315,0.04096040}, {316,0.05170297}, {317,0.04141584}, {318,0.05264356}, {319,0.04140594}, {320,0.05365347}, {321,0.04103960}, {322,0.04136634}, {323,0.04190099}, {324,0.04175248}, {325,0.04213861}, {326,0.04262376}, {327,0.04267327}, {328,0.04245545}, {329,0.04327723}, {330,0.04300990}, {331,0.04352475}, {332,0.04356436}, {333,0.04364356}, {334,0.04495050}, {335,0.04482178}, {336,0.05503960}, {337,0.04376238}, {338,0.05498020}, {339,0.04440594}, {340,0.05511881}, {341,0.04426733}, {342,0.05202970}, {343,0.04463366}, {344,0.05197030}, {345,0.04540594}, {346,0.05143564}, {347,0.04544554}, {348,0.05020792}, {349,0.04603960}, {350,0.04904950}, {351,0.04662376}, {352,0.04732673}, {353,0.04582178}, {354,0.04641584}, {355,0.05700990}, {356,0.04641584}, {357,0.05511881}, {358,0.04684158}, {359,0.05315842}, {360,0.04682178}, {361,0.05077228}, {362,0.04695050}, {363,0.04898020}, {364,0.06017822}, {365,0.04785149}, {366,0.05989109}, {367,0.04813861}, {368,0.05417822}, {369,0.04829703}, {370,0.05208911}, {371,0.04877228}, {372,0.04811881}, {373,0.06003960}, {374,0.04864356}, {375,0.05731683}, {376,0.04853465}, {377,0.05371287}, {378,0.04910891}, {379,0.04960396}, {380,0.06067327}, {381,0.04961386}, {382,0.05699010}, {383,0.04983168}, {384,0.05141584}, {385,0.06394059}, {386,0.04934653}, {387,0.05897030}, {388,0.05004950}, {389,0.05509901}, {390,0.06641584}, {391,0.05034653}, {392,0.06020792}, {393,0.05093069}, {394,0.05575248}, {395,0.06753465}, {396,0.05102970}, {397,0.06151485}, {398,0.05222772}, {399,0.05656436}, {400,0.06647525}, {401,0.05130693}, {402,0.06124752}, {403,0.05252475}, {404,0.05504950}, {405,0.06624752}, {406,0.05255446}, {407,0.05987129}, {408,0.05274257}, {409,0.05253465}, {410,0.06361386}, {411,0.05370297}, {412,0.05694059}, {413,0.06736634}, {414,0.05428713}, {415,0.06083168}, {416,0.07117822}, {417,0.05378218}, {418,0.06324752}, {419,0.05501980}, {420,0.05612871}, {421,0.06639604}, {422,0.05521782}, {423,0.05890099}, {424,0.06761386}, {425,0.05571287}, {426,0.06093069}, {427,0.06956436}, {428,0.05540594}, {429,0.06252475}, {430,0.07278218}, {431,0.05677228}, {432,0.06045545}, {433,0.07974257}, {434,0.05601980}, {435,0.06753465}, {436,0.08011881}, {437,0.05720792}, {438,0.06766337}, {439,0.08107921}, {440,0.05700990}, {441,0.06820792}, {442,0.07626733}, {443,0.05809901}, {444,0.06527723}, {445,0.07464356}, {446,0.05834653}, {447,0.06505941}, {448,0.07249505}, {449,0.05822772}, {450,0.06307921}, {451,0.07185149}, {452,0.05833663}, {453,0.06247525}, {454,0.07040594}, {455,0.05967327}, {456,0.06029703}, {457,0.06936634}, {458,0.07829703}, {459,0.06002970}, {460,0.06733663}, {461,0.07568317}, {462,0.06054455}, {463,0.06507921}, {464,0.07209901}, {465,0.06077228}, {466,0.06050495}, {467,0.06958416}, {468,0.07307921}, {469,0.06144554}, {470,0.06637624}, {471,0.07271287}, {472,0.06109901}, {473,0.06149505}, {474,0.06935644}, {475,0.07668317}, {476,0.06171287}, {477,0.06566337}, {478,0.07258416}, {479,0.08130693}, {480,0.06200990}, {481,0.06782178}, {482,0.07454455}, {483,0.06330693}, {484,0.06316832}, {485,0.06917822}, {486,0.07628713}, {487,0.06444554}, {488,0.06463366}, {489,0.07105941}, {490,0.07795050}, {491,0.06490099}, {492,0.06583168}, {493,0.07234653}, {494,0.07847525}, {495,0.06551485}, {496,0.06593069}, {497,0.07186139}, {498,0.07822772}, {499,0.06552475}, {500,0.06592079}, {505,0.07196040}, {510,0.07889109}, {515,0.08477228}, {520,0.06717822}, {525,0.07173267}, {530,0.07866337}, {535,0.08530693}, {540,0.08987129}, {545,0.07043564}, {550,0.07386139}, {555,0.07909901}, {560,0.08336634}, {565,0.08895050}, {570,0.09290099}, {575,0.09745545}, {580,0.07578218}, {585,0.07794059}, {590,0.08175248}, {595,0.08474257}, {600,0.08737624}, {605,0.09135644}, {610,0.09354455}, {615,0.09715842}, {620,0.09897030}, {625,0.10061386}, {630,0.10273267}, {635,0.10380198}, {640,0.10329703}, {645,0.10530693}, {650,1.09326733}, {655,0.11898020}, {660,0.11734653}, {665,0.11907921}, {670,0.11342574}, {675,0.11186139}, {680,0.11084158}, {685,0.11117822}, {690,0.11064356}, {695,0.11043564}, {700,0.10950495}, {705,0.10811881}, {710,0.10627723}, {715,0.10459406}, {720,0.10271287}, {725,0.10234653}, {730,0.10009901}, {735,0.12406931}, {740,0.12115842}, {745,0.11874257}, {750,0.11542574}, {755,0.11207921}, {760,0.10939604}, {765,0.10665347}, {770,0.12468317}, {775,0.12154455}, {780,0.11854455}, {785,0.11200000}, {790,0.11140594}, {795,0.13028713}, {800,0.11781188}, {805,0.11610891}, {810,0.11331683}, {815,0.11700990}, {820,0.14219802}, {825,0.13605941}, {830,0.12802970}, {835,0.11902970}, {840,0.13601980}, {845,0.13007921}, {850,0.12270297}, {855,0.14203960}, {860,0.13558416}, {865,0.12742574}, {870,0.14586139}, {875,0.13473267}, {880,0.12877228}, {885,0.14762376}, {890,0.13992079}, {895,0.13215842}, {900,0.14583168}, {905,0.13705941}, {910,0.12983168}, {915,0.14438614}, {920,0.13489109}, {925,0.14944554}, {930,0.14069307}, {935,0.13322772}, {940,0.14637624}, {945,0.13715842}, {950,0.15018812}, {955,0.14207921}, {960,0.15246535}, {965,0.14036634}, {970,0.15570297}, {975,0.14861386}, {980,0.17469307}, {985,0.15796040}, {990,0.17051485}, {995,0.15321782}, {1000,0.16537624}, {1010,0.15487129}, {1020,0.16773267}, {1030,0.15387129}, {1040,0.16220792}, {1050,0.15213861}, {1060,0.16252475}, {1070,0.17496040}, {1080,0.16012871}, {1090,0.16888119}, {1100,0.17769307}, {1110,0.16413861}, {1120,0.16948515}, {1130,0.18033663}, {1140,0.16594059}, {1150,0.17473267}, {1160,0.17925743}, {1170,0.18712871}, {1180,0.19371287}, {1190,0.18108911}, {1200,0.19365347}, {1210,0.20146535}, {1220,0.19983168}, {1230,0.20351485}, {1240,0.20746535}, {1250,0.21176238}, {1260,0.18592079}, {1270,0.19387129}, {1280,0.19205941}, {1290,0.19722772}, {1300,0.19921782}, {1310,0.20175248}, {1320,0.20101980}, {1330,0.20331683}, {1340,0.20431683}, {1350,0.20442574}, {1360,0.20340594}, {1370,0.20487129}, {1380,0.22600990}, {1390,0.22578218}, {1400,0.24475248}, {1410,0.23592079}, {1420,0.22448515}, {1430,0.22380198}, {1440,0.21893069}, {1450,0.24298020}, {1460,0.22856436}, {1470,0.23458416}, {1480,0.22731683}, {1490,0.24434653}, {1500,0.23905941}, {1510,0.23406931}, {1520,0.25055446}, {1530,0.24668317}, {1540,0.23673267}, {1550,0.25325743}, {1560,0.26746535}, {1570,0.25297030}, {1580,0.25893069}, {1590,0.25473267}, {1600,0.26905941}, {1610,0.25893069}, {1620,0.24926733}, {1630,0.26380198}, {1640,0.25043564}, {1650,0.26355446}, {1660,0.25543564}, {1670,0.26310891}, {1680,0.27773267}, {1690,0.26456436}, {1700,0.30071287}, {1710,0.27714851}, {1720,0.27775248}, {1730,0.29488119}, {1740,0.27288119}, {1750,0.28682178}, {1760,0.27374257}, {1770,0.27815842}, {1780,0.28522772}, {1790,0.29425743}, {1800,0.27652475}, {1810,0.28360396}, {1820,0.30310891}, {1830,0.32200000}, {1840,0.28763366}, {1850,0.29574257}, {1860,0.29652475}, {1870,0.29554455}, {1880,0.30806931}, {1890,0.31161386}, {1900,0.31416832}, {1910,0.29658416}, {1920,0.29483168}, {1930,0.29946535}, {1940,0.30154455}, {1950,0.32693069}, {1960,0.32020792}, {1970,0.31676238}, {1980,0.31885149}, {1990,0.31167327}, {2000,0.31556436}, {2050,0.31815842}, {2100,0.34573267}, {2150,0.34772277}, {2200,0.34760396}, {2250,0.36611881}, {2300,0.40104950}, {2350,0.39693069}, {2400,0.38658416}, {2450,0.39606931}, {2500,0.41147525}, {2550,0.42029703}, {2600,0.42419802}, {2650,0.43373267}, {2700,0.47148515}, {2750,0.45894059}, {2800,0.45753465}, {2850,0.47653465}, {2900,0.47117822}, {2950,0.48953465}, {3000,0.48804950}, {3050,0.52952475}, {3100,0.50767327}, {3150,0.51294059}, {3200,0.52173267}, {3250,0.52803960}, {3300,0.53098020}, {3350,0.53692079}, {3400,0.57603960}, {3450,0.59093069}, {3500,0.58477228}, {3550,0.57764356}, {3600,0.58780198}, {3650,0.59255446}, {3700,0.63382178}, {3750,0.62391089}, {3800,0.64411881}, {3850,0.62154455}, {3900,0.63431683}, {3950,0.67955446}, {4000,0.68597030}, {4050,0.67959406}, {4100,0.67047525}, {4150,0.67415842}, {4200,0.70095050}, {4250,0.72876238}, {4300,0.71998020}, {4350,0.72503960}, {4400,0.71984158}, {4450,0.73369307}, {4500,0.78753465}, {4550,0.76911881}, {4600,0.77606931}, {4650,0.77290099}, {4700,0.79902970}, {4750,0.80237624}, {4800,0.80995050}, {4850,0.80860396}, {4900,0.80154455}, {4950,0.85788119}, {5000,0.84885149}, {5050,0.84396040}, {5100,0.84953465}, {5150,0.88111881}, {5200,0.87517822}, {5250,0.86884158}, {5300,0.88134653}, {5350,0.89226733}, {5400,0.93328713}, {5450,0.91764356}, {5500,0.90885149}, {5550,0.93170297}, {5600,0.96914851}, {5650,0.95017822}, {5700,0.95674257}, {5750,0.99343564}, {5800,0.98484158}, {5850,0.98709901}, {5900,0.97898020}, {5950,1.02656436}, {6000,1.02917822}, {6050,1.0341714}, {6100,1.0663143}, {6150,1.0618000}, {6200,1.0606000}, {6250,1.1168000}, {6300,1.0838286}, {6350,1.0998857}, {6400,1.0569714}, {6450,1.1146286}, {6500,1.1254857}, {6550,1.1501714}, {6600,3.7889714}, {6650,1.1698000}, {6700,1.1559714}, {6750,1.1770286}, {6800,1.1768571}, {6850,1.1504571}, {6900,1.1459143}, {6950,1.2332286}, {7000,1.2102571}, {7050,1.2091714}, {7100,1.2404857}, {7150,1.2349714}, {7200,1.2059429}, {7250,1.2746571}, {7300,1.2555143}, {7350,1.2726571}, {7400,1.2822571}, {7450,1.2694857}, {7500,1.2850286}, {7550,1.3413714}, {7600,1.3262857}, {7650,1.3324286}, {7700,1.3281429}, {7750,1.3290286}, {7800,1.3259714}, {7850,1.3766286}, {7900,1.3863714}, {7950,1.3735143}, {8000,1.3815429}, {8050,1.3806286}, {8100,1.3903429}, {8150,1.4513429}, {8200,1.4195429}, {8250,1.4065143}, {8300,1.4395143}, {8350,1.4400000}, {8400,1.4363714}, {8450,1.4822571}, {8500,1.4870857}, {8550,1.4897714}, {8600,1.4876286}, {8650,1.4762000}, {8700,1.5384571}, {8750,1.5302286}, {8800,1.4846000}, {8850,1.5280571}, {8900,1.4989714}, {8950,1.5498286}, {9000,1.5645429}, {9050,1.5722000}, {9100,1.5811429}, {9150,1.5796571}, {9200,1.6059714}, {9250,1.5989714}, {9300,1.5917143}, {9350,1.6164286}, {9400,1.5998286}, {9450,1.6637143}, {9500,1.6509143}, {9550,1.6499143}, {9600,1.6621143}, {9650,1.6512857}, {9700,1.6838571}, {9750,1.6995143}, {9800,1.6731143}, {9850,1.7181714}, {9900,1.7028571}, {9950,1.7727429}, {10000,1.7382571}, {10100,1.7572286}, {10200,1.7560286}, {10300,1.7842571}, {10400,1.7854857}, {10500,1.7964571}, {10600,1.8390286}, {10700,1.8507143}, {10800,1.8804857}, {10900,1.8875143}, {11000,1.9279714}, {11100,1.9204286}, {11200,1.9536286}, {11300,1.9569143}, {11400,1.9704571}, {11500,1.9787143}, {11600,2.0211714}, {11700,2.0618857}, {11800,2.0302857}, {11900,2.0596571}, {12000,2.1018857}, {12100,2.0816000}, {12200,2.1131714}, {12300,2.0944857}, {12400,2.1756000}, {12500,2.1584571}, {12600,2.2116857}, {12700,2.2176000}, {12800,2.1961143}, {12900,2.2295143}, {13000,2.2384571}, {13100,2.3095143}, {13200,2.2892286}, {13300,2.3304571}, {13400,2.3535429}, {13500,2.3798857}, {13600,2.3299714}, {13700,2.3558857}, {13800,2.4505714}, {13900,2.4041714}, {14000,2.4216571}, {14100,2.4953429}, {14200,2.4904286}, {14300,2.5188000}, {14400,2.4964000}, {14500,2.4994286}, {14600,2.5184571}, {14700,2.5754571}, {14800,2.6232000}, {14900,2.5836286}, {15000,2.5698000}, {15100,2.7035143}, {15200,2.6461714}, {15300,2.6952000}, {15400,2.6853143}, {15500,2.6981143}, {15600,2.7448571}, {15700,2.7738571}, {15800,2.7846286}, {15900,2.7495429}, {16000,2.8198571}, {16100,2.8000571}, {16200,2.8136000}, {16300,2.8858000}, {16400,2.7964857}, {16500,2.8660286}, {16600,2.9077143}, {16700,2.9192857}, {16800,2.9511429}, {16900,2.9142857}, {17000,2.9252571}, {17100,3.0038857}, {17200,2.9906857}, {17300,2.9905429}, {17400,3.1203429}, {17500,3.0854857}, {17600,3.0419714}, {17700,3.0912000}, {17800,3.0768571}, {17900,3.2362286}, {18000,3.1172857}, {18100,3.1796857}, {18200,3.1719429}, {18300,3.2038857}, {18400,3.2571714}, {18500,3.1943429}, {18600,3.2936000}, {18700,3.2434286}, {18800,3.2246571}, {18900,3.3384286}, {19000,3.2616000}, {19100,3.3798286}, {19200,3.2854571}, {19300,6.7878000}, {19400,3.4222857}, {19500,3.3737714}, {19600,3.3904000}, {19700,3.4661714}, {19800,3.4513429}, {19900,3.5728571}, {20000,3.4542857}};
data["big_flat"]["LtacPrimUncurry"]["norm reif"]["system"] = {{1,0.00015842}, {2,0.00009901}, {3,0.00003960}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00002970}, {14,0.00000000}, {15,0.00000000}, {16,0.00003960}, {17,0.00002970}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00002970}, {23,0.00000000}, {24,0.00000000}, {25,0.00003960}, {26,0.00007921}, {27,0.00000000}, {28,0.00003960}, {29,0.00003960}, {30,0.00000000}, {31,0.00002970}, {32,0.00003960}, {33,0.00002970}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00002970}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003960}, {42,0.00003960}, {43,0.00000000}, {44,0.00003960}, {45,0.00009901}, {46,0.00003960}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00000000}, {51,0.00003960}, {52,0.00003960}, {53,0.00000000}, {54,0.00000000}, {55,0.00003960}, {56,0.00003960}, {57,0.00006931}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00005941}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00003960}, {67,0.00010891}, {68,0.00000000}, {69,0.00000000}, {70,0.00003960}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00003960}, {76,0.00003960}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00006931}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00003960}, {87,0.00006931}, {88,0.00003960}, {89,0.00000000}, {90,0.00011881}, {91,0.00003960}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00002970}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00003960}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003960}, {105,0.00003960}, {106,0.00013861}, {107,0.00003960}, {108,0.00000000}, {109,0.00003960}, {110,0.00003960}, {111,0.00003960}, {112,0.00002970}, {113,0.00000000}, {114,0.00003960}, {115,0.00007921}, {116,0.00003960}, {117,0.00000000}, {118,0.00006931}, {119,0.00003960}, {120,0.00006931}, {121,0.00003960}, {122,0.00000000}, {123,0.00000000}, {124,0.00003960}, {125,0.00006931}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00002970}, {133,0.00000000}, {134,0.00003960}, {135,0.00011881}, {136,0.00000000}, {137,0.00003960}, {138,0.00007921}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00017822}, {145,0.00002970}, {146,0.00000000}, {147,0.00007921}, {148,0.00003960}, {149,0.00007921}, {150,0.00000000}, {151,0.00003960}, {152,0.00003960}, {153,0.00011881}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00007921}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00003960}, {162,0.00015842}, {163,0.00003960}, {164,0.00003960}, {165,0.00010891}, {166,0.00000000}, {167,0.00003960}, {168,0.00003960}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00003960}, {174,0.00000000}, {175,0.00000000}, {176,0.00005941}, {177,0.00000000}, {178,0.00003960}, {179,0.00000000}, {180,0.00008911}, {181,0.00000000}, {182,0.00000000}, {183,0.00006931}, {184,0.00000000}, {185,0.00003960}, {186,0.00000000}, {187,0.00002970}, {188,0.00000000}, {189,0.00000000}, {190,0.00002970}, {191,0.00000000}, {192,0.00003960}, {193,0.00002970}, {194,0.00002970}, {195,0.00000000}, {196,0.00000000}, {197,0.00014851}, {198,0.00000000}, {199,0.00003960}, {200,0.00011881}, {201,0.00002970}, {202,0.00000000}, {203,0.00003960}, {204,0.00003960}, {205,0.00003960}, {206,0.00000000}, {207,0.00003960}, {208,0.00000000}, {209,0.00000000}, {210,0.00006931}, {211,0.00000000}, {212,0.00000000}, {213,0.00003960}, {214,0.00000000}, {215,0.00000000}, {216,0.00011881}, {217,0.00000000}, {218,0.00003960}, {219,0.00017822}, {220,0.00002970}, {221,0.00000000}, {222,0.00007921}, {223,0.00002970}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00003960}, {228,0.00003960}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00003960}, {233,0.00011881}, {234,0.00011881}, {235,0.00002970}, {236,0.00009901}, {237,0.00000000}, {238,0.00003960}, {239,0.00007921}, {240,0.00000000}, {241,0.00003960}, {242,0.00000000}, {243,0.00003960}, {244,0.00011881}, {245,0.00000000}, {246,0.00003960}, {247,0.00015842}, {248,0.00003960}, {249,0.00027723}, {250,0.00002970}, {251,0.00000000}, {252,0.00029703}, {253,0.00003960}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00018812}, {258,0.00000000}, {259,0.00000000}, {260,0.00003960}, {261,0.00000000}, {262,0.00019802}, {263,0.00010891}, {264,0.00000000}, {265,0.00002970}, {266,0.00000000}, {267,0.00017822}, {268,0.00000000}, {269,0.00000000}, {270,0.00002970}, {271,0.00000000}, {272,0.00010891}, {273,0.00003960}, {274,0.00030693}, {275,0.00003960}, {276,0.00002970}, {277,0.00007921}, {278,0.00000000}, {279,0.00014851}, {280,0.00000000}, {281,0.00018812}, {282,0.00000000}, {283,0.00003960}, {284,0.00010891}, {285,0.00003960}, {286,0.00013861}, {287,0.00000000}, {288,0.00018812}, {289,0.00000000}, {290,0.00000000}, {291,0.00007921}, {292,0.00002970}, {293,0.00003960}, {294,0.00000000}, {295,0.00014851}, {296,0.00002970}, {297,0.00015842}, {298,0.00000000}, {299,0.00009901}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00003960}, {305,0.00003960}, {306,0.00011881}, {307,0.00000000}, {308,0.00019802}, {309,0.00003960}, {310,0.00023762}, {311,0.00002970}, {312,0.00011881}, {313,0.00000000}, {314,0.00018812}, {315,0.00003960}, {316,0.00007921}, {317,0.00003960}, {318,0.00029703}, {319,0.00003960}, {320,0.00013861}, {321,0.00000000}, {322,0.00002970}, {323,0.00003960}, {324,0.00007921}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00002970}, {329,0.00003960}, {330,0.00003960}, {331,0.00003960}, {332,0.00011881}, {333,0.00007921}, {334,0.00000000}, {335,0.00002970}, {336,0.00027723}, {337,0.00000000}, {338,0.00012871}, {339,0.00002970}, {340,0.00015842}, {341,0.00002970}, {342,0.00026733}, {343,0.00000000}, {344,0.00015842}, {345,0.00006931}, {346,0.00007921}, {347,0.00002970}, {348,0.00002970}, {349,0.00000000}, {350,0.00002970}, {351,0.00003960}, {352,0.00006931}, {353,0.00003960}, {354,0.00000000}, {355,0.00013861}, {356,0.00002970}, {357,0.00014851}, {358,0.00003960}, {359,0.00003960}, {360,0.00000000}, {361,0.00010891}, {362,0.00003960}, {363,0.00023762}, {364,0.00038614}, {365,0.00003960}, {366,0.00128713}, {367,0.00007921}, {368,0.00011881}, {369,0.00000000}, {370,0.00011881}, {371,0.00003960}, {372,0.00000000}, {373,0.00042574}, {374,0.00002970}, {375,0.00007921}, {376,0.00000000}, {377,0.00002970}, {378,0.00000000}, {379,0.00000000}, {380,0.00033663}, {381,0.00006931}, {382,0.00019802}, {383,0.00003960}, {384,0.00007921}, {385,0.00021782}, {386,0.00003960}, {387,0.00009901}, {388,0.00002970}, {389,0.00010891}, {390,0.00022772}, {391,0.00000000}, {392,0.00018812}, {393,0.00000000}, {394,0.00007921}, {395,0.00030693}, {396,0.00003960}, {397,0.00030693}, {398,0.00000000}, {399,0.00003960}, {400,0.00019802}, {401,0.00000000}, {402,0.00015842}, {403,0.00003960}, {404,0.00015842}, {405,0.00006931}, {406,0.00010891}, {407,0.00026733}, {408,0.00000000}, {409,0.00000000}, {410,0.00007921}, {411,0.00000000}, {412,0.00018812}, {413,0.00035644}, {414,0.00000000}, {415,0.00003960}, {416,0.00040594}, {417,0.00000000}, {418,0.00015842}, {419,0.00000000}, {420,0.00002970}, {421,0.00022772}, {422,0.00000000}, {423,0.00003960}, {424,0.00034653}, {425,0.00003960}, {426,0.00013861}, {427,0.00000000}, {428,0.00003960}, {429,0.00000000}, {430,0.00020792}, {431,0.00007921}, {432,0.00011881}, {433,0.00026733}, {434,0.00003960}, {435,0.00010891}, {436,0.00023762}, {437,0.00003960}, {438,0.00016832}, {439,0.00023762}, {440,0.00003960}, {441,0.00014851}, {442,0.00021782}, {443,0.00000000}, {444,0.00007921}, {445,0.00035644}, {446,0.00000000}, {447,0.00015842}, {448,0.00022772}, {449,0.00003960}, {450,0.00007921}, {451,0.00030693}, {452,0.00003960}, {453,0.00007921}, {454,0.00028713}, {455,0.00000000}, {456,0.00003960}, {457,0.00011881}, {458,0.00046535}, {459,0.00000000}, {460,0.00007921}, {461,0.00031683}, {462,0.00003960}, {463,0.00011881}, {464,0.00031683}, {465,0.00000000}, {466,0.00000000}, {467,0.00019802}, {468,0.00028713}, {469,0.00000000}, {470,0.00011881}, {471,0.00022772}, {472,0.00003960}, {473,0.00000000}, {474,0.00022772}, {475,0.00014851}, {476,0.00003960}, {477,0.00018812}, {478,0.00003960}, {479,0.00029703}, {480,0.00000000}, {481,0.00019802}, {482,0.00014851}, {483,0.00000000}, {484,0.00000000}, {485,0.00010891}, {486,0.00035644}, {487,0.00003960}, {488,0.00000000}, {489,0.00013861}, {490,0.00026733}, {491,0.00000000}, {492,0.00003960}, {493,0.00015842}, {494,0.00023762}, {495,0.00014851}, {496,0.00007921}, {497,0.00007921}, {498,0.00023762}, {499,0.00000000}, {500,0.00000000}, {505,0.00024752}, {510,0.00034653}, {515,0.00030693}, {520,0.00003960}, {525,0.00007921}, {530,0.00000000}, {535,0.00033663}, {540,0.00042574}, {545,0.00000000}, {550,0.00000000}, {555,0.00022772}, {560,0.00033663}, {565,0.00028713}, {570,0.00039604}, {575,0.00044554}, {580,0.00007921}, {585,0.00007921}, {590,0.00019802}, {595,0.00019802}, {600,0.00030693}, {605,0.00038614}, {610,0.00022772}, {615,0.00030693}, {620,0.00032673}, {625,0.00030693}, {630,0.00023762}, {635,0.00003960}, {640,0.00000000}, {645,0.00002970}, {650,0.00273267}, {655,0.00003960}, {660,0.00007921}, {665,0.00006931}, {670,0.00019802}, {675,0.00000000}, {680,0.00007921}, {685,0.00000000}, {690,0.00006931}, {695,0.00000000}, {700,0.00003960}, {705,0.00000000}, {710,0.00003960}, {715,0.00007921}, {720,0.00000000}, {725,0.00000000}, {730,0.00003960}, {735,0.00006931}, {740,0.00000000}, {745,0.00003960}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00007921}, {770,0.00003960}, {775,0.00003960}, {780,0.00003960}, {785,0.00007921}, {790,0.00000000}, {795,0.00000000}, {800,0.00003960}, {805,0.00006931}, {810,0.00002970}, {815,0.00003960}, {820,0.00000000}, {825,0.00003960}, {830,0.00003960}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00003960}, {870,0.00003960}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00003960}, {900,0.00000000}, {905,0.00000000}, {910,0.00003960}, {915,0.00022772}, {920,0.00044554}, {925,0.00067327}, {930,0.00051485}, {935,0.00023762}, {940,0.00029703}, {945,0.00026733}, {950,0.00045545}, {955,0.00042574}, {960,0.00035644}, {965,0.00015842}, {970,0.00030693}, {975,0.00021782}, {980,0.00006931}, {985,0.00014851}, {990,0.00018812}, {995,0.00015842}, {1000,0.00029703}, {1010,0.00009901}, {1020,0.00010891}, {1030,0.00007921}, {1040,0.00027723}, {1050,0.00003960}, {1060,0.00007921}, {1070,0.00003960}, {1080,0.00007921}, {1090,0.00003960}, {1100,0.00015842}, {1110,0.00003960}, {1120,0.00018812}, {1130,0.00003960}, {1140,0.00011881}, {1150,0.00015842}, {1160,0.00007921}, {1170,0.00000000}, {1180,0.00003960}, {1190,0.00000000}, {1200,0.00003960}, {1210,0.00000000}, {1220,0.00003960}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00003960}, {1260,0.00007921}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00003960}, {1330,0.00003960}, {1340,0.00007921}, {1350,0.00000000}, {1360,0.00007921}, {1370,0.00003960}, {1380,0.00011881}, {1390,0.00003960}, {1400,0.00000000}, {1410,0.00003960}, {1420,0.00002970}, {1430,0.00003960}, {1440,0.00000000}, {1450,0.00003960}, {1460,0.00003960}, {1470,0.00007921}, {1480,0.00003960}, {1490,0.00003960}, {1500,0.00000000}, {1510,0.00007921}, {1520,0.00007921}, {1530,0.00003960}, {1540,0.00003960}, {1550,0.00005941}, {1560,0.00007921}, {1570,0.00003960}, {1580,0.00007921}, {1590,0.00010891}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00002970}, {1630,0.00003960}, {1640,0.00000000}, {1650,0.00003960}, {1660,0.00003960}, {1670,0.00003960}, {1680,0.00007921}, {1690,0.00003960}, {1700,0.00000000}, {1710,0.00003960}, {1720,0.00003960}, {1730,0.00007921}, {1740,0.00000000}, {1750,0.00003960}, {1760,0.00011881}, {1770,0.00011881}, {1780,0.00000000}, {1790,0.00011881}, {1800,0.00003960}, {1810,0.00007921}, {1820,0.00002970}, {1830,0.00006931}, {1840,0.00003960}, {1850,0.00000000}, {1860,0.00007921}, {1870,0.00003960}, {1880,0.00003960}, {1890,0.00003960}, {1900,0.00000000}, {1910,0.00005941}, {1920,0.00003960}, {1930,0.00002970}, {1940,0.00000000}, {1950,0.00010891}, {1960,0.00000000}, {1970,0.00007921}, {1980,0.00007921}, {1990,0.00010891}, {2000,0.00003960}, {2050,0.00007921}, {2100,0.00000000}, {2150,0.00007921}, {2200,0.00007921}, {2250,0.00000000}, {2300,0.00015842}, {2350,0.00003960}, {2400,0.00011881}, {2450,0.00007921}, {2500,0.00006931}, {2550,0.00015842}, {2600,0.00003960}, {2650,0.00018812}, {2700,0.00011881}, {2750,0.00003960}, {2800,0.00003960}, {2850,0.00006931}, {2900,0.00011881}, {2950,0.00018812}, {3000,0.00000000}, {3050,0.00007921}, {3100,0.00007921}, {3150,0.00000000}, {3200,0.00011881}, {3250,0.00011881}, {3300,0.00003960}, {3350,0.00007921}, {3400,0.00006931}, {3450,0.00003960}, {3500,0.00000000}, {3550,0.00011881}, {3600,0.00003960}, {3650,0.00000000}, {3700,0.00015842}, {3750,0.00018812}, {3800,0.00007921}, {3850,0.00007921}, {3900,0.00015842}, {3950,0.00010891}, {4000,0.00015842}, {4050,0.00003960}, {4100,0.00236634}, {4150,0.00260396}, {4200,0.00100990}, {4250,0.00007921}, {4300,0.00007921}, {4350,0.00016832}, {4400,0.00015842}, {4450,0.00011881}, {4500,0.00022772}, {4550,0.00047525}, {4600,0.00048515}, {4650,0.00000000}, {4700,0.00007921}, {4750,0.00015842}, {4800,0.00005941}, {4850,0.00003960}, {4900,0.00006931}, {4950,0.00009901}, {5000,0.00007921}, {5050,0.00003960}, {5100,0.00023762}, {5150,0.00011881}, {5200,0.00015842}, {5250,0.00030693}, {5300,0.00000000}, {5350,0.00007921}, {5400,0.00014851}, {5450,0.00007921}, {5500,0.00003960}, {5550,0.00011881}, {5600,0.00014851}, {5650,0.00003960}, {5700,0.00006931}, {5750,0.00000000}, {5800,0.00007921}, {5850,0.00002970}, {5900,0.00002970}, {5950,0.00011881}, {6000,0.00010891}, {6050,0.0043429}, {6100,0.0045714}, {6150,0.0061714}, {6200,0.0025714}, {6250,0.0002286}, {6300,0.0042000}, {6350,0.0039429}, {6400,0.0050286}, {6450,0.0001143}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0022571}, {6650,0.0004571}, {6700,0.0000000}, {6750,0.0002286}, {6800,0.0002286}, {6850,0.0001143}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000857}, {7050,0.0002286}, {7100,0.0003429}, {7150,0.0066571}, {7200,0.0060571}, {7250,0.0038857}, {7300,0.0003429}, {7350,0.0000000}, {7400,0.0001143}, {7450,0.0000000}, {7500,0.0002286}, {7550,0.0002286}, {7600,0.0000857}, {7650,0.0002286}, {7700,0.0000000}, {7750,0.0004286}, {7800,0.0003143}, {7850,0.0002000}, {7900,0.0001143}, {7950,0.0003429}, {8000,0.0000000}, {8050,0.0001143}, {8100,0.0001143}, {8150,0.0002286}, {8200,0.0001143}, {8250,0.0001143}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0001714}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0002286}, {8600,0.0003429}, {8650,0.0001143}, {8700,0.0001143}, {8750,0.0003429}, {8800,0.0003429}, {8850,0.0000000}, {8900,0.0003429}, {8950,0.0000000}, {9000,0.0003429}, {9050,0.0002286}, {9100,0.0004571}, {9150,0.0000000}, {9200,0.0004571}, {9250,0.0003429}, {9300,0.0002286}, {9350,0.0000000}, {9400,0.0001143}, {9450,0.0002286}, {9500,0.0000000}, {9550,0.0001143}, {9600,0.0002286}, {9650,0.0002000}, {9700,0.0001143}, {9750,0.0003429}, {9800,0.0000857}, {9850,0.0000000}, {9900,0.0004571}, {9950,0.0003429}, {10000,0.0001143}, {10100,0.0002000}, {10200,0.0002000}, {10300,0.0001143}, {10400,0.0004571}, {10500,0.0004571}, {10600,0.0002286}, {10700,0.0001143}, {10800,0.0001143}, {10900,0.0001143}, {11000,0.0003429}, {11100,0.0002286}, {11200,0.0002286}, {11300,0.0002286}, {11400,0.0003429}, {11500,0.0002286}, {11600,0.0001143}, {11700,0.0001143}, {11800,0.0001143}, {11900,0.0001143}, {12000,0.0002286}, {12100,0.0004286}, {12200,0.0003143}, {12300,0.0000000}, {12400,0.0005429}, {12500,0.0003429}, {12600,0.0004571}, {12700,0.0003429}, {12800,0.0003429}, {12900,0.0002286}, {13000,0.0002286}, {13100,0.0002286}, {13200,0.0002000}, {13300,0.0002286}, {13400,0.0003143}, {13500,0.0001143}, {13600,0.0002286}, {13700,0.0000000}, {13800,0.0005714}, {13900,0.0001143}, {14000,0.0001143}, {14100,0.0004286}, {14200,0.0005714}, {14300,0.0000000}, {14400,0.0004571}, {14500,0.0001143}, {14600,0.0000000}, {14700,0.0009143}, {14800,0.0004571}, {14900,0.0000000}, {15000,0.0004571}, {15100,0.0006857}, {15200,0.0006571}, {15300,0.0003429}, {15400,0.0002286}, {15500,0.0002286}, {15600,0.0003143}, {15700,0.0006571}, {15800,0.0003143}, {15900,0.0003143}, {16000,0.0003429}, {16100,0.0001143}, {16200,0.0004571}, {16300,0.0001143}, {16400,0.0002286}, {16500,0.0008857}, {16600,0.0001143}, {16700,0.0001143}, {16800,0.0003429}, {16900,0.0002286}, {17000,0.0005714}, {17100,0.0004571}, {17200,0.0003429}, {17300,0.0000000}, {17400,0.0002286}, {17500,0.0003429}, {17600,0.0003429}, {17700,0.0002286}, {17800,0.0006857}, {17900,0.0003429}, {18000,0.0000000}, {18100,0.0001143}, {18200,0.0005714}, {18300,0.0002286}, {18400,0.0000000}, {18500,0.0003143}, {18600,0.0003429}, {18700,0.0002286}, {18800,0.0034000}, {18900,0.0002286}, {19000,0.0001143}, {19100,0.0001143}, {19200,0.0085143}, {19300,0.0091429}, {19400,0.0001714}, {19500,0.0001143}, {19600,0.0000857}, {19700,0.0002286}, {19800,0.0001143}, {19900,0.0003429}, {20000,0.0003429}};
data["big_flat"]["LtacPrimUncurry"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacPrimUncurry"]["post"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00002970}, {4,0.00002970}, {5,0.00000000}, {6,0.00003960}, {7,0.00002970}, {8,0.00003960}, {9,0.00006931}, {10,0.00003960}, {11,0.00000000}, {12,0.00002970}, {13,0.00002970}, {14,0.00002970}, {15,0.00000000}, {16,0.00000000}, {17,0.00003960}, {18,0.00003960}, {19,0.00000000}, {20,0.00006931}, {21,0.00002970}, {22,0.00003960}, {23,0.00000000}, {24,0.00002970}, {25,0.00002970}, {26,0.00010891}, {27,0.00006931}, {28,0.00006931}, {29,0.00002970}, {30,0.00002970}, {31,0.00000000}, {32,0.00006931}, {33,0.00000000}, {34,0.00002970}, {35,0.00011881}, {36,0.00000000}, {37,0.00002970}, {38,0.00000000}, {39,0.00000000}, {40,0.00008911}, {41,0.00012871}, {42,0.00000000}, {43,0.00003960}, {44,0.00003960}, {45,0.00003960}, {46,0.00000000}, {47,0.00002970}, {48,0.00002970}, {49,0.00000000}, {50,0.00000000}, {51,0.00006931}, {52,0.00000000}, {53,0.00000000}, {54,0.00007921}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00002970}, {62,0.00002970}, {63,0.00000000}, {64,0.00005941}, {65,0.00000000}, {66,0.00002970}, {67,0.00002970}, {68,0.00000000}, {69,0.00010891}, {70,0.00000000}, {71,0.00003960}, {72,0.00006931}, {73,0.00000000}, {74,0.00005941}, {75,0.00003960}, {76,0.00006931}, {77,0.00000000}, {78,0.00000000}, {79,0.00003960}, {80,0.00007921}, {81,0.00000000}, {82,0.00002970}, {83,0.00003960}, {84,0.00002970}, {85,0.00005941}, {86,0.00006931}, {87,0.00000000}, {88,0.00003960}, {89,0.00006931}, {90,0.00000000}, {91,0.00000000}, {92,0.00002970}, {93,0.00000000}, {94,0.00000000}, {95,0.00003960}, {96,0.00000000}, {97,0.00007921}, {98,0.00003960}, {99,0.00006931}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00006931}, {104,0.00006931}, {105,0.00007921}, {106,0.00002970}, {107,0.00003960}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00007921}, {117,0.00003960}, {118,0.00000000}, {119,0.00006931}, {120,0.00000000}, {121,0.00002970}, {122,0.00003960}, {123,0.00010891}, {124,0.00002970}, {125,0.00003960}, {126,0.00000000}, {127,0.00003960}, {128,0.00000000}, {129,0.00002970}, {130,0.00000000}, {131,0.00003960}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00005941}, {137,0.00000000}, {138,0.00003960}, {139,0.00003960}, {140,0.00003960}, {141,0.00000000}, {142,0.00000000}, {143,0.00003960}, {144,0.00000000}, {145,0.00003960}, {146,0.00007921}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00009901}, {153,0.00005941}, {154,0.00000000}, {155,0.00002970}, {156,0.00000000}, {157,0.00000000}, {158,0.00003960}, {159,0.00000000}, {160,0.00008911}, {161,0.00005941}, {162,0.00002970}, {163,0.00000000}, {164,0.00000000}, {165,0.00010891}, {166,0.00003960}, {167,0.00000000}, {168,0.00002970}, {169,0.00000000}, {170,0.00002970}, {171,0.00010891}, {172,0.00000000}, {173,0.00000000}, {174,0.00003960}, {175,0.00005941}, {176,0.00000000}, {177,0.00000000}, {178,0.00005941}, {179,0.00002970}, {180,0.00000000}, {181,0.00009901}, {182,0.00006931}, {183,0.00005941}, {184,0.00006931}, {185,0.00003960}, {186,0.00005941}, {187,0.00002970}, {188,0.00003960}, {189,0.00002970}, {190,0.00009901}, {191,0.00000000}, {192,0.00002970}, {193,0.00009901}, {194,0.00000000}, {195,0.00000000}, {196,0.00002970}, {197,0.00003960}, {198,0.00002970}, {199,0.00002970}, {200,0.00002970}, {201,0.00002970}, {202,0.00002970}, {203,0.00002970}, {204,0.00000000}, {205,0.00005941}, {206,0.00000000}, {207,0.00002970}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00006931}, {215,0.00000000}, {216,0.00002970}, {217,0.00005941}, {218,0.00002970}, {219,0.00002970}, {220,0.00002970}, {221,0.00002970}, {222,0.00003960}, {223,0.00005941}, {224,0.00002970}, {225,0.00006931}, {226,0.00005941}, {227,0.00002970}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00005941}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00005941}, {236,0.00000000}, {237,0.00002970}, {238,0.00005941}, {239,0.00003960}, {240,0.00002970}, {241,0.00005941}, {242,0.00000000}, {243,0.00000000}, {244,0.00005941}, {245,0.00002970}, {246,0.00003960}, {247,0.00000000}, {248,0.00000000}, {249,0.00002970}, {250,0.00000000}, {251,0.00010891}, {252,0.00006931}, {253,0.00002970}, {254,0.00000000}, {255,0.00003960}, {256,0.00007921}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00010891}, {261,0.00005941}, {262,0.00000000}, {263,0.00009901}, {264,0.00002970}, {265,0.00006931}, {266,0.00003960}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00002970}, {271,0.00005941}, {272,0.00000000}, {273,0.00002970}, {274,0.00000000}, {275,0.00002970}, {276,0.00000000}, {277,0.00002970}, {278,0.00005941}, {279,0.00006931}, {280,0.00005941}, {281,0.00000000}, {282,0.00002970}, {283,0.00003960}, {284,0.00000000}, {285,0.00002970}, {286,0.00000000}, {287,0.00000000}, {288,0.00002970}, {289,0.00000000}, {290,0.00005941}, {291,0.00000000}, {292,0.00006931}, {293,0.00005941}, {294,0.00006931}, {295,0.00005941}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00005941}, {300,0.00000000}, {301,0.00003960}, {302,0.00002970}, {303,0.00002970}, {304,0.00002970}, {305,0.00000000}, {306,0.00002970}, {307,0.00000000}, {308,0.00000000}, {309,0.00006931}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00007921}, {316,0.00005941}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00002970}, {322,0.00000000}, {323,0.00002970}, {324,0.00002970}, {325,0.00006931}, {326,0.00002970}, {327,0.00002970}, {328,0.00003960}, {329,0.00000000}, {330,0.00008911}, {331,0.00000000}, {332,0.00002970}, {333,0.00005941}, {334,0.00000000}, {335,0.00003960}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00006931}, {340,0.00000000}, {341,0.00000000}, {342,0.00006931}, {343,0.00002970}, {344,0.00003960}, {345,0.00000000}, {346,0.00000000}, {347,0.00002970}, {348,0.00002970}, {349,0.00006931}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00005941}, {354,0.00005941}, {355,0.00000000}, {356,0.00002970}, {357,0.00000000}, {358,0.00002970}, {359,0.00006931}, {360,0.00000000}, {361,0.00007921}, {362,0.00006931}, {363,0.00002970}, {364,0.00000000}, {365,0.00003960}, {366,0.00000000}, {367,0.00003960}, {368,0.00003960}, {369,0.00003960}, {370,0.00000000}, {371,0.00003960}, {372,0.00007921}, {373,0.00000000}, {374,0.00009901}, {375,0.00012871}, {376,0.00010891}, {377,0.00002970}, {378,0.00003960}, {379,0.00003960}, {380,0.00000000}, {381,0.00002970}, {382,0.00002970}, {383,0.00011881}, {384,0.00007921}, {385,0.00003960}, {386,0.00003960}, {387,0.00002970}, {388,0.00003960}, {389,0.00000000}, {390,0.00000000}, {391,0.00003960}, {392,0.00002970}, {393,0.00002970}, {394,0.00000000}, {395,0.00006931}, {396,0.00003960}, {397,0.00003960}, {398,0.00002970}, {399,0.00006931}, {400,0.00003960}, {401,0.00002970}, {402,0.00000000}, {403,0.00000000}, {404,0.00003960}, {405,0.00000000}, {406,0.00003960}, {407,0.00000000}, {408,0.00006931}, {409,0.00000000}, {410,0.00003960}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00006931}, {420,0.00007921}, {421,0.00000000}, {422,0.00003960}, {423,0.00002970}, {424,0.00003960}, {425,0.00000000}, {426,0.00000000}, {427,0.00003960}, {428,0.00003960}, {429,0.00003960}, {430,0.00002970}, {431,0.00000000}, {432,0.00003960}, {433,0.00005941}, {434,0.00000000}, {435,0.00000000}, {436,0.00003960}, {437,0.00003960}, {438,0.00010891}, {439,0.00000000}, {440,0.00003960}, {441,0.00000000}, {442,0.00003960}, {443,0.00000000}, {444,0.00003960}, {445,0.00003960}, {446,0.00000000}, {447,0.00003960}, {448,0.00000000}, {449,0.00007921}, {450,0.00002970}, {451,0.00000000}, {452,0.00003960}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00002970}, {461,0.00003960}, {462,0.00003960}, {463,0.00000000}, {464,0.00002970}, {465,0.00000000}, {466,0.00003960}, {467,0.00003960}, {468,0.00005941}, {469,0.00003960}, {470,0.00000000}, {471,0.00000000}, {472,0.00005941}, {473,0.00003960}, {474,0.00000000}, {475,0.00003960}, {476,0.00007921}, {477,0.00003960}, {478,0.00003960}, {479,0.00010891}, {480,0.00003960}, {481,0.00000000}, {482,0.00006931}, {483,0.00003960}, {484,0.00007921}, {485,0.00010891}, {486,0.00007921}, {487,0.00003960}, {488,0.00000000}, {489,0.00000000}, {490,0.00006931}, {491,0.00002970}, {492,0.00000000}, {493,0.00000000}, {494,0.00003960}, {495,0.00006931}, {496,0.00000000}, {497,0.00003960}, {498,0.00006931}, {499,0.00003960}, {500,0.00000000}, {505,0.00007921}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00003960}, {530,0.00003960}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00002970}, {565,0.00000000}, {570,0.00003960}, {575,0.00003960}, {580,0.00007921}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00006931}, {615,0.00000000}, {620,0.00007921}, {625,0.00000000}, {630,0.00003960}, {635,0.00002970}, {640,0.00002970}, {645,0.00002970}, {650,0.00000000}, {655,0.00002970}, {660,0.00006931}, {665,0.00000000}, {670,0.00000000}, {675,0.00003960}, {680,0.00000000}, {685,0.00002970}, {690,0.00000000}, {695,0.00003960}, {700,0.00003960}, {705,0.00000000}, {710,0.00002970}, {715,0.00000000}, {720,0.00006931}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00006931}, {750,0.00002970}, {755,0.00003960}, {760,0.00003960}, {765,0.00002970}, {770,0.00002970}, {775,0.00005941}, {780,0.00002970}, {785,0.00003960}, {790,0.00002970}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00003960}, {815,0.00011881}, {820,0.00003960}, {825,0.00000000}, {830,0.00000000}, {835,0.00002970}, {840,0.00000000}, {845,0.00002970}, {850,0.00003960}, {855,0.00002970}, {860,0.00002970}, {865,0.00000000}, {870,0.00002970}, {875,0.00002970}, {880,0.00003960}, {885,0.00002970}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00006931}, {920,0.00000000}, {925,0.00012871}, {930,0.00000000}, {935,0.00007921}, {940,0.00005941}, {945,0.00000000}, {950,0.00007921}, {955,0.00000000}, {960,0.00002970}, {965,0.00010891}, {970,0.00000000}, {975,0.00002970}, {980,0.00002970}, {985,0.00003960}, {990,0.00005941}, {995,0.00000000}, {1000,0.00009901}, {1010,0.00002970}, {1020,0.00006931}, {1030,0.00003960}, {1040,0.00000000}, {1050,0.00002970}, {1060,0.00000000}, {1070,0.00003960}, {1080,0.00000000}, {1090,0.00002970}, {1100,0.00002970}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00005941}, {1140,0.00000000}, {1150,0.00003960}, {1160,0.00002970}, {1170,0.00002970}, {1180,0.00002970}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00006931}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00002970}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00006931}, {1290,0.00000000}, {1300,0.00006931}, {1310,0.00000000}, {1320,0.00005941}, {1330,0.00000000}, {1340,0.00002970}, {1350,0.00009901}, {1360,0.00000000}, {1370,0.00002970}, {1380,0.00002970}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00002970}, {1420,0.00006931}, {1430,0.00005941}, {1440,0.00009901}, {1450,0.00002970}, {1460,0.00007921}, {1470,0.00000000}, {1480,0.00002970}, {1490,0.00002970}, {1500,0.00000000}, {1510,0.00003960}, {1520,0.00002970}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00011881}, {1560,0.00010891}, {1570,0.00000000}, {1580,0.00002970}, {1590,0.00000000}, {1600,0.00003960}, {1610,0.00000000}, {1620,0.00002970}, {1630,0.00005941}, {1640,0.00000000}, {1650,0.00006931}, {1660,0.00000000}, {1670,0.00013861}, {1680,0.00000000}, {1690,0.00002970}, {1700,0.00000000}, {1710,0.00006931}, {1720,0.00005941}, {1730,0.00000000}, {1740,0.00002970}, {1750,0.00003960}, {1760,0.00000000}, {1770,0.00002970}, {1780,0.00005941}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00003960}, {1830,0.00000000}, {1840,0.00010891}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00006931}, {1890,0.00002970}, {1900,0.00002970}, {1910,0.00006931}, {1920,0.00003960}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00013861}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00003960}, {2050,0.00002970}, {2100,0.00006931}, {2150,0.00002970}, {2200,0.00002970}, {2250,0.00003960}, {2300,0.00002970}, {2350,0.00002970}, {2400,0.00000000}, {2450,0.00003960}, {2500,0.00003960}, {2550,0.00002970}, {2600,0.00002970}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00003960}, {2850,0.00002970}, {2900,0.00003960}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00011881}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00003960}, {3350,0.00003960}, {3400,0.00005941}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00003960}, {3650,0.00013861}, {3700,0.00000000}, {3750,0.00002970}, {3800,0.00013861}, {3850,0.00000000}, {3900,0.00006931}, {3950,0.00000000}, {4000,0.00006931}, {4050,0.00007921}, {4100,0.00000000}, {4150,0.00003960}, {4200,0.00000000}, {4250,0.00003960}, {4300,0.00000000}, {4350,0.00003960}, {4400,0.00003960}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00002970}, {4600,0.00000000}, {4650,0.00002970}, {4700,0.00002970}, {4750,0.00003960}, {4800,0.00014851}, {4850,0.00002970}, {4900,0.00009901}, {4950,0.00006931}, {5000,0.00002970}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00003960}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00002970}, {5450,0.00005941}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00007921}, {5750,0.00002970}, {5800,0.00010891}, {5850,0.00002970}, {5900,0.00000000}, {5950,0.00003960}, {6000,0.00002970}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0001143}, {6200,0.0000000}, {6250,0.0001143}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000857}, {6550,0.0000000}, {6600,0.0002286}, {6650,0.0000857}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000857}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0001714}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0001143}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0002000}, {7850,0.0000000}, {7900,0.0000857}, {7950,0.0002286}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0001143}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0001143}, {8700,0.0000000}, {8750,0.0001143}, {8800,0.0001143}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000857}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0002286}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0001143}, {9400,0.0000000}, {9450,0.0001143}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0001143}, {9650,0.0000857}, {9700,0.0000857}, {9750,0.0001143}, {9800,0.0000000}, {9850,0.0002000}, {9900,0.0000000}, {9950,0.0002000}, {10000,0.0001143}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000857}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000857}, {11000,0.0000857}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0001143}, {11400,0.0000000}, {11500,0.0002000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0002000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0001143}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000857}, {13200,0.0000000}, {13300,0.0001143}, {13400,0.0000000}, {13500,0.0001143}, {13600,0.0002000}, {13700,0.0000857}, {13800,0.0000000}, {13900,0.0000857}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0001714}, {14400,0.0001143}, {14500,0.0002571}, {14600,0.0000000}, {14700,0.0000857}, {14800,0.0000000}, {14900,0.0000857}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000857}, {15700,0.0001143}, {15800,0.0000000}, {15900,0.0000857}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0001143}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0001143}, {17300,0.0000000}, {17400,0.0000857}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0001143}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000857}, {19100,0.0001143}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000857}, {19500,0.0001143}, {19600,0.0001143}, {19700,0.0001143}, {19800,0.0001143}, {19900,0.0000857}, {20000,0.0000000}};
data["big_flat"]["LtacPrimUncurry"]["post"]["system"] = {{1,0.00003960}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00003960}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00003960}, {358,0.00000000}, {359,0.00000000}, {360,0.00003960}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00003960}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00003960}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00003960}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0001143}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0001143}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacPrimUncurry"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacPrimUncurry"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00003960}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00003960}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00002970}, {44,0.00003960}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00003960}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00002970}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00003960}, {70,0.00000000}, {71,0.00000000}, {72,0.00003960}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00003960}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00003960}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00002970}, {99,0.00007921}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00002970}, {133,0.00000000}, {134,0.00000000}, {135,0.00003960}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00002970}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00002970}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00002970}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00002970}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00002970}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00002970}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00002970}, {241,0.00000000}, {242,0.00000000}, {243,0.00003960}, {244,0.00000000}, {245,0.00000000}, {246,0.00002970}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00002970}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00002970}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00002970}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00002970}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00002970}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00006931}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00003960}, {362,0.00000000}, {363,0.00000000}, {364,0.00002970}, {365,0.00000000}, {366,0.00002970}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00003960}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00003960}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00003960}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00003960}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00003960}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00007921}, {477,0.00000000}, {478,0.00002970}, {479,0.00000000}, {480,0.00000000}, {481,0.00002970}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00003960}, {490,0.00000000}, {491,0.00007921}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00002970}, {499,0.00006931}, {500,0.00002970}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00002970}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00002970}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00003960}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00002970}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00009901}, {815,0.00000000}, {820,0.00000000}, {825,0.00002970}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00002970}, {895,0.00002970}, {900,0.00000000}, {905,0.00002970}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00002970}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00003960}, {1200,0.00003960}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00002970}, {1290,0.00000000}, {1300,0.00002970}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00002970}, {1350,0.00000000}, {1360,0.00003960}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00003960}, {1590,0.00000000}, {1600,0.00002970}, {1610,0.00000000}, {1620,0.00002970}, {1630,0.00000000}, {1640,0.00003960}, {1650,0.00003960}, {1660,0.00000000}, {1670,0.00003960}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00002970}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00002970}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00002970}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00003960}, {1940,0.00006931}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00003960}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00002970}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00002970}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00002970}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00002970}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00002970}, {4600,0.00003960}, {4650,0.00000000}, {4700,0.00002970}, {4750,0.00000000}, {4800,0.00003960}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00007921}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00003960}, {5900,0.00000000}, {5950,0.00003960}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0001143}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0001143}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0001143}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000857}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000857}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000857}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0001143}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0001143}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0001143}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0001143}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0001143}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0001143}, {20000,0.0000000}};
data["big_flat"]["LtacPrimUncurry"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00002970}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacPrimUncurry"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00003960}, {6,0.00100000}, {7,0.00100000}, {8,0.00100000}, {9,0.00100000}, {10,0.00101980}, {11,0.00100000}, {12,0.00100990}, {13,0.00114851}, {14,0.00197030}, {15,0.00200000}, {16,0.00200990}, {17,0.00200000}, {18,0.00200000}, {19,0.00201980}, {20,0.00214851}, {21,0.00233663}, {22,0.00296040}, {23,0.00300000}, {24,0.00300000}, {25,0.00300000}, {26,0.00301980}, {27,0.00316832}, {28,0.00307921}, {29,0.00337624}, {30,0.00399010}, {31,0.00400000}, {32,0.00400000}, {33,0.00400000}, {34,0.00407921}, {35,0.00417822}, {36,0.00417822}, {37,0.00445545}, {38,0.00496040}, {39,0.00500000}, {40,0.00500990}, {41,0.00508911}, {42,0.00516832}, {43,0.00528713}, {44,0.00614851}, {45,0.00561386}, {46,0.00600000}, {47,0.00601980}, {48,0.00601980}, {49,0.00611881}, {50,0.00614851}, {51,0.00622772}, {52,0.00630693}, {53,0.00666337}, {54,0.00695050}, {55,0.00703960}, {56,0.00811881}, {57,0.00716832}, {58,0.00718812}, {59,0.00726733}, {60,0.00734653}, {61,0.00769307}, {62,0.00803960}, {63,0.00825743}, {64,0.00815842}, {65,0.00823762}, {66,0.00940594}, {67,0.00838614}, {68,0.00843564}, {69,0.00881188}, {70,0.00906931}, {71,0.00912871}, {72,0.00908911}, {73,0.00920792}, {74,0.00927723}, {75,0.00935644}, {76,0.00948515}, {77,0.00983168}, {78,0.01010891}, {79,0.01031683}, {80,0.01035644}, {81,0.01042574}, {82,0.01511881}, {83,0.01024752}, {84,0.01049505}, {85,0.01095050}, {86,0.01120792}, {87,0.01128713}, {88,0.01129703}, {89,0.01137624}, {90,0.01276238}, {91,0.01154455}, {92,0.01176238}, {93,0.01212871}, {94,0.01227723}, {95,0.01236634}, {96,0.01832673}, {97,0.01215842}, {98,0.01235644}, {99,0.01264356}, {100,0.01273267}, {101,0.01295050}, {102,0.01314851}, {103,0.01518812}, {104,0.01324752}, {105,0.01333663}, {106,0.01355446}, {107,0.01379208}, {108,0.01385149}, {109,0.01566337}, {110,0.01427723}, {111,0.01444554}, {112,0.01448515}, {113,0.01455446}, {114,0.02120792}, {115,0.01457426}, {116,0.01468317}, {117,0.01507921}, {118,0.01528713}, {119,0.01536634}, {120,0.01764356}, {121,0.01545545}, {122,0.01568317}, {123,0.01600000}, {124,0.01594059}, {125,0.01923762}, {126,0.01618812}, {127,0.01630693}, {128,0.01625743}, {129,0.01633663}, {130,0.01978218}, {131,0.01677228}, {132,0.01699010}, {133,0.01721782}, {134,0.01732673}, {135,0.01973267}, {136,0.01729703}, {137,0.01753465}, {138,0.01769307}, {139,0.01805941}, {140,0.01787129}, {141,0.01838614}, {142,0.01853465}, {143,0.01873267}, {144,0.02197030}, {145,0.01858416}, {146,0.01882178}, {147,0.01913861}, {148,0.01927723}, {149,0.01939604}, {150,0.01950495}, {151,0.01961386}, {152,0.01958416}, {153,0.02131683}, {154,0.01989109}, {155,0.02025743}, {156,0.02032673}, {157,0.02303960}, {158,0.02054455}, {159,0.02084158}, {160,0.02065347}, {161,0.02374257}, {162,0.02074257}, {163,0.02118812}, {164,0.02126733}, {165,0.02418812}, {166,0.02151485}, {167,0.02160396}, {168,0.02170297}, {169,0.02380198}, {170,0.02198020}, {171,0.02233663}, {172,0.02232673}, {173,0.02244554}, {174,0.02267327}, {175,0.02282178}, {176,0.02830693}, {177,0.02280198}, {178,0.02329703}, {179,0.02342574}, {180,0.02624752}, {181,0.02349505}, {182,0.02379208}, {183,0.03141584}, {184,0.02341584}, {185,0.02385149}, {186,0.02416832}, {187,0.02776238}, {188,0.02439604}, {189,0.02448515}, {190,0.03153465}, {191,0.02471287}, {192,0.02456436}, {193,0.02498020}, {194,0.02687129}, {195,0.02519802}, {196,0.02530693}, {197,0.03011881}, {198,0.02564356}, {199,0.02589109}, {200,0.03295050}, {201,0.02583168}, {202,0.02614851}, {203,0.02644554}, {204,0.02657426}, {205,0.02682178}, {206,0.02678218}, {207,0.02868317}, {208,0.02673267}, {209,0.02697030}, {210,0.03006931}, {211,0.02756436}, {212,0.02759406}, {213,0.03131683}, {214,0.02782178}, {215,0.02811881}, {216,0.03187129}, {217,0.02824752}, {218,0.02843564}, {219,0.03245545}, {220,0.02877228}, {221,0.02908911}, {222,0.03238614}, {223,0.02948515}, {224,0.02902970}, {225,0.03157426}, {226,0.02908911}, {227,0.02946535}, {228,0.03078218}, {229,0.02987129}, {230,0.03023762}, {231,0.03042574}, {232,0.03045545}, {233,0.03824752}, {234,0.03042574}, {235,0.03084158}, {236,0.03660396}, {237,0.03064356}, {238,0.03094059}, {239,0.03426733}, {240,0.03101980}, {241,0.03136634}, {242,0.03163366}, {243,0.03204950}, {244,0.03871287}, {245,0.03196040}, {246,0.03225743}, {247,0.03599010}, {248,0.03228713}, {249,0.04300990}, {250,0.03261386}, {251,0.03302970}, {252,0.03882178}, {253,0.03332673}, {254,0.03358416}, {255,0.03481188}, {256,0.03305941}, {257,0.04071287}, {258,0.03346535}, {259,0.03377228}, {260,0.03561386}, {261,0.03397030}, {262,0.04213861}, {263,0.03448515}, {264,0.03418812}, {265,0.03619802}, {266,0.03468317}, {267,0.04227723}, {268,0.03478218}, {269,0.03551485}, {270,0.03517822}, {271,0.03600000}, {272,0.04079208}, {273,0.03560396}, {274,0.04616832}, {275,0.03581188}, {276,0.03609901}, {277,0.03875248}, {278,0.03619802}, {279,0.04353465}, {280,0.03646535}, {281,0.04809901}, {282,0.03677228}, {283,0.03690099}, {284,0.04045545}, {285,0.03753465}, {286,0.04373267}, {287,0.03799010}, {288,0.04688119}, {289,0.03748515}, {290,0.03790099}, {291,0.03785149}, {292,0.03805941}, {293,0.04111881}, {294,0.03875248}, {295,0.04447525}, {296,0.03850495}, {297,0.04687129}, {298,0.03880198}, {299,0.04963366}, {300,0.03906931}, {301,0.03945545}, {302,0.04046535}, {303,0.04018812}, {304,0.04215842}, {305,0.03977228}, {306,0.04433663}, {307,0.04047525}, {308,0.04634653}, {309,0.04042574}, {310,0.04826733}, {311,0.04116832}, {312,0.04963366}, {313,0.04092079}, {314,0.05111881}, {315,0.04143564}, {316,0.05221782}, {317,0.04164356}, {318,0.05345545}, {319,0.04199010}, {320,0.05423762}, {321,0.04156436}, {322,0.04193069}, {323,0.04216832}, {324,0.04226733}, {325,0.04262376}, {326,0.04265347}, {327,0.04308911}, {328,0.04262376}, {329,0.04326733}, {330,0.04309901}, {331,0.04371287}, {332,0.04370297}, {333,0.04379208}, {334,0.04517822}, {335,0.04470297}, {336,0.05577228}, {337,0.04384158}, {338,0.05549505}, {339,0.04445545}, {340,0.05594059}, {341,0.04483168}, {342,0.05269307}, {343,0.04499010}, {344,0.05260396}, {345,0.04537624}, {346,0.05216832}, {347,0.04564356}, {348,0.05059406}, {349,0.04616832}, {350,0.04939604}, {351,0.04679208}, {352,0.04746535}, {353,0.04619802}, {354,0.04640594}, {355,0.05762376}, {356,0.04642574}, {357,0.05551485}, {358,0.04704950}, {359,0.05406931}, {360,0.04692079}, {361,0.05159406}, {362,0.04733663}, {363,0.04974257}, {364,0.06078218}, {365,0.04817822}, {366,0.06170297}, {367,0.04861386}, {368,0.05485149}, {369,0.04858416}, {370,0.05272277}, {371,0.04926733}, {372,0.04866337}, {373,0.06094059}, {374,0.04926733}, {375,0.05785149}, {376,0.04940594}, {377,0.05403960}, {378,0.04963366}, {379,0.05016832}, {380,0.06121782}, {381,0.05058416}, {382,0.05751485}, {383,0.05093069}, {384,0.05213861}, {385,0.06403960}, {386,0.05026733}, {387,0.05965347}, {388,0.05071287}, {389,0.05504950}, {390,0.06663366}, {391,0.05100000}, {392,0.06079208}, {393,0.05138614}, {394,0.05624752}, {395,0.06843564}, {396,0.05164356}, {397,0.06185149}, {398,0.05265347}, {399,0.05676238}, {400,0.06715842}, {401,0.05228713}, {402,0.06140594}, {403,0.05324752}, {404,0.05567327}, {405,0.06654455}, {406,0.05321782}, {407,0.06062376}, {408,0.05323762}, {409,0.05349505}, {410,0.06389109}, {411,0.05422772}, {412,0.05750495}, {413,0.06805941}, {414,0.05450495}, {415,0.06107921}, {416,0.07190099}, {417,0.05430693}, {418,0.06329703}, {419,0.05516832}, {420,0.05648515}, {421,0.06671287}, {422,0.05539604}, {423,0.05936634}, {424,0.06812871}, {425,0.05592079}, {426,0.06101980}, {427,0.07033663}, {428,0.05599010}, {429,0.06246535}, {430,0.07342574}, {431,0.05693069}, {432,0.06082178}, {433,0.08050495}, {434,0.05656436}, {435,0.06805941}, {436,0.08096040}, {437,0.05785149}, {438,0.06826733}, {439,0.08159406}, {440,0.05743564}, {441,0.06891089}, {442,0.07672277}, {443,0.05845545}, {444,0.06538614}, {445,0.07524752}, {446,0.05894059}, {447,0.06537624}, {448,0.07325743}, {449,0.05874257}, {450,0.06348515}, {451,0.07268317}, {452,0.05891089}, {453,0.06264356}, {454,0.07162376}, {455,0.06006931}, {456,0.06061386}, {457,0.06998020}, {458,0.07909901}, {459,0.06034653}, {460,0.06786139}, {461,0.07620792}, {462,0.06084158}, {463,0.06522772}, {464,0.07312871}, {465,0.06095050}, {466,0.06109901}, {467,0.07041584}, {468,0.07364356}, {469,0.06172277}, {470,0.06647525}, {471,0.07359406}, {472,0.06181188}, {473,0.06205941}, {474,0.06992079}, {475,0.07741584}, {476,0.06244554}, {477,0.06608911}, {478,0.07299010}, {479,0.08224752}, {480,0.06245545}, {481,0.06834653}, {482,0.07517822}, {483,0.06360396}, {484,0.06343564}, {485,0.07005941}, {486,0.07709901}, {487,0.06467327}, {488,0.06488119}, {489,0.07202970}, {490,0.07863366}, {491,0.06529703}, {492,0.06613861}, {493,0.07291089}, {494,0.07907921}, {495,0.06558416}, {496,0.06624752}, {497,0.07270297}, {498,0.07886139}, {499,0.06569307}, {500,0.06633663}, {505,0.07271287}, {510,0.07975248}, {515,0.08551485}, {520,0.06755446}, {525,0.07278218}, {530,0.07908911}, {535,0.08601980}, {540,0.09099010}, {545,0.07103960}, {550,0.07429703}, {555,0.07982178}, {560,0.08425743}, {565,0.08953465}, {570,0.09353465}, {575,0.09828713}, {580,0.07624752}, {585,0.07811881}, {590,0.08251485}, {595,0.08566337}, {600,0.08856436}, {605,0.09228713}, {610,0.09411881}, {615,0.09790099}, {620,0.09981188}, {625,0.10156436}, {630,0.10347525}, {635,0.10462376}, {640,0.10383168}, {645,0.10575248}, {650,1.09758416}, {655,0.11939604}, {660,0.11829703}, {665,0.11969307}, {670,0.11429703}, {675,0.11236634}, {680,0.11160396}, {685,0.11186139}, {690,0.11133663}, {695,0.11126733}, {700,0.10985149}, {705,0.10850495}, {710,0.10699010}, {715,0.10531683}, {720,0.10358416}, {725,0.10298020}, {730,0.10083168}, {735,0.12460396}, {740,0.12151485}, {745,0.11971287}, {750,0.11642574}, {755,0.11315842}, {760,0.10964356}, {765,0.10754455}, {770,0.12501980}, {775,0.12226733}, {780,0.11905941}, {785,0.11259406}, {790,0.11199010}, {795,0.13082178}, {800,0.11854455}, {805,0.11691089}, {810,0.11417822}, {815,0.11829703}, {820,0.14268317}, {825,0.13641584}, {830,0.12851485}, {835,0.11950495}, {840,0.13689109}, {845,0.13062376}, {850,0.12307921}, {855,0.14283168}, {860,0.13619802}, {865,0.12792079}, {870,0.14644554}, {875,0.13532673}, {880,0.12935644}, {885,0.14838614}, {890,0.14065347}, {895,0.13275248}, {900,0.14650495}, {905,0.13782178}, {910,0.13039604}, {915,0.14520792}, {920,0.13600000}, {925,0.15112871}, {930,0.14178218}, {935,0.13429703}, {940,0.14715842}, {945,0.13825743}, {950,0.15148515}, {955,0.14326733}, {960,0.15346535}, {965,0.14121782}, {970,0.15676238}, {975,0.14946535}, {980,0.17542574}, {985,0.15886139}, {990,0.17140594}, {995,0.15439604}, {1000,0.16670297}, {1010,0.15599010}, {1020,0.16869307}, {1030,0.15471287}, {1040,0.16321782}, {1050,0.15295050}, {1060,0.16344554}, {1070,0.17605941}, {1080,0.16100990}, {1090,0.16967327}, {1100,0.17886139}, {1110,0.16490099}, {1120,0.17054455}, {1130,0.18106931}, {1140,0.16708911}, {1150,0.17611881}, {1160,0.18021782}, {1170,0.18764356}, {1180,0.19458416}, {1190,0.18202970}, {1200,0.19444554}, {1210,0.20204950}, {1220,0.20065347}, {1230,0.20412871}, {1240,0.20848515}, {1250,0.21266337}, {1260,0.18678218}, {1270,0.19430693}, {1280,0.19301980}, {1290,0.19815842}, {1300,0.20030693}, {1310,0.20258416}, {1320,0.20178218}, {1330,0.20376238}, {1340,0.20497030}, {1350,0.20490099}, {1360,0.20446535}, {1370,0.20536634}, {1380,0.22691089}, {1390,0.22686139}, {1400,0.24536634}, {1410,0.23676238}, {1420,0.22563366}, {1430,0.22484158}, {1440,0.21985149}, {1450,0.24420792}, {1460,0.22953465}, {1470,0.23559406}, {1480,0.22838614}, {1490,0.24517822}, {1500,0.24035644}, {1510,0.23550495}, {1520,0.25141584}, {1530,0.24766337}, {1540,0.23780198}, {1550,0.25399010}, {1560,0.26882178}, {1570,0.25430693}, {1580,0.26034653}, {1590,0.25602970}, {1600,0.27035644}, {1610,0.26001980}, {1620,0.25056436}, {1630,0.26506931}, {1640,0.25153465}, {1650,0.26468317}, {1660,0.25643564}, {1670,0.26387129}, {1680,0.27889109}, {1690,0.26532673}, {1700,0.30205941}, {1710,0.27828713}, {1720,0.27896040}, {1730,0.29611881}, {1740,0.27409901}, {1750,0.28817822}, {1760,0.27501980}, {1770,0.27932673}, {1780,0.28621782}, {1790,0.29596040}, {1800,0.27750495}, {1810,0.28472277}, {1820,0.30438614}, {1830,0.32309901}, {1840,0.28885149}, {1850,0.29686139}, {1860,0.29793069}, {1870,0.29699010}, {1880,0.30962376}, {1890,0.31279208}, {1900,0.31541584}, {1910,0.30293069}, {1920,0.29621782}, {1930,0.30097030}, {1940,0.30267327}, {1950,0.32837624}, {1960,0.32145545}, {1970,0.31828713}, {1980,0.32024752}, {1990,0.31314851}, {2000,0.31715842}, {2050,0.31976238}, {2100,0.34742574}, {2150,0.34960396}, {2200,0.34920792}, {2250,0.36794059}, {2300,0.40238614}, {2350,0.39845545}, {2400,0.38822772}, {2450,0.39757426}, {2500,0.41316832}, {2550,0.42200990}, {2600,0.42603960}, {2650,0.43586139}, {2700,0.47393069}, {2750,0.46076238}, {2800,0.45949505}, {2850,0.47854455}, {2900,0.47326733}, {2950,0.49172277}, {3000,0.48982178}, {3050,0.53162376}, {3100,0.50958416}, {3150,0.51460396}, {3200,0.52371287}, {3250,0.53004950}, {3300,0.53294059}, {3350,0.53922772}, {3400,0.57850495}, {3450,0.59343564}, {3500,0.58691089}, {3550,0.58016832}, {3600,0.59006931}, {3650,0.59498020}, {3700,0.63605941}, {3750,0.62647525}, {3800,0.64659406}, {3850,0.63321782}, {3900,0.63688119}, {3950,0.68251485}, {4000,0.68835644}, {4050,0.68216832}, {4100,0.67547525}, {4150,0.67938614}, {4200,0.70487129}, {4250,0.73128713}, {4300,0.72310891}, {4350,0.72791089}, {4400,0.72309901}, {4450,0.73652475}, {4500,0.79067327}, {4550,0.77199010}, {4600,0.77956436}, {4650,0.77601980}, {4700,0.80232673}, {4750,0.80558416}, {4800,0.81305941}, {4850,0.81144554}, {4900,0.80466337}, {4950,0.86126733}, {5000,0.85180198}, {5050,0.84736634}, {5100,0.85306931}, {5150,0.88431683}, {5200,0.87832673}, {5250,0.87263366}, {5300,0.88475248}, {5350,0.89571287}, {5400,0.93658416}, {5450,0.92113861}, {5500,0.91238614}, {5550,0.93533663}, {5600,0.97276238}, {5650,0.95380198}, {5700,0.96061386}, {5750,0.99685149}, {5800,0.98825743}, {5850,0.99080198}, {5900,0.98272277}, {5950,1.03056436}, {6000,1.03304950}, {6050,1.0425429}, {6100,1.0746857}, {6150,1.0714000}, {6200,1.0668571}, {6250,1.1209429}, {6300,1.1045429}, {6350,1.1078000}, {6400,1.0660286}, {6450,1.1184571}, {6500,1.1297714}, {6550,1.1538857}, {6600,3.7967714}, {6650,1.1744571}, {6700,1.1605143}, {6750,1.1814286}, {6800,1.1810571}, {6850,1.1546000}, {6900,1.1502571}, {6950,1.2377143}, {7000,1.2144286}, {7050,1.2136571}, {7100,1.2454000}, {7150,1.2462000}, {7200,1.2165714}, {7250,1.2833429}, {7300,1.2604000}, {7350,1.2767429}, {7400,1.2861714}, {7450,1.2741143}, {7500,1.2896857}, {7550,1.3463429}, {7600,1.3307429}, {7650,1.3378000}, {7700,1.3330286}, {7750,1.3340857}, {7800,1.3307714}, {7850,1.3818000}, {7900,1.3904000}, {7950,1.3780857}, {8000,1.3859714}, {8050,1.3849143}, {8100,1.3944857}, {8150,1.4564286}, {8200,1.4247429}, {8250,1.4116286}, {8300,1.4442857}, {8350,1.4444000}, {8400,1.4421429}, {8450,1.4870857}, {8500,1.4923714}, {8550,1.4952000}, {8600,1.4931714}, {8650,1.4807143}, {8700,1.5630857}, {8750,1.5354857}, {8800,1.4903143}, {8850,1.5334286}, {8900,1.5048857}, {8950,1.5546857}, {9000,1.5703143}, {9050,1.5778857}, {9100,1.5874286}, {9150,1.5845714}, {9200,1.6120571}, {9250,1.6046857}, {9300,1.6228571}, {9350,1.6217714}, {9400,1.6053714}, {9450,1.6699143}, {9500,1.6567143}, {9550,1.6590286}, {9600,1.6714571}, {9650,1.6598286}, {9700,1.6906000}, {9750,1.7068000}, {9800,1.6825429}, {9850,1.7247429}, {9900,1.7111714}, {9950,1.7807143}, {10000,1.7449429}, {10100,1.7632857}, {10200,1.7874571}, {10300,1.7910571}, {10400,1.7958571}, {10500,1.8054857}, {10600,1.8489143}, {10700,1.8580857}, {10800,1.8888857}, {10900,1.8964857}, {11000,1.9355429}, {11100,1.9309143}, {11200,1.9596857}, {11300,1.9631714}, {11400,1.9768286}, {11500,2.0162286}, {11600,2.0279143}, {11700,2.0759714}, {11800,2.0370286}, {11900,2.0666000}, {12000,2.1088571}, {12100,2.0887714}, {12200,2.1202000}, {12300,2.1023714}, {12400,2.1870286}, {12500,2.1666857}, {12600,2.2192857}, {12700,2.2251429}, {12800,2.2387714}, {12900,2.2423429}, {13000,2.2504857}, {13100,2.3263143}, {13200,2.3337143}, {13300,2.3400286}, {13400,2.3626571}, {13500,2.3916286}, {13600,2.3393714}, {13700,2.3706571}, {13800,2.4646857}, {13900,2.4337143}, {14000,2.4357143}, {14100,2.5098286}, {14200,2.5088857}, {14300,2.5419714}, {14400,2.5103429}, {14500,2.5139429}, {14600,2.5282000}, {14700,2.5936571}, {14800,2.6322857}, {14900,2.6467143}, {15000,2.6320286}, {15100,2.7242286}, {15200,2.6603143}, {15300,2.7110286}, {15400,2.6957143}, {15500,2.7108857}, {15600,2.7593714}, {15700,2.7878000}, {15800,2.8005143}, {15900,2.7611714}, {16000,2.8313714}, {16100,2.8100286}, {16200,2.8279143}, {16300,2.9213429}, {16400,2.8548286}, {16500,2.8865714}, {16600,2.9287143}, {16700,2.9336571}, {16800,2.9642571}, {16900,2.9284000}, {17000,2.9498857}, {17100,3.0165143}, {17200,3.0014857}, {17300,3.0005143}, {17400,3.1416000}, {17500,3.0963429}, {17600,3.1050000}, {17700,3.1019429}, {17800,3.0884286}, {17900,3.2506286}, {18000,3.1282286}, {18100,3.1912000}, {18200,3.1835714}, {18300,3.2158571}, {18400,3.2687143}, {18500,3.2058286}, {18600,3.3056857}, {18700,3.2554286}, {18800,3.2399714}, {18900,3.3500286}, {19000,3.3254000}, {19100,3.3920000}, {19200,3.3058571}, {19300,6.8105429}, {19400,3.4346000}, {19500,3.3859714}, {19600,3.4028857}, {19700,3.4776571}, {19800,3.4636286}, {19900,3.5846571}, {20000,3.4661429}};
data["big_flat"]["LtacPrimUncurry"]["reif"]["user"] = {{1,0.00011881}, {2,0.00027723}, {3,0.00071287}, {4,0.00063366}, {5,0.00122772}, {6,0.00092079}, {7,0.00127723}, {8,0.00099010}, {9,0.00103960}, {10,0.00154455}, {11,0.00155446}, {12,0.00161386}, {13,0.00173267}, {14,0.00181188}, {15,0.00191089}, {16,0.00190099}, {17,0.00212871}, {18,0.00241584}, {19,0.00230693}, {20,0.00263366}, {21,0.00266337}, {22,0.00265347}, {23,0.00282178}, {24,0.00300000}, {25,0.00290099}, {26,0.00310891}, {27,0.00340594}, {28,0.00331683}, {29,0.00348515}, {30,0.00375248}, {31,0.00387129}, {32,0.00405941}, {33,0.00404950}, {34,0.00434653}, {35,0.00433663}, {36,0.00476238}, {37,0.00452475}, {38,0.00489109}, {39,0.00512871}, {40,0.00510891}, {41,0.00510891}, {42,0.00537624}, {43,0.00540594}, {44,0.00679208}, {45,0.00584158}, {46,0.00603960}, {47,0.00627723}, {48,0.00624752}, {49,0.00628713}, {50,0.00631683}, {51,0.00658416}, {52,0.00693069}, {53,0.00713861}, {54,0.00712871}, {55,0.00738614}, {56,0.00846535}, {57,0.00731683}, {58,0.00776238}, {59,0.00788119}, {60,0.00782178}, {61,0.00821782}, {62,0.00821782}, {63,0.00845545}, {64,0.00851485}, {65,0.00840594}, {66,0.00957426}, {67,0.00867327}, {68,0.00870297}, {69,0.00908911}, {70,0.00909901}, {71,0.00949505}, {72,0.00933663}, {73,0.00965347}, {74,0.00945545}, {75,0.00974257}, {76,0.00972277}, {77,0.01009901}, {78,0.01003960}, {79,0.01023762}, {80,0.01019802}, {81,0.01028713}, {82,0.01534653}, {83,0.01055446}, {84,0.01058416}, {85,0.01067327}, {86,0.01103960}, {87,0.01120792}, {88,0.01112871}, {89,0.01151485}, {90,0.01261386}, {91,0.01142574}, {92,0.01164356}, {93,0.01217822}, {94,0.01217822}, {95,0.01257426}, {96,0.01800000}, {97,0.01211881}, {98,0.01310891}, {99,0.01271287}, {100,0.01272277}, {101,0.01294059}, {102,0.01300990}, {103,0.01559406}, {104,0.01348515}, {105,0.01385149}, {106,0.01385149}, {107,0.01412871}, {108,0.01423762}, {109,0.01622772}, {110,0.01423762}, {111,0.01460396}, {112,0.01475248}, {113,0.01509901}, {114,0.02153465}, {115,0.01486139}, {116,0.01483168}, {117,0.01518812}, {118,0.01556436}, {119,0.01589109}, {120,0.01805941}, {121,0.01578218}, {122,0.01640594}, {123,0.01653465}, {124,0.01634653}, {125,0.01926733}, {126,0.01642574}, {127,0.01688119}, {128,0.01655446}, {129,0.01674257}, {130,0.01964356}, {131,0.01728713}, {132,0.01723762}, {133,0.01720792}, {134,0.01763366}, {135,0.01973267}, {136,0.01744554}, {137,0.01765347}, {138,0.01780198}, {139,0.01829703}, {140,0.01823762}, {141,0.01852475}, {142,0.01856436}, {143,0.01885149}, {144,0.02213861}, {145,0.01873267}, {146,0.01908911}, {147,0.01917822}, {148,0.01919802}, {149,0.01917822}, {150,0.01931683}, {151,0.01968317}, {152,0.01954455}, {153,0.02127723}, {154,0.02007921}, {155,0.02040594}, {156,0.02027723}, {157,0.02307921}, {158,0.02077228}, {159,0.02085149}, {160,0.02069307}, {161,0.02401980}, {162,0.02045545}, {163,0.02103960}, {164,0.02099010}, {165,0.02413861}, {166,0.02139604}, {167,0.02166337}, {168,0.02146535}, {169,0.02409901}, {170,0.02185149}, {171,0.02223762}, {172,0.02237624}, {173,0.02203960}, {174,0.02301980}, {175,0.02250495}, {176,0.02847525}, {177,0.02305941}, {178,0.02317822}, {179,0.02353465}, {180,0.02648515}, {181,0.02325743}, {182,0.02363366}, {183,0.03152475}, {184,0.02352475}, {185,0.02425743}, {186,0.02401980}, {187,0.02792079}, {188,0.02417822}, {189,0.02475248}, {190,0.03175248}, {191,0.02517822}, {192,0.02454455}, {193,0.02519802}, {194,0.02702970}, {195,0.02507921}, {196,0.02520792}, {197,0.02989109}, {198,0.02574257}, {199,0.02619802}, {200,0.03290099}, {201,0.02596040}, {202,0.02621782}, {203,0.02678218}, {204,0.02663366}, {205,0.02656436}, {206,0.02709901}, {207,0.02905941}, {208,0.02707921}, {209,0.02705941}, {210,0.03052475}, {211,0.02774257}, {212,0.02775248}, {213,0.03174257}, {214,0.02814851}, {215,0.02855446}, {216,0.03215842}, {217,0.02853465}, {218,0.02842574}, {219,0.03257426}, {220,0.02896040}, {221,0.02964356}, {222,0.03250495}, {223,0.02949505}, {224,0.02920792}, {225,0.03188119}, {226,0.02909901}, {227,0.02963366}, {228,0.03126733}, {229,0.03017822}, {230,0.03021782}, {231,0.03071287}, {232,0.03073267}, {233,0.03785149}, {234,0.03058416}, {235,0.03080198}, {236,0.03652475}, {237,0.03112871}, {238,0.03123762}, {239,0.03426733}, {240,0.03161386}, {241,0.03167327}, {242,0.03166337}, {243,0.03242574}, {244,0.03844554}, {245,0.03195050}, {246,0.03242574}, {247,0.03588119}, {248,0.03263366}, {249,0.04306931}, {250,0.03268317}, {251,0.03329703}, {252,0.03849505}, {253,0.03311881}, {254,0.03380198}, {255,0.03456436}, {256,0.03287129}, {257,0.04040594}, {258,0.03346535}, {259,0.03392079}, {260,0.03532673}, {261,0.03399010}, {262,0.04232673}, {263,0.03430693}, {264,0.03410891}, {265,0.03604950}, {266,0.03433663}, {267,0.04232673}, {268,0.03443564}, {269,0.03555446}, {270,0.03530693}, {271,0.03573267}, {272,0.04074257}, {273,0.03514851}, {274,0.04643564}, {275,0.03537624}, {276,0.03602970}, {277,0.03838614}, {278,0.03591089}, {279,0.04336634}, {280,0.03607921}, {281,0.04806931}, {282,0.03668317}, {283,0.03669307}, {284,0.04009901}, {285,0.03727723}, {286,0.04394059}, {287,0.03786139}, {288,0.04711881}, {289,0.03710891}, {290,0.03753465}, {291,0.03760396}, {292,0.03797030}, {293,0.04095050}, {294,0.03897030}, {295,0.04459406}, {296,0.03828713}, {297,0.04726733}, {298,0.03859406}, {299,0.04943564}, {300,0.03894059}, {301,0.03940594}, {302,0.04042574}, {303,0.04015842}, {304,0.04205941}, {305,0.03972277}, {306,0.04436634}, {307,0.04063366}, {308,0.04636634}, {309,0.04029703}, {310,0.04837624}, {311,0.04108911}, {312,0.04942574}, {313,0.04091089}, {314,0.05108911}, {315,0.04123762}, {316,0.05187129}, {317,0.04176238}, {318,0.05303960}, {319,0.04194059}, {320,0.05397030}, {321,0.04135644}, {322,0.04165347}, {323,0.04232673}, {324,0.04230693}, {325,0.04258416}, {326,0.04287129}, {327,0.04325743}, {328,0.04261386}, {329,0.04363366}, {330,0.04325743}, {331,0.04398020}, {332,0.04376238}, {333,0.04393069}, {334,0.04528713}, {335,0.04506931}, {336,0.05523762}, {337,0.04400000}, {338,0.05531683}, {339,0.04486139}, {340,0.05533663}, {341,0.04473267}, {342,0.05239604}, {343,0.04509901}, {344,0.05232673}, {345,0.04565347}, {346,0.05168317}, {347,0.04589109}, {348,0.05043564}, {349,0.04645545}, {350,0.04944554}, {351,0.04692079}, {352,0.04750495}, {353,0.04610891}, {354,0.04661386}, {355,0.05712871}, {356,0.04645545}, {357,0.05542574}, {358,0.04728713}, {359,0.05334653}, {360,0.04709901}, {361,0.05103960}, {362,0.04723762}, {363,0.04936634}, {364,0.06050495}, {365,0.04821782}, {366,0.06027723}, {367,0.04856436}, {368,0.05440594}, {369,0.04860396}, {370,0.05234653}, {371,0.04907921}, {372,0.04842574}, {373,0.06026733}, {374,0.04897030}, {375,0.05771287}, {376,0.04884158}, {377,0.05398020}, {378,0.04941584}, {379,0.04981188}, {380,0.06096040}, {381,0.04982178}, {382,0.05724752}, {383,0.05033663}, {384,0.05168317}, {385,0.06428713}, {386,0.04987129}, {387,0.05942574}, {388,0.05018812}, {389,0.05527723}, {390,0.06668317}, {391,0.05079208}, {392,0.06045545}, {393,0.05158416}, {394,0.05619802}, {395,0.06786139}, {396,0.05137624}, {397,0.06172277}, {398,0.05262376}, {399,0.05678218}, {400,0.06676238}, {401,0.05168317}, {402,0.06147525}, {403,0.05278218}, {404,0.05527723}, {405,0.06654455}, {406,0.05292079}, {407,0.06025743}, {408,0.05311881}, {409,0.05307921}, {410,0.06379208}, {411,0.05409901}, {412,0.05722772}, {413,0.06775248}, {414,0.05451485}, {415,0.06111881}, {416,0.07143564}, {417,0.05434653}, {418,0.06354455}, {419,0.05537624}, {420,0.05647525}, {421,0.06682178}, {422,0.05555446}, {423,0.05929703}, {424,0.06790099}, {425,0.05594059}, {426,0.06113861}, {427,0.07005941}, {428,0.05591089}, {429,0.06268317}, {430,0.07300000}, {431,0.05711881}, {432,0.06096040}, {433,0.08003960}, {434,0.05655446}, {435,0.06775248}, {436,0.08039604}, {437,0.05763366}, {438,0.06791089}, {439,0.08137624}, {440,0.05715842}, {441,0.06841584}, {442,0.07647525}, {443,0.05825743}, {444,0.06566337}, {445,0.07501980}, {446,0.05880198}, {447,0.06535644}, {448,0.07288119}, {449,0.05856436}, {450,0.06359406}, {451,0.07202970}, {452,0.05858416}, {453,0.06279208}, {454,0.07100990}, {455,0.05999010}, {456,0.06075248}, {457,0.06974257}, {458,0.07851485}, {459,0.06031683}, {460,0.06765347}, {461,0.07600000}, {462,0.06083168}, {463,0.06548515}, {464,0.07278218}, {465,0.06093069}, {466,0.06081188}, {467,0.06993069}, {468,0.07331683}, {469,0.06184158}, {470,0.06669307}, {471,0.07318812}, {472,0.06158416}, {473,0.06192079}, {474,0.06971287}, {475,0.07699010}, {476,0.06203960}, {477,0.06581188}, {478,0.07300990}, {479,0.08134653}, {480,0.06257426}, {481,0.06809901}, {482,0.07500000}, {483,0.06377228}, {484,0.06354455}, {485,0.06958416}, {486,0.07686139}, {487,0.06505941}, {488,0.06511881}, {489,0.07146535}, {490,0.07835644}, {491,0.06531683}, {492,0.06620792}, {493,0.07250495}, {494,0.07886139}, {495,0.06583168}, {496,0.06631683}, {497,0.07234653}, {498,0.07874257}, {499,0.06586139}, {500,0.06632673}, {505,0.07231683}, {510,0.07927723}, {515,0.08514851}, {520,0.06746535}, {525,0.07230693}, {530,0.07892079}, {535,0.08563366}, {540,0.09035644}, {545,0.07092079}, {550,0.07431683}, {555,0.07949505}, {560,0.08369307}, {565,0.08934653}, {570,0.09319802}, {575,0.09793069}, {580,0.07607921}, {585,0.07832673}, {590,0.08201980}, {595,0.08513861}, {600,0.08778218}, {605,0.09182178}, {610,0.09396040}, {615,0.09753465}, {620,0.09912871}, {625,0.10098020}, {630,0.10309901}, {635,0.10413861}, {640,0.10381188}, {645,0.10564356}, {650,1.09373267}, {655,0.11936634}, {660,0.11783168}, {665,0.11946535}, {670,0.11380198}, {675,0.11218812}, {680,0.11135644}, {685,0.11151485}, {690,0.11121782}, {695,0.11094059}, {700,0.10992079}, {705,0.10857426}, {710,0.10686139}, {715,0.10509901}, {720,0.10328713}, {725,0.10287129}, {730,0.10067327}, {735,0.12443564}, {740,0.12150495}, {745,0.11934653}, {750,0.11621782}, {755,0.11251485}, {760,0.10968317}, {765,0.10714851}, {770,0.12506931}, {775,0.12200000}, {780,0.11879208}, {785,0.11241584}, {790,0.11198020}, {795,0.13059406}, {800,0.11839604}, {805,0.11668317}, {810,0.11377228}, {815,0.11753465}, {820,0.14262376}, {825,0.13662376}, {830,0.12864356}, {835,0.11935644}, {840,0.13637624}, {845,0.13049505}, {850,0.12300000}, {855,0.14262376}, {860,0.13621782}, {865,0.12801980}, {870,0.14645545}, {875,0.13536634}, {880,0.12927723}, {885,0.14842574}, {890,0.14044554}, {895,0.13276238}, {900,0.14646535}, {905,0.13767327}, {910,0.13040594}, {915,0.14476238}, {920,0.13559406}, {925,0.14992079}, {930,0.14099010}, {935,0.13371287}, {940,0.14681188}, {945,0.13771287}, {950,0.15062376}, {955,0.14248515}, {960,0.15284158}, {965,0.14064356}, {970,0.15604950}, {975,0.14914851}, {980,0.17540594}, {985,0.15867327}, {990,0.17095050}, {995,0.15397030}, {1000,0.16602970}, {1010,0.15550495}, {1020,0.16819802}, {1030,0.15447525}, {1040,0.16273267}, {1050,0.15283168}, {1060,0.16293069}, {1070,0.17578218}, {1080,0.16069307}, {1090,0.16974257}, {1100,0.17823762}, {1110,0.16453465}, {1120,0.17000000}, {1130,0.18076238}, {1140,0.16665347}, {1150,0.17528713}, {1160,0.17990099}, {1170,0.18762376}, {1180,0.19434653}, {1190,0.18172277}, {1200,0.19434653}, {1210,0.20200990}, {1220,0.20030693}, {1230,0.20394059}, {1240,0.20803960}, {1250,0.21238614}, {1260,0.18659406}, {1270,0.19446535}, {1280,0.19281188}, {1290,0.19788119}, {1300,0.19996040}, {1310,0.20246535}, {1320,0.20199010}, {1330,0.20394059}, {1340,0.20479208}, {1350,0.20497030}, {1360,0.20412871}, {1370,0.20534653}, {1380,0.22630693}, {1390,0.22655446}, {1400,0.24522772}, {1410,0.23657426}, {1420,0.22547525}, {1430,0.22446535}, {1440,0.21950495}, {1450,0.24382178}, {1460,0.22927723}, {1470,0.23523762}, {1480,0.22785149}, {1490,0.24515842}, {1500,0.23966337}, {1510,0.23494059}, {1520,0.25115842}, {1530,0.24736634}, {1540,0.23734653}, {1550,0.25395050}, {1560,0.26795050}, {1570,0.25403960}, {1580,0.26000000}, {1590,0.25568317}, {1600,0.27007921}, {1610,0.25966337}, {1620,0.25020792}, {1630,0.26472277}, {1640,0.25111881}, {1650,0.26439604}, {1660,0.25595050}, {1670,0.26368317}, {1680,0.27870297}, {1690,0.26545545}, {1700,0.30150495}, {1710,0.27783168}, {1720,0.27865347}, {1730,0.29543564}, {1740,0.27386139}, {1750,0.28783168}, {1760,0.27458416}, {1770,0.27899010}, {1780,0.28608911}, {1790,0.29557426}, {1800,0.27719802}, {1810,0.28472277}, {1820,0.30400990}, {1830,0.32275248}, {1840,0.28847525}, {1850,0.29653465}, {1860,0.29732673}, {1870,0.29641584}, {1880,0.30905941}, {1890,0.31256436}, {1900,0.31522772}, {1910,0.30246535}, {1920,0.29560396}, {1930,0.30022772}, {1940,0.30244554}, {1950,0.32779208}, {1960,0.32103960}, {1970,0.31771287}, {1980,0.31973267}, {1990,0.31257426}, {2000,0.31666337}, {2050,0.31941584}, {2100,0.34679208}, {2150,0.34898020}, {2200,0.34842574}, {2250,0.36707921}, {2300,0.40179208}, {2350,0.39789109}, {2400,0.38746535}, {2450,0.39726733}, {2500,0.41299010}, {2550,0.42155446}, {2600,0.42573267}, {2650,0.43514851}, {2700,0.47304950}, {2750,0.46011881}, {2800,0.45899010}, {2850,0.47800000}, {2900,0.47276238}, {2950,0.49139604}, {3000,0.48930693}, {3050,0.53086139}, {3100,0.50899010}, {3150,0.51396040}, {3200,0.52299010}, {3250,0.52932673}, {3300,0.53242574}, {3350,0.53845545}, {3400,0.57754455}, {3450,0.59275248}, {3500,0.58614851}, {3550,0.57927723}, {3600,0.58920792}, {3650,0.59400990}, {3700,0.63531683}, {3750,0.62577228}, {3800,0.64577228}, {3850,0.63274257}, {3900,0.63609901}, {3950,0.68132673}, {4000,0.68737624}, {4050,0.68145545}, {4100,0.67218812}, {4150,0.67606931}, {4200,0.70303960}, {4250,0.73017822}, {4300,0.72195050}, {4350,0.72692079}, {4400,0.72198020}, {4450,0.73570297}, {4500,0.78951485}, {4550,0.77103960}, {4600,0.77809901}, {4650,0.77515842}, {4700,0.80130693}, {4750,0.80433663}, {4800,0.81219802}, {4850,0.81076238}, {4900,0.80359406}, {4950,0.86021782}, {5000,0.85075248}, {5050,0.84643564}, {5100,0.85151485}, {5150,0.88336634}, {5200,0.87753465}, {5250,0.87121782}, {5300,0.88392079}, {5350,0.89479208}, {5400,0.93541584}, {5450,0.92032673}, {5500,0.91158416}, {5550,0.93418812}, {5600,0.97167327}, {5650,0.95273267}, {5700,0.95945545}, {5750,0.99590099}, {5800,0.98750495}, {5850,0.98997030}, {5900,0.98159406}, {5950,1.02933663}, {6000,1.03188119}, {6050,1.0364857}, {6100,1.0688286}, {6150,1.0635143}, {6200,1.0627714}, {6250,1.1198286}, {6300,1.0990571}, {6350,1.1029714}, {6400,1.0598286}, {6450,1.1180000}, {6500,1.1287143}, {6550,1.1528000}, {6600,3.7923143}, {6650,1.1725714}, {6700,1.1596286}, {6750,1.1799714}, {6800,1.1801143}, {6850,1.1535714}, {6900,1.1495143}, {6950,1.2369714}, {7000,1.2136286}, {7050,1.2127714}, {7100,1.2440857}, {7150,1.2382571}, {7200,1.2098286}, {7250,1.2780571}, {7300,1.2590857}, {7350,1.2762000}, {7400,1.2854000}, {7450,1.2731429}, {7500,1.2890286}, {7550,1.3453714}, {7600,1.3297714}, {7650,1.3361714}, {7700,1.3320857}, {7750,1.3329429}, {7800,1.3297714}, {7850,1.3804571}, {7900,1.3902286}, {7950,1.3773429}, {8000,1.3850571}, {8050,1.3844000}, {8100,1.3942000}, {8150,1.4553143}, {8200,1.4232000}, {8250,1.4105429}, {8300,1.4435714}, {8350,1.4438286}, {8400,1.4403714}, {8450,1.4860000}, {8500,1.4912286}, {8550,1.4938286}, {8600,1.4916857}, {8650,1.4803143}, {8700,1.5625714}, {8750,1.5341143}, {8800,1.4889143}, {8850,1.5320286}, {8900,1.5033429}, {8950,1.5539429}, {9000,1.5690571}, {9050,1.5765714}, {9100,1.5854286}, {9150,1.5841143}, {9200,1.6108286}, {9250,1.6032857}, {9300,1.6221429}, {9350,1.6210000}, {9400,1.6043714}, {9450,1.6680000}, {9500,1.6557143}, {9550,1.6547714}, {9600,1.6665714}, {9650,1.6560000}, {9700,1.6885714}, {9750,1.7045714}, {9800,1.6779143}, {9850,1.7232857}, {9900,1.7079143}, {9950,1.7776000}, {10000,1.7428286}, {10100,1.7620857}, {10200,1.7835143}, {10300,1.7895714}, {10400,1.7906571}, {10500,1.8010571}, {10600,1.8443429}, {10700,1.8557714}, {10800,1.8859143}, {10900,1.8922857}, {11000,1.9330571}, {11100,1.9253429}, {11200,1.9585143}, {11300,1.9623143}, {11400,1.9760000}, {11500,2.0150571}, {11600,2.0266571}, {11700,2.0680286}, {11800,2.0357143}, {11900,2.0657714}, {12000,2.1072286}, {12100,2.0874571}, {12200,2.1186857}, {12300,2.0999714}, {12400,2.1812286}, {12500,2.1648857}, {12600,2.2178286}, {12700,2.2241143}, {12800,2.2378286}, {12900,2.2362286}, {13000,2.2442571}, {13100,2.3160286}, {13200,2.3292286}, {13300,2.3373714}, {13400,2.3600286}, {13500,2.3860857}, {13600,2.3361429}, {13700,2.3627143}, {13800,2.4570286}, {13900,2.4112571}, {14000,2.4285714}, {14100,2.5028571}, {14200,2.4974571}, {14300,2.5258571}, {14400,2.5031143}, {14500,2.5064857}, {14600,2.5252857}, {14700,2.5827143}, {14800,2.6303143}, {14900,2.6276571}, {15000,2.6226571}, {15100,2.7106286}, {15200,2.6537714}, {15300,2.7026857}, {15400,2.6926571}, {15500,2.7058857}, {15600,2.7525714}, {15700,2.7813143}, {15800,2.7927143}, {15900,2.7571143}, {16000,2.8276857}, {16100,2.8079143}, {16200,2.8215429}, {16300,2.9168000}, {16400,2.8491714}, {16500,2.8739429}, {16600,2.9154571}, {16700,2.9272571}, {16800,2.9592286}, {16900,2.9224571}, {17000,2.9338571}, {17100,3.0126000}, {17200,2.9990000}, {17300,2.9988857}, {17400,3.1288000}, {17500,3.0938286}, {17600,3.1023143}, {17700,3.0995714}, {17800,3.0853143}, {17900,3.2450857}, {18000,3.1260571}, {18100,3.1884857}, {18200,3.1805143}, {18300,3.2128857}, {18400,3.2652857}, {18500,3.2032000}, {18600,3.3024571}, {18700,3.2523714}, {18800,3.2335714}, {18900,3.3478857}, {19000,3.3228000}, {19100,3.3892571}, {19200,3.2945143}, {19300,6.7970857}, {19400,3.4317143}, {19500,3.3831143}, {19600,3.3998857}, {19700,3.4756286}, {19800,3.4612000}, {19900,3.5824571}, {20000,3.4640857}};
data["big_flat"]["LtacPrimUncurry"]["reif"]["system"] = {{1,0.00018812}, {2,0.00009901}, {3,0.00003960}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00005941}, {14,0.00000000}, {15,0.00000000}, {16,0.00003960}, {17,0.00002970}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00002970}, {23,0.00000000}, {24,0.00000000}, {25,0.00003960}, {26,0.00007921}, {27,0.00000000}, {28,0.00003960}, {29,0.00003960}, {30,0.00000000}, {31,0.00002970}, {32,0.00003960}, {33,0.00002970}, {34,0.00000000}, {35,0.00003960}, {36,0.00000000}, {37,0.00002970}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003960}, {42,0.00003960}, {43,0.00003960}, {44,0.00003960}, {45,0.00009901}, {46,0.00003960}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00000000}, {51,0.00003960}, {52,0.00003960}, {53,0.00000000}, {54,0.00000000}, {55,0.00003960}, {56,0.00003960}, {57,0.00006931}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00005941}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00003960}, {67,0.00010891}, {68,0.00000000}, {69,0.00000000}, {70,0.00003960}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00003960}, {76,0.00003960}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00006931}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00007921}, {87,0.00006931}, {88,0.00003960}, {89,0.00000000}, {90,0.00011881}, {91,0.00003960}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00002970}, {97,0.00000000}, {98,0.00002970}, {99,0.00000000}, {100,0.00003960}, {101,0.00003960}, {102,0.00000000}, {103,0.00000000}, {104,0.00003960}, {105,0.00003960}, {106,0.00013861}, {107,0.00003960}, {108,0.00000000}, {109,0.00003960}, {110,0.00003960}, {111,0.00003960}, {112,0.00002970}, {113,0.00003960}, {114,0.00003960}, {115,0.00007921}, {116,0.00003960}, {117,0.00000000}, {118,0.00009901}, {119,0.00003960}, {120,0.00006931}, {121,0.00003960}, {122,0.00000000}, {123,0.00000000}, {124,0.00003960}, {125,0.00006931}, {126,0.00003960}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00002970}, {133,0.00000000}, {134,0.00003960}, {135,0.00011881}, {136,0.00000000}, {137,0.00003960}, {138,0.00007921}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00017822}, {145,0.00002970}, {146,0.00000000}, {147,0.00011881}, {148,0.00003960}, {149,0.00007921}, {150,0.00000000}, {151,0.00003960}, {152,0.00003960}, {153,0.00015842}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00007921}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00003960}, {162,0.00015842}, {163,0.00003960}, {164,0.00003960}, {165,0.00010891}, {166,0.00000000}, {167,0.00003960}, {168,0.00003960}, {169,0.00000000}, {170,0.00000000}, {171,0.00003960}, {172,0.00000000}, {173,0.00007921}, {174,0.00000000}, {175,0.00000000}, {176,0.00005941}, {177,0.00000000}, {178,0.00003960}, {179,0.00000000}, {180,0.00012871}, {181,0.00000000}, {182,0.00000000}, {183,0.00006931}, {184,0.00000000}, {185,0.00003960}, {186,0.00000000}, {187,0.00002970}, {188,0.00000000}, {189,0.00000000}, {190,0.00002970}, {191,0.00000000}, {192,0.00003960}, {193,0.00002970}, {194,0.00002970}, {195,0.00000000}, {196,0.00000000}, {197,0.00014851}, {198,0.00000000}, {199,0.00003960}, {200,0.00011881}, {201,0.00002970}, {202,0.00000000}, {203,0.00003960}, {204,0.00003960}, {205,0.00007921}, {206,0.00000000}, {207,0.00003960}, {208,0.00000000}, {209,0.00000000}, {210,0.00006931}, {211,0.00000000}, {212,0.00000000}, {213,0.00006931}, {214,0.00000000}, {215,0.00000000}, {216,0.00011881}, {217,0.00000000}, {218,0.00003960}, {219,0.00017822}, {220,0.00006931}, {221,0.00000000}, {222,0.00007921}, {223,0.00002970}, {224,0.00003960}, {225,0.00000000}, {226,0.00000000}, {227,0.00003960}, {228,0.00003960}, {229,0.00000000}, {230,0.00003960}, {231,0.00000000}, {232,0.00003960}, {233,0.00011881}, {234,0.00011881}, {235,0.00002970}, {236,0.00009901}, {237,0.00000000}, {238,0.00003960}, {239,0.00007921}, {240,0.00000000}, {241,0.00003960}, {242,0.00000000}, {243,0.00003960}, {244,0.00011881}, {245,0.00003960}, {246,0.00003960}, {247,0.00015842}, {248,0.00003960}, {249,0.00030693}, {250,0.00002970}, {251,0.00000000}, {252,0.00029703}, {253,0.00003960}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00018812}, {258,0.00000000}, {259,0.00000000}, {260,0.00003960}, {261,0.00000000}, {262,0.00019802}, {263,0.00010891}, {264,0.00000000}, {265,0.00002970}, {266,0.00000000}, {267,0.00017822}, {268,0.00000000}, {269,0.00000000}, {270,0.00002970}, {271,0.00000000}, {272,0.00010891}, {273,0.00003960}, {274,0.00030693}, {275,0.00003960}, {276,0.00002970}, {277,0.00007921}, {278,0.00000000}, {279,0.00017822}, {280,0.00000000}, {281,0.00018812}, {282,0.00000000}, {283,0.00003960}, {284,0.00010891}, {285,0.00003960}, {286,0.00013861}, {287,0.00000000}, {288,0.00018812}, {289,0.00000000}, {290,0.00000000}, {291,0.00007921}, {292,0.00002970}, {293,0.00007921}, {294,0.00000000}, {295,0.00014851}, {296,0.00002970}, {297,0.00015842}, {298,0.00000000}, {299,0.00009901}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00003960}, {305,0.00003960}, {306,0.00011881}, {307,0.00000000}, {308,0.00019802}, {309,0.00003960}, {310,0.00023762}, {311,0.00002970}, {312,0.00011881}, {313,0.00002970}, {314,0.00022772}, {315,0.00003960}, {316,0.00007921}, {317,0.00003960}, {318,0.00029703}, {319,0.00003960}, {320,0.00013861}, {321,0.00000000}, {322,0.00006931}, {323,0.00003960}, {324,0.00007921}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00006931}, {329,0.00003960}, {330,0.00003960}, {331,0.00003960}, {332,0.00011881}, {333,0.00007921}, {334,0.00000000}, {335,0.00002970}, {336,0.00027723}, {337,0.00000000}, {338,0.00015842}, {339,0.00002970}, {340,0.00015842}, {341,0.00002970}, {342,0.00026733}, {343,0.00000000}, {344,0.00015842}, {345,0.00006931}, {346,0.00011881}, {347,0.00006931}, {348,0.00002970}, {349,0.00000000}, {350,0.00002970}, {351,0.00003960}, {352,0.00006931}, {353,0.00003960}, {354,0.00003960}, {355,0.00013861}, {356,0.00002970}, {357,0.00014851}, {358,0.00003960}, {359,0.00003960}, {360,0.00000000}, {361,0.00010891}, {362,0.00003960}, {363,0.00023762}, {364,0.00038614}, {365,0.00003960}, {366,0.00128713}, {367,0.00007921}, {368,0.00019802}, {369,0.00000000}, {370,0.00011881}, {371,0.00003960}, {372,0.00000000}, {373,0.00042574}, {374,0.00002970}, {375,0.00007921}, {376,0.00000000}, {377,0.00002970}, {378,0.00002970}, {379,0.00000000}, {380,0.00033663}, {381,0.00006931}, {382,0.00019802}, {383,0.00003960}, {384,0.00007921}, {385,0.00021782}, {386,0.00003960}, {387,0.00009901}, {388,0.00002970}, {389,0.00010891}, {390,0.00022772}, {391,0.00000000}, {392,0.00018812}, {393,0.00000000}, {394,0.00007921}, {395,0.00030693}, {396,0.00003960}, {397,0.00030693}, {398,0.00000000}, {399,0.00007921}, {400,0.00027723}, {401,0.00000000}, {402,0.00015842}, {403,0.00003960}, {404,0.00015842}, {405,0.00006931}, {406,0.00010891}, {407,0.00029703}, {408,0.00003960}, {409,0.00000000}, {410,0.00007921}, {411,0.00000000}, {412,0.00021782}, {413,0.00035644}, {414,0.00000000}, {415,0.00003960}, {416,0.00040594}, {417,0.00002970}, {418,0.00015842}, {419,0.00000000}, {420,0.00002970}, {421,0.00022772}, {422,0.00000000}, {423,0.00007921}, {424,0.00034653}, {425,0.00003960}, {426,0.00013861}, {427,0.00000000}, {428,0.00003960}, {429,0.00000000}, {430,0.00028713}, {431,0.00011881}, {432,0.00011881}, {433,0.00026733}, {434,0.00003960}, {435,0.00010891}, {436,0.00023762}, {437,0.00003960}, {438,0.00016832}, {439,0.00027723}, {440,0.00003960}, {441,0.00018812}, {442,0.00021782}, {443,0.00000000}, {444,0.00007921}, {445,0.00035644}, {446,0.00003960}, {447,0.00022772}, {448,0.00022772}, {449,0.00003960}, {450,0.00007921}, {451,0.00034653}, {452,0.00011881}, {453,0.00007921}, {454,0.00028713}, {455,0.00000000}, {456,0.00003960}, {457,0.00011881}, {458,0.00050495}, {459,0.00000000}, {460,0.00007921}, {461,0.00031683}, {462,0.00003960}, {463,0.00011881}, {464,0.00043564}, {465,0.00000000}, {466,0.00000000}, {467,0.00019802}, {468,0.00028713}, {469,0.00000000}, {470,0.00011881}, {471,0.00022772}, {472,0.00003960}, {473,0.00000000}, {474,0.00022772}, {475,0.00014851}, {476,0.00003960}, {477,0.00018812}, {478,0.00003960}, {479,0.00033663}, {480,0.00000000}, {481,0.00019802}, {482,0.00014851}, {483,0.00000000}, {484,0.00000000}, {485,0.00010891}, {486,0.00035644}, {487,0.00007921}, {488,0.00000000}, {489,0.00013861}, {490,0.00026733}, {491,0.00000000}, {492,0.00003960}, {493,0.00015842}, {494,0.00023762}, {495,0.00014851}, {496,0.00007921}, {497,0.00007921}, {498,0.00023762}, {499,0.00000000}, {500,0.00000000}, {505,0.00024752}, {510,0.00034653}, {515,0.00030693}, {520,0.00003960}, {525,0.00007921}, {530,0.00000000}, {535,0.00033663}, {540,0.00042574}, {545,0.00000000}, {550,0.00003960}, {555,0.00022772}, {560,0.00037624}, {565,0.00028713}, {570,0.00039604}, {575,0.00052475}, {580,0.00007921}, {585,0.00007921}, {590,0.00019802}, {595,0.00019802}, {600,0.00030693}, {605,0.00038614}, {610,0.00030693}, {615,0.00030693}, {620,0.00032673}, {625,0.00034653}, {630,0.00023762}, {635,0.00003960}, {640,0.00000000}, {645,0.00002970}, {650,0.00292079}, {655,0.00006931}, {660,0.00007921}, {665,0.00006931}, {670,0.00023762}, {675,0.00000000}, {680,0.00007921}, {685,0.00000000}, {690,0.00006931}, {695,0.00000000}, {700,0.00003960}, {705,0.00000000}, {710,0.00003960}, {715,0.00007921}, {720,0.00000000}, {725,0.00000000}, {730,0.00007921}, {735,0.00006931}, {740,0.00000000}, {745,0.00003960}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00007921}, {770,0.00003960}, {775,0.00007921}, {780,0.00003960}, {785,0.00007921}, {790,0.00000000}, {795,0.00000000}, {800,0.00003960}, {805,0.00006931}, {810,0.00002970}, {815,0.00003960}, {820,0.00000000}, {825,0.00003960}, {830,0.00003960}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00003960}, {870,0.00003960}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00003960}, {900,0.00000000}, {905,0.00003960}, {910,0.00003960}, {915,0.00022772}, {920,0.00044554}, {925,0.00067327}, {930,0.00055446}, {935,0.00027723}, {940,0.00029703}, {945,0.00026733}, {950,0.00053465}, {955,0.00046535}, {960,0.00039604}, {965,0.00015842}, {970,0.00034653}, {975,0.00021782}, {980,0.00006931}, {985,0.00018812}, {990,0.00026733}, {995,0.00019802}, {1000,0.00029703}, {1010,0.00013861}, {1020,0.00010891}, {1030,0.00007921}, {1040,0.00027723}, {1050,0.00003960}, {1060,0.00007921}, {1070,0.00003960}, {1080,0.00007921}, {1090,0.00011881}, {1100,0.00015842}, {1110,0.00003960}, {1120,0.00018812}, {1130,0.00003960}, {1140,0.00011881}, {1150,0.00015842}, {1160,0.00007921}, {1170,0.00000000}, {1180,0.00003960}, {1190,0.00000000}, {1200,0.00003960}, {1210,0.00000000}, {1220,0.00003960}, {1230,0.00003960}, {1240,0.00000000}, {1250,0.00007921}, {1260,0.00011881}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00003960}, {1330,0.00003960}, {1340,0.00011881}, {1350,0.00000000}, {1360,0.00007921}, {1370,0.00003960}, {1380,0.00014851}, {1390,0.00003960}, {1400,0.00000000}, {1410,0.00003960}, {1420,0.00002970}, {1430,0.00003960}, {1440,0.00000000}, {1450,0.00003960}, {1460,0.00003960}, {1470,0.00007921}, {1480,0.00003960}, {1490,0.00003960}, {1500,0.00000000}, {1510,0.00007921}, {1520,0.00007921}, {1530,0.00007921}, {1540,0.00003960}, {1550,0.00005941}, {1560,0.00007921}, {1570,0.00003960}, {1580,0.00007921}, {1590,0.00010891}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00006931}, {1630,0.00003960}, {1640,0.00000000}, {1650,0.00003960}, {1660,0.00003960}, {1670,0.00003960}, {1680,0.00007921}, {1690,0.00007921}, {1700,0.00003960}, {1710,0.00003960}, {1720,0.00003960}, {1730,0.00007921}, {1740,0.00003960}, {1750,0.00003960}, {1760,0.00011881}, {1770,0.00011881}, {1780,0.00003960}, {1790,0.00011881}, {1800,0.00003960}, {1810,0.00007921}, {1820,0.00002970}, {1830,0.00006931}, {1840,0.00003960}, {1850,0.00000000}, {1860,0.00007921}, {1870,0.00003960}, {1880,0.00003960}, {1890,0.00003960}, {1900,0.00000000}, {1910,0.00005941}, {1920,0.00003960}, {1930,0.00002970}, {1940,0.00000000}, {1950,0.00010891}, {1960,0.00000000}, {1970,0.00007921}, {1980,0.00011881}, {1990,0.00010891}, {2000,0.00003960}, {2050,0.00007921}, {2100,0.00000000}, {2150,0.00007921}, {2200,0.00007921}, {2250,0.00000000}, {2300,0.00015842}, {2350,0.00003960}, {2400,0.00011881}, {2450,0.00007921}, {2500,0.00006931}, {2550,0.00015842}, {2600,0.00003960}, {2650,0.00018812}, {2700,0.00018812}, {2750,0.00003960}, {2800,0.00003960}, {2850,0.00006931}, {2900,0.00011881}, {2950,0.00018812}, {3000,0.00006931}, {3050,0.00011881}, {3100,0.00007921}, {3150,0.00000000}, {3200,0.00015842}, {3250,0.00011881}, {3300,0.00003960}, {3350,0.00011881}, {3400,0.00006931}, {3450,0.00003960}, {3500,0.00003960}, {3550,0.00011881}, {3600,0.00003960}, {3650,0.00000000}, {3700,0.00015842}, {3750,0.00022772}, {3800,0.00007921}, {3850,0.00007921}, {3900,0.00019802}, {3950,0.00014851}, {4000,0.00015842}, {4050,0.00003960}, {4100,0.00236634}, {4150,0.00264356}, {4200,0.00104950}, {4250,0.00007921}, {4300,0.00007921}, {4350,0.00016832}, {4400,0.00015842}, {4450,0.00011881}, {4500,0.00022772}, {4550,0.00051485}, {4600,0.00048515}, {4650,0.00000000}, {4700,0.00011881}, {4750,0.00023762}, {4800,0.00005941}, {4850,0.00003960}, {4900,0.00006931}, {4950,0.00009901}, {5000,0.00007921}, {5050,0.00011881}, {5100,0.00023762}, {5150,0.00015842}, {5200,0.00015842}, {5250,0.00030693}, {5300,0.00000000}, {5350,0.00007921}, {5400,0.00014851}, {5450,0.00007921}, {5500,0.00003960}, {5550,0.00011881}, {5600,0.00014851}, {5650,0.00010891}, {5700,0.00006931}, {5750,0.00000000}, {5800,0.00007921}, {5850,0.00002970}, {5900,0.00002970}, {5950,0.00015842}, {6000,0.00014851}, {6050,0.0052571}, {6100,0.0049143}, {6150,0.0065143}, {6200,0.0028857}, {6250,0.0003429}, {6300,0.0045429}, {6350,0.0040571}, {6400,0.0054857}, {6450,0.0001143}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0022571}, {6650,0.0005714}, {6700,0.0000000}, {6750,0.0002286}, {6800,0.0003429}, {6850,0.0001143}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000857}, {7050,0.0003429}, {7100,0.0003429}, {7150,0.0068857}, {7200,0.0060571}, {7250,0.0038857}, {7300,0.0004571}, {7350,0.0000000}, {7400,0.0001143}, {7450,0.0000000}, {7500,0.0002286}, {7550,0.0002286}, {7600,0.0000857}, {7650,0.0002286}, {7700,0.0000000}, {7750,0.0004286}, {7800,0.0003143}, {7850,0.0002000}, {7900,0.0001143}, {7950,0.0003429}, {8000,0.0001143}, {8050,0.0001143}, {8100,0.0002286}, {8150,0.0002286}, {8200,0.0001143}, {8250,0.0001143}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0001714}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0002286}, {8600,0.0003429}, {8650,0.0001143}, {8700,0.0001143}, {8750,0.0004571}, {8800,0.0003429}, {8850,0.0000000}, {8900,0.0003429}, {8950,0.0000000}, {9000,0.0003429}, {9050,0.0002286}, {9100,0.0004571}, {9150,0.0000000}, {9200,0.0004571}, {9250,0.0003429}, {9300,0.0002286}, {9350,0.0000000}, {9400,0.0002286}, {9450,0.0002286}, {9500,0.0000000}, {9550,0.0001143}, {9600,0.0002286}, {9650,0.0002000}, {9700,0.0002286}, {9750,0.0003429}, {9800,0.0000857}, {9850,0.0000000}, {9900,0.0004571}, {9950,0.0003429}, {10000,0.0001143}, {10100,0.0002000}, {10200,0.0003143}, {10300,0.0001143}, {10400,0.0004571}, {10500,0.0004571}, {10600,0.0002286}, {10700,0.0001143}, {10800,0.0001143}, {10900,0.0001143}, {11000,0.0003429}, {11100,0.0003143}, {11200,0.0002286}, {11300,0.0002286}, {11400,0.0003429}, {11500,0.0002286}, {11600,0.0001143}, {11700,0.0001143}, {11800,0.0001143}, {11900,0.0001143}, {12000,0.0002286}, {12100,0.0004286}, {12200,0.0003143}, {12300,0.0000000}, {12400,0.0005429}, {12500,0.0003429}, {12600,0.0004571}, {12700,0.0003429}, {12800,0.0003429}, {12900,0.0002286}, {13000,0.0002286}, {13100,0.0002286}, {13200,0.0002000}, {13300,0.0002286}, {13400,0.0003143}, {13500,0.0001143}, {13600,0.0002286}, {13700,0.0000000}, {13800,0.0005714}, {13900,0.0001143}, {14000,0.0001143}, {14100,0.0004286}, {14200,0.0005714}, {14300,0.0000000}, {14400,0.0004571}, {14500,0.0001143}, {14600,0.0000000}, {14700,0.0010286}, {14800,0.0004571}, {14900,0.0000000}, {15000,0.0004571}, {15100,0.0006857}, {15200,0.0007714}, {15300,0.0003429}, {15400,0.0002286}, {15500,0.0003429}, {15600,0.0003143}, {15700,0.0006571}, {15800,0.0003143}, {15900,0.0004286}, {16000,0.0003429}, {16100,0.0001143}, {16200,0.0004571}, {16300,0.0002286}, {16400,0.0002286}, {16500,0.0008857}, {16600,0.0001143}, {16700,0.0001143}, {16800,0.0003429}, {16900,0.0002286}, {17000,0.0005714}, {17100,0.0004571}, {17200,0.0003429}, {17300,0.0000000}, {17400,0.0002286}, {17500,0.0003429}, {17600,0.0003429}, {17700,0.0002286}, {17800,0.0008000}, {17900,0.0003429}, {18000,0.0000000}, {18100,0.0001143}, {18200,0.0006857}, {18300,0.0002286}, {18400,0.0000000}, {18500,0.0003143}, {18600,0.0004571}, {18700,0.0002286}, {18800,0.0034000}, {18900,0.0002286}, {19000,0.0001143}, {19100,0.0001143}, {19200,0.0086000}, {19300,0.0091429}, {19400,0.0001714}, {19500,0.0001143}, {19600,0.0000857}, {19700,0.0002286}, {19800,0.0001143}, {19900,0.0003429}, {20000,0.0003429}};
data["big_flat"]["LtacTCExplicitCtx"]["Aggregate"]["real"] = {{1,0.00100000}, {2,0.00100000}, {3,0.00100000}, {4,0.00101980}, {5,0.00100000}, {6,0.00101980}, {7,0.00131683}, {8,0.00200000}, {9,0.00200000}, {10,0.00200000}, {11,0.00200000}, {12,0.00201980}, {13,0.00224752}, {14,0.00242574}, {15,0.00300000}, {16,0.00300000}, {17,0.00300000}, {18,0.00301980}, {19,0.00307921}, {20,0.00329703}, {21,0.00364356}, {22,0.00400000}, {23,0.00400000}, {24,0.00400000}, {25,0.00403960}, {26,0.00506931}, {27,0.00428713}, {28,0.00477228}, {29,0.00610891}, {30,0.00500000}, {31,0.00503960}, {32,0.00515842}, {33,0.00531683}, {34,0.00534653}, {35,0.00580198}, {36,0.00600000}, {37,0.00600990}, {38,0.00607921}, {39,0.00637624}, {40,0.00626733}, {41,0.00649505}, {42,0.00674257}, {43,0.00700000}, {44,0.00700990}, {45,0.00716832}, {46,0.00717822}, {47,0.00736634}, {48,0.00737624}, {49,0.00779208}, {50,0.00800990}, {51,0.00808911}, {52,0.00815842}, {53,0.00908911}, {54,0.00847525}, {55,0.00833663}, {56,0.00873267}, {57,0.00901980}, {58,0.00933663}, {59,0.00923762}, {60,0.00928713}, {61,0.01219802}, {62,0.00941584}, {63,0.00983168}, {64,0.01209901}, {65,0.01020792}, {66,0.01022772}, {67,0.01011881}, {68,0.01037624}, {69,0.01045545}, {70,0.01069307}, {71,0.01220792}, {72,0.01118812}, {73,0.01117822}, {74,0.01115842}, {75,0.01130693}, {76,0.01148515}, {77,0.01185149}, {78,0.01217822}, {79,0.01219802}, {80,0.01213861}, {81,0.01296040}, {82,0.01301980}, {83,0.01253465}, {84,0.01270297}, {85,0.01313861}, {86,0.01310891}, {87,0.01321782}, {88,0.01313861}, {89,0.01333663}, {90,0.01346535}, {91,0.01383168}, {92,0.01522772}, {93,0.01658416}, {94,0.01748515}, {95,0.01822772}, {96,0.01817822}, {97,0.01843564}, {98,0.01823762}, {99,0.01755446}, {100,0.01641584}, {101,0.01529703}, {102,0.01520792}, {103,0.01547525}, {104,0.01543564}, {105,0.01587129}, {106,0.01601980}, {107,0.01623762}, {108,0.01627723}, {109,0.01655446}, {110,0.02186139}, {111,0.01728713}, {112,0.01661386}, {113,0.01697030}, {114,0.01715842}, {115,0.01722772}, {116,0.02256436}, {117,0.01741584}, {118,0.01769307}, {119,0.01792079}, {120,0.01817822}, {121,0.01997030}, {122,0.01832673}, {123,0.01862376}, {124,0.01872277}, {125,0.01871287}, {126,0.01900000}, {127,0.01918812}, {128,0.02187129}, {129,0.01942574}, {130,0.01936634}, {131,0.02341584}, {132,0.01962376}, {133,0.02000990}, {134,0.02111881}, {135,0.02028713}, {136,0.02037624}, {137,0.02044554}, {138,0.02046535}, {139,0.02215842}, {140,0.02083168}, {141,0.02645545}, {142,0.02138614}, {143,0.02156436}, {144,0.02138614}, {145,0.02164356}, {146,0.02154455}, {147,0.02205941}, {148,0.02214851}, {149,0.02247525}, {150,0.02232673}, {151,0.02382178}, {152,0.02251485}, {153,0.02739604}, {154,0.02316832}, {155,0.02381188}, {156,0.02357426}, {157,0.02359406}, {158,0.03200990}, {159,0.02393069}, {160,0.02345545}, {161,0.02404950}, {162,0.02412871}, {163,0.02580198}, {164,0.02451485}, {165,0.02472277}, {166,0.02604950}, {167,0.02525743}, {168,0.02522772}, {169,0.02522772}, {170,0.03123762}, {171,0.02556436}, {172,0.02567327}, {173,0.02574257}, {174,0.03250495}, {175,0.02627723}, {176,0.02602970}, {177,0.02634653}, {178,0.02837624}, {179,0.03441584}, {180,0.02662376}, {181,0.02718812}, {182,0.02701980}, {183,0.02723762}, {184,0.02832673}, {185,0.03283168}, {186,0.03636634}, {187,0.02795050}, {188,0.02785149}, {189,0.02828713}, {190,0.02826733}, {191,0.02857426}, {192,0.02832673}, {193,0.02846535}, {194,0.02854455}, {195,0.02886139}, {196,0.02881188}, {197,0.02909901}, {198,0.02921782}, {199,0.02941584}, {200,0.02927723}, {201,0.02951485}, {202,0.02982178}, {203,0.03022772}, {204,0.03031683}, {205,0.03040594}, {206,0.03064356}, {207,0.03081188}, {208,0.03060396}, {209,0.04332673}, {210,0.03874257}, {211,0.03410891}, {212,0.03121782}, {213,0.03185149}, {214,0.03171287}, {215,0.03193069}, {216,0.04082178}, {217,0.03503960}, {218,0.03206931}, {219,0.03261386}, {220,0.03269307}, {221,0.04002970}, {222,0.03275248}, {223,0.03307921}, {224,0.03321782}, {225,0.04049505}, {226,0.03320792}, {227,0.03385149}, {228,0.04667327}, {229,0.03622772}, {230,0.03400990}, {231,0.03461386}, {232,0.03702970}, {233,0.03427723}, {234,0.03584158}, {235,0.03610891}, {236,0.03478218}, {237,0.04296040}, {238,0.03526733}, {239,0.03556436}, {240,0.03697030}, {241,0.03582178}, {242,0.04119802}, {243,0.03600990}, {244,0.04442574}, {245,0.03651485}, {246,0.04639604}, {247,0.03652475}, {248,0.04853465}, {249,0.03679208}, {250,0.04843564}, {251,0.03719802}, {252,0.04726733}, {253,0.03767327}, {254,0.04427723}, {255,0.03798020}, {256,0.03963366}, {257,0.03798020}, {258,0.03772277}, {259,0.04787129}, {260,0.03826733}, {261,0.04098020}, {262,0.04002970}, {263,0.03896040}, {264,0.04405941}, {265,0.03914851}, {266,0.03903960}, {267,0.04436634}, {268,0.03974257}, {269,0.03985149}, {270,0.04267327}, {271,0.05398020}, {272,0.04045545}, {273,0.04018812}, {274,0.04616832}, {275,0.05200990}, {276,0.04100990}, {277,0.04097030}, {278,0.04239604}, {279,0.04873267}, {280,0.05464356}, {281,0.04188119}, {282,0.04154455}, {283,0.04186139}, {284,0.04495050}, {285,0.04917822}, {286,0.05297030}, {287,0.04419802}, {288,0.04261386}, {289,0.04268317}, {290,0.04300000}, {291,0.04322772}, {292,0.04321782}, {293,0.04426733}, {294,0.04587129}, {295,0.04695050}, {296,0.04781188}, {297,0.04900000}, {298,0.04929703}, {299,0.04958416}, {300,0.04928713}, {301,0.04768317}, {302,0.05078218}, {303,0.04947525}, {304,0.04756436}, {305,0.04615842}, {306,0.04531683}, {307,0.04533663}, {308,0.04543564}, {309,0.04648515}, {310,0.04593069}, {311,0.05974257}, {312,0.05590099}, {313,0.05244554}, {314,0.04825743}, {315,0.04681188}, {316,0.04711881}, {317,0.04900990}, {318,0.05723762}, {319,0.05218812}, {320,0.04708911}, {321,0.04733663}, {322,0.06168317}, {323,0.05571287}, {324,0.04972277}, {325,0.04804950}, {326,0.04989109}, {327,0.05589109}, {328,0.04838614}, {329,0.04854455}, {330,0.05903960}, {331,0.05287129}, {332,0.04900000}, {333,0.06666337}, {334,0.05228713}, {335,0.05032673}, {336,0.06038614}, {337,0.05111881}, {338,0.04996040}, {339,0.05727723}, {340,0.05003960}, {341,0.06217822}, {342,0.05216832}, {343,0.05254455}, {344,0.05436634}, {345,0.05122772}, {346,0.05679208}, {347,0.05159406}, {348,0.05839604}, {349,0.05153465}, {350,0.05863366}, {351,0.05234653}, {352,0.05742574}, {353,0.05241584}, {354,0.05635644}, {355,0.05273267}, {356,0.05421782}, {357,0.07112871}, {358,0.05307921}, {359,0.06475248}, {360,0.05298020}, {361,0.05681188}, {362,0.06814851}, {363,0.05364356}, {364,0.06041584}, {365,0.06997030}, {366,0.05388119}, {367,0.06112871}, {368,0.06990099}, {369,0.05451485}, {370,0.05930693}, {371,0.06683168}, {372,0.05515842}, {373,0.05657426}, {374,0.06199010}, {375,0.06864356}, {376,0.05550495}, {377,0.05600000}, {378,0.06100000}, {379,0.06653465}, {380,0.07891089}, {381,0.05654455}, {382,0.05656436}, {383,0.06063366}, {384,0.06447525}, {385,0.07019802}, {386,0.07459406}, {387,0.05704950}, {388,0.05693069}, {389,0.05843564}, {390,0.06065347}, {391,0.06326733}, {392,0.06553465}, {393,0.06710891}, {394,0.06949505}, {395,0.07152475}, {396,0.07242574}, {397,0.07383168}, {398,0.07443564}, {399,0.07726733}, {400,0.08314851}, {401,0.07822772}, {402,0.07801980}, {403,0.07774257}, {404,0.07290099}, {405,0.07492079}, {406,0.07342574}, {407,0.07195050}, {408,0.06900000}, {409,0.06605941}, {410,0.06434653}, {411,0.06252475}, {412,0.06063366}, {413,0.06124752}, {414,0.06267327}, {415,0.07405941}, {416,0.07237624}, {417,0.07041584}, {418,0.06387129}, {419,0.06173267}, {420,0.06366337}, {421,0.07686139}, {422,0.06986139}, {423,0.06438614}, {424,0.06213861}, {425,0.07922772}, {426,0.07167327}, {427,0.06541584}, {428,0.06327723}, {429,0.07725743}, {430,0.06901980}, {431,0.06414851}, {432,0.07864356}, {433,0.07306931}, {434,0.06406931}, {435,0.08613861}, {436,0.07220792}, {437,0.06489109}, {438,0.08072277}, {439,0.06893069}, {440,0.06495050}, {441,0.07543564}, {442,0.06528713}, {443,0.07891089}, {444,0.06732673}, {445,0.08134653}, {446,0.06999010}, {447,0.08328713}, {448,0.07124752}, {449,0.06839604}, {450,0.07456436}, {451,0.06713861}, {452,0.07568317}, {453,0.06914851}, {454,0.07464356}, {455,0.08800990}, {456,0.07172277}, {457,0.08447525}, {458,0.06879208}, {459,0.08102970}, {460,0.06800990}, {461,0.07556436}, {462,0.08512871}, {463,0.07007921}, {464,0.07908911}, {465,0.07039604}, {466,0.07363366}, {467,0.08815842}, {468,0.06866337}, {469,0.07371287}, {470,0.08271287}, {471,0.09084158}, {472,0.07086139}, {473,0.07963366}, {474,0.08575248}, {475,0.07013861}, {476,0.07281188}, {477,0.07989109}, {478,0.08505941}, {479,0.09078218}, {480,0.07061386}, {481,0.07843564}, {482,0.08555446}, {483,0.08853465}, {484,0.09332673}, {485,0.07159406}, {486,0.07414851}, {487,0.07786139}, {488,0.08150495}, {489,0.08441584}, {490,0.08714851}, {491,0.08986139}, {492,0.09223762}, {493,0.07323762}, {494,0.07367327}, {495,0.07452475}, {496,0.07464356}, {497,0.07622772}, {498,0.07686139}, {499,0.07803960}, {500,0.07811881}, {505,0.07920792}, {510,0.07786139}, {515,0.07552475}, {520,0.09740594}, {525,0.09362376}, {530,0.09044554}, {535,0.08195050}, {540,0.10104950}, {545,0.09034653}, {550,0.10593069}, {555,0.09271287}, {560,0.10301980}, {565,0.09012871}, {570,0.09869307}, {575,0.10333663}, {580,0.09068317}, {585,0.09967327}, {590,0.10165347}, {595,0.10567327}, {600,0.10668317}, {605,0.10565347}, {610,0.10494059}, {615,0.10383168}, {620,0.09909901}, {625,0.09894059}, {630,0.11917822}, {635,0.11207921}, {640,0.10154455}, {645,0.11795050}, {650,0.10684158}, {655,0.12000990}, {660,0.10756436}, {665,0.12830693}, {670,0.10540594}, {675,0.11155446}, {680,0.12073267}, {685,0.12527723}, {690,0.10630693}, {695,0.10903960}, {700,0.11437624}, {705,0.11278218}, {710,0.11261386}, {715,0.11255446}, {720,0.13131683}, {725,0.12916832}, {730,0.12138614}, {735,0.11951485}, {740,0.13778218}, {745,0.12707921}, {750,0.13969307}, {755,0.12875248}, {760,0.13517822}, {765,0.12924752}, {770,0.13280198}, {775,0.14691089}, {780,0.12712871}, {785,0.13391089}, {790,0.14977228}, {795,0.14782178}, {800,0.14806931}, {805,0.14735644}, {810,0.14698020}, {815,0.14619802}, {820,0.14688119}, {825,0.14252475}, {830,0.13588119}, {835,0.15242574}, {840,0.14538614}, {845,0.14000000}, {850,0.15268317}, {855,0.14373267}, {860,0.15310891}, {865,0.13800990}, {870,0.15535644}, {875,0.16169307}, {880,0.14201980}, {885,0.14874257}, {890,0.16381188}, {895,0.16247525}, {900,0.15976238}, {905,0.15836634}, {910,0.15833663}, {915,0.16929703}, {920,0.15957426}, {925,0.15367327}, {930,0.14938614}, {935,0.16556436}, {940,0.16216832}, {945,0.15346535}, {950,0.16566337}, {955,0.15551485}, {960,0.17938614}, {965,0.15863366}, {970,0.16832673}, {975,0.17265347}, {980,0.19944554}, {985,0.16669307}, {990,0.17208911}, {995,0.17124752}, {1000,0.18986139}, {1010,0.18257426}, {1020,0.17649505}, {1030,0.17285149}, {1040,0.17367327}, {1050,0.18862376}, {1060,0.17575248}, {1070,0.18812871}, {1080,0.20313861}, {1090,0.18254455}, {1100,0.18554455}, {1110,0.19413861}, {1120,0.19057426}, {1130,0.18714851}, {1140,0.21548515}, {1150,0.20311881}, {1160,0.21031683}, {1170,0.19963366}, {1180,0.21621782}, {1190,0.21683168}, {1200,0.21351485}, {1210,0.20904950}, {1220,0.22741584}, {1230,0.22177228}, {1240,0.22370297}, {1250,0.20987129}, {1260,0.23526733}, {1270,0.21603960}, {1280,0.21961386}, {1290,0.24314851}, {1300,0.23983168}, {1310,0.23725743}, {1320,0.24687129}, {1330,0.23656436}, {1340,0.22945545}, {1350,0.23050495}, {1360,0.23916832}, {1370,0.23871287}, {1380,0.24048515}, {1390,0.24473267}, {1400,0.26053465}, {1410,0.24998020}, {1420,0.27661386}, {1430,0.25552475}, {1440,0.24566337}, {1450,0.24854455}, {1460,0.25442574}, {1470,0.27677228}, {1480,0.25318812}, {1490,0.26541584}, {1500,0.26949505}, {1510,0.26641584}, {1520,0.27595050}, {1530,0.26590099}, {1540,0.26718812}, {1550,0.27904950}, {1560,0.29601980}, {1570,0.28695050}, {1580,0.26469307}, {1590,0.28489109}, {1600,0.28213861}, {1610,0.29373267}, {1620,0.28701980}, {1630,0.29093069}, {1640,0.28119802}, {1650,0.28070297}, {1660,0.29223762}, {1670,0.28460396}, {1680,0.29017822}, {1690,0.30266337}, {1700,0.30489109}, {1710,0.31084158}, {1720,0.30782178}, {1730,0.31258416}, {1740,0.30196040}, {1750,0.30330693}, {1760,0.33328713}, {1770,0.30797030}, {1780,0.34280198}, {1790,0.32082178}, {1800,0.33721782}, {1810,0.30926733}, {1820,0.32104950}, {1830,0.32836634}, {1840,0.33090099}, {1850,0.31322772}, {1860,0.34220792}, {1870,0.34031683}, {1880,0.33613861}, {1890,0.33290099}, {1900,0.32677228}, {1910,0.33704950}, {1920,0.35234653}, {1930,0.33188119}, {1940,0.36161386}, {1950,0.34608911}, {1960,0.34293069}, {1970,0.37955446}, {1980,0.33862376}, {1990,0.35425743}, {2000,0.34772277}, {2050,0.36036634}, {2100,0.39321782}, {2150,0.38211881}, {2200,0.38794059}, {2250,0.40375248}, {2300,0.40319802}, {2350,0.41306931}, {2400,0.43320792}, {2450,0.45534653}, {2500,0.43726733}, {2550,0.46260396}, {2600,0.45447525}, {2650,0.47260396}, {2700,0.48875248}, {2750,0.50978218}, {2800,0.54498020}, {2850,1.49529703}, {2900,0.50783168}, {2950,0.51547525}, {3000,0.53765347}, {3050,0.55674257}, {3100,0.56521782}, {3150,0.57375248}, {3200,0.56140594}, {3250,0.57823762}, {3300,0.59485149}, {3350,0.60926733}, {3400,0.59877228}, {3450,0.61824752}, {3500,0.62913861}, {3550,0.64545545}, {3600,0.66154455}, {3650,0.67821782}, {3700,0.69361386}, {3750,0.68443564}, {3800,0.69680198}, {3850,0.70574257}, {3900,0.69789109}, {3950,0.71544554}, {4000,0.74803960}, {4050,0.73740594}, {4100,0.73632673}, {4150,0.75293069}, {4200,0.78377228}, {4250,0.78288119}, {4300,0.77372277}, {4350,0.80834653}, {4400,0.81441584}, {4450,0.81687129}, {4500,0.82192079}, {4550,0.83591089}, {4600,0.83958416}, {4650,0.86811881}, {4700,0.84847525}, {4750,0.86873267}, {4800,0.87405941}, {4850,0.89926733}, {4900,0.89150495}, {4950,0.91557426}, {5000,0.91502970}, {5050,0.94233663}, {5100,0.95628713}, {5150,0.97132673}, {5200,0.94780198}, {5250,0.98389109}, {5300,0.96941584}, {5350,0.98659406}, {5400,1.00664356}, {5450,1.02317822}, {5500,1.02277228}, {5550,1.01522772}, {5600,1.02912871}, {5650,1.04358416}, {5700,1.08306931}, {5750,1.05450495}, {5800,1.07028713}, {5850,1.11931683}, {5900,1.09045545}, {5950,1.10928713}, {6000,1.11252475}, {6050,1.1860000}, {6100,1.2053429}, {6150,1.2002286}, {6200,1.2031714}, {6250,1.2396857}, {6300,1.2252571}, {6350,1.2305714}, {6400,1.2280000}, {6450,1.2617429}, {6500,1.2849429}, {6550,1.2968000}, {6600,1.2919429}, {6650,1.3180000}, {6700,1.3452000}, {6750,1.3525714}, {6800,1.3445143}, {6850,1.3675714}, {6900,1.3745714}, {6950,1.3929429}, {7000,1.3876571}, {7050,1.4031143}, {7100,1.4064286}, {7150,1.4138000}, {7200,1.4007143}, {7250,1.4152000}, {7300,1.4170000}, {7350,1.4114000}, {7400,1.4299143}, {7450,1.4617429}, {7500,1.4816571}, {7550,1.5037143}, {7600,1.5237714}, {7650,1.5240571}, {7700,1.5070000}, {7750,1.5073143}, {7800,1.5169429}, {7850,1.5820571}, {7900,1.5797714}, {7950,1.5955714}, {8000,1.5639714}, {8050,1.5840000}, {8100,1.5680000}, {8150,1.6274286}, {8200,1.6112000}, {8250,1.6210571}, {8300,1.6232571}, {8350,1.6549714}, {8400,1.6543714}, {8450,1.6508000}, {8500,1.6495714}, {8550,1.7023714}, {8600,1.7182286}, {8650,1.7028286}, {8700,1.7190571}, {8750,1.7507429}, {8800,1.7400000}, {8850,1.7015429}, {8900,1.7903714}, {8950,1.7896000}, {9000,1.7514000}, {9050,1.8067714}, {9100,1.8103143}, {9150,1.7993429}, {9200,1.8681714}, {9250,1.8285143}, {9300,1.8996286}, {9350,1.8716000}, {9400,1.8656571}, {9450,1.8973429}, {9500,1.8711714}, {9550,1.9084286}, {9600,1.9119714}, {9650,1.9101714}, {9700,1.9307714}, {9750,1.9099714}, {9800,1.9588000}, {9850,1.9272571}, {9900,1.9844571}, {9950,1.9712000}, {10000,2.0074286}, {10100,2.0319429}, {10200,2.0531429}, {10300,2.0289429}, {10400,2.0740286}, {10500,2.0220857}, {10600,2.0997143}, {10700,2.0752571}, {10800,2.1617143}, {10900,2.1210571}, {11000,2.2024286}, {11100,2.1436286}, {11200,2.2090000}, {11300,2.2256000}, {11400,2.2394571}, {11500,2.3175143}, {11600,2.2784857}, {11700,2.3668000}, {11800,2.3365714}, {11900,2.3665143}, {12000,2.4010857}, {12100,2.3978857}, {12200,2.4225429}, {12300,2.4328571}, {12400,2.4641714}, {12500,2.4792000}, {12600,2.5784286}, {12700,2.5274286}, {12800,2.5066000}, {12900,2.5536286}, {13000,2.5841143}, {13100,2.6080286}, {13200,2.6206000}, {13300,2.6333714}, {13400,2.6788286}, {13500,2.7179429}, {13600,2.7209143}, {13700,2.6951143}, {13800,2.7341714}, {13900,2.7531143}, {14000,2.8322000}, {14100,2.7824286}, {14200,2.8371143}, {14300,2.8885143}, {14400,3.1149714}, {14500,3.0810571}, {14600,2.9130000}, {14700,2.9286286}, {14800,2.9175429}, {14900,2.9284571}, {15000,2.9719143}, {15100,3.0229714}, {15200,3.0164000}, {15300,3.0362000}, {15400,3.1442571}, {15500,3.2169429}, {15600,3.2735143}, {15700,3.1614000}, {15800,3.4165714}, {15900,3.1602857}, {16000,3.4832000}, {16100,3.2211714}, {16200,3.1945429}, {16300,3.3186000}, {16400,3.2966286}, {16500,3.2971143}, {16600,3.2850857}, {16700,3.2805429}, {16800,3.2691143}, {16900,3.4022000}, {17000,3.4587714}, {17100,3.4726857}, {17200,3.3748286}, {17300,3.4320000}, {17400,3.4397714}, {17500,3.4890000}, {17600,3.5325714}, {17700,3.5798571}, {17800,3.5584000}, {17900,3.6568857}, {18000,3.6362000}, {18100,3.8065429}, {18200,3.5962286}, {18300,3.7507714}, {18400,3.7438286}, {18500,3.6868000}, {18600,3.9730571}, {18700,3.7516571}, {18800,3.8130000}, {18900,3.8206000}, {19000,3.7613143}, {19100,3.7765714}, {19200,3.8035429}, {19300,3.8597714}, {19400,3.8705714}, {19500,4.0353429}, {19600,3.9500857}, {19700,4.2498000}, {19800,4.2911143}, {19900,4.0184286}, {20000,4.1507714}};
data["big_flat"]["LtacTCExplicitCtx"]["Aggregate"]["user"] = {{1,0.00066337}, {2,0.00138614}, {3,0.00098020}, {4,0.00122772}, {5,0.00156436}, {6,0.00146535}, {7,0.00145545}, {8,0.00189109}, {9,0.00223762}, {10,0.00213861}, {11,0.00242574}, {12,0.00220792}, {13,0.00235644}, {14,0.00280198}, {15,0.00267327}, {16,0.00263366}, {17,0.00324752}, {18,0.00324752}, {19,0.00342574}, {20,0.00345545}, {21,0.00368317}, {22,0.00359406}, {23,0.00379208}, {24,0.00410891}, {25,0.00369307}, {26,0.00500990}, {27,0.00429703}, {28,0.00467327}, {29,0.00635644}, {30,0.00519802}, {31,0.00494059}, {32,0.00518812}, {33,0.00600000}, {34,0.00583168}, {35,0.00599010}, {36,0.00588119}, {37,0.00639604}, {38,0.00647525}, {39,0.00668317}, {40,0.00663366}, {41,0.00704950}, {42,0.00703960}, {43,0.00741584}, {44,0.00740594}, {45,0.00742574}, {46,0.00763366}, {47,0.00802970}, {48,0.00797030}, {49,0.00815842}, {50,0.00813861}, {51,0.00828713}, {52,0.00834653}, {53,0.00934653}, {54,0.00891089}, {55,0.00879208}, {56,0.00918812}, {57,0.00907921}, {58,0.00971287}, {59,0.00898020}, {60,0.00942574}, {61,0.01218812}, {62,0.00932673}, {63,0.00956436}, {64,0.01192079}, {65,0.01008911}, {66,0.01001980}, {67,0.01013861}, {68,0.01054455}, {69,0.01089109}, {70,0.01073267}, {71,0.01253465}, {72,0.01113861}, {73,0.01164356}, {74,0.01133663}, {75,0.01149505}, {76,0.01174257}, {77,0.01194059}, {78,0.01223762}, {79,0.01258416}, {80,0.01224752}, {81,0.01328713}, {82,0.01306931}, {83,0.01306931}, {84,0.01311881}, {85,0.01323762}, {86,0.01346535}, {87,0.01344554}, {88,0.01334653}, {89,0.01394059}, {90,0.01428713}, {91,0.01449505}, {92,0.01564356}, {93,0.01695050}, {94,0.01738614}, {95,0.01805941}, {96,0.01789109}, {97,0.01830693}, {98,0.01810891}, {99,0.01768317}, {100,0.01694059}, {101,0.01555446}, {102,0.01548515}, {103,0.01600990}, {104,0.01585149}, {105,0.01602970}, {106,0.01640594}, {107,0.01661386}, {108,0.01642574}, {109,0.01679208}, {110,0.02177228}, {111,0.01741584}, {112,0.01693069}, {113,0.01693069}, {114,0.01674257}, {115,0.01740594}, {116,0.02263366}, {117,0.01757426}, {118,0.01765347}, {119,0.01765347}, {120,0.01778218}, {121,0.01943564}, {122,0.01826733}, {123,0.01861386}, {124,0.01819802}, {125,0.01850495}, {126,0.01889109}, {127,0.01871287}, {128,0.02179208}, {129,0.01911881}, {130,0.01903960}, {131,0.02315842}, {132,0.01939604}, {133,0.01967327}, {134,0.02119802}, {135,0.01987129}, {136,0.01980198}, {137,0.02007921}, {138,0.02005941}, {139,0.02202970}, {140,0.02069307}, {141,0.02623762}, {142,0.02127723}, {143,0.02111881}, {144,0.02118812}, {145,0.02131683}, {146,0.02163366}, {147,0.02202970}, {148,0.02197030}, {149,0.02248515}, {150,0.02228713}, {151,0.02402970}, {152,0.02222772}, {153,0.02731683}, {154,0.02318812}, {155,0.02374257}, {156,0.02348515}, {157,0.02399010}, {158,0.03228713}, {159,0.02399010}, {160,0.02353465}, {161,0.02403960}, {162,0.02426733}, {163,0.02542574}, {164,0.02473267}, {165,0.02491089}, {166,0.02583168}, {167,0.02519802}, {168,0.02548515}, {169,0.02509901}, {170,0.03124752}, {171,0.02549505}, {172,0.02560396}, {173,0.02550495}, {174,0.03258416}, {175,0.02600990}, {176,0.02588119}, {177,0.02621782}, {178,0.02805941}, {179,0.03422772}, {180,0.02695050}, {181,0.02706931}, {182,0.02688119}, {183,0.02692079}, {184,0.02809901}, {185,0.03310891}, {186,0.03614851}, {187,0.02809901}, {188,0.02790099}, {189,0.02844554}, {190,0.02802970}, {191,0.02869307}, {192,0.02834653}, {193,0.02840594}, {194,0.02828713}, {195,0.02887129}, {196,0.02852475}, {197,0.02941584}, {198,0.02915842}, {199,0.02942574}, {200,0.02928713}, {201,0.02943564}, {202,0.02988119}, {203,0.03042574}, {204,0.02993069}, {205,0.03039604}, {206,0.03098020}, {207,0.03070297}, {208,0.03089109}, {209,0.04325743}, {210,0.03853465}, {211,0.03412871}, {212,0.03157426}, {213,0.03201980}, {214,0.03200990}, {215,0.03222772}, {216,0.04019802}, {217,0.03493069}, {218,0.03236634}, {219,0.03287129}, {220,0.03314851}, {221,0.03950495}, {222,0.03348515}, {223,0.03326733}, {224,0.03347525}, {225,0.03986139}, {226,0.03302970}, {227,0.03394059}, {228,0.04638614}, {229,0.03601980}, {230,0.03448515}, {231,0.03436634}, {232,0.03684158}, {233,0.03420792}, {234,0.03605941}, {235,0.03592079}, {236,0.03472277}, {237,0.04300990}, {238,0.03546535}, {239,0.03585149}, {240,0.03697030}, {241,0.03608911}, {242,0.04087129}, {243,0.03601980}, {244,0.04434653}, {245,0.03647525}, {246,0.04613861}, {247,0.03655446}, {248,0.04845545}, {249,0.03695050}, {250,0.04875248}, {251,0.03706931}, {252,0.04743564}, {253,0.03744554}, {254,0.04416832}, {255,0.03755446}, {256,0.03908911}, {257,0.03776238}, {258,0.03738614}, {259,0.04772277}, {260,0.03793069}, {261,0.04052475}, {262,0.03961386}, {263,0.03842574}, {264,0.04403960}, {265,0.03854455}, {266,0.03860396}, {267,0.04421782}, {268,0.03910891}, {269,0.03934653}, {270,0.04252475}, {271,0.05332673}, {272,0.04011881}, {273,0.03978218}, {274,0.04604950}, {275,0.05155446}, {276,0.04047525}, {277,0.04056436}, {278,0.04199010}, {279,0.04867327}, {280,0.05448515}, {281,0.04138614}, {282,0.04088119}, {283,0.04158416}, {284,0.04448515}, {285,0.04900000}, {286,0.05283168}, {287,0.04419802}, {288,0.04249505}, {289,0.04234653}, {290,0.04272277}, {291,0.04309901}, {292,0.04322772}, {293,0.04409901}, {294,0.04604950}, {295,0.04656436}, {296,0.04763366}, {297,0.04867327}, {298,0.04903960}, {299,0.04931683}, {300,0.04927723}, {301,0.04761386}, {302,0.05048515}, {303,0.04955446}, {304,0.04754455}, {305,0.04596040}, {306,0.04512871}, {307,0.04529703}, {308,0.04516832}, {309,0.04690099}, {310,0.04572277}, {311,0.05982178}, {312,0.05598020}, {313,0.05205941}, {314,0.04804950}, {315,0.04692079}, {316,0.04720792}, {317,0.04915842}, {318,0.05746535}, {319,0.05135644}, {320,0.04694059}, {321,0.04724752}, {322,0.06169307}, {323,0.05549505}, {324,0.04935644}, {325,0.04789109}, {326,0.04985149}, {327,0.05578218}, {328,0.04852475}, {329,0.04841584}, {330,0.05881188}, {331,0.05226733}, {332,0.04883168}, {333,0.06649505}, {334,0.05188119}, {335,0.05015842}, {336,0.06030693}, {337,0.05104950}, {338,0.04954455}, {339,0.05690099}, {340,0.04980198}, {341,0.06180198}, {342,0.05189109}, {343,0.05211881}, {344,0.05391089}, {345,0.05079208}, {346,0.05672277}, {347,0.05145545}, {348,0.05824752}, {349,0.05131683}, {350,0.05844554}, {351,0.05231683}, {352,0.05717822}, {353,0.05229703}, {354,0.05572277}, {355,0.05268317}, {356,0.05376238}, {357,0.07089109}, {358,0.05265347}, {359,0.06402970}, {360,0.05265347}, {361,0.05652475}, {362,0.06787129}, {363,0.05317822}, {364,0.06084158}, {365,0.07010891}, {366,0.05345545}, {367,0.06100000}, {368,0.06961386}, {369,0.05429703}, {370,0.05930693}, {371,0.06680198}, {372,0.05486139}, {373,0.05662376}, {374,0.06210891}, {375,0.06829703}, {376,0.05510891}, {377,0.05597030}, {378,0.06091089}, {379,0.06634653}, {380,0.07859406}, {381,0.05636634}, {382,0.05626733}, {383,0.06067327}, {384,0.06412871}, {385,0.07025743}, {386,0.07474257}, {387,0.05657426}, {388,0.05685149}, {389,0.05828713}, {390,0.06101980}, {391,0.06352475}, {392,0.06517822}, {393,0.06688119}, {394,0.06934653}, {395,0.07152475}, {396,0.07217822}, {397,0.07343564}, {398,0.07421782}, {399,0.07700000}, {400,0.08302970}, {401,0.07800990}, {402,0.07743564}, {403,0.07767327}, {404,0.07242574}, {405,0.07480198}, {406,0.07334653}, {407,0.07159406}, {408,0.06880198}, {409,0.06577228}, {410,0.06425743}, {411,0.06226733}, {412,0.06068317}, {413,0.06112871}, {414,0.06279208}, {415,0.07404950}, {416,0.07246535}, {417,0.07053465}, {418,0.06367327}, {419,0.06157426}, {420,0.06338614}, {421,0.07707921}, {422,0.06971287}, {423,0.06413861}, {424,0.06223762}, {425,0.07899010}, {426,0.07156436}, {427,0.06515842}, {428,0.06331683}, {429,0.07711881}, {430,0.06878218}, {431,0.06427723}, {432,0.07810891}, {433,0.07285149}, {434,0.06396040}, {435,0.08584158}, {436,0.07241584}, {437,0.06470297}, {438,0.08021782}, {439,0.06852475}, {440,0.06462376}, {441,0.07543564}, {442,0.06522772}, {443,0.07877228}, {444,0.06687129}, {445,0.08098020}, {446,0.06952475}, {447,0.08334653}, {448,0.07113861}, {449,0.06775248}, {450,0.07449505}, {451,0.06659406}, {452,0.07542574}, {453,0.06880198}, {454,0.07466337}, {455,0.08773267}, {456,0.07162376}, {457,0.08400000}, {458,0.06851485}, {459,0.08058416}, {460,0.06740594}, {461,0.07558416}, {462,0.08477228}, {463,0.07019802}, {464,0.07907921}, {465,0.07029703}, {466,0.07361386}, {467,0.08780198}, {468,0.06835644}, {469,0.07381188}, {470,0.08278218}, {471,0.09040594}, {472,0.07049505}, {473,0.07900000}, {474,0.08557426}, {475,0.07009901}, {476,0.07257426}, {477,0.07966337}, {478,0.08486139}, {479,0.09036634}, {480,0.07027723}, {481,0.07822772}, {482,0.08551485}, {483,0.08822772}, {484,0.09284158}, {485,0.07135644}, {486,0.07395050}, {487,0.07747525}, {488,0.08143564}, {489,0.08460396}, {490,0.08688119}, {491,0.08983168}, {492,0.09159406}, {493,0.07305941}, {494,0.07342574}, {495,0.07449505}, {496,0.07426733}, {497,0.07585149}, {498,0.07694059}, {499,0.07783168}, {500,0.07743564}, {505,0.07887129}, {510,0.07756436}, {515,0.07538614}, {520,0.09678218}, {525,0.09326733}, {530,0.09046535}, {535,0.08159406}, {540,0.10077228}, {545,0.09014851}, {550,0.10578218}, {555,0.09262376}, {560,0.10274257}, {565,0.08948515}, {570,0.09825743}, {575,0.10292079}, {580,0.09051485}, {585,0.09941584}, {590,0.10124752}, {595,0.10566337}, {600,0.10665347}, {605,0.10525743}, {610,0.10492079}, {615,0.10360396}, {620,0.09899010}, {625,0.09879208}, {630,0.11898020}, {635,0.11152475}, {640,0.10135644}, {645,0.11739604}, {650,0.10679208}, {655,0.11980198}, {660,0.10755446}, {665,0.12801980}, {670,0.10527723}, {675,0.11138614}, {680,0.12035644}, {685,0.12518812}, {690,0.10613861}, {695,0.10908911}, {700,0.11396040}, {705,0.11227723}, {710,0.11253465}, {715,0.11201980}, {720,0.13094059}, {725,0.12872277}, {730,0.12099010}, {735,0.11951485}, {740,0.13745545}, {745,0.12687129}, {750,0.13941584}, {755,0.12864356}, {760,0.13492079}, {765,0.12883168}, {770,0.13279208}, {775,0.14629703}, {780,0.12686139}, {785,0.13352475}, {790,0.14936634}, {795,0.14751485}, {800,0.14788119}, {805,0.14674257}, {810,0.14653465}, {815,0.14589109}, {820,0.14651485}, {825,0.14208911}, {830,0.13570297}, {835,0.15209901}, {840,0.14481188}, {845,0.13976238}, {850,0.15234653}, {855,0.14340594}, {860,0.15252475}, {865,0.13739604}, {870,0.15500000}, {875,0.16116832}, {880,0.14150495}, {885,0.14872277}, {890,0.16367327}, {895,0.16211881}, {900,0.15939604}, {905,0.15787129}, {910,0.15795050}, {915,0.16873267}, {920,0.15924752}, {925,0.15324752}, {930,0.14896040}, {935,0.16518812}, {940,0.16193069}, {945,0.15302970}, {950,0.16535644}, {955,0.15518812}, {960,0.17902970}, {965,0.15830693}, {970,0.16800990}, {975,0.17250495}, {980,0.19887129}, {985,0.16642574}, {990,0.17170297}, {995,0.17077228}, {1000,0.18958416}, {1010,0.18186139}, {1020,0.17621782}, {1030,0.17268317}, {1040,0.17323762}, {1050,0.18819802}, {1060,0.17529703}, {1070,0.18775248}, {1080,0.20265347}, {1090,0.18167327}, {1100,0.18514851}, {1110,0.19360396}, {1120,0.19019802}, {1130,0.18657426}, {1140,0.21487129}, {1150,0.20277228}, {1160,0.20979208}, {1170,0.19920792}, {1180,0.21566337}, {1190,0.21644554}, {1200,0.21298020}, {1210,0.20845545}, {1220,0.22675248}, {1230,0.22136634}, {1240,0.22308911}, {1250,0.20932673}, {1260,0.23455446}, {1270,0.21538614}, {1280,0.21894059}, {1290,0.24178218}, {1300,0.23915842}, {1310,0.23655446}, {1320,0.24584158}, {1330,0.23545545}, {1340,0.22881188}, {1350,0.22977228}, {1360,0.23848515}, {1370,0.23807921}, {1380,0.23974257}, {1390,0.24373267}, {1400,0.25967327}, {1410,0.24949505}, {1420,0.27580198}, {1430,0.25454455}, {1440,0.24488119}, {1450,0.24793069}, {1460,0.25359406}, {1470,0.27598020}, {1480,0.25251485}, {1490,0.26440594}, {1500,0.26862376}, {1510,0.26582178}, {1520,0.27493069}, {1530,0.26511881}, {1540,0.26644554}, {1550,0.27820792}, {1560,0.29519802}, {1570,0.28618812}, {1580,0.26385149}, {1590,0.28393069}, {1600,0.28119802}, {1610,0.29228713}, {1620,0.28622772}, {1630,0.29027723}, {1640,0.28053465}, {1650,0.27992079}, {1660,0.29087129}, {1670,0.28362376}, {1680,0.28935644}, {1690,0.30193069}, {1700,0.30364356}, {1710,0.30965347}, {1720,0.30692079}, {1730,0.31147525}, {1740,0.30117822}, {1750,0.30237624}, {1760,0.33234653}, {1770,0.30710891}, {1780,0.34182178}, {1790,0.31987129}, {1800,0.33592079}, {1810,0.30835644}, {1820,0.32015842}, {1830,0.32671287}, {1840,0.32979208}, {1850,0.31206931}, {1860,0.34078218}, {1870,0.33917822}, {1880,0.33502970}, {1890,0.33212871}, {1900,0.32548515}, {1910,0.33624752}, {1920,0.35162376}, {1930,0.33105941}, {1940,0.36073267}, {1950,0.34487129}, {1960,0.34196040}, {1970,0.37844554}, {1980,0.33765347}, {1990,0.35310891}, {2000,0.34685149}, {2050,0.35911881}, {2100,0.39176238}, {2150,0.38127723}, {2200,0.38702970}, {2250,0.40275248}, {2300,0.40207921}, {2350,0.41168317}, {2400,0.43166337}, {2450,0.45429703}, {2500,0.43593069}, {2550,0.46149505}, {2600,0.45299010}, {2650,0.47144554}, {2700,0.48731683}, {2750,0.50883168}, {2800,0.54390099}, {2850,1.49033663}, {2900,0.50658416}, {2950,0.51444554}, {3000,0.53653465}, {3050,0.55567327}, {3100,0.56117822}, {3150,0.57281188}, {3200,0.56052475}, {3250,0.57720792}, {3300,0.59365347}, {3350,0.60776238}, {3400,0.59771287}, {3450,0.61691089}, {3500,0.62811881}, {3550,0.64444554}, {3600,0.66026733}, {3650,0.67700990}, {3700,0.69192079}, {3750,0.68302970}, {3800,0.69532673}, {3850,0.70434653}, {3900,0.69662376}, {3950,0.71445545}, {4000,0.74583168}, {4050,0.73596040}, {4100,0.73503960}, {4150,0.75181188}, {4200,0.78215842}, {4250,0.78120792}, {4300,0.77203960}, {4350,0.80693069}, {4400,0.81280198}, {4450,0.81534653}, {4500,0.82028713}, {4550,0.83408911}, {4600,0.83779208}, {4650,0.86634653}, {4700,0.84662376}, {4750,0.86715842}, {4800,0.87227723}, {4850,0.89751485}, {4900,0.88976238}, {4950,0.91370297}, {5000,0.91281188}, {5050,0.94025743}, {5100,0.95421782}, {5150,0.96928713}, {5200,0.94576238}, {5250,0.98203960}, {5300,0.96688119}, {5350,0.98458416}, {5400,1.00451485}, {5450,1.02104950}, {5500,1.02069307}, {5550,1.01334653}, {5600,1.02701980}, {5650,1.04106931}, {5700,1.08105941}, {5750,1.05212871}, {5800,1.06831683}, {5850,1.11715842}, {5900,1.08799010}, {5950,1.10719802}, {6000,1.11062376}, {6050,1.1772286}, {6100,1.1955429}, {6150,1.1990000}, {6200,1.2016286}, {6250,1.2330000}, {6300,1.2236571}, {6350,1.2290286}, {6400,1.2268857}, {6450,1.2600857}, {6500,1.2836000}, {6550,1.2952571}, {6600,1.2913714}, {6650,1.3166286}, {6700,1.3443429}, {6750,1.3503714}, {6800,1.3432286}, {6850,1.3649714}, {6900,1.3720857}, {6950,1.3904571}, {7000,1.3836286}, {7050,1.4016857}, {7100,1.4047714}, {7150,1.4126286}, {7200,1.3983143}, {7250,1.4137714}, {7300,1.4156000}, {7350,1.4100571}, {7400,1.4232286}, {7450,1.4524857}, {7500,1.4786571}, {7550,1.5008857}, {7600,1.5140857}, {7650,1.5214857}, {7700,1.4995143}, {7750,1.5040000}, {7800,1.5135143}, {7850,1.5764286}, {7900,1.5657429}, {7950,1.5886857}, {8000,1.5625714}, {8050,1.5823429}, {8100,1.5662000}, {8150,1.6251714}, {8200,1.6088286}, {8250,1.6196286}, {8300,1.6212286}, {8350,1.6535143}, {8400,1.6521143}, {8450,1.6490857}, {8500,1.6478571}, {8550,1.7004857}, {8600,1.7158571}, {8650,1.7003714}, {8700,1.7169143}, {8750,1.7458857}, {8800,1.7384857}, {8850,1.6988857}, {8900,1.7884000}, {8950,1.7869429}, {9000,1.7490571}, {9050,1.8050000}, {9100,1.8087143}, {9150,1.7967429}, {9200,1.8652286}, {9250,1.8234571}, {9300,1.8948286}, {9350,1.8681714}, {9400,1.8628000}, {9450,1.8951143}, {9500,1.8684286}, {9550,1.9060286}, {9600,1.9085714}, {9650,1.9070000}, {9700,1.9276857}, {9750,1.9070286}, {9800,1.9557429}, {9850,1.9243714}, {9900,1.9816571}, {9950,1.9684286}, {10000,2.0040286}, {10100,2.0289714}, {10200,2.0504571}, {10300,2.0255143}, {10400,2.0712286}, {10500,2.0193143}, {10600,2.0970571}, {10700,2.0724286}, {10800,2.1586571}, {10900,2.1178857}, {11000,2.1981143}, {11100,2.1400286}, {11200,2.2052000}, {11300,2.2219714}, {11400,2.2359714}, {11500,2.3139714}, {11600,2.2740000}, {11700,2.3635143}, {11800,2.3324571}, {11900,2.3627714}, {12000,2.3974571}, {12100,2.3941143}, {12200,2.4183429}, {12300,2.4288286}, {12400,2.4595143}, {12500,2.4748286}, {12600,2.5739429}, {12700,2.5234857}, {12800,2.5043143}, {12900,2.5495714}, {13000,2.5805143}, {13100,2.6032571}, {13200,2.6169143}, {13300,2.6294000}, {13400,2.6750571}, {13500,2.7144000}, {13600,2.7176286}, {13700,2.6916571}, {13800,2.7312857}, {13900,2.7499429}, {14000,2.8287429}, {14100,2.7782857}, {14200,2.8330000}, {14300,2.8851143}, {14400,3.1116286}, {14500,3.0771714}, {14600,2.9097429}, {14700,2.9244857}, {14800,2.9135143}, {14900,2.9253143}, {15000,2.9682286}, {15100,3.0192000}, {15200,3.0130286}, {15300,3.0324857}, {15400,3.1402000}, {15500,3.2121714}, {15600,3.2691143}, {15700,3.1561429}, {15800,3.4121714}, {15900,3.1566571}, {16000,3.4788571}, {16100,3.2163429}, {16200,3.1911714}, {16300,3.3146857}, {16400,3.2925714}, {16500,3.2927714}, {16600,3.2827714}, {16700,3.2760000}, {16800,3.2657143}, {16900,3.3994571}, {17000,3.4555714}, {17100,3.4688857}, {17200,3.3713714}, {17300,3.4284571}, {17400,3.4349143}, {17500,3.4854000}, {17600,3.5281143}, {17700,3.5753429}, {17800,3.5547429}, {17900,3.6529714}, {18000,3.6321143}, {18100,3.8015714}, {18200,3.5917143}, {18300,3.7455714}, {18400,3.7388000}, {18500,3.6816000}, {18600,3.9662857}, {18700,3.7473143}, {18800,3.7972857}, {18900,3.8061429}, {19000,3.7450286}, {19100,3.7612000}, {19200,3.7946571}, {19300,3.8534571}, {19400,3.8516857}, {19500,4.0006000}, {19600,3.9301714}, {19700,4.2214286}, {19800,4.2553143}, {19900,4.0143429}, {20000,4.1458286}};
data["big_flat"]["LtacTCExplicitCtx"]["Aggregate"]["system"] = {{1,0.00009901}, {2,0.00003960}, {3,0.00007921}, {4,0.00005941}, {5,0.00006931}, {6,0.00000000}, {7,0.00003960}, {8,0.00005941}, {9,0.00003960}, {10,0.00002970}, {11,0.00003960}, {12,0.00006931}, {13,0.00010891}, {14,0.00003960}, {15,0.00000000}, {16,0.00010891}, {17,0.00003960}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00003960}, {23,0.00003960}, {24,0.00006931}, {25,0.00007921}, {26,0.00008911}, {27,0.00003960}, {28,0.00011881}, {29,0.00000000}, {30,0.00002970}, {31,0.00003960}, {32,0.00000000}, {33,0.00003960}, {34,0.00006931}, {35,0.00000000}, {36,0.00011881}, {37,0.00003960}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003960}, {42,0.00007921}, {43,0.00003960}, {44,0.00003960}, {45,0.00007921}, {46,0.00003960}, {47,0.00000000}, {48,0.00010891}, {49,0.00002970}, {50,0.00002970}, {51,0.00003960}, {52,0.00000000}, {53,0.00002970}, {54,0.00000000}, {55,0.00007921}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00013861}, {60,0.00002970}, {61,0.00011881}, {62,0.00011881}, {63,0.00007921}, {64,0.00009901}, {65,0.00007921}, {66,0.00000000}, {67,0.00009901}, {68,0.00006931}, {69,0.00007921}, {70,0.00007921}, {71,0.00003960}, {72,0.00007921}, {73,0.00010891}, {74,0.00003960}, {75,0.00003960}, {76,0.00006931}, {77,0.00003960}, {78,0.00002970}, {79,0.00002970}, {80,0.00000000}, {81,0.00007921}, {82,0.00007921}, {83,0.00000000}, {84,0.00000000}, {85,0.00003960}, {86,0.00000000}, {87,0.00006931}, {88,0.00006931}, {89,0.00000000}, {90,0.00005941}, {91,0.00006931}, {92,0.00007921}, {93,0.00011881}, {94,0.00011881}, {95,0.00007921}, {96,0.00018812}, {97,0.00003960}, {98,0.00015842}, {99,0.00000000}, {100,0.00003960}, {101,0.00003960}, {102,0.00000000}, {103,0.00000000}, {104,0.00006931}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00003960}, {109,0.00000000}, {110,0.00003960}, {111,0.00000000}, {112,0.00003960}, {113,0.00000000}, {114,0.00000000}, {115,0.00003960}, {116,0.00003960}, {117,0.00007921}, {118,0.00007921}, {119,0.00002970}, {120,0.00000000}, {121,0.00015842}, {122,0.00000000}, {123,0.00003960}, {124,0.00003960}, {125,0.00000000}, {126,0.00003960}, {127,0.00003960}, {128,0.00007921}, {129,0.00000000}, {130,0.00000000}, {131,0.00027723}, {132,0.00000000}, {133,0.00000000}, {134,0.00003960}, {135,0.00003960}, {136,0.00007921}, {137,0.00003960}, {138,0.00003960}, {139,0.00018812}, {140,0.00000000}, {141,0.00015842}, {142,0.00011881}, {143,0.00007921}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00003960}, {148,0.00003960}, {149,0.00007921}, {150,0.00000000}, {151,0.00011881}, {152,0.00006931}, {153,0.00010891}, {154,0.00003960}, {155,0.00015842}, {156,0.00015842}, {157,0.00000000}, {158,0.00003960}, {159,0.00007921}, {160,0.00003960}, {161,0.00006931}, {162,0.00000000}, {163,0.00010891}, {164,0.00002970}, {165,0.00003960}, {166,0.00015842}, {167,0.00011881}, {168,0.00003960}, {169,0.00018812}, {170,0.00022772}, {171,0.00000000}, {172,0.00007921}, {173,0.00007921}, {174,0.00019802}, {175,0.00007921}, {176,0.00000000}, {177,0.00007921}, {178,0.00021782}, {179,0.00027723}, {180,0.00000000}, {181,0.00003960}, {182,0.00007921}, {183,0.00003960}, {184,0.00030693}, {185,0.00019802}, {186,0.00015842}, {187,0.00010891}, {188,0.00003960}, {189,0.00014851}, {190,0.00019802}, {191,0.00000000}, {192,0.00000000}, {193,0.00002970}, {194,0.00007921}, {195,0.00000000}, {196,0.00003960}, {197,0.00007921}, {198,0.00003960}, {199,0.00009901}, {200,0.00003960}, {201,0.00002970}, {202,0.00003960}, {203,0.00000000}, {204,0.00011881}, {205,0.00018812}, {206,0.00000000}, {207,0.00012871}, {208,0.00003960}, {209,0.00022772}, {210,0.00000000}, {211,0.00007921}, {212,0.00000000}, {213,0.00009901}, {214,0.00007921}, {215,0.00007921}, {216,0.00010891}, {217,0.00015842}, {218,0.00003960}, {219,0.00019802}, {220,0.00000000}, {221,0.00015842}, {222,0.00000000}, {223,0.00011881}, {224,0.00000000}, {225,0.00027723}, {226,0.00010891}, {227,0.00007921}, {228,0.00041584}, {229,0.00007921}, {230,0.00000000}, {231,0.00026733}, {232,0.00003960}, {233,0.00003960}, {234,0.00000000}, {235,0.00011881}, {236,0.00003960}, {237,0.00011881}, {238,0.00003960}, {239,0.00000000}, {240,0.00023762}, {241,0.00003960}, {242,0.00014851}, {243,0.00018812}, {244,0.00006931}, {245,0.00003960}, {246,0.00011881}, {247,0.00003960}, {248,0.00000000}, {249,0.00006931}, {250,0.00003960}, {251,0.00003960}, {252,0.00003960}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00007921}, {257,0.00019802}, {258,0.00003960}, {259,0.00003960}, {260,0.00000000}, {261,0.00022772}, {262,0.00003960}, {263,0.00003960}, {264,0.00003960}, {265,0.00011881}, {266,0.00007921}, {267,0.00003960}, {268,0.00003960}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00003960}, {273,0.00000000}, {274,0.00000000}, {275,0.00007921}, {276,0.00006931}, {277,0.00003960}, {278,0.00003960}, {279,0.00010891}, {280,0.00006931}, {281,0.00011881}, {282,0.00000000}, {283,0.00003960}, {284,0.00007921}, {285,0.00006931}, {286,0.00000000}, {287,0.00003960}, {288,0.00000000}, {289,0.00003960}, {290,0.00007921}, {291,0.00003960}, {292,0.00007921}, {293,0.00003960}, {294,0.00007921}, {295,0.00003960}, {296,0.00006931}, {297,0.00002970}, {298,0.00002970}, {299,0.00007921}, {300,0.00003960}, {301,0.00003960}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00007921}, {306,0.00000000}, {307,0.00006931}, {308,0.00003960}, {309,0.00000000}, {310,0.00003960}, {311,0.00000000}, {312,0.00000000}, {313,0.00007921}, {314,0.00000000}, {315,0.00011881}, {316,0.00003960}, {317,0.00000000}, {318,0.00003960}, {319,0.00014851}, {320,0.00000000}, {321,0.00003960}, {322,0.00000000}, {323,0.00000000}, {324,0.00010891}, {325,0.00003960}, {326,0.00000000}, {327,0.00000000}, {328,0.00003960}, {329,0.00000000}, {330,0.00003960}, {331,0.00000000}, {332,0.00011881}, {333,0.00007921}, {334,0.00003960}, {335,0.00003960}, {336,0.00003960}, {337,0.00000000}, {338,0.00003960}, {339,0.00007921}, {340,0.00007921}, {341,0.00011881}, {342,0.00000000}, {343,0.00007921}, {344,0.00011881}, {345,0.00014851}, {346,0.00015842}, {347,0.00002970}, {348,0.00022772}, {349,0.00003960}, {350,0.00038614}, {351,0.00002970}, {352,0.00015842}, {353,0.00007921}, {354,0.00019802}, {355,0.00003960}, {356,0.00003960}, {357,0.00000000}, {358,0.00011881}, {359,0.00031683}, {360,0.00000000}, {361,0.00003960}, {362,0.00007921}, {363,0.00002970}, {364,0.00007921}, {365,0.00010891}, {366,0.00007921}, {367,0.00011881}, {368,0.00027723}, {369,0.00019802}, {370,0.00014851}, {371,0.00007921}, {372,0.00003960}, {373,0.00003960}, {374,0.00000000}, {375,0.00007921}, {376,0.00011881}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00003960}, {381,0.00003960}, {382,0.00011881}, {383,0.00006931}, {384,0.00003960}, {385,0.00003960}, {386,0.00003960}, {387,0.00007921}, {388,0.00003960}, {389,0.00002970}, {390,0.00003960}, {391,0.00000000}, {392,0.00007921}, {393,0.00003960}, {394,0.00007921}, {395,0.00000000}, {396,0.00000000}, {397,0.00011881}, {398,0.00003960}, {399,0.00003960}, {400,0.00006931}, {401,0.00006931}, {402,0.00007921}, {403,0.00007921}, {404,0.00007921}, {405,0.00003960}, {406,0.00005941}, {407,0.00003960}, {408,0.00003960}, {409,0.00007921}, {410,0.00000000}, {411,0.00000000}, {412,0.00003960}, {413,0.00007921}, {414,0.00003960}, {415,0.00003960}, {416,0.00003960}, {417,0.00000000}, {418,0.00000000}, {419,0.00003960}, {420,0.00007921}, {421,0.00000000}, {422,0.00003960}, {423,0.00003960}, {424,0.00015842}, {425,0.00003960}, {426,0.00007921}, {427,0.00007921}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00003960}, {432,0.00003960}, {433,0.00000000}, {434,0.00007921}, {435,0.00003960}, {436,0.00000000}, {437,0.00003960}, {438,0.00007921}, {439,0.00011881}, {440,0.00003960}, {441,0.00015842}, {442,0.00003960}, {443,0.00003960}, {444,0.00007921}, {445,0.00003960}, {446,0.00011881}, {447,0.00003960}, {448,0.00007921}, {449,0.00007921}, {450,0.00003960}, {451,0.00003960}, {452,0.00003960}, {453,0.00003960}, {454,0.00003960}, {455,0.00010891}, {456,0.00000000}, {457,0.00014851}, {458,0.00007921}, {459,0.00003960}, {460,0.00015842}, {461,0.00003960}, {462,0.00007921}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00003960}, {467,0.00000000}, {468,0.00003960}, {469,0.00007921}, {470,0.00015842}, {471,0.00003960}, {472,0.00007921}, {473,0.00007921}, {474,0.00000000}, {475,0.00003960}, {476,0.00007921}, {477,0.00011881}, {478,0.00007921}, {479,0.00000000}, {480,0.00007921}, {481,0.00000000}, {482,0.00003960}, {483,0.00003960}, {484,0.00003960}, {485,0.00003960}, {486,0.00003960}, {487,0.00003960}, {488,0.00007921}, {489,0.00000000}, {490,0.00003960}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00007921}, {495,0.00011881}, {496,0.00019802}, {497,0.00003960}, {498,0.00003960}, {499,0.00003960}, {500,0.00003960}, {505,0.00007921}, {510,0.00003960}, {515,0.00007921}, {520,0.00000000}, {525,0.00011881}, {530,0.00007921}, {535,0.00015842}, {540,0.00000000}, {545,0.00000000}, {550,0.00003960}, {555,0.00000000}, {560,0.00003960}, {565,0.00006931}, {570,0.00007921}, {575,0.00015842}, {580,0.00007921}, {585,0.00003960}, {590,0.00003960}, {595,0.00003960}, {600,0.00006931}, {605,0.00003960}, {610,0.00007921}, {615,0.00002970}, {620,0.00015842}, {625,0.00015842}, {630,0.00000000}, {635,0.00003960}, {640,0.00007921}, {645,0.00007921}, {650,0.00000000}, {655,0.00000000}, {660,0.00003960}, {665,0.00003960}, {670,0.00011881}, {675,0.00007921}, {680,0.00019802}, {685,0.00003960}, {690,0.00011881}, {695,0.00003960}, {700,0.00018812}, {705,0.00006931}, {710,0.00007921}, {715,0.00011881}, {720,0.00015842}, {725,0.00006931}, {730,0.00015842}, {735,0.00007921}, {740,0.00007921}, {745,0.00003960}, {750,0.00014851}, {755,0.00000000}, {760,0.00007921}, {765,0.00003960}, {770,0.00007921}, {775,0.00007921}, {780,0.00007921}, {785,0.00011881}, {790,0.00000000}, {795,0.00015842}, {800,0.00007921}, {805,0.00000000}, {810,0.00007921}, {815,0.00011881}, {820,0.00007921}, {825,0.00003960}, {830,0.00003960}, {835,0.00015842}, {840,0.00007921}, {845,0.00015842}, {850,0.00000000}, {855,0.00014851}, {860,0.00011881}, {865,0.00015842}, {870,0.00000000}, {875,0.00003960}, {880,0.00010891}, {885,0.00007921}, {890,0.00003960}, {895,0.00000000}, {900,0.00010891}, {905,0.00003960}, {910,0.00002970}, {915,0.00015842}, {920,0.00003960}, {925,0.00011881}, {930,0.00003960}, {935,0.00010891}, {940,0.00003960}, {945,0.00015842}, {950,0.00003960}, {955,0.00014851}, {960,0.00003960}, {965,0.00000000}, {970,0.00011881}, {975,0.00003960}, {980,0.00010891}, {985,0.00000000}, {990,0.00003960}, {995,0.00003960}, {1000,0.00000000}, {1010,0.00010891}, {1020,0.00003960}, {1030,0.00007921}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00003960}, {1070,0.00003960}, {1080,0.00015842}, {1090,0.00015842}, {1100,0.00011881}, {1110,0.00007921}, {1120,0.00007921}, {1130,0.00007921}, {1140,0.00014851}, {1150,0.00000000}, {1160,0.00015842}, {1170,0.00007921}, {1180,0.00003960}, {1190,0.00007921}, {1200,0.00003960}, {1210,0.00010891}, {1220,0.00003960}, {1230,0.00007921}, {1240,0.00015842}, {1250,0.00003960}, {1260,0.00003960}, {1270,0.00003960}, {1280,0.00015842}, {1290,0.00007921}, {1300,0.00003960}, {1310,0.00003960}, {1320,0.00027723}, {1330,0.00003960}, {1340,0.00003960}, {1350,0.00007921}, {1360,0.00007921}, {1370,0.00003960}, {1380,0.00000000}, {1390,0.00010891}, {1400,0.00026733}, {1410,0.00000000}, {1420,0.00003960}, {1430,0.00027723}, {1440,0.00003960}, {1450,0.00015842}, {1460,0.00007921}, {1470,0.00019802}, {1480,0.00000000}, {1490,0.00011881}, {1500,0.00010891}, {1510,0.00000000}, {1520,0.00011881}, {1530,0.00010891}, {1540,0.00003960}, {1550,0.00015842}, {1560,0.00011881}, {1570,0.00011881}, {1580,0.00000000}, {1590,0.00015842}, {1600,0.00000000}, {1610,0.00023762}, {1620,0.00003960}, {1630,0.00011881}, {1640,0.00011881}, {1650,0.00010891}, {1660,0.00031683}, {1670,0.00011881}, {1680,0.00003960}, {1690,0.00015842}, {1700,0.00019802}, {1710,0.00007921}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00003960}, {1750,0.00015842}, {1760,0.00003960}, {1770,0.00003960}, {1780,0.00022772}, {1790,0.00000000}, {1800,0.00015842}, {1810,0.00007921}, {1820,0.00003960}, {1830,0.00015842}, {1840,0.00007921}, {1850,0.00023762}, {1860,0.00011881}, {1870,0.00007921}, {1880,0.00010891}, {1890,0.00003960}, {1900,0.00019802}, {1910,0.00007921}, {1920,0.00007921}, {1930,0.00003960}, {1940,0.00011881}, {1950,0.00011881}, {1960,0.00011881}, {1970,0.00003960}, {1980,0.00019802}, {1990,0.00003960}, {2000,0.00003960}, {2050,0.00018812}, {2100,0.00019802}, {2150,0.00011881}, {2200,0.00003960}, {2250,0.00011881}, {2300,0.00019802}, {2350,0.00027723}, {2400,0.00015842}, {2450,0.00006931}, {2500,0.00019802}, {2550,0.00023762}, {2600,0.00000000}, {2650,0.00007921}, {2700,0.00011881}, {2750,0.00007921}, {2800,0.00019802}, {2850,0.00258416}, {2900,0.00019802}, {2950,0.00000000}, {3000,0.00007921}, {3050,0.00007921}, {3100,0.00288119}, {3150,0.00007921}, {3200,0.00011881}, {3250,0.00007921}, {3300,0.00011881}, {3350,0.00015842}, {3400,0.00019802}, {3450,0.00007921}, {3500,0.00011881}, {3550,0.00014851}, {3600,0.00011881}, {3650,0.00019802}, {3700,0.00039604}, {3750,0.00010891}, {3800,0.00018812}, {3850,0.00027723}, {3900,0.00003960}, {3950,0.00003960}, {4000,0.00018812}, {4050,0.00047525}, {4100,0.00018812}, {4150,0.00023762}, {4200,0.00022772}, {4250,0.00030693}, {4300,0.00015842}, {4350,0.00019802}, {4400,0.00015842}, {4450,0.00011881}, {4500,0.00003960}, {4550,0.00007921}, {4600,0.00011881}, {4650,0.00019802}, {4700,0.00022772}, {4750,0.00003960}, {4800,0.00023762}, {4850,0.00027723}, {4900,0.00007921}, {4950,0.00019802}, {5000,0.00035644}, {5050,0.00027723}, {5100,0.00026733}, {5150,0.00003960}, {5200,0.00011881}, {5250,0.00011881}, {5300,0.00050495}, {5350,0.00023762}, {5400,0.00031683}, {5450,0.00023762}, {5500,0.00015842}, {5550,0.00007921}, {5600,0.00015842}, {5650,0.00015842}, {5700,0.00015842}, {5750,0.00023762}, {5800,0.00018812}, {5850,0.00011881}, {5900,0.00043564}, {5950,0.00015842}, {6000,0.00015842}, {6050,0.0067143}, {6100,0.0078857}, {6150,0.0002286}, {6200,0.0003429}, {6250,0.0055714}, {6300,0.0002286}, {6350,0.0000000}, {6400,0.0002286}, {6450,0.0001143}, {6500,0.0002286}, {6550,0.0000000}, {6600,0.0001143}, {6650,0.0003429}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0001143}, {6850,0.0002286}, {6900,0.0003429}, {6950,0.0003429}, {7000,0.0001143}, {7050,0.0001143}, {7100,0.0004286}, {7150,0.0000000}, {7200,0.0004286}, {7250,0.0003429}, {7300,0.0001143}, {7350,0.0001143}, {7400,0.0002286}, {7450,0.0001143}, {7500,0.0001143}, {7550,0.0002000}, {7600,0.0003429}, {7650,0.0001143}, {7700,0.0003429}, {7750,0.0002000}, {7800,0.0002286}, {7850,0.0003429}, {7900,0.0002286}, {7950,0.0002286}, {8000,0.0001143}, {8050,0.0001143}, {8100,0.0003429}, {8150,0.0001143}, {8200,0.0005714}, {8250,0.0001143}, {8300,0.0006857}, {8350,0.0002286}, {8400,0.0003429}, {8450,0.0003429}, {8500,0.0000000}, {8550,0.0003143}, {8600,0.0001143}, {8650,0.0001143}, {8700,0.0002286}, {8750,0.0001143}, {8800,0.0001143}, {8850,0.0005429}, {8900,0.0004571}, {8950,0.0002286}, {9000,0.0000000}, {9050,0.0001143}, {9100,0.0002286}, {9150,0.0004571}, {9200,0.0003429}, {9250,0.0004571}, {9300,0.0025714}, {9350,0.0002286}, {9400,0.0002286}, {9450,0.0002286}, {9500,0.0001143}, {9550,0.0001143}, {9600,0.0003143}, {9650,0.0002286}, {9700,0.0002000}, {9750,0.0006857}, {9800,0.0002286}, {9850,0.0002286}, {9900,0.0000000}, {9950,0.0001143}, {10000,0.0005429}, {10100,0.0000000}, {10200,0.0001143}, {10300,0.0004000}, {10400,0.0002286}, {10500,0.0002000}, {10600,0.0001143}, {10700,0.0003429}, {10800,0.0005714}, {10900,0.0001143}, {11000,0.0002286}, {11100,0.0005714}, {11200,0.0003429}, {11300,0.0003429}, {11400,0.0001143}, {11500,0.0002000}, {11600,0.0001143}, {11700,0.0003429}, {11800,0.0004571}, {11900,0.0005429}, {12000,0.0000000}, {12100,0.0002286}, {12200,0.0005429}, {12300,0.0000000}, {12400,0.0005714}, {12500,0.0006857}, {12600,0.0005429}, {12700,0.0001143}, {12800,0.0002286}, {12900,0.0005714}, {13000,0.0001143}, {13100,0.0010286}, {13200,0.0004571}, {13300,0.0003429}, {13400,0.0003429}, {13500,0.0000857}, {13600,0.0001143}, {13700,0.0003429}, {13800,0.0001143}, {13900,0.0004571}, {14000,0.0003143}, {14100,0.0006571}, {14200,0.0003143}, {14300,0.0001143}, {14400,0.0003429}, {14500,0.0004571}, {14600,0.0006571}, {14700,0.0009143}, {14800,0.0011429}, {14900,0.0003429}, {15000,0.0004571}, {15100,0.0004571}, {15200,0.0002286}, {15300,0.0004571}, {15400,0.0005429}, {15500,0.0009143}, {15600,0.0015429}, {15700,0.0019429}, {15800,0.0009143}, {15900,0.0002286}, {16000,0.0007429}, {16100,0.0020571}, {16200,0.0012000}, {16300,0.0014571}, {16400,0.0024000}, {16500,0.0019143}, {16600,0.0005714}, {16700,0.0018000}, {16800,0.0006857}, {16900,0.0001143}, {17000,0.0003429}, {17100,0.0009143}, {17200,0.0006857}, {17300,0.0010286}, {17400,0.0010286}, {17500,0.0006857}, {17600,0.0004571}, {17700,0.0010000}, {17800,0.0003429}, {17900,0.0002286}, {18000,0.0000000}, {18100,0.0011429}, {18200,0.0006571}, {18300,0.0006857}, {18400,0.0001143}, {18500,0.0002286}, {18600,0.0024857}, {18700,0.0004571}, {18800,0.0009143}, {18900,0.0005714}, {19000,0.0000000}, {19100,0.0003429}, {19200,0.0016000}, {19300,0.0020571}, {19400,0.0001143}, {19500,0.0018000}, {19600,0.0013714}, {19700,0.0024857}, {19800,0.0020286}, {19900,0.0009714}, {20000,0.0020571}};
data["big_flat"]["LtacTCExplicitCtx"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00001980}, {7,0.00055446}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00106931}, {14,0.00124752}, {15,0.00200000}, {16,0.00200000}, {17,0.00200000}, {18,0.00200000}, {19,0.00200000}, {20,0.00204950}, {21,0.00227723}, {22,0.00252475}, {23,0.00300000}, {24,0.00300000}, {25,0.00300000}, {26,0.00400000}, {27,0.00308911}, {28,0.00324752}, {29,0.00500000}, {30,0.00397030}, {31,0.00400000}, {32,0.00400000}, {33,0.00400990}, {34,0.00411881}, {35,0.00429703}, {36,0.00432673}, {37,0.00457426}, {38,0.00500000}, {39,0.00500000}, {40,0.00500990}, {41,0.00514851}, {42,0.00520792}, {43,0.00524752}, {44,0.00527723}, {45,0.00581188}, {46,0.00600000}, {47,0.00603960}, {48,0.00609901}, {49,0.00620792}, {50,0.00623762}, {51,0.00638614}, {52,0.00652475}, {53,0.00731683}, {54,0.00705941}, {55,0.00706931}, {56,0.00712871}, {57,0.00715842}, {58,0.00729703}, {59,0.00753465}, {60,0.00772277}, {61,0.01048515}, {62,0.00808911}, {63,0.00816832}, {64,0.01034653}, {65,0.00828713}, {66,0.00834653}, {67,0.00854455}, {68,0.00899010}, {69,0.00914851}, {70,0.00909901}, {71,0.01037624}, {72,0.00931683}, {73,0.00923762}, {74,0.00932673}, {75,0.00990099}, {76,0.01002970}, {77,0.01016832}, {78,0.01021782}, {79,0.01025743}, {80,0.01017822}, {81,0.01044554}, {82,0.01045545}, {83,0.01098020}, {84,0.01110891}, {85,0.01115842}, {86,0.01112871}, {87,0.01126733}, {88,0.01122772}, {89,0.01148515}, {90,0.01186139}, {91,0.01208911}, {92,0.01327723}, {93,0.01475248}, {94,0.01556436}, {95,0.01631683}, {96,0.01623762}, {97,0.01653465}, {98,0.01619802}, {99,0.01561386}, {100,0.01445545}, {101,0.01329703}, {102,0.01319802}, {103,0.01349505}, {104,0.01342574}, {105,0.01387129}, {106,0.01401980}, {107,0.01421782}, {108,0.01422772}, {109,0.01443564}, {110,0.01986139}, {111,0.01523762}, {112,0.01451485}, {113,0.01484158}, {114,0.01512871}, {115,0.01517822}, {116,0.02046535}, {117,0.01527723}, {118,0.01553465}, {119,0.01564356}, {120,0.01600000}, {121,0.01780198}, {122,0.01618812}, {123,0.01641584}, {124,0.01654455}, {125,0.01643564}, {126,0.01673267}, {127,0.01690099}, {128,0.01963366}, {129,0.01720792}, {130,0.01721782}, {131,0.02124752}, {132,0.01735644}, {133,0.01768317}, {134,0.01884158}, {135,0.01795050}, {136,0.01803960}, {137,0.01824752}, {138,0.01824752}, {139,0.01979208}, {140,0.01840594}, {141,0.02415842}, {142,0.01887129}, {143,0.01925743}, {144,0.01915842}, {145,0.01935644}, {146,0.01925743}, {147,0.01948515}, {148,0.01955446}, {149,0.01991089}, {150,0.01993069}, {151,0.02041584}, {152,0.02017822}, {153,0.02509901}, {154,0.02062376}, {155,0.02133663}, {156,0.02088119}, {157,0.02107921}, {158,0.02944554}, {159,0.02150495}, {160,0.02113861}, {161,0.02147525}, {162,0.02139604}, {163,0.02317822}, {164,0.02182178}, {165,0.02213861}, {166,0.02348515}, {167,0.02261386}, {168,0.02248515}, {169,0.02242574}, {170,0.02855446}, {171,0.02294059}, {172,0.02301980}, {173,0.02316832}, {174,0.02986139}, {175,0.02343564}, {176,0.02321782}, {177,0.02346535}, {178,0.02563366}, {179,0.03168317}, {180,0.02399010}, {181,0.02445545}, {182,0.02431683}, {183,0.02435644}, {184,0.02556436}, {185,0.03011881}, {186,0.03363366}, {187,0.02520792}, {188,0.02513861}, {189,0.02544554}, {190,0.02536634}, {191,0.02564356}, {192,0.02541584}, {193,0.02552475}, {194,0.02563366}, {195,0.02603960}, {196,0.02593069}, {197,0.02622772}, {198,0.02630693}, {199,0.02648515}, {200,0.02627723}, {201,0.02655446}, {202,0.02688119}, {203,0.02718812}, {204,0.02731683}, {205,0.02737624}, {206,0.02762376}, {207,0.02780198}, {208,0.02758416}, {209,0.04033663}, {210,0.03576238}, {211,0.03108911}, {212,0.02819802}, {213,0.02879208}, {214,0.02861386}, {215,0.02880198}, {216,0.03777228}, {217,0.03194059}, {218,0.02890099}, {219,0.02946535}, {220,0.02957426}, {221,0.03693069}, {222,0.02964356}, {223,0.02985149}, {224,0.02999010}, {225,0.03738614}, {226,0.03000000}, {227,0.03064356}, {228,0.04359406}, {229,0.03296040}, {230,0.03075248}, {231,0.03131683}, {232,0.03378218}, {233,0.03099010}, {234,0.03142574}, {235,0.03284158}, {236,0.03149505}, {237,0.03969307}, {238,0.03185149}, {239,0.03213861}, {240,0.03366337}, {241,0.03252475}, {242,0.03787129}, {243,0.03259406}, {244,0.04110891}, {245,0.03292079}, {246,0.04301980}, {247,0.03322772}, {248,0.04528713}, {249,0.03338614}, {250,0.04504950}, {251,0.03360396}, {252,0.04376238}, {253,0.03405941}, {254,0.04082178}, {255,0.03449505}, {256,0.03614851}, {257,0.03444554}, {258,0.03426733}, {259,0.04442574}, {260,0.03472277}, {261,0.03745545}, {262,0.03510891}, {263,0.03544554}, {264,0.04052475}, {265,0.03559406}, {266,0.03548515}, {267,0.04076238}, {268,0.03606931}, {269,0.03618812}, {270,0.03906931}, {271,0.05030693}, {272,0.03673267}, {273,0.03658416}, {274,0.04250495}, {275,0.04847525}, {276,0.03732673}, {277,0.03725743}, {278,0.03877228}, {279,0.04503960}, {280,0.05103960}, {281,0.03815842}, {282,0.03776238}, {283,0.03811881}, {284,0.04117822}, {285,0.04553465}, {286,0.04932673}, {287,0.03906931}, {288,0.03882178}, {289,0.03880198}, {290,0.03905941}, {291,0.03934653}, {292,0.03935644}, {293,0.04038614}, {294,0.04201980}, {295,0.04317822}, {296,0.04393069}, {297,0.04514851}, {298,0.04546535}, {299,0.04570297}, {300,0.04544554}, {301,0.04379208}, {302,0.04683168}, {303,0.04554455}, {304,0.04356436}, {305,0.04148515}, {306,0.04127723}, {307,0.04124752}, {308,0.04138614}, {309,0.04244554}, {310,0.04186139}, {311,0.05583168}, {312,0.05194059}, {313,0.04842574}, {314,0.04422772}, {315,0.04273267}, {316,0.04299010}, {317,0.04327723}, {318,0.05319802}, {319,0.04810891}, {320,0.04288119}, {321,0.04316832}, {322,0.05760396}, {323,0.05159406}, {324,0.04564356}, {325,0.04387129}, {326,0.04431683}, {327,0.05174257}, {328,0.04416832}, {329,0.04436634}, {330,0.05490099}, {331,0.04868317}, {332,0.04473267}, {333,0.06251485}, {334,0.04811881}, {335,0.04597030}, {336,0.05621782}, {337,0.04561386}, {338,0.04569307}, {339,0.05304950}, {340,0.04565347}, {341,0.05796040}, {342,0.04680198}, {343,0.04659406}, {344,0.05003960}, {345,0.04688119}, {346,0.05250495}, {347,0.04727723}, {348,0.05398020}, {349,0.04714851}, {350,0.05425743}, {351,0.04798020}, {352,0.05304950}, {353,0.04799010}, {354,0.05192079}, {355,0.04823762}, {356,0.04978218}, {357,0.06675248}, {358,0.04856436}, {359,0.06025743}, {360,0.04837624}, {361,0.05224752}, {362,0.06370297}, {363,0.04915842}, {364,0.05598020}, {365,0.06556436}, {366,0.04934653}, {367,0.05658416}, {368,0.06542574}, {369,0.04985149}, {370,0.05479208}, {371,0.06232673}, {372,0.05056436}, {373,0.05094059}, {374,0.05739604}, {375,0.06416832}, {376,0.05077228}, {377,0.05127723}, {378,0.05643564}, {379,0.06199010}, {380,0.07434653}, {381,0.05179208}, {382,0.05174257}, {383,0.05585149}, {384,0.05979208}, {385,0.06543564}, {386,0.06992079}, {387,0.05229703}, {388,0.05212871}, {389,0.05271287}, {390,0.05595050}, {391,0.05860396}, {392,0.06077228}, {393,0.06237624}, {394,0.06475248}, {395,0.06681188}, {396,0.06769307}, {397,0.06907921}, {398,0.06963366}, {399,0.07248515}, {400,0.07845545}, {401,0.07340594}, {402,0.07317822}, {403,0.07296040}, {404,0.06803960}, {405,0.07011881}, {406,0.06860396}, {407,0.06700000}, {408,0.06403960}, {409,0.06107921}, {410,0.05943564}, {411,0.05748515}, {412,0.05553465}, {413,0.05619802}, {414,0.05608911}, {415,0.06910891}, {416,0.06741584}, {417,0.06536634}, {418,0.05884158}, {419,0.05656436}, {420,0.05667327}, {421,0.07192079}, {422,0.06481188}, {423,0.05929703}, {424,0.05694059}, {425,0.07412871}, {426,0.06654455}, {427,0.06027723}, {428,0.05796040}, {429,0.07219802}, {430,0.06392079}, {431,0.05895050}, {432,0.07359406}, {433,0.06782178}, {434,0.05884158}, {435,0.08098020}, {436,0.06695050}, {437,0.05957426}, {438,0.07549505}, {439,0.06366337}, {440,0.05965347}, {441,0.07022772}, {442,0.05993069}, {443,0.07367327}, {444,0.06202970}, {445,0.07609901}, {446,0.06459406}, {447,0.07803960}, {448,0.06594059}, {449,0.06120792}, {450,0.06919802}, {451,0.06160396}, {452,0.07034653}, {453,0.06160396}, {454,0.06924752}, {455,0.08268317}, {456,0.06632673}, {457,0.07904950}, {458,0.06338614}, {459,0.07553465}, {460,0.06239604}, {461,0.07009901}, {462,0.07968317}, {463,0.06457426}, {464,0.07368317}, {465,0.06302970}, {466,0.06814851}, {467,0.08257426}, {468,0.06300990}, {469,0.06825743}, {470,0.07727723}, {471,0.08529703}, {472,0.06529703}, {473,0.07402970}, {474,0.08021782}, {475,0.06448515}, {476,0.06709901}, {477,0.07425743}, {478,0.07941584}, {479,0.08520792}, {480,0.06483168}, {481,0.07271287}, {482,0.07992079}, {483,0.08285149}, {484,0.08778218}, {485,0.06574257}, {486,0.06840594}, {487,0.07212871}, {488,0.07583168}, {489,0.07874257}, {490,0.08146535}, {491,0.08422772}, {492,0.08649505}, {493,0.06741584}, {494,0.06777228}, {495,0.06778218}, {496,0.06877228}, {497,0.07043564}, {498,0.07102970}, {499,0.07226733}, {500,0.07227723}, {505,0.07333663}, {510,0.07192079}, {515,0.06943564}, {520,0.09152475}, {525,0.08763366}, {530,0.08422772}, {535,0.07585149}, {540,0.09489109}, {545,0.08413861}, {550,0.09967327}, {555,0.08637624}, {560,0.09665347}, {565,0.08371287}, {570,0.09220792}, {575,0.09682178}, {580,0.08398020}, {585,0.09296040}, {590,0.09495050}, {595,0.09888119}, {600,0.09981188}, {605,0.09879208}, {610,0.09801980}, {615,0.09681188}, {620,0.09205941}, {625,0.09187129}, {630,0.11217822}, {635,0.10495050}, {640,0.09429703}, {645,0.11072277}, {650,0.09953465}, {655,0.11271287}, {660,0.10017822}, {665,0.12092079}, {670,0.09793069}, {675,0.10400000}, {680,0.11316832}, {685,0.11774257}, {690,0.09869307}, {695,0.10133663}, {700,0.10656436}, {705,0.10491089}, {710,0.10469307}, {715,0.10312871}, {720,0.12335644}, {725,0.12112871}, {730,0.11330693}, {735,0.11135644}, {740,0.12964356}, {745,0.11877228}, {750,0.13155446}, {755,0.12040594}, {760,0.12677228}, {765,0.12081188}, {770,0.12430693}, {775,0.13834653}, {780,0.11852475}, {785,0.12529703}, {790,0.14108911}, {795,0.13913861}, {800,0.13934653}, {805,0.13858416}, {810,0.13819802}, {815,0.13734653}, {820,0.13792079}, {825,0.13354455}, {830,0.12685149}, {835,0.14338614}, {840,0.13622772}, {845,0.13070297}, {850,0.14345545}, {855,0.13443564}, {860,0.14382178}, {865,0.12866337}, {870,0.14591089}, {875,0.15235644}, {880,0.13238614}, {885,0.13919802}, {890,0.15416832}, {895,0.15099010}, {900,0.15013861}, {905,0.14879208}, {910,0.14879208}, {915,0.15705941}, {920,0.14987129}, {925,0.14396040}, {930,0.13799010}, {935,0.15576238}, {940,0.15238614}, {945,0.14221782}, {950,0.15571287}, {955,0.14550495}, {960,0.16936634}, {965,0.14712871}, {970,0.15650495}, {975,0.16247525}, {980,0.18930693}, {985,0.15638614}, {990,0.15976238}, {995,0.16091089}, {1000,0.17938614}, {1010,0.17203960}, {1020,0.16583168}, {1030,0.16206931}, {1040,0.16172277}, {1050,0.17769307}, {1060,0.16464356}, {1070,0.17694059}, {1080,0.19199010}, {1090,0.17119802}, {1100,0.17411881}, {1110,0.18259406}, {1120,0.17885149}, {1130,0.17372277}, {1140,0.20362376}, {1150,0.19122772}, {1160,0.19832673}, {1170,0.18756436}, {1180,0.20414851}, {1190,0.20468317}, {1200,0.19724752}, {1210,0.19211881}, {1220,0.21374257}, {1230,0.20921782}, {1240,0.21091089}, {1250,0.19699010}, {1260,0.22243564}, {1270,0.20291089}, {1280,0.20653465}, {1290,0.22996040}, {1300,0.22522772}, {1310,0.22206931}, {1320,0.23175248}, {1330,0.22298020}, {1340,0.21595050}, {1350,0.21531683}, {1360,0.22538614}, {1370,0.22324752}, {1380,0.22653465}, {1390,0.23077228}, {1400,0.24335644}, {1410,0.23592079}, {1420,0.26246535}, {1430,0.24117822}, {1440,0.23115842}, {1450,0.23301980}, {1460,0.23980198}, {1470,0.26215842}, {1480,0.23834653}, {1490,0.24913861}, {1500,0.25451485}, {1510,0.25147525}, {1520,0.26088119}, {1530,0.25081188}, {1540,0.25177228}, {1550,0.26363366}, {1560,0.27723762}, {1570,0.27139604}, {1580,0.24891089}, {1590,0.26909901}, {1600,0.26620792}, {1610,0.27781188}, {1620,0.27115842}, {1630,0.27486139}, {1640,0.26504950}, {1650,0.26188119}, {1660,0.27580198}, {1670,0.26618812}, {1680,0.27353465}, {1690,0.28603960}, {1700,0.28810891}, {1710,0.29402970}, {1720,0.29094059}, {1730,0.29559406}, {1740,0.28484158}, {1750,0.28610891}, {1760,0.31604950}, {1770,0.29053465}, {1780,0.32525743}, {1790,0.30326733}, {1800,0.31957426}, {1810,0.28749505}, {1820,0.29849505}, {1830,0.31051485}, {1840,0.31285149}, {1850,0.29497030}, {1860,0.32235644}, {1870,0.32189109}, {1880,0.31766337}, {1890,0.31163366}, {1900,0.30805941}, {1910,0.31824752}, {1920,0.33346535}, {1930,0.31290099}, {1940,0.34266337}, {1950,0.32699010}, {1960,0.32367327}, {1970,0.36037624}, {1980,0.31721782}, {1990,0.33477228}, {2000,0.32818812}, {2050,0.34038614}, {2100,0.37290099}, {2150,0.36117822}, {2200,0.36346535}, {2250,0.38038614}, {2300,0.38075248}, {2350,0.39016832}, {2400,0.40993069}, {2450,0.43151485}, {2500,0.40586139}, {2550,0.43783168}, {2600,0.42911881}, {2650,0.44669307}, {2700,0.45891089}, {2750,0.47907921}, {2800,0.51773267}, {2850,1.46750495}, {2900,0.47540594}, {2950,0.48382178}, {3000,0.50834653}, {3050,0.52691089}, {3100,0.52964356}, {3150,0.53867327}, {3200,0.53015842}, {3250,0.54645545}, {3300,0.56270297}, {3350,0.57654455}, {3400,0.56587129}, {3450,0.58250495}, {3500,0.59497030}, {3550,0.61062376}, {3600,0.62642574}, {3650,0.63354455}, {3700,0.65725743}, {3750,0.64765347}, {3800,0.65951485}, {3850,0.66796040}, {3900,0.65944554}, {3950,0.67647525}, {4000,0.70868317}, {4050,0.69743564}, {4100,0.69292079}, {4150,0.70493069}, {4200,0.74233663}, {4250,0.74093069}, {4300,0.73094059}, {4350,0.76110891}, {4400,0.77060396}, {4450,0.76956436}, {4500,0.77318812}, {4550,0.78537624}, {4600,0.79385149}, {4650,0.82176238}, {4700,0.79940594}, {4750,0.81128713}, {4800,0.82602970}, {4850,0.85088119}, {4900,0.83493069}, {4950,0.86127723}, {5000,0.86452475}, {5050,0.88885149}, {5100,0.90474257}, {5150,0.91921782}, {5200,0.89309901}, {5250,0.92593069}, {5300,0.91119802}, {5350,0.92766337}, {5400,0.95161386}, {5450,0.96771287}, {5500,0.96513861}, {5550,0.95007921}, {5600,0.97215842}, {5650,0.98623762}, {5700,1.02079208}, {5750,0.99213861}, {5800,1.00436634}, {5850,1.05926733}, {5900,1.02960396}, {5950,1.03490099}, {6000,1.05043564}, {6050,1.1120857}, {6100,1.1275429}, {6150,1.1045143}, {6200,1.1256000}, {6250,1.1487714}, {6300,1.1490571}, {6350,1.1512857}, {6400,1.1384857}, {6450,1.1741429}, {6500,1.2058000}, {6550,1.2179143}, {6600,1.2124286}, {6650,1.2304571}, {6700,1.2637143}, {6750,1.2662286}, {6800,1.2566857}, {6850,1.2819143}, {6900,1.2857429}, {6950,1.3058000}, {7000,1.2965714}, {7050,1.2983143}, {7100,1.3177143}, {7150,1.3246857}, {7200,1.3073714}, {7250,1.3243143}, {7300,1.3117143}, {7350,1.3174571}, {7400,1.3339429}, {7450,1.3567714}, {7500,1.3791429}, {7550,1.4085429}, {7600,1.4150286}, {7650,1.4134286}, {7700,1.4112000}, {7750,1.3949143}, {7800,1.4166571}, {7850,1.4818000}, {7900,1.4716000}, {7950,1.4616286}, {8000,1.4578571}, {8050,1.4742000}, {8100,1.4614000}, {8150,1.5196286}, {8200,1.4971143}, {8250,1.5164857}, {8300,1.4933143}, {8350,1.5479714}, {8400,1.5435714}, {8450,1.5417714}, {8500,1.5341143}, {8550,1.5844286}, {8600,1.5857714}, {8650,1.5731714}, {8700,1.5920571}, {8750,1.6345429}, {8800,1.6201714}, {8850,1.5900286}, {8900,1.6708571}, {8950,1.6700571}, {9000,1.6130571}, {9050,1.6655429}, {9100,1.6836286}, {9150,1.6735143}, {9200,1.7259143}, {9250,1.6724857}, {9300,1.7406286}, {9350,1.7283429}, {9400,1.7202857}, {9450,1.7577714}, {9500,1.7411143}, {9550,1.7749714}, {9600,1.7813429}, {9650,1.7718286}, {9700,1.7968857}, {9750,1.7725714}, {9800,1.8029429}, {9850,1.7981143}, {9900,1.8368000}, {9950,1.8284286}, {10000,1.8453714}, {10100,1.8819429}, {10200,1.8950286}, {10300,1.8824571}, {10400,1.9246286}, {10500,1.8488571}, {10600,1.9615429}, {10700,1.9249714}, {10800,2.0120571}, {10900,1.9679714}, {11000,2.0468000}, {11100,2.0033714}, {11200,2.0531429}, {11300,2.0535714}, {11400,2.0665714}, {11500,2.1151429}, {11600,2.1061143}, {11700,2.1768857}, {11800,2.1446857}, {11900,2.1745714}, {12000,2.2318286}, {12100,2.2157143}, {12200,2.2475714}, {12300,2.2567429}, {12400,2.2657429}, {12500,2.2701429}, {12600,2.3791714}, {12700,2.3402571}, {12800,2.3172286}, {12900,2.3378000}, {13000,2.3788571}, {13100,2.4204571}, {13200,2.4187714}, {13300,2.4411714}, {13400,2.4344571}, {13500,2.4891143}, {13600,2.4953714}, {13700,2.4983143}, {13800,2.5329714}, {13900,2.5419143}, {14000,2.5677429}, {14100,2.5962000}, {14200,2.6169429}, {14300,2.6474000}, {14400,2.8702286}, {14500,2.8374286}, {14600,2.6655143}, {14700,2.6964000}, {14800,2.6924571}, {14900,2.7187714}, {15000,2.7260857}, {15100,2.7918857}, {15200,2.7549429}, {15300,2.7695714}, {15400,2.8894286}, {15500,2.9075429}, {15600,3.0174857}, {15700,2.9057429}, {15800,3.1375714}, {15900,2.9106286}, {16000,3.2254571}, {16100,2.9399429}, {16200,2.9358571}, {16300,3.0622000}, {16400,3.0410571}, {16500,2.9882000}, {16600,2.9954571}, {16700,3.0233429}, {16800,3.0196571}, {16900,3.1302857}, {17000,3.1886571}, {17100,3.2019143}, {17200,3.1093143}, {17300,3.1586571}, {17400,3.1609143}, {17500,3.1948000}, {17600,3.2496000}, {17700,3.2896286}, {17800,3.2458000}, {17900,3.3525429}, {18000,3.3278857}, {18100,3.5061429}, {18200,3.3043429}, {18300,3.4191429}, {18400,3.5046857}, {18500,3.4373143}, {18600,3.6416857}, {18700,3.4642000}, {18800,3.5136571}, {18900,3.5285143}, {19000,3.4716857}, {19100,3.4581143}, {19200,3.4442286}, {19300,3.5131714}, {19400,3.5622857}, {19500,3.7446000}, {19600,3.6490857}, {19700,3.9519714}, {19800,3.9556857}, {19900,3.6364571}, {20000,3.8298286}};
data["big_flat"]["LtacTCExplicitCtx"]["actual reif"]["user"] = {{1,0.00014851}, {2,0.00039604}, {3,0.00023762}, {4,0.00047525}, {5,0.00071287}, {6,0.00087129}, {7,0.00058416}, {8,0.00070297}, {9,0.00127723}, {10,0.00108911}, {11,0.00148515}, {12,0.00138614}, {13,0.00154455}, {14,0.00139604}, {15,0.00194059}, {16,0.00211881}, {17,0.00201980}, {18,0.00224752}, {19,0.00251485}, {20,0.00260396}, {21,0.00240594}, {22,0.00287129}, {23,0.00283168}, {24,0.00300990}, {25,0.00312871}, {26,0.00392079}, {27,0.00309901}, {28,0.00329703}, {29,0.00484158}, {30,0.00363366}, {31,0.00376238}, {32,0.00402970}, {33,0.00420792}, {34,0.00420792}, {35,0.00412871}, {36,0.00470297}, {37,0.00495050}, {38,0.00496040}, {39,0.00535644}, {40,0.00497030}, {41,0.00541584}, {42,0.00583168}, {43,0.00549505}, {44,0.00533663}, {45,0.00609901}, {46,0.00576238}, {47,0.00664356}, {48,0.00657426}, {49,0.00640594}, {50,0.00675248}, {51,0.00636634}, {52,0.00692079}, {53,0.00782178}, {54,0.00755446}, {55,0.00735644}, {56,0.00738614}, {57,0.00760396}, {58,0.00776238}, {59,0.00789109}, {60,0.00795050}, {61,0.01022772}, {62,0.00800990}, {63,0.00804950}, {64,0.01072277}, {65,0.00830693}, {66,0.00861386}, {67,0.00838614}, {68,0.00921782}, {69,0.00859406}, {70,0.00881188}, {71,0.01047525}, {72,0.00929703}, {73,0.00938614}, {74,0.00964356}, {75,0.01007921}, {76,0.00973267}, {77,0.01015842}, {78,0.01000000}, {79,0.01028713}, {80,0.01093069}, {81,0.01073267}, {82,0.01053465}, {83,0.01082178}, {84,0.01098020}, {85,0.01127723}, {86,0.01121782}, {87,0.01169307}, {88,0.01152475}, {89,0.01185149}, {90,0.01198020}, {91,0.01221782}, {92,0.01338614}, {93,0.01497030}, {94,0.01592079}, {95,0.01656436}, {96,0.01646535}, {97,0.01681188}, {98,0.01642574}, {99,0.01581188}, {100,0.01460396}, {101,0.01374257}, {102,0.01378218}, {103,0.01400000}, {104,0.01342574}, {105,0.01398020}, {106,0.01423762}, {107,0.01437624}, {108,0.01487129}, {109,0.01475248}, {110,0.01947525}, {111,0.01588119}, {112,0.01490099}, {113,0.01534653}, {114,0.01553465}, {115,0.01549505}, {116,0.02037624}, {117,0.01561386}, {118,0.01598020}, {119,0.01592079}, {120,0.01628713}, {121,0.01776238}, {122,0.01632673}, {123,0.01675248}, {124,0.01662376}, {125,0.01689109}, {126,0.01682178}, {127,0.01675248}, {128,0.01935644}, {129,0.01746535}, {130,0.01755446}, {131,0.02100990}, {132,0.01742574}, {133,0.01817822}, {134,0.01853465}, {135,0.01779208}, {136,0.01792079}, {137,0.01838614}, {138,0.01797030}, {139,0.01944554}, {140,0.01828713}, {141,0.02401980}, {142,0.01863366}, {143,0.01894059}, {144,0.01862376}, {145,0.01907921}, {146,0.01895050}, {147,0.01924752}, {148,0.01917822}, {149,0.01972277}, {150,0.01980198}, {151,0.01968317}, {152,0.01982178}, {153,0.02509901}, {154,0.02066337}, {155,0.02122772}, {156,0.02093069}, {157,0.02106931}, {158,0.02952475}, {159,0.02111881}, {160,0.02106931}, {161,0.02150495}, {162,0.02137624}, {163,0.02345545}, {164,0.02174257}, {165,0.02214851}, {166,0.02331683}, {167,0.02264356}, {168,0.02225743}, {169,0.02255446}, {170,0.02831683}, {171,0.02305941}, {172,0.02316832}, {173,0.02363366}, {174,0.02952475}, {175,0.02377228}, {176,0.02338614}, {177,0.02371287}, {178,0.02523762}, {179,0.03168317}, {180,0.02399010}, {181,0.02451485}, {182,0.02440594}, {183,0.02464356}, {184,0.02520792}, {185,0.03021782}, {186,0.03398020}, {187,0.02501980}, {188,0.02501980}, {189,0.02527723}, {190,0.02529703}, {191,0.02571287}, {192,0.02518812}, {193,0.02553465}, {194,0.02584158}, {195,0.02555446}, {196,0.02592079}, {197,0.02601980}, {198,0.02619802}, {199,0.02646535}, {200,0.02625743}, {201,0.02637624}, {202,0.02678218}, {203,0.02707921}, {204,0.02737624}, {205,0.02697030}, {206,0.02762376}, {207,0.02745545}, {208,0.02738614}, {209,0.04013861}, {210,0.03601980}, {211,0.03141584}, {212,0.02800990}, {213,0.02888119}, {214,0.02853465}, {215,0.02908911}, {216,0.03744554}, {217,0.03200990}, {218,0.02892079}, {219,0.02929703}, {220,0.02932673}, {221,0.03656436}, {222,0.02937624}, {223,0.02995050}, {224,0.03021782}, {225,0.03698020}, {226,0.03040594}, {227,0.03074257}, {228,0.04311881}, {229,0.03332673}, {230,0.03093069}, {231,0.03138614}, {232,0.03375248}, {233,0.03131683}, {234,0.03157426}, {235,0.03285149}, {236,0.03147525}, {237,0.03921782}, {238,0.03195050}, {239,0.03225743}, {240,0.03370297}, {241,0.03227723}, {242,0.03744554}, {243,0.03261386}, {244,0.04098020}, {245,0.03296040}, {246,0.04287129}, {247,0.03341584}, {248,0.04544554}, {249,0.03304950}, {250,0.04457426}, {251,0.03387129}, {252,0.04318812}, {253,0.03447525}, {254,0.04042574}, {255,0.03482178}, {256,0.03650495}, {257,0.03447525}, {258,0.03431683}, {259,0.04431683}, {260,0.03497030}, {261,0.03739604}, {262,0.03516832}, {263,0.03567327}, {264,0.04037624}, {265,0.03577228}, {266,0.03536634}, {267,0.04056436}, {268,0.03628713}, {269,0.03636634}, {270,0.03854455}, {271,0.05027723}, {272,0.03653465}, {273,0.03662376}, {274,0.04234653}, {275,0.04826733}, {276,0.03775248}, {277,0.03722772}, {278,0.03850495}, {279,0.04479208}, {280,0.05078218}, {281,0.03808911}, {282,0.03799010}, {283,0.03797030}, {284,0.04095050}, {285,0.04551485}, {286,0.04911881}, {287,0.03878218}, {288,0.03866337}, {289,0.03844554}, {290,0.03881188}, {291,0.03870297}, {292,0.03896040}, {293,0.04017822}, {294,0.04176238}, {295,0.04299010}, {296,0.04380198}, {297,0.04508911}, {298,0.04554455}, {299,0.04551485}, {300,0.04553465}, {301,0.04384158}, {302,0.04673267}, {303,0.04563366}, {304,0.04359406}, {305,0.04124752}, {306,0.04090099}, {307,0.04122772}, {308,0.04127723}, {309,0.04187129}, {310,0.04161386}, {311,0.05563366}, {312,0.05151485}, {313,0.04838614}, {314,0.04415842}, {315,0.04234653}, {316,0.04254455}, {317,0.04312871}, {318,0.05278218}, {319,0.04809901}, {320,0.04285149}, {321,0.04319802}, {322,0.05740594}, {323,0.05117822}, {324,0.04560396}, {325,0.04394059}, {326,0.04405941}, {327,0.05125743}, {328,0.04393069}, {329,0.04431683}, {330,0.05482178}, {331,0.04901980}, {332,0.04471287}, {333,0.06295050}, {334,0.04812871}, {335,0.04606931}, {336,0.05598020}, {337,0.04570297}, {338,0.04571287}, {339,0.05278218}, {340,0.04563366}, {341,0.05807921}, {342,0.04685149}, {343,0.04640594}, {344,0.04985149}, {345,0.04681188}, {346,0.05208911}, {347,0.04723762}, {348,0.05343564}, {349,0.04732673}, {350,0.05344554}, {351,0.04812871}, {352,0.05281188}, {353,0.04818812}, {354,0.05151485}, {355,0.04843564}, {356,0.04997030}, {357,0.06689109}, {358,0.04873267}, {359,0.06021782}, {360,0.04877228}, {361,0.05197030}, {362,0.06374257}, {363,0.04958416}, {364,0.05565347}, {365,0.06495050}, {366,0.04928713}, {367,0.05645545}, {368,0.06489109}, {369,0.04958416}, {370,0.05417822}, {371,0.06208911}, {372,0.05074257}, {373,0.05079208}, {374,0.05745545}, {375,0.06431683}, {376,0.05094059}, {377,0.05104950}, {378,0.05629703}, {379,0.06183168}, {380,0.07414851}, {381,0.05165347}, {382,0.05147525}, {383,0.05564356}, {384,0.05988119}, {385,0.06545545}, {386,0.06982178}, {387,0.05209901}, {388,0.05210891}, {389,0.05266337}, {390,0.05551485}, {391,0.05836634}, {392,0.06095050}, {393,0.06243564}, {394,0.06433663}, {395,0.06658416}, {396,0.06784158}, {397,0.06902970}, {398,0.06953465}, {399,0.07214851}, {400,0.07828713}, {401,0.07335644}, {402,0.07327723}, {403,0.07278218}, {404,0.06805941}, {405,0.06996040}, {406,0.06857426}, {407,0.06672277}, {408,0.06399010}, {409,0.06100990}, {410,0.05954455}, {411,0.05769307}, {412,0.05518812}, {413,0.05618812}, {414,0.05582178}, {415,0.06890099}, {416,0.06710891}, {417,0.06516832}, {418,0.05865347}, {419,0.05662376}, {420,0.05648515}, {421,0.07205941}, {422,0.06449505}, {423,0.05911881}, {424,0.05676238}, {425,0.07404950}, {426,0.06620792}, {427,0.06016832}, {428,0.05768317}, {429,0.07191089}, {430,0.06358416}, {431,0.05877228}, {432,0.07387129}, {433,0.06775248}, {434,0.05875248}, {435,0.08087129}, {436,0.06670297}, {437,0.05981188}, {438,0.07544554}, {439,0.06360396}, {440,0.05934653}, {441,0.07039604}, {442,0.06000000}, {443,0.07347525}, {444,0.06189109}, {445,0.07600000}, {446,0.06455446}, {447,0.07784158}, {448,0.06580198}, {449,0.06110891}, {450,0.06884158}, {451,0.06164356}, {452,0.07011881}, {453,0.06208911}, {454,0.06897030}, {455,0.08244554}, {456,0.06590099}, {457,0.07858416}, {458,0.06340594}, {459,0.07545545}, {460,0.06248515}, {461,0.06986139}, {462,0.07968317}, {463,0.06471287}, {464,0.07364356}, {465,0.06287129}, {466,0.06792079}, {467,0.08253465}, {468,0.06305941}, {469,0.06781188}, {470,0.07710891}, {471,0.08510891}, {472,0.06504950}, {473,0.07383168}, {474,0.07980198}, {475,0.06418812}, {476,0.06700000}, {477,0.07422772}, {478,0.07910891}, {479,0.08507921}, {480,0.06475248}, {481,0.07238614}, {482,0.07962376}, {483,0.08318812}, {484,0.08758416}, {485,0.06542574}, {486,0.06821782}, {487,0.07214851}, {488,0.07543564}, {489,0.07848515}, {490,0.08121782}, {491,0.08390099}, {492,0.08640594}, {493,0.06686139}, {494,0.06726733}, {495,0.06747525}, {496,0.06824752}, {497,0.07055446}, {498,0.07086139}, {499,0.07213861}, {500,0.07208911}, {505,0.07333663}, {510,0.07206931}, {515,0.06915842}, {520,0.09123762}, {525,0.08752475}, {530,0.08420792}, {535,0.07551485}, {540,0.09484158}, {545,0.08408911}, {550,0.09968317}, {555,0.08599010}, {560,0.09640594}, {565,0.08381188}, {570,0.09236634}, {575,0.09655446}, {580,0.08417822}, {585,0.09304950}, {590,0.09512871}, {595,0.09848515}, {600,0.09989109}, {605,0.09845545}, {610,0.09805941}, {615,0.09718812}, {620,0.09218812}, {625,0.09160396}, {630,0.11207921}, {635,0.10499010}, {640,0.09416832}, {645,0.11015842}, {650,0.09920792}, {655,0.11253465}, {660,0.09977228}, {665,0.12075248}, {670,0.09750495}, {675,0.10415842}, {680,0.11302970}, {685,0.11738614}, {690,0.09848515}, {695,0.10116832}, {700,0.10688119}, {705,0.10457426}, {710,0.10444554}, {715,0.10280198}, {720,0.12332673}, {725,0.12067327}, {730,0.11313861}, {735,0.11099010}, {740,0.12932673}, {745,0.11847525}, {750,0.13104950}, {755,0.12015842}, {760,0.12637624}, {765,0.12045545}, {770,0.12431683}, {775,0.13837624}, {780,0.11844554}, {785,0.12500000}, {790,0.14069307}, {795,0.13887129}, {800,0.13918812}, {805,0.13841584}, {810,0.13779208}, {815,0.13728713}, {820,0.13716832}, {825,0.13315842}, {830,0.12625743}, {835,0.14314851}, {840,0.13598020}, {845,0.13066337}, {850,0.14328713}, {855,0.13404950}, {860,0.14360396}, {865,0.12815842}, {870,0.14563366}, {875,0.15252475}, {880,0.13240594}, {885,0.13891089}, {890,0.15358416}, {895,0.15075248}, {900,0.14948515}, {905,0.14859406}, {910,0.14852475}, {915,0.15669307}, {920,0.14964356}, {925,0.14366337}, {930,0.13766337}, {935,0.15534653}, {940,0.15222772}, {945,0.14198020}, {950,0.15554455}, {955,0.14533663}, {960,0.16902970}, {965,0.14673267}, {970,0.15633663}, {975,0.16247525}, {980,0.18898020}, {985,0.15646535}, {990,0.15976238}, {995,0.16063366}, {1000,0.17897030}, {1010,0.17143564}, {1020,0.16561386}, {1030,0.16149505}, {1040,0.16141584}, {1050,0.17731683}, {1060,0.16414851}, {1070,0.17665347}, {1080,0.19176238}, {1090,0.17081188}, {1100,0.17385149}, {1110,0.18204950}, {1120,0.17837624}, {1130,0.17363366}, {1140,0.20312871}, {1150,0.19093069}, {1160,0.19768317}, {1170,0.18701980}, {1180,0.20387129}, {1190,0.20406931}, {1200,0.19700990}, {1210,0.19159406}, {1220,0.21336634}, {1230,0.20860396}, {1240,0.21058416}, {1250,0.19654455}, {1260,0.22183168}, {1270,0.20238614}, {1280,0.20610891}, {1290,0.22959406}, {1300,0.22500990}, {1310,0.22159406}, {1320,0.23094059}, {1330,0.22243564}, {1340,0.21553465}, {1350,0.21459406}, {1360,0.22456436}, {1370,0.22261386}, {1380,0.22574257}, {1390,0.22985149}, {1400,0.24245545}, {1410,0.23531683}, {1420,0.26205941}, {1430,0.24038614}, {1440,0.23047525}, {1450,0.23259406}, {1460,0.23888119}, {1470,0.26135644}, {1480,0.23784158}, {1490,0.24826733}, {1500,0.25368317}, {1510,0.25128713}, {1520,0.26023762}, {1530,0.25009901}, {1540,0.25090099}, {1550,0.26298020}, {1560,0.27655446}, {1570,0.27065347}, {1580,0.24846535}, {1590,0.26820792}, {1600,0.26564356}, {1610,0.27709901}, {1620,0.27055446}, {1630,0.27384158}, {1640,0.26423762}, {1650,0.26129703}, {1660,0.27493069}, {1670,0.26553465}, {1680,0.27276238}, {1690,0.28548515}, {1700,0.28720792}, {1710,0.29333663}, {1720,0.29028713}, {1730,0.29457426}, {1740,0.28416832}, {1750,0.28534653}, {1760,0.31541584}, {1770,0.28970297}, {1780,0.32436634}, {1790,0.30214851}, {1800,0.31895050}, {1810,0.28679208}, {1820,0.29769307}, {1830,0.30940594}, {1840,0.31178218}, {1850,0.29418812}, {1860,0.32154455}, {1870,0.32119802}, {1880,0.31644554}, {1890,0.31088119}, {1900,0.30679208}, {1910,0.31744554}, {1920,0.33269307}, {1930,0.31203960}, {1940,0.34155446}, {1950,0.32607921}, {1960,0.32271287}, {1970,0.35937624}, {1980,0.31642574}, {1990,0.33406931}, {2000,0.32732673}, {2050,0.33918812}, {2100,0.37179208}, {2150,0.36001980}, {2200,0.36238614}, {2250,0.37925743}, {2300,0.37977228}, {2350,0.38914851}, {2400,0.40849505}, {2450,0.43051485}, {2500,0.40466337}, {2550,0.43696040}, {2600,0.42799010}, {2650,0.44570297}, {2700,0.45774257}, {2750,0.47803960}, {2800,0.51661386}, {2850,1.46230693}, {2900,0.47435644}, {2950,0.48300990}, {3000,0.50754455}, {3050,0.52634653}, {3100,0.52584158}, {3150,0.53754455}, {3200,0.52884158}, {3250,0.54555446}, {3300,0.56192079}, {3350,0.57550495}, {3400,0.56485149}, {3450,0.58147525}, {3500,0.59398020}, {3550,0.60943564}, {3600,0.62554455}, {3650,0.63244554}, {3700,0.65600990}, {3750,0.64622772}, {3800,0.65809901}, {3850,0.66648515}, {3900,0.65832673}, {3950,0.67537624}, {4000,0.70745545}, {4050,0.69601980}, {4100,0.69188119}, {4150,0.70358416}, {4200,0.74099010}, {4250,0.73928713}, {4300,0.72963366}, {4350,0.76010891}, {4400,0.76915842}, {4450,0.76834653}, {4500,0.77181188}, {4550,0.78399010}, {4600,0.79213861}, {4650,0.82017822}, {4700,0.79772277}, {4750,0.80977228}, {4800,0.82432673}, {4850,0.84887129}, {4900,0.83365347}, {4950,0.85939604}, {5000,0.86275248}, {5050,0.88708911}, {5100,0.90274257}, {5150,0.91737624}, {5200,0.89125743}, {5250,0.92416832}, {5300,0.90929703}, {5350,0.92556436}, {5400,0.94953465}, {5450,0.96551485}, {5500,0.96347525}, {5550,0.94804950}, {5600,0.96989109}, {5650,0.98434653}, {5700,1.01884158}, {5750,0.98996040}, {5800,1.00226733}, {5850,1.05724752}, {5900,1.02763366}, {5950,1.03263366}, {6000,1.04868317}, {6050,1.1053143}, {6100,1.1189714}, {6150,1.1034857}, {6200,1.1245429}, {6250,1.1430571}, {6300,1.1483429}, {6350,1.1502857}, {6400,1.1380286}, {6450,1.1728857}, {6500,1.2054286}, {6550,1.2171714}, {6600,1.2115143}, {6650,1.2292286}, {6700,1.2628000}, {6750,1.2637429}, {6800,1.2552857}, {6850,1.2795714}, {6900,1.2837714}, {6950,1.3045429}, {7000,1.2928286}, {7050,1.2974286}, {7100,1.3167429}, {7150,1.3238857}, {7200,1.3049143}, {7250,1.3231429}, {7300,1.3108857}, {7350,1.3162286}, {7400,1.3276571}, {7450,1.3502000}, {7500,1.3761429}, {7550,1.4068571}, {7600,1.4055429}, {7650,1.4110857}, {7700,1.4043714}, {7750,1.3917714}, {7800,1.4129143}, {7850,1.4764857}, {7900,1.4588857}, {7950,1.4553429}, {8000,1.4569143}, {8050,1.4720286}, {8100,1.4592000}, {8150,1.5183143}, {8200,1.4948571}, {8250,1.5153143}, {8300,1.4915714}, {8350,1.5464571}, {8400,1.5420000}, {8450,1.5398000}, {8500,1.5324000}, {8550,1.5822571}, {8600,1.5838857}, {8650,1.5710000}, {8700,1.5898000}, {8750,1.6300857}, {8800,1.6182286}, {8850,1.5887429}, {8900,1.6689143}, {8950,1.6674857}, {9000,1.6115429}, {9050,1.6636286}, {9100,1.6817714}, {9150,1.6711143}, {9200,1.7240857}, {9250,1.6697429}, {9300,1.7362571}, {9350,1.7253143}, {9400,1.7178571}, {9450,1.7555714}, {9500,1.7387429}, {9550,1.7724857}, {9600,1.7789714}, {9650,1.7690286}, {9700,1.7936000}, {9750,1.7698571}, {9800,1.8002857}, {9850,1.7954000}, {9900,1.8340286}, {9950,1.8254571}, {10000,1.8429143}, {10100,1.8794571}, {10200,1.8918571}, {10300,1.8793429}, {10400,1.9221143}, {10500,1.8463143}, {10600,1.9592857}, {10700,1.9223714}, {10800,2.0094000}, {10900,1.9649714}, {11000,2.0436286}, {11100,2.0004857}, {11200,2.0495143}, {11300,2.0502857}, {11400,2.0631143}, {11500,2.1118571}, {11600,2.1024000}, {11700,2.1733143}, {11800,2.1408286}, {11900,2.1707143}, {12000,2.2286857}, {12100,2.2123714}, {12200,2.2439143}, {12300,2.2530571}, {12400,2.2623714}, {12500,2.2659714}, {12600,2.3755714}, {12700,2.3366286}, {12800,2.3138857}, {12900,2.3343714}, {13000,2.3757143}, {13100,2.4169429}, {13200,2.4159143}, {13300,2.4366286}, {13400,2.4301143}, {13500,2.4858286}, {13600,2.4921714}, {13700,2.4958857}, {13800,2.5300857}, {13900,2.5393429}, {14000,2.5648857}, {14100,2.5929143}, {14200,2.6135429}, {14300,2.6441714}, {14400,2.8672000}, {14500,2.8338857}, {14600,2.6625714}, {14700,2.6928000}, {14800,2.6884857}, {14900,2.7156000}, {15000,2.7231714}, {15100,2.7885143}, {15200,2.7519143}, {15300,2.7666571}, {15400,2.8854286}, {15500,2.9037143}, {15600,3.0134286}, {15700,2.9012000}, {15800,3.1338000}, {15900,2.9082286}, {16000,3.2216571}, {16100,2.9354000}, {16200,2.9320286}, {16300,3.0581714}, {16400,3.0373143}, {16500,2.9848286}, {16600,2.9934286}, {16700,3.0194000}, {16800,3.0169429}, {16900,3.1283143}, {17000,3.1864857}, {17100,3.1988857}, {17200,3.1056000}, {17300,3.1549714}, {17400,3.1569714}, {17500,3.1918286}, {17600,3.2461714}, {17700,3.2860286}, {17800,3.2424571}, {17900,3.3488000}, {18000,3.3240286}, {18100,3.5012286}, {18200,3.3003143}, {18300,3.4147143}, {18400,3.5007429}, {18500,3.4329143}, {18600,3.6354571}, {18700,3.4600857}, {18800,3.4985143}, {18900,3.5150571}, {19000,3.4551143}, {19100,3.4437714}, {19200,3.4382857}, {19300,3.5077429}, {19400,3.5432857}, {19500,3.7113143}, {19600,3.6306857}, {19700,3.9262286}, {19800,3.9251429}, {19900,3.6328857}, {20000,3.8253714}};
data["big_flat"]["LtacTCExplicitCtx"]["actual reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003960}, {4,0.00002970}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00002970}, {11,0.00000000}, {12,0.00006931}, {13,0.00006931}, {14,0.00000000}, {15,0.00000000}, {16,0.00007921}, {17,0.00003960}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00006931}, {25,0.00007921}, {26,0.00002970}, {27,0.00000000}, {28,0.00003960}, {29,0.00000000}, {30,0.00002970}, {31,0.00000000}, {32,0.00000000}, {33,0.00003960}, {34,0.00006931}, {35,0.00000000}, {36,0.00007921}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003960}, {42,0.00003960}, {43,0.00003960}, {44,0.00000000}, {45,0.00007921}, {46,0.00003960}, {47,0.00000000}, {48,0.00007921}, {49,0.00000000}, {50,0.00000000}, {51,0.00003960}, {52,0.00000000}, {53,0.00002970}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00002970}, {60,0.00000000}, {61,0.00011881}, {62,0.00003960}, {63,0.00007921}, {64,0.00006931}, {65,0.00000000}, {66,0.00000000}, {67,0.00003960}, {68,0.00000000}, {69,0.00003960}, {70,0.00003960}, {71,0.00000000}, {72,0.00007921}, {73,0.00003960}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00002970}, {79,0.00000000}, {80,0.00000000}, {81,0.00003960}, {82,0.00003960}, {83,0.00000000}, {84,0.00000000}, {85,0.00003960}, {86,0.00000000}, {87,0.00003960}, {88,0.00000000}, {89,0.00000000}, {90,0.00002970}, {91,0.00003960}, {92,0.00007921}, {93,0.00007921}, {94,0.00003960}, {95,0.00007921}, {96,0.00014851}, {97,0.00003960}, {98,0.00007921}, {99,0.00000000}, {100,0.00000000}, {101,0.00003960}, {102,0.00000000}, {103,0.00000000}, {104,0.00002970}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00003960}, {109,0.00000000}, {110,0.00003960}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00003960}, {117,0.00007921}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00007921}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00003960}, {127,0.00003960}, {128,0.00003960}, {129,0.00000000}, {130,0.00000000}, {131,0.00015842}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00003960}, {136,0.00007921}, {137,0.00000000}, {138,0.00000000}, {139,0.00014851}, {140,0.00000000}, {141,0.00003960}, {142,0.00007921}, {143,0.00003960}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00007921}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00010891}, {154,0.00003960}, {155,0.00007921}, {156,0.00011881}, {157,0.00000000}, {158,0.00003960}, {159,0.00000000}, {160,0.00000000}, {161,0.00002970}, {162,0.00000000}, {163,0.00006931}, {164,0.00000000}, {165,0.00003960}, {166,0.00000000}, {167,0.00003960}, {168,0.00003960}, {169,0.00003960}, {170,0.00018812}, {171,0.00000000}, {172,0.00003960}, {173,0.00003960}, {174,0.00019802}, {175,0.00003960}, {176,0.00000000}, {177,0.00000000}, {178,0.00017822}, {179,0.00015842}, {180,0.00000000}, {181,0.00000000}, {182,0.00003960}, {183,0.00000000}, {184,0.00022772}, {185,0.00015842}, {186,0.00007921}, {187,0.00007921}, {188,0.00003960}, {189,0.00000000}, {190,0.00011881}, {191,0.00000000}, {192,0.00000000}, {193,0.00002970}, {194,0.00003960}, {195,0.00000000}, {196,0.00000000}, {197,0.00003960}, {198,0.00000000}, {199,0.00006931}, {200,0.00003960}, {201,0.00002970}, {202,0.00003960}, {203,0.00000000}, {204,0.00003960}, {205,0.00003960}, {206,0.00000000}, {207,0.00009901}, {208,0.00000000}, {209,0.00014851}, {210,0.00000000}, {211,0.00003960}, {212,0.00000000}, {213,0.00003960}, {214,0.00000000}, {215,0.00000000}, {216,0.00003960}, {217,0.00007921}, {218,0.00000000}, {219,0.00003960}, {220,0.00000000}, {221,0.00007921}, {222,0.00000000}, {223,0.00007921}, {224,0.00000000}, {225,0.00027723}, {226,0.00000000}, {227,0.00003960}, {228,0.00030693}, {229,0.00000000}, {230,0.00000000}, {231,0.00007921}, {232,0.00003960}, {233,0.00003960}, {234,0.00000000}, {235,0.00003960}, {236,0.00000000}, {237,0.00007921}, {238,0.00000000}, {239,0.00000000}, {240,0.00011881}, {241,0.00003960}, {242,0.00010891}, {243,0.00003960}, {244,0.00006931}, {245,0.00000000}, {246,0.00003960}, {247,0.00003960}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00003960}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00003960}, {257,0.00011881}, {258,0.00000000}, {259,0.00003960}, {260,0.00000000}, {261,0.00015842}, {262,0.00000000}, {263,0.00000000}, {264,0.00003960}, {265,0.00003960}, {266,0.00003960}, {267,0.00000000}, {268,0.00003960}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00003960}, {273,0.00000000}, {274,0.00000000}, {275,0.00003960}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00003960}, {280,0.00006931}, {281,0.00007921}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00003960}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00003960}, {296,0.00002970}, {297,0.00000000}, {298,0.00000000}, {299,0.00003960}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00003960}, {308,0.00003960}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00003960}, {316,0.00000000}, {317,0.00000000}, {318,0.00003960}, {319,0.00006931}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00003960}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00003960}, {336,0.00003960}, {337,0.00000000}, {338,0.00000000}, {339,0.00003960}, {340,0.00003960}, {341,0.00011881}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00003960}, {346,0.00011881}, {347,0.00002970}, {348,0.00019802}, {349,0.00000000}, {350,0.00034653}, {351,0.00002970}, {352,0.00011881}, {353,0.00000000}, {354,0.00011881}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00003960}, {359,0.00027723}, {360,0.00000000}, {361,0.00003960}, {362,0.00007921}, {363,0.00000000}, {364,0.00000000}, {365,0.00010891}, {366,0.00000000}, {367,0.00003960}, {368,0.00019802}, {369,0.00007921}, {370,0.00010891}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00007921}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00003960}, {382,0.00003960}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00003960}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00003960}, {391,0.00000000}, {392,0.00000000}, {393,0.00003960}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00007921}, {398,0.00000000}, {399,0.00000000}, {400,0.00002970}, {401,0.00006931}, {402,0.00003960}, {403,0.00003960}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00003960}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00007921}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00003960}, {423,0.00000000}, {424,0.00007921}, {425,0.00000000}, {426,0.00000000}, {427,0.00003960}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00007921}, {435,0.00000000}, {436,0.00000000}, {437,0.00003960}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00003960}, {442,0.00000000}, {443,0.00003960}, {444,0.00003960}, {445,0.00003960}, {446,0.00000000}, {447,0.00000000}, {448,0.00003960}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00003960}, {453,0.00003960}, {454,0.00003960}, {455,0.00003960}, {456,0.00000000}, {457,0.00006931}, {458,0.00003960}, {459,0.00000000}, {460,0.00003960}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003960}, {469,0.00003960}, {470,0.00003960}, {471,0.00000000}, {472,0.00003960}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00007921}, {479,0.00000000}, {480,0.00007921}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00003960}, {485,0.00000000}, {486,0.00003960}, {487,0.00003960}, {488,0.00007921}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00007921}, {495,0.00000000}, {496,0.00007921}, {497,0.00003960}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00003960}, {520,0.00000000}, {525,0.00003960}, {530,0.00000000}, {535,0.00003960}, {540,0.00000000}, {545,0.00000000}, {550,0.00003960}, {555,0.00000000}, {560,0.00000000}, {565,0.00006931}, {570,0.00003960}, {575,0.00007921}, {580,0.00000000}, {585,0.00000000}, {590,0.00003960}, {595,0.00003960}, {600,0.00002970}, {605,0.00000000}, {610,0.00003960}, {615,0.00000000}, {620,0.00003960}, {625,0.00003960}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00003960}, {670,0.00007921}, {675,0.00003960}, {680,0.00007921}, {685,0.00000000}, {690,0.00003960}, {695,0.00000000}, {700,0.00003960}, {705,0.00006931}, {710,0.00003960}, {715,0.00000000}, {720,0.00011881}, {725,0.00000000}, {730,0.00003960}, {735,0.00000000}, {740,0.00003960}, {745,0.00000000}, {750,0.00003960}, {755,0.00000000}, {760,0.00000000}, {765,0.00003960}, {770,0.00003960}, {775,0.00000000}, {780,0.00003960}, {785,0.00003960}, {790,0.00000000}, {795,0.00003960}, {800,0.00003960}, {805,0.00000000}, {810,0.00000000}, {815,0.00003960}, {820,0.00000000}, {825,0.00003960}, {830,0.00000000}, {835,0.00003960}, {840,0.00003960}, {845,0.00015842}, {850,0.00000000}, {855,0.00007921}, {860,0.00003960}, {865,0.00003960}, {870,0.00000000}, {875,0.00000000}, {880,0.00003960}, {885,0.00007921}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00003960}, {910,0.00000000}, {915,0.00003960}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00007921}, {940,0.00003960}, {945,0.00003960}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00003960}, {975,0.00000000}, {980,0.00002970}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00010891}, {1020,0.00000000}, {1030,0.00003960}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00003960}, {1090,0.00007921}, {1100,0.00003960}, {1110,0.00003960}, {1120,0.00003960}, {1130,0.00000000}, {1140,0.00003960}, {1150,0.00000000}, {1160,0.00003960}, {1170,0.00003960}, {1180,0.00003960}, {1190,0.00003960}, {1200,0.00003960}, {1210,0.00007921}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00003960}, {1280,0.00007921}, {1290,0.00003960}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00011881}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00007921}, {1360,0.00003960}, {1370,0.00003960}, {1380,0.00000000}, {1390,0.00003960}, {1400,0.00011881}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00003960}, {1440,0.00000000}, {1450,0.00003960}, {1460,0.00000000}, {1470,0.00011881}, {1480,0.00000000}, {1490,0.00011881}, {1500,0.00007921}, {1510,0.00000000}, {1520,0.00007921}, {1530,0.00003960}, {1540,0.00000000}, {1550,0.00007921}, {1560,0.00003960}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00003960}, {1600,0.00000000}, {1610,0.00007921}, {1620,0.00003960}, {1630,0.00007921}, {1640,0.00003960}, {1650,0.00003960}, {1660,0.00011881}, {1670,0.00007921}, {1680,0.00003960}, {1690,0.00003960}, {1700,0.00015842}, {1710,0.00007921}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00003960}, {1750,0.00011881}, {1760,0.00000000}, {1770,0.00003960}, {1780,0.00006931}, {1790,0.00000000}, {1800,0.00003960}, {1810,0.00003960}, {1820,0.00000000}, {1830,0.00011881}, {1840,0.00003960}, {1850,0.00015842}, {1860,0.00003960}, {1870,0.00003960}, {1880,0.00010891}, {1890,0.00000000}, {1900,0.00019802}, {1910,0.00003960}, {1920,0.00003960}, {1930,0.00000000}, {1940,0.00007921}, {1950,0.00003960}, {1960,0.00003960}, {1970,0.00000000}, {1980,0.00007921}, {1990,0.00003960}, {2000,0.00000000}, {2050,0.00006931}, {2100,0.00007921}, {2150,0.00003960}, {2200,0.00003960}, {2250,0.00007921}, {2300,0.00007921}, {2350,0.00011881}, {2400,0.00007921}, {2450,0.00002970}, {2500,0.00011881}, {2550,0.00011881}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00015842}, {2850,0.00254455}, {2900,0.00015842}, {2950,0.00000000}, {3000,0.00003960}, {3050,0.00007921}, {3100,0.00276238}, {3150,0.00003960}, {3200,0.00007921}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00007921}, {3400,0.00007921}, {3450,0.00000000}, {3500,0.00003960}, {3550,0.00007921}, {3600,0.00003960}, {3650,0.00007921}, {3700,0.00019802}, {3750,0.00007921}, {3800,0.00002970}, {3850,0.00015842}, {3900,0.00003960}, {3950,0.00000000}, {4000,0.00007921}, {4050,0.00027723}, {4100,0.00007921}, {4150,0.00019802}, {4200,0.00006931}, {4250,0.00019802}, {4300,0.00011881}, {4350,0.00007921}, {4400,0.00000000}, {4450,0.00011881}, {4500,0.00000000}, {4550,0.00003960}, {4600,0.00007921}, {4650,0.00007921}, {4700,0.00003960}, {4750,0.00003960}, {4800,0.00015842}, {4850,0.00019802}, {4900,0.00000000}, {4950,0.00015842}, {5000,0.00019802}, {5050,0.00019802}, {5100,0.00015842}, {5150,0.00003960}, {5200,0.00003960}, {5250,0.00011881}, {5300,0.00038614}, {5350,0.00023762}, {5400,0.00015842}, {5450,0.00015842}, {5500,0.00003960}, {5550,0.00007921}, {5600,0.00007921}, {5650,0.00003960}, {5700,0.00015842}, {5750,0.00015842}, {5800,0.00010891}, {5850,0.00007921}, {5900,0.00027723}, {5950,0.00007921}, {6000,0.00007921}, {6050,0.0056857}, {6100,0.0070286}, {6150,0.0002286}, {6200,0.0002286}, {6250,0.0046857}, {6300,0.0001143}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0001143}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0001143}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0001143}, {6850,0.0001143}, {6900,0.0001143}, {6950,0.0001143}, {7000,0.0000000}, {7050,0.0001143}, {7100,0.0001143}, {7150,0.0000000}, {7200,0.0003143}, {7250,0.0001143}, {7300,0.0001143}, {7350,0.0000000}, {7400,0.0001143}, {7450,0.0001143}, {7500,0.0000000}, {7550,0.0001143}, {7600,0.0003429}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0001143}, {7800,0.0002286}, {7850,0.0002286}, {7900,0.0002286}, {7950,0.0000000}, {8000,0.0001143}, {8050,0.0000000}, {8100,0.0002286}, {8150,0.0000000}, {8200,0.0004571}, {8250,0.0000000}, {8300,0.0004571}, {8350,0.0001143}, {8400,0.0002286}, {8450,0.0002286}, {8500,0.0000000}, {8550,0.0002286}, {8600,0.0001143}, {8650,0.0000000}, {8700,0.0001143}, {8750,0.0000000}, {8800,0.0001143}, {8850,0.0004571}, {8900,0.0001143}, {8950,0.0001143}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0001143}, {9150,0.0004571}, {9200,0.0002286}, {9250,0.0002286}, {9300,0.0021143}, {9350,0.0002286}, {9400,0.0002286}, {9450,0.0002286}, {9500,0.0001143}, {9550,0.0001143}, {9600,0.0002000}, {9650,0.0000000}, {9700,0.0002000}, {9750,0.0003429}, {9800,0.0000000}, {9850,0.0001143}, {9900,0.0000000}, {9950,0.0001143}, {10000,0.0002000}, {10100,0.0000000}, {10200,0.0001143}, {10300,0.0002000}, {10400,0.0000000}, {10500,0.0001143}, {10600,0.0001143}, {10700,0.0003429}, {10800,0.0003429}, {10900,0.0001143}, {11000,0.0002286}, {11100,0.0001143}, {11200,0.0003429}, {11300,0.0001143}, {11400,0.0001143}, {11500,0.0002000}, {11600,0.0001143}, {11700,0.0003429}, {11800,0.0003429}, {11900,0.0003143}, {12000,0.0000000}, {12100,0.0001143}, {12200,0.0003429}, {12300,0.0000000}, {12400,0.0001143}, {12500,0.0003429}, {12600,0.0004286}, {12700,0.0000000}, {12800,0.0002286}, {12900,0.0004571}, {13000,0.0001143}, {13100,0.0008000}, {13200,0.0000000}, {13300,0.0003429}, {13400,0.0002286}, {13500,0.0000857}, {13600,0.0000000}, {13700,0.0001143}, {13800,0.0000000}, {13900,0.0003429}, {14000,0.0002000}, {14100,0.0004571}, {14200,0.0002000}, {14300,0.0000000}, {14400,0.0003429}, {14500,0.0003429}, {14600,0.0005429}, {14700,0.0006857}, {14800,0.0010286}, {14900,0.0001143}, {15000,0.0003429}, {15100,0.0003429}, {15200,0.0001143}, {15300,0.0003429}, {15400,0.0004286}, {15500,0.0008000}, {15600,0.0013143}, {15700,0.0017143}, {15800,0.0006857}, {15900,0.0001143}, {16000,0.0006571}, {16100,0.0018286}, {16200,0.0010857}, {16300,0.0013429}, {16400,0.0022857}, {16500,0.0018000}, {16600,0.0003429}, {16700,0.0016000}, {16800,0.0005714}, {16900,0.0000000}, {17000,0.0002286}, {17100,0.0005714}, {17200,0.0005714}, {17300,0.0009143}, {17400,0.0008000}, {17500,0.0003429}, {17600,0.0003429}, {17700,0.0006571}, {17800,0.0002286}, {17900,0.0001143}, {18000,0.0000000}, {18100,0.0010286}, {18200,0.0004571}, {18300,0.0005714}, {18400,0.0001143}, {18500,0.0002286}, {18600,0.0022571}, {18700,0.0003429}, {18800,0.0006857}, {18900,0.0003429}, {19000,0.0000000}, {19100,0.0002286}, {19200,0.0012571}, {19300,0.0017143}, {19400,0.0001143}, {19500,0.0016857}, {19600,0.0012571}, {19700,0.0022571}, {19800,0.0016857}, {19900,0.0008571}, {20000,0.0017143}};
data["big_flat"]["LtacTCExplicitCtx"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00100990}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00100000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00100000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000990}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000990}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000990}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000990}, {426,0.00000000}, {427,0.00000990}, {428,0.00000000}, {429,0.00000000}, {430,0.00000990}, {431,0.00001980}, {432,0.00001980}, {433,0.00000990}, {434,0.00000000}, {435,0.00001980}, {436,0.00001980}, {437,0.00000990}, {438,0.00000990}, {439,0.00000000}, {440,0.00001980}, {441,0.00001980}, {442,0.00000990}, {443,0.00000990}, {444,0.00003960}, {445,0.00001980}, {446,0.00001980}, {447,0.00002970}, {448,0.00003960}, {449,0.00004950}, {450,0.00002970}, {451,0.00006931}, {452,0.00009901}, {453,0.00005941}, {454,0.00007921}, {455,0.00012871}, {456,0.00017822}, {457,0.00019802}, {458,0.00019802}, {459,0.00025743}, {460,0.00025743}, {461,0.00031683}, {462,0.00034653}, {463,0.00033663}, {464,0.00042574}, {465,0.00049505}, {466,0.00048515}, {467,0.00052475}, {468,0.00063366}, {469,0.00049505}, {470,0.00057426}, {471,0.00061386}, {472,0.00056436}, {473,0.00057426}, {474,0.00057426}, {475,0.00067327}, {476,0.00057426}, {477,0.00066337}, {478,0.00065347}, {479,0.00075248}, {480,0.00075248}, {481,0.00074257}, {482,0.00075248}, {483,0.00078218}, {484,0.00080198}, {485,0.00082178}, {486,0.00081188}, {487,0.00081188}, {488,0.00089109}, {489,0.00092079}, {490,0.00085149}, {491,0.00091089}, {492,0.00096040}, {493,0.00095050}, {494,0.00097030}, {495,0.00093069}, {496,0.00094059}, {497,0.00093069}, {498,0.00096040}, {499,0.00097030}, {500,0.00093069}, {505,0.00099010}, {510,0.00099010}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00100000}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00100000}, {830,0.00100000}, {835,0.00100000}, {840,0.00100000}, {845,0.00100000}, {850,0.00100000}, {855,0.00100000}, {860,0.00100000}, {865,0.00100000}, {870,0.00100990}, {875,0.00100000}, {880,0.00101980}, {885,0.00101980}, {890,0.00105941}, {895,0.00318812}, {900,0.00106931}, {905,0.00102970}, {910,0.00103960}, {915,0.00105941}, {920,0.00105941}, {925,0.00107921}, {930,0.00112871}, {935,0.00118812}, {940,0.00130693}, {945,0.00152475}, {950,0.00151485}, {955,0.00158416}, {960,0.00157426}, {965,0.00155446}, {970,0.00161386}, {975,0.00166337}, {980,0.00174257}, {985,0.00181188}, {990,0.00367327}, {995,0.00189109}, {1000,0.00195050}, {1010,0.00194059}, {1020,0.00199010}, {1030,0.00199010}, {1040,0.00200000}, {1050,0.00200000}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200000}, {1140,0.00200000}, {1150,0.00200000}, {1160,0.00200000}, {1170,0.00200000}, {1180,0.00200000}, {1190,0.00200000}, {1200,0.00200000}, {1210,0.00438614}, {1220,0.00200000}, {1230,0.00200000}, {1240,0.00200000}, {1250,0.00200000}, {1260,0.00200000}, {1270,0.00200000}, {1280,0.00200000}, {1290,0.00200000}, {1300,0.00200000}, {1310,0.00408911}, {1320,0.00200000}, {1330,0.00200990}, {1340,0.00201980}, {1350,0.00200990}, {1360,0.00202970}, {1370,0.00202970}, {1380,0.00206931}, {1390,0.00210891}, {1400,0.00536634}, {1410,0.00225743}, {1420,0.00236634}, {1430,0.00246535}, {1440,0.00245545}, {1450,0.00249505}, {1460,0.00251485}, {1470,0.00259406}, {1480,0.00272277}, {1490,0.00280198}, {1500,0.00292079}, {1510,0.00297030}, {1520,0.00294059}, {1530,0.00297030}, {1540,0.00300000}, {1550,0.00300000}, {1560,0.00300000}, {1570,0.00300000}, {1580,0.00300000}, {1590,0.00300000}, {1600,0.00300000}, {1610,0.00300000}, {1620,0.00300000}, {1630,0.00300000}, {1640,0.00300000}, {1650,0.00300000}, {1660,0.00300000}, {1670,0.00300000}, {1680,0.00300000}, {1690,0.00300000}, {1700,0.00300000}, {1710,0.00300000}, {1720,0.00300000}, {1730,0.00300000}, {1740,0.00300990}, {1750,0.00300000}, {1760,0.00300990}, {1770,0.00300990}, {1780,0.00300000}, {1790,0.00300990}, {1800,0.00301980}, {1810,0.00587129}, {1820,0.00709901}, {1830,0.00306931}, {1840,0.00311881}, {1850,0.00311881}, {1860,0.00315842}, {1870,0.00321782}, {1880,0.00345545}, {1890,0.00339604}, {1900,0.00347525}, {1910,0.00344554}, {1920,0.00347525}, {1930,0.00355446}, {1940,0.00357426}, {1950,0.00364356}, {1960,0.00364356}, {1970,0.00388119}, {1980,0.00383168}, {1990,0.00397030}, {2000,0.00399010}, {2050,0.00400000}, {2100,0.00400000}, {2150,0.00400000}, {2200,0.00400990}, {2250,0.00407921}, {2300,0.00419802}, {2350,0.00448515}, {2400,0.00460396}, {2450,0.00492079}, {2500,0.00500000}, {2550,0.00500000}, {2600,0.00500000}, {2650,0.00501980}, {2700,0.00901980}, {2750,0.00949505}, {2800,0.00552475}, {2850,0.00557426}, {2900,0.00991089}, {2950,0.00882178}, {3000,0.00600000}, {3050,0.00601980}, {3100,0.01185149}, {3150,0.01071287}, {3200,0.00630693}, {3250,0.00657426}, {3300,0.00662376}, {3350,0.00673267}, {3400,0.00697030}, {3450,0.00702970}, {3500,0.00704950}, {3550,0.00705941}, {3600,0.00716832}, {3650,0.01355446}, {3700,0.00759406}, {3750,0.00759406}, {3800,0.00773267}, {3850,0.00792079}, {3900,0.00804950}, {3950,0.00807921}, {4000,0.00813861}, {4050,0.00824752}, {4100,0.00844554}, {4150,0.01580198}, {4200,0.00862376}, {4250,0.00869307}, {4300,0.00889109}, {4350,0.00906931}, {4400,0.00911881}, {4450,0.00913861}, {4500,0.00925743}, {4550,0.00950495}, {4600,0.00965347}, {4650,0.00965347}, {4700,0.00971287}, {4750,0.00998020}, {4800,0.01009901}, {4850,0.01015842}, {4900,0.01669307}, {4950,0.01039604}, {5000,0.01068317}, {5050,0.01071287}, {5100,0.01080198}, {5150,0.01086139}, {5200,0.01100000}, {5250,0.01627723}, {5300,0.01120792}, {5350,0.01122772}, {5400,0.01152475}, {5450,0.01171287}, {5500,0.01173267}, {5550,0.01813861}, {5600,0.01190099}, {5650,0.01204950}, {5700,0.01214851}, {5750,0.01224752}, {5800,0.01234653}, {5850,0.01261386}, {5900,0.01274257}, {5950,0.01281188}, {6000,0.01285149}, {6050,0.0142000}, {6100,0.0194000}, {6150,0.0298286}, {6200,0.0144286}, {6250,0.0302000}, {6300,0.0148571}, {6350,0.0148857}, {6400,0.0151143}, {6450,0.0150000}, {6500,0.0153429}, {6550,0.0153714}, {6600,0.0154286}, {6650,0.0158000}, {6700,0.0158000}, {6750,0.0159714}, {6800,0.0161714}, {6850,0.0162857}, {6900,0.0162857}, {6950,0.0164857}, {7000,0.0219714}, {7050,0.0345429}, {7100,0.0169143}, {7150,0.0170857}, {7200,0.0171429}, {7250,0.0172286}, {7300,0.0342000}, {7350,0.0174857}, {7400,0.0175143}, {7450,0.0271714}, {7500,0.0180571}, {7550,0.0180857}, {7600,0.0319143}, {7650,0.0318286}, {7700,0.0186000}, {7750,0.0294857}, {7800,0.0188857}, {7850,0.0191429}, {7900,0.0306000}, {7950,0.0359143}, {8000,0.0194286}, {8050,0.0274000}, {8100,0.0195429}, {8150,0.0198000}, {8200,0.0294000}, {8250,0.0199143}, {8300,0.0455143}, {8350,0.0202000}, {8400,0.0263143}, {8450,0.0204000}, {8500,0.0207143}, {8550,0.0209714}, {8600,0.0418000}, {8650,0.0211714}, {8700,0.0212857}, {8750,0.0216000}, {8800,0.0217429}, {8850,0.0218571}, {8900,0.0219143}, {8950,0.0218857}, {9000,0.0385429}, {9050,0.0223714}, {9100,0.0224857}, {9150,0.0224286}, {9200,0.0402000}, {9250,0.0435714}, {9300,0.0546857}, {9350,0.0232857}, {9400,0.0428286}, {9450,0.0350000}, {9500,0.0235714}, {9550,0.0234571}, {9600,0.0237429}, {9650,0.0238571}, {9700,0.0240857}, {9750,0.0241143}, {9800,0.0402286}, {9850,0.0244000}, {9900,0.0243714}, {9950,0.0246857}, {10000,0.0502000}, {10100,0.0360571}, {10200,0.0350571}, {10300,0.0255714}, {10400,0.0258000}, {10500,0.0259143}, {10600,0.0261143}, {10700,0.0264571}, {10800,0.0267429}, {10900,0.0269143}, {11000,0.0270857}, {11100,0.0275429}, {11200,0.0276571}, {11300,0.0281143}, {11400,0.0284571}, {11500,0.0512286}, {11600,0.0287714}, {11700,0.0450000}, {11800,0.0294000}, {11900,0.0295714}, {12000,0.0298571}, {12100,0.0302857}, {12200,0.0304286}, {12300,0.0307143}, {12400,0.0444286}, {12500,0.0554286}, {12600,0.0449714}, {12700,0.0315429}, {12800,0.0317143}, {12900,0.0650000}, {13000,0.0523429}, {13100,0.0328857}, {13200,0.0329714}, {13300,0.0331143}, {13400,0.0630000}, {13500,0.0682000}, {13600,0.0628000}, {13700,0.0341714}, {13800,0.0346000}, {13900,0.0349429}, {14000,0.0348571}, {14100,0.0355714}, {14200,0.0491429}, {14300,0.0361143}, {14400,0.0363714}, {14500,0.0702571}, {14600,0.0367429}, {14700,0.0368857}, {14800,0.0372286}, {14900,0.0374571}, {15000,0.0376571}, {15100,0.0378857}, {15200,0.0698857}, {15300,0.0704571}, {15400,0.0691714}, {15500,0.0388571}, {15600,0.0391429}, {15700,0.0394571}, {15800,0.0720000}, {15900,0.0507429}, {16000,0.0580571}, {16100,0.0801429}, {16200,0.0542857}, {16300,0.0408857}, {16400,0.0412857}, {16500,0.0732000}, {16600,0.0587714}, {16700,0.0419143}, {16800,0.0422571}, {16900,0.0748286}, {17000,0.0428286}, {17100,0.0433714}, {17200,0.0432286}, {17300,0.0643143}, {17400,0.0440857}, {17500,0.0914286}, {17600,0.0700286}, {17700,0.0437714}, {17800,0.0848000}, {17900,0.0858000}, {18000,0.0454857}, {18100,0.0621714}, {18200,0.0461143}, {18300,0.0577714}, {18400,0.0467429}, {18500,0.0468286}, {18600,0.0936857}, {18700,0.0472286}, {18800,0.0477143}, {18900,0.0481429}, {19000,0.0482000}, {19100,0.0484857}, {19200,0.0503429}, {19300,0.0722286}, {19400,0.0494857}, {19500,0.0501714}, {19600,0.0499714}, {19700,0.0693143}, {19800,0.0720857}, {19900,0.0814571}, {20000,0.0634571}};
data["big_flat"]["LtacTCExplicitCtx"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00006931}, {3,0.00000000}, {4,0.00002970}, {5,0.00000000}, {6,0.00005941}, {7,0.00002970}, {8,0.00000000}, {9,0.00002970}, {10,0.00009901}, {11,0.00000000}, {12,0.00003960}, {13,0.00010891}, {14,0.00002970}, {15,0.00007921}, {16,0.00000000}, {17,0.00002970}, {18,0.00000000}, {19,0.00010891}, {20,0.00006931}, {21,0.00000000}, {22,0.00000000}, {23,0.00010891}, {24,0.00011881}, {25,0.00000000}, {26,0.00003960}, {27,0.00009901}, {28,0.00000000}, {29,0.00009901}, {30,0.00010891}, {31,0.00003960}, {32,0.00006931}, {33,0.00017822}, {34,0.00019802}, {35,0.00003960}, {36,0.00006931}, {37,0.00006931}, {38,0.00009901}, {39,0.00005941}, {40,0.00007921}, {41,0.00024752}, {42,0.00006931}, {43,0.00007921}, {44,0.00027723}, {45,0.00000000}, {46,0.00017822}, {47,0.00012871}, {48,0.00000000}, {49,0.00009901}, {50,0.00006931}, {51,0.00010891}, {52,0.00010891}, {53,0.00011881}, {54,0.00020792}, {55,0.00013861}, {56,0.00018812}, {57,0.00015842}, {58,0.00009901}, {59,0.00010891}, {60,0.00000000}, {61,0.00012871}, {62,0.00021782}, {63,0.00012871}, {64,0.00006931}, {65,0.00012871}, {66,0.00002970}, {67,0.00005941}, {68,0.00006931}, {69,0.00015842}, {70,0.00019802}, {71,0.00006931}, {72,0.00022772}, {73,0.00016832}, {74,0.00022772}, {75,0.00002970}, {76,0.00018812}, {77,0.00009901}, {78,0.00027723}, {79,0.00022772}, {80,0.00002970}, {81,0.00014851}, {82,0.00018812}, {83,0.00023762}, {84,0.00017822}, {85,0.00012871}, {86,0.00033663}, {87,0.00007921}, {88,0.00014851}, {89,0.00024752}, {90,0.00035644}, {91,0.00025743}, {92,0.00020792}, {93,0.00014851}, {94,0.00017822}, {95,0.00025743}, {96,0.00008911}, {97,0.00021782}, {98,0.00026733}, {99,0.00018812}, {100,0.00026733}, {101,0.00027723}, {102,0.00025743}, {103,0.00014851}, {104,0.00021782}, {105,0.00027723}, {106,0.00016832}, {107,0.00015842}, {108,0.00011881}, {109,0.00023762}, {110,0.00025743}, {111,0.00005941}, {112,0.00009901}, {113,0.00021782}, {114,0.00022772}, {115,0.00026733}, {116,0.00037624}, {117,0.00018812}, {118,0.00009901}, {119,0.00024752}, {120,0.00011881}, {121,0.00018812}, {122,0.00034653}, {123,0.00015842}, {124,0.00020792}, {125,0.00017822}, {126,0.00033663}, {127,0.00016832}, {128,0.00021782}, {129,0.00011881}, {130,0.00031683}, {131,0.00019802}, {132,0.00017822}, {133,0.00027723}, {134,0.00025743}, {135,0.00036634}, {136,0.00009901}, {137,0.00010891}, {138,0.00027723}, {139,0.00039604}, {140,0.00019802}, {141,0.00019802}, {142,0.00036634}, {143,0.00022772}, {144,0.00035644}, {145,0.00010891}, {146,0.00035644}, {147,0.00018812}, {148,0.00031683}, {149,0.00032673}, {150,0.00033663}, {151,0.00035644}, {152,0.00021782}, {153,0.00032673}, {154,0.00046535}, {155,0.00017822}, {156,0.00021782}, {157,0.00039604}, {158,0.00028713}, {159,0.00027723}, {160,0.00038614}, {161,0.00038614}, {162,0.00025743}, {163,0.00015842}, {164,0.00031683}, {165,0.00024752}, {166,0.00032673}, {167,0.00052475}, {168,0.00025743}, {169,0.00026733}, {170,0.00028713}, {171,0.00042574}, {172,0.00021782}, {173,0.00016832}, {174,0.00043564}, {175,0.00024752}, {176,0.00041584}, {177,0.00033663}, {178,0.00024752}, {179,0.00037624}, {180,0.00021782}, {181,0.00041584}, {182,0.00058416}, {183,0.00022772}, {184,0.00030693}, {185,0.00043564}, {186,0.00035644}, {187,0.00053465}, {188,0.00021782}, {189,0.00061386}, {190,0.00031683}, {191,0.00029703}, {192,0.00049505}, {193,0.00048515}, {194,0.00047525}, {195,0.00048515}, {196,0.00028713}, {197,0.00043564}, {198,0.00025743}, {199,0.00040594}, {200,0.00040594}, {201,0.00048515}, {202,0.00059406}, {203,0.00035644}, {204,0.00026733}, {205,0.00041584}, {206,0.00044554}, {207,0.00033663}, {208,0.00053465}, {209,0.00028713}, {210,0.00060396}, {211,0.00032673}, {212,0.00017822}, {213,0.00062376}, {214,0.00037624}, {215,0.00057426}, {216,0.00052475}, {217,0.00061386}, {218,0.00040594}, {219,0.00050495}, {220,0.00079208}, {221,0.00054455}, {222,0.00062376}, {223,0.00048515}, {224,0.00044554}, {225,0.00048515}, {226,0.00037624}, {227,0.00041584}, {228,0.00060396}, {229,0.00046535}, {230,0.00071287}, {231,0.00050495}, {232,0.00068317}, {233,0.00034653}, {234,0.00051485}, {235,0.00027723}, {236,0.00057426}, {237,0.00037624}, {238,0.00050495}, {239,0.00069307}, {240,0.00047525}, {241,0.00056436}, {242,0.00052475}, {243,0.00035644}, {244,0.00038614}, {245,0.00042574}, {246,0.00046535}, {247,0.00038614}, {248,0.00042574}, {249,0.00040594}, {250,0.00056436}, {251,0.00046535}, {252,0.00061386}, {253,0.00039604}, {254,0.00035644}, {255,0.00035644}, {256,0.00035644}, {257,0.00038614}, {258,0.00042574}, {259,0.00064356}, {260,0.00041584}, {261,0.00065347}, {262,0.00067327}, {263,0.00044554}, {264,0.00069307}, {265,0.00048515}, {266,0.00050495}, {267,0.00043564}, {268,0.00064356}, {269,0.00041584}, {270,0.00045545}, {271,0.00044554}, {272,0.00056436}, {273,0.00058416}, {274,0.00046535}, {275,0.00045545}, {276,0.00038614}, {277,0.00042574}, {278,0.00030693}, {279,0.00037624}, {280,0.00039604}, {281,0.00049505}, {282,0.00024752}, {283,0.00051485}, {284,0.00036634}, {285,0.00064356}, {286,0.00041584}, {287,0.00054455}, {288,0.00015842}, {289,0.00061386}, {290,0.00071287}, {291,0.00057426}, {292,0.00043564}, {293,0.00068317}, {294,0.00070297}, {295,0.00077228}, {296,0.00055446}, {297,0.00056436}, {298,0.00033663}, {299,0.00061386}, {300,0.00052475}, {301,0.00033663}, {302,0.00095050}, {303,0.00046535}, {304,0.00060396}, {305,0.00072277}, {306,0.00037624}, {307,0.00055446}, {308,0.00044554}, {309,0.00069307}, {310,0.00052475}, {311,0.00032673}, {312,0.00063366}, {313,0.00075248}, {314,0.00048515}, {315,0.00065347}, {316,0.00048515}, {317,0.00062376}, {318,0.00058416}, {319,0.00032673}, {320,0.00041584}, {321,0.00051485}, {322,0.00047525}, {323,0.00076238}, {324,0.00057426}, {325,0.00076238}, {326,0.00040594}, {327,0.00045545}, {328,0.00067327}, {329,0.00066337}, {330,0.00038614}, {331,0.00048515}, {332,0.00070297}, {333,0.00039604}, {334,0.00061386}, {335,0.00067327}, {336,0.00062376}, {337,0.00133663}, {338,0.00065347}, {339,0.00049505}, {340,0.00047525}, {341,0.00055446}, {342,0.00159406}, {343,0.00082178}, {344,0.00063366}, {345,0.00066337}, {346,0.00057426}, {347,0.00058416}, {348,0.00062376}, {349,0.00061386}, {350,0.00049505}, {351,0.00050495}, {352,0.00082178}, {353,0.00070297}, {354,0.00073267}, {355,0.00060396}, {356,0.00057426}, {357,0.00058416}, {358,0.00046535}, {359,0.00050495}, {360,0.00055446}, {361,0.00086139}, {362,0.00065347}, {363,0.00070297}, {364,0.00068317}, {365,0.00093069}, {366,0.00089109}, {367,0.00112871}, {368,0.00080198}, {369,0.00076238}, {370,0.00093069}, {371,0.00072277}, {372,0.00061386}, {373,0.00164356}, {374,0.00063366}, {375,0.00069307}, {376,0.00061386}, {377,0.00070297}, {378,0.00097030}, {379,0.00086139}, {380,0.00061386}, {381,0.00063366}, {382,0.00085149}, {383,0.00077228}, {384,0.00070297}, {385,0.00060396}, {386,0.00087129}, {387,0.00053465}, {388,0.00081188}, {389,0.00076238}, {390,0.00090099}, {391,0.00085149}, {392,0.00057426}, {393,0.00102970}, {394,0.00081188}, {395,0.00080198}, {396,0.00059406}, {397,0.00087129}, {398,0.00088119}, {399,0.00062376}, {400,0.00087129}, {401,0.00095050}, {402,0.00091089}, {403,0.00089109}, {404,0.00062376}, {405,0.00100000}, {406,0.00074257}, {407,0.00065347}, {408,0.00075248}, {409,0.00101980}, {410,0.00090099}, {411,0.00077228}, {412,0.00071287}, {413,0.00064356}, {414,0.00090099}, {415,0.00089109}, {416,0.00089109}, {417,0.00081188}, {418,0.00079208}, {419,0.00100990}, {420,0.00087129}, {421,0.00061386}, {422,0.00078218}, {423,0.00120792}, {424,0.00094059}, {425,0.00076238}, {426,0.00081188}, {427,0.00070297}, {428,0.00091089}, {429,0.00088119}, {430,0.00096040}, {431,0.00097030}, {432,0.00086139}, {433,0.00086139}, {434,0.00070297}, {435,0.00086139}, {436,0.00059406}, {437,0.00068317}, {438,0.00093069}, {439,0.00078218}, {440,0.00105941}, {441,0.00079208}, {442,0.00093069}, {443,0.00119802}, {444,0.00099010}, {445,0.00092079}, {446,0.00053465}, {447,0.00053465}, {448,0.00099010}, {449,0.00091089}, {450,0.00087129}, {451,0.00070297}, {452,0.00110891}, {453,0.00046535}, {454,0.00095050}, {455,0.00102970}, {456,0.00120792}, {457,0.00112871}, {458,0.00074257}, {459,0.00089109}, {460,0.00089109}, {461,0.00079208}, {462,0.00095050}, {463,0.00054455}, {464,0.00116832}, {465,0.00117822}, {466,0.00094059}, {467,0.00102970}, {468,0.00086139}, {469,0.00098020}, {470,0.00063366}, {471,0.00088119}, {472,0.00113861}, {473,0.00101980}, {474,0.00136634}, {475,0.00129703}, {476,0.00076238}, {477,0.00089109}, {478,0.00069307}, {479,0.00122772}, {480,0.00081188}, {481,0.00100990}, {482,0.00090099}, {483,0.00068317}, {484,0.00100990}, {485,0.00108911}, {486,0.00068317}, {487,0.00093069}, {488,0.00100000}, {489,0.00074257}, {490,0.00073267}, {491,0.00112871}, {492,0.00113861}, {493,0.00117822}, {494,0.00087129}, {495,0.00093069}, {496,0.00115842}, {497,0.00071287}, {498,0.00098020}, {499,0.00087129}, {500,0.00104950}, {505,0.00086139}, {510,0.00078218}, {515,0.00082178}, {520,0.00117822}, {525,0.00087129}, {530,0.00094059}, {535,0.00081188}, {540,0.00086139}, {545,0.00077228}, {550,0.00079208}, {555,0.00118812}, {560,0.00100000}, {565,0.00090099}, {570,0.00079208}, {575,0.00099010}, {580,0.00103960}, {585,0.00090099}, {590,0.00086139}, {595,0.00102970}, {600,0.00081188}, {605,0.00134653}, {610,0.00110891}, {615,0.00093069}, {620,0.00111881}, {625,0.00121782}, {630,0.00111881}, {635,0.00091089}, {640,0.00159406}, {645,0.00106931}, {650,0.00114851}, {655,0.00116832}, {660,0.00141584}, {665,0.00078218}, {670,0.00127723}, {675,0.00110891}, {680,0.00094059}, {685,0.00110891}, {690,0.00129703}, {695,0.00107921}, {700,0.00109901}, {705,0.00161386}, {710,0.00118812}, {715,0.00106931}, {720,0.00114851}, {725,0.00119802}, {730,0.00132673}, {735,0.00130693}, {740,0.00145545}, {745,0.00134653}, {750,0.00165347}, {755,0.00131683}, {760,0.00109901}, {765,0.00129703}, {770,0.00097030}, {775,0.00154455}, {780,0.00157426}, {785,0.00138614}, {790,0.00146535}, {795,0.00138614}, {800,0.00158416}, {805,0.00133663}, {810,0.00144554}, {815,0.00146535}, {820,0.00175248}, {825,0.00139604}, {830,0.00133663}, {835,0.00120792}, {840,0.00139604}, {845,0.00132673}, {850,0.00157426}, {855,0.00145545}, {860,0.00166337}, {865,0.00162376}, {870,0.00167327}, {875,0.00148515}, {880,0.00177228}, {885,0.00111881}, {890,0.00165347}, {895,0.00325743}, {900,0.00154455}, {905,0.00148515}, {910,0.00162376}, {915,0.00164356}, {920,0.00144554}, {925,0.00200000}, {930,0.00182178}, {935,0.00171287}, {940,0.00151485}, {945,0.00186139}, {950,0.00176238}, {955,0.00178218}, {960,0.00176238}, {965,0.00199010}, {970,0.00164356}, {975,0.00144554}, {980,0.00185149}, {985,0.00169307}, {990,0.00329703}, {995,0.00174257}, {1000,0.00192079}, {1010,0.00211881}, {1020,0.00173267}, {1030,0.00161386}, {1040,0.00179208}, {1050,0.00192079}, {1060,0.00184158}, {1070,0.00178218}, {1080,0.00189109}, {1090,0.00234653}, {1100,0.00168317}, {1110,0.00208911}, {1120,0.00184158}, {1130,0.00193069}, {1140,0.00187129}, {1150,0.00183168}, {1160,0.00207921}, {1170,0.00180198}, {1180,0.00169307}, {1190,0.00187129}, {1200,0.00243564}, {1210,0.00423762}, {1220,0.00209901}, {1230,0.00225743}, {1240,0.00197030}, {1250,0.00237624}, {1260,0.00222772}, {1270,0.00215842}, {1280,0.00176238}, {1290,0.00225743}, {1300,0.00221782}, {1310,0.00416832}, {1320,0.00205941}, {1330,0.00236634}, {1340,0.00234653}, {1350,0.00208911}, {1360,0.00251485}, {1370,0.00254455}, {1380,0.00233663}, {1390,0.00225743}, {1400,0.00560396}, {1410,0.00225743}, {1420,0.00234653}, {1430,0.00252475}, {1440,0.00266337}, {1450,0.00243564}, {1460,0.00277228}, {1470,0.00279208}, {1480,0.00282178}, {1490,0.00285149}, {1500,0.00283168}, {1510,0.00252475}, {1520,0.00319802}, {1530,0.00311881}, {1540,0.00285149}, {1550,0.00305941}, {1560,0.00286139}, {1570,0.00318812}, {1580,0.00280198}, {1590,0.00317822}, {1600,0.00290099}, {1610,0.00300990}, {1620,0.00321782}, {1630,0.00318812}, {1640,0.00320792}, {1650,0.00311881}, {1660,0.00311881}, {1670,0.00319802}, {1680,0.00310891}, {1690,0.00320792}, {1700,0.00339604}, {1710,0.00343564}, {1720,0.00324752}, {1730,0.00313861}, {1740,0.00347525}, {1750,0.00349505}, {1760,0.00346535}, {1770,0.00314851}, {1780,0.00347525}, {1790,0.00357426}, {1800,0.00350495}, {1810,0.00566337}, {1820,0.00671287}, {1830,0.00332673}, {1840,0.00339604}, {1850,0.00350495}, {1860,0.00339604}, {1870,0.00354455}, {1880,0.00361386}, {1890,0.00359406}, {1900,0.00358416}, {1910,0.00369307}, {1920,0.00372277}, {1930,0.00362376}, {1940,0.00369307}, {1950,0.00375248}, {1960,0.00376238}, {1970,0.00372277}, {1980,0.00380198}, {1990,0.00381188}, {2000,0.00383168}, {2050,0.00384158}, {2100,0.00407921}, {2150,0.00400990}, {2200,0.00416832}, {2250,0.00444554}, {2300,0.00450495}, {2350,0.00451485}, {2400,0.00459406}, {2450,0.00453465}, {2500,0.00487129}, {2550,0.00511881}, {2600,0.00526733}, {2650,0.00535644}, {2700,0.00884158}, {2750,0.01001980}, {2800,0.00575248}, {2850,0.00541584}, {2900,0.00995050}, {2950,0.00867327}, {3000,0.00603960}, {3050,0.00612871}, {3100,0.01206931}, {3150,0.01135644}, {3200,0.00634653}, {3250,0.00654455}, {3300,0.00674257}, {3350,0.00665347}, {3400,0.00681188}, {3450,0.00704950}, {3500,0.00694059}, {3550,0.00683168}, {3600,0.00721782}, {3650,0.01378218}, {3700,0.00726733}, {3750,0.00748515}, {3800,0.00775248}, {3850,0.00773267}, {3900,0.00805941}, {3950,0.00792079}, {4000,0.00808911}, {4050,0.00835644}, {4100,0.00829703}, {4150,0.01606931}, {4200,0.00879208}, {4250,0.00900990}, {4300,0.00917822}, {4350,0.00920792}, {4400,0.00903960}, {4450,0.00880198}, {4500,0.00953465}, {4550,0.00933663}, {4600,0.00981188}, {4650,0.00973267}, {4700,0.00982178}, {4750,0.00996040}, {4800,0.01000000}, {4850,0.01006931}, {4900,0.01640594}, {4950,0.01038614}, {5000,0.01078218}, {5050,0.01059406}, {5100,0.01093069}, {5150,0.01080198}, {5200,0.01094059}, {5250,0.01606931}, {5300,0.01120792}, {5350,0.01147525}, {5400,0.01146535}, {5450,0.01167327}, {5500,0.01157426}, {5550,0.01749505}, {5600,0.01202970}, {5650,0.01199010}, {5700,0.01200000}, {5750,0.01197030}, {5800,0.01219802}, {5850,0.01225743}, {5900,0.01290099}, {5950,0.01260396}, {6000,0.01304950}, {6050,0.0140571}, {6100,0.0188571}, {6150,0.0295143}, {6200,0.0142857}, {6250,0.0299143}, {6300,0.0146286}, {6350,0.0152286}, {6400,0.0151714}, {6450,0.0153714}, {6500,0.0158000}, {6550,0.0156000}, {6600,0.0154000}, {6650,0.0156286}, {6700,0.0159429}, {6750,0.0161429}, {6800,0.0161429}, {6850,0.0165429}, {6900,0.0162000}, {6950,0.0164000}, {7000,0.0224286}, {7050,0.0352571}, {7100,0.0170000}, {7150,0.0168286}, {7200,0.0165714}, {7250,0.0175714}, {7300,0.0344286}, {7350,0.0174571}, {7400,0.0176000}, {7450,0.0270286}, {7500,0.0183429}, {7550,0.0184571}, {7600,0.0319143}, {7650,0.0315429}, {7700,0.0183714}, {7750,0.0298857}, {7800,0.0188571}, {7850,0.0186000}, {7900,0.0301429}, {7950,0.0362857}, {8000,0.0196000}, {8050,0.0271143}, {8100,0.0191429}, {8150,0.0196286}, {8200,0.0298857}, {8250,0.0197714}, {8300,0.0460286}, {8350,0.0202000}, {8400,0.0263429}, {8450,0.0197714}, {8500,0.0208286}, {8550,0.0204286}, {8600,0.0419429}, {8650,0.0215429}, {8700,0.0218857}, {8750,0.0218857}, {8800,0.0218000}, {8850,0.0226000}, {8900,0.0223143}, {8950,0.0220571}, {9000,0.0384571}, {9050,0.0224857}, {9100,0.0224857}, {9150,0.0222857}, {9200,0.0399714}, {9250,0.0418857}, {9300,0.0544000}, {9350,0.0240857}, {9400,0.0429714}, {9450,0.0347143}, {9500,0.0242857}, {9550,0.0240857}, {9600,0.0242571}, {9650,0.0240571}, {9700,0.0246857}, {9750,0.0247429}, {9800,0.0396286}, {9850,0.0248571}, {9900,0.0243714}, {9950,0.0252000}, {10000,0.0507429}, {10100,0.0365143}, {10200,0.0351714}, {10300,0.0258286}, {10400,0.0260571}, {10500,0.0258571}, {10600,0.0269143}, {10700,0.0264857}, {10800,0.0268000}, {10900,0.0272857}, {11000,0.0274286}, {11100,0.0276571}, {11200,0.0278286}, {11300,0.0283714}, {11400,0.0284857}, {11500,0.0511143}, {11600,0.0286000}, {11700,0.0446857}, {11800,0.0300000}, {11900,0.0297143}, {12000,0.0306000}, {12100,0.0301143}, {12200,0.0301714}, {12300,0.0307429}, {12400,0.0446857}, {12500,0.0551143}, {12600,0.0450286}, {12700,0.0314000}, {12800,0.0315143}, {12900,0.0651429}, {13000,0.0527429}, {13100,0.0325714}, {13200,0.0329714}, {13300,0.0334571}, {13400,0.0632857}, {13500,0.0672286}, {13600,0.0626571}, {13700,0.0342571}, {13800,0.0344857}, {13900,0.0347143}, {14000,0.0346857}, {14100,0.0354286}, {14200,0.0494571}, {14300,0.0360286}, {14400,0.0361429}, {14500,0.0700000}, {14600,0.0369143}, {14700,0.0367429}, {14800,0.0370857}, {14900,0.0371143}, {15000,0.0375143}, {15100,0.0380286}, {15200,0.0692857}, {15300,0.0712000}, {15400,0.0685429}, {15500,0.0386571}, {15600,0.0387714}, {15700,0.0392286}, {15800,0.0715429}, {15900,0.0500571}, {16000,0.0583143}, {16100,0.0797143}, {16200,0.0546857}, {16300,0.0402286}, {16400,0.0412571}, {16500,0.0726286}, {16600,0.0587714}, {16700,0.0420571}, {16800,0.0424000}, {16900,0.0745429}, {17000,0.0428000}, {17100,0.0435143}, {17200,0.0432286}, {17300,0.0644857}, {17400,0.0443143}, {17500,0.0914000}, {17600,0.0698571}, {17700,0.0437429}, {17800,0.0847714}, {17900,0.0858000}, {18000,0.0456571}, {18100,0.0623143}, {18200,0.0461143}, {18300,0.0575429}, {18400,0.0465143}, {18500,0.0468857}, {18600,0.0931429}, {18700,0.0476571}, {18800,0.0476571}, {18900,0.0483143}, {19000,0.0481143}, {19100,0.0484286}, {19200,0.0490857}, {19300,0.0722571}, {19400,0.0492000}, {19500,0.0505143}, {19600,0.0495429}, {19700,0.0696000}, {19800,0.0699143}, {19900,0.0815429}, {20000,0.0626571}};
data["big_flat"]["LtacTCExplicitCtx"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00002970}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00002970}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00002970}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00003960}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00003960}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00003960}, {129,0.00000000}, {130,0.00000000}, {131,0.00003960}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00003960}, {139,0.00000000}, {140,0.00000000}, {141,0.00003960}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00003960}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00003960}, {167,0.00003960}, {168,0.00000000}, {169,0.00002970}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00003960}, {178,0.00000000}, {179,0.00003960}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00003960}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00003960}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00014851}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00003960}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00002970}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00003960}, {220,0.00000000}, {221,0.00003960}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00014851}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00003960}, {244,0.00000000}, {245,0.00003960}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00002970}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00007921}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00003960}, {280,0.00000000}, {281,0.00003960}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00003960}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00002970}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00003960}, {314,0.00000000}, {315,0.00003960}, {316,0.00003960}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00003960}, {344,0.00000000}, {345,0.00000000}, {346,0.00003960}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00003960}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00003960}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00003960}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00003960}, {405,0.00000000}, {406,0.00002970}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00003960}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00003960}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00006931}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00003960}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00003960}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00007921}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00003960}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00007921}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00007921}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00003960}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00007921}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00003960}, {920,0.00000000}, {925,0.00003960}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00003960}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00003960}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00003960}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00003960}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00003960}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00003960}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00003960}, {1400,0.00003960}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00003960}, {1560,0.00000000}, {1570,0.00003960}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00003960}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00003960}, {2350,0.00003960}, {2400,0.00003960}, {2450,0.00003960}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00003960}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00003960}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00003960}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00003960}, {3600,0.00000000}, {3650,0.00003960}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00003960}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00003960}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00003960}, {5250,0.00000000}, {5300,0.00003960}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00003960}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00003960}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0001143}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0001143}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0003429}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0001143}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0001143}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0001143}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0001143}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0002286}, {15900,0.0001143}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0001143}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0001143}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0001143}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0001143}, {19800,0.0001143}, {19900,0.0000000}, {20000,0.0001143}};
data["big_flat"]["LtacTCExplicitCtx"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00100000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00114851}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00002970}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00001980}, {1450,0.00128713}, {1460,0.00002970}, {1470,0.00000000}, {1480,0.00004950}, {1490,0.00001980}, {1500,0.00000990}, {1510,0.00000000}, {1520,0.00003960}, {1530,0.00008911}, {1540,0.00042574}, {1550,0.00000990}, {1560,0.00028713}, {1570,0.00003960}, {1580,0.00054455}, {1590,0.00040594}, {1600,0.00011881}, {1610,0.00007921}, {1620,0.00011881}, {1630,0.00044554}, {1640,0.00067327}, {1650,0.00100000}, {1660,0.00050495}, {1670,0.00100000}, {1680,0.00099010}, {1690,0.00051485}, {1700,0.00048515}, {1710,0.00052475}, {1720,0.00052475}, {1730,0.00099010}, {1740,0.00100000}, {1750,0.00100000}, {1760,0.00100000}, {1770,0.00100000}, {1780,0.00100000}, {1790,0.00100000}, {1800,0.00100000}, {1810,0.00100000}, {1820,0.00100000}, {1830,0.00100000}, {1840,0.00100000}, {1850,0.00100000}, {1860,0.00100000}, {1870,0.00100000}, {1880,0.00100000}, {1890,0.00100000}, {1900,0.00100000}, {1910,0.00100000}, {1920,0.00100000}, {1930,0.00100000}, {1940,0.00100000}, {1950,0.00100000}, {1960,0.00100000}, {1970,0.00100000}, {1980,0.00293069}, {1990,0.00100000}, {2000,0.00100000}, {2050,0.00100000}, {2100,0.00100000}, {2150,0.00100000}, {2200,0.00100000}, {2250,0.00100000}, {2300,0.00100000}, {2350,0.00100000}, {2400,0.00100000}, {2450,0.00100000}, {2500,0.00100000}, {2550,0.00100000}, {2600,0.00100000}, {2650,0.00100000}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100990}, {3100,0.00100990}, {3150,0.00100990}, {3200,0.00113861}, {3250,0.00121782}, {3300,0.00105941}, {3350,0.00120792}, {3400,0.00165347}, {3450,0.00183168}, {3500,0.00170297}, {3550,0.00200000}, {3600,0.00200000}, {3650,0.00200000}, {3700,0.00200000}, {3750,0.00200000}, {3800,0.00200000}, {3850,0.00200000}, {3900,0.00200000}, {3950,0.00200000}, {4000,0.00200000}, {4050,0.00200990}, {4100,0.00200000}, {4150,0.00200000}, {4200,0.00200000}, {4250,0.00200000}, {4300,0.00200990}, {4350,0.00201980}, {4400,0.00203960}, {4450,0.00204950}, {4500,0.00206931}, {4550,0.00208911}, {4600,0.00205941}, {4650,0.00209901}, {4700,0.00215842}, {4750,0.01259406}, {4800,0.00214851}, {4850,0.00211881}, {4900,0.00235644}, {4950,0.00265347}, {5000,0.00246535}, {5050,0.00272277}, {5100,0.00268317}, {5150,0.00275248}, {5200,0.00280198}, {5250,0.00287129}, {5300,0.00301980}, {5350,0.00306931}, {5400,0.00301980}, {5450,0.00302970}, {5500,0.00303960}, {5550,0.00552475}, {5600,0.00304950}, {5650,0.00306931}, {5700,0.00306931}, {5750,0.00310891}, {5800,0.00307921}, {5850,0.00308911}, {5900,0.00313861}, {5950,0.01449505}, {6000,0.00313861}, {6050,0.0043714}, {6100,0.0042286}, {6150,0.0110857}, {6200,0.0043143}, {6250,0.0044571}, {6300,0.0046286}, {6350,0.0047143}, {6400,0.0162857}, {6450,0.0047143}, {6500,0.0046857}, {6550,0.0045429}, {6600,0.0048857}, {6650,0.0048286}, {6700,0.0050000}, {6750,0.0050000}, {6800,0.0052000}, {6850,0.0053429}, {6900,0.0081143}, {6950,0.0054000}, {7000,0.0053143}, {7050,0.0054571}, {7100,0.0054571}, {7150,0.0054571}, {7200,0.0058286}, {7250,0.0056857}, {7300,0.0058571}, {7350,0.0057714}, {7400,0.0057143}, {7450,0.0061429}, {7500,0.0061429}, {7550,0.0060000}, {7600,0.0060857}, {7650,0.0061143}, {7700,0.0064857}, {7750,0.0064571}, {7800,0.0061429}, {7850,0.0064286}, {7900,0.0067143}, {7950,0.0213714}, {8000,0.0066857}, {8050,0.0065429}, {8100,0.0066286}, {8150,0.0098857}, {8200,0.0067714}, {8250,0.0065714}, {8300,0.0066286}, {8350,0.0068000}, {8400,0.0071429}, {8450,0.0072857}, {8500,0.0073429}, {8550,0.0073429}, {8600,0.0063714}, {8650,0.0211429}, {8700,0.0076571}, {8750,0.0076571}, {8800,0.0076857}, {8850,0.0078286}, {8900,0.0076000}, {8950,0.0076571}, {9000,0.0078286}, {9050,0.0078571}, {9100,0.0078286}, {9150,0.0077714}, {9200,0.0078857}, {9250,0.0180000}, {9300,0.0080000}, {9350,0.0200286}, {9400,0.0080000}, {9450,0.0082000}, {9500,0.0087143}, {9550,0.0087714}, {9600,0.0084286}, {9650,0.0119429}, {9700,0.0088000}, {9750,0.0088571}, {9800,0.0089143}, {9850,0.0088857}, {9900,0.0089143}, {9950,0.0089143}, {10000,0.0088857}, {10100,0.0089143}, {10200,0.0090000}, {10300,0.0088857}, {10400,0.0089429}, {10500,0.0092857}, {10600,0.0096000}, {10700,0.0122286}, {10800,0.0096286}, {10900,0.0097714}, {11000,0.0097714}, {11100,0.0097714}, {11200,0.0087143}, {11300,0.0215143}, {11400,0.0099143}, {11500,0.0280000}, {11600,0.0098857}, {11700,0.0103143}, {11800,0.0106000}, {11900,0.0107143}, {12000,0.0107429}, {12100,0.0107714}, {12200,0.0107714}, {12300,0.0107714}, {12400,0.0107429}, {12500,0.0108000}, {12600,0.0108857}, {12700,0.0109714}, {12800,0.0112571}, {12900,0.0108286}, {13000,0.0114286}, {13100,0.0115714}, {13200,0.0116000}, {13300,0.0117143}, {13400,0.0356000}, {13500,0.0117429}, {13600,0.0118571}, {13700,0.0106286}, {13800,0.0119714}, {13900,0.0122571}, {14000,0.0124286}, {14100,0.0126286}, {14200,0.0125714}, {14300,0.0127143}, {14400,0.0274857}, {14500,0.0128857}, {14600,0.0127714}, {14700,0.0128571}, {14800,0.0129714}, {14900,0.0132857}, {15000,0.0133714}, {15100,0.0131143}, {15200,0.0133714}, {15300,0.0223429}, {15400,0.0117143}, {15500,0.0876000}, {15600,0.0136000}, {15700,0.0137143}, {15800,0.0139143}, {15900,0.0138286}, {16000,0.0139714}, {16100,0.0140571}, {16200,0.0142571}, {16300,0.0142571}, {16400,0.0142857}, {16500,0.0479714}, {16600,0.0435429}, {16700,0.0126286}, {16800,0.0127429}, {16900,0.0148857}, {17000,0.0147429}, {17100,0.0150000}, {17200,0.0152286}, {17300,0.0152857}, {17400,0.0132857}, {17500,0.0152857}, {17600,0.0152857}, {17700,0.0153143}, {17800,0.0154286}, {17900,0.0155143}, {18000,0.0158000}, {18100,0.0307714}, {18200,0.0159429}, {18300,0.0489714}, {18400,0.0162857}, {18500,0.0163429}, {18600,0.0164000}, {18700,0.0163143}, {18800,0.0162857}, {18900,0.0164000}, {19000,0.0166000}, {19100,0.0220571}, {19200,0.0340000}, {19300,0.0517143}, {19400,0.0173429}, {19500,0.0172286}, {19600,0.0173143}, {19700,0.0173143}, {19800,0.0172857}, {19900,0.0335714}, {20000,0.0173714}};
data["big_flat"]["LtacTCExplicitCtx"]["eval lazy"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00002970}, {4,0.00000000}, {5,0.00006931}, {6,0.00000000}, {7,0.00003960}, {8,0.00003960}, {9,0.00003960}, {10,0.00003960}, {11,0.00005941}, {12,0.00002970}, {13,0.00000000}, {14,0.00007921}, {15,0.00006931}, {16,0.00000000}, {17,0.00006931}, {18,0.00003960}, {19,0.00003960}, {20,0.00000000}, {21,0.00011881}, {22,0.00009901}, {23,0.00000000}, {24,0.00003960}, {25,0.00000000}, {26,0.00003960}, {27,0.00000000}, {28,0.00000000}, {29,0.00008911}, {30,0.00014851}, {31,0.00009901}, {32,0.00005941}, {33,0.00007921}, {34,0.00006931}, {35,0.00000000}, {36,0.00002970}, {37,0.00006931}, {38,0.00000000}, {39,0.00000000}, {40,0.00011881}, {41,0.00005941}, {42,0.00003960}, {43,0.00003960}, {44,0.00003960}, {45,0.00002970}, {46,0.00005941}, {47,0.00006931}, {48,0.00000000}, {49,0.00008911}, {50,0.00009901}, {51,0.00009901}, {52,0.00002970}, {53,0.00003960}, {54,0.00000000}, {55,0.00009901}, {56,0.00009901}, {57,0.00011881}, {58,0.00018812}, {59,0.00000000}, {60,0.00016832}, {61,0.00006931}, {62,0.00002970}, {63,0.00010891}, {64,0.00002970}, {65,0.00000000}, {66,0.00012871}, {67,0.00005941}, {68,0.00006931}, {69,0.00006931}, {70,0.00008911}, {71,0.00010891}, {72,0.00002970}, {73,0.00005941}, {74,0.00002970}, {75,0.00000000}, {76,0.00005941}, {77,0.00000000}, {78,0.00002970}, {79,0.00010891}, {80,0.00005941}, {81,0.00009901}, {82,0.00005941}, {83,0.00009901}, {84,0.00018812}, {85,0.00010891}, {86,0.00005941}, {87,0.00002970}, {88,0.00015842}, {89,0.00013861}, {90,0.00009901}, {91,0.00000000}, {92,0.00005941}, {93,0.00009901}, {94,0.00002970}, {95,0.00000000}, {96,0.00005941}, {97,0.00005941}, {98,0.00013861}, {99,0.00019802}, {100,0.00008911}, {101,0.00013861}, {102,0.00012871}, {103,0.00017822}, {104,0.00012871}, {105,0.00002970}, {106,0.00006931}, {107,0.00009901}, {108,0.00015842}, {109,0.00011881}, {110,0.00005941}, {111,0.00011881}, {112,0.00023762}, {113,0.00006931}, {114,0.00010891}, {115,0.00005941}, {116,0.00009901}, {117,0.00012871}, {118,0.00005941}, {119,0.00008911}, {120,0.00008911}, {121,0.00011881}, {122,0.00009901}, {123,0.00029703}, {124,0.00005941}, {125,0.00009901}, {126,0.00017822}, {127,0.00000000}, {128,0.00010891}, {129,0.00005941}, {130,0.00005941}, {131,0.00003960}, {132,0.00002970}, {133,0.00012871}, {134,0.00017822}, {135,0.00014851}, {136,0.00010891}, {137,0.00012871}, {138,0.00016832}, {139,0.00008911}, {140,0.00023762}, {141,0.00014851}, {142,0.00002970}, {143,0.00003960}, {144,0.00002970}, {145,0.00000000}, {146,0.00024752}, {147,0.00003960}, {148,0.00013861}, {149,0.00011881}, {150,0.00006931}, {151,0.00013861}, {152,0.00013861}, {153,0.00010891}, {154,0.00012871}, {155,0.00014851}, {156,0.00009901}, {157,0.00014851}, {158,0.00005941}, {159,0.00014851}, {160,0.00000000}, {161,0.00013861}, {162,0.00014851}, {163,0.00011881}, {164,0.00010891}, {165,0.00010891}, {166,0.00016832}, {167,0.00003960}, {168,0.00014851}, {169,0.00015842}, {170,0.00018812}, {171,0.00014851}, {172,0.00006931}, {173,0.00014851}, {174,0.00006931}, {175,0.00017822}, {176,0.00017822}, {177,0.00021782}, {178,0.00024752}, {179,0.00010891}, {180,0.00013861}, {181,0.00003960}, {182,0.00009901}, {183,0.00020792}, {184,0.00007921}, {185,0.00013861}, {186,0.00003960}, {187,0.00007921}, {188,0.00030693}, {189,0.00012871}, {190,0.00016832}, {191,0.00011881}, {192,0.00013861}, {193,0.00016832}, {194,0.00006931}, {195,0.00024752}, {196,0.00011881}, {197,0.00014851}, {198,0.00006931}, {199,0.00008911}, {200,0.00021782}, {201,0.00014851}, {202,0.00013861}, {203,0.00005941}, {204,0.00011881}, {205,0.00013861}, {206,0.00016832}, {207,0.00014851}, {208,0.00017822}, {209,0.00005941}, {210,0.00025743}, {211,0.00012871}, {212,0.00027723}, {213,0.00009901}, {214,0.00024752}, {215,0.00002970}, {216,0.00007921}, {217,0.00022772}, {218,0.00032673}, {219,0.00013861}, {220,0.00019802}, {221,0.00018812}, {222,0.00025743}, {223,0.00019802}, {224,0.00023762}, {225,0.00017822}, {226,0.00014851}, {227,0.00027723}, {228,0.00022772}, {229,0.00014851}, {230,0.00017822}, {231,0.00002970}, {232,0.00016832}, {233,0.00009901}, {234,0.00024752}, {235,0.00025743}, {236,0.00013861}, {237,0.00009901}, {238,0.00002970}, {239,0.00011881}, {240,0.00019802}, {241,0.00029703}, {242,0.00021782}, {243,0.00012871}, {244,0.00009901}, {245,0.00011881}, {246,0.00008911}, {247,0.00019802}, {248,0.00022772}, {249,0.00028713}, {250,0.00018812}, {251,0.00009901}, {252,0.00023762}, {253,0.00015842}, {254,0.00031683}, {255,0.00012871}, {256,0.00026733}, {257,0.00013861}, {258,0.00029703}, {259,0.00018812}, {260,0.00041584}, {261,0.00005941}, {262,0.00010891}, {263,0.00009901}, {264,0.00010891}, {265,0.00008911}, {266,0.00032673}, {267,0.00010891}, {268,0.00020792}, {269,0.00023762}, {270,0.00024752}, {271,0.00028713}, {272,0.00017822}, {273,0.00009901}, {274,0.00012871}, {275,0.00020792}, {276,0.00019802}, {277,0.00022772}, {278,0.00019802}, {279,0.00026733}, {280,0.00002970}, {281,0.00010891}, {282,0.00015842}, {283,0.00015842}, {284,0.00025743}, {285,0.00016832}, {286,0.00008911}, {287,0.00113861}, {288,0.00024752}, {289,0.00017822}, {290,0.00036634}, {291,0.00030693}, {292,0.00026733}, {293,0.00024752}, {294,0.00009901}, {295,0.00023762}, {296,0.00023762}, {297,0.00027723}, {298,0.00031683}, {299,0.00017822}, {300,0.00009901}, {301,0.00016832}, {302,0.00035644}, {303,0.00015842}, {304,0.00015842}, {305,0.00011881}, {306,0.00031683}, {307,0.00014851}, {308,0.00017822}, {309,0.00020792}, {310,0.00005941}, {311,0.00027723}, {312,0.00010891}, {313,0.00026733}, {314,0.00025743}, {315,0.00023762}, {316,0.00023762}, {317,0.00022772}, {318,0.00005941}, {319,0.00021782}, {320,0.00028713}, {321,0.00024752}, {322,0.00030693}, {323,0.00009901}, {324,0.00026733}, {325,0.00014851}, {326,0.00008911}, {327,0.00018812}, {328,0.00014851}, {329,0.00027723}, {330,0.00021782}, {331,0.00006931}, {332,0.00024752}, {333,0.00012871}, {334,0.00019802}, {335,0.00018812}, {336,0.00017822}, {337,0.00027723}, {338,0.00029703}, {339,0.00011881}, {340,0.00021782}, {341,0.00013861}, {342,0.00012871}, {343,0.00028713}, {344,0.00022772}, {345,0.00030693}, {346,0.00018812}, {347,0.00022772}, {348,0.00031683}, {349,0.00023762}, {350,0.00017822}, {351,0.00040594}, {352,0.00042574}, {353,0.00036634}, {354,0.00043564}, {355,0.00019802}, {356,0.00026733}, {357,0.00019802}, {358,0.00031683}, {359,0.00023762}, {360,0.00056436}, {361,0.00044554}, {362,0.00018812}, {363,0.00034653}, {364,0.00018812}, {365,0.00015842}, {366,0.00014851}, {367,0.00024752}, {368,0.00017822}, {369,0.00015842}, {370,0.00036634}, {371,0.00017822}, {372,0.00021782}, {373,0.00030693}, {374,0.00028713}, {375,0.00025743}, {376,0.00020792}, {377,0.00031683}, {378,0.00022772}, {379,0.00022772}, {380,0.00019802}, {381,0.00027723}, {382,0.00033663}, {383,0.00024752}, {384,0.00042574}, {385,0.00021782}, {386,0.00028713}, {387,0.00022772}, {388,0.00029703}, {389,0.00020792}, {390,0.00028713}, {391,0.00045545}, {392,0.00026733}, {393,0.00030693}, {394,0.00035644}, {395,0.00038614}, {396,0.00017822}, {397,0.00026733}, {398,0.00021782}, {399,0.00029703}, {400,0.00024752}, {401,0.00018812}, {402,0.00029703}, {403,0.00029703}, {404,0.00027723}, {405,0.00026733}, {406,0.00020792}, {407,0.00034653}, {408,0.00018812}, {409,0.00033663}, {410,0.00023762}, {411,0.00030693}, {412,0.00027723}, {413,0.00024752}, {414,0.00138614}, {415,0.00023762}, {416,0.00031683}, {417,0.00030693}, {418,0.00040594}, {419,0.00002970}, {420,0.00032673}, {421,0.00011881}, {422,0.00029703}, {423,0.00048515}, {424,0.00043564}, {425,0.00013861}, {426,0.00022772}, {427,0.00032673}, {428,0.00036634}, {429,0.00043564}, {430,0.00047525}, {431,0.00037624}, {432,0.00011881}, {433,0.00035644}, {434,0.00032673}, {435,0.00022772}, {436,0.00015842}, {437,0.00018812}, {438,0.00035644}, {439,0.00041584}, {440,0.00041584}, {441,0.00013861}, {442,0.00040594}, {443,0.00018812}, {444,0.00031683}, {445,0.00022772}, {446,0.00046535}, {447,0.00022772}, {448,0.00036634}, {449,0.00041584}, {450,0.00032673}, {451,0.00033663}, {452,0.00033663}, {453,0.00032673}, {454,0.00034653}, {455,0.00030693}, {456,0.00025743}, {457,0.00031683}, {458,0.00030693}, {459,0.00030693}, {460,0.00022772}, {461,0.00042574}, {462,0.00013861}, {463,0.00025743}, {464,0.00023762}, {465,0.00037624}, {466,0.00013861}, {467,0.00023762}, {468,0.00027723}, {469,0.00034653}, {470,0.00017822}, {471,0.00024752}, {472,0.00034653}, {473,0.00055446}, {474,0.00036634}, {475,0.00022772}, {476,0.00034653}, {477,0.00049505}, {478,0.00038614}, {479,0.00027723}, {480,0.00034653}, {481,0.00055446}, {482,0.00045545}, {483,0.00016832}, {484,0.00060396}, {485,0.00034653}, {486,0.00044554}, {487,0.00024752}, {488,0.00026733}, {489,0.00025743}, {490,0.00036634}, {491,0.00024752}, {492,0.00021782}, {493,0.00049505}, {494,0.00044554}, {495,0.00035644}, {496,0.00036634}, {497,0.00039604}, {498,0.00035644}, {499,0.00045545}, {500,0.00049505}, {505,0.00041584}, {510,0.00035644}, {515,0.00035644}, {520,0.00036634}, {525,0.00038614}, {530,0.00046535}, {535,0.00051485}, {540,0.00028713}, {545,0.00038614}, {550,0.00023762}, {555,0.00054455}, {560,0.00037624}, {565,0.00057426}, {570,0.00024752}, {575,0.00031683}, {580,0.00031683}, {585,0.00046535}, {590,0.00037624}, {595,0.00052475}, {600,0.00026733}, {605,0.00025743}, {610,0.00036634}, {615,0.00020792}, {620,0.00034653}, {625,0.00038614}, {630,0.00024752}, {635,0.00038614}, {640,0.00028713}, {645,0.00042574}, {650,0.00047525}, {655,0.00031683}, {660,0.00039604}, {665,0.00034653}, {670,0.00052475}, {675,0.00027723}, {680,0.00040594}, {685,0.00046535}, {690,0.00034653}, {695,0.00038614}, {700,0.00027723}, {705,0.00041584}, {710,0.00052475}, {715,0.00062376}, {720,0.00040594}, {725,0.00048515}, {730,0.00022772}, {735,0.00054455}, {740,0.00037624}, {745,0.00050495}, {750,0.00051485}, {755,0.00050495}, {760,0.00063366}, {765,0.00046535}, {770,0.00048515}, {775,0.00023762}, {780,0.00043564}, {785,0.00048515}, {790,0.00046535}, {795,0.00063366}, {800,0.00048515}, {805,0.00041584}, {810,0.00063366}, {815,0.00027723}, {820,0.00078218}, {825,0.00050495}, {830,0.00077228}, {835,0.00042574}, {840,0.00038614}, {845,0.00056436}, {850,0.00054455}, {855,0.00049505}, {860,0.00036634}, {865,0.00056436}, {870,0.00037624}, {875,0.00030693}, {880,0.00041584}, {885,0.00053465}, {890,0.00084158}, {895,0.00045545}, {900,0.00061386}, {905,0.00058416}, {910,0.00053465}, {915,0.00058416}, {920,0.00051485}, {925,0.00048515}, {930,0.00059406}, {935,0.00061386}, {940,0.00078218}, {945,0.00053465}, {950,0.00056436}, {955,0.00064356}, {960,0.00057426}, {965,0.00050495}, {970,0.00048515}, {975,0.00043564}, {980,0.00046535}, {985,0.00066337}, {990,0.00036634}, {995,0.00064356}, {1000,0.00051485}, {1010,0.00063366}, {1020,0.00068317}, {1030,0.00063366}, {1040,0.00058416}, {1050,0.00051485}, {1060,0.00052475}, {1070,0.00054455}, {1080,0.00023762}, {1090,0.00055446}, {1100,0.00053465}, {1110,0.00088119}, {1120,0.00067327}, {1130,0.00047525}, {1140,0.00091089}, {1150,0.00062376}, {1160,0.00055446}, {1170,0.00061386}, {1180,0.00071287}, {1190,0.00066337}, {1200,0.00049505}, {1210,0.00064356}, {1220,0.00052475}, {1230,0.00066337}, {1240,0.00056436}, {1250,0.00078218}, {1260,0.00077228}, {1270,0.00071287}, {1280,0.00057426}, {1290,0.00068317}, {1300,0.00034653}, {1310,0.00066337}, {1320,0.00068317}, {1330,0.00085149}, {1340,0.00080198}, {1350,0.00086139}, {1360,0.00070297}, {1370,0.00079208}, {1380,0.00088119}, {1390,0.00089109}, {1400,0.00066337}, {1410,0.00059406}, {1420,0.00077228}, {1430,0.00064356}, {1440,0.00082178}, {1450,0.00154455}, {1460,0.00094059}, {1470,0.00075248}, {1480,0.00088119}, {1490,0.00091089}, {1500,0.00102970}, {1510,0.00078218}, {1520,0.00094059}, {1530,0.00092079}, {1540,0.00122772}, {1550,0.00064356}, {1560,0.00086139}, {1570,0.00106931}, {1580,0.00094059}, {1590,0.00095050}, {1600,0.00071287}, {1610,0.00103960}, {1620,0.00055446}, {1630,0.00117822}, {1640,0.00096040}, {1650,0.00061386}, {1660,0.00066337}, {1670,0.00093069}, {1680,0.00082178}, {1690,0.00120792}, {1700,0.00076238}, {1710,0.00088119}, {1720,0.00085149}, {1730,0.00088119}, {1740,0.00082178}, {1750,0.00097030}, {1760,0.00079208}, {1770,0.00098020}, {1780,0.00093069}, {1790,0.00102970}, {1800,0.00073267}, {1810,0.00087129}, {1820,0.00141584}, {1830,0.00100990}, {1840,0.00115842}, {1850,0.00114851}, {1860,0.00076238}, {1870,0.00087129}, {1880,0.00103960}, {1890,0.00116832}, {1900,0.00105941}, {1910,0.00126733}, {1920,0.00121782}, {1930,0.00098020}, {1940,0.00090099}, {1950,0.00093069}, {1960,0.00107921}, {1970,0.00106931}, {1980,0.00298020}, {1990,0.00083168}, {2000,0.00112871}, {2050,0.00147525}, {2100,0.00121782}, {2150,0.00120792}, {2200,0.00121782}, {2250,0.00128713}, {2300,0.00151485}, {2350,0.00113861}, {2400,0.00153465}, {2450,0.00149505}, {2500,0.00157426}, {2550,0.00100000}, {2600,0.00149505}, {2650,0.00145545}, {2700,0.00151485}, {2750,0.00118812}, {2800,0.00181188}, {2850,0.00173267}, {2900,0.00142574}, {2950,0.00162376}, {3000,0.00154455}, {3050,0.00158416}, {3100,0.00181188}, {3150,0.00159406}, {3200,0.00174257}, {3250,0.00175248}, {3300,0.00185149}, {3350,0.00206931}, {3400,0.00194059}, {3450,0.00191089}, {3500,0.00203960}, {3550,0.00203960}, {3600,0.00176238}, {3650,0.00206931}, {3700,0.00205941}, {3750,0.00199010}, {3800,0.00199010}, {3850,0.00179208}, {3900,0.00218812}, {3950,0.00221782}, {4000,0.00244554}, {4050,0.00211881}, {4100,0.00230693}, {4150,0.00239604}, {4200,0.00193069}, {4250,0.00215842}, {4300,0.00211881}, {4350,0.00227723}, {4400,0.00260396}, {4450,0.00248515}, {4500,0.00280198}, {4550,0.00279208}, {4600,0.00264356}, {4650,0.00262376}, {4700,0.00252475}, {4750,0.01270297}, {4800,0.00252475}, {4850,0.00307921}, {4900,0.00269307}, {4950,0.00298020}, {5000,0.00282178}, {5050,0.00278218}, {5100,0.00294059}, {5150,0.00286139}, {5200,0.00308911}, {5250,0.00299010}, {5300,0.00293069}, {5350,0.00327723}, {5400,0.00317822}, {5450,0.00326733}, {5500,0.00307921}, {5550,0.00582178}, {5600,0.00327723}, {5650,0.00332673}, {5700,0.00337624}, {5750,0.00325743}, {5800,0.00358416}, {5850,0.00337624}, {5900,0.00357426}, {5950,0.01468317}, {6000,0.00357426}, {6050,0.0039714}, {6100,0.0040286}, {6150,0.0114857}, {6200,0.0038000}, {6250,0.0037429}, {6300,0.0045143}, {6350,0.0045714}, {6400,0.0160571}, {6450,0.0048571}, {6500,0.0045429}, {6550,0.0041143}, {6600,0.0048286}, {6650,0.0051429}, {6700,0.0050286}, {6750,0.0052857}, {6800,0.0048000}, {6850,0.0056857}, {6900,0.0082857}, {6950,0.0060857}, {7000,0.0055714}, {7050,0.0057143}, {7100,0.0056286}, {7150,0.0054000}, {7200,0.0058286}, {7250,0.0057714}, {7300,0.0058571}, {7350,0.0055714}, {7400,0.0059714}, {7450,0.0055429}, {7500,0.0066286}, {7550,0.0056571}, {7600,0.0059143}, {7650,0.0065143}, {7700,0.0058571}, {7750,0.0065429}, {7800,0.0057429}, {7850,0.0065143}, {7900,0.0067143}, {7950,0.0210857}, {8000,0.0064286}, {8050,0.0064857}, {8100,0.0066857}, {8150,0.0094571}, {8200,0.0066286}, {8250,0.0063429}, {8300,0.0061714}, {8350,0.0069143}, {8400,0.0066571}, {8450,0.0070857}, {8500,0.0074000}, {8550,0.0066571}, {8600,0.0059429}, {8650,0.0216000}, {8700,0.0080000}, {8750,0.0073714}, {8800,0.0074286}, {8850,0.0069714}, {8900,0.0074857}, {8950,0.0076000}, {9000,0.0076857}, {9050,0.0084286}, {9100,0.0078857}, {9150,0.0080857}, {9200,0.0082000}, {9250,0.0176857}, {9300,0.0082571}, {9350,0.0198571}, {9400,0.0081143}, {9450,0.0084571}, {9500,0.0084571}, {9550,0.0091714}, {9600,0.0082857}, {9650,0.0120571}, {9700,0.0088571}, {9750,0.0088000}, {9800,0.0089714}, {9850,0.0084571}, {9900,0.0090571}, {9950,0.0093143}, {10000,0.0088286}, {10100,0.0092571}, {10200,0.0090286}, {10300,0.0089429}, {10400,0.0092857}, {10500,0.0092857}, {10600,0.0096286}, {10700,0.0119143}, {10800,0.0096857}, {10900,0.0095429}, {11000,0.0097714}, {11100,0.0098571}, {11200,0.0089143}, {11300,0.0216286}, {11400,0.0106571}, {11500,0.0282286}, {11600,0.0101143}, {11700,0.0099714}, {11800,0.0108000}, {11900,0.0106571}, {12000,0.0105143}, {12100,0.0104286}, {12200,0.0106857}, {12300,0.0110857}, {12400,0.0109143}, {12500,0.0108857}, {12600,0.0110000}, {12700,0.0108000}, {12800,0.0108857}, {12900,0.0107143}, {13000,0.0105714}, {13100,0.0110000}, {13200,0.0110857}, {13300,0.0118571}, {13400,0.0356571}, {13500,0.0117429}, {13600,0.0117714}, {13700,0.0099143}, {13800,0.0117143}, {13900,0.0120857}, {14000,0.0128000}, {14100,0.0119429}, {14200,0.0121429}, {14300,0.0125429}, {14400,0.0270571}, {14500,0.0133714}, {14600,0.0121714}, {14700,0.0125143}, {14800,0.0131429}, {14900,0.0135143}, {15000,0.0132857}, {15100,0.0132571}, {15200,0.0134000}, {15300,0.0220571}, {15400,0.0117429}, {15500,0.0872857}, {15600,0.0131714}, {15700,0.0145429}, {15800,0.0141429}, {15900,0.0138286}, {16000,0.0141714}, {16100,0.0135714}, {16200,0.0144286}, {16300,0.0143143}, {16400,0.0140000}, {16500,0.0476571}, {16600,0.0432286}, {16700,0.0128857}, {16800,0.0130571}, {16900,0.0146571}, {17000,0.0141429}, {17100,0.0154857}, {17200,0.0151143}, {17300,0.0151429}, {17400,0.0127429}, {17500,0.0156286}, {17600,0.0147714}, {17700,0.0155429}, {17800,0.0154857}, {17900,0.0155143}, {18000,0.0158000}, {18100,0.0309429}, {18200,0.0156857}, {18300,0.0486000}, {18400,0.0158857}, {18500,0.0163714}, {18600,0.0163429}, {18700,0.0163429}, {18800,0.0162857}, {18900,0.0165714}, {19000,0.0168286}, {19100,0.0217143}, {19200,0.0345714}, {19300,0.0520857}, {19400,0.0173143}, {19500,0.0169714}, {19600,0.0170000}, {19700,0.0168286}, {19800,0.0173143}, {19900,0.0332000}, {20000,0.0173714}};
data["big_flat"]["LtacTCExplicitCtx"]["eval lazy"]["system"] = {{1,0.00002970}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00002970}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00002970}, {89,0.00000000}, {90,0.00002970}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00002970}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00003960}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00003960}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00003960}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00003960}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00003960}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00003960}, {320,0.00000000}, {321,0.00003960}, {322,0.00000000}, {323,0.00000000}, {324,0.00002970}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00003960}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00003960}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00002970}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00003960}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00003960}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00003960}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00003960}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00003960}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00003960}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00003960}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00003960}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00003960}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00003960}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00003960}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00007921}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00003960}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00003960}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00003960}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00003960}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00003960}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00003960}, {3900,0.00000000}, {3950,0.00003960}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00003960}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00003960}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00003960}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00003960}, {5050,0.00003960}, {5100,0.00007921}, {5150,0.00000000}, {5200,0.00003960}, {5250,0.00000000}, {5300,0.00003960}, {5350,0.00000000}, {5400,0.00003960}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00007921}, {5650,0.00003960}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0004571}, {6100,0.0002857}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0003143}, {6300,0.0001143}, {6350,0.0000000}, {6400,0.0001143}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0001143}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0001143}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0001143}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0001143}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0001143}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0001143}, {8250,0.0000000}, {8300,0.0001143}, {8350,0.0001143}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0001143}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0001143}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0001143}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0001143}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0001143}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0001143}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0001143}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0001143}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000857}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0001143}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0001143}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCExplicitCtx"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00178218}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00106931}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00169307}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00001980}, {2000,0.00000990}, {2050,0.00000000}, {2100,0.00001980}, {2150,0.00001980}, {2200,0.00000000}, {2250,0.00006931}, {2300,0.00008911}, {2350,0.00043564}, {2400,0.00049505}, {2450,0.00050495}, {2500,0.00761386}, {2550,0.00100000}, {2600,0.00100000}, {2650,0.00100000}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00100000}, {3150,0.00100000}, {3200,0.00100000}, {3250,0.00100000}, {3300,0.00100000}, {3350,0.00100000}, {3400,0.00100000}, {3450,0.00100000}, {3500,0.00100000}, {3550,0.00100000}, {3600,0.00100000}, {3650,0.00100000}, {3700,0.00100000}, {3750,0.00100000}, {3800,0.00100000}, {3850,0.00100000}, {3900,0.00100000}, {3950,0.00100000}, {4000,0.00100000}, {4050,0.00100000}, {4100,0.00100000}, {4150,0.00100000}, {4200,0.00100000}, {4250,0.00100000}, {4300,0.00100000}, {4350,0.00100990}, {4400,0.00100990}, {4450,0.00101980}, {4500,0.00102970}, {4550,0.00105941}, {4600,0.00105941}, {4650,0.00113861}, {4700,0.00135644}, {4750,0.00132673}, {4800,0.00159406}, {4850,0.00163366}, {4900,0.00170297}, {4950,0.00170297}, {5000,0.00172277}, {5050,0.00183168}, {5100,0.00191089}, {5150,0.00199010}, {5200,0.00200000}, {5250,0.00200000}, {5300,0.00200000}, {5350,0.00200000}, {5400,0.00200000}, {5450,0.00200000}, {5500,0.00200000}, {5550,0.00200000}, {5600,0.00200000}, {5650,0.00200000}, {5700,0.00200000}, {5750,0.00200000}, {5800,0.00200000}, {5850,0.00200000}, {5900,0.00200000}, {5950,0.00200000}, {6000,0.00200000}, {6050,0.0020286}, {6100,0.0020286}, {6150,0.0020571}, {6200,0.0020571}, {6250,0.0021143}, {6300,0.0021714}, {6350,0.0023143}, {6400,0.0022286}, {6450,0.0022571}, {6500,0.0024857}, {6550,0.0024571}, {6600,0.0025143}, {6650,0.0026000}, {6700,0.0027429}, {6750,0.0026571}, {6800,0.0028286}, {6850,0.0028571}, {6900,0.0029429}, {6950,0.0029429}, {7000,0.0029429}, {7050,0.0029714}, {7100,0.0029714}, {7150,0.0030000}, {7200,0.0030000}, {7250,0.0029429}, {7300,0.0030000}, {7350,0.0029714}, {7400,0.0030000}, {7450,0.0030000}, {7500,0.0030000}, {7550,0.0030000}, {7600,0.0030000}, {7650,0.0030000}, {7700,0.0030000}, {7750,0.0030286}, {7800,0.0030000}, {7850,0.0030000}, {7900,0.0030286}, {7950,0.0030286}, {8000,0.0030286}, {8050,0.0030000}, {8100,0.0030286}, {8150,0.0030571}, {8200,0.0031143}, {8250,0.0030857}, {8300,0.0032000}, {8350,0.0032571}, {8400,0.0032571}, {8450,0.0034571}, {8500,0.0035143}, {8550,0.0035429}, {8600,0.0036857}, {8650,0.0037714}, {8700,0.0037714}, {8750,0.0038000}, {8800,0.0038286}, {8850,0.0038000}, {8900,0.0038000}, {8950,0.0038286}, {9000,0.0038286}, {9050,0.0038571}, {9100,0.0039143}, {9150,0.0039143}, {9200,0.0038857}, {9250,0.0039143}, {9300,0.0040000}, {9350,0.0040000}, {9400,0.0039714}, {9450,0.0040000}, {9500,0.0040000}, {9550,0.0040000}, {9600,0.0040000}, {9650,0.0040000}, {9700,0.0040000}, {9750,0.0040000}, {9800,0.0040286}, {9850,0.0040000}, {9900,0.0040000}, {9950,0.0040571}, {10000,0.0040286}, {10100,0.0040286}, {10200,0.0042286}, {10300,0.0043143}, {10400,0.0043429}, {10500,0.0196286}, {10600,0.0045714}, {10700,0.0047143}, {10800,0.0048000}, {10900,0.0047714}, {11000,0.0047714}, {11100,0.0047714}, {11200,0.0048000}, {11300,0.0048000}, {11400,0.0048857}, {11500,0.0048857}, {11600,0.0048857}, {11700,0.0050000}, {11800,0.0049429}, {11900,0.0050000}, {12000,0.0050000}, {12100,0.0050571}, {12200,0.0051429}, {12300,0.0051429}, {12400,0.0054571}, {12500,0.0053429}, {12600,0.0055714}, {12700,0.0056857}, {12800,0.0057143}, {12900,0.0056857}, {13000,0.0057143}, {13100,0.0057429}, {13200,0.0057143}, {13300,0.0056857}, {13400,0.0056571}, {13500,0.0056857}, {13600,0.0057429}, {13700,0.0058857}, {13800,0.0059429}, {13900,0.0060000}, {14000,0.0060286}, {14100,0.0060857}, {14200,0.0062000}, {14300,0.0296286}, {14400,0.0064286}, {14500,0.0064286}, {14600,0.0065714}, {14700,0.0066857}, {14800,0.0066857}, {14900,0.0067143}, {15000,0.0261714}, {15100,0.0066857}, {15200,0.0066857}, {15300,0.0066857}, {15400,0.0066857}, {15500,0.0066857}, {15600,0.0066571}, {15700,0.0066857}, {15800,0.0222286}, {15900,0.0068000}, {16000,0.0068571}, {16100,0.0070286}, {16200,0.0070000}, {16300,0.0070857}, {16400,0.0072857}, {16500,0.0074000}, {16600,0.0074286}, {16700,0.0075714}, {16800,0.0075714}, {16900,0.0076286}, {17000,0.0076571}, {17100,0.0076286}, {17200,0.0076286}, {17300,0.0076286}, {17400,0.0076571}, {17500,0.0076571}, {17600,0.0076571}, {17700,0.0076571}, {17800,0.0076857}, {17900,0.0077143}, {18000,0.0385429}, {18100,0.0077714}, {18200,0.0078000}, {18300,0.0080857}, {18400,0.0081143}, {18500,0.0082571}, {18600,0.0083143}, {18700,0.0085143}, {18800,0.0084286}, {18900,0.0086286}, {19000,0.0086571}, {19100,0.0086571}, {19200,0.0086571}, {19300,0.0086571}, {19400,0.0086857}, {19500,0.0086286}, {19600,0.0086571}, {19700,0.0086571}, {19800,0.0086571}, {19900,0.0086286}, {20000,0.0086571}};
data["big_flat"]["LtacTCExplicitCtx"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00002970}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00002970}, {16,0.00000000}, {17,0.00000000}, {18,0.00002970}, {19,0.00000000}, {20,0.00000000}, {21,0.00002970}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00002970}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00002970}, {30,0.00000000}, {31,0.00003960}, {32,0.00000000}, {33,0.00000000}, {34,0.00003960}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00002970}, {40,0.00007921}, {41,0.00000000}, {42,0.00009901}, {43,0.00005941}, {44,0.00000000}, {45,0.00000000}, {46,0.00006931}, {47,0.00005941}, {48,0.00003960}, {49,0.00000000}, {50,0.00006931}, {51,0.00003960}, {52,0.00007921}, {53,0.00003960}, {54,0.00003960}, {55,0.00002970}, {56,0.00003960}, {57,0.00002970}, {58,0.00007921}, {59,0.00006931}, {60,0.00002970}, {61,0.00000000}, {62,0.00002970}, {63,0.00007921}, {64,0.00000000}, {65,0.00002970}, {66,0.00000000}, {67,0.00010891}, {68,0.00000000}, {69,0.00005941}, {70,0.00003960}, {71,0.00002970}, {72,0.00013861}, {73,0.00003960}, {74,0.00008911}, {75,0.00014851}, {76,0.00009901}, {77,0.00005941}, {78,0.00000000}, {79,0.00002970}, {80,0.00000000}, {81,0.00005941}, {82,0.00008911}, {83,0.00017822}, {84,0.00000000}, {85,0.00005941}, {86,0.00011881}, {87,0.00005941}, {88,0.00000000}, {89,0.00011881}, {90,0.00007921}, {91,0.00000000}, {92,0.00006931}, {93,0.00003960}, {94,0.00002970}, {95,0.00013861}, {96,0.00002970}, {97,0.00002970}, {98,0.00009901}, {99,0.00009901}, {100,0.00002970}, {101,0.00008911}, {102,0.00002970}, {103,0.00002970}, {104,0.00007921}, {105,0.00013861}, {106,0.00003960}, {107,0.00013861}, {108,0.00005941}, {109,0.00000000}, {110,0.00009901}, {111,0.00006931}, {112,0.00009901}, {113,0.00000000}, {114,0.00000000}, {115,0.00003960}, {116,0.00000000}, {117,0.00006931}, {118,0.00002970}, {119,0.00013861}, {120,0.00005941}, {121,0.00006931}, {122,0.00008911}, {123,0.00011881}, {124,0.00009901}, {125,0.00009901}, {126,0.00000000}, {127,0.00009901}, {128,0.00002970}, {129,0.00017822}, {130,0.00005941}, {131,0.00000000}, {132,0.00012871}, {133,0.00000000}, {134,0.00003960}, {135,0.00008911}, {136,0.00012871}, {137,0.00011881}, {138,0.00014851}, {139,0.00018812}, {140,0.00002970}, {141,0.00005941}, {142,0.00016832}, {143,0.00012871}, {144,0.00014851}, {145,0.00008911}, {146,0.00010891}, {147,0.00007921}, {148,0.00014851}, {149,0.00013861}, {150,0.00002970}, {151,0.00003960}, {152,0.00003960}, {153,0.00014851}, {154,0.00009901}, {155,0.00003960}, {156,0.00015842}, {157,0.00006931}, {158,0.00003960}, {159,0.00010891}, {160,0.00005941}, {161,0.00007921}, {162,0.00011881}, {163,0.00006931}, {164,0.00007921}, {165,0.00011881}, {166,0.00006931}, {167,0.00010891}, {168,0.00005941}, {169,0.00000000}, {170,0.00010891}, {171,0.00007921}, {172,0.00014851}, {173,0.00010891}, {174,0.00010891}, {175,0.00006931}, {176,0.00016832}, {177,0.00003960}, {178,0.00017822}, {179,0.00009901}, {180,0.00029703}, {181,0.00000000}, {182,0.00006931}, {183,0.00010891}, {184,0.00009901}, {185,0.00014851}, {186,0.00000000}, {187,0.00000000}, {188,0.00014851}, {189,0.00013861}, {190,0.00003960}, {191,0.00014851}, {192,0.00024752}, {193,0.00011881}, {194,0.00009901}, {195,0.00014851}, {196,0.00011881}, {197,0.00015842}, {198,0.00006931}, {199,0.00014851}, {200,0.00006931}, {201,0.00018812}, {202,0.00000000}, {203,0.00010891}, {204,0.00002970}, {205,0.00017822}, {206,0.00011881}, {207,0.00017822}, {208,0.00003960}, {209,0.00018812}, {210,0.00011881}, {211,0.00030693}, {212,0.00017822}, {213,0.00002970}, {214,0.00006931}, {215,0.00003960}, {216,0.00003960}, {217,0.00011881}, {218,0.00006931}, {219,0.00010891}, {220,0.00009901}, {221,0.00003960}, {222,0.00003960}, {223,0.00002970}, {224,0.00031683}, {225,0.00007921}, {226,0.00010891}, {227,0.00008911}, {228,0.00014851}, {229,0.00017822}, {230,0.00023762}, {231,0.00028713}, {232,0.00030693}, {233,0.00003960}, {234,0.00015842}, {235,0.00003960}, {236,0.00012871}, {237,0.00011881}, {238,0.00008911}, {239,0.00005941}, {240,0.00003960}, {241,0.00000000}, {242,0.00009901}, {243,0.00009901}, {244,0.00015842}, {245,0.00037624}, {246,0.00002970}, {247,0.00008911}, {248,0.00013861}, {249,0.00010891}, {250,0.00012871}, {251,0.00015842}, {252,0.00022772}, {253,0.00016832}, {254,0.00008911}, {255,0.00002970}, {256,0.00002970}, {257,0.00005941}, {258,0.00010891}, {259,0.00000000}, {260,0.00006931}, {261,0.00002970}, {262,0.00032673}, {263,0.00003960}, {264,0.00006931}, {265,0.00003960}, {266,0.00009901}, {267,0.00009901}, {268,0.00020792}, {269,0.00018812}, {270,0.00010891}, {271,0.00008911}, {272,0.00020792}, {273,0.00008911}, {274,0.00013861}, {275,0.00002970}, {276,0.00003960}, {277,0.00008911}, {278,0.00007921}, {279,0.00019802}, {280,0.00011881}, {281,0.00009901}, {282,0.00005941}, {283,0.00016832}, {284,0.00005941}, {285,0.00019802}, {286,0.00008911}, {287,0.00008911}, {288,0.00024752}, {289,0.00013861}, {290,0.00010891}, {291,0.00028713}, {292,0.00018812}, {293,0.00007921}, {294,0.00009901}, {295,0.00013861}, {296,0.00022772}, {297,0.00011881}, {298,0.00013861}, {299,0.00009901}, {300,0.00017822}, {301,0.00009901}, {302,0.00017822}, {303,0.00003960}, {304,0.00013861}, {305,0.00014851}, {306,0.00015842}, {307,0.00020792}, {308,0.00018812}, {309,0.00022772}, {310,0.00012871}, {311,0.00009901}, {312,0.00012871}, {313,0.00021782}, {314,0.00010891}, {315,0.00020792}, {316,0.00020792}, {317,0.00019802}, {318,0.00008911}, {319,0.00011881}, {320,0.00011881}, {321,0.00013861}, {322,0.00010891}, {323,0.00016832}, {324,0.00010891}, {325,0.00016832}, {326,0.00034653}, {327,0.00014851}, {328,0.00013861}, {329,0.00025743}, {330,0.00010891}, {331,0.00013861}, {332,0.00018812}, {333,0.00019802}, {334,0.00009901}, {335,0.00008911}, {336,0.00016832}, {337,0.00019802}, {338,0.00014851}, {339,0.00011881}, {340,0.00018812}, {341,0.00002970}, {342,0.00011881}, {343,0.00015842}, {344,0.00003960}, {345,0.00017822}, {346,0.00006931}, {347,0.00008911}, {348,0.00012871}, {349,0.00005941}, {350,0.00022772}, {351,0.00015842}, {352,0.00002970}, {353,0.00002970}, {354,0.00016832}, {355,0.00015842}, {356,0.00015842}, {357,0.00009901}, {358,0.00014851}, {359,0.00013861}, {360,0.00024752}, {361,0.00013861}, {362,0.00010891}, {363,0.00009901}, {364,0.00021782}, {365,0.00013861}, {366,0.00035644}, {367,0.00012871}, {368,0.00017822}, {369,0.00006931}, {370,0.00019802}, {371,0.00013861}, {372,0.00006931}, {373,0.00030693}, {374,0.00031683}, {375,0.00016832}, {376,0.00021782}, {377,0.00010891}, {378,0.00030693}, {379,0.00014851}, {380,0.00019802}, {381,0.00019802}, {382,0.00014851}, {383,0.00014851}, {384,0.00013861}, {385,0.00014851}, {386,0.00023762}, {387,0.00029703}, {388,0.00013861}, {389,0.00045545}, {390,0.00026733}, {391,0.00016832}, {392,0.00017822}, {393,0.00003960}, {394,0.00013861}, {395,0.00024752}, {396,0.00012871}, {397,0.00018812}, {398,0.00018812}, {399,0.00020792}, {400,0.00006931}, {401,0.00018812}, {402,0.00003960}, {403,0.00012871}, {404,0.00028713}, {405,0.00015842}, {406,0.00025743}, {407,0.00023762}, {408,0.00010891}, {409,0.00034653}, {410,0.00025743}, {411,0.00013861}, {412,0.00036634}, {413,0.00036634}, {414,0.00024752}, {415,0.00015842}, {416,0.00017822}, {417,0.00016832}, {418,0.00016832}, {419,0.00028713}, {420,0.00177228}, {421,0.00018812}, {422,0.00029703}, {423,0.00014851}, {424,0.00027723}, {425,0.00021782}, {426,0.00017822}, {427,0.00017822}, {428,0.00024752}, {429,0.00021782}, {430,0.00013861}, {431,0.00028713}, {432,0.00022772}, {433,0.00010891}, {434,0.00018812}, {435,0.00013861}, {436,0.00025743}, {437,0.00029703}, {438,0.00017822}, {439,0.00020792}, {440,0.00027723}, {441,0.00021782}, {442,0.00025743}, {443,0.00030693}, {444,0.00018812}, {445,0.00012871}, {446,0.00014851}, {447,0.00016832}, {448,0.00006931}, {449,0.00026733}, {450,0.00024752}, {451,0.00009901}, {452,0.00030693}, {453,0.00018812}, {454,0.00030693}, {455,0.00013861}, {456,0.00013861}, {457,0.00040594}, {458,0.00021782}, {459,0.00020792}, {460,0.00029703}, {461,0.00010891}, {462,0.00014851}, {463,0.00013861}, {464,0.00032673}, {465,0.00036634}, {466,0.00003960}, {467,0.00020792}, {468,0.00017822}, {469,0.00034653}, {470,0.00018812}, {471,0.00048515}, {472,0.00022772}, {473,0.00030693}, {474,0.00017822}, {475,0.00003960}, {476,0.00027723}, {477,0.00018812}, {478,0.00026733}, {479,0.00021782}, {480,0.00019802}, {481,0.00014851}, {482,0.00011881}, {483,0.00018812}, {484,0.00019802}, {485,0.00043564}, {486,0.00031683}, {487,0.00025743}, {488,0.00017822}, {489,0.00020792}, {490,0.00032673}, {491,0.00031683}, {492,0.00015842}, {493,0.00038614}, {494,0.00029703}, {495,0.00044554}, {496,0.00033663}, {497,0.00035644}, {498,0.00030693}, {499,0.00016832}, {500,0.00034653}, {505,0.00030693}, {510,0.00018812}, {515,0.00020792}, {520,0.00017822}, {525,0.00016832}, {530,0.00016832}, {535,0.00008911}, {540,0.00017822}, {545,0.00014851}, {550,0.00039604}, {555,0.00012871}, {560,0.00013861}, {565,0.00013861}, {570,0.00029703}, {575,0.00017822}, {580,0.00007921}, {585,0.00025743}, {590,0.00030693}, {595,0.00022772}, {600,0.00017822}, {605,0.00018812}, {610,0.00023762}, {615,0.00026733}, {620,0.00022772}, {625,0.00017822}, {630,0.00028713}, {635,0.00024752}, {640,0.00008911}, {645,0.00049505}, {650,0.00032673}, {655,0.00029703}, {660,0.00015842}, {665,0.00025743}, {670,0.00031683}, {675,0.00029703}, {680,0.00014851}, {685,0.00028713}, {690,0.00034653}, {695,0.00018812}, {700,0.00028713}, {705,0.00033663}, {710,0.00031683}, {715,0.00141584}, {720,0.00020792}, {725,0.00027723}, {730,0.00038614}, {735,0.00015842}, {740,0.00027723}, {745,0.00025743}, {750,0.00037624}, {755,0.00033663}, {760,0.00025743}, {765,0.00035644}, {770,0.00028713}, {775,0.00019802}, {780,0.00017822}, {785,0.00040594}, {790,0.00036634}, {795,0.00032673}, {800,0.00041584}, {805,0.00033663}, {810,0.00032673}, {815,0.00021782}, {820,0.00024752}, {825,0.00033663}, {830,0.00037624}, {835,0.00024752}, {840,0.00022772}, {845,0.00028713}, {850,0.00027723}, {855,0.00031683}, {860,0.00030693}, {865,0.00026733}, {870,0.00038614}, {875,0.00018812}, {880,0.00033663}, {885,0.00038614}, {890,0.00025743}, {895,0.00026733}, {900,0.00026733}, {905,0.00021782}, {910,0.00027723}, {915,0.00017822}, {920,0.00019802}, {925,0.00032673}, {930,0.00157426}, {935,0.00047525}, {940,0.00015842}, {945,0.00026733}, {950,0.00016832}, {955,0.00029703}, {960,0.00035644}, {965,0.00050495}, {970,0.00035644}, {975,0.00031683}, {980,0.00048515}, {985,0.00026733}, {990,0.00041584}, {995,0.00034653}, {1000,0.00040594}, {1010,0.00026733}, {1020,0.00035644}, {1030,0.00033663}, {1040,0.00041584}, {1050,0.00037624}, {1060,0.00040594}, {1070,0.00047525}, {1080,0.00040594}, {1090,0.00036634}, {1100,0.00060396}, {1110,0.00044554}, {1120,0.00044554}, {1130,0.00049505}, {1140,0.00028713}, {1150,0.00032673}, {1160,0.00041584}, {1170,0.00047525}, {1180,0.00036634}, {1190,0.00046535}, {1200,0.00046535}, {1210,0.00040594}, {1220,0.00063366}, {1230,0.00049505}, {1240,0.00064356}, {1250,0.00031683}, {1260,0.00038614}, {1270,0.00060396}, {1280,0.00051485}, {1290,0.00028713}, {1300,0.00060396}, {1310,0.00037624}, {1320,0.00042574}, {1330,0.00041584}, {1340,0.00038614}, {1350,0.00025743}, {1360,0.00052475}, {1370,0.00038614}, {1380,0.00044554}, {1390,0.00058416}, {1400,0.00068317}, {1410,0.00053465}, {1420,0.00041584}, {1430,0.00049505}, {1440,0.00052475}, {1450,0.00052475}, {1460,0.00048515}, {1470,0.00057426}, {1480,0.00054455}, {1490,0.00064356}, {1500,0.00058416}, {1510,0.00042574}, {1520,0.00067327}, {1530,0.00061386}, {1540,0.00056436}, {1550,0.00055446}, {1560,0.00053465}, {1570,0.00068317}, {1580,0.00033663}, {1590,0.00050495}, {1600,0.00051485}, {1610,0.00081188}, {1620,0.00060396}, {1630,0.00066337}, {1640,0.00055446}, {1650,0.00079208}, {1660,0.00098020}, {1670,0.00070297}, {1680,0.00082178}, {1690,0.00044554}, {1700,0.00077228}, {1710,0.00064356}, {1720,0.00066337}, {1730,0.00077228}, {1740,0.00077228}, {1750,0.00049505}, {1760,0.00058416}, {1770,0.00067327}, {1780,0.00075248}, {1790,0.00077228}, {1800,0.00060396}, {1810,0.00062376}, {1820,0.00058416}, {1830,0.00046535}, {1840,0.00054455}, {1850,0.00049505}, {1860,0.00071287}, {1870,0.00074257}, {1880,0.00075248}, {1890,0.00073267}, {1900,0.00084158}, {1910,0.00069307}, {1920,0.00072277}, {1930,0.00078218}, {1940,0.00100990}, {1950,0.00079208}, {1960,0.00073267}, {1970,0.00059406}, {1980,0.00059406}, {1990,0.00078218}, {2000,0.00072277}, {2050,0.00084158}, {2100,0.00062376}, {2150,0.00079208}, {2200,0.00100000}, {2250,0.00107921}, {2300,0.00058416}, {2350,0.00093069}, {2400,0.00094059}, {2450,0.00079208}, {2500,0.00726733}, {2550,0.00107921}, {2600,0.00085149}, {2650,0.00099010}, {2700,0.00082178}, {2750,0.00118812}, {2800,0.00084158}, {2850,0.00093069}, {2900,0.00104950}, {2950,0.00091089}, {3000,0.00137624}, {3050,0.00095050}, {3100,0.00105941}, {3150,0.00123762}, {3200,0.00120792}, {3250,0.00137624}, {3300,0.00116832}, {3350,0.00118812}, {3400,0.00116832}, {3450,0.00130693}, {3500,0.00087129}, {3550,0.00130693}, {3600,0.00126733}, {3650,0.00122772}, {3700,0.00128713}, {3750,0.00135644}, {3800,0.00137624}, {3850,0.00169307}, {3900,0.00143564}, {3950,0.00136634}, {4000,0.00131683}, {4050,0.00161386}, {4100,0.00172277}, {4150,0.00136634}, {4200,0.00174257}, {4250,0.00175248}, {4300,0.00193069}, {4350,0.00175248}, {4400,0.00131683}, {4450,0.00163366}, {4500,0.00138614}, {4550,0.00149505}, {4600,0.00196040}, {4650,0.00214851}, {4700,0.00202970}, {4750,0.00156436}, {4800,0.00193069}, {4850,0.00150495}, {4900,0.00205941}, {4950,0.00203960}, {5000,0.00197030}, {5050,0.00224752}, {5100,0.00198020}, {5150,0.00225743}, {5200,0.00222772}, {5250,0.00211881}, {5300,0.00233663}, {5350,0.00241584}, {5400,0.00201980}, {5450,0.00211881}, {5500,0.00211881}, {5550,0.00213861}, {5600,0.00205941}, {5650,0.00215842}, {5700,0.00212871}, {5750,0.00201980}, {5800,0.00218812}, {5850,0.00245545}, {5900,0.00228713}, {5950,0.00243564}, {6000,0.00235644}, {6050,0.0020857}, {6100,0.0022571}, {6150,0.0021429}, {6200,0.0025429}, {6250,0.0022571}, {6300,0.0023429}, {6350,0.0028571}, {6400,0.0026000}, {6450,0.0027143}, {6500,0.0024571}, {6550,0.0030857}, {6600,0.0027429}, {6650,0.0022571}, {6700,0.0029143}, {6750,0.0025714}, {6800,0.0029143}, {6850,0.0025714}, {6900,0.0025429}, {6950,0.0023143}, {7000,0.0025714}, {7050,0.0023714}, {7100,0.0027429}, {7150,0.0027429}, {7200,0.0027429}, {7250,0.0030286}, {7300,0.0028857}, {7350,0.0025143}, {7400,0.0030286}, {7450,0.0031714}, {7500,0.0029143}, {7550,0.0030286}, {7600,0.0031714}, {7650,0.0031429}, {7700,0.0035429}, {7750,0.0030571}, {7800,0.0036571}, {7850,0.0034857}, {7900,0.0031429}, {7950,0.0037143}, {8000,0.0033714}, {8050,0.0032286}, {8100,0.0036571}, {8150,0.0035429}, {8200,0.0036571}, {8250,0.0033714}, {8300,0.0035143}, {8350,0.0034000}, {8400,0.0034571}, {8450,0.0036571}, {8500,0.0036000}, {8550,0.0038000}, {8600,0.0037714}, {8650,0.0038286}, {8700,0.0039429}, {8750,0.0038857}, {8800,0.0040286}, {8850,0.0038571}, {8900,0.0037143}, {8950,0.0039429}, {9000,0.0044857}, {9050,0.0040000}, {9100,0.0042000}, {9150,0.0040857}, {9200,0.0044571}, {9250,0.0044286}, {9300,0.0042000}, {9350,0.0045143}, {9400,0.0045143}, {9450,0.0041714}, {9500,0.0044000}, {9550,0.0042857}, {9600,0.0046571}, {9650,0.0042000}, {9700,0.0040286}, {9750,0.0045429}, {9800,0.0042000}, {9850,0.0046857}, {9900,0.0047143}, {9950,0.0046857}, {10000,0.0049714}, {10100,0.0042857}, {10200,0.0049429}, {10300,0.0044286}, {10400,0.0044286}, {10500,0.0195143}, {10600,0.0046571}, {10700,0.0044286}, {10800,0.0044286}, {10900,0.0051143}, {11000,0.0046857}, {11100,0.0049714}, {11200,0.0044000}, {11300,0.0052571}, {11400,0.0047143}, {11500,0.0050286}, {11600,0.0053714}, {11700,0.0056571}, {11800,0.0053429}, {11900,0.0056000}, {12000,0.0049714}, {12100,0.0054571}, {12200,0.0052857}, {12300,0.0048857}, {12400,0.0044857}, {12500,0.0055429}, {12600,0.0055143}, {12700,0.0058571}, {12800,0.0052571}, {12900,0.0056286}, {13000,0.0071714}, {13100,0.0056286}, {13200,0.0063714}, {13300,0.0055429}, {13400,0.0062000}, {13500,0.0060000}, {13600,0.0059143}, {13700,0.0062571}, {13800,0.0062000}, {13900,0.0063429}, {14000,0.0057143}, {14100,0.0066571}, {14200,0.0066286}, {14300,0.0298000}, {14400,0.0068857}, {14500,0.0060571}, {14600,0.0066286}, {14700,0.0071714}, {14800,0.0064857}, {14900,0.0066000}, {15000,0.0259429}, {15100,0.0067429}, {15200,0.0065429}, {15300,0.0070000}, {15400,0.0066286}, {15500,0.0068000}, {15600,0.0072286}, {15700,0.0068000}, {15800,0.0217714}, {15900,0.0071714}, {16000,0.0071143}, {16100,0.0076286}, {16200,0.0073143}, {16300,0.0073714}, {16400,0.0074000}, {16500,0.0075143}, {16600,0.0080286}, {16700,0.0076571}, {16800,0.0075714}, {16900,0.0073143}, {17000,0.0082857}, {17100,0.0077429}, {17200,0.0084000}, {17300,0.0081143}, {17400,0.0082000}, {17500,0.0078286}, {17600,0.0082286}, {17700,0.0079714}, {17800,0.0076286}, {17900,0.0079143}, {18000,0.0389143}, {18100,0.0080857}, {18200,0.0081714}, {18300,0.0082857}, {18400,0.0083143}, {18500,0.0080857}, {18600,0.0078571}, {18700,0.0082000}, {18800,0.0087714}, {18900,0.0082286}, {19000,0.0082286}, {19100,0.0086286}, {19200,0.0081714}, {19300,0.0086286}, {19400,0.0085429}, {19500,0.0088857}, {19600,0.0087714}, {19700,0.0094571}, {19800,0.0085714}, {19900,0.0095429}, {20000,0.0088286}};
data["big_flat"]["LtacTCExplicitCtx"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00003960}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00003960}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00003960}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00003960}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00003960}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00003960}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00003960}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00003960}, {276,0.00003960}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00003960}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00003960}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00003960}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00003960}, {355,0.00003960}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00003960}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00003960}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00003960}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00003960}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00003960}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00003960}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00003960}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00003960}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00003960}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00003960}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00003960}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00003960}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00003960}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00003960}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00003960}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00003960}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00003960}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00003960}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00003960}, {2550,0.00003960}, {2600,0.00000000}, {2650,0.00003960}, {2700,0.00003960}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00003960}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00003960}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00003960}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00002970}, {3600,0.00003960}, {3650,0.00000000}, {3700,0.00003960}, {3750,0.00000000}, {3800,0.00003960}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00002970}, {4050,0.00003960}, {4100,0.00000000}, {4150,0.00003960}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00003960}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00003960}, {4650,0.00000000}, {4700,0.00007921}, {4750,0.00000000}, {4800,0.00003960}, {4850,0.00003960}, {4900,0.00003960}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00003960}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0002286}, {6100,0.0002286}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0001143}, {6450,0.0000000}, {6500,0.0001143}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0001143}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0001143}, {7400,0.0001143}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000857}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0001143}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000857}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0001143}, {9300,0.0001143}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0001143}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0001143}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000857}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0001143}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0001143}, {15200,0.0000000}, {15300,0.0001143}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0001143}, {16400,0.0001143}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0001143}, {16900,0.0001143}, {17000,0.0000000}, {17100,0.0001143}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0001143}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0001143}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0001143}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCExplicitCtx"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00001980}, {5,0.00000000}, {6,0.00032673}, {7,0.00100000}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00132673}, {14,0.00187129}, {15,0.00200000}, {16,0.00200000}, {17,0.00200000}, {18,0.00200000}, {19,0.00200000}, {20,0.00225743}, {21,0.00252475}, {22,0.00300000}, {23,0.00300000}, {24,0.00300000}, {25,0.00300000}, {26,0.00400990}, {27,0.00319802}, {28,0.00330693}, {29,0.00504950}, {30,0.00400000}, {31,0.00400000}, {32,0.00400000}, {33,0.00410891}, {34,0.00422772}, {35,0.00432673}, {36,0.00454455}, {37,0.00500000}, {38,0.00500000}, {39,0.00501980}, {40,0.00509901}, {41,0.00532673}, {42,0.00525743}, {43,0.00545545}, {44,0.00580198}, {45,0.00600000}, {46,0.00600000}, {47,0.00627723}, {48,0.00620792}, {49,0.00626733}, {50,0.00631683}, {51,0.00659406}, {52,0.00696040}, {53,0.00751485}, {54,0.00726733}, {55,0.00709901}, {56,0.00715842}, {57,0.00722772}, {58,0.00746535}, {59,0.00791089}, {60,0.00803960}, {61,0.01062376}, {62,0.00813861}, {63,0.00820792}, {64,0.01041584}, {65,0.00834653}, {66,0.00863366}, {67,0.00900990}, {68,0.00917822}, {69,0.00918812}, {70,0.00911881}, {71,0.01058416}, {72,0.00937624}, {73,0.00945545}, {74,0.00975248}, {75,0.01009901}, {76,0.01010891}, {77,0.01018812}, {78,0.01023762}, {79,0.01036634}, {80,0.01030693}, {81,0.01076238}, {82,0.01095050}, {83,0.01110891}, {84,0.01115842}, {85,0.01123762}, {86,0.01118812}, {87,0.01143564}, {88,0.01142574}, {89,0.01191089}, {90,0.01207921}, {91,0.01210891}, {92,0.01339604}, {93,0.01495050}, {94,0.01583168}, {95,0.01639604}, {96,0.01644554}, {97,0.01668317}, {98,0.01644554}, {99,0.01591089}, {100,0.01467327}, {101,0.01338614}, {102,0.01339604}, {103,0.01371287}, {104,0.01382178}, {105,0.01412871}, {106,0.01411881}, {107,0.01424752}, {108,0.01432673}, {109,0.01465347}, {110,0.01998020}, {111,0.01539604}, {112,0.01489109}, {113,0.01507921}, {114,0.01517822}, {115,0.01523762}, {116,0.02079208}, {117,0.01549505}, {118,0.01581188}, {119,0.01603960}, {120,0.01623762}, {121,0.01803960}, {122,0.01630693}, {123,0.01659406}, {124,0.01673267}, {125,0.01671287}, {126,0.01700000}, {127,0.01713861}, {128,0.01981188}, {129,0.01733663}, {130,0.01729703}, {131,0.02140594}, {132,0.01752475}, {133,0.01793069}, {134,0.01901980}, {135,0.01822772}, {136,0.01828713}, {137,0.01833663}, {138,0.01834653}, {139,0.02004950}, {140,0.01866337}, {141,0.02438614}, {142,0.01924752}, {143,0.01938614}, {144,0.01923762}, {145,0.01952475}, {146,0.01938614}, {147,0.01969307}, {148,0.01982178}, {149,0.02025743}, {150,0.02022772}, {151,0.02056436}, {152,0.02032673}, {153,0.02524752}, {154,0.02079208}, {155,0.02149505}, {156,0.02127723}, {157,0.02140594}, {158,0.02963366}, {159,0.02164356}, {160,0.02122772}, {161,0.02162376}, {162,0.02158416}, {163,0.02339604}, {164,0.02220792}, {165,0.02244554}, {166,0.02369307}, {167,0.02274257}, {168,0.02256436}, {169,0.02256436}, {170,0.02883168}, {171,0.02332673}, {172,0.02331683}, {173,0.02342574}, {174,0.03003960}, {175,0.02362376}, {176,0.02342574}, {177,0.02376238}, {178,0.02586139}, {179,0.03196040}, {180,0.02428713}, {181,0.02465347}, {182,0.02450495}, {183,0.02460396}, {184,0.02578218}, {185,0.03031683}, {186,0.03387129}, {187,0.02549505}, {188,0.02542574}, {189,0.02564356}, {190,0.02558416}, {191,0.02596040}, {192,0.02563366}, {193,0.02580198}, {194,0.02593069}, {195,0.02628713}, {196,0.02624752}, {197,0.02638614}, {198,0.02643564}, {199,0.02675248}, {200,0.02653465}, {201,0.02688119}, {202,0.02729703}, {203,0.02750495}, {204,0.02754455}, {205,0.02762376}, {206,0.02788119}, {207,0.02805941}, {208,0.02783168}, {209,0.04060396}, {210,0.03605941}, {211,0.03135644}, {212,0.02842574}, {213,0.02899010}, {214,0.02889109}, {215,0.02914851}, {216,0.03803960}, {217,0.03222772}, {218,0.02920792}, {219,0.02973267}, {220,0.02976238}, {221,0.03719802}, {222,0.02990099}, {223,0.03021782}, {224,0.03029703}, {225,0.03761386}, {226,0.03029703}, {227,0.03092079}, {228,0.04377228}, {229,0.03334653}, {230,0.03107921}, {231,0.03164356}, {232,0.03407921}, {233,0.03130693}, {234,0.03158416}, {235,0.03311881}, {236,0.03175248}, {237,0.03998020}, {238,0.03219802}, {239,0.03253465}, {240,0.03399010}, {241,0.03274257}, {242,0.03817822}, {243,0.03287129}, {244,0.04138614}, {245,0.03333663}, {246,0.04334653}, {247,0.03341584}, {248,0.04546535}, {249,0.03367327}, {250,0.04534653}, {251,0.03408911}, {252,0.04410891}, {253,0.03449505}, {254,0.04109901}, {255,0.03471287}, {256,0.03645545}, {257,0.03474257}, {258,0.03453465}, {259,0.04465347}, {260,0.03501980}, {261,0.03779208}, {262,0.03542574}, {263,0.03575248}, {264,0.04092079}, {265,0.03591089}, {266,0.03574257}, {267,0.04113861}, {268,0.03641584}, {269,0.03654455}, {270,0.03943564}, {271,0.05070297}, {272,0.03703960}, {273,0.03686139}, {274,0.04291089}, {275,0.04873267}, {276,0.03764356}, {277,0.03759406}, {278,0.03906931}, {279,0.04542574}, {280,0.05129703}, {281,0.03842574}, {282,0.03809901}, {283,0.03854455}, {284,0.04154455}, {285,0.04577228}, {286,0.04967327}, {287,0.04085149}, {288,0.03918812}, {289,0.03915842}, {290,0.03949505}, {291,0.03972277}, {292,0.03983168}, {293,0.04069307}, {294,0.04233663}, {295,0.04350495}, {296,0.04436634}, {297,0.04547525}, {298,0.04572277}, {299,0.04608911}, {300,0.04574257}, {301,0.04404950}, {302,0.04722772}, {303,0.04597030}, {304,0.04400000}, {305,0.04188119}, {306,0.04164356}, {307,0.04172277}, {308,0.04169307}, {309,0.04281188}, {310,0.04219802}, {311,0.05616832}, {312,0.05224752}, {313,0.04888119}, {314,0.04452475}, {315,0.04312871}, {316,0.04332673}, {317,0.04363366}, {318,0.05349505}, {319,0.04845545}, {320,0.04323762}, {321,0.04358416}, {322,0.05788119}, {323,0.05196040}, {324,0.04593069}, {325,0.04430693}, {326,0.04468317}, {327,0.05207921}, {328,0.04449505}, {329,0.04475248}, {330,0.05525743}, {331,0.04898020}, {332,0.04512871}, {333,0.06287129}, {334,0.04842574}, {335,0.04643564}, {336,0.05656436}, {337,0.04605941}, {338,0.04607921}, {339,0.05339604}, {340,0.04606931}, {341,0.05827723}, {342,0.04716832}, {343,0.04702970}, {344,0.05040594}, {345,0.04723762}, {346,0.05282178}, {347,0.04753465}, {348,0.05449505}, {349,0.04758416}, {350,0.05465347}, {351,0.04829703}, {352,0.05340594}, {353,0.04833663}, {354,0.05237624}, {355,0.04859406}, {356,0.05015842}, {357,0.06707921}, {358,0.04893069}, {359,0.06071287}, {360,0.04884158}, {361,0.05273267}, {362,0.06403960}, {363,0.04948515}, {364,0.05634653}, {365,0.06592079}, {366,0.04968317}, {367,0.05698020}, {368,0.06579208}, {369,0.05028713}, {370,0.05510891}, {371,0.06270297}, {372,0.05091089}, {373,0.05139604}, {374,0.05776238}, {375,0.06446535}, {376,0.05119802}, {377,0.05159406}, {378,0.05675248}, {379,0.06233663}, {380,0.07468317}, {381,0.05226733}, {382,0.05224752}, {383,0.05629703}, {384,0.06025743}, {385,0.06591089}, {386,0.07034653}, {387,0.05266337}, {388,0.05250495}, {389,0.05307921}, {390,0.05630693}, {391,0.05893069}, {392,0.06115842}, {393,0.06273267}, {394,0.06506931}, {395,0.06717822}, {396,0.06810891}, {397,0.06945545}, {398,0.06997030}, {399,0.07286139}, {400,0.07881188}, {401,0.07381188}, {402,0.07354455}, {403,0.07324752}, {404,0.06840594}, {405,0.07047525}, {406,0.06897030}, {407,0.06747525}, {408,0.06450495}, {409,0.06153465}, {410,0.05992079}, {411,0.05799010}, {412,0.05601980}, {413,0.05660396}, {414,0.05806931}, {415,0.06938614}, {416,0.06778218}, {417,0.06581188}, {418,0.05926733}, {419,0.05705941}, {420,0.05709901}, {421,0.07228713}, {422,0.06520792}, {423,0.05969307}, {424,0.05749505}, {425,0.07458416}, {426,0.06693069}, {427,0.06063366}, {428,0.05845545}, {429,0.07260396}, {430,0.06426733}, {431,0.05934653}, {432,0.07396040}, {433,0.06831683}, {434,0.05929703}, {435,0.08133663}, {436,0.06741584}, {437,0.06003960}, {438,0.07593069}, {439,0.06412871}, {440,0.06006931}, {441,0.07057426}, {442,0.06038614}, {443,0.07410891}, {444,0.06249505}, {445,0.07653465}, {446,0.06510891}, {447,0.07849505}, {448,0.06631683}, {449,0.06169307}, {450,0.06959406}, {451,0.06208911}, {452,0.07073267}, {453,0.06212871}, {454,0.06971287}, {455,0.08306931}, {456,0.06668317}, {457,0.07951485}, {458,0.06384158}, {459,0.07598020}, {460,0.06290099}, {461,0.07054455}, {462,0.08014851}, {463,0.06501980}, {464,0.07406931}, {465,0.06351485}, {466,0.06860396}, {467,0.08312871}, {468,0.06348515}, {469,0.06867327}, {470,0.07766337}, {471,0.08572277}, {472,0.06580198}, {473,0.07451485}, {474,0.08064356}, {475,0.06491089}, {476,0.06767327}, {477,0.07473267}, {478,0.07992079}, {479,0.08565347}, {480,0.06540594}, {481,0.07315842}, {482,0.08034653}, {483,0.08333663}, {484,0.08819802}, {485,0.06633663}, {486,0.06886139}, {487,0.07266337}, {488,0.07630693}, {489,0.07917822}, {490,0.08193069}, {491,0.08467327}, {492,0.08704950}, {493,0.06784158}, {494,0.06827723}, {495,0.06826733}, {496,0.06923762}, {497,0.07089109}, {498,0.07158416}, {499,0.07271287}, {500,0.07276238}, {505,0.07390099}, {510,0.07241584}, {515,0.06995050}, {520,0.09192079}, {525,0.08801980}, {530,0.08488119}, {535,0.07630693}, {540,0.09530693}, {545,0.08458416}, {550,0.10020792}, {555,0.08691089}, {560,0.09711881}, {565,0.08419802}, {570,0.09269307}, {575,0.09733663}, {580,0.08459406}, {585,0.09343564}, {590,0.09537624}, {595,0.09936634}, {600,0.10040594}, {605,0.09936634}, {610,0.09860396}, {615,0.09741584}, {620,0.09268317}, {625,0.09244554}, {630,0.11268317}, {635,0.10557426}, {640,0.09488119}, {645,0.11125743}, {650,0.10014851}, {655,0.11319802}, {660,0.10078218}, {665,0.12140594}, {670,0.09852475}, {675,0.10460396}, {680,0.11372277}, {685,0.11823762}, {690,0.09918812}, {695,0.10201980}, {700,0.10718812}, {705,0.10555446}, {710,0.10535644}, {715,0.10386139}, {720,0.12402970}, {725,0.12180198}, {730,0.11391089}, {735,0.11209901}, {740,0.13025743}, {745,0.11951485}, {750,0.13205941}, {755,0.12107921}, {760,0.12748515}, {765,0.12136634}, {770,0.12496040}, {775,0.13900990}, {780,0.11916832}, {785,0.12592079}, {790,0.14180198}, {795,0.13973267}, {800,0.13995050}, {805,0.13926733}, {810,0.13882178}, {815,0.13803960}, {820,0.13862376}, {825,0.13416832}, {830,0.12755446}, {835,0.14405941}, {840,0.13693069}, {845,0.13148515}, {850,0.14412871}, {855,0.13517822}, {860,0.14456436}, {865,0.12935644}, {870,0.14668317}, {875,0.15300990}, {880,0.13320792}, {885,0.13988119}, {890,0.15494059}, {895,0.15157426}, {900,0.15092079}, {905,0.14944554}, {910,0.14950495}, {915,0.15777228}, {920,0.15063366}, {925,0.14469307}, {930,0.13877228}, {935,0.15648515}, {940,0.15306931}, {945,0.14308911}, {950,0.15644554}, {955,0.14625743}, {960,0.17010891}, {965,0.14787129}, {970,0.15725743}, {975,0.16315842}, {980,0.18999010}, {985,0.15721782}, {990,0.16053465}, {995,0.16159406}, {1000,0.18014851}, {1010,0.17271287}, {1020,0.16658416}, {1030,0.16292079}, {1040,0.16255446}, {1050,0.17836634}, {1060,0.16549505}, {1070,0.17776238}, {1080,0.19279208}, {1090,0.17201980}, {1100,0.17495050}, {1110,0.18340594}, {1120,0.17978218}, {1130,0.17460396}, {1140,0.20452475}, {1150,0.19216832}, {1160,0.19917822}, {1170,0.18842574}, {1180,0.20500990}, {1190,0.20548515}, {1200,0.19821782}, {1210,0.19311881}, {1220,0.21460396}, {1230,0.21009901}, {1240,0.21189109}, {1250,0.19795050}, {1260,0.22331683}, {1270,0.20390099}, {1280,0.20749505}, {1290,0.23085149}, {1300,0.22605941}, {1310,0.22299010}, {1320,0.23266337}, {1330,0.22392079}, {1340,0.21686139}, {1350,0.21634653}, {1360,0.22636634}, {1370,0.22424752}, {1380,0.22753465}, {1390,0.23174257}, {1400,0.24434653}, {1410,0.23688119}, {1420,0.26346535}, {1430,0.24218812}, {1440,0.23215842}, {1450,0.23513861}, {1460,0.24081188}, {1470,0.26313861}, {1480,0.23938614}, {1490,0.25013861}, {1500,0.25554455}, {1510,0.25248515}, {1520,0.26190099}, {1530,0.25189109}, {1540,0.25288119}, {1550,0.26470297}, {1560,0.27834653}, {1570,0.27243564}, {1580,0.25000990}, {1590,0.27019802}, {1600,0.26733663}, {1610,0.27892079}, {1620,0.27224752}, {1630,0.27591089}, {1640,0.26619802}, {1650,0.26300990}, {1660,0.27697030}, {1670,0.26734653}, {1680,0.27469307}, {1690,0.28712871}, {1700,0.28928713}, {1710,0.29516832}, {1720,0.29212871}, {1730,0.29676238}, {1740,0.28602970}, {1750,0.28738614}, {1760,0.31717822}, {1770,0.29172277}, {1780,0.32641584}, {1790,0.30443564}, {1800,0.32069307}, {1810,0.28872277}, {1820,0.29975248}, {1830,0.31160396}, {1840,0.31406931}, {1850,0.29619802}, {1860,0.32355446}, {1870,0.32314851}, {1880,0.31883168}, {1890,0.31298020}, {1900,0.30934653}, {1910,0.31957426}, {1920,0.33479208}, {1930,0.31423762}, {1940,0.34400000}, {1950,0.32830693}, {1960,0.32498020}, {1970,0.36159406}, {1980,0.32049505}, {1990,0.33613861}, {2000,0.32942574}, {2050,0.34169307}, {2100,0.37417822}, {2150,0.36256436}, {2200,0.36497030}, {2250,0.38193069}, {2300,0.38229703}, {2350,0.39168317}, {2400,0.41135644}, {2450,0.43296040}, {2500,0.40750495}, {2550,0.43941584}, {2600,0.43072277}, {2650,0.44835644}, {2700,0.46062376}, {2750,0.48081188}, {2800,0.51946535}, {2850,1.46925743}, {2900,0.47724752}, {2950,0.48567327}, {3000,0.51026733}, {3050,0.52885149}, {3100,0.53149505}, {3150,0.54057426}, {3200,0.53216832}, {3250,0.54848515}, {3300,0.56468317}, {3350,0.57859406}, {3400,0.56798020}, {3450,0.58465347}, {3500,0.59708911}, {3550,0.61273267}, {3600,0.62859406}, {3650,0.63584158}, {3700,0.65957426}, {3750,0.64996040}, {3800,0.66174257}, {3850,0.67022772}, {3900,0.66194059}, {3950,0.67896040}, {4000,0.71111881}, {4050,0.69995050}, {4100,0.69547525}, {4150,0.70751485}, {4200,0.74484158}, {4250,0.74350495}, {4300,0.73367327}, {4350,0.76379208}, {4400,0.77329703}, {4450,0.77220792}, {4500,0.77596040}, {4550,0.78814851}, {4600,0.79665347}, {4650,0.82460396}, {4700,0.80240594}, {4750,0.82451485}, {4800,0.82900990}, {4850,0.85386139}, {4900,0.83803960}, {4950,0.86443564}, {5000,0.86764356}, {5050,0.89201980}, {5100,0.90789109}, {5150,0.92243564}, {5200,0.89638614}, {5250,0.92916832}, {5300,0.91463366}, {5350,0.93108911}, {5400,0.95498020}, {5450,0.97109901}, {5500,0.96861386}, {5550,0.95631683}, {5600,0.97556436}, {5650,0.98980198}, {5700,1.02447525}, {5750,0.99578218}, {5800,1.00803960}, {5850,1.06297030}, {5900,1.03339604}, {5950,1.05003960}, {6000,1.05428713}, {6050,1.1172286}, {6100,1.1322000}, {6150,1.1163429}, {6200,1.1304571}, {6250,1.1537143}, {6300,1.1542571}, {6350,1.1564857}, {6400,1.1553143}, {6450,1.1794571}, {6500,1.2112000}, {6550,1.2231143}, {6600,1.2178571}, {6650,1.2358571}, {6700,1.2693714}, {6750,1.2717429}, {6800,1.2623429}, {6850,1.2878286}, {6900,1.2943714}, {6950,1.3117714}, {7000,1.3023429}, {7050,1.3043429}, {7100,1.3238286}, {7150,1.3308286}, {7200,1.3137143}, {7250,1.3305714}, {7300,1.3182000}, {7350,1.3236286}, {7400,1.3402857}, {7450,1.3634857}, {7500,1.3858286}, {7550,1.4153714}, {7600,1.4217143}, {7650,1.4202000}, {7700,1.4182000}, {7750,1.4018571}, {7800,1.4234000}, {7850,1.4888000}, {7900,1.4790571}, {7950,1.4835714}, {8000,1.4652000}, {8050,1.4814000}, {8100,1.4688571}, {8150,1.5300286}, {8200,1.5045714}, {8250,1.5237429}, {8300,1.5006571}, {8350,1.5554286}, {8400,1.5512571}, {8450,1.5494857}, {8500,1.5420286}, {8550,1.5922286}, {8600,1.5927714}, {8650,1.5948286}, {8700,1.6001714}, {8750,1.6427143}, {8800,1.6282571}, {8850,1.5984000}, {8900,1.6791143}, {8950,1.6783714}, {9000,1.6215429}, {9050,1.6740857}, {9100,1.6920000}, {9150,1.6820857}, {9200,1.7346286}, {9250,1.6911429}, {9300,1.7493429}, {9350,1.7490000}, {9400,1.7290857}, {9450,1.7665714}, {9500,1.7502571}, {9550,1.7840571}, {9600,1.7904571}, {9650,1.7845143}, {9700,1.8060286}, {9750,1.7818571}, {9800,1.8123143}, {9850,1.8074857}, {9900,1.8462857}, {9950,1.8378286}, {10000,1.8548286}, {10100,1.8915143}, {10200,1.9048571}, {10300,1.8921143}, {10400,1.9343143}, {10500,1.8588571}, {10600,1.9714571}, {10700,1.9377714}, {10800,2.0219714}, {10900,1.9781143}, {11000,2.0570286}, {11100,2.0138571}, {11200,2.0623143}, {11300,2.0756286}, {11400,2.0773429}, {11500,2.1437429}, {11600,2.1169143}, {11700,2.1878286}, {11800,2.1556571}, {11900,2.1857714}, {12000,2.2429714}, {12100,2.2270000}, {12200,2.2591143}, {12300,2.2681143}, {12400,2.2772857}, {12500,2.2816286}, {12600,2.3909143}, {12700,2.3519714}, {12800,2.3289714}, {12900,2.3492857}, {13000,2.3907429}, {13100,2.4326286}, {13200,2.4309429}, {13300,2.4534857}, {13400,2.4706857}, {13500,2.5015714}, {13600,2.5078857}, {13700,2.5094000}, {13800,2.5456286}, {13900,2.5547429}, {14000,2.5808000}, {14100,2.6094286}, {14200,2.6301143}, {14300,2.6608000}, {14400,2.8981714}, {14500,2.8508286}, {14600,2.6789429}, {14700,2.7099143}, {14800,2.7060857}, {14900,2.7326000}, {15000,2.7398571}, {15100,2.8055714}, {15200,2.7689143}, {15300,2.7926000}, {15400,2.9017714}, {15500,2.9958000}, {15600,3.0316571}, {15700,2.9199714}, {15800,3.1520571}, {15900,2.9250571}, {16000,3.2400571}, {16100,2.9545143}, {16200,2.9508000}, {16300,3.0771143}, {16400,3.0559143}, {16500,3.0367143}, {16600,3.0395143}, {16700,3.0365143}, {16800,3.0331429}, {16900,3.1457429}, {17000,3.2040571}, {17100,3.2174000}, {17200,3.1248571}, {17300,3.1744000}, {17400,3.1748000}, {17500,3.2108571}, {17600,3.2655714}, {17700,3.3057714}, {17800,3.2619714}, {17900,3.3687143}, {18000,3.3442000}, {18100,3.5375714}, {18200,3.3207143}, {18300,3.4686000}, {18400,3.5214857}, {18500,3.4542286}, {18600,3.6586571}, {18700,3.4812571}, {18800,3.5306571}, {18900,3.5457143}, {19000,3.4889429}, {19100,3.4809714}, {19200,3.4788571}, {19300,3.5655429}, {19400,3.5799429}, {19500,3.7622857}, {19600,3.6668571}, {19700,3.9699429}, {19800,3.9735429}, {19900,3.6704000}, {20000,3.8478000}};
data["big_flat"]["LtacTCExplicitCtx"]["norm reif"]["user"] = {{1,0.00014851}, {2,0.00043564}, {3,0.00035644}, {4,0.00051485}, {5,0.00081188}, {6,0.00087129}, {7,0.00062376}, {8,0.00077228}, {9,0.00141584}, {10,0.00126733}, {11,0.00171287}, {12,0.00148515}, {13,0.00154455}, {14,0.00161386}, {15,0.00200990}, {16,0.00217822}, {17,0.00215842}, {18,0.00240594}, {19,0.00255446}, {20,0.00260396}, {21,0.00255446}, {22,0.00307921}, {23,0.00283168}, {24,0.00307921}, {25,0.00323762}, {26,0.00397030}, {27,0.00323762}, {28,0.00333663}, {29,0.00496040}, {30,0.00390099}, {31,0.00389109}, {32,0.00424752}, {33,0.00435644}, {34,0.00437624}, {35,0.00421782}, {36,0.00482178}, {37,0.00508911}, {38,0.00509901}, {39,0.00535644}, {40,0.00522772}, {41,0.00549505}, {42,0.00588119}, {43,0.00563366}, {44,0.00542574}, {45,0.00613861}, {46,0.00594059}, {47,0.00673267}, {48,0.00666337}, {49,0.00669307}, {50,0.00688119}, {51,0.00658416}, {52,0.00700000}, {53,0.00796040}, {54,0.00755446}, {55,0.00748515}, {56,0.00760396}, {57,0.00785149}, {58,0.00802970}, {59,0.00789109}, {60,0.00813861}, {61,0.01035644}, {62,0.00808911}, {63,0.00823762}, {64,0.01089109}, {65,0.00834653}, {66,0.00887129}, {67,0.00851485}, {68,0.00935644}, {69,0.00893069}, {70,0.00897030}, {71,0.01088119}, {72,0.00938614}, {73,0.00958416}, {74,0.00984158}, {75,0.01011881}, {76,0.00981188}, {77,0.01015842}, {78,0.01011881}, {79,0.01046535}, {80,0.01109901}, {81,0.01095050}, {82,0.01071287}, {83,0.01103960}, {84,0.01126733}, {85,0.01145545}, {86,0.01137624}, {87,0.01177228}, {88,0.01177228}, {89,0.01206931}, {90,0.01215842}, {91,0.01229703}, {92,0.01358416}, {93,0.01513861}, {94,0.01601980}, {95,0.01669307}, {96,0.01652475}, {97,0.01693069}, {98,0.01663366}, {99,0.01610891}, {100,0.01476238}, {101,0.01405941}, {102,0.01403960}, {103,0.01430693}, {104,0.01359406}, {105,0.01401980}, {106,0.01436634}, {107,0.01458416}, {108,0.01511881}, {109,0.01526733}, {110,0.01962376}, {111,0.01604950}, {112,0.01520792}, {113,0.01543564}, {114,0.01574257}, {115,0.01561386}, {116,0.02054455}, {117,0.01585149}, {118,0.01608911}, {119,0.01611881}, {120,0.01644554}, {121,0.01788119}, {122,0.01646535}, {123,0.01707921}, {124,0.01668317}, {125,0.01701980}, {126,0.01706931}, {127,0.01688119}, {128,0.01953465}, {129,0.01759406}, {130,0.01765347}, {131,0.02109901}, {132,0.01760396}, {133,0.01839604}, {134,0.01878218}, {135,0.01807921}, {136,0.01812871}, {137,0.01855446}, {138,0.01829703}, {139,0.01958416}, {140,0.01859406}, {141,0.02424752}, {142,0.01877228}, {143,0.01901980}, {144,0.01873267}, {145,0.01907921}, {146,0.01928713}, {147,0.01932673}, {148,0.01942574}, {149,0.02007921}, {150,0.01994059}, {151,0.01995050}, {152,0.02004950}, {153,0.02530693}, {154,0.02087129}, {155,0.02145545}, {156,0.02114851}, {157,0.02130693}, {158,0.02968317}, {159,0.02145545}, {160,0.02110891}, {161,0.02172277}, {162,0.02164356}, {163,0.02359406}, {164,0.02196040}, {165,0.02237624}, {166,0.02355446}, {167,0.02269307}, {168,0.02247525}, {169,0.02285149}, {170,0.02866337}, {171,0.02326733}, {172,0.02333663}, {173,0.02390099}, {174,0.02990099}, {175,0.02400000}, {176,0.02366337}, {177,0.02400990}, {178,0.02549505}, {179,0.03197030}, {180,0.02417822}, {181,0.02472277}, {182,0.02462376}, {183,0.02485149}, {184,0.02536634}, {185,0.03042574}, {186,0.03405941}, {187,0.02517822}, {188,0.02545545}, {189,0.02550495}, {190,0.02560396}, {191,0.02583168}, {192,0.02546535}, {193,0.02581188}, {194,0.02598020}, {195,0.02587129}, {196,0.02609901}, {197,0.02624752}, {198,0.02634653}, {199,0.02668317}, {200,0.02650495}, {201,0.02665347}, {202,0.02701980}, {203,0.02713861}, {204,0.02753465}, {205,0.02724752}, {206,0.02786139}, {207,0.02778218}, {208,0.02771287}, {209,0.04035644}, {210,0.03627723}, {211,0.03162376}, {212,0.02843564}, {213,0.02909901}, {214,0.02895050}, {215,0.02916832}, {216,0.03759406}, {217,0.03239604}, {218,0.02938614}, {219,0.02957426}, {220,0.02961386}, {221,0.03688119}, {222,0.02975248}, {223,0.03020792}, {224,0.03059406}, {225,0.03715842}, {226,0.03072277}, {227,0.03117822}, {228,0.04337624}, {229,0.03359406}, {230,0.03119802}, {231,0.03152475}, {232,0.03392079}, {233,0.03154455}, {234,0.03192079}, {235,0.03315842}, {236,0.03170297}, {237,0.03940594}, {238,0.03212871}, {239,0.03249505}, {240,0.03403960}, {241,0.03279208}, {242,0.03767327}, {243,0.03286139}, {244,0.04114851}, {245,0.03310891}, {246,0.04307921}, {247,0.03367327}, {248,0.04582178}, {249,0.03342574}, {250,0.04491089}, {251,0.03420792}, {252,0.04363366}, {253,0.03472277}, {254,0.04086139}, {255,0.03514851}, {256,0.03685149}, {257,0.03473267}, {258,0.03481188}, {259,0.04465347}, {260,0.03554455}, {261,0.03749505}, {262,0.03537624}, {263,0.03579208}, {264,0.04057426}, {265,0.03602970}, {266,0.03598020}, {267,0.04088119}, {268,0.03653465}, {269,0.03672277}, {270,0.03884158}, {271,0.05061386}, {272,0.03679208}, {273,0.03680198}, {274,0.04261386}, {275,0.04870297}, {276,0.03795050}, {277,0.03745545}, {278,0.03879208}, {279,0.04522772}, {280,0.05092079}, {281,0.03826733}, {282,0.03815842}, {283,0.03818812}, {284,0.04145545}, {285,0.04577228}, {286,0.04925743}, {287,0.04020792}, {288,0.03897030}, {289,0.03873267}, {290,0.03933663}, {291,0.03908911}, {292,0.03934653}, {293,0.04047525}, {294,0.04189109}, {295,0.04342574}, {296,0.04427723}, {297,0.04547525}, {298,0.04611881}, {299,0.04582178}, {300,0.04576238}, {301,0.04409901}, {302,0.04715842}, {303,0.04584158}, {304,0.04383168}, {305,0.04153465}, {306,0.04139604}, {307,0.04151485}, {308,0.04155446}, {309,0.04218812}, {310,0.04178218}, {311,0.05611881}, {312,0.05164356}, {313,0.04878218}, {314,0.04456436}, {315,0.04265347}, {316,0.04300990}, {317,0.04346535}, {318,0.05290099}, {319,0.04837624}, {320,0.04327723}, {321,0.04352475}, {322,0.05780198}, {323,0.05134653}, {324,0.04595050}, {325,0.04413861}, {326,0.04425743}, {327,0.05154455}, {328,0.04425743}, {329,0.04471287}, {330,0.05518812}, {331,0.04925743}, {332,0.04502970}, {333,0.06321782}, {334,0.04846535}, {335,0.04629703}, {336,0.05621782}, {337,0.04612871}, {338,0.04620792}, {339,0.05305941}, {340,0.04599010}, {341,0.05829703}, {342,0.04704950}, {343,0.04680198}, {344,0.05007921}, {345,0.04725743}, {346,0.05242574}, {347,0.04748515}, {348,0.05387129}, {349,0.04777228}, {350,0.05366337}, {351,0.04860396}, {352,0.05328713}, {353,0.04874257}, {354,0.05201980}, {355,0.04870297}, {356,0.05028713}, {357,0.06724752}, {358,0.04913861}, {359,0.06057426}, {360,0.04941584}, {361,0.05245545}, {362,0.06400990}, {363,0.04993069}, {364,0.05588119}, {365,0.06514851}, {366,0.04955446}, {367,0.05684158}, {368,0.06514851}, {369,0.04980198}, {370,0.05464356}, {371,0.06236634}, {372,0.05100000}, {373,0.05126733}, {374,0.05781188}, {375,0.06458416}, {376,0.05121782}, {377,0.05150495}, {378,0.05666337}, {379,0.06210891}, {380,0.07439604}, {381,0.05200990}, {382,0.05199010}, {383,0.05596040}, {384,0.06034653}, {385,0.06576238}, {386,0.07029703}, {387,0.05242574}, {388,0.05243564}, {389,0.05308911}, {390,0.05591089}, {391,0.05906931}, {392,0.06137624}, {393,0.06277228}, {394,0.06481188}, {395,0.06705941}, {396,0.06813861}, {397,0.06940594}, {398,0.06983168}, {399,0.07253465}, {400,0.07861386}, {401,0.07370297}, {402,0.07361386}, {403,0.07323762}, {404,0.06848515}, {405,0.07035644}, {406,0.06895050}, {407,0.06717822}, {408,0.06430693}, {409,0.06138614}, {410,0.05992079}, {411,0.05815842}, {412,0.05559406}, {413,0.05661386}, {414,0.05764356}, {415,0.06922772}, {416,0.06742574}, {417,0.06551485}, {418,0.05934653}, {419,0.05669307}, {420,0.05689109}, {421,0.07228713}, {422,0.06479208}, {423,0.05975248}, {424,0.05734653}, {425,0.07422772}, {426,0.06652475}, {427,0.06062376}, {428,0.05819802}, {429,0.07243564}, {430,0.06413861}, {431,0.05926733}, {432,0.07406931}, {433,0.06818812}, {434,0.05919802}, {435,0.08131683}, {436,0.06694059}, {437,0.06013861}, {438,0.07592079}, {439,0.06405941}, {440,0.05986139}, {441,0.07056436}, {442,0.06046535}, {443,0.07376238}, {444,0.06236634}, {445,0.07631683}, {446,0.06502970}, {447,0.07817822}, {448,0.06618812}, {449,0.06163366}, {450,0.06922772}, {451,0.06216832}, {452,0.07067327}, {453,0.06248515}, {454,0.06946535}, {455,0.08294059}, {456,0.06621782}, {457,0.07900000}, {458,0.06379208}, {459,0.07581188}, {460,0.06278218}, {461,0.07056436}, {462,0.07988119}, {463,0.06498020}, {464,0.07396040}, {465,0.06324752}, {466,0.06824752}, {467,0.08295050}, {468,0.06345545}, {469,0.06835644}, {470,0.07735644}, {471,0.08556436}, {472,0.06543564}, {473,0.07444554}, {474,0.08032673}, {475,0.06460396}, {476,0.06745545}, {477,0.07479208}, {478,0.07967327}, {479,0.08547525}, {480,0.06514851}, {481,0.07300990}, {482,0.08024752}, {483,0.08341584}, {484,0.08821782}, {485,0.06585149}, {486,0.06878218}, {487,0.07258416}, {488,0.07574257}, {489,0.07876238}, {490,0.08172277}, {491,0.08421782}, {492,0.08675248}, {493,0.06741584}, {494,0.06797030}, {495,0.06800990}, {496,0.06873267}, {497,0.07102970}, {498,0.07134653}, {499,0.07264356}, {500,0.07275248}, {505,0.07390099}, {510,0.07247525}, {515,0.06964356}, {520,0.09173267}, {525,0.08807921}, {530,0.08477228}, {535,0.07620792}, {540,0.09521782}, {545,0.08454455}, {550,0.10003960}, {555,0.08666337}, {560,0.09702970}, {565,0.08458416}, {570,0.09275248}, {575,0.09700000}, {580,0.08452475}, {585,0.09371287}, {590,0.09556436}, {595,0.09918812}, {600,0.10026733}, {605,0.09886139}, {610,0.09851485}, {615,0.09751485}, {620,0.09263366}, {625,0.09222772}, {630,0.11247525}, {635,0.10554455}, {640,0.09452475}, {645,0.11080198}, {650,0.09983168}, {655,0.11295050}, {660,0.10038614}, {665,0.12117822}, {670,0.09820792}, {675,0.10462376}, {680,0.11361386}, {685,0.11797030}, {690,0.09887129}, {695,0.10172277}, {700,0.10724752}, {705,0.10520792}, {710,0.10537624}, {715,0.10380198}, {720,0.12389109}, {725,0.12138614}, {730,0.11349505}, {735,0.11170297}, {740,0.12981188}, {745,0.11923762}, {750,0.13169307}, {755,0.12078218}, {760,0.12729703}, {765,0.12103960}, {770,0.12490099}, {775,0.13871287}, {780,0.11904950}, {785,0.12566337}, {790,0.14128713}, {795,0.13971287}, {800,0.13987129}, {805,0.13896040}, {810,0.13858416}, {815,0.13765347}, {820,0.13824752}, {825,0.13378218}, {830,0.12725743}, {835,0.14372277}, {840,0.13663366}, {845,0.13139604}, {850,0.14400000}, {855,0.13468317}, {860,0.14410891}, {865,0.12897030}, {870,0.14606931}, {875,0.15299010}, {880,0.13287129}, {885,0.13967327}, {890,0.15469307}, {895,0.15126733}, {900,0.15040594}, {905,0.14933663}, {910,0.14928713}, {915,0.15753465}, {920,0.15031683}, {925,0.14440594}, {930,0.13845545}, {935,0.15606931}, {940,0.15342574}, {945,0.14275248}, {950,0.15629703}, {955,0.14626733}, {960,0.16981188}, {965,0.14749505}, {970,0.15695050}, {975,0.16301980}, {980,0.18955446}, {985,0.15733663}, {990,0.16036634}, {995,0.16146535}, {1000,0.17961386}, {1010,0.17222772}, {1020,0.16650495}, {1030,0.16237624}, {1040,0.16216832}, {1050,0.17791089}, {1060,0.16495050}, {1070,0.17736634}, {1080,0.19216832}, {1090,0.17148515}, {1100,0.17453465}, {1110,0.18312871}, {1120,0.17911881}, {1130,0.17441584}, {1140,0.20421782}, {1150,0.19177228}, {1160,0.19848515}, {1170,0.18782178}, {1180,0.20480198}, {1190,0.20492079}, {1200,0.19765347}, {1210,0.19245545}, {1220,0.21408911}, {1230,0.20945545}, {1240,0.21129703}, {1250,0.19749505}, {1260,0.22277228}, {1270,0.20335644}, {1280,0.20686139}, {1290,0.23053465}, {1300,0.22545545}, {1310,0.22244554}, {1320,0.23185149}, {1330,0.22350495}, {1340,0.21651485}, {1350,0.21575248}, {1360,0.22547525}, {1370,0.22364356}, {1380,0.22673267}, {1390,0.23104950}, {1400,0.24335644}, {1410,0.23612871}, {1420,0.26305941}, {1430,0.24116832}, {1440,0.23155446}, {1450,0.23444554}, {1460,0.23998020}, {1470,0.26232673}, {1480,0.23878218}, {1490,0.24933663}, {1500,0.25489109}, {1510,0.25215842}, {1520,0.26126733}, {1530,0.25109901}, {1540,0.25229703}, {1550,0.26370297}, {1560,0.27749505}, {1570,0.27199010}, {1580,0.24953465}, {1590,0.26933663}, {1600,0.26648515}, {1610,0.27825743}, {1620,0.27129703}, {1630,0.27519802}, {1640,0.26544554}, {1650,0.26209901}, {1660,0.27571287}, {1670,0.26667327}, {1680,0.27376238}, {1690,0.28684158}, {1700,0.28808911}, {1710,0.29440594}, {1720,0.29138614}, {1730,0.29564356}, {1740,0.28507921}, {1750,0.28646535}, {1760,0.31634653}, {1770,0.29080198}, {1780,0.32541584}, {1790,0.30342574}, {1800,0.31983168}, {1810,0.28785149}, {1820,0.29931683}, {1830,0.31053465}, {1840,0.31306931}, {1850,0.29550495}, {1860,0.32243564}, {1870,0.32217822}, {1880,0.31771287}, {1890,0.31216832}, {1900,0.30804950}, {1910,0.31881188}, {1920,0.33401980}, {1930,0.31311881}, {1940,0.34254455}, {1950,0.32713861}, {1960,0.32403960}, {1970,0.36058416}, {1980,0.31970297}, {1990,0.33508911}, {2000,0.32871287}, {2050,0.34089109}, {2100,0.37314851}, {2150,0.36135644}, {2200,0.36370297}, {2250,0.38083168}, {2300,0.38152475}, {2350,0.39043564}, {2400,0.41017822}, {2450,0.43221782}, {2500,0.40653465}, {2550,0.43812871}, {2600,0.42971287}, {2650,0.44739604}, {2700,0.45953465}, {2750,0.47967327}, {2800,0.51871287}, {2850,1.46429703}, {2900,0.47606931}, {2950,0.48491089}, {3000,0.50935644}, {3050,0.52820792}, {3100,0.52802970}, {3150,0.53931683}, {3200,0.53098020}, {3250,0.54757426}, {3300,0.56402970}, {3350,0.57775248}, {3400,0.56714851}, {3450,0.58368317}, {3500,0.59638614}, {3550,0.61171287}, {3600,0.62755446}, {3650,0.63474257}, {3700,0.65838614}, {3750,0.64867327}, {3800,0.66042574}, {3850,0.66856436}, {3900,0.66084158}, {3950,0.67785149}, {4000,0.71007921}, {4050,0.69838614}, {4100,0.69440594}, {4150,0.70627723}, {4200,0.74324752}, {4250,0.74168317}, {4300,0.73200990}, {4350,0.76266337}, {4400,0.77207921}, {4450,0.77112871}, {4500,0.77489109}, {4550,0.78700990}, {4600,0.79500000}, {4650,0.82305941}, {4700,0.80037624}, {4750,0.82310891}, {4800,0.82715842}, {4850,0.85217822}, {4900,0.83652475}, {4950,0.86255446}, {5000,0.86569307}, {5050,0.89004950}, {5100,0.90580198}, {5150,0.92038614}, {5200,0.89460396}, {5250,0.92741584}, {5300,0.91247525}, {5350,0.92898020}, {5400,0.95301980}, {5450,0.96896040}, {5500,0.96668317}, {5550,0.95427723}, {5600,0.97357426}, {5650,0.98799010}, {5700,1.02247525}, {5750,0.99352475}, {5800,1.00605941}, {5850,1.06090099}, {5900,1.03155446}, {5950,1.04812871}, {6000,1.05244554}, {6050,1.1097714}, {6100,1.1234286}, {6150,1.1153143}, {6200,1.1292000}, {6250,1.1475714}, {6300,1.1534857}, {6350,1.1555143}, {6400,1.1543429}, {6450,1.1783143}, {6500,1.2103714}, {6550,1.2215143}, {6600,1.2168857}, {6650,1.2349714}, {6700,1.2684857}, {6750,1.2698286}, {6800,1.2610857}, {6850,1.2858857}, {6900,1.2926286}, {6950,1.3110857}, {7000,1.2992571}, {7050,1.3036571}, {7100,1.3229429}, {7150,1.3297143}, {7200,1.3113429}, {7250,1.3293143}, {7300,1.3171714}, {7350,1.3224000}, {7400,1.3340857}, {7450,1.3563714}, {7500,1.3831714}, {7550,1.4129714}, {7600,1.4122000}, {7650,1.4182286}, {7700,1.4106571}, {7750,1.3987143}, {7800,1.4191714}, {7850,1.4836286}, {7900,1.4668000}, {7950,1.4771143}, {8000,1.4641429}, {8050,1.4792857}, {8100,1.4667143}, {8150,1.5282000}, {8200,1.5022000}, {8250,1.5223429}, {8300,1.4985143}, {8350,1.5540857}, {8400,1.5493714}, {8450,1.5476571}, {8500,1.5405429}, {8550,1.5895143}, {8600,1.5906571}, {8650,1.5930000}, {8700,1.5982857}, {8750,1.6380286}, {8800,1.6263429}, {8850,1.5962286}, {8900,1.6771429}, {8950,1.6756571}, {9000,1.6197429}, {9050,1.6726286}, {9100,1.6903143}, {9150,1.6796571}, {9200,1.7327143}, {9250,1.6882000}, {9300,1.7452000}, {9350,1.7458857}, {9400,1.7263429}, {9450,1.7645714}, {9500,1.7476286}, {9550,1.7822000}, {9600,1.7876857}, {9650,1.7816857}, {9700,1.8032571}, {9750,1.7792857}, {9800,1.8098286}, {9850,1.8044286}, {9900,1.8435143}, {9950,1.8351143}, {10000,1.8520000}, {10100,1.8890857}, {10200,1.9012571}, {10300,1.8888286}, {10400,1.9319429}, {10500,1.8562286}, {10600,1.9693143}, {10700,1.9348286}, {10800,2.0194571}, {10900,1.9748571}, {11000,2.0538286}, {11100,2.0108857}, {11200,2.0590000}, {11300,2.0723714}, {11400,2.0742000}, {11500,2.1403429}, {11600,2.1130571}, {11700,2.1838286}, {11800,2.1520571}, {11900,2.1819143}, {12000,2.2398000}, {12100,2.2232857}, {12200,2.2551143}, {12300,2.2648286}, {12400,2.2739143}, {12500,2.2777143}, {12600,2.3872571}, {12700,2.3481429}, {12800,2.3256571}, {12900,2.3458857}, {13000,2.3871714}, {13100,2.4289143}, {13200,2.4276286}, {13300,2.4491429}, {13400,2.4664000}, {13500,2.4983429}, {13600,2.5045714}, {13700,2.5062571}, {13800,2.5424000}, {13900,2.5520571}, {14000,2.5782286}, {14100,2.6057714}, {14200,2.6265429}, {14300,2.6575429}, {14400,2.8946286}, {14500,2.8478000}, {14600,2.6756000}, {14700,2.7060000}, {14800,2.7025429}, {14900,2.7297714}, {15000,2.7371714}, {15100,2.8022571}, {15200,2.7660857}, {15300,2.7895143}, {15400,2.8980571}, {15500,2.9915143}, {15600,3.0275143}, {15700,2.9162571}, {15800,3.1484000}, {15900,2.9224286}, {16000,3.2364000}, {16100,2.9495714}, {16200,2.9469143}, {16300,3.0733143}, {16400,3.0518571}, {16500,3.0328000}, {16600,3.0371143}, {16700,3.0331714}, {16800,3.0308000}, {16900,3.1434571}, {17000,3.2013143}, {17100,3.2147714}, {17200,3.1211429}, {17300,3.1706571}, {17400,3.1705714}, {17500,3.2079429}, {17600,3.2615143}, {17700,3.3020286}, {17800,3.2585143}, {17900,3.3648571}, {18000,3.3405714}, {18100,3.5326571}, {18200,3.3165714}, {18300,3.4636571}, {18400,3.5170857}, {18500,3.4498000}, {18600,3.6522000}, {18700,3.4768000}, {18800,3.5151143}, {18900,3.5321429}, {19000,3.4725714}, {19100,3.4663429}, {19200,3.4732286}, {19300,3.5601714}, {19400,3.5612286}, {19500,3.7286286}, {19600,3.6482286}, {19700,3.9436000}, {19800,3.9429143}, {19900,3.6665429}, {20000,3.8435143}};
data["big_flat"]["LtacTCExplicitCtx"]["norm reif"]["system"] = {{1,0.00005941}, {2,0.00000000}, {3,0.00007921}, {4,0.00005941}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00002970}, {11,0.00000000}, {12,0.00006931}, {13,0.00006931}, {14,0.00000000}, {15,0.00000000}, {16,0.00007921}, {17,0.00003960}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00006931}, {25,0.00007921}, {26,0.00002970}, {27,0.00000000}, {28,0.00003960}, {29,0.00000000}, {30,0.00002970}, {31,0.00000000}, {32,0.00000000}, {33,0.00003960}, {34,0.00006931}, {35,0.00000000}, {36,0.00007921}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003960}, {42,0.00003960}, {43,0.00003960}, {44,0.00003960}, {45,0.00007921}, {46,0.00003960}, {47,0.00000000}, {48,0.00007921}, {49,0.00000000}, {50,0.00000000}, {51,0.00003960}, {52,0.00000000}, {53,0.00002970}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00002970}, {60,0.00000000}, {61,0.00011881}, {62,0.00003960}, {63,0.00007921}, {64,0.00006931}, {65,0.00003960}, {66,0.00000000}, {67,0.00003960}, {68,0.00002970}, {69,0.00003960}, {70,0.00003960}, {71,0.00000000}, {72,0.00007921}, {73,0.00006931}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00002970}, {79,0.00002970}, {80,0.00000000}, {81,0.00003960}, {82,0.00003960}, {83,0.00000000}, {84,0.00000000}, {85,0.00003960}, {86,0.00000000}, {87,0.00003960}, {88,0.00002970}, {89,0.00000000}, {90,0.00005941}, {91,0.00003960}, {92,0.00007921}, {93,0.00007921}, {94,0.00003960}, {95,0.00007921}, {96,0.00014851}, {97,0.00003960}, {98,0.00007921}, {99,0.00000000}, {100,0.00000000}, {101,0.00003960}, {102,0.00000000}, {103,0.00000000}, {104,0.00006931}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00003960}, {109,0.00000000}, {110,0.00003960}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00003960}, {117,0.00007921}, {118,0.00000000}, {119,0.00002970}, {120,0.00000000}, {121,0.00007921}, {122,0.00000000}, {123,0.00000000}, {124,0.00003960}, {125,0.00000000}, {126,0.00003960}, {127,0.00003960}, {128,0.00003960}, {129,0.00000000}, {130,0.00000000}, {131,0.00015842}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00003960}, {136,0.00007921}, {137,0.00000000}, {138,0.00000000}, {139,0.00014851}, {140,0.00000000}, {141,0.00003960}, {142,0.00007921}, {143,0.00003960}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00007921}, {150,0.00000000}, {151,0.00003960}, {152,0.00000000}, {153,0.00010891}, {154,0.00003960}, {155,0.00007921}, {156,0.00011881}, {157,0.00000000}, {158,0.00003960}, {159,0.00000000}, {160,0.00000000}, {161,0.00006931}, {162,0.00000000}, {163,0.00006931}, {164,0.00000000}, {165,0.00003960}, {166,0.00000000}, {167,0.00003960}, {168,0.00003960}, {169,0.00003960}, {170,0.00018812}, {171,0.00000000}, {172,0.00003960}, {173,0.00003960}, {174,0.00019802}, {175,0.00003960}, {176,0.00000000}, {177,0.00000000}, {178,0.00017822}, {179,0.00015842}, {180,0.00000000}, {181,0.00000000}, {182,0.00003960}, {183,0.00003960}, {184,0.00022772}, {185,0.00015842}, {186,0.00007921}, {187,0.00007921}, {188,0.00003960}, {189,0.00000000}, {190,0.00011881}, {191,0.00000000}, {192,0.00000000}, {193,0.00002970}, {194,0.00003960}, {195,0.00000000}, {196,0.00000000}, {197,0.00003960}, {198,0.00000000}, {199,0.00006931}, {200,0.00003960}, {201,0.00002970}, {202,0.00003960}, {203,0.00000000}, {204,0.00003960}, {205,0.00003960}, {206,0.00000000}, {207,0.00009901}, {208,0.00000000}, {209,0.00014851}, {210,0.00000000}, {211,0.00003960}, {212,0.00000000}, {213,0.00003960}, {214,0.00000000}, {215,0.00000000}, {216,0.00003960}, {217,0.00007921}, {218,0.00000000}, {219,0.00003960}, {220,0.00000000}, {221,0.00007921}, {222,0.00000000}, {223,0.00007921}, {224,0.00000000}, {225,0.00027723}, {226,0.00000000}, {227,0.00003960}, {228,0.00033663}, {229,0.00000000}, {230,0.00000000}, {231,0.00007921}, {232,0.00003960}, {233,0.00003960}, {234,0.00000000}, {235,0.00003960}, {236,0.00000000}, {237,0.00011881}, {238,0.00000000}, {239,0.00000000}, {240,0.00011881}, {241,0.00003960}, {242,0.00010891}, {243,0.00003960}, {244,0.00006931}, {245,0.00000000}, {246,0.00003960}, {247,0.00003960}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00003960}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00003960}, {257,0.00011881}, {258,0.00000000}, {259,0.00003960}, {260,0.00000000}, {261,0.00015842}, {262,0.00000000}, {263,0.00000000}, {264,0.00003960}, {265,0.00003960}, {266,0.00003960}, {267,0.00000000}, {268,0.00003960}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00003960}, {273,0.00000000}, {274,0.00000000}, {275,0.00003960}, {276,0.00000000}, {277,0.00003960}, {278,0.00000000}, {279,0.00003960}, {280,0.00006931}, {281,0.00007921}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00003960}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00003960}, {296,0.00002970}, {297,0.00000000}, {298,0.00000000}, {299,0.00007921}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00003960}, {308,0.00003960}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00003960}, {316,0.00000000}, {317,0.00000000}, {318,0.00003960}, {319,0.00010891}, {320,0.00000000}, {321,0.00003960}, {322,0.00000000}, {323,0.00000000}, {324,0.00006931}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00003960}, {333,0.00000000}, {334,0.00000000}, {335,0.00003960}, {336,0.00003960}, {337,0.00000000}, {338,0.00000000}, {339,0.00003960}, {340,0.00003960}, {341,0.00011881}, {342,0.00000000}, {343,0.00000000}, {344,0.00003960}, {345,0.00003960}, {346,0.00011881}, {347,0.00002970}, {348,0.00022772}, {349,0.00000000}, {350,0.00034653}, {351,0.00002970}, {352,0.00011881}, {353,0.00003960}, {354,0.00011881}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00003960}, {359,0.00027723}, {360,0.00000000}, {361,0.00003960}, {362,0.00007921}, {363,0.00000000}, {364,0.00000000}, {365,0.00010891}, {366,0.00000000}, {367,0.00003960}, {368,0.00019802}, {369,0.00007921}, {370,0.00010891}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00003960}, {376,0.00007921}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00003960}, {382,0.00003960}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00003960}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00003960}, {391,0.00000000}, {392,0.00000000}, {393,0.00003960}, {394,0.00003960}, {395,0.00000000}, {396,0.00000000}, {397,0.00007921}, {398,0.00000000}, {399,0.00000000}, {400,0.00002970}, {401,0.00006931}, {402,0.00003960}, {403,0.00003960}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00003960}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00007921}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00003960}, {421,0.00000000}, {422,0.00003960}, {423,0.00000000}, {424,0.00007921}, {425,0.00000000}, {426,0.00000000}, {427,0.00003960}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00007921}, {435,0.00000000}, {436,0.00000000}, {437,0.00003960}, {438,0.00000000}, {439,0.00003960}, {440,0.00000000}, {441,0.00003960}, {442,0.00000000}, {443,0.00003960}, {444,0.00003960}, {445,0.00003960}, {446,0.00000000}, {447,0.00000000}, {448,0.00003960}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00003960}, {453,0.00003960}, {454,0.00003960}, {455,0.00003960}, {456,0.00000000}, {457,0.00006931}, {458,0.00007921}, {459,0.00000000}, {460,0.00007921}, {461,0.00000000}, {462,0.00003960}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003960}, {469,0.00003960}, {470,0.00003960}, {471,0.00000000}, {472,0.00003960}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00007921}, {479,0.00000000}, {480,0.00007921}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00003960}, {485,0.00000000}, {486,0.00003960}, {487,0.00003960}, {488,0.00007921}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00007921}, {495,0.00000000}, {496,0.00007921}, {497,0.00003960}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00003960}, {520,0.00000000}, {525,0.00003960}, {530,0.00000000}, {535,0.00003960}, {540,0.00000000}, {545,0.00000000}, {550,0.00003960}, {555,0.00000000}, {560,0.00000000}, {565,0.00006931}, {570,0.00003960}, {575,0.00007921}, {580,0.00003960}, {585,0.00000000}, {590,0.00003960}, {595,0.00003960}, {600,0.00002970}, {605,0.00000000}, {610,0.00003960}, {615,0.00000000}, {620,0.00003960}, {625,0.00003960}, {630,0.00000000}, {635,0.00003960}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00003960}, {670,0.00007921}, {675,0.00003960}, {680,0.00007921}, {685,0.00000000}, {690,0.00003960}, {695,0.00000000}, {700,0.00003960}, {705,0.00006931}, {710,0.00003960}, {715,0.00000000}, {720,0.00011881}, {725,0.00000000}, {730,0.00003960}, {735,0.00000000}, {740,0.00003960}, {745,0.00000000}, {750,0.00003960}, {755,0.00000000}, {760,0.00000000}, {765,0.00003960}, {770,0.00003960}, {775,0.00000000}, {780,0.00003960}, {785,0.00003960}, {790,0.00000000}, {795,0.00003960}, {800,0.00003960}, {805,0.00000000}, {810,0.00000000}, {815,0.00003960}, {820,0.00003960}, {825,0.00003960}, {830,0.00000000}, {835,0.00003960}, {840,0.00003960}, {845,0.00015842}, {850,0.00000000}, {855,0.00007921}, {860,0.00003960}, {865,0.00003960}, {870,0.00000000}, {875,0.00000000}, {880,0.00003960}, {885,0.00007921}, {890,0.00000000}, {895,0.00000000}, {900,0.00003960}, {905,0.00003960}, {910,0.00000000}, {915,0.00003960}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00007921}, {940,0.00003960}, {945,0.00003960}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00003960}, {975,0.00000000}, {980,0.00002970}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00010891}, {1020,0.00000000}, {1030,0.00003960}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00003960}, {1090,0.00007921}, {1100,0.00003960}, {1110,0.00003960}, {1120,0.00003960}, {1130,0.00000000}, {1140,0.00003960}, {1150,0.00000000}, {1160,0.00003960}, {1170,0.00007921}, {1180,0.00003960}, {1190,0.00003960}, {1200,0.00003960}, {1210,0.00007921}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00003960}, {1280,0.00007921}, {1290,0.00003960}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00011881}, {1330,0.00003960}, {1340,0.00000000}, {1350,0.00007921}, {1360,0.00003960}, {1370,0.00003960}, {1380,0.00000000}, {1390,0.00003960}, {1400,0.00015842}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00003960}, {1440,0.00000000}, {1450,0.00011881}, {1460,0.00000000}, {1470,0.00011881}, {1480,0.00000000}, {1490,0.00011881}, {1500,0.00007921}, {1510,0.00000000}, {1520,0.00007921}, {1530,0.00003960}, {1540,0.00000000}, {1550,0.00007921}, {1560,0.00003960}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00003960}, {1600,0.00000000}, {1610,0.00007921}, {1620,0.00003960}, {1630,0.00007921}, {1640,0.00003960}, {1650,0.00003960}, {1660,0.00011881}, {1670,0.00007921}, {1680,0.00003960}, {1690,0.00003960}, {1700,0.00015842}, {1710,0.00007921}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00003960}, {1750,0.00011881}, {1760,0.00000000}, {1770,0.00003960}, {1780,0.00006931}, {1790,0.00000000}, {1800,0.00003960}, {1810,0.00007921}, {1820,0.00000000}, {1830,0.00011881}, {1840,0.00003960}, {1850,0.00015842}, {1860,0.00003960}, {1870,0.00003960}, {1880,0.00010891}, {1890,0.00000000}, {1900,0.00019802}, {1910,0.00003960}, {1920,0.00003960}, {1930,0.00000000}, {1940,0.00007921}, {1950,0.00007921}, {1960,0.00003960}, {1970,0.00000000}, {1980,0.00007921}, {1990,0.00003960}, {2000,0.00003960}, {2050,0.00006931}, {2100,0.00007921}, {2150,0.00003960}, {2200,0.00003960}, {2250,0.00007921}, {2300,0.00007921}, {2350,0.00011881}, {2400,0.00011881}, {2450,0.00002970}, {2500,0.00011881}, {2550,0.00011881}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00003960}, {2750,0.00000000}, {2800,0.00015842}, {2850,0.00254455}, {2900,0.00015842}, {2950,0.00000000}, {3000,0.00003960}, {3050,0.00007921}, {3100,0.00276238}, {3150,0.00003960}, {3200,0.00007921}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00007921}, {3400,0.00007921}, {3450,0.00000000}, {3500,0.00003960}, {3550,0.00007921}, {3600,0.00003960}, {3650,0.00007921}, {3700,0.00023762}, {3750,0.00007921}, {3800,0.00002970}, {3850,0.00019802}, {3900,0.00003960}, {3950,0.00003960}, {4000,0.00007921}, {4050,0.00027723}, {4100,0.00007921}, {4150,0.00019802}, {4200,0.00006931}, {4250,0.00019802}, {4300,0.00011881}, {4350,0.00011881}, {4400,0.00000000}, {4450,0.00011881}, {4500,0.00000000}, {4550,0.00007921}, {4600,0.00007921}, {4650,0.00007921}, {4700,0.00007921}, {4750,0.00003960}, {4800,0.00015842}, {4850,0.00019802}, {4900,0.00000000}, {4950,0.00015842}, {5000,0.00023762}, {5050,0.00023762}, {5100,0.00023762}, {5150,0.00003960}, {5200,0.00007921}, {5250,0.00011881}, {5300,0.00042574}, {5350,0.00023762}, {5400,0.00019802}, {5450,0.00015842}, {5500,0.00003960}, {5550,0.00007921}, {5600,0.00015842}, {5650,0.00007921}, {5700,0.00015842}, {5750,0.00015842}, {5800,0.00010891}, {5850,0.00007921}, {5900,0.00027723}, {5950,0.00007921}, {6000,0.00007921}, {6050,0.0061429}, {6100,0.0073143}, {6150,0.0002286}, {6200,0.0002286}, {6250,0.0052286}, {6300,0.0002286}, {6350,0.0000000}, {6400,0.0001143}, {6450,0.0000000}, {6500,0.0001143}, {6550,0.0000000}, {6600,0.0001143}, {6650,0.0001143}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0001143}, {6850,0.0001143}, {6900,0.0001143}, {6950,0.0002286}, {7000,0.0001143}, {7050,0.0001143}, {7100,0.0001143}, {7150,0.0000000}, {7200,0.0003143}, {7250,0.0002286}, {7300,0.0001143}, {7350,0.0000000}, {7400,0.0001143}, {7450,0.0001143}, {7500,0.0000000}, {7550,0.0001143}, {7600,0.0003429}, {7650,0.0000000}, {7700,0.0001143}, {7750,0.0001143}, {7800,0.0002286}, {7850,0.0002286}, {7900,0.0002286}, {7950,0.0001143}, {8000,0.0001143}, {8050,0.0001143}, {8100,0.0002286}, {8150,0.0000000}, {8200,0.0005714}, {8250,0.0000000}, {8300,0.0005714}, {8350,0.0002286}, {8400,0.0002286}, {8450,0.0002286}, {8500,0.0000000}, {8550,0.0002286}, {8600,0.0001143}, {8650,0.0000000}, {8700,0.0001143}, {8750,0.0000000}, {8800,0.0001143}, {8850,0.0004571}, {8900,0.0002286}, {8950,0.0001143}, {9000,0.0000000}, {9050,0.0001143}, {9100,0.0001143}, {9150,0.0004571}, {9200,0.0002286}, {9250,0.0002286}, {9300,0.0021143}, {9350,0.0002286}, {9400,0.0002286}, {9450,0.0002286}, {9500,0.0001143}, {9550,0.0001143}, {9600,0.0002000}, {9650,0.0000000}, {9700,0.0002000}, {9750,0.0003429}, {9800,0.0000000}, {9850,0.0001143}, {9900,0.0000000}, {9950,0.0001143}, {10000,0.0002000}, {10100,0.0000000}, {10200,0.0001143}, {10300,0.0002000}, {10400,0.0001143}, {10500,0.0001143}, {10600,0.0001143}, {10700,0.0003429}, {10800,0.0003429}, {10900,0.0001143}, {11000,0.0002286}, {11100,0.0001143}, {11200,0.0003429}, {11300,0.0002286}, {11400,0.0001143}, {11500,0.0002000}, {11600,0.0001143}, {11700,0.0003429}, {11800,0.0003429}, {11900,0.0003143}, {12000,0.0000000}, {12100,0.0001143}, {12200,0.0004571}, {12300,0.0000000}, {12400,0.0001143}, {12500,0.0003429}, {12600,0.0004286}, {12700,0.0001143}, {12800,0.0002286}, {12900,0.0004571}, {13000,0.0001143}, {13100,0.0008000}, {13200,0.0001143}, {13300,0.0003429}, {13400,0.0002286}, {13500,0.0000857}, {13600,0.0000000}, {13700,0.0001143}, {13800,0.0000000}, {13900,0.0003429}, {14000,0.0002000}, {14100,0.0004571}, {14200,0.0002000}, {14300,0.0000000}, {14400,0.0003429}, {14500,0.0003429}, {14600,0.0005429}, {14700,0.0006857}, {14800,0.0010286}, {14900,0.0001143}, {15000,0.0003429}, {15100,0.0003429}, {15200,0.0001143}, {15300,0.0003429}, {15400,0.0004286}, {15500,0.0009143}, {15600,0.0013143}, {15700,0.0017143}, {15800,0.0006857}, {15900,0.0001143}, {16000,0.0007429}, {16100,0.0018286}, {16200,0.0010857}, {16300,0.0013429}, {16400,0.0022857}, {16500,0.0018000}, {16600,0.0003429}, {16700,0.0017143}, {16800,0.0005714}, {16900,0.0000000}, {17000,0.0002286}, {17100,0.0005714}, {17200,0.0005714}, {17300,0.0009143}, {17400,0.0009143}, {17500,0.0003429}, {17600,0.0003429}, {17700,0.0006571}, {17800,0.0002286}, {17900,0.0001143}, {18000,0.0000000}, {18100,0.0011429}, {18200,0.0004571}, {18300,0.0005714}, {18400,0.0001143}, {18500,0.0002286}, {18600,0.0022571}, {18700,0.0003429}, {18800,0.0006857}, {18900,0.0003429}, {19000,0.0000000}, {19100,0.0002286}, {19200,0.0012571}, {19300,0.0017143}, {19400,0.0001143}, {19500,0.0016857}, {19600,0.0012571}, {19700,0.0022571}, {19800,0.0016857}, {19900,0.0008571}, {20000,0.0017143}};
data["big_flat"]["LtacTCExplicitCtx"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00059406}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCExplicitCtx"]["post"]["user"] = {{1,0.00002970}, {2,0.00010891}, {3,0.00003960}, {4,0.00009901}, {5,0.00006931}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00009901}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00010891}, {14,0.00009901}, {15,0.00003960}, {16,0.00000000}, {17,0.00000000}, {18,0.00007921}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00010891}, {24,0.00005941}, {25,0.00000000}, {26,0.00002970}, {27,0.00006931}, {28,0.00000000}, {29,0.00006931}, {30,0.00006931}, {31,0.00000000}, {32,0.00002970}, {33,0.00003960}, {34,0.00006931}, {35,0.00011881}, {36,0.00003960}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00006931}, {42,0.00003960}, {43,0.00003960}, {44,0.00002970}, {45,0.00002970}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00003960}, {50,0.00003960}, {51,0.00010891}, {52,0.00000000}, {53,0.00002970}, {54,0.00000000}, {55,0.00000000}, {56,0.00007921}, {57,0.00003960}, {58,0.00002970}, {59,0.00002970}, {60,0.00000000}, {61,0.00002970}, {62,0.00000000}, {63,0.00003960}, {64,0.00002970}, {65,0.00002970}, {66,0.00000000}, {67,0.00009901}, {68,0.00000000}, {69,0.00000000}, {70,0.00005941}, {71,0.00002970}, {72,0.00002970}, {73,0.00003960}, {74,0.00000000}, {75,0.00003960}, {76,0.00009901}, {77,0.00008911}, {78,0.00009901}, {79,0.00005941}, {80,0.00005941}, {81,0.00000000}, {82,0.00009901}, {83,0.00002970}, {84,0.00002970}, {85,0.00002970}, {86,0.00000000}, {87,0.00003960}, {88,0.00006931}, {89,0.00005941}, {90,0.00009901}, {91,0.00005941}, {92,0.00002970}, {93,0.00005941}, {94,0.00003960}, {95,0.00006931}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00002970}, {101,0.00000000}, {102,0.00002970}, {103,0.00002970}, {104,0.00002970}, {105,0.00002970}, {106,0.00000000}, {107,0.00008911}, {108,0.00002970}, {109,0.00005941}, {110,0.00000000}, {111,0.00002970}, {112,0.00005941}, {113,0.00005941}, {114,0.00000000}, {115,0.00000000}, {116,0.00015842}, {117,0.00002970}, {118,0.00000000}, {119,0.00000000}, {120,0.00002970}, {121,0.00000000}, {122,0.00002970}, {123,0.00005941}, {124,0.00006931}, {125,0.00003960}, {126,0.00002970}, {127,0.00005941}, {128,0.00000000}, {129,0.00003960}, {130,0.00000000}, {131,0.00005941}, {132,0.00003960}, {133,0.00005941}, {134,0.00000000}, {135,0.00006931}, {136,0.00002970}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00002970}, {141,0.00000000}, {142,0.00005941}, {143,0.00000000}, {144,0.00006931}, {145,0.00003960}, {146,0.00000000}, {147,0.00007921}, {148,0.00003960}, {149,0.00000000}, {150,0.00000000}, {151,0.00002970}, {152,0.00000000}, {153,0.00003960}, {154,0.00000000}, {155,0.00000000}, {156,0.00003960}, {157,0.00003960}, {158,0.00002970}, {159,0.00000000}, {160,0.00003960}, {161,0.00000000}, {162,0.00003960}, {163,0.00000000}, {164,0.00003960}, {165,0.00003960}, {166,0.00002970}, {167,0.00000000}, {168,0.00002970}, {169,0.00000000}, {170,0.00010891}, {171,0.00000000}, {172,0.00006931}, {173,0.00000000}, {174,0.00002970}, {175,0.00000000}, {176,0.00010891}, {177,0.00010891}, {178,0.00006931}, {179,0.00000000}, {180,0.00007921}, {181,0.00000000}, {182,0.00003960}, {183,0.00006931}, {184,0.00002970}, {185,0.00003960}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00003960}, {191,0.00003960}, {192,0.00006931}, {193,0.00007921}, {194,0.00000000}, {195,0.00003960}, {196,0.00000000}, {197,0.00000000}, {198,0.00002970}, {199,0.00000000}, {200,0.00002970}, {201,0.00002970}, {202,0.00007921}, {203,0.00000000}, {204,0.00000000}, {205,0.00005941}, {206,0.00003960}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00002970}, {214,0.00005941}, {215,0.00009901}, {216,0.00002970}, {217,0.00005941}, {218,0.00006931}, {219,0.00007921}, {220,0.00003960}, {221,0.00006931}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00002970}, {227,0.00000000}, {228,0.00000000}, {229,0.00002970}, {230,0.00000000}, {231,0.00000000}, {232,0.00002970}, {233,0.00003960}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00005941}, {239,0.00003960}, {240,0.00006931}, {241,0.00009901}, {242,0.00000000}, {243,0.00006931}, {244,0.00006931}, {245,0.00000000}, {246,0.00005941}, {247,0.00003960}, {248,0.00002970}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00005941}, {253,0.00003960}, {254,0.00002970}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00002970}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00003960}, {264,0.00002970}, {265,0.00000000}, {266,0.00003960}, {267,0.00000000}, {268,0.00002970}, {269,0.00000000}, {270,0.00000000}, {271,0.00003960}, {272,0.00000000}, {273,0.00006931}, {274,0.00000000}, {275,0.00002970}, {276,0.00000000}, {277,0.00009901}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00005941}, {284,0.00005941}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00002970}, {290,0.00009901}, {291,0.00003960}, {292,0.00002970}, {293,0.00000000}, {294,0.00000000}, {295,0.00002970}, {296,0.00000000}, {297,0.00005941}, {298,0.00002970}, {299,0.00000000}, {300,0.00006931}, {301,0.00002970}, {302,0.00000000}, {303,0.00003960}, {304,0.00006931}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00007921}, {310,0.00002970}, {311,0.00009901}, {312,0.00006931}, {313,0.00000000}, {314,0.00000000}, {315,0.00005941}, {316,0.00000000}, {317,0.00000000}, {318,0.00002970}, {319,0.00006931}, {320,0.00000000}, {321,0.00002970}, {322,0.00000000}, {323,0.00006931}, {324,0.00002970}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00002970}, {329,0.00002970}, {330,0.00002970}, {331,0.00006931}, {332,0.00002970}, {333,0.00005941}, {334,0.00006931}, {335,0.00005941}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00007921}, {340,0.00000000}, {341,0.00006931}, {342,0.00000000}, {343,0.00000000}, {344,0.00002970}, {345,0.00000000}, {346,0.00003960}, {347,0.00000000}, {348,0.00007921}, {349,0.00000000}, {350,0.00003960}, {351,0.00003960}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00006931}, {356,0.00000000}, {357,0.00000000}, {358,0.00009901}, {359,0.00003960}, {360,0.00003960}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00006931}, {368,0.00002970}, {369,0.00002970}, {370,0.00000000}, {371,0.00003960}, {372,0.00007921}, {373,0.00007921}, {374,0.00003960}, {375,0.00000000}, {376,0.00000000}, {377,0.00010891}, {378,0.00003960}, {379,0.00003960}, {380,0.00002970}, {381,0.00000000}, {382,0.00002970}, {383,0.00006931}, {384,0.00002970}, {385,0.00000000}, {386,0.00000000}, {387,0.00002970}, {388,0.00007921}, {389,0.00003960}, {390,0.00003960}, {391,0.00011881}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00006931}, {397,0.00003960}, {398,0.00002970}, {399,0.00002970}, {400,0.00000000}, {401,0.00003960}, {402,0.00006931}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00007921}, {407,0.00002970}, {408,0.00003960}, {409,0.00006931}, {410,0.00007921}, {411,0.00000000}, {412,0.00000000}, {413,0.00002970}, {414,0.00000000}, {415,0.00007921}, {416,0.00003960}, {417,0.00000000}, {418,0.00000000}, {419,0.00003960}, {420,0.00000000}, {421,0.00006931}, {422,0.00005941}, {423,0.00002970}, {424,0.00003960}, {425,0.00005941}, {426,0.00007921}, {427,0.00006931}, {428,0.00011881}, {429,0.00003960}, {430,0.00000000}, {431,0.00005941}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00003960}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00002970}, {441,0.00003960}, {442,0.00003960}, {443,0.00000000}, {444,0.00011881}, {445,0.00000000}, {446,0.00006931}, {447,0.00000000}, {448,0.00002970}, {449,0.00002970}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00006931}, {454,0.00003960}, {455,0.00002970}, {456,0.00000000}, {457,0.00000000}, {458,0.00003960}, {459,0.00007921}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00003960}, {464,0.00007921}, {465,0.00000000}, {466,0.00006931}, {467,0.00003960}, {468,0.00000000}, {469,0.00009901}, {470,0.00000000}, {471,0.00000000}, {472,0.00010891}, {473,0.00000000}, {474,0.00000000}, {475,0.00003960}, {476,0.00002970}, {477,0.00000000}, {478,0.00000000}, {479,0.00012871}, {480,0.00014851}, {481,0.00007921}, {482,0.00000000}, {483,0.00003960}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00002970}, {489,0.00000000}, {490,0.00003960}, {491,0.00000000}, {492,0.00000000}, {493,0.00003960}, {494,0.00003960}, {495,0.00000000}, {496,0.00003960}, {497,0.00003960}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00003960}, {510,0.00003960}, {515,0.00007921}, {520,0.00000000}, {525,0.00000000}, {530,0.00003960}, {535,0.00000000}, {540,0.00000000}, {545,0.00002970}, {550,0.00003960}, {555,0.00000000}, {560,0.00000000}, {565,0.00002970}, {570,0.00000000}, {575,0.00000000}, {580,0.00003960}, {585,0.00000000}, {590,0.00009901}, {595,0.00002970}, {600,0.00000000}, {605,0.00003960}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00002970}, {630,0.00006931}, {635,0.00007921}, {640,0.00000000}, {645,0.00000000}, {650,0.00002970}, {655,0.00003960}, {660,0.00006931}, {665,0.00002970}, {670,0.00000000}, {675,0.00009901}, {680,0.00002970}, {685,0.00000000}, {690,0.00006931}, {695,0.00000000}, {700,0.00010891}, {705,0.00000000}, {710,0.00002970}, {715,0.00002970}, {720,0.00000000}, {725,0.00006931}, {730,0.00000000}, {735,0.00007921}, {740,0.00000000}, {745,0.00003960}, {750,0.00002970}, {755,0.00003960}, {760,0.00000000}, {765,0.00000000}, {770,0.00002970}, {775,0.00003960}, {780,0.00002970}, {785,0.00003960}, {790,0.00009901}, {795,0.00002970}, {800,0.00005941}, {805,0.00002970}, {810,0.00002970}, {815,0.00000000}, {820,0.00003960}, {825,0.00003960}, {830,0.00006931}, {835,0.00003960}, {840,0.00005941}, {845,0.00000000}, {850,0.00002970}, {855,0.00003960}, {860,0.00000000}, {865,0.00002970}, {870,0.00002970}, {875,0.00000000}, {880,0.00000000}, {885,0.00013861}, {890,0.00000000}, {895,0.00006931}, {900,0.00002970}, {905,0.00010891}, {910,0.00008911}, {915,0.00000000}, {920,0.00002970}, {925,0.00000000}, {930,0.00002970}, {935,0.00000000}, {940,0.00005941}, {945,0.00005941}, {950,0.00000000}, {955,0.00002970}, {960,0.00000000}, {965,0.00002970}, {970,0.00006931}, {975,0.00010891}, {980,0.00005941}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00002970}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00005941}, {1040,0.00076238}, {1050,0.00000000}, {1060,0.00002970}, {1070,0.00000000}, {1080,0.00002970}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00006931}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00002970}, {1160,0.00010891}, {1170,0.00005941}, {1180,0.00006931}, {1190,0.00002970}, {1200,0.00005941}, {1210,0.00002970}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00005941}, {1250,0.00007921}, {1260,0.00006931}, {1270,0.00010891}, {1280,0.00003960}, {1290,0.00005941}, {1300,0.00000000}, {1310,0.00002970}, {1320,0.00002970}, {1330,0.00000000}, {1340,0.00002970}, {1350,0.00000000}, {1360,0.00002970}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00002970}, {1410,0.00000000}, {1420,0.00002970}, {1430,0.00000000}, {1440,0.00003960}, {1450,0.00006931}, {1460,0.00003960}, {1470,0.00010891}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00007921}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00003960}, {1540,0.00003960}, {1550,0.00010891}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00003960}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00007921}, {1630,0.00006931}, {1640,0.00002970}, {1650,0.00000000}, {1660,0.00007921}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00002970}, {1710,0.00000000}, {1720,0.00003960}, {1730,0.00000000}, {1740,0.00006931}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00002970}, {1790,0.00006931}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00005941}, {1840,0.00003960}, {1850,0.00006931}, {1860,0.00000000}, {1870,0.00003960}, {1880,0.00002970}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00002970}, {1930,0.00003960}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00003960}, {1970,0.00010891}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00005941}, {2050,0.00010891}, {2100,0.00002970}, {2150,0.00003960}, {2200,0.00005941}, {2250,0.00000000}, {2300,0.00006931}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00003960}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00003960}, {2700,0.00000000}, {2750,0.00010891}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00006931}, {2950,0.00006931}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00003960}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00009901}, {3350,0.00000000}, {3400,0.00003960}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00003960}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00007921}, {3800,0.00003960}, {3850,0.00002970}, {3900,0.00005941}, {3950,0.00010891}, {4000,0.00003960}, {4050,0.00000000}, {4100,0.00003960}, {4150,0.00006931}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00002970}, {4400,0.00000000}, {4450,0.00003960}, {4500,0.00002970}, {4550,0.00011881}, {4600,0.00000000}, {4650,0.00003960}, {4700,0.00000000}, {4750,0.00003960}, {4800,0.00015842}, {4850,0.00003960}, {4900,0.00003960}, {4950,0.00002970}, {5000,0.00000000}, {5050,0.00010891}, {5100,0.00003960}, {5150,0.00003960}, {5200,0.00000000}, {5250,0.00007921}, {5300,0.00002970}, {5350,0.00019802}, {5400,0.00006931}, {5450,0.00007921}, {5500,0.00003960}, {5550,0.00007921}, {5600,0.00003960}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00003960}, {5800,0.00007921}, {5850,0.00003960}, {5900,0.00003960}, {5950,0.00000000}, {6000,0.00007921}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000857}, {6200,0.0000000}, {6250,0.0001143}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0001143}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0001143}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0001143}, {6800,0.0000000}, {6850,0.0000857}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000857}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0001143}, {7250,0.0000000}, {7300,0.0000857}, {7350,0.0001143}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0001143}, {7750,0.0000857}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000857}, {8450,0.0000000}, {8500,0.0001143}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000857}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000857}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0001143}, {9600,0.0000000}, {9650,0.0000857}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0001143}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0001143}, {10500,0.0000000}, {10600,0.0001143}, {10700,0.0001143}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0002000}, {11200,0.0001143}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0001143}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0002286}, {12200,0.0000000}, {12300,0.0000857}, {12400,0.0001143}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000857}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000857}, {13600,0.0000857}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0002000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000857}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0001143}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000857}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000857}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0001143}, {17000,0.0000000}, {17100,0.0001143}, {17200,0.0000857}, {17300,0.0001714}, {17400,0.0000000}, {17500,0.0001143}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000857}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0002000}, {18400,0.0004000}, {18500,0.0000000}, {18600,0.0000857}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0001143}, {19100,0.0000000}, {19200,0.0001714}, {19300,0.0000857}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000857}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000857}};
data["big_flat"]["LtacTCExplicitCtx"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00003960}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00003960}, {95,0.00000000}, {96,0.00003960}, {97,0.00000000}, {98,0.00003960}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00003960}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00003960}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00003960}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00002970}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003960}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00003960}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0001143}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0001143}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCExplicitCtx"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCExplicitCtx"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00003960}, {8,0.00002970}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00002970}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00002970}, {51,0.00000000}, {52,0.00002970}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00003960}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00005941}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00002970}, {91,0.00002970}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00002970}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00002970}, {103,0.00000000}, {104,0.00002970}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00003960}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00003960}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00002970}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00002970}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00005941}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00003960}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00003960}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00010891}, {159,0.00000000}, {160,0.00000000}, {161,0.00003960}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00002970}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00003960}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00003960}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00003960}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00003960}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00002970}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00002970}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00002970}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00002970}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00002970}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00003960}, {278,0.00000000}, {279,0.00000000}, {280,0.00005941}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00002970}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00003960}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00003960}, {317,0.00000000}, {318,0.00002970}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00002970}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00002970}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00002970}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00002970}, {350,0.00002970}, {351,0.00002970}, {352,0.00002970}, {353,0.00000000}, {354,0.00003960}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00002970}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00003960}, {367,0.00000000}, {368,0.00003960}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00003960}, {373,0.00000000}, {374,0.00000000}, {375,0.00002970}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00003960}, {380,0.00002970}, {381,0.00000000}, {382,0.00007921}, {383,0.00003960}, {384,0.00000000}, {385,0.00000000}, {386,0.00003960}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00006931}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00003960}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00002970}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00003960}, {431,0.00000000}, {432,0.00000000}, {433,0.00003960}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00003960}, {452,0.00000000}, {453,0.00002970}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00002970}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00002970}, {479,0.00000000}, {480,0.00000000}, {481,0.00003960}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00010891}, {486,0.00000000}, {487,0.00003960}, {488,0.00005941}, {489,0.00000000}, {490,0.00003960}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00002970}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00002970}, {660,0.00002970}, {665,0.00002970}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00002970}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00002970}, {745,0.00003960}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00002970}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00002970}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00002970}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00003960}, {925,0.00003960}, {930,0.00007921}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00002970}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00007921}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00006931}, {1270,0.00006931}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00002970}, {1450,0.00000000}, {1460,0.00003960}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00003960}, {1550,0.00000000}, {1560,0.00003960}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00003960}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00002970}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00002970}, {1750,0.00000000}, {1760,0.00002970}, {1770,0.00003960}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00003960}, {1810,0.00000000}, {1820,0.00002970}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00003960}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00003960}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00003960}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00003960}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00003960}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00003960}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00003960}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00003960}, {4250,0.00003960}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00003960}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00002970}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00007921}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000857}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0001143}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000857}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000857}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0001143}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000857}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0001143}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000857}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000857}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000857}, {15500,0.0000000}, {15600,0.0000857}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000857}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000857}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000857}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000857}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCExplicitCtx"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCExplicitCtx"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00001980}, {5,0.00021782}, {6,0.00100000}, {7,0.00100000}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00137624}, {13,0.00181188}, {14,0.00200000}, {15,0.00200000}, {16,0.00200000}, {17,0.00200000}, {18,0.00204950}, {19,0.00216832}, {20,0.00249505}, {21,0.00300000}, {22,0.00300000}, {23,0.00300000}, {24,0.00300000}, {25,0.00303960}, {26,0.00407921}, {27,0.00330693}, {28,0.00386139}, {29,0.00508911}, {30,0.00400000}, {31,0.00400000}, {32,0.00408911}, {33,0.00430693}, {34,0.00426733}, {35,0.00466337}, {36,0.00499010}, {37,0.00500000}, {38,0.00501980}, {39,0.00522772}, {40,0.00523762}, {41,0.00536634}, {42,0.00541584}, {43,0.00594059}, {44,0.00600000}, {45,0.00602970}, {46,0.00612871}, {47,0.00633663}, {48,0.00624752}, {49,0.00639604}, {50,0.00658416}, {51,0.00700000}, {52,0.00701980}, {53,0.00779208}, {54,0.00740594}, {55,0.00711881}, {56,0.00722772}, {57,0.00747525}, {58,0.00790099}, {59,0.00803960}, {60,0.00820792}, {61,0.01090099}, {62,0.00815842}, {63,0.00826733}, {64,0.01065347}, {65,0.00872277}, {66,0.00907921}, {67,0.00907921}, {68,0.00924752}, {69,0.00921782}, {70,0.00916832}, {71,0.01089109}, {72,0.00962376}, {73,0.00998020}, {74,0.01005941}, {75,0.01013861}, {76,0.01020792}, {77,0.01022772}, {78,0.01033663}, {79,0.01060396}, {80,0.01053465}, {81,0.01119802}, {82,0.01108911}, {83,0.01113861}, {84,0.01117822}, {85,0.01131683}, {86,0.01137624}, {87,0.01186139}, {88,0.01184158}, {89,0.01209901}, {90,0.01208911}, {91,0.01213861}, {92,0.01361386}, {93,0.01513861}, {94,0.01603960}, {95,0.01655446}, {96,0.01662376}, {97,0.01691089}, {98,0.01656436}, {99,0.01610891}, {100,0.01491089}, {101,0.01370297}, {102,0.01372277}, {103,0.01409901}, {104,0.01407921}, {105,0.01420792}, {106,0.01418812}, {107,0.01444554}, {108,0.01452475}, {109,0.01490099}, {110,0.02007921}, {111,0.01565347}, {112,0.01510891}, {113,0.01514851}, {114,0.01525743}, {115,0.01547525}, {116,0.02101980}, {117,0.01573267}, {118,0.01610891}, {119,0.01616832}, {120,0.01627723}, {121,0.01816832}, {122,0.01640594}, {123,0.01674257}, {124,0.01695050}, {125,0.01701980}, {126,0.01725743}, {127,0.01723762}, {128,0.02009901}, {129,0.01745545}, {130,0.01744554}, {131,0.02163366}, {132,0.01781188}, {133,0.01823762}, {134,0.01926733}, {135,0.01832673}, {136,0.01842574}, {137,0.01848515}, {138,0.01851485}, {139,0.02026733}, {140,0.01898020}, {141,0.02454455}, {142,0.01939604}, {143,0.01958416}, {144,0.01938614}, {145,0.01964356}, {146,0.01956436}, {147,0.02008911}, {148,0.02014851}, {149,0.02043564}, {150,0.02032673}, {151,0.02073267}, {152,0.02045545}, {153,0.02537624}, {154,0.02108911}, {155,0.02178218}, {156,0.02152475}, {157,0.02150495}, {158,0.02993069}, {159,0.02181188}, {160,0.02138614}, {161,0.02185149}, {162,0.02198020}, {163,0.02363366}, {164,0.02246535}, {165,0.02259406}, {166,0.02386139}, {167,0.02296040}, {168,0.02282178}, {169,0.02289109}, {170,0.02911881}, {171,0.02340594}, {172,0.02346535}, {173,0.02356436}, {174,0.03025743}, {175,0.02395050}, {176,0.02363366}, {177,0.02409901}, {178,0.02608911}, {179,0.03223762}, {180,0.02439604}, {181,0.02484158}, {182,0.02475248}, {183,0.02493069}, {184,0.02600990}, {185,0.03048515}, {186,0.03416832}, {187,0.02563366}, {188,0.02558416}, {189,0.02586139}, {190,0.02579208}, {191,0.02631683}, {192,0.02588119}, {193,0.02609901}, {194,0.02618812}, {195,0.02645545}, {196,0.02640594}, {197,0.02664356}, {198,0.02667327}, {199,0.02712871}, {200,0.02687129}, {201,0.02719802}, {202,0.02751485}, {203,0.02768317}, {204,0.02776238}, {205,0.02786139}, {206,0.02818812}, {207,0.02843564}, {208,0.02811881}, {209,0.04086139}, {210,0.03628713}, {211,0.03153465}, {212,0.02863366}, {213,0.02931683}, {214,0.02919802}, {215,0.02950495}, {216,0.03821782}, {217,0.03246535}, {218,0.02943564}, {219,0.02992079}, {220,0.03000000}, {221,0.03741584}, {222,0.03016832}, {223,0.03041584}, {224,0.03065347}, {225,0.03783168}, {226,0.03048515}, {227,0.03109901}, {228,0.04404950}, {229,0.03354455}, {230,0.03142574}, {231,0.03190099}, {232,0.03429703}, {233,0.03150495}, {234,0.03189109}, {235,0.03336634}, {236,0.03200990}, {237,0.04028713}, {238,0.03247525}, {239,0.03276238}, {240,0.03423762}, {241,0.03302970}, {242,0.03846535}, {243,0.03326733}, {244,0.04161386}, {245,0.03364356}, {246,0.04360396}, {247,0.03368317}, {248,0.04573267}, {249,0.03392079}, {250,0.04558416}, {251,0.03438614}, {252,0.04436634}, {253,0.03474257}, {254,0.04137624}, {255,0.03503960}, {256,0.03673267}, {257,0.03504950}, {258,0.03482178}, {259,0.04493069}, {260,0.03532673}, {261,0.03805941}, {262,0.03570297}, {263,0.03600000}, {264,0.04112871}, {265,0.03611881}, {266,0.03605941}, {267,0.04135644}, {268,0.03673267}, {269,0.03680198}, {270,0.03964356}, {271,0.05097030}, {272,0.03736634}, {273,0.03708911}, {274,0.04310891}, {275,0.04896040}, {276,0.03794059}, {277,0.03789109}, {278,0.03930693}, {279,0.04567327}, {280,0.05159406}, {281,0.03866337}, {282,0.03837624}, {283,0.03879208}, {284,0.04184158}, {285,0.04605941}, {286,0.04986139}, {287,0.04103960}, {288,0.03942574}, {289,0.03952475}, {290,0.03985149}, {291,0.03995050}, {292,0.04005941}, {293,0.04106931}, {294,0.04270297}, {295,0.04377228}, {296,0.04465347}, {297,0.04578218}, {298,0.04597030}, {299,0.04634653}, {300,0.04592079}, {301,0.04434653}, {302,0.04747525}, {303,0.04620792}, {304,0.04426733}, {305,0.04218812}, {306,0.04190099}, {307,0.04201980}, {308,0.04201980}, {309,0.04307921}, {310,0.04252475}, {311,0.05644554}, {312,0.05250495}, {313,0.04912871}, {314,0.04482178}, {315,0.04342574}, {316,0.04359406}, {317,0.04393069}, {318,0.05377228}, {319,0.04875248}, {320,0.04363366}, {321,0.04390099}, {322,0.05815842}, {323,0.05223762}, {324,0.04618812}, {325,0.04457426}, {326,0.04499010}, {327,0.05238614}, {328,0.04477228}, {329,0.04500990}, {330,0.05549505}, {331,0.04931683}, {332,0.04540594}, {333,0.06310891}, {334,0.04873267}, {335,0.04670297}, {336,0.05683168}, {337,0.04638614}, {338,0.04640594}, {339,0.05373267}, {340,0.04631683}, {341,0.05853465}, {342,0.04743564}, {343,0.04739604}, {344,0.05067327}, {345,0.04751485}, {346,0.05315842}, {347,0.04797030}, {348,0.05463366}, {349,0.04791089}, {350,0.05492079}, {351,0.04867327}, {352,0.05379208}, {353,0.04866337}, {354,0.05268317}, {355,0.04894059}, {356,0.05048515}, {357,0.06745545}, {358,0.04927723}, {359,0.06096040}, {360,0.04913861}, {361,0.05296040}, {362,0.06430693}, {363,0.04987129}, {364,0.05662376}, {365,0.06621782}, {366,0.05005941}, {367,0.05727723}, {368,0.06611881}, {369,0.05063366}, {370,0.05543564}, {371,0.06296040}, {372,0.05125743}, {373,0.05164356}, {374,0.05810891}, {375,0.06482178}, {376,0.05154455}, {377,0.05201980}, {378,0.05704950}, {379,0.06261386}, {380,0.07498020}, {381,0.05250495}, {382,0.05256436}, {383,0.05664356}, {384,0.06049505}, {385,0.06621782}, {386,0.07059406}, {387,0.05297030}, {388,0.05285149}, {389,0.05344554}, {390,0.05667327}, {391,0.05917822}, {392,0.06142574}, {393,0.06304950}, {394,0.06547525}, {395,0.06746535}, {396,0.06839604}, {397,0.06978218}, {398,0.07029703}, {399,0.07317822}, {400,0.07903960}, {401,0.07411881}, {402,0.07391089}, {403,0.07356436}, {404,0.06876238}, {405,0.07071287}, {406,0.06924752}, {407,0.06774257}, {408,0.06481188}, {409,0.06182178}, {410,0.06017822}, {411,0.05828713}, {412,0.05629703}, {413,0.05690099}, {414,0.05838614}, {415,0.06973267}, {416,0.06810891}, {417,0.06612871}, {418,0.05956436}, {419,0.05737624}, {420,0.05925743}, {421,0.07254455}, {422,0.06552475}, {423,0.06006931}, {424,0.05784158}, {425,0.07482178}, {426,0.06730693}, {427,0.06099010}, {428,0.05879208}, {429,0.07297030}, {430,0.06467327}, {431,0.05975248}, {432,0.07427723}, {433,0.06860396}, {434,0.05966337}, {435,0.08166337}, {436,0.06778218}, {437,0.06037624}, {438,0.07619802}, {439,0.06444554}, {440,0.06052475}, {441,0.07096040}, {442,0.06077228}, {443,0.07440594}, {444,0.06279208}, {445,0.07684158}, {446,0.06536634}, {447,0.07884158}, {448,0.06672277}, {449,0.06205941}, {450,0.06993069}, {451,0.06240594}, {452,0.07107921}, {453,0.06248515}, {454,0.07000990}, {455,0.08340594}, {456,0.06700990}, {457,0.07981188}, {458,0.06423762}, {459,0.07630693}, {460,0.06326733}, {461,0.07085149}, {462,0.08047525}, {463,0.06532673}, {464,0.07440594}, {465,0.06389109}, {466,0.06890099}, {467,0.08335644}, {468,0.06392079}, {469,0.06898020}, {470,0.07794059}, {471,0.08608911}, {472,0.06608911}, {473,0.07486139}, {474,0.08099010}, {475,0.06527723}, {476,0.06799010}, {477,0.07497030}, {478,0.08026733}, {479,0.08603960}, {480,0.06577228}, {481,0.07354455}, {482,0.08074257}, {483,0.08375248}, {484,0.08854455}, {485,0.06664356}, {486,0.06928713}, {487,0.07298020}, {488,0.07659406}, {489,0.07953465}, {490,0.08222772}, {491,0.08503960}, {492,0.08727723}, {493,0.06830693}, {494,0.06866337}, {495,0.06870297}, {496,0.06961386}, {497,0.07123762}, {498,0.07194059}, {499,0.07308911}, {500,0.07312871}, {505,0.07416832}, {510,0.07281188}, {515,0.07035644}, {520,0.09218812}, {525,0.08846535}, {530,0.08514851}, {535,0.07675248}, {540,0.09574257}, {545,0.08501980}, {550,0.10053465}, {555,0.08723762}, {560,0.09748515}, {565,0.08457426}, {570,0.09311881}, {575,0.09765347}, {580,0.08494059}, {585,0.09392079}, {590,0.09586139}, {595,0.09981188}, {600,0.10077228}, {605,0.09977228}, {610,0.09896040}, {615,0.09777228}, {620,0.09302970}, {625,0.09289109}, {630,0.11307921}, {635,0.10591089}, {640,0.09531683}, {645,0.11173267}, {650,0.10052475}, {655,0.11366337}, {660,0.10117822}, {665,0.12183168}, {670,0.09897030}, {675,0.10499010}, {680,0.11416832}, {685,0.11870297}, {690,0.09969307}, {695,0.10239604}, {700,0.10766337}, {705,0.10600000}, {710,0.10581188}, {715,0.10577228}, {720,0.12438614}, {725,0.12220792}, {730,0.11436634}, {735,0.11251485}, {740,0.13067327}, {745,0.11991089}, {750,0.13262376}, {755,0.12153465}, {760,0.12785149}, {765,0.12191089}, {770,0.12541584}, {775,0.13945545}, {780,0.11963366}, {785,0.12645545}, {790,0.14219802}, {795,0.14024752}, {800,0.14042574}, {805,0.13968317}, {810,0.13927723}, {815,0.13842574}, {820,0.13909901}, {825,0.13472277}, {830,0.12804950}, {835,0.14449505}, {840,0.13743564}, {845,0.13195050}, {850,0.14465347}, {855,0.13566337}, {860,0.14496040}, {865,0.12986139}, {870,0.14713861}, {875,0.15350495}, {880,0.13369307}, {885,0.14045545}, {890,0.15543564}, {895,0.15215842}, {900,0.15140594}, {905,0.14997030}, {910,0.15000000}, {915,0.15830693}, {920,0.15111881}, {925,0.14521782}, {930,0.14097030}, {935,0.15707921}, {940,0.15360396}, {945,0.14352475}, {950,0.15700990}, {955,0.14680198}, {960,0.17070297}, {965,0.14846535}, {970,0.15781188}, {975,0.16374257}, {980,0.19056436}, {985,0.15773267}, {990,0.16108911}, {995,0.16217822}, {1000,0.18071287}, {1010,0.17336634}, {1020,0.16720792}, {1030,0.16353465}, {1040,0.16308911}, {1050,0.17909901}, {1060,0.16610891}, {1070,0.17836634}, {1080,0.19340594}, {1090,0.17267327}, {1100,0.17554455}, {1110,0.18401980}, {1120,0.18030693}, {1130,0.17519802}, {1140,0.20510891}, {1150,0.19276238}, {1160,0.19985149}, {1170,0.18900000}, {1180,0.20564356}, {1190,0.20609901}, {1200,0.19894059}, {1210,0.19379208}, {1220,0.21523762}, {1230,0.21068317}, {1240,0.21258416}, {1250,0.19858416}, {1260,0.22397030}, {1270,0.20461386}, {1280,0.20818812}, {1290,0.23160396}, {1300,0.22665347}, {1310,0.22363366}, {1320,0.23334653}, {1330,0.22461386}, {1340,0.21757426}, {1350,0.21714851}, {1360,0.22707921}, {1370,0.22499010}, {1380,0.22824752}, {1390,0.23244554}, {1400,0.24506931}, {1410,0.23757426}, {1420,0.26414851}, {1430,0.24296040}, {1440,0.23290099}, {1450,0.23582178}, {1460,0.24157426}, {1470,0.26391089}, {1480,0.24013861}, {1490,0.25087129}, {1500,0.25632673}, {1510,0.25319802}, {1520,0.26260396}, {1530,0.25264356}, {1540,0.25369307}, {1550,0.26543564}, {1560,0.27907921}, {1570,0.27328713}, {1580,0.25083168}, {1590,0.27099010}, {1600,0.26812871}, {1610,0.27967327}, {1620,0.27296040}, {1630,0.27678218}, {1640,0.26699010}, {1650,0.26384158}, {1660,0.27779208}, {1670,0.26818812}, {1680,0.27551485}, {1690,0.28800990}, {1700,0.29009901}, {1710,0.29600000}, {1720,0.29298020}, {1730,0.29760396}, {1740,0.28685149}, {1750,0.28816832}, {1760,0.31806931}, {1770,0.29262376}, {1780,0.32729703}, {1790,0.30532673}, {1800,0.32157426}, {1810,0.28966337}, {1820,0.30064356}, {1830,0.31254455}, {1840,0.31498020}, {1850,0.29711881}, {1860,0.32443564}, {1870,0.32401980}, {1880,0.31973267}, {1890,0.31390099}, {1900,0.31027723}, {1910,0.32049505}, {1920,0.33570297}, {1930,0.31518812}, {1940,0.34491089}, {1950,0.32921782}, {1960,0.32587129}, {1970,0.36257426}, {1980,0.32147525}, {1990,0.33711881}, {2000,0.33040594}, {2050,0.34267327}, {2100,0.37516832}, {2150,0.36355446}, {2200,0.36598020}, {2250,0.38296040}, {2300,0.38340594}, {2350,0.39279208}, {2400,0.41245545}, {2450,0.43409901}, {2500,0.41562376}, {2550,0.44057426}, {2600,0.43197030}, {2650,0.44958416}, {2700,0.46187129}, {2750,0.48209901}, {2800,0.52075248}, {2850,1.47056436}, {2900,0.47861386}, {2950,0.48696040}, {3000,0.51160396}, {3050,0.53016832}, {3100,0.53294059}, {3150,0.54200000}, {3200,0.53361386}, {3250,0.55001980}, {3300,0.56619802}, {3350,0.58007921}, {3400,0.56952475}, {3450,0.58623762}, {3500,0.59861386}, {3550,0.61431683}, {3600,0.63020792}, {3650,0.63752475}, {3700,0.66118812}, {3750,0.65165347}, {3800,0.66345545}, {3850,0.67199010}, {3900,0.66369307}, {3950,0.68070297}, {4000,0.71294059}, {4050,0.70172277}, {4100,0.69729703}, {4150,0.70938614}, {4200,0.74677228}, {4250,0.74537624}, {4300,0.73563366}, {4350,0.76575248}, {4400,0.77527723}, {4450,0.77423762}, {4500,0.77795050}, {4550,0.79018812}, {4600,0.79869307}, {4650,0.82674257}, {4700,0.80450495}, {4750,0.82657426}, {4800,0.83114851}, {4850,0.85603960}, {4900,0.84027723}, {4950,0.86662376}, {5000,0.86986139}, {5050,0.89428713}, {5100,0.91013861}, {5150,0.92470297}, {5200,0.89863366}, {5250,0.93149505}, {5300,0.91699010}, {5350,0.93350495}, {5400,0.95742574}, {5450,0.97354455}, {5500,0.97111881}, {5550,0.95875248}, {5600,0.97809901}, {5650,0.99230693}, {5700,1.02693069}, {5750,0.99833663}, {5800,1.01053465}, {5850,1.06552475}, {5900,1.03595050}, {5950,1.05256436}, {6000,1.05697030}, {6050,1.1201143}, {6100,1.1351714}, {6150,1.1192857}, {6200,1.1334286}, {6250,1.1566857}, {6300,1.1572857}, {6350,1.1595714}, {6400,1.1583143}, {6450,1.1825429}, {6500,1.2143143}, {6550,1.2262286}, {6600,1.2210286}, {6650,1.2390000}, {6700,1.2726286}, {6750,1.2749714}, {6800,1.2657143}, {6850,1.2911714}, {6900,1.2978286}, {6950,1.3151143}, {7000,1.3056000}, {7050,1.3076571}, {7100,1.3273143}, {7150,1.3341714}, {7200,1.3171714}, {7250,1.3340857}, {7300,1.3218000}, {7350,1.3272000}, {7400,1.3438571}, {7450,1.3670286}, {7500,1.3893429}, {7550,1.4189714}, {7600,1.4253429}, {7650,1.4239714}, {7700,1.4218857}, {7750,1.4055714}, {7800,1.4272000}, {7850,1.4926000}, {7900,1.4828571}, {7950,1.4875143}, {8000,1.4690857}, {8050,1.4853143}, {8100,1.4726857}, {8150,1.5340000}, {8200,1.5085714}, {8250,1.5277714}, {8300,1.5046000}, {8350,1.5594571}, {8400,1.5552857}, {8450,1.5536571}, {8500,1.5461714}, {8550,1.5964000}, {8600,1.5968857}, {8650,1.5990571}, {8700,1.6045429}, {8750,1.6469143}, {8800,1.6326857}, {8850,1.6027714}, {8900,1.6834857}, {8950,1.6827429}, {9000,1.6258857}, {9050,1.6786000}, {9100,1.6965143}, {9150,1.6866000}, {9200,1.7390000}, {9250,1.6957143}, {9300,1.7540286}, {9350,1.7536857}, {9400,1.7337429}, {9450,1.7714000}, {9500,1.7548857}, {9550,1.7889143}, {9600,1.7951714}, {9650,1.7892000}, {9700,1.8107143}, {9750,1.7866571}, {9800,1.8171143}, {9850,1.8124286}, {9900,1.8511429}, {9950,1.8428000}, {10000,1.8597714}, {10100,1.8964286}, {10200,1.9098286}, {10300,1.8971429}, {10400,1.9394286}, {10500,1.8791143}, {10600,1.9768000}, {10700,1.9432000}, {10800,2.0272857}, {10900,1.9833429}, {11000,2.0623429}, {11100,2.0193429}, {11200,2.0677429}, {11300,2.0810571}, {11400,2.0827429}, {11500,2.1493714}, {11600,2.1225429}, {11700,2.1934571}, {11800,2.1614286}, {11900,2.1915429}, {12000,2.2487714}, {12100,2.2328857}, {12200,2.2649714}, {12300,2.2741143}, {12400,2.2832571}, {12500,2.2876571}, {12600,2.3969429}, {12700,2.3581429}, {12800,2.3352857}, {12900,2.3556000}, {13000,2.3970571}, {13100,2.4388857}, {13200,2.4373714}, {13300,2.4597714}, {13400,2.4771429}, {13500,2.5081714}, {13600,2.5144286}, {13700,2.5160571}, {13800,2.5522286}, {13900,2.5614857}, {14000,2.5875143}, {14100,2.6162857}, {14200,2.6369714}, {14300,2.6911429}, {14400,2.9051714}, {14500,2.8580286}, {14600,2.6861714}, {14700,2.7170571}, {14800,2.7132000}, {14900,2.7398286}, {15000,2.7666857}, {15100,2.8128000}, {15200,2.7761429}, {15300,2.7999714}, {15400,2.9090286}, {15500,3.0032571}, {15600,3.0390571}, {15700,2.9275714}, {15800,3.1751714}, {15900,2.9326571}, {16000,3.2478286}, {16100,2.9622000}, {16200,2.9585143}, {16300,3.0848857}, {16400,3.0638286}, {16500,3.0446857}, {16600,3.0475714}, {16700,3.0446286}, {16800,3.0411429}, {16900,3.1538286}, {17000,3.2122000}, {17100,3.2255429}, {17200,3.1331714}, {17300,3.1826571}, {17400,3.1831143}, {17500,3.2192000}, {17600,3.2740857}, {17700,3.3142571}, {17800,3.2704286}, {17900,3.3772857}, {18000,3.3836000}, {18100,3.5462286}, {18200,3.3294000}, {18300,3.4772857}, {18400,3.5302857}, {18500,3.4630571}, {18600,3.6676286}, {18700,3.4900571}, {18800,3.5395429}, {18900,3.5547714}, {19000,3.4980286}, {19100,3.4900000}, {19200,3.4881714}, {19300,3.5747714}, {19400,3.5892857}, {19500,3.7716857}, {19600,3.6762857}, {19700,3.9792571}, {19800,3.9830286}, {19900,3.6799143}, {20000,3.8572857}};
data["big_flat"]["LtacTCExplicitCtx"]["reif"]["user"] = {{1,0.00017822}, {2,0.00052475}, {3,0.00050495}, {4,0.00051485}, {5,0.00081188}, {6,0.00094059}, {7,0.00073267}, {8,0.00091089}, {9,0.00155446}, {10,0.00135644}, {11,0.00187129}, {12,0.00155446}, {13,0.00163366}, {14,0.00172277}, {15,0.00203960}, {16,0.00223762}, {17,0.00227723}, {18,0.00250495}, {19,0.00272277}, {20,0.00260396}, {21,0.00268317}, {22,0.00314851}, {23,0.00290099}, {24,0.00318812}, {25,0.00326733}, {26,0.00401980}, {27,0.00351485}, {28,0.00348515}, {29,0.00512871}, {30,0.00401980}, {31,0.00398020}, {32,0.00436634}, {33,0.00439604}, {34,0.00447525}, {35,0.00450495}, {36,0.00482178}, {37,0.00513861}, {38,0.00514851}, {39,0.00548515}, {40,0.00550495}, {41,0.00562376}, {42,0.00614851}, {43,0.00594059}, {44,0.00565347}, {45,0.00621782}, {46,0.00621782}, {47,0.00695050}, {48,0.00680198}, {49,0.00684158}, {50,0.00700990}, {51,0.00681188}, {52,0.00733663}, {53,0.00819802}, {54,0.00771287}, {55,0.00775248}, {56,0.00783168}, {57,0.00798020}, {58,0.00819802}, {59,0.00808911}, {60,0.00844554}, {61,0.01052475}, {62,0.00830693}, {63,0.00840594}, {64,0.01100990}, {65,0.00847525}, {66,0.00892079}, {67,0.00873267}, {68,0.00951485}, {69,0.00921782}, {70,0.00905941}, {71,0.01104950}, {72,0.00970297}, {73,0.00980198}, {74,0.01019802}, {75,0.01035644}, {76,0.01002970}, {77,0.01043564}, {78,0.01027723}, {79,0.01067327}, {80,0.01117822}, {81,0.01114851}, {82,0.01088119}, {83,0.01139604}, {84,0.01142574}, {85,0.01166337}, {86,0.01185149}, {87,0.01198020}, {88,0.01181188}, {89,0.01226733}, {90,0.01242574}, {91,0.01243564}, {92,0.01375248}, {93,0.01538614}, {94,0.01626733}, {95,0.01690099}, {96,0.01669307}, {97,0.01705941}, {98,0.01684158}, {99,0.01626733}, {100,0.01511881}, {101,0.01425743}, {102,0.01411881}, {103,0.01447525}, {104,0.01386139}, {105,0.01426733}, {106,0.01451485}, {107,0.01485149}, {108,0.01532673}, {109,0.01542574}, {110,0.01978218}, {111,0.01616832}, {112,0.01546535}, {113,0.01547525}, {114,0.01578218}, {115,0.01588119}, {116,0.02071287}, {117,0.01613861}, {118,0.01627723}, {119,0.01638614}, {120,0.01659406}, {121,0.01803960}, {122,0.01668317}, {123,0.01722772}, {124,0.01684158}, {125,0.01720792}, {126,0.01714851}, {127,0.01700990}, {128,0.01974257}, {129,0.01785149}, {130,0.01785149}, {131,0.02113861}, {132,0.01776238}, {133,0.01842574}, {134,0.01893069}, {135,0.01830693}, {136,0.01831683}, {137,0.01874257}, {138,0.01853465}, {139,0.01990099}, {140,0.01877228}, {141,0.02448515}, {142,0.01901980}, {143,0.01926733}, {144,0.01906931}, {145,0.01940594}, {146,0.01949505}, {147,0.01950495}, {148,0.01976238}, {149,0.02025743}, {150,0.01998020}, {151,0.02000000}, {152,0.02024752}, {153,0.02557426}, {154,0.02100000}, {155,0.02163366}, {156,0.02134653}, {157,0.02163366}, {158,0.02973267}, {159,0.02169307}, {160,0.02137624}, {161,0.02186139}, {162,0.02192079}, {163,0.02382178}, {164,0.02209901}, {165,0.02266337}, {166,0.02368317}, {167,0.02291089}, {168,0.02273267}, {169,0.02311881}, {170,0.02905941}, {171,0.02341584}, {172,0.02364356}, {173,0.02401980}, {174,0.03016832}, {175,0.02417822}, {176,0.02395050}, {177,0.02409901}, {178,0.02570297}, {179,0.03212871}, {180,0.02457426}, {181,0.02479208}, {182,0.02484158}, {183,0.02510891}, {184,0.02551485}, {185,0.03074257}, {186,0.03416832}, {187,0.02547525}, {188,0.02567327}, {189,0.02579208}, {190,0.02571287}, {191,0.02600990}, {192,0.02577228}, {193,0.02600990}, {194,0.02618812}, {195,0.02631683}, {196,0.02634653}, {197,0.02647525}, {198,0.02652475}, {199,0.02696040}, {200,0.02664356}, {201,0.02693069}, {202,0.02708911}, {203,0.02735644}, {204,0.02765347}, {205,0.02770297}, {206,0.02807921}, {207,0.02818812}, {208,0.02783168}, {209,0.04075248}, {210,0.03650495}, {211,0.03217822}, {212,0.02899010}, {213,0.02923762}, {214,0.02926733}, {215,0.02921782}, {216,0.03772277}, {217,0.03267327}, {218,0.02951485}, {219,0.02986139}, {220,0.02985149}, {221,0.03700000}, {222,0.02993069}, {223,0.03037624}, {224,0.03098020}, {225,0.03730693}, {226,0.03090099}, {227,0.03142574}, {228,0.04376238}, {229,0.03386139}, {230,0.03167327}, {231,0.03200990}, {232,0.03433663}, {233,0.03188119}, {234,0.03220792}, {235,0.03331683}, {236,0.03194059}, {237,0.03960396}, {238,0.03233663}, {239,0.03265347}, {240,0.03408911}, {241,0.03300990}, {242,0.03787129}, {243,0.03319802}, {244,0.04143564}, {245,0.03364356}, {246,0.04316832}, {247,0.03383168}, {248,0.04600000}, {249,0.03368317}, {250,0.04520792}, {251,0.03441584}, {252,0.04398020}, {253,0.03500990}, {254,0.04105941}, {255,0.03530693}, {256,0.03700990}, {257,0.03485149}, {258,0.03507921}, {259,0.04487129}, {260,0.03571287}, {261,0.03759406}, {262,0.03576238}, {263,0.03600000}, {264,0.04083168}, {265,0.03628713}, {266,0.03622772}, {267,0.04121782}, {268,0.03674257}, {269,0.03691089}, {270,0.03922772}, {271,0.05093069}, {272,0.03714851}, {273,0.03692079}, {274,0.04306931}, {275,0.04883168}, {276,0.03802970}, {277,0.03766337}, {278,0.03901980}, {279,0.04556436}, {280,0.05118812}, {281,0.03842574}, {282,0.03828713}, {283,0.03846535}, {284,0.04162376}, {285,0.04610891}, {286,0.04939604}, {287,0.04044554}, {288,0.03933663}, {289,0.03897030}, {290,0.03952475}, {291,0.03956436}, {292,0.03964356}, {293,0.04056436}, {294,0.04215842}, {295,0.04364356}, {296,0.04466337}, {297,0.04578218}, {298,0.04651485}, {299,0.04611881}, {300,0.04608911}, {301,0.04445545}, {302,0.04739604}, {303,0.04600990}, {304,0.04407921}, {305,0.04188119}, {306,0.04174257}, {307,0.04178218}, {308,0.04190099}, {309,0.04260396}, {310,0.04206931}, {311,0.05633663}, {312,0.05181188}, {313,0.04910891}, {314,0.04482178}, {315,0.04300990}, {316,0.04347525}, {317,0.04385149}, {318,0.05303960}, {319,0.04857426}, {320,0.04357426}, {321,0.04374257}, {322,0.05809901}, {323,0.05162376}, {324,0.04616832}, {325,0.04439604}, {326,0.04490099}, {327,0.05184158}, {328,0.04461386}, {329,0.04520792}, {330,0.05544554}, {331,0.04947525}, {332,0.04536634}, {333,0.06356436}, {334,0.04857426}, {335,0.04660396}, {336,0.05652475}, {337,0.04648515}, {338,0.04643564}, {339,0.05346535}, {340,0.04633663}, {341,0.05850495}, {342,0.04724752}, {343,0.04716832}, {344,0.05021782}, {345,0.04759406}, {346,0.05260396}, {347,0.04771287}, {348,0.05411881}, {349,0.04795050}, {350,0.05400990}, {351,0.04884158}, {352,0.05339604}, {353,0.04882178}, {354,0.05228713}, {355,0.04894059}, {356,0.05064356}, {357,0.06736634}, {358,0.04942574}, {359,0.06086139}, {360,0.04973267}, {361,0.05278218}, {362,0.06411881}, {363,0.05024752}, {364,0.05640594}, {365,0.06552475}, {366,0.05001980}, {367,0.05704950}, {368,0.06549505}, {369,0.05003960}, {370,0.05500990}, {371,0.06261386}, {372,0.05115842}, {373,0.05168317}, {374,0.05845545}, {375,0.06488119}, {376,0.05161386}, {377,0.05172277}, {378,0.05717822}, {379,0.06229703}, {380,0.07480198}, {381,0.05232673}, {382,0.05222772}, {383,0.05624752}, {384,0.06061386}, {385,0.06599010}, {386,0.07068317}, {387,0.05300990}, {388,0.05261386}, {389,0.05361386}, {390,0.05627723}, {391,0.05932673}, {392,0.06171287}, {393,0.06292079}, {394,0.06507921}, {395,0.06738614}, {396,0.06843564}, {397,0.06970297}, {398,0.07017822}, {399,0.07287129}, {400,0.07875248}, {401,0.07397030}, {402,0.07381188}, {403,0.07344554}, {404,0.06886139}, {405,0.07070297}, {406,0.06928713}, {407,0.06756436}, {408,0.06455446}, {409,0.06180198}, {410,0.06032673}, {411,0.05843564}, {412,0.05605941}, {413,0.05704950}, {414,0.05805941}, {415,0.06940594}, {416,0.06770297}, {417,0.06580198}, {418,0.05978218}, {419,0.05726733}, {420,0.05922772}, {421,0.07262376}, {422,0.06522772}, {423,0.06000990}, {424,0.05773267}, {425,0.07463366}, {426,0.06686139}, {427,0.06089109}, {428,0.05864356}, {429,0.07279208}, {430,0.06435644}, {431,0.05971287}, {432,0.07452475}, {433,0.06850495}, {434,0.05955446}, {435,0.08160396}, {436,0.06734653}, {437,0.06052475}, {438,0.07618812}, {439,0.06427723}, {440,0.06032673}, {441,0.07090099}, {442,0.06081188}, {443,0.07419802}, {444,0.06280198}, {445,0.07660396}, {446,0.06531683}, {447,0.07843564}, {448,0.06633663}, {449,0.06205941}, {450,0.06966337}, {451,0.06252475}, {452,0.07111881}, {453,0.06274257}, {454,0.06987129}, {455,0.08340594}, {456,0.06657426}, {457,0.07966337}, {458,0.06400990}, {459,0.07605941}, {460,0.06330693}, {461,0.07086139}, {462,0.08026733}, {463,0.06519802}, {464,0.07443564}, {465,0.06374257}, {466,0.06859406}, {467,0.08341584}, {468,0.06363366}, {469,0.06889109}, {470,0.07767327}, {471,0.08609901}, {472,0.06576238}, {473,0.07494059}, {474,0.08072277}, {475,0.06468317}, {476,0.06792079}, {477,0.07502970}, {478,0.08002970}, {479,0.08577228}, {480,0.06550495}, {481,0.07336634}, {482,0.08041584}, {483,0.08370297}, {484,0.08845545}, {485,0.06632673}, {486,0.06948515}, {487,0.07301980}, {488,0.07601980}, {489,0.07910891}, {490,0.08217822}, {491,0.08473267}, {492,0.08694059}, {493,0.06812871}, {494,0.06832673}, {495,0.06855446}, {496,0.06927723}, {497,0.07151485}, {498,0.07175248}, {499,0.07301980}, {500,0.07330693}, {505,0.07436634}, {510,0.07285149}, {515,0.07000990}, {520,0.09197030}, {525,0.08839604}, {530,0.08505941}, {535,0.07643564}, {540,0.09550495}, {545,0.08482178}, {550,0.10072277}, {555,0.08691089}, {560,0.09729703}, {565,0.08477228}, {570,0.09322772}, {575,0.09730693}, {580,0.08467327}, {585,0.09413861}, {590,0.09600990}, {595,0.09961386}, {600,0.10055446}, {605,0.09938614}, {610,0.09887129}, {615,0.09784158}, {620,0.09297030}, {625,0.09263366}, {630,0.11296040}, {635,0.10592079}, {640,0.09467327}, {645,0.11145545}, {650,0.10028713}, {655,0.11337624}, {660,0.10062376}, {665,0.12180198}, {670,0.09861386}, {675,0.10513861}, {680,0.11388119}, {685,0.11854455}, {690,0.09956436}, {695,0.10204950}, {700,0.10769307}, {705,0.10579208}, {710,0.10581188}, {715,0.10572277}, {720,0.12428713}, {725,0.12211881}, {730,0.11402970}, {735,0.11202970}, {740,0.13018812}, {745,0.11959406}, {750,0.13228713}, {755,0.12128713}, {760,0.12781188}, {765,0.12154455}, {770,0.12550495}, {775,0.13899010}, {780,0.11925743}, {785,0.12623762}, {790,0.14185149}, {795,0.14012871}, {800,0.14049505}, {805,0.13949505}, {810,0.13916832}, {815,0.13809901}, {820,0.13869307}, {825,0.13426733}, {830,0.12800000}, {835,0.14405941}, {840,0.13705941}, {845,0.13175248}, {850,0.14437624}, {855,0.13535644}, {860,0.14451485}, {865,0.12954455}, {870,0.14668317}, {875,0.15332673}, {880,0.13333663}, {885,0.14038614}, {890,0.15500990}, {895,0.15166337}, {900,0.15085149}, {905,0.14962376}, {910,0.14961386}, {915,0.15795050}, {920,0.15063366}, {925,0.14491089}, {930,0.14044554}, {935,0.15677228}, {940,0.15364356}, {945,0.14319802}, {950,0.15659406}, {955,0.14674257}, {960,0.17035644}, {965,0.14808911}, {970,0.15748515}, {975,0.16350495}, {980,0.19018812}, {985,0.15780198}, {990,0.16107921}, {995,0.16204950}, {1000,0.18019802}, {1010,0.17272277}, {1020,0.16705941}, {1030,0.16287129}, {1040,0.16275248}, {1050,0.17842574}, {1060,0.16569307}, {1070,0.17807921}, {1080,0.19266337}, {1090,0.17214851}, {1100,0.17539604}, {1110,0.18388119}, {1120,0.17994059}, {1130,0.17507921}, {1140,0.20460396}, {1150,0.19218812}, {1160,0.19902970}, {1170,0.18853465}, {1180,0.20532673}, {1190,0.20563366}, {1200,0.19829703}, {1210,0.19316832}, {1220,0.21487129}, {1230,0.21012871}, {1240,0.21203960}, {1250,0.19801980}, {1260,0.22328713}, {1270,0.20412871}, {1280,0.20763366}, {1290,0.23097030}, {1300,0.22622772}, {1310,0.22306931}, {1320,0.23244554}, {1330,0.22404950}, {1340,0.21706931}, {1350,0.21616832}, {1360,0.22611881}, {1370,0.22413861}, {1380,0.22755446}, {1390,0.23186139}, {1400,0.24425743}, {1410,0.23684158}, {1420,0.26376238}, {1430,0.24205941}, {1440,0.23229703}, {1450,0.23518812}, {1460,0.24069307}, {1470,0.26297030}, {1480,0.23952475}, {1490,0.25014851}, {1500,0.25562376}, {1510,0.25275248}, {1520,0.26211881}, {1530,0.25183168}, {1540,0.25296040}, {1550,0.26433663}, {1560,0.27815842}, {1570,0.27270297}, {1580,0.24995050}, {1590,0.27005941}, {1600,0.26721782}, {1610,0.27915842}, {1620,0.27194059}, {1630,0.27600000}, {1640,0.26620792}, {1650,0.26310891}, {1660,0.27686139}, {1670,0.26762376}, {1680,0.27476238}, {1690,0.28745545}, {1700,0.28896040}, {1710,0.29522772}, {1720,0.29217822}, {1730,0.29664356}, {1740,0.28612871}, {1750,0.28722772}, {1760,0.31728713}, {1770,0.29153465}, {1780,0.32633663}, {1790,0.30435644}, {1800,0.32050495}, {1810,0.28854455}, {1820,0.30005941}, {1830,0.31108911}, {1840,0.31386139}, {1850,0.29616832}, {1860,0.32331683}, {1870,0.32306931}, {1880,0.31873267}, {1890,0.31309901}, {1900,0.30902970}, {1910,0.31983168}, {1920,0.33491089}, {1930,0.31409901}, {1940,0.34374257}, {1950,0.32814851}, {1960,0.32494059}, {1970,0.36139604}, {1980,0.32048515}, {1990,0.33597030}, {2000,0.32953465}, {2050,0.34181188}, {2100,0.37390099}, {2150,0.36228713}, {2200,0.36490099}, {2250,0.38212871}, {2300,0.38239604}, {2350,0.39152475}, {2400,0.41129703}, {2450,0.43338614}, {2500,0.41455446}, {2550,0.43949505}, {2600,0.43069307}, {2650,0.44863366}, {2700,0.46056436}, {2750,0.48130693}, {2800,0.51967327}, {2850,1.46536634}, {2900,0.47737624}, {2950,0.48605941}, {3000,0.51094059}, {3050,0.52931683}, {3100,0.52920792}, {3150,0.54089109}, {3200,0.53250495}, {3250,0.54913861}, {3300,0.56542574}, {3350,0.57911881}, {3400,0.56852475}, {3450,0.58523762}, {3500,0.59749505}, {3550,0.61325743}, {3600,0.62921782}, {3650,0.63624752}, {3700,0.65982178}, {3750,0.65025743}, {3800,0.66212871}, {3850,0.67038614}, {3900,0.66240594}, {3950,0.67950495}, {4000,0.71160396}, {4050,0.70032673}, {4100,0.69635644}, {4150,0.70778218}, {4200,0.74528713}, {4250,0.74377228}, {4300,0.73419802}, {4350,0.76475248}, {4400,0.77382178}, {4450,0.77299010}, {4500,0.77662376}, {4550,0.78881188}, {4600,0.79709901}, {4650,0.82536634}, {4700,0.80261386}, {4750,0.82499010}, {4800,0.82937624}, {4850,0.85392079}, {4900,0.83876238}, {4950,0.86484158}, {5000,0.86794059}, {5050,0.89253465}, {5100,0.90793069}, {5150,0.92280198}, {5200,0.89721782}, {5250,0.92984158}, {5300,0.91506931}, {5350,0.93157426}, {5400,0.95536634}, {5450,0.97126733}, {5500,0.96909901}, {5550,0.95656436}, {5600,0.97589109}, {5650,0.99036634}, {5700,1.02474257}, {5750,0.99580198}, {5800,1.00854455}, {5850,1.06357426}, {5900,1.03400990}, {5950,1.05097030}, {6000,1.05521782}, {6050,1.1120571}, {6100,1.1259143}, {6150,1.1180286}, {6200,1.1324571}, {6250,1.1504000}, {6300,1.1561714}, {6350,1.1589143}, {6400,1.1574286}, {6450,1.1812000}, {6500,1.2132286}, {6550,1.2250571}, {6600,1.2200286}, {6650,1.2375143}, {6700,1.2716571}, {6750,1.2726286}, {6800,1.2645143}, {6850,1.2892571}, {6900,1.2957429}, {6950,1.3139714}, {7000,1.3026286}, {7050,1.3068286}, {7100,1.3262857}, {7150,1.3334286}, {7200,1.3147429}, {7250,1.3330571}, {7300,1.3208857}, {7350,1.3254857}, {7400,1.3378571}, {7450,1.3601143}, {7500,1.3867143}, {7550,1.4166000}, {7600,1.4157143}, {7650,1.4218000}, {7700,1.4146286}, {7750,1.4024286}, {7800,1.4234571}, {7850,1.4875429}, {7900,1.4704000}, {7950,1.4812857}, {8000,1.4681429}, {8050,1.4828857}, {8100,1.4706571}, {8150,1.5321714}, {8200,1.5062000}, {8250,1.5259143}, {8300,1.5027143}, {8350,1.5582571}, {8400,1.5532857}, {8450,1.5518286}, {8500,1.5444000}, {8550,1.5940286}, {8600,1.5950857}, {8650,1.5971429}, {8700,1.6026857}, {8750,1.6426857}, {8800,1.6310000}, {8850,1.6005714}, {8900,1.6813714}, {8950,1.6799143}, {9000,1.6246571}, {9050,1.6770000}, {9100,1.6947429}, {9150,1.6838857}, {9200,1.7376286}, {9250,1.6928000}, {9300,1.7496571}, {9350,1.7509429}, {9400,1.7312000}, {9450,1.7689714}, {9500,1.7524857}, {9550,1.7867714}, {9600,1.7928571}, {9650,1.7862571}, {9700,1.8076000}, {9750,1.7840571}, {9800,1.8144571}, {9850,1.8094571}, {9900,1.8486571}, {9950,1.8406000}, {10000,1.8574286}, {10100,1.8940571}, {10200,1.9067429}, {10300,1.8936286}, {10400,1.9366857}, {10500,1.8765429}, {10600,1.9741143}, {10700,1.9396857}, {10800,2.0242571}, {10900,1.9803714}, {11000,2.0590286}, {11100,2.0162857}, {11200,2.0637714}, {11300,2.0777714}, {11400,2.0793143}, {11500,2.1461429}, {11600,2.1188571}, {11700,2.1898571}, {11800,2.1576857}, {11900,2.1877143}, {12000,2.2452000}, {12100,2.2292286}, {12200,2.2610571}, {12300,2.2702286}, {12400,2.2790000}, {12500,2.2839714}, {12600,2.3934000}, {12700,2.3542286}, {12800,2.3317714}, {12900,2.3519143}, {13000,2.3946286}, {13100,2.4349714}, {13200,2.4344857}, {13300,2.4553429}, {13400,2.4730571}, {13500,2.5051714}, {13600,2.5109714}, {13700,2.5131714}, {13800,2.5490286}, {13900,2.5590571}, {14000,2.5849143}, {14100,2.6128857}, {14200,2.6334857}, {14300,2.6878857}, {14400,2.9020000}, {14500,2.8545429}, {14600,2.6827429}, {14700,2.7135714}, {14800,2.7094000}, {14900,2.7368571}, {15000,2.7636286}, {15100,2.8094000}, {15200,2.7731429}, {15300,2.7970286}, {15400,2.9053143}, {15500,2.9985143}, {15600,3.0353429}, {15700,2.9234571}, {15800,3.1708571}, {15900,2.9300857}, {16000,3.2438857}, {16100,2.9576286}, {16200,2.9544571}, {16300,3.0809429}, {16400,3.0597143}, {16500,3.0407714}, {16600,3.0454286}, {16700,3.0410857}, {16800,3.0389714}, {16900,3.1511714}, {17000,3.2100000}, {17100,3.2228286}, {17200,3.1298571}, {17300,3.1793143}, {17400,3.1789714}, {17500,3.2161143}, {17600,3.2700000}, {17700,3.3102000}, {17800,3.2665714}, {17900,3.3730857}, {18000,3.3800000}, {18100,3.5412286}, {18200,3.3251143}, {18300,3.4726286}, {18400,3.5258571}, {18500,3.4586571}, {18600,3.6610571}, {18700,3.4855143}, {18800,3.5246000}, {18900,3.5412286}, {19000,3.4816286}, {19100,3.4757429}, {19200,3.4823429}, {19300,3.5695143}, {19400,3.5706286}, {19500,3.7382571}, {19600,3.6574571}, {19700,3.9535429}, {19800,3.9521429}, {19900,3.6765714}, {20000,3.8529714}};
data["big_flat"]["LtacTCExplicitCtx"]["reif"]["system"] = {{1,0.00005941}, {2,0.00000000}, {3,0.00007921}, {4,0.00005941}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00003960}, {10,0.00002970}, {11,0.00000000}, {12,0.00006931}, {13,0.00006931}, {14,0.00000000}, {15,0.00000000}, {16,0.00007921}, {17,0.00003960}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00006931}, {25,0.00007921}, {26,0.00002970}, {27,0.00000000}, {28,0.00003960}, {29,0.00000000}, {30,0.00002970}, {31,0.00000000}, {32,0.00000000}, {33,0.00003960}, {34,0.00006931}, {35,0.00000000}, {36,0.00011881}, {37,0.00003960}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003960}, {42,0.00003960}, {43,0.00003960}, {44,0.00003960}, {45,0.00007921}, {46,0.00003960}, {47,0.00000000}, {48,0.00007921}, {49,0.00000000}, {50,0.00000000}, {51,0.00003960}, {52,0.00000000}, {53,0.00002970}, {54,0.00000000}, {55,0.00003960}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00002970}, {60,0.00000000}, {61,0.00011881}, {62,0.00003960}, {63,0.00007921}, {64,0.00006931}, {65,0.00007921}, {66,0.00000000}, {67,0.00003960}, {68,0.00002970}, {69,0.00003960}, {70,0.00003960}, {71,0.00000000}, {72,0.00007921}, {73,0.00006931}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00002970}, {79,0.00002970}, {80,0.00000000}, {81,0.00003960}, {82,0.00003960}, {83,0.00000000}, {84,0.00000000}, {85,0.00003960}, {86,0.00000000}, {87,0.00003960}, {88,0.00002970}, {89,0.00000000}, {90,0.00005941}, {91,0.00003960}, {92,0.00007921}, {93,0.00007921}, {94,0.00007921}, {95,0.00007921}, {96,0.00014851}, {97,0.00003960}, {98,0.00007921}, {99,0.00000000}, {100,0.00000000}, {101,0.00003960}, {102,0.00000000}, {103,0.00000000}, {104,0.00006931}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00003960}, {109,0.00000000}, {110,0.00003960}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00003960}, {117,0.00007921}, {118,0.00003960}, {119,0.00002970}, {120,0.00000000}, {121,0.00007921}, {122,0.00000000}, {123,0.00000000}, {124,0.00003960}, {125,0.00000000}, {126,0.00003960}, {127,0.00003960}, {128,0.00003960}, {129,0.00000000}, {130,0.00000000}, {131,0.00015842}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00003960}, {136,0.00007921}, {137,0.00000000}, {138,0.00000000}, {139,0.00014851}, {140,0.00000000}, {141,0.00003960}, {142,0.00007921}, {143,0.00003960}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00007921}, {150,0.00000000}, {151,0.00003960}, {152,0.00000000}, {153,0.00010891}, {154,0.00003960}, {155,0.00007921}, {156,0.00011881}, {157,0.00000000}, {158,0.00003960}, {159,0.00000000}, {160,0.00000000}, {161,0.00006931}, {162,0.00000000}, {163,0.00006931}, {164,0.00000000}, {165,0.00003960}, {166,0.00000000}, {167,0.00003960}, {168,0.00003960}, {169,0.00007921}, {170,0.00022772}, {171,0.00000000}, {172,0.00003960}, {173,0.00003960}, {174,0.00019802}, {175,0.00003960}, {176,0.00000000}, {177,0.00003960}, {178,0.00017822}, {179,0.00015842}, {180,0.00000000}, {181,0.00000000}, {182,0.00003960}, {183,0.00003960}, {184,0.00022772}, {185,0.00015842}, {186,0.00011881}, {187,0.00007921}, {188,0.00003960}, {189,0.00000000}, {190,0.00011881}, {191,0.00000000}, {192,0.00000000}, {193,0.00002970}, {194,0.00003960}, {195,0.00000000}, {196,0.00000000}, {197,0.00003960}, {198,0.00000000}, {199,0.00006931}, {200,0.00003960}, {201,0.00002970}, {202,0.00003960}, {203,0.00000000}, {204,0.00003960}, {205,0.00003960}, {206,0.00000000}, {207,0.00009901}, {208,0.00000000}, {209,0.00014851}, {210,0.00000000}, {211,0.00003960}, {212,0.00000000}, {213,0.00003960}, {214,0.00000000}, {215,0.00000000}, {216,0.00003960}, {217,0.00007921}, {218,0.00000000}, {219,0.00003960}, {220,0.00000000}, {221,0.00007921}, {222,0.00000000}, {223,0.00007921}, {224,0.00000000}, {225,0.00027723}, {226,0.00000000}, {227,0.00003960}, {228,0.00033663}, {229,0.00003960}, {230,0.00000000}, {231,0.00007921}, {232,0.00003960}, {233,0.00003960}, {234,0.00000000}, {235,0.00007921}, {236,0.00000000}, {237,0.00011881}, {238,0.00000000}, {239,0.00000000}, {240,0.00015842}, {241,0.00003960}, {242,0.00010891}, {243,0.00003960}, {244,0.00006931}, {245,0.00000000}, {246,0.00007921}, {247,0.00003960}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00003960}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00003960}, {257,0.00011881}, {258,0.00000000}, {259,0.00003960}, {260,0.00000000}, {261,0.00015842}, {262,0.00000000}, {263,0.00000000}, {264,0.00003960}, {265,0.00003960}, {266,0.00003960}, {267,0.00000000}, {268,0.00003960}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00003960}, {273,0.00000000}, {274,0.00000000}, {275,0.00007921}, {276,0.00003960}, {277,0.00003960}, {278,0.00000000}, {279,0.00003960}, {280,0.00006931}, {281,0.00007921}, {282,0.00000000}, {283,0.00000000}, {284,0.00003960}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00003960}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00003960}, {295,0.00003960}, {296,0.00002970}, {297,0.00000000}, {298,0.00000000}, {299,0.00007921}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00003960}, {308,0.00003960}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00007921}, {316,0.00000000}, {317,0.00000000}, {318,0.00003960}, {319,0.00010891}, {320,0.00000000}, {321,0.00003960}, {322,0.00000000}, {323,0.00000000}, {324,0.00010891}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00007921}, {333,0.00000000}, {334,0.00000000}, {335,0.00003960}, {336,0.00003960}, {337,0.00000000}, {338,0.00000000}, {339,0.00003960}, {340,0.00003960}, {341,0.00011881}, {342,0.00000000}, {343,0.00000000}, {344,0.00007921}, {345,0.00003960}, {346,0.00011881}, {347,0.00002970}, {348,0.00022772}, {349,0.00000000}, {350,0.00034653}, {351,0.00002970}, {352,0.00011881}, {353,0.00003960}, {354,0.00015842}, {355,0.00003960}, {356,0.00000000}, {357,0.00000000}, {358,0.00003960}, {359,0.00027723}, {360,0.00000000}, {361,0.00003960}, {362,0.00007921}, {363,0.00002970}, {364,0.00003960}, {365,0.00010891}, {366,0.00000000}, {367,0.00003960}, {368,0.00019802}, {369,0.00007921}, {370,0.00010891}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00003960}, {376,0.00007921}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00003960}, {382,0.00003960}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00003960}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00003960}, {391,0.00000000}, {392,0.00000000}, {393,0.00003960}, {394,0.00003960}, {395,0.00000000}, {396,0.00000000}, {397,0.00007921}, {398,0.00000000}, {399,0.00000000}, {400,0.00002970}, {401,0.00006931}, {402,0.00003960}, {403,0.00003960}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00003960}, {408,0.00000000}, {409,0.00003960}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00007921}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00007921}, {421,0.00000000}, {422,0.00003960}, {423,0.00000000}, {424,0.00011881}, {425,0.00000000}, {426,0.00003960}, {427,0.00003960}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00007921}, {435,0.00000000}, {436,0.00000000}, {437,0.00003960}, {438,0.00003960}, {439,0.00003960}, {440,0.00000000}, {441,0.00003960}, {442,0.00000000}, {443,0.00003960}, {444,0.00003960}, {445,0.00003960}, {446,0.00000000}, {447,0.00003960}, {448,0.00003960}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00003960}, {453,0.00003960}, {454,0.00003960}, {455,0.00003960}, {456,0.00000000}, {457,0.00006931}, {458,0.00007921}, {459,0.00003960}, {460,0.00011881}, {461,0.00003960}, {462,0.00003960}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003960}, {469,0.00003960}, {470,0.00003960}, {471,0.00000000}, {472,0.00003960}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00007921}, {479,0.00000000}, {480,0.00007921}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00003960}, {485,0.00000000}, {486,0.00003960}, {487,0.00003960}, {488,0.00007921}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00007921}, {495,0.00003960}, {496,0.00007921}, {497,0.00003960}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00003960}, {520,0.00000000}, {525,0.00003960}, {530,0.00000000}, {535,0.00003960}, {540,0.00000000}, {545,0.00000000}, {550,0.00003960}, {555,0.00000000}, {560,0.00000000}, {565,0.00006931}, {570,0.00003960}, {575,0.00007921}, {580,0.00003960}, {585,0.00000000}, {590,0.00003960}, {595,0.00003960}, {600,0.00002970}, {605,0.00000000}, {610,0.00003960}, {615,0.00000000}, {620,0.00003960}, {625,0.00003960}, {630,0.00000000}, {635,0.00003960}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00003960}, {670,0.00007921}, {675,0.00003960}, {680,0.00007921}, {685,0.00000000}, {690,0.00003960}, {695,0.00000000}, {700,0.00003960}, {705,0.00006931}, {710,0.00003960}, {715,0.00000000}, {720,0.00011881}, {725,0.00000000}, {730,0.00003960}, {735,0.00000000}, {740,0.00003960}, {745,0.00000000}, {750,0.00003960}, {755,0.00000000}, {760,0.00000000}, {765,0.00003960}, {770,0.00003960}, {775,0.00000000}, {780,0.00003960}, {785,0.00007921}, {790,0.00000000}, {795,0.00003960}, {800,0.00003960}, {805,0.00000000}, {810,0.00000000}, {815,0.00003960}, {820,0.00003960}, {825,0.00003960}, {830,0.00000000}, {835,0.00003960}, {840,0.00003960}, {845,0.00015842}, {850,0.00000000}, {855,0.00007921}, {860,0.00007921}, {865,0.00007921}, {870,0.00000000}, {875,0.00000000}, {880,0.00003960}, {885,0.00007921}, {890,0.00000000}, {895,0.00000000}, {900,0.00003960}, {905,0.00003960}, {910,0.00000000}, {915,0.00003960}, {920,0.00000000}, {925,0.00003960}, {930,0.00000000}, {935,0.00007921}, {940,0.00003960}, {945,0.00003960}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00007921}, {975,0.00000000}, {980,0.00002970}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00010891}, {1020,0.00000000}, {1030,0.00003960}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00003960}, {1090,0.00007921}, {1100,0.00003960}, {1110,0.00003960}, {1120,0.00003960}, {1130,0.00000000}, {1140,0.00003960}, {1150,0.00000000}, {1160,0.00007921}, {1170,0.00007921}, {1180,0.00003960}, {1190,0.00003960}, {1200,0.00003960}, {1210,0.00007921}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00003960}, {1280,0.00007921}, {1290,0.00007921}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00011881}, {1330,0.00003960}, {1340,0.00000000}, {1350,0.00007921}, {1360,0.00003960}, {1370,0.00003960}, {1380,0.00000000}, {1390,0.00003960}, {1400,0.00019802}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00003960}, {1440,0.00000000}, {1450,0.00011881}, {1460,0.00003960}, {1470,0.00011881}, {1480,0.00000000}, {1490,0.00011881}, {1500,0.00007921}, {1510,0.00000000}, {1520,0.00007921}, {1530,0.00003960}, {1540,0.00000000}, {1550,0.00007921}, {1560,0.00003960}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00007921}, {1600,0.00000000}, {1610,0.00007921}, {1620,0.00003960}, {1630,0.00007921}, {1640,0.00003960}, {1650,0.00003960}, {1660,0.00015842}, {1670,0.00007921}, {1680,0.00003960}, {1690,0.00003960}, {1700,0.00019802}, {1710,0.00007921}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00003960}, {1750,0.00011881}, {1760,0.00000000}, {1770,0.00003960}, {1780,0.00006931}, {1790,0.00000000}, {1800,0.00003960}, {1810,0.00007921}, {1820,0.00000000}, {1830,0.00011881}, {1840,0.00003960}, {1850,0.00015842}, {1860,0.00003960}, {1870,0.00007921}, {1880,0.00010891}, {1890,0.00000000}, {1900,0.00019802}, {1910,0.00003960}, {1920,0.00003960}, {1930,0.00000000}, {1940,0.00007921}, {1950,0.00007921}, {1960,0.00003960}, {1970,0.00000000}, {1980,0.00015842}, {1990,0.00003960}, {2000,0.00003960}, {2050,0.00010891}, {2100,0.00007921}, {2150,0.00003960}, {2200,0.00003960}, {2250,0.00007921}, {2300,0.00007921}, {2350,0.00011881}, {2400,0.00011881}, {2450,0.00002970}, {2500,0.00015842}, {2550,0.00015842}, {2600,0.00000000}, {2650,0.00003960}, {2700,0.00007921}, {2750,0.00000000}, {2800,0.00015842}, {2850,0.00258416}, {2900,0.00015842}, {2950,0.00000000}, {3000,0.00003960}, {3050,0.00007921}, {3100,0.00280198}, {3150,0.00003960}, {3200,0.00007921}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00007921}, {3400,0.00011881}, {3450,0.00000000}, {3500,0.00003960}, {3550,0.00010891}, {3600,0.00007921}, {3650,0.00007921}, {3700,0.00027723}, {3750,0.00007921}, {3800,0.00006931}, {3850,0.00019802}, {3900,0.00003960}, {3950,0.00003960}, {4000,0.00010891}, {4050,0.00031683}, {4100,0.00007921}, {4150,0.00023762}, {4200,0.00006931}, {4250,0.00019802}, {4300,0.00011881}, {4350,0.00011881}, {4400,0.00003960}, {4450,0.00011881}, {4500,0.00000000}, {4550,0.00007921}, {4600,0.00011881}, {4650,0.00007921}, {4700,0.00015842}, {4750,0.00003960}, {4800,0.00019802}, {4850,0.00023762}, {4900,0.00003960}, {4950,0.00015842}, {5000,0.00023762}, {5050,0.00023762}, {5100,0.00023762}, {5150,0.00003960}, {5200,0.00007921}, {5250,0.00011881}, {5300,0.00042574}, {5350,0.00023762}, {5400,0.00019802}, {5450,0.00015842}, {5500,0.00007921}, {5550,0.00007921}, {5600,0.00015842}, {5650,0.00007921}, {5700,0.00015842}, {5750,0.00015842}, {5800,0.00010891}, {5850,0.00007921}, {5900,0.00027723}, {5950,0.00007921}, {6000,0.00007921}, {6050,0.0063714}, {6100,0.0076571}, {6150,0.0002286}, {6200,0.0002286}, {6250,0.0052286}, {6300,0.0002286}, {6350,0.0000000}, {6400,0.0002286}, {6450,0.0000000}, {6500,0.0002286}, {6550,0.0000000}, {6600,0.0001143}, {6650,0.0002286}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0001143}, {6850,0.0001143}, {6900,0.0001143}, {6950,0.0002286}, {7000,0.0001143}, {7050,0.0001143}, {7100,0.0001143}, {7150,0.0000000}, {7200,0.0003143}, {7250,0.0002286}, {7300,0.0001143}, {7350,0.0001143}, {7400,0.0002286}, {7450,0.0001143}, {7500,0.0000000}, {7550,0.0002000}, {7600,0.0003429}, {7650,0.0000000}, {7700,0.0002286}, {7750,0.0001143}, {7800,0.0002286}, {7850,0.0002286}, {7900,0.0002286}, {7950,0.0001143}, {8000,0.0001143}, {8050,0.0001143}, {8100,0.0002286}, {8150,0.0000000}, {8200,0.0005714}, {8250,0.0000000}, {8300,0.0005714}, {8350,0.0002286}, {8400,0.0002286}, {8450,0.0002286}, {8500,0.0000000}, {8550,0.0002286}, {8600,0.0001143}, {8650,0.0000000}, {8700,0.0001143}, {8750,0.0000000}, {8800,0.0001143}, {8850,0.0005429}, {8900,0.0002286}, {8950,0.0001143}, {9000,0.0000000}, {9050,0.0001143}, {9100,0.0001143}, {9150,0.0004571}, {9200,0.0002286}, {9250,0.0003429}, {9300,0.0022286}, {9350,0.0002286}, {9400,0.0002286}, {9450,0.0002286}, {9500,0.0001143}, {9550,0.0001143}, {9600,0.0002000}, {9650,0.0000000}, {9700,0.0002000}, {9750,0.0003429}, {9800,0.0001143}, {9850,0.0001143}, {9900,0.0000000}, {9950,0.0001143}, {10000,0.0002000}, {10100,0.0000000}, {10200,0.0001143}, {10300,0.0002000}, {10400,0.0002286}, {10500,0.0001143}, {10600,0.0001143}, {10700,0.0003429}, {10800,0.0004571}, {10900,0.0001143}, {11000,0.0002286}, {11100,0.0001143}, {11200,0.0003429}, {11300,0.0002286}, {11400,0.0001143}, {11500,0.0002000}, {11600,0.0001143}, {11700,0.0003429}, {11800,0.0003429}, {11900,0.0003143}, {12000,0.0000000}, {12100,0.0001143}, {12200,0.0005429}, {12300,0.0000000}, {12400,0.0001143}, {12500,0.0004571}, {12600,0.0004286}, {12700,0.0001143}, {12800,0.0002286}, {12900,0.0004571}, {13000,0.0001143}, {13100,0.0008000}, {13200,0.0001143}, {13300,0.0003429}, {13400,0.0002286}, {13500,0.0000857}, {13600,0.0000000}, {13700,0.0001143}, {13800,0.0000000}, {13900,0.0003429}, {14000,0.0002000}, {14100,0.0004571}, {14200,0.0002000}, {14300,0.0000000}, {14400,0.0003429}, {14500,0.0003429}, {14600,0.0005429}, {14700,0.0006857}, {14800,0.0010286}, {14900,0.0001143}, {15000,0.0003429}, {15100,0.0004571}, {15200,0.0001143}, {15300,0.0004571}, {15400,0.0004286}, {15500,0.0009143}, {15600,0.0013143}, {15700,0.0017143}, {15800,0.0006857}, {15900,0.0001143}, {16000,0.0007429}, {16100,0.0018286}, {16200,0.0010857}, {16300,0.0014571}, {16400,0.0024000}, {16500,0.0018000}, {16600,0.0003429}, {16700,0.0017143}, {16800,0.0006857}, {16900,0.0001143}, {17000,0.0002286}, {17100,0.0006857}, {17200,0.0005714}, {17300,0.0009143}, {17400,0.0009143}, {17500,0.0004571}, {17600,0.0003429}, {17700,0.0006571}, {17800,0.0003429}, {17900,0.0001143}, {18000,0.0000000}, {18100,0.0011429}, {18200,0.0004571}, {18300,0.0005714}, {18400,0.0001143}, {18500,0.0002286}, {18600,0.0023714}, {18700,0.0003429}, {18800,0.0008000}, {18900,0.0003429}, {19000,0.0000000}, {19100,0.0002286}, {19200,0.0012571}, {19300,0.0018286}, {19400,0.0001143}, {19500,0.0016857}, {19600,0.0012571}, {19700,0.0022571}, {19800,0.0016857}, {19900,0.0008571}, {20000,0.0017143}};
data["big_flat"]["LtacTCGallinaCtx"]["Aggregate"]["real"] = {{1,0.00086139}, {2,0.00100000}, {3,0.00100000}, {4,0.00100000}, {5,0.00100000}, {6,0.00100000}, {7,0.00104950}, {8,0.00141584}, {9,0.00200000}, {10,0.00200000}, {11,0.00200000}, {12,0.00200000}, {13,0.00200000}, {14,0.00205941}, {15,0.00225743}, {16,0.00284158}, {17,0.00300000}, {18,0.00300000}, {19,0.00354455}, {20,0.00301980}, {21,0.00307921}, {22,0.00330693}, {23,0.00356436}, {24,0.00400000}, {25,0.00400000}, {26,0.00400000}, {27,0.00400000}, {28,0.00412871}, {29,0.00419802}, {30,0.00439604}, {31,0.00496040}, {32,0.00589109}, {33,0.00500000}, {34,0.00500000}, {35,0.00516832}, {36,0.00524752}, {37,0.00731683}, {38,0.00559406}, {39,0.00600000}, {40,0.00600000}, {41,0.00600990}, {42,0.00607921}, {43,0.00619802}, {44,0.00615842}, {45,0.00637624}, {46,0.00681188}, {47,0.00700990}, {48,0.00700990}, {49,0.00708911}, {50,0.00717822}, {51,0.00726733}, {52,0.00729703}, {53,0.00762376}, {54,0.00795050}, {55,0.00801980}, {56,0.00807921}, {57,0.00811881}, {58,0.00823762}, {59,0.00831683}, {60,0.00838614}, {61,0.00878218}, {62,0.00900000}, {63,0.00909901}, {64,0.00919802}, {65,0.00929703}, {66,0.00930693}, {67,0.01213861}, {68,0.00949505}, {69,0.00985149}, {70,0.01004950}, {71,0.01025743}, {72,0.01021782}, {73,0.01030693}, {74,0.01017822}, {75,0.01236634}, {76,0.01063366}, {77,0.01102970}, {78,0.01113861}, {79,0.01123762}, {80,0.01107921}, {81,0.01124752}, {82,0.01117822}, {83,0.01154455}, {84,0.01164356}, {85,0.01214851}, {86,0.01211881}, {87,0.01227723}, {88,0.01213861}, {89,0.01317822}, {90,0.01524752}, {91,0.01342574}, {92,0.01287129}, {93,0.01320792}, {94,0.01323762}, {95,0.01331683}, {96,0.01327723}, {97,0.01346535}, {98,0.01344554}, {99,0.01387129}, {100,0.01394059}, {101,0.01523762}, {102,0.01753465}, {103,0.01588119}, {104,0.01418812}, {105,0.01445545}, {106,0.01461386}, {107,0.01501980}, {108,0.01504950}, {109,0.01528713}, {110,0.01524752}, {111,0.01539604}, {112,0.01699010}, {113,0.01540594}, {114,0.01568317}, {115,0.01611881}, {116,0.01613861}, {117,0.02072277}, {118,0.01624752}, {119,0.01649505}, {120,0.01655446}, {121,0.01665347}, {122,0.01666337}, {123,0.01711881}, {124,0.01725743}, {125,0.01838614}, {126,0.01730693}, {127,0.01735644}, {128,0.01758416}, {129,0.01761386}, {130,0.01784158}, {131,0.01811881}, {132,0.01808911}, {133,0.01847525}, {134,0.01843564}, {135,0.01850495}, {136,0.01870297}, {137,0.02146535}, {138,0.01886139}, {139,0.01929703}, {140,0.01921782}, {141,0.01937624}, {142,0.01943564}, {143,0.01967327}, {144,0.02051485}, {145,0.02001980}, {146,0.02225743}, {147,0.02023762}, {148,0.02258416}, {149,0.02037624}, {150,0.02189109}, {151,0.02094059}, {152,0.02065347}, {153,0.02110891}, {154,0.02134653}, {155,0.02137624}, {156,0.02144554}, {157,0.02420792}, {158,0.02172277}, {159,0.02207921}, {160,0.02813861}, {161,0.02205941}, {162,0.02216832}, {163,0.02236634}, {164,0.02249505}, {165,0.02263366}, {166,0.02278218}, {167,0.02298020}, {168,0.02299010}, {169,0.02840594}, {170,0.02342574}, {171,0.02362376}, {172,0.02406931}, {173,0.03098020}, {174,0.02387129}, {175,0.02422772}, {176,0.02390099}, {177,0.02872277}, {178,0.02441584}, {179,0.02453465}, {180,0.02446535}, {181,0.02469307}, {182,0.02636634}, {183,0.03064356}, {184,0.02509901}, {185,0.02542574}, {186,0.02551485}, {187,0.02561386}, {188,0.02541584}, {189,0.02598020}, {190,0.02595050}, {191,0.02704950}, {192,0.02850495}, {193,0.03027723}, {194,0.03167327}, {195,0.03274257}, {196,0.03351485}, {197,0.03418812}, {198,0.03419802}, {199,0.03424752}, {200,0.03392079}, {201,0.03306931}, {202,0.03193069}, {203,0.03134653}, {204,0.02975248}, {205,0.02858416}, {206,0.02827723}, {207,0.02828713}, {208,0.02831683}, {209,0.02847525}, {210,0.02858416}, {211,0.02881188}, {212,0.04016832}, {213,0.03371287}, {214,0.02903960}, {215,0.02942574}, {216,0.02943564}, {217,0.02957426}, {218,0.03628713}, {219,0.03100990}, {220,0.02971287}, {221,0.03023762}, {222,0.03183168}, {223,0.03336634}, {224,0.03022772}, {225,0.03056436}, {226,0.03990099}, {227,0.03205941}, {228,0.03096040}, {229,0.03116832}, {230,0.03449505}, {231,0.03164356}, {232,0.03153465}, {233,0.03488119}, {234,0.03177228}, {235,0.03218812}, {236,0.03323762}, {237,0.03258416}, {238,0.03926733}, {239,0.03254455}, {240,0.03259406}, {241,0.03340594}, {242,0.03296040}, {243,0.03692079}, {244,0.03332673}, {245,0.03927723}, {246,0.03353465}, {247,0.04077228}, {248,0.03360396}, {249,0.04218812}, {250,0.03416832}, {251,0.04140594}, {252,0.03458416}, {253,0.03972277}, {254,0.03476238}, {255,0.03606931}, {256,0.03478218}, {257,0.03482178}, {258,0.04384158}, {259,0.03518812}, {260,0.03814851}, {261,0.03555446}, {262,0.03554455}, {263,0.04247525}, {264,0.03588119}, {265,0.03609901}, {266,0.04324752}, {267,0.03664356}, {268,0.03652475}, {269,0.04226733}, {270,0.03695050}, {271,0.03716832}, {272,0.03873267}, {273,0.04836634}, {274,0.03762376}, {275,0.03748515}, {276,0.03879208}, {277,0.04535644}, {278,0.03802970}, {279,0.03829703}, {280,0.03800000}, {281,0.04047525}, {282,0.04512871}, {283,0.05034653}, {284,0.03914851}, {285,0.03894059}, {286,0.03914851}, {287,0.03921782}, {288,0.04082178}, {289,0.04358416}, {290,0.04656436}, {291,0.04902970}, {292,0.04994059}, {293,0.04000990}, {294,0.04025743}, {295,0.04037624}, {296,0.04062376}, {297,0.04059406}, {298,0.04087129}, {299,0.04077228}, {300,0.04081188}, {301,0.04104950}, {302,0.04157426}, {303,0.04146535}, {304,0.04161386}, {305,0.04187129}, {306,0.05766337}, {307,0.05166337}, {308,0.04951485}, {309,0.04729703}, {310,0.04468317}, {311,0.04247525}, {312,0.04271287}, {313,0.04288119}, {314,0.04304950}, {315,0.05395050}, {316,0.04933663}, {317,0.04511881}, {318,0.04349505}, {319,0.04407921}, {320,0.05514851}, {321,0.04962376}, {322,0.04501980}, {323,0.04383168}, {324,0.04418812}, {325,0.05198020}, {326,0.04652475}, {327,0.04490099}, {328,0.04449505}, {329,0.05036634}, {330,0.04487129}, {331,0.04540594}, {332,0.05618812}, {333,0.04545545}, {334,0.04584158}, {335,0.05331683}, {336,0.04532673}, {337,0.04642574}, {338,0.05071287}, {339,0.04594059}, {340,0.05535644}, {341,0.04703960}, {342,0.04637624}, {343,0.04993069}, {344,0.04677228}, {345,0.05283168}, {346,0.04757426}, {347,0.05476238}, {348,0.04744554}, {349,0.05532673}, {350,0.04776238}, {351,0.05531683}, {352,0.04775248}, {353,0.05403960}, {354,0.04810891}, {355,0.05253465}, {356,0.04842574}, {357,0.05131683}, {358,0.06631683}, {359,0.04923762}, {360,0.05664356}, {361,0.04951485}, {362,0.05147525}, {363,0.06192079}, {364,0.04942574}, {365,0.05412871}, {366,0.06276238}, {367,0.05015842}, {368,0.05346535}, {369,0.06133663}, {370,0.05029703}, {371,0.05201980}, {372,0.05831683}, {373,0.05108911}, {374,0.05100990}, {375,0.05401980}, {376,0.05949505}, {377,0.05305941}, {378,0.05154455}, {379,0.05285149}, {380,0.05985149}, {381,0.06672277}, {382,0.05412871}, {383,0.05213861}, {384,0.05170297}, {385,0.05381188}, {386,0.05843564}, {387,0.06103960}, {388,0.06510891}, {389,0.05287129}, {390,0.05314851}, {391,0.05335644}, {392,0.05331683}, {393,0.05400000}, {394,0.05535644}, {395,0.05701980}, {396,0.05786139}, {397,0.05912871}, {398,0.05979208}, {399,0.06214851}, {400,0.06353465}, {401,0.06199010}, {402,0.06168317}, {403,0.06160396}, {404,0.06097030}, {405,0.05974257}, {406,0.05878218}, {407,0.05742574}, {408,0.05571287}, {409,0.05558416}, {410,0.05606931}, {411,0.05605941}, {412,0.06999010}, {413,0.06771287}, {414,0.06465347}, {415,0.06134653}, {416,0.05781188}, {417,0.05690099}, {418,0.05693069}, {419,0.07233663}, {420,0.06678218}, {421,0.06181188}, {422,0.05743564}, {423,0.05768317}, {424,0.07060396}, {425,0.06452475}, {426,0.05953465}, {427,0.05852475}, {428,0.06965347}, {429,0.06330693}, {430,0.05855446}, {431,0.07320792}, {432,0.06509901}, {433,0.05863366}, {434,0.06163366}, {435,0.07083168}, {436,0.05960396}, {437,0.07583168}, {438,0.06627723}, {439,0.05985149}, {440,0.07136634}, {441,0.06154455}, {442,0.07618812}, {443,0.06578218}, {444,0.06057426}, {445,0.06895050}, {446,0.06071287}, {447,0.07086139}, {448,0.06056436}, {449,0.07163366}, {450,0.06107921}, {451,0.07853465}, {452,0.06258416}, {453,0.07537624}, {454,0.06214851}, {455,0.07419802}, {456,0.06168317}, {457,0.07103960}, {458,0.06236634}, {459,0.06744554}, {460,0.07746535}, {461,0.06372277}, {462,0.07279208}, {463,0.06370297}, {464,0.06642574}, {465,0.07560396}, {466,0.06323762}, {467,0.07202970}, {468,0.08145545}, {469,0.06422772}, {470,0.06914851}, {471,0.07838614}, {472,0.06405941}, {473,0.06654455}, {474,0.07373267}, {475,0.07936634}, {476,0.06491089}, {477,0.06752475}, {478,0.07332673}, {479,0.07803960}, {480,0.06518812}, {481,0.06525743}, {482,0.07137624}, {483,0.07596040}, {484,0.07990099}, {485,0.08356436}, {486,0.06646535}, {487,0.06775248}, {488,0.06945545}, {489,0.07306931}, {490,0.07543564}, {491,0.07792079}, {492,0.07980198}, {493,0.08603960}, {494,0.09190099}, {495,0.06778218}, {496,0.06749505}, {497,0.06797030}, {498,0.06756436}, {499,0.06838614}, {500,0.06834653}, {505,0.06915842}, {510,0.06998020}, {515,0.07203960}, {520,0.08537624}, {525,0.08247525}, {530,0.07939604}, {535,0.07302970}, {540,0.08883168}, {545,0.07976238}, {550,0.09390099}, {555,0.08302970}, {560,0.09291089}, {565,0.08100990}, {570,0.08921782}, {575,0.09676238}, {580,0.07975248}, {585,0.08932673}, {590,0.09227723}, {595,0.09565347}, {600,0.09676238}, {605,0.09715842}, {610,0.09617822}, {615,0.09505941}, {620,0.09228713}, {625,0.09123762}, {630,0.11273267}, {635,0.10311881}, {640,0.09361386}, {645,0.10938614}, {650,0.09931683}, {655,0.09311881}, {660,0.10027723}, {665,0.12011881}, {670,0.09840594}, {675,0.10696040}, {680,0.11279208}, {685,0.09690099}, {690,0.09929703}, {695,0.10289109}, {700,0.10990099}, {705,0.10675248}, {710,0.10794059}, {715,0.10595050}, {720,0.10202970}, {725,0.12412871}, {730,0.11736634}, {735,0.11761386}, {740,0.10543564}, {745,0.12157426}, {750,0.11087129}, {755,0.12313861}, {760,0.11161386}, {765,0.12510891}, {770,0.13377228}, {775,0.11741584}, {780,0.12323762}, {785,0.12892079}, {790,0.14767327}, {795,0.11729703}, {800,0.11728713}, {805,0.12025743}, {810,0.12015842}, {815,0.11936634}, {820,0.15020792}, {825,0.13941584}, {830,0.13371287}, {835,0.12606931}, {840,0.14112871}, {845,0.14428713}, {850,0.12803960}, {855,0.14121782}, {860,0.12763366}, {865,0.13721782}, {870,0.12818812}, {875,0.13356436}, {880,0.13948515}, {885,0.14545545}, {890,0.16563366}, {895,0.13389109}, {900,0.13360396}, {905,0.13425743}, {910,0.13431683}, {915,0.14010891}, {920,0.13504950}, {925,0.15362376}, {930,0.14708911}, {935,0.14244554}, {940,0.13956436}, {945,0.14466337}, {950,0.14325743}, {955,0.15376238}, {960,0.15088119}, {965,0.15796040}, {970,0.14255446}, {975,0.14977228}, {980,0.15555446}, {985,0.16778218}, {990,0.14784158}, {995,0.14916832}, {1000,0.14630693}, {1010,0.15747525}, {1020,0.15525743}, {1030,0.15260396}, {1040,0.18347525}, {1050,0.16871287}, {1060,0.15731683}, {1070,0.16670297}, {1080,0.18027723}, {1090,0.16324752}, {1100,0.16625743}, {1110,0.17759406}, {1120,0.16983168}, {1130,0.16798020}, {1140,0.18461386}, {1150,0.18333663}, {1160,0.19165347}, {1170,0.18022772}, {1180,0.19575248}, {1190,0.19862376}, {1200,0.17799010}, {1210,0.18730693}, {1220,0.18501980}, {1230,0.20439604}, {1240,0.20500000}, {1250,0.19363366}, {1260,0.20661386}, {1270,0.20036634}, {1280,0.20273267}, {1290,0.23067327}, {1300,0.20089109}, {1310,0.19987129}, {1320,0.20329703}, {1330,0.22429703}, {1340,0.21524752}, {1350,0.21533663}, {1360,0.22408911}, {1370,0.23019802}, {1380,0.22743564}, {1390,0.21000990}, {1400,0.21770297}, {1410,0.21544554}, {1420,0.21082178}, {1430,0.21984158}, {1440,0.23241584}, {1450,0.23533663}, {1460,0.22323762}, {1470,0.24888119}, {1480,0.24549505}, {1490,0.22659406}, {1500,0.23477228}, {1510,0.23436634}, {1520,0.24038614}, {1530,0.23328713}, {1540,0.26748515}, {1550,0.24867327}, {1560,0.23597030}, {1570,0.25521782}, {1580,0.24199010}, {1590,0.24807921}, {1600,0.25003960}, {1610,0.26544554}, {1620,0.25931683}, {1630,0.26634653}, {1640,0.25242574}, {1650,0.27763366}, {1660,0.26333663}, {1670,0.28164356}, {1680,0.26087129}, {1690,0.27855446}, {1700,0.27416832}, {1710,0.28890099}, {1720,0.27892079}, {1730,0.28788119}, {1740,0.27480198}, {1750,0.27515842}, {1760,0.28237624}, {1770,0.28170297}, {1780,0.28161386}, {1790,0.29559406}, {1800,0.28242574}, {1810,0.27875248}, {1820,0.28820792}, {1830,0.28242574}, {1840,0.30745545}, {1850,0.29492079}, {1860,0.29244554}, {1870,0.32661386}, {1880,0.29270297}, {1890,0.30800000}, {1900,0.30265347}, {1910,0.31020792}, {1920,0.30392079}, {1930,0.30993069}, {1940,0.31348515}, {1950,0.30319802}, {1960,0.30938614}, {1970,0.30786139}, {1980,0.31337624}, {1990,0.32860396}, {2000,0.32290099}, {2050,0.33041584}, {2100,0.35001980}, {2150,0.34053465}, {2200,0.36199010}, {2250,0.38393069}, {2300,0.36627723}, {2350,0.37911881}, {2400,0.39989109}, {2450,0.41284158}, {2500,0.39949505}, {2550,0.40703960}, {2600,0.42853465}, {2650,0.44394059}, {2700,0.44091089}, {2750,0.46447525}, {2800,0.45207921}, {2850,0.46339604}, {2900,0.45935644}, {2950,0.47264356}, {3000,0.49219802}, {3050,0.50140594}, {3100,0.49793069}, {3150,0.51237624}, {3200,0.52009901}, {3250,0.52022772}, {3300,0.53513861}, {3350,0.54695050}, {3400,0.54355446}, {3450,0.55801980}, {3500,0.57350495}, {3550,0.58742574}, {3600,0.57207921}, {3650,0.58627723}, {3700,0.60532673}, {3750,0.62845545}, {3800,0.63468317}, {3850,0.63143564}, {3900,0.64041584}, {3950,0.64580198}, {4000,0.66279208}, {4050,0.68474257}, {4100,0.66315842}, {4150,0.68259406}, {4200,0.68316832}, {4250,0.71933663}, {4300,0.71019802}, {4350,0.72248515}, {4400,0.73832673}, {4450,0.73484158}, {4500,0.73733663}, {4550,0.76679208}, {4600,0.76485149}, {4650,0.78015842}, {4700,0.78270297}, {4750,0.77807921}, {4800,0.82442574}, {4850,0.79520792}, {4900,0.83433663}, {4950,0.83548515}, {5000,0.84414851}, {5050,0.84133663}, {5100,0.86857426}, {5150,0.85734653}, {5200,0.94120792}, {5250,0.87314851}, {5300,0.87539604}, {5350,0.90727723}, {5400,0.90073267}, {5450,0.90980198}, {5500,0.93043564}, {5550,0.93240594}, {5600,0.92942574}, {5650,0.94396040}, {5700,0.93782178}, {5750,0.96306931}, {5800,0.98231683}, {5850,0.99912871}, {5900,0.99153465}, {5950,0.99618812}, {6000,1.01132673}, {6050,1.0699143}, {6100,1.0749714}, {6150,1.0804571}, {6200,1.0793143}, {6250,1.0996571}, {6300,1.1074571}, {6350,1.1250286}, {6400,1.1124857}, {6450,1.1593429}, {6500,1.1578571}, {6550,1.1833429}, {6600,1.1868571}, {6650,1.1694857}, {6700,1.1616286}, {6750,1.1889429}, {6800,1.1928571}, {6850,1.2065714}, {6900,1.2177714}, {6950,1.2344000}, {7000,1.2698857}, {7050,1.2727143}, {7100,1.2712857}, {7150,1.2772286}, {7200,1.2785714}, {7250,1.2828857}, {7300,1.2965714}, {7350,1.3266000}, {7400,1.3038571}, {7450,1.2980571}, {7500,1.3064857}, {7550,1.3422571}, {7600,1.3893143}, {7650,1.3912857}, {7700,1.3688286}, {7750,1.3972857}, {7800,1.3918000}, {7850,1.3926571}, {7900,1.4245429}, {7950,1.4372857}, {8000,1.4160286}, {8050,1.4410571}, {8100,1.4189429}, {8150,1.4587143}, {8200,1.4657143}, {8250,1.4656286}, {8300,1.4639429}, {8350,1.4510000}, {8400,1.5011143}, {8450,1.5049143}, {8500,1.5020857}, {8550,1.5246571}, {8600,1.5703429}, {8650,1.5538571}, {8700,1.5538857}, {8750,1.5937714}, {8800,1.5708857}, {8850,1.5661714}, {8900,1.5937143}, {8950,1.6188286}, {9000,1.5796286}, {9050,1.6155429}, {9100,1.6513429}, {9150,1.6357429}, {9200,1.6608857}, {9250,1.6632286}, {9300,1.6526286}, {9350,1.7193714}, {9400,1.7057714}, {9450,1.6868286}, {9500,1.7261714}, {9550,1.7366000}, {9600,1.7221714}, {9650,1.7353143}, {9700,1.7849143}, {9750,1.7422857}, {9800,1.7667143}, {9850,1.8070857}, {9900,1.8008571}, {9950,1.8024286}, {10000,1.8220571}, {10100,1.7958000}, {10200,1.8751143}, {10300,1.8742857}, {10400,1.8780857}, {10500,1.8528571}, {10600,1.9136286}, {10700,1.9076286}, {10800,1.9418571}, {10900,1.9449714}, {11000,1.9837714}, {11100,2.0036286}, {11200,2.0345714}, {11300,1.9988000}, {11400,2.0509143}, {11500,2.0307143}, {11600,2.1033714}, {11700,2.2757429}, {11800,2.0963143}, {11900,2.2544857}, {12000,2.1442286}, {12100,2.1581429}, {12200,2.2060571}, {12300,2.2098571}, {12400,2.1777143}, {12500,2.2692000}, {12600,2.2760571}, {12700,2.2818000}, {12800,2.2483429}, {12900,2.3026000}, {13000,2.3375143}, {13100,2.3898000}, {13200,2.3800857}, {13300,2.3957714}, {13400,2.3881714}, {13500,2.4180857}, {13600,2.4121429}, {13700,2.4754857}, {13800,2.4567714}, {13900,2.5012857}, {14000,2.5193429}, {14100,2.5438286}, {14200,2.6023714}, {14300,2.5713143}, {14400,2.5864857}, {14500,2.6483429}, {14600,2.5900571}, {14700,2.6508286}, {14800,2.6723714}, {14900,2.6225429}, {15000,2.6630571}, {15100,2.7363429}, {15200,2.7440000}, {15300,2.8306857}, {15400,2.7483714}, {15500,2.8954571}, {15600,2.8354571}, {15700,2.8184571}, {15800,2.8526857}, {15900,2.8734857}, {16000,2.9295143}, {16100,2.9218857}, {16200,2.9009143}, {16300,2.8876000}, {16400,2.9299143}, {16500,2.9210571}, {16600,2.9835714}, {16700,3.1809429}, {16800,3.0169143}, {16900,3.0049429}, {17000,3.0102286}, {17100,3.0888286}, {17200,3.1781429}, {17300,3.0968286}, {17400,3.1470571}, {17500,3.1613429}, {17600,3.1814571}, {17700,3.1746857}, {17800,3.1890571}, {17900,3.2403143}, {18000,3.2340286}, {18100,3.2834000}, {18200,3.2478857}, {18300,3.2788286}, {18400,3.3320000}, {18500,3.3248000}, {18600,3.3253143}, {18700,3.3886857}, {18800,3.3798571}, {18900,3.4382571}, {19000,3.6582857}, {19100,3.4486857}, {19200,3.4307143}, {19300,3.5641143}, {19400,3.7887714}, {19500,3.5913429}, {19600,3.6713429}, {19700,3.5882286}, {19800,3.7208571}, {19900,3.8650571}, {20000,3.6624286}};
data["big_flat"]["LtacTCGallinaCtx"]["Aggregate"]["user"] = {{1,0.00047525}, {2,0.00078218}, {3,0.00125743}, {4,0.00115842}, {5,0.00141584}, {6,0.00161386}, {7,0.00198020}, {8,0.00142574}, {9,0.00176238}, {10,0.00194059}, {11,0.00204950}, {12,0.00193069}, {13,0.00256436}, {14,0.00229703}, {15,0.00254455}, {16,0.00272277}, {17,0.00280198}, {18,0.00307921}, {19,0.00352475}, {20,0.00315842}, {21,0.00324752}, {22,0.00323762}, {23,0.00364356}, {24,0.00382178}, {25,0.00413861}, {26,0.00393069}, {27,0.00438614}, {28,0.00437624}, {29,0.00439604}, {30,0.00438614}, {31,0.00521782}, {32,0.00581188}, {33,0.00497030}, {34,0.00499010}, {35,0.00564356}, {36,0.00546535}, {37,0.00767327}, {38,0.00574257}, {39,0.00587129}, {40,0.00622772}, {41,0.00571287}, {42,0.00651485}, {43,0.00671287}, {44,0.00655446}, {45,0.00694059}, {46,0.00689109}, {47,0.00750495}, {48,0.00747525}, {49,0.00728713}, {50,0.00764356}, {51,0.00771287}, {52,0.00772277}, {53,0.00805941}, {54,0.00824752}, {55,0.00823762}, {56,0.00836634}, {57,0.00833663}, {58,0.00841584}, {59,0.00883168}, {60,0.00860396}, {61,0.00895050}, {62,0.00912871}, {63,0.00936634}, {64,0.00937624}, {65,0.00961386}, {66,0.00972277}, {67,0.01224752}, {68,0.01003960}, {69,0.01002970}, {70,0.00978218}, {71,0.01017822}, {72,0.01022772}, {73,0.01071287}, {74,0.01044554}, {75,0.01263366}, {76,0.01060396}, {77,0.01090099}, {78,0.01111881}, {79,0.01123762}, {80,0.01148515}, {81,0.01140594}, {82,0.01173267}, {83,0.01185149}, {84,0.01187129}, {85,0.01211881}, {86,0.01200990}, {87,0.01285149}, {88,0.01229703}, {89,0.01320792}, {90,0.01565347}, {91,0.01349505}, {92,0.01298020}, {93,0.01315842}, {94,0.01372277}, {95,0.01377228}, {96,0.01346535}, {97,0.01386139}, {98,0.01400000}, {99,0.01403960}, {100,0.01408911}, {101,0.01556436}, {102,0.01762376}, {103,0.01605941}, {104,0.01433663}, {105,0.01451485}, {106,0.01496040}, {107,0.01509901}, {108,0.01533663}, {109,0.01527723}, {110,0.01563366}, {111,0.01596040}, {112,0.01692079}, {113,0.01591089}, {114,0.01625743}, {115,0.01618812}, {116,0.01624752}, {117,0.02081188}, {118,0.01650495}, {119,0.01673267}, {120,0.01674257}, {121,0.01701980}, {122,0.01711881}, {123,0.01711881}, {124,0.01730693}, {125,0.01843564}, {126,0.01758416}, {127,0.01742574}, {128,0.01752475}, {129,0.01777228}, {130,0.01804950}, {131,0.01781188}, {132,0.01777228}, {133,0.01842574}, {134,0.01817822}, {135,0.01846535}, {136,0.01844554}, {137,0.02128713}, {138,0.01876238}, {139,0.01914851}, {140,0.01885149}, {141,0.01906931}, {142,0.01908911}, {143,0.01938614}, {144,0.02008911}, {145,0.01962376}, {146,0.02215842}, {147,0.01998020}, {148,0.02267327}, {149,0.01987129}, {150,0.02191089}, {151,0.02117822}, {152,0.02044554}, {153,0.02114851}, {154,0.02095050}, {155,0.02112871}, {156,0.02137624}, {157,0.02416832}, {158,0.02149505}, {159,0.02184158}, {160,0.02782178}, {161,0.02205941}, {162,0.02213861}, {163,0.02261386}, {164,0.02229703}, {165,0.02270297}, {166,0.02305941}, {167,0.02310891}, {168,0.02276238}, {169,0.02828713}, {170,0.02345545}, {171,0.02357426}, {172,0.02413861}, {173,0.03106931}, {174,0.02397030}, {175,0.02410891}, {176,0.02367327}, {177,0.02900000}, {178,0.02433663}, {179,0.02460396}, {180,0.02431683}, {181,0.02477228}, {182,0.02611881}, {183,0.03100000}, {184,0.02525743}, {185,0.02535644}, {186,0.02558416}, {187,0.02535644}, {188,0.02514851}, {189,0.02621782}, {190,0.02581188}, {191,0.02681188}, {192,0.02830693}, {193,0.03053465}, {194,0.03189109}, {195,0.03289109}, {196,0.03370297}, {197,0.03426733}, {198,0.03423762}, {199,0.03419802}, {200,0.03396040}, {201,0.03294059}, {202,0.03201980}, {203,0.03153465}, {204,0.02980198}, {205,0.02850495}, {206,0.02788119}, {207,0.02818812}, {208,0.02803960}, {209,0.02813861}, {210,0.02860396}, {211,0.02879208}, {212,0.03950495}, {213,0.03384158}, {214,0.02860396}, {215,0.02912871}, {216,0.02939604}, {217,0.02964356}, {218,0.03617822}, {219,0.03126733}, {220,0.02969307}, {221,0.03040594}, {222,0.03163366}, {223,0.03326733}, {224,0.03028713}, {225,0.03089109}, {226,0.03931683}, {227,0.03227723}, {228,0.03107921}, {229,0.03172277}, {230,0.03470297}, {231,0.03164356}, {232,0.03178218}, {233,0.03475248}, {234,0.03213861}, {235,0.03214851}, {236,0.03339604}, {237,0.03245545}, {238,0.03875248}, {239,0.03216832}, {240,0.03244554}, {241,0.03345545}, {242,0.03293069}, {243,0.03694059}, {244,0.03348515}, {245,0.03865347}, {246,0.03341584}, {247,0.04044554}, {248,0.03383168}, {249,0.04190099}, {250,0.03407921}, {251,0.04121782}, {252,0.03455446}, {253,0.03933663}, {254,0.03467327}, {255,0.03631683}, {256,0.03511881}, {257,0.03474257}, {258,0.04385149}, {259,0.03540594}, {260,0.03774257}, {261,0.03564356}, {262,0.03581188}, {263,0.04171287}, {264,0.03595050}, {265,0.03619802}, {266,0.04265347}, {267,0.03702970}, {268,0.03643564}, {269,0.04233663}, {270,0.03670297}, {271,0.03711881}, {272,0.03824752}, {273,0.04841584}, {274,0.03757426}, {275,0.03733663}, {276,0.03829703}, {277,0.04536634}, {278,0.03781188}, {279,0.03782178}, {280,0.03797030}, {281,0.04025743}, {282,0.04497030}, {283,0.05007921}, {284,0.03872277}, {285,0.03862376}, {286,0.03878218}, {287,0.03840594}, {288,0.04017822}, {289,0.04377228}, {290,0.04645545}, {291,0.04876238}, {292,0.04981188}, {293,0.03964356}, {294,0.03987129}, {295,0.04011881}, {296,0.04026733}, {297,0.04023762}, {298,0.04065347}, {299,0.04040594}, {300,0.04052475}, {301,0.04081188}, {302,0.04161386}, {303,0.04086139}, {304,0.04125743}, {305,0.04151485}, {306,0.05741584}, {307,0.05119802}, {308,0.04946535}, {309,0.04722772}, {310,0.04471287}, {311,0.04235644}, {312,0.04216832}, {313,0.04273267}, {314,0.04295050}, {315,0.05359406}, {316,0.04920792}, {317,0.04494059}, {318,0.04343564}, {319,0.04375248}, {320,0.05484158}, {321,0.04932673}, {322,0.04522772}, {323,0.04376238}, {324,0.04408911}, {325,0.05144554}, {326,0.04638614}, {327,0.04489109}, {328,0.04405941}, {329,0.05032673}, {330,0.04493069}, {331,0.04558416}, {332,0.05609901}, {333,0.04564356}, {334,0.04580198}, {335,0.05331683}, {336,0.04533663}, {337,0.04626733}, {338,0.05027723}, {339,0.04619802}, {340,0.05534653}, {341,0.04701980}, {342,0.04616832}, {343,0.04961386}, {344,0.04655446}, {345,0.05226733}, {346,0.04740594}, {347,0.05391089}, {348,0.04743564}, {349,0.05449505}, {350,0.04769307}, {351,0.05457426}, {352,0.04801980}, {353,0.05346535}, {354,0.04825743}, {355,0.05210891}, {356,0.04838614}, {357,0.05133663}, {358,0.06560396}, {359,0.04941584}, {360,0.05620792}, {361,0.04968317}, {362,0.05170297}, {363,0.06188119}, {364,0.04964356}, {365,0.05348515}, {366,0.06281188}, {367,0.05025743}, {368,0.05344554}, {369,0.06112871}, {370,0.05000000}, {371,0.05185149}, {372,0.05831683}, {373,0.05104950}, {374,0.05098020}, {375,0.05374257}, {376,0.05940594}, {377,0.05291089}, {378,0.05165347}, {379,0.05266337}, {380,0.05973267}, {381,0.06658416}, {382,0.05418812}, {383,0.05208911}, {384,0.05138614}, {385,0.05333663}, {386,0.05826733}, {387,0.06090099}, {388,0.06486139}, {389,0.05277228}, {390,0.05307921}, {391,0.05265347}, {392,0.05314851}, {393,0.05365347}, {394,0.05506931}, {395,0.05669307}, {396,0.05756436}, {397,0.05935644}, {398,0.05969307}, {399,0.06163366}, {400,0.06341584}, {401,0.06220792}, {402,0.06161386}, {403,0.06148515}, {404,0.06119802}, {405,0.05970297}, {406,0.05906931}, {407,0.05755446}, {408,0.05575248}, {409,0.05512871}, {410,0.05529703}, {411,0.05594059}, {412,0.06983168}, {413,0.06738614}, {414,0.06438614}, {415,0.06126733}, {416,0.05816832}, {417,0.05681188}, {418,0.05685149}, {419,0.07265347}, {420,0.06620792}, {421,0.06157426}, {422,0.05732673}, {423,0.05795050}, {424,0.07062376}, {425,0.06381188}, {426,0.05962376}, {427,0.05844554}, {428,0.06934653}, {429,0.06304950}, {430,0.05847525}, {431,0.07303960}, {432,0.06492079}, {433,0.05888119}, {434,0.06146535}, {435,0.07044554}, {436,0.05950495}, {437,0.07529703}, {438,0.06588119}, {439,0.06015842}, {440,0.07099010}, {441,0.06148515}, {442,0.07607921}, {443,0.06546535}, {444,0.06070297}, {445,0.06887129}, {446,0.06086139}, {447,0.07063366}, {448,0.06075248}, {449,0.07159406}, {450,0.06121782}, {451,0.07818812}, {452,0.06261386}, {453,0.07504950}, {454,0.06237624}, {455,0.07404950}, {456,0.06180198}, {457,0.07079208}, {458,0.06255446}, {459,0.06687129}, {460,0.07696040}, {461,0.06373267}, {462,0.07286139}, {463,0.06319802}, {464,0.06612871}, {465,0.07517822}, {466,0.06323762}, {467,0.07196040}, {468,0.08115842}, {469,0.06400990}, {470,0.06901980}, {471,0.07800000}, {472,0.06390099}, {473,0.06627723}, {474,0.07385149}, {475,0.07897030}, {476,0.06463366}, {477,0.06727723}, {478,0.07345545}, {479,0.07777228}, {480,0.06481188}, {481,0.06471287}, {482,0.07103960}, {483,0.07573267}, {484,0.08003960}, {485,0.08366337}, {486,0.06603960}, {487,0.06757426}, {488,0.06927723}, {489,0.07321782}, {490,0.07534653}, {491,0.07747525}, {492,0.07956436}, {493,0.08551485}, {494,0.09121782}, {495,0.06760396}, {496,0.06740594}, {497,0.06756436}, {498,0.06712871}, {499,0.06800000}, {500,0.06779208}, {505,0.06898020}, {510,0.06988119}, {515,0.07149505}, {520,0.08500990}, {525,0.08181188}, {530,0.07924752}, {535,0.07295050}, {540,0.08852475}, {545,0.07932673}, {550,0.09352475}, {555,0.08311881}, {560,0.09259406}, {565,0.08049505}, {570,0.08892079}, {575,0.09652475}, {580,0.07950495}, {585,0.08907921}, {590,0.09189109}, {595,0.09569307}, {600,0.09650495}, {605,0.09690099}, {610,0.09603960}, {615,0.09476238}, {620,0.09219802}, {625,0.09119802}, {630,0.11266337}, {635,0.10280198}, {640,0.09395050}, {645,0.10915842}, {650,0.09910891}, {655,0.09294059}, {660,0.10042574}, {665,0.11934653}, {670,0.09808911}, {675,0.10671287}, {680,0.11230693}, {685,0.09690099}, {690,0.09897030}, {695,0.10245545}, {700,0.10949505}, {705,0.10653465}, {710,0.10781188}, {715,0.10555446}, {720,0.10136634}, {725,0.12349505}, {730,0.11695050}, {735,0.11711881}, {740,0.10537624}, {745,0.12108911}, {750,0.11049505}, {755,0.12296040}, {760,0.11102970}, {765,0.12483168}, {770,0.13353465}, {775,0.11728713}, {780,0.12294059}, {785,0.12885149}, {790,0.14720792}, {795,0.11716832}, {800,0.11717822}, {805,0.12009901}, {810,0.12002970}, {815,0.11924752}, {820,0.15015842}, {825,0.13917822}, {830,0.13339604}, {835,0.12588119}, {840,0.14071287}, {845,0.14386139}, {850,0.12754455}, {855,0.14113861}, {860,0.12714851}, {865,0.13701980}, {870,0.12794059}, {875,0.13345545}, {880,0.13926733}, {885,0.14498020}, {890,0.16528713}, {895,0.13361386}, {900,0.13289109}, {905,0.13382178}, {910,0.13395050}, {915,0.13975248}, {920,0.13483168}, {925,0.15314851}, {930,0.14677228}, {935,0.14194059}, {940,0.13966337}, {945,0.14442574}, {950,0.14295050}, {955,0.15343564}, {960,0.15046535}, {965,0.15760396}, {970,0.14240594}, {975,0.14976238}, {980,0.15523762}, {985,0.16794059}, {990,0.14727723}, {995,0.14873267}, {1000,0.14588119}, {1010,0.15686139}, {1020,0.15505941}, {1030,0.15231683}, {1040,0.18294059}, {1050,0.16786139}, {1060,0.15680198}, {1070,0.16621782}, {1080,0.17976238}, {1090,0.16287129}, {1100,0.16596040}, {1110,0.17721782}, {1120,0.16934653}, {1130,0.16730693}, {1140,0.18453465}, {1150,0.18272277}, {1160,0.19100000}, {1170,0.17988119}, {1180,0.19545545}, {1190,0.19823762}, {1200,0.17775248}, {1210,0.18670297}, {1220,0.18461386}, {1230,0.20380198}, {1240,0.20434653}, {1250,0.19294059}, {1260,0.20602970}, {1270,0.19999010}, {1280,0.20240594}, {1290,0.23000000}, {1300,0.20028713}, {1310,0.19922772}, {1320,0.20278218}, {1330,0.22330693}, {1340,0.21432673}, {1350,0.21494059}, {1360,0.22342574}, {1370,0.22944554}, {1380,0.22631683}, {1390,0.20923762}, {1400,0.21711881}, {1410,0.21426733}, {1420,0.21017822}, {1430,0.21937624}, {1440,0.23167327}, {1450,0.23448515}, {1460,0.22263366}, {1470,0.24809901}, {1480,0.24454455}, {1490,0.22599010}, {1500,0.23426733}, {1510,0.23360396}, {1520,0.23979208}, {1530,0.23281188}, {1540,0.26684158}, {1550,0.24817822}, {1560,0.23500000}, {1570,0.25453465}, {1580,0.24083168}, {1590,0.24758416}, {1600,0.24930693}, {1610,0.26477228}, {1620,0.25850495}, {1630,0.26534653}, {1640,0.25157426}, {1650,0.27698020}, {1660,0.26258416}, {1670,0.28066337}, {1680,0.26009901}, {1690,0.27787129}, {1700,0.27348515}, {1710,0.28790099}, {1720,0.27803960}, {1730,0.28695050}, {1740,0.27402970}, {1750,0.27456436}, {1760,0.28155446}, {1770,0.28059406}, {1780,0.28029703}, {1790,0.29464356}, {1800,0.28164356}, {1810,0.27746535}, {1820,0.28722772}, {1830,0.28151485}, {1840,0.30677228}, {1850,0.29450495}, {1860,0.29129703}, {1870,0.32545545}, {1880,0.29190099}, {1890,0.30718812}, {1900,0.30199010}, {1910,0.30909901}, {1920,0.30288119}, {1930,0.30909901}, {1940,0.31246535}, {1950,0.30218812}, {1960,0.30839604}, {1970,0.30677228}, {1980,0.31241584}, {1990,0.32747525}, {2000,0.32192079}, {2050,0.32914851}, {2100,0.34919802}, {2150,0.33931683}, {2200,0.36125743}, {2250,0.38278218}, {2300,0.36550495}, {2350,0.37814851}, {2400,0.39885149}, {2450,0.41180198}, {2500,0.39848515}, {2550,0.40613861}, {2600,0.42740594}, {2650,0.44303960}, {2700,0.43996040}, {2750,0.46290099}, {2800,0.45124752}, {2850,0.45928713}, {2900,0.45834653}, {2950,0.47132673}, {3000,0.49125743}, {3050,0.50026733}, {3100,0.49645545}, {3150,0.51155446}, {3200,0.51909901}, {3250,0.51927723}, {3300,0.53434653}, {3350,0.54591089}, {3400,0.54225743}, {3450,0.55681188}, {3500,0.57253465}, {3550,0.58633663}, {3600,0.57096040}, {3650,0.58539604}, {3700,0.60415842}, {3750,0.62745545}, {3800,0.63332673}, {3850,0.63016832}, {3900,0.63923762}, {3950,0.64442574}, {4000,0.66200990}, {4050,0.68357426}, {4100,0.66219802}, {4150,0.68123762}, {4200,0.68177228}, {4250,0.71790099}, {4300,0.70866337}, {4350,0.72089109}, {4400,0.73670297}, {4450,0.73339604}, {4500,0.73592079}, {4550,0.76511881}, {4600,0.76332673}, {4650,0.77849505}, {4700,0.78121782}, {4750,0.77664356}, {4800,0.82264356}, {4850,0.79359406}, {4900,0.83269307}, {4950,0.83390099}, {5000,0.84221782}, {5050,0.83938614}, {5100,0.86698020}, {5150,0.85553465}, {5200,0.93954455}, {5250,0.87142574}, {5300,0.87308911}, {5350,0.90530693}, {5400,0.89889109}, {5450,0.90745545}, {5500,0.92854455}, {5550,0.93040594}, {5600,0.92725743}, {5650,0.94210891}, {5700,0.93584158}, {5750,0.96077228}, {5800,0.98068317}, {5850,0.99686139}, {5900,0.98974257}, {5950,0.99419802}, {6000,1.00962376}, {6050,1.0627714}, {6100,1.0655143}, {6150,1.0792000}, {6200,1.0780571}, {6250,1.0982000}, {6300,1.1060286}, {6350,1.1238000}, {6400,1.1110857}, {6450,1.1573143}, {6500,1.1572857}, {6550,1.1816857}, {6600,1.1855429}, {6650,1.1678286}, {6700,1.1604857}, {6750,1.1879429}, {6800,1.1907143}, {6850,1.2018000}, {6900,1.2147143}, {6950,1.2332286}, {7000,1.2676571}, {7050,1.2721143}, {7100,1.2704857}, {7150,1.2762000}, {7200,1.2728286}, {7250,1.2817143}, {7300,1.2927143}, {7350,1.3195714}, {7400,1.3000571}, {7450,1.2962000}, {7500,1.3038000}, {7550,1.3353143}, {7600,1.3839429}, {7650,1.3846000}, {7700,1.3622857}, {7750,1.3876857}, {7800,1.3865429}, {7850,1.3830000}, {7900,1.4210857}, {7950,1.4355714}, {8000,1.4134571}, {8050,1.4387143}, {8100,1.4169714}, {8150,1.4568571}, {8200,1.4638000}, {8250,1.4646571}, {8300,1.4625143}, {8350,1.4488286}, {8400,1.4996571}, {8450,1.5037143}, {8500,1.4997143}, {8550,1.5227714}, {8600,1.5686571}, {8650,1.5519143}, {8700,1.5521714}, {8750,1.5896571}, {8800,1.5688857}, {8850,1.5640571}, {8900,1.5918286}, {8950,1.6171143}, {9000,1.5776571}, {9050,1.6137143}, {9100,1.6494571}, {9150,1.6334571}, {9200,1.6574286}, {9250,1.6604857}, {9300,1.6382286}, {9350,1.7152000}, {9400,1.7030857}, {9450,1.6843429}, {9500,1.7236000}, {9550,1.7348000}, {9600,1.7201143}, {9650,1.7322857}, {9700,1.7816857}, {9750,1.7392000}, {9800,1.7640857}, {9850,1.8041714}, {9900,1.7985429}, {9950,1.7997429}, {10000,1.8197429}, {10100,1.7933143}, {10200,1.8717714}, {10300,1.8712857}, {10400,1.8755429}, {10500,1.8500000}, {10600,1.9110857}, {10700,1.9046571}, {10800,1.9392000}, {10900,1.9420857}, {11000,1.9803714}, {11100,2.0009429}, {11200,2.0319714}, {11300,1.9954857}, {11400,2.0476286}, {11500,2.0278571}, {11600,2.0997429}, {11700,2.2708286}, {11800,2.0934000}, {11900,2.2495429}, {12000,2.1410286}, {12100,2.1548286}, {12200,2.2024286}, {12300,2.2055429}, {12400,2.1743143}, {12500,2.2653143}, {12600,2.2717429}, {12700,2.2772571}, {12800,2.2449143}, {12900,2.2986000}, {13000,2.3341714}, {13100,2.3867143}, {13200,2.3766857}, {13300,2.3920286}, {13400,2.3848000}, {13500,2.4148000}, {13600,2.4088286}, {13700,2.4695429}, {13800,2.4540000}, {13900,2.4981429}, {14000,2.5164857}, {14100,2.5400286}, {14200,2.5988286}, {14300,2.5674000}, {14400,2.5832000}, {14500,2.6451429}, {14600,2.5871143}, {14700,2.6477714}, {14800,2.6687429}, {14900,2.6204571}, {15000,2.6589714}, {15100,2.7334000}, {15200,2.7406857}, {15300,2.8274286}, {15400,2.7442571}, {15500,2.8924857}, {15600,2.8308857}, {15700,2.8142571}, {15800,2.8489429}, {15900,2.8708571}, {16000,2.9259143}, {16100,2.9188286}, {16200,2.8984857}, {16300,2.8837714}, {16400,2.9261714}, {16500,2.9183429}, {16600,2.9803143}, {16700,3.1779143}, {16800,3.0147429}, {16900,3.0021429}, {17000,3.0071714}, {17100,3.0857143}, {17200,3.1753143}, {17300,3.0944286}, {17400,3.1441143}, {17500,3.1584857}, {17600,3.1781714}, {17700,3.1707143}, {17800,3.1858857}, {17900,3.2368000}, {18000,3.2289714}, {18100,3.2778000}, {18200,3.2423143}, {18300,3.2741714}, {18400,3.3262571}, {18500,3.3196286}, {18600,3.3197429}, {18700,3.3838286}, {18800,3.3753143}, {18900,3.4074286}, {19000,3.6410857}, {19100,3.4288857}, {19200,3.3949143}, {19300,3.5594857}, {19400,3.7792000}, {19500,3.5806000}, {19600,3.6506571}, {19700,3.5796857}, {19800,3.6867429}, {19900,3.8601143}, {20000,3.6579429}};
data["big_flat"]["LtacTCGallinaCtx"]["Aggregate"]["system"] = {{1,0.00053465}, {2,0.00000000}, {3,0.00006931}, {4,0.00007921}, {5,0.00002970}, {6,0.00007921}, {7,0.00003960}, {8,0.00000000}, {9,0.00009901}, {10,0.00003960}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00003960}, {15,0.00006931}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00003960}, {21,0.00011881}, {22,0.00011881}, {23,0.00005941}, {24,0.00003960}, {25,0.00000000}, {26,0.00003960}, {27,0.00000000}, {28,0.00000000}, {29,0.00006931}, {30,0.00000000}, {31,0.00003960}, {32,0.00009901}, {33,0.00000000}, {34,0.00003960}, {35,0.00002970}, {36,0.00002970}, {37,0.00002970}, {38,0.00007921}, {39,0.00006931}, {40,0.00007921}, {41,0.00007921}, {42,0.00000000}, {43,0.00003960}, {44,0.00000000}, {45,0.00002970}, {46,0.00000000}, {47,0.00000000}, {48,0.00007921}, {49,0.00003960}, {50,0.00011881}, {51,0.00000000}, {52,0.00003960}, {53,0.00007921}, {54,0.00006931}, {55,0.00003960}, {56,0.00003960}, {57,0.00018812}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00003960}, {62,0.00000000}, {63,0.00003960}, {64,0.00003960}, {65,0.00000000}, {66,0.00000000}, {67,0.00025743}, {68,0.00013861}, {69,0.00002970}, {70,0.00002970}, {71,0.00000000}, {72,0.00007921}, {73,0.00000000}, {74,0.00011881}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00007921}, {79,0.00003960}, {80,0.00007921}, {81,0.00010891}, {82,0.00000000}, {83,0.00010891}, {84,0.00002970}, {85,0.00007921}, {86,0.00011881}, {87,0.00002970}, {88,0.00000000}, {89,0.00007921}, {90,0.00017822}, {91,0.00003960}, {92,0.00003960}, {93,0.00006931}, {94,0.00000000}, {95,0.00007921}, {96,0.00011881}, {97,0.00003960}, {98,0.00000000}, {99,0.00011881}, {100,0.00003960}, {101,0.00002970}, {102,0.00003960}, {103,0.00011881}, {104,0.00011881}, {105,0.00000000}, {106,0.00010891}, {107,0.00000000}, {108,0.00010891}, {109,0.00002970}, {110,0.00007921}, {111,0.00002970}, {112,0.00011881}, {113,0.00000000}, {114,0.00000000}, {115,0.00003960}, {116,0.00003960}, {117,0.00010891}, {118,0.00000000}, {119,0.00000000}, {120,0.00003960}, {121,0.00011881}, {122,0.00003960}, {123,0.00011881}, {124,0.00003960}, {125,0.00003960}, {126,0.00000000}, {127,0.00000000}, {128,0.00003960}, {129,0.00007921}, {130,0.00003960}, {131,0.00003960}, {132,0.00006931}, {133,0.00002970}, {134,0.00003960}, {135,0.00000000}, {136,0.00002970}, {137,0.00014851}, {138,0.00002970}, {139,0.00011881}, {140,0.00011881}, {141,0.00003960}, {142,0.00003960}, {143,0.00000000}, {144,0.00014851}, {145,0.00003960}, {146,0.00010891}, {147,0.00000000}, {148,0.00002970}, {149,0.00007921}, {150,0.00003960}, {151,0.00000000}, {152,0.00000000}, {153,0.00011881}, {154,0.00003960}, {155,0.00000000}, {156,0.00011881}, {157,0.00006931}, {158,0.00000000}, {159,0.00003960}, {160,0.00015842}, {161,0.00007921}, {162,0.00011881}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00003960}, {168,0.00011881}, {169,0.00018812}, {170,0.00003960}, {171,0.00003960}, {172,0.00011881}, {173,0.00023762}, {174,0.00007921}, {175,0.00011881}, {176,0.00015842}, {177,0.00000000}, {178,0.00010891}, {179,0.00003960}, {180,0.00002970}, {181,0.00010891}, {182,0.00003960}, {183,0.00003960}, {184,0.00007921}, {185,0.00000000}, {186,0.00002970}, {187,0.00002970}, {188,0.00005941}, {189,0.00000000}, {190,0.00007921}, {191,0.00007921}, {192,0.00003960}, {193,0.00014851}, {194,0.00023762}, {195,0.00018812}, {196,0.00015842}, {197,0.00007921}, {198,0.00005941}, {199,0.00027723}, {200,0.00006931}, {201,0.00030693}, {202,0.00025743}, {203,0.00003960}, {204,0.00014851}, {205,0.00007921}, {206,0.00003960}, {207,0.00000000}, {208,0.00003960}, {209,0.00000000}, {210,0.00000000}, {211,0.00003960}, {212,0.00022772}, {213,0.00007921}, {214,0.00014851}, {215,0.00003960}, {216,0.00003960}, {217,0.00000000}, {218,0.00015842}, {219,0.00010891}, {220,0.00015842}, {221,0.00011881}, {222,0.00023762}, {223,0.00011881}, {224,0.00006931}, {225,0.00003960}, {226,0.00035644}, {227,0.00003960}, {228,0.00003960}, {229,0.00000000}, {230,0.00003960}, {231,0.00003960}, {232,0.00003960}, {233,0.00007921}, {234,0.00000000}, {235,0.00003960}, {236,0.00000000}, {237,0.00010891}, {238,0.00025743}, {239,0.00003960}, {240,0.00018812}, {241,0.00007921}, {242,0.00006931}, {243,0.00000000}, {244,0.00000000}, {245,0.00011881}, {246,0.00000000}, {247,0.00007921}, {248,0.00003960}, {249,0.00010891}, {250,0.00003960}, {251,0.00003960}, {252,0.00015842}, {253,0.00003960}, {254,0.00003960}, {255,0.00007921}, {256,0.00003960}, {257,0.00014851}, {258,0.00003960}, {259,0.00003960}, {260,0.00007921}, {261,0.00003960}, {262,0.00000000}, {263,0.00019802}, {264,0.00000000}, {265,0.00003960}, {266,0.00000000}, {267,0.00007921}, {268,0.00003960}, {269,0.00000000}, {270,0.00011881}, {271,0.00003960}, {272,0.00007921}, {273,0.00003960}, {274,0.00011881}, {275,0.00003960}, {276,0.00015842}, {277,0.00006931}, {278,0.00003960}, {279,0.00000000}, {280,0.00007921}, {281,0.00003960}, {282,0.00003960}, {283,0.00000000}, {284,0.00003960}, {285,0.00013861}, {286,0.00000000}, {287,0.00000000}, {288,0.00011881}, {289,0.00000000}, {290,0.00007921}, {291,0.00011881}, {292,0.00002970}, {293,0.00003960}, {294,0.00007921}, {295,0.00015842}, {296,0.00003960}, {297,0.00007921}, {298,0.00003960}, {299,0.00011881}, {300,0.00007921}, {301,0.00000000}, {302,0.00003960}, {303,0.00011881}, {304,0.00003960}, {305,0.00007921}, {306,0.00000000}, {307,0.00003960}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00003960}, {312,0.00007921}, {313,0.00003960}, {314,0.00000000}, {315,0.00015842}, {316,0.00003960}, {317,0.00007921}, {318,0.00007921}, {319,0.00003960}, {320,0.00019802}, {321,0.00007921}, {322,0.00003960}, {323,0.00011881}, {324,0.00000000}, {325,0.00007921}, {326,0.00003960}, {327,0.00007921}, {328,0.00000000}, {329,0.00003960}, {330,0.00000000}, {331,0.00010891}, {332,0.00000000}, {333,0.00007921}, {334,0.00015842}, {335,0.00000000}, {336,0.00007921}, {337,0.00003960}, {338,0.00018812}, {339,0.00003960}, {340,0.00003960}, {341,0.00003960}, {342,0.00003960}, {343,0.00003960}, {344,0.00015842}, {345,0.00000000}, {346,0.00003960}, {347,0.00055446}, {348,0.00015842}, {349,0.00015842}, {350,0.00003960}, {351,0.00027723}, {352,0.00006931}, {353,0.00003960}, {354,0.00003960}, {355,0.00007921}, {356,0.00000000}, {357,0.00003960}, {358,0.00006931}, {359,0.00007921}, {360,0.00011881}, {361,0.00003960}, {362,0.00003960}, {363,0.00000000}, {364,0.00002970}, {365,0.00007921}, {366,0.00007921}, {367,0.00003960}, {368,0.00007921}, {369,0.00028713}, {370,0.00007921}, {371,0.00007921}, {372,0.00015842}, {373,0.00003960}, {374,0.00013861}, {375,0.00010891}, {376,0.00000000}, {377,0.00003960}, {378,0.00003960}, {379,0.00015842}, {380,0.00011881}, {381,0.00000000}, {382,0.00003960}, {383,0.00003960}, {384,0.00011881}, {385,0.00003960}, {386,0.00003960}, {387,0.00003960}, {388,0.00003960}, {389,0.00003960}, {390,0.00006931}, {391,0.00003960}, {392,0.00003960}, {393,0.00000000}, {394,0.00000000}, {395,0.00011881}, {396,0.00007921}, {397,0.00000000}, {398,0.00000000}, {399,0.00007921}, {400,0.00007921}, {401,0.00003960}, {402,0.00000000}, {403,0.00011881}, {404,0.00000000}, {405,0.00003960}, {406,0.00006931}, {407,0.00000000}, {408,0.00003960}, {409,0.00007921}, {410,0.00007921}, {411,0.00007921}, {412,0.00011881}, {413,0.00007921}, {414,0.00003960}, {415,0.00003960}, {416,0.00015842}, {417,0.00000000}, {418,0.00003960}, {419,0.00006931}, {420,0.00007921}, {421,0.00003960}, {422,0.00007921}, {423,0.00000000}, {424,0.00000000}, {425,0.00015842}, {426,0.00007921}, {427,0.00011881}, {428,0.00010891}, {429,0.00003960}, {430,0.00000000}, {431,0.00003960}, {432,0.00003960}, {433,0.00000000}, {434,0.00011881}, {435,0.00019802}, {436,0.00007921}, {437,0.00000000}, {438,0.00002970}, {439,0.00000000}, {440,0.00015842}, {441,0.00003960}, {442,0.00013861}, {443,0.00011881}, {444,0.00003960}, {445,0.00000000}, {446,0.00003960}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00011881}, {451,0.00000000}, {452,0.00000000}, {453,0.00003960}, {454,0.00007921}, {455,0.00003960}, {456,0.00000000}, {457,0.00003960}, {458,0.00007921}, {459,0.00006931}, {460,0.00003960}, {461,0.00003960}, {462,0.00007921}, {463,0.00003960}, {464,0.00007921}, {465,0.00002970}, {466,0.00007921}, {467,0.00011881}, {468,0.00000000}, {469,0.00011881}, {470,0.00003960}, {471,0.00007921}, {472,0.00015842}, {473,0.00000000}, {474,0.00010891}, {475,0.00007921}, {476,0.00003960}, {477,0.00007921}, {478,0.00007921}, {479,0.00007921}, {480,0.00007921}, {481,0.00007921}, {482,0.00003960}, {483,0.00007921}, {484,0.00000000}, {485,0.00014851}, {486,0.00011881}, {487,0.00007921}, {488,0.00007921}, {489,0.00003960}, {490,0.00000000}, {491,0.00010891}, {492,0.00003960}, {493,0.00013861}, {494,0.00007921}, {495,0.00000000}, {496,0.00000000}, {497,0.00007921}, {498,0.00003960}, {499,0.00003960}, {500,0.00003960}, {505,0.00007921}, {510,0.00003960}, {515,0.00011881}, {520,0.00003960}, {525,0.00014851}, {530,0.00000000}, {535,0.00007921}, {540,0.00011881}, {545,0.00015842}, {550,0.00007921}, {555,0.00000000}, {560,0.00002970}, {565,0.00007921}, {570,0.00007921}, {575,0.00006931}, {580,0.00011881}, {585,0.00007921}, {590,0.00007921}, {595,0.00011881}, {600,0.00003960}, {605,0.00003960}, {610,0.00007921}, {615,0.00003960}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00007921}, {640,0.00000000}, {645,0.00010891}, {650,0.00007921}, {655,0.00011881}, {660,0.00003960}, {665,0.00007921}, {670,0.00003960}, {675,0.00003960}, {680,0.00007921}, {685,0.00003960}, {690,0.00007921}, {695,0.00019802}, {700,0.00019802}, {705,0.00019802}, {710,0.00007921}, {715,0.00003960}, {720,0.00007921}, {725,0.00007921}, {730,0.00011881}, {735,0.00003960}, {740,0.00003960}, {745,0.00006931}, {750,0.00006931}, {755,0.00000000}, {760,0.00015842}, {765,0.00007921}, {770,0.00000000}, {775,0.00007921}, {780,0.00000000}, {785,0.00000000}, {790,0.00007921}, {795,0.00007921}, {800,0.00007921}, {805,0.00003960}, {810,0.00002970}, {815,0.00003960}, {820,0.00007921}, {825,0.00003960}, {830,0.00000000}, {835,0.00003960}, {840,0.00010891}, {845,0.00003960}, {850,0.00011881}, {855,0.00000000}, {860,0.00007921}, {865,0.00000000}, {870,0.00003960}, {875,0.00000000}, {880,0.00003960}, {885,0.00007921}, {890,0.00018812}, {895,0.00003960}, {900,0.00007921}, {905,0.00010891}, {910,0.00019802}, {915,0.00007921}, {920,0.00003960}, {925,0.00011881}, {930,0.00003960}, {935,0.00011881}, {940,0.00000000}, {945,0.00003960}, {950,0.00011881}, {955,0.00015842}, {960,0.00003960}, {965,0.00011881}, {970,0.00007921}, {975,0.00003960}, {980,0.00007921}, {985,0.00000000}, {990,0.00011881}, {995,0.00003960}, {1000,0.00006931}, {1010,0.00007921}, {1020,0.00003960}, {1030,0.00000000}, {1040,0.00027723}, {1050,0.00007921}, {1060,0.00011881}, {1070,0.00007921}, {1080,0.00011881}, {1090,0.00003960}, {1100,0.00011881}, {1110,0.00003960}, {1120,0.00011881}, {1130,0.00015842}, {1140,0.00000000}, {1150,0.00014851}, {1160,0.00007921}, {1170,0.00003960}, {1180,0.00018812}, {1190,0.00007921}, {1200,0.00003960}, {1210,0.00007921}, {1220,0.00011881}, {1230,0.00007921}, {1240,0.00000000}, {1250,0.00011881}, {1260,0.00000000}, {1270,0.00007921}, {1280,0.00007921}, {1290,0.00000000}, {1300,0.00023762}, {1310,0.00002970}, {1320,0.00003960}, {1330,0.00011881}, {1340,0.00007921}, {1350,0.00007921}, {1360,0.00011881}, {1370,0.00011881}, {1380,0.00015842}, {1390,0.00007921}, {1400,0.00007921}, {1410,0.00014851}, {1420,0.00011881}, {1430,0.00007921}, {1440,0.00003960}, {1450,0.00015842}, {1460,0.00010891}, {1470,0.00019802}, {1480,0.00015842}, {1490,0.00015842}, {1500,0.00011881}, {1510,0.00003960}, {1520,0.00011881}, {1530,0.00007921}, {1540,0.00011881}, {1550,0.00015842}, {1560,0.00011881}, {1570,0.00011881}, {1580,0.00010891}, {1590,0.00011881}, {1600,0.00013861}, {1610,0.00007921}, {1620,0.00011881}, {1630,0.00022772}, {1640,0.00027723}, {1650,0.00006931}, {1660,0.00002970}, {1670,0.00007921}, {1680,0.00003960}, {1690,0.00003960}, {1700,0.00007921}, {1710,0.00011881}, {1720,0.00015842}, {1730,0.00007921}, {1740,0.00003960}, {1750,0.00023762}, {1760,0.00011881}, {1770,0.00021782}, {1780,0.00011881}, {1790,0.00007921}, {1800,0.00007921}, {1810,0.00019802}, {1820,0.00007921}, {1830,0.00003960}, {1840,0.00009901}, {1850,0.00007921}, {1860,0.00010891}, {1870,0.00007921}, {1880,0.00003960}, {1890,0.00003960}, {1900,0.00003960}, {1910,0.00007921}, {1920,0.00011881}, {1930,0.00000000}, {1940,0.00007921}, {1950,0.00003960}, {1960,0.00011881}, {1970,0.00011881}, {1980,0.00010891}, {1990,0.00011881}, {2000,0.00015842}, {2050,0.00011881}, {2100,0.00011881}, {2150,0.00011881}, {2200,0.00003960}, {2250,0.00018812}, {2300,0.00007921}, {2350,0.00015842}, {2400,0.00007921}, {2450,0.00015842}, {2500,0.00011881}, {2550,0.00019802}, {2600,0.00000000}, {2650,0.00007921}, {2700,0.00007921}, {2750,0.00023762}, {2800,0.00015842}, {2850,0.00311881}, {2900,0.00006931}, {2950,0.00015842}, {3000,0.00003960}, {3050,0.00011881}, {3100,0.00015842}, {3150,0.00003960}, {3200,0.00015842}, {3250,0.00023762}, {3300,0.00000000}, {3350,0.00023762}, {3400,0.00015842}, {3450,0.00035644}, {3500,0.00007921}, {3550,0.00011881}, {3600,0.00007921}, {3650,0.00011881}, {3700,0.00014851}, {3750,0.00011881}, {3800,0.00023762}, {3850,0.00027723}, {3900,0.00011881}, {3950,0.00026733}, {4000,0.00000000}, {4050,0.00003960}, {4100,0.00018812}, {4150,0.00010891}, {4200,0.00000000}, {4250,0.00006931}, {4300,0.00011881}, {4350,0.00003960}, {4400,0.00018812}, {4450,0.00018812}, {4500,0.00019802}, {4550,0.00007921}, {4600,0.00019802}, {4650,0.00019802}, {4700,0.00014851}, {4750,0.00011881}, {4800,0.00007921}, {4850,0.00019802}, {4900,0.00011881}, {4950,0.00003960}, {5000,0.00031683}, {5050,0.00011881}, {5100,0.00019802}, {5150,0.00023762}, {5200,0.00011881}, {5250,0.00015842}, {5300,0.00022772}, {5350,0.00015842}, {5400,0.00011881}, {5450,0.00027723}, {5500,0.00015842}, {5550,0.00023762}, {5600,0.00027723}, {5650,0.00006931}, {5700,0.00023762}, {5750,0.00031683}, {5800,0.00007921}, {5850,0.00039604}, {5900,0.00014851}, {5950,0.00019802}, {6000,0.00007921}, {6050,0.0055714}, {6100,0.0078571}, {6150,0.0002286}, {6200,0.0003429}, {6250,0.0002286}, {6300,0.0008857}, {6350,0.0001143}, {6400,0.0003429}, {6450,0.0002857}, {6500,0.0001143}, {6550,0.0004571}, {6600,0.0003429}, {6650,0.0000000}, {6700,0.0005714}, {6750,0.0002286}, {6800,0.0001143}, {6850,0.0002286}, {6900,0.0002286}, {6950,0.0001143}, {7000,0.0002286}, {7050,0.0003429}, {7100,0.0000000}, {7150,0.0003429}, {7200,0.0002286}, {7250,0.0001143}, {7300,0.0003429}, {7350,0.0004571}, {7400,0.0002286}, {7450,0.0002286}, {7500,0.0001143}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0002286}, {7700,0.0001143}, {7750,0.0001143}, {7800,0.0002286}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0001143}, {8000,0.0004571}, {8050,0.0002286}, {8100,0.0000000}, {8150,0.0006857}, {8200,0.0001714}, {8250,0.0000000}, {8300,0.0001143}, {8350,0.0002286}, {8400,0.0003143}, {8450,0.0001143}, {8500,0.0002286}, {8550,0.0000000}, {8600,0.0001143}, {8650,0.0003429}, {8700,0.0002286}, {8750,0.0005714}, {8800,0.0002286}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0001143}, {9000,0.0001143}, {9050,0.0001143}, {9100,0.0001143}, {9150,0.0001143}, {9200,0.0002286}, {9250,0.0004571}, {9300,0.0022571}, {9350,0.0003429}, {9400,0.0002286}, {9450,0.0004286}, {9500,0.0003429}, {9550,0.0001143}, {9600,0.0001143}, {9650,0.0006857}, {9700,0.0002286}, {9750,0.0004571}, {9800,0.0004571}, {9850,0.0002286}, {9900,0.0002286}, {9950,0.0002286}, {10000,0.0003143}, {10100,0.0001143}, {10200,0.0003429}, {10300,0.0002286}, {10400,0.0002286}, {10500,0.0004571}, {10600,0.0002000}, {10700,0.0004571}, {10800,0.0002286}, {10900,0.0002286}, {11000,0.0002286}, {11100,0.0002000}, {11200,0.0001143}, {11300,0.0002286}, {11400,0.0002286}, {11500,0.0000000}, {11600,0.0001143}, {11700,0.0014571}, {11800,0.0000000}, {11900,0.0008000}, {12000,0.0001143}, {12100,0.0002286}, {12200,0.0003143}, {12300,0.0005714}, {12400,0.0001143}, {12500,0.0001143}, {12600,0.0007714}, {12700,0.0005714}, {12800,0.0001143}, {12900,0.0005143}, {13000,0.0003429}, {13100,0.0002286}, {13200,0.0001143}, {13300,0.0004571}, {13400,0.0003429}, {13500,0.0002286}, {13600,0.0002286}, {13700,0.0002286}, {13800,0.0004286}, {13900,0.0003429}, {14000,0.0000000}, {14100,0.0003429}, {14200,0.0001143}, {14300,0.0002286}, {14400,0.0004571}, {14500,0.0004571}, {14600,0.0002000}, {14700,0.0002286}, {14800,0.0011429}, {14900,0.0001143}, {15000,0.0010286}, {15100,0.0000000}, {15200,0.0002000}, {15300,0.0002286}, {15400,0.0005714}, {15500,0.0001143}, {15600,0.0019429}, {15700,0.0016000}, {15800,0.0005714}, {15900,0.0002286}, {16000,0.0012000}, {16100,0.0004571}, {16200,0.0001143}, {16300,0.0013714}, {16400,0.0016857}, {16500,0.0004571}, {16600,0.0012286}, {16700,0.0005714}, {16800,0.0003429}, {16900,0.0003429}, {17000,0.0005714}, {17100,0.0010286}, {17200,0.0004571}, {17300,0.0000000}, {17400,0.0002000}, {17500,0.0002286}, {17600,0.0004571}, {17700,0.0004571}, {17800,0.0001143}, {17900,0.0008000}, {18000,0.0014857}, {18100,0.0023714}, {18200,0.0021714}, {18300,0.0011429}, {18400,0.0013143}, {18500,0.0011429}, {18600,0.0014857}, {18700,0.0008000}, {18800,0.0009143}, {18900,0.0001143}, {19000,0.0011429}, {19100,0.0004571}, {19200,0.0009143}, {19300,0.0003143}, {19400,0.0014857}, {19500,0.0013429}, {19600,0.0014857}, {19700,0.0011429}, {19800,0.0021714}, {19900,0.0024000}, {20000,0.0019429}};
data["big_flat"]["LtacTCGallinaCtx"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00004950}, {8,0.00098020}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00114851}, {16,0.00139604}, {17,0.00200000}, {18,0.00200000}, {19,0.00223762}, {20,0.00200000}, {21,0.00200000}, {22,0.00207921}, {23,0.00220792}, {24,0.00246535}, {25,0.00299010}, {26,0.00300000}, {27,0.00300000}, {28,0.00300000}, {29,0.00300990}, {30,0.00305941}, {31,0.00332673}, {32,0.00440594}, {33,0.00380198}, {34,0.00400000}, {35,0.00400000}, {36,0.00400000}, {37,0.00600000}, {38,0.00419802}, {39,0.00431683}, {40,0.00427723}, {41,0.00475248}, {42,0.00500000}, {43,0.00500000}, {44,0.00500000}, {45,0.00508911}, {46,0.00511881}, {47,0.00533663}, {48,0.00537624}, {49,0.00561386}, {50,0.00591089}, {51,0.00600000}, {52,0.00600990}, {53,0.00618812}, {54,0.00640594}, {55,0.00620792}, {56,0.00627723}, {57,0.00647525}, {58,0.00687129}, {59,0.00700990}, {60,0.00703960}, {61,0.00729703}, {62,0.00719802}, {63,0.00712871}, {64,0.00726733}, {65,0.00754455}, {66,0.00771287}, {67,0.01038614}, {68,0.00810891}, {69,0.00819802}, {70,0.00817822}, {71,0.00832673}, {72,0.00828713}, {73,0.00852475}, {74,0.00866337}, {75,0.01077228}, {76,0.00912871}, {77,0.00915842}, {78,0.00920792}, {79,0.00924752}, {80,0.00913861}, {81,0.00937624}, {82,0.00955446}, {83,0.01005941}, {84,0.01005941}, {85,0.01018812}, {86,0.01016832}, {87,0.01031683}, {88,0.01020792}, {89,0.01121782}, {90,0.01335644}, {91,0.01098020}, {92,0.01110891}, {93,0.01120792}, {94,0.01123762}, {95,0.01129703}, {96,0.01126733}, {97,0.01151485}, {98,0.01149505}, {99,0.01187129}, {100,0.01205941}, {101,0.01230693}, {102,0.01558416}, {103,0.01394059}, {104,0.01217822}, {105,0.01239604}, {106,0.01255446}, {107,0.01303960}, {108,0.01302970}, {109,0.01326733}, {110,0.01318812}, {111,0.01335644}, {112,0.01494059}, {113,0.01327723}, {114,0.01348515}, {115,0.01397030}, {116,0.01407921}, {117,0.01858416}, {118,0.01415842}, {119,0.01435644}, {120,0.01438614}, {121,0.01444554}, {122,0.01443564}, {123,0.01485149}, {124,0.01506931}, {125,0.01515842}, {126,0.01516832}, {127,0.01518812}, {128,0.01528713}, {129,0.01532673}, {130,0.01543564}, {131,0.01575248}, {132,0.01572277}, {133,0.01625743}, {134,0.01626733}, {135,0.01624752}, {136,0.01634653}, {137,0.01922772}, {138,0.01638614}, {139,0.01685149}, {140,0.01676238}, {141,0.01718812}, {142,0.01719802}, {143,0.01730693}, {144,0.01818812}, {145,0.01751485}, {146,0.01983168}, {147,0.01772277}, {148,0.02021782}, {149,0.01809901}, {150,0.01950495}, {151,0.01854455}, {152,0.01821782}, {153,0.01850495}, {154,0.01865347}, {155,0.01870297}, {156,0.01892079}, {157,0.02165347}, {158,0.01929703}, {159,0.01951485}, {160,0.02555446}, {161,0.01943564}, {162,0.01945545}, {163,0.01972277}, {164,0.01982178}, {165,0.02014851}, {166,0.02028713}, {167,0.02032673}, {168,0.02030693}, {169,0.02591089}, {170,0.02059406}, {171,0.02092079}, {172,0.02090099}, {173,0.02830693}, {174,0.02126733}, {175,0.02143564}, {176,0.02117822}, {177,0.02601980}, {178,0.02161386}, {179,0.02171287}, {180,0.02171287}, {181,0.02200990}, {182,0.02355446}, {183,0.02796040}, {184,0.02238614}, {185,0.02250495}, {186,0.02266337}, {187,0.02281188}, {188,0.02259406}, {189,0.02316832}, {190,0.02314851}, {191,0.02421782}, {192,0.02563366}, {193,0.02744554}, {194,0.02892079}, {195,0.02994059}, {196,0.03068317}, {197,0.03128713}, {198,0.03123762}, {199,0.03135644}, {200,0.03106931}, {201,0.03020792}, {202,0.02904950}, {203,0.02839604}, {204,0.02680198}, {205,0.02482178}, {206,0.02517822}, {207,0.02528713}, {208,0.02528713}, {209,0.02546535}, {210,0.02553465}, {211,0.02577228}, {212,0.03720792}, {213,0.03066337}, {214,0.02598020}, {215,0.02637624}, {216,0.02628713}, {217,0.02646535}, {218,0.03320792}, {219,0.02787129}, {220,0.02659406}, {221,0.02701980}, {222,0.02713861}, {223,0.03021782}, {224,0.02699010}, {225,0.02734653}, {226,0.03679208}, {227,0.02884158}, {228,0.02764356}, {229,0.02787129}, {230,0.03124752}, {231,0.02843564}, {232,0.02832673}, {233,0.03166337}, {234,0.02850495}, {235,0.02887129}, {236,0.02995050}, {237,0.02926733}, {238,0.03600990}, {239,0.02933663}, {240,0.02921782}, {241,0.02940594}, {242,0.02964356}, {243,0.03356436}, {244,0.02990099}, {245,0.03599010}, {246,0.03010891}, {247,0.03745545}, {248,0.03024752}, {249,0.03881188}, {250,0.03065347}, {251,0.03807921}, {252,0.03104950}, {253,0.03627723}, {254,0.03122772}, {255,0.03270297}, {256,0.03124752}, {257,0.03135644}, {258,0.04040594}, {259,0.03163366}, {260,0.03470297}, {261,0.03188119}, {262,0.03190099}, {263,0.03906931}, {264,0.03218812}, {265,0.03250495}, {266,0.03967327}, {267,0.03298020}, {268,0.03289109}, {269,0.03871287}, {270,0.03326733}, {271,0.03348515}, {272,0.03503960}, {273,0.04478218}, {274,0.03396040}, {275,0.03379208}, {276,0.03505941}, {277,0.04167327}, {278,0.03432673}, {279,0.03453465}, {280,0.03419802}, {281,0.03683168}, {282,0.04142574}, {283,0.04670297}, {284,0.03536634}, {285,0.03512871}, {286,0.03528713}, {287,0.03536634}, {288,0.03703960}, {289,0.03979208}, {290,0.04278218}, {291,0.04526733}, {292,0.04622772}, {293,0.03607921}, {294,0.03637624}, {295,0.03649505}, {296,0.03674257}, {297,0.03669307}, {298,0.03690099}, {299,0.03684158}, {300,0.03688119}, {301,0.03706931}, {302,0.03758416}, {303,0.03747525}, {304,0.03760396}, {305,0.03787129}, {306,0.05370297}, {307,0.04767327}, {308,0.04564356}, {309,0.04331683}, {310,0.04070297}, {311,0.03843564}, {312,0.03861386}, {313,0.03881188}, {314,0.03896040}, {315,0.05000000}, {316,0.04532673}, {317,0.04110891}, {318,0.03933663}, {319,0.03990099}, {320,0.05111881}, {321,0.04556436}, {322,0.04092079}, {323,0.03963366}, {324,0.04002970}, {325,0.04788119}, {326,0.04239604}, {327,0.04066337}, {328,0.04023762}, {329,0.04625743}, {330,0.04064356}, {331,0.04114851}, {332,0.05206931}, {333,0.04127723}, {334,0.04160396}, {335,0.04919802}, {336,0.04101980}, {337,0.04203960}, {338,0.04652475}, {339,0.04162376}, {340,0.05114851}, {341,0.04264356}, {342,0.04204950}, {343,0.04571287}, {344,0.04244554}, {345,0.04853465}, {346,0.04317822}, {347,0.05049505}, {348,0.04309901}, {349,0.05098020}, {350,0.04331683}, {351,0.05097030}, {352,0.04328713}, {353,0.04967327}, {354,0.04362376}, {355,0.04810891}, {356,0.04396040}, {357,0.04682178}, {358,0.06188119}, {359,0.04470297}, {360,0.05213861}, {361,0.04496040}, {362,0.04703960}, {363,0.05749505}, {364,0.04488119}, {365,0.04958416}, {366,0.05829703}, {367,0.04549505}, {368,0.04887129}, {369,0.05679208}, {370,0.04563366}, {371,0.04746535}, {372,0.05387129}, {373,0.04642574}, {374,0.04634653}, {375,0.04937624}, {376,0.05494059}, {377,0.04675248}, {378,0.04676238}, {379,0.04710891}, {380,0.05510891}, {381,0.06207921}, {382,0.04737624}, {383,0.04739604}, {384,0.04698020}, {385,0.04909901}, {386,0.05369307}, {387,0.05637624}, {388,0.06045545}, {389,0.04800990}, {390,0.04828713}, {391,0.04849505}, {392,0.04847525}, {393,0.04833663}, {394,0.05056436}, {395,0.05220792}, {396,0.05305941}, {397,0.05429703}, {398,0.05492079}, {399,0.05732673}, {400,0.05871287}, {401,0.05718812}, {402,0.05684158}, {403,0.05672277}, {404,0.05609901}, {405,0.05479208}, {406,0.05388119}, {407,0.05248515}, {408,0.05060396}, {409,0.05054455}, {410,0.05095050}, {411,0.05096040}, {412,0.06517822}, {413,0.06282178}, {414,0.05971287}, {415,0.05631683}, {416,0.05274257}, {417,0.05172277}, {418,0.05179208}, {419,0.06737624}, {420,0.06174257}, {421,0.05671287}, {422,0.05226733}, {423,0.05253465}, {424,0.06547525}, {425,0.05945545}, {426,0.05330693}, {427,0.05335644}, {428,0.06451485}, {429,0.05813861}, {430,0.05332673}, {431,0.06815842}, {432,0.05990099}, {433,0.05335644}, {434,0.05358416}, {435,0.06557426}, {436,0.05432673}, {437,0.07075248}, {438,0.06098020}, {439,0.05453465}, {440,0.06624752}, {441,0.05631683}, {442,0.07103960}, {443,0.06047525}, {444,0.05516832}, {445,0.06363366}, {446,0.05531683}, {447,0.06550495}, {448,0.05510891}, {449,0.06624752}, {450,0.05560396}, {451,0.07324752}, {452,0.05622772}, {453,0.07004950}, {454,0.05667327}, {455,0.06885149}, {456,0.05621782}, {457,0.06565347}, {458,0.05689109}, {459,0.06186139}, {460,0.07202970}, {461,0.05699010}, {462,0.06744554}, {463,0.05809901}, {464,0.06089109}, {465,0.07011881}, {466,0.05760396}, {467,0.06655446}, {468,0.07594059}, {469,0.05858416}, {470,0.06363366}, {471,0.07278218}, {472,0.05824752}, {473,0.06099010}, {474,0.06820792}, {475,0.07379208}, {476,0.05919802}, {477,0.06189109}, {478,0.06758416}, {479,0.07239604}, {480,0.05943564}, {481,0.05950495}, {482,0.06569307}, {483,0.07028713}, {484,0.07429703}, {485,0.07802970}, {486,0.06066337}, {487,0.06106931}, {488,0.06377228}, {489,0.06732673}, {490,0.06978218}, {491,0.07227723}, {492,0.07415842}, {493,0.08036634}, {494,0.08622772}, {495,0.06178218}, {496,0.06154455}, {497,0.06205941}, {498,0.06165347}, {499,0.06246535}, {500,0.06239604}, {505,0.06313861}, {510,0.06397030}, {515,0.06390099}, {520,0.07931683}, {525,0.07647525}, {530,0.07326733}, {535,0.06670297}, {540,0.08262376}, {545,0.07341584}, {550,0.08760396}, {555,0.07668317}, {560,0.08652475}, {565,0.07451485}, {570,0.08261386}, {575,0.09024752}, {580,0.07306931}, {585,0.08259406}, {590,0.08546535}, {595,0.08891089}, {600,0.08996040}, {605,0.09025743}, {610,0.08929703}, {615,0.08808911}, {620,0.08524752}, {625,0.08415842}, {630,0.10571287}, {635,0.09599010}, {640,0.08632673}, {645,0.10219802}, {650,0.09202970}, {655,0.08247525}, {660,0.09283168}, {665,0.11279208}, {670,0.09086139}, {675,0.09945545}, {680,0.10521782}, {685,0.08760396}, {690,0.09158416}, {695,0.09508911}, {700,0.10211881}, {705,0.09888119}, {710,0.10009901}, {715,0.09799010}, {720,0.09402970}, {725,0.11391089}, {730,0.10923762}, {735,0.10948515}, {740,0.09717822}, {745,0.11334653}, {750,0.10251485}, {755,0.11474257}, {760,0.10314851}, {765,0.11663366}, {770,0.12540594}, {775,0.10890099}, {780,0.11461386}, {785,0.12034653}, {790,0.13909901}, {795,0.10847525}, {800,0.10846535}, {805,0.11140594}, {810,0.11123762}, {815,0.11043564}, {820,0.14141584}, {825,0.13049505}, {830,0.12474257}, {835,0.11701980}, {840,0.13213861}, {845,0.13515842}, {850,0.11878218}, {855,0.13051485}, {860,0.11819802}, {865,0.12789109}, {870,0.11755446}, {875,0.12408911}, {880,0.12996040}, {885,0.13597030}, {890,0.15606931}, {895,0.12421782}, {900,0.12389109}, {905,0.12462376}, {910,0.12468317}, {915,0.13047525}, {920,0.12347525}, {925,0.14403960}, {930,0.13605941}, {935,0.13262376}, {940,0.12800990}, {945,0.13474257}, {950,0.13320792}, {955,0.14390099}, {960,0.14082178}, {965,0.14797030}, {970,0.13241584}, {975,0.13961386}, {980,0.14540594}, {985,0.15756436}, {990,0.13733663}, {995,0.13864356}, {1000,0.13575248}, {1010,0.14685149}, {1020,0.14464356}, {1030,0.14026733}, {1040,0.17268317}, {1050,0.15492079}, {1060,0.14460396}, {1070,0.15557426}, {1080,0.16907921}, {1090,0.15045545}, {1100,0.15476238}, {1110,0.16601980}, {1120,0.15814851}, {1130,0.15521782}, {1140,0.17286139}, {1150,0.17144554}, {1160,0.17969307}, {1170,0.16810891}, {1180,0.18367327}, {1190,0.18643564}, {1200,0.16556436}, {1210,0.17484158}, {1220,0.17250495}, {1230,0.19188119}, {1240,0.19223762}, {1250,0.18069307}, {1260,0.19377228}, {1270,0.18734653}, {1280,0.18964356}, {1290,0.21774257}, {1300,0.18475248}, {1310,0.18645545}, {1320,0.18982178}, {1330,0.21095050}, {1340,0.20166337}, {1350,0.20159406}, {1360,0.21040594}, {1370,0.21628713}, {1380,0.21355446}, {1390,0.19513861}, {1400,0.20356436}, {1410,0.20116832}, {1420,0.19651485}, {1430,0.20367327}, {1440,0.21803960}, {1450,0.22079208}, {1460,0.20675248}, {1470,0.23420792}, {1480,0.22745545}, {1490,0.21171287}, {1500,0.21973267}, {1510,0.21928713}, {1520,0.22516832}, {1530,0.21798020}, {1540,0.25216832}, {1550,0.23316832}, {1560,0.22028713}, {1570,0.23809901}, {1580,0.22418812}, {1590,0.23220792}, {1600,0.23420792}, {1610,0.24661386}, {1620,0.24081188}, {1630,0.25008911}, {1640,0.23612871}, {1650,0.26141584}, {1660,0.24588119}, {1670,0.26524752}, {1680,0.24415842}, {1690,0.26189109}, {1700,0.25742574}, {1710,0.27208911}, {1720,0.26199010}, {1730,0.27089109}, {1740,0.25770297}, {1750,0.25791089}, {1760,0.26520792}, {1770,0.26421782}, {1780,0.26400000}, {1790,0.27806931}, {1800,0.26252475}, {1810,0.26096040}, {1820,0.27030693}, {1830,0.26229703}, {1840,0.28952475}, {1850,0.27670297}, {1860,0.27404950}, {1870,0.30817822}, {1880,0.27244554}, {1890,0.28927723}, {1900,0.28393069}, {1910,0.29151485}, {1920,0.28500000}, {1930,0.29091089}, {1940,0.29435644}, {1950,0.28142574}, {1960,0.29018812}, {1970,0.28219802}, {1980,0.29405941}, {1990,0.30928713}, {2000,0.30351485}, {2050,0.31051485}, {2100,0.32953465}, {2150,0.31947525}, {2200,0.34065347}, {2250,0.36202970}, {2300,0.34380198}, {2350,0.35618812}, {2400,0.37661386}, {2450,0.38901980}, {2500,0.37153465}, {2550,0.38218812}, {2600,0.40320792}, {2650,0.41816832}, {2700,0.41459406}, {2750,0.43768317}, {2800,0.42331683}, {2850,0.43230693}, {2900,0.43097030}, {2950,0.44386139}, {3000,0.46300000}, {3050,0.47160396}, {3100,0.46568317}, {3150,0.47527723}, {3200,0.48896040}, {3250,0.48487129}, {3300,0.50279208}, {3350,0.51429703}, {3400,0.51023762}, {3450,0.52424752}, {3500,0.53757426}, {3550,0.54872277}, {3600,0.53665347}, {3650,0.55051485}, {3700,0.56920792}, {3750,0.58687129}, {3800,0.59737624}, {3850,0.59352475}, {3900,0.59496040}, {3950,0.59998020}, {4000,0.62326733}, {4050,0.64474257}, {4100,0.62262376}, {4150,0.64169307}, {4200,0.64053465}, {4250,0.67322772}, {4300,0.66763366}, {4350,0.67939604}, {4400,0.69454455}, {4450,0.68657426}, {4500,0.68688119}, {4550,0.71940594}, {4600,0.71912871}, {4650,0.73386139}, {4700,0.73001980}, {4750,0.73050495}, {4800,0.77200000}, {4850,0.74445545}, {4900,0.78393069}, {4950,0.77545545}, {5000,0.78760396}, {5050,0.78819802}, {5100,0.81699010}, {5150,0.80522772}, {5200,0.87676238}, {5250,0.81984158}, {5300,0.82150495}, {5350,0.85283168}, {5400,0.83413861}, {5450,0.84976238}, {5500,0.87177228}, {5550,0.87254455}, {5600,0.86860396}, {5650,0.88639604}, {5700,0.87729703}, {5750,0.89764356}, {5800,0.92292079}, {5850,0.93908911}, {5900,0.92054455}, {5950,0.93499010}, {6000,0.94954455}, {6050,0.9790286}, {6100,1.0014286}, {6150,1.0065429}, {6200,1.0047429}, {6250,1.0199429}, {6300,1.0246000}, {6350,1.0442571}, {6400,1.0326857}, {6450,1.0640000}, {6500,1.0789143}, {6550,1.0892857}, {6600,1.1075429}, {6650,1.0834571}, {6700,1.0799143}, {6750,1.1062286}, {6800,1.0968000}, {6850,1.1216857}, {6900,1.1218000}, {6950,1.1358000}, {7000,1.1698571}, {7050,1.1858000}, {7100,1.1740286}, {7150,1.1834571}, {7200,1.1886857}, {7250,1.1819429}, {7300,1.2049429}, {7350,1.2087143}, {7400,1.2109143}, {7450,1.2021429}, {7500,1.2055429}, {7550,1.2453714}, {7600,1.2770286}, {7650,1.2920286}, {7700,1.2657714}, {7750,1.2979714}, {7800,1.2734571}, {7850,1.2777143}, {7900,1.3250571}, {7950,1.3359429}, {8000,1.3135429}, {8050,1.3325714}, {8100,1.3120000}, {8150,1.3500857}, {8200,1.3579143}, {8250,1.3555429}, {8300,1.3545429}, {8350,1.3502857}, {8400,1.3855143}, {8450,1.3975143}, {8500,1.3929714}, {8550,1.3976571}, {8600,1.4571429}, {8650,1.4323429}, {8700,1.4370857}, {8750,1.4746286}, {8800,1.4319143}, {8850,1.4459714}, {8900,1.4631714}, {8950,1.4938286}, {9000,1.4596286}, {9050,1.4960857}, {9100,1.5150286}, {9150,1.5115714}, {9200,1.5374000}, {9250,1.5170000}, {9300,1.5133714}, {9350,1.5629429}, {9400,1.5549429}, {9450,1.5623429}, {9500,1.5934571}, {9550,1.5781143}, {9600,1.5873429}, {9650,1.5932000}, {9700,1.6421714}, {9750,1.5992000}, {9800,1.6453143}, {9850,1.6322857}, {9900,1.6661714}, {9950,1.6668286}, {10000,1.6834000}, {10100,1.6594857}, {10200,1.7071429}, {10300,1.6962000}, {10400,1.7356000}, {10500,1.7028000}, {10600,1.7677429}, {10700,1.7602286}, {10800,1.7892000}, {10900,1.7672571}, {11000,1.8177429}, {11100,1.8258571}, {11200,1.8472286}, {11300,1.8393143}, {11400,1.8627143}, {11500,1.8618857}, {11600,1.9038286}, {11700,2.0946000}, {11800,1.9203714}, {11900,2.0478571}, {12000,1.9751429}, {12100,1.9818571}, {12200,2.0204000}, {12300,2.0145714}, {12400,2.0165714}, {12500,2.0681429}, {12600,2.0703143}, {12700,2.0925143}, {12800,2.0655714}, {12900,2.1164000}, {13000,2.1288000}, {13100,2.1622857}, {13200,2.1630000}, {13300,2.1897143}, {13400,2.1748857}, {13500,2.2157714}, {13600,2.2106000}, {13700,2.2457714}, {13800,2.2594286}, {13900,2.2989429}, {14000,2.3043714}, {14100,2.3296000}, {14200,2.3626286}, {14300,2.3685143}, {14400,2.3365143}, {14500,2.3942000}, {14600,2.3605143}, {14700,2.4189143}, {14800,2.4225143}, {14900,2.4097714}, {15000,2.4462000}, {15100,2.4990571}, {15200,2.4918000}, {15300,2.5890000}, {15400,2.5044286}, {15500,2.6058000}, {15600,2.5603143}, {15700,2.5508000}, {15800,2.5901429}, {15900,2.6006286}, {16000,2.6610000}, {16100,2.6621429}, {16200,2.6543714}, {16300,2.6770571}, {16400,2.6359714}, {16500,2.6601143}, {16600,2.7050286}, {16700,2.8252000}, {16800,2.7261143}, {16900,2.7388857}, {17000,2.7680000}, {17100,2.8119429}, {17200,2.8901143}, {17300,2.8036286}, {17400,2.8748000}, {17500,2.8593714}, {17600,2.8649143}, {17700,2.8896000}, {17800,2.8846857}, {17900,2.9504000}, {18000,2.9266571}, {18100,2.9956857}, {18200,2.9708286}, {18300,3.0198571}, {18400,3.0309429}, {18500,3.0230571}, {18600,3.0210000}, {18700,3.0649143}, {18800,3.0829143}, {18900,3.1337429}, {19000,3.3729714}, {19100,3.1637429}, {19200,3.1379429}, {19300,3.2552286}, {19400,3.4134571}, {19500,3.2977429}, {19600,3.2880000}, {19700,3.2459714}, {19800,3.4277429}, {19900,3.4287714}, {20000,3.3078571}};
data["big_flat"]["LtacTCGallinaCtx"]["actual reif"]["user"] = {{1,0.00006931}, {2,0.00009901}, {3,0.00044554}, {4,0.00028713}, {5,0.00072277}, {6,0.00071287}, {7,0.00070297}, {8,0.00071287}, {9,0.00083168}, {10,0.00139604}, {11,0.00137624}, {12,0.00095050}, {13,0.00149505}, {14,0.00138614}, {15,0.00176238}, {16,0.00168317}, {17,0.00194059}, {18,0.00176238}, {19,0.00271287}, {20,0.00231683}, {21,0.00227723}, {22,0.00247525}, {23,0.00249505}, {24,0.00223762}, {25,0.00272277}, {26,0.00302970}, {27,0.00300990}, {28,0.00321782}, {29,0.00335644}, {30,0.00326733}, {31,0.00333663}, {32,0.00440594}, {33,0.00378218}, {34,0.00367327}, {35,0.00394059}, {36,0.00399010}, {37,0.00645545}, {38,0.00442574}, {39,0.00446535}, {40,0.00474257}, {41,0.00432673}, {42,0.00480198}, {43,0.00496040}, {44,0.00470297}, {45,0.00533663}, {46,0.00534653}, {47,0.00567327}, {48,0.00594059}, {49,0.00578218}, {50,0.00581188}, {51,0.00560396}, {52,0.00619802}, {53,0.00647525}, {54,0.00681188}, {55,0.00645545}, {56,0.00677228}, {57,0.00675248}, {58,0.00750495}, {59,0.00697030}, {60,0.00726733}, {61,0.00726733}, {62,0.00711881}, {63,0.00737624}, {64,0.00756436}, {65,0.00774257}, {66,0.00773267}, {67,0.01034653}, {68,0.00802970}, {69,0.00823762}, {70,0.00833663}, {71,0.00840594}, {72,0.00849505}, {73,0.00866337}, {74,0.00887129}, {75,0.01120792}, {76,0.00882178}, {77,0.00886139}, {78,0.00929703}, {79,0.00922772}, {80,0.00980198}, {81,0.00954455}, {82,0.00926733}, {83,0.00984158}, {84,0.01018812}, {85,0.01019802}, {86,0.01041584}, {87,0.01054455}, {88,0.01051485}, {89,0.01167327}, {90,0.01404950}, {91,0.01100990}, {92,0.01109901}, {93,0.01118812}, {94,0.01141584}, {95,0.01139604}, {96,0.01129703}, {97,0.01192079}, {98,0.01197030}, {99,0.01196040}, {100,0.01222772}, {101,0.01254455}, {102,0.01595050}, {103,0.01367327}, {104,0.01205941}, {105,0.01286139}, {106,0.01286139}, {107,0.01313861}, {108,0.01300000}, {109,0.01341584}, {110,0.01351485}, {111,0.01381188}, {112,0.01540594}, {113,0.01343564}, {114,0.01348515}, {115,0.01438614}, {116,0.01454455}, {117,0.01822772}, {118,0.01447525}, {119,0.01493069}, {120,0.01478218}, {121,0.01475248}, {122,0.01484158}, {123,0.01504950}, {124,0.01531683}, {125,0.01549505}, {126,0.01555446}, {127,0.01569307}, {128,0.01566337}, {129,0.01585149}, {130,0.01584158}, {131,0.01608911}, {132,0.01596040}, {133,0.01646535}, {134,0.01661386}, {135,0.01640594}, {136,0.01676238}, {137,0.01899010}, {138,0.01685149}, {139,0.01727723}, {140,0.01718812}, {141,0.01723762}, {142,0.01720792}, {143,0.01725743}, {144,0.01788119}, {145,0.01741584}, {146,0.01951485}, {147,0.01735644}, {148,0.01973267}, {149,0.01784158}, {150,0.01913861}, {151,0.01783168}, {152,0.01793069}, {153,0.01818812}, {154,0.01857426}, {155,0.01841584}, {156,0.01842574}, {157,0.02150495}, {158,0.01900000}, {159,0.01947525}, {160,0.02574257}, {161,0.01889109}, {162,0.01907921}, {163,0.01937624}, {164,0.01961386}, {165,0.01976238}, {166,0.01997030}, {167,0.01995050}, {168,0.01983168}, {169,0.02582178}, {170,0.02029703}, {171,0.02062376}, {172,0.02062376}, {173,0.02782178}, {174,0.02117822}, {175,0.02101980}, {176,0.02072277}, {177,0.02580198}, {178,0.02152475}, {179,0.02161386}, {180,0.02161386}, {181,0.02221782}, {182,0.02366337}, {183,0.02797030}, {184,0.02221782}, {185,0.02264356}, {186,0.02259406}, {187,0.02305941}, {188,0.02242574}, {189,0.02310891}, {190,0.02285149}, {191,0.02423762}, {192,0.02557426}, {193,0.02715842}, {194,0.02886139}, {195,0.02995050}, {196,0.03089109}, {197,0.03169307}, {198,0.03163366}, {199,0.03157426}, {200,0.03129703}, {201,0.03000990}, {202,0.02865347}, {203,0.02835644}, {204,0.02636634}, {205,0.02505941}, {206,0.02502970}, {207,0.02524752}, {208,0.02537624}, {209,0.02576238}, {210,0.02520792}, {211,0.02588119}, {212,0.03693069}, {213,0.03079208}, {214,0.02607921}, {215,0.02646535}, {216,0.02616832}, {217,0.02622772}, {218,0.03321782}, {219,0.02788119}, {220,0.02675248}, {221,0.02681188}, {222,0.02679208}, {223,0.03049505}, {224,0.02683168}, {225,0.02719802}, {226,0.03651485}, {227,0.02875248}, {228,0.02772277}, {229,0.02792079}, {230,0.03163366}, {231,0.02858416}, {232,0.02818812}, {233,0.03182178}, {234,0.02858416}, {235,0.02862376}, {236,0.02989109}, {237,0.02886139}, {238,0.03595050}, {239,0.02929703}, {240,0.02880198}, {241,0.02962376}, {242,0.02963366}, {243,0.03386139}, {244,0.02959406}, {245,0.03619802}, {246,0.02995050}, {247,0.03730693}, {248,0.02963366}, {249,0.03860396}, {250,0.03070297}, {251,0.03774257}, {252,0.03118812}, {253,0.03611881}, {254,0.03116832}, {255,0.03243564}, {256,0.03085149}, {257,0.03092079}, {258,0.03987129}, {259,0.03177228}, {260,0.03447525}, {261,0.03198020}, {262,0.03172277}, {263,0.03884158}, {264,0.03243564}, {265,0.03243564}, {266,0.03938614}, {267,0.03300000}, {268,0.03293069}, {269,0.03828713}, {270,0.03333663}, {271,0.03360396}, {272,0.03508911}, {273,0.04478218}, {274,0.03373267}, {275,0.03371287}, {276,0.03532673}, {277,0.04087129}, {278,0.03426733}, {279,0.03513861}, {280,0.03423762}, {281,0.03675248}, {282,0.04105941}, {283,0.04693069}, {284,0.03517822}, {285,0.03507921}, {286,0.03565347}, {287,0.03574257}, {288,0.03683168}, {289,0.03933663}, {290,0.04250495}, {291,0.04480198}, {292,0.04625743}, {293,0.03609901}, {294,0.03637624}, {295,0.03631683}, {296,0.03672277}, {297,0.03667327}, {298,0.03683168}, {299,0.03701980}, {300,0.03714851}, {301,0.03708911}, {302,0.03757426}, {303,0.03767327}, {304,0.03758416}, {305,0.03761386}, {306,0.05356436}, {307,0.04762376}, {308,0.04535644}, {309,0.04346535}, {310,0.04023762}, {311,0.03819802}, {312,0.03828713}, {313,0.03845545}, {314,0.03879208}, {315,0.04952475}, {316,0.04548515}, {317,0.04091089}, {318,0.03908911}, {319,0.03978218}, {320,0.05050495}, {321,0.04539604}, {322,0.04035644}, {323,0.03902970}, {324,0.03968317}, {325,0.04798020}, {326,0.04225743}, {327,0.04038614}, {328,0.03967327}, {329,0.04600990}, {330,0.04033663}, {331,0.04073267}, {332,0.05173267}, {333,0.04092079}, {334,0.04083168}, {335,0.04894059}, {336,0.04047525}, {337,0.04194059}, {338,0.04639604}, {339,0.04131683}, {340,0.05060396}, {341,0.04241584}, {342,0.04219802}, {343,0.04572277}, {344,0.04220792}, {345,0.04853465}, {346,0.04316832}, {347,0.04979208}, {348,0.04298020}, {349,0.05060396}, {350,0.04308911}, {351,0.05073267}, {352,0.04275248}, {353,0.04968317}, {354,0.04328713}, {355,0.04842574}, {356,0.04400990}, {357,0.04706931}, {358,0.06208911}, {359,0.04441584}, {360,0.05190099}, {361,0.04480198}, {362,0.04704950}, {363,0.05725743}, {364,0.04482178}, {365,0.04973267}, {366,0.05809901}, {367,0.04510891}, {368,0.04879208}, {369,0.05644554}, {370,0.04573267}, {371,0.04743564}, {372,0.05331683}, {373,0.04684158}, {374,0.04630693}, {375,0.04934653}, {376,0.05475248}, {377,0.04682178}, {378,0.04696040}, {379,0.04728713}, {380,0.05483168}, {381,0.06198020}, {382,0.04756436}, {383,0.04757426}, {384,0.04743564}, {385,0.04920792}, {386,0.05353465}, {387,0.05612871}, {388,0.06051485}, {389,0.04810891}, {390,0.04840594}, {391,0.04887129}, {392,0.04893069}, {393,0.04858416}, {394,0.05058416}, {395,0.05184158}, {396,0.05311881}, {397,0.05403960}, {398,0.05493069}, {399,0.05726733}, {400,0.05865347}, {401,0.05683168}, {402,0.05698020}, {403,0.05662376}, {404,0.05584158}, {405,0.05456436}, {406,0.05356436}, {407,0.05235644}, {408,0.05040594}, {409,0.05048515}, {410,0.05101980}, {411,0.05103960}, {412,0.06476238}, {413,0.06278218}, {414,0.05959406}, {415,0.05628713}, {416,0.05249505}, {417,0.05159406}, {418,0.05188119}, {419,0.06685149}, {420,0.06168317}, {421,0.05659406}, {422,0.05218812}, {423,0.05241584}, {424,0.06546535}, {425,0.05972277}, {426,0.05316832}, {427,0.05286139}, {428,0.06419802}, {429,0.05833663}, {430,0.05295050}, {431,0.06779208}, {432,0.06017822}, {433,0.05318812}, {434,0.05361386}, {435,0.06542574}, {436,0.05395050}, {437,0.07103960}, {438,0.06124752}, {439,0.05413861}, {440,0.06579208}, {441,0.05610891}, {442,0.07086139}, {443,0.06058416}, {444,0.05491089}, {445,0.06367327}, {446,0.05504950}, {447,0.06530693}, {448,0.05498020}, {449,0.06605941}, {450,0.05525743}, {451,0.07321782}, {452,0.05601980}, {453,0.07015842}, {454,0.05616832}, {455,0.06819802}, {456,0.05620792}, {457,0.06542574}, {458,0.05657426}, {459,0.06200990}, {460,0.07187129}, {461,0.05684158}, {462,0.06710891}, {463,0.05833663}, {464,0.06074257}, {465,0.06977228}, {466,0.05751485}, {467,0.06613861}, {468,0.07589109}, {469,0.05845545}, {470,0.06343564}, {471,0.07271287}, {472,0.05839604}, {473,0.06108911}, {474,0.06779208}, {475,0.07346535}, {476,0.05944554}, {477,0.06188119}, {478,0.06713861}, {479,0.07222772}, {480,0.05934653}, {481,0.05917822}, {482,0.06547525}, {483,0.07024752}, {484,0.07439604}, {485,0.07790099}, {486,0.06063366}, {487,0.06124752}, {488,0.06341584}, {489,0.06711881}, {490,0.06985149}, {491,0.07220792}, {492,0.07443564}, {493,0.08037624}, {494,0.08609901}, {495,0.06178218}, {496,0.06171287}, {497,0.06196040}, {498,0.06140594}, {499,0.06257426}, {500,0.06246535}, {505,0.06274257}, {510,0.06372277}, {515,0.06391089}, {520,0.07913861}, {525,0.07596040}, {530,0.07324752}, {535,0.06658416}, {540,0.08258416}, {545,0.07331683}, {550,0.08752475}, {555,0.07655446}, {560,0.08614851}, {565,0.07424752}, {570,0.08239604}, {575,0.09021782}, {580,0.07319802}, {585,0.08266337}, {590,0.08559406}, {595,0.08863366}, {600,0.08978218}, {605,0.09017822}, {610,0.08911881}, {615,0.08797030}, {620,0.08511881}, {625,0.08410891}, {630,0.10557426}, {635,0.09574257}, {640,0.08652475}, {645,0.10215842}, {650,0.09199010}, {655,0.08252475}, {660,0.09309901}, {665,0.11268317}, {670,0.09091089}, {675,0.09927723}, {680,0.10496040}, {685,0.08737624}, {690,0.09111881}, {695,0.09500000}, {700,0.10198020}, {705,0.09860396}, {710,0.09967327}, {715,0.09734653}, {720,0.09400990}, {725,0.11352475}, {730,0.10911881}, {735,0.10899010}, {740,0.09718812}, {745,0.11277228}, {750,0.10222772}, {755,0.11450495}, {760,0.10284158}, {765,0.11652475}, {770,0.12543564}, {775,0.10873267}, {780,0.11429703}, {785,0.12014851}, {790,0.13848515}, {795,0.10828713}, {800,0.10834653}, {805,0.11102970}, {810,0.11103960}, {815,0.11000000}, {820,0.14120792}, {825,0.13009901}, {830,0.12476238}, {835,0.11723762}, {840,0.13219802}, {845,0.13482178}, {850,0.11861386}, {855,0.13049505}, {860,0.11770297}, {865,0.12780198}, {870,0.11749505}, {875,0.12376238}, {880,0.12964356}, {885,0.13558416}, {890,0.15566337}, {895,0.12395050}, {900,0.12367327}, {905,0.12433663}, {910,0.12417822}, {915,0.13023762}, {920,0.12333663}, {925,0.14382178}, {930,0.13573267}, {935,0.13254455}, {940,0.12800990}, {945,0.13479208}, {950,0.13299010}, {955,0.14391089}, {960,0.14076238}, {965,0.14808911}, {970,0.13216832}, {975,0.13945545}, {980,0.14510891}, {985,0.15710891}, {990,0.13730693}, {995,0.13849505}, {1000,0.13587129}, {1010,0.14694059}, {1020,0.14406931}, {1030,0.14006931}, {1040,0.17214851}, {1050,0.15422772}, {1060,0.14390099}, {1070,0.15519802}, {1080,0.16849505}, {1090,0.15023762}, {1100,0.15420792}, {1110,0.16561386}, {1120,0.15739604}, {1130,0.15493069}, {1140,0.17238614}, {1150,0.17104950}, {1160,0.17944554}, {1170,0.16768317}, {1180,0.18305941}, {1190,0.18611881}, {1200,0.16508911}, {1210,0.17472277}, {1220,0.17209901}, {1230,0.19112871}, {1240,0.19200990}, {1250,0.18037624}, {1260,0.19337624}, {1270,0.18670297}, {1280,0.18914851}, {1290,0.21723762}, {1300,0.18412871}, {1310,0.18589109}, {1320,0.18916832}, {1330,0.21065347}, {1340,0.20135644}, {1350,0.20079208}, {1360,0.20984158}, {1370,0.21562376}, {1380,0.21308911}, {1390,0.19459406}, {1400,0.20294059}, {1410,0.20075248}, {1420,0.19593069}, {1430,0.20274257}, {1440,0.21764356}, {1450,0.22008911}, {1460,0.20622772}, {1470,0.23339604}, {1480,0.22667327}, {1490,0.21136634}, {1500,0.21930693}, {1510,0.21849505}, {1520,0.22457426}, {1530,0.21743564}, {1540,0.25163366}, {1550,0.23247525}, {1560,0.21958416}, {1570,0.23783168}, {1580,0.22364356}, {1590,0.23137624}, {1600,0.23346535}, {1610,0.24613861}, {1620,0.24008911}, {1630,0.24929703}, {1640,0.23550495}, {1650,0.26082178}, {1660,0.24526733}, {1670,0.26480198}, {1680,0.24326733}, {1690,0.26120792}, {1700,0.25679208}, {1710,0.27163366}, {1720,0.26133663}, {1730,0.27015842}, {1740,0.25673267}, {1750,0.25696040}, {1760,0.26456436}, {1770,0.26340594}, {1780,0.26328713}, {1790,0.27751485}, {1800,0.26200990}, {1810,0.26034653}, {1820,0.26981188}, {1830,0.26156436}, {1840,0.28885149}, {1850,0.27590099}, {1860,0.27318812}, {1870,0.30732673}, {1880,0.27160396}, {1890,0.28849505}, {1900,0.28345545}, {1910,0.29069307}, {1920,0.28420792}, {1930,0.29001980}, {1940,0.29333663}, {1950,0.28036634}, {1960,0.28929703}, {1970,0.28141584}, {1980,0.29333663}, {1990,0.30822772}, {2000,0.30256436}, {2050,0.30987129}, {2100,0.32848515}, {2150,0.31854455}, {2200,0.33970297}, {2250,0.36133663}, {2300,0.34297030}, {2350,0.35508911}, {2400,0.37554455}, {2450,0.38820792}, {2500,0.37095050}, {2550,0.38100990}, {2600,0.40219802}, {2650,0.41741584}, {2700,0.41381188}, {2750,0.43649505}, {2800,0.42233663}, {2850,0.42852475}, {2900,0.42994059}, {2950,0.44253465}, {3000,0.46218812}, {3050,0.47042574}, {3100,0.46465347}, {3150,0.47427723}, {3200,0.48784158}, {3250,0.48369307}, {3300,0.50183168}, {3350,0.51338614}, {3400,0.50926733}, {3450,0.52360396}, {3500,0.53675248}, {3550,0.54793069}, {3600,0.53611881}, {3650,0.54946535}, {3700,0.56789109}, {3750,0.58611881}, {3800,0.59616832}, {3850,0.59256436}, {3900,0.59384158}, {3950,0.59904950}, {4000,0.62212871}, {4050,0.64364356}, {4100,0.62139604}, {4150,0.64063366}, {4200,0.63978218}, {4250,0.67199010}, {4300,0.66640594}, {4350,0.67802970}, {4400,0.69350495}, {4450,0.68513861}, {4500,0.68585149}, {4550,0.71851485}, {4600,0.71758416}, {4650,0.73213861}, {4700,0.72895050}, {4750,0.72904950}, {4800,0.77055446}, {4850,0.74268317}, {4900,0.78228713}, {4950,0.77380198}, {5000,0.78533663}, {5050,0.78653465}, {5100,0.81562376}, {5150,0.80376238}, {5200,0.87550495}, {5250,0.81823762}, {5300,0.81982178}, {5350,0.85113861}, {5400,0.83269307}, {5450,0.84790099}, {5500,0.86988119}, {5550,0.87093069}, {5600,0.86659406}, {5650,0.88489109}, {5700,0.87555446}, {5750,0.89575248}, {5800,0.92138614}, {5850,0.93695050}, {5900,0.91891089}, {5950,0.93335644}, {6000,0.94776238}, {6050,0.9731714}, {6100,0.9931143}, {6150,1.0058286}, {6200,1.0038000}, {6250,1.0194571}, {6300,1.0228571}, {6350,1.0433143}, {6400,1.0321143}, {6450,1.0631714}, {6500,1.0782571}, {6550,1.0877143}, {6600,1.1066286}, {6650,1.0831143}, {6700,1.0782000}, {6750,1.1047429}, {6800,1.0951714}, {6850,1.1161714}, {6900,1.1191429}, {6950,1.1346286}, {7000,1.1679143}, {7050,1.1847429}, {7100,1.1734571}, {7150,1.1821714}, {7200,1.1825429}, {7250,1.1808286}, {7300,1.2007429}, {7350,1.2013143}, {7400,1.2067143}, {7450,1.2007714}, {7500,1.2035714}, {7550,1.2386857}, {7600,1.2719429}, {7650,1.2865714}, {7700,1.2596000}, {7750,1.2884571}, {7800,1.2687143}, {7850,1.2678571}, {7900,1.3216286}, {7950,1.3340286}, {8000,1.3117714}, {8050,1.3308286}, {8100,1.3100571}, {8150,1.3482286}, {8200,1.3559714}, {8250,1.3542000}, {8300,1.3530286}, {8350,1.3485429}, {8400,1.3841143}, {8450,1.3961143}, {8500,1.3908000}, {8550,1.3959143}, {8600,1.4554571}, {8650,1.4302000}, {8700,1.4349429}, {8750,1.4719714}, {8800,1.4301429}, {8850,1.4438857}, {8900,1.4609714}, {8950,1.4922571}, {9000,1.4579714}, {9050,1.4942286}, {9100,1.5135714}, {9150,1.5097714}, {9200,1.5352571}, {9250,1.5147143}, {9300,1.5006286}, {9350,1.5595143}, {9400,1.5523714}, {9450,1.5596857}, {9500,1.5912000}, {9550,1.5753714}, {9600,1.5850571}, {9650,1.5903143}, {9700,1.6397143}, {9750,1.5972571}, {9800,1.6425143}, {9850,1.6298286}, {9900,1.6638857}, {9950,1.6645429}, {10000,1.6810000}, {10100,1.6571714}, {10200,1.7047143}, {10300,1.6936000}, {10400,1.7327714}, {10500,1.6999714}, {10600,1.7656857}, {10700,1.7573714}, {10800,1.7871143}, {10900,1.7644857}, {11000,1.8145714}, {11100,1.8233714}, {11200,1.8446000}, {11300,1.8364286}, {11400,1.8600000}, {11500,1.8592286}, {11600,1.9005714}, {11700,2.0900000}, {11800,1.9166571}, {11900,2.0437714}, {12000,1.9714857}, {12100,1.9781714}, {12200,2.0169143}, {12300,2.0112000}, {12400,2.0132571}, {12500,2.0647429}, {12600,2.0666857}, {12700,2.0886286}, {12800,2.0629714}, {12900,2.1130286}, {13000,2.1255714}, {13100,2.1590571}, {13200,2.1596857}, {13300,2.1863714}, {13400,2.1708857}, {13500,2.2128286}, {13600,2.2074571}, {13700,2.2402286}, {13800,2.2569143}, {13900,2.2967714}, {14000,2.3015429}, {14100,2.3266000}, {14200,2.3596286}, {14300,2.3658857}, {14400,2.3337143}, {14500,2.3912571}, {14600,2.3576571}, {14700,2.4161143}, {14800,2.4188857}, {14900,2.4072571}, {15000,2.4432857}, {15100,2.4962571}, {15200,2.4896286}, {15300,2.5858286}, {15400,2.5015143}, {15500,2.6036571}, {15600,2.5560000}, {15700,2.5467429}, {15800,2.5874286}, {15900,2.5979429}, {16000,2.6578286}, {16100,2.6594286}, {16200,2.6525714}, {16300,2.6741714}, {16400,2.6321714}, {16500,2.6587714}, {16600,2.7021714}, {16700,2.8229429}, {16800,2.7240571}, {16900,2.7365143}, {17000,2.7656286}, {17100,2.8091143}, {17200,2.8874571}, {17300,2.8008286}, {17400,2.8722571}, {17500,2.8562286}, {17600,2.8614571}, {17700,2.8862857}, {17800,2.8817714}, {17900,2.9470286}, {18000,2.9222571}, {18100,2.9910857}, {18200,2.9657429}, {18300,3.0152000}, {18400,3.0262857}, {18500,3.0186000}, {18600,3.0154286}, {18700,3.0601143}, {18800,3.0789143}, {18900,3.1038286}, {19000,3.3572571}, {19100,3.1443429}, {19200,3.1040000}, {19300,3.2513429}, {19400,3.4058571}, {19500,3.2877714}, {19600,3.2677143}, {19700,3.2380857}, {19800,3.3974571}, {19900,3.4241143}, {20000,3.3034000}};
data["big_flat"]["LtacTCGallinaCtx"]["actual reif"]["system"] = {{1,0.00003960}, {2,0.00000000}, {3,0.00002970}, {4,0.00003960}, {5,0.00002970}, {6,0.00000000}, {7,0.00003960}, {8,0.00000000}, {9,0.00000000}, {10,0.00003960}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00003960}, {15,0.00006931}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00003960}, {21,0.00007921}, {22,0.00007921}, {23,0.00002970}, {24,0.00003960}, {25,0.00000000}, {26,0.00003960}, {27,0.00000000}, {28,0.00000000}, {29,0.00006931}, {30,0.00000000}, {31,0.00000000}, {32,0.00006931}, {33,0.00000000}, {34,0.00003960}, {35,0.00000000}, {36,0.00002970}, {37,0.00000000}, {38,0.00003960}, {39,0.00000000}, {40,0.00003960}, {41,0.00003960}, {42,0.00000000}, {43,0.00003960}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00007921}, {49,0.00003960}, {50,0.00007921}, {51,0.00000000}, {52,0.00000000}, {53,0.00003960}, {54,0.00006931}, {55,0.00003960}, {56,0.00003960}, {57,0.00010891}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00003960}, {62,0.00000000}, {63,0.00003960}, {64,0.00003960}, {65,0.00000000}, {66,0.00000000}, {67,0.00011881}, {68,0.00003960}, {69,0.00002970}, {70,0.00002970}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00007921}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00003960}, {79,0.00003960}, {80,0.00007921}, {81,0.00006931}, {82,0.00000000}, {83,0.00006931}, {84,0.00000000}, {85,0.00007921}, {86,0.00003960}, {87,0.00002970}, {88,0.00000000}, {89,0.00007921}, {90,0.00013861}, {91,0.00000000}, {92,0.00000000}, {93,0.00006931}, {94,0.00000000}, {95,0.00003960}, {96,0.00007921}, {97,0.00003960}, {98,0.00000000}, {99,0.00003960}, {100,0.00000000}, {101,0.00000000}, {102,0.00003960}, {103,0.00007921}, {104,0.00003960}, {105,0.00000000}, {106,0.00006931}, {107,0.00000000}, {108,0.00007921}, {109,0.00002970}, {110,0.00003960}, {111,0.00002970}, {112,0.00007921}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00010891}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00007921}, {122,0.00000000}, {123,0.00003960}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00003960}, {129,0.00003960}, {130,0.00003960}, {131,0.00000000}, {132,0.00003960}, {133,0.00002970}, {134,0.00000000}, {135,0.00000000}, {136,0.00002970}, {137,0.00010891}, {138,0.00000000}, {139,0.00000000}, {140,0.00003960}, {141,0.00003960}, {142,0.00003960}, {143,0.00000000}, {144,0.00006931}, {145,0.00000000}, {146,0.00010891}, {147,0.00000000}, {148,0.00002970}, {149,0.00000000}, {150,0.00003960}, {151,0.00000000}, {152,0.00000000}, {153,0.00003960}, {154,0.00000000}, {155,0.00000000}, {156,0.00007921}, {157,0.00002970}, {158,0.00000000}, {159,0.00003960}, {160,0.00015842}, {161,0.00007921}, {162,0.00003960}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00011881}, {169,0.00014851}, {170,0.00000000}, {171,0.00000000}, {172,0.00007921}, {173,0.00019802}, {174,0.00003960}, {175,0.00003960}, {176,0.00011881}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00006931}, {182,0.00003960}, {183,0.00003960}, {184,0.00003960}, {185,0.00000000}, {186,0.00002970}, {187,0.00000000}, {188,0.00002970}, {189,0.00000000}, {190,0.00000000}, {191,0.00003960}, {192,0.00003960}, {193,0.00014851}, {194,0.00015842}, {195,0.00007921}, {196,0.00015842}, {197,0.00007921}, {198,0.00005941}, {199,0.00023762}, {200,0.00002970}, {201,0.00019802}, {202,0.00021782}, {203,0.00003960}, {204,0.00011881}, {205,0.00003960}, {206,0.00003960}, {207,0.00000000}, {208,0.00003960}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00022772}, {213,0.00003960}, {214,0.00003960}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00015842}, {219,0.00010891}, {220,0.00007921}, {221,0.00003960}, {222,0.00007921}, {223,0.00007921}, {224,0.00002970}, {225,0.00003960}, {226,0.00023762}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00003960}, {233,0.00007921}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00021782}, {239,0.00003960}, {240,0.00003960}, {241,0.00000000}, {242,0.00003960}, {243,0.00000000}, {244,0.00000000}, {245,0.00003960}, {246,0.00000000}, {247,0.00007921}, {248,0.00003960}, {249,0.00006931}, {250,0.00000000}, {251,0.00000000}, {252,0.00007921}, {253,0.00000000}, {254,0.00003960}, {255,0.00003960}, {256,0.00000000}, {257,0.00007921}, {258,0.00003960}, {259,0.00000000}, {260,0.00003960}, {261,0.00000000}, {262,0.00000000}, {263,0.00003960}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00003960}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00003960}, {275,0.00000000}, {276,0.00000000}, {277,0.00003960}, {278,0.00000000}, {279,0.00000000}, {280,0.00003960}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00003960}, {285,0.00006931}, {286,0.00000000}, {287,0.00000000}, {288,0.00007921}, {289,0.00000000}, {290,0.00003960}, {291,0.00000000}, {292,0.00002970}, {293,0.00003960}, {294,0.00000000}, {295,0.00003960}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00007921}, {300,0.00003960}, {301,0.00000000}, {302,0.00003960}, {303,0.00000000}, {304,0.00000000}, {305,0.00007921}, {306,0.00000000}, {307,0.00003960}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00007921}, {313,0.00000000}, {314,0.00000000}, {315,0.00003960}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00003960}, {320,0.00003960}, {321,0.00000000}, {322,0.00003960}, {323,0.00003960}, {324,0.00000000}, {325,0.00000000}, {326,0.00003960}, {327,0.00003960}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00006931}, {332,0.00000000}, {333,0.00003960}, {334,0.00003960}, {335,0.00000000}, {336,0.00003960}, {337,0.00003960}, {338,0.00003960}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00003960}, {344,0.00011881}, {345,0.00000000}, {346,0.00003960}, {347,0.00043564}, {348,0.00003960}, {349,0.00015842}, {350,0.00003960}, {351,0.00027723}, {352,0.00000000}, {353,0.00003960}, {354,0.00000000}, {355,0.00003960}, {356,0.00000000}, {357,0.00003960}, {358,0.00006931}, {359,0.00000000}, {360,0.00011881}, {361,0.00000000}, {362,0.00003960}, {363,0.00000000}, {364,0.00000000}, {365,0.00003960}, {366,0.00003960}, {367,0.00000000}, {368,0.00003960}, {369,0.00013861}, {370,0.00003960}, {371,0.00003960}, {372,0.00011881}, {373,0.00000000}, {374,0.00009901}, {375,0.00010891}, {376,0.00000000}, {377,0.00000000}, {378,0.00003960}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00003960}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00003960}, {387,0.00000000}, {388,0.00003960}, {389,0.00003960}, {390,0.00002970}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00003960}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00007921}, {400,0.00003960}, {401,0.00000000}, {402,0.00000000}, {403,0.00007921}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00003960}, {410,0.00003960}, {411,0.00000000}, {412,0.00000000}, {413,0.00003960}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00003960}, {419,0.00002970}, {420,0.00000000}, {421,0.00003960}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00003960}, {426,0.00003960}, {427,0.00003960}, {428,0.00003960}, {429,0.00000000}, {430,0.00000000}, {431,0.00003960}, {432,0.00000000}, {433,0.00000000}, {434,0.00003960}, {435,0.00003960}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00003960}, {441,0.00003960}, {442,0.00007921}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00003960}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00003960}, {454,0.00000000}, {455,0.00003960}, {456,0.00000000}, {457,0.00003960}, {458,0.00003960}, {459,0.00000000}, {460,0.00000000}, {461,0.00003960}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00002970}, {466,0.00000000}, {467,0.00007921}, {468,0.00000000}, {469,0.00003960}, {470,0.00003960}, {471,0.00000000}, {472,0.00007921}, {473,0.00000000}, {474,0.00000000}, {475,0.00003960}, {476,0.00003960}, {477,0.00003960}, {478,0.00000000}, {479,0.00003960}, {480,0.00000000}, {481,0.00003960}, {482,0.00000000}, {483,0.00007921}, {484,0.00000000}, {485,0.00003960}, {486,0.00003960}, {487,0.00003960}, {488,0.00003960}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00003960}, {494,0.00003960}, {495,0.00000000}, {496,0.00000000}, {497,0.00003960}, {498,0.00000000}, {499,0.00000000}, {500,0.00003960}, {505,0.00003960}, {510,0.00003960}, {515,0.00007921}, {520,0.00000000}, {525,0.00003960}, {530,0.00000000}, {535,0.00000000}, {540,0.00003960}, {545,0.00007921}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00007921}, {575,0.00000000}, {580,0.00000000}, {585,0.00003960}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00003960}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00007921}, {640,0.00000000}, {645,0.00003960}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00003960}, {685,0.00000000}, {690,0.00003960}, {695,0.00003960}, {700,0.00003960}, {705,0.00003960}, {710,0.00000000}, {715,0.00003960}, {720,0.00007921}, {725,0.00003960}, {730,0.00003960}, {735,0.00003960}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00007921}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00007921}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00002970}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00007921}, {845,0.00003960}, {850,0.00003960}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00003960}, {885,0.00003960}, {890,0.00011881}, {895,0.00000000}, {900,0.00000000}, {905,0.00006931}, {910,0.00007921}, {915,0.00000000}, {920,0.00003960}, {925,0.00007921}, {930,0.00003960}, {935,0.00003960}, {940,0.00000000}, {945,0.00000000}, {950,0.00003960}, {955,0.00007921}, {960,0.00000000}, {965,0.00000000}, {970,0.00003960}, {975,0.00000000}, {980,0.00003960}, {985,0.00000000}, {990,0.00007921}, {995,0.00000000}, {1000,0.00003960}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00003960}, {1050,0.00007921}, {1060,0.00003960}, {1070,0.00000000}, {1080,0.00003960}, {1090,0.00003960}, {1100,0.00003960}, {1110,0.00000000}, {1120,0.00007921}, {1130,0.00003960}, {1140,0.00000000}, {1150,0.00007921}, {1160,0.00003960}, {1170,0.00000000}, {1180,0.00007921}, {1190,0.00000000}, {1200,0.00003960}, {1210,0.00000000}, {1220,0.00003960}, {1230,0.00003960}, {1240,0.00000000}, {1250,0.00007921}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003960}, {1290,0.00000000}, {1300,0.00003960}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00003960}, {1340,0.00003960}, {1350,0.00003960}, {1360,0.00000000}, {1370,0.00007921}, {1380,0.00003960}, {1390,0.00003960}, {1400,0.00000000}, {1410,0.00003960}, {1420,0.00003960}, {1430,0.00003960}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00007921}, {1470,0.00015842}, {1480,0.00007921}, {1490,0.00007921}, {1500,0.00000000}, {1510,0.00003960}, {1520,0.00003960}, {1530,0.00000000}, {1540,0.00003960}, {1550,0.00011881}, {1560,0.00003960}, {1570,0.00007921}, {1580,0.00007921}, {1590,0.00003960}, {1600,0.00003960}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00007921}, {1640,0.00007921}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00003960}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00007921}, {1730,0.00003960}, {1740,0.00000000}, {1750,0.00023762}, {1760,0.00007921}, {1770,0.00006931}, {1780,0.00003960}, {1790,0.00003960}, {1800,0.00007921}, {1810,0.00007921}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00003960}, {1860,0.00006931}, {1870,0.00007921}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00003960}, {1910,0.00003960}, {1920,0.00003960}, {1930,0.00000000}, {1940,0.00003960}, {1950,0.00003960}, {1960,0.00003960}, {1970,0.00007921}, {1980,0.00007921}, {1990,0.00003960}, {2000,0.00007921}, {2050,0.00000000}, {2100,0.00003960}, {2150,0.00003960}, {2200,0.00003960}, {2250,0.00000000}, {2300,0.00003960}, {2350,0.00011881}, {2400,0.00007921}, {2450,0.00007921}, {2500,0.00007921}, {2550,0.00003960}, {2600,0.00000000}, {2650,0.00003960}, {2700,0.00003960}, {2750,0.00011881}, {2800,0.00003960}, {2850,0.00274257}, {2900,0.00002970}, {2950,0.00003960}, {3000,0.00000000}, {3050,0.00003960}, {3100,0.00007921}, {3150,0.00000000}, {3200,0.00003960}, {3250,0.00007921}, {3300,0.00000000}, {3350,0.00019802}, {3400,0.00011881}, {3450,0.00015842}, {3500,0.00003960}, {3550,0.00003960}, {3600,0.00007921}, {3650,0.00007921}, {3700,0.00010891}, {3750,0.00003960}, {3800,0.00011881}, {3850,0.00011881}, {3900,0.00007921}, {3950,0.00019802}, {4000,0.00000000}, {4050,0.00003960}, {4100,0.00007921}, {4150,0.00002970}, {4200,0.00000000}, {4250,0.00003960}, {4300,0.00003960}, {4350,0.00003960}, {4400,0.00000000}, {4450,0.00011881}, {4500,0.00007921}, {4550,0.00000000}, {4600,0.00007921}, {4650,0.00011881}, {4700,0.00006931}, {4750,0.00003960}, {4800,0.00003960}, {4850,0.00011881}, {4900,0.00003960}, {4950,0.00003960}, {5000,0.00031683}, {5050,0.00007921}, {5100,0.00011881}, {5150,0.00015842}, {5200,0.00003960}, {5250,0.00011881}, {5300,0.00007921}, {5350,0.00011881}, {5400,0.00003960}, {5450,0.00011881}, {5500,0.00007921}, {5550,0.00019802}, {5600,0.00007921}, {5650,0.00000000}, {5700,0.00019802}, {5750,0.00019802}, {5800,0.00000000}, {5850,0.00031683}, {5900,0.00003960}, {5950,0.00007921}, {6000,0.00003960}, {6050,0.0045714}, {6100,0.0070857}, {6150,0.0002286}, {6200,0.0002286}, {6250,0.0000000}, {6300,0.0006857}, {6350,0.0000000}, {6400,0.0001143}, {6450,0.0000857}, {6500,0.0001143}, {6550,0.0003429}, {6600,0.0003429}, {6650,0.0000000}, {6700,0.0003429}, {6750,0.0001143}, {6800,0.0000000}, {6850,0.0002286}, {6900,0.0000000}, {6950,0.0001143}, {7000,0.0002286}, {7050,0.0002286}, {7100,0.0000000}, {7150,0.0003429}, {7200,0.0002286}, {7250,0.0001143}, {7300,0.0002286}, {7350,0.0002286}, {7400,0.0002286}, {7450,0.0002286}, {7500,0.0001143}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0001143}, {7700,0.0000000}, {7750,0.0001143}, {7800,0.0001143}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0001143}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0003429}, {8200,0.0000857}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0001143}, {8400,0.0001143}, {8450,0.0000000}, {8500,0.0002286}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0003429}, {8700,0.0001143}, {8750,0.0002286}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0001143}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0001143}, {9150,0.0001143}, {9200,0.0001143}, {9250,0.0004571}, {9300,0.0020571}, {9350,0.0003429}, {9400,0.0002286}, {9450,0.0004286}, {9500,0.0002286}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0004571}, {9700,0.0001143}, {9750,0.0002286}, {9800,0.0002286}, {9850,0.0001143}, {9900,0.0001143}, {9950,0.0001143}, {10000,0.0002000}, {10100,0.0000000}, {10200,0.0003429}, {10300,0.0001143}, {10400,0.0000000}, {10500,0.0003429}, {10600,0.0000000}, {10700,0.0002286}, {10800,0.0002286}, {10900,0.0002286}, {11000,0.0002286}, {11100,0.0000857}, {11200,0.0001143}, {11300,0.0000000}, {11400,0.0002286}, {11500,0.0000000}, {11600,0.0001143}, {11700,0.0013429}, {11800,0.0000000}, {11900,0.0008000}, {12000,0.0001143}, {12100,0.0000000}, {12200,0.0003143}, {12300,0.0002286}, {12400,0.0001143}, {12500,0.0000000}, {12600,0.0007714}, {12700,0.0004571}, {12800,0.0000000}, {12900,0.0002857}, {13000,0.0001143}, {13100,0.0002286}, {13200,0.0000000}, {13300,0.0003429}, {13400,0.0002286}, {13500,0.0002286}, {13600,0.0002286}, {13700,0.0001143}, {13800,0.0001143}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0001143}, {14200,0.0001143}, {14300,0.0002286}, {14400,0.0003429}, {14500,0.0001143}, {14600,0.0001143}, {14700,0.0000000}, {14800,0.0011429}, {14900,0.0001143}, {15000,0.0006857}, {15100,0.0000000}, {15200,0.0002000}, {15300,0.0002286}, {15400,0.0004571}, {15500,0.0000000}, {15600,0.0018286}, {15700,0.0014857}, {15800,0.0004571}, {15900,0.0001143}, {16000,0.0009714}, {16100,0.0003429}, {16200,0.0001143}, {16300,0.0011429}, {16400,0.0015714}, {16500,0.0001143}, {16600,0.0012286}, {16700,0.0002286}, {16800,0.0002286}, {16900,0.0002286}, {17000,0.0003429}, {17100,0.0006857}, {17200,0.0004571}, {17300,0.0000000}, {17400,0.0001143}, {17500,0.0000000}, {17600,0.0004571}, {17700,0.0002286}, {17800,0.0000000}, {17900,0.0005714}, {18000,0.0013714}, {18100,0.0018000}, {18200,0.0018286}, {18300,0.0011429}, {18400,0.0007714}, {18500,0.0010286}, {18600,0.0014857}, {18700,0.0008000}, {18800,0.0005714}, {18900,0.0001143}, {19000,0.0010286}, {19100,0.0003429}, {19200,0.0006857}, {19300,0.0002000}, {19400,0.0008000}, {19500,0.0012286}, {19600,0.0012571}, {19700,0.0010286}, {19800,0.0021714}, {19900,0.0021714}, {20000,0.0016000}};
data["big_flat"]["LtacTCGallinaCtx"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00102970}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000990}, {417,0.00000000}, {418,0.00000990}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000990}, {423,0.00000990}, {424,0.00000000}, {425,0.00000000}, {426,0.00113861}, {427,0.00000000}, {428,0.00000000}, {429,0.00001980}, {430,0.00000990}, {431,0.00000990}, {432,0.00000000}, {433,0.00000990}, {434,0.00000990}, {435,0.00002970}, {436,0.00002970}, {437,0.00000990}, {438,0.00000990}, {439,0.00001980}, {440,0.00001980}, {441,0.00001980}, {442,0.00000990}, {443,0.00002970}, {444,0.00001980}, {445,0.00001980}, {446,0.00002970}, {447,0.00000990}, {448,0.00003960}, {449,0.00003960}, {450,0.00007921}, {451,0.00008911}, {452,0.00010891}, {453,0.00009901}, {454,0.00013861}, {455,0.00012871}, {456,0.00021782}, {457,0.00018812}, {458,0.00022772}, {459,0.00024752}, {460,0.00024752}, {461,0.00197030}, {462,0.00036634}, {463,0.00042574}, {464,0.00040594}, {465,0.00052475}, {466,0.00057426}, {467,0.00054455}, {468,0.00044554}, {469,0.00066337}, {470,0.00057426}, {471,0.00056436}, {472,0.00063366}, {473,0.00055446}, {474,0.00060396}, {475,0.00065347}, {476,0.00063366}, {477,0.00062376}, {478,0.00068317}, {479,0.00068317}, {480,0.00079208}, {481,0.00078218}, {482,0.00077228}, {483,0.00074257}, {484,0.00078218}, {485,0.00077228}, {486,0.00085149}, {487,0.00089109}, {488,0.00081188}, {489,0.00089109}, {490,0.00091089}, {491,0.00091089}, {492,0.00092079}, {493,0.00094059}, {494,0.00093069}, {495,0.00094059}, {496,0.00098020}, {497,0.00099010}, {498,0.00099010}, {499,0.00094059}, {500,0.00096040}, {505,0.00098020}, {510,0.00100000}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00100000}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00312871}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00100000}, {830,0.00100000}, {835,0.00100000}, {840,0.00100000}, {845,0.00100000}, {850,0.00100000}, {855,0.00100000}, {860,0.00100990}, {865,0.00100990}, {870,0.00100990}, {875,0.00100000}, {880,0.00101980}, {885,0.00102970}, {890,0.00102970}, {895,0.00103960}, {900,0.00104950}, {905,0.00103960}, {910,0.00105941}, {915,0.00105941}, {920,0.00103960}, {925,0.00105941}, {930,0.00113861}, {935,0.00133663}, {940,0.00132673}, {945,0.00146535}, {950,0.00162376}, {955,0.00159406}, {960,0.00157426}, {965,0.00149505}, {970,0.00162376}, {975,0.00168317}, {980,0.00176238}, {985,0.00175248}, {990,0.00187129}, {995,0.00191089}, {1000,0.00196040}, {1010,0.00199010}, {1020,0.00200000}, {1030,0.00200000}, {1040,0.00200000}, {1050,0.00443564}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200000}, {1140,0.00200000}, {1150,0.00200000}, {1160,0.00200000}, {1170,0.00200000}, {1180,0.00200000}, {1190,0.00200000}, {1200,0.00200000}, {1210,0.00200000}, {1220,0.00200000}, {1230,0.00200000}, {1240,0.00200000}, {1250,0.00200000}, {1260,0.00200000}, {1270,0.00200000}, {1280,0.00200000}, {1290,0.00200000}, {1300,0.00514851}, {1310,0.00200000}, {1320,0.00200000}, {1330,0.00200990}, {1340,0.00203960}, {1350,0.00201980}, {1360,0.00202970}, {1370,0.00203960}, {1380,0.00208911}, {1390,0.00210891}, {1400,0.00212871}, {1410,0.00226733}, {1420,0.00234653}, {1430,0.00242574}, {1440,0.00246535}, {1450,0.00259406}, {1460,0.00249505}, {1470,0.00259406}, {1480,0.00613861}, {1490,0.00282178}, {1500,0.00290099}, {1510,0.00298020}, {1520,0.00299010}, {1530,0.00297030}, {1540,0.00300000}, {1550,0.00300000}, {1560,0.00300000}, {1570,0.00300000}, {1580,0.00300000}, {1590,0.00300000}, {1600,0.00300000}, {1610,0.00589109}, {1620,0.00549505}, {1630,0.00300000}, {1640,0.00300000}, {1650,0.00300000}, {1660,0.00300000}, {1670,0.00300000}, {1680,0.00300000}, {1690,0.00300000}, {1700,0.00300000}, {1710,0.00300000}, {1720,0.00300000}, {1730,0.00300000}, {1740,0.00300000}, {1750,0.00300000}, {1760,0.00300000}, {1770,0.00300000}, {1780,0.00300000}, {1790,0.00300990}, {1800,0.00302970}, {1810,0.00301980}, {1820,0.00304950}, {1830,0.00306931}, {1840,0.00309901}, {1850,0.00313861}, {1860,0.00315842}, {1870,0.00327723}, {1880,0.00337624}, {1890,0.00343564}, {1900,0.00346535}, {1910,0.00347525}, {1920,0.00350495}, {1930,0.00358416}, {1940,0.00362376}, {1950,0.00363366}, {1960,0.00369307}, {1970,0.00544554}, {1980,0.00392079}, {1990,0.00393069}, {2000,0.00399010}, {2050,0.00399010}, {2100,0.00400000}, {2150,0.00400000}, {2200,0.00401980}, {2250,0.00405941}, {2300,0.00418812}, {2350,0.00445545}, {2400,0.00454455}, {2450,0.00491089}, {2500,0.00856436}, {2550,0.00500000}, {2600,0.00500990}, {2650,0.00502970}, {2700,0.00507921}, {2750,0.00518812}, {2800,0.00552475}, {2850,0.00914851}, {2900,0.00584158}, {2950,0.00599010}, {3000,0.00600990}, {3050,0.00601980}, {3100,0.00604950}, {3150,0.01277228}, {3200,0.00629703}, {3250,0.00657426}, {3300,0.00657426}, {3350,0.00675248}, {3400,0.00696040}, {3450,0.00701980}, {3500,0.00704950}, {3550,0.01151485}, {3600,0.00715842}, {3650,0.00730693}, {3700,0.00757426}, {3750,0.00760396}, {3800,0.00774257}, {3850,0.00798020}, {3900,0.00801980}, {3950,0.01190099}, {4000,0.00813861}, {4050,0.00818812}, {4100,0.00845545}, {4150,0.00861386}, {4200,0.00862376}, {4250,0.00871287}, {4300,0.00897030}, {4350,0.00904950}, {4400,0.00908911}, {4450,0.01364356}, {4500,0.00924752}, {4550,0.00952475}, {4600,0.00965347}, {4650,0.00968317}, {4700,0.00971287}, {4750,0.00994059}, {4800,0.01488119}, {4850,0.01016832}, {4900,0.01019802}, {4950,0.02102970}, {5000,0.01065347}, {5050,0.01074257}, {5100,0.01076238}, {5150,0.01085149}, {5200,0.02305941}, {5250,0.01115842}, {5300,0.01120792}, {5350,0.01126733}, {5400,0.01690099}, {5450,0.01173267}, {5500,0.01179208}, {5550,0.01177228}, {5600,0.01191089}, {5650,0.01205941}, {5700,0.01209901}, {5750,0.01218812}, {5800,0.01236634}, {5850,0.01256436}, {5900,0.02310891}, {5950,0.01278218}, {6000,0.01291089}, {6050,0.0214286}, {6100,0.0141143}, {6150,0.0144286}, {6200,0.0145143}, {6250,0.0144857}, {6300,0.0148000}, {6350,0.0148000}, {6400,0.0149714}, {6450,0.0326857}, {6500,0.0152571}, {6550,0.0265143}, {6600,0.0153714}, {6650,0.0155714}, {6700,0.0158286}, {6750,0.0160286}, {6800,0.0253429}, {6850,0.0162000}, {6900,0.0162857}, {6950,0.0165429}, {7000,0.0304571}, {7050,0.0167429}, {7100,0.0168286}, {7150,0.0170000}, {7200,0.0172000}, {7250,0.0172571}, {7300,0.0173429}, {7350,0.0294857}, {7400,0.0178286}, {7450,0.0177429}, {7500,0.0179429}, {7550,0.0181714}, {7600,0.0352286}, {7650,0.0192571}, {7700,0.0184857}, {7750,0.0186571}, {7800,0.0297143}, {7850,0.0338857}, {7900,0.0191143}, {7950,0.0192286}, {8000,0.0194286}, {8050,0.0194571}, {8100,0.0195429}, {8150,0.0197143}, {8200,0.0198286}, {8250,0.0199714}, {8300,0.0201714}, {8350,0.0202000}, {8400,0.0283714}, {8450,0.0205429}, {8500,0.0206571}, {8550,0.0325429}, {8600,0.0209429}, {8650,0.0314571}, {8700,0.0213714}, {8750,0.0223429}, {8800,0.0417429}, {8850,0.0217714}, {8900,0.0217714}, {8950,0.0219143}, {9000,0.0221143}, {9050,0.0221714}, {9100,0.0361429}, {9150,0.0224857}, {9200,0.0226571}, {9250,0.0226571}, {9300,0.0235714}, {9350,0.0467429}, {9400,0.0386571}, {9450,0.0318000}, {9500,0.0235429}, {9550,0.0536000}, {9600,0.0236286}, {9650,0.0366000}, {9700,0.0239429}, {9750,0.0239143}, {9800,0.0242286}, {9850,0.0578286}, {9900,0.0244286}, {9950,0.0245143}, {10000,0.0325429}, {10100,0.0251714}, {10200,0.0482000}, {10300,0.0613714}, {10400,0.0257714}, {10500,0.0258286}, {10600,0.0261143}, {10700,0.0265429}, {10800,0.0268286}, {10900,0.0547143}, {11000,0.0271714}, {11100,0.0498000}, {11200,0.0543143}, {11300,0.0280857}, {11400,0.0283714}, {11500,0.0284857}, {11600,0.0459429}, {11700,0.0290571}, {11800,0.0294000}, {11900,0.0296571}, {12000,0.0298857}, {12100,0.0301143}, {12200,0.0302000}, {12300,0.0509714}, {12400,0.0309143}, {12500,0.0496000}, {12600,0.0502286}, {12700,0.0317429}, {12800,0.0318286}, {12900,0.0322000}, {13000,0.0322857}, {13100,0.0622857}, {13200,0.0494000}, {13300,0.0332000}, {13400,0.0528000}, {13500,0.0338571}, {13600,0.0341714}, {13700,0.0654857}, {13800,0.0346571}, {13900,0.0347429}, {14000,0.0351429}, {14100,0.0356000}, {14200,0.0547714}, {14300,0.0360857}, {14400,0.0606286}, {14500,0.0703714}, {14600,0.0367714}, {14700,0.0688286}, {14800,0.0686000}, {14900,0.0373429}, {15000,0.0377714}, {15100,0.0381143}, {15200,0.0598000}, {15300,0.0386857}, {15400,0.0388000}, {15500,0.0742857}, {15600,0.0679429}, {15700,0.0676857}, {15800,0.0610000}, {15900,0.0783143}, {16000,0.0695143}, {16100,0.0404000}, {16200,0.0406286}, {16300,0.0411429}, {16400,0.0707714}, {16500,0.0594857}, {16600,0.0418000}, {16700,0.1288286}, {16800,0.0771143}, {16900,0.0426286}, {17000,0.0428571}, {17100,0.0650286}, {17200,0.0765143}, {17300,0.0626571}, {17400,0.0439714}, {17500,0.0744571}, {17600,0.0822571}, {17700,0.0616286}, {17800,0.0765714}, {17900,0.0451143}, {18000,0.0843429}, {18100,0.0458286}, {18200,0.0462000}, {18300,0.0466571}, {18400,0.0733143}, {18500,0.0720000}, {18600,0.0470000}, {18700,0.1021143}, {18800,0.0478286}, {18900,0.0472857}, {19000,0.0483143}, {19100,0.0693429}, {19200,0.0473429}, {19300,0.0492000}, {19400,0.0494571}, {19500,0.0498571}, {19600,0.0498286}, {19700,0.0872571}, {19800,0.0714571}, {19900,0.0499429}, {20000,0.1110857}};
data["big_flat"]["LtacTCGallinaCtx"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00002970}, {3,0.00000000}, {4,0.00006931}, {5,0.00003960}, {6,0.00002970}, {7,0.00006931}, {8,0.00000000}, {9,0.00003960}, {10,0.00006931}, {11,0.00007921}, {12,0.00006931}, {13,0.00003960}, {14,0.00006931}, {15,0.00002970}, {16,0.00005941}, {17,0.00010891}, {18,0.00006931}, {19,0.00003960}, {20,0.00010891}, {21,0.00007921}, {22,0.00002970}, {23,0.00010891}, {24,0.00010891}, {25,0.00000000}, {26,0.00002970}, {27,0.00002970}, {28,0.00002970}, {29,0.00002970}, {30,0.00000000}, {31,0.00000000}, {32,0.00002970}, {33,0.00003960}, {34,0.00003960}, {35,0.00017822}, {36,0.00007921}, {37,0.00020792}, {38,0.00000000}, {39,0.00009901}, {40,0.00014851}, {41,0.00014851}, {42,0.00003960}, {43,0.00012871}, {44,0.00002970}, {45,0.00010891}, {46,0.00000000}, {47,0.00021782}, {48,0.00007921}, {49,0.00006931}, {50,0.00015842}, {51,0.00029703}, {52,0.00006931}, {53,0.00015842}, {54,0.00000000}, {55,0.00029703}, {56,0.00009901}, {57,0.00005941}, {58,0.00007921}, {59,0.00009901}, {60,0.00024752}, {61,0.00005941}, {62,0.00020792}, {63,0.00013861}, {64,0.00008911}, {65,0.00018812}, {66,0.00014851}, {67,0.00018812}, {68,0.00005941}, {69,0.00016832}, {70,0.00011881}, {71,0.00015842}, {72,0.00011881}, {73,0.00026733}, {74,0.00012871}, {75,0.00015842}, {76,0.00015842}, {77,0.00019802}, {78,0.00017822}, {79,0.00022772}, {80,0.00009901}, {81,0.00013861}, {82,0.00034653}, {83,0.00021782}, {84,0.00021782}, {85,0.00025743}, {86,0.00008911}, {87,0.00015842}, {88,0.00018812}, {89,0.00002970}, {90,0.00011881}, {91,0.00021782}, {92,0.00025743}, {93,0.00005941}, {94,0.00018812}, {95,0.00041584}, {96,0.00019802}, {97,0.00005941}, {98,0.00026733}, {99,0.00019802}, {100,0.00034653}, {101,0.00011881}, {102,0.00010891}, {103,0.00018812}, {104,0.00025743}, {105,0.00015842}, {106,0.00009901}, {107,0.00021782}, {108,0.00015842}, {109,0.00014851}, {110,0.00015842}, {111,0.00020792}, {112,0.00011881}, {113,0.00019802}, {114,0.00013861}, {115,0.00028713}, {116,0.00010891}, {117,0.00030693}, {118,0.00018812}, {119,0.00020792}, {120,0.00016832}, {121,0.00031683}, {122,0.00024752}, {123,0.00032673}, {124,0.00026733}, {125,0.00032673}, {126,0.00024752}, {127,0.00025743}, {128,0.00021782}, {129,0.00028713}, {130,0.00028713}, {131,0.00034653}, {132,0.00026733}, {133,0.00033663}, {134,0.00021782}, {135,0.00028713}, {136,0.00014851}, {137,0.00040594}, {138,0.00023762}, {139,0.00029703}, {140,0.00025743}, {141,0.00013861}, {142,0.00027723}, {143,0.00034653}, {144,0.00030693}, {145,0.00019802}, {146,0.00020792}, {147,0.00035644}, {148,0.00036634}, {149,0.00010891}, {150,0.00039604}, {151,0.00036634}, {152,0.00022772}, {153,0.00028713}, {154,0.00029703}, {155,0.00034653}, {156,0.00050495}, {157,0.00028713}, {158,0.00024752}, {159,0.00016832}, {160,0.00039604}, {161,0.00040594}, {162,0.00038614}, {163,0.00037624}, {164,0.00027723}, {165,0.00046535}, {166,0.00024752}, {167,0.00045545}, {168,0.00035644}, {169,0.00021782}, {170,0.00028713}, {171,0.00025743}, {172,0.00042574}, {173,0.00033663}, {174,0.00021782}, {175,0.00047525}, {176,0.00037624}, {177,0.00055446}, {178,0.00040594}, {179,0.00049505}, {180,0.00006931}, {181,0.00028713}, {182,0.00018812}, {183,0.00031683}, {184,0.00048515}, {185,0.00048515}, {186,0.00020792}, {187,0.00044554}, {188,0.00034653}, {189,0.00047525}, {190,0.00051485}, {191,0.00027723}, {192,0.00045545}, {193,0.00057426}, {194,0.00027723}, {195,0.00038614}, {196,0.00026733}, {197,0.00049505}, {198,0.00045545}, {199,0.00056436}, {200,0.00034653}, {201,0.00040594}, {202,0.00045545}, {203,0.00032673}, {204,0.00070297}, {205,0.00017822}, {206,0.00051485}, {207,0.00042574}, {208,0.00025743}, {209,0.00025743}, {210,0.00029703}, {211,0.00047525}, {212,0.00051485}, {213,0.00035644}, {214,0.00032673}, {215,0.00043564}, {216,0.00045545}, {217,0.00046535}, {218,0.00040594}, {219,0.00058416}, {220,0.00036634}, {221,0.00043564}, {222,0.00053465}, {223,0.00051485}, {224,0.00027723}, {225,0.00032673}, {226,0.00049505}, {227,0.00024752}, {228,0.00050495}, {229,0.00040594}, {230,0.00052475}, {231,0.00047525}, {232,0.00053465}, {233,0.00064356}, {234,0.00066337}, {235,0.00048515}, {236,0.00052475}, {237,0.00045545}, {238,0.00050495}, {239,0.00037624}, {240,0.00054455}, {241,0.00041584}, {242,0.00038614}, {243,0.00055446}, {244,0.00027723}, {245,0.00033663}, {246,0.00065347}, {247,0.00041584}, {248,0.00047525}, {249,0.00054455}, {250,0.00032673}, {251,0.00047525}, {252,0.00044554}, {253,0.00050495}, {254,0.00030693}, {255,0.00075248}, {256,0.00053465}, {257,0.00057426}, {258,0.00034653}, {259,0.00039604}, {260,0.00056436}, {261,0.00056436}, {262,0.00063366}, {263,0.00036634}, {264,0.00058416}, {265,0.00064356}, {266,0.00055446}, {267,0.00031683}, {268,0.00045545}, {269,0.00077228}, {270,0.00054455}, {271,0.00072277}, {272,0.00047525}, {273,0.00036634}, {274,0.00058416}, {275,0.00047525}, {276,0.00046535}, {277,0.00063366}, {278,0.00059406}, {279,0.00035644}, {280,0.00081188}, {281,0.00047525}, {282,0.00038614}, {283,0.00041584}, {284,0.00048515}, {285,0.00060396}, {286,0.00032673}, {287,0.00020792}, {288,0.00061386}, {289,0.00048515}, {290,0.00043564}, {291,0.00052475}, {292,0.00056436}, {293,0.00064356}, {294,0.00050495}, {295,0.00046535}, {296,0.00046535}, {297,0.00066337}, {298,0.00050495}, {299,0.00047525}, {300,0.00034653}, {301,0.00042574}, {302,0.00048515}, {303,0.00045545}, {304,0.00047525}, {305,0.00063366}, {306,0.00051485}, {307,0.00068317}, {308,0.00041584}, {309,0.00043564}, {310,0.00057426}, {311,0.00089109}, {312,0.00055446}, {313,0.00053465}, {314,0.00045545}, {315,0.00063366}, {316,0.00046535}, {317,0.00063366}, {318,0.00052475}, {319,0.00037624}, {320,0.00068317}, {321,0.00070297}, {322,0.00055446}, {323,0.00049505}, {324,0.00074257}, {325,0.00037624}, {326,0.00057426}, {327,0.00050495}, {328,0.00053465}, {329,0.00074257}, {330,0.00068317}, {331,0.00044554}, {332,0.00075248}, {333,0.00049505}, {334,0.00068317}, {335,0.00061386}, {336,0.00055446}, {337,0.00067327}, {338,0.00051485}, {339,0.00089109}, {340,0.00079208}, {341,0.00059406}, {342,0.00039604}, {343,0.00082178}, {344,0.00042574}, {345,0.00063366}, {346,0.00056436}, {347,0.00052475}, {348,0.00079208}, {349,0.00059406}, {350,0.00068317}, {351,0.00050495}, {352,0.00092079}, {353,0.00055446}, {354,0.00059406}, {355,0.00031683}, {356,0.00074257}, {357,0.00071287}, {358,0.00054455}, {359,0.00071287}, {360,0.00078218}, {361,0.00052475}, {362,0.00097030}, {363,0.00072277}, {364,0.00066337}, {365,0.00060396}, {366,0.00071287}, {367,0.00063366}, {368,0.00082178}, {369,0.00037624}, {370,0.00059406}, {371,0.00076238}, {372,0.00065347}, {373,0.00044554}, {374,0.00089109}, {375,0.00100000}, {376,0.00064356}, {377,0.00077228}, {378,0.00055446}, {379,0.00170297}, {380,0.00065347}, {381,0.00082178}, {382,0.00096040}, {383,0.00074257}, {384,0.00085149}, {385,0.00077228}, {386,0.00075248}, {387,0.00109901}, {388,0.00082178}, {389,0.00108911}, {390,0.00061386}, {391,0.00059406}, {392,0.00070297}, {393,0.00074257}, {394,0.00080198}, {395,0.00088119}, {396,0.00051485}, {397,0.00064356}, {398,0.00082178}, {399,0.00071287}, {400,0.00073267}, {401,0.00078218}, {402,0.00086139}, {403,0.00077228}, {404,0.00108911}, {405,0.00076238}, {406,0.00110891}, {407,0.00053465}, {408,0.00073267}, {409,0.00071287}, {410,0.00070297}, {411,0.00075248}, {412,0.00121782}, {413,0.00054455}, {414,0.00095050}, {415,0.00075248}, {416,0.00106931}, {417,0.00083168}, {418,0.00075248}, {419,0.00082178}, {420,0.00079208}, {421,0.00067327}, {422,0.00113861}, {423,0.00075248}, {424,0.00099010}, {425,0.00056436}, {426,0.00181188}, {427,0.00085149}, {428,0.00091089}, {429,0.00086139}, {430,0.00074257}, {431,0.00105941}, {432,0.00080198}, {433,0.00109901}, {434,0.00072277}, {435,0.00090099}, {436,0.00064356}, {437,0.00077228}, {438,0.00084158}, {439,0.00112871}, {440,0.00091089}, {441,0.00113861}, {442,0.00082178}, {443,0.00066337}, {444,0.00107921}, {445,0.00087129}, {446,0.00083168}, {447,0.00076238}, {448,0.00082178}, {449,0.00091089}, {450,0.00106931}, {451,0.00089109}, {452,0.00100990}, {453,0.00090099}, {454,0.00084158}, {455,0.00082178}, {456,0.00072277}, {457,0.00077228}, {458,0.00082178}, {459,0.00074257}, {460,0.00102970}, {461,0.00171287}, {462,0.00088119}, {463,0.00049505}, {464,0.00106931}, {465,0.00118812}, {466,0.00085149}, {467,0.00080198}, {468,0.00088119}, {469,0.00128713}, {470,0.00084158}, {471,0.00101980}, {472,0.00074257}, {473,0.00070297}, {474,0.00105941}, {475,0.00118812}, {476,0.00089109}, {477,0.00098020}, {478,0.00101980}, {479,0.00115842}, {480,0.00104950}, {481,0.00102970}, {482,0.00078218}, {483,0.00087129}, {484,0.00093069}, {485,0.00089109}, {486,0.00078218}, {487,0.00088119}, {488,0.00079208}, {489,0.00099010}, {490,0.00094059}, {491,0.00079208}, {492,0.00069307}, {493,0.00094059}, {494,0.00092079}, {495,0.00098020}, {496,0.00090099}, {497,0.00079208}, {498,0.00121782}, {499,0.00071287}, {500,0.00081188}, {505,0.00111881}, {510,0.00089109}, {515,0.00090099}, {520,0.00114851}, {525,0.00105941}, {530,0.00121782}, {535,0.00129703}, {540,0.00079208}, {545,0.00116832}, {550,0.00103960}, {555,0.00074257}, {560,0.00115842}, {565,0.00104950}, {570,0.00118812}, {575,0.00099010}, {580,0.00076238}, {585,0.00099010}, {590,0.00084158}, {595,0.00100990}, {600,0.00107921}, {605,0.00100000}, {610,0.00111881}, {615,0.00100990}, {620,0.00128713}, {625,0.00115842}, {630,0.00100990}, {635,0.00111881}, {640,0.00117822}, {645,0.00114851}, {650,0.00089109}, {655,0.00115842}, {660,0.00105941}, {665,0.00090099}, {670,0.00118812}, {675,0.00088119}, {680,0.00126733}, {685,0.00100990}, {690,0.00141584}, {695,0.00110891}, {700,0.00117822}, {705,0.00125743}, {710,0.00130693}, {715,0.00147525}, {720,0.00131683}, {725,0.00325743}, {730,0.00126733}, {735,0.00142574}, {740,0.00136634}, {745,0.00152475}, {750,0.00114851}, {755,0.00135644}, {760,0.00161386}, {765,0.00099010}, {770,0.00131683}, {775,0.00128713}, {780,0.00126733}, {785,0.00092079}, {790,0.00164356}, {795,0.00131683}, {800,0.00135644}, {805,0.00140594}, {810,0.00122772}, {815,0.00147525}, {820,0.00150495}, {825,0.00130693}, {830,0.00136634}, {835,0.00142574}, {840,0.00156436}, {845,0.00152475}, {850,0.00147525}, {855,0.00178218}, {860,0.00171287}, {865,0.00165347}, {870,0.00141584}, {875,0.00147525}, {880,0.00138614}, {885,0.00159406}, {890,0.00147525}, {895,0.00164356}, {900,0.00192079}, {905,0.00162376}, {910,0.00157426}, {915,0.00172277}, {920,0.00171287}, {925,0.00167327}, {930,0.00168317}, {935,0.00139604}, {940,0.00136634}, {945,0.00174257}, {950,0.00171287}, {955,0.00138614}, {960,0.00158416}, {965,0.00126733}, {970,0.00174257}, {975,0.00173267}, {980,0.00161386}, {985,0.00151485}, {990,0.00145545}, {995,0.00172277}, {1000,0.00159406}, {1010,0.00210891}, {1020,0.00186139}, {1030,0.00154455}, {1040,0.00148515}, {1050,0.00496040}, {1060,0.00191089}, {1070,0.00201980}, {1080,0.00192079}, {1090,0.00164356}, {1100,0.00174257}, {1110,0.00202970}, {1120,0.00187129}, {1130,0.00201980}, {1140,0.00180198}, {1150,0.00190099}, {1160,0.00176238}, {1170,0.00207921}, {1180,0.00181188}, {1190,0.00187129}, {1200,0.00206931}, {1210,0.00212871}, {1220,0.00178218}, {1230,0.00229703}, {1240,0.00222772}, {1250,0.00199010}, {1260,0.00235644}, {1270,0.00241584}, {1280,0.00222772}, {1290,0.00234653}, {1300,0.00510891}, {1310,0.00229703}, {1320,0.00277228}, {1330,0.00237624}, {1340,0.00202970}, {1350,0.00243564}, {1360,0.00257426}, {1370,0.00241584}, {1380,0.00213861}, {1390,0.00236634}, {1400,0.00242574}, {1410,0.00211881}, {1420,0.00247525}, {1430,0.00257426}, {1440,0.00255446}, {1450,0.00253465}, {1460,0.00246535}, {1470,0.00291089}, {1480,0.00585149}, {1490,0.00264356}, {1500,0.00299010}, {1510,0.00299010}, {1520,0.00293069}, {1530,0.00285149}, {1540,0.00283168}, {1550,0.00274257}, {1560,0.00286139}, {1570,0.00311881}, {1580,0.00312871}, {1590,0.00307921}, {1600,0.00288119}, {1610,0.00565347}, {1620,0.00569307}, {1630,0.00311881}, {1640,0.00312871}, {1650,0.00316832}, {1660,0.00326733}, {1670,0.00303960}, {1680,0.00308911}, {1690,0.00301980}, {1700,0.00339604}, {1710,0.00321782}, {1720,0.00339604}, {1730,0.00330693}, {1740,0.00330693}, {1750,0.00320792}, {1760,0.00352475}, {1770,0.00313861}, {1780,0.00322772}, {1790,0.00360396}, {1800,0.00335644}, {1810,0.00343564}, {1820,0.00369307}, {1830,0.00331683}, {1840,0.00364356}, {1850,0.00370297}, {1860,0.00339604}, {1870,0.00352475}, {1880,0.00362376}, {1890,0.00370297}, {1900,0.00374257}, {1910,0.00364356}, {1920,0.00369307}, {1930,0.00377228}, {1940,0.00369307}, {1950,0.00372277}, {1960,0.00368317}, {1970,0.00525743}, {1980,0.00372277}, {1990,0.00378218}, {2000,0.00384158}, {2050,0.00377228}, {2100,0.00409901}, {2150,0.00407921}, {2200,0.00431683}, {2250,0.00413861}, {2300,0.00447525}, {2350,0.00436634}, {2400,0.00479208}, {2450,0.00487129}, {2500,0.00831683}, {2550,0.00510891}, {2600,0.00485149}, {2650,0.00545545}, {2700,0.00529703}, {2750,0.00546535}, {2800,0.00518812}, {2850,0.00938614}, {2900,0.00567327}, {2950,0.00539604}, {3000,0.00596040}, {3050,0.00588119}, {3100,0.00587129}, {3150,0.01281188}, {3200,0.00631683}, {3250,0.00641584}, {3300,0.00654455}, {3350,0.00659406}, {3400,0.00675248}, {3450,0.00672277}, {3500,0.00700000}, {3550,0.01164356}, {3600,0.00721782}, {3650,0.00711881}, {3700,0.00757426}, {3750,0.00772277}, {3800,0.00768317}, {3850,0.00752475}, {3900,0.00767327}, {3950,0.01259406}, {4000,0.00866337}, {4050,0.00854455}, {4100,0.00863366}, {4150,0.00866337}, {4200,0.00856436}, {4250,0.00890099}, {4300,0.00874257}, {4350,0.00857426}, {4400,0.00950495}, {4450,0.01325743}, {4500,0.00950495}, {4550,0.00934653}, {4600,0.00940594}, {4650,0.00977228}, {4700,0.00980198}, {4750,0.00970297}, {4800,0.01464356}, {4850,0.00992079}, {4900,0.01000990}, {4950,0.02099010}, {5000,0.01033663}, {5050,0.01088119}, {5100,0.01076238}, {5150,0.01100990}, {5200,0.02351485}, {5250,0.01132673}, {5300,0.01127723}, {5350,0.01141584}, {5400,0.01673267}, {5450,0.01153465}, {5500,0.01157426}, {5550,0.01181188}, {5600,0.01175248}, {5650,0.01199010}, {5700,0.01214851}, {5750,0.01226733}, {5800,0.01231683}, {5850,0.01240594}, {5900,0.02314851}, {5950,0.01245545}, {6000,0.01281188}, {6050,0.0218286}, {6100,0.0145429}, {6150,0.0140857}, {6200,0.0145429}, {6250,0.0147143}, {6300,0.0142571}, {6350,0.0149429}, {6400,0.0150000}, {6450,0.0322286}, {6500,0.0154286}, {6550,0.0266286}, {6600,0.0153429}, {6650,0.0156000}, {6700,0.0154857}, {6750,0.0158857}, {6800,0.0255429}, {6850,0.0162286}, {6900,0.0157714}, {6950,0.0161714}, {7000,0.0301714}, {7050,0.0166286}, {7100,0.0169143}, {7150,0.0168000}, {7200,0.0165429}, {7250,0.0170857}, {7300,0.0171714}, {7350,0.0286286}, {7400,0.0176000}, {7450,0.0176571}, {7500,0.0179143}, {7550,0.0179714}, {7600,0.0356571}, {7650,0.0183714}, {7700,0.0182000}, {7750,0.0181714}, {7800,0.0293714}, {7850,0.0340286}, {7900,0.0190286}, {7950,0.0187429}, {8000,0.0189714}, {8050,0.0189714}, {8100,0.0190857}, {8150,0.0198286}, {8200,0.0196286}, {8250,0.0205143}, {8300,0.0200571}, {8350,0.0208286}, {8400,0.0282571}, {8450,0.0205143}, {8500,0.0212000}, {8550,0.0325143}, {8600,0.0210857}, {8650,0.0319143}, {8700,0.0217429}, {8750,0.0216000}, {8800,0.0418000}, {8850,0.0217429}, {8900,0.0223429}, {8950,0.0221429}, {9000,0.0224000}, {9050,0.0220571}, {9100,0.0358286}, {9150,0.0231429}, {9200,0.0228286}, {9250,0.0224286}, {9300,0.0235429}, {9350,0.0470571}, {9400,0.0382857}, {9450,0.0318571}, {9500,0.0241143}, {9550,0.0538000}, {9600,0.0242286}, {9650,0.0362857}, {9700,0.0243714}, {9750,0.0245143}, {9800,0.0246000}, {9850,0.0577714}, {9900,0.0245143}, {9950,0.0251143}, {10000,0.0325143}, {10100,0.0258857}, {10200,0.0482000}, {10300,0.0613714}, {10400,0.0261143}, {10500,0.0262286}, {10600,0.0264000}, {10700,0.0270571}, {10800,0.0274571}, {10900,0.0548000}, {11000,0.0272000}, {11100,0.0501429}, {11200,0.0547714}, {11300,0.0281429}, {11400,0.0285714}, {11500,0.0286286}, {11600,0.0456000}, {11700,0.0294286}, {11800,0.0302000}, {11900,0.0297714}, {12000,0.0301143}, {12100,0.0302286}, {12200,0.0298286}, {12300,0.0510000}, {12400,0.0312286}, {12500,0.0498000}, {12600,0.0504571}, {12700,0.0315429}, {12800,0.0320857}, {12900,0.0315714}, {13000,0.0321143}, {13100,0.0618286}, {13200,0.0498857}, {13300,0.0338571}, {13400,0.0523714}, {13500,0.0336286}, {13600,0.0343143}, {13700,0.0653429}, {13800,0.0344857}, {13900,0.0350857}, {14000,0.0353143}, {14100,0.0358286}, {14200,0.0542571}, {14300,0.0360286}, {14400,0.0602571}, {14500,0.0701714}, {14600,0.0368000}, {14700,0.0686857}, {14800,0.0686000}, {14900,0.0373429}, {15000,0.0378000}, {15100,0.0385143}, {15200,0.0598571}, {15300,0.0382857}, {15400,0.0387143}, {15500,0.0742000}, {15600,0.0684000}, {15700,0.0679143}, {15800,0.0611429}, {15900,0.0785429}, {16000,0.0696000}, {16100,0.0398000}, {16200,0.0397714}, {16300,0.0414286}, {16400,0.0708857}, {16500,0.0594857}, {16600,0.0414571}, {16700,0.1280286}, {16800,0.0767714}, {16900,0.0429714}, {17000,0.0427429}, {17100,0.0650286}, {17200,0.0761714}, {17300,0.0626000}, {17400,0.0438571}, {17500,0.0747143}, {17600,0.0828571}, {17700,0.0612286}, {17800,0.0768000}, {17900,0.0455143}, {18000,0.0842571}, {18100,0.0462286}, {18200,0.0459714}, {18300,0.0461714}, {18400,0.0732571}, {18500,0.0722286}, {18600,0.0471143}, {18700,0.1022000}, {18800,0.0475143}, {18900,0.0473714}, {19000,0.0482286}, {19100,0.0696286}, {19200,0.0466857}, {19300,0.0494857}, {19400,0.0494857}, {19500,0.0491143}, {19600,0.0500286}, {19700,0.0876286}, {19800,0.0708857}, {19900,0.0503714}, {20000,0.1106000}};
data["big_flat"]["LtacTCGallinaCtx"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00002970}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00002970}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00002970}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00003960}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00003960}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003960}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00002970}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00003960}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00003960}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00003960}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00003960}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00003960}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00002970}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00003960}, {221,0.00000000}, {222,0.00003960}, {223,0.00000000}, {224,0.00003960}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00003960}, {236,0.00000000}, {237,0.00003960}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00003960}, {254,0.00000000}, {255,0.00003960}, {256,0.00000000}, {257,0.00003960}, {258,0.00000000}, {259,0.00003960}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00003960}, {264,0.00000000}, {265,0.00003960}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00003960}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00003960}, {277,0.00002970}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00003960}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00003960}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00003960}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00003960}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00003960}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00003960}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00007921}, {339,0.00000000}, {340,0.00003960}, {341,0.00003960}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00003960}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00003960}, {355,0.00003960}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00003960}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00003960}, {367,0.00000000}, {368,0.00003960}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00003960}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00003960}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00002970}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00003960}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00003960}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00003960}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00003960}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00003960}, {479,0.00000000}, {480,0.00003960}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00007921}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00002970}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00003960}, {585,0.00000000}, {590,0.00007921}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00003960}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00003960}, {675,0.00003960}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00007921}, {710,0.00003960}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00003960}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00003960}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00003960}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00003960}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00003960}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00003960}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00003960}, {985,0.00000000}, {990,0.00003960}, {995,0.00003960}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00003960}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003960}, {1290,0.00000000}, {1300,0.00003960}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00003960}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00003960}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00003960}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00011881}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00003960}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00003960}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00003960}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00003960}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00003960}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0001143}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000857}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0001143}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0001143}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0001143}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0002286}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0001143}, {15800,0.0001143}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0001143}, {16800,0.0001143}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000857}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0001143}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0002286}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0001143}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0002286}};
data["big_flat"]["LtacTCGallinaCtx"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00100000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00102970}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000990}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00004950}, {1400,0.00000990}, {1410,0.00001980}, {1420,0.00000990}, {1430,0.00003960}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00029703}, {1470,0.00002970}, {1480,0.00000000}, {1490,0.00045545}, {1500,0.00021782}, {1510,0.00022772}, {1520,0.00048515}, {1530,0.00047525}, {1540,0.00000990}, {1550,0.00009901}, {1560,0.00062376}, {1570,0.00012871}, {1580,0.00093069}, {1590,0.00059406}, {1600,0.00048515}, {1610,0.00043564}, {1620,0.00043564}, {1630,0.00056436}, {1640,0.00100000}, {1650,0.00013861}, {1660,0.00083168}, {1670,0.00037624}, {1680,0.00100000}, {1690,0.00072277}, {1700,0.00055446}, {1710,0.00047525}, {1720,0.00053465}, {1730,0.00100000}, {1740,0.00100000}, {1750,0.00100000}, {1760,0.00100000}, {1770,0.00100000}, {1780,0.00100000}, {1790,0.00100000}, {1800,0.00100000}, {1810,0.00100000}, {1820,0.00100000}, {1830,0.00100000}, {1840,0.00100000}, {1850,0.00100000}, {1860,0.00100000}, {1870,0.00100000}, {1880,0.00100000}, {1890,0.00100000}, {1900,0.00100000}, {1910,0.00100000}, {1920,0.00100000}, {1930,0.00100000}, {1940,0.00100000}, {1950,0.00100000}, {1960,0.00100000}, {1970,0.00100000}, {1980,0.00100000}, {1990,0.00100000}, {2000,0.00100000}, {2050,0.00100000}, {2100,0.00100000}, {2150,0.00100000}, {2200,0.00100000}, {2250,0.00100000}, {2300,0.00100000}, {2350,0.00100000}, {2400,0.00100000}, {2450,0.00100000}, {2500,0.00100000}, {2550,0.00100000}, {2600,0.00100000}, {2650,0.00100000}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00101980}, {3150,0.00105941}, {3200,0.00100000}, {3250,0.00158416}, {3300,0.00122772}, {3350,0.00153465}, {3400,0.00167327}, {3450,0.00194059}, {3500,0.00165347}, {3550,0.00198020}, {3600,0.00200000}, {3650,0.00200000}, {3700,0.00198020}, {3750,0.00649505}, {3800,0.00200000}, {3850,0.00200000}, {3900,0.00200000}, {3950,0.00200000}, {4000,0.00200000}, {4050,0.00200000}, {4100,0.00200990}, {4150,0.00200000}, {4200,0.00202970}, {4250,0.00200990}, {4300,0.00200000}, {4350,0.00200000}, {4400,0.00202970}, {4450,0.00205941}, {4500,0.00793069}, {4550,0.00209901}, {4600,0.00205941}, {4650,0.00206931}, {4700,0.00211881}, {4750,0.00217822}, {4800,0.00209901}, {4850,0.00227723}, {4900,0.00221782}, {4950,0.00222772}, {5000,0.00274257}, {5050,0.00271287}, {5100,0.00270297}, {5150,0.00273267}, {5200,0.00286139}, {5250,0.00286139}, {5300,0.00300990}, {5350,0.00302970}, {5400,0.00930693}, {5450,0.00305941}, {5500,0.00303960}, {5550,0.00304950}, {5600,0.00305941}, {5650,0.00306931}, {5700,0.00306931}, {5750,0.00307921}, {5800,0.00307921}, {5850,0.00309901}, {5900,0.00311881}, {5950,0.00310891}, {6000,0.00309901}, {6050,0.0154000}, {6100,0.0042571}, {6150,0.0043714}, {6200,0.0044857}, {6250,0.0044000}, {6300,0.0046000}, {6350,0.0046000}, {6400,0.0048857}, {6450,0.0047143}, {6500,0.0048857}, {6550,0.0046286}, {6600,0.0045143}, {6650,0.0082000}, {6700,0.0050000}, {6750,0.0050000}, {6800,0.0054000}, {6850,0.0053143}, {6900,0.0055143}, {6950,0.0055429}, {7000,0.0052571}, {7050,0.0053429}, {7100,0.0055714}, {7150,0.0056286}, {7200,0.0055429}, {7250,0.0056857}, {7300,0.0056000}, {7350,0.0058571}, {7400,0.0057714}, {7450,0.0058571}, {7500,0.0061143}, {7550,0.0059429}, {7600,0.0060571}, {7650,0.0060857}, {7700,0.0062857}, {7750,0.0063429}, {7800,0.0065143}, {7850,0.0065143}, {7900,0.0055429}, {7950,0.0066286}, {8000,0.0065714}, {8050,0.0065143}, {8100,0.0066286}, {8150,0.0067429}, {8200,0.0066286}, {8250,0.0068571}, {8300,0.0101143}, {8350,0.0072857}, {8400,0.0068571}, {8450,0.0073143}, {8500,0.0075714}, {8550,0.0072571}, {8600,0.0072857}, {8650,0.0076286}, {8700,0.0076000}, {8750,0.0077143}, {8800,0.0078571}, {8850,0.0077429}, {8900,0.0078286}, {8950,0.0077714}, {9000,0.0066286}, {9050,0.0078857}, {9100,0.0078286}, {9150,0.0078571}, {9200,0.0067429}, {9250,0.0082286}, {9300,0.0150286}, {9350,0.0084571}, {9400,0.0086286}, {9450,0.0084000}, {9500,0.0083429}, {9550,0.0083714}, {9600,0.0086000}, {9650,0.0085429}, {9700,0.0088000}, {9750,0.0088286}, {9800,0.0089143}, {9850,0.0088857}, {9900,0.0088857}, {9950,0.0089143}, {10000,0.0089143}, {10100,0.0089143}, {10200,0.0130286}, {10300,0.0089429}, {10400,0.0083714}, {10500,0.0093429}, {10600,0.0092286}, {10700,0.0094286}, {10800,0.0097714}, {10900,0.0097143}, {11000,0.0097714}, {11100,0.0097714}, {11200,0.0098000}, {11300,0.0098000}, {11400,0.0196000}, {11500,0.0102857}, {11600,0.0294000}, {11700,0.0105714}, {11800,0.0187429}, {11900,0.0224000}, {12000,0.0106857}, {12100,0.0107714}, {12200,0.0107714}, {12300,0.0107429}, {12400,0.0108857}, {12500,0.0108000}, {12600,0.0109429}, {12700,0.0109429}, {12800,0.0112571}, {12900,0.0114571}, {13000,0.0115143}, {13100,0.0115714}, {13200,0.0115429}, {13300,0.0116571}, {13400,0.0117143}, {13500,0.0117143}, {13600,0.0118286}, {13700,0.0118286}, {13800,0.0106286}, {13900,0.0122286}, {14000,0.0123143}, {14100,0.0125143}, {14200,0.0126000}, {14300,0.0127429}, {14400,0.0283714}, {14500,0.0128286}, {14600,0.0217429}, {14700,0.0128286}, {14800,0.0132286}, {14900,0.0132571}, {15000,0.0133714}, {15100,0.0133714}, {15200,0.0133714}, {15300,0.0133714}, {15400,0.0133714}, {15500,0.0422857}, {15600,0.0136857}, {15700,0.0234571}, {15800,0.0137143}, {15900,0.0139429}, {16000,0.0140000}, {16100,0.0141429}, {16200,0.0142857}, {16300,0.0143143}, {16400,0.0144000}, {16500,0.0125143}, {16600,0.0400286}, {16700,0.0145429}, {16800,0.0146571}, {16900,0.0146857}, {17000,0.0148571}, {17100,0.0151429}, {17200,0.0152571}, {17300,0.0152000}, {17400,0.0153143}, {17500,0.0286000}, {17600,0.0153714}, {17700,0.0153714}, {17800,0.0133714}, {17900,0.0135429}, {18000,0.0157143}, {18100,0.0156571}, {18200,0.0160286}, {18300,0.0162571}, {18400,0.0162857}, {18500,0.0163429}, {18600,0.0163714}, {18700,0.0163429}, {18800,0.0163429}, {18900,0.0165143}, {19000,0.0164286}, {19100,0.0166857}, {19200,0.0170000}, {19300,0.0145429}, {19400,0.0172000}, {19500,0.0174000}, {19600,0.0173143}, {19700,0.0163429}, {19800,0.0173714}, {19900,0.0318857}, {20000,0.0173429}};
data["big_flat"]["LtacTCGallinaCtx"]["eval lazy"]["user"] = {{1,0.00000000}, {2,0.00003960}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00009901}, {7,0.00011881}, {8,0.00002970}, {9,0.00002970}, {10,0.00000000}, {11,0.00007921}, {12,0.00002970}, {13,0.00002970}, {14,0.00006931}, {15,0.00002970}, {16,0.00000000}, {17,0.00000000}, {18,0.00003960}, {19,0.00002970}, {20,0.00003960}, {21,0.00003960}, {22,0.00006931}, {23,0.00002970}, {24,0.00002970}, {25,0.00002970}, {26,0.00003960}, {27,0.00000000}, {28,0.00009901}, {29,0.00003960}, {30,0.00006931}, {31,0.00002970}, {32,0.00014851}, {33,0.00005941}, {34,0.00003960}, {35,0.00003960}, {36,0.00013861}, {37,0.00002970}, {38,0.00006931}, {39,0.00000000}, {40,0.00006931}, {41,0.00006931}, {42,0.00009901}, {43,0.00006931}, {44,0.00006931}, {45,0.00003960}, {46,0.00005941}, {47,0.00005941}, {48,0.00002970}, {49,0.00003960}, {50,0.00002970}, {51,0.00018812}, {52,0.00002970}, {53,0.00006931}, {54,0.00010891}, {55,0.00006931}, {56,0.00006931}, {57,0.00003960}, {58,0.00000000}, {59,0.00006931}, {60,0.00006931}, {61,0.00010891}, {62,0.00002970}, {63,0.00000000}, {64,0.00003960}, {65,0.00005941}, {66,0.00017822}, {67,0.00002970}, {68,0.00011881}, {69,0.00010891}, {70,0.00008911}, {71,0.00011881}, {72,0.00002970}, {73,0.00008911}, {74,0.00021782}, {75,0.00002970}, {76,0.00015842}, {77,0.00003960}, {78,0.00008911}, {79,0.00018812}, {80,0.00005941}, {81,0.00006931}, {82,0.00006931}, {83,0.00012871}, {84,0.00002970}, {85,0.00009901}, {86,0.00000000}, {87,0.00015842}, {88,0.00012871}, {89,0.00002970}, {90,0.00008911}, {91,0.00009901}, {92,0.00005941}, {93,0.00008911}, {94,0.00009901}, {95,0.00013861}, {96,0.00013861}, {97,0.00017822}, {98,0.00005941}, {99,0.00005941}, {100,0.00002970}, {101,0.00013861}, {102,0.00020792}, {103,0.00014851}, {104,0.00012871}, {105,0.00014851}, {106,0.00006931}, {107,0.00010891}, {108,0.00012871}, {109,0.00006931}, {110,0.00005941}, {111,0.00012871}, {112,0.00011881}, {113,0.00014851}, {114,0.00000000}, {115,0.00002970}, {116,0.00009901}, {117,0.00009901}, {118,0.00012871}, {119,0.00000000}, {120,0.00016832}, {121,0.00005941}, {122,0.00005941}, {123,0.00017822}, {124,0.00012871}, {125,0.00120792}, {126,0.00014851}, {127,0.00008911}, {128,0.00009901}, {129,0.00002970}, {130,0.00008911}, {131,0.00006931}, {132,0.00020792}, {133,0.00014851}, {134,0.00002970}, {135,0.00009901}, {136,0.00011881}, {137,0.00006931}, {138,0.00000000}, {139,0.00000000}, {140,0.00015842}, {141,0.00015842}, {142,0.00018812}, {143,0.00003960}, {144,0.00003960}, {145,0.00000000}, {146,0.00017822}, {147,0.00019802}, {148,0.00013861}, {149,0.00008911}, {150,0.00018812}, {151,0.00011881}, {152,0.00003960}, {153,0.00011881}, {154,0.00007921}, {155,0.00020792}, {156,0.00011881}, {157,0.00025743}, {158,0.00012871}, {159,0.00002970}, {160,0.00006931}, {161,0.00010891}, {162,0.00026733}, {163,0.00028713}, {164,0.00016832}, {165,0.00013861}, {166,0.00019802}, {167,0.00031683}, {168,0.00003960}, {169,0.00009901}, {170,0.00010891}, {171,0.00018812}, {172,0.00019802}, {173,0.00025743}, {174,0.00020792}, {175,0.00006931}, {176,0.00022772}, {177,0.00012871}, {178,0.00010891}, {179,0.00012871}, {180,0.00022772}, {181,0.00014851}, {182,0.00006931}, {183,0.00010891}, {184,0.00022772}, {185,0.00006931}, {186,0.00012871}, {187,0.00015842}, {188,0.00009901}, {189,0.00027723}, {190,0.00018812}, {191,0.00007921}, {192,0.00013861}, {193,0.00021782}, {194,0.00022772}, {195,0.00011881}, {196,0.00011881}, {197,0.00002970}, {198,0.00007921}, {199,0.00006931}, {200,0.00016832}, {201,0.00000000}, {202,0.00005941}, {203,0.00018812}, {204,0.00023762}, {205,0.00007921}, {206,0.00012871}, {207,0.00022772}, {208,0.00010891}, {209,0.00019802}, {210,0.00033663}, {211,0.00010891}, {212,0.00022772}, {213,0.00030693}, {214,0.00013861}, {215,0.00016832}, {216,0.00020792}, {217,0.00010891}, {218,0.00017822}, {219,0.00026733}, {220,0.00005941}, {221,0.00025743}, {222,0.00018812}, {223,0.00016832}, {224,0.00024752}, {225,0.00024752}, {226,0.00018812}, {227,0.00018812}, {228,0.00014851}, {229,0.00021782}, {230,0.00021782}, {231,0.00017822}, {232,0.00015842}, {233,0.00020792}, {234,0.00009901}, {235,0.00017822}, {236,0.00009901}, {237,0.00012871}, {238,0.00016832}, {239,0.00022772}, {240,0.00013861}, {241,0.00011881}, {242,0.00012871}, {243,0.00019802}, {244,0.00014851}, {245,0.00021782}, {246,0.00027723}, {247,0.00020792}, {248,0.00015842}, {249,0.00008911}, {250,0.00006931}, {251,0.00012871}, {252,0.00012871}, {253,0.00027723}, {254,0.00026733}, {255,0.00018812}, {256,0.00026733}, {257,0.00023762}, {258,0.00011881}, {259,0.00026733}, {260,0.00024752}, {261,0.00016832}, {262,0.00019802}, {263,0.00018812}, {264,0.00009901}, {265,0.00016832}, {266,0.00013861}, {267,0.00028713}, {268,0.00009901}, {269,0.00022772}, {270,0.00027723}, {271,0.00016832}, {272,0.00015842}, {273,0.00012871}, {274,0.00008911}, {275,0.00011881}, {276,0.00016832}, {277,0.00038614}, {278,0.00027723}, {279,0.00015842}, {280,0.00017822}, {281,0.00022772}, {282,0.00006931}, {283,0.00019802}, {284,0.00015842}, {285,0.00031683}, {286,0.00022772}, {287,0.00025743}, {288,0.00018812}, {289,0.00019802}, {290,0.00016832}, {291,0.00025743}, {292,0.00015842}, {293,0.00038614}, {294,0.00029703}, {295,0.00045545}, {296,0.00025743}, {297,0.00019802}, {298,0.00012871}, {299,0.00015842}, {300,0.00023762}, {301,0.00024752}, {302,0.00028713}, {303,0.00018812}, {304,0.00020792}, {305,0.00023762}, {306,0.00015842}, {307,0.00017822}, {308,0.00023762}, {309,0.00018812}, {310,0.00019802}, {311,0.00019802}, {312,0.00029703}, {313,0.00036634}, {314,0.00018812}, {315,0.00026733}, {316,0.00016832}, {317,0.00037624}, {318,0.00014851}, {319,0.00005941}, {320,0.00015842}, {321,0.00018812}, {322,0.00028713}, {323,0.00040594}, {324,0.00020792}, {325,0.00038614}, {326,0.00022772}, {327,0.00013861}, {328,0.00038614}, {329,0.00025743}, {330,0.00019802}, {331,0.00019802}, {332,0.00019802}, {333,0.00033663}, {334,0.00021782}, {335,0.00008911}, {336,0.00031683}, {337,0.00030693}, {338,0.00038614}, {339,0.00017822}, {340,0.00016832}, {341,0.00018812}, {342,0.00005941}, {343,0.00008911}, {344,0.00025743}, {345,0.00030693}, {346,0.00029703}, {347,0.00023762}, {348,0.00019802}, {349,0.00022772}, {350,0.00025743}, {351,0.00027723}, {352,0.00025743}, {353,0.00041584}, {354,0.00017822}, {355,0.00018812}, {356,0.00017822}, {357,0.00027723}, {358,0.00006931}, {359,0.00032673}, {360,0.00028713}, {361,0.00033663}, {362,0.00025743}, {363,0.00037624}, {364,0.00023762}, {365,0.00026733}, {366,0.00030693}, {367,0.00036634}, {368,0.00025743}, {369,0.00033663}, {370,0.00030693}, {371,0.00025743}, {372,0.00025743}, {373,0.00018812}, {374,0.00028713}, {375,0.00019802}, {376,0.00031683}, {377,0.00029703}, {378,0.00017822}, {379,0.00035644}, {380,0.00028713}, {381,0.00014851}, {382,0.00012871}, {383,0.00014851}, {384,0.00032673}, {385,0.00034653}, {386,0.00027723}, {387,0.00039604}, {388,0.00020792}, {389,0.00042574}, {390,0.00022772}, {391,0.00049505}, {392,0.00020792}, {393,0.00022772}, {394,0.00025743}, {395,0.00054455}, {396,0.00028713}, {397,0.00021782}, {398,0.00017822}, {399,0.00037624}, {400,0.00022772}, {401,0.00031683}, {402,0.00018812}, {403,0.00022772}, {404,0.00032673}, {405,0.00035644}, {406,0.00045545}, {407,0.00028713}, {408,0.00038614}, {409,0.00058416}, {410,0.00021782}, {411,0.00012871}, {412,0.00015842}, {413,0.00036634}, {414,0.00042574}, {415,0.00033663}, {416,0.00029703}, {417,0.00054455}, {418,0.00028713}, {419,0.00014851}, {420,0.00040594}, {421,0.00033663}, {422,0.00015842}, {423,0.00022772}, {424,0.00037624}, {425,0.00039604}, {426,0.00035644}, {427,0.00029703}, {428,0.00037624}, {429,0.00018812}, {430,0.00041584}, {431,0.00028713}, {432,0.00025743}, {433,0.00023762}, {434,0.00034653}, {435,0.00033663}, {436,0.00036634}, {437,0.00028713}, {438,0.00018812}, {439,0.00049505}, {440,0.00029703}, {441,0.00037624}, {442,0.00009901}, {443,0.00019802}, {444,0.00028713}, {445,0.00024752}, {446,0.00049505}, {447,0.00051485}, {448,0.00030693}, {449,0.00029703}, {450,0.00026733}, {451,0.00025743}, {452,0.00036634}, {453,0.00023762}, {454,0.00041584}, {455,0.00032673}, {456,0.00034653}, {457,0.00037624}, {458,0.00041584}, {459,0.00034653}, {460,0.00029703}, {461,0.00040594}, {462,0.00020792}, {463,0.00043564}, {464,0.00041584}, {465,0.00027723}, {466,0.00029703}, {467,0.00040594}, {468,0.00030693}, {469,0.00032673}, {470,0.00047525}, {471,0.00012871}, {472,0.00047525}, {473,0.00048515}, {474,0.00030693}, {475,0.00015842}, {476,0.00039604}, {477,0.00035644}, {478,0.00018812}, {479,0.00036634}, {480,0.00035644}, {481,0.00067327}, {482,0.00038614}, {483,0.00035644}, {484,0.00032673}, {485,0.00018812}, {486,0.00017822}, {487,0.00047525}, {488,0.00067327}, {489,0.00041584}, {490,0.00021782}, {491,0.00033663}, {492,0.00037624}, {493,0.00034653}, {494,0.00032673}, {495,0.00039604}, {496,0.00032673}, {497,0.00054455}, {498,0.00045545}, {499,0.00037624}, {500,0.00034653}, {505,0.00033663}, {510,0.00046535}, {515,0.00021782}, {520,0.00040594}, {525,0.00041584}, {530,0.00020792}, {535,0.00024752}, {540,0.00029703}, {545,0.00034653}, {550,0.00017822}, {555,0.00044554}, {560,0.00049505}, {565,0.00065347}, {570,0.00025743}, {575,0.00041584}, {580,0.00036634}, {585,0.00034653}, {590,0.00055446}, {595,0.00038614}, {600,0.00031683}, {605,0.00036634}, {610,0.00038614}, {615,0.00056436}, {620,0.00030693}, {625,0.00027723}, {630,0.00048515}, {635,0.00051485}, {640,0.00039604}, {645,0.00028713}, {650,0.00039604}, {655,0.00042574}, {660,0.00030693}, {665,0.00041584}, {670,0.00038614}, {675,0.00028713}, {680,0.00045545}, {685,0.00052475}, {690,0.00041584}, {695,0.00057426}, {700,0.00033663}, {705,0.00052475}, {710,0.00050495}, {715,0.00051485}, {720,0.00029703}, {725,0.00042574}, {730,0.00041584}, {735,0.00040594}, {740,0.00047525}, {745,0.00065347}, {750,0.00063366}, {755,0.00042574}, {760,0.00034653}, {765,0.00035644}, {770,0.00015842}, {775,0.00063366}, {780,0.00057426}, {785,0.00051485}, {790,0.00052475}, {795,0.00060396}, {800,0.00060396}, {805,0.00040594}, {810,0.00050495}, {815,0.00072277}, {820,0.00035644}, {825,0.00062376}, {830,0.00035644}, {835,0.00039604}, {840,0.00038614}, {845,0.00035644}, {850,0.00060396}, {855,0.00040594}, {860,0.00050495}, {865,0.00047525}, {870,0.00139604}, {875,0.00057426}, {880,0.00039604}, {885,0.00042574}, {890,0.00062376}, {895,0.00067327}, {900,0.00051485}, {905,0.00052475}, {910,0.00058416}, {915,0.00048515}, {920,0.00051485}, {925,0.00026733}, {930,0.00063366}, {935,0.00076238}, {940,0.00071287}, {945,0.00033663}, {950,0.00052475}, {955,0.00061386}, {960,0.00082178}, {965,0.00049505}, {970,0.00062376}, {975,0.00053465}, {980,0.00048515}, {985,0.00062376}, {990,0.00086139}, {995,0.00046535}, {1000,0.00048515}, {1010,0.00036634}, {1020,0.00081188}, {1030,0.00045545}, {1040,0.00049505}, {1050,0.00070297}, {1060,0.00078218}, {1070,0.00049505}, {1080,0.00083168}, {1090,0.00073267}, {1100,0.00071287}, {1110,0.00067327}, {1120,0.00087129}, {1130,0.00077228}, {1140,0.00068317}, {1150,0.00055446}, {1160,0.00050495}, {1170,0.00052475}, {1180,0.00060396}, {1190,0.00064356}, {1200,0.00042574}, {1210,0.00062376}, {1220,0.00072277}, {1230,0.00068317}, {1240,0.00070297}, {1250,0.00065347}, {1260,0.00066337}, {1270,0.00075248}, {1280,0.00049505}, {1290,0.00091089}, {1300,0.00076238}, {1310,0.00086139}, {1320,0.00105941}, {1330,0.00077228}, {1340,0.00056436}, {1350,0.00067327}, {1360,0.00084158}, {1370,0.00056436}, {1380,0.00063366}, {1390,0.00068317}, {1400,0.00071287}, {1410,0.00081188}, {1420,0.00084158}, {1430,0.00092079}, {1440,0.00064356}, {1450,0.00074257}, {1460,0.00094059}, {1470,0.00111881}, {1480,0.00088119}, {1490,0.00094059}, {1500,0.00100990}, {1510,0.00100000}, {1520,0.00059406}, {1530,0.00092079}, {1540,0.00068317}, {1550,0.00089109}, {1560,0.00098020}, {1570,0.00072277}, {1580,0.00098020}, {1590,0.00097030}, {1600,0.00100990}, {1610,0.00092079}, {1620,0.00066337}, {1630,0.00106931}, {1640,0.00098020}, {1650,0.00094059}, {1660,0.00101980}, {1670,0.00084158}, {1680,0.00089109}, {1690,0.00100000}, {1700,0.00086139}, {1710,0.00070297}, {1720,0.00092079}, {1730,0.00088119}, {1740,0.00125743}, {1750,0.00098020}, {1760,0.00088119}, {1770,0.00097030}, {1780,0.00067327}, {1790,0.00056436}, {1800,0.00091089}, {1810,0.00102970}, {1820,0.00106931}, {1830,0.00115842}, {1840,0.00107921}, {1850,0.00111881}, {1860,0.00122772}, {1870,0.00100000}, {1880,0.00107921}, {1890,0.00118812}, {1900,0.00110891}, {1910,0.00107921}, {1920,0.00117822}, {1930,0.00118812}, {1940,0.00153465}, {1950,0.00138614}, {1960,0.00089109}, {1970,0.00117822}, {1980,0.00131683}, {1990,0.00103960}, {2000,0.00097030}, {2050,0.00104950}, {2100,0.00123762}, {2150,0.00116832}, {2200,0.00117822}, {2250,0.00123762}, {2300,0.00125743}, {2350,0.00157426}, {2400,0.00142574}, {2450,0.00098020}, {2500,0.00121782}, {2550,0.00182178}, {2600,0.00140594}, {2650,0.00124752}, {2700,0.00166337}, {2750,0.00165347}, {2800,0.00176238}, {2850,0.00132673}, {2900,0.00162376}, {2950,0.00203960}, {3000,0.00169307}, {3050,0.00163366}, {3100,0.00158416}, {3150,0.00187129}, {3200,0.00175248}, {3250,0.00198020}, {3300,0.00176238}, {3350,0.00183168}, {3400,0.00164356}, {3450,0.00182178}, {3500,0.00199010}, {3550,0.00180198}, {3600,0.00181188}, {3650,0.00199010}, {3700,0.00220792}, {3750,0.00632673}, {3800,0.00223762}, {3850,0.00206931}, {3900,0.00238614}, {3950,0.00195050}, {4000,0.00228713}, {4050,0.00204950}, {4100,0.00229703}, {4150,0.00192079}, {4200,0.00231683}, {4250,0.00236634}, {4300,0.00229703}, {4350,0.00244554}, {4400,0.00229703}, {4450,0.00247525}, {4500,0.00802970}, {4550,0.00258416}, {4600,0.00281188}, {4650,0.00287129}, {4700,0.00265347}, {4750,0.00269307}, {4800,0.00284158}, {4850,0.00299010}, {4900,0.00292079}, {4950,0.00300000}, {5000,0.00296040}, {5050,0.00311881}, {5100,0.00262376}, {5150,0.00283168}, {5200,0.00298020}, {5250,0.00307921}, {5300,0.00312871}, {5350,0.00309901}, {5400,0.00931683}, {5450,0.00336634}, {5500,0.00344554}, {5550,0.00331683}, {5600,0.00332673}, {5650,0.00334653}, {5700,0.00324752}, {5750,0.00342574}, {5800,0.00338614}, {5850,0.00359406}, {5900,0.00360396}, {5950,0.00336634}, {6000,0.00337624}, {6050,0.0151714}, {6100,0.0038571}, {6150,0.0036000}, {6200,0.0042000}, {6250,0.0043429}, {6300,0.0042286}, {6350,0.0046857}, {6400,0.0045143}, {6450,0.0046286}, {6500,0.0043429}, {6550,0.0047429}, {6600,0.0044000}, {6650,0.0076571}, {6700,0.0053714}, {6750,0.0055429}, {6800,0.0051429}, {6850,0.0054857}, {6900,0.0056286}, {6950,0.0052571}, {7000,0.0057429}, {7050,0.0057714}, {7100,0.0052571}, {7150,0.0057143}, {7200,0.0054571}, {7250,0.0056286}, {7300,0.0059143}, {7350,0.0061429}, {7400,0.0061714}, {7450,0.0055143}, {7500,0.0058000}, {7550,0.0065429}, {7600,0.0059429}, {7650,0.0062286}, {7700,0.0066286}, {7750,0.0064000}, {7800,0.0061429}, {7850,0.0067429}, {7900,0.0054286}, {7950,0.0063714}, {8000,0.0068286}, {8050,0.0067714}, {8100,0.0066000}, {8150,0.0067429}, {8200,0.0065429}, {8250,0.0064286}, {8300,0.0099429}, {8350,0.0068571}, {8400,0.0068000}, {8450,0.0068000}, {8500,0.0072286}, {8550,0.0070571}, {8600,0.0074286}, {8650,0.0073143}, {8700,0.0073143}, {8750,0.0079714}, {8800,0.0078286}, {8850,0.0080000}, {8900,0.0080571}, {8950,0.0075143}, {9000,0.0065143}, {9050,0.0084857}, {9100,0.0077143}, {9150,0.0080857}, {9200,0.0066000}, {9250,0.0087429}, {9300,0.0147143}, {9350,0.0086286}, {9400,0.0085429}, {9450,0.0086857}, {9500,0.0082857}, {9550,0.0088000}, {9600,0.0089429}, {9650,0.0087714}, {9700,0.0088000}, {9750,0.0087714}, {9800,0.0090571}, {9850,0.0092857}, {9900,0.0088000}, {9950,0.0092571}, {10000,0.0090571}, {10100,0.0092286}, {10200,0.0130571}, {10300,0.0090857}, {10400,0.0089143}, {10500,0.0095143}, {10600,0.0094571}, {10700,0.0097714}, {10800,0.0092571}, {10900,0.0094857}, {11000,0.0093714}, {11100,0.0098857}, {11200,0.0102857}, {11300,0.0106286}, {11400,0.0193714}, {11500,0.0108000}, {11600,0.0294000}, {11700,0.0108000}, {11800,0.0190571}, {11900,0.0226571}, {12000,0.0105429}, {12100,0.0106571}, {12200,0.0108571}, {12300,0.0107143}, {12400,0.0105714}, {12500,0.0112286}, {12600,0.0108571}, {12700,0.0111429}, {12800,0.0106857}, {12900,0.0111714}, {13000,0.0113429}, {13100,0.0111429}, {13200,0.0117714}, {13300,0.0116000}, {13400,0.0117143}, {13500,0.0114000}, {13600,0.0113429}, {13700,0.0113429}, {13800,0.0106000}, {13900,0.0116857}, {14000,0.0123143}, {14100,0.0123714}, {14200,0.0121714}, {14300,0.0124571}, {14400,0.0287429}, {14500,0.0126857}, {14600,0.0216286}, {14700,0.0133714}, {14800,0.0130286}, {14900,0.0133429}, {15000,0.0133429}, {15100,0.0133143}, {15200,0.0132000}, {15300,0.0139714}, {15400,0.0132571}, {15500,0.0420857}, {15600,0.0131714}, {15700,0.0237143}, {15800,0.0138857}, {15900,0.0140000}, {16000,0.0137714}, {16100,0.0144286}, {16200,0.0140857}, {16300,0.0147714}, {16400,0.0150571}, {16500,0.0123429}, {16600,0.0396286}, {16700,0.0151429}, {16800,0.0144571}, {16900,0.0147143}, {17000,0.0150000}, {17100,0.0152000}, {17200,0.0150571}, {17300,0.0153143}, {17400,0.0150857}, {17500,0.0291429}, {17600,0.0157429}, {17700,0.0157714}, {17800,0.0130000}, {17900,0.0137714}, {18000,0.0157714}, {18100,0.0158857}, {18200,0.0158286}, {18300,0.0160571}, {18400,0.0164286}, {18500,0.0165429}, {18600,0.0165714}, {18700,0.0166286}, {18800,0.0162857}, {18900,0.0166286}, {19000,0.0163714}, {19100,0.0169714}, {19200,0.0169714}, {19300,0.0147714}, {19400,0.0165143}, {19500,0.0170857}, {19600,0.0169143}, {19700,0.0162571}, {19800,0.0177143}, {19900,0.0319429}, {20000,0.0180286}};
data["big_flat"]["LtacTCGallinaCtx"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00002970}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00003960}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00003960}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00003960}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00002970}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00003960}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00003960}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00003960}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00003960}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00003960}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00002970}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00003960}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00003960}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00003960}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00002970}, {750,0.00002970}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00003960}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00003960}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00003960}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00003960}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00003960}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00003960}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00003960}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00003960}, {1450,0.00003960}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00003960}, {1640,0.00003960}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00003960}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00003960}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00003960}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00003960}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00007921}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00003960}, {2600,0.00000000}, {2650,0.00003960}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00003960}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00003960}, {3200,0.00003960}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00003960}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00003960}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00003960}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00003960}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00003960}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00003960}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00003960}, {5400,0.00000000}, {5450,0.00003960}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00003960}, {5650,0.00003960}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0005429}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0001143}, {6300,0.0002000}, {6350,0.0000000}, {6400,0.0001143}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0001143}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0001143}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0001143}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0001143}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0001143}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0001143}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0001143}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0002000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0001143}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0001143}, {9750,0.0000000}, {9800,0.0001143}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0001143}, {10400,0.0000000}, {10500,0.0001143}, {10600,0.0001143}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0001143}, {13100,0.0000000}, {13200,0.0001143}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0001143}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0001143}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0001143}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0001143}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0001143}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0001143}, {17100,0.0001143}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0001143}, {18200,0.0001143}, {18300,0.0000000}, {18400,0.0001143}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0001143}, {18900,0.0000000}, {19000,0.0001143}, {19100,0.0000000}, {19200,0.0001143}, {19300,0.0000000}, {19400,0.0001143}, {19500,0.0001143}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCGallinaCtx"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00011881}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00272277}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00201980}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00308911}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000990}, {1990,0.00000990}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000990}, {2200,0.00006931}, {2250,0.00006931}, {2300,0.00017822}, {2350,0.00041584}, {2400,0.00046535}, {2450,0.00056436}, {2500,0.00077228}, {2550,0.00100000}, {2600,0.00100000}, {2650,0.00100000}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00100000}, {3150,0.00100000}, {3200,0.00100000}, {3250,0.00100000}, {3300,0.00100000}, {3350,0.00100000}, {3400,0.00100000}, {3450,0.00100000}, {3500,0.00100000}, {3550,0.00100000}, {3600,0.00100000}, {3650,0.00100000}, {3700,0.00100000}, {3750,0.00100000}, {3800,0.00100000}, {3850,0.00100000}, {3900,0.00100000}, {3950,0.00100000}, {4000,0.00100000}, {4050,0.00100000}, {4100,0.00100000}, {4150,0.00100000}, {4200,0.00100000}, {4250,0.00100000}, {4300,0.00100000}, {4350,0.00100990}, {4400,0.00100000}, {4450,0.00101980}, {4500,0.00100990}, {4550,0.00106931}, {4600,0.00113861}, {4650,0.00109901}, {4700,0.00133663}, {4750,0.00154455}, {4800,0.00160396}, {4850,0.00161386}, {4900,0.00166337}, {4950,0.00175248}, {5000,0.00174257}, {5050,0.00178218}, {5100,0.00197030}, {5150,0.00200000}, {5200,0.00200000}, {5250,0.00200000}, {5300,0.00200000}, {5350,0.00200000}, {5400,0.00200000}, {5450,0.00200000}, {5500,0.00200000}, {5550,0.00200000}, {5600,0.00200000}, {5650,0.00200000}, {5700,0.00200000}, {5750,0.00200000}, {5800,0.00200000}, {5850,0.00200000}, {5900,0.00200000}, {5950,0.00200000}, {6000,0.00200000}, {6050,0.0020286}, {6100,0.0020286}, {6150,0.0020571}, {6200,0.0020857}, {6250,0.0020571}, {6300,0.0022571}, {6350,0.0021143}, {6400,0.0022286}, {6450,0.0023143}, {6500,0.0024000}, {6550,0.0023714}, {6600,0.0025143}, {6650,0.0026000}, {6700,0.0026286}, {6750,0.0027429}, {6800,0.0027429}, {6850,0.0028571}, {6900,0.0127143}, {6950,0.0146000}, {7000,0.0028857}, {7050,0.0029714}, {7100,0.0029714}, {7150,0.0030000}, {7200,0.0029714}, {7250,0.0108286}, {7300,0.0029714}, {7350,0.0178857}, {7400,0.0030000}, {7450,0.0030000}, {7500,0.0030000}, {7550,0.0030000}, {7600,0.0030000}, {7650,0.0030000}, {7700,0.0030000}, {7750,0.0030000}, {7800,0.0030000}, {7850,0.0030000}, {7900,0.0030286}, {7950,0.0030286}, {8000,0.0030000}, {8050,0.0030857}, {8100,0.0030286}, {8150,0.0030571}, {8200,0.0030286}, {8250,0.0031429}, {8300,0.0032571}, {8350,0.0031429}, {8400,0.0034000}, {8450,0.0032571}, {8500,0.0034857}, {8550,0.0034286}, {8600,0.0035714}, {8650,0.0037143}, {8700,0.0038000}, {8750,0.0038000}, {8800,0.0038000}, {8850,0.0038000}, {8900,0.0038000}, {8950,0.0038000}, {9000,0.0038000}, {9050,0.0038286}, {9100,0.0038857}, {9150,0.0038571}, {9200,0.0039429}, {9250,0.0213714}, {9300,0.0039714}, {9350,0.0040000}, {9400,0.0132000}, {9450,0.0039429}, {9500,0.0040000}, {9550,0.0040000}, {9600,0.0040000}, {9650,0.0040000}, {9700,0.0040000}, {9750,0.0040000}, {9800,0.0040000}, {9850,0.0040000}, {9900,0.0040000}, {9950,0.0040000}, {10000,0.0040286}, {10100,0.0040571}, {10200,0.0042000}, {10300,0.0041714}, {10400,0.0043143}, {10500,0.0045143}, {10600,0.0045429}, {10700,0.0047143}, {10800,0.0047429}, {10900,0.0047714}, {11000,0.0047714}, {11100,0.0047714}, {11200,0.0047714}, {11300,0.0047714}, {11400,0.0048571}, {11500,0.0049429}, {11600,0.0049429}, {11700,0.0220286}, {11800,0.0050000}, {11900,0.0050000}, {12000,0.0050286}, {12100,0.0050571}, {12200,0.0050857}, {12300,0.0052000}, {12400,0.0053143}, {12500,0.0054000}, {12600,0.0056000}, {12700,0.0056571}, {12800,0.0056857}, {12900,0.0057429}, {13000,0.0057143}, {13100,0.0057429}, {13200,0.0057714}, {13300,0.0056857}, {13400,0.0056857}, {13500,0.0057429}, {13600,0.0058286}, {13700,0.0059429}, {13800,0.0058857}, {13900,0.0060286}, {14000,0.0060571}, {14100,0.0060571}, {14200,0.0061429}, {14300,0.0062571}, {14400,0.0063143}, {14500,0.0065429}, {14600,0.0065429}, {14700,0.0066000}, {14800,0.0066857}, {14900,0.0067143}, {15000,0.0067143}, {15100,0.0066857}, {15200,0.0066857}, {15300,0.0066857}, {15400,0.0066857}, {15500,0.0066857}, {15600,0.0258286}, {15700,0.0066571}, {15800,0.0067429}, {15900,0.0068286}, {16000,0.0068857}, {16100,0.0069143}, {16200,0.0070571}, {16300,0.0069714}, {16400,0.0325429}, {16500,0.0073714}, {16600,0.0074000}, {16700,0.0303143}, {16800,0.0075714}, {16900,0.0076000}, {17000,0.0076000}, {17100,0.0076286}, {17200,0.0076286}, {17300,0.0076286}, {17400,0.0076571}, {17500,0.0076571}, {17600,0.0267714}, {17700,0.0076571}, {17800,0.0076571}, {17900,0.0078000}, {18000,0.0077143}, {18100,0.0077714}, {18200,0.0078286}, {18300,0.0080286}, {18400,0.0081143}, {18500,0.0081429}, {18600,0.0254571}, {18700,0.0084000}, {18800,0.0085143}, {18900,0.0086286}, {19000,0.0086000}, {19100,0.0086000}, {19200,0.0090000}, {19300,0.0086571}, {19400,0.0086571}, {19500,0.0086571}, {19600,0.0086571}, {19700,0.0086571}, {19800,0.0086571}, {19900,0.0086286}, {20000,0.0086571}};
data["big_flat"]["LtacTCGallinaCtx"]["lazy beta iota"]["user"] = {{1,0.00002970}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00006931}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003960}, {13,0.00007921}, {14,0.00000000}, {15,0.00000000}, {16,0.00002970}, {17,0.00003960}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00006931}, {22,0.00003960}, {23,0.00000000}, {24,0.00000000}, {25,0.00002970}, {26,0.00000000}, {27,0.00002970}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00007921}, {32,0.00010891}, {33,0.00002970}, {34,0.00000000}, {35,0.00003960}, {36,0.00000000}, {37,0.00002970}, {38,0.00007921}, {39,0.00000000}, {40,0.00003960}, {41,0.00000000}, {42,0.00000000}, {43,0.00003960}, {44,0.00000000}, {45,0.00003960}, {46,0.00003960}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00000000}, {51,0.00002970}, {52,0.00010891}, {53,0.00002970}, {54,0.00002970}, {55,0.00008911}, {56,0.00000000}, {57,0.00002970}, {58,0.00000000}, {59,0.00000000}, {60,0.00002970}, {61,0.00002970}, {62,0.00009901}, {63,0.00000000}, {64,0.00003960}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00012871}, {69,0.00000000}, {70,0.00003960}, {71,0.00000000}, {72,0.00015842}, {73,0.00000000}, {74,0.00002970}, {75,0.00000000}, {76,0.00002970}, {77,0.00003960}, {78,0.00000000}, {79,0.00002970}, {80,0.00002970}, {81,0.00003960}, {82,0.00002970}, {83,0.00003960}, {84,0.00000000}, {85,0.00003960}, {86,0.00002970}, {87,0.00005941}, {88,0.00005941}, {89,0.00000000}, {90,0.00002970}, {91,0.00059406}, {92,0.00002970}, {93,0.00005941}, {94,0.00008911}, {95,0.00006931}, {96,0.00011881}, {97,0.00000000}, {98,0.00013861}, {99,0.00000000}, {100,0.00000000}, {101,0.00005941}, {102,0.00009901}, {103,0.00012871}, {104,0.00002970}, {105,0.00000000}, {106,0.00005941}, {107,0.00012871}, {108,0.00009901}, {109,0.00003960}, {110,0.00002970}, {111,0.00009901}, {112,0.00000000}, {113,0.00006931}, {114,0.00006931}, {115,0.00000000}, {116,0.00000000}, {117,0.00024752}, {118,0.00015842}, {119,0.00006931}, {120,0.00005941}, {121,0.00002970}, {122,0.00009901}, {123,0.00002970}, {124,0.00009901}, {125,0.00002970}, {126,0.00000000}, {127,0.00009901}, {128,0.00009901}, {129,0.00007921}, {130,0.00012871}, {131,0.00002970}, {132,0.00012871}, {133,0.00018812}, {134,0.00006931}, {135,0.00012871}, {136,0.00002970}, {137,0.00003960}, {138,0.00009901}, {139,0.00011881}, {140,0.00008911}, {141,0.00005941}, {142,0.00010891}, {143,0.00008911}, {144,0.00002970}, {145,0.00017822}, {146,0.00011881}, {147,0.00010891}, {148,0.00003960}, {149,0.00011881}, {150,0.00009901}, {151,0.00005941}, {152,0.00002970}, {153,0.00009901}, {154,0.00002970}, {155,0.00003960}, {156,0.00009901}, {157,0.00002970}, {158,0.00025743}, {159,0.00016832}, {160,0.00003960}, {161,0.00006931}, {162,0.00003960}, {163,0.00026733}, {164,0.00000000}, {165,0.00007921}, {166,0.00006931}, {167,0.00003960}, {168,0.00011881}, {169,0.00005941}, {170,0.00010891}, {171,0.00011881}, {172,0.00022772}, {173,0.00020792}, {174,0.00009901}, {175,0.00006931}, {176,0.00006931}, {177,0.00003960}, {178,0.00011881}, {179,0.00028713}, {180,0.00015842}, {181,0.00013861}, {182,0.00006931}, {183,0.00006931}, {184,0.00002970}, {185,0.00011881}, {186,0.00003960}, {187,0.00011881}, {188,0.00014851}, {189,0.00018812}, {190,0.00011881}, {191,0.00009901}, {192,0.00012871}, {193,0.00009901}, {194,0.00006931}, {195,0.00000000}, {196,0.00017822}, {197,0.00011881}, {198,0.00006931}, {199,0.00006931}, {200,0.00009901}, {201,0.00013861}, {202,0.00003960}, {203,0.00005941}, {204,0.00006931}, {205,0.00017822}, {206,0.00022772}, {207,0.00002970}, {208,0.00006931}, {209,0.00007921}, {210,0.00010891}, {211,0.00010891}, {212,0.00009901}, {213,0.00002970}, {214,0.00014851}, {215,0.00029703}, {216,0.00006931}, {217,0.00014851}, {218,0.00000000}, {219,0.00007921}, {220,0.00006931}, {221,0.00006931}, {222,0.00010891}, {223,0.00010891}, {224,0.00014851}, {225,0.00014851}, {226,0.00003960}, {227,0.00005941}, {228,0.00018812}, {229,0.00015842}, {230,0.00014851}, {231,0.00009901}, {232,0.00009901}, {233,0.00018812}, {234,0.00016832}, {235,0.00002970}, {236,0.00007921}, {237,0.00014851}, {238,0.00002970}, {239,0.00008911}, {240,0.00007921}, {241,0.00006931}, {242,0.00006931}, {243,0.00012871}, {244,0.00016832}, {245,0.00015842}, {246,0.00009901}, {247,0.00013861}, {248,0.00005941}, {249,0.00005941}, {250,0.00013861}, {251,0.00009901}, {252,0.00013861}, {253,0.00016832}, {254,0.00018812}, {255,0.00011881}, {256,0.00028713}, {257,0.00006931}, {258,0.00009901}, {259,0.00017822}, {260,0.00011881}, {261,0.00012871}, {262,0.00018812}, {263,0.00006931}, {264,0.00019802}, {265,0.00000000}, {266,0.00011881}, {267,0.00000000}, {268,0.00020792}, {269,0.00018812}, {270,0.00009901}, {271,0.00016832}, {272,0.00016832}, {273,0.00009901}, {274,0.00015842}, {275,0.00011881}, {276,0.00022772}, {277,0.00016832}, {278,0.00012871}, {279,0.00003960}, {280,0.00015842}, {281,0.00009901}, {282,0.00010891}, {283,0.00003960}, {284,0.00025743}, {285,0.00006931}, {286,0.00019802}, {287,0.00018812}, {288,0.00006931}, {289,0.00021782}, {290,0.00009901}, {291,0.00015842}, {292,0.00008911}, {293,0.00005941}, {294,0.00023762}, {295,0.00015842}, {296,0.00018812}, {297,0.00002970}, {298,0.00025743}, {299,0.00018812}, {300,0.00006931}, {301,0.00005941}, {302,0.00027723}, {303,0.00015842}, {304,0.00012871}, {305,0.00017822}, {306,0.00020792}, {307,0.00006931}, {308,0.00015842}, {309,0.00009901}, {310,0.00019802}, {311,0.00017822}, {312,0.00018812}, {313,0.00018812}, {314,0.00012871}, {315,0.00016832}, {316,0.00012871}, {317,0.00006931}, {318,0.00015842}, {319,0.00011881}, {320,0.00017822}, {321,0.00016832}, {322,0.00008911}, {323,0.00013861}, {324,0.00012871}, {325,0.00019802}, {326,0.00006931}, {327,0.00015842}, {328,0.00039604}, {329,0.00012871}, {330,0.00007921}, {331,0.00017822}, {332,0.00025743}, {333,0.00002970}, {334,0.00017822}, {335,0.00042574}, {336,0.00013861}, {337,0.00028713}, {338,0.00008911}, {339,0.00011881}, {340,0.00019802}, {341,0.00013861}, {342,0.00006931}, {343,0.00021782}, {344,0.00019802}, {345,0.00026733}, {346,0.00018812}, {347,0.00023762}, {348,0.00009901}, {349,0.00019802}, {350,0.00028713}, {351,0.00007921}, {352,0.00022772}, {353,0.00013861}, {354,0.00010891}, {355,0.00017822}, {356,0.00020792}, {357,0.00009901}, {358,0.00010891}, {359,0.00020792}, {360,0.00019802}, {361,0.00025743}, {362,0.00017822}, {363,0.00014851}, {364,0.00027723}, {365,0.00022772}, {366,0.00019802}, {367,0.00023762}, {368,0.00018812}, {369,0.00031683}, {370,0.00026733}, {371,0.00017822}, {372,0.00013861}, {373,0.00010891}, {374,0.00013861}, {375,0.00018812}, {376,0.00018812}, {377,0.00015842}, {378,0.00037624}, {379,0.00027723}, {380,0.00010891}, {381,0.00013861}, {382,0.00024752}, {383,0.00028713}, {384,0.00014851}, {385,0.00011881}, {386,0.00028713}, {387,0.00018812}, {388,0.00015842}, {389,0.00012871}, {390,0.00030693}, {391,0.00011881}, {392,0.00011881}, {393,0.00037624}, {394,0.00009901}, {395,0.00022772}, {396,0.00021782}, {397,0.00002970}, {398,0.00009901}, {399,0.00007921}, {400,0.00009901}, {401,0.00026733}, {402,0.00010891}, {403,0.00013861}, {404,0.00017822}, {405,0.00015842}, {406,0.00019802}, {407,0.00025743}, {408,0.00017822}, {409,0.00006931}, {410,0.00035644}, {411,0.00018812}, {412,0.00011881}, {413,0.00018812}, {414,0.00002970}, {415,0.00009901}, {416,0.00015842}, {417,0.00022772}, {418,0.00024752}, {419,0.00007921}, {420,0.00035644}, {421,0.00024752}, {422,0.00017822}, {423,0.00025743}, {424,0.00012871}, {425,0.00011881}, {426,0.00018812}, {427,0.00027723}, {428,0.00024752}, {429,0.00021782}, {430,0.00021782}, {431,0.00026733}, {432,0.00007921}, {433,0.00034653}, {434,0.00275248}, {435,0.00006931}, {436,0.00039604}, {437,0.00017822}, {438,0.00022772}, {439,0.00010891}, {440,0.00020792}, {441,0.00016832}, {442,0.00044554}, {443,0.00019802}, {444,0.00014851}, {445,0.00019802}, {446,0.00026733}, {447,0.00031683}, {448,0.00014851}, {449,0.00003960}, {450,0.00029703}, {451,0.00034653}, {452,0.00009901}, {453,0.00008911}, {454,0.00035644}, {455,0.00019802}, {456,0.00011881}, {457,0.00022772}, {458,0.00020792}, {459,0.00017822}, {460,0.00015842}, {461,0.00054455}, {462,0.00018812}, {463,0.00046535}, {464,0.00023762}, {465,0.00014851}, {466,0.00025743}, {467,0.00003960}, {468,0.00014851}, {469,0.00024752}, {470,0.00036634}, {471,0.00036634}, {472,0.00006931}, {473,0.00028713}, {474,0.00009901}, {475,0.00024752}, {476,0.00033663}, {477,0.00021782}, {478,0.00026733}, {479,0.00018812}, {480,0.00023762}, {481,0.00027723}, {482,0.00007921}, {483,0.00018812}, {484,0.00013861}, {485,0.00022772}, {486,0.00044554}, {487,0.00032673}, {488,0.00007921}, {489,0.00017822}, {490,0.00020792}, {491,0.00026733}, {492,0.00010891}, {493,0.00010891}, {494,0.00033663}, {495,0.00039604}, {496,0.00023762}, {497,0.00017822}, {498,0.00036634}, {499,0.00028713}, {500,0.00031683}, {505,0.00045545}, {510,0.00034653}, {515,0.00035644}, {520,0.00026733}, {525,0.00029703}, {530,0.00041584}, {535,0.00019802}, {540,0.00015842}, {545,0.00022772}, {550,0.00032673}, {555,0.00010891}, {560,0.00013861}, {565,0.00010891}, {570,0.00030693}, {575,0.00026733}, {580,0.00031683}, {585,0.00024752}, {590,0.00012871}, {595,0.00016832}, {600,0.00028713}, {605,0.00030693}, {610,0.00028713}, {615,0.00025743}, {620,0.00019802}, {625,0.00021782}, {630,0.00008911}, {635,0.00037624}, {640,0.00012871}, {645,0.00024752}, {650,0.00018812}, {655,0.00027723}, {660,0.00020792}, {665,0.00029703}, {670,0.00031683}, {675,0.00029703}, {680,0.00027723}, {685,0.00026733}, {690,0.00023762}, {695,0.00017822}, {700,0.00029703}, {705,0.00028713}, {710,0.00023762}, {715,0.00021782}, {720,0.00036634}, {725,0.00034653}, {730,0.00022772}, {735,0.00033663}, {740,0.00024752}, {745,0.00019802}, {750,0.00028713}, {755,0.00026733}, {760,0.00025743}, {765,0.00045545}, {770,0.00024752}, {775,0.00031683}, {780,0.00022772}, {785,0.00030693}, {790,0.00031683}, {795,0.00019802}, {800,0.00030693}, {805,0.00044554}, {810,0.00032673}, {815,0.00025743}, {820,0.00046535}, {825,0.00028713}, {830,0.00027723}, {835,0.00036634}, {840,0.00023762}, {845,0.00042574}, {850,0.00027723}, {855,0.00028713}, {860,0.00045545}, {865,0.00042574}, {870,0.00033663}, {875,0.00035644}, {880,0.00038614}, {885,0.00043564}, {890,0.00045545}, {895,0.00028713}, {900,0.00016832}, {905,0.00031683}, {910,0.00052475}, {915,0.00042574}, {920,0.00195050}, {925,0.00040594}, {930,0.00056436}, {935,0.00022772}, {940,0.00031683}, {945,0.00039604}, {950,0.00035644}, {955,0.00025743}, {960,0.00025743}, {965,0.00039604}, {970,0.00038614}, {975,0.00035644}, {980,0.00043564}, {985,0.00042574}, {990,0.00012871}, {995,0.00037624}, {1000,0.00056436}, {1010,0.00018812}, {1020,0.00039604}, {1030,0.00048515}, {1040,0.00053465}, {1050,0.00026733}, {1060,0.00019802}, {1070,0.00066337}, {1080,0.00029703}, {1090,0.00046535}, {1100,0.00048515}, {1110,0.00028713}, {1120,0.00047525}, {1130,0.00035644}, {1140,0.00044554}, {1150,0.00054455}, {1160,0.00060396}, {1170,0.00057426}, {1180,0.00054455}, {1190,0.00055446}, {1200,0.00060396}, {1210,0.00032673}, {1220,0.00051485}, {1230,0.00047525}, {1240,0.00031683}, {1250,0.00055446}, {1260,0.00047525}, {1270,0.00040594}, {1280,0.00048515}, {1290,0.00012871}, {1300,0.00050495}, {1310,0.00068317}, {1320,0.00029703}, {1330,0.00049505}, {1340,0.00073267}, {1350,0.00045545}, {1360,0.00044554}, {1370,0.00058416}, {1380,0.00042574}, {1390,0.00045545}, {1400,0.00055446}, {1410,0.00051485}, {1420,0.00054455}, {1430,0.00047525}, {1440,0.00064356}, {1450,0.00052475}, {1460,0.00042574}, {1470,0.00044554}, {1480,0.00062376}, {1490,0.00066337}, {1500,0.00068317}, {1510,0.00070297}, {1520,0.00073267}, {1530,0.00057426}, {1540,0.00044554}, {1550,0.00037624}, {1560,0.00069307}, {1570,0.00061386}, {1580,0.00057426}, {1590,0.00052475}, {1600,0.00063366}, {1610,0.00050495}, {1620,0.00082178}, {1630,0.00068317}, {1640,0.00066337}, {1650,0.00051485}, {1660,0.00066337}, {1670,0.00044554}, {1680,0.00084158}, {1690,0.00041584}, {1700,0.00067327}, {1710,0.00053465}, {1720,0.00055446}, {1730,0.00074257}, {1740,0.00098020}, {1750,0.00107921}, {1760,0.00069307}, {1770,0.00053465}, {1780,0.00064356}, {1790,0.00111881}, {1800,0.00055446}, {1810,0.00036634}, {1820,0.00047525}, {1830,0.00075248}, {1840,0.00070297}, {1850,0.00093069}, {1860,0.00053465}, {1870,0.00080198}, {1880,0.00092079}, {1890,0.00052475}, {1900,0.00070297}, {1910,0.00066337}, {1920,0.00069307}, {1930,0.00088119}, {1940,0.00064356}, {1950,0.00321782}, {1960,0.00083168}, {1970,0.00073267}, {1980,0.00053465}, {1990,0.00080198}, {2000,0.00100000}, {2050,0.00083168}, {2100,0.00095050}, {2150,0.00093069}, {2200,0.00083168}, {2250,0.00076238}, {2300,0.00104950}, {2350,0.00100000}, {2400,0.00091089}, {2450,0.00100990}, {2500,0.00088119}, {2550,0.00079208}, {2600,0.00119802}, {2650,0.00103960}, {2700,0.00076238}, {2750,0.00082178}, {2800,0.00111881}, {2850,0.00115842}, {2900,0.00124752}, {2950,0.00082178}, {3000,0.00128713}, {3050,0.00105941}, {3100,0.00130693}, {3150,0.00101980}, {3200,0.00120792}, {3250,0.00117822}, {3300,0.00115842}, {3350,0.00125743}, {3400,0.00133663}, {3450,0.00117822}, {3500,0.00134653}, {3550,0.00140594}, {3600,0.00156436}, {3650,0.00147525}, {3700,0.00107921}, {3750,0.00141584}, {3800,0.00129703}, {3850,0.00152475}, {3900,0.00126733}, {3950,0.00158416}, {4000,0.00123762}, {4050,0.00167327}, {4100,0.00162376}, {4150,0.00190099}, {4200,0.00168317}, {4250,0.00160396}, {4300,0.00172277}, {4350,0.00183168}, {4400,0.00189109}, {4450,0.00184158}, {4500,0.00160396}, {4550,0.00182178}, {4600,0.00191089}, {4650,0.00193069}, {4700,0.00198020}, {4750,0.00184158}, {4800,0.00151485}, {4850,0.00203960}, {4900,0.00179208}, {4950,0.00192079}, {5000,0.00192079}, {5050,0.00193069}, {5100,0.00199010}, {5150,0.00215842}, {5200,0.00188119}, {5250,0.00222772}, {5300,0.00221782}, {5350,0.00207921}, {5400,0.00206931}, {5450,0.00203960}, {5500,0.00206931}, {5550,0.00200990}, {5600,0.00225743}, {5650,0.00208911}, {5700,0.00231683}, {5750,0.00225743}, {5800,0.00200000}, {5850,0.00211881}, {5900,0.00238614}, {5950,0.00254455}, {6000,0.00245545}, {6050,0.0024000}, {6100,0.0024571}, {6150,0.0030857}, {6200,0.0024000}, {6250,0.0023143}, {6300,0.0021714}, {6350,0.0025143}, {6400,0.0026286}, {6450,0.0027714}, {6500,0.0028000}, {6550,0.0022857}, {6600,0.0028000}, {6650,0.0029429}, {6700,0.0029143}, {6750,0.0025714}, {6800,0.0026286}, {6850,0.0028286}, {6900,0.0130286}, {6950,0.0147429}, {7000,0.0026857}, {7050,0.0023143}, {7100,0.0028286}, {7150,0.0028000}, {7200,0.0025429}, {7250,0.0114000}, {7300,0.0028000}, {7350,0.0182286}, {7400,0.0028286}, {7450,0.0028857}, {7500,0.0033429}, {7550,0.0028571}, {7600,0.0032000}, {7650,0.0031714}, {7700,0.0035429}, {7750,0.0036857}, {7800,0.0034000}, {7850,0.0031429}, {7900,0.0033143}, {7950,0.0032571}, {8000,0.0032286}, {8050,0.0033429}, {8100,0.0034857}, {8150,0.0034857}, {8200,0.0034857}, {8250,0.0037429}, {8300,0.0034857}, {8350,0.0033429}, {8400,0.0034286}, {8450,0.0035714}, {8500,0.0036857}, {8550,0.0036571}, {8600,0.0035714}, {8650,0.0039429}, {8700,0.0036000}, {8750,0.0036000}, {8800,0.0038000}, {8850,0.0037714}, {8900,0.0037714}, {8950,0.0041429}, {9000,0.0041714}, {9050,0.0039429}, {9100,0.0041714}, {9150,0.0039714}, {9200,0.0044286}, {9250,0.0208000}, {9300,0.0041429}, {9350,0.0041714}, {9400,0.0131429}, {9450,0.0044571}, {9500,0.0041429}, {9550,0.0050857}, {9600,0.0040571}, {9650,0.0041143}, {9700,0.0043143}, {9750,0.0046286}, {9800,0.0043429}, {9850,0.0041714}, {9900,0.0048286}, {9950,0.0044571}, {10000,0.0044286}, {10100,0.0046000}, {10200,0.0045714}, {10300,0.0046286}, {10400,0.0045714}, {10500,0.0050000}, {10600,0.0044286}, {10700,0.0047143}, {10800,0.0048571}, {10900,0.0046000}, {11000,0.0054286}, {11100,0.0049714}, {11200,0.0047143}, {11300,0.0045143}, {11400,0.0049714}, {11500,0.0047143}, {11600,0.0050857}, {11700,0.0226000}, {11800,0.0052857}, {11900,0.0052857}, {12000,0.0054000}, {12100,0.0052857}, {12200,0.0056286}, {12300,0.0052286}, {12400,0.0059714}, {12500,0.0054286}, {12600,0.0052000}, {12700,0.0053714}, {12800,0.0056571}, {12900,0.0055714}, {13000,0.0051714}, {13100,0.0058571}, {13200,0.0056000}, {13300,0.0060000}, {13400,0.0066000}, {13500,0.0058000}, {13600,0.0068286}, {13700,0.0062000}, {13800,0.0058286}, {13900,0.0066286}, {14000,0.0063429}, {14100,0.0064857}, {14200,0.0065714}, {14300,0.0063429}, {14400,0.0064000}, {14500,0.0070857}, {14600,0.0065714}, {14700,0.0060000}, {14800,0.0067714}, {14900,0.0069143}, {15000,0.0058571}, {15100,0.0066286}, {15200,0.0068857}, {15300,0.0067714}, {15400,0.0071143}, {15500,0.0073429}, {15600,0.0264286}, {15700,0.0072000}, {15800,0.0071429}, {15900,0.0073429}, {16000,0.0072571}, {16100,0.0069714}, {16200,0.0074286}, {16300,0.0071429}, {16400,0.0327143}, {16500,0.0076571}, {16600,0.0077714}, {16700,0.0300571}, {16800,0.0077143}, {16900,0.0078571}, {17000,0.0079143}, {17100,0.0076286}, {17200,0.0078857}, {17300,0.0082000}, {17400,0.0084857}, {17500,0.0078286}, {17600,0.0266286}, {17700,0.0077143}, {17800,0.0080857}, {17900,0.0078286}, {18000,0.0081143}, {18100,0.0075429}, {18200,0.0083143}, {18300,0.0082857}, {18400,0.0080286}, {18500,0.0080571}, {18600,0.0252000}, {18700,0.0084286}, {18800,0.0078286}, {18900,0.0078286}, {19000,0.0084571}, {19100,0.0083143}, {19200,0.0083143}, {19300,0.0087143}, {19400,0.0088857}, {19500,0.0083429}, {19600,0.0092000}, {19700,0.0088571}, {19800,0.0084571}, {19900,0.0086286}, {20000,0.0084000}};
data["big_flat"]["LtacTCGallinaCtx"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00003960}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00003960}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00003960}, {100,0.00003960}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00003960}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00003960}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00003960}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00002970}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00003960}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00003960}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00003960}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00003960}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00003960}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00002970}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00003960}, {435,0.00003960}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00003960}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00003960}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00003960}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00003960}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00003960}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00003960}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00002970}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00003960}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00002970}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00003960}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00003960}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00003960}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00003960}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00007921}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00003960}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00003960}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00003960}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00003960}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00003960}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00003960}, {5250,0.00000000}, {5300,0.00003960}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00007921}, {6000,0.00000000}, {6050,0.0002286}, {6100,0.0004571}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0002286}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0002286}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0001143}, {8000,0.0000000}, {8050,0.0001143}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0001143}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0001143}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0001143}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0001143}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0001143}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0001143}, {13000,0.0001143}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0001143}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0001143}, {18000,0.0000000}, {18100,0.0001143}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0001143}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0001143}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCGallinaCtx"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000990}, {7,0.00036634}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00108911}, {15,0.00132673}, {16,0.00200000}, {17,0.00200000}, {18,0.00200000}, {19,0.00257426}, {20,0.00200000}, {21,0.00202970}, {22,0.00227723}, {23,0.00232673}, {24,0.00293069}, {25,0.00300000}, {26,0.00300000}, {27,0.00300000}, {28,0.00300000}, {29,0.00309901}, {30,0.00323762}, {31,0.00355446}, {32,0.00459406}, {33,0.00400000}, {34,0.00400000}, {35,0.00400990}, {36,0.00404950}, {37,0.00607921}, {38,0.00424752}, {39,0.00448515}, {40,0.00463366}, {41,0.00500000}, {42,0.00500000}, {43,0.00500990}, {44,0.00503960}, {45,0.00521782}, {46,0.00516832}, {47,0.00544554}, {48,0.00559406}, {49,0.00598020}, {50,0.00600000}, {51,0.00604950}, {52,0.00612871}, {53,0.00626733}, {54,0.00645545}, {55,0.00634653}, {56,0.00649505}, {57,0.00695050}, {58,0.00701980}, {59,0.00710891}, {60,0.00718812}, {61,0.00735644}, {62,0.00723762}, {63,0.00729703}, {64,0.00744554}, {65,0.00787129}, {66,0.00802970}, {67,0.01050495}, {68,0.00817822}, {69,0.00821782}, {70,0.00820792}, {71,0.00844554}, {72,0.00843564}, {73,0.00887129}, {74,0.00901980}, {75,0.01104950}, {76,0.00918812}, {77,0.00922772}, {78,0.00925743}, {79,0.00935644}, {80,0.00928713}, {81,0.00969307}, {82,0.00995050}, {83,0.01018812}, {84,0.01010891}, {85,0.01022772}, {86,0.01024752}, {87,0.01043564}, {88,0.01034653}, {89,0.01133663}, {90,0.01348515}, {91,0.01106931}, {92,0.01119802}, {93,0.01122772}, {94,0.01131683}, {95,0.01155446}, {96,0.01142574}, {97,0.01177228}, {98,0.01184158}, {99,0.01220792}, {100,0.01215842}, {101,0.01235644}, {102,0.01582178}, {103,0.01409901}, {104,0.01227723}, {105,0.01267327}, {106,0.01297030}, {107,0.01317822}, {108,0.01319802}, {109,0.01330693}, {110,0.01329703}, {111,0.01347525}, {112,0.01513861}, {113,0.01352475}, {114,0.01384158}, {115,0.01418812}, {116,0.01422772}, {117,0.01886139}, {118,0.01424752}, {119,0.01452475}, {120,0.01454455}, {121,0.01465347}, {122,0.01480198}, {123,0.01516832}, {124,0.01526733}, {125,0.01637624}, {126,0.01527723}, {127,0.01536634}, {128,0.01552475}, {129,0.01554455}, {130,0.01577228}, {131,0.01608911}, {132,0.01607921}, {133,0.01634653}, {134,0.01636634}, {135,0.01644554}, {136,0.01659406}, {137,0.01937624}, {138,0.01668317}, {139,0.01718812}, {140,0.01710891}, {141,0.01723762}, {142,0.01728713}, {143,0.01754455}, {144,0.01831683}, {145,0.01771287}, {146,0.02011881}, {147,0.01804950}, {148,0.02041584}, {149,0.01822772}, {150,0.01966337}, {151,0.01871287}, {152,0.01836634}, {153,0.01871287}, {154,0.01899010}, {155,0.01917822}, {156,0.01923762}, {157,0.02191089}, {158,0.01944554}, {159,0.01967327}, {160,0.02575248}, {161,0.01959406}, {162,0.01968317}, {163,0.02008911}, {164,0.02008911}, {165,0.02035644}, {166,0.02048515}, {167,0.02050495}, {168,0.02045545}, {169,0.02612871}, {170,0.02088119}, {171,0.02125743}, {172,0.02127723}, {173,0.02849505}, {174,0.02141584}, {175,0.02167327}, {176,0.02141584}, {177,0.02636634}, {178,0.02184158}, {179,0.02205941}, {180,0.02201980}, {181,0.02234653}, {182,0.02385149}, {183,0.02811881}, {184,0.02253465}, {185,0.02283168}, {186,0.02289109}, {187,0.02318812}, {188,0.02295050}, {189,0.02345545}, {190,0.02331683}, {191,0.02450495}, {192,0.02593069}, {193,0.02761386}, {194,0.02919802}, {195,0.03011881}, {196,0.03096040}, {197,0.03149505}, {198,0.03153465}, {199,0.03158416}, {200,0.03128713}, {201,0.03045545}, {202,0.02928713}, {203,0.02860396}, {204,0.02711881}, {205,0.02520792}, {206,0.02550495}, {207,0.02545545}, {208,0.02551485}, {209,0.02559406}, {210,0.02583168}, {211,0.02601980}, {212,0.03740594}, {213,0.03091089}, {214,0.02626733}, {215,0.02658416}, {216,0.02651485}, {217,0.02667327}, {218,0.03348515}, {219,0.02826733}, {220,0.02690099}, {221,0.02732673}, {222,0.02737624}, {223,0.03048515}, {224,0.02734653}, {225,0.02763366}, {226,0.03706931}, {227,0.02918812}, {228,0.02801980}, {229,0.02825743}, {230,0.03156436}, {231,0.02867327}, {232,0.02856436}, {233,0.03195050}, {234,0.02876238}, {235,0.02918812}, {236,0.03025743}, {237,0.02955446}, {238,0.03629703}, {239,0.02950495}, {240,0.02956436}, {241,0.02972277}, {242,0.02981188}, {243,0.03393069}, {244,0.03023762}, {245,0.03626733}, {246,0.03046535}, {247,0.03771287}, {248,0.03051485}, {249,0.03916832}, {250,0.03101980}, {251,0.03831683}, {252,0.03144554}, {253,0.03654455}, {254,0.03160396}, {255,0.03292079}, {256,0.03159406}, {257,0.03161386}, {258,0.04067327}, {259,0.03189109}, {260,0.03497030}, {261,0.03231683}, {262,0.03229703}, {263,0.03927723}, {264,0.03255446}, {265,0.03274257}, {266,0.04001980}, {267,0.03331683}, {268,0.03320792}, {269,0.03900000}, {270,0.03356436}, {271,0.03386139}, {272,0.03540594}, {273,0.04511881}, {274,0.03420792}, {275,0.03412871}, {276,0.03540594}, {277,0.04203960}, {278,0.03456436}, {279,0.03498020}, {280,0.03466337}, {281,0.03710891}, {282,0.04172277}, {283,0.04705941}, {284,0.03568317}, {285,0.03546535}, {286,0.03565347}, {287,0.03580198}, {288,0.03745545}, {289,0.04017822}, {290,0.04310891}, {291,0.04554455}, {292,0.04656436}, {293,0.03641584}, {294,0.03669307}, {295,0.03677228}, {296,0.03708911}, {297,0.03700990}, {298,0.03722772}, {299,0.03716832}, {300,0.03724752}, {301,0.03746535}, {302,0.03798020}, {303,0.03785149}, {304,0.03799010}, {305,0.03823762}, {306,0.05405941}, {307,0.04808911}, {308,0.04598020}, {309,0.04371287}, {310,0.04100000}, {311,0.03882178}, {312,0.03893069}, {313,0.03909901}, {314,0.03931683}, {315,0.05027723}, {316,0.04572277}, {317,0.04141584}, {318,0.03980198}, {319,0.04025743}, {320,0.05137624}, {321,0.04589109}, {322,0.04130693}, {323,0.04000000}, {324,0.04041584}, {325,0.04830693}, {326,0.04274257}, {327,0.04111881}, {328,0.04061386}, {329,0.04653465}, {330,0.04101980}, {331,0.04152475}, {332,0.05240594}, {333,0.04155446}, {334,0.04189109}, {335,0.04950495}, {336,0.04140594}, {337,0.04241584}, {338,0.04684158}, {339,0.04202970}, {340,0.05157426}, {341,0.04302970}, {342,0.04237624}, {343,0.04608911}, {344,0.04282178}, {345,0.04886139}, {346,0.04351485}, {347,0.05078218}, {348,0.04342574}, {349,0.05134653}, {350,0.04370297}, {351,0.05138614}, {352,0.04364356}, {353,0.05003960}, {354,0.04403960}, {355,0.04847525}, {356,0.04435644}, {357,0.04731683}, {358,0.06228713}, {359,0.04504950}, {360,0.05257426}, {361,0.04535644}, {362,0.04741584}, {363,0.05779208}, {364,0.04527723}, {365,0.04995050}, {366,0.05865347}, {367,0.04595050}, {368,0.04934653}, {369,0.05719802}, {370,0.04604950}, {371,0.04782178}, {372,0.05417822}, {373,0.04680198}, {374,0.04671287}, {375,0.04978218}, {376,0.05525743}, {377,0.04717822}, {378,0.04722772}, {379,0.04756436}, {380,0.05548515}, {381,0.06247525}, {382,0.04984158}, {383,0.04783168}, {384,0.04736634}, {385,0.04947525}, {386,0.05418812}, {387,0.05683168}, {388,0.06081188}, {389,0.04848515}, {390,0.04880198}, {391,0.04890099}, {392,0.04883168}, {393,0.04876238}, {394,0.05102970}, {395,0.05257426}, {396,0.05350495}, {397,0.05468317}, {398,0.05538614}, {399,0.05765347}, {400,0.05904950}, {401,0.05756436}, {402,0.05723762}, {403,0.05715842}, {404,0.05645545}, {405,0.05529703}, {406,0.05434653}, {407,0.05289109}, {408,0.05107921}, {409,0.05098020}, {410,0.05139604}, {411,0.05144554}, {412,0.06549505}, {413,0.06303960}, {414,0.06008911}, {415,0.05677228}, {416,0.05321782}, {417,0.05214851}, {418,0.05229703}, {419,0.06779208}, {420,0.06222772}, {421,0.05712871}, {422,0.05273267}, {423,0.05292079}, {424,0.06588119}, {425,0.05989109}, {426,0.05374257}, {427,0.05374257}, {428,0.06489109}, {429,0.05857426}, {430,0.05371287}, {431,0.06857426}, {432,0.06036634}, {433,0.05380198}, {434,0.05407921}, {435,0.06603960}, {436,0.05480198}, {437,0.07110891}, {438,0.06147525}, {439,0.05491089}, {440,0.06658416}, {441,0.05667327}, {442,0.07141584}, {443,0.06095050}, {444,0.05561386}, {445,0.06406931}, {446,0.05582178}, {447,0.06600990}, {448,0.05558416}, {449,0.06668317}, {450,0.05608911}, {451,0.07359406}, {452,0.05669307}, {453,0.07042574}, {454,0.05708911}, {455,0.06928713}, {456,0.05663366}, {457,0.06608911}, {458,0.05725743}, {459,0.06238614}, {460,0.07246535}, {461,0.05747525}, {462,0.06780198}, {463,0.05862376}, {464,0.06135644}, {465,0.07061386}, {466,0.05814851}, {467,0.06699010}, {468,0.07636634}, {469,0.05908911}, {470,0.06406931}, {471,0.07325743}, {472,0.05885149}, {473,0.06139604}, {474,0.06863366}, {475,0.07426733}, {476,0.05965347}, {477,0.06235644}, {478,0.06803960}, {479,0.07289109}, {480,0.05981188}, {481,0.06003960}, {482,0.06610891}, {483,0.07075248}, {484,0.07472277}, {485,0.07846535}, {486,0.06104950}, {487,0.06159406}, {488,0.06422772}, {489,0.06779208}, {490,0.07025743}, {491,0.07266337}, {492,0.07456436}, {493,0.08072277}, {494,0.08662376}, {495,0.06227723}, {496,0.06204950}, {497,0.06265347}, {498,0.06217822}, {499,0.06300990}, {500,0.06286139}, {505,0.06361386}, {510,0.06443564}, {515,0.06435644}, {520,0.07976238}, {525,0.07682178}, {530,0.07375248}, {535,0.06722772}, {540,0.08310891}, {545,0.07402970}, {550,0.08808911}, {555,0.07715842}, {560,0.08705941}, {565,0.07511881}, {570,0.08318812}, {575,0.09072277}, {580,0.07364356}, {585,0.08316832}, {590,0.08605941}, {595,0.08949505}, {600,0.09045545}, {605,0.09079208}, {610,0.08989109}, {615,0.08856436}, {620,0.08586139}, {625,0.08479208}, {630,0.10623762}, {635,0.09652475}, {640,0.08699010}, {645,0.10271287}, {650,0.09250495}, {655,0.08305941}, {660,0.09343564}, {665,0.11329703}, {670,0.09150495}, {675,0.10001980}, {680,0.10581188}, {685,0.08822772}, {690,0.09223762}, {695,0.09573267}, {700,0.10270297}, {705,0.09953465}, {710,0.10073267}, {715,0.09859406}, {720,0.09464356}, {725,0.11457426}, {730,0.10984158}, {735,0.11001980}, {740,0.09785149}, {745,0.11396040}, {750,0.10313861}, {755,0.11541584}, {760,0.10389109}, {765,0.11733663}, {770,0.12598020}, {775,0.10947525}, {780,0.11524752}, {785,0.12097030}, {790,0.13969307}, {795,0.10926733}, {800,0.10916832}, {805,0.11213861}, {810,0.11195050}, {815,0.11115842}, {820,0.14200990}, {825,0.13113861}, {830,0.12538614}, {835,0.11768317}, {840,0.13272277}, {845,0.13578218}, {850,0.11950495}, {855,0.13120792}, {860,0.11899010}, {865,0.12857426}, {870,0.11945545}, {875,0.12487129}, {880,0.13064356}, {885,0.13664356}, {890,0.15675248}, {895,0.12498020}, {900,0.12475248}, {905,0.12534653}, {910,0.12541584}, {915,0.13123762}, {920,0.12426733}, {925,0.14463366}, {930,0.13679208}, {935,0.13341584}, {940,0.12880198}, {945,0.13551485}, {950,0.13398020}, {955,0.14456436}, {960,0.14162376}, {965,0.14866337}, {970,0.13317822}, {975,0.14039604}, {980,0.14609901}, {985,0.15835644}, {990,0.13825743}, {995,0.13945545}, {1000,0.13657426}, {1010,0.14764356}, {1020,0.14542574}, {1030,0.14113861}, {1040,0.17344554}, {1050,0.15569307}, {1060,0.14549505}, {1070,0.15641584}, {1080,0.16993069}, {1090,0.15128713}, {1100,0.15565347}, {1110,0.16688119}, {1120,0.15900000}, {1130,0.15609901}, {1140,0.17370297}, {1150,0.17227723}, {1160,0.18050495}, {1170,0.16904950}, {1180,0.18442574}, {1190,0.18726733}, {1200,0.16648515}, {1210,0.17579208}, {1220,0.17347525}, {1230,0.19269307}, {1240,0.19318812}, {1250,0.18164356}, {1260,0.19467327}, {1270,0.18824752}, {1280,0.19060396}, {1290,0.21861386}, {1300,0.18572277}, {1310,0.18746535}, {1320,0.19083168}, {1330,0.21187129}, {1340,0.20264356}, {1350,0.20255446}, {1360,0.21136634}, {1370,0.21728713}, {1380,0.21446535}, {1390,0.19613861}, {1400,0.20462376}, {1410,0.20222772}, {1420,0.19751485}, {1430,0.20472277}, {1440,0.21900990}, {1450,0.22182178}, {1460,0.20784158}, {1470,0.23525743}, {1480,0.22842574}, {1490,0.21278218}, {1500,0.22081188}, {1510,0.22036634}, {1520,0.22622772}, {1530,0.21913861}, {1540,0.25318812}, {1550,0.23425743}, {1560,0.22146535}, {1570,0.23917822}, {1580,0.22536634}, {1590,0.23329703}, {1600,0.23532673}, {1610,0.24768317}, {1620,0.24189109}, {1630,0.25118812}, {1640,0.23718812}, {1650,0.26246535}, {1660,0.24695050}, {1670,0.26634653}, {1680,0.24529703}, {1690,0.26301980}, {1700,0.25853465}, {1710,0.27316832}, {1720,0.26313861}, {1730,0.27202970}, {1740,0.25886139}, {1750,0.25911881}, {1760,0.26634653}, {1770,0.26540594}, {1780,0.26515842}, {1790,0.27917822}, {1800,0.26380198}, {1810,0.26221782}, {1820,0.27157426}, {1830,0.26360396}, {1840,0.29068317}, {1850,0.27792079}, {1860,0.27537624}, {1870,0.30938614}, {1880,0.27380198}, {1890,0.29054455}, {1900,0.28522772}, {1910,0.29270297}, {1920,0.28624752}, {1930,0.29220792}, {1940,0.29565347}, {1950,0.28269307}, {1960,0.29141584}, {1970,0.28352475}, {1980,0.29539604}, {1990,0.31050495}, {2000,0.30477228}, {2050,0.31182178}, {2100,0.33094059}, {2150,0.32089109}, {2200,0.34206931}, {2250,0.36350495}, {2300,0.34529703}, {2350,0.35769307}, {2400,0.37805941}, {2450,0.39052475}, {2500,0.37315842}, {2550,0.38384158}, {2600,0.40486139}, {2650,0.41981188}, {2700,0.41637624}, {2750,0.43945545}, {2800,0.42504950}, {2850,0.43402970}, {2900,0.43285149}, {2950,0.44570297}, {3000,0.46486139}, {3050,0.47349505}, {3100,0.46764356}, {3150,0.47726733}, {3200,0.49087129}, {3250,0.48697030}, {3300,0.50487129}, {3350,0.51635644}, {3400,0.51239604}, {3450,0.52639604}, {3500,0.53970297}, {3550,0.55093069}, {3600,0.53895050}, {3650,0.55281188}, {3700,0.57143564}, {3750,0.59396040}, {3800,0.59980198}, {3850,0.59602970}, {3900,0.59744554}, {3950,0.60253465}, {4000,0.62577228}, {4050,0.64737624}, {4100,0.62516832}, {4150,0.64421782}, {4200,0.64327723}, {4250,0.67597030}, {4300,0.67022772}, {4350,0.68209901}, {4400,0.69734653}, {4450,0.68934653}, {4500,0.69543564}, {4550,0.72227723}, {4600,0.72196040}, {4650,0.73673267}, {4700,0.73298020}, {4750,0.73351485}, {4800,0.77482178}, {4850,0.74753465}, {4900,0.78699010}, {4950,0.77851485}, {5000,0.79076238}, {5050,0.79141584}, {5100,0.82018812}, {5150,0.80841584}, {5200,0.88003960}, {5250,0.82314851}, {5300,0.82493069}, {5350,0.85618812}, {5400,0.84403960}, {5450,0.85327723}, {5500,0.87519802}, {5550,0.87610891}, {5600,0.87220792}, {5650,0.88998020}, {5700,0.88097030}, {5750,0.90123762}, {5800,0.92655446}, {5850,0.94280198}, {5900,0.92438614}, {5950,0.93874257}, {6000,0.95334653}, {6050,0.9950286}, {6100,1.0063143}, {6150,1.0114571}, {6200,1.0097429}, {6250,1.0248857}, {6300,1.0298000}, {6350,1.0494857}, {6400,1.0382000}, {6450,1.0693143}, {6500,1.0843429}, {6550,1.0947143}, {6600,1.1127429}, {6650,1.0921429}, {6700,1.0854000}, {6750,1.1118571}, {6800,1.1026000}, {6850,1.1272857}, {6900,1.1279143}, {6950,1.1420286}, {7000,1.1757429}, {7050,1.1916571}, {7100,1.1801429}, {7150,1.1898571}, {7200,1.1948857}, {7250,1.1881714}, {7300,1.2111143}, {7350,1.2151429}, {7400,1.2174571}, {7450,1.2086286}, {7500,1.2122000}, {7550,1.2518571}, {7600,1.2836286}, {7650,1.2986857}, {7700,1.2726857}, {7750,1.3050286}, {7800,1.2805143}, {7850,1.2848000}, {7900,1.3311143}, {7950,1.3431714}, {8000,1.3207714}, {8050,1.3396571}, {8100,1.3194000}, {8150,1.3576000}, {8200,1.3652857}, {8250,1.3630286}, {8300,1.3653714}, {8350,1.3581143}, {8400,1.3930571}, {8450,1.4052857}, {8500,1.4010000}, {8550,1.4056571}, {8600,1.4650000}, {8650,1.4404857}, {8700,1.4451714}, {8750,1.4828286}, {8800,1.4404571}, {8850,1.4543714}, {8900,1.4715429}, {8950,1.5021143}, {9000,1.4668571}, {9050,1.5047429}, {9100,1.5234286}, {9150,1.5200857}, {9200,1.5447429}, {9250,1.5259143}, {9300,1.5290286}, {9350,1.5719143}, {9400,1.5639714}, {9450,1.5714000}, {9500,1.6023429}, {9550,1.5870286}, {9600,1.5965143}, {9650,1.6022000}, {9700,1.6515143}, {9750,1.6085429}, {9800,1.6546857}, {9850,1.6417143}, {9900,1.6754857}, {9950,1.6763143}, {10000,1.6929429}, {10100,1.6692000}, {10200,1.7208000}, {10300,1.7058286}, {10400,1.7444857}, {10500,1.7126857}, {10600,1.7775714}, {10700,1.7700857}, {10800,1.7993143}, {10900,1.7773429}, {11000,1.8278857}, {11100,1.8362571}, {11200,1.8578857}, {11300,1.8498571}, {11400,1.8830286}, {11500,1.8727714}, {11600,1.9338571}, {11700,2.1055714}, {11800,1.9398286}, {11900,2.0708286}, {12000,1.9862286}, {12100,1.9930286}, {12200,2.0315143}, {12300,2.0259714}, {12400,2.0281429}, {12500,2.0798286}, {12600,2.0820000}, {12700,2.1042286}, {12800,2.0772857}, {12900,2.1282571}, {13000,2.1408286}, {13100,2.1744000}, {13200,2.1752857}, {13300,2.2018286}, {13400,2.1871429}, {13500,2.2282286}, {13600,2.2230286}, {13700,2.2582857}, {13800,2.2705714}, {13900,2.3117429}, {14000,2.3171714}, {14100,2.3425143}, {14200,2.3758571}, {14300,2.3819143}, {14400,2.3653429}, {14500,2.4077143}, {14600,2.3830286}, {14700,2.4323714}, {14800,2.4361714}, {14900,2.4235714}, {15000,2.4602286}, {15100,2.5128857}, {15200,2.5056857}, {15300,2.6029714}, {15400,2.5184571}, {15500,2.6485143}, {15600,2.5746571}, {15700,2.5749429}, {15800,2.6045143}, {15900,2.6151714}, {16000,2.6755714}, {16100,2.6767429}, {16200,2.6692286}, {16300,2.6918857}, {16400,2.6511714}, {16500,2.6733143}, {16600,2.7457714}, {16700,2.8404286}, {16800,2.7415143}, {16900,2.7542857}, {17000,2.7834857}, {17100,2.8276571}, {17200,2.9057714}, {17300,2.8191714}, {17400,2.8906000}, {17500,2.8886286}, {17600,2.8810571}, {17700,2.9056571}, {17800,2.8987143}, {17900,2.9646857}, {18000,2.9429143}, {18100,3.0120286}, {18200,2.9873714}, {18300,3.0365143}, {18400,3.0476286}, {18500,3.0399429}, {18600,3.0380571}, {18700,3.0817143}, {18800,3.0998857}, {18900,3.1508286}, {19000,3.3902286}, {19100,3.1812571}, {19200,3.1554857}, {19300,3.2706000}, {19400,3.4309429}, {19500,3.3156000}, {19600,3.3058000}, {19700,3.2631429}, {19800,3.4457429}, {19900,3.4612286}, {20000,3.3259143}};
data["big_flat"]["LtacTCGallinaCtx"]["norm reif"]["user"] = {{1,0.00009901}, {2,0.00013861}, {3,0.00044554}, {4,0.00035644}, {5,0.00080198}, {6,0.00087129}, {7,0.00082178}, {8,0.00077228}, {9,0.00100000}, {10,0.00143564}, {11,0.00145545}, {12,0.00098020}, {13,0.00162376}, {14,0.00148515}, {15,0.00193069}, {16,0.00168317}, {17,0.00204950}, {18,0.00184158}, {19,0.00274257}, {20,0.00238614}, {21,0.00238614}, {22,0.00260396}, {23,0.00266337}, {24,0.00237624}, {25,0.00279208}, {26,0.00316832}, {27,0.00300990}, {28,0.00331683}, {29,0.00339604}, {30,0.00336634}, {31,0.00344554}, {32,0.00463366}, {33,0.00390099}, {34,0.00381188}, {35,0.00408911}, {36,0.00424752}, {37,0.00658416}, {38,0.00455446}, {39,0.00455446}, {40,0.00493069}, {41,0.00444554}, {42,0.00502970}, {43,0.00525743}, {44,0.00489109}, {45,0.00538614}, {46,0.00547525}, {47,0.00594059}, {48,0.00610891}, {49,0.00588119}, {50,0.00598020}, {51,0.00597030}, {52,0.00627723}, {53,0.00664356}, {54,0.00695050}, {55,0.00654455}, {56,0.00691089}, {57,0.00684158}, {58,0.00759406}, {59,0.00723762}, {60,0.00734653}, {61,0.00752475}, {62,0.00724752}, {63,0.00741584}, {64,0.00761386}, {65,0.00791089}, {66,0.00804950}, {67,0.01047525}, {68,0.00827723}, {69,0.00846535}, {70,0.00849505}, {71,0.00867327}, {72,0.00861386}, {73,0.00890099}, {74,0.00928713}, {75,0.01128713}, {76,0.00919802}, {77,0.00902970}, {78,0.00960396}, {79,0.00955446}, {80,0.00996040}, {81,0.00982178}, {82,0.00944554}, {83,0.01009901}, {84,0.01026733}, {85,0.01040594}, {86,0.01049505}, {87,0.01083168}, {88,0.01077228}, {89,0.01184158}, {90,0.01416832}, {91,0.01113861}, {92,0.01134653}, {93,0.01138614}, {94,0.01170297}, {95,0.01173267}, {96,0.01147525}, {97,0.01214851}, {98,0.01204950}, {99,0.01212871}, {100,0.01234653}, {101,0.01293069}, {102,0.01618812}, {103,0.01406931}, {104,0.01239604}, {105,0.01311881}, {106,0.01315842}, {107,0.01341584}, {108,0.01332673}, {109,0.01350495}, {110,0.01371287}, {111,0.01416832}, {112,0.01568317}, {113,0.01384158}, {114,0.01356436}, {115,0.01456436}, {116,0.01471287}, {117,0.01832673}, {118,0.01473267}, {119,0.01493069}, {120,0.01503960}, {121,0.01491089}, {122,0.01496040}, {123,0.01531683}, {124,0.01556436}, {125,0.01692079}, {126,0.01574257}, {127,0.01584158}, {128,0.01595050}, {129,0.01601980}, {130,0.01604950}, {131,0.01627723}, {132,0.01616832}, {133,0.01676238}, {134,0.01664356}, {135,0.01659406}, {136,0.01700990}, {137,0.01913861}, {138,0.01688119}, {139,0.01730693}, {140,0.01743564}, {141,0.01740594}, {142,0.01745545}, {143,0.01736634}, {144,0.01807921}, {145,0.01749505}, {146,0.01973267}, {147,0.01759406}, {148,0.02000990}, {149,0.01800000}, {150,0.01941584}, {151,0.01799010}, {152,0.01800990}, {153,0.01833663}, {154,0.01869307}, {155,0.01871287}, {156,0.01868317}, {157,0.02183168}, {158,0.01915842}, {159,0.01966337}, {160,0.02581188}, {161,0.01908911}, {162,0.01946535}, {163,0.01981188}, {164,0.01986139}, {165,0.01998020}, {166,0.02035644}, {167,0.02047525}, {168,0.01997030}, {169,0.02596040}, {170,0.02043564}, {171,0.02096040}, {172,0.02097030}, {173,0.02835644}, {174,0.02149505}, {175,0.02129703}, {176,0.02104950}, {177,0.02596040}, {178,0.02166337}, {179,0.02183168}, {180,0.02214851}, {181,0.02245545}, {182,0.02382178}, {183,0.02831683}, {184,0.02249505}, {185,0.02285149}, {186,0.02297030}, {187,0.02334653}, {188,0.02271287}, {189,0.02363366}, {190,0.02339604}, {191,0.02434653}, {192,0.02571287}, {193,0.02750495}, {194,0.02923762}, {195,0.03009901}, {196,0.03112871}, {197,0.03173267}, {198,0.03176238}, {199,0.03182178}, {200,0.03150495}, {201,0.03013861}, {202,0.02888119}, {203,0.02874257}, {204,0.02671287}, {205,0.02528713}, {206,0.02527723}, {207,0.02555446}, {208,0.02567327}, {209,0.02606931}, {210,0.02561386}, {211,0.02599010}, {212,0.03734653}, {213,0.03121782}, {214,0.02625743}, {215,0.02669307}, {216,0.02642574}, {217,0.02651485}, {218,0.03342574}, {219,0.02824752}, {220,0.02689109}, {221,0.02715842}, {222,0.02711881}, {223,0.03082178}, {224,0.02714851}, {225,0.02747525}, {226,0.03673267}, {227,0.02899010}, {228,0.02788119}, {229,0.02830693}, {230,0.03190099}, {231,0.02890099}, {232,0.02847525}, {233,0.03211881}, {234,0.02888119}, {235,0.02907921}, {236,0.03005941}, {237,0.02910891}, {238,0.03615842}, {239,0.02963366}, {240,0.02902970}, {241,0.02990099}, {242,0.02984158}, {243,0.03411881}, {244,0.02986139}, {245,0.03645545}, {246,0.03034653}, {247,0.03757426}, {248,0.02989109}, {249,0.03885149}, {250,0.03092079}, {251,0.03793069}, {252,0.03147525}, {253,0.03653465}, {254,0.03156436}, {255,0.03276238}, {256,0.03139604}, {257,0.03130693}, {258,0.04018812}, {259,0.03215842}, {260,0.03491089}, {261,0.03234653}, {262,0.03206931}, {263,0.03913861}, {264,0.03264356}, {265,0.03277228}, {266,0.03962376}, {267,0.03345545}, {268,0.03313861}, {269,0.03863366}, {270,0.03372277}, {271,0.03394059}, {272,0.03541584}, {273,0.04503960}, {274,0.03397030}, {275,0.03402970}, {276,0.03552475}, {277,0.04141584}, {278,0.03472277}, {279,0.03545545}, {280,0.03450495}, {281,0.03704950}, {282,0.04118812}, {283,0.04715842}, {284,0.03545545}, {285,0.03553465}, {286,0.03599010}, {287,0.03610891}, {288,0.03708911}, {289,0.03964356}, {290,0.04281188}, {291,0.04531683}, {292,0.04643564}, {293,0.03650495}, {294,0.03673267}, {295,0.03688119}, {296,0.03704950}, {297,0.03703960}, {298,0.03702970}, {299,0.03723762}, {300,0.03742574}, {301,0.03733663}, {302,0.03794059}, {303,0.03790099}, {304,0.03783168}, {305,0.03790099}, {306,0.05376238}, {307,0.04792079}, {308,0.04580198}, {309,0.04371287}, {310,0.04058416}, {311,0.03840594}, {312,0.03868317}, {313,0.03889109}, {314,0.03906931}, {315,0.05000990}, {316,0.04588119}, {317,0.04148515}, {318,0.03935644}, {319,0.03992079}, {320,0.05077228}, {321,0.04567327}, {322,0.04086139}, {323,0.03970297}, {324,0.04012871}, {325,0.04841584}, {326,0.04263366}, {327,0.04073267}, {328,0.04016832}, {329,0.04646535}, {330,0.04071287}, {331,0.04101980}, {332,0.05195050}, {333,0.04135644}, {334,0.04131683}, {335,0.04909901}, {336,0.04092079}, {337,0.04233663}, {338,0.04686139}, {339,0.04155446}, {340,0.05083168}, {341,0.04278218}, {342,0.04236634}, {343,0.04595050}, {344,0.04268317}, {345,0.04891089}, {346,0.04359406}, {347,0.05012871}, {348,0.04323762}, {349,0.05093069}, {350,0.04343564}, {351,0.05113861}, {352,0.04311881}, {353,0.05013861}, {354,0.04364356}, {355,0.04866337}, {356,0.04420792}, {357,0.04750495}, {358,0.06223762}, {359,0.04495050}, {360,0.05222772}, {361,0.04535644}, {362,0.04736634}, {363,0.05775248}, {364,0.04517822}, {365,0.05003960}, {366,0.05857426}, {367,0.04569307}, {368,0.04916832}, {369,0.05701980}, {370,0.04614851}, {371,0.04781188}, {372,0.05374257}, {373,0.04706931}, {374,0.04680198}, {375,0.04954455}, {376,0.05527723}, {377,0.04721782}, {378,0.04715842}, {379,0.04774257}, {380,0.05517822}, {381,0.06224752}, {382,0.04967327}, {383,0.04798020}, {384,0.04784158}, {385,0.04960396}, {386,0.05388119}, {387,0.05666337}, {388,0.06085149}, {389,0.04866337}, {390,0.04891089}, {391,0.04942574}, {392,0.04914851}, {393,0.04904950}, {394,0.05096040}, {395,0.05247525}, {396,0.05348515}, {397,0.05435644}, {398,0.05510891}, {399,0.05776238}, {400,0.05897030}, {401,0.05725743}, {402,0.05725743}, {403,0.05700990}, {404,0.05622772}, {405,0.05501980}, {406,0.05409901}, {407,0.05268317}, {408,0.05096040}, {409,0.05106931}, {410,0.05127723}, {411,0.05126733}, {412,0.06500990}, {413,0.06323762}, {414,0.06015842}, {415,0.05678218}, {416,0.05287129}, {417,0.05220792}, {418,0.05221782}, {419,0.06705941}, {420,0.06213861}, {421,0.05714851}, {422,0.05238614}, {423,0.05272277}, {424,0.06590099}, {425,0.06017822}, {426,0.05370297}, {427,0.05336634}, {428,0.06470297}, {429,0.05862376}, {430,0.05340594}, {431,0.06812871}, {432,0.06061386}, {433,0.05342574}, {434,0.05398020}, {435,0.06593069}, {436,0.05433663}, {437,0.07140594}, {438,0.06147525}, {439,0.05470297}, {440,0.06615842}, {441,0.05665347}, {442,0.07111881}, {443,0.06082178}, {444,0.05531683}, {445,0.06396040}, {446,0.05564356}, {447,0.06596040}, {448,0.05541584}, {449,0.06652475}, {450,0.05561386}, {451,0.07354455}, {452,0.05642574}, {453,0.07050495}, {454,0.05669307}, {455,0.06882178}, {456,0.05671287}, {457,0.06590099}, {458,0.05715842}, {459,0.06248515}, {460,0.07232673}, {461,0.05740594}, {462,0.06735644}, {463,0.05890099}, {464,0.06118812}, {465,0.07016832}, {466,0.05795050}, {467,0.06663366}, {468,0.07622772}, {469,0.05891089}, {470,0.06391089}, {471,0.07293069}, {472,0.05897030}, {473,0.06159406}, {474,0.06819802}, {475,0.07365347}, {476,0.05995050}, {477,0.06223762}, {478,0.06756436}, {479,0.07260396}, {480,0.05988119}, {481,0.06005941}, {482,0.06595050}, {483,0.07076238}, {484,0.07476238}, {485,0.07815842}, {486,0.06096040}, {487,0.06176238}, {488,0.06417822}, {489,0.06762376}, {490,0.07012871}, {491,0.07281188}, {492,0.07493069}, {493,0.08077228}, {494,0.08661386}, {495,0.06225743}, {496,0.06212871}, {497,0.06260396}, {498,0.06190099}, {499,0.06299010}, {500,0.06290099}, {505,0.06316832}, {510,0.06423762}, {515,0.06416832}, {520,0.07968317}, {525,0.07644554}, {530,0.07356436}, {535,0.06707921}, {540,0.08291089}, {545,0.07371287}, {550,0.08792079}, {555,0.07713861}, {560,0.08692079}, {565,0.07506931}, {570,0.08271287}, {575,0.09078218}, {580,0.07371287}, {585,0.08319802}, {590,0.08629703}, {595,0.08919802}, {600,0.09023762}, {605,0.09078218}, {610,0.08968317}, {615,0.08866337}, {620,0.08553465}, {625,0.08453465}, {630,0.10628713}, {635,0.09631683}, {640,0.08695050}, {645,0.10250495}, {650,0.09249505}, {655,0.08315842}, {660,0.09371287}, {665,0.11322772}, {670,0.09151485}, {675,0.09967327}, {680,0.10555446}, {685,0.08817822}, {690,0.09174257}, {695,0.09570297}, {700,0.10244554}, {705,0.09938614}, {710,0.10026733}, {715,0.09806931}, {720,0.09436634}, {725,0.11414851}, {730,0.10973267}, {735,0.10957426}, {740,0.09774257}, {745,0.11366337}, {750,0.10305941}, {755,0.11511881}, {760,0.10327723}, {765,0.11697030}, {770,0.12562376}, {775,0.10948515}, {780,0.11518812}, {785,0.12080198}, {790,0.13920792}, {795,0.10900000}, {800,0.10918812}, {805,0.11161386}, {810,0.11173267}, {815,0.11084158}, {820,0.14173267}, {825,0.13091089}, {830,0.12529703}, {835,0.11772277}, {840,0.13266337}, {845,0.13531683}, {850,0.11934653}, {855,0.13100000}, {860,0.11841584}, {865,0.12849505}, {870,0.11938614}, {875,0.12456436}, {880,0.13028713}, {885,0.13613861}, {890,0.15648515}, {895,0.12493069}, {900,0.12429703}, {905,0.12508911}, {910,0.12495050}, {915,0.13086139}, {920,0.12400000}, {925,0.14414851}, {930,0.13654455}, {935,0.13346535}, {940,0.12895050}, {945,0.13532673}, {950,0.13376238}, {955,0.14467327}, {960,0.14176238}, {965,0.14869307}, {970,0.13300000}, {975,0.14016832}, {980,0.14580198}, {985,0.15790099}, {990,0.13836634}, {995,0.13918812}, {1000,0.13649505}, {1010,0.14746535}, {1020,0.14506931}, {1030,0.14079208}, {1040,0.17276238}, {1050,0.15513861}, {1060,0.14498020}, {1070,0.15586139}, {1080,0.16963366}, {1090,0.15113861}, {1100,0.15516832}, {1110,0.16652475}, {1120,0.15848515}, {1130,0.15596040}, {1140,0.17344554}, {1150,0.17176238}, {1160,0.18008911}, {1170,0.16833663}, {1180,0.18391089}, {1190,0.18695050}, {1200,0.16558416}, {1210,0.17556436}, {1220,0.17308911}, {1230,0.19198020}, {1240,0.19283168}, {1250,0.18122772}, {1260,0.19425743}, {1270,0.18763366}, {1280,0.18990099}, {1290,0.21838614}, {1300,0.18504950}, {1310,0.18692079}, {1320,0.19052475}, {1330,0.21166337}, {1340,0.20215842}, {1350,0.20160396}, {1360,0.21098020}, {1370,0.21638614}, {1380,0.21398020}, {1390,0.19551485}, {1400,0.20386139}, {1410,0.20171287}, {1420,0.19702970}, {1430,0.20403960}, {1440,0.21846535}, {1450,0.22101980}, {1460,0.20739604}, {1470,0.23475248}, {1480,0.22767327}, {1490,0.21248515}, {1500,0.22050495}, {1510,0.21977228}, {1520,0.22527723}, {1530,0.21847525}, {1540,0.25248515}, {1550,0.23349505}, {1560,0.22093069}, {1570,0.23867327}, {1580,0.22478218}, {1590,0.23252475}, {1600,0.23463366}, {1610,0.24721782}, {1620,0.24092079}, {1630,0.25051485}, {1640,0.23664356}, {1650,0.26198020}, {1660,0.24650495}, {1670,0.26571287}, {1680,0.24432673}, {1690,0.26232673}, {1700,0.25778218}, {1710,0.27242574}, {1720,0.26236634}, {1730,0.27129703}, {1740,0.25819802}, {1750,0.25806931}, {1760,0.26554455}, {1770,0.26442574}, {1780,0.26408911}, {1790,0.27828713}, {1800,0.26301980}, {1810,0.26146535}, {1820,0.27102970}, {1830,0.26296040}, {1840,0.29012871}, {1850,0.27721782}, {1860,0.27463366}, {1870,0.30851485}, {1880,0.27281188}, {1890,0.28984158}, {1900,0.28476238}, {1910,0.29192079}, {1920,0.28557426}, {1930,0.29136634}, {1940,0.29504950}, {1950,0.28192079}, {1960,0.29039604}, {1970,0.28280198}, {1980,0.29491089}, {1990,0.30944554}, {2000,0.30362376}, {2050,0.31117822}, {2100,0.32997030}, {2150,0.31995050}, {2200,0.34101980}, {2250,0.36271287}, {2300,0.34432673}, {2350,0.35680198}, {2400,0.37716832}, {2450,0.38943564}, {2500,0.37246535}, {2550,0.38304950}, {2600,0.40388119}, {2650,0.41885149}, {2700,0.41567327}, {2750,0.43838614}, {2800,0.42424752}, {2850,0.43011881}, {2900,0.43175248}, {2950,0.44472277}, {3000,0.46404950}, {3050,0.47227723}, {3100,0.46642574}, {3150,0.47645545}, {3200,0.48982178}, {3250,0.48585149}, {3300,0.50388119}, {3350,0.51544554}, {3400,0.51114851}, {3450,0.52565347}, {3500,0.53902970}, {3550,0.54993069}, {3600,0.53805941}, {3650,0.55174257}, {3700,0.57038614}, {3750,0.59318812}, {3800,0.59871287}, {3850,0.59484158}, {3900,0.59644554}, {3950,0.60125743}, {4000,0.62475248}, {4050,0.64599010}, {4100,0.62397030}, {4150,0.64280198}, {4200,0.64227723}, {4250,0.67480198}, {4300,0.66887129}, {4350,0.68082178}, {4400,0.69605941}, {4450,0.68787129}, {4500,0.69427723}, {4550,0.72130693}, {4600,0.72067327}, {4650,0.73525743}, {4700,0.73172277}, {4750,0.73195050}, {4800,0.77356436}, {4850,0.74594059}, {4900,0.78533663}, {4950,0.77696040}, {5000,0.78854455}, {5050,0.78990099}, {5100,0.81849505}, {5150,0.80695050}, {5200,0.87863366}, {5250,0.82154455}, {5300,0.82317822}, {5350,0.85450495}, {5400,0.84239604}, {5450,0.85145545}, {5500,0.87349505}, {5550,0.87444554}, {5600,0.87026733}, {5650,0.88843564}, {5700,0.87898020}, {5750,0.89940594}, {5800,0.92499010}, {5850,0.94081188}, {5900,0.92271287}, {5950,0.93704950}, {6000,0.95151485}, {6050,0.9888286}, {6100,0.9974000}, {6150,1.0100857}, {6200,1.0085429}, {6250,1.0243714}, {6300,1.0280000}, {6350,1.0485429}, {6400,1.0371714}, {6450,1.0683143}, {6500,1.0833143}, {6550,1.0929143}, {6600,1.1115143}, {6650,1.0918000}, {6700,1.0839429}, {6750,1.1110571}, {6800,1.1010571}, {6850,1.1221714}, {6900,1.1253429}, {6950,1.1406857}, {7000,1.1740857}, {7050,1.1911714}, {7100,1.1792857}, {7150,1.1884571}, {7200,1.1886000}, {7250,1.1869143}, {7300,1.2073429}, {7350,1.2081429}, {7400,1.2135143}, {7450,1.2066286}, {7500,1.2100000}, {7550,1.2457429}, {7600,1.2783429}, {7650,1.2936857}, {7700,1.2666857}, {7750,1.2955429}, {7800,1.2754857}, {7850,1.2754857}, {7900,1.3277143}, {7950,1.3410571}, {8000,1.3192857}, {8050,1.3383429}, {8100,1.3174857}, {8150,1.3558000}, {8200,1.3632286}, {8250,1.3616857}, {8300,1.3633714}, {8350,1.3564857}, {8400,1.3915714}, {8450,1.4034857}, {8500,1.3986571}, {8550,1.4036000}, {8600,1.4634571}, {8650,1.4381714}, {8700,1.4430000}, {8750,1.4806000}, {8800,1.4388286}, {8850,1.4525714}, {8900,1.4696857}, {8950,1.5003429}, {9000,1.4651714}, {9050,1.5030286}, {9100,1.5216857}, {9150,1.5186857}, {9200,1.5423714}, {9250,1.5239429}, {9300,1.5162286}, {9350,1.5684571}, {9400,1.5613143}, {9450,1.5690571}, {9500,1.6000857}, {9550,1.5845143}, {9600,1.5943429}, {9650,1.5995429}, {9700,1.6490571}, {9750,1.6064571}, {9800,1.6522000}, {9850,1.6396286}, {9900,1.6730286}, {9950,1.6742857}, {10000,1.6908000}, {10100,1.6670286}, {10200,1.7182857}, {10300,1.7030857}, {10400,1.7420286}, {10500,1.7101429}, {10600,1.7756000}, {10700,1.7678000}, {10800,1.7969429}, {10900,1.7744857}, {11000,1.8243429}, {11100,1.8338000}, {11200,1.8555143}, {11300,1.8474857}, {11400,1.8801143}, {11500,1.8703714}, {11600,1.9307714}, {11700,2.1012571}, {11800,1.9366857}, {11900,2.0667429}, {12000,1.9826000}, {12100,1.9898571}, {12200,2.0282286}, {12300,2.0225429}, {12400,2.0249143}, {12500,2.0765714}, {12600,2.0783429}, {12700,2.1004286}, {12800,2.0742857}, {12900,2.1250571}, {13000,2.1375143}, {13100,2.1711714}, {13200,2.1721714}, {13300,2.1987143}, {13400,2.1832857}, {13500,2.2248286}, {13600,2.2196857}, {13700,2.2522857}, {13800,2.2680286}, {13900,2.3094286}, {14000,2.3145714}, {14100,2.3396286}, {14200,2.3725429}, {14300,2.3790286}, {14400,2.3630000}, {14500,2.4048000}, {14600,2.3799714}, {14700,2.4301429}, {14800,2.4325429}, {14900,2.4211714}, {15000,2.4572000}, {15100,2.5102286}, {15200,2.5034571}, {15300,2.6003143}, {15400,2.5154571}, {15500,2.6461714}, {15600,2.5702000}, {15700,2.5710000}, {15800,2.6018286}, {15900,2.6127429}, {16000,2.6722857}, {16100,2.6742857}, {16200,2.6671714}, {16300,2.6892286}, {16400,2.6477714}, {16500,2.6718571}, {16600,2.7424000}, {16700,2.8385429}, {16800,2.7393143}, {16900,2.7520000}, {17000,2.7813429}, {17100,2.8246857}, {17200,2.9030571}, {17300,2.8165429}, {17400,2.8876286}, {17500,2.8858571}, {17600,2.8776286}, {17700,2.9025429}, {17800,2.8953143}, {17900,2.9613714}, {18000,2.9388571}, {18100,3.0074286}, {18200,2.9821429}, {18300,3.0316857}, {18400,3.0431429}, {18500,3.0354286}, {18600,3.0325714}, {18700,3.0772857}, {18800,3.0957714}, {18900,3.1212857}, {19000,3.3743429}, {19100,3.1618000}, {19200,3.1217143}, {19300,3.2664857}, {19400,3.4228000}, {19500,3.3055143}, {19600,3.2852000}, {19700,3.2547143}, {19800,3.4157714}, {19900,3.4565429}, {20000,3.3221714}};
data["big_flat"]["LtacTCGallinaCtx"]["norm reif"]["system"] = {{1,0.00007921}, {2,0.00000000}, {3,0.00002970}, {4,0.00003960}, {5,0.00002970}, {6,0.00000000}, {7,0.00003960}, {8,0.00000000}, {9,0.00000000}, {10,0.00003960}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00003960}, {15,0.00006931}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00003960}, {21,0.00007921}, {22,0.00007921}, {23,0.00002970}, {24,0.00003960}, {25,0.00000000}, {26,0.00003960}, {27,0.00000000}, {28,0.00000000}, {29,0.00006931}, {30,0.00000000}, {31,0.00000000}, {32,0.00006931}, {33,0.00000000}, {34,0.00003960}, {35,0.00002970}, {36,0.00002970}, {37,0.00000000}, {38,0.00003960}, {39,0.00000000}, {40,0.00003960}, {41,0.00003960}, {42,0.00000000}, {43,0.00003960}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00007921}, {49,0.00003960}, {50,0.00007921}, {51,0.00000000}, {52,0.00000000}, {53,0.00003960}, {54,0.00006931}, {55,0.00003960}, {56,0.00003960}, {57,0.00010891}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00003960}, {62,0.00000000}, {63,0.00003960}, {64,0.00003960}, {65,0.00000000}, {66,0.00000000}, {67,0.00011881}, {68,0.00003960}, {69,0.00002970}, {70,0.00002970}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00007921}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00003960}, {79,0.00003960}, {80,0.00007921}, {81,0.00006931}, {82,0.00000000}, {83,0.00006931}, {84,0.00000000}, {85,0.00007921}, {86,0.00003960}, {87,0.00002970}, {88,0.00000000}, {89,0.00007921}, {90,0.00013861}, {91,0.00000000}, {92,0.00000000}, {93,0.00006931}, {94,0.00000000}, {95,0.00003960}, {96,0.00007921}, {97,0.00003960}, {98,0.00000000}, {99,0.00003960}, {100,0.00000000}, {101,0.00000000}, {102,0.00003960}, {103,0.00007921}, {104,0.00003960}, {105,0.00000000}, {106,0.00006931}, {107,0.00000000}, {108,0.00007921}, {109,0.00002970}, {110,0.00003960}, {111,0.00002970}, {112,0.00007921}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00010891}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00007921}, {122,0.00003960}, {123,0.00003960}, {124,0.00000000}, {125,0.00003960}, {126,0.00000000}, {127,0.00000000}, {128,0.00003960}, {129,0.00007921}, {130,0.00003960}, {131,0.00000000}, {132,0.00003960}, {133,0.00002970}, {134,0.00000000}, {135,0.00000000}, {136,0.00002970}, {137,0.00010891}, {138,0.00002970}, {139,0.00000000}, {140,0.00003960}, {141,0.00003960}, {142,0.00003960}, {143,0.00000000}, {144,0.00006931}, {145,0.00000000}, {146,0.00010891}, {147,0.00000000}, {148,0.00002970}, {149,0.00000000}, {150,0.00003960}, {151,0.00000000}, {152,0.00000000}, {153,0.00003960}, {154,0.00000000}, {155,0.00000000}, {156,0.00007921}, {157,0.00006931}, {158,0.00000000}, {159,0.00003960}, {160,0.00015842}, {161,0.00007921}, {162,0.00003960}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00003960}, {168,0.00011881}, {169,0.00014851}, {170,0.00000000}, {171,0.00000000}, {172,0.00007921}, {173,0.00019802}, {174,0.00003960}, {175,0.00003960}, {176,0.00011881}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00006931}, {182,0.00003960}, {183,0.00003960}, {184,0.00003960}, {185,0.00000000}, {186,0.00002970}, {187,0.00000000}, {188,0.00002970}, {189,0.00000000}, {190,0.00000000}, {191,0.00003960}, {192,0.00003960}, {193,0.00014851}, {194,0.00015842}, {195,0.00007921}, {196,0.00015842}, {197,0.00007921}, {198,0.00005941}, {199,0.00023762}, {200,0.00002970}, {201,0.00019802}, {202,0.00021782}, {203,0.00003960}, {204,0.00011881}, {205,0.00007921}, {206,0.00003960}, {207,0.00000000}, {208,0.00003960}, {209,0.00000000}, {210,0.00000000}, {211,0.00003960}, {212,0.00022772}, {213,0.00003960}, {214,0.00007921}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00015842}, {219,0.00010891}, {220,0.00007921}, {221,0.00003960}, {222,0.00007921}, {223,0.00007921}, {224,0.00002970}, {225,0.00003960}, {226,0.00023762}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00003960}, {233,0.00007921}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00021782}, {239,0.00003960}, {240,0.00003960}, {241,0.00000000}, {242,0.00003960}, {243,0.00000000}, {244,0.00000000}, {245,0.00003960}, {246,0.00000000}, {247,0.00007921}, {248,0.00003960}, {249,0.00006931}, {250,0.00000000}, {251,0.00000000}, {252,0.00007921}, {253,0.00000000}, {254,0.00003960}, {255,0.00003960}, {256,0.00000000}, {257,0.00010891}, {258,0.00003960}, {259,0.00000000}, {260,0.00003960}, {261,0.00000000}, {262,0.00000000}, {263,0.00003960}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00003960}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00003960}, {275,0.00003960}, {276,0.00000000}, {277,0.00003960}, {278,0.00000000}, {279,0.00000000}, {280,0.00003960}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00003960}, {285,0.00006931}, {286,0.00000000}, {287,0.00000000}, {288,0.00007921}, {289,0.00000000}, {290,0.00003960}, {291,0.00007921}, {292,0.00002970}, {293,0.00003960}, {294,0.00000000}, {295,0.00003960}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00007921}, {300,0.00003960}, {301,0.00000000}, {302,0.00003960}, {303,0.00000000}, {304,0.00000000}, {305,0.00007921}, {306,0.00000000}, {307,0.00003960}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00007921}, {313,0.00000000}, {314,0.00000000}, {315,0.00003960}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00003960}, {320,0.00007921}, {321,0.00000000}, {322,0.00003960}, {323,0.00003960}, {324,0.00000000}, {325,0.00000000}, {326,0.00003960}, {327,0.00003960}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00006931}, {332,0.00000000}, {333,0.00003960}, {334,0.00003960}, {335,0.00000000}, {336,0.00003960}, {337,0.00003960}, {338,0.00003960}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00003960}, {344,0.00011881}, {345,0.00000000}, {346,0.00003960}, {347,0.00051485}, {348,0.00003960}, {349,0.00015842}, {350,0.00003960}, {351,0.00027723}, {352,0.00000000}, {353,0.00003960}, {354,0.00000000}, {355,0.00003960}, {356,0.00000000}, {357,0.00003960}, {358,0.00006931}, {359,0.00000000}, {360,0.00011881}, {361,0.00000000}, {362,0.00003960}, {363,0.00000000}, {364,0.00000000}, {365,0.00007921}, {366,0.00003960}, {367,0.00000000}, {368,0.00003960}, {369,0.00013861}, {370,0.00003960}, {371,0.00003960}, {372,0.00011881}, {373,0.00000000}, {374,0.00009901}, {375,0.00010891}, {376,0.00000000}, {377,0.00000000}, {378,0.00003960}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00003960}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00003960}, {387,0.00000000}, {388,0.00003960}, {389,0.00003960}, {390,0.00002970}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00003960}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00007921}, {400,0.00003960}, {401,0.00000000}, {402,0.00000000}, {403,0.00007921}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00003960}, {410,0.00003960}, {411,0.00000000}, {412,0.00000000}, {413,0.00007921}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00003960}, {419,0.00002970}, {420,0.00000000}, {421,0.00003960}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00003960}, {426,0.00003960}, {427,0.00003960}, {428,0.00003960}, {429,0.00000000}, {430,0.00000000}, {431,0.00003960}, {432,0.00000000}, {433,0.00000000}, {434,0.00003960}, {435,0.00003960}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00003960}, {441,0.00003960}, {442,0.00010891}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00003960}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00003960}, {454,0.00000000}, {455,0.00003960}, {456,0.00000000}, {457,0.00003960}, {458,0.00003960}, {459,0.00000000}, {460,0.00000000}, {461,0.00003960}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00002970}, {466,0.00000000}, {467,0.00007921}, {468,0.00000000}, {469,0.00003960}, {470,0.00003960}, {471,0.00000000}, {472,0.00007921}, {473,0.00000000}, {474,0.00000000}, {475,0.00003960}, {476,0.00003960}, {477,0.00003960}, {478,0.00000000}, {479,0.00003960}, {480,0.00000000}, {481,0.00003960}, {482,0.00000000}, {483,0.00007921}, {484,0.00000000}, {485,0.00003960}, {486,0.00007921}, {487,0.00003960}, {488,0.00003960}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00003960}, {494,0.00003960}, {495,0.00000000}, {496,0.00000000}, {497,0.00003960}, {498,0.00000000}, {499,0.00000000}, {500,0.00003960}, {505,0.00003960}, {510,0.00003960}, {515,0.00007921}, {520,0.00000000}, {525,0.00003960}, {530,0.00000000}, {535,0.00000000}, {540,0.00003960}, {545,0.00007921}, {550,0.00003960}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00007921}, {575,0.00003960}, {580,0.00000000}, {585,0.00003960}, {590,0.00000000}, {595,0.00003960}, {600,0.00000000}, {605,0.00000000}, {610,0.00003960}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00007921}, {640,0.00000000}, {645,0.00003960}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00003960}, {685,0.00000000}, {690,0.00003960}, {695,0.00007921}, {700,0.00003960}, {705,0.00003960}, {710,0.00000000}, {715,0.00003960}, {720,0.00007921}, {725,0.00003960}, {730,0.00003960}, {735,0.00003960}, {740,0.00000000}, {745,0.00002970}, {750,0.00002970}, {755,0.00000000}, {760,0.00007921}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00007921}, {795,0.00000000}, {800,0.00007921}, {805,0.00000000}, {810,0.00002970}, {815,0.00003960}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00007921}, {845,0.00003960}, {850,0.00003960}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00003960}, {875,0.00000000}, {880,0.00003960}, {885,0.00003960}, {890,0.00011881}, {895,0.00000000}, {900,0.00000000}, {905,0.00006931}, {910,0.00007921}, {915,0.00000000}, {920,0.00003960}, {925,0.00007921}, {930,0.00003960}, {935,0.00007921}, {940,0.00000000}, {945,0.00000000}, {950,0.00003960}, {955,0.00007921}, {960,0.00000000}, {965,0.00000000}, {970,0.00003960}, {975,0.00000000}, {980,0.00003960}, {985,0.00000000}, {990,0.00007921}, {995,0.00000000}, {1000,0.00003960}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00007921}, {1050,0.00007921}, {1060,0.00003960}, {1070,0.00000000}, {1080,0.00003960}, {1090,0.00003960}, {1100,0.00003960}, {1110,0.00000000}, {1120,0.00007921}, {1130,0.00003960}, {1140,0.00000000}, {1150,0.00011881}, {1160,0.00003960}, {1170,0.00000000}, {1180,0.00007921}, {1190,0.00000000}, {1200,0.00003960}, {1210,0.00003960}, {1220,0.00003960}, {1230,0.00003960}, {1240,0.00000000}, {1250,0.00007921}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003960}, {1290,0.00000000}, {1300,0.00007921}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00003960}, {1340,0.00003960}, {1350,0.00003960}, {1360,0.00000000}, {1370,0.00007921}, {1380,0.00003960}, {1390,0.00007921}, {1400,0.00000000}, {1410,0.00003960}, {1420,0.00003960}, {1430,0.00003960}, {1440,0.00003960}, {1450,0.00003960}, {1460,0.00007921}, {1470,0.00015842}, {1480,0.00007921}, {1490,0.00007921}, {1500,0.00000000}, {1510,0.00003960}, {1520,0.00003960}, {1530,0.00000000}, {1540,0.00003960}, {1550,0.00011881}, {1560,0.00003960}, {1570,0.00007921}, {1580,0.00007921}, {1590,0.00003960}, {1600,0.00003960}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00011881}, {1640,0.00011881}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00003960}, {1690,0.00003960}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00007921}, {1730,0.00003960}, {1740,0.00000000}, {1750,0.00023762}, {1760,0.00007921}, {1770,0.00006931}, {1780,0.00007921}, {1790,0.00003960}, {1800,0.00007921}, {1810,0.00007921}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00003960}, {1860,0.00006931}, {1870,0.00007921}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00003960}, {1910,0.00007921}, {1920,0.00003960}, {1930,0.00000000}, {1940,0.00003960}, {1950,0.00003960}, {1960,0.00003960}, {1970,0.00007921}, {1980,0.00007921}, {1990,0.00003960}, {2000,0.00007921}, {2050,0.00003960}, {2100,0.00003960}, {2150,0.00003960}, {2200,0.00003960}, {2250,0.00007921}, {2300,0.00003960}, {2350,0.00011881}, {2400,0.00007921}, {2450,0.00007921}, {2500,0.00007921}, {2550,0.00007921}, {2600,0.00000000}, {2650,0.00007921}, {2700,0.00003960}, {2750,0.00011881}, {2800,0.00003960}, {2850,0.00278218}, {2900,0.00002970}, {2950,0.00003960}, {3000,0.00000000}, {3050,0.00003960}, {3100,0.00007921}, {3150,0.00003960}, {3200,0.00007921}, {3250,0.00007921}, {3300,0.00000000}, {3350,0.00019802}, {3400,0.00015842}, {3450,0.00015842}, {3500,0.00003960}, {3550,0.00003960}, {3600,0.00007921}, {3650,0.00007921}, {3700,0.00010891}, {3750,0.00003960}, {3800,0.00011881}, {3850,0.00015842}, {3900,0.00007921}, {3950,0.00019802}, {4000,0.00000000}, {4050,0.00003960}, {4100,0.00011881}, {4150,0.00002970}, {4200,0.00000000}, {4250,0.00003960}, {4300,0.00007921}, {4350,0.00003960}, {4400,0.00000000}, {4450,0.00011881}, {4500,0.00007921}, {4550,0.00000000}, {4600,0.00007921}, {4650,0.00015842}, {4700,0.00006931}, {4750,0.00003960}, {4800,0.00007921}, {4850,0.00011881}, {4900,0.00003960}, {4950,0.00003960}, {5000,0.00031683}, {5050,0.00007921}, {5100,0.00011881}, {5150,0.00015842}, {5200,0.00003960}, {5250,0.00011881}, {5300,0.00007921}, {5350,0.00015842}, {5400,0.00003960}, {5450,0.00015842}, {5500,0.00007921}, {5550,0.00019802}, {5600,0.00011881}, {5650,0.00003960}, {5700,0.00019802}, {5750,0.00019802}, {5800,0.00000000}, {5850,0.00031683}, {5900,0.00003960}, {5950,0.00007921}, {6000,0.00003960}, {6050,0.0051143}, {6100,0.0070857}, {6150,0.0002286}, {6200,0.0002286}, {6250,0.0001143}, {6300,0.0008857}, {6350,0.0000000}, {6400,0.0002286}, {6450,0.0000857}, {6500,0.0001143}, {6550,0.0004571}, {6600,0.0003429}, {6650,0.0000000}, {6700,0.0004571}, {6750,0.0001143}, {6800,0.0000000}, {6850,0.0002286}, {6900,0.0000000}, {6950,0.0001143}, {7000,0.0002286}, {7050,0.0002286}, {7100,0.0000000}, {7150,0.0003429}, {7200,0.0002286}, {7250,0.0001143}, {7300,0.0003429}, {7350,0.0002286}, {7400,0.0002286}, {7450,0.0002286}, {7500,0.0001143}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0002286}, {7700,0.0000000}, {7750,0.0001143}, {7800,0.0001143}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0002286}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0005714}, {8200,0.0000857}, {8250,0.0000000}, {8300,0.0001143}, {8350,0.0001143}, {8400,0.0001143}, {8450,0.0000000}, {8500,0.0002286}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0003429}, {8700,0.0002286}, {8750,0.0002286}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0001143}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0001143}, {9150,0.0001143}, {9200,0.0001143}, {9250,0.0004571}, {9300,0.0022571}, {9350,0.0003429}, {9400,0.0002286}, {9450,0.0004286}, {9500,0.0003429}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0004571}, {9700,0.0002286}, {9750,0.0002286}, {9800,0.0003429}, {9850,0.0001143}, {9900,0.0001143}, {9950,0.0001143}, {10000,0.0002000}, {10100,0.0000000}, {10200,0.0003429}, {10300,0.0002286}, {10400,0.0000000}, {10500,0.0004571}, {10600,0.0001143}, {10700,0.0002286}, {10800,0.0002286}, {10900,0.0002286}, {11000,0.0002286}, {11100,0.0000857}, {11200,0.0001143}, {11300,0.0000000}, {11400,0.0002286}, {11500,0.0000000}, {11600,0.0001143}, {11700,0.0013429}, {11800,0.0000000}, {11900,0.0008000}, {12000,0.0001143}, {12100,0.0000000}, {12200,0.0003143}, {12300,0.0002286}, {12400,0.0001143}, {12500,0.0000000}, {12600,0.0007714}, {12700,0.0004571}, {12800,0.0000000}, {12900,0.0002857}, {13000,0.0002286}, {13100,0.0002286}, {13200,0.0001143}, {13300,0.0003429}, {13400,0.0002286}, {13500,0.0002286}, {13600,0.0002286}, {13700,0.0001143}, {13800,0.0002286}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0001143}, {14200,0.0001143}, {14300,0.0002286}, {14400,0.0003429}, {14500,0.0001143}, {14600,0.0001143}, {14700,0.0000000}, {14800,0.0011429}, {14900,0.0001143}, {15000,0.0006857}, {15100,0.0000000}, {15200,0.0002000}, {15300,0.0002286}, {15400,0.0004571}, {15500,0.0000000}, {15600,0.0019429}, {15700,0.0014857}, {15800,0.0004571}, {15900,0.0001143}, {16000,0.0010857}, {16100,0.0003429}, {16200,0.0001143}, {16300,0.0012571}, {16400,0.0015714}, {16500,0.0001143}, {16600,0.0012286}, {16700,0.0003429}, {16800,0.0002286}, {16900,0.0002286}, {17000,0.0004571}, {17100,0.0008000}, {17200,0.0004571}, {17300,0.0000000}, {17400,0.0001143}, {17500,0.0000000}, {17600,0.0004571}, {17700,0.0002286}, {17800,0.0000000}, {17900,0.0005714}, {18000,0.0013714}, {18100,0.0019143}, {18200,0.0019429}, {18300,0.0011429}, {18400,0.0008857}, {18500,0.0010286}, {18600,0.0014857}, {18700,0.0008000}, {18800,0.0006857}, {18900,0.0001143}, {19000,0.0011429}, {19100,0.0003429}, {19200,0.0008000}, {19300,0.0002000}, {19400,0.0009143}, {19500,0.0013429}, {19600,0.0012571}, {19700,0.0010286}, {19800,0.0021714}, {19900,0.0021714}, {20000,0.0016000}};
data["big_flat"]["LtacTCGallinaCtx"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCGallinaCtx"]["post"]["user"] = {{1,0.00000000}, {2,0.00006931}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00002970}, {7,0.00006931}, {8,0.00000000}, {9,0.00002970}, {10,0.00000000}, {11,0.00000000}, {12,0.00002970}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00006931}, {17,0.00002970}, {18,0.00008911}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00003960}, {24,0.00000000}, {25,0.00010891}, {26,0.00000000}, {27,0.00000000}, {28,0.00003960}, {29,0.00005941}, {30,0.00003960}, {31,0.00009901}, {32,0.00000000}, {33,0.00002970}, {34,0.00003960}, {35,0.00000000}, {36,0.00003960}, {37,0.00002970}, {38,0.00000000}, {39,0.00000000}, {40,0.00005941}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00006931}, {45,0.00002970}, {46,0.00000000}, {47,0.00000000}, {48,0.00007921}, {49,0.00000000}, {50,0.00011881}, {51,0.00011881}, {52,0.00002970}, {53,0.00003960}, {54,0.00000000}, {55,0.00006931}, {56,0.00003960}, {57,0.00003960}, {58,0.00000000}, {59,0.00000000}, {60,0.00005941}, {61,0.00003960}, {62,0.00002970}, {63,0.00003960}, {64,0.00006931}, {65,0.00000000}, {66,0.00002970}, {67,0.00002970}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00002970}, {74,0.00002970}, {75,0.00002970}, {76,0.00003960}, {77,0.00000000}, {78,0.00002970}, {79,0.00000000}, {80,0.00007921}, {81,0.00000000}, {82,0.00006931}, {83,0.00002970}, {84,0.00002970}, {85,0.00000000}, {86,0.00006931}, {87,0.00005941}, {88,0.00000000}, {89,0.00000000}, {90,0.00008911}, {91,0.00005941}, {92,0.00000000}, {93,0.00003960}, {94,0.00002970}, {95,0.00003960}, {96,0.00009901}, {97,0.00006931}, {98,0.00002970}, {99,0.00000000}, {100,0.00000000}, {101,0.00003960}, {102,0.00002970}, {103,0.00000000}, {104,0.00005941}, {105,0.00003960}, {106,0.00000000}, {107,0.00002970}, {108,0.00002970}, {109,0.00000000}, {110,0.00005941}, {111,0.00003960}, {112,0.00000000}, {113,0.00002970}, {114,0.00006931}, {115,0.00003960}, {116,0.00002970}, {117,0.00002970}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00002970}, {122,0.00000000}, {123,0.00002970}, {124,0.00005941}, {125,0.00000000}, {126,0.00009901}, {127,0.00008911}, {128,0.00005941}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00006931}, {133,0.00005941}, {134,0.00006931}, {135,0.00000000}, {136,0.00000000}, {137,0.00002970}, {138,0.00009901}, {139,0.00002970}, {140,0.00000000}, {141,0.00022772}, {142,0.00000000}, {143,0.00002970}, {144,0.00000000}, {145,0.00003960}, {146,0.00000000}, {147,0.00003960}, {148,0.00003960}, {149,0.00000000}, {150,0.00007921}, {151,0.00009901}, {152,0.00000000}, {153,0.00002970}, {154,0.00000000}, {155,0.00003960}, {156,0.00002970}, {157,0.00003960}, {158,0.00003960}, {159,0.00000000}, {160,0.00000000}, {161,0.00006931}, {162,0.00000000}, {163,0.00003960}, {164,0.00003960}, {165,0.00003960}, {166,0.00003960}, {167,0.00003960}, {168,0.00006931}, {169,0.00000000}, {170,0.00006931}, {171,0.00002970}, {172,0.00003960}, {173,0.00003960}, {174,0.00003960}, {175,0.00000000}, {176,0.00000000}, {177,0.00002970}, {178,0.00002970}, {179,0.00000000}, {180,0.00000000}, {181,0.00003960}, {182,0.00006931}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00002970}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00002970}, {191,0.00002970}, {192,0.00003960}, {193,0.00007921}, {194,0.00007921}, {195,0.00000000}, {196,0.00006931}, {197,0.00000000}, {198,0.00000000}, {199,0.00006931}, {200,0.00000000}, {201,0.00000000}, {202,0.00003960}, {203,0.00000000}, {204,0.00006931}, {205,0.00000000}, {206,0.00005941}, {207,0.00002970}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00007921}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00006931}, {218,0.00000000}, {219,0.00006931}, {220,0.00003960}, {221,0.00000000}, {222,0.00003960}, {223,0.00000000}, {224,0.00002970}, {225,0.00003960}, {226,0.00006931}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00002970}, {237,0.00007921}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00005941}, {243,0.00000000}, {244,0.00000000}, {245,0.00002970}, {246,0.00000000}, {247,0.00000000}, {248,0.00003960}, {249,0.00000000}, {250,0.00007921}, {251,0.00002970}, {252,0.00000000}, {253,0.00002970}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00003960}, {258,0.00003960}, {259,0.00002970}, {260,0.00000000}, {261,0.00000000}, {262,0.00002970}, {263,0.00002970}, {264,0.00000000}, {265,0.00005941}, {266,0.00003960}, {267,0.00002970}, {268,0.00002970}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00002970}, {274,0.00000000}, {275,0.00002970}, {276,0.00000000}, {277,0.00002970}, {278,0.00002970}, {279,0.00000000}, {280,0.00003960}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00003960}, {285,0.00002970}, {286,0.00003960}, {287,0.00005941}, {288,0.00000000}, {289,0.00000000}, {290,0.00007921}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00003960}, {295,0.00000000}, {296,0.00010891}, {297,0.00000000}, {298,0.00000000}, {299,0.00002970}, {300,0.00000000}, {301,0.00010891}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00002970}, {306,0.00002970}, {307,0.00003960}, {308,0.00000000}, {309,0.00002970}, {310,0.00000000}, {311,0.00005941}, {312,0.00000000}, {313,0.00000000}, {314,0.00003960}, {315,0.00006931}, {316,0.00006931}, {317,0.00000000}, {318,0.00006931}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00005941}, {324,0.00002970}, {325,0.00000000}, {326,0.00000000}, {327,0.00003960}, {328,0.00005941}, {329,0.00009901}, {330,0.00000000}, {331,0.00002970}, {332,0.00002970}, {333,0.00000000}, {334,0.00000000}, {335,0.00002970}, {336,0.00003960}, {337,0.00002970}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00006931}, {342,0.00002970}, {343,0.00009901}, {344,0.00008911}, {345,0.00005941}, {346,0.00000000}, {347,0.00008911}, {348,0.00000000}, {349,0.00002970}, {350,0.00002970}, {351,0.00003960}, {352,0.00003960}, {353,0.00000000}, {354,0.00013861}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00003960}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00003960}, {363,0.00000000}, {364,0.00000000}, {365,0.00003960}, {366,0.00000000}, {367,0.00002970}, {368,0.00000000}, {369,0.00003960}, {370,0.00007921}, {371,0.00000000}, {372,0.00002970}, {373,0.00000000}, {374,0.00007921}, {375,0.00002970}, {376,0.00003960}, {377,0.00000000}, {378,0.00003960}, {379,0.00000000}, {380,0.00003960}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00003960}, {386,0.00002970}, {387,0.00003960}, {388,0.00003960}, {389,0.00000000}, {390,0.00000000}, {391,0.00003960}, {392,0.00000000}, {393,0.00000000}, {394,0.00002970}, {395,0.00003960}, {396,0.00000000}, {397,0.00000000}, {398,0.00003960}, {399,0.00000000}, {400,0.00007921}, {401,0.00000000}, {402,0.00003960}, {403,0.00006931}, {404,0.00003960}, {405,0.00006931}, {406,0.00003960}, {407,0.00000000}, {408,0.00003960}, {409,0.00002970}, {410,0.00003960}, {411,0.00000000}, {412,0.00002970}, {413,0.00000000}, {414,0.00006931}, {415,0.00002970}, {416,0.00000000}, {417,0.00003960}, {418,0.00003960}, {419,0.00000000}, {420,0.00002970}, {421,0.00000000}, {422,0.00003960}, {423,0.00006931}, {424,0.00007921}, {425,0.00000000}, {426,0.00000000}, {427,0.00007921}, {428,0.00000000}, {429,0.00003960}, {430,0.00000000}, {431,0.00005941}, {432,0.00000000}, {433,0.00003960}, {434,0.00000000}, {435,0.00003960}, {436,0.00002970}, {437,0.00002970}, {438,0.00000000}, {439,0.00000000}, {440,0.00003960}, {441,0.00002970}, {442,0.00003960}, {443,0.00007921}, {444,0.00003960}, {445,0.00000000}, {446,0.00000000}, {447,0.00002970}, {448,0.00006931}, {449,0.00000000}, {450,0.00003960}, {451,0.00000000}, {452,0.00003960}, {453,0.00000000}, {454,0.00007921}, {455,0.00006931}, {456,0.00002970}, {457,0.00003960}, {458,0.00000000}, {459,0.00002970}, {460,0.00000000}, {461,0.00000000}, {462,0.00003960}, {463,0.00007921}, {464,0.00000000}, {465,0.00006931}, {466,0.00011881}, {467,0.00002970}, {468,0.00003960}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00002970}, {473,0.00002970}, {474,0.00003960}, {475,0.00003960}, {476,0.00006931}, {477,0.00000000}, {478,0.00003960}, {479,0.00007921}, {480,0.00002970}, {481,0.00002970}, {482,0.00003960}, {483,0.00003960}, {484,0.00002970}, {485,0.00002970}, {486,0.00007921}, {487,0.00006931}, {488,0.00003960}, {489,0.00003960}, {490,0.00003960}, {491,0.00000000}, {492,0.00000000}, {493,0.00003960}, {494,0.00003960}, {495,0.00002970}, {496,0.00003960}, {497,0.00000000}, {498,0.00002970}, {499,0.00009901}, {500,0.00007921}, {505,0.00007921}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00002970}, {540,0.00002970}, {545,0.00000000}, {550,0.00002970}, {555,0.00005941}, {560,0.00000000}, {565,0.00000000}, {570,0.00003960}, {575,0.00000000}, {580,0.00005941}, {585,0.00002970}, {590,0.00000000}, {595,0.00000000}, {600,0.00002970}, {605,0.00003960}, {610,0.00010891}, {615,0.00003960}, {620,0.00003960}, {625,0.00000000}, {630,0.00009901}, {635,0.00002970}, {640,0.00000000}, {645,0.00007921}, {650,0.00002970}, {655,0.00000000}, {660,0.00003960}, {665,0.00002970}, {670,0.00010891}, {675,0.00000000}, {680,0.00006931}, {685,0.00000000}, {690,0.00007921}, {695,0.00009901}, {700,0.00000000}, {705,0.00002970}, {710,0.00000000}, {715,0.00010891}, {720,0.00000000}, {725,0.00002970}, {730,0.00005941}, {735,0.00000000}, {740,0.00000000}, {745,0.00002970}, {750,0.00002970}, {755,0.00003960}, {760,0.00000000}, {765,0.00002970}, {770,0.00002970}, {775,0.00002970}, {780,0.00000000}, {785,0.00002970}, {790,0.00008911}, {795,0.00002970}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00006931}, {820,0.00000000}, {825,0.00007921}, {830,0.00002970}, {835,0.00000000}, {840,0.00000000}, {845,0.00003960}, {850,0.00000000}, {855,0.00002970}, {860,0.00003960}, {865,0.00005941}, {870,0.00000000}, {875,0.00003960}, {880,0.00003960}, {885,0.00000000}, {890,0.00000000}, {895,0.00002970}, {900,0.00005941}, {905,0.00006931}, {910,0.00002970}, {915,0.00002970}, {920,0.00003960}, {925,0.00003960}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00005941}, {950,0.00000000}, {955,0.00002970}, {960,0.00007921}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00003960}, {985,0.00006931}, {990,0.00000000}, {995,0.00003960}, {1000,0.00002970}, {1010,0.00000000}, {1020,0.00005941}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00011881}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00002970}, {1100,0.00002970}, {1110,0.00002970}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00003960}, {1150,0.00000000}, {1160,0.00005941}, {1170,0.00002970}, {1180,0.00002970}, {1190,0.00000000}, {1200,0.00013861}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00008911}, {1250,0.00002970}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00005941}, {1300,0.00009901}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00005941}, {1340,0.00012871}, {1350,0.00008911}, {1360,0.00005941}, {1370,0.00002970}, {1380,0.00000000}, {1390,0.00002970}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00003960}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00002970}, {1470,0.00006931}, {1480,0.00000000}, {1490,0.00003960}, {1500,0.00006931}, {1510,0.00000000}, {1520,0.00002970}, {1530,0.00003960}, {1540,0.00003960}, {1550,0.00000000}, {1560,0.00007921}, {1570,0.00002970}, {1580,0.00003960}, {1590,0.00000000}, {1600,0.00009901}, {1610,0.00003960}, {1620,0.00003960}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00003960}, {1660,0.00000000}, {1670,0.00006931}, {1680,0.00010891}, {1690,0.00000000}, {1700,0.00003960}, {1710,0.00005941}, {1720,0.00003960}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00003960}, {1760,0.00003960}, {1770,0.00002970}, {1780,0.00007921}, {1790,0.00006931}, {1800,0.00003960}, {1810,0.00010891}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00003960}, {1850,0.00002970}, {1860,0.00014851}, {1870,0.00003960}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00002970}, {1920,0.00000000}, {1930,0.00003960}, {1940,0.00000000}, {1950,0.00002970}, {1960,0.00000000}, {1970,0.00006931}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00006931}, {2050,0.00000000}, {2100,0.00017822}, {2150,0.00007921}, {2200,0.00007921}, {2250,0.00000000}, {2300,0.00017822}, {2350,0.00000000}, {2400,0.00007921}, {2450,0.00007921}, {2500,0.00007921}, {2550,0.00000000}, {2600,0.00003960}, {2650,0.00003960}, {2700,0.00003960}, {2750,0.00000000}, {2800,0.00003960}, {2850,0.00000000}, {2900,0.00003960}, {2950,0.00000000}, {3000,0.00003960}, {3050,0.00003960}, {3100,0.00002970}, {3150,0.00003960}, {3200,0.00006931}, {3250,0.00000000}, {3300,0.00003960}, {3350,0.00000000}, {3400,0.00007921}, {3450,0.00006931}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00002970}, {3700,0.00009901}, {3750,0.00003960}, {3800,0.00003960}, {3850,0.00009901}, {3900,0.00003960}, {3950,0.00000000}, {4000,0.00009901}, {4050,0.00007921}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00007921}, {4250,0.00003960}, {4300,0.00003960}, {4350,0.00002970}, {4400,0.00003960}, {4450,0.00000000}, {4500,0.00006931}, {4550,0.00010891}, {4600,0.00003960}, {4650,0.00007921}, {4700,0.00003960}, {4750,0.00000000}, {4800,0.00007921}, {4850,0.00003960}, {4900,0.00003960}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00010891}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00007921}, {5350,0.00007921}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00006931}, {5550,0.00003960}, {5600,0.00000000}, {5650,0.00007921}, {5700,0.00015842}, {5750,0.00003960}, {5800,0.00003960}, {5850,0.00003960}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000857}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000857}, {6350,0.0000000}, {6400,0.0000857}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0001143}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0001143}, {7400,0.0000857}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000857}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0001143}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0001143}, {8300,0.0001143}, {8350,0.0001143}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000857}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0002000}, {8950,0.0001143}, {9000,0.0000000}, {9050,0.0001143}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0001143}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0001143}, {9450,0.0000000}, {9500,0.0001143}, {9550,0.0000000}, {9600,0.0001143}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0001143}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0001143}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0001714}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0003143}, {11500,0.0000000}, {11600,0.0001143}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0001143}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000857}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000857}, {13000,0.0000000}, {13100,0.0000857}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000857}, {13900,0.0001714}, {14000,0.0000857}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0001143}, {14400,0.0001143}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0001143}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0001143}, {15500,0.0000000}, {15600,0.0002000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000857}, {16500,0.0000000}, {16600,0.0001143}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0001143}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000857}, {17300,0.0001714}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0001143}, {17700,0.0000000}, {17800,0.0001143}, {17900,0.0000857}, {18000,0.0000000}, {18100,0.0001143}, {18200,0.0000857}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0001714}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000857}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000857}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCGallinaCtx"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00003960}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00002970}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00003960}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCGallinaCtx"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCGallinaCtx"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003960}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00002970}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00003960}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00002970}, {63,0.00000000}, {64,0.00000000}, {65,0.00003960}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00002970}, {70,0.00000000}, {71,0.00003960}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00003960}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00002970}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00002970}, {125,0.00000000}, {126,0.00000000}, {127,0.00002970}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00003960}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00003960}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00003960}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00002970}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00003960}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00003960}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00032673}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00003960}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00002970}, {259,0.00002970}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00002970}, {266,0.00000000}, {267,0.00002970}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00003960}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00002970}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00002970}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00003960}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00003960}, {325,0.00002970}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00002970}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00002970}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00003960}, {364,0.00000000}, {365,0.00003960}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00003960}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00003960}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00003960}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00003960}, {439,0.00000000}, {440,0.00000000}, {441,0.00003960}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00003960}, {447,0.00000000}, {448,0.00003960}, {449,0.00000000}, {450,0.00000000}, {451,0.00003960}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00003960}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00003960}, {476,0.00000000}, {477,0.00002970}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00002970}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00003960}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00002970}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00002970}, {660,0.00000000}, {665,0.00003960}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00003960}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00002970}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00002970}, {845,0.00002970}, {850,0.00003960}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00003960}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00003960}, {940,0.00000000}, {945,0.00002970}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00002970}, {975,0.00000000}, {980,0.00000000}, {985,0.00002970}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00003960}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00003960}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00003960}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00003960}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003960}, {1490,0.00003960}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00003960}, {1530,0.00002970}, {1540,0.00000000}, {1550,0.00003960}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00007921}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00003960}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00003960}, {1940,0.00000000}, {1950,0.00007921}, {1960,0.00002970}, {1970,0.00000000}, {1980,0.00002970}, {1990,0.00003960}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00010891}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00003960}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00007921}, {2900,0.00000000}, {2950,0.00003960}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00002970}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00002970}, {3650,0.00003960}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00003960}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00003960}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00003960}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00010891}, {5000,0.00000000}, {5050,0.00003960}, {5100,0.00000000}, {5150,0.00002970}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00003960}, {5500,0.00003960}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0001143}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0001143}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0001143}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0001143}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000857}, {12000,0.0000000}, {12100,0.0001143}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000857}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000857}, {17100,0.0000000}, {17200,0.0000857}, {17300,0.0000000}, {17400,0.0001143}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0001143}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCGallinaCtx"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00003960}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCGallinaCtx"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00042574}, {7,0.00100000}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00107921}, {14,0.00137624}, {15,0.00200000}, {16,0.00200000}, {17,0.00200000}, {18,0.00200000}, {19,0.00299010}, {20,0.00202970}, {21,0.00224752}, {22,0.00238614}, {23,0.00300000}, {24,0.00300000}, {25,0.00300000}, {26,0.00300000}, {27,0.00300990}, {28,0.00310891}, {29,0.00316832}, {30,0.00343564}, {31,0.00399010}, {32,0.00492079}, {33,0.00400000}, {34,0.00400000}, {35,0.00407921}, {36,0.00415842}, {37,0.00626733}, {38,0.00441584}, {39,0.00489109}, {40,0.00500000}, {41,0.00500000}, {42,0.00500990}, {43,0.00512871}, {44,0.00512871}, {45,0.00525743}, {46,0.00535644}, {47,0.00589109}, {48,0.00599010}, {49,0.00600000}, {50,0.00603960}, {51,0.00618812}, {52,0.00617822}, {53,0.00635644}, {54,0.00658416}, {55,0.00673267}, {56,0.00693069}, {57,0.00700990}, {58,0.00712871}, {59,0.00724752}, {60,0.00723762}, {61,0.00742574}, {62,0.00734653}, {63,0.00772277}, {64,0.00781188}, {65,0.00808911}, {66,0.00816832}, {67,0.01064356}, {68,0.00823762}, {69,0.00828713}, {70,0.00835644}, {71,0.00876238}, {72,0.00887129}, {73,0.00908911}, {74,0.00905941}, {75,0.01113861}, {76,0.00921782}, {77,0.00929703}, {78,0.00942574}, {79,0.00970297}, {80,0.00967327}, {81,0.01013861}, {82,0.01004950}, {83,0.01023762}, {84,0.01012871}, {85,0.01025743}, {86,0.01039604}, {87,0.01076238}, {88,0.01071287}, {89,0.01163366}, {90,0.01380198}, {91,0.01208911}, {92,0.01124752}, {93,0.01130693}, {94,0.01149505}, {95,0.01186139}, {96,0.01175248}, {97,0.01215842}, {98,0.01211881}, {99,0.01225743}, {100,0.01221782}, {101,0.01243564}, {102,0.01600990}, {103,0.01420792}, {104,0.01261386}, {105,0.01308911}, {106,0.01316832}, {107,0.01322772}, {108,0.01322772}, {109,0.01343564}, {110,0.01344554}, {111,0.01378218}, {112,0.01525743}, {113,0.01394059}, {114,0.01408911}, {115,0.01424752}, {116,0.01427723}, {117,0.01909901}, {118,0.01439604}, {119,0.01479208}, {120,0.01488119}, {121,0.01501980}, {122,0.01505941}, {123,0.01523762}, {124,0.01532673}, {125,0.01649505}, {126,0.01541584}, {127,0.01559406}, {128,0.01566337}, {129,0.01582178}, {130,0.01607921}, {131,0.01620792}, {132,0.01612871}, {133,0.01655446}, {134,0.01659406}, {135,0.01659406}, {136,0.01675248}, {137,0.01955446}, {138,0.01702970}, {139,0.01730693}, {140,0.01721782}, {141,0.01739604}, {142,0.01742574}, {143,0.01771287}, {144,0.01855446}, {145,0.01807921}, {146,0.02025743}, {147,0.01820792}, {148,0.02058416}, {149,0.01834653}, {150,0.01989109}, {151,0.01891089}, {152,0.01858416}, {153,0.01906931}, {154,0.01930693}, {155,0.01931683}, {156,0.01938614}, {157,0.02213861}, {158,0.01961386}, {159,0.01987129}, {160,0.02601980}, {161,0.01990099}, {162,0.02007921}, {163,0.02028713}, {164,0.02036634}, {165,0.02048515}, {166,0.02062376}, {167,0.02066337}, {168,0.02071287}, {169,0.02625743}, {170,0.02128713}, {171,0.02149505}, {172,0.02144554}, {173,0.02872277}, {174,0.02160396}, {175,0.02189109}, {176,0.02165347}, {177,0.02656436}, {178,0.02212871}, {179,0.02237624}, {180,0.02224752}, {181,0.02242574}, {182,0.02406931}, {183,0.02831683}, {184,0.02272277}, {185,0.02310891}, {186,0.02328713}, {187,0.02344554}, {188,0.02319802}, {189,0.02363366}, {190,0.02347525}, {191,0.02462376}, {192,0.02618812}, {193,0.02794059}, {194,0.02937624}, {195,0.03035644}, {196,0.03121782}, {197,0.03177228}, {198,0.03180198}, {199,0.03180198}, {200,0.03145545}, {201,0.03069307}, {202,0.02939604}, {203,0.02892079}, {204,0.02737624}, {205,0.02542574}, {206,0.02567327}, {207,0.02574257}, {208,0.02571287}, {209,0.02591089}, {210,0.02611881}, {211,0.02633663}, {212,0.03762376}, {213,0.03116832}, {214,0.02642574}, {215,0.02681188}, {216,0.02667327}, {217,0.02691089}, {218,0.03368317}, {219,0.02843564}, {220,0.02720792}, {221,0.02758416}, {222,0.02765347}, {223,0.03070297}, {224,0.02753465}, {225,0.02785149}, {226,0.03727723}, {227,0.02941584}, {228,0.02829703}, {229,0.02850495}, {230,0.03179208}, {231,0.02894059}, {232,0.02882178}, {233,0.03221782}, {234,0.02905941}, {235,0.02947525}, {236,0.03052475}, {237,0.02973267}, {238,0.03648515}, {239,0.02975248}, {240,0.02973267}, {241,0.02994059}, {242,0.03019802}, {243,0.03417822}, {244,0.03051485}, {245,0.03650495}, {246,0.03065347}, {247,0.03797030}, {248,0.03070297}, {249,0.03939604}, {250,0.03132673}, {251,0.03859406}, {252,0.03167327}, {253,0.03679208}, {254,0.03186139}, {255,0.03315842}, {256,0.03179208}, {257,0.03186139}, {258,0.04095050}, {259,0.03228713}, {260,0.03520792}, {261,0.03258416}, {262,0.03260396}, {263,0.03956436}, {264,0.03285149}, {265,0.03306931}, {266,0.04028713}, {267,0.03359406}, {268,0.03351485}, {269,0.03924752}, {270,0.03392079}, {271,0.03413861}, {272,0.03565347}, {273,0.04534653}, {274,0.03453465}, {275,0.03441584}, {276,0.03569307}, {277,0.04227723}, {278,0.03487129}, {279,0.03524752}, {280,0.03491089}, {281,0.03735644}, {282,0.04195050}, {283,0.04723762}, {284,0.03599010}, {285,0.03579208}, {286,0.03595050}, {287,0.03602970}, {288,0.03771287}, {289,0.04039604}, {290,0.04341584}, {291,0.04586139}, {292,0.04681188}, {293,0.03673267}, {294,0.03700990}, {295,0.03705941}, {296,0.03736634}, {297,0.03732673}, {298,0.03753465}, {299,0.03744554}, {300,0.03761386}, {301,0.03776238}, {302,0.03826733}, {303,0.03817822}, {304,0.03823762}, {305,0.03849505}, {306,0.05432673}, {307,0.04834653}, {308,0.04615842}, {309,0.04392079}, {310,0.04132673}, {311,0.03912871}, {312,0.03920792}, {313,0.03949505}, {314,0.03965347}, {315,0.05054455}, {316,0.04599010}, {317,0.04172277}, {318,0.04004950}, {319,0.04056436}, {320,0.05175248}, {321,0.04611881}, {322,0.04162376}, {323,0.04022772}, {324,0.04081188}, {325,0.04848515}, {326,0.04304950}, {327,0.04141584}, {328,0.04093069}, {329,0.04687129}, {330,0.04134653}, {331,0.04186139}, {332,0.05265347}, {333,0.04196040}, {334,0.04231683}, {335,0.04982178}, {336,0.04171287}, {337,0.04279208}, {338,0.04712871}, {339,0.04229703}, {340,0.05183168}, {341,0.04335644}, {342,0.04271287}, {343,0.04635644}, {344,0.04317822}, {345,0.04916832}, {346,0.04384158}, {347,0.05109901}, {348,0.04382178}, {349,0.05156436}, {350,0.04404950}, {351,0.05162376}, {352,0.04400000}, {353,0.05038614}, {354,0.04434653}, {355,0.04881188}, {356,0.04472277}, {357,0.04755446}, {358,0.06248515}, {359,0.04544554}, {360,0.05283168}, {361,0.04571287}, {362,0.04770297}, {363,0.05816832}, {364,0.04561386}, {365,0.05025743}, {366,0.05902970}, {367,0.04629703}, {368,0.04960396}, {369,0.05746535}, {370,0.04637624}, {371,0.04817822}, {372,0.05444554}, {373,0.04721782}, {374,0.04705941}, {375,0.05008911}, {376,0.05555446}, {377,0.04755446}, {378,0.04752475}, {379,0.04786139}, {380,0.05587129}, {381,0.06278218}, {382,0.05016832}, {383,0.04814851}, {384,0.04769307}, {385,0.04977228}, {386,0.05438614}, {387,0.05702970}, {388,0.06110891}, {389,0.04880198}, {390,0.04902970}, {391,0.04928713}, {392,0.04918812}, {393,0.04912871}, {394,0.05126733}, {395,0.05290099}, {396,0.05384158}, {397,0.05500990}, {398,0.05567327}, {399,0.05799010}, {400,0.05934653}, {401,0.05786139}, {402,0.05752475}, {403,0.05751485}, {404,0.05677228}, {405,0.05562376}, {406,0.05465347}, {407,0.05327723}, {408,0.05142574}, {409,0.05136634}, {410,0.05176238}, {411,0.05184158}, {412,0.06581188}, {413,0.06340594}, {414,0.06036634}, {415,0.05711881}, {416,0.05353465}, {417,0.05256436}, {418,0.05264356}, {419,0.06804950}, {420,0.06253465}, {421,0.05748515}, {422,0.05306931}, {423,0.05339604}, {424,0.06625743}, {425,0.06017822}, {426,0.05417822}, {427,0.05410891}, {428,0.06520792}, {429,0.05892079}, {430,0.05417822}, {431,0.06886139}, {432,0.06064356}, {433,0.05423762}, {434,0.05729703}, {435,0.06635644}, {436,0.05525743}, {437,0.07146535}, {438,0.06180198}, {439,0.05532673}, {440,0.06695050}, {441,0.05706931}, {442,0.07174257}, {443,0.06119802}, {444,0.05599010}, {445,0.06437624}, {446,0.05622772}, {447,0.06628713}, {448,0.05599010}, {449,0.06702970}, {450,0.05645545}, {451,0.07395050}, {452,0.05704950}, {453,0.07073267}, {454,0.05748515}, {455,0.06963366}, {456,0.05704950}, {457,0.06643564}, {458,0.05771287}, {459,0.06271287}, {460,0.07279208}, {461,0.05784158}, {462,0.06821782}, {463,0.05899010}, {464,0.06172277}, {465,0.07089109}, {466,0.05847525}, {467,0.06738614}, {468,0.07671287}, {469,0.05947525}, {470,0.06440594}, {471,0.07363366}, {472,0.05920792}, {473,0.06172277}, {474,0.06895050}, {475,0.07456436}, {476,0.06006931}, {477,0.06265347}, {478,0.06848515}, {479,0.07318812}, {480,0.06025743}, {481,0.06036634}, {482,0.06651485}, {483,0.07108911}, {484,0.07505941}, {485,0.07873267}, {486,0.06151485}, {487,0.06198020}, {488,0.06457426}, {489,0.06816832}, {490,0.07055446}, {491,0.07305941}, {492,0.07496040}, {493,0.08115842}, {494,0.08700000}, {495,0.06275248}, {496,0.06252475}, {497,0.06293069}, {498,0.06255446}, {499,0.06339604}, {500,0.06334653}, {505,0.06403960}, {510,0.06487129}, {515,0.06488119}, {520,0.08020792}, {525,0.07725743}, {530,0.07416832}, {535,0.06765347}, {540,0.08348515}, {545,0.07432673}, {550,0.08846535}, {555,0.07756436}, {560,0.08745545}, {565,0.07544554}, {570,0.08349505}, {575,0.09113861}, {580,0.07403960}, {585,0.08357426}, {590,0.08639604}, {595,0.08983168}, {600,0.09091089}, {605,0.09123762}, {610,0.09020792}, {615,0.08900000}, {620,0.08622772}, {625,0.08515842}, {630,0.10665347}, {635,0.09697030}, {640,0.08735644}, {645,0.10315842}, {650,0.09301980}, {655,0.08356436}, {660,0.09385149}, {665,0.11376238}, {670,0.09188119}, {675,0.10046535}, {680,0.10620792}, {685,0.08867327}, {690,0.09268317}, {695,0.09615842}, {700,0.10321782}, {705,0.09998020}, {710,0.10118812}, {715,0.09903960}, {720,0.09512871}, {725,0.11491089}, {730,0.11032673}, {735,0.11059406}, {740,0.09834653}, {745,0.11443564}, {750,0.10360396}, {755,0.11585149}, {760,0.10431683}, {765,0.11771287}, {770,0.12645545}, {775,0.10999010}, {780,0.11575248}, {785,0.12149505}, {790,0.14016832}, {795,0.10973267}, {800,0.10964356}, {805,0.11261386}, {810,0.11238614}, {815,0.11165347}, {820,0.14250495}, {825,0.13163366}, {830,0.12589109}, {835,0.11823762}, {840,0.13324752}, {845,0.13633663}, {850,0.12000000}, {855,0.13170297}, {860,0.11949505}, {865,0.12902970}, {870,0.11998020}, {875,0.12530693}, {880,0.13118812}, {885,0.13719802}, {890,0.15733663}, {895,0.12557426}, {900,0.12519802}, {905,0.12585149}, {910,0.12593069}, {915,0.13174257}, {920,0.12667327}, {925,0.14524752}, {930,0.13730693}, {935,0.13385149}, {940,0.12937624}, {945,0.13601980}, {950,0.13459406}, {955,0.14508911}, {960,0.14214851}, {965,0.14929703}, {970,0.13373267}, {975,0.14091089}, {980,0.14664356}, {985,0.15883168}, {990,0.13875248}, {995,0.14001980}, {1000,0.13713861}, {1010,0.14825743}, {1020,0.14601980}, {1030,0.14164356}, {1040,0.17395050}, {1050,0.15628713}, {1060,0.14762376}, {1070,0.15700990}, {1080,0.17047525}, {1090,0.15187129}, {1100,0.15622772}, {1110,0.16747525}, {1120,0.15972277}, {1130,0.15672277}, {1140,0.17431683}, {1150,0.17285149}, {1160,0.18113861}, {1170,0.16968317}, {1180,0.18508911}, {1190,0.18793069}, {1200,0.16707921}, {1210,0.17643564}, {1220,0.17410891}, {1230,0.19332673}, {1240,0.19379208}, {1250,0.18239604}, {1260,0.19533663}, {1270,0.18893069}, {1280,0.19121782}, {1290,0.21921782}, {1300,0.18633663}, {1310,0.18819802}, {1320,0.19150495}, {1330,0.21249505}, {1340,0.20331683}, {1350,0.20330693}, {1360,0.21205941}, {1370,0.21804950}, {1380,0.21517822}, {1390,0.19686139}, {1400,0.20535644}, {1410,0.20295050}, {1420,0.19832673}, {1430,0.20536634}, {1440,0.21972277}, {1450,0.22248515}, {1460,0.20859406}, {1470,0.23600990}, {1480,0.22908911}, {1490,0.21351485}, {1500,0.22157426}, {1510,0.22114851}, {1520,0.22698020}, {1530,0.21984158}, {1540,0.25401980}, {1550,0.23500000}, {1560,0.22228713}, {1570,0.24001980}, {1580,0.22613861}, {1590,0.23413861}, {1600,0.23606931}, {1610,0.24847525}, {1620,0.24271287}, {1630,0.25201980}, {1640,0.23805941}, {1650,0.26332673}, {1660,0.24784158}, {1670,0.26713861}, {1680,0.24612871}, {1690,0.26381188}, {1700,0.25934653}, {1710,0.27399010}, {1720,0.26395050}, {1730,0.27291089}, {1740,0.25970297}, {1750,0.25997030}, {1760,0.26718812}, {1770,0.26625743}, {1780,0.26605941}, {1790,0.28010891}, {1800,0.26464356}, {1810,0.26304950}, {1820,0.27244554}, {1830,0.26441584}, {1840,0.29160396}, {1850,0.27883168}, {1860,0.27625743}, {1870,0.31036634}, {1880,0.27468317}, {1890,0.29144554}, {1900,0.28614851}, {1910,0.29360396}, {1920,0.28721782}, {1930,0.29312871}, {1940,0.29661386}, {1950,0.28636634}, {1960,0.29237624}, {1970,0.28445545}, {1980,0.29637624}, {1990,0.31147525}, {2000,0.30573267}, {2050,0.31282178}, {2100,0.33194059}, {2150,0.32192079}, {2200,0.34308911}, {2250,0.36456436}, {2300,0.34639604}, {2350,0.35877228}, {2400,0.37912871}, {2450,0.39171287}, {2500,0.37431683}, {2550,0.38495050}, {2600,0.40606931}, {2650,0.42101980}, {2700,0.41754455}, {2750,0.44071287}, {2800,0.42630693}, {2850,0.43534653}, {2900,0.43414851}, {2950,0.44707921}, {3000,0.46622772}, {3050,0.47486139}, {3100,0.46900000}, {3150,0.47877228}, {3200,0.49231683}, {3250,0.48841584}, {3300,0.50627723}, {3350,0.51779208}, {3400,0.51393069}, {3450,0.52795050}, {3500,0.54122772}, {3550,0.55252475}, {3600,0.54055446}, {3650,0.55446535}, {3700,0.57309901}, {3750,0.59568317}, {3800,0.60146535}, {3850,0.59764356}, {3900,0.59913861}, {3950,0.60423762}, {4000,0.62753465}, {4050,0.64907921}, {4100,0.62697030}, {4150,0.64608911}, {4200,0.64508911}, {4250,0.67786139}, {4300,0.67216832}, {4350,0.68405941}, {4400,0.69929703}, {4450,0.69135644}, {4500,0.69743564}, {4550,0.72434653}, {4600,0.72399010}, {4650,0.73879208}, {4700,0.73506931}, {4750,0.73567327}, {4800,0.77701980}, {4850,0.74968317}, {4900,0.78917822}, {4950,0.78075248}, {5000,0.79295050}, {5050,0.79365347}, {5100,0.82245545}, {5150,0.81068317}, {5200,0.88232673}, {5250,0.82551485}, {5300,0.82724752}, {5350,0.85855446}, {5400,0.84636634}, {5450,0.85569307}, {5500,0.87760396}, {5550,0.87845545}, {5600,0.87462376}, {5650,0.89246535}, {5700,0.88346535}, {5750,0.90380198}, {5800,0.92911881}, {5850,0.94539604}, {5900,0.92690099}, {5950,0.94140594}, {6000,0.95594059}, {6050,0.9980000}, {6100,1.0092286}, {6150,1.0142857}, {6200,1.0127429}, {6250,1.0279143}, {6300,1.0327143}, {6350,1.0524857}, {6400,1.0412571}, {6450,1.0724286}, {6500,1.0874286}, {6550,1.0978286}, {6600,1.1158286}, {6650,1.0954286}, {6700,1.0886286}, {6750,1.1151429}, {6800,1.1060286}, {6850,1.1307429}, {6900,1.1414000}, {6950,1.1573429}, {7000,1.1791143}, {7050,1.1950857}, {7100,1.1836857}, {7150,1.1932286}, {7200,1.1984857}, {7250,1.1996857}, {7300,1.2147143}, {7350,1.2337429}, {7400,1.2208571}, {7450,1.2121429}, {7500,1.2158000}, {7550,1.2555143}, {7600,1.2872857}, {7650,1.3024286}, {7700,1.2764000}, {7750,1.3088000}, {7800,1.2842857}, {7850,1.2885429}, {7900,1.3350000}, {7950,1.3470000}, {8000,1.3247143}, {8050,1.3436857}, {8100,1.3232571}, {8150,1.3615429}, {8200,1.3692857}, {8250,1.3670286}, {8300,1.3693714}, {8350,1.3622000}, {8400,1.3970857}, {8450,1.4094000}, {8500,1.4052286}, {8550,1.4098571}, {8600,1.4692000}, {8650,1.4446571}, {8700,1.4494857}, {8750,1.4870286}, {8800,1.4448000}, {8850,1.4586857}, {8900,1.4759429}, {8950,1.5065429}, {9000,1.4711714}, {9050,1.5090857}, {9100,1.5279429}, {9150,1.5246857}, {9200,1.5493429}, {9250,1.5479143}, {9300,1.5336857}, {9350,1.5765714}, {9400,1.5778286}, {9450,1.5760286}, {9500,1.6070286}, {9550,1.5918286}, {9600,1.6011714}, {9650,1.6069429}, {9700,1.6562000}, {9750,1.6132286}, {9800,1.6594857}, {9850,1.6464286}, {9900,1.6803429}, {9950,1.6811714}, {10000,1.6979143}, {10100,1.6742000}, {10200,1.7258000}, {10300,1.7108286}, {10400,1.7495714}, {10500,1.7178286}, {10600,1.7826571}, {10700,1.7754571}, {10800,1.8044857}, {10900,1.7825429}, {11000,1.8331714}, {11100,1.8416286}, {11200,1.8631714}, {11300,1.8553429}, {11400,1.8884857}, {11500,1.8784000}, {11600,1.9393429}, {11700,2.1283714}, {11800,1.9454000}, {11900,2.0766571}, {12000,1.9920000}, {12100,1.9990286}, {12200,2.0374571}, {12300,2.0319429}, {12400,2.0342000}, {12500,2.0857714}, {12600,2.0882857}, {12700,2.1103429}, {12800,2.0834571}, {12900,2.1343429}, {13000,2.1470286}, {13100,2.1807714}, {13200,2.1816286}, {13300,2.2082571}, {13400,2.1935429}, {13500,2.2347429}, {13600,2.2296857}, {13700,2.2649143}, {13800,2.2772000}, {13900,2.3184857}, {14000,2.3240571}, {14100,2.3493429}, {14200,2.3826286}, {14300,2.3888571}, {14400,2.3724000}, {14500,2.4146857}, {14600,2.3900000}, {14700,2.4395143}, {14800,2.4434286}, {14900,2.4306857}, {15000,2.4673714}, {15100,2.5202286}, {15200,2.5129714}, {15300,2.6104000}, {15400,2.5258286}, {15500,2.6559714}, {15600,2.6012000}, {15700,2.5825143}, {15800,2.6120286}, {15900,2.6228000}, {16000,2.6832000}, {16100,2.6844857}, {16200,2.6769714}, {16300,2.6996571}, {16400,2.6843714}, {16500,2.6813143}, {16600,2.7537714}, {16700,2.8715714}, {16800,2.7495143}, {16900,2.7622857}, {17000,2.7915429}, {17100,2.8358286}, {17200,2.9140571}, {17300,2.8274000}, {17400,2.8990571}, {17500,2.8969143}, {17600,2.9084857}, {17700,2.9140857}, {17800,2.9071429}, {17900,2.9732571}, {18000,2.9515429}, {18100,3.0207429}, {18200,2.9960571}, {18300,3.0453143}, {18400,3.0564286}, {18500,3.0487143}, {18600,3.0641429}, {18700,3.0908000}, {18800,3.1089714}, {18900,3.1598857}, {19000,3.3992571}, {19100,3.1903714}, {19200,3.1652571}, {19300,3.2798571}, {19400,3.4402857}, {19500,3.3249143}, {19600,3.3150571}, {19700,3.2725143}, {19800,3.4553429}, {19900,3.4707143}, {20000,3.3354000}};
data["big_flat"]["LtacTCGallinaCtx"]["reif"]["user"] = {{1,0.00015842}, {2,0.00024752}, {3,0.00055446}, {4,0.00051485}, {5,0.00100000}, {6,0.00087129}, {7,0.00095050}, {8,0.00085149}, {9,0.00100000}, {10,0.00152475}, {11,0.00161386}, {12,0.00111881}, {13,0.00177228}, {14,0.00151485}, {15,0.00193069}, {16,0.00186139}, {17,0.00217822}, {18,0.00204950}, {19,0.00278218}, {20,0.00249505}, {21,0.00249505}, {22,0.00268317}, {23,0.00273267}, {24,0.00261386}, {25,0.00289109}, {26,0.00316832}, {27,0.00306931}, {28,0.00343564}, {29,0.00343564}, {30,0.00350495}, {31,0.00361386}, {32,0.00476238}, {33,0.00409901}, {34,0.00390099}, {35,0.00426733}, {36,0.00433663}, {37,0.00667327}, {38,0.00465347}, {39,0.00459406}, {40,0.00501980}, {41,0.00459406}, {42,0.00537624}, {43,0.00552475}, {44,0.00514851}, {45,0.00559406}, {46,0.00560396}, {47,0.00602970}, {48,0.00627723}, {49,0.00618812}, {50,0.00614851}, {51,0.00609901}, {52,0.00657426}, {53,0.00680198}, {54,0.00699010}, {55,0.00690099}, {56,0.00695050}, {57,0.00688119}, {58,0.00768317}, {59,0.00736634}, {60,0.00746535}, {61,0.00775248}, {62,0.00754455}, {63,0.00768317}, {64,0.00778218}, {65,0.00799010}, {66,0.00823762}, {67,0.01055446}, {68,0.00858416}, {69,0.00854455}, {70,0.00874257}, {71,0.00871287}, {72,0.00898020}, {73,0.00901980}, {74,0.00932673}, {75,0.01141584}, {76,0.00932673}, {77,0.00921782}, {78,0.00977228}, {79,0.00976238}, {80,0.01003960}, {81,0.00991089}, {82,0.00948515}, {83,0.01022772}, {84,0.01048515}, {85,0.01049505}, {86,0.01057426}, {87,0.01091089}, {88,0.01085149}, {89,0.01184158}, {90,0.01429703}, {91,0.01203960}, {92,0.01138614}, {93,0.01167327}, {94,0.01190099}, {95,0.01209901}, {96,0.01175248}, {97,0.01227723}, {98,0.01231683}, {99,0.01224752}, {100,0.01239604}, {101,0.01309901}, {102,0.01637624}, {103,0.01427723}, {104,0.01252475}, {105,0.01311881}, {106,0.01332673}, {107,0.01371287}, {108,0.01372277}, {109,0.01367327}, {110,0.01400000}, {111,0.01433663}, {112,0.01572277}, {113,0.01418812}, {114,0.01386139}, {115,0.01464356}, {116,0.01471287}, {117,0.01872277}, {118,0.01498020}, {119,0.01513861}, {120,0.01529703}, {121,0.01513861}, {122,0.01511881}, {123,0.01544554}, {124,0.01578218}, {125,0.01714851}, {126,0.01586139}, {127,0.01606931}, {128,0.01609901}, {129,0.01614851}, {130,0.01638614}, {131,0.01640594}, {132,0.01643564}, {133,0.01695050}, {134,0.01681188}, {135,0.01682178}, {136,0.01716832}, {137,0.01926733}, {138,0.01700990}, {139,0.01751485}, {140,0.01752475}, {141,0.01749505}, {142,0.01770297}, {143,0.01756436}, {144,0.01814851}, {145,0.01779208}, {146,0.01997030}, {147,0.01784158}, {148,0.02018812}, {149,0.01819802}, {150,0.01953465}, {151,0.01817822}, {152,0.01814851}, {153,0.01858416}, {154,0.01879208}, {155,0.01882178}, {156,0.01894059}, {157,0.02205941}, {158,0.01950495}, {159,0.01986139}, {160,0.02596040}, {161,0.01943564}, {162,0.01958416}, {163,0.02018812}, {164,0.02003960}, {165,0.02017822}, {166,0.02044554}, {167,0.02061386}, {168,0.02030693}, {169,0.02605941}, {170,0.02075248}, {171,0.02138614}, {172,0.02137624}, {173,0.02888119}, {174,0.02175248}, {175,0.02153465}, {176,0.02147525}, {177,0.02622772}, {178,0.02194059}, {179,0.02219802}, {180,0.02251485}, {181,0.02267327}, {182,0.02406931}, {183,0.02848515}, {184,0.02262376}, {185,0.02312871}, {186,0.02310891}, {187,0.02353465}, {188,0.02302970}, {189,0.02392079}, {190,0.02363366}, {191,0.02459406}, {192,0.02595050}, {193,0.02772277}, {194,0.02941584}, {195,0.03023762}, {196,0.03147525}, {197,0.03204950}, {198,0.03193069}, {199,0.03200990}, {200,0.03161386}, {201,0.03035644}, {202,0.02901980}, {203,0.02901980}, {204,0.02690099}, {205,0.02559406}, {206,0.02558416}, {207,0.02572277}, {208,0.02575248}, {209,0.02631683}, {210,0.02590099}, {211,0.02612871}, {212,0.03752475}, {213,0.03147525}, {214,0.02651485}, {215,0.02709901}, {216,0.02661386}, {217,0.02674257}, {218,0.03353465}, {219,0.02837624}, {220,0.02699010}, {221,0.02737624}, {222,0.02738614}, {223,0.03114851}, {224,0.02740594}, {225,0.02779208}, {226,0.03680198}, {227,0.02919802}, {228,0.02810891}, {229,0.02860396}, {230,0.03215842}, {231,0.02906931}, {232,0.02864356}, {233,0.03237624}, {234,0.02922772}, {235,0.02911881}, {236,0.03026733}, {237,0.02945545}, {238,0.03633663}, {239,0.02980198}, {240,0.02917822}, {241,0.03014851}, {242,0.03006931}, {243,0.03428713}, {244,0.03021782}, {245,0.03684158}, {246,0.03061386}, {247,0.03774257}, {248,0.02997030}, {249,0.03894059}, {250,0.03122772}, {251,0.03818812}, {252,0.03165347}, {253,0.03674257}, {254,0.03181188}, {255,0.03297030}, {256,0.03191089}, {257,0.03151485}, {258,0.04039604}, {259,0.03276238}, {260,0.03514851}, {261,0.03264356}, {262,0.03249505}, {263,0.03929703}, {264,0.03310891}, {265,0.03281188}, {266,0.03981188}, {267,0.03369307}, {268,0.03356436}, {269,0.03892079}, {270,0.03397030}, {271,0.03428713}, {272,0.03567327}, {273,0.04528713}, {274,0.03424752}, {275,0.03438614}, {276,0.03605941}, {277,0.04163366}, {278,0.03500000}, {279,0.03565347}, {280,0.03482178}, {281,0.03727723}, {282,0.04148515}, {283,0.04729703}, {284,0.03597030}, {285,0.03565347}, {286,0.03619802}, {287,0.03635644}, {288,0.03723762}, {289,0.04002970}, {290,0.04319802}, {291,0.04567327}, {292,0.04660396}, {293,0.03663366}, {294,0.03707921}, {295,0.03714851}, {296,0.03736634}, {297,0.03718812}, {298,0.03731683}, {299,0.03748515}, {300,0.03755446}, {301,0.03751485}, {302,0.03828713}, {303,0.03805941}, {304,0.03804950}, {305,0.03815842}, {306,0.05406931}, {307,0.04799010}, {308,0.04609901}, {309,0.04409901}, {310,0.04110891}, {311,0.03859406}, {312,0.03906931}, {313,0.03914851}, {314,0.03939604}, {315,0.05017822}, {316,0.04622772}, {317,0.04165347}, {318,0.03983168}, {319,0.04019802}, {320,0.05110891}, {321,0.04600990}, {322,0.04114851}, {323,0.03994059}, {324,0.04032673}, {325,0.04869307}, {326,0.04282178}, {327,0.04109901}, {328,0.04072277}, {329,0.04674257}, {330,0.04081188}, {331,0.04128713}, {332,0.05238614}, {333,0.04147525}, {334,0.04169307}, {335,0.04959406}, {336,0.04127723}, {337,0.04284158}, {338,0.04707921}, {339,0.04181188}, {340,0.05117822}, {341,0.04308911}, {342,0.04255446}, {343,0.04637624}, {344,0.04301980}, {345,0.04933663}, {346,0.04394059}, {347,0.05054455}, {348,0.04346535}, {349,0.05132673}, {350,0.04380198}, {351,0.05132673}, {352,0.04349505}, {353,0.05041584}, {354,0.04389109}, {355,0.04884158}, {356,0.04454455}, {357,0.04780198}, {358,0.06244554}, {359,0.04532673}, {360,0.05253465}, {361,0.04579208}, {362,0.04764356}, {363,0.05809901}, {364,0.04558416}, {365,0.05037624}, {366,0.05892079}, {367,0.04613861}, {368,0.04950495}, {369,0.05747525}, {370,0.04667327}, {371,0.04810891}, {372,0.05398020}, {373,0.04740594}, {374,0.04720792}, {375,0.04985149}, {376,0.05547525}, {377,0.04764356}, {378,0.04774257}, {379,0.04816832}, {380,0.05543564}, {381,0.06239604}, {382,0.05005941}, {383,0.04833663}, {384,0.04809901}, {385,0.04981188}, {386,0.05427723}, {387,0.05702970}, {388,0.06102970}, {389,0.04896040}, {390,0.04944554}, {391,0.04965347}, {392,0.04932673}, {393,0.04957426}, {394,0.05113861}, {395,0.05273267}, {396,0.05373267}, {397,0.05450495}, {398,0.05534653}, {399,0.05785149}, {400,0.05922772}, {401,0.05771287}, {402,0.05755446}, {403,0.05751485}, {404,0.05644554}, {405,0.05530693}, {406,0.05430693}, {407,0.05301980}, {408,0.05121782}, {409,0.05121782}, {410,0.05166337}, {411,0.05156436}, {412,0.06517822}, {413,0.06353465}, {414,0.06030693}, {415,0.05700000}, {416,0.05306931}, {417,0.05258416}, {418,0.05259406}, {419,0.06738614}, {420,0.06253465}, {421,0.05765347}, {422,0.05267327}, {423,0.05312871}, {424,0.06609901}, {425,0.06052475}, {426,0.05398020}, {427,0.05393069}, {428,0.06499010}, {429,0.05903960}, {430,0.05406931}, {431,0.06852475}, {432,0.06075248}, {433,0.05378218}, {434,0.05733663}, {435,0.06609901}, {436,0.05495050}, {437,0.07164356}, {438,0.06187129}, {439,0.05492079}, {440,0.06653465}, {441,0.05697030}, {442,0.07159406}, {443,0.06113861}, {444,0.05559406}, {445,0.06426733}, {446,0.05610891}, {447,0.06632673}, {448,0.05562376}, {449,0.06669307}, {450,0.05618812}, {451,0.07399010}, {452,0.05671287}, {453,0.07065347}, {454,0.05734653}, {455,0.06930693}, {456,0.05691089}, {457,0.06622772}, {458,0.05746535}, {459,0.06273267}, {460,0.07253465}, {461,0.05809901}, {462,0.06757426}, {463,0.05961386}, {464,0.06153465}, {465,0.07047525}, {466,0.05833663}, {467,0.06680198}, {468,0.07653465}, {469,0.05924752}, {470,0.06450495}, {471,0.07354455}, {472,0.05909901}, {473,0.06196040}, {474,0.06848515}, {475,0.07397030}, {476,0.06031683}, {477,0.06249505}, {478,0.06814851}, {479,0.07291089}, {480,0.06020792}, {481,0.06043564}, {482,0.06612871}, {483,0.07103960}, {484,0.07495050}, {485,0.07843564}, {486,0.06160396}, {487,0.06221782}, {488,0.06443564}, {489,0.06794059}, {490,0.07035644}, {491,0.07315842}, {492,0.07507921}, {493,0.08092079}, {494,0.08705941}, {495,0.06278218}, {496,0.06240594}, {497,0.06294059}, {498,0.06245545}, {499,0.06335644}, {500,0.06332673}, {505,0.06369307}, {510,0.06475248}, {515,0.06467327}, {520,0.08003960}, {525,0.07684158}, {530,0.07412871}, {535,0.06735644}, {540,0.08317822}, {545,0.07408911}, {550,0.08839604}, {555,0.07731683}, {560,0.08718812}, {565,0.07530693}, {570,0.08315842}, {575,0.09122772}, {580,0.07421782}, {585,0.08351485}, {590,0.08655446}, {595,0.08951485}, {600,0.09071287}, {605,0.09124752}, {610,0.09011881}, {615,0.08904950}, {620,0.08592079}, {625,0.08487129}, {630,0.10652475}, {635,0.09685149}, {640,0.08718812}, {645,0.10288119}, {650,0.09285149}, {655,0.08359406}, {660,0.09402970}, {665,0.11388119}, {670,0.09200990}, {675,0.10018812}, {680,0.10604950}, {685,0.08882178}, {690,0.09225743}, {695,0.09597030}, {700,0.10289109}, {705,0.09971287}, {710,0.10078218}, {715,0.09850495}, {720,0.09516832}, {725,0.11469307}, {730,0.11002970}, {735,0.11001980}, {740,0.09807921}, {745,0.11409901}, {750,0.10360396}, {755,0.11547525}, {760,0.10373267}, {765,0.11762376}, {770,0.12607921}, {775,0.10998020}, {780,0.11561386}, {785,0.12129703}, {790,0.13978218}, {795,0.10944554}, {800,0.10962376}, {805,0.11233663}, {810,0.11227723}, {815,0.11120792}, {820,0.14233663}, {825,0.13124752}, {830,0.12567327}, {835,0.11835644}, {840,0.13307921}, {845,0.13601980}, {850,0.11990099}, {855,0.13142574}, {860,0.11923762}, {865,0.12908911}, {870,0.11987129}, {875,0.12513861}, {880,0.13089109}, {885,0.13678218}, {890,0.15709901}, {895,0.12539604}, {900,0.12455446}, {905,0.12560396}, {910,0.12562376}, {915,0.13149505}, {920,0.12644554}, {925,0.14472277}, {930,0.13741584}, {935,0.13386139}, {940,0.12941584}, {945,0.13587129}, {950,0.13441584}, {955,0.14502970}, {960,0.14219802}, {965,0.14930693}, {970,0.13353465}, {975,0.14073267}, {980,0.14641584}, {985,0.15846535}, {990,0.13870297}, {995,0.13969307}, {1000,0.13725743}, {1010,0.14773267}, {1020,0.14563366}, {1030,0.14145545}, {1040,0.17363366}, {1050,0.15555446}, {1060,0.14688119}, {1070,0.15681188}, {1080,0.17011881}, {1090,0.15183168}, {1100,0.15591089}, {1110,0.16700000}, {1120,0.15929703}, {1130,0.15640594}, {1140,0.17408911}, {1150,0.17251485}, {1160,0.18089109}, {1170,0.16920792}, {1180,0.18471287}, {1190,0.18762376}, {1200,0.16646535}, {1210,0.17614851}, {1220,0.17375248}, {1230,0.19278218}, {1240,0.19335644}, {1250,0.18201980}, {1260,0.19496040}, {1270,0.18821782}, {1280,0.19055446}, {1290,0.21870297}, {1300,0.18572277}, {1310,0.18786139}, {1320,0.19089109}, {1330,0.21246535}, {1340,0.20303960}, {1350,0.20237624}, {1360,0.21154455}, {1370,0.21724752}, {1380,0.21468317}, {1390,0.19624752}, {1400,0.20457426}, {1410,0.20244554}, {1420,0.19782178}, {1430,0.20479208}, {1440,0.21940594}, {1450,0.22175248}, {1460,0.20795050}, {1470,0.23529703}, {1480,0.22847525}, {1490,0.21321782}, {1500,0.22135644}, {1510,0.22067327}, {1520,0.22617822}, {1530,0.21920792}, {1540,0.25312871}, {1550,0.23412871}, {1560,0.22170297}, {1570,0.23937624}, {1580,0.22546535}, {1590,0.23320792}, {1600,0.23548515}, {1610,0.24789109}, {1620,0.24201980}, {1630,0.25144554}, {1640,0.23759406}, {1650,0.26265347}, {1660,0.24729703}, {1670,0.26635644}, {1680,0.24534653}, {1690,0.26288119}, {1700,0.25863366}, {1710,0.27314851}, {1720,0.26308911}, {1730,0.27218812}, {1740,0.25937624}, {1750,0.25940594}, {1760,0.26650495}, {1770,0.26518812}, {1780,0.26481188}, {1790,0.27944554}, {1800,0.26366337}, {1810,0.26197030}, {1820,0.27161386}, {1830,0.26387129}, {1840,0.29090099}, {1850,0.27833663}, {1860,0.27532673}, {1870,0.30948515}, {1880,0.27394059}, {1890,0.29065347}, {1900,0.28559406}, {1910,0.29281188}, {1920,0.28642574}, {1930,0.29257426}, {1940,0.29578218}, {1950,0.28545545}, {1960,0.29152475}, {1970,0.28371287}, {1980,0.29555446}, {1990,0.31046535}, {2000,0.30478218}, {2050,0.31210891}, {2100,0.33115842}, {2150,0.32120792}, {2200,0.34198020}, {2250,0.36361386}, {2300,0.34552475}, {2350,0.35802970}, {2400,0.37837624}, {2450,0.39056436}, {2500,0.37356436}, {2550,0.38402970}, {2600,0.40520792}, {2650,0.41998020}, {2700,0.41678218}, {2750,0.43949505}, {2800,0.42570297}, {2850,0.43149505}, {2900,0.43309901}, {2950,0.44561386}, {3000,0.46553465}, {3050,0.47355446}, {3100,0.46798020}, {3150,0.47763366}, {3200,0.49123762}, {3250,0.48733663}, {3300,0.50533663}, {3350,0.51697030}, {3400,0.51271287}, {3450,0.52700990}, {3500,0.54064356}, {3550,0.55172277}, {3600,0.53980198}, {3650,0.55349505}, {3700,0.57177228}, {3750,0.59489109}, {3800,0.60023762}, {3850,0.59660396}, {3900,0.59794059}, {3950,0.60320792}, {4000,0.62619802}, {4050,0.64800000}, {4100,0.62585149}, {4150,0.64506931}, {4200,0.64420792}, {4250,0.67667327}, {4300,0.67073267}, {4350,0.68292079}, {4400,0.69814851}, {4450,0.68992079}, {4500,0.69604950}, {4550,0.72329703}, {4600,0.72277228}, {4650,0.73733663}, {4700,0.73378218}, {4750,0.73403960}, {4800,0.77524752}, {4850,0.74817822}, {4900,0.78735644}, {4950,0.77931683}, {5000,0.79074257}, {5050,0.79201980}, {5100,0.82063366}, {5150,0.80927723}, {5200,0.88087129}, {5250,0.82401980}, {5300,0.82564356}, {5350,0.85673267}, {5400,0.84471287}, {5450,0.85371287}, {5500,0.87568317}, {5550,0.87667327}, {5600,0.87281188}, {5650,0.89078218}, {5700,0.88139604}, {5750,0.90194059}, {5800,0.92735644}, {5850,0.94325743}, {5900,0.92542574}, {5950,0.93983168}, {6000,0.95432673}, {6050,0.9915429}, {6100,1.0002000}, {6150,1.0138571}, {6200,1.0116000}, {6250,1.0274857}, {6300,1.0304286}, {6350,1.0516286}, {6400,1.0403143}, {6450,1.0715714}, {6500,1.0866857}, {6550,1.0960857}, {6600,1.1146571}, {6650,1.0950000}, {6700,1.0874286}, {6750,1.1140571}, {6800,1.1042571}, {6850,1.1258000}, {6900,1.1386571}, {6950,1.1558857}, {7000,1.1775143}, {7050,1.1940857}, {7100,1.1828000}, {7150,1.1918571}, {7200,1.1919429}, {7250,1.1986000}, {7300,1.2108000}, {7350,1.2269143}, {7400,1.2169143}, {7450,1.2102286}, {7500,1.2140000}, {7550,1.2494000}, {7600,1.2823714}, {7650,1.2972000}, {7700,1.2710571}, {7750,1.2996000}, {7800,1.2792286}, {7850,1.2788571}, {7900,1.3314286}, {7950,1.3448571}, {8000,1.3229714}, {8050,1.3422000}, {8100,1.3215143}, {8150,1.3594857}, {8200,1.3674000}, {8250,1.3658286}, {8300,1.3672571}, {8350,1.3604286}, {8400,1.3955429}, {8450,1.4076571}, {8500,1.4028286}, {8550,1.4080000}, {8600,1.4676000}, {8650,1.4427143}, {8700,1.4472857}, {8750,1.4846571}, {8800,1.4431143}, {8850,1.4569714}, {8900,1.4741143}, {8950,1.5048857}, {9000,1.4701714}, {9050,1.5071429}, {9100,1.5260571}, {9150,1.5230857}, {9200,1.5471429}, {9250,1.5454286}, {9300,1.5205429}, {9350,1.5731429}, {9400,1.5753429}, {9450,1.5739143}, {9500,1.6046571}, {9550,1.5899429}, {9600,1.5988857}, {9650,1.6042286}, {9700,1.6536857}, {9750,1.6113714}, {9800,1.6567714}, {9850,1.6442857}, {9900,1.6783143}, {9950,1.6789429}, {10000,1.6957429}, {10100,1.6720571}, {10200,1.7233143}, {10300,1.7081714}, {10400,1.7469143}, {10500,1.7154000}, {10600,1.7805143}, {10700,1.7730000}, {10800,1.8020571}, {10900,1.7793714}, {11000,1.8302857}, {11100,1.8390571}, {11200,1.8604571}, {11300,1.8524286}, {11400,1.8854857}, {11500,1.8755714}, {11600,1.9361429}, {11700,2.1243143}, {11800,1.9425714}, {11900,2.0724857}, {12000,1.9883429}, {12100,1.9958000}, {12200,2.0343714}, {12300,2.0284286}, {12400,2.0312571}, {12500,2.0827714}, {12600,2.0839714}, {12700,2.1066000}, {12800,2.0808286}, {12900,2.1312857}, {13000,2.1432286}, {13100,2.1775143}, {13200,2.1784286}, {13300,2.2050000}, {13400,2.1901143}, {13500,2.2312857}, {13600,2.2271714}, {13700,2.2591429}, {13800,2.2743714}, {13900,2.3162286}, {14000,2.3215143}, {14100,2.3465429}, {14200,2.3794571}, {14300,2.3858000}, {14400,2.3697143}, {14500,2.4122571}, {14600,2.3873143}, {14700,2.4367714}, {14800,2.4397714}, {14900,2.4284286}, {15000,2.4635714}, {15100,2.5172286}, {15200,2.5106857}, {15300,2.6074857}, {15400,2.5231143}, {15500,2.6539429}, {15600,2.5970571}, {15700,2.5783429}, {15800,2.6091429}, {15900,2.6205429}, {16000,2.6802286}, {16100,2.6817429}, {16200,2.6750571}, {16300,2.6966286}, {16400,2.6814000}, {16500,2.6800000}, {16600,2.7503143}, {16700,2.8692857}, {16800,2.7471143}, {16900,2.7602857}, {17000,2.7896000}, {17100,2.8327714}, {17200,2.9110857}, {17300,2.8249143}, {17400,2.8964857}, {17500,2.8938857}, {17600,2.9048571}, {17700,2.9108571}, {17800,2.9037714}, {17900,2.9695143}, {18000,2.9473143}, {18100,3.0156286}, {18200,2.9909714}, {18300,3.0405143}, {18400,3.0517429}, {18500,3.0443143}, {18600,3.0588857}, {18700,3.0865429}, {18800,3.1045143}, {18900,3.1296571}, {19000,3.3834571}, {19100,3.1711143}, {19200,3.1307143}, {19300,3.2758857}, {19400,3.4324286}, {19500,3.3145429}, {19600,3.2949429}, {19700,3.2641714}, {19800,3.4246857}, {19900,3.4660286}, {20000,3.3310857}};
data["big_flat"]["LtacTCGallinaCtx"]["reif"]["system"] = {{1,0.00011881}, {2,0.00000000}, {3,0.00002970}, {4,0.00003960}, {5,0.00002970}, {6,0.00000000}, {7,0.00003960}, {8,0.00000000}, {9,0.00000000}, {10,0.00003960}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00003960}, {15,0.00006931}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00003960}, {21,0.00007921}, {22,0.00011881}, {23,0.00002970}, {24,0.00003960}, {25,0.00000000}, {26,0.00003960}, {27,0.00000000}, {28,0.00000000}, {29,0.00006931}, {30,0.00000000}, {31,0.00000000}, {32,0.00006931}, {33,0.00000000}, {34,0.00003960}, {35,0.00002970}, {36,0.00002970}, {37,0.00000000}, {38,0.00007921}, {39,0.00000000}, {40,0.00003960}, {41,0.00003960}, {42,0.00000000}, {43,0.00003960}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00007921}, {49,0.00003960}, {50,0.00007921}, {51,0.00000000}, {52,0.00000000}, {53,0.00003960}, {54,0.00006931}, {55,0.00003960}, {56,0.00003960}, {57,0.00010891}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00003960}, {62,0.00000000}, {63,0.00003960}, {64,0.00003960}, {65,0.00000000}, {66,0.00000000}, {67,0.00015842}, {68,0.00003960}, {69,0.00002970}, {70,0.00002970}, {71,0.00000000}, {72,0.00003960}, {73,0.00000000}, {74,0.00007921}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00003960}, {79,0.00003960}, {80,0.00007921}, {81,0.00010891}, {82,0.00000000}, {83,0.00006931}, {84,0.00000000}, {85,0.00007921}, {86,0.00007921}, {87,0.00002970}, {88,0.00000000}, {89,0.00007921}, {90,0.00013861}, {91,0.00000000}, {92,0.00000000}, {93,0.00006931}, {94,0.00000000}, {95,0.00003960}, {96,0.00007921}, {97,0.00003960}, {98,0.00000000}, {99,0.00007921}, {100,0.00003960}, {101,0.00000000}, {102,0.00003960}, {103,0.00007921}, {104,0.00003960}, {105,0.00000000}, {106,0.00006931}, {107,0.00000000}, {108,0.00007921}, {109,0.00002970}, {110,0.00003960}, {111,0.00002970}, {112,0.00007921}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00010891}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00007921}, {122,0.00003960}, {123,0.00003960}, {124,0.00000000}, {125,0.00003960}, {126,0.00000000}, {127,0.00000000}, {128,0.00003960}, {129,0.00007921}, {130,0.00003960}, {131,0.00000000}, {132,0.00003960}, {133,0.00002970}, {134,0.00000000}, {135,0.00000000}, {136,0.00002970}, {137,0.00010891}, {138,0.00002970}, {139,0.00000000}, {140,0.00003960}, {141,0.00003960}, {142,0.00003960}, {143,0.00000000}, {144,0.00010891}, {145,0.00003960}, {146,0.00010891}, {147,0.00000000}, {148,0.00002970}, {149,0.00000000}, {150,0.00003960}, {151,0.00000000}, {152,0.00000000}, {153,0.00003960}, {154,0.00000000}, {155,0.00000000}, {156,0.00007921}, {157,0.00006931}, {158,0.00000000}, {159,0.00003960}, {160,0.00015842}, {161,0.00007921}, {162,0.00003960}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00003960}, {168,0.00011881}, {169,0.00014851}, {170,0.00000000}, {171,0.00000000}, {172,0.00007921}, {173,0.00019802}, {174,0.00003960}, {175,0.00003960}, {176,0.00011881}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00006931}, {182,0.00003960}, {183,0.00003960}, {184,0.00003960}, {185,0.00000000}, {186,0.00002970}, {187,0.00000000}, {188,0.00002970}, {189,0.00000000}, {190,0.00000000}, {191,0.00003960}, {192,0.00003960}, {193,0.00014851}, {194,0.00015842}, {195,0.00007921}, {196,0.00015842}, {197,0.00007921}, {198,0.00005941}, {199,0.00023762}, {200,0.00002970}, {201,0.00023762}, {202,0.00021782}, {203,0.00003960}, {204,0.00011881}, {205,0.00007921}, {206,0.00003960}, {207,0.00000000}, {208,0.00003960}, {209,0.00000000}, {210,0.00000000}, {211,0.00003960}, {212,0.00022772}, {213,0.00003960}, {214,0.00007921}, {215,0.00000000}, {216,0.00003960}, {217,0.00000000}, {218,0.00015842}, {219,0.00010891}, {220,0.00007921}, {221,0.00003960}, {222,0.00007921}, {223,0.00007921}, {224,0.00002970}, {225,0.00003960}, {226,0.00023762}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00003960}, {233,0.00007921}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00021782}, {239,0.00003960}, {240,0.00003960}, {241,0.00000000}, {242,0.00003960}, {243,0.00000000}, {244,0.00000000}, {245,0.00007921}, {246,0.00000000}, {247,0.00007921}, {248,0.00003960}, {249,0.00006931}, {250,0.00003960}, {251,0.00000000}, {252,0.00011881}, {253,0.00000000}, {254,0.00003960}, {255,0.00003960}, {256,0.00000000}, {257,0.00010891}, {258,0.00003960}, {259,0.00000000}, {260,0.00003960}, {261,0.00000000}, {262,0.00000000}, {263,0.00003960}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00003960}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00007921}, {275,0.00003960}, {276,0.00000000}, {277,0.00003960}, {278,0.00000000}, {279,0.00000000}, {280,0.00003960}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00003960}, {285,0.00013861}, {286,0.00000000}, {287,0.00000000}, {288,0.00007921}, {289,0.00000000}, {290,0.00003960}, {291,0.00007921}, {292,0.00002970}, {293,0.00003960}, {294,0.00000000}, {295,0.00003960}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00007921}, {300,0.00007921}, {301,0.00000000}, {302,0.00003960}, {303,0.00000000}, {304,0.00000000}, {305,0.00007921}, {306,0.00000000}, {307,0.00003960}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00007921}, {313,0.00000000}, {314,0.00000000}, {315,0.00003960}, {316,0.00000000}, {317,0.00003960}, {318,0.00000000}, {319,0.00003960}, {320,0.00007921}, {321,0.00000000}, {322,0.00003960}, {323,0.00003960}, {324,0.00000000}, {325,0.00000000}, {326,0.00003960}, {327,0.00003960}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00006931}, {332,0.00000000}, {333,0.00003960}, {334,0.00003960}, {335,0.00000000}, {336,0.00003960}, {337,0.00003960}, {338,0.00003960}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00003960}, {344,0.00011881}, {345,0.00000000}, {346,0.00003960}, {347,0.00051485}, {348,0.00007921}, {349,0.00015842}, {350,0.00003960}, {351,0.00027723}, {352,0.00000000}, {353,0.00003960}, {354,0.00000000}, {355,0.00003960}, {356,0.00000000}, {357,0.00003960}, {358,0.00006931}, {359,0.00000000}, {360,0.00011881}, {361,0.00003960}, {362,0.00003960}, {363,0.00000000}, {364,0.00000000}, {365,0.00007921}, {366,0.00003960}, {367,0.00000000}, {368,0.00003960}, {369,0.00017822}, {370,0.00003960}, {371,0.00003960}, {372,0.00011881}, {373,0.00000000}, {374,0.00009901}, {375,0.00010891}, {376,0.00000000}, {377,0.00000000}, {378,0.00003960}, {379,0.00000000}, {380,0.00003960}, {381,0.00000000}, {382,0.00003960}, {383,0.00000000}, {384,0.00003960}, {385,0.00000000}, {386,0.00003960}, {387,0.00000000}, {388,0.00003960}, {389,0.00003960}, {390,0.00002970}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00003960}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00007921}, {400,0.00003960}, {401,0.00003960}, {402,0.00000000}, {403,0.00007921}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00003960}, {410,0.00003960}, {411,0.00000000}, {412,0.00000000}, {413,0.00007921}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00003960}, {419,0.00002970}, {420,0.00000000}, {421,0.00003960}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00003960}, {426,0.00003960}, {427,0.00003960}, {428,0.00006931}, {429,0.00003960}, {430,0.00000000}, {431,0.00003960}, {432,0.00000000}, {433,0.00000000}, {434,0.00011881}, {435,0.00007921}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00003960}, {441,0.00003960}, {442,0.00010891}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00003960}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00003960}, {454,0.00000000}, {455,0.00003960}, {456,0.00000000}, {457,0.00003960}, {458,0.00003960}, {459,0.00000000}, {460,0.00000000}, {461,0.00003960}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00002970}, {466,0.00000000}, {467,0.00007921}, {468,0.00000000}, {469,0.00003960}, {470,0.00003960}, {471,0.00000000}, {472,0.00007921}, {473,0.00000000}, {474,0.00000000}, {475,0.00003960}, {476,0.00003960}, {477,0.00003960}, {478,0.00000000}, {479,0.00003960}, {480,0.00000000}, {481,0.00003960}, {482,0.00000000}, {483,0.00007921}, {484,0.00000000}, {485,0.00003960}, {486,0.00007921}, {487,0.00003960}, {488,0.00003960}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00003960}, {494,0.00003960}, {495,0.00000000}, {496,0.00000000}, {497,0.00003960}, {498,0.00000000}, {499,0.00000000}, {500,0.00003960}, {505,0.00003960}, {510,0.00003960}, {515,0.00007921}, {520,0.00000000}, {525,0.00003960}, {530,0.00000000}, {535,0.00000000}, {540,0.00003960}, {545,0.00007921}, {550,0.00007921}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00007921}, {575,0.00003960}, {580,0.00003960}, {585,0.00003960}, {590,0.00000000}, {595,0.00003960}, {600,0.00000000}, {605,0.00000000}, {610,0.00007921}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00007921}, {640,0.00000000}, {645,0.00003960}, {650,0.00003960}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00003960}, {685,0.00000000}, {690,0.00003960}, {695,0.00007921}, {700,0.00003960}, {705,0.00003960}, {710,0.00000000}, {715,0.00003960}, {720,0.00007921}, {725,0.00003960}, {730,0.00007921}, {735,0.00003960}, {740,0.00000000}, {745,0.00002970}, {750,0.00002970}, {755,0.00000000}, {760,0.00007921}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00007921}, {795,0.00000000}, {800,0.00007921}, {805,0.00000000}, {810,0.00002970}, {815,0.00003960}, {820,0.00003960}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00007921}, {845,0.00003960}, {850,0.00003960}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00003960}, {875,0.00000000}, {880,0.00003960}, {885,0.00003960}, {890,0.00011881}, {895,0.00000000}, {900,0.00000000}, {905,0.00006931}, {910,0.00007921}, {915,0.00003960}, {920,0.00003960}, {925,0.00007921}, {930,0.00003960}, {935,0.00007921}, {940,0.00000000}, {945,0.00000000}, {950,0.00003960}, {955,0.00007921}, {960,0.00000000}, {965,0.00003960}, {970,0.00003960}, {975,0.00000000}, {980,0.00003960}, {985,0.00000000}, {990,0.00007921}, {995,0.00000000}, {1000,0.00003960}, {1010,0.00003960}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00007921}, {1050,0.00007921}, {1060,0.00007921}, {1070,0.00000000}, {1080,0.00003960}, {1090,0.00003960}, {1100,0.00003960}, {1110,0.00000000}, {1120,0.00007921}, {1130,0.00003960}, {1140,0.00000000}, {1150,0.00011881}, {1160,0.00003960}, {1170,0.00000000}, {1180,0.00007921}, {1190,0.00000000}, {1200,0.00003960}, {1210,0.00003960}, {1220,0.00003960}, {1230,0.00003960}, {1240,0.00000000}, {1250,0.00007921}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003960}, {1290,0.00000000}, {1300,0.00007921}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00003960}, {1340,0.00003960}, {1350,0.00003960}, {1360,0.00000000}, {1370,0.00007921}, {1380,0.00003960}, {1390,0.00007921}, {1400,0.00000000}, {1410,0.00003960}, {1420,0.00003960}, {1430,0.00003960}, {1440,0.00003960}, {1450,0.00003960}, {1460,0.00007921}, {1470,0.00015842}, {1480,0.00007921}, {1490,0.00007921}, {1500,0.00000000}, {1510,0.00003960}, {1520,0.00003960}, {1530,0.00000000}, {1540,0.00003960}, {1550,0.00011881}, {1560,0.00003960}, {1570,0.00007921}, {1580,0.00007921}, {1590,0.00003960}, {1600,0.00003960}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00011881}, {1640,0.00011881}, {1650,0.00002970}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00003960}, {1690,0.00003960}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00007921}, {1730,0.00007921}, {1740,0.00000000}, {1750,0.00023762}, {1760,0.00007921}, {1770,0.00006931}, {1780,0.00007921}, {1790,0.00003960}, {1800,0.00007921}, {1810,0.00011881}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00002970}, {1850,0.00003960}, {1860,0.00006931}, {1870,0.00007921}, {1880,0.00003960}, {1890,0.00000000}, {1900,0.00003960}, {1910,0.00007921}, {1920,0.00003960}, {1930,0.00000000}, {1940,0.00003960}, {1950,0.00003960}, {1960,0.00007921}, {1970,0.00007921}, {1980,0.00007921}, {1990,0.00003960}, {2000,0.00007921}, {2050,0.00007921}, {2100,0.00003960}, {2150,0.00007921}, {2200,0.00003960}, {2250,0.00010891}, {2300,0.00003960}, {2350,0.00011881}, {2400,0.00007921}, {2450,0.00011881}, {2500,0.00007921}, {2550,0.00007921}, {2600,0.00000000}, {2650,0.00007921}, {2700,0.00003960}, {2750,0.00011881}, {2800,0.00003960}, {2850,0.00278218}, {2900,0.00002970}, {2950,0.00003960}, {3000,0.00000000}, {3050,0.00003960}, {3100,0.00007921}, {3150,0.00003960}, {3200,0.00007921}, {3250,0.00015842}, {3300,0.00000000}, {3350,0.00019802}, {3400,0.00015842}, {3450,0.00019802}, {3500,0.00003960}, {3550,0.00003960}, {3600,0.00007921}, {3650,0.00007921}, {3700,0.00010891}, {3750,0.00003960}, {3800,0.00011881}, {3850,0.00019802}, {3900,0.00007921}, {3950,0.00019802}, {4000,0.00000000}, {4050,0.00003960}, {4100,0.00011881}, {4150,0.00006931}, {4200,0.00000000}, {4250,0.00003960}, {4300,0.00011881}, {4350,0.00003960}, {4400,0.00000000}, {4450,0.00015842}, {4500,0.00007921}, {4550,0.00000000}, {4600,0.00007921}, {4650,0.00015842}, {4700,0.00006931}, {4750,0.00003960}, {4800,0.00007921}, {4850,0.00015842}, {4900,0.00007921}, {4950,0.00003960}, {5000,0.00031683}, {5050,0.00007921}, {5100,0.00011881}, {5150,0.00015842}, {5200,0.00007921}, {5250,0.00011881}, {5300,0.00011881}, {5350,0.00015842}, {5400,0.00007921}, {5450,0.00015842}, {5500,0.00007921}, {5550,0.00019802}, {5600,0.00011881}, {5650,0.00003960}, {5700,0.00019802}, {5750,0.00019802}, {5800,0.00000000}, {5850,0.00031683}, {5900,0.00003960}, {5950,0.00015842}, {6000,0.00003960}, {6050,0.0053429}, {6100,0.0075429}, {6150,0.0002286}, {6200,0.0002286}, {6250,0.0001143}, {6300,0.0008857}, {6350,0.0000000}, {6400,0.0002286}, {6450,0.0000857}, {6500,0.0001143}, {6550,0.0004571}, {6600,0.0003429}, {6650,0.0000000}, {6700,0.0004571}, {6750,0.0001143}, {6800,0.0000000}, {6850,0.0002286}, {6900,0.0002286}, {6950,0.0001143}, {7000,0.0002286}, {7050,0.0002286}, {7100,0.0000000}, {7150,0.0003429}, {7200,0.0002286}, {7250,0.0001143}, {7300,0.0003429}, {7350,0.0004571}, {7400,0.0002286}, {7450,0.0002286}, {7500,0.0001143}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0002286}, {7700,0.0000000}, {7750,0.0001143}, {7800,0.0001143}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0001143}, {8000,0.0002286}, {8050,0.0001143}, {8100,0.0000000}, {8150,0.0005714}, {8200,0.0000857}, {8250,0.0000000}, {8300,0.0001143}, {8350,0.0001143}, {8400,0.0002286}, {8450,0.0000000}, {8500,0.0002286}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0003429}, {8700,0.0002286}, {8750,0.0003429}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0001143}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0001143}, {9150,0.0001143}, {9200,0.0001143}, {9250,0.0004571}, {9300,0.0022571}, {9350,0.0003429}, {9400,0.0002286}, {9450,0.0004286}, {9500,0.0003429}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0004571}, {9700,0.0002286}, {9750,0.0002286}, {9800,0.0003429}, {9850,0.0001143}, {9900,0.0001143}, {9950,0.0001143}, {10000,0.0002000}, {10100,0.0001143}, {10200,0.0003429}, {10300,0.0002286}, {10400,0.0000000}, {10500,0.0004571}, {10600,0.0001143}, {10700,0.0002286}, {10800,0.0002286}, {10900,0.0002286}, {11000,0.0002286}, {11100,0.0002000}, {11200,0.0001143}, {11300,0.0000000}, {11400,0.0002286}, {11500,0.0000000}, {11600,0.0001143}, {11700,0.0013429}, {11800,0.0000000}, {11900,0.0008000}, {12000,0.0001143}, {12100,0.0000000}, {12200,0.0003143}, {12300,0.0003429}, {12400,0.0001143}, {12500,0.0000000}, {12600,0.0007714}, {12700,0.0004571}, {12800,0.0000000}, {12900,0.0004000}, {13000,0.0003429}, {13100,0.0002286}, {13200,0.0001143}, {13300,0.0003429}, {13400,0.0002286}, {13500,0.0002286}, {13600,0.0002286}, {13700,0.0001143}, {13800,0.0002286}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0001143}, {14200,0.0001143}, {14300,0.0002286}, {14400,0.0003429}, {14500,0.0001143}, {14600,0.0001143}, {14700,0.0000000}, {14800,0.0011429}, {14900,0.0001143}, {15000,0.0006857}, {15100,0.0000000}, {15200,0.0002000}, {15300,0.0002286}, {15400,0.0004571}, {15500,0.0000000}, {15600,0.0019429}, {15700,0.0014857}, {15800,0.0004571}, {15900,0.0001143}, {16000,0.0010857}, {16100,0.0004571}, {16200,0.0001143}, {16300,0.0012571}, {16400,0.0015714}, {16500,0.0001143}, {16600,0.0012286}, {16700,0.0003429}, {16800,0.0002286}, {16900,0.0002286}, {17000,0.0004571}, {17100,0.0008000}, {17200,0.0004571}, {17300,0.0000000}, {17400,0.0001143}, {17500,0.0000000}, {17600,0.0004571}, {17700,0.0002286}, {17800,0.0000000}, {17900,0.0006857}, {18000,0.0013714}, {18100,0.0020286}, {18200,0.0019429}, {18300,0.0011429}, {18400,0.0010000}, {18500,0.0010286}, {18600,0.0014857}, {18700,0.0008000}, {18800,0.0008000}, {18900,0.0001143}, {19000,0.0011429}, {19100,0.0003429}, {19200,0.0008000}, {19300,0.0002000}, {19400,0.0009143}, {19500,0.0013429}, {19600,0.0012571}, {19700,0.0010286}, {19800,0.0021714}, {19900,0.0021714}, {20000,0.0016000}};
data["big_flat"]["LtacTCPrimPair"]["Aggregate"]["real"] = {{1,0.00101980}, {2,0.00100000}, {3,0.00100000}, {4,0.00100000}, {5,0.00100000}, {6,0.00100000}, {7,0.00104950}, {8,0.00142574}, {9,0.00200000}, {10,0.00200000}, {11,0.00201980}, {12,0.00200000}, {13,0.00201980}, {14,0.00212871}, {15,0.00232673}, {16,0.00300000}, {17,0.00300000}, {18,0.00300000}, {19,0.00300000}, {20,0.00300990}, {21,0.00320792}, {22,0.00335644}, {23,0.00400990}, {24,0.00400000}, {25,0.00400000}, {26,0.00400000}, {27,0.00402970}, {28,0.00424752}, {29,0.00414851}, {30,0.00470297}, {31,0.00500000}, {32,0.00500000}, {33,0.00500000}, {34,0.00503960}, {35,0.00516832}, {36,0.00541584}, {37,0.00552475}, {38,0.00591089}, {39,0.00600000}, {40,0.00600990}, {41,0.00610891}, {42,0.00613861}, {43,0.00614851}, {44,0.00621782}, {45,0.00673267}, {46,0.00700990}, {47,0.00702970}, {48,0.00708911}, {49,0.00722772}, {50,0.00714851}, {51,0.00734653}, {52,0.00747525}, {53,0.00790099}, {54,0.00800990}, {55,0.00910891}, {56,0.00815842}, {57,0.00816832}, {58,0.00826733}, {59,0.00834653}, {60,0.00866337}, {61,0.00901980}, {62,0.00906931}, {63,0.00905941}, {64,0.00921782}, {65,0.00928713}, {66,0.00938614}, {67,0.00958416}, {68,0.00984158}, {69,0.01012871}, {70,0.01090099}, {71,0.01019802}, {72,0.01024752}, {73,0.01037624}, {74,0.01027723}, {75,0.01069307}, {76,0.01113861}, {77,0.01111881}, {78,0.01115842}, {79,0.01117822}, {80,0.01515842}, {81,0.01136634}, {82,0.01157426}, {83,0.01193069}, {84,0.01208911}, {85,0.01211881}, {86,0.01225743}, {87,0.01309901}, {88,0.01565347}, {89,0.01254455}, {90,0.01265347}, {91,0.01305941}, {92,0.01318812}, {93,0.01313861}, {94,0.01324752}, {95,0.01338614}, {96,0.01339604}, {97,0.01361386}, {98,0.01389109}, {99,0.01418812}, {100,0.01428713}, {101,0.01426733}, {102,0.01426733}, {103,0.01432673}, {104,0.01978218}, {105,0.01740594}, {106,0.01491089}, {107,0.01512871}, {108,0.01523762}, {109,0.01540594}, {110,0.01533663}, {111,0.01558416}, {112,0.01563366}, {113,0.01850495}, {114,0.01600990}, {115,0.01624752}, {116,0.01633663}, {117,0.01639604}, {118,0.02110891}, {119,0.01647525}, {120,0.01683168}, {121,0.01705941}, {122,0.01711881}, {123,0.01717822}, {124,0.01740594}, {125,0.01738614}, {126,0.02124752}, {127,0.01770297}, {128,0.01791089}, {129,0.02445545}, {130,0.01815842}, {131,0.01829703}, {132,0.02440594}, {133,0.01852475}, {134,0.01859406}, {135,0.02221782}, {136,0.01903960}, {137,0.01927723}, {138,0.01916832}, {139,0.01932673}, {140,0.02195050}, {141,0.01948515}, {142,0.02563366}, {143,0.02028713}, {144,0.02011881}, {145,0.02033663}, {146,0.02039604}, {147,0.02031683}, {148,0.02063366}, {149,0.02055446}, {150,0.02102970}, {151,0.02134653}, {152,0.02744554}, {153,0.02124752}, {154,0.02437624}, {155,0.02157426}, {156,0.02153465}, {157,0.02192079}, {158,0.02206931}, {159,0.02493069}, {160,0.02229703}, {161,0.02235644}, {162,0.02953465}, {163,0.02268317}, {164,0.02266337}, {165,0.02416832}, {166,0.02316832}, {167,0.02324752}, {168,0.02884158}, {169,0.02349505}, {170,0.02351485}, {171,0.02470297}, {172,0.02381188}, {173,0.02414851}, {174,0.02418812}, {175,0.02500990}, {176,0.03151485}, {177,0.02480198}, {178,0.02457426}, {179,0.02487129}, {180,0.02543564}, {181,0.03114851}, {182,0.02561386}, {183,0.02527723}, {184,0.02529703}, {185,0.02566337}, {186,0.02570297}, {187,0.02632673}, {188,0.02935644}, {189,0.03225743}, {190,0.03455446}, {191,0.02654455}, {192,0.02670297}, {193,0.02684158}, {194,0.02689109}, {195,0.02686139}, {196,0.02721782}, {197,0.02733663}, {198,0.02736634}, {199,0.02758416}, {200,0.02750495}, {201,0.02770297}, {202,0.02765347}, {203,0.02824752}, {204,0.02837624}, {205,0.02835644}, {206,0.03613861}, {207,0.03361386}, {208,0.03279208}, {209,0.02869307}, {210,0.02885149}, {211,0.02909901}, {212,0.02943564}, {213,0.02938614}, {214,0.04324752}, {215,0.03648515}, {216,0.02963366}, {217,0.02986139}, {218,0.03004950}, {219,0.03045545}, {220,0.03572277}, {221,0.03035644}, {222,0.03055446}, {223,0.03095050}, {224,0.03741584}, {225,0.03101980}, {226,0.03111881}, {227,0.03150495}, {228,0.03532673}, {229,0.03154455}, {230,0.03169307}, {231,0.03695050}, {232,0.03187129}, {233,0.03211881}, {234,0.03686139}, {235,0.03248515}, {236,0.03265347}, {237,0.03429703}, {238,0.03277228}, {239,0.04025743}, {240,0.03314851}, {241,0.03347525}, {242,0.03327723}, {243,0.03364356}, {244,0.03643564}, {245,0.03381188}, {246,0.03857426}, {247,0.03408911}, {248,0.04004950}, {249,0.03441584}, {250,0.04053465}, {251,0.03464356}, {252,0.03890099}, {253,0.03496040}, {254,0.03610891}, {255,0.03555446}, {256,0.03505941}, {257,0.04554455}, {258,0.03578218}, {259,0.04054455}, {260,0.03589109}, {261,0.03582178}, {262,0.04571287}, {263,0.03636634}, {264,0.03695050}, {265,0.04766337}, {266,0.03654455}, {267,0.03758416}, {268,0.04687129}, {269,0.03700000}, {270,0.03717822}, {271,0.04668317}, {272,0.03773267}, {273,0.03750495}, {274,0.03910891}, {275,0.04646535}, {276,0.03805941}, {277,0.03843564}, {278,0.03826733}, {279,0.04348515}, {280,0.04874257}, {281,0.03918812}, {282,0.03867327}, {283,0.03929703}, {284,0.03992079}, {285,0.04464356}, {286,0.04815842}, {287,0.05202970}, {288,0.03988119}, {289,0.03975248}, {290,0.03988119}, {291,0.04031683}, {292,0.04013861}, {293,0.04031683}, {294,0.04172277}, {295,0.04368317}, {296,0.04408911}, {297,0.04511881}, {298,0.04563366}, {299,0.04439604}, {300,0.04607921}, {301,0.04444554}, {302,0.04763366}, {303,0.04599010}, {304,0.04401980}, {305,0.04287129}, {306,0.04208911}, {307,0.04230693}, {308,0.04239604}, {309,0.04241584}, {310,0.04272277}, {311,0.05702970}, {312,0.05327723}, {313,0.05036634}, {314,0.04556436}, {315,0.04371287}, {316,0.04364356}, {317,0.04399010}, {318,0.05514851}, {319,0.04953465}, {320,0.04444554}, {321,0.04441584}, {322,0.04432673}, {323,0.05366337}, {324,0.04780198}, {325,0.04480198}, {326,0.04526733}, {327,0.05410891}, {328,0.04696040}, {329,0.04579208}, {330,0.05786139}, {331,0.05313861}, {332,0.04574257}, {333,0.04842574}, {334,0.05195050}, {335,0.04615842}, {336,0.06000990}, {337,0.04969307}, {338,0.04663366}, {339,0.05652475}, {340,0.04691089}, {341,0.04905941}, {342,0.05087129}, {343,0.04759406}, {344,0.05426733}, {345,0.04722772}, {346,0.05691089}, {347,0.04806931}, {348,0.05804950}, {349,0.04799010}, {350,0.05893069}, {351,0.04865347}, {352,0.05737624}, {353,0.04836634}, {354,0.05639604}, {355,0.04911881}, {356,0.05437624}, {357,0.04952475}, {358,0.05256436}, {359,0.06906931}, {360,0.04906931}, {361,0.05816832}, {362,0.04984158}, {363,0.05179208}, {364,0.06275248}, {365,0.05023762}, {366,0.05348515}, {367,0.06316832}, {368,0.05054455}, {369,0.05285149}, {370,0.06092079}, {371,0.05120792}, {372,0.05115842}, {373,0.05673267}, {374,0.06432673}, {375,0.05156436}, {376,0.05184158}, {377,0.05720792}, {378,0.06337624}, {379,0.05194059}, {380,0.05232673}, {381,0.05414851}, {382,0.06043564}, {383,0.06441584}, {384,0.06799010}, {385,0.05286139}, {386,0.05330693}, {387,0.05382178}, {388,0.05677228}, {389,0.06096040}, {390,0.06454455}, {391,0.06724752}, {392,0.06910891}, {393,0.05414851}, {394,0.05423762}, {395,0.05466337}, {396,0.05433663}, {397,0.05440594}, {398,0.05462376}, {399,0.05475248}, {400,0.05504950}, {401,0.05492079}, {402,0.05511881}, {403,0.05579208}, {404,0.05511881}, {405,0.05588119}, {406,0.05612871}, {407,0.05625743}, {408,0.05570297}, {409,0.06977228}, {410,0.06918812}, {411,0.06677228}, {412,0.06394059}, {413,0.06114851}, {414,0.05798020}, {415,0.05730693}, {416,0.05700000}, {417,0.07947525}, {418,0.07216832}, {419,0.06499010}, {420,0.05970297}, {421,0.05795050}, {422,0.07757426}, {423,0.07060396}, {424,0.06378218}, {425,0.05827723}, {426,0.05919802}, {427,0.07058416}, {428,0.06384158}, {429,0.05892079}, {430,0.07499010}, {431,0.06805941}, {432,0.06007921}, {433,0.06184158}, {434,0.07409901}, {435,0.06157426}, {436,0.06224752}, {437,0.07016832}, {438,0.06007921}, {439,0.07789109}, {440,0.06522772}, {441,0.06046535}, {442,0.07119802}, {443,0.06097030}, {444,0.07400000}, {445,0.06347525}, {446,0.07698020}, {447,0.06544554}, {448,0.07828713}, {449,0.06697030}, {450,0.06179208}, {451,0.07221782}, {452,0.06192079}, {453,0.07122772}, {454,0.06452475}, {455,0.06835644}, {456,0.07883168}, {457,0.06531683}, {458,0.07787129}, {459,0.06314851}, {460,0.07305941}, {461,0.06334653}, {462,0.06794059}, {463,0.07795050}, {464,0.06353465}, {465,0.07195050}, {466,0.07862376}, {467,0.06543564}, {468,0.07692079}, {469,0.08428713}, {470,0.06475248}, {471,0.07395050}, {472,0.08082178}, {473,0.06522772}, {474,0.06883168}, {475,0.07648515}, {476,0.08251485}, {477,0.06600990}, {478,0.06883168}, {479,0.07504950}, {480,0.07823762}, {481,0.06837624}, {482,0.06597030}, {483,0.07201980}, {484,0.07678218}, {485,0.08147525}, {486,0.08498020}, {487,0.06704950}, {488,0.06674257}, {489,0.06933663}, {490,0.07268317}, {491,0.07574257}, {492,0.07797030}, {493,0.07840594}, {494,0.08911881}, {495,0.08893069}, {496,0.08695050}, {497,0.08866337}, {498,0.08969307}, {499,0.07042574}, {500,0.07032673}, {505,0.07126733}, {510,0.08931683}, {515,0.08726733}, {520,0.08432673}, {525,0.08111881}, {530,0.07539604}, {535,0.10277228}, {540,0.08900990}, {545,0.07890099}, {550,0.09321782}, {555,0.08240594}, {560,0.09333663}, {565,0.08076238}, {570,0.08958416}, {575,0.09881188}, {580,0.08067327}, {585,0.09017822}, {590,0.09328713}, {595,0.09719802}, {600,0.09913861}, {605,0.09986139}, {610,0.09845545}, {615,0.09725743}, {620,0.09464356}, {625,0.09350495}, {630,0.12220792}, {635,0.10677228}, {640,0.09658416}, {645,0.11549505}, {650,0.10341584}, {655,0.09317822}, {660,0.10429703}, {665,0.10973267}, {670,0.10314851}, {675,0.11200990}, {680,0.11897030}, {685,0.10004950}, {690,0.10394059}, {695,0.10816832}, {700,0.10975248}, {705,0.11346535}, {710,0.11416832}, {715,0.11208911}, {720,0.10867327}, {725,0.10624752}, {730,0.12702970}, {735,0.12894059}, {740,0.11324752}, {745,0.13272277}, {750,0.11938614}, {755,0.13215842}, {760,0.11925743}, {765,0.14561386}, {770,0.11724752}, {775,0.12697030}, {780,0.13492079}, {785,0.11689109}, {790,0.11791089}, {795,0.12786139}, {800,0.12694059}, {805,0.13017822}, {810,0.13018812}, {815,0.12937624}, {820,0.13433663}, {825,0.12600990}, {830,0.14720792}, {835,0.13738614}, {840,0.13049505}, {845,0.16251485}, {850,0.14129703}, {855,0.12961386}, {860,0.14000000}, {865,0.15057426}, {870,0.14081188}, {875,0.15097030}, {880,0.15505941}, {885,0.13658416}, {890,0.13658416}, {895,0.14977228}, {900,0.14853465}, {905,0.14794059}, {910,0.14838614}, {915,0.14329703}, {920,0.14910891}, {925,0.14564356}, {930,0.13902970}, {935,0.15766337}, {940,0.16328713}, {945,0.14694059}, {950,0.15960396}, {955,0.14829703}, {960,0.15377228}, {965,0.15174257}, {970,0.16078218}, {975,0.16705941}, {980,0.15125743}, {985,0.16460396}, {990,0.16662376}, {995,0.16703960}, {1000,0.17013861}, {1010,0.17969307}, {1020,0.17582178}, {1030,0.17034653}, {1040,0.18033663}, {1050,0.16374257}, {1060,0.17644554}, {1070,0.16485149}, {1080,0.17996040}, {1090,0.18670297}, {1100,0.18799010}, {1110,0.21280198}, {1120,0.18847525}, {1130,0.19015842}, {1140,0.18646535}, {1150,0.18563366}, {1160,0.19801980}, {1170,0.18528713}, {1180,0.20093069}, {1190,0.20448515}, {1200,0.20667327}, {1210,0.19278218}, {1220,0.19067327}, {1230,0.20971287}, {1240,0.21136634}, {1250,0.20110891}, {1260,0.21409901}, {1270,0.20903960}, {1280,0.21059406}, {1290,0.21657426}, {1300,0.20253465}, {1310,0.20749505}, {1320,0.22080198}, {1330,0.21073267}, {1340,0.22663366}, {1350,0.22694059}, {1360,0.21250495}, {1370,0.23610891}, {1380,0.22973267}, {1390,0.22050495}, {1400,0.23500000}, {1410,0.22966337}, {1420,0.22810891}, {1430,0.23232673}, {1440,0.22390099}, {1450,0.25085149}, {1460,0.23528713}, {1470,0.25851485}, {1480,0.23655446}, {1490,0.24128713}, {1500,0.25707921}, {1510,0.25096040}, {1520,0.26303960}, {1530,0.25297030}, {1540,0.25399010}, {1550,0.24800000}, {1560,0.25954455}, {1570,0.24457426}, {1580,0.26064356}, {1590,0.27750495}, {1600,0.25049505}, {1610,0.26205941}, {1620,0.25596040}, {1630,0.26569307}, {1640,0.27290099}, {1650,0.27849505}, {1660,0.26241584}, {1670,0.28209901}, {1680,0.26273267}, {1690,0.28184158}, {1700,0.27734653}, {1710,0.29194059}, {1720,0.28246535}, {1730,0.29006931}, {1740,0.28158416}, {1750,0.27468317}, {1760,0.28754455}, {1770,0.28177228}, {1780,0.29101980}, {1790,0.30593069}, {1800,0.32467327}, {1810,0.28787129}, {1820,0.30778218}, {1830,0.31138614}, {1840,0.31586139}, {1850,0.30204950}, {1860,0.30771287}, {1870,0.30877228}, {1880,0.30550495}, {1890,0.33318812}, {1900,0.31175248}, {1910,0.32625743}, {1920,0.31570297}, {1930,0.32506931}, {1940,0.34297030}, {1950,0.31328713}, {1960,0.33500000}, {1970,0.31542574}, {1980,0.33131683}, {1990,0.35804950}, {2000,0.31832673}, {2050,0.33625743}, {2100,0.35312871}, {2150,0.36131683}, {2200,0.36965347}, {2250,0.37030693}, {2300,0.37252475}, {2350,0.38715842}, {2400,0.43070297}, {2450,0.40803960}, {2500,0.40813861}, {2550,0.42788119}, {2600,0.45243564}, {2650,0.44394059}, {2700,0.48401980}, {2750,0.47052475}, {2800,0.45886139}, {2850,0.47391089}, {2900,0.49625743}, {2950,0.48327723}, {3000,0.50814851}, {3050,0.51564356}, {3100,0.52105941}, {3150,0.52900000}, {3200,0.55503960}, {3250,0.54580198}, {3300,0.56806931}, {3350,0.57775248}, {3400,0.57350495}, {3450,0.59053465}, {3500,0.58786139}, {3550,0.59875248}, {3600,0.61516832}, {3650,0.60701980}, {3700,0.62288119}, {3750,0.64776238}, {3800,0.66796040}, {3850,0.66884158}, {3900,0.65880198}, {3950,0.66828713}, {4000,0.68401980}, {4050,0.69568317}, {4100,0.72261386}, {4150,0.70347525}, {4200,0.71507921}, {4250,0.73454455}, {4300,0.74447525}, {4350,0.74810891}, {4400,0.75517822}, {4450,0.78213861}, {4500,0.76280198}, {4550,0.77291089}, {4600,0.81724752}, {4650,0.77847525}, {4700,0.83025743}, {4750,0.81748515}, {4800,0.82096040}, {4850,0.83443564}, {4900,0.84124752}, {4950,0.84999010}, {5000,0.86164356}, {5050,0.86633663}, {5100,0.89504950}, {5150,0.89909901}, {5200,0.91054455}, {5250,0.92012871}, {5300,0.93977228}, {5350,0.93323762}, {5400,0.92958416}, {5450,0.95880198}, {5500,0.95933663}, {5550,0.96387129}, {5600,0.97193069}, {5650,0.97015842}, {5700,0.97190099}, {5750,1.00125743}, {5800,1.00842574}, {5850,1.00171287}, {5900,1.02016832}, {5950,1.04217822}, {6000,1.04750495}, {6050,1.1298857}, {6100,1.0966286}, {6150,1.1185429}, {6200,1.1322000}, {6250,1.1434000}, {6300,1.1645143}, {6350,1.1835714}, {6400,1.1851714}, {6450,1.1749143}, {6500,1.1628000}, {6550,1.1693714}, {6600,1.1737429}, {6650,1.1841429}, {6700,1.1928000}, {6750,1.2076286}, {6800,1.2259714}, {6850,1.2202857}, {6900,1.2262857}, {6950,1.2499714}, {7000,1.2611143}, {7050,1.2781429}, {7100,1.3152286}, {7150,1.3304571}, {7200,1.3467714}, {7250,1.3337429}, {7300,1.3498571}, {7350,1.3543714}, {7400,1.3588571}, {7450,1.3766571}, {7500,1.3598000}, {7550,1.3590571}, {7600,1.3780571}, {7650,1.4171714}, {7700,1.4474286}, {7750,1.4567714}, {7800,1.4484571}, {7850,1.4436571}, {7900,1.4281143}, {7950,1.4830571}, {8000,1.4800286}, {8050,1.5071429}, {8100,1.4763714}, {8150,1.4745143}, {8200,1.5022000}, {8250,1.5533143}, {8300,1.5238571}, {8350,1.5194286}, {8400,1.5308857}, {8450,1.5627429}, {8500,1.5682286}, {8550,1.5965143}, {8600,1.5681143}, {8650,1.6418000}, {8700,1.6190857}, {8750,1.6005143}, {8800,1.6362857}, {8850,1.6314000}, {8900,1.6188000}, {8950,1.6886000}, {9000,1.6595714}, {9050,1.6374571}, {9100,1.7118857}, {9150,1.7000857}, {9200,1.6649429}, {9250,1.7489143}, {9300,1.7506571}, {9350,1.7407429}, {9400,1.7468857}, {9450,1.7128857}, {9500,1.7779143}, {9550,1.7619429}, {9600,1.7985429}, {9650,1.7855714}, {9700,1.7778286}, {9750,1.8475714}, {9800,1.7792000}, {9850,1.8452571}, {9900,1.8405429}, {9950,1.8719143}, {10000,1.8176286}, {10100,1.9059429}, {10200,1.9063429}, {10300,1.9425429}, {10400,1.8804571}, {10500,1.9699429}, {10600,1.9000000}, {10700,1.9976286}, {10800,1.9629143}, {10900,2.0304571}, {11000,2.0022857}, {11100,2.0709714}, {11200,2.0267714}, {11300,2.1091714}, {11400,2.0923429}, {11500,2.1171429}, {11600,2.1500571}, {11700,2.1442571}, {11800,2.2125714}, {11900,2.2005714}, {12000,2.2044000}, {12100,2.2286000}, {12200,2.2805714}, {12300,2.2660571}, {12400,2.3208286}, {12500,2.2858857}, {12600,2.3421429}, {12700,2.3325429}, {12800,2.3416857}, {12900,2.3893714}, {13000,2.3718857}, {13100,2.4112571}, {13200,2.4686000}, {13300,2.4401429}, {13400,2.4775714}, {13500,2.4954286}, {13600,2.5124000}, {13700,2.5549714}, {13800,2.5429143}, {13900,2.5674286}, {14000,2.5911429}, {14100,2.5999714}, {14200,2.6176571}, {14300,2.6476000}, {14400,2.6873143}, {14500,2.7237714}, {14600,2.8543143}, {14700,2.7353429}, {14800,2.7370571}, {14900,2.7706286}, {15000,2.7787143}, {15100,2.7475714}, {15200,3.0640571}, {15300,2.9299143}, {15400,2.8819143}, {15500,2.8436571}, {15600,2.9669143}, {15700,2.9871143}, {15800,2.9081429}, {15900,2.9394571}, {16000,2.9433143}, {16100,2.9386571}, {16200,2.9472857}, {16300,3.0522857}, {16400,2.9799714}, {16500,3.1079429}, {16600,3.3627714}, {16700,3.0686571}, {16800,3.1930857}, {16900,3.0864857}, {17000,3.2351143}, {17100,3.2019714}, {17200,3.2833429}, {17300,3.2228857}, {17400,3.2028286}, {17500,3.4146000}, {17600,3.2514857}, {17700,3.3155714}, {17800,3.3457429}, {17900,3.3945714}, {18000,3.3473714}, {18100,3.3292857}, {18200,3.3425714}, {18300,3.4124571}, {18400,3.4078286}, {18500,3.4642571}, {18600,3.4395429}, {18700,3.4853429}, {18800,3.4550000}, {18900,3.5584000}, {19000,3.5511143}, {19100,3.5485429}, {19200,3.5535714}, {19300,3.6317143}, {19400,3.6406857}, {19500,3.6012571}, {19600,3.6888571}, {19700,3.8060286}, {19800,3.6634286}, {19900,3.8681429}, {20000,3.9418000}};
data["big_flat"]["LtacTCPrimPair"]["Aggregate"]["user"] = {{1,0.00075248}, {2,0.00117822}, {3,0.00096040}, {4,0.00115842}, {5,0.00122772}, {6,0.00155446}, {7,0.00131683}, {8,0.00201980}, {9,0.00160396}, {10,0.00191089}, {11,0.00173267}, {12,0.00215842}, {13,0.00234653}, {14,0.00250495}, {15,0.00269307}, {16,0.00287129}, {17,0.00290099}, {18,0.00298020}, {19,0.00310891}, {20,0.00322772}, {21,0.00345545}, {22,0.00340594}, {23,0.00398020}, {24,0.00372277}, {25,0.00420792}, {26,0.00403960}, {27,0.00443564}, {28,0.00447525}, {29,0.00430693}, {30,0.00498020}, {31,0.00480198}, {32,0.00495050}, {33,0.00564356}, {34,0.00562376}, {35,0.00523762}, {36,0.00586139}, {37,0.00564356}, {38,0.00616832}, {39,0.00627723}, {40,0.00600990}, {41,0.00614851}, {42,0.00636634}, {43,0.00697030}, {44,0.00639604}, {45,0.00681188}, {46,0.00698020}, {47,0.00723762}, {48,0.00764356}, {49,0.00745545}, {50,0.00774257}, {51,0.00793069}, {52,0.00792079}, {53,0.00812871}, {54,0.00840594}, {55,0.00910891}, {56,0.00832673}, {57,0.00862376}, {58,0.00860396}, {59,0.00883168}, {60,0.00917822}, {61,0.00887129}, {62,0.00883168}, {63,0.00915842}, {64,0.00921782}, {65,0.00921782}, {66,0.00925743}, {67,0.00987129}, {68,0.00945545}, {69,0.01017822}, {70,0.01116832}, {71,0.01011881}, {72,0.01051485}, {73,0.01076238}, {74,0.01028713}, {75,0.01089109}, {76,0.01114851}, {77,0.01121782}, {78,0.01131683}, {79,0.01111881}, {80,0.01553465}, {81,0.01165347}, {82,0.01191089}, {83,0.01177228}, {84,0.01208911}, {85,0.01209901}, {86,0.01256436}, {87,0.01313861}, {88,0.01591089}, {89,0.01301980}, {90,0.01286139}, {91,0.01327723}, {92,0.01361386}, {93,0.01372277}, {94,0.01349505}, {95,0.01369307}, {96,0.01377228}, {97,0.01400990}, {98,0.01388119}, {99,0.01412871}, {100,0.01466337}, {101,0.01501980}, {102,0.01482178}, {103,0.01473267}, {104,0.01936634}, {105,0.01765347}, {106,0.01515842}, {107,0.01516832}, {108,0.01583168}, {109,0.01551485}, {110,0.01581188}, {111,0.01611881}, {112,0.01624752}, {113,0.01867327}, {114,0.01634653}, {115,0.01636634}, {116,0.01662376}, {117,0.01678218}, {118,0.02062376}, {119,0.01679208}, {120,0.01714851}, {121,0.01687129}, {122,0.01709901}, {123,0.01736634}, {124,0.01729703}, {125,0.01747525}, {126,0.02129703}, {127,0.01803960}, {128,0.01763366}, {129,0.02421782}, {130,0.01783168}, {131,0.01817822}, {132,0.02427723}, {133,0.01839604}, {134,0.01828713}, {135,0.02181188}, {136,0.01886139}, {137,0.01891089}, {138,0.01890099}, {139,0.01898020}, {140,0.02151485}, {141,0.01926733}, {142,0.02552475}, {143,0.02000990}, {144,0.01960396}, {145,0.01992079}, {146,0.01990099}, {147,0.02014851}, {148,0.02047525}, {149,0.02055446}, {150,0.02055446}, {151,0.02085149}, {152,0.02717822}, {153,0.02099010}, {154,0.02443564}, {155,0.02143564}, {156,0.02125743}, {157,0.02144554}, {158,0.02199010}, {159,0.02484158}, {160,0.02231683}, {161,0.02214851}, {162,0.02933663}, {163,0.02289109}, {164,0.02271287}, {165,0.02384158}, {166,0.02314851}, {167,0.02324752}, {168,0.02863366}, {169,0.02338614}, {170,0.02389109}, {171,0.02506931}, {172,0.02400990}, {173,0.02410891}, {174,0.02411881}, {175,0.02483168}, {176,0.03175248}, {177,0.02470297}, {178,0.02452475}, {179,0.02502970}, {180,0.02582178}, {181,0.03125743}, {182,0.02551485}, {183,0.02548515}, {184,0.02521782}, {185,0.02551485}, {186,0.02549505}, {187,0.02614851}, {188,0.02920792}, {189,0.03222772}, {190,0.03486139}, {191,0.02629703}, {192,0.02649505}, {193,0.02689109}, {194,0.02689109}, {195,0.02690099}, {196,0.02712871}, {197,0.02745545}, {198,0.02736634}, {199,0.02756436}, {200,0.02775248}, {201,0.02753465}, {202,0.02744554}, {203,0.02786139}, {204,0.02800000}, {205,0.02803960}, {206,0.03620792}, {207,0.03346535}, {208,0.03302970}, {209,0.02909901}, {210,0.02916832}, {211,0.02870297}, {212,0.02965347}, {213,0.02903960}, {214,0.04300990}, {215,0.03648515}, {216,0.02967327}, {217,0.02990099}, {218,0.03036634}, {219,0.03063366}, {220,0.03551485}, {221,0.03044554}, {222,0.03074257}, {223,0.03114851}, {224,0.03736634}, {225,0.03121782}, {226,0.03136634}, {227,0.03172277}, {228,0.03519802}, {229,0.03185149}, {230,0.03186139}, {231,0.03645545}, {232,0.03217822}, {233,0.03254455}, {234,0.03644554}, {235,0.03264356}, {236,0.03277228}, {237,0.03418812}, {238,0.03282178}, {239,0.03988119}, {240,0.03326733}, {241,0.03363366}, {242,0.03314851}, {243,0.03366337}, {244,0.03653465}, {245,0.03404950}, {246,0.03849505}, {247,0.03373267}, {248,0.03955446}, {249,0.03484158}, {250,0.04016832}, {251,0.03459406}, {252,0.03872277}, {253,0.03488119}, {254,0.03617822}, {255,0.03587129}, {256,0.03485149}, {257,0.04518812}, {258,0.03581188}, {259,0.04021782}, {260,0.03592079}, {261,0.03581188}, {262,0.04548515}, {263,0.03637624}, {264,0.03692079}, {265,0.04753465}, {266,0.03639604}, {267,0.03750495}, {268,0.04694059}, {269,0.03711881}, {270,0.03723762}, {271,0.04662376}, {272,0.03736634}, {273,0.03722772}, {274,0.03845545}, {275,0.04667327}, {276,0.03800990}, {277,0.03774257}, {278,0.03813861}, {279,0.04342574}, {280,0.04854455}, {281,0.03857426}, {282,0.03835644}, {283,0.03881188}, {284,0.03948515}, {285,0.04475248}, {286,0.04811881}, {287,0.05157426}, {288,0.03950495}, {289,0.03927723}, {290,0.03982178}, {291,0.03979208}, {292,0.03959406}, {293,0.03994059}, {294,0.04142574}, {295,0.04364356}, {296,0.04399010}, {297,0.04481188}, {298,0.04548515}, {299,0.04437624}, {300,0.04612871}, {301,0.04400000}, {302,0.04769307}, {303,0.04612871}, {304,0.04380198}, {305,0.04265347}, {306,0.04201980}, {307,0.04224752}, {308,0.04201980}, {309,0.04213861}, {310,0.04240594}, {311,0.05689109}, {312,0.05283168}, {313,0.05002970}, {314,0.04539604}, {315,0.04343564}, {316,0.04362376}, {317,0.04366337}, {318,0.05474257}, {319,0.04932673}, {320,0.04425743}, {321,0.04407921}, {322,0.04375248}, {323,0.05346535}, {324,0.04775248}, {325,0.04474257}, {326,0.04561386}, {327,0.05385149}, {328,0.04694059}, {329,0.04545545}, {330,0.05790099}, {331,0.05275248}, {332,0.04545545}, {333,0.04808911}, {334,0.05136634}, {335,0.04607921}, {336,0.05994059}, {337,0.04948515}, {338,0.04681188}, {339,0.05581188}, {340,0.04689109}, {341,0.04907921}, {342,0.05052475}, {343,0.04760396}, {344,0.05404950}, {345,0.04736634}, {346,0.05679208}, {347,0.04815842}, {348,0.05797030}, {349,0.04805941}, {350,0.05854455}, {351,0.04871287}, {352,0.05721782}, {353,0.04845545}, {354,0.05613861}, {355,0.04900990}, {356,0.05399010}, {357,0.04982178}, {358,0.05261386}, {359,0.06903960}, {360,0.04915842}, {361,0.05798020}, {362,0.04980198}, {363,0.05167327}, {364,0.06292079}, {365,0.05044554}, {366,0.05349505}, {367,0.06258416}, {368,0.05059406}, {369,0.05260396}, {370,0.06083168}, {371,0.05097030}, {372,0.05097030}, {373,0.05657426}, {374,0.06428713}, {375,0.05167327}, {376,0.05166337}, {377,0.05712871}, {378,0.06328713}, {379,0.05187129}, {380,0.05217822}, {381,0.05374257}, {382,0.06051485}, {383,0.06422772}, {384,0.06805941}, {385,0.05254455}, {386,0.05318812}, {387,0.05343564}, {388,0.05686139}, {389,0.06108911}, {390,0.06410891}, {391,0.06677228}, {392,0.06865347}, {393,0.05373267}, {394,0.05404950}, {395,0.05431683}, {396,0.05419802}, {397,0.05398020}, {398,0.05424752}, {399,0.05413861}, {400,0.05486139}, {401,0.05462376}, {402,0.05532673}, {403,0.05567327}, {404,0.05467327}, {405,0.05523762}, {406,0.05593069}, {407,0.05550495}, {408,0.05522772}, {409,0.06933663}, {410,0.06909901}, {411,0.06632673}, {412,0.06365347}, {413,0.06108911}, {414,0.05791089}, {415,0.05700000}, {416,0.05682178}, {417,0.07944554}, {418,0.07194059}, {419,0.06475248}, {420,0.05990099}, {421,0.05771287}, {422,0.07738614}, {423,0.07046535}, {424,0.06373267}, {425,0.05822772}, {426,0.05930693}, {427,0.07061386}, {428,0.06375248}, {429,0.05921782}, {430,0.07481188}, {431,0.06798020}, {432,0.06007921}, {433,0.06180198}, {434,0.07385149}, {435,0.06165347}, {436,0.06209901}, {437,0.06995050}, {438,0.06018812}, {439,0.07769307}, {440,0.06472277}, {441,0.06058416}, {442,0.07108911}, {443,0.06074257}, {444,0.07415842}, {445,0.06357426}, {446,0.07646535}, {447,0.06520792}, {448,0.07805941}, {449,0.06650495}, {450,0.06193069}, {451,0.07211881}, {452,0.06216832}, {453,0.07120792}, {454,0.06428713}, {455,0.06812871}, {456,0.07841584}, {457,0.06507921}, {458,0.07732673}, {459,0.06275248}, {460,0.07318812}, {461,0.06287129}, {462,0.06765347}, {463,0.07747525}, {464,0.06324752}, {465,0.07170297}, {466,0.07826733}, {467,0.06498020}, {468,0.07662376}, {469,0.08408911}, {470,0.06421782}, {471,0.07374257}, {472,0.08020792}, {473,0.06519802}, {474,0.06857426}, {475,0.07635644}, {476,0.08220792}, {477,0.06579208}, {478,0.06841584}, {479,0.07494059}, {480,0.07775248}, {481,0.06825743}, {482,0.06557426}, {483,0.07191089}, {484,0.07638614}, {485,0.08151485}, {486,0.08454455}, {487,0.06655446}, {488,0.06606931}, {489,0.06915842}, {490,0.07245545}, {491,0.07572277}, {492,0.07729703}, {493,0.07785149}, {494,0.08878218}, {495,0.08875248}, {496,0.08688119}, {497,0.08836634}, {498,0.08908911}, {499,0.07009901}, {500,0.07001980}, {505,0.07117822}, {510,0.08884158}, {515,0.08705941}, {520,0.08382178}, {525,0.08084158}, {530,0.07511881}, {535,0.10251485}, {540,0.08877228}, {545,0.07851485}, {550,0.09281188}, {555,0.08231683}, {560,0.09333663}, {565,0.08067327}, {570,0.08920792}, {575,0.09834653}, {580,0.08058416}, {585,0.09002970}, {590,0.09304950}, {595,0.09688119}, {600,0.09898020}, {605,0.09967327}, {610,0.09820792}, {615,0.09695050}, {620,0.09482178}, {625,0.09391089}, {630,0.12168317}, {635,0.10660396}, {640,0.09670297}, {645,0.11533663}, {650,0.10301980}, {655,0.09306931}, {660,0.10416832}, {665,0.10945545}, {670,0.10282178}, {675,0.11176238}, {680,0.11852475}, {685,0.09949505}, {690,0.10365347}, {695,0.10766337}, {700,0.10966337}, {705,0.11302970}, {710,0.11367327}, {715,0.11185149}, {720,0.10871287}, {725,0.10587129}, {730,0.12659406}, {735,0.12874257}, {740,0.11271287}, {745,0.13239604}, {750,0.11891089}, {755,0.13160396}, {760,0.11900000}, {765,0.14515842}, {770,0.11700000}, {775,0.12638614}, {780,0.13425743}, {785,0.11643564}, {790,0.11773267}, {795,0.12735644}, {800,0.12678218}, {805,0.12989109}, {810,0.12969307}, {815,0.12895050}, {820,0.13438614}, {825,0.12584158}, {830,0.14700000}, {835,0.13682178}, {840,0.12989109}, {845,0.16251485}, {850,0.14086139}, {855,0.12933663}, {860,0.13964356}, {865,0.15056436}, {870,0.14045545}, {875,0.15052475}, {880,0.15444554}, {885,0.13593069}, {890,0.13629703}, {895,0.14961386}, {900,0.14812871}, {905,0.14733663}, {910,0.14737624}, {915,0.14298020}, {920,0.14896040}, {925,0.14545545}, {930,0.13863366}, {935,0.15711881}, {940,0.16363366}, {945,0.14673267}, {950,0.15910891}, {955,0.14799010}, {960,0.15374257}, {965,0.15173267}, {970,0.16095050}, {975,0.16684158}, {980,0.15067327}, {985,0.16421782}, {990,0.16614851}, {995,0.16675248}, {1000,0.16984158}, {1010,0.17911881}, {1020,0.17553465}, {1030,0.16992079}, {1040,0.17976238}, {1050,0.16344554}, {1060,0.17591089}, {1070,0.16433663}, {1080,0.17931683}, {1090,0.18639604}, {1100,0.18753465}, {1110,0.21224752}, {1120,0.18821782}, {1130,0.18956436}, {1140,0.18628713}, {1150,0.18521782}, {1160,0.19802970}, {1170,0.18461386}, {1180,0.20047525}, {1190,0.20373267}, {1200,0.20595050}, {1210,0.19198020}, {1220,0.19037624}, {1230,0.20907921}, {1240,0.21089109}, {1250,0.20077228}, {1260,0.21342574}, {1270,0.20871287}, {1280,0.20976238}, {1290,0.21587129}, {1300,0.20208911}, {1310,0.20685149}, {1320,0.22010891}, {1330,0.20970297}, {1340,0.22595050}, {1350,0.22626733}, {1360,0.21211881}, {1370,0.23522772}, {1380,0.22881188}, {1390,0.21975248}, {1400,0.23439604}, {1410,0.22897030}, {1420,0.22711881}, {1430,0.23136634}, {1440,0.22297030}, {1450,0.25025743}, {1460,0.23459406}, {1470,0.25817822}, {1480,0.23590099}, {1490,0.24019802}, {1500,0.25633663}, {1510,0.25028713}, {1520,0.26243564}, {1530,0.25260396}, {1540,0.25369307}, {1550,0.24753465}, {1560,0.25891089}, {1570,0.24416832}, {1580,0.25990099}, {1590,0.27665347}, {1600,0.24932673}, {1610,0.26134653}, {1620,0.25517822}, {1630,0.26488119}, {1640,0.27206931}, {1650,0.27745545}, {1660,0.26180198}, {1670,0.28118812}, {1680,0.26196040}, {1690,0.28105941}, {1700,0.27642574}, {1710,0.29084158}, {1720,0.28164356}, {1730,0.28937624}, {1740,0.28109901}, {1750,0.27375248}, {1760,0.28660396}, {1770,0.28085149}, {1780,0.28992079}, {1790,0.30508911}, {1800,0.32391089}, {1810,0.28700000}, {1820,0.30714851}, {1830,0.31044554}, {1840,0.31518812}, {1850,0.30117822}, {1860,0.30671287}, {1870,0.30783168}, {1880,0.30454455}, {1890,0.33241584}, {1900,0.31099010}, {1910,0.32504950}, {1920,0.31486139}, {1930,0.32384158}, {1940,0.34160396}, {1950,0.31219802}, {1960,0.33427723}, {1970,0.31434653}, {1980,0.33000000}, {1990,0.35714851}, {2000,0.31732673}, {2050,0.33523762}, {2100,0.35188119}, {2150,0.36042574}, {2200,0.36877228}, {2250,0.36916832}, {2300,0.37180198}, {2350,0.38616832}, {2400,0.42973267}, {2450,0.40674257}, {2500,0.40726733}, {2550,0.42687129}, {2600,0.45142574}, {2650,0.44279208}, {2700,0.48315842}, {2750,0.46931683}, {2800,0.45771287}, {2850,0.46962376}, {2900,0.49512871}, {2950,0.48234653}, {3000,0.50709901}, {3050,0.51435644}, {3100,0.51983168}, {3150,0.52799010}, {3200,0.55384158}, {3250,0.54509901}, {3300,0.56715842}, {3350,0.57687129}, {3400,0.57255446}, {3450,0.58947525}, {3500,0.58663366}, {3550,0.59763366}, {3600,0.61427723}, {3650,0.60593069}, {3700,0.62196040}, {3750,0.64666337}, {3800,0.66680198}, {3850,0.66751485}, {3900,0.65774257}, {3950,0.66696040}, {4000,0.68277228}, {4050,0.69412871}, {4100,0.72119802}, {4150,0.70199010}, {4200,0.71373267}, {4250,0.73324752}, {4300,0.74336634}, {4350,0.74707921}, {4400,0.75411881}, {4450,0.78067327}, {4500,0.76133663}, {4550,0.77129703}, {4600,0.81523762}, {4650,0.77704950}, {4700,0.82839604}, {4750,0.81583168}, {4800,0.81966337}, {4850,0.83279208}, {4900,0.83936634}, {4950,0.84809901}, {5000,0.85965347}, {5050,0.86405941}, {5100,0.89336634}, {5150,0.89709901}, {5200,0.90887129}, {5250,0.91744554}, {5300,0.93787129}, {5350,0.93148515}, {5400,0.92720792}, {5450,0.95664356}, {5500,0.95737624}, {5550,0.96184158}, {5600,0.96991089}, {5650,0.96831683}, {5700,0.97019802}, {5750,0.99928713}, {5800,1.00680198}, {5850,0.99937624}, {5900,1.01815842}, {5950,1.04035644}, {6000,1.04583168}, {6050,1.1206000}, {6100,1.0899429}, {6150,1.1171143}, {6200,1.1314286}, {6250,1.1417714}, {6300,1.1632000}, {6350,1.1820571}, {6400,1.1840286}, {6450,1.1738000}, {6500,1.1622571}, {6550,1.1685714}, {6600,1.1723429}, {6650,1.1824000}, {6700,1.1914571}, {6750,1.2040000}, {6800,1.2216000}, {6850,1.2185429}, {6900,1.2248571}, {6950,1.2482857}, {7000,1.2583429}, {7050,1.2773429}, {7100,1.3140857}, {7150,1.3287714}, {7200,1.3436000}, {7250,1.3324286}, {7300,1.3444000}, {7350,1.3507714}, {7400,1.3565714}, {7450,1.3716571}, {7500,1.3542000}, {7550,1.3548000}, {7600,1.3739429}, {7650,1.4055143}, {7700,1.4426571}, {7750,1.4443429}, {7800,1.4425714}, {7850,1.4408286}, {7900,1.4254286}, {7950,1.4791143}, {8000,1.4737714}, {8050,1.5020286}, {8100,1.4742000}, {8150,1.4721429}, {8200,1.5000857}, {8250,1.5514286}, {8300,1.5224857}, {8350,1.5179714}, {8400,1.5293143}, {8450,1.5610000}, {8500,1.5666000}, {8550,1.5944857}, {8600,1.5665429}, {8650,1.6391143}, {8700,1.6174857}, {8750,1.5946286}, {8800,1.6338000}, {8850,1.6291429}, {8900,1.6163429}, {8950,1.6864857}, {9000,1.6572000}, {9050,1.6352000}, {9100,1.7101429}, {9150,1.6897429}, {9200,1.6626857}, {9250,1.7466571}, {9300,1.7476571}, {9350,1.7377429}, {9400,1.7448857}, {9450,1.7101714}, {9500,1.7749429}, {9550,1.7590571}, {9600,1.7954857}, {9650,1.7821714}, {9700,1.7748857}, {9750,1.8445143}, {9800,1.7768000}, {9850,1.8425714}, {9900,1.8380571}, {9950,1.8690000}, {10000,1.8157429}, {10100,1.9030857}, {10200,1.9028857}, {10300,1.9393714}, {10400,1.8781143}, {10500,1.9675429}, {10600,1.8970571}, {10700,1.9955143}, {10800,1.9600571}, {10900,2.0279143}, {11000,1.9989143}, {11100,2.0672857}, {11200,2.0236000}, {11300,2.1058286}, {11400,2.0885714}, {11500,2.1143429}, {11600,2.1460286}, {11700,2.1401143}, {11800,2.2091714}, {11900,2.1963714}, {12000,2.2006286}, {12100,2.2247143}, {12200,2.2774286}, {12300,2.2626000}, {12400,2.3166571}, {12500,2.2822571}, {12600,2.3380286}, {12700,2.3281714}, {12800,2.3378000}, {12900,2.3858286}, {13000,2.3685143}, {13100,2.4077429}, {13200,2.4653714}, {13300,2.4364286}, {13400,2.4739714}, {13500,2.4919143}, {13600,2.5092571}, {13700,2.5425714}, {13800,2.5390571}, {13900,2.5645714}, {14000,2.5881143}, {14100,2.5964571}, {14200,2.6142000}, {14300,2.6439143}, {14400,2.6846286}, {14500,2.7205143}, {14600,2.8516000}, {14700,2.7328571}, {14800,2.7326571}, {14900,2.7666286}, {15000,2.7752857}, {15100,2.7446000}, {15200,3.0600286}, {15300,2.9262857}, {15400,2.8789714}, {15500,2.8395143}, {15600,2.9632571}, {15700,2.9835143}, {15800,2.9050857}, {15900,2.9367714}, {16000,2.9398286}, {16100,2.9356571}, {16200,2.9453429}, {16300,3.0501429}, {16400,2.9768571}, {16500,3.1052571}, {16600,3.3599714}, {16700,3.0648857}, {16800,3.1895714}, {16900,3.0838857}, {17000,3.2322857}, {17100,3.1987714}, {17200,3.2791714}, {17300,3.2200857}, {17400,3.1994571}, {17500,3.4110000}, {17600,3.2474286}, {17700,3.3118000}, {17800,3.3424286}, {17900,3.3904571}, {18000,3.3435143}, {18100,3.3249143}, {18200,3.3381143}, {18300,3.4081714}, {18400,3.4036571}, {18500,3.4588571}, {18600,3.4269714}, {18700,3.4796286}, {18800,3.4511143}, {18900,3.5439714}, {19000,3.5342571}, {19100,3.5179429}, {19200,3.5481429}, {19300,3.6266857}, {19400,3.6355714}, {19500,3.5874857}, {19600,3.6646286}, {19700,3.7873143}, {19800,3.6486286}, {19900,3.8502857}, {20000,3.9367714}};
data["big_flat"]["LtacTCPrimPair"]["Aggregate"]["system"] = {{1,0.00046535}, {2,0.00002970}, {3,0.00000000}, {4,0.00003960}, {5,0.00000000}, {6,0.00003960}, {7,0.00000000}, {8,0.00002970}, {9,0.00003960}, {10,0.00003960}, {11,0.00003960}, {12,0.00000000}, {13,0.00002970}, {14,0.00018812}, {15,0.00000000}, {16,0.00007921}, {17,0.00002970}, {18,0.00002970}, {19,0.00003960}, {20,0.00000000}, {21,0.00000000}, {22,0.00003960}, {23,0.00007921}, {24,0.00010891}, {25,0.00002970}, {26,0.00003960}, {27,0.00003960}, {28,0.00002970}, {29,0.00006931}, {30,0.00000000}, {31,0.00007921}, {32,0.00003960}, {33,0.00006931}, {34,0.00003960}, {35,0.00003960}, {36,0.00003960}, {37,0.00020792}, {38,0.00000000}, {39,0.00000000}, {40,0.00003960}, {41,0.00003960}, {42,0.00000000}, {43,0.00006931}, {44,0.00014851}, {45,0.00007921}, {46,0.00003960}, {47,0.00007921}, {48,0.00000000}, {49,0.00007921}, {50,0.00006931}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00006931}, {56,0.00006931}, {57,0.00007921}, {58,0.00011881}, {59,0.00006931}, {60,0.00003960}, {61,0.00000000}, {62,0.00007921}, {63,0.00000000}, {64,0.00003960}, {65,0.00003960}, {66,0.00000000}, {67,0.00006931}, {68,0.00003960}, {69,0.00000000}, {70,0.00003960}, {71,0.00007921}, {72,0.00003960}, {73,0.00000000}, {74,0.00011881}, {75,0.00007921}, {76,0.00007921}, {77,0.00003960}, {78,0.00000000}, {79,0.00010891}, {80,0.00015842}, {81,0.00002970}, {82,0.00000000}, {83,0.00003960}, {84,0.00003960}, {85,0.00006931}, {86,0.00000000}, {87,0.00000000}, {88,0.00015842}, {89,0.00003960}, {90,0.00007921}, {91,0.00003960}, {92,0.00000000}, {93,0.00000000}, {94,0.00006931}, {95,0.00007921}, {96,0.00005941}, {97,0.00002970}, {98,0.00003960}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00003960}, {103,0.00000000}, {104,0.00011881}, {105,0.00011881}, {106,0.00000000}, {107,0.00014851}, {108,0.00000000}, {109,0.00007921}, {110,0.00000000}, {111,0.00000000}, {112,0.00003960}, {113,0.00003960}, {114,0.00000000}, {115,0.00002970}, {116,0.00000000}, {117,0.00002970}, {118,0.00019802}, {119,0.00003960}, {120,0.00003960}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00003960}, {125,0.00007921}, {126,0.00007921}, {127,0.00003960}, {128,0.00013861}, {129,0.00023762}, {130,0.00002970}, {131,0.00000000}, {132,0.00022772}, {133,0.00000000}, {134,0.00015842}, {135,0.00017822}, {136,0.00006931}, {137,0.00005941}, {138,0.00011881}, {139,0.00000000}, {140,0.00018812}, {141,0.00003960}, {142,0.00017822}, {143,0.00003960}, {144,0.00011881}, {145,0.00000000}, {146,0.00010891}, {147,0.00010891}, {148,0.00003960}, {149,0.00003960}, {150,0.00003960}, {151,0.00002970}, {152,0.00007921}, {153,0.00000000}, {154,0.00007921}, {155,0.00000000}, {156,0.00006931}, {157,0.00011881}, {158,0.00003960}, {159,0.00014851}, {160,0.00006931}, {161,0.00000000}, {162,0.00019802}, {163,0.00000000}, {164,0.00007921}, {165,0.00022772}, {166,0.00003960}, {167,0.00002970}, {168,0.00003960}, {169,0.00009901}, {170,0.00003960}, {171,0.00007921}, {172,0.00003960}, {173,0.00003960}, {174,0.00000000}, {175,0.00011881}, {176,0.00011881}, {177,0.00000000}, {178,0.00010891}, {179,0.00000000}, {180,0.00000000}, {181,0.00019802}, {182,0.00007921}, {183,0.00003960}, {184,0.00010891}, {185,0.00010891}, {186,0.00003960}, {187,0.00007921}, {188,0.00007921}, {189,0.00017822}, {190,0.00007921}, {191,0.00000000}, {192,0.00000000}, {193,0.00006931}, {194,0.00003960}, {195,0.00000000}, {196,0.00007921}, {197,0.00003960}, {198,0.00000000}, {199,0.00007921}, {200,0.00002970}, {201,0.00000000}, {202,0.00010891}, {203,0.00000000}, {204,0.00015842}, {205,0.00007921}, {206,0.00023762}, {207,0.00014851}, {208,0.00019802}, {209,0.00000000}, {210,0.00000000}, {211,0.00003960}, {212,0.00000000}, {213,0.00003960}, {214,0.00026733}, {215,0.00002970}, {216,0.00000000}, {217,0.00010891}, {218,0.00002970}, {219,0.00003960}, {220,0.00017822}, {221,0.00007921}, {222,0.00000000}, {223,0.00000000}, {224,0.00014851}, {225,0.00013861}, {226,0.00003960}, {227,0.00009901}, {228,0.00009901}, {229,0.00007921}, {230,0.00000000}, {231,0.00019802}, {232,0.00007921}, {233,0.00003960}, {234,0.00023762}, {235,0.00000000}, {236,0.00000000}, {237,0.00015842}, {238,0.00010891}, {239,0.00019802}, {240,0.00011881}, {241,0.00013861}, {242,0.00003960}, {243,0.00007921}, {244,0.00000000}, {245,0.00003960}, {246,0.00000000}, {247,0.00002970}, {248,0.00003960}, {249,0.00000000}, {250,0.00011881}, {251,0.00003960}, {252,0.00007921}, {253,0.00007921}, {254,0.00003960}, {255,0.00000000}, {256,0.00002970}, {257,0.00010891}, {258,0.00000000}, {259,0.00003960}, {260,0.00000000}, {261,0.00006931}, {262,0.00000000}, {263,0.00003960}, {264,0.00000000}, {265,0.00006931}, {266,0.00007921}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00006931}, {271,0.00007921}, {272,0.00010891}, {273,0.00011881}, {274,0.00000000}, {275,0.00002970}, {276,0.00003960}, {277,0.00015842}, {278,0.00005941}, {279,0.00003960}, {280,0.00002970}, {281,0.00015842}, {282,0.00000000}, {283,0.00003960}, {284,0.00003960}, {285,0.00000000}, {286,0.00000000}, {287,0.00006931}, {288,0.00000000}, {289,0.00007921}, {290,0.00003960}, {291,0.00006931}, {292,0.00007921}, {293,0.00007921}, {294,0.00011881}, {295,0.00003960}, {296,0.00003960}, {297,0.00006931}, {298,0.00003960}, {299,0.00000000}, {300,0.00000000}, {301,0.00006931}, {302,0.00003960}, {303,0.00006931}, {304,0.00003960}, {305,0.00007921}, {306,0.00000000}, {307,0.00003960}, {308,0.00003960}, {309,0.00006931}, {310,0.00003960}, {311,0.00000000}, {312,0.00000000}, {313,0.00003960}, {314,0.00000000}, {315,0.00003960}, {316,0.00007921}, {317,0.00003960}, {318,0.00007921}, {319,0.00007921}, {320,0.00003960}, {321,0.00014851}, {322,0.00011881}, {323,0.00003960}, {324,0.00015842}, {325,0.00003960}, {326,0.00000000}, {327,0.00007921}, {328,0.00011881}, {329,0.00003960}, {330,0.00000000}, {331,0.00003960}, {332,0.00003960}, {333,0.00019802}, {334,0.00003960}, {335,0.00015842}, {336,0.00014851}, {337,0.00003960}, {338,0.00000000}, {339,0.00002970}, {340,0.00007921}, {341,0.00000000}, {342,0.00011881}, {343,0.00003960}, {344,0.00011881}, {345,0.00011881}, {346,0.00007921}, {347,0.00003960}, {348,0.00034653}, {349,0.00000000}, {350,0.00041584}, {351,0.00003960}, {352,0.00030693}, {353,0.00003960}, {354,0.00015842}, {355,0.00011881}, {356,0.00007921}, {357,0.00003960}, {358,0.00006931}, {359,0.00009901}, {360,0.00000000}, {361,0.00007921}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00007921}, {366,0.00011881}, {367,0.00039604}, {368,0.00003960}, {369,0.00003960}, {370,0.00023762}, {371,0.00003960}, {372,0.00007921}, {373,0.00002970}, {374,0.00003960}, {375,0.00000000}, {376,0.00003960}, {377,0.00000000}, {378,0.00015842}, {379,0.00003960}, {380,0.00007921}, {381,0.00002970}, {382,0.00003960}, {383,0.00011881}, {384,0.00015842}, {385,0.00003960}, {386,0.00007921}, {387,0.00000000}, {388,0.00021782}, {389,0.00003960}, {390,0.00007921}, {391,0.00003960}, {392,0.00007921}, {393,0.00000000}, {394,0.00003960}, {395,0.00010891}, {396,0.00003960}, {397,0.00003960}, {398,0.00002970}, {399,0.00003960}, {400,0.00003960}, {401,0.00000000}, {402,0.00011881}, {403,0.00003960}, {404,0.00007921}, {405,0.00000000}, {406,0.00003960}, {407,0.00007921}, {408,0.00011881}, {409,0.00003960}, {410,0.00003960}, {411,0.00000000}, {412,0.00011881}, {413,0.00011881}, {414,0.00003960}, {415,0.00003960}, {416,0.00003960}, {417,0.00003960}, {418,0.00006931}, {419,0.00011881}, {420,0.00003960}, {421,0.00003960}, {422,0.00003960}, {423,0.00007921}, {424,0.00000000}, {425,0.00003960}, {426,0.00003960}, {427,0.00007921}, {428,0.00002970}, {429,0.00000000}, {430,0.00011881}, {431,0.00003960}, {432,0.00011881}, {433,0.00000000}, {434,0.00003960}, {435,0.00007921}, {436,0.00000000}, {437,0.00007921}, {438,0.00003960}, {439,0.00000000}, {440,0.00011881}, {441,0.00015842}, {442,0.00007921}, {443,0.00015842}, {444,0.00000000}, {445,0.00007921}, {446,0.00011881}, {447,0.00000000}, {448,0.00015842}, {449,0.00000000}, {450,0.00003960}, {451,0.00006931}, {452,0.00000000}, {453,0.00000000}, {454,0.00011881}, {455,0.00007921}, {456,0.00003960}, {457,0.00007921}, {458,0.00011881}, {459,0.00007921}, {460,0.00003960}, {461,0.00003960}, {462,0.00000000}, {463,0.00006931}, {464,0.00003960}, {465,0.00003960}, {466,0.00000000}, {467,0.00007921}, {468,0.00007921}, {469,0.00007921}, {470,0.00015842}, {471,0.00003960}, {472,0.00015842}, {473,0.00000000}, {474,0.00011881}, {475,0.00015842}, {476,0.00003960}, {477,0.00000000}, {478,0.00011881}, {479,0.00000000}, {480,0.00010891}, {481,0.00010891}, {482,0.00006931}, {483,0.00011881}, {484,0.00007921}, {485,0.00003960}, {486,0.00006931}, {487,0.00011881}, {488,0.00000000}, {489,0.00003960}, {490,0.00011881}, {491,0.00003960}, {492,0.00007921}, {493,0.00007921}, {494,0.00000000}, {495,0.00000000}, {496,0.00002970}, {497,0.00003960}, {498,0.00002970}, {499,0.00007921}, {500,0.00006931}, {505,0.00007921}, {510,0.00015842}, {515,0.00003960}, {520,0.00002970}, {525,0.00007921}, {530,0.00003960}, {535,0.00027723}, {540,0.00011881}, {545,0.00010891}, {550,0.00011881}, {555,0.00000000}, {560,0.00011881}, {565,0.00018812}, {570,0.00007921}, {575,0.00019802}, {580,0.00003960}, {585,0.00003960}, {590,0.00003960}, {595,0.00007921}, {600,0.00000000}, {605,0.00003960}, {610,0.00007921}, {615,0.00007921}, {620,0.00007921}, {625,0.00007921}, {630,0.00003960}, {635,0.00003960}, {640,0.00003960}, {645,0.00002970}, {650,0.00003960}, {655,0.00007921}, {660,0.00011881}, {665,0.00007921}, {670,0.00003960}, {675,0.00000000}, {680,0.00015842}, {685,0.00007921}, {690,0.00007921}, {695,0.00007921}, {700,0.00011881}, {705,0.00000000}, {710,0.00011881}, {715,0.00015842}, {720,0.00000000}, {725,0.00019802}, {730,0.00015842}, {735,0.00003960}, {740,0.00007921}, {745,0.00003960}, {750,0.00007921}, {755,0.00003960}, {760,0.00015842}, {765,0.00007921}, {770,0.00003960}, {775,0.00011881}, {780,0.00019802}, {785,0.00007921}, {790,0.00015842}, {795,0.00006931}, {800,0.00003960}, {805,0.00010891}, {810,0.00014851}, {815,0.00006931}, {820,0.00003960}, {825,0.00007921}, {830,0.00007921}, {835,0.00010891}, {840,0.00007921}, {845,0.00000000}, {850,0.00000000}, {855,0.00007921}, {860,0.00007921}, {865,0.00000000}, {870,0.00000000}, {875,0.00003960}, {880,0.00011881}, {885,0.00015842}, {890,0.00011881}, {895,0.00000000}, {900,0.00003960}, {905,0.00006931}, {910,0.00018812}, {915,0.00003960}, {920,0.00000000}, {925,0.00007921}, {930,0.00011881}, {935,0.00003960}, {940,0.00000000}, {945,0.00003960}, {950,0.00003960}, {955,0.00007921}, {960,0.00003960}, {965,0.00007921}, {970,0.00000000}, {975,0.00003960}, {980,0.00011881}, {985,0.00019802}, {990,0.00015842}, {995,0.00003960}, {1000,0.00007921}, {1010,0.00003960}, {1020,0.00000000}, {1030,0.00007921}, {1040,0.00015842}, {1050,0.00000000}, {1060,0.00009901}, {1070,0.00007921}, {1080,0.00023762}, {1090,0.00000000}, {1100,0.00011881}, {1110,0.00011881}, {1120,0.00007921}, {1130,0.00011881}, {1140,0.00011881}, {1150,0.00000000}, {1160,0.00003960}, {1170,0.00007921}, {1180,0.00011881}, {1190,0.00010891}, {1200,0.00015842}, {1210,0.00014851}, {1220,0.00003960}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00006931}, {1260,0.00003960}, {1270,0.00007921}, {1280,0.00007921}, {1290,0.00007921}, {1300,0.00007921}, {1310,0.00002970}, {1320,0.00011881}, {1330,0.00011881}, {1340,0.00015842}, {1350,0.00007921}, {1360,0.00011881}, {1370,0.00007921}, {1380,0.00007921}, {1390,0.00015842}, {1400,0.00007921}, {1410,0.00003960}, {1420,0.00011881}, {1430,0.00018812}, {1440,0.00035644}, {1450,0.00000000}, {1460,0.00011881}, {1470,0.00011881}, {1480,0.00003960}, {1490,0.00003960}, {1500,0.00015842}, {1510,0.00011881}, {1520,0.00011881}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00003960}, {1560,0.00007921}, {1570,0.00003960}, {1580,0.00010891}, {1590,0.00011881}, {1600,0.00023762}, {1610,0.00003960}, {1620,0.00003960}, {1630,0.00006931}, {1640,0.00006931}, {1650,0.00014851}, {1660,0.00003960}, {1670,0.00011881}, {1680,0.00003960}, {1690,0.00011881}, {1700,0.00015842}, {1710,0.00019802}, {1720,0.00019802}, {1730,0.00007921}, {1740,0.00003960}, {1750,0.00007921}, {1760,0.00011881}, {1770,0.00010891}, {1780,0.00039604}, {1790,0.00011881}, {1800,0.00007921}, {1810,0.00003960}, {1820,0.00007921}, {1830,0.00010891}, {1840,0.00003960}, {1850,0.00010891}, {1860,0.00011881}, {1870,0.00014851}, {1880,0.00003960}, {1890,0.00000000}, {1900,0.00011881}, {1910,0.00003960}, {1920,0.00007921}, {1930,0.00011881}, {1940,0.00019802}, {1950,0.00007921}, {1960,0.00003960}, {1970,0.00007921}, {1980,0.00007921}, {1990,0.00003960}, {2000,0.00014851}, {2050,0.00027723}, {2100,0.00007921}, {2150,0.00003960}, {2200,0.00003960}, {2250,0.00003960}, {2300,0.00019802}, {2350,0.00007921}, {2400,0.00019802}, {2450,0.00023762}, {2500,0.00007921}, {2550,0.00003960}, {2600,0.00007921}, {2650,0.00003960}, {2700,0.00010891}, {2750,0.00003960}, {2800,0.00007921}, {2850,0.00314851}, {2900,0.00011881}, {2950,0.00000000}, {3000,0.00014851}, {3050,0.00022772}, {3100,0.00015842}, {3150,0.00026733}, {3200,0.00011881}, {3250,0.00011881}, {3300,0.00011881}, {3350,0.00007921}, {3400,0.00000000}, {3450,0.00007921}, {3500,0.00007921}, {3550,0.00015842}, {3600,0.00022772}, {3650,0.00006931}, {3700,0.00003960}, {3750,0.00011881}, {3800,0.00019802}, {3850,0.00011881}, {3900,0.00007921}, {3950,0.00015842}, {4000,0.00011881}, {4050,0.00018812}, {4100,0.00010891}, {4150,0.00015842}, {4200,0.00019802}, {4250,0.00011881}, {4300,0.00010891}, {4350,0.00007921}, {4400,0.00007921}, {4450,0.00000000}, {4500,0.00018812}, {4550,0.00011881}, {4600,0.00027723}, {4650,0.00019802}, {4700,0.00027723}, {4750,0.00010891}, {4800,0.00015842}, {4850,0.00031683}, {4900,0.00023762}, {4950,0.00011881}, {5000,0.00058416}, {5050,0.00042574}, {5100,0.00003960}, {5150,0.00015842}, {5200,0.00045545}, {5250,0.00089109}, {5300,0.00035644}, {5350,0.00027723}, {5400,0.00042574}, {5450,0.00011881}, {5500,0.00015842}, {5550,0.00007921}, {5600,0.00019802}, {5650,0.00011881}, {5700,0.00019802}, {5750,0.00015842}, {5800,0.00007921}, {5850,0.00050495}, {5900,0.00039604}, {5950,0.00015842}, {6000,0.00011881}, {6050,0.0080000}, {6100,0.0058000}, {6150,0.0003429}, {6200,0.0002000}, {6250,0.0000857}, {6300,0.0005429}, {6350,0.0001143}, {6400,0.0002286}, {6450,0.0002286}, {6500,0.0000000}, {6550,0.0001143}, {6600,0.0001143}, {6650,0.0003429}, {6700,0.0003429}, {6750,0.0001143}, {6800,0.0000000}, {6850,0.0006857}, {6900,0.0001143}, {6950,0.0000857}, {7000,0.0001143}, {7050,0.0001143}, {7100,0.0001143}, {7150,0.0004000}, {7200,0.0001143}, {7250,0.0004571}, {7300,0.0000000}, {7350,0.0001143}, {7400,0.0001143}, {7450,0.0000857}, {7500,0.0000000}, {7550,0.0001143}, {7600,0.0002286}, {7650,0.0000000}, {7700,0.0002286}, {7750,0.0002286}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0001143}, {7950,0.0001143}, {8000,0.0004571}, {8050,0.0004571}, {8100,0.0003429}, {8150,0.0002286}, {8200,0.0005714}, {8250,0.0006857}, {8300,0.0003429}, {8350,0.0001143}, {8400,0.0006857}, {8450,0.0005143}, {8500,0.0001143}, {8550,0.0001143}, {8600,0.0003429}, {8650,0.0002286}, {8700,0.0001143}, {8750,0.0001143}, {8800,0.0000000}, {8850,0.0004571}, {8900,0.0003429}, {8950,0.0002286}, {9000,0.0003429}, {9050,0.0002286}, {9100,0.0003143}, {9150,0.0006857}, {9200,0.0002286}, {9250,0.0001143}, {9300,0.0003429}, {9350,0.0001143}, {9400,0.0001143}, {9450,0.0004571}, {9500,0.0006857}, {9550,0.0003429}, {9600,0.0004571}, {9650,0.0003429}, {9700,0.0002286}, {9750,0.0005714}, {9800,0.0001143}, {9850,0.0000000}, {9900,0.0001143}, {9950,0.0002286}, {10000,0.0002000}, {10100,0.0003429}, {10200,0.0005429}, {10300,0.0004571}, {10400,0.0001143}, {10500,0.0001143}, {10600,0.0003429}, {10700,0.0001143}, {10800,0.0002000}, {10900,0.0002286}, {11000,0.0000000}, {11100,0.0005714}, {11200,0.0002286}, {11300,0.0001143}, {11400,0.0004571}, {11500,0.0002286}, {11600,0.0006857}, {11700,0.0006857}, {11800,0.0006857}, {11900,0.0012571}, {12000,0.0005714}, {12100,0.0004000}, {12200,0.0000000}, {12300,0.0003429}, {12400,0.0003429}, {12500,0.0002286}, {12600,0.0000000}, {12700,0.0003429}, {12800,0.0004571}, {12900,0.0006857}, {13000,0.0002000}, {13100,0.0002286}, {13200,0.0002286}, {13300,0.0006857}, {13400,0.0004286}, {13500,0.0004571}, {13600,0.0001143}, {13700,0.0003429}, {13800,0.0003429}, {13900,0.0000000}, {14000,0.0003429}, {14100,0.0003429}, {14200,0.0003429}, {14300,0.0003429}, {14400,0.0001143}, {14500,0.0002286}, {14600,0.0001143}, {14700,0.0004571}, {14800,0.0018000}, {14900,0.0012571}, {15000,0.0003143}, {15100,0.0004571}, {15200,0.0003429}, {15300,0.0001143}, {15400,0.0006857}, {15500,0.0011429}, {15600,0.0006857}, {15700,0.0010286}, {15800,0.0006857}, {15900,0.0003429}, {16000,0.0008000}, {16100,0.0004571}, {16200,0.0000000}, {16300,0.0004571}, {16400,0.0010000}, {16500,0.0006857}, {16600,0.0006857}, {16700,0.0017143}, {16800,0.0011429}, {16900,0.0002286}, {17000,0.0005714}, {17100,0.0005714}, {17200,0.0012571}, {17300,0.0003429}, {17400,0.0003429}, {17500,0.0006571}, {17600,0.0004571}, {17700,0.0005429}, {17800,0.0000000}, {17900,0.0010286}, {18000,0.0005714}, {18100,0.0006857}, {18200,0.0013429}, {18300,0.0002286}, {18400,0.0003429}, {18500,0.0012286}, {18600,0.0009143}, {18700,0.0016000}, {18800,0.0003429}, {18900,0.0001143}, {19000,0.0013143}, {19100,0.0006857}, {19200,0.0004571}, {19300,0.0004571}, {19400,0.0005714}, {19500,0.0013714}, {19600,0.0020286}, {19700,0.0008857}, {19800,0.0021143}, {19900,0.0013714}, {20000,0.0022857}};
data["big_flat"]["LtacTCPrimPair"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00007921}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100990}, {12,0.00100000}, {13,0.00100000}, {14,0.00102970}, {15,0.00114851}, {16,0.00190099}, {17,0.00200000}, {18,0.00200000}, {19,0.00200000}, {20,0.00200000}, {21,0.00200990}, {22,0.00221782}, {23,0.00220792}, {24,0.00274257}, {25,0.00300000}, {26,0.00300000}, {27,0.00300000}, {28,0.00300990}, {29,0.00305941}, {30,0.00317822}, {31,0.00337624}, {32,0.00372277}, {33,0.00400000}, {34,0.00400000}, {35,0.00400000}, {36,0.00404950}, {37,0.00420792}, {38,0.00427723}, {39,0.00436634}, {40,0.00456436}, {41,0.00500000}, {42,0.00500000}, {43,0.00500990}, {44,0.00501980}, {45,0.00517822}, {46,0.00510891}, {47,0.00534653}, {48,0.00553465}, {49,0.00598020}, {50,0.00600000}, {51,0.00600990}, {52,0.00607921}, {53,0.00626733}, {54,0.00633663}, {55,0.00742574}, {56,0.00649505}, {57,0.00695050}, {58,0.00700990}, {59,0.00709901}, {60,0.00716832}, {61,0.00730693}, {62,0.00715842}, {63,0.00720792}, {64,0.00745545}, {65,0.00797030}, {66,0.00802970}, {67,0.00825743}, {68,0.00815842}, {69,0.00821782}, {70,0.00917822}, {71,0.00840594}, {72,0.00846535}, {73,0.00887129}, {74,0.00900990}, {75,0.00910891}, {76,0.00929703}, {77,0.00916832}, {78,0.00921782}, {79,0.00929703}, {80,0.01335644}, {81,0.00985149}, {82,0.01011881}, {83,0.01013861}, {84,0.01012871}, {85,0.01016832}, {86,0.01028713}, {87,0.01118812}, {88,0.01399010}, {89,0.01081188}, {90,0.01105941}, {91,0.01115842}, {92,0.01118812}, {93,0.01120792}, {94,0.01125743}, {95,0.01143564}, {96,0.01149505}, {97,0.01174257}, {98,0.01203960}, {99,0.01211881}, {100,0.01229703}, {101,0.01226733}, {102,0.01230693}, {103,0.01233663}, {104,0.01788119}, {105,0.01544554}, {106,0.01297030}, {107,0.01312871}, {108,0.01321782}, {109,0.01333663}, {110,0.01330693}, {111,0.01353465}, {112,0.01355446}, {113,0.01643564}, {114,0.01393069}, {115,0.01421782}, {116,0.01424752}, {117,0.01430693}, {118,0.01904950}, {119,0.01436634}, {120,0.01460396}, {121,0.01482178}, {122,0.01497030}, {123,0.01513861}, {124,0.01528713}, {125,0.01516832}, {126,0.01916832}, {127,0.01541584}, {128,0.01553465}, {129,0.02230693}, {130,0.01589109}, {131,0.01618812}, {132,0.02224752}, {133,0.01628713}, {134,0.01632673}, {135,0.01990099}, {136,0.01656436}, {137,0.01684158}, {138,0.01686139}, {139,0.01714851}, {140,0.01948515}, {141,0.01723762}, {142,0.02331683}, {143,0.01762376}, {144,0.01750495}, {145,0.01787129}, {146,0.01798020}, {147,0.01803960}, {148,0.01830693}, {149,0.01820792}, {150,0.01854455}, {151,0.01866337}, {152,0.02507921}, {153,0.01874257}, {154,0.02202970}, {155,0.01919802}, {156,0.01916832}, {157,0.01951485}, {158,0.01942574}, {159,0.02245545}, {160,0.01954455}, {161,0.01967327}, {162,0.02708911}, {163,0.02024752}, {164,0.02026733}, {165,0.02045545}, {166,0.02048515}, {167,0.02044554}, {168,0.02622772}, {169,0.02076238}, {170,0.02094059}, {171,0.02220792}, {172,0.02125743}, {173,0.02142574}, {174,0.02138614}, {175,0.02158416}, {176,0.02890099}, {177,0.02199010}, {178,0.02188119}, {179,0.02222772}, {180,0.02268317}, {181,0.02836634}, {182,0.02280198}, {183,0.02240594}, {184,0.02246535}, {185,0.02289109}, {186,0.02293069}, {187,0.02311881}, {188,0.02654455}, {189,0.02951485}, {190,0.03180198}, {191,0.02366337}, {192,0.02381188}, {193,0.02388119}, {194,0.02396040}, {195,0.02400990}, {196,0.02441584}, {197,0.02441584}, {198,0.02442574}, {199,0.02465347}, {200,0.02452475}, {201,0.02474257}, {202,0.02474257}, {203,0.02525743}, {204,0.02538614}, {205,0.02533663}, {206,0.03320792}, {207,0.03062376}, {208,0.02978218}, {209,0.02563366}, {210,0.02576238}, {211,0.02606931}, {212,0.02633663}, {213,0.02634653}, {214,0.04026733}, {215,0.03345545}, {216,0.02649505}, {217,0.02672277}, {218,0.02690099}, {219,0.02732673}, {220,0.03268317}, {221,0.02714851}, {222,0.02737624}, {223,0.02777228}, {224,0.03431683}, {225,0.02784158}, {226,0.02789109}, {227,0.02825743}, {228,0.03216832}, {229,0.02835644}, {230,0.02844554}, {231,0.03370297}, {232,0.02861386}, {233,0.02882178}, {234,0.03364356}, {235,0.02922772}, {236,0.02940594}, {237,0.03093069}, {238,0.02956436}, {239,0.03699010}, {240,0.02981188}, {241,0.03008911}, {242,0.02983168}, {243,0.03031683}, {244,0.03300000}, {245,0.03049505}, {246,0.03521782}, {247,0.03061386}, {248,0.03660396}, {249,0.03080198}, {250,0.03724752}, {251,0.03122772}, {252,0.03554455}, {253,0.03143564}, {254,0.03261386}, {255,0.03200000}, {256,0.03149505}, {257,0.04216832}, {258,0.03215842}, {259,0.03709901}, {260,0.03236634}, {261,0.03237624}, {262,0.04229703}, {263,0.03279208}, {264,0.03352475}, {265,0.04421782}, {266,0.03283168}, {267,0.03404950}, {268,0.04333663}, {269,0.03342574}, {270,0.03349505}, {271,0.04309901}, {272,0.03413861}, {273,0.03386139}, {274,0.03538614}, {275,0.04280198}, {276,0.03430693}, {277,0.03474257}, {278,0.03464356}, {279,0.03984158}, {280,0.04515842}, {281,0.03540594}, {282,0.03494059}, {283,0.03551485}, {284,0.03623762}, {285,0.04086139}, {286,0.04443564}, {287,0.04827723}, {288,0.03601980}, {289,0.03587129}, {290,0.03612871}, {291,0.03644554}, {292,0.03623762}, {293,0.03647525}, {294,0.03791089}, {295,0.03985149}, {296,0.04029703}, {297,0.04129703}, {298,0.04182178}, {299,0.04052475}, {300,0.04225743}, {301,0.04062376}, {302,0.04375248}, {303,0.04208911}, {304,0.04009901}, {305,0.03817822}, {306,0.03807921}, {307,0.03825743}, {308,0.03833663}, {309,0.03840594}, {310,0.03873267}, {311,0.05308911}, {312,0.04927723}, {313,0.04632673}, {314,0.04157426}, {315,0.03962376}, {316,0.03955446}, {317,0.03980198}, {318,0.05113861}, {319,0.04549505}, {320,0.04029703}, {321,0.04023762}, {322,0.04013861}, {323,0.04959406}, {324,0.04369307}, {325,0.04057426}, {326,0.04108911}, {327,0.05002970}, {328,0.04280198}, {329,0.04157426}, {330,0.05375248}, {331,0.04900990}, {332,0.04145545}, {333,0.04210891}, {334,0.04779208}, {335,0.04197030}, {336,0.05587129}, {337,0.04550495}, {338,0.04228713}, {339,0.05222772}, {340,0.04260396}, {341,0.04289109}, {342,0.04659406}, {343,0.04326733}, {344,0.05001980}, {345,0.04290099}, {346,0.05264356}, {347,0.04361386}, {348,0.05373267}, {349,0.04371287}, {350,0.05462376}, {351,0.04422772}, {352,0.05308911}, {353,0.04388119}, {354,0.05205941}, {355,0.04464356}, {356,0.05003960}, {357,0.04500000}, {358,0.04812871}, {359,0.06467327}, {360,0.04457426}, {361,0.05373267}, {362,0.04526733}, {363,0.04728713}, {364,0.05829703}, {365,0.04561386}, {366,0.04898020}, {367,0.05866337}, {368,0.04601980}, {369,0.04825743}, {370,0.05640594}, {371,0.04653465}, {372,0.04651485}, {373,0.05222772}, {374,0.05989109}, {375,0.04690099}, {376,0.04713861}, {377,0.05256436}, {378,0.05876238}, {379,0.04719802}, {380,0.04757426}, {381,0.04952475}, {382,0.05571287}, {383,0.05978218}, {384,0.06330693}, {385,0.04809901}, {386,0.04848515}, {387,0.04829703}, {388,0.05205941}, {389,0.05624752}, {390,0.05986139}, {391,0.06256436}, {392,0.06439604}, {393,0.04928713}, {394,0.04931683}, {395,0.04977228}, {396,0.04942574}, {397,0.04950495}, {398,0.04969307}, {399,0.04981188}, {400,0.05013861}, {401,0.04994059}, {402,0.05014851}, {403,0.05081188}, {404,0.05012871}, {405,0.05091089}, {406,0.05115842}, {407,0.05119802}, {408,0.05073267}, {409,0.06487129}, {410,0.06422772}, {411,0.06178218}, {412,0.05895050}, {413,0.05615842}, {414,0.05300000}, {415,0.05221782}, {416,0.05186139}, {417,0.07452475}, {418,0.06711881}, {419,0.05996040}, {420,0.05466337}, {421,0.05276238}, {422,0.07265347}, {423,0.06557426}, {424,0.05866337}, {425,0.05304950}, {426,0.05396040}, {427,0.06548515}, {428,0.05864356}, {429,0.05367327}, {430,0.06996040}, {431,0.06291089}, {432,0.05408911}, {433,0.05426733}, {434,0.06895050}, {435,0.05641584}, {436,0.05484158}, {437,0.06495050}, {438,0.05480198}, {439,0.07268317}, {440,0.06002970}, {441,0.05515842}, {442,0.06600000}, {443,0.05559406}, {444,0.06882178}, {445,0.05818812}, {446,0.07175248}, {447,0.06007921}, {448,0.07294059}, {449,0.06157426}, {450,0.05631683}, {451,0.06680198}, {452,0.05644554}, {453,0.06583168}, {454,0.05732673}, {455,0.06288119}, {456,0.07353465}, {457,0.05997030}, {458,0.07253465}, {459,0.05757426}, {460,0.06767327}, {461,0.05782178}, {462,0.06248515}, {463,0.07251485}, {464,0.05788119}, {465,0.06649505}, {466,0.07323762}, {467,0.05847525}, {468,0.07142574}, {469,0.07880198}, {470,0.05908911}, {471,0.06838614}, {472,0.07521782}, {473,0.05955446}, {474,0.06322772}, {475,0.07087129}, {476,0.07691089}, {477,0.06030693}, {478,0.06318812}, {479,0.06941584}, {480,0.07261386}, {481,0.06023762}, {482,0.06012871}, {483,0.06630693}, {484,0.07111881}, {485,0.07594059}, {486,0.07939604}, {487,0.06129703}, {488,0.06095050}, {489,0.06353465}, {490,0.06696040}, {491,0.06998020}, {492,0.07215842}, {493,0.07264356}, {494,0.08341584}, {495,0.08325743}, {496,0.08124752}, {497,0.08295050}, {498,0.08398020}, {499,0.06463366}, {500,0.06282178}, {505,0.06399010}, {510,0.08342574}, {515,0.08142574}, {520,0.07831683}, {525,0.07505941}, {530,0.06930693}, {535,0.09666337}, {540,0.08282178}, {545,0.07257426}, {550,0.08700000}, {555,0.07595050}, {560,0.08697030}, {565,0.07437624}, {570,0.08300990}, {575,0.09236634}, {580,0.07317822}, {585,0.08349505}, {590,0.08661386}, {595,0.09034653}, {600,0.09233663}, {605,0.09301980}, {610,0.09153465}, {615,0.09032673}, {620,0.08755446}, {625,0.08638614}, {630,0.11516832}, {635,0.09969307}, {640,0.08938614}, {645,0.10833663}, {650,0.09612871}, {655,0.08577228}, {660,0.09689109}, {665,0.10235644}, {670,0.09569307}, {675,0.10447525}, {680,0.11145545}, {685,0.09246535}, {690,0.09627723}, {695,0.10037624}, {700,0.10199010}, {705,0.10566337}, {710,0.10625743}, {715,0.10411881}, {720,0.10064356}, {725,0.09808911}, {730,0.11770297}, {735,0.12084158}, {740,0.10505941}, {745,0.12241584}, {750,0.11105941}, {755,0.12387129}, {760,0.11089109}, {765,0.13460396}, {770,0.10868317}, {775,0.11839604}, {780,0.12416832}, {785,0.10644554}, {790,0.10930693}, {795,0.11910891}, {800,0.11821782}, {805,0.12138614}, {810,0.12132673}, {815,0.12053465}, {820,0.12533663}, {825,0.11692079}, {830,0.13817822}, {835,0.12839604}, {840,0.12139604}, {845,0.15341584}, {850,0.13204950}, {855,0.12018812}, {860,0.13068317}, {865,0.14134653}, {870,0.13142574}, {875,0.14159406}, {880,0.14567327}, {885,0.12708911}, {890,0.12703960}, {895,0.14021782}, {900,0.13894059}, {905,0.13832673}, {910,0.13881188}, {915,0.13241584}, {920,0.13947525}, {925,0.13582178}, {930,0.12910891}, {935,0.14786139}, {940,0.15131683}, {945,0.13700000}, {950,0.14966337}, {955,0.13816832}, {960,0.14384158}, {965,0.14165347}, {970,0.15068317}, {975,0.15701980}, {980,0.14098020}, {985,0.15164356}, {990,0.15629703}, {995,0.15660396}, {1000,0.15966337}, {1010,0.16920792}, {1020,0.16531683}, {1030,0.15964356}, {1040,0.16948515}, {1050,0.15275248}, {1060,0.16543564}, {1070,0.15379208}, {1080,0.16874257}, {1090,0.17551485}, {1100,0.17667327}, {1110,0.20134653}, {1120,0.17687129}, {1130,0.17859406}, {1140,0.17461386}, {1150,0.17203960}, {1160,0.18604950}, {1170,0.17081188}, {1180,0.18874257}, {1190,0.19226733}, {1200,0.19436634}, {1210,0.17812871}, {1220,0.17650495}, {1230,0.19712871}, {1240,0.19866337}, {1250,0.18826733}, {1260,0.20123762}, {1270,0.19605941}, {1280,0.19749505}, {1290,0.20210891}, {1300,0.18927723}, {1310,0.19407921}, {1320,0.20729703}, {1330,0.19712871}, {1340,0.21310891}, {1350,0.21325743}, {1360,0.19858416}, {1370,0.22232673}, {1380,0.21594059}, {1390,0.20650495}, {1400,0.22108911}, {1410,0.21550495}, {1420,0.21386139}, {1430,0.21802970}, {1440,0.20940594}, {1450,0.23639604}, {1460,0.22069307}, {1470,0.24385149}, {1480,0.22176238}, {1490,0.22642574}, {1500,0.24049505}, {1510,0.23376238}, {1520,0.24427723}, {1530,0.23774257}, {1540,0.23862376}, {1550,0.22968317}, {1560,0.24078218}, {1570,0.22887129}, {1580,0.24328713}, {1590,0.26169307}, {1600,0.23255446}, {1610,0.24601980}, {1620,0.23993069}, {1630,0.24739604}, {1640,0.25675248}, {1650,0.26217822}, {1660,0.24591089}, {1670,0.26562376}, {1680,0.24622772}, {1690,0.26320792}, {1700,0.26052475}, {1710,0.27505941}, {1720,0.26552475}, {1730,0.27300990}, {1740,0.26129703}, {1750,0.25557426}, {1760,0.27027723}, {1770,0.26432673}, {1780,0.27333663}, {1790,0.28828713}, {1800,0.30700990}, {1810,0.26906931}, {1820,0.28739604}, {1830,0.29355446}, {1840,0.29789109}, {1850,0.28381188}, {1860,0.28546535}, {1870,0.29032673}, {1880,0.28497030}, {1890,0.31459406}, {1900,0.29304950}, {1910,0.30753465}, {1920,0.29683168}, {1930,0.30615842}, {1940,0.32388119}, {1950,0.29176238}, {1960,0.31584158}, {1970,0.29608911}, {1980,0.31203960}, {1990,0.33714851}, {2000,0.29714851}, {2050,0.31623762}, {2100,0.32893069}, {2150,0.34049505}, {2200,0.34815842}, {2250,0.34666337}, {2300,0.34882178}, {2350,0.36284158}, {2400,0.40737624}, {2450,0.38418812}, {2500,0.38366337}, {2550,0.40303960}, {2600,0.42598020}, {2650,0.41586139}, {2700,0.45771287}, {2750,0.44127723}, {2800,0.43154455}, {2850,0.44607921}, {2900,0.46805941}, {2950,0.45037624}, {3000,0.47886139}, {3050,0.48579208}, {3100,0.48425743}, {3150,0.49818812}, {3200,0.52234653}, {3250,0.51396040}, {3300,0.53400990}, {3350,0.54513861}, {3400,0.54021782}, {3450,0.55682178}, {3500,0.55357426}, {3550,0.56432673}, {3600,0.57987129}, {3650,0.56784158}, {3700,0.58667327}, {3750,0.61104950}, {3800,0.63061386}, {3850,0.63103960}, {3900,0.62033663}, {3950,0.62933663}, {4000,0.64014851}, {4050,0.65223762}, {4100,0.67182178}, {4150,0.65474257}, {4200,0.67358416}, {4250,0.69271287}, {4300,0.70205941}, {4350,0.70486139}, {4400,0.70280198}, {4450,0.73778218}, {4500,0.70995050}, {4550,0.72762376}, {4600,0.76155446}, {4650,0.73025743}, {4700,0.77948515}, {4750,0.76996040}, {4800,0.77065347}, {4850,0.78586139}, {4900,0.78970297}, {4950,0.80019802}, {5000,0.80452475}, {5050,0.81515842}, {5100,0.84388119}, {5150,0.84428713}, {5200,0.85784158}, {5250,0.85618812}, {5300,0.88099010}, {5350,0.87878218}, {5400,0.87162376}, {5450,0.90329703}, {5500,0.89269307}, {5550,0.90082178}, {5600,0.90985149}, {5650,0.89977228}, {5700,0.90827723}, {5750,0.94250495}, {5800,0.94595050}, {5850,0.94008911}, {5900,0.95776238}, {5950,0.98102970}, {6000,0.98540594}, {6050,1.0235143}, {6100,1.0204857}, {6150,1.0415143}, {6200,1.0506857}, {6250,1.0677429}, {6300,1.0687714}, {6350,1.1068286}, {6400,1.0934286}, {6450,1.0970571}, {6500,1.0833714}, {6550,1.0870000}, {6600,1.0890000}, {6650,1.1000000}, {6700,1.1024286}, {6750,1.1210286}, {6800,1.1422571}, {6850,1.1295714}, {6900,1.1371714}, {6950,1.1491714}, {7000,1.1749143}, {7050,1.1880857}, {7100,1.2278571}, {7150,1.2413714}, {7200,1.2391429}, {7250,1.2440857}, {7300,1.2528286}, {7350,1.2538857}, {7400,1.2574571}, {7450,1.2670857}, {7500,1.2568000}, {7550,1.2541143}, {7600,1.2816000}, {7650,1.3023143}, {7700,1.3490857}, {7750,1.3294286}, {7800,1.3456857}, {7850,1.3270857}, {7900,1.3236000}, {7950,1.3795429}, {8000,1.3768857}, {8050,1.3848000}, {8100,1.3717714}, {8150,1.3643714}, {8200,1.3973143}, {8250,1.4274857}, {8300,1.4065429}, {8350,1.4076000}, {8400,1.3965429}, {8450,1.4542857}, {8500,1.4535714}, {8550,1.4575143}, {8600,1.4502286}, {8650,1.5252286}, {8700,1.4863429}, {8750,1.4672571}, {8800,1.5084286}, {8850,1.5114571}, {8900,1.4773143}, {8950,1.5706286}, {9000,1.5272571}, {9050,1.5159143}, {9100,1.5575714}, {9150,1.5732000}, {9200,1.5374571}, {9250,1.6046286}, {9300,1.5954857}, {9350,1.5944000}, {9400,1.6208857}, {9450,1.5902571}, {9500,1.6482286}, {9550,1.6217714}, {9600,1.6677143}, {9650,1.6426000}, {9700,1.6412000}, {9750,1.6845143}, {9800,1.6403143}, {9850,1.6972286}, {9900,1.6874571}, {9950,1.7108000}, {10000,1.6821429}, {10100,1.7378571}, {10200,1.7483143}, {10300,1.7695429}, {10400,1.7338857}, {10500,1.8053143}, {10600,1.7456857}, {10700,1.8350000}, {10800,1.8119143}, {10900,1.8584000}, {11000,1.8437714}, {11100,1.9156286}, {11200,1.8850857}, {11300,1.9214000}, {11400,1.9188286}, {11500,1.9479429}, {11600,1.9809143}, {11700,1.9739714}, {11800,2.0228857}, {11900,2.0267714}, {12000,2.0333714}, {12100,2.0529714}, {12200,2.0660000}, {12300,2.0652571}, {12400,2.1213143}, {12500,2.1158571}, {12600,2.1288857}, {12700,2.1526857}, {12800,2.1467429}, {12900,2.1887143}, {13000,2.1686857}, {13100,2.2093429}, {13200,2.2405714}, {13300,2.2460000}, {13400,2.2753714}, {13500,2.2814857}, {13600,2.2946000}, {13700,2.3270000}, {13800,2.3283143}, {13900,2.3648857}, {14000,2.3528000}, {14100,2.3800286}, {14200,2.4095714}, {14300,2.4044571}, {14400,2.4402857}, {14500,2.4628286}, {14600,2.6120286}, {14700,2.4910000}, {14800,2.5030571}, {14900,2.5272286}, {15000,2.5396000}, {15100,2.5420000}, {15200,2.8390286}, {15300,2.6607143}, {15400,2.6043429}, {15500,2.6061714}, {15600,2.7054286}, {15700,2.7304571}, {15800,2.6551714}, {15900,2.6992000}, {16000,2.6924286}, {16100,2.7057429}, {16200,2.7133143}, {16300,2.8321429}, {16400,2.7154286}, {16500,2.8306857}, {16600,3.0863429}, {16700,2.8068571}, {16800,2.9238857}, {16900,2.8363429}, {17000,3.0017714}, {17100,2.8882571}, {17200,3.0018571}, {17300,2.9081143}, {17400,2.9238286}, {17500,3.1194857}, {17600,2.9366571}, {17700,3.0013714}, {17800,3.0582286}, {17900,3.1056286}, {18000,3.0304000}, {18100,3.0499429}, {18200,3.0698571}, {18300,3.1033429}, {18400,3.1019714}, {18500,3.1819429}, {18600,3.1428000}, {18700,3.1376286}, {18800,3.1658286}, {18900,3.2252286}, {19000,3.2190857}, {19100,3.2381429}, {19200,3.2484000}, {19300,3.3332571}, {19400,3.3433429}, {19500,3.2956286}, {19600,3.3236000}, {19700,3.5017714}, {19800,3.3527714}, {19900,3.5392857}, {20000,3.5646571}};
data["big_flat"]["LtacTCPrimPair"]["actual reif"]["user"] = {{1,0.00018812}, {2,0.00027723}, {3,0.00015842}, {4,0.00060396}, {5,0.00068317}, {6,0.00086139}, {7,0.00035644}, {8,0.00130693}, {9,0.00089109}, {10,0.00087129}, {11,0.00103960}, {12,0.00149505}, {13,0.00157426}, {14,0.00156436}, {15,0.00181188}, {16,0.00182178}, {17,0.00200000}, {18,0.00190099}, {19,0.00248515}, {20,0.00252475}, {21,0.00235644}, {22,0.00249505}, {23,0.00241584}, {24,0.00262376}, {25,0.00255446}, {26,0.00283168}, {27,0.00299010}, {28,0.00317822}, {29,0.00318812}, {30,0.00311881}, {31,0.00349505}, {32,0.00366337}, {33,0.00374257}, {34,0.00382178}, {35,0.00398020}, {36,0.00416832}, {37,0.00432673}, {38,0.00464356}, {39,0.00480198}, {40,0.00470297}, {41,0.00454455}, {42,0.00515842}, {43,0.00503960}, {44,0.00512871}, {45,0.00552475}, {46,0.00511881}, {47,0.00561386}, {48,0.00600000}, {49,0.00581188}, {50,0.00622772}, {51,0.00603960}, {52,0.00628713}, {53,0.00658416}, {54,0.00658416}, {55,0.00801980}, {56,0.00710891}, {57,0.00714851}, {58,0.00709901}, {59,0.00715842}, {60,0.00719802}, {61,0.00744554}, {62,0.00744554}, {63,0.00755446}, {64,0.00771287}, {65,0.00789109}, {66,0.00789109}, {67,0.00802970}, {68,0.00793069}, {69,0.00840594}, {70,0.00922772}, {71,0.00859406}, {72,0.00851485}, {73,0.00882178}, {74,0.00900990}, {75,0.00940594}, {76,0.00918812}, {77,0.00917822}, {78,0.00946535}, {79,0.00943564}, {80,0.01400000}, {81,0.01001980}, {82,0.01019802}, {83,0.01020792}, {84,0.01035644}, {85,0.01038614}, {86,0.01053465}, {87,0.01135644}, {88,0.01399010}, {89,0.01097030}, {90,0.01114851}, {91,0.01100000}, {92,0.01119802}, {93,0.01160396}, {94,0.01142574}, {95,0.01171287}, {96,0.01182178}, {97,0.01194059}, {98,0.01214851}, {99,0.01203960}, {100,0.01234653}, {101,0.01279208}, {102,0.01254455}, {103,0.01258416}, {104,0.01765347}, {105,0.01564356}, {106,0.01273267}, {107,0.01323762}, {108,0.01361386}, {109,0.01341584}, {110,0.01399010}, {111,0.01386139}, {112,0.01401980}, {113,0.01663366}, {114,0.01404950}, {115,0.01437624}, {116,0.01479208}, {117,0.01464356}, {118,0.01871287}, {119,0.01489109}, {120,0.01486139}, {121,0.01527723}, {122,0.01518812}, {123,0.01530693}, {124,0.01561386}, {125,0.01562376}, {126,0.01875248}, {127,0.01590099}, {128,0.01590099}, {129,0.02227723}, {130,0.01625743}, {131,0.01649505}, {132,0.02198020}, {133,0.01664356}, {134,0.01674257}, {135,0.01955446}, {136,0.01718812}, {137,0.01723762}, {138,0.01683168}, {139,0.01725743}, {140,0.01929703}, {141,0.01727723}, {142,0.02332673}, {143,0.01757426}, {144,0.01748515}, {145,0.01770297}, {146,0.01773267}, {147,0.01752475}, {148,0.01776238}, {149,0.01782178}, {150,0.01820792}, {151,0.01858416}, {152,0.02495050}, {153,0.01849505}, {154,0.02192079}, {155,0.01875248}, {156,0.01887129}, {157,0.01905941}, {158,0.01900000}, {159,0.02224752}, {160,0.01914851}, {161,0.01953465}, {162,0.02695050}, {163,0.02017822}, {164,0.01984158}, {165,0.02023762}, {166,0.02030693}, {167,0.02054455}, {168,0.02626733}, {169,0.02050495}, {170,0.02064356}, {171,0.02199010}, {172,0.02099010}, {173,0.02152475}, {174,0.02165347}, {175,0.02171287}, {176,0.02851485}, {177,0.02224752}, {178,0.02219802}, {179,0.02211881}, {180,0.02280198}, {181,0.02816832}, {182,0.02268317}, {183,0.02268317}, {184,0.02238614}, {185,0.02311881}, {186,0.02292079}, {187,0.02325743}, {188,0.02641584}, {189,0.02981188}, {190,0.03224752}, {191,0.02379208}, {192,0.02398020}, {193,0.02417822}, {194,0.02446535}, {195,0.02419802}, {196,0.02448515}, {197,0.02433663}, {198,0.02451485}, {199,0.02484158}, {200,0.02466337}, {201,0.02479208}, {202,0.02485149}, {203,0.02539604}, {204,0.02521782}, {205,0.02526733}, {206,0.03315842}, {207,0.03084158}, {208,0.02981188}, {209,0.02531683}, {210,0.02568317}, {211,0.02604950}, {212,0.02622772}, {213,0.02646535}, {214,0.04011881}, {215,0.03343564}, {216,0.02640594}, {217,0.02687129}, {218,0.02661386}, {219,0.02728713}, {220,0.03290099}, {221,0.02694059}, {222,0.02733663}, {223,0.02781188}, {224,0.03407921}, {225,0.02758416}, {226,0.02775248}, {227,0.02781188}, {228,0.03241584}, {229,0.02815842}, {230,0.02852475}, {231,0.03379208}, {232,0.02863366}, {233,0.02889109}, {234,0.03398020}, {235,0.02917822}, {236,0.02940594}, {237,0.03093069}, {238,0.02931683}, {239,0.03666337}, {240,0.02982178}, {241,0.02989109}, {242,0.02961386}, {243,0.02994059}, {244,0.03310891}, {245,0.02999010}, {246,0.03517822}, {247,0.03044554}, {248,0.03708911}, {249,0.03060396}, {250,0.03708911}, {251,0.03125743}, {252,0.03535644}, {253,0.03126733}, {254,0.03271287}, {255,0.03211881}, {256,0.03132673}, {257,0.04197030}, {258,0.03217822}, {259,0.03698020}, {260,0.03252475}, {261,0.03233663}, {262,0.04235644}, {263,0.03298020}, {264,0.03367327}, {265,0.04428713}, {266,0.03292079}, {267,0.03398020}, {268,0.04299010}, {269,0.03347525}, {270,0.03329703}, {271,0.04301980}, {272,0.03452475}, {273,0.03402970}, {274,0.03592079}, {275,0.04256436}, {276,0.03452475}, {277,0.03521782}, {278,0.03499010}, {279,0.03937624}, {280,0.04518812}, {281,0.03594059}, {282,0.03503960}, {283,0.03558416}, {284,0.03637624}, {285,0.04057426}, {286,0.04401980}, {287,0.04796040}, {288,0.03624752}, {289,0.03581188}, {290,0.03606931}, {291,0.03647525}, {292,0.03652475}, {293,0.03648515}, {294,0.03741584}, {295,0.03987129}, {296,0.03992079}, {297,0.04106931}, {298,0.04188119}, {299,0.04067327}, {300,0.04215842}, {301,0.04034653}, {302,0.04373267}, {303,0.04178218}, {304,0.03966337}, {305,0.03794059}, {306,0.03798020}, {307,0.03801980}, {308,0.03811881}, {309,0.03836634}, {310,0.03850495}, {311,0.05285149}, {312,0.04923762}, {313,0.04626733}, {314,0.04156436}, {315,0.03927723}, {316,0.03948515}, {317,0.03960396}, {318,0.05089109}, {319,0.04552475}, {320,0.04000000}, {321,0.03981188}, {322,0.03991089}, {323,0.04932673}, {324,0.04326733}, {325,0.04029703}, {326,0.04083168}, {327,0.04976238}, {328,0.04277228}, {329,0.04130693}, {330,0.05322772}, {331,0.04893069}, {332,0.04128713}, {333,0.04189109}, {334,0.04783168}, {335,0.04185149}, {336,0.05574257}, {337,0.04526733}, {338,0.04209901}, {339,0.05191089}, {340,0.04219802}, {341,0.04273267}, {342,0.04668317}, {343,0.04288119}, {344,0.04971287}, {345,0.04269307}, {346,0.05205941}, {347,0.04357426}, {348,0.05283168}, {349,0.04364356}, {350,0.05377228}, {351,0.04412871}, {352,0.05266337}, {353,0.04343564}, {354,0.05177228}, {355,0.04457426}, {356,0.05015842}, {357,0.04509901}, {358,0.04830693}, {359,0.06443564}, {360,0.04428713}, {361,0.05361386}, {362,0.04510891}, {363,0.04758416}, {364,0.05833663}, {365,0.04561386}, {366,0.04920792}, {367,0.05852475}, {368,0.04603960}, {369,0.04856436}, {370,0.05594059}, {371,0.04654455}, {372,0.04684158}, {373,0.05228713}, {374,0.05978218}, {375,0.04684158}, {376,0.04714851}, {377,0.05262376}, {378,0.05873267}, {379,0.04720792}, {380,0.04778218}, {381,0.04926733}, {382,0.05535644}, {383,0.05946535}, {384,0.06308911}, {385,0.04817822}, {386,0.04887129}, {387,0.04829703}, {388,0.05174257}, {389,0.05583168}, {390,0.05997030}, {391,0.06248515}, {392,0.06433663}, {393,0.04952475}, {394,0.04946535}, {395,0.04998020}, {396,0.04985149}, {397,0.04953465}, {398,0.04986139}, {399,0.04991089}, {400,0.05009901}, {401,0.04980198}, {402,0.04974257}, {403,0.05060396}, {404,0.05025743}, {405,0.05103960}, {406,0.05078218}, {407,0.05123762}, {408,0.05036634}, {409,0.06498020}, {410,0.06407921}, {411,0.06205941}, {412,0.05886139}, {413,0.05600000}, {414,0.05285149}, {415,0.05220792}, {416,0.05145545}, {417,0.07469307}, {418,0.06700990}, {419,0.05985149}, {420,0.05442574}, {421,0.05265347}, {422,0.07261386}, {423,0.06543564}, {424,0.05853465}, {425,0.05314851}, {426,0.05349505}, {427,0.06525743}, {428,0.05843564}, {429,0.05359406}, {430,0.07019802}, {431,0.06292079}, {432,0.05360396}, {433,0.05437624}, {434,0.06869307}, {435,0.05601980}, {436,0.05478218}, {437,0.06466337}, {438,0.05455446}, {439,0.07270297}, {440,0.06013861}, {441,0.05476238}, {442,0.06580198}, {443,0.05547525}, {444,0.06872277}, {445,0.05790099}, {446,0.07161386}, {447,0.06021782}, {448,0.07303960}, {449,0.06165347}, {450,0.05571287}, {451,0.06674257}, {452,0.05611881}, {453,0.06565347}, {454,0.05718812}, {455,0.06294059}, {456,0.07342574}, {457,0.06023762}, {458,0.07246535}, {459,0.05732673}, {460,0.06721782}, {461,0.05745545}, {462,0.06220792}, {463,0.07270297}, {464,0.05792079}, {465,0.06647525}, {466,0.07318812}, {467,0.05840594}, {468,0.07148515}, {469,0.07862376}, {470,0.05898020}, {471,0.06838614}, {472,0.07494059}, {473,0.05961386}, {474,0.06313861}, {475,0.07053465}, {476,0.07669307}, {477,0.06055446}, {478,0.06288119}, {479,0.06927723}, {480,0.07258416}, {481,0.06022772}, {482,0.06049505}, {483,0.06579208}, {484,0.07085149}, {485,0.07571287}, {486,0.07889109}, {487,0.06107921}, {488,0.06098020}, {489,0.06334653}, {490,0.06667327}, {491,0.06991089}, {492,0.07235644}, {493,0.07265347}, {494,0.08363366}, {495,0.08282178}, {496,0.08108911}, {497,0.08277228}, {498,0.08404950}, {499,0.06455446}, {500,0.06238614}, {505,0.06396040}, {510,0.08325743}, {515,0.08141584}, {520,0.07800990}, {525,0.07501980}, {530,0.06901980}, {535,0.09639604}, {540,0.08275248}, {545,0.07248515}, {550,0.08662376}, {555,0.07588119}, {560,0.08674257}, {565,0.07400000}, {570,0.08305941}, {575,0.09232673}, {580,0.07324752}, {585,0.08369307}, {590,0.08638614}, {595,0.09034653}, {600,0.09219802}, {605,0.09302970}, {610,0.09131683}, {615,0.08996040}, {620,0.08761386}, {625,0.08656436}, {630,0.11513861}, {635,0.09940594}, {640,0.08920792}, {645,0.10808911}, {650,0.09569307}, {655,0.08585149}, {660,0.09670297}, {665,0.10203960}, {670,0.09579208}, {675,0.10440594}, {680,0.11108911}, {685,0.09232673}, {690,0.09630693}, {695,0.10021782}, {700,0.10190099}, {705,0.10556436}, {710,0.10597030}, {715,0.10397030}, {720,0.10051485}, {725,0.09779208}, {730,0.11751485}, {735,0.12060396}, {740,0.10483168}, {745,0.12176238}, {750,0.11066337}, {755,0.12374257}, {760,0.11067327}, {765,0.13455446}, {770,0.10867327}, {775,0.11812871}, {780,0.12397030}, {785,0.10619802}, {790,0.10868317}, {795,0.11893069}, {800,0.11795050}, {805,0.12136634}, {810,0.12130693}, {815,0.12023762}, {820,0.12508911}, {825,0.11693069}, {830,0.13816832}, {835,0.12797030}, {840,0.12084158}, {845,0.15318812}, {850,0.13174257}, {855,0.12006931}, {860,0.13042574}, {865,0.14141584}, {870,0.13139604}, {875,0.14128713}, {880,0.14549505}, {885,0.12687129}, {890,0.12679208}, {895,0.14003960}, {900,0.13871287}, {905,0.13799010}, {910,0.13871287}, {915,0.13226733}, {920,0.13925743}, {925,0.13588119}, {930,0.12916832}, {935,0.14742574}, {940,0.15108911}, {945,0.13687129}, {950,0.14962376}, {955,0.13784158}, {960,0.14356436}, {965,0.14133663}, {970,0.15079208}, {975,0.15698020}, {980,0.14061386}, {985,0.15139604}, {990,0.15602970}, {995,0.15635644}, {1000,0.15913861}, {1010,0.16869307}, {1020,0.16506931}, {1030,0.15893069}, {1040,0.16876238}, {1050,0.15233663}, {1060,0.16518812}, {1070,0.15352475}, {1080,0.16803960}, {1090,0.17522772}, {1100,0.17641584}, {1110,0.20076238}, {1120,0.17675248}, {1130,0.17819802}, {1140,0.17425743}, {1150,0.17181188}, {1160,0.18578218}, {1170,0.17052475}, {1180,0.18826733}, {1190,0.19175248}, {1200,0.19345545}, {1210,0.17749505}, {1220,0.17610891}, {1230,0.19673267}, {1240,0.19812871}, {1250,0.18790099}, {1260,0.20074257}, {1270,0.19535644}, {1280,0.19710891}, {1290,0.20151485}, {1300,0.18886139}, {1310,0.19360396}, {1320,0.20651485}, {1330,0.19659406}, {1340,0.21229703}, {1350,0.21260396}, {1360,0.19810891}, {1370,0.22157426}, {1380,0.21542574}, {1390,0.20544554}, {1400,0.22033663}, {1410,0.21503960}, {1420,0.21326733}, {1430,0.21752475}, {1440,0.20888119}, {1450,0.23591089}, {1460,0.22004950}, {1470,0.24345545}, {1480,0.22090099}, {1490,0.22574257}, {1500,0.24006931}, {1510,0.23299010}, {1520,0.24361386}, {1530,0.23751485}, {1540,0.23803960}, {1550,0.22899010}, {1560,0.23999010}, {1570,0.22818812}, {1580,0.24247525}, {1590,0.26105941}, {1600,0.23168317}, {1610,0.24536634}, {1620,0.23924752}, {1630,0.24672277}, {1640,0.25610891}, {1650,0.26138614}, {1660,0.24533663}, {1670,0.26509901}, {1680,0.24552475}, {1690,0.26257426}, {1700,0.25989109}, {1710,0.27442574}, {1720,0.26478218}, {1730,0.27263366}, {1740,0.26063366}, {1750,0.25510891}, {1760,0.26964356}, {1770,0.26351485}, {1780,0.27265347}, {1790,0.28769307}, {1800,0.30611881}, {1810,0.26843564}, {1820,0.28694059}, {1830,0.29249505}, {1840,0.29698020}, {1850,0.28294059}, {1860,0.28478218}, {1870,0.28971287}, {1880,0.28407921}, {1890,0.31390099}, {1900,0.29217822}, {1910,0.30663366}, {1920,0.29621782}, {1930,0.30528713}, {1940,0.32303960}, {1950,0.29097030}, {1960,0.31490099}, {1970,0.29557426}, {1980,0.31101980}, {1990,0.33639604}, {2000,0.29642574}, {2050,0.31526733}, {2100,0.32813861}, {2150,0.33949505}, {2200,0.34725743}, {2250,0.34597030}, {2300,0.34776238}, {2350,0.36214851}, {2400,0.40623762}, {2450,0.38331683}, {2500,0.38306931}, {2550,0.40194059}, {2600,0.42467327}, {2650,0.41452475}, {2700,0.45648515}, {2750,0.44028713}, {2800,0.43044554}, {2850,0.44222772}, {2900,0.46681188}, {2950,0.44933663}, {3000,0.47788119}, {3050,0.48464356}, {3100,0.48333663}, {3150,0.49688119}, {3200,0.52151485}, {3250,0.51314851}, {3300,0.53307921}, {3350,0.54398020}, {3400,0.53919802}, {3450,0.55577228}, {3500,0.55264356}, {3550,0.56334653}, {3600,0.57897030}, {3650,0.56702970}, {3700,0.58566337}, {3750,0.61011881}, {3800,0.62944554}, {3850,0.62997030}, {3900,0.61941584}, {3950,0.62843564}, {4000,0.63909901}, {4050,0.65096040}, {4100,0.67064356}, {4150,0.65386139}, {4200,0.67231683}, {4250,0.69142574}, {4300,0.70081188}, {4350,0.70385149}, {4400,0.70166337}, {4450,0.73655446}, {4500,0.70858416}, {4550,0.72616832}, {4600,0.76021782}, {4650,0.72897030}, {4700,0.77807921}, {4750,0.76856436}, {4800,0.76937624}, {4850,0.78427723}, {4900,0.78830693}, {4950,0.79856436}, {5000,0.80285149}, {5050,0.81334653}, {5100,0.84218812}, {5150,0.84270297}, {5200,0.85643564}, {5250,0.85416832}, {5300,0.87900990}, {5350,0.87675248}, {5400,0.86994059}, {5450,0.90122772}, {5500,0.89113861}, {5550,0.89896040}, {5600,0.90791089}, {5650,0.89789109}, {5700,0.90625743}, {5750,0.94082178}, {5800,0.94428713}, {5850,0.93796040}, {5900,0.95569307}, {5950,0.97900000}, {6000,0.98362376}, {6050,1.0162857}, {6100,1.0140857}, {6150,1.0413143}, {6200,1.0492857}, {6250,1.0666286}, {6300,1.0678571}, {6350,1.1058286}, {6400,1.0925429}, {6450,1.0966286}, {6500,1.0825714}, {6550,1.0856000}, {6600,1.0879143}, {6650,1.0991429}, {6700,1.1012000}, {6750,1.1177143}, {6800,1.1385714}, {6850,1.1280857}, {6900,1.1361429}, {6950,1.1475143}, {7000,1.1721429}, {7050,1.1872571}, {7100,1.2266857}, {7150,1.2401714}, {7200,1.2368571}, {7250,1.2431143}, {7300,1.2482000}, {7350,1.2503429}, {7400,1.2556857}, {7450,1.2638000}, {7500,1.2506571}, {7550,1.2496857}, {7600,1.2777143}, {7650,1.2935429}, {7700,1.3436286}, {7750,1.3169143}, {7800,1.3393143}, {7850,1.3247714}, {7900,1.3219143}, {7950,1.3760286}, {8000,1.3708571}, {8050,1.3793714}, {8100,1.3694857}, {8150,1.3620571}, {8200,1.3953714}, {8250,1.4258571}, {8300,1.4050000}, {8350,1.4058286}, {8400,1.3948571}, {8450,1.4526857}, {8500,1.4519143}, {8550,1.4553429}, {8600,1.4481714}, {8650,1.5234000}, {8700,1.4844857}, {8750,1.4617429}, {8800,1.5070000}, {8850,1.5094286}, {8900,1.4756000}, {8950,1.5693143}, {9000,1.5258571}, {9050,1.5142571}, {9100,1.5554571}, {9150,1.5634857}, {9200,1.5354857}, {9250,1.6029429}, {9300,1.5922000}, {9350,1.5920857}, {9400,1.6182857}, {9450,1.5877429}, {9500,1.6461143}, {9550,1.6196000}, {9600,1.6653143}, {9650,1.6401143}, {9700,1.6383714}, {9750,1.6822571}, {9800,1.6379429}, {9850,1.6949429}, {9900,1.6850000}, {9950,1.7088857}, {10000,1.6796571}, {10100,1.7349143}, {10200,1.7454571}, {10300,1.7665429}, {10400,1.7314000}, {10500,1.8028857}, {10600,1.7436286}, {10700,1.8329143}, {10800,1.8097714}, {10900,1.8552000}, {11000,1.8409429}, {11100,1.9130286}, {11200,1.8816857}, {11300,1.9181143}, {11400,1.9154571}, {11500,1.9455714}, {11600,1.9776286}, {11700,1.9703714}, {11800,2.0193143}, {11900,2.0230857}, {12000,2.0303714}, {12100,2.0495714}, {12200,2.0632000}, {12300,2.0619714}, {12400,2.1174000}, {12500,2.1127429}, {12600,2.1251429}, {12700,2.1492857}, {12800,2.1436571}, {12900,2.1855143}, {13000,2.1657429}, {13100,2.2063143}, {13200,2.2372857}, {13300,2.2425714}, {13400,2.2718857}, {13500,2.2780571}, {13600,2.2914857}, {13700,2.3151714}, {13800,2.3252571}, {13900,2.3625143}, {14000,2.3504857}, {14100,2.3771429}, {14200,2.4061143}, {14300,2.4022571}, {14400,2.4376571}, {14500,2.4596000}, {14600,2.6094000}, {14700,2.4883429}, {14800,2.4990000}, {14900,2.5241714}, {15000,2.5364857}, {15100,2.5393714}, {15200,2.8350000}, {15300,2.6575714}, {15400,2.6008857}, {15500,2.6027429}, {15600,2.7026571}, {15700,2.7278286}, {15800,2.6524000}, {15900,2.6962286}, {16000,2.6897714}, {16100,2.7030000}, {16200,2.7116571}, {16300,2.8298000}, {16400,2.7126000}, {16500,2.8284571}, {16600,3.0842000}, {16700,2.8037143}, {16800,2.9204000}, {16900,2.8340857}, {17000,2.9987714}, {17100,2.8857714}, {17200,2.9988286}, {17300,2.9054857}, {17400,2.9210286}, {17500,3.1161143}, {17600,2.9333143}, {17700,2.9974857}, {17800,3.0546857}, {17900,3.1016286}, {18000,3.0270286}, {18100,3.0456857}, {18200,3.0652571}, {18300,3.0994571}, {18400,3.0985714}, {18500,3.1766857}, {18600,3.1313143}, {18700,3.1325143}, {18800,3.1627714}, {18900,3.2109714}, {19000,3.2030571}, {19100,3.2097429}, {19200,3.2433429}, {19300,3.3289429}, {19400,3.3389714}, {19500,3.2838571}, {19600,3.3006857}, {19700,3.4830000}, {19800,3.3380571}, {19900,3.5262571}, {20000,3.5598857}};
data["big_flat"]["LtacTCPrimPair"]["actual reif"]["system"] = {{1,0.00006931}, {2,0.00000000}, {3,0.00000000}, {4,0.00003960}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00003960}, {10,0.00000000}, {11,0.00003960}, {12,0.00000000}, {13,0.00000000}, {14,0.00007921}, {15,0.00000000}, {16,0.00003960}, {17,0.00002970}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00003960}, {23,0.00000000}, {24,0.00006931}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00006931}, {30,0.00000000}, {31,0.00003960}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00003960}, {37,0.00017822}, {38,0.00000000}, {39,0.00000000}, {40,0.00003960}, {41,0.00003960}, {42,0.00000000}, {43,0.00002970}, {44,0.00007921}, {45,0.00003960}, {46,0.00003960}, {47,0.00003960}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00002970}, {57,0.00003960}, {58,0.00007921}, {59,0.00006931}, {60,0.00000000}, {61,0.00000000}, {62,0.00003960}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00002970}, {68,0.00000000}, {69,0.00000000}, {70,0.00003960}, {71,0.00007921}, {72,0.00000000}, {73,0.00000000}, {74,0.00003960}, {75,0.00007921}, {76,0.00003960}, {77,0.00000000}, {78,0.00000000}, {79,0.00003960}, {80,0.00007921}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00006931}, {86,0.00000000}, {87,0.00000000}, {88,0.00015842}, {89,0.00000000}, {90,0.00003960}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00003960}, {95,0.00007921}, {96,0.00002970}, {97,0.00000000}, {98,0.00003960}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00007921}, {105,0.00003960}, {106,0.00000000}, {107,0.00003960}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00003960}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00019802}, {119,0.00003960}, {120,0.00003960}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00003960}, {126,0.00003960}, {127,0.00003960}, {128,0.00013861}, {129,0.00019802}, {130,0.00000000}, {131,0.00000000}, {132,0.00010891}, {133,0.00000000}, {134,0.00003960}, {135,0.00013861}, {136,0.00006931}, {137,0.00000000}, {138,0.00003960}, {139,0.00000000}, {140,0.00011881}, {141,0.00000000}, {142,0.00009901}, {143,0.00003960}, {144,0.00007921}, {145,0.00000000}, {146,0.00003960}, {147,0.00006931}, {148,0.00003960}, {149,0.00000000}, {150,0.00003960}, {151,0.00002970}, {152,0.00007921}, {153,0.00000000}, {154,0.00003960}, {155,0.00000000}, {156,0.00000000}, {157,0.00003960}, {158,0.00000000}, {159,0.00014851}, {160,0.00002970}, {161,0.00000000}, {162,0.00011881}, {163,0.00000000}, {164,0.00003960}, {165,0.00014851}, {166,0.00000000}, {167,0.00002970}, {168,0.00003960}, {169,0.00005941}, {170,0.00000000}, {171,0.00003960}, {172,0.00003960}, {173,0.00000000}, {174,0.00000000}, {175,0.00003960}, {176,0.00011881}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00011881}, {182,0.00007921}, {183,0.00000000}, {184,0.00000000}, {185,0.00003960}, {186,0.00003960}, {187,0.00003960}, {188,0.00003960}, {189,0.00013861}, {190,0.00007921}, {191,0.00000000}, {192,0.00000000}, {193,0.00003960}, {194,0.00000000}, {195,0.00000000}, {196,0.00003960}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00003960}, {203,0.00000000}, {204,0.00011881}, {205,0.00000000}, {206,0.00015842}, {207,0.00010891}, {208,0.00019802}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00003960}, {214,0.00022772}, {215,0.00002970}, {216,0.00000000}, {217,0.00006931}, {218,0.00000000}, {219,0.00000000}, {220,0.00009901}, {221,0.00003960}, {222,0.00000000}, {223,0.00000000}, {224,0.00014851}, {225,0.00000000}, {226,0.00000000}, {227,0.00006931}, {228,0.00006931}, {229,0.00003960}, {230,0.00000000}, {231,0.00013861}, {232,0.00003960}, {233,0.00000000}, {234,0.00015842}, {235,0.00000000}, {236,0.00000000}, {237,0.00015842}, {238,0.00003960}, {239,0.00015842}, {240,0.00003960}, {241,0.00000000}, {242,0.00000000}, {243,0.00003960}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00003960}, {249,0.00000000}, {250,0.00011881}, {251,0.00000000}, {252,0.00003960}, {253,0.00000000}, {254,0.00003960}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00002970}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00006931}, {266,0.00003960}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00003960}, {274,0.00000000}, {275,0.00002970}, {276,0.00003960}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003960}, {282,0.00000000}, {283,0.00003960}, {284,0.00003960}, {285,0.00000000}, {286,0.00000000}, {287,0.00006931}, {288,0.00000000}, {289,0.00003960}, {290,0.00003960}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00003960}, {295,0.00003960}, {296,0.00000000}, {297,0.00000000}, {298,0.00003960}, {299,0.00000000}, {300,0.00000000}, {301,0.00002970}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00003960}, {306,0.00000000}, {307,0.00000000}, {308,0.00003960}, {309,0.00006931}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00003960}, {316,0.00000000}, {317,0.00000000}, {318,0.00003960}, {319,0.00003960}, {320,0.00003960}, {321,0.00006931}, {322,0.00007921}, {323,0.00000000}, {324,0.00003960}, {325,0.00003960}, {326,0.00000000}, {327,0.00003960}, {328,0.00003960}, {329,0.00000000}, {330,0.00000000}, {331,0.00003960}, {332,0.00000000}, {333,0.00003960}, {334,0.00000000}, {335,0.00003960}, {336,0.00002970}, {337,0.00003960}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00003960}, {343,0.00000000}, {344,0.00003960}, {345,0.00003960}, {346,0.00000000}, {347,0.00000000}, {348,0.00030693}, {349,0.00000000}, {350,0.00037624}, {351,0.00000000}, {352,0.00014851}, {353,0.00000000}, {354,0.00015842}, {355,0.00003960}, {356,0.00000000}, {357,0.00000000}, {358,0.00006931}, {359,0.00009901}, {360,0.00000000}, {361,0.00003960}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00003960}, {366,0.00000000}, {367,0.00027723}, {368,0.00000000}, {369,0.00000000}, {370,0.00019802}, {371,0.00000000}, {372,0.00007921}, {373,0.00002970}, {374,0.00000000}, {375,0.00000000}, {376,0.00003960}, {377,0.00000000}, {378,0.00007921}, {379,0.00000000}, {380,0.00003960}, {381,0.00000000}, {382,0.00000000}, {383,0.00007921}, {384,0.00000000}, {385,0.00003960}, {386,0.00003960}, {387,0.00000000}, {388,0.00007921}, {389,0.00000000}, {390,0.00003960}, {391,0.00000000}, {392,0.00003960}, {393,0.00000000}, {394,0.00003960}, {395,0.00000000}, {396,0.00000000}, {397,0.00003960}, {398,0.00000000}, {399,0.00000000}, {400,0.00003960}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00003960}, {408,0.00007921}, {409,0.00003960}, {410,0.00000000}, {411,0.00000000}, {412,0.00003960}, {413,0.00003960}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00003960}, {426,0.00000000}, {427,0.00003960}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00003960}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00011881}, {444,0.00000000}, {445,0.00003960}, {446,0.00003960}, {447,0.00000000}, {448,0.00007921}, {449,0.00000000}, {450,0.00003960}, {451,0.00006931}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00003960}, {457,0.00003960}, {458,0.00003960}, {459,0.00003960}, {460,0.00000000}, {461,0.00003960}, {462,0.00000000}, {463,0.00002970}, {464,0.00000000}, {465,0.00003960}, {466,0.00000000}, {467,0.00000000}, {468,0.00003960}, {469,0.00003960}, {470,0.00003960}, {471,0.00003960}, {472,0.00011881}, {473,0.00000000}, {474,0.00007921}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00003960}, {479,0.00000000}, {480,0.00003960}, {481,0.00007921}, {482,0.00002970}, {483,0.00003960}, {484,0.00000000}, {485,0.00000000}, {486,0.00003960}, {487,0.00011881}, {488,0.00000000}, {489,0.00003960}, {490,0.00000000}, {491,0.00000000}, {492,0.00003960}, {493,0.00003960}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00003960}, {500,0.00006931}, {505,0.00003960}, {510,0.00011881}, {515,0.00000000}, {520,0.00002970}, {525,0.00000000}, {530,0.00003960}, {535,0.00003960}, {540,0.00003960}, {545,0.00000000}, {550,0.00007921}, {555,0.00000000}, {560,0.00003960}, {565,0.00003960}, {570,0.00003960}, {575,0.00011881}, {580,0.00003960}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00003960}, {620,0.00003960}, {625,0.00003960}, {630,0.00000000}, {635,0.00003960}, {640,0.00000000}, {645,0.00002970}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00003960}, {670,0.00000000}, {675,0.00000000}, {680,0.00007921}, {685,0.00000000}, {690,0.00000000}, {695,0.00003960}, {700,0.00003960}, {705,0.00000000}, {710,0.00003960}, {715,0.00003960}, {720,0.00000000}, {725,0.00003960}, {730,0.00007921}, {735,0.00003960}, {740,0.00003960}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00007921}, {780,0.00003960}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00003960}, {805,0.00000000}, {810,0.00003960}, {815,0.00000000}, {820,0.00003960}, {825,0.00000000}, {830,0.00003960}, {835,0.00010891}, {840,0.00007921}, {845,0.00000000}, {850,0.00000000}, {855,0.00007921}, {860,0.00003960}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00007921}, {885,0.00007921}, {890,0.00003960}, {895,0.00000000}, {900,0.00003960}, {905,0.00003960}, {910,0.00006931}, {915,0.00000000}, {920,0.00000000}, {925,0.00003960}, {930,0.00007921}, {935,0.00000000}, {940,0.00000000}, {945,0.00003960}, {950,0.00000000}, {955,0.00007921}, {960,0.00003960}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00003960}, {985,0.00007921}, {990,0.00007921}, {995,0.00000000}, {1000,0.00003960}, {1010,0.00003960}, {1020,0.00000000}, {1030,0.00003960}, {1040,0.00003960}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00007921}, {1090,0.00000000}, {1100,0.00007921}, {1110,0.00007921}, {1120,0.00003960}, {1130,0.00007921}, {1140,0.00003960}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00007921}, {1190,0.00002970}, {1200,0.00000000}, {1210,0.00003960}, {1220,0.00003960}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00003960}, {1270,0.00000000}, {1280,0.00003960}, {1290,0.00003960}, {1300,0.00007921}, {1310,0.00000000}, {1320,0.00003960}, {1330,0.00000000}, {1340,0.00007921}, {1350,0.00007921}, {1360,0.00003960}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00011881}, {1400,0.00003960}, {1410,0.00000000}, {1420,0.00007921}, {1430,0.00014851}, {1440,0.00011881}, {1450,0.00000000}, {1460,0.00003960}, {1470,0.00003960}, {1480,0.00003960}, {1490,0.00003960}, {1500,0.00003960}, {1510,0.00003960}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00003960}, {1570,0.00000000}, {1580,0.00006931}, {1590,0.00011881}, {1600,0.00011881}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00002970}, {1650,0.00010891}, {1660,0.00003960}, {1670,0.00003960}, {1680,0.00003960}, {1690,0.00003960}, {1700,0.00007921}, {1710,0.00011881}, {1720,0.00007921}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00003960}, {1760,0.00007921}, {1770,0.00000000}, {1780,0.00023762}, {1790,0.00003960}, {1800,0.00003960}, {1810,0.00003960}, {1820,0.00003960}, {1830,0.00002970}, {1840,0.00000000}, {1850,0.00003960}, {1860,0.00011881}, {1870,0.00003960}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00003960}, {1920,0.00007921}, {1930,0.00003960}, {1940,0.00003960}, {1950,0.00003960}, {1960,0.00000000}, {1970,0.00007921}, {1980,0.00007921}, {1990,0.00000000}, {2000,0.00002970}, {2050,0.00011881}, {2100,0.00003960}, {2150,0.00000000}, {2200,0.00003960}, {2250,0.00000000}, {2300,0.00003960}, {2350,0.00003960}, {2400,0.00015842}, {2450,0.00011881}, {2500,0.00003960}, {2550,0.00000000}, {2600,0.00007921}, {2650,0.00000000}, {2700,0.00006931}, {2750,0.00003960}, {2800,0.00003960}, {2850,0.00306931}, {2900,0.00003960}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00010891}, {3100,0.00007921}, {3150,0.00018812}, {3200,0.00003960}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00003960}, {3400,0.00000000}, {3450,0.00003960}, {3500,0.00000000}, {3550,0.00007921}, {3600,0.00007921}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00007921}, {3800,0.00015842}, {3850,0.00007921}, {3900,0.00007921}, {3950,0.00007921}, {4000,0.00003960}, {4050,0.00011881}, {4100,0.00006931}, {4150,0.00007921}, {4200,0.00011881}, {4250,0.00003960}, {4300,0.00007921}, {4350,0.00000000}, {4400,0.00007921}, {4450,0.00000000}, {4500,0.00018812}, {4550,0.00007921}, {4600,0.00003960}, {4650,0.00007921}, {4700,0.00011881}, {4750,0.00006931}, {4800,0.00007921}, {4850,0.00027723}, {4900,0.00007921}, {4950,0.00000000}, {5000,0.00038614}, {5050,0.00031683}, {5100,0.00000000}, {5150,0.00003960}, {5200,0.00038614}, {5250,0.00066337}, {5300,0.00019802}, {5350,0.00007921}, {5400,0.00015842}, {5450,0.00007921}, {5500,0.00003960}, {5550,0.00003960}, {5600,0.00015842}, {5650,0.00000000}, {5700,0.00015842}, {5750,0.00003960}, {5800,0.00003960}, {5850,0.00031683}, {5900,0.00027723}, {5950,0.00015842}, {6000,0.00000000}, {6050,0.0063429}, {6100,0.0050286}, {6150,0.0001143}, {6200,0.0001143}, {6250,0.0000857}, {6300,0.0004286}, {6350,0.0001143}, {6400,0.0002286}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0002286}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0002286}, {6900,0.0000000}, {6950,0.0000857}, {7000,0.0001143}, {7050,0.0000000}, {7100,0.0001143}, {7150,0.0001143}, {7200,0.0001143}, {7250,0.0003429}, {7300,0.0000000}, {7350,0.0001143}, {7400,0.0000000}, {7450,0.0000857}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0001143}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0001143}, {8000,0.0002286}, {8050,0.0003429}, {8100,0.0003429}, {8150,0.0000000}, {8200,0.0003429}, {8250,0.0005714}, {8300,0.0002286}, {8350,0.0000000}, {8400,0.0004571}, {8450,0.0002857}, {8500,0.0001143}, {8550,0.0001143}, {8600,0.0003429}, {8650,0.0001143}, {8700,0.0001143}, {8750,0.0001143}, {8800,0.0000000}, {8850,0.0002286}, {8900,0.0003429}, {8950,0.0001143}, {9000,0.0001143}, {9050,0.0001143}, {9100,0.0003143}, {9150,0.0003429}, {9200,0.0002286}, {9250,0.0001143}, {9300,0.0003429}, {9350,0.0001143}, {9400,0.0001143}, {9450,0.0001143}, {9500,0.0004571}, {9550,0.0002286}, {9600,0.0004571}, {9650,0.0002286}, {9700,0.0001143}, {9750,0.0003429}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0001143}, {10000,0.0001143}, {10100,0.0003429}, {10200,0.0002286}, {10300,0.0002286}, {10400,0.0001143}, {10500,0.0000000}, {10600,0.0002286}, {10700,0.0001143}, {10800,0.0000000}, {10900,0.0002286}, {11000,0.0000000}, {11100,0.0003429}, {11200,0.0002286}, {11300,0.0000000}, {11400,0.0002286}, {11500,0.0001143}, {11600,0.0002286}, {11700,0.0005714}, {11800,0.0006857}, {11900,0.0010286}, {12000,0.0002286}, {12100,0.0001143}, {12200,0.0000000}, {12300,0.0001143}, {12400,0.0003429}, {12500,0.0002286}, {12600,0.0000000}, {12700,0.0002286}, {12800,0.0002286}, {12900,0.0004571}, {13000,0.0000857}, {13100,0.0002286}, {13200,0.0001143}, {13300,0.0006857}, {13400,0.0004286}, {13500,0.0002286}, {13600,0.0001143}, {13700,0.0001143}, {13800,0.0001143}, {13900,0.0000000}, {14000,0.0001143}, {14100,0.0001143}, {14200,0.0002286}, {14300,0.0001143}, {14400,0.0000000}, {14500,0.0001143}, {14600,0.0000000}, {14700,0.0002286}, {14800,0.0015714}, {14900,0.0011429}, {15000,0.0002000}, {15100,0.0001143}, {15200,0.0003429}, {15300,0.0000000}, {15400,0.0004571}, {15500,0.0008000}, {15600,0.0004571}, {15700,0.0008000}, {15800,0.0004571}, {15900,0.0002286}, {16000,0.0005714}, {16100,0.0003429}, {16200,0.0000000}, {16300,0.0003429}, {16400,0.0006857}, {16500,0.0006857}, {16600,0.0005714}, {16700,0.0012571}, {16800,0.0011429}, {16900,0.0000000}, {17000,0.0003429}, {17100,0.0005714}, {17200,0.0009143}, {17300,0.0001143}, {17400,0.0002286}, {17500,0.0001143}, {17600,0.0002286}, {17700,0.0005429}, {17800,0.0000000}, {17900,0.0004571}, {18000,0.0005714}, {18100,0.0004571}, {18200,0.0012286}, {18300,0.0002286}, {18400,0.0002286}, {18500,0.0011143}, {18600,0.0008000}, {18700,0.0012571}, {18800,0.0001143}, {18900,0.0001143}, {19000,0.0009714}, {19100,0.0001143}, {19200,0.0004571}, {19300,0.0004571}, {19400,0.0004571}, {19500,0.0011429}, {19600,0.0019143}, {19700,0.0005714}, {19800,0.0019143}, {19900,0.0012571}, {20000,0.0019429}};
data["big_flat"]["LtacTCPrimPair"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00085149}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000990}, {411,0.00000000}, {412,0.00000000}, {413,0.00000990}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000990}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000990}, {425,0.00000000}, {426,0.00000000}, {427,0.00001980}, {428,0.00000000}, {429,0.00000000}, {430,0.00000990}, {431,0.00000000}, {432,0.00000000}, {433,0.00000990}, {434,0.00000990}, {435,0.00001980}, {436,0.00000000}, {437,0.00000000}, {438,0.00000990}, {439,0.00001980}, {440,0.00002970}, {441,0.00000990}, {442,0.00001980}, {443,0.00000000}, {444,0.00000990}, {445,0.00000000}, {446,0.00000990}, {447,0.00000990}, {448,0.00000990}, {449,0.00003960}, {450,0.00003960}, {451,0.00007921}, {452,0.00011881}, {453,0.00007921}, {454,0.00012871}, {455,0.00012871}, {456,0.00018812}, {457,0.00021782}, {458,0.00025743}, {459,0.00024752}, {460,0.00017822}, {461,0.00034653}, {462,0.00031683}, {463,0.00044554}, {464,0.00055446}, {465,0.00047525}, {466,0.00053465}, {467,0.00187129}, {468,0.00056436}, {469,0.00060396}, {470,0.00061386}, {471,0.00059406}, {472,0.00063366}, {473,0.00068317}, {474,0.00062376}, {475,0.00066337}, {476,0.00067327}, {477,0.00066337}, {478,0.00066337}, {479,0.00068317}, {480,0.00077228}, {481,0.00076238}, {482,0.00079208}, {483,0.00075248}, {484,0.00084158}, {485,0.00077228}, {486,0.00080198}, {487,0.00083168}, {488,0.00087129}, {489,0.00087129}, {490,0.00094059}, {491,0.00091089}, {492,0.00086139}, {493,0.00093069}, {494,0.00095050}, {495,0.00093069}, {496,0.00096040}, {497,0.00100000}, {498,0.00096040}, {499,0.00094059}, {500,0.00097030}, {505,0.00099010}, {510,0.00100000}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00100000}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00309901}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00376238}, {770,0.00100000}, {775,0.00100000}, {780,0.00316832}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00100000}, {830,0.00100000}, {835,0.00100000}, {840,0.00100000}, {845,0.00100000}, {850,0.00100000}, {855,0.00100990}, {860,0.00100990}, {865,0.00100000}, {870,0.00100000}, {875,0.00100990}, {880,0.00101980}, {885,0.00103960}, {890,0.00102970}, {895,0.00103960}, {900,0.00105941}, {905,0.00102970}, {910,0.00102970}, {915,0.00106931}, {920,0.00104950}, {925,0.00105941}, {930,0.00111881}, {935,0.00121782}, {940,0.00137624}, {945,0.00149505}, {950,0.00156436}, {955,0.00163366}, {960,0.00156436}, {965,0.00164356}, {970,0.00160396}, {975,0.00168317}, {980,0.00172277}, {985,0.00410891}, {990,0.00184158}, {995,0.00194059}, {1000,0.00195050}, {1010,0.00197030}, {1020,0.00196040}, {1030,0.00199010}, {1040,0.00200000}, {1050,0.00200000}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200000}, {1140,0.00200000}, {1150,0.00200000}, {1160,0.00200000}, {1170,0.00415842}, {1180,0.00200000}, {1190,0.00200000}, {1200,0.00200000}, {1210,0.00200000}, {1220,0.00200000}, {1230,0.00200000}, {1240,0.00200000}, {1250,0.00200000}, {1260,0.00200000}, {1270,0.00200000}, {1280,0.00200000}, {1290,0.00200000}, {1300,0.00200000}, {1310,0.00200000}, {1320,0.00200000}, {1330,0.00200990}, {1340,0.00200990}, {1350,0.00200990}, {1360,0.00202970}, {1370,0.00204950}, {1380,0.00205941}, {1390,0.00213861}, {1400,0.00215842}, {1410,0.00233663}, {1420,0.00233663}, {1430,0.00239604}, {1440,0.00245545}, {1450,0.00252475}, {1460,0.00252475}, {1470,0.00256436}, {1480,0.00271287}, {1490,0.00285149}, {1500,0.00288119}, {1510,0.00500990}, {1520,0.00641584}, {1530,0.00299010}, {1540,0.00299010}, {1550,0.00300000}, {1560,0.00605941}, {1570,0.00300000}, {1580,0.00452475}, {1590,0.00300000}, {1600,0.00300000}, {1610,0.00300000}, {1620,0.00300000}, {1630,0.00300000}, {1640,0.00300000}, {1650,0.00300000}, {1660,0.00300000}, {1670,0.00300000}, {1680,0.00300000}, {1690,0.00300000}, {1700,0.00300000}, {1710,0.00300000}, {1720,0.00300000}, {1730,0.00300000}, {1740,0.00624752}, {1750,0.00300000}, {1760,0.00300990}, {1770,0.00300000}, {1780,0.00300990}, {1790,0.00302970}, {1800,0.00303960}, {1810,0.00302970}, {1820,0.00304950}, {1830,0.00307921}, {1840,0.00308911}, {1850,0.00314851}, {1860,0.00317822}, {1870,0.00334653}, {1880,0.00343564}, {1890,0.00343564}, {1900,0.00346535}, {1910,0.00345545}, {1920,0.00352475}, {1930,0.00354455}, {1940,0.00357426}, {1950,0.00357426}, {1960,0.00371287}, {1970,0.00379208}, {1980,0.00386139}, {1990,0.00394059}, {2000,0.00400000}, {2050,0.00400000}, {2100,0.00769307}, {2150,0.00400000}, {2200,0.00401980}, {2250,0.00405941}, {2300,0.00420792}, {2350,0.00441584}, {2400,0.00460396}, {2450,0.00491089}, {2500,0.00500000}, {2550,0.00500000}, {2600,0.00500000}, {2650,0.00503960}, {2700,0.00508911}, {2750,0.00513861}, {2800,0.00554455}, {2850,0.00556436}, {2900,0.00586139}, {2950,0.00600000}, {3000,0.00600990}, {3050,0.00601980}, {3100,0.01292079}, {3150,0.00614851}, {3200,0.00623762}, {3250,0.00656436}, {3300,0.00661386}, {3350,0.00679208}, {3400,0.00699010}, {3450,0.00701980}, {3500,0.00704950}, {3550,0.00710891}, {3600,0.00713861}, {3650,0.00734653}, {3700,0.00759406}, {3750,0.00760396}, {3800,0.00769307}, {3850,0.00792079}, {3900,0.00804950}, {3950,0.00808911}, {4000,0.00808911}, {4050,0.00815842}, {4100,0.01900000}, {4150,0.00865347}, {4200,0.00865347}, {4250,0.00873267}, {4300,0.00895050}, {4350,0.00905941}, {4400,0.01480198}, {4450,0.00920792}, {4500,0.01492079}, {4550,0.00953465}, {4600,0.01995050}, {4650,0.00968317}, {4700,0.01386139}, {4750,0.00998020}, {4800,0.01008911}, {4850,0.01014851}, {4900,0.01023762}, {4950,0.01036634}, {5000,0.01063366}, {5050,0.01073267}, {5100,0.01078218}, {5150,0.01085149}, {5200,0.01104950}, {5250,0.02218812}, {5300,0.01665347}, {5350,0.01125743}, {5400,0.01152475}, {5450,0.01175248}, {5500,0.02274257}, {5550,0.01866337}, {5600,0.01189109}, {5650,0.02070297}, {5700,0.01212871}, {5750,0.01217822}, {5800,0.01229703}, {5850,0.01265347}, {5900,0.01277228}, {5950,0.01279208}, {6000,0.01287129}, {6050,0.0470571}, {6100,0.0140857}, {6150,0.0143714}, {6200,0.0144857}, {6250,0.0147143}, {6300,0.0307143}, {6350,0.0149714}, {6400,0.0290571}, {6450,0.0150857}, {6500,0.0152571}, {6550,0.0154571}, {6600,0.0154000}, {6650,0.0156857}, {6700,0.0157143}, {6750,0.0159429}, {6800,0.0162000}, {6850,0.0161714}, {6900,0.0162000}, {6950,0.0164571}, {7000,0.0166000}, {7050,0.0166857}, {7100,0.0169143}, {7150,0.0170857}, {7200,0.0362000}, {7250,0.0172571}, {7300,0.0174286}, {7350,0.0266571}, {7400,0.0176571}, {7450,0.0344571}, {7500,0.0179429}, {7550,0.0181143}, {7600,0.0183143}, {7650,0.0182000}, {7700,0.0186286}, {7750,0.0385143}, {7800,0.0187714}, {7850,0.0364286}, {7900,0.0191143}, {7950,0.0192000}, {8000,0.0194286}, {8050,0.0386000}, {8100,0.0195143}, {8150,0.0195429}, {8200,0.0198286}, {8250,0.0364286}, {8300,0.0327429}, {8350,0.0202000}, {8400,0.0394000}, {8450,0.0203714}, {8500,0.0205429}, {8550,0.0485429}, {8600,0.0210571}, {8650,0.0213143}, {8700,0.0380286}, {8750,0.0325143}, {8800,0.0216000}, {8850,0.0217429}, {8900,0.0219429}, {8950,0.0220000}, {9000,0.0404286}, {9050,0.0222571}, {9100,0.0347714}, {9150,0.0226286}, {9200,0.0225714}, {9250,0.0434000}, {9300,0.0515429}, {9350,0.0232571}, {9400,0.0231714}, {9450,0.0232286}, {9500,0.0234571}, {9550,0.0235714}, {9600,0.0239143}, {9650,0.0487143}, {9700,0.0239143}, {9750,0.0546286}, {9800,0.0239714}, {9850,0.0242571}, {9900,0.0241714}, {9950,0.0503143}, {10000,0.0247429}, {10100,0.0500286}, {10200,0.0523429}, {10300,0.0541429}, {10400,0.0258571}, {10500,0.0465714}, {10600,0.0257143}, {10700,0.0264286}, {10800,0.0268000}, {10900,0.0564857}, {11000,0.0271429}, {11100,0.0274857}, {11200,0.0278857}, {11300,0.0513143}, {11400,0.0282286}, {11500,0.0285143}, {11600,0.0289143}, {11700,0.0284857}, {11800,0.0523143}, {11900,0.0297429}, {12000,0.0301143}, {12100,0.0301714}, {12200,0.0543143}, {12300,0.0540000}, {12400,0.0535714}, {12500,0.0312857}, {12600,0.0600571}, {12700,0.0316000}, {12800,0.0319714}, {12900,0.0318000}, {13000,0.0323714}, {13100,0.0328286}, {13200,0.0651143}, {13300,0.0332857}, {13400,0.0334286}, {13500,0.0487714}, {13600,0.0561143}, {13700,0.0344286}, {13800,0.0495429}, {13900,0.0349429}, {14000,0.0351143}, {14100,0.0701143}, {14200,0.0357429}, {14300,0.0360000}, {14400,0.0621143}, {14500,0.0713714}, {14600,0.0366571}, {14700,0.0368857}, {14800,0.0374571}, {14900,0.0626000}, {15000,0.0377429}, {15100,0.0379429}, {15200,0.0381143}, {15300,0.0378857}, {15400,0.0664286}, {15500,0.0388000}, {15600,0.0735429}, {15700,0.0676857}, {15800,0.0397143}, {15900,0.0397714}, {16000,0.0403429}, {16100,0.0404000}, {16200,0.0407143}, {16300,0.0410571}, {16400,0.0586571}, {16500,0.0418000}, {16600,0.0822000}, {16700,0.0422000}, {16800,0.0418571}, {16900,0.0426000}, {17000,0.0428571}, {17100,0.0897429}, {17200,0.0433143}, {17300,0.0750000}, {17400,0.0755714}, {17500,0.0727429}, {17600,0.0903714}, {17700,0.0853143}, {17800,0.0448857}, {17900,0.0714000}, {18000,0.0804286}, {18100,0.0458857}, {18200,0.0463143}, {18300,0.0816286}, {18400,0.0619429}, {18500,0.0471143}, {18600,0.0596857}, {18700,0.0847429}, {18800,0.0474857}, {18900,0.0862571}, {19000,0.0905714}, {19100,0.0489429}, {19200,0.0489143}, {19300,0.0492857}, {19400,0.0493714}, {19500,0.0496286}, {19600,0.1080571}, {19700,0.0726571}, {19800,0.0503143}, {19900,0.0525429}, {20000,0.1008000}};
data["big_flat"]["LtacTCPrimPair"]["cbv"]["user"] = {{1,0.00002970}, {2,0.00003960}, {3,0.00000000}, {4,0.00002970}, {5,0.00000000}, {6,0.00003960}, {7,0.00005941}, {8,0.00010891}, {9,0.00010891}, {10,0.00006931}, {11,0.00007921}, {12,0.00007921}, {13,0.00000000}, {14,0.00002970}, {15,0.00006931}, {16,0.00002970}, {17,0.00003960}, {18,0.00002970}, {19,0.00002970}, {20,0.00000000}, {21,0.00002970}, {22,0.00000000}, {23,0.00010891}, {24,0.00007921}, {25,0.00013861}, {26,0.00006931}, {27,0.00002970}, {28,0.00010891}, {29,0.00005941}, {30,0.00010891}, {31,0.00011881}, {32,0.00006931}, {33,0.00012871}, {34,0.00010891}, {35,0.00000000}, {36,0.00018812}, {37,0.00010891}, {38,0.00006931}, {39,0.00029703}, {40,0.00016832}, {41,0.00009901}, {42,0.00003960}, {43,0.00009901}, {44,0.00006931}, {45,0.00007921}, {46,0.00017822}, {47,0.00017822}, {48,0.00013861}, {49,0.00000000}, {50,0.00019802}, {51,0.00007921}, {52,0.00008911}, {53,0.00005941}, {54,0.00006931}, {55,0.00002970}, {56,0.00010891}, {57,0.00018812}, {58,0.00012871}, {59,0.00010891}, {60,0.00013861}, {61,0.00006931}, {62,0.00011881}, {63,0.00016832}, {64,0.00005941}, {65,0.00007921}, {66,0.00009901}, {67,0.00012871}, {68,0.00003960}, {69,0.00005941}, {70,0.00024752}, {71,0.00000000}, {72,0.00018812}, {73,0.00018812}, {74,0.00015842}, {75,0.00008911}, {76,0.00002970}, {77,0.00016832}, {78,0.00008911}, {79,0.00014851}, {80,0.00009901}, {81,0.00009901}, {82,0.00017822}, {83,0.00012871}, {84,0.00009901}, {85,0.00018812}, {86,0.00022772}, {87,0.00016832}, {88,0.00019802}, {89,0.00002970}, {90,0.00015842}, {91,0.00027723}, {92,0.00019802}, {93,0.00032673}, {94,0.00028713}, {95,0.00012871}, {96,0.00021782}, {97,0.00041584}, {98,0.00020792}, {99,0.00017822}, {100,0.00021782}, {101,0.00023762}, {102,0.00028713}, {103,0.00023762}, {104,0.00018812}, {105,0.00030693}, {106,0.00035644}, {107,0.00009901}, {108,0.00045545}, {109,0.00021782}, {110,0.00003960}, {111,0.00009901}, {112,0.00021782}, {113,0.00029703}, {114,0.00008911}, {115,0.00021782}, {116,0.00017822}, {117,0.00014851}, {118,0.00028713}, {119,0.00012871}, {120,0.00024752}, {121,0.00018812}, {122,0.00021782}, {123,0.00024752}, {124,0.00018812}, {125,0.00034653}, {126,0.00039604}, {127,0.00027723}, {128,0.00027723}, {129,0.00023762}, {130,0.00016832}, {131,0.00024752}, {132,0.00012871}, {133,0.00025743}, {134,0.00022772}, {135,0.00032673}, {136,0.00018812}, {137,0.00027723}, {138,0.00039604}, {139,0.00031683}, {140,0.00031683}, {141,0.00017822}, {142,0.00026733}, {143,0.00029703}, {144,0.00013861}, {145,0.00028713}, {146,0.00013861}, {147,0.00040594}, {148,0.00013861}, {149,0.00030693}, {150,0.00018812}, {151,0.00024752}, {152,0.00032673}, {153,0.00022772}, {154,0.00031683}, {155,0.00022772}, {156,0.00031683}, {157,0.00039604}, {158,0.00026733}, {159,0.00044554}, {160,0.00034653}, {161,0.00033663}, {162,0.00036634}, {163,0.00017822}, {164,0.00022772}, {165,0.00021782}, {166,0.00034653}, {167,0.00034653}, {168,0.00016832}, {169,0.00038614}, {170,0.00026733}, {171,0.00053465}, {172,0.00033663}, {173,0.00030693}, {174,0.00028713}, {175,0.00085149}, {176,0.00033663}, {177,0.00038614}, {178,0.00052475}, {179,0.00046535}, {180,0.00054455}, {181,0.00025743}, {182,0.00038614}, {183,0.00039604}, {184,0.00051485}, {185,0.00040594}, {186,0.00020792}, {187,0.00024752}, {188,0.00034653}, {189,0.00044554}, {190,0.00049505}, {191,0.00038614}, {192,0.00045545}, {193,0.00039604}, {194,0.00038614}, {195,0.00027723}, {196,0.00031683}, {197,0.00035644}, {198,0.00039604}, {199,0.00047525}, {200,0.00030693}, {201,0.00056436}, {202,0.00065347}, {203,0.00030693}, {204,0.00035644}, {205,0.00035644}, {206,0.00043564}, {207,0.00024752}, {208,0.00048515}, {209,0.00071287}, {210,0.00047525}, {211,0.00028713}, {212,0.00049505}, {213,0.00043564}, {214,0.00028713}, {215,0.00032673}, {216,0.00040594}, {217,0.00046535}, {218,0.00059406}, {219,0.00048515}, {220,0.00031683}, {221,0.00050495}, {222,0.00058416}, {223,0.00042574}, {224,0.00071287}, {225,0.00066337}, {226,0.00027723}, {227,0.00048515}, {228,0.00035644}, {229,0.00029703}, {230,0.00056436}, {231,0.00047525}, {232,0.00047525}, {233,0.00037624}, {234,0.00043564}, {235,0.00066337}, {236,0.00010891}, {237,0.00043564}, {238,0.00031683}, {239,0.00038614}, {240,0.00031683}, {241,0.00053465}, {242,0.00032673}, {243,0.00035644}, {244,0.00045545}, {245,0.00053465}, {246,0.00065347}, {247,0.00037624}, {248,0.00038614}, {249,0.00044554}, {250,0.00026733}, {251,0.00035644}, {252,0.00055446}, {253,0.00062376}, {254,0.00043564}, {255,0.00053465}, {256,0.00042574}, {257,0.00041584}, {258,0.00045545}, {259,0.00051485}, {260,0.00053465}, {261,0.00036634}, {262,0.00028713}, {263,0.00040594}, {264,0.00045545}, {265,0.00046535}, {266,0.00063366}, {267,0.00041584}, {268,0.00062376}, {269,0.00037624}, {270,0.00064356}, {271,0.00045545}, {272,0.00034653}, {273,0.00041584}, {274,0.00054455}, {275,0.00040594}, {276,0.00049505}, {277,0.00029703}, {278,0.00033663}, {279,0.00053465}, {280,0.00051485}, {281,0.00035644}, {282,0.00051485}, {283,0.00052475}, {284,0.00061386}, {285,0.00053465}, {286,0.00069307}, {287,0.00044554}, {288,0.00036634}, {289,0.00054455}, {290,0.00054455}, {291,0.00046535}, {292,0.00053465}, {293,0.00060396}, {294,0.00051485}, {295,0.00058416}, {296,0.00059406}, {297,0.00048515}, {298,0.00038614}, {299,0.00049505}, {300,0.00064356}, {301,0.00049505}, {302,0.00046535}, {303,0.00051485}, {304,0.00037624}, {305,0.00039604}, {306,0.00053465}, {307,0.00083168}, {308,0.00056436}, {309,0.00052475}, {310,0.00052475}, {311,0.00048515}, {312,0.00051485}, {313,0.00065347}, {314,0.00047525}, {315,0.00061386}, {316,0.00048515}, {317,0.00058416}, {318,0.00043564}, {319,0.00068317}, {320,0.00045545}, {321,0.00046535}, {322,0.00056436}, {323,0.00047525}, {324,0.00070297}, {325,0.00079208}, {326,0.00069307}, {327,0.00079208}, {328,0.00057426}, {329,0.00055446}, {330,0.00056436}, {331,0.00053465}, {332,0.00066337}, {333,0.00056436}, {334,0.00077228}, {335,0.00051485}, {336,0.00088119}, {337,0.00065347}, {338,0.00054455}, {339,0.00041584}, {340,0.00073267}, {341,0.00066337}, {342,0.00068317}, {343,0.00080198}, {344,0.00053465}, {345,0.00097030}, {346,0.00091089}, {347,0.00065347}, {348,0.00069307}, {349,0.00047525}, {350,0.00072277}, {351,0.00048515}, {352,0.00079208}, {353,0.00073267}, {354,0.00081188}, {355,0.00082178}, {356,0.00049505}, {357,0.00051485}, {358,0.00067327}, {359,0.00062376}, {360,0.00067327}, {361,0.00057426}, {362,0.00078218}, {363,0.00059406}, {364,0.00089109}, {365,0.00051485}, {366,0.00062376}, {367,0.00085149}, {368,0.00070297}, {369,0.00093069}, {370,0.00092079}, {371,0.00055446}, {372,0.00068317}, {373,0.00063366}, {374,0.00077228}, {375,0.00068317}, {376,0.00079208}, {377,0.00055446}, {378,0.00071287}, {379,0.00075248}, {380,0.00083168}, {381,0.00088119}, {382,0.00096040}, {383,0.00092079}, {384,0.00073267}, {385,0.00060396}, {386,0.00073267}, {387,0.00076238}, {388,0.00096040}, {389,0.00093069}, {390,0.00088119}, {391,0.00112871}, {392,0.00101980}, {393,0.00071287}, {394,0.00079208}, {395,0.00071287}, {396,0.00069307}, {397,0.00081188}, {398,0.00082178}, {399,0.00091089}, {400,0.00070297}, {401,0.00078218}, {402,0.00097030}, {403,0.00111881}, {404,0.00075248}, {405,0.00064356}, {406,0.00068317}, {407,0.00055446}, {408,0.00089109}, {409,0.00068317}, {410,0.00075248}, {411,0.00075248}, {412,0.00046535}, {413,0.00092079}, {414,0.00060396}, {415,0.00069307}, {416,0.00105941}, {417,0.00080198}, {418,0.00089109}, {419,0.00115842}, {420,0.00079208}, {421,0.00089109}, {422,0.00081188}, {423,0.00086139}, {424,0.00109901}, {425,0.00069307}, {426,0.00122772}, {427,0.00104950}, {428,0.00100000}, {429,0.00108911}, {430,0.00042574}, {431,0.00075248}, {432,0.00102970}, {433,0.00056436}, {434,0.00093069}, {435,0.00089109}, {436,0.00072277}, {437,0.00111881}, {438,0.00093069}, {439,0.00077228}, {440,0.00090099}, {441,0.00071287}, {442,0.00082178}, {443,0.00076238}, {444,0.00078218}, {445,0.00078218}, {446,0.00121782}, {447,0.00092079}, {448,0.00091089}, {449,0.00089109}, {450,0.00095050}, {451,0.00086139}, {452,0.00102970}, {453,0.00060396}, {454,0.00085149}, {455,0.00097030}, {456,0.00102970}, {457,0.00109901}, {458,0.00106931}, {459,0.00093069}, {460,0.00109901}, {461,0.00072277}, {462,0.00117822}, {463,0.00064356}, {464,0.00089109}, {465,0.00071287}, {466,0.00086139}, {467,0.00237624}, {468,0.00078218}, {469,0.00068317}, {470,0.00085149}, {471,0.00110891}, {472,0.00091089}, {473,0.00084158}, {474,0.00086139}, {475,0.00115842}, {476,0.00077228}, {477,0.00076238}, {478,0.00078218}, {479,0.00081188}, {480,0.00077228}, {481,0.00078218}, {482,0.00096040}, {483,0.00104950}, {484,0.00088119}, {485,0.00076238}, {486,0.00109901}, {487,0.00116832}, {488,0.00105941}, {489,0.00094059}, {490,0.00102970}, {491,0.00088119}, {492,0.00074257}, {493,0.00115842}, {494,0.00065347}, {495,0.00100000}, {496,0.00096040}, {497,0.00115842}, {498,0.00097030}, {499,0.00080198}, {500,0.00100000}, {505,0.00096040}, {510,0.00080198}, {515,0.00087129}, {520,0.00108911}, {525,0.00102970}, {530,0.00133663}, {535,0.00119802}, {540,0.00074257}, {545,0.00104950}, {550,0.00132673}, {555,0.00078218}, {560,0.00116832}, {565,0.00092079}, {570,0.00092079}, {575,0.00109901}, {580,0.00078218}, {585,0.00077228}, {590,0.00108911}, {595,0.00094059}, {600,0.00091089}, {605,0.00120792}, {610,0.00105941}, {615,0.00089109}, {620,0.00123762}, {625,0.00107921}, {630,0.00109901}, {635,0.00113861}, {640,0.00133663}, {645,0.00125743}, {650,0.00130693}, {655,0.00087129}, {660,0.00128713}, {665,0.00099010}, {670,0.00127723}, {675,0.00075248}, {680,0.00104950}, {685,0.00122772}, {690,0.00124752}, {695,0.00129703}, {700,0.00112871}, {705,0.00123762}, {710,0.00124752}, {715,0.00149505}, {720,0.00130693}, {725,0.00125743}, {730,0.00119802}, {735,0.00133663}, {740,0.00163366}, {745,0.00298020}, {750,0.00159406}, {755,0.00144554}, {760,0.00147525}, {765,0.00329703}, {770,0.00115842}, {775,0.00161386}, {780,0.00318812}, {785,0.00149505}, {790,0.00168317}, {795,0.00145545}, {800,0.00145545}, {805,0.00117822}, {810,0.00136634}, {815,0.00150495}, {820,0.00136634}, {825,0.00125743}, {830,0.00142574}, {835,0.00155446}, {840,0.00182178}, {845,0.00146535}, {850,0.00148515}, {855,0.00174257}, {860,0.00161386}, {865,0.00169307}, {870,0.00146535}, {875,0.00154455}, {880,0.00131683}, {885,0.00167327}, {890,0.00159406}, {895,0.00169307}, {900,0.00153465}, {905,0.00178218}, {910,0.00166337}, {915,0.00149505}, {920,0.00140594}, {925,0.00145545}, {930,0.00142574}, {935,0.00203960}, {940,0.00178218}, {945,0.00157426}, {950,0.00183168}, {955,0.00149505}, {960,0.00165347}, {965,0.00150495}, {970,0.00151485}, {975,0.00153465}, {980,0.00175248}, {985,0.00411881}, {990,0.00181188}, {995,0.00157426}, {1000,0.00176238}, {1010,0.00200990}, {1020,0.00177228}, {1030,0.00175248}, {1040,0.00164356}, {1050,0.00173267}, {1060,0.00192079}, {1070,0.00178218}, {1080,0.00194059}, {1090,0.00208911}, {1100,0.00194059}, {1110,0.00205941}, {1120,0.00194059}, {1130,0.00226733}, {1140,0.00177228}, {1150,0.00193069}, {1160,0.00178218}, {1170,0.00391089}, {1180,0.00195050}, {1190,0.00180198}, {1200,0.00213861}, {1210,0.00223762}, {1220,0.00216832}, {1230,0.00221782}, {1240,0.00198020}, {1250,0.00227723}, {1260,0.00225743}, {1270,0.00233663}, {1280,0.00240594}, {1290,0.00241584}, {1300,0.00255446}, {1310,0.00227723}, {1320,0.00248515}, {1330,0.00200000}, {1340,0.00239604}, {1350,0.00227723}, {1360,0.00242574}, {1370,0.00238614}, {1380,0.00221782}, {1390,0.00246535}, {1400,0.00246535}, {1410,0.00230693}, {1420,0.00219802}, {1430,0.00234653}, {1440,0.00260396}, {1450,0.00268317}, {1460,0.00280198}, {1470,0.00291089}, {1480,0.00256436}, {1490,0.00250495}, {1500,0.00294059}, {1510,0.00534653}, {1520,0.00625743}, {1530,0.00308911}, {1540,0.00299010}, {1550,0.00299010}, {1560,0.00606931}, {1570,0.00300000}, {1580,0.00451485}, {1590,0.00301980}, {1600,0.00284158}, {1610,0.00275248}, {1620,0.00299010}, {1630,0.00303960}, {1640,0.00316832}, {1650,0.00309901}, {1660,0.00313861}, {1670,0.00326733}, {1680,0.00314851}, {1690,0.00314851}, {1700,0.00316832}, {1710,0.00324752}, {1720,0.00337624}, {1730,0.00323762}, {1740,0.00618812}, {1750,0.00318812}, {1760,0.00339604}, {1770,0.00314851}, {1780,0.00336634}, {1790,0.00345545}, {1800,0.00346535}, {1810,0.00336634}, {1820,0.00342574}, {1830,0.00347525}, {1840,0.00358416}, {1850,0.00360396}, {1860,0.00351485}, {1870,0.00359406}, {1880,0.00357426}, {1890,0.00365347}, {1900,0.00350495}, {1910,0.00374257}, {1920,0.00367327}, {1930,0.00370297}, {1940,0.00371287}, {1950,0.00369307}, {1960,0.00371287}, {1970,0.00370297}, {1980,0.00380198}, {1990,0.00387129}, {2000,0.00376238}, {2050,0.00384158}, {2100,0.00746535}, {2150,0.00428713}, {2200,0.00432673}, {2250,0.00411881}, {2300,0.00451485}, {2350,0.00417822}, {2400,0.00480198}, {2450,0.00452475}, {2500,0.00464356}, {2550,0.00504950}, {2600,0.00532673}, {2650,0.00545545}, {2700,0.00530693}, {2750,0.00531683}, {2800,0.00528713}, {2850,0.00569307}, {2900,0.00553465}, {2950,0.00543564}, {3000,0.00579208}, {3050,0.00611881}, {3100,0.01296040}, {3150,0.00568317}, {3200,0.00653465}, {3250,0.00646535}, {3300,0.00656436}, {3350,0.00668317}, {3400,0.00655446}, {3450,0.00668317}, {3500,0.00682178}, {3550,0.00688119}, {3600,0.00708911}, {3650,0.00715842}, {3700,0.00732673}, {3750,0.00757426}, {3800,0.00761386}, {3850,0.00785149}, {3900,0.00753465}, {3950,0.00761386}, {4000,0.00804950}, {4050,0.00800990}, {4100,0.01889109}, {4150,0.00818812}, {4200,0.00866337}, {4250,0.00879208}, {4300,0.00902970}, {4350,0.00861386}, {4400,0.01483168}, {4450,0.00939604}, {4500,0.01490099}, {4550,0.00936634}, {4600,0.01957426}, {4650,0.00997030}, {4700,0.01372277}, {4750,0.01024752}, {4800,0.01037624}, {4850,0.01026733}, {4900,0.01033663}, {4950,0.01060396}, {5000,0.01056436}, {5050,0.01081188}, {5100,0.01067327}, {5150,0.01103960}, {5200,0.01082178}, {5250,0.02237624}, {5300,0.01642574}, {5350,0.01130693}, {5400,0.01126733}, {5450,0.01150495}, {5500,0.02289109}, {5550,0.01855446}, {5600,0.01209901}, {5650,0.02038614}, {5700,0.01190099}, {5750,0.01213861}, {5800,0.01229703}, {5850,0.01244554}, {5900,0.01236634}, {5950,0.01251485}, {6000,0.01278218}, {6050,0.0466857}, {6100,0.0141429}, {6150,0.0146286}, {6200,0.0144857}, {6250,0.0146000}, {6300,0.0304857}, {6350,0.0148286}, {6400,0.0290286}, {6450,0.0154286}, {6500,0.0155429}, {6550,0.0153143}, {6600,0.0152857}, {6650,0.0155143}, {6700,0.0158571}, {6750,0.0159429}, {6800,0.0161429}, {6850,0.0160000}, {6900,0.0161143}, {6950,0.0164000}, {7000,0.0165714}, {7050,0.0170286}, {7100,0.0167143}, {7150,0.0170000}, {7200,0.0362857}, {7250,0.0170286}, {7300,0.0178286}, {7350,0.0264857}, {7400,0.0178571}, {7450,0.0341143}, {7500,0.0175714}, {7550,0.0178857}, {7600,0.0183714}, {7650,0.0180286}, {7700,0.0186857}, {7750,0.0389143}, {7800,0.0185714}, {7850,0.0362857}, {7900,0.0191429}, {7950,0.0191714}, {8000,0.0191429}, {8050,0.0389429}, {8100,0.0196857}, {8150,0.0194000}, {8200,0.0198571}, {8250,0.0364286}, {8300,0.0326286}, {8350,0.0199714}, {8400,0.0393714}, {8450,0.0205714}, {8500,0.0202571}, {8550,0.0483429}, {8600,0.0216000}, {8650,0.0213143}, {8700,0.0384286}, {8750,0.0323143}, {8800,0.0220000}, {8850,0.0219429}, {8900,0.0219429}, {8950,0.0221714}, {9000,0.0398571}, {9050,0.0228857}, {9100,0.0346000}, {9150,0.0226857}, {9200,0.0220571}, {9250,0.0429714}, {9300,0.0523429}, {9350,0.0237143}, {9400,0.0237143}, {9450,0.0237714}, {9500,0.0238857}, {9550,0.0239429}, {9600,0.0241714}, {9650,0.0491143}, {9700,0.0246286}, {9750,0.0545143}, {9800,0.0244000}, {9850,0.0250286}, {9900,0.0245714}, {9950,0.0504571}, {10000,0.0244857}, {10100,0.0501714}, {10200,0.0523143}, {10300,0.0544571}, {10400,0.0266571}, {10500,0.0463429}, {10600,0.0263714}, {10700,0.0268571}, {10800,0.0268857}, {10900,0.0566000}, {11000,0.0276857}, {11100,0.0278000}, {11200,0.0278571}, {11300,0.0513143}, {11400,0.0286571}, {11500,0.0288286}, {11600,0.0296286}, {11700,0.0283714}, {11800,0.0526571}, {11900,0.0294571}, {12000,0.0300857}, {12100,0.0302571}, {12200,0.0542286}, {12300,0.0544571}, {12400,0.0535143}, {12500,0.0311143}, {12600,0.0595714}, {12700,0.0313714}, {12800,0.0319143}, {12900,0.0316857}, {13000,0.0323143}, {13100,0.0322286}, {13200,0.0648857}, {13300,0.0333714}, {13400,0.0332286}, {13500,0.0489714}, {13600,0.0560571}, {13700,0.0340571}, {13800,0.0495429}, {13900,0.0350857}, {14000,0.0350857}, {14100,0.0701143}, {14200,0.0360571}, {14300,0.0362857}, {14400,0.0621143}, {14500,0.0716571}, {14600,0.0365143}, {14700,0.0368857}, {14800,0.0378857}, {14900,0.0625714}, {15000,0.0374571}, {15100,0.0375429}, {15200,0.0384286}, {15300,0.0377714}, {15400,0.0660857}, {15500,0.0383714}, {15600,0.0736286}, {15700,0.0672857}, {15800,0.0391143}, {15900,0.0401429}, {16000,0.0396286}, {16100,0.0399714}, {16200,0.0399429}, {16300,0.0406571}, {16400,0.0583714}, {16500,0.0413429}, {16600,0.0824000}, {16700,0.0420571}, {16800,0.0415714}, {16900,0.0425714}, {17000,0.0424286}, {17100,0.0897429}, {17200,0.0432857}, {17300,0.0748571}, {17400,0.0759429}, {17500,0.0723714}, {17600,0.0902000}, {17700,0.0854286}, {17800,0.0454000}, {17900,0.0709714}, {18000,0.0803714}, {18100,0.0460000}, {18200,0.0467429}, {18300,0.0816000}, {18400,0.0617714}, {18500,0.0473429}, {18600,0.0592286}, {18700,0.0850857}, {18800,0.0475714}, {18900,0.0858286}, {19000,0.0905714}, {19100,0.0490000}, {19200,0.0486000}, {19300,0.0490857}, {19400,0.0496000}, {19500,0.0496000}, {19600,0.1082857}, {19700,0.0726000}, {19800,0.0506571}, {19900,0.0512571}, {20000,0.1009143}};
data["big_flat"]["LtacTCPrimPair"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00002970}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00003960}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00002970}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00003960}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00003960}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00003960}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00002970}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00002970}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00003960}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00003960}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00003960}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00007921}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00007921}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00007921}, {200,0.00000000}, {201,0.00000000}, {202,0.00002970}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00003960}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00003960}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00003960}, {221,0.00003960}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00006931}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00003960}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00003960}, {253,0.00003960}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00003960}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00003960}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00003960}, {278,0.00000000}, {279,0.00003960}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00002970}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00003960}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00003960}, {322,0.00000000}, {323,0.00000000}, {324,0.00007921}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00003960}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00003960}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00003960}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00003960}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00003960}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00003960}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00003960}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00003960}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00003960}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00003960}, {442,0.00003960}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00003960}, {459,0.00003960}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00003960}, {468,0.00000000}, {469,0.00000000}, {470,0.00007921}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00003960}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00003960}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00003960}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00002970}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00003960}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00003960}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00003960}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00003960}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00003960}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00003960}, {815,0.00002970}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00003960}, {880,0.00000000}, {885,0.00000000}, {890,0.00003960}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00003960}, {930,0.00000000}, {935,0.00003960}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00003960}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00003960}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003960}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00003960}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00003960}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00003960}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00003960}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00003960}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00003960}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00003960}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00003960}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00003960}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00003960}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00003960}, {4650,0.00000000}, {4700,0.00003960}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00003960}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00006931}, {5300,0.00003960}, {5350,0.00000000}, {5400,0.00003960}, {5450,0.00003960}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00003960}, {5800,0.00000000}, {5850,0.00003960}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0006571}, {6100,0.0000000}, {6150,0.0001143}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0001143}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0001143}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0001143}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0001143}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000857}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0001143}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0001143}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0001143}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0001143}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0001143}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0001143}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCPrimPair"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00100000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00200000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00201980}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000990}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000990}, {1410,0.00001980}, {1420,0.00000000}, {1430,0.00001980}, {1440,0.00005941}, {1450,0.00000000}, {1460,0.00001980}, {1470,0.00000000}, {1480,0.00021782}, {1490,0.00000000}, {1500,0.00001980}, {1510,0.00001980}, {1520,0.00002970}, {1530,0.00001980}, {1540,0.00045545}, {1550,0.00348515}, {1560,0.00005941}, {1570,0.00063366}, {1580,0.00037624}, {1590,0.00004950}, {1600,0.00100000}, {1610,0.00091089}, {1620,0.00097030}, {1630,0.00100000}, {1640,0.00029703}, {1650,0.00052475}, {1660,0.00100000}, {1670,0.00060396}, {1680,0.00014851}, {1690,0.00100000}, {1700,0.00100000}, {1710,0.00098020}, {1720,0.00100000}, {1730,0.00100000}, {1740,0.00100000}, {1750,0.00100000}, {1760,0.00100000}, {1770,0.00100000}, {1780,0.00100000}, {1790,0.00100000}, {1800,0.00100000}, {1810,0.00100000}, {1820,0.00100000}, {1830,0.00100000}, {1840,0.00100000}, {1850,0.00100000}, {1860,0.00100000}, {1870,0.00100000}, {1880,0.00100000}, {1890,0.00100000}, {1900,0.00100000}, {1910,0.00100000}, {1920,0.00100000}, {1930,0.00100000}, {1940,0.00100000}, {1950,0.00100000}, {1960,0.00100000}, {1970,0.00100000}, {1980,0.00100000}, {1990,0.00100000}, {2000,0.00100000}, {2050,0.00100000}, {2100,0.00100000}, {2150,0.00100000}, {2200,0.00100000}, {2250,0.00100000}, {2300,0.00100000}, {2350,0.00100000}, {2400,0.00100000}, {2450,0.00100000}, {2500,0.00100000}, {2550,0.00100000}, {2600,0.00100000}, {2650,0.00100000}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100990}, {3100,0.00104950}, {3150,0.00104950}, {3200,0.00101980}, {3250,0.00146535}, {3300,0.00108911}, {3350,0.00111881}, {3400,0.00161386}, {3450,0.00161386}, {3500,0.00200000}, {3550,0.00200000}, {3600,0.00200000}, {3650,0.00200000}, {3700,0.00200000}, {3750,0.00200000}, {3800,0.00200000}, {3850,0.00200000}, {3900,0.00200000}, {3950,0.00200000}, {4000,0.00200000}, {4050,0.00200000}, {4100,0.00200000}, {4150,0.00200000}, {4200,0.00200000}, {4250,0.00200000}, {4300,0.00200000}, {4350,0.00200000}, {4400,0.00205941}, {4450,0.00207921}, {4500,0.00206931}, {4550,0.00207921}, {4600,0.00204950}, {4650,0.00420792}, {4700,0.00209901}, {4750,0.00211881}, {4800,0.00214851}, {4850,0.00212871}, {4900,0.00222772}, {4950,0.00226733}, {5000,0.00272277}, {5050,0.00272277}, {5100,0.00268317}, {5150,0.00271287}, {5200,0.00283168}, {5250,0.00275248}, {5300,0.00291089}, {5350,0.00295050}, {5400,0.00302970}, {5450,0.00301980}, {5500,0.00302970}, {5550,0.00304950}, {5600,0.00308911}, {5650,0.00307921}, {5700,0.00307921}, {5750,0.00307921}, {5800,0.00305941}, {5850,0.00314851}, {5900,0.00309901}, {5950,0.00308911}, {6000,0.00313861}, {6050,0.0043429}, {6100,0.0043143}, {6150,0.0044571}, {6200,0.0045429}, {6250,0.0045143}, {6300,0.0045143}, {6350,0.0045143}, {6400,0.0047714}, {6450,0.0047429}, {6500,0.0049143}, {6550,0.0048571}, {6600,0.0049429}, {6650,0.0049429}, {6700,0.0140571}, {6750,0.0051143}, {6800,0.0049143}, {6850,0.0052571}, {6900,0.0100857}, {6950,0.0054857}, {7000,0.0052857}, {7050,0.0051143}, {7100,0.0054286}, {7150,0.0055143}, {7200,0.0047714}, {7250,0.0058000}, {7300,0.0059429}, {7350,0.0055429}, {7400,0.0059714}, {7450,0.0057714}, {7500,0.0059429}, {7550,0.0061429}, {7600,0.0059714}, {7650,0.0068571}, {7700,0.0063143}, {7750,0.0064857}, {7800,0.0062000}, {7850,0.0063143}, {7900,0.0064000}, {7950,0.0065429}, {8000,0.0068857}, {8050,0.0065714}, {8100,0.0067143}, {8150,0.0066571}, {8200,0.0064857}, {8250,0.0067143}, {8300,0.0071429}, {8350,0.0069429}, {8400,0.0072286}, {8450,0.0071143}, {8500,0.0072286}, {8550,0.0070857}, {8600,0.0075429}, {8650,0.0075429}, {8700,0.0076571}, {8750,0.0077429}, {8800,0.0077429}, {8850,0.0076857}, {8900,0.0077429}, {8950,0.0076857}, {9000,0.0078286}, {9050,0.0078286}, {9100,0.0079429}, {9150,0.0079714}, {9200,0.0078571}, {9250,0.0079714}, {9300,0.0080000}, {9350,0.0086286}, {9400,0.0070571}, {9450,0.0085143}, {9500,0.0083429}, {9550,0.0142857}, {9600,0.0085714}, {9650,0.0088571}, {9700,0.0086571}, {9750,0.0087143}, {9800,0.0088286}, {9850,0.0089143}, {9900,0.0088857}, {9950,0.0088857}, {10000,0.0075714}, {10100,0.0089143}, {10200,0.0089429}, {10300,0.0091714}, {10400,0.0090286}, {10500,0.0089143}, {10600,0.0094000}, {10700,0.0094857}, {10800,0.0096571}, {10900,0.0097714}, {11000,0.0097714}, {11100,0.0097714}, {11200,0.0098286}, {11300,0.0098000}, {11400,0.0214857}, {11500,0.0099429}, {11600,0.0102000}, {11700,0.0102000}, {11800,0.0105429}, {11900,0.0150000}, {12000,0.0107429}, {12100,0.0091429}, {12200,0.0107714}, {12300,0.0108571}, {12400,0.0107714}, {12500,0.0109714}, {12600,0.0109143}, {12700,0.0109714}, {12800,0.0097143}, {12900,0.0111714}, {13000,0.0115429}, {13100,0.0117143}, {13200,0.0116286}, {13300,0.0100571}, {13400,0.0117143}, {13500,0.0163143}, {13600,0.0104286}, {13700,0.0119429}, {13800,0.0119143}, {13900,0.0122286}, {14000,0.0301429}, {14100,0.0126571}, {14200,0.0126571}, {14300,0.0127143}, {14400,0.0128000}, {14500,0.0127714}, {14600,0.0355143}, {14700,0.0128286}, {14800,0.0130000}, {14900,0.0130000}, {15000,0.0134000}, {15100,0.0134000}, {15200,0.0133429}, {15300,0.0426000}, {15400,0.0134286}, {15500,0.0135143}, {15600,0.0117714}, {15700,0.0120000}, {15800,0.0187714}, {15900,0.0139429}, {16000,0.0139429}, {16100,0.0142571}, {16200,0.0143143}, {16300,0.0142857}, {16400,0.0230857}, {16500,0.0436857}, {16600,0.0143714}, {16700,0.0143714}, {16800,0.0146571}, {16900,0.0146857}, {17000,0.0149429}, {17100,0.0150571}, {17200,0.0149429}, {17300,0.0152571}, {17400,0.0153143}, {17500,0.0152857}, {17600,0.0208571}, {17700,0.0152857}, {17800,0.0154857}, {17900,0.0155429}, {18000,0.0159143}, {18100,0.0157429}, {18200,0.0161429}, {18300,0.0161429}, {18400,0.0162857}, {18500,0.0163429}, {18600,0.0164000}, {18700,0.0491429}, {18800,0.0162857}, {18900,0.0164571}, {19000,0.0165143}, {19100,0.0165714}, {19200,0.0167143}, {19300,0.0168857}, {19400,0.0172000}, {19500,0.0172571}, {19600,0.0172857}, {19700,0.0173714}, {19800,0.0152571}, {19900,0.0172571}, {20000,0.0174571}};
data["big_flat"]["LtacTCPrimPair"]["eval lazy"]["user"] = {{1,0.00000000}, {2,0.00009901}, {3,0.00005941}, {4,0.00003960}, {5,0.00005941}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00002970}, {10,0.00000000}, {11,0.00003960}, {12,0.00002970}, {13,0.00002970}, {14,0.00003960}, {15,0.00006931}, {16,0.00011881}, {17,0.00003960}, {18,0.00002970}, {19,0.00003960}, {20,0.00000000}, {21,0.00010891}, {22,0.00002970}, {23,0.00002970}, {24,0.00002970}, {25,0.00000000}, {26,0.00006931}, {27,0.00000000}, {28,0.00003960}, {29,0.00000000}, {30,0.00006931}, {31,0.00000000}, {32,0.00002970}, {33,0.00002970}, {34,0.00011881}, {35,0.00000000}, {36,0.00003960}, {37,0.00003960}, {38,0.00003960}, {39,0.00002970}, {40,0.00003960}, {41,0.00006931}, {42,0.00002970}, {43,0.00003960}, {44,0.00005941}, {45,0.00008911}, {46,0.00014851}, {47,0.00000000}, {48,0.00006931}, {49,0.00006931}, {50,0.00002970}, {51,0.00006931}, {52,0.00000000}, {53,0.00013861}, {54,0.00011881}, {55,0.00011881}, {56,0.00006931}, {57,0.00006931}, {58,0.00003960}, {59,0.00003960}, {60,0.00013861}, {61,0.00000000}, {62,0.00000000}, {63,0.00006931}, {64,0.00009901}, {65,0.00002970}, {66,0.00009901}, {67,0.00003960}, {68,0.00000000}, {69,0.00005941}, {70,0.00005941}, {71,0.00008911}, {72,0.00016832}, {73,0.00000000}, {74,0.00003960}, {75,0.00006931}, {76,0.00005941}, {77,0.00009901}, {78,0.00006931}, {79,0.00002970}, {80,0.00009901}, {81,0.00002970}, {82,0.00000000}, {83,0.00009901}, {84,0.00016832}, {85,0.00012871}, {86,0.00002970}, {87,0.00008911}, {88,0.00003960}, {89,0.00012871}, {90,0.00008911}, {91,0.00010891}, {92,0.00006931}, {93,0.00010891}, {94,0.00006931}, {95,0.00010891}, {96,0.00014851}, {97,0.00009901}, {98,0.00016832}, {99,0.00014851}, {100,0.00006931}, {101,0.00002970}, {102,0.00003960}, {103,0.00002970}, {104,0.00002970}, {105,0.00012871}, {106,0.00009901}, {107,0.00012871}, {108,0.00006931}, {109,0.00002970}, {110,0.00008911}, {111,0.00015842}, {112,0.00008911}, {113,0.00011881}, {114,0.00006931}, {115,0.00008911}, {116,0.00012871}, {117,0.00013861}, {118,0.00016832}, {119,0.00005941}, {120,0.00011881}, {121,0.00006931}, {122,0.00021782}, {123,0.00005941}, {124,0.00016832}, {125,0.00011881}, {126,0.00015842}, {127,0.00009901}, {128,0.00007921}, {129,0.00013861}, {130,0.00011881}, {131,0.00006931}, {132,0.00002970}, {133,0.00008911}, {134,0.00008911}, {135,0.00003960}, {136,0.00009901}, {137,0.00008911}, {138,0.00010891}, {139,0.00006931}, {140,0.00005941}, {141,0.00022772}, {142,0.00009901}, {143,0.00009901}, {144,0.00017822}, {145,0.00010891}, {146,0.00020792}, {147,0.00014851}, {148,0.00021782}, {149,0.00009901}, {150,0.00009901}, {151,0.00017822}, {152,0.00012871}, {153,0.00015842}, {154,0.00011881}, {155,0.00006931}, {156,0.00014851}, {157,0.00010891}, {158,0.00022772}, {159,0.00027723}, {160,0.00018812}, {161,0.00010891}, {162,0.00000000}, {163,0.00013861}, {164,0.00019802}, {165,0.00101980}, {166,0.00014851}, {167,0.00009901}, {168,0.00018812}, {169,0.00017822}, {170,0.00015842}, {171,0.00005941}, {172,0.00014851}, {173,0.00006931}, {174,0.00018812}, {175,0.00006931}, {176,0.00010891}, {177,0.00019802}, {178,0.00009901}, {179,0.00013861}, {180,0.00000000}, {181,0.00018812}, {182,0.00006931}, {183,0.00009901}, {184,0.00022772}, {185,0.00014851}, {186,0.00014851}, {187,0.00013861}, {188,0.00026733}, {189,0.00006931}, {190,0.00006931}, {191,0.00007921}, {192,0.00026733}, {193,0.00009901}, {194,0.00016832}, {195,0.00008911}, {196,0.00014851}, {197,0.00017822}, {198,0.00010891}, {199,0.00020792}, {200,0.00010891}, {201,0.00006931}, {202,0.00014851}, {203,0.00010891}, {204,0.00023762}, {205,0.00019802}, {206,0.00010891}, {207,0.00017822}, {208,0.00025743}, {209,0.00016832}, {210,0.00013861}, {211,0.00024752}, {212,0.00019802}, {213,0.00010891}, {214,0.00002970}, {215,0.00002970}, {216,0.00003960}, {217,0.00012871}, {218,0.00012871}, {219,0.00021782}, {220,0.00010891}, {221,0.00014851}, {222,0.00024752}, {223,0.00021782}, {224,0.00033663}, {225,0.00030693}, {226,0.00018812}, {227,0.00012871}, {228,0.00021782}, {229,0.00023762}, {230,0.00014851}, {231,0.00024752}, {232,0.00017822}, {233,0.00005941}, {234,0.00020792}, {235,0.00010891}, {236,0.00029703}, {237,0.00021782}, {238,0.00017822}, {239,0.00036634}, {240,0.00012871}, {241,0.00006931}, {242,0.00016832}, {243,0.00017822}, {244,0.00016832}, {245,0.00020792}, {246,0.00019802}, {247,0.00017822}, {248,0.00006931}, {249,0.00012871}, {250,0.00012871}, {251,0.00021782}, {252,0.00018812}, {253,0.00024752}, {254,0.00011881}, {255,0.00015842}, {256,0.00023762}, {257,0.00013861}, {258,0.00009901}, {259,0.00026733}, {260,0.00006931}, {261,0.00024752}, {262,0.00016832}, {263,0.00023762}, {264,0.00009901}, {265,0.00009901}, {266,0.00019802}, {267,0.00046535}, {268,0.00017822}, {269,0.00020792}, {270,0.00024752}, {271,0.00028713}, {272,0.00016832}, {273,0.00019802}, {274,0.00011881}, {275,0.00036634}, {276,0.00012871}, {277,0.00024752}, {278,0.00013861}, {279,0.00039604}, {280,0.00022772}, {281,0.00012871}, {282,0.00032673}, {283,0.00012871}, {284,0.00025743}, {285,0.00038614}, {286,0.00018812}, {287,0.00021782}, {288,0.00027723}, {289,0.00024752}, {290,0.00033663}, {291,0.00033663}, {292,0.00013861}, {293,0.00021782}, {294,0.00033663}, {295,0.00012871}, {296,0.00023762}, {297,0.00027723}, {298,0.00012871}, {299,0.00008911}, {300,0.00006931}, {301,0.00006931}, {302,0.00023762}, {303,0.00020792}, {304,0.00021782}, {305,0.00026733}, {306,0.00011881}, {307,0.00032673}, {308,0.00012871}, {309,0.00016832}, {310,0.00022772}, {311,0.00028713}, {312,0.00030693}, {313,0.00017822}, {314,0.00015842}, {315,0.00017822}, {316,0.00015842}, {317,0.00028713}, {318,0.00025743}, {319,0.00007921}, {320,0.00021782}, {321,0.00033663}, {322,0.00028713}, {323,0.00023762}, {324,0.00032673}, {325,0.00018812}, {326,0.00018812}, {327,0.00013861}, {328,0.00018812}, {329,0.00038614}, {330,0.00033663}, {331,0.00016832}, {332,0.00021782}, {333,0.00203960}, {334,0.00035644}, {335,0.00028713}, {336,0.00013861}, {337,0.00025743}, {338,0.00013861}, {339,0.00029703}, {340,0.00025743}, {341,0.00026733}, {342,0.00010891}, {343,0.00028713}, {344,0.00005941}, {345,0.00012871}, {346,0.00018812}, {347,0.00013861}, {348,0.00012871}, {349,0.00012871}, {350,0.00033663}, {351,0.00041584}, {352,0.00027723}, {353,0.00035644}, {354,0.00032673}, {355,0.00030693}, {356,0.00018812}, {357,0.00019802}, {358,0.00014851}, {359,0.00046535}, {360,0.00029703}, {361,0.00013861}, {362,0.00045545}, {363,0.00017822}, {364,0.00024752}, {365,0.00014851}, {366,0.00003960}, {367,0.00014851}, {368,0.00043564}, {369,0.00025743}, {370,0.00022772}, {371,0.00033663}, {372,0.00020792}, {373,0.00018812}, {374,0.00030693}, {375,0.00017822}, {376,0.00046535}, {377,0.00019802}, {378,0.00020792}, {379,0.00034653}, {380,0.00033663}, {381,0.00042574}, {382,0.00028713}, {383,0.00029703}, {384,0.00015842}, {385,0.00021782}, {386,0.00018812}, {387,0.00031683}, {388,0.00017822}, {389,0.00033663}, {390,0.00026733}, {391,0.00022772}, {392,0.00041584}, {393,0.00034653}, {394,0.00031683}, {395,0.00025743}, {396,0.00018812}, {397,0.00047525}, {398,0.00020792}, {399,0.00043564}, {400,0.00031683}, {401,0.00045545}, {402,0.00029703}, {403,0.00031683}, {404,0.00018812}, {405,0.00036634}, {406,0.00037624}, {407,0.00060396}, {408,0.00036634}, {409,0.00036634}, {410,0.00015842}, {411,0.00023762}, {412,0.00026733}, {413,0.00033663}, {414,0.00041584}, {415,0.00023762}, {416,0.00033663}, {417,0.00012871}, {418,0.00028713}, {419,0.00048515}, {420,0.00032673}, {421,0.00019802}, {422,0.00021782}, {423,0.00016832}, {424,0.00037624}, {425,0.00033663}, {426,0.00032673}, {427,0.00012871}, {428,0.00045545}, {429,0.00024752}, {430,0.00014851}, {431,0.00018812}, {432,0.00041584}, {433,0.00034653}, {434,0.00027723}, {435,0.00032673}, {436,0.00231683}, {437,0.00025743}, {438,0.00026733}, {439,0.00012871}, {440,0.00021782}, {441,0.00028713}, {442,0.00026733}, {443,0.00026733}, {444,0.00017822}, {445,0.00037624}, {446,0.00020792}, {447,0.00028713}, {448,0.00013861}, {449,0.00032673}, {450,0.00035644}, {451,0.00010891}, {452,0.00038614}, {453,0.00026733}, {454,0.00032673}, {455,0.00028713}, {456,0.00028713}, {457,0.00031683}, {458,0.00032673}, {459,0.00033663}, {460,0.00043564}, {461,0.00052475}, {462,0.00032673}, {463,0.00028713}, {464,0.00037624}, {465,0.00019802}, {466,0.00022772}, {467,0.00051485}, {468,0.00010891}, {469,0.00023762}, {470,0.00040594}, {471,0.00027723}, {472,0.00038614}, {473,0.00037624}, {474,0.00026733}, {475,0.00028713}, {476,0.00033663}, {477,0.00027723}, {478,0.00038614}, {479,0.00006931}, {480,0.00030693}, {481,0.00029703}, {482,0.00034653}, {483,0.00021782}, {484,0.00052475}, {485,0.00034653}, {486,0.00042574}, {487,0.00041584}, {488,0.00052475}, {489,0.00035644}, {490,0.00030693}, {491,0.00038614}, {492,0.00049505}, {493,0.00029703}, {494,0.00033663}, {495,0.00054455}, {496,0.00025743}, {497,0.00039604}, {498,0.00020792}, {499,0.00024752}, {500,0.00053465}, {505,0.00022772}, {510,0.00020792}, {515,0.00018812}, {520,0.00052475}, {525,0.00028713}, {530,0.00033663}, {535,0.00023762}, {540,0.00038614}, {545,0.00054455}, {550,0.00029703}, {555,0.00032673}, {560,0.00044554}, {565,0.00036634}, {570,0.00029703}, {575,0.00028713}, {580,0.00036634}, {585,0.00025743}, {590,0.00036634}, {595,0.00021782}, {600,0.00032673}, {605,0.00022772}, {610,0.00041584}, {615,0.00052475}, {620,0.00021782}, {625,0.00028713}, {630,0.00027723}, {635,0.00030693}, {640,0.00036634}, {645,0.00026733}, {650,0.00057426}, {655,0.00043564}, {660,0.00030693}, {665,0.00030693}, {670,0.00024752}, {675,0.00041584}, {680,0.00035644}, {685,0.00036634}, {690,0.00049505}, {695,0.00052475}, {700,0.00034653}, {705,0.00035644}, {710,0.00046535}, {715,0.00040594}, {720,0.00024752}, {725,0.00063366}, {730,0.00033663}, {735,0.00035644}, {740,0.00028713}, {745,0.00059406}, {750,0.00045545}, {755,0.00035644}, {760,0.00031683}, {765,0.00027723}, {770,0.00036634}, {775,0.00025743}, {780,0.00030693}, {785,0.00060396}, {790,0.00068317}, {795,0.00045545}, {800,0.00058416}, {805,0.00031683}, {810,0.00026733}, {815,0.00033663}, {820,0.00070297}, {825,0.00065347}, {830,0.00053465}, {835,0.00039604}, {840,0.00051485}, {845,0.00046535}, {850,0.00045545}, {855,0.00049505}, {860,0.00024752}, {865,0.00038614}, {870,0.00048515}, {875,0.00058416}, {880,0.00047525}, {885,0.00042574}, {890,0.00061386}, {895,0.00049505}, {900,0.00045545}, {905,0.00037624}, {910,0.00029703}, {915,0.00057426}, {920,0.00051485}, {925,0.00042574}, {930,0.00055446}, {935,0.00055446}, {940,0.00060396}, {945,0.00047525}, {950,0.00048515}, {955,0.00084158}, {960,0.00064356}, {965,0.00103960}, {970,0.00032673}, {975,0.00046535}, {980,0.00067327}, {985,0.00052475}, {990,0.00063366}, {995,0.00032673}, {1000,0.00063366}, {1010,0.00038614}, {1020,0.00058416}, {1030,0.00086139}, {1040,0.00087129}, {1050,0.00049505}, {1060,0.00068317}, {1070,0.00049505}, {1080,0.00075248}, {1090,0.00039604}, {1100,0.00060396}, {1110,0.00051485}, {1120,0.00030693}, {1130,0.00055446}, {1140,0.00067327}, {1150,0.00045545}, {1160,0.00059406}, {1170,0.00078218}, {1180,0.00053465}, {1190,0.00077228}, {1200,0.00056436}, {1210,0.00081188}, {1220,0.00078218}, {1230,0.00062376}, {1240,0.00058416}, {1250,0.00074257}, {1260,0.00062376}, {1270,0.00062376}, {1280,0.00048515}, {1290,0.00063366}, {1300,0.00054455}, {1310,0.00058416}, {1320,0.00071287}, {1330,0.00081188}, {1340,0.00069307}, {1350,0.00058416}, {1360,0.00057426}, {1370,0.00090099}, {1380,0.00054455}, {1390,0.00087129}, {1400,0.00077228}, {1410,0.00060396}, {1420,0.00066337}, {1430,0.00081188}, {1440,0.00071287}, {1450,0.00063366}, {1460,0.00065347}, {1470,0.00055446}, {1480,0.00072277}, {1490,0.00102970}, {1500,0.00065347}, {1510,0.00088119}, {1520,0.00066337}, {1530,0.00071287}, {1540,0.00084158}, {1550,0.00367327}, {1560,0.00116832}, {1570,0.00113861}, {1580,0.00114851}, {1590,0.00096040}, {1600,0.00104950}, {1610,0.00092079}, {1620,0.00111881}, {1630,0.00117822}, {1640,0.00101980}, {1650,0.00122772}, {1660,0.00096040}, {1670,0.00056436}, {1680,0.00068317}, {1690,0.00113861}, {1700,0.00094059}, {1710,0.00055446}, {1720,0.00101980}, {1730,0.00083168}, {1740,0.00094059}, {1750,0.00079208}, {1760,0.00101980}, {1770,0.00108911}, {1780,0.00091089}, {1790,0.00089109}, {1800,0.00107921}, {1810,0.00085149}, {1820,0.00072277}, {1830,0.00136634}, {1840,0.00114851}, {1850,0.00113861}, {1860,0.00080198}, {1870,0.00092079}, {1880,0.00122772}, {1890,0.00110891}, {1900,0.00116832}, {1910,0.00114851}, {1920,0.00117822}, {1930,0.00102970}, {1940,0.00126733}, {1950,0.00106931}, {1960,0.00094059}, {1970,0.00080198}, {1980,0.00098020}, {1990,0.00120792}, {2000,0.00087129}, {2050,0.00132673}, {2100,0.00099010}, {2150,0.00132673}, {2200,0.00121782}, {2250,0.00156436}, {2300,0.00163366}, {2350,0.00107921}, {2400,0.00108911}, {2450,0.00127723}, {2500,0.00163366}, {2550,0.00146535}, {2600,0.00145545}, {2650,0.00150495}, {2700,0.00171287}, {2750,0.00136634}, {2800,0.00157426}, {2850,0.00117822}, {2900,0.00156436}, {2950,0.00182178}, {3000,0.00152475}, {3050,0.00178218}, {3100,0.00171287}, {3150,0.00170297}, {3200,0.00171287}, {3250,0.00189109}, {3300,0.00187129}, {3350,0.00213861}, {3400,0.00221782}, {3450,0.00171287}, {3500,0.00198020}, {3550,0.00185149}, {3600,0.00210891}, {3650,0.00201980}, {3700,0.00222772}, {3750,0.00192079}, {3800,0.00204950}, {3850,0.00217822}, {3900,0.00238614}, {3950,0.00247525}, {4000,0.00234653}, {4050,0.00215842}, {4100,0.00250495}, {4150,0.00238614}, {4200,0.00211881}, {4250,0.00197030}, {4300,0.00219802}, {4350,0.00240594}, {4400,0.00248515}, {4450,0.00260396}, {4500,0.00236634}, {4550,0.00258416}, {4600,0.00266337}, {4650,0.00455446}, {4700,0.00262376}, {4750,0.00265347}, {4800,0.00299010}, {4850,0.00286139}, {4900,0.00264356}, {4950,0.00316832}, {5000,0.00282178}, {5050,0.00308911}, {5100,0.00293069}, {5150,0.00295050}, {5200,0.00268317}, {5250,0.00299010}, {5300,0.00309901}, {5350,0.00317822}, {5400,0.00289109}, {5450,0.00317822}, {5500,0.00314851}, {5550,0.00331683}, {5600,0.00344554}, {5650,0.00340594}, {5700,0.00340594}, {5750,0.00340594}, {5800,0.00318812}, {5850,0.00339604}, {5900,0.00355446}, {5950,0.00367327}, {6000,0.00340594}, {6050,0.0041143}, {6100,0.0042571}, {6150,0.0042571}, {6200,0.0044286}, {6250,0.0044857}, {6300,0.0040571}, {6350,0.0046286}, {6400,0.0044000}, {6450,0.0049429}, {6500,0.0049714}, {6550,0.0048857}, {6600,0.0050286}, {6650,0.0049714}, {6700,0.0141429}, {6750,0.0042286}, {6800,0.0050286}, {6850,0.0049714}, {6900,0.0102000}, {6950,0.0051429}, {7000,0.0051714}, {7050,0.0048286}, {7100,0.0052286}, {7150,0.0055714}, {7200,0.0042286}, {7250,0.0056571}, {7300,0.0049714}, {7350,0.0054000}, {7400,0.0059143}, {7450,0.0056857}, {7500,0.0060000}, {7550,0.0066000}, {7600,0.0056571}, {7650,0.0063143}, {7700,0.0062286}, {7750,0.0062286}, {7800,0.0064000}, {7850,0.0063143}, {7900,0.0062571}, {7950,0.0062286}, {8000,0.0063143}, {8050,0.0068286}, {8100,0.0068000}, {8150,0.0070857}, {8200,0.0066000}, {8250,0.0064857}, {8300,0.0070571}, {8350,0.0067429}, {8400,0.0069714}, {8450,0.0067714}, {8500,0.0069143}, {8550,0.0070857}, {8600,0.0072286}, {8650,0.0073429}, {8700,0.0074571}, {8750,0.0072000}, {8800,0.0079429}, {8850,0.0080000}, {8900,0.0077143}, {8950,0.0071143}, {9000,0.0080571}, {9050,0.0080286}, {9100,0.0086857}, {9150,0.0085714}, {9200,0.0079143}, {9250,0.0080286}, {9300,0.0084000}, {9350,0.0082857}, {9400,0.0074857}, {9450,0.0084286}, {9500,0.0084571}, {9550,0.0143429}, {9600,0.0083429}, {9650,0.0089714}, {9700,0.0084857}, {9750,0.0083714}, {9800,0.0086571}, {9850,0.0087143}, {9900,0.0092000}, {9950,0.0094000}, {10000,0.0074857}, {10100,0.0096857}, {10200,0.0092571}, {10300,0.0088857}, {10400,0.0096857}, {10500,0.0093714}, {10600,0.0090857}, {10700,0.0095714}, {10800,0.0094286}, {10900,0.0104857}, {11000,0.0097143}, {11100,0.0094000}, {11200,0.0099714}, {11300,0.0100571}, {11400,0.0221429}, {11500,0.0099714}, {11600,0.0098286}, {11700,0.0098571}, {11800,0.0105143}, {11900,0.0148857}, {12000,0.0102857}, {12100,0.0094857}, {12200,0.0107429}, {12300,0.0106571}, {12400,0.0106857}, {12500,0.0108571}, {12600,0.0110286}, {12700,0.0110000}, {12800,0.0093143}, {12900,0.0108000}, {13000,0.0115429}, {13100,0.0117143}, {13200,0.0112857}, {13300,0.0098571}, {13400,0.0114000}, {13500,0.0164000}, {13600,0.0102857}, {13700,0.0123429}, {13800,0.0117143}, {13900,0.0116571}, {14000,0.0304286}, {14100,0.0126286}, {14200,0.0129714}, {14300,0.0119714}, {14400,0.0127714}, {14500,0.0130857}, {14600,0.0353429}, {14700,0.0125714}, {14800,0.0131143}, {14900,0.0129143}, {15000,0.0129714}, {15100,0.0129429}, {15200,0.0138000}, {15300,0.0427429}, {15400,0.0133714}, {15500,0.0134571}, {15600,0.0120571}, {15700,0.0119143}, {15800,0.0182571}, {15900,0.0141714}, {16000,0.0139143}, {16100,0.0141429}, {16200,0.0138571}, {16300,0.0142571}, {16400,0.0229714}, {16500,0.0440857}, {16600,0.0139714}, {16700,0.0148571}, {16800,0.0146571}, {16900,0.0149143}, {17000,0.0155143}, {17100,0.0147429}, {17200,0.0146286}, {17300,0.0152571}, {17400,0.0150000}, {17500,0.0157429}, {17600,0.0206571}, {17700,0.0156571}, {17800,0.0157429}, {17900,0.0162286}, {18000,0.0160571}, {18100,0.0161429}, {18200,0.0162286}, {18300,0.0156857}, {18400,0.0160000}, {18500,0.0160571}, {18600,0.0159429}, {18700,0.0493143}, {18800,0.0166571}, {18900,0.0166571}, {19000,0.0164286}, {19100,0.0167429}, {19200,0.0167714}, {19300,0.0171714}, {19400,0.0172286}, {19500,0.0170571}, {19600,0.0172286}, {19700,0.0172571}, {19800,0.0152286}, {19900,0.0173143}, {20000,0.0174857}};
data["big_flat"]["LtacTCPrimPair"]["eval lazy"]["system"] = {{1,0.00007921}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00003960}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00002970}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00003960}, {157,0.00003960}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00003960}, {166,0.00003960}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00003960}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00002970}, {232,0.00003960}, {233,0.00003960}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00003960}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00003960}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00003960}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00003960}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00003960}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00003960}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00007921}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00002970}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00003960}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00003960}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00003960}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00003960}, {775,0.00000000}, {780,0.00003960}, {785,0.00000000}, {790,0.00003960}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00002970}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00002970}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00002970}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00003960}, {1430,0.00003960}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00003960}, {1560,0.00003960}, {1570,0.00000000}, {1580,0.00003960}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00003960}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00003960}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00003960}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00003960}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00003960}, {2600,0.00000000}, {2650,0.00003960}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00003960}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00002970}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00003960}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00003960}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00003960}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00003960}, {3700,0.00003960}, {3750,0.00000000}, {3800,0.00003960}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00003960}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00003960}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00003960}, {4700,0.00003960}, {4750,0.00000000}, {4800,0.00003960}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00003960}, {5100,0.00000000}, {5150,0.00007921}, {5200,0.00002970}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00007921}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00007921}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00003960}, {6050,0.0002000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000857}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0001143}, {6900,0.0001143}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0001143}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0001143}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0001143}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0002286}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0001143}, {8400,0.0001143}, {8450,0.0001143}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0001143}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0001143}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0001143}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0001143}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0001143}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0002286}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0001143}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0001143}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0001143}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0002286}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0001143}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0001143}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0001143}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0001143}, {16800,0.0000000}, {16900,0.0001143}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0001143}, {17300,0.0000000}, {17400,0.0001143}, {17500,0.0000000}, {17600,0.0001143}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0001143}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0001143}, {18600,0.0001143}, {18700,0.0002286}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0001143}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0001143}, {19600,0.0000000}, {19700,0.0001143}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCPrimPair"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00170297}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00200990}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000990}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000990}, {2050,0.00000990}, {2100,0.00000000}, {2150,0.00003960}, {2200,0.00000990}, {2250,0.00003960}, {2300,0.00010891}, {2350,0.00041584}, {2400,0.00048515}, {2450,0.00051485}, {2500,0.00079208}, {2550,0.00099010}, {2600,0.00100000}, {2650,0.00099010}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00466337}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00100000}, {3150,0.00100000}, {3200,0.00100000}, {3250,0.00100000}, {3300,0.00100000}, {3350,0.00100000}, {3400,0.00100000}, {3450,0.00100000}, {3500,0.00100000}, {3550,0.00100000}, {3600,0.00100000}, {3650,0.00100000}, {3700,0.00100000}, {3750,0.00100000}, {3800,0.00100000}, {3850,0.00100000}, {3900,0.00100000}, {3950,0.00100000}, {4000,0.00100000}, {4050,0.00100000}, {4100,0.00100000}, {4150,0.00878218}, {4200,0.00100000}, {4250,0.00100000}, {4300,0.00100000}, {4350,0.00100000}, {4400,0.00100000}, {4450,0.00100990}, {4500,0.00100990}, {4550,0.00102970}, {4600,0.00106931}, {4650,0.00115842}, {4700,0.00130693}, {4750,0.00157426}, {4800,0.00159406}, {4850,0.00162376}, {4900,0.00167327}, {4950,0.00171287}, {5000,0.00173267}, {5050,0.00178218}, {5100,0.00192079}, {5150,0.00200000}, {5200,0.00200000}, {5250,0.00200000}, {5300,0.00200000}, {5350,0.00200000}, {5400,0.00200000}, {5450,0.00200000}, {5500,0.00200000}, {5550,0.00200000}, {5600,0.00200000}, {5650,0.00200000}, {5700,0.00200000}, {5750,0.00200000}, {5800,0.00200000}, {5850,0.00200000}, {5900,0.00200000}, {5950,0.00200000}, {6000,0.00200000}, {6050,0.0020857}, {6100,0.0020286}, {6150,0.0021143}, {6200,0.0020286}, {6250,0.0020286}, {6300,0.0020857}, {6350,0.0022857}, {6400,0.0023143}, {6450,0.0023143}, {6500,0.0024286}, {6550,0.0024286}, {6600,0.0024000}, {6650,0.0026286}, {6700,0.0025714}, {6750,0.0026571}, {6800,0.0027429}, {6850,0.0028571}, {6900,0.0028571}, {6950,0.0148286}, {7000,0.0028857}, {7050,0.0029714}, {7100,0.0030000}, {7150,0.0030000}, {7200,0.0029714}, {7250,0.0029714}, {7300,0.0029714}, {7350,0.0029714}, {7400,0.0030000}, {7450,0.0030000}, {7500,0.0030000}, {7550,0.0030000}, {7600,0.0030286}, {7650,0.0132857}, {7700,0.0030000}, {7750,0.0030000}, {7800,0.0030000}, {7850,0.0030000}, {7900,0.0030286}, {7950,0.0030000}, {8000,0.0030286}, {8050,0.0030286}, {8100,0.0030286}, {8150,0.0030286}, {8200,0.0031429}, {8250,0.0030571}, {8300,0.0031429}, {8350,0.0031143}, {8400,0.0116286}, {8450,0.0033714}, {8500,0.0034571}, {8550,0.0035714}, {8600,0.0037143}, {8650,0.0037429}, {8700,0.0037714}, {8750,0.0037714}, {8800,0.0038000}, {8850,0.0038000}, {8900,0.0038000}, {8950,0.0038000}, {9000,0.0038286}, {9050,0.0038571}, {9100,0.0238000}, {9150,0.0038857}, {9200,0.0039143}, {9250,0.0039429}, {9300,0.0039714}, {9350,0.0202000}, {9400,0.0040000}, {9450,0.0040000}, {9500,0.0040000}, {9550,0.0040000}, {9600,0.0040000}, {9650,0.0040000}, {9700,0.0040000}, {9750,0.0040000}, {9800,0.0040000}, {9850,0.0168571}, {9900,0.0040286}, {9950,0.0040000}, {10000,0.0041429}, {10100,0.0040571}, {10200,0.0042000}, {10300,0.0043143}, {10400,0.0044857}, {10500,0.0045429}, {10600,0.0046000}, {10700,0.0047143}, {10800,0.0047429}, {10900,0.0047714}, {11000,0.0047714}, {11100,0.0047714}, {11200,0.0048000}, {11300,0.0047714}, {11400,0.0048286}, {11500,0.0048571}, {11600,0.0049429}, {11700,0.0049714}, {11800,0.0049714}, {11900,0.0050286}, {12000,0.0050286}, {12100,0.0050286}, {12200,0.0234000}, {12300,0.0052571}, {12400,0.0054000}, {12500,0.0055714}, {12600,0.0056286}, {12700,0.0056571}, {12800,0.0056571}, {12900,0.0057143}, {13000,0.0056857}, {13100,0.0057429}, {13200,0.0057429}, {13300,0.0056857}, {13400,0.0056857}, {13500,0.0057143}, {13600,0.0058857}, {13700,0.0058571}, {13800,0.0059714}, {13900,0.0059143}, {14000,0.0060571}, {14100,0.0060571}, {14200,0.0061714}, {14300,0.0242000}, {14400,0.0062857}, {14500,0.0064857}, {14600,0.0065714}, {14700,0.0066286}, {14800,0.0066857}, {14900,0.0066857}, {15000,0.0253143}, {15100,0.0067143}, {15200,0.0066857}, {15300,0.0066857}, {15400,0.0321429}, {15500,0.0066857}, {15600,0.0066571}, {15700,0.0066571}, {15800,0.0067429}, {15900,0.0067714}, {16000,0.0068857}, {16100,0.0069143}, {16200,0.0069714}, {16300,0.0072286}, {16400,0.0071714}, {16500,0.0073143}, {16600,0.0074000}, {16700,0.0075429}, {16800,0.0075714}, {16900,0.0075429}, {17000,0.0076286}, {17100,0.0076286}, {17200,0.0076286}, {17300,0.0376286}, {17400,0.0076571}, {17500,0.0076571}, {17600,0.0076571}, {17700,0.0076571}, {17800,0.0243429}, {17900,0.0076857}, {18000,0.0244857}, {18100,0.0077429}, {18200,0.0078286}, {18300,0.0080286}, {18400,0.0083143}, {18500,0.0082000}, {18600,0.0083714}, {18700,0.0085429}, {18800,0.0084286}, {18900,0.0086286}, {19000,0.0086286}, {19100,0.0086571}, {19200,0.0086571}, {19300,0.0086857}, {19400,0.0086571}, {19500,0.0086286}, {19600,0.0086286}, {19700,0.0086857}, {19800,0.0086571}, {19900,0.0086571}, {20000,0.0393143}};
data["big_flat"]["LtacTCPrimPair"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00002970}, {4,0.00003960}, {5,0.00002970}, {6,0.00002970}, {7,0.00003960}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00003960}, {15,0.00000000}, {16,0.00002970}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00003960}, {21,0.00000000}, {22,0.00006931}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00002970}, {27,0.00000000}, {28,0.00006931}, {29,0.00000000}, {30,0.00003960}, {31,0.00003960}, {32,0.00005941}, {33,0.00006931}, {34,0.00000000}, {35,0.00000000}, {36,0.00003960}, {37,0.00002970}, {38,0.00000000}, {39,0.00000000}, {40,0.00003960}, {41,0.00002970}, {42,0.00000000}, {43,0.00006931}, {44,0.00000000}, {45,0.00003960}, {46,0.00000000}, {47,0.00012871}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00006931}, {52,0.00000000}, {53,0.00006931}, {54,0.00003960}, {55,0.00000000}, {56,0.00000000}, {57,0.00003960}, {58,0.00000000}, {59,0.00002970}, {60,0.00006931}, {61,0.00009901}, {62,0.00002970}, {63,0.00003960}, {64,0.00002970}, {65,0.00002970}, {66,0.00003960}, {67,0.00002970}, {68,0.00000000}, {69,0.00011881}, {70,0.00002970}, {71,0.00003960}, {72,0.00000000}, {73,0.00000000}, {74,0.00008911}, {75,0.00003960}, {76,0.00002970}, {77,0.00006931}, {78,0.00008911}, {79,0.00005941}, {80,0.00005941}, {81,0.00006931}, {82,0.00000000}, {83,0.00000000}, {84,0.00002970}, {85,0.00003960}, {86,0.00002970}, {87,0.00002970}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00002970}, {92,0.00005941}, {93,0.00002970}, {94,0.00019802}, {95,0.00003960}, {96,0.00002970}, {97,0.00008911}, {98,0.00000000}, {99,0.00002970}, {100,0.00002970}, {101,0.00002970}, {102,0.00005941}, {103,0.00009901}, {104,0.00006931}, {105,0.00008911}, {106,0.00002970}, {107,0.00002970}, {108,0.00011881}, {109,0.00005941}, {110,0.00002970}, {111,0.00000000}, {112,0.00005941}, {113,0.00012871}, {114,0.00008911}, {115,0.00014851}, {116,0.00008911}, {117,0.00002970}, {118,0.00000000}, {119,0.00009901}, {120,0.00002970}, {121,0.00005941}, {122,0.00000000}, {123,0.00010891}, {124,0.00009901}, {125,0.00009901}, {126,0.00002970}, {127,0.00009901}, {128,0.00012871}, {129,0.00002970}, {130,0.00006931}, {131,0.00005941}, {132,0.00003960}, {133,0.00005941}, {134,0.00002970}, {135,0.00005941}, {136,0.00000000}, {137,0.00008911}, {138,0.00005941}, {139,0.00002970}, {140,0.00006931}, {141,0.00005941}, {142,0.00006931}, {143,0.00003960}, {144,0.00003960}, {145,0.00013861}, {146,0.00013861}, {147,0.00006931}, {148,0.00003960}, {149,0.00019802}, {150,0.00005941}, {151,0.00000000}, {152,0.00008911}, {153,0.00010891}, {154,0.00007921}, {155,0.00003960}, {156,0.00007921}, {157,0.00015842}, {158,0.00000000}, {159,0.00007921}, {160,0.00006931}, {161,0.00006931}, {162,0.00010891}, {163,0.00000000}, {164,0.00006931}, {165,0.00010891}, {166,0.00007921}, {167,0.00006931}, {168,0.00006931}, {169,0.00011881}, {170,0.00006931}, {171,0.00002970}, {172,0.00021782}, {173,0.00010891}, {174,0.00009901}, {175,0.00009901}, {176,0.00026733}, {177,0.00018812}, {178,0.00014851}, {179,0.00013861}, {180,0.00011881}, {181,0.00009901}, {182,0.00014851}, {183,0.00007921}, {184,0.00010891}, {185,0.00003960}, {186,0.00002970}, {187,0.00005941}, {188,0.00009901}, {189,0.00005941}, {190,0.00007921}, {191,0.00010891}, {192,0.00014851}, {193,0.00018812}, {194,0.00007921}, {195,0.00019802}, {196,0.00014851}, {197,0.00010891}, {198,0.00007921}, {199,0.00019802}, {200,0.00014851}, {201,0.00014851}, {202,0.00005941}, {203,0.00000000}, {204,0.00021782}, {205,0.00006931}, {206,0.00017822}, {207,0.00003960}, {208,0.00003960}, {209,0.00008911}, {210,0.00009901}, {211,0.00022772}, {212,0.00018812}, {213,0.00013861}, {214,0.00021782}, {215,0.00011881}, {216,0.00013861}, {217,0.00017822}, {218,0.00007921}, {219,0.00018812}, {220,0.00017822}, {221,0.00006931}, {222,0.00008911}, {223,0.00014851}, {224,0.00008911}, {225,0.00012871}, {226,0.00010891}, {227,0.00019802}, {228,0.00002970}, {229,0.00021782}, {230,0.00023762}, {231,0.00011881}, {232,0.00010891}, {233,0.00018812}, {234,0.00014851}, {235,0.00018812}, {236,0.00015842}, {237,0.00014851}, {238,0.00011881}, {239,0.00006931}, {240,0.00006931}, {241,0.00002970}, {242,0.00009901}, {243,0.00006931}, {244,0.00002970}, {245,0.00015842}, {246,0.00015842}, {247,0.00010891}, {248,0.00020792}, {249,0.00017822}, {250,0.00006931}, {251,0.00006931}, {252,0.00007921}, {253,0.00015842}, {254,0.00003960}, {255,0.00009901}, {256,0.00022772}, {257,0.00005941}, {258,0.00020792}, {259,0.00020792}, {260,0.00012871}, {261,0.00016832}, {262,0.00011881}, {263,0.00009901}, {264,0.00016832}, {265,0.00018812}, {266,0.00000000}, {267,0.00015842}, {268,0.00014851}, {269,0.00025743}, {270,0.00017822}, {271,0.00018812}, {272,0.00010891}, {273,0.00012871}, {274,0.00007921}, {275,0.00013861}, {276,0.00031683}, {277,0.00009901}, {278,0.00009901}, {279,0.00002970}, {280,0.00009901}, {281,0.00021782}, {282,0.00014851}, {283,0.00012871}, {284,0.00016832}, {285,0.00016832}, {286,0.00016832}, {287,0.00003960}, {288,0.00014851}, {289,0.00023762}, {290,0.00011881}, {291,0.00013861}, {292,0.00020792}, {293,0.00022772}, {294,0.00026733}, {295,0.00002970}, {296,0.00028713}, {297,0.00006931}, {298,0.00006931}, {299,0.00002970}, {300,0.00005941}, {301,0.00012871}, {302,0.00014851}, {303,0.00009901}, {304,0.00012871}, {305,0.00015842}, {306,0.00008911}, {307,0.00014851}, {308,0.00023762}, {309,0.00012871}, {310,0.00005941}, {311,0.00018812}, {312,0.00012871}, {313,0.00024752}, {314,0.00006931}, {315,0.00010891}, {316,0.00019802}, {317,0.00008911}, {318,0.00017822}, {319,0.00008911}, {320,0.00014851}, {321,0.00028713}, {322,0.00016832}, {323,0.00009901}, {324,0.00015842}, {325,0.00014851}, {326,0.00016832}, {327,0.00013861}, {328,0.00018812}, {329,0.00005941}, {330,0.00009901}, {331,0.00015842}, {332,0.00025743}, {333,0.00015842}, {334,0.00013861}, {335,0.00006931}, {336,0.00006931}, {337,0.00012871}, {338,0.00030693}, {339,0.00028713}, {340,0.00016832}, {341,0.00013861}, {342,0.00005941}, {343,0.00019802}, {344,0.00010891}, {345,0.00005941}, {346,0.00016832}, {347,0.00012871}, {348,0.00033663}, {349,0.00024752}, {350,0.00010891}, {351,0.00029703}, {352,0.00024752}, {353,0.00021782}, {354,0.00005941}, {355,0.00000000}, {356,0.00023762}, {357,0.00024752}, {358,0.00011881}, {359,0.00006931}, {360,0.00021782}, {361,0.00006931}, {362,0.00022772}, {363,0.00022772}, {364,0.00007921}, {365,0.00014851}, {366,0.00020792}, {367,0.00023762}, {368,0.00021782}, {369,0.00006931}, {370,0.00003960}, {371,0.00019802}, {372,0.00015842}, {373,0.00014851}, {374,0.00014851}, {375,0.00021782}, {376,0.00017822}, {377,0.00022772}, {378,0.00017822}, {379,0.00024752}, {380,0.00013861}, {381,0.00007921}, {382,0.00033663}, {383,0.00016832}, {384,0.00003960}, {385,0.00010891}, {386,0.00030693}, {387,0.00006931}, {388,0.00026733}, {389,0.00024752}, {390,0.00014851}, {391,0.00009901}, {392,0.00013861}, {393,0.00027723}, {394,0.00028713}, {395,0.00034653}, {396,0.00009901}, {397,0.00014851}, {398,0.00017822}, {399,0.00014851}, {400,0.00023762}, {401,0.00032673}, {402,0.00018812}, {403,0.00022772}, {404,0.00033663}, {405,0.00018812}, {406,0.00023762}, {407,0.00017822}, {408,0.00014851}, {409,0.00013861}, {410,0.00012871}, {411,0.00027723}, {412,0.00024752}, {413,0.00009901}, {414,0.00002970}, {415,0.00031683}, {416,0.00049505}, {417,0.00013861}, {418,0.00010891}, {419,0.00019802}, {420,0.00018812}, {421,0.00030693}, {422,0.00018812}, {423,0.00016832}, {424,0.00014851}, {425,0.00023762}, {426,0.00021782}, {427,0.00002970}, {428,0.00018812}, {429,0.00015842}, {430,0.00010891}, {431,0.00020792}, {432,0.00040594}, {433,0.00020792}, {434,0.00028713}, {435,0.00015842}, {436,0.00018812}, {437,0.00005941}, {438,0.00018812}, {439,0.00012871}, {440,0.00016832}, {441,0.00032673}, {442,0.00010891}, {443,0.00025743}, {444,0.00018812}, {445,0.00014851}, {446,0.00026733}, {447,0.00018812}, {448,0.00008911}, {449,0.00011881}, {450,0.00040594}, {451,0.00024752}, {452,0.00024752}, {453,0.00017822}, {454,0.00020792}, {455,0.00018812}, {456,0.00022772}, {457,0.00020792}, {458,0.00039604}, {459,0.00028713}, {460,0.00021782}, {461,0.00035644}, {462,0.00034653}, {463,0.00014851}, {464,0.00013861}, {465,0.00010891}, {466,0.00023762}, {467,0.00022772}, {468,0.00034653}, {469,0.00002970}, {470,0.00025743}, {471,0.00006931}, {472,0.00012871}, {473,0.00033663}, {474,0.00024752}, {475,0.00013861}, {476,0.00021782}, {477,0.00021782}, {478,0.00020792}, {479,0.00015842}, {480,0.00022772}, {481,0.00033663}, {482,0.00016832}, {483,0.00038614}, {484,0.00021782}, {485,0.00017822}, {486,0.00029703}, {487,0.00025743}, {488,0.00037624}, {489,0.00041584}, {490,0.00022772}, {491,0.00035644}, {492,0.00022772}, {493,0.00013861}, {494,0.00018812}, {495,0.00021782}, {496,0.00025743}, {497,0.00020792}, {498,0.00025743}, {499,0.00020792}, {500,0.00053465}, {505,0.00018812}, {510,0.00013861}, {515,0.00014851}, {520,0.00030693}, {525,0.00013861}, {530,0.00038614}, {535,0.00017822}, {540,0.00028713}, {545,0.00006931}, {550,0.00027723}, {555,0.00015842}, {560,0.00008911}, {565,0.00031683}, {570,0.00019802}, {575,0.00019802}, {580,0.00040594}, {585,0.00037624}, {590,0.00021782}, {595,0.00012871}, {600,0.00018812}, {605,0.00030693}, {610,0.00037624}, {615,0.00026733}, {620,0.00014851}, {625,0.00018812}, {630,0.00024752}, {635,0.00026733}, {640,0.00030693}, {645,0.00020792}, {650,0.00017822}, {655,0.00029703}, {660,0.00014851}, {665,0.00049505}, {670,0.00046535}, {675,0.00036634}, {680,0.00028713}, {685,0.00049505}, {690,0.00029703}, {695,0.00019802}, {700,0.00028713}, {705,0.00034653}, {710,0.00049505}, {715,0.00044554}, {720,0.00023762}, {725,0.00012871}, {730,0.00027723}, {735,0.00028713}, {740,0.00018812}, {745,0.00038614}, {750,0.00032673}, {755,0.00031683}, {760,0.00049505}, {765,0.00022772}, {770,0.00023762}, {775,0.00046535}, {780,0.00024752}, {785,0.00026733}, {790,0.00048515}, {795,0.00028713}, {800,0.00032673}, {805,0.00022772}, {810,0.00021782}, {815,0.00031683}, {820,0.00019802}, {825,0.00011881}, {830,0.00025743}, {835,0.00034653}, {840,0.00025743}, {845,0.00038614}, {850,0.00029703}, {855,0.00036634}, {860,0.00045545}, {865,0.00021782}, {870,0.00022772}, {875,0.00024752}, {880,0.00015842}, {885,0.00022772}, {890,0.00036634}, {895,0.00030693}, {900,0.00032673}, {905,0.00038614}, {910,0.00025743}, {915,0.00020792}, {920,0.00039604}, {925,0.00032673}, {930,0.00034653}, {935,0.00023762}, {940,0.00027723}, {945,0.00025743}, {950,0.00045545}, {955,0.00019802}, {960,0.00024752}, {965,0.00025743}, {970,0.00035644}, {975,0.00028713}, {980,0.00028713}, {985,0.00030693}, {990,0.00032673}, {995,0.00047525}, {1000,0.00047525}, {1010,0.00032673}, {1020,0.00018812}, {1030,0.00030693}, {1040,0.00041584}, {1050,0.00028713}, {1060,0.00026733}, {1070,0.00038614}, {1080,0.00025743}, {1090,0.00050495}, {1100,0.00050495}, {1110,0.00026733}, {1120,0.00053465}, {1130,0.00022772}, {1140,0.00048515}, {1150,0.00028713}, {1160,0.00040594}, {1170,0.00035644}, {1180,0.00046535}, {1190,0.00029703}, {1200,0.00057426}, {1210,0.00044554}, {1220,0.00151485}, {1230,0.00040594}, {1240,0.00053465}, {1250,0.00048515}, {1260,0.00061386}, {1270,0.00046535}, {1280,0.00084158}, {1290,0.00040594}, {1300,0.00043564}, {1310,0.00064356}, {1320,0.00080198}, {1330,0.00054455}, {1340,0.00057426}, {1350,0.00046535}, {1360,0.00030693}, {1370,0.00039604}, {1380,0.00063366}, {1390,0.00052475}, {1400,0.00054455}, {1410,0.00058416}, {1420,0.00046535}, {1430,0.00051485}, {1440,0.00036634}, {1450,0.00072277}, {1460,0.00075248}, {1470,0.00062376}, {1480,0.00058416}, {1490,0.00052475}, {1500,0.00065347}, {1510,0.00062376}, {1520,0.00055446}, {1530,0.00057426}, {1540,0.00056436}, {1550,0.00041584}, {1560,0.00068317}, {1570,0.00046535}, {1580,0.00060396}, {1590,0.00048515}, {1600,0.00026733}, {1610,0.00062376}, {1620,0.00041584}, {1630,0.00074257}, {1640,0.00043564}, {1650,0.00066337}, {1660,0.00061386}, {1670,0.00060396}, {1680,0.00089109}, {1690,0.00058416}, {1700,0.00053465}, {1710,0.00088119}, {1720,0.00052475}, {1730,0.00082178}, {1740,0.00065347}, {1750,0.00251485}, {1760,0.00061386}, {1770,0.00051485}, {1780,0.00041584}, {1790,0.00074257}, {1800,0.00068317}, {1810,0.00058416}, {1820,0.00046535}, {1830,0.00040594}, {1840,0.00044554}, {1850,0.00062376}, {1860,0.00088119}, {1870,0.00078218}, {1880,0.00067327}, {1890,0.00076238}, {1900,0.00070297}, {1910,0.00067327}, {1920,0.00065347}, {1930,0.00059406}, {1940,0.00038614}, {1950,0.00073267}, {1960,0.00096040}, {1970,0.00081188}, {1980,0.00076238}, {1990,0.00048515}, {2000,0.00104950}, {2050,0.00078218}, {2100,0.00061386}, {2150,0.00084158}, {2200,0.00087129}, {2250,0.00071287}, {2300,0.00059406}, {2350,0.00119802}, {2400,0.00109901}, {2450,0.00112871}, {2500,0.00073267}, {2550,0.00108911}, {2600,0.00100000}, {2650,0.00135644}, {2700,0.00102970}, {2750,0.00101980}, {2800,0.00108911}, {2850,0.00123762}, {2900,0.00109901}, {2950,0.00449505}, {3000,0.00135644}, {3050,0.00113861}, {3100,0.00137624}, {3150,0.00120792}, {3200,0.00117822}, {3250,0.00084158}, {3300,0.00109901}, {3350,0.00102970}, {3400,0.00115842}, {3450,0.00131683}, {3500,0.00119802}, {3550,0.00147525}, {3600,0.00123762}, {3650,0.00142574}, {3700,0.00116832}, {3750,0.00144554}, {3800,0.00156436}, {3850,0.00141584}, {3900,0.00113861}, {3950,0.00110891}, {4000,0.00131683}, {4050,0.00159406}, {4100,0.00127723}, {4150,0.00923762}, {4200,0.00169307}, {4250,0.00186139}, {4300,0.00167327}, {4350,0.00186139}, {4400,0.00158416}, {4450,0.00201980}, {4500,0.00177228}, {4550,0.00180198}, {4600,0.00160396}, {4650,0.00169307}, {4700,0.00173267}, {4750,0.00172277}, {4800,0.00181188}, {4850,0.00170297}, {4900,0.00227723}, {4950,0.00177228}, {5000,0.00174257}, {5050,0.00200000}, {5100,0.00220792}, {5150,0.00212871}, {5200,0.00171287}, {5250,0.00198020}, {5300,0.00246535}, {5350,0.00235644}, {5400,0.00234653}, {5450,0.00226733}, {5500,0.00181188}, {5550,0.00216832}, {5600,0.00226733}, {5650,0.00262376}, {5700,0.00236634}, {5750,0.00234653}, {5800,0.00234653}, {5850,0.00226733}, {5900,0.00235644}, {5950,0.00230693}, {6000,0.00281188}, {6050,0.0021714}, {6100,0.0025143}, {6150,0.0022857}, {6200,0.0020000}, {6250,0.0021143}, {6300,0.0022571}, {6350,0.0024857}, {6400,0.0028571}, {6450,0.0019143}, {6500,0.0026857}, {6550,0.0026571}, {6600,0.0024571}, {6650,0.0031143}, {6700,0.0032000}, {6750,0.0034571}, {6800,0.0025714}, {6850,0.0025714}, {6900,0.0026571}, {6950,0.0153714}, {7000,0.0026857}, {7050,0.0028571}, {7100,0.0025429}, {7150,0.0026857}, {7200,0.0025429}, {7250,0.0024857}, {7300,0.0030571}, {7350,0.0029429}, {7400,0.0026857}, {7450,0.0027714}, {7500,0.0031143}, {7550,0.0027714}, {7600,0.0028571}, {7650,0.0131714}, {7700,0.0033429}, {7750,0.0033714}, {7800,0.0034571}, {7850,0.0036571}, {7900,0.0028857}, {7950,0.0035429}, {8000,0.0036857}, {8050,0.0033714}, {8100,0.0031429}, {8150,0.0034000}, {8200,0.0033714}, {8250,0.0035429}, {8300,0.0036286}, {8350,0.0036286}, {8400,0.0119429}, {8450,0.0036571}, {8500,0.0035429}, {8550,0.0037429}, {8600,0.0036000}, {8650,0.0038286}, {8700,0.0043143}, {8750,0.0038857}, {8800,0.0037429}, {8850,0.0038286}, {8900,0.0037143}, {8950,0.0037143}, {9000,0.0038286}, {9050,0.0043429}, {9100,0.0239429}, {9150,0.0038286}, {9200,0.0042000}, {9250,0.0038571}, {9300,0.0041429}, {9350,0.0203714}, {9400,0.0041429}, {9450,0.0036857}, {9500,0.0044286}, {9550,0.0043143}, {9600,0.0042286}, {9650,0.0042286}, {9700,0.0043714}, {9750,0.0046857}, {9800,0.0041143}, {9850,0.0168857}, {9900,0.0040000}, {9950,0.0039429}, {10000,0.0049429}, {10100,0.0043143}, {10200,0.0049714}, {10300,0.0049429}, {10400,0.0043429}, {10500,0.0046286}, {10600,0.0048000}, {10700,0.0048571}, {10800,0.0046571}, {10900,0.0042857}, {11000,0.0052286}, {11100,0.0049429}, {11200,0.0050000}, {11300,0.0052571}, {11400,0.0046857}, {11500,0.0049429}, {11600,0.0052857}, {11700,0.0055143}, {11800,0.0056857}, {11900,0.0048857}, {12000,0.0053714}, {12100,0.0050286}, {12200,0.0237429}, {12300,0.0059143}, {12400,0.0055143}, {12500,0.0050286}, {12600,0.0059714}, {12700,0.0051429}, {12800,0.0062000}, {12900,0.0059429}, {13000,0.0053714}, {13100,0.0053143}, {13200,0.0059143}, {13300,0.0053143}, {13400,0.0057429}, {13500,0.0056857}, {13600,0.0057143}, {13700,0.0052286}, {13800,0.0060286}, {13900,0.0064000}, {14000,0.0055429}, {14100,0.0060286}, {14200,0.0057143}, {14300,0.0237714}, {14400,0.0063714}, {14500,0.0066286}, {14600,0.0066857}, {14700,0.0066571}, {14800,0.0061143}, {14900,0.0061143}, {15000,0.0248857}, {15100,0.0065429}, {15200,0.0062571}, {15300,0.0072000}, {15400,0.0320000}, {15500,0.0070000}, {15600,0.0067714}, {15700,0.0065714}, {15800,0.0070571}, {15900,0.0069714}, {16000,0.0070857}, {16100,0.0073143}, {16200,0.0077429}, {16300,0.0075429}, {16400,0.0075429}, {16500,0.0074857}, {16600,0.0078571}, {16700,0.0075429}, {16800,0.0076286}, {16900,0.0078000}, {17000,0.0077429}, {17100,0.0072857}, {17200,0.0079714}, {17300,0.0371429}, {17400,0.0080286}, {17500,0.0080286}, {17600,0.0078000}, {17700,0.0078286}, {17800,0.0244000}, {17900,0.0077714}, {18000,0.0240000}, {18100,0.0078857}, {18200,0.0081143}, {18300,0.0081143}, {18400,0.0084000}, {18500,0.0082286}, {18600,0.0082857}, {18700,0.0082857}, {18800,0.0078571}, {18900,0.0082286}, {19000,0.0081143}, {19100,0.0084571}, {19200,0.0085714}, {19300,0.0082857}, {19400,0.0087143}, {19500,0.0084571}, {19600,0.0087143}, {19700,0.0088857}, {19800,0.0091143}, {19900,0.0088000}, {20000,0.0395143}};
data["big_flat"]["LtacTCPrimPair"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00003960}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00003960}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00003960}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00003960}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00003960}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00003960}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00003960}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00003960}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00002970}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00003960}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00003960}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00003960}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00003960}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00003960}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00003960}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00003960}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00003960}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00003960}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00003960}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00007921}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00003960}, {1410,0.00003960}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00003960}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00003960}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00003960}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00003960}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00003960}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00003960}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00003960}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00003960}, {3550,0.00003960}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00003960}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00003960}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00003960}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00003960}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00003960}, {4900,0.00003960}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00003960}, {5300,0.00003960}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00007921}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00003960}, {5750,0.00003960}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0003429}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0001143}, {6750,0.0001143}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0001143}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0001143}, {8250,0.0001143}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0001143}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0001143}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0001143}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0001143}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0001143}, {12100,0.0001143}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0001143}, {13600,0.0000000}, {13700,0.0001143}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0001143}, {14100,0.0001143}, {14200,0.0001143}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0001143}, {14900,0.0001143}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0002286}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0001143}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0001143}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCPrimPair"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00004950}, {7,0.00073267}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100990}, {12,0.00100000}, {13,0.00100990}, {14,0.00124752}, {15,0.00159406}, {16,0.00200000}, {17,0.00200000}, {18,0.00200000}, {19,0.00200000}, {20,0.00200000}, {21,0.00213861}, {22,0.00227723}, {23,0.00274257}, {24,0.00300000}, {25,0.00300000}, {26,0.00300000}, {27,0.00300000}, {28,0.00305941}, {29,0.00310891}, {30,0.00328713}, {31,0.00379208}, {32,0.00400000}, {33,0.00400000}, {34,0.00400000}, {35,0.00400990}, {36,0.00422772}, {37,0.00431683}, {38,0.00434653}, {39,0.00470297}, {40,0.00499010}, {41,0.00500000}, {42,0.00500000}, {43,0.00503960}, {44,0.00508911}, {45,0.00519802}, {46,0.00521782}, {47,0.00572277}, {48,0.00597030}, {49,0.00600000}, {50,0.00601980}, {51,0.00614851}, {52,0.00613861}, {53,0.00628713}, {54,0.00644554}, {55,0.00774257}, {56,0.00697030}, {57,0.00702970}, {58,0.00706931}, {59,0.00717822}, {60,0.00717822}, {61,0.00734653}, {62,0.00727723}, {63,0.00760396}, {64,0.00789109}, {65,0.00808911}, {66,0.00815842}, {67,0.00826733}, {68,0.00817822}, {69,0.00828713}, {70,0.00925743}, {71,0.00872277}, {72,0.00890099}, {73,0.00917822}, {74,0.00904950}, {75,0.00912871}, {76,0.00933663}, {77,0.00923762}, {78,0.00931683}, {79,0.00962376}, {80,0.01354455}, {81,0.01013861}, {82,0.01016832}, {83,0.01017822}, {84,0.01017822}, {85,0.01022772}, {86,0.01047525}, {87,0.01124752}, {88,0.01412871}, {89,0.01114851}, {90,0.01111881}, {91,0.01118812}, {92,0.01120792}, {93,0.01131683}, {94,0.01147525}, {95,0.01180198}, {96,0.01188119}, {97,0.01213861}, {98,0.01216832}, {99,0.01226733}, {100,0.01233663}, {101,0.01236634}, {102,0.01244554}, {103,0.01265347}, {104,0.01799010}, {105,0.01556436}, {106,0.01308911}, {107,0.01316832}, {108,0.01326733}, {109,0.01348515}, {110,0.01346535}, {111,0.01375248}, {112,0.01385149}, {113,0.01669307}, {114,0.01408911}, {115,0.01427723}, {116,0.01437624}, {117,0.01443564}, {118,0.01913861}, {119,0.01458416}, {120,0.01492079}, {121,0.01513861}, {122,0.01513861}, {123,0.01517822}, {124,0.01537624}, {125,0.01536634}, {126,0.01927723}, {127,0.01566337}, {128,0.01584158}, {129,0.02245545}, {130,0.01613861}, {131,0.01629703}, {132,0.02236634}, {133,0.01644554}, {134,0.01651485}, {135,0.02012871}, {136,0.01690099}, {137,0.01716832}, {138,0.01713861}, {139,0.01727723}, {140,0.01982178}, {141,0.01735644}, {142,0.02349505}, {143,0.01793069}, {144,0.01781188}, {145,0.01815842}, {146,0.01827723}, {147,0.01817822}, {148,0.01841584}, {149,0.01836634}, {150,0.01872277}, {151,0.01896040}, {152,0.02527723}, {153,0.01902970}, {154,0.02219802}, {155,0.01932673}, {156,0.01924752}, {157,0.01963366}, {158,0.01959406}, {159,0.02266337}, {160,0.01984158}, {161,0.02008911}, {162,0.02724752}, {163,0.02036634}, {164,0.02039604}, {165,0.02164356}, {166,0.02065347}, {167,0.02069307}, {168,0.02643564}, {169,0.02119802}, {170,0.02122772}, {171,0.02236634}, {172,0.02137624}, {173,0.02161386}, {174,0.02160396}, {175,0.02186139}, {176,0.02916832}, {177,0.02238614}, {178,0.02222772}, {179,0.02239604}, {180,0.02306931}, {181,0.02861386}, {182,0.02299010}, {183,0.02269307}, {184,0.02270297}, {185,0.02322772}, {186,0.02325743}, {187,0.02334653}, {188,0.02686139}, {189,0.02979208}, {190,0.03202970}, {191,0.02398020}, {192,0.02411881}, {193,0.02437624}, {194,0.02434653}, {195,0.02436634}, {196,0.02463366}, {197,0.02461386}, {198,0.02467327}, {199,0.02489109}, {200,0.02479208}, {201,0.02504950}, {202,0.02510891}, {203,0.02557426}, {204,0.02561386}, {205,0.02558416}, {206,0.03345545}, {207,0.03092079}, {208,0.03009901}, {209,0.02600000}, {210,0.02614851}, {211,0.02627723}, {212,0.02653465}, {213,0.02648515}, {214,0.04052475}, {215,0.03363366}, {216,0.02676238}, {217,0.02708911}, {218,0.02724752}, {219,0.02757426}, {220,0.03295050}, {221,0.02747525}, {222,0.02765347}, {223,0.02801980}, {224,0.03454455}, {225,0.02812871}, {226,0.02818812}, {227,0.02857426}, {228,0.03240594}, {229,0.02856436}, {230,0.02872277}, {231,0.03409901}, {232,0.02892079}, {233,0.02912871}, {234,0.03391089}, {235,0.02945545}, {236,0.02963366}, {237,0.03133663}, {238,0.02978218}, {239,0.03726733}, {240,0.03009901}, {241,0.03036634}, {242,0.03022772}, {243,0.03060396}, {244,0.03335644}, {245,0.03072277}, {246,0.03556436}, {247,0.03096040}, {248,0.03700990}, {249,0.03130693}, {250,0.03751485}, {251,0.03150495}, {252,0.03582178}, {253,0.03176238}, {254,0.03296040}, {255,0.03232673}, {256,0.03183168}, {257,0.04243564}, {258,0.03258416}, {259,0.03743564}, {260,0.03266337}, {261,0.03263366}, {262,0.04255446}, {263,0.03308911}, {264,0.03375248}, {265,0.04447525}, {266,0.03328713}, {267,0.03440594}, {268,0.04360396}, {269,0.03377228}, {270,0.03383168}, {271,0.04341584}, {272,0.03439604}, {273,0.03418812}, {274,0.03576238}, {275,0.04309901}, {276,0.03469307}, {277,0.03506931}, {278,0.03498020}, {279,0.04013861}, {280,0.04540594}, {281,0.03575248}, {282,0.03527723}, {283,0.03587129}, {284,0.03655446}, {285,0.04125743}, {286,0.04468317}, {287,0.04854455}, {288,0.03645545}, {289,0.03623762}, {290,0.03637624}, {291,0.03681188}, {292,0.03660396}, {293,0.03676238}, {294,0.03827723}, {295,0.04014851}, {296,0.04060396}, {297,0.04159406}, {298,0.04213861}, {299,0.04088119}, {300,0.04261386}, {301,0.04098020}, {302,0.04416832}, {303,0.04247525}, {304,0.04041584}, {305,0.03853465}, {306,0.03837624}, {307,0.03869307}, {308,0.03881188}, {309,0.03880198}, {310,0.03906931}, {311,0.05346535}, {312,0.04964356}, {313,0.04673267}, {314,0.04189109}, {315,0.04001980}, {316,0.03990099}, {317,0.04018812}, {318,0.05140594}, {319,0.04585149}, {320,0.04068317}, {321,0.04061386}, {322,0.04050495}, {323,0.04992079}, {324,0.04405941}, {325,0.04098020}, {326,0.04146535}, {327,0.05034653}, {328,0.04314851}, {329,0.04189109}, {330,0.05409901}, {331,0.04936634}, {332,0.04187129}, {333,0.04466337}, {334,0.04815842}, {335,0.04225743}, {336,0.05622772}, {337,0.04584158}, {338,0.04264356}, {339,0.05261386}, {340,0.04299010}, {341,0.04329703}, {342,0.04692079}, {343,0.04359406}, {344,0.05032673}, {345,0.04323762}, {346,0.05300000}, {347,0.04400000}, {348,0.05418812}, {349,0.04400000}, {350,0.05500990}, {351,0.04458416}, {352,0.05341584}, {353,0.04425743}, {354,0.05238614}, {355,0.04507921}, {356,0.05036634}, {357,0.04543564}, {358,0.04844554}, {359,0.06502970}, {360,0.04498020}, {361,0.05404950}, {362,0.04567327}, {363,0.04770297}, {364,0.05865347}, {365,0.04601980}, {366,0.04937624}, {367,0.05898020}, {368,0.04634653}, {369,0.04867327}, {370,0.05671287}, {371,0.04696040}, {372,0.04687129}, {373,0.05259406}, {374,0.06017822}, {375,0.04725743}, {376,0.04758416}, {377,0.05298020}, {378,0.05913861}, {379,0.04762376}, {380,0.04792079}, {381,0.04985149}, {382,0.05615842}, {383,0.06012871}, {384,0.06363366}, {385,0.04848515}, {386,0.04884158}, {387,0.04863366}, {388,0.05246535}, {389,0.05671287}, {390,0.06023762}, {391,0.06296040}, {392,0.06476238}, {393,0.04966337}, {394,0.04970297}, {395,0.05017822}, {396,0.04989109}, {397,0.04998020}, {398,0.05017822}, {399,0.05023762}, {400,0.05046535}, {401,0.05037624}, {402,0.05055446}, {403,0.05118812}, {404,0.05058416}, {405,0.05125743}, {406,0.05153465}, {407,0.05167327}, {408,0.05116832}, {409,0.06528713}, {410,0.06462376}, {411,0.06220792}, {412,0.05943564}, {413,0.05666337}, {414,0.05348515}, {415,0.05258416}, {416,0.05227723}, {417,0.07487129}, {418,0.06750495}, {419,0.06028713}, {420,0.05509901}, {421,0.05321782}, {422,0.07299010}, {423,0.06595050}, {424,0.05910891}, {425,0.05344554}, {426,0.05441584}, {427,0.06590099}, {428,0.05921782}, {429,0.05410891}, {430,0.07029703}, {431,0.06333663}, {432,0.05448515}, {433,0.05479208}, {434,0.06937624}, {435,0.05681188}, {436,0.05755446}, {437,0.06539604}, {438,0.05520792}, {439,0.07310891}, {440,0.06041584}, {441,0.05555446}, {442,0.06636634}, {443,0.05608911}, {444,0.06924752}, {445,0.05869307}, {446,0.07212871}, {447,0.06059406}, {448,0.07343564}, {449,0.06211881}, {450,0.05681188}, {451,0.06723762}, {452,0.05698020}, {453,0.06628713}, {454,0.05778218}, {455,0.06334653}, {456,0.07390099}, {457,0.06032673}, {458,0.07286139}, {459,0.05811881}, {460,0.06806931}, {461,0.05834653}, {462,0.06296040}, {463,0.07297030}, {464,0.05840594}, {465,0.06692079}, {466,0.07359406}, {467,0.05903960}, {468,0.07185149}, {469,0.07922772}, {470,0.05955446}, {471,0.06883168}, {472,0.07573267}, {473,0.06000000}, {474,0.06362376}, {475,0.07132673}, {476,0.07732673}, {477,0.06074257}, {478,0.06370297}, {479,0.06988119}, {480,0.07305941}, {481,0.06074257}, {482,0.06062376}, {483,0.06683168}, {484,0.07156436}, {485,0.07630693}, {486,0.07984158}, {487,0.06163366}, {488,0.06142574}, {489,0.06404950}, {490,0.06743564}, {491,0.07053465}, {492,0.07276238}, {493,0.07314851}, {494,0.08389109}, {495,0.08363366}, {496,0.08162376}, {497,0.08346535}, {498,0.08440594}, {499,0.06511881}, {500,0.06339604}, {505,0.06442574}, {510,0.08381188}, {515,0.08181188}, {520,0.07877228}, {525,0.07560396}, {530,0.06979208}, {535,0.09716832}, {540,0.08332673}, {545,0.07310891}, {550,0.08742574}, {555,0.07653465}, {560,0.08746535}, {565,0.07485149}, {570,0.08361386}, {575,0.09276238}, {580,0.07371287}, {585,0.08403960}, {590,0.08709901}, {595,0.09095050}, {600,0.09280198}, {605,0.09353465}, {610,0.09215842}, {615,0.09084158}, {620,0.08820792}, {625,0.08709901}, {630,0.11564356}, {635,0.10017822}, {640,0.08996040}, {645,0.10886139}, {650,0.09665347}, {655,0.08640594}, {660,0.09747525}, {665,0.10284158}, {670,0.09628713}, {675,0.10509901}, {680,0.11200000}, {685,0.09303960}, {690,0.09690099}, {695,0.10109901}, {700,0.10261386}, {705,0.10625743}, {710,0.10691089}, {715,0.10479208}, {720,0.10136634}, {725,0.09880198}, {730,0.11822772}, {735,0.12143564}, {740,0.10575248}, {745,0.12293069}, {750,0.11167327}, {755,0.12454455}, {760,0.11152475}, {765,0.13524752}, {770,0.10940594}, {775,0.11902970}, {780,0.12478218}, {785,0.10718812}, {790,0.10996040}, {795,0.11981188}, {800,0.11885149}, {805,0.12212871}, {810,0.12193069}, {815,0.12119802}, {820,0.12602970}, {825,0.11773267}, {830,0.13884158}, {835,0.12899010}, {840,0.12208911}, {845,0.15411881}, {850,0.13277228}, {855,0.12098020}, {860,0.13136634}, {865,0.14200990}, {870,0.13204950}, {875,0.14224752}, {880,0.14633663}, {885,0.12771287}, {890,0.12767327}, {895,0.14085149}, {900,0.13958416}, {905,0.13905941}, {910,0.13952475}, {915,0.13307921}, {920,0.14020792}, {925,0.13661386}, {930,0.12995050}, {935,0.14860396}, {940,0.15203960}, {945,0.13772277}, {950,0.15039604}, {955,0.13893069}, {960,0.14444554}, {965,0.14237624}, {970,0.15136634}, {975,0.15779208}, {980,0.14171287}, {985,0.15243564}, {990,0.15705941}, {995,0.15732673}, {1000,0.16034653}, {1010,0.16996040}, {1020,0.16600000}, {1030,0.16037624}, {1040,0.17026733}, {1050,0.15361386}, {1060,0.16626733}, {1070,0.15457426}, {1080,0.16959406}, {1090,0.17629703}, {1100,0.17736634}, {1110,0.20216832}, {1120,0.17774257}, {1130,0.17936634}, {1140,0.17545545}, {1150,0.17290099}, {1160,0.18696040}, {1170,0.17176238}, {1180,0.18958416}, {1190,0.19310891}, {1200,0.19522772}, {1210,0.17906931}, {1220,0.17747525}, {1230,0.19801980}, {1240,0.19953465}, {1250,0.18918812}, {1260,0.20210891}, {1270,0.19702970}, {1280,0.19845545}, {1290,0.20296040}, {1300,0.19025743}, {1310,0.19504950}, {1320,0.20832673}, {1330,0.19812871}, {1340,0.21404950}, {1350,0.21420792}, {1360,0.19957426}, {1370,0.22328713}, {1380,0.21686139}, {1390,0.20752475}, {1400,0.22209901}, {1410,0.21649505}, {1420,0.21483168}, {1430,0.21905941}, {1440,0.21046535}, {1450,0.23737624}, {1460,0.22170297}, {1470,0.24485149}, {1480,0.22285149}, {1490,0.22745545}, {1500,0.24150495}, {1510,0.23480198}, {1520,0.24529703}, {1530,0.23882178}, {1540,0.23966337}, {1550,0.23367327}, {1560,0.24186139}, {1570,0.23002970}, {1580,0.24433663}, {1590,0.26275248}, {1600,0.23371287}, {1610,0.24714851}, {1620,0.24105941}, {1630,0.24856436}, {1640,0.25783168}, {1650,0.26327723}, {1660,0.24705941}, {1670,0.26672277}, {1680,0.24726733}, {1690,0.26438614}, {1700,0.26171287}, {1710,0.27620792}, {1720,0.26669307}, {1730,0.27422772}, {1740,0.26249505}, {1750,0.25684158}, {1760,0.27142574}, {1770,0.26554455}, {1780,0.27458416}, {1790,0.28951485}, {1800,0.30814851}, {1810,0.27029703}, {1820,0.28861386}, {1830,0.29467327}, {1840,0.29906931}, {1850,0.28498020}, {1860,0.28677228}, {1870,0.29167327}, {1880,0.28814851}, {1890,0.31581188}, {1900,0.29428713}, {1910,0.30880198}, {1920,0.29811881}, {1930,0.30739604}, {1940,0.32518812}, {1950,0.29315842}, {1960,0.31708911}, {1970,0.29739604}, {1980,0.31335644}, {1990,0.33841584}, {2000,0.29853465}, {2050,0.31757426}, {2100,0.33027723}, {2150,0.34182178}, {2200,0.34967327}, {2250,0.34825743}, {2300,0.35037624}, {2350,0.36438614}, {2400,0.40888119}, {2450,0.38576238}, {2500,0.38533663}, {2550,0.40463366}, {2600,0.42753465}, {2650,0.41758416}, {2700,0.45942574}, {2750,0.44303960}, {2800,0.43326733}, {2850,0.44791089}, {2900,0.46984158}, {2950,0.45233663}, {3000,0.48071287}, {3050,0.48769307}, {3100,0.48624752}, {3150,0.50015842}, {3200,0.52425743}, {3250,0.51601980}, {3300,0.53602970}, {3350,0.54719802}, {3400,0.54234653}, {3450,0.55887129}, {3500,0.55574257}, {3550,0.56657426}, {3600,0.58203960}, {3650,0.57012871}, {3700,0.58891089}, {3750,0.61331683}, {3800,0.63301980}, {3850,0.63335644}, {3900,0.62286139}, {3950,0.63180198}, {4000,0.64263366}, {4050,0.65478218}, {4100,0.67436634}, {4150,0.65740594}, {4200,0.67615842}, {4250,0.69523762}, {4300,0.70466337}, {4350,0.70754455}, {4400,0.70555446}, {4450,0.74054455}, {4500,0.71282178}, {4550,0.73046535}, {4600,0.76432673}, {4650,0.73508911}, {4700,0.78236634}, {4750,0.77286139}, {4800,0.77364356}, {4850,0.78879208}, {4900,0.79279208}, {4950,0.80324752}, {5000,0.80774257}, {5050,0.81835644}, {5100,0.84702970}, {5150,0.84750495}, {5200,0.86109901}, {5250,0.85938614}, {5300,0.88429703}, {5350,0.88212871}, {5400,0.87513861}, {5450,0.90659406}, {5500,0.89618812}, {5550,0.90423762}, {5600,0.91762376}, {5650,0.90343564}, {5700,0.91194059}, {5750,0.94616832}, {5800,0.94962376}, {5850,0.94386139}, {5900,0.96149505}, {5950,0.98469307}, {6000,0.98921782}, {6050,1.0285429}, {6100,1.0254571}, {6150,1.0464286}, {6200,1.0557714}, {6250,1.0728571}, {6300,1.0736857}, {6350,1.1119143}, {6400,1.0990000}, {6450,1.1022571}, {6500,1.0889143}, {6550,1.0923714}, {6600,1.0945429}, {6650,1.1056286}, {6700,1.1172000}, {6750,1.1267143}, {6800,1.1478857}, {6850,1.1354000}, {6900,1.1479143}, {6950,1.1552571}, {7000,1.1808857}, {7050,1.1939429}, {7100,1.2337429}, {7150,1.2475714}, {7200,1.2446286}, {7250,1.2505429}, {7300,1.2593714}, {7350,1.2599714}, {7400,1.2640571}, {7450,1.2736286}, {7500,1.2634571}, {7550,1.2608857}, {7600,1.2880286}, {7650,1.3096286}, {7700,1.3558571}, {7750,1.3365143}, {7800,1.3524000}, {7850,1.3340000}, {7900,1.3306571}, {7950,1.3867429}, {8000,1.3843143}, {8050,1.3920000}, {8100,1.3791429}, {8150,1.3717143}, {8200,1.4044857}, {8250,1.4349143}, {8300,1.4142000}, {8350,1.4151429}, {8400,1.4041714}, {8450,1.4620571}, {8500,1.4614000}, {8550,1.4651429}, {8600,1.4582286}, {8650,1.5332000}, {8700,1.4945429}, {8750,1.4755429}, {8800,1.5167429}, {8850,1.5197429}, {8900,1.4856571}, {8950,1.5788857}, {9000,1.5358000}, {9050,1.5244286}, {9100,1.5663143}, {9150,1.5817714}, {9200,1.5460000}, {9250,1.6133429}, {9300,1.6042571}, {9350,1.6035429}, {9400,1.6286571}, {9450,1.5992857}, {9500,1.6572000}, {9550,1.6366571}, {9600,1.6767429}, {9650,1.6518571}, {9700,1.6503143}, {9750,1.6937429}, {9800,1.6495429}, {9850,1.7068286}, {9900,1.6967714}, {9950,1.7201429}, {10000,1.6902857}, {10100,1.7475143}, {10200,1.7580000}, {10300,1.7794000}, {10400,1.7436857}, {10500,1.8151429}, {10600,1.7556286}, {10700,1.8449429}, {10800,1.8218857}, {10900,1.8685429}, {11000,1.8540571}, {11100,1.9260286}, {11200,1.8956286}, {11300,1.9319714}, {11400,1.9408571}, {11500,1.9586571}, {11600,1.9916857}, {11700,1.9848571}, {11800,2.0339429}, {11900,2.0425429}, {12000,2.0444857}, {12100,2.0629143}, {12200,2.0774571}, {12300,2.0768286}, {12400,2.1328857}, {12500,2.1276286}, {12600,2.1405714}, {12700,2.1644000}, {12800,2.1570286}, {12900,2.2005143}, {13000,2.1807714}, {13100,2.2213429}, {13200,2.2527429}, {13300,2.2568000}, {13400,2.2875143}, {13500,2.2985143}, {13600,2.3056857}, {13700,2.3396286}, {13800,2.3408286}, {13900,2.3778000}, {14000,2.3836571}, {14100,2.3932286}, {14200,2.4227143}, {14300,2.4178000}, {14400,2.4536571}, {14500,2.4762571}, {14600,2.6482000}, {14700,2.5045143}, {14800,2.5166857}, {14900,2.5410000}, {15000,2.5534857}, {15100,2.5559429}, {15200,2.8528857}, {15300,2.7039143}, {15400,2.6184571}, {15500,2.6204000}, {15600,2.7178000}, {15700,2.7430571}, {15800,2.6745714}, {15900,2.7136571}, {16000,2.7069714}, {16100,2.7204857}, {16200,2.7280857}, {16300,2.8472000}, {16400,2.7389429}, {16500,2.8750286}, {16600,3.1014857}, {16700,2.8219143}, {16800,2.9392857}, {16900,2.8516286}, {17000,3.0173143}, {17100,2.9037714}, {17200,3.0173429}, {17300,2.9238857}, {17400,2.9398000}, {17500,3.1351143}, {17600,2.9580857}, {17700,3.0175143}, {17800,3.0745143}, {17900,3.1218571}, {18000,3.0470000}, {18100,3.0662286}, {18200,3.0863714}, {18300,3.1198286}, {18400,3.1186286}, {18500,3.1985714}, {18600,3.1598000}, {18700,3.1873143}, {18800,3.1829143}, {18900,3.2422286}, {19000,3.2364571}, {19100,3.2555714}, {19200,3.2658286}, {19300,3.3508000}, {19400,3.3609429}, {19500,3.3133714}, {19600,3.3412571}, {19700,3.5197429}, {19800,3.3685714}, {19900,3.5572571}, {20000,3.5828571}};
data["big_flat"]["LtacTCPrimPair"]["norm reif"]["user"] = {{1,0.00022772}, {2,0.00037624}, {3,0.00025743}, {4,0.00064356}, {5,0.00085149}, {6,0.00090099}, {7,0.00042574}, {8,0.00133663}, {9,0.00096040}, {10,0.00093069}, {11,0.00107921}, {12,0.00152475}, {13,0.00169307}, {14,0.00170297}, {15,0.00195050}, {16,0.00200990}, {17,0.00206931}, {18,0.00208911}, {19,0.00255446}, {20,0.00256436}, {21,0.00249505}, {22,0.00255446}, {23,0.00251485}, {24,0.00269307}, {25,0.00263366}, {26,0.00300000}, {27,0.00308911}, {28,0.00327723}, {29,0.00318812}, {30,0.00329703}, {31,0.00354455}, {32,0.00387129}, {33,0.00386139}, {34,0.00401980}, {35,0.00402970}, {36,0.00426733}, {37,0.00449505}, {38,0.00477228}, {39,0.00493069}, {40,0.00484158}, {41,0.00468317}, {42,0.00528713}, {43,0.00513861}, {44,0.00528713}, {45,0.00573267}, {46,0.00539604}, {47,0.00571287}, {48,0.00617822}, {49,0.00603960}, {50,0.00638614}, {51,0.00625743}, {52,0.00632673}, {53,0.00681188}, {54,0.00691089}, {55,0.00814851}, {56,0.00729703}, {57,0.00736634}, {58,0.00718812}, {59,0.00729703}, {60,0.00745545}, {61,0.00748515}, {62,0.00744554}, {63,0.00764356}, {64,0.00784158}, {65,0.00800000}, {66,0.00805941}, {67,0.00815842}, {68,0.00800990}, {69,0.00852475}, {70,0.00935644}, {71,0.00871287}, {72,0.00881188}, {73,0.00898020}, {74,0.00914851}, {75,0.00958416}, {76,0.00931683}, {77,0.00930693}, {78,0.00959406}, {79,0.00955446}, {80,0.01420792}, {81,0.01009901}, {82,0.01023762}, {83,0.01037624}, {84,0.01057426}, {85,0.01059406}, {86,0.01074257}, {87,0.01151485}, {88,0.01416832}, {89,0.01117822}, {90,0.01130693}, {91,0.01117822}, {92,0.01136634}, {93,0.01182178}, {94,0.01160396}, {95,0.01193069}, {96,0.01205941}, {97,0.01215842}, {98,0.01244554}, {99,0.01232673}, {100,0.01247525}, {101,0.01288119}, {102,0.01280198}, {103,0.01274257}, {104,0.01771287}, {105,0.01589109}, {106,0.01302970}, {107,0.01344554}, {108,0.01379208}, {109,0.01353465}, {110,0.01423762}, {111,0.01423762}, {112,0.01413861}, {113,0.01682178}, {114,0.01417822}, {115,0.01457426}, {116,0.01516832}, {117,0.01487129}, {118,0.01892079}, {119,0.01509901}, {120,0.01505941}, {121,0.01540594}, {122,0.01557426}, {123,0.01547525}, {124,0.01594059}, {125,0.01577228}, {126,0.01905941}, {127,0.01607921}, {128,0.01611881}, {129,0.02249505}, {130,0.01640594}, {131,0.01659406}, {132,0.02222772}, {133,0.01673267}, {134,0.01686139}, {135,0.01977228}, {136,0.01737624}, {137,0.01742574}, {138,0.01694059}, {139,0.01745545}, {140,0.01945545}, {141,0.01754455}, {142,0.02345545}, {143,0.01774257}, {144,0.01773267}, {145,0.01785149}, {146,0.01795050}, {147,0.01774257}, {148,0.01810891}, {149,0.01796040}, {150,0.01841584}, {151,0.01883168}, {152,0.02510891}, {153,0.01865347}, {154,0.02220792}, {155,0.01890099}, {156,0.01902970}, {157,0.01921782}, {158,0.01941584}, {159,0.02263366}, {160,0.01939604}, {161,0.01965347}, {162,0.02699010}, {163,0.02039604}, {164,0.02014851}, {165,0.02162376}, {166,0.02049505}, {167,0.02080198}, {168,0.02650495}, {169,0.02082178}, {170,0.02102970}, {171,0.02205941}, {172,0.02126733}, {173,0.02166337}, {174,0.02194059}, {175,0.02180198}, {176,0.02879208}, {177,0.02248515}, {178,0.02247525}, {179,0.02232673}, {180,0.02289109}, {181,0.02851485}, {182,0.02280198}, {183,0.02291089}, {184,0.02277228}, {185,0.02334653}, {186,0.02322772}, {187,0.02343564}, {188,0.02676238}, {189,0.02998020}, {190,0.03240594}, {191,0.02398020}, {192,0.02437624}, {193,0.02435644}, {194,0.02467327}, {195,0.02437624}, {196,0.02478218}, {197,0.02469307}, {198,0.02476238}, {199,0.02511881}, {200,0.02481188}, {201,0.02492079}, {202,0.02511881}, {203,0.02562376}, {204,0.02545545}, {205,0.02553465}, {206,0.03332673}, {207,0.03114851}, {208,0.03017822}, {209,0.02554455}, {210,0.02586139}, {211,0.02633663}, {212,0.02653465}, {213,0.02666337}, {214,0.04015842}, {215,0.03350495}, {216,0.02649505}, {217,0.02704950}, {218,0.02694059}, {219,0.02761386}, {220,0.03300990}, {221,0.02731683}, {222,0.02772277}, {223,0.02828713}, {224,0.03445545}, {225,0.02802970}, {226,0.02798020}, {227,0.02801980}, {228,0.03276238}, {229,0.02851485}, {230,0.02875248}, {231,0.03415842}, {232,0.02900000}, {233,0.02897030}, {234,0.03427723}, {235,0.02931683}, {236,0.02979208}, {237,0.03128713}, {238,0.02962376}, {239,0.03702970}, {240,0.03012871}, {241,0.03018812}, {242,0.02992079}, {243,0.03029703}, {244,0.03337624}, {245,0.03036634}, {246,0.03547525}, {247,0.03072277}, {248,0.03718812}, {249,0.03094059}, {250,0.03728713}, {251,0.03172277}, {252,0.03573267}, {253,0.03175248}, {254,0.03299010}, {255,0.03232673}, {256,0.03175248}, {257,0.04214851}, {258,0.03235644}, {259,0.03730693}, {260,0.03271287}, {261,0.03280198}, {262,0.04265347}, {263,0.03331683}, {264,0.03398020}, {265,0.04449505}, {266,0.03329703}, {267,0.03470297}, {268,0.04329703}, {269,0.03380198}, {270,0.03374257}, {271,0.04339604}, {272,0.03477228}, {273,0.03431683}, {274,0.03613861}, {275,0.04319802}, {276,0.03467327}, {277,0.03557426}, {278,0.03522772}, {279,0.03985149}, {280,0.04548515}, {281,0.03612871}, {282,0.03546535}, {283,0.03584158}, {284,0.03665347}, {285,0.04120792}, {286,0.04433663}, {287,0.04826733}, {288,0.03663366}, {289,0.03617822}, {290,0.03657426}, {291,0.03684158}, {292,0.03675248}, {293,0.03682178}, {294,0.03783168}, {295,0.04001980}, {296,0.04028713}, {297,0.04147525}, {298,0.04204950}, {299,0.04079208}, {300,0.04237624}, {301,0.04051485}, {302,0.04407921}, {303,0.04214851}, {304,0.03997030}, {305,0.03827723}, {306,0.03820792}, {307,0.03840594}, {308,0.03832673}, {309,0.03859406}, {310,0.03884158}, {311,0.05327723}, {312,0.04954455}, {313,0.04656436}, {314,0.04177228}, {315,0.03976238}, {316,0.03972277}, {317,0.03997030}, {318,0.05118812}, {319,0.04566337}, {320,0.04029703}, {321,0.04020792}, {322,0.04031683}, {323,0.04960396}, {324,0.04390099}, {325,0.04063366}, {326,0.04124752}, {327,0.04994059}, {328,0.04304950}, {329,0.04186139}, {330,0.05372277}, {331,0.04915842}, {332,0.04172277}, {333,0.04470297}, {334,0.04822772}, {335,0.04226733}, {336,0.05600990}, {337,0.04563366}, {338,0.04235644}, {339,0.05234653}, {340,0.04261386}, {341,0.04316832}, {342,0.04680198}, {343,0.04325743}, {344,0.04980198}, {345,0.04295050}, {346,0.05236634}, {347,0.04387129}, {348,0.05307921}, {349,0.04395050}, {350,0.05417822}, {351,0.04470297}, {352,0.05301980}, {353,0.04384158}, {354,0.05211881}, {355,0.04503960}, {356,0.05034653}, {357,0.04544554}, {358,0.04853465}, {359,0.06498020}, {360,0.04478218}, {361,0.05396040}, {362,0.04580198}, {363,0.04785149}, {364,0.05877228}, {365,0.04580198}, {366,0.04934653}, {367,0.05874257}, {368,0.04663366}, {369,0.04888119}, {370,0.05625743}, {371,0.04702970}, {372,0.04722772}, {373,0.05250495}, {374,0.06019802}, {375,0.04716832}, {376,0.04780198}, {377,0.05282178}, {378,0.05903960}, {379,0.04763366}, {380,0.04819802}, {381,0.04977228}, {382,0.05570297}, {383,0.05984158}, {384,0.06337624}, {385,0.04844554}, {386,0.04912871}, {387,0.04876238}, {388,0.05206931}, {389,0.05631683}, {390,0.06030693}, {391,0.06277228}, {392,0.06480198}, {393,0.04992079}, {394,0.04986139}, {395,0.05027723}, {396,0.05011881}, {397,0.05012871}, {398,0.05022772}, {399,0.05038614}, {400,0.05052475}, {401,0.05029703}, {402,0.05007921}, {403,0.05100000}, {404,0.05047525}, {405,0.05148515}, {406,0.05123762}, {407,0.05187129}, {408,0.05081188}, {409,0.06536634}, {410,0.06434653}, {411,0.06237624}, {412,0.05915842}, {413,0.05666337}, {414,0.05344554}, {415,0.05259406}, {416,0.05183168}, {417,0.07484158}, {418,0.06736634}, {419,0.06044554}, {420,0.05491089}, {421,0.05296040}, {422,0.07287129}, {423,0.06570297}, {424,0.05912871}, {425,0.05358416}, {426,0.05391089}, {427,0.06555446}, {428,0.05907921}, {429,0.05385149}, {430,0.07038614}, {431,0.06310891}, {432,0.05406931}, {433,0.05476238}, {434,0.06914851}, {435,0.05653465}, {436,0.05756436}, {437,0.06505941}, {438,0.05483168}, {439,0.07288119}, {440,0.06049505}, {441,0.05513861}, {442,0.06610891}, {443,0.05588119}, {444,0.06903960}, {445,0.05844554}, {446,0.07189109}, {447,0.06067327}, {448,0.07325743}, {449,0.06200990}, {450,0.05621782}, {451,0.06695050}, {452,0.05658416}, {453,0.06601980}, {454,0.05769307}, {455,0.06326733}, {456,0.07383168}, {457,0.06058416}, {458,0.07292079}, {459,0.05795050}, {460,0.06779208}, {461,0.05838614}, {462,0.06264356}, {463,0.07308911}, {464,0.05836634}, {465,0.06678218}, {466,0.07354455}, {467,0.05911881}, {468,0.07160396}, {469,0.07902970}, {470,0.05960396}, {471,0.06872277}, {472,0.07544554}, {473,0.06021782}, {474,0.06355446}, {475,0.07091089}, {476,0.07713861}, {477,0.06095050}, {478,0.06336634}, {479,0.06967327}, {480,0.07294059}, {481,0.06058416}, {482,0.06093069}, {483,0.06610891}, {484,0.07145545}, {485,0.07618812}, {486,0.07958416}, {487,0.06153465}, {488,0.06155446}, {489,0.06374257}, {490,0.06707921}, {491,0.07035644}, {492,0.07303960}, {493,0.07300990}, {494,0.08402970}, {495,0.08354455}, {496,0.08143564}, {497,0.08334653}, {498,0.08426733}, {499,0.06494059}, {500,0.06300000}, {505,0.06418812}, {510,0.08352475}, {515,0.08170297}, {520,0.07870297}, {525,0.07539604}, {530,0.06951485}, {535,0.09670297}, {540,0.08324752}, {545,0.07320792}, {550,0.08706931}, {555,0.07636634}, {560,0.08725743}, {565,0.07449505}, {570,0.08353465}, {575,0.09269307}, {580,0.07369307}, {585,0.08420792}, {590,0.08689109}, {595,0.09063366}, {600,0.09262376}, {605,0.09330693}, {610,0.09198020}, {615,0.09069307}, {620,0.08794059}, {625,0.08692079}, {630,0.11552475}, {635,0.09975248}, {640,0.08963366}, {645,0.10843564}, {650,0.09650495}, {655,0.08652475}, {660,0.09705941}, {665,0.10250495}, {670,0.09614851}, {675,0.10493069}, {680,0.11169307}, {685,0.09279208}, {690,0.09688119}, {695,0.10090099}, {700,0.10240594}, {705,0.10612871}, {710,0.10667327}, {715,0.10448515}, {720,0.10096040}, {725,0.09857426}, {730,0.11804950}, {735,0.12113861}, {740,0.10529703}, {745,0.12252475}, {750,0.11131683}, {755,0.12423762}, {760,0.11105941}, {765,0.13492079}, {770,0.10915842}, {775,0.11849505}, {780,0.12440594}, {785,0.10708911}, {790,0.10961386}, {795,0.11963366}, {800,0.11871287}, {805,0.12193069}, {810,0.12168317}, {815,0.12075248}, {820,0.12618812}, {825,0.11783168}, {830,0.13884158}, {835,0.12854455}, {840,0.12149505}, {845,0.15373267}, {850,0.13233663}, {855,0.12065347}, {860,0.13089109}, {865,0.14205941}, {870,0.13198020}, {875,0.14201980}, {880,0.14615842}, {885,0.12747525}, {890,0.12756436}, {895,0.14070297}, {900,0.13930693}, {905,0.13851485}, {910,0.13910891}, {915,0.13305941}, {920,0.13994059}, {925,0.13650495}, {930,0.12988119}, {935,0.14821782}, {940,0.15186139}, {945,0.13748515}, {950,0.15024752}, {955,0.13904950}, {960,0.14438614}, {965,0.14261386}, {970,0.15126733}, {975,0.15760396}, {980,0.14153465}, {985,0.15214851}, {990,0.15679208}, {995,0.15686139}, {1000,0.15996040}, {1010,0.16934653}, {1020,0.16581188}, {1030,0.16008911}, {1040,0.16979208}, {1050,0.15300000}, {1060,0.16609901}, {1070,0.15425743}, {1080,0.16906931}, {1090,0.17570297}, {1100,0.17719802}, {1110,0.20152475}, {1120,0.17721782}, {1130,0.17900000}, {1140,0.17515842}, {1150,0.17243564}, {1160,0.18661386}, {1170,0.17156436}, {1180,0.18895050}, {1190,0.19270297}, {1200,0.19413861}, {1210,0.17852475}, {1220,0.17711881}, {1230,0.19761386}, {1240,0.19902970}, {1250,0.18878218}, {1260,0.20159406}, {1270,0.19616832}, {1280,0.19774257}, {1290,0.20223762}, {1300,0.18967327}, {1310,0.19443564}, {1320,0.20745545}, {1330,0.19770297}, {1340,0.21316832}, {1350,0.21334653}, {1360,0.19888119}, {1370,0.22271287}, {1380,0.21612871}, {1390,0.20666337}, {1400,0.22140594}, {1410,0.21575248}, {1420,0.21410891}, {1430,0.21849505}, {1440,0.20976238}, {1450,0.23666337}, {1460,0.22097030}, {1470,0.24419802}, {1480,0.22193069}, {1490,0.22687129}, {1500,0.24094059}, {1510,0.23410891}, {1520,0.24448515}, {1530,0.23835644}, {1540,0.23904950}, {1550,0.23308911}, {1560,0.24143564}, {1570,0.22948515}, {1580,0.24378218}, {1590,0.26211881}, {1600,0.23300990}, {1610,0.24650495}, {1620,0.24053465}, {1630,0.24808911}, {1640,0.25728713}, {1650,0.26265347}, {1660,0.24643564}, {1670,0.26570297}, {1680,0.24629703}, {1690,0.26381188}, {1700,0.26102970}, {1710,0.27509901}, {1720,0.26593069}, {1730,0.27359406}, {1740,0.26165347}, {1750,0.25605941}, {1760,0.27089109}, {1770,0.26484158}, {1780,0.27378218}, {1790,0.28869307}, {1800,0.30740594}, {1810,0.26948515}, {1820,0.28770297}, {1830,0.29411881}, {1840,0.29843564}, {1850,0.28422772}, {1860,0.28571287}, {1870,0.29075248}, {1880,0.28734653}, {1890,0.31515842}, {1900,0.29363366}, {1910,0.30788119}, {1920,0.29757426}, {1930,0.30655446}, {1940,0.32449505}, {1950,0.29229703}, {1960,0.31592079}, {1970,0.29650495}, {1980,0.31216832}, {1990,0.33780198}, {2000,0.29745545}, {2050,0.31686139}, {2100,0.32928713}, {2150,0.34095050}, {2200,0.34858416}, {2250,0.34770297}, {2300,0.34962376}, {2350,0.36331683}, {2400,0.40765347}, {2450,0.38480198}, {2500,0.38494059}, {2550,0.40358416}, {2600,0.42629703}, {2650,0.41633663}, {2700,0.45844554}, {2750,0.44187129}, {2800,0.43222772}, {2850,0.44363366}, {2900,0.46855446}, {2950,0.45144554}, {3000,0.47958416}, {3050,0.48665347}, {3100,0.48531683}, {3150,0.49881188}, {3200,0.52343564}, {3250,0.51525743}, {3300,0.53523762}, {3350,0.54644554}, {3400,0.54166337}, {3450,0.55772277}, {3500,0.55489109}, {3550,0.56545545}, {3600,0.58127723}, {3650,0.56935644}, {3700,0.58815842}, {3750,0.61227723}, {3800,0.63166337}, {3850,0.63236634}, {3900,0.62206931}, {3950,0.63116832}, {4000,0.64171287}, {4050,0.65338614}, {4100,0.67339604}, {4150,0.65649505}, {4200,0.67469307}, {4250,0.69364356}, {4300,0.70321782}, {4350,0.70649505}, {4400,0.70438614}, {4450,0.73933663}, {4500,0.71115842}, {4550,0.72892079}, {4600,0.76301980}, {4650,0.73378218}, {4700,0.78092079}, {4750,0.77146535}, {4800,0.77252475}, {4850,0.78738614}, {4900,0.79114851}, {4950,0.80198020}, {5000,0.80603960}, {5050,0.81664356}, {5100,0.84538614}, {5150,0.84584158}, {5200,0.85940594}, {5250,0.85729703}, {5300,0.88237624}, {5350,0.88016832}, {5400,0.87300990}, {5450,0.90465347}, {5500,0.89455446}, {5550,0.90255446}, {5600,0.91566337}, {5650,0.90144554}, {5700,0.90983168}, {5750,0.94445545}, {5800,0.94772277}, {5850,0.94160396}, {5900,0.95950495}, {5950,0.98289109}, {6000,0.98733663}, {6050,1.0209429}, {6100,1.0187143}, {6150,1.0459429}, {6200,1.0546857}, {6250,1.0716857}, {6300,1.0724571}, {6350,1.1110857}, {6400,1.0974857}, {6450,1.1022000}, {6500,1.0878571}, {6550,1.0909143}, {6600,1.0939143}, {6650,1.1048857}, {6700,1.1156286}, {6750,1.1224857}, {6800,1.1442286}, {6850,1.1337143}, {6900,1.1467429}, {6950,1.1532000}, {7000,1.1779143}, {7050,1.1928286}, {7100,1.2324857}, {7150,1.2464857}, {7200,1.2421143}, {7250,1.2494571}, {7300,1.2539714}, {7350,1.2562286}, {7400,1.2622571}, {7450,1.2698571}, {7500,1.2573714}, {7550,1.2566286}, {7600,1.2840286}, {7650,1.3005429}, {7700,1.3505429}, {7750,1.3237429}, {7800,1.3462000}, {7850,1.3316286}, {7900,1.3288000}, {7950,1.3829429}, {8000,1.3776857}, {8050,1.3869143}, {8100,1.3768857}, {8150,1.3699143}, {8200,1.4025714}, {8250,1.4330286}, {8300,1.4126571}, {8350,1.4132286}, {8400,1.4024286}, {8450,1.4600857}, {8500,1.4594571}, {8550,1.4632286}, {8600,1.4564286}, {8650,1.5315714}, {8700,1.4926000}, {8750,1.4697143}, {8800,1.5155429}, {8850,1.5183143}, {8900,1.4840286}, {8950,1.5769714}, {9000,1.5343143}, {9050,1.5226857}, {9100,1.5644000}, {9150,1.5725714}, {9200,1.5436857}, {9250,1.6114000}, {9300,1.6010000}, {9350,1.6008857}, {9400,1.6262857}, {9450,1.5969143}, {9500,1.6551429}, {9550,1.6346571}, {9600,1.6739714}, {9650,1.6495429}, {9700,1.6474286}, {9750,1.6908857}, {9800,1.6470857}, {9850,1.7041714}, {9900,1.6946857}, {9950,1.7185714}, {10000,1.6875143}, {10100,1.7449714}, {10200,1.7553143}, {10300,1.7763143}, {10400,1.7415143}, {10500,1.8128571}, {10600,1.7531429}, {10700,1.8429714}, {10800,1.8196571}, {10900,1.8660857}, {11000,1.8510000}, {11100,1.9230571}, {11200,1.8922857}, {11300,1.9286571}, {11400,1.9379429}, {11500,1.9561143}, {11600,1.9884571}, {11700,1.9807714}, {11800,2.0301714}, {11900,2.0387429}, {12000,2.0414000}, {12100,2.0596857}, {12200,2.0745143}, {12300,2.0732857}, {12400,2.1289429}, {12500,2.1241714}, {12600,2.1368000}, {12700,2.1611714}, {12800,2.1535429}, {12900,2.1971429}, {13000,2.1779714}, {13100,2.2188000}, {13200,2.2494000}, {13300,2.2532286}, {13400,2.2842286}, {13500,2.2950571}, {13600,2.3023429}, {13700,2.3282000}, {13800,2.3379714}, {13900,2.3753714}, {14000,2.3814571}, {14100,2.3904000}, {14200,2.4199143}, {14300,2.4153714}, {14400,2.4515143}, {14500,2.4733429}, {14600,2.6452000}, {14700,2.5014857}, {14800,2.5127143}, {14900,2.5376571}, {15000,2.5500571}, {15100,2.5531429}, {15200,2.8494286}, {15300,2.7006286}, {15400,2.6149143}, {15500,2.6170571}, {15600,2.7153714}, {15700,2.7403714}, {15800,2.6714571}, {15900,2.7109143}, {16000,2.7042857}, {16100,2.7178857}, {16200,2.7260000}, {16300,2.8445714}, {16400,2.7360571}, {16500,2.8729143}, {16600,3.0985714}, {16700,2.8190286}, {16800,2.9354857}, {16900,2.8494857}, {17000,3.0148000}, {17100,2.9012286}, {17200,3.0140571}, {17300,2.9214571}, {17400,2.9365143}, {17500,3.1326857}, {17600,2.9548571}, {17700,3.0137143}, {17800,3.0709143}, {17900,3.1184857}, {18000,3.0437714}, {18100,3.0623714}, {18200,3.0818857}, {18300,3.1156286}, {18400,3.1150286}, {18500,3.1932857}, {18600,3.1476286}, {18700,3.1822286}, {18800,3.1800000}, {18900,3.2281143}, {19000,3.2197143}, {19100,3.2268286}, {19200,3.2604571}, {19300,3.3466286}, {19400,3.3569714}, {19500,3.3014857}, {19600,3.3185143}, {19700,3.5011714}, {19800,3.3538571}, {19900,3.5440571}, {20000,3.5779143}};
data["big_flat"]["LtacTCPrimPair"]["norm reif"]["system"] = {{1,0.00014851}, {2,0.00002970}, {3,0.00000000}, {4,0.00003960}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00003960}, {10,0.00003960}, {11,0.00003960}, {12,0.00000000}, {13,0.00000000}, {14,0.00007921}, {15,0.00000000}, {16,0.00003960}, {17,0.00002970}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00003960}, {23,0.00000000}, {24,0.00006931}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00006931}, {30,0.00000000}, {31,0.00003960}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00003960}, {37,0.00017822}, {38,0.00000000}, {39,0.00000000}, {40,0.00003960}, {41,0.00003960}, {42,0.00000000}, {43,0.00002970}, {44,0.00007921}, {45,0.00007921}, {46,0.00003960}, {47,0.00003960}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00002970}, {57,0.00003960}, {58,0.00007921}, {59,0.00006931}, {60,0.00000000}, {61,0.00000000}, {62,0.00003960}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00002970}, {68,0.00000000}, {69,0.00000000}, {70,0.00003960}, {71,0.00007921}, {72,0.00000000}, {73,0.00000000}, {74,0.00003960}, {75,0.00007921}, {76,0.00003960}, {77,0.00000000}, {78,0.00000000}, {79,0.00003960}, {80,0.00007921}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00006931}, {86,0.00000000}, {87,0.00000000}, {88,0.00015842}, {89,0.00000000}, {90,0.00003960}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00003960}, {95,0.00007921}, {96,0.00002970}, {97,0.00000000}, {98,0.00003960}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00007921}, {105,0.00003960}, {106,0.00000000}, {107,0.00003960}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00003960}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00002970}, {118,0.00019802}, {119,0.00003960}, {120,0.00003960}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00003960}, {126,0.00003960}, {127,0.00003960}, {128,0.00013861}, {129,0.00019802}, {130,0.00000000}, {131,0.00000000}, {132,0.00014851}, {133,0.00000000}, {134,0.00003960}, {135,0.00013861}, {136,0.00006931}, {137,0.00000000}, {138,0.00003960}, {139,0.00000000}, {140,0.00014851}, {141,0.00000000}, {142,0.00009901}, {143,0.00003960}, {144,0.00007921}, {145,0.00000000}, {146,0.00007921}, {147,0.00006931}, {148,0.00003960}, {149,0.00000000}, {150,0.00003960}, {151,0.00002970}, {152,0.00007921}, {153,0.00000000}, {154,0.00003960}, {155,0.00000000}, {156,0.00003960}, {157,0.00007921}, {158,0.00000000}, {159,0.00014851}, {160,0.00002970}, {161,0.00000000}, {162,0.00011881}, {163,0.00000000}, {164,0.00007921}, {165,0.00022772}, {166,0.00003960}, {167,0.00002970}, {168,0.00003960}, {169,0.00009901}, {170,0.00000000}, {171,0.00003960}, {172,0.00003960}, {173,0.00000000}, {174,0.00000000}, {175,0.00003960}, {176,0.00011881}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00011881}, {182,0.00007921}, {183,0.00000000}, {184,0.00002970}, {185,0.00003960}, {186,0.00003960}, {187,0.00003960}, {188,0.00003960}, {189,0.00013861}, {190,0.00007921}, {191,0.00000000}, {192,0.00000000}, {193,0.00003960}, {194,0.00000000}, {195,0.00000000}, {196,0.00003960}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00003960}, {203,0.00000000}, {204,0.00011881}, {205,0.00003960}, {206,0.00015842}, {207,0.00010891}, {208,0.00019802}, {209,0.00000000}, {210,0.00000000}, {211,0.00003960}, {212,0.00000000}, {213,0.00003960}, {214,0.00022772}, {215,0.00002970}, {216,0.00000000}, {217,0.00006931}, {218,0.00000000}, {219,0.00000000}, {220,0.00009901}, {221,0.00003960}, {222,0.00000000}, {223,0.00000000}, {224,0.00014851}, {225,0.00000000}, {226,0.00000000}, {227,0.00006931}, {228,0.00006931}, {229,0.00007921}, {230,0.00000000}, {231,0.00016832}, {232,0.00007921}, {233,0.00003960}, {234,0.00015842}, {235,0.00000000}, {236,0.00000000}, {237,0.00015842}, {238,0.00003960}, {239,0.00015842}, {240,0.00003960}, {241,0.00000000}, {242,0.00000000}, {243,0.00003960}, {244,0.00000000}, {245,0.00003960}, {246,0.00000000}, {247,0.00000000}, {248,0.00003960}, {249,0.00000000}, {250,0.00011881}, {251,0.00000000}, {252,0.00003960}, {253,0.00000000}, {254,0.00003960}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00002970}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00006931}, {266,0.00003960}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00003960}, {274,0.00000000}, {275,0.00002970}, {276,0.00003960}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003960}, {282,0.00000000}, {283,0.00003960}, {284,0.00003960}, {285,0.00000000}, {286,0.00000000}, {287,0.00006931}, {288,0.00000000}, {289,0.00003960}, {290,0.00003960}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00003960}, {295,0.00003960}, {296,0.00000000}, {297,0.00000000}, {298,0.00003960}, {299,0.00000000}, {300,0.00000000}, {301,0.00002970}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00003960}, {306,0.00000000}, {307,0.00000000}, {308,0.00003960}, {309,0.00006931}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00003960}, {314,0.00000000}, {315,0.00003960}, {316,0.00000000}, {317,0.00003960}, {318,0.00003960}, {319,0.00003960}, {320,0.00003960}, {321,0.00006931}, {322,0.00007921}, {323,0.00000000}, {324,0.00003960}, {325,0.00003960}, {326,0.00000000}, {327,0.00003960}, {328,0.00003960}, {329,0.00000000}, {330,0.00000000}, {331,0.00003960}, {332,0.00000000}, {333,0.00007921}, {334,0.00000000}, {335,0.00003960}, {336,0.00002970}, {337,0.00003960}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00003960}, {343,0.00003960}, {344,0.00003960}, {345,0.00003960}, {346,0.00000000}, {347,0.00000000}, {348,0.00034653}, {349,0.00000000}, {350,0.00037624}, {351,0.00000000}, {352,0.00018812}, {353,0.00000000}, {354,0.00015842}, {355,0.00003960}, {356,0.00000000}, {357,0.00000000}, {358,0.00006931}, {359,0.00009901}, {360,0.00000000}, {361,0.00003960}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00003960}, {366,0.00000000}, {367,0.00035644}, {368,0.00000000}, {369,0.00000000}, {370,0.00019802}, {371,0.00000000}, {372,0.00007921}, {373,0.00002970}, {374,0.00000000}, {375,0.00000000}, {376,0.00003960}, {377,0.00000000}, {378,0.00007921}, {379,0.00000000}, {380,0.00003960}, {381,0.00002970}, {382,0.00003960}, {383,0.00007921}, {384,0.00000000}, {385,0.00003960}, {386,0.00003960}, {387,0.00000000}, {388,0.00007921}, {389,0.00000000}, {390,0.00003960}, {391,0.00000000}, {392,0.00003960}, {393,0.00000000}, {394,0.00003960}, {395,0.00000000}, {396,0.00000000}, {397,0.00003960}, {398,0.00000000}, {399,0.00003960}, {400,0.00003960}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00003960}, {408,0.00007921}, {409,0.00003960}, {410,0.00000000}, {411,0.00000000}, {412,0.00003960}, {413,0.00003960}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00003960}, {426,0.00000000}, {427,0.00003960}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00003960}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00011881}, {444,0.00000000}, {445,0.00003960}, {446,0.00003960}, {447,0.00000000}, {448,0.00007921}, {449,0.00000000}, {450,0.00003960}, {451,0.00006931}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00003960}, {457,0.00003960}, {458,0.00003960}, {459,0.00003960}, {460,0.00000000}, {461,0.00003960}, {462,0.00000000}, {463,0.00002970}, {464,0.00000000}, {465,0.00003960}, {466,0.00000000}, {467,0.00000000}, {468,0.00003960}, {469,0.00003960}, {470,0.00003960}, {471,0.00003960}, {472,0.00011881}, {473,0.00000000}, {474,0.00007921}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00007921}, {479,0.00000000}, {480,0.00003960}, {481,0.00007921}, {482,0.00002970}, {483,0.00003960}, {484,0.00000000}, {485,0.00000000}, {486,0.00003960}, {487,0.00011881}, {488,0.00000000}, {489,0.00003960}, {490,0.00000000}, {491,0.00000000}, {492,0.00003960}, {493,0.00003960}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00003960}, {500,0.00006931}, {505,0.00003960}, {510,0.00011881}, {515,0.00000000}, {520,0.00002970}, {525,0.00000000}, {530,0.00003960}, {535,0.00003960}, {540,0.00003960}, {545,0.00000000}, {550,0.00007921}, {555,0.00000000}, {560,0.00003960}, {565,0.00007921}, {570,0.00003960}, {575,0.00011881}, {580,0.00003960}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00003960}, {620,0.00003960}, {625,0.00003960}, {630,0.00000000}, {635,0.00003960}, {640,0.00000000}, {645,0.00002970}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00003960}, {670,0.00000000}, {675,0.00000000}, {680,0.00007921}, {685,0.00000000}, {690,0.00000000}, {695,0.00003960}, {700,0.00003960}, {705,0.00000000}, {710,0.00003960}, {715,0.00003960}, {720,0.00000000}, {725,0.00003960}, {730,0.00007921}, {735,0.00003960}, {740,0.00003960}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00003960}, {775,0.00007921}, {780,0.00007921}, {785,0.00000000}, {790,0.00003960}, {795,0.00000000}, {800,0.00003960}, {805,0.00000000}, {810,0.00006931}, {815,0.00000000}, {820,0.00003960}, {825,0.00000000}, {830,0.00003960}, {835,0.00010891}, {840,0.00007921}, {845,0.00000000}, {850,0.00000000}, {855,0.00007921}, {860,0.00003960}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00007921}, {885,0.00007921}, {890,0.00003960}, {895,0.00000000}, {900,0.00003960}, {905,0.00003960}, {910,0.00006931}, {915,0.00000000}, {920,0.00000000}, {925,0.00003960}, {930,0.00007921}, {935,0.00000000}, {940,0.00000000}, {945,0.00003960}, {950,0.00000000}, {955,0.00007921}, {960,0.00003960}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00003960}, {985,0.00007921}, {990,0.00007921}, {995,0.00000000}, {1000,0.00003960}, {1010,0.00003960}, {1020,0.00000000}, {1030,0.00007921}, {1040,0.00003960}, {1050,0.00000000}, {1060,0.00002970}, {1070,0.00000000}, {1080,0.00007921}, {1090,0.00000000}, {1100,0.00007921}, {1110,0.00007921}, {1120,0.00003960}, {1130,0.00007921}, {1140,0.00003960}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00007921}, {1190,0.00002970}, {1200,0.00000000}, {1210,0.00006931}, {1220,0.00003960}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00003960}, {1270,0.00000000}, {1280,0.00003960}, {1290,0.00003960}, {1300,0.00007921}, {1310,0.00000000}, {1320,0.00003960}, {1330,0.00000000}, {1340,0.00007921}, {1350,0.00007921}, {1360,0.00003960}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00011881}, {1400,0.00003960}, {1410,0.00000000}, {1420,0.00011881}, {1430,0.00018812}, {1440,0.00011881}, {1450,0.00000000}, {1460,0.00003960}, {1470,0.00003960}, {1480,0.00003960}, {1490,0.00003960}, {1500,0.00003960}, {1510,0.00003960}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00003960}, {1560,0.00007921}, {1570,0.00000000}, {1580,0.00010891}, {1590,0.00011881}, {1600,0.00011881}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00002970}, {1650,0.00010891}, {1660,0.00003960}, {1670,0.00003960}, {1680,0.00003960}, {1690,0.00007921}, {1700,0.00007921}, {1710,0.00011881}, {1720,0.00007921}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00003960}, {1760,0.00007921}, {1770,0.00000000}, {1780,0.00023762}, {1790,0.00007921}, {1800,0.00003960}, {1810,0.00003960}, {1820,0.00003960}, {1830,0.00002970}, {1840,0.00000000}, {1850,0.00007921}, {1860,0.00011881}, {1870,0.00003960}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00003960}, {1920,0.00007921}, {1930,0.00003960}, {1940,0.00003960}, {1950,0.00003960}, {1960,0.00000000}, {1970,0.00007921}, {1980,0.00007921}, {1990,0.00000000}, {2000,0.00002970}, {2050,0.00015842}, {2100,0.00003960}, {2150,0.00000000}, {2200,0.00003960}, {2250,0.00000000}, {2300,0.00003960}, {2350,0.00003960}, {2400,0.00015842}, {2450,0.00011881}, {2500,0.00003960}, {2550,0.00003960}, {2600,0.00007921}, {2650,0.00003960}, {2700,0.00006931}, {2750,0.00003960}, {2800,0.00003960}, {2850,0.00310891}, {2900,0.00003960}, {2950,0.00000000}, {3000,0.00002970}, {3050,0.00010891}, {3100,0.00007921}, {3150,0.00022772}, {3200,0.00003960}, {3250,0.00000000}, {3300,0.00003960}, {3350,0.00003960}, {3400,0.00000000}, {3450,0.00003960}, {3500,0.00003960}, {3550,0.00007921}, {3600,0.00007921}, {3650,0.00003960}, {3700,0.00003960}, {3750,0.00007921}, {3800,0.00019802}, {3850,0.00007921}, {3900,0.00007921}, {3950,0.00011881}, {4000,0.00003960}, {4050,0.00011881}, {4100,0.00006931}, {4150,0.00007921}, {4200,0.00011881}, {4250,0.00003960}, {4300,0.00007921}, {4350,0.00003960}, {4400,0.00007921}, {4450,0.00000000}, {4500,0.00018812}, {4550,0.00007921}, {4600,0.00003960}, {4650,0.00011881}, {4700,0.00015842}, {4750,0.00006931}, {4800,0.00011881}, {4850,0.00027723}, {4900,0.00007921}, {4950,0.00000000}, {5000,0.00038614}, {5050,0.00035644}, {5100,0.00000000}, {5150,0.00011881}, {5200,0.00041584}, {5250,0.00066337}, {5300,0.00019802}, {5350,0.00015842}, {5400,0.00015842}, {5450,0.00007921}, {5500,0.00003960}, {5550,0.00003960}, {5600,0.00015842}, {5650,0.00007921}, {5700,0.00015842}, {5750,0.00003960}, {5800,0.00003960}, {5850,0.00031683}, {5900,0.00027723}, {5950,0.00015842}, {6000,0.00003960}, {6050,0.0065429}, {6100,0.0051143}, {6150,0.0001143}, {6200,0.0002000}, {6250,0.0000857}, {6300,0.0004286}, {6350,0.0001143}, {6400,0.0002286}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0002286}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0003429}, {6900,0.0001143}, {6950,0.0000857}, {7000,0.0001143}, {7050,0.0000000}, {7100,0.0001143}, {7150,0.0001143}, {7200,0.0001143}, {7250,0.0003429}, {7300,0.0000000}, {7350,0.0001143}, {7400,0.0001143}, {7450,0.0000857}, {7500,0.0000000}, {7550,0.0001143}, {7600,0.0001143}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0001143}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0001143}, {8000,0.0004571}, {8050,0.0003429}, {8100,0.0003429}, {8150,0.0000000}, {8200,0.0003429}, {8250,0.0005714}, {8300,0.0002286}, {8350,0.0001143}, {8400,0.0005714}, {8450,0.0004000}, {8500,0.0001143}, {8550,0.0001143}, {8600,0.0003429}, {8650,0.0002286}, {8700,0.0001143}, {8750,0.0001143}, {8800,0.0000000}, {8850,0.0002286}, {8900,0.0003429}, {8950,0.0002286}, {9000,0.0001143}, {9050,0.0002286}, {9100,0.0003143}, {9150,0.0003429}, {9200,0.0002286}, {9250,0.0001143}, {9300,0.0003429}, {9350,0.0001143}, {9400,0.0001143}, {9450,0.0001143}, {9500,0.0004571}, {9550,0.0002286}, {9600,0.0004571}, {9650,0.0002286}, {9700,0.0001143}, {9750,0.0003429}, {9800,0.0001143}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0001143}, {10000,0.0001143}, {10100,0.0003429}, {10200,0.0003429}, {10300,0.0002286}, {10400,0.0001143}, {10500,0.0000000}, {10600,0.0003429}, {10700,0.0001143}, {10800,0.0000000}, {10900,0.0002286}, {11000,0.0000000}, {11100,0.0005714}, {11200,0.0002286}, {11300,0.0000000}, {11400,0.0002286}, {11500,0.0001143}, {11600,0.0002286}, {11700,0.0006857}, {11800,0.0006857}, {11900,0.0011429}, {12000,0.0002286}, {12100,0.0001143}, {12200,0.0000000}, {12300,0.0002286}, {12400,0.0003429}, {12500,0.0002286}, {12600,0.0000000}, {12700,0.0002286}, {12800,0.0002286}, {12900,0.0004571}, {13000,0.0000857}, {13100,0.0002286}, {13200,0.0001143}, {13300,0.0006857}, {13400,0.0004286}, {13500,0.0002286}, {13600,0.0001143}, {13700,0.0001143}, {13800,0.0001143}, {13900,0.0000000}, {14000,0.0001143}, {14100,0.0001143}, {14200,0.0002286}, {14300,0.0002286}, {14400,0.0000000}, {14500,0.0001143}, {14600,0.0000000}, {14700,0.0002286}, {14800,0.0015714}, {14900,0.0011429}, {15000,0.0002000}, {15100,0.0003429}, {15200,0.0003429}, {15300,0.0000000}, {15400,0.0004571}, {15500,0.0009143}, {15600,0.0004571}, {15700,0.0008000}, {15800,0.0005714}, {15900,0.0002286}, {16000,0.0005714}, {16100,0.0003429}, {16200,0.0000000}, {16300,0.0003429}, {16400,0.0008000}, {16500,0.0006857}, {16600,0.0005714}, {16700,0.0013714}, {16800,0.0011429}, {16900,0.0001143}, {17000,0.0003429}, {17100,0.0005714}, {17200,0.0010286}, {17300,0.0001143}, {17400,0.0003429}, {17500,0.0001143}, {17600,0.0003429}, {17700,0.0005429}, {17800,0.0000000}, {17900,0.0004571}, {18000,0.0005714}, {18100,0.0005714}, {18200,0.0012286}, {18300,0.0002286}, {18400,0.0002286}, {18500,0.0012286}, {18600,0.0009143}, {18700,0.0014857}, {18800,0.0001143}, {18900,0.0001143}, {19000,0.0010857}, {19100,0.0001143}, {19200,0.0004571}, {19300,0.0004571}, {19400,0.0004571}, {19500,0.0012571}, {19600,0.0019143}, {19700,0.0006857}, {19800,0.0019143}, {19900,0.0012571}, {20000,0.0019429}};
data["big_flat"]["LtacTCPrimPair"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCPrimPair"]["post"]["user"] = {{1,0.00003960}, {2,0.00002970}, {3,0.00002970}, {4,0.00003960}, {5,0.00000000}, {6,0.00010891}, {7,0.00000000}, {8,0.00000000}, {9,0.00003960}, {10,0.00000000}, {11,0.00000000}, {12,0.00003960}, {13,0.00007921}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00002970}, {18,0.00009901}, {19,0.00002970}, {20,0.00000000}, {21,0.00000000}, {22,0.00002970}, {23,0.00005941}, {24,0.00005941}, {25,0.00006931}, {26,0.00003960}, {27,0.00003960}, {28,0.00000000}, {29,0.00005941}, {30,0.00000000}, {31,0.00002970}, {32,0.00003960}, {33,0.00005941}, {34,0.00006931}, {35,0.00003960}, {36,0.00000000}, {37,0.00007921}, {38,0.00006931}, {39,0.00000000}, {40,0.00002970}, {41,0.00016832}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00002970}, {46,0.00009901}, {47,0.00002970}, {48,0.00003960}, {49,0.00003960}, {50,0.00000000}, {51,0.00003960}, {52,0.00005941}, {53,0.00002970}, {54,0.00003960}, {55,0.00000000}, {56,0.00000000}, {57,0.00006931}, {58,0.00006931}, {59,0.00006931}, {60,0.00002970}, {61,0.00002970}, {62,0.00002970}, {63,0.00000000}, {64,0.00002970}, {65,0.00000000}, {66,0.00002970}, {67,0.00000000}, {68,0.00005941}, {69,0.00002970}, {70,0.00000000}, {71,0.00002970}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00003960}, {77,0.00008911}, {78,0.00003960}, {79,0.00002970}, {80,0.00002970}, {81,0.00002970}, {82,0.00003960}, {83,0.00009901}, {84,0.00000000}, {85,0.00002970}, {86,0.00003960}, {87,0.00000000}, {88,0.00005941}, {89,0.00005941}, {90,0.00009901}, {91,0.00003960}, {92,0.00003960}, {93,0.00000000}, {94,0.00000000}, {95,0.00005941}, {96,0.00002970}, {97,0.00000000}, {98,0.00002970}, {99,0.00000000}, {100,0.00002970}, {101,0.00006931}, {102,0.00002970}, {103,0.00000000}, {104,0.00002970}, {105,0.00002970}, {106,0.00002970}, {107,0.00006931}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00003960}, {113,0.00002970}, {114,0.00003960}, {115,0.00002970}, {116,0.00000000}, {117,0.00005941}, {118,0.00002970}, {119,0.00002970}, {120,0.00005941}, {121,0.00000000}, {122,0.00012871}, {123,0.00009901}, {124,0.00006931}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00002970}, {129,0.00000000}, {130,0.00000000}, {131,0.00002970}, {132,0.00008911}, {133,0.00002970}, {134,0.00000000}, {135,0.00000000}, {136,0.00002970}, {137,0.00002970}, {138,0.00002970}, {139,0.00012871}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00002970}, {144,0.00006931}, {145,0.00002970}, {146,0.00000000}, {147,0.00003960}, {148,0.00000000}, {149,0.00006931}, {150,0.00010891}, {151,0.00010891}, {152,0.00002970}, {153,0.00002970}, {154,0.00003960}, {155,0.00002970}, {156,0.00003960}, {157,0.00003960}, {158,0.00003960}, {159,0.00003960}, {160,0.00003960}, {161,0.00000000}, {162,0.00003960}, {163,0.00002970}, {164,0.00000000}, {165,0.00006931}, {166,0.00000000}, {167,0.00000000}, {168,0.00003960}, {169,0.00002970}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00006931}, {175,0.00006931}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00003960}, {181,0.00005941}, {182,0.00002970}, {183,0.00000000}, {184,0.00000000}, {185,0.00006931}, {186,0.00002970}, {187,0.00009901}, {188,0.00003960}, {189,0.00006931}, {190,0.00003960}, {191,0.00000000}, {192,0.00002970}, {193,0.00006931}, {194,0.00002970}, {195,0.00000000}, {196,0.00003960}, {197,0.00000000}, {198,0.00002970}, {199,0.00002970}, {200,0.00009901}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00006931}, {205,0.00000000}, {206,0.00000000}, {207,0.00003960}, {208,0.00000000}, {209,0.00006931}, {210,0.00003960}, {211,0.00002970}, {212,0.00000000}, {213,0.00007921}, {214,0.00002970}, {215,0.00000000}, {216,0.00003960}, {217,0.00003960}, {218,0.00007921}, {219,0.00002970}, {220,0.00003960}, {221,0.00000000}, {222,0.00002970}, {223,0.00003960}, {224,0.00000000}, {225,0.00000000}, {226,0.00006931}, {227,0.00000000}, {228,0.00003960}, {229,0.00002970}, {230,0.00003960}, {231,0.00000000}, {232,0.00002970}, {233,0.00002970}, {234,0.00000000}, {235,0.00006931}, {236,0.00000000}, {237,0.00002970}, {238,0.00002970}, {239,0.00003960}, {240,0.00000000}, {241,0.00002970}, {242,0.00006931}, {243,0.00005941}, {244,0.00000000}, {245,0.00007921}, {246,0.00000000}, {247,0.00002970}, {248,0.00000000}, {249,0.00003960}, {250,0.00000000}, {251,0.00002970}, {252,0.00000000}, {253,0.00005941}, {254,0.00005941}, {255,0.00000000}, {256,0.00000000}, {257,0.00003960}, {258,0.00003960}, {259,0.00003960}, {260,0.00000000}, {261,0.00003960}, {262,0.00002970}, {263,0.00002970}, {264,0.00005941}, {265,0.00000000}, {266,0.00000000}, {267,0.00006931}, {268,0.00000000}, {269,0.00006931}, {270,0.00003960}, {271,0.00006931}, {272,0.00002970}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00003960}, {277,0.00002970}, {278,0.00000000}, {279,0.00000000}, {280,0.00006931}, {281,0.00000000}, {282,0.00002970}, {283,0.00000000}, {284,0.00000000}, {285,0.00005941}, {286,0.00002970}, {287,0.00002970}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00003960}, {294,0.00000000}, {295,0.00000000}, {296,0.00003960}, {297,0.00000000}, {298,0.00002970}, {299,0.00002970}, {300,0.00005941}, {301,0.00008911}, {302,0.00003960}, {303,0.00000000}, {304,0.00003960}, {305,0.00003960}, {306,0.00000000}, {307,0.00002970}, {308,0.00000000}, {309,0.00000000}, {310,0.00002970}, {311,0.00005941}, {312,0.00000000}, {313,0.00002970}, {314,0.00000000}, {315,0.00003960}, {316,0.00002970}, {317,0.00005941}, {318,0.00002970}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00002970}, {323,0.00000000}, {324,0.00002970}, {325,0.00002970}, {326,0.00002970}, {327,0.00000000}, {328,0.00003960}, {329,0.00000000}, {330,0.00003960}, {331,0.00003960}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00002970}, {336,0.00000000}, {337,0.00002970}, {338,0.00002970}, {339,0.00000000}, {340,0.00002970}, {341,0.00000000}, {342,0.00003960}, {343,0.00000000}, {344,0.00000000}, {345,0.00003960}, {346,0.00000000}, {347,0.00005941}, {348,0.00000000}, {349,0.00013861}, {350,0.00003960}, {351,0.00000000}, {352,0.00000000}, {353,0.00003960}, {354,0.00006931}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00002970}, {360,0.00000000}, {361,0.00002970}, {362,0.00006931}, {363,0.00006931}, {364,0.00006931}, {365,0.00010891}, {366,0.00003960}, {367,0.00003960}, {368,0.00006931}, {369,0.00000000}, {370,0.00000000}, {371,0.00002970}, {372,0.00000000}, {373,0.00003960}, {374,0.00000000}, {375,0.00006931}, {376,0.00003960}, {377,0.00003960}, {378,0.00007921}, {379,0.00003960}, {380,0.00007921}, {381,0.00003960}, {382,0.00000000}, {383,0.00006931}, {384,0.00010891}, {385,0.00000000}, {386,0.00003960}, {387,0.00007921}, {388,0.00003960}, {389,0.00002970}, {390,0.00000000}, {391,0.00009901}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00007921}, {396,0.00000000}, {397,0.00000000}, {398,0.00005941}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00003960}, {403,0.00003960}, {404,0.00002970}, {405,0.00002970}, {406,0.00007921}, {407,0.00000000}, {408,0.00006931}, {409,0.00006931}, {410,0.00003960}, {411,0.00000000}, {412,0.00010891}, {413,0.00003960}, {414,0.00007921}, {415,0.00000000}, {416,0.00003960}, {417,0.00007921}, {418,0.00003960}, {419,0.00000000}, {420,0.00000000}, {421,0.00003960}, {422,0.00000000}, {423,0.00003960}, {424,0.00015842}, {425,0.00000000}, {426,0.00003960}, {427,0.00000000}, {428,0.00006931}, {429,0.00003960}, {430,0.00014851}, {431,0.00003960}, {432,0.00002970}, {433,0.00000000}, {434,0.00003960}, {435,0.00002970}, {436,0.00003960}, {437,0.00000000}, {438,0.00007921}, {439,0.00007921}, {440,0.00000000}, {441,0.00003960}, {442,0.00006931}, {443,0.00000000}, {444,0.00005941}, {445,0.00003960}, {446,0.00000000}, {447,0.00000000}, {448,0.00003960}, {449,0.00016832}, {450,0.00000000}, {451,0.00000000}, {452,0.00010891}, {453,0.00006931}, {454,0.00000000}, {455,0.00006931}, {456,0.00000000}, {457,0.00003960}, {458,0.00000000}, {459,0.00002970}, {460,0.00000000}, {461,0.00003960}, {462,0.00000000}, {463,0.00000000}, {464,0.00003960}, {465,0.00000000}, {466,0.00002970}, {467,0.00003960}, {468,0.00012871}, {469,0.00003960}, {470,0.00006931}, {471,0.00000000}, {472,0.00003960}, {473,0.00000000}, {474,0.00003960}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00002970}, {479,0.00009901}, {480,0.00006931}, {481,0.00000000}, {482,0.00000000}, {483,0.00003960}, {484,0.00009901}, {485,0.00007921}, {486,0.00003960}, {487,0.00000000}, {488,0.00003960}, {489,0.00000000}, {490,0.00007921}, {491,0.00003960}, {492,0.00000000}, {493,0.00002970}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00011881}, {500,0.00000000}, {505,0.00003960}, {510,0.00000000}, {515,0.00006931}, {520,0.00010891}, {525,0.00000000}, {530,0.00000000}, {535,0.00002970}, {540,0.00003960}, {545,0.00002970}, {550,0.00000000}, {555,0.00002970}, {560,0.00002970}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00002970}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00002970}, {605,0.00003960}, {610,0.00000000}, {615,0.00006931}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00008911}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00002970}, {660,0.00006931}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00006931}, {685,0.00000000}, {690,0.00000000}, {695,0.00005941}, {700,0.00000000}, {705,0.00002970}, {710,0.00002970}, {715,0.00002970}, {720,0.00002970}, {725,0.00003960}, {730,0.00002970}, {735,0.00006931}, {740,0.00006931}, {745,0.00000000}, {750,0.00003960}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00002970}, {775,0.00002970}, {780,0.00002970}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00002970}, {815,0.00007921}, {820,0.00003960}, {825,0.00002970}, {830,0.00002970}, {835,0.00002970}, {840,0.00006931}, {845,0.00003960}, {850,0.00002970}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00002970}, {875,0.00000000}, {880,0.00000000}, {885,0.00005941}, {890,0.00003960}, {895,0.00006931}, {900,0.00002970}, {905,0.00007921}, {910,0.00000000}, {915,0.00002970}, {920,0.00006931}, {925,0.00005941}, {930,0.00000000}, {935,0.00006931}, {940,0.00000000}, {945,0.00005941}, {950,0.00002970}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00011881}, {980,0.00003960}, {985,0.00002970}, {990,0.00006931}, {995,0.00009901}, {1000,0.00003960}, {1010,0.00000000}, {1020,0.00006931}, {1030,0.00002970}, {1040,0.00002970}, {1050,0.00000000}, {1060,0.00002970}, {1070,0.00000000}, {1080,0.00003960}, {1090,0.00006931}, {1100,0.00002970}, {1110,0.00003960}, {1120,0.00002970}, {1130,0.00000000}, {1140,0.00002970}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00002970}, {1180,0.00002970}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00013861}, {1230,0.00002970}, {1240,0.00000000}, {1250,0.00003960}, {1260,0.00006931}, {1270,0.00007921}, {1280,0.00000000}, {1290,0.00003960}, {1300,0.00006931}, {1310,0.00000000}, {1320,0.00002970}, {1330,0.00006931}, {1340,0.00000000}, {1350,0.00003960}, {1360,0.00003960}, {1370,0.00006931}, {1380,0.00002970}, {1390,0.00000000}, {1400,0.00002970}, {1410,0.00006931}, {1420,0.00005941}, {1430,0.00002970}, {1440,0.00003960}, {1450,0.00000000}, {1460,0.00003960}, {1470,0.00003960}, {1480,0.00003960}, {1490,0.00003960}, {1500,0.00000000}, {1510,0.00003960}, {1520,0.00002970}, {1530,0.00005941}, {1540,0.00003960}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00006931}, {1580,0.00007921}, {1590,0.00007921}, {1600,0.00006931}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00002970}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00010891}, {1680,0.00006931}, {1690,0.00006931}, {1700,0.00002970}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00003960}, {1740,0.00006931}, {1750,0.00000000}, {1760,0.00002970}, {1770,0.00000000}, {1780,0.00003960}, {1790,0.00003960}, {1800,0.00002970}, {1810,0.00010891}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00007921}, {1850,0.00002970}, {1860,0.00003960}, {1870,0.00000000}, {1880,0.00003960}, {1890,0.00002970}, {1900,0.00000000}, {1910,0.00003960}, {1920,0.00003960}, {1930,0.00000000}, {1940,0.00003960}, {1950,0.00000000}, {1960,0.00003960}, {1970,0.00002970}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00007921}, {2050,0.00000000}, {2100,0.00002970}, {2150,0.00010891}, {2200,0.00002970}, {2250,0.00003960}, {2300,0.00002970}, {2350,0.00000000}, {2400,0.00003960}, {2450,0.00005941}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00003960}, {2650,0.00006931}, {2700,0.00000000}, {2750,0.00003960}, {2800,0.00003960}, {2850,0.00006931}, {2900,0.00000000}, {2950,0.00010891}, {3000,0.00003960}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00006931}, {3250,0.00002970}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00002970}, {3450,0.00007921}, {3500,0.00003960}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00003960}, {3700,0.00002970}, {3750,0.00005941}, {3800,0.00003960}, {3850,0.00000000}, {3900,0.00003960}, {3950,0.00003960}, {4000,0.00008911}, {4050,0.00007921}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00007921}, {4300,0.00002970}, {4350,0.00002970}, {4400,0.00003960}, {4450,0.00000000}, {4500,0.00007921}, {4550,0.00006931}, {4600,0.00003960}, {4650,0.00000000}, {4700,0.00002970}, {4750,0.00000000}, {4800,0.00003960}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00006931}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00002970}, {5250,0.00003960}, {5300,0.00002970}, {5350,0.00000000}, {5400,0.00007921}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00002970}, {5600,0.00000000}, {5650,0.00005941}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00007921}, {5850,0.00003960}, {5900,0.00006931}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0001143}, {6150,0.0000000}, {6200,0.0000857}, {6250,0.0002000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0001143}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0002000}, {6750,0.0001143}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0001143}, {7000,0.0000857}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000857}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000857}, {7500,0.0001143}, {7550,0.0001143}, {7600,0.0000000}, {7650,0.0000857}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0002000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0001143}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0001143}, {8300,0.0000000}, {8350,0.0000857}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0001143}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000857}, {8950,0.0000857}, {9000,0.0001143}, {9050,0.0000000}, {9100,0.0001143}, {9150,0.0001143}, {9200,0.0001143}, {9250,0.0000000}, {9300,0.0001143}, {9350,0.0000000}, {9400,0.0001143}, {9450,0.0000857}, {9500,0.0000000}, {9550,0.0002286}, {9600,0.0002000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0001143}, {9800,0.0002286}, {9850,0.0000000}, {9900,0.0001143}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0001143}, {10200,0.0000000}, {10300,0.0000857}, {10400,0.0000000}, {10500,0.0001143}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000857}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0001143}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0001143}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000857}, {12200,0.0001143}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0001143}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000857}, {13100,0.0000857}, {13200,0.0000000}, {13300,0.0002000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000857}, {14100,0.0000000}, {14200,0.0001143}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0002000}, {14600,0.0001143}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0002286}, {15100,0.0000000}, {15200,0.0001143}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0001143}, {15800,0.0001143}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0002000}, {16400,0.0000000}, {16500,0.0001143}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0001143}, {17200,0.0000857}, {17300,0.0000000}, {17400,0.0001714}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0002000}, {18000,0.0001143}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000857}, {18600,0.0002000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0002000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000857}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0001143}, {20000,0.0000000}};
data["big_flat"]["LtacTCPrimPair"]["post"]["system"] = {{1,0.00003960}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00003960}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00002970}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00003960}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00003960}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00003960}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00003960}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00003960}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00003960}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00003960}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00003960}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0001143}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCPrimPair"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCPrimPair"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00003960}, {10,0.00003960}, {11,0.00000000}, {12,0.00000000}, {13,0.00003960}, {14,0.00000000}, {15,0.00000000}, {16,0.00003960}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00002970}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00002970}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00003960}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00002970}, {43,0.00000000}, {44,0.00003960}, {45,0.00000000}, {46,0.00000000}, {47,0.00002970}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00002970}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00002970}, {71,0.00005941}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00002970}, {92,0.00000000}, {93,0.00000000}, {94,0.00002970}, {95,0.00000000}, {96,0.00003960}, {97,0.00002970}, {98,0.00003960}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00002970}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00003960}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00003960}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00002970}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00002970}, {145,0.00000000}, {146,0.00003960}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00002970}, {155,0.00003960}, {156,0.00003960}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00002970}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00002970}, {172,0.00000000}, {173,0.00003960}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00003960}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00002970}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00002970}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00003960}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00003960}, {256,0.00000000}, {257,0.00003960}, {258,0.00000000}, {259,0.00000000}, {260,0.00002970}, {261,0.00002970}, {262,0.00003960}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00002970}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00002970}, {294,0.00003960}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00003960}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00003960}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00002970}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00003960}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00002970}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00002970}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00006931}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00002970}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00003960}, {378,0.00002970}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00002970}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00003960}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00011881}, {403,0.00000000}, {404,0.00000000}, {405,0.00002970}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00002970}, {410,0.00000000}, {411,0.00000000}, {412,0.00003960}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00002970}, {432,0.00000000}, {433,0.00003960}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00002970}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00003960}, {478,0.00002970}, {479,0.00003960}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00003960}, {570,0.00002970}, {575,0.00005941}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00002970}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00002970}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00002970}, {670,0.00000000}, {675,0.00002970}, {680,0.00003960}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00003960}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00002970}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00002970}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00003960}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00002970}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00005941}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00002970}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00002970}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00002970}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00002970}, {1200,0.00007921}, {1210,0.00000000}, {1220,0.00002970}, {1230,0.00000000}, {1240,0.00002970}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00002970}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00002970}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00003960}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00003960}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00002970}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00003960}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00003960}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00002970}, {2700,0.00003960}, {2750,0.00000000}, {2800,0.00003960}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00003960}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00003960}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00002970}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00003960}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00003960}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00003960}, {5550,0.00007921}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00002970}, {5800,0.00000000}, {5850,0.00003960}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0001143}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0001143}, {7150,0.0000857}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0001143}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0001143}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0001143}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0001143}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000857}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000857}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000857}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCPrimPair"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00002970}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTCPrimPair"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000990}, {6,0.00056436}, {7,0.00100000}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100990}, {12,0.00100000}, {13,0.00133663}, {14,0.00169307}, {15,0.00200000}, {16,0.00200000}, {17,0.00200000}, {18,0.00200000}, {19,0.00200000}, {20,0.00207921}, {21,0.00228713}, {22,0.00269307}, {23,0.00300000}, {24,0.00300000}, {25,0.00300000}, {26,0.00300000}, {27,0.00303960}, {28,0.00325743}, {29,0.00317822}, {30,0.00383168}, {31,0.00400000}, {32,0.00400000}, {33,0.00400000}, {34,0.00401980}, {35,0.00414851}, {36,0.00431683}, {37,0.00444554}, {38,0.00478218}, {39,0.00500000}, {40,0.00500000}, {41,0.00501980}, {42,0.00502970}, {43,0.00509901}, {44,0.00508911}, {45,0.00535644}, {46,0.00578218}, {47,0.00600000}, {48,0.00600000}, {49,0.00602970}, {50,0.00606931}, {51,0.00622772}, {52,0.00618812}, {53,0.00640594}, {54,0.00679208}, {55,0.00801980}, {56,0.00701980}, {57,0.00710891}, {58,0.00718812}, {59,0.00720792}, {60,0.00726733}, {61,0.00748515}, {62,0.00774257}, {63,0.00800990}, {64,0.00810891}, {65,0.00820792}, {66,0.00818812}, {67,0.00829703}, {68,0.00824752}, {69,0.00841584}, {70,0.00937624}, {71,0.00900990}, {72,0.00914851}, {73,0.00926733}, {74,0.00906931}, {75,0.00914851}, {76,0.00939604}, {77,0.00941584}, {78,0.00976238}, {79,0.01011881}, {80,0.01389109}, {81,0.01018812}, {82,0.01020792}, {83,0.01027723}, {84,0.01025743}, {85,0.01043564}, {86,0.01083168}, {87,0.01134653}, {88,0.01419802}, {89,0.01116832}, {90,0.01114851}, {91,0.01124752}, {92,0.01131683}, {93,0.01151485}, {94,0.01190099}, {95,0.01217822}, {96,0.01215842}, {97,0.01217822}, {98,0.01225743}, {99,0.01237624}, {100,0.01244554}, {101,0.01262376}, {102,0.01285149}, {103,0.01303960}, {104,0.01806931}, {105,0.01573267}, {106,0.01312871}, {107,0.01327723}, {108,0.01341584}, {109,0.01377228}, {110,0.01381188}, {111,0.01410891}, {112,0.01416832}, {113,0.01690099}, {114,0.01414851}, {115,0.01436634}, {116,0.01452475}, {117,0.01468317}, {118,0.01928713}, {119,0.01499010}, {120,0.01514851}, {121,0.01524752}, {122,0.01521782}, {123,0.01527723}, {124,0.01554455}, {125,0.01549505}, {126,0.01953465}, {127,0.01603960}, {128,0.01615842}, {129,0.02259406}, {130,0.01621782}, {131,0.01639604}, {132,0.02262376}, {133,0.01662376}, {134,0.01677228}, {135,0.02030693}, {136,0.01716832}, {137,0.01732673}, {138,0.01718812}, {139,0.01740594}, {140,0.02005941}, {141,0.01760396}, {142,0.02374257}, {143,0.01831683}, {144,0.01817822}, {145,0.01833663}, {146,0.01840594}, {147,0.01833663}, {148,0.01859406}, {149,0.01856436}, {150,0.01900000}, {151,0.01925743}, {152,0.02544554}, {153,0.01921782}, {154,0.02235644}, {155,0.01955446}, {156,0.01946535}, {157,0.01984158}, {158,0.01996040}, {159,0.02284158}, {160,0.02021782}, {161,0.02032673}, {162,0.02742574}, {163,0.02057426}, {164,0.02055446}, {165,0.02192079}, {166,0.02098020}, {167,0.02111881}, {168,0.02661386}, {169,0.02143564}, {170,0.02139604}, {171,0.02253465}, {172,0.02157426}, {173,0.02186139}, {174,0.02190099}, {175,0.02219802}, {176,0.02935644}, {177,0.02254455}, {178,0.02239604}, {179,0.02256436}, {180,0.02330693}, {181,0.02887129}, {182,0.02330693}, {183,0.02307921}, {184,0.02310891}, {185,0.02342574}, {186,0.02342574}, {187,0.02359406}, {188,0.02709901}, {189,0.02995050}, {190,0.03221782}, {191,0.02430693}, {192,0.02444554}, {193,0.02455446}, {194,0.02449505}, {195,0.02449505}, {196,0.02475248}, {197,0.02480198}, {198,0.02500990}, {199,0.02523762}, {200,0.02519802}, {201,0.02530693}, {202,0.02529703}, {203,0.02568317}, {204,0.02576238}, {205,0.02581188}, {206,0.03377228}, {207,0.03114851}, {208,0.03037624}, {209,0.02626733}, {210,0.02630693}, {211,0.02643564}, {212,0.02673267}, {213,0.02672277}, {214,0.04076238}, {215,0.03388119}, {216,0.02708911}, {217,0.02740594}, {218,0.02747525}, {219,0.02782178}, {220,0.03319802}, {221,0.02768317}, {222,0.02787129}, {223,0.02828713}, {224,0.03478218}, {225,0.02841584}, {226,0.02847525}, {227,0.02880198}, {228,0.03262376}, {229,0.02882178}, {230,0.02899010}, {231,0.03434653}, {232,0.02923762}, {233,0.02938614}, {234,0.03416832}, {235,0.02964356}, {236,0.02988119}, {237,0.03154455}, {238,0.03015842}, {239,0.03748515}, {240,0.03045545}, {241,0.03067327}, {242,0.03048515}, {243,0.03082178}, {244,0.03360396}, {245,0.03102970}, {246,0.03577228}, {247,0.03125743}, {248,0.03720792}, {249,0.03153465}, {250,0.03773267}, {251,0.03179208}, {252,0.03610891}, {253,0.03211881}, {254,0.03324752}, {255,0.03264356}, {256,0.03212871}, {257,0.04263366}, {258,0.03283168}, {259,0.03762376}, {260,0.03290099}, {261,0.03292079}, {262,0.04275248}, {263,0.03340594}, {264,0.03397030}, {265,0.04472277}, {266,0.03354455}, {267,0.03463366}, {268,0.04385149}, {269,0.03403960}, {270,0.03413861}, {271,0.04365347}, {272,0.03465347}, {273,0.03446535}, {274,0.03605941}, {275,0.04340594}, {276,0.03497030}, {277,0.03534653}, {278,0.03516832}, {279,0.04038614}, {280,0.04558416}, {281,0.03613861}, {282,0.03557426}, {283,0.03604950}, {284,0.03675248}, {285,0.04151485}, {286,0.04499010}, {287,0.04888119}, {288,0.03668317}, {289,0.03657426}, {290,0.03669307}, {291,0.03706931}, {292,0.03691089}, {293,0.03706931}, {294,0.03851485}, {295,0.04043564}, {296,0.04094059}, {297,0.04196040}, {298,0.04243564}, {299,0.04121782}, {300,0.04282178}, {301,0.04116832}, {302,0.04443564}, {303,0.04268317}, {304,0.04069307}, {305,0.03878218}, {306,0.03874257}, {307,0.03896040}, {308,0.03905941}, {309,0.03911881}, {310,0.03934653}, {311,0.05374257}, {312,0.04997030}, {313,0.04700000}, {314,0.04210891}, {315,0.04029703}, {316,0.04023762}, {317,0.04046535}, {318,0.05172277}, {319,0.04614851}, {320,0.04102970}, {321,0.04088119}, {322,0.04084158}, {323,0.05014851}, {324,0.04432673}, {325,0.04130693}, {326,0.04176238}, {327,0.05065347}, {328,0.04350495}, {329,0.04214851}, {330,0.05431683}, {331,0.04959406}, {332,0.04219802}, {333,0.04498020}, {334,0.04847525}, {335,0.04256436}, {336,0.05647525}, {337,0.04615842}, {338,0.04296040}, {339,0.05290099}, {340,0.04334653}, {341,0.04551485}, {342,0.04718812}, {343,0.04390099}, {344,0.05058416}, {345,0.04360396}, {346,0.05328713}, {347,0.04431683}, {348,0.05440594}, {349,0.04435644}, {350,0.05524752}, {351,0.04489109}, {352,0.05367327}, {353,0.04459406}, {354,0.05269307}, {355,0.04537624}, {356,0.05070297}, {357,0.04577228}, {358,0.04884158}, {359,0.06534653}, {360,0.04529703}, {361,0.05440594}, {362,0.04600000}, {363,0.04793069}, {364,0.05893069}, {365,0.04646535}, {366,0.04969307}, {367,0.05930693}, {368,0.04672277}, {369,0.04896040}, {370,0.05705941}, {371,0.04722772}, {372,0.04724752}, {373,0.05290099}, {374,0.06047525}, {375,0.04765347}, {376,0.04792079}, {377,0.05333663}, {378,0.05945545}, {379,0.04799010}, {380,0.04829703}, {381,0.05015842}, {382,0.05642574}, {383,0.06045545}, {384,0.06402970}, {385,0.04891089}, {386,0.04923762}, {387,0.04899010}, {388,0.05280198}, {389,0.05692079}, {390,0.06050495}, {391,0.06321782}, {392,0.06514851}, {393,0.05003960}, {394,0.05015842}, {395,0.05051485}, {396,0.05018812}, {397,0.05026733}, {398,0.05052475}, {399,0.05067327}, {400,0.05090099}, {401,0.05073267}, {402,0.05096040}, {403,0.05149505}, {404,0.05094059}, {405,0.05172277}, {406,0.05192079}, {407,0.05204950}, {408,0.05149505}, {409,0.06561386}, {410,0.06497030}, {411,0.06259406}, {412,0.05973267}, {413,0.05691089}, {414,0.05377228}, {415,0.05297030}, {416,0.05267327}, {417,0.07517822}, {418,0.06786139}, {419,0.06071287}, {420,0.05539604}, {421,0.05358416}, {422,0.07329703}, {423,0.06632673}, {424,0.05943564}, {425,0.05395050}, {426,0.05481188}, {427,0.06624752}, {428,0.05940594}, {429,0.05451485}, {430,0.07061386}, {431,0.06371287}, {432,0.05493069}, {433,0.05510891}, {434,0.06972277}, {435,0.05709901}, {436,0.05779208}, {437,0.06579208}, {438,0.05557426}, {439,0.07345545}, {440,0.06081188}, {441,0.05596040}, {442,0.06673267}, {443,0.05647525}, {444,0.06955446}, {445,0.05897030}, {446,0.07245545}, {447,0.06091089}, {448,0.07373267}, {449,0.06233663}, {450,0.05712871}, {451,0.06760396}, {452,0.05727723}, {453,0.06656436}, {454,0.05819802}, {455,0.06372277}, {456,0.07419802}, {457,0.06071287}, {458,0.07327723}, {459,0.05846535}, {460,0.06839604}, {461,0.05870297}, {462,0.06329703}, {463,0.07327723}, {464,0.05873267}, {465,0.06727723}, {466,0.07399010}, {467,0.05937624}, {468,0.07215842}, {469,0.07960396}, {470,0.06000000}, {471,0.06922772}, {472,0.07600990}, {473,0.06043564}, {474,0.06400000}, {475,0.07171287}, {476,0.07771287}, {477,0.06116832}, {478,0.06402970}, {479,0.07024752}, {480,0.07341584}, {481,0.06113861}, {482,0.06110891}, {483,0.06723762}, {484,0.07192079}, {485,0.07670297}, {486,0.08011881}, {487,0.06215842}, {488,0.06185149}, {489,0.06440594}, {490,0.06783168}, {491,0.07088119}, {492,0.07305941}, {493,0.07351485}, {494,0.08417822}, {495,0.08401980}, {496,0.08200990}, {497,0.08376238}, {498,0.08477228}, {499,0.06544554}, {500,0.06375248}, {505,0.06489109}, {510,0.08422772}, {515,0.08220792}, {520,0.07912871}, {525,0.07596040}, {530,0.07015842}, {535,0.09750495}, {540,0.08366337}, {545,0.07348515}, {550,0.08787129}, {555,0.07688119}, {560,0.08785149}, {565,0.07530693}, {570,0.08393069}, {575,0.09326733}, {580,0.07418812}, {585,0.08445545}, {590,0.08750495}, {595,0.09130693}, {600,0.09321782}, {605,0.09394059}, {610,0.09248515}, {615,0.09124752}, {620,0.08857426}, {625,0.08740594}, {630,0.11607921}, {635,0.10067327}, {640,0.09038614}, {645,0.10926733}, {650,0.09712871}, {655,0.08682178}, {660,0.09791089}, {665,0.10325743}, {670,0.09676238}, {675,0.10547525}, {680,0.11248515}, {685,0.09354455}, {690,0.09736634}, {695,0.10146535}, {700,0.10302970}, {705,0.10669307}, {710,0.10731683}, {715,0.10523762}, {720,0.10179208}, {725,0.09923762}, {730,0.11873267}, {735,0.12190099}, {740,0.10614851}, {745,0.12345545}, {750,0.11216832}, {755,0.12492079}, {760,0.11201980}, {765,0.13569307}, {770,0.10985149}, {775,0.11951485}, {780,0.12526733}, {785,0.10772277}, {790,0.11047525}, {795,0.12027723}, {800,0.11935644}, {805,0.12255446}, {810,0.12247525}, {815,0.12168317}, {820,0.12653465}, {825,0.11817822}, {830,0.13932673}, {835,0.12948515}, {840,0.12259406}, {845,0.15456436}, {850,0.13327723}, {855,0.12150495}, {860,0.13184158}, {865,0.14248515}, {870,0.13259406}, {875,0.14277228}, {880,0.14689109}, {885,0.12827723}, {890,0.12833663}, {895,0.14143564}, {900,0.14014851}, {905,0.13955446}, {910,0.14007921}, {915,0.13361386}, {920,0.14070297}, {925,0.13718812}, {930,0.13050495}, {935,0.14904950}, {940,0.15263366}, {945,0.13824752}, {950,0.15089109}, {955,0.13956436}, {960,0.14504950}, {965,0.14284158}, {970,0.15200000}, {975,0.15830693}, {980,0.14231683}, {985,0.15296040}, {990,0.15766337}, {995,0.15794059}, {1000,0.16105941}, {1010,0.17056436}, {1020,0.16659406}, {1030,0.16097030}, {1040,0.17088119}, {1050,0.15412871}, {1060,0.16679208}, {1070,0.15515842}, {1080,0.17007921}, {1090,0.17683168}, {1100,0.17804950}, {1110,0.20275248}, {1120,0.17830693}, {1130,0.17999010}, {1140,0.17605941}, {1150,0.17348515}, {1160,0.18752475}, {1170,0.17232673}, {1180,0.19025743}, {1190,0.19370297}, {1200,0.19593069}, {1210,0.17974257}, {1220,0.17971287}, {1230,0.19865347}, {1240,0.20019802}, {1250,0.18988119}, {1260,0.20274257}, {1270,0.19773267}, {1280,0.19914851}, {1290,0.20356436}, {1300,0.19094059}, {1310,0.19576238}, {1320,0.20905941}, {1330,0.19883168}, {1340,0.21473267}, {1350,0.21494059}, {1360,0.20029703}, {1370,0.22393069}, {1380,0.21755446}, {1390,0.20821782}, {1400,0.22267327}, {1410,0.21722772}, {1420,0.21559406}, {1430,0.21976238}, {1440,0.21117822}, {1450,0.23809901}, {1460,0.22252475}, {1470,0.24559406}, {1480,0.22353465}, {1490,0.22816832}, {1500,0.24227723}, {1510,0.23557426}, {1520,0.24612871}, {1530,0.23956436}, {1540,0.24051485}, {1550,0.23443564}, {1560,0.24261386}, {1570,0.23077228}, {1580,0.24510891}, {1590,0.26356436}, {1600,0.23649505}, {1610,0.24798020}, {1620,0.24184158}, {1630,0.24938614}, {1640,0.25861386}, {1650,0.26411881}, {1660,0.24794059}, {1670,0.26756436}, {1680,0.24806931}, {1690,0.26516832}, {1700,0.26251485}, {1710,0.27703960}, {1720,0.26752475}, {1730,0.27501980}, {1740,0.26331683}, {1750,0.25948515}, {1760,0.27227723}, {1770,0.26644554}, {1780,0.27544554}, {1790,0.29035644}, {1800,0.30903960}, {1810,0.27120792}, {1820,0.28954455}, {1830,0.29554455}, {1840,0.29992079}, {1850,0.28593069}, {1860,0.28766337}, {1870,0.29248515}, {1880,0.28905941}, {1890,0.31676238}, {1900,0.29518812}, {1910,0.30971287}, {1920,0.29905941}, {1930,0.30833663}, {1940,0.32611881}, {1950,0.29407921}, {1960,0.31803960}, {1970,0.29834653}, {1980,0.31431683}, {1990,0.33938614}, {2000,0.29948515}, {2050,0.31855446}, {2100,0.33125743}, {2150,0.34282178}, {2200,0.35075248}, {2250,0.34932673}, {2300,0.35142574}, {2350,0.36547525}, {2400,0.41001980}, {2450,0.38690099}, {2500,0.38644554}, {2550,0.40582178}, {2600,0.42875248}, {2650,0.41879208}, {2700,0.46066337}, {2750,0.44427723}, {2800,0.43458416}, {2850,0.44918812}, {2900,0.47114851}, {2950,0.45768317}, {3000,0.48208911}, {3050,0.48912871}, {3100,0.48765347}, {3150,0.50151485}, {3200,0.52569307}, {3250,0.51751485}, {3300,0.53746535}, {3350,0.54864356}, {3400,0.54391089}, {3450,0.56050495}, {3500,0.55732673}, {3550,0.56804950}, {3600,0.58371287}, {3650,0.57186139}, {3700,0.59061386}, {3750,0.61502970}, {3800,0.63470297}, {3850,0.63511881}, {3900,0.62455446}, {3950,0.63353465}, {4000,0.64439604}, {4050,0.65658416}, {4100,0.67621782}, {4150,0.66693069}, {4200,0.67803960}, {4250,0.69711881}, {4300,0.70656436}, {4350,0.70947525}, {4400,0.70753465}, {4450,0.74250495}, {4500,0.71482178}, {4550,0.73249505}, {4600,0.76637624}, {4650,0.73713861}, {4700,0.78446535}, {4750,0.77495050}, {4800,0.77579208}, {4850,0.79094059}, {4900,0.79500000}, {4950,0.80541584}, {5000,0.80996040}, {5050,0.82058416}, {5100,0.84930693}, {5150,0.84983168}, {5200,0.86341584}, {5250,0.86169307}, {5300,0.88660396}, {5350,0.88444554}, {5400,0.87747525}, {5450,0.90904950}, {5500,0.89862376}, {5550,0.90669307}, {5600,0.92084158}, {5650,0.90588119}, {5700,0.91447525}, {5750,0.94863366}, {5800,0.95208911}, {5850,0.94645545}, {5900,0.96404950}, {5950,0.98730693}, {6000,0.99191089}, {6050,1.0314571}, {6100,1.0283714}, {6150,1.0494571}, {6200,1.0586857}, {6250,1.0758286}, {6300,1.0766857}, {6350,1.1150000}, {6400,1.1020857}, {6450,1.1054286}, {6500,1.0920571}, {6550,1.0955143}, {6600,1.0976000}, {6650,1.1087143}, {6700,1.1203429}, {6750,1.1299429}, {6800,1.1510000}, {6850,1.1386286}, {6900,1.1512571}, {6950,1.1707429}, {7000,1.1843143}, {7050,1.1972571}, {7100,1.2371429}, {7150,1.2510571}, {7200,1.2481429}, {7250,1.2538286}, {7300,1.2627714}, {7350,1.2634571}, {7400,1.2677429}, {7450,1.2771714}, {7500,1.2669714}, {7550,1.2644857}, {7600,1.2918000}, {7650,1.3235714}, {7700,1.3595714}, {7750,1.3492286}, {7800,1.3561143}, {7850,1.3378000}, {7900,1.3344857}, {7950,1.3906000}, {8000,1.3882857}, {8050,1.3959714}, {8100,1.3831143}, {8150,1.3756571}, {8200,1.4085143}, {8250,1.4388286}, {8300,1.4182286}, {8350,1.4191714}, {8400,1.4164000}, {8450,1.4660857}, {8500,1.4656000}, {8550,1.4693143}, {8600,1.4625429}, {8650,1.5375143}, {8700,1.4988571}, {8750,1.4798286}, {8800,1.5209429}, {8850,1.5240857}, {8900,1.4900286}, {8950,1.5834286}, {9000,1.5401714}, {9050,1.5288857}, {9100,1.5906286}, {9150,1.5862857}, {9200,1.5505714}, {9250,1.6178286}, {9300,1.6089143}, {9350,1.6244571}, {9400,1.6332286}, {9450,1.6038857}, {9500,1.6618857}, {9550,1.6412857}, {9600,1.6815143}, {9650,1.6566571}, {9700,1.6550286}, {9750,1.6984857}, {9800,1.6544286}, {9850,1.7242000}, {9900,1.7016286}, {9950,1.7250000}, {10000,1.6952857}, {10100,1.7525143}, {10200,1.7630571}, {10300,1.7845143}, {10400,1.7488286}, {10500,1.8202286}, {10600,1.7606571}, {10700,1.8501429}, {10800,1.8271714}, {10900,1.8738571}, {11000,1.8594000}, {11100,1.9315429}, {11200,1.9010857}, {11300,1.9374000}, {11400,1.9464286}, {11500,1.9642571}, {11600,1.9973429}, {11700,1.9904286}, {11800,2.0396857}, {11900,2.0482857}, {12000,2.0502857}, {12100,2.0686857}, {12200,2.1016571}, {12300,2.0828286}, {12400,2.1388286}, {12500,2.1337429}, {12600,2.1466857}, {12700,2.1704571}, {12800,2.1632286}, {12900,2.2067143}, {13000,2.1869429}, {13100,2.2278286}, {13200,2.2591429}, {13300,2.2631429}, {13400,2.2940571}, {13500,2.3049143}, {13600,2.3122000}, {13700,2.3463143}, {13800,2.3476000}, {13900,2.3845143}, {14000,2.3904286}, {14100,2.4000286}, {14200,2.4297143}, {14300,2.4426286}, {14400,2.4606571}, {14500,2.4833143}, {14600,2.6552000}, {14700,2.5116286}, {14800,2.5239429}, {14900,2.5480571}, {15000,2.5793429}, {15100,2.5632000}, {15200,2.8602286}, {15300,2.7112571}, {15400,2.6511714}, {15500,2.6277143}, {15600,2.7254000}, {15700,2.7505429}, {15800,2.6820857}, {15900,2.7213143}, {16000,2.7146857}, {16100,2.7282000}, {16200,2.7359429}, {16300,2.8548286}, {16400,2.7469143}, {16500,2.8829143}, {16600,3.1093429}, {16700,2.8299143}, {16800,2.9472857}, {16900,2.8596571}, {17000,3.0254571}, {17100,2.9120571}, {17200,3.0256000}, {17300,2.9622286}, {17400,2.9480286}, {17500,3.1436286}, {17600,2.9666000}, {17700,3.0259143}, {17800,3.0995143}, {17900,3.1303714}, {18000,3.0720857}, {18100,3.0748286}, {18200,3.0950571}, {18300,3.1286857}, {18400,3.1274857}, {18500,3.2074286}, {18600,3.1686286}, {18700,3.1963714}, {18800,3.1917143}, {18900,3.2513143}, {19000,3.2454571}, {19100,3.2646857}, {19200,3.2750571}, {19300,3.3602286}, {19400,3.3703429}, {19500,3.3227143}, {19600,3.3506857}, {19700,3.5292286}, {19800,3.3779429}, {19900,3.5666857}, {20000,3.6229143}};
data["big_flat"]["LtacTCPrimPair"]["reif"]["user"] = {{1,0.00025743}, {2,0.00056436}, {3,0.00031683}, {4,0.00071287}, {5,0.00088119}, {6,0.00096040}, {7,0.00058416}, {8,0.00139604}, {9,0.00096040}, {10,0.00110891}, {11,0.00115842}, {12,0.00175248}, {13,0.00183168}, {14,0.00184158}, {15,0.00200990}, {16,0.00210891}, {17,0.00213861}, {18,0.00218812}, {19,0.00266337}, {20,0.00266337}, {21,0.00259406}, {22,0.00273267}, {23,0.00257426}, {24,0.00275248}, {25,0.00279208}, {26,0.00302970}, {27,0.00315842}, {28,0.00342574}, {29,0.00329703}, {30,0.00364356}, {31,0.00363366}, {32,0.00409901}, {33,0.00416832}, {34,0.00410891}, {35,0.00429703}, {36,0.00466337}, {37,0.00457426}, {38,0.00495050}, {39,0.00505941}, {40,0.00497030}, {41,0.00481188}, {42,0.00541584}, {43,0.00531683}, {44,0.00528713}, {45,0.00591089}, {46,0.00543564}, {47,0.00591089}, {48,0.00621782}, {49,0.00626733}, {50,0.00647525}, {51,0.00639604}, {52,0.00646535}, {53,0.00710891}, {54,0.00713861}, {55,0.00817822}, {56,0.00737624}, {57,0.00745545}, {58,0.00736634}, {59,0.00760396}, {60,0.00767327}, {61,0.00773267}, {62,0.00761386}, {63,0.00781188}, {64,0.00796040}, {65,0.00813861}, {66,0.00819802}, {67,0.00835644}, {68,0.00804950}, {69,0.00871287}, {70,0.00951485}, {71,0.00880198}, {72,0.00881188}, {73,0.00906931}, {74,0.00934653}, {75,0.00972277}, {76,0.00951485}, {77,0.00948515}, {78,0.00975248}, {79,0.00971287}, {80,0.01448515}, {81,0.01035644}, {82,0.01031683}, {83,0.01041584}, {84,0.01065347}, {85,0.01091089}, {86,0.01096040}, {87,0.01159406}, {88,0.01416832}, {89,0.01139604}, {90,0.01139604}, {91,0.01138614}, {92,0.01169307}, {93,0.01190099}, {94,0.01191089}, {95,0.01201980}, {96,0.01217822}, {97,0.01239604}, {98,0.01262376}, {99,0.01260396}, {100,0.01255446}, {101,0.01300990}, {102,0.01300000}, {103,0.01295050}, {104,0.01781188}, {105,0.01606931}, {106,0.01314851}, {107,0.01364356}, {108,0.01406931}, {109,0.01366337}, {110,0.01439604}, {111,0.01445545}, {112,0.01437624}, {113,0.01700990}, {114,0.01433663}, {115,0.01490099}, {116,0.01528713}, {117,0.01496040}, {118,0.01899010}, {119,0.01531683}, {120,0.01524752}, {121,0.01565347}, {122,0.01561386}, {123,0.01565347}, {124,0.01614851}, {125,0.01604950}, {126,0.01911881}, {127,0.01636634}, {128,0.01644554}, {129,0.02257426}, {130,0.01650495}, {131,0.01678218}, {132,0.02239604}, {133,0.01685149}, {134,0.01695050}, {135,0.01998020}, {136,0.01748515}, {137,0.01755446}, {138,0.01710891}, {139,0.01748515}, {140,0.01966337}, {141,0.01768317}, {142,0.02370297}, {143,0.01793069}, {144,0.01784158}, {145,0.01821782}, {146,0.01823762}, {147,0.01784158}, {148,0.01827723}, {149,0.01822772}, {150,0.01857426}, {151,0.01890099}, {152,0.02526733}, {153,0.01884158}, {154,0.02254455}, {155,0.01905941}, {156,0.01922772}, {157,0.01946535}, {158,0.01956436}, {159,0.02278218}, {160,0.01948515}, {161,0.01979208}, {162,0.02718812}, {163,0.02044554}, {164,0.02037624}, {165,0.02180198}, {166,0.02069307}, {167,0.02099010}, {168,0.02665347}, {169,0.02110891}, {170,0.02116832}, {171,0.02223762}, {172,0.02174257}, {173,0.02184158}, {174,0.02211881}, {175,0.02209901}, {176,0.02929703}, {177,0.02271287}, {178,0.02279208}, {179,0.02257426}, {180,0.02310891}, {181,0.02873267}, {182,0.02314851}, {183,0.02314851}, {184,0.02307921}, {185,0.02338614}, {186,0.02344554}, {187,0.02364356}, {188,0.02689109}, {189,0.03005941}, {190,0.03253465}, {191,0.02421782}, {192,0.02460396}, {193,0.02461386}, {194,0.02478218}, {195,0.02468317}, {196,0.02506931}, {197,0.02487129}, {198,0.02492079}, {199,0.02543564}, {200,0.02499010}, {201,0.02517822}, {202,0.02524752}, {203,0.02577228}, {204,0.02587129}, {205,0.02573267}, {206,0.03358416}, {207,0.03131683}, {208,0.03041584}, {209,0.02578218}, {210,0.02599010}, {211,0.02659406}, {212,0.02672277}, {213,0.02684158}, {214,0.04047525}, {215,0.03373267}, {216,0.02670297}, {217,0.02725743}, {218,0.02702970}, {219,0.02786139}, {220,0.03339604}, {221,0.02745545}, {222,0.02800990}, {223,0.02855446}, {224,0.03472277}, {225,0.02831683}, {226,0.02839604}, {227,0.02836634}, {228,0.03291089}, {229,0.02906931}, {230,0.02910891}, {231,0.03434653}, {232,0.02937624}, {233,0.02929703}, {234,0.03446535}, {235,0.02985149}, {236,0.03009901}, {237,0.03155446}, {238,0.02993069}, {239,0.03722772}, {240,0.03030693}, {241,0.03026733}, {242,0.03008911}, {243,0.03064356}, {244,0.03350495}, {245,0.03070297}, {246,0.03581188}, {247,0.03105941}, {248,0.03746535}, {249,0.03136634}, {250,0.03746535}, {251,0.03186139}, {252,0.03598020}, {253,0.03200990}, {254,0.03315842}, {255,0.03249505}, {256,0.03216832}, {257,0.04234653}, {258,0.03282178}, {259,0.03764356}, {260,0.03293069}, {261,0.03316832}, {262,0.04281188}, {263,0.03352475}, {264,0.03426733}, {265,0.04486139}, {266,0.03337624}, {267,0.03489109}, {268,0.04365347}, {269,0.03421782}, {270,0.03411881}, {271,0.04380198}, {272,0.03498020}, {273,0.03471287}, {274,0.03626733}, {275,0.04349505}, {276,0.03518812}, {277,0.03571287}, {278,0.03545545}, {279,0.03994059}, {280,0.04578218}, {281,0.03643564}, {282,0.03579208}, {283,0.03616832}, {284,0.03691089}, {285,0.04142574}, {286,0.04463366}, {287,0.04841584}, {288,0.03684158}, {289,0.03654455}, {290,0.03669307}, {291,0.03703960}, {292,0.03700000}, {293,0.03707921}, {294,0.03814851}, {295,0.04008911}, {296,0.04077228}, {297,0.04173267}, {298,0.04217822}, {299,0.04100000}, {300,0.04265347}, {301,0.04089109}, {302,0.04434653}, {303,0.04241584}, {304,0.04015842}, {305,0.03858416}, {306,0.03845545}, {307,0.03861386}, {308,0.03873267}, {309,0.03876238}, {310,0.03895050}, {311,0.05371287}, {312,0.04972277}, {313,0.04697030}, {314,0.04202970}, {315,0.03997030}, {316,0.03997030}, {317,0.04008911}, {318,0.05144554}, {319,0.04599010}, {320,0.04077228}, {321,0.04075248}, {322,0.04056436}, {323,0.04989109}, {324,0.04419802}, {325,0.04085149}, {326,0.04151485}, {327,0.05021782}, {328,0.04338614}, {329,0.04201980}, {330,0.05393069}, {331,0.04937624}, {332,0.04219802}, {333,0.04491089}, {334,0.04841584}, {335,0.04253465}, {336,0.05630693}, {337,0.04596040}, {338,0.04288119}, {339,0.05282178}, {340,0.04301980}, {341,0.04543564}, {342,0.04700000}, {343,0.04369307}, {344,0.05002970}, {345,0.04318812}, {346,0.05268317}, {347,0.04417822}, {348,0.05354455}, {349,0.04443564}, {350,0.05439604}, {351,0.04510891}, {352,0.05339604}, {353,0.04413861}, {354,0.05224752}, {355,0.04522772}, {356,0.05073267}, {357,0.04590099}, {358,0.04886139}, {359,0.06516832}, {360,0.04529703}, {361,0.05402970}, {362,0.04616832}, {363,0.04819802}, {364,0.05898020}, {365,0.04617822}, {366,0.04959406}, {367,0.05917822}, {368,0.04703960}, {369,0.04903960}, {370,0.05640594}, {371,0.04739604}, {372,0.04750495}, {373,0.05285149}, {374,0.06047525}, {375,0.04753465}, {376,0.04805941}, {377,0.05309901}, {378,0.05930693}, {379,0.04809901}, {380,0.04838614}, {381,0.04991089}, {382,0.05622772}, {383,0.06000990}, {384,0.06353465}, {385,0.04877228}, {386,0.04954455}, {387,0.04900990}, {388,0.05241584}, {389,0.05675248}, {390,0.06050495}, {391,0.06299010}, {392,0.06512871}, {393,0.05023762}, {394,0.05018812}, {395,0.05073267}, {396,0.05033663}, {397,0.05046535}, {398,0.05044554}, {399,0.05068317}, {400,0.05087129}, {401,0.05065347}, {402,0.05034653}, {403,0.05133663}, {404,0.05085149}, {405,0.05182178}, {406,0.05171287}, {407,0.05208911}, {408,0.05102970}, {409,0.06563366}, {410,0.06456436}, {411,0.06292079}, {412,0.05966337}, {413,0.05679208}, {414,0.05372277}, {415,0.05299010}, {416,0.05243564}, {417,0.07501980}, {418,0.06760396}, {419,0.06074257}, {420,0.05528713}, {421,0.05342574}, {422,0.07318812}, {423,0.06605941}, {424,0.05934653}, {425,0.05384158}, {426,0.05421782}, {427,0.06570297}, {428,0.05937624}, {429,0.05405941}, {430,0.07061386}, {431,0.06345545}, {432,0.05453465}, {433,0.05518812}, {434,0.06963366}, {435,0.05682178}, {436,0.05799010}, {437,0.06530693}, {438,0.05526733}, {439,0.07308911}, {440,0.06078218}, {441,0.05555446}, {442,0.06643564}, {443,0.05626733}, {444,0.06930693}, {445,0.05889109}, {446,0.07239604}, {447,0.06090099}, {448,0.07344554}, {449,0.06221782}, {450,0.05690099}, {451,0.06741584}, {452,0.05706931}, {453,0.06632673}, {454,0.05803960}, {455,0.06359406}, {456,0.07428713}, {457,0.06093069}, {458,0.07332673}, {459,0.05837624}, {460,0.06812871}, {461,0.05894059}, {462,0.06301980}, {463,0.07339604}, {464,0.05861386}, {465,0.06701980}, {466,0.07392079}, {467,0.05946535}, {468,0.07213861}, {469,0.07921782}, {470,0.05998020}, {471,0.06894059}, {472,0.07568317}, {473,0.06066337}, {474,0.06384158}, {475,0.07120792}, {476,0.07747525}, {477,0.06141584}, {478,0.06376238}, {479,0.07011881}, {480,0.07334653}, {481,0.06108911}, {482,0.06119802}, {483,0.06675248}, {484,0.07179208}, {485,0.07653465}, {486,0.08005941}, {487,0.06208911}, {488,0.06194059}, {489,0.06424752}, {490,0.06742574}, {491,0.07086139}, {492,0.07340594}, {493,0.07324752}, {494,0.08424752}, {495,0.08395050}, {496,0.08198020}, {497,0.08355446}, {498,0.08458416}, {499,0.06526733}, {500,0.06365347}, {505,0.06450495}, {510,0.08380198}, {515,0.08195050}, {520,0.07907921}, {525,0.07563366}, {530,0.07011881}, {535,0.09706931}, {540,0.08367327}, {545,0.07348515}, {550,0.08747525}, {555,0.07660396}, {560,0.08738614}, {565,0.07488119}, {570,0.08380198}, {575,0.09297030}, {580,0.07430693}, {585,0.08472277}, {590,0.08727723}, {595,0.09096040}, {600,0.09303960}, {605,0.09377228}, {610,0.09256436}, {615,0.09111881}, {620,0.08830693}, {625,0.08719802}, {630,0.11586139}, {635,0.10033663}, {640,0.09011881}, {645,0.10881188}, {650,0.09682178}, {655,0.08708911}, {660,0.09738614}, {665,0.10329703}, {670,0.09686139}, {675,0.10554455}, {680,0.11211881}, {685,0.09354455}, {690,0.09725743}, {695,0.10128713}, {700,0.10278218}, {705,0.10671287}, {710,0.10733663}, {715,0.10519802}, {720,0.10136634}, {725,0.09879208}, {730,0.11840594}, {735,0.12150495}, {740,0.10568317}, {745,0.12309901}, {750,0.11178218}, {755,0.12477228}, {760,0.11187129}, {765,0.13533663}, {770,0.10947525}, {775,0.11910891}, {780,0.12483168}, {785,0.10757426}, {790,0.11032673}, {795,0.12003960}, {800,0.11925743}, {805,0.12226733}, {810,0.12205941}, {815,0.12119802}, {820,0.12662376}, {825,0.11802970}, {830,0.13918812}, {835,0.12909901}, {840,0.12206931}, {845,0.15430693}, {850,0.13295050}, {855,0.12116832}, {860,0.13146535}, {865,0.14242574}, {870,0.13227723}, {875,0.14246535}, {880,0.14651485}, {885,0.12775248}, {890,0.12799010}, {895,0.14107921}, {900,0.13970297}, {905,0.13907921}, {910,0.13945545}, {915,0.13338614}, {920,0.14053465}, {925,0.13707921}, {930,0.13035644}, {935,0.14873267}, {940,0.15239604}, {945,0.13799010}, {950,0.15084158}, {955,0.13936634}, {960,0.14495050}, {965,0.14298020}, {970,0.15181188}, {975,0.15816832}, {980,0.14200000}, {985,0.15255446}, {990,0.15725743}, {995,0.15754455}, {1000,0.16070297}, {1010,0.16988119}, {1020,0.16621782}, {1030,0.16060396}, {1040,0.17045545}, {1050,0.15349505}, {1060,0.16669307}, {1070,0.15474257}, {1080,0.16946535}, {1090,0.17649505}, {1100,0.17789109}, {1110,0.20186139}, {1120,0.17798020}, {1130,0.17928713}, {1140,0.17591089}, {1150,0.17306931}, {1160,0.18724752}, {1170,0.17221782}, {1180,0.18975248}, {1190,0.19322772}, {1200,0.19498020}, {1210,0.17919802}, {1220,0.17901980}, {1230,0.19824752}, {1240,0.19979208}, {1250,0.18936634}, {1260,0.20243564}, {1270,0.19680198}, {1280,0.19888119}, {1290,0.20276238}, {1300,0.19025743}, {1310,0.19541584}, {1320,0.20867327}, {1330,0.19846535}, {1340,0.21406931}, {1350,0.21395050}, {1360,0.19948515}, {1370,0.22333663}, {1380,0.21699010}, {1390,0.20740594}, {1400,0.22210891}, {1410,0.21655446}, {1420,0.21484158}, {1430,0.21924752}, {1440,0.21033663}, {1450,0.23752475}, {1460,0.22191089}, {1470,0.24506931}, {1480,0.22274257}, {1490,0.22754455}, {1500,0.24169307}, {1510,0.23488119}, {1520,0.24518812}, {1530,0.23903960}, {1540,0.23984158}, {1550,0.23375248}, {1560,0.24219802}, {1570,0.23009901}, {1580,0.24454455}, {1590,0.26280198}, {1600,0.23570297}, {1610,0.24735644}, {1620,0.24103960}, {1630,0.24897030}, {1640,0.25792079}, {1650,0.26343564}, {1660,0.24718812}, {1670,0.26651485}, {1680,0.24742574}, {1690,0.26452475}, {1700,0.26179208}, {1710,0.27615842}, {1720,0.26670297}, {1730,0.27453465}, {1740,0.26252475}, {1750,0.25894059}, {1760,0.27162376}, {1770,0.26555446}, {1780,0.27430693}, {1790,0.28973267}, {1800,0.30816832}, {1810,0.27024752}, {1820,0.28829703}, {1830,0.29473267}, {1840,0.29898020}, {1850,0.28507921}, {1860,0.28682178}, {1870,0.29165347}, {1880,0.28823762}, {1890,0.31605941}, {1900,0.29442574}, {1910,0.30865347}, {1920,0.29833663}, {1930,0.30724752}, {1940,0.32502970}, {1950,0.29329703}, {1960,0.31730693}, {1970,0.29751485}, {1980,0.31315842}, {1990,0.33836634}, {2000,0.29878218}, {2050,0.31778218}, {2100,0.33017822}, {2150,0.34196040}, {2200,0.34966337}, {2250,0.34863366}, {2300,0.35031683}, {2350,0.36481188}, {2400,0.40898020}, {2450,0.38606931}, {2500,0.38578218}, {2550,0.40484158}, {2600,0.42759406}, {2650,0.41796040}, {2700,0.45964356}, {2750,0.44305941}, {2800,0.43352475}, {2850,0.44517822}, {2900,0.46993069}, {2950,0.45655446}, {3000,0.48124752}, {3050,0.48806931}, {3100,0.48688119}, {3150,0.50036634}, {3200,0.52486139}, {3250,0.51630693}, {3300,0.53661386}, {3350,0.54768317}, {3400,0.54294059}, {3450,0.55925743}, {3500,0.55635644}, {3550,0.56711881}, {3600,0.58273267}, {3650,0.57104950}, {3700,0.58956436}, {3750,0.61398020}, {3800,0.63340594}, {3850,0.63397030}, {3900,0.62345545}, {3950,0.63244554}, {4000,0.64328713}, {4050,0.65519802}, {4100,0.67503960}, {4150,0.66631683}, {4200,0.67679208}, {4250,0.69579208}, {4300,0.70534653}, {4350,0.70848515}, {4400,0.70611881}, {4450,0.74154455}, {4500,0.71306931}, {4550,0.73112871}, {4600,0.76481188}, {4650,0.73580198}, {4700,0.78278218}, {4750,0.77331683}, {4800,0.77454455}, {4850,0.78942574}, {4900,0.79367327}, {4950,0.80396040}, {5000,0.80807921}, {5050,0.81878218}, {5100,0.84768317}, {5150,0.84816832}, {5200,0.86124752}, {5250,0.85960396}, {5300,0.88509901}, {5350,0.88283168}, {5400,0.87557426}, {5450,0.90710891}, {5500,0.89656436}, {5550,0.90493069}, {5600,0.91909901}, {5650,0.90418812}, {5700,0.91236634}, {5750,0.94703960}, {5800,0.95040594}, {5850,0.94418812}, {5900,0.96194059}, {5950,0.98552475}, {6000,0.99031683}, {6050,1.0234286}, {6100,1.0216286}, {6150,1.0488857}, {6200,1.0571714}, {6250,1.0743143}, {6300,1.0755429}, {6350,1.1140857}, {6400,1.1007714}, {6450,1.1043143}, {6500,1.0909143}, {6550,1.0942000}, {6600,1.0967714}, {6650,1.1083143}, {6700,1.1194857}, {6750,1.1263714}, {6800,1.1471143}, {6850,1.1372857}, {6900,1.1500286}, {6950,1.1692571}, {7000,1.1812857}, {7050,1.1964000}, {7100,1.2355143}, {7150,1.2496857}, {7200,1.2453143}, {7250,1.2528857}, {7300,1.2577143}, {7350,1.2599714}, {7400,1.2657429}, {7450,1.2734000}, {7500,1.2610857}, {7550,1.2604857}, {7600,1.2874000}, {7650,1.3138857}, {7700,1.3544286}, {7750,1.3367429}, {7800,1.3501429}, {7850,1.3356571}, {7900,1.3322000}, {7950,1.3869429}, {8000,1.3819429}, {8050,1.3906286}, {8100,1.3807714}, {8150,1.3737143}, {8200,1.4063714}, {8250,1.4368571}, {8300,1.4167714}, {8350,1.4175143}, {8400,1.4144571}, {8450,1.4640571}, {8500,1.4637429}, {8550,1.4674000}, {8600,1.4604857}, {8650,1.5358571}, {8700,1.4976000}, {8750,1.4741429}, {8800,1.5196571}, {8850,1.5225714}, {8900,1.4883143}, {8950,1.5814000}, {9000,1.5386000}, {9050,1.5273429}, {9100,1.5885429}, {9150,1.5766857}, {9200,1.5484571}, {9250,1.6154571}, {9300,1.6054857}, {9350,1.6220286}, {9400,1.6305429}, {9450,1.6010286}, {9500,1.6598000}, {9550,1.6392286}, {9600,1.6786000}, {9650,1.6540000}, {9700,1.6522286}, {9750,1.6959429}, {9800,1.6515714}, {9850,1.7219143}, {9900,1.6991143}, {9950,1.7227429}, {10000,1.6928000}, {10100,1.7497143}, {10200,1.7607429}, {10300,1.7815714}, {10400,1.7460286}, {10500,1.8176286}, {10600,1.7582286}, {10700,1.8482857}, {10800,1.8248286}, {10900,1.8705714}, {11000,1.8566286}, {11100,1.9283714}, {11200,1.8977714}, {11300,1.9341714}, {11400,1.9430571}, {11500,1.9612857}, {11600,1.9940000}, {11700,1.9867143}, {11800,2.0363714}, {11900,2.0438286}, {12000,2.0469714}, {12100,2.0648571}, {12200,2.0987143}, {12300,2.0796000}, {12400,2.1350857}, {12500,2.1296286}, {12600,2.1432571}, {12700,2.1670000}, {12800,2.1600286}, {12900,2.2035714}, {13000,2.1838286}, {13100,2.2248571}, {13200,2.2556571}, {13300,2.2589714}, {13400,2.2905429}, {13500,2.3013143}, {13600,2.3091429}, {13700,2.3339143}, {13800,2.3443714}, {13900,2.3823429}, {14000,2.3877714}, {14100,2.3969429}, {14200,2.4259714}, {14300,2.4396857}, {14400,2.4585429}, {14500,2.4803143}, {14600,2.6524286}, {14700,2.5085714}, {14800,2.5193429}, {14900,2.5440286}, {15000,2.5758000}, {15100,2.5603429}, {15200,2.8562571}, {15300,2.7087714}, {15400,2.6476286}, {15500,2.6242857}, {15600,2.7228000}, {15700,2.7476286}, {15800,2.6788857}, {15900,2.7182000}, {16000,2.7116286}, {16100,2.7254000}, {16200,2.7341429}, {16300,2.8526000}, {16400,2.7440286}, {16500,2.8805429}, {16600,3.1068571}, {16700,2.8269429}, {16800,2.9436286}, {16900,2.8574571}, {17000,3.0229143}, {17100,2.9090286}, {17200,3.0222286}, {17300,2.9594000}, {17400,2.9451143}, {17500,3.1408286}, {17600,2.9629714}, {17700,3.0218857}, {17800,3.0961143}, {17900,3.1264571}, {18000,3.0687429}, {18100,3.0707429}, {18200,3.0907143}, {18300,3.1246000}, {18400,3.1238857}, {18500,3.2020857}, {18600,3.1566571}, {18700,3.1910286}, {18800,3.1883143}, {18900,3.2370000}, {19000,3.2289714}, {19100,3.2357429}, {19200,3.2697143}, {19300,3.3556286}, {19400,3.3664000}, {19500,3.3106000}, {19600,3.3281143}, {19700,3.5107143}, {19800,3.3637143}, {19900,3.5539429}, {20000,3.6181143}};
data["big_flat"]["LtacTCPrimPair"]["reif"]["system"] = {{1,0.00014851}, {2,0.00002970}, {3,0.00000000}, {4,0.00003960}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00003960}, {10,0.00003960}, {11,0.00003960}, {12,0.00000000}, {13,0.00000000}, {14,0.00010891}, {15,0.00000000}, {16,0.00003960}, {17,0.00002970}, {18,0.00000000}, {19,0.00003960}, {20,0.00000000}, {21,0.00000000}, {22,0.00003960}, {23,0.00000000}, {24,0.00006931}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00006931}, {30,0.00000000}, {31,0.00003960}, {32,0.00000000}, {33,0.00003960}, {34,0.00000000}, {35,0.00000000}, {36,0.00003960}, {37,0.00017822}, {38,0.00000000}, {39,0.00000000}, {40,0.00003960}, {41,0.00003960}, {42,0.00000000}, {43,0.00002970}, {44,0.00007921}, {45,0.00007921}, {46,0.00003960}, {47,0.00003960}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00002970}, {57,0.00007921}, {58,0.00007921}, {59,0.00006931}, {60,0.00000000}, {61,0.00000000}, {62,0.00003960}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00002970}, {68,0.00000000}, {69,0.00000000}, {70,0.00003960}, {71,0.00007921}, {72,0.00000000}, {73,0.00000000}, {74,0.00003960}, {75,0.00007921}, {76,0.00007921}, {77,0.00003960}, {78,0.00000000}, {79,0.00003960}, {80,0.00007921}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00006931}, {86,0.00000000}, {87,0.00000000}, {88,0.00015842}, {89,0.00000000}, {90,0.00003960}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00003960}, {95,0.00007921}, {96,0.00002970}, {97,0.00000000}, {98,0.00003960}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00007921}, {105,0.00003960}, {106,0.00000000}, {107,0.00007921}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00003960}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00002970}, {118,0.00019802}, {119,0.00003960}, {120,0.00003960}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00003960}, {126,0.00003960}, {127,0.00003960}, {128,0.00013861}, {129,0.00023762}, {130,0.00000000}, {131,0.00000000}, {132,0.00014851}, {133,0.00000000}, {134,0.00007921}, {135,0.00013861}, {136,0.00006931}, {137,0.00000000}, {138,0.00003960}, {139,0.00000000}, {140,0.00014851}, {141,0.00000000}, {142,0.00009901}, {143,0.00003960}, {144,0.00007921}, {145,0.00000000}, {146,0.00007921}, {147,0.00006931}, {148,0.00003960}, {149,0.00003960}, {150,0.00003960}, {151,0.00002970}, {152,0.00007921}, {153,0.00000000}, {154,0.00003960}, {155,0.00000000}, {156,0.00003960}, {157,0.00007921}, {158,0.00000000}, {159,0.00014851}, {160,0.00002970}, {161,0.00000000}, {162,0.00015842}, {163,0.00000000}, {164,0.00007921}, {165,0.00022772}, {166,0.00003960}, {167,0.00002970}, {168,0.00003960}, {169,0.00009901}, {170,0.00000000}, {171,0.00003960}, {172,0.00003960}, {173,0.00000000}, {174,0.00000000}, {175,0.00003960}, {176,0.00011881}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00011881}, {182,0.00007921}, {183,0.00000000}, {184,0.00002970}, {185,0.00003960}, {186,0.00003960}, {187,0.00003960}, {188,0.00003960}, {189,0.00017822}, {190,0.00007921}, {191,0.00000000}, {192,0.00000000}, {193,0.00003960}, {194,0.00000000}, {195,0.00000000}, {196,0.00003960}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00003960}, {203,0.00000000}, {204,0.00011881}, {205,0.00003960}, {206,0.00019802}, {207,0.00010891}, {208,0.00019802}, {209,0.00000000}, {210,0.00000000}, {211,0.00003960}, {212,0.00000000}, {213,0.00003960}, {214,0.00022772}, {215,0.00002970}, {216,0.00000000}, {217,0.00010891}, {218,0.00000000}, {219,0.00000000}, {220,0.00009901}, {221,0.00003960}, {222,0.00000000}, {223,0.00000000}, {224,0.00014851}, {225,0.00000000}, {226,0.00000000}, {227,0.00006931}, {228,0.00006931}, {229,0.00007921}, {230,0.00000000}, {231,0.00019802}, {232,0.00007921}, {233,0.00003960}, {234,0.00019802}, {235,0.00000000}, {236,0.00000000}, {237,0.00015842}, {238,0.00003960}, {239,0.00015842}, {240,0.00003960}, {241,0.00000000}, {242,0.00000000}, {243,0.00003960}, {244,0.00000000}, {245,0.00003960}, {246,0.00000000}, {247,0.00000000}, {248,0.00003960}, {249,0.00000000}, {250,0.00011881}, {251,0.00000000}, {252,0.00003960}, {253,0.00000000}, {254,0.00003960}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00006931}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00006931}, {266,0.00003960}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00003960}, {274,0.00000000}, {275,0.00002970}, {276,0.00003960}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003960}, {282,0.00000000}, {283,0.00003960}, {284,0.00003960}, {285,0.00000000}, {286,0.00000000}, {287,0.00006931}, {288,0.00000000}, {289,0.00007921}, {290,0.00003960}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00003960}, {295,0.00003960}, {296,0.00000000}, {297,0.00000000}, {298,0.00003960}, {299,0.00000000}, {300,0.00000000}, {301,0.00002970}, {302,0.00000000}, {303,0.00003960}, {304,0.00000000}, {305,0.00003960}, {306,0.00000000}, {307,0.00000000}, {308,0.00003960}, {309,0.00006931}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00003960}, {314,0.00000000}, {315,0.00003960}, {316,0.00000000}, {317,0.00003960}, {318,0.00003960}, {319,0.00003960}, {320,0.00003960}, {321,0.00006931}, {322,0.00007921}, {323,0.00000000}, {324,0.00003960}, {325,0.00003960}, {326,0.00000000}, {327,0.00003960}, {328,0.00003960}, {329,0.00000000}, {330,0.00000000}, {331,0.00003960}, {332,0.00000000}, {333,0.00007921}, {334,0.00000000}, {335,0.00003960}, {336,0.00002970}, {337,0.00003960}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00007921}, {343,0.00003960}, {344,0.00003960}, {345,0.00003960}, {346,0.00000000}, {347,0.00000000}, {348,0.00034653}, {349,0.00000000}, {350,0.00037624}, {351,0.00000000}, {352,0.00018812}, {353,0.00000000}, {354,0.00015842}, {355,0.00003960}, {356,0.00000000}, {357,0.00000000}, {358,0.00006931}, {359,0.00009901}, {360,0.00000000}, {361,0.00003960}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00003960}, {366,0.00000000}, {367,0.00035644}, {368,0.00000000}, {369,0.00000000}, {370,0.00019802}, {371,0.00000000}, {372,0.00007921}, {373,0.00002970}, {374,0.00000000}, {375,0.00000000}, {376,0.00003960}, {377,0.00000000}, {378,0.00007921}, {379,0.00000000}, {380,0.00003960}, {381,0.00002970}, {382,0.00003960}, {383,0.00007921}, {384,0.00000000}, {385,0.00003960}, {386,0.00003960}, {387,0.00000000}, {388,0.00011881}, {389,0.00000000}, {390,0.00003960}, {391,0.00000000}, {392,0.00003960}, {393,0.00000000}, {394,0.00003960}, {395,0.00003960}, {396,0.00000000}, {397,0.00003960}, {398,0.00000000}, {399,0.00003960}, {400,0.00003960}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00003960}, {405,0.00000000}, {406,0.00000000}, {407,0.00007921}, {408,0.00007921}, {409,0.00003960}, {410,0.00000000}, {411,0.00000000}, {412,0.00003960}, {413,0.00003960}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00003960}, {426,0.00000000}, {427,0.00003960}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00003960}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00003960}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00011881}, {444,0.00000000}, {445,0.00003960}, {446,0.00003960}, {447,0.00000000}, {448,0.00011881}, {449,0.00000000}, {450,0.00003960}, {451,0.00006931}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00003960}, {457,0.00003960}, {458,0.00003960}, {459,0.00003960}, {460,0.00000000}, {461,0.00003960}, {462,0.00000000}, {463,0.00002970}, {464,0.00000000}, {465,0.00003960}, {466,0.00000000}, {467,0.00000000}, {468,0.00003960}, {469,0.00003960}, {470,0.00003960}, {471,0.00003960}, {472,0.00011881}, {473,0.00000000}, {474,0.00007921}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00007921}, {479,0.00000000}, {480,0.00003960}, {481,0.00007921}, {482,0.00002970}, {483,0.00003960}, {484,0.00003960}, {485,0.00000000}, {486,0.00003960}, {487,0.00011881}, {488,0.00000000}, {489,0.00003960}, {490,0.00000000}, {491,0.00000000}, {492,0.00003960}, {493,0.00003960}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00003960}, {500,0.00006931}, {505,0.00003960}, {510,0.00015842}, {515,0.00000000}, {520,0.00002970}, {525,0.00000000}, {530,0.00003960}, {535,0.00003960}, {540,0.00003960}, {545,0.00000000}, {550,0.00007921}, {555,0.00000000}, {560,0.00003960}, {565,0.00007921}, {570,0.00003960}, {575,0.00011881}, {580,0.00003960}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00003960}, {620,0.00003960}, {625,0.00007921}, {630,0.00000000}, {635,0.00003960}, {640,0.00003960}, {645,0.00002970}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00003960}, {670,0.00000000}, {675,0.00000000}, {680,0.00007921}, {685,0.00000000}, {690,0.00003960}, {695,0.00003960}, {700,0.00003960}, {705,0.00000000}, {710,0.00003960}, {715,0.00003960}, {720,0.00000000}, {725,0.00003960}, {730,0.00007921}, {735,0.00003960}, {740,0.00003960}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00003960}, {775,0.00007921}, {780,0.00007921}, {785,0.00000000}, {790,0.00003960}, {795,0.00000000}, {800,0.00003960}, {805,0.00000000}, {810,0.00006931}, {815,0.00000000}, {820,0.00003960}, {825,0.00000000}, {830,0.00003960}, {835,0.00010891}, {840,0.00007921}, {845,0.00000000}, {850,0.00000000}, {855,0.00007921}, {860,0.00003960}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00007921}, {885,0.00007921}, {890,0.00003960}, {895,0.00000000}, {900,0.00003960}, {905,0.00003960}, {910,0.00006931}, {915,0.00000000}, {920,0.00000000}, {925,0.00003960}, {930,0.00007921}, {935,0.00000000}, {940,0.00000000}, {945,0.00003960}, {950,0.00000000}, {955,0.00007921}, {960,0.00003960}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00003960}, {985,0.00007921}, {990,0.00007921}, {995,0.00000000}, {1000,0.00007921}, {1010,0.00003960}, {1020,0.00000000}, {1030,0.00007921}, {1040,0.00003960}, {1050,0.00000000}, {1060,0.00002970}, {1070,0.00000000}, {1080,0.00007921}, {1090,0.00000000}, {1100,0.00007921}, {1110,0.00011881}, {1120,0.00007921}, {1130,0.00007921}, {1140,0.00003960}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00007921}, {1190,0.00002970}, {1200,0.00000000}, {1210,0.00006931}, {1220,0.00003960}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00003960}, {1270,0.00000000}, {1280,0.00003960}, {1290,0.00003960}, {1300,0.00007921}, {1310,0.00000000}, {1320,0.00007921}, {1330,0.00000000}, {1340,0.00007921}, {1350,0.00007921}, {1360,0.00003960}, {1370,0.00007921}, {1380,0.00000000}, {1390,0.00011881}, {1400,0.00007921}, {1410,0.00003960}, {1420,0.00011881}, {1430,0.00018812}, {1440,0.00011881}, {1450,0.00000000}, {1460,0.00007921}, {1470,0.00003960}, {1480,0.00003960}, {1490,0.00003960}, {1500,0.00003960}, {1510,0.00003960}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00003960}, {1560,0.00007921}, {1570,0.00000000}, {1580,0.00010891}, {1590,0.00011881}, {1600,0.00019802}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00002970}, {1650,0.00010891}, {1660,0.00003960}, {1670,0.00003960}, {1680,0.00003960}, {1690,0.00007921}, {1700,0.00007921}, {1710,0.00011881}, {1720,0.00007921}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00003960}, {1760,0.00007921}, {1770,0.00000000}, {1780,0.00027723}, {1790,0.00007921}, {1800,0.00003960}, {1810,0.00003960}, {1820,0.00007921}, {1830,0.00002970}, {1840,0.00000000}, {1850,0.00007921}, {1860,0.00011881}, {1870,0.00007921}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00003960}, {1920,0.00007921}, {1930,0.00003960}, {1940,0.00003960}, {1950,0.00003960}, {1960,0.00000000}, {1970,0.00007921}, {1980,0.00007921}, {1990,0.00000000}, {2000,0.00002970}, {2050,0.00015842}, {2100,0.00003960}, {2150,0.00000000}, {2200,0.00003960}, {2250,0.00000000}, {2300,0.00003960}, {2350,0.00003960}, {2400,0.00015842}, {2450,0.00015842}, {2500,0.00003960}, {2550,0.00003960}, {2600,0.00007921}, {2650,0.00003960}, {2700,0.00006931}, {2750,0.00003960}, {2800,0.00003960}, {2850,0.00310891}, {2900,0.00003960}, {2950,0.00000000}, {3000,0.00002970}, {3050,0.00010891}, {3100,0.00011881}, {3150,0.00022772}, {3200,0.00003960}, {3250,0.00000000}, {3300,0.00003960}, {3350,0.00003960}, {3400,0.00000000}, {3450,0.00003960}, {3500,0.00007921}, {3550,0.00011881}, {3600,0.00007921}, {3650,0.00003960}, {3700,0.00003960}, {3750,0.00007921}, {3800,0.00019802}, {3850,0.00011881}, {3900,0.00007921}, {3950,0.00011881}, {4000,0.00003960}, {4050,0.00015842}, {4100,0.00006931}, {4150,0.00007921}, {4200,0.00015842}, {4250,0.00003960}, {4300,0.00007921}, {4350,0.00003960}, {4400,0.00007921}, {4450,0.00000000}, {4500,0.00018812}, {4550,0.00007921}, {4600,0.00007921}, {4650,0.00011881}, {4700,0.00015842}, {4750,0.00006931}, {4800,0.00011881}, {4850,0.00031683}, {4900,0.00011881}, {4950,0.00000000}, {5000,0.00038614}, {5050,0.00035644}, {5100,0.00000000}, {5150,0.00011881}, {5200,0.00041584}, {5250,0.00070297}, {5300,0.00023762}, {5350,0.00015842}, {5400,0.00015842}, {5450,0.00007921}, {5500,0.00011881}, {5550,0.00003960}, {5600,0.00015842}, {5650,0.00007921}, {5700,0.00019802}, {5750,0.00007921}, {5800,0.00003960}, {5850,0.00031683}, {5900,0.00027723}, {5950,0.00015842}, {6000,0.00003960}, {6050,0.0067714}, {6100,0.0054571}, {6150,0.0001143}, {6200,0.0002000}, {6250,0.0000857}, {6300,0.0004286}, {6350,0.0001143}, {6400,0.0002286}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0003429}, {6750,0.0001143}, {6800,0.0000000}, {6850,0.0003429}, {6900,0.0001143}, {6950,0.0000857}, {7000,0.0001143}, {7050,0.0000000}, {7100,0.0001143}, {7150,0.0001143}, {7200,0.0001143}, {7250,0.0003429}, {7300,0.0000000}, {7350,0.0001143}, {7400,0.0001143}, {7450,0.0000857}, {7500,0.0000000}, {7550,0.0001143}, {7600,0.0001143}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0001143}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0001143}, {8000,0.0004571}, {8050,0.0004571}, {8100,0.0003429}, {8150,0.0000000}, {8200,0.0004571}, {8250,0.0006857}, {8300,0.0002286}, {8350,0.0001143}, {8400,0.0005714}, {8450,0.0004000}, {8500,0.0001143}, {8550,0.0001143}, {8600,0.0003429}, {8650,0.0002286}, {8700,0.0001143}, {8750,0.0001143}, {8800,0.0000000}, {8850,0.0002286}, {8900,0.0003429}, {8950,0.0002286}, {9000,0.0001143}, {9050,0.0002286}, {9100,0.0003143}, {9150,0.0004571}, {9200,0.0002286}, {9250,0.0001143}, {9300,0.0003429}, {9350,0.0001143}, {9400,0.0001143}, {9450,0.0002286}, {9500,0.0004571}, {9550,0.0002286}, {9600,0.0004571}, {9650,0.0002286}, {9700,0.0002286}, {9750,0.0003429}, {9800,0.0001143}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0001143}, {10000,0.0001143}, {10100,0.0003429}, {10200,0.0003429}, {10300,0.0002286}, {10400,0.0001143}, {10500,0.0000000}, {10600,0.0003429}, {10700,0.0001143}, {10800,0.0001143}, {10900,0.0002286}, {11000,0.0000000}, {11100,0.0005714}, {11200,0.0002286}, {11300,0.0000000}, {11400,0.0002286}, {11500,0.0001143}, {11600,0.0002286}, {11700,0.0006857}, {11800,0.0006857}, {11900,0.0011429}, {12000,0.0003429}, {12100,0.0002286}, {12200,0.0000000}, {12300,0.0002286}, {12400,0.0003429}, {12500,0.0002286}, {12600,0.0000000}, {12700,0.0002286}, {12800,0.0002286}, {12900,0.0004571}, {13000,0.0000857}, {13100,0.0002286}, {13200,0.0001143}, {13300,0.0006857}, {13400,0.0004286}, {13500,0.0003429}, {13600,0.0001143}, {13700,0.0002286}, {13800,0.0001143}, {13900,0.0000000}, {14000,0.0002286}, {14100,0.0002286}, {14200,0.0003429}, {14300,0.0002286}, {14400,0.0000000}, {14500,0.0001143}, {14600,0.0000000}, {14700,0.0002286}, {14800,0.0016857}, {14900,0.0012571}, {15000,0.0002000}, {15100,0.0003429}, {15200,0.0003429}, {15300,0.0000000}, {15400,0.0004571}, {15500,0.0009143}, {15600,0.0004571}, {15700,0.0008000}, {15800,0.0005714}, {15900,0.0003429}, {16000,0.0005714}, {16100,0.0003429}, {16200,0.0000000}, {16300,0.0003429}, {16400,0.0008857}, {16500,0.0006857}, {16600,0.0005714}, {16700,0.0013714}, {16800,0.0011429}, {16900,0.0001143}, {17000,0.0003429}, {17100,0.0005714}, {17200,0.0010286}, {17300,0.0003429}, {17400,0.0003429}, {17500,0.0001143}, {17600,0.0003429}, {17700,0.0005429}, {17800,0.0000000}, {17900,0.0004571}, {18000,0.0005714}, {18100,0.0005714}, {18200,0.0012286}, {18300,0.0002286}, {18400,0.0002286}, {18500,0.0012286}, {18600,0.0009143}, {18700,0.0014857}, {18800,0.0002286}, {18900,0.0001143}, {19000,0.0010857}, {19100,0.0001143}, {19200,0.0004571}, {19300,0.0004571}, {19400,0.0004571}, {19500,0.0012571}, {19600,0.0019143}, {19700,0.0008000}, {19800,0.0019143}, {19900,0.0012571}, {20000,0.0019429}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["Aggregate"]["real"] = {{1,0.00100000}, {2,0.00100990}, {3,0.00100000}, {4,0.00100000}, {5,0.00100000}, {6,0.00102970}, {7,0.00141584}, {8,0.00200000}, {9,0.00200000}, {10,0.00200000}, {11,0.00200000}, {12,0.00206931}, {13,0.00240594}, {14,0.00254455}, {15,0.00300000}, {16,0.00300000}, {17,0.00300000}, {18,0.00300990}, {19,0.00311881}, {20,0.00335644}, {21,0.00380198}, {22,0.00400000}, {23,0.00400000}, {24,0.00400000}, {25,0.00407921}, {26,0.00416832}, {27,0.00444554}, {28,0.00487129}, {29,0.00500000}, {30,0.00500000}, {31,0.00506931}, {32,0.00509901}, {33,0.00533663}, {34,0.00614851}, {35,0.00594059}, {36,0.00600000}, {37,0.00601980}, {38,0.00611881}, {39,0.00624752}, {40,0.00624752}, {41,0.00650495}, {42,0.00683168}, {43,0.00872277}, {44,0.00704950}, {45,0.00934653}, {46,0.00723762}, {47,0.00900000}, {48,0.00736634}, {49,0.00781188}, {50,0.00800990}, {51,0.00810891}, {52,0.00817822}, {53,0.00827723}, {54,0.00838614}, {55,0.00846535}, {56,0.00869307}, {57,0.00904950}, {58,0.00911881}, {59,0.01115842}, {60,0.00931683}, {61,0.00930693}, {62,0.01245545}, {63,0.00999010}, {64,0.01000990}, {65,0.01132673}, {66,0.01021782}, {67,0.01019802}, {68,0.01029703}, {69,0.01057426}, {70,0.01078218}, {71,0.01119802}, {72,0.01125743}, {73,0.01521782}, {74,0.01116832}, {75,0.01143564}, {76,0.01145545}, {77,0.01198020}, {78,0.01533663}, {79,0.01218812}, {80,0.01214851}, {81,0.01224752}, {82,0.01229703}, {83,0.01247525}, {84,0.01272277}, {85,0.01553465}, {86,0.01318812}, {87,0.01327723}, {88,0.01323762}, {89,0.01349505}, {90,0.01356436}, {91,0.01397030}, {92,0.01407921}, {93,0.01425743}, {94,0.01427723}, {95,0.01442574}, {96,0.01422772}, {97,0.01471287}, {98,0.01479208}, {99,0.01528713}, {100,0.01525743}, {101,0.01529703}, {102,0.01524752}, {103,0.01539604}, {104,0.01578218}, {105,0.02198020}, {106,0.01889109}, {107,0.01608911}, {108,0.01636634}, {109,0.01633663}, {110,0.01650495}, {111,0.01674257}, {112,0.01692079}, {113,0.02115842}, {114,0.01715842}, {115,0.01741584}, {116,0.01734653}, {117,0.01745545}, {118,0.02218812}, {119,0.01796040}, {120,0.01808911}, {121,0.01838614}, {122,0.02403960}, {123,0.01839604}, {124,0.01861386}, {125,0.01883168}, {126,0.02062376}, {127,0.01912871}, {128,0.01931683}, {129,0.02259406}, {130,0.01934653}, {131,0.01960396}, {132,0.02221782}, {133,0.01983168}, {134,0.02027723}, {135,0.02024752}, {136,0.02030693}, {137,0.02562376}, {138,0.02057426}, {139,0.02078218}, {140,0.02087129}, {141,0.02129703}, {142,0.02149505}, {143,0.02142574}, {144,0.02371287}, {145,0.02165347}, {146,0.02478218}, {147,0.02224752}, {148,0.02487129}, {149,0.02245545}, {150,0.02361386}, {151,0.02287129}, {152,0.02244554}, {153,0.02284158}, {154,0.02297030}, {155,0.03020792}, {156,0.02334653}, {157,0.02473267}, {158,0.02387129}, {159,0.02388119}, {160,0.02859406}, {161,0.02400990}, {162,0.02414851}, {163,0.03084158}, {164,0.02441584}, {165,0.02445545}, {166,0.03029703}, {167,0.02514851}, {168,0.02488119}, {169,0.02714851}, {170,0.02556436}, {171,0.02551485}, {172,0.02543564}, {173,0.02866337}, {174,0.02607921}, {175,0.02634653}, {176,0.02624752}, {177,0.02627723}, {178,0.03142574}, {179,0.02660396}, {180,0.02666337}, {181,0.02722772}, {182,0.02706931}, {183,0.02724752}, {184,0.03063366}, {185,0.03435644}, {186,0.02751485}, {187,0.02792079}, {188,0.02807921}, {189,0.02805941}, {190,0.02831683}, {191,0.02861386}, {192,0.02840594}, {193,0.02852475}, {194,0.02861386}, {195,0.02885149}, {196,0.02873267}, {197,0.02916832}, {198,0.02934653}, {199,0.02934653}, {200,0.02953465}, {201,0.02982178}, {202,0.02976238}, {203,0.03016832}, {204,0.03026733}, {205,0.03054455}, {206,0.03059406}, {207,0.03094059}, {208,0.03243564}, {209,0.04086139}, {210,0.03620792}, {211,0.03132673}, {212,0.03124752}, {213,0.03168317}, {214,0.03173267}, {215,0.03369307}, {216,0.03762376}, {217,0.03223762}, {218,0.03234653}, {219,0.03253465}, {220,0.04368317}, {221,0.03641584}, {222,0.03291089}, {223,0.03323762}, {224,0.04422772}, {225,0.03612871}, {226,0.03328713}, {227,0.03388119}, {228,0.03875248}, {229,0.03394059}, {230,0.03410891}, {231,0.04164356}, {232,0.03413861}, {233,0.03460396}, {234,0.04057426}, {235,0.03456436}, {236,0.03499010}, {237,0.03739604}, {238,0.03529703}, {239,0.04293069}, {240,0.03560396}, {241,0.03707921}, {242,0.03576238}, {243,0.03618812}, {244,0.03794059}, {245,0.03659406}, {246,0.03967327}, {247,0.03679208}, {248,0.04074257}, {249,0.03684158}, {250,0.04038614}, {251,0.03770297}, {252,0.03874257}, {253,0.03742574}, {254,0.03772277}, {255,0.04843564}, {256,0.03770297}, {257,0.04404950}, {258,0.03814851}, {259,0.03844554}, {260,0.05030693}, {261,0.03874257}, {262,0.04266337}, {263,0.03877228}, {264,0.03869307}, {265,0.04453465}, {266,0.03921782}, {267,0.03941584}, {268,0.04300990}, {269,0.05776238}, {270,0.04026733}, {271,0.04038614}, {272,0.05023762}, {273,0.04031683}, {274,0.04073267}, {275,0.04086139}, {276,0.04752475}, {277,0.05421782}, {278,0.04089109}, {279,0.04139604}, {280,0.04237624}, {281,0.04783168}, {282,0.05263366}, {283,0.04228713}, {284,0.04229703}, {285,0.04203960}, {286,0.04226733}, {287,0.04407921}, {288,0.04692079}, {289,0.04990099}, {290,0.05213861}, {291,0.05489109}, {292,0.04417822}, {293,0.04358416}, {294,0.04395050}, {295,0.04384158}, {296,0.04392079}, {297,0.04393069}, {298,0.04426733}, {299,0.04442574}, {300,0.04444554}, {301,0.04455446}, {302,0.04506931}, {303,0.04510891}, {304,0.04502970}, {305,0.06367327}, {306,0.05720792}, {307,0.05496040}, {308,0.05267327}, {309,0.04989109}, {310,0.04685149}, {311,0.04621782}, {312,0.04613861}, {313,0.04637624}, {314,0.05951485}, {315,0.05593069}, {316,0.05074257}, {317,0.04712871}, {318,0.04737624}, {319,0.04949505}, {320,0.05649505}, {321,0.05078218}, {322,0.04719802}, {323,0.04815842}, {324,0.05885149}, {325,0.05297030}, {326,0.04796040}, {327,0.04843564}, {328,0.05738614}, {329,0.05045545}, {330,0.04879208}, {331,0.06563366}, {332,0.05327723}, {333,0.04923762}, {334,0.06140594}, {335,0.05157426}, {336,0.04957426}, {337,0.05938614}, {338,0.04965347}, {339,0.06519802}, {340,0.05405941}, {341,0.05066337}, {342,0.05854455}, {343,0.05069307}, {344,0.06107921}, {345,0.05077228}, {346,0.06446535}, {347,0.05256436}, {348,0.06497030}, {349,0.05292079}, {350,0.06447525}, {351,0.05206931}, {352,0.06365347}, {353,0.05175248}, {354,0.05918812}, {355,0.05270297}, {356,0.06098020}, {357,0.05252475}, {358,0.05770297}, {359,0.06853465}, {360,0.05296040}, {361,0.06204950}, {362,0.05364356}, {363,0.05521782}, {364,0.06555446}, {365,0.05410891}, {366,0.05621782}, {367,0.06544554}, {368,0.05417822}, {369,0.05571287}, {370,0.06143564}, {371,0.07031683}, {372,0.05511881}, {373,0.05874257}, {374,0.06507921}, {375,0.05746535}, {376,0.05538614}, {377,0.05830693}, {378,0.06359406}, {379,0.07010891}, {380,0.05648515}, {381,0.05626733}, {382,0.05816832}, {383,0.06243564}, {384,0.06663366}, {385,0.07237624}, {386,0.05665347}, {387,0.05678218}, {388,0.05715842}, {389,0.05880198}, {390,0.06201980}, {391,0.06467327}, {392,0.06627723}, {393,0.06861386}, {394,0.07034653}, {395,0.06980198}, {396,0.07287129}, {397,0.07398020}, {398,0.07447525}, {399,0.08316832}, {400,0.08027723}, {401,0.07772277}, {402,0.07786139}, {403,0.07622772}, {404,0.07475248}, {405,0.07454455}, {406,0.07241584}, {407,0.07054455}, {408,0.06718812}, {409,0.06571287}, {410,0.06304950}, {411,0.06191089}, {412,0.06076238}, {413,0.06135644}, {414,0.07651485}, {415,0.07593069}, {416,0.07254455}, {417,0.06624752}, {418,0.06137624}, {419,0.06212871}, {420,0.07971287}, {421,0.07409901}, {422,0.06643564}, {423,0.06267327}, {424,0.06442574}, {425,0.07517822}, {426,0.06837624}, {427,0.06299010}, {428,0.08001980}, {429,0.07295050}, {430,0.06546535}, {431,0.06431683}, {432,0.07430693}, {433,0.06833663}, {434,0.06400990}, {435,0.07881188}, {436,0.06675248}, {437,0.06717822}, {438,0.07493069}, {439,0.06546535}, {440,0.08005941}, {441,0.06917822}, {442,0.06734653}, {443,0.07279208}, {444,0.06554455}, {445,0.07581188}, {446,0.06612871}, {447,0.07762376}, {448,0.06562376}, {449,0.08288119}, {450,0.06787129}, {451,0.08600990}, {452,0.06787129}, {453,0.08207921}, {454,0.06707921}, {455,0.08000990}, {456,0.06695050}, {457,0.07693069}, {458,0.06956436}, {459,0.07251485}, {460,0.08257426}, {461,0.06806931}, {462,0.07743564}, {463,0.08698020}, {464,0.07079208}, {465,0.08046535}, {466,0.06849505}, {467,0.07500990}, {468,0.08360396}, {469,0.06928713}, {470,0.07253465}, {471,0.07879208}, {472,0.08843564}, {473,0.07009901}, {474,0.07571287}, {475,0.08288119}, {476,0.08877228}, {477,0.07093069}, {478,0.07511881}, {479,0.08103960}, {480,0.08931683}, {481,0.07319802}, {482,0.07214851}, {483,0.07658416}, {484,0.08161386}, {485,0.08261386}, {486,0.08960396}, {487,0.09268317}, {488,0.07196040}, {489,0.07354455}, {490,0.07599010}, {491,0.07920792}, {492,0.08136634}, {493,0.08562376}, {494,0.08895050}, {495,0.08813861}, {496,0.08950495}, {497,0.08772277}, {498,0.09100000}, {499,0.09168317}, {500,0.09151485}, {505,0.09084158}, {510,0.08912871}, {515,0.08616832}, {520,0.08290099}, {525,0.07855446}, {530,0.10541584}, {535,0.09139604}, {540,0.08084158}, {545,0.09757426}, {550,0.08530693}, {555,0.09791089}, {560,0.08428713}, {565,0.09422772}, {570,0.10280198}, {575,0.08706931}, {580,0.09485149}, {585,0.10039604}, {590,0.10290099}, {595,0.10526733}, {600,0.10530693}, {605,0.10499010}, {610,0.10382178}, {615,0.10200990}, {620,0.10165347}, {625,0.09534653}, {630,0.11501980}, {635,0.10601980}, {640,0.09778218}, {645,0.11208911}, {650,0.10155446}, {655,0.11376238}, {660,0.10094059}, {665,0.11309901}, {670,0.12326733}, {675,0.10493069}, {680,0.11006931}, {685,0.11483168}, {690,0.11824752}, {695,0.12168317}, {700,0.12726733}, {705,0.12628713}, {710,0.12464356}, {715,0.12136634}, {720,0.11781188}, {725,0.11445545}, {730,0.14595050}, {735,0.12841584}, {740,0.11751485}, {745,0.13357426}, {750,0.12175248}, {755,0.13396040}, {760,0.12576238}, {765,0.13416832}, {770,0.14227723}, {775,0.12394059}, {780,0.13042574}, {785,0.13539604}, {790,0.14614851}, {795,0.14778218}, {800,0.14853465}, {805,0.14678218}, {810,0.14554455}, {815,0.15777228}, {820,0.14454455}, {825,0.13945545}, {830,0.13253465}, {835,0.14873267}, {840,0.15103960}, {845,0.16239604}, {850,0.14938614}, {855,0.15909901}, {860,0.14656436}, {865,0.17090099}, {870,0.14500990}, {875,0.15209901}, {880,0.15643564}, {885,0.16163366}, {890,0.14627723}, {895,0.14585149}, {900,0.14639604}, {905,0.14684158}, {910,0.14590099}, {915,0.17313861}, {920,0.16731683}, {925,0.16172277}, {930,0.15616832}, {935,0.15800990}, {940,0.17136634}, {945,0.16024752}, {950,0.17147525}, {955,0.16058416}, {960,0.17756436}, {965,0.16060396}, {970,0.16787129}, {975,0.17579208}, {980,0.16322772}, {985,0.16807921}, {990,0.16910891}, {995,0.17278218}, {1000,0.17983168}, {1010,0.17835644}, {1020,0.17309901}, {1030,0.16657426}, {1040,0.19438614}, {1050,0.18129703}, {1060,0.19178218}, {1070,0.19467327}, {1080,0.19129703}, {1090,0.19370297}, {1100,0.19508911}, {1110,0.20596040}, {1120,0.19908911}, {1130,0.19467327}, {1140,0.19448515}, {1150,0.20833663}, {1160,0.19392079}, {1170,0.22095050}, {1180,0.21715842}, {1190,0.21787129}, {1200,0.20547525}, {1210,0.20542574}, {1220,0.22232673}, {1230,0.22659406}, {1240,0.21670297}, {1250,0.22859406}, {1260,0.22373267}, {1270,0.22951485}, {1280,0.21121782}, {1290,0.22521782}, {1300,0.22364356}, {1310,0.24444554}, {1320,0.22758416}, {1330,0.22278218}, {1340,0.24950495}, {1350,0.23312871}, {1360,0.24300000}, {1370,0.23924752}, {1380,0.24003960}, {1390,0.26866337}, {1400,0.25371287}, {1410,0.24933663}, {1420,0.26141584}, {1430,0.24765347}, {1440,0.25626733}, {1450,0.26203960}, {1460,0.24864356}, {1470,0.26668317}, {1480,0.26576238}, {1490,0.25823762}, {1500,0.25451485}, {1510,0.27400000}, {1520,0.26065347}, {1530,0.27297030}, {1540,0.26947525}, {1550,0.26266337}, {1560,0.28747525}, {1570,0.26467327}, {1580,0.28495050}, {1590,0.28007921}, {1600,0.29510891}, {1610,0.28658416}, {1620,0.29778218}, {1630,0.28428713}, {1640,0.28935644}, {1650,0.29608911}, {1660,0.30265347}, {1670,0.29637624}, {1680,0.30290099}, {1690,0.29194059}, {1700,0.31720792}, {1710,0.29792079}, {1720,0.31200990}, {1730,0.29613861}, {1740,0.32351485}, {1750,0.30458416}, {1760,0.30668317}, {1770,0.30780198}, {1780,0.32183168}, {1790,0.33397030}, {1800,0.30778218}, {1810,0.32313861}, {1820,0.31323762}, {1830,0.35581188}, {1840,0.32176238}, {1850,0.32639604}, {1860,0.33014851}, {1870,0.32570297}, {1880,0.31965347}, {1890,0.33748515}, {1900,0.35631683}, {1910,0.34102970}, {1920,0.35195050}, {1930,0.33847525}, {1940,0.33694059}, {1950,0.36813861}, {1960,0.34176238}, {1970,0.35882178}, {1980,0.34691089}, {1990,0.34604950}, {2000,0.35983168}, {2050,0.34990099}, {2100,0.37158416}, {2150,0.38741584}, {2200,0.38066337}, {2250,0.41186139}, {2300,0.43002970}, {2350,0.40789109}, {2400,0.42856436}, {2450,0.43688119}, {2500,0.44897030}, {2550,0.45945545}, {2600,0.49206931}, {2650,0.45649505}, {2700,0.47277228}, {2750,0.49968317}, {2800,0.49559406}, {2850,0.52568317}, {2900,0.53630693}, {2950,0.53038614}, {3000,0.54471287}, {3050,0.54659406}, {3100,0.55997030}, {3150,0.55616832}, {3200,0.56934653}, {3250,0.58545545}, {3300,0.59922772}, {3350,0.60548515}, {3400,0.62104950}, {3450,0.62720792}, {3500,0.63218812}, {3550,0.65668317}, {3600,0.65209901}, {3650,0.66853465}, {3700,0.65762376}, {3750,0.68293069}, {3800,0.69881188}, {3850,0.72785149}, {3900,0.71798020}, {3950,0.72628713}, {4000,0.71909901}, {4050,0.74856436}, {4100,0.77162376}, {4150,0.75853465}, {4200,0.76962376}, {4250,0.79717822}, {4300,0.79901980}, {4350,0.79594059}, {4400,0.81442574}, {4450,0.82362376}, {4500,0.82638614}, {4550,0.85389109}, {4600,0.84537624}, {4650,0.85415842}, {4700,0.87754455}, {4750,0.86412871}, {4800,0.90815842}, {4850,0.88857426}, {4900,1.00969307}, {4950,0.90949505}, {5000,0.94741584}, {5050,0.93134653}, {5100,0.96261386}, {5150,0.93553465}, {5200,0.97341584}, {5250,0.98300990}, {5300,0.98271287}, {5350,1.00406931}, {5400,1.00127723}, {5450,1.01145545}, {5500,1.03182178}, {5550,1.01570297}, {5600,1.03589109}, {5650,1.05171287}, {5700,1.04949505}, {5750,1.06330693}, {5800,1.07254455}, {5850,1.09435644}, {5900,1.10512871}, {5950,1.11196040}, {6000,1.12330693}, {6050,1.1814000}, {6100,3.7283714}, {6150,1.2081143}, {6200,1.2541714}, {6250,1.2339143}, {6300,1.2077714}, {6350,1.2164857}, {6400,1.2067143}, {6450,1.2236571}, {6500,1.2332000}, {6550,1.2521429}, {6600,1.2570857}, {6650,1.2876286}, {6700,1.2864000}, {6750,1.2976571}, {6800,1.3079143}, {6850,1.3127714}, {6900,1.3348571}, {6950,1.3343143}, {7000,1.3483714}, {7050,1.3494571}, {7100,1.3785429}, {7150,1.4012857}, {7200,1.4040000}, {7250,1.4468571}, {7300,1.4612571}, {7350,1.4565143}, {7400,1.4721714}, {7450,1.4675143}, {7500,1.4608857}, {7550,1.4764857}, {7600,1.4633143}, {7650,1.5018000}, {7700,1.5448857}, {7750,1.5380857}, {7800,1.5589143}, {7850,1.5326000}, {7900,1.5364000}, {7950,1.5892000}, {8000,1.6150286}, {8050,1.5915429}, {8100,1.6073714}, {8150,1.5843714}, {8200,1.5712571}, {8250,1.6491429}, {8300,1.6230286}, {8350,1.6404857}, {8400,1.6218000}, {8450,1.6844571}, {8500,1.6785429}, {8550,1.6816286}, {8600,1.6611429}, {8650,1.7577714}, {8700,1.7250857}, {8750,1.7468286}, {8800,1.7354000}, {8850,1.7394857}, {8900,1.7331714}, {8950,1.8033143}, {9000,1.7710857}, {9050,1.7688571}, {9100,1.8235429}, {9150,1.8272286}, {9200,1.8258286}, {9250,1.8436857}, {9300,1.8254571}, {9350,1.8784000}, {9400,1.8828286}, {9450,1.9071429}, {9500,1.9051429}, {9550,1.8924286}, {9600,1.8969429}, {9650,1.9185429}, {9700,1.9674857}, {9750,1.9346000}, {9800,1.9723714}, {9850,1.9761714}, {9900,2.0052571}, {9950,1.9930571}, {10000,2.0175429}, {10100,1.9900000}, {10200,2.0891429}, {10300,2.0272571}, {10400,2.0588857}, {10500,2.0498857}, {10600,2.1095429}, {10700,2.1405429}, {10800,2.1182000}, {10900,2.1408000}, {11000,2.1984000}, {11100,2.2051714}, {11200,2.2005143}, {11300,2.2148286}, {11400,2.2784286}, {11500,2.2757429}, {11600,2.3189143}, {11700,2.3058286}, {11800,2.3380857}, {11900,2.3954857}, {12000,2.3579429}, {12100,2.4561429}, {12200,2.4375143}, {12300,2.4075429}, {12400,2.4158000}, {12500,2.4672286}, {12600,2.5076857}, {12700,2.6005429}, {12800,2.5077429}, {12900,2.5489429}, {13000,2.5867714}, {13100,2.6169714}, {13200,2.5794857}, {13300,2.6477714}, {13400,2.6143429}, {13500,2.6847143}, {13600,2.6758571}, {13700,2.7315429}, {13800,2.7516286}, {13900,2.7602286}, {14000,2.8072571}, {14100,2.8172857}, {14200,2.8512286}, {14300,2.8909143}, {14400,3.0539714}, {14500,2.9164286}, {14600,2.8966286}, {14700,3.1882286}, {14800,3.0303429}, {14900,3.0234286}, {15000,2.9708286}, {15100,3.0208000}, {15200,3.0611714}, {15300,3.1057714}, {15400,3.0831429}, {15500,3.1925714}, {15600,3.0629714}, {15700,3.2024000}, {15800,3.2599143}, {15900,3.2836571}, {16000,3.2494571}, {16100,3.1806571}, {16200,3.4941143}, {16300,3.2446571}, {16400,3.2048857}, {16500,3.2924857}, {16600,3.3215714}, {16700,3.4012571}, {16800,3.2836571}, {16900,3.4305429}, {17000,3.3574571}, {17100,3.3447714}, {17200,3.6686857}, {17300,3.4250286}, {17400,3.5169429}, {17500,3.5378857}, {17600,3.5292286}, {17700,3.5574000}, {17800,3.5870286}, {17900,3.5444286}, {18000,3.6497429}, {18100,3.5953143}, {18200,3.6660286}, {18300,3.7071143}, {18400,3.6234000}, {18500,3.6538857}, {18600,3.8535143}, {18700,3.7137429}, {18800,3.7892286}, {18900,3.8083714}, {19000,3.7442571}, {19100,3.9902286}, {19200,3.9528857}, {19300,3.8780571}, {19400,3.8698571}, {19500,3.9254286}, {19600,4.0893429}, {19700,4.0430286}, {19800,4.0577429}, {19900,4.1146000}, {20000,4.0516286}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["Aggregate"]["user"] = {{1,0.00112871}, {2,0.00116832}, {3,0.00112871}, {4,0.00132673}, {5,0.00164356}, {6,0.00177228}, {7,0.00139604}, {8,0.00220792}, {9,0.00214851}, {10,0.00225743}, {11,0.00243564}, {12,0.00229703}, {13,0.00265347}, {14,0.00279208}, {15,0.00249505}, {16,0.00300000}, {17,0.00293069}, {18,0.00308911}, {19,0.00343564}, {20,0.00334653}, {21,0.00349505}, {22,0.00369307}, {23,0.00383168}, {24,0.00409901}, {25,0.00462376}, {26,0.00446535}, {27,0.00443564}, {28,0.00513861}, {29,0.00465347}, {30,0.00525743}, {31,0.00552475}, {32,0.00489109}, {33,0.00554455}, {34,0.00660396}, {35,0.00588119}, {36,0.00626733}, {37,0.00629703}, {38,0.00649505}, {39,0.00636634}, {40,0.00687129}, {41,0.00732673}, {42,0.00692079}, {43,0.00930693}, {44,0.00735644}, {45,0.00965347}, {46,0.00763366}, {47,0.00901980}, {48,0.00783168}, {49,0.00800000}, {50,0.00812871}, {51,0.00843564}, {52,0.00853465}, {53,0.00868317}, {54,0.00886139}, {55,0.00888119}, {56,0.00871287}, {57,0.00934653}, {58,0.00891089}, {59,0.01118812}, {60,0.00945545}, {61,0.00982178}, {62,0.01269307}, {63,0.01008911}, {64,0.01020792}, {65,0.01149505}, {66,0.01009901}, {67,0.01017822}, {68,0.01081188}, {69,0.01070297}, {70,0.01097030}, {71,0.01125743}, {72,0.01102970}, {73,0.01549505}, {74,0.01144554}, {75,0.01181188}, {76,0.01187129}, {77,0.01207921}, {78,0.01544554}, {79,0.01240594}, {80,0.01224752}, {81,0.01251485}, {82,0.01258416}, {83,0.01288119}, {84,0.01291089}, {85,0.01609901}, {86,0.01332673}, {87,0.01372277}, {88,0.01361386}, {89,0.01386139}, {90,0.01380198}, {91,0.01387129}, {92,0.01371287}, {93,0.01448515}, {94,0.01470297}, {95,0.01475248}, {96,0.01473267}, {97,0.01507921}, {98,0.01541584}, {99,0.01559406}, {100,0.01557426}, {101,0.01594059}, {102,0.01570297}, {103,0.01572277}, {104,0.01608911}, {105,0.02153465}, {106,0.01883168}, {107,0.01617822}, {108,0.01669307}, {109,0.01662376}, {110,0.01674257}, {111,0.01699010}, {112,0.01699010}, {113,0.02072277}, {114,0.01690099}, {115,0.01761386}, {116,0.01745545}, {117,0.01791089}, {118,0.02211881}, {119,0.01785149}, {120,0.01803960}, {121,0.01838614}, {122,0.02352475}, {123,0.01840594}, {124,0.01833663}, {125,0.01850495}, {126,0.02024752}, {127,0.01879208}, {128,0.01902970}, {129,0.02260396}, {130,0.01921782}, {131,0.01941584}, {132,0.02182178}, {133,0.01968317}, {134,0.02019802}, {135,0.01997030}, {136,0.01981188}, {137,0.02525743}, {138,0.02050495}, {139,0.02029703}, {140,0.02043564}, {141,0.02107921}, {142,0.02092079}, {143,0.02121782}, {144,0.02353465}, {145,0.02152475}, {146,0.02470297}, {147,0.02216832}, {148,0.02480198}, {149,0.02243564}, {150,0.02358416}, {151,0.02263366}, {152,0.02212871}, {153,0.02296040}, {154,0.02277228}, {155,0.03017822}, {156,0.02341584}, {157,0.02483168}, {158,0.02369307}, {159,0.02381188}, {160,0.02834653}, {161,0.02379208}, {162,0.02400990}, {163,0.03120792}, {164,0.02463366}, {165,0.02459406}, {166,0.03039604}, {167,0.02508911}, {168,0.02464356}, {169,0.02683168}, {170,0.02518812}, {171,0.02589109}, {172,0.02521782}, {173,0.02857426}, {174,0.02587129}, {175,0.02636634}, {176,0.02600990}, {177,0.02624752}, {178,0.03159406}, {179,0.02667327}, {180,0.02620792}, {181,0.02715842}, {182,0.02695050}, {183,0.02700000}, {184,0.03081188}, {185,0.03431683}, {186,0.02729703}, {187,0.02780198}, {188,0.02784158}, {189,0.02818812}, {190,0.02813861}, {191,0.02882178}, {192,0.02818812}, {193,0.02875248}, {194,0.02858416}, {195,0.02937624}, {196,0.02833663}, {197,0.02899010}, {198,0.02924752}, {199,0.02931683}, {200,0.02971287}, {201,0.02986139}, {202,0.02977228}, {203,0.03062376}, {204,0.03026733}, {205,0.03029703}, {206,0.03100000}, {207,0.03151485}, {208,0.03260396}, {209,0.04063366}, {210,0.03623762}, {211,0.03164356}, {212,0.03162376}, {213,0.03200990}, {214,0.03195050}, {215,0.03366337}, {216,0.03762376}, {217,0.03247525}, {218,0.03274257}, {219,0.03283168}, {220,0.04341584}, {221,0.03617822}, {222,0.03339604}, {223,0.03342574}, {224,0.04407921}, {225,0.03582178}, {226,0.03340594}, {227,0.03398020}, {228,0.03838614}, {229,0.03399010}, {230,0.03390099}, {231,0.04123762}, {232,0.03436634}, {233,0.03444554}, {234,0.04042574}, {235,0.03464356}, {236,0.03499010}, {237,0.03749505}, {238,0.03507921}, {239,0.04215842}, {240,0.03567327}, {241,0.03691089}, {242,0.03608911}, {243,0.03619802}, {244,0.03762376}, {245,0.03665347}, {246,0.03935644}, {247,0.03709901}, {248,0.04028713}, {249,0.03698020}, {250,0.04018812}, {251,0.03744554}, {252,0.03876238}, {253,0.03733663}, {254,0.03760396}, {255,0.04851485}, {256,0.03720792}, {257,0.04395050}, {258,0.03793069}, {259,0.03835644}, {260,0.04994059}, {261,0.03824752}, {262,0.04249505}, {263,0.03856436}, {264,0.03855446}, {265,0.04444554}, {266,0.03872277}, {267,0.03904950}, {268,0.04268317}, {269,0.05712871}, {270,0.03982178}, {271,0.04001980}, {272,0.04986139}, {273,0.04007921}, {274,0.04051485}, {275,0.04094059}, {276,0.04750495}, {277,0.05382178}, {278,0.04046535}, {279,0.04159406}, {280,0.04236634}, {281,0.04781188}, {282,0.05205941}, {283,0.04194059}, {284,0.04219802}, {285,0.04166337}, {286,0.04192079}, {287,0.04401980}, {288,0.04675248}, {289,0.04972277}, {290,0.05163366}, {291,0.05421782}, {292,0.04403960}, {293,0.04336634}, {294,0.04374257}, {295,0.04389109}, {296,0.04344554}, {297,0.04373267}, {298,0.04398020}, {299,0.04400000}, {300,0.04457426}, {301,0.04458416}, {302,0.04511881}, {303,0.04493069}, {304,0.04462376}, {305,0.06394059}, {306,0.05690099}, {307,0.05448515}, {308,0.05211881}, {309,0.04975248}, {310,0.04699010}, {311,0.04595050}, {312,0.04611881}, {313,0.04647525}, {314,0.05988119}, {315,0.05599010}, {316,0.05029703}, {317,0.04733663}, {318,0.04740594}, {319,0.04942574}, {320,0.05619802}, {321,0.05048515}, {322,0.04706931}, {323,0.04822772}, {324,0.05885149}, {325,0.05282178}, {326,0.04805941}, {327,0.04854455}, {328,0.05734653}, {329,0.04991089}, {330,0.04845545}, {331,0.06587129}, {332,0.05298020}, {333,0.04900000}, {334,0.06145545}, {335,0.05102970}, {336,0.04934653}, {337,0.05927723}, {338,0.04943564}, {339,0.06513861}, {340,0.05320792}, {341,0.05035644}, {342,0.05884158}, {343,0.05044554}, {344,0.06133663}, {345,0.05047525}, {346,0.06430693}, {347,0.05209901}, {348,0.06461386}, {349,0.05248515}, {350,0.06365347}, {351,0.05170297}, {352,0.06305941}, {353,0.05164356}, {354,0.05939604}, {355,0.05262376}, {356,0.06097030}, {357,0.05229703}, {358,0.05747525}, {359,0.06819802}, {360,0.05270297}, {361,0.06200990}, {362,0.05320792}, {363,0.05497030}, {364,0.06513861}, {365,0.05389109}, {366,0.05618812}, {367,0.06537624}, {368,0.05369307}, {369,0.05502970}, {370,0.06116832}, {371,0.07032673}, {372,0.05526733}, {373,0.05867327}, {374,0.06464356}, {375,0.05720792}, {376,0.05484158}, {377,0.05816832}, {378,0.06348515}, {379,0.06973267}, {380,0.05617822}, {381,0.05602970}, {382,0.05806931}, {383,0.06233663}, {384,0.06632673}, {385,0.07245545}, {386,0.05631683}, {387,0.05630693}, {388,0.05673267}, {389,0.05872277}, {390,0.06190099}, {391,0.06449505}, {392,0.06621782}, {393,0.06831683}, {394,0.07046535}, {395,0.06996040}, {396,0.07307921}, {397,0.07379208}, {398,0.07432673}, {399,0.08315842}, {400,0.07998020}, {401,0.07749505}, {402,0.07761386}, {403,0.07613861}, {404,0.07444554}, {405,0.07420792}, {406,0.07216832}, {407,0.07038614}, {408,0.06681188}, {409,0.06514851}, {410,0.06298020}, {411,0.06192079}, {412,0.06083168}, {413,0.06132673}, {414,0.07599010}, {415,0.07567327}, {416,0.07250495}, {417,0.06590099}, {418,0.06141584}, {419,0.06235644}, {420,0.07953465}, {421,0.07398020}, {422,0.06577228}, {423,0.06253465}, {424,0.06400000}, {425,0.07504950}, {426,0.06827723}, {427,0.06296040}, {428,0.07979208}, {429,0.07282178}, {430,0.06551485}, {431,0.06414851}, {432,0.07412871}, {433,0.06822772}, {434,0.06379208}, {435,0.07838614}, {436,0.06679208}, {437,0.06697030}, {438,0.07465347}, {439,0.06522772}, {440,0.08000000}, {441,0.06918812}, {442,0.06691089}, {443,0.07255446}, {444,0.06534653}, {445,0.07556436}, {446,0.06581188}, {447,0.07751485}, {448,0.06523762}, {449,0.08245545}, {450,0.06745545}, {451,0.08563366}, {452,0.06725743}, {453,0.08153465}, {454,0.06693069}, {455,0.07948515}, {456,0.06667327}, {457,0.07664356}, {458,0.06929703}, {459,0.07263366}, {460,0.08225743}, {461,0.06786139}, {462,0.07704950}, {463,0.08685149}, {464,0.07085149}, {465,0.07998020}, {466,0.06826733}, {467,0.07463366}, {468,0.08373267}, {469,0.06906931}, {470,0.07221782}, {471,0.07856436}, {472,0.08819802}, {473,0.07010891}, {474,0.07545545}, {475,0.08289109}, {476,0.08858416}, {477,0.07118812}, {478,0.07500990}, {479,0.08076238}, {480,0.08921782}, {481,0.07322772}, {482,0.07208911}, {483,0.07631683}, {484,0.08114851}, {485,0.08237624}, {486,0.08951485}, {487,0.09277228}, {488,0.07206931}, {489,0.07337624}, {490,0.07572277}, {491,0.07866337}, {492,0.08144554}, {493,0.08529703}, {494,0.08899010}, {495,0.08817822}, {496,0.08924752}, {497,0.08751485}, {498,0.09052475}, {499,0.09167327}, {500,0.09098020}, {505,0.09037624}, {510,0.08900000}, {515,0.08583168}, {520,0.08276238}, {525,0.07807921}, {530,0.10500990}, {535,0.09107921}, {540,0.08049505}, {545,0.09735644}, {550,0.08500000}, {555,0.09785149}, {560,0.08424752}, {565,0.09430693}, {570,0.10266337}, {575,0.08702970}, {580,0.09484158}, {585,0.10014851}, {590,0.10279208}, {595,0.10492079}, {600,0.10533663}, {605,0.10511881}, {610,0.10338614}, {615,0.10171287}, {620,0.10113861}, {625,0.09536634}, {630,0.11485149}, {635,0.10603960}, {640,0.09782178}, {645,0.11183168}, {650,0.10086139}, {655,0.11352475}, {660,0.10074257}, {665,0.11280198}, {670,0.12272277}, {675,0.10482178}, {680,0.10996040}, {685,0.11469307}, {690,0.11801980}, {695,0.12139604}, {700,0.12700000}, {705,0.12593069}, {710,0.12438614}, {715,0.12120792}, {720,0.11732673}, {725,0.11404950}, {730,0.14534653}, {735,0.12812871}, {740,0.11704950}, {745,0.13312871}, {750,0.12154455}, {755,0.13333663}, {760,0.12555446}, {765,0.13369307}, {770,0.14228713}, {775,0.12366337}, {780,0.12997030}, {785,0.13487129}, {790,0.14570297}, {795,0.14742574}, {800,0.14840594}, {805,0.14640594}, {810,0.14546535}, {815,0.15728713}, {820,0.14428713}, {825,0.13896040}, {830,0.13231683}, {835,0.14858416}, {840,0.15083168}, {845,0.16177228}, {850,0.14927723}, {855,0.15888119}, {860,0.14641584}, {865,0.17040594}, {870,0.14474257}, {875,0.15191089}, {880,0.15600990}, {885,0.16138614}, {890,0.14586139}, {895,0.14568317}, {900,0.14573267}, {905,0.14646535}, {910,0.14593069}, {915,0.17295050}, {920,0.16702970}, {925,0.16134653}, {930,0.15593069}, {935,0.15765347}, {940,0.17106931}, {945,0.16004950}, {950,0.17152475}, {955,0.16032673}, {960,0.17717822}, {965,0.16040594}, {970,0.16773267}, {975,0.17526733}, {980,0.16289109}, {985,0.16775248}, {990,0.16882178}, {995,0.17244554}, {1000,0.17924752}, {1010,0.17770297}, {1020,0.17256436}, {1030,0.16624752}, {1040,0.19354455}, {1050,0.18067327}, {1060,0.19120792}, {1070,0.19435644}, {1080,0.19082178}, {1090,0.19317822}, {1100,0.19439604}, {1110,0.20536634}, {1120,0.19846535}, {1130,0.19421782}, {1140,0.19387129}, {1150,0.20795050}, {1160,0.19332673}, {1170,0.22038614}, {1180,0.21667327}, {1190,0.21732673}, {1200,0.20487129}, {1210,0.20466337}, {1220,0.22187129}, {1230,0.22596040}, {1240,0.21600000}, {1250,0.22768317}, {1260,0.22284158}, {1270,0.22865347}, {1280,0.21095050}, {1290,0.22431683}, {1300,0.22313861}, {1310,0.24381188}, {1320,0.22699010}, {1330,0.22196040}, {1340,0.24897030}, {1350,0.23230693}, {1360,0.24208911}, {1370,0.23822772}, {1380,0.23933663}, {1390,0.26837624}, {1400,0.25309901}, {1410,0.24849505}, {1420,0.26082178}, {1430,0.24706931}, {1440,0.25552475}, {1450,0.26168317}, {1460,0.24813861}, {1470,0.26604950}, {1480,0.26474257}, {1490,0.25779208}, {1500,0.25377228}, {1510,0.27331683}, {1520,0.25983168}, {1530,0.27230693}, {1540,0.26838614}, {1550,0.26191089}, {1560,0.28680198}, {1570,0.26401980}, {1580,0.28417822}, {1590,0.27926733}, {1600,0.29435644}, {1610,0.28542574}, {1620,0.29668317}, {1630,0.28369307}, {1640,0.28854455}, {1650,0.29544554}, {1660,0.30170297}, {1670,0.29536634}, {1680,0.30189109}, {1690,0.29096040}, {1700,0.31616832}, {1710,0.29706931}, {1720,0.31126733}, {1730,0.29527723}, {1740,0.32237624}, {1750,0.30356436}, {1760,0.30561386}, {1770,0.30699010}, {1780,0.32084158}, {1790,0.33290099}, {1800,0.30697030}, {1810,0.32216832}, {1820,0.31220792}, {1830,0.35482178}, {1840,0.32096040}, {1850,0.32546535}, {1860,0.32900990}, {1870,0.32449505}, {1880,0.31859406}, {1890,0.33640594}, {1900,0.35523762}, {1910,0.34000990}, {1920,0.35109901}, {1930,0.33735644}, {1940,0.33601980}, {1950,0.36697030}, {1960,0.34066337}, {1970,0.35772277}, {1980,0.34579208}, {1990,0.34552475}, {2000,0.35877228}, {2050,0.34855446}, {2100,0.37017822}, {2150,0.38650495}, {2200,0.37954455}, {2250,0.41065347}, {2300,0.42888119}, {2350,0.40681188}, {2400,0.42757426}, {2450,0.43594059}, {2500,0.44792079}, {2550,0.45818812}, {2600,0.49095050}, {2650,0.45512871}, {2700,0.47139604}, {2750,0.49892079}, {2800,0.49408911}, {2850,0.52465347}, {2900,0.53533663}, {2950,0.52943564}, {3000,0.54334653}, {3050,0.54525743}, {3100,0.55859406}, {3150,0.55492079}, {3200,0.56810891}, {3250,0.58442574}, {3300,0.59751485}, {3350,0.60467327}, {3400,0.62009901}, {3450,0.62626733}, {3500,0.63123762}, {3550,0.65529703}, {3600,0.65094059}, {3650,0.66698020}, {3700,0.65599010}, {3750,0.68173267}, {3800,0.69761386}, {3850,0.72635644}, {3900,0.71660396}, {3950,0.72475248}, {4000,0.71742574}, {4050,0.74701980}, {4100,0.76973267}, {4150,0.75696040}, {4200,0.76829703}, {4250,0.79574257}, {4300,0.79722772}, {4350,0.79396040}, {4400,0.81276238}, {4450,0.82197030}, {4500,0.82467327}, {4550,0.85223762}, {4600,0.84337624}, {4650,0.85262376}, {4700,0.87542574}, {4750,0.86199010}, {4800,0.90624752}, {4850,0.88648515}, {4900,1.00692079}, {4950,0.90752475}, {5000,0.94534653}, {5050,0.92917822}, {5100,0.96062376}, {5150,0.93336634}, {5200,0.97117822}, {5250,0.98076238}, {5300,0.98084158}, {5350,1.00178218}, {5400,0.99893069}, {5450,1.00956436}, {5500,1.02972277}, {5550,1.01341584}, {5600,1.03392079}, {5650,1.04981188}, {5700,1.04728713}, {5750,1.06123762}, {5800,1.07063366}, {5850,1.09225743}, {5900,1.10317822}, {5950,1.10970297}, {6000,1.12133663}, {6050,1.1730000}, {6100,3.7230857}, {6150,1.2074857}, {6200,1.2529143}, {6250,1.2323143}, {6300,1.2065714}, {6350,1.2148857}, {6400,1.2051429}, {6450,1.2228571}, {6500,1.2318571}, {6550,1.2513714}, {6600,1.2564000}, {6650,1.2862571}, {6700,1.2854571}, {6750,1.2949714}, {6800,1.3029429}, {6850,1.3117429}, {6900,1.3332857}, {6950,1.3314286}, {7000,1.3471429}, {7050,1.3480286}, {7100,1.3776857}, {7150,1.3964000}, {7200,1.4031714}, {7250,1.4444000}, {7300,1.4574286}, {7350,1.4512857}, {7400,1.4710286}, {7450,1.4592000}, {7500,1.4577143}, {7550,1.4734571}, {7600,1.4611714}, {7650,1.4970857}, {7700,1.5431429}, {7750,1.5358000}, {7800,1.5490857}, {7850,1.5299429}, {7900,1.5335714}, {7950,1.5871714}, {8000,1.6112286}, {8050,1.5902571}, {8100,1.6046286}, {8150,1.5822571}, {8200,1.5696571}, {8250,1.6473143}, {8300,1.6214286}, {8350,1.6387429}, {8400,1.6198286}, {8450,1.6824571}, {8500,1.6765714}, {8550,1.6791429}, {8600,1.6590571}, {8650,1.7556286}, {8700,1.7219429}, {8750,1.7452286}, {8800,1.7337714}, {8850,1.7353714}, {8900,1.7310286}, {8950,1.8013143}, {9000,1.7692000}, {9050,1.7668571}, {9100,1.8207429}, {9150,1.8244286}, {9200,1.8228000}, {9250,1.8386857}, {9300,1.8220571}, {9350,1.8752000}, {9400,1.8796857}, {9450,1.9043429}, {9500,1.9026571}, {9550,1.8898571}, {9600,1.8931429}, {9650,1.9150857}, {9700,1.9643429}, {9750,1.9315429}, {9800,1.9689714}, {9850,1.9733714}, {9900,2.0025143}, {9950,1.9905714}, {10000,2.0152857}, {10100,1.9866571}, {10200,2.0832571}, {10300,2.0243143}, {10400,2.0557143}, {10500,2.0474857}, {10600,2.1064286}, {10700,2.1377714}, {10800,2.1160000}, {10900,2.1371143}, {11000,2.1951429}, {11100,2.2016571}, {11200,2.1971429}, {11300,2.2114571}, {11400,2.2750286}, {11500,2.2720857}, {11600,2.3145143}, {11700,2.3023143}, {11800,2.3336571}, {11900,2.3917429}, {12000,2.3541143}, {12100,2.4521143}, {12200,2.4338571}, {12300,2.4030286}, {12400,2.4111429}, {12500,2.4625143}, {12600,2.5033714}, {12700,2.5970571}, {12800,2.5040857}, {12900,2.5460000}, {13000,2.5836857}, {13100,2.6131714}, {13200,2.5754857}, {13300,2.6431429}, {13400,2.6103429}, {13500,2.6809143}, {13600,2.6711143}, {13700,2.7290000}, {13800,2.7489143}, {13900,2.7566857}, {14000,2.8035429}, {14100,2.8135143}, {14200,2.8472000}, {14300,2.8879429}, {14400,3.0503429}, {14500,2.9119143}, {14600,2.8924000}, {14700,3.1838571}, {14800,3.0273429}, {14900,3.0189714}, {15000,2.9673429}, {15100,3.0159429}, {15200,3.0572857}, {15300,3.1010000}, {15400,3.0790571}, {15500,3.1886571}, {15600,3.0596000}, {15700,3.1992571}, {15800,3.2570000}, {15900,3.2796286}, {16000,3.2458571}, {16100,3.1772857}, {16200,3.4899143}, {16300,3.2418857}, {16400,3.2021429}, {16500,3.2891429}, {16600,3.3181143}, {16700,3.3969429}, {16800,3.2809714}, {16900,3.4257714}, {17000,3.3544571}, {17100,3.3415143}, {17200,3.6637143}, {17300,3.4204000}, {17400,3.5124000}, {17500,3.5322286}, {17600,3.5258286}, {17700,3.5526571}, {17800,3.5814286}, {17900,3.5408286}, {18000,3.6449429}, {18100,3.5916286}, {18200,3.6617143}, {18300,3.7014571}, {18400,3.6176857}, {18500,3.6487714}, {18600,3.8478286}, {18700,3.7081714}, {18800,3.7724000}, {18900,3.7987714}, {19000,3.7350571}, {19100,3.9737429}, {19200,3.9474857}, {19300,3.8732286}, {19400,3.8580000}, {19500,3.9078286}, {19600,4.0512286}, {19700,4.0196000}, {19800,4.0526571}, {19900,4.1071143}, {20000,4.0454571}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["Aggregate"]["system"] = {{1,0.00002970}, {2,0.00007921}, {3,0.00003960}, {4,0.00000000}, {5,0.00003960}, {6,0.00000000}, {7,0.00003960}, {8,0.00010891}, {9,0.00000000}, {10,0.00002970}, {11,0.00007921}, {12,0.00003960}, {13,0.00000000}, {14,0.00010891}, {15,0.00010891}, {16,0.00003960}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00006931}, {21,0.00011881}, {22,0.00000000}, {23,0.00007921}, {24,0.00003960}, {25,0.00003960}, {26,0.00003960}, {27,0.00000000}, {28,0.00000000}, {29,0.00007921}, {30,0.00000000}, {31,0.00007921}, {32,0.00000000}, {33,0.00007921}, {34,0.00000000}, {35,0.00010891}, {36,0.00003960}, {37,0.00003960}, {38,0.00013861}, {39,0.00003960}, {40,0.00002970}, {41,0.00000000}, {42,0.00000000}, {43,0.00003960}, {44,0.00002970}, {45,0.00017822}, {46,0.00003960}, {47,0.00000000}, {48,0.00006931}, {49,0.00003960}, {50,0.00000000}, {51,0.00000000}, {52,0.00003960}, {53,0.00000000}, {54,0.00000000}, {55,0.00002970}, {56,0.00000000}, {57,0.00000000}, {58,0.00003960}, {59,0.00002970}, {60,0.00007921}, {61,0.00011881}, {62,0.00027723}, {63,0.00006931}, {64,0.00002970}, {65,0.00003960}, {66,0.00006931}, {67,0.00003960}, {68,0.00010891}, {69,0.00003960}, {70,0.00000000}, {71,0.00003960}, {72,0.00000000}, {73,0.00002970}, {74,0.00002970}, {75,0.00011881}, {76,0.00000000}, {77,0.00002970}, {78,0.00017822}, {79,0.00000000}, {80,0.00009901}, {81,0.00002970}, {82,0.00007921}, {83,0.00000000}, {84,0.00011881}, {85,0.00003960}, {86,0.00007921}, {87,0.00007921}, {88,0.00003960}, {89,0.00011881}, {90,0.00003960}, {91,0.00007921}, {92,0.00007921}, {93,0.00003960}, {94,0.00006931}, {95,0.00000000}, {96,0.00000000}, {97,0.00007921}, {98,0.00003960}, {99,0.00011881}, {100,0.00003960}, {101,0.00006931}, {102,0.00010891}, {103,0.00002970}, {104,0.00007921}, {105,0.00018812}, {106,0.00007921}, {107,0.00005941}, {108,0.00000000}, {109,0.00003960}, {110,0.00006931}, {111,0.00003960}, {112,0.00003960}, {113,0.00003960}, {114,0.00018812}, {115,0.00003960}, {116,0.00007921}, {117,0.00002970}, {118,0.00003960}, {119,0.00003960}, {120,0.00003960}, {121,0.00003960}, {122,0.00022772}, {123,0.00003960}, {124,0.00006931}, {125,0.00006931}, {126,0.00011881}, {127,0.00003960}, {128,0.00003960}, {129,0.00011881}, {130,0.00002970}, {131,0.00003960}, {132,0.00003960}, {133,0.00003960}, {134,0.00002970}, {135,0.00003960}, {136,0.00019802}, {137,0.00015842}, {138,0.00007921}, {139,0.00000000}, {140,0.00003960}, {141,0.00003960}, {142,0.00002970}, {143,0.00010891}, {144,0.00014851}, {145,0.00000000}, {146,0.00006931}, {147,0.00000000}, {148,0.00005941}, {149,0.00000000}, {150,0.00011881}, {151,0.00006931}, {152,0.00000000}, {153,0.00003960}, {154,0.00000000}, {155,0.00013861}, {156,0.00006931}, {157,0.00000000}, {158,0.00013861}, {159,0.00003960}, {160,0.00014851}, {161,0.00022772}, {162,0.00000000}, {163,0.00027723}, {164,0.00003960}, {165,0.00007921}, {166,0.00007921}, {167,0.00000000}, {168,0.00003960}, {169,0.00025743}, {170,0.00011881}, {171,0.00000000}, {172,0.00015842}, {173,0.00003960}, {174,0.00003960}, {175,0.00007921}, {176,0.00010891}, {177,0.00010891}, {178,0.00032673}, {179,0.00007921}, {180,0.00011881}, {181,0.00003960}, {182,0.00006931}, {183,0.00000000}, {184,0.00002970}, {185,0.00019802}, {186,0.00015842}, {187,0.00007921}, {188,0.00007921}, {189,0.00007921}, {190,0.00006931}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00011881}, {197,0.00003960}, {198,0.00000000}, {199,0.00003960}, {200,0.00000000}, {201,0.00007921}, {202,0.00003960}, {203,0.00003960}, {204,0.00003960}, {205,0.00003960}, {206,0.00000000}, {207,0.00000000}, {208,0.00003960}, {209,0.00006931}, {210,0.00003960}, {211,0.00002970}, {212,0.00000000}, {213,0.00003960}, {214,0.00000000}, {215,0.00011881}, {216,0.00003960}, {217,0.00003960}, {218,0.00003960}, {219,0.00010891}, {220,0.00030693}, {221,0.00014851}, {222,0.00011881}, {223,0.00003960}, {224,0.00034653}, {225,0.00019802}, {226,0.00003960}, {227,0.00007921}, {228,0.00019802}, {229,0.00010891}, {230,0.00011881}, {231,0.00022772}, {232,0.00000000}, {233,0.00011881}, {234,0.00006931}, {235,0.00003960}, {236,0.00006931}, {237,0.00010891}, {238,0.00007921}, {239,0.00031683}, {240,0.00003960}, {241,0.00010891}, {242,0.00000000}, {243,0.00007921}, {244,0.00007921}, {245,0.00003960}, {246,0.00000000}, {247,0.00003960}, {248,0.00000000}, {249,0.00003960}, {250,0.00011881}, {251,0.00002970}, {252,0.00000000}, {253,0.00000000}, {254,0.00007921}, {255,0.00000000}, {256,0.00000000}, {257,0.00007921}, {258,0.00003960}, {259,0.00011881}, {260,0.00003960}, {261,0.00007921}, {262,0.00010891}, {263,0.00003960}, {264,0.00002970}, {265,0.00003960}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00007921}, {270,0.00009901}, {271,0.00007921}, {272,0.00003960}, {273,0.00000000}, {274,0.00006931}, {275,0.00000000}, {276,0.00002970}, {277,0.00000000}, {278,0.00007921}, {279,0.00000000}, {280,0.00011881}, {281,0.00003960}, {282,0.00003960}, {283,0.00007921}, {284,0.00000000}, {285,0.00003960}, {286,0.00006931}, {287,0.00002970}, {288,0.00014851}, {289,0.00003960}, {290,0.00003960}, {291,0.00007921}, {292,0.00007921}, {293,0.00000000}, {294,0.00003960}, {295,0.00000000}, {296,0.00003960}, {297,0.00003960}, {298,0.00010891}, {299,0.00002970}, {300,0.00003960}, {301,0.00003960}, {302,0.00003960}, {303,0.00003960}, {304,0.00006931}, {305,0.00000000}, {306,0.00006931}, {307,0.00000000}, {308,0.00003960}, {309,0.00007921}, {310,0.00006931}, {311,0.00003960}, {312,0.00000000}, {313,0.00003960}, {314,0.00000000}, {315,0.00000000}, {316,0.00007921}, {317,0.00003960}, {318,0.00003960}, {319,0.00003960}, {320,0.00007921}, {321,0.00000000}, {322,0.00010891}, {323,0.00000000}, {324,0.00007921}, {325,0.00000000}, {326,0.00000000}, {327,0.00007921}, {328,0.00007921}, {329,0.00007921}, {330,0.00003960}, {331,0.00003960}, {332,0.00000000}, {333,0.00003960}, {334,0.00000000}, {335,0.00007921}, {336,0.00003960}, {337,0.00011881}, {338,0.00007921}, {339,0.00000000}, {340,0.00011881}, {341,0.00009901}, {342,0.00000000}, {343,0.00003960}, {344,0.00003960}, {345,0.00006931}, {346,0.00038614}, {347,0.00019802}, {348,0.00045545}, {349,0.00011881}, {350,0.00055446}, {351,0.00011881}, {352,0.00014851}, {353,0.00003960}, {354,0.00000000}, {355,0.00011881}, {356,0.00007921}, {357,0.00000000}, {358,0.00011881}, {359,0.00015842}, {360,0.00003960}, {361,0.00000000}, {362,0.00007921}, {363,0.00014851}, {364,0.00015842}, {365,0.00003960}, {366,0.00007921}, {367,0.00019802}, {368,0.00015842}, {369,0.00007921}, {370,0.00015842}, {371,0.00007921}, {372,0.00000000}, {373,0.00000000}, {374,0.00003960}, {375,0.00007921}, {376,0.00011881}, {377,0.00000000}, {378,0.00000000}, {379,0.00003960}, {380,0.00003960}, {381,0.00000000}, {382,0.00003960}, {383,0.00007921}, {384,0.00003960}, {385,0.00007921}, {386,0.00011881}, {387,0.00000000}, {388,0.00007921}, {389,0.00011881}, {390,0.00007921}, {391,0.00010891}, {392,0.00003960}, {393,0.00006931}, {394,0.00000000}, {395,0.00011881}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00007921}, {400,0.00003960}, {401,0.00003960}, {402,0.00003960}, {403,0.00003960}, {404,0.00003960}, {405,0.00000000}, {406,0.00015842}, {407,0.00011881}, {408,0.00003960}, {409,0.00000000}, {410,0.00011881}, {411,0.00007921}, {412,0.00007921}, {413,0.00003960}, {414,0.00011881}, {415,0.00003960}, {416,0.00006931}, {417,0.00007921}, {418,0.00002970}, {419,0.00007921}, {420,0.00003960}, {421,0.00003960}, {422,0.00019802}, {423,0.00007921}, {424,0.00007921}, {425,0.00003960}, {426,0.00011881}, {427,0.00000000}, {428,0.00007921}, {429,0.00003960}, {430,0.00002970}, {431,0.00003960}, {432,0.00000000}, {433,0.00007921}, {434,0.00003960}, {435,0.00000000}, {436,0.00007921}, {437,0.00003960}, {438,0.00014851}, {439,0.00003960}, {440,0.00000000}, {441,0.00000000}, {442,0.00003960}, {443,0.00007921}, {444,0.00003960}, {445,0.00014851}, {446,0.00003960}, {447,0.00000000}, {448,0.00003960}, {449,0.00003960}, {450,0.00007921}, {451,0.00015842}, {452,0.00007921}, {453,0.00003960}, {454,0.00007921}, {455,0.00018812}, {456,0.00007921}, {457,0.00000000}, {458,0.00003960}, {459,0.00000000}, {460,0.00007921}, {461,0.00000000}, {462,0.00003960}, {463,0.00000000}, {464,0.00003960}, {465,0.00003960}, {466,0.00011881}, {467,0.00003960}, {468,0.00003960}, {469,0.00000000}, {470,0.00003960}, {471,0.00003960}, {472,0.00003960}, {473,0.00003960}, {474,0.00003960}, {475,0.00003960}, {476,0.00003960}, {477,0.00000000}, {478,0.00007921}, {479,0.00011881}, {480,0.00003960}, {481,0.00003960}, {482,0.00007921}, {483,0.00011881}, {484,0.00007921}, {485,0.00003960}, {486,0.00003960}, {487,0.00003960}, {488,0.00000000}, {489,0.00003960}, {490,0.00003960}, {491,0.00011881}, {492,0.00007921}, {493,0.00014851}, {494,0.00003960}, {495,0.00003960}, {496,0.00002970}, {497,0.00003960}, {498,0.00006931}, {499,0.00000000}, {500,0.00003960}, {505,0.00000000}, {510,0.00003960}, {515,0.00007921}, {520,0.00000000}, {525,0.00007921}, {530,0.00011881}, {535,0.00006931}, {540,0.00003960}, {545,0.00007921}, {550,0.00011881}, {555,0.00007921}, {560,0.00003960}, {565,0.00007921}, {570,0.00003960}, {575,0.00003960}, {580,0.00003960}, {585,0.00007921}, {590,0.00000000}, {595,0.00007921}, {600,0.00002970}, {605,0.00003960}, {610,0.00007921}, {615,0.00003960}, {620,0.00010891}, {625,0.00011881}, {630,0.00007921}, {635,0.00007921}, {640,0.00000000}, {645,0.00000000}, {650,0.00007921}, {655,0.00003960}, {660,0.00000000}, {665,0.00000000}, {670,0.00011881}, {675,0.00000000}, {680,0.00003960}, {685,0.00007921}, {690,0.00003960}, {695,0.00003960}, {700,0.00003960}, {705,0.00011881}, {710,0.00007921}, {715,0.00007921}, {720,0.00007921}, {725,0.00007921}, {730,0.00007921}, {735,0.00011881}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00007921}, {760,0.00000000}, {765,0.00019802}, {770,0.00000000}, {775,0.00000000}, {780,0.00019802}, {785,0.00023762}, {790,0.00011881}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00007921}, {815,0.00007921}, {820,0.00003960}, {825,0.00018812}, {830,0.00003960}, {835,0.00003960}, {840,0.00007921}, {845,0.00000000}, {850,0.00003960}, {855,0.00010891}, {860,0.00006931}, {865,0.00002970}, {870,0.00011881}, {875,0.00011881}, {880,0.00007921}, {885,0.00000000}, {890,0.00011881}, {895,0.00003960}, {900,0.00003960}, {905,0.00019802}, {910,0.00003960}, {915,0.00015842}, {920,0.00003960}, {925,0.00007921}, {930,0.00014851}, {935,0.00006931}, {940,0.00000000}, {945,0.00011881}, {950,0.00003960}, {955,0.00003960}, {960,0.00011881}, {965,0.00000000}, {970,0.00003960}, {975,0.00003960}, {980,0.00015842}, {985,0.00003960}, {990,0.00007921}, {995,0.00000000}, {1000,0.00003960}, {1010,0.00003960}, {1020,0.00011881}, {1030,0.00003960}, {1040,0.00000000}, {1050,0.00010891}, {1060,0.00007921}, {1070,0.00003960}, {1080,0.00007921}, {1090,0.00003960}, {1100,0.00000000}, {1110,0.00015842}, {1120,0.00031683}, {1130,0.00002970}, {1140,0.00011881}, {1150,0.00015842}, {1160,0.00007921}, {1170,0.00003960}, {1180,0.00007921}, {1190,0.00011881}, {1200,0.00000000}, {1210,0.00015842}, {1220,0.00000000}, {1230,0.00014851}, {1240,0.00019802}, {1250,0.00011881}, {1260,0.00007921}, {1270,0.00007921}, {1280,0.00000000}, {1290,0.00007921}, {1300,0.00006931}, {1310,0.00011881}, {1320,0.00007921}, {1330,0.00013861}, {1340,0.00006931}, {1350,0.00015842}, {1360,0.00003960}, {1370,0.00007921}, {1380,0.00003960}, {1390,0.00011881}, {1400,0.00011881}, {1410,0.00007921}, {1420,0.00009901}, {1430,0.00003960}, {1440,0.00022772}, {1450,0.00007921}, {1460,0.00015842}, {1470,0.00026733}, {1480,0.00007921}, {1490,0.00010891}, {1500,0.00003960}, {1510,0.00007921}, {1520,0.00000000}, {1530,0.00007921}, {1540,0.00014851}, {1550,0.00007921}, {1560,0.00011881}, {1570,0.00019802}, {1580,0.00003960}, {1590,0.00007921}, {1600,0.00000000}, {1610,0.00023762}, {1620,0.00018812}, {1630,0.00013861}, {1640,0.00007921}, {1650,0.00003960}, {1660,0.00007921}, {1670,0.00007921}, {1680,0.00015842}, {1690,0.00015842}, {1700,0.00003960}, {1710,0.00011881}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00011881}, {1750,0.00003960}, {1760,0.00011881}, {1770,0.00003960}, {1780,0.00011881}, {1790,0.00015842}, {1800,0.00006931}, {1810,0.00002970}, {1820,0.00015842}, {1830,0.00023762}, {1840,0.00011881}, {1850,0.00023762}, {1860,0.00007921}, {1870,0.00011881}, {1880,0.00007921}, {1890,0.00015842}, {1900,0.00014851}, {1910,0.00007921}, {1920,0.00003960}, {1930,0.00010891}, {1940,0.00019802}, {1950,0.00013861}, {1960,0.00000000}, {1970,0.00007921}, {1980,0.00019802}, {1990,0.00003960}, {2000,0.00007921}, {2050,0.00023762}, {2100,0.00011881}, {2150,0.00011881}, {2200,0.00007921}, {2250,0.00010891}, {2300,0.00019802}, {2350,0.00010891}, {2400,0.00011881}, {2450,0.00026733}, {2500,0.00007921}, {2550,0.00014851}, {2600,0.00003960}, {2650,0.00021782}, {2700,0.00015842}, {2750,0.00011881}, {2800,0.00039604}, {2850,0.00011881}, {2900,0.00015842}, {2950,0.00007921}, {3000,0.00014851}, {3050,0.00011881}, {3100,0.00019802}, {3150,0.00019802}, {3200,0.00031683}, {3250,0.00015842}, {3300,0.00010891}, {3350,0.00007921}, {3400,0.00015842}, {3450,0.00003960}, {3500,0.00007921}, {3550,0.00011881}, {3600,0.00019802}, {3650,0.00007921}, {3700,0.00042574}, {3750,0.00003960}, {3800,0.00007921}, {3850,0.00007921}, {3900,0.00007921}, {3950,0.00015842}, {4000,0.00010891}, {4050,0.00029703}, {4100,0.00042574}, {4150,0.00011881}, {4200,0.00011881}, {4250,0.00017822}, {4300,0.00015842}, {4350,0.00011881}, {4400,0.00023762}, {4450,0.00015842}, {4500,0.00007921}, {4550,0.00015842}, {4600,0.00039604}, {4650,0.00003960}, {4700,0.00023762}, {4750,0.00031683}, {4800,0.00035644}, {4850,0.00019802}, {4900,0.00062376}, {4950,0.00035644}, {5000,0.00011881}, {5050,0.00015842}, {5100,0.00034653}, {5150,0.00046535}, {5200,0.00029703}, {5250,0.00039604}, {5300,0.00014851}, {5350,0.00023762}, {5400,0.00030693}, {5450,0.00011881}, {5500,0.00026733}, {5550,0.00014851}, {5600,0.00039604}, {5650,0.00015842}, {5700,0.00019802}, {5750,0.00026733}, {5800,0.00031683}, {5850,0.00019802}, {5900,0.00011881}, {5950,0.00015842}, {6000,0.00035644}, {6050,0.0072571}, {6100,0.0033429}, {6150,0.0001143}, {6200,0.0003429}, {6250,0.0004571}, {6300,0.0003143}, {6350,0.0006571}, {6400,0.0006571}, {6450,0.0001143}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0002286}, {6700,0.0001143}, {6750,0.0002000}, {6800,0.0002286}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0003143}, {7000,0.0005429}, {7050,0.0001143}, {7100,0.0003429}, {7150,0.0003429}, {7200,0.0000000}, {7250,0.0003429}, {7300,0.0000857}, {7350,0.0004000}, {7400,0.0001143}, {7450,0.0003143}, {7500,0.0001143}, {7550,0.0003429}, {7600,0.0001143}, {7650,0.0001143}, {7700,0.0001143}, {7750,0.0002000}, {7800,0.0005429}, {7850,0.0000000}, {7900,0.0002000}, {7950,0.0001143}, {8000,0.0003429}, {8050,0.0002000}, {8100,0.0002286}, {8150,0.0001143}, {8200,0.0003143}, {8250,0.0004571}, {8300,0.0001143}, {8350,0.0002286}, {8400,0.0000000}, {8450,0.0001143}, {8500,0.0002286}, {8550,0.0003429}, {8600,0.0003429}, {8650,0.0002286}, {8700,0.0004571}, {8750,0.0000000}, {8800,0.0002286}, {8850,0.0004286}, {8900,0.0000000}, {8950,0.0002286}, {9000,0.0001143}, {9050,0.0003429}, {9100,0.0003143}, {9150,0.0002286}, {9200,0.0003143}, {9250,0.0004000}, {9300,0.0002286}, {9350,0.0002286}, {9400,0.0003429}, {9450,0.0001143}, {9500,0.0001143}, {9550,0.0004571}, {9600,0.0004571}, {9650,0.0002286}, {9700,0.0003429}, {9750,0.0004286}, {9800,0.0004571}, {9850,0.0000000}, {9900,0.0002286}, {9950,0.0002286}, {10000,0.0000000}, {10100,0.0004000}, {10200,0.0028286}, {10300,0.0003429}, {10400,0.0005714}, {10500,0.0001143}, {10600,0.0003429}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0004286}, {11000,0.0002000}, {11100,0.0001143}, {11200,0.0003143}, {11300,0.0003429}, {11400,0.0002286}, {11500,0.0003429}, {11600,0.0006857}, {11700,0.0001143}, {11800,0.0006857}, {11900,0.0001143}, {12000,0.0000000}, {12100,0.0003429}, {12200,0.0001143}, {12300,0.0004286}, {12400,0.0001143}, {12500,0.0004571}, {12600,0.0002286}, {12700,0.0000000}, {12800,0.0002286}, {12900,0.0001143}, {13000,0.0002286}, {13100,0.0004571}, {13200,0.0011429}, {13300,0.0001143}, {13400,0.0003429}, {13500,0.0002286}, {13600,0.0003429}, {13700,0.0002286}, {13800,0.0003429}, {13900,0.0001143}, {14000,0.0002286}, {14100,0.0000000}, {14200,0.0002286}, {14300,0.0002286}, {14400,0.0003429}, {14500,0.0011429}, {14600,0.0012571}, {14700,0.0007714}, {14800,0.0001143}, {14900,0.0014286}, {15000,0.0001143}, {15100,0.0020857}, {15200,0.0005714}, {15300,0.0017143}, {15400,0.0010000}, {15500,0.0009143}, {15600,0.0009143}, {15700,0.0004286}, {15800,0.0004286}, {15900,0.0009143}, {16000,0.0009143}, {16100,0.0011143}, {16200,0.0013429}, {16300,0.0004571}, {16400,0.0011143}, {16500,0.0016857}, {16600,0.0015714}, {16700,0.0012571}, {16800,0.0000857}, {16900,0.0022571}, {17000,0.0005714}, {17100,0.0004571}, {17200,0.0013429}, {17300,0.0013429}, {17400,0.0015714}, {17500,0.0025143}, {17600,0.0004571}, {17700,0.0009143}, {17800,0.0016000}, {17900,0.0002286}, {18000,0.0012286}, {18100,0.0001143}, {18200,0.0004571}, {18300,0.0018000}, {18400,0.0017143}, {18500,0.0009143}, {18600,0.0016000}, {18700,0.0011429}, {18800,0.0003429}, {18900,0.0008000}, {19000,0.0010000}, {19100,0.0004571}, {19200,0.0008000}, {19300,0.0008000}, {19400,0.0032000}, {19500,0.0012571}, {19600,0.0011143}, {19700,0.0022857}, {19800,0.0017143}, {19900,0.0041714}, {20000,0.0025714}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000990}, {7,0.00072277}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00106931}, {14,0.00115842}, {15,0.00200000}, {16,0.00200000}, {17,0.00200000}, {18,0.00200000}, {19,0.00200000}, {20,0.00207921}, {21,0.00225743}, {22,0.00252475}, {23,0.00300000}, {24,0.00300000}, {25,0.00300000}, {26,0.00300000}, {27,0.00307921}, {28,0.00307921}, {29,0.00331683}, {30,0.00394059}, {31,0.00400000}, {32,0.00400000}, {33,0.00400000}, {34,0.00500000}, {35,0.00444554}, {36,0.00427723}, {37,0.00463366}, {38,0.00499010}, {39,0.00500000}, {40,0.00500000}, {41,0.00517822}, {42,0.00519802}, {43,0.00722772}, {44,0.00534653}, {45,0.00806931}, {46,0.00600000}, {47,0.00733663}, {48,0.00605941}, {49,0.00615842}, {50,0.00618812}, {51,0.00633663}, {52,0.00642574}, {53,0.00696040}, {54,0.00703960}, {55,0.00712871}, {56,0.00710891}, {57,0.00719802}, {58,0.00719802}, {59,0.00946535}, {60,0.00776238}, {61,0.00804950}, {62,0.01097030}, {63,0.00825743}, {64,0.00818812}, {65,0.00962376}, {66,0.00840594}, {67,0.00859406}, {68,0.00887129}, {69,0.00917822}, {70,0.00913861}, {71,0.00924752}, {72,0.00928713}, {73,0.01342574}, {74,0.00940594}, {75,0.00989109}, {76,0.01000000}, {77,0.01011881}, {78,0.01354455}, {79,0.01022772}, {80,0.01020792}, {81,0.01039604}, {82,0.01049505}, {83,0.01101980}, {84,0.01100990}, {85,0.01380198}, {86,0.01118812}, {87,0.01130693}, {88,0.01124752}, {89,0.01158416}, {90,0.01177228}, {91,0.01211881}, {92,0.01207921}, {93,0.01225743}, {94,0.01226733}, {95,0.01241584}, {96,0.01227723}, {97,0.01269307}, {98,0.01281188}, {99,0.01327723}, {100,0.01325743}, {101,0.01327723}, {102,0.01321782}, {103,0.01332673}, {104,0.01372277}, {105,0.01997030}, {106,0.01686139}, {107,0.01405941}, {108,0.01428713}, {109,0.01426733}, {110,0.01440594}, {111,0.01456436}, {112,0.01479208}, {113,0.01905941}, {114,0.01509901}, {115,0.01528713}, {116,0.01521782}, {117,0.01529703}, {118,0.02005941}, {119,0.01567327}, {120,0.01578218}, {121,0.01615842}, {122,0.02177228}, {123,0.01625743}, {124,0.01642574}, {125,0.01647525}, {126,0.01838614}, {127,0.01686139}, {128,0.01687129}, {129,0.02036634}, {130,0.01716832}, {131,0.01733663}, {132,0.01989109}, {133,0.01740594}, {134,0.01780198}, {135,0.01792079}, {136,0.01799010}, {137,0.02331683}, {138,0.01829703}, {139,0.01839604}, {140,0.01836634}, {141,0.01862376}, {142,0.01896040}, {143,0.01913861}, {144,0.02134653}, {145,0.01933663}, {146,0.02243564}, {147,0.01968317}, {148,0.02239604}, {149,0.01980198}, {150,0.02126733}, {151,0.02044554}, {152,0.02014851}, {153,0.02039604}, {154,0.02036634}, {155,0.02757426}, {156,0.02068317}, {157,0.02229703}, {158,0.02130693}, {159,0.02143564}, {160,0.02613861}, {161,0.02133663}, {162,0.02143564}, {163,0.02834653}, {164,0.02171287}, {165,0.02192079}, {166,0.02765347}, {167,0.02244554}, {168,0.02226733}, {169,0.02453465}, {170,0.02276238}, {171,0.02283168}, {172,0.02269307}, {173,0.02603960}, {174,0.02338614}, {175,0.02352475}, {176,0.02344554}, {177,0.02337624}, {178,0.02868317}, {179,0.02388119}, {180,0.02393069}, {181,0.02447525}, {182,0.02423762}, {183,0.02435644}, {184,0.02786139}, {185,0.03162376}, {186,0.02467327}, {187,0.02508911}, {188,0.02519802}, {189,0.02519802}, {190,0.02541584}, {191,0.02564356}, {192,0.02544554}, {193,0.02556436}, {194,0.02565347}, {195,0.02591089}, {196,0.02582178}, {197,0.02622772}, {198,0.02637624}, {199,0.02637624}, {200,0.02654455}, {201,0.02679208}, {202,0.02672277}, {203,0.02710891}, {204,0.02719802}, {205,0.02744554}, {206,0.02754455}, {207,0.02788119}, {208,0.02769307}, {209,0.03783168}, {210,0.03317822}, {211,0.02825743}, {212,0.02814851}, {213,0.02857426}, {214,0.02864356}, {215,0.03067327}, {216,0.03450495}, {217,0.02900990}, {218,0.02914851}, {219,0.02932673}, {220,0.04057426}, {221,0.03320792}, {222,0.02976238}, {223,0.02995050}, {224,0.04107921}, {225,0.03291089}, {226,0.02999010}, {227,0.03059406}, {228,0.03561386}, {229,0.03068317}, {230,0.03076238}, {231,0.03843564}, {232,0.03074257}, {233,0.03131683}, {234,0.03736634}, {235,0.03132673}, {236,0.03165347}, {237,0.03409901}, {238,0.03190099}, {239,0.03957426}, {240,0.03217822}, {241,0.03246535}, {242,0.03243564}, {243,0.03270297}, {244,0.03458416}, {245,0.03300990}, {246,0.03634653}, {247,0.03341584}, {248,0.03737624}, {249,0.03346535}, {250,0.03690099}, {251,0.03403960}, {252,0.03509901}, {253,0.03390099}, {254,0.03417822}, {255,0.04501980}, {256,0.03417822}, {257,0.04063366}, {258,0.03467327}, {259,0.03489109}, {260,0.04680198}, {261,0.03502970}, {262,0.03918812}, {263,0.03514851}, {264,0.03512871}, {265,0.04100000}, {266,0.03552475}, {267,0.03575248}, {268,0.03939604}, {269,0.05417822}, {270,0.03660396}, {271,0.03669307}, {272,0.04665347}, {273,0.03666337}, {274,0.03705941}, {275,0.03710891}, {276,0.04382178}, {277,0.05063366}, {278,0.03709901}, {279,0.03763366}, {280,0.03866337}, {281,0.04413861}, {282,0.04893069}, {283,0.03844554}, {284,0.03844554}, {285,0.03813861}, {286,0.03846535}, {287,0.04026733}, {288,0.04304950}, {289,0.04615842}, {290,0.04834653}, {291,0.05101980}, {292,0.03925743}, {293,0.03967327}, {294,0.04001980}, {295,0.03990099}, {296,0.03997030}, {297,0.03992079}, {298,0.04028713}, {299,0.04044554}, {300,0.04045545}, {301,0.04060396}, {302,0.04106931}, {303,0.04110891}, {304,0.04100990}, {305,0.05978218}, {306,0.05329703}, {307,0.05098020}, {308,0.04871287}, {309,0.04584158}, {310,0.04172277}, {311,0.04207921}, {312,0.04199010}, {313,0.04225743}, {314,0.05553465}, {315,0.05190099}, {316,0.04667327}, {317,0.04296040}, {318,0.04326733}, {319,0.04378218}, {320,0.05238614}, {321,0.04669307}, {322,0.04297030}, {323,0.04386139}, {324,0.05468317}, {325,0.04887129}, {326,0.04378218}, {327,0.04419802}, {328,0.05324752}, {329,0.04627723}, {330,0.04448515}, {331,0.06151485}, {332,0.04905941}, {333,0.04495050}, {334,0.05719802}, {335,0.04728713}, {336,0.04531683}, {337,0.05523762}, {338,0.04524752}, {339,0.06086139}, {340,0.04976238}, {341,0.04633663}, {342,0.05429703}, {343,0.04634653}, {344,0.05677228}, {345,0.04638614}, {346,0.06017822}, {347,0.04725743}, {348,0.06066337}, {349,0.04723762}, {350,0.06014851}, {351,0.04753465}, {352,0.05929703}, {353,0.04718812}, {354,0.05477228}, {355,0.04826733}, {356,0.05654455}, {357,0.04800000}, {358,0.05324752}, {359,0.06406931}, {360,0.04836634}, {361,0.05746535}, {362,0.04906931}, {363,0.05063366}, {364,0.06103960}, {365,0.04947525}, {366,0.05175248}, {367,0.06092079}, {368,0.04960396}, {369,0.04977228}, {370,0.05685149}, {371,0.06578218}, {372,0.05039604}, {373,0.05407921}, {374,0.06051485}, {375,0.05129703}, {376,0.05065347}, {377,0.05361386}, {378,0.05893069}, {379,0.06546535}, {380,0.05169307}, {381,0.05147525}, {382,0.05338614}, {383,0.05771287}, {384,0.06194059}, {385,0.06764356}, {386,0.05190099}, {387,0.05200000}, {388,0.05228713}, {389,0.05400990}, {390,0.05723762}, {391,0.05987129}, {392,0.06145545}, {393,0.06382178}, {394,0.06554455}, {395,0.06500000}, {396,0.06801980}, {397,0.06923762}, {398,0.06962376}, {399,0.07830693}, {400,0.07543564}, {401,0.07290099}, {402,0.07307921}, {403,0.07131683}, {404,0.06982178}, {405,0.06959406}, {406,0.06750495}, {407,0.06558416}, {408,0.06218812}, {409,0.06072277}, {410,0.05804950}, {411,0.05600990}, {412,0.05569307}, {413,0.05620792}, {414,0.07156436}, {415,0.07090099}, {416,0.06748515}, {417,0.06116832}, {418,0.05618812}, {419,0.05689109}, {420,0.07467327}, {421,0.06899010}, {422,0.06133663}, {423,0.05741584}, {424,0.05733663}, {425,0.07005941}, {426,0.06324752}, {427,0.05770297}, {428,0.07493069}, {429,0.06779208}, {430,0.06027723}, {431,0.05894059}, {432,0.06914851}, {433,0.06316832}, {434,0.05869307}, {435,0.07365347}, {436,0.06149505}, {437,0.05972277}, {438,0.06975248}, {439,0.06001980}, {440,0.07483168}, {441,0.06388119}, {442,0.06215842}, {443,0.06746535}, {444,0.06019802}, {445,0.07050495}, {446,0.06065347}, {447,0.07229703}, {448,0.06022772}, {449,0.07755446}, {450,0.06247525}, {451,0.08069307}, {452,0.06236634}, {453,0.07671287}, {454,0.06144554}, {455,0.07460396}, {456,0.06147525}, {457,0.07150495}, {458,0.06204950}, {459,0.06697030}, {460,0.07711881}, {461,0.06244554}, {462,0.07193069}, {463,0.08158416}, {464,0.06528713}, {465,0.07485149}, {466,0.06281188}, {467,0.06943564}, {468,0.07805941}, {469,0.06352475}, {470,0.06685149}, {471,0.07322772}, {472,0.08291089}, {473,0.06430693}, {474,0.07003960}, {475,0.07728713}, {476,0.08320792}, {477,0.06511881}, {478,0.06941584}, {479,0.07539604}, {480,0.08362376}, {481,0.06502970}, {482,0.06526733}, {483,0.07091089}, {484,0.07596040}, {485,0.07694059}, {486,0.08383168}, {487,0.08695050}, {488,0.06610891}, {489,0.06774257}, {490,0.07018812}, {491,0.07352475}, {492,0.07555446}, {493,0.07981188}, {494,0.08313861}, {495,0.08241584}, {496,0.08376238}, {497,0.08192079}, {498,0.08516832}, {499,0.08589109}, {500,0.08576238}, {505,0.08496040}, {510,0.08321782}, {515,0.08019802}, {520,0.07682178}, {525,0.07155446}, {530,0.09931683}, {535,0.08524752}, {540,0.07461386}, {545,0.09130693}, {550,0.07893069}, {555,0.09163366}, {560,0.07766337}, {565,0.08772277}, {570,0.09639604}, {575,0.07908911}, {580,0.08815842}, {585,0.09364356}, {590,0.09620792}, {595,0.09851485}, {600,0.09852475}, {605,0.09809901}, {610,0.09684158}, {615,0.09493069}, {620,0.09460396}, {625,0.08637624}, {630,0.10792079}, {635,0.09885149}, {640,0.08904950}, {645,0.10487129}, {650,0.09415842}, {655,0.10641584}, {660,0.09345545}, {665,0.10560396}, {670,0.11585149}, {675,0.09618812}, {680,0.10247525}, {685,0.10716832}, {690,0.11055446}, {695,0.11396040}, {700,0.11944554}, {705,0.11850495}, {710,0.11674257}, {715,0.11335644}, {720,0.10975248}, {725,0.10623762}, {730,0.13594059}, {735,0.12023762}, {740,0.10920792}, {745,0.12535644}, {750,0.11335644}, {755,0.12557426}, {760,0.11718812}, {765,0.12573267}, {770,0.13385149}, {775,0.11530693}, {780,0.12182178}, {785,0.12680198}, {790,0.13603960}, {795,0.13908911}, {800,0.13976238}, {805,0.13804950}, {810,0.13670297}, {815,0.14699010}, {820,0.13553465}, {825,0.13041584}, {830,0.12349505}, {835,0.13963366}, {840,0.14183168}, {845,0.15325743}, {850,0.14003960}, {855,0.14989109}, {860,0.13717822}, {865,0.16153465}, {870,0.13551485}, {875,0.14256436}, {880,0.14692079}, {885,0.15213861}, {890,0.13505941}, {895,0.13614851}, {900,0.13679208}, {905,0.13711881}, {910,0.13627723}, {915,0.16359406}, {920,0.15772277}, {925,0.15190099}, {930,0.14644554}, {935,0.14812871}, {940,0.16155446}, {945,0.15029703}, {950,0.16155446}, {955,0.15056436}, {960,0.16745545}, {965,0.15042574}, {970,0.15778218}, {975,0.16560396}, {980,0.15291089}, {985,0.15770297}, {990,0.15879208}, {995,0.16223762}, {1000,0.16934653}, {1010,0.16775248}, {1020,0.16236634}, {1030,0.15575248}, {1040,0.18356436}, {1050,0.17036634}, {1060,0.18075248}, {1070,0.17993069}, {1080,0.18003960}, {1090,0.18236634}, {1100,0.18364356}, {1110,0.19446535}, {1120,0.18750495}, {1130,0.18289109}, {1140,0.18080198}, {1150,0.19642574}, {1160,0.18019802}, {1170,0.20879208}, {1180,0.20497030}, {1190,0.20566337}, {1200,0.18903960}, {1210,0.18965347}, {1220,0.20983168}, {1230,0.21404950}, {1240,0.20380198}, {1250,0.21438614}, {1260,0.21083168}, {1270,0.21657426}, {1280,0.19805941}, {1290,0.21200990}, {1300,0.21028713}, {1310,0.23105941}, {1320,0.21409901}, {1330,0.20729703}, {1340,0.23591089}, {1350,0.21935644}, {1360,0.22921782}, {1370,0.22535644}, {1380,0.22612871}, {1390,0.25480198}, {1400,0.23971287}, {1410,0.23518812}, {1420,0.24438614}, {1430,0.23331683}, {1440,0.24175248}, {1450,0.24760396}, {1460,0.23403960}, {1470,0.24815842}, {1480,0.25107921}, {1490,0.24320792}, {1500,0.23953465}, {1510,0.25881188}, {1520,0.24322772}, {1530,0.25779208}, {1540,0.25408911}, {1550,0.24716832}, {1560,0.27191089}, {1570,0.24889109}, {1580,0.26909901}, {1590,0.26426733}, {1600,0.27923762}, {1610,0.27072277}, {1620,0.28174257}, {1630,0.26816832}, {1640,0.27311881}, {1650,0.27985149}, {1660,0.28618812}, {1670,0.27978218}, {1680,0.28618812}, {1690,0.27520792}, {1700,0.30033663}, {1710,0.28105941}, {1720,0.29504950}, {1730,0.27596040}, {1740,0.30647525}, {1750,0.28733663}, {1760,0.28778218}, {1770,0.29027723}, {1780,0.30432673}, {1790,0.31633663}, {1800,0.28710891}, {1810,0.29839604}, {1820,0.29376238}, {1830,0.33782178}, {1840,0.30355446}, {1850,0.30804950}, {1860,0.31185149}, {1870,0.30717822}, {1880,0.30105941}, {1890,0.31886139}, {1900,0.33767327}, {1910,0.32228713}, {1920,0.33308911}, {1930,0.31955446}, {1940,0.31786139}, {1950,0.34910891}, {1960,0.32252475}, {1970,0.33961386}, {1980,0.32755446}, {1990,0.32656436}, {2000,0.34030693}, {2050,0.32983168}, {2100,0.35106931}, {2150,0.36233663}, {2200,0.35917822}, {2250,0.38989109}, {2300,0.40765347}, {2350,0.38499010}, {2400,0.40513861}, {2450,0.41287129}, {2500,0.42462376}, {2550,0.43449505}, {2600,0.46672277}, {2650,0.42782178}, {2700,0.44631683}, {2750,0.47285149}, {2800,0.46681188}, {2850,0.49790099}, {2900,0.50808911}, {2950,0.50158416}, {3000,0.51537624}, {3050,0.51658416}, {3100,0.52956436}, {3150,0.52524752}, {3200,0.53798020}, {3250,0.55359406}, {3300,0.56682178}, {3350,0.57263366}, {3400,0.58173267}, {3450,0.59185149}, {3500,0.59509901}, {3550,0.62192079}, {3600,0.60652475}, {3650,0.63119802}, {3700,0.61785149}, {3750,0.64346535}, {3800,0.65330693}, {3850,0.68368317}, {3900,0.67974257}, {3950,0.68215842}, {4000,0.67964356}, {4050,0.70852475}, {4100,0.73114851}, {4150,0.71754455}, {4200,0.72826733}, {4250,0.75518812}, {4300,0.75308911}, {4350,0.75268317}, {4400,0.76763366}, {4450,0.77964356}, {4500,0.78169307}, {4550,0.80375248}, {4600,0.79938614}, {4650,0.79874257}, {4700,0.83063366}, {4750,0.81651485}, {4800,0.86023762}, {4850,0.83993069}, {4900,0.96048515}, {4950,0.85937624}, {5000,0.89372277}, {5050,0.88020792}, {5100,0.91147525}, {5150,0.88002970}, {5200,0.90994059}, {5250,0.92087129}, {5300,0.92889109}, {5350,0.94953465}, {5400,0.94637624}, {5450,0.95588119}, {5500,0.97582178}, {5550,0.95328713}, {5600,0.97894059}, {5650,0.99426733}, {5700,0.99142574}, {5750,1.00052475}, {5800,1.01306931}, {5850,1.02149505}, {5900,1.04459406}, {5950,1.03559406}, {6000,1.06135644}, {6050,1.1093714}, {6100,3.6551429}, {6150,1.1336000}, {6200,1.1610571}, {6250,1.1544000}, {6300,1.1261714}, {6350,1.1333714}, {6400,1.1237714}, {6450,1.1443143}, {6500,1.1484571}, {6550,1.1622857}, {6600,1.1774571}, {6650,1.1895714}, {6700,1.2046286}, {6750,1.1993429}, {6800,1.2240857}, {6850,1.2290571}, {6900,1.2453429}, {6950,1.2447143}, {7000,1.2491429}, {7050,1.2506857}, {7100,1.2787143}, {7150,1.3099143}, {7200,1.3136857}, {7250,1.3482857}, {7300,1.3660286}, {7350,1.3647429}, {7400,1.3676286}, {7450,1.3670857}, {7500,1.3668286}, {7550,1.3719429}, {7600,1.3582571}, {7650,1.3888571}, {7700,1.4464000}, {7750,1.4382286}, {7800,1.4603714}, {7850,1.4324857}, {7900,1.4356286}, {7950,1.4789714}, {8000,1.4978286}, {8050,1.4838857}, {8100,1.4866286}, {8150,1.4791429}, {8200,1.4617429}, {8250,1.5436000}, {8300,1.5139714}, {8350,1.5339714}, {8400,1.4994000}, {8450,1.5754000}, {8500,1.5542571}, {8550,1.5643143}, {8600,1.5524857}, {8650,1.6161143}, {8700,1.6088571}, {8750,1.6144000}, {8800,1.6181714}, {8850,1.6252286}, {8900,1.5980000}, {8950,1.6593429}, {9000,1.6502571}, {9050,1.6342857}, {9100,1.6920000}, {9150,1.6973429}, {9200,1.6829143}, {9250,1.6963429}, {9300,1.6935143}, {9350,1.7391714}, {9400,1.7562286}, {9450,1.7394857}, {9500,1.7771143}, {9550,1.7428857}, {9600,1.7617143}, {9650,1.7853143}, {9700,1.8157143}, {9750,1.7964286}, {9800,1.8304286}, {9850,1.8221143}, {9900,1.8528571}, {9950,1.8427143}, {10000,1.8646571}, {10100,1.8357429}, {10200,1.9304857}, {10300,1.8812571}, {10400,1.9121143}, {10500,1.8868857}, {10600,1.9558000}, {10700,1.9630286}, {10800,1.9700286}, {10900,1.9812000}, {11000,2.0397143}, {11100,2.0240286}, {11200,2.0556000}, {11300,2.0553143}, {11400,2.0920571}, {11500,2.1060286}, {11600,2.1066571}, {11700,2.1464857}, {11800,2.1485143}, {11900,2.2010571}, {12000,2.1871143}, {12100,2.2668286}, {12200,2.2572286}, {12300,2.2387714}, {12400,2.2240571}, {12500,2.2666857}, {12600,2.3287714}, {12700,2.3887429}, {12800,2.3006000}, {12900,2.3483429}, {13000,2.3759429}, {13100,2.4084571}, {13200,2.3895429}, {13300,2.4485714}, {13400,2.4141143}, {13500,2.4720857}, {13600,2.4736286}, {13700,2.4953143}, {13800,2.5260857}, {13900,2.5286857}, {14000,2.5699429}, {14100,2.5750000}, {14200,2.6229429}, {14300,2.6438286}, {14400,2.7976286}, {14500,2.6578000}, {14600,2.6505143}, {14700,2.9214571}, {14800,2.7908857}, {14900,2.8069143}, {15000,2.7421143}, {15100,2.7734286}, {15200,2.8141714}, {15300,2.8656286}, {15400,2.8770000}, {15500,2.9264000}, {15600,2.8214857}, {15700,2.9280000}, {15800,2.9658286}, {15900,3.0794286}, {16000,2.9548571}, {16100,2.9136857}, {16200,3.2548286}, {16300,2.9628571}, {16400,2.9439143}, {16500,3.0141714}, {16600,3.0992000}, {16700,3.1204571}, {16800,3.0464000}, {16900,3.1429143}, {17000,3.0794857}, {17100,3.0816857}, {17200,3.3741143}, {17300,3.1390286}, {17400,3.2512000}, {17500,3.2482571}, {17600,3.2428571}, {17700,3.2925429}, {17800,3.2834000}, {17900,3.2439714}, {18000,3.3465143}, {18100,3.2923143}, {18200,3.3584286}, {18300,3.4490571}, {18400,3.3661143}, {18500,3.4108857}, {18600,3.5229143}, {18700,3.3964000}, {18800,3.4300857}, {18900,3.4553143}, {19000,3.4650000}, {19100,3.6781143}, {19200,3.6323429}, {19300,3.5702000}, {19400,3.5562286}, {19500,3.5697143}, {19600,3.7434286}, {19700,3.6921429}, {19800,3.7392857}, {19900,3.7300000}, {20000,3.6754857}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["actual reif"]["user"] = {{1,0.00022772}, {2,0.00035644}, {3,0.00047525}, {4,0.00074257}, {5,0.00066337}, {6,0.00094059}, {7,0.00078218}, {8,0.00136634}, {9,0.00115842}, {10,0.00144554}, {11,0.00162376}, {12,0.00114851}, {13,0.00192079}, {14,0.00155446}, {15,0.00163366}, {16,0.00206931}, {17,0.00204950}, {18,0.00235644}, {19,0.00245545}, {20,0.00215842}, {21,0.00230693}, {22,0.00278218}, {23,0.00309901}, {24,0.00304950}, {25,0.00263366}, {26,0.00293069}, {27,0.00329703}, {28,0.00323762}, {29,0.00357426}, {30,0.00369307}, {31,0.00377228}, {32,0.00387129}, {33,0.00401980}, {34,0.00521782}, {35,0.00433663}, {36,0.00447525}, {37,0.00457426}, {38,0.00477228}, {39,0.00467327}, {40,0.00553465}, {41,0.00526733}, {42,0.00539604}, {43,0.00749505}, {44,0.00589109}, {45,0.00821782}, {46,0.00589109}, {47,0.00790099}, {48,0.00632673}, {49,0.00649505}, {50,0.00671287}, {51,0.00636634}, {52,0.00651485}, {53,0.00718812}, {54,0.00723762}, {55,0.00741584}, {56,0.00764356}, {57,0.00754455}, {58,0.00778218}, {59,0.00980198}, {60,0.00798020}, {61,0.00824752}, {62,0.01055446}, {63,0.00855446}, {64,0.00817822}, {65,0.00924752}, {66,0.00845545}, {67,0.00878218}, {68,0.00897030}, {69,0.00921782}, {70,0.00919802}, {71,0.00923762}, {72,0.00925743}, {73,0.01386139}, {74,0.00976238}, {75,0.00984158}, {76,0.00966337}, {77,0.01025743}, {78,0.01374257}, {79,0.01050495}, {80,0.01041584}, {81,0.01073267}, {82,0.01071287}, {83,0.01083168}, {84,0.01106931}, {85,0.01428713}, {86,0.01147525}, {87,0.01169307}, {88,0.01153465}, {89,0.01192079}, {90,0.01187129}, {91,0.01202970}, {92,0.01210891}, {93,0.01256436}, {94,0.01274257}, {95,0.01266337}, {96,0.01278218}, {97,0.01321782}, {98,0.01318812}, {99,0.01331683}, {100,0.01359406}, {101,0.01348515}, {102,0.01329703}, {103,0.01344554}, {104,0.01448515}, {105,0.01925743}, {106,0.01702970}, {107,0.01449505}, {108,0.01458416}, {109,0.01469307}, {110,0.01482178}, {111,0.01502970}, {112,0.01519802}, {113,0.01890099}, {114,0.01512871}, {115,0.01557426}, {116,0.01559406}, {117,0.01568317}, {118,0.01976238}, {119,0.01620792}, {120,0.01618812}, {121,0.01637624}, {122,0.02135644}, {123,0.01638614}, {124,0.01659406}, {125,0.01672277}, {126,0.01835644}, {127,0.01710891}, {128,0.01749505}, {129,0.02003960}, {130,0.01718812}, {131,0.01759406}, {132,0.01964356}, {133,0.01739604}, {134,0.01816832}, {135,0.01812871}, {136,0.01794059}, {137,0.02298020}, {138,0.01809901}, {139,0.01842574}, {140,0.01853465}, {141,0.01852475}, {142,0.01891089}, {143,0.01871287}, {144,0.02125743}, {145,0.01888119}, {146,0.02264356}, {147,0.01954455}, {148,0.02235644}, {149,0.01948515}, {150,0.02132673}, {151,0.02017822}, {152,0.01942574}, {153,0.01968317}, {154,0.01998020}, {155,0.02719802}, {156,0.02028713}, {157,0.02217822}, {158,0.02071287}, {159,0.02114851}, {160,0.02584158}, {161,0.02061386}, {162,0.02148515}, {163,0.02816832}, {164,0.02162376}, {165,0.02176238}, {166,0.02743564}, {167,0.02264356}, {168,0.02249505}, {169,0.02429703}, {170,0.02308911}, {171,0.02300990}, {172,0.02300990}, {173,0.02605941}, {174,0.02341584}, {175,0.02362376}, {176,0.02371287}, {177,0.02317822}, {178,0.02835644}, {179,0.02387129}, {180,0.02397030}, {181,0.02469307}, {182,0.02425743}, {183,0.02441584}, {184,0.02784158}, {185,0.03172277}, {186,0.02463366}, {187,0.02528713}, {188,0.02538614}, {189,0.02553465}, {190,0.02537624}, {191,0.02578218}, {192,0.02548515}, {193,0.02563366}, {194,0.02576238}, {195,0.02573267}, {196,0.02616832}, {197,0.02631683}, {198,0.02629703}, {199,0.02648515}, {200,0.02647525}, {201,0.02652475}, {202,0.02666337}, {203,0.02701980}, {204,0.02715842}, {205,0.02734653}, {206,0.02733663}, {207,0.02762376}, {208,0.02745545}, {209,0.03809901}, {210,0.03281188}, {211,0.02826733}, {212,0.02789109}, {213,0.02842574}, {214,0.02849505}, {215,0.03101980}, {216,0.03461386}, {217,0.02921782}, {218,0.02920792}, {219,0.02880198}, {220,0.04009901}, {221,0.03337624}, {222,0.02938614}, {223,0.03031683}, {224,0.04078218}, {225,0.03282178}, {226,0.03021782}, {227,0.03086139}, {228,0.03548515}, {229,0.03089109}, {230,0.03089109}, {231,0.03786139}, {232,0.03089109}, {233,0.03150495}, {234,0.03724752}, {235,0.03132673}, {236,0.03165347}, {237,0.03372277}, {238,0.03216832}, {239,0.03912871}, {240,0.03223762}, {241,0.03244554}, {242,0.03218812}, {243,0.03260396}, {244,0.03484158}, {245,0.03343564}, {246,0.03637624}, {247,0.03322772}, {248,0.03736634}, {249,0.03329703}, {250,0.03680198}, {251,0.03424752}, {252,0.03539604}, {253,0.03393069}, {254,0.03454455}, {255,0.04516832}, {256,0.03432673}, {257,0.04037624}, {258,0.03457426}, {259,0.03490099}, {260,0.04658416}, {261,0.03506931}, {262,0.03891089}, {263,0.03513861}, {264,0.03546535}, {265,0.04106931}, {266,0.03554455}, {267,0.03589109}, {268,0.03890099}, {269,0.05431683}, {270,0.03653465}, {271,0.03661386}, {272,0.04671287}, {273,0.03656436}, {274,0.03696040}, {275,0.03722772}, {276,0.04381188}, {277,0.05034653}, {278,0.03706931}, {279,0.03754455}, {280,0.03817822}, {281,0.04422772}, {282,0.04885149}, {283,0.03826733}, {284,0.03833663}, {285,0.03817822}, {286,0.03830693}, {287,0.03985149}, {288,0.04300990}, {289,0.04599010}, {290,0.04844554}, {291,0.05107921}, {292,0.03903960}, {293,0.03947525}, {294,0.03983168}, {295,0.03938614}, {296,0.03955446}, {297,0.03935644}, {298,0.03978218}, {299,0.04019802}, {300,0.04016832}, {301,0.04011881}, {302,0.04074257}, {303,0.04063366}, {304,0.04099010}, {305,0.05987129}, {306,0.05318812}, {307,0.05066337}, {308,0.04852475}, {309,0.04587129}, {310,0.04130693}, {311,0.04197030}, {312,0.04167327}, {313,0.04194059}, {314,0.05527723}, {315,0.05145545}, {316,0.04660396}, {317,0.04299010}, {318,0.04277228}, {319,0.04382178}, {320,0.05211881}, {321,0.04670297}, {322,0.04291089}, {323,0.04387129}, {324,0.05425743}, {325,0.04855446}, {326,0.04332673}, {327,0.04396040}, {328,0.05319802}, {329,0.04635644}, {330,0.04473267}, {331,0.06160396}, {332,0.04895050}, {333,0.04470297}, {334,0.05735644}, {335,0.04711881}, {336,0.04528713}, {337,0.05488119}, {338,0.04518812}, {339,0.06127723}, {340,0.04946535}, {341,0.04617822}, {342,0.05401980}, {343,0.04644554}, {344,0.05656436}, {345,0.04599010}, {346,0.05986139}, {347,0.04728713}, {348,0.06052475}, {349,0.04752475}, {350,0.05994059}, {351,0.04776238}, {352,0.05938614}, {353,0.04716832}, {354,0.05456436}, {355,0.04803960}, {356,0.05661386}, {357,0.04828713}, {358,0.05321782}, {359,0.06381188}, {360,0.04874257}, {361,0.05742574}, {362,0.04902970}, {363,0.05038614}, {364,0.06107921}, {365,0.04965347}, {366,0.05145545}, {367,0.06119802}, {368,0.04965347}, {369,0.04959406}, {370,0.05682178}, {371,0.06563366}, {372,0.05039604}, {373,0.05413861}, {374,0.06068317}, {375,0.05132673}, {376,0.05103960}, {377,0.05372277}, {378,0.05891089}, {379,0.06555446}, {380,0.05170297}, {381,0.05151485}, {382,0.05294059}, {383,0.05769307}, {384,0.06197030}, {385,0.06730693}, {386,0.05184158}, {387,0.05200000}, {388,0.05213861}, {389,0.05379208}, {390,0.05713861}, {391,0.05947525}, {392,0.06131683}, {393,0.06366337}, {394,0.06528713}, {395,0.06487129}, {396,0.06789109}, {397,0.06898020}, {398,0.06933663}, {399,0.07803960}, {400,0.07537624}, {401,0.07278218}, {402,0.07285149}, {403,0.07132673}, {404,0.06987129}, {405,0.06953465}, {406,0.06722772}, {407,0.06529703}, {408,0.06226733}, {409,0.06094059}, {410,0.05797030}, {411,0.05570297}, {412,0.05533663}, {413,0.05625743}, {414,0.07174257}, {415,0.07098020}, {416,0.06716832}, {417,0.06104950}, {418,0.05588119}, {419,0.05657426}, {420,0.07459406}, {421,0.06863366}, {422,0.06115842}, {423,0.05732673}, {424,0.05719802}, {425,0.06947525}, {426,0.06306931}, {427,0.05754455}, {428,0.07468317}, {429,0.06766337}, {430,0.06022772}, {431,0.05902970}, {432,0.06933663}, {433,0.06300000}, {434,0.05870297}, {435,0.07349505}, {436,0.06126733}, {437,0.05958416}, {438,0.06932673}, {439,0.06021782}, {440,0.07441584}, {441,0.06383168}, {442,0.06238614}, {443,0.06716832}, {444,0.06048515}, {445,0.07063366}, {446,0.06062376}, {447,0.07227723}, {448,0.06020792}, {449,0.07744554}, {450,0.06270297}, {451,0.08043564}, {452,0.06259406}, {453,0.07641584}, {454,0.06143564}, {455,0.07450495}, {456,0.06147525}, {457,0.07147525}, {458,0.06207921}, {459,0.06655446}, {460,0.07720792}, {461,0.06249505}, {462,0.07168317}, {463,0.08137624}, {464,0.06533663}, {465,0.07494059}, {466,0.06281188}, {467,0.06917822}, {468,0.07782178}, {469,0.06327723}, {470,0.06646535}, {471,0.07311881}, {472,0.08296040}, {473,0.06433663}, {474,0.06978218}, {475,0.07681188}, {476,0.08297030}, {477,0.06472277}, {478,0.06919802}, {479,0.07545545}, {480,0.08327723}, {481,0.06472277}, {482,0.06481188}, {483,0.07079208}, {484,0.07582178}, {485,0.07661386}, {486,0.08374257}, {487,0.08679208}, {488,0.06565347}, {489,0.06726733}, {490,0.07002970}, {491,0.07347525}, {492,0.07532673}, {493,0.07946535}, {494,0.08273267}, {495,0.08194059}, {496,0.08355446}, {497,0.08159406}, {498,0.08528713}, {499,0.08600000}, {500,0.08565347}, {505,0.08499010}, {510,0.08301980}, {515,0.08007921}, {520,0.07685149}, {525,0.07138614}, {530,0.09904950}, {535,0.08499010}, {540,0.07438614}, {545,0.09131683}, {550,0.07878218}, {555,0.09132673}, {560,0.07749505}, {565,0.08752475}, {570,0.09631683}, {575,0.07907921}, {580,0.08828713}, {585,0.09383168}, {590,0.09634653}, {595,0.09829703}, {600,0.09853465}, {605,0.09800000}, {610,0.09658416}, {615,0.09481188}, {620,0.09447525}, {625,0.08623762}, {630,0.10794059}, {635,0.09826733}, {640,0.08878218}, {645,0.10487129}, {650,0.09368317}, {655,0.10669307}, {660,0.09340594}, {665,0.10549505}, {670,0.11545545}, {675,0.09595050}, {680,0.10221782}, {685,0.10694059}, {690,0.11059406}, {695,0.11367327}, {700,0.11925743}, {705,0.11830693}, {710,0.11677228}, {715,0.11350495}, {720,0.10953465}, {725,0.10621782}, {730,0.13556436}, {735,0.12018812}, {740,0.10884158}, {745,0.12488119}, {750,0.11318812}, {755,0.12543564}, {760,0.11720792}, {765,0.12513861}, {770,0.13360396}, {775,0.11499010}, {780,0.12144554}, {785,0.12622772}, {790,0.13577228}, {795,0.13879208}, {800,0.13972277}, {805,0.13786139}, {810,0.13644554}, {815,0.14680198}, {820,0.13525743}, {825,0.13026733}, {830,0.12317822}, {835,0.13900000}, {840,0.14150495}, {845,0.15270297}, {850,0.13981188}, {855,0.14980198}, {860,0.13688119}, {865,0.16122772}, {870,0.13485149}, {875,0.14263366}, {880,0.14653465}, {885,0.15178218}, {890,0.13476238}, {895,0.13610891}, {900,0.13651485}, {905,0.13696040}, {910,0.13596040}, {915,0.16352475}, {920,0.15774257}, {925,0.15160396}, {930,0.14621782}, {935,0.14806931}, {940,0.16131683}, {945,0.15010891}, {950,0.16159406}, {955,0.15024752}, {960,0.16710891}, {965,0.15031683}, {970,0.15737624}, {975,0.16550495}, {980,0.15252475}, {985,0.15735644}, {990,0.15878218}, {995,0.16217822}, {1000,0.16917822}, {1010,0.16750495}, {1020,0.16204950}, {1030,0.15559406}, {1040,0.18355446}, {1050,0.17024752}, {1060,0.18029703}, {1070,0.17956436}, {1080,0.17982178}, {1090,0.18215842}, {1100,0.18325743}, {1110,0.19400000}, {1120,0.18726733}, {1130,0.18248515}, {1140,0.18051485}, {1150,0.19567327}, {1160,0.17988119}, {1170,0.20838614}, {1180,0.20444554}, {1190,0.20478218}, {1200,0.18845545}, {1210,0.18910891}, {1220,0.20932673}, {1230,0.21352475}, {1240,0.20306931}, {1250,0.21380198}, {1260,0.21022772}, {1270,0.21584158}, {1280,0.19750495}, {1290,0.21141584}, {1300,0.20979208}, {1310,0.23034653}, {1320,0.21369307}, {1330,0.20670297}, {1340,0.23545545}, {1350,0.21864356}, {1360,0.22834653}, {1370,0.22479208}, {1380,0.22550495}, {1390,0.25405941}, {1400,0.23888119}, {1410,0.23453465}, {1420,0.24372277}, {1430,0.23258416}, {1440,0.24090099}, {1450,0.24720792}, {1460,0.23335644}, {1470,0.24767327}, {1480,0.25073267}, {1490,0.24263366}, {1500,0.23877228}, {1510,0.25815842}, {1520,0.24264356}, {1530,0.25700000}, {1540,0.25327723}, {1550,0.24636634}, {1560,0.27100000}, {1570,0.24837624}, {1580,0.26844554}, {1590,0.26348515}, {1600,0.27854455}, {1610,0.26978218}, {1620,0.28074257}, {1630,0.26738614}, {1640,0.27262376}, {1650,0.27921782}, {1660,0.28549505}, {1670,0.27864356}, {1680,0.28509901}, {1690,0.27440594}, {1700,0.29971287}, {1710,0.28013861}, {1720,0.29435644}, {1730,0.27513861}, {1740,0.30556436}, {1750,0.28666337}, {1760,0.28720792}, {1770,0.28940594}, {1780,0.30348515}, {1790,0.31541584}, {1800,0.28609901}, {1810,0.29739604}, {1820,0.29325743}, {1830,0.33694059}, {1840,0.30292079}, {1850,0.30704950}, {1860,0.31079208}, {1870,0.30623762}, {1880,0.30035644}, {1890,0.31791089}, {1900,0.33708911}, {1910,0.32127723}, {1920,0.33201980}, {1930,0.31837624}, {1940,0.31690099}, {1950,0.34783168}, {1960,0.32173267}, {1970,0.33895050}, {1980,0.32638614}, {1990,0.32576238}, {2000,0.33943564}, {2050,0.32859406}, {2100,0.34976238}, {2150,0.36141584}, {2200,0.35824752}, {2250,0.38926733}, {2300,0.40677228}, {2350,0.38383168}, {2400,0.40453465}, {2450,0.41185149}, {2500,0.42350495}, {2550,0.43360396}, {2600,0.46595050}, {2650,0.42660396}, {2700,0.44536634}, {2750,0.47183168}, {2800,0.46532673}, {2850,0.49684158}, {2900,0.50699010}, {2950,0.50080198}, {3000,0.51433663}, {3050,0.51568317}, {3100,0.52871287}, {3150,0.52424752}, {3200,0.53674257}, {3250,0.55279208}, {3300,0.56592079}, {3350,0.57180198}, {3400,0.58052475}, {3450,0.59061386}, {3500,0.59399010}, {3550,0.62096040}, {3600,0.60536634}, {3650,0.63039604}, {3700,0.61649505}, {3750,0.64231683}, {3800,0.65193069}, {3850,0.68221782}, {3900,0.67857426}, {3950,0.68087129}, {4000,0.67867327}, {4050,0.70717822}, {4100,0.72960396}, {4150,0.71628713}, {4200,0.72679208}, {4250,0.75377228}, {4300,0.75145545}, {4350,0.75149505}, {4400,0.76614851}, {4450,0.77805941}, {4500,0.78052475}, {4550,0.80221782}, {4600,0.79777228}, {4650,0.79723762}, {4700,0.82912871}, {4750,0.81463366}, {4800,0.85864356}, {4850,0.83815842}, {4900,0.95877228}, {4950,0.85743564}, {5000,0.89180198}, {5050,0.87824752}, {5100,0.90957426}, {5150,0.87811881}, {5200,0.90797030}, {5250,0.91879208}, {5300,0.92697030}, {5350,0.94758416}, {5400,0.94437624}, {5450,0.95369307}, {5500,0.97375248}, {5550,0.95143564}, {5600,0.97665347}, {5650,0.99209901}, {5700,0.98949505}, {5750,0.99852475}, {5800,1.01093069}, {5850,1.01986139}, {5900,1.04269307}, {5950,1.03394059}, {6000,1.05952475}, {6050,1.1017143}, {6100,3.6495429}, {6150,1.1324857}, {6200,1.1597714}, {6250,1.1532000}, {6300,1.1257429}, {6350,1.1322857}, {6400,1.1220857}, {6450,1.1431714}, {6500,1.1480000}, {6550,1.1615143}, {6600,1.1765143}, {6650,1.1888286}, {6700,1.2035143}, {6750,1.1964000}, {6800,1.2202000}, {6850,1.2282857}, {6900,1.2442571}, {6950,1.2426000}, {7000,1.2482857}, {7050,1.2497714}, {7100,1.2774000}, {7150,1.3074286}, {7200,1.3125143}, {7250,1.3461143}, {7300,1.3618286}, {7350,1.3602571}, {7400,1.3661143}, {7450,1.3606286}, {7500,1.3638000}, {7550,1.3696857}, {7600,1.3565143}, {7650,1.3846571}, {7700,1.4439143}, {7750,1.4361714}, {7800,1.4503429}, {7850,1.4293429}, {7900,1.4327429}, {7950,1.4774571}, {8000,1.4939143}, {8050,1.4820286}, {8100,1.4833714}, {8150,1.4770571}, {8200,1.4605429}, {8250,1.5415429}, {8300,1.5123143}, {8350,1.5323143}, {8400,1.4980286}, {8450,1.5732286}, {8500,1.5524000}, {8550,1.5628571}, {8600,1.5512000}, {8650,1.6136571}, {8700,1.6062000}, {8750,1.6126571}, {8800,1.6162857}, {8850,1.6213429}, {8900,1.5965429}, {8950,1.6568286}, {9000,1.6484571}, {9050,1.6323429}, {9100,1.6894000}, {9150,1.6953143}, {9200,1.6808000}, {9250,1.6918000}, {9300,1.6905143}, {9350,1.7365714}, {9400,1.7535143}, {9450,1.7376286}, {9500,1.7748286}, {9550,1.7408286}, {9600,1.7590286}, {9650,1.7827429}, {9700,1.8122286}, {9750,1.7938286}, {9800,1.8270000}, {9850,1.8195714}, {9900,1.8497143}, {9950,1.8399429}, {10000,1.8615143}, {10100,1.8329429}, {10200,1.9252286}, {10300,1.8786571}, {10400,1.9089429}, {10500,1.8848286}, {10600,1.9532571}, {10700,1.9613143}, {10800,1.9679143}, {10900,1.9781429}, {11000,2.0367714}, {11100,2.0207429}, {11200,2.0523714}, {11300,2.0517714}, {11400,2.0886857}, {11500,2.1022000}, {11600,2.1034571}, {11700,2.1429714}, {11800,2.1446000}, {11900,2.1975429}, {12000,2.1838286}, {12100,2.2624571}, {12200,2.2532286}, {12300,2.2349143}, {12400,2.2197429}, {12500,2.2629714}, {12600,2.3254571}, {12700,2.3855714}, {12800,2.2976571}, {12900,2.3453714}, {13000,2.3731429}, {13100,2.4041143}, {13200,2.3847714}, {13300,2.4444571}, {13400,2.4105429}, {13500,2.4683714}, {13600,2.4690857}, {13700,2.4923429}, {13800,2.5231429}, {13900,2.5264286}, {14000,2.5666571}, {14100,2.5720000}, {14200,2.6190571}, {14300,2.6410000}, {14400,2.7951429}, {14500,2.6544286}, {14600,2.6463714}, {14700,2.9185143}, {14800,2.7879714}, {14900,2.8029429}, {15000,2.7390286}, {15100,2.7682857}, {15200,2.8110857}, {15300,2.8610286}, {15400,2.8731429}, {15500,2.9224286}, {15600,2.8178571}, {15700,2.9250857}, {15800,2.9629429}, {15900,3.0757714}, {16000,2.9515714}, {16100,2.9111429}, {16200,3.2510286}, {16300,2.9602571}, {16400,2.9410286}, {16500,3.0112286}, {16600,3.0961714}, {16700,3.1167714}, {16800,3.0441429}, {16900,3.1383714}, {17000,3.0768857}, {17100,3.0791429}, {17200,3.3703143}, {17300,3.1345429}, {17400,3.2469429}, {17500,3.2429714}, {17600,3.2389429}, {17700,3.2885714}, {17800,3.2796000}, {17900,3.2402857}, {18000,3.3418857}, {18100,3.2890286}, {18200,3.3544571}, {18300,3.4436000}, {18400,3.3606286}, {18500,3.4062000}, {18600,3.5175143}, {18700,3.3921429}, {18800,3.4137714}, {18900,3.4469714}, {19000,3.4587714}, {19100,3.6627429}, {19200,3.6270000}, {19300,3.5657429}, {19400,3.5468857}, {19500,3.5530571}, {19600,3.7067429}, {19700,3.6742286}, {19800,3.7340286}, {19900,3.7237143}, {20000,3.6707429}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["actual reif"]["system"] = {{1,0.00002970}, {2,0.00000000}, {3,0.00003960}, {4,0.00000000}, {5,0.00003960}, {6,0.00000000}, {7,0.00003960}, {8,0.00007921}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00006931}, {15,0.00002970}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00003960}, {21,0.00007921}, {22,0.00000000}, {23,0.00003960}, {24,0.00000000}, {25,0.00003960}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00003960}, {32,0.00000000}, {33,0.00007921}, {34,0.00000000}, {35,0.00002970}, {36,0.00000000}, {37,0.00000000}, {38,0.00002970}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00003960}, {44,0.00000000}, {45,0.00013861}, {46,0.00003960}, {47,0.00000000}, {48,0.00002970}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00002970}, {60,0.00000000}, {61,0.00003960}, {62,0.00023762}, {63,0.00002970}, {64,0.00002970}, {65,0.00000000}, {66,0.00006931}, {67,0.00003960}, {68,0.00003960}, {69,0.00003960}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00002970}, {74,0.00002970}, {75,0.00007921}, {76,0.00000000}, {77,0.00002970}, {78,0.00010891}, {79,0.00000000}, {80,0.00003960}, {81,0.00002970}, {82,0.00007921}, {83,0.00000000}, {84,0.00000000}, {85,0.00003960}, {86,0.00007921}, {87,0.00000000}, {88,0.00003960}, {89,0.00003960}, {90,0.00003960}, {91,0.00003960}, {92,0.00000000}, {93,0.00000000}, {94,0.00003960}, {95,0.00000000}, {96,0.00000000}, {97,0.00003960}, {98,0.00000000}, {99,0.00003960}, {100,0.00000000}, {101,0.00002970}, {102,0.00007921}, {103,0.00000000}, {104,0.00007921}, {105,0.00006931}, {106,0.00007921}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00002970}, {111,0.00003960}, {112,0.00000000}, {113,0.00003960}, {114,0.00010891}, {115,0.00003960}, {116,0.00003960}, {117,0.00000000}, {118,0.00003960}, {119,0.00003960}, {120,0.00000000}, {121,0.00000000}, {122,0.00018812}, {123,0.00000000}, {124,0.00003960}, {125,0.00000000}, {126,0.00007921}, {127,0.00003960}, {128,0.00003960}, {129,0.00011881}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00003960}, {136,0.00011881}, {137,0.00003960}, {138,0.00003960}, {139,0.00000000}, {140,0.00003960}, {141,0.00000000}, {142,0.00002970}, {143,0.00007921}, {144,0.00010891}, {145,0.00000000}, {146,0.00006931}, {147,0.00000000}, {148,0.00005941}, {149,0.00000000}, {150,0.00007921}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00010891}, {156,0.00006931}, {157,0.00000000}, {158,0.00010891}, {159,0.00000000}, {160,0.00010891}, {161,0.00007921}, {162,0.00000000}, {163,0.00019802}, {164,0.00003960}, {165,0.00000000}, {166,0.00007921}, {167,0.00000000}, {168,0.00003960}, {169,0.00013861}, {170,0.00011881}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00003960}, {175,0.00003960}, {176,0.00002970}, {177,0.00002970}, {178,0.00013861}, {179,0.00003960}, {180,0.00007921}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00002970}, {185,0.00019802}, {186,0.00003960}, {187,0.00000000}, {188,0.00003960}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00007921}, {202,0.00003960}, {203,0.00000000}, {204,0.00000000}, {205,0.00003960}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00003960}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00003960}, {214,0.00000000}, {215,0.00000000}, {216,0.00003960}, {217,0.00000000}, {218,0.00003960}, {219,0.00002970}, {220,0.00018812}, {221,0.00014851}, {222,0.00003960}, {223,0.00000000}, {224,0.00030693}, {225,0.00011881}, {226,0.00003960}, {227,0.00007921}, {228,0.00011881}, {229,0.00003960}, {230,0.00003960}, {231,0.00018812}, {232,0.00000000}, {233,0.00007921}, {234,0.00006931}, {235,0.00000000}, {236,0.00000000}, {237,0.00006931}, {238,0.00000000}, {239,0.00031683}, {240,0.00000000}, {241,0.00003960}, {242,0.00000000}, {243,0.00007921}, {244,0.00003960}, {245,0.00000000}, {246,0.00000000}, {247,0.00003960}, {248,0.00000000}, {249,0.00000000}, {250,0.00003960}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00003960}, {255,0.00000000}, {256,0.00000000}, {257,0.00007921}, {258,0.00000000}, {259,0.00003960}, {260,0.00000000}, {261,0.00007921}, {262,0.00000000}, {263,0.00003960}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00007921}, {272,0.00000000}, {273,0.00000000}, {274,0.00003960}, {275,0.00000000}, {276,0.00002970}, {277,0.00000000}, {278,0.00003960}, {279,0.00000000}, {280,0.00003960}, {281,0.00003960}, {282,0.00003960}, {283,0.00003960}, {284,0.00000000}, {285,0.00000000}, {286,0.00003960}, {287,0.00002970}, {288,0.00003960}, {289,0.00000000}, {290,0.00003960}, {291,0.00003960}, {292,0.00000000}, {293,0.00000000}, {294,0.00003960}, {295,0.00000000}, {296,0.00003960}, {297,0.00000000}, {298,0.00003960}, {299,0.00000000}, {300,0.00000000}, {301,0.00003960}, {302,0.00003960}, {303,0.00003960}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00003960}, {311,0.00003960}, {312,0.00000000}, {313,0.00003960}, {314,0.00000000}, {315,0.00000000}, {316,0.00003960}, {317,0.00000000}, {318,0.00003960}, {319,0.00000000}, {320,0.00003960}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00007921}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00003960}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00003960}, {336,0.00003960}, {337,0.00011881}, {338,0.00003960}, {339,0.00000000}, {340,0.00003960}, {341,0.00005941}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00022772}, {347,0.00000000}, {348,0.00041584}, {349,0.00003960}, {350,0.00051485}, {351,0.00003960}, {352,0.00006931}, {353,0.00003960}, {354,0.00000000}, {355,0.00011881}, {356,0.00000000}, {357,0.00000000}, {358,0.00003960}, {359,0.00015842}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00006931}, {364,0.00011881}, {365,0.00000000}, {366,0.00000000}, {367,0.00015842}, {368,0.00003960}, {369,0.00003960}, {370,0.00011881}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00007921}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00003960}, {381,0.00000000}, {382,0.00003960}, {383,0.00003960}, {384,0.00000000}, {385,0.00003960}, {386,0.00000000}, {387,0.00000000}, {388,0.00003960}, {389,0.00003960}, {390,0.00003960}, {391,0.00003960}, {392,0.00000000}, {393,0.00003960}, {394,0.00000000}, {395,0.00011881}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00003960}, {400,0.00003960}, {401,0.00003960}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00007921}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00007921}, {411,0.00003960}, {412,0.00000000}, {413,0.00000000}, {414,0.00003960}, {415,0.00000000}, {416,0.00003960}, {417,0.00007921}, {418,0.00000000}, {419,0.00007921}, {420,0.00003960}, {421,0.00000000}, {422,0.00011881}, {423,0.00003960}, {424,0.00000000}, {425,0.00003960}, {426,0.00007921}, {427,0.00000000}, {428,0.00003960}, {429,0.00000000}, {430,0.00002970}, {431,0.00000000}, {432,0.00000000}, {433,0.00003960}, {434,0.00003960}, {435,0.00000000}, {436,0.00000000}, {437,0.00003960}, {438,0.00003960}, {439,0.00003960}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00003960}, {445,0.00003960}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00003960}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00003960}, {455,0.00011881}, {456,0.00003960}, {457,0.00000000}, {458,0.00003960}, {459,0.00000000}, {460,0.00003960}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003960}, {469,0.00000000}, {470,0.00000000}, {471,0.00003960}, {472,0.00003960}, {473,0.00003960}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00003960}, {479,0.00003960}, {480,0.00000000}, {481,0.00000000}, {482,0.00007921}, {483,0.00000000}, {484,0.00000000}, {485,0.00003960}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00003960}, {492,0.00000000}, {493,0.00006931}, {494,0.00003960}, {495,0.00003960}, {496,0.00000000}, {497,0.00003960}, {498,0.00003960}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00003960}, {520,0.00000000}, {525,0.00000000}, {530,0.00003960}, {535,0.00006931}, {540,0.00000000}, {545,0.00000000}, {550,0.00003960}, {555,0.00000000}, {560,0.00000000}, {565,0.00003960}, {570,0.00003960}, {575,0.00000000}, {580,0.00000000}, {585,0.00003960}, {590,0.00000000}, {595,0.00007921}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00002970}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00003960}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00003960}, {715,0.00000000}, {720,0.00000000}, {725,0.00007921}, {730,0.00003960}, {735,0.00003960}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00003960}, {760,0.00000000}, {765,0.00015842}, {770,0.00000000}, {775,0.00000000}, {780,0.00007921}, {785,0.00007921}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00003960}, {815,0.00003960}, {820,0.00000000}, {825,0.00002970}, {830,0.00000000}, {835,0.00000000}, {840,0.00007921}, {845,0.00000000}, {850,0.00003960}, {855,0.00003960}, {860,0.00003960}, {865,0.00000000}, {870,0.00003960}, {875,0.00003960}, {880,0.00000000}, {885,0.00000000}, {890,0.00007921}, {895,0.00000000}, {900,0.00003960}, {905,0.00007921}, {910,0.00000000}, {915,0.00003960}, {920,0.00000000}, {925,0.00000000}, {930,0.00007921}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00003960}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00003960}, {985,0.00003960}, {990,0.00003960}, {995,0.00000000}, {1000,0.00003960}, {1010,0.00003960}, {1020,0.00007921}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00007921}, {1130,0.00002970}, {1140,0.00000000}, {1150,0.00003960}, {1160,0.00000000}, {1170,0.00003960}, {1180,0.00003960}, {1190,0.00007921}, {1200,0.00000000}, {1210,0.00003960}, {1220,0.00000000}, {1230,0.00006931}, {1240,0.00003960}, {1250,0.00003960}, {1260,0.00000000}, {1270,0.00003960}, {1280,0.00000000}, {1290,0.00003960}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00003960}, {1340,0.00000000}, {1350,0.00011881}, {1360,0.00003960}, {1370,0.00007921}, {1380,0.00003960}, {1390,0.00003960}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00007921}, {1450,0.00000000}, {1460,0.00003960}, {1470,0.00007921}, {1480,0.00000000}, {1490,0.00010891}, {1500,0.00003960}, {1510,0.00003960}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00003960}, {1550,0.00003960}, {1560,0.00007921}, {1570,0.00011881}, {1580,0.00003960}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00007921}, {1620,0.00002970}, {1630,0.00007921}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00003960}, {1680,0.00007921}, {1690,0.00007921}, {1700,0.00000000}, {1710,0.00007921}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00007921}, {1750,0.00000000}, {1760,0.00007921}, {1770,0.00003960}, {1780,0.00003960}, {1790,0.00007921}, {1800,0.00002970}, {1810,0.00000000}, {1820,0.00011881}, {1830,0.00007921}, {1840,0.00007921}, {1850,0.00015842}, {1860,0.00007921}, {1870,0.00007921}, {1880,0.00000000}, {1890,0.00007921}, {1900,0.00003960}, {1910,0.00000000}, {1920,0.00003960}, {1930,0.00010891}, {1940,0.00011881}, {1950,0.00009901}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00003960}, {1990,0.00003960}, {2000,0.00003960}, {2050,0.00019802}, {2100,0.00007921}, {2150,0.00003960}, {2200,0.00000000}, {2250,0.00003960}, {2300,0.00003960}, {2350,0.00006931}, {2400,0.00000000}, {2450,0.00011881}, {2500,0.00003960}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00010891}, {2700,0.00007921}, {2750,0.00007921}, {2800,0.00039604}, {2850,0.00007921}, {2900,0.00011881}, {2950,0.00003960}, {3000,0.00003960}, {3050,0.00003960}, {3100,0.00015842}, {3150,0.00015842}, {3200,0.00015842}, {3250,0.00003960}, {3300,0.00010891}, {3350,0.00007921}, {3400,0.00011881}, {3450,0.00000000}, {3500,0.00007921}, {3550,0.00000000}, {3600,0.00011881}, {3650,0.00003960}, {3700,0.00026733}, {3750,0.00003960}, {3800,0.00003960}, {3850,0.00003960}, {3900,0.00003960}, {3950,0.00011881}, {4000,0.00007921}, {4050,0.00011881}, {4100,0.00027723}, {4150,0.00007921}, {4200,0.00003960}, {4250,0.00010891}, {4300,0.00011881}, {4350,0.00007921}, {4400,0.00015842}, {4450,0.00011881}, {4500,0.00003960}, {4550,0.00011881}, {4600,0.00007921}, {4650,0.00000000}, {4700,0.00007921}, {4750,0.00019802}, {4800,0.00011881}, {4850,0.00015842}, {4900,0.00047525}, {4950,0.00035644}, {5000,0.00003960}, {5050,0.00011881}, {5100,0.00018812}, {5150,0.00034653}, {5200,0.00002970}, {5250,0.00039604}, {5300,0.00003960}, {5350,0.00015842}, {5400,0.00015842}, {5450,0.00007921}, {5500,0.00010891}, {5550,0.00003960}, {5600,0.00031683}, {5650,0.00015842}, {5700,0.00015842}, {5750,0.00014851}, {5800,0.00027723}, {5850,0.00011881}, {5900,0.00007921}, {5950,0.00007921}, {6000,0.00019802}, {6050,0.0067143}, {6100,0.0027714}, {6150,0.0000000}, {6200,0.0001143}, {6250,0.0003429}, {6300,0.0000000}, {6350,0.0003429}, {6400,0.0004571}, {6450,0.0001143}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0002000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0002000}, {7000,0.0000000}, {7050,0.0001143}, {7100,0.0001143}, {7150,0.0001143}, {7200,0.0000000}, {7250,0.0003429}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0001143}, {7450,0.0001143}, {7500,0.0001143}, {7550,0.0002286}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0004286}, {7850,0.0000000}, {7900,0.0001143}, {7950,0.0000000}, {8000,0.0002286}, {8050,0.0000000}, {8100,0.0001143}, {8150,0.0001143}, {8200,0.0002000}, {8250,0.0002286}, {8300,0.0000000}, {8350,0.0001143}, {8400,0.0000000}, {8450,0.0001143}, {8500,0.0000000}, {8550,0.0002286}, {8600,0.0000000}, {8650,0.0001143}, {8700,0.0002286}, {8750,0.0000000}, {8800,0.0001143}, {8850,0.0003429}, {8900,0.0000000}, {8950,0.0002286}, {9000,0.0001143}, {9050,0.0002286}, {9100,0.0001143}, {9150,0.0000000}, {9200,0.0003143}, {9250,0.0002000}, {9300,0.0000000}, {9350,0.0002286}, {9400,0.0002286}, {9450,0.0000000}, {9500,0.0001143}, {9550,0.0001143}, {9600,0.0002286}, {9650,0.0001143}, {9700,0.0002286}, {9750,0.0001143}, {9800,0.0003429}, {9850,0.0000000}, {9900,0.0001143}, {9950,0.0001143}, {10000,0.0000000}, {10100,0.0002857}, {10200,0.0021714}, {10300,0.0001143}, {10400,0.0004571}, {10500,0.0000000}, {10600,0.0001143}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0002000}, {11000,0.0001143}, {11100,0.0001143}, {11200,0.0003143}, {11300,0.0003429}, {11400,0.0001143}, {11500,0.0003429}, {11600,0.0005714}, {11700,0.0001143}, {11800,0.0004571}, {11900,0.0001143}, {12000,0.0000000}, {12100,0.0003429}, {12200,0.0000000}, {12300,0.0003143}, {12400,0.0001143}, {12500,0.0002286}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0002286}, {12900,0.0001143}, {13000,0.0000000}, {13100,0.0002286}, {13200,0.0010286}, {13300,0.0001143}, {13400,0.0003429}, {13500,0.0001143}, {13600,0.0000000}, {13700,0.0001143}, {13800,0.0003429}, {13900,0.0001143}, {14000,0.0001143}, {14100,0.0000000}, {14200,0.0001143}, {14300,0.0002286}, {14400,0.0001143}, {14500,0.0009143}, {14600,0.0009143}, {14700,0.0006571}, {14800,0.0000000}, {14900,0.0012286}, {15000,0.0001143}, {15100,0.0020857}, {15200,0.0002286}, {15300,0.0014857}, {15400,0.0007714}, {15500,0.0008000}, {15600,0.0006857}, {15700,0.0003143}, {15800,0.0002000}, {15900,0.0008000}, {16000,0.0008000}, {16100,0.0003429}, {16200,0.0013429}, {16300,0.0004571}, {16400,0.0010286}, {16500,0.0014571}, {16600,0.0011143}, {16700,0.0012571}, {16800,0.0000857}, {16900,0.0019143}, {17000,0.0002286}, {17100,0.0002286}, {17200,0.0008000}, {17300,0.0012286}, {17400,0.0014571}, {17500,0.0022857}, {17600,0.0003429}, {17700,0.0008000}, {17800,0.0010286}, {17900,0.0002286}, {18000,0.0011143}, {18100,0.0000000}, {18200,0.0002286}, {18300,0.0016857}, {18400,0.0012571}, {18500,0.0008000}, {18600,0.0016000}, {18700,0.0009143}, {18800,0.0003429}, {18900,0.0006857}, {19000,0.0010000}, {19100,0.0003429}, {19200,0.0008000}, {19300,0.0003429}, {19400,0.0027429}, {19500,0.0009143}, {19600,0.0011143}, {19700,0.0021714}, {19800,0.0017143}, {19900,0.0039429}, {20000,0.0022571}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00100000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00140594}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00175248}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000990}, {423,0.00000000}, {424,0.00000990}, {425,0.00000990}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000990}, {431,0.00002970}, {432,0.00000000}, {433,0.00001980}, {434,0.00000000}, {435,0.00001980}, {436,0.00000000}, {437,0.00000000}, {438,0.00000990}, {439,0.00000000}, {440,0.00000000}, {441,0.00000990}, {442,0.00000990}, {443,0.00000990}, {444,0.00000990}, {445,0.00002970}, {446,0.00000990}, {447,0.00002970}, {448,0.00001980}, {449,0.00005941}, {450,0.00003960}, {451,0.00008911}, {452,0.00008911}, {453,0.00012871}, {454,0.00014851}, {455,0.00014851}, {456,0.00023762}, {457,0.00018812}, {458,0.00015842}, {459,0.00017822}, {460,0.00020792}, {461,0.00033663}, {462,0.00032673}, {463,0.00038614}, {464,0.00044554}, {465,0.00049505}, {466,0.00051485}, {467,0.00036634}, {468,0.00052475}, {469,0.00059406}, {470,0.00052475}, {471,0.00056436}, {472,0.00058416}, {473,0.00058416}, {474,0.00051485}, {475,0.00064356}, {476,0.00060396}, {477,0.00068317}, {478,0.00064356}, {479,0.00072277}, {480,0.00072277}, {481,0.00072277}, {482,0.00075248}, {483,0.00074257}, {484,0.00074257}, {485,0.00077228}, {486,0.00080198}, {487,0.00089109}, {488,0.00092079}, {489,0.00087129}, {490,0.00087129}, {491,0.00088119}, {492,0.00084158}, {493,0.00089109}, {494,0.00093069}, {495,0.00093069}, {496,0.00091089}, {497,0.00094059}, {498,0.00097030}, {499,0.00094059}, {500,0.00097030}, {505,0.00098020}, {510,0.00100000}, {515,0.00100000}, {520,0.00100000}, {525,0.00112871}, {530,0.00100000}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00100000}, {830,0.00100000}, {835,0.00100000}, {840,0.00100000}, {845,0.00100990}, {850,0.00100000}, {855,0.00100000}, {860,0.00100990}, {865,0.00100990}, {870,0.00101980}, {875,0.00100990}, {880,0.00101980}, {885,0.00102970}, {890,0.00103960}, {895,0.00105941}, {900,0.00103960}, {905,0.00104950}, {910,0.00103960}, {915,0.00106931}, {920,0.00105941}, {925,0.00104950}, {930,0.00106931}, {935,0.00115842}, {940,0.00132673}, {945,0.00153465}, {950,0.00154455}, {955,0.00154455}, {960,0.00152475}, {965,0.00160396}, {970,0.00160396}, {975,0.00167327}, {980,0.00172277}, {985,0.00175248}, {990,0.00186139}, {995,0.00192079}, {1000,0.00190099}, {1010,0.00196040}, {1020,0.00195050}, {1030,0.00200000}, {1040,0.00200000}, {1050,0.00200000}, {1060,0.00200000}, {1070,0.00522772}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200000}, {1140,0.00200000}, {1150,0.00200000}, {1160,0.00380198}, {1170,0.00200000}, {1180,0.00200000}, {1190,0.00200000}, {1200,0.00490099}, {1210,0.00414851}, {1220,0.00200000}, {1230,0.00200000}, {1240,0.00200000}, {1250,0.00200000}, {1260,0.00200000}, {1270,0.00200000}, {1280,0.00200000}, {1290,0.00200000}, {1300,0.00200000}, {1310,0.00200000}, {1320,0.00201980}, {1330,0.00200990}, {1340,0.00200000}, {1350,0.00202970}, {1360,0.00202970}, {1370,0.00204950}, {1380,0.00208911}, {1390,0.00206931}, {1400,0.00213861}, {1410,0.00221782}, {1420,0.00510891}, {1430,0.00248515}, {1440,0.00247525}, {1450,0.00248515}, {1460,0.00256436}, {1470,0.00630693}, {1480,0.00269307}, {1490,0.00280198}, {1500,0.00292079}, {1510,0.00298020}, {1520,0.00296040}, {1530,0.00298020}, {1540,0.00299010}, {1550,0.00300000}, {1560,0.00299010}, {1570,0.00300000}, {1580,0.00300000}, {1590,0.00300000}, {1600,0.00300000}, {1610,0.00300000}, {1620,0.00300000}, {1630,0.00300000}, {1640,0.00300000}, {1650,0.00300000}, {1660,0.00300000}, {1670,0.00300000}, {1680,0.00300000}, {1690,0.00300000}, {1700,0.00300000}, {1710,0.00300000}, {1720,0.00300000}, {1730,0.00618812}, {1740,0.00300000}, {1750,0.00300000}, {1760,0.00300000}, {1770,0.00300000}, {1780,0.00300000}, {1790,0.00301980}, {1800,0.00302970}, {1810,0.00670297}, {1820,0.00304950}, {1830,0.00306931}, {1840,0.00310891}, {1850,0.00316832}, {1860,0.00323762}, {1870,0.00325743}, {1880,0.00339604}, {1890,0.00344554}, {1900,0.00345545}, {1910,0.00348515}, {1920,0.00354455}, {1930,0.00361386}, {1940,0.00358416}, {1950,0.00356436}, {1960,0.00371287}, {1970,0.00379208}, {1980,0.00385149}, {1990,0.00393069}, {2000,0.00399010}, {2050,0.00400000}, {2100,0.00400000}, {2150,0.00400000}, {2200,0.00402970}, {2250,0.00405941}, {2300,0.00414851}, {2350,0.00444554}, {2400,0.00455446}, {2450,0.00492079}, {2500,0.00500000}, {2550,0.00500000}, {2600,0.00500990}, {2650,0.00505941}, {2700,0.00510891}, {2750,0.00520792}, {2800,0.00552475}, {2850,0.00559406}, {2900,0.00583168}, {2950,0.00600000}, {3000,0.00600990}, {3050,0.00603960}, {3100,0.00605941}, {3150,0.00612871}, {3200,0.00626733}, {3250,0.00653465}, {3300,0.00660396}, {3350,0.00676238}, {3400,0.01300000}, {3450,0.00700990}, {3500,0.01002970}, {3550,0.00704950}, {3600,0.01291089}, {3650,0.00739604}, {3700,0.00762376}, {3750,0.00761386}, {3800,0.00765347}, {3850,0.01420792}, {3900,0.00803960}, {3950,0.01373267}, {4000,0.00810891}, {4050,0.00819802}, {4100,0.00844554}, {4150,0.00860396}, {4200,0.00864356}, {4250,0.00870297}, {4300,0.00882178}, {4350,0.00905941}, {4400,0.01237624}, {4450,0.00916832}, {4500,0.00918812}, {4550,0.01452475}, {4600,0.00968317}, {4650,0.01899010}, {4700,0.00977228}, {4750,0.01002970}, {4800,0.01007921}, {4850,0.01013861}, {4900,0.01018812}, {4950,0.01036634}, {5000,0.01062376}, {5050,0.01075248}, {5100,0.01080198}, {5150,0.01085149}, {5200,0.02208911}, {5250,0.02032673}, {5300,0.01120792}, {5350,0.01126733}, {5400,0.01155446}, {5450,0.01175248}, {5500,0.01174257}, {5550,0.01178218}, {5600,0.01194059}, {5650,0.01203960}, {5700,0.01212871}, {5750,0.01209901}, {5800,0.01225743}, {5850,0.02559406}, {5900,0.01275248}, {5950,0.02245545}, {6000,0.01285149}, {6050,0.0140286}, {6100,0.0141714}, {6150,0.0145429}, {6200,0.0339143}, {6250,0.0141429}, {6300,0.0147429}, {6350,0.0223429}, {6400,0.0150286}, {6450,0.0152000}, {6500,0.0217429}, {6550,0.0235714}, {6600,0.0154000}, {6650,0.0317143}, {6700,0.0158857}, {6750,0.0236286}, {6800,0.0161429}, {6850,0.0163143}, {6900,0.0163714}, {6950,0.0165429}, {7000,0.0304000}, {7050,0.0160857}, {7100,0.0286571}, {7150,0.0170571}, {7200,0.0171143}, {7250,0.0173143}, {7300,0.0174000}, {7350,0.0176000}, {7400,0.0301143}, {7450,0.0178000}, {7500,0.0180000}, {7550,0.0181429}, {7600,0.0275429}, {7650,0.0269714}, {7700,0.0186857}, {7750,0.0188000}, {7800,0.0187429}, {7850,0.0190000}, {7900,0.0191714}, {7950,0.0192857}, {8000,0.0337429}, {8050,0.0194286}, {8100,0.0384857}, {8150,0.0198286}, {8200,0.0197143}, {8250,0.0199429}, {8300,0.0201143}, {8350,0.0201429}, {8400,0.0276000}, {8450,0.0205714}, {8500,0.0281143}, {8550,0.0208286}, {8600,0.0211429}, {8650,0.0485143}, {8700,0.0214571}, {8750,0.0364857}, {8800,0.0216000}, {8850,0.0216571}, {8900,0.0394000}, {8950,0.0218571}, {9000,0.0221429}, {9050,0.0397714}, {9100,0.0223429}, {9150,0.0216000}, {9200,0.0438286}, {9250,0.0330286}, {9300,0.0229429}, {9350,0.0230571}, {9400,0.0230857}, {9450,0.0539429}, {9500,0.0233714}, {9550,0.0377143}, {9600,0.0237143}, {9650,0.0238571}, {9700,0.0349429}, {9750,0.0242000}, {9800,0.0243714}, {9850,0.0452857}, {9900,0.0243714}, {9950,0.0237429}, {10000,0.0248571}, {10100,0.0249714}, {10200,0.0485714}, {10300,0.0255143}, {10400,0.0360571}, {10500,0.0477143}, {10600,0.0262000}, {10700,0.0466571}, {10800,0.0266857}, {10900,0.0270286}, {11000,0.0271714}, {11100,0.0555143}, {11200,0.0278857}, {11300,0.0280857}, {11400,0.0515714}, {11500,0.0284857}, {11600,0.0568857}, {11700,0.0292857}, {11800,0.0525143}, {11900,0.0454857}, {12000,0.0298571}, {12100,0.0531429}, {12200,0.0304571}, {12300,0.0306571}, {12400,0.0466286}, {12500,0.0299143}, {12600,0.0313143}, {12700,0.0452571}, {12800,0.0589429}, {12900,0.0321429}, {13000,0.0324571}, {13100,0.0514571}, {13200,0.0329429}, {13300,0.0334000}, {13400,0.0487429}, {13500,0.0338571}, {13600,0.0340571}, {13700,0.0588000}, {13800,0.0348571}, {13900,0.0634571}, {14000,0.0351714}, {14100,0.0712857}, {14200,0.0565429}, {14300,0.0697429}, {14400,0.0708571}, {14500,0.0563429}, {14600,0.0537429}, {14700,0.0367143}, {14800,0.0358000}, {14900,0.0375143}, {15000,0.0618286}, {15100,0.0590571}, {15200,0.0380286}, {15300,0.0386286}, {15400,0.0386857}, {15500,0.0697714}, {15600,0.0391429}, {15700,0.0658571}, {15800,0.0763429}, {15900,0.0400000}, {16000,0.0706857}, {16100,0.0404857}, {16200,0.0668857}, {16300,0.0658571}, {16400,0.0800286}, {16500,0.0644286}, {16600,0.0417429}, {16700,0.0746000}, {16800,0.0570857}, {16900,0.0831429}, {17000,0.0626000}, {17100,0.0582286}, {17200,0.0751714}, {17300,0.0438571}, {17400,0.0438286}, {17500,0.0569714}, {17600,0.0444857}, {17700,0.0446286}, {17800,0.0618571}, {17900,0.0452571}, {18000,0.0828857}, {18100,0.0618000}, {18200,0.0442857}, {18300,0.0464286}, {18400,0.0465714}, {18500,0.0468286}, {18600,0.0470571}, {18700,0.0706000}, {18800,0.0737714}, {18900,0.0929429}, {19000,0.0493429}, {19100,0.0801429}, {19200,0.0818857}, {19300,0.0489429}, {19400,0.0494571}, {19500,0.0918571}, {19600,0.0911143}, {19700,0.0956857}, {19800,0.0602857}, {19900,0.1028857}, {20000,0.0710571}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["cbv"]["user"] = {{1,0.00002970}, {2,0.00000000}, {3,0.00000000}, {4,0.00002970}, {5,0.00003960}, {6,0.00006931}, {7,0.00000000}, {8,0.00000000}, {9,0.00002970}, {10,0.00000000}, {11,0.00003960}, {12,0.00003960}, {13,0.00002970}, {14,0.00010891}, {15,0.00000000}, {16,0.00002970}, {17,0.00003960}, {18,0.00002970}, {19,0.00000000}, {20,0.00017822}, {21,0.00002970}, {22,0.00002970}, {23,0.00003960}, {24,0.00000000}, {25,0.00003960}, {26,0.00010891}, {27,0.00002970}, {28,0.00014851}, {29,0.00008911}, {30,0.00007921}, {31,0.00000000}, {32,0.00008911}, {33,0.00007921}, {34,0.00011881}, {35,0.00012871}, {36,0.00002970}, {37,0.00018812}, {38,0.00011881}, {39,0.00010891}, {40,0.00002970}, {41,0.00007921}, {42,0.00022772}, {43,0.00010891}, {44,0.00021782}, {45,0.00005941}, {46,0.00014851}, {47,0.00016832}, {48,0.00019802}, {49,0.00020792}, {50,0.00012871}, {51,0.00023762}, {52,0.00022772}, {53,0.00012871}, {54,0.00016832}, {55,0.00007921}, {56,0.00003960}, {57,0.00026733}, {58,0.00009901}, {59,0.00017822}, {60,0.00005941}, {61,0.00016832}, {62,0.00023762}, {63,0.00015842}, {64,0.00020792}, {65,0.00021782}, {66,0.00013861}, {67,0.00017822}, {68,0.00012871}, {69,0.00005941}, {70,0.00012871}, {71,0.00008911}, {72,0.00011881}, {73,0.00015842}, {74,0.00010891}, {75,0.00015842}, {76,0.00018812}, {77,0.00009901}, {78,0.00009901}, {79,0.00019802}, {80,0.00012871}, {81,0.00014851}, {82,0.00009901}, {83,0.00017822}, {84,0.00026733}, {85,0.00014851}, {86,0.00010891}, {87,0.00031683}, {88,0.00011881}, {89,0.00016832}, {90,0.00018812}, {91,0.00020792}, {92,0.00027723}, {93,0.00006931}, {94,0.00014851}, {95,0.00018812}, {96,0.00026733}, {97,0.00017822}, {98,0.00030693}, {99,0.00013861}, {100,0.00011881}, {101,0.00009901}, {102,0.00014851}, {103,0.00025743}, {104,0.00019802}, {105,0.00023762}, {106,0.00016832}, {107,0.00014851}, {108,0.00029703}, {109,0.00031683}, {110,0.00014851}, {111,0.00022772}, {112,0.00027723}, {113,0.00021782}, {114,0.00018812}, {115,0.00024752}, {116,0.00021782}, {117,0.00025743}, {118,0.00029703}, {119,0.00015842}, {120,0.00008911}, {121,0.00022772}, {122,0.00020792}, {123,0.00017822}, {124,0.00011881}, {125,0.00013861}, {126,0.00028713}, {127,0.00027723}, {128,0.00023762}, {129,0.00015842}, {130,0.00026733}, {131,0.00015842}, {132,0.00024752}, {133,0.00024752}, {134,0.00030693}, {135,0.00026733}, {136,0.00023762}, {137,0.00009901}, {138,0.00026733}, {139,0.00008911}, {140,0.00012871}, {141,0.00021782}, {142,0.00017822}, {143,0.00026733}, {144,0.00013861}, {145,0.00020792}, {146,0.00021782}, {147,0.00028713}, {148,0.00023762}, {149,0.00016832}, {150,0.00048515}, {151,0.00039604}, {152,0.00022772}, {153,0.00019802}, {154,0.00041584}, {155,0.00041584}, {156,0.00017822}, {157,0.00035644}, {158,0.00027723}, {159,0.00035644}, {160,0.00030693}, {161,0.00038614}, {162,0.00036634}, {163,0.00032673}, {164,0.00017822}, {165,0.00036634}, {166,0.00052475}, {167,0.00028713}, {168,0.00029703}, {169,0.00027723}, {170,0.00019802}, {171,0.00037624}, {172,0.00024752}, {173,0.00040594}, {174,0.00030693}, {175,0.00026733}, {176,0.00047525}, {177,0.00064356}, {178,0.00036634}, {179,0.00049505}, {180,0.00019802}, {181,0.00044554}, {182,0.00017822}, {183,0.00040594}, {184,0.00028713}, {185,0.00018812}, {186,0.00054455}, {187,0.00043564}, {188,0.00044554}, {189,0.00024752}, {190,0.00049505}, {191,0.00031683}, {192,0.00021782}, {193,0.00051485}, {194,0.00041584}, {195,0.00051485}, {196,0.00029703}, {197,0.00041584}, {198,0.00032673}, {199,0.00027723}, {200,0.00027723}, {201,0.00039604}, {202,0.00029703}, {203,0.00034653}, {204,0.00053465}, {205,0.00017822}, {206,0.00032673}, {207,0.00043564}, {208,0.00050495}, {209,0.00040594}, {210,0.00062376}, {211,0.00051485}, {212,0.00026733}, {213,0.00031683}, {214,0.00039604}, {215,0.00047525}, {216,0.00035644}, {217,0.00051485}, {218,0.00024752}, {219,0.00038614}, {220,0.00061386}, {221,0.00038614}, {222,0.00065347}, {223,0.00039604}, {224,0.00049505}, {225,0.00059406}, {226,0.00053465}, {227,0.00056436}, {228,0.00046535}, {229,0.00052475}, {230,0.00059406}, {231,0.00048515}, {232,0.00049505}, {233,0.00037624}, {234,0.00055446}, {235,0.00038614}, {236,0.00024752}, {237,0.00050495}, {238,0.00009901}, {239,0.00039604}, {240,0.00026733}, {241,0.00018812}, {242,0.00044554}, {243,0.00040594}, {244,0.00032673}, {245,0.00057426}, {246,0.00039604}, {247,0.00043564}, {248,0.00068317}, {249,0.00067327}, {250,0.00045545}, {251,0.00044554}, {252,0.00053465}, {253,0.00054455}, {254,0.00045545}, {255,0.00049505}, {256,0.00038614}, {257,0.00059406}, {258,0.00034653}, {259,0.00049505}, {260,0.00047525}, {261,0.00042574}, {262,0.00023762}, {263,0.00042574}, {264,0.00057426}, {265,0.00027723}, {266,0.00065347}, {267,0.00065347}, {268,0.00056436}, {269,0.00036634}, {270,0.00059406}, {271,0.00054455}, {272,0.00036634}, {273,0.00053465}, {274,0.00044554}, {275,0.00048515}, {276,0.00058416}, {277,0.00037624}, {278,0.00036634}, {279,0.00056436}, {280,0.00071287}, {281,0.00052475}, {282,0.00032673}, {283,0.00048515}, {284,0.00039604}, {285,0.00033663}, {286,0.00043564}, {287,0.00054455}, {288,0.00035644}, {289,0.00062376}, {290,0.00042574}, {291,0.00033663}, {292,0.00043564}, {293,0.00031683}, {294,0.00032673}, {295,0.00063366}, {296,0.00045545}, {297,0.00048515}, {298,0.00047525}, {299,0.00042574}, {300,0.00062376}, {301,0.00074257}, {302,0.00062376}, {303,0.00066337}, {304,0.00037624}, {305,0.00073267}, {306,0.00060396}, {307,0.00059406}, {308,0.00052475}, {309,0.00056436}, {310,0.00146535}, {311,0.00051485}, {312,0.00066337}, {313,0.00064356}, {314,0.00047525}, {315,0.00060396}, {316,0.00037624}, {317,0.00048515}, {318,0.00061386}, {319,0.00057426}, {320,0.00065347}, {321,0.00063366}, {322,0.00051485}, {323,0.00045545}, {324,0.00048515}, {325,0.00055446}, {326,0.00072277}, {327,0.00054455}, {328,0.00054455}, {329,0.00042574}, {330,0.00064356}, {331,0.00060396}, {332,0.00061386}, {333,0.00040594}, {334,0.00047525}, {335,0.00062376}, {336,0.00034653}, {337,0.00042574}, {338,0.00040594}, {339,0.00047525}, {340,0.00058416}, {341,0.00043564}, {342,0.00041584}, {343,0.00063366}, {344,0.00050495}, {345,0.00064356}, {346,0.00074257}, {347,0.00052475}, {348,0.00060396}, {349,0.00123762}, {350,0.00083168}, {351,0.00068317}, {352,0.00057426}, {353,0.00094059}, {354,0.00051485}, {355,0.00107921}, {356,0.00074257}, {357,0.00056436}, {358,0.00063366}, {359,0.00065347}, {360,0.00073267}, {361,0.00057426}, {362,0.00065347}, {363,0.00083168}, {364,0.00070297}, {365,0.00065347}, {366,0.00085149}, {367,0.00061386}, {368,0.00067327}, {369,0.00196040}, {370,0.00061386}, {371,0.00079208}, {372,0.00065347}, {373,0.00058416}, {374,0.00070297}, {375,0.00042574}, {376,0.00057426}, {377,0.00057426}, {378,0.00104950}, {379,0.00074257}, {380,0.00059406}, {381,0.00068317}, {382,0.00066337}, {383,0.00073267}, {384,0.00054455}, {385,0.00090099}, {386,0.00052475}, {387,0.00067327}, {388,0.00055446}, {389,0.00077228}, {390,0.00063366}, {391,0.00082178}, {392,0.00084158}, {393,0.00083168}, {394,0.00090099}, {395,0.00060396}, {396,0.00080198}, {397,0.00092079}, {398,0.00094059}, {399,0.00085149}, {400,0.00062376}, {401,0.00085149}, {402,0.00060396}, {403,0.00078218}, {404,0.00068317}, {405,0.00079208}, {406,0.00060396}, {407,0.00089109}, {408,0.00096040}, {409,0.00082178}, {410,0.00092079}, {411,0.00095050}, {412,0.00102970}, {413,0.00091089}, {414,0.00054455}, {415,0.00066337}, {416,0.00083168}, {417,0.00089109}, {418,0.00082178}, {419,0.00084158}, {420,0.00088119}, {421,0.00115842}, {422,0.00095050}, {423,0.00074257}, {424,0.00088119}, {425,0.00102970}, {426,0.00073267}, {427,0.00079208}, {428,0.00083168}, {429,0.00097030}, {430,0.00095050}, {431,0.00068317}, {432,0.00088119}, {433,0.00084158}, {434,0.00095050}, {435,0.00057426}, {436,0.00103960}, {437,0.00083168}, {438,0.00084158}, {439,0.00090099}, {440,0.00101980}, {441,0.00092079}, {442,0.00066337}, {443,0.00068317}, {444,0.00072277}, {445,0.00077228}, {446,0.00087129}, {447,0.00073267}, {448,0.00104950}, {449,0.00081188}, {450,0.00096040}, {451,0.00084158}, {452,0.00079208}, {453,0.00097030}, {454,0.00104950}, {455,0.00059406}, {456,0.00100990}, {457,0.00089109}, {458,0.00100000}, {459,0.00071287}, {460,0.00091089}, {461,0.00069307}, {462,0.00094059}, {463,0.00084158}, {464,0.00076238}, {465,0.00073267}, {466,0.00088119}, {467,0.00062376}, {468,0.00057426}, {469,0.00091089}, {470,0.00104950}, {471,0.00113861}, {472,0.00056436}, {473,0.00071287}, {474,0.00107921}, {475,0.00107921}, {476,0.00098020}, {477,0.00111881}, {478,0.00110891}, {479,0.00069307}, {480,0.00104950}, {481,0.00114851}, {482,0.00080198}, {483,0.00076238}, {484,0.00090099}, {485,0.00086139}, {486,0.00085149}, {487,0.00110891}, {488,0.00087129}, {489,0.00099010}, {490,0.00086139}, {491,0.00104950}, {492,0.00088119}, {493,0.00104950}, {494,0.00093069}, {495,0.00087129}, {496,0.00118812}, {497,0.00091089}, {498,0.00069307}, {499,0.00091089}, {500,0.00071287}, {505,0.00088119}, {510,0.00092079}, {515,0.00099010}, {520,0.00089109}, {525,0.00174257}, {530,0.00094059}, {535,0.00124752}, {540,0.00105941}, {545,0.00097030}, {550,0.00080198}, {555,0.00099010}, {560,0.00079208}, {565,0.00088119}, {570,0.00135644}, {575,0.00091089}, {580,0.00088119}, {585,0.00094059}, {590,0.00090099}, {595,0.00094059}, {600,0.00113861}, {605,0.00090099}, {610,0.00117822}, {615,0.00104950}, {620,0.00092079}, {625,0.00124752}, {630,0.00076238}, {635,0.00129703}, {640,0.00115842}, {645,0.00129703}, {650,0.00131683}, {655,0.00089109}, {660,0.00133663}, {665,0.00121782}, {670,0.00107921}, {675,0.00149505}, {680,0.00105941}, {685,0.00136634}, {690,0.00103960}, {695,0.00109901}, {700,0.00120792}, {705,0.00106931}, {710,0.00091089}, {715,0.00105941}, {720,0.00124752}, {725,0.00131683}, {730,0.00113861}, {735,0.00131683}, {740,0.00134653}, {745,0.00143564}, {750,0.00138614}, {755,0.00152475}, {760,0.00122772}, {765,0.00148515}, {770,0.00155446}, {775,0.00122772}, {780,0.00127723}, {785,0.00139604}, {790,0.00104950}, {795,0.00132673}, {800,0.00129703}, {805,0.00134653}, {810,0.00136634}, {815,0.00132673}, {820,0.00175248}, {825,0.00144554}, {830,0.00159406}, {835,0.00187129}, {840,0.00157426}, {845,0.00167327}, {850,0.00126733}, {855,0.00127723}, {860,0.00153465}, {865,0.00176238}, {870,0.00141584}, {875,0.00140594}, {880,0.00154455}, {885,0.00174257}, {890,0.00148515}, {895,0.00130693}, {900,0.00178218}, {905,0.00143564}, {910,0.00110891}, {915,0.00125743}, {920,0.00144554}, {925,0.00169307}, {930,0.00143564}, {935,0.00184158}, {940,0.00169307}, {945,0.00182178}, {950,0.00138614}, {955,0.00155446}, {960,0.00167327}, {965,0.00202970}, {970,0.00169307}, {975,0.00187129}, {980,0.00160396}, {985,0.00172277}, {990,0.00161386}, {995,0.00161386}, {1000,0.00149505}, {1010,0.00183168}, {1020,0.00195050}, {1030,0.00165347}, {1040,0.00147525}, {1050,0.00188119}, {1060,0.00177228}, {1070,0.00501980}, {1080,0.00188119}, {1090,0.00193069}, {1100,0.00197030}, {1110,0.00170297}, {1120,0.00214851}, {1130,0.00174257}, {1140,0.00214851}, {1150,0.00203960}, {1160,0.00365347}, {1170,0.00218812}, {1180,0.00194059}, {1190,0.00195050}, {1200,0.00434653}, {1210,0.00442574}, {1220,0.00232673}, {1230,0.00248515}, {1240,0.00235644}, {1250,0.00199010}, {1260,0.00220792}, {1270,0.00221782}, {1280,0.00228713}, {1290,0.00225743}, {1300,0.00220792}, {1310,0.00251485}, {1320,0.00219802}, {1330,0.00217822}, {1340,0.00244554}, {1350,0.00240594}, {1360,0.00238614}, {1370,0.00229703}, {1380,0.00247525}, {1390,0.00250495}, {1400,0.00249505}, {1410,0.00223762}, {1420,0.00508911}, {1430,0.00274257}, {1440,0.00245545}, {1450,0.00268317}, {1460,0.00268317}, {1470,0.00618812}, {1480,0.00296040}, {1490,0.00289109}, {1500,0.00292079}, {1510,0.00303960}, {1520,0.00272277}, {1530,0.00303960}, {1540,0.00300000}, {1550,0.00309901}, {1560,0.00300000}, {1570,0.00292079}, {1580,0.00311881}, {1590,0.00280198}, {1600,0.00303960}, {1610,0.00295050}, {1620,0.00302970}, {1630,0.00319802}, {1640,0.00297030}, {1650,0.00331683}, {1660,0.00321782}, {1670,0.00323762}, {1680,0.00344554}, {1690,0.00321782}, {1700,0.00313861}, {1710,0.00316832}, {1720,0.00324752}, {1730,0.00625743}, {1740,0.00354455}, {1750,0.00321782}, {1760,0.00341584}, {1770,0.00327723}, {1780,0.00328713}, {1790,0.00352475}, {1800,0.00335644}, {1810,0.00653465}, {1820,0.00345545}, {1830,0.00345545}, {1840,0.00359406}, {1850,0.00367327}, {1860,0.00354455}, {1870,0.00353465}, {1880,0.00354455}, {1890,0.00357426}, {1900,0.00355446}, {1910,0.00366337}, {1920,0.00350495}, {1930,0.00375248}, {1940,0.00368317}, {1950,0.00370297}, {1960,0.00379208}, {1970,0.00379208}, {1980,0.00389109}, {1990,0.00369307}, {2000,0.00373267}, {2050,0.00415842}, {2100,0.00402970}, {2150,0.00419802}, {2200,0.00424752}, {2250,0.00413861}, {2300,0.00441584}, {2350,0.00450495}, {2400,0.00444554}, {2450,0.00463366}, {2500,0.00465347}, {2550,0.00472277}, {2600,0.00479208}, {2650,0.00527723}, {2700,0.00521782}, {2750,0.00521782}, {2800,0.00552475}, {2850,0.00563366}, {2900,0.00594059}, {2950,0.00604950}, {3000,0.00601980}, {3050,0.00592079}, {3100,0.00609901}, {3150,0.00591089}, {3200,0.00650495}, {3250,0.00613861}, {3300,0.00646535}, {3350,0.00677228}, {3400,0.01328713}, {3450,0.00699010}, {3500,0.00999010}, {3550,0.00700990}, {3600,0.01311881}, {3650,0.00719802}, {3700,0.00739604}, {3750,0.00744554}, {3800,0.00751485}, {3850,0.01440594}, {3900,0.00770297}, {3950,0.01408911}, {4000,0.00796040}, {4050,0.00805941}, {4100,0.00813861}, {4150,0.00851485}, {4200,0.00886139}, {4250,0.00881188}, {4300,0.00898020}, {4350,0.00882178}, {4400,0.01292079}, {4450,0.00933663}, {4500,0.00923762}, {4550,0.01444554}, {4600,0.00974257}, {4650,0.01896040}, {4700,0.00971287}, {4750,0.01010891}, {4800,0.00983168}, {4850,0.01045545}, {4900,0.01037624}, {4950,0.01034653}, {5000,0.01051485}, {5050,0.01102970}, {5100,0.01062376}, {5150,0.01104950}, {5200,0.02224752}, {5250,0.01983168}, {5300,0.01110891}, {5350,0.01130693}, {5400,0.01157426}, {5450,0.01160396}, {5500,0.01161386}, {5550,0.01156436}, {5600,0.01179208}, {5650,0.01180198}, {5700,0.01210891}, {5750,0.01214851}, {5800,0.01262376}, {5850,0.02586139}, {5900,0.01268317}, {5950,0.02242574}, {6000,0.01307921}, {6050,0.0140571}, {6100,0.0144857}, {6150,0.0137429}, {6200,0.0342857}, {6250,0.0142000}, {6300,0.0140000}, {6350,0.0225429}, {6400,0.0150000}, {6450,0.0151143}, {6500,0.0223429}, {6550,0.0237143}, {6600,0.0156571}, {6650,0.0310857}, {6700,0.0160857}, {6750,0.0240571}, {6800,0.0158857}, {6850,0.0156000}, {6900,0.0166000}, {6950,0.0164286}, {7000,0.0305714}, {7050,0.0158857}, {7100,0.0288571}, {7150,0.0168000}, {7200,0.0168857}, {7250,0.0169714}, {7300,0.0169714}, {7350,0.0170571}, {7400,0.0300571}, {7450,0.0179143}, {7500,0.0175714}, {7550,0.0180286}, {7600,0.0276286}, {7650,0.0268000}, {7700,0.0186286}, {7750,0.0187429}, {7800,0.0187429}, {7850,0.0187714}, {7900,0.0190286}, {7950,0.0191714}, {8000,0.0333429}, {8050,0.0191143}, {8100,0.0386857}, {8150,0.0199429}, {8200,0.0195429}, {8250,0.0197143}, {8300,0.0197714}, {8350,0.0197429}, {8400,0.0276286}, {8450,0.0203429}, {8500,0.0281429}, {8550,0.0202286}, {8600,0.0206571}, {8650,0.0486286}, {8700,0.0214571}, {8750,0.0362286}, {8800,0.0214286}, {8850,0.0214571}, {8900,0.0391429}, {8950,0.0218571}, {9000,0.0222857}, {9050,0.0398857}, {9100,0.0224571}, {9150,0.0215714}, {9200,0.0436571}, {9250,0.0332000}, {9300,0.0234571}, {9350,0.0233714}, {9400,0.0236000}, {9450,0.0542571}, {9500,0.0239143}, {9550,0.0379714}, {9600,0.0235429}, {9650,0.0243143}, {9700,0.0348857}, {9750,0.0238571}, {9800,0.0244000}, {9850,0.0457143}, {9900,0.0249429}, {9950,0.0240857}, {10000,0.0253429}, {10100,0.0255143}, {10200,0.0484571}, {10300,0.0260571}, {10400,0.0360571}, {10500,0.0484000}, {10600,0.0266571}, {10700,0.0472286}, {10800,0.0267429}, {10900,0.0273714}, {11000,0.0275714}, {11100,0.0553143}, {11200,0.0279429}, {11300,0.0284857}, {11400,0.0518000}, {11500,0.0286000}, {11600,0.0572571}, {11700,0.0295429}, {11800,0.0518857}, {11900,0.0450571}, {12000,0.0298571}, {12100,0.0536000}, {12200,0.0304571}, {12300,0.0301714}, {12400,0.0465143}, {12500,0.0297143}, {12600,0.0311714}, {12700,0.0458571}, {12800,0.0590000}, {12900,0.0320000}, {13000,0.0321143}, {13100,0.0515429}, {13200,0.0326000}, {13300,0.0338000}, {13400,0.0492571}, {13500,0.0335429}, {13600,0.0331714}, {13700,0.0583429}, {13800,0.0342857}, {13900,0.0641714}, {14000,0.0353143}, {14100,0.0708000}, {14200,0.0563143}, {14300,0.0692857}, {14400,0.0709429}, {14500,0.0563143}, {14600,0.0541143}, {14700,0.0367714}, {14800,0.0362286}, {14900,0.0373429}, {15000,0.0614286}, {15100,0.0590286}, {15200,0.0380000}, {15300,0.0381143}, {15400,0.0382857}, {15500,0.0698857}, {15600,0.0390857}, {15700,0.0656857}, {15800,0.0759714}, {15900,0.0392857}, {16000,0.0706000}, {16100,0.0408571}, {16200,0.0664571}, {16300,0.0659429}, {16400,0.0802286}, {16500,0.0642286}, {16600,0.0417429}, {16700,0.0748857}, {16800,0.0564286}, {16900,0.0830000}, {17000,0.0629429}, {17100,0.0580571}, {17200,0.0750857}, {17300,0.0438857}, {17400,0.0440571}, {17500,0.0570286}, {17600,0.0452571}, {17700,0.0443143}, {17800,0.0617714}, {17900,0.0453429}, {18000,0.0827429}, {18100,0.0618286}, {18200,0.0444857}, {18300,0.0459143}, {18400,0.0465714}, {18500,0.0468571}, {18600,0.0466571}, {18700,0.0706857}, {18800,0.0742857}, {18900,0.0929714}, {19000,0.0481714}, {19100,0.0793429}, {19200,0.0819714}, {19300,0.0492571}, {19400,0.0486857}, {19500,0.0921143}, {19600,0.0917143}, {19700,0.0943429}, {19800,0.0601143}, {19900,0.1027143}, {20000,0.0708857}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00003960}, {12,0.00000000}, {13,0.00000000}, {14,0.00003960}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00003960}, {53,0.00000000}, {54,0.00000000}, {55,0.00002970}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00003960}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00005941}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00002970}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00006931}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00003960}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00003960}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00006931}, {152,0.00000000}, {153,0.00003960}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00003960}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00003960}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00003960}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00002970}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00003960}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00003960}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00002970}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00007921}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00003960}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00003960}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00003960}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00003960}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00002970}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00003960}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00002970}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00003960}, {286,0.00000000}, {287,0.00000000}, {288,0.00006931}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00002970}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00003960}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00003960}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00003960}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00003960}, {370,0.00000000}, {371,0.00003960}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00003960}, {413,0.00000000}, {414,0.00003960}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00007921}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00003960}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00003960}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00003960}, {492,0.00003960}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00003960}, {535,0.00000000}, {540,0.00000000}, {545,0.00003960}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00003960}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00003960}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00003960}, {785,0.00000000}, {790,0.00003960}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00007921}, {830,0.00003960}, {835,0.00003960}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00003960}, {935,0.00000000}, {940,0.00000000}, {945,0.00003960}, {950,0.00003960}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00003960}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00003960}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00003960}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00003960}, {1430,0.00000000}, {1440,0.00003960}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00003960}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00003960}, {1620,0.00000000}, {1630,0.00002970}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00003960}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00003960}, {1880,0.00003960}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00003960}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00002970}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00003960}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00003960}, {5250,0.00000000}, {5300,0.00003960}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0001143}, {6250,0.0000000}, {6300,0.0001143}, {6350,0.0002000}, {6400,0.0000857}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0001143}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0001143}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0001143}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0001143}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0003429}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0001143}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0001143}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0001143}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000857}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0002286}, {17000,0.0000000}, {17100,0.0001143}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0001143}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0001143}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0001143}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0001143}, {19600,0.0000000}, {19700,0.0001143}, {19800,0.0000000}, {19900,0.0002286}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00200990}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00200000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00001980}, {1450,0.00000000}, {1460,0.00003960}, {1470,0.00001980}, {1480,0.00000000}, {1490,0.00026733}, {1500,0.00026733}, {1510,0.00040594}, {1520,0.00046535}, {1530,0.00003960}, {1540,0.00001980}, {1550,0.00054455}, {1560,0.00004950}, {1570,0.00052475}, {1580,0.00047525}, {1590,0.00013861}, {1600,0.00004950}, {1610,0.00004950}, {1620,0.00016832}, {1630,0.00044554}, {1640,0.00098020}, {1650,0.00032673}, {1660,0.00099010}, {1670,0.00048515}, {1680,0.00100000}, {1690,0.00100000}, {1700,0.00100000}, {1710,0.00100000}, {1720,0.00100000}, {1730,0.00100000}, {1740,0.00076238}, {1750,0.00100000}, {1760,0.00100000}, {1770,0.00100000}, {1780,0.00100000}, {1790,0.00100000}, {1800,0.00100000}, {1810,0.00100000}, {1820,0.00098020}, {1830,0.00100000}, {1840,0.00100000}, {1850,0.00100000}, {1860,0.00100000}, {1870,0.00100000}, {1880,0.00100000}, {1890,0.00100000}, {1900,0.00100000}, {1910,0.00100000}, {1920,0.00100000}, {1930,0.00100000}, {1940,0.00100000}, {1950,0.00100000}, {1960,0.00100000}, {1970,0.00100000}, {1980,0.00100000}, {1990,0.00100000}, {2000,0.00100000}, {2050,0.00100000}, {2100,0.00100000}, {2150,0.00100000}, {2200,0.00100000}, {2250,0.00100000}, {2300,0.00100000}, {2350,0.00100000}, {2400,0.00100000}, {2450,0.00100000}, {2500,0.00100000}, {2550,0.00100000}, {2600,0.00100000}, {2650,0.00100000}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00269307}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00102970}, {3100,0.00101980}, {3150,0.00104950}, {3200,0.00105941}, {3250,0.00137624}, {3300,0.00135644}, {3350,0.00161386}, {3400,0.00163366}, {3450,0.00200000}, {3500,0.00200000}, {3550,0.00187129}, {3600,0.00200000}, {3650,0.00200000}, {3700,0.00200000}, {3750,0.00200000}, {3800,0.01002970}, {3850,0.00200000}, {3900,0.00200000}, {3950,0.00200000}, {4000,0.00200000}, {4050,0.00200000}, {4100,0.00200000}, {4150,0.00200000}, {4200,0.00200000}, {4250,0.00200000}, {4300,0.00200990}, {4350,0.00202970}, {4400,0.00200990}, {4450,0.00201980}, {4500,0.00202970}, {4550,0.00206931}, {4600,0.00206931}, {4650,0.00209901}, {4700,0.00214851}, {4750,0.00211881}, {4800,0.00210891}, {4850,0.00216832}, {4900,0.00218812}, {4950,0.00238614}, {5000,0.00233663}, {5050,0.00272277}, {5100,0.00272277}, {5150,0.00278218}, {5200,0.00282178}, {5250,0.00288119}, {5300,0.00292079}, {5350,0.00303960}, {5400,0.00300990}, {5450,0.00302970}, {5500,0.00302970}, {5550,0.00304950}, {5600,0.00306931}, {5650,0.00305941}, {5700,0.00305941}, {5750,0.00305941}, {5800,0.00311881}, {5850,0.00312871}, {5900,0.00308911}, {5950,0.00311881}, {6000,0.00312871}, {6050,0.0042857}, {6100,0.0043429}, {6150,0.0044286}, {6200,0.0043143}, {6250,0.0044286}, {6300,0.0098857}, {6350,0.0045429}, {6400,0.0045714}, {6450,0.0049429}, {6500,0.0046571}, {6550,0.0046286}, {6600,0.0047429}, {6650,0.0050000}, {6700,0.0051143}, {6750,0.0053429}, {6800,0.0052000}, {6850,0.0052571}, {6900,0.0052286}, {6950,0.0054286}, {7000,0.0052000}, {7050,0.0055714}, {7100,0.0055714}, {7150,0.0057714}, {7200,0.0056571}, {7250,0.0056571}, {7300,0.0055429}, {7350,0.0054857}, {7400,0.0055714}, {7450,0.0066286}, {7500,0.0053143}, {7550,0.0061429}, {7600,0.0062286}, {7650,0.0062857}, {7700,0.0061429}, {7750,0.0063714}, {7800,0.0063143}, {7850,0.0065714}, {7900,0.0064000}, {7950,0.0066571}, {8000,0.0065714}, {8050,0.0065429}, {8100,0.0063714}, {8150,0.0066286}, {8200,0.0116857}, {8250,0.0066571}, {8300,0.0070571}, {8350,0.0067429}, {8400,0.0071143}, {8450,0.0071429}, {8500,0.0138857}, {8550,0.0072571}, {8600,0.0077429}, {8650,0.0075143}, {8700,0.0073429}, {8750,0.0075429}, {8800,0.0077143}, {8850,0.0078571}, {8900,0.0076000}, {8950,0.0276000}, {9000,0.0078000}, {9050,0.0078857}, {9100,0.0079429}, {9150,0.0077143}, {9200,0.0067429}, {9250,0.0082286}, {9300,0.0081143}, {9350,0.0081143}, {9400,0.0080286}, {9450,0.0083429}, {9500,0.0082286}, {9550,0.0085143}, {9600,0.0088571}, {9650,0.0086000}, {9700,0.0170857}, {9750,0.0087143}, {9800,0.0088571}, {9850,0.0088571}, {9900,0.0089143}, {9950,0.0089143}, {10000,0.0230286}, {10100,0.0089143}, {10200,0.0089714}, {10300,0.0088857}, {10400,0.0092571}, {10500,0.0078000}, {10600,0.0095429}, {10700,0.0096571}, {10800,0.0097714}, {10900,0.0097429}, {11000,0.0097714}, {11100,0.0097714}, {11200,0.0098286}, {11300,0.0097714}, {11400,0.0098286}, {11500,0.0099714}, {11600,0.0327143}, {11700,0.0106000}, {11800,0.0105143}, {11900,0.0106857}, {12000,0.0088571}, {12100,0.0107714}, {12200,0.0107714}, {12300,0.0107714}, {12400,0.0105143}, {12500,0.0108000}, {12600,0.0108286}, {12700,0.0290571}, {12800,0.0114286}, {12900,0.0112571}, {13000,0.0116857}, {13100,0.0116286}, {13200,0.0100000}, {13300,0.0116857}, {13400,0.0117429}, {13500,0.0118286}, {13600,0.0120857}, {13700,0.0118857}, {13800,0.0120571}, {13900,0.0124000}, {14000,0.0124857}, {14100,0.0115714}, {14200,0.0125714}, {14300,0.0126571}, {14400,0.0127429}, {14500,0.0128571}, {14600,0.0281429}, {14700,0.0130286}, {14800,0.0130286}, {14900,0.0114571}, {15000,0.0133429}, {15100,0.0172000}, {15200,0.0133714}, {15300,0.0134000}, {15400,0.0134571}, {15500,0.0135429}, {15600,0.0117143}, {15700,0.0138857}, {15800,0.0404857}, {15900,0.0140000}, {16000,0.0430857}, {16100,0.0373143}, {16200,0.0142857}, {16300,0.0324571}, {16400,0.0142857}, {16500,0.0143429}, {16600,0.0144571}, {16700,0.0144857}, {16800,0.0146286}, {16900,0.0147714}, {17000,0.0212857}, {17100,0.0151714}, {17200,0.0151143}, {17300,0.0423714}, {17400,0.0153143}, {17500,0.0327714}, {17600,0.0132857}, {17700,0.0153429}, {17800,0.0155714}, {17900,0.0155143}, {18000,0.0157714}, {18100,0.0155429}, {18200,0.0155143}, {18300,0.0162571}, {18400,0.0163429}, {18500,0.0164000}, {18600,0.0250571}, {18700,0.0162857}, {18800,0.0306571}, {18900,0.0411429}, {19000,0.0166000}, {19100,0.0165714}, {19200,0.0168857}, {19300,0.0171429}, {19400,0.0176286}, {19500,0.0173429}, {19600,0.0156000}, {19700,0.0180000}, {19800,0.0172857}, {19900,0.0173143}, {20000,0.0436571}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["eval lazy"]["user"] = {{1,0.00002970}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00003960}, {6,0.00003960}, {7,0.00003960}, {8,0.00000000}, {9,0.00003960}, {10,0.00000000}, {11,0.00002970}, {12,0.00002970}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00002970}, {18,0.00002970}, {19,0.00002970}, {20,0.00007921}, {21,0.00006931}, {22,0.00007921}, {23,0.00000000}, {24,0.00000000}, {25,0.00006931}, {26,0.00003960}, {27,0.00005941}, {28,0.00009901}, {29,0.00000000}, {30,0.00000000}, {31,0.00010891}, {32,0.00000000}, {33,0.00011881}, {34,0.00000000}, {35,0.00000000}, {36,0.00002970}, {37,0.00000000}, {38,0.00010891}, {39,0.00003960}, {40,0.00002970}, {41,0.00003960}, {42,0.00005941}, {43,0.00007921}, {44,0.00002970}, {45,0.00010891}, {46,0.00006931}, {47,0.00006931}, {48,0.00000000}, {49,0.00003960}, {50,0.00006931}, {51,0.00014851}, {52,0.00000000}, {53,0.00005941}, {54,0.00002970}, {55,0.00010891}, {56,0.00000000}, {57,0.00014851}, {58,0.00012871}, {59,0.00002970}, {60,0.00006931}, {61,0.00003960}, {62,0.00002970}, {63,0.00008911}, {64,0.00015842}, {65,0.00005941}, {66,0.00006931}, {67,0.00012871}, {68,0.00000000}, {69,0.00002970}, {70,0.00013861}, {71,0.00005941}, {72,0.00000000}, {73,0.00008911}, {74,0.00009901}, {75,0.00003960}, {76,0.00014851}, {77,0.00005941}, {78,0.00005941}, {79,0.00005941}, {80,0.00005941}, {81,0.00000000}, {82,0.00006931}, {83,0.00000000}, {84,0.00008911}, {85,0.00005941}, {86,0.00005941}, {87,0.00010891}, {88,0.00006931}, {89,0.00006931}, {90,0.00005941}, {91,0.00008911}, {92,0.00002970}, {93,0.00005941}, {94,0.00008911}, {95,0.00005941}, {96,0.00002970}, {97,0.00009901}, {98,0.00008911}, {99,0.00009901}, {100,0.00006931}, {101,0.00007921}, {102,0.00011881}, {103,0.00021782}, {104,0.00003960}, {105,0.00014851}, {106,0.00014851}, {107,0.00008911}, {108,0.00006931}, {109,0.00002970}, {110,0.00006931}, {111,0.00008911}, {112,0.00008911}, {113,0.00013861}, {114,0.00006931}, {115,0.00012871}, {116,0.00012871}, {117,0.00020792}, {118,0.00005941}, {119,0.00012871}, {120,0.00009901}, {121,0.00000000}, {122,0.00016832}, {123,0.00003960}, {124,0.00017822}, {125,0.00015842}, {126,0.00000000}, {127,0.00002970}, {128,0.00014851}, {129,0.00008911}, {130,0.00009901}, {131,0.00015842}, {132,0.00017822}, {133,0.00012871}, {134,0.00008911}, {135,0.00019802}, {136,0.00013861}, {137,0.00012871}, {138,0.00007921}, {139,0.00016832}, {140,0.00009901}, {141,0.00012871}, {142,0.00011881}, {143,0.00019802}, {144,0.00003960}, {145,0.00019802}, {146,0.00005941}, {147,0.00005941}, {148,0.00009901}, {149,0.00007921}, {150,0.00010891}, {151,0.00000000}, {152,0.00014851}, {153,0.00026733}, {154,0.00005941}, {155,0.00014851}, {156,0.00017822}, {157,0.00017822}, {158,0.00017822}, {159,0.00011881}, {160,0.00009901}, {161,0.00016832}, {162,0.00027723}, {163,0.00002970}, {164,0.00016832}, {165,0.00020792}, {166,0.00021782}, {167,0.00008911}, {168,0.00024752}, {169,0.00008911}, {170,0.00006931}, {171,0.00014851}, {172,0.00010891}, {173,0.00025743}, {174,0.00013861}, {175,0.00003960}, {176,0.00009901}, {177,0.00017822}, {178,0.00013861}, {179,0.00009901}, {180,0.00009901}, {181,0.00028713}, {182,0.00024752}, {183,0.00022772}, {184,0.00013861}, {185,0.00028713}, {186,0.00007921}, {187,0.00017822}, {188,0.00016832}, {189,0.00018812}, {190,0.00019802}, {191,0.00013861}, {192,0.00016832}, {193,0.00011881}, {194,0.00018812}, {195,0.00029703}, {196,0.00000000}, {197,0.00006931}, {198,0.00022772}, {199,0.00006931}, {200,0.00010891}, {201,0.00029703}, {202,0.00005941}, {203,0.00018812}, {204,0.00016832}, {205,0.00015842}, {206,0.00017822}, {207,0.00021782}, {208,0.00014851}, {209,0.00018812}, {210,0.00023762}, {211,0.00010891}, {212,0.00029703}, {213,0.00025743}, {214,0.00006931}, {215,0.00010891}, {216,0.00019802}, {217,0.00003960}, {218,0.00028713}, {219,0.00016832}, {220,0.00010891}, {221,0.00014851}, {222,0.00026733}, {223,0.00015842}, {224,0.00005941}, {225,0.00018812}, {226,0.00007921}, {227,0.00021782}, {228,0.00025743}, {229,0.00017822}, {230,0.00030693}, {231,0.00024752}, {232,0.00033663}, {233,0.00015842}, {234,0.00013861}, {235,0.00014851}, {236,0.00040594}, {237,0.00018812}, {238,0.00019802}, {239,0.00023762}, {240,0.00025743}, {241,0.00015842}, {242,0.00013861}, {243,0.00018812}, {244,0.00024752}, {245,0.00011881}, {246,0.00014851}, {247,0.00022772}, {248,0.00015842}, {249,0.00015842}, {250,0.00023762}, {251,0.00015842}, {252,0.00003960}, {253,0.00041584}, {254,0.00005941}, {255,0.00008911}, {256,0.00017822}, {257,0.00008911}, {258,0.00027723}, {259,0.00012871}, {260,0.00016832}, {261,0.00016832}, {262,0.00015842}, {263,0.00014851}, {264,0.00015842}, {265,0.00021782}, {266,0.00026733}, {267,0.00029703}, {268,0.00033663}, {269,0.00013861}, {270,0.00020792}, {271,0.00011881}, {272,0.00017822}, {273,0.00024752}, {274,0.00002970}, {275,0.00022772}, {276,0.00014851}, {277,0.00021782}, {278,0.00014851}, {279,0.00020792}, {280,0.00006931}, {281,0.00015842}, {282,0.00030693}, {283,0.00024752}, {284,0.00010891}, {285,0.00027723}, {286,0.00013861}, {287,0.00014851}, {288,0.00038614}, {289,0.00019802}, {290,0.00011881}, {291,0.00006931}, {292,0.00006931}, {293,0.00022772}, {294,0.00022772}, {295,0.00018812}, {296,0.00018812}, {297,0.00015842}, {298,0.00025743}, {299,0.00021782}, {300,0.00008911}, {301,0.00018812}, {302,0.00011881}, {303,0.00012871}, {304,0.00032673}, {305,0.00010891}, {306,0.00024752}, {307,0.00022772}, {308,0.00024752}, {309,0.00019802}, {310,0.00013861}, {311,0.00021782}, {312,0.00025743}, {313,0.00014851}, {314,0.00018812}, {315,0.00018812}, {316,0.00033663}, {317,0.00012871}, {318,0.00032673}, {319,0.00032673}, {320,0.00016832}, {321,0.00021782}, {322,0.00019802}, {323,0.00027723}, {324,0.00029703}, {325,0.00031683}, {326,0.00027723}, {327,0.00016832}, {328,0.00012871}, {329,0.00027723}, {330,0.00010891}, {331,0.00024752}, {332,0.00023762}, {333,0.00025743}, {334,0.00028713}, {335,0.00037624}, {336,0.00013861}, {337,0.00021782}, {338,0.00018812}, {339,0.00025743}, {340,0.00030693}, {341,0.00025743}, {342,0.00024752}, {343,0.00018812}, {344,0.00039604}, {345,0.00028713}, {346,0.00013861}, {347,0.00018812}, {348,0.00014851}, {349,0.00037624}, {350,0.00012871}, {351,0.00029703}, {352,0.00013861}, {353,0.00040594}, {354,0.00028713}, {355,0.00029703}, {356,0.00024752}, {357,0.00024752}, {358,0.00033663}, {359,0.00045545}, {360,0.00024752}, {361,0.00034653}, {362,0.00033663}, {363,0.00029703}, {364,0.00014851}, {365,0.00046535}, {366,0.00046535}, {367,0.00006931}, {368,0.00040594}, {369,0.00027723}, {370,0.00032673}, {371,0.00023762}, {372,0.00025743}, {373,0.00013861}, {374,0.00025743}, {375,0.00032673}, {376,0.00021782}, {377,0.00035644}, {378,0.00028713}, {379,0.00032673}, {380,0.00026733}, {381,0.00025743}, {382,0.00032673}, {383,0.00028713}, {384,0.00024752}, {385,0.00020792}, {386,0.00033663}, {387,0.00024752}, {388,0.00054455}, {389,0.00014851}, {390,0.00021782}, {391,0.00024752}, {392,0.00018812}, {393,0.00029703}, {394,0.00030693}, {395,0.00026733}, {396,0.00018812}, {397,0.00022772}, {398,0.00020792}, {399,0.00038614}, {400,0.00026733}, {401,0.00024752}, {402,0.00017822}, {403,0.00021782}, {404,0.00026733}, {405,0.00049505}, {406,0.00040594}, {407,0.00021782}, {408,0.00017822}, {409,0.00041584}, {410,0.00017822}, {411,0.00019802}, {412,0.00029703}, {413,0.00040594}, {414,0.00021782}, {415,0.00018812}, {416,0.00018812}, {417,0.00043564}, {418,0.00018812}, {419,0.00033663}, {420,0.00021782}, {421,0.00047525}, {422,0.00041584}, {423,0.00034653}, {424,0.00022772}, {425,0.00030693}, {426,0.00011881}, {427,0.00025743}, {428,0.00023762}, {429,0.00034653}, {430,0.00028713}, {431,0.00030693}, {432,0.00009901}, {433,0.00024752}, {434,0.00021782}, {435,0.00034653}, {436,0.00018812}, {437,0.00223762}, {438,0.00028713}, {439,0.00014851}, {440,0.00045545}, {441,0.00025743}, {442,0.00021782}, {443,0.00030693}, {444,0.00054455}, {445,0.00029703}, {446,0.00058416}, {447,0.00042574}, {448,0.00023762}, {449,0.00027723}, {450,0.00028713}, {451,0.00033663}, {452,0.00041584}, {453,0.00034653}, {454,0.00025743}, {455,0.00029703}, {456,0.00037624}, {457,0.00041584}, {458,0.00029703}, {459,0.00032673}, {460,0.00022772}, {461,0.00018812}, {462,0.00032673}, {463,0.00019802}, {464,0.00022772}, {465,0.00021782}, {466,0.00038614}, {467,0.00037624}, {468,0.00045545}, {469,0.00045545}, {470,0.00026733}, {471,0.00022772}, {472,0.00037624}, {473,0.00026733}, {474,0.00043564}, {475,0.00028713}, {476,0.00023762}, {477,0.00046535}, {478,0.00020792}, {479,0.00021782}, {480,0.00042574}, {481,0.00042574}, {482,0.00042574}, {483,0.00050495}, {484,0.00042574}, {485,0.00020792}, {486,0.00023762}, {487,0.00020792}, {488,0.00039604}, {489,0.00040594}, {490,0.00021782}, {491,0.00047525}, {492,0.00029703}, {493,0.00043564}, {494,0.00051485}, {495,0.00031683}, {496,0.00028713}, {497,0.00008911}, {498,0.00022772}, {499,0.00021782}, {500,0.00039604}, {505,0.00023762}, {510,0.00029703}, {515,0.00035644}, {520,0.00014851}, {525,0.00047525}, {530,0.00034653}, {535,0.00037624}, {540,0.00041584}, {545,0.00026733}, {550,0.00066337}, {555,0.00033663}, {560,0.00031683}, {565,0.00043564}, {570,0.00019802}, {575,0.00027723}, {580,0.00020792}, {585,0.00026733}, {590,0.00037624}, {595,0.00024752}, {600,0.00010891}, {605,0.00043564}, {610,0.00040594}, {615,0.00050495}, {620,0.00041584}, {625,0.00037624}, {630,0.00037624}, {635,0.00028713}, {640,0.00048515}, {645,0.00031683}, {650,0.00059406}, {655,0.00029703}, {660,0.00052475}, {665,0.00039604}, {670,0.00038614}, {675,0.00039604}, {680,0.00042574}, {685,0.00041584}, {690,0.00019802}, {695,0.00024752}, {700,0.00038614}, {705,0.00038614}, {710,0.00035644}, {715,0.00030693}, {720,0.00045545}, {725,0.00047525}, {730,0.00035644}, {735,0.00046535}, {740,0.00041584}, {745,0.00044554}, {750,0.00043564}, {755,0.00048515}, {760,0.00043564}, {765,0.00028713}, {770,0.00043564}, {775,0.00069307}, {780,0.00047525}, {785,0.00058416}, {790,0.00045545}, {795,0.00048515}, {800,0.00045545}, {805,0.00045545}, {810,0.00054455}, {815,0.00030693}, {820,0.00054455}, {825,0.00050495}, {830,0.00048515}, {835,0.00071287}, {840,0.00048515}, {845,0.00024752}, {850,0.00047525}, {855,0.00047525}, {860,0.00056436}, {865,0.00046535}, {870,0.00077228}, {875,0.00054455}, {880,0.00049505}, {885,0.00042574}, {890,0.00189109}, {895,0.00045545}, {900,0.00052475}, {905,0.00057426}, {910,0.00047525}, {915,0.00033663}, {920,0.00046535}, {925,0.00056436}, {930,0.00044554}, {935,0.00047525}, {940,0.00038614}, {945,0.00047525}, {950,0.00047525}, {955,0.00062376}, {960,0.00069307}, {965,0.00056436}, {970,0.00062376}, {975,0.00036634}, {980,0.00069307}, {985,0.00065347}, {990,0.00047525}, {995,0.00047525}, {1000,0.00037624}, {1010,0.00064356}, {1020,0.00043564}, {1030,0.00051485}, {1040,0.00054455}, {1050,0.00041584}, {1060,0.00064356}, {1070,0.00062376}, {1080,0.00046535}, {1090,0.00059406}, {1100,0.00063366}, {1110,0.00068317}, {1120,0.00070297}, {1130,0.00041584}, {1140,0.00054455}, {1150,0.00060396}, {1160,0.00068317}, {1170,0.00065347}, {1180,0.00042574}, {1190,0.00066337}, {1200,0.00084158}, {1210,0.00076238}, {1220,0.00076238}, {1230,0.00045545}, {1240,0.00089109}, {1250,0.00085149}, {1260,0.00084158}, {1270,0.00074257}, {1280,0.00075248}, {1290,0.00098020}, {1300,0.00076238}, {1310,0.00058416}, {1320,0.00065347}, {1330,0.00074257}, {1340,0.00062376}, {1350,0.00056436}, {1360,0.00070297}, {1370,0.00070297}, {1380,0.00092079}, {1390,0.00046535}, {1400,0.00070297}, {1410,0.00068317}, {1420,0.00059406}, {1430,0.00092079}, {1440,0.00059406}, {1450,0.00050495}, {1460,0.00077228}, {1470,0.00113861}, {1480,0.00088119}, {1490,0.00056436}, {1500,0.00096040}, {1510,0.00085149}, {1520,0.00100990}, {1530,0.00093069}, {1540,0.00091089}, {1550,0.00106931}, {1560,0.00086139}, {1570,0.00084158}, {1580,0.00101980}, {1590,0.00100990}, {1600,0.00076238}, {1610,0.00103960}, {1620,0.00086139}, {1630,0.00077228}, {1640,0.00095050}, {1650,0.00098020}, {1660,0.00099010}, {1670,0.00110891}, {1680,0.00116832}, {1690,0.00101980}, {1700,0.00096040}, {1710,0.00087129}, {1720,0.00105941}, {1730,0.00107921}, {1740,0.00076238}, {1750,0.00081188}, {1760,0.00107921}, {1770,0.00108911}, {1780,0.00094059}, {1790,0.00103960}, {1800,0.00106931}, {1810,0.00112871}, {1820,0.00085149}, {1830,0.00092079}, {1840,0.00116832}, {1850,0.00100990}, {1860,0.00141584}, {1870,0.00128713}, {1880,0.00086139}, {1890,0.00094059}, {1900,0.00080198}, {1910,0.00125743}, {1920,0.00099010}, {1930,0.00115842}, {1940,0.00136634}, {1950,0.00114851}, {1960,0.00083168}, {1970,0.00079208}, {1980,0.00108911}, {1990,0.00102970}, {2000,0.00103960}, {2050,0.00133663}, {2100,0.00156436}, {2150,0.00112871}, {2200,0.00123762}, {2250,0.00110891}, {2300,0.00126733}, {2350,0.00139604}, {2400,0.00061386}, {2450,0.00139604}, {2500,0.00138614}, {2550,0.00158416}, {2600,0.00116832}, {2650,0.00171287}, {2700,0.00112871}, {2750,0.00132673}, {2800,0.00265347}, {2850,0.00158416}, {2900,0.00172277}, {2950,0.00152475}, {3000,0.00171287}, {3050,0.00145545}, {3100,0.00162376}, {3150,0.00159406}, {3200,0.00189109}, {3250,0.00149505}, {3300,0.00176238}, {3350,0.00189109}, {3400,0.00171287}, {3450,0.00221782}, {3500,0.00213861}, {3550,0.00163366}, {3600,0.00207921}, {3650,0.00177228}, {3700,0.00197030}, {3750,0.00197030}, {3800,0.01043564}, {3850,0.00223762}, {3900,0.00202970}, {3950,0.00217822}, {4000,0.00198020}, {4050,0.00224752}, {4100,0.00230693}, {4150,0.00233663}, {4200,0.00237624}, {4250,0.00212871}, {4300,0.00229703}, {4350,0.00234653}, {4400,0.00212871}, {4450,0.00284158}, {4500,0.00237624}, {4550,0.00248515}, {4600,0.00236634}, {4650,0.00282178}, {4700,0.00241584}, {4750,0.00249505}, {4800,0.00265347}, {4850,0.00292079}, {4900,0.00247525}, {4950,0.00299010}, {5000,0.00264356}, {5050,0.00289109}, {5100,0.00297030}, {5150,0.00288119}, {5200,0.00298020}, {5250,0.00300000}, {5300,0.00317822}, {5350,0.00292079}, {5400,0.00302970}, {5450,0.00337624}, {5500,0.00325743}, {5550,0.00342574}, {5600,0.00346535}, {5650,0.00335644}, {5700,0.00308911}, {5750,0.00343564}, {5800,0.00342574}, {5850,0.00346535}, {5900,0.00332673}, {5950,0.00350495}, {6000,0.00371287}, {6050,0.0036857}, {6100,0.0042571}, {6150,0.0043143}, {6200,0.0042857}, {6250,0.0042286}, {6300,0.0092571}, {6350,0.0043714}, {6400,0.0047429}, {6450,0.0050571}, {6500,0.0043143}, {6550,0.0045143}, {6600,0.0049143}, {6650,0.0045429}, {6700,0.0052571}, {6750,0.0052571}, {6800,0.0045714}, {6850,0.0050000}, {6900,0.0051429}, {6950,0.0052000}, {7000,0.0051143}, {7050,0.0055714}, {7100,0.0062286}, {7150,0.0056857}, {7200,0.0062571}, {7250,0.0053714}, {7300,0.0053143}, {7350,0.0060857}, {7400,0.0052857}, {7450,0.0063714}, {7500,0.0055714}, {7550,0.0060571}, {7600,0.0064000}, {7650,0.0059429}, {7700,0.0064000}, {7750,0.0060286}, {7800,0.0061143}, {7850,0.0063143}, {7900,0.0061429}, {7950,0.0066286}, {8000,0.0065714}, {8050,0.0069714}, {8100,0.0064571}, {8150,0.0063143}, {8200,0.0122000}, {8250,0.0066286}, {8300,0.0068857}, {8350,0.0063429}, {8400,0.0070571}, {8450,0.0071714}, {8500,0.0145429}, {8550,0.0068286}, {8600,0.0070000}, {8650,0.0075143}, {8700,0.0072000}, {8750,0.0076000}, {8800,0.0080857}, {8850,0.0074286}, {8900,0.0074286}, {8950,0.0279714}, {9000,0.0081143}, {9050,0.0081143}, {9100,0.0081429}, {9150,0.0078286}, {9200,0.0066000}, {9250,0.0083714}, {9300,0.0084571}, {9350,0.0082571}, {9400,0.0085714}, {9450,0.0077143}, {9500,0.0084857}, {9550,0.0088857}, {9600,0.0082857}, {9650,0.0080571}, {9700,0.0168857}, {9750,0.0087429}, {9800,0.0093429}, {9850,0.0090000}, {9900,0.0090857}, {9950,0.0087429}, {10000,0.0234571}, {10100,0.0093143}, {10200,0.0095143}, {10300,0.0094286}, {10400,0.0090286}, {10500,0.0078857}, {10600,0.0088857}, {10700,0.0091143}, {10800,0.0090857}, {10900,0.0094000}, {11000,0.0097429}, {11100,0.0102000}, {11200,0.0099143}, {11300,0.0097429}, {11400,0.0105429}, {11500,0.0108000}, {11600,0.0327429}, {11700,0.0109714}, {11800,0.0104571}, {11900,0.0102000}, {12000,0.0090286}, {12100,0.0105714}, {12200,0.0109143}, {12300,0.0106000}, {12400,0.0106857}, {12500,0.0107714}, {12600,0.0104286}, {12700,0.0286857}, {12800,0.0110857}, {12900,0.0110000}, {13000,0.0111714}, {13100,0.0115143}, {13200,0.0103429}, {13300,0.0114571}, {13400,0.0110857}, {13500,0.0121714}, {13600,0.0119429}, {13700,0.0115429}, {13800,0.0118571}, {13900,0.0117143}, {14000,0.0116571}, {14100,0.0113429}, {14200,0.0124000}, {14300,0.0124571}, {14400,0.0126857}, {14500,0.0123143}, {14600,0.0288857}, {14700,0.0127143}, {14800,0.0131429}, {14900,0.0107714}, {15000,0.0138286}, {15100,0.0172000}, {15200,0.0135714}, {15300,0.0136857}, {15400,0.0133429}, {15500,0.0136571}, {15600,0.0118857}, {15700,0.0139143}, {15800,0.0406857}, {15900,0.0145429}, {16000,0.0432286}, {16100,0.0368857}, {16200,0.0142571}, {16300,0.0323429}, {16400,0.0146286}, {16500,0.0141429}, {16600,0.0145714}, {16700,0.0147714}, {16800,0.0147714}, {16900,0.0150000}, {17000,0.0203429}, {17100,0.0150286}, {17200,0.0145714}, {17300,0.0432286}, {17400,0.0151429}, {17500,0.0328286}, {17600,0.0137429}, {17700,0.0153714}, {17800,0.0145143}, {17900,0.0159714}, {18000,0.0157429}, {18100,0.0156000}, {18200,0.0153143}, {18300,0.0156571}, {18400,0.0164286}, {18500,0.0161429}, {18600,0.0249429}, {18700,0.0160571}, {18800,0.0307429}, {18900,0.0411143}, {19000,0.0166000}, {19100,0.0163714}, {19200,0.0168571}, {19300,0.0171714}, {19400,0.0171714}, {19500,0.0175714}, {19600,0.0155429}, {19700,0.0175143}, {19800,0.0172000}, {19900,0.0173429}, {20000,0.0432571}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00003960}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00003960}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00003960}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00003960}, {229,0.00000000}, {230,0.00000000}, {231,0.00003960}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00002970}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00003960}, {270,0.00002970}, {271,0.00000000}, {272,0.00003960}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00003960}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00003960}, {347,0.00000000}, {348,0.00000000}, {349,0.00003960}, {350,0.00000000}, {351,0.00000000}, {352,0.00003960}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00003960}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00003960}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00003960}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00002970}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00003960}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00003960}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00007921}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00003960}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00003960}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003960}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00003960}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00003960}, {1840,0.00003960}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00003960}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00003960}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00003960}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00002970}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00007921}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00003960}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00007921}, {4850,0.00000000}, {4900,0.00003960}, {4950,0.00000000}, {5000,0.00003960}, {5050,0.00000000}, {5100,0.00007921}, {5150,0.00000000}, {5200,0.00002970}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00006931}, {5450,0.00000000}, {5500,0.00003960}, {5550,0.00000000}, {5600,0.00003960}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0002000}, {6100,0.0001143}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0002286}, {7050,0.0000000}, {7100,0.0001143}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0001143}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0001143}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0001143}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0001143}, {8600,0.0001143}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0001143}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0001143}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0001143}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000857}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0001143}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0001143}, {12600,0.0001143}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0001143}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000857}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0001143}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0001143}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0001143}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0001143}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0001143}, {17100,0.0000000}, {17200,0.0002286}, {17300,0.0001143}, {17400,0.0000000}, {17500,0.0001143}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0002286}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0001143}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0001143}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00189109}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000990}, {1950,0.00000000}, {1960,0.00000990}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00434653}, {2200,0.00000990}, {2250,0.00001980}, {2300,0.00011881}, {2350,0.00042574}, {2400,0.00047525}, {2450,0.00060396}, {2500,0.00075248}, {2550,0.00100000}, {2600,0.00100000}, {2650,0.00100000}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00100000}, {3150,0.00100000}, {3200,0.00100000}, {3250,0.00100000}, {3300,0.00100000}, {3350,0.00100000}, {3400,0.00100000}, {3450,0.00100000}, {3500,0.00100000}, {3550,0.00100000}, {3600,0.00100000}, {3650,0.00100000}, {3700,0.00100000}, {3750,0.00100000}, {3800,0.00100000}, {3850,0.00100000}, {3900,0.00100000}, {3950,0.00100000}, {4000,0.00100000}, {4050,0.00100000}, {4100,0.00100000}, {4150,0.00100000}, {4200,0.00100000}, {4250,0.00100000}, {4300,0.00100000}, {4350,0.00100990}, {4400,0.00100000}, {4450,0.00101980}, {4500,0.00102970}, {4550,0.00104950}, {4600,0.00110891}, {4650,0.00112871}, {4700,0.00126733}, {4750,0.00156436}, {4800,0.00161386}, {4850,0.00163366}, {4900,0.00166337}, {4950,0.00173267}, {5000,0.00174257}, {5050,0.00179208}, {5100,0.00196040}, {5150,0.00200000}, {5200,0.00200000}, {5250,0.00200000}, {5300,0.00200000}, {5350,0.00200000}, {5400,0.00200000}, {5450,0.00200000}, {5500,0.00200000}, {5550,0.00200000}, {5600,0.00200000}, {5650,0.00200000}, {5700,0.00200000}, {5750,0.00200000}, {5800,0.00200000}, {5850,0.00200000}, {5900,0.00200000}, {5950,0.00200000}, {6000,0.00200000}, {6050,0.0020286}, {6100,0.0021143}, {6150,0.0020857}, {6200,0.0020571}, {6250,0.0021143}, {6300,0.0021714}, {6350,0.0022000}, {6400,0.0024571}, {6450,0.0023714}, {6500,0.0024000}, {6550,0.0024000}, {6600,0.0024571}, {6650,0.0026000}, {6700,0.0026000}, {6750,0.0107714}, {6800,0.0028286}, {6850,0.0027714}, {6900,0.0028857}, {6950,0.0029143}, {7000,0.0029143}, {7050,0.0029429}, {7100,0.0029714}, {7150,0.0029429}, {7200,0.0029714}, {7250,0.0029714}, {7300,0.0029714}, {7350,0.0030000}, {7400,0.0030000}, {7450,0.0030000}, {7500,0.0030000}, {7550,0.0030286}, {7600,0.0030000}, {7650,0.0030000}, {7700,0.0030286}, {7750,0.0030000}, {7800,0.0030286}, {7850,0.0030286}, {7900,0.0030286}, {7950,0.0030000}, {8000,0.0030571}, {8050,0.0030000}, {8100,0.0030286}, {8150,0.0031143}, {8200,0.0030286}, {8250,0.0031714}, {8300,0.0032000}, {8350,0.0032857}, {8400,0.0032571}, {8450,0.0034000}, {8500,0.0034571}, {8550,0.0035714}, {8600,0.0038286}, {8650,0.0036571}, {8700,0.0037429}, {8750,0.0038000}, {8800,0.0037714}, {8850,0.0038000}, {8900,0.0038000}, {8950,0.0038286}, {9000,0.0038000}, {9050,0.0038286}, {9100,0.0038571}, {9150,0.0038000}, {9200,0.0039714}, {9250,0.0154000}, {9300,0.0040000}, {9350,0.0039714}, {9400,0.0040000}, {9450,0.0040000}, {9500,0.0040000}, {9550,0.0040000}, {9600,0.0040000}, {9650,0.0040000}, {9700,0.0040000}, {9750,0.0040000}, {9800,0.0040000}, {9850,0.0040286}, {9900,0.0230571}, {9950,0.0040571}, {10000,0.0040000}, {10100,0.0164571}, {10200,0.0042286}, {10300,0.0042000}, {10400,0.0043429}, {10500,0.0044000}, {10600,0.0046571}, {10700,0.0047429}, {10800,0.0047714}, {10900,0.0047714}, {11000,0.0047714}, {11100,0.0047714}, {11200,0.0047714}, {11300,0.0048000}, {11400,0.0048286}, {11500,0.0048857}, {11600,0.0048571}, {11700,0.0049714}, {11800,0.0050000}, {11900,0.0050286}, {12000,0.0050000}, {12100,0.0050571}, {12200,0.0050857}, {12300,0.0052286}, {12400,0.0052286}, {12500,0.0054857}, {12600,0.0054857}, {12700,0.0056857}, {12800,0.0057143}, {12900,0.0057143}, {13000,0.0319143}, {13100,0.0057429}, {13200,0.0057143}, {13300,0.0056857}, {13400,0.0057429}, {13500,0.0057714}, {13600,0.0058286}, {13700,0.0058857}, {13800,0.0059143}, {13900,0.0060000}, {14000,0.0060571}, {14100,0.0061143}, {14200,0.0061143}, {14300,0.0062857}, {14400,0.0064000}, {14500,0.0326571}, {14600,0.0065143}, {14700,0.0295143}, {14800,0.0066571}, {14900,0.0067143}, {15000,0.0067143}, {15100,0.0066857}, {15200,0.0066857}, {15300,0.0066857}, {15400,0.0066857}, {15500,0.0066857}, {15600,0.0066571}, {15700,0.0251143}, {15800,0.0066857}, {15900,0.0068000}, {16000,0.0068857}, {16100,0.0071143}, {16200,0.0070571}, {16300,0.0071429}, {16400,0.0072000}, {16500,0.0073143}, {16600,0.0074857}, {16700,0.0075143}, {16800,0.0076000}, {16900,0.0075143}, {17000,0.0076286}, {17100,0.0076286}, {17200,0.0076286}, {17300,0.0076286}, {17400,0.0076571}, {17500,0.0076857}, {17600,0.0076571}, {17700,0.0076286}, {17800,0.0306571}, {17900,0.0077143}, {18000,0.0077143}, {18100,0.0078286}, {18200,0.0080000}, {18300,0.0079143}, {18400,0.0080286}, {18500,0.0082571}, {18600,0.0084000}, {18700,0.0084571}, {18800,0.0086000}, {18900,0.0086286}, {19000,0.0086000}, {19100,0.0086571}, {19200,0.0086571}, {19300,0.0086571}, {19400,0.0088286}, {19500,0.0301714}, {19600,0.0089429}, {19700,0.0088000}, {19800,0.0086571}, {19900,0.0469429}, {20000,0.0087143}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00002970}, {7,0.00000000}, {8,0.00005941}, {9,0.00000000}, {10,0.00000000}, {11,0.00003960}, {12,0.00003960}, {13,0.00003960}, {14,0.00000000}, {15,0.00003960}, {16,0.00002970}, {17,0.00005941}, {18,0.00000000}, {19,0.00000000}, {20,0.00007921}, {21,0.00003960}, {22,0.00000000}, {23,0.00007921}, {24,0.00000000}, {25,0.00003960}, {26,0.00000000}, {27,0.00003960}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00009901}, {32,0.00000000}, {33,0.00002970}, {34,0.00000000}, {35,0.00015842}, {36,0.00006931}, {37,0.00002970}, {38,0.00000000}, {39,0.00002970}, {40,0.00002970}, {41,0.00000000}, {42,0.00003960}, {43,0.00002970}, {44,0.00003960}, {45,0.00006931}, {46,0.00002970}, {47,0.00000000}, {48,0.00011881}, {49,0.00000000}, {50,0.00002970}, {51,0.00003960}, {52,0.00006931}, {53,0.00010891}, {54,0.00009901}, {55,0.00002970}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00005941}, {61,0.00005941}, {62,0.00013861}, {63,0.00002970}, {64,0.00002970}, {65,0.00000000}, {66,0.00003960}, {67,0.00000000}, {68,0.00005941}, {69,0.00000000}, {70,0.00006931}, {71,0.00009901}, {72,0.00006931}, {73,0.00002970}, {74,0.00005941}, {75,0.00008911}, {76,0.00002970}, {77,0.00008911}, {78,0.00005941}, {79,0.00005941}, {80,0.00011881}, {81,0.00005941}, {82,0.00005941}, {83,0.00013861}, {84,0.00002970}, {85,0.00002970}, {86,0.00000000}, {87,0.00002970}, {88,0.00008911}, {89,0.00003960}, {90,0.00010891}, {91,0.00002970}, {92,0.00008911}, {93,0.00008911}, {94,0.00002970}, {95,0.00002970}, {96,0.00000000}, {97,0.00000000}, {98,0.00002970}, {99,0.00005941}, {100,0.00000000}, {101,0.00009901}, {102,0.00005941}, {103,0.00000000}, {104,0.00000000}, {105,0.00005941}, {106,0.00005941}, {107,0.00009901}, {108,0.00003960}, {109,0.00005941}, {110,0.00016832}, {111,0.00002970}, {112,0.00008911}, {113,0.00002970}, {114,0.00013861}, {115,0.00018812}, {116,0.00012871}, {117,0.00002970}, {118,0.00000000}, {119,0.00005941}, {120,0.00003960}, {121,0.00005941}, {122,0.00000000}, {123,0.00003960}, {124,0.00005941}, {125,0.00010891}, {126,0.00000000}, {127,0.00002970}, {128,0.00002970}, {129,0.00003960}, {130,0.00008911}, {131,0.00009901}, {132,0.00002970}, {133,0.00012871}, {134,0.00002970}, {135,0.00002970}, {136,0.00012871}, {137,0.00008911}, {138,0.00005941}, {139,0.00000000}, {140,0.00008911}, {141,0.00005941}, {142,0.00011881}, {143,0.00005941}, {144,0.00010891}, {145,0.00010891}, {146,0.00007921}, {147,0.00000000}, {148,0.00003960}, {149,0.00006931}, {150,0.00020792}, {151,0.00006931}, {152,0.00007921}, {153,0.00021782}, {154,0.00007921}, {155,0.00009901}, {156,0.00007921}, {157,0.00000000}, {158,0.00016832}, {159,0.00002970}, {160,0.00006931}, {161,0.00017822}, {162,0.00013861}, {163,0.00020792}, {164,0.00009901}, {165,0.00010891}, {166,0.00003960}, {167,0.00010891}, {168,0.00006931}, {169,0.00006931}, {170,0.00009901}, {171,0.00007921}, {172,0.00007921}, {173,0.00013861}, {174,0.00020792}, {175,0.00018812}, {176,0.00010891}, {177,0.00017822}, {178,0.00000000}, {179,0.00002970}, {180,0.00015842}, {181,0.00010891}, {182,0.00011881}, {183,0.00014851}, {184,0.00013861}, {185,0.00009901}, {186,0.00014851}, {187,0.00015842}, {188,0.00007921}, {189,0.00007921}, {190,0.00012871}, {191,0.00010891}, {192,0.00010891}, {193,0.00005941}, {194,0.00018812}, {195,0.00007921}, {196,0.00006931}, {197,0.00013861}, {198,0.00003960}, {199,0.00010891}, {200,0.00013861}, {201,0.00021782}, {202,0.00023762}, {203,0.00007921}, {204,0.00006931}, {205,0.00002970}, {206,0.00024752}, {207,0.00011881}, {208,0.00013861}, {209,0.00019802}, {210,0.00010891}, {211,0.00013861}, {212,0.00010891}, {213,0.00027723}, {214,0.00007921}, {215,0.00011881}, {216,0.00028713}, {217,0.00014851}, {218,0.00010891}, {219,0.00026733}, {220,0.00000000}, {221,0.00003960}, {222,0.00018812}, {223,0.00010891}, {224,0.00015842}, {225,0.00007921}, {226,0.00007921}, {227,0.00006931}, {228,0.00012871}, {229,0.00012871}, {230,0.00014851}, {231,0.00000000}, {232,0.00021782}, {233,0.00007921}, {234,0.00016832}, {235,0.00023762}, {236,0.00000000}, {237,0.00016832}, {238,0.00012871}, {239,0.00007921}, {240,0.00021782}, {241,0.00017822}, {242,0.00013861}, {243,0.00025743}, {244,0.00006931}, {245,0.00016832}, {246,0.00006931}, {247,0.00019802}, {248,0.00006931}, {249,0.00021782}, {250,0.00002970}, {251,0.00025743}, {252,0.00002970}, {253,0.00003960}, {254,0.00009901}, {255,0.00005941}, {256,0.00017822}, {257,0.00010891}, {258,0.00006931}, {259,0.00012871}, {260,0.00015842}, {261,0.00014851}, {262,0.00012871}, {263,0.00013861}, {264,0.00006931}, {265,0.00003960}, {266,0.00013861}, {267,0.00011881}, {268,0.00005941}, {269,0.00011881}, {270,0.00010891}, {271,0.00022772}, {272,0.00002970}, {273,0.00020792}, {274,0.00026733}, {275,0.00009901}, {276,0.00002970}, {277,0.00009901}, {278,0.00009901}, {279,0.00025743}, {280,0.00010891}, {281,0.00006931}, {282,0.00015842}, {283,0.00002970}, {284,0.00003960}, {285,0.00009901}, {286,0.00012871}, {287,0.00023762}, {288,0.00000000}, {289,0.00015842}, {290,0.00014851}, {291,0.00016832}, {292,0.00012871}, {293,0.00029703}, {294,0.00002970}, {295,0.00018812}, {296,0.00022772}, {297,0.00009901}, {298,0.00012871}, {299,0.00017822}, {300,0.00017822}, {301,0.00006931}, {302,0.00017822}, {303,0.00016832}, {304,0.00002970}, {305,0.00011881}, {306,0.00000000}, {307,0.00005941}, {308,0.00005941}, {309,0.00015842}, {310,0.00010891}, {311,0.00018812}, {312,0.00027723}, {313,0.00014851}, {314,0.00019802}, {315,0.00005941}, {316,0.00010891}, {317,0.00016832}, {318,0.00018812}, {319,0.00014851}, {320,0.00002970}, {321,0.00019802}, {322,0.00015842}, {323,0.00013861}, {324,0.00016832}, {325,0.00009901}, {326,0.00012871}, {327,0.00015842}, {328,0.00012871}, {329,0.00014851}, {330,0.00015842}, {331,0.00012871}, {332,0.00016832}, {333,0.00018812}, {334,0.00013861}, {335,0.00017822}, {336,0.00015842}, {337,0.00016832}, {338,0.00014851}, {339,0.00016832}, {340,0.00017822}, {341,0.00022772}, {342,0.00014851}, {343,0.00016832}, {344,0.00013861}, {345,0.00025743}, {346,0.00018812}, {347,0.00016832}, {348,0.00010891}, {349,0.00002970}, {350,0.00008911}, {351,0.00013861}, {352,0.00010891}, {353,0.00025743}, {354,0.00011881}, {355,0.00020792}, {356,0.00007921}, {357,0.00029703}, {358,0.00011881}, {359,0.00017822}, {360,0.00010891}, {361,0.00022772}, {362,0.00030693}, {363,0.00013861}, {364,0.00003960}, {365,0.00018812}, {366,0.00013861}, {367,0.00023762}, {368,0.00031683}, {369,0.00036634}, {370,0.00003960}, {371,0.00011881}, {372,0.00020792}, {373,0.00024752}, {374,0.00012871}, {375,0.00019802}, {376,0.00019802}, {377,0.00008911}, {378,0.00013861}, {379,0.00014851}, {380,0.00020792}, {381,0.00033663}, {382,0.00025743}, {383,0.00016832}, {384,0.00011881}, {385,0.00022772}, {386,0.00007921}, {387,0.00016832}, {388,0.00020792}, {389,0.00034653}, {390,0.00024752}, {391,0.00030693}, {392,0.00020792}, {393,0.00010891}, {394,0.00003960}, {395,0.00021782}, {396,0.00026733}, {397,0.00024752}, {398,0.00006931}, {399,0.00010891}, {400,0.00028713}, {401,0.00025743}, {402,0.00028713}, {403,0.00019802}, {404,0.00018812}, {405,0.00003960}, {406,0.00002970}, {407,0.00023762}, {408,0.00006931}, {409,0.00005941}, {410,0.00012871}, {411,0.00018812}, {412,0.00021782}, {413,0.00019802}, {414,0.00011881}, {415,0.00026733}, {416,0.00017822}, {417,0.00012871}, {418,0.00012871}, {419,0.00021782}, {420,0.00025743}, {421,0.00002970}, {422,0.00005941}, {423,0.00024752}, {424,0.00027723}, {425,0.00029703}, {426,0.00045545}, {427,0.00034653}, {428,0.00020792}, {429,0.00015842}, {430,0.00034653}, {431,0.00013861}, {432,0.00016832}, {433,0.00014851}, {434,0.00034653}, {435,0.00018812}, {436,0.00025743}, {437,0.00028713}, {438,0.00012871}, {439,0.00023762}, {440,0.00023762}, {441,0.00007921}, {442,0.00007921}, {443,0.00014851}, {444,0.00026733}, {445,0.00009901}, {446,0.00022772}, {447,0.00018812}, {448,0.00024752}, {449,0.00024752}, {450,0.00013861}, {451,0.00018812}, {452,0.00035644}, {453,0.00010891}, {454,0.00030693}, {455,0.00010891}, {456,0.00006931}, {457,0.00014851}, {458,0.00225743}, {459,0.00021782}, {460,0.00014851}, {461,0.00031683}, {462,0.00031683}, {463,0.00020792}, {464,0.00018812}, {465,0.00027723}, {466,0.00011881}, {467,0.00031683}, {468,0.00009901}, {469,0.00020792}, {470,0.00021782}, {471,0.00036634}, {472,0.00006931}, {473,0.00025743}, {474,0.00030693}, {475,0.00023762}, {476,0.00022772}, {477,0.00010891}, {478,0.00046535}, {479,0.00008911}, {480,0.00013861}, {481,0.00010891}, {482,0.00026733}, {483,0.00026733}, {484,0.00015842}, {485,0.00028713}, {486,0.00017822}, {487,0.00010891}, {488,0.00038614}, {489,0.00021782}, {490,0.00031683}, {491,0.00009901}, {492,0.00018812}, {493,0.00022772}, {494,0.00022772}, {495,0.00032673}, {496,0.00022772}, {497,0.00013861}, {498,0.00024752}, {499,0.00016832}, {500,0.00031683}, {505,0.00007921}, {510,0.00013861}, {515,0.00014851}, {520,0.00011881}, {525,0.00025743}, {530,0.00016832}, {535,0.00034653}, {540,0.00019802}, {545,0.00018812}, {550,0.00029703}, {555,0.00022772}, {560,0.00025743}, {565,0.00012871}, {570,0.00018812}, {575,0.00026733}, {580,0.00028713}, {585,0.00030693}, {590,0.00037624}, {595,0.00015842}, {600,0.00020792}, {605,0.00023762}, {610,0.00015842}, {615,0.00030693}, {620,0.00029703}, {625,0.00025743}, {630,0.00031683}, {635,0.00025743}, {640,0.00025743}, {645,0.00025743}, {650,0.00033663}, {655,0.00022772}, {660,0.00027723}, {665,0.00030693}, {670,0.00029703}, {675,0.00026733}, {680,0.00038614}, {685,0.00033663}, {690,0.00045545}, {695,0.00030693}, {700,0.00038614}, {705,0.00027723}, {710,0.00027723}, {715,0.00016832}, {720,0.00035644}, {725,0.00043564}, {730,0.00032673}, {735,0.00048515}, {740,0.00031683}, {745,0.00031683}, {750,0.00020792}, {755,0.00022772}, {760,0.00024752}, {765,0.00024752}, {770,0.00031683}, {775,0.00035644}, {780,0.00015842}, {785,0.00035644}, {790,0.00023762}, {795,0.00040594}, {800,0.00032673}, {805,0.00027723}, {810,0.00025743}, {815,0.00029703}, {820,0.00016832}, {825,0.00020792}, {830,0.00025743}, {835,0.00037624}, {840,0.00052475}, {845,0.00041584}, {850,0.00046535}, {855,0.00041584}, {860,0.00044554}, {865,0.00018812}, {870,0.00043564}, {875,0.00018812}, {880,0.00026733}, {885,0.00034653}, {890,0.00012871}, {895,0.00045545}, {900,0.00024752}, {905,0.00039604}, {910,0.00050495}, {915,0.00035644}, {920,0.00028713}, {925,0.00032673}, {930,0.00024752}, {935,0.00037624}, {940,0.00031683}, {945,0.00048515}, {950,0.00021782}, {955,0.00042574}, {960,0.00030693}, {965,0.00056436}, {970,0.00022772}, {975,0.00038614}, {980,0.00025743}, {985,0.00037624}, {990,0.00046535}, {995,0.00041584}, {1000,0.00038614}, {1010,0.00022772}, {1020,0.00033663}, {1030,0.00037624}, {1040,0.00030693}, {1050,0.00036634}, {1060,0.00041584}, {1070,0.00033663}, {1080,0.00052475}, {1090,0.00031683}, {1100,0.00045545}, {1110,0.00040594}, {1120,0.00028713}, {1130,0.00057426}, {1140,0.00028713}, {1150,0.00049505}, {1160,0.00034653}, {1170,0.00045545}, {1180,0.00045545}, {1190,0.00059406}, {1200,0.00042574}, {1210,0.00028713}, {1220,0.00028713}, {1230,0.00059406}, {1240,0.00037624}, {1250,0.00041584}, {1260,0.00042574}, {1270,0.00060396}, {1280,0.00037624}, {1290,0.00039604}, {1300,0.00044554}, {1310,0.00057426}, {1320,0.00028713}, {1330,0.00057426}, {1340,0.00028713}, {1350,0.00079208}, {1360,0.00041584}, {1370,0.00049505}, {1380,0.00041584}, {1390,0.00058416}, {1400,0.00049505}, {1410,0.00039604}, {1420,0.00074257}, {1430,0.00052475}, {1440,0.00050495}, {1450,0.00048515}, {1460,0.00049505}, {1470,0.00040594}, {1480,0.00058416}, {1490,0.00041584}, {1500,0.00068317}, {1510,0.00049505}, {1520,0.00055446}, {1530,0.00059406}, {1540,0.00071287}, {1550,0.00055446}, {1560,0.00052475}, {1570,0.00036634}, {1580,0.00045545}, {1590,0.00050495}, {1600,0.00064356}, {1610,0.00072277}, {1620,0.00062376}, {1630,0.00075248}, {1640,0.00069307}, {1650,0.00060396}, {1660,0.00064356}, {1670,0.00068317}, {1680,0.00094059}, {1690,0.00055446}, {1700,0.00057426}, {1710,0.00061386}, {1720,0.00053465}, {1730,0.00075248}, {1740,0.00074257}, {1750,0.00047525}, {1760,0.00053465}, {1770,0.00076238}, {1780,0.00075248}, {1790,0.00047525}, {1800,0.00082178}, {1810,0.00073267}, {1820,0.00064356}, {1830,0.00089109}, {1840,0.00057426}, {1850,0.00060396}, {1860,0.00042574}, {1870,0.00047525}, {1880,0.00086139}, {1890,0.00058416}, {1900,0.00082178}, {1910,0.00089109}, {1920,0.00077228}, {1930,0.00098020}, {1940,0.00064356}, {1950,0.00064356}, {1960,0.00091089}, {1970,0.00048515}, {1980,0.00094059}, {1990,0.00091089}, {2000,0.00085149}, {2050,0.00067327}, {2100,0.00058416}, {2150,0.00441584}, {2200,0.00073267}, {2250,0.00066337}, {2300,0.00102970}, {2350,0.00086139}, {2400,0.00084158}, {2450,0.00098020}, {2500,0.00123762}, {2550,0.00067327}, {2600,0.00113861}, {2650,0.00096040}, {2700,0.00096040}, {2750,0.00097030}, {2800,0.00123762}, {2850,0.00111881}, {2900,0.00100000}, {2950,0.00096040}, {3000,0.00115842}, {3050,0.00131683}, {3100,0.00128713}, {3150,0.00122772}, {3200,0.00112871}, {3250,0.00124752}, {3300,0.00129703}, {3350,0.00143564}, {3400,0.00150495}, {3450,0.00112871}, {3500,0.00105941}, {3550,0.00171287}, {3600,0.00137624}, {3650,0.00153465}, {3700,0.00129703}, {3750,0.00133663}, {3800,0.00149505}, {3850,0.00111881}, {3900,0.00148515}, {3950,0.00147525}, {4000,0.00169307}, {4050,0.00144554}, {4100,0.00153465}, {4150,0.00141584}, {4200,0.00133663}, {4250,0.00191089}, {4300,0.00195050}, {4350,0.00179208}, {4400,0.00186139}, {4450,0.00128713}, {4500,0.00173267}, {4550,0.00215842}, {4600,0.00196040}, {4650,0.00187129}, {4700,0.00205941}, {4750,0.00210891}, {4800,0.00175248}, {4850,0.00162376}, {4900,0.00180198}, {4950,0.00165347}, {5000,0.00242574}, {5050,0.00222772}, {5100,0.00199010}, {5150,0.00205941}, {5200,0.00236634}, {5250,0.00225743}, {5300,0.00202970}, {5350,0.00210891}, {5400,0.00227723}, {5450,0.00216832}, {5500,0.00218812}, {5550,0.00211881}, {5600,0.00230693}, {5650,0.00240594}, {5700,0.00244554}, {5750,0.00212871}, {5800,0.00230693}, {5850,0.00248515}, {5900,0.00236634}, {5950,0.00242574}, {6000,0.00244554}, {6050,0.0029714}, {6100,0.0022571}, {6150,0.0022857}, {6200,0.0024000}, {6250,0.0024000}, {6300,0.0028286}, {6350,0.0025429}, {6400,0.0029429}, {6450,0.0024857}, {6500,0.0030286}, {6550,0.0027143}, {6600,0.0027714}, {6650,0.0028857}, {6700,0.0028000}, {6750,0.0111143}, {6800,0.0030286}, {6850,0.0026000}, {6900,0.0028286}, {6950,0.0028000}, {7000,0.0028857}, {7050,0.0025429}, {7100,0.0024000}, {7150,0.0025429}, {7200,0.0023143}, {7250,0.0024000}, {7300,0.0025143}, {7350,0.0028286}, {7400,0.0029143}, {7450,0.0027714}, {7500,0.0029714}, {7550,0.0028286}, {7600,0.0028571}, {7650,0.0030857}, {7700,0.0031143}, {7750,0.0034571}, {7800,0.0032571}, {7850,0.0036571}, {7900,0.0031429}, {7950,0.0034571}, {8000,0.0037143}, {8050,0.0035714}, {8100,0.0031714}, {8150,0.0034857}, {8200,0.0033143}, {8250,0.0036286}, {8300,0.0034571}, {8350,0.0036571}, {8400,0.0034286}, {8450,0.0036857}, {8500,0.0034286}, {8550,0.0038286}, {8600,0.0038286}, {8650,0.0036000}, {8700,0.0039429}, {8750,0.0035429}, {8800,0.0036571}, {8850,0.0038571}, {8900,0.0038571}, {8950,0.0039714}, {9000,0.0040571}, {9050,0.0040286}, {9100,0.0039714}, {9150,0.0043143}, {9200,0.0044571}, {9250,0.0152286}, {9300,0.0046857}, {9350,0.0040571}, {9400,0.0042286}, {9450,0.0044571}, {9500,0.0043429}, {9550,0.0041143}, {9600,0.0045429}, {9650,0.0044857}, {9700,0.0042857}, {9750,0.0040571}, {9800,0.0041714}, {9850,0.0044000}, {9900,0.0237429}, {9950,0.0048286}, {10000,0.0046286}, {10100,0.0163143}, {10200,0.0049429}, {10300,0.0039143}, {10400,0.0048857}, {10500,0.0049429}, {10600,0.0046571}, {10700,0.0048571}, {10800,0.0052286}, {10900,0.0045429}, {11000,0.0052000}, {11100,0.0046857}, {11200,0.0055429}, {11300,0.0052286}, {11400,0.0048857}, {11500,0.0048000}, {11600,0.0048000}, {11700,0.0046857}, {11800,0.0053143}, {11900,0.0059429}, {12000,0.0054286}, {12100,0.0059714}, {12200,0.0054000}, {12300,0.0048571}, {12400,0.0054000}, {12500,0.0051714}, {12600,0.0052286}, {12700,0.0055429}, {12800,0.0055714}, {12900,0.0060286}, {13000,0.0318857}, {13100,0.0064857}, {13200,0.0054857}, {13300,0.0062000}, {13400,0.0066286}, {13500,0.0057429}, {13600,0.0060000}, {13700,0.0066000}, {13800,0.0056000}, {13900,0.0065714}, {14000,0.0070286}, {14100,0.0061429}, {14200,0.0066000}, {14300,0.0061429}, {14400,0.0067714}, {14500,0.0332286}, {14600,0.0061143}, {14700,0.0294571}, {14800,0.0070857}, {14900,0.0064571}, {15000,0.0065429}, {15100,0.0069714}, {15200,0.0069143}, {15300,0.0065429}, {15400,0.0068286}, {15500,0.0071714}, {15600,0.0065714}, {15700,0.0253429}, {15800,0.0073714}, {15900,0.0074000}, {16000,0.0073429}, {16100,0.0074000}, {16200,0.0076286}, {16300,0.0072857}, {16400,0.0075143}, {16500,0.0074286}, {16600,0.0077714}, {16700,0.0078000}, {16800,0.0079714}, {16900,0.0076857}, {17000,0.0074286}, {17100,0.0076857}, {17200,0.0077429}, {17300,0.0076857}, {17400,0.0079429}, {17500,0.0083429}, {17600,0.0082286}, {17700,0.0078857}, {17800,0.0310286}, {17900,0.0081143}, {18000,0.0083143}, {18100,0.0080000}, {18200,0.0083143}, {18300,0.0087429}, {18400,0.0077429}, {18500,0.0085714}, {18600,0.0080571}, {18700,0.0090000}, {18800,0.0082286}, {18900,0.0082571}, {19000,0.0082571}, {19100,0.0089714}, {19200,0.0086571}, {19300,0.0084571}, {19400,0.0082571}, {19500,0.0296857}, {19600,0.0090571}, {19700,0.0082857}, {19800,0.0088000}, {19900,0.0468286}, {20000,0.0085143}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003960}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00003960}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00003960}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00003960}, {63,0.00003960}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00003960}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00003960}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00003960}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00003960}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00003960}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00003960}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00003960}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00003960}, {455,0.00000000}, {456,0.00003960}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00003960}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00007921}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00003960}, {1220,0.00000000}, {1230,0.00003960}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00003960}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00003960}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00003960}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00003960}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00007921}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00003960}, {2200,0.00003960}, {2250,0.00000000}, {2300,0.00003960}, {2350,0.00003960}, {2400,0.00000000}, {2450,0.00003960}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00003960}, {2900,0.00000000}, {2950,0.00003960}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00007921}, {3250,0.00003960}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00007921}, {3750,0.00000000}, {3800,0.00003960}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00002970}, {4050,0.00006931}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00007921}, {4250,0.00000000}, {4300,0.00003960}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00003960}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00003960}, {5150,0.00000000}, {5200,0.00003960}, {5250,0.00000000}, {5300,0.00002970}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00003960}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00003960}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00003960}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0001143}, {6100,0.0001143}, {6150,0.0000000}, {6200,0.0001143}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0001143}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0001143}, {7000,0.0001143}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0001143}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0001143}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0001143}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0001143}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0002286}, {10400,0.0001143}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0001143}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0001143}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0001143}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0001143}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0001143}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0001143}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0001143}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0001143}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0001143}, {18300,0.0000000}, {18400,0.0001143}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0001143}, {19400,0.0001143}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00028713}, {7,0.00100000}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00137624}, {14,0.00181188}, {15,0.00200000}, {16,0.00200000}, {17,0.00200000}, {18,0.00200000}, {19,0.00203960}, {20,0.00229703}, {21,0.00246535}, {22,0.00300000}, {23,0.00300000}, {24,0.00300000}, {25,0.00300000}, {26,0.00303960}, {27,0.00329703}, {28,0.00323762}, {29,0.00387129}, {30,0.00400000}, {31,0.00400000}, {32,0.00400000}, {33,0.00409901}, {34,0.00501980}, {35,0.00446535}, {36,0.00451485}, {37,0.00498020}, {38,0.00500000}, {39,0.00500990}, {40,0.00505941}, {41,0.00531683}, {42,0.00521782}, {43,0.00727723}, {44,0.00582178}, {45,0.00816832}, {46,0.00601980}, {47,0.00749505}, {48,0.00619802}, {49,0.00619802}, {50,0.00629703}, {51,0.00659406}, {52,0.00695050}, {53,0.00702970}, {54,0.00711881}, {55,0.00715842}, {56,0.00715842}, {57,0.00725743}, {58,0.00733663}, {59,0.00966337}, {60,0.00805941}, {61,0.00808911}, {62,0.01111881}, {63,0.00832673}, {64,0.00825743}, {65,0.00984158}, {66,0.00866337}, {67,0.00900000}, {68,0.00907921}, {69,0.00923762}, {70,0.00915842}, {71,0.00927723}, {72,0.00936634}, {73,0.01367327}, {74,0.00980198}, {75,0.01024752}, {76,0.01004950}, {77,0.01015842}, {78,0.01387129}, {79,0.01032673}, {80,0.01031683}, {81,0.01063366}, {82,0.01098020}, {83,0.01111881}, {84,0.01103960}, {85,0.01409901}, {86,0.01124752}, {87,0.01152475}, {88,0.01144554}, {89,0.01203960}, {90,0.01210891}, {91,0.01212871}, {92,0.01210891}, {93,0.01232673}, {94,0.01239604}, {95,0.01265347}, {96,0.01248515}, {97,0.01308911}, {98,0.01310891}, {99,0.01330693}, {100,0.01329703}, {101,0.01340594}, {102,0.01337624}, {103,0.01363366}, {104,0.01402970}, {105,0.02009901}, {106,0.01702970}, {107,0.01410891}, {108,0.01438614}, {109,0.01437624}, {110,0.01456436}, {111,0.01493069}, {112,0.01505941}, {113,0.01923762}, {114,0.01519802}, {115,0.01540594}, {116,0.01537624}, {117,0.01546535}, {118,0.02024752}, {119,0.01603960}, {120,0.01612871}, {121,0.01635644}, {122,0.02206931}, {123,0.01635644}, {124,0.01658416}, {125,0.01677228}, {126,0.01861386}, {127,0.01709901}, {128,0.01723762}, {129,0.02052475}, {130,0.01728713}, {131,0.01749505}, {132,0.02014851}, {133,0.01762376}, {134,0.01811881}, {135,0.01820792}, {136,0.01824752}, {137,0.02349505}, {138,0.01839604}, {139,0.01856436}, {140,0.01853465}, {141,0.01897030}, {142,0.01929703}, {143,0.01926733}, {144,0.02154455}, {145,0.01947525}, {146,0.02259406}, {147,0.01987129}, {148,0.02261386}, {149,0.02023762}, {150,0.02145545}, {151,0.02064356}, {152,0.02026733}, {153,0.02058416}, {154,0.02054455}, {155,0.02788119}, {156,0.02100000}, {157,0.02250495}, {158,0.02156436}, {159,0.02156436}, {160,0.02629703}, {161,0.02149505}, {162,0.02155446}, {163,0.02853465}, {164,0.02199010}, {165,0.02220792}, {166,0.02793069}, {167,0.02264356}, {168,0.02240594}, {169,0.02469307}, {170,0.02305941}, {171,0.02316832}, {172,0.02317822}, {173,0.02621782}, {174,0.02355446}, {175,0.02375248}, {176,0.02367327}, {177,0.02368317}, {178,0.02902970}, {179,0.02417822}, {180,0.02421782}, {181,0.02465347}, {182,0.02440594}, {183,0.02456436}, {184,0.02815842}, {185,0.03192079}, {186,0.02497030}, {187,0.02537624}, {188,0.02551485}, {189,0.02536634}, {190,0.02560396}, {191,0.02594059}, {192,0.02561386}, {193,0.02585149}, {194,0.02603960}, {195,0.02629703}, {196,0.02622772}, {197,0.02641584}, {198,0.02654455}, {199,0.02662376}, {200,0.02673267}, {201,0.02710891}, {202,0.02712871}, {203,0.02741584}, {204,0.02743564}, {205,0.02769307}, {206,0.02777228}, {207,0.02813861}, {208,0.02797030}, {209,0.03818812}, {210,0.03342574}, {211,0.02850495}, {212,0.02839604}, {213,0.02880198}, {214,0.02883168}, {215,0.03090099}, {216,0.03478218}, {217,0.02933663}, {218,0.02949505}, {219,0.02963366}, {220,0.04076238}, {221,0.03355446}, {222,0.02998020}, {223,0.03029703}, {224,0.04133663}, {225,0.03318812}, {226,0.03031683}, {227,0.03091089}, {228,0.03583168}, {229,0.03094059}, {230,0.03108911}, {231,0.03868317}, {232,0.03113861}, {233,0.03156436}, {234,0.03759406}, {235,0.03154455}, {236,0.03192079}, {237,0.03440594}, {238,0.03220792}, {239,0.03989109}, {240,0.03249505}, {241,0.03267327}, {242,0.03268317}, {243,0.03302970}, {244,0.03484158}, {245,0.03344554}, {246,0.03665347}, {247,0.03368317}, {248,0.03760396}, {249,0.03370297}, {250,0.03728713}, {251,0.03433663}, {252,0.03554455}, {253,0.03426733}, {254,0.03456436}, {255,0.04530693}, {256,0.03447525}, {257,0.04090099}, {258,0.03490099}, {259,0.03516832}, {260,0.04704950}, {261,0.03538614}, {262,0.03945545}, {263,0.03554455}, {264,0.03551485}, {265,0.04128713}, {266,0.03574257}, {267,0.03603960}, {268,0.03964356}, {269,0.05446535}, {270,0.03689109}, {271,0.03706931}, {272,0.04698020}, {273,0.03699010}, {274,0.03733663}, {275,0.03738614}, {276,0.04417822}, {277,0.05090099}, {278,0.03747525}, {279,0.03802970}, {280,0.03902970}, {281,0.04446535}, {282,0.04926733}, {283,0.03884158}, {284,0.03882178}, {285,0.03857426}, {286,0.03878218}, {287,0.04065347}, {288,0.04349505}, {289,0.04650495}, {290,0.04862376}, {291,0.05134653}, {292,0.03965347}, {293,0.04004950}, {294,0.04033663}, {295,0.04029703}, {296,0.04033663}, {297,0.04024752}, {298,0.04053465}, {299,0.04094059}, {300,0.04085149}, {301,0.04100000}, {302,0.04133663}, {303,0.04139604}, {304,0.04142574}, {305,0.06006931}, {306,0.05367327}, {307,0.05137624}, {308,0.04900990}, {309,0.04614851}, {310,0.04203960}, {311,0.04238614}, {312,0.04236634}, {313,0.04260396}, {314,0.05594059}, {315,0.05221782}, {316,0.04707921}, {317,0.04325743}, {318,0.04356436}, {319,0.04415842}, {320,0.05271287}, {321,0.04701980}, {322,0.04335644}, {323,0.04427723}, {324,0.05506931}, {325,0.04920792}, {326,0.04406931}, {327,0.04450495}, {328,0.05365347}, {329,0.04658416}, {330,0.04488119}, {331,0.06183168}, {332,0.04946535}, {333,0.04530693}, {334,0.05755446}, {335,0.04771287}, {336,0.04557426}, {337,0.05553465}, {338,0.04568317}, {339,0.06129703}, {340,0.05013861}, {341,0.04667327}, {342,0.05461386}, {343,0.04671287}, {344,0.05710891}, {345,0.04675248}, {346,0.06054455}, {347,0.04762376}, {348,0.06098020}, {349,0.04760396}, {350,0.06052475}, {351,0.04797030}, {352,0.05962376}, {353,0.04764356}, {354,0.05514851}, {355,0.04859406}, {356,0.05693069}, {357,0.04839604}, {358,0.05355446}, {359,0.06447525}, {360,0.04882178}, {361,0.05793069}, {362,0.04940594}, {363,0.05109901}, {364,0.06141584}, {365,0.04989109}, {366,0.05207921}, {367,0.06128713}, {368,0.04997030}, {369,0.05017822}, {370,0.05725743}, {371,0.06614851}, {372,0.05080198}, {373,0.05450495}, {374,0.06085149}, {375,0.05171287}, {376,0.05107921}, {377,0.05405941}, {378,0.05929703}, {379,0.06595050}, {380,0.05202970}, {381,0.05191089}, {382,0.05377228}, {383,0.05803960}, {384,0.06235644}, {385,0.06803960}, {386,0.05226733}, {387,0.05234653}, {388,0.05268317}, {389,0.05438614}, {390,0.05761386}, {391,0.06024752}, {392,0.06188119}, {393,0.06419802}, {394,0.06593069}, {395,0.06536634}, {396,0.06841584}, {397,0.06957426}, {398,0.07001980}, {399,0.07870297}, {400,0.07579208}, {401,0.07325743}, {402,0.07332673}, {403,0.07177228}, {404,0.07023762}, {405,0.06995050}, {406,0.06789109}, {407,0.06605941}, {408,0.06257426}, {409,0.06114851}, {410,0.05850495}, {411,0.05643564}, {412,0.05605941}, {413,0.05665347}, {414,0.07190099}, {415,0.07126733}, {416,0.06785149}, {417,0.06160396}, {418,0.05666337}, {419,0.05739604}, {420,0.07505941}, {421,0.06941584}, {422,0.06174257}, {423,0.05792079}, {424,0.05785149}, {425,0.07052475}, {426,0.06365347}, {427,0.05817822}, {428,0.07535644}, {429,0.06832673}, {430,0.06072277}, {431,0.05941584}, {432,0.06951485}, {433,0.06359406}, {434,0.05911881}, {435,0.07403960}, {436,0.06193069}, {437,0.06240594}, {438,0.07008911}, {439,0.06050495}, {440,0.07516832}, {441,0.06432673}, {442,0.06241584}, {443,0.06792079}, {444,0.06063366}, {445,0.07097030}, {446,0.06113861}, {447,0.07275248}, {448,0.06069307}, {449,0.07798020}, {450,0.06295050}, {451,0.08103960}, {452,0.06288119}, {453,0.07708911}, {454,0.06203960}, {455,0.07504950}, {456,0.06187129}, {457,0.07190099}, {458,0.06242574}, {459,0.06742574}, {460,0.07757426}, {461,0.06292079}, {462,0.07241584}, {463,0.08193069}, {464,0.06573267}, {465,0.07531683}, {466,0.06336634}, {467,0.06988119}, {468,0.07850495}, {469,0.06400990}, {470,0.06737624}, {471,0.07375248}, {472,0.08323762}, {473,0.06484158}, {474,0.07054455}, {475,0.07768317}, {476,0.08359406}, {477,0.06561386}, {478,0.06992079}, {479,0.07583168}, {480,0.08413861}, {481,0.06554455}, {482,0.06584158}, {483,0.07136634}, {484,0.07635644}, {485,0.07737624}, {486,0.08432673}, {487,0.08749505}, {488,0.06649505}, {489,0.06833663}, {490,0.07077228}, {491,0.07394059}, {492,0.07604950}, {493,0.08038614}, {494,0.08358416}, {495,0.08286139}, {496,0.08419802}, {497,0.08237624}, {498,0.08557426}, {499,0.08638614}, {500,0.08618812}, {505,0.08536634}, {510,0.08370297}, {515,0.08064356}, {520,0.07735644}, {525,0.07201980}, {530,0.09979208}, {535,0.08580198}, {540,0.07509901}, {545,0.09174257}, {550,0.07944554}, {555,0.09205941}, {560,0.07826733}, {565,0.08823762}, {570,0.09680198}, {575,0.07970297}, {580,0.08867327}, {585,0.09420792}, {590,0.09663366}, {595,0.09902970}, {600,0.09902970}, {605,0.09867327}, {610,0.09728713}, {615,0.09565347}, {620,0.09514851}, {625,0.08700000}, {630,0.10849505}, {635,0.09941584}, {640,0.08971287}, {645,0.10531683}, {650,0.09474257}, {655,0.10698020}, {660,0.09413861}, {665,0.10623762}, {670,0.11639604}, {675,0.09677228}, {680,0.10304950}, {685,0.10778218}, {690,0.11110891}, {695,0.11452475}, {700,0.12001980}, {705,0.11902970}, {710,0.11737624}, {715,0.11397030}, {720,0.11039604}, {725,0.10692079}, {730,0.13650495}, {735,0.12088119}, {740,0.10984158}, {745,0.12593069}, {750,0.11400990}, {755,0.12620792}, {760,0.11799010}, {765,0.12630693}, {770,0.13438614}, {775,0.11597030}, {780,0.12243564}, {785,0.12740594}, {790,0.13667327}, {795,0.13965347}, {800,0.14043564}, {805,0.13870297}, {810,0.13737624}, {815,0.14754455}, {820,0.13626733}, {825,0.13110891}, {830,0.12412871}, {835,0.14036634}, {840,0.14250495}, {845,0.15396040}, {850,0.14076238}, {855,0.15052475}, {860,0.13793069}, {865,0.16224752}, {870,0.13634653}, {875,0.14328713}, {880,0.14757426}, {885,0.15285149}, {890,0.13745545}, {895,0.13693069}, {900,0.13754455}, {905,0.13793069}, {910,0.13702970}, {915,0.16426733}, {920,0.15840594}, {925,0.15270297}, {930,0.14719802}, {935,0.14893069}, {940,0.16216832}, {945,0.15100990}, {950,0.16227723}, {955,0.15126733}, {960,0.16829703}, {965,0.15120792}, {970,0.15846535}, {975,0.16642574}, {980,0.15373267}, {985,0.15847525}, {990,0.15953465}, {995,0.16304950}, {1000,0.17004950}, {1010,0.16852475}, {1020,0.16317822}, {1030,0.15663366}, {1040,0.18424752}, {1050,0.17115842}, {1060,0.18148515}, {1070,0.18080198}, {1080,0.18086139}, {1090,0.18315842}, {1100,0.18439604}, {1110,0.19530693}, {1120,0.18833663}, {1130,0.18370297}, {1140,0.18165347}, {1150,0.19732673}, {1160,0.18111881}, {1170,0.20966337}, {1180,0.20579208}, {1190,0.20650495}, {1200,0.19001980}, {1210,0.19059406}, {1220,0.21067327}, {1230,0.21492079}, {1240,0.20481188}, {1250,0.21524752}, {1260,0.21177228}, {1270,0.21743564}, {1280,0.19903960}, {1290,0.21291089}, {1300,0.21129703}, {1310,0.23204950}, {1320,0.21504950}, {1330,0.20827723}, {1340,0.23688119}, {1350,0.22033663}, {1360,0.23017822}, {1370,0.22632673}, {1380,0.22709901}, {1390,0.25579208}, {1400,0.24071287}, {1410,0.23618812}, {1420,0.24537624}, {1430,0.23436634}, {1440,0.24281188}, {1450,0.24855446}, {1460,0.23506931}, {1470,0.24915842}, {1480,0.25204950}, {1490,0.24433663}, {1500,0.24061386}, {1510,0.25989109}, {1520,0.24433663}, {1530,0.25882178}, {1540,0.25513861}, {1550,0.24826733}, {1560,0.27294059}, {1570,0.25000000}, {1580,0.27017822}, {1590,0.26536634}, {1600,0.28037624}, {1610,0.27177228}, {1620,0.28288119}, {1630,0.26927723}, {1640,0.27422772}, {1650,0.28092079}, {1660,0.28732673}, {1670,0.28090099}, {1680,0.28735644}, {1690,0.27636634}, {1700,0.30147525}, {1710,0.28220792}, {1720,0.29621782}, {1730,0.27705941}, {1740,0.30754455}, {1750,0.28847525}, {1760,0.28904950}, {1770,0.29149505}, {1780,0.30547525}, {1790,0.31747525}, {1800,0.28832673}, {1810,0.29961386}, {1820,0.29492079}, {1830,0.33902970}, {1840,0.30489109}, {1850,0.30931683}, {1860,0.31306931}, {1870,0.30849505}, {1880,0.30228713}, {1890,0.32012871}, {1900,0.33889109}, {1910,0.32351485}, {1920,0.33434653}, {1930,0.32078218}, {1940,0.31919802}, {1950,0.35026733}, {1960,0.32382178}, {1970,0.34097030}, {1980,0.32885149}, {1990,0.32794059}, {2000,0.34159406}, {2050,0.33118812}, {2100,0.35247525}, {2150,0.36372277}, {2200,0.36058416}, {2250,0.39136634}, {2300,0.40913861}, {2350,0.38647525}, {2400,0.40667327}, {2450,0.41446535}, {2500,0.42611881}, {2550,0.43614851}, {2600,0.46829703}, {2650,0.42957426}, {2700,0.44806931}, {2750,0.47455446}, {2800,0.47001980}, {2850,0.49964356}, {2900,0.50988119}, {2950,0.50346535}, {3000,0.51722772}, {3050,0.51854455}, {3100,0.53150495}, {3150,0.52723762}, {3200,0.53993069}, {3250,0.55562376}, {3300,0.56933663}, {3350,0.57477228}, {3400,0.58385149}, {3450,0.59405941}, {3500,0.59721782}, {3550,0.62408911}, {3600,0.60883168}, {3650,0.63340594}, {3700,0.62017822}, {3750,0.64580198}, {3800,0.66393069}, {3850,0.68601980}, {3900,0.68207921}, {3950,0.68462376}, {4000,0.68212871}, {4050,0.71102970}, {4100,0.73364356}, {4150,0.72000990}, {4200,0.73077228}, {4250,0.75769307}, {4300,0.75575248}, {4350,0.75541584}, {4400,0.77027723}, {4450,0.78247525}, {4500,0.78453465}, {4550,0.80650495}, {4600,0.80221782}, {4650,0.80162376}, {4700,0.83356436}, {4750,0.81947525}, {4800,0.86318812}, {4850,0.84297030}, {4900,0.96353465}, {4950,0.86251485}, {5000,0.89680198}, {5050,0.88342574}, {5100,0.91464356}, {5150,0.88326733}, {5200,0.91312871}, {5250,0.92415842}, {5300,0.93210891}, {5350,0.95293069}, {5400,0.94968317}, {5450,0.95924752}, {5500,0.97935644}, {5550,0.95686139}, {5600,0.98250495}, {5650,0.99779208}, {5700,0.99493069}, {5750,1.00414851}, {5800,1.01671287}, {5850,1.02522772}, {5900,1.04822772}, {5950,1.03940594}, {6000,1.06518812}, {6050,1.1141714}, {6100,3.6601429}, {6150,1.1385143}, {6200,1.1658000}, {6250,1.1593143}, {6300,1.1367714}, {6350,1.1383143}, {6400,1.1289714}, {6450,1.1497429}, {6500,1.1538286}, {6550,1.1676000}, {6600,1.1828857}, {6650,1.1951429}, {6700,1.2103714}, {6750,1.2052571}, {6800,1.2297429}, {6850,1.2348000}, {6900,1.2511714}, {6950,1.2506571}, {7000,1.2550000}, {7050,1.2567143}, {7100,1.2848571}, {7150,1.3163143}, {7200,1.3201429}, {7250,1.3544571}, {7300,1.3721429}, {7350,1.3709143}, {7400,1.3738571}, {7450,1.3743143}, {7500,1.3726000}, {7550,1.3785714}, {7600,1.3650000}, {7650,1.3957714}, {7700,1.4531143}, {7750,1.4452000}, {7800,1.4671429}, {7850,1.4395143}, {7900,1.4424286}, {7950,1.4863143}, {8000,1.5049714}, {8050,1.4911714}, {8100,1.4937714}, {8150,1.4864000}, {8200,1.4740286}, {8250,1.5508857}, {8300,1.5216571}, {8350,1.5413429}, {8400,1.5071143}, {8450,1.5830857}, {8500,1.5687429}, {8550,1.5721429}, {8600,1.5606857}, {8650,1.6240286}, {8700,1.6167429}, {8750,1.6225143}, {8800,1.6265714}, {8850,1.6338286}, {8900,1.6061714}, {8950,1.6875143}, {9000,1.6586286}, {9050,1.6428571}, {9100,1.7006571}, {9150,1.7057714}, {9200,1.6904000}, {9250,1.7052286}, {9300,1.7022857}, {9350,1.7481429}, {9400,1.7650857}, {9450,1.7485429}, {9500,1.7861714}, {9550,1.7518857}, {9600,1.7710571}, {9650,1.7943714}, {9700,1.8333714}, {9750,1.8055143}, {9800,1.8396857}, {9850,1.8313143}, {9900,1.8622286}, {9950,1.8521429}, {10000,1.8883429}, {10100,1.8454571}, {10200,1.9403143}, {10300,1.8909429}, {10400,1.9220000}, {10500,1.8954000}, {10600,1.9658000}, {10700,1.9731714}, {10800,1.9802286}, {10900,1.9911714}, {11000,2.0501143}, {11100,2.0344286}, {11200,2.0660857}, {11300,2.0657429}, {11400,2.1026286}, {11500,2.1166857}, {11600,2.1398571}, {11700,2.1575143}, {11800,2.1593714}, {11900,2.2122286}, {12000,2.1968857}, {12100,2.2781429}, {12200,2.2683714}, {12300,2.2501714}, {12400,2.2351429}, {12500,2.2783143}, {12600,2.3403143}, {12700,2.4184286}, {12800,2.3125714}, {12900,2.3602000}, {13000,2.3879429}, {13100,2.4205143}, {13200,2.4002571}, {13300,2.4608000}, {13400,2.4264571}, {13500,2.4845714}, {13600,2.4863429}, {13700,2.5078857}, {13800,2.5388571}, {13900,2.5415143}, {14000,2.5829143}, {14100,2.5870857}, {14200,2.6360286}, {14300,2.6570286}, {14400,2.8108571}, {14500,2.6712286}, {14600,2.6793429}, {14700,2.9351429}, {14800,2.8046286}, {14900,2.8187429}, {15000,2.7559714}, {15100,2.7912286}, {15200,2.8281714}, {15300,2.8797143}, {15400,2.8912286}, {15500,2.9405714}, {15600,2.8338857}, {15700,2.9423714}, {15800,3.0068571}, {15900,3.0940571}, {16000,2.9986286}, {16100,2.9515714}, {16200,3.2697714}, {16300,2.9959143}, {16400,2.9588571}, {16500,3.0292571}, {16600,3.1143714}, {16700,3.1356571}, {16800,3.0617143}, {16900,3.1583143}, {17000,3.1013429}, {17100,3.0973143}, {17200,3.3896571}, {17300,3.1819714}, {17400,3.2670000}, {17500,3.2819143}, {17600,3.2569143}, {17700,3.3086571}, {17800,3.2996571}, {17900,3.2601429}, {18000,3.3630286}, {18100,3.3086571}, {18200,3.3746857}, {18300,3.4656571}, {18400,3.3829429}, {18500,3.4277714}, {18600,3.5485429}, {18700,3.4133429}, {18800,3.4614286}, {18900,3.4969714}, {19000,3.4823714}, {19100,3.6955143}, {19200,3.6498286}, {19300,3.5877143}, {19400,3.5744857}, {19500,3.5875143}, {19600,3.7594571}, {19700,3.7107714}, {19800,3.7571429}, {19900,3.7481143}, {20000,3.7196857}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["norm reif"]["user"] = {{1,0.00025743}, {2,0.00042574}, {3,0.00051485}, {4,0.00077228}, {5,0.00077228}, {6,0.00101980}, {7,0.00082178}, {8,0.00151485}, {9,0.00126733}, {10,0.00144554}, {11,0.00169307}, {12,0.00121782}, {13,0.00192079}, {14,0.00168317}, {15,0.00167327}, {16,0.00214851}, {17,0.00214851}, {18,0.00249505}, {19,0.00248515}, {20,0.00229703}, {21,0.00237624}, {22,0.00290099}, {23,0.00309901}, {24,0.00317822}, {25,0.00274257}, {26,0.00303960}, {27,0.00335644}, {28,0.00340594}, {29,0.00365347}, {30,0.00369307}, {31,0.00395050}, {32,0.00396040}, {33,0.00422772}, {34,0.00535644}, {35,0.00446535}, {36,0.00464356}, {37,0.00462376}, {38,0.00500000}, {39,0.00472277}, {40,0.00557426}, {41,0.00539604}, {42,0.00566337}, {43,0.00778218}, {44,0.00597030}, {45,0.00846535}, {46,0.00610891}, {47,0.00807921}, {48,0.00641584}, {49,0.00662376}, {50,0.00691089}, {51,0.00667327}, {52,0.00674257}, {53,0.00726733}, {54,0.00745545}, {55,0.00763366}, {56,0.00783168}, {57,0.00777228}, {58,0.00798020}, {59,0.00996040}, {60,0.00813861}, {61,0.00828713}, {62,0.01063366}, {63,0.00871287}, {64,0.00846535}, {65,0.00940594}, {66,0.00858416}, {67,0.00899010}, {68,0.00897030}, {69,0.00938614}, {70,0.00937624}, {71,0.00939604}, {72,0.00941584}, {73,0.01405941}, {74,0.01004950}, {75,0.00997030}, {76,0.00995050}, {77,0.01033663}, {78,0.01397030}, {79,0.01062376}, {80,0.01053465}, {81,0.01077228}, {82,0.01093069}, {83,0.01100000}, {84,0.01127723}, {85,0.01440594}, {86,0.01155446}, {87,0.01187129}, {88,0.01166337}, {89,0.01204950}, {90,0.01199010}, {91,0.01218812}, {92,0.01218812}, {93,0.01272277}, {94,0.01296040}, {95,0.01293069}, {96,0.01282178}, {97,0.01343564}, {98,0.01330693}, {99,0.01353465}, {100,0.01380198}, {101,0.01375248}, {102,0.01353465}, {103,0.01390099}, {104,0.01457426}, {105,0.01958416}, {106,0.01720792}, {107,0.01485149}, {108,0.01471287}, {109,0.01477228}, {110,0.01491089}, {111,0.01514851}, {112,0.01531683}, {113,0.01904950}, {114,0.01521782}, {115,0.01584158}, {116,0.01583168}, {117,0.01595050}, {118,0.01991089}, {119,0.01643564}, {120,0.01636634}, {121,0.01652475}, {122,0.02166337}, {123,0.01653465}, {124,0.01680198}, {125,0.01691089}, {126,0.01845545}, {127,0.01726733}, {128,0.01767327}, {129,0.02019802}, {130,0.01735644}, {131,0.01775248}, {132,0.01988119}, {133,0.01752475}, {134,0.01829703}, {135,0.01833663}, {136,0.01810891}, {137,0.02328713}, {138,0.01823762}, {139,0.01865347}, {140,0.01863366}, {141,0.01870297}, {142,0.01907921}, {143,0.01895050}, {144,0.02130693}, {145,0.01913861}, {146,0.02285149}, {147,0.01961386}, {148,0.02266337}, {149,0.01966337}, {150,0.02146535}, {151,0.02027723}, {152,0.01961386}, {153,0.02006931}, {154,0.02009901}, {155,0.02745545}, {156,0.02056436}, {157,0.02245545}, {158,0.02106931}, {159,0.02142574}, {160,0.02603960}, {161,0.02087129}, {162,0.02184158}, {163,0.02820792}, {164,0.02193069}, {165,0.02206931}, {166,0.02768317}, {167,0.02285149}, {168,0.02280198}, {169,0.02449505}, {170,0.02317822}, {171,0.02324752}, {172,0.02323762}, {173,0.02637624}, {174,0.02371287}, {175,0.02371287}, {176,0.02388119}, {177,0.02364356}, {178,0.02857426}, {179,0.02408911}, {180,0.02414851}, {181,0.02498020}, {182,0.02457426}, {183,0.02468317}, {184,0.02809901}, {185,0.03206931}, {186,0.02479208}, {187,0.02558416}, {188,0.02558416}, {189,0.02577228}, {190,0.02567327}, {191,0.02596040}, {192,0.02590099}, {193,0.02581188}, {194,0.02607921}, {195,0.02618812}, {196,0.02624752}, {197,0.02654455}, {198,0.02662376}, {199,0.02663366}, {200,0.02670297}, {201,0.02690099}, {202,0.02677228}, {203,0.02724752}, {204,0.02739604}, {205,0.02768317}, {206,0.02755446}, {207,0.02797030}, {208,0.02765347}, {209,0.03829703}, {210,0.03310891}, {211,0.02840594}, {212,0.02835644}, {213,0.02881188}, {214,0.02875248}, {215,0.03115842}, {216,0.03485149}, {217,0.02931683}, {218,0.02961386}, {219,0.02924752}, {220,0.04028713}, {221,0.03360396}, {222,0.02991089}, {223,0.03075248}, {224,0.04099010}, {225,0.03311881}, {226,0.03036634}, {227,0.03113861}, {228,0.03586139}, {229,0.03127723}, {230,0.03131683}, {231,0.03824752}, {232,0.03136634}, {233,0.03179208}, {234,0.03752475}, {235,0.03158416}, {236,0.03224752}, {237,0.03395050}, {238,0.03247525}, {239,0.03945545}, {240,0.03265347}, {241,0.03278218}, {242,0.03245545}, {243,0.03289109}, {244,0.03526733}, {245,0.03359406}, {246,0.03657426}, {247,0.03357426}, {248,0.03756436}, {249,0.03355446}, {250,0.03713861}, {251,0.03448515}, {252,0.03552475}, {253,0.03448515}, {254,0.03470297}, {255,0.04532673}, {256,0.03469307}, {257,0.04061386}, {258,0.03500000}, {259,0.03506931}, {260,0.04700000}, {261,0.03541584}, {262,0.03914851}, {263,0.03546535}, {264,0.03566337}, {265,0.04135644}, {266,0.03600990}, {267,0.03625743}, {268,0.03932673}, {269,0.05452475}, {270,0.03688119}, {271,0.03677228}, {272,0.04700990}, {273,0.03697030}, {274,0.03706931}, {275,0.03751485}, {276,0.04400990}, {277,0.05058416}, {278,0.03725743}, {279,0.03781188}, {280,0.03827723}, {281,0.04447525}, {282,0.04916832}, {283,0.03861386}, {284,0.03845545}, {285,0.03848515}, {286,0.03851485}, {287,0.04011881}, {288,0.04363366}, {289,0.04635644}, {290,0.04860396}, {291,0.05119802}, {292,0.03918812}, {293,0.03971287}, {294,0.04027723}, {295,0.03964356}, {296,0.03978218}, {297,0.03978218}, {298,0.04013861}, {299,0.04069307}, {300,0.04042574}, {301,0.04044554}, {302,0.04104950}, {303,0.04101980}, {304,0.04148515}, {305,0.06014851}, {306,0.05372277}, {307,0.05104950}, {308,0.04887129}, {309,0.04618812}, {310,0.04158416}, {311,0.04237624}, {312,0.04208911}, {313,0.04233663}, {314,0.05569307}, {315,0.05174257}, {316,0.04715842}, {317,0.04315842}, {318,0.04332673}, {319,0.04429703}, {320,0.05243564}, {321,0.04697030}, {322,0.04324752}, {323,0.04445545}, {324,0.05482178}, {325,0.04899010}, {326,0.04396040}, {327,0.04425743}, {328,0.05340594}, {329,0.04668317}, {330,0.04495050}, {331,0.06205941}, {332,0.04919802}, {333,0.04507921}, {334,0.05772277}, {335,0.04766337}, {336,0.04556436}, {337,0.05519802}, {338,0.04547525}, {339,0.06160396}, {340,0.04982178}, {341,0.04652475}, {342,0.05440594}, {343,0.04682178}, {344,0.05730693}, {345,0.04646535}, {346,0.06010891}, {347,0.04755446}, {348,0.06083168}, {349,0.04810891}, {350,0.06012871}, {351,0.04814851}, {352,0.05964356}, {353,0.04770297}, {354,0.05491089}, {355,0.04843564}, {356,0.05702970}, {357,0.04855446}, {358,0.05364356}, {359,0.06430693}, {360,0.04904950}, {361,0.05811881}, {362,0.04944554}, {363,0.05075248}, {364,0.06135644}, {365,0.05015842}, {366,0.05202970}, {367,0.06131683}, {368,0.05008911}, {369,0.04991089}, {370,0.05724752}, {371,0.06601980}, {372,0.05065347}, {373,0.05436634}, {374,0.06110891}, {375,0.05176238}, {376,0.05132673}, {377,0.05411881}, {378,0.05936634}, {379,0.06600000}, {380,0.05203960}, {381,0.05185149}, {382,0.05351485}, {383,0.05814851}, {384,0.06231683}, {385,0.06766337}, {386,0.05228713}, {387,0.05225743}, {388,0.05274257}, {389,0.05401980}, {390,0.05751485}, {391,0.05991089}, {392,0.06160396}, {393,0.06399010}, {394,0.06565347}, {395,0.06531683}, {396,0.06819802}, {397,0.06939604}, {398,0.06962376}, {399,0.07845545}, {400,0.07571287}, {401,0.07322772}, {402,0.07310891}, {403,0.07165347}, {404,0.07024752}, {405,0.07020792}, {406,0.06780198}, {407,0.06562376}, {408,0.06250495}, {409,0.06143564}, {410,0.05826733}, {411,0.05599010}, {412,0.05575248}, {413,0.05675248}, {414,0.07201980}, {415,0.07121782}, {416,0.06744554}, {417,0.06164356}, {418,0.05624752}, {419,0.05714851}, {420,0.07485149}, {421,0.06938614}, {422,0.06162376}, {423,0.05776238}, {424,0.05761386}, {425,0.07001980}, {426,0.06324752}, {427,0.05804950}, {428,0.07504950}, {429,0.06810891}, {430,0.06063366}, {431,0.05944554}, {432,0.06950495}, {433,0.06337624}, {434,0.05905941}, {435,0.07399010}, {436,0.06152475}, {437,0.06215842}, {438,0.06980198}, {439,0.06039604}, {440,0.07508911}, {441,0.06418812}, {442,0.06268317}, {443,0.06759406}, {444,0.06112871}, {445,0.07097030}, {446,0.06122772}, {447,0.07277228}, {448,0.06059406}, {449,0.07785149}, {450,0.06301980}, {451,0.08090099}, {452,0.06303960}, {453,0.07694059}, {454,0.06174257}, {455,0.07480198}, {456,0.06185149}, {457,0.07205941}, {458,0.06237624}, {459,0.06706931}, {460,0.07756436}, {461,0.06280198}, {462,0.07226733}, {463,0.08170297}, {464,0.06564356}, {465,0.07520792}, {466,0.06323762}, {467,0.06977228}, {468,0.07834653}, {469,0.06377228}, {470,0.06687129}, {471,0.07344554}, {472,0.08351485}, {473,0.06469307}, {474,0.07034653}, {475,0.07720792}, {476,0.08348515}, {477,0.06528713}, {478,0.06945545}, {479,0.07579208}, {480,0.08381188}, {481,0.06518812}, {482,0.06524752}, {483,0.07142574}, {484,0.07634653}, {485,0.07691089}, {486,0.08399010}, {487,0.08703960}, {488,0.06616832}, {489,0.06789109}, {490,0.07030693}, {491,0.07404950}, {492,0.07573267}, {493,0.08005941}, {494,0.08335644}, {495,0.08247525}, {496,0.08394059}, {497,0.08186139}, {498,0.08557426}, {499,0.08626733}, {500,0.08606931}, {505,0.08530693}, {510,0.08340594}, {515,0.08067327}, {520,0.07713861}, {525,0.07212871}, {530,0.09956436}, {535,0.08545545}, {540,0.07490099}, {545,0.09166337}, {550,0.07963366}, {555,0.09190099}, {560,0.07794059}, {565,0.08808911}, {570,0.09656436}, {575,0.07942574}, {580,0.08857426}, {585,0.09415842}, {590,0.09698020}, {595,0.09871287}, {600,0.09873267}, {605,0.09863366}, {610,0.09714851}, {615,0.09543564}, {620,0.09498020}, {625,0.08669307}, {630,0.10844554}, {635,0.09866337}, {640,0.08941584}, {645,0.10532673}, {650,0.09448515}, {655,0.10702970}, {660,0.09409901}, {665,0.10605941}, {670,0.11616832}, {675,0.09661386}, {680,0.10289109}, {685,0.10755446}, {690,0.11083168}, {695,0.11411881}, {700,0.11976238}, {705,0.11888119}, {710,0.11730693}, {715,0.11404950}, {720,0.11008911}, {725,0.10694059}, {730,0.13606931}, {735,0.12083168}, {740,0.10939604}, {745,0.12556436}, {750,0.11394059}, {755,0.12605941}, {760,0.11788119}, {765,0.12562376}, {770,0.13415842}, {775,0.11598020}, {780,0.12212871}, {785,0.12716832}, {790,0.13645545}, {795,0.13951485}, {800,0.14026733}, {805,0.13850495}, {810,0.13722772}, {815,0.14730693}, {820,0.13599010}, {825,0.13097030}, {830,0.12382178}, {835,0.14007921}, {840,0.14210891}, {845,0.15321782}, {850,0.14041584}, {855,0.15049505}, {860,0.13760396}, {865,0.16194059}, {870,0.13582178}, {875,0.14333663}, {880,0.14720792}, {885,0.15238614}, {890,0.13716832}, {895,0.13669307}, {900,0.13722772}, {905,0.13762376}, {910,0.13666337}, {915,0.16397030}, {920,0.15840594}, {925,0.15243564}, {930,0.14683168}, {935,0.14869307}, {940,0.16198020}, {945,0.15074257}, {950,0.16217822}, {955,0.15108911}, {960,0.16807921}, {965,0.15099010}, {970,0.15828713}, {975,0.16591089}, {980,0.15346535}, {985,0.15818812}, {990,0.15943564}, {995,0.16276238}, {1000,0.16963366}, {1010,0.16845545}, {1020,0.16275248}, {1030,0.15624752}, {1040,0.18429703}, {1050,0.17075248}, {1060,0.18107921}, {1070,0.18039604}, {1080,0.18039604}, {1090,0.18293069}, {1100,0.18418812}, {1110,0.19489109}, {1120,0.18819802}, {1130,0.18327723}, {1140,0.18122772}, {1150,0.19656436}, {1160,0.18086139}, {1170,0.20922772}, {1180,0.20506931}, {1190,0.20560396}, {1200,0.18966337}, {1210,0.19009901}, {1220,0.21029703}, {1230,0.21419802}, {1240,0.20410891}, {1250,0.21489109}, {1260,0.21132673}, {1270,0.21671287}, {1280,0.19851485}, {1290,0.21272277}, {1300,0.21077228}, {1310,0.23119802}, {1320,0.21455446}, {1330,0.20770297}, {1340,0.23628713}, {1350,0.21950495}, {1360,0.22930693}, {1370,0.22577228}, {1380,0.22665347}, {1390,0.25480198}, {1400,0.23982178}, {1410,0.23536634}, {1420,0.24457426}, {1430,0.23384158}, {1440,0.24181188}, {1450,0.24786139}, {1460,0.23436634}, {1470,0.24901980}, {1480,0.25167327}, {1490,0.24332673}, {1500,0.23988119}, {1510,0.25921782}, {1520,0.24385149}, {1530,0.25820792}, {1540,0.25436634}, {1550,0.24771287}, {1560,0.27200000}, {1570,0.24936634}, {1580,0.26970297}, {1590,0.26457426}, {1600,0.27939604}, {1610,0.27097030}, {1620,0.28177228}, {1630,0.26826733}, {1640,0.27366337}, {1650,0.28044554}, {1660,0.28667327}, {1670,0.27993069}, {1680,0.28635644}, {1690,0.27558416}, {1700,0.30076238}, {1710,0.28130693}, {1720,0.29559406}, {1730,0.27631683}, {1740,0.30656436}, {1750,0.28773267}, {1760,0.28842574}, {1770,0.29069307}, {1780,0.30479208}, {1790,0.31660396}, {1800,0.28739604}, {1810,0.29876238}, {1820,0.29436634}, {1830,0.33800990}, {1840,0.30428713}, {1850,0.30820792}, {1860,0.31234653}, {1870,0.30778218}, {1880,0.30129703}, {1890,0.31901980}, {1900,0.33801980}, {1910,0.32270297}, {1920,0.33313861}, {1930,0.31972277}, {1940,0.31847525}, {1950,0.34912871}, {1960,0.32274257}, {1970,0.33999010}, {1980,0.32755446}, {1990,0.32698020}, {2000,0.34060396}, {2050,0.33007921}, {2100,0.35157426}, {2150,0.36276238}, {2200,0.35970297}, {2250,0.39062376}, {2300,0.40817822}, {2350,0.38537624}, {2400,0.40546535}, {2450,0.41349505}, {2500,0.42516832}, {2550,0.43533663}, {2600,0.46723762}, {2650,0.42861386}, {2700,0.44684158}, {2750,0.47345545}, {2800,0.46835644}, {2850,0.49862376}, {2900,0.50898020}, {2950,0.50252475}, {3000,0.51632673}, {3050,0.51745545}, {3100,0.53053465}, {3150,0.52615842}, {3200,0.53887129}, {3250,0.55456436}, {3300,0.56793069}, {3350,0.57385149}, {3400,0.58245545}, {3450,0.59314851}, {3500,0.59632673}, {3550,0.62291089}, {3600,0.60776238}, {3650,0.63239604}, {3700,0.61869307}, {3750,0.64450495}, {3800,0.66274257}, {3850,0.68483168}, {3900,0.68090099}, {3950,0.68329703}, {4000,0.68092079}, {4050,0.70965347}, {4100,0.73215842}, {4150,0.71888119}, {4200,0.72942574}, {4250,0.75630693}, {4300,0.75396040}, {4350,0.75404950}, {4400,0.76862376}, {4450,0.78114851}, {4500,0.78309901}, {4550,0.80488119}, {4600,0.80030693}, {4650,0.80027723}, {4700,0.83162376}, {4750,0.81751485}, {4800,0.86144554}, {4850,0.84126733}, {4900,0.96145545}, {4950,0.86054455}, {5000,0.89456436}, {5050,0.88127723}, {5100,0.91272277}, {5150,0.88121782}, {5200,0.91121782}, {5250,0.92205941}, {5300,0.93037624}, {5350,0.95074257}, {5400,0.94760396}, {5450,0.95726733}, {5500,0.97727723}, {5550,0.95514851}, {5600,0.98035644}, {5650,0.99562376}, {5700,0.99293069}, {5750,1.00218812}, {5800,1.01455446}, {5850,1.02339604}, {5900,1.04632673}, {5950,1.03759406}, {6000,1.06339604}, {6050,1.1057714}, {6100,3.6543429}, {6150,1.1375714}, {6200,1.1647429}, {6250,1.1580000}, {6300,1.1352571}, {6350,1.1372857}, {6400,1.1274571}, {6450,1.1486857}, {6500,1.1530857}, {6550,1.1667429}, {6600,1.1820000}, {6650,1.1938571}, {6700,1.2092571}, {6750,1.2021429}, {6800,1.2252857}, {6850,1.2338857}, {6900,1.2499429}, {6950,1.2486000}, {7000,1.2539143}, {7050,1.2561429}, {7100,1.2840000}, {7150,1.3138571}, {7200,1.3194286}, {7250,1.3521143}, {7300,1.3677714}, {7350,1.3667714}, {7400,1.3717429}, {7450,1.3674286}, {7500,1.3698286}, {7550,1.3762000}, {7600,1.3636286}, {7650,1.3913714}, {7700,1.4510000}, {7750,1.4426286}, {7800,1.4570857}, {7850,1.4362286}, {7900,1.4394857}, {7950,1.4848286}, {8000,1.5012571}, {8050,1.4898857}, {8100,1.4905429}, {8150,1.4843714}, {8200,1.4730286}, {8250,1.5488857}, {8300,1.5199429}, {8350,1.5393143}, {8400,1.5058000}, {8450,1.5812571}, {8500,1.5672286}, {8550,1.5703143}, {8600,1.5588000}, {8650,1.6219143}, {8700,1.6141429}, {8750,1.6209429}, {8800,1.6251714}, {8850,1.6295429}, {8900,1.6047714}, {8950,1.6850571}, {9000,1.6570286}, {9050,1.6408000}, {9100,1.6980286}, {9150,1.7034857}, {9200,1.6879429}, {9250,1.7004571}, {9300,1.6995714}, {9350,1.7452000}, {9400,1.7626286}, {9450,1.7458000}, {9500,1.7836286}, {9550,1.7501714}, {9600,1.7677429}, {9650,1.7911429}, {9700,1.8300857}, {9750,1.8029714}, {9800,1.8371429}, {9850,1.8290000}, {9900,1.8592857}, {9950,1.8490571}, {10000,1.8852571}, {10100,1.8427143}, {10200,1.9351143}, {10300,1.8884857}, {10400,1.9183143}, {10500,1.8930286}, {10600,1.9631429}, {10700,1.9710571}, {10800,1.9773143}, {10900,1.9880857}, {11000,2.0470571}, {11100,2.0315143}, {11200,2.0627429}, {11300,2.0622571}, {11400,2.0997714}, {11500,2.1136286}, {11600,2.1370286}, {11700,2.1544857}, {11800,2.1555714}, {11900,2.2084286}, {12000,2.1933143}, {12100,2.2739429}, {12200,2.2647714}, {12300,2.2461429}, {12400,2.2311143}, {12500,2.2743714}, {12600,2.3367143}, {12700,2.4148000}, {12800,2.3095143}, {12900,2.3572000}, {13000,2.3850857}, {13100,2.4163429}, {13200,2.3960857}, {13300,2.4567143}, {13400,2.4224000}, {13500,2.4812286}, {13600,2.4817429}, {13700,2.5045143}, {13800,2.5355429}, {13900,2.5388857}, {14000,2.5792286}, {14100,2.5841714}, {14200,2.6320571}, {14300,2.6542000}, {14400,2.8083714}, {14500,2.6673714}, {14600,2.6755143}, {14700,2.9317429}, {14800,2.8017429}, {14900,2.8150857}, {15000,2.7536857}, {15100,2.7863714}, {15200,2.8254000}, {15300,2.8753143}, {15400,2.8871143}, {15500,2.9366286}, {15600,2.8304000}, {15700,2.9396000}, {15800,3.0043429}, {15900,3.0907714}, {16000,2.9954000}, {16100,2.9484857}, {16200,3.2658286}, {16300,2.9930286}, {16400,2.9561143}, {16500,3.0258286}, {16600,3.1112857}, {16700,3.1320571}, {16800,3.0593429}, {16900,3.1539143}, {17000,3.0984571}, {17100,3.0947714}, {17200,3.3852857}, {17300,3.1782286}, {17400,3.2624857}, {17500,3.2764000}, {17600,3.2532000}, {17700,3.3045429}, {17800,3.2947143}, {17900,3.2568571}, {18000,3.3583429}, {18100,3.3049714}, {18200,3.3702286}, {18300,3.4598286}, {18400,3.3774571}, {18500,3.4228571}, {18600,3.5432286}, {18700,3.4084286}, {18800,3.4450571}, {18900,3.4888000}, {19000,3.4758571}, {19100,3.6796571}, {19200,3.6443714}, {19300,3.5836571}, {19400,3.5646286}, {19500,3.5714571}, {19600,3.7226286}, {19700,3.6925714}, {19800,3.7518571}, {19900,3.7416286}, {20000,3.7147714}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["norm reif"]["system"] = {{1,0.00002970}, {2,0.00003960}, {3,0.00003960}, {4,0.00000000}, {5,0.00003960}, {6,0.00000000}, {7,0.00003960}, {8,0.00007921}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00006931}, {15,0.00002970}, {16,0.00003960}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00003960}, {21,0.00007921}, {22,0.00000000}, {23,0.00003960}, {24,0.00000000}, {25,0.00003960}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00003960}, {32,0.00000000}, {33,0.00007921}, {34,0.00000000}, {35,0.00002970}, {36,0.00000000}, {37,0.00000000}, {38,0.00002970}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00003960}, {44,0.00000000}, {45,0.00013861}, {46,0.00003960}, {47,0.00000000}, {48,0.00002970}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00002970}, {60,0.00000000}, {61,0.00003960}, {62,0.00023762}, {63,0.00002970}, {64,0.00002970}, {65,0.00000000}, {66,0.00006931}, {67,0.00003960}, {68,0.00003960}, {69,0.00003960}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00002970}, {74,0.00002970}, {75,0.00007921}, {76,0.00000000}, {77,0.00002970}, {78,0.00010891}, {79,0.00000000}, {80,0.00003960}, {81,0.00002970}, {82,0.00007921}, {83,0.00000000}, {84,0.00000000}, {85,0.00003960}, {86,0.00007921}, {87,0.00000000}, {88,0.00003960}, {89,0.00003960}, {90,0.00003960}, {91,0.00003960}, {92,0.00000000}, {93,0.00003960}, {94,0.00003960}, {95,0.00000000}, {96,0.00000000}, {97,0.00003960}, {98,0.00000000}, {99,0.00003960}, {100,0.00000000}, {101,0.00002970}, {102,0.00007921}, {103,0.00000000}, {104,0.00007921}, {105,0.00010891}, {106,0.00007921}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00002970}, {111,0.00003960}, {112,0.00000000}, {113,0.00003960}, {114,0.00010891}, {115,0.00003960}, {116,0.00003960}, {117,0.00000000}, {118,0.00003960}, {119,0.00003960}, {120,0.00000000}, {121,0.00000000}, {122,0.00018812}, {123,0.00000000}, {124,0.00003960}, {125,0.00000000}, {126,0.00007921}, {127,0.00003960}, {128,0.00003960}, {129,0.00011881}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00003960}, {136,0.00011881}, {137,0.00007921}, {138,0.00003960}, {139,0.00000000}, {140,0.00003960}, {141,0.00000000}, {142,0.00002970}, {143,0.00007921}, {144,0.00010891}, {145,0.00000000}, {146,0.00006931}, {147,0.00000000}, {148,0.00005941}, {149,0.00000000}, {150,0.00007921}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00010891}, {156,0.00006931}, {157,0.00000000}, {158,0.00010891}, {159,0.00000000}, {160,0.00010891}, {161,0.00011881}, {162,0.00000000}, {163,0.00023762}, {164,0.00003960}, {165,0.00000000}, {166,0.00007921}, {167,0.00000000}, {168,0.00003960}, {169,0.00013861}, {170,0.00011881}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00003960}, {175,0.00003960}, {176,0.00002970}, {177,0.00002970}, {178,0.00017822}, {179,0.00003960}, {180,0.00007921}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00002970}, {185,0.00019802}, {186,0.00011881}, {187,0.00000000}, {188,0.00003960}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00007921}, {202,0.00003960}, {203,0.00000000}, {204,0.00000000}, {205,0.00003960}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00003960}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00003960}, {214,0.00000000}, {215,0.00003960}, {216,0.00003960}, {217,0.00000000}, {218,0.00003960}, {219,0.00006931}, {220,0.00018812}, {221,0.00014851}, {222,0.00003960}, {223,0.00000000}, {224,0.00030693}, {225,0.00011881}, {226,0.00003960}, {227,0.00007921}, {228,0.00015842}, {229,0.00003960}, {230,0.00003960}, {231,0.00022772}, {232,0.00000000}, {233,0.00007921}, {234,0.00006931}, {235,0.00000000}, {236,0.00000000}, {237,0.00006931}, {238,0.00000000}, {239,0.00031683}, {240,0.00000000}, {241,0.00006931}, {242,0.00000000}, {243,0.00007921}, {244,0.00003960}, {245,0.00000000}, {246,0.00000000}, {247,0.00003960}, {248,0.00000000}, {249,0.00000000}, {250,0.00003960}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00003960}, {255,0.00000000}, {256,0.00000000}, {257,0.00007921}, {258,0.00000000}, {259,0.00003960}, {260,0.00000000}, {261,0.00007921}, {262,0.00000000}, {263,0.00003960}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00003960}, {270,0.00002970}, {271,0.00007921}, {272,0.00003960}, {273,0.00000000}, {274,0.00003960}, {275,0.00000000}, {276,0.00002970}, {277,0.00000000}, {278,0.00003960}, {279,0.00000000}, {280,0.00007921}, {281,0.00003960}, {282,0.00003960}, {283,0.00003960}, {284,0.00000000}, {285,0.00000000}, {286,0.00003960}, {287,0.00002970}, {288,0.00003960}, {289,0.00000000}, {290,0.00003960}, {291,0.00003960}, {292,0.00000000}, {293,0.00000000}, {294,0.00003960}, {295,0.00000000}, {296,0.00003960}, {297,0.00000000}, {298,0.00003960}, {299,0.00000000}, {300,0.00000000}, {301,0.00003960}, {302,0.00003960}, {303,0.00003960}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00003960}, {311,0.00003960}, {312,0.00000000}, {313,0.00003960}, {314,0.00000000}, {315,0.00000000}, {316,0.00003960}, {317,0.00000000}, {318,0.00003960}, {319,0.00000000}, {320,0.00003960}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00007921}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00003960}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00003960}, {336,0.00003960}, {337,0.00011881}, {338,0.00003960}, {339,0.00000000}, {340,0.00003960}, {341,0.00005941}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00026733}, {347,0.00000000}, {348,0.00041584}, {349,0.00007921}, {350,0.00051485}, {351,0.00003960}, {352,0.00010891}, {353,0.00003960}, {354,0.00000000}, {355,0.00011881}, {356,0.00000000}, {357,0.00000000}, {358,0.00003960}, {359,0.00015842}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00006931}, {364,0.00011881}, {365,0.00000000}, {366,0.00000000}, {367,0.00015842}, {368,0.00003960}, {369,0.00003960}, {370,0.00011881}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00007921}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00003960}, {381,0.00000000}, {382,0.00003960}, {383,0.00003960}, {384,0.00000000}, {385,0.00003960}, {386,0.00000000}, {387,0.00000000}, {388,0.00003960}, {389,0.00003960}, {390,0.00003960}, {391,0.00003960}, {392,0.00000000}, {393,0.00003960}, {394,0.00000000}, {395,0.00011881}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00003960}, {400,0.00003960}, {401,0.00003960}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00007921}, {407,0.00003960}, {408,0.00000000}, {409,0.00000000}, {410,0.00007921}, {411,0.00003960}, {412,0.00000000}, {413,0.00000000}, {414,0.00003960}, {415,0.00000000}, {416,0.00003960}, {417,0.00007921}, {418,0.00000000}, {419,0.00007921}, {420,0.00003960}, {421,0.00000000}, {422,0.00011881}, {423,0.00003960}, {424,0.00000000}, {425,0.00003960}, {426,0.00007921}, {427,0.00000000}, {428,0.00003960}, {429,0.00000000}, {430,0.00002970}, {431,0.00000000}, {432,0.00000000}, {433,0.00003960}, {434,0.00003960}, {435,0.00000000}, {436,0.00000000}, {437,0.00003960}, {438,0.00003960}, {439,0.00003960}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00003960}, {445,0.00003960}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00003960}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00003960}, {455,0.00015842}, {456,0.00003960}, {457,0.00000000}, {458,0.00003960}, {459,0.00000000}, {460,0.00003960}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003960}, {469,0.00000000}, {470,0.00000000}, {471,0.00003960}, {472,0.00003960}, {473,0.00003960}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00003960}, {479,0.00003960}, {480,0.00000000}, {481,0.00000000}, {482,0.00007921}, {483,0.00000000}, {484,0.00000000}, {485,0.00003960}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00003960}, {492,0.00000000}, {493,0.00006931}, {494,0.00003960}, {495,0.00003960}, {496,0.00000000}, {497,0.00003960}, {498,0.00003960}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00003960}, {520,0.00000000}, {525,0.00000000}, {530,0.00003960}, {535,0.00006931}, {540,0.00000000}, {545,0.00000000}, {550,0.00003960}, {555,0.00000000}, {560,0.00000000}, {565,0.00003960}, {570,0.00003960}, {575,0.00000000}, {580,0.00000000}, {585,0.00003960}, {590,0.00000000}, {595,0.00007921}, {600,0.00000000}, {605,0.00003960}, {610,0.00000000}, {615,0.00000000}, {620,0.00002970}, {625,0.00003960}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00003960}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00003960}, {700,0.00000000}, {705,0.00000000}, {710,0.00003960}, {715,0.00000000}, {720,0.00000000}, {725,0.00007921}, {730,0.00003960}, {735,0.00003960}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00003960}, {760,0.00000000}, {765,0.00015842}, {770,0.00000000}, {775,0.00000000}, {780,0.00007921}, {785,0.00007921}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00003960}, {815,0.00003960}, {820,0.00000000}, {825,0.00002970}, {830,0.00000000}, {835,0.00000000}, {840,0.00007921}, {845,0.00000000}, {850,0.00003960}, {855,0.00003960}, {860,0.00003960}, {865,0.00002970}, {870,0.00003960}, {875,0.00003960}, {880,0.00000000}, {885,0.00000000}, {890,0.00011881}, {895,0.00000000}, {900,0.00003960}, {905,0.00007921}, {910,0.00000000}, {915,0.00007921}, {920,0.00000000}, {925,0.00000000}, {930,0.00007921}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00003960}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00003960}, {985,0.00003960}, {990,0.00003960}, {995,0.00000000}, {1000,0.00003960}, {1010,0.00003960}, {1020,0.00007921}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00003960}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00007921}, {1130,0.00002970}, {1140,0.00007921}, {1150,0.00003960}, {1160,0.00000000}, {1170,0.00003960}, {1180,0.00003960}, {1190,0.00007921}, {1200,0.00000000}, {1210,0.00003960}, {1220,0.00000000}, {1230,0.00010891}, {1240,0.00003960}, {1250,0.00003960}, {1260,0.00000000}, {1270,0.00003960}, {1280,0.00000000}, {1290,0.00003960}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00003960}, {1340,0.00000000}, {1350,0.00011881}, {1360,0.00003960}, {1370,0.00007921}, {1380,0.00003960}, {1390,0.00003960}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00007921}, {1450,0.00003960}, {1460,0.00003960}, {1470,0.00007921}, {1480,0.00003960}, {1490,0.00010891}, {1500,0.00003960}, {1510,0.00003960}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00003960}, {1550,0.00003960}, {1560,0.00007921}, {1570,0.00011881}, {1580,0.00003960}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00007921}, {1620,0.00002970}, {1630,0.00007921}, {1640,0.00000000}, {1650,0.00003960}, {1660,0.00000000}, {1670,0.00003960}, {1680,0.00007921}, {1690,0.00007921}, {1700,0.00000000}, {1710,0.00007921}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00007921}, {1750,0.00000000}, {1760,0.00007921}, {1770,0.00003960}, {1780,0.00003960}, {1790,0.00007921}, {1800,0.00002970}, {1810,0.00000000}, {1820,0.00011881}, {1830,0.00011881}, {1840,0.00011881}, {1850,0.00015842}, {1860,0.00007921}, {1870,0.00007921}, {1880,0.00000000}, {1890,0.00007921}, {1900,0.00003960}, {1910,0.00000000}, {1920,0.00003960}, {1930,0.00010891}, {1940,0.00011881}, {1950,0.00009901}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00003960}, {1990,0.00003960}, {2000,0.00003960}, {2050,0.00019802}, {2100,0.00007921}, {2150,0.00003960}, {2200,0.00000000}, {2250,0.00003960}, {2300,0.00003960}, {2350,0.00006931}, {2400,0.00000000}, {2450,0.00011881}, {2500,0.00003960}, {2550,0.00003960}, {2600,0.00000000}, {2650,0.00010891}, {2700,0.00007921}, {2750,0.00011881}, {2800,0.00039604}, {2850,0.00007921}, {2900,0.00011881}, {2950,0.00003960}, {3000,0.00003960}, {3050,0.00003960}, {3100,0.00015842}, {3150,0.00015842}, {3200,0.00015842}, {3250,0.00003960}, {3300,0.00010891}, {3350,0.00007921}, {3400,0.00011881}, {3450,0.00000000}, {3500,0.00007921}, {3550,0.00000000}, {3600,0.00011881}, {3650,0.00003960}, {3700,0.00026733}, {3750,0.00003960}, {3800,0.00003960}, {3850,0.00003960}, {3900,0.00003960}, {3950,0.00011881}, {4000,0.00007921}, {4050,0.00011881}, {4100,0.00031683}, {4150,0.00007921}, {4200,0.00003960}, {4250,0.00013861}, {4300,0.00011881}, {4350,0.00007921}, {4400,0.00023762}, {4450,0.00011881}, {4500,0.00003960}, {4550,0.00011881}, {4600,0.00011881}, {4650,0.00000000}, {4700,0.00007921}, {4750,0.00019802}, {4800,0.00019802}, {4850,0.00015842}, {4900,0.00051485}, {4950,0.00035644}, {5000,0.00007921}, {5050,0.00011881}, {5100,0.00026733}, {5150,0.00034653}, {5200,0.00005941}, {5250,0.00039604}, {5300,0.00003960}, {5350,0.00015842}, {5400,0.00022772}, {5450,0.00007921}, {5500,0.00014851}, {5550,0.00003960}, {5600,0.00035644}, {5650,0.00015842}, {5700,0.00015842}, {5750,0.00014851}, {5800,0.00027723}, {5850,0.00011881}, {5900,0.00007921}, {5950,0.00007921}, {6000,0.00019802}, {6050,0.0069143}, {6100,0.0028857}, {6150,0.0001143}, {6200,0.0001143}, {6250,0.0003429}, {6300,0.0000000}, {6350,0.0003429}, {6400,0.0004571}, {6450,0.0001143}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0002000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0002000}, {7000,0.0002286}, {7050,0.0001143}, {7100,0.0002286}, {7150,0.0001143}, {7200,0.0000000}, {7250,0.0003429}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0001143}, {7450,0.0002286}, {7500,0.0001143}, {7550,0.0002286}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0004286}, {7850,0.0000000}, {7900,0.0001143}, {7950,0.0000000}, {8000,0.0003429}, {8050,0.0000000}, {8100,0.0002286}, {8150,0.0001143}, {8200,0.0002000}, {8250,0.0003429}, {8300,0.0000000}, {8350,0.0001143}, {8400,0.0000000}, {8450,0.0001143}, {8500,0.0000000}, {8550,0.0003429}, {8600,0.0001143}, {8650,0.0001143}, {8700,0.0002286}, {8750,0.0000000}, {8800,0.0001143}, {8850,0.0003429}, {8900,0.0000000}, {8950,0.0002286}, {9000,0.0001143}, {9050,0.0003429}, {9100,0.0001143}, {9150,0.0000000}, {9200,0.0003143}, {9250,0.0002000}, {9300,0.0000000}, {9350,0.0002286}, {9400,0.0002286}, {9450,0.0001143}, {9500,0.0001143}, {9550,0.0001143}, {9600,0.0002286}, {9650,0.0002286}, {9700,0.0003429}, {9750,0.0001143}, {9800,0.0003429}, {9850,0.0000000}, {9900,0.0001143}, {9950,0.0001143}, {10000,0.0000000}, {10100,0.0002857}, {10200,0.0022571}, {10300,0.0001143}, {10400,0.0004571}, {10500,0.0000000}, {10600,0.0002286}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0002000}, {11000,0.0001143}, {11100,0.0001143}, {11200,0.0003143}, {11300,0.0003429}, {11400,0.0001143}, {11500,0.0003429}, {11600,0.0005714}, {11700,0.0001143}, {11800,0.0004571}, {11900,0.0001143}, {12000,0.0000000}, {12100,0.0003429}, {12200,0.0000000}, {12300,0.0003143}, {12400,0.0001143}, {12500,0.0003429}, {12600,0.0001143}, {12700,0.0000000}, {12800,0.0002286}, {12900,0.0001143}, {13000,0.0000000}, {13100,0.0002286}, {13200,0.0010286}, {13300,0.0001143}, {13400,0.0003429}, {13500,0.0001143}, {13600,0.0000000}, {13700,0.0001143}, {13800,0.0003429}, {13900,0.0001143}, {14000,0.0001143}, {14100,0.0000000}, {14200,0.0001143}, {14300,0.0002286}, {14400,0.0001143}, {14500,0.0009143}, {14600,0.0010286}, {14700,0.0006571}, {14800,0.0000000}, {14900,0.0013143}, {15000,0.0001143}, {15100,0.0020857}, {15200,0.0002286}, {15300,0.0014857}, {15400,0.0008857}, {15500,0.0008000}, {15600,0.0006857}, {15700,0.0004286}, {15800,0.0002000}, {15900,0.0008000}, {16000,0.0008000}, {16100,0.0004571}, {16200,0.0013429}, {16300,0.0004571}, {16400,0.0010286}, {16500,0.0015714}, {16600,0.0011143}, {16700,0.0012571}, {16800,0.0000857}, {16900,0.0019143}, {17000,0.0003429}, {17100,0.0002286}, {17200,0.0010286}, {17300,0.0013429}, {17400,0.0014571}, {17500,0.0024000}, {17600,0.0003429}, {17700,0.0008000}, {17800,0.0012571}, {17900,0.0002286}, {18000,0.0011143}, {18100,0.0000000}, {18200,0.0002286}, {18300,0.0016857}, {18400,0.0012571}, {18500,0.0008000}, {18600,0.0016000}, {18700,0.0009143}, {18800,0.0003429}, {18900,0.0006857}, {19000,0.0010000}, {19100,0.0004571}, {19200,0.0008000}, {19300,0.0003429}, {19400,0.0027429}, {19500,0.0009143}, {19600,0.0011143}, {19700,0.0021714}, {19800,0.0017143}, {19900,0.0039429}, {20000,0.0023714}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["post"]["user"] = {{1,0.00003960}, {2,0.00002970}, {3,0.00003960}, {4,0.00003960}, {5,0.00000000}, {6,0.00002970}, {7,0.00002970}, {8,0.00003960}, {9,0.00002970}, {10,0.00000000}, {11,0.00003960}, {12,0.00003960}, {13,0.00006931}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00007921}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00002970}, {24,0.00000000}, {25,0.00010891}, {26,0.00006931}, {27,0.00000000}, {28,0.00007921}, {29,0.00002970}, {30,0.00005941}, {31,0.00003960}, {32,0.00000000}, {33,0.00006931}, {34,0.00010891}, {35,0.00000000}, {36,0.00003960}, {37,0.00003960}, {38,0.00000000}, {39,0.00003960}, {40,0.00002970}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00003960}, {45,0.00002970}, {46,0.00006931}, {47,0.00000000}, {48,0.00000000}, {49,0.00007921}, {50,0.00000000}, {51,0.00000000}, {52,0.00005941}, {53,0.00002970}, {54,0.00000000}, {55,0.00003960}, {56,0.00000000}, {57,0.00003960}, {58,0.00007921}, {59,0.00003960}, {60,0.00000000}, {61,0.00003960}, {62,0.00006931}, {63,0.00002970}, {64,0.00005941}, {65,0.00011881}, {66,0.00006931}, {67,0.00003960}, {68,0.00002970}, {69,0.00002970}, {70,0.00002970}, {71,0.00002970}, {72,0.00003960}, {73,0.00002970}, {74,0.00000000}, {75,0.00000000}, {76,0.00002970}, {77,0.00002970}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00005941}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00008911}, {88,0.00002970}, {89,0.00000000}, {90,0.00002970}, {91,0.00002970}, {92,0.00002970}, {93,0.00008911}, {94,0.00002970}, {95,0.00013861}, {96,0.00000000}, {97,0.00005941}, {98,0.00002970}, {99,0.00008911}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00007921}, {104,0.00002970}, {105,0.00003960}, {106,0.00003960}, {107,0.00006931}, {108,0.00000000}, {109,0.00000000}, {110,0.00002970}, {111,0.00000000}, {112,0.00000000}, {113,0.00005941}, {114,0.00005941}, {115,0.00003960}, {116,0.00003960}, {117,0.00006931}, {118,0.00003960}, {119,0.00002970}, {120,0.00002970}, {121,0.00000000}, {122,0.00002970}, {123,0.00002970}, {124,0.00006931}, {125,0.00002970}, {126,0.00000000}, {127,0.00002970}, {128,0.00005941}, {129,0.00003960}, {130,0.00002970}, {131,0.00000000}, {132,0.00003960}, {133,0.00002970}, {134,0.00000000}, {135,0.00002970}, {136,0.00006931}, {137,0.00000000}, {138,0.00006931}, {139,0.00000000}, {140,0.00003960}, {141,0.00009901}, {142,0.00002970}, {143,0.00003960}, {144,0.00003960}, {145,0.00002970}, {146,0.00002970}, {147,0.00002970}, {148,0.00003960}, {149,0.00013861}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00003960}, {154,0.00002970}, {155,0.00000000}, {156,0.00000000}, {157,0.00003960}, {158,0.00000000}, {159,0.00000000}, {160,0.00003960}, {161,0.00000000}, {162,0.00003960}, {163,0.00003960}, {164,0.00006931}, {165,0.00002970}, {166,0.00002970}, {167,0.00002970}, {168,0.00002970}, {169,0.00011881}, {170,0.00003960}, {171,0.00000000}, {172,0.00006931}, {173,0.00000000}, {174,0.00006931}, {175,0.00000000}, {176,0.00000000}, {177,0.00003960}, {178,0.00002970}, {179,0.00002970}, {180,0.00000000}, {181,0.00002970}, {182,0.00010891}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00010891}, {187,0.00000000}, {188,0.00003960}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00006931}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00003960}, {200,0.00005941}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00003960}, {205,0.00003960}, {206,0.00003960}, {207,0.00003960}, {208,0.00000000}, {209,0.00003960}, {210,0.00000000}, {211,0.00010891}, {212,0.00002970}, {213,0.00002970}, {214,0.00000000}, {215,0.00000000}, {216,0.00003960}, {217,0.00003960}, {218,0.00002970}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00002970}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00003960}, {231,0.00000000}, {232,0.00000000}, {233,0.00003960}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00006931}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00002970}, {242,0.00002970}, {243,0.00010891}, {244,0.00000000}, {245,0.00000000}, {246,0.00010891}, {247,0.00002970}, {248,0.00003960}, {249,0.00000000}, {250,0.00005941}, {251,0.00006931}, {252,0.00005941}, {253,0.00002970}, {254,0.00002970}, {255,0.00000000}, {256,0.00000000}, {257,0.00002970}, {258,0.00000000}, {259,0.00003960}, {260,0.00009901}, {261,0.00000000}, {262,0.00006931}, {263,0.00007921}, {264,0.00008911}, {265,0.00000000}, {266,0.00003960}, {267,0.00003960}, {268,0.00006931}, {269,0.00006931}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00002970}, {274,0.00002970}, {275,0.00002970}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00002970}, {280,0.00006931}, {281,0.00000000}, {282,0.00000000}, {283,0.00002970}, {284,0.00002970}, {285,0.00006931}, {286,0.00002970}, {287,0.00008911}, {288,0.00000000}, {289,0.00006931}, {290,0.00000000}, {291,0.00003960}, {292,0.00003960}, {293,0.00003960}, {294,0.00002970}, {295,0.00002970}, {296,0.00005941}, {297,0.00000000}, {298,0.00002970}, {299,0.00002970}, {300,0.00000000}, {301,0.00000000}, {302,0.00007921}, {303,0.00000000}, {304,0.00002970}, {305,0.00002970}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00003960}, {314,0.00007921}, {315,0.00005941}, {316,0.00010891}, {317,0.00009901}, {318,0.00006931}, {319,0.00003960}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00002970}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00006931}, {328,0.00003960}, {329,0.00002970}, {330,0.00003960}, {331,0.00000000}, {332,0.00000000}, {333,0.00003960}, {334,0.00002970}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00002970}, {339,0.00008911}, {340,0.00005941}, {341,0.00005941}, {342,0.00000000}, {343,0.00003960}, {344,0.00002970}, {345,0.00002970}, {346,0.00006931}, {347,0.00000000}, {348,0.00000000}, {349,0.00002970}, {350,0.00000000}, {351,0.00003960}, {352,0.00000000}, {353,0.00003960}, {354,0.00009901}, {355,0.00003960}, {356,0.00003960}, {357,0.00007921}, {358,0.00000000}, {359,0.00002970}, {360,0.00003960}, {361,0.00003960}, {362,0.00003960}, {363,0.00014851}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00002970}, {368,0.00003960}, {369,0.00010891}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00007921}, {375,0.00000000}, {376,0.00003960}, {377,0.00000000}, {378,0.00003960}, {379,0.00002970}, {380,0.00002970}, {381,0.00007921}, {382,0.00000000}, {383,0.00006931}, {384,0.00003960}, {385,0.00000000}, {386,0.00003960}, {387,0.00010891}, {388,0.00002970}, {389,0.00002970}, {390,0.00000000}, {391,0.00003960}, {392,0.00002970}, {393,0.00006931}, {394,0.00003960}, {395,0.00000000}, {396,0.00007921}, {397,0.00002970}, {398,0.00003960}, {399,0.00002970}, {400,0.00000000}, {401,0.00005941}, {402,0.00002970}, {403,0.00003960}, {404,0.00014851}, {405,0.00007921}, {406,0.00000000}, {407,0.00002970}, {408,0.00007921}, {409,0.00003960}, {410,0.00003960}, {411,0.00002970}, {412,0.00000000}, {413,0.00000000}, {414,0.00003960}, {415,0.00000000}, {416,0.00002970}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00002970}, {421,0.00003960}, {422,0.00000000}, {423,0.00006931}, {424,0.00000000}, {425,0.00016832}, {426,0.00000000}, {427,0.00002970}, {428,0.00003960}, {429,0.00003960}, {430,0.00002970}, {431,0.00003960}, {432,0.00000000}, {433,0.00010891}, {434,0.00000000}, {435,0.00002970}, {436,0.00002970}, {437,0.00002970}, {438,0.00002970}, {439,0.00003960}, {440,0.00003960}, {441,0.00000000}, {442,0.00000000}, {443,0.00009901}, {444,0.00000000}, {445,0.00003960}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00003960}, {450,0.00000000}, {451,0.00009901}, {452,0.00003960}, {453,0.00006931}, {454,0.00002970}, {455,0.00010891}, {456,0.00006931}, {457,0.00002970}, {458,0.00000000}, {459,0.00000000}, {460,0.00003960}, {461,0.00000000}, {462,0.00003960}, {463,0.00015842}, {464,0.00002970}, {465,0.00000000}, {466,0.00000000}, {467,0.00003960}, {468,0.00002970}, {469,0.00000000}, {470,0.00000000}, {471,0.00006931}, {472,0.00000000}, {473,0.00003960}, {474,0.00003960}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00002970}, {481,0.00002970}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00006931}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00003960}, {491,0.00000000}, {492,0.00000000}, {493,0.00007921}, {494,0.00002970}, {495,0.00000000}, {496,0.00000000}, {497,0.00003960}, {498,0.00002970}, {499,0.00002970}, {500,0.00000000}, {505,0.00003960}, {510,0.00002970}, {515,0.00000000}, {520,0.00006931}, {525,0.00000000}, {530,0.00002970}, {535,0.00006931}, {540,0.00005941}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00008911}, {565,0.00006931}, {570,0.00005941}, {575,0.00002970}, {580,0.00000000}, {585,0.00000000}, {590,0.00005941}, {595,0.00002970}, {600,0.00006931}, {605,0.00005941}, {610,0.00002970}, {615,0.00000000}, {620,0.00002970}, {625,0.00002970}, {630,0.00006931}, {635,0.00000000}, {640,0.00012871}, {645,0.00002970}, {650,0.00000000}, {655,0.00002970}, {660,0.00002970}, {665,0.00000000}, {670,0.00005941}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00002970}, {695,0.00002970}, {700,0.00006931}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00007921}, {735,0.00005941}, {740,0.00002970}, {745,0.00002970}, {750,0.00006931}, {755,0.00005941}, {760,0.00000000}, {765,0.00000000}, {770,0.00002970}, {775,0.00000000}, {780,0.00003960}, {785,0.00003960}, {790,0.00002970}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00006931}, {825,0.00000000}, {830,0.00005941}, {835,0.00000000}, {840,0.00000000}, {845,0.00009901}, {850,0.00002970}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00002970}, {875,0.00002970}, {880,0.00002970}, {885,0.00006931}, {890,0.00003960}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00005941}, {940,0.00006931}, {945,0.00002970}, {950,0.00016832}, {955,0.00000000}, {960,0.00014851}, {965,0.00000000}, {970,0.00009901}, {975,0.00002970}, {980,0.00000000}, {985,0.00000000}, {990,0.00002970}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00005941}, {1020,0.00000000}, {1030,0.00002970}, {1040,0.00000000}, {1050,0.00005941}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00006931}, {1130,0.00009901}, {1140,0.00002970}, {1150,0.00000000}, {1160,0.00006931}, {1170,0.00000000}, {1180,0.00002970}, {1190,0.00007921}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00002970}, {1230,0.00002970}, {1240,0.00002970}, {1250,0.00000000}, {1260,0.00002970}, {1270,0.00002970}, {1280,0.00006931}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00003960}, {1350,0.00005941}, {1360,0.00003960}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00002970}, {1400,0.00000000}, {1410,0.00002970}, {1420,0.00009901}, {1430,0.00000000}, {1440,0.00003960}, {1450,0.00008911}, {1460,0.00003960}, {1470,0.00000000}, {1480,0.00003960}, {1490,0.00007921}, {1500,0.00011881}, {1510,0.00003960}, {1520,0.00000000}, {1530,0.00007921}, {1540,0.00003960}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00007921}, {1580,0.00007921}, {1590,0.00003960}, {1600,0.00000000}, {1610,0.00006931}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003960}, {1670,0.00006931}, {1680,0.00000000}, {1690,0.00007921}, {1700,0.00006931}, {1710,0.00003960}, {1720,0.00003960}, {1730,0.00002970}, {1740,0.00000000}, {1750,0.00003960}, {1760,0.00002970}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00006931}, {1800,0.00006931}, {1810,0.00003960}, {1820,0.00010891}, {1830,0.00003960}, {1840,0.00003960}, {1850,0.00003960}, {1860,0.00003960}, {1870,0.00005941}, {1880,0.00003960}, {1890,0.00000000}, {1900,0.00003960}, {1910,0.00000000}, {1920,0.00007921}, {1930,0.00000000}, {1940,0.00003960}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00008911}, {1980,0.00002970}, {1990,0.00003960}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00003960}, {2250,0.00003960}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00003960}, {2450,0.00003960}, {2500,0.00000000}, {2550,0.00003960}, {2600,0.00003960}, {2650,0.00000000}, {2700,0.00007921}, {2750,0.00000000}, {2800,0.00011881}, {2850,0.00003960}, {2900,0.00003960}, {2950,0.00007921}, {3000,0.00007921}, {3050,0.00000000}, {3100,0.00005941}, {3150,0.00002970}, {3200,0.00003960}, {3250,0.00006931}, {3300,0.00003960}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00003960}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00003960}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00002970}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00002970}, {4150,0.00006931}, {4200,0.00003960}, {4250,0.00002970}, {4300,0.00000000}, {4350,0.00002970}, {4400,0.00000000}, {4450,0.00006931}, {4500,0.00003960}, {4550,0.00003960}, {4600,0.00000000}, {4650,0.00002970}, {4700,0.00003960}, {4750,0.00003960}, {4800,0.00007921}, {4850,0.00011881}, {4900,0.00002970}, {4950,0.00003960}, {5000,0.00003960}, {5050,0.00000000}, {5100,0.00011881}, {5150,0.00000000}, {5200,0.00010891}, {5250,0.00000000}, {5300,0.00003960}, {5350,0.00000000}, {5400,0.00003960}, {5450,0.00003960}, {5500,0.00007921}, {5550,0.00007921}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00003960}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00002970}, {5950,0.00005941}, {6000,0.00000000}, {6050,0.0001143}, {6100,0.0000000}, {6150,0.0001143}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0001143}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0001143}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0002857}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000857}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0003143}, {7450,0.0000857}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0001143}, {7700,0.0002286}, {7750,0.0000857}, {7800,0.0000000}, {7850,0.0000857}, {7900,0.0000000}, {7950,0.0001143}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000857}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000857}, {8700,0.0002286}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0001143}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0002286}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0001143}, {9450,0.0000000}, {9500,0.0001143}, {9550,0.0000000}, {9600,0.0000857}, {9650,0.0001143}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0001143}, {10200,0.0001143}, {10300,0.0000857}, {10400,0.0000000}, {10500,0.0004571}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0001143}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000857}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0001143}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0001143}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000857}, {13200,0.0000857}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0001143}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0002000}, {14400,0.0001143}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000857}, {14900,0.0000857}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000857}, {15400,0.0000000}, {15500,0.0001143}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000857}, {15900,0.0000000}, {16000,0.0001143}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000857}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000857}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000857}, {18000,0.0000000}, {18100,0.0000857}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0001143}, {18900,0.0000857}, {19000,0.0000000}, {19100,0.0001143}, {19200,0.0000857}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000857}, {19700,0.0000857}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000857}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00003960}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00003960}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00003960}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00003960}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00003960}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00003960}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00003960}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00002970}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00003960}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00003960}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00003960}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00008911}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00002970}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00002970}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00002970}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00002970}, {98,0.00000000}, {99,0.00002970}, {100,0.00000000}, {101,0.00000000}, {102,0.00002970}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00003960}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00003960}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00002970}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00003960}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00003960}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00002970}, {186,0.00000000}, {187,0.00000000}, {188,0.00003960}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00002970}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00002970}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00003960}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00009901}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00003960}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00003960}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00003960}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00002970}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00002970}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00002970}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00002970}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00002970}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00002970}, {305,0.00000000}, {306,0.00002970}, {307,0.00000000}, {308,0.00000000}, {309,0.00002970}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00002970}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00003960}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00002970}, {342,0.00003960}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00003960}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00002970}, {361,0.00000000}, {362,0.00000000}, {363,0.00003960}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00003960}, {369,0.00000000}, {370,0.00000000}, {371,0.00003960}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00002970}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00002970}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00003960}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00003960}, {452,0.00000000}, {453,0.00000000}, {454,0.00003960}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00002970}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00002970}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00003960}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00003960}, {497,0.00006931}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00006931}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00007921}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00002970}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00002970}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00002970}, {850,0.00002970}, {855,0.00002970}, {860,0.00000000}, {865,0.00000000}, {870,0.00002970}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00002970}, {920,0.00003960}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00002970}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00007921}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00002970}, {1120,0.00000000}, {1130,0.00002970}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00003960}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00002970}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00003960}, {1310,0.00000000}, {1320,0.00002970}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00003960}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00003960}, {1480,0.00002970}, {1490,0.00002970}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00002970}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00003960}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00003960}, {1700,0.00003960}, {1710,0.00003960}, {1720,0.00000000}, {1730,0.00002970}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00002970}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00003960}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00005941}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00003960}, {2300,0.00000000}, {2350,0.00003960}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00003960}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00002970}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00002970}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00003960}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0001143}, {6600,0.0001143}, {6650,0.0001143}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0001143}, {7200,0.0000000}, {7250,0.0001143}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0001143}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0001143}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0001143}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0001143}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0001143}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000857}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000857}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000857}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0001143}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000857}, {17400,0.0001143}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00003960}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00003960}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00021782}, {6,0.00100000}, {7,0.00100000}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00128713}, {13,0.00178218}, {14,0.00200000}, {15,0.00200000}, {16,0.00200000}, {17,0.00200000}, {18,0.00200990}, {19,0.00218812}, {20,0.00247525}, {21,0.00300000}, {22,0.00300000}, {23,0.00300000}, {24,0.00300000}, {25,0.00305941}, {26,0.00316832}, {27,0.00339604}, {28,0.00385149}, {29,0.00400000}, {30,0.00400000}, {31,0.00400000}, {32,0.00402970}, {33,0.00431683}, {34,0.00512871}, {35,0.00473267}, {36,0.00500000}, {37,0.00500000}, {38,0.00501980}, {39,0.00509901}, {40,0.00520792}, {41,0.00534653}, {42,0.00540594}, {43,0.00746535}, {44,0.00600000}, {45,0.00826733}, {46,0.00612871}, {47,0.00766337}, {48,0.00622772}, {49,0.00629703}, {50,0.00657426}, {51,0.00700990}, {52,0.00701980}, {53,0.00716832}, {54,0.00726733}, {55,0.00718812}, {56,0.00727723}, {57,0.00748515}, {58,0.00786139}, {59,0.00983168}, {60,0.00818812}, {61,0.00810891}, {62,0.01119802}, {63,0.00838614}, {64,0.00831683}, {65,0.01013861}, {66,0.00902970}, {67,0.00907921}, {68,0.00913861}, {69,0.00929703}, {70,0.00918812}, {71,0.00938614}, {72,0.00954455}, {73,0.01392079}, {74,0.01004950}, {75,0.01027723}, {76,0.01009901}, {77,0.01021782}, {78,0.01400990}, {79,0.01063366}, {80,0.01064356}, {81,0.01108911}, {82,0.01109901}, {83,0.01114851}, {84,0.01106931}, {85,0.01420792}, {86,0.01137624}, {87,0.01190099}, {88,0.01189109}, {89,0.01217822}, {90,0.01213861}, {91,0.01213861}, {92,0.01217822}, {93,0.01253465}, {94,0.01261386}, {95,0.01300990}, {96,0.01298020}, {97,0.01325743}, {98,0.01314851}, {99,0.01337624}, {100,0.01338614}, {101,0.01367327}, {102,0.01364356}, {103,0.01401980}, {104,0.01432673}, {105,0.02021782}, {106,0.01717822}, {107,0.01422772}, {108,0.01456436}, {109,0.01467327}, {110,0.01495050}, {111,0.01515842}, {112,0.01523762}, {113,0.01937624}, {114,0.01527723}, {115,0.01562376}, {116,0.01561386}, {117,0.01584158}, {118,0.02045545}, {119,0.01617822}, {120,0.01621782}, {121,0.01651485}, {122,0.02216832}, {123,0.01659406}, {124,0.01678218}, {125,0.01708911}, {126,0.01886139}, {127,0.01717822}, {128,0.01739604}, {129,0.02075248}, {130,0.01742574}, {131,0.01770297}, {132,0.02034653}, {133,0.01801980}, {134,0.01835644}, {135,0.01823762}, {136,0.01835644}, {137,0.02370297}, {138,0.01858416}, {139,0.01884158}, {140,0.01891089}, {141,0.01928713}, {142,0.01947525}, {143,0.01942574}, {144,0.02171287}, {145,0.01962376}, {146,0.02278218}, {147,0.02021782}, {148,0.02283168}, {149,0.02038614}, {150,0.02158416}, {151,0.02078218}, {152,0.02036634}, {153,0.02074257}, {154,0.02081188}, {155,0.02811881}, {156,0.02131683}, {157,0.02263366}, {158,0.02168317}, {159,0.02177228}, {160,0.02649505}, {161,0.02173267}, {162,0.02188119}, {163,0.02868317}, {164,0.02230693}, {165,0.02234653}, {166,0.02817822}, {167,0.02282178}, {168,0.02258416}, {169,0.02496040}, {170,0.02339604}, {171,0.02333663}, {172,0.02327723}, {173,0.02642574}, {174,0.02372277}, {175,0.02401980}, {176,0.02391089}, {177,0.02396040}, {178,0.02923762}, {179,0.02435644}, {180,0.02440594}, {181,0.02486139}, {182,0.02463366}, {183,0.02480198}, {184,0.02835644}, {185,0.03213861}, {186,0.02523762}, {187,0.02554455}, {188,0.02571287}, {189,0.02561386}, {190,0.02590099}, {191,0.02622772}, {192,0.02589109}, {193,0.02615842}, {194,0.02634653}, {195,0.02646535}, {196,0.02637624}, {197,0.02661386}, {198,0.02678218}, {199,0.02697030}, {200,0.02703960}, {201,0.02738614}, {202,0.02726733}, {203,0.02756436}, {204,0.02767327}, {205,0.02799010}, {206,0.02810891}, {207,0.02843564}, {208,0.02825743}, {209,0.03838614}, {210,0.03369307}, {211,0.02872277}, {212,0.02859406}, {213,0.02909901}, {214,0.02914851}, {215,0.03111881}, {216,0.03507921}, {217,0.02954455}, {218,0.02972277}, {219,0.02981188}, {220,0.04094059}, {221,0.03374257}, {222,0.03028713}, {223,0.03045545}, {224,0.04154455}, {225,0.03334653}, {226,0.03050495}, {227,0.03119802}, {228,0.03612871}, {229,0.03124752}, {230,0.03142574}, {231,0.03892079}, {232,0.03140594}, {233,0.03177228}, {234,0.03788119}, {235,0.03184158}, {236,0.03228713}, {237,0.03460396}, {238,0.03248515}, {239,0.04019802}, {240,0.03273267}, {241,0.03297030}, {242,0.03294059}, {243,0.03337624}, {244,0.03520792}, {245,0.03370297}, {246,0.03684158}, {247,0.03392079}, {248,0.03786139}, {249,0.03394059}, {250,0.03750495}, {251,0.03475248}, {252,0.03581188}, {253,0.03450495}, {254,0.03473267}, {255,0.04549505}, {256,0.03470297}, {257,0.04111881}, {258,0.03516832}, {259,0.03547525}, {260,0.04734653}, {261,0.03570297}, {262,0.03966337}, {263,0.03577228}, {264,0.03568317}, {265,0.04151485}, {266,0.03615842}, {267,0.03636634}, {268,0.03997030}, {269,0.05474257}, {270,0.03721782}, {271,0.03728713}, {272,0.04720792}, {273,0.03721782}, {274,0.03765347}, {275,0.03773267}, {276,0.04445545}, {277,0.05106931}, {278,0.03779208}, {279,0.03830693}, {280,0.03926733}, {281,0.04471287}, {282,0.04954455}, {283,0.03912871}, {284,0.03910891}, {285,0.03885149}, {286,0.03900990}, {287,0.04090099}, {288,0.04374257}, {289,0.04670297}, {290,0.04895050}, {291,0.05172277}, {292,0.03998020}, {293,0.04031683}, {294,0.04059406}, {295,0.04051485}, {296,0.04057426}, {297,0.04054455}, {298,0.04086139}, {299,0.04123762}, {300,0.04115842}, {301,0.04125743}, {302,0.04165347}, {303,0.04170297}, {304,0.04167327}, {305,0.06036634}, {306,0.05387129}, {307,0.05168317}, {308,0.04926733}, {309,0.04650495}, {310,0.04231683}, {311,0.04269307}, {312,0.04266337}, {313,0.04295050}, {314,0.05614851}, {315,0.05252475}, {316,0.04733663}, {317,0.04361386}, {318,0.04393069}, {319,0.04444554}, {320,0.05297030}, {321,0.04727723}, {322,0.04373267}, {323,0.04454455}, {324,0.05530693}, {325,0.04946535}, {326,0.04437624}, {327,0.04493069}, {328,0.05390099}, {329,0.04684158}, {330,0.04518812}, {331,0.06209901}, {332,0.04977228}, {333,0.04561386}, {334,0.05779208}, {335,0.04799010}, {336,0.04592079}, {337,0.05584158}, {338,0.04594059}, {339,0.06145545}, {340,0.05042574}, {341,0.04700000}, {342,0.05490099}, {343,0.04703960}, {344,0.05737624}, {345,0.04700990}, {346,0.06075248}, {347,0.04795050}, {348,0.06129703}, {349,0.04799010}, {350,0.06083168}, {351,0.04831683}, {352,0.05995050}, {353,0.04797030}, {354,0.05548515}, {355,0.04893069}, {356,0.05720792}, {357,0.04869307}, {358,0.05389109}, {359,0.06469307}, {360,0.04907921}, {361,0.05818812}, {362,0.04977228}, {363,0.05131683}, {364,0.06167327}, {365,0.05019802}, {366,0.05239604}, {367,0.06155446}, {368,0.05028713}, {369,0.05050495}, {370,0.05753465}, {371,0.06651485}, {372,0.05111881}, {373,0.05481188}, {374,0.06112871}, {375,0.05200000}, {376,0.05141584}, {377,0.05435644}, {378,0.05963366}, {379,0.06613861}, {380,0.05248515}, {381,0.05219802}, {382,0.05417822}, {383,0.05843564}, {384,0.06263366}, {385,0.06838614}, {386,0.05250495}, {387,0.05269307}, {388,0.05305941}, {389,0.05472277}, {390,0.05787129}, {391,0.06049505}, {392,0.06218812}, {393,0.06448515}, {394,0.06622772}, {395,0.06575248}, {396,0.06871287}, {397,0.06984158}, {398,0.07032673}, {399,0.07902970}, {400,0.07611881}, {401,0.07357426}, {402,0.07360396}, {403,0.07206931}, {404,0.07053465}, {405,0.07034653}, {406,0.06820792}, {407,0.06623762}, {408,0.06297030}, {409,0.06144554}, {410,0.05891089}, {411,0.05680198}, {412,0.05641584}, {413,0.05699010}, {414,0.07221782}, {415,0.07167327}, {416,0.06817822}, {417,0.06197030}, {418,0.05694059}, {419,0.05770297}, {420,0.07535644}, {421,0.06973267}, {422,0.06211881}, {423,0.05832673}, {424,0.05819802}, {425,0.07074257}, {426,0.06395050}, {427,0.05853465}, {428,0.07571287}, {429,0.06860396}, {430,0.06105941}, {431,0.05976238}, {432,0.06995050}, {433,0.06397030}, {434,0.05955446}, {435,0.07433663}, {436,0.06228713}, {437,0.06265347}, {438,0.07042574}, {439,0.06089109}, {440,0.07554455}, {441,0.06471287}, {442,0.06279208}, {443,0.06820792}, {444,0.06101980}, {445,0.07123762}, {446,0.06151485}, {447,0.07310891}, {448,0.06104950}, {449,0.07823762}, {450,0.06326733}, {451,0.08145545}, {452,0.06327723}, {453,0.07749505}, {454,0.06232673}, {455,0.07541584}, {456,0.06231683}, {457,0.07221782}, {458,0.06494059}, {459,0.06777228}, {460,0.07792079}, {461,0.06331683}, {462,0.07277228}, {463,0.08226733}, {464,0.06611881}, {465,0.07565347}, {466,0.06370297}, {467,0.07022772}, {468,0.07887129}, {469,0.06441584}, {470,0.06775248}, {471,0.07400990}, {472,0.08366337}, {473,0.06522772}, {474,0.07091089}, {475,0.07806931}, {476,0.08395050}, {477,0.06594059}, {478,0.07023762}, {479,0.07623762}, {480,0.08441584}, {481,0.06592079}, {482,0.06619802}, {483,0.07168317}, {484,0.07673267}, {485,0.07768317}, {486,0.08462376}, {487,0.08780198}, {488,0.06695050}, {489,0.06855446}, {490,0.07104950}, {491,0.07431683}, {492,0.07642574}, {493,0.08062376}, {494,0.08394059}, {495,0.08319802}, {496,0.08450495}, {497,0.08269307}, {498,0.08596040}, {499,0.08666337}, {500,0.08658416}, {505,0.08576238}, {510,0.08401980}, {515,0.08103960}, {520,0.07765347}, {525,0.07247525}, {530,0.10008911}, {535,0.08610891}, {540,0.07552475}, {545,0.09210891}, {550,0.07985149}, {555,0.09250495}, {560,0.07866337}, {565,0.08865347}, {570,0.09725743}, {575,0.08009901}, {580,0.08907921}, {585,0.09454455}, {590,0.09709901}, {595,0.09942574}, {600,0.09947525}, {605,0.09904950}, {610,0.09779208}, {615,0.09591089}, {620,0.09557426}, {625,0.08736634}, {630,0.10884158}, {635,0.09984158}, {640,0.09012871}, {645,0.10579208}, {650,0.09516832}, {655,0.10736634}, {660,0.09453465}, {665,0.10659406}, {670,0.11681188}, {675,0.09724752}, {680,0.10358416}, {685,0.10819802}, {690,0.11155446}, {695,0.11496040}, {700,0.12045545}, {705,0.11951485}, {710,0.11783168}, {715,0.11440594}, {720,0.11086139}, {725,0.10740594}, {730,0.13697030}, {735,0.12128713}, {740,0.11034653}, {745,0.12637624}, {750,0.11449505}, {755,0.12667327}, {760,0.11837624}, {765,0.12681188}, {770,0.13491089}, {775,0.11644554}, {780,0.12292079}, {785,0.12792079}, {790,0.13711881}, {795,0.14022772}, {800,0.14088119}, {805,0.13916832}, {810,0.13785149}, {815,0.14813861}, {820,0.13670297}, {825,0.13160396}, {830,0.12459406}, {835,0.14079208}, {840,0.14299010}, {845,0.15441584}, {850,0.14129703}, {855,0.15107921}, {860,0.13842574}, {865,0.16273267}, {870,0.13679208}, {875,0.14391089}, {880,0.14814851}, {885,0.15328713}, {890,0.13795050}, {895,0.13745545}, {900,0.13806931}, {905,0.13844554}, {910,0.13751485}, {915,0.16475248}, {920,0.15889109}, {925,0.15320792}, {930,0.14764356}, {935,0.14946535}, {940,0.16273267}, {945,0.15163366}, {950,0.16277228}, {955,0.15179208}, {960,0.16883168}, {965,0.15179208}, {970,0.15903960}, {975,0.16687129}, {980,0.15429703}, {985,0.15910891}, {990,0.16001980}, {995,0.16357426}, {1000,0.17068317}, {1010,0.16910891}, {1020,0.16371287}, {1030,0.15714851}, {1040,0.18489109}, {1050,0.17173267}, {1060,0.18208911}, {1070,0.18139604}, {1080,0.18145545}, {1090,0.18374257}, {1100,0.18496040}, {1110,0.19591089}, {1120,0.18895050}, {1130,0.18441584}, {1140,0.18227723}, {1150,0.19786139}, {1160,0.18171287}, {1170,0.21032673}, {1180,0.20649505}, {1190,0.20711881}, {1200,0.19062376}, {1210,0.19131683}, {1220,0.21134653}, {1230,0.21552475}, {1240,0.20541584}, {1250,0.21594059}, {1260,0.21236634}, {1270,0.21809901}, {1280,0.19979208}, {1290,0.21367327}, {1300,0.21202970}, {1310,0.23271287}, {1320,0.21575248}, {1330,0.20898020}, {1340,0.23759406}, {1350,0.22106931}, {1360,0.23090099}, {1370,0.22701980}, {1380,0.22782178}, {1390,0.25650495}, {1400,0.24140594}, {1410,0.23692079}, {1420,0.24618812}, {1430,0.23504950}, {1440,0.24349505}, {1450,0.24932673}, {1460,0.23584158}, {1470,0.24997030}, {1480,0.25277228}, {1490,0.24505941}, {1500,0.24136634}, {1510,0.26067327}, {1520,0.24501980}, {1530,0.25959406}, {1540,0.25588119}, {1550,0.24905941}, {1560,0.27371287}, {1570,0.25079208}, {1580,0.27103960}, {1590,0.26612871}, {1600,0.28113861}, {1610,0.27257426}, {1620,0.28366337}, {1630,0.27003960}, {1640,0.27507921}, {1650,0.28175248}, {1660,0.28818812}, {1670,0.28177228}, {1680,0.28818812}, {1690,0.27717822}, {1700,0.30233663}, {1710,0.28304950}, {1720,0.29705941}, {1730,0.27798020}, {1740,0.30839604}, {1750,0.28936634}, {1760,0.28991089}, {1770,0.29238614}, {1780,0.30635644}, {1790,0.31837624}, {1800,0.28924752}, {1810,0.30051485}, {1820,0.29577228}, {1830,0.33989109}, {1840,0.30571287}, {1850,0.31022772}, {1860,0.31396040}, {1870,0.30939604}, {1880,0.30319802}, {1890,0.32104950}, {1900,0.33983168}, {1910,0.32444554}, {1920,0.33529703}, {1930,0.32170297}, {1940,0.32014851}, {1950,0.35122772}, {1960,0.32473267}, {1970,0.34191089}, {1980,0.32976238}, {1990,0.32885149}, {2000,0.34253465}, {2050,0.33216832}, {2100,0.35345545}, {2150,0.36886139}, {2200,0.36161386}, {2250,0.39241584}, {2300,0.41018812}, {2350,0.38758416}, {2400,0.40774257}, {2450,0.41563366}, {2500,0.42732673}, {2550,0.43730693}, {2600,0.46960396}, {2650,0.43078218}, {2700,0.44932673}, {2750,0.47580198}, {2800,0.47121782}, {2850,0.50094059}, {2900,0.51116832}, {2950,0.50477228}, {3000,0.51857426}, {3050,0.51994059}, {3100,0.53294059}, {3150,0.52867327}, {3200,0.54142574}, {3250,0.55719802}, {3300,0.57082178}, {3350,0.57626733}, {3400,0.58546535}, {3450,0.59559406}, {3500,0.59882178}, {3550,0.62569307}, {3600,0.61035644}, {3650,0.63502970}, {3700,0.62182178}, {3750,0.64746535}, {3800,0.66555446}, {3850,0.68779208}, {3900,0.68385149}, {3950,0.68639604}, {4000,0.68392079}, {4050,0.71282178}, {4100,0.73546535}, {4150,0.72190099}, {4200,0.73264356}, {4250,0.75960396}, {4300,0.75763366}, {4350,0.75737624}, {4400,0.77227723}, {4450,0.78448515}, {4500,0.78651485}, {4550,0.80863366}, {4600,0.80428713}, {4650,0.80371287}, {4700,0.83566337}, {4750,0.82156436}, {4800,0.86530693}, {4850,0.84512871}, {4900,0.96571287}, {4950,0.86473267}, {5000,0.89900000}, {5050,0.88560396}, {5100,0.91695050}, {5150,0.88555446}, {5200,0.91538614}, {5250,0.92649505}, {5300,0.93453465}, {5350,0.95526733}, {5400,0.95200990}, {5450,0.96169307}, {5500,0.98178218}, {5550,0.95929703}, {5600,0.98496040}, {5650,1.00028713}, {5700,0.99743564}, {5750,1.00670297}, {5800,1.01928713}, {5850,1.02783168}, {5900,1.05078218}, {5950,1.04198020}, {6000,1.06774257}, {6050,1.1171143}, {6100,3.6630000}, {6150,1.1414857}, {6200,1.1687429}, {6250,1.1623143}, {6300,1.1396571}, {6350,1.1413714}, {6400,1.1320000}, {6450,1.1528571}, {6500,1.1569429}, {6550,1.1707714}, {6600,1.1860000}, {6650,1.1982286}, {6700,1.2135714}, {6750,1.2166000}, {6800,1.2329714}, {6850,1.2380286}, {6900,1.2545143}, {6950,1.2540571}, {7000,1.2582857}, {7050,1.2601714}, {7100,1.2882000}, {7150,1.3198286}, {7200,1.3234857}, {7250,1.3580000}, {7300,1.3756286}, {7350,1.3744286}, {7400,1.3774857}, {7450,1.3780286}, {7500,1.3762857}, {7550,1.3821429}, {7600,1.3686571}, {7650,1.3994857}, {7700,1.4568857}, {7750,1.4489429}, {7800,1.4710000}, {7850,1.4433714}, {7900,1.4461714}, {7950,1.4902286}, {8000,1.5088857}, {8050,1.4951143}, {8100,1.4976000}, {8150,1.4902857}, {8200,1.4780286}, {8250,1.5549429}, {8300,1.5256571}, {8350,1.5454286}, {8400,1.5111143}, {8450,1.5872286}, {8500,1.5728571}, {8550,1.5764857}, {8600,1.5650286}, {8650,1.6283143}, {8700,1.6210000}, {8750,1.6267429}, {8800,1.6308286}, {8850,1.6381429}, {8900,1.6104571}, {8950,1.6920286}, {9000,1.6631429}, {9050,1.6473429}, {9100,1.7050286}, {9150,1.7101714}, {9200,1.6948286}, {9250,1.7212857}, {9300,1.7069429}, {9350,1.7526857}, {9400,1.7697714}, {9450,1.7530000}, {9500,1.7907429}, {9550,1.7564571}, {9600,1.7757429}, {9650,1.7991714}, {9700,1.8381429}, {9750,1.8103714}, {9800,1.8445714}, {9850,1.8362571}, {9900,1.8860286}, {9950,1.8570857}, {10000,1.8933143}, {10100,1.8626286}, {10200,1.9452571}, {10300,1.8958857}, {10400,1.9270000}, {10500,1.9004286}, {10600,1.9710286}, {10700,1.9784286}, {10800,1.9854857}, {10900,1.9966571}, {11000,2.0554286}, {11100,2.0397714}, {11200,2.0715429}, {11300,2.0711429}, {11400,2.1082571}, {11500,2.1223143}, {11600,2.1455429}, {11700,2.1632000}, {11800,2.1651143}, {11900,2.2179429}, {12000,2.2026286}, {12100,2.2840286}, {12200,2.2744000}, {12300,2.2560857}, {12400,2.2411429}, {12500,2.2843143}, {12600,2.3464571}, {12700,2.4245143}, {12800,2.3186286}, {12900,2.3664857}, {13000,2.4206000}, {13100,2.4267429}, {13200,2.4065143}, {13300,2.4671429}, {13400,2.4329429}, {13500,2.4912000}, {13600,2.4929429}, {13700,2.5145429}, {13800,2.5455429}, {13900,2.5483143}, {14000,2.5897143}, {14100,2.5940286}, {14200,2.6428857}, {14300,2.6639429}, {14400,2.8179429}, {14500,2.7045429}, {14600,2.6863429}, {14700,2.9652000}, {14800,2.8118000}, {14900,2.8260286}, {15000,2.7632000}, {15100,2.7986000}, {15200,2.8355429}, {15300,2.8870000}, {15400,2.8986571}, {15500,2.9479714}, {15600,2.8414000}, {15700,2.9681429}, {15800,3.0144286}, {15900,3.1016000}, {16000,3.0063143}, {16100,2.9592286}, {16200,3.2775429}, {16300,3.0037714}, {16400,2.9668000}, {16500,3.0370286}, {16600,3.1223429}, {16700,3.1435714}, {16800,3.0697429}, {16900,3.1663143}, {17000,3.1094286}, {17100,3.1055143}, {17200,3.3979714}, {17300,3.1903143}, {17400,3.2753714}, {17500,3.2903714}, {17600,3.2653429}, {17700,3.3170286}, {17800,3.3311143}, {17900,3.2687429}, {18000,3.3715714}, {18100,3.3173143}, {18200,3.3834000}, {18300,3.4743429}, {18400,3.3917143}, {18500,3.4366857}, {18600,3.5576000}, {18700,3.4223429}, {18800,3.4704857}, {18900,3.5060857}, {19000,3.4914857}, {19100,3.7046571}, {19200,3.6591429}, {19300,3.5971143}, {19400,3.5840000}, {19500,3.6185143}, {19600,3.7691429}, {19700,3.7202571}, {19800,3.7666000}, {19900,3.7958286}, {20000,3.7292286}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["reif"]["user"] = {{1,0.00050495}, {2,0.00049505}, {3,0.00051485}, {4,0.00077228}, {5,0.00085149}, {6,0.00110891}, {7,0.00085149}, {8,0.00168317}, {9,0.00132673}, {10,0.00147525}, {11,0.00188119}, {12,0.00136634}, {13,0.00202970}, {14,0.00182178}, {15,0.00185149}, {16,0.00238614}, {17,0.00223762}, {18,0.00259406}, {19,0.00258416}, {20,0.00251485}, {21,0.00269307}, {22,0.00293069}, {23,0.00321782}, {24,0.00317822}, {25,0.00296040}, {26,0.00314851}, {27,0.00351485}, {28,0.00348515}, {29,0.00374257}, {30,0.00383168}, {31,0.00416832}, {32,0.00419802}, {33,0.00430693}, {34,0.00544554}, {35,0.00471287}, {36,0.00494059}, {37,0.00494059}, {38,0.00503960}, {39,0.00484158}, {40,0.00565347}, {41,0.00555446}, {42,0.00575248}, {43,0.00809901}, {44,0.00611881}, {45,0.00860396}, {46,0.00627723}, {47,0.00807921}, {48,0.00675248}, {49,0.00681188}, {50,0.00700000}, {51,0.00689109}, {52,0.00695050}, {53,0.00745545}, {54,0.00768317}, {55,0.00778218}, {56,0.00799010}, {57,0.00793069}, {58,0.00803960}, {59,0.01003960}, {60,0.00829703}, {61,0.00840594}, {62,0.01097030}, {63,0.00892079}, {64,0.00858416}, {65,0.00956436}, {66,0.00878218}, {67,0.00903960}, {68,0.00908911}, {69,0.00942574}, {70,0.00951485}, {71,0.00970297}, {72,0.00954455}, {73,0.01421782}, {74,0.01016832}, {75,0.01024752}, {76,0.01016832}, {77,0.01061386}, {78,0.01414851}, {79,0.01093069}, {80,0.01091089}, {81,0.01099010}, {82,0.01114851}, {83,0.01138614}, {84,0.01135644}, {85,0.01448515}, {86,0.01171287}, {87,0.01204950}, {88,0.01196040}, {89,0.01235644}, {90,0.01217822}, {91,0.01234653}, {92,0.01234653}, {93,0.01298020}, {94,0.01319802}, {95,0.01313861}, {96,0.01301980}, {97,0.01360396}, {98,0.01354455}, {99,0.01385149}, {100,0.01388119}, {101,0.01396040}, {102,0.01369307}, {103,0.01402970}, {104,0.01457426}, {105,0.01971287}, {106,0.01730693}, {107,0.01505941}, {108,0.01479208}, {109,0.01500000}, {110,0.01525743}, {111,0.01529703}, {112,0.01554455}, {113,0.01911881}, {114,0.01555446}, {115,0.01611881}, {116,0.01605941}, {117,0.01608911}, {118,0.02006931}, {119,0.01660396}, {120,0.01651485}, {121,0.01675248}, {122,0.02175248}, {123,0.01667327}, {124,0.01692079}, {125,0.01707921}, {126,0.01856436}, {127,0.01743564}, {128,0.01770297}, {129,0.02039604}, {130,0.01763366}, {131,0.01800990}, {132,0.02007921}, {133,0.01775248}, {134,0.01839604}, {135,0.01836634}, {136,0.01831683}, {137,0.02356436}, {138,0.01839604}, {139,0.01871287}, {140,0.01877228}, {141,0.01887129}, {142,0.01932673}, {143,0.01908911}, {144,0.02148515}, {145,0.01933663}, {146,0.02299010}, {147,0.01986139}, {148,0.02279208}, {149,0.01992079}, {150,0.02178218}, {151,0.02049505}, {152,0.01979208}, {153,0.02057426}, {154,0.02032673}, {155,0.02768317}, {156,0.02081188}, {157,0.02274257}, {158,0.02141584}, {159,0.02151485}, {160,0.02626733}, {161,0.02119802}, {162,0.02210891}, {163,0.02852475}, {164,0.02224752}, {165,0.02234653}, {166,0.02777228}, {167,0.02314851}, {168,0.02320792}, {169,0.02463366}, {170,0.02333663}, {171,0.02346535}, {172,0.02338614}, {173,0.02651485}, {174,0.02395050}, {175,0.02397030}, {176,0.02412871}, {177,0.02412871}, {178,0.02865347}, {179,0.02426733}, {180,0.02431683}, {181,0.02520792}, {182,0.02479208}, {183,0.02490099}, {184,0.02832673}, {185,0.03230693}, {186,0.02517822}, {187,0.02574257}, {188,0.02566337}, {189,0.02606931}, {190,0.02580198}, {191,0.02616832}, {192,0.02606931}, {193,0.02597030}, {194,0.02630693}, {195,0.02642574}, {196,0.02641584}, {197,0.02675248}, {198,0.02686139}, {199,0.02687129}, {200,0.02689109}, {201,0.02718812}, {202,0.02707921}, {203,0.02737624}, {204,0.02769307}, {205,0.02778218}, {206,0.02793069}, {207,0.02822772}, {208,0.02790099}, {209,0.03853465}, {210,0.03328713}, {211,0.02867327}, {212,0.02867327}, {213,0.02931683}, {214,0.02890099}, {215,0.03130693}, {216,0.03525743}, {217,0.02958416}, {218,0.03000000}, {219,0.02975248}, {220,0.04046535}, {221,0.03376238}, {222,0.03024752}, {223,0.03089109}, {224,0.04123762}, {225,0.03329703}, {226,0.03067327}, {227,0.03122772}, {228,0.03606931}, {229,0.03172277}, {230,0.03154455}, {231,0.03839604}, {232,0.03178218}, {233,0.03198020}, {234,0.03783168}, {235,0.03191089}, {236,0.03228713}, {237,0.03429703}, {238,0.03276238}, {239,0.03958416}, {240,0.03302970}, {241,0.03313861}, {242,0.03276238}, {243,0.03329703}, {244,0.03538614}, {245,0.03384158}, {246,0.03688119}, {247,0.03397030}, {248,0.03772277}, {249,0.03387129}, {250,0.03722772}, {251,0.03495050}, {252,0.03565347}, {253,0.03463366}, {254,0.03499010}, {255,0.04544554}, {256,0.03505941}, {257,0.04077228}, {258,0.03516832}, {259,0.03529703}, {260,0.04730693}, {261,0.03576238}, {262,0.03950495}, {263,0.03577228}, {264,0.03588119}, {265,0.04148515}, {266,0.03627723}, {267,0.03650495}, {268,0.03944554}, {269,0.05476238}, {270,0.03701980}, {271,0.03707921}, {272,0.04712871}, {273,0.03725743}, {274,0.03743564}, {275,0.03771287}, {276,0.04404950}, {277,0.05081188}, {278,0.03741584}, {279,0.03817822}, {280,0.03851485}, {281,0.04460396}, {282,0.04949505}, {283,0.03867327}, {284,0.03859406}, {285,0.03864356}, {286,0.03875248}, {287,0.04039604}, {288,0.04383168}, {289,0.04665347}, {290,0.04879208}, {291,0.05142574}, {292,0.03942574}, {293,0.04019802}, {294,0.04031683}, {295,0.03996040}, {296,0.04014851}, {297,0.03999010}, {298,0.04042574}, {299,0.04105941}, {300,0.04064356}, {301,0.04066337}, {302,0.04149505}, {303,0.04136634}, {304,0.04161386}, {305,0.06033663}, {306,0.05380198}, {307,0.05123762}, {308,0.04903960}, {309,0.04648515}, {310,0.04190099}, {311,0.04276238}, {312,0.04262376}, {313,0.04271287}, {314,0.05604950}, {315,0.05186139}, {316,0.04739604}, {317,0.04358416}, {318,0.04357426}, {319,0.04465347}, {320,0.05254455}, {321,0.04744554}, {322,0.04361386}, {323,0.04466337}, {324,0.05512871}, {325,0.04920792}, {326,0.04430693}, {327,0.04459406}, {328,0.05369307}, {329,0.04694059}, {330,0.04527723}, {331,0.06239604}, {332,0.04943564}, {333,0.04550495}, {334,0.05795050}, {335,0.04801980}, {336,0.04607921}, {337,0.05554455}, {338,0.04593069}, {339,0.06199010}, {340,0.05008911}, {341,0.04693069}, {342,0.05472277}, {343,0.04703960}, {344,0.05756436}, {345,0.04712871}, {346,0.06042574}, {347,0.04795050}, {348,0.06105941}, {349,0.04826733}, {350,0.06036634}, {351,0.04844554}, {352,0.06000000}, {353,0.04800990}, {354,0.05517822}, {355,0.04881188}, {356,0.05723762}, {357,0.04898020}, {358,0.05379208}, {359,0.06460396}, {360,0.04926733}, {361,0.05842574}, {362,0.04986139}, {363,0.05100990}, {364,0.06149505}, {365,0.05041584}, {366,0.05231683}, {367,0.06166337}, {368,0.05058416}, {369,0.05035644}, {370,0.05742574}, {371,0.06623762}, {372,0.05094059}, {373,0.05473267}, {374,0.06123762}, {375,0.05212871}, {376,0.05159406}, {377,0.05437624}, {378,0.05959406}, {379,0.06622772}, {380,0.05234653}, {381,0.05232673}, {382,0.05392079}, {383,0.05850495}, {384,0.06250495}, {385,0.06798020}, {386,0.05255446}, {387,0.05248515}, {388,0.05312871}, {389,0.05448515}, {390,0.05799010}, {391,0.06035644}, {392,0.06196040}, {393,0.06426733}, {394,0.06574257}, {395,0.06572277}, {396,0.06865347}, {397,0.06974257}, {398,0.06986139}, {399,0.07888119}, {400,0.07609901}, {401,0.07357426}, {402,0.07347525}, {403,0.07199010}, {404,0.07050495}, {405,0.07054455}, {406,0.06797030}, {407,0.06601980}, {408,0.06267327}, {409,0.06167327}, {410,0.05865347}, {411,0.05637624}, {412,0.05601980}, {413,0.05700990}, {414,0.07223762}, {415,0.07165347}, {416,0.06787129}, {417,0.06185149}, {418,0.05663366}, {419,0.05750495}, {420,0.07519802}, {421,0.06947525}, {422,0.06180198}, {423,0.05822772}, {424,0.05804950}, {425,0.07048515}, {426,0.06382178}, {427,0.05861386}, {428,0.07546535}, {429,0.06828713}, {430,0.06103960}, {431,0.05979208}, {432,0.06986139}, {433,0.06372277}, {434,0.05960396}, {435,0.07436634}, {436,0.06182178}, {437,0.06255446}, {438,0.07011881}, {439,0.06068317}, {440,0.07543564}, {441,0.06430693}, {442,0.06295050}, {443,0.06800990}, {444,0.06146535}, {445,0.07120792}, {446,0.06152475}, {447,0.07312871}, {448,0.06090099}, {449,0.07816832}, {450,0.06326733}, {451,0.08114851}, {452,0.06343564}, {453,0.07712871}, {454,0.06208911}, {455,0.07509901}, {456,0.06198020}, {457,0.07220792}, {458,0.06472277}, {459,0.06738614}, {460,0.07780198}, {461,0.06319802}, {462,0.07269307}, {463,0.08212871}, {464,0.06592079}, {465,0.07551485}, {466,0.06339604}, {467,0.07035644}, {468,0.07864356}, {469,0.06409901}, {470,0.06715842}, {471,0.07388119}, {472,0.08373267}, {473,0.06508911}, {474,0.07093069}, {475,0.07765347}, {476,0.08382178}, {477,0.06554455}, {478,0.07010891}, {479,0.07592079}, {480,0.08417822}, {481,0.06538614}, {482,0.06567327}, {483,0.07192079}, {484,0.07657426}, {485,0.07737624}, {486,0.08417822}, {487,0.08733663}, {488,0.06668317}, {489,0.06830693}, {490,0.07085149}, {491,0.07431683}, {492,0.07596040}, {493,0.08042574}, {494,0.08368317}, {495,0.08309901}, {496,0.08423762}, {497,0.08212871}, {498,0.08598020}, {499,0.08654455}, {500,0.08665347}, {505,0.08546535}, {510,0.08359406}, {515,0.08098020}, {520,0.07733663}, {525,0.07241584}, {530,0.09992079}, {535,0.08595050}, {540,0.07516832}, {545,0.09200990}, {550,0.08012871}, {555,0.09228713}, {560,0.07834653}, {565,0.08834653}, {570,0.09693069}, {575,0.07993069}, {580,0.08906931}, {585,0.09470297}, {590,0.09751485}, {595,0.09902970}, {600,0.09905941}, {605,0.09905941}, {610,0.09751485}, {615,0.09581188}, {620,0.09545545}, {625,0.08708911}, {630,0.10887129}, {635,0.09897030}, {640,0.08983168}, {645,0.10570297}, {650,0.09505941}, {655,0.10736634}, {660,0.09450495}, {665,0.10649505}, {670,0.11660396}, {675,0.09697030}, {680,0.10359406}, {685,0.10797030}, {690,0.11164356}, {695,0.11468317}, {700,0.12025743}, {705,0.11919802}, {710,0.11794059}, {715,0.11436634}, {720,0.11073267}, {725,0.10750495}, {730,0.13660396}, {735,0.12138614}, {740,0.10989109}, {745,0.12613861}, {750,0.11431683}, {755,0.12653465}, {760,0.11831683}, {765,0.12609901}, {770,0.13459406}, {775,0.11653465}, {780,0.12249505}, {785,0.12765347}, {790,0.13687129}, {795,0.14011881}, {800,0.14076238}, {805,0.13905941}, {810,0.13767327}, {815,0.14783168}, {820,0.13630693}, {825,0.13129703}, {830,0.12423762}, {835,0.14063366}, {840,0.14276238}, {845,0.15390099}, {850,0.14108911}, {855,0.15124752}, {860,0.13828713}, {865,0.16223762}, {870,0.13632673}, {875,0.14359406}, {880,0.14762376}, {885,0.15288119}, {890,0.13754455}, {895,0.13734653}, {900,0.13758416}, {905,0.13820792}, {910,0.13735644}, {915,0.16454455}, {920,0.15885149}, {925,0.15297030}, {930,0.14737624}, {935,0.14932673}, {940,0.16247525}, {945,0.15140594}, {950,0.16248515}, {955,0.15164356}, {960,0.16855446}, {965,0.15177228}, {970,0.15867327}, {975,0.16646535}, {980,0.15389109}, {985,0.15879208}, {990,0.16010891}, {995,0.16337624}, {1000,0.17012871}, {1010,0.16879208}, {1020,0.16330693}, {1030,0.15679208}, {1040,0.18491089}, {1050,0.17129703}, {1060,0.18169307}, {1070,0.18085149}, {1080,0.18118812}, {1090,0.18336634}, {1100,0.18478218}, {1110,0.19544554}, {1120,0.18859406}, {1130,0.18413861}, {1140,0.18170297}, {1150,0.19725743}, {1160,0.18137624}, {1170,0.20980198}, {1180,0.20572277}, {1190,0.20651485}, {1200,0.19021782}, {1210,0.19054455}, {1220,0.21076238}, {1230,0.21507921}, {1240,0.20463366}, {1250,0.21533663}, {1260,0.21203960}, {1270,0.21768317}, {1280,0.19903960}, {1290,0.21324752}, {1300,0.21148515}, {1310,0.23201980}, {1320,0.21500000}, {1330,0.20859406}, {1340,0.23679208}, {1350,0.22067327}, {1360,0.22995050}, {1370,0.22647525}, {1380,0.22722772}, {1390,0.25555446}, {1400,0.24057426}, {1410,0.23594059}, {1420,0.24553465}, {1430,0.23462376}, {1440,0.24256436}, {1450,0.24856436}, {1460,0.23505941}, {1470,0.24956436}, {1480,0.25237624}, {1490,0.24406931}, {1500,0.24073267}, {1510,0.25998020}, {1520,0.24459406}, {1530,0.25894059}, {1540,0.25523762}, {1550,0.24846535}, {1560,0.27268317}, {1570,0.24983168}, {1580,0.27024752}, {1590,0.26525743}, {1600,0.28021782}, {1610,0.27188119}, {1620,0.28259406}, {1630,0.26921782}, {1640,0.27444554}, {1650,0.28122772}, {1660,0.28756436}, {1670,0.28084158}, {1680,0.28745545}, {1690,0.27616832}, {1700,0.30148515}, {1710,0.28223762}, {1720,0.29627723}, {1730,0.27738614}, {1740,0.30748515}, {1750,0.28847525}, {1760,0.28914851}, {1770,0.29174257}, {1780,0.30570297}, {1790,0.31720792}, {1800,0.28841584}, {1810,0.29963366}, {1820,0.29514851}, {1830,0.33900000}, {1840,0.30508911}, {1850,0.30889109}, {1860,0.31291089}, {1870,0.30847525}, {1880,0.30246535}, {1890,0.31984158}, {1900,0.33897030}, {1910,0.32382178}, {1920,0.33430693}, {1930,0.32095050}, {1940,0.31926733}, {1950,0.35005941}, {1960,0.32392079}, {1970,0.34063366}, {1980,0.32869307}, {1990,0.32809901}, {2000,0.34170297}, {2050,0.33090099}, {2100,0.35239604}, {2150,0.36773267}, {2200,0.36063366}, {2250,0.39139604}, {2300,0.40938614}, {2350,0.38644554}, {2400,0.40653465}, {2450,0.41468317}, {2500,0.42652475}, {2550,0.43615842}, {2600,0.46874257}, {2650,0.42989109}, {2700,0.44809901}, {2750,0.47465347}, {2800,0.46973267}, {2850,0.50000990}, {2900,0.51012871}, {2950,0.50371287}, {3000,0.51770297}, {3050,0.51917822}, {3100,0.53206931}, {3150,0.52773267}, {3200,0.54023762}, {3250,0.55597030}, {3300,0.56943564}, {3350,0.57561386}, {3400,0.58409901}, {3450,0.59457426}, {3500,0.59756436}, {3550,0.62486139}, {3600,0.60936634}, {3650,0.63421782}, {3700,0.62029703}, {3750,0.64618812}, {3800,0.66447525}, {3850,0.68636634}, {3900,0.68269307}, {3950,0.68502970}, {4000,0.68292079}, {4050,0.71146535}, {4100,0.73400000}, {4150,0.72064356}, {4200,0.73118812}, {4250,0.75854455}, {4300,0.75614851}, {4350,0.75604950}, {4400,0.77069307}, {4450,0.78273267}, {4500,0.78510891}, {4550,0.80730693}, {4600,0.80242574}, {4650,0.80229703}, {4700,0.83392079}, {4750,0.81986139}, {4800,0.86344554}, {4850,0.84322772}, {4900,0.96356436}, {4950,0.86242574}, {5000,0.89729703}, {5050,0.88373267}, {5100,0.91493069}, {5150,0.88362376}, {5200,0.91382178}, {5250,0.92462376}, {5300,0.93251485}, {5350,0.95298020}, {5400,0.95000000}, {5450,0.95956436}, {5500,0.97963366}, {5550,0.95742574}, {5600,0.98294059}, {5650,0.99837624}, {5700,0.99556436}, {5750,1.00451485}, {5800,1.01711881}, {5850,1.02610891}, {5900,1.04891089}, {5950,1.04037624}, {6000,1.06611881}, {6050,1.1090571}, {6100,3.6571143}, {6150,1.1402571}, {6200,1.1675429}, {6250,1.1612571}, {6300,1.1388857}, {6350,1.1402000}, {6400,1.1306286}, {6450,1.1517714}, {6500,1.1563714}, {6550,1.1696571}, {6600,1.1849714}, {6650,1.1970857}, {6700,1.2125143}, {6750,1.2135429}, {6800,1.2288571}, {6850,1.2371143}, {6900,1.2534000}, {6950,1.2521143}, {7000,1.2575714}, {7050,1.2594000}, {7100,1.2869714}, {7150,1.3170000}, {7200,1.3222286}, {7250,1.3552571}, {7300,1.3709143}, {7350,1.3700857}, {7400,1.3756857}, {7450,1.3709429}, {7500,1.3736286}, {7550,1.3795714}, {7600,1.3669143}, {7650,1.3950000}, {7700,1.4545429}, {7750,1.4465714}, {7800,1.4608571}, {7850,1.4401429}, {7900,1.4433714}, {7950,1.4886571}, {8000,1.5052857}, {8050,1.4937429}, {8100,1.4946286}, {8150,1.4883143}, {8200,1.4768000}, {8250,1.5528000}, {8300,1.5239429}, {8350,1.5434286}, {8400,1.5096571}, {8450,1.5852000}, {8500,1.5709714}, {8550,1.5748571}, {8600,1.5635714}, {8650,1.6264286}, {8700,1.6184571}, {8750,1.6253429}, {8800,1.6295429}, {8850,1.6338571}, {8900,1.6090286}, {8950,1.6896857}, {9000,1.6613429}, {9050,1.6451143}, {9100,1.7022286}, {9150,1.7080571}, {9200,1.6926000}, {9250,1.7168000}, {9300,1.7046571}, {9350,1.7496286}, {9400,1.7673143}, {9450,1.7505714}, {9500,1.7887143}, {9550,1.7545429}, {9600,1.7728857}, {9650,1.7957429}, {9700,1.8346857}, {9750,1.8071429}, {9800,1.8418000}, {9850,1.8336286}, {9900,1.8834000}, {9950,1.8543143}, {10000,1.8901429}, {10100,1.8598286}, {10200,1.9403429}, {10300,1.8928286}, {10400,1.9238000}, {10500,1.8982571}, {10600,1.9682571}, {10700,1.9765714}, {10800,1.9831714}, {10900,1.9930571}, {11000,2.0525429}, {11100,2.0364571}, {11200,2.0688000}, {11300,2.0677143}, {11400,2.1049714}, {11500,2.1188286}, {11600,2.1420571}, {11700,2.1594571}, {11800,2.1611143}, {11900,2.2147429}, {12000,2.1990286}, {12100,2.2802286}, {12200,2.2705714}, {12300,2.2519143}, {12400,2.2369714}, {12500,2.2802286}, {12600,2.3425143}, {12700,2.4208571}, {12800,2.3154857}, {12900,2.3637143}, {13000,2.4175143}, {13100,2.4230286}, {13200,2.4020000}, {13300,2.4631429}, {13400,2.4294571}, {13500,2.4873429}, {13600,2.4880857}, {13700,2.5116571}, {13800,2.5418000}, {13900,2.5460000}, {14000,2.5864571}, {14100,2.5908857}, {14200,2.6391429}, {14300,2.6606000}, {14400,2.8156000}, {14500,2.7009714}, {14600,2.6821714}, {14700,2.9616286}, {14800,2.8091429}, {14900,2.8220571}, {15000,2.7604571}, {15100,2.7937143}, {15200,2.8326857}, {15300,2.8823143}, {15400,2.8943429}, {15500,2.9441714}, {15600,2.8373714}, {15700,2.9654857}, {15800,3.0119429}, {15900,3.0986286}, {16000,3.0029714}, {16100,2.9564571}, {16200,3.2736857}, {16300,3.0007143}, {16400,2.9640286}, {16500,3.0337714}, {16600,3.1192857}, {16700,3.1400286}, {16800,3.0677143}, {16900,3.1620571}, {17000,3.1062857}, {17100,3.1026857}, {17200,3.3934000}, {17300,3.1863143}, {17400,3.2709714}, {17500,3.2850000}, {17600,3.2620571}, {17700,3.3126857}, {17800,3.3264286}, {17900,3.2654000}, {18000,3.3673143}, {18100,3.3136286}, {18200,3.3790000}, {18300,3.4690571}, {18400,3.3859714}, {18500,3.4321429}, {18600,3.5518571}, {18700,3.4181714}, {18800,3.4538286}, {18900,3.4979429}, {19000,3.4847714}, {19100,3.6893714}, {19200,3.6538000}, {19300,3.5925429}, {19400,3.5738000}, {19500,3.6018000}, {19600,3.7321143}, {19700,3.7016571}, {19800,3.7611143}, {19900,3.7892000}, {20000,3.7237143}};
data["big_flat"]["LtacTacInTermExplicitCtx"]["reif"]["system"] = {{1,0.00002970}, {2,0.00003960}, {3,0.00003960}, {4,0.00000000}, {5,0.00003960}, {6,0.00000000}, {7,0.00003960}, {8,0.00007921}, {9,0.00000000}, {10,0.00000000}, {11,0.00003960}, {12,0.00003960}, {13,0.00000000}, {14,0.00006931}, {15,0.00002970}, {16,0.00003960}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00003960}, {21,0.00007921}, {22,0.00000000}, {23,0.00003960}, {24,0.00000000}, {25,0.00003960}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00007921}, {32,0.00000000}, {33,0.00007921}, {34,0.00000000}, {35,0.00006931}, {36,0.00000000}, {37,0.00000000}, {38,0.00005941}, {39,0.00000000}, {40,0.00002970}, {41,0.00000000}, {42,0.00000000}, {43,0.00003960}, {44,0.00000000}, {45,0.00013861}, {46,0.00003960}, {47,0.00000000}, {48,0.00002970}, {49,0.00003960}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00002970}, {60,0.00000000}, {61,0.00007921}, {62,0.00027723}, {63,0.00006931}, {64,0.00002970}, {65,0.00000000}, {66,0.00006931}, {67,0.00003960}, {68,0.00003960}, {69,0.00003960}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00002970}, {74,0.00002970}, {75,0.00011881}, {76,0.00000000}, {77,0.00002970}, {78,0.00010891}, {79,0.00000000}, {80,0.00003960}, {81,0.00002970}, {82,0.00007921}, {83,0.00000000}, {84,0.00000000}, {85,0.00003960}, {86,0.00007921}, {87,0.00000000}, {88,0.00003960}, {89,0.00003960}, {90,0.00003960}, {91,0.00003960}, {92,0.00000000}, {93,0.00003960}, {94,0.00003960}, {95,0.00000000}, {96,0.00000000}, {97,0.00003960}, {98,0.00000000}, {99,0.00003960}, {100,0.00000000}, {101,0.00002970}, {102,0.00010891}, {103,0.00000000}, {104,0.00007921}, {105,0.00014851}, {106,0.00007921}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00002970}, {111,0.00003960}, {112,0.00000000}, {113,0.00003960}, {114,0.00010891}, {115,0.00003960}, {116,0.00003960}, {117,0.00000000}, {118,0.00003960}, {119,0.00003960}, {120,0.00000000}, {121,0.00000000}, {122,0.00018812}, {123,0.00000000}, {124,0.00003960}, {125,0.00000000}, {126,0.00007921}, {127,0.00003960}, {128,0.00003960}, {129,0.00011881}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00003960}, {136,0.00011881}, {137,0.00007921}, {138,0.00003960}, {139,0.00000000}, {140,0.00003960}, {141,0.00000000}, {142,0.00002970}, {143,0.00007921}, {144,0.00010891}, {145,0.00000000}, {146,0.00006931}, {147,0.00000000}, {148,0.00005941}, {149,0.00000000}, {150,0.00007921}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00010891}, {156,0.00006931}, {157,0.00000000}, {158,0.00010891}, {159,0.00000000}, {160,0.00014851}, {161,0.00011881}, {162,0.00000000}, {163,0.00023762}, {164,0.00003960}, {165,0.00003960}, {166,0.00007921}, {167,0.00000000}, {168,0.00003960}, {169,0.00013861}, {170,0.00011881}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00003960}, {175,0.00003960}, {176,0.00002970}, {177,0.00006931}, {178,0.00017822}, {179,0.00003960}, {180,0.00007921}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00002970}, {185,0.00019802}, {186,0.00011881}, {187,0.00000000}, {188,0.00003960}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00007921}, {202,0.00003960}, {203,0.00000000}, {204,0.00003960}, {205,0.00003960}, {206,0.00000000}, {207,0.00000000}, {208,0.00003960}, {209,0.00003960}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00003960}, {214,0.00000000}, {215,0.00003960}, {216,0.00003960}, {217,0.00000000}, {218,0.00003960}, {219,0.00006931}, {220,0.00018812}, {221,0.00014851}, {222,0.00003960}, {223,0.00000000}, {224,0.00030693}, {225,0.00011881}, {226,0.00003960}, {227,0.00007921}, {228,0.00015842}, {229,0.00003960}, {230,0.00003960}, {231,0.00022772}, {232,0.00000000}, {233,0.00007921}, {234,0.00006931}, {235,0.00000000}, {236,0.00000000}, {237,0.00006931}, {238,0.00000000}, {239,0.00031683}, {240,0.00000000}, {241,0.00006931}, {242,0.00000000}, {243,0.00007921}, {244,0.00007921}, {245,0.00000000}, {246,0.00000000}, {247,0.00003960}, {248,0.00000000}, {249,0.00000000}, {250,0.00003960}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00003960}, {255,0.00000000}, {256,0.00000000}, {257,0.00007921}, {258,0.00000000}, {259,0.00003960}, {260,0.00000000}, {261,0.00007921}, {262,0.00000000}, {263,0.00003960}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00003960}, {270,0.00002970}, {271,0.00007921}, {272,0.00003960}, {273,0.00000000}, {274,0.00003960}, {275,0.00000000}, {276,0.00002970}, {277,0.00000000}, {278,0.00003960}, {279,0.00000000}, {280,0.00007921}, {281,0.00003960}, {282,0.00003960}, {283,0.00003960}, {284,0.00000000}, {285,0.00000000}, {286,0.00003960}, {287,0.00002970}, {288,0.00003960}, {289,0.00000000}, {290,0.00003960}, {291,0.00003960}, {292,0.00000000}, {293,0.00000000}, {294,0.00003960}, {295,0.00000000}, {296,0.00003960}, {297,0.00000000}, {298,0.00003960}, {299,0.00000000}, {300,0.00000000}, {301,0.00003960}, {302,0.00003960}, {303,0.00003960}, {304,0.00000000}, {305,0.00000000}, {306,0.00002970}, {307,0.00000000}, {308,0.00000000}, {309,0.00003960}, {310,0.00003960}, {311,0.00003960}, {312,0.00000000}, {313,0.00003960}, {314,0.00000000}, {315,0.00000000}, {316,0.00003960}, {317,0.00000000}, {318,0.00003960}, {319,0.00000000}, {320,0.00003960}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00007921}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00003960}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00003960}, {336,0.00003960}, {337,0.00011881}, {338,0.00003960}, {339,0.00000000}, {340,0.00003960}, {341,0.00005941}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00030693}, {347,0.00000000}, {348,0.00041584}, {349,0.00007921}, {350,0.00051485}, {351,0.00003960}, {352,0.00010891}, {353,0.00003960}, {354,0.00000000}, {355,0.00011881}, {356,0.00000000}, {357,0.00000000}, {358,0.00003960}, {359,0.00015842}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00006931}, {364,0.00011881}, {365,0.00000000}, {366,0.00000000}, {367,0.00015842}, {368,0.00003960}, {369,0.00003960}, {370,0.00011881}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00007921}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00003960}, {381,0.00000000}, {382,0.00003960}, {383,0.00003960}, {384,0.00000000}, {385,0.00003960}, {386,0.00000000}, {387,0.00000000}, {388,0.00003960}, {389,0.00003960}, {390,0.00003960}, {391,0.00003960}, {392,0.00000000}, {393,0.00003960}, {394,0.00000000}, {395,0.00011881}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00003960}, {400,0.00003960}, {401,0.00003960}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00007921}, {407,0.00003960}, {408,0.00000000}, {409,0.00000000}, {410,0.00007921}, {411,0.00003960}, {412,0.00003960}, {413,0.00000000}, {414,0.00003960}, {415,0.00000000}, {416,0.00003960}, {417,0.00007921}, {418,0.00000000}, {419,0.00007921}, {420,0.00003960}, {421,0.00000000}, {422,0.00011881}, {423,0.00003960}, {424,0.00000000}, {425,0.00003960}, {426,0.00007921}, {427,0.00000000}, {428,0.00003960}, {429,0.00000000}, {430,0.00002970}, {431,0.00000000}, {432,0.00000000}, {433,0.00003960}, {434,0.00003960}, {435,0.00000000}, {436,0.00000000}, {437,0.00003960}, {438,0.00003960}, {439,0.00003960}, {440,0.00000000}, {441,0.00000000}, {442,0.00003960}, {443,0.00000000}, {444,0.00003960}, {445,0.00003960}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00003960}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00007921}, {455,0.00015842}, {456,0.00007921}, {457,0.00000000}, {458,0.00003960}, {459,0.00000000}, {460,0.00007921}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003960}, {469,0.00000000}, {470,0.00000000}, {471,0.00003960}, {472,0.00003960}, {473,0.00003960}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00003960}, {479,0.00003960}, {480,0.00000000}, {481,0.00000000}, {482,0.00007921}, {483,0.00000000}, {484,0.00000000}, {485,0.00003960}, {486,0.00000000}, {487,0.00003960}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00003960}, {492,0.00000000}, {493,0.00006931}, {494,0.00003960}, {495,0.00003960}, {496,0.00000000}, {497,0.00003960}, {498,0.00003960}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00003960}, {520,0.00000000}, {525,0.00000000}, {530,0.00003960}, {535,0.00006931}, {540,0.00000000}, {545,0.00000000}, {550,0.00003960}, {555,0.00000000}, {560,0.00000000}, {565,0.00003960}, {570,0.00003960}, {575,0.00000000}, {580,0.00000000}, {585,0.00003960}, {590,0.00000000}, {595,0.00007921}, {600,0.00000000}, {605,0.00003960}, {610,0.00000000}, {615,0.00003960}, {620,0.00002970}, {625,0.00003960}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00003960}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00003960}, {700,0.00000000}, {705,0.00000000}, {710,0.00003960}, {715,0.00000000}, {720,0.00000000}, {725,0.00007921}, {730,0.00003960}, {735,0.00003960}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00003960}, {760,0.00000000}, {765,0.00019802}, {770,0.00000000}, {775,0.00000000}, {780,0.00007921}, {785,0.00007921}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00003960}, {815,0.00003960}, {820,0.00000000}, {825,0.00002970}, {830,0.00000000}, {835,0.00000000}, {840,0.00007921}, {845,0.00000000}, {850,0.00003960}, {855,0.00003960}, {860,0.00003960}, {865,0.00002970}, {870,0.00003960}, {875,0.00003960}, {880,0.00000000}, {885,0.00000000}, {890,0.00011881}, {895,0.00000000}, {900,0.00003960}, {905,0.00007921}, {910,0.00000000}, {915,0.00007921}, {920,0.00000000}, {925,0.00000000}, {930,0.00007921}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00003960}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00011881}, {985,0.00003960}, {990,0.00003960}, {995,0.00000000}, {1000,0.00003960}, {1010,0.00003960}, {1020,0.00007921}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00003960}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00007921}, {1130,0.00002970}, {1140,0.00007921}, {1150,0.00003960}, {1160,0.00000000}, {1170,0.00003960}, {1180,0.00003960}, {1190,0.00007921}, {1200,0.00000000}, {1210,0.00007921}, {1220,0.00000000}, {1230,0.00014851}, {1240,0.00007921}, {1250,0.00003960}, {1260,0.00000000}, {1270,0.00003960}, {1280,0.00000000}, {1290,0.00003960}, {1300,0.00000000}, {1310,0.00003960}, {1320,0.00000000}, {1330,0.00003960}, {1340,0.00000000}, {1350,0.00011881}, {1360,0.00003960}, {1370,0.00007921}, {1380,0.00003960}, {1390,0.00003960}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00007921}, {1450,0.00003960}, {1460,0.00003960}, {1470,0.00007921}, {1480,0.00003960}, {1490,0.00010891}, {1500,0.00003960}, {1510,0.00003960}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00003960}, {1550,0.00003960}, {1560,0.00007921}, {1570,0.00011881}, {1580,0.00003960}, {1590,0.00003960}, {1600,0.00000000}, {1610,0.00011881}, {1620,0.00002970}, {1630,0.00007921}, {1640,0.00000000}, {1650,0.00003960}, {1660,0.00000000}, {1670,0.00003960}, {1680,0.00007921}, {1690,0.00007921}, {1700,0.00000000}, {1710,0.00007921}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00007921}, {1750,0.00000000}, {1760,0.00007921}, {1770,0.00003960}, {1780,0.00003960}, {1790,0.00011881}, {1800,0.00002970}, {1810,0.00000000}, {1820,0.00011881}, {1830,0.00011881}, {1840,0.00011881}, {1850,0.00019802}, {1860,0.00007921}, {1870,0.00007921}, {1880,0.00000000}, {1890,0.00007921}, {1900,0.00003960}, {1910,0.00000000}, {1920,0.00003960}, {1930,0.00010891}, {1940,0.00011881}, {1950,0.00009901}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00011881}, {1990,0.00003960}, {2000,0.00003960}, {2050,0.00019802}, {2100,0.00007921}, {2150,0.00007921}, {2200,0.00003960}, {2250,0.00003960}, {2300,0.00007921}, {2350,0.00010891}, {2400,0.00000000}, {2450,0.00015842}, {2500,0.00003960}, {2550,0.00003960}, {2600,0.00000000}, {2650,0.00010891}, {2700,0.00007921}, {2750,0.00011881}, {2800,0.00039604}, {2850,0.00011881}, {2900,0.00011881}, {2950,0.00007921}, {3000,0.00003960}, {3050,0.00003960}, {3100,0.00015842}, {3150,0.00015842}, {3200,0.00023762}, {3250,0.00007921}, {3300,0.00010891}, {3350,0.00007921}, {3400,0.00011881}, {3450,0.00000000}, {3500,0.00007921}, {3550,0.00000000}, {3600,0.00011881}, {3650,0.00003960}, {3700,0.00034653}, {3750,0.00003960}, {3800,0.00007921}, {3850,0.00003960}, {3900,0.00003960}, {3950,0.00011881}, {4000,0.00010891}, {4050,0.00018812}, {4100,0.00031683}, {4150,0.00007921}, {4200,0.00011881}, {4250,0.00013861}, {4300,0.00015842}, {4350,0.00007921}, {4400,0.00023762}, {4450,0.00011881}, {4500,0.00003960}, {4550,0.00011881}, {4600,0.00011881}, {4650,0.00000000}, {4700,0.00007921}, {4750,0.00019802}, {4800,0.00019802}, {4850,0.00015842}, {4900,0.00055446}, {4950,0.00035644}, {5000,0.00007921}, {5050,0.00011881}, {5100,0.00030693}, {5150,0.00034653}, {5200,0.00009901}, {5250,0.00039604}, {5300,0.00006931}, {5350,0.00015842}, {5400,0.00022772}, {5450,0.00007921}, {5500,0.00018812}, {5550,0.00003960}, {5600,0.00035644}, {5650,0.00015842}, {5700,0.00015842}, {5750,0.00018812}, {5800,0.00027723}, {5850,0.00011881}, {5900,0.00011881}, {5950,0.00007921}, {6000,0.00019802}, {6050,0.0070286}, {6100,0.0030000}, {6150,0.0001143}, {6200,0.0002286}, {6250,0.0003429}, {6300,0.0000000}, {6350,0.0003429}, {6400,0.0004571}, {6450,0.0001143}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0001143}, {6750,0.0002000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0003143}, {7000,0.0003429}, {7050,0.0001143}, {7100,0.0002286}, {7150,0.0002286}, {7200,0.0000000}, {7250,0.0003429}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0001143}, {7450,0.0002286}, {7500,0.0001143}, {7550,0.0002286}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0001143}, {7750,0.0000000}, {7800,0.0004286}, {7850,0.0000000}, {7900,0.0001143}, {7950,0.0000000}, {8000,0.0003429}, {8050,0.0000000}, {8100,0.0002286}, {8150,0.0001143}, {8200,0.0003143}, {8250,0.0003429}, {8300,0.0000000}, {8350,0.0001143}, {8400,0.0000000}, {8450,0.0001143}, {8500,0.0000000}, {8550,0.0003429}, {8600,0.0001143}, {8650,0.0001143}, {8700,0.0002286}, {8750,0.0000000}, {8800,0.0001143}, {8850,0.0003429}, {8900,0.0000000}, {8950,0.0002286}, {9000,0.0001143}, {9050,0.0003429}, {9100,0.0001143}, {9150,0.0000000}, {9200,0.0003143}, {9250,0.0002000}, {9300,0.0000000}, {9350,0.0002286}, {9400,0.0002286}, {9450,0.0001143}, {9500,0.0001143}, {9550,0.0001143}, {9600,0.0002286}, {9650,0.0002286}, {9700,0.0003429}, {9750,0.0002286}, {9800,0.0003429}, {9850,0.0000000}, {9900,0.0001143}, {9950,0.0001143}, {10000,0.0000000}, {10100,0.0002857}, {10200,0.0022571}, {10300,0.0003429}, {10400,0.0005714}, {10500,0.0000000}, {10600,0.0002286}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0002000}, {11000,0.0001143}, {11100,0.0001143}, {11200,0.0003143}, {11300,0.0003429}, {11400,0.0001143}, {11500,0.0003429}, {11600,0.0006857}, {11700,0.0001143}, {11800,0.0004571}, {11900,0.0001143}, {12000,0.0000000}, {12100,0.0003429}, {12200,0.0000000}, {12300,0.0003143}, {12400,0.0001143}, {12500,0.0003429}, {12600,0.0001143}, {12700,0.0000000}, {12800,0.0002286}, {12900,0.0001143}, {13000,0.0001143}, {13100,0.0002286}, {13200,0.0010286}, {13300,0.0001143}, {13400,0.0003429}, {13500,0.0001143}, {13600,0.0000000}, {13700,0.0001143}, {13800,0.0003429}, {13900,0.0001143}, {14000,0.0001143}, {14100,0.0000000}, {14200,0.0001143}, {14300,0.0002286}, {14400,0.0001143}, {14500,0.0009143}, {14600,0.0011429}, {14700,0.0006571}, {14800,0.0000000}, {14900,0.0013143}, {15000,0.0001143}, {15100,0.0020857}, {15200,0.0002286}, {15300,0.0016000}, {15400,0.0008857}, {15500,0.0008000}, {15600,0.0006857}, {15700,0.0004286}, {15800,0.0002000}, {15900,0.0008000}, {16000,0.0008000}, {16100,0.0005714}, {16200,0.0013429}, {16300,0.0004571}, {16400,0.0010286}, {16500,0.0015714}, {16600,0.0012286}, {16700,0.0012571}, {16800,0.0000857}, {16900,0.0019143}, {17000,0.0003429}, {17100,0.0002286}, {17200,0.0011429}, {17300,0.0013429}, {17400,0.0014571}, {17500,0.0024000}, {17600,0.0003429}, {17700,0.0008000}, {17800,0.0013714}, {17900,0.0002286}, {18000,0.0011143}, {18100,0.0000000}, {18200,0.0003429}, {18300,0.0016857}, {18400,0.0013714}, {18500,0.0008000}, {18600,0.0016000}, {18700,0.0009143}, {18800,0.0003429}, {18900,0.0006857}, {19000,0.0010000}, {19100,0.0004571}, {19200,0.0008000}, {19300,0.0004571}, {19400,0.0028571}, {19500,0.0009143}, {19600,0.0011143}, {19700,0.0021714}, {19800,0.0017143}, {19900,0.0039429}, {20000,0.0023714}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["Aggregate"]["real"] = {{1,0.00100000}, {2,0.00100000}, {3,0.00100000}, {4,0.00100000}, {5,0.00100000}, {6,0.00100000}, {7,0.00106931}, {8,0.00896040}, {9,0.00200000}, {10,0.00200000}, {11,0.00200000}, {12,0.00200000}, {13,0.00200990}, {14,0.00206931}, {15,0.00234653}, {16,0.00299010}, {17,0.00300000}, {18,0.00300000}, {19,0.00300000}, {20,0.00300990}, {21,0.00319802}, {22,0.00330693}, {23,0.00379208}, {24,0.00400000}, {25,0.00400000}, {26,0.00400000}, {27,0.00403960}, {28,0.00414851}, {29,0.00424752}, {30,0.00449505}, {31,0.00500000}, {32,0.00500000}, {33,0.00500000}, {34,0.00501980}, {35,0.00533663}, {36,0.00524752}, {37,0.00543564}, {38,0.00569307}, {39,0.00600000}, {40,0.00600000}, {41,0.00607921}, {42,0.00612871}, {43,0.00613861}, {44,0.00632673}, {45,0.00653465}, {46,0.00691089}, {47,0.00701980}, {48,0.00701980}, {49,0.00906931}, {50,0.00715842}, {51,0.00715842}, {52,0.00729703}, {53,0.00762376}, {54,0.00800990}, {55,0.00804950}, {56,0.00913861}, {57,0.00812871}, {58,0.00816832}, {59,0.00833663}, {60,0.00853465}, {61,0.00886139}, {62,0.00905941}, {63,0.00926733}, {64,0.00914851}, {65,0.00929703}, {66,0.00927723}, {67,0.00929703}, {68,0.00958416}, {69,0.01000990}, {70,0.01010891}, {71,0.01021782}, {72,0.01111881}, {73,0.01023762}, {74,0.01021782}, {75,0.01047525}, {76,0.01067327}, {77,0.01261386}, {78,0.01111881}, {79,0.01122772}, {80,0.01106931}, {81,0.01131683}, {82,0.01123762}, {83,0.01155446}, {84,0.01500990}, {85,0.01217822}, {86,0.01202970}, {87,0.01223762}, {88,0.01217822}, {89,0.01241584}, {90,0.01240594}, {91,0.01278218}, {92,0.01300000}, {93,0.01315842}, {94,0.01315842}, {95,0.01324752}, {96,0.01319802}, {97,0.01346535}, {98,0.01352475}, {99,0.01401980}, {100,0.01412871}, {101,0.01417822}, {102,0.01420792}, {103,0.01430693}, {104,0.01445545}, {105,0.01438614}, {106,0.01469307}, {107,0.01976238}, {108,0.01630693}, {109,0.01511881}, {110,0.01517822}, {111,0.01537624}, {112,0.01551485}, {113,0.01566337}, {114,0.02000000}, {115,0.01601980}, {116,0.01622772}, {117,0.01620792}, {118,0.01642574}, {119,0.01998020}, {120,0.01639604}, {121,0.01672277}, {122,0.01685149}, {123,0.02052475}, {124,0.01717822}, {125,0.01732673}, {126,0.01735644}, {127,0.01736634}, {128,0.01752475}, {129,0.01799010}, {130,0.01782178}, {131,0.01818812}, {132,0.01830693}, {133,0.01823762}, {134,0.01857426}, {135,0.02389109}, {136,0.01861386}, {137,0.01894059}, {138,0.01897030}, {139,0.01918812}, {140,0.02297030}, {141,0.01938614}, {142,0.01969307}, {143,0.01987129}, {144,0.01989109}, {145,0.01999010}, {146,0.02021782}, {147,0.02032673}, {148,0.02053465}, {149,0.02033663}, {150,0.02058416}, {151,0.02109901}, {152,0.02616832}, {153,0.02120792}, {154,0.02287129}, {155,0.02139604}, {156,0.02144554}, {157,0.02179208}, {158,0.02178218}, {159,0.02366337}, {160,0.02205941}, {161,0.02222772}, {162,0.02612871}, {163,0.02239604}, {164,0.02247525}, {165,0.02652475}, {166,0.02269307}, {167,0.02323762}, {168,0.02458416}, {169,0.02339604}, {170,0.02330693}, {171,0.02348515}, {172,0.02700990}, {173,0.02372277}, {174,0.02398020}, {175,0.02418812}, {176,0.02537624}, {177,0.03453465}, {178,0.02444554}, {179,0.02456436}, {180,0.02450495}, {181,0.02473267}, {182,0.02867327}, {183,0.03255446}, {184,0.02530693}, {185,0.02535644}, {186,0.02539604}, {187,0.02567327}, {188,0.02560396}, {189,0.02601980}, {190,0.02606931}, {191,0.02814851}, {192,0.02926733}, {193,0.03105941}, {194,0.03228713}, {195,0.03317822}, {196,0.03380198}, {197,0.03429703}, {198,0.03429703}, {199,0.03403960}, {200,0.03347525}, {201,0.03259406}, {202,0.03165347}, {203,0.03066337}, {204,0.02902970}, {205,0.02789109}, {206,0.02816832}, {207,0.02845545}, {208,0.02843564}, {209,0.02862376}, {210,0.02852475}, {211,0.03074257}, {212,0.03632673}, {213,0.03108911}, {214,0.02918812}, {215,0.02945545}, {216,0.02953465}, {217,0.03104950}, {218,0.03357426}, {219,0.02977228}, {220,0.02986139}, {221,0.03032673}, {222,0.03699010}, {223,0.03045545}, {224,0.03050495}, {225,0.03047525}, {226,0.03569307}, {227,0.03093069}, {228,0.03088119}, {229,0.03784158}, {230,0.03145545}, {231,0.03175248}, {232,0.03923762}, {233,0.03162376}, {234,0.03200000}, {235,0.03791089}, {236,0.03211881}, {237,0.03258416}, {238,0.03398020}, {239,0.03273267}, {240,0.03838614}, {241,0.03286139}, {242,0.03420792}, {243,0.03312871}, {244,0.03317822}, {245,0.03364356}, {246,0.03362376}, {247,0.03445545}, {248,0.03371287}, {249,0.03502970}, {250,0.03458416}, {251,0.03438614}, {252,0.03487129}, {253,0.03472277}, {254,0.04390099}, {255,0.03506931}, {256,0.03998020}, {257,0.03501980}, {258,0.03606931}, {259,0.03528713}, {260,0.03519802}, {261,0.04090099}, {262,0.03576238}, {263,0.03569307}, {264,0.04310891}, {265,0.03590099}, {266,0.03600000}, {267,0.04299010}, {268,0.03676238}, {269,0.03695050}, {270,0.04200990}, {271,0.03899010}, {272,0.03710891}, {273,0.03696040}, {274,0.04405941}, {275,0.03919802}, {276,0.03774257}, {277,0.03766337}, {278,0.04057426}, {279,0.04606931}, {280,0.03818812}, {281,0.03850495}, {282,0.03833663}, {283,0.03873267}, {284,0.04205941}, {285,0.04587129}, {286,0.04928713}, {287,0.03958416}, {288,0.03942574}, {289,0.03926733}, {290,0.03970297}, {291,0.03988119}, {292,0.03969307}, {293,0.04100000}, {294,0.04238614}, {295,0.04318812}, {296,0.04398020}, {297,0.04455446}, {298,0.04507921}, {299,0.04531683}, {300,0.04402970}, {301,0.04456436}, {302,0.04556436}, {303,0.04464356}, {304,0.04321782}, {305,0.04142574}, {306,0.04167327}, {307,0.04201980}, {308,0.04217822}, {309,0.04218812}, {310,0.04257426}, {311,0.05367327}, {312,0.04991089}, {313,0.04521782}, {314,0.04316832}, {315,0.04331683}, {316,0.04336634}, {317,0.05591089}, {318,0.05055446}, {319,0.04548515}, {320,0.04322772}, {321,0.04390099}, {322,0.05373267}, {323,0.04862376}, {324,0.04380198}, {325,0.04456436}, {326,0.05423762}, {327,0.04845545}, {328,0.04438614}, {329,0.04513861}, {330,0.05177228}, {331,0.04513861}, {332,0.04542574}, {333,0.05602970}, {334,0.04548515}, {335,0.04616832}, {336,0.05198020}, {337,0.04587129}, {338,0.05935644}, {339,0.04865347}, {340,0.04591089}, {341,0.05366337}, {342,0.04640594}, {343,0.05724752}, {344,0.04652475}, {345,0.06013861}, {346,0.04828713}, {347,0.04745545}, {348,0.04937624}, {349,0.04780198}, {350,0.04952475}, {351,0.04956436}, {352,0.04869307}, {353,0.05992079}, {354,0.04800990}, {355,0.05755446}, {356,0.04831683}, {357,0.05803960}, {358,0.04890099}, {359,0.05203960}, {360,0.06244554}, {361,0.04931683}, {362,0.05641584}, {363,0.04947525}, {364,0.04943564}, {365,0.05803960}, {366,0.04974257}, {367,0.05043564}, {368,0.05691089}, {369,0.05025743}, {370,0.05043564}, {371,0.05513861}, {372,0.06156436}, {373,0.05115842}, {374,0.05115842}, {375,0.05653465}, {376,0.06205941}, {377,0.05167327}, {378,0.05137624}, {379,0.05468317}, {380,0.06254455}, {381,0.06900990}, {382,0.05220792}, {383,0.05221782}, {384,0.05189109}, {385,0.05581188}, {386,0.06070297}, {387,0.06349505}, {388,0.06706931}, {389,0.05292079}, {390,0.05324752}, {391,0.05329703}, {392,0.05328713}, {393,0.05445545}, {394,0.05614851}, {395,0.05752475}, {396,0.05845545}, {397,0.05964356}, {398,0.05999010}, {399,0.06400000}, {400,0.06315842}, {401,0.06176238}, {402,0.06141584}, {403,0.06134653}, {404,0.05993069}, {405,0.05924752}, {406,0.05775248}, {407,0.05668317}, {408,0.05536634}, {409,0.05594059}, {410,0.05608911}, {411,0.05624752}, {412,0.06849505}, {413,0.06598020}, {414,0.06291089}, {415,0.06024752}, {416,0.05653465}, {417,0.05711881}, {418,0.05876238}, {419,0.06961386}, {420,0.06402970}, {421,0.05902970}, {422,0.05745545}, {423,0.07356436}, {424,0.06772277}, {425,0.06152475}, {426,0.05824752}, {427,0.07326733}, {428,0.06655446}, {429,0.05989109}, {430,0.05851485}, {431,0.06940594}, {432,0.06180198}, {433,0.05890099}, {434,0.07599010}, {435,0.06369307}, {436,0.05959406}, {437,0.07108911}, {438,0.06114851}, {439,0.07656436}, {440,0.06612871}, {441,0.05996040}, {442,0.07080198}, {443,0.06190099}, {444,0.07364356}, {445,0.06350495}, {446,0.07600000}, {447,0.06524752}, {448,0.06087129}, {449,0.06582178}, {450,0.06097030}, {451,0.07000000}, {452,0.06167327}, {453,0.06793069}, {454,0.06405941}, {455,0.06652475}, {456,0.07623762}, {457,0.06385149}, {458,0.07489109}, {459,0.06253465}, {460,0.07040594}, {461,0.06441584}, {462,0.06507921}, {463,0.07445545}, {464,0.06300000}, {465,0.06803960}, {466,0.07790099}, {467,0.06411881}, {468,0.07088119}, {469,0.07905941}, {470,0.06388119}, {471,0.06875248}, {472,0.07559406}, {473,0.06667327}, {474,0.06497030}, {475,0.07074257}, {476,0.07613861}, {477,0.06697030}, {478,0.06539604}, {479,0.06886139}, {480,0.07562376}, {481,0.08515842}, {482,0.06569307}, {483,0.06592079}, {484,0.06894059}, {485,0.07446535}, {486,0.07744554}, {487,0.08051485}, {488,0.08224752}, {489,0.06670297}, {490,0.06649505}, {491,0.06760396}, {492,0.06961386}, {493,0.07301980}, {494,0.07664356}, {495,0.07668317}, {496,0.07732673}, {497,0.07928713}, {498,0.07891089}, {499,0.08008911}, {500,0.07930693}, {505,0.07929703}, {510,0.07807921}, {515,0.07535644}, {520,0.07191089}, {525,0.07192079}, {530,0.09239604}, {535,0.08186139}, {540,0.07319802}, {545,0.08620792}, {550,0.07562376}, {555,0.08826733}, {560,0.07597030}, {565,0.08481188}, {570,0.09307921}, {575,0.07889109}, {580,0.08481188}, {585,0.09085149}, {590,0.09359406}, {595,0.09550495}, {600,0.09674257}, {605,0.09624752}, {610,0.09516832}, {615,0.09350495}, {620,0.09375248}, {625,0.08747525}, {630,0.10598020}, {635,0.09795050}, {640,0.08937624}, {645,0.10363366}, {650,0.09416832}, {655,0.10584158}, {660,0.09417822}, {665,0.10895050}, {670,0.11507921}, {675,0.09744554}, {680,0.10265347}, {685,0.10792079}, {690,0.11166337}, {695,0.11439604}, {700,0.12547525}, {705,0.11919802}, {710,0.11834653}, {715,0.11490099}, {720,0.11123762}, {725,0.10877228}, {730,0.10599010}, {735,0.12256436}, {740,0.11442574}, {745,0.12783168}, {750,0.11699010}, {755,0.12762376}, {760,0.12216832}, {765,0.12913861}, {770,0.11208911}, {775,0.11931683}, {780,0.12586139}, {785,0.13046535}, {790,0.11600990}, {795,0.11783168}, {800,0.11859406}, {805,0.11924752}, {810,0.11935644}, {815,0.12208911}, {820,0.14132673}, {825,0.13587129}, {830,0.12840594}, {835,0.12244554}, {840,0.13603960}, {845,0.13281188}, {850,0.14607921}, {855,0.13282178}, {860,0.14289109}, {865,0.13780198}, {870,0.14411881}, {875,0.15002970}, {880,0.13134653}, {885,0.13705941}, {890,0.14443564}, {895,0.14406931}, {900,0.14677228}, {905,0.14444554}, {910,0.14568317}, {915,0.15091089}, {920,0.13914851}, {925,0.13804950}, {930,0.13496040}, {935,0.16176238}, {940,0.14559406}, {945,0.16002970}, {950,0.14822772}, {955,0.14022772}, {960,0.15374257}, {965,0.15371287}, {970,0.14609901}, {975,0.15535644}, {980,0.16548515}, {985,0.14594059}, {990,0.14751485}, {995,0.15071287}, {1000,0.15519802}, {1010,0.15529703}, {1020,0.15271287}, {1030,0.17012871}, {1040,0.17014851}, {1050,0.16116832}, {1060,0.17058416}, {1070,0.16866337}, {1080,0.17411881}, {1090,0.17316832}, {1100,0.17761386}, {1110,0.18388119}, {1120,0.18003960}, {1130,0.17531683}, {1140,0.17337624}, {1150,0.18736634}, {1160,0.17424752}, {1170,0.20020792}, {1180,0.19717822}, {1190,0.18004950}, {1200,0.18864356}, {1210,0.17770297}, {1220,0.18297030}, {1230,0.21842574}, {1240,0.19946535}, {1250,0.18894059}, {1260,0.20703960}, {1270,0.21475248}, {1280,0.19572277}, {1290,0.20844554}, {1300,0.20844554}, {1310,0.20908911}, {1320,0.20840594}, {1330,0.20635644}, {1340,0.21740594}, {1350,0.22067327}, {1360,0.20783168}, {1370,0.22553465}, {1380,0.22638614}, {1390,0.20473267}, {1400,0.21605941}, {1410,0.21470297}, {1420,0.22024752}, {1430,0.23549505}, {1440,0.24830693}, {1450,0.22818812}, {1460,0.23744554}, {1470,0.23199010}, {1480,0.23157426}, {1490,0.24710891}, {1500,0.24730693}, {1510,0.25550495}, {1520,0.24824752}, {1530,0.24044554}, {1540,0.24176238}, {1550,0.25150495}, {1560,0.25075248}, {1570,0.25387129}, {1580,0.25285149}, {1590,0.24849505}, {1600,0.27230693}, {1610,0.26020792}, {1620,0.27604950}, {1630,0.25582178}, {1640,0.26544554}, {1650,0.26794059}, {1660,0.27568317}, {1670,0.26880198}, {1680,0.26334653}, {1690,0.26509901}, {1700,0.27131683}, {1710,0.27354455}, {1720,0.28809901}, {1730,0.26676238}, {1740,0.29441584}, {1750,0.27690099}, {1760,0.27800000}, {1770,0.27969307}, {1780,0.29793069}, {1790,0.29387129}, {1800,0.28064356}, {1810,0.27933663}, {1820,0.28511881}, {1830,0.27938614}, {1840,0.29554455}, {1850,0.30220792}, {1860,0.30348515}, {1870,0.29802970}, {1880,0.30272277}, {1890,0.31688119}, {1900,0.31618812}, {1910,0.29752475}, {1920,0.30483168}, {1930,0.31431683}, {1940,0.31673267}, {1950,0.32888119}, {1960,0.31661386}, {1970,0.31516832}, {1980,0.31495050}, {1990,0.32545545}, {2000,0.34845545}, {2050,0.32816832}, {2100,0.33094059}, {2150,0.36264356}, {2200,0.34304950}, {2250,0.36784158}, {2300,0.40842574}, {2350,0.37801980}, {2400,0.39234653}, {2450,0.40083168}, {2500,0.42220792}, {2550,0.44549505}, {2600,0.42316832}, {2650,0.42834653}, {2700,0.44336634}, {2750,0.45455446}, {2800,0.46277228}, {2850,0.47559406}, {2900,0.49076238}, {2950,0.49483168}, {3000,0.51069307}, {3050,0.51141584}, {3100,0.52389109}, {3150,0.52834653}, {3200,0.52510891}, {3250,0.55718812}, {3300,0.54707921}, {3350,0.55952475}, {3400,0.56759406}, {3450,0.57710891}, {3500,0.57741584}, {3550,0.58348515}, {3600,0.58456436}, {3650,0.59616832}, {3700,0.61585149}, {3750,0.60514851}, {3800,0.62041584}, {3850,0.63740594}, {3900,0.66874257}, {3950,0.64839604}, {4000,0.66435644}, {4050,0.66437624}, {4100,0.67245545}, {4150,0.70727723}, {4200,0.68647525}, {4250,0.69259406}, {4300,0.72627723}, {4350,0.71244554}, {4400,0.71782178}, {4450,0.74492079}, {4500,0.74405941}, {4550,0.74727723}, {4600,0.79026733}, {4650,0.76644554}, {4700,0.79671287}, {4750,0.78887129}, {4800,0.77749505}, {4850,0.81873267}, {4900,0.81477228}, {4950,0.81989109}, {5000,0.82241584}, {5050,0.96989109}, {5100,0.84955446}, {5150,0.85134653}, {5200,0.87753465}, {5250,0.88084158}, {5300,0.88620792}, {5350,0.91123762}, {5400,0.89466337}, {5450,0.91602970}, {5500,0.91599010}, {5550,0.92664356}, {5600,0.94419802}, {5650,0.93460396}, {5700,0.95011881}, {5750,0.97067327}, {5800,0.98763366}, {5850,0.99291089}, {5900,0.98233663}, {5950,1.00170297}, {6000,0.99548515}, {6050,1.1116000}, {6100,1.0750286}, {6150,1.0473143}, {6200,1.0783714}, {6250,1.0767429}, {6300,1.0749429}, {6350,1.0976286}, {6400,1.0937714}, {6450,1.1217429}, {6500,1.1474000}, {6550,1.1549429}, {6600,1.1600571}, {6650,1.1826571}, {6700,1.1838571}, {6750,1.2025143}, {6800,1.1948857}, {6850,1.2017429}, {6900,1.2294286}, {6950,1.2299714}, {7000,1.2327143}, {7050,1.2372286}, {7100,1.2516286}, {7150,1.2710857}, {7200,1.2295143}, {7250,1.2520000}, {7300,1.2874286}, {7350,1.3210000}, {7400,1.3306286}, {7450,1.3422857}, {7500,1.3349143}, {7550,1.3570571}, {7600,1.3563429}, {7650,1.3533714}, {7700,1.3459429}, {7750,1.4050286}, {7800,1.4182000}, {7850,1.4177714}, {7900,1.4054000}, {7950,1.4196857}, {8000,1.4292857}, {8050,1.4506000}, {8100,1.4589143}, {8150,1.4597143}, {8200,1.4146286}, {8250,1.4615429}, {8300,1.4970571}, {8350,1.4852857}, {8400,1.4719143}, {8450,1.4784857}, {8500,1.5355429}, {8550,1.5371714}, {8600,1.5008000}, {8650,1.5666286}, {8700,1.6041714}, {8750,1.5488571}, {8800,1.5790857}, {8850,1.5916286}, {8900,1.5782857}, {8950,1.6429429}, {9000,1.5989714}, {9050,1.5993714}, {9100,1.6448571}, {9150,1.6662857}, {9200,1.6294000}, {9250,1.6765429}, {9300,1.6929143}, {9350,1.6634286}, {9400,1.7041143}, {9450,1.7169143}, {9500,1.7236000}, {9550,1.7226857}, {9600,1.7481714}, {9650,1.7662857}, {9700,1.7193429}, {9750,1.7703429}, {9800,1.7375714}, {9850,1.7771143}, {9900,1.7920857}, {9950,1.8160286}, {10000,1.7847429}, {10100,1.8278286}, {10200,1.8378000}, {10300,1.8616000}, {10400,1.8154000}, {10500,1.8625429}, {10600,1.8767143}, {10700,1.9464571}, {10800,1.8813143}, {10900,1.9650000}, {11000,1.9577143}, {11100,1.9988286}, {11200,1.9927143}, {11300,2.0395429}, {11400,2.0455714}, {11500,2.0746286}, {11600,2.0787143}, {11700,2.1254571}, {11800,2.0884000}, {11900,2.1749714}, {12000,2.1388000}, {12100,2.1713143}, {12200,2.2121143}, {12300,2.1917429}, {12400,2.2227429}, {12500,2.2401429}, {12600,2.2647714}, {12700,2.2770000}, {12800,2.2737143}, {12900,2.3129143}, {13000,2.3538000}, {13100,2.3357429}, {13200,2.3344286}, {13300,2.4240286}, {13400,2.3988571}, {13500,2.4618857}, {13600,2.4333714}, {13700,2.4518857}, {13800,2.4725429}, {13900,2.5236571}, {14000,2.5171429}, {14100,2.5486000}, {14200,2.6678286}, {14300,2.6222000}, {14400,2.5740857}, {14500,2.9622571}, {14600,2.6255429}, {14700,2.8128857}, {14800,2.7275143}, {14900,2.6830286}, {15000,2.6897143}, {15100,2.7553143}, {15200,2.7998571}, {15300,2.7623714}, {15400,2.9437429}, {15500,2.7955429}, {15600,2.7788000}, {15700,2.9218571}, {15800,2.9273143}, {15900,2.8397714}, {16000,2.8361429}, {16100,2.8744286}, {16200,2.8927429}, {16300,2.9768286}, {16400,2.9385143}, {16500,2.9971143}, {16600,3.1356571}, {16700,3.0072857}, {16800,3.0026000}, {16900,3.0158000}, {17000,3.0678286}, {17100,3.1652000}, {17200,3.0899714}, {17300,3.1009714}, {17400,3.1037714}, {17500,3.1352857}, {17600,3.1431143}, {17700,3.1414286}, {17800,3.1682571}, {17900,3.2364000}, {18000,3.1942571}, {18100,3.3004571}, {18200,3.2668000}, {18300,3.4062571}, {18400,3.3360857}, {18500,3.3287714}, {18600,3.3406571}, {18700,3.4356571}, {18800,3.4048000}, {18900,3.4357143}, {19000,3.6671429}, {19100,3.4871143}, {19200,3.6187714}, {19300,3.5064286}, {19400,3.5037429}, {19500,3.7869143}, {19600,3.6717143}, {19700,3.7633714}, {19800,3.5775714}, {19900,3.7831143}, {20000,3.6926857}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["Aggregate"]["user"] = {{1,0.00060396}, {2,0.00103960}, {3,0.00109901}, {4,0.00129703}, {5,0.00136634}, {6,0.00109901}, {7,0.00195050}, {8,0.00849505}, {9,0.00180198}, {10,0.00217822}, {11,0.00186139}, {12,0.00212871}, {13,0.00236634}, {14,0.00228713}, {15,0.00245545}, {16,0.00301980}, {17,0.00279208}, {18,0.00313861}, {19,0.00324752}, {20,0.00324752}, {21,0.00329703}, {22,0.00335644}, {23,0.00372277}, {24,0.00372277}, {25,0.00406931}, {26,0.00385149}, {27,0.00458416}, {28,0.00416832}, {29,0.00450495}, {30,0.00463366}, {31,0.00467327}, {32,0.00552475}, {33,0.00497030}, {34,0.00548515}, {35,0.00546535}, {36,0.00545545}, {37,0.00556436}, {38,0.00563366}, {39,0.00628713}, {40,0.00611881}, {41,0.00662376}, {42,0.00622772}, {43,0.00655446}, {44,0.00672277}, {45,0.00725743}, {46,0.00688119}, {47,0.00733663}, {48,0.00748515}, {49,0.00923762}, {50,0.00751485}, {51,0.00761386}, {52,0.00782178}, {53,0.00782178}, {54,0.00819802}, {55,0.00833663}, {56,0.00944554}, {57,0.00826733}, {58,0.00867327}, {59,0.00853465}, {60,0.00871287}, {61,0.00837624}, {62,0.00880198}, {63,0.00910891}, {64,0.00892079}, {65,0.00932673}, {66,0.00937624}, {67,0.01004950}, {68,0.00962376}, {69,0.00972277}, {70,0.01015842}, {71,0.01034653}, {72,0.01089109}, {73,0.01048515}, {74,0.01044554}, {75,0.01102970}, {76,0.01059406}, {77,0.01300990}, {78,0.01082178}, {79,0.01136634}, {80,0.01139604}, {81,0.01186139}, {82,0.01150495}, {83,0.01188119}, {84,0.01552475}, {85,0.01208911}, {86,0.01217822}, {87,0.01249505}, {88,0.01260396}, {89,0.01278218}, {90,0.01294059}, {91,0.01327723}, {92,0.01327723}, {93,0.01328713}, {94,0.01321782}, {95,0.01338614}, {96,0.01303960}, {97,0.01387129}, {98,0.01407921}, {99,0.01404950}, {100,0.01431683}, {101,0.01450495}, {102,0.01473267}, {103,0.01445545}, {104,0.01480198}, {105,0.01498020}, {106,0.01518812}, {107,0.01950495}, {108,0.01665347}, {109,0.01533663}, {110,0.01572277}, {111,0.01588119}, {112,0.01595050}, {113,0.01615842}, {114,0.01967327}, {115,0.01596040}, {116,0.01647525}, {117,0.01640594}, {118,0.01656436}, {119,0.01936634}, {120,0.01673267}, {121,0.01701980}, {122,0.01713861}, {123,0.02023762}, {124,0.01740594}, {125,0.01751485}, {126,0.01765347}, {127,0.01740594}, {128,0.01787129}, {129,0.01816832}, {130,0.01774257}, {131,0.01819802}, {132,0.01822772}, {133,0.01809901}, {134,0.01846535}, {135,0.02363366}, {136,0.01863366}, {137,0.01898020}, {138,0.01864356}, {139,0.01895050}, {140,0.02292079}, {141,0.01896040}, {142,0.01943564}, {143,0.01935644}, {144,0.01945545}, {145,0.01966337}, {146,0.01966337}, {147,0.01988119}, {148,0.02011881}, {149,0.02046535}, {150,0.02040594}, {151,0.02119802}, {152,0.02596040}, {153,0.02124752}, {154,0.02270297}, {155,0.02119802}, {156,0.02126733}, {157,0.02151485}, {158,0.02180198}, {159,0.02361386}, {160,0.02220792}, {161,0.02202970}, {162,0.02569307}, {163,0.02262376}, {164,0.02246535}, {165,0.02647525}, {166,0.02263366}, {167,0.02300990}, {168,0.02464356}, {169,0.02356436}, {170,0.02345545}, {171,0.02370297}, {172,0.02680198}, {173,0.02367327}, {174,0.02408911}, {175,0.02407921}, {176,0.02528713}, {177,0.03365347}, {178,0.02438614}, {179,0.02453465}, {180,0.02468317}, {181,0.02474257}, {182,0.02844554}, {183,0.03272277}, {184,0.02497030}, {185,0.02529703}, {186,0.02567327}, {187,0.02538614}, {188,0.02537624}, {189,0.02613861}, {190,0.02587129}, {191,0.02784158}, {192,0.02917822}, {193,0.03142574}, {194,0.03256436}, {195,0.03295050}, {196,0.03408911}, {197,0.03416832}, {198,0.03407921}, {199,0.03380198}, {200,0.03349505}, {201,0.03272277}, {202,0.03171287}, {203,0.03061386}, {204,0.02876238}, {205,0.02800000}, {206,0.02798020}, {207,0.02824752}, {208,0.02800000}, {209,0.02855446}, {210,0.02828713}, {211,0.03077228}, {212,0.03605941}, {213,0.03112871}, {214,0.02944554}, {215,0.02927723}, {216,0.02970297}, {217,0.03137624}, {218,0.03339604}, {219,0.02963366}, {220,0.02973267}, {221,0.03053465}, {222,0.03655446}, {223,0.03034653}, {224,0.03068317}, {225,0.03047525}, {226,0.03559406}, {227,0.03120792}, {228,0.03085149}, {229,0.03763366}, {230,0.03158416}, {231,0.03197030}, {232,0.03876238}, {233,0.03167327}, {234,0.03212871}, {235,0.03737624}, {236,0.03213861}, {237,0.03241584}, {238,0.03415842}, {239,0.03264356}, {240,0.03800000}, {241,0.03321782}, {242,0.03420792}, {243,0.03289109}, {244,0.03341584}, {245,0.03382178}, {246,0.03365347}, {247,0.03474257}, {248,0.03381188}, {249,0.03486139}, {250,0.03462376}, {251,0.03432673}, {252,0.03478218}, {253,0.03484158}, {254,0.04378218}, {255,0.03523762}, {256,0.03974257}, {257,0.03534653}, {258,0.03623762}, {259,0.03527723}, {260,0.03543564}, {261,0.04038614}, {262,0.03597030}, {263,0.03574257}, {264,0.04283168}, {265,0.03595050}, {266,0.03614851}, {267,0.04282178}, {268,0.03693069}, {269,0.03691089}, {270,0.04172277}, {271,0.03837624}, {272,0.03728713}, {273,0.03691089}, {274,0.04405941}, {275,0.03934653}, {276,0.03745545}, {277,0.03771287}, {278,0.04027723}, {279,0.04586139}, {280,0.03804950}, {281,0.03814851}, {282,0.03793069}, {283,0.03836634}, {284,0.04167327}, {285,0.04581188}, {286,0.04930693}, {287,0.03910891}, {288,0.03893069}, {289,0.03890099}, {290,0.03933663}, {291,0.03965347}, {292,0.03934653}, {293,0.04078218}, {294,0.04207921}, {295,0.04312871}, {296,0.04362376}, {297,0.04448515}, {298,0.04500000}, {299,0.04538614}, {300,0.04361386}, {301,0.04455446}, {302,0.04542574}, {303,0.04452475}, {304,0.04300000}, {305,0.04106931}, {306,0.04134653}, {307,0.04166337}, {308,0.04190099}, {309,0.04197030}, {310,0.04247525}, {311,0.05356436}, {312,0.04973267}, {313,0.04515842}, {314,0.04296040}, {315,0.04307921}, {316,0.04288119}, {317,0.05550495}, {318,0.05030693}, {319,0.04539604}, {320,0.04286139}, {321,0.04408911}, {322,0.05348515}, {323,0.04878218}, {324,0.04353465}, {325,0.04451485}, {326,0.05375248}, {327,0.04825743}, {328,0.04433663}, {329,0.04488119}, {330,0.05147525}, {331,0.04512871}, {332,0.04546535}, {333,0.05564356}, {334,0.04531683}, {335,0.04605941}, {336,0.05126733}, {337,0.04592079}, {338,0.05945545}, {339,0.04877228}, {340,0.04622772}, {341,0.05319802}, {342,0.04660396}, {343,0.05717822}, {344,0.04669307}, {345,0.06005941}, {346,0.04807921}, {347,0.04770297}, {348,0.04906931}, {349,0.04783168}, {350,0.04980198}, {351,0.04942574}, {352,0.04860396}, {353,0.05951485}, {354,0.04828713}, {355,0.05737624}, {356,0.04863366}, {357,0.05776238}, {358,0.04920792}, {359,0.05185149}, {360,0.06213861}, {361,0.04941584}, {362,0.05622772}, {363,0.04980198}, {364,0.04940594}, {365,0.05800990}, {366,0.04992079}, {367,0.05038614}, {368,0.05666337}, {369,0.05072277}, {370,0.05046535}, {371,0.05485149}, {372,0.06159406}, {373,0.05072277}, {374,0.05054455}, {375,0.05636634}, {376,0.06197030}, {377,0.05149505}, {378,0.05157426}, {379,0.05472277}, {380,0.06262376}, {381,0.06898020}, {382,0.05220792}, {383,0.05205941}, {384,0.05174257}, {385,0.05544554}, {386,0.06074257}, {387,0.06339604}, {388,0.06721782}, {389,0.05282178}, {390,0.05341584}, {391,0.05301980}, {392,0.05315842}, {393,0.05447525}, {394,0.05586139}, {395,0.05750495}, {396,0.05860396}, {397,0.05959406}, {398,0.06006931}, {399,0.06388119}, {400,0.06308911}, {401,0.06188119}, {402,0.06124752}, {403,0.06130693}, {404,0.05984158}, {405,0.05943564}, {406,0.05760396}, {407,0.05655446}, {408,0.05535644}, {409,0.05594059}, {410,0.05571287}, {411,0.05612871}, {412,0.06853465}, {413,0.06578218}, {414,0.06278218}, {415,0.06052475}, {416,0.05643564}, {417,0.05700990}, {418,0.05870297}, {419,0.06936634}, {420,0.06385149}, {421,0.05932673}, {422,0.05720792}, {423,0.07306931}, {424,0.06742574}, {425,0.06171287}, {426,0.05816832}, {427,0.07288119}, {428,0.06632673}, {429,0.05992079}, {430,0.05864356}, {431,0.06930693}, {432,0.06188119}, {433,0.05879208}, {434,0.07569307}, {435,0.06381188}, {436,0.05958416}, {437,0.07085149}, {438,0.06116832}, {439,0.07650495}, {440,0.06589109}, {441,0.05988119}, {442,0.07104950}, {443,0.06208911}, {444,0.07384158}, {445,0.06329703}, {446,0.07575248}, {447,0.06488119}, {448,0.06105941}, {449,0.06563366}, {450,0.06081188}, {451,0.06964356}, {452,0.06153465}, {453,0.06765347}, {454,0.06391089}, {455,0.06610891}, {456,0.07614851}, {457,0.06358416}, {458,0.07453465}, {459,0.06242574}, {460,0.07007921}, {461,0.06443564}, {462,0.06500000}, {463,0.07394059}, {464,0.06278218}, {465,0.06751485}, {466,0.07787129}, {467,0.06396040}, {468,0.07092079}, {469,0.07866337}, {470,0.06393069}, {471,0.06850495}, {472,0.07541584}, {473,0.06634653}, {474,0.06500990}, {475,0.07052475}, {476,0.07582178}, {477,0.06673267}, {478,0.06528713}, {479,0.06854455}, {480,0.07545545}, {481,0.08505941}, {482,0.06523762}, {483,0.06569307}, {484,0.06882178}, {485,0.07462376}, {486,0.07710891}, {487,0.08010891}, {488,0.08183168}, {489,0.06639604}, {490,0.06616832}, {491,0.06725743}, {492,0.06950495}, {493,0.07299010}, {494,0.07644554}, {495,0.07626733}, {496,0.07682178}, {497,0.07890099}, {498,0.07852475}, {499,0.07958416}, {500,0.07897030}, {505,0.07890099}, {510,0.07744554}, {515,0.07516832}, {520,0.07195050}, {525,0.07172277}, {530,0.09222772}, {535,0.08157426}, {540,0.07329703}, {545,0.08606931}, {550,0.07530693}, {555,0.08809901}, {560,0.07559406}, {565,0.08475248}, {570,0.09323762}, {575,0.07884158}, {580,0.08469307}, {585,0.09046535}, {590,0.09348515}, {595,0.09518812}, {600,0.09646535}, {605,0.09602970}, {610,0.09513861}, {615,0.09330693}, {620,0.09352475}, {625,0.08729703}, {630,0.10547525}, {635,0.09778218}, {640,0.08902970}, {645,0.10390099}, {650,0.09432673}, {655,0.10577228}, {660,0.09421782}, {665,0.10866337}, {670,0.11490099}, {675,0.09744554}, {680,0.10213861}, {685,0.10793069}, {690,0.11121782}, {695,0.11425743}, {700,0.12519802}, {705,0.11879208}, {710,0.11782178}, {715,0.11444554}, {720,0.11076238}, {725,0.10869307}, {730,0.10588119}, {735,0.12237624}, {740,0.11374257}, {745,0.12747525}, {750,0.11669307}, {755,0.12758416}, {760,0.12222772}, {765,0.12877228}, {770,0.11177228}, {775,0.11916832}, {780,0.12543564}, {785,0.13001980}, {790,0.11576238}, {795,0.11752475}, {800,0.11854455}, {805,0.11895050}, {810,0.11891089}, {815,0.12167327}, {820,0.14095050}, {825,0.13559406}, {830,0.12829703}, {835,0.12210891}, {840,0.13593069}, {845,0.13232673}, {850,0.14584158}, {855,0.13238614}, {860,0.14265347}, {865,0.13769307}, {870,0.14352475}, {875,0.14946535}, {880,0.13080198}, {885,0.13661386}, {890,0.14400000}, {895,0.14353465}, {900,0.14651485}, {905,0.14410891}, {910,0.14541584}, {915,0.15073267}, {920,0.13895050}, {925,0.13753465}, {930,0.13487129}, {935,0.16148515}, {940,0.14535644}, {945,0.15973267}, {950,0.14812871}, {955,0.14035644}, {960,0.15334653}, {965,0.15336634}, {970,0.14588119}, {975,0.15511881}, {980,0.16497030}, {985,0.14552475}, {990,0.14721782}, {995,0.15073267}, {1000,0.15504950}, {1010,0.15481188}, {1020,0.15209901}, {1030,0.16967327}, {1040,0.16994059}, {1050,0.16067327}, {1060,0.16993069}, {1070,0.16808911}, {1080,0.17381188}, {1090,0.17280198}, {1100,0.17708911}, {1110,0.18363366}, {1120,0.17956436}, {1130,0.17526733}, {1140,0.17280198}, {1150,0.18702970}, {1160,0.17349505}, {1170,0.19966337}, {1180,0.19649505}, {1190,0.17948515}, {1200,0.18837624}, {1210,0.17708911}, {1220,0.18235644}, {1230,0.21760396}, {1240,0.19911881}, {1250,0.18822772}, {1260,0.20653465}, {1270,0.21393069}, {1280,0.19530693}, {1290,0.20743564}, {1300,0.20779208}, {1310,0.20847525}, {1320,0.20744554}, {1330,0.20572277}, {1340,0.21649505}, {1350,0.21986139}, {1360,0.20710891}, {1370,0.22477228}, {1380,0.22539604}, {1390,0.20390099}, {1400,0.21496040}, {1410,0.21408911}, {1420,0.21933663}, {1430,0.23475248}, {1440,0.24779208}, {1450,0.22752475}, {1460,0.23696040}, {1470,0.23141584}, {1480,0.23075248}, {1490,0.24667327}, {1500,0.24668317}, {1510,0.25502970}, {1520,0.24753465}, {1530,0.23971287}, {1540,0.24093069}, {1550,0.25071287}, {1560,0.25023762}, {1570,0.25319802}, {1580,0.25201980}, {1590,0.24797030}, {1600,0.27165347}, {1610,0.25952475}, {1620,0.27555446}, {1630,0.25542574}, {1640,0.26485149}, {1650,0.26718812}, {1660,0.27477228}, {1670,0.26778218}, {1680,0.26253465}, {1690,0.26447525}, {1700,0.27068317}, {1710,0.27288119}, {1720,0.28739604}, {1730,0.26559406}, {1740,0.29329703}, {1750,0.27588119}, {1760,0.27728713}, {1770,0.27907921}, {1780,0.29680198}, {1790,0.29313861}, {1800,0.27989109}, {1810,0.27875248}, {1820,0.28401980}, {1830,0.27877228}, {1840,0.29494059}, {1850,0.30134653}, {1860,0.30255446}, {1870,0.29717822}, {1880,0.30159406}, {1890,0.31575248}, {1900,0.31520792}, {1910,0.29676238}, {1920,0.30369307}, {1930,0.31300000}, {1940,0.31562376}, {1950,0.32792079}, {1960,0.31565347}, {1970,0.31403960}, {1980,0.31406931}, {1990,0.32458416}, {2000,0.34712871}, {2050,0.32726733}, {2100,0.33030693}, {2150,0.36159406}, {2200,0.34200990}, {2250,0.36629703}, {2300,0.40711881}, {2350,0.37695050}, {2400,0.39149505}, {2450,0.40006931}, {2500,0.42132673}, {2550,0.44417822}, {2600,0.42210891}, {2650,0.42718812}, {2700,0.44214851}, {2750,0.45336634}, {2800,0.46188119}, {2850,0.47451485}, {2900,0.48947525}, {2950,0.49371287}, {3000,0.50921782}, {3050,0.51032673}, {3100,0.52142574}, {3150,0.52719802}, {3200,0.52391089}, {3250,0.55580198}, {3300,0.54617822}, {3350,0.55866337}, {3400,0.56634653}, {3450,0.57612871}, {3500,0.57619802}, {3550,0.58256436}, {3600,0.58338614}, {3650,0.59517822}, {3700,0.61460396}, {3750,0.60420792}, {3800,0.61894059}, {3850,0.63620792}, {3900,0.66749505}, {3950,0.64723762}, {4000,0.66327723}, {4050,0.66301980}, {4100,0.67124752}, {4150,0.70609901}, {4200,0.68462376}, {4250,0.69135644}, {4300,0.72531683}, {4350,0.71143564}, {4400,0.71619802}, {4450,0.74354455}, {4500,0.74277228}, {4550,0.74574257}, {4600,0.78855446}, {4650,0.76493069}, {4700,0.79515842}, {4750,0.78720792}, {4800,0.77572277}, {4850,0.81671287}, {4900,0.81265347}, {4950,0.81764356}, {5000,0.82053465}, {5050,0.96700000}, {5100,0.84762376}, {5150,0.84902970}, {5200,0.87532673}, {5250,0.87873267}, {5300,0.88439604}, {5350,0.90921782}, {5400,0.89220792}, {5450,0.91421782}, {5500,0.91348515}, {5550,0.92429703}, {5600,0.94216832}, {5650,0.93271287}, {5700,0.94793069}, {5750,0.96913861}, {5800,0.98589109}, {5850,0.99111881}, {5900,0.98009901}, {5950,0.99971287}, {6000,0.99354455}, {6050,1.1070857}, {6100,1.0730857}, {6150,1.0461429}, {6200,1.0769429}, {6250,1.0723143}, {6300,1.0739714}, {6350,1.0962857}, {6400,1.0928571}, {6450,1.1208857}, {6500,1.1460000}, {6550,1.1533429}, {6600,1.1592571}, {6650,1.1820857}, {6700,1.1828857}, {6750,1.1991143}, {6800,1.1923143}, {6850,1.1999143}, {6900,1.2280000}, {6950,1.2257714}, {7000,1.2318286}, {7050,1.2360857}, {7100,1.2506571}, {7150,1.2705429}, {7200,1.2283429}, {7250,1.2495429}, {7300,1.2868571}, {7350,1.3180571}, {7400,1.3276000}, {7450,1.3388286}, {7500,1.3322857}, {7550,1.3529429}, {7600,1.3480000}, {7650,1.3512000}, {7700,1.3362857}, {7750,1.3947714}, {7800,1.4137429}, {7850,1.4139429}, {7900,1.3979429}, {7950,1.4112857}, {8000,1.4273429}, {8050,1.4473429}, {8100,1.4568571}, {8150,1.4584571}, {8200,1.4134286}, {8250,1.4593714}, {8300,1.4949714}, {8350,1.4833143}, {8400,1.4700286}, {8450,1.4769429}, {8500,1.5339429}, {8550,1.5361143}, {8600,1.4986857}, {8650,1.5647429}, {8700,1.6030000}, {8750,1.5470571}, {8800,1.5774571}, {8850,1.5888286}, {8900,1.5765714}, {8950,1.6411143}, {9000,1.5968857}, {9050,1.5975143}, {9100,1.6423429}, {9150,1.6642857}, {9200,1.6269143}, {9250,1.6703714}, {9300,1.6828000}, {9350,1.6605143}, {9400,1.7014000}, {9450,1.7144000}, {9500,1.7207429}, {9550,1.7203429}, {9600,1.7452000}, {9650,1.7628857}, {9700,1.7169143}, {9750,1.7671429}, {9800,1.7354286}, {9850,1.7744857}, {9900,1.7897714}, {9950,1.8141429}, {10000,1.7823143}, {10100,1.8248000}, {10200,1.8285143}, {10300,1.8590857}, {10400,1.8127429}, {10500,1.8597143}, {10600,1.8745143}, {10700,1.9439429}, {10800,1.8784000}, {10900,1.9614857}, {11000,1.9548857}, {11100,1.9959143}, {11200,1.9896000}, {11300,2.0365143}, {11400,2.0426000}, {11500,2.0706286}, {11600,2.0758857}, {11700,2.1217429}, {11800,2.0844000}, {11900,2.1713714}, {12000,2.1357714}, {12100,2.1672857}, {12200,2.2080857}, {12300,2.1877143}, {12400,2.2182286}, {12500,2.2354571}, {12600,2.2608571}, {12700,2.2725429}, {12800,2.2704571}, {12900,2.3095714}, {13000,2.3506000}, {13100,2.3323714}, {13200,2.3312571}, {13300,2.4198000}, {13400,2.3958571}, {13500,2.4582286}, {13600,2.4295714}, {13700,2.4493429}, {13800,2.4698286}, {13900,2.5208571}, {14000,2.5135429}, {14100,2.5449714}, {14200,2.6634000}, {14300,2.6185143}, {14400,2.5708571}, {14500,2.9553143}, {14600,2.6223143}, {14700,2.8087714}, {14800,2.7241429}, {14900,2.6787429}, {15000,2.6863429}, {15100,2.7520571}, {15200,2.7964286}, {15300,2.7584000}, {15400,2.9391714}, {15500,2.7923143}, {15600,2.7746857}, {15700,2.9188857}, {15800,2.9242286}, {15900,2.8367714}, {16000,2.8329143}, {16100,2.8718571}, {16200,2.8897714}, {16300,2.9740857}, {16400,2.9364286}, {16500,2.9942000}, {16600,3.1326000}, {16700,3.0044571}, {16800,3.0001429}, {16900,3.0122857}, {17000,3.0651429}, {17100,3.1621143}, {17200,3.0848286}, {17300,3.0970000}, {17400,3.1013143}, {17500,3.1305429}, {17600,3.1393714}, {17700,3.1374286}, {17800,3.1643429}, {17900,3.2330286}, {18000,3.1909714}, {18100,3.2968571}, {18200,3.2621714}, {18300,3.4000000}, {18400,3.3318286}, {18500,3.3242000}, {18600,3.3356286}, {18700,3.4312000}, {18800,3.3816857}, {18900,3.4294857}, {19000,3.6296857}, {19100,3.4594857}, {19200,3.6136857}, {19300,3.4992571}, {19400,3.4965429}, {19500,3.7682286}, {19600,3.6536000}, {19700,3.7331714}, {19800,3.5626286}, {19900,3.7778286}, {20000,3.6895143}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["Aggregate"]["system"] = {{1,0.00003960}, {2,0.00003960}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00010891}, {7,0.00000000}, {8,0.00021782}, {9,0.00003960}, {10,0.00000000}, {11,0.00010891}, {12,0.00003960}, {13,0.00003960}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00002970}, {18,0.00003960}, {19,0.00000000}, {20,0.00000000}, {21,0.00007921}, {22,0.00007921}, {23,0.00003960}, {24,0.00003960}, {25,0.00000000}, {26,0.00002970}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00007921}, {31,0.00000000}, {32,0.00000000}, {33,0.00002970}, {34,0.00003960}, {35,0.00003960}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00003960}, {40,0.00003960}, {41,0.00000000}, {42,0.00003960}, {43,0.00002970}, {44,0.00003960}, {45,0.00003960}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00010891}, {50,0.00003960}, {51,0.00007921}, {52,0.00003960}, {53,0.00007921}, {54,0.00003960}, {55,0.00000000}, {56,0.00007921}, {57,0.00007921}, {58,0.00003960}, {59,0.00000000}, {60,0.00007921}, {61,0.00007921}, {62,0.00006931}, {63,0.00003960}, {64,0.00000000}, {65,0.00013861}, {66,0.00000000}, {67,0.00003960}, {68,0.00006931}, {69,0.00002970}, {70,0.00007921}, {71,0.00003960}, {72,0.00011881}, {73,0.00000000}, {74,0.00002970}, {75,0.00000000}, {76,0.00003960}, {77,0.00006931}, {78,0.00003960}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00003960}, {83,0.00000000}, {84,0.00013861}, {85,0.00006931}, {86,0.00000000}, {87,0.00002970}, {88,0.00002970}, {89,0.00006931}, {90,0.00010891}, {91,0.00000000}, {92,0.00000000}, {93,0.00007921}, {94,0.00000000}, {95,0.00003960}, {96,0.00000000}, {97,0.00007921}, {98,0.00003960}, {99,0.00007921}, {100,0.00000000}, {101,0.00003960}, {102,0.00000000}, {103,0.00003960}, {104,0.00005941}, {105,0.00003960}, {106,0.00003960}, {107,0.00003960}, {108,0.00007921}, {109,0.00006931}, {110,0.00000000}, {111,0.00014851}, {112,0.00007921}, {113,0.00000000}, {114,0.00003960}, {115,0.00002970}, {116,0.00007921}, {117,0.00003960}, {118,0.00002970}, {119,0.00014851}, {120,0.00003960}, {121,0.00003960}, {122,0.00002970}, {123,0.00015842}, {124,0.00011881}, {125,0.00000000}, {126,0.00006931}, {127,0.00007921}, {128,0.00000000}, {129,0.00002970}, {130,0.00000000}, {131,0.00007921}, {132,0.00010891}, {133,0.00007921}, {134,0.00002970}, {135,0.00014851}, {136,0.00011881}, {137,0.00000000}, {138,0.00003960}, {139,0.00003960}, {140,0.00018812}, {141,0.00011881}, {142,0.00002970}, {143,0.00003960}, {144,0.00003960}, {145,0.00000000}, {146,0.00007921}, {147,0.00000000}, {148,0.00000000}, {149,0.00003960}, {150,0.00000000}, {151,0.00007921}, {152,0.00013861}, {153,0.00000000}, {154,0.00003960}, {155,0.00003960}, {156,0.00002970}, {157,0.00007921}, {158,0.00006931}, {159,0.00003960}, {160,0.00000000}, {161,0.00000000}, {162,0.00023762}, {163,0.00003960}, {164,0.00003960}, {165,0.00007921}, {166,0.00010891}, {167,0.00003960}, {168,0.00007921}, {169,0.00002970}, {170,0.00007921}, {171,0.00007921}, {172,0.00010891}, {173,0.00002970}, {174,0.00003960}, {175,0.00003960}, {176,0.00003960}, {177,0.00096040}, {178,0.00003960}, {179,0.00000000}, {180,0.00007921}, {181,0.00007921}, {182,0.00013861}, {183,0.00023762}, {184,0.00007921}, {185,0.00002970}, {186,0.00007921}, {187,0.00003960}, {188,0.00000000}, {189,0.00007921}, {190,0.00006931}, {191,0.00018812}, {192,0.00026733}, {193,0.00010891}, {194,0.00011881}, {195,0.00037624}, {196,0.00015842}, {197,0.00022772}, {198,0.00037624}, {199,0.00026733}, {200,0.00026733}, {201,0.00011881}, {202,0.00023762}, {203,0.00011881}, {204,0.00007921}, {205,0.00003960}, {206,0.00000000}, {207,0.00007921}, {208,0.00003960}, {209,0.00003960}, {210,0.00000000}, {211,0.00007921}, {212,0.00022772}, {213,0.00003960}, {214,0.00000000}, {215,0.00007921}, {216,0.00003960}, {217,0.00007921}, {218,0.00022772}, {219,0.00007921}, {220,0.00003960}, {221,0.00000000}, {222,0.00019802}, {223,0.00007921}, {224,0.00003960}, {225,0.00015842}, {226,0.00018812}, {227,0.00003960}, {228,0.00010891}, {229,0.00018812}, {230,0.00006931}, {231,0.00007921}, {232,0.00021782}, {233,0.00011881}, {234,0.00015842}, {235,0.00022772}, {236,0.00006931}, {237,0.00007921}, {238,0.00006931}, {239,0.00011881}, {240,0.00003960}, {241,0.00011881}, {242,0.00011881}, {243,0.00011881}, {244,0.00000000}, {245,0.00007921}, {246,0.00003960}, {247,0.00003960}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00011881}, {253,0.00000000}, {254,0.00006931}, {255,0.00000000}, {256,0.00002970}, {257,0.00015842}, {258,0.00003960}, {259,0.00007921}, {260,0.00000000}, {261,0.00003960}, {262,0.00003960}, {263,0.00006931}, {264,0.00002970}, {265,0.00003960}, {266,0.00003960}, {267,0.00007921}, {268,0.00000000}, {269,0.00007921}, {270,0.00003960}, {271,0.00003960}, {272,0.00000000}, {273,0.00007921}, {274,0.00002970}, {275,0.00003960}, {276,0.00007921}, {277,0.00000000}, {278,0.00000000}, {279,0.00003960}, {280,0.00000000}, {281,0.00007921}, {282,0.00007921}, {283,0.00014851}, {284,0.00000000}, {285,0.00011881}, {286,0.00003960}, {287,0.00000000}, {288,0.00003960}, {289,0.00002970}, {290,0.00003960}, {291,0.00007921}, {292,0.00000000}, {293,0.00000000}, {294,0.00006931}, {295,0.00003960}, {296,0.00000000}, {297,0.00000000}, {298,0.00007921}, {299,0.00007921}, {300,0.00010891}, {301,0.00002970}, {302,0.00014851}, {303,0.00011881}, {304,0.00000000}, {305,0.00000000}, {306,0.00007921}, {307,0.00007921}, {308,0.00002970}, {309,0.00003960}, {310,0.00002970}, {311,0.00003960}, {312,0.00003960}, {313,0.00003960}, {314,0.00003960}, {315,0.00003960}, {316,0.00002970}, {317,0.00011881}, {318,0.00000000}, {319,0.00003960}, {320,0.00003960}, {321,0.00003960}, {322,0.00000000}, {323,0.00000000}, {324,0.00007921}, {325,0.00000000}, {326,0.00007921}, {327,0.00000000}, {328,0.00014851}, {329,0.00000000}, {330,0.00003960}, {331,0.00011881}, {332,0.00007921}, {333,0.00007921}, {334,0.00000000}, {335,0.00000000}, {336,0.00015842}, {337,0.00000000}, {338,0.00007921}, {339,0.00003960}, {340,0.00006931}, {341,0.00007921}, {342,0.00000000}, {343,0.00003960}, {344,0.00007921}, {345,0.00000000}, {346,0.00011881}, {347,0.00000000}, {348,0.00023762}, {349,0.00003960}, {350,0.00011881}, {351,0.00023762}, {352,0.00019802}, {353,0.00022772}, {354,0.00002970}, {355,0.00007921}, {356,0.00000000}, {357,0.00003960}, {358,0.00003960}, {359,0.00007921}, {360,0.00011881}, {361,0.00003960}, {362,0.00015842}, {363,0.00003960}, {364,0.00011881}, {365,0.00003960}, {366,0.00003960}, {367,0.00003960}, {368,0.00015842}, {369,0.00002970}, {370,0.00007921}, {371,0.00015842}, {372,0.00000000}, {373,0.00007921}, {374,0.00007921}, {375,0.00007921}, {376,0.00003960}, {377,0.00011881}, {378,0.00000000}, {379,0.00003960}, {380,0.00007921}, {381,0.00000000}, {382,0.00000000}, {383,0.00003960}, {384,0.00007921}, {385,0.00003960}, {386,0.00005941}, {387,0.00000000}, {388,0.00003960}, {389,0.00000000}, {390,0.00007921}, {391,0.00011881}, {392,0.00000000}, {393,0.00000000}, {394,0.00002970}, {395,0.00003960}, {396,0.00003960}, {397,0.00010891}, {398,0.00007921}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00009901}, {403,0.00007921}, {404,0.00000000}, {405,0.00000000}, {406,0.00003960}, {407,0.00019802}, {408,0.00000000}, {409,0.00000000}, {410,0.00007921}, {411,0.00003960}, {412,0.00015842}, {413,0.00015842}, {414,0.00015842}, {415,0.00000000}, {416,0.00003960}, {417,0.00003960}, {418,0.00000000}, {419,0.00000000}, {420,0.00003960}, {421,0.00007921}, {422,0.00010891}, {423,0.00007921}, {424,0.00006931}, {425,0.00000000}, {426,0.00007921}, {427,0.00006931}, {428,0.00003960}, {429,0.00003960}, {430,0.00007921}, {431,0.00011881}, {432,0.00003960}, {433,0.00006931}, {434,0.00003960}, {435,0.00003960}, {436,0.00003960}, {437,0.00007921}, {438,0.00003960}, {439,0.00003960}, {440,0.00000000}, {441,0.00003960}, {442,0.00007921}, {443,0.00015842}, {444,0.00000000}, {445,0.00000000}, {446,0.00007921}, {447,0.00007921}, {448,0.00010891}, {449,0.00007921}, {450,0.00015842}, {451,0.00003960}, {452,0.00010891}, {453,0.00000000}, {454,0.00007921}, {455,0.00011881}, {456,0.00007921}, {457,0.00007921}, {458,0.00011881}, {459,0.00007921}, {460,0.00011881}, {461,0.00007921}, {462,0.00007921}, {463,0.00002970}, {464,0.00007921}, {465,0.00003960}, {466,0.00003960}, {467,0.00000000}, {468,0.00003960}, {469,0.00014851}, {470,0.00000000}, {471,0.00011881}, {472,0.00003960}, {473,0.00007921}, {474,0.00003960}, {475,0.00015842}, {476,0.00015842}, {477,0.00003960}, {478,0.00000000}, {479,0.00000000}, {480,0.00011881}, {481,0.00003960}, {482,0.00003960}, {483,0.00006931}, {484,0.00007921}, {485,0.00000000}, {486,0.00000000}, {487,0.00003960}, {488,0.00003960}, {489,0.00006931}, {490,0.00007921}, {491,0.00003960}, {492,0.00003960}, {493,0.00007921}, {494,0.00000000}, {495,0.00000000}, {496,0.00014851}, {497,0.00003960}, {498,0.00000000}, {499,0.00003960}, {500,0.00000000}, {505,0.00003960}, {510,0.00007921}, {515,0.00003960}, {520,0.00003960}, {525,0.00011881}, {530,0.00003960}, {535,0.00007921}, {540,0.00003960}, {545,0.00010891}, {550,0.00011881}, {555,0.00003960}, {560,0.00003960}, {565,0.00007921}, {570,0.00003960}, {575,0.00006931}, {580,0.00000000}, {585,0.00003960}, {590,0.00000000}, {595,0.00014851}, {600,0.00006931}, {605,0.00003960}, {610,0.00003960}, {615,0.00003960}, {620,0.00000000}, {625,0.00015842}, {630,0.00007921}, {635,0.00000000}, {640,0.00000000}, {645,0.00003960}, {650,0.00000000}, {655,0.00007921}, {660,0.00007921}, {665,0.00007921}, {670,0.00015842}, {675,0.00007921}, {680,0.00011881}, {685,0.00011881}, {690,0.00015842}, {695,0.00003960}, {700,0.00007921}, {705,0.00003960}, {710,0.00007921}, {715,0.00011881}, {720,0.00003960}, {725,0.00006931}, {730,0.00003960}, {735,0.00010891}, {740,0.00010891}, {745,0.00011881}, {750,0.00007921}, {755,0.00006931}, {760,0.00003960}, {765,0.00019802}, {770,0.00023762}, {775,0.00007921}, {780,0.00011881}, {785,0.00011881}, {790,0.00000000}, {795,0.00011881}, {800,0.00003960}, {805,0.00007921}, {810,0.00007921}, {815,0.00007921}, {820,0.00003960}, {825,0.00007921}, {830,0.00022772}, {835,0.00011881}, {840,0.00007921}, {845,0.00003960}, {850,0.00007921}, {855,0.00007921}, {860,0.00007921}, {865,0.00000000}, {870,0.00015842}, {875,0.00013861}, {880,0.00007921}, {885,0.00011881}, {890,0.00015842}, {895,0.00003960}, {900,0.00011881}, {905,0.00003960}, {910,0.00003960}, {915,0.00007921}, {920,0.00007921}, {925,0.00003960}, {930,0.00003960}, {935,0.00003960}, {940,0.00003960}, {945,0.00000000}, {950,0.00011881}, {955,0.00000000}, {960,0.00006931}, {965,0.00007921}, {970,0.00003960}, {975,0.00003960}, {980,0.00000000}, {985,0.00019802}, {990,0.00014851}, {995,0.00000000}, {1000,0.00015842}, {1010,0.00007921}, {1020,0.00007921}, {1030,0.00003960}, {1040,0.00000000}, {1050,0.00019802}, {1060,0.00011881}, {1070,0.00015842}, {1080,0.00003960}, {1090,0.00006931}, {1100,0.00003960}, {1110,0.00007921}, {1120,0.00003960}, {1130,0.00003960}, {1140,0.00015842}, {1150,0.00000000}, {1160,0.00007921}, {1170,0.00015842}, {1180,0.00003960}, {1190,0.00003960}, {1200,0.00003960}, {1210,0.00011881}, {1220,0.00007921}, {1230,0.00007921}, {1240,0.00007921}, {1250,0.00003960}, {1260,0.00015842}, {1270,0.00002970}, {1280,0.00015842}, {1290,0.00019802}, {1300,0.00007921}, {1310,0.00015842}, {1320,0.00011881}, {1330,0.00003960}, {1340,0.00003960}, {1350,0.00007921}, {1360,0.00000000}, {1370,0.00011881}, {1380,0.00003960}, {1390,0.00003960}, {1400,0.00015842}, {1410,0.00007921}, {1420,0.00007921}, {1430,0.00007921}, {1440,0.00006931}, {1450,0.00007921}, {1460,0.00003960}, {1470,0.00011881}, {1480,0.00002970}, {1490,0.00007921}, {1500,0.00006931}, {1510,0.00007921}, {1520,0.00003960}, {1530,0.00015842}, {1540,0.00023762}, {1550,0.00003960}, {1560,0.00007921}, {1570,0.00006931}, {1580,0.00003960}, {1590,0.00007921}, {1600,0.00011881}, {1610,0.00007921}, {1620,0.00000000}, {1630,0.00003960}, {1640,0.00000000}, {1650,0.00015842}, {1660,0.00011881}, {1670,0.00007921}, {1680,0.00018812}, {1690,0.00007921}, {1700,0.00007921}, {1710,0.00003960}, {1720,0.00007921}, {1730,0.00011881}, {1740,0.00011881}, {1750,0.00007921}, {1760,0.00007921}, {1770,0.00007921}, {1780,0.00019802}, {1790,0.00000000}, {1800,0.00019802}, {1810,0.00003960}, {1820,0.00007921}, {1830,0.00007921}, {1840,0.00003960}, {1850,0.00011881}, {1860,0.00011881}, {1870,0.00014851}, {1880,0.00018812}, {1890,0.00007921}, {1900,0.00015842}, {1910,0.00007921}, {1920,0.00022772}, {1930,0.00018812}, {1940,0.00015842}, {1950,0.00003960}, {1960,0.00023762}, {1970,0.00015842}, {1980,0.00010891}, {1990,0.00007921}, {2000,0.00011881}, {2050,0.00003960}, {2100,0.00007921}, {2150,0.00018812}, {2200,0.00011881}, {2250,0.00018812}, {2300,0.00015842}, {2350,0.00015842}, {2400,0.00015842}, {2450,0.00003960}, {2500,0.00019802}, {2550,0.00011881}, {2600,0.00018812}, {2650,0.00007921}, {2700,0.00021782}, {2750,0.00015842}, {2800,0.00002970}, {2850,0.00007921}, {2900,0.00019802}, {2950,0.00007921}, {3000,0.00026733}, {3050,0.00007921}, {3100,0.00163366}, {3150,0.00031683}, {3200,0.00015842}, {3250,0.00011881}, {3300,0.00015842}, {3350,0.00007921}, {3400,0.00025743}, {3450,0.00003960}, {3500,0.00010891}, {3550,0.00006931}, {3600,0.00011881}, {3650,0.00023762}, {3700,0.00015842}, {3750,0.00011881}, {3800,0.00018812}, {3850,0.00014851}, {3900,0.00022772}, {3950,0.00023762}, {4000,0.00003960}, {4050,0.00011881}, {4100,0.00007921}, {4150,0.00015842}, {4200,0.00027723}, {4250,0.00007921}, {4300,0.00014851}, {4350,0.00007921}, {4400,0.00018812}, {4450,0.00011881}, {4500,0.00003960}, {4550,0.00019802}, {4600,0.00022772}, {4650,0.00011881}, {4700,0.00015842}, {4750,0.00018812}, {4800,0.00019802}, {4850,0.00046535}, {4900,0.00051485}, {4950,0.00029703}, {5000,0.00003960}, {5050,0.00121782}, {5100,0.00015842}, {5150,0.00027723}, {5200,0.00050495}, {5250,0.00046535}, {5300,0.00011881}, {5350,0.00022772}, {5400,0.00038614}, {5450,0.00011881}, {5500,0.00027723}, {5550,0.00023762}, {5600,0.00019802}, {5650,0.00015842}, {5700,0.00023762}, {5750,0.00011881}, {5800,0.00007921}, {5850,0.00015842}, {5900,0.00013861}, {5950,0.00023762}, {6000,0.00011881}, {6050,0.0031143}, {6100,0.0013143}, {6150,0.0003429}, {6200,0.0006857}, {6250,0.0029143}, {6300,0.0000857}, {6350,0.0000857}, {6400,0.0001143}, {6450,0.0001143}, {6500,0.0001143}, {6550,0.0003429}, {6600,0.0001143}, {6650,0.0000000}, {6700,0.0001143}, {6750,0.0003429}, {6800,0.0001143}, {6850,0.0001143}, {6900,0.0001143}, {6950,0.0002286}, {7000,0.0000857}, {7050,0.0001143}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0002286}, {7250,0.0002286}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0002286}, {7450,0.0002286}, {7500,0.0003143}, {7550,0.0003429}, {7600,0.0003429}, {7650,0.0000000}, {7700,0.0004571}, {7750,0.0001143}, {7800,0.0002286}, {7850,0.0003429}, {7900,0.0001143}, {7950,0.0003429}, {8000,0.0000000}, {8050,0.0005714}, {8100,0.0001143}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0001143}, {8300,0.0001143}, {8350,0.0002286}, {8400,0.0003429}, {8450,0.0002000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0004286}, {8650,0.0003429}, {8700,0.0002000}, {8750,0.0002286}, {8800,0.0000000}, {8850,0.0002000}, {8900,0.0002286}, {8950,0.0000000}, {9000,0.0003143}, {9050,0.0001143}, {9100,0.0002286}, {9150,0.0005714}, {9200,0.0002286}, {9250,0.0003429}, {9300,0.0001143}, {9350,0.0002286}, {9400,0.0002286}, {9450,0.0001143}, {9500,0.0002000}, {9550,0.0001143}, {9600,0.0003143}, {9650,0.0003429}, {9700,0.0001143}, {9750,0.0005714}, {9800,0.0003429}, {9850,0.0004571}, {9900,0.0001143}, {9950,0.0000000}, {10000,0.0001143}, {10100,0.0000000}, {10200,0.0066000}, {10300,0.0002286}, {10400,0.0000000}, {10500,0.0004571}, {10600,0.0002286}, {10700,0.0003429}, {10800,0.0004571}, {10900,0.0001143}, {11000,0.0001143}, {11100,0.0002286}, {11200,0.0001143}, {11300,0.0003429}, {11400,0.0002286}, {11500,0.0003429}, {11600,0.0002286}, {11700,0.0001143}, {11800,0.0008857}, {11900,0.0001143}, {12000,0.0000000}, {12100,0.0008000}, {12200,0.0004571}, {12300,0.0008000}, {12400,0.0006857}, {12500,0.0010286}, {12600,0.0001143}, {12700,0.0009143}, {12800,0.0005429}, {12900,0.0003429}, {13000,0.0005714}, {13100,0.0002286}, {13200,0.0001143}, {13300,0.0005429}, {13400,0.0000000}, {13500,0.0003429}, {13600,0.0002286}, {13700,0.0001143}, {13800,0.0001143}, {13900,0.0002286}, {14000,0.0006857}, {14100,0.0008000}, {14200,0.0011143}, {14300,0.0004571}, {14400,0.0001143}, {14500,0.0029714}, {14600,0.0005429}, {14700,0.0013429}, {14800,0.0003429}, {14900,0.0008857}, {15000,0.0008000}, {15100,0.0001143}, {15200,0.0007714}, {15300,0.0011429}, {15400,0.0010286}, {15500,0.0005714}, {15600,0.0005714}, {15700,0.0006857}, {15800,0.0002286}, {15900,0.0005714}, {16000,0.0004571}, {16100,0.0002286}, {16200,0.0010000}, {16300,0.0004571}, {16400,0.0002000}, {16500,0.0013714}, {16600,0.0011143}, {16700,0.0005714}, {16800,0.0002286}, {16900,0.0008000}, {17000,0.0001143}, {17100,0.0005714}, {17200,0.0020286}, {17300,0.0014857}, {17400,0.0000000}, {17500,0.0013714}, {17600,0.0006571}, {17700,0.0012571}, {17800,0.0007714}, {17900,0.0005714}, {18000,0.0003429}, {18100,0.0003429}, {18200,0.0009143}, {18300,0.0016857}, {18400,0.0004286}, {18500,0.0007714}, {18600,0.0013714}, {18700,0.0012286}, {18800,0.0010286}, {18900,0.0000000}, {19000,0.0005714}, {19100,0.0003429}, {19200,0.0008857}, {19300,0.0031714}, {19400,0.0013714}, {19500,0.0005429}, {19600,0.0009143}, {19700,0.0025714}, {19800,0.0026286}, {19900,0.0023714}, {20000,0.0009143}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00003960}, {8,0.00791089}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00112871}, {16,0.00151485}, {17,0.00200000}, {18,0.00200000}, {19,0.00200000}, {20,0.00200000}, {21,0.00200000}, {22,0.00203960}, {23,0.00227723}, {24,0.00245545}, {25,0.00300000}, {26,0.00300000}, {27,0.00300000}, {28,0.00300000}, {29,0.00300000}, {30,0.00306931}, {31,0.00338614}, {32,0.00333663}, {33,0.00390099}, {34,0.00400000}, {35,0.00400000}, {36,0.00400000}, {37,0.00402970}, {38,0.00416832}, {39,0.00426733}, {40,0.00426733}, {41,0.00469307}, {42,0.00500000}, {43,0.00500000}, {44,0.00500000}, {45,0.00510891}, {46,0.00517822}, {47,0.00536634}, {48,0.00538614}, {49,0.00747525}, {50,0.00596040}, {51,0.00600000}, {52,0.00600000}, {53,0.00615842}, {54,0.00638614}, {55,0.00624752}, {56,0.00745545}, {57,0.00654455}, {58,0.00688119}, {59,0.00702970}, {60,0.00705941}, {61,0.00718812}, {62,0.00719802}, {63,0.00734653}, {64,0.00721782}, {65,0.00748515}, {66,0.00772277}, {67,0.00802970}, {68,0.00806931}, {69,0.00821782}, {70,0.00818812}, {71,0.00823762}, {72,0.00920792}, {73,0.00841584}, {74,0.00865347}, {75,0.00909901}, {76,0.00907921}, {77,0.01102970}, {78,0.00914851}, {79,0.00929703}, {80,0.00915842}, {81,0.00946535}, {82,0.00951485}, {83,0.01000000}, {84,0.01319802}, {85,0.01023762}, {86,0.01009901}, {87,0.01026733}, {88,0.01020792}, {89,0.01048515}, {90,0.01062376}, {91,0.01100000}, {92,0.01109901}, {93,0.01116832}, {94,0.01117822}, {95,0.01124752}, {96,0.01119802}, {97,0.01145545}, {98,0.01154455}, {99,0.01198020}, {100,0.01214851}, {101,0.01216832}, {102,0.01218812}, {103,0.01226733}, {104,0.01241584}, {105,0.01235644}, {106,0.01255446}, {107,0.01773267}, {108,0.01429703}, {109,0.01307921}, {110,0.01314851}, {111,0.01329703}, {112,0.01338614}, {113,0.01353465}, {114,0.01788119}, {115,0.01383168}, {116,0.01402970}, {117,0.01415842}, {118,0.01429703}, {119,0.01779208}, {120,0.01420792}, {121,0.01447525}, {122,0.01449505}, {123,0.01835644}, {124,0.01498020}, {125,0.01518812}, {126,0.01517822}, {127,0.01522772}, {128,0.01530693}, {129,0.01565347}, {130,0.01537624}, {131,0.01581188}, {132,0.01595050}, {133,0.01607921}, {134,0.01627723}, {135,0.02140594}, {136,0.01626733}, {137,0.01653465}, {138,0.01638614}, {139,0.01673267}, {140,0.02050495}, {141,0.01715842}, {142,0.01732673}, {143,0.01736634}, {144,0.01746535}, {145,0.01747525}, {146,0.01758416}, {147,0.01776238}, {148,0.01799010}, {149,0.01806931}, {150,0.01826733}, {151,0.01864356}, {152,0.02365347}, {153,0.01855446}, {154,0.02026733}, {155,0.01880198}, {156,0.01889109}, {157,0.01938614}, {158,0.01936634}, {159,0.02117822}, {160,0.01947525}, {161,0.01947525}, {162,0.02346535}, {163,0.01972277}, {164,0.01981188}, {165,0.02406931}, {166,0.02022772}, {167,0.02047525}, {168,0.02199010}, {169,0.02055446}, {170,0.02046535}, {171,0.02082178}, {172,0.02427723}, {173,0.02115842}, {174,0.02132673}, {175,0.02138614}, {176,0.02257426}, {177,0.03180198}, {178,0.02161386}, {179,0.02177228}, {180,0.02169307}, {181,0.02199010}, {182,0.02598020}, {183,0.02986139}, {184,0.02245545}, {185,0.02245545}, {186,0.02246535}, {187,0.02278218}, {188,0.02272277}, {189,0.02318812}, {190,0.02318812}, {191,0.02530693}, {192,0.02635644}, {193,0.02822772}, {194,0.02942574}, {195,0.03029703}, {196,0.03095050}, {197,0.03141584}, {198,0.03131683}, {199,0.03112871}, {200,0.03061386}, {201,0.02965347}, {202,0.02879208}, {203,0.02765347}, {204,0.02607921}, {205,0.02483168}, {206,0.02509901}, {207,0.02543564}, {208,0.02541584}, {209,0.02555446}, {210,0.02541584}, {211,0.02574257}, {212,0.03326733}, {213,0.02795050}, {214,0.02601980}, {215,0.02631683}, {216,0.02636634}, {217,0.02654455}, {218,0.03049505}, {219,0.02656436}, {220,0.02677228}, {221,0.02717822}, {222,0.03379208}, {223,0.02725743}, {224,0.02727723}, {225,0.02730693}, {226,0.03250495}, {227,0.02759406}, {228,0.02760396}, {229,0.03463366}, {230,0.02810891}, {231,0.02849505}, {232,0.03596040}, {233,0.02837624}, {234,0.02860396}, {235,0.03460396}, {236,0.02872277}, {237,0.02920792}, {238,0.03067327}, {239,0.02945545}, {240,0.03506931}, {241,0.02951485}, {242,0.02958416}, {243,0.02967327}, {244,0.02972277}, {245,0.03014851}, {246,0.03015842}, {247,0.03113861}, {248,0.03026733}, {249,0.03156436}, {250,0.03103960}, {251,0.03081188}, {252,0.03122772}, {253,0.03109901}, {254,0.04048515}, {255,0.03148515}, {256,0.03649505}, {257,0.03142574}, {258,0.03147525}, {259,0.03171287}, {260,0.03161386}, {261,0.03738614}, {262,0.03209901}, {263,0.03203960}, {264,0.03955446}, {265,0.03238614}, {266,0.03239604}, {267,0.03943564}, {268,0.03307921}, {269,0.03318812}, {270,0.03838614}, {271,0.03545545}, {272,0.03336634}, {273,0.03335644}, {274,0.04041584}, {275,0.03408911}, {276,0.03397030}, {277,0.03398020}, {278,0.03693069}, {279,0.04239604}, {280,0.03431683}, {281,0.03467327}, {282,0.03461386}, {283,0.03501980}, {284,0.03830693}, {285,0.04221782}, {286,0.04564356}, {287,0.03570297}, {288,0.03550495}, {289,0.03543564}, {290,0.03579208}, {291,0.03599010}, {292,0.03576238}, {293,0.03607921}, {294,0.03852475}, {295,0.03933663}, {296,0.04004950}, {297,0.04068317}, {298,0.04118812}, {299,0.04141584}, {300,0.04007921}, {301,0.04065347}, {302,0.04167327}, {303,0.04064356}, {304,0.03740594}, {305,0.03733663}, {306,0.03760396}, {307,0.03796040}, {308,0.03809901}, {309,0.03810891}, {310,0.03846535}, {311,0.04971287}, {312,0.04589109}, {313,0.04115842}, {314,0.03907921}, {315,0.03924752}, {316,0.03920792}, {317,0.05191089}, {318,0.04650495}, {319,0.04139604}, {320,0.03906931}, {321,0.03969307}, {322,0.04966337}, {323,0.04452475}, {324,0.03963366}, {325,0.04026733}, {326,0.05009901}, {327,0.04418812}, {328,0.04012871}, {329,0.04085149}, {330,0.04762376}, {331,0.04095050}, {332,0.04109901}, {333,0.05173267}, {334,0.04117822}, {335,0.04179208}, {336,0.04778218}, {337,0.04151485}, {338,0.05514851}, {339,0.04436634}, {340,0.04161386}, {341,0.04942574}, {342,0.04191089}, {343,0.05296040}, {344,0.04202970}, {345,0.05590099}, {346,0.04391089}, {347,0.04304950}, {348,0.04500990}, {349,0.04340594}, {350,0.04508911}, {351,0.04363366}, {352,0.04312871}, {353,0.05564356}, {354,0.04337624}, {355,0.05320792}, {356,0.04377228}, {357,0.05359406}, {358,0.04431683}, {359,0.04749505}, {360,0.05798020}, {361,0.04476238}, {362,0.05188119}, {363,0.04491089}, {364,0.04487129}, {365,0.05350495}, {366,0.04512871}, {367,0.04585149}, {368,0.05235644}, {369,0.04560396}, {370,0.04559406}, {371,0.05056436}, {372,0.05704950}, {373,0.04649505}, {374,0.04641584}, {375,0.05192079}, {376,0.05744554}, {377,0.04693069}, {378,0.04664356}, {379,0.04999010}, {380,0.05799010}, {381,0.06440594}, {382,0.04740594}, {383,0.04743564}, {384,0.04699010}, {385,0.05105941}, {386,0.05595050}, {387,0.05875248}, {388,0.06237624}, {389,0.04808911}, {390,0.04837624}, {391,0.04841584}, {392,0.04837624}, {393,0.04959406}, {394,0.05124752}, {395,0.05270297}, {396,0.05359406}, {397,0.05479208}, {398,0.05512871}, {399,0.05911881}, {400,0.05835644}, {401,0.05687129}, {402,0.05658416}, {403,0.05647525}, {404,0.05500000}, {405,0.05424752}, {406,0.05279208}, {407,0.05173267}, {408,0.05025743}, {409,0.05084158}, {410,0.05095050}, {411,0.05111881}, {412,0.06359406}, {413,0.06102970}, {414,0.05796040}, {415,0.05518812}, {416,0.05139604}, {417,0.05196040}, {418,0.05165347}, {419,0.06457426}, {420,0.05890099}, {421,0.05394059}, {422,0.05226733}, {423,0.06847525}, {424,0.06259406}, {425,0.05639604}, {426,0.05287129}, {427,0.06821782}, {428,0.06143564}, {429,0.05477228}, {430,0.05324752}, {431,0.06427723}, {432,0.05660396}, {433,0.05353465}, {434,0.07086139}, {435,0.05849505}, {436,0.05419802}, {437,0.06591089}, {438,0.05588119}, {439,0.07136634}, {440,0.06093069}, {441,0.05459406}, {442,0.06555446}, {443,0.05583168}, {444,0.06842574}, {445,0.05817822}, {446,0.07067327}, {447,0.05977228}, {448,0.05543564}, {449,0.06042574}, {450,0.05547525}, {451,0.06451485}, {452,0.05620792}, {453,0.06248515}, {454,0.05640594}, {455,0.06100000}, {456,0.07082178}, {457,0.05833663}, {458,0.06937624}, {459,0.05688119}, {460,0.06483168}, {461,0.05711881}, {462,0.05959406}, {463,0.06893069}, {464,0.05741584}, {465,0.06256436}, {466,0.07239604}, {467,0.05837624}, {468,0.06538614}, {469,0.07346535}, {470,0.05814851}, {471,0.06309901}, {472,0.06997030}, {473,0.05928713}, {474,0.05921782}, {475,0.06505941}, {476,0.07055446}, {477,0.05934653}, {478,0.05955446}, {479,0.06317822}, {480,0.06997030}, {481,0.07952475}, {482,0.05991089}, {483,0.06012871}, {484,0.06330693}, {485,0.06885149}, {486,0.07174257}, {487,0.07492079}, {488,0.07658416}, {489,0.06077228}, {490,0.06066337}, {491,0.06175248}, {492,0.06375248}, {493,0.06719802}, {494,0.07079208}, {495,0.07086139}, {496,0.07149505}, {497,0.07350495}, {498,0.07309901}, {499,0.07426733}, {500,0.07354455}, {505,0.07335644}, {510,0.07214851}, {515,0.06931683}, {520,0.06588119}, {525,0.06571287}, {530,0.08626733}, {535,0.07566337}, {540,0.06681188}, {545,0.07998020}, {550,0.06817822}, {555,0.08185149}, {560,0.06930693}, {565,0.07823762}, {570,0.08653465}, {575,0.07207921}, {580,0.07816832}, {585,0.08417822}, {590,0.08688119}, {595,0.08874257}, {600,0.08989109}, {605,0.08939604}, {610,0.08815842}, {615,0.08650495}, {620,0.08670297}, {625,0.07900000}, {630,0.09887129}, {635,0.09080198}, {640,0.08206931}, {645,0.09633663}, {650,0.08680198}, {655,0.09852475}, {660,0.08670297}, {665,0.10148515}, {670,0.10763366}, {675,0.08981188}, {680,0.09509901}, {685,0.10024752}, {690,0.10401980}, {695,0.10665347}, {700,0.11770297}, {705,0.11141584}, {710,0.11055446}, {715,0.10703960}, {720,0.10328713}, {725,0.10071287}, {730,0.09778218}, {735,0.11441584}, {740,0.10624752}, {745,0.11966337}, {750,0.10863366}, {755,0.11934653}, {760,0.11366337}, {765,0.12066337}, {770,0.10347525}, {775,0.11080198}, {780,0.11729703}, {785,0.12190099}, {790,0.10717822}, {795,0.10903960}, {800,0.10973267}, {805,0.11031683}, {810,0.11042574}, {815,0.11311881}, {820,0.13246535}, {825,0.12690099}, {830,0.11934653}, {835,0.11320792}, {840,0.12695050}, {845,0.12361386}, {850,0.13687129}, {855,0.12338614}, {860,0.13364356}, {865,0.12838614}, {870,0.13463366}, {875,0.14059406}, {880,0.12180198}, {885,0.12741584}, {890,0.13481188}, {895,0.13448515}, {900,0.13491089}, {905,0.13484158}, {910,0.13415842}, {915,0.14130693}, {920,0.12948515}, {925,0.12825743}, {930,0.12328713}, {935,0.15187129}, {940,0.13574257}, {945,0.15024752}, {950,0.13821782}, {955,0.12823762}, {960,0.14363366}, {965,0.14365347}, {970,0.13594059}, {975,0.14318812}, {980,0.15515842}, {985,0.13422772}, {990,0.13704950}, {995,0.14023762}, {1000,0.14466337}, {1010,0.14474257}, {1020,0.14190099}, {1030,0.15941584}, {1040,0.15924752}, {1050,0.15013861}, {1060,0.15956436}, {1070,0.15742574}, {1080,0.15997030}, {1090,0.16191089}, {1100,0.16619802}, {1110,0.17237624}, {1120,0.16841584}, {1130,0.16356436}, {1140,0.16145545}, {1150,0.17546535}, {1160,0.16210891}, {1170,0.18809901}, {1180,0.18498020}, {1190,0.16621782}, {1200,0.17611881}, {1210,0.16515842}, {1220,0.16897030}, {1230,0.20576238}, {1240,0.18670297}, {1250,0.17598020}, {1260,0.19410891}, {1270,0.20193069}, {1280,0.18255446}, {1290,0.19527723}, {1300,0.19510891}, {1310,0.19579208}, {1320,0.19492079}, {1330,0.19277228}, {1340,0.20065347}, {1350,0.20691089}, {1360,0.19399010}, {1370,0.21165347}, {1380,0.21255446}, {1390,0.19062376}, {1400,0.20191089}, {1410,0.20047525}, {1420,0.20590099}, {1430,0.22122772}, {1440,0.23386139}, {1450,0.21352475}, {1460,0.22155446}, {1470,0.21714851}, {1480,0.21674257}, {1490,0.23222772}, {1500,0.22908911}, {1510,0.23758416}, {1520,0.23311881}, {1530,0.22519802}, {1540,0.22634653}, {1550,0.23607921}, {1560,0.23508911}, {1570,0.23825743}, {1580,0.23695050}, {1590,0.23262376}, {1600,0.25642574}, {1610,0.24110891}, {1620,0.25778218}, {1630,0.23964356}, {1640,0.24920792}, {1650,0.25160396}, {1660,0.25917822}, {1670,0.25228713}, {1680,0.24495050}, {1690,0.24837624}, {1700,0.25435644}, {1710,0.25500990}, {1720,0.27108911}, {1730,0.24958416}, {1740,0.27734653}, {1750,0.25969307}, {1760,0.25798020}, {1770,0.26214851}, {1780,0.28045545}, {1790,0.27629703}, {1800,0.26293069}, {1810,0.26147525}, {1820,0.26714851}, {1830,0.26155446}, {1840,0.27743564}, {1850,0.28396040}, {1860,0.28519802}, {1870,0.27950495}, {1880,0.28413861}, {1890,0.29840594}, {1900,0.29433663}, {1910,0.27666337}, {1920,0.28291089}, {1930,0.29542574}, {1940,0.29775248}, {1950,0.30964356}, {1960,0.29743564}, {1970,0.29592079}, {1980,0.29562376}, {1990,0.30619802}, {2000,0.32905941}, {2050,0.30816832}, {2100,0.30829703}, {2150,0.34017822}, {2200,0.31889109}, {2250,0.34586139}, {2300,0.38613861}, {2350,0.35507921}, {2400,0.36902970}, {2450,0.37691089}, {2500,0.39792079}, {2550,0.42052475}, {2600,0.39784158}, {2650,0.40258416}, {2700,0.41529703}, {2750,0.42758416}, {2800,0.43111881}, {2850,0.44780198}, {2900,0.46252475}, {2950,0.46175248}, {3000,0.48141584}, {3050,0.48155446}, {3100,0.49369307}, {3150,0.49760396}, {3200,0.48942574}, {3250,0.52540594}, {3300,0.51463366}, {3350,0.51761386}, {3400,0.53413861}, {3450,0.54059406}, {3500,0.54305941}, {3550,0.54574257}, {3600,0.54916832}, {3650,0.56027723}, {3700,0.57239604}, {3750,0.56665347}, {3800,0.58301980}, {3850,0.59941584}, {3900,0.63026733}, {3950,0.60946535}, {4000,0.62496040}, {4050,0.62428713}, {4100,0.62427723}, {4150,0.66183168}, {4200,0.64035644}, {4250,0.64745545}, {4300,0.68361386}, {4350,0.66646535}, {4400,0.67226733}, {4450,0.69875248}, {4500,0.69930693}, {4550,0.70191089}, {4600,0.74430693}, {4650,0.72000000}, {4700,0.75003960}, {4750,0.74127723}, {4800,0.72750495}, {4850,0.76210891}, {4900,0.75768317}, {4950,0.76232673}, {5000,0.77223762}, {5050,0.91480198}, {5100,0.79560396}, {5150,0.79665347}, {5200,0.82464356}, {5250,0.82765347}, {5300,0.82568317}, {5350,0.85678218}, {5400,0.83467327}, {5450,0.85092079}, {5500,0.85479208}, {5550,0.86804950}, {5600,0.88716832}, {5650,0.87061386}, {5700,0.89210891}, {5750,0.90091089}, {5800,0.92822772}, {5850,0.93282178}, {5900,0.91134653}, {5950,0.94031683}, {6000,0.92645545}, {6050,1.0358000}, {6100,0.9999143}, {6150,0.9692857}, {6200,1.0021143}, {6250,0.9989429}, {6300,0.9995714}, {6350,1.0213714}, {6400,1.0138286}, {6450,1.0381714}, {6500,1.0679714}, {6550,1.0752000}, {6600,1.0662000}, {6650,1.1023143}, {6700,1.0893429}, {6750,1.1173143}, {6800,1.1041143}, {6850,1.1125143}, {6900,1.1395429}, {6950,1.1439429}, {7000,1.1400000}, {7050,1.1380000}, {7100,1.1622286}, {7150,1.1606571}, {7200,1.1394571}, {7250,1.1574571}, {7300,1.1955429}, {7350,1.2292571}, {7400,1.2393143}, {7450,1.2476000}, {7500,1.2166286}, {7550,1.2575429}, {7600,1.2588286}, {7650,1.2433429}, {7700,1.2438857}, {7750,1.3057143}, {7800,1.3012000}, {7850,1.3043429}, {7900,1.3022286}, {7950,1.2960000}, {8000,1.3263429}, {8050,1.3470857}, {8100,1.3505429}, {8150,1.3550571}, {8200,1.3118286}, {8250,1.3539714}, {8300,1.3832857}, {8350,1.3732571}, {8400,1.3555714}, {8450,1.3634286}, {8500,1.4246857}, {8550,1.4238286}, {8600,1.3863143}, {8650,1.4361429}, {8700,1.4558286}, {8750,1.4286571}, {8800,1.4609143}, {8850,1.4726857}, {8900,1.4472571}, {8950,1.4936000}, {9000,1.4854571}, {9050,1.4786286}, {9100,1.5108571}, {9150,1.5431714}, {9200,1.4885143}, {9250,1.5511143}, {9300,1.5641429}, {9350,1.5362857}, {9400,1.5540000}, {9450,1.5515714}, {9500,1.5877143}, {9550,1.5997714}, {9600,1.6068857}, {9650,1.6083143}, {9700,1.5896857}, {9750,1.6369429}, {9800,1.5930857}, {9850,1.6454286}, {9900,1.6226000}, {9950,1.6759714}, {10000,1.6314857}, {10100,1.6841143}, {10200,1.6716857}, {10300,1.7083429}, {10400,1.6736286}, {10500,1.7265143}, {10600,1.7296857}, {10700,1.7801714}, {10800,1.7154857}, {10900,1.8108000}, {11000,1.8037714}, {11100,1.8448571}, {11200,1.8347714}, {11300,1.8533714}, {11400,1.8648571}, {11500,1.8931714}, {11600,1.9172286}, {11700,1.9361429}, {11800,1.9271429}, {11900,1.9800286}, {12000,1.9644857}, {12100,1.9940857}, {12200,2.0225143}, {12300,2.0011143}, {12400,2.0256286}, {12500,2.0594286}, {12600,2.0846000}, {12700,2.0841714}, {12800,2.0670286}, {12900,2.1060000}, {13000,2.1364857}, {13100,2.1416571}, {13200,2.1415429}, {13300,2.1878286}, {13400,2.1934000}, {13500,2.2160857}, {13600,2.2236000}, {13700,2.2357429}, {13800,2.2609143}, {13900,2.2835429}, {14000,2.2922286}, {14100,2.3326857}, {14200,2.4390571}, {14300,2.3805143}, {14400,2.3464286}, {14500,2.7294571}, {14600,2.3870000}, {14700,2.5933429}, {14800,2.4843429}, {14900,2.4340286}, {15000,2.4563143}, {15100,2.4974857}, {15200,2.5646571}, {15300,2.5092000}, {15400,2.6815714}, {15500,2.5469429}, {15600,2.5594571}, {15700,2.6635714}, {15800,2.6603429}, {15900,2.5835143}, {16000,2.5940000}, {16100,2.6486571}, {16200,2.6381143}, {16300,2.6997143}, {16400,2.6622571}, {16500,2.7017429}, {16600,2.9049143}, {16700,2.7511714}, {16800,2.7420571}, {16900,2.7449143}, {17000,2.7930857}, {17100,2.8881714}, {17200,2.8006286}, {17300,2.8402286}, {17400,2.8562857}, {17500,2.8612571}, {17600,2.8760571}, {17700,2.8783429}, {17800,2.8928857}, {17900,2.9645143}, {18000,2.9144286}, {18100,2.9804857}, {18200,2.9741429}, {18300,3.0462286}, {18400,3.0268286}, {18500,3.0304571}, {18600,3.0409714}, {18700,3.0678000}, {18800,3.0885429}, {18900,3.1011143}, {19000,3.3584286}, {19100,3.1620000}, {19200,3.2790571}, {19300,3.1780857}, {19400,3.1948000}, {19500,3.3629143}, {19600,3.2101429}, {19700,3.4505714}, {19800,3.2614286}, {19900,3.4191714}, {20000,3.3822286}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["actual reif"]["user"] = {{1,0.00026733}, {2,0.00017822}, {3,0.00032673}, {4,0.00058416}, {5,0.00050495}, {6,0.00063366}, {7,0.00119802}, {8,0.00803960}, {9,0.00130693}, {10,0.00142574}, {11,0.00098020}, {12,0.00147525}, {13,0.00162376}, {14,0.00155446}, {15,0.00159406}, {16,0.00176238}, {17,0.00180198}, {18,0.00218812}, {19,0.00224752}, {20,0.00209901}, {21,0.00219802}, {22,0.00252475}, {23,0.00268317}, {24,0.00276238}, {25,0.00279208}, {26,0.00293069}, {27,0.00275248}, {28,0.00317822}, {29,0.00307921}, {30,0.00313861}, {31,0.00342574}, {32,0.00350495}, {33,0.00351485}, {34,0.00381188}, {35,0.00365347}, {36,0.00391089}, {37,0.00422772}, {38,0.00406931}, {39,0.00447525}, {40,0.00460396}, {41,0.00481188}, {42,0.00501980}, {43,0.00492079}, {44,0.00509901}, {45,0.00538614}, {46,0.00538614}, {47,0.00556436}, {48,0.00600000}, {49,0.00778218}, {50,0.00625743}, {51,0.00592079}, {52,0.00619802}, {53,0.00665347}, {54,0.00662376}, {55,0.00691089}, {56,0.00781188}, {57,0.00711881}, {58,0.00676238}, {59,0.00706931}, {60,0.00692079}, {61,0.00737624}, {62,0.00720792}, {63,0.00756436}, {64,0.00762376}, {65,0.00773267}, {66,0.00771287}, {67,0.00773267}, {68,0.00817822}, {69,0.00801980}, {70,0.00822772}, {71,0.00835644}, {72,0.00911881}, {73,0.00880198}, {74,0.00870297}, {75,0.00906931}, {76,0.00888119}, {77,0.01108911}, {78,0.00920792}, {79,0.00942574}, {80,0.00986139}, {81,0.00979208}, {82,0.01005941}, {83,0.00980198}, {84,0.01332673}, {85,0.01030693}, {86,0.01020792}, {87,0.01066337}, {88,0.01039604}, {89,0.01077228}, {90,0.01050495}, {91,0.01092079}, {92,0.01099010}, {93,0.01134653}, {94,0.01166337}, {95,0.01150495}, {96,0.01156436}, {97,0.01193069}, {98,0.01183168}, {99,0.01195050}, {100,0.01200990}, {101,0.01210891}, {102,0.01233663}, {103,0.01256436}, {104,0.01255446}, {105,0.01260396}, {106,0.01309901}, {107,0.01776238}, {108,0.01479208}, {109,0.01295050}, {110,0.01340594}, {111,0.01347525}, {112,0.01345545}, {113,0.01378218}, {114,0.01769307}, {115,0.01405941}, {116,0.01420792}, {117,0.01468317}, {118,0.01476238}, {119,0.01756436}, {120,0.01469307}, {121,0.01497030}, {122,0.01491089}, {123,0.01801980}, {124,0.01503960}, {125,0.01556436}, {126,0.01541584}, {127,0.01550495}, {128,0.01575248}, {129,0.01609901}, {130,0.01594059}, {131,0.01614851}, {132,0.01616832}, {133,0.01612871}, {134,0.01682178}, {135,0.02114851}, {136,0.01649505}, {137,0.01682178}, {138,0.01680198}, {139,0.01701980}, {140,0.02017822}, {141,0.01753465}, {142,0.01719802}, {143,0.01709901}, {144,0.01738614}, {145,0.01730693}, {146,0.01730693}, {147,0.01764356}, {148,0.01768317}, {149,0.01749505}, {150,0.01798020}, {151,0.01812871}, {152,0.02375248}, {153,0.01794059}, {154,0.01961386}, {155,0.01828713}, {156,0.01847525}, {157,0.01920792}, {158,0.01886139}, {159,0.02098020}, {160,0.01908911}, {161,0.01914851}, {162,0.02333663}, {163,0.01945545}, {164,0.01949505}, {165,0.02398020}, {166,0.01991089}, {167,0.02025743}, {168,0.02180198}, {169,0.02020792}, {170,0.02015842}, {171,0.02092079}, {172,0.02429703}, {173,0.02088119}, {174,0.02120792}, {175,0.02115842}, {176,0.02277228}, {177,0.03142574}, {178,0.02178218}, {179,0.02181188}, {180,0.02156436}, {181,0.02179208}, {182,0.02584158}, {183,0.02984158}, {184,0.02270297}, {185,0.02249505}, {186,0.02257426}, {187,0.02295050}, {188,0.02288119}, {189,0.02318812}, {190,0.02319802}, {191,0.02533663}, {192,0.02647525}, {193,0.02788119}, {194,0.02946535}, {195,0.03028713}, {196,0.03096040}, {197,0.03186139}, {198,0.03151485}, {199,0.03108911}, {200,0.03072277}, {201,0.02969307}, {202,0.02826733}, {203,0.02731683}, {204,0.02596040}, {205,0.02450495}, {206,0.02503960}, {207,0.02543564}, {208,0.02542574}, {209,0.02532673}, {210,0.02555446}, {211,0.02586139}, {212,0.03341584}, {213,0.02765347}, {214,0.02613861}, {215,0.02631683}, {216,0.02635644}, {217,0.02601980}, {218,0.03058416}, {219,0.02661386}, {220,0.02676238}, {221,0.02707921}, {222,0.03416832}, {223,0.02721782}, {224,0.02695050}, {225,0.02722772}, {226,0.03258416}, {227,0.02772277}, {228,0.02759406}, {229,0.03471287}, {230,0.02792079}, {231,0.02831683}, {232,0.03596040}, {233,0.02805941}, {234,0.02851485}, {235,0.03457426}, {236,0.02814851}, {237,0.02936634}, {238,0.03017822}, {239,0.02905941}, {240,0.03521782}, {241,0.02877228}, {242,0.02903960}, {243,0.02973267}, {244,0.02944554}, {245,0.03003960}, {246,0.02974257}, {247,0.03088119}, {248,0.03013861}, {249,0.03167327}, {250,0.03088119}, {251,0.03082178}, {252,0.03133663}, {253,0.03073267}, {254,0.04015842}, {255,0.03141584}, {256,0.03633663}, {257,0.03128713}, {258,0.03136634}, {259,0.03154455}, {260,0.03152475}, {261,0.03716832}, {262,0.03184158}, {263,0.03185149}, {264,0.03929703}, {265,0.03237624}, {266,0.03268317}, {267,0.03916832}, {268,0.03336634}, {269,0.03304950}, {270,0.03799010}, {271,0.03577228}, {272,0.03313861}, {273,0.03344554}, {274,0.04001980}, {275,0.03409901}, {276,0.03460396}, {277,0.03387129}, {278,0.03694059}, {279,0.04217822}, {280,0.03460396}, {281,0.03480198}, {282,0.03461386}, {283,0.03525743}, {284,0.03836634}, {285,0.04182178}, {286,0.04567327}, {287,0.03584158}, {288,0.03578218}, {289,0.03561386}, {290,0.03583168}, {291,0.03623762}, {292,0.03580198}, {293,0.03610891}, {294,0.03855446}, {295,0.03923762}, {296,0.03994059}, {297,0.04028713}, {298,0.04090099}, {299,0.04110891}, {300,0.03980198}, {301,0.04024752}, {302,0.04111881}, {303,0.03998020}, {304,0.03722772}, {305,0.03730693}, {306,0.03747525}, {307,0.03782178}, {308,0.03786139}, {309,0.03777228}, {310,0.03828713}, {311,0.04926733}, {312,0.04587129}, {313,0.04061386}, {314,0.03880198}, {315,0.03871287}, {316,0.03907921}, {317,0.05155446}, {318,0.04644554}, {319,0.04118812}, {320,0.03862376}, {321,0.03919802}, {322,0.04952475}, {323,0.04419802}, {324,0.03937624}, {325,0.04006931}, {326,0.04979208}, {327,0.04432673}, {328,0.03984158}, {329,0.04071287}, {330,0.04733663}, {331,0.04037624}, {332,0.04053465}, {333,0.05155446}, {334,0.04082178}, {335,0.04163366}, {336,0.04793069}, {337,0.04139604}, {338,0.05493069}, {339,0.04451485}, {340,0.04098020}, {341,0.04936634}, {342,0.04166337}, {343,0.05237624}, {344,0.04178218}, {345,0.05579208}, {346,0.04379208}, {347,0.04254455}, {348,0.04466337}, {349,0.04343564}, {350,0.04498020}, {351,0.04328713}, {352,0.04318812}, {353,0.05516832}, {354,0.04337624}, {355,0.05299010}, {356,0.04345545}, {357,0.05334653}, {358,0.04398020}, {359,0.04758416}, {360,0.05793069}, {361,0.04475248}, {362,0.05167327}, {363,0.04433663}, {364,0.04463366}, {365,0.05331683}, {366,0.04510891}, {367,0.04587129}, {368,0.05214851}, {369,0.04517822}, {370,0.04575248}, {371,0.05055446}, {372,0.05697030}, {373,0.04683168}, {374,0.04665347}, {375,0.05203960}, {376,0.05773267}, {377,0.04695050}, {378,0.04659406}, {379,0.05006931}, {380,0.05793069}, {381,0.06422772}, {382,0.04758416}, {383,0.04763366}, {384,0.04691089}, {385,0.05112871}, {386,0.05596040}, {387,0.05874257}, {388,0.06210891}, {389,0.04809901}, {390,0.04850495}, {391,0.04822772}, {392,0.04831683}, {393,0.04959406}, {394,0.05128713}, {395,0.05259406}, {396,0.05340594}, {397,0.05448515}, {398,0.05468317}, {399,0.05899010}, {400,0.05839604}, {401,0.05641584}, {402,0.05663366}, {403,0.05647525}, {404,0.05466337}, {405,0.05397030}, {406,0.05266337}, {407,0.05139604}, {408,0.05028713}, {409,0.05125743}, {410,0.05110891}, {411,0.05114851}, {412,0.06307921}, {413,0.06106931}, {414,0.05772277}, {415,0.05487129}, {416,0.05136634}, {417,0.05171287}, {418,0.05168317}, {419,0.06454455}, {420,0.05867327}, {421,0.05373267}, {422,0.05216832}, {423,0.06845545}, {424,0.06267327}, {425,0.05622772}, {426,0.05278218}, {427,0.06801980}, {428,0.06127723}, {429,0.05463366}, {430,0.05281188}, {431,0.06417822}, {432,0.05623762}, {433,0.05332673}, {434,0.07098020}, {435,0.05841584}, {436,0.05373267}, {437,0.06553465}, {438,0.05581188}, {439,0.07129703}, {440,0.06087129}, {441,0.05464356}, {442,0.06500990}, {443,0.05538614}, {444,0.06805941}, {445,0.05816832}, {446,0.07055446}, {447,0.05987129}, {448,0.05509901}, {449,0.06049505}, {450,0.05519802}, {451,0.06467327}, {452,0.05587129}, {453,0.06259406}, {454,0.05591089}, {455,0.06135644}, {456,0.07063366}, {457,0.05846535}, {458,0.06944554}, {459,0.05648515}, {460,0.06465347}, {461,0.05650495}, {462,0.05927723}, {463,0.06875248}, {464,0.05716832}, {465,0.06248515}, {466,0.07229703}, {467,0.05851485}, {468,0.06479208}, {469,0.07354455}, {470,0.05794059}, {471,0.06308911}, {472,0.06993069}, {473,0.05904950}, {474,0.05920792}, {475,0.06475248}, {476,0.07035644}, {477,0.05962376}, {478,0.05967327}, {479,0.06317822}, {480,0.06977228}, {481,0.07898020}, {482,0.05979208}, {483,0.06019802}, {484,0.06320792}, {485,0.06863366}, {486,0.07169307}, {487,0.07444554}, {488,0.07645545}, {489,0.06076238}, {490,0.06078218}, {491,0.06160396}, {492,0.06355446}, {493,0.06674257}, {494,0.07047525}, {495,0.07060396}, {496,0.07156436}, {497,0.07339604}, {498,0.07322772}, {499,0.07408911}, {500,0.07366337}, {505,0.07335644}, {510,0.07166337}, {515,0.06932673}, {520,0.06558416}, {525,0.06523762}, {530,0.08631683}, {535,0.07531683}, {540,0.06659406}, {545,0.07997030}, {550,0.06811881}, {555,0.08205941}, {560,0.06903960}, {565,0.07786139}, {570,0.08670297}, {575,0.07228713}, {580,0.07786139}, {585,0.08374257}, {590,0.08644554}, {595,0.08825743}, {600,0.08968317}, {605,0.08900000}, {610,0.08801980}, {615,0.08630693}, {620,0.08639604}, {625,0.07906931}, {630,0.09851485}, {635,0.09090099}, {640,0.08232673}, {645,0.09652475}, {650,0.08667327}, {655,0.09847525}, {660,0.08665347}, {665,0.10152475}, {670,0.10749505}, {675,0.08969307}, {680,0.09502970}, {685,0.09989109}, {690,0.10406931}, {695,0.10651485}, {700,0.11783168}, {705,0.11126733}, {710,0.11016832}, {715,0.10689109}, {720,0.10271287}, {725,0.10027723}, {730,0.09768317}, {735,0.11401980}, {740,0.10618812}, {745,0.11952475}, {750,0.10860396}, {755,0.11923762}, {760,0.11359406}, {765,0.12010891}, {770,0.10305941}, {775,0.11057426}, {780,0.11714851}, {785,0.12163366}, {790,0.10711881}, {795,0.10891089}, {800,0.10975248}, {805,0.11028713}, {810,0.11007921}, {815,0.11290099}, {820,0.13219802}, {825,0.12670297}, {830,0.11920792}, {835,0.11263366}, {840,0.12663366}, {845,0.12326733}, {850,0.13700000}, {855,0.12301980}, {860,0.13348515}, {865,0.12806931}, {870,0.13471287}, {875,0.14043564}, {880,0.12145545}, {885,0.12718812}, {890,0.13465347}, {895,0.13441584}, {900,0.13461386}, {905,0.13433663}, {910,0.13426733}, {915,0.14107921}, {920,0.12969307}, {925,0.12800990}, {930,0.12308911}, {935,0.15175248}, {940,0.13556436}, {945,0.14985149}, {950,0.13823762}, {955,0.12805941}, {960,0.14306931}, {965,0.14337624}, {970,0.13554455}, {975,0.14289109}, {980,0.15520792}, {985,0.13414851}, {990,0.13693069}, {995,0.13994059}, {1000,0.14434653}, {1010,0.14437624}, {1020,0.14167327}, {1030,0.15915842}, {1040,0.15862376}, {1050,0.14966337}, {1060,0.15928713}, {1070,0.15701980}, {1080,0.15979208}, {1090,0.16160396}, {1100,0.16570297}, {1110,0.17189109}, {1120,0.16808911}, {1130,0.16292079}, {1140,0.16105941}, {1150,0.17528713}, {1160,0.16174257}, {1170,0.18751485}, {1180,0.18475248}, {1190,0.16628713}, {1200,0.17570297}, {1210,0.16511881}, {1220,0.16875248}, {1230,0.20524752}, {1240,0.18623762}, {1250,0.17538614}, {1260,0.19328713}, {1270,0.20168317}, {1280,0.18202970}, {1290,0.19452475}, {1300,0.19495050}, {1310,0.19502970}, {1320,0.19437624}, {1330,0.19237624}, {1340,0.19996040}, {1350,0.20646535}, {1360,0.19339604}, {1370,0.21120792}, {1380,0.21173267}, {1390,0.19000990}, {1400,0.20100990}, {1410,0.20015842}, {1420,0.20547525}, {1430,0.22041584}, {1440,0.23313861}, {1450,0.21275248}, {1460,0.22108911}, {1470,0.21666337}, {1480,0.21601980}, {1490,0.23184158}, {1500,0.22862376}, {1510,0.23704950}, {1520,0.23262376}, {1530,0.22458416}, {1540,0.22579208}, {1550,0.23563366}, {1560,0.23464356}, {1570,0.23791089}, {1580,0.23649505}, {1590,0.23194059}, {1600,0.25553465}, {1610,0.24013861}, {1620,0.25706931}, {1630,0.23904950}, {1640,0.24869307}, {1650,0.25078218}, {1660,0.25857426}, {1670,0.25149505}, {1680,0.24443564}, {1690,0.24745545}, {1700,0.25392079}, {1710,0.25427723}, {1720,0.27065347}, {1730,0.24906931}, {1740,0.27618812}, {1750,0.25891089}, {1760,0.25740594}, {1770,0.26146535}, {1780,0.27951485}, {1790,0.27606931}, {1800,0.26236634}, {1810,0.26087129}, {1820,0.26654455}, {1830,0.26095050}, {1840,0.27674257}, {1850,0.28308911}, {1860,0.28445545}, {1870,0.27848515}, {1880,0.28339604}, {1890,0.29751485}, {1900,0.29350495}, {1910,0.27580198}, {1920,0.28221782}, {1930,0.29462376}, {1940,0.29687129}, {1950,0.30888119}, {1960,0.29670297}, {1970,0.29527723}, {1980,0.29437624}, {1990,0.30542574}, {2000,0.32780198}, {2050,0.30715842}, {2100,0.30720792}, {2150,0.33900000}, {2200,0.31801980}, {2250,0.34489109}, {2300,0.38513861}, {2350,0.35396040}, {2400,0.36799010}, {2450,0.37584158}, {2500,0.39679208}, {2550,0.41947525}, {2600,0.39687129}, {2650,0.40190099}, {2700,0.41427723}, {2750,0.42677228}, {2800,0.43010891}, {2850,0.44666337}, {2900,0.46146535}, {2950,0.46092079}, {3000,0.48044554}, {3050,0.48051485}, {3100,0.49118812}, {3150,0.49638614}, {3200,0.48837624}, {3250,0.52432673}, {3300,0.51389109}, {3350,0.51686139}, {3400,0.53329703}, {3450,0.53963366}, {3500,0.54225743}, {3550,0.54501980}, {3600,0.54811881}, {3650,0.55947525}, {3700,0.57129703}, {3750,0.56580198}, {3800,0.58170297}, {3850,0.59842574}, {3900,0.62931683}, {3950,0.60831683}, {4000,0.62394059}, {4050,0.62318812}, {4100,0.62304950}, {4150,0.66050495}, {4200,0.63932673}, {4250,0.64650495}, {4300,0.68258416}, {4350,0.66521782}, {4400,0.67083168}, {4450,0.69711881}, {4500,0.69828713}, {4550,0.70052475}, {4600,0.74267327}, {4650,0.71867327}, {4700,0.74851485}, {4750,0.73986139}, {4800,0.72620792}, {4850,0.76017822}, {4900,0.75592079}, {4950,0.76058416}, {5000,0.77072277}, {5050,0.91229703}, {5100,0.79410891}, {5150,0.79487129}, {5200,0.82293069}, {5250,0.82581188}, {5300,0.82400990}, {5350,0.85534653}, {5400,0.83304950}, {5450,0.84898020}, {5500,0.85318812}, {5550,0.86678218}, {5600,0.88507921}, {5650,0.86901980}, {5700,0.88993069}, {5750,0.89928713}, {5800,0.92671287}, {5850,0.93100000}, {5900,0.90982178}, {5950,0.93855446}, {6000,0.92492079}, {6050,1.0326286}, {6100,0.9982857}, {6150,0.9684286}, {6200,1.0010571}, {6250,0.9957714}, {6300,0.9982571}, {6350,1.0205714}, {6400,1.0129714}, {6450,1.0374286}, {6500,1.0668286}, {6550,1.0740857}, {6600,1.0655429}, {6650,1.1012857}, {6700,1.0880571}, {6750,1.1139143}, {6800,1.1019143}, {6850,1.1112571}, {6900,1.1379714}, {6950,1.1394571}, {7000,1.1387429}, {7050,1.1372000}, {7100,1.1614571}, {7150,1.1598286}, {7200,1.1384571}, {7250,1.1562000}, {7300,1.1948286}, {7350,1.2260571}, {7400,1.2373714}, {7450,1.2444000}, {7500,1.2138000}, {7550,1.2530857}, {7600,1.2519429}, {7650,1.2410286}, {7700,1.2359429}, {7750,1.2967714}, {7800,1.2975429}, {7850,1.3008000}, {7900,1.2974000}, {7950,1.2883429}, {8000,1.3246857}, {8050,1.3446000}, {8100,1.3491143}, {8150,1.3538571}, {8200,1.3106571}, {8250,1.3523429}, {8300,1.3811429}, {8350,1.3724571}, {8400,1.3541143}, {8450,1.3616857}, {8500,1.4226000}, {8550,1.4218000}, {8600,1.3848571}, {8650,1.4342000}, {8700,1.4542571}, {8750,1.4277143}, {8800,1.4597143}, {8850,1.4695143}, {8900,1.4449143}, {8950,1.4922286}, {9000,1.4836286}, {9050,1.4762000}, {9100,1.5085714}, {9150,1.5418857}, {9200,1.4870000}, {9250,1.5457429}, {9300,1.5552286}, {9350,1.5334571}, {9400,1.5524571}, {9450,1.5498571}, {9500,1.5858000}, {9550,1.5980286}, {9600,1.6044000}, {9650,1.6059429}, {9700,1.5874286}, {9750,1.6344857}, {9800,1.5906857}, {9850,1.6434857}, {9900,1.6202286}, {9950,1.6736571}, {10000,1.6291143}, {10100,1.6819143}, {10200,1.6629714}, {10300,1.7058571}, {10400,1.6719429}, {10500,1.7235714}, {10600,1.7272857}, {10700,1.7784286}, {10800,1.7130286}, {10900,1.8074857}, {11000,1.8013429}, {11100,1.8421143}, {11200,1.8321429}, {11300,1.8500857}, {11400,1.8614000}, {11500,1.8902571}, {11600,1.9138000}, {11700,1.9333714}, {11800,1.9234857}, {11900,1.9763714}, {12000,1.9615143}, {12100,1.9905143}, {12200,2.0192571}, {12300,1.9981143}, {12400,2.0222000}, {12500,2.0559429}, {12600,2.0813429}, {12700,2.0802286}, {12800,2.0645143}, {12900,2.1025429}, {13000,2.1342000}, {13100,2.1383714}, {13200,2.1386571}, {13300,2.1838571}, {13400,2.1902000}, {13500,2.2128571}, {13600,2.2208000}, {13700,2.2332286}, {13800,2.2587714}, {13900,2.2810286}, {14000,2.2892286}, {14100,2.3288857}, {14200,2.4356286}, {14300,2.3776000}, {14400,2.3432000}, {14500,2.7239429}, {14600,2.3842000}, {14700,2.5895714}, {14800,2.4815429}, {14900,2.4306857}, {15000,2.4531714}, {15100,2.4950286}, {15200,2.5614286}, {15300,2.5059714}, {15400,2.6774000}, {15500,2.5444286}, {15600,2.5562857}, {15700,2.6604000}, {15800,2.6574571}, {15900,2.5807143}, {16000,2.5914000}, {16100,2.6462571}, {16200,2.6352286}, {16300,2.6977429}, {16400,2.6604857}, {16500,2.6991143}, {16600,2.9026857}, {16700,2.7485143}, {16800,2.7397143}, {16900,2.7425143}, {17000,2.7904286}, {17100,2.8848000}, {17200,2.7962857}, {17300,2.8360286}, {17400,2.8533429}, {17500,2.8570857}, {17600,2.8723143}, {17700,2.8748286}, {17800,2.8890571}, {17900,2.9609714}, {18000,2.9111143}, {18100,2.9769429}, {18200,2.9697714}, {18300,3.0413714}, {18400,3.0225143}, {18500,3.0261429}, {18600,3.0362000}, {18700,3.0634571}, {18800,3.0685714}, {18900,3.0958857}, {19000,3.3212000}, {19100,3.1371714}, {19200,3.2734857}, {19300,3.1716000}, {19400,3.1884286}, {19500,3.3480000}, {19600,3.1924571}, {19700,3.4268857}, {19800,3.2502571}, {19900,3.4151714}, {20000,3.3792286}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["actual reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00013861}, {9,0.00003960}, {10,0.00000000}, {11,0.00003960}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00002970}, {18,0.00003960}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00007921}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00002970}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00003960}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00003960}, {35,0.00003960}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00003960}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00002970}, {44,0.00003960}, {45,0.00003960}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00003960}, {50,0.00000000}, {51,0.00007921}, {52,0.00000000}, {53,0.00003960}, {54,0.00000000}, {55,0.00000000}, {56,0.00007921}, {57,0.00003960}, {58,0.00003960}, {59,0.00000000}, {60,0.00003960}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00002970}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00002970}, {70,0.00003960}, {71,0.00000000}, {72,0.00007921}, {73,0.00000000}, {74,0.00002970}, {75,0.00000000}, {76,0.00003960}, {77,0.00006931}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00003960}, {83,0.00000000}, {84,0.00006931}, {85,0.00002970}, {86,0.00000000}, {87,0.00002970}, {88,0.00000000}, {89,0.00006931}, {90,0.00003960}, {91,0.00000000}, {92,0.00000000}, {93,0.00003960}, {94,0.00000000}, {95,0.00003960}, {96,0.00000000}, {97,0.00003960}, {98,0.00000000}, {99,0.00003960}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00002970}, {105,0.00000000}, {106,0.00000000}, {107,0.00003960}, {108,0.00003960}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00003960}, {113,0.00000000}, {114,0.00000000}, {115,0.00002970}, {116,0.00003960}, {117,0.00000000}, {118,0.00000000}, {119,0.00014851}, {120,0.00003960}, {121,0.00000000}, {122,0.00002970}, {123,0.00011881}, {124,0.00003960}, {125,0.00000000}, {126,0.00000000}, {127,0.00003960}, {128,0.00000000}, {129,0.00002970}, {130,0.00000000}, {131,0.00003960}, {132,0.00007921}, {133,0.00003960}, {134,0.00000000}, {135,0.00014851}, {136,0.00007921}, {137,0.00000000}, {138,0.00000000}, {139,0.00003960}, {140,0.00018812}, {141,0.00007921}, {142,0.00002970}, {143,0.00003960}, {144,0.00003960}, {145,0.00000000}, {146,0.00003960}, {147,0.00000000}, {148,0.00000000}, {149,0.00003960}, {150,0.00000000}, {151,0.00000000}, {152,0.00005941}, {153,0.00000000}, {154,0.00003960}, {155,0.00003960}, {156,0.00002970}, {157,0.00003960}, {158,0.00002970}, {159,0.00003960}, {160,0.00000000}, {161,0.00000000}, {162,0.00019802}, {163,0.00000000}, {164,0.00000000}, {165,0.00003960}, {166,0.00003960}, {167,0.00003960}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00003960}, {172,0.00007921}, {173,0.00002970}, {174,0.00003960}, {175,0.00003960}, {176,0.00000000}, {177,0.00081188}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00003960}, {182,0.00010891}, {183,0.00023762}, {184,0.00000000}, {185,0.00000000}, {186,0.00003960}, {187,0.00000000}, {188,0.00000000}, {189,0.00007921}, {190,0.00000000}, {191,0.00011881}, {192,0.00011881}, {193,0.00010891}, {194,0.00003960}, {195,0.00037624}, {196,0.00007921}, {197,0.00010891}, {198,0.00037624}, {199,0.00019802}, {200,0.00018812}, {201,0.00011881}, {202,0.00023762}, {203,0.00011881}, {204,0.00003960}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00003960}, {209,0.00003960}, {210,0.00000000}, {211,0.00003960}, {212,0.00015842}, {213,0.00003960}, {214,0.00000000}, {215,0.00003960}, {216,0.00003960}, {217,0.00000000}, {218,0.00018812}, {219,0.00003960}, {220,0.00000000}, {221,0.00000000}, {222,0.00007921}, {223,0.00000000}, {224,0.00000000}, {225,0.00011881}, {226,0.00015842}, {227,0.00000000}, {228,0.00002970}, {229,0.00018812}, {230,0.00003960}, {231,0.00000000}, {232,0.00014851}, {233,0.00011881}, {234,0.00003960}, {235,0.00015842}, {236,0.00003960}, {237,0.00003960}, {238,0.00000000}, {239,0.00003960}, {240,0.00000000}, {241,0.00003960}, {242,0.00007921}, {243,0.00000000}, {244,0.00000000}, {245,0.00003960}, {246,0.00003960}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00003960}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00003960}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00003960}, {262,0.00003960}, {263,0.00002970}, {264,0.00002970}, {265,0.00000000}, {266,0.00000000}, {267,0.00003960}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00003960}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00003960}, {283,0.00000000}, {284,0.00000000}, {285,0.00003960}, {286,0.00000000}, {287,0.00000000}, {288,0.00003960}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00002970}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00003960}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00006931}, {303,0.00007921}, {304,0.00000000}, {305,0.00000000}, {306,0.00003960}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00003960}, {313,0.00000000}, {314,0.00000000}, {315,0.00003960}, {316,0.00002970}, {317,0.00003960}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00003960}, {322,0.00000000}, {323,0.00000000}, {324,0.00003960}, {325,0.00000000}, {326,0.00003960}, {327,0.00000000}, {328,0.00003960}, {329,0.00000000}, {330,0.00000000}, {331,0.00003960}, {332,0.00003960}, {333,0.00003960}, {334,0.00000000}, {335,0.00000000}, {336,0.00003960}, {337,0.00000000}, {338,0.00000000}, {339,0.00003960}, {340,0.00003960}, {341,0.00003960}, {342,0.00000000}, {343,0.00000000}, {344,0.00003960}, {345,0.00000000}, {346,0.00003960}, {347,0.00000000}, {348,0.00023762}, {349,0.00000000}, {350,0.00003960}, {351,0.00000000}, {352,0.00003960}, {353,0.00018812}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00003960}, {358,0.00000000}, {359,0.00003960}, {360,0.00011881}, {361,0.00003960}, {362,0.00000000}, {363,0.00003960}, {364,0.00007921}, {365,0.00000000}, {366,0.00003960}, {367,0.00000000}, {368,0.00011881}, {369,0.00000000}, {370,0.00003960}, {371,0.00003960}, {372,0.00000000}, {373,0.00007921}, {374,0.00003960}, {375,0.00000000}, {376,0.00003960}, {377,0.00003960}, {378,0.00000000}, {379,0.00000000}, {380,0.00003960}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00003960}, {385,0.00003960}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00003960}, {391,0.00007921}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00002970}, {398,0.00003960}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00007921}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00011881}, {408,0.00000000}, {409,0.00000000}, {410,0.00003960}, {411,0.00000000}, {412,0.00011881}, {413,0.00011881}, {414,0.00011881}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00007921}, {422,0.00002970}, {423,0.00003960}, {424,0.00006931}, {425,0.00000000}, {426,0.00000000}, {427,0.00003960}, {428,0.00000000}, {429,0.00003960}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00003960}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00003960}, {442,0.00003960}, {443,0.00003960}, {444,0.00000000}, {445,0.00000000}, {446,0.00003960}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00007921}, {451,0.00000000}, {452,0.00002970}, {453,0.00000000}, {454,0.00003960}, {455,0.00007921}, {456,0.00003960}, {457,0.00003960}, {458,0.00000000}, {459,0.00003960}, {460,0.00003960}, {461,0.00000000}, {462,0.00003960}, {463,0.00002970}, {464,0.00007921}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00003960}, {470,0.00000000}, {471,0.00003960}, {472,0.00000000}, {473,0.00003960}, {474,0.00000000}, {475,0.00007921}, {476,0.00003960}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00003960}, {481,0.00003960}, {482,0.00003960}, {483,0.00000000}, {484,0.00003960}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00003960}, {490,0.00000000}, {491,0.00000000}, {492,0.00003960}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00007921}, {497,0.00000000}, {498,0.00000000}, {499,0.00003960}, {500,0.00000000}, {505,0.00000000}, {510,0.00003960}, {515,0.00003960}, {520,0.00003960}, {525,0.00011881}, {530,0.00003960}, {535,0.00003960}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00003960}, {570,0.00000000}, {575,0.00003960}, {580,0.00000000}, {585,0.00003960}, {590,0.00000000}, {595,0.00006931}, {600,0.00006931}, {605,0.00000000}, {610,0.00000000}, {615,0.00003960}, {620,0.00000000}, {625,0.00003960}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00007921}, {660,0.00000000}, {665,0.00003960}, {670,0.00003960}, {675,0.00003960}, {680,0.00003960}, {685,0.00003960}, {690,0.00000000}, {695,0.00000000}, {700,0.00003960}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00006931}, {740,0.00007921}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00011881}, {770,0.00007921}, {775,0.00007921}, {780,0.00000000}, {785,0.00007921}, {790,0.00000000}, {795,0.00007921}, {800,0.00000000}, {805,0.00003960}, {810,0.00000000}, {815,0.00003960}, {820,0.00000000}, {825,0.00000000}, {830,0.00002970}, {835,0.00003960}, {840,0.00003960}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00007921}, {865,0.00000000}, {870,0.00003960}, {875,0.00000000}, {880,0.00003960}, {885,0.00007921}, {890,0.00003960}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00003960}, {920,0.00000000}, {925,0.00000000}, {930,0.00003960}, {935,0.00003960}, {940,0.00000000}, {945,0.00000000}, {950,0.00003960}, {955,0.00000000}, {960,0.00002970}, {965,0.00007921}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00007921}, {990,0.00000000}, {995,0.00000000}, {1000,0.00007921}, {1010,0.00000000}, {1020,0.00003960}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00011881}, {1060,0.00003960}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00003960}, {1120,0.00003960}, {1130,0.00000000}, {1140,0.00007921}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00003960}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00003960}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00003960}, {1250,0.00003960}, {1260,0.00011881}, {1270,0.00002970}, {1280,0.00000000}, {1290,0.00011881}, {1300,0.00003960}, {1310,0.00007921}, {1320,0.00003960}, {1330,0.00003960}, {1340,0.00000000}, {1350,0.00003960}, {1360,0.00000000}, {1370,0.00007921}, {1380,0.00003960}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00003960}, {1420,0.00003960}, {1430,0.00000000}, {1440,0.00006931}, {1450,0.00003960}, {1460,0.00000000}, {1470,0.00003960}, {1480,0.00002970}, {1490,0.00003960}, {1500,0.00000000}, {1510,0.00003960}, {1520,0.00000000}, {1530,0.00011881}, {1540,0.00007921}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00006931}, {1580,0.00003960}, {1590,0.00003960}, {1600,0.00007921}, {1610,0.00007921}, {1620,0.00000000}, {1630,0.00003960}, {1640,0.00000000}, {1650,0.00011881}, {1660,0.00003960}, {1670,0.00007921}, {1680,0.00007921}, {1690,0.00003960}, {1700,0.00003960}, {1710,0.00003960}, {1720,0.00003960}, {1730,0.00007921}, {1740,0.00007921}, {1750,0.00000000}, {1760,0.00007921}, {1770,0.00000000}, {1780,0.00015842}, {1790,0.00000000}, {1800,0.00007921}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00007921}, {1840,0.00000000}, {1850,0.00007921}, {1860,0.00003960}, {1870,0.00002970}, {1880,0.00007921}, {1890,0.00007921}, {1900,0.00011881}, {1910,0.00000000}, {1920,0.00011881}, {1930,0.00010891}, {1940,0.00003960}, {1950,0.00000000}, {1960,0.00015842}, {1970,0.00003960}, {1980,0.00002970}, {1990,0.00000000}, {2000,0.00007921}, {2050,0.00003960}, {2100,0.00007921}, {2150,0.00007921}, {2200,0.00003960}, {2250,0.00007921}, {2300,0.00007921}, {2350,0.00007921}, {2400,0.00007921}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00007921}, {2600,0.00007921}, {2650,0.00003960}, {2700,0.00010891}, {2750,0.00000000}, {2800,0.00002970}, {2850,0.00000000}, {2900,0.00007921}, {2950,0.00000000}, {3000,0.00007921}, {3050,0.00007921}, {3100,0.00140594}, {3150,0.00019802}, {3200,0.00007921}, {3250,0.00007921}, {3300,0.00003960}, {3350,0.00000000}, {3400,0.00003960}, {3450,0.00003960}, {3500,0.00000000}, {3550,0.00003960}, {3600,0.00003960}, {3650,0.00007921}, {3700,0.00000000}, {3750,0.00003960}, {3800,0.00007921}, {3850,0.00007921}, {3900,0.00007921}, {3950,0.00011881}, {4000,0.00000000}, {4050,0.00003960}, {4100,0.00003960}, {4150,0.00007921}, {4200,0.00011881}, {4250,0.00003960}, {4300,0.00003960}, {4350,0.00007921}, {4400,0.00007921}, {4450,0.00003960}, {4500,0.00003960}, {4550,0.00015842}, {4600,0.00018812}, {4650,0.00003960}, {4700,0.00003960}, {4750,0.00007921}, {4800,0.00007921}, {4850,0.00038614}, {4900,0.00047525}, {4950,0.00018812}, {5000,0.00003960}, {5050,0.00106931}, {5100,0.00011881}, {5150,0.00011881}, {5200,0.00046535}, {5250,0.00026733}, {5300,0.00003960}, {5350,0.00011881}, {5400,0.00014851}, {5450,0.00007921}, {5500,0.00011881}, {5550,0.00015842}, {5600,0.00015842}, {5650,0.00007921}, {5700,0.00019802}, {5750,0.00000000}, {5800,0.00003960}, {5850,0.00011881}, {5900,0.00006931}, {5950,0.00015842}, {6000,0.00011881}, {6050,0.0026857}, {6100,0.0011143}, {6150,0.0002286}, {6200,0.0001143}, {6250,0.0021429}, {6300,0.0000857}, {6350,0.0000000}, {6400,0.0001143}, {6450,0.0001143}, {6500,0.0001143}, {6550,0.0002286}, {6600,0.0001143}, {6650,0.0000000}, {6700,0.0001143}, {6750,0.0002286}, {6800,0.0001143}, {6850,0.0001143}, {6900,0.0000000}, {6950,0.0001143}, {7000,0.0000857}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0001143}, {7250,0.0001143}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0003143}, {7550,0.0003429}, {7600,0.0001143}, {7650,0.0000000}, {7700,0.0002286}, {7750,0.0001143}, {7800,0.0001143}, {7850,0.0000000}, {7900,0.0001143}, {7950,0.0001143}, {8000,0.0000000}, {8050,0.0003429}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0001143}, {8350,0.0000000}, {8400,0.0002286}, {8450,0.0000857}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0002000}, {8650,0.0003429}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0002286}, {8950,0.0000000}, {9000,0.0002000}, {9050,0.0001143}, {9100,0.0002286}, {9150,0.0002286}, {9200,0.0001143}, {9250,0.0003429}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0002286}, {9450,0.0001143}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0003143}, {9650,0.0002286}, {9700,0.0001143}, {9750,0.0001143}, {9800,0.0001143}, {9850,0.0003429}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0061429}, {10300,0.0001143}, {10400,0.0000000}, {10500,0.0004571}, {10600,0.0000000}, {10700,0.0001143}, {10800,0.0002286}, {10900,0.0001143}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0001143}, {11400,0.0002286}, {11500,0.0001143}, {11600,0.0002286}, {11700,0.0000000}, {11800,0.0008857}, {11900,0.0001143}, {12000,0.0000000}, {12100,0.0004571}, {12200,0.0002286}, {12300,0.0002286}, {12400,0.0003429}, {12500,0.0008000}, {12600,0.0000000}, {12700,0.0005714}, {12800,0.0001143}, {12900,0.0002286}, {13000,0.0002286}, {13100,0.0001143}, {13200,0.0001143}, {13300,0.0005429}, {13400,0.0000000}, {13500,0.0001143}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0005714}, {14100,0.0008000}, {14200,0.0008857}, {14300,0.0004571}, {14400,0.0000000}, {14500,0.0025714}, {14600,0.0005429}, {14700,0.0013429}, {14800,0.0003429}, {14900,0.0008000}, {15000,0.0004571}, {15100,0.0001143}, {15200,0.0007714}, {15300,0.0008000}, {15400,0.0006857}, {15500,0.0002286}, {15600,0.0005714}, {15700,0.0006857}, {15800,0.0002286}, {15900,0.0005714}, {16000,0.0002286}, {16100,0.0001143}, {16200,0.0010000}, {16300,0.0003429}, {16400,0.0001143}, {16500,0.0010286}, {16600,0.0006571}, {16700,0.0004571}, {16800,0.0000000}, {16900,0.0006857}, {17000,0.0000000}, {17100,0.0005714}, {17200,0.0018000}, {17300,0.0014857}, {17400,0.0000000}, {17500,0.0013714}, {17600,0.0006571}, {17700,0.0009143}, {17800,0.0007714}, {17900,0.0004571}, {18000,0.0002286}, {18100,0.0001143}, {18200,0.0006857}, {18300,0.0013429}, {18400,0.0002286}, {18500,0.0007714}, {18600,0.0010286}, {18700,0.0010000}, {18800,0.0008000}, {18900,0.0000000}, {19000,0.0005714}, {19100,0.0003429}, {19200,0.0008857}, {19300,0.0026286}, {19400,0.0011429}, {19500,0.0003143}, {19600,0.0008000}, {19700,0.0023429}, {19800,0.0024000}, {19900,0.0016857}, {20000,0.0005714}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00100000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00200000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00112871}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000990}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00001980}, {426,0.00000990}, {427,0.00000990}, {428,0.00000990}, {429,0.00000000}, {430,0.00000000}, {431,0.00000990}, {432,0.00001980}, {433,0.00001980}, {434,0.00000990}, {435,0.00000000}, {436,0.00000990}, {437,0.00000990}, {438,0.00000000}, {439,0.00000990}, {440,0.00001980}, {441,0.00000000}, {442,0.00000000}, {443,0.00000990}, {444,0.00000990}, {445,0.00000990}, {446,0.00002970}, {447,0.00001980}, {448,0.00002970}, {449,0.00003960}, {450,0.00006931}, {451,0.00004950}, {452,0.00006931}, {453,0.00007921}, {454,0.00011881}, {455,0.00012871}, {456,0.00014851}, {457,0.00021782}, {458,0.00016832}, {459,0.00022772}, {460,0.00024752}, {461,0.00034653}, {462,0.00040594}, {463,0.00039604}, {464,0.00046535}, {465,0.00041584}, {466,0.00044554}, {467,0.00063366}, {468,0.00052475}, {469,0.00057426}, {470,0.00061386}, {471,0.00055446}, {472,0.00056436}, {473,0.00065347}, {474,0.00061386}, {475,0.00062376}, {476,0.00061386}, {477,0.00072277}, {478,0.00074257}, {479,0.00066337}, {480,0.00070297}, {481,0.00078218}, {482,0.00075248}, {483,0.00079208}, {484,0.00076238}, {485,0.00083168}, {486,0.00081188}, {487,0.00081188}, {488,0.00085149}, {489,0.00089109}, {490,0.00096040}, {491,0.00089109}, {492,0.00091089}, {493,0.00095050}, {494,0.00089109}, {495,0.00094059}, {496,0.00096040}, {497,0.00097030}, {498,0.00097030}, {499,0.00094059}, {500,0.00093069}, {505,0.00098020}, {510,0.00100000}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00100000}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00185149}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00100000}, {830,0.00100000}, {835,0.00100000}, {840,0.00100000}, {845,0.00100000}, {850,0.00100000}, {855,0.00100990}, {860,0.00100000}, {865,0.00100990}, {870,0.00100990}, {875,0.00101980}, {880,0.00101980}, {885,0.00103960}, {890,0.00101980}, {895,0.00102970}, {900,0.00369307}, {905,0.00103960}, {910,0.00324752}, {915,0.00102970}, {920,0.00102970}, {925,0.00102970}, {930,0.00108911}, {935,0.00124752}, {940,0.00136634}, {945,0.00147525}, {950,0.00161386}, {955,0.00157426}, {960,0.00158416}, {965,0.00161386}, {970,0.00159406}, {975,0.00369307}, {980,0.00172277}, {985,0.00183168}, {990,0.00184158}, {995,0.00192079}, {1000,0.00195050}, {1010,0.00199010}, {1020,0.00197030}, {1030,0.00195050}, {1040,0.00199010}, {1050,0.00200000}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00473267}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200000}, {1140,0.00200000}, {1150,0.00200000}, {1160,0.00200000}, {1170,0.00200000}, {1180,0.00200000}, {1190,0.00200000}, {1200,0.00200000}, {1210,0.00200000}, {1220,0.00200000}, {1230,0.00200000}, {1240,0.00200000}, {1250,0.00200000}, {1260,0.00200000}, {1270,0.00200000}, {1280,0.00200000}, {1290,0.00200000}, {1300,0.00200000}, {1310,0.00200000}, {1320,0.00200000}, {1330,0.00200990}, {1340,0.00200000}, {1350,0.00200990}, {1360,0.00201980}, {1370,0.00206931}, {1380,0.00210891}, {1390,0.00207921}, {1400,0.00213861}, {1410,0.00226733}, {1420,0.00231683}, {1430,0.00242574}, {1440,0.00247525}, {1450,0.00247525}, {1460,0.00253465}, {1470,0.00261386}, {1480,0.00271287}, {1490,0.00282178}, {1500,0.00598020}, {1510,0.00561386}, {1520,0.00296040}, {1530,0.00300000}, {1540,0.00300000}, {1550,0.00300000}, {1560,0.00300000}, {1570,0.00300000}, {1580,0.00300000}, {1590,0.00300000}, {1600,0.00300000}, {1610,0.00613861}, {1620,0.00300000}, {1630,0.00300000}, {1640,0.00300000}, {1650,0.00300000}, {1660,0.00300000}, {1670,0.00300000}, {1680,0.00300000}, {1690,0.00300000}, {1700,0.00300000}, {1710,0.00300000}, {1720,0.00300000}, {1730,0.00300000}, {1740,0.00300990}, {1750,0.00300000}, {1760,0.00300000}, {1770,0.00300000}, {1780,0.00300990}, {1790,0.00300000}, {1800,0.00302970}, {1810,0.00304950}, {1820,0.00305941}, {1830,0.00307921}, {1840,0.00307921}, {1850,0.00313861}, {1860,0.00318812}, {1870,0.00326733}, {1880,0.00334653}, {1890,0.00341584}, {1900,0.00346535}, {1910,0.00349505}, {1920,0.00353465}, {1930,0.00356436}, {1940,0.00358416}, {1950,0.00360396}, {1960,0.00367327}, {1970,0.00376238}, {1980,0.00385149}, {1990,0.00396040}, {2000,0.00398020}, {2050,0.00400000}, {2100,0.00400000}, {2150,0.00400000}, {2200,0.00400990}, {2250,0.00404950}, {2300,0.00416832}, {2350,0.00444554}, {2400,0.00455446}, {2450,0.00496040}, {2500,0.00499010}, {2550,0.00500000}, {2600,0.00500990}, {2650,0.00503960}, {2700,0.00507921}, {2750,0.00520792}, {2800,0.01012871}, {2850,0.00561386}, {2900,0.00586139}, {2950,0.01017822}, {3000,0.00601980}, {3050,0.00601980}, {3100,0.00606931}, {3150,0.00611881}, {3200,0.00627723}, {3250,0.00657426}, {3300,0.00661386}, {3350,0.00671287}, {3400,0.00700000}, {3450,0.00701980}, {3500,0.00702970}, {3550,0.00707921}, {3600,0.00715842}, {3650,0.00733663}, {3700,0.01489109}, {3750,0.00761386}, {3800,0.00769307}, {3850,0.00792079}, {3900,0.00803960}, {3950,0.00807921}, {4000,0.00810891}, {4050,0.00820792}, {4100,0.01413861}, {4150,0.01336634}, {4200,0.00866337}, {4250,0.00874257}, {4300,0.00892079}, {4350,0.00907921}, {4400,0.00913861}, {4450,0.00914851}, {4500,0.00919802}, {4550,0.00960396}, {4600,0.00966337}, {4650,0.00968317}, {4700,0.00975248}, {4750,0.00998020}, {4800,0.01009901}, {4850,0.01848515}, {4900,0.01020792}, {4950,0.01041584}, {5000,0.01061386}, {5050,0.01073267}, {5100,0.01075248}, {5150,0.01082178}, {5200,0.01104950}, {5250,0.01115842}, {5300,0.01120792}, {5350,0.01124752}, {5400,0.01153465}, {5450,0.01174257}, {5500,0.01172277}, {5550,0.01178218}, {5600,0.01186139}, {5650,0.01203960}, {5700,0.01214851}, {5750,0.02356436}, {5800,0.01234653}, {5850,0.01261386}, {5900,0.01273267}, {5950,0.01282178}, {6000,0.01283168}, {6050,0.0140571}, {6100,0.0141714}, {6150,0.0145143}, {6200,0.0143714}, {6250,0.0145714}, {6300,0.0147143}, {6350,0.0148286}, {6400,0.0150000}, {6450,0.0146571}, {6500,0.0152286}, {6550,0.0154000}, {6600,0.0154286}, {6650,0.0155714}, {6700,0.0273429}, {6750,0.0159714}, {6800,0.0161429}, {6850,0.0162000}, {6900,0.0162857}, {6950,0.0168571}, {7000,0.0244857}, {7050,0.0302571}, {7100,0.0169714}, {7150,0.0324000}, {7200,0.0173143}, {7250,0.0176857}, {7300,0.0174286}, {7350,0.0173429}, {7400,0.0176000}, {7450,0.0178857}, {7500,0.0289143}, {7550,0.0182286}, {7600,0.0187143}, {7650,0.0317714}, {7700,0.0191429}, {7750,0.0186000}, {7800,0.0366286}, {7850,0.0263429}, {7900,0.0190286}, {7950,0.0365429}, {8000,0.0194286}, {8050,0.0194000}, {8100,0.0194857}, {8150,0.0197429}, {8200,0.0197714}, {8250,0.0199143}, {8300,0.0287429}, {8350,0.0200857}, {8400,0.0202857}, {8450,0.0204571}, {8500,0.0208286}, {8550,0.0209714}, {8600,0.0211429}, {8650,0.0211429}, {8700,0.0562286}, {8750,0.0213429}, {8800,0.0215714}, {8850,0.0217714}, {8900,0.0218571}, {8950,0.0532571}, {9000,0.0221143}, {9050,0.0222000}, {9100,0.0225429}, {9150,0.0226000}, {9200,0.0227143}, {9250,0.0228857}, {9300,0.0230857}, {9350,0.0232286}, {9400,0.0494857}, {9450,0.0552000}, {9500,0.0233143}, {9550,0.0235714}, {9600,0.0350000}, {9650,0.0511714}, {9700,0.0239714}, {9750,0.0241143}, {9800,0.0311714}, {9850,0.0243143}, {9900,0.0526857}, {9950,0.0246571}, {10000,0.0368286}, {10100,0.0250857}, {10200,0.0388857}, {10300,0.0256000}, {10400,0.0259429}, {10500,0.0258857}, {10600,0.0261429}, {10700,0.0453714}, {10800,0.0409143}, {10900,0.0268857}, {11000,0.0272286}, {11100,0.0273143}, {11200,0.0277714}, {11300,0.0496857}, {11400,0.0481714}, {11500,0.0284857}, {11600,0.0287429}, {11700,0.0536000}, {11800,0.0292571}, {11900,0.0474571}, {12000,0.0297714}, {12100,0.0302571}, {12200,0.0463143}, {12300,0.0306286}, {12400,0.0308286}, {12500,0.0310571}, {12600,0.0313429}, {12700,0.0612857}, {12800,0.0566286}, {12900,0.0486571}, {13000,0.0645143}, {13100,0.0327429}, {13200,0.0330000}, {13300,0.0554571}, {13400,0.0334286}, {13500,0.0664286}, {13600,0.0475429}, {13700,0.0462000}, {13800,0.0345143}, {13900,0.0690571}, {14000,0.0351714}, {14100,0.0353429}, {14200,0.0466571}, {14300,0.0558000}, {14400,0.0362571}, {14500,0.0534857}, {14600,0.0616000}, {14700,0.0368571}, {14800,0.0639143}, {14900,0.0698571}, {15000,0.0378286}, {15100,0.0715429}, {15200,0.0382286}, {15300,0.0764286}, {15400,0.0571143}, {15500,0.0388857}, {15600,0.0390286}, {15700,0.0590571}, {15800,0.0671143}, {15900,0.0399143}, {16000,0.0401143}, {16100,0.0656571}, {16200,0.0405429}, {16300,0.0678000}, {16400,0.0654000}, {16500,0.0827714}, {16600,0.0635714}, {16700,0.0420571}, {16800,0.0425714}, {16900,0.0426286}, {17000,0.0561714}, {17100,0.0430857}, {17200,0.0705143}, {17300,0.0771143}, {17400,0.0741714}, {17500,0.0444286}, {17600,0.0444571}, {17700,0.0447714}, {17800,0.0448857}, {17900,0.0753714}, {18000,0.0455429}, {18100,0.0958286}, {18200,0.0463143}, {18300,0.0628286}, {18400,0.0786000}, {18500,0.0697714}, {18600,0.0807429}, {18700,0.1533714}, {18800,0.0459143}, {18900,0.0765429}, {19000,0.0676000}, {19100,0.0652286}, {19200,0.0754571}, {19300,0.1033429}, {19400,0.0492857}, {19500,0.1713714}, {19600,0.1806571}, {19700,0.0502000}, {19800,0.0803429}, {19900,0.0821143}, {20000,0.0510000}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00003960}, {3,0.00003960}, {4,0.00003960}, {5,0.00005941}, {6,0.00006931}, {7,0.00000000}, {8,0.00000000}, {9,0.00003960}, {10,0.00002970}, {11,0.00015842}, {12,0.00002970}, {13,0.00003960}, {14,0.00006931}, {15,0.00003960}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00013861}, {20,0.00009901}, {21,0.00000000}, {22,0.00005941}, {23,0.00003960}, {24,0.00000000}, {25,0.00000000}, {26,0.00006931}, {27,0.00005941}, {28,0.00005941}, {29,0.00015842}, {30,0.00013861}, {31,0.00008911}, {32,0.00005941}, {33,0.00002970}, {34,0.00011881}, {35,0.00006931}, {36,0.00020792}, {37,0.00010891}, {38,0.00009901}, {39,0.00009901}, {40,0.00003960}, {41,0.00010891}, {42,0.00002970}, {43,0.00010891}, {44,0.00014851}, {45,0.00006931}, {46,0.00007921}, {47,0.00006931}, {48,0.00010891}, {49,0.00016832}, {50,0.00009901}, {51,0.00027723}, {52,0.00007921}, {53,0.00003960}, {54,0.00020792}, {55,0.00005941}, {56,0.00006931}, {57,0.00016832}, {58,0.00018812}, {59,0.00020792}, {60,0.00014851}, {61,0.00005941}, {62,0.00018812}, {63,0.00008911}, {64,0.00009901}, {65,0.00013861}, {66,0.00012871}, {67,0.00006931}, {68,0.00006931}, {69,0.00024752}, {70,0.00021782}, {71,0.00008911}, {72,0.00006931}, {73,0.00002970}, {74,0.00023762}, {75,0.00015842}, {76,0.00012871}, {77,0.00013861}, {78,0.00018812}, {79,0.00015842}, {80,0.00022772}, {81,0.00016832}, {82,0.00005941}, {83,0.00025743}, {84,0.00012871}, {85,0.00011881}, {86,0.00021782}, {87,0.00002970}, {88,0.00031683}, {89,0.00023762}, {90,0.00021782}, {91,0.00024752}, {92,0.00025743}, {93,0.00008911}, {94,0.00017822}, {95,0.00021782}, {96,0.00005941}, {97,0.00016832}, {98,0.00015842}, {99,0.00031683}, {100,0.00035644}, {101,0.00031683}, {102,0.00019802}, {103,0.00018812}, {104,0.00031683}, {105,0.00016832}, {106,0.00020792}, {107,0.00026733}, {108,0.00015842}, {109,0.00029703}, {110,0.00017822}, {111,0.00014851}, {112,0.00022772}, {113,0.00014851}, {114,0.00045545}, {115,0.00028713}, {116,0.00020792}, {117,0.00012871}, {118,0.00013861}, {119,0.00008911}, {120,0.00022772}, {121,0.00020792}, {122,0.00018812}, {123,0.00019802}, {124,0.00034653}, {125,0.00018812}, {126,0.00019802}, {127,0.00033663}, {128,0.00027723}, {129,0.00014851}, {130,0.00017822}, {131,0.00036634}, {132,0.00019802}, {133,0.00031683}, {134,0.00022772}, {135,0.00028713}, {136,0.00024752}, {137,0.00016832}, {138,0.00018812}, {139,0.00020792}, {140,0.00027723}, {141,0.00018812}, {142,0.00031683}, {143,0.00023762}, {144,0.00006931}, {145,0.00024752}, {146,0.00035644}, {147,0.00013861}, {148,0.00031683}, {149,0.00029703}, {150,0.00028713}, {151,0.00038614}, {152,0.00020792}, {153,0.00047525}, {154,0.00038614}, {155,0.00046535}, {156,0.00030693}, {157,0.00022772}, {158,0.00035644}, {159,0.00027723}, {160,0.00011881}, {161,0.00022772}, {162,0.00021782}, {163,0.00034653}, {164,0.00031683}, {165,0.00032673}, {166,0.00034653}, {167,0.00026733}, {168,0.00018812}, {169,0.00047525}, {170,0.00028713}, {171,0.00035644}, {172,0.00028713}, {173,0.00017822}, {174,0.00036634}, {175,0.00046535}, {176,0.00026733}, {177,0.00030693}, {178,0.00031683}, {179,0.00022772}, {180,0.00054455}, {181,0.00036634}, {182,0.00024752}, {183,0.00021782}, {184,0.00026733}, {185,0.00044554}, {186,0.00039604}, {187,0.00039604}, {188,0.00025743}, {189,0.00026733}, {190,0.00032673}, {191,0.00027723}, {192,0.00035644}, {193,0.00038614}, {194,0.00038614}, {195,0.00036634}, {196,0.00029703}, {197,0.00024752}, {198,0.00056436}, {199,0.00035644}, {200,0.00041584}, {201,0.00043564}, {202,0.00055446}, {203,0.00047525}, {204,0.00033663}, {205,0.00034653}, {206,0.00037624}, {207,0.00032673}, {208,0.00050495}, {209,0.00035644}, {210,0.00058416}, {211,0.00032673}, {212,0.00020792}, {213,0.00062376}, {214,0.00037624}, {215,0.00043564}, {216,0.00030693}, {217,0.00066337}, {218,0.00028713}, {219,0.00047525}, {220,0.00046535}, {221,0.00043564}, {222,0.00055446}, {223,0.00049505}, {224,0.00052475}, {225,0.00035644}, {226,0.00039604}, {227,0.00062376}, {228,0.00030693}, {229,0.00059406}, {230,0.00039604}, {231,0.00063366}, {232,0.00075248}, {233,0.00028713}, {234,0.00039604}, {235,0.00043564}, {236,0.00039604}, {237,0.00042574}, {238,0.00059406}, {239,0.00044554}, {240,0.00051485}, {241,0.00073267}, {242,0.00044554}, {243,0.00043564}, {244,0.00044554}, {245,0.00036634}, {246,0.00053465}, {247,0.00039604}, {248,0.00034653}, {249,0.00042574}, {250,0.00048515}, {251,0.00048515}, {252,0.00044554}, {253,0.00061386}, {254,0.00042574}, {255,0.00044554}, {256,0.00047525}, {257,0.00047525}, {258,0.00144554}, {259,0.00032673}, {260,0.00048515}, {261,0.00049505}, {262,0.00038614}, {263,0.00036634}, {264,0.00030693}, {265,0.00044554}, {266,0.00036634}, {267,0.00052475}, {268,0.00039604}, {269,0.00055446}, {270,0.00082178}, {271,0.00036634}, {272,0.00062376}, {273,0.00045545}, {274,0.00037624}, {275,0.00045545}, {276,0.00024752}, {277,0.00046535}, {278,0.00044554}, {279,0.00046535}, {280,0.00035644}, {281,0.00070297}, {282,0.00065347}, {283,0.00052475}, {284,0.00063366}, {285,0.00049505}, {286,0.00042574}, {287,0.00056436}, {288,0.00043564}, {289,0.00066337}, {290,0.00046535}, {291,0.00048515}, {292,0.00056436}, {293,0.00064356}, {294,0.00044554}, {295,0.00066337}, {296,0.00033663}, {297,0.00052475}, {298,0.00060396}, {299,0.00057426}, {300,0.00060396}, {301,0.00058416}, {302,0.00053465}, {303,0.00071287}, {304,0.00195050}, {305,0.00059406}, {306,0.00031683}, {307,0.00065347}, {308,0.00042574}, {309,0.00053465}, {310,0.00055446}, {311,0.00055446}, {312,0.00046535}, {313,0.00051485}, {314,0.00061386}, {315,0.00075248}, {316,0.00036634}, {317,0.00069307}, {318,0.00081188}, {319,0.00034653}, {320,0.00058416}, {321,0.00070297}, {322,0.00053465}, {323,0.00056436}, {324,0.00039604}, {325,0.00041584}, {326,0.00058416}, {327,0.00066337}, {328,0.00047525}, {329,0.00060396}, {330,0.00058416}, {331,0.00078218}, {332,0.00075248}, {333,0.00037624}, {334,0.00056436}, {335,0.00052475}, {336,0.00036634}, {337,0.00043564}, {338,0.00074257}, {339,0.00049505}, {340,0.00052475}, {341,0.00070297}, {342,0.00063366}, {343,0.00080198}, {344,0.00073267}, {345,0.00070297}, {346,0.00063366}, {347,0.00079208}, {348,0.00072277}, {349,0.00040594}, {350,0.00064356}, {351,0.00076238}, {352,0.00154455}, {353,0.00037624}, {354,0.00078218}, {355,0.00061386}, {356,0.00066337}, {357,0.00084158}, {358,0.00070297}, {359,0.00080198}, {360,0.00077228}, {361,0.00076238}, {362,0.00073267}, {363,0.00087129}, {364,0.00074257}, {365,0.00064356}, {366,0.00075248}, {367,0.00057426}, {368,0.00073267}, {369,0.00071287}, {370,0.00076238}, {371,0.00076238}, {372,0.00052475}, {373,0.00067327}, {374,0.00066337}, {375,0.00093069}, {376,0.00069307}, {377,0.00066337}, {378,0.00100990}, {379,0.00083168}, {380,0.00060396}, {381,0.00064356}, {382,0.00089109}, {383,0.00091089}, {384,0.00095050}, {385,0.00068317}, {386,0.00041584}, {387,0.00100000}, {388,0.00102970}, {389,0.00061386}, {390,0.00087129}, {391,0.00059406}, {392,0.00065347}, {393,0.00069307}, {394,0.00080198}, {395,0.00073267}, {396,0.00100000}, {397,0.00092079}, {398,0.00068317}, {399,0.00104950}, {400,0.00095050}, {401,0.00076238}, {402,0.00069307}, {403,0.00061386}, {404,0.00075248}, {405,0.00088119}, {406,0.00048515}, {407,0.00071287}, {408,0.00085149}, {409,0.00047525}, {410,0.00063366}, {411,0.00084158}, {412,0.00100990}, {413,0.00081188}, {414,0.00068317}, {415,0.00078218}, {416,0.00070297}, {417,0.00087129}, {418,0.00071287}, {419,0.00066337}, {420,0.00100990}, {421,0.00073267}, {422,0.00099010}, {423,0.00081188}, {424,0.00083168}, {425,0.00084158}, {426,0.00077228}, {427,0.00098020}, {428,0.00111881}, {429,0.00087129}, {430,0.00087129}, {431,0.00079208}, {432,0.00102970}, {433,0.00108911}, {434,0.00073267}, {435,0.00091089}, {436,0.00070297}, {437,0.00075248}, {438,0.00069307}, {439,0.00095050}, {440,0.00099010}, {441,0.00096040}, {442,0.00095050}, {443,0.00090099}, {444,0.00085149}, {445,0.00069307}, {446,0.00082178}, {447,0.00088119}, {448,0.00091089}, {449,0.00116832}, {450,0.00101980}, {451,0.00071287}, {452,0.00118812}, {453,0.00082178}, {454,0.00101980}, {455,0.00044554}, {456,0.00063366}, {457,0.00090099}, {458,0.00089109}, {459,0.00089109}, {460,0.00092079}, {461,0.00102970}, {462,0.00106931}, {463,0.00085149}, {464,0.00092079}, {465,0.00074257}, {466,0.00052475}, {467,0.00086139}, {468,0.00100990}, {469,0.00061386}, {470,0.00089109}, {471,0.00087129}, {472,0.00094059}, {473,0.00092079}, {474,0.00097030}, {475,0.00065347}, {476,0.00091089}, {477,0.00066337}, {478,0.00120792}, {479,0.00080198}, {480,0.00095050}, {481,0.00098020}, {482,0.00103960}, {483,0.00091089}, {484,0.00104950}, {485,0.00100990}, {486,0.00071287}, {487,0.00106931}, {488,0.00113861}, {489,0.00097030}, {490,0.00068317}, {491,0.00136634}, {492,0.00109901}, {493,0.00092079}, {494,0.00114851}, {495,0.00109901}, {496,0.00079208}, {497,0.00077228}, {498,0.00083168}, {499,0.00096040}, {500,0.00113861}, {505,0.00091089}, {510,0.00108911}, {515,0.00078218}, {520,0.00095050}, {525,0.00111881}, {530,0.00097030}, {535,0.00108911}, {540,0.00116832}, {545,0.00070297}, {550,0.00173267}, {555,0.00081188}, {560,0.00105941}, {565,0.00100000}, {570,0.00110891}, {575,0.00088119}, {580,0.00099010}, {585,0.00140594}, {590,0.00121782}, {595,0.00123762}, {600,0.00117822}, {605,0.00113861}, {610,0.00101980}, {615,0.00092079}, {620,0.00098020}, {625,0.00116832}, {630,0.00102970}, {635,0.00106931}, {640,0.00111881}, {645,0.00084158}, {650,0.00116832}, {655,0.00095050}, {660,0.00108911}, {665,0.00113861}, {670,0.00099010}, {675,0.00119802}, {680,0.00089109}, {685,0.00144554}, {690,0.00124752}, {695,0.00131683}, {700,0.00100000}, {705,0.00138614}, {710,0.00120792}, {715,0.00100000}, {720,0.00116832}, {725,0.00127723}, {730,0.00109901}, {735,0.00110891}, {740,0.00121782}, {745,0.00129703}, {750,0.00134653}, {755,0.00128713}, {760,0.00105941}, {765,0.00128713}, {770,0.00146535}, {775,0.00129703}, {780,0.00122772}, {785,0.00143564}, {790,0.00143564}, {795,0.00116832}, {800,0.00139604}, {805,0.00132673}, {810,0.00132673}, {815,0.00129703}, {820,0.00145545}, {825,0.00158416}, {830,0.00113861}, {835,0.00151485}, {840,0.00161386}, {845,0.00150495}, {850,0.00130693}, {855,0.00167327}, {860,0.00141584}, {865,0.00140594}, {870,0.00143564}, {875,0.00156436}, {880,0.00167327}, {885,0.00155446}, {890,0.00187129}, {895,0.00144554}, {900,0.00351485}, {905,0.00156436}, {910,0.00320792}, {915,0.00175248}, {920,0.00160396}, {925,0.00182178}, {930,0.00173267}, {935,0.00190099}, {940,0.00162376}, {945,0.00184158}, {950,0.00154455}, {955,0.00146535}, {960,0.00174257}, {965,0.00173267}, {970,0.00184158}, {975,0.00328713}, {980,0.00206931}, {985,0.00171287}, {990,0.00172277}, {995,0.00157426}, {1000,0.00169307}, {1010,0.00176238}, {1020,0.00175248}, {1030,0.00172277}, {1040,0.00203960}, {1050,0.00191089}, {1060,0.00210891}, {1070,0.00192079}, {1080,0.00453465}, {1090,0.00179208}, {1100,0.00208911}, {1110,0.00189109}, {1120,0.00201980}, {1130,0.00185149}, {1140,0.00219802}, {1150,0.00207921}, {1160,0.00215842}, {1170,0.00208911}, {1180,0.00209901}, {1190,0.00208911}, {1200,0.00204950}, {1210,0.00194059}, {1220,0.00209901}, {1230,0.00229703}, {1240,0.00236634}, {1250,0.00223762}, {1260,0.00229703}, {1270,0.00170297}, {1280,0.00216832}, {1290,0.00206931}, {1300,0.00205941}, {1310,0.00244554}, {1320,0.00228713}, {1330,0.00207921}, {1340,0.00255446}, {1350,0.00227723}, {1360,0.00254455}, {1370,0.00229703}, {1380,0.00226733}, {1390,0.00221782}, {1400,0.00220792}, {1410,0.00223762}, {1420,0.00233663}, {1430,0.00243564}, {1440,0.00250495}, {1450,0.00266337}, {1460,0.00254455}, {1470,0.00275248}, {1480,0.00273267}, {1490,0.00302970}, {1500,0.00583168}, {1510,0.00563366}, {1520,0.00277228}, {1530,0.00302970}, {1540,0.00270297}, {1550,0.00278218}, {1560,0.00318812}, {1570,0.00268317}, {1580,0.00301980}, {1590,0.00331683}, {1600,0.00300990}, {1610,0.00626733}, {1620,0.00292079}, {1630,0.00298020}, {1640,0.00302970}, {1650,0.00304950}, {1660,0.00300000}, {1670,0.00297030}, {1680,0.00320792}, {1690,0.00295050}, {1700,0.00307921}, {1710,0.00304950}, {1720,0.00327723}, {1730,0.00334653}, {1740,0.00339604}, {1750,0.00321782}, {1760,0.00351485}, {1770,0.00331683}, {1780,0.00318812}, {1790,0.00352475}, {1800,0.00348515}, {1810,0.00343564}, {1820,0.00342574}, {1830,0.00341584}, {1840,0.00347525}, {1850,0.00339604}, {1860,0.00347525}, {1870,0.00351485}, {1880,0.00364356}, {1890,0.00371287}, {1900,0.00368317}, {1910,0.00366337}, {1920,0.00372277}, {1930,0.00363366}, {1940,0.00369307}, {1950,0.00361386}, {1960,0.00373267}, {1970,0.00371287}, {1980,0.00393069}, {1990,0.00365347}, {2000,0.00383168}, {2050,0.00394059}, {2100,0.00419802}, {2150,0.00427723}, {2200,0.00426733}, {2250,0.00437624}, {2300,0.00421782}, {2350,0.00462376}, {2400,0.00466337}, {2450,0.00519802}, {2500,0.00463366}, {2550,0.00533663}, {2600,0.00529703}, {2650,0.00555446}, {2700,0.00555446}, {2750,0.00527723}, {2800,0.01037624}, {2850,0.00589109}, {2900,0.00580198}, {2950,0.01032673}, {3000,0.00601980}, {3050,0.00597030}, {3100,0.00593069}, {3150,0.00602970}, {3200,0.00619802}, {3250,0.00630693}, {3300,0.00670297}, {3350,0.00667327}, {3400,0.00664356}, {3450,0.00674257}, {3500,0.00700000}, {3550,0.00700000}, {3600,0.00715842}, {3650,0.00709901}, {3700,0.01496040}, {3750,0.00749505}, {3800,0.00765347}, {3850,0.00775248}, {3900,0.00793069}, {3950,0.00800990}, {4000,0.00795050}, {4050,0.00815842}, {4100,0.01452475}, {4150,0.01340594}, {4200,0.00841584}, {4250,0.00874257}, {4300,0.00925743}, {4350,0.00931683}, {4400,0.00908911}, {4450,0.00915842}, {4500,0.00949505}, {4550,0.00965347}, {4600,0.01006931}, {4650,0.00951485}, {4700,0.00985149}, {4750,0.00994059}, {4800,0.00992079}, {4850,0.01824752}, {4900,0.01045545}, {4950,0.01052475}, {5000,0.01042574}, {5050,0.01117822}, {5100,0.01085149}, {5150,0.01086139}, {5200,0.01116832}, {5250,0.01125743}, {5300,0.01109901}, {5350,0.01115842}, {5400,0.01135644}, {5450,0.01157426}, {5500,0.01179208}, {5550,0.01170297}, {5600,0.01181188}, {5650,0.01207921}, {5700,0.01219802}, {5750,0.02378218}, {5800,0.01239604}, {5850,0.01257426}, {5900,0.01270297}, {5950,0.01299010}, {6000,0.01266337}, {6050,0.0139429}, {6100,0.0143429}, {6150,0.0146286}, {6200,0.0141714}, {6250,0.0141429}, {6300,0.0149143}, {6350,0.0149714}, {6400,0.0148571}, {6450,0.0149714}, {6500,0.0158286}, {6550,0.0155143}, {6600,0.0154286}, {6650,0.0157714}, {6700,0.0273143}, {6750,0.0159143}, {6800,0.0160857}, {6850,0.0160571}, {6900,0.0158571}, {6950,0.0165429}, {7000,0.0244857}, {7050,0.0298857}, {7100,0.0168857}, {7150,0.0324000}, {7200,0.0173429}, {7250,0.0172857}, {7300,0.0172857}, {7350,0.0176857}, {7400,0.0178286}, {7450,0.0174571}, {7500,0.0289429}, {7550,0.0187714}, {7600,0.0183714}, {7650,0.0319714}, {7700,0.0188571}, {7750,0.0180571}, {7800,0.0369714}, {7850,0.0267429}, {7900,0.0191429}, {7950,0.0365714}, {8000,0.0191429}, {8050,0.0193143}, {8100,0.0190571}, {8150,0.0200857}, {8200,0.0200000}, {8250,0.0197714}, {8300,0.0282571}, {8350,0.0198000}, {8400,0.0200857}, {8450,0.0203429}, {8500,0.0207429}, {8550,0.0203429}, {8600,0.0207714}, {8650,0.0204286}, {8700,0.0562000}, {8750,0.0217714}, {8800,0.0215143}, {8850,0.0220000}, {8900,0.0213143}, {8950,0.0530000}, {9000,0.0220286}, {9050,0.0228571}, {9100,0.0224857}, {9150,0.0229714}, {9200,0.0229429}, {9250,0.0234000}, {9300,0.0229714}, {9350,0.0239143}, {9400,0.0500571}, {9450,0.0555143}, {9500,0.0232571}, {9550,0.0242000}, {9600,0.0350857}, {9650,0.0514571}, {9700,0.0243143}, {9750,0.0244571}, {9800,0.0314857}, {9850,0.0244000}, {9900,0.0528286}, {9950,0.0250000}, {10000,0.0369429}, {10100,0.0249714}, {10200,0.0384571}, {10300,0.0264857}, {10400,0.0261143}, {10500,0.0258571}, {10600,0.0270000}, {10700,0.0453143}, {10800,0.0409429}, {10900,0.0270857}, {11000,0.0277143}, {11100,0.0280857}, {11200,0.0281714}, {11300,0.0494857}, {11400,0.0485143}, {11500,0.0286286}, {11600,0.0286857}, {11700,0.0540857}, {11800,0.0291714}, {11900,0.0473143}, {12000,0.0302286}, {12100,0.0300571}, {12200,0.0462857}, {12300,0.0310857}, {12400,0.0310286}, {12500,0.0308286}, {12600,0.0312857}, {12700,0.0610286}, {12800,0.0564571}, {12900,0.0486286}, {13000,0.0644286}, {13100,0.0324286}, {13200,0.0329429}, {13300,0.0555714}, {13400,0.0331143}, {13500,0.0663143}, {13600,0.0476000}, {13700,0.0466857}, {13800,0.0349429}, {13900,0.0689429}, {14000,0.0349429}, {14100,0.0354571}, {14200,0.0466286}, {14300,0.0560286}, {14400,0.0366857}, {14500,0.0537429}, {14600,0.0614857}, {14700,0.0373429}, {14800,0.0638571}, {14900,0.0700000}, {15000,0.0375429}, {15100,0.0718571}, {15200,0.0381429}, {15300,0.0762000}, {15400,0.0569714}, {15500,0.0384000}, {15600,0.0388571}, {15700,0.0582286}, {15800,0.0672000}, {15900,0.0402571}, {16000,0.0394857}, {16100,0.0650286}, {16200,0.0406286}, {16300,0.0675143}, {16400,0.0649143}, {16500,0.0825429}, {16600,0.0635429}, {16700,0.0421429}, {16800,0.0423714}, {16900,0.0433143}, {17000,0.0562286}, {17100,0.0428857}, {17200,0.0701143}, {17300,0.0770286}, {17400,0.0743143}, {17500,0.0440571}, {17600,0.0442286}, {17700,0.0446000}, {17800,0.0450571}, {17900,0.0757714}, {18000,0.0458000}, {18100,0.0962286}, {18200,0.0465714}, {18300,0.0625143}, {18400,0.0786857}, {18500,0.0694857}, {18600,0.0806571}, {18700,0.1533143}, {18800,0.0455143}, {18900,0.0766571}, {19000,0.0675429}, {19100,0.0650000}, {19200,0.0754571}, {19300,0.1032857}, {19400,0.0493143}, {19500,0.1690571}, {19600,0.1809143}, {19700,0.0507429}, {19800,0.0782571}, {19900,0.0823429}, {20000,0.0512857}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00003960}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00003960}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00003960}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00003960}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00003960}, {125,0.00000000}, {126,0.00002970}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00003960}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00003960}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00003960}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00003960}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00003960}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00003960}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00003960}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00002970}, {213,0.00000000}, {214,0.00000000}, {215,0.00003960}, {216,0.00000000}, {217,0.00000000}, {218,0.00003960}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00003960}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00003960}, {232,0.00002970}, {233,0.00000000}, {234,0.00003960}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00003960}, {244,0.00000000}, {245,0.00003960}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00003960}, {255,0.00000000}, {256,0.00000000}, {257,0.00003960}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003960}, {266,0.00003960}, {267,0.00003960}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00007921}, {284,0.00000000}, {285,0.00003960}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00003960}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00003960}, {300,0.00000000}, {301,0.00000000}, {302,0.00003960}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00003960}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00003960}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00003960}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00003960}, {352,0.00007921}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00007921}, {372,0.00000000}, {373,0.00000000}, {374,0.00003960}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00003960}, {385,0.00000000}, {386,0.00002970}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00003960}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00002970}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00003960}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00003960}, {449,0.00000000}, {450,0.00003960}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00003960}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00003960}, {470,0.00000000}, {471,0.00003960}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00006931}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00003960}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00003960}, {555,0.00000000}, {560,0.00003960}, {565,0.00000000}, {570,0.00000000}, {575,0.00002970}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00003960}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00003960}, {630,0.00003960}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00003960}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00003960}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00003960}, {750,0.00000000}, {755,0.00000000}, {760,0.00003960}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00003960}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00003960}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00003960}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00003960}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00003960}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00003960}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00003960}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00003960}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00003960}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00002970}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00003960}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00003960}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00003960}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00003960}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00003960}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00003960}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00003960}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00003960}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00003960}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00003960}, {4300,0.00003960}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00003960}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00002970}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00007921}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00003960}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0001143}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0001143}, {7900,0.0000000}, {7950,0.0001143}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0001143}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0001143}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0001143}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0002286}, {10700,0.0001143}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0001143}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0001143}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0001143}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0001143}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0001143}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0001143}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0002286}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0001143}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00200000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00200000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000990}, {1350,0.00000000}, {1360,0.00000990}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00001980}, {1410,0.00001980}, {1420,0.00002970}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00015842}, {1480,0.00003960}, {1490,0.00001980}, {1500,0.00000000}, {1510,0.00000990}, {1520,0.00000990}, {1530,0.00004950}, {1540,0.00047525}, {1550,0.00002970}, {1560,0.00048515}, {1570,0.00001980}, {1580,0.00067327}, {1590,0.00047525}, {1600,0.00047525}, {1610,0.00040594}, {1620,0.00043564}, {1630,0.00073267}, {1640,0.00100000}, {1650,0.00045545}, {1660,0.00100000}, {1670,0.00056436}, {1680,0.00100000}, {1690,0.00100000}, {1700,0.00100000}, {1710,0.00100000}, {1720,0.00100000}, {1730,0.00100000}, {1740,0.00065347}, {1750,0.00100000}, {1760,0.00100000}, {1770,0.00100000}, {1780,0.00100000}, {1790,0.00100000}, {1800,0.00100000}, {1810,0.00100000}, {1820,0.00100000}, {1830,0.00100000}, {1840,0.00100000}, {1850,0.00100000}, {1860,0.00100000}, {1870,0.00100000}, {1880,0.00100000}, {1890,0.00100000}, {1900,0.00100000}, {1910,0.00100000}, {1920,0.00100000}, {1930,0.00100000}, {1940,0.00100000}, {1950,0.00100000}, {1960,0.00100000}, {1970,0.00100000}, {1980,0.00100000}, {1990,0.00100000}, {2000,0.00100000}, {2050,0.00100000}, {2100,0.00100000}, {2150,0.00100000}, {2200,0.00100000}, {2250,0.00100000}, {2300,0.00100000}, {2350,0.00100000}, {2400,0.00100000}, {2450,0.00100000}, {2500,0.00100000}, {2550,0.00100000}, {2600,0.00100000}, {2650,0.00100000}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100990}, {3100,0.00100000}, {3150,0.00101980}, {3200,0.00135644}, {3250,0.00105941}, {3300,0.00156436}, {3350,0.00804950}, {3400,0.00161386}, {3450,0.00200000}, {3500,0.00200000}, {3550,0.00465347}, {3600,0.00200000}, {3650,0.00200000}, {3700,0.00200000}, {3750,0.00200000}, {3800,0.00200000}, {3850,0.00200000}, {3900,0.00200000}, {3950,0.00200000}, {4000,0.00200000}, {4050,0.00200000}, {4100,0.00411881}, {4150,0.00200000}, {4200,0.00200000}, {4250,0.00200000}, {4300,0.00200990}, {4350,0.00206931}, {4400,0.00204950}, {4450,0.00205941}, {4500,0.00201980}, {4550,0.00204950}, {4600,0.00209901}, {4650,0.00209901}, {4700,0.00206931}, {4750,0.00216832}, {4800,0.00217822}, {4850,0.00212871}, {4900,0.00233663}, {4950,0.00269307}, {5000,0.00264356}, {5050,0.00275248}, {5100,0.00278218}, {5150,0.00283168}, {5200,0.00278218}, {5250,0.00288119}, {5300,0.00766337}, {5350,0.00300990}, {5400,0.00304950}, {5450,0.00304950}, {5500,0.00303960}, {5550,0.00501980}, {5600,0.00305941}, {5650,0.00307921}, {5700,0.00305941}, {5750,0.00307921}, {5800,0.00307921}, {5850,0.00307921}, {5900,0.01345545}, {5950,0.00309901}, {6000,0.00723762}, {6050,0.0042000}, {6100,0.0044286}, {6150,0.0045429}, {6200,0.0044286}, {6250,0.0043143}, {6300,0.0041429}, {6350,0.0043714}, {6400,0.0046000}, {6450,0.0048000}, {6500,0.0046286}, {6550,0.0048857}, {6600,0.0048571}, {6650,0.0048000}, {6700,0.0051714}, {6750,0.0050286}, {6800,0.0052857}, {6850,0.0052571}, {6900,0.0052857}, {6950,0.0054286}, {7000,0.0051714}, {7050,0.0052857}, {7100,0.0053143}, {7150,0.0057143}, {7200,0.0052571}, {7250,0.0092286}, {7300,0.0057429}, {7350,0.0056571}, {7400,0.0056571}, {7450,0.0058286}, {7500,0.0199143}, {7550,0.0060857}, {7600,0.0062286}, {7650,0.0058857}, {7700,0.0064000}, {7750,0.0064571}, {7800,0.0064286}, {7850,0.0066571}, {7900,0.0064286}, {7950,0.0066571}, {8000,0.0066571}, {8050,0.0065143}, {8100,0.0065429}, {8150,0.0066571}, {8200,0.0069429}, {8250,0.0068857}, {8300,0.0068000}, {8350,0.0069143}, {8400,0.0111714}, {8450,0.0074571}, {8500,0.0072571}, {8550,0.0072286}, {8600,0.0076000}, {8650,0.0176571}, {8700,0.0075714}, {8750,0.0076286}, {8800,0.0076571}, {8850,0.0077429}, {8900,0.0077714}, {8950,0.0076857}, {9000,0.0078571}, {9050,0.0068000}, {9100,0.0078286}, {9150,0.0077429}, {9200,0.0236571}, {9250,0.0080857}, {9300,0.0080857}, {9350,0.0080571}, {9400,0.0083143}, {9450,0.0138857}, {9500,0.0085429}, {9550,0.0087714}, {9600,0.0084286}, {9650,0.0086000}, {9700,0.0075143}, {9750,0.0086571}, {9800,0.0088857}, {9850,0.0089143}, {9900,0.0089143}, {9950,0.0088857}, {10000,0.0089143}, {10100,0.0089143}, {10200,0.0190571}, {10300,0.0090000}, {10400,0.0091429}, {10500,0.0093714}, {10600,0.0090286}, {10700,0.0097714}, {10800,0.0123429}, {10900,0.0097143}, {11000,0.0097714}, {11100,0.0097714}, {11200,0.0097714}, {11300,0.0098286}, {11400,0.0098286}, {11500,0.0099143}, {11600,0.0102286}, {11700,0.0102000}, {11800,0.0106857}, {11900,0.0107143}, {12000,0.0107429}, {12100,0.0107714}, {12200,0.0107714}, {12300,0.0107429}, {12400,0.0107714}, {12500,0.0108571}, {12600,0.0109429}, {12700,0.0112857}, {12800,0.0113429}, {12900,0.0114857}, {13000,0.0114571}, {13100,0.0117143}, {13200,0.0156000}, {13300,0.0117143}, {13400,0.0117143}, {13500,0.0279429}, {13600,0.0117714}, {13700,0.0119143}, {13800,0.0217143}, {13900,0.0122571}, {14000,0.0218000}, {14100,0.0125714}, {14200,0.0125429}, {14300,0.0126000}, {14400,0.0127143}, {14500,0.0127714}, {14600,0.0128000}, {14700,0.0127429}, {14800,0.0130000}, {14900,0.0114571}, {15000,0.0132286}, {15100,0.0133429}, {15200,0.0116571}, {15300,0.0134000}, {15400,0.0134571}, {15500,0.0135714}, {15600,0.0137714}, {15700,0.0137143}, {15800,0.0137714}, {15900,0.0142571}, {16000,0.0122857}, {16100,0.0142857}, {16200,0.0142000}, {16300,0.0142571}, {16400,0.0143143}, {16500,0.0143143}, {16600,0.0144571}, {16700,0.0144000}, {16800,0.0145143}, {16900,0.0145714}, {17000,0.0148857}, {17100,0.0152571}, {17200,0.0151714}, {17300,0.0152571}, {17400,0.0152857}, {17500,0.0153143}, {17600,0.0153143}, {17700,0.0153714}, {17800,0.0154571}, {17900,0.0155429}, {18000,0.0136000}, {18100,0.0161143}, {18200,0.0160000}, {18300,0.0162571}, {18400,0.0163143}, {18500,0.0163714}, {18600,0.0162857}, {18700,0.0163429}, {18800,0.0163714}, {18900,0.0166000}, {19000,0.0165143}, {19100,0.0145429}, {19200,0.0232571}, {19300,0.0170857}, {19400,0.0172857}, {19500,0.0173429}, {19600,0.0542286}, {19700,0.0181143}, {19800,0.0173143}, {19900,0.0172857}, {20000,0.0152286}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["eval lazy"]["user"] = {{1,0.00003960}, {2,0.00003960}, {3,0.00000000}, {4,0.00000000}, {5,0.00005941}, {6,0.00000000}, {7,0.00003960}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00006931}, {15,0.00000000}, {16,0.00002970}, {17,0.00002970}, {18,0.00007921}, {19,0.00006931}, {20,0.00000000}, {21,0.00009901}, {22,0.00002970}, {23,0.00003960}, {24,0.00007921}, {25,0.00003960}, {26,0.00000000}, {27,0.00009901}, {28,0.00011881}, {29,0.00007921}, {30,0.00003960}, {31,0.00003960}, {32,0.00009901}, {33,0.00006931}, {34,0.00002970}, {35,0.00023762}, {36,0.00002970}, {37,0.00005941}, {38,0.00005941}, {39,0.00011881}, {40,0.00007921}, {41,0.00002970}, {42,0.00003960}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00002970}, {47,0.00015842}, {48,0.00003960}, {49,0.00010891}, {50,0.00000000}, {51,0.00000000}, {52,0.00006931}, {53,0.00000000}, {54,0.00006931}, {55,0.00003960}, {56,0.00010891}, {57,0.00003960}, {58,0.00002970}, {59,0.00007921}, {60,0.00014851}, {61,0.00000000}, {62,0.00014851}, {63,0.00008911}, {64,0.00006931}, {65,0.00003960}, {66,0.00000000}, {67,0.00005941}, {68,0.00006931}, {69,0.00017822}, {70,0.00009901}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00008911}, {75,0.00006931}, {76,0.00002970}, {77,0.00005941}, {78,0.00009901}, {79,0.00012871}, {80,0.00002970}, {81,0.00009901}, {82,0.00011881}, {83,0.00002970}, {84,0.00005941}, {85,0.00016832}, {86,0.00000000}, {87,0.00002970}, {88,0.00000000}, {89,0.00005941}, {90,0.00000000}, {91,0.00009901}, {92,0.00012871}, {93,0.00002970}, {94,0.00000000}, {95,0.00009901}, {96,0.00002970}, {97,0.00002970}, {98,0.00003960}, {99,0.00018812}, {100,0.00003960}, {101,0.00003960}, {102,0.00006931}, {103,0.00009901}, {104,0.00006931}, {105,0.00005941}, {106,0.00003960}, {107,0.00014851}, {108,0.00006931}, {109,0.00011881}, {110,0.00000000}, {111,0.00009901}, {112,0.00012871}, {113,0.00014851}, {114,0.00000000}, {115,0.00011881}, {116,0.00000000}, {117,0.00002970}, {118,0.00005941}, {119,0.00005941}, {120,0.00009901}, {121,0.00009901}, {122,0.00012871}, {123,0.00009901}, {124,0.00006931}, {125,0.00002970}, {126,0.00002970}, {127,0.00008911}, {128,0.00016832}, {129,0.00012871}, {130,0.00008911}, {131,0.00002970}, {132,0.00021782}, {133,0.00002970}, {134,0.00006931}, {135,0.00005941}, {136,0.00011881}, {137,0.00005941}, {138,0.00000000}, {139,0.00009901}, {140,0.00006931}, {141,0.00005941}, {142,0.00005941}, {143,0.00019802}, {144,0.00021782}, {145,0.00006931}, {146,0.00026733}, {147,0.00020792}, {148,0.00007921}, {149,0.00014851}, {150,0.00015842}, {151,0.00002970}, {152,0.00007921}, {153,0.00020792}, {154,0.00009901}, {155,0.00010891}, {156,0.00006931}, {157,0.00003960}, {158,0.00013861}, {159,0.00019802}, {160,0.00014851}, {161,0.00010891}, {162,0.00019802}, {163,0.00017822}, {164,0.00006931}, {165,0.00007921}, {166,0.00007921}, {167,0.00017822}, {168,0.00023762}, {169,0.00010891}, {170,0.00006931}, {171,0.00022772}, {172,0.00007921}, {173,0.00018812}, {174,0.00006931}, {175,0.00025743}, {176,0.00006931}, {177,0.00007921}, {178,0.00007921}, {179,0.00015842}, {180,0.00013861}, {181,0.00022772}, {182,0.00021782}, {183,0.00010891}, {184,0.00005941}, {185,0.00014851}, {186,0.00017822}, {187,0.00014851}, {188,0.00021782}, {189,0.00038614}, {190,0.00031683}, {191,0.00017822}, {192,0.00013861}, {193,0.00031683}, {194,0.00021782}, {195,0.00002970}, {196,0.00016832}, {197,0.00014851}, {198,0.00000000}, {199,0.00011881}, {200,0.00003960}, {201,0.00009901}, {202,0.00014851}, {203,0.00026733}, {204,0.00036634}, {205,0.00013861}, {206,0.00017822}, {207,0.00015842}, {208,0.00010891}, {209,0.00023762}, {210,0.00014851}, {211,0.00014851}, {212,0.00000000}, {213,0.00025743}, {214,0.00014851}, {215,0.00018812}, {216,0.00011881}, {217,0.00020792}, {218,0.00031683}, {219,0.00010891}, {220,0.00016832}, {221,0.00025743}, {222,0.00006931}, {223,0.00009901}, {224,0.00034653}, {225,0.00000000}, {226,0.00009901}, {227,0.00015842}, {228,0.00020792}, {229,0.00015842}, {230,0.00023762}, {231,0.00003960}, {232,0.00017822}, {233,0.00028713}, {234,0.00013861}, {235,0.00026733}, {236,0.00025743}, {237,0.00019802}, {238,0.00025743}, {239,0.00016832}, {240,0.00019802}, {241,0.00019802}, {242,0.00014851}, {243,0.00019802}, {244,0.00020792}, {245,0.00005941}, {246,0.00017822}, {247,0.00013861}, {248,0.00020792}, {249,0.00018812}, {250,0.00009901}, {251,0.00030693}, {252,0.00018812}, {253,0.00022772}, {254,0.00018812}, {255,0.00005941}, {256,0.00016832}, {257,0.00024752}, {258,0.00023762}, {259,0.00016832}, {260,0.00034653}, {261,0.00033663}, {262,0.00025743}, {263,0.00025743}, {264,0.00006931}, {265,0.00017822}, {266,0.00016832}, {267,0.00009901}, {268,0.00020792}, {269,0.00012871}, {270,0.00020792}, {271,0.00008911}, {272,0.00013861}, {273,0.00020792}, {274,0.00042574}, {275,0.00020792}, {276,0.00015842}, {277,0.00020792}, {278,0.00026733}, {279,0.00018812}, {280,0.00033663}, {281,0.00019802}, {282,0.00014851}, {283,0.00021782}, {284,0.00011881}, {285,0.00019802}, {286,0.00012871}, {287,0.00016832}, {288,0.00016832}, {289,0.00005941}, {290,0.00014851}, {291,0.00012871}, {292,0.00025743}, {293,0.00017822}, {294,0.00018812}, {295,0.00022772}, {296,0.00020792}, {297,0.00017822}, {298,0.00013861}, {299,0.00011881}, {300,0.00020792}, {301,0.00030693}, {302,0.00022772}, {303,0.00031683}, {304,0.00017822}, {305,0.00030693}, {306,0.00025743}, {307,0.00019802}, {308,0.00016832}, {309,0.00022772}, {310,0.00018812}, {311,0.00026733}, {312,0.00029703}, {313,0.00020792}, {314,0.00019802}, {315,0.00030693}, {316,0.00018812}, {317,0.00012871}, {318,0.00030693}, {319,0.00030693}, {320,0.00030693}, {321,0.00025743}, {322,0.00019802}, {323,0.00014851}, {324,0.00026733}, {325,0.00018812}, {326,0.00016832}, {327,0.00024752}, {328,0.00013861}, {329,0.00019802}, {330,0.00030693}, {331,0.00027723}, {332,0.00025743}, {333,0.00009901}, {334,0.00015842}, {335,0.00012871}, {336,0.00023762}, {337,0.00021782}, {338,0.00019802}, {339,0.00014851}, {340,0.00031683}, {341,0.00023762}, {342,0.00027723}, {343,0.00011881}, {344,0.00009901}, {345,0.00026733}, {346,0.00030693}, {347,0.00035644}, {348,0.00026733}, {349,0.00050495}, {350,0.00017822}, {351,0.00028713}, {352,0.00013861}, {353,0.00043564}, {354,0.00022772}, {355,0.00030693}, {356,0.00027723}, {357,0.00019802}, {358,0.00025743}, {359,0.00031683}, {360,0.00010891}, {361,0.00016832}, {362,0.00026733}, {363,0.00043564}, {364,0.00030693}, {365,0.00032673}, {366,0.00024752}, {367,0.00032673}, {368,0.00029703}, {369,0.00045545}, {370,0.00035644}, {371,0.00033663}, {372,0.00043564}, {373,0.00031683}, {374,0.00030693}, {375,0.00035644}, {376,0.00019802}, {377,0.00035644}, {378,0.00017822}, {379,0.00015842}, {380,0.00039604}, {381,0.00020792}, {382,0.00027723}, {383,0.00015842}, {384,0.00029703}, {385,0.00018812}, {386,0.00030693}, {387,0.00026733}, {388,0.00023762}, {389,0.00018812}, {390,0.00029703}, {391,0.00048515}, {392,0.00059406}, {393,0.00034653}, {394,0.00025743}, {395,0.00026733}, {396,0.00024752}, {397,0.00023762}, {398,0.00028713}, {399,0.00030693}, {400,0.00027723}, {401,0.00037624}, {402,0.00045545}, {403,0.00030693}, {404,0.00033663}, {405,0.00016832}, {406,0.00040594}, {407,0.00033663}, {408,0.00016832}, {409,0.00035644}, {410,0.00024752}, {411,0.00028713}, {412,0.00019802}, {413,0.00047525}, {414,0.00043564}, {415,0.00049505}, {416,0.00026733}, {417,0.00043564}, {418,0.00017822}, {419,0.00042574}, {420,0.00015842}, {421,0.00022772}, {422,0.00037624}, {423,0.00018812}, {424,0.00025743}, {425,0.00040594}, {426,0.00037624}, {427,0.00025743}, {428,0.00038614}, {429,0.00018812}, {430,0.00039604}, {431,0.00042574}, {432,0.00028713}, {433,0.00026733}, {434,0.00021782}, {435,0.00037624}, {436,0.00046535}, {437,0.00029703}, {438,0.00036634}, {439,0.00021782}, {440,0.00023762}, {441,0.00021782}, {442,0.00045545}, {443,0.00024752}, {444,0.00016832}, {445,0.00053465}, {446,0.00037624}, {447,0.00041584}, {448,0.00040594}, {449,0.00023762}, {450,0.00028713}, {451,0.00032673}, {452,0.00032673}, {453,0.00013861}, {454,0.00038614}, {455,0.00033663}, {456,0.00035644}, {457,0.00024752}, {458,0.00032673}, {459,0.00039604}, {460,0.00036634}, {461,0.00053465}, {462,0.00037624}, {463,0.00023762}, {464,0.00050495}, {465,0.00032673}, {466,0.00045545}, {467,0.00025743}, {468,0.00060396}, {469,0.00031683}, {470,0.00035644}, {471,0.00025743}, {472,0.00047525}, {473,0.00028713}, {474,0.00039604}, {475,0.00038614}, {476,0.00037624}, {477,0.00040594}, {478,0.00040594}, {479,0.00048515}, {480,0.00023762}, {481,0.00028713}, {482,0.00045545}, {483,0.00033663}, {484,0.00019802}, {485,0.00028713}, {486,0.00020792}, {487,0.00050495}, {488,0.00014851}, {489,0.00034653}, {490,0.00035644}, {491,0.00032673}, {492,0.00021782}, {493,0.00040594}, {494,0.00042574}, {495,0.00038614}, {496,0.00023762}, {497,0.00028713}, {498,0.00034653}, {499,0.00049505}, {500,0.00025743}, {505,0.00043564}, {510,0.00055446}, {515,0.00046535}, {520,0.00046535}, {525,0.00051485}, {530,0.00037624}, {535,0.00034653}, {540,0.00062376}, {545,0.00029703}, {550,0.00036634}, {555,0.00034653}, {560,0.00055446}, {565,0.00045545}, {570,0.00028713}, {575,0.00033663}, {580,0.00044554}, {585,0.00046535}, {590,0.00019802}, {595,0.00035644}, {600,0.00035644}, {605,0.00030693}, {610,0.00043564}, {615,0.00038614}, {620,0.00065347}, {625,0.00014851}, {630,0.00036634}, {635,0.00047525}, {640,0.00042574}, {645,0.00039604}, {650,0.00043564}, {655,0.00022772}, {660,0.00058416}, {665,0.00034653}, {670,0.00021782}, {675,0.00026733}, {680,0.00038614}, {685,0.00039604}, {690,0.00023762}, {695,0.00035644}, {700,0.00017822}, {705,0.00053465}, {710,0.00048515}, {715,0.00039604}, {720,0.00044554}, {725,0.00054455}, {730,0.00031683}, {735,0.00037624}, {740,0.00029703}, {745,0.00036634}, {750,0.00027723}, {755,0.00039604}, {760,0.00046535}, {765,0.00057426}, {770,0.00062376}, {775,0.00043564}, {780,0.00033663}, {785,0.00035644}, {790,0.00055446}, {795,0.00039604}, {800,0.00050495}, {805,0.00037624}, {810,0.00045545}, {815,0.00032673}, {820,0.00050495}, {825,0.00047525}, {830,0.00063366}, {835,0.00062376}, {840,0.00049505}, {845,0.00028713}, {850,0.00030693}, {855,0.00064356}, {860,0.00049505}, {865,0.00064356}, {870,0.00039604}, {875,0.00044554}, {880,0.00059406}, {885,0.00047525}, {890,0.00062376}, {895,0.00050495}, {900,0.00073267}, {905,0.00067327}, {910,0.00053465}, {915,0.00060396}, {920,0.00034653}, {925,0.00056436}, {930,0.00206931}, {935,0.00027723}, {940,0.00072277}, {945,0.00072277}, {950,0.00043564}, {955,0.00213861}, {960,0.00076238}, {965,0.00028713}, {970,0.00074257}, {975,0.00069307}, {980,0.00048515}, {985,0.00057426}, {990,0.00054455}, {995,0.00057426}, {1000,0.00045545}, {1010,0.00051485}, {1020,0.00049505}, {1030,0.00067327}, {1040,0.00046535}, {1050,0.00071287}, {1060,0.00044554}, {1070,0.00062376}, {1080,0.00056436}, {1090,0.00066337}, {1100,0.00080198}, {1110,0.00040594}, {1120,0.00068317}, {1130,0.00072277}, {1140,0.00056436}, {1150,0.00053465}, {1160,0.00071287}, {1170,0.00091089}, {1180,0.00056436}, {1190,0.00054455}, {1200,0.00073267}, {1210,0.00039604}, {1220,0.00051485}, {1230,0.00066337}, {1240,0.00050495}, {1250,0.00099010}, {1260,0.00082178}, {1270,0.00050495}, {1280,0.00077228}, {1290,0.00073267}, {1300,0.00035644}, {1310,0.00040594}, {1320,0.00065347}, {1330,0.00065347}, {1340,0.00095050}, {1350,0.00062376}, {1360,0.00073267}, {1370,0.00053465}, {1380,0.00077228}, {1390,0.00073267}, {1400,0.00077228}, {1410,0.00047525}, {1420,0.00062376}, {1430,0.00074257}, {1440,0.00070297}, {1450,0.00068317}, {1460,0.00072277}, {1470,0.00086139}, {1480,0.00097030}, {1490,0.00096040}, {1500,0.00072277}, {1510,0.00053465}, {1520,0.00088119}, {1530,0.00104950}, {1540,0.00092079}, {1550,0.00102970}, {1560,0.00111881}, {1570,0.00085149}, {1580,0.00121782}, {1590,0.00109901}, {1600,0.00127723}, {1610,0.00113861}, {1620,0.00096040}, {1630,0.00106931}, {1640,0.00102970}, {1650,0.00088119}, {1660,0.00084158}, {1670,0.00096040}, {1680,0.00073267}, {1690,0.00110891}, {1700,0.00079208}, {1710,0.00070297}, {1720,0.00106931}, {1730,0.00073267}, {1740,0.00102970}, {1750,0.00084158}, {1760,0.00083168}, {1770,0.00099010}, {1780,0.00077228}, {1790,0.00070297}, {1800,0.00104950}, {1810,0.00102970}, {1820,0.00099010}, {1830,0.00085149}, {1840,0.00091089}, {1850,0.00106931}, {1860,0.00092079}, {1870,0.00120792}, {1880,0.00109901}, {1890,0.00106931}, {1900,0.00099010}, {1910,0.00116832}, {1920,0.00110891}, {1930,0.00058416}, {1940,0.00114851}, {1950,0.00107921}, {1960,0.00104950}, {1970,0.00101980}, {1980,0.00138614}, {1990,0.00102970}, {2000,0.00122772}, {2050,0.00102970}, {2100,0.00131683}, {2150,0.00122772}, {2200,0.00110891}, {2250,0.00155446}, {2300,0.00135644}, {2350,0.00160396}, {2400,0.00133663}, {2450,0.00168317}, {2500,0.00159406}, {2550,0.00122772}, {2600,0.00127723}, {2650,0.00125743}, {2700,0.00114851}, {2750,0.00120792}, {2800,0.00151485}, {2850,0.00155446}, {2900,0.00160396}, {2950,0.00154455}, {3000,0.00165347}, {3050,0.00161386}, {3100,0.00160396}, {3150,0.00184158}, {3200,0.00176238}, {3250,0.00191089}, {3300,0.00187129}, {3350,0.00774257}, {3400,0.00172277}, {3450,0.00183168}, {3500,0.00209901}, {3550,0.00454455}, {3600,0.00186139}, {3650,0.00164356}, {3700,0.00225743}, {3750,0.00203960}, {3800,0.00220792}, {3850,0.00222772}, {3900,0.00199010}, {3950,0.00200990}, {4000,0.00209901}, {4050,0.00238614}, {4100,0.00427723}, {4150,0.00232673}, {4200,0.00224752}, {4250,0.00227723}, {4300,0.00223762}, {4350,0.00268317}, {4400,0.00263366}, {4450,0.00287129}, {4500,0.00243564}, {4550,0.00266337}, {4600,0.00292079}, {4650,0.00257426}, {4700,0.00266337}, {4750,0.00256436}, {4800,0.00269307}, {4850,0.00293069}, {4900,0.00264356}, {4950,0.00294059}, {5000,0.00299010}, {5050,0.00285149}, {5100,0.00283168}, {5150,0.00306931}, {5200,0.00288119}, {5250,0.00300000}, {5300,0.00786139}, {5350,0.00267327}, {5400,0.00316832}, {5450,0.00334653}, {5500,0.00300990}, {5550,0.00493069}, {5600,0.00342574}, {5650,0.00327723}, {5700,0.00320792}, {5750,0.00349505}, {5800,0.00318812}, {5850,0.00337624}, {5900,0.01326733}, {5950,0.00358416}, {6000,0.00736634}, {6050,0.0036857}, {6100,0.0046286}, {6150,0.0046857}, {6200,0.0046857}, {6250,0.0042571}, {6300,0.0041714}, {6350,0.0038571}, {6400,0.0047714}, {6450,0.0046571}, {6500,0.0045714}, {6550,0.0049143}, {6600,0.0048857}, {6650,0.0055143}, {6700,0.0054000}, {6750,0.0048571}, {6800,0.0051714}, {6850,0.0049714}, {6900,0.0052286}, {6950,0.0057429}, {7000,0.0051714}, {7050,0.0049429}, {7100,0.0054857}, {7150,0.0059143}, {7200,0.0054571}, {7250,0.0093429}, {7300,0.0055429}, {7350,0.0064286}, {7400,0.0057143}, {7450,0.0059143}, {7500,0.0199143}, {7550,0.0055714}, {7600,0.0063143}, {7650,0.0057429}, {7700,0.0060286}, {7750,0.0063429}, {7800,0.0064857}, {7850,0.0071429}, {7900,0.0062857}, {7950,0.0066286}, {8000,0.0066857}, {8050,0.0068571}, {8100,0.0063714}, {8150,0.0062571}, {8200,0.0070571}, {8250,0.0071143}, {8300,0.0066286}, {8350,0.0066000}, {8400,0.0109714}, {8450,0.0071143}, {8500,0.0072286}, {8550,0.0072000}, {8600,0.0072286}, {8650,0.0170000}, {8700,0.0073143}, {8750,0.0070571}, {8800,0.0077143}, {8850,0.0083429}, {8900,0.0080571}, {8950,0.0074857}, {9000,0.0082857}, {9050,0.0074286}, {9100,0.0079429}, {9150,0.0074571}, {9200,0.0236286}, {9250,0.0083429}, {9300,0.0079714}, {9350,0.0086571}, {9400,0.0082000}, {9450,0.0134286}, {9500,0.0085714}, {9550,0.0089143}, {9600,0.0080000}, {9650,0.0085714}, {9700,0.0075143}, {9750,0.0089429}, {9800,0.0087143}, {9850,0.0084571}, {9900,0.0092857}, {9950,0.0086000}, {10000,0.0092286}, {10100,0.0090571}, {10200,0.0186857}, {10300,0.0090000}, {10400,0.0090857}, {10500,0.0092571}, {10600,0.0092571}, {10700,0.0092000}, {10800,0.0120000}, {10900,0.0101429}, {11000,0.0093429}, {11100,0.0100857}, {11200,0.0095714}, {11300,0.0100286}, {11400,0.0104000}, {11500,0.0098286}, {11600,0.0101143}, {11700,0.0104286}, {11800,0.0108857}, {11900,0.0107429}, {12000,0.0107429}, {12100,0.0107714}, {12200,0.0106286}, {12300,0.0104286}, {12400,0.0105714}, {12500,0.0107143}, {12600,0.0106571}, {12700,0.0113143}, {12800,0.0108571}, {12900,0.0111429}, {13000,0.0110571}, {13100,0.0110857}, {13200,0.0155143}, {13300,0.0112857}, {13400,0.0119714}, {13500,0.0284857}, {13600,0.0119714}, {13700,0.0121429}, {13800,0.0216000}, {13900,0.0118857}, {14000,0.0217714}, {14100,0.0123429}, {14200,0.0125429}, {14300,0.0122857}, {14400,0.0129714}, {14500,0.0125143}, {14600,0.0128286}, {14700,0.0126000}, {14800,0.0124857}, {14900,0.0107143}, {15000,0.0128000}, {15100,0.0133143}, {15200,0.0109429}, {15300,0.0136000}, {15400,0.0135143}, {15500,0.0137143}, {15600,0.0134571}, {15700,0.0142000}, {15800,0.0143143}, {15900,0.0134000}, {16000,0.0123429}, {16100,0.0140571}, {16200,0.0138000}, {16300,0.0143714}, {16400,0.0146857}, {16500,0.0143429}, {16600,0.0142857}, {16700,0.0144857}, {16800,0.0143714}, {16900,0.0146286}, {17000,0.0155714}, {17100,0.0147714}, {17200,0.0154571}, {17300,0.0152571}, {17400,0.0157143}, {17500,0.0155429}, {17600,0.0154571}, {17700,0.0156000}, {17800,0.0155429}, {17900,0.0156000}, {18000,0.0136857}, {18100,0.0157143}, {18200,0.0159143}, {18300,0.0163429}, {18400,0.0167429}, {18500,0.0165143}, {18600,0.0167714}, {18700,0.0161429}, {18800,0.0162857}, {18900,0.0166000}, {19000,0.0167429}, {19100,0.0154286}, {19200,0.0235143}, {19300,0.0171714}, {19400,0.0172857}, {19500,0.0172857}, {19600,0.0547143}, {19700,0.0175143}, {19800,0.0170857}, {19900,0.0174286}, {20000,0.0154571}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00003960}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00003960}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00007921}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00003960}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00003960}, {287,0.00000000}, {288,0.00000000}, {289,0.00002970}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00007921}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00003960}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00003960}, {391,0.00003960}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00003960}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00003960}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003960}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00003960}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00003960}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00003960}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00003960}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00003960}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00003960}, {1240,0.00003960}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00003960}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00003960}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00003960}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00003960}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00003960}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00003960}, {1970,0.00003960}, {1980,0.00003960}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00002970}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00003960}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00003960}, {2900,0.00000000}, {2950,0.00003960}, {3000,0.00003960}, {3050,0.00000000}, {3100,0.00003960}, {3150,0.00003960}, {3200,0.00003960}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00003960}, {3450,0.00000000}, {3500,0.00003960}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00003960}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00003960}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00002970}, {4350,0.00000000}, {4400,0.00003960}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00003960}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00003960}, {5100,0.00000000}, {5150,0.00007921}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00003960}, {5350,0.00003960}, {5400,0.00003960}, {5450,0.00000000}, {5500,0.00007921}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00003960}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0002286}, {6100,0.0000000}, {6150,0.0001143}, {6200,0.0000000}, {6250,0.0001143}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0001143}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0001143}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0001143}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0001143}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0001143}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0003429}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0001143}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0001143}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0001143}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0003429}, {12400,0.0001143}, {12500,0.0000000}, {12600,0.0001143}, {12700,0.0000000}, {12800,0.0001143}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000857}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0003429}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0001143}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0001143}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0001143}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0001143}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0001143}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00100000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00184158}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000990}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000990}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00001980}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000990}, {2200,0.00308911}, {2250,0.00007921}, {2300,0.00010891}, {2350,0.00043564}, {2400,0.00047525}, {2450,0.00051485}, {2500,0.00072277}, {2550,0.00100000}, {2600,0.00100000}, {2650,0.00100000}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00100000}, {3150,0.00100000}, {3200,0.00100000}, {3250,0.00100000}, {3300,0.00100000}, {3350,0.00100000}, {3400,0.00100000}, {3450,0.00100000}, {3500,0.00100000}, {3550,0.00100000}, {3600,0.00100000}, {3650,0.00100000}, {3700,0.00100000}, {3750,0.00100000}, {3800,0.00100000}, {3850,0.00100000}, {3900,0.00100000}, {3950,0.00100000}, {4000,0.00100000}, {4050,0.00100000}, {4100,0.00100000}, {4150,0.00100000}, {4200,0.00100000}, {4250,0.00100000}, {4300,0.00100000}, {4350,0.00100000}, {4400,0.00101980}, {4450,0.00101980}, {4500,0.00102970}, {4550,0.00101980}, {4600,0.00108911}, {4650,0.00107921}, {4700,0.00131683}, {4750,0.00153465}, {4800,0.00159406}, {4850,0.00166337}, {4900,0.00167327}, {4950,0.00912871}, {5000,0.00171287}, {5050,0.00182178}, {5100,0.00191089}, {5150,0.00200000}, {5200,0.00200000}, {5250,0.00200000}, {5300,0.00200000}, {5350,0.00200000}, {5400,0.00200000}, {5450,0.00200000}, {5500,0.00200000}, {5550,0.00200000}, {5600,0.00200000}, {5650,0.00200000}, {5700,0.00200000}, {5750,0.00200000}, {5800,0.00200000}, {5850,0.00200000}, {5900,0.00200000}, {5950,0.00200000}, {6000,0.00200000}, {6050,0.0020286}, {6100,0.0020286}, {6150,0.0020571}, {6200,0.0020286}, {6250,0.0021429}, {6300,0.0022571}, {6350,0.0022571}, {6400,0.0022000}, {6450,0.0024000}, {6500,0.0023714}, {6550,0.0024286}, {6600,0.0142286}, {6650,0.0025143}, {6700,0.0026000}, {6750,0.0027714}, {6800,0.0028286}, {6850,0.0028286}, {6900,0.0028571}, {6950,0.0029143}, {7000,0.0028571}, {7050,0.0029143}, {7100,0.0029714}, {7150,0.0029714}, {7200,0.0030000}, {7250,0.0029714}, {7300,0.0030000}, {7350,0.0030000}, {7400,0.0030000}, {7450,0.0030000}, {7500,0.0030000}, {7550,0.0030000}, {7600,0.0030000}, {7650,0.0030286}, {7700,0.0030000}, {7750,0.0030286}, {7800,0.0030000}, {7850,0.0030000}, {7900,0.0030286}, {7950,0.0030286}, {8000,0.0030000}, {8050,0.0030286}, {8100,0.0030286}, {8150,0.0030571}, {8200,0.0030000}, {8250,0.0031429}, {8300,0.0032286}, {8350,0.0032286}, {8400,0.0032857}, {8450,0.0034571}, {8500,0.0033429}, {8550,0.0035714}, {8600,0.0036571}, {8650,0.0037714}, {8700,0.0037429}, {8750,0.0038000}, {8800,0.0038000}, {8850,0.0038000}, {8900,0.0156286}, {8950,0.0038000}, {9000,0.0038286}, {9050,0.0038000}, {9100,0.0038571}, {9150,0.0038857}, {9200,0.0039143}, {9250,0.0039714}, {9300,0.0039714}, {9350,0.0039429}, {9400,0.0039714}, {9450,0.0040000}, {9500,0.0040000}, {9550,0.0040000}, {9600,0.0040000}, {9650,0.0040000}, {9700,0.0040000}, {9750,0.0040000}, {9800,0.0040286}, {9850,0.0040000}, {9900,0.0040286}, {9950,0.0040000}, {10000,0.0040286}, {10100,0.0040286}, {10200,0.0041429}, {10300,0.0042571}, {10400,0.0043143}, {10500,0.0045429}, {10600,0.0046857}, {10700,0.0046000}, {10800,0.0047714}, {10900,0.0047714}, {11000,0.0047714}, {11100,0.0047714}, {11200,0.0048000}, {11300,0.0048286}, {11400,0.0048857}, {11500,0.0048857}, {11600,0.0049143}, {11700,0.0049714}, {11800,0.0050000}, {11900,0.0050000}, {12000,0.0050000}, {12100,0.0050286}, {12200,0.0051429}, {12300,0.0052286}, {12400,0.0053429}, {12500,0.0054857}, {12600,0.0055714}, {12700,0.0056571}, {12800,0.0057143}, {12900,0.0056857}, {13000,0.0057143}, {13100,0.0057429}, {13200,0.0057143}, {13300,0.0295714}, {13400,0.0056857}, {13500,0.0057714}, {13600,0.0057429}, {13700,0.0059143}, {13800,0.0060286}, {13900,0.0059714}, {14000,0.0060571}, {14100,0.0062000}, {14200,0.0061429}, {14300,0.0062286}, {14400,0.0064286}, {14500,0.0064571}, {14600,0.0064857}, {14700,0.0066571}, {14800,0.0066857}, {14900,0.0067143}, {15000,0.0067143}, {15100,0.0066857}, {15200,0.0066857}, {15300,0.0066857}, {15400,0.0244000}, {15500,0.0066857}, {15600,0.0066571}, {15700,0.0067143}, {15800,0.0066857}, {15900,0.0219714}, {16000,0.0069143}, {16100,0.0069429}, {16200,0.0070571}, {16300,0.0072000}, {16400,0.0072000}, {16500,0.0072857}, {16600,0.0074571}, {16700,0.0074286}, {16800,0.0076000}, {16900,0.0076000}, {17000,0.0076286}, {17100,0.0290000}, {17200,0.0076571}, {17300,0.0076571}, {17400,0.0076286}, {17500,0.0076857}, {17600,0.0076286}, {17700,0.0076571}, {17800,0.0076286}, {17900,0.0076857}, {18000,0.0077429}, {18100,0.0077714}, {18200,0.0078857}, {18300,0.0082000}, {18400,0.0082286}, {18500,0.0082000}, {18600,0.0084000}, {18700,0.0084857}, {18800,0.0086000}, {18900,0.0334571}, {19000,0.0086571}, {19100,0.0086571}, {19200,0.0086571}, {19300,0.0086571}, {19400,0.0087429}, {19500,0.0087143}, {19600,0.0086857}, {19700,0.0090286}, {19800,0.0086571}, {19900,0.0464571}, {20000,0.0086857}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00002970}, {4,0.00003960}, {5,0.00003960}, {6,0.00000000}, {7,0.00000000}, {8,0.00002970}, {9,0.00000000}, {10,0.00002970}, {11,0.00000000}, {12,0.00002970}, {13,0.00003960}, {14,0.00003960}, {15,0.00000000}, {16,0.00000000}, {17,0.00002970}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00006931}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00003960}, {28,0.00000000}, {29,0.00000000}, {30,0.00002970}, {31,0.00003960}, {32,0.00000000}, {33,0.00002970}, {34,0.00000000}, {35,0.00003960}, {36,0.00002970}, {37,0.00003960}, {38,0.00000000}, {39,0.00002970}, {40,0.00003960}, {41,0.00006931}, {42,0.00003960}, {43,0.00000000}, {44,0.00000000}, {45,0.00002970}, {46,0.00000000}, {47,0.00002970}, {48,0.00000000}, {49,0.00000000}, {50,0.00002970}, {51,0.00000000}, {52,0.00009901}, {53,0.00002970}, {54,0.00003960}, {55,0.00002970}, {56,0.00002970}, {57,0.00000000}, {58,0.00005941}, {59,0.00000000}, {60,0.00003960}, {61,0.00003960}, {62,0.00003960}, {63,0.00003960}, {64,0.00003960}, {65,0.00002970}, {66,0.00008911}, {67,0.00011881}, {68,0.00002970}, {69,0.00002970}, {70,0.00002970}, {71,0.00005941}, {72,0.00005941}, {73,0.00002970}, {74,0.00000000}, {75,0.00008911}, {76,0.00005941}, {77,0.00002970}, {78,0.00003960}, {79,0.00012871}, {80,0.00003960}, {81,0.00002970}, {82,0.00002970}, {83,0.00000000}, {84,0.00010891}, {85,0.00002970}, {86,0.00005941}, {87,0.00009901}, {88,0.00005941}, {89,0.00006931}, {90,0.00006931}, {91,0.00016832}, {92,0.00003960}, {93,0.00006931}, {94,0.00003960}, {95,0.00003960}, {96,0.00007921}, {97,0.00005941}, {98,0.00005941}, {99,0.00005941}, {100,0.00008911}, {101,0.00002970}, {102,0.00014851}, {103,0.00002970}, {104,0.00011881}, {105,0.00002970}, {106,0.00002970}, {107,0.00002970}, {108,0.00011881}, {109,0.00008911}, {110,0.00013861}, {111,0.00002970}, {112,0.00003960}, {113,0.00000000}, {114,0.00009901}, {115,0.00005941}, {116,0.00002970}, {117,0.00002970}, {118,0.00002970}, {119,0.00010891}, {120,0.00002970}, {121,0.00014851}, {122,0.00007921}, {123,0.00010891}, {124,0.00012871}, {125,0.00006931}, {126,0.00013861}, {127,0.00009901}, {128,0.00005941}, {129,0.00005941}, {130,0.00013861}, {131,0.00005941}, {132,0.00008911}, {133,0.00006931}, {134,0.00008911}, {135,0.00006931}, {136,0.00018812}, {137,0.00017822}, {138,0.00013861}, {139,0.00009901}, {140,0.00002970}, {141,0.00003960}, {142,0.00011881}, {143,0.00012871}, {144,0.00014851}, {145,0.00002970}, {146,0.00000000}, {147,0.00012871}, {148,0.00013861}, {149,0.00003960}, {150,0.00000000}, {151,0.00002970}, {152,0.00003960}, {153,0.00016832}, {154,0.00006931}, {155,0.00003960}, {156,0.00009901}, {157,0.00006931}, {158,0.00010891}, {159,0.00007921}, {160,0.00011881}, {161,0.00007921}, {162,0.00011881}, {163,0.00010891}, {164,0.00009901}, {165,0.00014851}, {166,0.00005941}, {167,0.00002970}, {168,0.00021782}, {169,0.00009901}, {170,0.00010891}, {171,0.00002970}, {172,0.00006931}, {173,0.00006931}, {174,0.00012871}, {175,0.00015842}, {176,0.00003960}, {177,0.00003960}, {178,0.00006931}, {179,0.00003960}, {180,0.00007921}, {181,0.00006931}, {182,0.00002970}, {183,0.00008911}, {184,0.00009901}, {185,0.00002970}, {186,0.00022772}, {187,0.00008911}, {188,0.00020792}, {189,0.00010891}, {190,0.00007921}, {191,0.00014851}, {192,0.00007921}, {193,0.00013861}, {194,0.00003960}, {195,0.00006931}, {196,0.00002970}, {197,0.00003960}, {198,0.00010891}, {199,0.00002970}, {200,0.00000000}, {201,0.00006931}, {202,0.00011881}, {203,0.00010891}, {204,0.00011881}, {205,0.00021782}, {206,0.00011881}, {207,0.00024752}, {208,0.00003960}, {209,0.00013861}, {210,0.00003960}, {211,0.00000000}, {212,0.00009901}, {213,0.00017822}, {214,0.00010891}, {215,0.00010891}, {216,0.00011881}, {217,0.00013861}, {218,0.00000000}, {219,0.00010891}, {220,0.00013861}, {221,0.00017822}, {222,0.00002970}, {223,0.00002970}, {224,0.00017822}, {225,0.00021782}, {226,0.00017822}, {227,0.00013861}, {228,0.00015842}, {229,0.00009901}, {230,0.00017822}, {231,0.00008911}, {232,0.00006931}, {233,0.00014851}, {234,0.00011881}, {235,0.00007921}, {236,0.00009901}, {237,0.00002970}, {238,0.00002970}, {239,0.00005941}, {240,0.00021782}, {241,0.00017822}, {242,0.00131683}, {243,0.00020792}, {244,0.00005941}, {245,0.00008911}, {246,0.00000000}, {247,0.00015842}, {248,0.00014851}, {249,0.00006931}, {250,0.00013861}, {251,0.00009901}, {252,0.00016832}, {253,0.00008911}, {254,0.00009901}, {255,0.00009901}, {256,0.00011881}, {257,0.00008911}, {258,0.00006931}, {259,0.00016832}, {260,0.00012871}, {261,0.00014851}, {262,0.00025743}, {263,0.00010891}, {264,0.00012871}, {265,0.00013861}, {266,0.00010891}, {267,0.00002970}, {268,0.00009901}, {269,0.00012871}, {270,0.00014851}, {271,0.00002970}, {272,0.00017822}, {273,0.00018812}, {274,0.00002970}, {275,0.00012871}, {276,0.00012871}, {277,0.00007921}, {278,0.00012871}, {279,0.00000000}, {280,0.00016832}, {281,0.00000000}, {282,0.00009901}, {283,0.00022772}, {284,0.00009901}, {285,0.00009901}, {286,0.00002970}, {287,0.00020792}, {288,0.00005941}, {289,0.00006931}, {290,0.00009901}, {291,0.00005941}, {292,0.00006931}, {293,0.00015842}, {294,0.00009901}, {295,0.00012871}, {296,0.00019802}, {297,0.00009901}, {298,0.00017822}, {299,0.00008911}, {300,0.00005941}, {301,0.00005941}, {302,0.00016832}, {303,0.00010891}, {304,0.00015842}, {305,0.00019802}, {306,0.00011881}, {307,0.00020792}, {308,0.00017822}, {309,0.00008911}, {310,0.00003960}, {311,0.00011881}, {312,0.00009901}, {313,0.00016832}, {314,0.00024752}, {315,0.00020792}, {316,0.00017822}, {317,0.00006931}, {318,0.00015842}, {319,0.00013861}, {320,0.00014851}, {321,0.00021782}, {322,0.00012871}, {323,0.00014851}, {324,0.00025743}, {325,0.00018812}, {326,0.00017822}, {327,0.00002970}, {328,0.00018812}, {329,0.00019802}, {330,0.00022772}, {331,0.00024752}, {332,0.00022772}, {333,0.00017822}, {334,0.00026733}, {335,0.00015842}, {336,0.00009901}, {337,0.00013861}, {338,0.00013861}, {339,0.00009901}, {340,0.00013861}, {341,0.00006931}, {342,0.00005941}, {343,0.00013861}, {344,0.00013861}, {345,0.00019802}, {346,0.00031683}, {347,0.00019802}, {348,0.00003960}, {349,0.00005941}, {350,0.00010891}, {351,0.00015842}, {352,0.00023762}, {353,0.00024752}, {354,0.00014851}, {355,0.00021782}, {356,0.00014851}, {357,0.00011881}, {358,0.00021782}, {359,0.00027723}, {360,0.00021782}, {361,0.00017822}, {362,0.00023762}, {363,0.00032673}, {364,0.00024752}, {365,0.00014851}, {366,0.00017822}, {367,0.00024752}, {368,0.00005941}, {369,0.00006931}, {370,0.00011881}, {371,0.00008911}, {372,0.00017822}, {373,0.00007921}, {374,0.00015842}, {375,0.00011881}, {376,0.00007921}, {377,0.00007921}, {378,0.00018812}, {379,0.00018812}, {380,0.00007921}, {381,0.00014851}, {382,0.00007921}, {383,0.00018812}, {384,0.00027723}, {385,0.00010891}, {386,0.00003960}, {387,0.00003960}, {388,0.00006931}, {389,0.00032673}, {390,0.00020792}, {391,0.00021782}, {392,0.00028713}, {393,0.00033663}, {394,0.00017822}, {395,0.00015842}, {396,0.00019802}, {397,0.00024752}, {398,0.00007921}, {399,0.00003960}, {400,0.00012871}, {401,0.00028713}, {402,0.00006931}, {403,0.00013861}, {404,0.00021782}, {405,0.00027723}, {406,0.00026733}, {407,0.00028713}, {408,0.00029703}, {409,0.00025743}, {410,0.00015842}, {411,0.00017822}, {412,0.00029703}, {413,0.00016832}, {414,0.00014851}, {415,0.00029703}, {416,0.00044554}, {417,0.00019802}, {418,0.00022772}, {419,0.00006931}, {420,0.00031683}, {421,0.00013861}, {422,0.00017822}, {423,0.00015842}, {424,0.00010891}, {425,0.00019802}, {426,0.00019802}, {427,0.00021782}, {428,0.00017822}, {429,0.00007921}, {430,0.00010891}, {431,0.00018812}, {432,0.00015842}, {433,0.00017822}, {434,0.00009901}, {435,0.00019802}, {436,0.00022772}, {437,0.00030693}, {438,0.00034653}, {439,0.00041584}, {440,0.00016832}, {441,0.00007921}, {442,0.00021782}, {443,0.00017822}, {444,0.00011881}, {445,0.00010891}, {446,0.00013861}, {447,0.00003960}, {448,0.00015842}, {449,0.00034653}, {450,0.00029703}, {451,0.00023762}, {452,0.00020792}, {453,0.00019802}, {454,0.00021782}, {455,0.00023762}, {456,0.00024752}, {457,0.00012871}, {458,0.00015842}, {459,0.00021782}, {460,0.00012871}, {461,0.00028713}, {462,0.00036634}, {463,0.00022772}, {464,0.00037624}, {465,0.00039604}, {466,0.00026733}, {467,0.00015842}, {468,0.00022772}, {469,0.00014851}, {470,0.00022772}, {471,0.00025743}, {472,0.00022772}, {473,0.00037624}, {474,0.00015842}, {475,0.00014851}, {476,0.00022772}, {477,0.00175248}, {478,0.00041584}, {479,0.00034653}, {480,0.00025743}, {481,0.00022772}, {482,0.00018812}, {483,0.00029703}, {484,0.00020792}, {485,0.00025743}, {486,0.00027723}, {487,0.00009901}, {488,0.00019802}, {489,0.00022772}, {490,0.00023762}, {491,0.00021782}, {492,0.00031683}, {493,0.00038614}, {494,0.00025743}, {495,0.00014851}, {496,0.00014851}, {497,0.00013861}, {498,0.00020792}, {499,0.00010891}, {500,0.00024752}, {505,0.00034653}, {510,0.00029703}, {515,0.00010891}, {520,0.00017822}, {525,0.00028713}, {530,0.00021782}, {535,0.00016832}, {540,0.00017822}, {545,0.00015842}, {550,0.00032673}, {555,0.00025743}, {560,0.00019802}, {565,0.00030693}, {570,0.00014851}, {575,0.00022772}, {580,0.00030693}, {585,0.00036634}, {590,0.00041584}, {595,0.00036634}, {600,0.00039604}, {605,0.00016832}, {610,0.00009901}, {615,0.00026733}, {620,0.00020792}, {625,0.00026733}, {630,0.00027723}, {635,0.00013861}, {640,0.00015842}, {645,0.00025743}, {650,0.00005941}, {655,0.00024752}, {660,0.00021782}, {665,0.00017822}, {670,0.00031683}, {675,0.00021782}, {680,0.00023762}, {685,0.00018812}, {690,0.00009901}, {695,0.00026733}, {700,0.00036634}, {705,0.00021782}, {710,0.00028713}, {715,0.00032673}, {720,0.00029703}, {725,0.00038614}, {730,0.00023762}, {735,0.00027723}, {740,0.00036634}, {745,0.00024752}, {750,0.00037624}, {755,0.00045545}, {760,0.00020792}, {765,0.00033663}, {770,0.00015842}, {775,0.00025743}, {780,0.00025743}, {785,0.00023762}, {790,0.00053465}, {795,0.00022772}, {800,0.00009901}, {805,0.00030693}, {810,0.00040594}, {815,0.00039604}, {820,0.00040594}, {825,0.00023762}, {830,0.00047525}, {835,0.00041584}, {840,0.00043564}, {845,0.00035644}, {850,0.00037624}, {855,0.00034653}, {860,0.00027723}, {865,0.00036634}, {870,0.00020792}, {875,0.00014851}, {880,0.00027723}, {885,0.00024752}, {890,0.00028713}, {895,0.00020792}, {900,0.00030693}, {905,0.00043564}, {910,0.00018812}, {915,0.00028713}, {920,0.00015842}, {925,0.00025743}, {930,0.00038614}, {935,0.00043564}, {940,0.00025743}, {945,0.00040594}, {950,0.00046535}, {955,0.00047525}, {960,0.00052475}, {965,0.00048515}, {970,0.00041584}, {975,0.00021782}, {980,0.00029703}, {985,0.00029703}, {990,0.00051485}, {995,0.00039604}, {1000,0.00060396}, {1010,0.00038614}, {1020,0.00034653}, {1030,0.00029703}, {1040,0.00069307}, {1050,0.00040594}, {1060,0.00038614}, {1070,0.00023762}, {1080,0.00026733}, {1090,0.00043564}, {1100,0.00014851}, {1110,0.00046535}, {1120,0.00033663}, {1130,0.00031683}, {1140,0.00045545}, {1150,0.00049505}, {1160,0.00044554}, {1170,0.00024752}, {1180,0.00040594}, {1190,0.00055446}, {1200,0.00043564}, {1210,0.00051485}, {1220,0.00041584}, {1230,0.00049505}, {1240,0.00061386}, {1250,0.00041584}, {1260,0.00051485}, {1270,0.00068317}, {1280,0.00042574}, {1290,0.00052475}, {1300,0.00061386}, {1310,0.00062376}, {1320,0.00063366}, {1330,0.00051485}, {1340,0.00050495}, {1350,0.00054455}, {1360,0.00029703}, {1370,0.00084158}, {1380,0.00045545}, {1390,0.00043564}, {1400,0.00054455}, {1410,0.00049505}, {1420,0.00059406}, {1430,0.00062376}, {1440,0.00067327}, {1450,0.00060396}, {1460,0.00049505}, {1470,0.00077228}, {1480,0.00073267}, {1490,0.00041584}, {1500,0.00068317}, {1510,0.00062376}, {1520,0.00057426}, {1530,0.00061386}, {1540,0.00073267}, {1550,0.00035644}, {1560,0.00037624}, {1570,0.00050495}, {1580,0.00041584}, {1590,0.00069307}, {1600,0.00052475}, {1610,0.00046535}, {1620,0.00080198}, {1630,0.00060396}, {1640,0.00068317}, {1650,0.00062376}, {1660,0.00043564}, {1670,0.00074257}, {1680,0.00074257}, {1690,0.00053465}, {1700,0.00056436}, {1710,0.00076238}, {1720,0.00058416}, {1730,0.00063366}, {1740,0.00089109}, {1750,0.00071287}, {1760,0.00071287}, {1770,0.00061386}, {1780,0.00063366}, {1790,0.00097030}, {1800,0.00045545}, {1810,0.00059406}, {1820,0.00070297}, {1830,0.00074257}, {1840,0.00065347}, {1850,0.00089109}, {1860,0.00086139}, {1870,0.00076238}, {1880,0.00047525}, {1890,0.00073267}, {1900,0.00100000}, {1910,0.00083168}, {1920,0.00073267}, {1930,0.00076238}, {1940,0.00078218}, {1950,0.00070297}, {1960,0.00066337}, {1970,0.00056436}, {1980,0.00075248}, {1990,0.00058416}, {2000,0.00068317}, {2050,0.00102970}, {2100,0.00062376}, {2150,0.00089109}, {2200,0.00317822}, {2250,0.00070297}, {2300,0.00063366}, {2350,0.00081188}, {2400,0.00109901}, {2450,0.00070297}, {2500,0.00067327}, {2550,0.00087129}, {2600,0.00116832}, {2650,0.00096040}, {2700,0.00119802}, {2750,0.00138614}, {2800,0.00094059}, {2850,0.00120792}, {2900,0.00110891}, {2950,0.00124752}, {3000,0.00099010}, {3050,0.00108911}, {3100,0.00105941}, {3150,0.00093069}, {3200,0.00118812}, {3250,0.00116832}, {3300,0.00114851}, {3350,0.00138614}, {3400,0.00148515}, {3450,0.00122772}, {3500,0.00108911}, {3550,0.00115842}, {3600,0.00173267}, {3650,0.00161386}, {3700,0.00105941}, {3750,0.00136634}, {3800,0.00136634}, {3850,0.00134653}, {3900,0.00153465}, {3950,0.00168317}, {4000,0.00162376}, {4050,0.00146535}, {4100,0.00156436}, {4150,0.00153465}, {4200,0.00159406}, {4250,0.00158416}, {4300,0.00173267}, {4350,0.00151485}, {4400,0.00161386}, {4450,0.00138614}, {4500,0.00204950}, {4550,0.00176238}, {4600,0.00170297}, {4650,0.00188119}, {4700,0.00197030}, {4750,0.00194059}, {4800,0.00213861}, {4850,0.00183168}, {4900,0.00204950}, {4950,0.00921782}, {5000,0.00193069}, {5050,0.00202970}, {5100,0.00187129}, {5150,0.00200000}, {5200,0.00214851}, {5250,0.00198020}, {5300,0.00200000}, {5350,0.00224752}, {5400,0.00208911}, {5450,0.00185149}, {5500,0.00212871}, {5550,0.00218812}, {5600,0.00211881}, {5650,0.00206931}, {5700,0.00258416}, {5750,0.00171287}, {5800,0.00247525}, {5850,0.00246535}, {5900,0.00238614}, {5950,0.00215842}, {6000,0.00248515}, {6050,0.0028000}, {6100,0.0021429}, {6150,0.0017714}, {6200,0.0018286}, {6250,0.0022000}, {6300,0.0025714}, {6350,0.0031143}, {6400,0.0022571}, {6450,0.0028286}, {6500,0.0028857}, {6550,0.0028286}, {6600,0.0142000}, {6650,0.0025429}, {6700,0.0028286}, {6750,0.0026000}, {6800,0.0028286}, {6850,0.0025143}, {6900,0.0027714}, {6950,0.0022857}, {7000,0.0026286}, {7050,0.0026286}, {7100,0.0026000}, {7150,0.0030000}, {7200,0.0025714}, {7250,0.0026571}, {7300,0.0024857}, {7350,0.0025143}, {7400,0.0027143}, {7450,0.0028571}, {7500,0.0031429}, {7550,0.0032286}, {7600,0.0032571}, {7650,0.0031143}, {7700,0.0031429}, {7750,0.0031714}, {7800,0.0026857}, {7850,0.0028000}, {7900,0.0035429}, {7950,0.0032571}, {8000,0.0035429}, {8050,0.0036857}, {8100,0.0034857}, {8150,0.0035714}, {8200,0.0035429}, {8250,0.0034000}, {8300,0.0034571}, {8350,0.0033429}, {8400,0.0036000}, {8450,0.0037714}, {8500,0.0035143}, {8550,0.0036571}, {8600,0.0037143}, {8650,0.0036286}, {8700,0.0038571}, {8750,0.0036000}, {8800,0.0034857}, {8850,0.0041143}, {8900,0.0157714}, {8950,0.0038857}, {9000,0.0039714}, {9050,0.0038571}, {9100,0.0042000}, {9150,0.0040571}, {9200,0.0041429}, {9250,0.0046286}, {9300,0.0040286}, {9350,0.0040286}, {9400,0.0044571}, {9450,0.0042857}, {9500,0.0041429}, {9550,0.0044571}, {9600,0.0048857}, {9650,0.0042571}, {9700,0.0045429}, {9750,0.0044857}, {9800,0.0046857}, {9850,0.0045143}, {9900,0.0042857}, {9950,0.0048857}, {10000,0.0043429}, {10100,0.0043143}, {10200,0.0044000}, {10300,0.0046000}, {10400,0.0048571}, {10500,0.0047714}, {10600,0.0049143}, {10700,0.0050286}, {10800,0.0051143}, {10900,0.0046000}, {11000,0.0053714}, {11100,0.0048286}, {11200,0.0052286}, {11300,0.0048857}, {11400,0.0048286}, {11500,0.0056857}, {11600,0.0053429}, {11700,0.0048000}, {11800,0.0046000}, {11900,0.0052857}, {12000,0.0050000}, {12100,0.0054571}, {12200,0.0051429}, {12300,0.0050857}, {12400,0.0052000}, {12500,0.0056286}, {12600,0.0059143}, {12700,0.0054571}, {12800,0.0052571}, {12900,0.0054571}, {13000,0.0053143}, {13100,0.0061429}, {13200,0.0059143}, {13300,0.0295429}, {13400,0.0059143}, {13500,0.0056286}, {13600,0.0056857}, {13700,0.0054571}, {13800,0.0065714}, {13900,0.0060286}, {14000,0.0059429}, {14100,0.0062857}, {14200,0.0060286}, {14300,0.0069143}, {14400,0.0066857}, {14500,0.0068286}, {14600,0.0064571}, {14700,0.0063429}, {14800,0.0069143}, {14900,0.0073143}, {15000,0.0068857}, {15100,0.0067714}, {15200,0.0071143}, {15300,0.0060000}, {15400,0.0246286}, {15500,0.0071143}, {15600,0.0074571}, {15700,0.0070286}, {15800,0.0068571}, {15900,0.0221714}, {16000,0.0071429}, {16100,0.0075143}, {16200,0.0076000}, {16300,0.0072571}, {16400,0.0072000}, {16500,0.0074857}, {16600,0.0073143}, {16700,0.0074286}, {16800,0.0077714}, {16900,0.0079429}, {17000,0.0076286}, {17100,0.0288286}, {17200,0.0077429}, {17300,0.0078000}, {17400,0.0082286}, {17500,0.0083143}, {17600,0.0083143}, {17700,0.0076857}, {17800,0.0079429}, {17900,0.0077714}, {18000,0.0080857}, {18100,0.0085429}, {18200,0.0081714}, {18300,0.0078000}, {18400,0.0078286}, {18500,0.0080857}, {18600,0.0081714}, {18700,0.0085143}, {18800,0.0079714}, {18900,0.0338000}, {19000,0.0084857}, {19100,0.0088857}, {19200,0.0081714}, {19300,0.0080857}, {19400,0.0084000}, {19500,0.0082857}, {19600,0.0082286}, {19700,0.0087143}, {19800,0.0090000}, {19900,0.0457143}, {20000,0.0087143}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00003960}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00003960}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00003960}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00003960}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00003960}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00003960}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00002970}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00002970}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00003960}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00003960}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00003960}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00003960}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00003960}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00003960}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00003960}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00003960}, {675,0.00000000}, {680,0.00003960}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00003960}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00003960}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00003960}, {1410,0.00003960}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00007921}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00003960}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00003960}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00003960}, {2200,0.00000000}, {2250,0.00003960}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00002970}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00003960}, {3050,0.00000000}, {3100,0.00002970}, {3150,0.00007921}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00003960}, {3350,0.00000000}, {3400,0.00003960}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00003960}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00003960}, {4250,0.00000000}, {4300,0.00003960}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00007921}, {4500,0.00000000}, {4550,0.00003960}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00007921}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00003960}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00003960}, {5250,0.00003960}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00003960}, {5450,0.00000000}, {5500,0.00003960}, {5550,0.00003960}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00003960}, {6000,0.00000000}, {6050,0.0000857}, {6100,0.0001143}, {6150,0.0000000}, {6200,0.0001143}, {6250,0.0001143}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0001143}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0001143}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0001143}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0001143}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0001143}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0002000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0001143}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0001143}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0001143}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0001143}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0001143}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00045545}, {8,0.00798020}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00103960}, {15,0.00138614}, {16,0.00200000}, {17,0.00200000}, {18,0.00200000}, {19,0.00200000}, {20,0.00200000}, {21,0.00202970}, {22,0.00221782}, {23,0.00243564}, {24,0.00297030}, {25,0.00300000}, {26,0.00300000}, {27,0.00300000}, {28,0.00300990}, {29,0.00305941}, {30,0.00317822}, {31,0.00364356}, {32,0.00381188}, {33,0.00400000}, {34,0.00400000}, {35,0.00400000}, {36,0.00400990}, {37,0.00425743}, {38,0.00420792}, {39,0.00446535}, {40,0.00465347}, {41,0.00500000}, {42,0.00500000}, {43,0.00500000}, {44,0.00508911}, {45,0.00526733}, {46,0.00519802}, {47,0.00550495}, {48,0.00556436}, {49,0.00767327}, {50,0.00600000}, {51,0.00600990}, {52,0.00608911}, {53,0.00621782}, {54,0.00644554}, {55,0.00639604}, {56,0.00776238}, {57,0.00695050}, {58,0.00700990}, {59,0.00708911}, {60,0.00728713}, {61,0.00723762}, {62,0.00726733}, {63,0.00744554}, {64,0.00740594}, {65,0.00795050}, {66,0.00802970}, {67,0.00807921}, {68,0.00820792}, {69,0.00824752}, {70,0.00821782}, {71,0.00839604}, {72,0.00928713}, {73,0.00882178}, {74,0.00902970}, {75,0.00919802}, {76,0.00913861}, {77,0.01113861}, {78,0.00918812}, {79,0.00942574}, {80,0.00935644}, {81,0.00979208}, {82,0.01000990}, {83,0.01007921}, {84,0.01334653}, {85,0.01030693}, {86,0.01016832}, {87,0.01039604}, {88,0.01035644}, {89,0.01087129}, {90,0.01100990}, {91,0.01110891}, {92,0.01117822}, {93,0.01119802}, {94,0.01124752}, {95,0.01135644}, {96,0.01128713}, {97,0.01171287}, {98,0.01200000}, {99,0.01224752}, {100,0.01222772}, {101,0.01223762}, {102,0.01221782}, {103,0.01241584}, {104,0.01257426}, {105,0.01270297}, {106,0.01288119}, {107,0.01799010}, {108,0.01437624}, {109,0.01314851}, {110,0.01321782}, {111,0.01345545}, {112,0.01358416}, {113,0.01378218}, {114,0.01805941}, {115,0.01409901}, {116,0.01421782}, {117,0.01419802}, {118,0.01442574}, {119,0.01805941}, {120,0.01439604}, {121,0.01472277}, {122,0.01484158}, {123,0.01855446}, {124,0.01512871}, {125,0.01526733}, {126,0.01530693}, {127,0.01532673}, {128,0.01547525}, {129,0.01590099}, {130,0.01566337}, {131,0.01610891}, {132,0.01621782}, {133,0.01618812}, {134,0.01638614}, {135,0.02176238}, {136,0.01644554}, {137,0.01670297}, {138,0.01667327}, {139,0.01710891}, {140,0.02075248}, {141,0.01726733}, {142,0.01751485}, {143,0.01760396}, {144,0.01769307}, {145,0.01763366}, {146,0.01785149}, {147,0.01807921}, {148,0.01831683}, {149,0.01820792}, {150,0.01836634}, {151,0.01882178}, {152,0.02389109}, {153,0.01876238}, {154,0.02046535}, {155,0.01917822}, {156,0.01923762}, {157,0.01959406}, {158,0.01954455}, {159,0.02138614}, {160,0.01964356}, {161,0.01975248}, {162,0.02377228}, {163,0.02007921}, {164,0.02015842}, {165,0.02428713}, {166,0.02035644}, {167,0.02063366}, {168,0.02222772}, {169,0.02074257}, {170,0.02081188}, {171,0.02111881}, {172,0.02446535}, {173,0.02136634}, {174,0.02158416}, {175,0.02149505}, {176,0.02293069}, {177,0.03208911}, {178,0.02184158}, {179,0.02208911}, {180,0.02205941}, {181,0.02227723}, {182,0.02622772}, {183,0.03007921}, {184,0.02259406}, {185,0.02269307}, {186,0.02268317}, {187,0.02317822}, {188,0.02306931}, {189,0.02339604}, {190,0.02342574}, {191,0.02554455}, {192,0.02671287}, {193,0.02840594}, {194,0.02972277}, {195,0.03053465}, {196,0.03117822}, {197,0.03167327}, {198,0.03159406}, {199,0.03134653}, {200,0.03088119}, {201,0.02988119}, {202,0.02903960}, {203,0.02798020}, {204,0.02636634}, {205,0.02515842}, {206,0.02541584}, {207,0.02566337}, {208,0.02563366}, {209,0.02579208}, {210,0.02562376}, {211,0.02604950}, {212,0.03349505}, {213,0.02835644}, {214,0.02637624}, {215,0.02656436}, {216,0.02660396}, {217,0.02681188}, {218,0.03070297}, {219,0.02688119}, {220,0.02701980}, {221,0.02740594}, {222,0.03411881}, {223,0.02747525}, {224,0.02757426}, {225,0.02751485}, {226,0.03282178}, {227,0.02797030}, {228,0.02794059}, {229,0.03489109}, {230,0.02844554}, {231,0.02873267}, {232,0.03627723}, {233,0.02858416}, {234,0.02891089}, {235,0.03495050}, {236,0.02906931}, {237,0.02954455}, {238,0.03096040}, {239,0.02965347}, {240,0.03538614}, {241,0.02974257}, {242,0.02983168}, {243,0.03002970}, {244,0.03000990}, {245,0.03052475}, {246,0.03051485}, {247,0.03139604}, {248,0.03055446}, {249,0.03187129}, {250,0.03135644}, {251,0.03119802}, {252,0.03162376}, {253,0.03149505}, {254,0.04078218}, {255,0.03177228}, {256,0.03679208}, {257,0.03175248}, {258,0.03178218}, {259,0.03209901}, {260,0.03188119}, {261,0.03771287}, {262,0.03245545}, {263,0.03237624}, {264,0.03986139}, {265,0.03263366}, {266,0.03269307}, {267,0.03969307}, {268,0.03339604}, {269,0.03348515}, {270,0.03876238}, {271,0.03564356}, {272,0.03374257}, {273,0.03371287}, {274,0.04072277}, {275,0.03444554}, {276,0.03424752}, {277,0.03423762}, {278,0.03723762}, {279,0.04265347}, {280,0.03475248}, {281,0.03500990}, {282,0.03486139}, {283,0.03523762}, {284,0.03868317}, {285,0.04247525}, {286,0.04591089}, {287,0.03600000}, {288,0.03593069}, {289,0.03580198}, {290,0.03607921}, {291,0.03633663}, {292,0.03620792}, {293,0.03637624}, {294,0.03891089}, {295,0.03976238}, {296,0.04044554}, {297,0.04101980}, {298,0.04149505}, {299,0.04170297}, {300,0.04039604}, {301,0.04097030}, {302,0.04200000}, {303,0.04097030}, {304,0.03774257}, {305,0.03778218}, {306,0.03800990}, {307,0.03834653}, {308,0.03833663}, {309,0.03847525}, {310,0.03886139}, {311,0.05000000}, {312,0.04625743}, {313,0.04144554}, {314,0.03936634}, {315,0.03952475}, {316,0.03955446}, {317,0.05224752}, {318,0.04684158}, {319,0.04177228}, {320,0.03942574}, {321,0.04004950}, {322,0.04998020}, {323,0.04485149}, {324,0.03995050}, {325,0.04062376}, {326,0.05044554}, {327,0.04465347}, {328,0.04052475}, {329,0.04122772}, {330,0.04800990}, {331,0.04119802}, {332,0.04147525}, {333,0.05217822}, {334,0.04154455}, {335,0.04223762}, {336,0.04808911}, {337,0.04192079}, {338,0.05547525}, {339,0.04471287}, {340,0.04199010}, {341,0.04975248}, {342,0.04242574}, {343,0.05328713}, {344,0.04248515}, {345,0.05618812}, {346,0.04430693}, {347,0.04337624}, {348,0.04540594}, {349,0.04371287}, {350,0.04554455}, {351,0.04403960}, {352,0.04343564}, {353,0.05587129}, {354,0.04391089}, {355,0.05355446}, {356,0.04421782}, {357,0.05400000}, {358,0.04471287}, {359,0.04792079}, {360,0.05834653}, {361,0.04506931}, {362,0.05228713}, {363,0.04532673}, {364,0.04516832}, {365,0.05385149}, {366,0.04551485}, {367,0.04626733}, {368,0.05277228}, {369,0.04601980}, {370,0.04608911}, {371,0.05092079}, {372,0.05735644}, {373,0.04685149}, {374,0.04681188}, {375,0.05229703}, {376,0.05779208}, {377,0.04742574}, {378,0.04706931}, {379,0.05045545}, {380,0.05831683}, {381,0.06475248}, {382,0.04783168}, {383,0.04789109}, {384,0.04752475}, {385,0.05151485}, {386,0.05635644}, {387,0.05912871}, {388,0.06278218}, {389,0.04848515}, {390,0.04868317}, {391,0.04878218}, {392,0.04882178}, {393,0.05010891}, {394,0.05172277}, {395,0.05313861}, {396,0.05399010}, {397,0.05521782}, {398,0.05558416}, {399,0.05962376}, {400,0.05867327}, {401,0.05725743}, {402,0.05696040}, {403,0.05690099}, {404,0.05541584}, {405,0.05466337}, {406,0.05322772}, {407,0.05212871}, {408,0.05072277}, {409,0.05136634}, {410,0.05137624}, {411,0.05158416}, {412,0.06395050}, {413,0.06140594}, {414,0.05837624}, {415,0.05578218}, {416,0.05177228}, {417,0.05232673}, {418,0.05215842}, {419,0.06494059}, {420,0.05933663}, {421,0.05436634}, {422,0.05270297}, {423,0.06887129}, {424,0.06298020}, {425,0.05688119}, {426,0.05342574}, {427,0.06861386}, {428,0.06177228}, {429,0.05519802}, {430,0.05369307}, {431,0.06467327}, {432,0.05700990}, {433,0.05399010}, {434,0.07128713}, {435,0.05890099}, {436,0.05470297}, {437,0.06634653}, {438,0.05633663}, {439,0.07179208}, {440,0.06132673}, {441,0.05500990}, {442,0.06604950}, {443,0.05628713}, {444,0.06880198}, {445,0.05861386}, {446,0.07110891}, {447,0.06034653}, {448,0.05582178}, {449,0.06088119}, {450,0.05597030}, {451,0.06505941}, {452,0.05662376}, {453,0.06293069}, {454,0.05691089}, {455,0.06148515}, {456,0.07128713}, {457,0.05882178}, {458,0.06984158}, {459,0.05741584}, {460,0.06535644}, {461,0.05750495}, {462,0.06006931}, {463,0.06935644}, {464,0.05783168}, {465,0.06299010}, {466,0.07283168}, {467,0.05885149}, {468,0.06572277}, {469,0.07387129}, {470,0.05859406}, {471,0.06368317}, {472,0.07043564}, {473,0.05973267}, {474,0.05961386}, {475,0.06550495}, {476,0.07095050}, {477,0.05988119}, {478,0.06009901}, {479,0.06367327}, {480,0.07040594}, {481,0.07998020}, {482,0.06037624}, {483,0.06059406}, {484,0.06369307}, {485,0.06924752}, {486,0.07213861}, {487,0.07525743}, {488,0.07704950}, {489,0.06125743}, {490,0.06114851}, {491,0.06237624}, {492,0.06430693}, {493,0.06758416}, {494,0.07132673}, {495,0.07135644}, {496,0.07197030}, {497,0.07394059}, {498,0.07357426}, {499,0.07472277}, {500,0.07390099}, {505,0.07396040}, {510,0.07250495}, {515,0.06980198}, {520,0.06639604}, {525,0.06617822}, {530,0.08674257}, {535,0.07609901}, {540,0.06733663}, {545,0.08044554}, {550,0.06868317}, {555,0.08236634}, {560,0.06986139}, {565,0.07878218}, {570,0.08708911}, {575,0.07260396}, {580,0.07872277}, {585,0.08468317}, {590,0.08737624}, {595,0.08921782}, {600,0.09044554}, {605,0.08990099}, {610,0.08878218}, {615,0.08701980}, {620,0.08726733}, {625,0.08087129}, {630,0.09939604}, {635,0.09132673}, {640,0.08274257}, {645,0.09700000}, {650,0.08740594}, {655,0.09905941}, {660,0.08730693}, {665,0.10210891}, {670,0.10814851}, {675,0.09048515}, {680,0.09570297}, {685,0.10082178}, {690,0.10461386}, {695,0.10728713}, {700,0.11826733}, {705,0.11196040}, {710,0.11118812}, {715,0.10756436}, {720,0.10385149}, {725,0.10129703}, {730,0.09843564}, {735,0.11496040}, {740,0.10685149}, {745,0.12020792}, {750,0.10922772}, {755,0.11990099}, {760,0.11433663}, {765,0.12127723}, {770,0.10413861}, {775,0.11137624}, {780,0.11790099}, {785,0.12246535}, {790,0.10787129}, {795,0.10977228}, {800,0.11047525}, {805,0.11101980}, {810,0.11109901}, {815,0.11378218}, {820,0.13307921}, {825,0.12750495}, {830,0.12004950}, {835,0.11391089}, {840,0.12752475}, {845,0.12440594}, {850,0.13756436}, {855,0.12421782}, {860,0.13426733}, {865,0.12906931}, {870,0.13540594}, {875,0.14123762}, {880,0.12254455}, {885,0.12816832}, {890,0.13557426}, {895,0.13516832}, {900,0.13559406}, {905,0.13556436}, {910,0.13483168}, {915,0.14199010}, {920,0.13023762}, {925,0.12899010}, {930,0.12584158}, {935,0.15263366}, {940,0.13642574}, {945,0.15094059}, {950,0.13897030}, {955,0.13099010}, {960,0.14434653}, {965,0.14431683}, {970,0.13674257}, {975,0.14396040}, {980,0.15594059}, {985,0.13498020}, {990,0.13786139}, {995,0.14100990}, {1000,0.14544554}, {1010,0.14551485}, {1020,0.14277228}, {1030,0.16010891}, {1040,0.16002970}, {1050,0.15096040}, {1060,0.16035644}, {1070,0.15833663}, {1080,0.16082178}, {1090,0.16269307}, {1100,0.16695050}, {1110,0.17318812}, {1120,0.16924752}, {1130,0.16440594}, {1140,0.16233663}, {1150,0.17630693}, {1160,0.16300000}, {1170,0.18892079}, {1180,0.18582178}, {1190,0.16715842}, {1200,0.17703960}, {1210,0.16603960}, {1220,0.16991089}, {1230,0.20665347}, {1240,0.18754455}, {1250,0.17695050}, {1260,0.19502970}, {1270,0.20279208}, {1280,0.18354455}, {1290,0.19619802}, {1300,0.19604950}, {1310,0.19668317}, {1320,0.19584158}, {1330,0.19372277}, {1340,0.20166337}, {1350,0.20785149}, {1360,0.19500990}, {1370,0.21262376}, {1380,0.21347525}, {1390,0.19161386}, {1400,0.20293069}, {1410,0.20147525}, {1420,0.20694059}, {1430,0.22220792}, {1440,0.23483168}, {1450,0.21454455}, {1460,0.22247525}, {1470,0.21820792}, {1480,0.21779208}, {1490,0.23325743}, {1500,0.23007921}, {1510,0.23857426}, {1520,0.23415842}, {1530,0.22624752}, {1540,0.22744554}, {1550,0.23710891}, {1560,0.23615842}, {1570,0.23930693}, {1580,0.23813861}, {1590,0.23380198}, {1600,0.25753465}, {1610,0.24219802}, {1620,0.25883168}, {1630,0.24080198}, {1640,0.25034653}, {1650,0.25271287}, {1660,0.26034653}, {1670,0.25346535}, {1680,0.24619802}, {1690,0.24949505}, {1700,0.25561386}, {1710,0.25618812}, {1720,0.27225743}, {1730,0.25080198}, {1740,0.27844554}, {1750,0.26083168}, {1760,0.25917822}, {1770,0.26334653}, {1780,0.28161386}, {1790,0.27745545}, {1800,0.26410891}, {1810,0.26267327}, {1820,0.26844554}, {1830,0.26268317}, {1840,0.27863366}, {1850,0.28521782}, {1860,0.28639604}, {1870,0.28072277}, {1880,0.28535644}, {1890,0.29964356}, {1900,0.29568317}, {1910,0.27790099}, {1920,0.28423762}, {1930,0.29667327}, {1940,0.29900000}, {1950,0.31099010}, {1960,0.29877228}, {1970,0.29721782}, {1980,0.29689109}, {1990,0.30741584}, {2000,0.33031683}, {2050,0.30952475}, {2100,0.30964356}, {2150,0.34150495}, {2200,0.32038614}, {2250,0.34728713}, {2300,0.38758416}, {2350,0.35661386}, {2400,0.37047525}, {2450,0.37846535}, {2500,0.39933663}, {2550,0.42212871}, {2600,0.39939604}, {2650,0.40415842}, {2700,0.41698020}, {2750,0.42932673}, {2800,0.43280198}, {2850,0.44951485}, {2900,0.46424752}, {2950,0.46359406}, {3000,0.48324752}, {3050,0.48343564}, {3100,0.49549505}, {3150,0.49953465}, {3200,0.49153465}, {3250,0.52738614}, {3300,0.51671287}, {3350,0.52617822}, {3400,0.53626733}, {3450,0.54281188}, {3500,0.54525743}, {3550,0.55093069}, {3600,0.55142574}, {3650,0.56252475}, {3700,0.57475248}, {3750,0.56902970}, {3800,0.58534653}, {3850,0.60176238}, {3900,0.63270297}, {3950,0.61192079}, {4000,0.62730693}, {4050,0.62681188}, {4100,0.62898020}, {4150,0.66431683}, {4200,0.64294059}, {4250,0.65010891}, {4300,0.68629703}, {4350,0.66921782}, {4400,0.67502970}, {4450,0.70155446}, {4500,0.70208911}, {4550,0.70477228}, {4600,0.74710891}, {4650,0.72289109}, {4700,0.75289109}, {4750,0.74421782}, {4800,0.73057426}, {4850,0.76510891}, {4900,0.76079208}, {4950,0.76551485}, {5000,0.77535644}, {5050,0.91800990}, {5100,0.79882178}, {5150,0.79999010}, {5200,0.82785149}, {5250,0.83086139}, {5300,0.83390099}, {5350,0.86015842}, {5400,0.83805941}, {5450,0.85435644}, {5500,0.85819802}, {5550,0.87359406}, {5600,0.89064356}, {5650,0.87424752}, {5700,0.89567327}, {5750,0.90453465}, {5800,0.93189109}, {5850,0.93646535}, {5900,0.92548515}, {5950,0.94408911}, {6000,0.93424752}, {6050,1.0405429}, {6100,1.0048286}, {6150,0.9744571}, {6200,1.0069714}, {6250,1.0038857}, {6300,1.0043714}, {6350,1.0264286}, {6400,1.0191429}, {6450,1.0436857}, {6500,1.0732000}, {6550,1.0806857}, {6600,1.0715714}, {6650,1.1078857}, {6700,1.0952000}, {6750,1.1227429}, {6800,1.1100000}, {6850,1.1182286}, {6900,1.1453143}, {6950,1.1499143}, {7000,1.1457143}, {7050,1.1438857}, {7100,1.1683143}, {7150,1.1671143}, {7200,1.1453143}, {7250,1.1673143}, {7300,1.2019429}, {7350,1.2354857}, {7400,1.2456857}, {7450,1.2539714}, {7500,1.2372000}, {7550,1.2642000}, {7600,1.2657143}, {7650,1.2498571}, {7700,1.2507429}, {7750,1.3128857}, {7800,1.3081714}, {7850,1.3116000}, {7900,1.3091714}, {7950,1.3032857}, {8000,1.3335429}, {8050,1.3543143}, {8100,1.3577429}, {8150,1.3623429}, {8200,1.3192571}, {8250,1.3615714}, {8300,1.3907429}, {8350,1.3807714}, {8400,1.3714857}, {8450,1.3712571}, {8500,1.4325714}, {8550,1.4316286}, {8600,1.3943714}, {8650,1.4543429}, {8700,1.4640571}, {8750,1.4366286}, {8800,1.4691714}, {8850,1.4808857}, {8900,1.4557714}, {8950,1.5017143}, {9000,1.4940571}, {9050,1.4859429}, {9100,1.5194857}, {9150,1.5517429}, {9200,1.5128286}, {9250,1.5598571}, {9300,1.5728857}, {9350,1.5450571}, {9400,1.5629143}, {9450,1.5660857}, {9500,1.5967143}, {9550,1.6089429}, {9600,1.6158286}, {9650,1.6173714}, {9700,1.5977429}, {9750,1.6460000}, {9800,1.6024571}, {9850,1.6548857}, {9900,1.6320571}, {9950,1.6853143}, {10000,1.6409429}, {10100,1.6937143}, {10200,1.6913429}, {10300,1.7180000}, {10400,1.6835429}, {10500,1.7364000}, {10600,1.7396000}, {10700,1.7902571}, {10800,1.7284571}, {10900,1.8208286}, {11000,1.8139429}, {11100,1.8552857}, {11200,1.8453429}, {11300,1.8639714}, {11400,1.8755429}, {11500,1.9038000}, {11600,1.9280571}, {11700,1.9469429}, {11800,1.9383429}, {11900,1.9911143}, {12000,1.9756286}, {12100,2.0054571}, {12200,2.0338857}, {12300,2.0125143}, {12400,2.0371429}, {12500,2.0711429}, {12600,2.0962286}, {12700,2.0960286}, {12800,2.0788571}, {12900,2.1179714}, {13000,2.1484286}, {13100,2.1538000}, {13200,2.1578571}, {13300,2.2001429}, {13400,2.2056857}, {13500,2.2445429}, {13600,2.2360000}, {13700,2.2484000}, {13800,2.2830857}, {13900,2.2963714}, {14000,2.3146286}, {14100,2.3456571}, {14200,2.4521429}, {14300,2.3937429}, {14400,2.3598000}, {14500,2.7428000}, {14600,2.4003143}, {14700,2.6067429}, {14800,2.4979143}, {14900,2.4460857}, {15000,2.4701143}, {15100,2.5113429}, {15200,2.5768857}, {15300,2.5231714}, {15400,2.6957429}, {15500,2.5611714}, {15600,2.5737429}, {15700,2.6778571}, {15800,2.6747429}, {15900,2.5982000}, {16000,2.6067714}, {16100,2.6632857}, {16200,2.6528000}, {16300,2.7144571}, {16400,2.6770000}, {16500,2.7166571}, {16600,2.9199429}, {16700,2.7663429}, {16800,2.7574000}, {16900,2.7602571}, {17000,2.8085429}, {17100,2.9038286}, {17200,2.8162000}, {17300,2.8559714}, {17400,2.8722571}, {17500,2.8773143}, {17600,2.8920571}, {17700,2.8944286}, {17800,2.9092000}, {17900,2.9807143}, {18000,2.9287714}, {18100,2.9970286}, {18200,2.9907143}, {18300,3.0629429}, {18400,3.0436857}, {18500,3.0473429}, {18600,3.0577714}, {18700,3.0848000}, {18800,3.1053143}, {18900,3.1184286}, {19000,3.3757143}, {19100,3.1773429}, {19200,3.3030000}, {19300,3.1956571}, {19400,3.2124857}, {19500,3.3808286}, {19600,3.2650000}, {19700,3.4691714}, {19800,3.2794286}, {19900,3.4372000}, {20000,3.3981143}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["norm reif"]["user"] = {{1,0.00030693}, {2,0.00035644}, {3,0.00035644}, {4,0.00062376}, {5,0.00056436}, {6,0.00063366}, {7,0.00127723}, {8,0.00806931}, {9,0.00134653}, {10,0.00148515}, {11,0.00103960}, {12,0.00155446}, {13,0.00166337}, {14,0.00165347}, {15,0.00163366}, {16,0.00179208}, {17,0.00190099}, {18,0.00232673}, {19,0.00239604}, {20,0.00213861}, {21,0.00232673}, {22,0.00259406}, {23,0.00272277}, {24,0.00288119}, {25,0.00289109}, {26,0.00299010}, {27,0.00296040}, {28,0.00333663}, {29,0.00321782}, {30,0.00324752}, {31,0.00346535}, {32,0.00371287}, {33,0.00365347}, {34,0.00399010}, {35,0.00400000}, {36,0.00400000}, {37,0.00440594}, {38,0.00414851}, {39,0.00482178}, {40,0.00487129}, {41,0.00489109}, {42,0.00506931}, {43,0.00496040}, {44,0.00514851}, {45,0.00543564}, {46,0.00546535}, {47,0.00582178}, {48,0.00621782}, {49,0.00800000}, {50,0.00633663}, {51,0.00596040}, {52,0.00633663}, {53,0.00674257}, {54,0.00681188}, {55,0.00703960}, {56,0.00796040}, {57,0.00721782}, {58,0.00688119}, {59,0.00719802}, {60,0.00722772}, {61,0.00741584}, {62,0.00744554}, {63,0.00768317}, {64,0.00770297}, {65,0.00787129}, {66,0.00783168}, {67,0.00798020}, {68,0.00826733}, {69,0.00828713}, {70,0.00839604}, {71,0.00848515}, {72,0.00911881}, {73,0.00893069}, {74,0.00887129}, {75,0.00928713}, {76,0.00900000}, {77,0.01120792}, {78,0.00942574}, {79,0.00972277}, {80,0.00995050}, {81,0.00996040}, {82,0.01031683}, {83,0.00992079}, {84,0.01340594}, {85,0.01061386}, {86,0.01032673}, {87,0.01083168}, {88,0.01056436}, {89,0.01090099}, {90,0.01059406}, {91,0.01108911}, {92,0.01119802}, {93,0.01138614}, {94,0.01166337}, {95,0.01167327}, {96,0.01168317}, {97,0.01201980}, {98,0.01201980}, {99,0.01219802}, {100,0.01217822}, {101,0.01215842}, {102,0.01253465}, {103,0.01279208}, {104,0.01269307}, {105,0.01268317}, {106,0.01318812}, {107,0.01794059}, {108,0.01491089}, {109,0.01318812}, {110,0.01340594}, {111,0.01368317}, {112,0.01383168}, {113,0.01411881}, {114,0.01779208}, {115,0.01426733}, {116,0.01442574}, {117,0.01472277}, {118,0.01492079}, {119,0.01776238}, {120,0.01490099}, {121,0.01520792}, {122,0.01510891}, {123,0.01825743}, {124,0.01521782}, {125,0.01567327}, {126,0.01557426}, {127,0.01570297}, {128,0.01601980}, {129,0.01625743}, {130,0.01604950}, {131,0.01617822}, {132,0.01638614}, {133,0.01619802}, {134,0.01699010}, {135,0.02134653}, {136,0.01663366}, {137,0.01697030}, {138,0.01687129}, {139,0.01722772}, {140,0.02034653}, {141,0.01768317}, {142,0.01725743}, {143,0.01740594}, {144,0.01769307}, {145,0.01745545}, {146,0.01760396}, {147,0.01791089}, {148,0.01784158}, {149,0.01768317}, {150,0.01828713}, {151,0.01826733}, {152,0.02391089}, {153,0.01819802}, {154,0.01993069}, {155,0.01855446}, {156,0.01862376}, {157,0.01929703}, {158,0.01905941}, {159,0.02136634}, {160,0.01939604}, {161,0.01927723}, {162,0.02354455}, {163,0.01972277}, {164,0.01973267}, {165,0.02410891}, {166,0.02008911}, {167,0.02053465}, {168,0.02214851}, {169,0.02039604}, {170,0.02039604}, {171,0.02126733}, {172,0.02457426}, {173,0.02116832}, {174,0.02128713}, {175,0.02149505}, {176,0.02295050}, {177,0.03159406}, {178,0.02188119}, {179,0.02210891}, {180,0.02183168}, {181,0.02216832}, {182,0.02609901}, {183,0.03015842}, {184,0.02287129}, {185,0.02282178}, {186,0.02282178}, {187,0.02320792}, {188,0.02319802}, {189,0.02370297}, {190,0.02373267}, {191,0.02555446}, {192,0.02661386}, {193,0.02826733}, {194,0.02986139}, {195,0.03032673}, {196,0.03141584}, {197,0.03207921}, {198,0.03162376}, {199,0.03131683}, {200,0.03077228}, {201,0.02991089}, {202,0.02850495}, {203,0.02784158}, {204,0.02642574}, {205,0.02464356}, {206,0.02541584}, {207,0.02566337}, {208,0.02556436}, {209,0.02572277}, {210,0.02573267}, {211,0.02601980}, {212,0.03341584}, {213,0.02801980}, {214,0.02632673}, {215,0.02652475}, {216,0.02655446}, {217,0.02637624}, {218,0.03107921}, {219,0.02680198}, {220,0.02695050}, {221,0.02739604}, {222,0.03434653}, {223,0.02750495}, {224,0.02731683}, {225,0.02731683}, {226,0.03292079}, {227,0.02791089}, {228,0.02790099}, {229,0.03495050}, {230,0.02833663}, {231,0.02836634}, {232,0.03619802}, {233,0.02851485}, {234,0.02888119}, {235,0.03493069}, {236,0.02865347}, {237,0.02970297}, {238,0.03058416}, {239,0.02927723}, {240,0.03555446}, {241,0.02915842}, {242,0.02926733}, {243,0.02999010}, {244,0.02981188}, {245,0.03034653}, {246,0.03018812}, {247,0.03110891}, {248,0.03045545}, {249,0.03192079}, {250,0.03116832}, {251,0.03122772}, {252,0.03158416}, {253,0.03118812}, {254,0.04050495}, {255,0.03162376}, {256,0.03657426}, {257,0.03160396}, {258,0.03171287}, {259,0.03190099}, {260,0.03197030}, {261,0.03751485}, {262,0.03226733}, {263,0.03235644}, {264,0.03945545}, {265,0.03271287}, {266,0.03294059}, {267,0.03927723}, {268,0.03378218}, {269,0.03329703}, {270,0.03825743}, {271,0.03598020}, {272,0.03334653}, {273,0.03375248}, {274,0.04058416}, {275,0.03438614}, {276,0.03497030}, {277,0.03426733}, {278,0.03725743}, {279,0.04246535}, {280,0.03512871}, {281,0.03516832}, {282,0.03492079}, {283,0.03559406}, {284,0.03853465}, {285,0.04215842}, {286,0.04591089}, {287,0.03608911}, {288,0.03596040}, {289,0.03582178}, {290,0.03605941}, {291,0.03637624}, {292,0.03616832}, {293,0.03636634}, {294,0.03875248}, {295,0.03959406}, {296,0.04023762}, {297,0.04077228}, {298,0.04107921}, {299,0.04138614}, {300,0.04009901}, {301,0.04076238}, {302,0.04150495}, {303,0.04046535}, {304,0.03751485}, {305,0.03772277}, {306,0.03777228}, {307,0.03802970}, {308,0.03814851}, {309,0.03806931}, {310,0.03851485}, {311,0.04963366}, {312,0.04636634}, {313,0.04098020}, {314,0.03903960}, {315,0.03926733}, {316,0.03936634}, {317,0.05177228}, {318,0.04688119}, {319,0.04172277}, {320,0.03900990}, {321,0.03954455}, {322,0.04975248}, {323,0.04446535}, {324,0.03974257}, {325,0.04029703}, {326,0.05007921}, {327,0.04474257}, {328,0.04000000}, {329,0.04103960}, {330,0.04781188}, {331,0.04085149}, {332,0.04102970}, {333,0.05175248}, {334,0.04102970}, {335,0.04197030}, {336,0.04829703}, {337,0.04171287}, {338,0.05518812}, {339,0.04474257}, {340,0.04138614}, {341,0.04966337}, {342,0.04218812}, {343,0.05262376}, {344,0.04195050}, {345,0.05612871}, {346,0.04428713}, {347,0.04306931}, {348,0.04514851}, {349,0.04405941}, {350,0.04543564}, {351,0.04366337}, {352,0.04340594}, {353,0.05572277}, {354,0.04375248}, {355,0.05345545}, {356,0.04389109}, {357,0.05365347}, {358,0.04440594}, {359,0.04797030}, {360,0.05816832}, {361,0.04500990}, {362,0.05205941}, {363,0.04493069}, {364,0.04507921}, {365,0.05366337}, {366,0.04545545}, {367,0.04652475}, {368,0.05252475}, {369,0.04575248}, {370,0.04620792}, {371,0.05096040}, {372,0.05755446}, {373,0.04723762}, {374,0.04713861}, {375,0.05246535}, {376,0.05797030}, {377,0.04751485}, {378,0.04684158}, {379,0.05034653}, {380,0.05842574}, {381,0.06454455}, {382,0.04800990}, {383,0.04804950}, {384,0.04734653}, {385,0.05147525}, {386,0.05639604}, {387,0.05911881}, {388,0.06242574}, {389,0.04847525}, {390,0.04882178}, {391,0.04883168}, {392,0.04906931}, {393,0.05005941}, {394,0.05157426}, {395,0.05300990}, {396,0.05375248}, {397,0.05478218}, {398,0.05502970}, {399,0.05962376}, {400,0.05876238}, {401,0.05689109}, {402,0.05723762}, {403,0.05693069}, {404,0.05510891}, {405,0.05418812}, {406,0.05312871}, {407,0.05174257}, {408,0.05052475}, {409,0.05165347}, {410,0.05143564}, {411,0.05151485}, {412,0.06327723}, {413,0.06158416}, {414,0.05825743}, {415,0.05556436}, {416,0.05170297}, {417,0.05214851}, {418,0.05186139}, {419,0.06502970}, {420,0.05894059}, {421,0.05403960}, {422,0.05254455}, {423,0.06872277}, {424,0.06293069}, {425,0.05670297}, {426,0.05324752}, {427,0.06843564}, {428,0.06176238}, {429,0.05484158}, {430,0.05344554}, {431,0.06466337}, {432,0.05669307}, {433,0.05362376}, {434,0.07139604}, {435,0.05894059}, {436,0.05437624}, {437,0.06599010}, {438,0.05630693}, {439,0.07166337}, {440,0.06124752}, {441,0.05492079}, {442,0.06562376}, {443,0.05575248}, {444,0.06842574}, {445,0.05900000}, {446,0.07106931}, {447,0.06042574}, {448,0.05560396}, {449,0.06074257}, {450,0.05556436}, {451,0.06502970}, {452,0.05634653}, {453,0.06273267}, {454,0.05642574}, {455,0.06180198}, {456,0.07107921}, {457,0.05885149}, {458,0.06992079}, {459,0.05722772}, {460,0.06504950}, {461,0.05739604}, {462,0.05988119}, {463,0.06911881}, {464,0.05781188}, {465,0.06284158}, {466,0.07293069}, {467,0.05881188}, {468,0.06543564}, {469,0.07391089}, {470,0.05842574}, {471,0.06334653}, {472,0.07055446}, {473,0.05943564}, {474,0.05975248}, {475,0.06529703}, {476,0.07097030}, {477,0.06014851}, {478,0.06023762}, {479,0.06378218}, {480,0.07003960}, {481,0.07943564}, {482,0.06033663}, {483,0.06073267}, {484,0.06343564}, {485,0.06917822}, {486,0.07199010}, {487,0.07499010}, {488,0.07676238}, {489,0.06115842}, {490,0.06117822}, {491,0.06201980}, {492,0.06381188}, {493,0.06724752}, {494,0.07108911}, {495,0.07125743}, {496,0.07194059}, {497,0.07373267}, {498,0.07362376}, {499,0.07469307}, {500,0.07396040}, {505,0.07387129}, {510,0.07226733}, {515,0.06998020}, {520,0.06612871}, {525,0.06593069}, {530,0.08684158}, {535,0.07574257}, {540,0.06735644}, {545,0.08043564}, {550,0.06874257}, {555,0.08248515}, {560,0.06973267}, {565,0.07849505}, {570,0.08701980}, {575,0.07271287}, {580,0.07846535}, {585,0.08433663}, {590,0.08679208}, {595,0.08876238}, {600,0.09020792}, {605,0.08943564}, {610,0.08858416}, {615,0.08681188}, {620,0.08717822}, {625,0.08065347}, {630,0.09911881}, {635,0.09165347}, {640,0.08295050}, {645,0.09697030}, {650,0.08725743}, {655,0.09874257}, {660,0.08735644}, {665,0.10199010}, {670,0.10788119}, {675,0.09022772}, {680,0.09558416}, {685,0.10040594}, {690,0.10450495}, {695,0.10692079}, {700,0.11803960}, {705,0.11198020}, {710,0.11082178}, {715,0.10742574}, {720,0.10336634}, {725,0.10096040}, {730,0.09811881}, {735,0.11467327}, {740,0.10663366}, {745,0.12006931}, {750,0.10896040}, {755,0.11974257}, {760,0.11434653}, {765,0.12091089}, {770,0.10404950}, {775,0.11115842}, {780,0.11755446}, {785,0.12214851}, {790,0.10777228}, {795,0.10946535}, {800,0.11037624}, {805,0.11086139}, {810,0.11080198}, {815,0.11330693}, {820,0.13282178}, {825,0.12736634}, {830,0.11995050}, {835,0.11352475}, {840,0.12721782}, {845,0.12369307}, {850,0.13748515}, {855,0.12387129}, {860,0.13422772}, {865,0.12887129}, {870,0.13524752}, {875,0.14106931}, {880,0.12222772}, {885,0.12777228}, {890,0.13545545}, {895,0.13505941}, {900,0.13555446}, {905,0.13530693}, {910,0.13493069}, {915,0.14181188}, {920,0.13038614}, {925,0.12873267}, {930,0.12572277}, {935,0.15212871}, {940,0.13642574}, {945,0.15079208}, {950,0.13886139}, {955,0.13071287}, {960,0.14406931}, {965,0.14372277}, {970,0.13649505}, {975,0.14372277}, {980,0.15585149}, {985,0.13491089}, {990,0.13771287}, {995,0.14086139}, {1000,0.14495050}, {1010,0.14504950}, {1020,0.14228713}, {1030,0.15996040}, {1040,0.15919802}, {1050,0.15059406}, {1060,0.15995050}, {1070,0.15781188}, {1080,0.16056436}, {1090,0.16243564}, {1100,0.16674257}, {1110,0.17245545}, {1120,0.16902970}, {1130,0.16395050}, {1140,0.16183168}, {1150,0.17600000}, {1160,0.16274257}, {1170,0.18873267}, {1180,0.18550495}, {1190,0.16693069}, {1200,0.17660396}, {1210,0.16568317}, {1220,0.16944554}, {1230,0.20611881}, {1240,0.18689109}, {1250,0.17667327}, {1260,0.19424752}, {1270,0.20226733}, {1280,0.18297030}, {1290,0.19548515}, {1300,0.19549505}, {1310,0.19564356}, {1320,0.19519802}, {1330,0.19328713}, {1340,0.20119802}, {1350,0.20726733}, {1360,0.19436634}, {1370,0.21182178}, {1380,0.21277228}, {1390,0.19094059}, {1400,0.20202970}, {1410,0.20082178}, {1420,0.20623762}, {1430,0.22140594}, {1440,0.23395050}, {1450,0.21366337}, {1460,0.22193069}, {1470,0.21766337}, {1480,0.21722772}, {1490,0.23298020}, {1500,0.22947525}, {1510,0.23772277}, {1520,0.23372277}, {1530,0.22569307}, {1540,0.22690099}, {1550,0.23681188}, {1560,0.23602970}, {1570,0.23884158}, {1580,0.23779208}, {1590,0.23315842}, {1600,0.25700000}, {1610,0.24146535}, {1620,0.25820792}, {1630,0.24025743}, {1640,0.24976238}, {1650,0.25197030}, {1660,0.25960396}, {1670,0.25257426}, {1680,0.24533663}, {1690,0.24871287}, {1700,0.25488119}, {1710,0.25514851}, {1720,0.27190099}, {1730,0.24991089}, {1740,0.27738614}, {1750,0.25987129}, {1760,0.25858416}, {1770,0.26268317}, {1780,0.28046535}, {1790,0.27681188}, {1800,0.26353465}, {1810,0.26207921}, {1820,0.26766337}, {1830,0.26198020}, {1840,0.27772277}, {1850,0.28434653}, {1860,0.28555446}, {1870,0.27989109}, {1880,0.28457426}, {1890,0.29865347}, {1900,0.29467327}, {1910,0.27715842}, {1920,0.28342574}, {1930,0.29535644}, {1940,0.29824752}, {1950,0.31002970}, {1960,0.29782178}, {1970,0.29656436}, {1980,0.29599010}, {1990,0.30668317}, {2000,0.32918812}, {2050,0.30835644}, {2100,0.30872277}, {2150,0.34036634}, {2200,0.31933663}, {2250,0.34659406}, {2300,0.38677228}, {2350,0.35571287}, {2400,0.36944554}, {2450,0.37776238}, {2500,0.39864356}, {2550,0.42092079}, {2600,0.39835644}, {2650,0.40325743}, {2700,0.41569307}, {2750,0.42809901}, {2800,0.43174257}, {2850,0.44846535}, {2900,0.46325743}, {2950,0.46261386}, {3000,0.48230693}, {3050,0.48251485}, {3100,0.49292079}, {3150,0.49847525}, {3200,0.49045545}, {3250,0.52651485}, {3300,0.51606931}, {3350,0.52533663}, {3400,0.53523762}, {3450,0.54186139}, {3500,0.54458416}, {3550,0.55012871}, {3600,0.55018812}, {3650,0.56130693}, {3700,0.57390099}, {3750,0.56811881}, {3800,0.58418812}, {3850,0.60097030}, {3900,0.63146535}, {3950,0.61054455}, {4000,0.62636634}, {4050,0.62576238}, {4100,0.62793069}, {4150,0.66306931}, {4200,0.64188119}, {4250,0.64905941}, {4300,0.68508911}, {4350,0.66811881}, {4400,0.67378218}, {4450,0.70023762}, {4500,0.70085149}, {4550,0.70347525}, {4600,0.74569307}, {4650,0.72154455}, {4700,0.75145545}, {4750,0.74264356}, {4800,0.72905941}, {4850,0.76333663}, {4900,0.75889109}, {4950,0.76380198}, {5000,0.77387129}, {5050,0.91539604}, {5100,0.79726733}, {5150,0.79816832}, {5200,0.82609901}, {5250,0.82916832}, {5300,0.83241584}, {5350,0.85822772}, {5400,0.83644554}, {5450,0.85251485}, {5500,0.85647525}, {5550,0.87204950}, {5600,0.88874257}, {5650,0.87251485}, {5700,0.89332673}, {5750,0.90310891}, {5800,0.93014851}, {5850,0.93465347}, {5900,0.92369307}, {5950,0.94238614}, {6000,0.93267327}, {6050,1.0366857}, {6100,1.0032286}, {6150,0.9736000}, {6200,1.0062857}, {6250,1.0008286}, {6300,1.0030000}, {6350,1.0250286}, {6400,1.0184286}, {6450,1.0426286}, {6500,1.0718857}, {6550,1.0797429}, {6600,1.0709714}, {6650,1.1074286}, {6700,1.0941143}, {6750,1.1193143}, {6800,1.1075143}, {6850,1.1169714}, {6900,1.1439143}, {6950,1.1458571}, {7000,1.1444000}, {7050,1.1429714}, {7100,1.1674286}, {7150,1.1662286}, {7200,1.1443714}, {7250,1.1658000}, {7300,1.2007429}, {7350,1.2328857}, {7400,1.2436286}, {7450,1.2509429}, {7500,1.2342857}, {7550,1.2592857}, {7600,1.2586286}, {7650,1.2472857}, {7700,1.2424571}, {7750,1.3038286}, {7800,1.3047429}, {7850,1.3084571}, {7900,1.3042286}, {7950,1.2956571}, {8000,1.3321429}, {8050,1.3521714}, {8100,1.3560571}, {8150,1.3608571}, {8200,1.3183714}, {8250,1.3602000}, {8300,1.3887429}, {8350,1.3795714}, {8400,1.3702000}, {8450,1.3694000}, {8500,1.4306286}, {8550,1.4297143}, {8600,1.3927429}, {8650,1.4516286}, {8700,1.4622286}, {8750,1.4356286}, {8800,1.4682571}, {8850,1.4785143}, {8900,1.4536000}, {8950,1.5003429}, {9000,1.4923143}, {9050,1.4839429}, {9100,1.5170286}, {9150,1.5500286}, {9200,1.5107143}, {9250,1.5544857}, {9300,1.5636000}, {9350,1.5426286}, {9400,1.5609143}, {9450,1.5641143}, {9500,1.5948286}, {9550,1.6073429}, {9600,1.6130000}, {9650,1.6149143}, {9700,1.5954000}, {9750,1.6439143}, {9800,1.5999429}, {9850,1.6522286}, {9900,1.6299714}, {9950,1.6827429}, {10000,1.6386857}, {10100,1.6913714}, {10200,1.6825429}, {10300,1.7152286}, {10400,1.6815429}, {10500,1.7334000}, {10600,1.7370571}, {10700,1.7881429}, {10800,1.7254857}, {10900,1.8182000}, {11000,1.8112000}, {11100,1.8528571}, {11200,1.8423714}, {11300,1.8605143}, {11400,1.8724571}, {11500,1.9005143}, {11600,1.9242857}, {11700,1.9444571}, {11800,1.9349714}, {11900,1.9878286}, {12000,1.9728857}, {12100,2.0018286}, {12200,2.0306286}, {12300,2.0090857}, {12400,2.0333714}, {12500,2.0673429}, {12600,2.0926286}, {12700,2.0922571}, {12800,2.0763143}, {12900,2.1143714}, {13000,2.1460857}, {13100,2.1505143}, {13200,2.1546571}, {13300,2.1962286}, {13400,2.2028571}, {13500,2.2416286}, {13600,2.2334857}, {13700,2.2462000}, {13800,2.2810286}, {13900,2.2938857}, {14000,2.3116571}, {14100,2.3422571}, {14200,2.4488857}, {14300,2.3904857}, {14400,2.3570571}, {14500,2.7373429}, {14600,2.3976857}, {14700,2.6027429}, {14800,2.4948000}, {14900,2.4422286}, {15000,2.4667714}, {15100,2.5090571}, {15200,2.5731714}, {15300,2.5202571}, {15400,2.6914571}, {15500,2.5586286}, {15600,2.5702000}, {15700,2.6750571}, {15800,2.6721714}, {15900,2.5946000}, {16000,2.6044000}, {16100,2.6606857}, {16200,2.6497429}, {16300,2.7125429}, {16400,2.6757143}, {16500,2.7139143}, {16600,2.9174571}, {16700,2.7635143}, {16800,2.7546571}, {16900,2.7575143}, {17000,2.8064571}, {17100,2.9003143}, {17200,2.8118571}, {17300,2.8518000}, {17400,2.8694857}, {17500,2.8732571}, {17600,2.8883714}, {17700,2.8909714}, {17800,2.9052571}, {17900,2.9770286}, {18000,2.9255143}, {18100,2.9930286}, {18200,2.9862857}, {18300,3.0582286}, {18400,3.0398000}, {18500,3.0431143}, {18600,3.0534571}, {18700,3.0799714}, {18800,3.0853143}, {18900,3.1129714}, {19000,3.3383429}, {19100,3.1528857}, {19200,3.2979429}, {19300,3.1892857}, {19400,3.2062857}, {19500,3.3660000}, {19600,3.2476857}, {19700,3.4450571}, {19800,3.2678571}, {19900,3.4331429}, {20000,3.3950571}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["norm reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00013861}, {9,0.00003960}, {10,0.00000000}, {11,0.00003960}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00002970}, {18,0.00003960}, {19,0.00000000}, {20,0.00000000}, {21,0.00003960}, {22,0.00007921}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00002970}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00003960}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00003960}, {35,0.00003960}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00003960}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00002970}, {44,0.00003960}, {45,0.00003960}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00003960}, {50,0.00000000}, {51,0.00007921}, {52,0.00000000}, {53,0.00003960}, {54,0.00000000}, {55,0.00000000}, {56,0.00007921}, {57,0.00003960}, {58,0.00003960}, {59,0.00000000}, {60,0.00003960}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00002970}, {66,0.00000000}, {67,0.00003960}, {68,0.00002970}, {69,0.00002970}, {70,0.00003960}, {71,0.00000000}, {72,0.00007921}, {73,0.00000000}, {74,0.00002970}, {75,0.00000000}, {76,0.00003960}, {77,0.00006931}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00003960}, {83,0.00000000}, {84,0.00006931}, {85,0.00002970}, {86,0.00000000}, {87,0.00002970}, {88,0.00000000}, {89,0.00006931}, {90,0.00003960}, {91,0.00000000}, {92,0.00000000}, {93,0.00003960}, {94,0.00000000}, {95,0.00003960}, {96,0.00000000}, {97,0.00003960}, {98,0.00000000}, {99,0.00003960}, {100,0.00000000}, {101,0.00003960}, {102,0.00000000}, {103,0.00000000}, {104,0.00002970}, {105,0.00000000}, {106,0.00000000}, {107,0.00003960}, {108,0.00003960}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00003960}, {113,0.00000000}, {114,0.00003960}, {115,0.00002970}, {116,0.00003960}, {117,0.00000000}, {118,0.00000000}, {119,0.00014851}, {120,0.00003960}, {121,0.00000000}, {122,0.00002970}, {123,0.00011881}, {124,0.00003960}, {125,0.00000000}, {126,0.00003960}, {127,0.00003960}, {128,0.00000000}, {129,0.00002970}, {130,0.00000000}, {131,0.00003960}, {132,0.00007921}, {133,0.00003960}, {134,0.00000000}, {135,0.00014851}, {136,0.00007921}, {137,0.00000000}, {138,0.00000000}, {139,0.00003960}, {140,0.00018812}, {141,0.00007921}, {142,0.00002970}, {143,0.00003960}, {144,0.00003960}, {145,0.00000000}, {146,0.00003960}, {147,0.00000000}, {148,0.00000000}, {149,0.00003960}, {150,0.00000000}, {151,0.00000000}, {152,0.00005941}, {153,0.00000000}, {154,0.00003960}, {155,0.00003960}, {156,0.00002970}, {157,0.00003960}, {158,0.00002970}, {159,0.00003960}, {160,0.00000000}, {161,0.00000000}, {162,0.00019802}, {163,0.00000000}, {164,0.00000000}, {165,0.00003960}, {166,0.00003960}, {167,0.00003960}, {168,0.00007921}, {169,0.00000000}, {170,0.00000000}, {171,0.00003960}, {172,0.00007921}, {173,0.00002970}, {174,0.00003960}, {175,0.00003960}, {176,0.00000000}, {177,0.00081188}, {178,0.00003960}, {179,0.00000000}, {180,0.00000000}, {181,0.00003960}, {182,0.00010891}, {183,0.00023762}, {184,0.00000000}, {185,0.00000000}, {186,0.00003960}, {187,0.00000000}, {188,0.00000000}, {189,0.00007921}, {190,0.00000000}, {191,0.00011881}, {192,0.00011881}, {193,0.00010891}, {194,0.00003960}, {195,0.00037624}, {196,0.00007921}, {197,0.00010891}, {198,0.00037624}, {199,0.00019802}, {200,0.00018812}, {201,0.00011881}, {202,0.00023762}, {203,0.00011881}, {204,0.00003960}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00003960}, {209,0.00003960}, {210,0.00000000}, {211,0.00003960}, {212,0.00015842}, {213,0.00003960}, {214,0.00000000}, {215,0.00003960}, {216,0.00003960}, {217,0.00000000}, {218,0.00018812}, {219,0.00003960}, {220,0.00000000}, {221,0.00000000}, {222,0.00007921}, {223,0.00000000}, {224,0.00003960}, {225,0.00015842}, {226,0.00015842}, {227,0.00000000}, {228,0.00002970}, {229,0.00018812}, {230,0.00003960}, {231,0.00000000}, {232,0.00014851}, {233,0.00011881}, {234,0.00003960}, {235,0.00015842}, {236,0.00003960}, {237,0.00003960}, {238,0.00000000}, {239,0.00003960}, {240,0.00000000}, {241,0.00003960}, {242,0.00007921}, {243,0.00000000}, {244,0.00000000}, {245,0.00003960}, {246,0.00003960}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00003960}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00003960}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00003960}, {262,0.00003960}, {263,0.00002970}, {264,0.00002970}, {265,0.00000000}, {266,0.00000000}, {267,0.00003960}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00003960}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00003960}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00003960}, {283,0.00000000}, {284,0.00000000}, {285,0.00003960}, {286,0.00003960}, {287,0.00000000}, {288,0.00003960}, {289,0.00002970}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00002970}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00003960}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00006931}, {303,0.00007921}, {304,0.00000000}, {305,0.00000000}, {306,0.00003960}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00003960}, {313,0.00000000}, {314,0.00000000}, {315,0.00003960}, {316,0.00002970}, {317,0.00003960}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00003960}, {322,0.00000000}, {323,0.00000000}, {324,0.00003960}, {325,0.00000000}, {326,0.00007921}, {327,0.00000000}, {328,0.00003960}, {329,0.00000000}, {330,0.00000000}, {331,0.00003960}, {332,0.00003960}, {333,0.00003960}, {334,0.00000000}, {335,0.00000000}, {336,0.00003960}, {337,0.00000000}, {338,0.00000000}, {339,0.00003960}, {340,0.00003960}, {341,0.00003960}, {342,0.00000000}, {343,0.00000000}, {344,0.00003960}, {345,0.00000000}, {346,0.00003960}, {347,0.00000000}, {348,0.00023762}, {349,0.00000000}, {350,0.00003960}, {351,0.00000000}, {352,0.00003960}, {353,0.00018812}, {354,0.00000000}, {355,0.00003960}, {356,0.00000000}, {357,0.00003960}, {358,0.00000000}, {359,0.00003960}, {360,0.00011881}, {361,0.00003960}, {362,0.00007921}, {363,0.00003960}, {364,0.00007921}, {365,0.00000000}, {366,0.00003960}, {367,0.00000000}, {368,0.00011881}, {369,0.00000000}, {370,0.00003960}, {371,0.00003960}, {372,0.00000000}, {373,0.00007921}, {374,0.00003960}, {375,0.00000000}, {376,0.00003960}, {377,0.00007921}, {378,0.00000000}, {379,0.00000000}, {380,0.00003960}, {381,0.00000000}, {382,0.00000000}, {383,0.00003960}, {384,0.00003960}, {385,0.00003960}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00007921}, {391,0.00011881}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00002970}, {398,0.00003960}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00007921}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00011881}, {408,0.00000000}, {409,0.00000000}, {410,0.00003960}, {411,0.00000000}, {412,0.00011881}, {413,0.00011881}, {414,0.00015842}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00007921}, {422,0.00002970}, {423,0.00003960}, {424,0.00006931}, {425,0.00000000}, {426,0.00003960}, {427,0.00003960}, {428,0.00000000}, {429,0.00003960}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00003960}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00003960}, {442,0.00003960}, {443,0.00007921}, {444,0.00000000}, {445,0.00000000}, {446,0.00003960}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00007921}, {451,0.00000000}, {452,0.00002970}, {453,0.00000000}, {454,0.00003960}, {455,0.00007921}, {456,0.00003960}, {457,0.00007921}, {458,0.00000000}, {459,0.00003960}, {460,0.00003960}, {461,0.00000000}, {462,0.00003960}, {463,0.00002970}, {464,0.00007921}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003960}, {469,0.00003960}, {470,0.00000000}, {471,0.00003960}, {472,0.00000000}, {473,0.00003960}, {474,0.00000000}, {475,0.00007921}, {476,0.00007921}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00003960}, {481,0.00003960}, {482,0.00003960}, {483,0.00000000}, {484,0.00003960}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00003960}, {490,0.00003960}, {491,0.00000000}, {492,0.00003960}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00007921}, {497,0.00000000}, {498,0.00000000}, {499,0.00003960}, {500,0.00000000}, {505,0.00000000}, {510,0.00003960}, {515,0.00003960}, {520,0.00003960}, {525,0.00011881}, {530,0.00003960}, {535,0.00003960}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00003960}, {570,0.00000000}, {575,0.00003960}, {580,0.00000000}, {585,0.00003960}, {590,0.00000000}, {595,0.00010891}, {600,0.00006931}, {605,0.00000000}, {610,0.00000000}, {615,0.00003960}, {620,0.00000000}, {625,0.00003960}, {630,0.00003960}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00007921}, {660,0.00000000}, {665,0.00003960}, {670,0.00003960}, {675,0.00003960}, {680,0.00003960}, {685,0.00003960}, {690,0.00000000}, {695,0.00000000}, {700,0.00003960}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00006931}, {740,0.00007921}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00011881}, {770,0.00007921}, {775,0.00007921}, {780,0.00000000}, {785,0.00007921}, {790,0.00000000}, {795,0.00007921}, {800,0.00000000}, {805,0.00003960}, {810,0.00000000}, {815,0.00003960}, {820,0.00000000}, {825,0.00003960}, {830,0.00002970}, {835,0.00003960}, {840,0.00003960}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00007921}, {865,0.00000000}, {870,0.00003960}, {875,0.00000000}, {880,0.00003960}, {885,0.00007921}, {890,0.00003960}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00003960}, {920,0.00000000}, {925,0.00000000}, {930,0.00003960}, {935,0.00003960}, {940,0.00000000}, {945,0.00000000}, {950,0.00007921}, {955,0.00000000}, {960,0.00002970}, {965,0.00007921}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00007921}, {990,0.00003960}, {995,0.00000000}, {1000,0.00007921}, {1010,0.00000000}, {1020,0.00003960}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00011881}, {1060,0.00003960}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00003960}, {1120,0.00003960}, {1130,0.00000000}, {1140,0.00007921}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00003960}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00003960}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00003960}, {1240,0.00007921}, {1250,0.00003960}, {1260,0.00011881}, {1270,0.00002970}, {1280,0.00000000}, {1290,0.00011881}, {1300,0.00003960}, {1310,0.00011881}, {1320,0.00003960}, {1330,0.00003960}, {1340,0.00000000}, {1350,0.00003960}, {1360,0.00000000}, {1370,0.00007921}, {1380,0.00003960}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00003960}, {1420,0.00007921}, {1430,0.00000000}, {1440,0.00006931}, {1450,0.00003960}, {1460,0.00000000}, {1470,0.00003960}, {1480,0.00002970}, {1490,0.00003960}, {1500,0.00000000}, {1510,0.00003960}, {1520,0.00000000}, {1530,0.00011881}, {1540,0.00007921}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00006931}, {1580,0.00003960}, {1590,0.00003960}, {1600,0.00007921}, {1610,0.00007921}, {1620,0.00000000}, {1630,0.00003960}, {1640,0.00000000}, {1650,0.00011881}, {1660,0.00003960}, {1670,0.00007921}, {1680,0.00007921}, {1690,0.00003960}, {1700,0.00003960}, {1710,0.00003960}, {1720,0.00003960}, {1730,0.00007921}, {1740,0.00007921}, {1750,0.00000000}, {1760,0.00007921}, {1770,0.00000000}, {1780,0.00015842}, {1790,0.00000000}, {1800,0.00011881}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00007921}, {1840,0.00000000}, {1850,0.00007921}, {1860,0.00003960}, {1870,0.00002970}, {1880,0.00014851}, {1890,0.00007921}, {1900,0.00011881}, {1910,0.00000000}, {1920,0.00011881}, {1930,0.00014851}, {1940,0.00003960}, {1950,0.00000000}, {1960,0.00019802}, {1970,0.00007921}, {1980,0.00006931}, {1990,0.00000000}, {2000,0.00007921}, {2050,0.00003960}, {2100,0.00007921}, {2150,0.00007921}, {2200,0.00003960}, {2250,0.00010891}, {2300,0.00007921}, {2350,0.00007921}, {2400,0.00007921}, {2450,0.00000000}, {2500,0.00003960}, {2550,0.00007921}, {2600,0.00007921}, {2650,0.00003960}, {2700,0.00014851}, {2750,0.00000000}, {2800,0.00002970}, {2850,0.00003960}, {2900,0.00007921}, {2950,0.00003960}, {3000,0.00011881}, {3050,0.00007921}, {3100,0.00144554}, {3150,0.00023762}, {3200,0.00011881}, {3250,0.00007921}, {3300,0.00003960}, {3350,0.00000000}, {3400,0.00007921}, {3450,0.00003960}, {3500,0.00003960}, {3550,0.00003960}, {3600,0.00003960}, {3650,0.00011881}, {3700,0.00000000}, {3750,0.00003960}, {3800,0.00011881}, {3850,0.00007921}, {3900,0.00007921}, {3950,0.00011881}, {4000,0.00000000}, {4050,0.00003960}, {4100,0.00003960}, {4150,0.00007921}, {4200,0.00011881}, {4250,0.00003960}, {4300,0.00006931}, {4350,0.00007921}, {4400,0.00011881}, {4450,0.00003960}, {4500,0.00003960}, {4550,0.00015842}, {4600,0.00018812}, {4650,0.00003960}, {4700,0.00003960}, {4750,0.00007921}, {4800,0.00007921}, {4850,0.00038614}, {4900,0.00051485}, {4950,0.00018812}, {5000,0.00003960}, {5050,0.00110891}, {5100,0.00011881}, {5150,0.00019802}, {5200,0.00046535}, {5250,0.00026733}, {5300,0.00007921}, {5350,0.00015842}, {5400,0.00018812}, {5450,0.00007921}, {5500,0.00019802}, {5550,0.00015842}, {5600,0.00015842}, {5650,0.00007921}, {5700,0.00019802}, {5750,0.00003960}, {5800,0.00003960}, {5850,0.00011881}, {5900,0.00006931}, {5950,0.00015842}, {6000,0.00011881}, {6050,0.0029143}, {6100,0.0011143}, {6150,0.0003429}, {6200,0.0002286}, {6250,0.0022571}, {6300,0.0000857}, {6350,0.0000000}, {6400,0.0001143}, {6450,0.0001143}, {6500,0.0001143}, {6550,0.0002286}, {6600,0.0001143}, {6650,0.0000000}, {6700,0.0001143}, {6750,0.0002286}, {6800,0.0001143}, {6850,0.0001143}, {6900,0.0000000}, {6950,0.0002286}, {7000,0.0000857}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0001143}, {7250,0.0001143}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0003143}, {7550,0.0003429}, {7600,0.0001143}, {7650,0.0000000}, {7700,0.0003429}, {7750,0.0001143}, {7800,0.0001143}, {7850,0.0000000}, {7900,0.0001143}, {7950,0.0001143}, {8000,0.0000000}, {8050,0.0004571}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0001143}, {8300,0.0001143}, {8350,0.0000000}, {8400,0.0002286}, {8450,0.0000857}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0003143}, {8650,0.0003429}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0002286}, {8950,0.0000000}, {9000,0.0002000}, {9050,0.0001143}, {9100,0.0002286}, {9150,0.0002286}, {9200,0.0001143}, {9250,0.0003429}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0002286}, {9450,0.0001143}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0003143}, {9650,0.0002286}, {9700,0.0001143}, {9750,0.0001143}, {9800,0.0001143}, {9850,0.0003429}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0064857}, {10300,0.0001143}, {10400,0.0000000}, {10500,0.0004571}, {10600,0.0000000}, {10700,0.0001143}, {10800,0.0003429}, {10900,0.0001143}, {11000,0.0000000}, {11100,0.0001143}, {11200,0.0000000}, {11300,0.0001143}, {11400,0.0002286}, {11500,0.0002286}, {11600,0.0002286}, {11700,0.0000000}, {11800,0.0008857}, {11900,0.0001143}, {12000,0.0000000}, {12100,0.0004571}, {12200,0.0002286}, {12300,0.0005714}, {12400,0.0004571}, {12500,0.0008000}, {12600,0.0001143}, {12700,0.0005714}, {12800,0.0002286}, {12900,0.0002286}, {13000,0.0002286}, {13100,0.0001143}, {13200,0.0001143}, {13300,0.0005429}, {13400,0.0000000}, {13500,0.0001143}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0005714}, {14100,0.0008000}, {14200,0.0008857}, {14300,0.0004571}, {14400,0.0000000}, {14500,0.0025714}, {14600,0.0005429}, {14700,0.0013429}, {14800,0.0003429}, {14900,0.0008857}, {15000,0.0004571}, {15100,0.0001143}, {15200,0.0007714}, {15300,0.0008000}, {15400,0.0010286}, {15500,0.0002286}, {15600,0.0005714}, {15700,0.0006857}, {15800,0.0002286}, {15900,0.0005714}, {16000,0.0002286}, {16100,0.0002286}, {16200,0.0010000}, {16300,0.0003429}, {16400,0.0001143}, {16500,0.0010286}, {16600,0.0006571}, {16700,0.0004571}, {16800,0.0000000}, {16900,0.0006857}, {17000,0.0000000}, {17100,0.0005714}, {17200,0.0018000}, {17300,0.0014857}, {17400,0.0000000}, {17500,0.0013714}, {17600,0.0006571}, {17700,0.0009143}, {17800,0.0007714}, {17900,0.0005714}, {18000,0.0002286}, {18100,0.0001143}, {18200,0.0006857}, {18300,0.0013429}, {18400,0.0002286}, {18500,0.0007714}, {18600,0.0010286}, {18700,0.0010000}, {18800,0.0009143}, {18900,0.0000000}, {19000,0.0005714}, {19100,0.0003429}, {19200,0.0008857}, {19300,0.0026286}, {19400,0.0011429}, {19500,0.0003143}, {19600,0.0009143}, {19700,0.0023429}, {19800,0.0024000}, {19900,0.0018000}, {20000,0.0005714}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["post"]["user"] = {{1,0.00000000}, {2,0.00003960}, {3,0.00000000}, {4,0.00002970}, {5,0.00002970}, {6,0.00000000}, {7,0.00002970}, {8,0.00000000}, {9,0.00000000}, {10,0.00002970}, {11,0.00000000}, {12,0.00000000}, {13,0.00002970}, {14,0.00003960}, {15,0.00000000}, {16,0.00003960}, {17,0.00003960}, {18,0.00011881}, {19,0.00002970}, {20,0.00009901}, {21,0.00003960}, {22,0.00000000}, {23,0.00002970}, {24,0.00003960}, {25,0.00003960}, {26,0.00006931}, {27,0.00006931}, {28,0.00000000}, {29,0.00000000}, {30,0.00002970}, {31,0.00000000}, {32,0.00009901}, {33,0.00002970}, {34,0.00000000}, {35,0.00002970}, {36,0.00007921}, {37,0.00000000}, {38,0.00000000}, {39,0.00007921}, {40,0.00003960}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00009901}, {46,0.00002970}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00002970}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00007921}, {61,0.00000000}, {62,0.00000000}, {63,0.00002970}, {64,0.00000000}, {65,0.00006931}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00002970}, {70,0.00008911}, {71,0.00000000}, {72,0.00002970}, {73,0.00010891}, {74,0.00000000}, {75,0.00000000}, {76,0.00002970}, {77,0.00006931}, {78,0.00000000}, {79,0.00000000}, {80,0.00002970}, {81,0.00000000}, {82,0.00002970}, {83,0.00005941}, {84,0.00005941}, {85,0.00002970}, {86,0.00003960}, {87,0.00006931}, {88,0.00000000}, {89,0.00000000}, {90,0.00010891}, {91,0.00005941}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00003960}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00002970}, {100,0.00003960}, {101,0.00002970}, {102,0.00000000}, {103,0.00005941}, {104,0.00010891}, {105,0.00000000}, {106,0.00000000}, {107,0.00002970}, {108,0.00000000}, {109,0.00002970}, {110,0.00000000}, {111,0.00003960}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00006931}, {116,0.00000000}, {117,0.00000000}, {118,0.00005941}, {119,0.00010891}, {120,0.00002970}, {121,0.00000000}, {122,0.00005941}, {123,0.00002970}, {124,0.00000000}, {125,0.00006931}, {126,0.00000000}, {127,0.00009901}, {128,0.00002970}, {129,0.00002970}, {130,0.00005941}, {131,0.00000000}, {132,0.00006931}, {133,0.00002970}, {134,0.00000000}, {135,0.00005941}, {136,0.00005941}, {137,0.00002970}, {138,0.00000000}, {139,0.00003960}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00002970}, {145,0.00002970}, {146,0.00003960}, {147,0.00007921}, {148,0.00000000}, {149,0.00006931}, {150,0.00003960}, {151,0.00002970}, {152,0.00003960}, {153,0.00014851}, {154,0.00000000}, {155,0.00006931}, {156,0.00003960}, {157,0.00006931}, {158,0.00000000}, {159,0.00002970}, {160,0.00000000}, {161,0.00003960}, {162,0.00002970}, {163,0.00000000}, {164,0.00003960}, {165,0.00000000}, {166,0.00007921}, {167,0.00000000}, {168,0.00000000}, {169,0.00006931}, {170,0.00006931}, {171,0.00007921}, {172,0.00002970}, {173,0.00002970}, {174,0.00000000}, {175,0.00000000}, {176,0.00002970}, {177,0.00000000}, {178,0.00000000}, {179,0.00007921}, {180,0.00003960}, {181,0.00010891}, {182,0.00007921}, {183,0.00000000}, {184,0.00002970}, {185,0.00000000}, {186,0.00002970}, {187,0.00002970}, {188,0.00003960}, {189,0.00003960}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00007921}, {194,0.00000000}, {195,0.00000000}, {196,0.00006931}, {197,0.00002970}, {198,0.00003960}, {199,0.00002970}, {200,0.00003960}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00008911}, {205,0.00000000}, {206,0.00003960}, {207,0.00003960}, {208,0.00009901}, {209,0.00008911}, {210,0.00000000}, {211,0.00003960}, {212,0.00007921}, {213,0.00003960}, {214,0.00000000}, {215,0.00000000}, {216,0.00003960}, {217,0.00003960}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00003960}, {224,0.00000000}, {225,0.00000000}, {226,0.00002970}, {227,0.00000000}, {228,0.00002970}, {229,0.00000000}, {230,0.00005941}, {231,0.00005941}, {232,0.00006931}, {233,0.00000000}, {234,0.00002970}, {235,0.00000000}, {236,0.00006931}, {237,0.00003960}, {238,0.00000000}, {239,0.00002970}, {240,0.00003960}, {241,0.00000000}, {242,0.00000000}, {243,0.00002970}, {244,0.00000000}, {245,0.00007921}, {246,0.00000000}, {247,0.00002970}, {248,0.00007921}, {249,0.00000000}, {250,0.00003960}, {251,0.00000000}, {252,0.00000000}, {253,0.00003960}, {254,0.00002970}, {255,0.00007921}, {256,0.00002970}, {257,0.00000000}, {258,0.00000000}, {259,0.00002970}, {260,0.00002970}, {261,0.00000000}, {262,0.00002970}, {263,0.00000000}, {264,0.00002970}, {265,0.00000000}, {266,0.00002970}, {267,0.00006931}, {268,0.00002970}, {269,0.00000000}, {270,0.00007921}, {271,0.00009901}, {272,0.00003960}, {273,0.00003960}, {274,0.00000000}, {275,0.00000000}, {276,0.00003960}, {277,0.00002970}, {278,0.00000000}, {279,0.00002970}, {280,0.00000000}, {281,0.00002970}, {282,0.00000000}, {283,0.00003960}, {284,0.00005941}, {285,0.00002970}, {286,0.00002970}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00002970}, {291,0.00000000}, {292,0.00002970}, {293,0.00003960}, {294,0.00003960}, {295,0.00002970}, {296,0.00000000}, {297,0.00000000}, {298,0.00003960}, {299,0.00002970}, {300,0.00002970}, {301,0.00002970}, {302,0.00000000}, {303,0.00002970}, {304,0.00010891}, {305,0.00000000}, {306,0.00003960}, {307,0.00000000}, {308,0.00003960}, {309,0.00002970}, {310,0.00000000}, {311,0.00000000}, {312,0.00005941}, {313,0.00002970}, {314,0.00005941}, {315,0.00003960}, {316,0.00002970}, {317,0.00000000}, {318,0.00002970}, {319,0.00000000}, {320,0.00003960}, {321,0.00010891}, {322,0.00003960}, {323,0.00000000}, {324,0.00002970}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00011881}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00002970}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00002970}, {337,0.00005941}, {338,0.00012871}, {339,0.00002970}, {340,0.00000000}, {341,0.00000000}, {342,0.00005941}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00002970}, {347,0.00007921}, {348,0.00000000}, {349,0.00002970}, {350,0.00003960}, {351,0.00006931}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00002970}, {356,0.00000000}, {357,0.00000000}, {358,0.00010891}, {359,0.00002970}, {360,0.00003960}, {361,0.00002970}, {362,0.00000000}, {363,0.00000000}, {364,0.00007921}, {365,0.00006931}, {366,0.00002970}, {367,0.00000000}, {368,0.00000000}, {369,0.00003960}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00002970}, {374,0.00000000}, {375,0.00000000}, {376,0.00011881}, {377,0.00000000}, {378,0.00003960}, {379,0.00010891}, {380,0.00000000}, {381,0.00006931}, {382,0.00007921}, {383,0.00003960}, {384,0.00007921}, {385,0.00000000}, {386,0.00000000}, {387,0.00003960}, {388,0.00000000}, {389,0.00003960}, {390,0.00011881}, {391,0.00000000}, {392,0.00003960}, {393,0.00000000}, {394,0.00006931}, {395,0.00000000}, {396,0.00000000}, {397,0.00002970}, {398,0.00003960}, {399,0.00000000}, {400,0.00003960}, {401,0.00002970}, {402,0.00000000}, {403,0.00003960}, {404,0.00000000}, {405,0.00002970}, {406,0.00002970}, {407,0.00000000}, {408,0.00003960}, {409,0.00006931}, {410,0.00010891}, {411,0.00002970}, {412,0.00000000}, {413,0.00003960}, {414,0.00000000}, {415,0.00000000}, {416,0.00013861}, {417,0.00009901}, {418,0.00007921}, {419,0.00003960}, {420,0.00000000}, {421,0.00003960}, {422,0.00003960}, {423,0.00000000}, {424,0.00000000}, {425,0.00003960}, {426,0.00002970}, {427,0.00000000}, {428,0.00002970}, {429,0.00000000}, {430,0.00003960}, {431,0.00003960}, {432,0.00007921}, {433,0.00002970}, {434,0.00003960}, {435,0.00003960}, {436,0.00003960}, {437,0.00003960}, {438,0.00002970}, {439,0.00007921}, {440,0.00000000}, {441,0.00011881}, {442,0.00003960}, {443,0.00002970}, {444,0.00000000}, {445,0.00000000}, {446,0.00009901}, {447,0.00003960}, {448,0.00000000}, {449,0.00000000}, {450,0.00007921}, {451,0.00002970}, {452,0.00007921}, {453,0.00003960}, {454,0.00003960}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00002970}, {459,0.00007921}, {460,0.00003960}, {461,0.00000000}, {462,0.00000000}, {463,0.00007921}, {464,0.00000000}, {465,0.00007921}, {466,0.00003960}, {467,0.00002970}, {468,0.00007921}, {469,0.00010891}, {470,0.00000000}, {471,0.00003960}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00002970}, {477,0.00007921}, {478,0.00002970}, {479,0.00000000}, {480,0.00003960}, {481,0.00000000}, {482,0.00000000}, {483,0.00003960}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00002970}, {491,0.00007921}, {492,0.00002970}, {493,0.00003960}, {494,0.00000000}, {495,0.00005941}, {496,0.00000000}, {497,0.00007921}, {498,0.00003960}, {499,0.00003960}, {500,0.00003960}, {505,0.00007921}, {510,0.00000000}, {515,0.00000000}, {520,0.00002970}, {525,0.00000000}, {530,0.00007921}, {535,0.00002970}, {540,0.00006931}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00002970}, {565,0.00011881}, {570,0.00003960}, {575,0.00003960}, {580,0.00005941}, {585,0.00000000}, {590,0.00003960}, {595,0.00000000}, {600,0.00003960}, {605,0.00000000}, {610,0.00002970}, {615,0.00002970}, {620,0.00000000}, {625,0.00000000}, {630,0.00008911}, {635,0.00000000}, {640,0.00003960}, {645,0.00002970}, {650,0.00003960}, {655,0.00005941}, {660,0.00000000}, {665,0.00000000}, {670,0.00005941}, {675,0.00000000}, {680,0.00002970}, {685,0.00003960}, {690,0.00003960}, {695,0.00002970}, {700,0.00002970}, {705,0.00000000}, {710,0.00003960}, {715,0.00005941}, {720,0.00000000}, {725,0.00005941}, {730,0.00000000}, {735,0.00002970}, {740,0.00002970}, {745,0.00006931}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00002970}, {770,0.00002970}, {775,0.00006931}, {780,0.00002970}, {785,0.00000000}, {790,0.00002970}, {795,0.00000000}, {800,0.00000000}, {805,0.00003960}, {810,0.00000000}, {815,0.00000000}, {820,0.00008911}, {825,0.00006931}, {830,0.00002970}, {835,0.00000000}, {840,0.00000000}, {845,0.00009901}, {850,0.00002970}, {855,0.00000000}, {860,0.00000000}, {865,0.00002970}, {870,0.00002970}, {875,0.00000000}, {880,0.00000000}, {885,0.00006931}, {890,0.00002970}, {895,0.00009901}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00002970}, {920,0.00006931}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00006931}, {950,0.00002970}, {955,0.00000000}, {960,0.00003960}, {965,0.00013861}, {970,0.00003960}, {975,0.00006931}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00006931}, {1030,0.00003960}, {1040,0.00009901}, {1050,0.00000000}, {1060,0.00002970}, {1070,0.00002970}, {1080,0.00002970}, {1090,0.00010891}, {1100,0.00000000}, {1110,0.00005941}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00002970}, {1160,0.00002970}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00002970}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00002970}, {1260,0.00000000}, {1270,0.00002970}, {1280,0.00003960}, {1290,0.00006931}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00003960}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00003960}, {1380,0.00003960}, {1390,0.00002970}, {1400,0.00000000}, {1410,0.00003960}, {1420,0.00002970}, {1430,0.00000000}, {1440,0.00007921}, {1450,0.00002970}, {1460,0.00003960}, {1470,0.00000000}, {1480,0.00006931}, {1490,0.00003960}, {1500,0.00000000}, {1510,0.00003960}, {1520,0.00000000}, {1530,0.00003960}, {1540,0.00000000}, {1550,0.00002970}, {1560,0.00003960}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00003960}, {1600,0.00000000}, {1610,0.00002970}, {1620,0.00000000}, {1630,0.00003960}, {1640,0.00002970}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00003960}, {1680,0.00010891}, {1690,0.00000000}, {1700,0.00003960}, {1710,0.00010891}, {1720,0.00006931}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00002970}, {1770,0.00000000}, {1780,0.00003960}, {1790,0.00006931}, {1800,0.00003960}, {1810,0.00003960}, {1820,0.00000000}, {1830,0.00006931}, {1840,0.00006931}, {1850,0.00003960}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00006931}, {1890,0.00002970}, {1900,0.00003960}, {1910,0.00003960}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00003960}, {1950,0.00000000}, {1960,0.00007921}, {1970,0.00007921}, {1980,0.00000000}, {1990,0.00002970}, {2000,0.00006931}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00006931}, {2200,0.00000000}, {2250,0.00007921}, {2300,0.00011881}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00002970}, {2550,0.00000000}, {2600,0.00002970}, {2650,0.00007921}, {2700,0.00007921}, {2750,0.00006931}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00003960}, {2950,0.00002970}, {3000,0.00003960}, {3050,0.00003960}, {3100,0.00000000}, {3150,0.00009901}, {3200,0.00003960}, {3250,0.00003960}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00003960}, {3450,0.00003960}, {3500,0.00002970}, {3550,0.00002970}, {3600,0.00006931}, {3650,0.00002970}, {3700,0.00002970}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00003960}, {3900,0.00002970}, {3950,0.00003960}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00010891}, {4200,0.00003960}, {4250,0.00003960}, {4300,0.00007921}, {4350,0.00000000}, {4400,0.00003960}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00003960}, {4600,0.00000000}, {4650,0.00003960}, {4700,0.00003960}, {4750,0.00000000}, {4800,0.00003960}, {4850,0.00003960}, {4900,0.00007921}, {4950,0.00003960}, {5000,0.00000000}, {5050,0.00003960}, {5100,0.00003960}, {5150,0.00018812}, {5200,0.00003960}, {5250,0.00003960}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00007921}, {5450,0.00003960}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00003960}, {5650,0.00006931}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00010891}, {5850,0.00000000}, {5900,0.00003960}, {5950,0.00000000}, {6000,0.00002970}, {6050,0.0001143}, {6100,0.0000000}, {6150,0.0001143}, {6200,0.0001143}, {6250,0.0000857}, {6300,0.0000857}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0001143}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0002000}, {6800,0.0000857}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000857}, {7050,0.0002571}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0001143}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0001143}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0001143}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0001143}, {8100,0.0001143}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0001143}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000857}, {8550,0.0000857}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000857}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0001143}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0001143}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0001143}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0001143}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0001143}, {10500,0.0000000}, {10600,0.0001143}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0001143}, {11000,0.0000857}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000857}, {11900,0.0000000}, {12000,0.0001143}, {12100,0.0001143}, {12200,0.0000857}, {12300,0.0002286}, {12400,0.0001143}, {12500,0.0000000}, {12600,0.0001143}, {12700,0.0002000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0002286}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000857}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0001143}, {15200,0.0000857}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0001143}, {15900,0.0002286}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0001143}, {16300,0.0000000}, {16400,0.0000857}, {16500,0.0000000}, {16600,0.0003143}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000857}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000857}, {18500,0.0001714}, {18600,0.0000857}, {18700,0.0000857}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000857}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0001143}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00002970}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00002970}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00003960}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00003960}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00003960}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00003960}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00003960}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00003960}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00003960}, {12,0.00000000}, {13,0.00003960}, {14,0.00000000}, {15,0.00002970}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00002970}, {26,0.00000000}, {27,0.00000000}, {28,0.00003960}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00003960}, {34,0.00000000}, {35,0.00003960}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00002970}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00003960}, {60,0.00002970}, {61,0.00000000}, {62,0.00002970}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00003960}, {68,0.00000000}, {69,0.00003960}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00003960}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00002970}, {121,0.00000000}, {122,0.00000000}, {123,0.00002970}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00002970}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00006931}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00003960}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00003960}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00003960}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00003960}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00003960}, {196,0.00003960}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00002970}, {201,0.00003960}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00003960}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00002970}, {234,0.00003960}, {235,0.00000000}, {236,0.00002970}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00003960}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00002970}, {260,0.00000000}, {261,0.00003960}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00002970}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00003960}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00002970}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00002970}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00003960}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00002970}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00003960}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00002970}, {328,0.00000000}, {329,0.00000000}, {330,0.00003960}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00002970}, {344,0.00003960}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00002970}, {370,0.00003960}, {371,0.00003960}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00003960}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00003960}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00002970}, {391,0.00002970}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00002970}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00002970}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00003960}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00002970}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00002970}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00003960}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00002970}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00003960}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00002970}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00003960}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00002970}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00002970}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00002970}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00002970}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00002970}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00002970}, {810,0.00000000}, {815,0.00000000}, {820,0.00002970}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00002970}, {870,0.00000000}, {875,0.00000000}, {880,0.00003960}, {885,0.00000000}, {890,0.00002970}, {895,0.00000000}, {900,0.00000000}, {905,0.00003960}, {910,0.00002970}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00002970}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00003960}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00002970}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00005941}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00003960}, {1430,0.00000000}, {1440,0.00002970}, {1450,0.00006931}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00003960}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003960}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00003960}, {1720,0.00000000}, {1730,0.00002970}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00003960}, {1870,0.00003960}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00003960}, {1920,0.00003960}, {1930,0.00000000}, {1940,0.00003960}, {1950,0.00003960}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00003960}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00002970}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00007921}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00002970}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00002970}, {3750,0.00002970}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00003960}, {4150,0.00003960}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00003960}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00003960}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0001143}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0001143}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0001143}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0001143}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0001143}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0001143}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0001714}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000857}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000857}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0001143}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0001143}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00036634}, {7,0.00100000}, {8,0.00799010}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00114851}, {14,0.00123762}, {15,0.00200000}, {16,0.00200000}, {17,0.00200000}, {18,0.00200000}, {19,0.00200000}, {20,0.00201980}, {21,0.00223762}, {22,0.00237624}, {23,0.00300000}, {24,0.00300000}, {25,0.00300000}, {26,0.00300000}, {27,0.00301980}, {28,0.00307921}, {29,0.00319802}, {30,0.00335644}, {31,0.00400000}, {32,0.00400000}, {33,0.00400000}, {34,0.00400000}, {35,0.00405941}, {36,0.00414851}, {37,0.00432673}, {38,0.00440594}, {39,0.00495050}, {40,0.00500000}, {41,0.00500000}, {42,0.00501980}, {43,0.00507921}, {44,0.00521782}, {45,0.00532673}, {46,0.00541584}, {47,0.00589109}, {48,0.00599010}, {49,0.00797030}, {50,0.00602970}, {51,0.00607921}, {52,0.00614851}, {53,0.00626733}, {54,0.00655446}, {55,0.00683168}, {56,0.00801980}, {57,0.00700990}, {58,0.00706931}, {59,0.00722772}, {60,0.00733663}, {61,0.00727723}, {62,0.00741584}, {63,0.00783168}, {64,0.00792079}, {65,0.00810891}, {66,0.00815842}, {67,0.00811881}, {68,0.00825743}, {69,0.00834653}, {70,0.00836634}, {71,0.00874257}, {72,0.00941584}, {73,0.00906931}, {74,0.00904950}, {75,0.00921782}, {76,0.00915842}, {77,0.01119802}, {78,0.00936634}, {79,0.00976238}, {80,0.00977228}, {81,0.01014851}, {82,0.01005941}, {83,0.01010891}, {84,0.01353465}, {85,0.01034653}, {86,0.01036634}, {87,0.01075248}, {88,0.01074257}, {89,0.01120792}, {90,0.01108911}, {91,0.01120792}, {92,0.01122772}, {93,0.01127723}, {94,0.01141584}, {95,0.01174257}, {96,0.01163366}, {97,0.01215842}, {98,0.01217822}, {99,0.01228713}, {100,0.01226733}, {101,0.01234653}, {102,0.01240594}, {103,0.01270297}, {104,0.01283168}, {105,0.01302970}, {106,0.01313861}, {107,0.01809901}, {108,0.01448515}, {109,0.01321782}, {110,0.01331683}, {111,0.01379208}, {112,0.01382178}, {113,0.01415842}, {114,0.01813861}, {115,0.01414851}, {116,0.01427723}, {117,0.01428713}, {118,0.01459406}, {119,0.01818812}, {120,0.01471287}, {121,0.01506931}, {122,0.01513861}, {123,0.01872277}, {124,0.01521782}, {125,0.01541584}, {126,0.01553465}, {127,0.01559406}, {128,0.01569307}, {129,0.01615842}, {130,0.01605941}, {131,0.01623762}, {132,0.01634653}, {133,0.01626733}, {134,0.01661386}, {135,0.02200990}, {136,0.01671287}, {137,0.01706931}, {138,0.01704950}, {139,0.01718812}, {140,0.02098020}, {141,0.01736634}, {142,0.01771287}, {143,0.01788119}, {144,0.01788119}, {145,0.01794059}, {146,0.01819802}, {147,0.01830693}, {148,0.01850495}, {149,0.01829703}, {150,0.01854455}, {151,0.01900990}, {152,0.02414851}, {153,0.01910891}, {154,0.02073267}, {155,0.01930693}, {156,0.01936634}, {157,0.01973267}, {158,0.01969307}, {159,0.02156436}, {160,0.01986139}, {161,0.02005941}, {162,0.02400990}, {163,0.02024752}, {164,0.02033663}, {165,0.02433663}, {166,0.02054455}, {167,0.02086139}, {168,0.02238614}, {169,0.02106931}, {170,0.02114851}, {171,0.02130693}, {172,0.02477228}, {173,0.02148515}, {174,0.02171287}, {175,0.02177228}, {176,0.02319802}, {177,0.03220792}, {178,0.02218812}, {179,0.02240594}, {180,0.02232673}, {181,0.02242574}, {182,0.02636634}, {183,0.03019802}, {184,0.02282178}, {185,0.02296040}, {186,0.02306931}, {187,0.02340594}, {188,0.02331683}, {189,0.02361386}, {190,0.02355446}, {191,0.02573267}, {192,0.02697030}, {193,0.02862376}, {194,0.02994059}, {195,0.03080198}, {196,0.03138614}, {197,0.03193069}, {198,0.03196040}, {199,0.03161386}, {200,0.03104950}, {201,0.03015842}, {202,0.02918812}, {203,0.02820792}, {204,0.02653465}, {205,0.02533663}, {206,0.02559406}, {207,0.02588119}, {208,0.02584158}, {209,0.02600990}, {210,0.02604950}, {211,0.02632673}, {212,0.03375248}, {213,0.02852475}, {214,0.02656436}, {215,0.02680198}, {216,0.02689109}, {217,0.02712871}, {218,0.03092079}, {219,0.02718812}, {220,0.02733663}, {221,0.02769307}, {222,0.03434653}, {223,0.02781188}, {224,0.02777228}, {225,0.02774257}, {226,0.03306931}, {227,0.02822772}, {228,0.02820792}, {229,0.03518812}, {230,0.02871287}, {231,0.02903960}, {232,0.03650495}, {233,0.02899010}, {234,0.02921782}, {235,0.03514851}, {236,0.02933663}, {237,0.02975248}, {238,0.03124752}, {239,0.03000990}, {240,0.03557426}, {241,0.03001980}, {242,0.03145545}, {243,0.03028713}, {244,0.03035644}, {245,0.03076238}, {246,0.03068317}, {247,0.03153465}, {248,0.03084158}, {249,0.03211881}, {250,0.03166337}, {251,0.03143564}, {252,0.03187129}, {253,0.03179208}, {254,0.04100000}, {255,0.03206931}, {256,0.03705941}, {257,0.03204950}, {258,0.03208911}, {259,0.03228713}, {260,0.03217822}, {261,0.03797030}, {262,0.03277228}, {263,0.03267327}, {264,0.04010891}, {265,0.03292079}, {266,0.03300990}, {267,0.03999010}, {268,0.03367327}, {269,0.03386139}, {270,0.03896040}, {271,0.03597030}, {272,0.03402970}, {273,0.03391089}, {274,0.04099010}, {275,0.03467327}, {276,0.03459406}, {277,0.03456436}, {278,0.03749505}, {279,0.04293069}, {280,0.03503960}, {281,0.03534653}, {282,0.03515842}, {283,0.03553465}, {284,0.03890099}, {285,0.04275248}, {286,0.04612871}, {287,0.03631683}, {288,0.03624752}, {289,0.03608911}, {290,0.03636634}, {291,0.03658416}, {292,0.03648515}, {293,0.03670297}, {294,0.03915842}, {295,0.03998020}, {296,0.04069307}, {297,0.04128713}, {298,0.04181188}, {299,0.04200990}, {300,0.04066337}, {301,0.04124752}, {302,0.04225743}, {303,0.04121782}, {304,0.03800990}, {305,0.03800000}, {306,0.03831683}, {307,0.03861386}, {308,0.03870297}, {309,0.03879208}, {310,0.03921782}, {311,0.05033663}, {312,0.04652475}, {313,0.04173267}, {314,0.03974257}, {315,0.03992079}, {316,0.03986139}, {317,0.05246535}, {318,0.04709901}, {319,0.04203960}, {320,0.03979208}, {321,0.04039604}, {322,0.05031683}, {323,0.04512871}, {324,0.04027723}, {325,0.04101980}, {326,0.05079208}, {327,0.04493069}, {328,0.04086139}, {329,0.04154455}, {330,0.04827723}, {331,0.04146535}, {332,0.04172277}, {333,0.05239604}, {334,0.04190099}, {335,0.04250495}, {336,0.04838614}, {337,0.04227723}, {338,0.05576238}, {339,0.04511881}, {340,0.04231683}, {341,0.05001980}, {342,0.04270297}, {343,0.05359406}, {344,0.04280198}, {345,0.05653465}, {346,0.04467327}, {347,0.04374257}, {348,0.04566337}, {349,0.04406931}, {350,0.04577228}, {351,0.04431683}, {352,0.04380198}, {353,0.05621782}, {354,0.04419802}, {355,0.05388119}, {356,0.04443564}, {357,0.05429703}, {358,0.04505941}, {359,0.04820792}, {360,0.05860396}, {361,0.04544554}, {362,0.05254455}, {363,0.04564356}, {364,0.04560396}, {365,0.05417822}, {366,0.04591089}, {367,0.04653465}, {368,0.05302970}, {369,0.04632673}, {370,0.04645545}, {371,0.05122772}, {372,0.05765347}, {373,0.04720792}, {374,0.04712871}, {375,0.05261386}, {376,0.05812871}, {377,0.04772277}, {378,0.04738614}, {379,0.05071287}, {380,0.05854455}, {381,0.06504950}, {382,0.04815842}, {383,0.04820792}, {384,0.04782178}, {385,0.05179208}, {386,0.05667327}, {387,0.05940594}, {388,0.06307921}, {389,0.04872277}, {390,0.04908911}, {391,0.04914851}, {392,0.04914851}, {393,0.05033663}, {394,0.05198020}, {395,0.05337624}, {396,0.05432673}, {397,0.05548515}, {398,0.05586139}, {399,0.05986139}, {400,0.05900990}, {401,0.05760396}, {402,0.05726733}, {403,0.05713861}, {404,0.05569307}, {405,0.05505941}, {406,0.05353465}, {407,0.05241584}, {408,0.05112871}, {409,0.05174257}, {410,0.05177228}, {411,0.05196040}, {412,0.06434653}, {413,0.06181188}, {414,0.05870297}, {415,0.05600990}, {416,0.05218812}, {417,0.05277228}, {418,0.05242574}, {419,0.06529703}, {420,0.05964356}, {421,0.05471287}, {422,0.05309901}, {423,0.06916832}, {424,0.06336634}, {425,0.05719802}, {426,0.05369307}, {427,0.06887129}, {428,0.06210891}, {429,0.05552475}, {430,0.05407921}, {431,0.06493069}, {432,0.05740594}, {433,0.05442574}, {434,0.07164356}, {435,0.05930693}, {436,0.05502970}, {437,0.06663366}, {438,0.05664356}, {439,0.07213861}, {440,0.06172277}, {441,0.05543564}, {442,0.06629703}, {443,0.05666337}, {444,0.06914851}, {445,0.05896040}, {446,0.07142574}, {447,0.06063366}, {448,0.05624752}, {449,0.06122772}, {450,0.05633663}, {451,0.06539604}, {452,0.05699010}, {453,0.06325743}, {454,0.05729703}, {455,0.06181188}, {456,0.07153465}, {457,0.05917822}, {458,0.07018812}, {459,0.05782178}, {460,0.06568317}, {461,0.05799010}, {462,0.06039604}, {463,0.06973267}, {464,0.05820792}, {465,0.06327723}, {466,0.07314851}, {467,0.05927723}, {468,0.06609901}, {469,0.07427723}, {470,0.05904950}, {471,0.06396040}, {472,0.07078218}, {473,0.06013861}, {474,0.06009901}, {475,0.06589109}, {476,0.07127723}, {477,0.06216832}, {478,0.06046535}, {479,0.06399010}, {480,0.07075248}, {481,0.08030693}, {482,0.06080198}, {483,0.06100000}, {484,0.06407921}, {485,0.06962376}, {486,0.07250495}, {487,0.07565347}, {488,0.07734653}, {489,0.06170297}, {490,0.06147525}, {491,0.06261386}, {492,0.06462376}, {493,0.06805941}, {494,0.07165347}, {495,0.07167327}, {496,0.07230693}, {497,0.07422772}, {498,0.07390099}, {499,0.07507921}, {500,0.07427723}, {505,0.07417822}, {510,0.07297030}, {515,0.07017822}, {520,0.06676238}, {525,0.06659406}, {530,0.08706931}, {535,0.07653465}, {540,0.06779208}, {545,0.08087129}, {550,0.06911881}, {555,0.08271287}, {560,0.07032673}, {565,0.07914851}, {570,0.08744554}, {575,0.07310891}, {580,0.07912871}, {585,0.08510891}, {590,0.08776238}, {595,0.08960396}, {600,0.09077228}, {605,0.09030693}, {610,0.08909901}, {615,0.08741584}, {620,0.08762376}, {625,0.08131683}, {630,0.09983168}, {635,0.09179208}, {640,0.08310891}, {645,0.09733663}, {650,0.08783168}, {655,0.09946535}, {660,0.08774257}, {665,0.10248515}, {670,0.10857426}, {675,0.09086139}, {680,0.09613861}, {685,0.10124752}, {690,0.10500000}, {695,0.10765347}, {700,0.11867327}, {705,0.11243564}, {710,0.11159406}, {715,0.10808911}, {720,0.10432673}, {725,0.10179208}, {730,0.09892079}, {735,0.11547525}, {740,0.10730693}, {745,0.12068317}, {750,0.10974257}, {755,0.12039604}, {760,0.11479208}, {765,0.12175248}, {770,0.10465347}, {775,0.11189109}, {780,0.11835644}, {785,0.12298020}, {790,0.10835644}, {795,0.11021782}, {800,0.11089109}, {805,0.11155446}, {810,0.11162376}, {815,0.11426733}, {820,0.13353465}, {825,0.12801980}, {830,0.12052475}, {835,0.11445545}, {840,0.12805941}, {845,0.12481188}, {850,0.13801980}, {855,0.12463366}, {860,0.13479208}, {865,0.12961386}, {870,0.13581188}, {875,0.14170297}, {880,0.12301980}, {885,0.12865347}, {890,0.13605941}, {895,0.13567327}, {900,0.13614851}, {905,0.13610891}, {910,0.13538614}, {915,0.14253465}, {920,0.13072277}, {925,0.12953465}, {930,0.12644554}, {935,0.15312871}, {940,0.13698020}, {945,0.15147525}, {950,0.13953465}, {955,0.13147525}, {960,0.14491089}, {965,0.14489109}, {970,0.13721782}, {975,0.14443564}, {980,0.15647525}, {985,0.13564356}, {990,0.13840594}, {995,0.14156436}, {1000,0.14597030}, {1010,0.14610891}, {1020,0.14331683}, {1030,0.16078218}, {1040,0.16059406}, {1050,0.15160396}, {1060,0.16096040}, {1070,0.15888119}, {1080,0.16145545}, {1090,0.16321782}, {1100,0.16757426}, {1110,0.17380198}, {1120,0.16989109}, {1130,0.16504950}, {1140,0.16297030}, {1150,0.17692079}, {1160,0.16368317}, {1170,0.18957426}, {1180,0.18645545}, {1190,0.16777228}, {1200,0.17783168}, {1210,0.16671287}, {1220,0.17062376}, {1230,0.20731683}, {1240,0.18821782}, {1250,0.17764356}, {1260,0.19575248}, {1270,0.20351485}, {1280,0.18423762}, {1290,0.19686139}, {1300,0.19678218}, {1310,0.19739604}, {1320,0.19655446}, {1330,0.19443564}, {1340,0.20236634}, {1350,0.20856436}, {1360,0.19565347}, {1370,0.21329703}, {1380,0.21417822}, {1390,0.19234653}, {1400,0.20363366}, {1410,0.20221782}, {1420,0.20768317}, {1430,0.22298020}, {1440,0.23564356}, {1450,0.21530693}, {1460,0.22314851}, {1470,0.21899010}, {1480,0.21850495}, {1490,0.23401980}, {1500,0.23077228}, {1510,0.23932673}, {1520,0.23489109}, {1530,0.22699010}, {1540,0.22820792}, {1550,0.23784158}, {1560,0.23698020}, {1570,0.24010891}, {1580,0.23888119}, {1590,0.23452475}, {1600,0.25827723}, {1610,0.24300990}, {1620,0.25967327}, {1630,0.24162376}, {1640,0.25117822}, {1650,0.25354455}, {1660,0.26110891}, {1670,0.25424752}, {1680,0.24698020}, {1690,0.25036634}, {1700,0.25639604}, {1710,0.25697030}, {1720,0.27309901}, {1730,0.25163366}, {1740,0.27929703}, {1750,0.26167327}, {1760,0.26002970}, {1770,0.26422772}, {1780,0.28251485}, {1790,0.27829703}, {1800,0.26498020}, {1810,0.26357426}, {1820,0.26927723}, {1830,0.26359406}, {1840,0.27954455}, {1850,0.28614851}, {1860,0.28731683}, {1870,0.28167327}, {1880,0.28625743}, {1890,0.30058416}, {1900,0.29661386}, {1910,0.27887129}, {1920,0.28514851}, {1930,0.29760396}, {1940,0.29993069}, {1950,0.31191089}, {1960,0.29969307}, {1970,0.29816832}, {1980,0.29782178}, {1990,0.30839604}, {2000,0.33126733}, {2050,0.31050495}, {2100,0.31065347}, {2150,0.34251485}, {2200,0.32392079}, {2250,0.34835644}, {2300,0.38866337}, {2350,0.35773267}, {2400,0.37163366}, {2450,0.37962376}, {2500,0.40049505}, {2550,0.42333663}, {2600,0.40063366}, {2650,0.40542574}, {2700,0.41820792}, {2750,0.43058416}, {2800,0.43412871}, {2850,0.45086139}, {2900,0.46556436}, {2950,0.46495050}, {3000,0.48467327}, {3050,0.48487129}, {3100,0.49699010}, {3150,0.50095050}, {3200,0.49297030}, {3250,0.52891089}, {3300,0.51820792}, {3350,0.52769307}, {3400,0.53779208}, {3450,0.54437624}, {3500,0.54686139}, {3550,0.55251485}, {3600,0.55303960}, {3650,0.56422772}, {3700,0.57635644}, {3750,0.57067327}, {3800,0.58706931}, {3850,0.60353465}, {3900,0.63444554}, {3950,0.61367327}, {4000,0.62912871}, {4050,0.62860396}, {4100,0.63082178}, {4150,0.66616832}, {4200,0.64482178}, {4250,0.65203960}, {4300,0.68821782}, {4350,0.67115842}, {4400,0.67698020}, {4450,0.70359406}, {4500,0.70409901}, {4550,0.70683168}, {4600,0.74916832}, {4650,0.72496040}, {4700,0.75500000}, {4750,0.74628713}, {4800,0.73267327}, {4850,0.76728713}, {4900,0.76294059}, {4950,0.77515842}, {5000,0.77759406}, {5050,0.92019802}, {5100,0.80111881}, {5150,0.80227723}, {5200,0.83020792}, {5250,0.83325743}, {5300,0.83628713}, {5350,0.86252475}, {5400,0.84045545}, {5450,0.85675248}, {5500,0.86066337}, {5550,0.87600000}, {5600,0.89315842}, {5650,0.87669307}, {5700,0.89811881}, {5750,0.90703960}, {5800,0.93443564}, {5850,0.93904950}, {5900,0.92798020}, {5950,0.94671287}, {6000,0.93694059}, {6050,1.0434857}, {6100,1.0076857}, {6150,0.9773714}, {6200,1.0099143}, {6250,1.0068286}, {6300,1.0074000}, {6350,1.0295143}, {6400,1.0222286}, {6450,1.0467714}, {6500,1.0763429}, {6550,1.0837714}, {6600,1.0864000}, {6650,1.1110286}, {6700,1.0984000}, {6750,1.1260571}, {6800,1.1132571}, {6850,1.1215429}, {6900,1.1486857}, {6950,1.1532857}, {7000,1.1491429}, {7050,1.1471714}, {7100,1.1716857}, {7150,1.1704571}, {7200,1.1487143}, {7250,1.1709143}, {7300,1.2053143}, {7350,1.2390000}, {7400,1.2491429}, {7450,1.2575429}, {7500,1.2407714}, {7550,1.2678000}, {7600,1.2692571}, {7650,1.2536571}, {7700,1.2544571}, {7750,1.3165143}, {7800,1.3120000}, {7850,1.3154571}, {7900,1.3129714}, {7950,1.3071429}, {8000,1.3374286}, {8050,1.3582857}, {8100,1.3616571}, {8150,1.3663143}, {8200,1.3232571}, {8250,1.3655143}, {8300,1.3946857}, {8350,1.3848000}, {8400,1.3755714}, {8450,1.3753714}, {8500,1.4366571}, {8550,1.4358857}, {8600,1.3986857}, {8650,1.4586571}, {8700,1.4681429}, {8750,1.4409143}, {8800,1.4733714}, {8850,1.4852857}, {8900,1.4719714}, {8950,1.5062000}, {9000,1.4983714}, {9050,1.4903429}, {9100,1.5238857}, {9150,1.5561429}, {9200,1.5173429}, {9250,1.5645143}, {9300,1.5775143}, {9350,1.5496571}, {9400,1.5675714}, {9450,1.5706286}, {9500,1.6013714}, {9550,1.6136286}, {9600,1.6206857}, {9650,1.6221143}, {9700,1.6024857}, {9750,1.6508286}, {9800,1.6072286}, {9850,1.6596857}, {9900,1.6369714}, {9950,1.6902571}, {10000,1.6458571}, {10100,1.6986857}, {10200,1.6963429}, {10300,1.7229714}, {10400,1.6886286}, {10500,1.7415143}, {10600,1.7445429}, {10700,1.7954286}, {10800,1.7336000}, {10900,1.8262286}, {11000,1.8192286}, {11100,1.8606571}, {11200,1.8507714}, {11300,1.8695143}, {11400,1.8810857}, {11500,1.9093714}, {11600,1.9336571}, {11700,1.9526286}, {11800,1.9440857}, {11900,1.9968857}, {12000,1.9814000}, {12100,2.0113143}, {12200,2.0398571}, {12300,2.0185429}, {12400,2.0431143}, {12500,2.0772000}, {12600,2.1022857}, {12700,2.1022286}, {12800,2.0850286}, {12900,2.1242857}, {13000,2.1547143}, {13100,2.1602000}, {13200,2.1641143}, {13300,2.2304571}, {13400,2.2121429}, {13500,2.2511429}, {13600,2.2424857}, {13700,2.2549714}, {13800,2.2898571}, {13900,2.3031429}, {14000,2.3214857}, {14100,2.3526571}, {14200,2.4590000}, {14300,2.4006571}, {14400,2.3668571}, {14500,2.7500000}, {14600,2.4073714}, {14700,2.6138571}, {14800,2.5052000}, {14900,2.4532286}, {15000,2.4774286}, {15100,2.5185429}, {15200,2.5842571}, {15300,2.5305714}, {15400,2.7209714}, {15500,2.5685429}, {15600,2.5812857}, {15700,2.6854286}, {15800,2.6822000}, {15900,2.6208286}, {16000,2.6144857}, {16100,2.6710571}, {16200,2.6606000}, {16300,2.7222857}, {16400,2.6848857}, {16500,2.7246000}, {16600,2.9279143}, {16700,2.7742000}, {16800,2.7653714}, {16900,2.7682286}, {17000,2.8166571}, {17100,2.9335714}, {17200,2.8246286}, {17300,2.8643429}, {17400,2.8804857}, {17500,2.8856286}, {17600,2.9003429}, {17700,2.9028571}, {17800,2.9176286}, {17900,2.9893143}, {18000,2.9374000}, {18100,3.0056571}, {18200,2.9994571}, {18300,3.0718286}, {18400,3.0524857}, {18500,3.0562000}, {18600,3.0667714}, {18700,3.0938000}, {18800,3.1143143}, {18900,3.1526571}, {19000,3.3847143}, {19100,3.1865429}, {19200,3.3122571}, {19300,3.2047429}, {19400,3.2219143}, {19500,3.3901429}, {19600,3.2744286}, {19700,3.4790286}, {19800,3.2888571}, {19900,3.4842857}, {20000,3.4077143}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["reif"]["user"] = {{1,0.00033663}, {2,0.00039604}, {3,0.00041584}, {4,0.00078218}, {5,0.00071287}, {6,0.00066337}, {7,0.00134653}, {8,0.00822772}, {9,0.00141584}, {10,0.00158416}, {11,0.00109901}, {12,0.00166337}, {13,0.00173267}, {14,0.00169307}, {15,0.00166337}, {16,0.00185149}, {17,0.00207921}, {18,0.00239604}, {19,0.00243564}, {20,0.00220792}, {21,0.00250495}, {22,0.00266337}, {23,0.00279208}, {24,0.00300990}, {25,0.00300990}, {26,0.00307921}, {27,0.00310891}, {28,0.00333663}, {29,0.00330693}, {30,0.00338614}, {31,0.00355446}, {32,0.00386139}, {33,0.00378218}, {34,0.00421782}, {35,0.00419802}, {36,0.00415842}, {37,0.00454455}, {38,0.00422772}, {39,0.00503960}, {40,0.00496040}, {41,0.00511881}, {42,0.00511881}, {43,0.00504950}, {44,0.00518812}, {45,0.00565347}, {46,0.00554455}, {47,0.00601980}, {48,0.00625743}, {49,0.00803960}, {50,0.00641584}, {51,0.00604950}, {52,0.00649505}, {53,0.00678218}, {54,0.00704950}, {55,0.00720792}, {56,0.00819802}, {57,0.00733663}, {58,0.00714851}, {59,0.00728713}, {60,0.00731683}, {61,0.00766337}, {62,0.00759406}, {63,0.00777228}, {64,0.00780198}, {65,0.00799010}, {66,0.00810891}, {67,0.00830693}, {68,0.00835644}, {69,0.00848515}, {70,0.00856436}, {71,0.00874257}, {72,0.00933663}, {73,0.00922772}, {74,0.00906931}, {75,0.00944554}, {76,0.00923762}, {77,0.01133663}, {78,0.00955446}, {79,0.01009901}, {80,0.01004950}, {81,0.01000000}, {82,0.01039604}, {83,0.01008911}, {84,0.01368317}, {85,0.01086139}, {86,0.01040594}, {87,0.01103960}, {88,0.01064356}, {89,0.01106931}, {90,0.01087129}, {91,0.01138614}, {92,0.01133663}, {93,0.01151485}, {94,0.01196040}, {95,0.01180198}, {96,0.01178218}, {97,0.01217822}, {98,0.01234653}, {99,0.01227723}, {100,0.01233663}, {101,0.01235644}, {102,0.01295050}, {103,0.01287129}, {104,0.01290099}, {105,0.01284158}, {106,0.01326733}, {107,0.01810891}, {108,0.01518812}, {109,0.01343564}, {110,0.01363366}, {111,0.01380198}, {112,0.01396040}, {113,0.01431683}, {114,0.01801980}, {115,0.01443564}, {116,0.01451485}, {117,0.01492079}, {118,0.01500000}, {119,0.01799010}, {120,0.01503960}, {121,0.01547525}, {122,0.01544554}, {123,0.01840594}, {124,0.01554455}, {125,0.01580198}, {126,0.01582178}, {127,0.01589109}, {128,0.01615842}, {129,0.01639604}, {130,0.01633663}, {131,0.01626733}, {132,0.01657426}, {133,0.01639604}, {134,0.01707921}, {135,0.02159406}, {136,0.01689109}, {137,0.01729703}, {138,0.01719802}, {139,0.01735644}, {140,0.02059406}, {141,0.01776238}, {142,0.01747525}, {143,0.01771287}, {144,0.01792079}, {145,0.01757426}, {146,0.01766337}, {147,0.01811881}, {148,0.01819802}, {149,0.01775248}, {150,0.01837624}, {151,0.01846535}, {152,0.02410891}, {153,0.01856436}, {154,0.02010891}, {155,0.01879208}, {156,0.01877228}, {157,0.01944554}, {158,0.01929703}, {159,0.02146535}, {160,0.01964356}, {161,0.01943564}, {162,0.02385149}, {163,0.02003960}, {164,0.02003960}, {165,0.02429703}, {166,0.02029703}, {167,0.02057426}, {168,0.02241584}, {169,0.02057426}, {170,0.02067327}, {171,0.02135644}, {172,0.02472277}, {173,0.02149505}, {174,0.02158416}, {175,0.02180198}, {176,0.02317822}, {177,0.03176238}, {178,0.02215842}, {179,0.02234653}, {180,0.02197030}, {181,0.02229703}, {182,0.02619802}, {183,0.03046535}, {184,0.02313861}, {185,0.02300000}, {186,0.02324752}, {187,0.02352475}, {188,0.02361386}, {189,0.02388119}, {190,0.02387129}, {191,0.02584158}, {192,0.02669307}, {193,0.02871287}, {194,0.02996040}, {195,0.03063366}, {196,0.03149505}, {197,0.03225743}, {198,0.03184158}, {199,0.03148515}, {200,0.03091089}, {201,0.03008911}, {202,0.02871287}, {203,0.02810891}, {204,0.02657426}, {205,0.02494059}, {206,0.02565347}, {207,0.02604950}, {208,0.02580198}, {209,0.02594059}, {210,0.02587129}, {211,0.02613861}, {212,0.03370297}, {213,0.02837624}, {214,0.02656436}, {215,0.02671287}, {216,0.02690099}, {217,0.02663366}, {218,0.03118812}, {219,0.02702970}, {220,0.02712871}, {221,0.02772277}, {222,0.03442574}, {223,0.02761386}, {224,0.02767327}, {225,0.02759406}, {226,0.03313861}, {227,0.02816832}, {228,0.02813861}, {229,0.03519802}, {230,0.02861386}, {231,0.02876238}, {232,0.03633663}, {233,0.02887129}, {234,0.02916832}, {235,0.03509901}, {236,0.02886139}, {237,0.02990099}, {238,0.03079208}, {239,0.02957426}, {240,0.03587129}, {241,0.02952475}, {242,0.03120792}, {243,0.03037624}, {244,0.03008911}, {245,0.03050495}, {246,0.03044554}, {247,0.03143564}, {248,0.03070297}, {249,0.03214851}, {250,0.03151485}, {251,0.03151485}, {252,0.03198020}, {253,0.03147525}, {254,0.04072277}, {255,0.03214851}, {256,0.03676238}, {257,0.03193069}, {258,0.03184158}, {259,0.03215842}, {260,0.03222772}, {261,0.03788119}, {262,0.03272277}, {263,0.03254455}, {264,0.03974257}, {265,0.03298020}, {266,0.03325743}, {267,0.03942574}, {268,0.03400000}, {269,0.03358416}, {270,0.03851485}, {271,0.03608911}, {272,0.03382178}, {273,0.03408911}, {274,0.04085149}, {275,0.03466337}, {276,0.03518812}, {277,0.03470297}, {278,0.03742574}, {279,0.04259406}, {280,0.03538614}, {281,0.03524752}, {282,0.03508911}, {283,0.03595050}, {284,0.03867327}, {285,0.04232673}, {286,0.04610891}, {287,0.03640594}, {288,0.03615842}, {289,0.03612871}, {290,0.03623762}, {291,0.03653465}, {292,0.03638614}, {293,0.03660396}, {294,0.03902970}, {295,0.03987129}, {296,0.04052475}, {297,0.04095050}, {298,0.04134653}, {299,0.04164356}, {300,0.04023762}, {301,0.04083168}, {302,0.04185149}, {303,0.04068317}, {304,0.03773267}, {305,0.03804950}, {306,0.03806931}, {307,0.03831683}, {308,0.03839604}, {309,0.03836634}, {310,0.03865347}, {311,0.04981188}, {312,0.04653465}, {313,0.04123762}, {314,0.03931683}, {315,0.03949505}, {316,0.03959406}, {317,0.05199010}, {318,0.04713861}, {319,0.04199010}, {320,0.03924752}, {321,0.03995050}, {322,0.04990099}, {323,0.04477228}, {324,0.04002970}, {325,0.04074257}, {326,0.05043564}, {327,0.04500000}, {328,0.04044554}, {329,0.04134653}, {330,0.04811881}, {331,0.04126733}, {332,0.04135644}, {333,0.05208911}, {334,0.04141584}, {335,0.04235644}, {336,0.04851485}, {337,0.04209901}, {338,0.05540594}, {339,0.04499010}, {340,0.04160396}, {341,0.04974257}, {342,0.04240594}, {343,0.05290099}, {344,0.04230693}, {345,0.05642574}, {346,0.04488119}, {347,0.04340594}, {348,0.04531683}, {349,0.04421782}, {350,0.04591089}, {351,0.04388119}, {352,0.04385149}, {353,0.05622772}, {354,0.04395050}, {355,0.05380198}, {356,0.04423762}, {357,0.05392079}, {358,0.04472277}, {359,0.04844554}, {360,0.05847525}, {361,0.04528713}, {362,0.05237624}, {363,0.04553465}, {364,0.04539604}, {365,0.05390099}, {366,0.04572277}, {367,0.04700990}, {368,0.05275248}, {369,0.04612871}, {370,0.04644554}, {371,0.05126733}, {372,0.05790099}, {373,0.04747525}, {374,0.04747525}, {375,0.05262376}, {376,0.05816832}, {377,0.04773267}, {378,0.04725743}, {379,0.05076238}, {380,0.05863366}, {381,0.06483168}, {382,0.04810891}, {383,0.04851485}, {384,0.04775248}, {385,0.05169307}, {386,0.05649505}, {387,0.05920792}, {388,0.06250495}, {389,0.04897030}, {390,0.04912871}, {391,0.04911881}, {392,0.04951485}, {393,0.05046535}, {394,0.05175248}, {395,0.05324752}, {396,0.05398020}, {397,0.05504950}, {398,0.05519802}, {399,0.05975248}, {400,0.05904950}, {401,0.05751485}, {402,0.05736634}, {403,0.05710891}, {404,0.05539604}, {405,0.05459406}, {406,0.05340594}, {407,0.05217822}, {408,0.05105941}, {409,0.05202970}, {410,0.05159406}, {411,0.05187129}, {412,0.06368317}, {413,0.06181188}, {414,0.05882178}, {415,0.05594059}, {416,0.05217822}, {417,0.05238614}, {418,0.05223762}, {419,0.06518812}, {420,0.05937624}, {421,0.05427723}, {422,0.05273267}, {423,0.06898020}, {424,0.06307921}, {425,0.05700000}, {426,0.05349505}, {427,0.06883168}, {428,0.06201980}, {429,0.05496040}, {430,0.05363366}, {431,0.06495050}, {432,0.05700990}, {433,0.05396040}, {434,0.07160396}, {435,0.05931683}, {436,0.05474257}, {437,0.06647525}, {438,0.05679208}, {439,0.07215842}, {440,0.06141584}, {441,0.05509901}, {442,0.06588119}, {443,0.05627723}, {444,0.06870297}, {445,0.05920792}, {446,0.07130693}, {447,0.06070297}, {448,0.05582178}, {449,0.06122772}, {450,0.05596040}, {451,0.06537624}, {452,0.05662376}, {453,0.06303960}, {454,0.05680198}, {455,0.06228713}, {456,0.07145545}, {457,0.05915842}, {458,0.07018812}, {459,0.05763366}, {460,0.06523762}, {461,0.05800990}, {462,0.06033663}, {463,0.06946535}, {464,0.05841584}, {465,0.06330693}, {466,0.07348515}, {467,0.05915842}, {468,0.06570297}, {469,0.07413861}, {470,0.05882178}, {471,0.06367327}, {472,0.07095050}, {473,0.06002970}, {474,0.06014851}, {475,0.06548515}, {476,0.07131683}, {477,0.06219802}, {478,0.06079208}, {479,0.06419802}, {480,0.07056436}, {481,0.07989109}, {482,0.06066337}, {483,0.06129703}, {484,0.06380198}, {485,0.06965347}, {486,0.07236634}, {487,0.07517822}, {488,0.07709901}, {489,0.06144554}, {490,0.06141584}, {491,0.06242574}, {492,0.06428713}, {493,0.06779208}, {494,0.07151485}, {495,0.07166337}, {496,0.07226733}, {497,0.07417822}, {498,0.07393069}, {499,0.07488119}, {500,0.07432673}, {505,0.07427723}, {510,0.07284158}, {515,0.07019802}, {520,0.06635644}, {525,0.06629703}, {530,0.08708911}, {535,0.07600990}, {540,0.06773267}, {545,0.08082178}, {550,0.06915842}, {555,0.08291089}, {560,0.07014851}, {565,0.07907921}, {570,0.08732673}, {575,0.07307921}, {580,0.07893069}, {585,0.08492079}, {590,0.08746535}, {595,0.08929703}, {600,0.09084158}, {605,0.08991089}, {610,0.08878218}, {615,0.08717822}, {620,0.08746535}, {625,0.08102970}, {630,0.09954455}, {635,0.09183168}, {640,0.08327723}, {645,0.09747525}, {650,0.08739604}, {655,0.09919802}, {660,0.08772277}, {665,0.10234653}, {670,0.10841584}, {675,0.09067327}, {680,0.09604950}, {685,0.10073267}, {690,0.10478218}, {695,0.10745545}, {700,0.11849505}, {705,0.11224752}, {710,0.11122772}, {715,0.10794059}, {720,0.10401980}, {725,0.10157426}, {730,0.09861386}, {735,0.11522772}, {740,0.10712871}, {745,0.12050495}, {750,0.10941584}, {755,0.12033663}, {760,0.11469307}, {765,0.12148515}, {770,0.10450495}, {775,0.11151485}, {780,0.11801980}, {785,0.12247525}, {790,0.10855446}, {795,0.10979208}, {800,0.11052475}, {805,0.11125743}, {810,0.11141584}, {815,0.11395050}, {820,0.13336634}, {825,0.12776238}, {830,0.12056436}, {835,0.11424752}, {840,0.12797030}, {845,0.12411881}, {850,0.13812871}, {855,0.12440594}, {860,0.13468317}, {865,0.12939604}, {870,0.13552475}, {875,0.14136634}, {880,0.12274257}, {885,0.12814851}, {890,0.13591089}, {895,0.13549505}, {900,0.13600000}, {905,0.13593069}, {910,0.13517822}, {915,0.14216832}, {920,0.13079208}, {925,0.12921782}, {930,0.12628713}, {935,0.15269307}, {940,0.13681188}, {945,0.15137624}, {950,0.13953465}, {955,0.13148515}, {960,0.14476238}, {965,0.14440594}, {970,0.13700990}, {975,0.14402970}, {980,0.15624752}, {985,0.13537624}, {990,0.13842574}, {995,0.14151485}, {1000,0.14569307}, {1010,0.14575248}, {1020,0.14283168}, {1030,0.16048515}, {1040,0.16005941}, {1050,0.15120792}, {1060,0.16051485}, {1070,0.15836634}, {1080,0.16105941}, {1090,0.16314851}, {1100,0.16700000}, {1110,0.17310891}, {1120,0.16949505}, {1130,0.16464356}, {1140,0.16249505}, {1150,0.17665347}, {1160,0.16336634}, {1170,0.18908911}, {1180,0.18604950}, {1190,0.16759406}, {1200,0.17719802}, {1210,0.16639604}, {1220,0.17020792}, {1230,0.20687129}, {1240,0.18768317}, {1250,0.17722772}, {1260,0.19500990}, {1270,0.20325743}, {1280,0.18371287}, {1290,0.19630693}, {1300,0.19633663}, {1310,0.19657426}, {1320,0.19608911}, {1330,0.19408911}, {1340,0.20184158}, {1350,0.20810891}, {1360,0.19486139}, {1370,0.21291089}, {1380,0.21343564}, {1390,0.19154455}, {1400,0.20281188}, {1410,0.20158416}, {1420,0.20700990}, {1430,0.22231683}, {1440,0.23493069}, {1450,0.21445545}, {1460,0.22274257}, {1470,0.21855446}, {1480,0.21814851}, {1490,0.23378218}, {1500,0.23027723}, {1510,0.23848515}, {1520,0.23439604}, {1530,0.22641584}, {1540,0.22771287}, {1550,0.23720792}, {1560,0.23650495}, {1570,0.23949505}, {1580,0.23825743}, {1590,0.23404950}, {1600,0.25775248}, {1610,0.24205941}, {1620,0.25909901}, {1630,0.24107921}, {1640,0.25059406}, {1650,0.25265347}, {1660,0.26036634}, {1670,0.25348515}, {1680,0.24636634}, {1690,0.24941584}, {1700,0.25561386}, {1710,0.25626733}, {1720,0.27257426}, {1730,0.25070297}, {1740,0.27841584}, {1750,0.26062376}, {1760,0.25947525}, {1770,0.26340594}, {1780,0.28119802}, {1790,0.27796040}, {1800,0.26404950}, {1810,0.26274257}, {1820,0.26842574}, {1830,0.26288119}, {1840,0.27863366}, {1850,0.28538614}, {1860,0.28662376}, {1870,0.28073267}, {1880,0.28511881}, {1890,0.29949505}, {1900,0.29596040}, {1910,0.27813861}, {1920,0.28428713}, {1930,0.29625743}, {1940,0.29911881}, {1950,0.31087129}, {1960,0.29869307}, {1970,0.29718812}, {1980,0.29693069}, {1990,0.30757426}, {2000,0.33001980}, {2050,0.30947525}, {2100,0.30961386}, {2150,0.34149505}, {2200,0.32297030}, {2250,0.34748515}, {2300,0.38759406}, {2350,0.35677228}, {2400,0.37089109}, {2450,0.37855446}, {2500,0.39955446}, {2550,0.42200000}, {2600,0.39969307}, {2650,0.40432673}, {2700,0.41711881}, {2750,0.42977228}, {2800,0.43303960}, {2850,0.44983168}, {2900,0.46456436}, {2950,0.46412871}, {3000,0.48350495}, {3050,0.48392079}, {3100,0.49438614}, {3150,0.49960396}, {3200,0.49186139}, {3250,0.52795050}, {3300,0.51739604}, {3350,0.52697030}, {3400,0.53703960}, {3450,0.54339604}, {3500,0.54590099}, {3550,0.55148515}, {3600,0.55215842}, {3650,0.56319802}, {3700,0.57526733}, {3750,0.56973267}, {3800,0.58594059}, {3850,0.60252475}, {3900,0.63337624}, {3950,0.61247525}, {4000,0.62828713}, {4050,0.62744554}, {4100,0.62975248}, {4150,0.66489109}, {4200,0.64363366}, {4250,0.65091089}, {4300,0.68713861}, {4350,0.66984158}, {4400,0.67563366}, {4450,0.70178218}, {4500,0.70304950}, {4550,0.70528713}, {4600,0.74768317}, {4650,0.72368317}, {4700,0.75367327}, {4750,0.74493069}, {4800,0.73144554}, {4850,0.76558416}, {4900,0.76119802}, {4950,0.77366337}, {5000,0.77589109}, {5050,0.91776238}, {5100,0.79941584}, {5150,0.80035644}, {5200,0.82838614}, {5250,0.83150495}, {5300,0.83465347}, {5350,0.86076238}, {5400,0.83866337}, {5450,0.85451485}, {5500,0.85882178}, {5550,0.87454455}, {5600,0.89113861}, {5650,0.87471287}, {5700,0.89612871}, {5750,0.90508911}, {5800,0.93284158}, {5850,0.93732673}, {5900,0.92633663}, {5950,0.94474257}, {6000,0.93537624}, {6050,1.0398571}, {6100,1.0058571}, {6150,0.9758286}, {6200,1.0086571}, {6250,1.0035429}, {6300,1.0064000}, {6350,1.0286571}, {6400,1.0210000}, {6450,1.0457429}, {6500,1.0754571}, {6550,1.0830000}, {6600,1.0856286}, {6650,1.1102857}, {6700,1.0972571}, {6750,1.1226857}, {6800,1.1111429}, {6850,1.1202286}, {6900,1.1471429}, {6950,1.1487714}, {7000,1.1476571}, {7050,1.1462286}, {7100,1.1704571}, {7150,1.1697429}, {7200,1.1477714}, {7250,1.1690000}, {7300,1.2043429}, {7350,1.2363429}, {7400,1.2470857}, {7450,1.2546000}, {7500,1.2383429}, {7550,1.2631143}, {7600,1.2627429}, {7650,1.2511429}, {7700,1.2459714}, {7750,1.3074286}, {7800,1.3080286}, {7850,1.3119143}, {7900,1.3084000}, {7950,1.2993143}, {8000,1.3360000}, {8050,1.3563714}, {8100,1.3601143}, {8150,1.3646286}, {8200,1.3223429}, {8250,1.3638857}, {8300,1.3928857}, {8350,1.3834000}, {8400,1.3741143}, {8450,1.3736571}, {8500,1.4344857}, {8550,1.4337429}, {8600,1.3967429}, {8650,1.4558857}, {8700,1.4668000}, {8750,1.4396000}, {8800,1.4722857}, {8850,1.4834286}, {8900,1.4700571}, {8950,1.5047429}, {9000,1.4966857}, {9050,1.4882857}, {9100,1.5216000}, {9150,1.5542571}, {9200,1.5151429}, {9250,1.5594571}, {9300,1.5678286}, {9350,1.5470857}, {9400,1.5658286}, {9450,1.5686857}, {9500,1.5990857}, {9550,1.6122857}, {9600,1.6181143}, {9650,1.6195429}, {9700,1.6000857}, {9750,1.6486000}, {9800,1.6048571}, {9850,1.6574857}, {9900,1.6347143}, {9950,1.6881429}, {10000,1.6433143}, {10100,1.6959714}, {10200,1.6871714}, {10300,1.7200857}, {10400,1.6868000}, {10500,1.7384000}, {10600,1.7422000}, {10700,1.7935714}, {10800,1.7308571}, {10900,1.8231143}, {11000,1.8169429}, {11100,1.8579714}, {11200,1.8483429}, {11300,1.8658571}, {11400,1.8775714}, {11500,1.9066857}, {11600,1.9300857}, {11700,1.9497714}, {11800,1.9399429}, {11900,1.9935714}, {12000,1.9782571}, {12100,2.0076857}, {12200,2.0360571}, {12300,2.0150000}, {12400,2.0392571}, {12500,2.0733429}, {12600,2.0989714}, {12700,2.0981714}, {12800,2.0819143}, {12900,2.1205143}, {13000,2.1518857}, {13100,2.1570857}, {13200,2.1611714}, {13300,2.2262571}, {13400,2.2091429}, {13500,2.2475714}, {13600,2.2397429}, {13700,2.2521714}, {13800,2.2882571}, {13900,2.3002857}, {14000,2.3181143}, {14100,2.3489714}, {14200,2.4552286}, {14300,2.3977714}, {14400,2.3640000}, {14500,2.7444857}, {14600,2.4048857}, {14700,2.6096857}, {14800,2.5021143}, {14900,2.4498857}, {15000,2.4739714}, {15100,2.5160000}, {15200,2.5807143}, {15300,2.5268857}, {15400,2.7164857}, {15500,2.5659714}, {15600,2.5782857}, {15700,2.6823429}, {15800,2.6795714}, {15900,2.6176857}, {16000,2.6121714}, {16100,2.6684000}, {16200,2.6574857}, {16300,2.7202000}, {16400,2.6832286}, {16500,2.7220000}, {16600,2.9252286}, {16700,2.7713714}, {16800,2.7626571}, {16900,2.7656571}, {17000,2.8146571}, {17100,2.9296286}, {17200,2.8199143}, {17300,2.8599714}, {17400,2.8780571}, {17500,2.8817143}, {17600,2.8970857}, {17700,2.8989143}, {17800,2.9134571}, {17900,2.9853429}, {18000,2.9344000}, {18100,3.0018571}, {18200,2.9952571}, {18300,3.0669714}, {18400,3.0483143}, {18500,3.0519143}, {18600,3.0623429}, {18700,3.0892000}, {18800,3.0940857}, {18900,3.1472571}, {19000,3.3477429}, {19100,3.1624286}, {19200,3.3069143}, {19300,3.1979429}, {19400,3.2153143}, {19500,3.3750000}, {19600,3.2566571}, {19700,3.4547429}, {19800,3.2775429}, {19900,3.4796286}, {20000,3.4044000}};
data["big_flat"]["LtacTacInTermGallinaCtx"]["reif"]["system"] = {{1,0.00000000}, {2,0.00003960}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00003960}, {7,0.00000000}, {8,0.00013861}, {9,0.00003960}, {10,0.00000000}, {11,0.00003960}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00002970}, {18,0.00003960}, {19,0.00000000}, {20,0.00000000}, {21,0.00003960}, {22,0.00007921}, {23,0.00003960}, {24,0.00000000}, {25,0.00000000}, {26,0.00002970}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00007921}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00003960}, {35,0.00003960}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00003960}, {40,0.00003960}, {41,0.00000000}, {42,0.00000000}, {43,0.00002970}, {44,0.00003960}, {45,0.00003960}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00003960}, {50,0.00000000}, {51,0.00007921}, {52,0.00003960}, {53,0.00003960}, {54,0.00000000}, {55,0.00000000}, {56,0.00007921}, {57,0.00007921}, {58,0.00003960}, {59,0.00000000}, {60,0.00003960}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00002970}, {66,0.00000000}, {67,0.00003960}, {68,0.00002970}, {69,0.00002970}, {70,0.00003960}, {71,0.00000000}, {72,0.00007921}, {73,0.00000000}, {74,0.00002970}, {75,0.00000000}, {76,0.00003960}, {77,0.00006931}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00003960}, {83,0.00000000}, {84,0.00006931}, {85,0.00002970}, {86,0.00000000}, {87,0.00002970}, {88,0.00000000}, {89,0.00006931}, {90,0.00003960}, {91,0.00000000}, {92,0.00000000}, {93,0.00003960}, {94,0.00000000}, {95,0.00003960}, {96,0.00000000}, {97,0.00003960}, {98,0.00000000}, {99,0.00003960}, {100,0.00000000}, {101,0.00003960}, {102,0.00000000}, {103,0.00003960}, {104,0.00002970}, {105,0.00000000}, {106,0.00000000}, {107,0.00003960}, {108,0.00003960}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00003960}, {113,0.00000000}, {114,0.00003960}, {115,0.00002970}, {116,0.00003960}, {117,0.00000000}, {118,0.00000000}, {119,0.00014851}, {120,0.00003960}, {121,0.00000000}, {122,0.00002970}, {123,0.00011881}, {124,0.00003960}, {125,0.00000000}, {126,0.00003960}, {127,0.00003960}, {128,0.00000000}, {129,0.00002970}, {130,0.00000000}, {131,0.00003960}, {132,0.00007921}, {133,0.00003960}, {134,0.00000000}, {135,0.00014851}, {136,0.00007921}, {137,0.00000000}, {138,0.00000000}, {139,0.00003960}, {140,0.00018812}, {141,0.00007921}, {142,0.00002970}, {143,0.00003960}, {144,0.00003960}, {145,0.00000000}, {146,0.00007921}, {147,0.00000000}, {148,0.00000000}, {149,0.00003960}, {150,0.00000000}, {151,0.00000000}, {152,0.00005941}, {153,0.00000000}, {154,0.00003960}, {155,0.00003960}, {156,0.00002970}, {157,0.00003960}, {158,0.00006931}, {159,0.00003960}, {160,0.00000000}, {161,0.00000000}, {162,0.00019802}, {163,0.00000000}, {164,0.00000000}, {165,0.00003960}, {166,0.00003960}, {167,0.00003960}, {168,0.00007921}, {169,0.00000000}, {170,0.00000000}, {171,0.00003960}, {172,0.00007921}, {173,0.00002970}, {174,0.00003960}, {175,0.00003960}, {176,0.00000000}, {177,0.00088119}, {178,0.00003960}, {179,0.00000000}, {180,0.00000000}, {181,0.00003960}, {182,0.00010891}, {183,0.00023762}, {184,0.00000000}, {185,0.00000000}, {186,0.00003960}, {187,0.00003960}, {188,0.00000000}, {189,0.00007921}, {190,0.00000000}, {191,0.00011881}, {192,0.00011881}, {193,0.00010891}, {194,0.00003960}, {195,0.00037624}, {196,0.00007921}, {197,0.00010891}, {198,0.00037624}, {199,0.00019802}, {200,0.00022772}, {201,0.00011881}, {202,0.00023762}, {203,0.00011881}, {204,0.00003960}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00003960}, {209,0.00003960}, {210,0.00000000}, {211,0.00007921}, {212,0.00015842}, {213,0.00003960}, {214,0.00000000}, {215,0.00003960}, {216,0.00003960}, {217,0.00000000}, {218,0.00018812}, {219,0.00003960}, {220,0.00000000}, {221,0.00000000}, {222,0.00007921}, {223,0.00000000}, {224,0.00003960}, {225,0.00015842}, {226,0.00015842}, {227,0.00000000}, {228,0.00002970}, {229,0.00018812}, {230,0.00003960}, {231,0.00000000}, {232,0.00014851}, {233,0.00011881}, {234,0.00003960}, {235,0.00015842}, {236,0.00003960}, {237,0.00003960}, {238,0.00000000}, {239,0.00003960}, {240,0.00000000}, {241,0.00003960}, {242,0.00011881}, {243,0.00000000}, {244,0.00000000}, {245,0.00003960}, {246,0.00003960}, {247,0.00003960}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00003960}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00007921}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00003960}, {262,0.00003960}, {263,0.00002970}, {264,0.00002970}, {265,0.00000000}, {266,0.00000000}, {267,0.00003960}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00003960}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00003960}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00003960}, {283,0.00000000}, {284,0.00000000}, {285,0.00003960}, {286,0.00003960}, {287,0.00000000}, {288,0.00003960}, {289,0.00002970}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00002970}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00003960}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00006931}, {303,0.00007921}, {304,0.00000000}, {305,0.00000000}, {306,0.00003960}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00003960}, {313,0.00000000}, {314,0.00000000}, {315,0.00003960}, {316,0.00002970}, {317,0.00003960}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00003960}, {322,0.00000000}, {323,0.00000000}, {324,0.00003960}, {325,0.00000000}, {326,0.00007921}, {327,0.00000000}, {328,0.00003960}, {329,0.00000000}, {330,0.00000000}, {331,0.00003960}, {332,0.00003960}, {333,0.00003960}, {334,0.00000000}, {335,0.00000000}, {336,0.00003960}, {337,0.00000000}, {338,0.00000000}, {339,0.00003960}, {340,0.00006931}, {341,0.00003960}, {342,0.00000000}, {343,0.00000000}, {344,0.00007921}, {345,0.00000000}, {346,0.00003960}, {347,0.00000000}, {348,0.00023762}, {349,0.00000000}, {350,0.00003960}, {351,0.00000000}, {352,0.00003960}, {353,0.00018812}, {354,0.00000000}, {355,0.00003960}, {356,0.00000000}, {357,0.00003960}, {358,0.00000000}, {359,0.00003960}, {360,0.00011881}, {361,0.00003960}, {362,0.00007921}, {363,0.00003960}, {364,0.00007921}, {365,0.00000000}, {366,0.00003960}, {367,0.00000000}, {368,0.00011881}, {369,0.00000000}, {370,0.00003960}, {371,0.00003960}, {372,0.00000000}, {373,0.00007921}, {374,0.00003960}, {375,0.00000000}, {376,0.00003960}, {377,0.00007921}, {378,0.00000000}, {379,0.00000000}, {380,0.00003960}, {381,0.00000000}, {382,0.00000000}, {383,0.00003960}, {384,0.00003960}, {385,0.00003960}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00007921}, {391,0.00011881}, {392,0.00000000}, {393,0.00000000}, {394,0.00002970}, {395,0.00000000}, {396,0.00000000}, {397,0.00002970}, {398,0.00007921}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00007921}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00011881}, {408,0.00000000}, {409,0.00000000}, {410,0.00003960}, {411,0.00003960}, {412,0.00011881}, {413,0.00011881}, {414,0.00015842}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00007921}, {422,0.00002970}, {423,0.00007921}, {424,0.00006931}, {425,0.00000000}, {426,0.00003960}, {427,0.00003960}, {428,0.00000000}, {429,0.00003960}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00003960}, {436,0.00000000}, {437,0.00007921}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00003960}, {442,0.00003960}, {443,0.00007921}, {444,0.00000000}, {445,0.00000000}, {446,0.00003960}, {447,0.00003960}, {448,0.00000000}, {449,0.00000000}, {450,0.00007921}, {451,0.00003960}, {452,0.00002970}, {453,0.00000000}, {454,0.00003960}, {455,0.00007921}, {456,0.00003960}, {457,0.00007921}, {458,0.00000000}, {459,0.00003960}, {460,0.00003960}, {461,0.00000000}, {462,0.00003960}, {463,0.00002970}, {464,0.00007921}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003960}, {469,0.00003960}, {470,0.00000000}, {471,0.00003960}, {472,0.00000000}, {473,0.00003960}, {474,0.00000000}, {475,0.00011881}, {476,0.00007921}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00003960}, {481,0.00003960}, {482,0.00003960}, {483,0.00000000}, {484,0.00003960}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00003960}, {489,0.00003960}, {490,0.00003960}, {491,0.00000000}, {492,0.00003960}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00007921}, {497,0.00000000}, {498,0.00000000}, {499,0.00003960}, {500,0.00000000}, {505,0.00000000}, {510,0.00003960}, {515,0.00003960}, {520,0.00003960}, {525,0.00011881}, {530,0.00003960}, {535,0.00003960}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00003960}, {570,0.00000000}, {575,0.00003960}, {580,0.00000000}, {585,0.00003960}, {590,0.00000000}, {595,0.00010891}, {600,0.00006931}, {605,0.00000000}, {610,0.00000000}, {615,0.00003960}, {620,0.00000000}, {625,0.00003960}, {630,0.00003960}, {635,0.00000000}, {640,0.00000000}, {645,0.00003960}, {650,0.00000000}, {655,0.00007921}, {660,0.00000000}, {665,0.00003960}, {670,0.00007921}, {675,0.00003960}, {680,0.00007921}, {685,0.00003960}, {690,0.00003960}, {695,0.00000000}, {700,0.00003960}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00006931}, {740,0.00007921}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00011881}, {770,0.00007921}, {775,0.00007921}, {780,0.00000000}, {785,0.00007921}, {790,0.00000000}, {795,0.00007921}, {800,0.00000000}, {805,0.00003960}, {810,0.00000000}, {815,0.00003960}, {820,0.00000000}, {825,0.00003960}, {830,0.00002970}, {835,0.00003960}, {840,0.00003960}, {845,0.00003960}, {850,0.00000000}, {855,0.00000000}, {860,0.00007921}, {865,0.00000000}, {870,0.00003960}, {875,0.00000000}, {880,0.00003960}, {885,0.00007921}, {890,0.00003960}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00003960}, {920,0.00000000}, {925,0.00000000}, {930,0.00003960}, {935,0.00003960}, {940,0.00000000}, {945,0.00000000}, {950,0.00007921}, {955,0.00000000}, {960,0.00002970}, {965,0.00007921}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00007921}, {990,0.00003960}, {995,0.00000000}, {1000,0.00007921}, {1010,0.00000000}, {1020,0.00003960}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00011881}, {1060,0.00003960}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00007921}, {1120,0.00003960}, {1130,0.00000000}, {1140,0.00007921}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00003960}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00003960}, {1210,0.00003960}, {1220,0.00000000}, {1230,0.00003960}, {1240,0.00007921}, {1250,0.00003960}, {1260,0.00011881}, {1270,0.00002970}, {1280,0.00000000}, {1290,0.00015842}, {1300,0.00003960}, {1310,0.00011881}, {1320,0.00003960}, {1330,0.00003960}, {1340,0.00000000}, {1350,0.00003960}, {1360,0.00000000}, {1370,0.00007921}, {1380,0.00003960}, {1390,0.00000000}, {1400,0.00003960}, {1410,0.00007921}, {1420,0.00007921}, {1430,0.00000000}, {1440,0.00006931}, {1450,0.00003960}, {1460,0.00000000}, {1470,0.00003960}, {1480,0.00002970}, {1490,0.00003960}, {1500,0.00000000}, {1510,0.00003960}, {1520,0.00000000}, {1530,0.00011881}, {1540,0.00007921}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00006931}, {1580,0.00003960}, {1590,0.00003960}, {1600,0.00007921}, {1610,0.00007921}, {1620,0.00000000}, {1630,0.00003960}, {1640,0.00000000}, {1650,0.00011881}, {1660,0.00011881}, {1670,0.00007921}, {1680,0.00007921}, {1690,0.00003960}, {1700,0.00003960}, {1710,0.00003960}, {1720,0.00003960}, {1730,0.00007921}, {1740,0.00007921}, {1750,0.00000000}, {1760,0.00007921}, {1770,0.00000000}, {1780,0.00015842}, {1790,0.00000000}, {1800,0.00011881}, {1810,0.00000000}, {1820,0.00003960}, {1830,0.00007921}, {1840,0.00000000}, {1850,0.00007921}, {1860,0.00003960}, {1870,0.00002970}, {1880,0.00014851}, {1890,0.00007921}, {1900,0.00011881}, {1910,0.00000000}, {1920,0.00011881}, {1930,0.00014851}, {1940,0.00007921}, {1950,0.00000000}, {1960,0.00019802}, {1970,0.00007921}, {1980,0.00006931}, {1990,0.00000000}, {2000,0.00007921}, {2050,0.00003960}, {2100,0.00007921}, {2150,0.00011881}, {2200,0.00003960}, {2250,0.00014851}, {2300,0.00007921}, {2350,0.00007921}, {2400,0.00007921}, {2450,0.00000000}, {2500,0.00003960}, {2550,0.00007921}, {2600,0.00010891}, {2650,0.00003960}, {2700,0.00014851}, {2750,0.00000000}, {2800,0.00002970}, {2850,0.00003960}, {2900,0.00007921}, {2950,0.00003960}, {3000,0.00015842}, {3050,0.00007921}, {3100,0.00147525}, {3150,0.00031683}, {3200,0.00011881}, {3250,0.00007921}, {3300,0.00007921}, {3350,0.00000000}, {3400,0.00011881}, {3450,0.00003960}, {3500,0.00003960}, {3550,0.00003960}, {3600,0.00003960}, {3650,0.00011881}, {3700,0.00000000}, {3750,0.00007921}, {3800,0.00011881}, {3850,0.00007921}, {3900,0.00007921}, {3950,0.00011881}, {4000,0.00000000}, {4050,0.00003960}, {4100,0.00003960}, {4150,0.00007921}, {4200,0.00015842}, {4250,0.00003960}, {4300,0.00010891}, {4350,0.00007921}, {4400,0.00011881}, {4450,0.00011881}, {4500,0.00003960}, {4550,0.00019802}, {4600,0.00018812}, {4650,0.00003960}, {4700,0.00003960}, {4750,0.00007921}, {4800,0.00015842}, {4850,0.00038614}, {4900,0.00051485}, {4950,0.00022772}, {5000,0.00003960}, {5050,0.00110891}, {5100,0.00011881}, {5150,0.00019802}, {5200,0.00050495}, {5250,0.00030693}, {5300,0.00007921}, {5350,0.00015842}, {5400,0.00022772}, {5450,0.00007921}, {5500,0.00023762}, {5550,0.00019802}, {5600,0.00015842}, {5650,0.00007921}, {5700,0.00019802}, {5750,0.00003960}, {5800,0.00003960}, {5850,0.00011881}, {5900,0.00006931}, {5950,0.00019802}, {6000,0.00011881}, {6050,0.0030000}, {6100,0.0012286}, {6150,0.0003429}, {6200,0.0003429}, {6250,0.0023714}, {6300,0.0000857}, {6350,0.0000000}, {6400,0.0001143}, {6450,0.0001143}, {6500,0.0001143}, {6550,0.0002286}, {6600,0.0001143}, {6650,0.0000000}, {6700,0.0001143}, {6750,0.0002286}, {6800,0.0001143}, {6850,0.0001143}, {6900,0.0000000}, {6950,0.0002286}, {7000,0.0000857}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0001143}, {7250,0.0002286}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0001143}, {7450,0.0000000}, {7500,0.0003143}, {7550,0.0003429}, {7600,0.0001143}, {7650,0.0000000}, {7700,0.0003429}, {7750,0.0001143}, {7800,0.0001143}, {7850,0.0000000}, {7900,0.0001143}, {7950,0.0001143}, {8000,0.0000000}, {8050,0.0004571}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0001143}, {8300,0.0001143}, {8350,0.0001143}, {8400,0.0002286}, {8450,0.0000857}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0004286}, {8650,0.0003429}, {8700,0.0000000}, {8750,0.0001143}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0002286}, {8950,0.0000000}, {9000,0.0002000}, {9050,0.0001143}, {9100,0.0002286}, {9150,0.0002286}, {9200,0.0001143}, {9250,0.0003429}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0002286}, {9450,0.0001143}, {9500,0.0001143}, {9550,0.0000000}, {9600,0.0003143}, {9650,0.0002286}, {9700,0.0001143}, {9750,0.0001143}, {9800,0.0001143}, {9850,0.0003429}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0064857}, {10300,0.0001143}, {10400,0.0000000}, {10500,0.0004571}, {10600,0.0000000}, {10700,0.0002286}, {10800,0.0003429}, {10900,0.0001143}, {11000,0.0000000}, {11100,0.0001143}, {11200,0.0000000}, {11300,0.0001143}, {11400,0.0002286}, {11500,0.0002286}, {11600,0.0002286}, {11700,0.0000000}, {11800,0.0008857}, {11900,0.0001143}, {12000,0.0000000}, {12100,0.0004571}, {12200,0.0002286}, {12300,0.0005714}, {12400,0.0004571}, {12500,0.0008000}, {12600,0.0001143}, {12700,0.0005714}, {12800,0.0002286}, {12900,0.0002286}, {13000,0.0002286}, {13100,0.0001143}, {13200,0.0001143}, {13300,0.0005429}, {13400,0.0000000}, {13500,0.0001143}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0005714}, {14100,0.0008000}, {14200,0.0008857}, {14300,0.0004571}, {14400,0.0000000}, {14500,0.0027714}, {14600,0.0005429}, {14700,0.0013429}, {14800,0.0003429}, {14900,0.0008857}, {15000,0.0004571}, {15100,0.0001143}, {15200,0.0007714}, {15300,0.0008000}, {15400,0.0010286}, {15500,0.0002286}, {15600,0.0005714}, {15700,0.0006857}, {15800,0.0002286}, {15900,0.0005714}, {16000,0.0003429}, {16100,0.0002286}, {16200,0.0010000}, {16300,0.0003429}, {16400,0.0001143}, {16500,0.0010286}, {16600,0.0006571}, {16700,0.0004571}, {16800,0.0000000}, {16900,0.0006857}, {17000,0.0001143}, {17100,0.0005714}, {17200,0.0018000}, {17300,0.0014857}, {17400,0.0000000}, {17500,0.0013714}, {17600,0.0006571}, {17700,0.0009143}, {17800,0.0007714}, {17900,0.0005714}, {18000,0.0002286}, {18100,0.0001143}, {18200,0.0006857}, {18300,0.0013429}, {18400,0.0002286}, {18500,0.0007714}, {18600,0.0011429}, {18700,0.0010000}, {18800,0.0009143}, {18900,0.0000000}, {19000,0.0005714}, {19100,0.0003429}, {19200,0.0008857}, {19300,0.0027429}, {19400,0.0011429}, {19500,0.0003143}, {19600,0.0009143}, {19700,0.0023429}, {19800,0.0024000}, {19900,0.0019143}, {20000,0.0005714}};
data["big_flat"]["LtacTacInTermPrimPair"]["Aggregate"]["real"] = {{1,0.00100000}, {2,0.00100000}, {3,0.00100000}, {4,0.00100000}, {5,0.00100000}, {6,0.00100000}, {7,0.00108911}, {8,0.00160396}, {9,0.00200000}, {10,0.00200000}, {11,0.00200000}, {12,0.00200000}, {13,0.00203960}, {14,0.00216832}, {15,0.00243564}, {16,0.00300000}, {17,0.00300000}, {18,0.00300000}, {19,0.00300000}, {20,0.00302970}, {21,0.00326733}, {22,0.00333663}, {23,0.00399010}, {24,0.00400000}, {25,0.00400000}, {26,0.00400000}, {27,0.00409901}, {28,0.00413861}, {29,0.00431683}, {30,0.00485149}, {31,0.00500000}, {32,0.00500000}, {33,0.00500990}, {34,0.00508911}, {35,0.00532673}, {36,0.00527723}, {37,0.00553465}, {38,0.00597030}, {39,0.00774257}, {40,0.00600000}, {41,0.00624752}, {42,0.00615842}, {43,0.00615842}, {44,0.00636634}, {45,0.00680198}, {46,0.00700000}, {47,0.00702970}, {48,0.00714851}, {49,0.00721782}, {50,0.00715842}, {51,0.00917822}, {52,0.00761386}, {53,0.00797030}, {54,0.00809901}, {55,0.00809901}, {56,0.00813861}, {57,0.00819802}, {58,0.00820792}, {59,0.00847525}, {60,0.00878218}, {61,0.00901980}, {62,0.00911881}, {63,0.00924752}, {64,0.00909901}, {65,0.00930693}, {66,0.00943564}, {67,0.00956436}, {68,0.01000990}, {69,0.01015842}, {70,0.01014851}, {71,0.01022772}, {72,0.01022772}, {73,0.01030693}, {74,0.01034653}, {75,0.01074257}, {76,0.01105941}, {77,0.01114851}, {78,0.01122772}, {79,0.01123762}, {80,0.01118812}, {81,0.01145545}, {82,0.01156436}, {83,0.01620792}, {84,0.01208911}, {85,0.01220792}, {86,0.01211881}, {87,0.01227723}, {88,0.01218812}, {89,0.01249505}, {90,0.01266337}, {91,0.01309901}, {92,0.01313861}, {93,0.01310891}, {94,0.01311881}, {95,0.01324752}, {96,0.01326733}, {97,0.01363366}, {98,0.01384158}, {99,0.01414851}, {100,0.01416832}, {101,0.01428713}, {102,0.01420792}, {103,0.01444554}, {104,0.01454455}, {105,0.01472277}, {106,0.01496040}, {107,0.01519802}, {108,0.01529703}, {109,0.01888119}, {110,0.01522772}, {111,0.01552475}, {112,0.01566337}, {113,0.01585149}, {114,0.01605941}, {115,0.02108911}, {116,0.01614851}, {117,0.01626733}, {118,0.01655446}, {119,0.01662376}, {120,0.01950495}, {121,0.01699010}, {122,0.01712871}, {123,0.01732673}, {124,0.01922772}, {125,0.01739604}, {126,0.01744554}, {127,0.02345545}, {128,0.01774257}, {129,0.01821782}, {130,0.02439604}, {131,0.01823762}, {132,0.01856436}, {133,0.02354455}, {134,0.01862376}, {135,0.01884158}, {136,0.01976238}, {137,0.01932673}, {138,0.02566337}, {139,0.01930693}, {140,0.01950495}, {141,0.01958416}, {142,0.01987129}, {143,0.02055446}, {144,0.02011881}, {145,0.02247525}, {146,0.02026733}, {147,0.02333663}, {148,0.02065347}, {149,0.02283168}, {150,0.02096040}, {151,0.02132673}, {152,0.02130693}, {153,0.02132673}, {154,0.02145545}, {155,0.02152475}, {156,0.02627723}, {157,0.02197030}, {158,0.02200990}, {159,0.02244554}, {160,0.02225743}, {161,0.02436634}, {162,0.02235644}, {163,0.02260396}, {164,0.02574257}, {165,0.02313861}, {166,0.02321782}, {167,0.02482178}, {168,0.02340594}, {169,0.02349505}, {170,0.02337624}, {171,0.02861386}, {172,0.02397030}, {173,0.02408911}, {174,0.02416832}, {175,0.02833663}, {176,0.02447525}, {177,0.02470297}, {178,0.02446535}, {179,0.02465347}, {180,0.02838614}, {181,0.03372277}, {182,0.02532673}, {183,0.02527723}, {184,0.02542574}, {185,0.02542574}, {186,0.02560396}, {187,0.02780198}, {188,0.03105941}, {189,0.03355446}, {190,0.02722772}, {191,0.02666337}, {192,0.02646535}, {193,0.02663366}, {194,0.02675248}, {195,0.02698020}, {196,0.02699010}, {197,0.02725743}, {198,0.02740594}, {199,0.02736634}, {200,0.02741584}, {201,0.02763366}, {202,0.02782178}, {203,0.02826733}, {204,0.02827723}, {205,0.03723762}, {206,0.03534653}, {207,0.03137624}, {208,0.03076238}, {209,0.02879208}, {210,0.02880198}, {211,0.02918812}, {212,0.02933663}, {213,0.02956436}, {214,0.03985149}, {215,0.03301980}, {216,0.02965347}, {217,0.02995050}, {218,0.02974257}, {219,0.03950495}, {220,0.03281188}, {221,0.03050495}, {222,0.03053465}, {223,0.04182178}, {224,0.03383168}, {225,0.03090099}, {226,0.03100990}, {227,0.04005941}, {228,0.03132673}, {229,0.03156436}, {230,0.04135644}, {231,0.03295050}, {232,0.03186139}, {233,0.04165347}, {234,0.03213861}, {235,0.03252475}, {236,0.03948515}, {237,0.03252475}, {238,0.03291089}, {239,0.03456436}, {240,0.03304950}, {241,0.03893069}, {242,0.03319802}, {243,0.04264356}, {244,0.03336634}, {245,0.03399010}, {246,0.03382178}, {247,0.03389109}, {248,0.03391089}, {249,0.03431683}, {250,0.03438614}, {251,0.03571287}, {252,0.03502970}, {253,0.04460396}, {254,0.03493069}, {255,0.04107921}, {256,0.03536634}, {257,0.03665347}, {258,0.03546535}, {259,0.03561386}, {260,0.04341584}, {261,0.03585149}, {262,0.03601980}, {263,0.04697030}, {264,0.03621782}, {265,0.03782178}, {266,0.04671287}, {267,0.03683168}, {268,0.03737624}, {269,1.03032673}, {270,0.03723762}, {271,0.03744554}, {272,0.04332673}, {273,0.05369307}, {274,0.03782178}, {275,0.03808911}, {276,0.04214851}, {277,0.04879208}, {278,0.03865347}, {279,0.03872277}, {280,0.03852475}, {281,0.04289109}, {282,0.04754455}, {283,0.04038614}, {284,0.03940594}, {285,0.03946535}, {286,0.03943564}, {287,0.03989109}, {288,0.04265347}, {289,0.04581188}, {290,0.04814851}, {291,0.05084158}, {292,0.05220792}, {293,0.04064356}, {294,0.04113861}, {295,0.04095050}, {296,0.04087129}, {297,0.04114851}, {298,0.04107921}, {299,0.04131683}, {300,0.04190099}, {301,0.04182178}, {302,0.04191089}, {303,0.04240594}, {304,0.04213861}, {305,0.06095050}, {306,0.05773267}, {307,0.05217822}, {308,0.04976238}, {309,0.04743564}, {310,0.04431683}, {311,0.04292079}, {312,0.04294059}, {313,0.04323762}, {314,0.04529703}, {315,0.05345545}, {316,0.04885149}, {317,0.04407921}, {318,0.04400000}, {319,0.04438614}, {320,0.05501980}, {321,0.04932673}, {322,0.04420792}, {323,0.04462376}, {324,0.05789109}, {325,0.05127723}, {326,0.04546535}, {327,0.04538614}, {328,0.05588119}, {329,0.04900990}, {330,0.04516832}, {331,0.06591089}, {332,0.05326733}, {333,0.04618812}, {334,0.06174257}, {335,0.05119802}, {336,0.04636634}, {337,0.05916832}, {338,0.04811881}, {339,0.04680198}, {340,0.05379208}, {341,0.04728713}, {342,0.05905941}, {343,0.04784158}, {344,0.06197030}, {345,0.04995050}, {346,0.04788119}, {347,0.05153465}, {348,0.04811881}, {349,0.05240594}, {350,0.04844554}, {351,0.05209901}, {352,0.04815842}, {353,0.05100990}, {354,0.06242574}, {355,0.04901980}, {356,0.05975248}, {357,0.04938614}, {358,0.06056436}, {359,0.04965347}, {360,0.05237624}, {361,0.06419802}, {362,0.04985149}, {363,0.05685149}, {364,0.05223762}, {365,0.05012871}, {366,0.05799010}, {367,0.05216832}, {368,0.05069307}, {369,0.05678218}, {370,0.06314851}, {371,0.05125743}, {372,0.05357426}, {373,0.06069307}, {374,0.05233663}, {375,0.05170297}, {376,0.05423762}, {377,0.06040594}, {378,0.06584158}, {379,0.05213861}, {380,0.05262376}, {381,0.05757426}, {382,0.06276238}, {383,0.06640594}, {384,0.05429703}, {385,0.05263366}, {386,0.05306931}, {387,0.05574257}, {388,0.05918812}, {389,0.06257426}, {390,0.06600990}, {391,0.06787129}, {392,0.06958416}, {393,0.05417822}, {394,0.05439604}, {395,0.05493069}, {396,0.05410891}, {397,0.05486139}, {398,0.05510891}, {399,0.05482178}, {400,0.05505941}, {401,0.05495050}, {402,0.05494059}, {403,0.05595050}, {404,0.05554455}, {405,0.05602970}, {406,0.05588119}, {407,0.05659406}, {408,0.07184158}, {409,0.07029703}, {410,0.06778218}, {411,0.06568317}, {412,0.06240594}, {413,0.05959406}, {414,0.05716832}, {415,0.05753465}, {416,0.05949505}, {417,0.07700000}, {418,0.06905941}, {419,0.06222772}, {420,0.05773267}, {421,0.05781188}, {422,0.07469307}, {423,0.06782178}, {424,0.06089109}, {425,0.05822772}, {426,0.07443564}, {427,0.06753465}, {428,0.06043564}, {429,0.05934653}, {430,0.07147525}, {431,0.06382178}, {432,0.05939604}, {433,0.07694059}, {434,0.06782178}, {435,0.06000990}, {436,0.07506931}, {437,0.06480198}, {438,0.06029703}, {439,0.07128713}, {440,0.06068317}, {441,0.07698020}, {442,0.06540594}, {443,0.06113861}, {444,0.06891089}, {445,0.06109901}, {446,0.07133663}, {447,0.06168317}, {448,0.07307921}, {449,0.06138614}, {450,0.07562376}, {451,0.06331683}, {452,0.07961386}, {453,0.06256436}, {454,0.07631683}, {455,0.06295050}, {456,0.07331683}, {457,0.06294059}, {458,0.07029703}, {459,0.08106931}, {460,0.06550495}, {461,0.07594059}, {462,0.06373267}, {463,0.07049505}, {464,0.07912871}, {465,0.06386139}, {466,0.07507921}, {467,0.09008911}, {468,0.06540594}, {469,0.07449505}, {470,0.08360396}, {471,0.06502970}, {472,0.07185149}, {473,0.07875248}, {474,0.06540594}, {475,0.06673267}, {476,0.07275248}, {477,0.07882178}, {478,0.08431683}, {479,0.06611881}, {480,0.07087129}, {481,0.08031683}, {482,0.08588119}, {483,0.08848515}, {484,0.06681188}, {485,0.06918812}, {486,0.07400990}, {487,0.07750495}, {488,0.08016832}, {489,0.08333663}, {490,0.08594059}, {491,0.06749505}, {492,0.06746535}, {493,0.06916832}, {494,0.07157426}, {495,0.07221782}, {496,0.07409901}, {497,0.07598020}, {498,0.07620792}, {499,0.07718812}, {500,0.07740594}, {505,0.07749505}, {510,0.07595050}, {515,0.07287129}, {520,0.07133663}, {525,0.09045545}, {530,0.08609901}, {535,0.08022772}, {540,0.09744554}, {545,0.08693069}, {550,0.07562376}, {555,0.08800990}, {560,0.09860396}, {565,0.08501980}, {570,0.09356436}, {575,0.10537624}, {580,0.08515842}, {585,0.09282178}, {590,0.09508911}, {595,0.09710891}, {600,0.09966337}, {605,0.09887129}, {610,0.09767327}, {615,0.09566337}, {620,0.09442574}, {625,0.08983168}, {630,0.11022772}, {635,0.09907921}, {640,0.09274257}, {645,0.10800990}, {650,0.09765347}, {655,0.10989109}, {660,0.09777228}, {665,0.11652475}, {670,0.12324752}, {675,0.10154455}, {680,0.10952475}, {685,0.11365347}, {690,0.11731683}, {695,0.12205941}, {700,0.13602970}, {705,0.12776238}, {710,0.12614851}, {715,0.12276238}, {720,0.11832673}, {725,0.11542574}, {730,0.11586139}, {735,0.13226733}, {740,0.12214851}, {745,0.11166337}, {750,0.12473267}, {755,0.11357426}, {760,0.13493069}, {765,0.14055446}, {770,0.12074257}, {775,0.12961386}, {780,0.13560396}, {785,0.11763366}, {790,0.12955446}, {795,0.12876238}, {800,0.12983168}, {805,0.12931683}, {810,0.12949505}, {815,0.12424752}, {820,0.12705941}, {825,0.12336634}, {830,0.14221782}, {835,0.13341584}, {840,0.12632673}, {845,0.14740594}, {850,0.13396040}, {855,0.14666337}, {860,0.13354455}, {865,0.15891089}, {870,0.13357426}, {875,0.13990099}, {880,0.14479208}, {885,0.15083168}, {890,0.16574257}, {895,0.13760396}, {900,0.13594059}, {905,0.13616832}, {910,0.13635644}, {915,0.14213861}, {920,0.16130693}, {925,0.15412871}, {930,0.14812871}, {935,0.14223762}, {940,0.16440594}, {945,0.15365347}, {950,0.14226733}, {955,0.15499010}, {960,0.14939604}, {965,0.15698020}, {970,0.16393069}, {975,0.14793069}, {980,0.16400990}, {985,0.16164356}, {990,0.16652475}, {995,0.16868317}, {1000,0.18737624}, {1010,0.17049505}, {1020,0.17101980}, {1030,0.16823762}, {1040,0.16686139}, {1050,0.18422772}, {1060,0.16933663}, {1070,0.19306931}, {1080,0.17058416}, {1090,0.17489109}, {1100,0.17777228}, {1110,0.18507921}, {1120,0.18161386}, {1130,0.17646535}, {1140,0.21367327}, {1150,0.18906931}, {1160,0.19974257}, {1170,0.18356436}, {1180,0.20126733}, {1190,0.20370297}, {1200,0.19658416}, {1210,0.19374257}, {1220,0.20942574}, {1230,0.21799010}, {1240,0.20078218}, {1250,0.19535644}, {1260,0.22621782}, {1270,0.22368317}, {1280,0.20300000}, {1290,0.21796040}, {1300,0.21947525}, {1310,0.21801980}, {1320,0.22517822}, {1330,0.21571287}, {1340,0.22671287}, {1350,0.23308911}, {1360,0.21750495}, {1370,0.23752475}, {1380,0.21722772}, {1390,0.22170297}, {1400,0.23132673}, {1410,0.22710891}, {1420,0.23746535}, {1430,0.22880198}, {1440,0.24315842}, {1450,0.23643564}, {1460,0.22943564}, {1470,0.24757426}, {1480,0.24799010}, {1490,0.25212871}, {1500,0.24077228}, {1510,0.23846535}, {1520,0.23421782}, {1530,0.25803960}, {1540,0.26434653}, {1550,0.24837624}, {1560,0.27781188}, {1570,0.25209901}, {1580,0.28786139}, {1590,0.27222772}, {1600,0.26023762}, {1610,0.25847525}, {1620,0.26623762}, {1630,0.28051485}, {1640,0.27946535}, {1650,0.27008911}, {1660,0.27391089}, {1670,0.27199010}, {1680,0.27682178}, {1690,0.29035644}, {1700,0.26940594}, {1710,0.27508911}, {1720,0.26809901}, {1730,0.29552475}, {1740,0.31478218}, {1750,0.28628713}, {1760,0.30904950}, {1770,0.28561386}, {1780,0.30523762}, {1790,0.29986139}, {1800,0.30291089}, {1810,0.28661386}, {1820,0.29567327}, {1830,0.30635644}, {1840,0.30840594}, {1850,0.32557426}, {1860,0.31305941}, {1870,0.31231683}, {1880,0.31344554}, {1890,0.33105941}, {1900,0.30637624}, {1910,0.30782178}, {1920,0.31994059}, {1930,0.32757426}, {1940,0.33178218}, {1950,0.30898020}, {1960,0.33423762}, {1970,0.32916832}, {1980,0.32866337}, {1990,0.33231683}, {2000,0.32619802}, {2050,0.32577228}, {2100,0.34996040}, {2150,0.34479208}, {2200,0.36453465}, {2250,0.37953465}, {2300,0.37523762}, {2350,0.38623762}, {2400,0.40821782}, {2450,0.41925743}, {2500,0.45510891}, {2550,0.42080198}, {2600,0.42601980}, {2650,0.44863366}, {2700,0.44853465}, {2750,0.44656436}, {2800,0.47616832}, {2850,0.50363366}, {2900,0.51520792}, {2950,0.52394059}, {3000,0.54308911}, {3050,0.53826733}, {3100,0.56462376}, {3150,0.56020792}, {3200,0.55721782}, {3250,0.54932673}, {3300,0.56825743}, {3350,0.57149505}, {3400,0.59036634}, {3450,0.59684158}, {3500,0.61412871}, {3550,0.62400000}, {3600,0.62511881}, {3650,0.62149505}, {3700,0.62650495}, {3750,0.63226733}, {3800,0.64277228}, {3850,0.64012871}, {3900,0.67480198}, {3950,0.70198020}, {4000,0.66600990}, {4050,0.69880198}, {4100,0.69004950}, {4150,0.71733663}, {4200,0.73484158}, {4250,0.72686139}, {4300,0.72865347}, {4350,0.74553465}, {4400,0.74731683}, {4450,0.75370297}, {4500,0.79704950}, {4550,0.78061386}, {4600,0.78372277}, {4650,0.80667327}, {4700,0.79854455}, {4750,0.82706931}, {4800,0.82766337}, {4850,0.85516832}, {4900,0.82675248}, {4950,0.87576238}, {5000,0.86328713}, {5050,0.89176238}, {5100,0.87232673}, {5150,0.89922772}, {5200,0.89537624}, {5250,0.92518812}, {5300,0.92700000}, {5350,0.92462376}, {5400,0.95490099}, {5450,0.94186139}, {5500,0.94182178}, {5550,0.98219802}, {5600,0.95648515}, {5650,0.96858416}, {5700,0.99442574}, {5750,1.00674257}, {5800,0.99693069}, {5850,1.02903960}, {5900,1.00911881}, {5950,1.03222772}, {6000,1.04500990}, {6050,1.0969714}, {6100,1.1216571}, {6150,1.1067429}, {6200,1.1085714}, {6250,1.1109714}, {6300,1.1270857}, {6350,1.1529143}, {6400,1.1560571}, {6450,1.1706000}, {6500,1.1727429}, {6550,1.1821143}, {6600,1.1929143}, {6650,1.2125714}, {6700,1.2328000}, {6750,1.2529429}, {6800,1.2458857}, {6850,1.2419143}, {6900,1.2663143}, {6950,1.2714286}, {7000,1.2895714}, {7050,1.2862000}, {7100,1.2914857}, {7150,1.3089714}, {7200,1.2879429}, {7250,1.2980571}, {7300,1.2947714}, {7350,1.3288286}, {7400,1.3563714}, {7450,1.3907143}, {7500,1.3934000}, {7550,1.4012286}, {7600,1.3837143}, {7650,1.4138000}, {7700,1.3872000}, {7750,1.3936857}, {7800,1.4786286}, {7850,1.4626000}, {7900,1.4522571}, {7950,1.4603143}, {8000,1.4369429}, {8050,1.4876000}, {8100,1.5229143}, {8150,1.4990571}, {8200,1.4970857}, {8250,1.4975429}, {8300,1.5411143}, {8350,1.5444571}, {8400,1.5325714}, {8450,1.5244286}, {8500,1.5720000}, {8550,1.5864571}, {8600,1.6031429}, {8650,1.5852571}, {8700,1.6310000}, {8750,1.6215429}, {8800,1.6008571}, {8850,1.6597143}, {8900,1.6251429}, {8950,1.6101714}, {9000,1.6876000}, {9050,1.6722286}, {9100,1.6573714}, {9150,1.7206000}, {9200,1.7071429}, {9250,1.7142000}, {9300,1.7443714}, {9350,1.7537143}, {9400,1.7437714}, {9450,1.7526857}, {9500,1.7467143}, {9550,1.7881714}, {9600,1.7398286}, {9650,1.8136857}, {9700,1.7747429}, {9750,1.8356857}, {9800,1.8254000}, {9850,1.8809714}, {9900,1.8182286}, {9950,1.8805714}, {10000,1.8132571}, {10100,1.9004286}, {10200,1.8934571}, {10300,1.9443429}, {10400,1.8823714}, {10500,1.9847143}, {10600,1.9338000}, {10700,1.9740286}, {10800,1.9757714}, {10900,2.0240286}, {11000,2.0170286}, {11100,2.0939714}, {11200,2.0439714}, {11300,2.1028000}, {11400,2.0906286}, {11500,2.1367714}, {11600,2.1301143}, {11700,2.1336571}, {11800,2.1792571}, {11900,2.1994286}, {12000,2.1906857}, {12100,2.2478286}, {12200,2.2498286}, {12300,2.2953429}, {12400,2.3052857}, {12500,2.2895143}, {12600,2.3073429}, {12700,2.3625429}, {12800,2.3570286}, {12900,2.4650857}, {13000,2.3775429}, {13100,2.4168000}, {13200,2.4360571}, {13300,2.4612857}, {13400,2.4416286}, {13500,2.4985714}, {13600,2.4932000}, {13700,2.5054571}, {13800,2.5195143}, {13900,2.5990857}, {14000,2.5724857}, {14100,2.6586000}, {14200,2.6114857}, {14300,2.6318857}, {14400,2.6196571}, {14500,2.7492857}, {14600,2.7104286}, {14700,3.1110571}, {14800,3.0031714}, {14900,2.9093429}, {15000,2.7441429}, {15100,2.8248286}, {15200,2.7911429}, {15300,2.9062571}, {15400,3.0521143}, {15500,2.9178000}, {15600,3.1908571}, {15700,2.9122286}, {15800,2.9932857}, {15900,2.9482286}, {16000,3.0104571}, {16100,3.0264571}, {16200,3.0201429}, {16300,3.1054286}, {16400,3.1159429}, {16500,3.3794000}, {16600,3.0422571}, {16700,3.0521714}, {16800,3.2011714}, {16900,3.0837714}, {17000,3.2281143}, {17100,3.1870000}, {17200,3.1846857}, {17300,3.2577429}, {17400,3.2760857}, {17500,3.1944000}, {17600,3.3140000}, {17700,3.2698571}, {17800,3.2753429}, {17900,3.3143143}, {18000,3.3055714}, {18100,3.3790857}, {18200,3.3720571}, {18300,3.4323429}, {18400,3.3781429}, {18500,3.4008286}, {18600,3.4189429}, {18700,3.4601714}, {18800,3.4838286}, {18900,3.5007714}, {19000,3.5402857}, {19100,3.5186571}, {19200,3.6117429}, {19300,3.6220000}, {19400,3.5732286}, {19500,3.7020000}, {19600,3.7059714}, {19700,3.8180857}, {19800,3.6907429}, {19900,3.8756857}, {20000,3.7834571}};
data["big_flat"]["LtacTacInTermPrimPair"]["Aggregate"]["user"] = {{1,0.00091089}, {2,0.00116832}, {3,0.00128713}, {4,0.00137624}, {5,0.00136634}, {6,0.00170297}, {7,0.00159406}, {8,0.00209901}, {9,0.00173267}, {10,0.00195050}, {11,0.00191089}, {12,0.00267327}, {13,0.00226733}, {14,0.00241584}, {15,0.00274257}, {16,0.00274257}, {17,0.00297030}, {18,0.00299010}, {19,0.00319802}, {20,0.00328713}, {21,0.00342574}, {22,0.00361386}, {23,0.00371287}, {24,0.00387129}, {25,0.00398020}, {26,0.00429703}, {27,0.00431683}, {28,0.00443564}, {29,0.00473267}, {30,0.00456436}, {31,0.00530693}, {32,0.00490099}, {33,0.00514851}, {34,0.00477228}, {35,0.00600990}, {36,0.00561386}, {37,0.00572277}, {38,0.00593069}, {39,0.00800000}, {40,0.00592079}, {41,0.00650495}, {42,0.00688119}, {43,0.00658416}, {44,0.00659406}, {45,0.00721782}, {46,0.00715842}, {47,0.00765347}, {48,0.00758416}, {49,0.00766337}, {50,0.00736634}, {51,0.00884158}, {52,0.00787129}, {53,0.00818812}, {54,0.00851485}, {55,0.00842574}, {56,0.00828713}, {57,0.00871287}, {58,0.00865347}, {59,0.00883168}, {60,0.00871287}, {61,0.00899010}, {62,0.00946535}, {63,0.00947525}, {64,0.00944554}, {65,0.00932673}, {66,0.00971287}, {67,0.00932673}, {68,0.00953465}, {69,0.00990099}, {70,0.01026733}, {71,0.01020792}, {72,0.01012871}, {73,0.01071287}, {74,0.01078218}, {75,0.01092079}, {76,0.01090099}, {77,0.01091089}, {78,0.01126733}, {79,0.01147525}, {80,0.01139604}, {81,0.01154455}, {82,0.01200990}, {83,0.01647525}, {84,0.01205941}, {85,0.01242574}, {86,0.01212871}, {87,0.01257426}, {88,0.01294059}, {89,0.01268317}, {90,0.01256436}, {91,0.01301980}, {92,0.01321782}, {93,0.01307921}, {94,0.01347525}, {95,0.01348515}, {96,0.01370297}, {97,0.01421782}, {98,0.01351485}, {99,0.01382178}, {100,0.01439604}, {101,0.01478218}, {102,0.01492079}, {103,0.01493069}, {104,0.01487129}, {105,0.01489109}, {106,0.01545545}, {107,0.01544554}, {108,0.01579208}, {109,0.01861386}, {110,0.01582178}, {111,0.01605941}, {112,0.01596040}, {113,0.01617822}, {114,0.01613861}, {115,0.02065347}, {116,0.01645545}, {117,0.01640594}, {118,0.01691089}, {119,0.01698020}, {120,0.01931683}, {121,0.01706931}, {122,0.01718812}, {123,0.01712871}, {124,0.01883168}, {125,0.01756436}, {126,0.01739604}, {127,0.02330693}, {128,0.01778218}, {129,0.01786139}, {130,0.02416832}, {131,0.01815842}, {132,0.01857426}, {133,0.02340594}, {134,0.01850495}, {135,0.01869307}, {136,0.01943564}, {137,0.01926733}, {138,0.02563366}, {139,0.01915842}, {140,0.01918812}, {141,0.01940594}, {142,0.01959406}, {143,0.02031683}, {144,0.01988119}, {145,0.02245545}, {146,0.02003960}, {147,0.02338614}, {148,0.02031683}, {149,0.02279208}, {150,0.02070297}, {151,0.02082178}, {152,0.02113861}, {153,0.02095050}, {154,0.02172277}, {155,0.02140594}, {156,0.02600990}, {157,0.02203960}, {158,0.02185149}, {159,0.02211881}, {160,0.02224752}, {161,0.02447525}, {162,0.02243564}, {163,0.02243564}, {164,0.02569307}, {165,0.02339604}, {166,0.02332673}, {167,0.02500990}, {168,0.02318812}, {169,0.02335644}, {170,0.02347525}, {171,0.02816832}, {172,0.02399010}, {173,0.02408911}, {174,0.02422772}, {175,0.02828713}, {176,0.02448515}, {177,0.02449505}, {178,0.02444554}, {179,0.02474257}, {180,0.02781188}, {181,0.03396040}, {182,0.02549505}, {183,0.02531683}, {184,0.02524752}, {185,0.02545545}, {186,0.02560396}, {187,0.02760396}, {188,0.03126733}, {189,0.03357426}, {190,0.02698020}, {191,0.02640594}, {192,0.02632673}, {193,0.02666337}, {194,0.02657426}, {195,0.02687129}, {196,0.02689109}, {197,0.02715842}, {198,0.02715842}, {199,0.02684158}, {200,0.02746535}, {201,0.02758416}, {202,0.02779208}, {203,0.02795050}, {204,0.02811881}, {205,0.03661386}, {206,0.03519802}, {207,0.03152475}, {208,0.03114851}, {209,0.02873267}, {210,0.02874257}, {211,0.02948515}, {212,0.02905941}, {213,0.02998020}, {214,0.03952475}, {215,0.03313861}, {216,0.02964356}, {217,0.02985149}, {218,0.02997030}, {219,0.03885149}, {220,0.03284158}, {221,0.03058416}, {222,0.03050495}, {223,0.04138614}, {224,0.03367327}, {225,0.03117822}, {226,0.03149505}, {227,0.03962376}, {228,0.03164356}, {229,0.03177228}, {230,0.04085149}, {231,0.03306931}, {232,0.03223762}, {233,0.04156436}, {234,0.03230693}, {235,0.03282178}, {236,0.03872277}, {237,0.03246535}, {238,0.03294059}, {239,0.03463366}, {240,0.03274257}, {241,0.03854455}, {242,0.03293069}, {243,0.04267327}, {244,0.03338614}, {245,0.03408911}, {246,0.03384158}, {247,0.03410891}, {248,0.03403960}, {249,0.03399010}, {250,0.03397030}, {251,0.03610891}, {252,0.03505941}, {253,0.04463366}, {254,0.03490099}, {255,0.04048515}, {256,0.03523762}, {257,0.03648515}, {258,0.03558416}, {259,0.03572277}, {260,0.04319802}, {261,0.03588119}, {262,0.03612871}, {263,0.04698020}, {264,0.03652475}, {265,0.03789109}, {266,0.04661386}, {267,0.03678218}, {268,0.03715842}, {269,1.02613861}, {270,0.03715842}, {271,0.03751485}, {272,0.04299010}, {273,0.05318812}, {274,0.03760396}, {275,0.03772277}, {276,0.04213861}, {277,0.04856436}, {278,0.03830693}, {279,0.03831683}, {280,0.03820792}, {281,0.04274257}, {282,0.04759406}, {283,0.04015842}, {284,0.03905941}, {285,0.03909901}, {286,0.03887129}, {287,0.03918812}, {288,0.04248515}, {289,0.04540594}, {290,0.04802970}, {291,0.05036634}, {292,0.05180198}, {293,0.04006931}, {294,0.04071287}, {295,0.04058416}, {296,0.04036634}, {297,0.04089109}, {298,0.04055446}, {299,0.04111881}, {300,0.04170297}, {301,0.04167327}, {302,0.04115842}, {303,0.04200000}, {304,0.04170297}, {305,0.06083168}, {306,0.05782178}, {307,0.05153465}, {308,0.04944554}, {309,0.04739604}, {310,0.04400000}, {311,0.04272277}, {312,0.04242574}, {313,0.04322772}, {314,0.04511881}, {315,0.05312871}, {316,0.04873267}, {317,0.04394059}, {318,0.04386139}, {319,0.04429703}, {320,0.05466337}, {321,0.04947525}, {322,0.04387129}, {323,0.04457426}, {324,0.05770297}, {325,0.05083168}, {326,0.04567327}, {327,0.04514851}, {328,0.05571287}, {329,0.04891089}, {330,0.04517822}, {331,0.06600990}, {332,0.05257426}, {333,0.04588119}, {334,0.06167327}, {335,0.05088119}, {336,0.04667327}, {337,0.05920792}, {338,0.04806931}, {339,0.04653465}, {340,0.05320792}, {341,0.04719802}, {342,0.05895050}, {343,0.04769307}, {344,0.06239604}, {345,0.04977228}, {346,0.04783168}, {347,0.05089109}, {348,0.04826733}, {349,0.05188119}, {350,0.04836634}, {351,0.05166337}, {352,0.04814851}, {353,0.05082178}, {354,0.06239604}, {355,0.04890099}, {356,0.05967327}, {357,0.04946535}, {358,0.06060396}, {359,0.04953465}, {360,0.05222772}, {361,0.06408911}, {362,0.04957426}, {363,0.05669307}, {364,0.05182178}, {365,0.05039604}, {366,0.05800990}, {367,0.05210891}, {368,0.05063366}, {369,0.05630693}, {370,0.06295050}, {371,0.05128713}, {372,0.05346535}, {373,0.06091089}, {374,0.05227723}, {375,0.05161386}, {376,0.05406931}, {377,0.06030693}, {378,0.06558416}, {379,0.05220792}, {380,0.05245545}, {381,0.05742574}, {382,0.06274257}, {383,0.06588119}, {384,0.05418812}, {385,0.05239604}, {386,0.05312871}, {387,0.05543564}, {388,0.05889109}, {389,0.06257426}, {390,0.06578218}, {391,0.06768317}, {392,0.06935644}, {393,0.05394059}, {394,0.05449505}, {395,0.05476238}, {396,0.05399010}, {397,0.05464356}, {398,0.05454455}, {399,0.05468317}, {400,0.05458416}, {401,0.05463366}, {402,0.05490099}, {403,0.05555446}, {404,0.05511881}, {405,0.05568317}, {406,0.05535644}, {407,0.05650495}, {408,0.07172277}, {409,0.07016832}, {410,0.06735644}, {411,0.06537624}, {412,0.06246535}, {413,0.05944554}, {414,0.05689109}, {415,0.05751485}, {416,0.05945545}, {417,0.07689109}, {418,0.06864356}, {419,0.06203960}, {420,0.05736634}, {421,0.05755446}, {422,0.07442574}, {423,0.06745545}, {424,0.06108911}, {425,0.05835644}, {426,0.07443564}, {427,0.06723762}, {428,0.06075248}, {429,0.05940594}, {430,0.07148515}, {431,0.06375248}, {432,0.05930693}, {433,0.07678218}, {434,0.06760396}, {435,0.06020792}, {436,0.07499010}, {437,0.06429703}, {438,0.06055446}, {439,0.07131683}, {440,0.06113861}, {441,0.07661386}, {442,0.06510891}, {443,0.06122772}, {444,0.06865347}, {445,0.06101980}, {446,0.07126733}, {447,0.06153465}, {448,0.07287129}, {449,0.06131683}, {450,0.07575248}, {451,0.06299010}, {452,0.07933663}, {453,0.06236634}, {454,0.07629703}, {455,0.06264356}, {456,0.07340594}, {457,0.06291089}, {458,0.06974257}, {459,0.08086139}, {460,0.06514851}, {461,0.07574257}, {462,0.06338614}, {463,0.07007921}, {464,0.07875248}, {465,0.06379208}, {466,0.07468317}, {467,0.08979208}, {468,0.06506931}, {469,0.07450495}, {470,0.08353465}, {471,0.06486139}, {472,0.07185149}, {473,0.07855446}, {474,0.06505941}, {475,0.06625743}, {476,0.07263366}, {477,0.07851485}, {478,0.08417822}, {479,0.06593069}, {480,0.07067327}, {481,0.08026733}, {482,0.08577228}, {483,0.08804950}, {484,0.06637624}, {485,0.06889109}, {486,0.07415842}, {487,0.07702970}, {488,0.07986139}, {489,0.08309901}, {490,0.08584158}, {491,0.06726733}, {492,0.06710891}, {493,0.06893069}, {494,0.07194059}, {495,0.07210891}, {496,0.07387129}, {497,0.07538614}, {498,0.07588119}, {499,0.07686139}, {500,0.07728713}, {505,0.07715842}, {510,0.07578218}, {515,0.07282178}, {520,0.07100000}, {525,0.08996040}, {530,0.08585149}, {535,0.07982178}, {540,0.09731683}, {545,0.08670297}, {550,0.07537624}, {555,0.08763366}, {560,0.09813861}, {565,0.08461386}, {570,0.09329703}, {575,0.10533663}, {580,0.08516832}, {585,0.09310891}, {590,0.09510891}, {595,0.09659406}, {600,0.09950495}, {605,0.09896040}, {610,0.09743564}, {615,0.09543564}, {620,0.09424752}, {625,0.08982178}, {630,0.11007921}, {635,0.09877228}, {640,0.09292079}, {645,0.10752475}, {650,0.09739604}, {655,0.10940594}, {660,0.09740594}, {665,0.11636634}, {670,0.12268317}, {675,0.10100000}, {680,0.10881188}, {685,0.11377228}, {690,0.11674257}, {695,0.12209901}, {700,0.13560396}, {705,0.12729703}, {710,0.12546535}, {715,0.12217822}, {720,0.11797030}, {725,0.11490099}, {730,0.11561386}, {735,0.13191089}, {740,0.12160396}, {745,0.11148515}, {750,0.12431683}, {755,0.11335644}, {760,0.13427723}, {765,0.14049505}, {770,0.12077228}, {775,0.12946535}, {780,0.13500990}, {785,0.11728713}, {790,0.12914851}, {795,0.12853465}, {800,0.12962376}, {805,0.12896040}, {810,0.12928713}, {815,0.12384158}, {820,0.12679208}, {825,0.12254455}, {830,0.14159406}, {835,0.13310891}, {840,0.12631683}, {845,0.14686139}, {850,0.13388119}, {855,0.14604950}, {860,0.13306931}, {865,0.15850495}, {870,0.13316832}, {875,0.13976238}, {880,0.14422772}, {885,0.15052475}, {890,0.16548515}, {895,0.13724752}, {900,0.13542574}, {905,0.13592079}, {910,0.13630693}, {915,0.14199010}, {920,0.16097030}, {925,0.15387129}, {930,0.14759406}, {935,0.14196040}, {940,0.16435644}, {945,0.15311881}, {950,0.14227723}, {955,0.15464356}, {960,0.14918812}, {965,0.15672277}, {970,0.16351485}, {975,0.14736634}, {980,0.16370297}, {985,0.16119802}, {990,0.16619802}, {995,0.16864356}, {1000,0.18690099}, {1010,0.17010891}, {1020,0.17033663}, {1030,0.16777228}, {1040,0.16633663}, {1050,0.18369307}, {1060,0.16864356}, {1070,0.19207921}, {1080,0.17015842}, {1090,0.17440594}, {1100,0.17711881}, {1110,0.18479208}, {1120,0.18107921}, {1130,0.17619802}, {1140,0.21291089}, {1150,0.18843564}, {1160,0.19933663}, {1170,0.18310891}, {1180,0.20066337}, {1190,0.20307921}, {1200,0.19618812}, {1210,0.19298020}, {1220,0.20893069}, {1230,0.21730693}, {1240,0.20019802}, {1250,0.19464356}, {1260,0.22533663}, {1270,0.22299010}, {1280,0.20205941}, {1290,0.21743564}, {1300,0.21886139}, {1310,0.21708911}, {1320,0.22460396}, {1330,0.21487129}, {1340,0.22574257}, {1350,0.23242574}, {1360,0.21656436}, {1370,0.23682178}, {1380,0.21609901}, {1390,0.22122772}, {1400,0.23041584}, {1410,0.22636634}, {1420,0.23647525}, {1430,0.22807921}, {1440,0.24218812}, {1450,0.23593069}, {1460,0.22874257}, {1470,0.24700000}, {1480,0.24700990}, {1490,0.25153465}, {1500,0.24002970}, {1510,0.23766337}, {1520,0.23366337}, {1530,0.25736634}, {1540,0.26319802}, {1550,0.24764356}, {1560,0.27720792}, {1570,0.25115842}, {1580,0.28705941}, {1590,0.27167327}, {1600,0.25957426}, {1610,0.25758416}, {1620,0.26559406}, {1630,0.27961386}, {1640,0.27863366}, {1650,0.26921782}, {1660,0.27305941}, {1670,0.27097030}, {1680,0.27607921}, {1690,0.28969307}, {1700,0.26860396}, {1710,0.27451485}, {1720,0.26733663}, {1730,0.29450495}, {1740,0.31377228}, {1750,0.28515842}, {1760,0.30804950}, {1770,0.28497030}, {1780,0.30423762}, {1790,0.29883168}, {1800,0.30194059}, {1810,0.28578218}, {1820,0.29477228}, {1830,0.30542574}, {1840,0.30745545}, {1850,0.32465347}, {1860,0.31194059}, {1870,0.31160396}, {1880,0.31235644}, {1890,0.32980198}, {1900,0.30542574}, {1910,0.30693069}, {1920,0.31887129}, {1930,0.32642574}, {1940,0.33094059}, {1950,0.30800000}, {1960,0.33319802}, {1970,0.32812871}, {1980,0.32794059}, {1990,0.33113861}, {2000,0.32535644}, {2050,0.32485149}, {2100,0.34885149}, {2150,0.34392079}, {2200,0.36342574}, {2250,0.37828713}, {2300,0.37424752}, {2350,0.38553465}, {2400,0.40687129}, {2450,0.41816832}, {2500,0.45391089}, {2550,0.41954455}, {2600,0.42489109}, {2650,0.44720792}, {2700,0.44738614}, {2750,0.44564356}, {2800,0.47449505}, {2850,0.50279208}, {2900,0.51417822}, {2950,0.52282178}, {3000,0.54205941}, {3050,0.53725743}, {3100,0.55972277}, {3150,0.55862376}, {3200,0.55590099}, {3250,0.54833663}, {3300,0.56727723}, {3350,0.57035644}, {3400,0.58930693}, {3450,0.59519802}, {3500,0.61264356}, {3550,0.62260396}, {3600,0.62396040}, {3650,0.62039604}, {3700,0.62557426}, {3750,0.63096040}, {3800,0.64138614}, {3850,0.63888119}, {3900,0.67355446}, {3950,0.70061386}, {4000,0.66465347}, {4050,0.69732673}, {4100,0.68914851}, {4150,0.71600000}, {4200,0.73365347}, {4250,0.72517822}, {4300,0.72705941}, {4350,0.74405941}, {4400,0.74574257}, {4450,0.75234653}, {4500,0.79587129}, {4550,0.77881188}, {4600,0.78248515}, {4650,0.80524752}, {4700,0.79705941}, {4750,0.82494059}, {4800,0.82643564}, {4850,0.85310891}, {4900,0.82492079}, {4950,0.87381188}, {5000,0.86130693}, {5050,0.88929703}, {5100,0.87048515}, {5150,0.89763366}, {5200,0.89314851}, {5250,0.92345545}, {5300,0.92500000}, {5350,0.92285149}, {5400,0.95281188}, {5450,0.94031683}, {5500,0.93953465}, {5550,0.98012871}, {5600,0.95457426}, {5650,0.96643564}, {5700,0.99225743}, {5750,1.00465347}, {5800,0.99491089}, {5850,1.02718812}, {5900,1.00719802}, {5950,1.03034653}, {6000,1.04305941}, {6050,1.0946000}, {6100,1.1131143}, {6150,1.1061429}, {6200,1.1075714}, {6250,1.1041714}, {6300,1.1262286}, {6350,1.1517143}, {6400,1.1550857}, {6450,1.1694857}, {6500,1.1716571}, {6550,1.1806286}, {6600,1.1921714}, {6650,1.2114286}, {6700,1.2311143}, {6750,1.2504286}, {6800,1.2426857}, {6850,1.2411143}, {6900,1.2635429}, {6950,1.2687714}, {7000,1.2874571}, {7050,1.2849143}, {7100,1.2867143}, {7150,1.3075714}, {7200,1.2870286}, {7250,1.2965429}, {7300,1.2928286}, {7350,1.3225714}, {7400,1.3505714}, {7450,1.3888286}, {7500,1.3894571}, {7550,1.3976571}, {7600,1.3792000}, {7650,1.4069429}, {7700,1.3846857}, {7750,1.3875143}, {7800,1.4764571}, {7850,1.4587714}, {7900,1.4498000}, {7950,1.4578571}, {8000,1.4354286}, {8050,1.4857429}, {8100,1.5208571}, {8150,1.4976286}, {8200,1.4950857}, {8250,1.4960857}, {8300,1.5394000}, {8350,1.5426000}, {8400,1.5313429}, {8450,1.5228571}, {8500,1.5698571}, {8550,1.5844571}, {8600,1.6012571}, {8650,1.5833714}, {8700,1.6294857}, {8750,1.6197429}, {8800,1.5988857}, {8850,1.6578286}, {8900,1.6232286}, {8950,1.6089714}, {9000,1.6857143}, {9050,1.6709714}, {9100,1.6551714}, {9150,1.7188286}, {9200,1.7032857}, {9250,1.7090857}, {9300,1.7415714}, {9350,1.7508571}, {9400,1.7413143}, {9450,1.7502286}, {9500,1.7442571}, {9550,1.7855714}, {9600,1.7370000}, {9650,1.8109143}, {9700,1.7718571}, {9750,1.8333429}, {9800,1.8227714}, {9850,1.8787429}, {9900,1.8161429}, {9950,1.8775143}, {10000,1.8098857}, {10100,1.8974571}, {10200,1.8850286}, {10300,1.9416571}, {10400,1.8789429}, {10500,1.9821429}, {10600,1.9311714}, {10700,1.9709429}, {10800,1.9729429}, {10900,2.0208000}, {11000,2.0132571}, {11100,2.0910000}, {11200,2.0407714}, {11300,2.0990286}, {11400,2.0880000}, {11500,2.1330286}, {11600,2.1268857}, {11700,2.1306857}, {11800,2.1762000}, {11900,2.1962000}, {12000,2.1876000}, {12100,2.2444571}, {12200,2.2462857}, {12300,2.2914286}, {12400,2.3014286}, {12500,2.2853143}, {12600,2.3035714}, {12700,2.3583143}, {12800,2.3538286}, {12900,2.4608571}, {13000,2.3745714}, {13100,2.4130000}, {13200,2.4322000}, {13300,2.4572286}, {13400,2.4386000}, {13500,2.4955714}, {13600,2.4896857}, {13700,2.5027714}, {13800,2.5160286}, {13900,2.5961143}, {14000,2.5691429}, {14100,2.6545429}, {14200,2.6079429}, {14300,2.6287714}, {14400,2.6162571}, {14500,2.7458571}, {14600,2.7074000}, {14700,3.1074571}, {14800,2.9992571}, {14900,2.9056286}, {15000,2.7409143}, {15100,2.8216571}, {15200,2.7872000}, {15300,2.9022000}, {15400,3.0475143}, {15500,2.9140857}, {15600,3.1872857}, {15700,2.9088571}, {15800,2.9902857}, {15900,2.9453429}, {16000,3.0072000}, {16100,3.0232857}, {16200,3.0167143}, {16300,3.1006857}, {16400,3.1136571}, {16500,3.3760000}, {16600,3.0391714}, {16700,3.0488571}, {16800,3.1985143}, {16900,3.0802857}, {17000,3.2246286}, {17100,3.1829429}, {17200,3.1812286}, {17300,3.2539429}, {17400,3.2721429}, {17500,3.1910571}, {17600,3.3091429}, {17700,3.2664571}, {17800,3.2715143}, {17900,3.3103143}, {18000,3.3018571}, {18100,3.3755714}, {18200,3.3670286}, {18300,3.4281714}, {18400,3.3732857}, {18500,3.3970000}, {18600,3.4143429}, {18700,3.4557429}, {18800,3.4724286}, {18900,3.4803429}, {19000,3.5316000}, {19100,3.5055429}, {19200,3.6062000}, {19300,3.6163143}, {19400,3.5547714}, {19500,3.6851143}, {19600,3.6753429}, {19700,3.7966286}, {19800,3.6729143}, {19900,3.8720000}, {20000,3.7778857}};
data["big_flat"]["LtacTacInTermPrimPair"]["Aggregate"]["system"] = {{1,0.00000000}, {2,0.00002970}, {3,0.00000000}, {4,0.00000000}, {5,0.00003960}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00003960}, {10,0.00000000}, {11,0.00006931}, {12,0.00000000}, {13,0.00000000}, {14,0.00002970}, {15,0.00003960}, {16,0.00002970}, {17,0.00003960}, {18,0.00006931}, {19,0.00000000}, {20,0.00003960}, {21,0.00000000}, {22,0.00003960}, {23,0.00003960}, {24,0.00003960}, {25,0.00000000}, {26,0.00003960}, {27,0.00000000}, {28,0.00011881}, {29,0.00003960}, {30,0.00002970}, {31,0.00003960}, {32,0.00003960}, {33,0.00003960}, {34,0.00003960}, {35,0.00000000}, {36,0.00002970}, {37,0.00003960}, {38,0.00002970}, {39,0.00003960}, {40,0.00003960}, {41,0.00003960}, {42,0.00003960}, {43,0.00000000}, {44,0.00000000}, {45,0.00002970}, {46,0.00000000}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00006931}, {51,0.00019802}, {52,0.00007921}, {53,0.00000000}, {54,0.00002970}, {55,0.00000000}, {56,0.00010891}, {57,0.00000000}, {58,0.00014851}, {59,0.00006931}, {60,0.00003960}, {61,0.00000000}, {62,0.00000000}, {63,0.00007921}, {64,0.00010891}, {65,0.00007921}, {66,0.00000000}, {67,0.00000000}, {68,0.00007921}, {69,0.00003960}, {70,0.00003960}, {71,0.00003960}, {72,0.00000000}, {73,0.00003960}, {74,0.00011881}, {75,0.00011881}, {76,0.00006931}, {77,0.00007921}, {78,0.00002970}, {79,0.00003960}, {80,0.00007921}, {81,0.00007921}, {82,0.00000000}, {83,0.00007921}, {84,0.00006931}, {85,0.00000000}, {86,0.00007921}, {87,0.00000000}, {88,0.00000000}, {89,0.00003960}, {90,0.00003960}, {91,0.00003960}, {92,0.00003960}, {93,0.00007921}, {94,0.00000000}, {95,0.00009901}, {96,0.00006931}, {97,0.00003960}, {98,0.00009901}, {99,0.00003960}, {100,0.00003960}, {101,0.00000000}, {102,0.00000000}, {103,0.00003960}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00011881}, {108,0.00000000}, {109,0.00010891}, {110,0.00000000}, {111,0.00000000}, {112,0.00007921}, {113,0.00002970}, {114,0.00003960}, {115,0.00014851}, {116,0.00003960}, {117,0.00003960}, {118,0.00000000}, {119,0.00007921}, {120,0.00000000}, {121,0.00003960}, {122,0.00000000}, {123,0.00011881}, {124,0.00014851}, {125,0.00000000}, {126,0.00009901}, {127,0.00007921}, {128,0.00003960}, {129,0.00003960}, {130,0.00026733}, {131,0.00003960}, {132,0.00007921}, {133,0.00018812}, {134,0.00007921}, {135,0.00003960}, {136,0.00011881}, {137,0.00011881}, {138,0.00003960}, {139,0.00003960}, {140,0.00010891}, {141,0.00011881}, {142,0.00002970}, {143,0.00014851}, {144,0.00000000}, {145,0.00014851}, {146,0.00003960}, {147,0.00005941}, {148,0.00000000}, {149,0.00010891}, {150,0.00010891}, {151,0.00003960}, {152,0.00003960}, {153,0.00006931}, {154,0.00003960}, {155,0.00003960}, {156,0.00023762}, {157,0.00010891}, {158,0.00003960}, {159,0.00000000}, {160,0.00000000}, {161,0.00003960}, {162,0.00007921}, {163,0.00000000}, {164,0.00022772}, {165,0.00003960}, {166,0.00003960}, {167,0.00007921}, {168,0.00007921}, {169,0.00000000}, {170,0.00003960}, {171,0.00024752}, {172,0.00007921}, {173,0.00000000}, {174,0.00000000}, {175,0.00006931}, {176,0.00006931}, {177,0.00010891}, {178,0.00011881}, {179,0.00003960}, {180,0.00007921}, {181,0.00019802}, {182,0.00000000}, {183,0.00003960}, {184,0.00003960}, {185,0.00000000}, {186,0.00003960}, {187,0.00003960}, {188,0.00015842}, {189,0.00007921}, {190,0.00011881}, {191,0.00000000}, {192,0.00002970}, {193,0.00007921}, {194,0.00000000}, {195,0.00007921}, {196,0.00007921}, {197,0.00000000}, {198,0.00003960}, {199,0.00003960}, {200,0.00011881}, {201,0.00003960}, {202,0.00000000}, {203,0.00000000}, {204,0.00002970}, {205,0.00034653}, {206,0.00015842}, {207,0.00015842}, {208,0.00011881}, {209,0.00002970}, {210,0.00007921}, {211,0.00003960}, {212,0.00003960}, {213,0.00007921}, {214,0.00019802}, {215,0.00010891}, {216,0.00003960}, {217,0.00003960}, {218,0.00003960}, {219,0.00046535}, {220,0.00015842}, {221,0.00000000}, {222,0.00006931}, {223,0.00035644}, {224,0.00015842}, {225,0.00002970}, {226,0.00007921}, {227,0.00026733}, {228,0.00000000}, {229,0.00002970}, {230,0.00022772}, {231,0.00003960}, {232,0.00006931}, {233,0.00023762}, {234,0.00007921}, {235,0.00007921}, {236,0.00038614}, {237,0.00003960}, {238,0.00007921}, {239,0.00015842}, {240,0.00015842}, {241,0.00003960}, {242,0.00000000}, {243,0.00011881}, {244,0.00003960}, {245,0.00000000}, {246,0.00000000}, {247,0.00003960}, {248,0.00003960}, {249,0.00003960}, {250,0.00003960}, {251,0.00000000}, {252,0.00000000}, {253,0.00003960}, {254,0.00000000}, {255,0.00003960}, {256,0.00002970}, {257,0.00007921}, {258,0.00007921}, {259,0.00000000}, {260,0.00006931}, {261,0.00003960}, {262,0.00007921}, {263,0.00007921}, {264,0.00010891}, {265,0.00000000}, {266,0.00003960}, {267,0.00003960}, {268,0.00000000}, {269,0.00258416}, {270,0.00007921}, {271,0.00002970}, {272,0.00023762}, {273,0.00000000}, {274,0.00000000}, {275,0.00015842}, {276,0.00003960}, {277,0.00015842}, {278,0.00003960}, {279,0.00011881}, {280,0.00000000}, {281,0.00003960}, {282,0.00000000}, {283,0.00000000}, {284,0.00015842}, {285,0.00000000}, {286,0.00007921}, {287,0.00007921}, {288,0.00003960}, {289,0.00010891}, {290,0.00003960}, {291,0.00000000}, {292,0.00003960}, {293,0.00019802}, {294,0.00006931}, {295,0.00011881}, {296,0.00015842}, {297,0.00000000}, {298,0.00007921}, {299,0.00003960}, {300,0.00003960}, {301,0.00003960}, {302,0.00003960}, {303,0.00000000}, {304,0.00007921}, {305,0.00003960}, {306,0.00000000}, {307,0.00007921}, {308,0.00002970}, {309,0.00003960}, {310,0.00007921}, {311,0.00003960}, {312,0.00007921}, {313,0.00000000}, {314,0.00003960}, {315,0.00000000}, {316,0.00006931}, {317,0.00000000}, {318,0.00003960}, {319,0.00000000}, {320,0.00011881}, {321,0.00007921}, {322,0.00003960}, {323,0.00015842}, {324,0.00015842}, {325,0.00000000}, {326,0.00000000}, {327,0.00003960}, {328,0.00007921}, {329,0.00007921}, {330,0.00000000}, {331,0.00000000}, {332,0.00005941}, {333,0.00018812}, {334,0.00003960}, {335,0.00007921}, {336,0.00003960}, {337,0.00003960}, {338,0.00015842}, {339,0.00006931}, {340,0.00003960}, {341,0.00006931}, {342,0.00000000}, {343,0.00003960}, {344,0.00003960}, {345,0.00000000}, {346,0.00011881}, {347,0.00011881}, {348,0.00007921}, {349,0.00011881}, {350,0.00007921}, {351,0.00014851}, {352,0.00011881}, {353,0.00006931}, {354,0.00003960}, {355,0.00010891}, {356,0.00000000}, {357,0.00009901}, {358,0.00019802}, {359,0.00003960}, {360,0.00007921}, {361,0.00003960}, {362,0.00011881}, {363,0.00011881}, {364,0.00007921}, {365,0.00000000}, {366,0.00011881}, {367,0.00014851}, {368,0.00003960}, {369,0.00003960}, {370,0.00034653}, {371,0.00013861}, {372,0.00003960}, {373,0.00003960}, {374,0.00006931}, {375,0.00007921}, {376,0.00011881}, {377,0.00007921}, {378,0.00003960}, {379,0.00000000}, {380,0.00003960}, {381,0.00003960}, {382,0.00003960}, {383,0.00007921}, {384,0.00015842}, {385,0.00007921}, {386,0.00003960}, {387,0.00002970}, {388,0.00003960}, {389,0.00003960}, {390,0.00003960}, {391,0.00006931}, {392,0.00003960}, {393,0.00003960}, {394,0.00000000}, {395,0.00000000}, {396,0.00003960}, {397,0.00003960}, {398,0.00007921}, {399,0.00000000}, {400,0.00003960}, {401,0.00003960}, {402,0.00003960}, {403,0.00007921}, {404,0.00007921}, {405,0.00011881}, {406,0.00007921}, {407,0.00007921}, {408,0.00011881}, {409,0.00003960}, {410,0.00003960}, {411,0.00003960}, {412,0.00003960}, {413,0.00003960}, {414,0.00007921}, {415,0.00000000}, {416,0.00006931}, {417,0.00000000}, {418,0.00006931}, {419,0.00003960}, {420,0.00003960}, {421,0.00007921}, {422,0.00011881}, {423,0.00003960}, {424,0.00000000}, {425,0.00000000}, {426,0.00011881}, {427,0.00000000}, {428,0.00003960}, {429,0.00003960}, {430,0.00003960}, {431,0.00000000}, {432,0.00007921}, {433,0.00010891}, {434,0.00000000}, {435,0.00003960}, {436,0.00000000}, {437,0.00007921}, {438,0.00003960}, {439,0.00003960}, {440,0.00003960}, {441,0.00003960}, {442,0.00011881}, {443,0.00000000}, {444,0.00007921}, {445,0.00007921}, {446,0.00003960}, {447,0.00003960}, {448,0.00011881}, {449,0.00000000}, {450,0.00003960}, {451,0.00000000}, {452,0.00003960}, {453,0.00007921}, {454,0.00003960}, {455,0.00007921}, {456,0.00003960}, {457,0.00000000}, {458,0.00015842}, {459,0.00002970}, {460,0.00003960}, {461,0.00003960}, {462,0.00000000}, {463,0.00015842}, {464,0.00003960}, {465,0.00007921}, {466,0.00003960}, {467,0.00007921}, {468,0.00007921}, {469,0.00011881}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00006931}, {474,0.00000000}, {475,0.00007921}, {476,0.00003960}, {477,0.00003960}, {478,0.00007921}, {479,0.00003960}, {480,0.00003960}, {481,0.00002970}, {482,0.00000000}, {483,0.00005941}, {484,0.00011881}, {485,0.00006931}, {486,0.00000000}, {487,0.00003960}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00015842}, {492,0.00003960}, {493,0.00011881}, {494,0.00007921}, {495,0.00019802}, {496,0.00003960}, {497,0.00000000}, {498,0.00000000}, {499,0.00011881}, {500,0.00002970}, {505,0.00007921}, {510,0.00007921}, {515,0.00000000}, {520,0.00003960}, {525,0.00007921}, {530,0.00011881}, {535,0.00003960}, {540,0.00003960}, {545,0.00003960}, {550,0.00002970}, {555,0.00000000}, {560,0.00011881}, {565,0.00007921}, {570,0.00015842}, {575,0.00000000}, {580,0.00003960}, {585,0.00000000}, {590,0.00007921}, {595,0.00003960}, {600,0.00003960}, {605,0.00003960}, {610,0.00000000}, {615,0.00011881}, {620,0.00000000}, {625,0.00000000}, {630,0.00007921}, {635,0.00000000}, {640,0.00006931}, {645,0.00003960}, {650,0.00011881}, {655,0.00003960}, {660,0.00022772}, {665,0.00003960}, {670,0.00007921}, {675,0.00006931}, {680,0.00007921}, {685,0.00003960}, {690,0.00007921}, {695,0.00000000}, {700,0.00007921}, {705,0.00007921}, {710,0.00014851}, {715,0.00003960}, {720,0.00003960}, {725,0.00015842}, {730,0.00011881}, {735,0.00007921}, {740,0.00019802}, {745,0.00000000}, {750,0.00003960}, {755,0.00000000}, {760,0.00007921}, {765,0.00003960}, {770,0.00003960}, {775,0.00003960}, {780,0.00011881}, {785,0.00007921}, {790,0.00007921}, {795,0.00000000}, {800,0.00002970}, {805,0.00015842}, {810,0.00000000}, {815,0.00003960}, {820,0.00000000}, {825,0.00022772}, {830,0.00007921}, {835,0.00015842}, {840,0.00003960}, {845,0.00009901}, {850,0.00003960}, {855,0.00003960}, {860,0.00003960}, {865,0.00015842}, {870,0.00003960}, {875,0.00006931}, {880,0.00011881}, {885,0.00019802}, {890,0.00003960}, {895,0.00015842}, {900,0.00007921}, {905,0.00000000}, {910,0.00000000}, {915,0.00007921}, {920,0.00003960}, {925,0.00010891}, {930,0.00022772}, {935,0.00011881}, {940,0.00000000}, {945,0.00009901}, {950,0.00000000}, {955,0.00003960}, {960,0.00007921}, {965,0.00011881}, {970,0.00007921}, {975,0.00011881}, {980,0.00000000}, {985,0.00007921}, {990,0.00010891}, {995,0.00000000}, {1000,0.00019802}, {1010,0.00003960}, {1020,0.00007921}, {1030,0.00000000}, {1040,0.00022772}, {1050,0.00003960}, {1060,0.00011881}, {1070,0.00011881}, {1080,0.00007921}, {1090,0.00019802}, {1100,0.00003960}, {1110,0.00003960}, {1120,0.00019802}, {1130,0.00003960}, {1140,0.00003960}, {1150,0.00000000}, {1160,0.00003960}, {1170,0.00011881}, {1180,0.00003960}, {1190,0.00003960}, {1200,0.00003960}, {1210,0.00010891}, {1220,0.00003960}, {1230,0.00000000}, {1240,0.00007921}, {1250,0.00007921}, {1260,0.00007921}, {1270,0.00015842}, {1280,0.00007921}, {1290,0.00000000}, {1300,0.00007921}, {1310,0.00007921}, {1320,0.00003960}, {1330,0.00003960}, {1340,0.00003960}, {1350,0.00010891}, {1360,0.00031683}, {1370,0.00007921}, {1380,0.00007921}, {1390,0.00002970}, {1400,0.00000000}, {1410,0.00003960}, {1420,0.00015842}, {1430,0.00011881}, {1440,0.00019802}, {1450,0.00007921}, {1460,0.00007921}, {1470,0.00011881}, {1480,0.00015842}, {1490,0.00003960}, {1500,0.00003960}, {1510,0.00011881}, {1520,0.00011881}, {1530,0.00011881}, {1540,0.00031683}, {1550,0.00003960}, {1560,0.00007921}, {1570,0.00003960}, {1580,0.00011881}, {1590,0.00003960}, {1600,0.00018812}, {1610,0.00011881}, {1620,0.00006931}, {1630,0.00000000}, {1640,0.00006931}, {1650,0.00015842}, {1660,0.00007921}, {1670,0.00007921}, {1680,0.00006931}, {1690,0.00007921}, {1700,0.00000000}, {1710,0.00007921}, {1720,0.00000000}, {1730,0.00007921}, {1740,0.00007921}, {1750,0.00011881}, {1760,0.00022772}, {1770,0.00003960}, {1780,0.00007921}, {1790,0.00030693}, {1800,0.00003960}, {1810,0.00007921}, {1820,0.00007921}, {1830,0.00007921}, {1840,0.00015842}, {1850,0.00003960}, {1860,0.00007921}, {1870,0.00002970}, {1880,0.00007921}, {1890,0.00011881}, {1900,0.00003960}, {1910,0.00022772}, {1920,0.00011881}, {1930,0.00007921}, {1940,0.00007921}, {1950,0.00003960}, {1960,0.00026733}, {1970,0.00011881}, {1980,0.00019802}, {1990,0.00023762}, {2000,0.00015842}, {2050,0.00019802}, {2100,0.00007921}, {2150,0.00019802}, {2200,0.00010891}, {2250,0.00018812}, {2300,0.00011881}, {2350,0.00000000}, {2400,0.00007921}, {2450,0.00030693}, {2500,0.00015842}, {2550,0.00006931}, {2600,0.00003960}, {2650,0.00015842}, {2700,0.00007921}, {2750,0.00007921}, {2800,0.00015842}, {2850,0.00000000}, {2900,0.00011881}, {2950,0.00007921}, {3000,0.00011881}, {3050,0.00003960}, {3100,0.00408911}, {3150,0.00031683}, {3200,0.00026733}, {3250,0.00007921}, {3300,0.00018812}, {3350,0.00018812}, {3400,0.00011881}, {3450,0.00015842}, {3500,0.00026733}, {3550,0.00007921}, {3600,0.00014851}, {3650,0.00011881}, {3700,0.00003960}, {3750,0.00007921}, {3800,0.00015842}, {3850,0.00003960}, {3900,0.00011881}, {3950,0.00011881}, {4000,0.00027723}, {4050,0.00011881}, {4100,0.00000000}, {4150,0.00007921}, {4200,0.00007921}, {4250,0.00011881}, {4300,0.00027723}, {4350,0.00027723}, {4400,0.00019802}, {4450,0.00011881}, {4500,0.00000000}, {4550,0.00007921}, {4600,0.00007921}, {4650,0.00003960}, {4700,0.00011881}, {4750,0.00023762}, {4800,0.00015842}, {4850,0.00043564}, {4900,0.00007921}, {4950,0.00023762}, {5000,0.00027723}, {5050,0.00047525}, {5100,0.00023762}, {5150,0.00003960}, {5200,0.00063366}, {5250,0.00011881}, {5300,0.00018812}, {5350,0.00014851}, {5400,0.00015842}, {5450,0.00011881}, {5500,0.00019802}, {5550,0.00023762}, {5600,0.00018812}, {5650,0.00000000}, {5700,0.00010891}, {5750,0.00011881}, {5800,0.00011881}, {5850,0.00019802}, {5900,0.00011881}, {5950,0.00003960}, {6000,0.00019802}, {6050,0.0010000}, {6100,0.0071143}, {6150,0.0001143}, {6200,0.0002286}, {6250,0.0060857}, {6300,0.0002286}, {6350,0.0001143}, {6400,0.0001143}, {6450,0.0001143}, {6500,0.0003429}, {6550,0.0005429}, {6600,0.0001143}, {6650,0.0003429}, {6700,0.0003429}, {6750,0.0000000}, {6800,0.0006857}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0004571}, {7000,0.0004571}, {7050,0.0002286}, {7100,0.0000000}, {7150,0.0004571}, {7200,0.0002286}, {7250,0.0000000}, {7300,0.0003143}, {7350,0.0000000}, {7400,0.0004571}, {7450,0.0000000}, {7500,0.0001143}, {7550,0.0001143}, {7600,0.0001143}, {7650,0.0003429}, {7700,0.0001143}, {7750,0.0001143}, {7800,0.0002286}, {7850,0.0002286}, {7900,0.0001143}, {7950,0.0004571}, {8000,0.0001143}, {8050,0.0004571}, {8100,0.0001143}, {8150,0.0000000}, {8200,0.0002000}, {8250,0.0002286}, {8300,0.0001143}, {8350,0.0003429}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0004286}, {8550,0.0002286}, {8600,0.0001143}, {8650,0.0003429}, {8700,0.0001143}, {8750,0.0000857}, {8800,0.0003429}, {8850,0.0002286}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0001143}, {9050,0.0000000}, {9100,0.0003429}, {9150,0.0000000}, {9200,0.0001143}, {9250,0.0003429}, {9300,0.0002286}, {9350,0.0003429}, {9400,0.0002286}, {9450,0.0002286}, {9500,0.0003429}, {9550,0.0004571}, {9600,0.0000000}, {9650,0.0001143}, {9700,0.0002000}, {9750,0.0000000}, {9800,0.0002286}, {9850,0.0000000}, {9900,0.0002000}, {9950,0.0003429}, {10000,0.0004571}, {10100,0.0001143}, {10200,0.0059714}, {10300,0.0001143}, {10400,0.0003429}, {10500,0.0002286}, {10600,0.0002000}, {10700,0.0002286}, {10800,0.0000000}, {10900,0.0001143}, {11000,0.0003429}, {11100,0.0001143}, {11200,0.0004571}, {11300,0.0005429}, {11400,0.0004571}, {11500,0.0002286}, {11600,0.0001143}, {11700,0.0000000}, {11800,0.0001143}, {11900,0.0000000}, {12000,0.0001143}, {12100,0.0003429}, {12200,0.0004571}, {12300,0.0002286}, {12400,0.0003429}, {12500,0.0000857}, {12600,0.0002286}, {12700,0.0008000}, {12800,0.0000000}, {12900,0.0012571}, {13000,0.0001143}, {13100,0.0006857}, {13200,0.0002286}, {13300,0.0003429}, {13400,0.0003429}, {13500,0.0000000}, {13600,0.0003143}, {13700,0.0001143}, {13800,0.0004571}, {13900,0.0005714}, {14000,0.0008857}, {14100,0.0010286}, {14200,0.0005714}, {14300,0.0005429}, {14400,0.0003429}, {14500,0.0002286}, {14600,0.0003429}, {14700,0.0006857}, {14800,0.0009143}, {14900,0.0008000}, {15000,0.0002286}, {15100,0.0003429}, {15200,0.0007429}, {15300,0.0009143}, {15400,0.0011143}, {15500,0.0009143}, {15600,0.0002286}, {15700,0.0010286}, {15800,0.0013429}, {15900,0.0002000}, {16000,0.0006857}, {16100,0.0004571}, {16200,0.0008000}, {16300,0.0023714}, {16400,0.0005714}, {16500,0.0013714}, {16600,0.0011429}, {16700,0.0011429}, {16800,0.0002286}, {16900,0.0006571}, {17000,0.0011429}, {17100,0.0017143}, {17200,0.0006571}, {17300,0.0009143}, {17400,0.0005714}, {17500,0.0001143}, {17600,0.0014857}, {17700,0.0004571}, {17800,0.0010000}, {17900,0.0004571}, {18000,0.0003429}, {18100,0.0003429}, {18200,0.0018286}, {18300,0.0004571}, {18400,0.0009143}, {18500,0.0002286}, {18600,0.0003429}, {18700,0.0009143}, {18800,0.0007429}, {18900,0.0002286}, {19000,0.0006857}, {19100,0.0004571}, {19200,0.0012571}, {19300,0.0016000}, {19400,0.0008857}, {19500,0.0004571}, {19600,0.0004571}, {19700,0.0033143}, {19800,0.0024000}, {19900,0.0012571}, {20000,0.0030571}};
data["big_flat"]["LtacTacInTermPrimPair"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00012871}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00117822}, {16,0.00190099}, {17,0.00200000}, {18,0.00200000}, {19,0.00200000}, {20,0.00200000}, {21,0.00200990}, {22,0.00209901}, {23,0.00231683}, {24,0.00281188}, {25,0.00300000}, {26,0.00300000}, {27,0.00300000}, {28,0.00300000}, {29,0.00303960}, {30,0.00317822}, {31,0.00338614}, {32,0.00355446}, {33,0.00400000}, {34,0.00400000}, {35,0.00400000}, {36,0.00400990}, {37,0.00410891}, {38,0.00425743}, {39,0.00640594}, {40,0.00453465}, {41,0.00500000}, {42,0.00500000}, {43,0.00500000}, {44,0.00503960}, {45,0.00522772}, {46,0.00515842}, {47,0.00542574}, {48,0.00550495}, {49,0.00598020}, {50,0.00600000}, {51,0.00768317}, {52,0.00609901}, {53,0.00620792}, {54,0.00638614}, {55,0.00626733}, {56,0.00648515}, {57,0.00690099}, {58,0.00700990}, {59,0.00705941}, {60,0.00726733}, {61,0.00714851}, {62,0.00715842}, {63,0.00739604}, {64,0.00739604}, {65,0.00785149}, {66,0.00804950}, {67,0.00809901}, {68,0.00830693}, {69,0.00821782}, {70,0.00823762}, {71,0.00831683}, {72,0.00842574}, {73,0.00885149}, {74,0.00903960}, {75,0.00914851}, {76,0.00911881}, {77,0.00917822}, {78,0.00927723}, {79,0.00935644}, {80,0.00935644}, {81,0.00985149}, {82,0.01003960}, {83,0.01440594}, {84,0.01011881}, {85,0.01021782}, {86,0.01014851}, {87,0.01038614}, {88,0.01037624}, {89,0.01073267}, {90,0.01098020}, {91,0.01113861}, {92,0.01114851}, {93,0.01115842}, {94,0.01114851}, {95,0.01130693}, {96,0.01133663}, {97,0.01168317}, {98,0.01195050}, {99,0.01211881}, {100,0.01218812}, {101,0.01228713}, {102,0.01215842}, {103,0.01242574}, {104,0.01249505}, {105,0.01269307}, {106,0.01296040}, {107,0.01317822}, {108,0.01326733}, {109,0.01683168}, {110,0.01315842}, {111,0.01336634}, {112,0.01348515}, {113,0.01364356}, {114,0.01387129}, {115,0.01903960}, {116,0.01408911}, {117,0.01414851}, {118,0.01441584}, {119,0.01442574}, {120,0.01736634}, {121,0.01463366}, {122,0.01488119}, {123,0.01521782}, {124,0.01702970}, {125,0.01518812}, {126,0.01521782}, {127,0.02125743}, {128,0.01547525}, {129,0.01583168}, {130,0.02221782}, {131,0.01611881}, {132,0.01623762}, {133,0.02130693}, {134,0.01637624}, {135,0.01645545}, {136,0.01738614}, {137,0.01682178}, {138,0.02325743}, {139,0.01712871}, {140,0.01726733}, {141,0.01723762}, {142,0.01738614}, {143,0.01747525}, {144,0.01748515}, {145,0.02015842}, {146,0.01792079}, {147,0.02091089}, {148,0.01830693}, {149,0.02041584}, {150,0.01843564}, {151,0.01864356}, {152,0.01868317}, {153,0.01873267}, {154,0.01898020}, {155,0.01918812}, {156,0.02382178}, {157,0.01951485}, {158,0.01933663}, {159,0.01976238}, {160,0.01952475}, {161,0.02183168}, {162,0.01980198}, {163,0.02012871}, {164,0.02317822}, {165,0.02054455}, {166,0.02049505}, {167,0.02232673}, {168,0.02059406}, {169,0.02071287}, {170,0.02073267}, {171,0.02603960}, {172,0.02136634}, {173,0.02138614}, {174,0.02133663}, {175,0.02557426}, {176,0.02164356}, {177,0.02183168}, {178,0.02169307}, {179,0.02199010}, {180,0.02569307}, {181,0.03108911}, {182,0.02251485}, {183,0.02243564}, {184,0.02252475}, {185,0.02262376}, {186,0.02281188}, {187,0.02502970}, {188,0.02823762}, {189,0.03075248}, {190,0.02328713}, {191,0.02369307}, {192,0.02350495}, {193,0.02367327}, {194,0.02382178}, {195,0.02403960}, {196,0.02403960}, {197,0.02432673}, {198,0.02443564}, {199,0.02440594}, {200,0.02444554}, {201,0.02461386}, {202,0.02482178}, {203,0.02518812}, {204,0.02514851}, {205,0.03425743}, {206,0.03232673}, {207,0.02837624}, {208,0.02772277}, {209,0.02564356}, {210,0.02568317}, {211,0.02609901}, {212,0.02621782}, {213,0.02644554}, {214,0.03679208}, {215,0.02989109}, {216,0.02653465}, {217,0.02681188}, {218,0.02652475}, {219,0.03644554}, {220,0.02959406}, {221,0.02734653}, {222,0.02732673}, {223,0.03875248}, {224,0.03066337}, {225,0.02767327}, {226,0.02772277}, {227,0.03688119}, {228,0.02804950}, {229,0.02826733}, {230,0.03814851}, {231,0.02967327}, {232,0.02863366}, {233,0.03854455}, {234,0.02877228}, {235,0.02924752}, {236,0.03627723}, {237,0.02925743}, {238,0.02957426}, {239,0.03124752}, {240,0.02975248}, {241,0.03561386}, {242,0.02973267}, {243,0.03933663}, {244,0.03004950}, {245,0.03061386}, {246,0.03048515}, {247,0.03040594}, {248,0.03037624}, {249,0.03085149}, {250,0.03082178}, {251,0.03236634}, {252,0.03143564}, {253,0.04124752}, {254,0.03144554}, {255,0.03763366}, {256,0.03182178}, {257,0.03306931}, {258,0.03184158}, {259,0.03200990}, {260,0.03986139}, {261,0.03231683}, {262,0.03249505}, {263,0.04350495}, {264,0.03265347}, {265,0.03433663}, {266,0.04314851}, {267,0.03327723}, {268,0.03317822}, {269,1.02659406}, {270,0.03357426}, {271,0.03375248}, {272,0.03972277}, {273,0.05012871}, {274,0.03401980}, {275,0.03436634}, {276,0.03855446}, {277,0.04507921}, {278,0.03494059}, {279,0.03498020}, {280,0.03475248}, {281,0.03917822}, {282,0.04394059}, {283,0.03669307}, {284,0.03554455}, {285,0.03560396}, {286,0.03565347}, {287,0.03598020}, {288,0.03884158}, {289,0.04202970}, {290,0.04435644}, {291,0.04704950}, {292,0.04853465}, {293,0.03672277}, {294,0.03724752}, {295,0.03702970}, {296,0.03695050}, {297,0.03717822}, {298,0.03711881}, {299,0.03729703}, {300,0.03789109}, {301,0.03781188}, {302,0.03790099}, {303,0.03836634}, {304,0.03815842}, {305,0.05699010}, {306,0.05378218}, {307,0.04816832}, {308,0.04574257}, {309,0.04341584}, {310,0.04029703}, {311,0.03887129}, {312,0.03886139}, {313,0.03916832}, {314,0.03947525}, {315,0.04941584}, {316,0.04484158}, {317,0.03989109}, {318,0.03986139}, {319,0.04023762}, {320,0.05097030}, {321,0.04514851}, {322,0.03999010}, {323,0.04032673}, {324,0.05375248}, {325,0.04711881}, {326,0.04117822}, {327,0.04114851}, {328,0.05178218}, {329,0.04485149}, {330,0.04090099}, {331,0.06178218}, {332,0.04906931}, {333,0.04187129}, {334,0.05755446}, {335,0.04701980}, {336,0.04204950}, {337,0.05490099}, {338,0.04384158}, {339,0.04235644}, {340,0.04959406}, {341,0.04284158}, {342,0.05475248}, {343,0.04342574}, {344,0.05779208}, {345,0.04560396}, {346,0.04347525}, {347,0.04715842}, {348,0.04371287}, {349,0.04791089}, {350,0.04398020}, {351,0.04770297}, {352,0.04366337}, {353,0.04662376}, {354,0.05801980}, {355,0.04451485}, {356,0.05538614}, {357,0.04485149}, {358,0.05606931}, {359,0.04501980}, {360,0.04793069}, {361,0.05975248}, {362,0.04518812}, {363,0.05237624}, {364,0.04585149}, {365,0.04552475}, {366,0.05345545}, {367,0.04608911}, {368,0.04604950}, {369,0.05216832}, {370,0.05861386}, {371,0.04659406}, {372,0.04903960}, {373,0.05608911}, {374,0.04698020}, {375,0.04701980}, {376,0.04957426}, {377,0.05570297}, {378,0.06125743}, {379,0.04740594}, {380,0.04786139}, {381,0.05287129}, {382,0.05804950}, {383,0.06167327}, {384,0.04783168}, {385,0.04781188}, {386,0.04821782}, {387,0.05096040}, {388,0.05444554}, {389,0.05779208}, {390,0.06126733}, {391,0.06319802}, {392,0.06486139}, {393,0.04926733}, {394,0.04950495}, {395,0.04995050}, {396,0.04918812}, {397,0.04988119}, {398,0.05009901}, {399,0.04986139}, {400,0.05004950}, {401,0.04998020}, {402,0.04993069}, {403,0.05098020}, {404,0.05053465}, {405,0.05099010}, {406,0.05084158}, {407,0.05143564}, {408,0.06696040}, {409,0.06536634}, {410,0.06276238}, {411,0.06067327}, {412,0.05736634}, {413,0.05461386}, {414,0.05206931}, {415,0.05238614}, {416,0.05222772}, {417,0.07202970}, {418,0.06400990}, {419,0.05715842}, {420,0.05254455}, {421,0.05263366}, {422,0.06964356}, {423,0.06266337}, {424,0.05573267}, {425,0.05298020}, {426,0.06937624}, {427,0.06244554}, {428,0.05536634}, {429,0.05401980}, {430,0.06635644}, {431,0.05870297}, {432,0.05408911}, {433,0.07175248}, {434,0.06254455}, {435,0.05472277}, {436,0.06992079}, {437,0.05952475}, {438,0.05500990}, {439,0.06611881}, {440,0.05525743}, {441,0.07174257}, {442,0.06007921}, {443,0.05566337}, {444,0.06364356}, {445,0.05572277}, {446,0.06601980}, {447,0.05622772}, {448,0.06772277}, {449,0.05587129}, {450,0.07034653}, {451,0.05674257}, {452,0.07431683}, {453,0.05701980}, {454,0.07090099}, {455,0.05733663}, {456,0.06786139}, {457,0.05737624}, {458,0.06483168}, {459,0.07566337}, {460,0.05994059}, {461,0.07048515}, {462,0.05815842}, {463,0.06500990}, {464,0.07371287}, {465,0.05820792}, {466,0.06948515}, {467,0.08464356}, {468,0.05873267}, {469,0.06890099}, {470,0.07809901}, {471,0.05934653}, {472,0.06620792}, {473,0.07315842}, {474,0.05960396}, {475,0.06108911}, {476,0.06718812}, {477,0.07316832}, {478,0.07883168}, {479,0.06034653}, {480,0.06520792}, {481,0.07467327}, {482,0.08026733}, {483,0.08290099}, {484,0.06097030}, {485,0.06336634}, {486,0.06832673}, {487,0.07183168}, {488,0.07452475}, {489,0.07763366}, {490,0.08032673}, {491,0.06161386}, {492,0.06156436}, {493,0.06189109}, {494,0.06574257}, {495,0.06638614}, {496,0.06827723}, {497,0.07006931}, {498,0.07039604}, {499,0.07131683}, {500,0.07150495}, {505,0.07150495}, {510,0.07001980}, {515,0.06676238}, {520,0.06514851}, {525,0.08443564}, {530,0.07999010}, {535,0.07399010}, {540,0.09126733}, {545,0.08057426}, {550,0.06914851}, {555,0.08175248}, {560,0.09225743}, {565,0.07856436}, {570,0.08703960}, {575,0.09888119}, {580,0.07845545}, {585,0.08607921}, {590,0.08845545}, {595,0.09035644}, {600,0.09284158}, {605,0.09194059}, {610,0.09072277}, {615,0.08864356}, {620,0.08734653}, {625,0.08265347}, {630,0.10311881}, {635,0.09191089}, {640,0.08549505}, {645,0.10075248}, {650,0.09024752}, {655,0.10254455}, {660,0.09041584}, {665,0.10914851}, {670,0.11353465}, {675,0.09403960}, {680,0.10190099}, {685,0.10599010}, {690,0.10972277}, {695,0.11261386}, {700,0.12830693}, {705,0.12002970}, {710,0.11835644}, {715,0.11480198}, {720,0.11033663}, {725,0.10731683}, {730,0.10768317}, {735,0.12420792}, {740,0.11392079}, {745,0.10328713}, {750,0.11641584}, {755,0.10509901}, {760,0.12648515}, {765,0.13221782}, {770,0.11219802}, {775,0.12103960}, {780,0.12711881}, {785,0.10894059}, {790,0.12079208}, {795,0.11992079}, {800,0.12100990}, {805,0.12040594}, {810,0.12060396}, {815,0.11528713}, {820,0.11795050}, {825,0.11307921}, {830,0.13313861}, {835,0.12433663}, {840,0.11714851}, {845,0.13816832}, {850,0.12466337}, {855,0.13745545}, {860,0.12417822}, {865,0.14651485}, {870,0.12215842}, {875,0.13037624}, {880,0.13531683}, {885,0.14132673}, {890,0.15614851}, {895,0.12624752}, {900,0.12621782}, {905,0.12654455}, {910,0.12664356}, {915,0.13054455}, {920,0.15178218}, {925,0.14446535}, {930,0.13832673}, {935,0.13233663}, {940,0.15452475}, {945,0.14363366}, {950,0.13113861}, {955,0.14313861}, {960,0.13931683}, {965,0.14681188}, {970,0.15376238}, {975,0.13761386}, {980,0.15375248}, {985,0.15118812}, {990,0.15620792}, {995,0.15830693}, {1000,0.17691089}, {1010,0.15997030}, {1020,0.16036634}, {1030,0.15743564}, {1040,0.15595050}, {1050,0.17333663}, {1060,0.15820792}, {1070,0.18192079}, {1080,0.15920792}, {1090,0.16162376}, {1100,0.16634653}, {1110,0.17352475}, {1120,0.16994059}, {1130,0.16468317}, {1140,0.20194059}, {1150,0.17711881}, {1160,0.18782178}, {1170,0.17150495}, {1180,0.18914851}, {1190,0.19153465}, {1200,0.18202970}, {1210,0.17852475}, {1220,0.19695050}, {1230,0.20538614}, {1240,0.18792079}, {1250,0.18020792}, {1260,0.21325743}, {1270,0.21081188}, {1280,0.18984158}, {1290,0.20485149}, {1300,0.20616832}, {1310,0.20473267}, {1320,0.21179208}, {1330,0.20213861}, {1340,0.21307921}, {1350,0.21936634}, {1360,0.20366337}, {1370,0.22372277}, {1380,0.20327723}, {1390,0.20759406}, {1400,0.21715842}, {1410,0.21292079}, {1420,0.22324752}, {1430,0.21440594}, {1440,0.22881188}, {1450,0.22183168}, {1460,0.21465347}, {1470,0.23289109}, {1480,0.23322772}, {1490,0.23348515}, {1500,0.22571287}, {1510,0.22326733}, {1520,0.21899010}, {1530,0.24289109}, {1540,0.24606931}, {1550,0.23277228}, {1560,0.26224752}, {1570,0.23638614}, {1580,0.27210891}, {1590,0.25649505}, {1600,0.24421782}, {1610,0.24245545}, {1620,0.25013861}, {1630,0.26449505}, {1640,0.26330693}, {1650,0.25365347}, {1660,0.25758416}, {1670,0.25540594}, {1680,0.26018812}, {1690,0.27370297}, {1700,0.25021782}, {1710,0.25816832}, {1720,0.24804950}, {1730,0.27849505}, {1740,0.29760396}, {1750,0.26564356}, {1760,0.29179208}, {1770,0.26564356}, {1780,0.28763366}, {1790,0.28220792}, {1800,0.28528713}, {1810,0.26683168}, {1820,0.27684158}, {1830,0.28836634}, {1840,0.29029703}, {1850,0.30719802}, {1860,0.29474257}, {1870,0.29381188}, {1880,0.29484158}, {1890,0.31253465}, {1900,0.28125743}, {1910,0.28900990}, {1920,0.29864356}, {1930,0.30741584}, {1940,0.31277228}, {1950,0.28976238}, {1960,0.31336634}, {1970,0.30990099}, {1980,0.30939604}, {1990,0.31033663}, {2000,0.30651485}, {2050,0.30578218}, {2100,0.32945545}, {2150,0.32368317}, {2200,0.34311881}, {2250,0.35758416}, {2300,0.35279208}, {2350,0.36069307}, {2400,0.38488119}, {2450,0.39534653}, {2500,0.43078218}, {2550,0.39595050}, {2600,0.39300990}, {2650,0.42105941}, {2700,0.42208911}, {2750,0.41981188}, {2800,0.44868317}, {2850,0.47192079}, {2900,0.48024752}, {2950,0.49210891}, {3000,0.51384158}, {3050,0.50837624}, {3100,0.53422772}, {3150,0.52944554}, {3200,0.52267327}, {3250,0.51517822}, {3300,0.53598020}, {3350,0.53870297}, {3400,0.55391089}, {3450,0.56104950}, {3500,0.57994059}, {3550,0.58923762}, {3600,0.58384158}, {3650,0.58182178}, {3700,0.59016832}, {3750,0.59093069}, {3800,0.60528713}, {3850,0.60216832}, {3900,0.63370297}, {3950,0.66307921}, {4000,0.62426733}, {4050,0.65878218}, {4100,0.64949505}, {4150,0.67661386}, {4200,0.69338614}, {4250,0.68487129}, {4300,0.68140594}, {4350,0.70250495}, {4400,0.70334653}, {4450,0.70931683}, {4500,0.75230693}, {4550,0.73537624}, {4600,0.73519802}, {4650,0.75353465}, {4700,0.75162376}, {4750,0.77465347}, {4800,0.77234653}, {4850,0.79984158}, {4900,0.77504950}, {4950,0.82599010}, {5000,0.80241584}, {5050,0.82487129}, {5100,0.82074257}, {5150,0.84554455}, {5200,0.84061386}, {5250,0.86300000}, {5300,0.87313861}, {5350,0.86481188}, {5400,0.88845545}, {5450,0.87976238}, {5500,0.88103960}, {5550,0.92575248}, {5600,0.89282178}, {5650,0.90329703}, {5700,0.93627723}, {5750,0.94788119}, {5800,0.92203960}, {5850,0.95930693}, {5900,0.94843564}, {5950,0.96794059}, {6000,0.98138614}, {6050,1.0203714}, {6100,1.0483143}, {6150,1.0324000}, {6200,1.0213714}, {6250,1.0283714}, {6300,1.0516286}, {6350,1.0762286}, {6400,1.0787143}, {6450,1.0924286}, {6500,1.0921714}, {6550,1.0892286}, {6600,1.1135143}, {6650,1.1257429}, {6700,1.1360000}, {6750,1.1537429}, {6800,1.1488857}, {6850,1.1563714}, {6900,1.1806857}, {6950,1.1844286}, {7000,1.2038857}, {7050,1.1993714}, {7100,1.1978000}, {7150,1.2161714}, {7200,1.1918000}, {7250,1.2073429}, {7300,1.2012000}, {7350,1.2223143}, {7400,1.2577429}, {7450,1.2858286}, {7500,1.2990000}, {7550,1.3054000}, {7600,1.2806000}, {7650,1.3134571}, {7700,1.2811714}, {7750,1.2944571}, {7800,1.3690286}, {7850,1.3582857}, {7900,1.3412857}, {7950,1.3570000}, {8000,1.3288286}, {8050,1.3751143}, {8100,1.4194857}, {8150,1.3819143}, {8200,1.3762286}, {8250,1.3716571}, {8300,1.4349714}, {8350,1.4388286}, {8400,1.4178857}, {8450,1.4164857}, {8500,1.4580571}, {8550,1.4716286}, {8600,1.4717143}, {8650,1.4536286}, {8700,1.5107714}, {8750,1.5042000}, {8800,1.4633143}, {8850,1.5388571}, {8900,1.5088286}, {8950,1.4830286}, {9000,1.5602571}, {9050,1.5431429}, {9100,1.5293429}, {9150,1.5892000}, {9200,1.5770857}, {9250,1.5594000}, {9300,1.6082857}, {9350,1.5937714}, {9400,1.6102286}, {9450,1.6136000}, {9500,1.5954571}, {9550,1.6290571}, {9600,1.6072571}, {9650,1.6587429}, {9700,1.6385714}, {9750,1.6992571}, {9800,1.6731714}, {9850,1.7152857}, {9900,1.6834857}, {9950,1.7449143}, {10000,1.6768571}, {10100,1.7620286}, {10200,1.7308857}, {10300,1.7976571}, {10400,1.7348857}, {10500,1.8186571}, {10600,1.7582286}, {10700,1.8215429}, {10800,1.8056857}, {10900,1.8695143}, {11000,1.8587143}, {11100,1.9153714}, {11200,1.8760286}, {11300,1.9205429}, {11400,1.9080286}, {11500,1.9538000}, {11600,1.9663143}, {11700,1.9777429}, {11800,1.9998000}, {11900,2.0160000}, {12000,2.0232286}, {12100,2.0648000}, {12200,2.0629429}, {12300,2.0680571}, {12400,2.1058857}, {12500,2.1064857}, {12600,2.1152571}, {12700,2.1456000}, {12800,2.1515429}, {12900,2.2688286}, {13000,2.1860571}, {13100,2.2101429}, {13200,2.2447429}, {13300,2.2471143}, {13400,2.2407714}, {13500,2.2944857}, {13600,2.3010286}, {13700,2.3091143}, {13800,2.3198286}, {13900,2.3520857}, {14000,2.3666857}, {14100,2.4455143}, {14200,2.4093143}, {14300,2.4166286}, {14400,2.4189143}, {14500,2.5263429}, {14600,2.4573143}, {14700,2.8341143}, {14800,2.7797429}, {14900,2.6012000}, {15000,2.5282286}, {15100,2.5553143}, {15200,2.5440571}, {15300,2.6770857}, {15400,2.7994286}, {15500,2.6975143}, {15600,2.9177714}, {15700,2.6588286}, {15800,2.7584286}, {15900,2.6865429}, {16000,2.7667429}, {16100,2.7744000}, {16200,2.7892000}, {16300,2.8260286}, {16400,2.8328286}, {16500,3.1075143}, {16600,2.7726857}, {16700,2.8100000}, {16800,2.8911143}, {16900,2.8286571}, {17000,2.9461714}, {17100,2.9578571}, {17200,2.8904857}, {17300,2.9854000}, {17400,2.9453429}, {17500,2.9354000}, {17600,3.0518571}, {17700,2.9889143}, {17800,2.9908286}, {17900,3.0287714}, {18000,3.0254000}, {18100,3.0449714}, {18200,3.0831714}, {18300,3.0983714}, {18400,3.0793714}, {18500,3.1070857}, {18600,3.1197143}, {18700,3.1502286}, {18800,3.1681714}, {18900,3.2091429}, {19000,3.2195143}, {19100,3.2422286}, {19200,3.3152000}, {19300,3.2663143}, {19400,3.2719429}, {19500,3.3677143}, {19600,3.3789714}, {19700,3.4808286}, {19800,3.3296571}, {19900,3.4250571}, {20000,3.4757143}};
data["big_flat"]["LtacTacInTermPrimPair"]["actual reif"]["user"] = {{1,0.00020792}, {2,0.00026733}, {3,0.00031683}, {4,0.00060396}, {5,0.00060396}, {6,0.00099010}, {7,0.00083168}, {8,0.00114851}, {9,0.00086139}, {10,0.00104950}, {11,0.00098020}, {12,0.00159406}, {13,0.00136634}, {14,0.00146535}, {15,0.00154455}, {16,0.00178218}, {17,0.00169307}, {18,0.00205941}, {19,0.00225743}, {20,0.00203960}, {21,0.00224752}, {22,0.00247525}, {23,0.00265347}, {24,0.00267327}, {25,0.00286139}, {26,0.00257426}, {27,0.00299010}, {28,0.00303960}, {29,0.00314851}, {30,0.00342574}, {31,0.00372277}, {32,0.00351485}, {33,0.00369307}, {34,0.00370297}, {35,0.00412871}, {36,0.00410891}, {37,0.00427723}, {38,0.00450495}, {39,0.00670297}, {40,0.00458416}, {41,0.00501980}, {42,0.00507921}, {43,0.00491089}, {44,0.00520792}, {45,0.00541584}, {46,0.00552475}, {47,0.00596040}, {48,0.00609901}, {49,0.00583168}, {50,0.00622772}, {51,0.00801980}, {52,0.00625743}, {53,0.00670297}, {54,0.00670297}, {55,0.00678218}, {56,0.00701980}, {57,0.00693069}, {58,0.00680198}, {59,0.00732673}, {60,0.00737624}, {61,0.00722772}, {62,0.00739604}, {63,0.00736634}, {64,0.00759406}, {65,0.00774257}, {66,0.00791089}, {67,0.00790099}, {68,0.00810891}, {69,0.00839604}, {70,0.00848515}, {71,0.00834653}, {72,0.00827723}, {73,0.00891089}, {74,0.00890099}, {75,0.00899010}, {76,0.00896040}, {77,0.00923762}, {78,0.00961386}, {79,0.00942574}, {80,0.00987129}, {81,0.01000000}, {82,0.01021782}, {83,0.01467327}, {84,0.01016832}, {85,0.01041584}, {86,0.01032673}, {87,0.01064356}, {88,0.01047525}, {89,0.01106931}, {90,0.01094059}, {91,0.01148515}, {92,0.01119802}, {93,0.01148515}, {94,0.01156436}, {95,0.01155446}, {96,0.01176238}, {97,0.01200990}, {98,0.01171287}, {99,0.01219802}, {100,0.01239604}, {101,0.01239604}, {102,0.01259406}, {103,0.01300990}, {104,0.01269307}, {105,0.01278218}, {106,0.01312871}, {107,0.01307921}, {108,0.01375248}, {109,0.01686139}, {110,0.01365347}, {111,0.01368317}, {112,0.01367327}, {113,0.01391089}, {114,0.01413861}, {115,0.01873267}, {116,0.01444554}, {117,0.01449505}, {118,0.01463366}, {119,0.01483168}, {120,0.01725743}, {121,0.01519802}, {122,0.01535644}, {123,0.01530693}, {124,0.01721782}, {125,0.01567327}, {126,0.01575248}, {127,0.02094059}, {128,0.01607921}, {129,0.01631683}, {130,0.02208911}, {131,0.01628713}, {132,0.01668317}, {133,0.02094059}, {134,0.01665347}, {135,0.01668317}, {136,0.01760396}, {137,0.01690099}, {138,0.02309901}, {139,0.01726733}, {140,0.01700000}, {141,0.01747525}, {142,0.01736634}, {143,0.01737624}, {144,0.01733663}, {145,0.01978218}, {146,0.01756436}, {147,0.02045545}, {148,0.01794059}, {149,0.02026733}, {150,0.01794059}, {151,0.01846535}, {152,0.01829703}, {153,0.01861386}, {154,0.01840594}, {155,0.01863366}, {156,0.02373267}, {157,0.01904950}, {158,0.01891089}, {159,0.01917822}, {160,0.01910891}, {161,0.02164356}, {162,0.01953465}, {163,0.01988119}, {164,0.02316832}, {165,0.01994059}, {166,0.02017822}, {167,0.02208911}, {168,0.02037624}, {169,0.02068317}, {170,0.02038614}, {171,0.02600990}, {172,0.02100990}, {173,0.02066337}, {174,0.02127723}, {175,0.02520792}, {176,0.02166337}, {177,0.02192079}, {178,0.02168317}, {179,0.02181188}, {180,0.02591089}, {181,0.03106931}, {182,0.02220792}, {183,0.02244554}, {184,0.02266337}, {185,0.02300990}, {186,0.02265347}, {187,0.02499010}, {188,0.02799010}, {189,0.03117822}, {190,0.02358416}, {191,0.02381188}, {192,0.02377228}, {193,0.02377228}, {194,0.02390099}, {195,0.02431683}, {196,0.02407921}, {197,0.02452475}, {198,0.02474257}, {199,0.02450495}, {200,0.02449505}, {201,0.02489109}, {202,0.02508911}, {203,0.02519802}, {204,0.02490099}, {205,0.03411881}, {206,0.03242574}, {207,0.02825743}, {208,0.02758416}, {209,0.02568317}, {210,0.02587129}, {211,0.02573267}, {212,0.02652475}, {213,0.02623762}, {214,0.03673267}, {215,0.02984158}, {216,0.02638614}, {217,0.02718812}, {218,0.02641584}, {219,0.03605941}, {220,0.02971287}, {221,0.02715842}, {222,0.02731683}, {223,0.03801980}, {224,0.03086139}, {225,0.02763366}, {226,0.02757426}, {227,0.03663366}, {228,0.02778218}, {229,0.02792079}, {230,0.03794059}, {231,0.02998020}, {232,0.02848515}, {233,0.03800990}, {234,0.02844554}, {235,0.02879208}, {236,0.03603960}, {237,0.02889109}, {238,0.02909901}, {239,0.03103960}, {240,0.02935644}, {241,0.03606931}, {242,0.03000000}, {243,0.03883168}, {244,0.02985149}, {245,0.03085149}, {246,0.03041584}, {247,0.03029703}, {248,0.03006931}, {249,0.03110891}, {250,0.03096040}, {251,0.03216832}, {252,0.03166337}, {253,0.04098020}, {254,0.03135644}, {255,0.03741584}, {256,0.03168317}, {257,0.03316832}, {258,0.03178218}, {259,0.03170297}, {260,0.03939604}, {261,0.03206931}, {262,0.03251485}, {263,0.04328713}, {264,0.03238614}, {265,0.03427723}, {266,0.04268317}, {267,0.03337624}, {268,0.03325743}, {269,1.02298020}, {270,0.03399010}, {271,0.03349505}, {272,0.03954455}, {273,0.05005941}, {274,0.03399010}, {275,0.03461386}, {276,0.03786139}, {277,0.04506931}, {278,0.03492079}, {279,0.03504950}, {280,0.03509901}, {281,0.03867327}, {282,0.04375248}, {283,0.03665347}, {284,0.03573267}, {285,0.03589109}, {286,0.03603960}, {287,0.03636634}, {288,0.03841584}, {289,0.04188119}, {290,0.04447525}, {291,0.04716832}, {292,0.04836634}, {293,0.03685149}, {294,0.03724752}, {295,0.03673267}, {296,0.03672277}, {297,0.03703960}, {298,0.03690099}, {299,0.03722772}, {300,0.03764356}, {301,0.03777228}, {302,0.03779208}, {303,0.03819802}, {304,0.03811881}, {305,0.05682178}, {306,0.05342574}, {307,0.04796040}, {308,0.04612871}, {309,0.04338614}, {310,0.03997030}, {311,0.03858416}, {312,0.03877228}, {313,0.03881188}, {314,0.03941584}, {315,0.04919802}, {316,0.04493069}, {317,0.03970297}, {318,0.03951485}, {319,0.03991089}, {320,0.05051485}, {321,0.04520792}, {322,0.03982178}, {323,0.04004950}, {324,0.05333663}, {325,0.04726733}, {326,0.04087129}, {327,0.04057426}, {328,0.05134653}, {329,0.04463366}, {330,0.04040594}, {331,0.06180198}, {332,0.04896040}, {333,0.04159406}, {334,0.05758416}, {335,0.04668317}, {336,0.04168317}, {337,0.05480198}, {338,0.04382178}, {339,0.04219802}, {340,0.04958416}, {341,0.04294059}, {342,0.05454455}, {343,0.04316832}, {344,0.05771287}, {345,0.04536634}, {346,0.04340594}, {347,0.04717822}, {348,0.04367327}, {349,0.04801980}, {350,0.04372277}, {351,0.04781188}, {352,0.04358416}, {353,0.04697030}, {354,0.05796040}, {355,0.04430693}, {356,0.05545545}, {357,0.04487129}, {358,0.05566337}, {359,0.04477228}, {360,0.04817822}, {361,0.05977228}, {362,0.04553465}, {363,0.05224752}, {364,0.04587129}, {365,0.04518812}, {366,0.05293069}, {367,0.04603960}, {368,0.04600000}, {369,0.05237624}, {370,0.05811881}, {371,0.04644554}, {372,0.04953465}, {373,0.05571287}, {374,0.04761386}, {375,0.04709901}, {376,0.04966337}, {377,0.05575248}, {378,0.06099010}, {379,0.04721782}, {380,0.04789109}, {381,0.05273267}, {382,0.05802970}, {383,0.06168317}, {384,0.04789109}, {385,0.04802970}, {386,0.04817822}, {387,0.05092079}, {388,0.05422772}, {389,0.05762376}, {390,0.06111881}, {391,0.06307921}, {392,0.06491089}, {393,0.04960396}, {394,0.04931683}, {395,0.04993069}, {396,0.04921782}, {397,0.04992079}, {398,0.05009901}, {399,0.04987129}, {400,0.05007921}, {401,0.04999010}, {402,0.04991089}, {403,0.05087129}, {404,0.05067327}, {405,0.05085149}, {406,0.05095050}, {407,0.05129703}, {408,0.06684158}, {409,0.06538614}, {410,0.06282178}, {411,0.06072277}, {412,0.05709901}, {413,0.05465347}, {414,0.05184158}, {415,0.05203960}, {416,0.05197030}, {417,0.07210891}, {418,0.06385149}, {419,0.05694059}, {420,0.05250495}, {421,0.05269307}, {422,0.06942574}, {423,0.06264356}, {424,0.05557426}, {425,0.05285149}, {426,0.06906931}, {427,0.06243564}, {428,0.05493069}, {429,0.05408911}, {430,0.06599010}, {431,0.05829703}, {432,0.05395050}, {433,0.07140594}, {434,0.06244554}, {435,0.05404950}, {436,0.06947525}, {437,0.05987129}, {438,0.05486139}, {439,0.06586139}, {440,0.05481188}, {441,0.07175248}, {442,0.06026733}, {443,0.05542574}, {444,0.06315842}, {445,0.05542574}, {446,0.06558416}, {447,0.05620792}, {448,0.06724752}, {449,0.05559406}, {450,0.07003960}, {451,0.05673267}, {452,0.07387129}, {453,0.05657426}, {454,0.07067327}, {455,0.05716832}, {456,0.06735644}, {457,0.05722772}, {458,0.06447525}, {459,0.07549505}, {460,0.06020792}, {461,0.07049505}, {462,0.05797030}, {463,0.06497030}, {464,0.07378218}, {465,0.05819802}, {466,0.06935644}, {467,0.08432673}, {468,0.05846535}, {469,0.06868317}, {470,0.07793069}, {471,0.05948515}, {472,0.06599010}, {473,0.07323762}, {474,0.05990099}, {475,0.06102970}, {476,0.06691089}, {477,0.07316832}, {478,0.07842574}, {479,0.06067327}, {480,0.06502970}, {481,0.07456436}, {482,0.08020792}, {483,0.08263366}, {484,0.06101980}, {485,0.06339604}, {486,0.06829703}, {487,0.07190099}, {488,0.07463366}, {489,0.07722772}, {490,0.08008911}, {491,0.06165347}, {492,0.06145545}, {493,0.06181188}, {494,0.06517822}, {495,0.06609901}, {496,0.06800000}, {497,0.07012871}, {498,0.07032673}, {499,0.07143564}, {500,0.07163366}, {505,0.07183168}, {510,0.06975248}, {515,0.06621782}, {520,0.06485149}, {525,0.08409901}, {530,0.07974257}, {535,0.07390099}, {540,0.09127723}, {545,0.08037624}, {550,0.06927723}, {555,0.08165347}, {560,0.09217822}, {565,0.07833663}, {570,0.08678218}, {575,0.09897030}, {580,0.07837624}, {585,0.08608911}, {590,0.08802970}, {595,0.09027723}, {600,0.09273267}, {605,0.09219802}, {610,0.09032673}, {615,0.08813861}, {620,0.08704950}, {625,0.08277228}, {630,0.10300990}, {635,0.09189109}, {640,0.08544554}, {645,0.10089109}, {650,0.09005941}, {655,0.10230693}, {660,0.08977228}, {665,0.10873267}, {670,0.11335644}, {675,0.09389109}, {680,0.10135644}, {685,0.10637624}, {690,0.10927723}, {695,0.11237624}, {700,0.12810891}, {705,0.11969307}, {710,0.11793069}, {715,0.11447525}, {720,0.10983168}, {725,0.10709901}, {730,0.10775248}, {735,0.12413861}, {740,0.11378218}, {745,0.10306931}, {750,0.11600990}, {755,0.10505941}, {760,0.12619802}, {765,0.13225743}, {770,0.11200990}, {775,0.12114851}, {780,0.12700000}, {785,0.10875248}, {790,0.12055446}, {795,0.11975248}, {800,0.12068317}, {805,0.12010891}, {810,0.12037624}, {815,0.11526733}, {820,0.11794059}, {825,0.11274257}, {830,0.13299010}, {835,0.12412871}, {840,0.11704950}, {845,0.13773267}, {850,0.12474257}, {855,0.13710891}, {860,0.12370297}, {865,0.14632673}, {870,0.12177228}, {875,0.13031683}, {880,0.13486139}, {885,0.14100000}, {890,0.15579208}, {895,0.12600990}, {900,0.12583168}, {905,0.12615842}, {910,0.12656436}, {915,0.13027723}, {920,0.15161386}, {925,0.14432673}, {930,0.13819802}, {935,0.13237624}, {940,0.15444554}, {945,0.14331683}, {950,0.13126733}, {955,0.14299010}, {960,0.13905941}, {965,0.14681188}, {970,0.15374257}, {975,0.13748515}, {980,0.15355446}, {985,0.15087129}, {990,0.15591089}, {995,0.15800000}, {1000,0.17676238}, {1010,0.15983168}, {1020,0.16014851}, {1030,0.15701980}, {1040,0.15564356}, {1050,0.17286139}, {1060,0.15812871}, {1070,0.18177228}, {1080,0.15898020}, {1090,0.16146535}, {1100,0.16624752}, {1110,0.17264356}, {1120,0.16924752}, {1130,0.16436634}, {1140,0.20178218}, {1150,0.17674257}, {1160,0.18748515}, {1170,0.17105941}, {1180,0.18890099}, {1190,0.19110891}, {1200,0.18152475}, {1210,0.17819802}, {1220,0.19616832}, {1230,0.20490099}, {1240,0.18735644}, {1250,0.17918812}, {1260,0.21268317}, {1270,0.21021782}, {1280,0.18912871}, {1290,0.20420792}, {1300,0.20579208}, {1310,0.20421782}, {1320,0.21111881}, {1330,0.20161386}, {1340,0.21233663}, {1350,0.21857426}, {1360,0.20286139}, {1370,0.22313861}, {1380,0.20260396}, {1390,0.20731683}, {1400,0.21650495}, {1410,0.21245545}, {1420,0.22298020}, {1430,0.21374257}, {1440,0.22839604}, {1450,0.22103960}, {1460,0.21416832}, {1470,0.23229703}, {1480,0.23243564}, {1490,0.23282178}, {1500,0.22522772}, {1510,0.22248515}, {1520,0.21855446}, {1530,0.24213861}, {1540,0.24523762}, {1550,0.23213861}, {1560,0.26148515}, {1570,0.23554455}, {1580,0.27112871}, {1590,0.25607921}, {1600,0.24389109}, {1610,0.24193069}, {1620,0.24943564}, {1630,0.26367327}, {1640,0.26236634}, {1650,0.25269307}, {1660,0.25688119}, {1670,0.25484158}, {1680,0.25936634}, {1690,0.27309901}, {1700,0.24961386}, {1710,0.25734653}, {1720,0.24726733}, {1730,0.27763366}, {1740,0.29694059}, {1750,0.26501980}, {1760,0.29087129}, {1770,0.26497030}, {1780,0.28662376}, {1790,0.28103960}, {1800,0.28452475}, {1810,0.26641584}, {1820,0.27613861}, {1830,0.28746535}, {1840,0.28926733}, {1850,0.30645545}, {1860,0.29371287}, {1870,0.29289109}, {1880,0.29381188}, {1890,0.31149505}, {1900,0.28058416}, {1910,0.28841584}, {1920,0.29755446}, {1930,0.30670297}, {1940,0.31199010}, {1950,0.28888119}, {1960,0.31245545}, {1970,0.30929703}, {1980,0.30839604}, {1990,0.30937624}, {2000,0.30554455}, {2050,0.30468317}, {2100,0.32873267}, {2150,0.32300000}, {2200,0.34214851}, {2250,0.35636634}, {2300,0.35176238}, {2350,0.35993069}, {2400,0.38400990}, {2450,0.39412871}, {2500,0.42989109}, {2550,0.39510891}, {2600,0.39184158}, {2650,0.42034653}, {2700,0.42112871}, {2750,0.41891089}, {2800,0.44755446}, {2850,0.47057426}, {2900,0.47895050}, {2950,0.49093069}, {3000,0.51301980}, {3050,0.50741584}, {3100,0.52930693}, {3150,0.52829703}, {3200,0.52178218}, {3250,0.51432673}, {3300,0.53505941}, {3350,0.53789109}, {3400,0.55306931}, {3450,0.55993069}, {3500,0.57894059}, {3550,0.58823762}, {3600,0.58298020}, {3650,0.58089109}, {3700,0.58926733}, {3750,0.58998020}, {3800,0.60413861}, {3850,0.60141584}, {3900,0.63293069}, {3950,0.66235644}, {4000,0.62327723}, {4050,0.65767327}, {4100,0.64833663}, {4150,0.67579208}, {4200,0.69230693}, {4250,0.68359406}, {4300,0.68015842}, {4350,0.70119802}, {4400,0.70211881}, {4450,0.70822772}, {4500,0.75122772}, {4550,0.73391089}, {4600,0.73400990}, {4650,0.75233663}, {4700,0.75021782}, {4750,0.77345545}, {4800,0.77047525}, {4850,0.79804950}, {4900,0.77369307}, {4950,0.82439604}, {5000,0.80057426}, {5050,0.82305941}, {5100,0.81905941}, {5150,0.84402970}, {5200,0.83848515}, {5250,0.86102970}, {5300,0.87139604}, {5350,0.86275248}, {5400,0.88642574}, {5450,0.87764356}, {5500,0.87911881}, {5550,0.92400000}, {5600,0.89107921}, {5650,0.90125743}, {5700,0.93449505}, {5750,0.94615842}, {5800,0.92028713}, {5850,0.95772277}, {5900,0.94640594}, {5950,0.96654455}, {6000,0.97960396}, {6050,1.0186571}, {6100,1.0408571}, {6150,1.0318857}, {6200,1.0206000}, {6250,1.0220571}, {6300,1.0505714}, {6350,1.0752571}, {6400,1.0774571}, {6450,1.0912000}, {6500,1.0905429}, {6550,1.0877714}, {6600,1.1130857}, {6650,1.1248000}, {6700,1.1350000}, {6750,1.1512857}, {6800,1.1459143}, {6850,1.1556286}, {6900,1.1776000}, {6950,1.1821143}, {7000,1.2017143}, {7050,1.1987143}, {7100,1.1933714}, {7150,1.2150571}, {7200,1.1906571}, {7250,1.2060000}, {7300,1.1997714}, {7350,1.2158857}, {7400,1.2509429}, {7450,1.2842571}, {7500,1.2956286}, {7550,1.3026857}, {7600,1.2776857}, {7650,1.3072571}, {7700,1.2795143}, {7750,1.2883429}, {7800,1.3671429}, {7850,1.3547143}, {7900,1.3391714}, {7950,1.3547714}, {8000,1.3277714}, {8050,1.3732000}, {8100,1.4181143}, {8150,1.3804857}, {8200,1.3746857}, {8250,1.3703714}, {8300,1.4332000}, {8350,1.4374000}, {8400,1.4163714}, {8450,1.4145429}, {8500,1.4562571}, {8550,1.4698286}, {8600,1.4696286}, {8650,1.4519143}, {8700,1.5093429}, {8750,1.5026857}, {8800,1.4616000}, {8850,1.5368857}, {8900,1.5075429}, {8950,1.4815429}, {9000,1.5589429}, {9050,1.5414857}, {9100,1.5273429}, {9150,1.5878571}, {9200,1.5734286}, {9250,1.5544857}, {9300,1.6061429}, {9350,1.5910000}, {9400,1.6084000}, {9450,1.6117143}, {9500,1.5940000}, {9550,1.6269429}, {9600,1.6050857}, {9650,1.6559714}, {9700,1.6358571}, {9750,1.6971143}, {9800,1.6702571}, {9850,1.7128857}, {9900,1.6811714}, {9950,1.7418571}, {10000,1.6743429}, {10100,1.7596286}, {10200,1.7233429}, {10300,1.7949714}, {10400,1.7319429}, {10500,1.8159429}, {10600,1.7559429}, {10700,1.8198286}, {10800,1.8032857}, {10900,1.8666286}, {11000,1.8551143}, {11100,1.9130286}, {11200,1.8730286}, {11300,1.9170286}, {11400,1.9047429}, {11500,1.9512000}, {11600,1.9635143}, {11700,1.9750286}, {11800,1.9970857}, {11900,2.0131429}, {12000,2.0197429}, {12100,2.0615429}, {12200,2.0590571}, {12300,2.0652286}, {12400,2.1026000}, {12500,2.1028286}, {12600,2.1118286}, {12700,2.1418571}, {12800,2.1485429}, {12900,2.2647143}, {13000,2.1833429}, {13100,2.2061714}, {13200,2.2416571}, {13300,2.2437714}, {13400,2.2378571}, {13500,2.2921714}, {13600,2.2981429}, {13700,2.3061429}, {13800,2.3170571}, {13900,2.3492571}, {14000,2.3633714}, {14100,2.4421429}, {14200,2.4061143}, {14300,2.4137143}, {14400,2.4166000}, {14500,2.5240286}, {14600,2.4540286}, {14700,2.8297429}, {14800,2.7758571}, {14900,2.5978571}, {15000,2.5250000}, {15100,2.5525714}, {15200,2.5408000}, {15300,2.6735429}, {15400,2.7956286}, {15500,2.6937714}, {15600,2.9146286}, {15700,2.6554571}, {15800,2.7550286}, {15900,2.6839429}, {16000,2.7644571}, {16100,2.7715714}, {16200,2.7859429}, {16300,2.8218857}, {16400,2.8312571}, {16500,3.1048571}, {16600,2.7697143}, {16700,2.8068571}, {16800,2.8883714}, {16900,2.8260571}, {17000,2.9428857}, {17100,2.9536571}, {17200,2.8871429}, {17300,2.9817143}, {17400,2.9423429}, {17500,2.9325143}, {17600,3.0469429}, {17700,2.9860286}, {17800,2.9871143}, {17900,3.0258000}, {18000,3.0225143}, {18100,3.0423714}, {18200,3.0788571}, {18300,3.0941429}, {18400,3.0752000}, {18500,3.1034857}, {18600,3.1162571}, {18700,3.1457714}, {18800,3.1583429}, {18900,3.1892857}, {19000,3.2111143}, {19100,3.2297143}, {19200,3.3102286}, {19300,3.2613429}, {19400,3.2546286}, {19500,3.3511429}, {19600,3.3513714}, {19700,3.4615714}, {19800,3.3116286}, {19900,3.4221714}, {20000,3.4705429}};
data["big_flat"]["LtacTacInTermPrimPair"]["actual reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00006931}, {12,0.00000000}, {13,0.00000000}, {14,0.00002970}, {15,0.00000000}, {16,0.00000000}, {17,0.00003960}, {18,0.00002970}, {19,0.00000000}, {20,0.00003960}, {21,0.00000000}, {22,0.00000000}, {23,0.00003960}, {24,0.00003960}, {25,0.00000000}, {26,0.00003960}, {27,0.00000000}, {28,0.00011881}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00003960}, {33,0.00000000}, {34,0.00003960}, {35,0.00000000}, {36,0.00000000}, {37,0.00003960}, {38,0.00002970}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00002970}, {46,0.00000000}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00003960}, {51,0.00015842}, {52,0.00003960}, {53,0.00000000}, {54,0.00002970}, {55,0.00000000}, {56,0.00003960}, {57,0.00000000}, {58,0.00006931}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00003960}, {66,0.00000000}, {67,0.00000000}, {68,0.00003960}, {69,0.00003960}, {70,0.00003960}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00007921}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00003960}, {80,0.00003960}, {81,0.00003960}, {82,0.00000000}, {83,0.00007921}, {84,0.00002970}, {85,0.00000000}, {86,0.00007921}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00003960}, {91,0.00003960}, {92,0.00000000}, {93,0.00003960}, {94,0.00000000}, {95,0.00009901}, {96,0.00000000}, {97,0.00000000}, {98,0.00006931}, {99,0.00003960}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00003960}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00007921}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00003960}, {113,0.00002970}, {114,0.00000000}, {115,0.00014851}, {116,0.00003960}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00003960}, {122,0.00000000}, {123,0.00007921}, {124,0.00010891}, {125,0.00000000}, {126,0.00002970}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00011881}, {131,0.00003960}, {132,0.00003960}, {133,0.00010891}, {134,0.00000000}, {135,0.00000000}, {136,0.00003960}, {137,0.00011881}, {138,0.00003960}, {139,0.00003960}, {140,0.00003960}, {141,0.00000000}, {142,0.00002970}, {143,0.00002970}, {144,0.00000000}, {145,0.00010891}, {146,0.00003960}, {147,0.00000000}, {148,0.00000000}, {149,0.00006931}, {150,0.00002970}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00003960}, {155,0.00000000}, {156,0.00011881}, {157,0.00006931}, {158,0.00003960}, {159,0.00000000}, {160,0.00000000}, {161,0.00003960}, {162,0.00003960}, {163,0.00000000}, {164,0.00022772}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00003960}, {169,0.00000000}, {170,0.00000000}, {171,0.00020792}, {172,0.00007921}, {173,0.00000000}, {174,0.00000000}, {175,0.00006931}, {176,0.00000000}, {177,0.00007921}, {178,0.00007921}, {179,0.00003960}, {180,0.00003960}, {181,0.00015842}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00003960}, {188,0.00011881}, {189,0.00007921}, {190,0.00003960}, {191,0.00000000}, {192,0.00000000}, {193,0.00007921}, {194,0.00000000}, {195,0.00007921}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00003960}, {200,0.00011881}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00031683}, {206,0.00011881}, {207,0.00011881}, {208,0.00011881}, {209,0.00002970}, {210,0.00000000}, {211,0.00000000}, {212,0.00003960}, {213,0.00000000}, {214,0.00019802}, {215,0.00010891}, {216,0.00003960}, {217,0.00000000}, {218,0.00003960}, {219,0.00034653}, {220,0.00007921}, {221,0.00000000}, {222,0.00000000}, {223,0.00031683}, {224,0.00007921}, {225,0.00000000}, {226,0.00003960}, {227,0.00026733}, {228,0.00000000}, {229,0.00000000}, {230,0.00018812}, {231,0.00003960}, {232,0.00000000}, {233,0.00015842}, {234,0.00000000}, {235,0.00003960}, {236,0.00034653}, {237,0.00003960}, {238,0.00003960}, {239,0.00011881}, {240,0.00007921}, {241,0.00000000}, {242,0.00000000}, {243,0.00007921}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00003960}, {249,0.00000000}, {250,0.00003960}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00002970}, {257,0.00003960}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00003960}, {262,0.00003960}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00003960}, {267,0.00000000}, {268,0.00000000}, {269,0.00230693}, {270,0.00000000}, {271,0.00000000}, {272,0.00011881}, {273,0.00000000}, {274,0.00000000}, {275,0.00007921}, {276,0.00000000}, {277,0.00003960}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003960}, {282,0.00000000}, {283,0.00000000}, {284,0.00003960}, {285,0.00000000}, {286,0.00003960}, {287,0.00003960}, {288,0.00000000}, {289,0.00003960}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00003960}, {294,0.00002970}, {295,0.00003960}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00003960}, {308,0.00002970}, {309,0.00003960}, {310,0.00003960}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00003960}, {317,0.00000000}, {318,0.00003960}, {319,0.00000000}, {320,0.00007921}, {321,0.00000000}, {322,0.00003960}, {323,0.00007921}, {324,0.00003960}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00003960}, {329,0.00003960}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00011881}, {334,0.00003960}, {335,0.00003960}, {336,0.00003960}, {337,0.00000000}, {338,0.00007921}, {339,0.00003960}, {340,0.00000000}, {341,0.00002970}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00003960}, {347,0.00003960}, {348,0.00000000}, {349,0.00011881}, {350,0.00003960}, {351,0.00007921}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00006931}, {356,0.00000000}, {357,0.00003960}, {358,0.00015842}, {359,0.00000000}, {360,0.00007921}, {361,0.00003960}, {362,0.00007921}, {363,0.00003960}, {364,0.00007921}, {365,0.00000000}, {366,0.00011881}, {367,0.00003960}, {368,0.00000000}, {369,0.00003960}, {370,0.00010891}, {371,0.00006931}, {372,0.00003960}, {373,0.00003960}, {374,0.00000000}, {375,0.00007921}, {376,0.00003960}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00003960}, {385,0.00003960}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00003960}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00003960}, {399,0.00000000}, {400,0.00003960}, {401,0.00003960}, {402,0.00000000}, {403,0.00003960}, {404,0.00000000}, {405,0.00003960}, {406,0.00007921}, {407,0.00003960}, {408,0.00003960}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00003960}, {413,0.00003960}, {414,0.00000000}, {415,0.00000000}, {416,0.00002970}, {417,0.00000000}, {418,0.00003960}, {419,0.00000000}, {420,0.00000000}, {421,0.00003960}, {422,0.00003960}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00003960}, {429,0.00003960}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00003960}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00003960}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00003960}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00003960}, {446,0.00003960}, {447,0.00003960}, {448,0.00003960}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00003960}, {453,0.00003960}, {454,0.00000000}, {455,0.00003960}, {456,0.00003960}, {457,0.00000000}, {458,0.00007921}, {459,0.00000000}, {460,0.00000000}, {461,0.00003960}, {462,0.00000000}, {463,0.00007921}, {464,0.00000000}, {465,0.00003960}, {466,0.00000000}, {467,0.00007921}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00002970}, {482,0.00000000}, {483,0.00000000}, {484,0.00007921}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00007921}, {492,0.00000000}, {493,0.00011881}, {494,0.00003960}, {495,0.00007921}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00003960}, {500,0.00000000}, {505,0.00007921}, {510,0.00007921}, {515,0.00000000}, {520,0.00003960}, {525,0.00003960}, {530,0.00003960}, {535,0.00003960}, {540,0.00000000}, {545,0.00003960}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00003960}, {570,0.00015842}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00003960}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00003960}, {645,0.00000000}, {650,0.00000000}, {655,0.00003960}, {660,0.00018812}, {665,0.00000000}, {670,0.00007921}, {675,0.00000000}, {680,0.00003960}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00007921}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00003960}, {730,0.00003960}, {735,0.00003960}, {740,0.00007921}, {745,0.00000000}, {750,0.00003960}, {755,0.00000000}, {760,0.00003960}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00003960}, {795,0.00000000}, {800,0.00002970}, {805,0.00003960}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00006931}, {830,0.00003960}, {835,0.00000000}, {840,0.00000000}, {845,0.00003960}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00003960}, {870,0.00000000}, {875,0.00002970}, {880,0.00003960}, {885,0.00007921}, {890,0.00003960}, {895,0.00003960}, {900,0.00003960}, {905,0.00000000}, {910,0.00000000}, {915,0.00003960}, {920,0.00000000}, {925,0.00002970}, {930,0.00014851}, {935,0.00000000}, {940,0.00000000}, {945,0.00006931}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00007921}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00003960}, {990,0.00007921}, {995,0.00000000}, {1000,0.00011881}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00011881}, {1050,0.00000000}, {1060,0.00003960}, {1070,0.00003960}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00003960}, {1110,0.00003960}, {1120,0.00011881}, {1130,0.00000000}, {1140,0.00003960}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00003960}, {1180,0.00000000}, {1190,0.00003960}, {1200,0.00000000}, {1210,0.00010891}, {1220,0.00003960}, {1230,0.00000000}, {1240,0.00003960}, {1250,0.00007921}, {1260,0.00003960}, {1270,0.00015842}, {1280,0.00003960}, {1290,0.00000000}, {1300,0.00007921}, {1310,0.00003960}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00007921}, {1370,0.00003960}, {1380,0.00003960}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00003960}, {1420,0.00003960}, {1430,0.00003960}, {1440,0.00007921}, {1450,0.00003960}, {1460,0.00003960}, {1470,0.00003960}, {1480,0.00007921}, {1490,0.00000000}, {1500,0.00003960}, {1510,0.00007921}, {1520,0.00007921}, {1530,0.00007921}, {1540,0.00011881}, {1550,0.00003960}, {1560,0.00007921}, {1570,0.00000000}, {1580,0.00003960}, {1590,0.00000000}, {1600,0.00002970}, {1610,0.00003960}, {1620,0.00002970}, {1630,0.00000000}, {1640,0.00002970}, {1650,0.00007921}, {1660,0.00000000}, {1670,0.00003960}, {1680,0.00006931}, {1690,0.00003960}, {1700,0.00000000}, {1710,0.00007921}, {1720,0.00000000}, {1730,0.00003960}, {1740,0.00007921}, {1750,0.00003960}, {1760,0.00011881}, {1770,0.00003960}, {1780,0.00007921}, {1790,0.00014851}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00003960}, {1840,0.00003960}, {1850,0.00000000}, {1860,0.00003960}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00007921}, {1900,0.00000000}, {1910,0.00007921}, {1920,0.00003960}, {1930,0.00000000}, {1940,0.00003960}, {1950,0.00000000}, {1960,0.00011881}, {1970,0.00007921}, {1980,0.00007921}, {1990,0.00003960}, {2000,0.00007921}, {2050,0.00007921}, {2100,0.00000000}, {2150,0.00003960}, {2200,0.00000000}, {2250,0.00007921}, {2300,0.00007921}, {2350,0.00000000}, {2400,0.00003960}, {2450,0.00022772}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00007921}, {2700,0.00007921}, {2750,0.00000000}, {2800,0.00011881}, {2850,0.00000000}, {2900,0.00011881}, {2950,0.00003960}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00404950}, {3150,0.00027723}, {3200,0.00000000}, {3250,0.00003960}, {3300,0.00003960}, {3350,0.00003960}, {3400,0.00003960}, {3450,0.00015842}, {3500,0.00011881}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00003960}, {3800,0.00011881}, {3850,0.00000000}, {3900,0.00003960}, {3950,0.00003960}, {4000,0.00015842}, {4050,0.00007921}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00007921}, {4350,0.00011881}, {4400,0.00007921}, {4450,0.00003960}, {4500,0.00000000}, {4550,0.00007921}, {4600,0.00007921}, {4650,0.00003960}, {4700,0.00007921}, {4750,0.00007921}, {4800,0.00015842}, {4850,0.00035644}, {4900,0.00003960}, {4950,0.00011881}, {5000,0.00015842}, {5050,0.00035644}, {5100,0.00011881}, {5150,0.00003960}, {5200,0.00055446}, {5250,0.00011881}, {5300,0.00011881}, {5350,0.00010891}, {5400,0.00003960}, {5450,0.00007921}, {5500,0.00007921}, {5550,0.00003960}, {5600,0.00010891}, {5650,0.00000000}, {5700,0.00002970}, {5750,0.00007921}, {5800,0.00003960}, {5850,0.00007921}, {5900,0.00003960}, {5950,0.00003960}, {6000,0.00011881}, {6050,0.0005714}, {6100,0.0064857}, {6150,0.0001143}, {6200,0.0001143}, {6250,0.0050571}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0003429}, {6550,0.0004286}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0002286}, {6750,0.0000000}, {6800,0.0004571}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0003429}, {7000,0.0004571}, {7050,0.0002286}, {7100,0.0000000}, {7150,0.0002286}, {7200,0.0001143}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0003429}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0001143}, {7600,0.0000000}, {7650,0.0002286}, {7700,0.0000000}, {7750,0.0001143}, {7800,0.0001143}, {7850,0.0001143}, {7900,0.0000000}, {7950,0.0001143}, {8000,0.0000000}, {8050,0.0002286}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000857}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0001143}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0002000}, {8550,0.0001143}, {8600,0.0001143}, {8650,0.0000000}, {8700,0.0001143}, {8750,0.0000857}, {8800,0.0001143}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0003429}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0002286}, {9300,0.0001143}, {9350,0.0003429}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0002286}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0002000}, {9750,0.0000000}, {9800,0.0001143}, {9850,0.0000000}, {9900,0.0002000}, {9950,0.0003429}, {10000,0.0003429}, {10100,0.0001143}, {10200,0.0056286}, {10300,0.0001143}, {10400,0.0001143}, {10500,0.0001143}, {10600,0.0002000}, {10700,0.0002286}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0003429}, {11100,0.0000000}, {11200,0.0001143}, {11300,0.0003143}, {11400,0.0002286}, {11500,0.0001143}, {11600,0.0001143}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0001143}, {12100,0.0002286}, {12200,0.0003429}, {12300,0.0001143}, {12400,0.0001143}, {12500,0.0000000}, {12600,0.0001143}, {12700,0.0004571}, {12800,0.0000000}, {12900,0.0012571}, {13000,0.0000000}, {13100,0.0005714}, {13200,0.0002286}, {13300,0.0001143}, {13400,0.0002286}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0001143}, {13800,0.0001143}, {13900,0.0001143}, {14000,0.0007714}, {14100,0.0009143}, {14200,0.0005714}, {14300,0.0004571}, {14400,0.0001143}, {14500,0.0001143}, {14600,0.0003429}, {14700,0.0005714}, {14800,0.0006857}, {14900,0.0004571}, {15000,0.0002286}, {15100,0.0001143}, {15200,0.0006286}, {15300,0.0009143}, {15400,0.0010000}, {15500,0.0006857}, {15600,0.0001143}, {15700,0.0008000}, {15800,0.0013429}, {15900,0.0000857}, {16000,0.0003429}, {16100,0.0003429}, {16200,0.0006857}, {16300,0.0020286}, {16400,0.0002286}, {16500,0.0012571}, {16600,0.0010286}, {16700,0.0010286}, {16800,0.0002286}, {16900,0.0006571}, {17000,0.0008000}, {17100,0.0012571}, {17200,0.0005429}, {17300,0.0006857}, {17400,0.0005714}, {17500,0.0001143}, {17600,0.0014857}, {17700,0.0002286}, {17800,0.0005429}, {17900,0.0004571}, {18000,0.0001143}, {18100,0.0002286}, {18200,0.0012571}, {18300,0.0003429}, {18400,0.0005714}, {18500,0.0002286}, {18600,0.0002286}, {18700,0.0008000}, {18800,0.0006286}, {18900,0.0001143}, {19000,0.0006857}, {19100,0.0004571}, {19200,0.0009143}, {19300,0.0014857}, {19400,0.0007714}, {19500,0.0002286}, {19600,0.0002286}, {19700,0.0029714}, {19800,0.0021714}, {19900,0.0008000}, {20000,0.0029429}};
data["big_flat"]["LtacTacInTermPrimPair"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000990}, {426,0.00000990}, {427,0.00001980}, {428,0.00000000}, {429,0.00000990}, {430,0.00000990}, {431,0.00001980}, {432,0.00001980}, {433,0.00000990}, {434,0.00000000}, {435,0.00000990}, {436,0.00000000}, {437,0.00000000}, {438,0.00001980}, {439,0.00000990}, {440,0.00000000}, {441,0.00001980}, {442,0.00002970}, {443,0.00000000}, {444,0.00000990}, {445,0.00002970}, {446,0.00000990}, {447,0.00003960}, {448,0.00003960}, {449,0.00002970}, {450,0.00002970}, {451,0.00011881}, {452,0.00014851}, {453,0.00011881}, {454,0.00008911}, {455,0.00018812}, {456,0.00014851}, {457,0.00014851}, {458,0.00016832}, {459,0.00016832}, {460,0.00024752}, {461,0.00030693}, {462,0.00041584}, {463,0.00044554}, {464,0.00046535}, {465,0.00057426}, {466,0.00053465}, {467,0.00057426}, {468,0.00158416}, {469,0.00060396}, {470,0.00065347}, {471,0.00068317}, {472,0.00053465}, {473,0.00065347}, {474,0.00073267}, {475,0.00062376}, {476,0.00065347}, {477,0.00065347}, {478,0.00069307}, {479,0.00073267}, {480,0.00074257}, {481,0.00074257}, {482,0.00080198}, {483,0.00076238}, {484,0.00081188}, {485,0.00083168}, {486,0.00083168}, {487,0.00085149}, {488,0.00087129}, {489,0.00096040}, {490,0.00094059}, {491,0.00091089}, {492,0.00095050}, {493,0.00191089}, {494,0.00091089}, {495,0.00092079}, {496,0.00093069}, {497,0.00094059}, {498,0.00096040}, {499,0.00097030}, {500,0.00093069}, {505,0.00099010}, {510,0.00100000}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00100000}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00315842}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00298020}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00100990}, {830,0.00100000}, {835,0.00100000}, {840,0.00100000}, {845,0.00100000}, {850,0.00100000}, {855,0.00100990}, {860,0.00100000}, {865,0.00449505}, {870,0.00102970}, {875,0.00101980}, {880,0.00100990}, {885,0.00104950}, {890,0.00104950}, {895,0.00103960}, {900,0.00103960}, {905,0.00105941}, {910,0.00104950}, {915,0.00102970}, {920,0.00102970}, {925,0.00105941}, {930,0.00109901}, {935,0.00125743}, {940,0.00136634}, {945,0.00155446}, {950,0.00159406}, {955,0.00304950}, {960,0.00162376}, {965,0.00157426}, {970,0.00164356}, {975,0.00163366}, {980,0.00178218}, {985,0.00178218}, {990,0.00187129}, {995,0.00192079}, {1000,0.00193069}, {1010,0.00198020}, {1020,0.00197030}, {1030,0.00198020}, {1040,0.00200000}, {1050,0.00200000}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00200000}, {1090,0.00379208}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200000}, {1140,0.00200000}, {1150,0.00200000}, {1160,0.00200000}, {1170,0.00200000}, {1180,0.00200000}, {1190,0.00200000}, {1200,0.00200000}, {1210,0.00200000}, {1220,0.00200000}, {1230,0.00200000}, {1240,0.00200000}, {1250,0.00426733}, {1260,0.00200000}, {1270,0.00200000}, {1280,0.00200000}, {1290,0.00200000}, {1300,0.00200000}, {1310,0.00200000}, {1320,0.00200000}, {1330,0.00200990}, {1340,0.00200000}, {1350,0.00200990}, {1360,0.00202970}, {1370,0.00204950}, {1380,0.00208911}, {1390,0.00209901}, {1400,0.00208911}, {1410,0.00230693}, {1420,0.00237624}, {1430,0.00241584}, {1440,0.00241584}, {1450,0.00250495}, {1460,0.00257426}, {1470,0.00265347}, {1480,0.00267327}, {1490,0.00280198}, {1500,0.00287129}, {1510,0.00299010}, {1520,0.00299010}, {1530,0.00298020}, {1540,0.00568317}, {1550,0.00300000}, {1560,0.00300000}, {1570,0.00300000}, {1580,0.00300000}, {1590,0.00300000}, {1600,0.00300000}, {1610,0.00300000}, {1620,0.00300000}, {1630,0.00300000}, {1640,0.00300000}, {1650,0.00300000}, {1660,0.00300000}, {1670,0.00300000}, {1680,0.00300000}, {1690,0.00300000}, {1700,0.00300990}, {1710,0.00300000}, {1720,0.00300000}, {1730,0.00300000}, {1740,0.00300000}, {1750,0.00660396}, {1760,0.00300000}, {1770,0.00300000}, {1780,0.00300990}, {1790,0.00300990}, {1800,0.00302970}, {1810,0.00302970}, {1820,0.00304950}, {1830,0.00305941}, {1840,0.00310891}, {1850,0.00317822}, {1860,0.00319802}, {1870,0.00328713}, {1880,0.00343564}, {1890,0.00335644}, {1900,0.00654455}, {1910,0.00347525}, {1920,0.00356436}, {1930,0.00352475}, {1940,0.00360396}, {1950,0.00359406}, {1960,0.00366337}, {1970,0.00376238}, {1980,0.00390099}, {1990,0.00645545}, {2000,0.00399010}, {2050,0.00400000}, {2100,0.00400000}, {2150,0.00400000}, {2200,0.00400990}, {2250,0.00405941}, {2300,0.00418812}, {2350,0.00722772}, {2400,0.00454455}, {2450,0.00489109}, {2500,0.00499010}, {2550,0.00500000}, {2600,0.00997030}, {2650,0.00503960}, {2700,0.00509901}, {2750,0.00519802}, {2800,0.00554455}, {2850,0.00558416}, {2900,0.01264356}, {2950,0.00600000}, {3000,0.00600000}, {3050,0.00601980}, {3100,0.00606931}, {3150,0.00611881}, {3200,0.00628713}, {3250,0.00656436}, {3300,0.00662376}, {3350,0.00677228}, {3400,0.01037624}, {3450,0.00702970}, {3500,0.00704950}, {3550,0.00708911}, {3600,0.00717822}, {3650,0.00736634}, {3700,0.00757426}, {3750,0.00761386}, {3800,0.00769307}, {3850,0.00795050}, {3900,0.00802970}, {3950,0.00804950}, {4000,0.00812871}, {4050,0.00821782}, {4100,0.00840594}, {4150,0.00862376}, {4200,0.00864356}, {4250,0.00872277}, {4300,0.00894059}, {4350,0.00903960}, {4400,0.00909901}, {4450,0.00920792}, {4500,0.00925743}, {4550,0.00956436}, {4600,0.00968317}, {4650,0.01673267}, {4700,0.00976238}, {4750,0.00997030}, {4800,0.01774257}, {4850,0.01723762}, {4900,0.01023762}, {4950,0.01043564}, {5000,0.02122772}, {5050,0.02202970}, {5100,0.01079208}, {5150,0.01088119}, {5200,0.01099010}, {5250,0.02036634}, {5300,0.01123762}, {5350,0.01125743}, {5400,0.02333663}, {5450,0.01172277}, {5500,0.01175248}, {5550,0.01182178}, {5600,0.01186139}, {5650,0.01536634}, {5700,0.01216832}, {5750,0.01220792}, {5800,0.02456436}, {5850,0.02274257}, {5900,0.01274257}, {5950,0.01283168}, {6000,0.01282178}, {6050,0.0140857}, {6100,0.0140857}, {6150,0.0144571}, {6200,0.0271714}, {6250,0.0145429}, {6300,0.0148571}, {6350,0.0147714}, {6400,0.0149714}, {6450,0.0151714}, {6500,0.0152000}, {6550,0.0153714}, {6600,0.0155714}, {6650,0.0157429}, {6700,0.0312286}, {6750,0.0330857}, {6800,0.0161429}, {6850,0.0162571}, {6900,0.0164571}, {6950,0.0166000}, {7000,0.0166571}, {7050,0.0166571}, {7100,0.0244286}, {7150,0.0171143}, {7200,0.0172286}, {7250,0.0173714}, {7300,0.0174571}, {7350,0.0176286}, {7400,0.0239429}, {7450,0.0284857}, {7500,0.0180857}, {7550,0.0182286}, {7600,0.0182000}, {7650,0.0184286}, {7700,0.0185143}, {7750,0.0185714}, {7800,0.0286571}, {7850,0.0246571}, {7900,0.0192000}, {7950,0.0192571}, {8000,0.0193429}, {8050,0.0194571}, {8100,0.0197143}, {8150,0.0329714}, {8200,0.0196857}, {8250,0.0378286}, {8300,0.0200000}, {8350,0.0202000}, {8400,0.0204286}, {8450,0.0204857}, {8500,0.0209143}, {8550,0.0210000}, {8600,0.0386571}, {8650,0.0382000}, {8700,0.0213143}, {8750,0.0215714}, {8800,0.0370571}, {8850,0.0217429}, {8900,0.0303429}, {8950,0.0218286}, {9000,0.0220571}, {9050,0.0223143}, {9100,0.0222857}, {9150,0.0225429}, {9200,0.0301143}, {9250,0.0522286}, {9300,0.0230000}, {9350,0.0551429}, {9400,0.0231429}, {9450,0.0233429}, {9500,0.0429714}, {9550,0.0494571}, {9600,0.0236571}, {9650,0.0383143}, {9700,0.0239429}, {9750,0.0240857}, {9800,0.0441714}, {9850,0.0558286}, {9900,0.0243714}, {9950,0.0247143}, {10000,0.0248000}, {10100,0.0250000}, {10200,0.0505429}, {10300,0.0255429}, {10400,0.0256571}, {10500,0.0486286}, {10600,0.0558000}, {10700,0.0263143}, {10800,0.0267714}, {10900,0.0269143}, {11000,0.0271714}, {11100,0.0528286}, {11200,0.0277429}, {11300,0.0280286}, {11400,0.0510857}, {11500,0.0286286}, {11600,0.0288286}, {11700,0.0290286}, {11800,0.0452000}, {11900,0.0402571}, {12000,0.0298857}, {12100,0.0302286}, {12200,0.0560000}, {12300,0.0590857}, {12400,0.0308571}, {12500,0.0310857}, {12600,0.0445143}, {12700,0.0630571}, {12800,0.0455429}, {12900,0.0321714}, {13000,0.0325429}, {13100,0.0326857}, {13200,0.0329714}, {13300,0.0574571}, {13400,0.0335714}, {13500,0.0338571}, {13600,0.0340286}, {13700,0.0342571}, {13800,0.0346571}, {13900,0.0708857}, {14000,0.0531429}, {14100,0.0356571}, {14200,0.0357143}, {14300,0.0358286}, {14400,0.0363714}, {14500,0.0464000}, {14600,0.0720857}, {14700,0.1305429}, {14800,0.0371429}, {14900,0.0376286}, {15000,0.0377429}, {15100,0.0756571}, {15200,0.0381143}, {15300,0.0387143}, {15400,0.0630286}, {15500,0.0390286}, {15600,0.0692571}, {15700,0.0575429}, {15800,0.0396571}, {15900,0.0757429}, {16000,0.0736857}, {16100,0.0576857}, {16200,0.0407429}, {16300,0.0678286}, {16400,0.0721714}, {16500,0.0417714}, {16600,0.0588571}, {16700,0.0747429}, {16800,0.0740571}, {16900,0.0428000}, {17000,0.0672286}, {17100,0.0555143}, {17200,0.0434571}, {17300,0.0438286}, {17400,0.0840571}, {17500,0.0441714}, {17600,0.0442571}, {17700,0.0652000}, {17800,0.0753429}, {17900,0.0452286}, {18000,0.0695429}, {18100,0.0859143}, {18200,0.0608857}, {18300,0.0934571}, {18400,0.0465429}, {18500,0.0468000}, {18600,0.0470286}, {18700,0.0698571}, {18800,0.0714000}, {18900,0.0483714}, {19000,0.0807143}, {19100,0.0804286}, {19200,0.0856571}, {19300,0.0934000}, {19400,0.0497714}, {19500,0.0613143}, {19600,0.0511429}, {19700,0.0855143}, {19800,0.0503714}, {19900,0.1494857}, {20000,0.0507714}};
data["big_flat"]["LtacTacInTermPrimPair"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003960}, {4,0.00010891}, {5,0.00003960}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00009901}, {11,0.00000000}, {12,0.00007921}, {13,0.00002970}, {14,0.00007921}, {15,0.00006931}, {16,0.00003960}, {17,0.00000000}, {18,0.00000000}, {19,0.00006931}, {20,0.00002970}, {21,0.00014851}, {22,0.00010891}, {23,0.00000000}, {24,0.00005941}, {25,0.00000000}, {26,0.00002970}, {27,0.00005941}, {28,0.00006931}, {29,0.00014851}, {30,0.00003960}, {31,0.00012871}, {32,0.00007921}, {33,0.00009901}, {34,0.00007921}, {35,0.00018812}, {36,0.00020792}, {37,0.00003960}, {38,0.00013861}, {39,0.00006931}, {40,0.00009901}, {41,0.00006931}, {42,0.00005941}, {43,0.00009901}, {44,0.00011881}, {45,0.00021782}, {46,0.00007921}, {47,0.00017822}, {48,0.00016832}, {49,0.00012871}, {50,0.00006931}, {51,0.00015842}, {52,0.00017822}, {53,0.00021782}, {54,0.00013861}, {55,0.00009901}, {56,0.00020792}, {57,0.00026733}, {58,0.00016832}, {59,0.00011881}, {60,0.00017822}, {61,0.00005941}, {62,0.00016832}, {63,0.00008911}, {64,0.00023762}, {65,0.00018812}, {66,0.00017822}, {67,0.00020792}, {68,0.00009901}, {69,0.00008911}, {70,0.00013861}, {71,0.00022772}, {72,0.00009901}, {73,0.00017822}, {74,0.00015842}, {75,0.00017822}, {76,0.00015842}, {77,0.00020792}, {78,0.00017822}, {79,0.00016832}, {80,0.00009901}, {81,0.00020792}, {82,0.00020792}, {83,0.00032673}, {84,0.00019802}, {85,0.00017822}, {86,0.00024752}, {87,0.00011881}, {88,0.00030693}, {89,0.00006931}, {90,0.00021782}, {91,0.00011881}, {92,0.00005941}, {93,0.00008911}, {94,0.00011881}, {95,0.00023762}, {96,0.00011881}, {97,0.00022772}, {98,0.00003960}, {99,0.00009901}, {100,0.00029703}, {101,0.00018812}, {102,0.00029703}, {103,0.00015842}, {104,0.00018812}, {105,0.00030693}, {106,0.00015842}, {107,0.00018812}, {108,0.00018812}, {109,0.00018812}, {110,0.00028713}, {111,0.00030693}, {112,0.00016832}, {113,0.00018812}, {114,0.00017822}, {115,0.00013861}, {116,0.00014851}, {117,0.00030693}, {118,0.00031683}, {119,0.00037624}, {120,0.00033663}, {121,0.00015842}, {122,0.00019802}, {123,0.00013861}, {124,0.00021782}, {125,0.00002970}, {126,0.00017822}, {127,0.00026733}, {128,0.00030693}, {129,0.00016832}, {130,0.00027723}, {131,0.00018812}, {132,0.00020792}, {133,0.00049505}, {134,0.00019802}, {135,0.00005941}, {136,0.00022772}, {137,0.00041584}, {138,0.00030693}, {139,0.00019802}, {140,0.00038614}, {141,0.00011881}, {142,0.00028713}, {143,0.00025743}, {144,0.00040594}, {145,0.00022772}, {146,0.00034653}, {147,0.00036634}, {148,0.00027723}, {149,0.00043564}, {150,0.00052475}, {151,0.00013861}, {152,0.00022772}, {153,0.00023762}, {154,0.00032673}, {155,0.00033663}, {156,0.00056436}, {157,0.00022772}, {158,0.00027723}, {159,0.00028713}, {160,0.00041584}, {161,0.00057426}, {162,0.00018812}, {163,0.00032673}, {164,0.00034653}, {165,0.00058416}, {166,0.00026733}, {167,0.00023762}, {168,0.00017822}, {169,0.00028713}, {170,0.00027723}, {171,0.00017822}, {172,0.00022772}, {173,0.00060396}, {174,0.00019802}, {175,0.00053465}, {176,0.00039604}, {177,0.00028713}, {178,0.00025743}, {179,0.00039604}, {180,0.00022772}, {181,0.00041584}, {182,0.00043564}, {183,0.00030693}, {184,0.00024752}, {185,0.00028713}, {186,0.00039604}, {187,0.00027723}, {188,0.00010891}, {189,0.00038614}, {190,0.00047525}, {191,0.00050495}, {192,0.00036634}, {193,0.00032673}, {194,0.00033663}, {195,0.00030693}, {196,0.00054455}, {197,0.00027723}, {198,0.00018812}, {199,0.00048515}, {200,0.00053465}, {201,0.00056436}, {202,0.00053465}, {203,0.00044554}, {204,0.00076238}, {205,0.00041584}, {206,0.00053465}, {207,0.00020792}, {208,0.00037624}, {209,0.00024752}, {210,0.00043564}, {211,0.00055446}, {212,0.00035644}, {213,0.00066337}, {214,0.00047525}, {215,0.00045545}, {216,0.00023762}, {217,0.00040594}, {218,0.00039604}, {219,0.00041584}, {220,0.00054455}, {221,0.00050495}, {222,0.00035644}, {223,0.00046535}, {224,0.00045545}, {225,0.00057426}, {226,0.00039604}, {227,0.00050495}, {228,0.00046535}, {229,0.00053465}, {230,0.00047525}, {231,0.00039604}, {232,0.00047525}, {233,0.00048515}, {234,0.00039604}, {235,0.00037624}, {236,0.00041584}, {237,0.00041584}, {238,0.00041584}, {239,0.00056436}, {240,0.00043564}, {241,0.00036634}, {242,0.00037624}, {243,0.00044554}, {244,0.00040594}, {245,0.00025743}, {246,0.00047525}, {247,0.00040594}, {248,0.00068317}, {249,0.00023762}, {250,0.00031683}, {251,0.00058416}, {252,0.00016832}, {253,0.00050495}, {254,0.00040594}, {255,0.00036634}, {256,0.00043564}, {257,0.00051485}, {258,0.00049505}, {259,0.00034653}, {260,0.00059406}, {261,0.00056436}, {262,0.00044554}, {263,0.00042574}, {264,0.00059406}, {265,0.00061386}, {266,0.00030693}, {267,0.00048515}, {268,0.00038614}, {269,0.00059406}, {270,0.00034653}, {271,0.00057426}, {272,0.00058416}, {273,0.00034653}, {274,0.00049505}, {275,0.00061386}, {276,0.00060396}, {277,0.00051485}, {278,0.00027723}, {279,0.00057426}, {280,0.00066337}, {281,0.00052475}, {282,0.00066337}, {283,0.00069307}, {284,0.00046535}, {285,0.00038614}, {286,0.00050495}, {287,0.00052475}, {288,0.00048515}, {289,0.00034653}, {290,0.00059406}, {291,0.00051485}, {292,0.00044554}, {293,0.00038614}, {294,0.00053465}, {295,0.00053465}, {296,0.00050495}, {297,0.00053465}, {298,0.00080198}, {299,0.00037624}, {300,0.00046535}, {301,0.00033663}, {302,0.00056436}, {303,0.00044554}, {304,0.00031683}, {305,0.00065347}, {306,0.00062376}, {307,0.00051485}, {308,0.00056436}, {309,0.00050495}, {310,0.00031683}, {311,0.00068317}, {312,0.00022772}, {313,0.00080198}, {314,0.00050495}, {315,0.00050495}, {316,0.00059406}, {317,0.00048515}, {318,0.00033663}, {319,0.00048515}, {320,0.00048515}, {321,0.00049505}, {322,0.00056436}, {323,0.00048515}, {324,0.00045545}, {325,0.00050495}, {326,0.00047525}, {327,0.00056436}, {328,0.00055446}, {329,0.00064356}, {330,0.00055446}, {331,0.00048515}, {332,0.00058416}, {333,0.00048515}, {334,0.00063366}, {335,0.00060396}, {336,0.00058416}, {337,0.00056436}, {338,0.00081188}, {339,0.00063366}, {340,0.00051485}, {341,0.00038614}, {342,0.00043564}, {343,0.00047525}, {344,0.00045545}, {345,0.00064356}, {346,0.00049505}, {347,0.00038614}, {348,0.00057426}, {349,0.00051485}, {350,0.00070297}, {351,0.00055446}, {352,0.00064356}, {353,0.00045545}, {354,0.00095050}, {355,0.00070297}, {356,0.00068317}, {357,0.00056436}, {358,0.00080198}, {359,0.00073267}, {360,0.00071287}, {361,0.00095050}, {362,0.00038614}, {363,0.00073267}, {364,0.00088119}, {365,0.00094059}, {366,0.00102970}, {367,0.00046535}, {368,0.00079208}, {369,0.00070297}, {370,0.00067327}, {371,0.00082178}, {372,0.00074257}, {373,0.00070297}, {374,0.00075248}, {375,0.00073267}, {376,0.00081188}, {377,0.00081188}, {378,0.00090099}, {379,0.00100000}, {380,0.00072277}, {381,0.00110891}, {382,0.00072277}, {383,0.00077228}, {384,0.00086139}, {385,0.00075248}, {386,0.00099010}, {387,0.00079208}, {388,0.00081188}, {389,0.00077228}, {390,0.00071287}, {391,0.00071287}, {392,0.00075248}, {393,0.00060396}, {394,0.00088119}, {395,0.00100000}, {396,0.00093069}, {397,0.00069307}, {398,0.00094059}, {399,0.00073267}, {400,0.00063366}, {401,0.00073267}, {402,0.00087129}, {403,0.00036634}, {404,0.00086139}, {405,0.00069307}, {406,0.00076238}, {407,0.00092079}, {408,0.00093069}, {409,0.00073267}, {410,0.00087129}, {411,0.00075248}, {412,0.00079208}, {413,0.00060396}, {414,0.00105941}, {415,0.00108911}, {416,0.00093069}, {417,0.00088119}, {418,0.00086139}, {419,0.00071287}, {420,0.00059406}, {421,0.00061386}, {422,0.00096040}, {423,0.00075248}, {424,0.00073267}, {425,0.00085149}, {426,0.00084158}, {427,0.00097030}, {428,0.00106931}, {429,0.00087129}, {430,0.00096040}, {431,0.00106931}, {432,0.00068317}, {433,0.00077228}, {434,0.00100000}, {435,0.00082178}, {436,0.00092079}, {437,0.00078218}, {438,0.00087129}, {439,0.00082178}, {440,0.00071287}, {441,0.00084158}, {442,0.00064356}, {443,0.00107921}, {444,0.00075248}, {445,0.00070297}, {446,0.00100990}, {447,0.00087129}, {448,0.00088119}, {449,0.00078218}, {450,0.00103960}, {451,0.00089109}, {452,0.00064356}, {453,0.00136634}, {454,0.00105941}, {455,0.00061386}, {456,0.00097030}, {457,0.00068317}, {458,0.00086139}, {459,0.00094059}, {460,0.00085149}, {461,0.00071287}, {462,0.00078218}, {463,0.00084158}, {464,0.00080198}, {465,0.00117822}, {466,0.00078218}, {467,0.00092079}, {468,0.00183168}, {469,0.00111881}, {470,0.00073267}, {471,0.00050495}, {472,0.00075248}, {473,0.00079208}, {474,0.00082178}, {475,0.00107921}, {476,0.00088119}, {477,0.00092079}, {478,0.00104950}, {479,0.00095050}, {480,0.00082178}, {481,0.00071287}, {482,0.00113861}, {483,0.00095050}, {484,0.00065347}, {485,0.00088119}, {486,0.00086139}, {487,0.00105941}, {488,0.00126733}, {489,0.00127723}, {490,0.00099010}, {491,0.00091089}, {492,0.00104950}, {493,0.00215842}, {494,0.00089109}, {495,0.00115842}, {496,0.00091089}, {497,0.00086139}, {498,0.00093069}, {499,0.00085149}, {500,0.00078218}, {505,0.00068317}, {510,0.00111881}, {515,0.00097030}, {520,0.00102970}, {525,0.00130693}, {530,0.00124752}, {535,0.00105941}, {540,0.00085149}, {545,0.00095050}, {550,0.00111881}, {555,0.00121782}, {560,0.00074257}, {565,0.00063366}, {570,0.00097030}, {575,0.00093069}, {580,0.00065347}, {585,0.00084158}, {590,0.00097030}, {595,0.00112871}, {600,0.00110891}, {605,0.00102970}, {610,0.00133663}, {615,0.00109901}, {620,0.00095050}, {625,0.00121782}, {630,0.00122772}, {635,0.00090099}, {640,0.00129703}, {645,0.00063366}, {650,0.00128713}, {655,0.00113861}, {660,0.00124752}, {665,0.00120792}, {670,0.00302970}, {675,0.00141584}, {680,0.00125743}, {685,0.00108911}, {690,0.00141584}, {695,0.00270297}, {700,0.00121782}, {705,0.00117822}, {710,0.00153465}, {715,0.00133663}, {720,0.00147525}, {725,0.00111881}, {730,0.00124752}, {735,0.00121782}, {740,0.00122772}, {745,0.00146535}, {750,0.00154455}, {755,0.00145545}, {760,0.00157426}, {765,0.00122772}, {770,0.00142574}, {775,0.00125743}, {780,0.00153465}, {785,0.00148515}, {790,0.00135644}, {795,0.00144554}, {800,0.00142574}, {805,0.00131683}, {810,0.00133663}, {815,0.00143564}, {820,0.00153465}, {825,0.00155446}, {830,0.00177228}, {835,0.00141584}, {840,0.00124752}, {845,0.00132673}, {850,0.00130693}, {855,0.00178218}, {860,0.00176238}, {865,0.00411881}, {870,0.00162376}, {875,0.00134653}, {880,0.00173267}, {885,0.00142574}, {890,0.00141584}, {895,0.00152475}, {900,0.00149505}, {905,0.00151485}, {910,0.00138614}, {915,0.00173267}, {920,0.00165347}, {925,0.00134653}, {930,0.00180198}, {935,0.00143564}, {940,0.00146535}, {945,0.00198020}, {950,0.00156436}, {955,0.00312871}, {960,0.00188119}, {965,0.00165347}, {970,0.00165347}, {975,0.00191089}, {980,0.00199010}, {985,0.00180198}, {990,0.00184158}, {995,0.00139604}, {1000,0.00166337}, {1010,0.00149505}, {1020,0.00177228}, {1030,0.00166337}, {1040,0.00168317}, {1050,0.00189109}, {1060,0.00177228}, {1070,0.00192079}, {1080,0.00217822}, {1090,0.00353465}, {1100,0.00170297}, {1110,0.00215842}, {1120,0.00190099}, {1130,0.00182178}, {1140,0.00222772}, {1150,0.00203960}, {1160,0.00169307}, {1170,0.00188119}, {1180,0.00226733}, {1190,0.00219802}, {1200,0.00201980}, {1210,0.00209901}, {1220,0.00202970}, {1230,0.00191089}, {1240,0.00203960}, {1250,0.00428713}, {1260,0.00210891}, {1270,0.00228713}, {1280,0.00221782}, {1290,0.00229703}, {1300,0.00194059}, {1310,0.00235644}, {1320,0.00217822}, {1330,0.00227723}, {1340,0.00183168}, {1350,0.00232673}, {1360,0.00222772}, {1370,0.00274257}, {1380,0.00224752}, {1390,0.00252475}, {1400,0.00232673}, {1410,0.00232673}, {1420,0.00236634}, {1430,0.00249505}, {1440,0.00238614}, {1450,0.00257426}, {1460,0.00260396}, {1470,0.00253465}, {1480,0.00253465}, {1490,0.00280198}, {1500,0.00286139}, {1510,0.00265347}, {1520,0.00300990}, {1530,0.00290099}, {1540,0.00582178}, {1550,0.00297030}, {1560,0.00287129}, {1570,0.00274257}, {1580,0.00296040}, {1590,0.00275248}, {1600,0.00304950}, {1610,0.00299010}, {1620,0.00317822}, {1630,0.00295050}, {1640,0.00326733}, {1650,0.00300000}, {1660,0.00300000}, {1670,0.00324752}, {1680,0.00317822}, {1690,0.00343564}, {1700,0.00327723}, {1710,0.00326733}, {1720,0.00324752}, {1730,0.00326733}, {1740,0.00334653}, {1750,0.00659406}, {1760,0.00317822}, {1770,0.00318812}, {1780,0.00351485}, {1790,0.00335644}, {1800,0.00348515}, {1810,0.00331683}, {1820,0.00339604}, {1830,0.00350495}, {1840,0.00356436}, {1850,0.00349505}, {1860,0.00345545}, {1870,0.00355446}, {1880,0.00368317}, {1890,0.00364356}, {1900,0.00650495}, {1910,0.00372277}, {1920,0.00359406}, {1930,0.00369307}, {1940,0.00359406}, {1950,0.00365347}, {1960,0.00370297}, {1970,0.00369307}, {1980,0.00395050}, {1990,0.00637624}, {2000,0.00396040}, {2050,0.00399010}, {2100,0.00386139}, {2150,0.00403960}, {2200,0.00443564}, {2250,0.00440594}, {2300,0.00458416}, {2350,0.00700990}, {2400,0.00428713}, {2450,0.00458416}, {2500,0.00465347}, {2550,0.00488119}, {2600,0.01032673}, {2650,0.00515842}, {2700,0.00536634}, {2750,0.00490099}, {2800,0.00572277}, {2850,0.00523762}, {2900,0.01272277}, {2950,0.00596040}, {3000,0.00565347}, {3050,0.00590099}, {3100,0.00628713}, {3150,0.00618812}, {3200,0.00639604}, {3250,0.00634653}, {3300,0.00660396}, {3350,0.00658416}, {3400,0.01071287}, {3450,0.00687129}, {3500,0.00685149}, {3550,0.00686139}, {3600,0.00714851}, {3650,0.00731683}, {3700,0.00740594}, {3750,0.00746535}, {3800,0.00758416}, {3850,0.00753465}, {3900,0.00819802}, {3950,0.00792079}, {4000,0.00825743}, {4050,0.00858416}, {4100,0.00850495}, {4150,0.00844554}, {4200,0.00861386}, {4250,0.00875248}, {4300,0.00892079}, {4350,0.00927723}, {4400,0.00930693}, {4450,0.00917822}, {4500,0.00992079}, {4550,0.00945545}, {4600,0.00970297}, {4650,0.01669307}, {4700,0.01006931}, {4750,0.01034653}, {4800,0.01768317}, {4850,0.01701980}, {4900,0.01038614}, {4950,0.01019802}, {5000,0.02074257}, {5050,0.02196040}, {5100,0.01085149}, {5150,0.01072277}, {5200,0.01098020}, {5250,0.02035644}, {5300,0.01123762}, {5350,0.01130693}, {5400,0.02355446}, {5450,0.01164356}, {5500,0.01172277}, {5550,0.01177228}, {5600,0.01168317}, {5650,0.01509901}, {5700,0.01219802}, {5750,0.01245545}, {5800,0.02496040}, {5850,0.02315842}, {5900,0.01274257}, {5950,0.01261386}, {6000,0.01260396}, {6050,0.0141714}, {6100,0.0142571}, {6150,0.0141143}, {6200,0.0272857}, {6250,0.0143143}, {6300,0.0146000}, {6350,0.0146000}, {6400,0.0150286}, {6450,0.0154857}, {6500,0.0153429}, {6550,0.0153429}, {6600,0.0156000}, {6650,0.0160571}, {6700,0.0310000}, {6750,0.0334571}, {6800,0.0155714}, {6850,0.0158571}, {6900,0.0160571}, {6950,0.0163714}, {7000,0.0164000}, {7050,0.0166857}, {7100,0.0249143}, {7150,0.0166000}, {7200,0.0173714}, {7250,0.0172286}, {7300,0.0170571}, {7350,0.0176857}, {7400,0.0240857}, {7450,0.0282571}, {7500,0.0183143}, {7550,0.0186000}, {7600,0.0177429}, {7650,0.0178857}, {7700,0.0184857}, {7750,0.0186000}, {7800,0.0286286}, {7850,0.0250000}, {7900,0.0193714}, {7950,0.0193714}, {8000,0.0190857}, {8050,0.0196000}, {8100,0.0196571}, {8150,0.0327714}, {8200,0.0192571}, {8250,0.0384857}, {8300,0.0195429}, {8350,0.0202571}, {8400,0.0203429}, {8450,0.0204286}, {8500,0.0214000}, {8550,0.0210857}, {8600,0.0384857}, {8650,0.0383714}, {8700,0.0219429}, {8750,0.0212571}, {8800,0.0377429}, {8850,0.0215429}, {8900,0.0302000}, {8950,0.0222286}, {9000,0.0234857}, {9050,0.0230571}, {9100,0.0229143}, {9150,0.0234571}, {9200,0.0304286}, {9250,0.0523429}, {9300,0.0232857}, {9350,0.0551143}, {9400,0.0234286}, {9450,0.0238000}, {9500,0.0431429}, {9550,0.0495714}, {9600,0.0241429}, {9650,0.0378571}, {9700,0.0240857}, {9750,0.0244286}, {9800,0.0442286}, {9850,0.0553714}, {9900,0.0251429}, {9950,0.0254571}, {10000,0.0254000}, {10100,0.0252857}, {10200,0.0511143}, {10300,0.0259429}, {10400,0.0258571}, {10500,0.0491143}, {10600,0.0558286}, {10700,0.0266000}, {10800,0.0269143}, {10900,0.0266571}, {11000,0.0275143}, {11100,0.0524286}, {11200,0.0282000}, {11300,0.0283429}, {11400,0.0512286}, {11500,0.0286000}, {11600,0.0290000}, {11700,0.0292000}, {11800,0.0451429}, {11900,0.0404000}, {12000,0.0300286}, {12100,0.0306000}, {12200,0.0559429}, {12300,0.0588857}, {12400,0.0311714}, {12500,0.0313714}, {12600,0.0445143}, {12700,0.0623714}, {12800,0.0452857}, {12900,0.0320571}, {13000,0.0326286}, {13100,0.0333714}, {13200,0.0333143}, {13300,0.0573429}, {13400,0.0337714}, {13500,0.0332857}, {13600,0.0338000}, {13700,0.0337714}, {13800,0.0356286}, {13900,0.0707429}, {14000,0.0532571}, {14100,0.0360000}, {14200,0.0359143}, {14300,0.0360857}, {14400,0.0366857}, {14500,0.0464286}, {14600,0.0719143}, {14700,0.1303143}, {14800,0.0372286}, {14900,0.0374000}, {15000,0.0376571}, {15100,0.0753143}, {15200,0.0382857}, {15300,0.0381714}, {15400,0.0633143}, {15500,0.0383714}, {15600,0.0687429}, {15700,0.0570857}, {15800,0.0387714}, {15900,0.0755143}, {16000,0.0735143}, {16100,0.0568857}, {16200,0.0404000}, {16300,0.0669429}, {16400,0.0720571}, {16500,0.0416571}, {16600,0.0586571}, {16700,0.0742286}, {16800,0.0743714}, {16900,0.0427714}, {17000,0.0673714}, {17100,0.0554857}, {17200,0.0438286}, {17300,0.0437143}, {17400,0.0840286}, {17500,0.0448286}, {17600,0.0445143}, {17700,0.0651429}, {17800,0.0750000}, {17900,0.0454000}, {18000,0.0688286}, {18100,0.0852571}, {18200,0.0606857}, {18300,0.0933143}, {18400,0.0467143}, {18500,0.0464857}, {18600,0.0466571}, {18700,0.0704571}, {18800,0.0703714}, {18900,0.0488857}, {19000,0.0806571}, {19100,0.0803143}, {19200,0.0856286}, {19300,0.0941143}, {19400,0.0494857}, {19500,0.0612286}, {19600,0.0496857}, {19700,0.0857143}, {19800,0.0511143}, {19900,0.1494857}, {20000,0.0507143}};
data["big_flat"]["LtacTacInTermPrimPair"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00003960}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00002970}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00003960}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00003960}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00003960}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00006931}, {131,0.00000000}, {132,0.00000000}, {133,0.00003960}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00003960}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00003960}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00003960}, {208,0.00000000}, {209,0.00000000}, {210,0.00003960}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00007921}, {220,0.00003960}, {221,0.00000000}, {222,0.00000000}, {223,0.00003960}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00003960}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00003960}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00003960}, {264,0.00002970}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00003960}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00003960}, {279,0.00003960}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00003960}, {285,0.00000000}, {286,0.00000000}, {287,0.00003960}, {288,0.00000000}, {289,0.00000000}, {290,0.00003960}, {291,0.00000000}, {292,0.00000000}, {293,0.00007921}, {294,0.00000000}, {295,0.00000000}, {296,0.00003960}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00003960}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00003960}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00003960}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00002970}, {333,0.00002970}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00003960}, {338,0.00003960}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00003960}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00003960}, {378,0.00000000}, {379,0.00000000}, {380,0.00003960}, {381,0.00003960}, {382,0.00000000}, {383,0.00003960}, {384,0.00003960}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00003960}, {391,0.00006931}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00003960}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00002970}, {419,0.00003960}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00003960}, {433,0.00003960}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00003960}, {464,0.00000000}, {465,0.00003960}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00003960}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00003960}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00003960}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00011881}, {715,0.00000000}, {720,0.00003960}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00003960}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00003960}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00003960}, {880,0.00000000}, {885,0.00003960}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00003960}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00003960}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00003960}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00003960}, {1090,0.00003960}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00003960}, {1270,0.00000000}, {1280,0.00003960}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00003960}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00003960}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00003960}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00003960}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00003960}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00003960}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00003960}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00002970}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00003960}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00003960}, {3250,0.00003960}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00003960}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00007921}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0001143}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0001143}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0001143}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0001143}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0001143}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0001143}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0001143}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0001143}, {16400,0.0001143}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0002286}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0002286}, {19800,0.0000000}, {19900,0.0002286}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermPrimPair"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00163366}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00200990}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000990}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00001980}, {1390,0.00000000}, {1400,0.00000990}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00001980}, {1440,0.00000000}, {1450,0.00000990}, {1460,0.00011881}, {1470,0.00003960}, {1480,0.00000000}, {1490,0.00046535}, {1500,0.00037624}, {1510,0.00045545}, {1520,0.00047525}, {1530,0.00000990}, {1540,0.00000990}, {1550,0.00046535}, {1560,0.00005941}, {1570,0.00051485}, {1580,0.00010891}, {1590,0.00001980}, {1600,0.00095050}, {1610,0.00087129}, {1620,0.00099010}, {1630,0.00002970}, {1640,0.00041584}, {1650,0.00097030}, {1660,0.00041584}, {1670,0.00100000}, {1680,0.00058416}, {1690,0.00047525}, {1700,0.00100000}, {1710,0.00100000}, {1720,0.00100000}, {1730,0.00065347}, {1740,0.00100000}, {1750,0.00100000}, {1760,0.00100000}, {1770,0.00100000}, {1780,0.00100000}, {1790,0.00100000}, {1800,0.00100000}, {1810,0.00100000}, {1820,0.00100000}, {1830,0.00100000}, {1840,0.00100000}, {1850,0.00100000}, {1860,0.00100000}, {1870,0.00100000}, {1880,0.00100000}, {1890,0.00100000}, {1900,0.00100000}, {1910,0.00100000}, {1920,0.00100000}, {1930,0.00100000}, {1940,0.00100000}, {1950,0.00100000}, {1960,0.00100000}, {1970,0.00100000}, {1980,0.00100000}, {1990,0.00100000}, {2000,0.00100000}, {2050,0.00100000}, {2100,0.00100000}, {2150,0.00100000}, {2200,0.00100000}, {2250,0.00100000}, {2300,0.00100000}, {2350,0.00100000}, {2400,0.00100000}, {2450,0.00100000}, {2500,0.00100000}, {2550,0.00100000}, {2600,0.00404950}, {2650,0.00100000}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00100000}, {3150,0.00101980}, {3200,0.00120792}, {3250,0.00155446}, {3300,0.00150495}, {3350,0.00155446}, {3400,0.00156436}, {3450,0.00161386}, {3500,0.00162376}, {3550,0.00198020}, {3600,0.00200000}, {3650,0.00200000}, {3700,0.00200000}, {3750,0.00200000}, {3800,0.00200000}, {3850,0.00200000}, {3900,0.00200000}, {3950,0.00200000}, {4000,0.00200000}, {4050,0.00200000}, {4100,0.00200000}, {4150,0.00200000}, {4200,0.00200000}, {4250,0.00200000}, {4300,0.00202970}, {4350,0.00202970}, {4400,0.00203960}, {4450,0.00205941}, {4500,0.00204950}, {4550,0.00203960}, {4600,0.00489109}, {4650,0.00206931}, {4700,0.00213861}, {4750,0.00219802}, {4800,0.00211881}, {4850,0.00214851}, {4900,0.00498020}, {4950,0.00217822}, {5000,0.00266337}, {5050,0.00276238}, {5100,0.00275248}, {5150,0.00272277}, {5200,0.00274257}, {5250,0.00279208}, {5300,0.00300000}, {5350,0.00303960}, {5400,0.00302970}, {5450,0.00302970}, {5500,0.00303960}, {5550,0.00303960}, {5600,0.00306931}, {5650,0.00307921}, {5700,0.00304950}, {5750,0.00307921}, {5800,0.00311881}, {5850,0.00308911}, {5900,0.00309901}, {5950,0.00313861}, {6000,0.00314851}, {6050,0.0042857}, {6100,0.0042857}, {6150,0.0043714}, {6200,0.0045143}, {6250,0.0045143}, {6300,0.0044857}, {6350,0.0044857}, {6400,0.0048286}, {6450,0.0047143}, {6500,0.0048000}, {6550,0.0189429}, {6600,0.0047143}, {6650,0.0049143}, {6700,0.0048857}, {6750,0.0049714}, {6800,0.0051143}, {6850,0.0052000}, {6900,0.0053714}, {6950,0.0054286}, {7000,0.0052571}, {7050,0.0051714}, {7100,0.0056857}, {7150,0.0054571}, {7200,0.0058286}, {7250,0.0057714}, {7300,0.0058571}, {7350,0.0058857}, {7400,0.0059143}, {7450,0.0059143}, {7500,0.0058286}, {7550,0.0060857}, {7600,0.0094000}, {7650,0.0060857}, {7700,0.0063714}, {7750,0.0064000}, {7800,0.0062571}, {7850,0.0062857}, {7900,0.0065143}, {7950,0.0065429}, {8000,0.0066571}, {8050,0.0064857}, {8100,0.0064571}, {8150,0.0067143}, {8200,0.0068571}, {8250,0.0068571}, {8300,0.0066857}, {8350,0.0066857}, {8400,0.0071143}, {8450,0.0072000}, {8500,0.0073429}, {8550,0.0075143}, {8600,0.0074286}, {8650,0.0076571}, {8700,0.0117143}, {8750,0.0076000}, {8800,0.0078000}, {8850,0.0076571}, {8900,0.0077143}, {8950,0.0125714}, {9000,0.0078000}, {9050,0.0078571}, {9100,0.0078286}, {9150,0.0078571}, {9200,0.0078857}, {9250,0.0080857}, {9300,0.0081143}, {9350,0.0081429}, {9400,0.0084286}, {9450,0.0178000}, {9500,0.0083143}, {9550,0.0087143}, {9600,0.0071429}, {9650,0.0182857}, {9700,0.0088286}, {9750,0.0089143}, {9800,0.0088000}, {9850,0.0088286}, {9900,0.0089143}, {9950,0.0088857}, {10000,0.0088857}, {10100,0.0089143}, {10200,0.0090000}, {10300,0.0090000}, {10400,0.0090286}, {10500,0.0090000}, {10600,0.0092571}, {10700,0.0097143}, {10800,0.0257143}, {10900,0.0096857}, {11000,0.0097714}, {11100,0.0097714}, {11200,0.0097714}, {11300,0.0098286}, {11400,0.0099429}, {11500,0.0193143}, {11600,0.0100571}, {11700,0.0105143}, {11800,0.0087714}, {11900,0.0107143}, {12000,0.0097714}, {12100,0.0107429}, {12200,0.0108000}, {12300,0.0358000}, {12400,0.0108857}, {12500,0.0152571}, {12600,0.0108000}, {12700,0.0111714}, {12800,0.0114286}, {12900,0.0112857}, {13000,0.0115429}, {13100,0.0117714}, {13200,0.0115429}, {13300,0.0117143}, {13400,0.0108286}, {13500,0.0118000}, {13600,0.0119143}, {13700,0.0120286}, {13800,0.0106000}, {13900,0.0123714}, {14000,0.0125143}, {14100,0.0110000}, {14200,0.0126571}, {14300,0.0126857}, {14400,0.0128571}, {14500,0.0128000}, {14600,0.0128286}, {14700,0.0129143}, {14800,0.0128857}, {14900,0.0130286}, {15000,0.0133429}, {15100,0.0133429}, {15200,0.0352286}, {15300,0.0133714}, {15400,0.0133714}, {15500,0.0134857}, {15600,0.0286857}, {15700,0.0137143}, {15800,0.0120286}, {15900,0.0138857}, {16000,0.0142857}, {16100,0.0123429}, {16200,0.0142286}, {16300,0.0142286}, {16400,0.0142857}, {16500,0.0143714}, {16600,0.0143429}, {16700,0.0145429}, {16800,0.0146286}, {16900,0.0146286}, {17000,0.0148000}, {17100,0.0151429}, {17200,0.0453429}, {17300,0.0152571}, {17400,0.0486286}, {17500,0.0152857}, {17600,0.0153143}, {17700,0.0154000}, {17800,0.0153143}, {17900,0.0154000}, {18000,0.0157429}, {18100,0.0405143}, {18200,0.0159429}, {18300,0.0161714}, {18400,0.0155714}, {18500,0.0163429}, {18600,0.0142857}, {18700,0.0142571}, {18800,0.0163429}, {18900,0.0164286}, {19000,0.0165143}, {19100,0.0168000}, {19200,0.0172000}, {19300,0.0171429}, {19400,0.0172571}, {19500,0.0173429}, {19600,0.0173429}, {19700,0.0173429}, {19800,0.0238000}, {19900,0.0368286}, {20000,0.0173429}};
data["big_flat"]["LtacTacInTermPrimPair"]["eval lazy"]["user"] = {{1,0.00003960}, {2,0.00000000}, {3,0.00002970}, {4,0.00002970}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00008911}, {9,0.00003960}, {10,0.00000000}, {11,0.00000000}, {12,0.00002970}, {13,0.00002970}, {14,0.00005941}, {15,0.00000000}, {16,0.00002970}, {17,0.00006931}, {18,0.00003960}, {19,0.00002970}, {20,0.00003960}, {21,0.00006931}, {22,0.00000000}, {23,0.00006931}, {24,0.00000000}, {25,0.00010891}, {26,0.00005941}, {27,0.00006931}, {28,0.00002970}, {29,0.00003960}, {30,0.00000000}, {31,0.00002970}, {32,0.00000000}, {33,0.00003960}, {34,0.00006931}, {35,0.00005941}, {36,0.00010891}, {37,0.00002970}, {38,0.00007921}, {39,0.00011881}, {40,0.00000000}, {41,0.00002970}, {42,0.00006931}, {43,0.00009901}, {44,0.00002970}, {45,0.00006931}, {46,0.00000000}, {47,0.00003960}, {48,0.00000000}, {49,0.00002970}, {50,0.00002970}, {51,0.00008911}, {52,0.00007921}, {53,0.00012871}, {54,0.00000000}, {55,0.00003960}, {56,0.00003960}, {57,0.00013861}, {58,0.00020792}, {59,0.00000000}, {60,0.00000000}, {61,0.00002970}, {62,0.00006931}, {63,0.00013861}, {64,0.00005941}, {65,0.00009901}, {66,0.00010891}, {67,0.00002970}, {68,0.00005941}, {69,0.00012871}, {70,0.00005941}, {71,0.00009901}, {72,0.00006931}, {73,0.00009901}, {74,0.00003960}, {75,0.00000000}, {76,0.00003960}, {77,0.00002970}, {78,0.00007921}, {79,0.00016832}, {80,0.00012871}, {81,0.00005941}, {82,0.00008911}, {83,0.00002970}, {84,0.00002970}, {85,0.00000000}, {86,0.00005941}, {87,0.00020792}, {88,0.00008911}, {89,0.00013861}, {90,0.00012871}, {91,0.00005941}, {92,0.00005941}, {93,0.00002970}, {94,0.00002970}, {95,0.00022772}, {96,0.00002970}, {97,0.00008911}, {98,0.00009901}, {99,0.00005941}, {100,0.00015842}, {101,0.00007921}, {102,0.00012871}, {103,0.00000000}, {104,0.00016832}, {105,0.00016832}, {106,0.00015842}, {107,0.00000000}, {108,0.00008911}, {109,0.00020792}, {110,0.00005941}, {111,0.00005941}, {112,0.00016832}, {113,0.00010891}, {114,0.00003960}, {115,0.00012871}, {116,0.00011881}, {117,0.00012871}, {118,0.00009901}, {119,0.00002970}, {120,0.00017822}, {121,0.00015842}, {122,0.00008911}, {123,0.00006931}, {124,0.00005941}, {125,0.00019802}, {126,0.00009901}, {127,0.00000000}, {128,0.00006931}, {129,0.00008911}, {130,0.00009901}, {131,0.00005941}, {132,0.00005941}, {133,0.00011881}, {134,0.00015842}, {135,0.00005941}, {136,0.00009901}, {137,0.00006931}, {138,0.00003960}, {139,0.00006931}, {140,0.00012871}, {141,0.00009901}, {142,0.00025743}, {143,0.00019802}, {144,0.00020792}, {145,0.00006931}, {146,0.00006931}, {147,0.00011881}, {148,0.00011881}, {149,0.00006931}, {150,0.00009901}, {151,0.00015842}, {152,0.00009901}, {153,0.00013861}, {154,0.00025743}, {155,0.00006931}, {156,0.00017822}, {157,0.00011881}, {158,0.00013861}, {159,0.00011881}, {160,0.00017822}, {161,0.00019802}, {162,0.00009901}, {163,0.00010891}, {164,0.00007921}, {165,0.00006931}, {166,0.00011881}, {167,0.00014851}, {168,0.00007921}, {169,0.00007921}, {170,0.00022772}, {171,0.00022772}, {172,0.00006931}, {173,0.00002970}, {174,0.00024752}, {175,0.00018812}, {176,0.00017822}, {177,0.00009901}, {178,0.00017822}, {179,0.00017822}, {180,0.00022772}, {181,0.00009901}, {182,0.00034653}, {183,0.00018812}, {184,0.00017822}, {185,0.00019802}, {186,0.00006931}, {187,0.00012871}, {188,0.00014851}, {189,0.00014851}, {190,0.00009901}, {191,0.00013861}, {192,0.00014851}, {193,0.00018812}, {194,0.00009901}, {195,0.00010891}, {196,0.00014851}, {197,0.00028713}, {198,0.00006931}, {199,0.00018812}, {200,0.00030693}, {201,0.00009901}, {202,0.00010891}, {203,0.00011881}, {204,0.00022772}, {205,0.00003960}, {206,0.00003960}, {207,0.00029703}, {208,0.00021782}, {209,0.00021782}, {210,0.00014851}, {211,0.00010891}, {212,0.00025743}, {213,0.00009901}, {214,0.00011881}, {215,0.00023762}, {216,0.00021782}, {217,0.00017822}, {218,0.00014851}, {219,0.00016832}, {220,0.00023762}, {221,0.00023762}, {222,0.00033663}, {223,0.00025743}, {224,0.00022772}, {225,0.00008911}, {226,0.00010891}, {227,0.00014851}, {228,0.00028713}, {229,0.00024752}, {230,0.00009901}, {231,0.00019802}, {232,0.00026733}, {233,0.00016832}, {234,0.00007921}, {235,0.00024752}, {236,0.00002970}, {237,0.00036634}, {238,0.00041584}, {239,0.00029703}, {240,0.00006931}, {241,0.00011881}, {242,0.00023762}, {243,0.00019802}, {244,0.00013861}, {245,0.00022772}, {246,0.00019802}, {247,0.00023762}, {248,0.00006931}, {249,0.00010891}, {250,0.00012871}, {251,0.00008911}, {252,0.00008911}, {253,0.00017822}, {254,0.00009901}, {255,0.00025743}, {256,0.00023762}, {257,0.00024752}, {258,0.00012871}, {259,0.00022772}, {260,0.00028713}, {261,0.00016832}, {262,0.00012871}, {263,0.00018812}, {264,0.00025743}, {265,0.00010891}, {266,0.00030693}, {267,0.00018812}, {268,0.00014851}, {269,0.00009901}, {270,0.00028713}, {271,0.00016832}, {272,0.00012871}, {273,0.00006931}, {274,0.00018812}, {275,0.00012871}, {276,0.00005941}, {277,0.00021782}, {278,0.00026733}, {279,0.00021782}, {280,0.00008911}, {281,0.00023762}, {282,0.00023762}, {283,0.00019802}, {284,0.00023762}, {285,0.00021782}, {286,0.00009901}, {287,0.00011881}, {288,0.00018812}, {289,0.00019802}, {290,0.00025743}, {291,0.00022772}, {292,0.00022772}, {293,0.00021782}, {294,0.00019802}, {295,0.00033663}, {296,0.00023762}, {297,0.00032673}, {298,0.00018812}, {299,0.00025743}, {300,0.00026733}, {301,0.00018812}, {302,0.00027723}, {303,0.00032673}, {304,0.00018812}, {305,0.00011881}, {306,0.00012871}, {307,0.00029703}, {308,0.00008911}, {309,0.00010891}, {310,0.00020792}, {311,0.00023762}, {312,0.00018812}, {313,0.00012871}, {314,0.00146535}, {315,0.00028713}, {316,0.00012871}, {317,0.00013861}, {318,0.00039604}, {319,0.00014851}, {320,0.00016832}, {321,0.00029703}, {322,0.00015842}, {323,0.00003960}, {324,0.00012871}, {325,0.00017822}, {326,0.00013861}, {327,0.00028713}, {328,0.00014851}, {329,0.00023762}, {330,0.00027723}, {331,0.00027723}, {332,0.00019802}, {333,0.00015842}, {334,0.00021782}, {335,0.00027723}, {336,0.00016832}, {337,0.00023762}, {338,0.00028713}, {339,0.00019802}, {340,0.00026733}, {341,0.00018812}, {342,0.00027723}, {343,0.00040594}, {344,0.00040594}, {345,0.00025743}, {346,0.00006931}, {347,0.00028713}, {348,0.00014851}, {349,0.00025743}, {350,0.00030693}, {351,0.00023762}, {352,0.00027723}, {353,0.00030693}, {354,0.00034653}, {355,0.00033663}, {356,0.00027723}, {357,0.00018812}, {358,0.00022772}, {359,0.00033663}, {360,0.00027723}, {361,0.00028713}, {362,0.00029703}, {363,0.00018812}, {364,0.00018812}, {365,0.00040594}, {366,0.00030693}, {367,0.00017822}, {368,0.00027723}, {369,0.00015842}, {370,0.00026733}, {371,0.00029703}, {372,0.00031683}, {373,0.00034653}, {374,0.00022772}, {375,0.00032673}, {376,0.00025743}, {377,0.00023762}, {378,0.00015842}, {379,0.00027723}, {380,0.00035644}, {381,0.00015842}, {382,0.00035644}, {383,0.00035644}, {384,0.00014851}, {385,0.00022772}, {386,0.00058416}, {387,0.00027723}, {388,0.00048515}, {389,0.00031683}, {390,0.00038614}, {391,0.00021782}, {392,0.00028713}, {393,0.00029703}, {394,0.00029703}, {395,0.00029703}, {396,0.00024752}, {397,0.00033663}, {398,0.00033663}, {399,0.00031683}, {400,0.00013861}, {401,0.00042574}, {402,0.00034653}, {403,0.00035644}, {404,0.00047525}, {405,0.00035644}, {406,0.00041584}, {407,0.00037624}, {408,0.00023762}, {409,0.00022772}, {410,0.00024752}, {411,0.00025743}, {412,0.00043564}, {413,0.00037624}, {414,0.00052475}, {415,0.00034653}, {416,0.00247525}, {417,0.00017822}, {418,0.00026733}, {419,0.00048515}, {420,0.00028713}, {421,0.00027723}, {422,0.00027723}, {423,0.00023762}, {424,0.00042574}, {425,0.00024752}, {426,0.00020792}, {427,0.00034653}, {428,0.00018812}, {429,0.00021782}, {430,0.00033663}, {431,0.00037624}, {432,0.00043564}, {433,0.00025743}, {434,0.00029703}, {435,0.00033663}, {436,0.00028713}, {437,0.00048515}, {438,0.00024752}, {439,0.00033663}, {440,0.00031683}, {441,0.00032673}, {442,0.00031683}, {443,0.00026733}, {444,0.00026733}, {445,0.00041584}, {446,0.00041584}, {447,0.00020792}, {448,0.00030693}, {449,0.00044554}, {450,0.00021782}, {451,0.00040594}, {452,0.00046535}, {453,0.00035644}, {454,0.00027723}, {455,0.00032673}, {456,0.00044554}, {457,0.00028713}, {458,0.00045545}, {459,0.00033663}, {460,0.00032673}, {461,0.00050495}, {462,0.00019802}, {463,0.00020792}, {464,0.00028713}, {465,0.00045545}, {466,0.00045545}, {467,0.00019802}, {468,0.00039604}, {469,0.00023762}, {470,0.00018812}, {471,0.00066337}, {472,0.00026733}, {473,0.00023762}, {474,0.00023762}, {475,0.00033663}, {476,0.00049505}, {477,0.00010891}, {478,0.00034653}, {479,0.00037624}, {480,0.00036634}, {481,0.00028713}, {482,0.00021782}, {483,0.00042574}, {484,0.00050495}, {485,0.00028713}, {486,0.00023762}, {487,0.00042574}, {488,0.00015842}, {489,0.00022772}, {490,0.00041584}, {491,0.00023762}, {492,0.00054455}, {493,0.00062376}, {494,0.00022772}, {495,0.00030693}, {496,0.00049505}, {497,0.00052475}, {498,0.00032673}, {499,0.00033663}, {500,0.00032673}, {505,0.00025743}, {510,0.00026733}, {515,0.00051485}, {520,0.00048515}, {525,0.00031683}, {530,0.00049505}, {535,0.00051485}, {540,0.00018812}, {545,0.00046535}, {550,0.00023762}, {555,0.00037624}, {560,0.00036634}, {565,0.00041584}, {570,0.00040594}, {575,0.00022772}, {580,0.00022772}, {585,0.00040594}, {590,0.00036634}, {595,0.00047525}, {600,0.00023762}, {605,0.00024752}, {610,0.00037624}, {615,0.00053465}, {620,0.00044554}, {625,0.00044554}, {630,0.00022772}, {635,0.00033663}, {640,0.00031683}, {645,0.00022772}, {650,0.00037624}, {655,0.00042574}, {660,0.00032673}, {665,0.00041584}, {670,0.00024752}, {675,0.00058416}, {680,0.00066337}, {685,0.00025743}, {690,0.00044554}, {695,0.00051485}, {700,0.00038614}, {705,0.00039604}, {710,0.00030693}, {715,0.00030693}, {720,0.00048515}, {725,0.00035644}, {730,0.00035644}, {735,0.00023762}, {740,0.00030693}, {745,0.00059406}, {750,0.00030693}, {755,0.00063366}, {760,0.00043564}, {765,0.00032673}, {770,0.00073267}, {775,0.00019802}, {780,0.00035644}, {785,0.00042574}, {790,0.00051485}, {795,0.00049505}, {800,0.00051485}, {805,0.00046535}, {810,0.00045545}, {815,0.00031683}, {820,0.00044554}, {825,0.00040594}, {830,0.00017822}, {835,0.00057426}, {840,0.00065347}, {845,0.00037624}, {850,0.00056436}, {855,0.00049505}, {860,0.00042574}, {865,0.00061386}, {870,0.00038614}, {875,0.00056436}, {880,0.00044554}, {885,0.00056436}, {890,0.00035644}, {895,0.00057426}, {900,0.00060396}, {905,0.00057426}, {910,0.00090099}, {915,0.00087129}, {920,0.00038614}, {925,0.00048515}, {930,0.00034653}, {935,0.00046535}, {940,0.00046535}, {945,0.00051485}, {950,0.00064356}, {955,0.00052475}, {960,0.00068317}, {965,0.00038614}, {970,0.00049505}, {975,0.00062376}, {980,0.00055446}, {985,0.00067327}, {990,0.00050495}, {995,0.00049505}, {1000,0.00040594}, {1010,0.00034653}, {1020,0.00061386}, {1030,0.00066337}, {1040,0.00037624}, {1050,0.00055446}, {1060,0.00047525}, {1070,0.00040594}, {1080,0.00059406}, {1090,0.00082178}, {1100,0.00046535}, {1110,0.00068317}, {1120,0.00066337}, {1130,0.00083168}, {1140,0.00044554}, {1150,0.00082178}, {1160,0.00064356}, {1170,0.00064356}, {1180,0.00076238}, {1190,0.00065347}, {1200,0.00068317}, {1210,0.00061386}, {1220,0.00058416}, {1230,0.00067327}, {1240,0.00084158}, {1250,0.00090099}, {1260,0.00060396}, {1270,0.00064356}, {1280,0.00080198}, {1290,0.00065347}, {1300,0.00041584}, {1310,0.00062376}, {1320,0.00073267}, {1330,0.00077228}, {1340,0.00097030}, {1350,0.00061386}, {1360,0.00069307}, {1370,0.00070297}, {1380,0.00074257}, {1390,0.00088119}, {1400,0.00085149}, {1410,0.00044554}, {1420,0.00075248}, {1430,0.00088119}, {1440,0.00053465}, {1450,0.00073267}, {1460,0.00090099}, {1470,0.00050495}, {1480,0.00076238}, {1490,0.00096040}, {1500,0.00097030}, {1510,0.00098020}, {1520,0.00072277}, {1530,0.00068317}, {1540,0.00088119}, {1550,0.00100000}, {1560,0.00078218}, {1570,0.00071287}, {1580,0.00061386}, {1590,0.00100000}, {1600,0.00100990}, {1610,0.00084158}, {1620,0.00104950}, {1630,0.00057426}, {1640,0.00083168}, {1650,0.00111881}, {1660,0.00102970}, {1670,0.00112871}, {1680,0.00101980}, {1690,0.00090099}, {1700,0.00101980}, {1710,0.00101980}, {1720,0.00120792}, {1730,0.00075248}, {1740,0.00095050}, {1750,0.00084158}, {1760,0.00099010}, {1770,0.00106931}, {1780,0.00123762}, {1790,0.00107921}, {1800,0.00103960}, {1810,0.00104950}, {1820,0.00111881}, {1830,0.00107921}, {1840,0.00141584}, {1850,0.00109901}, {1860,0.00097030}, {1870,0.00125743}, {1880,0.00124752}, {1890,0.00090099}, {1900,0.00103960}, {1910,0.00112871}, {1920,0.00144554}, {1930,0.00086139}, {1940,0.00086139}, {1950,0.00120792}, {1960,0.00134653}, {1970,0.00119802}, {1980,0.00118812}, {1990,0.00100000}, {2000,0.00120792}, {2050,0.00107921}, {2100,0.00113861}, {2150,0.00112871}, {2200,0.00133663}, {2250,0.00164356}, {2300,0.00117822}, {2350,0.00119802}, {2400,0.00143564}, {2450,0.00124752}, {2500,0.00134653}, {2550,0.00151485}, {2600,0.00413861}, {2650,0.00128713}, {2700,0.00141584}, {2750,0.00135644}, {2800,0.00119802}, {2850,0.00183168}, {2900,0.00155446}, {2950,0.00142574}, {3000,0.00131683}, {3050,0.00153465}, {3100,0.00146535}, {3150,0.00169307}, {3200,0.00182178}, {3250,0.00199010}, {3300,0.00194059}, {3350,0.00164356}, {3400,0.00176238}, {3450,0.00173267}, {3500,0.00175248}, {3550,0.00163366}, {3600,0.00176238}, {3650,0.00208911}, {3700,0.00223762}, {3750,0.00229703}, {3800,0.00192079}, {3850,0.00179208}, {3900,0.00193069}, {3950,0.00160396}, {4000,0.00211881}, {4050,0.00187129}, {4100,0.00212871}, {4150,0.00231683}, {4200,0.00259406}, {4250,0.00241584}, {4300,0.00243564}, {4350,0.00245545}, {4400,0.00249505}, {4450,0.00247525}, {4500,0.00236634}, {4550,0.00279208}, {4600,0.00498020}, {4650,0.00230693}, {4700,0.00255446}, {4750,0.00250495}, {4800,0.00301980}, {4850,0.00256436}, {4900,0.00505941}, {4950,0.00278218}, {5000,0.00301980}, {5050,0.00355446}, {5100,0.00297030}, {5150,0.00328713}, {5200,0.00305941}, {5250,0.00320792}, {5300,0.00322772}, {5350,0.00344554}, {5400,0.00338614}, {5450,0.00343564}, {5500,0.00325743}, {5550,0.00332673}, {5600,0.00317822}, {5650,0.00348515}, {5700,0.00332673}, {5750,0.00338614}, {5800,0.00345545}, {5850,0.00345545}, {5900,0.00348515}, {5950,0.00328713}, {6000,0.00337624}, {6050,0.0040286}, {6100,0.0039714}, {6150,0.0042000}, {6200,0.0042286}, {6250,0.0038857}, {6300,0.0044571}, {6350,0.0042571}, {6400,0.0043714}, {6450,0.0050571}, {6500,0.0049429}, {6550,0.0190286}, {6600,0.0043429}, {6650,0.0048286}, {6700,0.0049143}, {6750,0.0049429}, {6800,0.0051714}, {6850,0.0050571}, {6900,0.0052571}, {6950,0.0054000}, {7000,0.0048571}, {7050,0.0039714}, {7100,0.0050857}, {7150,0.0050000}, {7200,0.0056857}, {7250,0.0056000}, {7300,0.0050000}, {7350,0.0061429}, {7400,0.0057429}, {7450,0.0058857}, {7500,0.0055143}, {7550,0.0060286}, {7600,0.0093714}, {7650,0.0058000}, {7700,0.0063714}, {7750,0.0064000}, {7800,0.0060000}, {7850,0.0062000}, {7900,0.0063714}, {7950,0.0061429}, {8000,0.0063714}, {8050,0.0060571}, {8100,0.0062857}, {8150,0.0068000}, {8200,0.0067143}, {8250,0.0068286}, {8300,0.0069714}, {8350,0.0064000}, {8400,0.0072286}, {8450,0.0069143}, {8500,0.0068857}, {8550,0.0072286}, {8600,0.0071143}, {8650,0.0077429}, {8700,0.0120857}, {8750,0.0072571}, {8800,0.0076857}, {8850,0.0074000}, {8900,0.0075714}, {8950,0.0124000}, {9000,0.0081143}, {9050,0.0082286}, {9100,0.0079429}, {9150,0.0082000}, {9200,0.0078857}, {9250,0.0084571}, {9300,0.0086286}, {9350,0.0084857}, {9400,0.0082857}, {9450,0.0174857}, {9500,0.0081714}, {9550,0.0088571}, {9600,0.0072286}, {9650,0.0179143}, {9700,0.0086000}, {9750,0.0084857}, {9800,0.0094000}, {9850,0.0094000}, {9900,0.0085429}, {9950,0.0086571}, {10000,0.0090857}, {10100,0.0095143}, {10200,0.0089429}, {10300,0.0096000}, {10400,0.0096000}, {10500,0.0092000}, {10600,0.0095714}, {10700,0.0088571}, {10800,0.0265429}, {10900,0.0094857}, {11000,0.0100857}, {11100,0.0091714}, {11200,0.0098000}, {11300,0.0100000}, {11400,0.0107714}, {11500,0.0187429}, {11600,0.0092857}, {11700,0.0101143}, {11800,0.0084286}, {11900,0.0105429}, {12000,0.0102286}, {12100,0.0103714}, {12200,0.0107143}, {12300,0.0354571}, {12400,0.0109429}, {12500,0.0156286}, {12600,0.0107143}, {12700,0.0109143}, {12800,0.0110286}, {12900,0.0111143}, {13000,0.0112857}, {13100,0.0116857}, {13200,0.0118000}, {13300,0.0115143}, {13400,0.0106286}, {13500,0.0114286}, {13600,0.0121714}, {13700,0.0118000}, {13800,0.0104571}, {13900,0.0122857}, {14000,0.0123429}, {14100,0.0110286}, {14200,0.0122571}, {14300,0.0125714}, {14400,0.0123429}, {14500,0.0124000}, {14600,0.0130286}, {14700,0.0133714}, {14800,0.0128857}, {14900,0.0125714}, {15000,0.0135429}, {15100,0.0130571}, {15200,0.0344857}, {15300,0.0126857}, {15400,0.0134286}, {15500,0.0139429}, {15600,0.0288571}, {15700,0.0136571}, {15800,0.0113714}, {15900,0.0133714}, {16000,0.0136000}, {16100,0.0119143}, {16200,0.0142857}, {16300,0.0145143}, {16400,0.0144000}, {16500,0.0144571}, {16600,0.0150857}, {16700,0.0147429}, {16800,0.0150000}, {16900,0.0150000}, {17000,0.0151143}, {17100,0.0151429}, {17200,0.0450286}, {17300,0.0153714}, {17400,0.0486857}, {17500,0.0152857}, {17600,0.0157429}, {17700,0.0152000}, {17800,0.0158286}, {17900,0.0157714}, {18000,0.0159429}, {18100,0.0395714}, {18200,0.0160286}, {18300,0.0163429}, {18400,0.0158857}, {18500,0.0161429}, {18600,0.0141429}, {18700,0.0141429}, {18800,0.0166000}, {18900,0.0165143}, {19000,0.0165143}, {19100,0.0169143}, {19200,0.0170286}, {19300,0.0170857}, {19400,0.0165714}, {19500,0.0172286}, {19600,0.0169714}, {19700,0.0174000}, {19800,0.0239429}, {19900,0.0367429}, {20000,0.0171714}};
data["big_flat"]["LtacTacInTermPrimPair"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00003960}, {52,0.00003960}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00003960}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00003960}, {97,0.00000000}, {98,0.00002970}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00003960}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00003960}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00003960}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00003960}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00003960}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00002970}, {233,0.00003960}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00003960}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00003960}, {256,0.00000000}, {257,0.00000000}, {258,0.00003960}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00003960}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00003960}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00003960}, {324,0.00003960}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00003960}, {349,0.00000000}, {350,0.00000000}, {351,0.00003960}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00003960}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00003960}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00003960}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00003960}, {775,0.00000000}, {780,0.00003960}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00003960}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00003960}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00002970}, {1050,0.00000000}, {1060,0.00003960}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00003960}, {1440,0.00003960}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00007921}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00003960}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00003960}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00003960}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00002970}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00003960}, {2050,0.00000000}, {2100,0.00003960}, {2150,0.00000000}, {2200,0.00003960}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00003960}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00003960}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00007921}, {3050,0.00000000}, {3100,0.00003960}, {3150,0.00000000}, {3200,0.00006931}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00003960}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00002970}, {3550,0.00003960}, {3600,0.00003960}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00003960}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00003960}, {4200,0.00000000}, {4250,0.00003960}, {4300,0.00007921}, {4350,0.00000000}, {4400,0.00003960}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00003960}, {5150,0.00000000}, {5200,0.00007921}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00003960}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00003960}, {5900,0.00007921}, {5950,0.00000000}, {6000,0.00003960}, {6050,0.0001143}, {6100,0.0002857}, {6150,0.0000000}, {6200,0.0001143}, {6250,0.0002286}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0001143}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0001143}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0002000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0001143}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0001143}, {8300,0.0000000}, {8350,0.0001143}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0001143}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0001143}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0001143}, {9250,0.0001143}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0001143}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0001143}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0001143}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0001143}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0001143}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0001143}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0002286}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0001143}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0001143}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0001143}, {16000,0.0001143}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0001143}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0001143}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0001143}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0001143}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0001143}, {19300,0.0001143}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0001143}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermPrimPair"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000990}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000990}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000990}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00001980}, {2150,0.00000000}, {2200,0.00000990}, {2250,0.00007921}, {2300,0.00015842}, {2350,0.00038614}, {2400,0.00047525}, {2450,0.00054455}, {2500,0.00074257}, {2550,0.00099010}, {2600,0.00100000}, {2650,0.00100000}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00100000}, {3150,0.00100000}, {3200,0.00100000}, {3250,0.00100000}, {3300,0.00100000}, {3350,0.00100000}, {3400,0.00100000}, {3450,0.00100000}, {3500,0.00100000}, {3550,0.00100000}, {3600,0.00707921}, {3650,0.00480198}, {3700,0.00100000}, {3750,0.00100000}, {3800,0.00100000}, {3850,0.00100000}, {3900,0.00100000}, {3950,0.00100000}, {4000,0.00100000}, {4050,0.00100000}, {4100,0.00100000}, {4150,0.00100000}, {4200,0.00100000}, {4250,0.00100000}, {4300,0.00100000}, {4350,0.00100000}, {4400,0.00100990}, {4450,0.00100990}, {4500,0.00101980}, {4550,0.00101980}, {4600,0.00108911}, {4650,0.00117822}, {4700,0.00128713}, {4750,0.00150495}, {4800,0.00159406}, {4850,0.00162376}, {4900,0.00167327}, {4950,0.00173267}, {5000,0.00176238}, {5050,0.00178218}, {5100,0.00195050}, {5150,0.00199010}, {5200,0.00200000}, {5250,0.00200000}, {5300,0.00200000}, {5350,0.00200000}, {5400,0.00200000}, {5450,0.00200000}, {5500,0.00667327}, {5550,0.00200000}, {5600,0.00200000}, {5650,0.00200000}, {5700,0.00200000}, {5750,0.00200000}, {5800,0.00200000}, {5850,0.00200000}, {5900,0.00200000}, {5950,0.00200000}, {6000,0.00200000}, {6050,0.0020000}, {6100,0.0021143}, {6150,0.0020857}, {6200,0.0021714}, {6250,0.0020857}, {6300,0.0021429}, {6350,0.0021143}, {6400,0.0022857}, {6450,0.0023429}, {6500,0.0023143}, {6550,0.0023714}, {6600,0.0024857}, {6650,0.0024857}, {6700,0.0026857}, {6750,0.0027714}, {6800,0.0168571}, {6850,0.0027714}, {6900,0.0028571}, {6950,0.0029143}, {7000,0.0029429}, {7050,0.0030000}, {7100,0.0029714}, {7150,0.0029714}, {7200,0.0029714}, {7250,0.0030000}, {7300,0.0030000}, {7350,0.0172286}, {7400,0.0030000}, {7450,0.0030000}, {7500,0.0030000}, {7550,0.0030000}, {7600,0.0030000}, {7650,0.0031714}, {7700,0.0030286}, {7750,0.0030286}, {7800,0.0030286}, {7850,0.0030000}, {7900,0.0132571}, {7950,0.0030286}, {8000,0.0030286}, {8050,0.0030286}, {8100,0.0030286}, {8150,0.0030571}, {8200,0.0171143}, {8250,0.0030000}, {8300,0.0031143}, {8350,0.0032000}, {8400,0.0033714}, {8450,0.0034571}, {8500,0.0035143}, {8550,0.0035429}, {8600,0.0036286}, {8650,0.0037143}, {8700,0.0038000}, {8750,0.0038286}, {8800,0.0038000}, {8850,0.0038000}, {8900,0.0038000}, {8950,0.0037714}, {9000,0.0038571}, {9050,0.0038000}, {9100,0.0039143}, {9150,0.0038571}, {9200,0.0038857}, {9250,0.0039429}, {9300,0.0039714}, {9350,0.0040000}, {9400,0.0040000}, {9450,0.0040000}, {9500,0.0039714}, {9550,0.0040000}, {9600,0.0040000}, {9650,0.0040000}, {9700,0.0040000}, {9750,0.0040000}, {9800,0.0040000}, {9850,0.0040000}, {9900,0.0040000}, {9950,0.0040000}, {10000,0.0040286}, {10100,0.0041143}, {10200,0.0042000}, {10300,0.0043143}, {10400,0.0043429}, {10500,0.0044857}, {10600,0.0045714}, {10700,0.0047143}, {10800,0.0047714}, {10900,0.0047714}, {11000,0.0047714}, {11100,0.0047714}, {11200,0.0048000}, {11300,0.0047714}, {11400,0.0048286}, {11500,0.0049714}, {11600,0.0049429}, {11700,0.0049714}, {11800,0.0050000}, {11900,0.0050000}, {12000,0.0050000}, {12100,0.0050286}, {12200,0.0052000}, {12300,0.0051714}, {12400,0.0272571}, {12500,0.0053714}, {12600,0.0056571}, {12700,0.0056286}, {12800,0.0056857}, {12900,0.0057143}, {13000,0.0057714}, {13100,0.0252571}, {13200,0.0057143}, {13300,0.0056857}, {13400,0.0056857}, {13500,0.0057429}, {13600,0.0057429}, {13700,0.0058857}, {13800,0.0059714}, {13900,0.0060857}, {14000,0.0060857}, {14100,0.0060571}, {14200,0.0061429}, {14300,0.0062286}, {14400,0.0064286}, {14500,0.0064286}, {14600,0.0064571}, {14700,0.0066000}, {14800,0.0066286}, {14900,0.0067143}, {15000,0.0067143}, {15100,0.0066857}, {15200,0.0066857}, {15300,0.0066857}, {15400,0.0066857}, {15500,0.0066857}, {15600,0.0066857}, {15700,0.0066571}, {15800,0.0067143}, {15900,0.0067714}, {16000,0.0068857}, {16100,0.0069143}, {16200,0.0070571}, {16300,0.0071714}, {16400,0.0072857}, {16500,0.0073429}, {16600,0.0073429}, {16700,0.0074857}, {16800,0.0389429}, {16900,0.0076286}, {17000,0.0076000}, {17100,0.0076286}, {17200,0.0076857}, {17300,0.0076571}, {17400,0.0076571}, {17500,0.0076571}, {17600,0.0076857}, {17700,0.0076571}, {17800,0.0076571}, {17900,0.0076286}, {18000,0.0077714}, {18100,0.0078857}, {18200,0.0079143}, {18300,0.0079714}, {18400,0.0080857}, {18500,0.0082571}, {18600,0.0084286}, {18700,0.0084571}, {18800,0.0085714}, {18900,0.0086000}, {19000,0.0086286}, {19100,0.0086571}, {19200,0.0086571}, {19300,0.0314857}, {19400,0.0086857}, {19500,0.0406857}, {19600,0.0306000}, {19700,0.0086857}, {19800,0.0086571}, {19900,0.0086000}, {20000,0.0086571}};
data["big_flat"]["LtacTacInTermPrimPair"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00006931}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00002970}, {15,0.00000000}, {16,0.00006931}, {17,0.00000000}, {18,0.00002970}, {19,0.00003960}, {20,0.00000000}, {21,0.00000000}, {22,0.00002970}, {23,0.00010891}, {24,0.00007921}, {25,0.00000000}, {26,0.00000000}, {27,0.00005941}, {28,0.00003960}, {29,0.00003960}, {30,0.00002970}, {31,0.00006931}, {32,0.00000000}, {33,0.00006931}, {34,0.00000000}, {35,0.00003960}, {36,0.00007921}, {37,0.00002970}, {38,0.00006931}, {39,0.00003960}, {40,0.00006931}, {41,0.00006931}, {42,0.00003960}, {43,0.00002970}, {44,0.00000000}, {45,0.00002970}, {46,0.00002970}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00000000}, {51,0.00002970}, {52,0.00002970}, {53,0.00007921}, {54,0.00006931}, {55,0.00007921}, {56,0.00000000}, {57,0.00002970}, {58,0.00003960}, {59,0.00006931}, {60,0.00002970}, {61,0.00002970}, {62,0.00002970}, {63,0.00005941}, {64,0.00002970}, {65,0.00002970}, {66,0.00002970}, {67,0.00002970}, {68,0.00000000}, {69,0.00002970}, {70,0.00009901}, {71,0.00005941}, {72,0.00002970}, {73,0.00000000}, {74,0.00005941}, {75,0.00009901}, {76,0.00009901}, {77,0.00002970}, {78,0.00002970}, {79,0.00008911}, {80,0.00002970}, {81,0.00005941}, {82,0.00007921}, {83,0.00002970}, {84,0.00006931}, {85,0.00002970}, {86,0.00007921}, {87,0.00012871}, {88,0.00006931}, {89,0.00002970}, {90,0.00002970}, {91,0.00006931}, {92,0.00006931}, {93,0.00003960}, {94,0.00002970}, {95,0.00005941}, {96,0.00009901}, {97,0.00003960}, {98,0.00003960}, {99,0.00006931}, {100,0.00006931}, {101,0.00002970}, {102,0.00008911}, {103,0.00006931}, {104,0.00000000}, {105,0.00008911}, {106,0.00008911}, {107,0.00008911}, {108,0.00002970}, {109,0.00008911}, {110,0.00000000}, {111,0.00000000}, {112,0.00008911}, {113,0.00002970}, {114,0.00002970}, {115,0.00003960}, {116,0.00012871}, {117,0.00000000}, {118,0.00008911}, {119,0.00011881}, {120,0.00002970}, {121,0.00009901}, {122,0.00006931}, {123,0.00002970}, {124,0.00000000}, {125,0.00009901}, {126,0.00000000}, {127,0.00009901}, {128,0.00003960}, {129,0.00002970}, {130,0.00002970}, {131,0.00000000}, {132,0.00020792}, {133,0.00006931}, {134,0.00006931}, {135,0.00023762}, {136,0.00011881}, {137,0.00019802}, {138,0.00006931}, {139,0.00010891}, {140,0.00003960}, {141,0.00016832}, {142,0.00012871}, {143,0.00009901}, {144,0.00009901}, {145,0.00000000}, {146,0.00003960}, {147,0.00006931}, {148,0.00003960}, {149,0.00002970}, {150,0.00017822}, {151,0.00006931}, {152,0.00005941}, {153,0.00011881}, {154,0.00009901}, {155,0.00003960}, {156,0.00003960}, {157,0.00006931}, {158,0.00003960}, {159,0.00012871}, {160,0.00013861}, {161,0.00000000}, {162,0.00021782}, {163,0.00015842}, {164,0.00006931}, {165,0.00003960}, {166,0.00011881}, {167,0.00010891}, {168,0.00014851}, {169,0.00006931}, {170,0.00008911}, {171,0.00003960}, {172,0.00006931}, {173,0.00021782}, {174,0.00010891}, {175,0.00006931}, {176,0.00007921}, {177,0.00006931}, {178,0.00002970}, {179,0.00018812}, {180,0.00010891}, {181,0.00009901}, {182,0.00000000}, {183,0.00017822}, {184,0.00009901}, {185,0.00006931}, {186,0.00014851}, {187,0.00007921}, {188,0.00012871}, {189,0.00006931}, {190,0.00010891}, {191,0.00006931}, {192,0.00017822}, {193,0.00013861}, {194,0.00014851}, {195,0.00006931}, {196,0.00021782}, {197,0.00015842}, {198,0.00013861}, {199,0.00007921}, {200,0.00007921}, {201,0.00003960}, {202,0.00017822}, {203,0.00003960}, {204,0.00015842}, {205,0.00006931}, {206,0.00003960}, {207,0.00012871}, {208,0.00002970}, {209,0.00009901}, {210,0.00010891}, {211,0.00014851}, {212,0.00000000}, {213,0.00009901}, {214,0.00009901}, {215,0.00009901}, {216,0.00007921}, {217,0.00003960}, {218,0.00013861}, {219,0.00010891}, {220,0.00011881}, {221,0.00006931}, {222,0.00009901}, {223,0.00013861}, {224,0.00018812}, {225,0.00007921}, {226,0.00017822}, {227,0.00017822}, {228,0.00018812}, {229,0.00016832}, {230,0.00000000}, {231,0.00009901}, {232,0.00006931}, {233,0.00007921}, {234,0.00014851}, {235,0.00009901}, {236,0.00002970}, {237,0.00018812}, {238,0.00022772}, {239,0.00002970}, {240,0.00009901}, {241,0.00002970}, {242,0.00006931}, {243,0.00011881}, {244,0.00018812}, {245,0.00009901}, {246,0.00012871}, {247,0.00017822}, {248,0.00016832}, {249,0.00015842}, {250,0.00002970}, {251,0.00013861}, {252,0.00005941}, {253,0.00009901}, {254,0.00010891}, {255,0.00019802}, {256,0.00005941}, {257,0.00008911}, {258,0.00011881}, {259,0.00008911}, {260,0.00010891}, {261,0.00019802}, {262,0.00019802}, {263,0.00007921}, {264,0.00013861}, {265,0.00010891}, {266,0.00014851}, {267,0.00007921}, {268,0.00025743}, {269,0.00002970}, {270,0.00003960}, {271,0.00012871}, {272,0.00011881}, {273,0.00013861}, {274,0.00020792}, {275,0.00002970}, {276,0.00013861}, {277,0.00022772}, {278,0.00017822}, {279,0.00015842}, {280,0.00009901}, {281,0.00021782}, {282,0.00003960}, {283,0.00011881}, {284,0.00002970}, {285,0.00018812}, {286,0.00006931}, {287,0.00019802}, {288,0.00016832}, {289,0.00008911}, {290,0.00000000}, {291,0.00016832}, {292,0.00014851}, {293,0.00015842}, {294,0.00012871}, {295,0.00006931}, {296,0.00021782}, {297,0.00018812}, {298,0.00023762}, {299,0.00021782}, {300,0.00009901}, {301,0.00011881}, {302,0.00006931}, {303,0.00019802}, {304,0.00019802}, {305,0.00026733}, {306,0.00011881}, {307,0.00012871}, {308,0.00012871}, {309,0.00012871}, {310,0.00008911}, {311,0.00008911}, {312,0.00005941}, {313,0.00018812}, {314,0.00009901}, {315,0.00013861}, {316,0.00019802}, {317,0.00019802}, {318,0.00025743}, {319,0.00013861}, {320,0.00006931}, {321,0.00016832}, {322,0.00009901}, {323,0.00025743}, {324,0.00022772}, {325,0.00009901}, {326,0.00022772}, {327,0.00015842}, {328,0.00027723}, {329,0.00014851}, {330,0.00010891}, {331,0.00014851}, {332,0.00028713}, {333,0.00012871}, {334,0.00011881}, {335,0.00009901}, {336,0.00014851}, {337,0.00002970}, {338,0.00022772}, {339,0.00006931}, {340,0.00005941}, {341,0.00022772}, {342,0.00009901}, {343,0.00015842}, {344,0.00012871}, {345,0.00002970}, {346,0.00014851}, {347,0.00016832}, {348,0.00033663}, {349,0.00012871}, {350,0.00028713}, {351,0.00024752}, {352,0.00014851}, {353,0.00018812}, {354,0.00014851}, {355,0.00013861}, {356,0.00010891}, {357,0.00015842}, {358,0.00009901}, {359,0.00022772}, {360,0.00018812}, {361,0.00028713}, {362,0.00006931}, {363,0.00022772}, {364,0.00025743}, {365,0.00021782}, {366,0.00014851}, {367,0.00020792}, {368,0.00030693}, {369,0.00014851}, {370,0.00010891}, {371,0.00010891}, {372,0.00011881}, {373,0.00025743}, {374,0.00017822}, {375,0.00028713}, {376,0.00010891}, {377,0.00014851}, {378,0.00020792}, {379,0.00028713}, {380,0.00023762}, {381,0.00025743}, {382,0.00023762}, {383,0.00033663}, {384,0.00022772}, {385,0.00020792}, {386,0.00014851}, {387,0.00019802}, {388,0.00006931}, {389,0.00013861}, {390,0.00025743}, {391,0.00006931}, {392,0.00013861}, {393,0.00011881}, {394,0.00031683}, {395,0.00021782}, {396,0.00029703}, {397,0.00023762}, {398,0.00009901}, {399,0.00021782}, {400,0.00019802}, {401,0.00025743}, {402,0.00013861}, {403,0.00019802}, {404,0.00014851}, {405,0.00020792}, {406,0.00010891}, {407,0.00017822}, {408,0.00021782}, {409,0.00026733}, {410,0.00011881}, {411,0.00018812}, {412,0.00041584}, {413,0.00006931}, {414,0.00020792}, {415,0.00028713}, {416,0.00017822}, {417,0.00014851}, {418,0.00030693}, {419,0.00011881}, {420,0.00028713}, {421,0.00025743}, {422,0.00006931}, {423,0.00016832}, {424,0.00035644}, {425,0.00012871}, {426,0.00025743}, {427,0.00007921}, {428,0.00024752}, {429,0.00011881}, {430,0.00022772}, {431,0.00010891}, {432,0.00012871}, {433,0.00019802}, {434,0.00007921}, {435,0.00029703}, {436,0.00018812}, {437,0.00017822}, {438,0.00017822}, {439,0.00010891}, {440,0.00023762}, {441,0.00006931}, {442,0.00022772}, {443,0.00031683}, {444,0.00030693}, {445,0.00030693}, {446,0.00025743}, {447,0.00022772}, {448,0.00024752}, {449,0.00003960}, {450,0.00026733}, {451,0.00027723}, {452,0.00026733}, {453,0.00036634}, {454,0.00017822}, {455,0.00023762}, {456,0.00029703}, {457,0.00030693}, {458,0.00021782}, {459,0.00023762}, {460,0.00022772}, {461,0.00013861}, {462,0.00036634}, {463,0.00021782}, {464,0.00018812}, {465,0.00009901}, {466,0.00027723}, {467,0.00027723}, {468,0.00046535}, {469,0.00019802}, {470,0.00021782}, {471,0.00018812}, {472,0.00029703}, {473,0.00016832}, {474,0.00019802}, {475,0.00035644}, {476,0.00023762}, {477,0.00033663}, {478,0.00011881}, {479,0.00026733}, {480,0.00017822}, {481,0.00011881}, {482,0.00037624}, {483,0.00018812}, {484,0.00010891}, {485,0.00017822}, {486,0.00010891}, {487,0.00011881}, {488,0.00003960}, {489,0.00028713}, {490,0.00029703}, {491,0.00023762}, {492,0.00037624}, {493,0.00026733}, {494,0.00023762}, {495,0.00025743}, {496,0.00017822}, {497,0.00012871}, {498,0.00023762}, {499,0.00027723}, {500,0.00024752}, {505,0.00010891}, {510,0.00024752}, {515,0.00038614}, {520,0.00020792}, {525,0.00009901}, {530,0.00031683}, {535,0.00009901}, {540,0.00008911}, {545,0.00016832}, {550,0.00039604}, {555,0.00012871}, {560,0.00012871}, {565,0.00035644}, {570,0.00019802}, {575,0.00019802}, {580,0.00034653}, {585,0.00016832}, {590,0.00016832}, {595,0.00024752}, {600,0.00013861}, {605,0.00009901}, {610,0.00034653}, {615,0.00022772}, {620,0.00035644}, {625,0.00023762}, {630,0.00042574}, {635,0.00038614}, {640,0.00027723}, {645,0.00019802}, {650,0.00018812}, {655,0.00027723}, {660,0.00026733}, {665,0.00023762}, {670,0.00031683}, {675,0.00026733}, {680,0.00033663}, {685,0.00008911}, {690,0.00035644}, {695,0.00018812}, {700,0.00031683}, {705,0.00018812}, {710,0.00026733}, {715,0.00028713}, {720,0.00034653}, {725,0.00020792}, {730,0.00022772}, {735,0.00012871}, {740,0.00037624}, {745,0.00020792}, {750,0.00039604}, {755,0.00014851}, {760,0.00034653}, {765,0.00020792}, {770,0.00030693}, {775,0.00025743}, {780,0.00021782}, {785,0.00032673}, {790,0.00019802}, {795,0.00026733}, {800,0.00015842}, {805,0.00035644}, {810,0.00028713}, {815,0.00025743}, {820,0.00041584}, {825,0.00019802}, {830,0.00020792}, {835,0.00032673}, {840,0.00035644}, {845,0.00029703}, {850,0.00011881}, {855,0.00030693}, {860,0.00038614}, {865,0.00015842}, {870,0.00049505}, {875,0.00017822}, {880,0.00029703}, {885,0.00046535}, {890,0.00055446}, {895,0.00030693}, {900,0.00031683}, {905,0.00031683}, {910,0.00019802}, {915,0.00023762}, {920,0.00023762}, {925,0.00043564}, {930,0.00031683}, {935,0.00036634}, {940,0.00032673}, {945,0.00028713}, {950,0.00046535}, {955,0.00024752}, {960,0.00026733}, {965,0.00037624}, {970,0.00008911}, {975,0.00029703}, {980,0.00025743}, {985,0.00026733}, {990,0.00033663}, {995,0.00034653}, {1000,0.00038614}, {1010,0.00051485}, {1020,0.00029703}, {1030,0.00043564}, {1040,0.00022772}, {1050,0.00037624}, {1060,0.00035644}, {1070,0.00025743}, {1080,0.00029703}, {1090,0.00029703}, {1100,0.00035644}, {1110,0.00046535}, {1120,0.00030693}, {1130,0.00041584}, {1140,0.00035644}, {1150,0.00045545}, {1160,0.00069307}, {1170,0.00046535}, {1180,0.00027723}, {1190,0.00032673}, {1200,0.00035644}, {1210,0.00048515}, {1220,0.00060396}, {1230,0.00039604}, {1240,0.00042574}, {1250,0.00047525}, {1260,0.00069307}, {1270,0.00029703}, {1280,0.00053465}, {1290,0.00048515}, {1300,0.00037624}, {1310,0.00052475}, {1320,0.00037624}, {1330,0.00052475}, {1340,0.00043564}, {1350,0.00043564}, {1360,0.00071287}, {1370,0.00047525}, {1380,0.00088119}, {1390,0.00022772}, {1400,0.00041584}, {1410,0.00048515}, {1420,0.00042574}, {1430,0.00034653}, {1440,0.00046535}, {1450,0.00056436}, {1460,0.00049505}, {1470,0.00057426}, {1480,0.00079208}, {1490,0.00070297}, {1500,0.00056436}, {1510,0.00077228}, {1520,0.00063366}, {1530,0.00054455}, {1540,0.00071287}, {1550,0.00059406}, {1560,0.00067327}, {1570,0.00069307}, {1580,0.00095050}, {1590,0.00047525}, {1600,0.00059406}, {1610,0.00063366}, {1620,0.00056436}, {1630,0.00067327}, {1640,0.00082178}, {1650,0.00082178}, {1660,0.00058416}, {1670,0.00081188}, {1680,0.00097030}, {1690,0.00082178}, {1700,0.00054455}, {1710,0.00070297}, {1720,0.00091089}, {1730,0.00083168}, {1740,0.00054455}, {1750,0.00055446}, {1760,0.00076238}, {1770,0.00073267}, {1780,0.00066337}, {1790,0.00075248}, {1800,0.00067327}, {1810,0.00049505}, {1820,0.00076238}, {1830,0.00057426}, {1840,0.00068317}, {1850,0.00067327}, {1860,0.00059406}, {1870,0.00066337}, {1880,0.00060396}, {1890,0.00070297}, {1900,0.00077228}, {1910,0.00070297}, {1920,0.00082178}, {1930,0.00064356}, {1940,0.00080198}, {1950,0.00055446}, {1960,0.00085149}, {1970,0.00051485}, {1980,0.00079208}, {1990,0.00086139}, {2000,0.00069307}, {2050,0.00069307}, {2100,0.00074257}, {2150,0.00089109}, {2200,0.00084158}, {2250,0.00077228}, {2300,0.00105941}, {2350,0.00090099}, {2400,0.00089109}, {2450,0.00102970}, {2500,0.00076238}, {2550,0.00092079}, {2600,0.00108911}, {2650,0.00110891}, {2700,0.00110891}, {2750,0.00123762}, {2800,0.00105941}, {2850,0.00092079}, {2900,0.00097030}, {2950,0.00140594}, {3000,0.00117822}, {3050,0.00106931}, {3100,0.00123762}, {3150,0.00132673}, {3200,0.00131683}, {3250,0.00122772}, {3300,0.00108911}, {3350,0.00156436}, {3400,0.00134653}, {3450,0.00161386}, {3500,0.00132673}, {3550,0.00153465}, {3600,0.00717822}, {3650,0.00462376}, {3700,0.00122772}, {3750,0.00122772}, {3800,0.00142574}, {3850,0.00186139}, {3900,0.00167327}, {3950,0.00202970}, {4000,0.00174257}, {4050,0.00189109}, {4100,0.00156436}, {4150,0.00151485}, {4200,0.00115842}, {4250,0.00153465}, {4300,0.00153465}, {4350,0.00152475}, {4400,0.00190099}, {4450,0.00160396}, {4500,0.00171287}, {4550,0.00164356}, {4600,0.00232673}, {4650,0.00200990}, {4700,0.00198020}, {4750,0.00196040}, {4800,0.00156436}, {4850,0.00191089}, {4900,0.00222772}, {4950,0.00200000}, {5000,0.00209901}, {5050,0.00151485}, {5100,0.00185149}, {5150,0.00163366}, {5200,0.00210891}, {5250,0.00208911}, {5300,0.00205941}, {5350,0.00213861}, {5400,0.00192079}, {5450,0.00254455}, {5500,0.00666337}, {5550,0.00176238}, {5600,0.00232673}, {5650,0.00246535}, {5700,0.00216832}, {5750,0.00227723}, {5800,0.00247525}, {5850,0.00198020}, {5900,0.00264356}, {5950,0.00222772}, {6000,0.00244554}, {6050,0.0025429}, {6100,0.0025143}, {6150,0.0019714}, {6200,0.0023429}, {6250,0.0026857}, {6300,0.0023143}, {6350,0.0027429}, {6400,0.0029429}, {6450,0.0024000}, {6500,0.0026857}, {6550,0.0026571}, {6600,0.0030286}, {6650,0.0028571}, {6700,0.0028000}, {6750,0.0030571}, {6800,0.0163143}, {6850,0.0026571}, {6900,0.0027714}, {6950,0.0023429}, {7000,0.0024571}, {7050,0.0032000}, {7100,0.0026571}, {7150,0.0030286}, {7200,0.0026571}, {7250,0.0025714}, {7300,0.0025714}, {7350,0.0172000}, {7400,0.0029143}, {7450,0.0023714}, {7500,0.0031143}, {7550,0.0031143}, {7600,0.0030286}, {7650,0.0034286}, {7700,0.0033429}, {7750,0.0032857}, {7800,0.0034286}, {7850,0.0034571}, {7900,0.0133143}, {7950,0.0034286}, {8000,0.0032571}, {8050,0.0031714}, {8100,0.0036000}, {8150,0.0035429}, {8200,0.0175714}, {8250,0.0035143}, {8300,0.0035429}, {8350,0.0038000}, {8400,0.0035714}, {8450,0.0036000}, {8500,0.0037429}, {8550,0.0038857}, {8600,0.0032857}, {8650,0.0034000}, {8700,0.0036857}, {8750,0.0035429}, {8800,0.0035429}, {8850,0.0039429}, {8900,0.0036000}, {8950,0.0039429}, {9000,0.0037714}, {9050,0.0037143}, {9100,0.0038857}, {9150,0.0040000}, {9200,0.0040857}, {9250,0.0037714}, {9300,0.0044857}, {9350,0.0042286}, {9400,0.0040857}, {9450,0.0042000}, {9500,0.0041143}, {9550,0.0039714}, {9600,0.0042571}, {9650,0.0046286}, {9700,0.0043714}, {9750,0.0045429}, {9800,0.0042000}, {9850,0.0039429}, {9900,0.0042857}, {9950,0.0048286}, {10000,0.0045143}, {10100,0.0041429}, {10200,0.0042000}, {10300,0.0047429}, {10400,0.0047429}, {10500,0.0047143}, {10600,0.0046000}, {10700,0.0054286}, {10800,0.0043143}, {10900,0.0048286}, {11000,0.0045429}, {11100,0.0053714}, {11200,0.0054286}, {11300,0.0051429}, {11400,0.0045714}, {11500,0.0048857}, {11600,0.0060286}, {11700,0.0048571}, {11800,0.0058000}, {11900,0.0055714}, {12000,0.0050571}, {12100,0.0055429}, {12200,0.0060571}, {12300,0.0054857}, {12400,0.0274286}, {12500,0.0056571}, {12600,0.0059143}, {12700,0.0053714}, {12800,0.0051143}, {12900,0.0059143}, {13000,0.0065714}, {13100,0.0251143}, {13200,0.0054286}, {13300,0.0061143}, {13400,0.0058571}, {13500,0.0060857}, {13600,0.0049429}, {13700,0.0063429}, {13800,0.0054000}, {13900,0.0060286}, {14000,0.0064857}, {14100,0.0062286}, {14200,0.0065143}, {14300,0.0060857}, {14400,0.0065429}, {14500,0.0066000}, {14600,0.0065714}, {14700,0.0070000}, {14800,0.0062000}, {14900,0.0068286}, {15000,0.0065714}, {15100,0.0065143}, {15200,0.0068286}, {15300,0.0074286}, {15400,0.0069143}, {15500,0.0068857}, {15600,0.0072286}, {15700,0.0072571}, {15800,0.0068857}, {15900,0.0074000}, {16000,0.0073429}, {16100,0.0075143}, {16200,0.0072286}, {16300,0.0073143}, {16400,0.0072857}, {16500,0.0076000}, {16600,0.0071714}, {16700,0.0081143}, {16800,0.0389429}, {16900,0.0078286}, {17000,0.0076571}, {17100,0.0077143}, {17200,0.0076000}, {17300,0.0078857}, {17400,0.0078571}, {17500,0.0080571}, {17600,0.0077429}, {17700,0.0080286}, {17800,0.0080571}, {17900,0.0080000}, {18000,0.0077143}, {18100,0.0082857}, {18200,0.0080571}, {18300,0.0084286}, {18400,0.0083714}, {18500,0.0084571}, {18600,0.0077714}, {18700,0.0086000}, {18800,0.0079429}, {18900,0.0087429}, {19000,0.0079714}, {19100,0.0082857}, {19200,0.0084000}, {19300,0.0314571}, {19400,0.0096000}, {19500,0.0405429}, {19600,0.0303714}, {19700,0.0085143}, {19800,0.0082286}, {19900,0.0082286}, {20000,0.0087714}};
data["big_flat"]["LtacTacInTermPrimPair"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00006931}, {141,0.00003960}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00003960}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00003960}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00003960}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00003960}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00003960}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00003960}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00002970}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00003960}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003960}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00003960}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00003960}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00003960}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00003960}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00003960}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00003960}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00003960}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00003960}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003960}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00003960}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00003960}, {1890,0.00003960}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00003960}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00003960}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00003960}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00002970}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00007921}, {3400,0.00003960}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00003960}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00003960}, {3850,0.00000000}, {3900,0.00003960}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00003960}, {4350,0.00000000}, {4400,0.00003960}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00007921}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00003960}, {5000,0.00003960}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00003960}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00003960}, {5850,0.00003960}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0001143}, {6100,0.0001143}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0002286}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0001143}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0001143}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0001143}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0002286}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0001143}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0002286}, {9450,0.0000000}, {9500,0.0001143}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0001143}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0001143}, {11400,0.0001143}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0001143}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0001143}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0001143}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0001143}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0001143}, {15600,0.0001143}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0002286}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0001143}, {17100,0.0002286}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0001143}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0002286}, {18100,0.0000000}, {18200,0.0002286}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0001143}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermPrimPair"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00001980}, {7,0.00072277}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100990}, {14,0.00114851}, {15,0.00158416}, {16,0.00200000}, {17,0.00200000}, {18,0.00200000}, {19,0.00200000}, {20,0.00200000}, {21,0.00208911}, {22,0.00221782}, {23,0.00269307}, {24,0.00300000}, {25,0.00300000}, {26,0.00300000}, {27,0.00301980}, {28,0.00301980}, {29,0.00314851}, {30,0.00326733}, {31,0.00372277}, {32,0.00400000}, {33,0.00400000}, {34,0.00400000}, {35,0.00401980}, {36,0.00412871}, {37,0.00418812}, {38,0.00437624}, {39,0.00652475}, {40,0.00500000}, {41,0.00500000}, {42,0.00500990}, {43,0.00505941}, {44,0.00514851}, {45,0.00526733}, {46,0.00530693}, {47,0.00568317}, {48,0.00596040}, {49,0.00600000}, {50,0.00600000}, {51,0.00797030}, {52,0.00611881}, {53,0.00624752}, {54,0.00648515}, {55,0.00658416}, {56,0.00694059}, {57,0.00702970}, {58,0.00707921}, {59,0.00716832}, {60,0.00729703}, {61,0.00717822}, {62,0.00729703}, {63,0.00765347}, {64,0.00786139}, {65,0.00811881}, {66,0.00811881}, {67,0.00812871}, {68,0.00833663}, {69,0.00827723}, {70,0.00832673}, {71,0.00863366}, {72,0.00883168}, {73,0.00906931}, {74,0.00908911}, {75,0.00915842}, {76,0.00911881}, {77,0.00925743}, {78,0.00942574}, {79,0.00964356}, {80,0.00983168}, {81,0.01019802}, {82,0.01010891}, {83,0.01461386}, {84,0.01016832}, {85,0.01026733}, {86,0.01029703}, {87,0.01059406}, {88,0.01078218}, {89,0.01111881}, {90,0.01106931}, {91,0.01117822}, {92,0.01117822}, {93,0.01126733}, {94,0.01130693}, {95,0.01155446}, {96,0.01173267}, {97,0.01208911}, {98,0.01216832}, {99,0.01219802}, {100,0.01222772}, {101,0.01235644}, {102,0.01233663}, {103,0.01269307}, {104,0.01283168}, {105,0.01311881}, {106,0.01309901}, {107,0.01326733}, {108,0.01328713}, {109,0.01708911}, {110,0.01332673}, {111,0.01370297}, {112,0.01389109}, {113,0.01403960}, {114,0.01412871}, {115,0.01913861}, {116,0.01412871}, {117,0.01426733}, {118,0.01455446}, {119,0.01464356}, {120,0.01759406}, {121,0.01504950}, {122,0.01513861}, {123,0.01528713}, {124,0.01719802}, {125,0.01534653}, {126,0.01540594}, {127,0.02144554}, {128,0.01569307}, {129,0.01613861}, {130,0.02234653}, {131,0.01618812}, {132,0.01637624}, {133,0.02149505}, {134,0.01652475}, {135,0.01668317}, {136,0.01763366}, {137,0.01718812}, {138,0.02354455}, {139,0.01719802}, {140,0.01731683}, {141,0.01738614}, {142,0.01763366}, {143,0.01776238}, {144,0.01775248}, {145,0.02028713}, {146,0.01811881}, {147,0.02108911}, {148,0.01841584}, {149,0.02057426}, {150,0.01860396}, {151,0.01892079}, {152,0.01887129}, {153,0.01915842}, {154,0.01923762}, {155,0.01933663}, {156,0.02408911}, {157,0.01963366}, {158,0.01949505}, {159,0.01997030}, {160,0.01973267}, {161,0.02215842}, {162,0.02008911}, {163,0.02032673}, {164,0.02336634}, {165,0.02072277}, {166,0.02064356}, {167,0.02251485}, {168,0.02089109}, {169,0.02113861}, {170,0.02113861}, {171,0.02624752}, {172,0.02151485}, {173,0.02155446}, {174,0.02149505}, {175,0.02590099}, {176,0.02194059}, {177,0.02224752}, {178,0.02218812}, {179,0.02228713}, {180,0.02595050}, {181,0.03129703}, {182,0.02268317}, {183,0.02265347}, {184,0.02277228}, {185,0.02298020}, {186,0.02313861}, {187,0.02529703}, {188,0.02843564}, {189,0.03102970}, {190,0.02346535}, {191,0.02398020}, {192,0.02377228}, {193,0.02397030}, {194,0.02414851}, {195,0.02432673}, {196,0.02436634}, {197,0.02450495}, {198,0.02459406}, {199,0.02466337}, {200,0.02463366}, {201,0.02491089}, {202,0.02517822}, {203,0.02558416}, {204,0.02556436}, {205,0.03451485}, {206,0.03259406}, {207,0.02862376}, {208,0.02808911}, {209,0.02603960}, {210,0.02609901}, {211,0.02637624}, {212,0.02647525}, {213,0.02666337}, {214,0.03704950}, {215,0.03021782}, {216,0.02673267}, {217,0.02710891}, {218,0.02689109}, {219,0.03666337}, {220,0.02998020}, {221,0.02760396}, {222,0.02758416}, {223,0.03894059}, {224,0.03098020}, {225,0.02800990}, {226,0.02808911}, {227,0.03717822}, {228,0.02833663}, {229,0.02855446}, {230,0.03845545}, {231,0.02998020}, {232,0.02888119}, {233,0.03869307}, {234,0.02913861}, {235,0.02951485}, {236,0.03648515}, {237,0.02950495}, {238,0.02978218}, {239,0.03155446}, {240,0.02997030}, {241,0.03594059}, {242,0.03009901}, {243,0.03962376}, {244,0.03028713}, {245,0.03086139}, {246,0.03068317}, {247,0.03069307}, {248,0.03070297}, {249,0.03115842}, {250,0.03123762}, {251,0.03262376}, {252,0.03177228}, {253,0.04155446}, {254,0.03168317}, {255,0.03792079}, {256,0.03209901}, {257,0.03346535}, {258,0.03219802}, {259,0.03229703}, {260,0.04020792}, {261,0.03262376}, {262,0.03277228}, {263,0.04376238}, {264,0.03287129}, {265,0.03462376}, {266,0.04341584}, {267,0.03359406}, {268,0.03350495}, {269,1.02701980}, {270,0.03389109}, {271,0.03409901}, {272,0.04001980}, {273,0.05037624}, {274,0.03434653}, {275,0.03471287}, {276,0.03878218}, {277,0.04541584}, {278,0.03531683}, {279,0.03519802}, {280,0.03505941}, {281,0.03957426}, {282,0.04421782}, {283,0.03700990}, {284,0.03599010}, {285,0.03599010}, {286,0.03593069}, {287,0.03633663}, {288,0.03917822}, {289,0.04239604}, {290,0.04467327}, {291,0.04732673}, {292,0.04881188}, {293,0.03707921}, {294,0.03756436}, {295,0.03728713}, {296,0.03728713}, {297,0.03741584}, {298,0.03742574}, {299,0.03767327}, {300,0.03820792}, {301,0.03817822}, {302,0.03817822}, {303,0.03873267}, {304,0.03842574}, {305,0.05734653}, {306,0.05411881}, {307,0.04845545}, {308,0.04606931}, {309,0.04382178}, {310,0.04061386}, {311,0.03920792}, {312,0.03916832}, {313,0.03950495}, {314,0.04161386}, {315,0.04984158}, {316,0.04519802}, {317,0.04025743}, {318,0.04022772}, {319,0.04056436}, {320,0.05128713}, {321,0.04557426}, {322,0.04034653}, {323,0.04073267}, {324,0.05410891}, {325,0.04745545}, {326,0.04156436}, {327,0.04154455}, {328,0.05216832}, {329,0.04517822}, {330,0.04127723}, {331,0.06211881}, {332,0.04946535}, {333,0.04226733}, {334,0.05791089}, {335,0.04725743}, {336,0.04240594}, {337,0.05530693}, {338,0.04425743}, {339,0.04279208}, {340,0.04991089}, {341,0.04331683}, {342,0.05515842}, {343,0.04382178}, {344,0.05802970}, {345,0.04596040}, {346,0.04385149}, {347,0.04755446}, {348,0.04415842}, {349,0.04841584}, {350,0.04436634}, {351,0.04807921}, {352,0.04406931}, {353,0.04698020}, {354,0.05840594}, {355,0.04496040}, {356,0.05572277}, {357,0.04523762}, {358,0.05647525}, {359,0.04544554}, {360,0.04834653}, {361,0.06015842}, {362,0.04555446}, {363,0.05273267}, {364,0.04623762}, {365,0.04594059}, {366,0.05386139}, {367,0.04645545}, {368,0.04646535}, {369,0.05263366}, {370,0.05897030}, {371,0.04697030}, {372,0.04940594}, {373,0.05644554}, {374,0.04739604}, {375,0.04742574}, {376,0.04998020}, {377,0.05618812}, {378,0.06160396}, {379,0.04784158}, {380,0.04830693}, {381,0.05329703}, {382,0.05852475}, {383,0.06206931}, {384,0.04830693}, {385,0.04830693}, {386,0.04866337}, {387,0.05139604}, {388,0.05486139}, {389,0.05819802}, {390,0.06161386}, {391,0.06355446}, {392,0.06527723}, {393,0.04972277}, {394,0.04990099}, {395,0.05032673}, {396,0.04963366}, {397,0.05023762}, {398,0.05060396}, {399,0.05031683}, {400,0.05042574}, {401,0.05041584}, {402,0.05034653}, {403,0.05138614}, {404,0.05095050}, {405,0.05141584}, {406,0.05125743}, {407,0.05187129}, {408,0.06737624}, {409,0.06585149}, {410,0.06325743}, {411,0.06102970}, {412,0.05783168}, {413,0.05506931}, {414,0.05254455}, {415,0.05280198}, {416,0.05485149}, {417,0.07235644}, {418,0.06435644}, {419,0.05760396}, {420,0.05292079}, {421,0.05304950}, {422,0.07006931}, {423,0.06309901}, {424,0.05621782}, {425,0.05343564}, {426,0.06970297}, {427,0.06291089}, {428,0.05576238}, {429,0.05453465}, {430,0.06665347}, {431,0.05905941}, {432,0.05454455}, {433,0.07213861}, {434,0.06300990}, {435,0.05515842}, {436,0.07028713}, {437,0.06000990}, {438,0.05538614}, {439,0.06652475}, {440,0.05571287}, {441,0.07211881}, {442,0.06059406}, {443,0.05616832}, {444,0.06407921}, {445,0.05617822}, {446,0.06644554}, {447,0.05668317}, {448,0.06817822}, {449,0.05633663}, {450,0.07069307}, {451,0.05723762}, {452,0.07471287}, {453,0.05747525}, {454,0.07137624}, {455,0.05782178}, {456,0.06834653}, {457,0.05781188}, {458,0.06523762}, {459,0.07609901}, {460,0.06046535}, {461,0.07095050}, {462,0.05864356}, {463,0.06543564}, {464,0.07410891}, {465,0.05867327}, {466,0.06992079}, {467,0.08503960}, {468,0.05920792}, {469,0.06937624}, {470,0.07855446}, {471,0.05980198}, {472,0.06671287}, {473,0.07360396}, {474,0.06003960}, {475,0.06155446}, {476,0.06758416}, {477,0.07365347}, {478,0.07922772}, {479,0.06087129}, {480,0.06566337}, {481,0.07515842}, {482,0.08063366}, {483,0.08332673}, {484,0.06146535}, {485,0.06394059}, {486,0.06878218}, {487,0.07223762}, {488,0.07498020}, {489,0.07808911}, {490,0.08064356}, {491,0.06214851}, {492,0.06210891}, {493,0.06243564}, {494,0.06626733}, {495,0.06683168}, {496,0.06872277}, {497,0.07059406}, {498,0.07092079}, {499,0.07181188}, {500,0.07206931}, {505,0.07200000}, {510,0.07035644}, {515,0.06734653}, {520,0.06572277}, {525,0.08480198}, {530,0.08044554}, {535,0.07455446}, {540,0.09171287}, {545,0.08113861}, {550,0.06970297}, {555,0.08208911}, {560,0.09264356}, {565,0.07903960}, {570,0.08752475}, {575,0.09931683}, {580,0.07899010}, {585,0.08665347}, {590,0.08886139}, {595,0.09085149}, {600,0.09329703}, {605,0.09249505}, {610,0.09123762}, {615,0.08919802}, {620,0.08797030}, {625,0.08339604}, {630,0.10371287}, {635,0.09239604}, {640,0.08605941}, {645,0.10134653}, {650,0.09091089}, {655,0.10316832}, {660,0.09094059}, {665,0.10962376}, {670,0.11399010}, {675,0.09461386}, {680,0.10252475}, {685,0.10656436}, {690,0.11023762}, {695,0.11318812}, {700,0.12895050}, {705,0.12051485}, {710,0.11887129}, {715,0.11542574}, {720,0.11099010}, {725,0.10800990}, {730,0.10835644}, {735,0.12469307}, {740,0.11448515}, {745,0.10400000}, {750,0.11700990}, {755,0.10570297}, {760,0.12715842}, {765,0.13279208}, {770,0.11287129}, {775,0.12164356}, {780,0.12772277}, {785,0.10958416}, {790,0.12144554}, {795,0.12068317}, {800,0.12165347}, {805,0.12112871}, {810,0.12123762}, {815,0.11596040}, {820,0.11872277}, {825,0.11376238}, {830,0.13381188}, {835,0.12498020}, {840,0.11784158}, {845,0.13887129}, {850,0.12543564}, {855,0.13799010}, {860,0.12493069}, {865,0.14719802}, {870,0.12291089}, {875,0.13112871}, {880,0.13601980}, {885,0.14200990}, {890,0.15688119}, {895,0.12704950}, {900,0.12699010}, {905,0.12727723}, {910,0.12744554}, {915,0.13138614}, {920,0.15241584}, {925,0.14511881}, {930,0.13899010}, {935,0.13322772}, {940,0.15523762}, {945,0.14437624}, {950,0.13198020}, {955,0.14393069}, {960,0.14002970}, {965,0.14761386}, {970,0.15447525}, {975,0.13841584}, {980,0.15453465}, {985,0.15201980}, {990,0.15694059}, {995,0.15900990}, {1000,0.17768317}, {1010,0.16075248}, {1020,0.16117822}, {1030,0.15818812}, {1040,0.15677228}, {1050,0.17402970}, {1060,0.15910891}, {1070,0.18273267}, {1080,0.16004950}, {1090,0.16239604}, {1100,0.16716832}, {1110,0.17434653}, {1120,0.17081188}, {1130,0.16557426}, {1140,0.20272277}, {1150,0.17797030}, {1160,0.18863366}, {1170,0.17232673}, {1180,0.19000990}, {1190,0.19236634}, {1200,0.18293069}, {1210,0.17948515}, {1220,0.19777228}, {1230,0.20626733}, {1240,0.18888119}, {1250,0.18115842}, {1260,0.21414851}, {1270,0.21168317}, {1280,0.19081188}, {1290,0.20570297}, {1300,0.20706931}, {1310,0.20565347}, {1320,0.21275248}, {1330,0.20308911}, {1340,0.21406931}, {1350,0.22031683}, {1360,0.20462376}, {1370,0.22464356}, {1380,0.20427723}, {1390,0.20860396}, {1400,0.21814851}, {1410,0.21392079}, {1420,0.22423762}, {1430,0.21541584}, {1440,0.22976238}, {1450,0.22289109}, {1460,0.21572277}, {1470,0.23392079}, {1480,0.23419802}, {1490,0.23459406}, {1500,0.22676238}, {1510,0.22436634}, {1520,0.22005941}, {1530,0.24392079}, {1540,0.24711881}, {1550,0.23387129}, {1560,0.26329703}, {1570,0.23746535}, {1580,0.27315842}, {1590,0.25754455}, {1600,0.24538614}, {1610,0.24364356}, {1620,0.25121782}, {1630,0.26555446}, {1640,0.26439604}, {1650,0.25486139}, {1660,0.25866337}, {1670,0.25651485}, {1680,0.26126733}, {1690,0.27484158}, {1700,0.25136634}, {1710,0.25930693}, {1720,0.24926733}, {1730,0.27964356}, {1740,0.29884158}, {1750,0.26682178}, {1760,0.29295050}, {1770,0.26690099}, {1780,0.28884158}, {1790,0.28336634}, {1800,0.28642574}, {1810,0.26808911}, {1820,0.27817822}, {1830,0.28958416}, {1840,0.29145545}, {1850,0.30854455}, {1860,0.29594059}, {1870,0.29512871}, {1880,0.29605941}, {1890,0.31368317}, {1900,0.28256436}, {1910,0.29022772}, {1920,0.29988119}, {1930,0.30861386}, {1940,0.31395050}, {1950,0.29101980}, {1960,0.31466337}, {1970,0.31120792}, {1980,0.31067327}, {1990,0.31162376}, {2000,0.30785149}, {2050,0.30704950}, {2100,0.33084158}, {2150,0.32513861}, {2200,0.34443564}, {2250,0.35907921}, {2300,0.35425743}, {2350,0.36210891}, {2400,0.38631683}, {2450,0.39686139}, {2500,0.43245545}, {2550,0.39754455}, {2600,0.39733663}, {2650,0.42264356}, {2700,0.42383168}, {2750,0.42143564}, {2800,0.45046535}, {2850,0.47370297}, {2900,0.48211881}, {2950,0.49398020}, {3000,0.51568317}, {3050,0.51030693}, {3100,0.53614851}, {3150,0.53134653}, {3200,0.52469307}, {3250,0.51722772}, {3300,0.53801980}, {3350,0.54079208}, {3400,0.55597030}, {3450,0.56317822}, {3500,0.58202970}, {3550,0.59140594}, {3600,0.58603960}, {3650,0.58412871}, {3700,0.59248515}, {3750,0.59325743}, {3800,0.60761386}, {3850,0.60457426}, {3900,0.63605941}, {3950,0.66549505}, {4000,0.62682178}, {4050,0.66131683}, {4100,0.65203960}, {4150,0.67916832}, {4200,0.69593069}, {4250,0.68744554}, {4300,0.68410891}, {4350,0.70513861}, {4400,0.70607921}, {4450,0.71216832}, {4500,0.75506931}, {4550,0.73816832}, {4600,0.74070297}, {4650,0.75637624}, {4700,0.75463366}, {4750,0.77769307}, {4800,0.77530693}, {4850,0.80286139}, {4900,0.78054455}, {4950,0.82905941}, {5000,0.80563366}, {5050,0.82807921}, {5100,0.82393069}, {5150,0.84869307}, {5200,0.84386139}, {5250,0.86630693}, {5300,0.87650495}, {5350,0.86819802}, {5400,0.89176238}, {5450,0.88325743}, {5500,0.88450495}, {5550,0.92905941}, {5600,0.89646535}, {5650,0.90688119}, {5700,0.93979208}, {5750,0.95146535}, {5800,0.92578218}, {5850,0.96289109}, {5900,0.95210891}, {5950,0.97186139}, {6000,0.98520792}, {6050,1.0252857}, {6100,1.0532286}, {6150,1.0373143}, {6200,1.0263714}, {6250,1.0334000}, {6300,1.0566571}, {6350,1.0813429}, {6400,1.0840571}, {6450,1.0976000}, {6500,1.0976000}, {6550,1.1085429}, {6600,1.1187429}, {6650,1.1313143}, {6700,1.1415143}, {6750,1.1594286}, {6800,1.1546571}, {6850,1.1621429}, {6900,1.1866571}, {6950,1.1902571}, {7000,1.2097429}, {7050,1.2051143}, {7100,1.2040571}, {7150,1.2221429}, {7200,1.1982000}, {7250,1.2136000}, {7300,1.2076857}, {7350,1.2288286}, {7400,1.2641714}, {7450,1.2924000}, {7500,1.3054857}, {7550,1.3120857}, {7600,1.2905714}, {7650,1.3200571}, {7700,1.2881714}, {7750,1.3014286}, {7800,1.3758571}, {7850,1.3651714}, {7900,1.3484000}, {7950,1.3641429}, {8000,1.3361714}, {8050,1.3821714}, {8100,1.4266286}, {8150,1.3893429}, {8200,1.3837714}, {8250,1.3791429}, {8300,1.4423143}, {8350,1.4462000}, {8400,1.4255714}, {8450,1.4241714}, {8500,1.4661143}, {8550,1.4797429}, {8600,1.4796857}, {8650,1.4617429}, {8700,1.5230000}, {8750,1.5122857}, {8800,1.4717143}, {8850,1.5471143}, {8900,1.5171714}, {8950,1.4961714}, {9000,1.5687714}, {9050,1.5516286}, {9100,1.5378286}, {9150,1.5978571}, {9200,1.5857429}, {9250,1.5681143}, {9300,1.6170857}, {9350,1.6026857}, {9400,1.6192286}, {9450,1.6320857}, {9500,1.6045429}, {9550,1.6382286}, {9600,1.6150857}, {9650,1.6776286}, {9700,1.6477714}, {9750,1.7084571}, {9800,1.6824571}, {9850,1.7246000}, {9900,1.6928286}, {9950,1.7544000}, {10000,1.6862857}, {10100,1.7715714}, {10200,1.7407429}, {10300,1.8072286}, {10400,1.7445429}, {10500,1.8283714}, {10600,1.7681714}, {10700,1.8316857}, {10800,1.8320286}, {10900,1.8796571}, {11000,1.8690286}, {11100,1.9257143}, {11200,1.8864857}, {11300,1.9312000}, {11400,1.9186857}, {11500,1.9738286}, {11600,1.9771143}, {11700,1.9886286}, {11800,2.0093714}, {11900,2.0271429}, {12000,2.0334857}, {12100,2.0760857}, {12200,2.0744286}, {12300,2.1045429}, {12400,2.1175143}, {12500,2.1225714}, {12600,2.1268286}, {12700,2.1574571}, {12800,2.1633429}, {12900,2.2808000}, {13000,2.1980857}, {13100,2.2222571}, {13200,2.2568000}, {13300,2.2593714}, {13400,2.2524000}, {13500,2.3070571}, {13600,2.3136286}, {13700,2.3218286}, {13800,2.3310000}, {13900,2.3649143}, {14000,2.3797143}, {14100,2.4572571}, {14200,2.4224571}, {14300,2.4297714}, {14400,2.4323143}, {14500,2.5398857}, {14600,2.4707429}, {14700,2.8476857}, {14800,2.7933143}, {14900,2.6148571}, {15000,2.5419714}, {15100,2.5690857}, {15200,2.5798286}, {15300,2.6910000}, {15400,2.8136286}, {15500,2.7117143}, {15600,2.9471429}, {15700,2.6731714}, {15800,2.7711143}, {15900,2.7011429}, {16000,2.7813143}, {16100,2.7871714}, {16200,2.8038857}, {16300,2.8408000}, {16400,2.8477714}, {16500,3.1224571}, {16600,2.7877429}, {16700,2.8253143}, {16800,2.9064286}, {16900,2.8439714}, {17000,2.9615429}, {17100,2.9734000}, {17200,2.9364857}, {17300,3.0011429}, {17400,2.9946571}, {17500,2.9514286}, {17600,3.0678286}, {17700,3.0050571}, {17800,3.0069714}, {17900,3.0450286}, {18000,3.0416286}, {18100,3.0860857}, {18200,3.0997429}, {18300,3.1150000}, {18400,3.0956857}, {18500,3.1239714}, {18600,3.1345143}, {18700,3.1650571}, {18800,3.1851714}, {18900,3.2262571}, {19000,3.2368000}, {19100,3.2597143}, {19200,3.3327143}, {19300,3.2839429}, {19400,3.2896286}, {19500,3.3855143}, {19600,3.3968000}, {19700,3.4989143}, {19800,3.3541143}, {19900,3.4625714}, {20000,3.4936286}};
data["big_flat"]["LtacTacInTermPrimPair"]["norm reif"]["user"] = {{1,0.00032673}, {2,0.00029703}, {3,0.00046535}, {4,0.00063366}, {5,0.00073267}, {6,0.00109901}, {7,0.00094059}, {8,0.00129703}, {9,0.00100990}, {10,0.00107921}, {11,0.00106931}, {12,0.00174257}, {13,0.00142574}, {14,0.00156436}, {15,0.00160396}, {16,0.00181188}, {17,0.00180198}, {18,0.00212871}, {19,0.00228713}, {20,0.00218812}, {21,0.00238614}, {22,0.00251485}, {23,0.00285149}, {24,0.00274257}, {25,0.00300990}, {26,0.00263366}, {27,0.00305941}, {28,0.00306931}, {29,0.00325743}, {30,0.00342574}, {31,0.00376238}, {32,0.00356436}, {33,0.00378218}, {34,0.00379208}, {35,0.00429703}, {36,0.00428713}, {37,0.00440594}, {38,0.00469307}, {39,0.00698020}, {40,0.00458416}, {41,0.00514851}, {42,0.00528713}, {43,0.00517822}, {44,0.00537624}, {45,0.00555446}, {46,0.00567327}, {47,0.00604950}, {48,0.00628713}, {49,0.00591089}, {50,0.00639604}, {51,0.00816832}, {52,0.00635644}, {53,0.00687129}, {54,0.00683168}, {55,0.00687129}, {56,0.00711881}, {57,0.00713861}, {58,0.00714851}, {59,0.00740594}, {60,0.00750495}, {61,0.00739604}, {62,0.00759406}, {63,0.00771287}, {64,0.00771287}, {65,0.00791089}, {66,0.00828713}, {67,0.00798020}, {68,0.00818812}, {69,0.00864356}, {70,0.00865347}, {71,0.00847525}, {72,0.00844554}, {73,0.00920792}, {74,0.00902970}, {75,0.00902970}, {76,0.00908911}, {77,0.00935644}, {78,0.00983168}, {79,0.00968317}, {80,0.01011881}, {81,0.01012871}, {82,0.01033663}, {83,0.01476238}, {84,0.01028713}, {85,0.01050495}, {86,0.01059406}, {87,0.01095050}, {88,0.01059406}, {89,0.01124752}, {90,0.01115842}, {91,0.01160396}, {92,0.01131683}, {93,0.01160396}, {94,0.01169307}, {95,0.01189109}, {96,0.01184158}, {97,0.01224752}, {98,0.01200990}, {99,0.01227723}, {100,0.01260396}, {101,0.01261386}, {102,0.01284158}, {103,0.01310891}, {104,0.01291089}, {105,0.01307921}, {106,0.01337624}, {107,0.01324752}, {108,0.01387129}, {109,0.01711881}, {110,0.01391089}, {111,0.01385149}, {112,0.01392079}, {113,0.01408911}, {114,0.01433663}, {115,0.01901980}, {116,0.01464356}, {117,0.01470297}, {118,0.01483168}, {119,0.01486139}, {120,0.01746535}, {121,0.01548515}, {122,0.01547525}, {123,0.01539604}, {124,0.01737624}, {125,0.01606931}, {126,0.01592079}, {127,0.02098020}, {128,0.01619802}, {129,0.01645545}, {130,0.02225743}, {131,0.01645545}, {132,0.01685149}, {133,0.02113861}, {134,0.01691089}, {135,0.01681188}, {136,0.01783168}, {137,0.01705941}, {138,0.02318812}, {139,0.01741584}, {140,0.01725743}, {141,0.01757426}, {142,0.01769307}, {143,0.01757426}, {144,0.01757426}, {145,0.02003960}, {146,0.01774257}, {147,0.02064356}, {148,0.01817822}, {149,0.02052475}, {150,0.01818812}, {151,0.01871287}, {152,0.01853465}, {153,0.01885149}, {154,0.01876238}, {155,0.01878218}, {156,0.02396040}, {157,0.01920792}, {158,0.01914851}, {159,0.01933663}, {160,0.01936634}, {161,0.02200000}, {162,0.01974257}, {163,0.02001980}, {164,0.02334653}, {165,0.02007921}, {166,0.02041584}, {167,0.02241584}, {168,0.02061386}, {169,0.02087129}, {170,0.02086139}, {171,0.02630693}, {172,0.02117822}, {173,0.02075248}, {174,0.02168317}, {175,0.02553465}, {176,0.02199010}, {177,0.02208911}, {178,0.02200990}, {179,0.02207921}, {180,0.02613861}, {181,0.03123762}, {182,0.02266337}, {183,0.02284158}, {184,0.02299010}, {185,0.02329703}, {186,0.02288119}, {187,0.02517822}, {188,0.02830693}, {189,0.03141584}, {190,0.02376238}, {191,0.02408911}, {192,0.02396040}, {193,0.02402970}, {194,0.02424752}, {195,0.02448515}, {196,0.02430693}, {197,0.02492079}, {198,0.02489109}, {199,0.02479208}, {200,0.02491089}, {201,0.02505941}, {202,0.02519802}, {203,0.02542574}, {204,0.02515842}, {205,0.03427723}, {206,0.03255446}, {207,0.02872277}, {208,0.02792079}, {209,0.02594059}, {210,0.02605941}, {211,0.02590099}, {212,0.02689109}, {213,0.02643564}, {214,0.03698020}, {215,0.03023762}, {216,0.02671287}, {217,0.02738614}, {218,0.02660396}, {219,0.03626733}, {220,0.03000000}, {221,0.02749505}, {222,0.02775248}, {223,0.03829703}, {224,0.03122772}, {225,0.02773267}, {226,0.02776238}, {227,0.03682178}, {228,0.02832673}, {229,0.02831683}, {230,0.03803960}, {231,0.03027723}, {232,0.02905941}, {233,0.03819802}, {234,0.02872277}, {235,0.02916832}, {236,0.03613861}, {237,0.02939604}, {238,0.02975248}, {239,0.03142574}, {240,0.02970297}, {241,0.03619802}, {242,0.03039604}, {243,0.03922772}, {244,0.03006931}, {245,0.03129703}, {246,0.03067327}, {247,0.03065347}, {248,0.03027723}, {249,0.03124752}, {250,0.03120792}, {251,0.03232673}, {252,0.03182178}, {253,0.04132673}, {254,0.03165347}, {255,0.03771287}, {256,0.03202970}, {257,0.03357426}, {258,0.03213861}, {259,0.03217822}, {260,0.03975248}, {261,0.03237624}, {262,0.03268317}, {263,0.04358416}, {264,0.03272277}, {265,0.03449505}, {266,0.04311881}, {267,0.03380198}, {268,0.03349505}, {269,1.02317822}, {270,0.03439604}, {271,0.03383168}, {272,0.03984158}, {273,0.05017822}, {274,0.03437624}, {275,0.03489109}, {276,0.03806931}, {277,0.04538614}, {278,0.03538614}, {279,0.03541584}, {280,0.03541584}, {281,0.03904950}, {282,0.04409901}, {283,0.03691089}, {284,0.03600990}, {285,0.03615842}, {286,0.03630693}, {287,0.03650495}, {288,0.03866337}, {289,0.04230693}, {290,0.04481188}, {291,0.04747525}, {292,0.04863366}, {293,0.03717822}, {294,0.03753465}, {295,0.03720792}, {296,0.03700000}, {297,0.03736634}, {298,0.03715842}, {299,0.03761386}, {300,0.03803960}, {301,0.03810891}, {302,0.03810891}, {303,0.03869307}, {304,0.03842574}, {305,0.05701980}, {306,0.05364356}, {307,0.04832673}, {308,0.04637624}, {309,0.04357426}, {310,0.04034653}, {311,0.03896040}, {312,0.03914851}, {313,0.03904950}, {314,0.04134653}, {315,0.04961386}, {316,0.04509901}, {317,0.03999010}, {318,0.04003960}, {319,0.04024752}, {320,0.05074257}, {321,0.04559406}, {322,0.04002970}, {323,0.04013861}, {324,0.05349505}, {325,0.04754455}, {326,0.04124752}, {327,0.04107921}, {328,0.05156436}, {329,0.04504950}, {330,0.04081188}, {331,0.06223762}, {332,0.04925743}, {333,0.04195050}, {334,0.05794059}, {335,0.04706931}, {336,0.04199010}, {337,0.05510891}, {338,0.04432673}, {339,0.04257426}, {340,0.04997030}, {341,0.04318812}, {342,0.05494059}, {343,0.04377228}, {344,0.05833663}, {345,0.04582178}, {346,0.04353465}, {347,0.04768317}, {348,0.04402970}, {349,0.04841584}, {350,0.04420792}, {351,0.04811881}, {352,0.04393069}, {353,0.04742574}, {354,0.05835644}, {355,0.04471287}, {356,0.05577228}, {357,0.04514851}, {358,0.05602970}, {359,0.04536634}, {360,0.04845545}, {361,0.06013861}, {362,0.04591089}, {363,0.05243564}, {364,0.04627723}, {365,0.04585149}, {366,0.05340594}, {367,0.04635644}, {368,0.04639604}, {369,0.05264356}, {370,0.05851485}, {371,0.04695050}, {372,0.04989109}, {373,0.05611881}, {374,0.04792079}, {375,0.04753465}, {376,0.05000000}, {377,0.05620792}, {378,0.06125743}, {379,0.04770297}, {380,0.04835644}, {381,0.05293069}, {382,0.05859406}, {383,0.06208911}, {384,0.04805941}, {385,0.04839604}, {386,0.04891089}, {387,0.05127723}, {388,0.05481188}, {389,0.05803960}, {390,0.06165347}, {391,0.06333663}, {392,0.06525743}, {393,0.05000000}, {394,0.04965347}, {395,0.05025743}, {396,0.04949505}, {397,0.05033663}, {398,0.05046535}, {399,0.05036634}, {400,0.05032673}, {401,0.05041584}, {402,0.05045545}, {403,0.05133663}, {404,0.05114851}, {405,0.05132673}, {406,0.05140594}, {407,0.05167327}, {408,0.06712871}, {409,0.06567327}, {410,0.06313861}, {411,0.06113861}, {412,0.05765347}, {413,0.05517822}, {414,0.05242574}, {415,0.05242574}, {416,0.05467327}, {417,0.07251485}, {418,0.06428713}, {419,0.05773267}, {420,0.05287129}, {421,0.05308911}, {422,0.06991089}, {423,0.06288119}, {424,0.05605941}, {425,0.05312871}, {426,0.06940594}, {427,0.06285149}, {428,0.05519802}, {429,0.05439604}, {430,0.06643564}, {431,0.05895050}, {432,0.05442574}, {433,0.07173267}, {434,0.06286139}, {435,0.05467327}, {436,0.07012871}, {437,0.06044554}, {438,0.05517822}, {439,0.06637624}, {440,0.05524752}, {441,0.07219802}, {442,0.06070297}, {443,0.05579208}, {444,0.06356436}, {445,0.05598020}, {446,0.06612871}, {447,0.05665347}, {448,0.06784158}, {449,0.05616832}, {450,0.07033663}, {451,0.05721782}, {452,0.07445545}, {453,0.05707921}, {454,0.07102970}, {455,0.05770297}, {456,0.06797030}, {457,0.05763366}, {458,0.06493069}, {459,0.07594059}, {460,0.06067327}, {461,0.07108911}, {462,0.05824752}, {463,0.06521782}, {464,0.07417822}, {465,0.05885149}, {466,0.06991089}, {467,0.08462376}, {468,0.05895050}, {469,0.06913861}, {470,0.07831683}, {471,0.06026733}, {472,0.06626733}, {473,0.07347525}, {474,0.06018812}, {475,0.06149505}, {476,0.06754455}, {477,0.07339604}, {478,0.07880198}, {479,0.06127723}, {480,0.06552475}, {481,0.07499010}, {482,0.08052475}, {483,0.08310891}, {484,0.06168317}, {485,0.06379208}, {486,0.06866337}, {487,0.07234653}, {488,0.07490099}, {489,0.07761386}, {490,0.08057426}, {491,0.06197030}, {492,0.06203960}, {493,0.06251485}, {494,0.06549505}, {495,0.06647525}, {496,0.06867327}, {497,0.07092079}, {498,0.07077228}, {499,0.07188119}, {500,0.07212871}, {505,0.07216832}, {510,0.07011881}, {515,0.06687129}, {520,0.06546535}, {525,0.08475248}, {530,0.08025743}, {535,0.07456436}, {540,0.09164356}, {545,0.08103960}, {550,0.06958416}, {555,0.08225743}, {560,0.09276238}, {565,0.07903960}, {570,0.08730693}, {575,0.09929703}, {580,0.07881188}, {585,0.08655446}, {590,0.08848515}, {595,0.09095050}, {600,0.09307921}, {605,0.09250495}, {610,0.09097030}, {615,0.08891089}, {620,0.08768317}, {625,0.08329703}, {630,0.10333663}, {635,0.09234653}, {640,0.08584158}, {645,0.10136634}, {650,0.09058416}, {655,0.10287129}, {660,0.09029703}, {665,0.10931683}, {670,0.11378218}, {675,0.09470297}, {680,0.10221782}, {685,0.10672277}, {690,0.10987129}, {695,0.11300990}, {700,0.12860396}, {705,0.12025743}, {710,0.11840594}, {715,0.11500990}, {720,0.11055446}, {725,0.10760396}, {730,0.10815842}, {735,0.12444554}, {740,0.11426733}, {745,0.10387129}, {750,0.11654455}, {755,0.10585149}, {760,0.12672277}, {765,0.13275248}, {770,0.11287129}, {775,0.12152475}, {780,0.12746535}, {785,0.10935644}, {790,0.12117822}, {795,0.12045545}, {800,0.12147525}, {805,0.12078218}, {810,0.12096040}, {815,0.11564356}, {820,0.11856436}, {825,0.11336634}, {830,0.13329703}, {835,0.12482178}, {840,0.11797030}, {845,0.13845545}, {850,0.12555446}, {855,0.13775248}, {860,0.12427723}, {865,0.14717822}, {870,0.12232673}, {875,0.13111881}, {880,0.13551485}, {885,0.14169307}, {890,0.15635644}, {895,0.12690099}, {900,0.12669307}, {905,0.12694059}, {910,0.12768317}, {915,0.13136634}, {920,0.15212871}, {925,0.14495050}, {930,0.13876238}, {935,0.13294059}, {940,0.15510891}, {945,0.14411881}, {950,0.13204950}, {955,0.14367327}, {960,0.13998020}, {965,0.14731683}, {970,0.15439604}, {975,0.13828713}, {980,0.15423762}, {985,0.15167327}, {990,0.15651485}, {995,0.15869307}, {1000,0.17726733}, {1010,0.16036634}, {1020,0.16105941}, {1030,0.15790099}, {1040,0.15609901}, {1050,0.17358416}, {1060,0.15874257}, {1070,0.18238614}, {1080,0.15970297}, {1090,0.16253465}, {1100,0.16686139}, {1110,0.17359406}, {1120,0.17012871}, {1130,0.16545545}, {1140,0.20231683}, {1150,0.17788119}, {1160,0.18829703}, {1170,0.17190099}, {1180,0.18984158}, {1190,0.19199010}, {1200,0.18246535}, {1210,0.17900000}, {1220,0.19692079}, {1230,0.20579208}, {1240,0.18838614}, {1250,0.18030693}, {1260,0.21351485}, {1270,0.21111881}, {1280,0.19007921}, {1290,0.20500990}, {1300,0.20638614}, {1310,0.20513861}, {1320,0.21213861}, {1330,0.20252475}, {1340,0.21362376}, {1350,0.21936634}, {1360,0.20370297}, {1370,0.22399010}, {1380,0.20360396}, {1390,0.20841584}, {1400,0.21772277}, {1410,0.21305941}, {1420,0.22392079}, {1430,0.21494059}, {1440,0.22913861}, {1450,0.22210891}, {1460,0.21528713}, {1470,0.23307921}, {1480,0.23330693}, {1490,0.23396040}, {1500,0.22626733}, {1510,0.22365347}, {1520,0.21944554}, {1530,0.24294059}, {1540,0.24634653}, {1550,0.23334653}, {1560,0.26240594}, {1570,0.23641584}, {1580,0.27205941}, {1590,0.25717822}, {1600,0.24510891}, {1610,0.24295050}, {1620,0.25076238}, {1630,0.26436634}, {1640,0.26344554}, {1650,0.25402970}, {1660,0.25809901}, {1670,0.25609901}, {1680,0.26061386}, {1690,0.27422772}, {1700,0.25083168}, {1710,0.25857426}, {1720,0.24857426}, {1730,0.27870297}, {1740,0.29800990}, {1750,0.26609901}, {1760,0.29217822}, {1770,0.26620792}, {1780,0.28799010}, {1790,0.28225743}, {1800,0.28570297}, {1810,0.26769307}, {1820,0.27750495}, {1830,0.28867327}, {1840,0.29083168}, {1850,0.30776238}, {1860,0.29477228}, {1870,0.29434653}, {1880,0.29513861}, {1890,0.31264356}, {1900,0.28181188}, {1910,0.28974257}, {1920,0.29923762}, {1930,0.30780198}, {1940,0.31306931}, {1950,0.29038614}, {1960,0.31392079}, {1970,0.31080198}, {1980,0.30975248}, {1990,0.31050495}, {2000,0.30692079}, {2050,0.30600990}, {2100,0.33013861}, {2150,0.32421782}, {2200,0.34369307}, {2250,0.35832673}, {2300,0.35316832}, {2350,0.36139604}, {2400,0.38573267}, {2450,0.39555446}, {2500,0.43156436}, {2550,0.39681188}, {2600,0.39637624}, {2650,0.42179208}, {2700,0.42276238}, {2750,0.42042574}, {2800,0.44899010}, {2850,0.47288119}, {2900,0.48081188}, {2950,0.49265347}, {3000,0.51457426}, {3050,0.50925743}, {3100,0.53102970}, {3150,0.53028713}, {3200,0.52380198}, {3250,0.51657426}, {3300,0.53735644}, {3350,0.53979208}, {3400,0.55501980}, {3450,0.56187129}, {3500,0.58089109}, {3550,0.59000990}, {3600,0.58493069}, {3650,0.58323762}, {3700,0.59178218}, {3750,0.59246535}, {3800,0.60641584}, {3850,0.60345545}, {3900,0.63504950}, {3950,0.66425743}, {4000,0.62565347}, {4050,0.65985149}, {4100,0.65077228}, {4150,0.67828713}, {4200,0.69511881}, {4250,0.68633663}, {4300,0.68295050}, {4350,0.70386139}, {4400,0.70479208}, {4450,0.71100000}, {4500,0.75400990}, {4550,0.73687129}, {4600,0.73925743}, {4650,0.75488119}, {4700,0.75307921}, {4750,0.77610891}, {4800,0.77370297}, {4850,0.80095050}, {4900,0.77916832}, {4950,0.82733663}, {5000,0.80384158}, {5050,0.82674257}, {5100,0.82225743}, {5150,0.84754455}, {5200,0.84173267}, {5250,0.86450495}, {5300,0.87479208}, {5350,0.86639604}, {5400,0.89003960}, {5450,0.88130693}, {5500,0.88262376}, {5550,0.92743564}, {5600,0.89452475}, {5650,0.90490099}, {5700,0.93805941}, {5750,0.94977228}, {5800,0.92402970}, {5850,0.96137624}, {5900,0.95026733}, {5950,0.97012871}, {6000,0.98319802}, {6050,1.0234571}, {6100,1.0452571}, {6150,1.0366286}, {6200,1.0254000}, {6250,1.0265429}, {6300,1.0558000}, {6350,1.0800857}, {6400,1.0826857}, {6450,1.0970286}, {6500,1.0960000}, {6550,1.1073714}, {6600,1.1178857}, {6650,1.1302571}, {6700,1.1405429}, {6750,1.1568000}, {6800,1.1520857}, {6850,1.1611429}, {6900,1.1832857}, {6950,1.1880286}, {7000,1.2071429}, {7050,1.2031429}, {7100,1.1992571}, {7150,1.2207143}, {7200,1.1969714}, {7250,1.2121429}, {7300,1.2053429}, {7350,1.2225429}, {7400,1.2570571}, {7450,1.2909429}, {7500,1.3016571}, {7550,1.3092000}, {7600,1.2876857}, {7650,1.3137143}, {7700,1.2868000}, {7750,1.2954000}, {7800,1.3739429}, {7850,1.3615143}, {7900,1.3460857}, {7950,1.3616857}, {8000,1.3351429}, {8050,1.3798571}, {8100,1.4249143}, {8150,1.3878857}, {8200,1.3819429}, {8250,1.3778857}, {8300,1.4409143}, {8350,1.4444000}, {8400,1.4242571}, {8450,1.4220857}, {8500,1.4641714}, {8550,1.4778571}, {8600,1.4775143}, {8650,1.4602857}, {8700,1.5216571}, {8750,1.5107143}, {8800,1.4699429}, {8850,1.5450286}, {8900,1.5157714}, {8950,1.4944286}, {9000,1.5676571}, {9050,1.5503429}, {9100,1.5357143}, {9150,1.5963143}, {9200,1.5817143}, {9250,1.5634000}, {9300,1.6151714}, {9350,1.5998857}, {9400,1.6171714}, {9450,1.6302571}, {9500,1.6025714}, {9550,1.6362286}, {9600,1.6126571}, {9650,1.6748857}, {9700,1.6448000}, {9750,1.7060857}, {9800,1.6802571}, {9850,1.7228571}, {9900,1.6901714}, {9950,1.7510571}, {10000,1.6839143}, {10100,1.7696286}, {10200,1.7326286}, {10300,1.8050857}, {10400,1.7420571}, {10500,1.8261429}, {10600,1.7659143}, {10700,1.8292286}, {10800,1.8299143}, {10900,1.8766571}, {11000,1.8657429}, {11100,1.9226286}, {11200,1.8834000}, {11300,1.9277143}, {11400,1.9158286}, {11500,1.9710286}, {11600,1.9732571}, {11700,1.9859429}, {11800,2.0058857}, {11900,2.0240571}, {12000,2.0304000}, {12100,2.0724286}, {12200,2.0704857}, {12300,2.1010857}, {12400,2.1142571}, {12500,2.1189714}, {12600,2.1232000}, {12700,2.1535714}, {12800,2.1604857}, {12900,2.2766571}, {13000,2.1954000}, {13100,2.2184857}, {13200,2.2540571}, {13300,2.2559429}, {13400,2.2492571}, {13500,2.3043429}, {13600,2.3112000}, {13700,2.3188000}, {13800,2.3282571}, {13900,2.3620857}, {14000,2.3763143}, {14100,2.4539714}, {14200,2.4191143}, {14300,2.4270571}, {14400,2.4298857}, {14500,2.5372571}, {14600,2.4675714}, {14700,2.8440571}, {14800,2.7893714}, {14900,2.6112000}, {15000,2.5391429}, {15100,2.5663429}, {15200,2.5760286}, {15300,2.6868571}, {15400,2.8096571}, {15500,2.7081429}, {15600,2.9438857}, {15700,2.6698857}, {15800,2.7673143}, {15900,2.6981143}, {16000,2.7787429}, {16100,2.7840571}, {16200,2.8007143}, {16300,2.8368286}, {16400,2.8461714}, {16500,3.1197143}, {16600,2.7852286}, {16700,2.8220857}, {16800,2.9038000}, {16900,2.8415143}, {17000,2.9585429}, {17100,2.9694000}, {17200,2.9330571}, {17300,2.9974571}, {17400,2.9913714}, {17500,2.9483714}, {17600,3.0633429}, {17700,3.0018286}, {17800,3.0036571}, {17900,3.0420286}, {18000,3.0389714}, {18100,3.0826286}, {18200,3.0954286}, {18300,3.1110286}, {18400,3.0915429}, {18500,3.1199429}, {18600,3.1305143}, {18700,3.1601714}, {18800,3.1753714}, {18900,3.2060857}, {19000,3.2280286}, {19100,3.2472571}, {19200,3.3277429}, {19300,3.2788857}, {19400,3.2716857}, {19500,3.3690857}, {19600,3.3688000}, {19700,3.4795714}, {19800,3.3362857}, {19900,3.4593143}, {20000,3.4883429}};
data["big_flat"]["LtacTacInTermPrimPair"]["norm reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00006931}, {12,0.00000000}, {13,0.00000000}, {14,0.00002970}, {15,0.00000000}, {16,0.00000000}, {17,0.00003960}, {18,0.00002970}, {19,0.00000000}, {20,0.00003960}, {21,0.00000000}, {22,0.00000000}, {23,0.00003960}, {24,0.00003960}, {25,0.00000000}, {26,0.00003960}, {27,0.00000000}, {28,0.00011881}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00003960}, {33,0.00000000}, {34,0.00003960}, {35,0.00000000}, {36,0.00000000}, {37,0.00003960}, {38,0.00002970}, {39,0.00000000}, {40,0.00003960}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00002970}, {46,0.00000000}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00003960}, {51,0.00019802}, {52,0.00007921}, {53,0.00000000}, {54,0.00002970}, {55,0.00000000}, {56,0.00003960}, {57,0.00000000}, {58,0.00006931}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00003960}, {66,0.00000000}, {67,0.00000000}, {68,0.00003960}, {69,0.00003960}, {70,0.00003960}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00011881}, {76,0.00003960}, {77,0.00000000}, {78,0.00000000}, {79,0.00003960}, {80,0.00003960}, {81,0.00003960}, {82,0.00000000}, {83,0.00007921}, {84,0.00002970}, {85,0.00000000}, {86,0.00007921}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00003960}, {91,0.00003960}, {92,0.00000000}, {93,0.00003960}, {94,0.00000000}, {95,0.00009901}, {96,0.00003960}, {97,0.00000000}, {98,0.00009901}, {99,0.00003960}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00003960}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00007921}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00003960}, {113,0.00002970}, {114,0.00000000}, {115,0.00014851}, {116,0.00003960}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00003960}, {122,0.00000000}, {123,0.00011881}, {124,0.00010891}, {125,0.00000000}, {126,0.00002970}, {127,0.00000000}, {128,0.00003960}, {129,0.00000000}, {130,0.00011881}, {131,0.00003960}, {132,0.00003960}, {133,0.00010891}, {134,0.00000000}, {135,0.00000000}, {136,0.00007921}, {137,0.00011881}, {138,0.00003960}, {139,0.00003960}, {140,0.00003960}, {141,0.00000000}, {142,0.00002970}, {143,0.00002970}, {144,0.00000000}, {145,0.00010891}, {146,0.00003960}, {147,0.00002970}, {148,0.00000000}, {149,0.00006931}, {150,0.00002970}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00003960}, {155,0.00000000}, {156,0.00011881}, {157,0.00006931}, {158,0.00003960}, {159,0.00000000}, {160,0.00000000}, {161,0.00003960}, {162,0.00003960}, {163,0.00000000}, {164,0.00022772}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00003960}, {169,0.00000000}, {170,0.00000000}, {171,0.00024752}, {172,0.00007921}, {173,0.00000000}, {174,0.00000000}, {175,0.00006931}, {176,0.00003960}, {177,0.00007921}, {178,0.00007921}, {179,0.00003960}, {180,0.00003960}, {181,0.00015842}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00003960}, {188,0.00011881}, {189,0.00007921}, {190,0.00003960}, {191,0.00000000}, {192,0.00000000}, {193,0.00007921}, {194,0.00000000}, {195,0.00007921}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00003960}, {200,0.00011881}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00031683}, {206,0.00011881}, {207,0.00011881}, {208,0.00011881}, {209,0.00002970}, {210,0.00000000}, {211,0.00000000}, {212,0.00003960}, {213,0.00000000}, {214,0.00019802}, {215,0.00010891}, {216,0.00003960}, {217,0.00000000}, {218,0.00003960}, {219,0.00034653}, {220,0.00007921}, {221,0.00000000}, {222,0.00000000}, {223,0.00031683}, {224,0.00011881}, {225,0.00000000}, {226,0.00003960}, {227,0.00026733}, {228,0.00000000}, {229,0.00000000}, {230,0.00018812}, {231,0.00003960}, {232,0.00002970}, {233,0.00019802}, {234,0.00000000}, {235,0.00003960}, {236,0.00034653}, {237,0.00003960}, {238,0.00003960}, {239,0.00011881}, {240,0.00011881}, {241,0.00000000}, {242,0.00000000}, {243,0.00007921}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00003960}, {249,0.00000000}, {250,0.00003960}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00003960}, {256,0.00002970}, {257,0.00003960}, {258,0.00003960}, {259,0.00000000}, {260,0.00000000}, {261,0.00003960}, {262,0.00003960}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00003960}, {267,0.00000000}, {268,0.00000000}, {269,0.00234653}, {270,0.00000000}, {271,0.00000000}, {272,0.00015842}, {273,0.00000000}, {274,0.00000000}, {275,0.00007921}, {276,0.00000000}, {277,0.00003960}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003960}, {282,0.00000000}, {283,0.00000000}, {284,0.00003960}, {285,0.00000000}, {286,0.00003960}, {287,0.00003960}, {288,0.00000000}, {289,0.00003960}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00003960}, {294,0.00002970}, {295,0.00003960}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00003960}, {308,0.00002970}, {309,0.00003960}, {310,0.00007921}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00003960}, {317,0.00000000}, {318,0.00003960}, {319,0.00000000}, {320,0.00007921}, {321,0.00000000}, {322,0.00003960}, {323,0.00011881}, {324,0.00007921}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00003960}, {329,0.00003960}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00011881}, {334,0.00003960}, {335,0.00003960}, {336,0.00003960}, {337,0.00000000}, {338,0.00007921}, {339,0.00003960}, {340,0.00000000}, {341,0.00002970}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00003960}, {347,0.00003960}, {348,0.00003960}, {349,0.00011881}, {350,0.00003960}, {351,0.00011881}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00006931}, {356,0.00000000}, {357,0.00003960}, {358,0.00015842}, {359,0.00000000}, {360,0.00007921}, {361,0.00003960}, {362,0.00007921}, {363,0.00003960}, {364,0.00007921}, {365,0.00000000}, {366,0.00011881}, {367,0.00003960}, {368,0.00000000}, {369,0.00003960}, {370,0.00014851}, {371,0.00006931}, {372,0.00003960}, {373,0.00003960}, {374,0.00000000}, {375,0.00007921}, {376,0.00003960}, {377,0.00000000}, {378,0.00003960}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00003960}, {385,0.00003960}, {386,0.00000000}, {387,0.00000000}, {388,0.00003960}, {389,0.00003960}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00003960}, {399,0.00000000}, {400,0.00003960}, {401,0.00003960}, {402,0.00000000}, {403,0.00003960}, {404,0.00003960}, {405,0.00003960}, {406,0.00007921}, {407,0.00003960}, {408,0.00003960}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00003960}, {413,0.00003960}, {414,0.00000000}, {415,0.00000000}, {416,0.00002970}, {417,0.00000000}, {418,0.00003960}, {419,0.00000000}, {420,0.00000000}, {421,0.00003960}, {422,0.00003960}, {423,0.00003960}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00003960}, {429,0.00003960}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00003960}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00003960}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00003960}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00003960}, {446,0.00003960}, {447,0.00003960}, {448,0.00003960}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00003960}, {453,0.00003960}, {454,0.00000000}, {455,0.00003960}, {456,0.00003960}, {457,0.00000000}, {458,0.00007921}, {459,0.00000000}, {460,0.00000000}, {461,0.00003960}, {462,0.00000000}, {463,0.00007921}, {464,0.00000000}, {465,0.00003960}, {466,0.00000000}, {467,0.00007921}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00003960}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00002970}, {482,0.00000000}, {483,0.00000000}, {484,0.00007921}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00007921}, {492,0.00000000}, {493,0.00011881}, {494,0.00003960}, {495,0.00007921}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00003960}, {500,0.00000000}, {505,0.00007921}, {510,0.00007921}, {515,0.00000000}, {520,0.00003960}, {525,0.00003960}, {530,0.00003960}, {535,0.00003960}, {540,0.00000000}, {545,0.00003960}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00003960}, {570,0.00015842}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00003960}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00003960}, {645,0.00000000}, {650,0.00000000}, {655,0.00003960}, {660,0.00018812}, {665,0.00000000}, {670,0.00007921}, {675,0.00000000}, {680,0.00003960}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00007921}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00003960}, {730,0.00003960}, {735,0.00003960}, {740,0.00007921}, {745,0.00000000}, {750,0.00003960}, {755,0.00000000}, {760,0.00003960}, {765,0.00000000}, {770,0.00003960}, {775,0.00000000}, {780,0.00003960}, {785,0.00000000}, {790,0.00003960}, {795,0.00000000}, {800,0.00002970}, {805,0.00003960}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00010891}, {830,0.00003960}, {835,0.00000000}, {840,0.00000000}, {845,0.00003960}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00003960}, {870,0.00000000}, {875,0.00002970}, {880,0.00003960}, {885,0.00007921}, {890,0.00003960}, {895,0.00003960}, {900,0.00003960}, {905,0.00000000}, {910,0.00000000}, {915,0.00003960}, {920,0.00003960}, {925,0.00002970}, {930,0.00014851}, {935,0.00000000}, {940,0.00000000}, {945,0.00006931}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00007921}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00003960}, {990,0.00007921}, {995,0.00000000}, {1000,0.00011881}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00014851}, {1050,0.00000000}, {1060,0.00007921}, {1070,0.00003960}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00003960}, {1110,0.00003960}, {1120,0.00011881}, {1130,0.00000000}, {1140,0.00003960}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00003960}, {1180,0.00000000}, {1190,0.00003960}, {1200,0.00000000}, {1210,0.00010891}, {1220,0.00003960}, {1230,0.00000000}, {1240,0.00003960}, {1250,0.00007921}, {1260,0.00003960}, {1270,0.00015842}, {1280,0.00003960}, {1290,0.00000000}, {1300,0.00007921}, {1310,0.00003960}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00007921}, {1370,0.00003960}, {1380,0.00003960}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00003960}, {1420,0.00003960}, {1430,0.00007921}, {1440,0.00011881}, {1450,0.00003960}, {1460,0.00003960}, {1470,0.00003960}, {1480,0.00007921}, {1490,0.00000000}, {1500,0.00003960}, {1510,0.00007921}, {1520,0.00007921}, {1530,0.00007921}, {1540,0.00011881}, {1550,0.00003960}, {1560,0.00007921}, {1570,0.00000000}, {1580,0.00003960}, {1590,0.00000000}, {1600,0.00010891}, {1610,0.00003960}, {1620,0.00002970}, {1630,0.00000000}, {1640,0.00002970}, {1650,0.00007921}, {1660,0.00000000}, {1670,0.00003960}, {1680,0.00006931}, {1690,0.00003960}, {1700,0.00000000}, {1710,0.00007921}, {1720,0.00000000}, {1730,0.00003960}, {1740,0.00007921}, {1750,0.00007921}, {1760,0.00015842}, {1770,0.00003960}, {1780,0.00007921}, {1790,0.00018812}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00003960}, {1840,0.00003960}, {1850,0.00000000}, {1860,0.00007921}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00007921}, {1900,0.00000000}, {1910,0.00007921}, {1920,0.00003960}, {1930,0.00000000}, {1940,0.00003960}, {1950,0.00000000}, {1960,0.00014851}, {1970,0.00007921}, {1980,0.00007921}, {1990,0.00003960}, {2000,0.00011881}, {2050,0.00007921}, {2100,0.00003960}, {2150,0.00003960}, {2200,0.00003960}, {2250,0.00007921}, {2300,0.00007921}, {2350,0.00000000}, {2400,0.00003960}, {2450,0.00026733}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00007921}, {2700,0.00007921}, {2750,0.00000000}, {2800,0.00015842}, {2850,0.00000000}, {2900,0.00011881}, {2950,0.00003960}, {3000,0.00007921}, {3050,0.00000000}, {3100,0.00408911}, {3150,0.00027723}, {3200,0.00006931}, {3250,0.00003960}, {3300,0.00003960}, {3350,0.00007921}, {3400,0.00003960}, {3450,0.00015842}, {3500,0.00014851}, {3550,0.00003960}, {3600,0.00003960}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00003960}, {3800,0.00011881}, {3850,0.00003960}, {3900,0.00003960}, {3950,0.00003960}, {4000,0.00015842}, {4050,0.00007921}, {4100,0.00000000}, {4150,0.00003960}, {4200,0.00000000}, {4250,0.00003960}, {4300,0.00015842}, {4350,0.00011881}, {4400,0.00011881}, {4450,0.00003960}, {4500,0.00000000}, {4550,0.00007921}, {4600,0.00007921}, {4650,0.00003960}, {4700,0.00007921}, {4750,0.00007921}, {4800,0.00015842}, {4850,0.00035644}, {4900,0.00003960}, {4950,0.00011881}, {5000,0.00015842}, {5050,0.00035644}, {5100,0.00015842}, {5150,0.00003960}, {5200,0.00063366}, {5250,0.00011881}, {5300,0.00011881}, {5350,0.00010891}, {5400,0.00011881}, {5450,0.00007921}, {5500,0.00007921}, {5550,0.00003960}, {5600,0.00010891}, {5650,0.00000000}, {5700,0.00002970}, {5750,0.00007921}, {5800,0.00003960}, {5850,0.00011881}, {5900,0.00011881}, {5950,0.00003960}, {6000,0.00015842}, {6050,0.0006857}, {6100,0.0067714}, {6150,0.0001143}, {6200,0.0002286}, {6250,0.0052857}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0001143}, {6450,0.0000000}, {6500,0.0003429}, {6550,0.0004286}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0002286}, {6750,0.0000000}, {6800,0.0004571}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0003429}, {7000,0.0004571}, {7050,0.0002286}, {7100,0.0000000}, {7150,0.0003429}, {7200,0.0001143}, {7250,0.0000000}, {7300,0.0002000}, {7350,0.0000000}, {7400,0.0003429}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0001143}, {7600,0.0000000}, {7650,0.0002286}, {7700,0.0000000}, {7750,0.0001143}, {7800,0.0001143}, {7850,0.0001143}, {7900,0.0000000}, {7950,0.0002286}, {8000,0.0000000}, {8050,0.0002286}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000857}, {8250,0.0001143}, {8300,0.0000000}, {8350,0.0002286}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0002000}, {8550,0.0001143}, {8600,0.0001143}, {8650,0.0001143}, {8700,0.0001143}, {8750,0.0000857}, {8800,0.0001143}, {8850,0.0001143}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0003429}, {9150,0.0000000}, {9200,0.0001143}, {9250,0.0003429}, {9300,0.0001143}, {9350,0.0003429}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0003429}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0002000}, {9750,0.0000000}, {9800,0.0002286}, {9850,0.0000000}, {9900,0.0002000}, {9950,0.0003429}, {10000,0.0003429}, {10100,0.0001143}, {10200,0.0056286}, {10300,0.0001143}, {10400,0.0001143}, {10500,0.0002286}, {10600,0.0002000}, {10700,0.0002286}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0003429}, {11100,0.0000000}, {11200,0.0001143}, {11300,0.0003143}, {11400,0.0002286}, {11500,0.0002286}, {11600,0.0001143}, {11700,0.0000000}, {11800,0.0001143}, {11900,0.0000000}, {12000,0.0001143}, {12100,0.0002286}, {12200,0.0003429}, {12300,0.0001143}, {12400,0.0001143}, {12500,0.0000000}, {12600,0.0001143}, {12700,0.0004571}, {12800,0.0000000}, {12900,0.0012571}, {13000,0.0000000}, {13100,0.0005714}, {13200,0.0002286}, {13300,0.0002286}, {13400,0.0002286}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0001143}, {13800,0.0003429}, {13900,0.0001143}, {14000,0.0007714}, {14100,0.0009143}, {14200,0.0005714}, {14300,0.0004571}, {14400,0.0001143}, {14500,0.0001143}, {14600,0.0003429}, {14700,0.0005714}, {14800,0.0008000}, {14900,0.0004571}, {15000,0.0002286}, {15100,0.0001143}, {15200,0.0007429}, {15300,0.0009143}, {15400,0.0010000}, {15500,0.0006857}, {15600,0.0001143}, {15700,0.0008000}, {15800,0.0013429}, {15900,0.0002000}, {16000,0.0004571}, {16100,0.0003429}, {16200,0.0006857}, {16300,0.0021429}, {16400,0.0002286}, {16500,0.0012571}, {16600,0.0010286}, {16700,0.0010286}, {16800,0.0002286}, {16900,0.0006571}, {17000,0.0008000}, {17100,0.0012571}, {17200,0.0005429}, {17300,0.0006857}, {17400,0.0005714}, {17500,0.0001143}, {17600,0.0014857}, {17700,0.0002286}, {17800,0.0006571}, {17900,0.0004571}, {18000,0.0001143}, {18100,0.0002286}, {18200,0.0012571}, {18300,0.0003429}, {18400,0.0005714}, {18500,0.0002286}, {18600,0.0003429}, {18700,0.0008000}, {18800,0.0006286}, {18900,0.0002286}, {19000,0.0006857}, {19100,0.0004571}, {19200,0.0010286}, {19300,0.0016000}, {19400,0.0007714}, {19500,0.0002286}, {19600,0.0002286}, {19700,0.0029714}, {19800,0.0021714}, {19900,0.0009143}, {20000,0.0029429}};
data["big_flat"]["LtacTacInTermPrimPair"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermPrimPair"]["post"]["user"] = {{1,0.00003960}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00003960}, {7,0.00000000}, {8,0.00000000}, {9,0.00003960}, {10,0.00010891}, {11,0.00003960}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00002970}, {16,0.00003960}, {17,0.00006931}, {18,0.00002970}, {19,0.00000000}, {20,0.00008911}, {21,0.00000000}, {22,0.00000000}, {23,0.00003960}, {24,0.00002970}, {25,0.00006931}, {26,0.00003960}, {27,0.00006931}, {28,0.00002970}, {29,0.00006931}, {30,0.00000000}, {31,0.00007921}, {32,0.00009901}, {33,0.00003960}, {34,0.00000000}, {35,0.00002970}, {36,0.00007921}, {37,0.00000000}, {38,0.00000000}, {39,0.00003960}, {40,0.00000000}, {41,0.00006931}, {42,0.00000000}, {43,0.00003960}, {44,0.00000000}, {45,0.00003960}, {46,0.00000000}, {47,0.00000000}, {48,0.00002970}, {49,0.00007921}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00003960}, {54,0.00000000}, {55,0.00003960}, {56,0.00002970}, {57,0.00003960}, {58,0.00000000}, {59,0.00002970}, {60,0.00000000}, {61,0.00002970}, {62,0.00000000}, {63,0.00005941}, {64,0.00008911}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00002970}, {71,0.00002970}, {72,0.00002970}, {73,0.00000000}, {74,0.00009901}, {75,0.00000000}, {76,0.00002970}, {77,0.00000000}, {78,0.00002970}, {79,0.00005941}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00006931}, {84,0.00002970}, {85,0.00003960}, {86,0.00000000}, {87,0.00002970}, {88,0.00000000}, {89,0.00009901}, {90,0.00000000}, {91,0.00002970}, {92,0.00002970}, {93,0.00006931}, {94,0.00000000}, {95,0.00000000}, {96,0.00002970}, {97,0.00000000}, {98,0.00000000}, {99,0.00002970}, {100,0.00002970}, {101,0.00000000}, {102,0.00000000}, {103,0.00002970}, {104,0.00000000}, {105,0.00000000}, {106,0.00003960}, {107,0.00000000}, {108,0.00009901}, {109,0.00002970}, {110,0.00005941}, {111,0.00002970}, {112,0.00000000}, {113,0.00000000}, {114,0.00011881}, {115,0.00002970}, {116,0.00000000}, {117,0.00002970}, {118,0.00000000}, {119,0.00000000}, {120,0.00002970}, {121,0.00000000}, {122,0.00000000}, {123,0.00002970}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00005941}, {128,0.00003960}, {129,0.00002970}, {130,0.00000000}, {131,0.00000000}, {132,0.00002970}, {133,0.00002970}, {134,0.00005941}, {135,0.00000000}, {136,0.00003960}, {137,0.00002970}, {138,0.00000000}, {139,0.00002970}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00003960}, {144,0.00000000}, {145,0.00007921}, {146,0.00002970}, {147,0.00007921}, {148,0.00007921}, {149,0.00002970}, {150,0.00003960}, {151,0.00000000}, {152,0.00003960}, {153,0.00000000}, {154,0.00000000}, {155,0.00002970}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00003960}, {160,0.00003960}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00003960}, {165,0.00000000}, {166,0.00000000}, {167,0.00003960}, {168,0.00003960}, {169,0.00002970}, {170,0.00002970}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00003960}, {177,0.00000000}, {178,0.00003960}, {179,0.00003960}, {180,0.00002970}, {181,0.00003960}, {182,0.00000000}, {183,0.00007921}, {184,0.00000000}, {185,0.00000000}, {186,0.00006931}, {187,0.00000000}, {188,0.00003960}, {189,0.00003960}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00002970}, {194,0.00000000}, {195,0.00003960}, {196,0.00003960}, {197,0.00014851}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00005941}, {202,0.00000000}, {203,0.00003960}, {204,0.00003960}, {205,0.00003960}, {206,0.00000000}, {207,0.00003960}, {208,0.00003960}, {209,0.00002970}, {210,0.00003960}, {211,0.00011881}, {212,0.00003960}, {213,0.00000000}, {214,0.00006931}, {215,0.00002970}, {216,0.00000000}, {217,0.00000000}, {218,0.00003960}, {219,0.00003960}, {220,0.00000000}, {221,0.00000000}, {222,0.00007921}, {223,0.00003960}, {224,0.00000000}, {225,0.00006931}, {226,0.00002970}, {227,0.00003960}, {228,0.00000000}, {229,0.00000000}, {230,0.00003960}, {231,0.00003960}, {232,0.00003960}, {233,0.00000000}, {234,0.00003960}, {235,0.00010891}, {236,0.00002970}, {237,0.00002970}, {238,0.00009901}, {239,0.00000000}, {240,0.00003960}, {241,0.00006931}, {242,0.00000000}, {243,0.00003960}, {244,0.00000000}, {245,0.00002970}, {246,0.00009901}, {247,0.00000000}, {248,0.00007921}, {249,0.00000000}, {250,0.00008911}, {251,0.00002970}, {252,0.00003960}, {253,0.00000000}, {254,0.00005941}, {255,0.00012871}, {256,0.00000000}, {257,0.00005941}, {258,0.00002970}, {259,0.00003960}, {260,0.00000000}, {261,0.00005941}, {262,0.00000000}, {263,0.00003960}, {264,0.00002970}, {265,0.00000000}, {266,0.00003960}, {267,0.00006931}, {268,0.00008911}, {269,0.00002970}, {270,0.00000000}, {271,0.00005941}, {272,0.00000000}, {273,0.00000000}, {274,0.00002970}, {275,0.00003960}, {276,0.00005941}, {277,0.00003960}, {278,0.00005941}, {279,0.00002970}, {280,0.00005941}, {281,0.00000000}, {282,0.00005941}, {283,0.00000000}, {284,0.00006931}, {285,0.00005941}, {286,0.00000000}, {287,0.00000000}, {288,0.00003960}, {289,0.00002970}, {290,0.00006931}, {291,0.00000000}, {292,0.00003960}, {293,0.00000000}, {294,0.00008911}, {295,0.00000000}, {296,0.00003960}, {297,0.00000000}, {298,0.00002970}, {299,0.00000000}, {300,0.00002970}, {301,0.00000000}, {302,0.00002970}, {303,0.00002970}, {304,0.00002970}, {305,0.00000000}, {306,0.00002970}, {307,0.00005941}, {308,0.00002970}, {309,0.00007921}, {310,0.00000000}, {311,0.00013861}, {312,0.00003960}, {313,0.00008911}, {314,0.00002970}, {315,0.00002970}, {316,0.00000000}, {317,0.00002970}, {318,0.00006931}, {319,0.00000000}, {320,0.00005941}, {321,0.00000000}, {322,0.00000000}, {323,0.00009901}, {324,0.00002970}, {325,0.00002970}, {326,0.00002970}, {327,0.00002970}, {328,0.00000000}, {329,0.00003960}, {330,0.00003960}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00008911}, {336,0.00000000}, {337,0.00005941}, {338,0.00007921}, {339,0.00002970}, {340,0.00000000}, {341,0.00005941}, {342,0.00002970}, {343,0.00000000}, {344,0.00002970}, {345,0.00003960}, {346,0.00000000}, {347,0.00002970}, {348,0.00002970}, {349,0.00000000}, {350,0.00000000}, {351,0.00007921}, {352,0.00000000}, {353,0.00000000}, {354,0.00015842}, {355,0.00002970}, {356,0.00002970}, {357,0.00000000}, {358,0.00006931}, {359,0.00000000}, {360,0.00003960}, {361,0.00006931}, {362,0.00007921}, {363,0.00003960}, {364,0.00003960}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00003960}, {369,0.00002970}, {370,0.00011881}, {371,0.00006931}, {372,0.00000000}, {373,0.00000000}, {374,0.00003960}, {375,0.00002970}, {376,0.00000000}, {377,0.00000000}, {378,0.00002970}, {379,0.00003960}, {380,0.00000000}, {381,0.00002970}, {382,0.00003960}, {383,0.00000000}, {384,0.00003960}, {385,0.00003960}, {386,0.00000000}, {387,0.00000000}, {388,0.00011881}, {389,0.00000000}, {390,0.00002970}, {391,0.00006931}, {392,0.00002970}, {393,0.00007921}, {394,0.00002970}, {395,0.00000000}, {396,0.00002970}, {397,0.00015842}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00002970}, {402,0.00006931}, {403,0.00003960}, {404,0.00000000}, {405,0.00002970}, {406,0.00002970}, {407,0.00000000}, {408,0.00009901}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00002970}, {415,0.00002970}, {416,0.00002970}, {417,0.00000000}, {418,0.00000000}, {419,0.00006931}, {420,0.00002970}, {421,0.00003960}, {422,0.00015842}, {423,0.00003960}, {424,0.00000000}, {425,0.00003960}, {426,0.00002970}, {427,0.00010891}, {428,0.00003960}, {429,0.00000000}, {430,0.00007921}, {431,0.00007921}, {432,0.00000000}, {433,0.00007921}, {434,0.00000000}, {435,0.00002970}, {436,0.00000000}, {437,0.00000000}, {438,0.00005941}, {439,0.00003960}, {440,0.00002970}, {441,0.00000000}, {442,0.00014851}, {443,0.00000000}, {444,0.00003960}, {445,0.00003960}, {446,0.00000000}, {447,0.00002970}, {448,0.00000000}, {449,0.00007921}, {450,0.00002970}, {451,0.00007921}, {452,0.00006931}, {453,0.00003960}, {454,0.00000000}, {455,0.00003960}, {456,0.00007921}, {457,0.00003960}, {458,0.00000000}, {459,0.00000000}, {460,0.00006931}, {461,0.00000000}, {462,0.00000000}, {463,0.00007921}, {464,0.00000000}, {465,0.00003960}, {466,0.00000000}, {467,0.00009901}, {468,0.00000000}, {469,0.00000000}, {470,0.00003960}, {471,0.00000000}, {472,0.00000000}, {473,0.00003960}, {474,0.00003960}, {475,0.00007921}, {476,0.00003960}, {477,0.00014851}, {478,0.00000000}, {479,0.00006931}, {480,0.00006931}, {481,0.00002970}, {482,0.00003960}, {483,0.00006931}, {484,0.00000000}, {485,0.00003960}, {486,0.00000000}, {487,0.00000000}, {488,0.00009901}, {489,0.00003960}, {490,0.00000000}, {491,0.00003960}, {492,0.00003960}, {493,0.00000000}, {494,0.00003960}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00003960}, {499,0.00003960}, {500,0.00003960}, {505,0.00006931}, {510,0.00000000}, {515,0.00010891}, {520,0.00007921}, {525,0.00007921}, {530,0.00000000}, {535,0.00002970}, {540,0.00002970}, {545,0.00002970}, {550,0.00009901}, {555,0.00003960}, {560,0.00000000}, {565,0.00005941}, {570,0.00003960}, {575,0.00003960}, {580,0.00003960}, {585,0.00003960}, {590,0.00000000}, {595,0.00002970}, {600,0.00000000}, {605,0.00002970}, {610,0.00003960}, {615,0.00000000}, {620,0.00002970}, {625,0.00003960}, {630,0.00010891}, {635,0.00003960}, {640,0.00000000}, {645,0.00008911}, {650,0.00003960}, {655,0.00000000}, {660,0.00002970}, {665,0.00000000}, {670,0.00000000}, {675,0.00005941}, {680,0.00000000}, {685,0.00000000}, {690,0.00005941}, {695,0.00000000}, {700,0.00000000}, {705,0.00008911}, {710,0.00006931}, {715,0.00000000}, {720,0.00005941}, {725,0.00007921}, {730,0.00002970}, {735,0.00005941}, {740,0.00002970}, {745,0.00000000}, {750,0.00000000}, {755,0.00002970}, {760,0.00000000}, {765,0.00002970}, {770,0.00000000}, {775,0.00000000}, {780,0.00014851}, {785,0.00000000}, {790,0.00006931}, {795,0.00000000}, {800,0.00006931}, {805,0.00008911}, {810,0.00000000}, {815,0.00006931}, {820,0.00002970}, {825,0.00002970}, {830,0.00002970}, {835,0.00000000}, {840,0.00006931}, {845,0.00006931}, {850,0.00000000}, {855,0.00002970}, {860,0.00002970}, {865,0.00002970}, {870,0.00000000}, {875,0.00002970}, {880,0.00000000}, {885,0.00002970}, {890,0.00000000}, {895,0.00007921}, {900,0.00007921}, {905,0.00009901}, {910,0.00005941}, {915,0.00002970}, {920,0.00002970}, {925,0.00000000}, {930,0.00003960}, {935,0.00005941}, {940,0.00000000}, {945,0.00000000}, {950,0.00002970}, {955,0.00000000}, {960,0.00002970}, {965,0.00002970}, {970,0.00003960}, {975,0.00000000}, {980,0.00009901}, {985,0.00009901}, {990,0.00000000}, {995,0.00006931}, {1000,0.00000000}, {1010,0.00002970}, {1020,0.00002970}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00003960}, {1060,0.00002970}, {1070,0.00000000}, {1080,0.00002970}, {1090,0.00003960}, {1100,0.00000000}, {1110,0.00007921}, {1120,0.00006931}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00002970}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00005941}, {1220,0.00002970}, {1230,0.00007921}, {1240,0.00000000}, {1250,0.00003960}, {1260,0.00000000}, {1270,0.00003960}, {1280,0.00000000}, {1290,0.00002970}, {1300,0.00006931}, {1310,0.00005941}, {1320,0.00000000}, {1330,0.00003960}, {1340,0.00003960}, {1350,0.00000000}, {1360,0.00007921}, {1370,0.00000000}, {1380,0.00007921}, {1390,0.00008911}, {1400,0.00002970}, {1410,0.00002970}, {1420,0.00000000}, {1430,0.00002970}, {1440,0.00009901}, {1450,0.00000000}, {1460,0.00005941}, {1470,0.00000000}, {1480,0.00010891}, {1490,0.00003960}, {1500,0.00000000}, {1510,0.00007921}, {1520,0.00005941}, {1530,0.00007921}, {1540,0.00011881}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00003960}, {1580,0.00000000}, {1590,0.00006931}, {1600,0.00003960}, {1610,0.00003960}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00002970}, {1650,0.00011881}, {1660,0.00003960}, {1670,0.00007921}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00007921}, {1710,0.00003960}, {1720,0.00007921}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00003960}, {1770,0.00000000}, {1780,0.00006931}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00003960}, {1820,0.00002970}, {1830,0.00010891}, {1840,0.00003960}, {1850,0.00002970}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00009901}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00003960}, {1920,0.00000000}, {1930,0.00003960}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00002970}, {1970,0.00000000}, {1980,0.00003960}, {1990,0.00003960}, {2000,0.00002970}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00003960}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00005941}, {2400,0.00000000}, {2450,0.00003960}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00003960}, {2700,0.00002970}, {2750,0.00000000}, {2800,0.00007921}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00007921}, {3000,0.00007921}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00002970}, {3250,0.00003960}, {3300,0.00009901}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00003960}, {3500,0.00003960}, {3550,0.00003960}, {3600,0.00000000}, {3650,0.00005941}, {3700,0.00006931}, {3750,0.00003960}, {3800,0.00000000}, {3850,0.00002970}, {3900,0.00003960}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00003960}, {4100,0.00010891}, {4150,0.00000000}, {4200,0.00002970}, {4250,0.00003960}, {4300,0.00010891}, {4350,0.00000000}, {4400,0.00007921}, {4450,0.00003960}, {4500,0.00003960}, {4550,0.00003960}, {4600,0.00000000}, {4650,0.00006931}, {4700,0.00007921}, {4750,0.00005941}, {4800,0.00007921}, {4850,0.00002970}, {4900,0.00006931}, {4950,0.00014851}, {5000,0.00000000}, {5050,0.00010891}, {5100,0.00000000}, {5150,0.00003960}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00003960}, {5350,0.00003960}, {5400,0.00003960}, {5450,0.00000000}, {5500,0.00003960}, {5550,0.00003960}, {5600,0.00003960}, {5650,0.00003960}, {5700,0.00003960}, {5750,0.00000000}, {5800,0.00007921}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000857}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0001143}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0001143}, {6650,0.0000000}, {6700,0.0000857}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000857}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000857}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000857}, {7400,0.0000000}, {7450,0.0001143}, {7500,0.0000000}, {7550,0.0000857}, {7600,0.0001143}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000857}, {7800,0.0001143}, {7850,0.0001143}, {7900,0.0000000}, {7950,0.0001143}, {8000,0.0001143}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0001143}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0001143}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0001143}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0002286}, {9050,0.0000000}, {9100,0.0001143}, {9150,0.0001143}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0001143}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0002286}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000857}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0001143}, {11400,0.0000000}, {11500,0.0001143}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0001143}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000857}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000857}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0002000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0001714}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0001143}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000857}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000857}, {16400,0.0000857}, {16500,0.0000000}, {16600,0.0000857}, {16700,0.0000857}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0001143}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0001143}, {18500,0.0000000}, {18600,0.0001143}, {18700,0.0000857}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0001143}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermPrimPair"]["post"]["system"] = {{1,0.00000000}, {2,0.00002970}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00003960}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00003960}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00003960}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00003960}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00003960}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00003960}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermPrimPair"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermPrimPair"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00003960}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00003960}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00002970}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00002970}, {72,0.00003960}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00002970}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00003960}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00002970}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00005941}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00003960}, {121,0.00000000}, {122,0.00000000}, {123,0.00002970}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00006931}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00003960}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00003960}, {197,0.00000000}, {198,0.00003960}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00002970}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00002970}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00003960}, {212,0.00000000}, {213,0.00003960}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00003960}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00003960}, {231,0.00000000}, {232,0.00007921}, {233,0.00000000}, {234,0.00000000}, {235,0.00003960}, {236,0.00002970}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00002970}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00002970}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00003960}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00002970}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00002970}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00003960}, {302,0.00000000}, {303,0.00000000}, {304,0.00002970}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00002970}, {316,0.00000000}, {317,0.00003960}, {318,0.00002970}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00002970}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00008911}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00007921}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00003960}, {365,0.00000000}, {366,0.00000000}, {367,0.00003960}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00003960}, {378,0.00002970}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00003960}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00003960}, {399,0.00000000}, {400,0.00003960}, {401,0.00002970}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00002970}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00003960}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00002970}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00003960}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00002970}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00002970}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00003960}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00002970}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00005941}, {555,0.00000000}, {560,0.00003960}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00002970}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00002970}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00002970}, {700,0.00000000}, {705,0.00003960}, {710,0.00000000}, {715,0.00002970}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00006931}, {740,0.00002970}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00002970}, {785,0.00003960}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00002970}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00003960}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00002970}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00003960}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00002970}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00002970}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00002970}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00002970}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00002970}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00002970}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00003960}, {1570,0.00003960}, {1580,0.00000000}, {1590,0.00003960}, {1600,0.00000000}, {1610,0.00003960}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00002970}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00003960}, {1880,0.00003960}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00002970}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00002970}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00003960}, {3450,0.00003960}, {3500,0.00003960}, {3550,0.00003960}, {3600,0.00003960}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00003960}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00003960}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00003960}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00003960}, {5100,0.00003960}, {5150,0.00003960}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00003960}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0001143}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000857}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0001143}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0001143}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0001143}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0001143}, {9650,0.0000000}, {9700,0.0001143}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000857}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000857}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermPrimPair"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.0000000}, {6100,0.0000000}, {6150,0.0000000}, {6200,0.0000000}, {6250,0.0000000}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0000000}, {6450,0.0000000}, {6500,0.0000000}, {6550,0.0000000}, {6600,0.0000000}, {6650,0.0000000}, {6700,0.0000000}, {6750,0.0000000}, {6800,0.0000000}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0000000}, {7000,0.0000000}, {7050,0.0000000}, {7100,0.0000000}, {7150,0.0000000}, {7200,0.0000000}, {7250,0.0000000}, {7300,0.0000000}, {7350,0.0000000}, {7400,0.0000000}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0000000}, {7600,0.0000000}, {7650,0.0000000}, {7700,0.0000000}, {7750,0.0000000}, {7800,0.0000000}, {7850,0.0000000}, {7900,0.0000000}, {7950,0.0000000}, {8000,0.0000000}, {8050,0.0000000}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000000}, {8250,0.0000000}, {8300,0.0000000}, {8350,0.0000000}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0000000}, {8550,0.0000000}, {8600,0.0000000}, {8650,0.0000000}, {8700,0.0000000}, {8750,0.0000000}, {8800,0.0000000}, {8850,0.0000000}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0000000}, {9050,0.0000000}, {9100,0.0000000}, {9150,0.0000000}, {9200,0.0000000}, {9250,0.0000000}, {9300,0.0000000}, {9350,0.0000000}, {9400,0.0000000}, {9450,0.0000000}, {9500,0.0000000}, {9550,0.0000000}, {9600,0.0000000}, {9650,0.0000000}, {9700,0.0000000}, {9750,0.0000000}, {9800,0.0000000}, {9850,0.0000000}, {9900,0.0000000}, {9950,0.0000000}, {10000,0.0000000}, {10100,0.0000000}, {10200,0.0000000}, {10300,0.0000000}, {10400,0.0000000}, {10500,0.0000000}, {10600,0.0000000}, {10700,0.0000000}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0000000}, {11100,0.0000000}, {11200,0.0000000}, {11300,0.0000000}, {11400,0.0000000}, {11500,0.0000000}, {11600,0.0000000}, {11700,0.0000000}, {11800,0.0000000}, {11900,0.0000000}, {12000,0.0000000}, {12100,0.0000000}, {12200,0.0000000}, {12300,0.0000000}, {12400,0.0000000}, {12500,0.0000000}, {12600,0.0000000}, {12700,0.0000000}, {12800,0.0000000}, {12900,0.0000000}, {13000,0.0000000}, {13100,0.0000000}, {13200,0.0000000}, {13300,0.0000000}, {13400,0.0000000}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0000000}, {13800,0.0000000}, {13900,0.0000000}, {14000,0.0000000}, {14100,0.0000000}, {14200,0.0000000}, {14300,0.0000000}, {14400,0.0000000}, {14500,0.0000000}, {14600,0.0000000}, {14700,0.0000000}, {14800,0.0000000}, {14900,0.0000000}, {15000,0.0000000}, {15100,0.0000000}, {15200,0.0000000}, {15300,0.0000000}, {15400,0.0000000}, {15500,0.0000000}, {15600,0.0000000}, {15700,0.0000000}, {15800,0.0000000}, {15900,0.0000000}, {16000,0.0000000}, {16100,0.0000000}, {16200,0.0000000}, {16300,0.0000000}, {16400,0.0000000}, {16500,0.0000000}, {16600,0.0000000}, {16700,0.0000000}, {16800,0.0000000}, {16900,0.0000000}, {17000,0.0000000}, {17100,0.0000000}, {17200,0.0000000}, {17300,0.0000000}, {17400,0.0000000}, {17500,0.0000000}, {17600,0.0000000}, {17700,0.0000000}, {17800,0.0000000}, {17900,0.0000000}, {18000,0.0000000}, {18100,0.0000000}, {18200,0.0000000}, {18300,0.0000000}, {18400,0.0000000}, {18500,0.0000000}, {18600,0.0000000}, {18700,0.0000000}, {18800,0.0000000}, {18900,0.0000000}, {19000,0.0000000}, {19100,0.0000000}, {19200,0.0000000}, {19300,0.0000000}, {19400,0.0000000}, {19500,0.0000000}, {19600,0.0000000}, {19700,0.0000000}, {19800,0.0000000}, {19900,0.0000000}, {20000,0.0000000}};
data["big_flat"]["LtacTacInTermPrimPair"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00064356}, {7,0.00100000}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00133663}, {14,0.00154455}, {15,0.00200000}, {16,0.00200000}, {17,0.00200000}, {18,0.00200000}, {19,0.00200000}, {20,0.00207921}, {21,0.00227723}, {22,0.00266337}, {23,0.00300000}, {24,0.00300000}, {25,0.00300000}, {26,0.00300000}, {27,0.00305941}, {28,0.00310891}, {29,0.00326733}, {30,0.00379208}, {31,0.00400000}, {32,0.00400000}, {33,0.00400000}, {34,0.00400990}, {35,0.00425743}, {36,0.00422772}, {37,0.00430693}, {38,0.00478218}, {39,0.00665347}, {40,0.00500000}, {41,0.00500000}, {42,0.00505941}, {43,0.00509901}, {44,0.00521782}, {45,0.00540594}, {46,0.00571287}, {47,0.00600000}, {48,0.00600000}, {49,0.00604950}, {50,0.00607921}, {51,0.00802970}, {52,0.00618812}, {53,0.00640594}, {54,0.00679208}, {55,0.00700000}, {56,0.00701980}, {57,0.00708911}, {58,0.00714851}, {59,0.00721782}, {60,0.00732673}, {61,0.00733663}, {62,0.00777228}, {63,0.00803960}, {64,0.00800990}, {65,0.00822772}, {66,0.00816832}, {67,0.00815842}, {68,0.00838614}, {69,0.00846535}, {70,0.00863366}, {71,0.00906931}, {72,0.00912871}, {73,0.00918812}, {74,0.00909901}, {75,0.00921782}, {76,0.00920792}, {77,0.00938614}, {78,0.00970297}, {79,0.01008911}, {80,0.01005941}, {81,0.01023762}, {82,0.01017822}, {83,0.01486139}, {84,0.01025743}, {85,0.01050495}, {86,0.01057426}, {87,0.01108911}, {88,0.01102970}, {89,0.01112871}, {90,0.01108911}, {91,0.01121782}, {92,0.01126733}, {93,0.01146535}, {94,0.01168317}, {95,0.01205941}, {96,0.01205941}, {97,0.01215842}, {98,0.01220792}, {99,0.01226733}, {100,0.01232673}, {101,0.01255446}, {102,0.01263366}, {103,0.01307921}, {104,0.01316832}, {105,0.01315842}, {106,0.01313861}, {107,0.01337624}, {108,0.01347525}, {109,0.01721782}, {110,0.01362376}, {111,0.01409901}, {112,0.01417822}, {113,0.01413861}, {114,0.01417822}, {115,0.01922772}, {116,0.01428713}, {117,0.01452475}, {118,0.01481188}, {119,0.01502970}, {120,0.01785149}, {121,0.01518812}, {122,0.01520792}, {123,0.01543564}, {124,0.01739604}, {125,0.01554455}, {126,0.01570297}, {127,0.02164356}, {128,0.01602970}, {129,0.01630693}, {130,0.02257426}, {131,0.01624752}, {132,0.01664356}, {133,0.02182178}, {134,0.01675248}, {135,0.01703960}, {136,0.01789109}, {137,0.01732673}, {138,0.02379208}, {139,0.01732673}, {140,0.01751485}, {141,0.01761386}, {142,0.01789109}, {143,0.01815842}, {144,0.01808911}, {145,0.02045545}, {146,0.01821782}, {147,0.02134653}, {148,0.01859406}, {149,0.02081188}, {150,0.01893069}, {151,0.01926733}, {152,0.01924752}, {153,0.01929703}, {154,0.01939604}, {155,0.01941584}, {156,0.02423762}, {157,0.01985149}, {158,0.01986139}, {159,0.02026733}, {160,0.02009901}, {161,0.02233663}, {162,0.02021782}, {163,0.02045545}, {164,0.02356436}, {165,0.02087129}, {166,0.02093069}, {167,0.02269307}, {168,0.02120792}, {169,0.02138614}, {170,0.02123762}, {171,0.02635644}, {172,0.02173267}, {173,0.02176238}, {174,0.02180198}, {175,0.02610891}, {176,0.02222772}, {177,0.02244554}, {178,0.02228713}, {179,0.02244554}, {180,0.02614851}, {181,0.03142574}, {182,0.02293069}, {183,0.02302970}, {184,0.02314851}, {185,0.02325743}, {186,0.02335644}, {187,0.02552475}, {188,0.02865347}, {189,0.03125743}, {190,0.02378218}, {191,0.02428713}, {192,0.02409901}, {193,0.02421782}, {194,0.02436634}, {195,0.02453465}, {196,0.02451485}, {197,0.02478218}, {198,0.02488119}, {199,0.02500000}, {200,0.02503960}, {201,0.02522772}, {202,0.02539604}, {203,0.02569307}, {204,0.02580198}, {205,0.03473267}, {206,0.03288119}, {207,0.02889109}, {208,0.02828713}, {209,0.02627723}, {210,0.02629703}, {211,0.02654455}, {212,0.02671287}, {213,0.02690099}, {214,0.03727723}, {215,0.03041584}, {216,0.02708911}, {217,0.02741584}, {218,0.02719802}, {219,0.03692079}, {220,0.03017822}, {221,0.02786139}, {222,0.02779208}, {223,0.03925743}, {224,0.03122772}, {225,0.02837624}, {226,0.02841584}, {227,0.03741584}, {228,0.02859406}, {229,0.02885149}, {230,0.03864356}, {231,0.03023762}, {232,0.02921782}, {233,0.03900990}, {234,0.02931683}, {235,0.02973267}, {236,0.03680198}, {237,0.02981188}, {238,0.03016832}, {239,0.03171287}, {240,0.03032673}, {241,0.03615842}, {242,0.03033663}, {243,0.03981188}, {244,0.03048515}, {245,0.03114851}, {246,0.03099010}, {247,0.03104950}, {248,0.03102970}, {249,0.03151485}, {250,0.03146535}, {251,0.03280198}, {252,0.03201980}, {253,0.04173267}, {254,0.03205941}, {255,0.03823762}, {256,0.03236634}, {257,0.03371287}, {258,0.03246535}, {259,0.03264356}, {260,0.04044554}, {261,0.03282178}, {262,0.03300990}, {263,0.04400990}, {264,0.03315842}, {265,0.03485149}, {266,0.04370297}, {267,0.03382178}, {268,0.03378218}, {269,1.02724752}, {270,0.03418812}, {271,0.03433663}, {272,0.04027723}, {273,0.05066337}, {274,0.03476238}, {275,0.03497030}, {276,0.03901980}, {277,0.04569307}, {278,0.03551485}, {279,0.03560396}, {280,0.03533663}, {281,0.03979208}, {282,0.04444554}, {283,0.03729703}, {284,0.03623762}, {285,0.03626733}, {286,0.03617822}, {287,0.03663366}, {288,0.03949505}, {289,0.04267327}, {290,0.04495050}, {291,0.04758416}, {292,0.04898020}, {293,0.03738614}, {294,0.03781188}, {295,0.03765347}, {296,0.03756436}, {297,0.03778218}, {298,0.03779208}, {299,0.03799010}, {300,0.03849505}, {301,0.03844554}, {302,0.03846535}, {303,0.03897030}, {304,0.03876238}, {305,0.05756436}, {306,0.05440594}, {307,0.04877228}, {308,0.04634653}, {309,0.04401980}, {310,0.04086139}, {311,0.03953465}, {312,0.03950495}, {313,0.03986139}, {314,0.04184158}, {315,0.05004950}, {316,0.04549505}, {317,0.04055446}, {318,0.04053465}, {319,0.04083168}, {320,0.05169307}, {321,0.04586139}, {322,0.04071287}, {323,0.04105941}, {324,0.05438614}, {325,0.04776238}, {326,0.04185149}, {327,0.04184158}, {328,0.05236634}, {329,0.04549505}, {330,0.04164356}, {331,0.06241584}, {332,0.04973267}, {333,0.04256436}, {334,0.05813861}, {335,0.04760396}, {336,0.04270297}, {337,0.05556436}, {338,0.04455446}, {339,0.04310891}, {340,0.05027723}, {341,0.04358416}, {342,0.05538614}, {343,0.04413861}, {344,0.05833663}, {345,0.04622772}, {346,0.04426733}, {347,0.04779208}, {348,0.04449505}, {349,0.04866337}, {350,0.04464356}, {351,0.04833663}, {352,0.04436634}, {353,0.04731683}, {354,0.05877228}, {355,0.04527723}, {356,0.05603960}, {357,0.04563366}, {358,0.05675248}, {359,0.04582178}, {360,0.04857426}, {361,0.06038614}, {362,0.04599010}, {363,0.05300000}, {364,0.04659406}, {365,0.04627723}, {366,0.05411881}, {367,0.04685149}, {368,0.04673267}, {369,0.05289109}, {370,0.05927723}, {371,0.04730693}, {372,0.04967327}, {373,0.05674257}, {374,0.04771287}, {375,0.04775248}, {376,0.05026733}, {377,0.05645545}, {378,0.06194059}, {379,0.04815842}, {380,0.04860396}, {381,0.05356436}, {382,0.05879208}, {383,0.06241584}, {384,0.04861386}, {385,0.04855446}, {386,0.04899010}, {387,0.05160396}, {388,0.05515842}, {389,0.05850495}, {390,0.06189109}, {391,0.06379208}, {392,0.06553465}, {393,0.05000990}, {394,0.05028713}, {395,0.05077228}, {396,0.04996040}, {397,0.05064356}, {398,0.05094059}, {399,0.05057426}, {400,0.05091089}, {401,0.05067327}, {402,0.05070297}, {403,0.05171287}, {404,0.05131683}, {405,0.05180198}, {406,0.05161386}, {407,0.05227723}, {408,0.06766337}, {409,0.06609901}, {410,0.06351485}, {411,0.06140594}, {412,0.05811881}, {413,0.05539604}, {414,0.05286139}, {415,0.05319802}, {416,0.05526733}, {417,0.07271287}, {418,0.06478218}, {419,0.05796040}, {420,0.05331683}, {421,0.05338614}, {422,0.07044554}, {423,0.06340594}, {424,0.05652475}, {425,0.05379208}, {426,0.07006931}, {427,0.06324752}, {428,0.05612871}, {429,0.05491089}, {430,0.06705941}, {431,0.05938614}, {432,0.05490099}, {433,0.07243564}, {434,0.06338614}, {435,0.05555446}, {436,0.07061386}, {437,0.06030693}, {438,0.05575248}, {439,0.06685149}, {440,0.05604950}, {441,0.07247525}, {442,0.06086139}, {443,0.05649505}, {444,0.06437624}, {445,0.05657426}, {446,0.06679208}, {447,0.05706931}, {448,0.06848515}, {449,0.05673267}, {450,0.07101980}, {451,0.05759406}, {452,0.07506931}, {453,0.05787129}, {454,0.07169307}, {455,0.05821782}, {456,0.06862376}, {457,0.05824752}, {458,0.06558416}, {459,0.07648515}, {460,0.06086139}, {461,0.07127723}, {462,0.05903960}, {463,0.06583168}, {464,0.07441584}, {465,0.05909901}, {466,0.07028713}, {467,0.08541584}, {468,0.05956436}, {469,0.06972277}, {470,0.07889109}, {471,0.06020792}, {472,0.06702970}, {473,0.07396040}, {474,0.06046535}, {475,0.06194059}, {476,0.06797030}, {477,0.07390099}, {478,0.07953465}, {479,0.06127723}, {480,0.06602970}, {481,0.07544554}, {482,0.08100000}, {483,0.08364356}, {484,0.06187129}, {485,0.06424752}, {486,0.06911881}, {487,0.07263366}, {488,0.07527723}, {489,0.07840594}, {490,0.08104950}, {491,0.06257426}, {492,0.06243564}, {493,0.06284158}, {494,0.06660396}, {495,0.06725743}, {496,0.06909901}, {497,0.07098020}, {498,0.07119802}, {499,0.07216832}, {500,0.07238614}, {505,0.07241584}, {510,0.07079208}, {515,0.06768317}, {520,0.06605941}, {525,0.08522772}, {530,0.08082178}, {535,0.07490099}, {540,0.09213861}, {545,0.08144554}, {550,0.07011881}, {555,0.08255446}, {560,0.09308911}, {565,0.07947525}, {570,0.08791089}, {575,0.09970297}, {580,0.07943564}, {585,0.08703960}, {590,0.08931683}, {595,0.09127723}, {600,0.09373267}, {605,0.09297030}, {610,0.09168317}, {615,0.08962376}, {620,0.08834653}, {625,0.08367327}, {630,0.10405941}, {635,0.09288119}, {640,0.08652475}, {645,0.10170297}, {650,0.09123762}, {655,0.10349505}, {660,0.09140594}, {665,0.11011881}, {670,0.11451485}, {675,0.09506931}, {680,0.10296040}, {685,0.10697030}, {690,0.11070297}, {695,0.11361386}, {700,0.12928713}, {705,0.12100000}, {710,0.11935644}, {715,0.11583168}, {720,0.11139604}, {725,0.10841584}, {730,0.10879208}, {735,0.12521782}, {740,0.11499010}, {745,0.10441584}, {750,0.11748515}, {755,0.10624752}, {760,0.12757426}, {765,0.13329703}, {770,0.11335644}, {775,0.12212871}, {780,0.12817822}, {785,0.11017822}, {790,0.12196040}, {795,0.12109901}, {800,0.12211881}, {805,0.12153465}, {810,0.12172277}, {815,0.11643564}, {820,0.11914851}, {825,0.11425743}, {830,0.13425743}, {835,0.12552475}, {840,0.11837624}, {845,0.13936634}, {850,0.12588119}, {855,0.13860396}, {860,0.12544554}, {865,0.14768317}, {870,0.12347525}, {875,0.13163366}, {880,0.13651485}, {885,0.14251485}, {890,0.15733663}, {895,0.12758416}, {900,0.12749505}, {905,0.12779208}, {910,0.12798020}, {915,0.13185149}, {920,0.15293069}, {925,0.14569307}, {930,0.13955446}, {935,0.13363366}, {940,0.15581188}, {945,0.14488119}, {950,0.13255446}, {955,0.14448515}, {960,0.14056436}, {965,0.14807921}, {970,0.15501980}, {975,0.13901980}, {980,0.15508911}, {985,0.15258416}, {990,0.15745545}, {995,0.15957426}, {1000,0.17817822}, {1010,0.16131683}, {1020,0.16173267}, {1030,0.15872277}, {1040,0.15738614}, {1050,0.17470297}, {1060,0.15969307}, {1070,0.18332673}, {1080,0.16071287}, {1090,0.16299010}, {1100,0.16773267}, {1110,0.17490099}, {1120,0.17144554}, {1130,0.16612871}, {1140,0.20334653}, {1150,0.17869307}, {1160,0.18929703}, {1170,0.17295050}, {1180,0.19062376}, {1190,0.19300000}, {1200,0.18352475}, {1210,0.18004950}, {1220,0.19844554}, {1230,0.20687129}, {1240,0.18944554}, {1250,0.18181188}, {1260,0.21484158}, {1270,0.21235644}, {1280,0.19146535}, {1290,0.20633663}, {1300,0.20781188}, {1310,0.20631683}, {1320,0.21340594}, {1330,0.20386139}, {1340,0.21479208}, {1350,0.22100990}, {1360,0.20532673}, {1370,0.22529703}, {1380,0.20494059}, {1390,0.20940594}, {1400,0.21888119}, {1410,0.21463366}, {1420,0.22500000}, {1430,0.21615842}, {1440,0.23049505}, {1450,0.22350495}, {1460,0.21649505}, {1470,0.23460396}, {1480,0.23493069}, {1490,0.23541584}, {1500,0.22756436}, {1510,0.22516832}, {1520,0.22087129}, {1530,0.24465347}, {1540,0.24787129}, {1550,0.23472277}, {1560,0.26408911}, {1570,0.23828713}, {1580,0.27402970}, {1590,0.25837624}, {1600,0.24620792}, {1610,0.24437624}, {1620,0.25206931}, {1630,0.26634653}, {1640,0.26518812}, {1650,0.25563366}, {1660,0.25948515}, {1670,0.25742574}, {1680,0.26215842}, {1690,0.27569307}, {1700,0.25223762}, {1710,0.26020792}, {1720,0.25009901}, {1730,0.28050495}, {1740,0.29965347}, {1750,0.26765347}, {1760,0.29376238}, {1770,0.26772277}, {1780,0.28966337}, {1790,0.28425743}, {1800,0.28732673}, {1810,0.26897030}, {1820,0.27908911}, {1830,0.29045545}, {1840,0.29236634}, {1850,0.30940594}, {1860,0.29685149}, {1870,0.29601980}, {1880,0.29700000}, {1890,0.31461386}, {1900,0.28347525}, {1910,0.29115842}, {1920,0.30086139}, {1930,0.30955446}, {1940,0.31490099}, {1950,0.29198020}, {1960,0.31555446}, {1970,0.31213861}, {1980,0.31160396}, {1990,0.31253465}, {2000,0.30883168}, {2050,0.30802970}, {2100,0.33186139}, {2150,0.32613861}, {2200,0.34548515}, {2250,0.36012871}, {2300,0.35532673}, {2350,0.36326733}, {2400,0.38745545}, {2450,0.39801980}, {2500,0.43352475}, {2550,0.39874257}, {2600,0.39865347}, {2650,0.42393069}, {2700,0.42508911}, {2750,0.42278218}, {2800,0.45177228}, {2850,0.47504950}, {2900,0.48341584}, {2950,0.49533663}, {3000,0.51701980}, {3050,0.51170297}, {3100,0.53742574}, {3150,0.53276238}, {3200,0.52620792}, {3250,0.51875248}, {3300,0.53952475}, {3350,0.54227723}, {3400,0.55742574}, {3450,0.56480198}, {3500,0.58362376}, {3550,0.59298020}, {3600,0.59376238}, {3650,0.58965347}, {3700,0.59416832}, {3750,0.59492079}, {3800,0.60935644}, {3850,0.60634653}, {3900,0.63781188}, {3950,0.66722772}, {4000,0.62861386}, {4050,0.66310891}, {4100,0.65391089}, {4150,0.68106931}, {4200,0.69785149}, {4250,0.68932673}, {4300,0.68603960}, {4350,0.70707921}, {4400,0.70805941}, {4450,0.71412871}, {4500,0.75707921}, {4550,0.74017822}, {4600,0.74274257}, {4650,0.75841584}, {4700,0.75674257}, {4750,0.77986139}, {4800,0.77741584}, {4850,0.80502970}, {4900,0.78277228}, {4950,0.83122772}, {5000,0.80779208}, {5050,0.83034653}, {5100,0.82608911}, {5150,0.85113861}, {5200,0.84619802}, {5250,0.86862376}, {5300,0.87881188}, {5350,0.87064356}, {5400,0.89415842}, {5450,0.88566337}, {5500,0.89179208}, {5550,0.93163366}, {5600,0.89894059}, {5650,0.90936634}, {5700,0.94240594}, {5750,0.95404950}, {5800,0.92831683}, {5850,0.96555446}, {5900,0.95479208}, {5950,0.97444554}, {6000,0.98787129}, {6050,1.0281714}, {6100,1.0560571}, {6150,1.0402000}, {6200,1.0293429}, {6250,1.0363429}, {6300,1.0596286}, {6350,1.0843714}, {6400,1.0871143}, {6450,1.1006286}, {6500,1.1008000}, {6550,1.1118571}, {6600,1.1219143}, {6650,1.1345143}, {6700,1.1447143}, {6750,1.1625143}, {6800,1.1721714}, {6850,1.1654286}, {6900,1.1898571}, {6950,1.1936571}, {7000,1.2130571}, {7050,1.2085429}, {7100,1.2074571}, {7150,1.2255143}, {7200,1.2016857}, {7250,1.2170286}, {7300,1.2112286}, {7350,1.2466857}, {7400,1.2676857}, {7450,1.2958857}, {7500,1.3090571}, {7550,1.3157429}, {7600,1.2942286}, {7650,1.3240000}, {7700,1.2918857}, {7750,1.3051714}, {7800,1.3796571}, {7850,1.3690000}, {7900,1.3622000}, {7950,1.3680571}, {8000,1.3401429}, {8050,1.3861429}, {8100,1.4305714}, {8150,1.3933143}, {8200,1.4017143}, {8250,1.3831429}, {8300,1.4463143}, {8350,1.4501714}, {8400,1.4296857}, {8450,1.4282857}, {8500,1.4702571}, {8550,1.4838857}, {8600,1.4837714}, {8650,1.4660286}, {8700,1.5274286}, {8750,1.5166571}, {8800,1.4759143}, {8850,1.5515143}, {8900,1.5214571}, {8950,1.5004857}, {9000,1.5731714}, {9050,1.5560857}, {9100,1.5424000}, {9150,1.6022286}, {9200,1.5902571}, {9250,1.5726857}, {9300,1.6217143}, {9350,1.6072857}, {9400,1.6237143}, {9450,1.6367714}, {9500,1.6091714}, {9550,1.6428286}, {9600,1.6196857}, {9650,1.6823714}, {9700,1.6525143}, {9750,1.7132857}, {9800,1.6872571}, {9850,1.7293714}, {9900,1.6976857}, {9950,1.7592286}, {10000,1.6912857}, {10100,1.7766000}, {10200,1.7456571}, {10300,1.8124000}, {10400,1.7497714}, {10500,1.8334286}, {10600,1.7732857}, {10700,1.8368571}, {10800,1.8373429}, {10900,1.8849429}, {11000,1.8743714}, {11100,1.9310857}, {11200,1.8919143}, {11300,1.9366000}, {11400,1.9242571}, {11500,1.9794571}, {11600,1.9827714}, {11700,1.9944000}, {11800,2.0150857}, {11900,2.0329714}, {12000,2.0393429}, {12100,2.0820000}, {12200,2.0804000}, {12300,2.1104571}, {12400,2.1455429}, {12500,2.1285143}, {12600,2.1329143}, {12700,2.1636000}, {12800,2.1695429}, {12900,2.2869429}, {13000,2.2044000}, {13100,2.2482571}, {13200,2.2632000}, {13300,2.2657429}, {13400,2.2588286}, {13500,2.3136286}, {13600,2.3202571}, {13700,2.3284286}, {13800,2.3375714}, {13900,2.3717143}, {14000,2.3864857}, {14100,2.4641714}, {14200,2.4294000}, {14300,2.4367714}, {14400,2.4393143}, {14500,2.5468857}, {14600,2.4776857}, {14700,2.8547143}, {14800,2.8003429}, {14900,2.6220857}, {15000,2.5491429}, {15100,2.5764000}, {15200,2.5870571}, {15300,2.6984571}, {15400,2.8210286}, {15500,2.7191714}, {15600,2.9546286}, {15700,2.6806571}, {15800,2.7786000}, {15900,2.7086286}, {16000,2.7890000}, {16100,2.7949714}, {16200,2.8116571}, {16300,2.8486000}, {16400,2.8557143}, {16500,3.1303429}, {16600,2.7956571}, {16700,2.8332286}, {16800,2.9461143}, {16900,2.8521143}, {17000,2.9696286}, {17100,2.9816571}, {17200,2.9447714}, {17300,3.0093143}, {17400,3.0029714}, {17500,2.9597429}, {17600,3.0762286}, {17700,3.0135714}, {17800,3.0154286}, {17900,3.0535429}, {18000,3.0502857}, {18100,3.0948000}, {18200,3.1084857}, {18300,3.1236857}, {18400,3.1044571}, {18500,3.1327143}, {18600,3.1434000}, {18700,3.1739714}, {18800,3.1941714}, {18900,3.2354286}, {19000,3.2459429}, {19100,3.2688000}, {19200,3.3419429}, {19300,3.3162286}, {19400,3.2989714}, {19500,3.4269429}, {19600,3.4281143}, {19700,3.5082571}, {19800,3.3635714}, {19900,3.4719714}, {20000,3.5031714}};
data["big_flat"]["LtacTacInTermPrimPair"]["reif"]["user"] = {{1,0.00032673}, {2,0.00036634}, {3,0.00071287}, {4,0.00070297}, {5,0.00083168}, {6,0.00121782}, {7,0.00100000}, {8,0.00150495}, {9,0.00104950}, {10,0.00114851}, {11,0.00106931}, {12,0.00178218}, {13,0.00150495}, {14,0.00159406}, {15,0.00188119}, {16,0.00200990}, {17,0.00200990}, {18,0.00222772}, {19,0.00242574}, {20,0.00228713}, {21,0.00257426}, {22,0.00265347}, {23,0.00303960}, {24,0.00292079}, {25,0.00304950}, {26,0.00291089}, {27,0.00324752}, {28,0.00333663}, {29,0.00339604}, {30,0.00345545}, {31,0.00397030}, {32,0.00375248}, {33,0.00409901}, {34,0.00383168}, {35,0.00451485}, {36,0.00456436}, {37,0.00457426}, {38,0.00497030}, {39,0.00706931}, {40,0.00488119}, {41,0.00532673}, {42,0.00547525}, {43,0.00521782}, {44,0.00559406}, {45,0.00571287}, {46,0.00576238}, {47,0.00631683}, {48,0.00647525}, {49,0.00600990}, {50,0.00647525}, {51,0.00825743}, {52,0.00652475}, {53,0.00700990}, {54,0.00706931}, {55,0.00700990}, {56,0.00725743}, {57,0.00726733}, {58,0.00719802}, {59,0.00757426}, {60,0.00767327}, {61,0.00752475}, {62,0.00767327}, {63,0.00799010}, {64,0.00793069}, {65,0.00795050}, {66,0.00840594}, {67,0.00813861}, {68,0.00822772}, {69,0.00873267}, {70,0.00892079}, {71,0.00859406}, {72,0.00864356}, {73,0.00929703}, {74,0.00923762}, {75,0.00940594}, {76,0.00933663}, {77,0.00939604}, {78,0.00987129}, {79,0.00997030}, {80,0.01039604}, {81,0.01032673}, {82,0.01047525}, {83,0.01487129}, {84,0.01055446}, {85,0.01059406}, {86,0.01095050}, {87,0.01135644}, {88,0.01078218}, {89,0.01133663}, {90,0.01128713}, {91,0.01181188}, {92,0.01161386}, {93,0.01169307}, {94,0.01183168}, {95,0.01208911}, {96,0.01201980}, {97,0.01246535}, {98,0.01209901}, {99,0.01236634}, {100,0.01286139}, {101,0.01265347}, {102,0.01296040}, {103,0.01331683}, {104,0.01296040}, {105,0.01339604}, {106,0.01353465}, {107,0.01340594}, {108,0.01411881}, {109,0.01726733}, {110,0.01402970}, {111,0.01394059}, {112,0.01424752}, {113,0.01438614}, {114,0.01437624}, {115,0.01918812}, {116,0.01493069}, {117,0.01479208}, {118,0.01502970}, {119,0.01514851}, {120,0.01760396}, {121,0.01569307}, {122,0.01563366}, {123,0.01547525}, {124,0.01747525}, {125,0.01623762}, {126,0.01596040}, {127,0.02118812}, {128,0.01637624}, {129,0.01666337}, {130,0.02247525}, {131,0.01664356}, {132,0.01717822}, {133,0.02126733}, {134,0.01703960}, {135,0.01708911}, {136,0.01805941}, {137,0.01736634}, {138,0.02339604}, {139,0.01763366}, {140,0.01739604}, {141,0.01774257}, {142,0.01788119}, {143,0.01774257}, {144,0.01770297}, {145,0.02003960}, {146,0.01786139}, {147,0.02096040}, {148,0.01849505}, {149,0.02056436}, {150,0.01840594}, {151,0.01886139}, {152,0.01865347}, {153,0.01923762}, {154,0.01902970}, {155,0.01887129}, {156,0.02427723}, {157,0.01938614}, {158,0.01945545}, {159,0.01958416}, {160,0.01977228}, {161,0.02209901}, {162,0.02026733}, {163,0.02035644}, {164,0.02353465}, {165,0.02016832}, {166,0.02066337}, {167,0.02260396}, {168,0.02093069}, {169,0.02108911}, {170,0.02106931}, {171,0.02640594}, {172,0.02143564}, {173,0.02107921}, {174,0.02199010}, {175,0.02563366}, {176,0.02232673}, {177,0.02226733}, {178,0.02204950}, {179,0.02246535}, {180,0.02632673}, {181,0.03151485}, {182,0.02275248}, {183,0.02321782}, {184,0.02310891}, {185,0.02350495}, {186,0.02317822}, {187,0.02529703}, {188,0.02861386}, {189,0.03158416}, {190,0.02396040}, {191,0.02420792}, {192,0.02419802}, {193,0.02440594}, {194,0.02450495}, {195,0.02490099}, {196,0.02463366}, {197,0.02510891}, {198,0.02508911}, {199,0.02497030}, {200,0.02510891}, {201,0.02513861}, {202,0.02543564}, {203,0.02550495}, {204,0.02546535}, {205,0.03439604}, {206,0.03268317}, {207,0.02889109}, {208,0.02812871}, {209,0.02638614}, {210,0.02629703}, {211,0.02615842}, {212,0.02689109}, {213,0.02661386}, {214,0.03717822}, {215,0.03050495}, {216,0.02694059}, {217,0.02749505}, {218,0.02689109}, {219,0.03640594}, {220,0.03028713}, {221,0.02761386}, {222,0.02795050}, {223,0.03855446}, {224,0.03158416}, {225,0.02792079}, {226,0.02810891}, {227,0.03707921}, {228,0.02879208}, {229,0.02872277}, {230,0.03815842}, {231,0.03044554}, {232,0.02932673}, {233,0.03838614}, {234,0.02899010}, {235,0.02943564}, {236,0.03635644}, {237,0.02973267}, {238,0.03017822}, {239,0.03158416}, {240,0.02996040}, {241,0.03632673}, {242,0.03060396}, {243,0.03943564}, {244,0.03045545}, {245,0.03155446}, {246,0.03089109}, {247,0.03093069}, {248,0.03072277}, {249,0.03162376}, {250,0.03132673}, {251,0.03271287}, {252,0.03198020}, {253,0.04165347}, {254,0.03200990}, {255,0.03806931}, {256,0.03218812}, {257,0.03381188}, {258,0.03237624}, {259,0.03241584}, {260,0.04000990}, {261,0.03268317}, {262,0.03308911}, {263,0.04380198}, {264,0.03310891}, {265,0.03471287}, {266,0.04360396}, {267,0.03407921}, {268,0.03383168}, {269,1.02335644}, {270,0.03449505}, {271,0.03416832}, {272,0.04006931}, {273,0.05043564}, {274,0.03468317}, {275,0.03503960}, {276,0.03831683}, {277,0.04588119}, {278,0.03580198}, {279,0.03565347}, {280,0.03558416}, {281,0.03938614}, {282,0.04422772}, {283,0.03709901}, {284,0.03609901}, {285,0.03658416}, {286,0.03649505}, {287,0.03680198}, {288,0.03896040}, {289,0.04251485}, {290,0.04485149}, {291,0.04781188}, {292,0.04894059}, {293,0.03744554}, {294,0.03769307}, {295,0.03730693}, {296,0.03728713}, {297,0.03758416}, {298,0.03743564}, {299,0.03790099}, {300,0.03823762}, {301,0.03836634}, {302,0.03828713}, {303,0.03905941}, {304,0.03867327}, {305,0.05748515}, {306,0.05399010}, {307,0.04861386}, {308,0.04654455}, {309,0.04396040}, {310,0.04045545}, {311,0.03911881}, {312,0.03932673}, {313,0.03931683}, {314,0.04160396}, {315,0.04988119}, {316,0.04548515}, {317,0.04041584}, {318,0.04046535}, {319,0.04044554}, {320,0.05107921}, {321,0.04592079}, {322,0.04037624}, {323,0.04064356}, {324,0.05387129}, {325,0.04772277}, {326,0.04159406}, {327,0.04141584}, {328,0.05198020}, {329,0.04547525}, {330,0.04107921}, {331,0.06263366}, {332,0.04967327}, {333,0.04221782}, {334,0.05824752}, {335,0.04722772}, {336,0.04221782}, {337,0.05518812}, {338,0.04470297}, {339,0.04282178}, {340,0.05012871}, {341,0.04370297}, {342,0.05514851}, {343,0.04423762}, {344,0.05849505}, {345,0.04611881}, {346,0.04381188}, {347,0.04797030}, {348,0.04464356}, {349,0.04861386}, {350,0.04466337}, {351,0.04849505}, {352,0.04425743}, {353,0.04769307}, {354,0.05864356}, {355,0.04500000}, {356,0.05599010}, {357,0.04546535}, {358,0.05614851}, {359,0.04589109}, {360,0.04865347}, {361,0.06066337}, {362,0.04621782}, {363,0.05272277}, {364,0.04659406}, {365,0.04631683}, {366,0.05364356}, {367,0.04679208}, {368,0.04693069}, {369,0.05283168}, {370,0.05884158}, {371,0.04723762}, {372,0.05008911}, {373,0.05657426}, {374,0.04818812}, {375,0.04795050}, {376,0.05018812}, {377,0.05654455}, {378,0.06164356}, {379,0.04818812}, {380,0.04874257}, {381,0.05319802}, {382,0.05892079}, {383,0.06255446}, {384,0.04839604}, {385,0.04869307}, {386,0.04913861}, {387,0.05155446}, {388,0.05516832}, {389,0.05838614}, {390,0.06207921}, {391,0.06348515}, {392,0.06541584}, {393,0.05015842}, {394,0.05003960}, {395,0.05054455}, {396,0.04979208}, {397,0.05076238}, {398,0.05070297}, {399,0.05061386}, {400,0.05071287}, {401,0.05074257}, {402,0.05070297}, {403,0.05181188}, {404,0.05133663}, {405,0.05160396}, {406,0.05162376}, {407,0.05199010}, {408,0.06750495}, {409,0.06601980}, {410,0.06325743}, {411,0.06134653}, {412,0.05827723}, {413,0.05539604}, {414,0.05277228}, {415,0.05279208}, {416,0.05500990}, {417,0.07271287}, {418,0.06466337}, {419,0.05809901}, {420,0.05323762}, {421,0.05349505}, {422,0.07005941}, {423,0.06330693}, {424,0.05658416}, {425,0.05350495}, {426,0.06980198}, {427,0.06307921}, {428,0.05554455}, {429,0.05461386}, {430,0.06667327}, {431,0.05922772}, {432,0.05476238}, {433,0.07203960}, {434,0.06311881}, {435,0.05512871}, {436,0.07043564}, {437,0.06079208}, {438,0.05555446}, {439,0.06656436}, {440,0.05570297}, {441,0.07235644}, {442,0.06109901}, {443,0.05634653}, {444,0.06416832}, {445,0.05643564}, {446,0.06647525}, {447,0.05701980}, {448,0.06821782}, {449,0.05635644}, {450,0.07072277}, {451,0.05770297}, {452,0.07486139}, {453,0.05766337}, {454,0.07127723}, {455,0.05822772}, {456,0.06848515}, {457,0.05812871}, {458,0.06525743}, {459,0.07628713}, {460,0.06102970}, {461,0.07135644}, {462,0.05904950}, {463,0.06555446}, {464,0.07443564}, {465,0.05900990}, {466,0.07042574}, {467,0.08505941}, {468,0.05950495}, {469,0.06948515}, {470,0.07856436}, {471,0.06065347}, {472,0.06670297}, {473,0.07380198}, {474,0.06055446}, {475,0.06206931}, {476,0.06803960}, {477,0.07391089}, {478,0.07904950}, {479,0.06155446}, {480,0.06578218}, {481,0.07522772}, {482,0.08102970}, {483,0.08339604}, {484,0.06187129}, {485,0.06403960}, {486,0.06896040}, {487,0.07261386}, {488,0.07498020}, {489,0.07794059}, {490,0.08108911}, {491,0.06233663}, {492,0.06247525}, {493,0.06291089}, {494,0.06581188}, {495,0.06687129}, {496,0.06900990}, {497,0.07125743}, {498,0.07112871}, {499,0.07218812}, {500,0.07248515}, {505,0.07246535}, {510,0.07052475}, {515,0.06730693}, {520,0.06573267}, {525,0.08498020}, {530,0.08065347}, {535,0.07487129}, {540,0.09188119}, {545,0.08148515}, {550,0.07032673}, {555,0.08248515}, {560,0.09302970}, {565,0.07963366}, {570,0.08764356}, {575,0.09963366}, {580,0.07942574}, {585,0.08686139}, {590,0.08887129}, {595,0.09131683}, {600,0.09340594}, {605,0.09267327}, {610,0.09153465}, {615,0.08922772}, {620,0.08819802}, {625,0.08363366}, {630,0.10385149}, {635,0.09296040}, {640,0.08632673}, {645,0.10177228}, {650,0.09087129}, {655,0.10336634}, {660,0.09088119}, {665,0.10987129}, {670,0.11421782}, {675,0.09514851}, {680,0.10278218}, {685,0.10682178}, {690,0.11049505}, {695,0.11340594}, {700,0.12909901}, {705,0.12060396}, {710,0.11892079}, {715,0.11557426}, {720,0.11110891}, {725,0.10791089}, {730,0.10854455}, {735,0.12473267}, {740,0.11490099}, {745,0.10431683}, {750,0.11709901}, {755,0.10607921}, {760,0.12722772}, {765,0.13310891}, {770,0.11334653}, {775,0.12201980}, {780,0.12778218}, {785,0.10979208}, {790,0.12155446}, {795,0.12086139}, {800,0.12178218}, {805,0.12133663}, {810,0.12134653}, {815,0.11603960}, {820,0.11914851}, {825,0.11375248}, {830,0.13371287}, {835,0.12530693}, {840,0.11839604}, {845,0.13893069}, {850,0.12589109}, {855,0.13823762}, {860,0.12491089}, {865,0.14755446}, {870,0.12297030}, {875,0.13143564}, {880,0.13605941}, {885,0.14235644}, {890,0.15715842}, {895,0.12728713}, {900,0.12717822}, {905,0.12759406}, {910,0.12804950}, {915,0.13177228}, {920,0.15257426}, {925,0.14562376}, {930,0.13917822}, {935,0.13351485}, {940,0.15577228}, {945,0.14450495}, {950,0.13267327}, {955,0.14410891}, {960,0.14034653}, {965,0.14790099}, {970,0.15465347}, {975,0.13877228}, {980,0.15469307}, {985,0.15212871}, {990,0.15702970}, {995,0.15914851}, {1000,0.17784158}, {1010,0.16116832}, {1020,0.16142574}, {1030,0.15856436}, {1040,0.15648515}, {1050,0.17412871}, {1060,0.15925743}, {1070,0.18290099}, {1080,0.16014851}, {1090,0.16295050}, {1100,0.16736634}, {1110,0.17426733}, {1120,0.17073267}, {1130,0.16615842}, {1140,0.20273267}, {1150,0.17844554}, {1160,0.18926733}, {1170,0.17253465}, {1180,0.19014851}, {1190,0.19254455}, {1200,0.18290099}, {1210,0.17973267}, {1220,0.19782178}, {1230,0.20637624}, {1240,0.18898020}, {1250,0.18103960}, {1260,0.21443564}, {1270,0.21162376}, {1280,0.19076238}, {1290,0.20568317}, {1300,0.20708911}, {1310,0.20587129}, {1320,0.21268317}, {1330,0.20327723}, {1340,0.21432673}, {1350,0.21997030}, {1360,0.20472277}, {1370,0.22453465}, {1380,0.20469307}, {1390,0.20890099}, {1400,0.21830693}, {1410,0.21378218}, {1420,0.22449505}, {1430,0.21553465}, {1440,0.22976238}, {1450,0.22273267}, {1460,0.21593069}, {1470,0.23390099}, {1480,0.23423762}, {1490,0.23493069}, {1500,0.22696040}, {1510,0.22456436}, {1520,0.22030693}, {1530,0.24380198}, {1540,0.24725743}, {1550,0.23424752}, {1560,0.26330693}, {1570,0.23731683}, {1580,0.27315842}, {1590,0.25777228}, {1600,0.24594059}, {1610,0.24390099}, {1620,0.25152475}, {1630,0.26525743}, {1640,0.26451485}, {1650,0.25506931}, {1660,0.25897030}, {1670,0.25703960}, {1680,0.26167327}, {1690,0.27524752}, {1700,0.25157426}, {1710,0.25944554}, {1720,0.24968317}, {1730,0.27965347}, {1740,0.29873267}, {1750,0.26675248}, {1760,0.29320792}, {1770,0.26703960}, {1780,0.28890099}, {1790,0.28317822}, {1800,0.28651485}, {1810,0.26827723}, {1820,0.27832673}, {1830,0.28951485}, {1840,0.29171287}, {1850,0.30859406}, {1860,0.29558416}, {1870,0.29512871}, {1880,0.29596040}, {1890,0.31360396}, {1900,0.28270297}, {1910,0.29060396}, {1920,0.30041584}, {1930,0.30849505}, {1940,0.31418812}, {1950,0.29113861}, {1960,0.31499010}, {1970,0.31147525}, {1980,0.31068317}, {1990,0.31151485}, {2000,0.30771287}, {2050,0.30686139}, {2100,0.33122772}, {2150,0.32550495}, {2200,0.34477228}, {2250,0.35934653}, {2300,0.35465347}, {2350,0.36241584}, {2400,0.38679208}, {2450,0.39690099}, {2500,0.43253465}, {2550,0.39799010}, {2600,0.39779208}, {2650,0.42310891}, {2700,0.42400000}, {2750,0.42178218}, {2800,0.45022772}, {2850,0.47386139}, {2900,0.48206931}, {2950,0.49424752}, {3000,0.51601980}, {3050,0.51062376}, {3100,0.53249505}, {3150,0.53195050}, {3200,0.52535644}, {3250,0.51805941}, {3300,0.53875248}, {3350,0.54154455}, {3400,0.55678218}, {3450,0.56379208}, {3500,0.58238614}, {3550,0.59188119}, {3600,0.59291089}, {3650,0.58847525}, {3700,0.59319802}, {3750,0.59383168}, {3800,0.60817822}, {3850,0.60560396}, {3900,0.63683168}, {3950,0.66661386}, {4000,0.62758416}, {4050,0.66200990}, {4100,0.65272277}, {4150,0.68008911}, {4200,0.69641584}, {4250,0.68810891}, {4300,0.68481188}, {4350,0.70550495}, {4400,0.70696040}, {4450,0.71276238}, {4500,0.75589109}, {4550,0.73892079}, {4600,0.74179208}, {4650,0.75706931}, {4700,0.75529703}, {4750,0.77824752}, {4800,0.77539604}, {4850,0.80310891}, {4900,0.78153465}, {4950,0.82957426}, {5000,0.80628713}, {5050,0.82842574}, {5100,0.82457426}, {5150,0.84927723}, {5200,0.84402970}, {5250,0.86688119}, {5300,0.87700990}, {5350,0.86875248}, {5400,0.89230693}, {5450,0.88403960}, {5500,0.88965347}, {5550,0.92947525}, {5600,0.89712871}, {5650,0.90765347}, {5700,0.94049505}, {5750,0.95229703}, {5800,0.92681188}, {5850,0.96363366}, {5900,0.95304950}, {5950,0.97265347}, {6000,0.98593069}, {6050,1.0262286}, {6100,1.0480571}, {6150,1.0390571}, {6200,1.0282286}, {6250,1.0299429}, {6300,1.0585429}, {6350,1.0832286}, {6400,1.0860000}, {6450,1.0996000}, {6500,1.0991714}, {6550,1.1105429}, {6600,1.1213429}, {6650,1.1335714}, {6700,1.1436286}, {6750,1.1602000}, {6800,1.1689714}, {6850,1.1644286}, {6900,1.1865714}, {6950,1.1908000}, {7000,1.2103429}, {7050,1.2072000}, {7100,1.2028000}, {7150,1.2243714}, {7200,1.2004571}, {7250,1.2152286}, {7300,1.2089714}, {7350,1.2403143}, {7400,1.2611429}, {7450,1.2940000}, {7500,1.3053714}, {7550,1.3130571}, {7600,1.2911143}, {7650,1.3175429}, {7700,1.2905143}, {7750,1.2989429}, {7800,1.3778286}, {7850,1.3655429}, {7900,1.3597143}, {7950,1.3654000}, {8000,1.3388286}, {8050,1.3836000}, {8100,1.4289714}, {8150,1.3917429}, {8200,1.4000857}, {8250,1.3818000}, {8300,1.4446857}, {8350,1.4486571}, {8400,1.4282571}, {8450,1.4263429}, {8500,1.4683714}, {8550,1.4821714}, {8600,1.4817143}, {8650,1.4639714}, {8700,1.5257714}, {8750,1.5149714}, {8800,1.4738571}, {8850,1.5492286}, {8900,1.5197429}, {8950,1.4988000}, {9000,1.5715429}, {9050,1.5543429}, {9100,1.5400857}, {9150,1.6006286}, {9200,1.5861429}, {9250,1.5673714}, {9300,1.6198571}, {9350,1.6045143}, {9400,1.6218286}, {9450,1.6348571}, {9500,1.6068857}, {9550,1.6406571}, {9600,1.6172857}, {9650,1.6800286}, {9700,1.6495429}, {9750,1.7110000}, {9800,1.6847429}, {9850,1.7270000}, {9900,1.6950000}, {9950,1.7562000}, {10000,1.6888286}, {10100,1.7740857}, {10200,1.7372857}, {10300,1.8101429}, {10400,1.7472286}, {10500,1.8310857}, {10600,1.7707714}, {10700,1.8353143}, {10800,1.8344857}, {10900,1.8818286}, {11000,1.8707143}, {11100,1.9284286}, {11200,1.8890857}, {11300,1.9332857}, {11400,1.9209143}, {11500,1.9764571}, {11600,1.9796000}, {11700,1.9915143}, {11800,2.0124571}, {11900,2.0304571}, {12000,2.0358286}, {12100,2.0783429}, {12200,2.0771429}, {12300,2.1071143}, {12400,2.1420571}, {12500,2.1252000}, {12600,2.1297429}, {12700,2.1592857}, {12800,2.1661143}, {12900,2.2829143}, {13000,2.2024286}, {13100,2.2441714}, {13200,2.2600286}, {13300,2.2626000}, {13400,2.2554000}, {13500,2.3109714}, {13600,2.3169143}, {13700,2.3255143}, {13800,2.3341429}, {13900,2.3688000}, {14000,2.3833429}, {14100,2.4607143}, {14200,2.4260857}, {14300,2.4334857}, {14400,2.4365714}, {14500,2.5442286}, {14600,2.4744571}, {14700,2.8515429}, {14800,2.7962571}, {14900,2.6185143}, {15000,2.5461714}, {15100,2.5730286}, {15200,2.5833429}, {15300,2.6945429}, {15400,2.8171714}, {15500,2.7153714}, {15600,2.9514857}, {15700,2.6776857}, {15800,2.7743143}, {15900,2.7058286}, {16000,2.7861429}, {16100,2.7918000}, {16200,2.8084571}, {16300,2.8447429}, {16400,2.8539429}, {16500,3.1276571}, {16600,2.7927714}, {16700,2.8304000}, {16800,2.9433429}, {16900,2.8496286}, {17000,2.9665714}, {17100,2.9774857}, {17200,2.9412000}, {17300,3.0058000}, {17400,2.9998000}, {17500,2.9566000}, {17600,3.0715714}, {17700,3.0101143}, {17800,3.0119714}, {17900,3.0503429}, {18000,3.0471714}, {18100,3.0916286}, {18200,3.1038857}, {18300,3.1199429}, {18400,3.1005143}, {18500,3.1291143}, {18600,3.1391143}, {18700,3.1696000}, {18800,3.1839714}, {18900,3.2157429}, {19000,3.2367429}, {19100,3.2565143}, {19200,3.3367714}, {19300,3.3108000}, {19400,3.2818286}, {19500,3.4104000}, {19600,3.4001429}, {19700,3.4886857}, {19800,3.3452286}, {19900,3.4681714}, {20000,3.4977714}};
data["big_flat"]["LtacTacInTermPrimPair"]["reif"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00006931}, {12,0.00000000}, {13,0.00000000}, {14,0.00002970}, {15,0.00000000}, {16,0.00000000}, {17,0.00003960}, {18,0.00002970}, {19,0.00000000}, {20,0.00003960}, {21,0.00000000}, {22,0.00000000}, {23,0.00003960}, {24,0.00003960}, {25,0.00000000}, {26,0.00003960}, {27,0.00000000}, {28,0.00011881}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00003960}, {33,0.00000000}, {34,0.00003960}, {35,0.00000000}, {36,0.00000000}, {37,0.00003960}, {38,0.00002970}, {39,0.00000000}, {40,0.00003960}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00002970}, {46,0.00000000}, {47,0.00000000}, {48,0.00003960}, {49,0.00000000}, {50,0.00006931}, {51,0.00019802}, {52,0.00007921}, {53,0.00000000}, {54,0.00002970}, {55,0.00000000}, {56,0.00003960}, {57,0.00000000}, {58,0.00006931}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00003960}, {66,0.00000000}, {67,0.00000000}, {68,0.00003960}, {69,0.00003960}, {70,0.00003960}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00003960}, {75,0.00011881}, {76,0.00003960}, {77,0.00000000}, {78,0.00000000}, {79,0.00003960}, {80,0.00007921}, {81,0.00003960}, {82,0.00000000}, {83,0.00007921}, {84,0.00002970}, {85,0.00000000}, {86,0.00007921}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00003960}, {91,0.00003960}, {92,0.00000000}, {93,0.00003960}, {94,0.00000000}, {95,0.00009901}, {96,0.00003960}, {97,0.00000000}, {98,0.00009901}, {99,0.00003960}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00003960}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00007921}, {108,0.00000000}, {109,0.00002970}, {110,0.00000000}, {111,0.00000000}, {112,0.00003960}, {113,0.00002970}, {114,0.00000000}, {115,0.00014851}, {116,0.00003960}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00003960}, {122,0.00000000}, {123,0.00011881}, {124,0.00010891}, {125,0.00000000}, {126,0.00002970}, {127,0.00000000}, {128,0.00003960}, {129,0.00000000}, {130,0.00011881}, {131,0.00003960}, {132,0.00003960}, {133,0.00010891}, {134,0.00000000}, {135,0.00000000}, {136,0.00007921}, {137,0.00011881}, {138,0.00003960}, {139,0.00003960}, {140,0.00010891}, {141,0.00003960}, {142,0.00002970}, {143,0.00002970}, {144,0.00000000}, {145,0.00010891}, {146,0.00003960}, {147,0.00005941}, {148,0.00000000}, {149,0.00006931}, {150,0.00002970}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00003960}, {155,0.00000000}, {156,0.00011881}, {157,0.00006931}, {158,0.00003960}, {159,0.00000000}, {160,0.00000000}, {161,0.00003960}, {162,0.00003960}, {163,0.00000000}, {164,0.00022772}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00007921}, {169,0.00000000}, {170,0.00000000}, {171,0.00024752}, {172,0.00007921}, {173,0.00000000}, {174,0.00000000}, {175,0.00006931}, {176,0.00003960}, {177,0.00007921}, {178,0.00007921}, {179,0.00003960}, {180,0.00003960}, {181,0.00015842}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00003960}, {188,0.00011881}, {189,0.00007921}, {190,0.00003960}, {191,0.00000000}, {192,0.00000000}, {193,0.00007921}, {194,0.00000000}, {195,0.00007921}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00003960}, {200,0.00011881}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00031683}, {206,0.00011881}, {207,0.00011881}, {208,0.00011881}, {209,0.00002970}, {210,0.00000000}, {211,0.00000000}, {212,0.00003960}, {213,0.00000000}, {214,0.00019802}, {215,0.00010891}, {216,0.00003960}, {217,0.00000000}, {218,0.00003960}, {219,0.00034653}, {220,0.00007921}, {221,0.00000000}, {222,0.00000000}, {223,0.00031683}, {224,0.00011881}, {225,0.00000000}, {226,0.00003960}, {227,0.00026733}, {228,0.00000000}, {229,0.00000000}, {230,0.00018812}, {231,0.00003960}, {232,0.00002970}, {233,0.00019802}, {234,0.00000000}, {235,0.00003960}, {236,0.00034653}, {237,0.00003960}, {238,0.00003960}, {239,0.00011881}, {240,0.00011881}, {241,0.00000000}, {242,0.00000000}, {243,0.00007921}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00003960}, {249,0.00000000}, {250,0.00003960}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00003960}, {256,0.00002970}, {257,0.00003960}, {258,0.00003960}, {259,0.00000000}, {260,0.00000000}, {261,0.00003960}, {262,0.00003960}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00003960}, {267,0.00000000}, {268,0.00000000}, {269,0.00234653}, {270,0.00000000}, {271,0.00000000}, {272,0.00015842}, {273,0.00000000}, {274,0.00000000}, {275,0.00011881}, {276,0.00003960}, {277,0.00003960}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003960}, {282,0.00000000}, {283,0.00000000}, {284,0.00007921}, {285,0.00000000}, {286,0.00007921}, {287,0.00003960}, {288,0.00000000}, {289,0.00003960}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00003960}, {294,0.00002970}, {295,0.00003960}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00003960}, {308,0.00002970}, {309,0.00003960}, {310,0.00007921}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00003960}, {317,0.00000000}, {318,0.00003960}, {319,0.00000000}, {320,0.00007921}, {321,0.00000000}, {322,0.00003960}, {323,0.00011881}, {324,0.00007921}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00003960}, {329,0.00003960}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00011881}, {334,0.00003960}, {335,0.00003960}, {336,0.00003960}, {337,0.00000000}, {338,0.00007921}, {339,0.00003960}, {340,0.00003960}, {341,0.00002970}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00003960}, {347,0.00003960}, {348,0.00003960}, {349,0.00011881}, {350,0.00003960}, {351,0.00011881}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00006931}, {356,0.00000000}, {357,0.00006931}, {358,0.00019802}, {359,0.00000000}, {360,0.00007921}, {361,0.00003960}, {362,0.00007921}, {363,0.00003960}, {364,0.00007921}, {365,0.00000000}, {366,0.00011881}, {367,0.00003960}, {368,0.00003960}, {369,0.00003960}, {370,0.00014851}, {371,0.00006931}, {372,0.00003960}, {373,0.00003960}, {374,0.00000000}, {375,0.00007921}, {376,0.00003960}, {377,0.00000000}, {378,0.00003960}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00003960}, {385,0.00003960}, {386,0.00000000}, {387,0.00002970}, {388,0.00003960}, {389,0.00003960}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00003960}, {399,0.00000000}, {400,0.00003960}, {401,0.00003960}, {402,0.00000000}, {403,0.00003960}, {404,0.00003960}, {405,0.00003960}, {406,0.00007921}, {407,0.00003960}, {408,0.00003960}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00003960}, {413,0.00003960}, {414,0.00003960}, {415,0.00000000}, {416,0.00002970}, {417,0.00000000}, {418,0.00003960}, {419,0.00000000}, {420,0.00000000}, {421,0.00003960}, {422,0.00003960}, {423,0.00003960}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00003960}, {429,0.00003960}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00003960}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00003960}, {438,0.00003960}, {439,0.00000000}, {440,0.00000000}, {441,0.00003960}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00003960}, {446,0.00003960}, {447,0.00003960}, {448,0.00003960}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00003960}, {453,0.00003960}, {454,0.00000000}, {455,0.00003960}, {456,0.00003960}, {457,0.00000000}, {458,0.00011881}, {459,0.00000000}, {460,0.00000000}, {461,0.00003960}, {462,0.00000000}, {463,0.00007921}, {464,0.00000000}, {465,0.00003960}, {466,0.00000000}, {467,0.00007921}, {468,0.00003960}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00003960}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00003960}, {480,0.00000000}, {481,0.00002970}, {482,0.00000000}, {483,0.00000000}, {484,0.00007921}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00007921}, {492,0.00000000}, {493,0.00011881}, {494,0.00003960}, {495,0.00007921}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00003960}, {500,0.00000000}, {505,0.00007921}, {510,0.00007921}, {515,0.00000000}, {520,0.00003960}, {525,0.00003960}, {530,0.00003960}, {535,0.00003960}, {540,0.00000000}, {545,0.00003960}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00003960}, {570,0.00015842}, {575,0.00000000}, {580,0.00003960}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00003960}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00003960}, {645,0.00000000}, {650,0.00000000}, {655,0.00003960}, {660,0.00022772}, {665,0.00000000}, {670,0.00007921}, {675,0.00000000}, {680,0.00007921}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00007921}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00003960}, {730,0.00003960}, {735,0.00003960}, {740,0.00007921}, {745,0.00000000}, {750,0.00003960}, {755,0.00000000}, {760,0.00003960}, {765,0.00000000}, {770,0.00003960}, {775,0.00000000}, {780,0.00003960}, {785,0.00000000}, {790,0.00007921}, {795,0.00000000}, {800,0.00002970}, {805,0.00003960}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00014851}, {830,0.00003960}, {835,0.00000000}, {840,0.00000000}, {845,0.00003960}, {850,0.00000000}, {855,0.00003960}, {860,0.00000000}, {865,0.00007921}, {870,0.00000000}, {875,0.00002970}, {880,0.00003960}, {885,0.00007921}, {890,0.00003960}, {895,0.00003960}, {900,0.00003960}, {905,0.00000000}, {910,0.00000000}, {915,0.00003960}, {920,0.00003960}, {925,0.00002970}, {930,0.00014851}, {935,0.00003960}, {940,0.00000000}, {945,0.00006931}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00007921}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00003960}, {990,0.00007921}, {995,0.00000000}, {1000,0.00011881}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00014851}, {1050,0.00000000}, {1060,0.00007921}, {1070,0.00003960}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00003960}, {1110,0.00003960}, {1120,0.00011881}, {1130,0.00000000}, {1140,0.00003960}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00003960}, {1180,0.00000000}, {1190,0.00003960}, {1200,0.00000000}, {1210,0.00010891}, {1220,0.00003960}, {1230,0.00000000}, {1240,0.00003960}, {1250,0.00007921}, {1260,0.00003960}, {1270,0.00015842}, {1280,0.00003960}, {1290,0.00000000}, {1300,0.00007921}, {1310,0.00003960}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00007921}, {1370,0.00003960}, {1380,0.00003960}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00003960}, {1420,0.00003960}, {1430,0.00007921}, {1440,0.00011881}, {1450,0.00003960}, {1460,0.00003960}, {1470,0.00003960}, {1480,0.00011881}, {1490,0.00000000}, {1500,0.00003960}, {1510,0.00011881}, {1520,0.00007921}, {1530,0.00007921}, {1540,0.00011881}, {1550,0.00003960}, {1560,0.00007921}, {1570,0.00000000}, {1580,0.00003960}, {1590,0.00000000}, {1600,0.00010891}, {1610,0.00003960}, {1620,0.00002970}, {1630,0.00000000}, {1640,0.00002970}, {1650,0.00007921}, {1660,0.00000000}, {1670,0.00003960}, {1680,0.00006931}, {1690,0.00003960}, {1700,0.00000000}, {1710,0.00007921}, {1720,0.00000000}, {1730,0.00003960}, {1740,0.00007921}, {1750,0.00007921}, {1760,0.00015842}, {1770,0.00003960}, {1780,0.00007921}, {1790,0.00018812}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00003960}, {1840,0.00003960}, {1850,0.00000000}, {1860,0.00007921}, {1870,0.00000000}, {1880,0.00003960}, {1890,0.00011881}, {1900,0.00000000}, {1910,0.00011881}, {1920,0.00003960}, {1930,0.00000000}, {1940,0.00007921}, {1950,0.00000000}, {1960,0.00014851}, {1970,0.00007921}, {1980,0.00007921}, {1990,0.00003960}, {2000,0.00011881}, {2050,0.00007921}, {2100,0.00003960}, {2150,0.00003960}, {2200,0.00007921}, {2250,0.00007921}, {2300,0.00007921}, {2350,0.00000000}, {2400,0.00007921}, {2450,0.00026733}, {2500,0.00000000}, {2550,0.00002970}, {2600,0.00000000}, {2650,0.00007921}, {2700,0.00007921}, {2750,0.00000000}, {2800,0.00015842}, {2850,0.00000000}, {2900,0.00011881}, {2950,0.00003960}, {3000,0.00007921}, {3050,0.00000000}, {3100,0.00408911}, {3150,0.00027723}, {3200,0.00006931}, {3250,0.00003960}, {3300,0.00003960}, {3350,0.00015842}, {3400,0.00007921}, {3450,0.00015842}, {3500,0.00014851}, {3550,0.00003960}, {3600,0.00003960}, {3650,0.00003960}, {3700,0.00000000}, {3750,0.00003960}, {3800,0.00015842}, {3850,0.00003960}, {3900,0.00007921}, {3950,0.00003960}, {4000,0.00015842}, {4050,0.00007921}, {4100,0.00000000}, {4150,0.00007921}, {4200,0.00000000}, {4250,0.00003960}, {4300,0.00019802}, {4350,0.00011881}, {4400,0.00015842}, {4450,0.00003960}, {4500,0.00000000}, {4550,0.00007921}, {4600,0.00007921}, {4650,0.00003960}, {4700,0.00007921}, {4750,0.00015842}, {4800,0.00015842}, {4850,0.00035644}, {4900,0.00003960}, {4950,0.00015842}, {5000,0.00019802}, {5050,0.00035644}, {5100,0.00015842}, {5150,0.00003960}, {5200,0.00063366}, {5250,0.00011881}, {5300,0.00011881}, {5350,0.00010891}, {5400,0.00011881}, {5450,0.00007921}, {5500,0.00011881}, {5550,0.00003960}, {5600,0.00010891}, {5650,0.00000000}, {5700,0.00002970}, {5750,0.00007921}, {5800,0.00007921}, {5850,0.00015842}, {5900,0.00011881}, {5950,0.00003960}, {6000,0.00015842}, {6050,0.0008000}, {6100,0.0070000}, {6150,0.0001143}, {6200,0.0002286}, {6250,0.0055143}, {6300,0.0000000}, {6350,0.0000000}, {6400,0.0001143}, {6450,0.0000000}, {6500,0.0003429}, {6550,0.0004286}, {6600,0.0001143}, {6650,0.0000000}, {6700,0.0002286}, {6750,0.0000000}, {6800,0.0004571}, {6850,0.0000000}, {6900,0.0000000}, {6950,0.0004571}, {7000,0.0004571}, {7050,0.0002286}, {7100,0.0000000}, {7150,0.0003429}, {7200,0.0001143}, {7250,0.0000000}, {7300,0.0002000}, {7350,0.0000000}, {7400,0.0004571}, {7450,0.0000000}, {7500,0.0000000}, {7550,0.0001143}, {7600,0.0000000}, {7650,0.0002286}, {7700,0.0000000}, {7750,0.0001143}, {7800,0.0001143}, {7850,0.0001143}, {7900,0.0000000}, {7950,0.0002286}, {8000,0.0000000}, {8050,0.0002286}, {8100,0.0000000}, {8150,0.0000000}, {8200,0.0000857}, {8250,0.0001143}, {8300,0.0000000}, {8350,0.0002286}, {8400,0.0000000}, {8450,0.0000000}, {8500,0.0002000}, {8550,0.0002286}, {8600,0.0001143}, {8650,0.0003429}, {8700,0.0001143}, {8750,0.0000857}, {8800,0.0001143}, {8850,0.0001143}, {8900,0.0000000}, {8950,0.0000000}, {9000,0.0001143}, {9050,0.0000000}, {9100,0.0003429}, {9150,0.0000000}, {9200,0.0001143}, {9250,0.0003429}, {9300,0.0001143}, {9350,0.0003429}, {9400,0.0002286}, {9450,0.0000000}, {9500,0.0001143}, {9550,0.0003429}, {9600,0.0000000}, {9650,0.0001143}, {9700,0.0002000}, {9750,0.0000000}, {9800,0.0002286}, {9850,0.0000000}, {9900,0.0002000}, {9950,0.0003429}, {10000,0.0003429}, {10100,0.0001143}, {10200,0.0057429}, {10300,0.0001143}, {10400,0.0001143}, {10500,0.0002286}, {10600,0.0002000}, {10700,0.0002286}, {10800,0.0000000}, {10900,0.0000000}, {11000,0.0003429}, {11100,0.0000000}, {11200,0.0001143}, {11300,0.0004286}, {11400,0.0003429}, {11500,0.0002286}, {11600,0.0001143}, {11700,0.0000000}, {11800,0.0001143}, {11900,0.0000000}, {12000,0.0001143}, {12100,0.0002286}, {12200,0.0003429}, {12300,0.0001143}, {12400,0.0001143}, {12500,0.0000000}, {12600,0.0001143}, {12700,0.0005714}, {12800,0.0000000}, {12900,0.0012571}, {13000,0.0000000}, {13100,0.0006857}, {13200,0.0002286}, {13300,0.0002286}, {13400,0.0002286}, {13500,0.0000000}, {13600,0.0000000}, {13700,0.0001143}, {13800,0.0003429}, {13900,0.0001143}, {14000,0.0007714}, {14100,0.0010286}, {14200,0.0005714}, {14300,0.0004571}, {14400,0.0001143}, {14500,0.0001143}, {14600,0.0003429}, {14700,0.0005714}, {14800,0.0008000}, {14900,0.0004571}, {15000,0.0002286}, {15100,0.0002286}, {15200,0.0007429}, {15300,0.0009143}, {15400,0.0010000}, {15500,0.0008000}, {15600,0.0002286}, {15700,0.0008000}, {15800,0.0013429}, {15900,0.0002000}, {16000,0.0004571}, {16100,0.0003429}, {16200,0.0006857}, {16300,0.0021429}, {16400,0.0004571}, {16500,0.0012571}, {16600,0.0010286}, {16700,0.0010286}, {16800,0.0002286}, {16900,0.0006571}, {17000,0.0009143}, {17100,0.0014857}, {17200,0.0005429}, {17300,0.0006857}, {17400,0.0005714}, {17500,0.0001143}, {17600,0.0014857}, {17700,0.0003429}, {17800,0.0006571}, {17900,0.0004571}, {18000,0.0003429}, {18100,0.0002286}, {18200,0.0014857}, {18300,0.0003429}, {18400,0.0005714}, {18500,0.0002286}, {18600,0.0003429}, {18700,0.0008000}, {18800,0.0006286}, {18900,0.0002286}, {19000,0.0006857}, {19100,0.0004571}, {19200,0.0010286}, {19300,0.0016000}, {19400,0.0007714}, {19500,0.0003429}, {19600,0.0003429}, {19700,0.0029714}, {19800,0.0021714}, {19900,0.0009143}, {20000,0.0029429}};
data["big_flat"]["Mtac2"]["Aggregate"]["real"] = {{1,0.001413146}, {2,0.001112676}, {3,0.001117371}, {4,0.001122066}, {5,0.001122066}, {6,0.001122066}, {7,0.001122066}, {8,0.001122066}, {9,0.001169014}, {10,0.001215962}, {11,0.001530516}, {12,0.002056338}, {13,0.002122066}, {14,0.002122066}, {15,0.002122066}, {16,0.002122066}, {17,0.002122066}, {18,0.002122066}, {19,0.002140845}, {20,0.020492958}, {21,0.002469484}, {22,0.002826291}, {23,0.003028169}, {24,0.003061033}, {25,0.003061033}, {26,0.003093897}, {27,0.003093897}, {28,0.003126761}, {29,0.003187793}, {30,0.003211268}, {31,0.003441315}, {32,0.003854460}, {33,0.004046948}, {34,0.004061033}, {35,0.004061033}, {36,0.004065728}, {37,0.004070423}, {38,0.004098592}, {39,0.004122066}, {40,0.004352113}, {41,0.004798122}, {42,0.004990610}, {43,0.005009390}, {44,0.005042254}, {45,0.006037559}, {46,0.005070423}, {47,0.005103286}, {48,0.005187793}, {49,0.005399061}, {50,0.005901408}, {51,0.005990610}, {52,0.006000000}, {53,0.006004695}, {54,0.006018779}, {55,0.006075117}, {56,0.006159624}, {57,0.006286385}, {58,0.006755869}, {59,0.007056338}, {60,0.008093897}, {61,0.007107981}, {62,0.007103286}, {63,0.007098592}, {64,0.007178404}, {65,0.007323944}, {66,0.007732394}, {67,0.007990610}, {68,0.008037559}, {69,0.008037559}, {70,0.008056338}, {71,0.008075117}, {72,0.009234742}, {73,0.008394366}, {74,0.008802817}, {75,0.008981221}, {76,0.009014085}, {77,0.009037559}, {78,0.009046948}, {79,0.009093897}, {80,0.009338028}, {81,0.009718310}, {82,0.010760563}, {83,0.010037559}, {84,0.010051643}, {85,0.010075117}, {86,0.010136150}, {87,0.010291080}, {88,0.010591549}, {89,0.010882629}, {90,0.011685446}, {91,0.011107981}, {92,0.011136150}, {93,0.011201878}, {94,0.011323944}, {95,0.011577465}, {96,0.011971831}, {97,0.012028169}, {98,0.013159624}, {99,0.012089202}, {100,0.012178404}, {101,0.012417840}, {102,0.012765258}, {103,0.012953052}, {104,0.013032864}, {105,0.014178404}, {106,0.013136150}, {107,0.013201878}, {108,0.013596244}, {109,0.013887324}, {110,0.014004695}, {111,0.014943662}, {112,0.014126761}, {113,0.014234742}, {114,0.014521127}, {115,0.014868545}, {116,0.015107981}, {117,0.016812207}, {118,0.015215962}, {119,0.015272300}, {120,0.015835681}, {121,0.016079812}, {122,0.016408451}, {123,0.018042254}, {124,0.017596244}, {125,0.017530516}, {126,0.017497653}, {127,0.017586854}, {128,0.019417840}, {129,0.017929577}, {130,0.017779343}, {131,0.017802817}, {132,0.018004695}, {133,0.019497653}, {134,0.018281690}, {135,0.018272300}, {136,0.018338028}, {137,0.018629108}, {138,0.020117371}, {139,0.019051643}, {140,0.019159624}, {141,0.019248826}, {142,0.021225352}, {143,0.019521127}, {144,0.019976526}, {145,0.020079812}, {146,0.020169014}, {147,0.021079812}, {148,0.020516432}, {149,0.020826291}, {150,0.021187793}, {151,0.022361502}, {152,0.021338028}, {153,0.021455399}, {154,0.021779343}, {155,0.022929577}, {156,0.022117371}, {157,0.022211268}, {158,0.023201878}, {159,0.022591549}, {160,0.023009390}, {161,0.023126761}, {162,0.025084507}, {163,0.023384977}, {164,0.023727700}, {165,0.023962441}, {166,0.025375587}, {167,0.024183099}, {168,0.024478873}, {169,0.026830986}, {170,0.025051643}, {171,0.025272300}, {172,0.025399061}, {173,0.026366197}, {174,0.025699531}, {175,0.025920188}, {176,0.027563380}, {177,0.026342723}, {178,0.026530516}, {179,0.028887324}, {180,0.027323944}, {181,0.027577465}, {182,0.029737089}, {183,0.027892019}, {184,0.028164319}, {185,0.030150235}, {186,0.028323944}, {187,0.028347418}, {188,0.031140845}, {189,0.028901408}, {190,0.029079812}, {191,0.031150235}, {192,0.029629108}, {193,0.029859155}, {194,0.031596244}, {195,0.030197183}, {196,0.030582160}, {197,0.031511737}, {198,0.030967136}, {199,0.033422535}, {200,0.031431925}, {201,0.031600939}, {202,0.033446009}, {203,0.032037559}, {204,0.033413146}, {205,0.032521127}, {206,0.032779343}, {207,0.034737089}, {208,0.033347418}, {209,0.033450704}, {210,0.033737089}, {211,0.033971831}, {212,0.035751174}, {213,0.034342723}, {214,0.037056338}, {215,0.034896714}, {216,0.035154930}, {217,0.036309859}, {218,0.035492958}, {219,0.039178404}, {220,0.036070423}, {221,0.040046948}, {222,0.036563380}, {223,0.036713615}, {224,0.038877934}, {225,0.037450704}, {226,0.039924883}, {227,0.037826291}, {228,0.040859155}, {229,0.038441315}, {230,0.041924883}, {231,0.038737089}, {232,0.042990610}, {233,0.039338028}, {234,0.043868545}, {235,0.039924883}, {236,0.044450704}, {237,0.040568075}, {238,0.042281690}, {239,0.040915493}, {240,0.042478873}, {241,0.041441315}, {242,0.043244131}, {243,0.041971831}, {244,0.046464789}, {245,0.042577465}, {246,0.047098592}, {247,0.043122066}, {248,0.047788732}, {249,0.043938967}, {250,0.049347418}, {251,0.045553991}, {252,0.049661972}, {253,0.049281690}, {254,0.050845070}, {255,0.047023474}, {256,0.049253521}, {257,0.050713615}, {258,0.046760563}, {259,0.050652582}, {260,0.047070423}, {261,0.050469484}, {262,0.047582160}, {263,0.050023474}, {264,0.053455399}, {265,0.048657277}, {266,0.052507042}, {267,0.048915493}, {268,0.051896714}, {269,0.051643192}, {270,0.050920188}, {271,0.055281690}, {272,0.052441315}, {273,0.055474178}, {274,0.057798122}, {275,0.052009390}, {276,0.055976526}, {277,0.052248826}, {278,0.054985915}, {279,0.056727700}, {280,0.052929577}, {281,0.055802817}, {282,0.057690141}, {283,0.053521127}, {284,0.056802817}, {285,0.057525822}, {286,0.054248826}, {287,0.056530516}, {288,0.058591549}, {289,0.055291080}, {290,0.057511737}, {291,0.059136150}, {292,0.056009390}, {293,0.058211268}, {294,0.059995305}, {295,0.057323944}, {296,0.060859155}, {297,0.061164319}, {298,0.060840376}, {299,0.058957746}, {300,0.060497653}, {301,0.061849765}, {302,0.059272300}, {303,0.060938967}, {304,0.062248826}, {305,0.063798122}, {306,0.060488263}, {307,0.062577465}, {308,0.063774648}, {309,0.065394366}, {310,0.061474178}, {311,0.063600939}, {312,0.065206573}, {313,0.066507042}, {314,0.063173709}, {315,0.064830986}, {316,0.066220657}, {317,0.067784038}, {318,0.065309859}, {319,0.064422535}, {320,0.065741784}, {321,0.067145540}, {322,0.068455399}, {323,0.068474178}, {324,0.066403756}, {325,0.068014085}, {326,0.068591549}, {327,0.069577465}, {328,0.071201878}, {329,0.067521127}, {330,0.068389671}, {331,0.069610329}, {332,0.070727700}, {333,0.072187793}, {334,0.073718310}, {335,0.074258216}, {336,0.072281690}, {337,0.072568075}, {338,0.072647887}, {339,0.072821596}, {340,0.074023474}, {341,0.074976526}, {342,0.076056338}, {343,0.077079812}, {344,0.074718310}, {345,0.073427230}, {346,0.074971831}, {347,0.075455399}, {348,0.076215962}, {349,0.077295775}, {350,0.078915493}, {351,0.078821596}, {352,0.079103286}, {353,0.079375587}, {354,0.080305164}, {355,0.080732394}, {356,0.081924883}, {357,0.082103286}, {358,0.082521127}, {359,0.082967136}, {360,0.080938967}, {361,0.080821596}, {362,0.080239437}, {363,0.080384977}, {364,0.081239437}, {365,0.082291080}, {366,0.083187793}, {367,0.082769953}, {368,0.083051643}, {369,0.083582160}, {370,0.083061033}, {371,0.084455399}, {372,0.084638498}, {373,0.088657277}, {374,0.089394366}, {375,0.089056338}, {376,0.089136150}, {377,0.088737089}, {378,0.088887324}, {379,0.088680751}, {380,0.088849765}, {381,0.089145540}, {382,0.088784038}, {383,0.089197183}, {384,0.089234742}, {385,0.089408451}, {386,0.089244131}, {387,0.089779343}, {388,0.093863850}, {389,0.093774648}, {390,0.093835681}, {391,0.093061033}, {392,0.093103286}, {393,0.093122066}, {394,0.093572770}, {395,0.094089202}, {396,0.097920188}, {397,0.096464789}, {398,0.097300469}, {399,0.094394366}, {400,0.098582160}, {401,0.096586854}, {402,0.097145540}, {403,0.100723005}, {404,0.100483568}, {405,0.100309859}, {406,0.099708920}, {407,0.099723005}, {408,0.103765258}, {409,0.102788732}, {410,0.101657277}, {411,0.101140845}, {412,0.101661972}, {413,0.104798122}, {414,0.103450704}, {415,0.103441315}, {416,0.103258216}, {417,0.108408451}, {418,0.105746479}, {419,0.105723005}, {420,0.104685446}, {421,0.107272300}, {422,0.105910798}, {423,0.104887324}, {424,0.108291080}, {425,0.107446009}, {426,0.106516432}, {427,0.106671362}, {428,0.109849765}, {429,0.108000000}, {430,0.107586854}, {431,0.110333333}, {432,0.109652582}, {433,0.109117371}, {434,0.112680751}, {435,0.110629108}, {436,0.110765258}, {437,0.116079812}, {438,0.110338028}, {439,0.111802817}, {440,0.115192488}, {441,0.113549296}, {442,0.116629108}, {443,0.115558685}, {444,0.114436620}, {445,0.116169014}, {446,0.115596244}, {447,0.117713615}, {448,0.117586854}, {449,0.117098592}, {450,0.118685446}, {451,0.117539906}, {452,0.119877934}, {453,0.118971831}, {454,0.120586854}, {455,0.120042254}, {456,0.119211268}, {457,0.121276995}, {458,0.120384977}, {459,0.122192488}, {460,0.121192488}, {461,0.122793427}, {462,0.121544601}, {463,0.123380282}, {464,0.123427230}, {465,0.124502347}, {466,0.123492958}, {467,0.125084507}, {468,0.124051643}, {469,0.126140845}, {470,0.125061033}, {471,0.127154930}, {472,0.126577465}, {473,0.127507042}, {474,0.129953052}, {475,0.128854460}, {476,0.129408451}, {477,0.128276995}, {478,0.130107981}, {479,0.129821596}, {480,0.130511737}, {481,0.133014085}, {482,0.131370892}, {483,0.132699531}, {484,0.133262911}, {485,0.133065728}, {486,0.134553991}, {487,0.133079812}, {488,0.134948357}, {489,0.139399061}, {490,0.137647887}, {491,0.138248826}, {492,0.140436620}, {493,0.137920188}, {494,0.139525822}, {495,0.140431925}, {496,0.139535211}, {497,0.141079812}, {498,0.142591549}, {499,0.140333333}, {500,0.143497653}, {505,0.146070423}, {510,0.149568075}, {515,0.149000000}, {520,0.151769953}, {525,0.152089202}, {530,0.155239437}, {535,0.157098592}, {540,0.161460094}, {545,0.162596244}, {550,0.167366197}, {555,0.167892019}, {560,0.171737089}, {565,0.172807512}, {570,0.178572770}, {575,0.179840376}, {580,0.185065728}, {585,0.184582160}, {590,0.187582160}, {595,0.190492958}, {600,0.193624413}, {605,0.194685446}, {610,0.199366197}, {615,0.200366197}, {620,0.204225352}, {625,0.205723005}, {630,0.210633803}, {635,0.213014085}, {640,0.216286385}, {645,0.219291080}, {650,0.224201878}, {655,0.223122066}, {660,0.227807512}, {665,0.230061033}, {670,0.234187793}, {675,0.237840376}, {680,0.240652582}, {685,0.243065728}, {690,0.246464789}, {695,0.250248826}, {700,0.258953052}, {705,0.258774648}, {710,0.263732394}, {715,0.268028169}, {720,0.272619718}, {725,0.275014085}, {730,0.279422535}, {735,0.279192488}, {740,0.286591549}, {745,0.290389671}, {750,0.290192488}, {755,0.296234742}, {760,0.302234742}, {765,0.296657277}, {770,0.303417840}, {775,0.305553991}, {780,0.310206573}, {785,0.311436620}, {790,0.317197183}, {795,0.322943662}, {800,0.324516432}, {805,0.328539906}, {810,0.337737089}, {815,0.335450704}, {820,0.340145540}, {825,0.342769953}, {830,0.345262911}, {835,0.349708920}, {840,0.351154930}, {845,0.356854460}, {850,0.360553991}, {855,0.363258216}, {860,0.367924883}, {865,0.372107981}, {870,0.376497653}, {875,0.383943662}, {880,0.385539906}, {885,0.386863850}, {890,0.392577465}, {895,0.402093897}, {900,0.406004695}, {905,0.409436620}, {910,0.410920188}, {915,0.418145540}, {920,0.419558685}, {925,0.425446009}, {930,0.425197183}, {935,0.430605634}, {940,0.438361502}, {945,0.435300469}, {950,0.441197183}, {955,0.448441315}, {960,0.450906103}, {965,0.454990610}, {970,0.459553991}, {975,0.464539906}, {980,0.468230047}, {985,0.473981221}, {990,0.481046948}, {995,0.482887324}, {1000,0.493516432}, {1010,0.496511737}, {1020,0.504455399}, {1030,0.513291080}, {1040,0.524798122}, {1050,0.542056338}, {1060,0.552647887}, {1070,0.559117371}, {1080,0.568666667}, {1090,0.577338028}, {1100,0.583009390}, {1110,0.592478873}, {1120,0.602126761}, {1130,0.611281690}, {1140,0.626319249}, {1150,0.643197183}, {1160,0.642741784}, {1170,0.655042254}, {1180,0.667103286}, {1190,0.674788732}, {1200,0.685854460}, {1210,0.692197183}, {1220,0.714389671}, {1230,0.725408451}, {1240,0.735295775}, {1250,0.747582160}, {1260,0.752352113}, {1270,0.765690141}, {1280,0.772816901}, {1290,0.784924883}, {1300,0.796920188}, {1310,0.812356808}, {1320,0.819633803}, {1330,0.838652582}, {1340,0.854474178}, {1350,0.851253521}, {1360,0.872408451}, {1370,0.888000000}, {1380,0.902882629}, {1390,0.903892019}, {1400,0.916455399}, {1410,0.926460094}, {1420,0.943276995}, {1430,0.957873239}, {1440,0.964572770}, {1450,0.976211268}, {1460,0.986272300}, {1470,1.002577465}, {1480,1.040370892}, {1490,1.045464789}, {1500,1.042197183}, {1510,1.066692}, {1520,1.068077}, {1530,1.093462}, {1540,1.102692}, {1550,1.114000}, {1560,1.116923}, {1570,1.131923}, {1580,1.163231}, {1590,1.164615}, {1600,1.179308}, {1610,1.193692}, {1620,1.202462}, {1630,1.231923}, {1640,1.236615}, {1650,1.247077}, {1660,1.259308}, {1670,1.274538}, {1680,1.294538}, {1690,1.307538}, {1700,1.312077}, {1710,1.334077}, {1720,1.365923}, {1730,1.360385}, {1740,1.389000}, {1750,1.387385}, {1760,1.403154}, {1770,1.440769}, {1780,1.447923}, {1790,1.445769}, {1800,1.460923}, {1810,1.475923}, {1820,1.511308}, {1830,1.512538}, {1840,1.524462}, {1850,1.538462}, {1860,1.558538}, {1870,1.581538}, {1880,1.624077}, {1890,1.604000}, {1900,1.620154}, {1910,1.640615}, {1920,1.660692}, {1930,1.666308}, {1940,1.688077}, {1950,1.701923}, {1960,1.716308}, {1970,1.742462}, {1980,1.740231}, {1990,1.765308}, {2000,1.810846}, {2050,1.865154}, {2100,1.957077}, {2150,2.023308}, {2200,2.112000}, {2250,2.228538}, {2300,2.299538}, {2350,2.402615}, {2400,2.490462}, {2450,2.622846}, {2500,2.696923}, {2550,2.801308}, {2600,2.913077}, {2650,3.010077}, {2700,3.126538}, {2750,3.266769}, {2800,3.342154}, {2850,3.450154}, {2900,3.574846}, {2950,3.697385}, {3000,3.891692}, {3050,3.960692}, {3100,4.076154}, {3150,4.204769}, {3200,4.358385}, {3250,4.465231}, {3300,4.626923}, {3350,4.764077}, {3400,4.885385}, {3450,5.012308}, {3500,5.156077}, {3550,5.323846}, {3600,5.448538}, {3650,5.617308}, {3700,5.776692}, {3750,5.901692}, {3800,6.089308}, {3850,6.203923}, {3900,6.398846}, {3950,6.537923}, {4000,6.730462}, {4050,6.868692}, {4100,7.092000}, {4150,7.234000}, {4200,7.403769}, {4250,7.541538}, {4300,7.732462}, {4350,7.870538}, {4400,8.137385}, {4450,8.346692}, {4500,8.482308}, {4550,8.686462}, {4600,8.847077}, {4650,8.997462}, {4700,9.236231}, {4750,9.397462}, {4800,9.595154}, {4850,9.802846}, {4900,9.967538}, {4950,10.233385}, {5000,10.410462}, {5050,10.638154}, {5100,10.891692}, {5150,11.144538}, {5200,11.322846}, {5250,11.517000}, {5300,11.761385}, {5350,11.944077}, {5400,12.167538}, {5450,12.432077}, {5500,12.596231}, {5550,12.834538}, {5600,13.136538}, {5650,13.331000}, {5700,13.615000}, {5750,13.818385}, {5800,14.093308}, {5850,14.362308}, {5900,14.589923}, {5950,14.841231}, {6000,15.096462}, {6050,15.390538}, {6100,15.627923}, {6150,15.841462}, {6200,16.215615}, {6250,16.442769}, {6300,16.723000}, {6350,16.974846}, {6400,17.266538}, {6450,17.594538}, {6500,17.791154}, {6550,18.124385}, {6600,18.364308}, {6650,18.731154}, {6700,18.982615}, {6750,19.265077}, {6800,19.609846}, {6850,20.008308}, {6900,20.175692}, {6950,20.458000}, {7000,20.705615}, {7050,21.031231}, {7100,21.336538}, {7150,21.649538}, {7200,21.914769}, {7250,22.232077}, {7300,22.417692}, {7350,22.820923}, {7400,23.249923}, {7450,23.622308}, {7500,23.857615}, {7550,24.238538}, {7600,24.408462}, {7650,24.958846}, {7700,25.300385}, {7750,25.573692}, {7800,25.890692}, {7850,26.123308}, {7900,26.513000}, {7950,26.739000}, {8000,27.348462}, {8050,27.578000}, {8100,27.895077}, {8150,28.237615}, {8200,28.574615}, {8250,29.037154}, {8300,29.301000}, {8350,29.706077}, {8400,30.035538}, {8450,30.473077}, {8500,30.692462}, {8550,31.189846}, {8600,31.519615}, {8650,31.880385}, {8700,32.381615}, {8750,32.591846}, {8800,33.137692}, {8850,33.436846}, {8900,33.823692}, {8950,34.318538}, {9000,34.683538}, {9050,34.915231}, {9100,35.645923}, {9150,35.903385}, {9200,36.266923}, {9250,36.575462}, {9300,36.958000}, {9350,37.266077}, {9400,37.667308}, {9450,37.983462}, {9500,38.562154}, {9550,38.887000}, {9600,39.313154}, {9650,39.651615}, {9700,40.530308}, {9750,40.935231}, {9800,41.142077}, {9850,41.583538}, {9900,42.058462}, {9950,42.564538}, {10000,42.968385}};
data["big_flat"]["Mtac2"]["Aggregate"]["user"] = {{1,0.000957746}, {2,0.001032864}, {3,0.001183099}, {4,0.001502347}, {5,0.001389671}, {6,0.001596244}, {7,0.001708920}, {8,0.001708920}, {9,0.001915493}, {10,0.001915493}, {11,0.002028169}, {12,0.002291080}, {13,0.002154930}, {14,0.002422535}, {15,0.002328638}, {16,0.002488263}, {17,0.002845070}, {18,0.002507042}, {19,0.002680751}, {20,0.020713615}, {21,0.002821596}, {22,0.003032864}, {23,0.003427230}, {24,0.003239437}, {25,0.003305164}, {26,0.003333333}, {27,0.003375587}, {28,0.003521127}, {29,0.003605634}, {30,0.003779343}, {31,0.003723005}, {32,0.003830986}, {33,0.003976526}, {34,0.004014085}, {35,0.004159624}, {36,0.004366197}, {37,0.004295775}, {38,0.004417840}, {39,0.004507042}, {40,0.004586854}, {41,0.004765258}, {42,0.004976526}, {43,0.004967136}, {44,0.004896714}, {45,0.006131455}, {46,0.005380282}, {47,0.005276995}, {48,0.005812207}, {49,0.005455399}, {50,0.005873239}, {51,0.005892019}, {52,0.006093897}, {53,0.006441315}, {54,0.006225352}, {55,0.006657277}, {56,0.006793427}, {57,0.006863850}, {58,0.006652582}, {59,0.007159624}, {60,0.008323944}, {61,0.007295775}, {62,0.007624413}, {63,0.007896714}, {64,0.007957746}, {65,0.007971831}, {66,0.008164319}, {67,0.008145540}, {68,0.008328638}, {69,0.008535211}, {70,0.008488263}, {71,0.008596244}, {72,0.009948357}, {73,0.009084507}, {74,0.009046948}, {75,0.009276995}, {76,0.009197183}, {77,0.009708920}, {78,0.009539906}, {79,0.009784038}, {80,0.009859155}, {81,0.010028169}, {82,0.011211268}, {83,0.010422535}, {84,0.010234742}, {85,0.010647887}, {86,0.010910798}, {87,0.010788732}, {88,0.010845070}, {89,0.011211268}, {90,0.012051643}, {91,0.011600939}, {92,0.011741784}, {93,0.011713615}, {94,0.011798122}, {95,0.012046948}, {96,0.012150235}, {97,0.012154930}, {98,0.013413146}, {99,0.012253521}, {100,0.012375587}, {101,0.012892019}, {102,0.012896714}, {103,0.013042254}, {104,0.013136150}, {105,0.014826291}, {106,0.013539906}, {107,0.013826291}, {108,0.013990610}, {109,0.014042254}, {110,0.014314554}, {111,0.015192488}, {112,0.014826291}, {113,0.014774648}, {114,0.014863850}, {115,0.015098592}, {116,0.015492958}, {117,0.017126761}, {118,0.015525822}, {119,0.015802817}, {120,0.016272300}, {121,0.016441315}, {122,0.016657277}, {123,0.018281690}, {124,0.018112676}, {125,0.017910798}, {126,0.017859155}, {127,0.017657277}, {128,0.019516432}, {129,0.018276995}, {130,0.018272300}, {131,0.018037559}, {132,0.018380282}, {133,0.019685446}, {134,0.018535211}, {135,0.018615023}, {136,0.018685446}, {137,0.019150235}, {138,0.020300469}, {139,0.019347418}, {140,0.019549296}, {141,0.019676056}, {142,0.021511737}, {143,0.019784038}, {144,0.020093897}, {145,0.020098592}, {146,0.020446009}, {147,0.020938967}, {148,0.020680751}, {149,0.021042254}, {150,0.021319249}, {151,0.022830986}, {152,0.021384977}, {153,0.021516432}, {154,0.022131455}, {155,0.023291080}, {156,0.022145540}, {157,0.022361502}, {158,0.023694836}, {159,0.023070423}, {160,0.023234742}, {161,0.023497653}, {162,0.025291080}, {163,0.023802817}, {164,0.023882629}, {165,0.024164319}, {166,0.025323944}, {167,0.024704225}, {168,0.024502347}, {169,0.026774648}, {170,0.025394366}, {171,0.025483568}, {172,0.025661972}, {173,0.026558685}, {174,0.025924883}, {175,0.025929577}, {176,0.027600939}, {177,0.026441315}, {178,0.026516432}, {179,0.028798122}, {180,0.027098592}, {181,0.027422535}, {182,0.029985915}, {183,0.027769953}, {184,0.028239437}, {185,0.030323944}, {186,0.028488263}, {187,0.028309859}, {188,0.031596244}, {189,0.029004695}, {190,0.029089202}, {191,0.031370892}, {192,0.029920188}, {193,0.030154930}, {194,0.031943662}, {195,0.030633803}, {196,0.030849765}, {197,0.031896714}, {198,0.031460094}, {199,0.033469484}, {200,0.031704225}, {201,0.031981221}, {202,0.033647887}, {203,0.032276995}, {204,0.033713615}, {205,0.032610329}, {206,0.033183099}, {207,0.034652582}, {208,0.033737089}, {209,0.033643192}, {210,0.033915493}, {211,0.034122066}, {212,0.035694836}, {213,0.034220657}, {214,0.036854460}, {215,0.034821596}, {216,0.035230047}, {217,0.036262911}, {218,0.035521127}, {219,0.039666667}, {220,0.036056338}, {221,0.040267606}, {222,0.036586854}, {223,0.036643192}, {224,0.039014085}, {225,0.037605634}, {226,0.040178404}, {227,0.037835681}, {228,0.041023474}, {229,0.038685446}, {230,0.041798122}, {231,0.039023474}, {232,0.042957746}, {233,0.039723005}, {234,0.043685446}, {235,0.040281690}, {236,0.044591549}, {237,0.040769953}, {238,0.042417840}, {239,0.041023474}, {240,0.042375587}, {241,0.041704225}, {242,0.043248826}, {243,0.041953052}, {244,0.046328638}, {245,0.042718310}, {246,0.047389671}, {247,0.043098592}, {248,0.048164319}, {249,0.043873239}, {250,0.049460094}, {251,0.045464789}, {252,0.049605634}, {253,0.049154930}, {254,0.051089202}, {255,0.047126761}, {256,0.049413146}, {257,0.050615023}, {258,0.046957746}, {259,0.050568075}, {260,0.047258216}, {261,0.050347418}, {262,0.047915493}, {263,0.050239437}, {264,0.053103286}, {265,0.048826291}, {266,0.052272300}, {267,0.049009390}, {268,0.051553991}, {269,0.051553991}, {270,0.050699531}, {271,0.054901408}, {272,0.052211268}, {273,0.055239437}, {274,0.057666667}, {275,0.051784038}, {276,0.055666667}, {277,0.051863850}, {278,0.054802817}, {279,0.056605634}, {280,0.052643192}, {281,0.055633803}, {282,0.057821596}, {283,0.053211268}, {284,0.056732394}, {285,0.057338028}, {286,0.054136150}, {287,0.056333333}, {288,0.058727700}, {289,0.055295775}, {290,0.057502347}, {291,0.059201878}, {292,0.055854460}, {293,0.058272300}, {294,0.060140845}, {295,0.057042254}, {296,0.060906103}, {297,0.061070423}, {298,0.061028169}, {299,0.059004695}, {300,0.060671362}, {301,0.061910798}, {302,0.059380282}, {303,0.061126761}, {304,0.062356808}, {305,0.063896714}, {306,0.060619718}, {307,0.062704225}, {308,0.063901408}, {309,0.065483568}, {310,0.061760563}, {311,0.063953052}, {312,0.065136150}, {313,0.066361502}, {314,0.063619718}, {315,0.064887324}, {316,0.066107981}, {317,0.067502347}, {318,0.065436620}, {319,0.064530516}, {320,0.065586854}, {321,0.066661972}, {322,0.068070423}, {323,0.068159624}, {324,0.066244131}, {325,0.067741784}, {326,0.068089202}, {327,0.069244131}, {328,0.071046948}, {329,0.067239437}, {330,0.068173709}, {331,0.069450704}, {332,0.070366197}, {333,0.071741784}, {334,0.073422535}, {335,0.074098592}, {336,0.071798122}, {337,0.072258216}, {338,0.072699531}, {339,0.072596244}, {340,0.074201878}, {341,0.074910798}, {342,0.075990610}, {343,0.077164319}, {344,0.074539906}, {345,0.073464789}, {346,0.075028169}, {347,0.075389671}, {348,0.076192488}, {349,0.077117371}, {350,0.079004695}, {351,0.079117371}, {352,0.079366197}, {353,0.079553991}, {354,0.080305164}, {355,0.080863850}, {356,0.081877934}, {357,0.082014085}, {358,0.082563380}, {359,0.082821596}, {360,0.081126761}, {361,0.080892019}, {362,0.080535211}, {363,0.080652582}, {364,0.081253521}, {365,0.082206573}, {366,0.082882629}, {367,0.082521127}, {368,0.082948357}, {369,0.083154930}, {370,0.083061033}, {371,0.084000000}, {372,0.084356808}, {373,0.088220657}, {374,0.089431925}, {375,0.088971831}, {376,0.089201878}, {377,0.088530516}, {378,0.088812207}, {379,0.088812207}, {380,0.088769953}, {381,0.089159624}, {382,0.088671362}, {383,0.089211268}, {384,0.089333333}, {385,0.089488263}, {386,0.089154930}, {387,0.089751174}, {388,0.094089202}, {389,0.093788732}, {390,0.093741784}, {391,0.093046948}, {392,0.093267606}, {393,0.092957746}, {394,0.093582160}, {395,0.093892019}, {396,0.097934272}, {397,0.096690141}, {398,0.097281690}, {399,0.094413146}, {400,0.098591549}, {401,0.096971831}, {402,0.097328638}, {403,0.100525822}, {404,0.100417840}, {405,0.100361502}, {406,0.099699531}, {407,0.099915493}, {408,0.103474178}, {409,0.102741784}, {410,0.101568075}, {411,0.101154930}, {412,0.101375587}, {413,0.104877934}, {414,0.103032864}, {415,0.103394366}, {416,0.102924883}, {417,0.108422535}, {418,0.105755869}, {419,0.105868545}, {420,0.104436620}, {421,0.107450704}, {422,0.105957746}, {423,0.104760563}, {424,0.108563380}, {425,0.107591549}, {426,0.106671362}, {427,0.106633803}, {428,0.110037559}, {429,0.107929577}, {430,0.107774648}, {431,0.110436620}, {432,0.109723005}, {433,0.109239437}, {434,0.112464789}, {435,0.110671362}, {436,0.110690141}, {437,0.115863850}, {438,0.110281690}, {439,0.111629108}, {440,0.114793427}, {441,0.113338028}, {442,0.115995305}, {443,0.115211268}, {444,0.113887324}, {445,0.115896714}, {446,0.115220657}, {447,0.117652582}, {448,0.117234742}, {449,0.116694836}, {450,0.118826291}, {451,0.117248826}, {452,0.120032864}, {453,0.118732394}, {454,0.120793427}, {455,0.120042254}, {456,0.119399061}, {457,0.121065728}, {458,0.120408451}, {459,0.122455399}, {460,0.121154930}, {461,0.122577465}, {462,0.121366197}, {463,0.123295775}, {464,0.123140845}, {465,0.124375587}, {466,0.123399061}, {467,0.124967136}, {468,0.123938967}, {469,0.126169014}, {470,0.124816901}, {471,0.127394366}, {472,0.126619718}, {473,0.127737089}, {474,0.130173709}, {475,0.129075117}, {476,0.129488263}, {477,0.128460094}, {478,0.130422535}, {479,0.130000000}, {480,0.130516432}, {481,0.132985915}, {482,0.131422535}, {483,0.132319249}, {484,0.133136150}, {485,0.132793427}, {486,0.134436620}, {487,0.133070423}, {488,0.134633803}, {489,0.139413146}, {490,0.137488263}, {491,0.138319249}, {492,0.140680751}, {493,0.137798122}, {494,0.139619718}, {495,0.140676056}, {496,0.139774648}, {497,0.141154930}, {498,0.142591549}, {499,0.140230047}, {500,0.143323944}, {505,0.145680751}, {510,0.149549296}, {515,0.148568075}, {520,0.151943662}, {525,0.151990610}, {530,0.155164319}, {535,0.157178404}, {540,0.161553991}, {545,0.162507042}, {550,0.167258216}, {555,0.167572770}, {560,0.171737089}, {565,0.172732394}, {570,0.178234742}, {575,0.179389671}, {580,0.184652582}, {585,0.184131455}, {590,0.187563380}, {595,0.190647887}, {600,0.193708920}, {605,0.194638498}, {610,0.199061033}, {615,0.200201878}, {620,0.204380282}, {625,0.205530516}, {630,0.210422535}, {635,0.212901408}, {640,0.216262911}, {645,0.219046948}, {650,0.224056338}, {655,0.222934272}, {660,0.227704225}, {665,0.229943662}, {670,0.233976526}, {675,0.237769953}, {680,0.240460094}, {685,0.242840376}, {690,0.246206573}, {695,0.249859155}, {700,0.258727700}, {705,0.258657277}, {710,0.262948357}, {715,0.268009390}, {720,0.272558685}, {725,0.274774648}, {730,0.279305164}, {735,0.279107981}, {740,0.286333333}, {745,0.290145540}, {750,0.290004695}, {755,0.295737089}, {760,0.302098592}, {765,0.296544601}, {770,0.303187793}, {775,0.305427230}, {780,0.309779343}, {785,0.311084507}, {790,0.316948357}, {795,0.322699531}, {800,0.324352113}, {805,0.328539906}, {810,0.337558685}, {815,0.335098592}, {820,0.339779343}, {825,0.342779343}, {830,0.344877934}, {835,0.349816901}, {840,0.351136150}, {845,0.356812207}, {850,0.360220657}, {855,0.362995305}, {860,0.367544601}, {865,0.371380282}, {870,0.376187793}, {875,0.383840376}, {880,0.385586854}, {885,0.386849765}, {890,0.392690141}, {895,0.401906103}, {900,0.405854460}, {905,0.409220657}, {910,0.410671362}, {915,0.418018779}, {920,0.419380282}, {925,0.425056338}, {930,0.424699531}, {935,0.430295775}, {940,0.438122066}, {945,0.434863850}, {950,0.441220657}, {955,0.448075117}, {960,0.450694836}, {965,0.454943662}, {970,0.459544601}, {975,0.464281690}, {980,0.467892019}, {985,0.473647887}, {990,0.480788732}, {995,0.482657277}, {1000,0.493469484}, {1010,0.495924883}, {1020,0.504164319}, {1030,0.513098592}, {1040,0.524647887}, {1050,0.541652582}, {1060,0.552272300}, {1070,0.558685446}, {1080,0.568427230}, {1090,0.576962441}, {1100,0.582910798}, {1110,0.592375587}, {1120,0.601694836}, {1130,0.610723005}, {1140,0.626079812}, {1150,0.643056338}, {1160,0.642417840}, {1170,0.654680751}, {1180,0.667018779}, {1190,0.674633803}, {1200,0.685558685}, {1210,0.691840376}, {1220,0.714098592}, {1230,0.724976526}, {1240,0.734615023}, {1250,0.747427230}, {1260,0.752333333}, {1270,0.765549296}, {1280,0.772784038}, {1290,0.784816901}, {1300,0.796633803}, {1310,0.811995305}, {1320,0.819446009}, {1330,0.838492958}, {1340,0.854014085}, {1350,0.850807512}, {1360,0.872000000}, {1370,0.887802817}, {1380,0.902563380}, {1390,0.903220657}, {1400,0.916319249}, {1410,0.926136150}, {1420,0.942985915}, {1430,0.957403756}, {1440,0.963840376}, {1450,0.975990610}, {1460,0.986173709}, {1470,1.002417840}, {1480,1.039943662}, {1490,1.044981221}, {1500,1.041807512}, {1510,1.064308}, {1520,1.065615}, {1530,1.091308}, {1540,1.102000}, {1550,1.113000}, {1560,1.115231}, {1570,1.130923}, {1580,1.162000}, {1590,1.162538}, {1600,1.178308}, {1610,1.191462}, {1620,1.201154}, {1630,1.231923}, {1640,1.236538}, {1650,1.246923}, {1660,1.258923}, {1670,1.273846}, {1680,1.294385}, {1690,1.307385}, {1700,1.312385}, {1710,1.334154}, {1720,1.365000}, {1730,1.360000}, {1740,1.388462}, {1750,1.387154}, {1760,1.403000}, {1770,1.440385}, {1780,1.448154}, {1790,1.445077}, {1800,1.460231}, {1810,1.475462}, {1820,1.511308}, {1830,1.512769}, {1840,1.524692}, {1850,1.538769}, {1860,1.558385}, {1870,1.581077}, {1880,1.623846}, {1890,1.603462}, {1900,1.619000}, {1910,1.640538}, {1920,1.661462}, {1930,1.666615}, {1940,1.687692}, {1950,1.700769}, {1960,1.716000}, {1970,1.742462}, {1980,1.739923}, {1990,1.764846}, {2000,1.810692}, {2050,1.864923}, {2100,1.955846}, {2150,2.022692}, {2200,2.112385}, {2250,2.228385}, {2300,2.299923}, {2350,2.402846}, {2400,2.490538}, {2450,2.621923}, {2500,2.696769}, {2550,2.801385}, {2600,2.912692}, {2650,3.010231}, {2700,3.126154}, {2750,3.266077}, {2800,3.342000}, {2850,3.448077}, {2900,3.574538}, {2950,3.697462}, {3000,3.890923}, {3050,3.961077}, {3100,4.075462}, {3150,4.204077}, {3200,4.358385}, {3250,4.465308}, {3300,4.625231}, {3350,4.760462}, {3400,4.886077}, {3450,5.011615}, {3500,5.155846}, {3550,5.323462}, {3600,5.448000}, {3650,5.616615}, {3700,5.775538}, {3750,5.901385}, {3800,6.088923}, {3850,6.202692}, {3900,6.398077}, {3950,6.535923}, {4000,6.729000}, {4050,6.867538}, {4100,7.091462}, {4150,7.233000}, {4200,7.403385}, {4250,7.540231}, {4300,7.731692}, {4350,7.870077}, {4400,8.136923}, {4450,8.345538}, {4500,8.481538}, {4550,8.687000}, {4600,8.845154}, {4650,8.996538}, {4700,9.235000}, {4750,9.397000}, {4800,9.595538}, {4850,9.802154}, {4900,9.966923}, {4950,10.232615}, {5000,10.410385}, {5050,10.637308}, {5100,10.890154}, {5150,11.142769}, {5200,11.321769}, {5250,11.516692}, {5300,11.760462}, {5350,11.941769}, {5400,12.165692}, {5450,12.429846}, {5500,12.594615}, {5550,12.833846}, {5600,13.134615}, {5650,13.329308}, {5700,13.614000}, {5750,13.817615}, {5800,14.091846}, {5850,14.360385}, {5900,14.588923}, {5950,14.839462}, {6000,15.095000}, {6050,15.388923}, {6100,15.624615}, {6150,15.839385}, {6200,16.212462}, {6250,16.441769}, {6300,16.722538}, {6350,16.971538}, {6400,17.264154}, {6450,17.592231}, {6500,17.789846}, {6550,18.123385}, {6600,18.361308}, {6650,18.726538}, {6700,18.979846}, {6750,19.263231}, {6800,19.606615}, {6850,20.001846}, {6900,20.173385}, {6950,20.454077}, {7000,20.702769}, {7050,21.027385}, {7100,21.334846}, {7150,21.645615}, {7200,21.911769}, {7250,22.229308}, {7300,22.414077}, {7350,22.818000}, {7400,23.242000}, {7450,23.616692}, {7500,23.850769}, {7550,24.233538}, {7600,24.403462}, {7650,24.951538}, {7700,25.297000}, {7750,25.568923}, {7800,25.885308}, {7850,26.118000}, {7900,26.507154}, {7950,26.734692}, {8000,27.338923}, {8050,27.571692}, {8100,27.892846}, {8150,28.234615}, {8200,28.572462}, {8250,29.033692}, {8300,29.298077}, {8350,29.705000}, {8400,30.031077}, {8450,30.471923}, {8500,30.692077}, {8550,31.188462}, {8600,31.517000}, {8650,31.879308}, {8700,32.377769}, {8750,32.589615}, {8800,33.134692}, {8850,33.430077}, {8900,33.819538}, {8950,34.312462}, {9000,34.675846}, {9050,34.909615}, {9100,35.614231}, {9150,35.896154}, {9200,36.264000}, {9250,36.572000}, {9300,36.952231}, {9350,37.261000}, {9400,37.662385}, {9450,37.978077}, {9500,38.556615}, {9550,38.880615}, {9600,39.308154}, {9650,39.644000}, {9700,40.524692}, {9750,40.922923}, {9800,41.134385}, {9850,41.573077}, {9900,42.054923}, {9950,42.558538}, {10000,42.962308}};
data["big_flat"]["Mtac2"]["Aggregate"]["system"] = {{1,0.000995305}, {2,0.000300469}, {3,0.000112676}, {4,0.000018779}, {5,0.000122066}, {6,0.000112676}, {7,0.000018779}, {8,0.000093897}, {9,0.000032864}, {10,0.000075117}, {11,0.000051643}, {12,0.000051643}, {13,0.000070423}, {14,0.000093897}, {15,0.000018779}, {16,0.000018779}, {17,0.000018779}, {18,0.000014085}, {19,0.000075117}, {20,0.000272300}, {21,0.000197183}, {22,0.000070423}, {23,0.000014085}, {24,0.000018779}, {25,0.000037559}, {26,0.000032864}, {27,0.000098592}, {28,0.000051643}, {29,0.000037559}, {30,0.000056338}, {31,0.000000000}, {32,0.000018779}, {33,0.000046948}, {34,0.000018779}, {35,0.000018779}, {36,0.000037559}, {37,0.000037559}, {38,0.000075117}, {39,0.000070423}, {40,0.000037559}, {41,0.000037559}, {42,0.000037559}, {43,0.000103286}, {44,0.000056338}, {45,0.000070423}, {46,0.000070423}, {47,0.000089202}, {48,0.000075117}, {49,0.000056338}, {50,0.000037559}, {51,0.000018779}, {52,0.000032864}, {53,0.000056338}, {54,0.000056338}, {55,0.000032864}, {56,0.000032864}, {57,0.000000000}, {58,0.000070423}, {59,0.000051643}, {60,0.000051643}, {61,0.000051643}, {62,0.000037559}, {63,0.000018779}, {64,0.000051643}, {65,0.000037559}, {66,0.000018779}, {67,0.000065728}, {68,0.000032864}, {69,0.000098592}, {70,0.000056338}, {71,0.000000000}, {72,0.000056338}, {73,0.000037559}, {74,0.000000000}, {75,0.000070423}, {76,0.000056338}, {77,0.000000000}, {78,0.000037559}, {79,0.000056338}, {80,0.000032864}, {81,0.000051643}, {82,0.000136150}, {83,0.000051643}, {84,0.000075117}, {85,0.000056338}, {86,0.000018779}, {87,0.000032864}, {88,0.000084507}, {89,0.000051643}, {90,0.000075117}, {91,0.000032864}, {92,0.000079812}, {93,0.000070423}, {94,0.000056338}, {95,0.000014085}, {96,0.000051643}, {97,0.000018779}, {98,0.000046948}, {99,0.000051643}, {100,0.000070423}, {101,0.000056338}, {102,0.000037559}, {103,0.000032864}, {104,0.000075117}, {105,0.000136150}, {106,0.000018779}, {107,0.000000000}, {108,0.000051643}, {109,0.000089202}, {110,0.000037559}, {111,0.000070423}, {112,0.000145540}, {113,0.000042254}, {114,0.000037559}, {115,0.000056338}, {116,0.000042254}, {117,0.000084507}, {118,0.000037559}, {119,0.000000000}, {120,0.000037559}, {121,0.000046948}, {122,0.000056338}, {123,0.000051643}, {124,0.000056338}, {125,0.000032864}, {126,0.000070423}, {127,0.000093897}, {128,0.000089202}, {129,0.000070423}, {130,0.000018779}, {131,0.000065728}, {132,0.000000000}, {133,0.000056338}, {134,0.000051643}, {135,0.000014085}, {136,0.000093897}, {137,0.000037559}, {138,0.000046948}, {139,0.000014085}, {140,0.000018779}, {141,0.000018779}, {142,0.000070423}, {143,0.000061033}, {144,0.000051643}, {145,0.000051643}, {146,0.000051643}, {147,0.000107981}, {148,0.000075117}, {149,0.000000000}, {150,0.000000000}, {151,0.000056338}, {152,0.000107981}, {153,0.000037559}, {154,0.000037559}, {155,0.000089202}, {156,0.000056338}, {157,0.000084507}, {158,0.000032864}, {159,0.000084507}, {160,0.000070423}, {161,0.000051643}, {162,0.000070423}, {163,0.000014085}, {164,0.000046948}, {165,0.000018779}, {166,0.000014085}, {167,0.000018779}, {168,0.000093897}, {169,0.000107981}, {170,0.000107981}, {171,0.000018779}, {172,0.000075117}, {173,0.000070423}, {174,0.000018779}, {175,0.000065728}, {176,0.000070423}, {177,0.000018779}, {178,0.000075117}, {179,0.000150235}, {180,0.000103286}, {181,0.000032864}, {182,0.000070423}, {183,0.000051643}, {184,0.000051643}, {185,0.000103286}, {186,0.000056338}, {187,0.000014085}, {188,0.000122066}, {189,0.000051643}, {190,0.000018779}, {191,0.000201878}, {192,0.000065728}, {193,0.000075117}, {194,0.000075117}, {195,0.000056338}, {196,0.000000000}, {197,0.000075117}, {198,0.000075117}, {199,0.000093897}, {200,0.000084507}, {201,0.000107981}, {202,0.000051643}, {203,0.000051643}, {204,0.000061033}, {205,0.000089202}, {206,0.000037559}, {207,0.000079812}, {208,0.000075117}, {209,0.000056338}, {210,0.000070423}, {211,0.000000000}, {212,0.000093897}, {213,0.000028169}, {214,0.000079812}, {215,0.000107981}, {216,0.000014085}, {217,0.000112676}, {218,0.000065728}, {219,0.000046948}, {220,0.000065728}, {221,0.000164319}, {222,0.000103286}, {223,0.000075117}, {224,0.000089202}, {225,0.000065728}, {226,0.000075117}, {227,0.000056338}, {228,0.000122066}, {229,0.000122066}, {230,0.000140845}, {231,0.000065728}, {232,0.000093897}, {233,0.000018779}, {234,0.000183099}, {235,0.000122066}, {236,0.000164319}, {237,0.000075117}, {238,0.000089202}, {239,0.000037559}, {240,0.000145540}, {241,0.000037559}, {242,0.000018779}, {243,0.000037559}, {244,0.000230047}, {245,0.000051643}, {246,0.000150235}, {247,0.000070423}, {248,0.000089202}, {249,0.000070423}, {250,0.000197183}, {251,0.000056338}, {252,0.000093897}, {253,0.000018779}, {254,0.000037559}, {255,0.000107981}, {256,0.000037559}, {257,0.000145540}, {258,0.000107981}, {259,0.000089202}, {260,0.000037559}, {261,0.000089202}, {262,0.000056338}, {263,0.000018779}, {264,0.000107981}, {265,0.000098592}, {266,0.000159624}, {267,0.000075117}, {268,0.000140845}, {269,0.000084507}, {270,0.000075117}, {271,0.000253521}, {272,0.000107981}, {273,0.000140845}, {274,0.000169014}, {275,0.000037559}, {276,0.000136150}, {277,0.000136150}, {278,0.000103286}, {279,0.000131455}, {280,0.000070423}, {281,0.000183099}, {282,0.000093897}, {283,0.000107981}, {284,0.000084507}, {285,0.000197183}, {286,0.000112676}, {287,0.000154930}, {288,0.000192488}, {289,0.000018779}, {290,0.000145540}, {291,0.000051643}, {292,0.000032864}, {293,0.000140845}, {294,0.000089202}, {295,0.000056338}, {296,0.000136150}, {297,0.000319249}, {298,0.000107981}, {299,0.000084507}, {300,0.000192488}, {301,0.000215962}, {302,0.000018779}, {303,0.000107981}, {304,0.000126761}, {305,0.000126761}, {306,0.000107981}, {307,0.000093897}, {308,0.000183099}, {309,0.000183099}, {310,0.000089202}, {311,0.000051643}, {312,0.000131455}, {313,0.000211268}, {314,0.000056338}, {315,0.000164319}, {316,0.000126761}, {317,0.000126761}, {318,0.000089202}, {319,0.000089202}, {320,0.000169014}, {321,0.000230047}, {322,0.000103286}, {323,0.000201878}, {324,0.000032864}, {325,0.000107981}, {326,0.000107981}, {327,0.000169014}, {328,0.000089202}, {329,0.000089202}, {330,0.000037559}, {331,0.000145540}, {332,0.000089202}, {333,0.000154930}, {334,0.000211268}, {335,0.000089202}, {336,0.000079812}, {337,0.000089202}, {338,0.000037559}, {339,0.000070423}, {340,0.000145540}, {341,0.000244131}, {342,0.000159624}, {343,0.000107981}, {344,0.000117371}, {345,0.000084507}, {346,0.000098592}, {347,0.000150235}, {348,0.000075117}, {349,0.000159624}, {350,0.000103286}, {351,0.000131455}, {352,0.000248826}, {353,0.000131455}, {354,0.000169014}, {355,0.000192488}, {356,0.000201878}, {357,0.000032864}, {358,0.000056338}, {359,0.000018779}, {360,0.000032864}, {361,0.000122066}, {362,0.000032864}, {363,0.000037559}, {364,0.000103286}, {365,0.000093897}, {366,0.000126761}, {367,0.000051643}, {368,0.000070423}, {369,0.000150235}, {370,0.000051643}, {371,0.000122066}, {372,0.000070423}, {373,0.000178404}, {374,0.000014085}, {375,0.000075117}, {376,0.000056338}, {377,0.000056338}, {378,0.000084507}, {379,0.000089202}, {380,0.000018779}, {381,0.000014085}, {382,0.000056338}, {383,0.000075117}, {384,0.000070423}, {385,0.000032864}, {386,0.000117371}, {387,0.000051643}, {388,0.000037559}, {389,0.000056338}, {390,0.000070423}, {391,0.000056338}, {392,0.000093897}, {393,0.000018779}, {394,0.000032864}, {395,0.000075117}, {396,0.000089202}, {397,0.000037559}, {398,0.000145540}, {399,0.000056338}, {400,0.000070423}, {401,0.000056338}, {402,0.000037559}, {403,0.000028169}, {404,0.000037559}, {405,0.000018779}, {406,0.000056338}, {407,0.000075117}, {408,0.000051643}, {409,0.000018779}, {410,0.000018779}, {411,0.000032864}, {412,0.000070423}, {413,0.000037559}, {414,0.000018779}, {415,0.000037559}, {416,0.000070423}, {417,0.000056338}, {418,0.000075117}, {419,0.000018779}, {420,0.000075117}, {421,0.000018779}, {422,0.000150235}, {423,0.000037559}, {424,0.000107981}, {425,0.000136150}, {426,0.000056338}, {427,0.000037559}, {428,0.000037559}, {429,0.000084507}, {430,0.000037559}, {431,0.000075117}, {432,0.000065728}, {433,0.000070423}, {434,0.000051643}, {435,0.000070423}, {436,0.000037559}, {437,0.000046948}, {438,0.000089202}, {439,0.000056338}, {440,0.000070423}, {441,0.000131455}, {442,0.000056338}, {443,0.000089202}, {444,0.000051643}, {445,0.000000000}, {446,0.000018779}, {447,0.000018779}, {448,0.000107981}, {449,0.000037559}, {450,0.000093897}, {451,0.000093897}, {452,0.000037559}, {453,0.000075117}, {454,0.000000000}, {455,0.000037559}, {456,0.000070423}, {457,0.000075117}, {458,0.000000000}, {459,0.000032864}, {460,0.000051643}, {461,0.000089202}, {462,0.000051643}, {463,0.000107981}, {464,0.000079812}, {465,0.000056338}, {466,0.000018779}, {467,0.000032864}, {468,0.000089202}, {469,0.000032864}, {470,0.000093897}, {471,0.000075117}, {472,0.000032864}, {473,0.000056338}, {474,0.000018779}, {475,0.000112676}, {476,0.000084507}, {477,0.000112676}, {478,0.000215962}, {479,0.000084507}, {480,0.000112676}, {481,0.000103286}, {482,0.000075117}, {483,0.000037559}, {484,0.000018779}, {485,0.000075117}, {486,0.000056338}, {487,0.000126761}, {488,0.000075117}, {489,0.000037559}, {490,0.000037559}, {491,0.000107981}, {492,0.000032864}, {493,0.000032864}, {494,0.000107981}, {495,0.000098592}, {496,0.000075117}, {497,0.000107981}, {498,0.000056338}, {499,0.000032864}, {500,0.000103286}, {505,0.000037559}, {510,0.000018779}, {515,0.000089202}, {520,0.000046948}, {525,0.000075117}, {530,0.000037559}, {535,0.000037559}, {540,0.000075117}, {545,0.000107981}, {550,0.000018779}, {555,0.000089202}, {560,0.000145540}, {565,0.000056338}, {570,0.000112676}, {575,0.000093897}, {580,0.000126761}, {585,0.000112676}, {590,0.000112676}, {595,0.000014085}, {600,0.000051643}, {605,0.000075117}, {610,0.000140845}, {615,0.000089202}, {620,0.000126761}, {625,0.000112676}, {630,0.000103286}, {635,0.000140845}, {640,0.000107981}, {645,0.000093897}, {650,0.000089202}, {655,0.000018779}, {660,0.000056338}, {665,0.000126761}, {670,0.000056338}, {675,0.000089202}, {680,0.000089202}, {685,0.000037559}, {690,0.000089202}, {695,0.000140845}, {700,0.000107981}, {705,0.000140845}, {710,0.000084507}, {715,0.000075117}, {720,0.000112676}, {725,0.000107981}, {730,0.000056338}, {735,0.000061033}, {740,0.000093897}, {745,0.000122066}, {750,0.000126761}, {755,0.000201878}, {760,0.000051643}, {765,0.000112676}, {770,0.000089202}, {775,0.000051643}, {780,0.000056338}, {785,0.000150235}, {790,0.000089202}, {795,0.000107981}, {800,0.000126761}, {805,0.000089202}, {810,0.000084507}, {815,0.000145540}, {820,0.000206573}, {825,0.000112676}, {830,0.000117371}, {835,0.000131455}, {840,0.000037559}, {845,0.000075117}, {850,0.000126761}, {855,0.000089202}, {860,0.000126761}, {865,0.000112676}, {870,0.000122066}, {875,0.000107981}, {880,0.000070423}, {885,0.000159624}, {890,0.000037559}, {895,0.000107981}, {900,0.000107981}, {905,0.000070423}, {910,0.000183099}, {915,0.000089202}, {920,0.000089202}, {925,0.000089202}, {930,0.000164319}, {935,0.000112676}, {940,0.000140845}, {945,0.000103286}, {950,0.000122066}, {955,0.000117371}, {960,0.000075117}, {965,0.000103286}, {970,0.000056338}, {975,0.000112676}, {980,0.000103286}, {985,0.000093897}, {990,0.000150235}, {995,0.000107981}, {1000,0.000107981}, {1010,0.000112676}, {1020,0.000150235}, {1030,0.000093897}, {1040,0.000084507}, {1050,0.000145540}, {1060,0.000070423}, {1070,0.000093897}, {1080,0.000192488}, {1090,0.000107981}, {1100,0.000140845}, {1110,0.000107981}, {1120,0.000253521}, {1130,0.000126761}, {1140,0.000150235}, {1150,0.000140845}, {1160,0.000126761}, {1170,0.000140845}, {1180,0.000126761}, {1190,0.000145540}, {1200,0.000145540}, {1210,0.000178404}, {1220,0.000056338}, {1230,0.000084507}, {1240,0.000276995}, {1250,0.000281690}, {1260,0.000089202}, {1270,0.000131455}, {1280,0.000051643}, {1290,0.000164319}, {1300,0.000178404}, {1310,0.000183099}, {1320,0.000056338}, {1330,0.000150235}, {1340,0.000197183}, {1350,0.000183099}, {1360,0.000234742}, {1370,0.000173709}, {1380,0.000056338}, {1390,0.000211268}, {1400,0.000122066}, {1410,0.000164319}, {1420,0.000122066}, {1430,0.000187793}, {1440,0.000206573}, {1450,0.000018779}, {1460,0.000112676}, {1470,0.000093897}, {1480,0.000230047}, {1490,0.000164319}, {1500,0.000140845}, {1510,0.002077}, {1520,0.002000}, {1530,0.001846}, {1540,0.000308}, {1550,0.001231}, {1560,0.000923}, {1570,0.000538}, {1580,0.001462}, {1590,0.001462}, {1600,0.000308}, {1610,0.001462}, {1620,0.001462}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000308}, {1680,0.000615}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000308}, {1730,0.000000}, {1740,0.000538}, {1750,0.000308}, {1760,0.000000}, {1770,0.000308}, {1780,0.000000}, {1790,0.000308}, {1800,0.000231}, {1810,0.000231}, {1820,0.000308}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000308}, {1870,0.000308}, {1880,0.000000}, {1890,0.000538}, {1900,0.000308}, {1910,0.000308}, {1920,0.000000}, {1930,0.000308}, {1940,0.000000}, {1950,0.000308}, {1960,0.000000}, {1970,0.000000}, {1980,0.000308}, {1990,0.000000}, {2000,0.000308}, {2050,0.000000}, {2100,0.000000}, {2150,0.000308}, {2200,0.000000}, {2250,0.000000}, {2300,0.000000}, {2350,0.000308}, {2400,0.000000}, {2450,0.000615}, {2500,0.000308}, {2550,0.000615}, {2600,0.000308}, {2650,0.000000}, {2700,0.000538}, {2750,0.000615}, {2800,0.000000}, {2850,0.000846}, {2900,0.000538}, {2950,0.000308}, {3000,0.000538}, {3050,0.000000}, {3100,0.000615}, {3150,0.000000}, {3200,0.000615}, {3250,0.000000}, {3300,0.001231}, {3350,0.003077}, {3400,0.000000}, {3450,0.000308}, {3500,0.000000}, {3550,0.000000}, {3600,0.000923}, {3650,0.000615}, {3700,0.000615}, {3750,0.000308}, {3800,0.000000}, {3850,0.001154}, {3900,0.000538}, {3950,0.000923}, {4000,0.000923}, {4050,0.000615}, {4100,0.000923}, {4150,0.000308}, {4200,0.000308}, {4250,0.000615}, {4300,0.000923}, {4350,0.000615}, {4400,0.000000}, {4450,0.001231}, {4500,0.000615}, {4550,0.000000}, {4600,0.000923}, {4650,0.000846}, {4700,0.001538}, {4750,0.000308}, {4800,0.000000}, {4850,0.000538}, {4900,0.000923}, {4950,0.000308}, {5000,0.000308}, {5050,0.001231}, {5100,0.000923}, {5150,0.001385}, {5200,0.001231}, {5250,0.000923}, {5300,0.001154}, {5350,0.002385}, {5400,0.001538}, {5450,0.002385}, {5500,0.000923}, {5550,0.000308}, {5600,0.001462}, {5650,0.001538}, {5700,0.000923}, {5750,0.001231}, {5800,0.001846}, {5850,0.002077}, {5900,0.000923}, {5950,0.001538}, {6000,0.002385}, {6050,0.001385}, {6100,0.002769}, {6150,0.001769}, {6200,0.002385}, {6250,0.001846}, {6300,0.001538}, {6350,0.002769}, {6400,0.002385}, {6450,0.002308}, {6500,0.001538}, {6550,0.000615}, {6600,0.002462}, {6650,0.003615}, {6700,0.002308}, {6750,0.002462}, {6800,0.003923}, {6850,0.006077}, {6900,0.002308}, {6950,0.004000}, {7000,0.003000}, {7050,0.003692}, {7100,0.001538}, {7150,0.003923}, {7200,0.002462}, {7250,0.002462}, {7300,0.003769}, {7350,0.002462}, {7400,0.007615}, {7450,0.005769}, {7500,0.007231}, {7550,0.004846}, {7600,0.005077}, {7650,0.006538}, {7700,0.003000}, {7750,0.004923}, {7800,0.005769}, {7850,0.004692}, {7900,0.005769}, {7950,0.003923}, {8000,0.008615}, {8050,0.006077}, {8100,0.002385}, {8150,0.003154}, {8200,0.001538}, {8250,0.004000}, {8300,0.002462}, {8350,0.001538}, {8400,0.003385}, {8450,0.001538}, {8500,0.000615}, {8550,0.002077}, {8600,0.001846}, {8650,0.001462}, {8700,0.004308}, {8750,0.002385}, {8800,0.003923}, {8850,0.005692}, {8900,0.004308}, {8950,0.006462}, {9000,0.006769}, {9050,0.004846}, {9100,0.031692}, {9150,0.006615}, {9200,0.003692}, {9250,0.003846}, {9300,0.005231}, {9350,0.005077}, {9400,0.005231}, {9450,0.004231}, {9500,0.005462}, {9550,0.006077}, {9600,0.005769}, {9650,0.008000}, {9700,0.005000}, {9750,0.009769}, {9800,0.005538}, {9850,0.007000}, {9900,0.003231}, {9950,0.005538}, {10000,0.006462}};
data["big_flat"]["Mtac2"]["actual reif"]["real"] = {{1,0.000187793}, {2,0.000004695}, {3,0.000056338}, {4,0.000061033}, {5,0.000061033}, {6,0.000061033}, {7,0.000061033}, {8,0.000061033}, {9,0.000112676}, {10,0.000197183}, {11,0.000873239}, {12,0.001061033}, {13,0.001061033}, {14,0.001061033}, {15,0.001061033}, {16,0.001061033}, {17,0.001061033}, {18,0.001065728}, {19,0.001117371}, {20,0.001122066}, {21,0.001098592}, {22,0.001197183}, {23,0.001676056}, {24,0.002061033}, {25,0.002061033}, {26,0.002061033}, {27,0.002061033}, {28,0.002061033}, {29,0.002061033}, {30,0.002089202}, {31,0.002084507}, {32,0.002107981}, {33,0.002154930}, {34,0.002577465}, {35,0.002985915}, {36,0.003032864}, {37,0.003056338}, {38,0.003061033}, {39,0.003065728}, {40,0.003070423}, {41,0.003084507}, {42,0.003122066}, {43,0.003136150}, {44,0.003539906}, {45,0.004474178}, {46,0.004000000}, {47,0.004000000}, {48,0.004009390}, {49,0.004000000}, {50,0.004023474}, {51,0.004032864}, {52,0.004075117}, {53,0.004225352}, {54,0.004746479}, {55,0.005028169}, {56,0.005032864}, {57,0.005075117}, {58,0.005065728}, {59,0.005079812}, {60,0.006230047}, {61,0.005183099}, {62,0.005314554}, {63,0.005779343}, {64,0.006051643}, {65,0.006051643}, {66,0.006046948}, {67,0.006051643}, {68,0.006065728}, {69,0.006107981}, {70,0.006220657}, {71,0.006544601}, {72,0.007892019}, {73,0.007023474}, {74,0.007014085}, {75,0.007014085}, {76,0.007051643}, {77,0.007089202}, {78,0.007201878}, {79,0.007488263}, {80,0.007938967}, {81,0.008065728}, {82,0.009042254}, {83,0.008046948}, {84,0.008107981}, {85,0.008140845}, {86,0.008333333}, {87,0.008661972}, {88,0.009000000}, {89,0.009023474}, {90,0.009981221}, {91,0.009117371}, {92,0.009169014}, {93,0.009300469}, {94,0.009525822}, {95,0.009849765}, {96,0.010028169}, {97,0.010042254}, {98,0.011225352}, {99,0.010112676}, {100,0.010234742}, {101,0.010455399}, {102,0.010906103}, {103,0.010990610}, {104,0.011023474}, {105,0.012215962}, {106,0.011126761}, {107,0.011164319}, {108,0.011525822}, {109,0.011859155}, {110,0.011995305}, {111,0.012957746}, {112,0.012103286}, {113,0.012169014}, {114,0.012370892}, {115,0.012643192}, {116,0.013061033}, {117,0.014680751}, {118,0.013098592}, {119,0.013098592}, {120,0.013563380}, {121,0.013708920}, {122,0.014253521}, {123,0.015723005}, {124,0.015309859}, {125,0.015206573}, {126,0.015061033}, {127,0.015159624}, {128,0.017051643}, {129,0.015774648}, {130,0.015610329}, {131,0.015507042}, {132,0.015544601}, {133,0.017286385}, {134,0.016014085}, {135,0.016150235}, {136,0.016183099}, {137,0.016295775}, {138,0.017830986}, {139,0.016502347}, {140,0.016859155}, {141,0.017056338}, {142,0.019023474}, {143,0.017206573}, {144,0.017436620}, {145,0.017671362}, {146,0.017976526}, {147,0.018751174}, {148,0.018145540}, {149,0.018253521}, {150,0.018610329}, {151,0.020018779}, {152,0.019051643}, {153,0.019169014}, {154,0.019230047}, {155,0.020352113}, {156,0.019586854}, {157,0.019892019}, {158,0.020028169}, {159,0.020150235}, {160,0.020347418}, {161,0.020549296}, {162,0.022563380}, {163,0.021028169}, {164,0.021178404}, {165,0.021281690}, {166,0.022910798}, {167,0.021610329}, {168,0.022000000}, {169,0.024197183}, {170,0.022338028}, {171,0.022539906}, {172,0.022798122}, {173,0.023906103}, {174,0.023117371}, {175,0.023131455}, {176,0.024962441}, {177,0.023751174}, {178,0.024014085}, {179,0.026098592}, {180,0.024366197}, {181,0.024784038}, {182,0.027131455}, {183,0.025262911}, {184,0.025370892}, {185,0.027417840}, {186,0.025563380}, {187,0.025633803}, {188,0.028417840}, {189,0.026089202}, {190,0.026295775}, {191,0.028380282}, {192,0.026906103}, {193,0.027004695}, {194,0.028826291}, {195,0.027333333}, {196,0.027774648}, {197,0.027971831}, {198,0.028084507}, {199,0.030619718}, {200,0.028516432}, {201,0.028727700}, {202,0.030586854}, {203,0.029136150}, {204,0.029356808}, {205,0.029582160}, {206,0.029868545}, {207,0.031826291}, {208,0.030399061}, {209,0.030469484}, {210,0.030737089}, {211,0.030985915}, {212,0.032807512}, {213,0.031347418}, {214,0.034065728}, {215,0.031882629}, {216,0.032112676}, {217,0.033352113}, {218,0.032450704}, {219,0.036140845}, {220,0.033046948}, {221,0.037004695}, {222,0.033431925}, {223,0.033539906}, {224,0.035821596}, {225,0.034323944}, {226,0.036840376}, {227,0.034704225}, {228,0.037760563}, {229,0.035305164}, {230,0.038821596}, {231,0.035525822}, {232,0.039835681}, {233,0.036159624}, {234,0.040713615}, {235,0.036657277}, {236,0.041262911}, {237,0.037314554}, {238,0.039154930}, {239,0.037666667}, {240,0.039262911}, {241,0.038183099}, {242,0.040051643}, {243,0.038572770}, {244,0.043201878}, {245,0.039234742}, {246,0.043826291}, {247,0.039802817}, {248,0.044427230}, {249,0.040455399}, {250,0.045840376}, {251,0.041920188}, {252,0.045661972}, {253,0.045507042}, {254,0.047276995}, {255,0.043417840}, {256,0.045723005}, {257,0.047248826}, {258,0.043258216}, {259,0.047253521}, {260,0.043605634}, {261,0.047009390}, {262,0.044079812}, {263,0.046629108}, {264,0.049976526}, {265,0.045112676}, {266,0.048985915}, {267,0.045342723}, {268,0.048408451}, {269,0.045981221}, {270,0.047201878}, {271,0.051596244}, {272,0.048535211}, {273,0.051676056}, {274,0.054122066}, {275,0.048272300}, {276,0.052286385}, {277,0.048544601}, {278,0.051267606}, {279,0.053089202}, {280,0.049305164}, {281,0.052136150}, {282,0.054084507}, {283,0.049863850}, {284,0.053154930}, {285,0.053863850}, {286,0.050478873}, {287,0.052906103}, {288,0.054892019}, {289,0.051544601}, {290,0.053892019}, {291,0.055384977}, {292,0.052220657}, {293,0.054441315}, {294,0.056272300}, {295,0.053375587}, {296,0.057004695}, {297,0.057300469}, {298,0.056971831}, {299,0.055103286}, {300,0.056685446}, {301,0.058084507}, {302,0.055384977}, {303,0.057140845}, {304,0.058394366}, {305,0.059962441}, {306,0.056553991}, {307,0.058699531}, {308,0.059924883}, {309,0.061488263}, {310,0.057535211}, {311,0.059718310}, {312,0.061309859}, {313,0.062596244}, {314,0.059201878}, {315,0.060924883}, {316,0.062262911}, {317,0.063845070}, {318,0.061314554}, {319,0.060399061}, {320,0.061779343}, {321,0.063159624}, {322,0.064455399}, {323,0.064478873}, {324,0.062338028}, {325,0.063971831}, {326,0.064577465}, {327,0.065511737}, {328,0.067164319}, {329,0.063366197}, {330,0.064239437}, {331,0.065507042}, {332,0.066488263}, {333,0.067976526}, {334,0.069436620}, {335,0.069920188}, {336,0.067779343}, {337,0.068328638}, {338,0.068460094}, {339,0.068661972}, {340,0.069854460}, {341,0.070727700}, {342,0.071765258}, {343,0.072868545}, {344,0.070568075}, {345,0.069107981}, {346,0.070718310}, {347,0.071187793}, {348,0.071887324}, {349,0.072901408}, {350,0.074511737}, {351,0.074455399}, {352,0.074798122}, {353,0.075079812}, {354,0.075985915}, {355,0.076422535}, {356,0.077549296}, {357,0.077812207}, {358,0.078164319}, {359,0.078605634}, {360,0.076586854}, {361,0.075000000}, {362,0.075732394}, {363,0.075403756}, {364,0.076093897}, {365,0.077713615}, {366,0.078671362}, {367,0.078338028}, {368,0.078577465}, {369,0.079046948}, {370,0.077647887}, {371,0.078469484}, {372,0.080107981}, {373,0.084150235}, {374,0.084835681}, {375,0.084525822}, {376,0.084591549}, {377,0.084154930}, {378,0.084352113}, {379,0.084136150}, {380,0.084253521}, {381,0.084558685}, {382,0.084131455}, {383,0.084525822}, {384,0.084596244}, {385,0.084845070}, {386,0.084605634}, {387,0.085140845}, {388,0.088582160}, {389,0.089028169}, {390,0.089112676}, {391,0.088342723}, {392,0.088427230}, {393,0.088375587}, {394,0.088699531}, {395,0.089140845}, {396,0.092995305}, {397,0.091671362}, {398,0.092502347}, {399,0.089582160}, {400,0.093779343}, {401,0.091788732}, {402,0.092338028}, {403,0.095830986}, {404,0.095558685}, {405,0.095403756}, {406,0.094774648}, {407,0.094821596}, {408,0.097755869}, {409,0.097929577}, {410,0.096798122}, {411,0.096286385}, {412,0.096784038}, {413,0.099887324}, {414,0.098553991}, {415,0.098507042}, {416,0.098272300}, {417,0.101305164}, {418,0.100723005}, {419,0.100769953}, {420,0.099727700}, {421,0.102314554}, {422,0.100929577}, {423,0.099859155}, {424,0.103239437}, {425,0.102403756}, {426,0.101497653}, {427,0.101629108}, {428,0.103920188}, {429,0.102943662}, {430,0.102516432}, {431,0.105239437}, {432,0.104530516}, {433,0.104009390}, {434,0.107521127}, {435,0.105525822}, {436,0.105521127}, {437,0.110882629}, {438,0.105136150}, {439,0.106572770}, {440,0.109084507}, {441,0.108286385}, {442,0.111234742}, {443,0.110159624}, {444,0.109131455}, {445,0.110915493}, {446,0.110347418}, {447,0.112455399}, {448,0.112276995}, {449,0.111737089}, {450,0.113356808}, {451,0.112201878}, {452,0.114549296}, {453,0.113652582}, {454,0.115276995}, {455,0.114723005}, {456,0.113868545}, {457,0.114976526}, {458,0.114985915}, {459,0.116854460}, {460,0.115826291}, {461,0.117366197}, {462,0.116107981}, {463,0.117971831}, {464,0.117981221}, {465,0.119051643}, {466,0.118079812}, {467,0.119647887}, {468,0.118676056}, {469,0.120647887}, {470,0.119582160}, {471,0.121643192}, {472,0.121131455}, {473,0.121985915}, {474,0.124455399}, {475,0.123380282}, {476,0.123915493}, {477,0.122699531}, {478,0.124535211}, {479,0.123295775}, {480,0.124929577}, {481,0.127422535}, {482,0.125694836}, {483,0.126868545}, {484,0.127004695}, {485,0.127389671}, {486,0.128882629}, {487,0.127384977}, {488,0.129286385}, {489,0.133708920}, {490,0.131934272}, {491,0.132525822}, {492,0.134746479}, {493,0.132230047}, {494,0.133887324}, {495,0.134788732}, {496,0.133812207}, {497,0.135403756}, {498,0.136868545}, {499,0.134535211}, {500,0.137737089}, {505,0.140239437}, {510,0.143680751}, {515,0.143032864}, {520,0.144215962}, {525,0.146079812}, {530,0.149192488}, {535,0.151032864}, {540,0.155342723}, {545,0.156436620}, {550,0.161131455}, {555,0.161577465}, {560,0.165399061}, {565,0.166408451}, {570,0.172056338}, {575,0.173154930}, {580,0.178295775}, {585,0.177769953}, {590,0.180863850}, {595,0.183798122}, {600,0.186835681}, {605,0.187779343}, {610,0.190868545}, {615,0.193469484}, {620,0.197328638}, {625,0.198784038}, {630,0.203647887}, {635,0.205976526}, {640,0.209089202}, {645,0.212014085}, {650,0.217000000}, {655,0.215845070}, {660,0.220511737}, {665,0.222718310}, {670,0.226769953}, {675,0.230356808}, {680,0.233178404}, {685,0.235530516}, {690,0.238845070}, {695,0.241985915}, {700,0.250469484}, {705,0.250657277}, {710,0.254924883}, {715,0.258079812}, {720,0.264286385}, {725,0.266741784}, {730,0.271333333}, {735,0.271150235}, {740,0.278239437}, {745,0.281990610}, {750,0.282023474}, {755,0.288032864}, {760,0.294023474}, {765,0.288291080}, {770,0.292347418}, {775,0.297070423}, {780,0.301676056}, {785,0.302591549}, {790,0.308234742}, {795,0.311746479}, {800,0.315666667}, {805,0.319629108}, {810,0.327032864}, {815,0.326624413}, {820,0.331187793}, {825,0.333910798}, {830,0.336286385}, {835,0.340737089}, {840,0.342164319}, {845,0.347784038}, {850,0.351422535}, {855,0.354023474}, {860,0.358553991}, {865,0.362694836}, {870,0.364154930}, {875,0.374436620}, {880,0.374145540}, {885,0.377469484}, {890,0.383023474}, {895,0.392478873}, {900,0.396338028}, {905,0.399807512}, {910,0.401220657}, {915,0.408323944}, {920,0.409708920}, {925,0.415427230}, {930,0.415220657}, {935,0.420525822}, {940,0.428370892}, {945,0.425281690}, {950,0.431107981}, {955,0.438169014}, {960,0.440788732}, {965,0.444821596}, {970,0.449305164}, {975,0.452920188}, {980,0.457882629}, {985,0.463323944}, {990,0.470455399}, {995,0.472262911}, {1000,0.482962441}, {1010,0.485413146}, {1020,0.493718310}, {1030,0.500694836}, {1040,0.513826291}, {1050,0.531037559}, {1060,0.541577465}, {1070,0.547676056}, {1080,0.554417840}, {1090,0.559056338}, {1100,0.571436620}, {1110,0.580699531}, {1120,0.590305164}, {1130,0.599488263}, {1140,0.614361502}, {1150,0.631211268}, {1160,0.628098592}, {1170,0.642319249}, {1180,0.654478873}, {1190,0.662230047}, {1200,0.673295775}, {1210,0.679647887}, {1220,0.701671362}, {1230,0.712516432}, {1240,0.722323944}, {1250,0.734408451}, {1260,0.738854460}, {1270,0.752436620}, {1280,0.759600939}, {1290,0.771539906}, {1300,0.783502347}, {1310,0.798727700}, {1320,0.805652582}, {1330,0.824774648}, {1340,0.838201878}, {1350,0.837347418}, {1360,0.858248826}, {1370,0.873582160}, {1380,0.888446009}, {1390,0.889450704}, {1400,0.902032864}, {1410,0.911967136}, {1420,0.928690141}, {1430,0.943234742}, {1440,0.949676056}, {1450,0.961262911}, {1460,0.971380282}, {1470,0.985361502}, {1480,1.025056338}, {1490,1.029990610}, {1500,1.026863850}, {1510,1.051615}, {1520,1.048231}, {1530,1.078231}, {1540,1.087385}, {1550,1.094846}, {1560,1.101385}, {1570,1.116231}, {1580,1.147308}, {1590,1.148769}, {1600,1.158769}, {1610,1.177462}, {1620,1.186077}, {1630,1.215385}, {1640,1.219923}, {1650,1.224923}, {1660,1.242692}, {1670,1.254615}, {1680,1.277769}, {1690,1.290385}, {1700,1.295308}, {1710,1.316154}, {1720,1.348077}, {1730,1.343077}, {1740,1.371692}, {1750,1.370077}, {1760,1.379000}, {1770,1.421385}, {1780,1.429462}, {1790,1.428154}, {1800,1.443000}, {1810,1.457846}, {1820,1.488231}, {1830,1.493769}, {1840,1.506231}, {1850,1.520231}, {1860,1.536923}, {1870,1.562769}, {1880,1.605154}, {1890,1.585308}, {1900,1.597077}, {1910,1.621538}, {1920,1.636615}, {1930,1.647154}, {1940,1.668846}, {1950,1.676615}, {1960,1.695231}, {1970,1.715769}, {1980,1.720846}, {1990,1.739385}, {2000,1.790462}, {2050,1.844154}, {2100,1.935692}, {2150,1.997538}, {2200,2.090769}, {2250,2.206769}, {2300,2.277154}, {2350,2.379846}, {2400,2.467308}, {2450,2.599077}, {2500,2.668538}, {2550,2.772385}, {2600,2.888000}, {2650,2.984462}, {2700,3.100615}, {2750,3.240308}, {2800,3.315231}, {2850,3.417385}, {2900,3.546923}, {2950,3.664000}, {3000,3.862462}, {3050,3.931385}, {3100,4.046308}, {3150,4.174231}, {3200,4.327462}, {3250,4.433769}, {3300,4.594846}, {3350,4.725846}, {3400,4.852462}, {3450,4.978462}, {3500,5.112077}, {3550,5.288923}, {3600,5.413385}, {3650,5.581538}, {3700,5.731615}, {3750,5.865231}, {3800,6.039462}, {3850,6.166308}, {3900,6.348154}, {3950,6.499385}, {4000,6.691846}, {4050,6.813692}, {4100,7.051846}, {4150,7.175385}, {4200,7.362692}, {4250,7.499692}, {4300,7.690000}, {4350,7.827385}, {4400,8.074154}, {4450,8.302385}, {4500,8.437000}, {4550,8.633154}, {4600,8.800846}, {4650,8.942154}, {4700,9.189231}, {4750,9.333385}, {4800,9.547692}, {4850,9.744000}, {4900,9.919154}, {4950,10.175000}, {5000,10.347692}, {5050,10.587308}, {5100,10.825923}, {5150,11.083077}, {5200,11.269692}, {5250,11.440923}, {5300,11.696308}, {5350,11.889846}, {5400,12.104538}, {5450,12.366615}, {5500,12.540154}, {5550,12.777538}, {5600,13.067154}, {5650,13.272538}, {5700,13.528462}, {5750,13.759000}, {5800,14.033538}, {5850,14.272462}, {5900,14.528923}, {5950,14.770231}, {6000,15.023308}, {6050,15.327538}, {6100,15.549077}, {6150,15.777615}, {6200,16.150462}, {6250,16.377308}, {6300,16.657000}, {6350,16.908308}, {6400,17.191692}, {6450,17.526231}, {6500,17.711615}, {6550,18.045154}, {6600,18.293615}, {6650,18.646154}, {6700,18.903308}, {6750,19.193000}, {6800,19.529615}, {6850,19.928077}, {6900,20.088154}, {6950,20.378154}, {7000,20.624538}, {7050,20.945923}, {7100,21.260846}, {7150,21.572385}, {7200,21.831462}, {7250,22.123231}, {7300,22.339538}, {7350,22.733615}, {7400,23.157923}, {7450,23.535231}, {7500,23.769231}, {7550,24.150615}, {7600,24.314308}, {7650,24.858769}, {7700,25.196462}, {7750,25.472308}, {7800,25.797462}, {7850,26.027615}, {7900,26.427385}, {7950,26.622846}, {8000,27.242538}, {8050,27.465231}, {8100,27.791923}, {8150,28.119846}, {8200,28.473385}, {8250,28.929077}, {8300,29.205000}, {8350,29.596615}, {8400,29.910462}, {8450,30.361923}, {8500,30.599000}, {8550,31.068077}, {8600,31.400462}, {8650,31.784231}, {8700,32.261231}, {8750,32.478385}, {8800,33.001462}, {8850,33.321538}, {8900,33.711231}, {8950,34.218769}, {9000,34.556692}, {9050,34.790077}, {9100,35.539154}, {9150,35.796462}, {9200,36.138308}, {9250,36.435692}, {9300,36.854385}, {9350,37.140462}, {9400,37.535308}, {9450,37.858615}, {9500,38.437692}, {9550,38.763923}, {9600,39.190077}, {9650,39.519077}, {9700,40.420692}, {9750,40.795538}, {9800,40.987538}, {9850,41.438154}, {9900,41.917462}, {9950,42.423462}, {10000,42.854154}};
data["big_flat"]["Mtac2"]["actual reif"]["user"] = {{1,0.000582160}, {2,0.000244131}, {3,0.000319249}, {4,0.000600939}, {5,0.000638498}, {6,0.000769953}, {7,0.000882629}, {8,0.001014085}, {9,0.001070423}, {10,0.001107981}, {11,0.001201878}, {12,0.001276995}, {13,0.001014085}, {14,0.001446009}, {15,0.001352113}, {16,0.001408451}, {17,0.001718310}, {18,0.001718310}, {19,0.001591549}, {20,0.001995305}, {21,0.001591549}, {22,0.002089202}, {23,0.002089202}, {24,0.002122066}, {25,0.002061033}, {26,0.002183099}, {27,0.002201878}, {28,0.002394366}, {29,0.002389671}, {30,0.002483568}, {31,0.002591549}, {32,0.002671362}, {33,0.002661972}, {34,0.002760563}, {35,0.003046948}, {36,0.002760563}, {37,0.003103286}, {38,0.003093897}, {39,0.003136150}, {40,0.003239437}, {41,0.003352113}, {42,0.003370892}, {43,0.003568075}, {44,0.003657277}, {45,0.004455399}, {46,0.003755869}, {47,0.003755869}, {48,0.004154930}, {49,0.003910798}, {50,0.004211268}, {51,0.004394366}, {52,0.004643192}, {53,0.004610329}, {54,0.004732394}, {55,0.005164319}, {56,0.005272300}, {57,0.005103286}, {58,0.005272300}, {59,0.005309859}, {60,0.006821596}, {61,0.005680751}, {62,0.005863850}, {63,0.005995305}, {64,0.006356808}, {65,0.006408451}, {66,0.006511737}, {67,0.006234742}, {68,0.006511737}, {69,0.006699531}, {70,0.006826291}, {71,0.007178404}, {72,0.008164319}, {73,0.007206573}, {74,0.007380282}, {75,0.007417840}, {76,0.007582160}, {77,0.007755869}, {78,0.007868545}, {79,0.008056338}, {80,0.008131455}, {81,0.008356808}, {82,0.009558685}, {83,0.008807512}, {84,0.008657277}, {85,0.008845070}, {86,0.008957746}, {87,0.008920188}, {88,0.009211268}, {89,0.009305164}, {90,0.010281690}, {91,0.009572770}, {92,0.009751174}, {93,0.009845070}, {94,0.009920188}, {95,0.010131455}, {96,0.010220657}, {97,0.010305164}, {98,0.011718310}, {99,0.010446009}, {100,0.010849765}, {101,0.010582160}, {102,0.010976526}, {103,0.011192488}, {104,0.011286385}, {105,0.012723005}, {106,0.011774648}, {107,0.011920188}, {108,0.012037559}, {109,0.012136150}, {110,0.012267606}, {111,0.013338028}, {112,0.012521127}, {113,0.012746479}, {114,0.012816901}, {115,0.013014085}, {116,0.013314554}, {117,0.015173709}, {118,0.013591549}, {119,0.013525822}, {120,0.013962441}, {121,0.014065728}, {122,0.014666667}, {123,0.016389671}, {124,0.015558685}, {125,0.015652582}, {126,0.015619718}, {127,0.015652582}, {128,0.017492958}, {129,0.015962441}, {130,0.016084507}, {131,0.016075117}, {132,0.016126761}, {133,0.017708920}, {134,0.016338028}, {135,0.016333333}, {136,0.016704225}, {137,0.016830986}, {138,0.018366197}, {139,0.017042254}, {140,0.017192488}, {141,0.017178404}, {142,0.019211268}, {143,0.017694836}, {144,0.017798122}, {145,0.017938967}, {146,0.018159624}, {147,0.018765258}, {148,0.018399061}, {149,0.018352113}, {150,0.018704225}, {151,0.019943662}, {152,0.019197183}, {153,0.019211268}, {154,0.019244131}, {155,0.020530516}, {156,0.019568075}, {157,0.019816901}, {158,0.020009390}, {159,0.020178404}, {160,0.020676056}, {161,0.020981221}, {162,0.022755869}, {163,0.020708920}, {164,0.021042254}, {165,0.021427230}, {166,0.023183099}, {167,0.021690141}, {168,0.022211268}, {169,0.024413146}, {170,0.022511737}, {171,0.023065728}, {172,0.023004695}, {173,0.024281690}, {174,0.023394366}, {175,0.023629108}, {176,0.025159624}, {177,0.024192488}, {178,0.024206573}, {179,0.026018779}, {180,0.024793427}, {181,0.025131455}, {182,0.027234742}, {183,0.025521127}, {184,0.025525822}, {185,0.027483568}, {186,0.025784038}, {187,0.025976526}, {188,0.028539906}, {189,0.026258216}, {190,0.026535211}, {191,0.028323944}, {192,0.026812207}, {193,0.026835681}, {194,0.028957746}, {195,0.027394366}, {196,0.027699531}, {197,0.027868545}, {198,0.028037559}, {199,0.030751174}, {200,0.028455399}, {201,0.028676056}, {202,0.030826291}, {203,0.029347418}, {204,0.029549296}, {205,0.030014085}, {206,0.029854460}, {207,0.032201878}, {208,0.030431925}, {209,0.030896714}, {210,0.031075117}, {211,0.031272300}, {212,0.032802817}, {213,0.031760563}, {214,0.034305164}, {215,0.032244131}, {216,0.032615023}, {217,0.033586854}, {218,0.032784038}, {219,0.036239437}, {220,0.033281690}, {221,0.037061033}, {222,0.033507042}, {223,0.033713615}, {224,0.035694836}, {225,0.034328638}, {226,0.036835681}, {227,0.034647887}, {228,0.037854460}, {229,0.035169014}, {230,0.039009390}, {231,0.035549296}, {232,0.040192488}, {233,0.036291080}, {234,0.041004695}, {235,0.036568075}, {236,0.041488263}, {237,0.037427230}, {238,0.039291080}, {239,0.038051643}, {240,0.039586854}, {241,0.038399061}, {242,0.040525822}, {243,0.039098592}, {244,0.043103286}, {245,0.039863850}, {246,0.043699531}, {247,0.040117371}, {248,0.044605634}, {249,0.040746479}, {250,0.045629108}, {251,0.041976526}, {252,0.045798122}, {253,0.045666667}, {254,0.047281690}, {255,0.043699531}, {256,0.045793427}, {257,0.047638498}, {258,0.043347418}, {259,0.047535211}, {260,0.043422535}, {261,0.047215962}, {262,0.044281690}, {263,0.046967136}, {264,0.050164319}, {265,0.045394366}, {266,0.049018779}, {267,0.045643192}, {268,0.048549296}, {269,0.046408451}, {270,0.047455399}, {271,0.051309859}, {272,0.048948357}, {273,0.051647887}, {274,0.053798122}, {275,0.048605634}, {276,0.052089202}, {277,0.048863850}, {278,0.051211268}, {279,0.052666667}, {280,0.049286385}, {281,0.051863850}, {282,0.053985915}, {283,0.049882629}, {284,0.052840376}, {285,0.053558685}, {286,0.050469484}, {287,0.052727700}, {288,0.054553991}, {289,0.051352113}, {290,0.053525822}, {291,0.055516432}, {292,0.052117371}, {293,0.054084507}, {294,0.056244131}, {295,0.053230047}, {296,0.056840376}, {297,0.057093897}, {298,0.056920188}, {299,0.055333333}, {300,0.056436620}, {301,0.057938967}, {302,0.055389671}, {303,0.057032864}, {304,0.058478873}, {305,0.059929577}, {306,0.056591549}, {307,0.058981221}, {308,0.060061033}, {309,0.061727700}, {310,0.057718310}, {311,0.059887324}, {312,0.061591549}, {313,0.062629108}, {314,0.059511737}, {315,0.061075117}, {316,0.062643192}, {317,0.064018779}, {318,0.061446009}, {319,0.060638498}, {320,0.061910798}, {321,0.063436620}, {322,0.064723005}, {323,0.064629108}, {324,0.062821596}, {325,0.064206573}, {326,0.064887324}, {327,0.065323944}, {328,0.066896714}, {329,0.063633803}, {330,0.064600939}, {331,0.065521127}, {332,0.066516432}, {333,0.067887324}, {334,0.068948357}, {335,0.069779343}, {336,0.067694836}, {337,0.068323944}, {338,0.067943662}, {339,0.068436620}, {340,0.069474178}, {341,0.070356808}, {342,0.071676056}, {343,0.072666667}, {344,0.070633803}, {345,0.068920188}, {346,0.070474178}, {347,0.071065728}, {348,0.071765258}, {349,0.072769953}, {350,0.074549296}, {351,0.074276995}, {352,0.074624413}, {353,0.075154930}, {354,0.076314554}, {355,0.076492958}, {356,0.077859155}, {357,0.078474178}, {358,0.078356808}, {359,0.079103286}, {360,0.076741784}, {361,0.075197183}, {362,0.075807512}, {363,0.075563380}, {364,0.076309859}, {365,0.078187793}, {366,0.079093897}, {367,0.078784038}, {368,0.078910798}, {369,0.079511737}, {370,0.078089202}, {371,0.078694836}, {372,0.080521127}, {373,0.084000000}, {374,0.084549296}, {375,0.084225352}, {376,0.084370892}, {377,0.084018779}, {378,0.084000000}, {379,0.083751174}, {380,0.084084507}, {381,0.084126761}, {382,0.083938967}, {383,0.084215962}, {384,0.084488263}, {385,0.084718310}, {386,0.084572770}, {387,0.084915493}, {388,0.088596244}, {389,0.089056338}, {390,0.089262911}, {391,0.088417840}, {392,0.088403756}, {393,0.088558685}, {394,0.088821596}, {395,0.089140845}, {396,0.093037559}, {397,0.091694836}, {398,0.092511737}, {399,0.089577465}, {400,0.093882629}, {401,0.091723005}, {402,0.092553991}, {403,0.096394366}, {404,0.096023474}, {405,0.095779343}, {406,0.094788732}, {407,0.095117371}, {408,0.098000000}, {409,0.098042254}, {410,0.097225352}, {411,0.096746479}, {412,0.097042254}, {413,0.099821596}, {414,0.098887324}, {415,0.098643192}, {416,0.098507042}, {417,0.101323944}, {418,0.100680751}, {419,0.100746479}, {420,0.099849765}, {421,0.102150235}, {422,0.100868545}, {423,0.099995305}, {424,0.102906103}, {425,0.102136150}, {426,0.101309859}, {427,0.101615023}, {428,0.103676056}, {429,0.102591549}, {430,0.102525822}, {431,0.105004695}, {432,0.104328638}, {433,0.103877934}, {434,0.107713615}, {435,0.105352113}, {436,0.105272300}, {437,0.110882629}, {438,0.105093897}, {439,0.106854460}, {440,0.109333333}, {441,0.108474178}, {442,0.111366197}, {443,0.110305164}, {444,0.109497653}, {445,0.111201878}, {446,0.110474178}, {447,0.112502347}, {448,0.112187793}, {449,0.111784038}, {450,0.112929577}, {451,0.111976526}, {452,0.114375587}, {453,0.113446009}, {454,0.114957746}, {455,0.114502347}, {456,0.113633803}, {457,0.114558685}, {458,0.114549296}, {459,0.116464789}, {460,0.115431925}, {461,0.117230047}, {462,0.115830986}, {463,0.118037559}, {464,0.117995305}, {465,0.118929577}, {466,0.118244131}, {467,0.119816901}, {468,0.118431925}, {469,0.120910798}, {470,0.119629108}, {471,0.121643192}, {472,0.121211268}, {473,0.121971831}, {474,0.124422535}, {475,0.123173709}, {476,0.123685446}, {477,0.122572770}, {478,0.124502347}, {479,0.123239437}, {480,0.124784038}, {481,0.127558685}, {482,0.125840376}, {483,0.127042254}, {484,0.127276995}, {485,0.127591549}, {486,0.129000000}, {487,0.127511737}, {488,0.129610329}, {489,0.133685446}, {490,0.131967136}, {491,0.132291080}, {492,0.134694836}, {493,0.132305164}, {494,0.133732394}, {495,0.134629108}, {496,0.133619718}, {497,0.135122066}, {498,0.136708920}, {499,0.134544601}, {500,0.137821596}, {505,0.140225352}, {510,0.143605634}, {515,0.142990610}, {520,0.144258216}, {525,0.145873239}, {530,0.148981221}, {535,0.151192488}, {540,0.155380282}, {545,0.156460094}, {550,0.161507042}, {555,0.161798122}, {560,0.165305164}, {565,0.166201878}, {570,0.171995305}, {575,0.173131455}, {580,0.178084507}, {585,0.177615023}, {590,0.180582160}, {595,0.183436620}, {600,0.187126761}, {605,0.187859155}, {610,0.191145540}, {615,0.193558685}, {620,0.197169014}, {625,0.198859155}, {630,0.203586854}, {635,0.205854460}, {640,0.209079812}, {645,0.211868545}, {650,0.216981221}, {655,0.215929577}, {660,0.220258216}, {665,0.222746479}, {670,0.226915493}, {675,0.230178404}, {680,0.232957746}, {685,0.235478873}, {690,0.238558685}, {695,0.241859155}, {700,0.250305164}, {705,0.250507042}, {710,0.254948357}, {715,0.258164319}, {720,0.264342723}, {725,0.266774648}, {730,0.271201878}, {735,0.270985915}, {740,0.278046948}, {745,0.281868545}, {750,0.281854460}, {755,0.287882629}, {760,0.293619718}, {765,0.288300469}, {770,0.292370892}, {775,0.297004695}, {780,0.301563380}, {785,0.302478873}, {790,0.307887324}, {795,0.311615023}, {800,0.315877934}, {805,0.319657277}, {810,0.327145540}, {815,0.326366197}, {820,0.331131455}, {825,0.333727700}, {830,0.336262911}, {835,0.340863850}, {840,0.342319249}, {845,0.347812207}, {850,0.351464789}, {855,0.353882629}, {860,0.358075117}, {865,0.362417840}, {870,0.363948357}, {875,0.374009390}, {880,0.373760563}, {885,0.377375587}, {890,0.383122066}, {895,0.392511737}, {900,0.396563380}, {905,0.399558685}, {910,0.400938967}, {915,0.408225352}, {920,0.409568075}, {925,0.415464789}, {930,0.415107981}, {935,0.420262911}, {940,0.428032864}, {945,0.424967136}, {950,0.430953052}, {955,0.438107981}, {960,0.440840376}, {965,0.444920188}, {970,0.448943662}, {975,0.452981221}, {980,0.457873239}, {985,0.463267606}, {990,0.470169014}, {995,0.471990610}, {1000,0.482713615}, {1010,0.485328638}, {1020,0.493699531}, {1030,0.500718310}, {1040,0.513760563}, {1050,0.531070423}, {1060,0.541474178}, {1070,0.547488263}, {1080,0.554258216}, {1090,0.558896714}, {1100,0.571516432}, {1110,0.580638498}, {1120,0.589967136}, {1130,0.599319249}, {1140,0.614093897}, {1150,0.631065728}, {1160,0.628103286}, {1170,0.642225352}, {1180,0.654525822}, {1190,0.662126761}, {1200,0.673098592}, {1210,0.679361502}, {1220,0.701347418}, {1230,0.712464789}, {1240,0.722084507}, {1250,0.733802817}, {1260,0.738521127}, {1270,0.752319249}, {1280,0.759380282}, {1290,0.771295775}, {1300,0.783450704}, {1310,0.798680751}, {1320,0.805694836}, {1330,0.824535211}, {1340,0.837868545}, {1350,0.837042254}, {1360,0.857892019}, {1370,0.873253521}, {1380,0.888347418}, {1390,0.889183099}, {1400,0.901915493}, {1410,0.911680751}, {1420,0.928638498}, {1430,0.942816901}, {1440,0.949361502}, {1450,0.961093897}, {1460,0.971159624}, {1470,0.985197183}, {1480,1.024934272}, {1490,1.029788732}, {1500,1.026661972}, {1510,1.051000}, {1520,1.047000}, {1530,1.076846}, {1540,1.086538}, {1550,1.094846}, {1560,1.100385}, {1570,1.115923}, {1580,1.146154}, {1590,1.148154}, {1600,1.158308}, {1610,1.176538}, {1620,1.184000}, {1630,1.215462}, {1640,1.219923}, {1650,1.225462}, {1660,1.243077}, {1670,1.254154}, {1680,1.277692}, {1690,1.290154}, {1700,1.295923}, {1710,1.315538}, {1720,1.347769}, {1730,1.343462}, {1740,1.370923}, {1750,1.369231}, {1760,1.377923}, {1770,1.421077}, {1780,1.428769}, {1790,1.428615}, {1800,1.442077}, {1810,1.457000}, {1820,1.486308}, {1830,1.494077}, {1840,1.506846}, {1850,1.519538}, {1860,1.536692}, {1870,1.562462}, {1880,1.605077}, {1890,1.585769}, {1900,1.597077}, {1910,1.622231}, {1920,1.636000}, {1930,1.647615}, {1940,1.669154}, {1950,1.676000}, {1960,1.695077}, {1970,1.715538}, {1980,1.720308}, {1990,1.739308}, {2000,1.789769}, {2050,1.844154}, {2100,1.935846}, {2150,1.998462}, {2200,2.090769}, {2250,2.206615}, {2300,2.277462}, {2350,2.379692}, {2400,2.467077}, {2450,2.597692}, {2500,2.668462}, {2550,2.771923}, {2600,2.887692}, {2650,2.984615}, {2700,3.100385}, {2750,3.240385}, {2800,3.315615}, {2850,3.416923}, {2900,3.547538}, {2950,3.663538}, {3000,3.862231}, {3050,3.931385}, {3100,4.046308}, {3150,4.173077}, {3200,4.327077}, {3250,4.433923}, {3300,4.592923}, {3350,4.722308}, {3400,4.852154}, {3450,4.978769}, {3500,5.112308}, {3550,5.289462}, {3600,5.412692}, {3650,5.580462}, {3700,5.731308}, {3750,5.863769}, {3800,6.038769}, {3850,6.164923}, {3900,6.348308}, {3950,6.498231}, {4000,6.690308}, {4050,6.813308}, {4100,7.050231}, {4150,7.175692}, {4200,7.361385}, {4250,7.499538}, {4300,7.688308}, {4350,7.826231}, {4400,8.074077}, {4450,8.301000}, {4500,8.435692}, {4550,8.633154}, {4600,8.799615}, {4650,8.942231}, {4700,9.188308}, {4750,9.332615}, {4800,9.547077}, {4850,9.743615}, {4900,9.918385}, {4950,10.174385}, {5000,10.346692}, {5050,10.586077}, {5100,10.824769}, {5150,11.081231}, {5200,11.269077}, {5250,11.439231}, {5300,11.694538}, {5350,11.887154}, {5400,12.104231}, {5450,12.363846}, {5500,12.540462}, {5550,12.777538}, {5600,13.065923}, {5650,13.270923}, {5700,13.528692}, {5750,13.758000}, {5800,14.031846}, {5850,14.271077}, {5900,14.528538}, {5950,14.769615}, {6000,15.021538}, {6050,15.326692}, {6100,15.546385}, {6150,15.776231}, {6200,16.147000}, {6250,16.376000}, {6300,16.655846}, {6350,16.905385}, {6400,17.189385}, {6450,17.524000}, {6500,17.710692}, {6550,18.044769}, {6600,18.292000}, {6650,18.643077}, {6700,18.901077}, {6750,19.191462}, {6800,19.525308}, {6850,19.922462}, {6900,20.086000}, {6950,20.374154}, {7000,20.621462}, {7050,20.942154}, {7100,21.259538}, {7150,21.568231}, {7200,21.828308}, {7250,22.120154}, {7300,22.336231}, {7350,22.731385}, {7400,23.150769}, {7450,23.529154}, {7500,23.762077}, {7550,24.145538}, {7600,24.309000}, {7650,24.852231}, {7700,25.193692}, {7750,25.467000}, {7800,25.790923}, {7850,26.022462}, {7900,26.421154}, {7950,26.618462}, {8000,27.233462}, {8050,27.459385}, {8100,27.789462}, {8150,28.116308}, {8200,28.472231}, {8250,28.925769}, {8300,29.201923}, {8350,29.595308}, {8400,29.906462}, {8450,30.361154}, {8500,30.598615}, {8550,31.065077}, {8600,31.399769}, {8650,31.783000}, {8700,32.257846}, {8750,32.476000}, {8800,32.997923}, {8850,33.315077}, {8900,33.706769}, {8950,34.212538}, {9000,34.549615}, {9050,34.784769}, {9100,35.507000}, {9150,35.790385}, {9200,36.134615}, {9250,36.432846}, {9300,36.849692}, {9350,37.134846}, {9400,37.530846}, {9450,37.854077}, {9500,38.432000}, {9550,38.757154}, {9600,39.185154}, {9650,39.510692}, {9700,40.415615}, {9750,40.783462}, {9800,40.979846}, {9850,41.429154}, {9900,41.914769}, {9950,42.418154}, {10000,42.848846}};
data["big_flat"]["Mtac2"]["actual reif"]["system"] = {{1,0.000521127}, {2,0.000089202}, {3,0.000000000}, {4,0.000018779}, {5,0.000037559}, {6,0.000037559}, {7,0.000000000}, {8,0.000056338}, {9,0.000018779}, {10,0.000056338}, {11,0.000018779}, {12,0.000000000}, {13,0.000037559}, {14,0.000075117}, {15,0.000000000}, {16,0.000018779}, {17,0.000018779}, {18,0.000014085}, {19,0.000056338}, {20,0.000032864}, {21,0.000150235}, {22,0.000051643}, {23,0.000014085}, {24,0.000000000}, {25,0.000000000}, {26,0.000014085}, {27,0.000037559}, {28,0.000032864}, {29,0.000000000}, {30,0.000018779}, {31,0.000000000}, {32,0.000000000}, {33,0.000014085}, {34,0.000000000}, {35,0.000000000}, {36,0.000018779}, {37,0.000000000}, {38,0.000037559}, {39,0.000018779}, {40,0.000000000}, {41,0.000018779}, {42,0.000018779}, {43,0.000014085}, {44,0.000000000}, {45,0.000037559}, {46,0.000032864}, {47,0.000018779}, {48,0.000037559}, {49,0.000018779}, {50,0.000000000}, {51,0.000000000}, {52,0.000018779}, {53,0.000018779}, {54,0.000056338}, {55,0.000014085}, {56,0.000000000}, {57,0.000000000}, {58,0.000051643}, {59,0.000018779}, {60,0.000032864}, {61,0.000018779}, {62,0.000018779}, {63,0.000000000}, {64,0.000014085}, {65,0.000018779}, {66,0.000000000}, {67,0.000065728}, {68,0.000018779}, {69,0.000032864}, {70,0.000018779}, {71,0.000000000}, {72,0.000000000}, {73,0.000018779}, {74,0.000000000}, {75,0.000037559}, {76,0.000018779}, {77,0.000000000}, {78,0.000000000}, {79,0.000018779}, {80,0.000000000}, {81,0.000051643}, {82,0.000065728}, {83,0.000018779}, {84,0.000018779}, {85,0.000037559}, {86,0.000000000}, {87,0.000014085}, {88,0.000037559}, {89,0.000037559}, {90,0.000018779}, {91,0.000032864}, {92,0.000028169}, {93,0.000051643}, {94,0.000018779}, {95,0.000000000}, {96,0.000018779}, {97,0.000018779}, {98,0.000018779}, {99,0.000014085}, {100,0.000018779}, {101,0.000037559}, {102,0.000037559}, {103,0.000014085}, {104,0.000037559}, {105,0.000098592}, {106,0.000018779}, {107,0.000000000}, {108,0.000018779}, {109,0.000000000}, {110,0.000000000}, {111,0.000018779}, {112,0.000018779}, {113,0.000014085}, {114,0.000000000}, {115,0.000018779}, {116,0.000014085}, {117,0.000051643}, {118,0.000000000}, {119,0.000000000}, {120,0.000018779}, {121,0.000028169}, {122,0.000037559}, {123,0.000014085}, {124,0.000037559}, {125,0.000018779}, {126,0.000037559}, {127,0.000037559}, {128,0.000037559}, {129,0.000000000}, {130,0.000000000}, {131,0.000018779}, {132,0.000000000}, {133,0.000018779}, {134,0.000037559}, {135,0.000014085}, {136,0.000000000}, {137,0.000000000}, {138,0.000014085}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000032864}, {143,0.000018779}, {144,0.000018779}, {145,0.000018779}, {146,0.000018779}, {147,0.000032864}, {148,0.000018779}, {149,0.000000000}, {150,0.000000000}, {151,0.000037559}, {152,0.000037559}, {153,0.000000000}, {154,0.000037559}, {155,0.000070423}, {156,0.000018779}, {157,0.000018779}, {158,0.000000000}, {159,0.000000000}, {160,0.000070423}, {161,0.000018779}, {162,0.000070423}, {163,0.000014085}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000037559}, {169,0.000075117}, {170,0.000037559}, {171,0.000000000}, {172,0.000018779}, {173,0.000037559}, {174,0.000018779}, {175,0.000000000}, {176,0.000051643}, {177,0.000000000}, {178,0.000037559}, {179,0.000093897}, {180,0.000028169}, {181,0.000000000}, {182,0.000018779}, {183,0.000032864}, {184,0.000018779}, {185,0.000018779}, {186,0.000000000}, {187,0.000000000}, {188,0.000107981}, {189,0.000037559}, {190,0.000000000}, {191,0.000164319}, {192,0.000018779}, {193,0.000037559}, {194,0.000056338}, {195,0.000000000}, {196,0.000000000}, {197,0.000037559}, {198,0.000000000}, {199,0.000093897}, {200,0.000032864}, {201,0.000032864}, {202,0.000037559}, {203,0.000000000}, {204,0.000032864}, {205,0.000051643}, {206,0.000037559}, {207,0.000032864}, {208,0.000037559}, {209,0.000000000}, {210,0.000018779}, {211,0.000000000}, {212,0.000037559}, {213,0.000014085}, {214,0.000065728}, {215,0.000014085}, {216,0.000000000}, {217,0.000018779}, {218,0.000051643}, {219,0.000032864}, {220,0.000018779}, {221,0.000089202}, {222,0.000018779}, {223,0.000018779}, {224,0.000000000}, {225,0.000000000}, {226,0.000056338}, {227,0.000037559}, {228,0.000070423}, {229,0.000037559}, {230,0.000122066}, {231,0.000014085}, {232,0.000037559}, {233,0.000000000}, {234,0.000164319}, {235,0.000014085}, {236,0.000075117}, {237,0.000000000}, {238,0.000018779}, {239,0.000018779}, {240,0.000018779}, {241,0.000000000}, {242,0.000018779}, {243,0.000000000}, {244,0.000145540}, {245,0.000000000}, {246,0.000056338}, {247,0.000032864}, {248,0.000032864}, {249,0.000018779}, {250,0.000140845}, {251,0.000037559}, {252,0.000018779}, {253,0.000018779}, {254,0.000018779}, {255,0.000032864}, {256,0.000000000}, {257,0.000089202}, {258,0.000000000}, {259,0.000075117}, {260,0.000018779}, {261,0.000070423}, {262,0.000018779}, {263,0.000018779}, {264,0.000070423}, {265,0.000037559}, {266,0.000122066}, {267,0.000014085}, {268,0.000070423}, {269,0.000014085}, {270,0.000000000}, {271,0.000183099}, {272,0.000037559}, {273,0.000056338}, {274,0.000037559}, {275,0.000000000}, {276,0.000103286}, {277,0.000070423}, {278,0.000046948}, {279,0.000093897}, {280,0.000032864}, {281,0.000079812}, {282,0.000075117}, {283,0.000037559}, {284,0.000051643}, {285,0.000103286}, {286,0.000018779}, {287,0.000051643}, {288,0.000122066}, {289,0.000000000}, {290,0.000112676}, {291,0.000018779}, {292,0.000000000}, {293,0.000075117}, {294,0.000037559}, {295,0.000018779}, {296,0.000061033}, {297,0.000234742}, {298,0.000089202}, {299,0.000014085}, {300,0.000126761}, {301,0.000112676}, {302,0.000018779}, {303,0.000070423}, {304,0.000089202}, {305,0.000107981}, {306,0.000018779}, {307,0.000056338}, {308,0.000145540}, {309,0.000037559}, {310,0.000032864}, {311,0.000032864}, {312,0.000075117}, {313,0.000126761}, {314,0.000037559}, {315,0.000131455}, {316,0.000032864}, {317,0.000075117}, {318,0.000051643}, {319,0.000018779}, {320,0.000112676}, {321,0.000126761}, {322,0.000051643}, {323,0.000093897}, {324,0.000018779}, {325,0.000056338}, {326,0.000070423}, {327,0.000112676}, {328,0.000075117}, {329,0.000037559}, {330,0.000000000}, {331,0.000089202}, {332,0.000018779}, {333,0.000117371}, {334,0.000117371}, {335,0.000056338}, {336,0.000000000}, {337,0.000037559}, {338,0.000000000}, {339,0.000051643}, {340,0.000070423}, {341,0.000131455}, {342,0.000084507}, {343,0.000070423}, {344,0.000070423}, {345,0.000000000}, {346,0.000084507}, {347,0.000131455}, {348,0.000056338}, {349,0.000107981}, {350,0.000051643}, {351,0.000056338}, {352,0.000140845}, {353,0.000093897}, {354,0.000103286}, {355,0.000103286}, {356,0.000107981}, {357,0.000000000}, {358,0.000037559}, {359,0.000000000}, {360,0.000000000}, {361,0.000018779}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000037559}, {367,0.000000000}, {368,0.000037559}, {369,0.000000000}, {370,0.000000000}, {371,0.000037559}, {372,0.000018779}, {373,0.000056338}, {374,0.000014085}, {375,0.000018779}, {376,0.000000000}, {377,0.000000000}, {378,0.000051643}, {379,0.000037559}, {380,0.000000000}, {381,0.000000000}, {382,0.000018779}, {383,0.000037559}, {384,0.000000000}, {385,0.000018779}, {386,0.000018779}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000018779}, {392,0.000018779}, {393,0.000000000}, {394,0.000014085}, {395,0.000000000}, {396,0.000018779}, {397,0.000000000}, {398,0.000056338}, {399,0.000037559}, {400,0.000037559}, {401,0.000037559}, {402,0.000000000}, {403,0.000014085}, {404,0.000000000}, {405,0.000000000}, {406,0.000037559}, {407,0.000000000}, {408,0.000018779}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000070423}, {413,0.000018779}, {414,0.000000000}, {415,0.000018779}, {416,0.000000000}, {417,0.000000000}, {418,0.000018779}, {419,0.000000000}, {420,0.000018779}, {421,0.000000000}, {422,0.000018779}, {423,0.000000000}, {424,0.000032864}, {425,0.000056338}, {426,0.000018779}, {427,0.000018779}, {428,0.000018779}, {429,0.000032864}, {430,0.000037559}, {431,0.000000000}, {432,0.000018779}, {433,0.000037559}, {434,0.000018779}, {435,0.000037559}, {436,0.000018779}, {437,0.000018779}, {438,0.000018779}, {439,0.000000000}, {440,0.000000000}, {441,0.000037559}, {442,0.000018779}, {443,0.000032864}, {444,0.000051643}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000037559}, {449,0.000000000}, {450,0.000037559}, {451,0.000018779}, {452,0.000018779}, {453,0.000037559}, {454,0.000000000}, {455,0.000018779}, {456,0.000018779}, {457,0.000018779}, {458,0.000000000}, {459,0.000014085}, {460,0.000014085}, {461,0.000056338}, {462,0.000014085}, {463,0.000037559}, {464,0.000014085}, {465,0.000056338}, {466,0.000000000}, {467,0.000000000}, {468,0.000075117}, {469,0.000000000}, {470,0.000037559}, {471,0.000018779}, {472,0.000018779}, {473,0.000018779}, {474,0.000018779}, {475,0.000018779}, {476,0.000028169}, {477,0.000056338}, {478,0.000037559}, {479,0.000028169}, {480,0.000056338}, {481,0.000084507}, {482,0.000000000}, {483,0.000000000}, {484,0.000018779}, {485,0.000018779}, {486,0.000018779}, {487,0.000037559}, {488,0.000056338}, {489,0.000000000}, {490,0.000000000}, {491,0.000070423}, {492,0.000018779}, {493,0.000014085}, {494,0.000070423}, {495,0.000018779}, {496,0.000037559}, {497,0.000037559}, {498,0.000018779}, {499,0.000018779}, {500,0.000037559}, {505,0.000000000}, {510,0.000018779}, {515,0.000051643}, {520,0.000000000}, {525,0.000000000}, {530,0.000018779}, {535,0.000037559}, {540,0.000037559}, {545,0.000032864}, {550,0.000000000}, {555,0.000018779}, {560,0.000018779}, {565,0.000000000}, {570,0.000018779}, {575,0.000018779}, {580,0.000037559}, {585,0.000000000}, {590,0.000018779}, {595,0.000000000}, {600,0.000018779}, {605,0.000037559}, {610,0.000014085}, {615,0.000037559}, {620,0.000056338}, {625,0.000037559}, {630,0.000032864}, {635,0.000065728}, {640,0.000014085}, {645,0.000018779}, {650,0.000037559}, {655,0.000000000}, {660,0.000018779}, {665,0.000018779}, {670,0.000000000}, {675,0.000000000}, {680,0.000018779}, {685,0.000018779}, {690,0.000032864}, {695,0.000000000}, {700,0.000037559}, {705,0.000070423}, {710,0.000000000}, {715,0.000000000}, {720,0.000056338}, {725,0.000018779}, {730,0.000037559}, {735,0.000046948}, {740,0.000056338}, {745,0.000046948}, {750,0.000070423}, {755,0.000075117}, {760,0.000037559}, {765,0.000056338}, {770,0.000056338}, {775,0.000000000}, {780,0.000037559}, {785,0.000018779}, {790,0.000018779}, {795,0.000032864}, {800,0.000051643}, {805,0.000018779}, {810,0.000014085}, {815,0.000075117}, {820,0.000112676}, {825,0.000037559}, {830,0.000046948}, {835,0.000056338}, {840,0.000000000}, {845,0.000037559}, {850,0.000051643}, {855,0.000070423}, {860,0.000056338}, {865,0.000075117}, {870,0.000089202}, {875,0.000056338}, {880,0.000018779}, {885,0.000065728}, {890,0.000018779}, {895,0.000056338}, {900,0.000056338}, {905,0.000032864}, {910,0.000056338}, {915,0.000014085}, {920,0.000032864}, {925,0.000018779}, {930,0.000075117}, {935,0.000037559}, {940,0.000051643}, {945,0.000070423}, {950,0.000070423}, {955,0.000032864}, {960,0.000000000}, {965,0.000051643}, {970,0.000018779}, {975,0.000018779}, {980,0.000056338}, {985,0.000018779}, {990,0.000056338}, {995,0.000037559}, {1000,0.000056338}, {1010,0.000037559}, {1020,0.000075117}, {1030,0.000056338}, {1040,0.000018779}, {1050,0.000037559}, {1060,0.000014085}, {1070,0.000037559}, {1080,0.000093897}, {1090,0.000037559}, {1100,0.000070423}, {1110,0.000000000}, {1120,0.000150235}, {1130,0.000075117}, {1140,0.000037559}, {1150,0.000037559}, {1160,0.000051643}, {1170,0.000065728}, {1180,0.000037559}, {1190,0.000056338}, {1200,0.000107981}, {1210,0.000089202}, {1220,0.000018779}, {1230,0.000051643}, {1240,0.000070423}, {1250,0.000206573}, {1260,0.000070423}, {1270,0.000037559}, {1280,0.000014085}, {1290,0.000075117}, {1300,0.000037559}, {1310,0.000107981}, {1320,0.000018779}, {1330,0.000093897}, {1340,0.000093897}, {1350,0.000126761}, {1360,0.000126761}, {1370,0.000126761}, {1380,0.000000000}, {1390,0.000065728}, {1400,0.000122066}, {1410,0.000126761}, {1420,0.000028169}, {1430,0.000056338}, {1440,0.000112676}, {1450,0.000018779}, {1460,0.000037559}, {1470,0.000037559}, {1480,0.000089202}, {1490,0.000056338}, {1500,0.000089202}, {1510,0.001154}, {1520,0.000846}, {1530,0.001846}, {1540,0.000308}, {1550,0.001231}, {1560,0.000615}, {1570,0.000308}, {1580,0.000923}, {1590,0.001154}, {1600,0.000000}, {1610,0.000923}, {1620,0.001462}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000000}, {1680,0.000000}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000000}, {1730,0.000000}, {1740,0.000538}, {1750,0.000000}, {1760,0.000000}, {1770,0.000000}, {1780,0.000000}, {1790,0.000308}, {1800,0.000000}, {1810,0.000231}, {1820,0.000000}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000308}, {1900,0.000308}, {1910,0.000000}, {1920,0.000000}, {1930,0.000308}, {1940,0.000000}, {1950,0.000000}, {1960,0.000000}, {1970,0.000000}, {1980,0.000308}, {1990,0.000000}, {2000,0.000308}, {2050,0.000000}, {2100,0.000000}, {2150,0.000000}, {2200,0.000000}, {2250,0.000000}, {2300,0.000000}, {2350,0.000308}, {2400,0.000000}, {2450,0.000615}, {2500,0.000000}, {2550,0.000615}, {2600,0.000308}, {2650,0.000000}, {2700,0.000538}, {2750,0.000615}, {2800,0.000000}, {2850,0.000538}, {2900,0.000308}, {2950,0.000308}, {3000,0.000538}, {3050,0.000000}, {3100,0.000615}, {3150,0.000000}, {3200,0.000615}, {3250,0.000000}, {3300,0.001231}, {3350,0.003077}, {3400,0.000000}, {3450,0.000000}, {3500,0.000000}, {3550,0.000000}, {3600,0.000615}, {3650,0.000615}, {3700,0.000308}, {3750,0.000000}, {3800,0.000000}, {3850,0.000538}, {3900,0.000000}, {3950,0.000923}, {4000,0.000923}, {4050,0.000308}, {4100,0.000923}, {4150,0.000000}, {4200,0.000308}, {4250,0.000308}, {4300,0.000923}, {4350,0.000615}, {4400,0.000000}, {4450,0.000923}, {4500,0.000615}, {4550,0.000000}, {4600,0.000923}, {4650,0.000846}, {4700,0.000923}, {4750,0.000308}, {4800,0.000000}, {4850,0.000538}, {4900,0.000923}, {4950,0.000308}, {5000,0.000308}, {5050,0.001231}, {5100,0.000615}, {5150,0.001154}, {5200,0.001231}, {5250,0.000615}, {5300,0.001154}, {5350,0.002385}, {5400,0.001538}, {5450,0.002385}, {5500,0.000308}, {5550,0.000308}, {5600,0.001231}, {5650,0.001538}, {5700,0.000923}, {5750,0.001231}, {5800,0.001846}, {5850,0.002077}, {5900,0.000923}, {5950,0.001538}, {6000,0.001769}, {6050,0.001154}, {6100,0.002769}, {6150,0.001462}, {6200,0.002385}, {6250,0.001538}, {6300,0.001538}, {6350,0.002769}, {6400,0.002385}, {6450,0.002308}, {6500,0.001538}, {6550,0.000615}, {6600,0.002154}, {6650,0.003308}, {6700,0.002000}, {6750,0.001846}, {6800,0.003923}, {6850,0.006077}, {6900,0.002308}, {6950,0.003692}, {7000,0.003000}, {7050,0.003692}, {7100,0.001538}, {7150,0.003615}, {7200,0.002462}, {7250,0.002462}, {7300,0.003231}, {7350,0.002462}, {7400,0.007308}, {7450,0.005769}, {7500,0.007231}, {7550,0.004846}, {7600,0.005077}, {7650,0.006231}, {7700,0.002692}, {7750,0.004615}, {7800,0.005769}, {7850,0.004385}, {7900,0.005769}, {7950,0.003923}, {8000,0.008615}, {8050,0.006077}, {8100,0.002385}, {8150,0.003154}, {8200,0.001231}, {8250,0.003385}, {8300,0.002462}, {8350,0.001538}, {8400,0.003385}, {8450,0.001231}, {8500,0.000615}, {8550,0.001769}, {8600,0.001538}, {8650,0.001462}, {8700,0.004000}, {8750,0.002385}, {8800,0.003923}, {8850,0.005385}, {8900,0.004308}, {8950,0.006154}, {9000,0.006462}, {9050,0.004846}, {9100,0.031692}, {9150,0.006615}, {9200,0.003692}, {9250,0.003538}, {9300,0.005231}, {9350,0.005077}, {9400,0.004923}, {9450,0.003923}, {9500,0.005154}, {9550,0.006077}, {9600,0.005154}, {9650,0.008000}, {9700,0.004385}, {9750,0.009538}, {9800,0.005538}, {9850,0.006692}, {9900,0.003231}, {9950,0.005538}, {10000,0.006154}};
data["big_flat"]["Mtac2"]["cbv"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000004695}, {181,0.000000000}, {182,0.000004695}, {183,0.000004695}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.001000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000004695}, {247,0.000000000}, {248,0.000004695}, {249,0.000004695}, {250,0.000032864}, {251,0.000009390}, {252,0.000023474}, {253,0.000079812}, {254,0.000028169}, {255,0.000004695}, {256,0.000009390}, {257,0.000000000}, {258,0.000004695}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000014085}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000004695}, {270,0.000014085}, {271,0.000018779}, {272,0.000028169}, {273,0.000028169}, {274,0.000023474}, {275,0.000004695}, {276,0.000009390}, {277,0.000004695}, {278,0.000009390}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000004695}, {294,0.000004695}, {295,0.000004695}, {296,0.000023474}, {297,0.000004695}, {298,0.000023474}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000004695}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000004695}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000009390}, {334,0.000018779}, {335,0.000004695}, {336,0.000023474}, {337,0.000028169}, {338,0.000004695}, {339,0.000000000}, {340,0.000000000}, {341,0.000004695}, {342,0.000004695}, {343,0.000004695}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000009390}, {350,0.000028169}, {351,0.000018779}, {352,0.000009390}, {353,0.000004695}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000004695}, {361,0.000004695}, {362,0.000000000}, {363,0.000009390}, {364,0.000004695}, {365,0.000014085}, {366,0.000014085}, {367,0.000009390}, {368,0.000000000}, {369,0.000000000}, {370,0.001004695}, {371,0.000009390}, {372,0.000004695}, {373,0.000000000}, {374,0.000009390}, {375,0.000018779}, {376,0.000004695}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000004695}, {384,0.000004695}, {385,0.000009390}, {386,0.000004695}, {387,0.000000000}, {388,0.000000000}, {389,0.000009390}, {390,0.000023474}, {391,0.000009390}, {392,0.000009390}, {393,0.000004695}, {394,0.000014085}, {395,0.000028169}, {396,0.000018779}, {397,0.000004695}, {398,0.000018779}, {399,0.000009390}, {400,0.000014085}, {401,0.000009390}, {402,0.000000000}, {403,0.000000000}, {404,0.000009390}, {405,0.000014085}, {406,0.000028169}, {407,0.000023474}, {408,0.000009390}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000014085}, {417,0.002516432}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000009390}, {425,0.000004695}, {426,0.000000000}, {427,0.000000000}, {428,0.000004695}, {429,0.000000000}, {430,0.000000000}, {431,0.000004695}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000009390}, {436,0.000000000}, {437,0.000037559}, {438,0.000028169}, {439,0.000004695}, {440,0.000028169}, {441,0.000023474}, {442,0.000037559}, {443,0.000032864}, {444,0.000037559}, {445,0.000028169}, {446,0.000009390}, {447,0.000009390}, {448,0.000023474}, {449,0.000037559}, {450,0.000042254}, {451,0.000056338}, {452,0.000037559}, {453,0.000056338}, {454,0.000075117}, {455,0.000093897}, {456,0.000075117}, {457,0.000187793}, {458,0.000136150}, {459,0.000150235}, {460,0.000136150}, {461,0.000211268}, {462,0.000206573}, {463,0.000276995}, {464,0.000309859}, {465,0.000399061}, {466,0.000417840}, {467,0.000469484}, {468,0.000460094}, {469,0.000535211}, {470,0.000558685}, {471,0.000615023}, {472,0.000661972}, {473,0.000732394}, {474,0.000769953}, {475,0.000854460}, {476,0.000755869}, {477,0.000812207}, {478,0.000845070}, {479,0.000835681}, {480,0.000887324}, {481,0.000896714}, {482,0.000906103}, {483,0.000910798}, {484,0.000901408}, {485,0.000901408}, {486,0.000906103}, {487,0.000901408}, {488,0.000910798}, {489,0.000920188}, {490,0.000934272}, {491,0.000920188}, {492,0.000953052}, {493,0.000934272}, {494,0.000934272}, {495,0.000943662}, {496,0.000953052}, {497,0.000971831}, {498,0.000962441}, {499,0.000985915}, {500,0.000981221}, {505,0.001009390}, {510,0.001000000}, {515,0.001004695}, {520,0.001004695}, {525,0.001000000}, {530,0.001004695}, {535,0.001000000}, {540,0.001000000}, {545,0.001000000}, {550,0.001000000}, {555,0.001004695}, {560,0.001009390}, {565,0.001000000}, {570,0.001009390}, {575,0.001004695}, {580,0.001018779}, {585,0.001009390}, {590,0.001014085}, {595,0.001004695}, {600,0.001004695}, {605,0.001018779}, {610,0.001009390}, {615,0.001018779}, {620,0.001000000}, {625,0.001009390}, {630,0.001000000}, {635,0.001000000}, {640,0.001009390}, {645,0.001028169}, {650,0.001018779}, {655,0.001000000}, {660,0.001009390}, {665,0.001000000}, {670,0.001009390}, {675,0.001018779}, {680,0.001009390}, {685,0.001009390}, {690,0.001009390}, {695,0.001028169}, {700,0.001159624}, {705,0.001098592}, {710,0.001056338}, {715,0.002924883}, {720,0.001093897}, {725,0.001075117}, {730,0.001056338}, {735,0.001009390}, {740,0.001018779}, {745,0.001084507}, {750,0.001018779}, {755,0.001014085}, {760,0.001000000}, {765,0.001009390}, {770,0.003962441}, {775,0.001018779}, {780,0.001028169}, {785,0.001018779}, {790,0.001065728}, {795,0.001070423}, {800,0.001046948}, {805,0.001056338}, {810,0.001046948}, {815,0.001042254}, {820,0.001004695}, {825,0.001014085}, {830,0.001000000}, {835,0.001028169}, {840,0.001000000}, {845,0.001014085}, {850,0.001000000}, {855,0.001028169}, {860,0.001014085}, {865,0.001028169}, {870,0.004051643}, {875,0.001061033}, {880,0.001000000}, {885,0.001000000}, {890,0.001000000}, {895,0.001028169}, {900,0.001023474}, {905,0.001014085}, {910,0.001046948}, {915,0.001061033}, {920,0.001089202}, {925,0.001192488}, {930,0.001239437}, {935,0.001347418}, {940,0.001441315}, {945,0.001582160}, {950,0.001657277}, {955,0.001676056}, {960,0.001802817}, {965,0.001802817}, {970,0.001812207}, {975,0.001863850}, {980,0.001863850}, {985,0.001873239}, {990,0.001953052}, {995,0.001906103}, {1000,0.001957746}, {1010,0.001976526}, {1020,0.002018779}, {1030,0.002009390}, {1040,0.002014085}, {1050,0.002037559}, {1060,0.002000000}, {1070,0.002014085}, {1080,0.002042254}, {1090,0.005816901}, {1100,0.002070423}, {1110,0.002000000}, {1120,0.002056338}, {1130,0.002014085}, {1140,0.002014085}, {1150,0.002028169}, {1160,0.002014085}, {1170,0.002084507}, {1180,0.002098592}, {1190,0.002056338}, {1200,0.002042254}, {1210,0.002014085}, {1220,0.002028169}, {1230,0.002046948}, {1240,0.002032864}, {1250,0.002028169}, {1260,0.002084507}, {1270,0.002126761}, {1280,0.002000000}, {1290,0.002037559}, {1300,0.002028169}, {1310,0.002037559}, {1320,0.002061033}, {1330,0.002131455}, {1340,0.002037559}, {1350,0.002032864}, {1360,0.002098592}, {1370,0.002267606}, {1380,0.002370892}, {1390,0.002436620}, {1400,0.002525822}, {1410,0.002605634}, {1420,0.002661972}, {1430,0.002741784}, {1440,0.002774648}, {1450,0.002845070}, {1460,0.002882629}, {1470,0.002854460}, {1480,0.002924883}, {1490,0.003004695}, {1500,0.002995305}, {1510,0.002923}, {1520,0.007308}, {1530,0.003000}, {1540,0.003000}, {1550,0.003000}, {1560,0.003000}, {1570,0.003000}, {1580,0.003000}, {1590,0.003000}, {1600,0.007308}, {1610,0.003000}, {1620,0.003000}, {1630,0.003000}, {1640,0.003000}, {1650,0.008462}, {1660,0.003000}, {1670,0.003000}, {1680,0.003000}, {1690,0.003000}, {1700,0.003000}, {1710,0.003000}, {1720,0.003308}, {1730,0.003000}, {1740,0.003000}, {1750,0.003000}, {1760,0.009231}, {1770,0.003385}, {1780,0.003385}, {1790,0.003000}, {1800,0.003000}, {1810,0.003000}, {1820,0.003000}, {1830,0.003462}, {1840,0.003154}, {1850,0.003308}, {1860,0.003308}, {1870,0.003308}, {1880,0.003308}, {1890,0.003308}, {1900,0.003308}, {1910,0.003308}, {1920,0.003846}, {1930,0.004000}, {1940,0.004000}, {1950,0.004000}, {1960,0.004231}, {1970,0.010846}, {1980,0.003923}, {1990,0.003923}, {2000,0.004231}, {2050,0.004000}, {2100,0.004308}, {2150,0.008923}, {2200,0.004000}, {2250,0.004000}, {2300,0.004231}, {2350,0.004308}, {2400,0.004615}, {2450,0.004846}, {2500,0.004923}, {2550,0.005000}, {2600,0.005000}, {2650,0.005000}, {2700,0.005000}, {2750,0.005154}, {2800,0.005308}, {2850,0.005692}, {2900,0.005769}, {2950,0.005923}, {3000,0.006000}, {3050,0.006000}, {3100,0.006000}, {3150,0.006077}, {3200,0.006154}, {3250,0.006385}, {3300,0.006769}, {3350,0.006846}, {3400,0.006846}, {3450,0.006846}, {3500,0.007000}, {3550,0.007154}, {3600,0.007308}, {3650,0.007308}, {3700,0.016538}, {3750,0.007692}, {3800,0.020615}, {3850,0.007769}, {3900,0.020846}, {3950,0.008000}, {4000,0.008077}, {4050,0.023846}, {4100,0.008308}, {4150,0.019615}, {4200,0.008692}, {4250,0.008769}, {4300,0.008769}, {4350,0.008846}, {4400,0.028769}, {4450,0.009308}, {4500,0.009308}, {4550,0.009308}, {4600,0.009385}, {4650,0.009769}, {4700,0.009846}, {4750,0.026923}, {4800,0.010000}, {4850,0.021308}, {4900,0.010154}, {4950,0.019615}, {5000,0.023462}, {5050,0.010385}, {5100,0.025692}, {5150,0.011000}, {5200,0.011077}, {5250,0.011000}, {5300,0.011231}, {5350,0.011231}, {5400,0.011308}, {5450,0.011308}, {5500,0.011462}, {5550,0.012000}, {5600,0.012077}, {5650,0.012077}, {5700,0.026077}, {5750,0.012308}, {5800,0.012308}, {5850,0.012154}, {5900,0.012615}, {5950,0.012692}, {6000,0.024308}, {6050,0.013231}, {6100,0.028462}, {6150,0.013231}, {6200,0.013308}, {6250,0.013462}, {6300,0.013538}, {6350,0.013769}, {6400,0.021462}, {6450,0.014308}, {6500,0.025308}, {6550,0.023923}, {6600,0.014385}, {6650,0.014385}, {6700,0.014385}, {6750,0.014692}, {6800,0.023000}, {6850,0.015231}, {6900,0.028692}, {6950,0.015308}, {7000,0.015308}, {7050,0.025308}, {7100,0.015385}, {7150,0.015615}, {7200,0.015923}, {7250,0.033538}, {7300,0.016231}, {7350,0.016308}, {7400,0.028923}, {7450,0.016462}, {7500,0.016538}, {7550,0.016615}, {7600,0.029154}, {7650,0.033692}, {7700,0.037231}, {7750,0.033692}, {7800,0.017462}, {7850,0.017385}, {7900,0.017385}, {7950,0.017538}, {8000,0.017846}, {8050,0.018308}, {8100,0.018308}, {8150,0.018231}, {8200,0.018231}, {8250,0.037385}, {8300,0.018462}, {8350,0.037308}, {8400,0.033846}, {8450,0.019000}, {8500,0.019231}, {8550,0.034923}, {8600,0.043385}, {8650,0.019538}, {8700,0.019692}, {8750,0.036538}, {8800,0.032923}, {8850,0.037000}, {8900,0.020308}, {8950,0.020462}, {9000,0.020308}, {9050,0.042846}, {9100,0.020846}, {9150,0.020462}, {9200,0.020462}, {9250,0.044231}, {9300,0.021231}, {9350,0.031154}, {9400,0.021462}, {9450,0.042154}, {9500,0.021385}, {9550,0.021462}, {9600,0.037615}, {9650,0.021538}, {9700,0.022077}, {9750,0.022308}, {9800,0.047538}, {9850,0.043538}, {9900,0.036462}, {9950,0.050462}, {10000,0.022923}};
data["big_flat"]["Mtac2"]["cbv"]["user"] = {{1,0.000018779}, {2,0.000018779}, {3,0.000000000}, {4,0.000037559}, {5,0.000037559}, {6,0.000018779}, {7,0.000018779}, {8,0.000075117}, {9,0.000056338}, {10,0.000056338}, {11,0.000018779}, {12,0.000037559}, {13,0.000056338}, {14,0.000075117}, {15,0.000037559}, {16,0.000075117}, {17,0.000075117}, {18,0.000056338}, {19,0.000075117}, {20,0.000037559}, {21,0.000093897}, {22,0.000032864}, {23,0.000075117}, {24,0.000070423}, {25,0.000093897}, {26,0.000107981}, {27,0.000089202}, {28,0.000037559}, {29,0.000093897}, {30,0.000070423}, {31,0.000056338}, {32,0.000145540}, {33,0.000117371}, {34,0.000046948}, {35,0.000037559}, {36,0.000154930}, {37,0.000084507}, {38,0.000136150}, {39,0.000061033}, {40,0.000131455}, {41,0.000079812}, {42,0.000107981}, {43,0.000103286}, {44,0.000018779}, {45,0.000117371}, {46,0.000089202}, {47,0.000131455}, {48,0.000117371}, {49,0.000126761}, {50,0.000140845}, {51,0.000126761}, {52,0.000192488}, {53,0.000169014}, {54,0.000154930}, {55,0.000098592}, {56,0.000065728}, {57,0.000107981}, {58,0.000131455}, {59,0.000145540}, {60,0.000140845}, {61,0.000150235}, {62,0.000262911}, {63,0.000314554}, {64,0.000314554}, {65,0.000295775}, {66,0.000272300}, {67,0.000230047}, {68,0.000178404}, {69,0.000112676}, {70,0.000075117}, {71,0.000169014}, {72,0.000206573}, {73,0.000187793}, {74,0.000206573}, {75,0.000169014}, {76,0.000206573}, {77,0.000225352}, {78,0.000206573}, {79,0.000262911}, {80,0.000244131}, {81,0.000244131}, {82,0.000262911}, {83,0.000187793}, {84,0.000169014}, {85,0.000300469}, {86,0.000150235}, {87,0.000300469}, {88,0.000112676}, {89,0.000262911}, {90,0.000258216}, {91,0.000352113}, {92,0.000225352}, {93,0.000262911}, {94,0.000150235}, {95,0.000309859}, {96,0.000140845}, {97,0.000375587}, {98,0.000197183}, {99,0.000230047}, {100,0.000220657}, {101,0.000211268}, {102,0.000225352}, {103,0.000267606}, {104,0.000352113}, {105,0.000258216}, {106,0.000206573}, {107,0.000244131}, {108,0.000300469}, {109,0.000314554}, {110,0.000183099}, {111,0.000206573}, {112,0.000319249}, {113,0.000225352}, {114,0.000169014}, {115,0.000394366}, {116,0.000356808}, {117,0.000206573}, {118,0.000225352}, {119,0.000187793}, {120,0.000319249}, {121,0.000244131}, {122,0.000131455}, {123,0.000244131}, {124,0.000403756}, {125,0.000225352}, {126,0.000183099}, {127,0.000234742}, {128,0.000253521}, {129,0.000309859}, {130,0.000211268}, {131,0.000244131}, {132,0.000305164}, {133,0.000215962}, {134,0.000389671}, {135,0.000230047}, {136,0.000183099}, {137,0.000169014}, {138,0.000314554}, {139,0.000328638}, {140,0.000347418}, {141,0.000535211}, {142,0.000427230}, {143,0.000300469}, {144,0.000399061}, {145,0.000295775}, {146,0.000323944}, {147,0.000267606}, {148,0.000159624}, {149,0.000291080}, {150,0.000291080}, {151,0.000338028}, {152,0.000305164}, {153,0.000234742}, {154,0.000305164}, {155,0.000380282}, {156,0.000399061}, {157,0.000272300}, {158,0.000478873}, {159,0.000408451}, {160,0.000262911}, {161,0.000328638}, {162,0.000323944}, {163,0.000323944}, {164,0.000370892}, {165,0.000234742}, {166,0.000230047}, {167,0.000201878}, {168,0.000295775}, {169,0.000319249}, {170,0.000314554}, {171,0.000300469}, {172,0.000380282}, {173,0.000375587}, {174,0.000319249}, {175,0.000370892}, {176,0.000384977}, {177,0.000356808}, {178,0.000323944}, {179,0.000328638}, {180,0.000244131}, {181,0.000234742}, {182,0.000286385}, {183,0.000267606}, {184,0.000586854}, {185,0.000323944}, {186,0.000333333}, {187,0.000380282}, {188,0.000356808}, {189,0.000323944}, {190,0.000403756}, {191,0.000511737}, {192,0.000460094}, {193,0.000474178}, {194,0.000356808}, {195,0.000478873}, {196,0.000309859}, {197,0.000995305}, {198,0.000370892}, {199,0.000530516}, {200,0.000478873}, {201,0.000530516}, {202,0.000384977}, {203,0.000328638}, {204,0.000464789}, {205,0.000333333}, {206,0.000483568}, {207,0.000375587}, {208,0.000460094}, {209,0.000450704}, {210,0.000366197}, {211,0.000436620}, {212,0.000394366}, {213,0.000342723}, {214,0.000291080}, {215,0.000525822}, {216,0.000380282}, {217,0.000450704}, {218,0.000380282}, {219,0.000422535}, {220,0.000342723}, {221,0.000488263}, {222,0.000525822}, {223,0.000474178}, {224,0.000436620}, {225,0.000417840}, {226,0.000305164}, {227,0.000577465}, {228,0.000370892}, {229,0.000619718}, {230,0.000244131}, {231,0.000488263}, {232,0.000478873}, {233,0.000441315}, {234,0.000516432}, {235,0.000370892}, {236,0.000319249}, {237,0.000417840}, {238,0.000408451}, {239,0.000549296}, {240,0.000553991}, {241,0.000492958}, {242,0.000422535}, {243,0.000361502}, {244,0.000342723}, {245,0.000483568}, {246,0.000629108}, {247,0.000643192}, {248,0.000699531}, {249,0.000596244}, {250,0.000525822}, {251,0.000460094}, {252,0.000497653}, {253,0.000661972}, {254,0.000563380}, {255,0.000563380}, {256,0.000521127}, {257,0.000342723}, {258,0.000516432}, {259,0.000661972}, {260,0.000544601}, {261,0.000333333}, {262,0.000342723}, {263,0.000408451}, {264,0.000427230}, {265,0.000600939}, {266,0.000492958}, {267,0.000488263}, {268,0.000502347}, {269,0.000399061}, {270,0.000558685}, {271,0.000431925}, {272,0.000305164}, {273,0.000464789}, {274,0.000507042}, {275,0.000295775}, {276,0.000375587}, {277,0.000281690}, {278,0.000375587}, {279,0.000553991}, {280,0.000403756}, {281,0.000356808}, {282,0.000446009}, {283,0.000478873}, {284,0.000572770}, {285,0.000417840}, {286,0.000436620}, {287,0.000422535}, {288,0.000563380}, {289,0.000455399}, {290,0.000511737}, {291,0.000389671}, {292,0.000605634}, {293,0.000638498}, {294,0.000399061}, {295,0.000436620}, {296,0.000657277}, {297,0.000685446}, {298,0.000615023}, {299,0.000370892}, {300,0.000657277}, {301,0.000530516}, {302,0.000516432}, {303,0.000478873}, {304,0.000408451}, {305,0.000502347}, {306,0.000464789}, {307,0.000417840}, {308,0.000563380}, {309,0.000586854}, {310,0.000568075}, {311,0.000685446}, {312,0.000521127}, {313,0.000694836}, {314,0.000460094}, {315,0.000596244}, {316,0.000647887}, {317,0.000591549}, {318,0.000596244}, {319,0.000464789}, {320,0.000690141}, {321,0.000525822}, {322,0.000455399}, {323,0.000558685}, {324,0.000474178}, {325,0.000558685}, {326,0.000469484}, {327,0.000615023}, {328,0.000615023}, {329,0.000535211}, {330,0.000596244}, {331,0.000708920}, {332,0.000572770}, {333,0.000431925}, {334,0.000507042}, {335,0.000586854}, {336,0.000521127}, {337,0.000652582}, {338,0.000873239}, {339,0.000469484}, {340,0.000446009}, {341,0.000577465}, {342,0.000680751}, {343,0.000694836}, {344,0.000417840}, {345,0.000502347}, {346,0.000676056}, {347,0.000676056}, {348,0.000450704}, {349,0.000615023}, {350,0.000694836}, {351,0.000685446}, {352,0.000793427}, {353,0.000488263}, {354,0.000652582}, {355,0.000553991}, {356,0.000671362}, {357,0.000539906}, {358,0.000516432}, {359,0.000521127}, {360,0.000732394}, {361,0.000619718}, {362,0.000624413}, {363,0.000610329}, {364,0.000624413}, {365,0.000600939}, {366,0.000488263}, {367,0.000638498}, {368,0.000652582}, {369,0.000507042}, {370,0.001234742}, {371,0.000657277}, {372,0.000657277}, {373,0.000507042}, {374,0.000704225}, {375,0.000661972}, {376,0.000737089}, {377,0.000643192}, {378,0.000769953}, {379,0.000751174}, {380,0.000694836}, {381,0.000896714}, {382,0.000868545}, {383,0.000671362}, {384,0.000676056}, {385,0.000694836}, {386,0.000615023}, {387,0.000746479}, {388,0.000647887}, {389,0.000929577}, {390,0.000647887}, {391,0.000643192}, {392,0.000718310}, {393,0.000863850}, {394,0.000741784}, {395,0.000671362}, {396,0.000835681}, {397,0.000746479}, {398,0.000708920}, {399,0.000793427}, {400,0.000788732}, {401,0.000643192}, {402,0.000835681}, {403,0.000633803}, {404,0.000751174}, {405,0.000798122}, {406,0.000835681}, {407,0.000784038}, {408,0.000826291}, {409,0.000938967}, {410,0.000816901}, {411,0.000812207}, {412,0.000483568}, {413,0.000835681}, {414,0.000633803}, {415,0.000769953}, {416,0.000793427}, {417,0.002774648}, {418,0.000704225}, {419,0.000924883}, {420,0.000568075}, {421,0.000882629}, {422,0.000882629}, {423,0.000741784}, {424,0.000859155}, {425,0.000802817}, {426,0.000915493}, {427,0.000816901}, {428,0.000699531}, {429,0.001126761}, {430,0.000737089}, {431,0.000816901}, {432,0.001004695}, {433,0.000774648}, {434,0.000793427}, {435,0.001014085}, {436,0.000807512}, {437,0.000873239}, {438,0.001126761}, {439,0.000685446}, {440,0.000990610}, {441,0.000741784}, {442,0.000802817}, {443,0.000873239}, {444,0.000882629}, {445,0.000765258}, {446,0.000892019}, {447,0.000732394}, {448,0.001042254}, {449,0.000976526}, {450,0.000892019}, {451,0.001004695}, {452,0.000802817}, {453,0.000892019}, {454,0.000793427}, {455,0.000901408}, {456,0.000849765}, {457,0.000882629}, {458,0.001004695}, {459,0.000957746}, {460,0.000924883}, {461,0.000755869}, {462,0.000859155}, {463,0.000723005}, {464,0.000812207}, {465,0.000863850}, {466,0.000704225}, {467,0.000788732}, {468,0.001197183}, {469,0.000835681}, {470,0.000845070}, {471,0.000732394}, {472,0.000774648}, {473,0.000854460}, {474,0.001070423}, {475,0.000901408}, {476,0.001000000}, {477,0.000971831}, {478,0.000765258}, {479,0.001131455}, {480,0.001037559}, {481,0.001136150}, {482,0.000953052}, {483,0.000943662}, {484,0.000873239}, {485,0.001000000}, {486,0.001032864}, {487,0.000985915}, {488,0.000821596}, {489,0.000859155}, {490,0.000741784}, {491,0.001117371}, {492,0.000990610}, {493,0.001018779}, {494,0.000915493}, {495,0.000798122}, {496,0.001122066}, {497,0.000798122}, {498,0.000896714}, {499,0.001014085}, {500,0.000924883}, {505,0.001117371}, {510,0.000901408}, {515,0.000967136}, {520,0.000784038}, {525,0.000948357}, {530,0.001028169}, {535,0.000887324}, {540,0.000957746}, {545,0.001206573}, {550,0.001042254}, {555,0.001206573}, {560,0.001117371}, {565,0.000948357}, {570,0.001037559}, {575,0.001046948}, {580,0.001070423}, {585,0.001089202}, {590,0.001098592}, {595,0.001089202}, {600,0.001004695}, {605,0.001220657}, {610,0.001136150}, {615,0.001159624}, {620,0.001112676}, {625,0.001028169}, {630,0.001347418}, {635,0.001032864}, {640,0.001112676}, {645,0.001164319}, {650,0.001037559}, {655,0.001215962}, {660,0.001122066}, {665,0.001065728}, {670,0.001103286}, {675,0.001276995}, {680,0.001098592}, {685,0.001253521}, {690,0.001403756}, {695,0.001037559}, {700,0.001347418}, {705,0.001455399}, {710,0.001389671}, {715,0.002666667}, {720,0.001441315}, {725,0.001431925}, {730,0.001422535}, {735,0.001281690}, {740,0.001347418}, {745,0.001436620}, {750,0.001347418}, {755,0.001422535}, {760,0.001441315}, {765,0.001206573}, {770,0.003563380}, {775,0.001281690}, {780,0.001389671}, {785,0.001422535}, {790,0.001455399}, {795,0.001502347}, {800,0.001126761}, {805,0.001314554}, {810,0.001539906}, {815,0.001741784}, {820,0.001572770}, {825,0.001507042}, {830,0.001676056}, {835,0.001356808}, {840,0.001422535}, {845,0.001413146}, {850,0.001422535}, {855,0.001568075}, {860,0.001596244}, {865,0.001713615}, {870,0.004018779}, {875,0.001610329}, {880,0.001427230}, {885,0.001230047}, {890,0.001586854}, {895,0.001629108}, {900,0.001553991}, {905,0.001497653}, {910,0.001605634}, {915,0.001708920}, {920,0.001661972}, {925,0.001591549}, {930,0.001633803}, {935,0.001751174}, {940,0.001741784}, {945,0.001661972}, {950,0.001591549}, {955,0.001553991}, {960,0.001422535}, {965,0.001892019}, {970,0.001671362}, {975,0.001779343}, {980,0.001896714}, {985,0.001680751}, {990,0.001934272}, {995,0.001723005}, {1000,0.001713615}, {1010,0.001647887}, {1020,0.001971831}, {1030,0.001826291}, {1040,0.001840376}, {1050,0.001873239}, {1060,0.001924883}, {1070,0.002107981}, {1080,0.001924883}, {1090,0.005882629}, {1100,0.001943662}, {1110,0.001943662}, {1120,0.002276995}, {1130,0.002169014}, {1140,0.002258216}, {1150,0.002258216}, {1160,0.002136150}, {1170,0.002258216}, {1180,0.002262911}, {1190,0.002131455}, {1200,0.002380282}, {1210,0.002370892}, {1220,0.002361502}, {1230,0.002469484}, {1240,0.002521127}, {1250,0.002544601}, {1260,0.002422535}, {1270,0.002507042}, {1280,0.002469484}, {1290,0.002408451}, {1300,0.002680751}, {1310,0.002516432}, {1320,0.002431925}, {1330,0.002798122}, {1340,0.002521127}, {1350,0.002544601}, {1360,0.002389671}, {1370,0.002746479}, {1380,0.002666667}, {1390,0.002723005}, {1400,0.003107981}, {1410,0.002807512}, {1420,0.002596244}, {1430,0.002802817}, {1440,0.002638498}, {1450,0.002943662}, {1460,0.002943662}, {1470,0.002784038}, {1480,0.002967136}, {1490,0.002976526}, {1500,0.002769953}, {1510,0.002769}, {1520,0.006308}, {1530,0.002769}, {1540,0.003154}, {1550,0.002615}, {1560,0.003000}, {1570,0.003231}, {1580,0.003154}, {1590,0.003615}, {1600,0.006615}, {1610,0.003615}, {1620,0.003000}, {1630,0.003462}, {1640,0.003077}, {1650,0.008231}, {1660,0.003231}, {1670,0.002769}, {1680,0.003692}, {1690,0.003308}, {1700,0.003692}, {1710,0.003077}, {1720,0.003231}, {1730,0.002769}, {1740,0.003077}, {1750,0.003231}, {1760,0.009154}, {1770,0.003462}, {1780,0.003692}, {1790,0.003385}, {1800,0.003231}, {1810,0.003231}, {1820,0.003154}, {1830,0.003615}, {1840,0.003308}, {1850,0.003154}, {1860,0.003077}, {1870,0.003308}, {1880,0.002923}, {1890,0.003231}, {1900,0.003154}, {1910,0.003385}, {1920,0.003385}, {1930,0.003769}, {1940,0.004154}, {1950,0.003923}, {1960,0.004231}, {1970,0.009923}, {1980,0.004077}, {1990,0.003615}, {2000,0.004385}, {2050,0.004077}, {2100,0.004077}, {2150,0.008385}, {2200,0.004462}, {2250,0.004308}, {2300,0.004231}, {2350,0.005385}, {2400,0.003769}, {2450,0.004308}, {2500,0.003769}, {2550,0.004769}, {2600,0.005154}, {2650,0.006077}, {2700,0.004538}, {2750,0.005462}, {2800,0.005692}, {2850,0.005385}, {2900,0.005846}, {2950,0.006231}, {3000,0.005615}, {3050,0.005000}, {3100,0.006462}, {3150,0.006077}, {3200,0.006462}, {3250,0.006385}, {3300,0.006308}, {3350,0.006077}, {3400,0.007000}, {3450,0.007231}, {3500,0.007692}, {3550,0.007000}, {3600,0.007692}, {3650,0.007615}, {3700,0.016692}, {3750,0.007769}, {3800,0.019692}, {3850,0.008308}, {3900,0.020615}, {3950,0.008308}, {4000,0.008231}, {4050,0.024462}, {4100,0.009077}, {4150,0.018846}, {4200,0.008154}, {4250,0.008462}, {4300,0.008462}, {4350,0.009077}, {4400,0.029308}, {4450,0.009231}, {4500,0.009000}, {4550,0.010615}, {4600,0.009077}, {4650,0.009462}, {4700,0.010154}, {4750,0.027077}, {4800,0.010231}, {4850,0.021615}, {4900,0.011385}, {4950,0.019769}, {5000,0.023615}, {5050,0.010615}, {5100,0.025538}, {5150,0.012000}, {5200,0.011615}, {5250,0.011385}, {5300,0.011615}, {5350,0.012231}, {5400,0.011923}, {5450,0.012154}, {5500,0.012000}, {5550,0.012308}, {5600,0.011846}, {5650,0.011538}, {5700,0.027231}, {5750,0.012231}, {5800,0.012077}, {5850,0.012000}, {5900,0.012615}, {5950,0.013462}, {6000,0.024231}, {6050,0.013462}, {6100,0.028000}, {6150,0.012846}, {6200,0.013154}, {6250,0.013154}, {6300,0.014308}, {6350,0.013154}, {6400,0.020231}, {6450,0.014231}, {6500,0.026308}, {6550,0.024000}, {6600,0.013231}, {6650,0.013846}, {6700,0.014077}, {6750,0.014462}, {6800,0.023154}, {6850,0.014923}, {6900,0.029000}, {6950,0.015077}, {7000,0.015769}, {7050,0.025231}, {7100,0.015692}, {7150,0.015769}, {7200,0.015846}, {7250,0.034154}, {7300,0.015769}, {7350,0.016769}, {7400,0.029385}, {7450,0.017538}, {7500,0.016692}, {7550,0.017077}, {7600,0.029692}, {7650,0.033923}, {7700,0.037385}, {7750,0.033615}, {7800,0.017385}, {7850,0.017154}, {7900,0.016769}, {7950,0.017077}, {8000,0.017231}, {8050,0.018308}, {8100,0.017846}, {8150,0.017846}, {8200,0.017692}, {8250,0.037692}, {8300,0.018385}, {8350,0.037615}, {8400,0.034000}, {8450,0.019000}, {8500,0.018308}, {8550,0.034308}, {8600,0.043846}, {8650,0.019462}, {8700,0.019231}, {8750,0.037462}, {8800,0.033308}, {8850,0.036615}, {8900,0.019385}, {8950,0.020462}, {9000,0.020000}, {9050,0.043385}, {9100,0.020462}, {9150,0.020615}, {9200,0.019308}, {9250,0.044000}, {9300,0.021308}, {9350,0.031538}, {9400,0.020077}, {9450,0.041308}, {9500,0.021538}, {9550,0.020538}, {9600,0.037462}, {9650,0.021308}, {9700,0.022154}, {9750,0.022615}, {9800,0.047923}, {9850,0.044385}, {9900,0.036308}, {9950,0.050769}, {10000,0.022615}};
data["big_flat"]["Mtac2"]["cbv"]["system"] = {{1,0.000056338}, {2,0.000018779}, {3,0.000000000}, {4,0.000000000}, {5,0.000018779}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000018779}, {44,0.000018779}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000018779}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000018779}, {60,0.000000000}, {61,0.000014085}, {62,0.000000000}, {63,0.000000000}, {64,0.000018779}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000014085}, {70,0.000018779}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000014085}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000018779}, {89,0.000000000}, {90,0.000018779}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000037559}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000014085}, {110,0.000018779}, {111,0.000000000}, {112,0.000032864}, {113,0.000000000}, {114,0.000018779}, {115,0.000018779}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000018779}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000014085}, {129,0.000018779}, {130,0.000000000}, {131,0.000014085}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000018779}, {137,0.000000000}, {138,0.000000000}, {139,0.000014085}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000014085}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000018779}, {148,0.000018779}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000014085}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000032864}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000018779}, {171,0.000000000}, {172,0.000018779}, {173,0.000014085}, {174,0.000000000}, {175,0.000018779}, {176,0.000018779}, {177,0.000000000}, {178,0.000018779}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000014085}, {183,0.000000000}, {184,0.000000000}, {185,0.000014085}, {186,0.000018779}, {187,0.000014085}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000037559}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000018779}, {196,0.000000000}, {197,0.000000000}, {198,0.000018779}, {199,0.000000000}, {200,0.000032864}, {201,0.000018779}, {202,0.000000000}, {203,0.000018779}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000018779}, {208,0.000018779}, {209,0.000000000}, {210,0.000018779}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000014085}, {215,0.000037559}, {216,0.000000000}, {217,0.000000000}, {218,0.000014085}, {219,0.000000000}, {220,0.000014085}, {221,0.000000000}, {222,0.000014085}, {223,0.000000000}, {224,0.000018779}, {225,0.000018779}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000018779}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000070423}, {236,0.000018779}, {237,0.000018779}, {238,0.000018779}, {239,0.000018779}, {240,0.000018779}, {241,0.000037559}, {242,0.000000000}, {243,0.000018779}, {244,0.000014085}, {245,0.000018779}, {246,0.000000000}, {247,0.000000000}, {248,0.000018779}, {249,0.000018779}, {250,0.000000000}, {251,0.000018779}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000032864}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000018779}, {269,0.000000000}, {270,0.000000000}, {271,0.000037559}, {272,0.000018779}, {273,0.000014085}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000018779}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000037559}, {286,0.000000000}, {287,0.000014085}, {288,0.000037559}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000018779}, {296,0.000000000}, {297,0.000014085}, {298,0.000000000}, {299,0.000000000}, {300,0.000046948}, {301,0.000018779}, {302,0.000000000}, {303,0.000000000}, {304,0.000018779}, {305,0.000018779}, {306,0.000000000}, {307,0.000018779}, {308,0.000018779}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000018779}, {313,0.000037559}, {314,0.000018779}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000018779}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000018779}, {330,0.000018779}, {331,0.000000000}, {332,0.000014085}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000018779}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000018779}, {343,0.000000000}, {344,0.000000000}, {345,0.000018779}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000018779}, {355,0.000014085}, {356,0.000000000}, {357,0.000000000}, {358,0.000018779}, {359,0.000000000}, {360,0.000018779}, {361,0.000018779}, {362,0.000014085}, {363,0.000018779}, {364,0.000000000}, {365,0.000000000}, {366,0.000018779}, {367,0.000000000}, {368,0.000000000}, {369,0.000018779}, {370,0.000000000}, {371,0.000018779}, {372,0.000014085}, {373,0.000018779}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000018779}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000018779}, {384,0.000000000}, {385,0.000000000}, {386,0.000014085}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000018779}, {391,0.000000000}, {392,0.000018779}, {393,0.000018779}, {394,0.000000000}, {395,0.000037559}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000018779}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000018779}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000018779}, {414,0.000018779}, {415,0.000000000}, {416,0.000000000}, {417,0.000018779}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000037559}, {423,0.000000000}, {424,0.000000000}, {425,0.000018779}, {426,0.000018779}, {427,0.000000000}, {428,0.000000000}, {429,0.000018779}, {430,0.000000000}, {431,0.000018779}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000037559}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000018779}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000018779}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000018779}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000018779}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000032864}, {479,0.000000000}, {480,0.000018779}, {481,0.000000000}, {482,0.000018779}, {483,0.000018779}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000014085}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000018779}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000018779}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000018779}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000014085}, {550,0.000000000}, {555,0.000018779}, {560,0.000000000}, {565,0.000000000}, {570,0.000018779}, {575,0.000037559}, {580,0.000000000}, {585,0.000018779}, {590,0.000018779}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000037559}, {620,0.000000000}, {625,0.000018779}, {630,0.000018779}, {635,0.000018779}, {640,0.000018779}, {645,0.000018779}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000032864}, {680,0.000051643}, {685,0.000000000}, {690,0.000000000}, {695,0.000018779}, {700,0.000000000}, {705,0.000000000}, {710,0.000018779}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000018779}, {750,0.000000000}, {755,0.000000000}, {760,0.000014085}, {765,0.000000000}, {770,0.000014085}, {775,0.000018779}, {780,0.000000000}, {785,0.000018779}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000018779}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000018779}, {835,0.000000000}, {840,0.000018779}, {845,0.000000000}, {850,0.000018779}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000018779}, {890,0.000000000}, {895,0.000018779}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000018779}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000018779}, {940,0.000018779}, {945,0.000000000}, {950,0.000000000}, {955,0.000014085}, {960,0.000000000}, {965,0.000000000}, {970,0.000018779}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000018779}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000037559}, {1030,0.000018779}, {1040,0.000000000}, {1050,0.000018779}, {1060,0.000000000}, {1070,0.000018779}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000014085}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000018779}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000018779}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000018779}, {1280,0.000000000}, {1290,0.000018779}, {1300,0.000014085}, {1310,0.000018779}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000018779}, {1360,0.000018779}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000037559}, {1400,0.000000000}, {1410,0.000018779}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000018779}, {1470,0.000000000}, {1480,0.000018779}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000308}, {1520,0.000000}, {1530,0.000000}, {1540,0.000000}, {1550,0.000000}, {1560,0.000000}, {1570,0.000000}, {1580,0.000000}, {1590,0.000000}, {1600,0.000000}, {1610,0.000000}, {1620,0.000000}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000308}, {1680,0.000000}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000000}, {1730,0.000000}, {1740,0.000000}, {1750,0.000000}, {1760,0.000000}, {1770,0.000000}, {1780,0.000000}, {1790,0.000000}, {1800,0.000231}, {1810,0.000000}, {1820,0.000000}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000000}, {1900,0.000000}, {1910,0.000000}, {1920,0.000000}, {1930,0.000000}, {1940,0.000000}, {1950,0.000000}, {1960,0.000000}, {1970,0.000000}, {1980,0.000000}, {1990,0.000000}, {2000,0.000000}, {2050,0.000000}, {2100,0.000000}, {2150,0.000000}, {2200,0.000000}, {2250,0.000000}, {2300,0.000000}, {2350,0.000000}, {2400,0.000000}, {2450,0.000000}, {2500,0.000000}, {2550,0.000000}, {2600,0.000000}, {2650,0.000000}, {2700,0.000000}, {2750,0.000000}, {2800,0.000000}, {2850,0.000000}, {2900,0.000000}, {2950,0.000000}, {3000,0.000000}, {3050,0.000000}, {3100,0.000000}, {3150,0.000000}, {3200,0.000000}, {3250,0.000000}, {3300,0.000000}, {3350,0.000000}, {3400,0.000000}, {3450,0.000000}, {3500,0.000000}, {3550,0.000000}, {3600,0.000000}, {3650,0.000000}, {3700,0.000000}, {3750,0.000000}, {3800,0.000000}, {3850,0.000000}, {3900,0.000000}, {3950,0.000000}, {4000,0.000000}, {4050,0.000000}, {4100,0.000000}, {4150,0.000308}, {4200,0.000000}, {4250,0.000000}, {4300,0.000000}, {4350,0.000000}, {4400,0.000000}, {4450,0.000000}, {4500,0.000000}, {4550,0.000000}, {4600,0.000000}, {4650,0.000000}, {4700,0.000000}, {4750,0.000000}, {4800,0.000000}, {4850,0.000000}, {4900,0.000000}, {4950,0.000000}, {5000,0.000000}, {5050,0.000000}, {5100,0.000000}, {5150,0.000000}, {5200,0.000000}, {5250,0.000000}, {5300,0.000000}, {5350,0.000000}, {5400,0.000000}, {5450,0.000000}, {5500,0.000000}, {5550,0.000000}, {5600,0.000000}, {5650,0.000000}, {5700,0.000000}, {5750,0.000000}, {5800,0.000000}, {5850,0.000000}, {5900,0.000000}, {5950,0.000000}, {6000,0.000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000308}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000538}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000308}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000308}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}};
data["big_flat"]["Mtac2"]["eval lazy"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.001000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000009390}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.002004695}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.001009390}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000004695}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000004695}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000004695}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000004695}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.002596244}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000004695}, {1510,0.000000}, {1520,0.000000}, {1530,0.000000}, {1540,0.000000}, {1550,0.000000}, {1560,0.000000}, {1570,0.000000}, {1580,0.000000}, {1590,0.000000}, {1600,0.000000}, {1610,0.000000}, {1620,0.000077}, {1630,0.000077}, {1640,0.000000}, {1650,0.000077}, {1660,0.000000}, {1670,0.000000}, {1680,0.000000}, {1690,0.000385}, {1700,0.000231}, {1710,0.000308}, {1720,0.000385}, {1730,0.000692}, {1740,0.000923}, {1750,0.000923}, {1760,0.000923}, {1770,0.001000}, {1780,0.000462}, {1790,0.001000}, {1800,0.001000}, {1810,0.001000}, {1820,0.001000}, {1830,0.001000}, {1840,0.001000}, {1850,0.001000}, {1860,0.001000}, {1870,0.001000}, {1880,0.001000}, {1890,0.001000}, {1900,0.001000}, {1910,0.001000}, {1920,0.001000}, {1930,0.001000}, {1940,0.001000}, {1950,0.001000}, {1960,0.001000}, {1970,0.001000}, {1980,0.001000}, {1990,0.001000}, {2000,0.001000}, {2050,0.001000}, {2100,0.001000}, {2150,0.001000}, {2200,0.001000}, {2250,0.001000}, {2300,0.001000}, {2350,0.001000}, {2400,0.001000}, {2450,0.001000}, {2500,0.001000}, {2550,0.001000}, {2600,0.001000}, {2650,0.001000}, {2700,0.001000}, {2750,0.001000}, {2800,0.001000}, {2850,0.001000}, {2900,0.001000}, {2950,0.001000}, {3000,0.001000}, {3050,0.001000}, {3100,0.001000}, {3150,0.001000}, {3200,0.001000}, {3250,0.001000}, {3300,0.001000}, {3350,0.001000}, {3400,0.001000}, {3450,0.001000}, {3500,0.001615}, {3550,0.001692}, {3600,0.001231}, {3650,0.001769}, {3700,0.001846}, {3750,0.002000}, {3800,0.001846}, {3850,0.002000}, {3900,0.002000}, {3950,0.002000}, {4000,0.002000}, {4050,0.002000}, {4100,0.002000}, {4150,0.002000}, {4200,0.002000}, {4250,0.002000}, {4300,0.002000}, {4350,0.002000}, {4400,0.002000}, {4450,0.002000}, {4500,0.002000}, {4550,0.002077}, {4600,0.002000}, {4650,0.002000}, {4700,0.002000}, {4750,0.002000}, {4800,0.002000}, {4850,0.002000}, {4900,0.002077}, {4950,0.002231}, {5000,0.002000}, {5050,0.002308}, {5100,0.002000}, {5150,0.002308}, {5200,0.002308}, {5250,0.002538}, {5300,0.002769}, {5350,0.002846}, {5400,0.002231}, {5450,0.002846}, {5500,0.002462}, {5550,0.003000}, {5600,0.015154}, {5650,0.002846}, {5700,0.003077}, {5750,0.002846}, {5800,0.003077}, {5850,0.003000}, {5900,0.003000}, {5950,0.003000}, {6000,0.003000}, {6050,0.003000}, {6100,0.003308}, {6150,0.003000}, {6200,0.003000}, {6250,0.003000}, {6300,0.003154}, {6350,0.003000}, {6400,0.003308}, {6450,0.003000}, {6500,0.003000}, {6550,0.003462}, {6600,0.003385}, {6650,0.003308}, {6700,0.003385}, {6750,0.003000}, {6800,0.003000}, {6850,0.003308}, {6900,0.003231}, {6950,0.003077}, {7000,0.003231}, {7050,0.004154}, {7100,0.004077}, {7150,0.003308}, {7200,0.003308}, {7250,0.004154}, {7300,0.003769}, {7350,0.003769}, {7400,0.003923}, {7450,0.004000}, {7500,0.004000}, {7550,0.004000}, {7600,0.004000}, {7650,0.004000}, {7700,0.004000}, {7750,0.004000}, {7800,0.004000}, {7850,0.004231}, {7900,0.004000}, {7950,0.028000}, {8000,0.004615}, {8050,0.028769}, {8100,0.004000}, {8150,0.027154}, {8200,0.004231}, {8250,0.004000}, {8300,0.004000}, {8350,0.004231}, {8400,0.005231}, {8450,0.005308}, {8500,0.004231}, {8550,0.005000}, {8600,0.004308}, {8650,0.004308}, {8700,0.028923}, {8750,0.004385}, {8800,0.030000}, {8850,0.004308}, {8900,0.004308}, {8950,0.004538}, {9000,0.005615}, {9050,0.005077}, {9100,0.005000}, {9150,0.005000}, {9200,0.005769}, {9250,0.004923}, {9300,0.005000}, {9350,0.004846}, {9400,0.006077}, {9450,0.005154}, {9500,0.004923}, {9550,0.006462}, {9600,0.005154}, {9650,0.006308}, {9700,0.005308}, {9750,0.028846}, {9800,0.006385}, {9850,0.006615}, {9900,0.020538}, {9950,0.005308}, {10000,0.005308}};
data["big_flat"]["Mtac2"]["eval lazy"]["user"] = {{1,0.000018779}, {2,0.000037559}, {3,0.000000000}, {4,0.000075117}, {5,0.000037559}, {6,0.000056338}, {7,0.000037559}, {8,0.000018779}, {9,0.000018779}, {10,0.000037559}, {11,0.000037559}, {12,0.000018779}, {13,0.000056338}, {14,0.000018779}, {15,0.000018779}, {16,0.000070423}, {17,0.000018779}, {18,0.000000000}, {19,0.000018779}, {20,0.000018779}, {21,0.000018779}, {22,0.000018779}, {23,0.000018779}, {24,0.000075117}, {25,0.000122066}, {26,0.000000000}, {27,0.000018779}, {28,0.000070423}, {29,0.000037559}, {30,0.000032864}, {31,0.000093897}, {32,0.000051643}, {33,0.000037559}, {34,0.000089202}, {35,0.000051643}, {36,0.000032864}, {37,0.000042254}, {38,0.000046948}, {39,0.000046948}, {40,0.000056338}, {41,0.000051643}, {42,0.000014085}, {43,0.000032864}, {44,0.000065728}, {45,0.000028169}, {46,0.000098592}, {47,0.000051643}, {48,0.000046948}, {49,0.000084507}, {50,0.000117371}, {51,0.000098592}, {52,0.000084507}, {53,0.000089202}, {54,0.000032864}, {55,0.000018779}, {56,0.000093897}, {57,0.000056338}, {58,0.000018779}, {59,0.000032864}, {60,0.000056338}, {61,0.000037559}, {62,0.000037559}, {63,0.000018779}, {64,0.000112676}, {65,0.000093897}, {66,0.000056338}, {67,0.000131455}, {68,0.000075117}, {69,0.000075117}, {70,0.000169014}, {71,0.000093897}, {72,0.000093897}, {73,0.000112676}, {74,0.000075117}, {75,0.000075117}, {76,0.000131455}, {77,0.000187793}, {78,0.000056338}, {79,0.000093897}, {80,0.000075117}, {81,0.000056338}, {82,0.000075117}, {83,0.000075117}, {84,0.000075117}, {85,0.000056338}, {86,0.000112676}, {87,0.000112676}, {88,0.000037559}, {89,0.000075117}, {90,0.000093897}, {91,0.000093897}, {92,0.000150235}, {93,0.000150235}, {94,0.000122066}, {95,0.000112676}, {96,0.000159624}, {97,0.000178404}, {98,0.000117371}, {99,0.000079812}, {100,0.000065728}, {101,0.000183099}, {102,0.000126761}, {103,0.000070423}, {104,0.000037559}, {105,0.000131455}, {106,0.000056338}, {107,0.000056338}, {108,0.000093897}, {109,0.000112676}, {110,0.000075117}, {111,0.000112676}, {112,0.000169014}, {113,0.000112676}, {114,0.000187793}, {115,0.000093897}, {116,0.000150235}, {117,0.000169014}, {118,0.000093897}, {119,0.000131455}, {120,0.000093897}, {121,0.000150235}, {122,0.000150235}, {123,0.000112676}, {124,0.000164319}, {125,0.000089202}, {126,0.000145540}, {127,0.000164319}, {128,0.000107981}, {129,0.000098592}, {130,0.000145540}, {131,0.000122066}, {132,0.000159624}, {133,0.000136150}, {134,0.000126761}, {135,0.000070423}, {136,0.000075117}, {137,0.000201878}, {138,0.000075117}, {139,0.000150235}, {140,0.000056338}, {141,0.000070423}, {142,0.000075117}, {143,0.000173709}, {144,0.000065728}, {145,0.000061033}, {146,0.000037559}, {147,0.000103286}, {148,0.000093897}, {149,0.000178404}, {150,0.000112676}, {151,0.000183099}, {152,0.000037559}, {153,0.000089202}, {154,0.000206573}, {155,0.000098592}, {156,0.000084507}, {157,0.000079812}, {158,0.000098592}, {159,0.000154930}, {160,0.000084507}, {161,0.000107981}, {162,0.000046948}, {163,0.000136150}, {164,0.000112676}, {165,0.000253521}, {166,0.000206573}, {167,0.000061033}, {168,0.000107981}, {169,0.000169014}, {170,0.000122066}, {171,0.000117371}, {172,0.000150235}, {173,0.000159624}, {174,0.000211268}, {175,0.000098592}, {176,0.000098592}, {177,0.000103286}, {178,0.000107981}, {179,0.000117371}, {180,0.000107981}, {181,0.000112676}, {182,0.000136150}, {183,0.000140845}, {184,0.000169014}, {185,0.000103286}, {186,0.000126761}, {187,0.000140845}, {188,0.000131455}, {189,0.000169014}, {190,0.000136150}, {191,0.000028169}, {192,0.000136150}, {193,0.000183099}, {194,0.000140845}, {195,0.000159624}, {196,0.000126761}, {197,0.000154930}, {198,0.000150235}, {199,0.000131455}, {200,0.000065728}, {201,0.000126761}, {202,0.000126761}, {203,0.000098592}, {204,0.001028169}, {205,0.000093897}, {206,0.000164319}, {207,0.000103286}, {208,0.000276995}, {209,0.000145540}, {210,0.000197183}, {211,0.000150235}, {212,0.000187793}, {213,0.000150235}, {214,0.000178404}, {215,0.000244131}, {216,0.000089202}, {217,0.000122066}, {218,0.000154930}, {219,0.000178404}, {220,0.000136150}, {221,0.000103286}, {222,0.000126761}, {223,0.000126761}, {224,0.000244131}, {225,0.000164319}, {226,0.000136150}, {227,0.000211268}, {228,0.000140845}, {229,0.000140845}, {230,0.000098592}, {231,0.000084507}, {232,0.000230047}, {233,0.000211268}, {234,0.000065728}, {235,0.000079812}, {236,0.000136150}, {237,0.000164319}, {238,0.000136150}, {239,0.000093897}, {240,0.000103286}, {241,0.000234742}, {242,0.000131455}, {243,0.000126761}, {244,0.000173709}, {245,0.000164319}, {246,0.000126761}, {247,0.000145540}, {248,0.000131455}, {249,0.000112676}, {250,0.000197183}, {251,0.000225352}, {252,0.000220657}, {253,0.000197183}, {254,0.000225352}, {255,0.000178404}, {256,0.000131455}, {257,0.000164319}, {258,0.000150235}, {259,0.000126761}, {260,0.000248826}, {261,0.000192488}, {262,0.000197183}, {263,0.000267606}, {264,0.000164319}, {265,0.000215962}, {266,0.000145540}, {267,0.000187793}, {268,0.000183099}, {269,0.000098592}, {270,0.000286385}, {271,0.000150235}, {272,0.000112676}, {273,0.000136150}, {274,0.000169014}, {275,0.000122066}, {276,0.000145540}, {277,0.000244131}, {278,0.000234742}, {279,0.000211268}, {280,0.000159624}, {281,0.000220657}, {282,0.000201878}, {283,0.000164319}, {284,0.000201878}, {285,0.000239437}, {286,0.000140845}, {287,0.000122066}, {288,0.000150235}, {289,0.000173709}, {290,0.000107981}, {291,0.000117371}, {292,0.000145540}, {293,0.000192488}, {294,0.000192488}, {295,0.000234742}, {296,0.000164319}, {297,0.000140845}, {298,0.000169014}, {299,0.000183099}, {300,0.000126761}, {301,0.000281690}, {302,0.000169014}, {303,0.000201878}, {304,0.000281690}, {305,0.000197183}, {306,0.000201878}, {307,0.000084507}, {308,0.000178404}, {309,0.000169014}, {310,0.000117371}, {311,0.000239437}, {312,0.000112676}, {313,0.000272300}, {314,0.000169014}, {315,0.000206573}, {316,0.000169014}, {317,0.000342723}, {318,0.000178404}, {319,0.000206573}, {320,0.000187793}, {321,0.000117371}, {322,0.000225352}, {323,0.000136150}, {324,0.000173709}, {325,0.000164319}, {326,0.000276995}, {327,0.000262911}, {328,0.000164319}, {329,0.000225352}, {330,0.000248826}, {331,0.000211268}, {332,0.000117371}, {333,0.000169014}, {334,0.000267606}, {335,0.000164319}, {336,0.000215962}, {337,0.000286385}, {338,0.000122066}, {339,0.000183099}, {340,0.000136150}, {341,0.000262911}, {342,0.000187793}, {343,0.000140845}, {344,0.000187793}, {345,0.000122066}, {346,0.000154930}, {347,0.000122066}, {348,0.000211268}, {349,0.000164319}, {350,0.000215962}, {351,0.000211268}, {352,0.000140845}, {353,0.000248826}, {354,0.000201878}, {355,0.000173709}, {356,0.000150235}, {357,0.000183099}, {358,0.000206573}, {359,0.000230047}, {360,0.000201878}, {361,0.000192488}, {362,0.000220657}, {363,0.000159624}, {364,0.000187793}, {365,0.000159624}, {366,0.000206573}, {367,0.000150235}, {368,0.000183099}, {369,0.000300469}, {370,0.000192488}, {371,0.000206573}, {372,0.000140845}, {373,0.000136150}, {374,0.000154930}, {375,0.000239437}, {376,0.000215962}, {377,0.000286385}, {378,0.000295775}, {379,0.000183099}, {380,0.000384977}, {381,0.000230047}, {382,0.000206573}, {383,0.000164319}, {384,0.000178404}, {385,0.000192488}, {386,0.000225352}, {387,0.000300469}, {388,0.000197183}, {389,0.000140845}, {390,0.000262911}, {391,0.000319249}, {392,0.000323944}, {393,0.000258216}, {394,0.000234742}, {395,0.000239437}, {396,0.000192488}, {397,0.000244131}, {398,0.000258216}, {399,0.000239437}, {400,0.000309859}, {401,0.000178404}, {402,0.000173709}, {403,0.000248826}, {404,0.000276995}, {405,0.000206573}, {406,0.000366197}, {407,0.000169014}, {408,0.000272300}, {409,0.000215962}, {410,0.000319249}, {411,0.000244131}, {412,0.000347418}, {413,0.000338028}, {414,0.000234742}, {415,0.000225352}, {416,0.000197183}, {417,0.000305164}, {418,0.000169014}, {419,0.000281690}, {420,0.000258216}, {421,0.000366197}, {422,0.000281690}, {423,0.000244131}, {424,0.000258216}, {425,0.000281690}, {426,0.000314554}, {427,0.000309859}, {428,0.000244131}, {429,0.000201878}, {430,0.000281690}, {431,0.000361502}, {432,0.000328638}, {433,0.000159624}, {434,0.000281690}, {435,0.000234742}, {436,0.000272300}, {437,0.000225352}, {438,0.000309859}, {439,0.000267606}, {440,0.000276995}, {441,0.000267606}, {442,0.000206573}, {443,0.000239437}, {444,0.000239437}, {445,0.000211268}, {446,0.000276995}, {447,0.000291080}, {448,0.000192488}, {449,0.000375587}, {450,0.000305164}, {451,0.000267606}, {452,0.000352113}, {453,0.000295775}, {454,0.000215962}, {455,0.000262911}, {456,0.000262911}, {457,0.000408451}, {458,0.000338028}, {459,0.000300469}, {460,0.000436620}, {461,0.000262911}, {462,0.000253521}, {463,0.000276995}, {464,0.000328638}, {465,0.000441315}, {466,0.000197183}, {467,0.000281690}, {468,0.000239437}, {469,0.000295775}, {470,0.000272300}, {471,0.000239437}, {472,0.000333333}, {473,0.000234742}, {474,0.000173709}, {475,0.000319249}, {476,0.000375587}, {477,0.000323944}, {478,0.000122066}, {479,0.000253521}, {480,0.000305164}, {481,0.000291080}, {482,0.000338028}, {483,0.000370892}, {484,0.000732394}, {485,0.000244131}, {486,0.000347418}, {487,0.000427230}, {488,0.000267606}, {489,0.000248826}, {490,0.000262911}, {491,0.000427230}, {492,0.000305164}, {493,0.000234742}, {494,0.000272300}, {495,0.000272300}, {496,0.000333333}, {497,0.000314554}, {498,0.000276995}, {499,0.000192488}, {500,0.000309859}, {505,0.000422535}, {510,0.000244131}, {515,0.000413146}, {520,0.000389671}, {525,0.000215962}, {530,0.000408451}, {535,0.000305164}, {540,0.000422535}, {545,0.000342723}, {550,0.000234742}, {555,0.000192488}, {560,0.000366197}, {565,0.000276995}, {570,0.000239437}, {575,0.000338028}, {580,0.000431925}, {585,0.000314554}, {590,0.000281690}, {595,0.000394366}, {600,0.000225352}, {605,0.000338028}, {610,0.000469484}, {615,0.000267606}, {620,0.000431925}, {625,0.000258216}, {630,0.000361502}, {635,0.000347418}, {640,0.000291080}, {645,0.000305164}, {650,0.000347418}, {655,0.000375587}, {660,0.000286385}, {665,0.000309859}, {670,0.000342723}, {675,0.000347418}, {680,0.000483568}, {685,0.000352113}, {690,0.000366197}, {695,0.000352113}, {700,0.000309859}, {705,0.000408451}, {710,0.000258216}, {715,0.000394366}, {720,0.000389671}, {725,0.000342723}, {730,0.000422535}, {735,0.000417840}, {740,0.000525822}, {745,0.000431925}, {750,0.000272300}, {755,0.000446009}, {760,0.000262911}, {765,0.000347418}, {770,0.000361502}, {775,0.000431925}, {780,0.000352113}, {785,0.000502347}, {790,0.000361502}, {795,0.000380282}, {800,0.000375587}, {805,0.000502347}, {810,0.000286385}, {815,0.000511737}, {820,0.000356808}, {825,0.000427230}, {830,0.000366197}, {835,0.000375587}, {840,0.000525822}, {845,0.000323944}, {850,0.000436620}, {855,0.000568075}, {860,0.000572770}, {865,0.000413146}, {870,0.000572770}, {875,0.000591549}, {880,0.002234742}, {885,0.000492958}, {890,0.000431925}, {895,0.000483568}, {900,0.000319249}, {905,0.000394366}, {910,0.000600939}, {915,0.000366197}, {920,0.000441315}, {925,0.000338028}, {930,0.000488263}, {935,0.000403756}, {940,0.000507042}, {945,0.000488263}, {950,0.000553991}, {955,0.000384977}, {960,0.000417840}, {965,0.000408451}, {970,0.000619718}, {975,0.001403756}, {980,0.000577465}, {985,0.000342723}, {990,0.000535211}, {995,0.000610329}, {1000,0.000544601}, {1010,0.000436620}, {1020,0.000521127}, {1030,0.000413146}, {1040,0.000431925}, {1050,0.000511737}, {1060,0.000436620}, {1070,0.000582160}, {1080,0.000643192}, {1090,0.000586854}, {1100,0.000638498}, {1110,0.000568075}, {1120,0.000671362}, {1130,0.000544601}, {1140,0.000802817}, {1150,0.000586854}, {1160,0.000619718}, {1170,0.000511737}, {1180,0.000591549}, {1190,0.000765258}, {1200,0.000676056}, {1210,0.000704225}, {1220,0.000657277}, {1230,0.000530516}, {1240,0.000704225}, {1250,0.000647887}, {1260,0.000676056}, {1270,0.000769953}, {1280,0.000802817}, {1290,0.000854460}, {1300,0.000652582}, {1310,0.000619718}, {1320,0.000488263}, {1330,0.000633803}, {1340,0.000779343}, {1350,0.000577465}, {1360,0.000863850}, {1370,0.000699531}, {1380,0.000962441}, {1390,0.000802817}, {1400,0.000816901}, {1410,0.000826291}, {1420,0.000769953}, {1430,0.000859155}, {1440,0.000816901}, {1450,0.000577465}, {1460,0.000610329}, {1470,0.002760563}, {1480,0.000690141}, {1490,0.000948357}, {1500,0.000830986}, {1510,0.000769}, {1520,0.000692}, {1530,0.000231}, {1540,0.000231}, {1550,0.000000}, {1560,0.001462}, {1570,0.001385}, {1580,0.000615}, {1590,0.000615}, {1600,0.000308}, {1610,0.001154}, {1620,0.001308}, {1630,0.000538}, {1640,0.000846}, {1650,0.000615}, {1660,0.000615}, {1670,0.001077}, {1680,0.000923}, {1690,0.001231}, {1700,0.000462}, {1710,0.001231}, {1720,0.000769}, {1730,0.000462}, {1740,0.000769}, {1750,0.001154}, {1760,0.001231}, {1770,0.001538}, {1780,0.001462}, {1790,0.000538}, {1800,0.000692}, {1810,0.000231}, {1820,0.001385}, {1830,0.000692}, {1840,0.000846}, {1850,0.001154}, {1860,0.000769}, {1870,0.000692}, {1880,0.000846}, {1890,0.000231}, {1900,0.000692}, {1910,0.000692}, {1920,0.001077}, {1930,0.000308}, {1940,0.000923}, {1950,0.001692}, {1960,0.001385}, {1970,0.001154}, {1980,0.001154}, {1990,0.001769}, {2000,0.002000}, {2050,0.001769}, {2100,0.001692}, {2150,0.000769}, {2200,0.001154}, {2250,0.001154}, {2300,0.001154}, {2350,0.001077}, {2400,0.001154}, {2450,0.001077}, {2500,0.001308}, {2550,0.002000}, {2600,0.000846}, {2650,0.001462}, {2700,0.001462}, {2750,0.000923}, {2800,0.001692}, {2850,0.001231}, {2900,0.001308}, {2950,0.001615}, {3000,0.001769}, {3050,0.001615}, {3100,0.000692}, {3150,0.001769}, {3200,0.001154}, {3250,0.001000}, {3300,0.000692}, {3350,0.001231}, {3400,0.002385}, {3450,0.002308}, {3500,0.001231}, {3550,0.002000}, {3600,0.001000}, {3650,0.002846}, {3700,0.001308}, {3750,0.002231}, {3800,0.001692}, {3850,0.002000}, {3900,0.001385}, {3950,0.001923}, {4000,0.001462}, {4050,0.001462}, {4100,0.002000}, {4150,0.002000}, {4200,0.002154}, {4250,0.002538}, {4300,0.002385}, {4350,0.002231}, {4400,0.002231}, {4450,0.002231}, {4500,0.003769}, {4550,0.002538}, {4600,0.002462}, {4650,0.002000}, {4700,0.001769}, {4750,0.003308}, {4800,0.002154}, {4850,0.002846}, {4900,0.003385}, {4950,0.002538}, {5000,0.002462}, {5050,0.002154}, {5100,0.002846}, {5150,0.002923}, {5200,0.002615}, {5250,0.002615}, {5300,0.003692}, {5350,0.003385}, {5400,0.001538}, {5450,0.002923}, {5500,0.003000}, {5550,0.003692}, {5600,0.015000}, {5650,0.003000}, {5700,0.003077}, {5750,0.002462}, {5800,0.003154}, {5850,0.003308}, {5900,0.002769}, {5950,0.001846}, {6000,0.002615}, {6050,0.003462}, {6100,0.003615}, {6150,0.002923}, {6200,0.003462}, {6250,0.004000}, {6300,0.003769}, {6350,0.003538}, {6400,0.004154}, {6450,0.003000}, {6500,0.003846}, {6550,0.003538}, {6600,0.003615}, {6650,0.003769}, {6700,0.003846}, {6750,0.002846}, {6800,0.003615}, {6850,0.003538}, {6900,0.004000}, {6950,0.003769}, {7000,0.003538}, {7050,0.004154}, {7100,0.003615}, {7150,0.003385}, {7200,0.003462}, {7250,0.004308}, {7300,0.003462}, {7350,0.003923}, {7400,0.003538}, {7450,0.003231}, {7500,0.003615}, {7550,0.004077}, {7600,0.004000}, {7650,0.003615}, {7700,0.004462}, {7750,0.004000}, {7800,0.003385}, {7850,0.005538}, {7900,0.004077}, {7950,0.028308}, {8000,0.005154}, {8050,0.028462}, {8100,0.004846}, {8150,0.027615}, {8200,0.003923}, {8250,0.003923}, {8300,0.004385}, {8350,0.003923}, {8400,0.004692}, {8450,0.004000}, {8500,0.004615}, {8550,0.006231}, {8600,0.003538}, {8650,0.004769}, {8700,0.028846}, {8750,0.004000}, {8800,0.030385}, {8850,0.003538}, {8900,0.004538}, {8950,0.003462}, {9000,0.005308}, {9050,0.004154}, {9100,0.004846}, {9150,0.005077}, {9200,0.005462}, {9250,0.004231}, {9300,0.003231}, {9350,0.004846}, {9400,0.005231}, {9450,0.005692}, {9500,0.004385}, {9550,0.005769}, {9600,0.004385}, {9650,0.006000}, {9700,0.004385}, {9750,0.029077}, {9800,0.006308}, {9850,0.006231}, {9900,0.019692}, {9950,0.004923}, {10000,0.004462}};
data["big_flat"]["Mtac2"]["eval lazy"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000018779}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000018779}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000014085}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000032864}, {112,0.000000000}, {113,0.000014085}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000018779}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000018779}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000018779}, {176,0.000000000}, {177,0.000018779}, {178,0.000000000}, {179,0.000000000}, {180,0.000018779}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000018779}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000018779}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000018779}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000018779}, {213,0.000000000}, {214,0.000000000}, {215,0.000018779}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000018779}, {223,0.000000000}, {224,0.000018779}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000018779}, {229,0.000018779}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000018779}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000018779}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000018779}, {265,0.000000000}, {266,0.000018779}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000018779}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000018779}, {277,0.000000000}, {278,0.000018779}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000018779}, {285,0.000000000}, {286,0.000037559}, {287,0.000018779}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000014085}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000018779}, {300,0.000000000}, {301,0.000018779}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000018779}, {308,0.000000000}, {309,0.000032864}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000018779}, {317,0.000000000}, {318,0.000000000}, {319,0.000018779}, {320,0.000000000}, {321,0.000018779}, {322,0.000000000}, {323,0.000056338}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000018779}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000037559}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000032864}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000018779}, {354,0.000018779}, {355,0.000000000}, {356,0.000018779}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000014085}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000018779}, {378,0.000000000}, {379,0.000018779}, {380,0.000000000}, {381,0.000014085}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000018779}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000018779}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000018779}, {421,0.000000000}, {422,0.000018779}, {423,0.000000000}, {424,0.000037559}, {425,0.000018779}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000018779}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000018779}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000018779}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000018779}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000018779}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000018779}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000018779}, {590,0.000018779}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000018779}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000018779}, {750,0.000018779}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000014085}, {815,0.000000000}, {820,0.000018779}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000032864}, {885,0.000018779}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000014085}, {915,0.000018779}, {920,0.000018779}, {925,0.000000000}, {930,0.000014085}, {935,0.000000000}, {940,0.000000000}, {945,0.000018779}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000018779}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000018779}, {1070,0.000000000}, {1080,0.000018779}, {1090,0.000000000}, {1100,0.000018779}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000018779}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000018779}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000018779}, {1260,0.000000000}, {1270,0.000018779}, {1280,0.000000000}, {1290,0.000018779}, {1300,0.000018779}, {1310,0.000018779}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000018779}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000018779}, {1430,0.000056338}, {1440,0.000018779}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000018779}, {1490,0.000000000}, {1500,0.000032864}, {1510,0.000000}, {1520,0.000000}, {1530,0.000000}, {1540,0.000000}, {1550,0.000000}, {1560,0.000000}, {1570,0.000000}, {1580,0.000000}, {1590,0.000000}, {1600,0.000000}, {1610,0.000000}, {1620,0.000000}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000000}, {1680,0.000000}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000000}, {1730,0.000000}, {1740,0.000000}, {1750,0.000000}, {1760,0.000000}, {1770,0.000000}, {1780,0.000000}, {1790,0.000000}, {1800,0.000000}, {1810,0.000000}, {1820,0.000000}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000231}, {1900,0.000000}, {1910,0.000308}, {1920,0.000000}, {1930,0.000000}, {1940,0.000000}, {1950,0.000000}, {1960,0.000000}, {1970,0.000000}, {1980,0.000000}, {1990,0.000000}, {2000,0.000000}, {2050,0.000000}, {2100,0.000000}, {2150,0.000000}, {2200,0.000000}, {2250,0.000000}, {2300,0.000000}, {2350,0.000000}, {2400,0.000000}, {2450,0.000000}, {2500,0.000000}, {2550,0.000000}, {2600,0.000000}, {2650,0.000000}, {2700,0.000000}, {2750,0.000000}, {2800,0.000000}, {2850,0.000000}, {2900,0.000000}, {2950,0.000000}, {3000,0.000000}, {3050,0.000000}, {3100,0.000000}, {3150,0.000000}, {3200,0.000000}, {3250,0.000000}, {3300,0.000000}, {3350,0.000000}, {3400,0.000000}, {3450,0.000000}, {3500,0.000000}, {3550,0.000000}, {3600,0.000000}, {3650,0.000000}, {3700,0.000308}, {3750,0.000308}, {3800,0.000000}, {3850,0.000000}, {3900,0.000000}, {3950,0.000000}, {4000,0.000000}, {4050,0.000000}, {4100,0.000000}, {4150,0.000000}, {4200,0.000000}, {4250,0.000000}, {4300,0.000000}, {4350,0.000000}, {4400,0.000000}, {4450,0.000000}, {4500,0.000000}, {4550,0.000000}, {4600,0.000000}, {4650,0.000000}, {4700,0.000000}, {4750,0.000000}, {4800,0.000000}, {4850,0.000000}, {4900,0.000000}, {4950,0.000000}, {5000,0.000000}, {5050,0.000000}, {5100,0.000000}, {5150,0.000000}, {5200,0.000000}, {5250,0.000000}, {5300,0.000000}, {5350,0.000000}, {5400,0.000000}, {5450,0.000000}, {5500,0.000000}, {5550,0.000000}, {5600,0.000000}, {5650,0.000000}, {5700,0.000000}, {5750,0.000000}, {5800,0.000000}, {5850,0.000000}, {5900,0.000000}, {5950,0.000000}, {6000,0.000308}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000308}, {8250,0.000308}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000308}, {8650,0.000000}, {8700,0.000308}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000308}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}};
data["big_flat"]["Mtac2"]["lazy beta iota"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000004695}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000004695}, {895,0.000004695}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000004695}, {920,0.000004695}, {925,0.000000000}, {930,0.000004695}, {935,0.000009390}, {940,0.000000000}, {945,0.000004695}, {950,0.000000000}, {955,0.000009390}, {960,0.000000000}, {965,0.000000000}, {970,0.000004695}, {975,0.000000000}, {980,0.000004695}, {985,0.000023474}, {990,0.000004695}, {995,0.000009390}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000004695}, {1030,0.000004695}, {1040,0.000009390}, {1050,0.000000000}, {1060,0.000004695}, {1070,0.000014085}, {1080,0.000009390}, {1090,0.000023474}, {1100,0.000000000}, {1110,0.000018779}, {1120,0.000004695}, {1130,0.000004695}, {1140,0.000009390}, {1150,0.000004695}, {1160,0.000023474}, {1170,0.000032864}, {1180,0.000018779}, {1190,0.000009390}, {1200,0.000004695}, {1210,0.000009390}, {1220,0.000014085}, {1230,0.000009390}, {1240,0.000009390}, {1250,0.000023474}, {1260,0.000032864}, {1270,0.000000000}, {1280,0.000009390}, {1290,0.000004695}, {1300,0.000009390}, {1310,0.000009390}, {1320,0.000032864}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000004695}, {1360,0.000018779}, {1370,0.000014085}, {1380,0.000014085}, {1390,0.000009390}, {1400,0.000004695}, {1410,0.000004695}, {1420,0.000004695}, {1430,0.000004695}, {1440,0.000014085}, {1450,0.000004695}, {1460,0.000004695}, {1470,0.000000000}, {1480,0.000018779}, {1490,0.000009390}, {1500,0.000004695}, {1510,0.000000}, {1520,0.000000}, {1530,0.000000}, {1540,0.000000}, {1550,0.000000}, {1560,0.000000}, {1570,0.000000}, {1580,0.000000}, {1590,0.000000}, {1600,0.000000}, {1610,0.000000}, {1620,0.000000}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000000}, {1680,0.000000}, {1690,0.000000}, {1700,0.000000}, {1710,0.000077}, {1720,0.000000}, {1730,0.000000}, {1740,0.000000}, {1750,0.000000}, {1760,0.000077}, {1770,0.000077}, {1780,0.000000}, {1790,0.000000}, {1800,0.000000}, {1810,0.000000}, {1820,0.000077}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000000}, {1900,0.000000}, {1910,0.000000}, {1920,0.000000}, {1930,0.000000}, {1940,0.000000}, {1950,0.000154}, {1960,0.000154}, {1970,0.000000}, {1980,0.000000}, {1990,0.000154}, {2000,0.000000}, {2050,0.000077}, {2100,0.000000}, {2150,0.000000}, {2200,0.000077}, {2250,0.000077}, {2300,0.000000}, {2350,0.000308}, {2400,0.000769}, {2450,0.000769}, {2500,0.000769}, {2550,0.000846}, {2600,0.000923}, {2650,0.001000}, {2700,0.001000}, {2750,0.001000}, {2800,0.001000}, {2850,0.001000}, {2900,0.001000}, {2950,0.005308}, {3000,0.001000}, {3050,0.001000}, {3100,0.001000}, {3150,0.001000}, {3200,0.001000}, {3250,0.001000}, {3300,0.001000}, {3350,0.001000}, {3400,0.001000}, {3450,0.001000}, {3500,0.001000}, {3550,0.001000}, {3600,0.001000}, {3650,0.001000}, {3700,0.001000}, {3750,0.001000}, {3800,0.001000}, {3850,0.001000}, {3900,0.001000}, {3950,0.001000}, {4000,0.001000}, {4050,0.001000}, {4100,0.001000}, {4150,0.001000}, {4200,0.001000}, {4250,0.001000}, {4300,0.001000}, {4350,0.001000}, {4400,0.001000}, {4450,0.001000}, {4500,0.001077}, {4550,0.001077}, {4600,0.001154}, {4650,0.001154}, {4700,0.001308}, {4750,0.001308}, {4800,0.001308}, {4850,0.001692}, {4900,0.001846}, {4950,0.001846}, {5000,0.001846}, {5050,0.001846}, {5100,0.001846}, {5150,0.001923}, {5200,0.002000}, {5250,0.002000}, {5300,0.002000}, {5350,0.002000}, {5400,0.002000}, {5450,0.002000}, {5500,0.002000}, {5550,0.002000}, {5600,0.002000}, {5650,0.002000}, {5700,0.002000}, {5750,0.002000}, {5800,0.002000}, {5850,0.018308}, {5900,0.002000}, {5950,0.002000}, {6000,0.002000}, {6050,0.002000}, {6100,0.002000}, {6150,0.002000}, {6200,0.002000}, {6250,0.002000}, {6300,0.002000}, {6350,0.002000}, {6400,0.002000}, {6450,0.002000}, {6500,0.002000}, {6550,0.002077}, {6600,0.002077}, {6650,0.002154}, {6700,0.002077}, {6750,0.002154}, {6800,0.002308}, {6850,0.002308}, {6900,0.002308}, {6950,0.002308}, {7000,0.002308}, {7050,0.002308}, {7100,0.002385}, {7150,0.002923}, {7200,0.002462}, {7250,0.002846}, {7300,0.002923}, {7350,0.002923}, {7400,0.003000}, {7450,0.003000}, {7500,0.003000}, {7550,0.003000}, {7600,0.003000}, {7650,0.003000}, {7700,0.003000}, {7750,0.003000}, {7800,0.003000}, {7850,0.003000}, {7900,0.003000}, {7950,0.003000}, {8000,0.003000}, {8050,0.003000}, {8100,0.003000}, {8150,0.003000}, {8200,0.003000}, {8250,0.003000}, {8300,0.003000}, {8350,0.003000}, {8400,0.003000}, {8450,0.003077}, {8500,0.003000}, {8550,0.003000}, {8600,0.003154}, {8650,0.003154}, {8700,0.003154}, {8750,0.003154}, {8800,0.003308}, {8850,0.003308}, {8900,0.003154}, {8950,0.003308}, {9000,0.023000}, {9050,0.003385}, {9100,0.003308}, {9150,0.003308}, {9200,0.003308}, {9250,0.003308}, {9300,0.003385}, {9350,0.003385}, {9400,0.028692}, {9450,0.003615}, {9500,0.003846}, {9550,0.003692}, {9600,0.003769}, {9650,0.003846}, {9700,0.003923}, {9750,0.003923}, {9800,0.003923}, {9850,0.003923}, {9900,0.003923}, {9950,0.003923}, {10000,0.003923}};
data["big_flat"]["Mtac2"]["lazy beta iota"]["user"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000018779}, {5,0.000018779}, {6,0.000075117}, {7,0.000018779}, {8,0.000000000}, {9,0.000018779}, {10,0.000018779}, {11,0.000018779}, {12,0.000018779}, {13,0.000037559}, {14,0.000018779}, {15,0.000056338}, {16,0.000000000}, {17,0.000018779}, {18,0.000018779}, {19,0.000018779}, {20,0.000037559}, {21,0.000056338}, {22,0.000018779}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000037559}, {28,0.000014085}, {29,0.000018779}, {30,0.000018779}, {31,0.000018779}, {32,0.000037559}, {33,0.000056338}, {34,0.000028169}, {35,0.000065728}, {36,0.000093897}, {37,0.000032864}, {38,0.000037559}, {39,0.000000000}, {40,0.000107981}, {41,0.000018779}, {42,0.000075117}, {43,0.000014085}, {44,0.000051643}, {45,0.000032864}, {46,0.000070423}, {47,0.000000000}, {48,0.000051643}, {49,0.000065728}, {50,0.000065728}, {51,0.000032864}, {52,0.000084507}, {53,0.000084507}, {54,0.000037559}, {55,0.000037559}, {56,0.000037559}, {57,0.000084507}, {58,0.000018779}, {59,0.000056338}, {60,0.000056338}, {61,0.000093897}, {62,0.000075117}, {63,0.000075117}, {64,0.000093897}, {65,0.000018779}, {66,0.000018779}, {67,0.000093897}, {68,0.000075117}, {69,0.000056338}, {70,0.000089202}, {71,0.000075117}, {72,0.000037559}, {73,0.000075117}, {74,0.000093897}, {75,0.000206573}, {76,0.000093897}, {77,0.000075117}, {78,0.000075117}, {79,0.000131455}, {80,0.000037559}, {81,0.000056338}, {82,0.000093897}, {83,0.000056338}, {84,0.000075117}, {85,0.000037559}, {86,0.000093897}, {87,0.000075117}, {88,0.000169014}, {89,0.000075117}, {90,0.000056338}, {91,0.000089202}, {92,0.000056338}, {93,0.000037559}, {94,0.000093897}, {95,0.000075117}, {96,0.000000000}, {97,0.000084507}, {98,0.000018779}, {99,0.000084507}, {100,0.000051643}, {101,0.000164319}, {102,0.000117371}, {103,0.000075117}, {104,0.000032864}, {105,0.000093897}, {106,0.000056338}, {107,0.000093897}, {108,0.000075117}, {109,0.000112676}, {110,0.000056338}, {111,0.000112676}, {112,0.000112676}, {113,0.000075117}, {114,0.000075117}, {115,0.000075117}, {116,0.000075117}, {117,0.000056338}, {118,0.000093897}, {119,0.000112676}, {120,0.000112676}, {121,0.000169014}, {122,0.000107981}, {123,0.000075117}, {124,0.000112676}, {125,0.000107981}, {126,0.000070423}, {127,0.000046948}, {128,0.000032864}, {129,0.000065728}, {130,0.000070423}, {131,0.000061033}, {132,0.000098592}, {133,0.000051643}, {134,0.000075117}, {135,0.000183099}, {136,0.000075117}, {137,0.000070423}, {138,0.000018779}, {139,0.000075117}, {140,0.000112676}, {141,0.000103286}, {142,0.000070423}, {143,0.000084507}, {144,0.000056338}, {145,0.000140845}, {146,0.000122066}, {147,0.000103286}, {148,0.000145540}, {149,0.000140845}, {150,0.000070423}, {151,0.000070423}, {152,0.000126761}, {153,0.000117371}, {154,0.000065728}, {155,0.000089202}, {156,0.000173709}, {157,0.000051643}, {158,0.000112676}, {159,0.000046948}, {160,0.000220657}, {161,0.000061033}, {162,0.000107981}, {163,0.000131455}, {164,0.000169014}, {165,0.000051643}, {166,0.000032864}, {167,0.000136150}, {168,0.000065728}, {169,0.000065728}, {170,0.000154930}, {171,0.000079812}, {172,0.000122066}, {173,0.000112676}, {174,0.000169014}, {175,0.000056338}, {176,0.000089202}, {177,0.000215962}, {178,0.000126761}, {179,0.000061033}, {180,0.000051643}, {181,0.000070423}, {182,0.000103286}, {183,0.000084507}, {184,0.000061033}, {185,0.000075117}, {186,0.000154930}, {187,0.000084507}, {188,0.000093897}, {189,0.000150235}, {190,0.000065728}, {191,0.000065728}, {192,0.000173709}, {193,0.000197183}, {194,0.000070423}, {195,0.000126761}, {196,0.000103286}, {197,0.000098592}, {198,0.000107981}, {199,0.000145540}, {200,0.000206573}, {201,0.000032864}, {202,0.000122066}, {203,0.000046948}, {204,0.000084507}, {205,0.000230047}, {206,0.000098592}, {207,0.000056338}, {208,0.000089202}, {209,0.000112676}, {210,0.000112676}, {211,0.000098592}, {212,0.000178404}, {213,0.000117371}, {214,0.000070423}, {215,0.000178404}, {216,0.000140845}, {217,0.000079812}, {218,0.000131455}, {219,0.000187793}, {220,0.000117371}, {221,0.000107981}, {222,0.000183099}, {223,0.000117371}, {224,0.000079812}, {225,0.000220657}, {226,0.000061033}, {227,0.000089202}, {228,0.000084507}, {229,0.000112676}, {230,0.000178404}, {231,0.000234742}, {232,0.000126761}, {233,0.000112676}, {234,0.000046948}, {235,0.000126761}, {236,0.000070423}, {237,0.000098592}, {238,0.000136150}, {239,0.000032864}, {240,0.000098592}, {241,0.000037559}, {242,0.000122066}, {243,0.000117371}, {244,0.000140845}, {245,0.000107981}, {246,0.000089202}, {247,0.000075117}, {248,0.000122066}, {249,0.000159624}, {250,0.000117371}, {251,0.000150235}, {252,0.000061033}, {253,0.000159624}, {254,0.000201878}, {255,0.000098592}, {256,0.000192488}, {257,0.000042254}, {258,0.000122066}, {259,0.000140845}, {260,0.000136150}, {261,0.000140845}, {262,0.000140845}, {263,0.000131455}, {264,0.000089202}, {265,0.000103286}, {266,0.000065728}, {267,0.000075117}, {268,0.000070423}, {269,0.000169014}, {270,0.000164319}, {271,0.000145540}, {272,0.000159624}, {273,0.000187793}, {274,0.000131455}, {275,0.000342723}, {276,0.000150235}, {277,0.000136150}, {278,0.000117371}, {279,0.000107981}, {280,0.000192488}, {281,0.000042254}, {282,0.000131455}, {283,0.000159624}, {284,0.000103286}, {285,0.000131455}, {286,0.000046948}, {287,0.000197183}, {288,0.000075117}, {289,0.000084507}, {290,0.000197183}, {291,0.000131455}, {292,0.000112676}, {293,0.000169014}, {294,0.000145540}, {295,0.000201878}, {296,0.000154930}, {297,0.000140845}, {298,0.000089202}, {299,0.000014085}, {300,0.000093897}, {301,0.000187793}, {302,0.000145540}, {303,0.000136150}, {304,0.000046948}, {305,0.000098592}, {306,0.000079812}, {307,0.000169014}, {308,0.000103286}, {309,0.000061033}, {310,0.000206573}, {311,0.000093897}, {312,0.000131455}, {313,0.000107981}, {314,0.000131455}, {315,0.000187793}, {316,0.000150235}, {317,0.000136150}, {318,0.000018779}, {319,0.000225352}, {320,0.000103286}, {321,0.000103286}, {322,0.000169014}, {323,0.000150235}, {324,0.000187793}, {325,0.000140845}, {326,0.000136150}, {327,0.000093897}, {328,0.000112676}, {329,0.000159624}, {330,0.000122066}, {331,0.000178404}, {332,0.000145540}, {333,0.000140845}, {334,0.000070423}, {335,0.000136150}, {336,0.000117371}, {337,0.000164319}, {338,0.000159624}, {339,0.000136150}, {340,0.000183099}, {341,0.000154930}, {342,0.000178404}, {343,0.000093897}, {344,0.000070423}, {345,0.000253521}, {346,0.000131455}, {347,0.000154930}, {348,0.000122066}, {349,0.000201878}, {350,0.000065728}, {351,0.000262911}, {352,0.000150235}, {353,0.000089202}, {354,0.000107981}, {355,0.000211268}, {356,0.000112676}, {357,0.000159624}, {358,0.000075117}, {359,0.000183099}, {360,0.000192488}, {361,0.000291080}, {362,0.000309859}, {363,0.000178404}, {364,0.000154930}, {365,0.000164319}, {366,0.000107981}, {367,0.000230047}, {368,0.000117371}, {369,0.000117371}, {370,0.000192488}, {371,0.000187793}, {372,0.000140845}, {373,0.000201878}, {374,0.000107981}, {375,0.000126761}, {376,0.000140845}, {377,0.000122066}, {378,0.000112676}, {379,0.000154930}, {380,0.000230047}, {381,0.000215962}, {382,0.000225352}, {383,0.000192488}, {384,0.000164319}, {385,0.000220657}, {386,0.000126761}, {387,0.000164319}, {388,0.000234742}, {389,0.000112676}, {390,0.000159624}, {391,0.000164319}, {392,0.000192488}, {393,0.000234742}, {394,0.000079812}, {395,0.000305164}, {396,0.000131455}, {397,0.000192488}, {398,0.000192488}, {399,0.000178404}, {400,0.000154930}, {401,0.000323944}, {402,0.000131455}, {403,0.000154930}, {404,0.000169014}, {405,0.000183099}, {406,0.000253521}, {407,0.000248826}, {408,0.000126761}, {409,0.000145540}, {410,0.000140845}, {411,0.000173709}, {412,0.000239437}, {413,0.000070423}, {414,0.000183099}, {415,0.000140845}, {416,0.000220657}, {417,0.000136150}, {418,0.000394366}, {419,0.000107981}, {420,0.000154930}, {421,0.000258216}, {422,0.000192488}, {423,0.000192488}, {424,0.000154930}, {425,0.000159624}, {426,0.000098592}, {427,0.000117371}, {428,0.000187793}, {429,0.000211268}, {430,0.000183099}, {431,0.000267606}, {432,0.000150235}, {433,0.000187793}, {434,0.000093897}, {435,0.000248826}, {436,0.000126761}, {437,0.000244131}, {438,0.000093897}, {439,0.000197183}, {440,0.000150235}, {441,0.000169014}, {442,0.000187793}, {443,0.000169014}, {444,0.000211268}, {445,0.000154930}, {446,0.000173709}, {447,0.000103286}, {448,0.000183099}, {449,0.000225352}, {450,0.000211268}, {451,0.000253521}, {452,0.000065728}, {453,0.000267606}, {454,0.000253521}, {455,0.000131455}, {456,0.000178404}, {457,0.000234742}, {458,0.000164319}, {459,0.000192488}, {460,0.000248826}, {461,0.000347418}, {462,0.000239437}, {463,0.000159624}, {464,0.000136150}, {465,0.000201878}, {466,0.000225352}, {467,0.000169014}, {468,0.000150235}, {469,0.000187793}, {470,0.000460094}, {471,0.000206573}, {472,0.000169014}, {473,0.000201878}, {474,0.000187793}, {475,0.000206573}, {476,0.000215962}, {477,0.000244131}, {478,0.000230047}, {479,0.000314554}, {480,0.000253521}, {481,0.000089202}, {482,0.000136150}, {483,0.000272300}, {484,0.000178404}, {485,0.000201878}, {486,0.000262911}, {487,0.000159624}, {488,0.000258216}, {489,0.000248826}, {490,0.000169014}, {491,0.000169014}, {492,0.000089202}, {493,0.000230047}, {494,0.000267606}, {495,0.000197183}, {496,0.000230047}, {497,0.000239437}, {498,0.000159624}, {499,0.000159624}, {500,0.000098592}, {505,0.000225352}, {510,0.000145540}, {515,0.000239437}, {520,0.000244131}, {525,0.000295775}, {530,0.000197183}, {535,0.000262911}, {540,0.000183099}, {545,0.000084507}, {550,0.000239437}, {555,0.000295775}, {560,0.000183099}, {565,0.000267606}, {570,0.000234742}, {575,0.000305164}, {580,0.000187793}, {585,0.000295775}, {590,0.000211268}, {595,0.000352113}, {600,0.000164319}, {605,0.000215962}, {610,0.000215962}, {615,0.000342723}, {620,0.000248826}, {625,0.000122066}, {630,0.000272300}, {635,0.000234742}, {640,0.000117371}, {645,0.000361502}, {650,0.000244131}, {655,0.000300469}, {660,0.000258216}, {665,0.000248826}, {670,0.000248826}, {675,0.000267606}, {680,0.000267606}, {685,0.000230047}, {690,0.000300469}, {695,0.000384977}, {700,0.000356808}, {705,0.000206573}, {710,0.000295775}, {715,0.000305164}, {720,0.000253521}, {725,0.000413146}, {730,0.000295775}, {735,0.000342723}, {740,0.000253521}, {745,0.000291080}, {750,0.000352113}, {755,0.000230047}, {760,0.000352113}, {765,0.000253521}, {770,0.000211268}, {775,0.000169014}, {780,0.000314554}, {785,0.000328638}, {790,0.000295775}, {795,0.000267606}, {800,0.000323944}, {805,0.000352113}, {810,0.000347418}, {815,0.000244131}, {820,0.000276995}, {825,0.000380282}, {830,0.000206573}, {835,0.000314554}, {840,0.000244131}, {845,0.000211268}, {850,0.000267606}, {855,0.000328638}, {860,0.000220657}, {865,0.000300469}, {870,0.000333333}, {875,0.000267606}, {880,0.000319249}, {885,0.000384977}, {890,0.000460094}, {895,0.000338028}, {900,0.000375587}, {905,0.000258216}, {910,0.000201878}, {915,0.000323944}, {920,0.000338028}, {925,0.000328638}, {930,0.000403756}, {935,0.000291080}, {940,0.000474178}, {945,0.000262911}, {950,0.000333333}, {955,0.000375587}, {960,0.000352113}, {965,0.000441315}, {970,0.000370892}, {975,0.000370892}, {980,0.000267606}, {985,0.000361502}, {990,0.000450704}, {995,0.000370892}, {1000,0.000347418}, {1010,0.000248826}, {1020,0.000323944}, {1030,0.000399061}, {1040,0.000295775}, {1050,0.000234742}, {1060,0.000384977}, {1070,0.000399061}, {1080,0.000436620}, {1090,0.000446009}, {1100,0.000446009}, {1110,0.000591549}, {1120,0.000413146}, {1130,0.000258216}, {1140,0.000591549}, {1150,0.000384977}, {1160,0.000441315}, {1170,0.000530516}, {1180,0.000577465}, {1190,0.000431925}, {1200,0.000408451}, {1210,0.000380282}, {1220,0.000276995}, {1230,0.000629108}, {1240,0.000460094}, {1250,0.000572770}, {1260,0.000610329}, {1270,0.000436620}, {1280,0.000535211}, {1290,0.000464789}, {1300,0.000291080}, {1310,0.000366197}, {1320,0.000727700}, {1330,0.000718310}, {1340,0.000478873}, {1350,0.000643192}, {1360,0.000483568}, {1370,0.000516432}, {1380,0.000478873}, {1390,0.000704225}, {1400,0.000553991}, {1410,0.000737089}, {1420,0.000295775}, {1430,0.000600939}, {1440,0.000765258}, {1450,0.000661972}, {1460,0.000676056}, {1470,0.000605634}, {1480,0.000718310}, {1490,0.000577465}, {1500,0.000455399}, {1510,0.000000}, {1520,0.000231}, {1530,0.000692}, {1540,0.001077}, {1550,0.000692}, {1560,0.000462}, {1570,0.000615}, {1580,0.000000}, {1590,0.001077}, {1600,0.001000}, {1610,0.000231}, {1620,0.000308}, {1630,0.000538}, {1640,0.001231}, {1650,0.000231}, {1660,0.000923}, {1670,0.000923}, {1680,0.000308}, {1690,0.001077}, {1700,0.000000}, {1710,0.001000}, {1720,0.000231}, {1730,0.000846}, {1740,0.001154}, {1750,0.000615}, {1760,0.001000}, {1770,0.000462}, {1780,0.000538}, {1790,0.000231}, {1800,0.001000}, {1810,0.000923}, {1820,0.000538}, {1830,0.000231}, {1840,0.000462}, {1850,0.000769}, {1860,0.000462}, {1870,0.000615}, {1880,0.000923}, {1890,0.000538}, {1900,0.000231}, {1910,0.000769}, {1920,0.001385}, {1930,0.000538}, {1940,0.001154}, {1950,0.000538}, {1960,0.000308}, {1970,0.000462}, {1980,0.000308}, {1990,0.000308}, {2000,0.000538}, {2050,0.000462}, {2100,0.000000}, {2150,0.000308}, {2200,0.000846}, {2250,0.001462}, {2300,0.000000}, {2350,0.000538}, {2400,0.001000}, {2450,0.000846}, {2500,0.000538}, {2550,0.000615}, {2600,0.001077}, {2650,0.001231}, {2700,0.000923}, {2750,0.001385}, {2800,0.001077}, {2850,0.000308}, {2900,0.000769}, {2950,0.006000}, {3000,0.000462}, {3050,0.000538}, {3100,0.001769}, {3150,0.001308}, {3200,0.001846}, {3250,0.001923}, {3300,0.002000}, {3350,0.001538}, {3400,0.001000}, {3450,0.000769}, {3500,0.001846}, {3550,0.000231}, {3600,0.001308}, {3650,0.000231}, {3700,0.001462}, {3750,0.000308}, {3800,0.001462}, {3850,0.001308}, {3900,0.001846}, {3950,0.001385}, {4000,0.001846}, {4050,0.001308}, {4100,0.001385}, {4150,0.001308}, {4200,0.001231}, {4250,0.001154}, {4300,0.001538}, {4350,0.001923}, {4400,0.001769}, {4450,0.001538}, {4500,0.000615}, {4550,0.001308}, {4600,0.001692}, {4650,0.001769}, {4700,0.002769}, {4750,0.001154}, {4800,0.002846}, {4850,0.001077}, {4900,0.001538}, {4950,0.002615}, {5000,0.002000}, {5050,0.002000}, {5100,0.001231}, {5150,0.002308}, {5200,0.001846}, {5250,0.002615}, {5300,0.001846}, {5350,0.001692}, {5400,0.001846}, {5450,0.002769}, {5500,0.000846}, {5550,0.001154}, {5600,0.002615}, {5650,0.002154}, {5700,0.002154}, {5750,0.002769}, {5800,0.002385}, {5850,0.017615}, {5900,0.002846}, {5950,0.003308}, {6000,0.002923}, {6050,0.001462}, {6100,0.002692}, {6150,0.002385}, {6200,0.002385}, {6250,0.002923}, {6300,0.002462}, {6350,0.002692}, {6400,0.002308}, {6450,0.002538}, {6500,0.002077}, {6550,0.003462}, {6600,0.002692}, {6650,0.002154}, {6700,0.002769}, {6750,0.002615}, {6800,0.003692}, {6850,0.003231}, {6900,0.002923}, {6950,0.002846}, {7000,0.002462}, {7050,0.003000}, {7100,0.002462}, {7150,0.003385}, {7200,0.002769}, {7250,0.002462}, {7300,0.002846}, {7350,0.001692}, {7400,0.002077}, {7450,0.002692}, {7500,0.002231}, {7550,0.002769}, {7600,0.001846}, {7650,0.003308}, {7700,0.002538}, {7750,0.002077}, {7800,0.002769}, {7850,0.002154}, {7900,0.002923}, {7950,0.003000}, {8000,0.003000}, {8050,0.003308}, {8100,0.002538}, {8150,0.002923}, {8200,0.003538}, {8250,0.002692}, {8300,0.003077}, {8350,0.003231}, {8400,0.003077}, {8450,0.003462}, {8500,0.003077}, {8550,0.003077}, {8600,0.003308}, {8650,0.002692}, {8700,0.002846}, {8750,0.003538}, {8800,0.002769}, {8850,0.003231}, {8900,0.003385}, {8950,0.003308}, {9000,0.022692}, {9050,0.003077}, {9100,0.003077}, {9150,0.003077}, {9200,0.003231}, {9250,0.003154}, {9300,0.003923}, {9350,0.003077}, {9400,0.028462}, {9450,0.003385}, {9500,0.003385}, {9550,0.002923}, {9600,0.003692}, {9650,0.003154}, {9700,0.003846}, {9750,0.002769}, {9800,0.003000}, {9850,0.002846}, {9900,0.003692}, {9950,0.004000}, {10000,0.003615}};
data["big_flat"]["Mtac2"]["lazy beta iota"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000018779}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000018779}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000018779}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000014085}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000014085}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000018779}, {130,0.000000000}, {131,0.000018779}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000014085}, {167,0.000000000}, {168,0.000018779}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000018779}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000018779}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000018779}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000018779}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000018779}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000018779}, {228,0.000000000}, {229,0.000014085}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000018779}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000018779}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000018779}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000014085}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000014085}, {293,0.000000000}, {294,0.000018779}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000018779}, {317,0.000000000}, {318,0.000000000}, {319,0.000018779}, {320,0.000000000}, {321,0.000000000}, {322,0.000014085}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000018779}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000018779}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000018779}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000018779}, {357,0.000018779}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000018779}, {367,0.000000000}, {368,0.000014085}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000018779}, {373,0.000018779}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000018779}, {401,0.000000000}, {402,0.000000000}, {403,0.000014085}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000014085}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000014085}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000018779}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000018779}, {476,0.000000000}, {477,0.000018779}, {478,0.000018779}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000018779}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000037559}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000018779}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000014085}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000018779}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000018779}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000037559}, {730,0.000018779}, {735,0.000014085}, {740,0.000000000}, {745,0.000018779}, {750,0.000000000}, {755,0.000018779}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000056338}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000018779}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000018779}, {960,0.000018779}, {965,0.000000000}, {970,0.000000000}, {975,0.000018779}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000018779}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000018779}, {1120,0.000014085}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000018779}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000018779}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000037559}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000037559}, {1500,0.000000000}, {1510,0.000308}, {1520,0.000615}, {1530,0.000000}, {1540,0.000000}, {1550,0.000000}, {1560,0.000000}, {1570,0.000000}, {1580,0.000308}, {1590,0.000308}, {1600,0.000308}, {1610,0.000000}, {1620,0.000000}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000000}, {1680,0.000615}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000308}, {1730,0.000000}, {1740,0.000000}, {1750,0.000308}, {1760,0.000000}, {1770,0.000000}, {1780,0.000000}, {1790,0.000000}, {1800,0.000000}, {1810,0.000000}, {1820,0.000000}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000000}, {1900,0.000000}, {1910,0.000000}, {1920,0.000000}, {1930,0.000000}, {1940,0.000000}, {1950,0.000000}, {1960,0.000000}, {1970,0.000000}, {1980,0.000000}, {1990,0.000000}, {2000,0.000000}, {2050,0.000000}, {2100,0.000000}, {2150,0.000000}, {2200,0.000000}, {2250,0.000000}, {2300,0.000000}, {2350,0.000000}, {2400,0.000000}, {2450,0.000000}, {2500,0.000000}, {2550,0.000000}, {2600,0.000000}, {2650,0.000000}, {2700,0.000000}, {2750,0.000000}, {2800,0.000000}, {2850,0.000000}, {2900,0.000000}, {2950,0.000000}, {3000,0.000000}, {3050,0.000000}, {3100,0.000000}, {3150,0.000000}, {3200,0.000000}, {3250,0.000000}, {3300,0.000000}, {3350,0.000000}, {3400,0.000000}, {3450,0.000000}, {3500,0.000000}, {3550,0.000000}, {3600,0.000000}, {3650,0.000000}, {3700,0.000000}, {3750,0.000000}, {3800,0.000000}, {3850,0.000000}, {3900,0.000000}, {3950,0.000000}, {4000,0.000000}, {4050,0.000308}, {4100,0.000000}, {4150,0.000000}, {4200,0.000000}, {4250,0.000000}, {4300,0.000000}, {4350,0.000000}, {4400,0.000000}, {4450,0.000308}, {4500,0.000000}, {4550,0.000000}, {4600,0.000000}, {4650,0.000000}, {4700,0.000000}, {4750,0.000000}, {4800,0.000000}, {4850,0.000000}, {4900,0.000000}, {4950,0.000000}, {5000,0.000000}, {5050,0.000000}, {5100,0.000000}, {5150,0.000000}, {5200,0.000000}, {5250,0.000000}, {5300,0.000000}, {5350,0.000000}, {5400,0.000000}, {5450,0.000000}, {5500,0.000308}, {5550,0.000000}, {5600,0.000000}, {5650,0.000000}, {5700,0.000000}, {5750,0.000000}, {5800,0.000000}, {5850,0.000000}, {5900,0.000000}, {5950,0.000000}, {6000,0.000000}, {6050,0.000231}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000308}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000308}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000308}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000231}, {9800,0.000000}, {9850,0.000308}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}};
data["big_flat"]["Mtac2"]["norm reif"]["real"] = {{1,0.001061033}, {2,0.000061033}, {3,0.000061033}, {4,0.000061033}, {5,0.000061033}, {6,0.000061033}, {7,0.000075117}, {8,0.000150235}, {9,0.000305164}, {10,0.001056338}, {11,0.001061033}, {12,0.001061033}, {13,0.001061033}, {14,0.001061033}, {15,0.001061033}, {16,0.001079812}, {17,0.001117371}, {18,0.001122066}, {19,0.001145540}, {20,0.001145540}, {21,0.001384977}, {22,0.001990610}, {23,0.002061033}, {24,0.002061033}, {25,0.002061033}, {26,0.002061033}, {27,0.002061033}, {28,0.002061033}, {29,0.002089202}, {30,0.002117371}, {31,0.002107981}, {32,0.002338028}, {33,0.002868545}, {34,0.003056338}, {35,0.003061033}, {36,0.003061033}, {37,0.003061033}, {38,0.003065728}, {39,0.003075117}, {40,0.003093897}, {41,0.003126761}, {42,0.003286385}, {43,0.003812207}, {44,0.004004695}, {45,0.004920188}, {46,0.004009390}, {47,0.004004695}, {48,0.004023474}, {49,0.004014085}, {50,0.004061033}, {51,0.004159624}, {52,0.004483568}, {53,0.004943662}, {54,0.005000000}, {55,0.005042254}, {56,0.005046948}, {57,0.005084507}, {58,0.005079812}, {59,0.005145540}, {60,0.006474178}, {61,0.005605634}, {62,0.005995305}, {63,0.006061033}, {64,0.006061033}, {65,0.006065728}, {66,0.006061033}, {67,0.006089202}, {68,0.006154930}, {69,0.006319249}, {70,0.006812207}, {71,0.007009390}, {72,0.008023474}, {73,0.007042254}, {74,0.007037559}, {75,0.007065728}, {76,0.007126761}, {77,0.007347418}, {78,0.007741784}, {79,0.007962441}, {80,0.008004695}, {81,0.008075117}, {82,0.009079812}, {83,0.008103286}, {84,0.008230047}, {85,0.008483568}, {86,0.008868545}, {87,0.009018779}, {88,0.009028169}, {89,0.009042254}, {90,0.010023474}, {91,0.009234742}, {92,0.009413146}, {93,0.009723005}, {94,0.009967136}, {95,0.010028169}, {96,0.010051643}, {97,0.010093897}, {98,0.011544601}, {99,0.010323944}, {100,0.010671362}, {101,0.010967136}, {102,0.011014085}, {103,0.011028169}, {104,0.011084507}, {105,0.012605634}, {106,0.011342723}, {107,0.011553991}, {108,0.011976526}, {109,0.012018779}, {110,0.012046948}, {111,0.013051643}, {112,0.012248826}, {113,0.012492958}, {114,0.012835681}, {115,0.012995305}, {116,0.013126761}, {117,0.015004695}, {118,0.013248826}, {119,0.013380282}, {120,0.013995305}, {121,0.014183099}, {122,0.014399061}, {123,0.016023474}, {124,0.015446009}, {125,0.015417840}, {126,0.015422535}, {127,0.015539906}, {128,0.017427230}, {129,0.015845070}, {130,0.015708920}, {131,0.015694836}, {132,0.015962441}, {133,0.017446009}, {134,0.016262911}, {135,0.016258216}, {136,0.016281690}, {137,0.016478873}, {138,0.018084507}, {139,0.016985915}, {140,0.017103286}, {141,0.017173709}, {142,0.019150235}, {143,0.017370892}, {144,0.017798122}, {145,0.018009390}, {146,0.018098592}, {147,0.019014085}, {148,0.018286385}, {149,0.018516432}, {150,0.018967136}, {151,0.020173709}, {152,0.019225352}, {153,0.019253521}, {154,0.019450704}, {155,0.020619718}, {156,0.019971831}, {157,0.020140845}, {158,0.020178404}, {159,0.020267606}, {160,0.020652582}, {161,0.020929577}, {162,0.022915493}, {163,0.021169014}, {164,0.021276995}, {165,0.021558685}, {166,0.023098592}, {167,0.021990610}, {168,0.022164319}, {169,0.024417840}, {170,0.022530516}, {171,0.022854460}, {172,0.023126761}, {173,0.024122066}, {174,0.023248826}, {175,0.023356808}, {176,0.025089202}, {177,0.024122066}, {178,0.024164319}, {179,0.026291080}, {180,0.024690141}, {181,0.025112676}, {182,0.027366197}, {183,0.025469484}, {184,0.025582160}, {185,0.027718310}, {186,0.025877934}, {187,0.025962441}, {188,0.028727700}, {189,0.026262911}, {190,0.026492958}, {191,0.028723005}, {192,0.027051643}, {193,0.027183099}, {194,0.029032864}, {195,0.027633803}, {196,0.028000000}, {197,0.028140845}, {198,0.028267606}, {199,0.030845070}, {200,0.028873239}, {201,0.028985915}, {202,0.030877934}, {203,0.029370892}, {204,0.030892019}, {205,0.029929577}, {206,0.030103286}, {207,0.032042254}, {208,0.030737089}, {209,0.030812207}, {210,0.030976526}, {211,0.031140845}, {212,0.033023474}, {213,0.031629108}, {214,0.034328638}, {215,0.032098592}, {216,0.032338028}, {217,0.033619718}, {218,0.032769953}, {219,0.036413146}, {220,0.033253521}, {221,0.037272300}, {222,0.033765258}, {223,0.033901408}, {224,0.036051643}, {225,0.034624413}, {226,0.037089202}, {227,0.034985915}, {228,0.037995305}, {229,0.035553991}, {230,0.039051643}, {231,0.035892019}, {232,0.040164319}, {233,0.036413146}, {234,0.040990610}, {235,0.037009390}, {236,0.041572770}, {237,0.037638498}, {238,0.039356808}, {239,0.037924883}, {240,0.039577465}, {241,0.038460094}, {242,0.040291080}, {243,0.038976526}, {244,0.043488263}, {245,0.039497653}, {246,0.044126761}, {247,0.040079812}, {248,0.044755869}, {249,0.040769953}, {250,0.046178404}, {251,0.042323944}, {252,0.046295775}, {253,0.045849765}, {254,0.047568075}, {255,0.043751174}, {256,0.046061033}, {257,0.047586854}, {258,0.043582160}, {259,0.047502347}, {260,0.043859155}, {261,0.047366197}, {262,0.044366197}, {263,0.046859155}, {264,0.050215962}, {265,0.045403756}, {266,0.049319249}, {267,0.045615023}, {268,0.048666667}, {269,0.046338028}, {270,0.047507042}, {271,0.051896714}, {272,0.048887324}, {273,0.052061033}, {274,0.054413146}, {275,0.048582160}, {276,0.052596244}, {277,0.048882629}, {278,0.051605634}, {279,0.053422535}, {280,0.049558685}, {281,0.052488263}, {282,0.054422535}, {283,0.050244131}, {284,0.053469484}, {285,0.054258216}, {286,0.050793427}, {287,0.053234742}, {288,0.055225352}, {289,0.051882629}, {290,0.054183099}, {291,0.055704225}, {292,0.052502347}, {293,0.054732394}, {294,0.056577465}, {295,0.053718310}, {296,0.057309859}, {297,0.057633803}, {298,0.057305164}, {299,0.055389671}, {300,0.057079812}, {301,0.058370892}, {302,0.055690141}, {303,0.057370892}, {304,0.058746479}, {305,0.060319249}, {306,0.056877934}, {307,0.059014085}, {308,0.060253521}, {309,0.061826291}, {310,0.057971831}, {311,0.060122066}, {312,0.061624413}, {313,0.062873239}, {314,0.059521127}, {315,0.061187793}, {316,0.062568075}, {317,0.064145540}, {318,0.061643192}, {319,0.060694836}, {320,0.062117371}, {321,0.063450704}, {322,0.064821596}, {323,0.064793427}, {324,0.062680751}, {325,0.064295775}, {326,0.064882629}, {327,0.065882629}, {328,0.067497653}, {329,0.063708920}, {330,0.064544601}, {331,0.065887324}, {332,0.066906103}, {333,0.068352113}, {334,0.069901408}, {335,0.070413146}, {336,0.068319249}, {337,0.068718310}, {338,0.068826291}, {339,0.068981221}, {340,0.070201878}, {341,0.071131455}, {342,0.072169014}, {343,0.073225352}, {344,0.070868545}, {345,0.069474178}, {346,0.071079812}, {347,0.071558685}, {348,0.072276995}, {349,0.073286385}, {350,0.074892019}, {351,0.074854460}, {352,0.075122066}, {353,0.075422535}, {354,0.076333333}, {355,0.076755869}, {356,0.077967136}, {357,0.078093897}, {358,0.078511737}, {359,0.078962441}, {360,0.076906103}, {361,0.075328638}, {362,0.076117371}, {363,0.075699531}, {364,0.076507042}, {365,0.078154930}, {366,0.079065728}, {367,0.078694836}, {368,0.078924883}, {369,0.079474178}, {370,0.078046948}, {371,0.078774648}, {372,0.080525822}, {373,0.084511737}, {374,0.085225352}, {375,0.084915493}, {376,0.084976526}, {377,0.084549296}, {378,0.084638498}, {379,0.084464789}, {380,0.084605634}, {381,0.084896714}, {382,0.084502347}, {383,0.084906103}, {384,0.084976526}, {385,0.085201878}, {386,0.084962441}, {387,0.085497653}, {388,0.088924883}, {389,0.089460094}, {390,0.089507042}, {391,0.088723005}, {392,0.088741784}, {393,0.088732394}, {394,0.089145540}, {395,0.089671362}, {396,0.093530516}, {397,0.092028169}, {398,0.092906103}, {399,0.090014085}, {400,0.094131455}, {401,0.092173709}, {402,0.092718310}, {403,0.096272300}, {404,0.096004695}, {405,0.095835681}, {406,0.095197183}, {407,0.095234742}, {408,0.098154930}, {409,0.098239437}, {410,0.097192488}, {411,0.096629108}, {412,0.097173709}, {413,0.100276995}, {414,0.098938967}, {415,0.098873239}, {416,0.098699531}, {417,0.101723005}, {418,0.101136150}, {419,0.101164319}, {420,0.100089202}, {421,0.102751174}, {422,0.101281690}, {423,0.100295775}, {424,0.103699531}, {425,0.102788732}, {426,0.101845070}, {427,0.102032864}, {428,0.104309859}, {429,0.103309859}, {430,0.102924883}, {431,0.105647887}, {432,0.104981221}, {433,0.104446009}, {434,0.107943662}, {435,0.105943662}, {436,0.105920188}, {437,0.111291080}, {438,0.105605634}, {439,0.107032864}, {440,0.109464789}, {441,0.108718310}, {442,0.111760563}, {443,0.110769953}, {444,0.109582160}, {445,0.111380282}, {446,0.110788732}, {447,0.112920188}, {448,0.112723005}, {449,0.112220657}, {450,0.113765258}, {451,0.112629108}, {452,0.114981221}, {453,0.114093897}, {454,0.115741784}, {455,0.115154930}, {456,0.114286385}, {457,0.115394366}, {458,0.115446009}, {459,0.117244131}, {460,0.116215962}, {461,0.117835681}, {462,0.116591549}, {463,0.118422535}, {464,0.118427230}, {465,0.119507042}, {466,0.118511737}, {467,0.120075117}, {468,0.119037559}, {469,0.121093897}, {470,0.120028169}, {471,0.122089202}, {472,0.121478873}, {473,0.122431925}, {474,0.124826291}, {475,0.123769953}, {476,0.124305164}, {477,0.123136150}, {478,0.124957746}, {479,0.123694836}, {480,0.125347418}, {481,0.127849765}, {482,0.126164319}, {483,0.127441315}, {484,0.128004695}, {485,0.127859155}, {486,0.129281690}, {487,0.127849765}, {488,0.129732394}, {489,0.134230047}, {490,0.132431925}, {491,0.132985915}, {492,0.135201878}, {493,0.132652582}, {494,0.134309859}, {495,0.135215962}, {496,0.134276995}, {497,0.135755869}, {498,0.137291080}, {499,0.135037559}, {500,0.138183099}, {505,0.140615023}, {510,0.144154930}, {515,0.143525822}, {520,0.144708920}, {525,0.146549296}, {530,0.149666667}, {535,0.151469484}, {540,0.155826291}, {545,0.156896714}, {550,0.161568075}, {555,0.162061033}, {560,0.165849765}, {565,0.166906103}, {570,0.172577465}, {575,0.173769953}, {580,0.178938967}, {585,0.178403756}, {590,0.181389671}, {595,0.184267606}, {600,0.187323944}, {605,0.188319249}, {610,0.191474178}, {615,0.193981221}, {620,0.197812207}, {625,0.199253521}, {630,0.204089202}, {635,0.206507042}, {640,0.209647887}, {645,0.212553991}, {650,0.217483568}, {655,0.216356808}, {660,0.221004695}, {665,0.223248826}, {670,0.227272300}, {675,0.230915493}, {680,0.233718310}, {685,0.236070423}, {690,0.239361502}, {695,0.242723005}, {700,0.251183099}, {705,0.251253521}, {710,0.256244131}, {715,0.258676056}, {720,0.264915493}, {725,0.267342723}, {730,0.271920188}, {735,0.271765258}, {740,0.278873239}, {745,0.282600939}, {750,0.282647887}, {755,0.288652582}, {760,0.294568075}, {765,0.288901408}, {770,0.292920188}, {775,0.297657277}, {780,0.302272300}, {785,0.303356808}, {790,0.308962441}, {795,0.312488263}, {800,0.316338028}, {805,0.320276995}, {810,0.327680751}, {815,0.327244131}, {820,0.331892019}, {825,0.334544601}, {830,0.336906103}, {835,0.341319249}, {840,0.342784038}, {845,0.348422535}, {850,0.352075117}, {855,0.354704225}, {860,0.359314554}, {865,0.363422535}, {870,0.364957746}, {875,0.375126761}, {880,0.376807512}, {885,0.378065728}, {890,0.383723005}, {895,0.393126761}, {900,0.397051643}, {905,0.400450704}, {910,0.401892019}, {915,0.409070423}, {920,0.410441315}, {925,0.416230047}, {930,0.415981221}, {935,0.421300469}, {940,0.429089202}, {945,0.425971831}, {950,0.431868545}, {955,0.438995305}, {960,0.441474178}, {965,0.445502347}, {970,0.450056338}, {975,0.454906103}, {980,0.458605634}, {985,0.464164319}, {990,0.471197183}, {995,0.473075117}, {1000,0.483657277}, {1010,0.486657277}, {1020,0.494427230}, {1030,0.501474178}, {1040,0.514615023}, {1050,0.531826291}, {1060,0.542361502}, {1070,0.548633803}, {1080,0.555258216}, {1090,0.559896714}, {1100,0.572267606}, {1110,0.581535211}, {1120,0.591103286}, {1130,0.600319249}, {1140,0.615211268}, {1150,0.632009390}, {1160,0.628957746}, {1170,0.643215962}, {1180,0.655309859}, {1190,0.663122066}, {1200,0.674183099}, {1210,0.680474178}, {1220,0.702488263}, {1230,0.713408451}, {1240,0.723267606}, {1250,0.735319249}, {1260,0.739798122}, {1270,0.753338028}, {1280,0.760483568}, {1290,0.772460094}, {1300,0.784408451}, {1310,0.799685446}, {1320,0.806615023}, {1330,0.825685446}, {1340,0.839107981}, {1350,0.838314554}, {1360,0.859234742}, {1370,0.874619718}, {1380,0.889469484}, {1390,0.890441315}, {1400,0.903000000}, {1410,0.912967136}, {1420,0.929685446}, {1430,0.944244131}, {1440,0.950727700}, {1450,0.962286385}, {1460,0.972352113}, {1470,0.988596244}, {1480,1.026178404}, {1490,1.031117371}, {1500,1.027892019}, {1510,1.052462}, {1520,1.049231}, {1530,1.079231}, {1540,1.088462}, {1550,1.096077}, {1560,1.102462}, {1570,1.117231}, {1580,1.148385}, {1590,1.149769}, {1600,1.159923}, {1610,1.178538}, {1620,1.187154}, {1630,1.216615}, {1640,1.221000}, {1650,1.226000}, {1660,1.243846}, {1670,1.255846}, {1680,1.278846}, {1690,1.291692}, {1700,1.296308}, {1710,1.317308}, {1720,1.349154}, {1730,1.344308}, {1740,1.372846}, {1750,1.371154}, {1760,1.380154}, {1770,1.422846}, {1780,1.430462}, {1790,1.429231}, {1800,1.444462}, {1810,1.459154}, {1820,1.489385}, {1830,1.495000}, {1840,1.507385}, {1850,1.521385}, {1860,1.538077}, {1870,1.564077}, {1880,1.606462}, {1890,1.586538}, {1900,1.598385}, {1910,1.623000}, {1920,1.637615}, {1930,1.648385}, {1940,1.670077}, {1950,1.678000}, {1960,1.696462}, {1970,1.717077}, {1980,1.722231}, {1990,1.740846}, {2000,1.791692}, {2050,1.845308}, {2100,1.937231}, {2150,1.998846}, {2200,2.091923}, {2250,2.208077}, {2300,2.278538}, {2350,2.381231}, {2400,2.468846}, {2450,2.600538}, {2500,2.669923}, {2550,2.773923}, {2600,2.889692}, {2650,2.986154}, {2700,3.102154}, {2750,3.242000}, {2800,3.316923}, {2850,3.419231}, {2900,3.548615}, {2950,3.665615}, {3000,3.864231}, {3050,3.933308}, {3100,4.048000}, {3150,4.176231}, {3200,4.329308}, {3250,4.435769}, {3300,4.596846}, {3350,4.727846}, {3400,4.854385}, {3450,4.980538}, {3500,5.114231}, {3550,5.291154}, {3600,5.415538}, {3650,5.583692}, {3700,5.733692}, {3750,5.867385}, {3800,6.041615}, {3850,6.168462}, {3900,6.350462}, {3950,6.501923}, {4000,6.694077}, {4050,6.816154}, {4100,7.054000}, {4150,7.177846}, {4200,7.365000}, {4250,7.502154}, {4300,7.692308}, {4350,7.830154}, {4400,8.076692}, {4450,8.304846}, {4500,8.439923}, {4550,8.635846}, {4600,8.803615}, {4650,8.944692}, {4700,9.192154}, {4750,9.336231}, {4800,9.550462}, {4850,9.746923}, {4900,9.922077}, {4950,10.178077}, {5000,10.350538}, {5050,10.590462}, {5100,10.828615}, {5150,11.086154}, {5200,11.272923}, {5250,11.444231}, {5300,11.699538}, {5350,11.893000}, {5400,12.107538}, {5450,12.369769}, {5500,12.543231}, {5550,12.780923}, {5600,13.082692}, {5650,13.275846}, {5700,13.532154}, {5750,13.762231}, {5800,14.037154}, {5850,14.276077}, {5900,14.532615}, {5950,14.773692}, {6000,15.026538}, {6050,15.331077}, {6100,15.553000}, {6150,15.781077}, {6200,16.154154}, {6250,16.380615}, {6300,16.661154}, {6350,16.912077}, {6400,17.195846}, {6450,17.530000}, {6500,17.715462}, {6550,18.049385}, {6600,18.297846}, {6650,18.650462}, {6700,18.907538}, {6750,19.197000}, {6800,19.533615}, {6850,19.932077}, {6900,20.092154}, {6950,20.382000}, {7000,20.628538}, {7050,20.950462}, {7100,21.265538}, {7150,21.576385}, {7200,21.835615}, {7250,22.127923}, {7300,22.343692}, {7350,22.737769}, {7400,23.162231}, {7450,23.539385}, {7500,23.773692}, {7550,24.155077}, {7600,24.318923}, {7650,24.863308}, {7700,25.200923}, {7750,25.476846}, {7800,25.802000}, {7850,26.032692}, {7900,26.431923}, {7950,26.651538}, {8000,27.247923}, {8050,27.494462}, {8100,27.796538}, {8150,28.147615}, {8200,28.478462}, {8250,28.933846}, {8300,29.209846}, {8350,29.601615}, {8400,29.916000}, {8450,30.367538}, {8500,30.604000}, {8550,31.086385}, {8600,31.405462}, {8650,31.789231}, {8700,32.290615}, {8750,32.483615}, {8800,33.032231}, {8850,33.326769}, {8900,33.716385}, {8950,34.224077}, {9000,34.562846}, {9050,34.795769}, {9100,35.544385}, {9150,35.801923}, {9200,36.144846}, {9250,36.441154}, {9300,36.860000}, {9350,37.145769}, {9400,37.542231}, {9450,37.864308}, {9500,38.443154}, {9550,38.770692}, {9600,39.195615}, {9650,39.525769}, {9700,40.426231}, {9750,40.824769}, {9800,40.994308}, {9850,41.445308}, {9900,41.938538}, {9950,42.429462}, {10000,42.860462}};
data["big_flat"]["Mtac2"]["norm reif"]["user"] = {{1,0.000657277}, {2,0.000319249}, {3,0.000413146}, {4,0.000713615}, {5,0.000732394}, {6,0.000901408}, {7,0.000995305}, {8,0.001107981}, {9,0.001145540}, {10,0.001183099}, {11,0.001239437}, {12,0.001314554}, {13,0.001164319}, {14,0.001521127}, {15,0.001446009}, {16,0.001497653}, {17,0.001830986}, {18,0.001774648}, {19,0.001741784}, {20,0.002089202}, {21,0.001624413}, {22,0.002197183}, {23,0.002253521}, {24,0.002272300}, {25,0.002201878}, {26,0.002230047}, {27,0.002314554}, {28,0.002521127}, {29,0.002539906}, {30,0.002572770}, {31,0.002746479}, {32,0.002802817}, {33,0.002840376}, {34,0.002901408}, {35,0.003183099}, {36,0.002845070}, {37,0.003192488}, {38,0.003215962}, {39,0.003248826}, {40,0.003384977}, {41,0.003507042}, {42,0.003478873}, {43,0.003680751}, {44,0.003741784}, {45,0.004600939}, {46,0.003938967}, {47,0.003906103}, {48,0.004338028}, {49,0.004098592}, {50,0.004408451}, {51,0.004586854}, {52,0.004821596}, {53,0.004727700}, {54,0.004807512}, {55,0.005300469}, {56,0.005525822}, {57,0.005258216}, {58,0.005375587}, {59,0.005441315}, {60,0.007014085}, {61,0.005849765}, {62,0.006032864}, {63,0.006244131}, {64,0.006605634}, {65,0.006596244}, {66,0.006605634}, {67,0.006478873}, {68,0.006661972}, {69,0.006849765}, {70,0.007112676}, {71,0.007309859}, {72,0.008370892}, {73,0.007375587}, {74,0.007586854}, {75,0.007680751}, {76,0.007769953}, {77,0.008018779}, {78,0.008000000}, {79,0.008281690}, {80,0.008356808}, {81,0.008488263}, {82,0.009727700}, {83,0.008976526}, {84,0.008863850}, {85,0.008976526}, {86,0.009145540}, {87,0.009164319}, {88,0.009305164}, {89,0.009474178}, {90,0.010469484}, {91,0.009718310}, {92,0.010009390}, {93,0.010107981}, {94,0.010192488}, {95,0.010338028}, {96,0.010474178}, {97,0.010643192}, {98,0.011938967}, {99,0.010652582}, {100,0.010934272}, {101,0.010873239}, {102,0.011178404}, {103,0.011356808}, {104,0.011455399}, {105,0.012971831}, {106,0.011924883}, {107,0.012070423}, {108,0.012262911}, {109,0.012441315}, {110,0.012455399}, {111,0.013492958}, {112,0.012802817}, {113,0.013009390}, {114,0.013117371}, {115,0.013126761}, {116,0.013558685}, {117,0.015342723}, {118,0.013741784}, {119,0.013807512}, {120,0.014169014}, {121,0.014258216}, {122,0.014854460}, {123,0.016577465}, {124,0.015901408}, {125,0.015807512}, {126,0.015854460}, {127,0.015967136}, {128,0.017685446}, {129,0.016164319}, {130,0.016286385}, {131,0.016305164}, {132,0.016431925}, {133,0.017981221}, {134,0.016544601}, {135,0.016474178}, {136,0.016887324}, {137,0.017107981}, {138,0.018478873}, {139,0.017230047}, {140,0.017305164}, {141,0.017281690}, {142,0.019403756}, {143,0.018004695}, {144,0.017924883}, {145,0.018098592}, {146,0.018262911}, {147,0.018929577}, {148,0.018577465}, {149,0.018633803}, {150,0.018957746}, {151,0.020267606}, {152,0.019267606}, {153,0.019366197}, {154,0.019629108}, {155,0.020737089}, {156,0.019765258}, {157,0.020000000}, {158,0.020281690}, {159,0.020492958}, {160,0.020845070}, {161,0.021281690}, {162,0.022915493}, {163,0.020887324}, {164,0.021244131}, {165,0.021892019}, {166,0.023474178}, {167,0.021892019}, {168,0.022502347}, {169,0.024690141}, {170,0.022840376}, {171,0.023323944}, {172,0.023328638}, {173,0.024563380}, {174,0.023732394}, {175,0.023882629}, {176,0.025314554}, {177,0.024361502}, {178,0.024347418}, {179,0.026234742}, {180,0.024976526}, {181,0.025305164}, {182,0.027469484}, {183,0.025765258}, {184,0.025774648}, {185,0.027661972}, {186,0.025981221}, {187,0.026234742}, {188,0.028840376}, {189,0.026492958}, {190,0.026676056}, {191,0.028446009}, {192,0.027051643}, {193,0.027079812}, {194,0.029220657}, {195,0.027647887}, {196,0.027920188}, {197,0.028192488}, {198,0.028253521}, {199,0.031018779}, {200,0.028690141}, {201,0.028915493}, {202,0.031093897}, {203,0.029638498}, {204,0.030990610}, {205,0.030197183}, {206,0.030173709}, {207,0.032389671}, {208,0.030877934}, {209,0.031234742}, {210,0.031478873}, {211,0.031577465}, {212,0.033065728}, {213,0.032014085}, {214,0.034535211}, {215,0.032563380}, {216,0.032769953}, {217,0.033845070}, {218,0.033023474}, {219,0.036516432}, {220,0.033450704}, {221,0.037431925}, {222,0.033774648}, {223,0.033906103}, {224,0.036098592}, {225,0.034643192}, {226,0.037046948}, {227,0.034924883}, {228,0.038051643}, {229,0.035413146}, {230,0.039244131}, {231,0.035746479}, {232,0.040469484}, {233,0.036685446}, {234,0.041107981}, {235,0.036732394}, {236,0.041666667}, {237,0.037859155}, {238,0.039629108}, {239,0.038248826}, {240,0.039859155}, {241,0.038896714}, {242,0.040690141}, {243,0.039370892}, {244,0.043356808}, {245,0.040075117}, {246,0.043863850}, {247,0.040384977}, {248,0.044868545}, {249,0.040929577}, {250,0.045943662}, {251,0.042333333}, {252,0.046145540}, {253,0.045920188}, {254,0.047629108}, {255,0.043948357}, {256,0.046018779}, {257,0.047953052}, {258,0.043629108}, {259,0.047704225}, {260,0.043774648}, {261,0.047549296}, {262,0.044690141}, {263,0.047370892}, {264,0.050460094}, {265,0.045741784}, {266,0.049258216}, {267,0.046023474}, {268,0.048812207}, {269,0.046600939}, {270,0.047892019}, {271,0.051596244}, {272,0.049201878}, {273,0.051887324}, {274,0.054103286}, {275,0.048812207}, {276,0.052333333}, {277,0.049187793}, {278,0.051535211}, {279,0.053075117}, {280,0.049572770}, {281,0.052192488}, {282,0.054366197}, {283,0.050084507}, {284,0.053169014}, {285,0.053985915}, {286,0.050708920}, {287,0.052967136}, {288,0.054910798}, {289,0.051619718}, {290,0.053765258}, {291,0.055751174}, {292,0.052366197}, {293,0.054478873}, {294,0.056521127}, {295,0.053615023}, {296,0.057169014}, {297,0.057314554}, {298,0.057225352}, {299,0.055610329}, {300,0.056732394}, {301,0.058375587}, {302,0.055694836}, {303,0.057389671}, {304,0.058920188}, {305,0.060342723}, {306,0.056896714}, {307,0.059206573}, {308,0.060356808}, {309,0.062009390}, {310,0.057957746}, {311,0.060276995}, {312,0.061887324}, {313,0.063126761}, {314,0.059830986}, {315,0.061403756}, {316,0.062948357}, {317,0.064492958}, {318,0.061755869}, {319,0.061117371}, {320,0.062192488}, {321,0.063652582}, {322,0.065023474}, {323,0.064845070}, {324,0.063122066}, {325,0.064417840}, {326,0.065192488}, {327,0.065676056}, {328,0.067211268}, {329,0.064037559}, {330,0.064929577}, {331,0.065760563}, {332,0.066647887}, {333,0.068173709}, {334,0.069380282}, {335,0.070075117}, {336,0.068004695}, {337,0.068765258}, {338,0.068154930}, {339,0.068774648}, {340,0.069746479}, {341,0.070821596}, {342,0.072103286}, {343,0.072910798}, {344,0.070943662}, {345,0.069215962}, {346,0.070798122}, {347,0.071323944}, {348,0.072178404}, {349,0.073075117}, {350,0.074910798}, {351,0.074671362}, {352,0.074910798}, {353,0.075596244}, {354,0.076647887}, {355,0.076826291}, {356,0.078056338}, {357,0.078746479}, {358,0.078685446}, {359,0.079516432}, {360,0.077140845}, {361,0.075483568}, {362,0.076215962}, {363,0.075863850}, {364,0.076591549}, {365,0.078436620}, {366,0.079488263}, {367,0.079018779}, {368,0.079295775}, {369,0.079976526}, {370,0.078380282}, {371,0.079131455}, {372,0.080732394}, {373,0.084272300}, {374,0.084816901}, {375,0.084568075}, {376,0.084765258}, {377,0.084436620}, {378,0.084492958}, {379,0.084009390}, {380,0.084643192}, {381,0.084530516}, {382,0.084300469}, {383,0.084516432}, {384,0.084774648}, {385,0.085000000}, {386,0.084943662}, {387,0.085464789}, {388,0.088906103}, {389,0.089258216}, {390,0.089708920}, {391,0.088854460}, {392,0.088835681}, {393,0.088971831}, {394,0.089159624}, {395,0.089441315}, {396,0.093483568}, {397,0.092023474}, {398,0.092901408}, {399,0.089967136}, {400,0.094333333}, {401,0.092009390}, {402,0.092873239}, {403,0.096718310}, {404,0.096370892}, {405,0.096169014}, {406,0.095370892}, {407,0.095370892}, {408,0.098328638}, {409,0.098342723}, {410,0.097596244}, {411,0.097042254}, {412,0.097563380}, {413,0.100225352}, {414,0.099211268}, {415,0.098887324}, {416,0.098826291}, {417,0.101727700}, {418,0.100967136}, {419,0.101140845}, {420,0.100154930}, {421,0.102638498}, {422,0.101244131}, {423,0.100342723}, {424,0.103286385}, {425,0.102492958}, {426,0.101699531}, {427,0.102018779}, {428,0.104107981}, {429,0.102901408}, {430,0.102854460}, {431,0.105610329}, {432,0.104798122}, {433,0.104164319}, {434,0.108075117}, {435,0.105676056}, {436,0.105741784}, {437,0.111234742}, {438,0.105652582}, {439,0.107286385}, {440,0.109685446}, {441,0.108779343}, {442,0.111676056}, {443,0.110657277}, {444,0.109798122}, {445,0.111436620}, {446,0.110835681}, {447,0.112868545}, {448,0.112535211}, {449,0.112272300}, {450,0.113347418}, {451,0.112314554}, {452,0.114845070}, {453,0.113906103}, {454,0.115267606}, {455,0.114863850}, {456,0.114046948}, {457,0.115042254}, {458,0.115000000}, {459,0.116901408}, {460,0.116046948}, {461,0.117784038}, {462,0.116319249}, {463,0.118450704}, {464,0.118455399}, {465,0.119549296}, {466,0.118568075}, {467,0.120178404}, {468,0.118859155}, {469,0.121300469}, {470,0.119981221}, {471,0.122051643}, {472,0.121661972}, {473,0.122328638}, {474,0.124798122}, {475,0.123619718}, {476,0.124253521}, {477,0.123000000}, {478,0.124723005}, {479,0.123568075}, {480,0.125286385}, {481,0.127985915}, {482,0.126389671}, {483,0.127544601}, {484,0.128276995}, {485,0.128032864}, {486,0.129431925}, {487,0.128117371}, {488,0.129981221}, {489,0.134004695}, {490,0.132342723}, {491,0.132812207}, {492,0.135065728}, {493,0.132652582}, {494,0.134122066}, {495,0.134995305}, {496,0.134009390}, {497,0.135624413}, {498,0.137112676}, {499,0.134788732}, {500,0.138276995}, {505,0.140737089}, {510,0.143924883}, {515,0.143488263}, {520,0.144723005}, {525,0.146178404}, {530,0.149671362}, {535,0.151582160}, {540,0.155971831}, {545,0.156971831}, {550,0.161868545}, {555,0.162093897}, {560,0.165779343}, {565,0.166563380}, {570,0.172460094}, {575,0.173633803}, {580,0.178629108}, {585,0.178014085}, {590,0.180976526}, {595,0.184000000}, {600,0.187492958}, {605,0.188384977}, {610,0.191802817}, {615,0.193910798}, {620,0.197751174}, {625,0.199361502}, {630,0.204075117}, {635,0.206309859}, {640,0.209690141}, {645,0.212427230}, {650,0.217474178}, {655,0.216417840}, {660,0.220699531}, {665,0.223276995}, {670,0.227413146}, {675,0.230647887}, {680,0.233615023}, {685,0.236018779}, {690,0.239136150}, {695,0.242258216}, {700,0.250765258}, {705,0.251051643}, {710,0.255333333}, {715,0.258765258}, {720,0.264934272}, {725,0.267281690}, {730,0.271798122}, {735,0.271563380}, {740,0.278727700}, {745,0.282544601}, {750,0.282230047}, {755,0.288544601}, {760,0.294122066}, {765,0.288938967}, {770,0.292873239}, {775,0.297713615}, {780,0.302084507}, {785,0.303145540}, {790,0.308464789}, {795,0.312122066}, {800,0.316403756}, {805,0.320347418}, {810,0.327591549}, {815,0.327178404}, {820,0.331661972}, {825,0.334328638}, {830,0.336859155}, {835,0.341577465}, {840,0.342967136}, {845,0.348314554}, {850,0.352112676}, {855,0.354629108}, {860,0.358910798}, {865,0.363051643}, {870,0.364713615}, {875,0.374877934}, {880,0.376746479}, {885,0.378239437}, {890,0.383643192}, {895,0.393291080}, {900,0.397004695}, {905,0.400215962}, {910,0.401854460}, {915,0.408657277}, {920,0.410159624}, {925,0.416046948}, {930,0.415906103}, {935,0.420774648}, {940,0.428713615}, {945,0.425849765}, {950,0.431690141}, {955,0.438661972}, {960,0.441446009}, {965,0.445469484}, {970,0.449727700}, {975,0.454873239}, {980,0.458676056}, {985,0.463826291}, {990,0.470976526}, {995,0.472802817}, {1000,0.483464789}, {1010,0.485877934}, {1020,0.494497653}, {1030,0.501267606}, {1040,0.514338028}, {1050,0.531779343}, {1060,0.542093897}, {1070,0.548276995}, {1080,0.555079812}, {1090,0.559624413}, {1100,0.572281690}, {1110,0.581314554}, {1120,0.590826291}, {1130,0.600107981}, {1140,0.615107981}, {1150,0.631769953}, {1160,0.628901408}, {1170,0.642901408}, {1180,0.655234742}, {1190,0.663023474}, {1200,0.674009390}, {1210,0.680314554}, {1220,0.702183099}, {1230,0.713065728}, {1240,0.722887324}, {1250,0.734558685}, {1260,0.739328638}, {1270,0.753192488}, {1280,0.760417840}, {1290,0.772342723}, {1300,0.784361502}, {1310,0.799417840}, {1320,0.806342723}, {1330,0.825239437}, {1340,0.838802817}, {1350,0.837713615}, {1360,0.858840376}, {1370,0.874230047}, {1380,0.889483568}, {1390,0.890159624}, {1400,0.902859155}, {1410,0.912732394}, {1420,0.929572770}, {1430,0.943845070}, {1440,0.950352113}, {1450,0.961845070}, {1460,0.971882629}, {1470,0.988488263}, {1480,1.025812207}, {1490,1.031023474}, {1500,1.027676056}, {1510,1.052308}, {1520,1.047923}, {1530,1.077154}, {1540,1.086846}, {1550,1.094846}, {1560,1.101923}, {1570,1.117308}, {1580,1.146846}, {1590,1.148769}, {1600,1.158692}, {1610,1.177769}, {1620,1.185462}, {1630,1.216077}, {1640,1.220923}, {1650,1.226077}, {1660,1.244308}, {1670,1.255462}, {1680,1.278769}, {1690,1.291923}, {1700,1.296462}, {1710,1.317077}, {1720,1.348692}, {1730,1.344308}, {1740,1.371692}, {1750,1.370692}, {1760,1.379615}, {1770,1.422846}, {1780,1.430846}, {1790,1.429308}, {1800,1.443000}, {1810,1.457846}, {1820,1.488385}, {1830,1.494769}, {1840,1.507769}, {1850,1.521231}, {1860,1.537615}, {1870,1.563385}, {1880,1.606308}, {1890,1.586077}, {1900,1.597846}, {1910,1.623077}, {1920,1.637462}, {1930,1.647923}, {1940,1.670231}, {1950,1.677923}, {1960,1.696538}, {1970,1.716846}, {1980,1.721615}, {1990,1.741462}, {2000,1.792000}, {2050,1.846000}, {2100,1.938231}, {2150,1.999615}, {2200,2.091923}, {2250,2.208231}, {2300,2.279000}, {2350,2.380846}, {2400,2.468692}, {2450,2.599538}, {2500,2.670077}, {2550,2.774000}, {2600,2.888538}, {2650,2.986154}, {2700,3.102308}, {2750,3.241308}, {2800,3.317462}, {2850,3.418692}, {2900,3.548923}, {2950,3.665538}, {3000,3.864308}, {3050,3.933385}, {3100,4.047077}, {3150,4.175615}, {3200,4.328692}, {3250,4.435154}, {3300,4.594077}, {3350,4.723846}, {3400,4.855000}, {3450,4.981538}, {3500,5.113923}, {3550,5.292000}, {3600,5.414385}, {3650,5.584000}, {3700,5.733385}, {3750,5.867154}, {3800,6.040923}, {3850,6.167308}, {3900,6.350077}, {3950,6.500615}, {4000,6.692308}, {4050,6.815385}, {4100,7.052615}, {4150,7.178154}, {4200,7.363923}, {4250,7.502308}, {4300,7.691154}, {4350,7.829000}, {4400,8.076385}, {4450,8.303615}, {4500,8.439923}, {4550,8.636154}, {4600,8.802462}, {4650,8.944538}, {4700,9.190385}, {4750,9.336308}, {4800,9.549846}, {4850,9.746615}, {4900,9.922154}, {4950,10.177154}, {5000,10.349692}, {5050,10.588385}, {5100,10.828231}, {5150,11.084769}, {5200,11.272000}, {5250,11.443000}, {5300,11.698615}, {5350,11.890846}, {5400,12.105923}, {5450,12.366846}, {5500,12.543692}, {5550,12.781231}, {5600,13.081692}, {5650,13.274231}, {5700,13.532000}, {5750,13.760538}, {5800,14.035231}, {5850,14.274615}, {5900,14.531385}, {5950,14.771923}, {6000,15.024154}, {6050,15.330615}, {6100,15.550154}, {6150,15.779538}, {6200,16.150923}, {6250,16.380077}, {6300,16.659846}, {6350,16.909154}, {6400,17.193692}, {6450,17.527231}, {6500,17.714692}, {6550,18.048846}, {6600,18.295769}, {6650,18.647308}, {6700,18.905000}, {6750,19.194308}, {6800,19.529154}, {6850,19.926154}, {6900,20.090000}, {6950,20.378231}, {7000,20.625923}, {7050,20.946769}, {7100,21.263692}, {7150,21.572308}, {7200,21.832615}, {7250,22.125308}, {7300,22.340154}, {7350,22.736154}, {7400,23.155385}, {7450,23.533308}, {7500,23.766615}, {7550,24.150000}, {7600,24.313769}, {7650,24.856308}, {7700,25.198692}, {7750,25.472462}, {7800,25.795462}, {7850,26.028308}, {7900,26.425692}, {7950,26.647538}, {8000,27.238923}, {8050,27.488385}, {8100,27.794692}, {8150,28.144154}, {8200,28.476923}, {8250,28.930692}, {8300,29.207308}, {8350,29.599846}, {8400,29.911692}, {8450,30.365923}, {8500,30.603923}, {8550,31.084385}, {8600,31.404077}, {8650,31.788231}, {8700,32.287308}, {8750,32.480769}, {8800,33.028769}, {8850,33.319231}, {8900,33.711846}, {8950,34.216769}, {9000,34.555615}, {9050,34.790000}, {9100,35.512769}, {9150,35.796154}, {9200,36.140692}, {9250,36.437846}, {9300,36.854308}, {9350,37.140462}, {9400,37.537000}, {9450,37.861077}, {9500,38.437077}, {9550,38.763692}, {9600,39.190308}, {9650,39.517385}, {9700,40.421154}, {9750,40.813538}, {9800,40.986846}, {9850,41.436000}, {9900,41.935077}, {9950,42.423692}, {10000,42.853923}};
data["big_flat"]["Mtac2"]["norm reif"]["system"] = {{1,0.000539906}, {2,0.000103286}, {3,0.000046948}, {4,0.000018779}, {5,0.000037559}, {6,0.000037559}, {7,0.000000000}, {8,0.000056338}, {9,0.000018779}, {10,0.000056338}, {11,0.000018779}, {12,0.000000000}, {13,0.000037559}, {14,0.000075117}, {15,0.000000000}, {16,0.000018779}, {17,0.000018779}, {18,0.000014085}, {19,0.000056338}, {20,0.000032864}, {21,0.000150235}, {22,0.000051643}, {23,0.000014085}, {24,0.000000000}, {25,0.000000000}, {26,0.000014085}, {27,0.000037559}, {28,0.000032864}, {29,0.000000000}, {30,0.000018779}, {31,0.000000000}, {32,0.000000000}, {33,0.000014085}, {34,0.000000000}, {35,0.000000000}, {36,0.000018779}, {37,0.000000000}, {38,0.000037559}, {39,0.000018779}, {40,0.000000000}, {41,0.000018779}, {42,0.000018779}, {43,0.000014085}, {44,0.000000000}, {45,0.000056338}, {46,0.000032864}, {47,0.000018779}, {48,0.000056338}, {49,0.000018779}, {50,0.000018779}, {51,0.000000000}, {52,0.000018779}, {53,0.000018779}, {54,0.000056338}, {55,0.000014085}, {56,0.000014085}, {57,0.000000000}, {58,0.000051643}, {59,0.000018779}, {60,0.000032864}, {61,0.000018779}, {62,0.000018779}, {63,0.000000000}, {64,0.000014085}, {65,0.000018779}, {66,0.000000000}, {67,0.000065728}, {68,0.000018779}, {69,0.000032864}, {70,0.000018779}, {71,0.000000000}, {72,0.000000000}, {73,0.000018779}, {74,0.000000000}, {75,0.000056338}, {76,0.000018779}, {77,0.000000000}, {78,0.000000000}, {79,0.000018779}, {80,0.000000000}, {81,0.000051643}, {82,0.000065728}, {83,0.000018779}, {84,0.000018779}, {85,0.000037559}, {86,0.000000000}, {87,0.000032864}, {88,0.000037559}, {89,0.000051643}, {90,0.000018779}, {91,0.000032864}, {92,0.000028169}, {93,0.000051643}, {94,0.000018779}, {95,0.000000000}, {96,0.000018779}, {97,0.000018779}, {98,0.000018779}, {99,0.000014085}, {100,0.000018779}, {101,0.000037559}, {102,0.000037559}, {103,0.000014085}, {104,0.000037559}, {105,0.000098592}, {106,0.000018779}, {107,0.000000000}, {108,0.000018779}, {109,0.000000000}, {110,0.000000000}, {111,0.000051643}, {112,0.000037559}, {113,0.000028169}, {114,0.000000000}, {115,0.000018779}, {116,0.000014085}, {117,0.000051643}, {118,0.000000000}, {119,0.000000000}, {120,0.000018779}, {121,0.000028169}, {122,0.000037559}, {123,0.000014085}, {124,0.000037559}, {125,0.000018779}, {126,0.000037559}, {127,0.000037559}, {128,0.000037559}, {129,0.000018779}, {130,0.000000000}, {131,0.000018779}, {132,0.000000000}, {133,0.000018779}, {134,0.000037559}, {135,0.000014085}, {136,0.000018779}, {137,0.000000000}, {138,0.000028169}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000032864}, {143,0.000018779}, {144,0.000018779}, {145,0.000037559}, {146,0.000018779}, {147,0.000032864}, {148,0.000018779}, {149,0.000000000}, {150,0.000000000}, {151,0.000037559}, {152,0.000037559}, {153,0.000000000}, {154,0.000037559}, {155,0.000089202}, {156,0.000018779}, {157,0.000037559}, {158,0.000000000}, {159,0.000000000}, {160,0.000070423}, {161,0.000018779}, {162,0.000070423}, {163,0.000014085}, {164,0.000000000}, {165,0.000018779}, {166,0.000000000}, {167,0.000000000}, {168,0.000037559}, {169,0.000089202}, {170,0.000037559}, {171,0.000000000}, {172,0.000018779}, {173,0.000037559}, {174,0.000018779}, {175,0.000018779}, {176,0.000051643}, {177,0.000018779}, {178,0.000037559}, {179,0.000112676}, {180,0.000046948}, {181,0.000000000}, {182,0.000018779}, {183,0.000032864}, {184,0.000018779}, {185,0.000037559}, {186,0.000018779}, {187,0.000000000}, {188,0.000107981}, {189,0.000037559}, {190,0.000000000}, {191,0.000164319}, {192,0.000018779}, {193,0.000056338}, {194,0.000056338}, {195,0.000000000}, {196,0.000000000}, {197,0.000037559}, {198,0.000018779}, {199,0.000093897}, {200,0.000032864}, {201,0.000032864}, {202,0.000037559}, {203,0.000018779}, {204,0.000032864}, {205,0.000051643}, {206,0.000037559}, {207,0.000032864}, {208,0.000037559}, {209,0.000000000}, {210,0.000018779}, {211,0.000000000}, {212,0.000056338}, {213,0.000014085}, {214,0.000065728}, {215,0.000051643}, {216,0.000000000}, {217,0.000037559}, {218,0.000051643}, {219,0.000032864}, {220,0.000018779}, {221,0.000089202}, {222,0.000037559}, {223,0.000018779}, {224,0.000018779}, {225,0.000000000}, {226,0.000056338}, {227,0.000037559}, {228,0.000089202}, {229,0.000056338}, {230,0.000122066}, {231,0.000032864}, {232,0.000056338}, {233,0.000000000}, {234,0.000164319}, {235,0.000014085}, {236,0.000075117}, {237,0.000000000}, {238,0.000037559}, {239,0.000018779}, {240,0.000018779}, {241,0.000000000}, {242,0.000018779}, {243,0.000000000}, {244,0.000164319}, {245,0.000000000}, {246,0.000056338}, {247,0.000051643}, {248,0.000032864}, {249,0.000018779}, {250,0.000178404}, {251,0.000037559}, {252,0.000018779}, {253,0.000018779}, {254,0.000018779}, {255,0.000051643}, {256,0.000018779}, {257,0.000089202}, {258,0.000000000}, {259,0.000075117}, {260,0.000018779}, {261,0.000070423}, {262,0.000018779}, {263,0.000018779}, {264,0.000089202}, {265,0.000037559}, {266,0.000159624}, {267,0.000014085}, {268,0.000070423}, {269,0.000014085}, {270,0.000000000}, {271,0.000201878}, {272,0.000037559}, {273,0.000056338}, {274,0.000037559}, {275,0.000000000}, {276,0.000122066}, {277,0.000070423}, {278,0.000065728}, {279,0.000093897}, {280,0.000032864}, {281,0.000079812}, {282,0.000075117}, {283,0.000037559}, {284,0.000070423}, {285,0.000103286}, {286,0.000075117}, {287,0.000089202}, {288,0.000122066}, {289,0.000018779}, {290,0.000112676}, {291,0.000018779}, {292,0.000000000}, {293,0.000089202}, {294,0.000037559}, {295,0.000018779}, {296,0.000061033}, {297,0.000234742}, {298,0.000089202}, {299,0.000032864}, {300,0.000126761}, {301,0.000131455}, {302,0.000018779}, {303,0.000070423}, {304,0.000089202}, {305,0.000107981}, {306,0.000018779}, {307,0.000075117}, {308,0.000145540}, {309,0.000070423}, {310,0.000032864}, {311,0.000032864}, {312,0.000075117}, {313,0.000140845}, {314,0.000037559}, {315,0.000131455}, {316,0.000051643}, {317,0.000089202}, {318,0.000051643}, {319,0.000037559}, {320,0.000112676}, {321,0.000164319}, {322,0.000051643}, {323,0.000150235}, {324,0.000018779}, {325,0.000056338}, {326,0.000070423}, {327,0.000131455}, {328,0.000075117}, {329,0.000037559}, {330,0.000000000}, {331,0.000089202}, {332,0.000018779}, {333,0.000117371}, {334,0.000117371}, {335,0.000056338}, {336,0.000014085}, {337,0.000037559}, {338,0.000000000}, {339,0.000051643}, {340,0.000089202}, {341,0.000169014}, {342,0.000084507}, {343,0.000070423}, {344,0.000070423}, {345,0.000000000}, {346,0.000084507}, {347,0.000131455}, {348,0.000056338}, {349,0.000140845}, {350,0.000051643}, {351,0.000056338}, {352,0.000154930}, {353,0.000112676}, {354,0.000136150}, {355,0.000103286}, {356,0.000145540}, {357,0.000000000}, {358,0.000037559}, {359,0.000000000}, {360,0.000000000}, {361,0.000018779}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000037559}, {367,0.000000000}, {368,0.000037559}, {369,0.000000000}, {370,0.000000000}, {371,0.000051643}, {372,0.000018779}, {373,0.000070423}, {374,0.000014085}, {375,0.000018779}, {376,0.000000000}, {377,0.000018779}, {378,0.000051643}, {379,0.000056338}, {380,0.000000000}, {381,0.000014085}, {382,0.000018779}, {383,0.000037559}, {384,0.000000000}, {385,0.000018779}, {386,0.000018779}, {387,0.000000000}, {388,0.000018779}, {389,0.000000000}, {390,0.000000000}, {391,0.000037559}, {392,0.000018779}, {393,0.000000000}, {394,0.000014085}, {395,0.000000000}, {396,0.000018779}, {397,0.000000000}, {398,0.000075117}, {399,0.000037559}, {400,0.000037559}, {401,0.000037559}, {402,0.000000000}, {403,0.000014085}, {404,0.000000000}, {405,0.000000000}, {406,0.000037559}, {407,0.000000000}, {408,0.000018779}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000070423}, {413,0.000018779}, {414,0.000000000}, {415,0.000018779}, {416,0.000000000}, {417,0.000000000}, {418,0.000018779}, {419,0.000000000}, {420,0.000037559}, {421,0.000000000}, {422,0.000037559}, {423,0.000018779}, {424,0.000089202}, {425,0.000075117}, {426,0.000018779}, {427,0.000018779}, {428,0.000018779}, {429,0.000032864}, {430,0.000037559}, {431,0.000000000}, {432,0.000037559}, {433,0.000037559}, {434,0.000018779}, {435,0.000037559}, {436,0.000018779}, {437,0.000018779}, {438,0.000018779}, {439,0.000018779}, {440,0.000000000}, {441,0.000037559}, {442,0.000018779}, {443,0.000032864}, {444,0.000051643}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000037559}, {449,0.000018779}, {450,0.000037559}, {451,0.000018779}, {452,0.000018779}, {453,0.000037559}, {454,0.000000000}, {455,0.000018779}, {456,0.000018779}, {457,0.000037559}, {458,0.000000000}, {459,0.000014085}, {460,0.000014085}, {461,0.000056338}, {462,0.000014085}, {463,0.000037559}, {464,0.000014085}, {465,0.000056338}, {466,0.000000000}, {467,0.000000000}, {468,0.000075117}, {469,0.000000000}, {470,0.000056338}, {471,0.000018779}, {472,0.000018779}, {473,0.000018779}, {474,0.000018779}, {475,0.000018779}, {476,0.000028169}, {477,0.000056338}, {478,0.000037559}, {479,0.000028169}, {480,0.000056338}, {481,0.000084507}, {482,0.000000000}, {483,0.000018779}, {484,0.000018779}, {485,0.000018779}, {486,0.000018779}, {487,0.000037559}, {488,0.000056338}, {489,0.000000000}, {490,0.000000000}, {491,0.000070423}, {492,0.000018779}, {493,0.000014085}, {494,0.000070423}, {495,0.000018779}, {496,0.000037559}, {497,0.000037559}, {498,0.000018779}, {499,0.000018779}, {500,0.000037559}, {505,0.000000000}, {510,0.000018779}, {515,0.000051643}, {520,0.000000000}, {525,0.000018779}, {530,0.000018779}, {535,0.000037559}, {540,0.000037559}, {545,0.000032864}, {550,0.000000000}, {555,0.000018779}, {560,0.000018779}, {565,0.000000000}, {570,0.000018779}, {575,0.000018779}, {580,0.000037559}, {585,0.000018779}, {590,0.000037559}, {595,0.000000000}, {600,0.000018779}, {605,0.000037559}, {610,0.000014085}, {615,0.000037559}, {620,0.000056338}, {625,0.000037559}, {630,0.000032864}, {635,0.000065728}, {640,0.000014085}, {645,0.000018779}, {650,0.000037559}, {655,0.000000000}, {660,0.000018779}, {665,0.000032864}, {670,0.000000000}, {675,0.000018779}, {680,0.000018779}, {685,0.000018779}, {690,0.000032864}, {695,0.000000000}, {700,0.000037559}, {705,0.000070423}, {710,0.000014085}, {715,0.000000000}, {720,0.000056338}, {725,0.000018779}, {730,0.000037559}, {735,0.000046948}, {740,0.000056338}, {745,0.000065728}, {750,0.000089202}, {755,0.000075117}, {760,0.000037559}, {765,0.000056338}, {770,0.000056338}, {775,0.000000000}, {780,0.000037559}, {785,0.000018779}, {790,0.000018779}, {795,0.000032864}, {800,0.000070423}, {805,0.000018779}, {810,0.000028169}, {815,0.000075117}, {820,0.000131455}, {825,0.000037559}, {830,0.000046948}, {835,0.000056338}, {840,0.000000000}, {845,0.000037559}, {850,0.000051643}, {855,0.000070423}, {860,0.000056338}, {865,0.000075117}, {870,0.000103286}, {875,0.000056338}, {880,0.000051643}, {885,0.000084507}, {890,0.000018779}, {895,0.000056338}, {900,0.000056338}, {905,0.000032864}, {910,0.000070423}, {915,0.000032864}, {920,0.000051643}, {925,0.000032864}, {930,0.000089202}, {935,0.000037559}, {940,0.000051643}, {945,0.000089202}, {950,0.000070423}, {955,0.000032864}, {960,0.000000000}, {965,0.000051643}, {970,0.000018779}, {975,0.000037559}, {980,0.000056338}, {985,0.000018779}, {990,0.000056338}, {995,0.000037559}, {1000,0.000056338}, {1010,0.000037559}, {1020,0.000075117}, {1030,0.000056338}, {1040,0.000018779}, {1050,0.000056338}, {1060,0.000032864}, {1070,0.000037559}, {1080,0.000112676}, {1090,0.000037559}, {1100,0.000089202}, {1110,0.000000000}, {1120,0.000150235}, {1130,0.000093897}, {1140,0.000037559}, {1150,0.000037559}, {1160,0.000051643}, {1170,0.000065728}, {1180,0.000037559}, {1190,0.000056338}, {1200,0.000107981}, {1210,0.000089202}, {1220,0.000037559}, {1230,0.000051643}, {1240,0.000089202}, {1250,0.000225352}, {1260,0.000070423}, {1270,0.000056338}, {1280,0.000014085}, {1290,0.000093897}, {1300,0.000056338}, {1310,0.000126761}, {1320,0.000018779}, {1330,0.000093897}, {1340,0.000093897}, {1350,0.000145540}, {1360,0.000126761}, {1370,0.000126761}, {1380,0.000000000}, {1390,0.000065728}, {1400,0.000122066}, {1410,0.000126761}, {1420,0.000046948}, {1430,0.000112676}, {1440,0.000131455}, {1450,0.000018779}, {1460,0.000037559}, {1470,0.000037559}, {1480,0.000107981}, {1490,0.000056338}, {1500,0.000122066}, {1510,0.001154}, {1520,0.000846}, {1530,0.001846}, {1540,0.000308}, {1550,0.001231}, {1560,0.000615}, {1570,0.000308}, {1580,0.000923}, {1590,0.001154}, {1600,0.000000}, {1610,0.000923}, {1620,0.001462}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000000}, {1680,0.000000}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000000}, {1730,0.000000}, {1740,0.000538}, {1750,0.000000}, {1760,0.000000}, {1770,0.000000}, {1780,0.000000}, {1790,0.000308}, {1800,0.000000}, {1810,0.000231}, {1820,0.000308}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000538}, {1900,0.000308}, {1910,0.000308}, {1920,0.000000}, {1930,0.000308}, {1940,0.000000}, {1950,0.000000}, {1960,0.000000}, {1970,0.000000}, {1980,0.000308}, {1990,0.000000}, {2000,0.000308}, {2050,0.000000}, {2100,0.000000}, {2150,0.000000}, {2200,0.000000}, {2250,0.000000}, {2300,0.000000}, {2350,0.000308}, {2400,0.000000}, {2450,0.000615}, {2500,0.000000}, {2550,0.000615}, {2600,0.000308}, {2650,0.000000}, {2700,0.000538}, {2750,0.000615}, {2800,0.000000}, {2850,0.000538}, {2900,0.000308}, {2950,0.000308}, {3000,0.000538}, {3050,0.000000}, {3100,0.000615}, {3150,0.000000}, {3200,0.000615}, {3250,0.000000}, {3300,0.001231}, {3350,0.003077}, {3400,0.000000}, {3450,0.000000}, {3500,0.000000}, {3550,0.000000}, {3600,0.000615}, {3650,0.000615}, {3700,0.000615}, {3750,0.000308}, {3800,0.000000}, {3850,0.000538}, {3900,0.000000}, {3950,0.000923}, {4000,0.000923}, {4050,0.000308}, {4100,0.000923}, {4150,0.000000}, {4200,0.000308}, {4250,0.000308}, {4300,0.000923}, {4350,0.000615}, {4400,0.000000}, {4450,0.000923}, {4500,0.000615}, {4550,0.000000}, {4600,0.000923}, {4650,0.000846}, {4700,0.000923}, {4750,0.000308}, {4800,0.000000}, {4850,0.000538}, {4900,0.000923}, {4950,0.000308}, {5000,0.000308}, {5050,0.001231}, {5100,0.000615}, {5150,0.001154}, {5200,0.001231}, {5250,0.000615}, {5300,0.001154}, {5350,0.002385}, {5400,0.001538}, {5450,0.002385}, {5500,0.000308}, {5550,0.000308}, {5600,0.001231}, {5650,0.001538}, {5700,0.000923}, {5750,0.001231}, {5800,0.001846}, {5850,0.002077}, {5900,0.000923}, {5950,0.001538}, {6000,0.002077}, {6050,0.001154}, {6100,0.002769}, {6150,0.001462}, {6200,0.002385}, {6250,0.001538}, {6300,0.001538}, {6350,0.002769}, {6400,0.002385}, {6450,0.002308}, {6500,0.001538}, {6550,0.000615}, {6600,0.002154}, {6650,0.003308}, {6700,0.002000}, {6750,0.001846}, {6800,0.003923}, {6850,0.006077}, {6900,0.002308}, {6950,0.003692}, {7000,0.003000}, {7050,0.003692}, {7100,0.001538}, {7150,0.003615}, {7200,0.002462}, {7250,0.002462}, {7300,0.003231}, {7350,0.002462}, {7400,0.007308}, {7450,0.005769}, {7500,0.007231}, {7550,0.004846}, {7600,0.005077}, {7650,0.006231}, {7700,0.002692}, {7750,0.004615}, {7800,0.005769}, {7850,0.004385}, {7900,0.005769}, {7950,0.003923}, {8000,0.008615}, {8050,0.006077}, {8100,0.002385}, {8150,0.003154}, {8200,0.001538}, {8250,0.003692}, {8300,0.002462}, {8350,0.001538}, {8400,0.003385}, {8450,0.001231}, {8500,0.000615}, {8550,0.001769}, {8600,0.001846}, {8650,0.001462}, {8700,0.004308}, {8750,0.002385}, {8800,0.003923}, {8850,0.005385}, {8900,0.004308}, {8950,0.006154}, {9000,0.006462}, {9050,0.004846}, {9100,0.031692}, {9150,0.006615}, {9200,0.003692}, {9250,0.003538}, {9300,0.005231}, {9350,0.005077}, {9400,0.004923}, {9450,0.003923}, {9500,0.005154}, {9550,0.006077}, {9600,0.005462}, {9650,0.008000}, {9700,0.004385}, {9750,0.009538}, {9800,0.005538}, {9850,0.006692}, {9900,0.003231}, {9950,0.005538}, {10000,0.006154}};
data["big_flat"]["Mtac2"]["post"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000}, {1520,0.000000}, {1530,0.000000}, {1540,0.000000}, {1550,0.000000}, {1560,0.000000}, {1570,0.000000}, {1580,0.000000}, {1590,0.000000}, {1600,0.000000}, {1610,0.000000}, {1620,0.000000}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000000}, {1680,0.000000}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000000}, {1730,0.000000}, {1740,0.000000}, {1750,0.000000}, {1760,0.000000}, {1770,0.000000}, {1780,0.000000}, {1790,0.000000}, {1800,0.000000}, {1810,0.000000}, {1820,0.000000}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000000}, {1900,0.000000}, {1910,0.000000}, {1920,0.000000}, {1930,0.000000}, {1940,0.000000}, {1950,0.000000}, {1960,0.000000}, {1970,0.000000}, {1980,0.000000}, {1990,0.000000}, {2000,0.000000}, {2050,0.000000}, {2100,0.000000}, {2150,0.000000}, {2200,0.000000}, {2250,0.000000}, {2300,0.000000}, {2350,0.000000}, {2400,0.000000}, {2450,0.000000}, {2500,0.000000}, {2550,0.000000}, {2600,0.000000}, {2650,0.000000}, {2700,0.000000}, {2750,0.000000}, {2800,0.000000}, {2850,0.000000}, {2900,0.000000}, {2950,0.000000}, {3000,0.000000}, {3050,0.000000}, {3100,0.000000}, {3150,0.000000}, {3200,0.000000}, {3250,0.000000}, {3300,0.000000}, {3350,0.000000}, {3400,0.000000}, {3450,0.000000}, {3500,0.000000}, {3550,0.000000}, {3600,0.000000}, {3650,0.000000}, {3700,0.000000}, {3750,0.000000}, {3800,0.000000}, {3850,0.000000}, {3900,0.000000}, {3950,0.000000}, {4000,0.000000}, {4050,0.000000}, {4100,0.000000}, {4150,0.000000}, {4200,0.000000}, {4250,0.000000}, {4300,0.000000}, {4350,0.000000}, {4400,0.000000}, {4450,0.000000}, {4500,0.000000}, {4550,0.000000}, {4600,0.000000}, {4650,0.000000}, {4700,0.000000}, {4750,0.000000}, {4800,0.000000}, {4850,0.000000}, {4900,0.000000}, {4950,0.000000}, {5000,0.000000}, {5050,0.000000}, {5100,0.000000}, {5150,0.000000}, {5200,0.000000}, {5250,0.000000}, {5300,0.000000}, {5350,0.000000}, {5400,0.000000}, {5450,0.000000}, {5500,0.000000}, {5550,0.000000}, {5600,0.000000}, {5650,0.000000}, {5700,0.000000}, {5750,0.000000}, {5800,0.000000}, {5850,0.000000}, {5900,0.000000}, {5950,0.000000}, {6000,0.000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}};
data["big_flat"]["Mtac2"]["post"]["user"] = {{1,0.000018779}, {2,0.000037559}, {3,0.000000000}, {4,0.000018779}, {5,0.000000000}, {6,0.000093897}, {7,0.000000000}, {8,0.000037559}, {9,0.000018779}, {10,0.000037559}, {11,0.000037559}, {12,0.000037559}, {13,0.000018779}, {14,0.000093897}, {15,0.000056338}, {16,0.000018779}, {17,0.000093897}, {18,0.000018779}, {19,0.000075117}, {20,0.000037559}, {21,0.000037559}, {22,0.000037559}, {23,0.000000000}, {24,0.000018779}, {25,0.000056338}, {26,0.000018779}, {27,0.000037559}, {28,0.000018779}, {29,0.000070423}, {30,0.000084507}, {31,0.000056338}, {32,0.000051643}, {33,0.000032864}, {34,0.000000000}, {35,0.000046948}, {36,0.000018779}, {37,0.000014085}, {38,0.000084507}, {39,0.000018779}, {40,0.000079812}, {41,0.000014085}, {42,0.000051643}, {43,0.000018779}, {44,0.000032864}, {45,0.000056338}, {46,0.000028169}, {47,0.000070423}, {48,0.000042254}, {49,0.000018779}, {50,0.000018779}, {51,0.000028169}, {52,0.000018779}, {53,0.000037559}, {54,0.000014085}, {55,0.000056338}, {56,0.000000000}, {57,0.000018779}, {58,0.000000000}, {59,0.000018779}, {60,0.000014085}, {61,0.000018779}, {62,0.000056338}, {63,0.000037559}, {64,0.000000000}, {65,0.000018779}, {66,0.000018779}, {67,0.000037559}, {68,0.000056338}, {69,0.000018779}, {70,0.000037559}, {71,0.000018779}, {72,0.000037559}, {73,0.000037559}, {74,0.000075117}, {75,0.000000000}, {76,0.000056338}, {77,0.000056338}, {78,0.000037559}, {79,0.000037559}, {80,0.000000000}, {81,0.000056338}, {82,0.000056338}, {83,0.000056338}, {84,0.000037559}, {85,0.000075117}, {86,0.000018779}, {87,0.000037559}, {88,0.000018779}, {89,0.000037559}, {90,0.000000000}, {91,0.000037559}, {92,0.000000000}, {93,0.000056338}, {94,0.000037559}, {95,0.000014085}, {96,0.000018779}, {97,0.000018779}, {98,0.000018779}, {99,0.000051643}, {100,0.000032864}, {101,0.000032864}, {102,0.000000000}, {103,0.000000000}, {104,0.000037559}, {105,0.000037559}, {106,0.000037559}, {107,0.000056338}, {108,0.000037559}, {109,0.000018779}, {110,0.000075117}, {111,0.000000000}, {112,0.000032864}, {113,0.000018779}, {114,0.000018779}, {115,0.000037559}, {116,0.000018779}, {117,0.000018779}, {118,0.000056338}, {119,0.000037559}, {120,0.000037559}, {121,0.000018779}, {122,0.000037559}, {123,0.000018779}, {124,0.000032864}, {125,0.000051643}, {126,0.000032864}, {127,0.000037559}, {128,0.000051643}, {129,0.000018779}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000037559}, {134,0.000018779}, {135,0.000018779}, {136,0.000018779}, {137,0.000037559}, {138,0.000056338}, {139,0.000032864}, {140,0.000000000}, {141,0.000018779}, {142,0.000037559}, {143,0.000032864}, {144,0.000051643}, {145,0.000037559}, {146,0.000037559}, {147,0.000032864}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000018779}, {152,0.000051643}, {153,0.000018779}, {154,0.000014085}, {155,0.000014085}, {156,0.000018779}, {157,0.000065728}, {158,0.000000000}, {159,0.000032864}, {160,0.000014085}, {161,0.000037559}, {162,0.000070423}, {163,0.000032864}, {164,0.000014085}, {165,0.000032864}, {166,0.000046948}, {167,0.000014085}, {168,0.000061033}, {169,0.000051643}, {170,0.000032864}, {171,0.000000000}, {172,0.000056338}, {173,0.000000000}, {174,0.000000000}, {175,0.000018779}, {176,0.000018779}, {177,0.000032864}, {178,0.000000000}, {179,0.000032864}, {180,0.000000000}, {181,0.000014085}, {182,0.000032864}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000032864}, {188,0.000000000}, {189,0.000061033}, {190,0.000018779}, {191,0.000056338}, {192,0.000014085}, {193,0.000032864}, {194,0.000014085}, {195,0.000046948}, {196,0.000075117}, {197,0.000018779}, {198,0.000018779}, {199,0.000126761}, {200,0.000028169}, {201,0.000032864}, {202,0.000018779}, {203,0.000014085}, {204,0.000032864}, {205,0.000037559}, {206,0.000037559}, {207,0.000037559}, {208,0.000018779}, {209,0.000065728}, {210,0.000032864}, {211,0.000000000}, {212,0.000000000}, {213,0.000046948}, {214,0.000046948}, {215,0.000014085}, {216,0.000051643}, {217,0.000037559}, {218,0.000028169}, {219,0.000014085}, {220,0.000046948}, {221,0.000000000}, {222,0.000018779}, {223,0.000014085}, {224,0.000014085}, {225,0.000000000}, {226,0.000065728}, {227,0.000032864}, {228,0.000000000}, {229,0.000056338}, {230,0.000046948}, {231,0.000032864}, {232,0.000028169}, {233,0.000018779}, {234,0.000018779}, {235,0.000018779}, {236,0.000018779}, {237,0.000018779}, {238,0.000028169}, {239,0.000014085}, {240,0.000032864}, {241,0.000037559}, {242,0.000018779}, {243,0.000018779}, {244,0.000046948}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000018779}, {249,0.000018779}, {250,0.000032864}, {251,0.000056338}, {252,0.000014085}, {253,0.000014085}, {254,0.000042254}, {255,0.000051643}, {256,0.000000000}, {257,0.000014085}, {258,0.000070423}, {259,0.000042254}, {260,0.000079812}, {261,0.000028169}, {262,0.000028169}, {263,0.000056338}, {264,0.000018779}, {265,0.000070423}, {266,0.000042254}, {267,0.000051643}, {268,0.000032864}, {269,0.000018779}, {270,0.000018779}, {271,0.000000000}, {272,0.000028169}, {273,0.000032864}, {274,0.000028169}, {275,0.000000000}, {276,0.000032864}, {277,0.000032864}, {278,0.000018779}, {279,0.000079812}, {280,0.000000000}, {281,0.000056338}, {282,0.000061033}, {283,0.000000000}, {284,0.000000000}, {285,0.000018779}, {286,0.000014085}, {287,0.000042254}, {288,0.000056338}, {289,0.000018779}, {290,0.000014085}, {291,0.000042254}, {292,0.000014085}, {293,0.000046948}, {294,0.000046948}, {295,0.000042254}, {296,0.000028169}, {297,0.000046948}, {298,0.000014085}, {299,0.000000000}, {300,0.000014085}, {301,0.000000000}, {302,0.000014085}, {303,0.000028169}, {304,0.000028169}, {305,0.000014085}, {306,0.000042254}, {307,0.000014085}, {308,0.000018779}, {309,0.000028169}, {310,0.000028169}, {311,0.000089202}, {312,0.000028169}, {313,0.000000000}, {314,0.000046948}, {315,0.000014085}, {316,0.000000000}, {317,0.000032864}, {318,0.000014085}, {319,0.000014085}, {320,0.000046948}, {321,0.000042254}, {322,0.000079812}, {323,0.000014085}, {324,0.000014085}, {325,0.000084507}, {326,0.000028169}, {327,0.000046948}, {328,0.000028169}, {329,0.000000000}, {330,0.000037559}, {331,0.000014085}, {332,0.000032864}, {333,0.000028169}, {334,0.000032864}, {335,0.000061033}, {336,0.000061033}, {337,0.000032864}, {338,0.000084507}, {339,0.000028169}, {340,0.000014085}, {341,0.000028169}, {342,0.000032864}, {343,0.000000000}, {344,0.000046948}, {345,0.000046948}, {346,0.000028169}, {347,0.000000000}, {348,0.000014085}, {349,0.000046948}, {350,0.000032864}, {351,0.000037559}, {352,0.000046948}, {353,0.000046948}, {354,0.000000000}, {355,0.000014085}, {356,0.000018779}, {357,0.000032864}, {358,0.000046948}, {359,0.000000000}, {360,0.000028169}, {361,0.000000000}, {362,0.000014085}, {363,0.000070423}, {364,0.000000000}, {365,0.000000000}, {366,0.000014085}, {367,0.000046948}, {368,0.000028169}, {369,0.000000000}, {370,0.000028169}, {371,0.000028169}, {372,0.000028169}, {373,0.000000000}, {374,0.000028169}, {375,0.000046948}, {376,0.000037559}, {377,0.000032864}, {378,0.000032864}, {379,0.000014085}, {380,0.000014085}, {381,0.000018779}, {382,0.000000000}, {383,0.000032864}, {384,0.000042254}, {385,0.000032864}, {386,0.000037559}, {387,0.000000000}, {388,0.000000000}, {389,0.000018779}, {390,0.000000000}, {391,0.000018779}, {392,0.000000000}, {393,0.000032864}, {394,0.000037559}, {395,0.000070423}, {396,0.000000000}, {397,0.000051643}, {398,0.000051643}, {399,0.000014085}, {400,0.000051643}, {401,0.000037559}, {402,0.000032864}, {403,0.000070423}, {404,0.000018779}, {405,0.000000000}, {406,0.000000000}, {407,0.000046948}, {408,0.000056338}, {409,0.000051643}, {410,0.000000000}, {411,0.000018779}, {412,0.000046948}, {413,0.000000000}, {414,0.000028169}, {415,0.000028169}, {416,0.000032864}, {417,0.000037559}, {418,0.000014085}, {419,0.000056338}, {420,0.000037559}, {421,0.000014085}, {422,0.000014085}, {423,0.000000000}, {424,0.000051643}, {425,0.000032864}, {426,0.000014085}, {427,0.000046948}, {428,0.000079812}, {429,0.000046948}, {430,0.000018779}, {431,0.000051643}, {432,0.000018779}, {433,0.000037559}, {434,0.000000000}, {435,0.000000000}, {436,0.000032864}, {437,0.000065728}, {438,0.000046948}, {439,0.000018779}, {440,0.000014085}, {441,0.000018779}, {442,0.000051643}, {443,0.000032864}, {444,0.000000000}, {445,0.000070423}, {446,0.000014085}, {447,0.000037559}, {448,0.000070423}, {449,0.000000000}, {450,0.000051643}, {451,0.000000000}, {452,0.000075117}, {453,0.000000000}, {454,0.000014085}, {455,0.000051643}, {456,0.000032864}, {457,0.000014085}, {458,0.000065728}, {459,0.000056338}, {460,0.000014085}, {461,0.000018779}, {462,0.000061033}, {463,0.000018779}, {464,0.000018779}, {465,0.000000000}, {466,0.000046948}, {467,0.000018779}, {468,0.000014085}, {469,0.000051643}, {470,0.000032864}, {471,0.000037559}, {472,0.000014085}, {473,0.000046948}, {474,0.000018779}, {475,0.000051643}, {476,0.000014085}, {477,0.000037559}, {478,0.000051643}, {479,0.000042254}, {480,0.000032864}, {481,0.000032864}, {482,0.000032864}, {483,0.000000000}, {484,0.000032864}, {485,0.000070423}, {486,0.000032864}, {487,0.000032864}, {488,0.000046948}, {489,0.000037559}, {490,0.000079812}, {491,0.000014085}, {492,0.000014085}, {493,0.000000000}, {494,0.000032864}, {495,0.000032864}, {496,0.000018779}, {497,0.000037559}, {498,0.000000000}, {499,0.000018779}, {500,0.000000000}, {505,0.000051643}, {510,0.000051643}, {515,0.000014085}, {520,0.000014085}, {525,0.000000000}, {530,0.000075117}, {535,0.000061033}, {540,0.000000000}, {545,0.000028169}, {550,0.000056338}, {555,0.000028169}, {560,0.000051643}, {565,0.000018779}, {570,0.000046948}, {575,0.000056338}, {580,0.000032864}, {585,0.000042254}, {590,0.000056338}, {595,0.000000000}, {600,0.000042254}, {605,0.000000000}, {610,0.000046948}, {615,0.000018779}, {620,0.000014085}, {625,0.000014085}, {630,0.000061033}, {635,0.000014085}, {640,0.000032864}, {645,0.000000000}, {650,0.000046948}, {655,0.000028169}, {660,0.000000000}, {665,0.000032864}, {670,0.000042254}, {675,0.000061033}, {680,0.000018779}, {685,0.000056338}, {690,0.000018779}, {695,0.000042254}, {700,0.000046948}, {705,0.000028169}, {710,0.000018779}, {715,0.000014085}, {720,0.000014085}, {725,0.000084507}, {730,0.000014085}, {735,0.000056338}, {740,0.000018779}, {745,0.000014085}, {750,0.000028169}, {755,0.000014085}, {760,0.000032864}, {765,0.000042254}, {770,0.000037559}, {775,0.000046948}, {780,0.000014085}, {785,0.000014085}, {790,0.000037559}, {795,0.000018779}, {800,0.000061033}, {805,0.000014085}, {810,0.000018779}, {815,0.000014085}, {820,0.000014085}, {825,0.000046948}, {830,0.000065728}, {835,0.000032864}, {840,0.000046948}, {845,0.000065728}, {850,0.000014085}, {855,0.000028169}, {860,0.000014085}, {865,0.000000000}, {870,0.000000000}, {875,0.000061033}, {880,0.000061033}, {885,0.000018779}, {890,0.000000000}, {895,0.000028169}, {900,0.000000000}, {905,0.000046948}, {910,0.000014085}, {915,0.000018779}, {920,0.000061033}, {925,0.000056338}, {930,0.000051643}, {935,0.000018779}, {940,0.000000000}, {945,0.000018779}, {950,0.000014085}, {955,0.000014085}, {960,0.000000000}, {965,0.000042254}, {970,0.000018779}, {975,0.000000000}, {980,0.000061033}, {985,0.000000000}, {990,0.000018779}, {995,0.000046948}, {1000,0.000000000}, {1010,0.000032864}, {1020,0.000051643}, {1030,0.000051643}, {1040,0.000037559}, {1050,0.000046948}, {1060,0.000037559}, {1070,0.000014085}, {1080,0.000037559}, {1090,0.000018779}, {1100,0.000032864}, {1110,0.000056338}, {1120,0.000075117}, {1130,0.000065728}, {1140,0.000018779}, {1150,0.000056338}, {1160,0.000032864}, {1170,0.000014085}, {1180,0.000061033}, {1190,0.000107981}, {1200,0.000037559}, {1210,0.000037559}, {1220,0.000028169}, {1230,0.000018779}, {1240,0.000014085}, {1250,0.000000000}, {1260,0.000089202}, {1270,0.000000000}, {1280,0.000032864}, {1290,0.000032864}, {1300,0.000037559}, {1310,0.000000000}, {1320,0.000037559}, {1330,0.000018779}, {1340,0.000014085}, {1350,0.000000000}, {1360,0.000046948}, {1370,0.000056338}, {1380,0.000032864}, {1390,0.000037559}, {1400,0.000014085}, {1410,0.000018779}, {1420,0.000070423}, {1430,0.000032864}, {1440,0.000056338}, {1450,0.000075117}, {1460,0.000032864}, {1470,0.000032864}, {1480,0.000032864}, {1490,0.000056338}, {1500,0.000018779}, {1510,0.000000}, {1520,0.000000}, {1530,0.000000}, {1540,0.000000}, {1550,0.000000}, {1560,0.000000}, {1570,0.000000}, {1580,0.000000}, {1590,0.000000}, {1600,0.000000}, {1610,0.000000}, {1620,0.000000}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000000}, {1680,0.000000}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000000}, {1730,0.000000}, {1740,0.000000}, {1750,0.000000}, {1760,0.000000}, {1770,0.000000}, {1780,0.000000}, {1790,0.000000}, {1800,0.000000}, {1810,0.000000}, {1820,0.000000}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000000}, {1900,0.000308}, {1910,0.000000}, {1920,0.000000}, {1930,0.000000}, {1940,0.000000}, {1950,0.000000}, {1960,0.000000}, {1970,0.000000}, {1980,0.000000}, {1990,0.000308}, {2000,0.000000}, {2050,0.000000}, {2100,0.000308}, {2150,0.000000}, {2200,0.000000}, {2250,0.000000}, {2300,0.000000}, {2350,0.000231}, {2400,0.000000}, {2450,0.000000}, {2500,0.000000}, {2550,0.000000}, {2600,0.000000}, {2650,0.000000}, {2700,0.000000}, {2750,0.000308}, {2800,0.000000}, {2850,0.000923}, {2900,0.000231}, {2950,0.000231}, {3000,0.000000}, {3050,0.000308}, {3100,0.000000}, {3150,0.000000}, {3200,0.000000}, {3250,0.000000}, {3300,0.000000}, {3350,0.000000}, {3400,0.000000}, {3450,0.000000}, {3500,0.000000}, {3550,0.000000}, {3600,0.000000}, {3650,0.000000}, {3700,0.000000}, {3750,0.000000}, {3800,0.000000}, {3850,0.000231}, {3900,0.000000}, {3950,0.000000}, {4000,0.000000}, {4050,0.000000}, {4100,0.000000}, {4150,0.000000}, {4200,0.000000}, {4250,0.000000}, {4300,0.000615}, {4350,0.000000}, {4400,0.000000}, {4450,0.000000}, {4500,0.000308}, {4550,0.000000}, {4600,0.000000}, {4650,0.000000}, {4700,0.000000}, {4750,0.000000}, {4800,0.000000}, {4850,0.000000}, {4900,0.000000}, {4950,0.000000}, {5000,0.000000}, {5050,0.000000}, {5100,0.000000}, {5150,0.000000}, {5200,0.000000}, {5250,0.000000}, {5300,0.000000}, {5350,0.000000}, {5400,0.000000}, {5450,0.000000}, {5500,0.000308}, {5550,0.000000}, {5600,0.000000}, {5650,0.000308}, {5700,0.000000}, {5750,0.000000}, {5800,0.000000}, {5850,0.000000}, {5900,0.000000}, {5950,0.000000}, {6000,0.000000}, {6050,0.000308}, {6100,0.000000}, {6150,0.000000}, {6200,0.000308}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000308}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000308}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000231}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000231}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000231}, {9950,0.000000}, {10000,0.000231}};
data["big_flat"]["Mtac2"]["post"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000014085}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000018779}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000018779}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000018779}, {70,0.000000000}, {71,0.000000000}, {72,0.000018779}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000018779}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000018779}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000018779}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000018779}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000014085}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000014085}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000018779}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000018779}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000018779}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000018779}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000018779}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000014085}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000037559}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000018779}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000018779}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000018779}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000018779}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000018779}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000}, {1520,0.000000}, {1530,0.000000}, {1540,0.000000}, {1550,0.000000}, {1560,0.000000}, {1570,0.000000}, {1580,0.000000}, {1590,0.000000}, {1600,0.000000}, {1610,0.000000}, {1620,0.000000}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000000}, {1680,0.000000}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000000}, {1730,0.000000}, {1740,0.000000}, {1750,0.000000}, {1760,0.000000}, {1770,0.000000}, {1780,0.000000}, {1790,0.000000}, {1800,0.000000}, {1810,0.000000}, {1820,0.000000}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000000}, {1900,0.000000}, {1910,0.000000}, {1920,0.000000}, {1930,0.000000}, {1940,0.000000}, {1950,0.000000}, {1960,0.000000}, {1970,0.000000}, {1980,0.000000}, {1990,0.000000}, {2000,0.000000}, {2050,0.000000}, {2100,0.000000}, {2150,0.000000}, {2200,0.000000}, {2250,0.000000}, {2300,0.000000}, {2350,0.000000}, {2400,0.000000}, {2450,0.000000}, {2500,0.000000}, {2550,0.000000}, {2600,0.000000}, {2650,0.000000}, {2700,0.000000}, {2750,0.000000}, {2800,0.000000}, {2850,0.000000}, {2900,0.000000}, {2950,0.000000}, {3000,0.000000}, {3050,0.000000}, {3100,0.000000}, {3150,0.000000}, {3200,0.000000}, {3250,0.000000}, {3300,0.000000}, {3350,0.000000}, {3400,0.000000}, {3450,0.000000}, {3500,0.000000}, {3550,0.000000}, {3600,0.000000}, {3650,0.000000}, {3700,0.000000}, {3750,0.000000}, {3800,0.000000}, {3850,0.000000}, {3900,0.000000}, {3950,0.000000}, {4000,0.000000}, {4050,0.000000}, {4100,0.000000}, {4150,0.000000}, {4200,0.000000}, {4250,0.000000}, {4300,0.000000}, {4350,0.000000}, {4400,0.000000}, {4450,0.000000}, {4500,0.000000}, {4550,0.000000}, {4600,0.000000}, {4650,0.000000}, {4700,0.000000}, {4750,0.000000}, {4800,0.000000}, {4850,0.000000}, {4900,0.000000}, {4950,0.000000}, {5000,0.000000}, {5050,0.000000}, {5100,0.000000}, {5150,0.000000}, {5200,0.000000}, {5250,0.000000}, {5300,0.000000}, {5350,0.000000}, {5400,0.000000}, {5450,0.000000}, {5500,0.000000}, {5550,0.000000}, {5600,0.000000}, {5650,0.000000}, {5700,0.000000}, {5750,0.000000}, {5800,0.000000}, {5850,0.000000}, {5900,0.000000}, {5950,0.000000}, {6000,0.000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}};
data["big_flat"]["Mtac2"]["pre"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000}, {1520,0.000000}, {1530,0.000000}, {1540,0.000000}, {1550,0.000000}, {1560,0.000000}, {1570,0.000000}, {1580,0.000000}, {1590,0.000000}, {1600,0.000000}, {1610,0.000000}, {1620,0.000000}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000000}, {1680,0.000000}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000000}, {1730,0.000000}, {1740,0.000000}, {1750,0.000000}, {1760,0.000000}, {1770,0.000000}, {1780,0.000000}, {1790,0.000000}, {1800,0.000000}, {1810,0.000000}, {1820,0.000000}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000000}, {1900,0.000000}, {1910,0.000000}, {1920,0.000000}, {1930,0.000000}, {1940,0.000000}, {1950,0.000000}, {1960,0.000000}, {1970,0.000000}, {1980,0.000000}, {1990,0.000000}, {2000,0.000000}, {2050,0.000000}, {2100,0.000000}, {2150,0.000000}, {2200,0.000000}, {2250,0.000000}, {2300,0.000000}, {2350,0.000000}, {2400,0.000000}, {2450,0.000000}, {2500,0.000000}, {2550,0.000000}, {2600,0.000000}, {2650,0.000000}, {2700,0.000000}, {2750,0.000000}, {2800,0.000000}, {2850,0.000000}, {2900,0.000000}, {2950,0.000000}, {3000,0.000000}, {3050,0.000000}, {3100,0.000000}, {3150,0.000000}, {3200,0.000000}, {3250,0.000000}, {3300,0.000000}, {3350,0.000000}, {3400,0.000000}, {3450,0.000000}, {3500,0.000000}, {3550,0.000000}, {3600,0.000000}, {3650,0.000000}, {3700,0.000000}, {3750,0.000000}, {3800,0.000000}, {3850,0.000000}, {3900,0.000000}, {3950,0.000000}, {4000,0.000000}, {4050,0.000000}, {4100,0.000000}, {4150,0.000000}, {4200,0.000000}, {4250,0.000000}, {4300,0.000000}, {4350,0.000000}, {4400,0.000000}, {4450,0.000000}, {4500,0.000000}, {4550,0.000000}, {4600,0.000000}, {4650,0.000000}, {4700,0.000000}, {4750,0.000000}, {4800,0.000000}, {4850,0.000000}, {4900,0.000000}, {4950,0.000000}, {5000,0.000000}, {5050,0.000000}, {5100,0.000000}, {5150,0.000000}, {5200,0.000000}, {5250,0.000000}, {5300,0.000000}, {5350,0.000000}, {5400,0.000000}, {5450,0.000000}, {5500,0.000000}, {5550,0.000000}, {5600,0.000000}, {5650,0.000000}, {5700,0.000000}, {5750,0.000000}, {5800,0.000000}, {5850,0.000000}, {5900,0.000000}, {5950,0.000000}, {6000,0.000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}};
data["big_flat"]["Mtac2"]["pre"]["user"] = {{1,0.000000000}, {2,0.000018779}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000018779}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000018779}, {17,0.000018779}, {18,0.000000000}, {19,0.000018779}, {20,0.000000000}, {21,0.000000000}, {22,0.000037559}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000018779}, {27,0.000014085}, {28,0.000000000}, {29,0.000018779}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000032864}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000018779}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000028169}, {44,0.000000000}, {45,0.000000000}, {46,0.000014085}, {47,0.000000000}, {48,0.000000000}, {49,0.000014085}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000014085}, {54,0.000000000}, {55,0.000018779}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000018779}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000037559}, {79,0.000018779}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000018779}, {84,0.000000000}, {85,0.000000000}, {86,0.000018779}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000018779}, {91,0.000000000}, {92,0.000018779}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000018779}, {101,0.000000000}, {102,0.000000000}, {103,0.000014085}, {104,0.000000000}, {105,0.000000000}, {106,0.000018779}, {107,0.000000000}, {108,0.000037559}, {109,0.000018779}, {110,0.000018779}, {111,0.000000000}, {112,0.000000000}, {113,0.000018779}, {114,0.000018779}, {115,0.000000000}, {116,0.000018779}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000018779}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000018779}, {127,0.000000000}, {128,0.000000000}, {129,0.000018779}, {130,0.000000000}, {131,0.000028169}, {132,0.000018779}, {133,0.000014085}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000018779}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000032864}, {153,0.000000000}, {154,0.000000000}, {155,0.000018779}, {156,0.000000000}, {157,0.000014085}, {158,0.000018779}, {159,0.000032864}, {160,0.000014085}, {161,0.000014085}, {162,0.000014085}, {163,0.000014085}, {164,0.000000000}, {165,0.000018779}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000014085}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000018779}, {178,0.000032864}, {179,0.000000000}, {180,0.000014085}, {181,0.000000000}, {182,0.000014085}, {183,0.000000000}, {184,0.000000000}, {185,0.000018779}, {186,0.000000000}, {187,0.000000000}, {188,0.000014085}, {189,0.000018779}, {190,0.000018779}, {191,0.000000000}, {192,0.000000000}, {193,0.000014085}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000018779}, {199,0.000000000}, {200,0.000018779}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000014085}, {207,0.000018779}, {208,0.000032864}, {209,0.000000000}, {210,0.000014085}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000014085}, {216,0.000000000}, {217,0.000000000}, {218,0.000014085}, {219,0.000000000}, {220,0.000018779}, {221,0.000000000}, {222,0.000018779}, {223,0.000018779}, {224,0.000000000}, {225,0.000014085}, {226,0.000018779}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000014085}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000018779}, {241,0.000000000}, {242,0.000014085}, {243,0.000014085}, {244,0.000000000}, {245,0.000000000}, {246,0.000014085}, {247,0.000018779}, {248,0.000014085}, {249,0.000000000}, {250,0.000000000}, {251,0.000014085}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000014085}, {259,0.000000000}, {260,0.000000000}, {261,0.000014085}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000014085}, {266,0.000014085}, {267,0.000000000}, {268,0.000014085}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000018779}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000014085}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000014085}, {289,0.000000000}, {290,0.000018779}, {291,0.000018779}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000018779}, {296,0.000028169}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000018779}, {302,0.000014085}, {303,0.000000000}, {304,0.000032864}, {305,0.000014085}, {306,0.000000000}, {307,0.000014085}, {308,0.000028169}, {309,0.000000000}, {310,0.000014085}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000028169}, {315,0.000000000}, {316,0.000014085}, {317,0.000000000}, {318,0.000028169}, {319,0.000000000}, {320,0.000014085}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000014085}, {333,0.000000000}, {334,0.000014085}, {335,0.000000000}, {336,0.000000000}, {337,0.000018779}, {338,0.000000000}, {339,0.000000000}, {340,0.000018779}, {341,0.000000000}, {342,0.000014085}, {343,0.000000000}, {344,0.000014085}, {345,0.000000000}, {346,0.000014085}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000014085}, {353,0.000018779}, {354,0.000000000}, {355,0.000000000}, {356,0.000014085}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000014085}, {366,0.000014085}, {367,0.000000000}, {368,0.000018779}, {369,0.000014085}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000014085}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000028169}, {391,0.000000000}, {392,0.000000000}, {393,0.000018779}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000018779}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000018779}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000014085}, {411,0.000000000}, {412,0.000028169}, {413,0.000018779}, {414,0.000000000}, {415,0.000014085}, {416,0.000000000}, {417,0.000018779}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000018779}, {425,0.000014085}, {426,0.000000000}, {427,0.000000000}, {428,0.000037559}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000018779}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000014085}, {437,0.000018779}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000018779}, {442,0.000000000}, {443,0.000037559}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000018779}, {454,0.000018779}, {455,0.000037559}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000018779}, {460,0.000018779}, {461,0.000000000}, {462,0.000018779}, {463,0.000000000}, {464,0.000018779}, {465,0.000032864}, {466,0.000018779}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000018779}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000018779}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000018779}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000032864}, {560,0.000000000}, {565,0.000018779}, {570,0.000000000}, {575,0.000018779}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000028169}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000018779}, {680,0.000000000}, {685,0.000000000}, {690,0.000014085}, {695,0.000032864}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000014085}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000014085}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000028169}, {780,0.000014085}, {785,0.000014085}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000018779}, {830,0.000018779}, {835,0.000014085}, {840,0.000014085}, {845,0.000000000}, {850,0.000014085}, {855,0.000000000}, {860,0.000014085}, {865,0.000018779}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000018779}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000018779}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000014085}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000014085}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000014085}, {1070,0.000000000}, {1080,0.000032864}, {1090,0.000032864}, {1100,0.000000000}, {1110,0.000018779}, {1120,0.000000000}, {1130,0.000018779}, {1140,0.000037559}, {1150,0.000018779}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000028169}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000014085}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000014085}, {1250,0.000037559}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000018779}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000014085}, {1370,0.000000000}, {1380,0.000014085}, {1390,0.000000000}, {1400,0.000014085}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000014085}, {1440,0.000000000}, {1450,0.000032864}, {1460,0.000056338}, {1470,0.000018779}, {1480,0.000018779}, {1490,0.000014085}, {1500,0.000018779}, {1510,0.000000}, {1520,0.000000}, {1530,0.000000}, {1540,0.000000}, {1550,0.000000}, {1560,0.000000}, {1570,0.000000}, {1580,0.000000}, {1590,0.000000}, {1600,0.000000}, {1610,0.000000}, {1620,0.000000}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000000}, {1680,0.000000}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000000}, {1730,0.000000}, {1740,0.000000}, {1750,0.000000}, {1760,0.000000}, {1770,0.000000}, {1780,0.000000}, {1790,0.000000}, {1800,0.000000}, {1810,0.000000}, {1820,0.000000}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000000}, {1900,0.000000}, {1910,0.000000}, {1920,0.000000}, {1930,0.000000}, {1940,0.000000}, {1950,0.000000}, {1960,0.000000}, {1970,0.000000}, {1980,0.000000}, {1990,0.000000}, {2000,0.000000}, {2050,0.000000}, {2100,0.000000}, {2150,0.000000}, {2200,0.000000}, {2250,0.000000}, {2300,0.000000}, {2350,0.000000}, {2400,0.000000}, {2450,0.000000}, {2500,0.000000}, {2550,0.000000}, {2600,0.000000}, {2650,0.000000}, {2700,0.000000}, {2750,0.000000}, {2800,0.000000}, {2850,0.000000}, {2900,0.000000}, {2950,0.000000}, {3000,0.000000}, {3050,0.000000}, {3100,0.000000}, {3150,0.000000}, {3200,0.000000}, {3250,0.000000}, {3300,0.000000}, {3350,0.000000}, {3400,0.000000}, {3450,0.000000}, {3500,0.000000}, {3550,0.000000}, {3600,0.000000}, {3650,0.000000}, {3700,0.000000}, {3750,0.000000}, {3800,0.000000}, {3850,0.000000}, {3900,0.000000}, {3950,0.000000}, {4000,0.000000}, {4050,0.000000}, {4100,0.000000}, {4150,0.000000}, {4200,0.000000}, {4250,0.000000}, {4300,0.000000}, {4350,0.000000}, {4400,0.000000}, {4450,0.000000}, {4500,0.000000}, {4550,0.000000}, {4600,0.000000}, {4650,0.000000}, {4700,0.000000}, {4750,0.000000}, {4800,0.000000}, {4850,0.000000}, {4900,0.000000}, {4950,0.000000}, {5000,0.000000}, {5050,0.000000}, {5100,0.000000}, {5150,0.000000}, {5200,0.000000}, {5250,0.000000}, {5300,0.000000}, {5350,0.000000}, {5400,0.000000}, {5450,0.000000}, {5500,0.000308}, {5550,0.000000}, {5600,0.000000}, {5650,0.000000}, {5700,0.000000}, {5750,0.000000}, {5800,0.000000}, {5850,0.000000}, {5900,0.000000}, {5950,0.000000}, {6000,0.000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000308}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}};
data["big_flat"]["Mtac2"]["pre"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000014085}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000018779}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000018779}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000018779}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000018779}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000}, {1520,0.000000}, {1530,0.000000}, {1540,0.000000}, {1550,0.000000}, {1560,0.000000}, {1570,0.000000}, {1580,0.000000}, {1590,0.000000}, {1600,0.000000}, {1610,0.000000}, {1620,0.000000}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000000}, {1680,0.000000}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000000}, {1730,0.000000}, {1740,0.000000}, {1750,0.000000}, {1760,0.000000}, {1770,0.000000}, {1780,0.000000}, {1790,0.000000}, {1800,0.000000}, {1810,0.000000}, {1820,0.000000}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000000}, {1900,0.000000}, {1910,0.000000}, {1920,0.000000}, {1930,0.000000}, {1940,0.000000}, {1950,0.000000}, {1960,0.000000}, {1970,0.000000}, {1980,0.000000}, {1990,0.000000}, {2000,0.000000}, {2050,0.000000}, {2100,0.000000}, {2150,0.000000}, {2200,0.000000}, {2250,0.000000}, {2300,0.000000}, {2350,0.000000}, {2400,0.000000}, {2450,0.000000}, {2500,0.000000}, {2550,0.000000}, {2600,0.000000}, {2650,0.000000}, {2700,0.000000}, {2750,0.000000}, {2800,0.000000}, {2850,0.000000}, {2900,0.000000}, {2950,0.000000}, {3000,0.000000}, {3050,0.000000}, {3100,0.000000}, {3150,0.000000}, {3200,0.000000}, {3250,0.000000}, {3300,0.000000}, {3350,0.000000}, {3400,0.000000}, {3450,0.000000}, {3500,0.000000}, {3550,0.000000}, {3600,0.000000}, {3650,0.000000}, {3700,0.000000}, {3750,0.000000}, {3800,0.000000}, {3850,0.000000}, {3900,0.000000}, {3950,0.000000}, {4000,0.000000}, {4050,0.000000}, {4100,0.000000}, {4150,0.000000}, {4200,0.000000}, {4250,0.000000}, {4300,0.000000}, {4350,0.000000}, {4400,0.000000}, {4450,0.000000}, {4500,0.000000}, {4550,0.000000}, {4600,0.000000}, {4650,0.000000}, {4700,0.000000}, {4750,0.000000}, {4800,0.000000}, {4850,0.000000}, {4900,0.000000}, {4950,0.000000}, {5000,0.000000}, {5050,0.000000}, {5100,0.000000}, {5150,0.000000}, {5200,0.000000}, {5250,0.000000}, {5300,0.000000}, {5350,0.000000}, {5400,0.000000}, {5450,0.000000}, {5500,0.000000}, {5550,0.000000}, {5600,0.000000}, {5650,0.000000}, {5700,0.000000}, {5750,0.000000}, {5800,0.000000}, {5850,0.000000}, {5900,0.000000}, {5950,0.000000}, {6000,0.000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}};
data["big_flat"]["Mtac2"]["reif"]["real"] = {{1,0.001079812}, {2,0.000061033}, {3,0.000061033}, {4,0.000061033}, {5,0.000061033}, {6,0.000122066}, {7,0.000220657}, {8,0.000943662}, {9,0.001061033}, {10,0.001061033}, {11,0.001061033}, {12,0.001061033}, {13,0.001061033}, {14,0.001117371}, {15,0.001122066}, {16,0.001122066}, {17,0.001145540}, {18,0.001159624}, {19,0.001248826}, {20,0.001863850}, {21,0.002061033}, {22,0.002061033}, {23,0.002061033}, {24,0.002061033}, {25,0.002061033}, {26,0.002061033}, {27,0.002065728}, {28,0.002089202}, {29,0.002140845}, {30,0.002276995}, {31,0.002666667}, {32,0.003051643}, {33,0.003061033}, {34,0.003061033}, {35,0.003061033}, {36,0.003061033}, {37,0.003070423}, {38,0.003089202}, {39,0.003122066}, {40,0.003211268}, {41,0.003666667}, {42,0.003976526}, {43,0.004000000}, {44,0.004009390}, {45,0.005014085}, {46,0.004028169}, {47,0.004042254}, {48,0.004098592}, {49,0.004154930}, {50,0.004338028}, {51,0.004840376}, {52,0.005000000}, {53,0.005000000}, {54,0.005004695}, {55,0.005056338}, {56,0.005075117}, {57,0.005117371}, {58,0.005173709}, {59,0.005394366}, {60,0.006915493}, {61,0.006079812}, {62,0.006075117}, {63,0.006070423}, {64,0.006070423}, {65,0.006098592}, {66,0.006131455}, {67,0.006206573}, {68,0.006666667}, {69,0.006990610}, {70,0.007023474}, {71,0.007023474}, {72,0.008046948}, {73,0.007075117}, {74,0.007084507}, {75,0.007187793}, {76,0.007539906}, {77,0.007929577}, {78,0.008014085}, {79,0.008009390}, {80,0.008028169}, {81,0.008126761}, {82,0.009159624}, {83,0.008300469}, {84,0.008718310}, {85,0.009009390}, {86,0.009037559}, {87,0.009037559}, {88,0.009061033}, {89,0.009098592}, {90,0.010070423}, {91,0.009629108}, {92,0.009920188}, {93,0.010042254}, {94,0.010046948}, {95,0.010070423}, {96,0.010126761}, {97,0.010215962}, {98,0.011910798}, {99,0.010835681}, {100,0.011009390}, {101,0.011023474}, {102,0.011056338}, {103,0.011103286}, {104,0.011225352}, {105,0.012948357}, {106,0.011887324}, {107,0.011985915}, {108,0.012014085}, {109,0.012056338}, {110,0.012107981}, {111,0.013112676}, {112,0.012676056}, {113,0.012962441}, {114,0.013023474}, {115,0.013042254}, {116,0.013192488}, {117,0.015117371}, {118,0.013516432}, {119,0.013798122}, {120,0.014305164}, {121,0.014272300}, {122,0.014427230}, {123,0.016394366}, {124,0.015751174}, {125,0.015892019}, {126,0.015816901}, {127,0.015769953}, {128,0.017676056}, {129,0.015962441}, {130,0.016028169}, {131,0.016061033}, {132,0.016276995}, {133,0.017788732}, {134,0.016342723}, {135,0.016361502}, {136,0.016539906}, {137,0.016854460}, {138,0.018197183}, {139,0.017154930}, {140,0.017192488}, {141,0.017347418}, {142,0.019342723}, {143,0.017737089}, {144,0.018051643}, {145,0.018126761}, {146,0.018220657}, {147,0.019126761}, {148,0.018615023}, {149,0.018906103}, {150,0.019215962}, {151,0.020403756}, {152,0.019356808}, {153,0.019488263}, {154,0.019830986}, {155,0.020962441}, {156,0.020140845}, {157,0.020201878}, {158,0.020333333}, {159,0.020530516}, {160,0.020990610}, {161,0.021140845}, {162,0.023065728}, {163,0.021323944}, {164,0.021652582}, {165,0.021910798}, {166,0.023267606}, {167,0.022154930}, {168,0.022338028}, {169,0.024699531}, {170,0.022967136}, {171,0.023164319}, {172,0.023276995}, {173,0.024253521}, {174,0.023483568}, {175,0.023741784}, {176,0.025338028}, {177,0.024239437}, {178,0.024276995}, {179,0.026572770}, {180,0.025103286}, {181,0.025450704}, {182,0.027525822}, {183,0.025615023}, {184,0.025920188}, {185,0.027985915}, {186,0.026112676}, {187,0.026136150}, {188,0.028924883}, {189,0.026558685}, {190,0.026840376}, {191,0.028924883}, {192,0.027272300}, {193,0.027436620}, {194,0.029234742}, {195,0.027981221}, {196,0.028183099}, {197,0.028342723}, {198,0.028586854}, {199,0.031028169}, {200,0.029075117}, {201,0.029225352}, {202,0.031070423}, {203,0.029610329}, {204,0.031075117}, {205,0.030164319}, {206,0.030295775}, {207,0.032300469}, {208,0.031028169}, {209,0.031051643}, {210,0.031211268}, {211,0.031389671}, {212,0.033206573}, {213,0.031976526}, {214,0.034586854}, {215,0.032333333}, {216,0.032671362}, {217,0.033863850}, {218,0.033032864}, {219,0.036741784}, {220,0.033582160}, {221,0.037535211}, {222,0.034042254}, {223,0.034154930}, {224,0.036286385}, {225,0.034915493}, {226,0.037295775}, {227,0.035239437}, {228,0.038239437}, {229,0.035892019}, {230,0.039366197}, {231,0.036131455}, {232,0.040384977}, {233,0.036713615}, {234,0.041211268}, {235,0.037239437}, {236,0.041840376}, {237,0.037953052}, {238,0.039643192}, {239,0.038164319}, {240,0.039840376}, {241,0.038821596}, {242,0.040553991}, {243,0.039201878}, {244,0.043737089}, {245,0.039877934}, {246,0.044389671}, {247,0.040366197}, {248,0.045065728}, {249,0.041126761}, {250,0.046422535}, {251,0.042624413}, {252,0.046647887}, {253,0.046215962}, {254,0.047765258}, {255,0.044089202}, {256,0.046342723}, {257,0.047840376}, {258,0.043868545}, {259,0.047784038}, {260,0.044201878}, {261,0.047553991}, {262,0.044680751}, {263,0.047169014}, {264,0.050521127}, {265,0.045708920}, {266,0.049591549}, {267,0.046009390}, {268,0.048981221}, {269,0.046633803}, {270,0.047873239}, {271,0.052211268}, {272,0.049239437}, {273,0.052342723}, {274,0.054676056}, {275,0.048962441}, {276,0.052948357}, {277,0.049178404}, {278,0.051929577}, {279,0.053708920}, {280,0.049887324}, {281,0.052751174}, {282,0.054619718}, {283,0.050497653}, {284,0.053723005}, {285,0.054450704}, {286,0.051183099}, {287,0.053436620}, {288,0.055492958}, {289,0.052201878}, {290,0.054413146}, {291,0.056037559}, {292,0.052854460}, {293,0.055075117}, {294,0.056816901}, {295,0.054093897}, {296,0.057624413}, {297,0.057938967}, {298,0.057615023}, {299,0.055694836}, {300,0.057323944}, {301,0.058661972}, {302,0.056079812}, {303,0.057661972}, {304,0.058995305}, {305,0.060605634}, {306,0.057201878}, {307,0.059356808}, {308,0.060516432}, {309,0.062140845}, {310,0.058234742}, {311,0.060370892}, {312,0.061910798}, {313,0.063183099}, {314,0.059868545}, {315,0.061535211}, {316,0.062877934}, {317,0.064441315}, {318,0.061990610}, {319,0.061018779}, {320,0.062366197}, {321,0.063765258}, {322,0.065117371}, {323,0.065089202}, {324,0.063032864}, {325,0.064591549}, {326,0.065225352}, {327,0.066197183}, {328,0.067798122}, {329,0.064065728}, {330,0.064938967}, {331,0.066197183}, {332,0.067201878}, {333,0.068647887}, {334,0.070178404}, {335,0.070680751}, {336,0.068685446}, {337,0.069028169}, {338,0.069136150}, {339,0.069323944}, {340,0.070507042}, {341,0.071413146}, {342,0.072492958}, {343,0.073521127}, {344,0.071239437}, {345,0.069807512}, {346,0.071394366}, {347,0.071830986}, {348,0.072619718}, {349,0.073615023}, {350,0.075201878}, {351,0.075183099}, {352,0.075511737}, {353,0.075774648}, {354,0.076629108}, {355,0.077070423}, {356,0.078267606}, {357,0.078502347}, {358,0.078760563}, {359,0.079267606}, {360,0.077248826}, {361,0.075661972}, {362,0.076446009}, {363,0.076122066}, {364,0.077464789}, {365,0.078502347}, {366,0.079370892}, {367,0.078981221}, {368,0.079281690}, {369,0.079784038}, {370,0.078422535}, {371,0.079220657}, {372,0.080835681}, {373,0.084830986}, {374,0.085544601}, {375,0.085234742}, {376,0.085291080}, {377,0.084863850}, {378,0.085004695}, {379,0.084802817}, {380,0.084938967}, {381,0.085272300}, {382,0.084873239}, {383,0.085286385}, {384,0.085328638}, {385,0.085492958}, {386,0.085323944}, {387,0.085835681}, {388,0.089309859}, {389,0.089765258}, {390,0.089802817}, {391,0.089056338}, {392,0.089089202}, {393,0.089084507}, {394,0.089539906}, {395,0.090009390}, {396,0.093882629}, {397,0.092399061}, {398,0.093220657}, {399,0.090338028}, {400,0.094502347}, {401,0.092511737}, {402,0.093061033}, {403,0.096629108}, {404,0.096352113}, {405,0.096145540}, {406,0.095525822}, {407,0.095591549}, {408,0.098530516}, {409,0.098596244}, {410,0.097511737}, {411,0.097023474}, {412,0.097511737}, {413,0.100605634}, {414,0.099300469}, {415,0.099244131}, {416,0.099079812}, {417,0.102089202}, {418,0.101544601}, {419,0.101460094}, {420,0.100422535}, {421,0.103070423}, {422,0.101661972}, {423,0.100629108}, {424,0.103995305}, {425,0.103159624}, {426,0.102211268}, {427,0.102375587}, {428,0.104680751}, {429,0.103676056}, {430,0.103286385}, {431,0.106004695}, {432,0.105309859}, {433,0.104769953}, {434,0.108234742}, {435,0.106291080}, {436,0.106300469}, {437,0.111629108}, {438,0.105920188}, {439,0.107366197}, {440,0.109830986}, {441,0.109131455}, {442,0.112173709}, {443,0.111107981}, {444,0.109910798}, {445,0.111760563}, {446,0.111117371}, {447,0.113244131}, {448,0.113051643}, {449,0.112600939}, {450,0.114136150}, {451,0.113023474}, {452,0.115328638}, {453,0.114455399}, {454,0.116089202}, {455,0.115521127}, {456,0.114591549}, {457,0.115784038}, {458,0.115746479}, {459,0.117647887}, {460,0.116624413}, {461,0.118154930}, {462,0.116943662}, {463,0.118788732}, {464,0.118779343}, {465,0.119859155}, {466,0.118812207}, {467,0.120417840}, {468,0.119408451}, {469,0.121455399}, {470,0.120370892}, {471,0.122446009}, {472,0.121920188}, {473,0.122746479}, {474,0.125323944}, {475,0.124173709}, {476,0.124685446}, {477,0.123544601}, {478,0.125370892}, {479,0.124079812}, {480,0.125713615}, {481,0.128267606}, {482,0.126568075}, {483,0.127849765}, {484,0.128431925}, {485,0.128248826}, {486,0.129708920}, {487,0.128225352}, {488,0.130084507}, {489,0.134549296}, {490,0.132769953}, {491,0.133399061}, {492,0.135577465}, {493,0.133037559}, {494,0.134671362}, {495,0.135572770}, {496,0.134647887}, {497,0.136215962}, {498,0.137690141}, {499,0.135427230}, {500,0.138544601}, {505,0.141084507}, {510,0.144516432}, {515,0.143887324}, {520,0.145075117}, {525,0.146920188}, {530,0.150018779}, {535,0.151924883}, {540,0.156215962}, {545,0.157305164}, {550,0.162046948}, {555,0.162431925}, {560,0.166328638}, {565,0.167309859}, {570,0.172938967}, {575,0.174117371}, {580,0.179352113}, {585,0.178845070}, {590,0.181854460}, {595,0.184699531}, {600,0.187788732}, {605,0.188769953}, {610,0.191901408}, {615,0.194446009}, {620,0.198295775}, {625,0.199746479}, {630,0.204600939}, {635,0.206962441}, {640,0.210122066}, {645,0.212995305}, {650,0.217967136}, {655,0.216830986}, {660,0.221483568}, {665,0.223713615}, {670,0.227788732}, {675,0.231384977}, {680,0.234192488}, {685,0.236553991}, {690,0.239873239}, {695,0.243230047}, {700,0.251751174}, {705,0.251760563}, {710,0.256760563}, {715,0.259239437}, {720,0.265408451}, {725,0.267840376}, {730,0.272399061}, {735,0.272192488}, {740,0.279361502}, {745,0.283089202}, {750,0.283098592}, {755,0.289079812}, {760,0.295117371}, {765,0.289417840}, {770,0.293422535}, {775,0.298220657}, {780,0.302793427}, {785,0.303826291}, {790,0.309478873}, {795,0.312995305}, {800,0.316873239}, {805,0.320826291}, {810,0.328178404}, {815,0.327765258}, {820,0.332417840}, {825,0.335070423}, {830,0.337497653}, {835,0.341863850}, {840,0.343314554}, {845,0.348971831}, {850,0.352615023}, {855,0.355244131}, {860,0.359854460}, {865,0.363976526}, {870,0.365464789}, {875,0.375699531}, {880,0.377342723}, {885,0.378694836}, {890,0.384295775}, {895,0.393737089}, {900,0.397615023}, {905,0.401075117}, {910,0.402455399}, {915,0.409610329}, {920,0.410962441}, {925,0.416816901}, {930,0.416577465}, {935,0.421901408}, {940,0.429708920}, {945,0.426511737}, {950,0.432436620}, {955,0.439619718}, {960,0.442046948}, {965,0.446065728}, {970,0.450610329}, {975,0.455497653}, {980,0.459230047}, {985,0.464779343}, {990,0.471807512}, {995,0.473671362}, {1000,0.484291080}, {1010,0.487230047}, {1020,0.495042254}, {1030,0.502079812}, {1040,0.515225352}, {1050,0.532431925}, {1060,0.542948357}, {1070,0.549244131}, {1080,0.555906103}, {1090,0.560535211}, {1100,0.572877934}, {1110,0.582258216}, {1120,0.591826291}, {1130,0.600929577}, {1140,0.615868545}, {1150,0.632723005}, {1160,0.629685446}, {1170,0.643971831}, {1180,0.656051643}, {1190,0.663812207}, {1200,0.674892019}, {1210,0.681150235}, {1220,0.703183099}, {1230,0.714122066}, {1240,0.723976526}, {1250,0.736051643}, {1260,0.740572770}, {1270,0.753985915}, {1280,0.761154930}, {1290,0.773192488}, {1300,0.785098592}, {1310,0.800441315}, {1320,0.807394366}, {1330,0.826450704}, {1340,0.839835681}, {1350,0.839084507}, {1360,0.860009390}, {1370,0.875422535}, {1380,0.890234742}, {1390,0.891230047}, {1400,0.903812207}, {1410,0.913760563}, {1420,0.930450704}, {1430,0.944981221}, {1440,0.951530516}, {1450,0.963098592}, {1460,0.973159624}, {1470,0.989436620}, {1480,1.026957746}, {1490,1.031924883}, {1500,1.028727700}, {1510,1.053308}, {1520,1.050154}, {1530,1.080077}, {1540,1.089000}, {1550,1.097000}, {1560,1.103154}, {1570,1.118077}, {1580,1.149231}, {1590,1.150462}, {1600,1.160769}, {1610,1.179385}, {1620,1.188077}, {1630,1.217385}, {1640,1.221846}, {1650,1.226923}, {1660,1.244692}, {1670,1.256615}, {1680,1.279846}, {1690,1.292538}, {1700,1.297308}, {1710,1.318308}, {1720,1.350154}, {1730,1.345308}, {1740,1.373692}, {1750,1.372154}, {1760,1.381154}, {1770,1.423692}, {1780,1.431462}, {1790,1.430154}, {1800,1.445385}, {1810,1.460077}, {1820,1.490462}, {1830,1.496000}, {1840,1.508308}, {1850,1.522385}, {1860,1.539000}, {1870,1.565077}, {1880,1.607462}, {1890,1.587462}, {1900,1.599385}, {1910,1.624000}, {1920,1.638615}, {1930,1.649385}, {1940,1.671077}, {1950,1.679077}, {1960,1.697615}, {1970,1.718077}, {1980,1.723231}, {1990,1.742000}, {2000,1.792692}, {2050,1.846462}, {2100,1.938231}, {2150,1.999923}, {2200,2.093154}, {2250,2.209231}, {2300,2.279538}, {2350,2.382385}, {2400,2.470000}, {2450,2.601846}, {2500,2.671231}, {2550,2.775000}, {2600,2.890769}, {2650,2.987308}, {2700,3.103538}, {2750,3.243231}, {2800,3.318231}, {2850,3.420385}, {2900,3.550000}, {2950,3.671923}, {3000,3.865692}, {3050,3.934615}, {3100,4.049462}, {3150,4.177538}, {3200,4.331154}, {3250,4.437231}, {3300,4.598385}, {3350,4.729385}, {3400,4.856154}, {3450,4.982231}, {3500,5.115923}, {3550,5.292846}, {3600,5.417154}, {3650,5.585385}, {3700,5.735462}, {3750,5.869154}, {3800,6.043462}, {3850,6.170308}, {3900,6.352308}, {3950,6.503692}, {4000,6.695923}, {4050,6.818000}, {4100,7.056000}, {4150,7.179769}, {4200,7.367000}, {4250,7.504154}, {4300,7.694308}, {4350,7.832154}, {4400,8.078769}, {4450,8.306846}, {4500,8.441923}, {4550,8.637923}, {4600,8.805769}, {4650,8.946769}, {4700,9.194231}, {4750,9.338231}, {4800,9.552692}, {4850,9.749000}, {4900,9.924077}, {4950,10.180154}, {5000,10.352692}, {5050,10.592615}, {5100,10.830923}, {5150,11.088462}, {5200,11.275462}, {5250,11.446462}, {5300,11.701846}, {5350,11.895462}, {5400,12.109923}, {5450,12.372308}, {5500,12.545692}, {5550,12.783308}, {5600,13.085308}, {5650,13.278462}, {5700,13.534769}, {5750,13.764923}, {5800,14.039846}, {5850,14.294923}, {5900,14.535308}, {5950,14.776154}, {6000,15.029385}, {6050,15.333692}, {6100,15.555769}, {6150,15.783923}, {6200,16.157000}, {6250,16.383462}, {6300,16.663923}, {6350,16.914923}, {6400,17.198615}, {6450,17.533077}, {6500,17.718462}, {6550,18.052308}, {6600,18.300769}, {6650,18.668846}, {6700,18.910538}, {6750,19.200154}, {6800,19.536615}, {6850,19.935154}, {6900,20.095385}, {6950,20.385231}, {7000,20.631692}, {7050,20.953615}, {7100,21.268615}, {7150,21.579615}, {7200,21.838846}, {7250,22.131000}, {7300,22.346923}, {7350,22.741231}, {7400,23.165538}, {7450,23.542923}, {7500,23.777000}, {7550,24.158385}, {7600,24.322231}, {7650,24.866846}, {7700,25.204692}, {7750,25.480462}, {7800,25.805538}, {7850,26.036077}, {7900,26.435538}, {7950,26.655154}, {8000,27.251692}, {8050,27.498231}, {8100,27.800308}, {8150,28.151231}, {8200,28.482077}, {8250,28.937615}, {8300,29.213462}, {8350,29.605385}, {8400,29.919923}, {8450,30.371385}, {8500,30.607769}, {8550,31.090154}, {8600,31.409308}, {8650,31.793231}, {8700,32.294538}, {8750,32.487615}, {8800,33.036077}, {8850,33.330769}, {8900,33.720462}, {8950,34.228154}, {9000,34.586692}, {9050,34.799846}, {9100,35.548615}, {9150,35.806000}, {9200,36.149154}, {9250,36.445385}, {9300,36.864231}, {9350,37.150000}, {9400,37.571462}, {9450,37.868615}, {9500,38.447308}, {9550,38.775231}, {9600,39.200077}, {9650,39.530000}, {9700,40.430846}, {9750,40.829231}, {9800,40.998923}, {9850,41.449846}, {9900,41.943154}, {9950,42.434077}, {10000,42.864769}};
data["big_flat"]["Mtac2"]["reif"]["user"] = {{1,0.000732394}, {2,0.000450704}, {3,0.000544601}, {4,0.000807512}, {5,0.000863850}, {6,0.001051643}, {7,0.001070423}, {8,0.001145540}, {9,0.001239437}, {10,0.001276995}, {11,0.001333333}, {12,0.001446009}, {13,0.001295775}, {14,0.001596244}, {15,0.001633803}, {16,0.001647887}, {17,0.001924883}, {18,0.001882629}, {19,0.001816901}, {20,0.002239437}, {21,0.001830986}, {22,0.002366197}, {23,0.002422535}, {24,0.002384977}, {25,0.002328638}, {26,0.002352113}, {27,0.002530516}, {28,0.002676056}, {29,0.002708920}, {30,0.002737089}, {31,0.002929577}, {32,0.002948357}, {33,0.002915493}, {34,0.003126761}, {35,0.003323944}, {36,0.003107981}, {37,0.003361502}, {38,0.003347418}, {39,0.003455399}, {40,0.003577465}, {41,0.003577465}, {42,0.003755869}, {43,0.003802817}, {44,0.003934272}, {45,0.004849765}, {46,0.004145540}, {47,0.004009390}, {48,0.004549296}, {49,0.004234742}, {50,0.004666667}, {51,0.004751174}, {52,0.005084507}, {53,0.004967136}, {54,0.005145540}, {55,0.005478873}, {56,0.005746479}, {57,0.005586854}, {58,0.005586854}, {59,0.005647887}, {60,0.007178404}, {61,0.006093897}, {62,0.006258216}, {63,0.006525822}, {64,0.006774648}, {65,0.006746479}, {66,0.006699531}, {67,0.006723005}, {68,0.006868545}, {69,0.007093897}, {70,0.007300469}, {71,0.007460094}, {72,0.008539906}, {73,0.007563380}, {74,0.007887324}, {75,0.008000000}, {76,0.007995305}, {77,0.008262911}, {78,0.008244131}, {79,0.008507042}, {80,0.008544601}, {81,0.008657277}, {82,0.009915493}, {83,0.009126761}, {84,0.009014085}, {85,0.009183099}, {86,0.009446009}, {87,0.009309859}, {88,0.009568075}, {89,0.009718310}, {90,0.010694836}, {91,0.010028169}, {92,0.010197183}, {93,0.010295775}, {94,0.010450704}, {95,0.010474178}, {96,0.010549296}, {97,0.010812207}, {98,0.012079812}, {99,0.010892019}, {100,0.011070423}, {101,0.011197183}, {102,0.011413146}, {103,0.011577465}, {104,0.011657277}, {105,0.013178404}, {106,0.012112676}, {107,0.012276995}, {108,0.012507042}, {109,0.012629108}, {110,0.012718310}, {111,0.013755869}, {112,0.013084507}, {113,0.013253521}, {114,0.013361502}, {115,0.013370892}, {116,0.013708920}, {117,0.015474178}, {118,0.013929577}, {119,0.014089202}, {120,0.014525822}, {121,0.014577465}, {122,0.015075117}, {123,0.016807512}, {124,0.016131455}, {125,0.016206573}, {126,0.016098592}, {127,0.016122066}, {128,0.017812207}, {129,0.016352113}, {130,0.016549296}, {131,0.016483568}, {132,0.016619718}, {133,0.018169014}, {134,0.016830986}, {135,0.016746479}, {136,0.017070423}, {137,0.017291080}, {138,0.018629108}, {139,0.017450704}, {140,0.017619718}, {141,0.017610329}, {142,0.019615023}, {143,0.018145540}, {144,0.018173709}, {145,0.018384977}, {146,0.018464789}, {147,0.019183099}, {148,0.018821596}, {149,0.018910798}, {150,0.019169014}, {151,0.020492958}, {152,0.019455399}, {153,0.019591549}, {154,0.019873239}, {155,0.020967136}, {156,0.020093897}, {157,0.020192488}, {158,0.020600939}, {159,0.020704225}, {160,0.021281690}, {161,0.021469484}, {162,0.023230047}, {163,0.021225352}, {164,0.021596244}, {165,0.022103286}, {166,0.023652582}, {167,0.022225352}, {168,0.022798122}, {169,0.024854460}, {170,0.023244131}, {171,0.023568075}, {172,0.023605634}, {173,0.024835681}, {174,0.024084507}, {175,0.024140845}, {176,0.025563380}, {177,0.024699531}, {178,0.024619718}, {179,0.026483568}, {180,0.025093897}, {181,0.025455399}, {182,0.027666667}, {183,0.026014085}, {184,0.025948357}, {185,0.027887324}, {186,0.026276995}, {187,0.026422535}, {188,0.029107981}, {189,0.026769953}, {190,0.026877934}, {191,0.028596244}, {192,0.027352113}, {193,0.027375587}, {194,0.029624413}, {195,0.027849765}, {196,0.028201878}, {197,0.028507042}, {198,0.028511737}, {199,0.031338028}, {200,0.029075117}, {201,0.029169014}, {202,0.031455399}, {203,0.029924883}, {204,0.031300469}, {205,0.030647887}, {206,0.030464789}, {207,0.032553991}, {208,0.031201878}, {209,0.031441315}, {210,0.031863850}, {211,0.031868545}, {212,0.033469484}, {213,0.032169014}, {214,0.034713615}, {215,0.032826291}, {216,0.033042254}, {217,0.034051643}, {218,0.033267606}, {219,0.036877934}, {220,0.033788732}, {221,0.037718310}, {222,0.034046948}, {223,0.034145540}, {224,0.036352113}, {225,0.035009390}, {226,0.037342723}, {227,0.035173709}, {228,0.038338028}, {229,0.035666667}, {230,0.039591549}, {231,0.036150235}, {232,0.040751174}, {233,0.037023474}, {234,0.041262911}, {235,0.037150235}, {236,0.041812207}, {237,0.038220657}, {238,0.039971831}, {239,0.038408451}, {240,0.040093897}, {241,0.039131455}, {242,0.040971831}, {243,0.039657277}, {244,0.043619718}, {245,0.040262911}, {246,0.044178404}, {247,0.040619718}, {248,0.045187793}, {249,0.041206573}, {250,0.046169014}, {251,0.042591549}, {252,0.046446009}, {253,0.046244131}, {254,0.048037559}, {255,0.044248826}, {256,0.046394366}, {257,0.048103286}, {258,0.043948357}, {259,0.047971831}, {260,0.044154930}, {261,0.047826291}, {262,0.044985915}, {263,0.047600939}, {264,0.050690141}, {265,0.045990610}, {266,0.049431925}, {267,0.046342723}, {268,0.049046948}, {269,0.046882629}, {270,0.048197183}, {271,0.051901408}, {272,0.049446009}, {273,0.052112676}, {274,0.054460094}, {275,0.049394366}, {276,0.052661972}, {277,0.049384977}, {278,0.051746479}, {279,0.053309859}, {280,0.049859155}, {281,0.052328638}, {282,0.054704225}, {283,0.050370892}, {284,0.053460094}, {285,0.054314554}, {286,0.050882629}, {287,0.053281690}, {288,0.055169014}, {289,0.051882629}, {290,0.054178404}, {291,0.055967136}, {292,0.052591549}, {293,0.054798122}, {294,0.056873239}, {295,0.054079812}, {296,0.057530516}, {297,0.057652582}, {298,0.057460094}, {299,0.055708920}, {300,0.056929577}, {301,0.058793427}, {302,0.056098592}, {303,0.057741784}, {304,0.059112676}, {305,0.060661972}, {306,0.057159624}, {307,0.059586854}, {308,0.060718310}, {309,0.062230047}, {310,0.058366197}, {311,0.060483568}, {312,0.062145540}, {313,0.063338028}, {314,0.060122066}, {315,0.061774648}, {316,0.063253521}, {317,0.064671362}, {318,0.061981221}, {319,0.061530516}, {320,0.062563380}, {321,0.063938967}, {322,0.065323944}, {323,0.065075117}, {324,0.063535211}, {325,0.064638498}, {326,0.065347418}, {327,0.065934272}, {328,0.067427230}, {329,0.064342723}, {330,0.065159624}, {331,0.066028169}, {332,0.066962441}, {333,0.068530516}, {334,0.069605634}, {335,0.070403756}, {336,0.068291080}, {337,0.069028169}, {338,0.068492958}, {339,0.069126761}, {340,0.070070423}, {341,0.071239437}, {342,0.072394366}, {343,0.073276995}, {344,0.071173709}, {345,0.069694836}, {346,0.071258216}, {347,0.071605634}, {348,0.072497653}, {349,0.073535211}, {350,0.075075117}, {351,0.075183099}, {352,0.075220657}, {353,0.075920188}, {354,0.077009390}, {355,0.077291080}, {356,0.078413146}, {357,0.079093897}, {358,0.078924883}, {359,0.079863850}, {360,0.077483568}, {361,0.075920188}, {362,0.076737089}, {363,0.076295775}, {364,0.077657277}, {365,0.078723005}, {366,0.079765258}, {367,0.079450704}, {368,0.079600939}, {369,0.080314554}, {370,0.078774648}, {371,0.079464789}, {372,0.080934272}, {373,0.084610329}, {374,0.085201878}, {375,0.084924883}, {376,0.085117371}, {377,0.084718310}, {378,0.084859155}, {379,0.084309859}, {380,0.085107981}, {381,0.085079812}, {382,0.084676056}, {383,0.084938967}, {384,0.085070423}, {385,0.085408451}, {386,0.085258216}, {387,0.085938967}, {388,0.089314554}, {389,0.089460094}, {390,0.090046948}, {391,0.089103286}, {392,0.089230047}, {393,0.089366197}, {394,0.089422535}, {395,0.089929577}, {396,0.093802817}, {397,0.092366197}, {398,0.093230047}, {399,0.090323944}, {400,0.094638498}, {401,0.092563380}, {402,0.093230047}, {403,0.096990610}, {404,0.096765258}, {405,0.096591549}, {406,0.095854460}, {407,0.095802817}, {408,0.098572770}, {409,0.098586854}, {410,0.097821596}, {411,0.097295775}, {412,0.097915493}, {413,0.100417840}, {414,0.099539906}, {415,0.099178404}, {416,0.099220657}, {417,0.101967136}, {418,0.101478873}, {419,0.101366197}, {420,0.100483568}, {421,0.103018779}, {422,0.101577465}, {423,0.100704225}, {424,0.103657277}, {425,0.102845070}, {426,0.101906103}, {427,0.102319249}, {428,0.104441315}, {429,0.103286385}, {430,0.103154930}, {431,0.106112676}, {432,0.105112676}, {433,0.104516432}, {434,0.108333333}, {435,0.106154930}, {436,0.106150235}, {437,0.111572770}, {438,0.105906103}, {439,0.107713615}, {440,0.109957746}, {441,0.109084507}, {442,0.111943662}, {443,0.111028169}, {444,0.110126761}, {445,0.111699531}, {446,0.111183099}, {447,0.113093897}, {448,0.112859155}, {449,0.112596244}, {450,0.113685446}, {451,0.112657277}, {452,0.114915493}, {453,0.114309859}, {454,0.115807512}, {455,0.115154930}, {456,0.114422535}, {457,0.115389671}, {458,0.115427230}, {459,0.117375587}, {460,0.116563380}, {461,0.118291080}, {462,0.116798122}, {463,0.118859155}, {464,0.118798122}, {465,0.119962441}, {466,0.119023474}, {467,0.120474178}, {468,0.119178404}, {469,0.121596244}, {470,0.120582160}, {471,0.122408451}, {472,0.121990610}, {473,0.122671362}, {474,0.125305164}, {475,0.124018779}, {476,0.124657277}, {477,0.123408451}, {478,0.125220657}, {479,0.123976526}, {480,0.125769953}, {481,0.128258216}, {482,0.126671362}, {483,0.128065728}, {484,0.128666667}, {485,0.128488263}, {486,0.129901408}, {487,0.128422535}, {488,0.130403756}, {489,0.134502347}, {490,0.132680751}, {491,0.133079812}, {492,0.135333333}, {493,0.133014085}, {494,0.134507042}, {495,0.135380282}, {496,0.134492958}, {497,0.136032864}, {498,0.137568075}, {499,0.135131455}, {500,0.138492958}, {505,0.141159624}, {510,0.144197183}, {515,0.143868545}, {520,0.145079812}, {525,0.146727700}, {530,0.150089202}, {535,0.151976526}, {540,0.156370892}, {545,0.157140845}, {550,0.162159624}, {555,0.162610329}, {560,0.166065728}, {565,0.167112676}, {570,0.173018779}, {575,0.174178404}, {580,0.178953052}, {585,0.178539906}, {590,0.181460094}, {595,0.184596244}, {600,0.187845070}, {605,0.188873239}, {610,0.192173709}, {615,0.194399061}, {620,0.198342723}, {625,0.199741784}, {630,0.204483568}, {635,0.206732394}, {640,0.209990610}, {645,0.213070423}, {650,0.217887324}, {655,0.216859155}, {660,0.221225352}, {665,0.223732394}, {670,0.227798122}, {675,0.231061033}, {680,0.234009390}, {685,0.236446009}, {690,0.239624413}, {695,0.242887324}, {700,0.251450704}, {705,0.251478873}, {710,0.255953052}, {715,0.259211268}, {720,0.265328638}, {725,0.267976526}, {730,0.272338028}, {735,0.272075117}, {740,0.279192488}, {745,0.282953052}, {750,0.282821596}, {755,0.288953052}, {760,0.294798122}, {765,0.289366197}, {770,0.293183099}, {775,0.298173709}, {780,0.302694836}, {785,0.303676056}, {790,0.309046948}, {795,0.312643192}, {800,0.316943662}, {805,0.320887324}, {810,0.328197183}, {815,0.327647887}, {820,0.332215962}, {825,0.334906103}, {830,0.337262911}, {835,0.341990610}, {840,0.343328638}, {845,0.348845070}, {850,0.352502347}, {855,0.355164319}, {860,0.359267606}, {865,0.363549296}, {870,0.365248826}, {875,0.375361502}, {880,0.377436620}, {885,0.378854460}, {890,0.384281690}, {895,0.393816901}, {900,0.397502347}, {905,0.400873239}, {910,0.402403756}, {915,0.409272300}, {920,0.410676056}, {925,0.416586854}, {930,0.416521127}, {935,0.421272300}, {940,0.429460094}, {945,0.426267606}, {950,0.432183099}, {955,0.439342723}, {960,0.442183099}, {965,0.446159624}, {970,0.450436620}, {975,0.455553991}, {980,0.459093897}, {985,0.464469484}, {990,0.471610329}, {995,0.473338028}, {1000,0.484070423}, {1010,0.486394366}, {1020,0.495051643}, {1030,0.501887324}, {1040,0.514920188}, {1050,0.532084507}, {1060,0.542708920}, {1070,0.548929577}, {1080,0.555699531}, {1090,0.560258216}, {1100,0.572953052}, {1110,0.582070423}, {1120,0.591483568}, {1130,0.600539906}, {1140,0.615906103}, {1150,0.632342723}, {1160,0.629469484}, {1170,0.643676056}, {1180,0.655967136}, {1190,0.663633803}, {1200,0.674629108}, {1210,0.680896714}, {1220,0.702746479}, {1230,0.713943662}, {1240,0.723596244}, {1250,0.735338028}, {1260,0.740079812}, {1270,0.753910798}, {1280,0.761258216}, {1290,0.773004695}, {1300,0.784873239}, {1310,0.800028169}, {1320,0.807342723}, {1330,0.826117371}, {1340,0.839502347}, {1350,0.838553991}, {1360,0.859511737}, {1370,0.874981221}, {1380,0.890051643}, {1390,0.891107981}, {1400,0.903582160}, {1410,0.913638498}, {1420,0.930112676}, {1430,0.944676056}, {1440,0.951314554}, {1450,0.962661972}, {1460,0.972948357}, {1470,0.989356808}, {1480,1.026802817}, {1490,1.031863850}, {1500,1.028286385}, {1510,1.052308}, {1520,1.048231}, {1530,1.078077}, {1540,1.088231}, {1550,1.095769}, {1560,1.102538}, {1570,1.118231}, {1580,1.146846}, {1590,1.149923}, {1600,1.159923}, {1610,1.178000}, {1620,1.186154}, {1630,1.216692}, {1640,1.222231}, {1650,1.226538}, {1660,1.245308}, {1670,1.256462}, {1680,1.279154}, {1690,1.293077}, {1700,1.296846}, {1710,1.318385}, {1720,1.349000}, {1730,1.345231}, {1740,1.372923}, {1750,1.371462}, {1760,1.381538}, {1770,1.423462}, {1780,1.431385}, {1790,1.429615}, {1800,1.445077}, {1810,1.459538}, {1820,1.489385}, {1830,1.495000}, {1840,1.508231}, {1850,1.522154}, {1860,1.538462}, {1870,1.564154}, {1880,1.607385}, {1890,1.586615}, {1900,1.598154}, {1910,1.624000}, {1920,1.639231}, {1930,1.648846}, {1940,1.671462}, {1950,1.678538}, {1960,1.697154}, {1970,1.717308}, {1980,1.721923}, {1990,1.741769}, {2000,1.792923}, {2050,1.846538}, {2100,1.938231}, {2150,2.000000}, {2200,2.093077}, {2250,2.209769}, {2300,2.279000}, {2350,2.381385}, {2400,2.469846}, {2450,2.601077}, {2500,2.671077}, {2550,2.774769}, {2600,2.890231}, {2650,2.987462}, {2700,3.103231}, {2750,3.243000}, {2800,3.318615}, {2850,3.419308}, {2900,3.549769}, {2950,3.672154}, {3000,3.864923}, {3050,3.934231}, {3100,4.049462}, {3150,4.177231}, {3200,4.330923}, {3250,4.437692}, {3300,4.596923}, {3350,4.726154}, {3400,4.856077}, {3450,4.982462}, {3500,5.116154}, {3550,5.292615}, {3600,5.416000}, {3650,5.584538}, {3700,5.735077}, {3750,5.867769}, {3800,6.043154}, {3850,6.168769}, {3900,6.352846}, {3950,6.502308}, {4000,6.694615}, {4050,6.816846}, {4100,7.054692}, {4150,7.179462}, {4200,7.365846}, {4250,7.503462}, {4300,7.692846}, {4350,7.831231}, {4400,8.078308}, {4450,8.305462}, {4500,8.440615}, {4550,8.637615}, {4600,8.804308}, {4650,8.946538}, {4700,9.193846}, {4750,9.338154}, {4800,9.553077}, {4850,9.747846}, {4900,9.923923}, {4950,10.179923}, {5000,10.352308}, {5050,10.590615}, {5100,10.829538}, {5150,11.087692}, {5200,11.274231}, {5250,11.446077}, {5300,11.700923}, {5350,11.893077}, {5400,12.107923}, {5450,12.370308}, {5500,12.544538}, {5550,12.782385}, {5600,13.084385}, {5650,13.276692}, {5700,13.534538}, {5750,13.763692}, {5800,14.037692}, {5850,14.292923}, {5900,14.534538}, {5950,14.775538}, {6000,15.027308}, {6050,15.332231}, {6100,15.553000}, {6150,15.782308}, {6200,16.153308}, {6250,16.383000}, {6300,16.662846}, {6350,16.911923}, {6400,17.196385}, {6450,17.529846}, {6500,17.716846}, {6550,18.052308}, {6600,18.299000}, {6650,18.665538}, {6700,18.908462}, {6750,19.197385}, {6800,19.533615}, {6850,19.929385}, {6900,20.093077}, {6950,20.381154}, {7000,20.628692}, {7050,20.950615}, {7100,21.266538}, {7150,21.576462}, {7200,21.835769}, {7250,22.128231}, {7300,22.343538}, {7350,22.738385}, {7400,23.157923}, {7450,23.536308}, {7500,23.769462}, {7550,24.153462}, {7600,24.316077}, {7650,24.860077}, {7700,25.202154}, {7750,25.474923}, {7800,25.798692}, {7850,26.031154}, {7900,26.429077}, {7950,26.651308}, {8000,27.242692}, {8050,27.492308}, {8100,27.797538}, {8150,28.147846}, {8200,28.481154}, {8250,28.933846}, {8300,29.211231}, {8350,29.604308}, {8400,29.915385}, {8450,30.370000}, {8500,30.607231}, {8550,31.088385}, {8600,31.408000}, {8650,31.791615}, {8700,32.291308}, {8750,32.484846}, {8800,33.032385}, {8850,33.323308}, {8900,33.716077}, {8950,34.220692}, {9000,34.579077}, {9050,34.793923}, {9100,35.516462}, {9150,35.800154}, {9200,36.144692}, {9250,36.441692}, {9300,36.859462}, {9350,37.144538}, {9400,37.566308}, {9450,37.865308}, {9500,38.441308}, {9550,38.767923}, {9600,39.194538}, {9650,39.522077}, {9700,40.425923}, {9750,40.816923}, {9800,40.991000}, {9850,41.439615}, {9900,41.939462}, {9950,42.428692}, {10000,42.859000}};
data["big_flat"]["Mtac2"]["reif"]["system"] = {{1,0.000577465}, {2,0.000159624}, {3,0.000046948}, {4,0.000018779}, {5,0.000037559}, {6,0.000037559}, {7,0.000018779}, {8,0.000056338}, {9,0.000018779}, {10,0.000056338}, {11,0.000018779}, {12,0.000000000}, {13,0.000037559}, {14,0.000075117}, {15,0.000000000}, {16,0.000018779}, {17,0.000018779}, {18,0.000014085}, {19,0.000056338}, {20,0.000032864}, {21,0.000150235}, {22,0.000051643}, {23,0.000014085}, {24,0.000000000}, {25,0.000000000}, {26,0.000014085}, {27,0.000051643}, {28,0.000032864}, {29,0.000000000}, {30,0.000037559}, {31,0.000000000}, {32,0.000000000}, {33,0.000014085}, {34,0.000000000}, {35,0.000000000}, {36,0.000018779}, {37,0.000000000}, {38,0.000037559}, {39,0.000018779}, {40,0.000000000}, {41,0.000018779}, {42,0.000018779}, {43,0.000014085}, {44,0.000018779}, {45,0.000056338}, {46,0.000032864}, {47,0.000037559}, {48,0.000056338}, {49,0.000018779}, {50,0.000018779}, {51,0.000000000}, {52,0.000018779}, {53,0.000018779}, {54,0.000056338}, {55,0.000032864}, {56,0.000014085}, {57,0.000000000}, {58,0.000051643}, {59,0.000018779}, {60,0.000032864}, {61,0.000018779}, {62,0.000018779}, {63,0.000018779}, {64,0.000014085}, {65,0.000018779}, {66,0.000000000}, {67,0.000065728}, {68,0.000032864}, {69,0.000065728}, {70,0.000037559}, {71,0.000000000}, {72,0.000000000}, {73,0.000018779}, {74,0.000000000}, {75,0.000056338}, {76,0.000018779}, {77,0.000000000}, {78,0.000000000}, {79,0.000037559}, {80,0.000000000}, {81,0.000051643}, {82,0.000065728}, {83,0.000018779}, {84,0.000037559}, {85,0.000037559}, {86,0.000000000}, {87,0.000032864}, {88,0.000051643}, {89,0.000051643}, {90,0.000018779}, {91,0.000032864}, {92,0.000042254}, {93,0.000051643}, {94,0.000018779}, {95,0.000014085}, {96,0.000018779}, {97,0.000018779}, {98,0.000018779}, {99,0.000032864}, {100,0.000037559}, {101,0.000037559}, {102,0.000037559}, {103,0.000032864}, {104,0.000037559}, {105,0.000098592}, {106,0.000018779}, {107,0.000000000}, {108,0.000018779}, {109,0.000018779}, {110,0.000000000}, {111,0.000051643}, {112,0.000037559}, {113,0.000028169}, {114,0.000000000}, {115,0.000018779}, {116,0.000014085}, {117,0.000051643}, {118,0.000000000}, {119,0.000000000}, {120,0.000018779}, {121,0.000028169}, {122,0.000037559}, {123,0.000014085}, {124,0.000037559}, {125,0.000018779}, {126,0.000037559}, {127,0.000037559}, {128,0.000037559}, {129,0.000037559}, {130,0.000000000}, {131,0.000037559}, {132,0.000000000}, {133,0.000018779}, {134,0.000037559}, {135,0.000014085}, {136,0.000018779}, {137,0.000000000}, {138,0.000046948}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000032864}, {143,0.000032864}, {144,0.000018779}, {145,0.000037559}, {146,0.000018779}, {147,0.000032864}, {148,0.000018779}, {149,0.000000000}, {150,0.000000000}, {151,0.000037559}, {152,0.000037559}, {153,0.000000000}, {154,0.000037559}, {155,0.000089202}, {156,0.000018779}, {157,0.000037559}, {158,0.000000000}, {159,0.000018779}, {160,0.000070423}, {161,0.000018779}, {162,0.000070423}, {163,0.000014085}, {164,0.000014085}, {165,0.000018779}, {166,0.000014085}, {167,0.000000000}, {168,0.000056338}, {169,0.000089202}, {170,0.000056338}, {171,0.000000000}, {172,0.000018779}, {173,0.000037559}, {174,0.000018779}, {175,0.000018779}, {176,0.000051643}, {177,0.000018779}, {178,0.000056338}, {179,0.000112676}, {180,0.000046948}, {181,0.000000000}, {182,0.000018779}, {183,0.000032864}, {184,0.000018779}, {185,0.000037559}, {186,0.000018779}, {187,0.000000000}, {188,0.000107981}, {189,0.000037559}, {190,0.000000000}, {191,0.000164319}, {192,0.000037559}, {193,0.000056338}, {194,0.000056338}, {195,0.000000000}, {196,0.000000000}, {197,0.000037559}, {198,0.000037559}, {199,0.000093897}, {200,0.000032864}, {201,0.000051643}, {202,0.000037559}, {203,0.000018779}, {204,0.000032864}, {205,0.000070423}, {206,0.000037559}, {207,0.000032864}, {208,0.000037559}, {209,0.000000000}, {210,0.000018779}, {211,0.000000000}, {212,0.000056338}, {213,0.000014085}, {214,0.000065728}, {215,0.000051643}, {216,0.000000000}, {217,0.000056338}, {218,0.000051643}, {219,0.000032864}, {220,0.000018779}, {221,0.000089202}, {222,0.000037559}, {223,0.000018779}, {224,0.000018779}, {225,0.000000000}, {226,0.000056338}, {227,0.000056338}, {228,0.000089202}, {229,0.000070423}, {230,0.000122066}, {231,0.000032864}, {232,0.000075117}, {233,0.000018779}, {234,0.000164319}, {235,0.000032864}, {236,0.000075117}, {237,0.000000000}, {238,0.000037559}, {239,0.000018779}, {240,0.000018779}, {241,0.000000000}, {242,0.000018779}, {243,0.000000000}, {244,0.000164319}, {245,0.000000000}, {246,0.000075117}, {247,0.000051643}, {248,0.000032864}, {249,0.000018779}, {250,0.000178404}, {251,0.000037559}, {252,0.000018779}, {253,0.000018779}, {254,0.000018779}, {255,0.000051643}, {256,0.000037559}, {257,0.000089202}, {258,0.000000000}, {259,0.000075117}, {260,0.000018779}, {261,0.000070423}, {262,0.000037559}, {263,0.000018779}, {264,0.000089202}, {265,0.000037559}, {266,0.000159624}, {267,0.000014085}, {268,0.000070423}, {269,0.000014085}, {270,0.000037559}, {271,0.000201878}, {272,0.000037559}, {273,0.000056338}, {274,0.000056338}, {275,0.000000000}, {276,0.000122066}, {277,0.000070423}, {278,0.000065728}, {279,0.000093897}, {280,0.000032864}, {281,0.000079812}, {282,0.000075117}, {283,0.000056338}, {284,0.000070423}, {285,0.000103286}, {286,0.000075117}, {287,0.000103286}, {288,0.000136150}, {289,0.000018779}, {290,0.000112676}, {291,0.000018779}, {292,0.000014085}, {293,0.000089202}, {294,0.000056338}, {295,0.000037559}, {296,0.000061033}, {297,0.000248826}, {298,0.000089202}, {299,0.000032864}, {300,0.000126761}, {301,0.000131455}, {302,0.000018779}, {303,0.000070423}, {304,0.000089202}, {305,0.000107981}, {306,0.000018779}, {307,0.000075117}, {308,0.000145540}, {309,0.000070423}, {310,0.000032864}, {311,0.000032864}, {312,0.000093897}, {313,0.000140845}, {314,0.000037559}, {315,0.000145540}, {316,0.000070423}, {317,0.000089202}, {318,0.000051643}, {319,0.000056338}, {320,0.000131455}, {321,0.000164319}, {322,0.000065728}, {323,0.000150235}, {324,0.000018779}, {325,0.000056338}, {326,0.000070423}, {327,0.000131455}, {328,0.000075117}, {329,0.000051643}, {330,0.000000000}, {331,0.000107981}, {332,0.000018779}, {333,0.000117371}, {334,0.000117371}, {335,0.000056338}, {336,0.000014085}, {337,0.000037559}, {338,0.000000000}, {339,0.000051643}, {340,0.000089202}, {341,0.000169014}, {342,0.000122066}, {343,0.000070423}, {344,0.000070423}, {345,0.000014085}, {346,0.000084507}, {347,0.000131455}, {348,0.000056338}, {349,0.000140845}, {350,0.000070423}, {351,0.000056338}, {352,0.000154930}, {353,0.000112676}, {354,0.000136150}, {355,0.000103286}, {356,0.000164319}, {357,0.000018779}, {358,0.000037559}, {359,0.000000000}, {360,0.000000000}, {361,0.000018779}, {362,0.000018779}, {363,0.000000000}, {364,0.000018779}, {365,0.000037559}, {366,0.000056338}, {367,0.000000000}, {368,0.000051643}, {369,0.000018779}, {370,0.000000000}, {371,0.000051643}, {372,0.000037559}, {373,0.000089202}, {374,0.000014085}, {375,0.000018779}, {376,0.000000000}, {377,0.000018779}, {378,0.000051643}, {379,0.000056338}, {380,0.000000000}, {381,0.000014085}, {382,0.000018779}, {383,0.000037559}, {384,0.000000000}, {385,0.000018779}, {386,0.000018779}, {387,0.000000000}, {388,0.000018779}, {389,0.000018779}, {390,0.000018779}, {391,0.000037559}, {392,0.000018779}, {393,0.000000000}, {394,0.000014085}, {395,0.000000000}, {396,0.000018779}, {397,0.000000000}, {398,0.000093897}, {399,0.000037559}, {400,0.000056338}, {401,0.000037559}, {402,0.000000000}, {403,0.000028169}, {404,0.000000000}, {405,0.000000000}, {406,0.000037559}, {407,0.000000000}, {408,0.000018779}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000070423}, {413,0.000018779}, {414,0.000000000}, {415,0.000018779}, {416,0.000000000}, {417,0.000000000}, {418,0.000018779}, {419,0.000000000}, {420,0.000037559}, {421,0.000000000}, {422,0.000037559}, {423,0.000018779}, {424,0.000089202}, {425,0.000075117}, {426,0.000018779}, {427,0.000018779}, {428,0.000018779}, {429,0.000046948}, {430,0.000037559}, {431,0.000000000}, {432,0.000051643}, {433,0.000037559}, {434,0.000018779}, {435,0.000051643}, {436,0.000018779}, {437,0.000032864}, {438,0.000018779}, {439,0.000018779}, {440,0.000000000}, {441,0.000037559}, {442,0.000018779}, {443,0.000032864}, {444,0.000051643}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000037559}, {449,0.000018779}, {450,0.000037559}, {451,0.000018779}, {452,0.000018779}, {453,0.000037559}, {454,0.000000000}, {455,0.000018779}, {456,0.000037559}, {457,0.000037559}, {458,0.000000000}, {459,0.000014085}, {460,0.000014085}, {461,0.000056338}, {462,0.000014085}, {463,0.000037559}, {464,0.000014085}, {465,0.000056338}, {466,0.000000000}, {467,0.000000000}, {468,0.000075117}, {469,0.000000000}, {470,0.000056338}, {471,0.000018779}, {472,0.000018779}, {473,0.000018779}, {474,0.000018779}, {475,0.000037559}, {476,0.000028169}, {477,0.000075117}, {478,0.000056338}, {479,0.000028169}, {480,0.000056338}, {481,0.000084507}, {482,0.000000000}, {483,0.000018779}, {484,0.000018779}, {485,0.000037559}, {486,0.000018779}, {487,0.000037559}, {488,0.000056338}, {489,0.000000000}, {490,0.000000000}, {491,0.000070423}, {492,0.000018779}, {493,0.000014085}, {494,0.000107981}, {495,0.000018779}, {496,0.000037559}, {497,0.000051643}, {498,0.000018779}, {499,0.000018779}, {500,0.000037559}, {505,0.000000000}, {510,0.000018779}, {515,0.000051643}, {520,0.000000000}, {525,0.000037559}, {530,0.000018779}, {535,0.000037559}, {540,0.000037559}, {545,0.000032864}, {550,0.000000000}, {555,0.000018779}, {560,0.000018779}, {565,0.000000000}, {570,0.000037559}, {575,0.000018779}, {580,0.000037559}, {585,0.000018779}, {590,0.000037559}, {595,0.000000000}, {600,0.000018779}, {605,0.000037559}, {610,0.000032864}, {615,0.000037559}, {620,0.000056338}, {625,0.000037559}, {630,0.000046948}, {635,0.000065728}, {640,0.000032864}, {645,0.000018779}, {650,0.000037559}, {655,0.000000000}, {660,0.000037559}, {665,0.000032864}, {670,0.000000000}, {675,0.000018779}, {680,0.000037559}, {685,0.000018779}, {690,0.000051643}, {695,0.000032864}, {700,0.000056338}, {705,0.000070423}, {710,0.000032864}, {715,0.000000000}, {720,0.000056338}, {725,0.000056338}, {730,0.000056338}, {735,0.000061033}, {740,0.000056338}, {745,0.000084507}, {750,0.000089202}, {755,0.000093897}, {760,0.000037559}, {765,0.000056338}, {770,0.000056338}, {775,0.000000000}, {780,0.000037559}, {785,0.000075117}, {790,0.000018779}, {795,0.000032864}, {800,0.000070423}, {805,0.000018779}, {810,0.000028169}, {815,0.000093897}, {820,0.000150235}, {825,0.000037559}, {830,0.000046948}, {835,0.000056338}, {840,0.000000000}, {845,0.000037559}, {850,0.000051643}, {855,0.000070423}, {860,0.000056338}, {865,0.000075117}, {870,0.000103286}, {875,0.000056338}, {880,0.000051643}, {885,0.000084507}, {890,0.000018779}, {895,0.000056338}, {900,0.000056338}, {905,0.000032864}, {910,0.000070423}, {915,0.000032864}, {920,0.000051643}, {925,0.000032864}, {930,0.000089202}, {935,0.000037559}, {940,0.000051643}, {945,0.000089202}, {950,0.000070423}, {955,0.000070423}, {960,0.000018779}, {965,0.000051643}, {970,0.000018779}, {975,0.000056338}, {980,0.000056338}, {985,0.000018779}, {990,0.000056338}, {995,0.000037559}, {1000,0.000075117}, {1010,0.000037559}, {1020,0.000075117}, {1030,0.000056338}, {1040,0.000070423}, {1050,0.000056338}, {1060,0.000032864}, {1070,0.000037559}, {1080,0.000112676}, {1090,0.000037559}, {1100,0.000089202}, {1110,0.000018779}, {1120,0.000164319}, {1130,0.000093897}, {1140,0.000056338}, {1150,0.000037559}, {1160,0.000051643}, {1170,0.000065728}, {1180,0.000037559}, {1190,0.000075117}, {1200,0.000107981}, {1210,0.000089202}, {1220,0.000037559}, {1230,0.000051643}, {1240,0.000107981}, {1250,0.000225352}, {1260,0.000070423}, {1270,0.000093897}, {1280,0.000014085}, {1290,0.000093897}, {1300,0.000093897}, {1310,0.000145540}, {1320,0.000018779}, {1330,0.000093897}, {1340,0.000093897}, {1350,0.000145540}, {1360,0.000126761}, {1370,0.000126761}, {1380,0.000000000}, {1390,0.000065728}, {1400,0.000122066}, {1410,0.000126761}, {1420,0.000065728}, {1430,0.000112676}, {1440,0.000131455}, {1450,0.000018779}, {1460,0.000037559}, {1470,0.000037559}, {1480,0.000107981}, {1490,0.000093897}, {1500,0.000122066}, {1510,0.001769}, {1520,0.001769}, {1530,0.001846}, {1540,0.000308}, {1550,0.001231}, {1560,0.000923}, {1570,0.000308}, {1580,0.001231}, {1590,0.001462}, {1600,0.000308}, {1610,0.001231}, {1620,0.001462}, {1630,0.000000}, {1640,0.000000}, {1650,0.000000}, {1660,0.000000}, {1670,0.000000}, {1680,0.000615}, {1690,0.000000}, {1700,0.000000}, {1710,0.000000}, {1720,0.000308}, {1730,0.000000}, {1740,0.000538}, {1750,0.000308}, {1760,0.000000}, {1770,0.000000}, {1780,0.000000}, {1790,0.000308}, {1800,0.000000}, {1810,0.000231}, {1820,0.000308}, {1830,0.000000}, {1840,0.000000}, {1850,0.000000}, {1860,0.000000}, {1870,0.000000}, {1880,0.000000}, {1890,0.000538}, {1900,0.000308}, {1910,0.000308}, {1920,0.000000}, {1930,0.000308}, {1940,0.000000}, {1950,0.000000}, {1960,0.000000}, {1970,0.000000}, {1980,0.000308}, {1990,0.000000}, {2000,0.000308}, {2050,0.000000}, {2100,0.000000}, {2150,0.000000}, {2200,0.000000}, {2250,0.000000}, {2300,0.000000}, {2350,0.000308}, {2400,0.000000}, {2450,0.000615}, {2500,0.000000}, {2550,0.000615}, {2600,0.000308}, {2650,0.000000}, {2700,0.000538}, {2750,0.000615}, {2800,0.000000}, {2850,0.000538}, {2900,0.000308}, {2950,0.000308}, {3000,0.000538}, {3050,0.000000}, {3100,0.000615}, {3150,0.000000}, {3200,0.000615}, {3250,0.000000}, {3300,0.001231}, {3350,0.003077}, {3400,0.000000}, {3450,0.000000}, {3500,0.000000}, {3550,0.000000}, {3600,0.000615}, {3650,0.000615}, {3700,0.000615}, {3750,0.000308}, {3800,0.000000}, {3850,0.000538}, {3900,0.000000}, {3950,0.000923}, {4000,0.000923}, {4050,0.000615}, {4100,0.000923}, {4150,0.000000}, {4200,0.000308}, {4250,0.000308}, {4300,0.000923}, {4350,0.000615}, {4400,0.000000}, {4450,0.001231}, {4500,0.000615}, {4550,0.000000}, {4600,0.000923}, {4650,0.000846}, {4700,0.000923}, {4750,0.000308}, {4800,0.000000}, {4850,0.000538}, {4900,0.000923}, {4950,0.000308}, {5000,0.000308}, {5050,0.001231}, {5100,0.000615}, {5150,0.001154}, {5200,0.001231}, {5250,0.000615}, {5300,0.001154}, {5350,0.002385}, {5400,0.001538}, {5450,0.002385}, {5500,0.000615}, {5550,0.000308}, {5600,0.001231}, {5650,0.001538}, {5700,0.000923}, {5750,0.001231}, {5800,0.001846}, {5850,0.002077}, {5900,0.000923}, {5950,0.001538}, {6000,0.002077}, {6050,0.001385}, {6100,0.002769}, {6150,0.001462}, {6200,0.002385}, {6250,0.001538}, {6300,0.001538}, {6350,0.002769}, {6400,0.002385}, {6450,0.002308}, {6500,0.001538}, {6550,0.000615}, {6600,0.002154}, {6650,0.003308}, {6700,0.002000}, {6750,0.002154}, {6800,0.003923}, {6850,0.006077}, {6900,0.002308}, {6950,0.003692}, {7000,0.003000}, {7050,0.003692}, {7100,0.001538}, {7150,0.003615}, {7200,0.002462}, {7250,0.002462}, {7300,0.003231}, {7350,0.002462}, {7400,0.007308}, {7450,0.005769}, {7500,0.007231}, {7550,0.004846}, {7600,0.005077}, {7650,0.006231}, {7700,0.002692}, {7750,0.004923}, {7800,0.005769}, {7850,0.004385}, {7900,0.005769}, {7950,0.003923}, {8000,0.008615}, {8050,0.006077}, {8100,0.002385}, {8150,0.003154}, {8200,0.001538}, {8250,0.003692}, {8300,0.002462}, {8350,0.001538}, {8400,0.003385}, {8450,0.001231}, {8500,0.000615}, {8550,0.001769}, {8600,0.001846}, {8650,0.001462}, {8700,0.004308}, {8750,0.002385}, {8800,0.003923}, {8850,0.005385}, {8900,0.004308}, {8950,0.006154}, {9000,0.006462}, {9050,0.004846}, {9100,0.031692}, {9150,0.006615}, {9200,0.003692}, {9250,0.003538}, {9300,0.005231}, {9350,0.005077}, {9400,0.004923}, {9450,0.003923}, {9500,0.005462}, {9550,0.006077}, {9600,0.005462}, {9650,0.008000}, {9700,0.004385}, {9750,0.009769}, {9800,0.005538}, {9850,0.007000}, {9900,0.003231}, {9950,0.005538}, {10000,0.006154}};
data["big_flat"]["OCaml"]["Aggregate"]["real"] = {{1,0.00099099}, {2,0.00023423}, {3,0.00029730}, {4,0.00048649}, {5,0.00053153}, {6,0.00082883}, {7,0.00091892}, {8,0.00096396}, {9,0.00099099}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00100000}, {16,0.00100000}, {17,0.00100000}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00100901}, {22,0.00100000}, {23,0.00100000}, {24,0.00100000}, {25,0.00100000}, {26,0.00100000}, {27,0.00100000}, {28,0.00100000}, {29,0.00100000}, {30,0.00100000}, {31,0.00100000}, {32,0.00100000}, {33,0.00100000}, {34,0.00100000}, {35,0.00100000}, {36,0.00100000}, {37,0.00100000}, {38,0.00100000}, {39,0.00100000}, {40,0.00100000}, {41,0.00100000}, {42,0.01623423}, {43,0.00102703}, {44,0.00100000}, {45,0.00100000}, {46,0.00100000}, {47,0.00100000}, {48,0.00100000}, {49,0.00100000}, {50,0.00100000}, {51,0.00100000}, {52,0.00100000}, {53,0.00101802}, {54,0.00100000}, {55,0.00100000}, {56,0.00100000}, {57,0.00100000}, {58,0.00100000}, {59,0.00100000}, {60,0.00100000}, {61,0.00101802}, {62,0.00100000}, {63,0.00100000}, {64,0.00100000}, {65,0.00100000}, {66,0.00100000}, {67,0.00100000}, {68,0.00100000}, {69,0.00100000}, {70,0.00100000}, {71,0.00100000}, {72,0.00101802}, {73,0.00100000}, {74,0.00100000}, {75,0.00100000}, {76,0.00100901}, {77,0.00100000}, {78,0.00103604}, {79,0.00100000}, {80,0.00101802}, {81,0.00101802}, {82,0.00102703}, {83,0.00104505}, {84,0.00107207}, {85,0.00109910}, {86,0.00110811}, {87,0.00121622}, {88,0.00117117}, {89,0.00128829}, {90,0.00131532}, {91,0.00136937}, {92,0.00147748}, {93,0.00143243}, {94,0.00151351}, {95,0.00156757}, {96,0.00159459}, {97,0.00172072}, {98,0.00298198}, {99,0.00178378}, {100,0.00180180}, {101,0.00185586}, {102,0.00189189}, {103,0.00195495}, {104,0.00194595}, {105,0.00197297}, {106,0.00198198}, {107,0.00200000}, {108,0.00200000}, {109,0.00200000}, {110,0.00200000}, {111,0.00200000}, {112,0.00200000}, {113,0.00200000}, {114,0.00200000}, {115,0.00200000}, {116,0.00200000}, {117,0.00200000}, {118,0.00200000}, {119,0.00200000}, {120,0.00200000}, {121,0.00200000}, {122,0.00200000}, {123,0.00200000}, {124,0.00200000}, {125,0.00200000}, {126,0.00200000}, {127,0.00200000}, {128,0.00200000}, {129,0.00200000}, {130,0.00200000}, {131,0.00200000}, {132,0.00200000}, {133,0.00200000}, {134,0.00200000}, {135,0.00200000}, {136,0.00200000}, {137,0.00201802}, {138,0.00200000}, {139,0.00300000}, {140,0.00200000}, {141,0.00200000}, {142,0.00200000}, {143,0.00200000}, {144,0.00200000}, {145,0.00200000}, {146,0.00200000}, {147,0.00200000}, {148,0.00201802}, {149,0.00200000}, {150,0.00200000}, {151,0.00200000}, {152,0.00200000}, {153,0.00200000}, {154,0.00200000}, {155,0.00200000}, {156,0.00200000}, {157,0.00200901}, {158,0.00200000}, {159,0.00200000}, {160,0.00200000}, {161,0.00200000}, {162,0.00200000}, {163,0.00200000}, {164,0.00200000}, {165,0.00201802}, {166,0.00200901}, {167,0.00201802}, {168,0.00202703}, {169,0.00201802}, {170,0.00201802}, {171,0.00205405}, {172,0.00203604}, {173,0.00391892}, {174,0.00203604}, {175,0.00203604}, {176,0.00205405}, {177,0.00209009}, {178,0.00211712}, {179,0.00210811}, {180,0.00215315}, {181,0.00218018}, {182,0.00220721}, {183,0.00229730}, {184,0.00231532}, {185,0.00231532}, {186,0.00242342}, {187,0.00243243}, {188,0.00252252}, {189,0.00254955}, {190,0.00259459}, {191,0.00262162}, {192,0.00271171}, {193,0.00281081}, {194,0.00281081}, {195,0.00279279}, {196,0.00281081}, {197,0.00281982}, {198,0.00286486}, {199,0.00291892}, {200,0.00289189}, {201,0.00291892}, {202,0.00294595}, {203,0.00398198}, {204,0.00299099}, {205,0.00300000}, {206,0.00299099}, {207,0.00300000}, {208,0.00300000}, {209,0.00300000}, {210,0.00300000}, {211,0.00300000}, {212,0.00300000}, {213,0.00300000}, {214,0.00300000}, {215,0.00300000}, {216,0.00300000}, {217,0.00300000}, {218,0.00300000}, {219,0.00301802}, {220,0.00300000}, {221,0.00300000}, {222,0.00300000}, {223,0.00300000}, {224,0.00300000}, {225,0.00300000}, {226,0.00300000}, {227,0.00300000}, {228,0.00301802}, {229,0.00300000}, {230,0.00300000}, {231,0.00300000}, {232,0.00300000}, {233,0.00300000}, {234,0.00300000}, {235,0.00301802}, {236,0.00300000}, {237,0.00300000}, {238,0.00300000}, {239,0.00300000}, {240,0.00300000}, {241,0.00300000}, {242,0.00300000}, {243,0.00300000}, {244,0.00300901}, {245,0.00300901}, {246,0.00300000}, {247,0.00300000}, {248,0.00300000}, {249,0.00300000}, {250,0.00300000}, {251,0.00300000}, {252,0.00302703}, {253,0.00300901}, {254,0.00398198}, {255,0.00300901}, {256,0.00300000}, {257,0.00301802}, {258,0.00301802}, {259,0.00301802}, {260,0.00301802}, {261,0.00304505}, {262,0.00302703}, {263,0.00301802}, {264,0.00301802}, {265,0.00303604}, {266,0.00307207}, {267,0.00307207}, {268,0.00317117}, {269,0.00315315}, {270,0.00316216}, {271,0.00321622}, {272,0.00318919}, {273,0.00327027}, {274,0.00327928}, {275,0.00333333}, {276,0.00335135}, {277,0.00404505}, {278,0.00347748}, {279,0.00350450}, {280,0.00346847}, {281,0.00354955}, {282,0.00355856}, {283,0.00360360}, {284,0.00367568}, {285,0.00372072}, {286,0.00369369}, {287,0.00371171}, {288,0.00372973}, {289,0.00374775}, {290,0.00379279}, {291,0.00380180}, {292,0.00381081}, {293,0.00384685}, {294,0.00389189}, {295,0.00384685}, {296,0.00389189}, {297,0.00390991}, {298,0.00470270}, {299,0.00395495}, {300,0.00399099}, {301,0.00397297}, {302,0.00399099}, {303,0.00399099}, {304,0.00400000}, {305,0.00400901}, {306,0.00400000}, {307,0.00401802}, {308,0.00399099}, {309,0.00400000}, {310,0.00400000}, {311,0.00400000}, {312,0.00400000}, {313,0.00400000}, {314,0.00400000}, {315,0.00400000}, {316,0.00400000}, {317,0.00401802}, {318,0.00500901}, {319,0.00400000}, {320,0.00400000}, {321,0.00400000}, {322,0.00400000}, {323,0.00400000}, {324,0.00400000}, {325,0.00400000}, {326,0.00400000}, {327,0.00400000}, {328,0.00400000}, {329,0.00400000}, {330,0.00400000}, {331,0.00401802}, {332,0.00400000}, {333,0.00400000}, {334,0.00400000}, {335,0.00400000}, {336,0.00402703}, {337,0.00559459}, {338,0.00400000}, {339,0.00400000}, {340,0.00400000}, {341,0.00400000}, {342,0.00401802}, {343,0.00401802}, {344,0.00400000}, {345,0.00400901}, {346,0.00400901}, {347,0.00401802}, {348,0.00404505}, {349,0.00400901}, {350,0.00400901}, {351,0.00402703}, {352,0.00404505}, {353,0.00404505}, {354,0.00412613}, {355,0.00580180}, {356,0.00409910}, {357,0.00409009}, {358,0.00417117}, {359,0.00415315}, {360,0.00419820}, {361,0.00426126}, {362,0.00423423}, {363,0.00428829}, {364,0.00429730}, {365,0.00427928}, {366,0.00435135}, {367,0.00442342}, {368,0.00437838}, {369,0.00445946}, {370,0.00450450}, {371,0.00458559}, {372,0.00454054}, {373,0.00572072}, {374,0.00463964}, {375,0.00464865}, {376,0.00465766}, {377,0.00466667}, {378,0.00469369}, {379,0.00471171}, {380,0.00472973}, {381,0.00472973}, {382,0.00472973}, {383,0.00475676}, {384,0.00472973}, {385,0.00481081}, {386,0.00479279}, {387,0.00481081}, {388,0.00481982}, {389,0.00484685}, {390,0.00590991}, {391,0.00492793}, {392,0.00496396}, {393,0.00492793}, {394,0.00497297}, {395,0.00496396}, {396,0.00500000}, {397,0.00498198}, {398,0.00494595}, {399,0.00498198}, {400,0.00499099}, {401,0.00500000}, {402,0.00500000}, {403,0.00500000}, {404,0.00500000}, {405,0.00501802}, {406,0.00592793}, {407,0.00500000}, {408,0.00500000}, {409,0.00500000}, {410,0.00500000}, {411,0.00500000}, {412,0.00500000}, {413,0.00500000}, {414,0.00500000}, {415,0.00500901}, {416,0.00500000}, {417,0.00500000}, {418,0.00500000}, {419,0.00500000}, {420,0.00500000}, {421,0.00500000}, {422,0.00500000}, {423,0.00500000}, {424,0.00500901}, {425,0.00500000}, {426,0.00500000}, {427,0.00500000}, {428,0.00500901}, {429,0.00500000}, {430,0.00500000}, {431,0.00501802}, {432,0.00501802}, {433,0.00500901}, {434,0.00500901}, {435,0.00501802}, {436,0.00504505}, {437,0.00590090}, {438,0.00502703}, {439,0.00505405}, {440,0.00505405}, {441,0.00508108}, {442,0.00509009}, {443,0.00517117}, {444,0.00509910}, {445,0.00511712}, {446,0.00517117}, {447,0.00514414}, {448,0.00519820}, {449,0.00524324}, {450,0.00524324}, {451,0.00708108}, {452,0.00527027}, {453,0.00529730}, {454,0.00536937}, {455,0.00531532}, {456,0.00536036}, {457,0.00537838}, {458,0.00545045}, {459,0.00552252}, {460,0.00547748}, {461,0.00549550}, {462,0.00551351}, {463,0.00557658}, {464,0.00561261}, {465,0.00563063}, {466,0.00622523}, {467,0.00562162}, {468,0.00563964}, {469,0.00564865}, {470,0.00567568}, {471,0.00567568}, {472,0.00566667}, {473,0.00567568}, {474,0.00571171}, {475,0.00572072}, {476,0.00568468}, {477,0.00570270}, {478,0.00572973}, {479,0.00572973}, {480,0.00602703}, {481,0.00574775}, {482,0.00580180}, {483,0.00577477}, {484,0.00579279}, {485,0.00585586}, {486,0.00584685}, {487,0.00583784}, {488,0.00585586}, {489,0.00588288}, {490,0.00584685}, {491,0.00594595}, {492,0.00595495}, {493,0.00697297}, {494,0.00593694}, {495,0.00594595}, {496,0.00597297}, {497,0.00594595}, {498,0.00599099}, {499,0.00598198}, {500,0.00599099}, {505,0.00600901}, {510,0.00600901}, {515,0.00600000}, {520,0.00600000}, {525,0.00602703}, {530,0.00767568}, {535,0.00611712}, {540,0.00618018}, {545,0.00635135}, {550,0.00645045}, {555,0.00657658}, {560,0.00668468}, {565,0.00668468}, {570,0.00672072}, {575,0.00674775}, {580,0.00681081}, {585,0.00690090}, {590,0.00826126}, {595,0.00693694}, {600,0.00700000}, {605,0.00700000}, {610,0.00702703}, {615,0.00703604}, {620,0.00705405}, {625,0.00710811}, {630,0.00720721}, {635,0.00737838}, {640,0.00751351}, {645,0.00877477}, {650,0.00765766}, {655,0.00768468}, {660,0.00768468}, {665,0.00768468}, {670,0.00770270}, {675,0.00774775}, {680,0.00781982}, {685,0.00787387}, {690,0.00796396}, {695,0.01070270}, {700,0.00800901}, {705,0.00802703}, {710,0.00806306}, {715,0.00809910}, {720,0.00820721}, {725,0.00822523}, {730,0.00842342}, {735,0.00849550}, {740,0.00863063}, {745,0.01044144}, {750,0.00866667}, {755,0.00868468}, {760,0.00872072}, {765,0.00872973}, {770,0.00873874}, {775,0.00878378}, {780,0.00887387}, {785,0.00900901}, {790,0.01181081}, {795,0.00904505}, {800,0.00904505}, {805,0.00910811}, {810,0.00926126}, {815,0.00933333}, {820,0.00944144}, {825,0.00947748}, {830,0.01265766}, {835,0.00963964}, {840,0.00965766}, {845,0.00965766}, {850,0.00966667}, {855,0.00968468}, {860,0.00969369}, {865,0.00973874}, {870,0.00983784}, {875,0.00977477}, {880,0.00989189}, {885,0.01000901}, {890,0.01014414}, {895,0.01020721}, {900,0.01027027}, {905,0.01036937}, {910,0.01363063}, {915,0.01050450}, {920,0.01056757}, {925,0.01063063}, {930,0.01066667}, {935,0.01066667}, {940,0.01067568}, {945,0.01075676}, {950,0.01339640}, {955,0.01075676}, {960,0.01075676}, {965,0.01083784}, {970,0.01083784}, {975,0.01090991}, {980,0.01102703}, {985,0.01565766}, {990,0.01118018}, {995,0.01128829}, {1000,0.01141441}, {1010,0.01157658}, {1020,0.01165766}, {1030,0.01169369}, {1040,0.01414414}, {1050,0.01174775}, {1060,0.01190090}, {1070,0.01204505}, {1080,0.01224324}, {1090,0.01247748}, {1100,0.01267568}, {1110,0.01473874}, {1120,0.01270270}, {1130,0.01268468}, {1140,0.01278378}, {1150,0.01286486}, {1160,0.01305405}, {1170,0.01580180}, {1180,0.01340541}, {1190,0.01358559}, {1200,0.01369369}, {1210,0.01371171}, {1220,0.01385586}, {1230,0.01645045}, {1240,0.01401802}, {1250,0.01410811}, {1260,0.01430631}, {1270,0.01444144}, {1280,0.01943243}, {1290,0.01469369}, {1300,0.01472973}, {1310,0.01482883}, {1320,0.01491892}, {1330,0.01504505}, {1340,0.01836036}, {1350,0.01528829}, {1360,0.01544144}, {1370,0.01559459}, {1380,0.01569369}, {1390,0.02078378}, {1400,0.01590991}, {1410,0.01599099}, {1420,0.01610811}, {1430,0.01625225}, {1440,0.02153153}, {1450,0.01652252}, {1460,0.01665766}, {1470,0.01682883}, {1480,0.01688288}, {1490,0.01973874}, {1500,0.01700901}, {1510,0.01723423}, {1520,0.01736937}, {1530,0.01763964}, {1540,0.01859459}, {1550,0.01769369}, {1560,0.01783784}, {1570,0.01796396}, {1580,0.02276577}, {1590,0.01817117}, {1600,0.01828829}, {1610,0.01847748}, {1620,0.01869369}, {1630,0.02090090}, {1640,0.01883784}, {1650,0.01898198}, {1660,0.01918919}, {1670,0.02444144}, {1680,0.01938739}, {1690,0.01941441}, {1700,0.01959459}, {1710,0.02550450}, {1720,0.01983784}, {1730,0.02002703}, {1740,0.02007207}, {1750,0.02031532}, {1760,0.01984685}, {1770,0.02058559}, {1780,0.02063964}, {1790,0.02088288}, {1800,0.02157658}, {1810,0.02106306}, {1820,0.02109009}, {1830,0.02136036}, {1840,0.02225225}, {1850,0.02153153}, {1860,0.02173874}, {1870,0.02190090}, {1880,0.02204505}, {1890,0.02208108}, {1900,0.02223423}, {1910,0.02637838}, {1920,0.02253153}, {1930,0.02272973}, {1940,0.02283784}, {1950,0.02684685}, {1960,0.02305405}, {1970,0.02313514}, {1980,0.02332432}, {1990,0.02459459}, {2000,0.02365766}, {2050,0.02432432}, {2100,0.02911712}, {2150,0.02591892}, {2200,0.02663964}, {2250,0.02754054}, {2300,0.02858559}, {2350,0.02872072}, {2400,0.02948649}, {2450,0.03202703}, {2500,0.03101802}, {2550,0.03184685}, {2600,0.03201802}, {2650,0.03345946}, {2700,0.03890090}, {2750,0.03491892}, {2800,0.03596396}, {2850,0.04180180}, {2900,0.03727928}, {2950,0.04684685}, {3000,0.03864865}, {3050,0.03961261}, {3100,0.04672973}, {3150,0.04097297}, {3200,0.04996396}, {3250,0.04248649}, {3300,0.05096396}, {3350,0.04420721}, {3400,0.04485586}, {3450,0.04755856}, {3500,0.04662162}, {3550,0.04945946}, {3600,0.04839640}, {3650,0.05155856}, {3700,0.04981081}, {3750,0.05291892}, {3800,0.05117117}, {3850,0.05409009}, {3900,0.05333333}, {3950,0.05286486}, {4000,0.06180180}, {4050,0.05580180}, {4100,0.06014414}, {4150,0.05694595}, {4200,0.06065766}, {4250,0.05890090}, {4300,0.06238739}, {4350,0.06909009}, {4400,0.06152252}, {4450,0.07402703}, {4500,0.06336937}, {4550,0.07059459}, {4600,0.07241441}, {4650,0.06577477}, {4700,0.07619820}, {4750,0.07440541}, {4800,0.06838739}, {4850,0.07310811}, {4900,0.07088288}, {4950,0.07118018}, {5000,0.07769369}, {5050,0.08368468}, {5100,0.07418919}, {5150,0.08692793}, {5200,0.08925225}, {5250,0.07725225}, {5300,0.08136937}, {5350,0.08884685}, {5400,0.08013514}, {5450,0.08085586}, {5500,0.09302703}, {5550,0.10184685}, {5600,0.08486486}, {5650,0.08478378}, {5700,0.09839640}, {5750,0.10778378}, {5800,0.11241441}, {5850,0.08877477}, {5900,0.09303604}, {5950,0.10586486}, {6000,0.11890090}, {6050,0.10465766}, {6100,0.09436036}, {6150,0.09353153}, {6200,0.10278378}, {6250,0.11092793}, {6300,0.12355856}, {6350,0.10752252}, {6400,0.11459459}, {6450,0.10155856}, {6500,0.10471171}, {6550,0.10790991}, {6600,0.11771171}, {6650,0.12410811}, {6700,0.12212613}, {6750,0.12580180}, {6800,0.12225225}, {6850,0.12173874}, {6900,0.12401802}, {6950,0.11569369}, {7000,0.11334234}, {7050,0.11357658}, {7100,0.11985586}, {7150,0.11938739}, {7200,0.12088288}, {7250,0.12215315}, {7300,0.12129730}, {7350,0.12453153}, {7400,0.12524324}, {7450,0.12624324}, {7500,0.12720721}, {7550,0.12900901}, {7600,0.12848649}, {7650,0.12962162}, {7700,0.13029730}, {7750,0.12918919}, {7800,0.12942342}, {7850,0.14610811}, {7900,0.14952252}, {7950,0.14481982}, {8000,0.13077477}, {8050,0.15792793}, {8100,0.14933333}, {8150,0.16299099}, {8200,0.16232432}, {8250,0.15505405}, {8300,0.15327928}, {8350,0.15488288}, {8400,0.15096396}, {8450,0.13770270}, {8500,0.16289189}, {8550,0.16568468}, {8600,0.16363964}, {8650,0.15924324}, {8700,0.16168468}, {8750,0.15400000}, {8800,0.16709910}, {8850,0.18146847}, {8900,0.16409910}, {8950,0.16846847}, {9000,0.15754054}, {9050,0.16578378}, {9100,0.19222523}, {9150,0.17059459}, {9200,0.17684685}, {9250,0.18849550}, {9300,0.17955856}, {9350,0.17140541}, {9400,0.18014414}, {9450,0.17881982}, {9500,0.19403604}, {9550,0.18789189}, {9600,0.16431532}, {9650,0.18229730}, {9700,0.17550450}, {9750,0.17304505}, {9800,0.17254054}, {9850,0.17618919}, {9900,0.18535135}, {9950,0.17989189}, {10000,0.17878378}, {10100,0.18347748}, {10200,0.19012613}, {10300,0.19833333}, {10400,0.20138739}, {10500,0.20977477}, {10600,0.18789189}, {10700,0.20528829}, {10800,0.20404505}, {10900,0.19581081}, {11000,0.20900901}, {11100,0.20037838}, {11200,0.21133333}, {11300,0.20242342}, {11400,0.20816216}, {11500,0.21809009}, {11600,0.20919820}, {11700,0.23090090}, {11800,0.24232432}, {11900,0.23758559}, {12000,0.22005405}, {12100,0.21106306}, {12200,0.25831532}, {12300,0.22410811}, {12400,0.25930631}, {12500,0.27373874}, {12600,0.23147748}, {12700,0.20718018}, {12800,0.26792793}, {12900,0.25552252}, {13000,0.26800000}, {13100,0.23482883}, {13200,0.27751351}, {13300,0.25913514}, {13400,0.25256757}, {13500,0.27463964}, {13600,0.24286486}, {13700,0.27776577}, {13800,0.29898198}, {13900,0.28234234}, {14000,0.25496396}, {14100,0.26918919}, {14200,0.29900000}, {14300,0.26784685}, {14400,0.24337838}, {14500,0.24633333}, {14600,0.25601802}, {14700,0.26778378}, {14800,0.27176577}, {14900,0.27562162}, {15000,0.27459459}, {15100,0.27237838}, {15200,0.26192793}, {15300,0.26560360}, {15400,0.29513514}, {15500,0.29735135}, {15600,0.30078378}, {15700,0.28720721}, {15800,0.33710811}, {15900,0.35176577}, {16000,0.33745045}, {16100,0.30109910}, {16200,0.33020721}, {16300,0.29555856}, {16400,0.33882883}, {16500,0.36285586}, {16600,0.30796396}, {16700,0.31945045}, {16800,0.31632432}, {16900,0.36836036}, {17000,0.29936036}, {17100,0.32145045}, {17200,0.37564865}, {17300,0.33339640}, {17400,0.33776577}, {17500,0.37744144}, {17600,0.32595495}, {17700,0.32342342}, {17800,0.38169369}, {17900,3.87983784}, {18000,0.36780180}, {18100,0.32607207}, {18200,0.33210811}, {18300,0.38452252}, {18400,0.39409009}, {18500,0.38968468}, {18600,0.39793694}, {18700,0.39452252}, {18800,0.36595495}, {18900,0.38481081}, {19000,0.35161261}, {19100,0.34861261}, {19200,0.39586486}, {19300,0.38461261}, {19400,0.41772072}, {19500,0.37196396}, {19600,0.37894595}, {19700,0.39639640}, {19800,0.42109910}, {19900,0.36804505}, {20000,0.40972477}};
data["big_flat"]["OCaml"]["Aggregate"]["user"] = {{1,0.00037838}, {2,0.00040541}, {3,0.00065766}, {4,0.00108108}, {5,0.00075676}, {6,0.00076577}, {7,0.00112613}, {8,0.00077477}, {9,0.00081081}, {10,0.00104505}, {11,0.00085586}, {12,0.00055856}, {13,0.00101802}, {14,0.00093694}, {15,0.00068468}, {16,0.00112613}, {17,0.00102703}, {18,0.00080180}, {19,0.00133333}, {20,0.00093694}, {21,0.00094595}, {22,0.00111712}, {23,0.00088288}, {24,0.00123423}, {25,0.00107207}, {26,0.00073874}, {27,0.00151351}, {28,0.00099099}, {29,0.00086486}, {30,0.00118018}, {31,0.00077477}, {32,0.00145946}, {33,0.00107207}, {34,0.00108108}, {35,0.00142342}, {36,0.00104505}, {37,0.00162162}, {38,0.00091892}, {39,0.00129730}, {40,0.00103604}, {41,0.00124324}, {42,0.01616216}, {43,0.00109009}, {44,0.00136036}, {45,0.00119820}, {46,0.00143243}, {47,0.00123423}, {48,0.00128829}, {49,0.00127027}, {50,0.00118919}, {51,0.00148649}, {52,0.00106306}, {53,0.00133333}, {54,0.00117117}, {55,0.00151351}, {56,0.00140541}, {57,0.00143243}, {58,0.00157658}, {59,0.00140541}, {60,0.00152252}, {61,0.00140541}, {62,0.00128829}, {63,0.00139640}, {64,0.00127928}, {65,0.00137838}, {66,0.00134234}, {67,0.00152252}, {68,0.00135135}, {69,0.00160360}, {70,0.00145946}, {71,0.00170270}, {72,0.00145045}, {73,0.00155856}, {74,0.00137838}, {75,0.00162162}, {76,0.00127027}, {77,0.00184685}, {78,0.00136937}, {79,0.00184685}, {80,0.00157658}, {81,0.00159459}, {82,0.00179279}, {83,0.00151351}, {84,0.00175676}, {85,0.00141441}, {86,0.00176577}, {87,0.00149550}, {88,0.00186486}, {89,0.00145946}, {90,0.00178378}, {91,0.00154054}, {92,0.00176577}, {93,0.00168468}, {94,0.00174775}, {95,0.00194595}, {96,0.00161261}, {97,0.00177477}, {98,0.00284685}, {99,0.00194595}, {100,0.00168468}, {101,0.00183784}, {102,0.00180180}, {103,0.00155856}, {104,0.00197297}, {105,0.00161261}, {106,0.00198198}, {107,0.00186486}, {108,0.00175676}, {109,0.00204505}, {110,0.00176577}, {111,0.00188288}, {112,0.00200901}, {113,0.00170270}, {114,0.00219820}, {115,0.00183784}, {116,0.00193694}, {117,0.00210811}, {118,0.00172072}, {119,0.00206306}, {120,0.00197297}, {121,0.00168468}, {122,0.00209009}, {123,0.00226126}, {124,0.00174775}, {125,0.00199099}, {126,0.00217117}, {127,0.00190991}, {128,0.00198198}, {129,0.00201802}, {130,0.00191892}, {131,0.00207207}, {132,0.00211712}, {133,0.00208108}, {134,0.00217117}, {135,0.00205405}, {136,0.00207207}, {137,0.00236036}, {138,0.00200901}, {139,0.00298198}, {140,0.00202703}, {141,0.00207207}, {142,0.00201802}, {143,0.00218018}, {144,0.00202703}, {145,0.00231532}, {146,0.00212613}, {147,0.00212613}, {148,0.00231532}, {149,0.00215315}, {150,0.00236036}, {151,0.00206306}, {152,0.00245045}, {153,0.00228829}, {154,0.00236937}, {155,0.00214414}, {156,0.00240541}, {157,0.00247748}, {158,0.00241441}, {159,0.00228829}, {160,0.00239640}, {161,0.00236036}, {162,0.00254955}, {163,0.00237838}, {164,0.00229730}, {165,0.00234234}, {166,0.00255856}, {167,0.00245045}, {168,0.00222523}, {169,0.00213514}, {170,0.00261261}, {171,0.00259459}, {172,0.00224324}, {173,0.00388288}, {174,0.00240541}, {175,0.00227928}, {176,0.00241441}, {177,0.00258559}, {178,0.00245946}, {179,0.00254955}, {180,0.00261261}, {181,0.00259459}, {182,0.00269369}, {183,0.00241441}, {184,0.00237838}, {185,0.00266667}, {186,0.00263063}, {187,0.00272973}, {188,0.00276577}, {189,0.00240541}, {190,0.00255856}, {191,0.00266667}, {192,0.00254955}, {193,0.00262162}, {194,0.00270270}, {195,0.00288288}, {196,0.00261261}, {197,0.00276577}, {198,0.00275676}, {199,0.00260360}, {200,0.00279279}, {201,0.00296396}, {202,0.00278378}, {203,0.00382883}, {204,0.00277477}, {205,0.00272973}, {206,0.00291892}, {207,0.00284685}, {208,0.00265766}, {209,0.00241441}, {210,0.00256757}, {211,0.00286486}, {212,0.00288288}, {213,0.00284685}, {214,0.00266667}, {215,0.00271171}, {216,0.00287387}, {217,0.00307207}, {218,0.00288288}, {219,0.00296396}, {220,0.00308108}, {221,0.00290991}, {222,0.00282883}, {223,0.00292793}, {224,0.00300000}, {225,0.00313514}, {226,0.00315315}, {227,0.00304505}, {228,0.00303604}, {229,0.00309910}, {230,0.00291892}, {231,0.00310811}, {232,0.00289189}, {233,0.00302703}, {234,0.00300901}, {235,0.00281081}, {236,0.00309009}, {237,0.00310811}, {238,0.00300901}, {239,0.00310811}, {240,0.00307207}, {241,0.00297297}, {242,0.00311712}, {243,0.00298198}, {244,0.00316216}, {245,0.00305405}, {246,0.00296396}, {247,0.00301802}, {248,0.00303604}, {249,0.00303604}, {250,0.00301802}, {251,0.00319820}, {252,0.00329730}, {253,0.00329730}, {254,0.00385586}, {255,0.00334234}, {256,0.00311712}, {257,0.00319820}, {258,0.00324324}, {259,0.00317117}, {260,0.00319820}, {261,0.00327027}, {262,0.00327027}, {263,0.00316216}, {264,0.00346847}, {265,0.00327027}, {266,0.00332432}, {267,0.00333333}, {268,0.00340541}, {269,0.00342342}, {270,0.00337838}, {271,0.00342342}, {272,0.00329730}, {273,0.00347748}, {274,0.00354054}, {275,0.00337838}, {276,0.00346847}, {277,0.00413514}, {278,0.00350450}, {279,0.00338739}, {280,0.00341441}, {281,0.00347748}, {282,0.00354955}, {283,0.00351351}, {284,0.00346847}, {285,0.00346847}, {286,0.00337838}, {287,0.00352252}, {288,0.00356757}, {289,0.00363063}, {290,0.00345946}, {291,0.00357658}, {292,0.00364865}, {293,0.00362162}, {294,0.00368468}, {295,0.00349550}, {296,0.00358559}, {297,0.00377477}, {298,0.00454955}, {299,0.00370270}, {300,0.00372072}, {301,0.00367568}, {302,0.00377477}, {303,0.00364865}, {304,0.00380180}, {305,0.00369369}, {306,0.00384685}, {307,0.00369369}, {308,0.00396396}, {309,0.00392793}, {310,0.00384685}, {311,0.00376577}, {312,0.00390090}, {313,0.00390090}, {314,0.00385586}, {315,0.00387387}, {316,0.00390090}, {317,0.00391892}, {318,0.00513514}, {319,0.00373874}, {320,0.00385586}, {321,0.00415315}, {322,0.00383784}, {323,0.00391892}, {324,0.00405405}, {325,0.00408108}, {326,0.00411712}, {327,0.00375676}, {328,0.00434234}, {329,0.00386486}, {330,0.00423423}, {331,0.00404505}, {332,0.00426126}, {333,0.00436036}, {334,0.00408108}, {335,0.00405405}, {336,0.00410811}, {337,0.00551351}, {338,0.00402703}, {339,0.00421622}, {340,0.00424324}, {341,0.00422523}, {342,0.00412613}, {343,0.00422523}, {344,0.00418018}, {345,0.00407207}, {346,0.00429730}, {347,0.00397297}, {348,0.00418919}, {349,0.00417117}, {350,0.00411712}, {351,0.00424324}, {352,0.00459459}, {353,0.00425225}, {354,0.00450450}, {355,0.00558559}, {356,0.00419820}, {357,0.00435135}, {358,0.00445946}, {359,0.00427928}, {360,0.00425225}, {361,0.00431532}, {362,0.00429730}, {363,0.00472072}, {364,0.00411712}, {365,0.00433333}, {366,0.00451351}, {367,0.00440541}, {368,0.00432432}, {369,0.00464865}, {370,0.00435135}, {371,0.00454054}, {372,0.00456757}, {373,0.00562162}, {374,0.00463964}, {375,0.00466667}, {376,0.00466667}, {377,0.00446847}, {378,0.00472072}, {379,0.00432432}, {380,0.00482883}, {381,0.00446847}, {382,0.00454054}, {383,0.00485586}, {384,0.00437838}, {385,0.00474775}, {386,0.00469369}, {387,0.00481982}, {388,0.00454054}, {389,0.00482883}, {390,0.00550450}, {391,0.00461261}, {392,0.00472072}, {393,0.00477477}, {394,0.00469369}, {395,0.00511712}, {396,0.00485586}, {397,0.00458559}, {398,0.00464865}, {399,0.00475676}, {400,0.00505405}, {401,0.00465766}, {402,0.00508108}, {403,0.00463063}, {404,0.00505405}, {405,0.00454054}, {406,0.00590090}, {407,0.00474775}, {408,0.00496396}, {409,0.00477477}, {410,0.00481081}, {411,0.00485586}, {412,0.00472973}, {413,0.00505405}, {414,0.00467568}, {415,0.00531532}, {416,0.00463063}, {417,0.00521622}, {418,0.00478378}, {419,0.00492793}, {420,0.00498198}, {421,0.00467568}, {422,0.00508108}, {423,0.00502703}, {424,0.00502703}, {425,0.00509910}, {426,0.00470270}, {427,0.00507207}, {428,0.00521622}, {429,0.00512613}, {430,0.00518919}, {431,0.00501802}, {432,0.00498198}, {433,0.00537838}, {434,0.00515315}, {435,0.00506306}, {436,0.00505405}, {437,0.00572072}, {438,0.00508108}, {439,0.00512613}, {440,0.00526126}, {441,0.00513514}, {442,0.00537838}, {443,0.00505405}, {444,0.00516216}, {445,0.00529730}, {446,0.00490991}, {447,0.00517117}, {448,0.00546847}, {449,0.00529730}, {450,0.00533333}, {451,0.00690991}, {452,0.00513514}, {453,0.00540541}, {454,0.00508108}, {455,0.00547748}, {456,0.00540541}, {457,0.00524324}, {458,0.00540541}, {459,0.00539640}, {460,0.00554955}, {461,0.00516216}, {462,0.00557658}, {463,0.00536036}, {464,0.00501802}, {465,0.00555856}, {466,0.00620721}, {467,0.00552252}, {468,0.00514414}, {469,0.00542342}, {470,0.00559459}, {471,0.00551351}, {472,0.00524324}, {473,0.00555856}, {474,0.00595495}, {475,0.00535135}, {476,0.00518919}, {477,0.00570270}, {478,0.00577477}, {479,0.00536036}, {480,0.00575676}, {481,0.00526126}, {482,0.00581982}, {483,0.00581982}, {484,0.00511712}, {485,0.00548649}, {486,0.00584685}, {487,0.00574775}, {488,0.00557658}, {489,0.00527027}, {490,0.00588288}, {491,0.00587387}, {492,0.00554054}, {493,0.00643243}, {494,0.00560360}, {495,0.00581081}, {496,0.00596396}, {497,0.00585586}, {498,0.00571171}, {499,0.00573874}, {500,0.00563964}, {505,0.00598198}, {510,0.00595495}, {515,0.00569369}, {520,0.00603604}, {525,0.00616216}, {530,0.00733333}, {535,0.00632432}, {540,0.00623423}, {545,0.00623423}, {550,0.00615315}, {555,0.00637838}, {560,0.00631532}, {565,0.00634234}, {570,0.00662162}, {575,0.00655856}, {580,0.00638739}, {585,0.00654054}, {590,0.00807207}, {595,0.00692793}, {600,0.00693694}, {605,0.00712613}, {610,0.00681982}, {615,0.00703604}, {620,0.00700901}, {625,0.00699099}, {630,0.00710811}, {635,0.00714414}, {640,0.00709910}, {645,0.00857658}, {650,0.00731532}, {655,0.00724324}, {660,0.00737838}, {665,0.00735135}, {670,0.00750450}, {675,0.00750450}, {680,0.00757658}, {685,0.00767568}, {690,0.00755856}, {695,0.01068468}, {700,0.00784685}, {705,0.00762162}, {710,0.00800000}, {715,0.00795495}, {720,0.00828829}, {725,0.00804505}, {730,0.00850450}, {735,0.00767568}, {740,0.00852252}, {745,0.01057658}, {750,0.00816216}, {755,0.00853153}, {760,0.00836036}, {765,0.00829730}, {770,0.00909009}, {775,0.00835135}, {780,0.00891892}, {785,0.00882883}, {790,0.01190090}, {795,0.00903604}, {800,0.00865766}, {805,0.00911712}, {810,0.00930631}, {815,0.00875676}, {820,0.00925225}, {825,0.00905405}, {830,0.01294595}, {835,0.00903604}, {840,0.00965766}, {845,0.00956757}, {850,0.00953153}, {855,0.00985586}, {860,0.00998198}, {865,0.00961261}, {870,0.00971171}, {875,0.00964865}, {880,0.00982883}, {885,0.00990991}, {890,0.01011712}, {895,0.01029730}, {900,0.01027928}, {905,0.01021622}, {910,0.01362162}, {915,0.01063964}, {920,0.01044144}, {925,0.01037838}, {930,0.01059459}, {935,0.01085586}, {940,0.01079279}, {945,0.01075676}, {950,0.01351351}, {955,0.01109910}, {960,0.01104505}, {965,0.01129730}, {970,0.01119820}, {975,0.01134234}, {980,0.01150450}, {985,0.01554054}, {990,0.01131532}, {995,0.01148649}, {1000,0.01172072}, {1010,0.01153153}, {1020,0.01168468}, {1030,0.01226126}, {1040,0.01445946}, {1050,0.01201802}, {1060,0.01247748}, {1070,0.01229730}, {1080,0.01242342}, {1090,0.01259459}, {1100,0.01233333}, {1110,0.01465766}, {1120,0.01271171}, {1130,0.01291892}, {1140,0.01296396}, {1150,0.01322523}, {1160,0.01301802}, {1170,0.01554955}, {1180,0.01348649}, {1190,0.01355856}, {1200,0.01349550}, {1210,0.01355856}, {1220,0.01381081}, {1230,0.01618018}, {1240,0.01394595}, {1250,0.01414414}, {1260,0.01439640}, {1270,0.01445946}, {1280,0.01900901}, {1290,0.01427027}, {1300,0.01472072}, {1310,0.01500901}, {1320,0.01473874}, {1330,0.01495495}, {1340,0.01779279}, {1350,0.01495495}, {1360,0.01519820}, {1370,0.01530631}, {1380,0.01550450}, {1390,0.02036937}, {1400,0.01605405}, {1410,0.01579279}, {1420,0.01584685}, {1430,0.01656757}, {1440,0.02136937}, {1450,0.01644144}, {1460,0.01611712}, {1470,0.01636937}, {1480,0.01663063}, {1490,0.01926126}, {1500,0.01682883}, {1510,0.01690991}, {1520,0.01722523}, {1530,0.01734234}, {1540,0.01827027}, {1550,0.01739640}, {1560,0.01727928}, {1570,0.01738739}, {1580,0.02262162}, {1590,0.01811712}, {1600,0.01794595}, {1610,0.01811712}, {1620,0.01835135}, {1630,0.02056757}, {1640,0.01858559}, {1650,0.01890090}, {1660,0.01900901}, {1670,0.02379279}, {1680,0.01897297}, {1690,0.01926126}, {1700,0.01926126}, {1710,0.02538739}, {1720,0.01930631}, {1730,0.01974775}, {1740,0.01970270}, {1750,0.02014414}, {1760,0.01946847}, {1770,0.02037838}, {1780,0.02056757}, {1790,0.02073874}, {1800,0.02118018}, {1810,0.02047748}, {1820,0.02062162}, {1830,0.02072973}, {1840,0.02223423}, {1850,0.02108108}, {1860,0.02184685}, {1870,0.02196396}, {1880,0.02227027}, {1890,0.02201802}, {1900,0.02204505}, {1910,0.02595495}, {1920,0.02254955}, {1930,0.02274775}, {1940,0.02297297}, {1950,0.02654955}, {1960,0.02294595}, {1970,0.02300000}, {1980,0.02325225}, {1990,0.02472072}, {2000,0.02370270}, {2050,0.02438739}, {2100,0.02909009}, {2150,0.02599099}, {2200,0.02636036}, {2250,0.02761261}, {2300,0.02834234}, {2350,0.02890090}, {2400,0.02987387}, {2450,0.03218018}, {2500,0.03129730}, {2550,0.03227928}, {2600,0.03218919}, {2650,0.03372973}, {2700,0.03869369}, {2750,0.03494595}, {2800,0.03576577}, {2850,0.04181081}, {2900,0.03730631}, {2950,0.04672973}, {3000,0.03854054}, {3050,0.03963063}, {3100,0.04650450}, {3150,0.04089189}, {3200,0.04960360}, {3250,0.04270270}, {3300,0.05056757}, {3350,0.04431532}, {3400,0.04467568}, {3450,0.04753153}, {3500,0.04672973}, {3550,0.04918919}, {3600,0.04814414}, {3650,0.05150450}, {3700,0.04921622}, {3750,0.05291892}, {3800,0.05059459}, {3850,0.05396396}, {3900,0.05320721}, {3950,0.05276577}, {4000,0.06136036}, {4050,0.05563964}, {4100,0.05987387}, {4150,0.05698198}, {4200,0.06053153}, {4250,0.05881982}, {4300,0.06226126}, {4350,0.06880180}, {4400,0.06154955}, {4450,0.07338739}, {4500,0.06285586}, {4550,0.07074775}, {4600,0.07223423}, {4650,0.06590991}, {4700,0.07610811}, {4750,0.07429730}, {4800,0.06839640}, {4850,0.07311712}, {4900,0.07060360}, {4950,0.07122523}, {5000,0.07755856}, {5050,0.08338739}, {5100,0.07415315}, {5150,0.08652252}, {5200,0.08868468}, {5250,0.07701802}, {5300,0.08088288}, {5350,0.08851351}, {5400,0.08000901}, {5450,0.08050450}, {5500,0.09281982}, {5550,0.10163063}, {5600,0.08481081}, {5650,0.08470270}, {5700,0.09797297}, {5750,0.10739640}, {5800,0.11024324}, {5850,0.08856757}, {5900,0.09307207}, {5950,0.10560360}, {6000,0.11800901}, {6050,0.10392793}, {6100,0.09416216}, {6150,0.09328829}, {6200,0.10231532}, {6250,0.11051351}, {6300,0.12265766}, {6350,0.10727928}, {6400,0.11426126}, {6450,0.10163063}, {6500,0.10426126}, {6550,0.10772973}, {6600,0.11736036}, {6650,0.12315315}, {6700,0.12165766}, {6750,0.12517117}, {6800,0.12154955}, {6850,0.12132432}, {6900,0.12352252}, {6950,0.11542342}, {7000,0.11305405}, {7050,0.11364865}, {7100,0.11945045}, {7150,0.11930631}, {7200,0.12079279}, {7250,0.12208108}, {7300,0.12126126}, {7350,0.12386486}, {7400,0.12525225}, {7450,0.12592793}, {7500,0.12672973}, {7550,0.12876577}, {7600,0.12800000}, {7650,0.12944144}, {7700,0.12984685}, {7750,0.12927027}, {7800,0.12913514}, {7850,0.14558559}, {7900,0.14895495}, {7950,0.14404505}, {8000,0.13018919}, {8050,0.15696396}, {8100,0.14845045}, {8150,0.16224324}, {8200,0.16148649}, {8250,0.15404505}, {8300,0.15289189}, {8350,0.15453153}, {8400,0.15047748}, {8450,0.13715315}, {8500,0.16182883}, {8550,0.16453153}, {8600,0.16327027}, {8650,0.15853153}, {8700,0.16116216}, {8750,0.15364865}, {8800,0.16675676}, {8850,0.18058559}, {8900,0.16393694}, {8950,0.16809009}, {9000,0.15655856}, {9050,0.16498198}, {9100,0.19138739}, {9150,0.16958559}, {9200,0.17590991}, {9250,0.18758559}, {9300,0.17895495}, {9350,0.17073874}, {9400,0.17946847}, {9450,0.17783784}, {9500,0.19291892}, {9550,0.18738739}, {9600,0.16347748}, {9650,0.18131532}, {9700,0.17469369}, {9750,0.17235135}, {9800,0.17185586}, {9850,0.17567568}, {9900,0.18472973}, {9950,0.17976577}, {10000,0.17846847}, {10100,0.18295495}, {10200,0.18964865}, {10300,0.19792793}, {10400,0.20011712}, {10500,0.20859459}, {10600,0.18757658}, {10700,0.20490090}, {10800,0.20316216}, {10900,0.19560360}, {11000,0.20855856}, {11100,0.19963063}, {11200,0.21059459}, {11300,0.20206306}, {11400,0.20717117}, {11500,0.21780180}, {11600,0.20818018}, {11700,0.22998198}, {11800,0.24205405}, {11900,0.23739640}, {12000,0.21981081}, {12100,0.21089189}, {12200,0.25814414}, {12300,0.22422523}, {12400,0.25865766}, {12500,0.27353153}, {12600,0.23111712}, {12700,0.20711712}, {12800,0.26805405}, {12900,0.25449550}, {13000,0.26700000}, {13100,0.23315315}, {13200,0.27620721}, {13300,0.25823423}, {13400,0.25171171}, {13500,0.27373874}, {13600,0.24229730}, {13700,0.27658559}, {13800,0.29724324}, {13900,0.28129730}, {14000,0.25461261}, {14100,0.26823423}, {14200,0.29792793}, {14300,0.26687387}, {14400,0.24241441}, {14500,0.24538739}, {14600,0.25490090}, {14700,0.26654955}, {14800,0.27059459}, {14900,0.27434234}, {15000,0.27363063}, {15100,0.27087387}, {15200,0.26094595}, {15300,0.26417117}, {15400,0.29278378}, {15500,0.29647748}, {15600,0.29951351}, {15700,0.28681982}, {15800,0.33659459}, {15900,0.35131532}, {16000,0.33714414}, {16100,0.30091892}, {16200,0.32942342}, {16300,0.29518018}, {16400,0.33883784}, {16500,0.36259459}, {16600,0.30763063}, {16700,0.31909009}, {16800,0.31572973}, {16900,0.36811712}, {17000,0.29916216}, {17100,0.32100901}, {17200,0.37521622}, {17300,0.33325225}, {17400,0.33765766}, {17500,0.37712613}, {17600,0.32569369}, {17700,0.32332432}, {17800,0.38160360}, {17900,3.87580180}, {18000,0.36751351}, {18100,0.32563063}, {18200,0.33154955}, {18300,0.38416216}, {18400,0.39384685}, {18500,0.38918919}, {18600,0.39761261}, {18700,0.39411712}, {18800,0.36609009}, {18900,0.38477477}, {19000,0.35115315}, {19100,0.34814414}, {19200,0.39573874}, {19300,0.38392793}, {19400,0.41720721}, {19500,0.37150450}, {19600,0.37869369}, {19700,0.39636937}, {19800,0.42085586}, {19900,0.36800000}, {20000,0.40975229}};
data["big_flat"]["OCaml"]["Aggregate"]["system"] = {{1,0.00081081}, {2,0.00027027}, {3,0.00038739}, {4,0.00007207}, {5,0.00003604}, {6,0.00007207}, {7,0.00000000}, {8,0.00002703}, {9,0.00003604}, {10,0.00000000}, {11,0.00000000}, {12,0.00017117}, {13,0.00007207}, {14,0.00003604}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00002703}, {19,0.00003604}, {20,0.00000000}, {21,0.00000000}, {22,0.00006306}, {23,0.00006306}, {24,0.00003604}, {25,0.00003604}, {26,0.00000000}, {27,0.00000000}, {28,0.00003604}, {29,0.00014414}, {30,0.00000000}, {31,0.00003604}, {32,0.00007207}, {33,0.00000000}, {34,0.00000000}, {35,0.00002703}, {36,0.00003604}, {37,0.00000000}, {38,0.00006306}, {39,0.00003604}, {40,0.00007207}, {41,0.00000000}, {42,0.00034234}, {43,0.00003604}, {44,0.00006306}, {45,0.00000000}, {46,0.00002703}, {47,0.00007207}, {48,0.00000000}, {49,0.00014414}, {50,0.00000000}, {51,0.00003604}, {52,0.00006306}, {53,0.00014414}, {54,0.00000000}, {55,0.00003604}, {56,0.00000000}, {57,0.00010811}, {58,0.00000000}, {59,0.00000000}, {60,0.00002703}, {61,0.00000000}, {62,0.00009910}, {63,0.00003604}, {64,0.00000000}, {65,0.00003604}, {66,0.00002703}, {67,0.00000000}, {68,0.00007207}, {69,0.00003604}, {70,0.00000000}, {71,0.00003604}, {72,0.00000000}, {73,0.00003604}, {74,0.00003604}, {75,0.00003604}, {76,0.00003604}, {77,0.00003604}, {78,0.00003604}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00003604}, {84,0.00003604}, {85,0.00003604}, {86,0.00002703}, {87,0.00014414}, {88,0.00003604}, {89,0.00003604}, {90,0.00007207}, {91,0.00000000}, {92,0.00007207}, {93,0.00006306}, {94,0.00007207}, {95,0.00000000}, {96,0.00002703}, {97,0.00002703}, {98,0.00014414}, {99,0.00007207}, {100,0.00000000}, {101,0.00000000}, {102,0.00007207}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00010811}, {108,0.00003604}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00003604}, {113,0.00007207}, {114,0.00000000}, {115,0.00006306}, {116,0.00003604}, {117,0.00002703}, {118,0.00000000}, {119,0.00002703}, {120,0.00000000}, {121,0.00003604}, {122,0.00000000}, {123,0.00000000}, {124,0.00007207}, {125,0.00003604}, {126,0.00003604}, {127,0.00000000}, {128,0.00003604}, {129,0.00007207}, {130,0.00003604}, {131,0.00003604}, {132,0.00014414}, {133,0.00003604}, {134,0.00007207}, {135,0.00009910}, {136,0.00007207}, {137,0.00000000}, {138,0.00003604}, {139,0.00007207}, {140,0.00009910}, {141,0.00007207}, {142,0.00000000}, {143,0.00000000}, {144,0.00009910}, {145,0.00006306}, {146,0.00007207}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00003604}, {153,0.00003604}, {154,0.00003604}, {155,0.00000000}, {156,0.00003604}, {157,0.00007207}, {158,0.00003604}, {159,0.00006306}, {160,0.00000000}, {161,0.00000000}, {162,0.00003604}, {163,0.00007207}, {164,0.00003604}, {165,0.00010811}, {166,0.00003604}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00006306}, {171,0.00000000}, {172,0.00003604}, {173,0.00000000}, {174,0.00003604}, {175,0.00010811}, {176,0.00002703}, {177,0.00009910}, {178,0.00006306}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00006306}, {184,0.00003604}, {185,0.00000000}, {186,0.00003604}, {187,0.00000000}, {188,0.00010811}, {189,0.00003604}, {190,0.00003604}, {191,0.00007207}, {192,0.00003604}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00003604}, {197,0.00002703}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00010811}, {202,0.00009910}, {203,0.00014414}, {204,0.00000000}, {205,0.00006306}, {206,0.00000000}, {207,0.00003604}, {208,0.00010811}, {209,0.00010811}, {210,0.00000000}, {211,0.00003604}, {212,0.00007207}, {213,0.00007207}, {214,0.00014414}, {215,0.00007207}, {216,0.00007207}, {217,0.00000000}, {218,0.00010811}, {219,0.00000000}, {220,0.00007207}, {221,0.00007207}, {222,0.00007207}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00003604}, {227,0.00006306}, {228,0.00003604}, {229,0.00003604}, {230,0.00000000}, {231,0.00000000}, {232,0.00007207}, {233,0.00014414}, {234,0.00003604}, {235,0.00007207}, {236,0.00000000}, {237,0.00000000}, {238,0.00003604}, {239,0.00002703}, {240,0.00003604}, {241,0.00000000}, {242,0.00000000}, {243,0.00007207}, {244,0.00003604}, {245,0.00007207}, {246,0.00000000}, {247,0.00003604}, {248,0.00003604}, {249,0.00010811}, {250,0.00007207}, {251,0.00003604}, {252,0.00006306}, {253,0.00000000}, {254,0.00010811}, {255,0.00000000}, {256,0.00007207}, {257,0.00007207}, {258,0.00000000}, {259,0.00000000}, {260,0.00003604}, {261,0.00007207}, {262,0.00010811}, {263,0.00010811}, {264,0.00000000}, {265,0.00003604}, {266,0.00014414}, {267,0.00002703}, {268,0.00007207}, {269,0.00003604}, {270,0.00003604}, {271,0.00007207}, {272,0.00002703}, {273,0.00000000}, {274,0.00003604}, {275,0.00010811}, {276,0.00007207}, {277,0.00000000}, {278,0.00002703}, {279,0.00003604}, {280,0.00000000}, {281,0.00007207}, {282,0.00007207}, {283,0.00003604}, {284,0.00007207}, {285,0.00013514}, {286,0.00007207}, {287,0.00003604}, {288,0.00003604}, {289,0.00000000}, {290,0.00007207}, {291,0.00000000}, {292,0.00003604}, {293,0.00007207}, {294,0.00000000}, {295,0.00017117}, {296,0.00003604}, {297,0.00000000}, {298,0.00013514}, {299,0.00000000}, {300,0.00000000}, {301,0.00003604}, {302,0.00000000}, {303,0.00010811}, {304,0.00003604}, {305,0.00010811}, {306,0.00000000}, {307,0.00003604}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00006306}, {312,0.00003604}, {313,0.00003604}, {314,0.00003604}, {315,0.00010811}, {316,0.00000000}, {317,0.00013514}, {318,0.00007207}, {319,0.00010811}, {320,0.00009910}, {321,0.00000000}, {322,0.00014414}, {323,0.00006306}, {324,0.00003604}, {325,0.00000000}, {326,0.00003604}, {327,0.00014414}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00009009}, {333,0.00000000}, {334,0.00003604}, {335,0.00013514}, {336,0.00007207}, {337,0.00000000}, {338,0.00009910}, {339,0.00007207}, {340,0.00009910}, {341,0.00003604}, {342,0.00000000}, {343,0.00007207}, {344,0.00003604}, {345,0.00003604}, {346,0.00009910}, {347,0.00007207}, {348,0.00002703}, {349,0.00007207}, {350,0.00007207}, {351,0.00017117}, {352,0.00000000}, {353,0.00000000}, {354,0.00006306}, {355,0.00007207}, {356,0.00006306}, {357,0.00003604}, {358,0.00000000}, {359,0.00014414}, {360,0.00003604}, {361,0.00007207}, {362,0.00006306}, {363,0.00007207}, {364,0.00007207}, {365,0.00000000}, {366,0.00010811}, {367,0.00003604}, {368,0.00003604}, {369,0.00003604}, {370,0.00003604}, {371,0.00003604}, {372,0.00000000}, {373,0.00000000}, {374,0.00003604}, {375,0.00007207}, {376,0.00000000}, {377,0.00000000}, {378,0.00003604}, {379,0.00002703}, {380,0.00003604}, {381,0.00000000}, {382,0.00007207}, {383,0.00003604}, {384,0.00003604}, {385,0.00006306}, {386,0.00007207}, {387,0.00003604}, {388,0.00009910}, {389,0.00010811}, {390,0.00009910}, {391,0.00007207}, {392,0.00000000}, {393,0.00007207}, {394,0.00007207}, {395,0.00000000}, {396,0.00000000}, {397,0.00010811}, {398,0.00007207}, {399,0.00010811}, {400,0.00003604}, {401,0.00014414}, {402,0.00006306}, {403,0.00007207}, {404,0.00000000}, {405,0.00007207}, {406,0.00014414}, {407,0.00007207}, {408,0.00000000}, {409,0.00000000}, {410,0.00007207}, {411,0.00003604}, {412,0.00010811}, {413,0.00006306}, {414,0.00007207}, {415,0.00000000}, {416,0.00000000}, {417,0.00003604}, {418,0.00000000}, {419,0.00003604}, {420,0.00007207}, {421,0.00007207}, {422,0.00009910}, {423,0.00003604}, {424,0.00000000}, {425,0.00009910}, {426,0.00010811}, {427,0.00003604}, {428,0.00000000}, {429,0.00009910}, {430,0.00010811}, {431,0.00010811}, {432,0.00009910}, {433,0.00007207}, {434,0.00003604}, {435,0.00003604}, {436,0.00005405}, {437,0.00003604}, {438,0.00000000}, {439,0.00006306}, {440,0.00000000}, {441,0.00006306}, {442,0.00007207}, {443,0.00007207}, {444,0.00014414}, {445,0.00010811}, {446,0.00009910}, {447,0.00007207}, {448,0.00003604}, {449,0.00000000}, {450,0.00006306}, {451,0.00007207}, {452,0.00014414}, {453,0.00007207}, {454,0.00006306}, {455,0.00000000}, {456,0.00003604}, {457,0.00002703}, {458,0.00000000}, {459,0.00003604}, {460,0.00007207}, {461,0.00007207}, {462,0.00007207}, {463,0.00007207}, {464,0.00000000}, {465,0.00000000}, {466,0.00010811}, {467,0.00007207}, {468,0.00014414}, {469,0.00009910}, {470,0.00007207}, {471,0.00003604}, {472,0.00000000}, {473,0.00000000}, {474,0.00007207}, {475,0.00003604}, {476,0.00003604}, {477,0.00000000}, {478,0.00003604}, {479,0.00003604}, {480,0.00003604}, {481,0.00003604}, {482,0.00010811}, {483,0.00007207}, {484,0.00005405}, {485,0.00007207}, {486,0.00000000}, {487,0.00000000}, {488,0.00003604}, {489,0.00014414}, {490,0.00010811}, {491,0.00014414}, {492,0.00010811}, {493,0.00007207}, {494,0.00010811}, {495,0.00010811}, {496,0.00003604}, {497,0.00000000}, {498,0.00000000}, {499,0.00003604}, {500,0.00003604}, {505,0.00012613}, {510,0.00003604}, {515,0.00003604}, {520,0.00003604}, {525,0.00003604}, {530,0.00013514}, {535,0.00007207}, {540,0.00003604}, {545,0.00003604}, {550,0.00006306}, {555,0.00000000}, {560,0.00007207}, {565,0.00003604}, {570,0.00000000}, {575,0.00003604}, {580,0.00010811}, {585,0.00007207}, {590,0.00010811}, {595,0.00007207}, {600,0.00003604}, {605,0.00000000}, {610,0.00009910}, {615,0.00002703}, {620,0.00003604}, {625,0.00000000}, {630,0.00009910}, {635,0.00007207}, {640,0.00003604}, {645,0.00007207}, {650,0.00007207}, {655,0.00009910}, {660,0.00003604}, {665,0.00014414}, {670,0.00007207}, {675,0.00010811}, {680,0.00003604}, {685,0.00000000}, {690,0.00003604}, {695,0.00014414}, {700,0.00003604}, {705,0.00010811}, {710,0.00013514}, {715,0.00010811}, {720,0.00003604}, {725,0.00003604}, {730,0.00003604}, {735,0.00007207}, {740,0.00016216}, {745,0.00003604}, {750,0.00010811}, {755,0.00010811}, {760,0.00003604}, {765,0.00006306}, {770,0.00010811}, {775,0.00018018}, {780,0.00007207}, {785,0.00010811}, {790,0.00014414}, {795,0.00003604}, {800,0.00014414}, {805,0.00003604}, {810,0.00007207}, {815,0.00007207}, {820,0.00006306}, {825,0.00018018}, {830,0.00014414}, {835,0.00010811}, {840,0.00003604}, {845,0.00000000}, {850,0.00006306}, {855,0.00009009}, {860,0.00003604}, {865,0.00007207}, {870,0.00007207}, {875,0.00014414}, {880,0.00010811}, {885,0.00003604}, {890,0.00003604}, {895,0.00010811}, {900,0.00000000}, {905,0.00003604}, {910,0.00010811}, {915,0.00007207}, {920,0.00007207}, {925,0.00003604}, {930,0.00003604}, {935,0.00007207}, {940,0.00012613}, {945,0.00007207}, {950,0.00002703}, {955,0.00021622}, {960,0.00010811}, {965,0.00003604}, {970,0.00010811}, {975,0.00006306}, {980,0.00000000}, {985,0.00021622}, {990,0.00017117}, {995,0.00010811}, {1000,0.00003604}, {1010,0.00007207}, {1020,0.00007207}, {1030,0.00000000}, {1040,0.00009910}, {1050,0.00007207}, {1060,0.00003604}, {1070,0.00003604}, {1080,0.00007207}, {1090,0.00010811}, {1100,0.00016216}, {1110,0.00016216}, {1120,0.00007207}, {1130,0.00013514}, {1140,0.00018018}, {1150,0.00007207}, {1160,0.00020721}, {1170,0.00027027}, {1180,0.00010811}, {1190,0.00003604}, {1200,0.00000000}, {1210,0.00007207}, {1220,0.00010811}, {1230,0.00003604}, {1240,0.00013514}, {1250,0.00009910}, {1260,0.00003604}, {1270,0.00003604}, {1280,0.00023423}, {1290,0.00017117}, {1300,0.00010811}, {1310,0.00003604}, {1320,0.00014414}, {1330,0.00007207}, {1340,0.00025225}, {1350,0.00018018}, {1360,0.00000000}, {1370,0.00013514}, {1380,0.00006306}, {1390,0.00020721}, {1400,0.00003604}, {1410,0.00007207}, {1420,0.00010811}, {1430,0.00007207}, {1440,0.00019820}, {1450,0.00017117}, {1460,0.00009910}, {1470,0.00007207}, {1480,0.00007207}, {1490,0.00007207}, {1500,0.00003604}, {1510,0.00009910}, {1520,0.00003604}, {1530,0.00010811}, {1540,0.00003604}, {1550,0.00007207}, {1560,0.00017117}, {1570,0.00009910}, {1580,0.00025225}, {1590,0.00003604}, {1600,0.00003604}, {1610,0.00003604}, {1620,0.00010811}, {1630,0.00017117}, {1640,0.00003604}, {1650,0.00000000}, {1660,0.00003604}, {1670,0.00027928}, {1680,0.00000000}, {1690,0.00009910}, {1700,0.00003604}, {1710,0.00036036}, {1720,0.00024324}, {1730,0.00000000}, {1740,0.00013514}, {1750,0.00007207}, {1760,0.00014414}, {1770,0.00007207}, {1780,0.00003604}, {1790,0.00007207}, {1800,0.00010811}, {1810,0.00003604}, {1820,0.00010811}, {1830,0.00013514}, {1840,0.00007207}, {1850,0.00024324}, {1860,0.00003604}, {1870,0.00000000}, {1880,0.00006306}, {1890,0.00003604}, {1900,0.00017117}, {1910,0.00014414}, {1920,0.00009910}, {1930,0.00002703}, {1940,0.00000000}, {1950,0.00019820}, {1960,0.00009910}, {1970,0.00010811}, {1980,0.00000000}, {1990,0.00014414}, {2000,0.00014414}, {2050,0.00003604}, {2100,0.00014414}, {2150,0.00000000}, {2200,0.00003604}, {2250,0.00000000}, {2300,0.00024324}, {2350,0.00006306}, {2400,0.00003604}, {2450,0.00007207}, {2500,0.00016216}, {2550,0.00003604}, {2600,0.00007207}, {2650,0.00006306}, {2700,0.00013514}, {2750,0.00000000}, {2800,0.00014414}, {2850,0.00021622}, {2900,0.00009910}, {2950,0.00025225}, {3000,0.00018018}, {3050,0.00007207}, {3100,0.00016216}, {3150,0.00017117}, {3200,0.00024324}, {3250,0.00014414}, {3300,0.00035135}, {3350,0.00010811}, {3400,0.00002703}, {3450,0.00007207}, {3500,0.00003604}, {3550,0.00024324}, {3600,0.00014414}, {3650,0.00017117}, {3700,0.00010811}, {3750,0.00014414}, {3800,0.00010811}, {3850,0.00007207}, {3900,0.00010811}, {3950,0.00007207}, {4000,0.00036036}, {4050,0.00010811}, {4100,0.00021622}, {4150,0.00025225}, {4200,0.00031532}, {4250,0.00007207}, {4300,0.00017117}, {4350,0.00027928}, {4400,0.00012613}, {4450,0.00045946}, {4500,0.00018018}, {4550,0.00014414}, {4600,0.00025225}, {4650,0.00014414}, {4700,0.00031532}, {4750,0.00010811}, {4800,0.00021622}, {4850,0.00019820}, {4900,0.00003604}, {4950,0.00005405}, {5000,0.00032432}, {5050,0.00013514}, {5100,0.00010811}, {5150,0.00060360}, {5200,0.00048649}, {5250,0.00021622}, {5300,0.00035135}, {5350,0.00027928}, {5400,0.00010811}, {5450,0.00018018}, {5500,0.00035135}, {5550,0.00036036}, {5600,0.00032432}, {5650,0.00007207}, {5700,0.00054054}, {5750,0.00053153}, {5800,0.00198198}, {5850,0.00049550}, {5900,0.00017117}, {5950,0.00036036}, {6000,0.00088288}, {6050,0.00063063}, {6100,0.00021622}, {6150,0.00012613}, {6200,0.00041441}, {6250,0.00036036}, {6300,0.00080180}, {6350,0.00045045}, {6400,0.00045946}, {6450,0.00012613}, {6500,0.00042342}, {6550,0.00036036}, {6600,0.00038739}, {6650,0.00077477}, {6700,0.00052252}, {6750,0.00067568}, {6800,0.00081982}, {6850,0.00036036}, {6900,0.00057658}, {6950,0.00020721}, {7000,0.00028829}, {7050,0.00014414}, {7100,0.00038739}, {7150,0.00021622}, {7200,0.00026126}, {7250,0.00021622}, {7300,0.00027928}, {7350,0.00034234}, {7400,0.00010811}, {7450,0.00017117}, {7500,0.00036036}, {7550,0.00024324}, {7600,0.00027928}, {7650,0.00007207}, {7700,0.00017117}, {7750,0.00016216}, {7800,0.00024324}, {7850,0.00059459}, {7900,0.00056757}, {7950,0.00073874}, {8000,0.00048649}, {8050,0.00088288}, {8100,0.00069369}, {8150,0.00079279}, {8200,0.00075676}, {8250,0.00071171}, {8300,0.00049550}, {8350,0.00045946}, {8400,0.00054054}, {8450,0.00053153}, {8500,0.00096396}, {8550,0.00076577}, {8600,0.00049550}, {8650,0.00054955}, {8700,0.00056757}, {8750,0.00035135}, {8800,0.00049550}, {8850,0.00096396}, {8900,0.00049550}, {8950,0.00043243}, {9000,0.00072072}, {9050,0.00068468}, {9100,0.00098198}, {9150,0.00059459}, {9200,0.00079279}, {9250,0.00081982}, {9300,0.00054955}, {9350,0.00049550}, {9400,0.00066667}, {9450,0.00081982}, {9500,0.00109009}, {9550,0.00070270}, {9600,0.00081081}, {9650,0.00060360}, {9700,0.00030631}, {9750,0.00046847}, {9800,0.00048649}, {9850,0.00053153}, {9900,0.00066667}, {9950,0.00031532}, {10000,0.00027928}, {10100,0.00054054}, {10200,0.00049550}, {10300,0.00049550}, {10400,0.00102703}, {10500,0.00106306}, {10600,0.00064865}, {10700,0.00081982}, {10800,0.00078378}, {10900,0.00056757}, {11000,0.00059459}, {11100,0.00049550}, {11200,0.00066667}, {11300,0.00042342}, {11400,0.00085586}, {11500,0.00053153}, {11600,0.00079279}, {11700,0.00086486}, {11800,0.00025225}, {11900,0.00014414}, {12000,0.00014414}, {12100,0.00010811}, {12200,0.00006306}, {12300,0.00007207}, {12400,0.00020721}, {12500,0.00023423}, {12600,0.00025225}, {12700,0.00007207}, {12800,0.00010811}, {12900,0.00110811}, {13000,0.00117117}, {13100,0.00116216}, {13200,0.00133333}, {13300,0.00098198}, {13400,0.00085586}, {13500,0.00086486}, {13600,0.00071171}, {13700,0.00105405}, {13800,0.00154054}, {13900,0.00091892}, {14000,0.00053153}, {14100,0.00104505}, {14200,0.00103604}, {14300,0.00071171}, {14400,0.00086486}, {14500,0.00104505}, {14600,0.00102703}, {14700,0.00114414}, {14800,0.00100000}, {14900,0.00108108}, {15000,0.00111712}, {15100,0.00090090}, {15200,0.00104505}, {15300,0.00103604}, {15400,0.00168468}, {15500,0.00080180}, {15600,0.00132432}, {15700,0.00007207}, {15800,0.00018919}, {15900,0.00021622}, {16000,0.00000000}, {16100,0.00009910}, {16200,0.00041441}, {16300,0.00025225}, {16400,0.00021622}, {16500,0.00020721}, {16600,0.00031532}, {16700,0.00023423}, {16800,0.00028829}, {16900,0.00031532}, {17000,0.00020721}, {17100,0.00032432}, {17200,0.00020721}, {17300,0.00018018}, {17400,0.00017117}, {17500,0.00028829}, {17600,0.00025225}, {17700,0.00013514}, {17800,0.00021622}, {17900,0.00335135}, {18000,0.00036036}, {18100,0.00007207}, {18200,0.00010811}, {18300,0.00018018}, {18400,0.00014414}, {18500,0.00025225}, {18600,0.00021622}, {18700,0.00020721}, {18800,0.00010811}, {18900,0.00017117}, {19000,0.00025225}, {19100,0.00025225}, {19200,0.00032432}, {19300,0.00030631}, {19400,0.00021622}, {19500,0.00045946}, {19600,0.00021622}, {19700,0.00010811}, {19800,0.00014414}, {19900,0.00021622}, {20000,0.00000000}};
data["big_flat"]["OCaml"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00098198}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00005405}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000901}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000901}, {1040,0.00000000}, {1050,0.00000901}, {1060,0.00001802}, {1070,0.00001802}, {1080,0.00000901}, {1090,0.00001802}, {1100,0.00000901}, {1110,0.00002703}, {1120,0.00003604}, {1130,0.00001802}, {1140,0.00002703}, {1150,0.00008108}, {1160,0.00010811}, {1170,0.00009910}, {1180,0.00010811}, {1190,0.00014414}, {1200,0.00027928}, {1210,0.00027928}, {1220,0.00031532}, {1230,0.00016216}, {1240,0.00042342}, {1250,0.00047748}, {1260,0.00045045}, {1270,0.00054054}, {1280,0.00058559}, {1290,0.00063964}, {1300,0.00072072}, {1310,0.00073874}, {1320,0.00080180}, {1330,0.00087387}, {1340,0.00072973}, {1350,0.00088288}, {1360,0.00094595}, {1370,0.00096396}, {1380,0.00098198}, {1390,0.00100000}, {1400,0.00098198}, {1410,0.00100000}, {1420,0.00100000}, {1430,0.00100000}, {1440,0.00100000}, {1450,0.00100000}, {1460,0.00100000}, {1470,0.00100000}, {1480,0.00100000}, {1490,0.00100000}, {1500,0.00100000}, {1510,0.00100000}, {1520,0.00100000}, {1530,0.00100000}, {1540,0.00100000}, {1550,0.00100000}, {1560,0.00100000}, {1570,0.00100000}, {1580,0.00100000}, {1590,0.00100000}, {1600,0.00100000}, {1610,0.00100000}, {1620,0.00100000}, {1630,0.00100000}, {1640,0.00100000}, {1650,0.00100000}, {1660,0.00100000}, {1670,0.00100000}, {1680,0.00100000}, {1690,0.00100000}, {1700,0.00100000}, {1710,0.00100000}, {1720,0.00100000}, {1730,0.00100000}, {1740,0.00100000}, {1750,0.00100000}, {1760,0.00100000}, {1770,0.00100000}, {1780,0.00100000}, {1790,0.00100000}, {1800,0.00100000}, {1810,0.00100000}, {1820,0.00100000}, {1830,0.00100901}, {1840,0.00100000}, {1850,0.00100000}, {1860,0.00100901}, {1870,0.00100000}, {1880,0.00100901}, {1890,0.00100901}, {1900,0.00100901}, {1910,0.00100000}, {1920,0.00100000}, {1930,0.00100000}, {1940,0.00100000}, {1950,0.00544144}, {1960,0.00100000}, {1970,0.00100000}, {1980,0.00100901}, {1990,0.00100000}, {2000,0.00100000}, {2050,0.00100000}, {2100,0.00101802}, {2150,0.00104505}, {2200,0.00102703}, {2250,0.00109009}, {2300,0.00104505}, {2350,0.00123423}, {2400,0.00145946}, {2450,0.00149550}, {2500,0.00170270}, {2550,0.00185586}, {2600,0.00189189}, {2650,0.00200901}, {2700,0.00200901}, {2750,0.00201802}, {2800,0.00200901}, {2850,0.00205405}, {2900,0.00202703}, {2950,0.00206306}, {3000,0.00209009}, {3050,0.00210811}, {3100,0.00212613}, {3150,0.00209910}, {3200,0.00226126}, {3250,0.00218919}, {3300,0.00230631}, {3350,0.00239640}, {3400,0.00236036}, {3450,0.00246847}, {3500,0.00258559}, {3550,0.00265766}, {3600,0.00284685}, {3650,0.00285586}, {3700,0.00301802}, {3750,0.00301802}, {3800,0.00302703}, {3850,0.00309009}, {3900,0.00321622}, {3950,0.00327027}, {4000,0.00322523}, {4050,0.00338739}, {4100,0.00329730}, {4150,0.00338739}, {4200,0.00290991}, {4250,0.00352252}, {4300,0.00358559}, {4350,0.00367568}, {4400,0.00371171}, {4450,0.00381982}, {4500,0.00395495}, {4550,0.00406306}, {4600,0.00397297}, {4650,0.00416216}, {4700,0.00419820}, {4750,0.00429730}, {4800,0.00428829}, {4850,0.00301802}, {4900,0.00442342}, {4950,0.00445045}, {5000,0.00323423}, {5050,0.00461261}, {5100,0.00471171}, {5150,0.00489189}, {5200,0.00489189}, {5250,0.00491892}, {5300,0.00500000}, {5350,0.00509009}, {5400,0.00503604}, {5450,0.00522523}, {5500,0.00532432}, {5550,0.00539640}, {5600,0.00535135}, {5650,0.00544144}, {5700,0.00547748}, {5750,0.00551351}, {5800,0.00560360}, {5850,0.00566667}, {5900,0.00584685}, {5950,0.00582883}, {6000,0.00622523}, {6050,0.00594595}, {6100,0.00602703}, {6150,0.00613514}, {6200,0.00619820}, {6250,0.00627027}, {6300,0.00659459}, {6350,0.00642342}, {6400,0.00647748}, {6450,0.00646847}, {6500,0.00652252}, {6550,0.00658559}, {6600,0.00664865}, {6650,0.00668468}, {6700,0.00667568}, {6750,0.00674775}, {6800,0.00679279}, {6850,0.00689189}, {6900,0.00705405}, {6950,0.00718919}, {7000,0.00718919}, {7050,0.00735135}, {7100,0.00743243}, {7150,0.00741441}, {7200,0.00746847}, {7250,0.00757658}, {7300,0.00754955}, {7350,0.00756757}, {7400,0.00763063}, {7450,0.00768468}, {7500,0.00767568}, {7550,0.00774775}, {7600,0.00781982}, {7650,0.00792793}, {7700,0.00800000}, {7750,0.00806306}, {7800,0.00820721}, {7850,0.00831532}, {7900,0.00835135}, {7950,0.00848649}, {8000,0.00846847}, {8050,0.00852252}, {8100,0.00856757}, {8150,0.00862162}, {8200,0.00863063}, {8250,0.00865766}, {8300,0.00865766}, {8350,0.00866667}, {8400,0.00872973}, {8450,0.00879279}, {8500,0.00904505}, {8550,0.00895495}, {8600,0.00908108}, {8650,0.00897297}, {8700,0.00915315}, {8750,0.00928829}, {8800,0.00965766}, {8850,0.00952252}, {8900,0.00949550}, {8950,0.00958559}, {9000,0.00961261}, {9050,0.00954054}, {9100,0.00963964}, {9150,0.00963964}, {9200,0.00965766}, {9250,0.00970270}, {9300,0.00974775}, {9350,0.00972072}, {9400,0.00979279}, {9450,0.01013514}, {9500,0.00990090}, {9550,0.01004505}, {9600,0.01017117}, {9650,0.01024324}, {9700,0.01026126}, {9750,0.01042342}, {9800,0.00669369}, {9850,0.01052252}, {9900,0.01057658}, {9950,0.00672973}, {10000,0.01063063}, {10100,0.01065766}, {10200,0.01070270}, {10300,0.01080180}, {10400,0.01094595}, {10500,0.01114414}, {10600,0.01130631}, {10700,0.01147748}, {10800,0.01154955}, {10900,0.00962162}, {11000,0.01165766}, {11100,0.02380180}, {11200,0.01183784}, {11300,0.00772973}, {11400,0.01209910}, {11500,0.01218018}, {11600,0.01238739}, {11700,0.01250450}, {11800,0.01250450}, {11900,0.01270270}, {12000,0.00876577}, {12100,0.01276577}, {12200,0.01299099}, {12300,0.01346847}, {12400,0.01325225}, {12500,0.01325225}, {12600,0.01340541}, {12700,0.01351351}, {12800,0.01357658}, {12900,0.01374775}, {13000,0.01374775}, {13100,0.01390090}, {13200,0.01401802}, {13300,0.01411712}, {13400,0.03914414}, {13500,0.01436036}, {13600,0.01449550}, {13700,0.01459459}, {13800,0.01463964}, {13900,0.01479279}, {14000,0.00976577}, {14100,0.01568468}, {14200,0.01512613}, {14300,0.01527027}, {14400,0.01532432}, {14500,0.01546847}, {14600,0.01552252}, {14700,0.01565766}, {14800,0.01580180}, {14900,0.01593694}, {15000,0.01602703}, {15100,0.01609910}, {15200,0.01620721}, {15300,0.01630631}, {15400,0.01632432}, {15500,0.01649550}, {15600,0.01714414}, {15700,0.03608108}, {15800,0.01681982}, {15900,0.01696396}, {16000,0.01707207}, {16100,0.01720721}, {16200,0.01726126}, {16300,0.01772973}, {16400,0.01739640}, {16500,0.01758559}, {16600,0.01763964}, {16700,0.01783784}, {16800,0.01245045}, {16900,0.01810811}, {17000,0.01815315}, {17100,0.01869369}, {17200,0.01830631}, {17300,0.01842342}, {17400,0.01857658}, {17500,0.01872973}, {17600,0.01890090}, {17700,0.01929730}, {17800,0.01906306}, {17900,0.01919820}, {18000,0.01927928}, {18100,0.01940541}, {18200,0.03033333}, {18300,0.01957658}, {18400,0.02001802}, {18500,0.01981982}, {18600,0.02030631}, {18700,0.02015315}, {18800,0.02041441}, {18900,0.02028829}, {19000,0.03217117}, {19100,0.02045946}, {19200,0.02051351}, {19300,0.02065766}, {19400,0.02075676}, {19500,0.02110811}, {19600,0.02097297}, {19700,0.02109910}, {19800,0.02121622}, {19900,0.02131532}, {20000,0.02140367}};
data["big_flat"]["OCaml"]["actual reif"]["user"] = {{1,0.00005405}, {2,0.00008108}, {3,0.00007207}, {4,0.00011712}, {5,0.00012613}, {6,0.00013514}, {7,0.00005405}, {8,0.00007207}, {9,0.00009009}, {10,0.00013514}, {11,0.00008108}, {12,0.00006306}, {13,0.00007207}, {14,0.00017117}, {15,0.00009009}, {16,0.00013514}, {17,0.00021622}, {18,0.00013514}, {19,0.00007207}, {20,0.00011712}, {21,0.00007207}, {22,0.00009910}, {23,0.00011712}, {24,0.00018018}, {25,0.00012613}, {26,0.00006306}, {27,0.00012613}, {28,0.00013514}, {29,0.00011712}, {30,0.00012613}, {31,0.00009009}, {32,0.00031532}, {33,0.00018018}, {34,0.00011712}, {35,0.00013514}, {36,0.00007207}, {37,0.00021622}, {38,0.00010811}, {39,0.00018018}, {40,0.00006306}, {41,0.00016216}, {42,0.00013514}, {43,0.00009910}, {44,0.00016216}, {45,0.00017117}, {46,0.00010811}, {47,0.00018018}, {48,0.00019820}, {49,0.00012613}, {50,0.00013514}, {51,0.00009009}, {52,0.00010811}, {53,0.00013514}, {54,0.00024324}, {55,0.00012613}, {56,0.00016216}, {57,0.00012613}, {58,0.00008108}, {59,0.00009009}, {60,0.00015315}, {61,0.00019820}, {62,0.00026126}, {63,0.00013514}, {64,0.00018919}, {65,0.00012613}, {66,0.00011712}, {67,0.00017117}, {68,0.00015315}, {69,0.00022523}, {70,0.00014414}, {71,0.00011712}, {72,0.00017117}, {73,0.00018018}, {74,0.00009910}, {75,0.00021622}, {76,0.00019820}, {77,0.00015315}, {78,0.00011712}, {79,0.00009910}, {80,0.00009910}, {81,0.00013514}, {82,0.00022523}, {83,0.00028829}, {84,0.00023423}, {85,0.00014414}, {86,0.00020721}, {87,0.00009009}, {88,0.00018018}, {89,0.00023423}, {90,0.00022523}, {91,0.00011712}, {92,0.00009910}, {93,0.00024324}, {94,0.00014414}, {95,0.00018018}, {96,0.00015315}, {97,0.00018018}, {98,0.00135135}, {99,0.00009009}, {100,0.00011712}, {101,0.00034234}, {102,0.00015315}, {103,0.00018018}, {104,0.00015315}, {105,0.00009910}, {106,0.00025225}, {107,0.00016216}, {108,0.00025225}, {109,0.00019820}, {110,0.00029730}, {111,0.00020721}, {112,0.00015315}, {113,0.00018919}, {114,0.00022523}, {115,0.00014414}, {116,0.00018919}, {117,0.00041441}, {118,0.00011712}, {119,0.00015315}, {120,0.00013514}, {121,0.00017117}, {122,0.00018018}, {123,0.00026126}, {124,0.00021622}, {125,0.00013514}, {126,0.00026126}, {127,0.00027027}, {128,0.00014414}, {129,0.00028829}, {130,0.00029730}, {131,0.00024324}, {132,0.00032432}, {133,0.00020721}, {134,0.00016216}, {135,0.00016216}, {136,0.00026126}, {137,0.00035135}, {138,0.00028829}, {139,0.00020721}, {140,0.00015315}, {141,0.00014414}, {142,0.00011712}, {143,0.00021622}, {144,0.00017117}, {145,0.00014414}, {146,0.00022523}, {147,0.00023423}, {148,0.00018919}, {149,0.00020721}, {150,0.00017117}, {151,0.00027027}, {152,0.00009009}, {153,0.00036036}, {154,0.00009910}, {155,0.00027928}, {156,0.00009009}, {157,0.00025225}, {158,0.00036036}, {159,0.00020721}, {160,0.00022523}, {161,0.00028829}, {162,0.00023423}, {163,0.00027928}, {164,0.00014414}, {165,0.00023423}, {166,0.00026126}, {167,0.00021622}, {168,0.00009009}, {169,0.00021622}, {170,0.00022523}, {171,0.00052252}, {172,0.00022523}, {173,0.00021622}, {174,0.00018919}, {175,0.00016216}, {176,0.00028829}, {177,0.00016216}, {178,0.00028829}, {179,0.00024324}, {180,0.00003604}, {181,0.00034234}, {182,0.00027027}, {183,0.00016216}, {184,0.00023423}, {185,0.00029730}, {186,0.00033333}, {187,0.00036937}, {188,0.00032432}, {189,0.00014414}, {190,0.00031532}, {191,0.00023423}, {192,0.00022523}, {193,0.00017117}, {194,0.00041441}, {195,0.00032432}, {196,0.00021622}, {197,0.00022523}, {198,0.00023423}, {199,0.00029730}, {200,0.00022523}, {201,0.00030631}, {202,0.00023423}, {203,0.00053153}, {204,0.00022523}, {205,0.00023423}, {206,0.00023423}, {207,0.00019820}, {208,0.00024324}, {209,0.00029730}, {210,0.00023423}, {211,0.00021622}, {212,0.00019820}, {213,0.00015315}, {214,0.00018018}, {215,0.00026126}, {216,0.00018919}, {217,0.00023423}, {218,0.00028829}, {219,0.00038739}, {220,0.00027928}, {221,0.00047748}, {222,0.00027928}, {223,0.00040541}, {224,0.00041441}, {225,0.00027928}, {226,0.00030631}, {227,0.00025225}, {228,0.00033333}, {229,0.00022523}, {230,0.00039640}, {231,0.00027928}, {232,0.00030631}, {233,0.00022523}, {234,0.00023423}, {235,0.00021622}, {236,0.00021622}, {237,0.00018018}, {238,0.00006306}, {239,0.00016216}, {240,0.00028829}, {241,0.00026126}, {242,0.00026126}, {243,0.00027027}, {244,0.00016216}, {245,0.00017117}, {246,0.00031532}, {247,0.00031532}, {248,0.00037838}, {249,0.00022523}, {250,0.00028829}, {251,0.00024324}, {252,0.00019820}, {253,0.00032432}, {254,0.00022523}, {255,0.00031532}, {256,0.00022523}, {257,0.00014414}, {258,0.00027928}, {259,0.00045946}, {260,0.00018018}, {261,0.00015315}, {262,0.00018919}, {263,0.00038739}, {264,0.00037838}, {265,0.00023423}, {266,0.00032432}, {267,0.00027928}, {268,0.00025225}, {269,0.00037838}, {270,0.00019820}, {271,0.00030631}, {272,0.00027928}, {273,0.00027928}, {274,0.00032432}, {275,0.00016216}, {276,0.00027027}, {277,0.00043243}, {278,0.00045946}, {279,0.00027027}, {280,0.00032432}, {281,0.00016216}, {282,0.00012613}, {283,0.00024324}, {284,0.00036036}, {285,0.00038739}, {286,0.00050450}, {287,0.00016216}, {288,0.00005405}, {289,0.00042342}, {290,0.00027928}, {291,0.00027027}, {292,0.00027928}, {293,0.00038739}, {294,0.00028829}, {295,0.00023423}, {296,0.00041441}, {297,0.00038739}, {298,0.00028829}, {299,0.00030631}, {300,0.00027928}, {301,0.00046847}, {302,0.00021622}, {303,0.00055856}, {304,0.00036937}, {305,0.00029730}, {306,0.00022523}, {307,0.00032432}, {308,0.00034234}, {309,0.00029730}, {310,0.00034234}, {311,0.00026126}, {312,0.00043243}, {313,0.00020721}, {314,0.00049550}, {315,0.00035135}, {316,0.00044144}, {317,0.00026126}, {318,0.00033333}, {319,0.00025225}, {320,0.00020721}, {321,0.00016216}, {322,0.00031532}, {323,0.00046847}, {324,0.00022523}, {325,0.00022523}, {326,0.00040541}, {327,0.00021622}, {328,0.00032432}, {329,0.00016216}, {330,0.00042342}, {331,0.00018919}, {332,0.00025225}, {333,0.00030631}, {334,0.00029730}, {335,0.00039640}, {336,0.00029730}, {337,0.00054054}, {338,0.00047748}, {339,0.00049550}, {340,0.00031532}, {341,0.00027027}, {342,0.00063063}, {343,0.00036937}, {344,0.00048649}, {345,0.00045946}, {346,0.00028829}, {347,0.00042342}, {348,0.00043243}, {349,0.00015315}, {350,0.00039640}, {351,0.00034234}, {352,0.00021622}, {353,0.00031532}, {354,0.00027928}, {355,0.00031532}, {356,0.00041441}, {357,0.00045045}, {358,0.00036937}, {359,0.00031532}, {360,0.00040541}, {361,0.00033333}, {362,0.00035135}, {363,0.00036036}, {364,0.00030631}, {365,0.00035135}, {366,0.00029730}, {367,0.00031532}, {368,0.00027928}, {369,0.00036937}, {370,0.00020721}, {371,0.00029730}, {372,0.00035135}, {373,0.00038739}, {374,0.00033333}, {375,0.00034234}, {376,0.00043243}, {377,0.00039640}, {378,0.00034234}, {379,0.00047748}, {380,0.00018018}, {381,0.00023423}, {382,0.00049550}, {383,0.00023423}, {384,0.00049550}, {385,0.00036036}, {386,0.00036937}, {387,0.00045045}, {388,0.00036036}, {389,0.00025225}, {390,0.00035135}, {391,0.00017117}, {392,0.00037838}, {393,0.00029730}, {394,0.00040541}, {395,0.00038739}, {396,0.00018919}, {397,0.00037838}, {398,0.00022523}, {399,0.00039640}, {400,0.00020721}, {401,0.00045045}, {402,0.00031532}, {403,0.00033333}, {404,0.00026126}, {405,0.00034234}, {406,0.00027928}, {407,0.00031532}, {408,0.00036937}, {409,0.00027928}, {410,0.00026126}, {411,0.00025225}, {412,0.00043243}, {413,0.00020721}, {414,0.00052252}, {415,0.00024324}, {416,0.00032432}, {417,0.00036036}, {418,0.00036937}, {419,0.00040541}, {420,0.00018919}, {421,0.00049550}, {422,0.00026126}, {423,0.00047748}, {424,0.00055856}, {425,0.00039640}, {426,0.00036036}, {427,0.00039640}, {428,0.00029730}, {429,0.00051351}, {430,0.00044144}, {431,0.00026126}, {432,0.00064865}, {433,0.00044144}, {434,0.00060360}, {435,0.00042342}, {436,0.00026126}, {437,0.00037838}, {438,0.00036036}, {439,0.00031532}, {440,0.00037838}, {441,0.00040541}, {442,0.00030631}, {443,0.00035135}, {444,0.00055856}, {445,0.00043243}, {446,0.00033333}, {447,0.00034234}, {448,0.00045045}, {449,0.00039640}, {450,0.00046847}, {451,0.00039640}, {452,0.00051351}, {453,0.00036937}, {454,0.00043243}, {455,0.00037838}, {456,0.00056757}, {457,0.00046847}, {458,0.00025225}, {459,0.00068468}, {460,0.00043243}, {461,0.00049550}, {462,0.00033333}, {463,0.00037838}, {464,0.00056757}, {465,0.00017117}, {466,0.00029730}, {467,0.00026126}, {468,0.00049550}, {469,0.00032432}, {470,0.00031532}, {471,0.00046847}, {472,0.00065766}, {473,0.00035135}, {474,0.00027027}, {475,0.00048649}, {476,0.00031532}, {477,0.00045946}, {478,0.00033333}, {479,0.00036937}, {480,0.00064865}, {481,0.00022523}, {482,0.00019820}, {483,0.00049550}, {484,0.00056757}, {485,0.00033333}, {486,0.00048649}, {487,0.00053153}, {488,0.00045946}, {489,0.00042342}, {490,0.00016216}, {491,0.00045045}, {492,0.00056757}, {493,0.00052252}, {494,0.00032432}, {495,0.00033333}, {496,0.00045045}, {497,0.00049550}, {498,0.00055856}, {499,0.00058559}, {500,0.00033333}, {505,0.00036036}, {510,0.00035135}, {515,0.00057658}, {520,0.00040541}, {525,0.00036036}, {530,0.00041441}, {535,0.00038739}, {540,0.00035135}, {545,0.00051351}, {550,0.00051351}, {555,0.00054054}, {560,0.00042342}, {565,0.00039640}, {570,0.00036937}, {575,0.00054955}, {580,0.00058559}, {585,0.00053153}, {590,0.00082883}, {595,0.00028829}, {600,0.00032432}, {605,0.00042342}, {610,0.00039640}, {615,0.00051351}, {620,0.00023423}, {625,0.00050450}, {630,0.00049550}, {635,0.00045946}, {640,0.00051351}, {645,0.00065766}, {650,0.00063063}, {655,0.00047748}, {660,0.00030631}, {665,0.00046847}, {670,0.00047748}, {675,0.00040541}, {680,0.00081081}, {685,0.00049550}, {690,0.00054955}, {695,0.00052252}, {700,0.00064865}, {705,0.00036937}, {710,0.00066667}, {715,0.00061261}, {720,0.00066667}, {725,0.00067568}, {730,0.00056757}, {735,0.00061261}, {740,0.00072072}, {745,0.00063964}, {750,0.00048649}, {755,0.00055856}, {760,0.00039640}, {765,0.00037838}, {770,0.00066667}, {775,0.00038739}, {780,0.00054054}, {785,0.00057658}, {790,0.00050450}, {795,0.00071171}, {800,0.00047748}, {805,0.00081081}, {810,0.00053153}, {815,0.00034234}, {820,0.00048649}, {825,0.00069369}, {830,0.00082883}, {835,0.00045045}, {840,0.00062162}, {845,0.00069369}, {850,0.00043243}, {855,0.00081982}, {860,0.00066667}, {865,0.00059459}, {870,0.00063964}, {875,0.00075676}, {880,0.00047748}, {885,0.00068468}, {890,0.00066667}, {895,0.00063063}, {900,0.00072072}, {905,0.00054955}, {910,0.00046847}, {915,0.00068468}, {920,0.00061261}, {925,0.00070270}, {930,0.00067568}, {935,0.00074775}, {940,0.00048649}, {945,0.00072973}, {950,0.00063063}, {955,0.00081081}, {960,0.00090991}, {965,0.00088288}, {970,0.00059459}, {975,0.00057658}, {980,0.00084685}, {985,0.00080180}, {990,0.00087387}, {995,0.00070270}, {1000,0.00060360}, {1010,0.00077477}, {1020,0.00083784}, {1030,0.00037838}, {1040,0.00090090}, {1050,0.00093694}, {1060,0.00062162}, {1070,0.00063964}, {1080,0.00069369}, {1090,0.00087387}, {1100,0.00096396}, {1110,0.00077477}, {1120,0.00083784}, {1130,0.00075676}, {1140,0.00081982}, {1150,0.00090090}, {1160,0.00071171}, {1170,0.00075676}, {1180,0.00094595}, {1190,0.00100901}, {1200,0.00108108}, {1210,0.00095495}, {1220,0.00086486}, {1230,0.00086486}, {1240,0.00089189}, {1250,0.00093694}, {1260,0.00100901}, {1270,0.00077477}, {1280,0.00111712}, {1290,0.00070270}, {1300,0.00124324}, {1310,0.00104505}, {1320,0.00094595}, {1330,0.00091892}, {1340,0.00092793}, {1350,0.00076577}, {1360,0.00101802}, {1370,0.00103604}, {1380,0.00125225}, {1390,0.00109009}, {1400,0.00074775}, {1410,0.00099099}, {1420,0.00124324}, {1430,0.00094595}, {1440,0.00096396}, {1450,0.00100000}, {1460,0.00098198}, {1470,0.00100901}, {1480,0.00109910}, {1490,0.00118018}, {1500,0.00095495}, {1510,0.00123423}, {1520,0.00113514}, {1530,0.00127027}, {1540,0.00098198}, {1550,0.00103604}, {1560,0.00105405}, {1570,0.00113514}, {1580,0.00122523}, {1590,0.00123423}, {1600,0.00121622}, {1610,0.00103604}, {1620,0.00101802}, {1630,0.00123423}, {1640,0.00128829}, {1650,0.00130631}, {1660,0.00148649}, {1670,0.00106306}, {1680,0.00102703}, {1690,0.00129730}, {1700,0.00131532}, {1710,0.00118018}, {1720,0.00115315}, {1730,0.00090991}, {1740,0.00142342}, {1750,0.00130631}, {1760,0.00102703}, {1770,0.00129730}, {1780,0.00110811}, {1790,0.00120721}, {1800,0.00130631}, {1810,0.00108108}, {1820,0.00116216}, {1830,0.00121622}, {1840,0.00151351}, {1850,0.00147748}, {1860,0.00137838}, {1870,0.00121622}, {1880,0.00162162}, {1890,0.00134234}, {1900,0.00139640}, {1910,0.00136937}, {1920,0.00125225}, {1930,0.00137838}, {1940,0.00120721}, {1950,0.00507207}, {1960,0.00150450}, {1970,0.00157658}, {1980,0.00197297}, {1990,0.00128829}, {2000,0.00165766}, {2050,0.00130631}, {2100,0.00152252}, {2150,0.00171171}, {2200,0.00178378}, {2250,0.00141441}, {2300,0.00130631}, {2350,0.00139640}, {2400,0.00172072}, {2450,0.00187387}, {2500,0.00166667}, {2550,0.00238739}, {2600,0.00178378}, {2650,0.00192793}, {2700,0.00190090}, {2750,0.00217117}, {2800,0.00207207}, {2850,0.00222523}, {2900,0.00215315}, {2950,0.00245045}, {3000,0.00200000}, {3050,0.00227027}, {3100,0.00236937}, {3150,0.00239640}, {3200,0.00239640}, {3250,0.00272072}, {3300,0.00263063}, {3350,0.00262162}, {3400,0.00250450}, {3450,0.00295495}, {3500,0.00263964}, {3550,0.00268468}, {3600,0.00307207}, {3650,0.00289189}, {3700,0.00319820}, {3750,0.00305405}, {3800,0.00304505}, {3850,0.00300000}, {3900,0.00335135}, {3950,0.00336937}, {4000,0.00325225}, {4050,0.00341441}, {4100,0.00354955}, {4150,0.00361261}, {4200,0.00309910}, {4250,0.00365766}, {4300,0.00369369}, {4350,0.00382883}, {4400,0.00398198}, {4450,0.00381982}, {4500,0.00404505}, {4550,0.00408108}, {4600,0.00385586}, {4650,0.00436937}, {4700,0.00425225}, {4750,0.00437838}, {4800,0.00431532}, {4850,0.00317117}, {4900,0.00442342}, {4950,0.00453153}, {5000,0.00362162}, {5050,0.00496396}, {5100,0.00454955}, {5150,0.00480180}, {5200,0.00481081}, {5250,0.00472973}, {5300,0.00479279}, {5350,0.00494595}, {5400,0.00477477}, {5450,0.00531532}, {5500,0.00548649}, {5550,0.00540541}, {5600,0.00541441}, {5650,0.00519820}, {5700,0.00554955}, {5750,0.00549550}, {5800,0.00544144}, {5850,0.00570270}, {5900,0.00548649}, {5950,0.00576577}, {6000,0.00607207}, {6050,0.00598198}, {6100,0.00618919}, {6150,0.00613514}, {6200,0.00587387}, {6250,0.00605405}, {6300,0.00631532}, {6350,0.00601802}, {6400,0.00618919}, {6450,0.00636036}, {6500,0.00622523}, {6550,0.00654955}, {6600,0.00663063}, {6650,0.00655856}, {6700,0.00640541}, {6750,0.00671171}, {6800,0.00656757}, {6850,0.00672072}, {6900,0.00673874}, {6950,0.00692793}, {7000,0.00690991}, {7050,0.00705405}, {7100,0.00719820}, {7150,0.00705405}, {7200,0.00678378}, {7250,0.00716216}, {7300,0.00742342}, {7350,0.00742342}, {7400,0.00749550}, {7450,0.00739640}, {7500,0.00754955}, {7550,0.00765766}, {7600,0.00752252}, {7650,0.00790991}, {7700,0.00790991}, {7750,0.00796396}, {7800,0.00816216}, {7850,0.00831532}, {7900,0.00804505}, {7950,0.00798198}, {8000,0.00825225}, {8050,0.00864865}, {8100,0.00833333}, {8150,0.00853153}, {8200,0.00902703}, {8250,0.00896396}, {8300,0.00850450}, {8350,0.00890991}, {8400,0.00929730}, {8450,0.00875676}, {8500,0.00937838}, {8550,0.00920721}, {8600,0.00942342}, {8650,0.00936937}, {8700,0.00924324}, {8750,0.00947748}, {8800,0.00995495}, {8850,0.00935135}, {8900,0.00986486}, {8950,0.00972072}, {9000,0.00949550}, {9050,0.00980180}, {9100,0.01015315}, {9150,0.01005405}, {9200,0.01031532}, {9250,0.01041441}, {9300,0.01006306}, {9350,0.01006306}, {9400,0.01015315}, {9450,0.01045946}, {9500,0.01040541}, {9550,0.01024324}, {9600,0.01072072}, {9650,0.01042342}, {9700,0.01063063}, {9750,0.01096396}, {9800,0.00669369}, {9850,0.01063964}, {9900,0.01067568}, {9950,0.00697297}, {10000,0.01089189}, {10100,0.01116216}, {10200,0.01118919}, {10300,0.01127027}, {10400,0.01154955}, {10500,0.01159459}, {10600,0.01168468}, {10700,0.01190090}, {10800,0.01200000}, {10900,0.00963964}, {11000,0.01200901}, {11100,0.02371171}, {11200,0.01221622}, {11300,0.00781982}, {11400,0.01215315}, {11500,0.01250450}, {11600,0.01265766}, {11700,0.01268468}, {11800,0.01270270}, {11900,0.01303604}, {12000,0.00918919}, {12100,0.01309009}, {12200,0.01338739}, {12300,0.01338739}, {12400,0.01330631}, {12500,0.01320721}, {12600,0.01340541}, {12700,0.01368468}, {12800,0.01367568}, {12900,0.01381081}, {13000,0.01390991}, {13100,0.01414414}, {13200,0.01421622}, {13300,0.01388288}, {13400,0.03854054}, {13500,0.01432432}, {13600,0.01448649}, {13700,0.01460360}, {13800,0.01466667}, {13900,0.01479279}, {14000,0.01026126}, {14100,0.01550450}, {14200,0.01495495}, {14300,0.01495495}, {14400,0.01517117}, {14500,0.01504505}, {14600,0.01517117}, {14700,0.01572072}, {14800,0.01578378}, {14900,0.01582883}, {15000,0.01604505}, {15100,0.01590991}, {15200,0.01615315}, {15300,0.01593694}, {15400,0.01643243}, {15500,0.01654054}, {15600,0.01717117}, {15700,0.03614414}, {15800,0.01642342}, {15900,0.01690090}, {16000,0.01700901}, {16100,0.01716216}, {16200,0.01719820}, {16300,0.01775676}, {16400,0.01765766}, {16500,0.01719820}, {16600,0.01775676}, {16700,0.01754955}, {16800,0.01263063}, {16900,0.01784685}, {17000,0.01824324}, {17100,0.01866667}, {17200,0.01843243}, {17300,0.01815315}, {17400,0.01884685}, {17500,0.01865766}, {17600,0.01890090}, {17700,0.01923423}, {17800,0.01904505}, {17900,0.01900901}, {18000,0.01909009}, {18100,0.01916216}, {18200,0.03023423}, {18300,0.01911712}, {18400,0.01993694}, {18500,0.01963964}, {18600,0.02051351}, {18700,0.01942342}, {18800,0.02070270}, {18900,0.02046847}, {19000,0.03236036}, {19100,0.02054955}, {19200,0.02049550}, {19300,0.02054955}, {19400,0.02071171}, {19500,0.02087387}, {19600,0.02096396}, {19700,0.02109009}, {19800,0.02136036}, {19900,0.02132432}, {20000,0.02166055}};
data["big_flat"]["OCaml"]["actual reif"]["system"] = {{1,0.00017117}, {2,0.00000000}, {3,0.00007207}, {4,0.00003604}, {5,0.00000000}, {6,0.00003604}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003604}, {13,0.00000000}, {14,0.00003604}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00002703}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00002703}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00003604}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00003604}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00003604}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00003604}, {69,0.00000000}, {70,0.00000000}, {71,0.00003604}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00010811}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00003604}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00003604}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00003604}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00003604}, {158,0.00003604}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00003604}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00003604}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00003604}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00003604}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00007207}, {255,0.00000000}, {256,0.00000000}, {257,0.00003604}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003604}, {266,0.00003604}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00003604}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00003604}, {296,0.00000000}, {297,0.00000000}, {298,0.00002703}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00007207}, {316,0.00000000}, {317,0.00000000}, {318,0.00003604}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00003604}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00002703}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00003604}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00002703}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00003604}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00003604}, {375,0.00003604}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00003604}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00003604}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00003604}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00002703}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00003604}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00003604}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00003604}, {431,0.00000000}, {432,0.00000000}, {433,0.00003604}, {434,0.00000000}, {435,0.00003604}, {436,0.00000000}, {437,0.00003604}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00002703}, {442,0.00000000}, {443,0.00003604}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00003604}, {448,0.00000000}, {449,0.00000000}, {450,0.00002703}, {451,0.00000000}, {452,0.00003604}, {453,0.00003604}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00003604}, {460,0.00000000}, {461,0.00000000}, {462,0.00003604}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00003604}, {476,0.00003604}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00003604}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00003604}, {490,0.00000000}, {491,0.00000000}, {492,0.00002703}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00003604}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00002703}, {660,0.00003604}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00003604}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00003604}, {760,0.00003604}, {765,0.00000000}, {770,0.00000000}, {775,0.00003604}, {780,0.00000000}, {785,0.00003604}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00003604}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00003604}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00003604}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00003604}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00003604}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00005405}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00003604}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00003604}, {1350,0.00007207}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00003604}, {1420,0.00000000}, {1430,0.00003604}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00003604}, {1520,0.00000000}, {1530,0.00003604}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00003604}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00003604}, {1630,0.00003604}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003604}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00003604}, {1730,0.00000000}, {1740,0.00003604}, {1750,0.00003604}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00003604}, {1850,0.00007207}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00003604}, {1910,0.00003604}, {1920,0.00002703}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00017117}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00007207}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00007207}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00002703}, {2700,0.00002703}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00007207}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00003604}, {3050,0.00003604}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00003604}, {3300,0.00003604}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00003604}, {3900,0.00000000}, {3950,0.00003604}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00003604}, {4150,0.00010811}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00009910}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00003604}, {4550,0.00003604}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00007207}, {4800,0.00007207}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00003604}, {5200,0.00000000}, {5250,0.00007207}, {5300,0.00000000}, {5350,0.00003604}, {5400,0.00000000}, {5450,0.00003604}, {5500,0.00003604}, {5550,0.00000000}, {5600,0.00003604}, {5650,0.00000000}, {5700,0.00007207}, {5750,0.00003604}, {5800,0.00007207}, {5850,0.00003604}, {5900,0.00003604}, {5950,0.00003604}, {6000,0.00007207}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00002703}, {6250,0.00000000}, {6300,0.00003604}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00003604}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00007207}, {6750,0.00000000}, {6800,0.00003604}, {6850,0.00003604}, {6900,0.00003604}, {6950,0.00006306}, {7000,0.00003604}, {7050,0.00000000}, {7100,0.00007207}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00003604}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00003604}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00003604}, {8150,0.00003604}, {8200,0.00000000}, {8250,0.00003604}, {8300,0.00003604}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00006306}, {8550,0.00003604}, {8600,0.00007207}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00003604}, {8900,0.00003604}, {8950,0.00000000}, {9000,0.00003604}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00002703}, {9350,0.00000000}, {9400,0.00002703}, {9450,0.00000000}, {9500,0.00009910}, {9550,0.00003604}, {9600,0.00003604}, {9650,0.00007207}, {9700,0.00000000}, {9750,0.00003604}, {9800,0.00002703}, {9850,0.00003604}, {9900,0.00003604}, {9950,0.00000000}, {10000,0.00003604}, {10100,0.00003604}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00007207}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00024324}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00010811}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00003604}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00009009}, {13100,0.00007207}, {13200,0.00000000}, {13300,0.00003604}, {13400,0.00067568}, {13500,0.00000000}, {13600,0.00003604}, {13700,0.00000000}, {13800,0.00003604}, {13900,0.00006306}, {14000,0.00000000}, {14100,0.00003604}, {14200,0.00003604}, {14300,0.00003604}, {14400,0.00003604}, {14500,0.00003604}, {14600,0.00003604}, {14700,0.00007207}, {14800,0.00003604}, {14900,0.00000000}, {15000,0.00010811}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00003604}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00009910}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00003604}, {16400,0.00000000}, {16500,0.00003604}, {16600,0.00000000}, {16700,0.00003604}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00003604}, {17100,0.00003604}, {17200,0.00007207}, {17300,0.00000000}, {17400,0.00003604}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00003604}, {18000,0.00003604}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00007207}, {18600,0.00000000}, {18700,0.00003604}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00007207}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00006306}, {19600,0.00003604}, {19700,0.00007207}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["OCaml"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00098198}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00001802}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00098198}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00098198}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00001802}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00002703}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000901}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00127928}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00001802}, {406,0.00117117}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000901}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000901}, {418,0.00000901}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000901}, {425,0.00000000}, {426,0.00001802}, {427,0.00001802}, {428,0.00001802}, {429,0.00007207}, {430,0.00000000}, {431,0.00005405}, {432,0.00004505}, {433,0.00002703}, {434,0.00007207}, {435,0.00007207}, {436,0.00007207}, {437,0.00011712}, {438,0.00016216}, {439,0.00014414}, {440,0.00015315}, {441,0.00024324}, {442,0.00019820}, {443,0.00027928}, {444,0.00023423}, {445,0.00033333}, {446,0.00045045}, {447,0.00036937}, {448,0.00042342}, {449,0.00053153}, {450,0.00048649}, {451,0.00053153}, {452,0.00062162}, {453,0.00060360}, {454,0.00064865}, {455,0.00063063}, {456,0.00063063}, {457,0.00063964}, {458,0.00069369}, {459,0.00068468}, {460,0.00065766}, {461,0.00072072}, {462,0.00070270}, {463,0.00069369}, {464,0.00075676}, {465,0.00075676}, {466,0.00076577}, {467,0.00081982}, {468,0.00077477}, {469,0.00078378}, {470,0.00081081}, {471,0.00084685}, {472,0.00090090}, {473,0.00092793}, {474,0.00097297}, {475,0.00095495}, {476,0.00094595}, {477,0.00092793}, {478,0.00098198}, {479,0.00095495}, {480,0.00099099}, {481,0.00100000}, {482,0.00096396}, {483,0.00099099}, {484,0.00100000}, {485,0.00100000}, {486,0.00100000}, {487,0.00100000}, {488,0.00100000}, {489,0.00100000}, {490,0.00100000}, {491,0.00100000}, {492,0.00100000}, {493,0.00100000}, {494,0.00100000}, {495,0.00100000}, {496,0.00100000}, {497,0.00100000}, {498,0.00099099}, {499,0.00100000}, {500,0.00100000}, {505,0.00100000}, {510,0.00100000}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00100000}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00305405}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00101802}, {790,0.00425225}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00101802}, {830,0.00105405}, {835,0.00102703}, {840,0.00101802}, {845,0.00105405}, {850,0.00107207}, {855,0.00108108}, {860,0.00116216}, {865,0.00122523}, {870,0.00121622}, {875,0.00134234}, {880,0.00141441}, {885,0.00154955}, {890,0.00156757}, {895,0.00167568}, {900,0.00172973}, {905,0.00171171}, {910,0.00180180}, {915,0.00179279}, {920,0.00182883}, {925,0.00187387}, {930,0.00195495}, {935,0.00193694}, {940,0.00196396}, {945,0.00200000}, {950,0.00435135}, {955,0.00199099}, {960,0.00200000}, {965,0.00200000}, {970,0.00200000}, {975,0.00200000}, {980,0.00200000}, {985,0.00200000}, {990,0.00200000}, {995,0.00200000}, {1000,0.00200000}, {1010,0.00200000}, {1020,0.00200000}, {1030,0.00200000}, {1040,0.00200000}, {1050,0.00200000}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200000}, {1140,0.00200000}, {1150,0.00200000}, {1160,0.00200000}, {1170,0.00490090}, {1180,0.00200000}, {1190,0.00200000}, {1200,0.00200000}, {1210,0.00200000}, {1220,0.00200000}, {1230,0.00497297}, {1240,0.00201802}, {1250,0.00203604}, {1260,0.00209009}, {1270,0.00209009}, {1280,0.00218018}, {1290,0.00220721}, {1300,0.00244144}, {1310,0.00249550}, {1320,0.00264865}, {1330,0.00265766}, {1340,0.00596396}, {1350,0.00276577}, {1360,0.00281081}, {1370,0.00287387}, {1380,0.00290991}, {1390,0.00296396}, {1400,0.00300000}, {1410,0.00300000}, {1420,0.00300000}, {1430,0.00300000}, {1440,0.00303604}, {1450,0.00300000}, {1460,0.00300000}, {1470,0.00300000}, {1480,0.00300000}, {1490,0.00300000}, {1500,0.00300000}, {1510,0.00300000}, {1520,0.00300000}, {1530,0.00300000}, {1540,0.00300000}, {1550,0.00300000}, {1560,0.00300000}, {1570,0.00300000}, {1580,0.00300000}, {1590,0.00300000}, {1600,0.00300901}, {1610,0.00300901}, {1620,0.00302703}, {1630,0.00574775}, {1640,0.00303604}, {1650,0.00305405}, {1660,0.00305405}, {1670,0.00326126}, {1680,0.00320721}, {1690,0.00322523}, {1700,0.00321622}, {1710,0.00334234}, {1720,0.00344144}, {1730,0.00362162}, {1740,0.00364865}, {1750,0.00369369}, {1760,0.00369369}, {1770,0.00375676}, {1780,0.00380180}, {1790,0.00384685}, {1800,0.00390991}, {1810,0.00393694}, {1820,0.00394595}, {1830,0.00397297}, {1840,0.00400000}, {1850,0.00400000}, {1860,0.00400000}, {1870,0.00400000}, {1880,0.00400000}, {1890,0.00400000}, {1900,0.00400000}, {1910,0.00400000}, {1920,0.00400000}, {1930,0.00400000}, {1940,0.00400000}, {1950,0.00410811}, {1960,0.00400000}, {1970,0.00400000}, {1980,0.00400901}, {1990,0.00400901}, {2000,0.00400901}, {2050,0.00409009}, {2100,0.00430631}, {2150,0.00463964}, {2200,0.00482883}, {2250,0.00497297}, {2300,0.00499099}, {2350,0.00500901}, {2400,0.00504505}, {2450,0.00516216}, {2500,0.00540541}, {2550,0.00564865}, {2600,0.00579279}, {2650,0.00591892}, {2700,0.00600901}, {2750,0.00601802}, {2800,0.00611712}, {2850,0.01204505}, {2900,0.00657658}, {2950,0.00670270}, {3000,0.00679279}, {3050,0.00695495}, {3100,0.01418018}, {3150,0.00707207}, {3200,0.00718018}, {3250,0.00732432}, {3300,0.00758559}, {3350,0.00781081}, {3400,0.00785586}, {3450,0.00798198}, {3500,0.00804505}, {3550,0.00813514}, {3600,0.00834234}, {3650,0.00836036}, {3700,0.00872072}, {3750,0.00876577}, {3800,0.00887387}, {3850,0.00896396}, {3900,0.00919820}, {3950,0.00922523}, {4000,0.00939640}, {4050,0.00963964}, {4100,0.00970270}, {4150,0.00983784}, {4200,0.01467568}, {4250,0.01009910}, {4300,0.01018018}, {4350,0.01038739}, {4400,0.01046847}, {4450,0.01075676}, {4500,0.01082883}, {4550,0.01084685}, {4600,0.01100000}, {4650,0.01121622}, {4700,0.02126126}, {4750,0.01151351}, {4800,0.01164865}, {4850,0.01198198}, {4900,0.01189189}, {4950,0.01199099}, {5000,0.02115315}, {5050,0.01232432}, {5100,0.01246847}, {5150,0.02462162}, {5200,0.01273874}, {5250,0.01281081}, {5300,0.01293694}, {5350,0.01304505}, {5400,0.01326126}, {5450,0.01344144}, {5500,0.02553153}, {5550,0.01361261}, {5600,0.01377477}, {5650,0.01390991}, {5700,0.02745045}, {5750,0.01416216}, {5800,0.01439640}, {5850,0.01451351}, {5900,0.01463964}, {5950,0.03114414}, {6000,0.01487387}, {6050,0.01496396}, {6100,0.01514414}, {6150,0.01534234}, {6200,0.01518018}, {6250,0.03043243}, {6300,0.01572973}, {6350,0.01578378}, {6400,0.01587387}, {6450,0.01609910}, {6500,0.01629730}, {6550,0.01643243}, {6600,0.03069369}, {6650,0.03637838}, {6700,0.01700901}, {6750,0.01691892}, {6800,0.01707207}, {6850,0.01720721}, {6900,0.01739640}, {6950,0.01759459}, {7000,0.01766667}, {7050,0.01772072}, {7100,0.01791892}, {7150,0.01802703}, {7200,0.01815315}, {7250,0.01831532}, {7300,0.01846847}, {7350,0.01860360}, {7400,0.01872973}, {7450,0.01881081}, {7500,0.01903604}, {7550,0.01916216}, {7600,0.01927027}, {7650,0.01944144}, {7700,0.01965766}, {7750,0.01972973}, {7800,0.01983784}, {7850,0.01999099}, {7900,0.02010811}, {7950,0.02026126}, {8000,0.02042342}, {8050,0.02058559}, {8100,0.02102703}, {8150,0.04863063}, {8200,0.04689189}, {8250,0.03904505}, {8300,0.02121622}, {8350,0.02139640}, {8400,0.02152252}, {8450,0.02163964}, {8500,0.02180180}, {8550,0.04424324}, {8600,0.04176577}, {8650,0.02223423}, {8700,0.02234234}, {8750,0.02253153}, {8800,0.02258559}, {8850,0.05573874}, {8900,0.02190991}, {8950,0.02298198}, {9000,0.02313514}, {9050,0.02321622}, {9100,0.06246847}, {9150,0.02360360}, {9200,0.02367568}, {9250,0.02381982}, {9300,0.04692793}, {9350,0.02409910}, {9400,0.02434234}, {9450,0.02443243}, {9500,0.05836937}, {9550,0.02481982}, {9600,0.02486486}, {9650,0.04440541}, {9700,0.02509910}, {9750,0.02521622}, {9800,0.02569369}, {9850,0.02441441}, {9900,0.02562162}, {9950,0.02612613}, {10000,0.02506306}, {10100,0.02622523}, {10200,0.04334234}, {10300,0.02672973}, {10400,0.02697297}, {10500,0.05857658}, {10600,0.02759459}, {10700,0.05115315}, {10800,0.02821622}, {10900,0.04218018}, {11000,0.02879279}, {11100,0.02938739}, {11200,0.02923423}, {11300,0.02993694}, {11400,0.02981982}, {11500,0.05163964}, {11600,0.03037838}, {11700,0.06133333}, {11800,0.03087387}, {11900,0.04391892}, {12000,0.03182883}, {12100,0.03168468}, {12200,0.05793694}, {12300,0.03223423}, {12400,0.03256757}, {12500,0.06745946}, {12600,0.03307207}, {12700,0.03347748}, {12800,0.05140541}, {12900,0.06815315}, {13000,0.03417117}, {13100,0.03444144}, {13200,0.05483784}, {13300,0.06548649}, {13400,0.03525225}, {13500,0.03557658}, {13600,0.03594595}, {13700,0.05179279}, {13800,0.07238739}, {13900,0.06550450}, {14000,0.03740541}, {14100,0.03712613}, {14200,0.03747748}, {14300,0.03781982}, {14400,0.03807207}, {14500,0.03840541}, {14600,0.03854955}, {14700,0.03831532}, {14800,0.03763964}, {14900,0.03785586}, {15000,0.03826126}, {15100,0.03968468}, {15200,0.04036036}, {15300,0.04060360}, {15400,0.04090090}, {15500,0.04127928}, {15600,0.04156757}, {15700,0.04213514}, {15800,0.08124324}, {15900,0.08486486}, {16000,0.07645946}, {16100,0.06010811}, {16200,0.04327928}, {16300,0.04332432}, {16400,0.07710811}, {16500,0.09130631}, {16600,0.06113514}, {16700,0.04445946}, {16800,0.06419820}, {16900,0.09100000}, {17000,0.05981081}, {17100,0.04568468}, {17200,0.09224324}, {17300,0.07114414}, {17400,0.04654054}, {17500,0.09069369}, {17600,0.06940541}, {17700,0.04752252}, {17800,0.09298198}, {17900,0.04790090}, {18000,0.08088288}, {18100,0.07338739}, {18200,0.04927027}, {18300,0.09808108}, {18400,0.04938739}, {18500,0.09403604}, {18600,0.04987387}, {18700,0.09545946}, {18800,0.05039640}, {18900,0.09161261}, {19000,0.05111712}, {19100,0.07950450}, {19200,0.07627027}, {19300,0.05104505}, {19400,0.10971171}, {19500,0.05233333}, {19600,0.08509009}, {19700,0.08607207}, {19800,0.05324324}, {19900,0.08791892}, {20000,0.09392661}};
data["big_flat"]["OCaml"]["cbv"]["user"] = {{1,0.00002703}, {2,0.00000000}, {3,0.00002703}, {4,0.00003604}, {5,0.00003604}, {6,0.00007207}, {7,0.00000000}, {8,0.00009910}, {9,0.00000000}, {10,0.00002703}, {11,0.00003604}, {12,0.00000000}, {13,0.00012613}, {14,0.00000000}, {15,0.00002703}, {16,0.00011712}, {17,0.00006306}, {18,0.00002703}, {19,0.00010811}, {20,0.00006306}, {21,0.00002703}, {22,0.00007207}, {23,0.00002703}, {24,0.00009910}, {25,0.00002703}, {26,0.00003604}, {27,0.00014414}, {28,0.00011712}, {29,0.00006306}, {30,0.00010811}, {31,0.00002703}, {32,0.00000000}, {33,0.00003604}, {34,0.00002703}, {35,0.00013514}, {36,0.00005405}, {37,0.00006306}, {38,0.00000000}, {39,0.00012613}, {40,0.00015315}, {41,0.00000000}, {42,0.00023423}, {43,0.00007207}, {44,0.00007207}, {45,0.00003604}, {46,0.00009910}, {47,0.00013514}, {48,0.00009910}, {49,0.00006306}, {50,0.00011712}, {51,0.00003604}, {52,0.00013514}, {53,0.00013514}, {54,0.00012613}, {55,0.00013514}, {56,0.00018018}, {57,0.00003604}, {58,0.00021622}, {59,0.00005405}, {60,0.00019820}, {61,0.00013514}, {62,0.00007207}, {63,0.00012613}, {64,0.00010811}, {65,0.00002703}, {66,0.00014414}, {67,0.00016216}, {68,0.00009910}, {69,0.00009009}, {70,0.00005405}, {71,0.00017117}, {72,0.00006306}, {73,0.00019820}, {74,0.00010811}, {75,0.00017117}, {76,0.00014414}, {77,0.00017117}, {78,0.00013514}, {79,0.00015315}, {80,0.00019820}, {81,0.00027027}, {82,0.00016216}, {83,0.00020721}, {84,0.00015315}, {85,0.00023423}, {86,0.00024324}, {87,0.00007207}, {88,0.00011712}, {89,0.00013514}, {90,0.00018919}, {91,0.00013514}, {92,0.00018919}, {93,0.00016216}, {94,0.00037838}, {95,0.00012613}, {96,0.00021622}, {97,0.00015315}, {98,0.00015315}, {99,0.00027928}, {100,0.00018919}, {101,0.00024324}, {102,0.00029730}, {103,0.00020721}, {104,0.00025225}, {105,0.00011712}, {106,0.00019820}, {107,0.00014414}, {108,0.00027027}, {109,0.00039640}, {110,0.00013514}, {111,0.00034234}, {112,0.00027027}, {113,0.00024324}, {114,0.00027928}, {115,0.00014414}, {116,0.00029730}, {117,0.00026126}, {118,0.00020721}, {119,0.00023423}, {120,0.00026126}, {121,0.00024324}, {122,0.00030631}, {123,0.00023423}, {124,0.00023423}, {125,0.00043243}, {126,0.00031532}, {127,0.00005405}, {128,0.00029730}, {129,0.00023423}, {130,0.00023423}, {131,0.00036937}, {132,0.00024324}, {133,0.00036937}, {134,0.00042342}, {135,0.00036036}, {136,0.00008108}, {137,0.00012613}, {138,0.00012613}, {139,0.00036036}, {140,0.00018919}, {141,0.00026126}, {142,0.00031532}, {143,0.00022523}, {144,0.00030631}, {145,0.00023423}, {146,0.00022523}, {147,0.00037838}, {148,0.00018919}, {149,0.00025225}, {150,0.00020721}, {151,0.00032432}, {152,0.00036036}, {153,0.00019820}, {154,0.00027928}, {155,0.00032432}, {156,0.00040541}, {157,0.00036937}, {158,0.00022523}, {159,0.00026126}, {160,0.00027027}, {161,0.00031532}, {162,0.00037838}, {163,0.00032432}, {164,0.00023423}, {165,0.00042342}, {166,0.00036937}, {167,0.00033333}, {168,0.00032432}, {169,0.00053153}, {170,0.00034234}, {171,0.00033333}, {172,0.00025225}, {173,0.00028829}, {174,0.00012613}, {175,0.00042342}, {176,0.00032432}, {177,0.00036937}, {178,0.00029730}, {179,0.00022523}, {180,0.00048649}, {181,0.00034234}, {182,0.00026126}, {183,0.00027928}, {184,0.00044144}, {185,0.00036937}, {186,0.00045045}, {187,0.00052252}, {188,0.00020721}, {189,0.00031532}, {190,0.00033333}, {191,0.00031532}, {192,0.00043243}, {193,0.00039640}, {194,0.00036036}, {195,0.00032432}, {196,0.00031532}, {197,0.00040541}, {198,0.00042342}, {199,0.00055856}, {200,0.00045946}, {201,0.00023423}, {202,0.00037838}, {203,0.00124324}, {204,0.00026126}, {205,0.00036937}, {206,0.00034234}, {207,0.00030631}, {208,0.00036036}, {209,0.00031532}, {210,0.00044144}, {211,0.00033333}, {212,0.00029730}, {213,0.00052252}, {214,0.00049550}, {215,0.00058559}, {216,0.00045045}, {217,0.00049550}, {218,0.00044144}, {219,0.00045045}, {220,0.00049550}, {221,0.00052252}, {222,0.00054955}, {223,0.00033333}, {224,0.00036937}, {225,0.00050450}, {226,0.00035135}, {227,0.00037838}, {228,0.00045045}, {229,0.00047748}, {230,0.00050450}, {231,0.00054955}, {232,0.00048649}, {233,0.00046847}, {234,0.00042342}, {235,0.00046847}, {236,0.00041441}, {237,0.00043243}, {238,0.00045946}, {239,0.00052252}, {240,0.00051351}, {241,0.00057658}, {242,0.00053153}, {243,0.00046847}, {244,0.00053153}, {245,0.00057658}, {246,0.00057658}, {247,0.00038739}, {248,0.00032432}, {249,0.00029730}, {250,0.00028829}, {251,0.00036036}, {252,0.00048649}, {253,0.00036937}, {254,0.00137838}, {255,0.00059459}, {256,0.00051351}, {257,0.00069369}, {258,0.00058559}, {259,0.00054955}, {260,0.00054955}, {261,0.00057658}, {262,0.00042342}, {263,0.00046847}, {264,0.00047748}, {265,0.00054054}, {266,0.00049550}, {267,0.00044144}, {268,0.00045946}, {269,0.00054054}, {270,0.00053153}, {271,0.00054054}, {272,0.00047748}, {273,0.00057658}, {274,0.00067568}, {275,0.00047748}, {276,0.00034234}, {277,0.00049550}, {278,0.00063063}, {279,0.00063964}, {280,0.00072072}, {281,0.00069369}, {282,0.00042342}, {283,0.00033333}, {284,0.00041441}, {285,0.00060360}, {286,0.00072973}, {287,0.00076577}, {288,0.00058559}, {289,0.00039640}, {290,0.00062162}, {291,0.00052252}, {292,0.00077477}, {293,0.00054054}, {294,0.00045045}, {295,0.00051351}, {296,0.00070270}, {297,0.00076577}, {298,0.00114414}, {299,0.00056757}, {300,0.00057658}, {301,0.00063964}, {302,0.00062162}, {303,0.00056757}, {304,0.00081982}, {305,0.00048649}, {306,0.00063964}, {307,0.00043243}, {308,0.00059459}, {309,0.00076577}, {310,0.00071171}, {311,0.00060360}, {312,0.00064865}, {313,0.00071171}, {314,0.00052252}, {315,0.00066667}, {316,0.00063063}, {317,0.00058559}, {318,0.00052252}, {319,0.00058559}, {320,0.00083784}, {321,0.00050450}, {322,0.00048649}, {323,0.00056757}, {324,0.00086486}, {325,0.00050450}, {326,0.00060360}, {327,0.00082883}, {328,0.00063964}, {329,0.00083784}, {330,0.00054955}, {331,0.00075676}, {332,0.00072072}, {333,0.00044144}, {334,0.00074775}, {335,0.00045946}, {336,0.00060360}, {337,0.00063063}, {338,0.00076577}, {339,0.00058559}, {340,0.00054054}, {341,0.00078378}, {342,0.00053153}, {343,0.00041441}, {344,0.00052252}, {345,0.00082883}, {346,0.00044144}, {347,0.00050450}, {348,0.00077477}, {349,0.00053153}, {350,0.00061261}, {351,0.00062162}, {352,0.00073874}, {353,0.00063964}, {354,0.00067568}, {355,0.00058559}, {356,0.00079279}, {357,0.00063964}, {358,0.00072072}, {359,0.00078378}, {360,0.00064865}, {361,0.00073874}, {362,0.00055856}, {363,0.00068468}, {364,0.00063964}, {365,0.00088288}, {366,0.00072973}, {367,0.00062162}, {368,0.00066667}, {369,0.00063063}, {370,0.00054955}, {371,0.00090991}, {372,0.00081982}, {373,0.00160360}, {374,0.00075676}, {375,0.00064865}, {376,0.00081081}, {377,0.00084685}, {378,0.00069369}, {379,0.00071171}, {380,0.00106306}, {381,0.00072973}, {382,0.00100000}, {383,0.00060360}, {384,0.00081982}, {385,0.00072973}, {386,0.00080180}, {387,0.00068468}, {388,0.00073874}, {389,0.00072973}, {390,0.00088288}, {391,0.00063964}, {392,0.00102703}, {393,0.00057658}, {394,0.00078378}, {395,0.00063964}, {396,0.00092793}, {397,0.00076577}, {398,0.00089189}, {399,0.00063964}, {400,0.00076577}, {401,0.00053153}, {402,0.00092793}, {403,0.00062162}, {404,0.00109009}, {405,0.00064865}, {406,0.00167568}, {407,0.00077477}, {408,0.00090090}, {409,0.00077477}, {410,0.00089189}, {411,0.00103604}, {412,0.00081081}, {413,0.00100901}, {414,0.00054955}, {415,0.00105405}, {416,0.00066667}, {417,0.00072072}, {418,0.00090991}, {419,0.00102703}, {420,0.00095495}, {421,0.00072072}, {422,0.00082883}, {423,0.00094595}, {424,0.00058559}, {425,0.00088288}, {426,0.00077477}, {427,0.00090090}, {428,0.00079279}, {429,0.00081081}, {430,0.00055856}, {431,0.00090090}, {432,0.00078378}, {433,0.00063063}, {434,0.00080180}, {435,0.00082883}, {436,0.00096396}, {437,0.00107207}, {438,0.00108108}, {439,0.00088288}, {440,0.00105405}, {441,0.00074775}, {442,0.00087387}, {443,0.00073874}, {444,0.00065766}, {445,0.00068468}, {446,0.00075676}, {447,0.00094595}, {448,0.00090090}, {449,0.00084685}, {450,0.00080180}, {451,0.00065766}, {452,0.00072973}, {453,0.00119820}, {454,0.00100000}, {455,0.00086486}, {456,0.00103604}, {457,0.00091892}, {458,0.00101802}, {459,0.00073874}, {460,0.00117117}, {461,0.00082883}, {462,0.00073874}, {463,0.00115315}, {464,0.00083784}, {465,0.00083784}, {466,0.00100901}, {467,0.00121622}, {468,0.00095495}, {469,0.00064865}, {470,0.00099099}, {471,0.00116216}, {472,0.00082883}, {473,0.00070270}, {474,0.00126126}, {475,0.00105405}, {476,0.00085586}, {477,0.00069369}, {478,0.00113514}, {479,0.00114414}, {480,0.00077477}, {481,0.00081081}, {482,0.00087387}, {483,0.00117117}, {484,0.00087387}, {485,0.00092793}, {486,0.00106306}, {487,0.00106306}, {488,0.00108108}, {489,0.00075676}, {490,0.00098198}, {491,0.00100000}, {492,0.00106306}, {493,0.00078378}, {494,0.00098198}, {495,0.00086486}, {496,0.00121622}, {497,0.00097297}, {498,0.00104505}, {499,0.00116216}, {500,0.00070270}, {505,0.00115315}, {510,0.00122523}, {515,0.00088288}, {520,0.00085586}, {525,0.00106306}, {530,0.00128829}, {535,0.00101802}, {540,0.00118919}, {545,0.00116216}, {550,0.00094595}, {555,0.00109009}, {560,0.00092793}, {565,0.00119820}, {570,0.00118919}, {575,0.00109910}, {580,0.00100000}, {585,0.00096396}, {590,0.00115315}, {595,0.00137838}, {600,0.00129730}, {605,0.00141441}, {610,0.00135135}, {615,0.00127027}, {620,0.00143243}, {625,0.00150450}, {630,0.00132432}, {635,0.00121622}, {640,0.00102703}, {645,0.00132432}, {650,0.00125225}, {655,0.00150450}, {660,0.00149550}, {665,0.00127928}, {670,0.00119820}, {675,0.00123423}, {680,0.00139640}, {685,0.00147748}, {690,0.00127027}, {695,0.00128829}, {700,0.00132432}, {705,0.00145946}, {710,0.00137838}, {715,0.00174775}, {720,0.00119820}, {725,0.00161261}, {730,0.00127928}, {735,0.00152252}, {740,0.00112613}, {745,0.00323423}, {750,0.00178378}, {755,0.00119820}, {760,0.00142342}, {765,0.00169369}, {770,0.00116216}, {775,0.00181081}, {780,0.00123423}, {785,0.00166667}, {790,0.00412613}, {795,0.00152252}, {800,0.00192793}, {805,0.00162162}, {810,0.00134234}, {815,0.00198198}, {820,0.00179279}, {825,0.00181081}, {830,0.00153153}, {835,0.00214414}, {840,0.00183784}, {845,0.00164865}, {850,0.00175676}, {855,0.00174775}, {860,0.00160360}, {865,0.00207207}, {870,0.00198198}, {875,0.00185586}, {880,0.00182883}, {885,0.00177477}, {890,0.00172072}, {895,0.00180180}, {900,0.00194595}, {905,0.00186486}, {910,0.00189189}, {915,0.00203604}, {920,0.00200901}, {925,0.00212613}, {930,0.00188288}, {935,0.00201802}, {940,0.00192793}, {945,0.00193694}, {950,0.00450450}, {955,0.00196396}, {960,0.00188288}, {965,0.00183784}, {970,0.00191892}, {975,0.00191892}, {980,0.00182883}, {985,0.00206306}, {990,0.00181081}, {995,0.00203604}, {1000,0.00226126}, {1010,0.00223423}, {1020,0.00207207}, {1030,0.00254955}, {1040,0.00166667}, {1050,0.00177477}, {1060,0.00228829}, {1070,0.00184685}, {1080,0.00256757}, {1090,0.00192793}, {1100,0.00219820}, {1110,0.00208108}, {1120,0.00204505}, {1130,0.00232432}, {1140,0.00230631}, {1150,0.00254955}, {1160,0.00235135}, {1170,0.00490090}, {1180,0.00236937}, {1190,0.00234234}, {1200,0.00236036}, {1210,0.00260360}, {1220,0.00258559}, {1230,0.00503604}, {1240,0.00267568}, {1250,0.00263964}, {1260,0.00251351}, {1270,0.00243243}, {1280,0.00266667}, {1290,0.00290090}, {1300,0.00273874}, {1310,0.00265766}, {1320,0.00278378}, {1330,0.00253153}, {1340,0.00571171}, {1350,0.00288288}, {1360,0.00278378}, {1370,0.00268468}, {1380,0.00287387}, {1390,0.00289189}, {1400,0.00292793}, {1410,0.00300000}, {1420,0.00297297}, {1430,0.00296396}, {1440,0.00318919}, {1450,0.00292793}, {1460,0.00327027}, {1470,0.00302703}, {1480,0.00336937}, {1490,0.00295495}, {1500,0.00322523}, {1510,0.00303604}, {1520,0.00329730}, {1530,0.00314414}, {1540,0.00302703}, {1550,0.00316216}, {1560,0.00315315}, {1570,0.00311712}, {1580,0.00335135}, {1590,0.00326126}, {1600,0.00338739}, {1610,0.00338739}, {1620,0.00328829}, {1630,0.00559459}, {1640,0.00340541}, {1650,0.00348649}, {1660,0.00344144}, {1670,0.00359459}, {1680,0.00351351}, {1690,0.00352252}, {1700,0.00359459}, {1710,0.00361261}, {1720,0.00363063}, {1730,0.00376577}, {1740,0.00359459}, {1750,0.00363063}, {1760,0.00371171}, {1770,0.00377477}, {1780,0.00382883}, {1790,0.00377477}, {1800,0.00376577}, {1810,0.00382883}, {1820,0.00381081}, {1830,0.00372973}, {1840,0.00390090}, {1850,0.00400901}, {1860,0.00387387}, {1870,0.00404505}, {1880,0.00408108}, {1890,0.00405405}, {1900,0.00385586}, {1910,0.00407207}, {1920,0.00404505}, {1930,0.00401802}, {1940,0.00409009}, {1950,0.00414414}, {1960,0.00427928}, {1970,0.00422523}, {1980,0.00412613}, {1990,0.00420721}, {2000,0.00400000}, {2050,0.00438739}, {2100,0.00424324}, {2150,0.00463063}, {2200,0.00464865}, {2250,0.00501802}, {2300,0.00490090}, {2350,0.00521622}, {2400,0.00518919}, {2450,0.00537838}, {2500,0.00545946}, {2550,0.00552252}, {2600,0.00577477}, {2650,0.00519820}, {2700,0.00598198}, {2750,0.00620721}, {2800,0.00612613}, {2850,0.01223423}, {2900,0.00636036}, {2950,0.00645946}, {3000,0.00634234}, {3050,0.00656757}, {3100,0.01407207}, {3150,0.00693694}, {3200,0.00723423}, {3250,0.00724324}, {3300,0.00719820}, {3350,0.00733333}, {3400,0.00776577}, {3450,0.00781081}, {3500,0.00769369}, {3550,0.00795495}, {3600,0.00835135}, {3650,0.00834234}, {3700,0.00828829}, {3750,0.00846847}, {3800,0.00881081}, {3850,0.00876577}, {3900,0.00898198}, {3950,0.00920721}, {4000,0.00916216}, {4050,0.00981982}, {4100,0.00994595}, {4150,0.01015315}, {4200,0.01455856}, {4250,0.01033333}, {4300,0.01042342}, {4350,0.01061261}, {4400,0.01081982}, {4450,0.01097297}, {4500,0.01088288}, {4550,0.01108108}, {4600,0.01131532}, {4650,0.01167568}, {4700,0.02069369}, {4750,0.01167568}, {4800,0.01185586}, {4850,0.01227928}, {4900,0.01239640}, {4950,0.01238739}, {5000,0.02070270}, {5050,0.01245045}, {5100,0.01283784}, {5150,0.02429730}, {5200,0.01310811}, {5250,0.01309009}, {5300,0.01315315}, {5350,0.01338739}, {5400,0.01337838}, {5450,0.01366667}, {5500,0.02553153}, {5550,0.01379279}, {5600,0.01397297}, {5650,0.01404505}, {5700,0.02726126}, {5750,0.01433333}, {5800,0.01436937}, {5850,0.01458559}, {5900,0.01474775}, {5950,0.03146847}, {6000,0.01493694}, {6050,0.01501802}, {6100,0.01495495}, {6150,0.01534234}, {6200,0.01502703}, {6250,0.03051351}, {6300,0.01555856}, {6350,0.01588288}, {6400,0.01571171}, {6450,0.01593694}, {6500,0.01602703}, {6550,0.01645946}, {6600,0.03067568}, {6650,0.03601802}, {6700,0.01684685}, {6750,0.01684685}, {6800,0.01668468}, {6850,0.01701802}, {6900,0.01696396}, {6950,0.01746847}, {7000,0.01767568}, {7050,0.01760360}, {7100,0.01789189}, {7150,0.01769369}, {7200,0.01786486}, {7250,0.01790090}, {7300,0.01808108}, {7350,0.01827928}, {7400,0.01833333}, {7450,0.01833333}, {7500,0.01863063}, {7550,0.01898198}, {7600,0.01878378}, {7650,0.01896396}, {7700,0.01940541}, {7750,0.01949550}, {7800,0.01963063}, {7850,0.01966667}, {7900,0.01999099}, {7950,0.01987387}, {8000,0.02031532}, {8050,0.02070270}, {8100,0.02082883}, {8150,0.04806306}, {8200,0.04624324}, {8250,0.03862162}, {8300,0.02097297}, {8350,0.02163063}, {8400,0.02183784}, {8450,0.02165766}, {8500,0.02173874}, {8550,0.04359459}, {8600,0.04135135}, {8650,0.02245946}, {8700,0.02217117}, {8750,0.02258559}, {8800,0.02271171}, {8850,0.05482883}, {8900,0.02201802}, {8950,0.02315315}, {9000,0.02325225}, {9050,0.02347748}, {9100,0.06210811}, {9150,0.02387387}, {9200,0.02400000}, {9250,0.02392793}, {9300,0.04692793}, {9350,0.02451351}, {9400,0.02461261}, {9450,0.02441441}, {9500,0.05780180}, {9550,0.02495495}, {9600,0.02500000}, {9650,0.04355856}, {9700,0.02497297}, {9750,0.02520721}, {9800,0.02588288}, {9850,0.02458559}, {9900,0.02568468}, {9950,0.02627928}, {10000,0.02511712}, {10100,0.02617117}, {10200,0.04304505}, {10300,0.02661261}, {10400,0.02673874}, {10500,0.05755856}, {10600,0.02719820}, {10700,0.05062162}, {10800,0.02787387}, {10900,0.04169369}, {11000,0.02852252}, {11100,0.02897297}, {11200,0.02882883}, {11300,0.02979279}, {11400,0.02949550}, {11500,0.05133333}, {11600,0.02995495}, {11700,0.06120721}, {11800,0.03073874}, {11900,0.04409009}, {12000,0.03182883}, {12100,0.03184685}, {12200,0.05801802}, {12300,0.03240541}, {12400,0.03270270}, {12500,0.06767568}, {12600,0.03310811}, {12700,0.03365766}, {12800,0.05136937}, {12900,0.06745045}, {13000,0.03457658}, {13100,0.03489189}, {13200,0.05410811}, {13300,0.06512613}, {13400,0.03544144}, {13500,0.03588288}, {13600,0.03607207}, {13700,0.05113514}, {13800,0.07198198}, {13900,0.06523423}, {14000,0.03737838}, {14100,0.03707207}, {14200,0.03727027}, {14300,0.03792793}, {14400,0.03795495}, {14500,0.03816216}, {14600,0.03843243}, {14700,0.03800901}, {14800,0.03745946}, {14900,0.03755856}, {15000,0.03792793}, {15100,0.03949550}, {15200,0.03992793}, {15300,0.04036937}, {15400,0.04055856}, {15500,0.04099099}, {15600,0.04104505}, {15700,0.04164865}, {15800,0.08123423}, {15900,0.08511712}, {16000,0.07627928}, {16100,0.06052252}, {16200,0.04327928}, {16300,0.04350450}, {16400,0.07731532}, {16500,0.09135135}, {16600,0.06131532}, {16700,0.04465766}, {16800,0.06437838}, {16900,0.09086486}, {17000,0.05996396}, {17100,0.04572973}, {17200,0.09200000}, {17300,0.07129730}, {17400,0.04664865}, {17500,0.09041441}, {17600,0.06934234}, {17700,0.04757658}, {17800,0.09313514}, {17900,0.04816216}, {18000,0.08085586}, {18100,0.07330631}, {18200,0.04926126}, {18300,0.09775676}, {18400,0.04966667}, {18500,0.09372973}, {18600,0.04984685}, {18700,0.09561261}, {18800,0.05036036}, {18900,0.09136937}, {19000,0.05122523}, {19100,0.07947748}, {19200,0.07629730}, {19300,0.05101802}, {19400,0.10931532}, {19500,0.05229730}, {19600,0.08481982}, {19700,0.08613514}, {19800,0.05291892}, {19900,0.08799099}, {20000,0.09373394}};
data["big_flat"]["OCaml"]["cbv"]["system"] = {{1,0.00007207}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00003604}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00003604}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00003604}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00003604}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00003604}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00002703}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00003604}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00003604}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00003604}, {133,0.00000000}, {134,0.00003604}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00003604}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00003604}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00002703}, {177,0.00002703}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00006306}, {184,0.00000000}, {185,0.00000000}, {186,0.00003604}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00003604}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00007207}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00007207}, {210,0.00000000}, {211,0.00000000}, {212,0.00003604}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00007207}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00003604}, {227,0.00003604}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00003604}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00003604}, {239,0.00000000}, {240,0.00003604}, {241,0.00000000}, {242,0.00000000}, {243,0.00003604}, {244,0.00000000}, {245,0.00003604}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00003604}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00002703}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00003604}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00003604}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00003604}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00002703}, {318,0.00000000}, {319,0.00003604}, {320,0.00000000}, {321,0.00000000}, {322,0.00010811}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00003604}, {339,0.00003604}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00003604}, {344,0.00000000}, {345,0.00000000}, {346,0.00003604}, {347,0.00003604}, {348,0.00000000}, {349,0.00003604}, {350,0.00000000}, {351,0.00003604}, {352,0.00000000}, {353,0.00000000}, {354,0.00003604}, {355,0.00003604}, {356,0.00003604}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00003604}, {362,0.00002703}, {363,0.00003604}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00003604}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00003604}, {387,0.00000000}, {388,0.00000000}, {389,0.00003604}, {390,0.00006306}, {391,0.00000000}, {392,0.00000000}, {393,0.00003604}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00003604}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00003604}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00003604}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00003604}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00003604}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00003604}, {430,0.00000000}, {431,0.00003604}, {432,0.00006306}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00003604}, {442,0.00000000}, {443,0.00003604}, {444,0.00003604}, {445,0.00003604}, {446,0.00003604}, {447,0.00000000}, {448,0.00003604}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00003604}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00003604}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00003604}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00003604}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00003604}, {479,0.00000000}, {480,0.00000000}, {481,0.00003604}, {482,0.00003604}, {483,0.00003604}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00003604}, {492,0.00002703}, {493,0.00003604}, {494,0.00000000}, {495,0.00003604}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00006306}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00002703}, {535,0.00003604}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00003604}, {565,0.00003604}, {570,0.00000000}, {575,0.00003604}, {580,0.00003604}, {585,0.00000000}, {590,0.00000000}, {595,0.00003604}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00003604}, {635,0.00000000}, {640,0.00003604}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00007207}, {675,0.00003604}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00003604}, {740,0.00000000}, {745,0.00000000}, {750,0.00003604}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00003604}, {780,0.00000000}, {785,0.00000000}, {790,0.00014414}, {795,0.00000000}, {800,0.00003604}, {805,0.00000000}, {810,0.00003604}, {815,0.00003604}, {820,0.00000000}, {825,0.00007207}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00003604}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00003604}, {890,0.00000000}, {895,0.00003604}, {900,0.00000000}, {905,0.00003604}, {910,0.00000000}, {915,0.00000000}, {920,0.00003604}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00002703}, {945,0.00000000}, {950,0.00002703}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00003604}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00007207}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00003604}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00003604}, {1100,0.00006306}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00006306}, {1140,0.00000000}, {1150,0.00003604}, {1160,0.00000000}, {1170,0.00010811}, {1180,0.00003604}, {1190,0.00003604}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00003604}, {1240,0.00006306}, {1250,0.00003604}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00007207}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00007207}, {1330,0.00000000}, {1340,0.00014414}, {1350,0.00007207}, {1360,0.00000000}, {1370,0.00002703}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00003604}, {1420,0.00003604}, {1430,0.00003604}, {1440,0.00003604}, {1450,0.00000000}, {1460,0.00003604}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00003604}, {1540,0.00000000}, {1550,0.00003604}, {1560,0.00000000}, {1570,0.00007207}, {1580,0.00003604}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00003604}, {1620,0.00000000}, {1630,0.00003604}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00003604}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00002703}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00003604}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00003604}, {2000,0.00003604}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00006306}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00010811}, {2900,0.00003604}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00002703}, {3150,0.00003604}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00002703}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00003604}, {3700,0.00003604}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00003604}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00003604}, {4200,0.00006306}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00006306}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00027928}, {4750,0.00000000}, {4800,0.00003604}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00018018}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00042342}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00003604}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00020721}, {5550,0.00000000}, {5600,0.00010811}, {5650,0.00000000}, {5700,0.00032432}, {5750,0.00007207}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00007207}, {5950,0.00018018}, {6000,0.00003604}, {6050,0.00003604}, {6100,0.00003604}, {6150,0.00009910}, {6200,0.00003604}, {6250,0.00025225}, {6300,0.00003604}, {6350,0.00000000}, {6400,0.00002703}, {6450,0.00003604}, {6500,0.00003604}, {6550,0.00003604}, {6600,0.00027928}, {6650,0.00049550}, {6700,0.00000000}, {6750,0.00003604}, {6800,0.00000000}, {6850,0.00003604}, {6900,0.00007207}, {6950,0.00000000}, {7000,0.00007207}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00003604}, {7200,0.00003604}, {7250,0.00003604}, {7300,0.00003604}, {7350,0.00007207}, {7400,0.00000000}, {7450,0.00002703}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00003604}, {7800,0.00003604}, {7850,0.00000000}, {7900,0.00003604}, {7950,0.00007207}, {8000,0.00007207}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00052252}, {8200,0.00050450}, {8250,0.00035135}, {8300,0.00007207}, {8350,0.00003604}, {8400,0.00003604}, {8450,0.00003604}, {8500,0.00007207}, {8550,0.00049550}, {8600,0.00013514}, {8650,0.00003604}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00053153}, {8900,0.00003604}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00010811}, {9100,0.00064865}, {9150,0.00003604}, {9200,0.00003604}, {9250,0.00000000}, {9300,0.00019820}, {9350,0.00003604}, {9400,0.00003604}, {9450,0.00007207}, {9500,0.00059459}, {9550,0.00000000}, {9600,0.00003604}, {9650,0.00049550}, {9700,0.00007207}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00003604}, {9900,0.00003604}, {9950,0.00000000}, {10000,0.00009910}, {10100,0.00000000}, {10200,0.00031532}, {10300,0.00003604}, {10400,0.00000000}, {10500,0.00091892}, {10600,0.00000000}, {10700,0.00046847}, {10800,0.00003604}, {10900,0.00027928}, {11000,0.00000000}, {11100,0.00007207}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00003604}, {11500,0.00024324}, {11600,0.00010811}, {11700,0.00057658}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00003604}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00075676}, {13000,0.00003604}, {13100,0.00002703}, {13200,0.00057658}, {13300,0.00052252}, {13400,0.00000000}, {13500,0.00003604}, {13600,0.00007207}, {13700,0.00018018}, {13800,0.00053153}, {13900,0.00035135}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00003604}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00010811}, {14900,0.00010811}, {15000,0.00003604}, {15100,0.00007207}, {15200,0.00010811}, {15300,0.00003604}, {15400,0.00014414}, {15500,0.00003604}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00007207}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00002703}, {16300,0.00000000}, {16400,0.00003604}, {16500,0.00003604}, {16600,0.00003604}, {16700,0.00002703}, {16800,0.00003604}, {16900,0.00007207}, {17000,0.00000000}, {17100,0.00007207}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00003604}, {17500,0.00000000}, {17600,0.00003604}, {17700,0.00000000}, {17800,0.00003604}, {17900,0.00007207}, {18000,0.00014414}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00007207}, {18400,0.00000000}, {18500,0.00007207}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00003604}, {18900,0.00000000}, {19000,0.00003604}, {19100,0.00000000}, {19200,0.00007207}, {19300,0.00003604}, {19400,0.00007207}, {19500,0.00003604}, {19600,0.00003604}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["OCaml"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00001802}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00098198}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000901}, {172,0.00000000}, {173,0.00098198}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00098198}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00488288}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00275676}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00007207}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00558559}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000901}, {1480,0.00000901}, {1490,0.00000901}, {1500,0.00000901}, {1510,0.00000901}, {1520,0.00000000}, {1530,0.00003604}, {1540,0.00000901}, {1550,0.00004505}, {1560,0.00002703}, {1570,0.00005405}, {1580,0.00023423}, {1590,0.00011712}, {1600,0.00018919}, {1610,0.00026126}, {1620,0.00040541}, {1630,0.00038739}, {1640,0.00053153}, {1650,0.00057658}, {1660,0.00072072}, {1670,0.00075676}, {1680,0.00074775}, {1690,0.00074775}, {1700,0.00076577}, {1710,0.00085586}, {1720,0.00089189}, {1730,0.00095495}, {1740,0.00098198}, {1750,0.00100000}, {1760,0.00100000}, {1770,0.00100000}, {1780,0.00100000}, {1790,0.00100000}, {1800,0.00100000}, {1810,0.00100000}, {1820,0.00100000}, {1830,0.00100000}, {1840,0.00100000}, {1850,0.00100000}, {1860,0.00100000}, {1870,0.00100000}, {1880,0.00100000}, {1890,0.00100000}, {1900,0.00100000}, {1910,0.00106306}, {1920,0.00100000}, {1930,0.00100000}, {1940,0.00100000}, {1950,0.00100000}, {1960,0.00100000}, {1970,0.00100000}, {1980,0.00100000}, {1990,0.00100000}, {2000,0.00100000}, {2050,0.00100000}, {2100,0.00107207}, {2150,0.00100000}, {2200,0.00100000}, {2250,0.00100000}, {2300,0.00100000}, {2350,0.00100000}, {2400,0.00100000}, {2450,0.00100000}, {2500,0.00100000}, {2550,0.00100000}, {2600,0.00100000}, {2650,0.00100901}, {2700,0.00102703}, {2750,0.00100901}, {2800,0.00103604}, {2850,0.00109009}, {2900,0.00107207}, {2950,0.00117117}, {3000,0.00120721}, {3050,0.00144144}, {3100,0.00154054}, {3150,0.00166667}, {3200,0.00181081}, {3250,0.00189189}, {3300,0.00191892}, {3350,0.00200000}, {3400,0.00199099}, {3450,0.00200000}, {3500,0.00200000}, {3550,0.00200000}, {3600,0.00200000}, {3650,0.00200000}, {3700,0.00202703}, {3750,0.00201802}, {3800,0.00209009}, {3850,0.00204505}, {3900,0.00210811}, {3950,0.00209009}, {4000,0.00210811}, {4050,0.00222523}, {4100,0.00246847}, {4150,0.00233333}, {4200,0.00244144}, {4250,0.00241441}, {4300,0.00258559}, {4350,0.00266667}, {4400,0.00269369}, {4450,0.01559459}, {4500,0.00288288}, {4550,0.00290991}, {4600,0.00294595}, {4650,0.00299099}, {4700,0.00298198}, {4750,0.00302703}, {4800,0.00301802}, {4850,0.00303604}, {4900,0.00314414}, {4950,0.00313514}, {5000,0.00318919}, {5050,0.00326126}, {5100,0.00327027}, {5150,0.00344144}, {5200,0.00346847}, {5250,0.00344144}, {5300,0.00348649}, {5350,0.00354955}, {5400,0.00365766}, {5450,0.00374775}, {5500,0.00381081}, {5550,0.00420721}, {5600,0.00386486}, {5650,0.00390991}, {5700,0.00391892}, {5750,0.02692793}, {5800,0.00399099}, {5850,0.00399099}, {5900,0.00399099}, {5950,0.00399099}, {6000,0.03282883}, {6050,0.00412613}, {6100,0.00413514}, {6150,0.00420721}, {6200,0.00440541}, {6250,0.00437838}, {6300,0.03184685}, {6350,0.00454054}, {6400,0.00459459}, {6450,0.00460360}, {6500,0.00462162}, {6550,0.00463964}, {6600,0.00468468}, {6650,0.00477477}, {6700,0.02194595}, {6750,0.00521622}, {6800,0.00486486}, {6850,0.00490090}, {6900,0.00499099}, {6950,0.00499099}, {7000,0.00499099}, {7050,0.00500000}, {7100,0.00500000}, {7150,0.00503604}, {7200,0.00509009}, {7250,0.00512613}, {7300,0.00514414}, {7350,0.00522523}, {7400,0.00530631}, {7450,0.00543243}, {7500,0.00554955}, {7550,0.00559459}, {7600,0.00560360}, {7650,0.00563063}, {7700,0.00566667}, {7750,0.00566667}, {7800,0.00565766}, {7850,0.00567568}, {7900,0.00570270}, {7950,0.00576577}, {8000,0.00578378}, {8050,0.00639640}, {8100,0.02219820}, {8150,0.00597297}, {8200,0.00597297}, {8250,0.00599099}, {8300,0.00601802}, {8350,0.00605405}, {8400,0.00604505}, {8450,0.00614414}, {8500,0.02813514}, {8550,0.00627027}, {8600,0.00638739}, {8650,0.00637838}, {8700,0.00649550}, {8750,0.00657658}, {8800,0.02720721}, {8850,0.00661261}, {8900,0.00662162}, {8950,0.00663063}, {9000,0.00663063}, {9050,0.02175676}, {9100,0.00669369}, {9150,0.00663063}, {9200,0.00665766}, {9250,0.04062162}, {9300,0.00678378}, {9350,0.00682883}, {9400,0.00683784}, {9450,0.02763063}, {9500,0.00694595}, {9550,0.00701802}, {9600,0.00705405}, {9650,0.00708108}, {9700,0.00711712}, {9750,0.00715315}, {9800,0.00731532}, {9850,0.00730631}, {9900,0.00738739}, {9950,0.00747748}, {10000,0.00759459}, {10100,0.00760360}, {10200,0.00762162}, {10300,0.00763063}, {10400,0.00806306}, {10500,0.00764865}, {10600,0.00773874}, {10700,0.00779279}, {10800,0.00798198}, {10900,0.00809009}, {11000,0.00821622}, {11100,0.00832432}, {11200,0.00854955}, {11300,0.00858559}, {11400,0.00861261}, {11500,0.00861261}, {11600,0.00859459}, {11700,0.00862162}, {11800,0.00933333}, {11900,0.00866667}, {12000,0.00874775}, {12100,0.00897297}, {12200,0.00911712}, {12300,0.02385586}, {12400,0.00942342}, {12500,0.00953153}, {12600,0.02636937}, {12700,0.00959459}, {12800,0.00959459}, {12900,0.00959459}, {13000,0.05817117}, {13100,0.00963964}, {13200,0.00966667}, {13300,0.00974775}, {13400,0.00859459}, {13500,0.01004505}, {13600,0.01033333}, {13700,0.01049550}, {13800,0.01056757}, {13900,0.01058559}, {14000,0.01058559}, {14100,0.04079279}, {14200,0.01126126}, {14300,0.01062162}, {14400,0.01070270}, {14500,0.01068468}, {14600,0.01080180}, {14700,0.01096396}, {14800,0.01110811}, {14900,0.01131532}, {15000,0.01148649}, {15100,0.01154955}, {15200,0.01159459}, {15300,0.01159459}, {15400,0.01159459}, {15500,0.01224324}, {15600,0.04298198}, {15700,0.01172072}, {15800,0.01178378}, {15900,0.01176577}, {16000,0.01188288}, {16100,0.01214414}, {16200,0.01229730}, {16300,0.03180180}, {16400,0.01258559}, {16500,0.01259459}, {16600,0.01260360}, {16700,0.01327928}, {16800,0.01261261}, {16900,0.01267568}, {17000,0.01271171}, {17100,0.04083784}, {17200,0.01290090}, {17300,0.01300901}, {17400,0.05187387}, {17500,0.01345946}, {17600,0.01348649}, {17700,0.03011712}, {17800,0.01358559}, {17900,0.01359459}, {18000,0.01363063}, {18100,0.01364865}, {18200,0.01363063}, {18300,0.01379279}, {18400,0.03406306}, {18500,0.01393694}, {18600,0.04077477}, {18700,0.01417117}, {18800,0.03402703}, {18900,0.01444144}, {19000,0.01454054}, {19100,0.01458559}, {19200,0.01461261}, {19300,0.01541441}, {19400,0.01466667}, {19500,0.03311712}, {19600,0.01477477}, {19700,0.01493694}, {19800,0.04769369}, {19900,0.01512613}, {20000,0.01524771}};
data["big_flat"]["OCaml"]["eval lazy"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00009910}, {6,0.00002703}, {7,0.00005405}, {8,0.00000000}, {9,0.00007207}, {10,0.00006306}, {11,0.00000000}, {12,0.00000000}, {13,0.00006306}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00002703}, {18,0.00000000}, {19,0.00008108}, {20,0.00002703}, {21,0.00005405}, {22,0.00002703}, {23,0.00000000}, {24,0.00006306}, {25,0.00006306}, {26,0.00009910}, {27,0.00003604}, {28,0.00002703}, {29,0.00003604}, {30,0.00002703}, {31,0.00002703}, {32,0.00002703}, {33,0.00005405}, {34,0.00007207}, {35,0.00000000}, {36,0.00003604}, {37,0.00012613}, {38,0.00009009}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00002703}, {43,0.00003604}, {44,0.00009009}, {45,0.00006306}, {46,0.00002703}, {47,0.00006306}, {48,0.00007207}, {49,0.00006306}, {50,0.00000000}, {51,0.00005405}, {52,0.00000000}, {53,0.00010811}, {54,0.00002703}, {55,0.00003604}, {56,0.00006306}, {57,0.00012613}, {58,0.00013514}, {59,0.00013514}, {60,0.00003604}, {61,0.00005405}, {62,0.00003604}, {63,0.00002703}, {64,0.00002703}, {65,0.00002703}, {66,0.00010811}, {67,0.00002703}, {68,0.00000000}, {69,0.00000000}, {70,0.00011712}, {71,0.00000000}, {72,0.00007207}, {73,0.00011712}, {74,0.00010811}, {75,0.00009009}, {76,0.00003604}, {77,0.00003604}, {78,0.00003604}, {79,0.00000000}, {80,0.00012613}, {81,0.00006306}, {82,0.00000000}, {83,0.00006306}, {84,0.00009910}, {85,0.00005405}, {86,0.00009009}, {87,0.00003604}, {88,0.00011712}, {89,0.00006306}, {90,0.00003604}, {91,0.00009910}, {92,0.00012613}, {93,0.00009910}, {94,0.00007207}, {95,0.00006306}, {96,0.00000000}, {97,0.00009009}, {98,0.00009910}, {99,0.00006306}, {100,0.00008108}, {101,0.00006306}, {102,0.00010811}, {103,0.00012613}, {104,0.00009009}, {105,0.00000000}, {106,0.00009910}, {107,0.00006306}, {108,0.00003604}, {109,0.00000000}, {110,0.00003604}, {111,0.00009009}, {112,0.00002703}, {113,0.00003604}, {114,0.00006306}, {115,0.00013514}, {116,0.00006306}, {117,0.00012613}, {118,0.00006306}, {119,0.00006306}, {120,0.00019820}, {121,0.00009009}, {122,0.00011712}, {123,0.00003604}, {124,0.00006306}, {125,0.00009910}, {126,0.00005405}, {127,0.00006306}, {128,0.00009910}, {129,0.00002703}, {130,0.00003604}, {131,0.00006306}, {132,0.00009910}, {133,0.00000000}, {134,0.00007207}, {135,0.00006306}, {136,0.00015315}, {137,0.00014414}, {138,0.00012613}, {139,0.00098198}, {140,0.00009910}, {141,0.00009009}, {142,0.00009910}, {143,0.00009910}, {144,0.00009009}, {145,0.00013514}, {146,0.00015315}, {147,0.00005405}, {148,0.00006306}, {149,0.00016216}, {150,0.00009009}, {151,0.00009009}, {152,0.00012613}, {153,0.00016216}, {154,0.00005405}, {155,0.00016216}, {156,0.00014414}, {157,0.00008108}, {158,0.00007207}, {159,0.00015315}, {160,0.00009910}, {161,0.00002703}, {162,0.00019820}, {163,0.00017117}, {164,0.00026126}, {165,0.00005405}, {166,0.00025225}, {167,0.00006306}, {168,0.00022523}, {169,0.00019820}, {170,0.00018018}, {171,0.00006306}, {172,0.00018018}, {173,0.00139640}, {174,0.00026126}, {175,0.00003604}, {176,0.00019820}, {177,0.00009009}, {178,0.00006306}, {179,0.00021622}, {180,0.00015315}, {181,0.00010811}, {182,0.00009910}, {183,0.00009910}, {184,0.00005405}, {185,0.00013514}, {186,0.00005405}, {187,0.00002703}, {188,0.00019820}, {189,0.00016216}, {190,0.00007207}, {191,0.00002703}, {192,0.00018919}, {193,0.00020721}, {194,0.00009009}, {195,0.00002703}, {196,0.00010811}, {197,0.00003604}, {198,0.00012613}, {199,0.00006306}, {200,0.00037838}, {201,0.00032432}, {202,0.00014414}, {203,0.00009910}, {204,0.00019820}, {205,0.00014414}, {206,0.00006306}, {207,0.00014414}, {208,0.00009910}, {209,0.00011712}, {210,0.00016216}, {211,0.00009009}, {212,0.00006306}, {213,0.00018919}, {214,0.00020721}, {215,0.00007207}, {216,0.00012613}, {217,0.00011712}, {218,0.00015315}, {219,0.00012613}, {220,0.00016216}, {221,0.00007207}, {222,0.00019820}, {223,0.00016216}, {224,0.00020721}, {225,0.00018018}, {226,0.00018919}, {227,0.00009910}, {228,0.00015315}, {229,0.00027027}, {230,0.00011712}, {231,0.00013514}, {232,0.00011712}, {233,0.00027928}, {234,0.00025225}, {235,0.00028829}, {236,0.00018919}, {237,0.00018018}, {238,0.00021622}, {239,0.00013514}, {240,0.00014414}, {241,0.00018919}, {242,0.00014414}, {243,0.00013514}, {244,0.00005405}, {245,0.00014414}, {246,0.00015315}, {247,0.00012613}, {248,0.00021622}, {249,0.00009910}, {250,0.00015315}, {251,0.00018919}, {252,0.00027928}, {253,0.00019820}, {254,0.00019820}, {255,0.00011712}, {256,0.00020721}, {257,0.00018018}, {258,0.00027027}, {259,0.00014414}, {260,0.00009910}, {261,0.00013514}, {262,0.00029730}, {263,0.00027928}, {264,0.00018018}, {265,0.00012613}, {266,0.00015315}, {267,0.00010811}, {268,0.00016216}, {269,0.00008108}, {270,0.00019820}, {271,0.00016216}, {272,0.00028829}, {273,0.00011712}, {274,0.00007207}, {275,0.00023423}, {276,0.00021622}, {277,0.00014414}, {278,0.00018919}, {279,0.00027027}, {280,0.00006306}, {281,0.00016216}, {282,0.00013514}, {283,0.00020721}, {284,0.00022523}, {285,0.00022523}, {286,0.00016216}, {287,0.00010811}, {288,0.00019820}, {289,0.00020721}, {290,0.00028829}, {291,0.00019820}, {292,0.00022523}, {293,0.00002703}, {294,0.00018018}, {295,0.00022523}, {296,0.00022523}, {297,0.00025225}, {298,0.00024324}, {299,0.00015315}, {300,0.00023423}, {301,0.00015315}, {302,0.00017117}, {303,0.00009910}, {304,0.00016216}, {305,0.00026126}, {306,0.00010811}, {307,0.00019820}, {308,0.00012613}, {309,0.00028829}, {310,0.00015315}, {311,0.00019820}, {312,0.00014414}, {313,0.00021622}, {314,0.00012613}, {315,0.00019820}, {316,0.00013514}, {317,0.00025225}, {318,0.00118919}, {319,0.00032432}, {320,0.00023423}, {321,0.00012613}, {322,0.00013514}, {323,0.00026126}, {324,0.00016216}, {325,0.00029730}, {326,0.00016216}, {327,0.00026126}, {328,0.00026126}, {329,0.00012613}, {330,0.00027027}, {331,0.00029730}, {332,0.00014414}, {333,0.00021622}, {334,0.00005405}, {335,0.00015315}, {336,0.00013514}, {337,0.00011712}, {338,0.00017117}, {339,0.00017117}, {340,0.00023423}, {341,0.00021622}, {342,0.00009910}, {343,0.00025225}, {344,0.00024324}, {345,0.00003604}, {346,0.00017117}, {347,0.00020721}, {348,0.00018919}, {349,0.00032432}, {350,0.00024324}, {351,0.00028829}, {352,0.00009910}, {353,0.00021622}, {354,0.00018919}, {355,0.00027928}, {356,0.00018919}, {357,0.00017117}, {358,0.00021622}, {359,0.00026126}, {360,0.00026126}, {361,0.00014414}, {362,0.00025225}, {363,0.00029730}, {364,0.00022523}, {365,0.00031532}, {366,0.00025225}, {367,0.00034234}, {368,0.00036937}, {369,0.00024324}, {370,0.00025225}, {371,0.00019820}, {372,0.00018919}, {373,0.00015315}, {374,0.00018018}, {375,0.00022523}, {376,0.00017117}, {377,0.00027027}, {378,0.00034234}, {379,0.00025225}, {380,0.00017117}, {381,0.00028829}, {382,0.00026126}, {383,0.00008108}, {384,0.00018919}, {385,0.00012613}, {386,0.00034234}, {387,0.00014414}, {388,0.00023423}, {389,0.00032432}, {390,0.00009910}, {391,0.00036036}, {392,0.00009910}, {393,0.00018018}, {394,0.00032432}, {395,0.00018919}, {396,0.00034234}, {397,0.00019820}, {398,0.00027027}, {399,0.00028829}, {400,0.00031532}, {401,0.00035135}, {402,0.00016216}, {403,0.00031532}, {404,0.00019820}, {405,0.00042342}, {406,0.00019820}, {407,0.00039640}, {408,0.00031532}, {409,0.00011712}, {410,0.00041441}, {411,0.00008108}, {412,0.00018919}, {413,0.00021622}, {414,0.00036036}, {415,0.00043243}, {416,0.00044144}, {417,0.00012613}, {418,0.00026126}, {419,0.00018919}, {420,0.00022523}, {421,0.00025225}, {422,0.00028829}, {423,0.00023423}, {424,0.00033333}, {425,0.00022523}, {426,0.00022523}, {427,0.00023423}, {428,0.00027928}, {429,0.00050450}, {430,0.00036036}, {431,0.00024324}, {432,0.00023423}, {433,0.00028829}, {434,0.00024324}, {435,0.00021622}, {436,0.00025225}, {437,0.00017117}, {438,0.00018919}, {439,0.00028829}, {440,0.00026126}, {441,0.00040541}, {442,0.00026126}, {443,0.00033333}, {444,0.00019820}, {445,0.00024324}, {446,0.00019820}, {447,0.00013514}, {448,0.00022523}, {449,0.00027928}, {450,0.00039640}, {451,0.00024324}, {452,0.00022523}, {453,0.00033333}, {454,0.00032432}, {455,0.00033333}, {456,0.00036937}, {457,0.00028829}, {458,0.00046847}, {459,0.00018018}, {460,0.00018018}, {461,0.00055856}, {462,0.00017117}, {463,0.00029730}, {464,0.00032432}, {465,0.00043243}, {466,0.00011712}, {467,0.00046847}, {468,0.00037838}, {469,0.00044144}, {470,0.00021622}, {471,0.00023423}, {472,0.00015315}, {473,0.00025225}, {474,0.00033333}, {475,0.00029730}, {476,0.00033333}, {477,0.00029730}, {478,0.00026126}, {479,0.00025225}, {480,0.00029730}, {481,0.00029730}, {482,0.00022523}, {483,0.00022523}, {484,0.00027027}, {485,0.00029730}, {486,0.00021622}, {487,0.00025225}, {488,0.00039640}, {489,0.00037838}, {490,0.00039640}, {491,0.00016216}, {492,0.00029730}, {493,0.00020721}, {494,0.00030631}, {495,0.00032432}, {496,0.00032432}, {497,0.00019820}, {498,0.00039640}, {499,0.00027027}, {500,0.00040541}, {505,0.00015315}, {510,0.00022523}, {515,0.00051351}, {520,0.00040541}, {525,0.00018018}, {530,0.00027928}, {535,0.00033333}, {540,0.00027027}, {545,0.00024324}, {550,0.00030631}, {555,0.00033333}, {560,0.00036036}, {565,0.00043243}, {570,0.00024324}, {575,0.00026126}, {580,0.00027928}, {585,0.00043243}, {590,0.00023423}, {595,0.00021622}, {600,0.00031532}, {605,0.00018018}, {610,0.00039640}, {615,0.00045946}, {620,0.00043243}, {625,0.00036937}, {630,0.00017117}, {635,0.00047748}, {640,0.00045045}, {645,0.00035135}, {650,0.00036036}, {655,0.00047748}, {660,0.00031532}, {665,0.00039640}, {670,0.00047748}, {675,0.00052252}, {680,0.00030631}, {685,0.00045946}, {690,0.00032432}, {695,0.00031532}, {700,0.00030631}, {705,0.00031532}, {710,0.00042342}, {715,0.00035135}, {720,0.00044144}, {725,0.00022523}, {730,0.00055856}, {735,0.00007207}, {740,0.00027928}, {745,0.00062162}, {750,0.00014414}, {755,0.00045946}, {760,0.00035135}, {765,0.00041441}, {770,0.00078378}, {775,0.00026126}, {780,0.00054054}, {785,0.00042342}, {790,0.00048649}, {795,0.00051351}, {800,0.00026126}, {805,0.00040541}, {810,0.00054955}, {815,0.00065766}, {820,0.00045946}, {825,0.00020721}, {830,0.00069369}, {835,0.00045946}, {840,0.00051351}, {845,0.00043243}, {850,0.00064865}, {855,0.00035135}, {860,0.00036937}, {865,0.00041441}, {870,0.00047748}, {875,0.00046847}, {880,0.00076577}, {885,0.00062162}, {890,0.00060360}, {895,0.00069369}, {900,0.00060360}, {905,0.00062162}, {910,0.00067568}, {915,0.00037838}, {920,0.00054054}, {925,0.00054955}, {930,0.00061261}, {935,0.00046847}, {940,0.00054054}, {945,0.00069369}, {950,0.00071171}, {955,0.00047748}, {960,0.00063964}, {965,0.00045946}, {970,0.00051351}, {975,0.00069369}, {980,0.00063063}, {985,0.00456757}, {990,0.00042342}, {995,0.00062162}, {1000,0.00032432}, {1010,0.00050450}, {1020,0.00051351}, {1030,0.00067568}, {1040,0.00261261}, {1050,0.00075676}, {1060,0.00037838}, {1070,0.00075676}, {1080,0.00063964}, {1090,0.00056757}, {1100,0.00067568}, {1110,0.00061261}, {1120,0.00062162}, {1130,0.00056757}, {1140,0.00074775}, {1150,0.00058559}, {1160,0.00084685}, {1170,0.00074775}, {1180,0.00060360}, {1190,0.00049550}, {1200,0.00067568}, {1210,0.00081982}, {1220,0.00077477}, {1230,0.00071171}, {1240,0.00072973}, {1250,0.00053153}, {1260,0.00063063}, {1270,0.00071171}, {1280,0.00065766}, {1290,0.00088288}, {1300,0.00098198}, {1310,0.00080180}, {1320,0.00080180}, {1330,0.00077477}, {1340,0.00081081}, {1350,0.00090991}, {1360,0.00080180}, {1370,0.00075676}, {1380,0.00066667}, {1390,0.00515315}, {1400,0.00122523}, {1410,0.00060360}, {1420,0.00051351}, {1430,0.00101802}, {1440,0.00061261}, {1450,0.00089189}, {1460,0.00072072}, {1470,0.00080180}, {1480,0.00067568}, {1490,0.00068468}, {1500,0.00104505}, {1510,0.00075676}, {1520,0.00092793}, {1530,0.00081982}, {1540,0.00066667}, {1550,0.00082883}, {1560,0.00067568}, {1570,0.00097297}, {1580,0.00110811}, {1590,0.00101802}, {1600,0.00080180}, {1610,0.00091892}, {1620,0.00100000}, {1630,0.00092793}, {1640,0.00066667}, {1650,0.00087387}, {1660,0.00068468}, {1670,0.00103604}, {1680,0.00083784}, {1690,0.00080180}, {1700,0.00097297}, {1710,0.00085586}, {1720,0.00082883}, {1730,0.00101802}, {1740,0.00080180}, {1750,0.00100901}, {1760,0.00107207}, {1770,0.00076577}, {1780,0.00109009}, {1790,0.00101802}, {1800,0.00111712}, {1810,0.00102703}, {1820,0.00137838}, {1830,0.00113514}, {1840,0.00097297}, {1850,0.00078378}, {1860,0.00127928}, {1870,0.00095495}, {1880,0.00075676}, {1890,0.00091892}, {1900,0.00123423}, {1910,0.00099099}, {1920,0.00127928}, {1930,0.00103604}, {1940,0.00135135}, {1950,0.00118018}, {1960,0.00117117}, {1970,0.00101802}, {1980,0.00088288}, {1990,0.00127928}, {2000,0.00092793}, {2050,0.00102703}, {2100,0.00128829}, {2150,0.00124324}, {2200,0.00121622}, {2250,0.00154054}, {2300,0.00141441}, {2350,0.00154054}, {2400,0.00148649}, {2450,0.00128829}, {2500,0.00163964}, {2550,0.00089189}, {2600,0.00160360}, {2650,0.00154955}, {2700,0.00165766}, {2750,0.00136937}, {2800,0.00172973}, {2850,0.00165766}, {2900,0.00173874}, {2950,0.00144144}, {3000,0.00218919}, {3050,0.00207207}, {3100,0.00192793}, {3150,0.00175676}, {3200,0.00218018}, {3250,0.00165766}, {3300,0.00178378}, {3350,0.00214414}, {3400,0.00192793}, {3450,0.00206306}, {3500,0.00229730}, {3550,0.00236937}, {3600,0.00204505}, {3650,0.00214414}, {3700,0.00206306}, {3750,0.00190090}, {3800,0.00246847}, {3850,0.00245946}, {3900,0.00244144}, {3950,0.00253153}, {4000,0.00244144}, {4050,0.00243243}, {4100,0.00282883}, {4150,0.00280180}, {4200,0.00275676}, {4250,0.00258559}, {4300,0.00288288}, {4350,0.00277477}, {4400,0.00277477}, {4450,0.01517117}, {4500,0.00301802}, {4550,0.00306306}, {4600,0.00304505}, {4650,0.00314414}, {4700,0.00311712}, {4750,0.00331532}, {4800,0.00304505}, {4850,0.00315315}, {4900,0.00344144}, {4950,0.00333333}, {5000,0.00330631}, {5050,0.00325225}, {5100,0.00353153}, {5150,0.00361261}, {5200,0.00376577}, {5250,0.00363063}, {5300,0.00368468}, {5350,0.00364865}, {5400,0.00373874}, {5450,0.00389189}, {5500,0.00381982}, {5550,0.00425225}, {5600,0.00382883}, {5650,0.00387387}, {5700,0.00398198}, {5750,0.02648649}, {5800,0.00401802}, {5850,0.00402703}, {5900,0.00388288}, {5950,0.00423423}, {6000,0.03238739}, {6050,0.00408108}, {6100,0.00409009}, {6150,0.00443243}, {6200,0.00445045}, {6250,0.00452252}, {6300,0.03149550}, {6350,0.00463964}, {6400,0.00454054}, {6450,0.00459459}, {6500,0.00484685}, {6550,0.00463964}, {6600,0.00456757}, {6650,0.00443243}, {6700,0.02145946}, {6750,0.00525225}, {6800,0.00479279}, {6850,0.00493694}, {6900,0.00502703}, {6950,0.00467568}, {7000,0.00510811}, {7050,0.00509910}, {7100,0.00514414}, {7150,0.00497297}, {7200,0.00566667}, {7250,0.00507207}, {7300,0.00523423}, {7350,0.00550450}, {7400,0.00537838}, {7450,0.00550450}, {7500,0.00527928}, {7550,0.00530631}, {7600,0.00523423}, {7650,0.00516216}, {7700,0.00559459}, {7750,0.00560360}, {7800,0.00536036}, {7850,0.00545045}, {7900,0.00599099}, {7950,0.00597297}, {8000,0.00590991}, {8050,0.00608108}, {8100,0.02227027}, {8150,0.00570270}, {8200,0.00563964}, {8250,0.00575676}, {8300,0.00627027}, {8350,0.00577477}, {8400,0.00580180}, {8450,0.00663063}, {8500,0.02756757}, {8550,0.00652252}, {8600,0.00612613}, {8650,0.00618919}, {8700,0.00591892}, {8750,0.00655856}, {8800,0.02684685}, {8850,0.00649550}, {8900,0.00634234}, {8950,0.00654054}, {9000,0.00666667}, {9050,0.02176577}, {9100,0.00700901}, {9150,0.00674775}, {9200,0.00669369}, {9250,0.03952252}, {9300,0.00683784}, {9350,0.00688288}, {9400,0.00710811}, {9450,0.02696396}, {9500,0.00706306}, {9550,0.00707207}, {9600,0.00669369}, {9650,0.00734234}, {9700,0.00710811}, {9750,0.00719820}, {9800,0.00731532}, {9850,0.00730631}, {9900,0.00733333}, {9950,0.00750450}, {10000,0.00764865}, {10100,0.00746847}, {10200,0.00758559}, {10300,0.00790090}, {10400,0.00843243}, {10500,0.00782883}, {10600,0.00818919}, {10700,0.00804505}, {10800,0.00790090}, {10900,0.00832432}, {11000,0.00844144}, {11100,0.00851351}, {11200,0.00836036}, {11300,0.00871171}, {11400,0.00880180}, {11500,0.00881982}, {11600,0.00866667}, {11700,0.00886486}, {11800,0.00959459}, {11900,0.00870270}, {12000,0.00868468}, {12100,0.00908108}, {12200,0.00914414}, {12300,0.02432432}, {12400,0.00956757}, {12500,0.00971171}, {12600,0.02625225}, {12700,0.00970270}, {12800,0.00963964}, {12900,0.00999099}, {13000,0.05710811}, {13100,0.00978378}, {13200,0.01000000}, {13300,0.01067568}, {13400,0.00843243}, {13500,0.01045946}, {13600,0.01052252}, {13700,0.01076577}, {13800,0.01031532}, {13900,0.01062162}, {14000,0.01090090}, {14100,0.03976577}, {14200,0.01159459}, {14300,0.01128829}, {14400,0.01123423}, {14500,0.01141441}, {14600,0.01149550}, {14700,0.01118018}, {14800,0.01145045}, {14900,0.01133333}, {15000,0.01174775}, {15100,0.01162162}, {15200,0.01176577}, {15300,0.01200901}, {15400,0.01184685}, {15500,0.01254955}, {15600,0.04177477}, {15700,0.01208108}, {15800,0.01224324}, {15900,0.01229730}, {16000,0.01235135}, {16100,0.01245045}, {16200,0.01249550}, {16300,0.03157658}, {16400,0.01255856}, {16500,0.01271171}, {16600,0.01272072}, {16700,0.01339640}, {16800,0.01280180}, {16900,0.01315315}, {17000,0.01286486}, {17100,0.04040541}, {17200,0.01326126}, {17300,0.01360360}, {17400,0.05155856}, {17500,0.01342342}, {17600,0.01336036}, {17700,0.02990090}, {17800,0.01343243}, {17900,0.01364865}, {18000,0.01376577}, {18100,0.01412613}, {18200,0.01391892}, {18300,0.01438739}, {18400,0.03429730}, {18500,0.01434234}, {18600,0.04062162}, {18700,0.01449550}, {18800,0.03400000}, {18900,0.01466667}, {19000,0.01457658}, {19100,0.01445946}, {19200,0.01472973}, {19300,0.01567568}, {19400,0.01503604}, {19500,0.03321622}, {19600,0.01509910}, {19700,0.01527928}, {19800,0.04799099}, {19900,0.01526126}, {20000,0.01522936}};
data["big_flat"]["OCaml"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00003604}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00003604}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00003604}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00007207}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00003604}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00002703}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00003604}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00003604}, {271,0.00000000}, {272,0.00002703}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00003604}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00003604}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00003604}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00003604}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00003604}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00003604}, {351,0.00007207}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00003604}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00003604}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00003604}, {455,0.00000000}, {456,0.00000000}, {457,0.00002703}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00003604}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00003604}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00003604}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00003604}, {520,0.00000000}, {525,0.00003604}, {530,0.00000000}, {535,0.00000000}, {540,0.00003604}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00003604}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00003604}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00003604}, {705,0.00003604}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00003604}, {745,0.00000000}, {750,0.00003604}, {755,0.00003604}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00003604}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00002703}, {860,0.00000000}, {865,0.00000000}, {870,0.00003604}, {875,0.00003604}, {880,0.00003604}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00003604}, {930,0.00003604}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00003604}, {980,0.00000000}, {985,0.00021622}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00006306}, {1050,0.00000000}, {1060,0.00003604}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00003604}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00002703}, {1170,0.00007207}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00003604}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00002703}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00003604}, {1330,0.00000000}, {1340,0.00003604}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00017117}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003604}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00003604}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00003604}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00007207}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00003604}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00003604}, {1720,0.00003604}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00007207}, {1840,0.00000000}, {1850,0.00007207}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00003604}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00003604}, {3050,0.00000000}, {3100,0.00007207}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00003604}, {3300,0.00003604}, {3350,0.00003604}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00003604}, {3600,0.00000000}, {3650,0.00003604}, {3700,0.00003604}, {3750,0.00007207}, {3800,0.00003604}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00003604}, {4000,0.00000000}, {4050,0.00007207}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00003604}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00002703}, {4450,0.00031532}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00003604}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00003604}, {5150,0.00003604}, {5200,0.00003604}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00003604}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00003604}, {5600,0.00000000}, {5650,0.00003604}, {5700,0.00003604}, {5750,0.00031532}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00064865}, {6050,0.00000000}, {6100,0.00003604}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00051351}, {6350,0.00000000}, {6400,0.00003604}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00007207}, {6700,0.00031532}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00003604}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00002703}, {7350,0.00002703}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00003604}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00007207}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00003604}, {8000,0.00000000}, {8050,0.00003604}, {8100,0.00031532}, {8150,0.00002703}, {8200,0.00003604}, {8250,0.00003604}, {8300,0.00000000}, {8350,0.00003604}, {8400,0.00003604}, {8450,0.00003604}, {8500,0.00050450}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00003604}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00027928}, {8850,0.00003604}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00032432}, {9100,0.00003604}, {9150,0.00000000}, {9200,0.00003604}, {9250,0.00060360}, {9300,0.00003604}, {9350,0.00003604}, {9400,0.00000000}, {9450,0.00060360}, {9500,0.00007207}, {9550,0.00007207}, {9600,0.00003604}, {9650,0.00000000}, {9700,0.00003604}, {9750,0.00003604}, {9800,0.00000000}, {9850,0.00003604}, {9900,0.00000000}, {9950,0.00003604}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00003604}, {10800,0.00003604}, {10900,0.00003604}, {11000,0.00003604}, {11100,0.00003604}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00003604}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00003604}, {12000,0.00003604}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00003604}, {12600,0.00007207}, {12700,0.00000000}, {12800,0.00003604}, {12900,0.00000000}, {13000,0.00087387}, {13100,0.00003604}, {13200,0.00000000}, {13300,0.00003604}, {13400,0.00003604}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00007207}, {13800,0.00007207}, {13900,0.00007207}, {14000,0.00000000}, {14100,0.00072072}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00003604}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00010811}, {15500,0.00007207}, {15600,0.00076577}, {15700,0.00007207}, {15800,0.00003604}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00003604}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00003604}, {16800,0.00003604}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00006306}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00003604}, {17700,0.00000000}, {17800,0.00007207}, {17900,0.00000000}, {18000,0.00003604}, {18100,0.00000000}, {18200,0.00003604}, {18300,0.00003604}, {18400,0.00003604}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00003604}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00003604}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00003604}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["OCaml"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.01457658}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00098198}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000901}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000901}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000901}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000901}, {1350,0.00000901}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00002703}, {1410,0.00001802}, {1420,0.00002703}, {1430,0.00004505}, {1440,0.00561261}, {1450,0.00005405}, {1460,0.00003604}, {1470,0.00005405}, {1480,0.00004505}, {1490,0.00000000}, {1500,0.00005405}, {1510,0.00011712}, {1520,0.00007207}, {1530,0.00003604}, {1540,0.00012613}, {1550,0.00010811}, {1560,0.00015315}, {1570,0.00011712}, {1580,0.00025225}, {1590,0.00017117}, {1600,0.00022523}, {1610,0.00026126}, {1620,0.00042342}, {1630,0.00031532}, {1640,0.00039640}, {1650,0.00039640}, {1660,0.00044144}, {1670,0.00050450}, {1680,0.00052252}, {1690,0.00054955}, {1700,0.00053153}, {1710,0.00072072}, {1720,0.00061261}, {1730,0.00067568}, {1740,0.00070270}, {1750,0.00072973}, {1760,0.00072072}, {1770,0.00081081}, {1780,0.00079279}, {1790,0.00079279}, {1800,0.00083784}, {1810,0.00081982}, {1820,0.00087387}, {1830,0.00093694}, {1840,0.00095495}, {1850,0.00091892}, {1860,0.00100000}, {1870,0.00095495}, {1880,0.00099099}, {1890,0.00100000}, {1900,0.00095495}, {1910,0.00098198}, {1920,0.00100000}, {1930,0.00100000}, {1940,0.00100000}, {1950,0.00001802}, {1960,0.00100000}, {1970,0.00100000}, {1980,0.00100000}, {1990,0.00100000}, {2000,0.00100000}, {2050,0.00100000}, {2100,0.00098198}, {2150,0.00100000}, {2200,0.00100000}, {2250,0.00100000}, {2300,0.00100000}, {2350,0.00100901}, {2400,0.00100000}, {2450,0.00101802}, {2500,0.00102703}, {2550,0.00104505}, {2600,0.00106306}, {2650,0.00115315}, {2700,0.00135135}, {2750,0.00122523}, {2800,0.00128829}, {2850,0.00136937}, {2900,0.00145946}, {2950,0.00147748}, {3000,0.00153153}, {3050,0.00164865}, {3100,0.00172973}, {3150,0.00174775}, {3200,0.00182883}, {3250,0.00186486}, {3300,0.00195495}, {3350,0.00190991}, {3400,0.00198198}, {3450,0.00199099}, {3500,0.00200000}, {3550,0.00200901}, {3600,0.00204505}, {3650,0.00201802}, {3700,0.00207207}, {3750,0.00207207}, {3800,0.00214414}, {3850,0.00223423}, {3900,0.00235135}, {3950,0.00240541}, {4000,0.00242342}, {4050,0.00252252}, {4100,0.00253153}, {4150,0.00257658}, {4200,0.00201802}, {4250,0.00270270}, {4300,0.00270270}, {4350,0.00283784}, {4400,0.00283784}, {4450,0.00179279}, {4500,0.00289189}, {4550,0.00297297}, {4600,0.00296396}, {4650,0.00300000}, {4700,0.00299099}, {4750,0.00301802}, {4800,0.00303604}, {4850,0.00201802}, {4900,0.00312613}, {4950,0.00318018}, {5000,0.00202703}, {5050,0.00332432}, {5100,0.00336036}, {5150,0.00345946}, {5200,0.00351351}, {5250,0.00354054}, {5300,0.00361261}, {5350,0.01434234}, {5400,0.00361261}, {5450,0.00365766}, {5500,0.00367568}, {5550,0.00367568}, {5600,0.00375676}, {5650,0.00382883}, {5700,0.00385586}, {5750,0.00206306}, {5800,0.00390991}, {5850,0.00396396}, {5900,0.00399099}, {5950,0.00401802}, {6000,0.00229730}, {6050,0.00407207}, {6100,0.00406306}, {6150,0.00412613}, {6200,0.00428829}, {6250,0.00428829}, {6300,0.00263063}, {6350,0.00445045}, {6400,0.00454054}, {6450,0.00458559}, {6500,0.00460360}, {6550,0.00461261}, {6600,0.00463063}, {6650,0.00463063}, {6700,0.00288288}, {6750,0.00458559}, {6800,0.00463063}, {6850,0.00465766}, {6900,0.00469369}, {6950,0.00469369}, {7000,0.00470270}, {7050,0.00473874}, {7100,0.00485586}, {7150,0.00485586}, {7200,0.00496396}, {7250,0.00499099}, {7300,0.00505405}, {7350,0.00510811}, {7400,0.00516216}, {7450,0.00525225}, {7500,0.00532432}, {7550,0.00536937}, {7600,0.00539640}, {7650,0.00548649}, {7700,0.00554054}, {7750,0.00562162}, {7800,0.00561261}, {7850,0.00563063}, {7900,0.00563964}, {7950,0.00563964}, {8000,0.00563964}, {8050,0.02972973}, {8100,0.00360360}, {8150,0.00564865}, {8200,0.00564865}, {8250,0.00567568}, {8300,0.00568468}, {8350,0.00573874}, {8400,0.00575676}, {8450,0.00578378}, {8500,0.00366667}, {8550,0.00596396}, {8600,0.00600000}, {8650,0.00611712}, {8700,0.00622523}, {8750,0.00634234}, {8800,0.00389189}, {8850,0.00641441}, {8900,0.00644144}, {8950,0.00659459}, {9000,0.00654955}, {9050,0.00399099}, {9100,0.00662162}, {9150,0.00663063}, {9200,0.00662162}, {9250,0.00400000}, {9300,0.00663063}, {9350,0.00662162}, {9400,0.00662162}, {9450,0.00404505}, {9500,0.00662162}, {9550,0.00665766}, {9600,0.00718018}, {9650,0.00665766}, {9700,0.00672973}, {9750,0.00677477}, {9800,0.00431532}, {9850,0.00681081}, {9900,0.00698198}, {9950,0.00448649}, {10000,0.00714414}, {10100,0.00729730}, {10200,0.00748649}, {10300,0.00755856}, {10400,0.03004505}, {10500,0.00761261}, {10600,0.00763964}, {10700,0.00762162}, {10800,0.00765766}, {10900,0.00647748}, {11000,0.00773874}, {11100,0.00500901}, {11200,0.00789189}, {11300,0.00504505}, {11400,0.00823423}, {11500,0.00837838}, {11600,0.00849550}, {11700,0.00856757}, {11800,0.04859459}, {11900,0.00861261}, {12000,0.00573874}, {12100,0.00861261}, {12200,0.00866667}, {12300,0.00559459}, {12400,0.00884685}, {12500,0.00888288}, {12600,0.00559459}, {12700,0.00924324}, {12800,0.00934234}, {12900,0.00946847}, {13000,0.00569369}, {13100,0.00954955}, {13200,0.00959459}, {13300,0.00962162}, {13400,0.00604505}, {13500,0.04993694}, {13600,0.00971171}, {13700,0.00985586}, {13800,0.00990991}, {13900,0.00997297}, {14000,0.00659459}, {14100,0.00658559}, {14200,0.03773874}, {14300,0.01089189}, {14400,0.01055856}, {14500,0.01059459}, {14600,0.01058559}, {14700,0.01066667}, {14800,0.01078378}, {14900,0.01078378}, {15000,0.01079279}, {15100,0.01090991}, {15200,0.01104505}, {15300,0.01109910}, {15400,0.01175676}, {15500,0.03785586}, {15600,0.00710811}, {15700,0.00733333}, {15800,0.01143243}, {15900,0.01156757}, {16000,0.01166667}, {16100,0.01166667}, {16200,0.05540541}, {16300,0.00759459}, {16400,0.01198198}, {16500,0.01200000}, {16600,0.01204505}, {16700,0.03748649}, {16800,0.00782883}, {16900,0.01232432}, {17000,0.01242342}, {17100,0.00762162}, {17200,0.01254054}, {17300,0.01263964}, {17400,0.00770270}, {17500,0.01284685}, {17600,0.01290090}, {17700,0.00816216}, {17800,0.01302703}, {17900,3.50512613}, {18000,0.01320721}, {18100,0.01330631}, {18200,0.00861261}, {18300,0.01336036}, {18400,0.00859459}, {18500,0.01346847}, {18600,0.00860360}, {18700,0.01367568}, {18800,0.00860360}, {18900,0.01390991}, {19000,0.00863063}, {19100,0.01403604}, {19200,0.01414414}, {19300,0.05209910}, {19400,0.01427027}, {19500,0.00881081}, {19600,0.01426126}, {19700,0.01441441}, {19800,0.00931532}, {19900,0.01461261}, {20000,0.01468807}};
data["big_flat"]["OCaml"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00002703}, {4,0.00003604}, {5,0.00000000}, {6,0.00002703}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00003604}, {11,0.00002703}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00007207}, {16,0.00003604}, {17,0.00000000}, {18,0.00000000}, {19,0.00003604}, {20,0.00000000}, {21,0.00002703}, {22,0.00006306}, {23,0.00002703}, {24,0.00002703}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00002703}, {32,0.00007207}, {33,0.00000000}, {34,0.00006306}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00006306}, {40,0.00000000}, {41,0.00000000}, {42,0.01445045}, {43,0.00003604}, {44,0.00000000}, {45,0.00007207}, {46,0.00000000}, {47,0.00006306}, {48,0.00005405}, {49,0.00005405}, {50,0.00002703}, {51,0.00012613}, {52,0.00002703}, {53,0.00000000}, {54,0.00002703}, {55,0.00003604}, {56,0.00000000}, {57,0.00009009}, {58,0.00000000}, {59,0.00006306}, {60,0.00003604}, {61,0.00000000}, {62,0.00003604}, {63,0.00007207}, {64,0.00006306}, {65,0.00003604}, {66,0.00003604}, {67,0.00003604}, {68,0.00003604}, {69,0.00000000}, {70,0.00008108}, {71,0.00010811}, {72,0.00002703}, {73,0.00000000}, {74,0.00016216}, {75,0.00010811}, {76,0.00009910}, {77,0.00000000}, {78,0.00002703}, {79,0.00007207}, {80,0.00003604}, {81,0.00009910}, {82,0.00009910}, {83,0.00007207}, {84,0.00009009}, {85,0.00000000}, {86,0.00006306}, {87,0.00009910}, {88,0.00009910}, {89,0.00000000}, {90,0.00006306}, {91,0.00002703}, {92,0.00006306}, {93,0.00000000}, {94,0.00006306}, {95,0.00000000}, {96,0.00000000}, {97,0.00009009}, {98,0.00009910}, {99,0.00006306}, {100,0.00009910}, {101,0.00012613}, {102,0.00006306}, {103,0.00009009}, {104,0.00003604}, {105,0.00014414}, {106,0.00003604}, {107,0.00006306}, {108,0.00002703}, {109,0.00003604}, {110,0.00000000}, {111,0.00000000}, {112,0.00002703}, {113,0.00010811}, {114,0.00010811}, {115,0.00006306}, {116,0.00006306}, {117,0.00006306}, {118,0.00003604}, {119,0.00014414}, {120,0.00013514}, {121,0.00009910}, {122,0.00002703}, {123,0.00007207}, {124,0.00006306}, {125,0.00009910}, {126,0.00009009}, {127,0.00006306}, {128,0.00002703}, {129,0.00000000}, {130,0.00003604}, {131,0.00003604}, {132,0.00009910}, {133,0.00003604}, {134,0.00006306}, {135,0.00000000}, {136,0.00000000}, {137,0.00006306}, {138,0.00008108}, {139,0.00019820}, {140,0.00007207}, {141,0.00006306}, {142,0.00009009}, {143,0.00003604}, {144,0.00013514}, {145,0.00009009}, {146,0.00007207}, {147,0.00009910}, {148,0.00012613}, {149,0.00018018}, {150,0.00013514}, {151,0.00008108}, {152,0.00009910}, {153,0.00003604}, {154,0.00009009}, {155,0.00010811}, {156,0.00009009}, {157,0.00016216}, {158,0.00012613}, {159,0.00006306}, {160,0.00006306}, {161,0.00008108}, {162,0.00022523}, {163,0.00000000}, {164,0.00000000}, {165,0.00006306}, {166,0.00011712}, {167,0.00012613}, {168,0.00000000}, {169,0.00000000}, {170,0.00010811}, {171,0.00000000}, {172,0.00003604}, {173,0.00013514}, {174,0.00009009}, {175,0.00003604}, {176,0.00005405}, {177,0.00011712}, {178,0.00006306}, {179,0.00006306}, {180,0.00009009}, {181,0.00014414}, {182,0.00011712}, {183,0.00009910}, {184,0.00013514}, {185,0.00009009}, {186,0.00013514}, {187,0.00006306}, {188,0.00012613}, {189,0.00015315}, {190,0.00008108}, {191,0.00012613}, {192,0.00000000}, {193,0.00003604}, {194,0.00010811}, {195,0.00013514}, {196,0.00024324}, {197,0.00007207}, {198,0.00011712}, {199,0.00008108}, {200,0.00009009}, {201,0.00013514}, {202,0.00009009}, {203,0.00026126}, {204,0.00014414}, {205,0.00009009}, {206,0.00009910}, {207,0.00006306}, {208,0.00012613}, {209,0.00000000}, {210,0.00010811}, {211,0.00015315}, {212,0.00005405}, {213,0.00009009}, {214,0.00009910}, {215,0.00012613}, {216,0.00009910}, {217,0.00003604}, {218,0.00006306}, {219,0.00008108}, {220,0.00018919}, {221,0.00017117}, {222,0.00006306}, {223,0.00012613}, {224,0.00012613}, {225,0.00018018}, {226,0.00007207}, {227,0.00012613}, {228,0.00012613}, {229,0.00013514}, {230,0.00009009}, {231,0.00006306}, {232,0.00007207}, {233,0.00009009}, {234,0.00009009}, {235,0.00012613}, {236,0.00017117}, {237,0.00013514}, {238,0.00009910}, {239,0.00010811}, {240,0.00003604}, {241,0.00006306}, {242,0.00000000}, {243,0.00007207}, {244,0.00018018}, {245,0.00007207}, {246,0.00003604}, {247,0.00009009}, {248,0.00011712}, {249,0.00017117}, {250,0.00005405}, {251,0.00015315}, {252,0.00014414}, {253,0.00009910}, {254,0.00005405}, {255,0.00016216}, {256,0.00009910}, {257,0.00020721}, {258,0.00006306}, {259,0.00000000}, {260,0.00018018}, {261,0.00018919}, {262,0.00017117}, {263,0.00005405}, {264,0.00007207}, {265,0.00009009}, {266,0.00006306}, {267,0.00007207}, {268,0.00017117}, {269,0.00011712}, {270,0.00009009}, {271,0.00025225}, {272,0.00007207}, {273,0.00012613}, {274,0.00009910}, {275,0.00014414}, {276,0.00009009}, {277,0.00019820}, {278,0.00016216}, {279,0.00015315}, {280,0.00009910}, {281,0.00006306}, {282,0.00009009}, {283,0.00012613}, {284,0.00011712}, {285,0.00018919}, {286,0.00006306}, {287,0.00005405}, {288,0.00016216}, {289,0.00011712}, {290,0.00020721}, {291,0.00020721}, {292,0.00002703}, {293,0.00010811}, {294,0.00017117}, {295,0.00012613}, {296,0.00015315}, {297,0.00000000}, {298,0.00014414}, {299,0.00018018}, {300,0.00025225}, {301,0.00009910}, {302,0.00024324}, {303,0.00002703}, {304,0.00019820}, {305,0.00024324}, {306,0.00013514}, {307,0.00019820}, {308,0.00016216}, {309,0.00023423}, {310,0.00012613}, {311,0.00013514}, {312,0.00013514}, {313,0.00026126}, {314,0.00012613}, {315,0.00012613}, {316,0.00013514}, {317,0.00007207}, {318,0.00010811}, {319,0.00011712}, {320,0.00033333}, {321,0.00019820}, {322,0.00013514}, {323,0.00008108}, {324,0.00020721}, {325,0.00009009}, {326,0.00022523}, {327,0.00016216}, {328,0.00017117}, {329,0.00015315}, {330,0.00007207}, {331,0.00009009}, {332,0.00012613}, {333,0.00016216}, {334,0.00012613}, {335,0.00013514}, {336,0.00034234}, {337,0.00136036}, {338,0.00013514}, {339,0.00009910}, {340,0.00026126}, {341,0.00013514}, {342,0.00003604}, {343,0.00005405}, {344,0.00018919}, {345,0.00020721}, {346,0.00009910}, {347,0.00009009}, {348,0.00003604}, {349,0.00012613}, {350,0.00017117}, {351,0.00003604}, {352,0.00029730}, {353,0.00002703}, {354,0.00015315}, {355,0.00016216}, {356,0.00009009}, {357,0.00012613}, {358,0.00023423}, {359,0.00014414}, {360,0.00010811}, {361,0.00009910}, {362,0.00010811}, {363,0.00006306}, {364,0.00010811}, {365,0.00014414}, {366,0.00008108}, {367,0.00019820}, {368,0.00010811}, {369,0.00007207}, {370,0.00012613}, {371,0.00017117}, {372,0.00006306}, {373,0.00025225}, {374,0.00016216}, {375,0.00020721}, {376,0.00019820}, {377,0.00009910}, {378,0.00013514}, {379,0.00036036}, {380,0.00017117}, {381,0.00023423}, {382,0.00012613}, {383,0.00020721}, {384,0.00015315}, {385,0.00012613}, {386,0.00014414}, {387,0.00017117}, {388,0.00027027}, {389,0.00013514}, {390,0.00012613}, {391,0.00029730}, {392,0.00019820}, {393,0.00025225}, {394,0.00029730}, {395,0.00033333}, {396,0.00034234}, {397,0.00018018}, {398,0.00028829}, {399,0.00013514}, {400,0.00020721}, {401,0.00030631}, {402,0.00019820}, {403,0.00037838}, {404,0.00012613}, {405,0.00016216}, {406,0.00014414}, {407,0.00019820}, {408,0.00013514}, {409,0.00027928}, {410,0.00017117}, {411,0.00018919}, {412,0.00033333}, {413,0.00029730}, {414,0.00016216}, {415,0.00014414}, {416,0.00037838}, {417,0.00015315}, {418,0.00027027}, {419,0.00022523}, {420,0.00028829}, {421,0.00009910}, {422,0.00033333}, {423,0.00009910}, {424,0.00010811}, {425,0.00009910}, {426,0.00022523}, {427,0.00018018}, {428,0.00021622}, {429,0.00019820}, {430,0.00018018}, {431,0.00002703}, {432,0.00009009}, {433,0.00013514}, {434,0.00010811}, {435,0.00022523}, {436,0.00022523}, {437,0.00015315}, {438,0.00028829}, {439,0.00012613}, {440,0.00018018}, {441,0.00029730}, {442,0.00023423}, {443,0.00018919}, {444,0.00013514}, {445,0.00013514}, {446,0.00012613}, {447,0.00012613}, {448,0.00030631}, {449,0.00024324}, {450,0.00009910}, {451,0.00009910}, {452,0.00017117}, {453,0.00006306}, {454,0.00009910}, {455,0.00025225}, {456,0.00007207}, {457,0.00019820}, {458,0.00018919}, {459,0.00013514}, {460,0.00023423}, {461,0.00016216}, {462,0.00025225}, {463,0.00016216}, {464,0.00030631}, {465,0.00017117}, {466,0.00036937}, {467,0.00019820}, {468,0.00013514}, {469,0.00022523}, {470,0.00016216}, {471,0.00006306}, {472,0.00024324}, {473,0.00029730}, {474,0.00009910}, {475,0.00012613}, {476,0.00045946}, {477,0.00018018}, {478,0.00020721}, {479,0.00013514}, {480,0.00017117}, {481,0.00035135}, {482,0.00031532}, {483,0.00030631}, {484,0.00013514}, {485,0.00029730}, {486,0.00018919}, {487,0.00023423}, {488,0.00010811}, {489,0.00027027}, {490,0.00020721}, {491,0.00007207}, {492,0.00018018}, {493,0.00027928}, {494,0.00031532}, {495,0.00017117}, {496,0.00019820}, {497,0.00015315}, {498,0.00018919}, {499,0.00018919}, {500,0.00032432}, {505,0.00031532}, {510,0.00022523}, {515,0.00018018}, {520,0.00018018}, {525,0.00015315}, {530,0.00020721}, {535,0.00018919}, {540,0.00021622}, {545,0.00017117}, {550,0.00026126}, {555,0.00019820}, {560,0.00021622}, {565,0.00026126}, {570,0.00019820}, {575,0.00019820}, {580,0.00006306}, {585,0.00022523}, {590,0.00022523}, {595,0.00014414}, {600,0.00011712}, {605,0.00042342}, {610,0.00017117}, {615,0.00015315}, {620,0.00018018}, {625,0.00025225}, {630,0.00021622}, {635,0.00027027}, {640,0.00033333}, {645,0.00034234}, {650,0.00030631}, {655,0.00018919}, {660,0.00027027}, {665,0.00027027}, {670,0.00025225}, {675,0.00034234}, {680,0.00022523}, {685,0.00030631}, {690,0.00039640}, {695,0.00034234}, {700,0.00030631}, {705,0.00018018}, {710,0.00034234}, {715,0.00020721}, {720,0.00049550}, {725,0.00027928}, {730,0.00044144}, {735,0.00041441}, {740,0.00047748}, {745,0.00036036}, {750,0.00029730}, {755,0.00027928}, {760,0.00054955}, {765,0.00032432}, {770,0.00026126}, {775,0.00040541}, {780,0.00026126}, {785,0.00042342}, {790,0.00027027}, {795,0.00022523}, {800,0.00040541}, {805,0.00018919}, {810,0.00045946}, {815,0.00028829}, {820,0.00040541}, {825,0.00027027}, {830,0.00024324}, {835,0.00025225}, {840,0.00027928}, {845,0.00045045}, {850,0.00023423}, {855,0.00039640}, {860,0.00053153}, {865,0.00042342}, {870,0.00028829}, {875,0.00037838}, {880,0.00032432}, {885,0.00031532}, {890,0.00040541}, {895,0.00038739}, {900,0.00031532}, {905,0.00033333}, {910,0.00022523}, {915,0.00050450}, {920,0.00036937}, {925,0.00047748}, {930,0.00042342}, {935,0.00047748}, {940,0.00048649}, {945,0.00038739}, {950,0.00032432}, {955,0.00053153}, {960,0.00034234}, {965,0.00039640}, {970,0.00043243}, {975,0.00044144}, {980,0.00044144}, {985,0.00035135}, {990,0.00027928}, {995,0.00045045}, {1000,0.00066667}, {1010,0.00046847}, {1020,0.00038739}, {1030,0.00063964}, {1040,0.00062162}, {1050,0.00043243}, {1060,0.00070270}, {1070,0.00040541}, {1080,0.00068468}, {1090,0.00026126}, {1100,0.00065766}, {1110,0.00031532}, {1120,0.00048649}, {1130,0.00049550}, {1140,0.00037838}, {1150,0.00029730}, {1160,0.00045946}, {1170,0.00037838}, {1180,0.00066667}, {1190,0.00049550}, {1200,0.00070270}, {1210,0.00065766}, {1220,0.00066667}, {1230,0.00046847}, {1240,0.00074775}, {1250,0.00071171}, {1260,0.00067568}, {1270,0.00073874}, {1280,0.00049550}, {1290,0.00076577}, {1300,0.00067568}, {1310,0.00059459}, {1320,0.00068468}, {1330,0.00063063}, {1340,0.00062162}, {1350,0.00072072}, {1360,0.00070270}, {1370,0.00073874}, {1380,0.00056757}, {1390,0.00063063}, {1400,0.00067568}, {1410,0.00079279}, {1420,0.00063964}, {1430,0.00053153}, {1440,0.00542342}, {1450,0.00062162}, {1460,0.00085586}, {1470,0.00074775}, {1480,0.00076577}, {1490,0.00054955}, {1500,0.00067568}, {1510,0.00068468}, {1520,0.00082883}, {1530,0.00046847}, {1540,0.00079279}, {1550,0.00092793}, {1560,0.00101802}, {1570,0.00069369}, {1580,0.00048649}, {1590,0.00074775}, {1600,0.00088288}, {1610,0.00090991}, {1620,0.00083784}, {1630,0.00089189}, {1640,0.00115315}, {1650,0.00103604}, {1660,0.00087387}, {1670,0.00101802}, {1680,0.00137838}, {1690,0.00078378}, {1700,0.00098198}, {1710,0.00106306}, {1720,0.00103604}, {1730,0.00096396}, {1740,0.00084685}, {1750,0.00089189}, {1760,0.00098198}, {1770,0.00117117}, {1780,0.00116216}, {1790,0.00102703}, {1800,0.00100901}, {1810,0.00122523}, {1820,0.00081982}, {1830,0.00093694}, {1840,0.00085586}, {1850,0.00098198}, {1860,0.00090090}, {1870,0.00126126}, {1880,0.00123423}, {1890,0.00099099}, {1900,0.00083784}, {1910,0.00116216}, {1920,0.00104505}, {1930,0.00117117}, {1940,0.00107207}, {1950,0.00088288}, {1960,0.00076577}, {1970,0.00121622}, {1980,0.00105405}, {1990,0.00100000}, {2000,0.00109009}, {2050,0.00141441}, {2100,0.00119820}, {2150,0.00086486}, {2200,0.00102703}, {2250,0.00126126}, {2300,0.00137838}, {2350,0.00128829}, {2400,0.00134234}, {2450,0.00135135}, {2500,0.00118919}, {2550,0.00200000}, {2600,0.00136937}, {2650,0.00167568}, {2700,0.00174775}, {2750,0.00175676}, {2800,0.00147748}, {2850,0.00175676}, {2900,0.00182883}, {2950,0.00211712}, {3000,0.00150450}, {3050,0.00155856}, {3100,0.00169369}, {3150,0.00218018}, {3200,0.00190991}, {3250,0.00220721}, {3300,0.00214414}, {3350,0.00197297}, {3400,0.00237838}, {3450,0.00218018}, {3500,0.00242342}, {3550,0.00215315}, {3600,0.00239640}, {3650,0.00281081}, {3700,0.00264865}, {3750,0.00262162}, {3800,0.00251351}, {3850,0.00272072}, {3900,0.00256757}, {3950,0.00261261}, {4000,0.00263063}, {4050,0.00295495}, {4100,0.00270270}, {4150,0.00285586}, {4200,0.00214414}, {4250,0.00307207}, {4300,0.00266667}, {4350,0.00297297}, {4400,0.00304505}, {4450,0.00201802}, {4500,0.00278378}, {4550,0.00316216}, {4600,0.00330631}, {4650,0.00320721}, {4700,0.00317117}, {4750,0.00344144}, {4800,0.00336036}, {4850,0.00201802}, {4900,0.00338739}, {4950,0.00323423}, {5000,0.00236036}, {5050,0.00335135}, {5100,0.00349550}, {5150,0.00348649}, {5200,0.00332432}, {5250,0.00359459}, {5300,0.00372072}, {5350,0.01428829}, {5400,0.00384685}, {5450,0.00372973}, {5500,0.00372072}, {5550,0.00374775}, {5600,0.00396396}, {5650,0.00392793}, {5700,0.00378378}, {5750,0.00241441}, {5800,0.00416216}, {5850,0.00392793}, {5900,0.00426126}, {5950,0.00405405}, {6000,0.00257658}, {6050,0.00431532}, {6100,0.00422523}, {6150,0.00432432}, {6200,0.00419820}, {6250,0.00438739}, {6300,0.00265766}, {6350,0.00439640}, {6400,0.00454955}, {6450,0.00447748}, {6500,0.00414414}, {6550,0.00465766}, {6600,0.00451351}, {6650,0.00463063}, {6700,0.00290991}, {6750,0.00464865}, {6800,0.00496396}, {6850,0.00487387}, {6900,0.00478378}, {6950,0.00498198}, {7000,0.00501802}, {7050,0.00477477}, {7100,0.00471171}, {7150,0.00510811}, {7200,0.00445946}, {7250,0.00501802}, {7300,0.00499099}, {7350,0.00457658}, {7400,0.00515315}, {7450,0.00489189}, {7500,0.00520721}, {7550,0.00513514}, {7600,0.00525225}, {7650,0.00545045}, {7700,0.00534234}, {7750,0.00527027}, {7800,0.00557658}, {7850,0.00562162}, {7900,0.00537838}, {7950,0.00554955}, {8000,0.00546847}, {8050,0.02937838}, {8100,0.00329730}, {8150,0.00600901}, {8200,0.00595495}, {8250,0.00563063}, {8300,0.00586486}, {8350,0.00602703}, {8400,0.00592793}, {8450,0.00600000}, {8500,0.00347748}, {8550,0.00574775}, {8600,0.00600000}, {8650,0.00610811}, {8700,0.00670270}, {8750,0.00618919}, {8800,0.00348649}, {8850,0.00623423}, {8900,0.00600901}, {8950,0.00637838}, {9000,0.00643243}, {9050,0.00363063}, {9100,0.00607207}, {9150,0.00631532}, {9200,0.00654054}, {9250,0.00405405}, {9300,0.00705405}, {9350,0.00694595}, {9400,0.00667568}, {9450,0.00371171}, {9500,0.00667568}, {9550,0.00654955}, {9600,0.00738739}, {9650,0.00696396}, {9700,0.00694595}, {9750,0.00676577}, {9800,0.00425225}, {9850,0.00716216}, {9900,0.00712613}, {9950,0.00399099}, {10000,0.00718919}, {10100,0.00723423}, {10200,0.00728829}, {10300,0.00752252}, {10400,0.02895495}, {10500,0.00746847}, {10600,0.00786486}, {10700,0.00760360}, {10800,0.00791892}, {10900,0.00627027}, {11000,0.00826126}, {11100,0.00472072}, {11200,0.00833333}, {11300,0.00496396}, {11400,0.00828829}, {11500,0.00848649}, {11600,0.00836036}, {11700,0.00868468}, {11800,0.04863063}, {11900,0.00896396}, {12000,0.00640541}, {12100,0.00868468}, {12200,0.00929730}, {12300,0.00525225}, {12400,0.00903604}, {12500,0.00918018}, {12600,0.00547748}, {12700,0.00936036}, {12800,0.00972072}, {12900,0.00935135}, {13000,0.00616216}, {13100,0.00949550}, {13200,0.00989189}, {13300,0.00958559}, {13400,0.00610811}, {13500,0.04952252}, {13600,0.01017117}, {13700,0.01011712}, {13800,0.01080180}, {13900,0.01018018}, {14000,0.00648649}, {14100,0.00653153}, {14200,0.03732432}, {14300,0.01072072}, {14400,0.01094595}, {14500,0.01090991}, {14600,0.01085586}, {14700,0.01130631}, {14800,0.01094595}, {14900,0.01126126}, {15000,0.01089189}, {15100,0.01134234}, {15200,0.01131532}, {15300,0.01123423}, {15400,0.01200000}, {15500,0.03728829}, {15600,0.00733333}, {15700,0.00738739}, {15800,0.01172072}, {15900,0.01172072}, {16000,0.01207207}, {16100,0.01200000}, {16200,0.05517117}, {16300,0.00764865}, {16400,0.01230631}, {16500,0.01241441}, {16600,0.01235135}, {16700,0.03747748}, {16800,0.00821622}, {16900,0.01247748}, {17000,0.01273874}, {17100,0.00815315}, {17200,0.01272973}, {17300,0.01271171}, {17400,0.00806306}, {17500,0.01290991}, {17600,0.01315315}, {17700,0.00829730}, {17800,0.01318018}, {17900,3.50217117}, {18000,0.01344144}, {18100,0.01358559}, {18200,0.00832432}, {18300,0.01381982}, {18400,0.00863964}, {18500,0.01362162}, {18600,0.00854955}, {18700,0.01404505}, {18800,0.00859459}, {18900,0.01400000}, {19000,0.00877477}, {19100,0.01446847}, {19200,0.01430631}, {19300,0.05191892}, {19400,0.01439640}, {19500,0.00909009}, {19600,0.01467568}, {19700,0.01426126}, {19800,0.00894595}, {19900,0.01479279}, {20000,0.01500917}};
data["big_flat"]["OCaml"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00027027}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00003604}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00003604}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00003604}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00003604}, {157,0.00000000}, {158,0.00000000}, {159,0.00002703}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00002703}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00003604}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00003604}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00003604}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00003604}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00003604}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00003604}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00003604}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00003604}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00002703}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00003604}, {402,0.00000000}, {403,0.00003604}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00003604}, {411,0.00003604}, {412,0.00000000}, {413,0.00000000}, {414,0.00003604}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00003604}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00003604}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00002703}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00003604}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00002703}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00003604}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00002703}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00007207}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00002703}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00002703}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00007207}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00006306}, {995,0.00003604}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00003604}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00003604}, {1170,0.00003604}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00003604}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00003604}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00003604}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00003604}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00003604}, {1430,0.00000000}, {1440,0.00013514}, {1450,0.00000000}, {1460,0.00002703}, {1470,0.00003604}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00003604}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00002703}, {1570,0.00002703}, {1580,0.00003604}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00003604}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00002703}, {1680,0.00000000}, {1690,0.00006306}, {1700,0.00000000}, {1710,0.00003604}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00003604}, {1780,0.00000000}, {1790,0.00007207}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00003604}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00003604}, {1900,0.00003604}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00002703}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00002703}, {2400,0.00000000}, {2450,0.00003604}, {2500,0.00003604}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00003604}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00003604}, {3100,0.00000000}, {3150,0.00003604}, {3200,0.00006306}, {3250,0.00003604}, {3300,0.00003604}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00003604}, {3500,0.00000000}, {3550,0.00003604}, {3600,0.00003604}, {3650,0.00003604}, {3700,0.00003604}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00003604}, {3950,0.00000000}, {4000,0.00003604}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00003604}, {4200,0.00000000}, {4250,0.00003604}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00014414}, {4500,0.00003604}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00013514}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00007207}, {5800,0.00000000}, {5850,0.00003604}, {5900,0.00000000}, {5950,0.00003604}, {6000,0.00002703}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00007207}, {6300,0.00010811}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00003604}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00003604}, {6700,0.00006306}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00003604}, {6950,0.00000000}, {7000,0.00007207}, {7050,0.00000000}, {7100,0.00003604}, {7150,0.00003604}, {7200,0.00006306}, {7250,0.00003604}, {7300,0.00000000}, {7350,0.00003604}, {7400,0.00000000}, {7450,0.00006306}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00002703}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00002703}, {7800,0.00006306}, {7850,0.00003604}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00003604}, {8050,0.00055856}, {8100,0.00000000}, {8150,0.00002703}, {8200,0.00000000}, {8250,0.00007207}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00007207}, {8450,0.00003604}, {8500,0.00000000}, {8550,0.00003604}, {8600,0.00003604}, {8650,0.00000000}, {8700,0.00003604}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00007207}, {8900,0.00010811}, {8950,0.00007207}, {9000,0.00000000}, {9050,0.00003604}, {9100,0.00003604}, {9150,0.00003604}, {9200,0.00003604}, {9250,0.00007207}, {9300,0.00007207}, {9350,0.00000000}, {9400,0.00003604}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00003604}, {9750,0.00000000}, {9800,0.00007207}, {9850,0.00007207}, {9900,0.00000000}, {9950,0.00003604}, {10000,0.00000000}, {10100,0.00003604}, {10200,0.00000000}, {10300,0.00003604}, {10400,0.00089189}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00010811}, {11200,0.00000000}, {11300,0.00002703}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00005405}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00007207}, {12000,0.00003604}, {12100,0.00003604}, {12200,0.00002703}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00007207}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00003604}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00003604}, {13400,0.00003604}, {13500,0.00043243}, {13600,0.00003604}, {13700,0.00003604}, {13800,0.00003604}, {13900,0.00006306}, {14000,0.00000000}, {14100,0.00003604}, {14200,0.00042342}, {14300,0.00003604}, {14400,0.00000000}, {14500,0.00003604}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00003604}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00003604}, {15400,0.00007207}, {15500,0.00024324}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00002703}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00003604}, {16300,0.00003604}, {16400,0.00000000}, {16500,0.00003604}, {16600,0.00000000}, {16700,0.00003604}, {16800,0.00000000}, {16900,0.00007207}, {17000,0.00003604}, {17100,0.00003604}, {17200,0.00000000}, {17300,0.00003604}, {17400,0.00003604}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00246847}, {18000,0.00003604}, {18100,0.00000000}, {18200,0.00003604}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00003604}, {18600,0.00000000}, {18700,0.00003604}, {18800,0.00000000}, {18900,0.00003604}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00003604}, {19300,0.00003604}, {19400,0.00000000}, {19500,0.00003604}, {19600,0.00003604}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00003604}, {20000,0.00000000}};
data["big_flat"]["OCaml"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00001802}, {96,0.00000000}, {97,0.00000000}, {98,0.00100000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00098198}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00001802}, {172,0.00000000}, {173,0.00114414}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000901}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00114414}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00001802}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00002703}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00001802}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000901}, {560,0.00000000}, {565,0.00000901}, {570,0.00004505}, {575,0.00003604}, {580,0.00005405}, {585,0.00012613}, {590,0.00013514}, {595,0.00018018}, {600,0.00030631}, {605,0.00039640}, {610,0.00054955}, {615,0.00063063}, {620,0.00069369}, {625,0.00072072}, {630,0.00075676}, {635,0.00081982}, {640,0.00090090}, {645,0.00096396}, {650,0.00092793}, {655,0.00097297}, {660,0.00098198}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00100000}, {830,0.00100000}, {835,0.00100000}, {840,0.00100000}, {845,0.00100000}, {850,0.00100000}, {855,0.00100000}, {860,0.00100000}, {865,0.00100000}, {870,0.00105405}, {875,0.00100000}, {880,0.00100000}, {885,0.00100000}, {890,0.00100000}, {895,0.00100000}, {900,0.00100000}, {905,0.00100000}, {910,0.00100000}, {915,0.00100000}, {920,0.00100000}, {925,0.00100000}, {930,0.00100000}, {935,0.00100000}, {940,0.00100000}, {945,0.00100000}, {950,0.00100000}, {955,0.00100000}, {960,0.00100901}, {965,0.00100000}, {970,0.00100000}, {975,0.00100000}, {980,0.00100000}, {985,0.00577477}, {990,0.00100000}, {995,0.00100000}, {1000,0.00100000}, {1010,0.00100000}, {1020,0.00100000}, {1030,0.00100000}, {1040,0.00361261}, {1050,0.00100000}, {1060,0.00100000}, {1070,0.00100000}, {1080,0.00100000}, {1090,0.00100000}, {1100,0.00100000}, {1110,0.00100000}, {1120,0.00100000}, {1130,0.00100000}, {1140,0.00100000}, {1150,0.00100000}, {1160,0.00100000}, {1170,0.00100000}, {1180,0.00100000}, {1190,0.00100000}, {1200,0.00100000}, {1210,0.00100000}, {1220,0.00101802}, {1230,0.00100901}, {1240,0.00103604}, {1250,0.00101802}, {1260,0.00102703}, {1270,0.00102703}, {1280,0.00115315}, {1290,0.00109009}, {1300,0.00114414}, {1310,0.00116216}, {1320,0.00122523}, {1330,0.00118919}, {1340,0.00119820}, {1350,0.00127928}, {1360,0.00142342}, {1370,0.00145045}, {1380,0.00154955}, {1390,0.00674775}, {1400,0.00164865}, {1410,0.00172973}, {1420,0.00179279}, {1430,0.00186486}, {1440,0.00185586}, {1450,0.00190090}, {1460,0.00192793}, {1470,0.00193694}, {1480,0.00194595}, {1490,0.00173874}, {1500,0.00200000}, {1510,0.00200000}, {1520,0.00200000}, {1530,0.00200000}, {1540,0.00200000}, {1550,0.00200000}, {1560,0.00200000}, {1570,0.00200000}, {1580,0.00205405}, {1590,0.00200000}, {1600,0.00200000}, {1610,0.00200000}, {1620,0.00200000}, {1630,0.00200000}, {1640,0.00200000}, {1650,0.00200901}, {1660,0.00200000}, {1670,0.00200000}, {1680,0.00200000}, {1690,0.00200000}, {1700,0.00200000}, {1710,0.00200000}, {1720,0.00200000}, {1730,0.00200000}, {1740,0.00200000}, {1750,0.00200901}, {1760,0.00200000}, {1770,0.00200000}, {1780,0.00200000}, {1790,0.00200901}, {1800,0.00200000}, {1810,0.00200901}, {1820,0.00200000}, {1830,0.00200901}, {1840,0.00201802}, {1850,0.00200000}, {1860,0.00204505}, {1870,0.00202703}, {1880,0.00202703}, {1890,0.00205405}, {1900,0.00204505}, {1910,0.00211712}, {1920,0.00207207}, {1930,0.00209910}, {1940,0.00213514}, {1950,0.00667568}, {1960,0.00211712}, {1970,0.00213514}, {1980,0.00225225}, {1990,0.00218018}, {2000,0.00236937}, {2050,0.00256757}, {2100,0.00279279}, {2150,0.00290991}, {2200,0.00300000}, {2250,0.00302703}, {2300,0.00300000}, {2350,0.00301802}, {2400,0.00304505}, {2450,0.00307207}, {2500,0.00309009}, {2550,0.00318919}, {2600,0.00321622}, {2650,0.00336036}, {2700,0.00367568}, {2750,0.00380180}, {2800,0.00389189}, {2850,0.00399099}, {2900,0.00402703}, {2950,0.00409009}, {3000,0.00412613}, {3050,0.00417117}, {3100,0.00421622}, {3150,0.00427027}, {3200,0.00448649}, {3250,0.00452252}, {3300,0.00471171}, {3350,0.00478378}, {3400,0.00488288}, {3450,0.00501802}, {3500,0.00509910}, {3550,0.00515315}, {3600,0.00541441}, {3650,0.00543243}, {3700,0.00546847}, {3750,0.00553153}, {3800,0.00560360}, {3850,0.00573874}, {3900,0.00590090}, {3950,0.00604505}, {4000,0.00600000}, {4050,0.00635135}, {4100,0.00649550}, {4150,0.00641441}, {4200,0.00585586}, {4250,0.00661261}, {4300,0.00679279}, {4350,0.00696396}, {4400,0.00698198}, {4450,0.01997297}, {4500,0.00734234}, {4550,0.00734234}, {4600,0.00741441}, {4650,0.00766667}, {4700,0.00774775}, {4750,0.00791892}, {4800,0.00795495}, {4850,0.00652252}, {4900,0.00818018}, {4950,0.00828829}, {5000,0.00716216}, {5050,0.00848649}, {5100,0.00867568}, {5150,0.00894595}, {5200,0.00893694}, {5250,0.00893694}, {5300,0.00910811}, {5350,0.00922523}, {5400,0.00921622}, {5450,0.00939640}, {5500,0.00962162}, {5550,0.00997297}, {5600,0.00981982}, {5650,0.00989189}, {5700,0.01012613}, {5750,0.03300901}, {5800,0.01027027}, {5850,0.01029730}, {5900,0.01043243}, {5950,0.01056757}, {6000,0.03961261}, {6050,0.01070270}, {6100,0.01086486}, {6150,0.01108108}, {6200,0.01114414}, {6250,0.01120721}, {6300,0.03898198}, {6350,0.01139640}, {6400,0.01151351}, {6450,0.01154054}, {6500,0.01168468}, {6550,0.01178378}, {6600,0.01196396}, {6650,0.01201802}, {6700,0.02925225}, {6750,0.01269369}, {6800,0.01232432}, {6850,0.01236937}, {6900,0.01259459}, {6950,0.01264865}, {7000,0.01270270}, {7050,0.01284685}, {7100,0.01304505}, {7150,0.01309009}, {7200,0.01315315}, {7250,0.01338739}, {7300,0.01343243}, {7350,0.01352252}, {7400,0.01364865}, {7450,0.01367568}, {7500,0.01379279}, {7550,0.01392793}, {7600,0.01394595}, {7650,0.01416216}, {7700,0.01434234}, {7750,0.01439640}, {7800,0.01445946}, {7850,0.01450450}, {7900,0.01454054}, {7950,0.01473874}, {8000,0.01476577}, {8050,0.01536036}, {8100,0.03138739}, {8150,0.01515315}, {8200,0.01525225}, {8250,0.01531532}, {8300,0.01533333}, {8350,0.01551351}, {8400,0.01555856}, {8450,0.01570270}, {8500,0.03796396}, {8550,0.01584685}, {8600,0.01605405}, {8650,0.01595495}, {8700,0.01615315}, {8750,0.01626126}, {8800,0.03737838}, {8850,0.01645946}, {8900,0.01648649}, {8950,0.01660360}, {9000,0.01673874}, {9050,0.03180180}, {9100,0.01694595}, {9150,0.01698198}, {9200,0.01712613}, {9250,0.05106306}, {9300,0.01731532}, {9350,0.01732432}, {9400,0.01736937}, {9450,0.03840541}, {9500,0.01761261}, {9550,0.01770270}, {9600,0.01784685}, {9650,0.01788288}, {9700,0.01800000}, {9750,0.01817117}, {9800,0.01460360}, {9850,0.01827027}, {9900,0.01833333}, {9950,0.01474775}, {10000,0.01855856}, {10100,0.01871171}, {10200,0.01901802}, {10300,0.01921622}, {10400,0.01974775}, {10500,0.01942342}, {10600,0.01970270}, {10700,0.01992793}, {10800,0.02017117}, {10900,0.01824324}, {11000,0.02037838}, {11100,0.03272973}, {11200,0.02083784}, {11300,0.01678378}, {11400,0.02126126}, {11500,0.02127027}, {11600,0.02147748}, {11700,0.02171171}, {11800,0.02256757}, {11900,0.02217117}, {12000,0.01842342}, {12100,0.02238739}, {12200,0.02263063}, {12300,0.03800000}, {12400,0.02310811}, {12500,0.02319820}, {12600,0.04024324}, {12700,0.02352252}, {12800,0.02381081}, {12900,0.02397297}, {13000,0.07255856}, {13100,0.02432432}, {13200,0.02446847}, {13300,0.02464865}, {13400,0.04815315}, {13500,0.02505405}, {13600,0.02530631}, {13700,0.02550450}, {13800,0.02563964}, {13900,0.02581081}, {14000,0.02104505}, {14100,0.05700000}, {14200,0.02699099}, {14300,0.02656757}, {14400,0.02682883}, {14500,0.02699099}, {14600,0.02709009}, {14700,0.02733333}, {14800,0.02748649}, {14900,0.02767568}, {15000,0.02789189}, {15100,0.02805405}, {15200,0.02825225}, {15300,0.02836937}, {15400,0.02861261}, {15500,0.02947748}, {15600,0.06078378}, {15700,0.04859459}, {15800,0.02935135}, {15900,0.02948649}, {16000,0.02968468}, {16100,0.02992793}, {16200,0.03005405}, {16300,0.05021622}, {16400,0.03046847}, {16500,0.03064865}, {16600,0.03083784}, {16700,0.03163063}, {16800,0.02554054}, {16900,0.03137838}, {17000,0.03162162}, {17100,0.06010811}, {17200,0.03197297}, {17300,0.03216216}, {17400,0.07107207}, {17500,0.03261261}, {17600,0.03277477}, {17700,0.04990991}, {17800,0.03313514}, {17900,0.03336036}, {18000,0.03349550}, {18100,0.03367568}, {18200,0.04472973}, {18300,0.03405405}, {18400,0.05466667}, {18500,0.03438739}, {18600,0.06169369}, {18700,0.03488288}, {18800,0.05500000}, {18900,0.03519820}, {19000,0.04714414}, {19100,0.03559459}, {19200,0.03575676}, {19300,0.03670270}, {19400,0.03610811}, {19500,0.05480180}, {19600,0.03643243}, {19700,0.03669369}, {19800,0.06951351}, {19900,0.03702703}, {20000,0.03724771}};
data["big_flat"]["OCaml"]["norm reif"]["user"] = {{1,0.00005405}, {2,0.00008108}, {3,0.00010811}, {4,0.00018018}, {5,0.00028829}, {6,0.00018919}, {7,0.00016216}, {8,0.00012613}, {9,0.00023423}, {10,0.00019820}, {11,0.00010811}, {12,0.00012613}, {13,0.00018919}, {14,0.00020721}, {15,0.00012613}, {16,0.00020721}, {17,0.00024324}, {18,0.00019820}, {19,0.00022523}, {20,0.00023423}, {21,0.00012613}, {22,0.00015315}, {23,0.00018018}, {24,0.00034234}, {25,0.00028829}, {26,0.00021622}, {27,0.00026126}, {28,0.00022523}, {29,0.00018919}, {30,0.00023423}, {31,0.00018018}, {32,0.00040541}, {33,0.00026126}, {34,0.00028829}, {35,0.00024324}, {36,0.00010811}, {37,0.00045045}, {38,0.00027027}, {39,0.00021622}, {40,0.00011712}, {41,0.00019820}, {42,0.00025225}, {43,0.00017117}, {44,0.00032432}, {45,0.00027027}, {46,0.00017117}, {47,0.00024324}, {48,0.00030631}, {49,0.00018919}, {50,0.00016216}, {51,0.00017117}, {52,0.00013514}, {53,0.00032432}, {54,0.00030631}, {55,0.00026126}, {56,0.00029730}, {57,0.00032432}, {58,0.00024324}, {59,0.00025225}, {60,0.00018919}, {61,0.00025225}, {62,0.00035135}, {63,0.00016216}, {64,0.00024324}, {65,0.00018018}, {66,0.00025225}, {67,0.00019820}, {68,0.00022523}, {69,0.00026126}, {70,0.00028829}, {71,0.00011712}, {72,0.00027928}, {73,0.00033333}, {74,0.00020721}, {75,0.00030631}, {76,0.00027027}, {77,0.00024324}, {78,0.00015315}, {79,0.00013514}, {80,0.00030631}, {81,0.00025225}, {82,0.00026126}, {83,0.00044144}, {84,0.00038739}, {85,0.00022523}, {86,0.00029730}, {87,0.00018919}, {88,0.00036937}, {89,0.00035135}, {90,0.00026126}, {91,0.00028829}, {92,0.00028829}, {93,0.00047748}, {94,0.00024324}, {95,0.00029730}, {96,0.00022523}, {97,0.00030631}, {98,0.00151351}, {99,0.00023423}, {100,0.00022523}, {101,0.00044144}, {102,0.00036036}, {103,0.00034234}, {104,0.00035135}, {105,0.00015315}, {106,0.00038739}, {107,0.00031532}, {108,0.00028829}, {109,0.00026126}, {110,0.00033333}, {111,0.00039640}, {112,0.00026126}, {113,0.00031532}, {114,0.00035135}, {115,0.00038739}, {116,0.00025225}, {117,0.00054054}, {118,0.00021622}, {119,0.00028829}, {120,0.00038739}, {121,0.00026126}, {122,0.00046847}, {123,0.00036036}, {124,0.00031532}, {125,0.00029730}, {126,0.00034234}, {127,0.00033333}, {128,0.00027027}, {129,0.00045045}, {130,0.00039640}, {131,0.00034234}, {132,0.00045045}, {133,0.00024324}, {134,0.00027027}, {135,0.00022523}, {136,0.00044144}, {137,0.00055856}, {138,0.00051351}, {139,0.00121622}, {140,0.00038739}, {141,0.00030631}, {142,0.00027027}, {143,0.00035135}, {144,0.00029730}, {145,0.00034234}, {146,0.00048649}, {147,0.00028829}, {148,0.00032432}, {149,0.00043243}, {150,0.00028829}, {151,0.00042342}, {152,0.00027928}, {153,0.00054955}, {154,0.00025225}, {155,0.00046847}, {156,0.00023423}, {157,0.00036937}, {158,0.00050450}, {159,0.00045946}, {160,0.00045045}, {161,0.00036937}, {162,0.00045946}, {163,0.00057658}, {164,0.00043243}, {165,0.00035135}, {166,0.00057658}, {167,0.00034234}, {168,0.00041441}, {169,0.00041441}, {170,0.00040541}, {171,0.00064865}, {172,0.00040541}, {173,0.00166667}, {174,0.00045045}, {175,0.00019820}, {176,0.00051351}, {177,0.00037838}, {178,0.00035135}, {179,0.00048649}, {180,0.00018919}, {181,0.00048649}, {182,0.00036937}, {183,0.00028829}, {184,0.00035135}, {185,0.00045946}, {186,0.00045946}, {187,0.00039640}, {188,0.00054955}, {189,0.00030631}, {190,0.00045045}, {191,0.00026126}, {192,0.00050450}, {193,0.00044144}, {194,0.00050450}, {195,0.00043243}, {196,0.00032432}, {197,0.00028829}, {198,0.00045045}, {199,0.00045045}, {200,0.00066667}, {201,0.00069369}, {202,0.00041441}, {203,0.00068468}, {204,0.00048649}, {205,0.00045045}, {206,0.00029730}, {207,0.00040541}, {208,0.00042342}, {209,0.00041441}, {210,0.00042342}, {211,0.00040541}, {212,0.00028829}, {213,0.00034234}, {214,0.00038739}, {215,0.00036937}, {216,0.00031532}, {217,0.00042342}, {218,0.00054054}, {219,0.00054054}, {220,0.00047748}, {221,0.00068468}, {222,0.00054054}, {223,0.00063063}, {224,0.00068468}, {225,0.00048649}, {226,0.00056757}, {227,0.00037838}, {228,0.00051351}, {229,0.00049550}, {230,0.00051351}, {231,0.00050450}, {232,0.00048649}, {233,0.00056757}, {234,0.00052252}, {235,0.00053153}, {236,0.00048649}, {237,0.00038739}, {238,0.00033333}, {239,0.00036937}, {240,0.00048649}, {241,0.00048649}, {242,0.00047748}, {243,0.00046847}, {244,0.00028829}, {245,0.00037838}, {246,0.00050450}, {247,0.00046847}, {248,0.00063063}, {249,0.00042342}, {250,0.00047748}, {251,0.00048649}, {252,0.00054054}, {253,0.00064865}, {254,0.00049550}, {255,0.00046847}, {256,0.00049550}, {257,0.00036036}, {258,0.00054955}, {259,0.00063063}, {260,0.00031532}, {261,0.00039640}, {262,0.00048649}, {263,0.00070270}, {264,0.00063063}, {265,0.00038739}, {266,0.00054955}, {267,0.00045045}, {268,0.00045045}, {269,0.00049550}, {270,0.00042342}, {271,0.00050450}, {272,0.00056757}, {273,0.00039640}, {274,0.00046847}, {275,0.00039640}, {276,0.00055856}, {277,0.00057658}, {278,0.00068468}, {279,0.00063063}, {280,0.00045045}, {281,0.00032432}, {282,0.00026126}, {283,0.00051351}, {284,0.00058559}, {285,0.00085586}, {286,0.00075676}, {287,0.00033333}, {288,0.00025225}, {289,0.00065766}, {290,0.00056757}, {291,0.00059459}, {292,0.00053153}, {293,0.00044144}, {294,0.00053153}, {295,0.00051351}, {296,0.00072973}, {297,0.00070270}, {298,0.00053153}, {299,0.00048649}, {300,0.00051351}, {301,0.00065766}, {302,0.00045045}, {303,0.00068468}, {304,0.00053153}, {305,0.00059459}, {306,0.00036937}, {307,0.00052252}, {308,0.00057658}, {309,0.00061261}, {310,0.00049550}, {311,0.00049550}, {312,0.00061261}, {313,0.00049550}, {314,0.00065766}, {315,0.00062162}, {316,0.00064865}, {317,0.00051351}, {318,0.00159459}, {319,0.00064865}, {320,0.00044144}, {321,0.00038739}, {322,0.00052252}, {323,0.00084685}, {324,0.00045946}, {325,0.00058559}, {326,0.00063964}, {327,0.00051351}, {328,0.00075676}, {329,0.00032432}, {330,0.00072072}, {331,0.00054955}, {332,0.00050450}, {333,0.00059459}, {334,0.00035135}, {335,0.00060360}, {336,0.00046847}, {337,0.00065766}, {338,0.00064865}, {339,0.00066667}, {340,0.00057658}, {341,0.00062162}, {342,0.00072973}, {343,0.00070270}, {344,0.00072973}, {345,0.00056757}, {346,0.00052252}, {347,0.00072973}, {348,0.00068468}, {349,0.00047748}, {350,0.00069369}, {351,0.00065766}, {352,0.00034234}, {353,0.00053153}, {354,0.00046847}, {355,0.00059459}, {356,0.00063964}, {357,0.00069369}, {358,0.00064865}, {359,0.00060360}, {360,0.00070270}, {361,0.00063964}, {362,0.00060360}, {363,0.00069369}, {364,0.00059459}, {365,0.00066667}, {366,0.00061261}, {367,0.00076577}, {368,0.00064865}, {369,0.00071171}, {370,0.00052252}, {371,0.00052252}, {372,0.00057658}, {373,0.00057658}, {374,0.00051351}, {375,0.00059459}, {376,0.00071171}, {377,0.00075676}, {378,0.00068468}, {379,0.00072973}, {380,0.00035135}, {381,0.00052252}, {382,0.00079279}, {383,0.00035135}, {384,0.00072072}, {385,0.00052252}, {386,0.00081081}, {387,0.00065766}, {388,0.00062162}, {389,0.00061261}, {390,0.00047748}, {391,0.00056757}, {392,0.00058559}, {393,0.00058559}, {394,0.00090991}, {395,0.00057658}, {396,0.00066667}, {397,0.00057658}, {398,0.00053153}, {399,0.00074775}, {400,0.00061261}, {401,0.00080180}, {402,0.00054054}, {403,0.00067568}, {404,0.00053153}, {405,0.00080180}, {406,0.00053153}, {407,0.00074775}, {408,0.00078378}, {409,0.00045946}, {410,0.00073874}, {411,0.00053153}, {412,0.00065766}, {413,0.00045045}, {414,0.00094595}, {415,0.00067568}, {416,0.00080180}, {417,0.00048649}, {418,0.00063063}, {419,0.00065766}, {420,0.00041441}, {421,0.00087387}, {422,0.00058559}, {423,0.00071171}, {424,0.00099099}, {425,0.00072973}, {426,0.00064865}, {427,0.00065766}, {428,0.00064865}, {429,0.00104505}, {430,0.00083784}, {431,0.00056757}, {432,0.00097297}, {433,0.00078378}, {434,0.00093694}, {435,0.00063964}, {436,0.00054955}, {437,0.00058559}, {438,0.00060360}, {439,0.00066667}, {440,0.00069369}, {441,0.00087387}, {442,0.00060360}, {443,0.00075676}, {444,0.00075676}, {445,0.00071171}, {446,0.00062162}, {447,0.00051351}, {448,0.00074775}, {449,0.00071171}, {450,0.00089189}, {451,0.00063964}, {452,0.00073874}, {453,0.00073874}, {454,0.00075676}, {455,0.00071171}, {456,0.00096396}, {457,0.00075676}, {458,0.00075676}, {459,0.00086486}, {460,0.00061261}, {461,0.00108108}, {462,0.00053153}, {463,0.00070270}, {464,0.00091892}, {465,0.00063063}, {466,0.00041441}, {467,0.00072973}, {468,0.00099099}, {469,0.00083784}, {470,0.00053153}, {471,0.00072973}, {472,0.00090991}, {473,0.00063964}, {474,0.00060360}, {475,0.00088288}, {476,0.00074775}, {477,0.00075676}, {478,0.00063063}, {479,0.00064865}, {480,0.00100901}, {481,0.00052252}, {482,0.00051351}, {483,0.00075676}, {484,0.00090090}, {485,0.00065766}, {486,0.00070270}, {487,0.00078378}, {488,0.00085586}, {489,0.00083784}, {490,0.00063063}, {491,0.00063964}, {492,0.00097297}, {493,0.00085586}, {494,0.00063063}, {495,0.00068468}, {496,0.00084685}, {497,0.00072973}, {498,0.00099099}, {499,0.00089189}, {500,0.00082883}, {505,0.00051351}, {510,0.00061261}, {515,0.00109009}, {520,0.00090090}, {525,0.00061261}, {530,0.00069369}, {535,0.00075676}, {540,0.00062162}, {545,0.00082883}, {550,0.00090991}, {555,0.00090090}, {560,0.00088288}, {565,0.00082883}, {570,0.00081982}, {575,0.00084685}, {580,0.00086486}, {585,0.00102703}, {590,0.00116216}, {595,0.00058559}, {600,0.00069369}, {605,0.00069369}, {610,0.00079279}, {615,0.00103604}, {620,0.00070270}, {625,0.00087387}, {630,0.00066667}, {635,0.00102703}, {640,0.00100000}, {645,0.00100901}, {650,0.00105405}, {655,0.00109009}, {660,0.00068468}, {665,0.00094595}, {670,0.00099099}, {675,0.00096396}, {680,0.00114414}, {685,0.00095495}, {690,0.00094595}, {695,0.00099099}, {700,0.00101802}, {705,0.00081982}, {710,0.00111712}, {715,0.00100000}, {720,0.00114414}, {725,0.00090090}, {730,0.00119820}, {735,0.00078378}, {740,0.00103604}, {745,0.00136036}, {750,0.00073874}, {755,0.00108108}, {760,0.00085586}, {765,0.00086486}, {770,0.00147748}, {775,0.00074775}, {780,0.00118919}, {785,0.00103604}, {790,0.00105405}, {795,0.00126126}, {800,0.00090090}, {805,0.00125225}, {810,0.00114414}, {815,0.00100000}, {820,0.00098198}, {825,0.00096396}, {830,0.00155856}, {835,0.00090991}, {840,0.00117117}, {845,0.00112613}, {850,0.00111712}, {855,0.00119820}, {860,0.00112613}, {865,0.00111712}, {870,0.00115315}, {875,0.00128829}, {880,0.00124324}, {885,0.00136937}, {890,0.00130631}, {895,0.00132432}, {900,0.00142342}, {905,0.00117117}, {910,0.00117117}, {915,0.00113514}, {920,0.00118919}, {925,0.00128829}, {930,0.00128829}, {935,0.00121622}, {940,0.00106306}, {945,0.00142342}, {950,0.00140541}, {955,0.00135135}, {960,0.00154955}, {965,0.00144144}, {970,0.00124324}, {975,0.00136937}, {980,0.00150450}, {985,0.00543243}, {990,0.00132432}, {995,0.00139640}, {1000,0.00092793}, {1010,0.00127928}, {1020,0.00142342}, {1030,0.00114414}, {1040,0.00364865}, {1050,0.00175676}, {1060,0.00100000}, {1070,0.00139640}, {1080,0.00133333}, {1090,0.00151351}, {1100,0.00167568}, {1110,0.00144144}, {1120,0.00153153}, {1130,0.00138739}, {1140,0.00171171}, {1150,0.00158559}, {1160,0.00170270}, {1170,0.00150450}, {1180,0.00160360}, {1190,0.00154054}, {1200,0.00179279}, {1210,0.00180180}, {1220,0.00167568}, {1230,0.00173874}, {1240,0.00165766}, {1250,0.00156757}, {1260,0.00166667}, {1270,0.00155856}, {1280,0.00181081}, {1290,0.00164865}, {1300,0.00222523}, {1310,0.00188288}, {1320,0.00184685}, {1330,0.00178378}, {1340,0.00183784}, {1350,0.00174775}, {1360,0.00184685}, {1370,0.00191892}, {1380,0.00198198}, {1390,0.00630631}, {1400,0.00203604}, {1410,0.00166667}, {1420,0.00181982}, {1430,0.00202703}, {1440,0.00161261}, {1450,0.00191892}, {1460,0.00177477}, {1470,0.00186486}, {1480,0.00188288}, {1490,0.00190090}, {1500,0.00209910}, {1510,0.00202703}, {1520,0.00209910}, {1530,0.00212613}, {1540,0.00164865}, {1550,0.00190090}, {1560,0.00176577}, {1570,0.00214414}, {1580,0.00236937}, {1590,0.00230631}, {1600,0.00213514}, {1610,0.00209910}, {1620,0.00208108}, {1630,0.00216216}, {1640,0.00204505}, {1650,0.00224324}, {1660,0.00220721}, {1670,0.00213514}, {1680,0.00191892}, {1690,0.00216216}, {1700,0.00238739}, {1710,0.00213514}, {1720,0.00215315}, {1730,0.00209009}, {1740,0.00228829}, {1750,0.00235135}, {1760,0.00218919}, {1770,0.00213514}, {1780,0.00219820}, {1790,0.00232432}, {1800,0.00251351}, {1810,0.00218018}, {1820,0.00256757}, {1830,0.00245045}, {1840,0.00252252}, {1850,0.00229730}, {1860,0.00269369}, {1870,0.00217117}, {1880,0.00237838}, {1890,0.00233333}, {1900,0.00272973}, {1910,0.00250450}, {1920,0.00263964}, {1930,0.00241441}, {1940,0.00255856}, {1950,0.00636036}, {1960,0.00279279}, {1970,0.00259459}, {1980,0.00292793}, {1990,0.00260360}, {2000,0.00268468}, {2050,0.00239640}, {2100,0.00284685}, {2150,0.00304505}, {2200,0.00308108}, {2250,0.00299099}, {2300,0.00290090}, {2350,0.00317117}, {2400,0.00331532}, {2450,0.00319820}, {2500,0.00334234}, {2550,0.00343243}, {2600,0.00354955}, {2650,0.00361261}, {2700,0.00355856}, {2750,0.00364865}, {2800,0.00400000}, {2850,0.00390991}, {2900,0.00389189}, {2950,0.00392793}, {3000,0.00418919}, {3050,0.00446847}, {3100,0.00442342}, {3150,0.00421622}, {3200,0.00465766}, {3250,0.00440541}, {3300,0.00445045}, {3350,0.00481982}, {3400,0.00452252}, {3450,0.00511712}, {3500,0.00500000}, {3550,0.00512613}, {3600,0.00525225}, {3650,0.00503604}, {3700,0.00529730}, {3750,0.00511712}, {3800,0.00551351}, {3850,0.00556757}, {3900,0.00592793}, {3950,0.00602703}, {4000,0.00572072}, {4050,0.00590090}, {4100,0.00644144}, {4150,0.00641441}, {4200,0.00585586}, {4250,0.00638739}, {4300,0.00660360}, {4350,0.00676577}, {4400,0.00684685}, {4450,0.01938739}, {4500,0.00727027}, {4550,0.00722523}, {4600,0.00705405}, {4650,0.00771171}, {4700,0.00759459}, {4750,0.00790991}, {4800,0.00759459}, {4850,0.00645946}, {4900,0.00814414}, {4950,0.00817117}, {5000,0.00701802}, {5050,0.00854955}, {5100,0.00839640}, {5150,0.00877477}, {5200,0.00896396}, {5250,0.00879279}, {5300,0.00887387}, {5350,0.00895495}, {5400,0.00901802}, {5450,0.00983784}, {5500,0.00996396}, {5550,0.01023423}, {5600,0.00997297}, {5650,0.00972072}, {5700,0.01033333}, {5750,0.03299099}, {5800,0.01021622}, {5850,0.01054054}, {5900,0.01038739}, {5950,0.01093694}, {6000,0.03894595}, {6050,0.01090991}, {6100,0.01118919}, {6150,0.01146847}, {6200,0.01123423}, {6250,0.01146847}, {6300,0.03808108}, {6350,0.01164865}, {6400,0.01170270}, {6450,0.01198198}, {6500,0.01213514}, {6550,0.01216216}, {6600,0.01223423}, {6650,0.01205405}, {6700,0.02872973}, {6750,0.01299099}, {6800,0.01235135}, {6850,0.01277477}, {6900,0.01285586}, {6950,0.01268468}, {7000,0.01305405}, {7050,0.01320721}, {7100,0.01333333}, {7150,0.01313514}, {7200,0.01350450}, {7250,0.01338739}, {7300,0.01366667}, {7350,0.01394595}, {7400,0.01386486}, {7450,0.01394595}, {7500,0.01387387}, {7550,0.01393694}, {7600,0.01376577}, {7650,0.01395495}, {7700,0.01440541}, {7750,0.01452252}, {7800,0.01442342}, {7850,0.01455856}, {7900,0.01486486}, {7950,0.01474775}, {8000,0.01471171}, {8050,0.01525225}, {8100,0.03115315}, {8150,0.01484685}, {8200,0.01509009}, {8250,0.01515315}, {8300,0.01520721}, {8350,0.01505405}, {8400,0.01545045}, {8450,0.01566667}, {8500,0.03731532}, {8550,0.01593694}, {8600,0.01583784}, {8650,0.01579279}, {8700,0.01545045}, {8750,0.01627027}, {8800,0.03723423}, {8850,0.01602703}, {8900,0.01627027}, {8950,0.01631532}, {9000,0.01633333}, {9050,0.03163063}, {9100,0.01723423}, {9150,0.01695495}, {9200,0.01700901}, {9250,0.05033333}, {9300,0.01694595}, {9350,0.01706306}, {9400,0.01734234}, {9450,0.03775676}, {9500,0.01760360}, {9550,0.01738739}, {9600,0.01762162}, {9650,0.01784685}, {9700,0.01797297}, {9750,0.01828829}, {9800,0.01436036}, {9850,0.01810811}, {9900,0.01818919}, {9950,0.01478378}, {10000,0.01861261}, {10100,0.01872072}, {10200,0.01882883}, {10300,0.01921622}, {10400,0.02000000}, {10500,0.01948649}, {10600,0.01990991}, {10700,0.02002703}, {10800,0.02009009}, {10900,0.01813514}, {11000,0.02062162}, {11100,0.03248649}, {11200,0.02081982}, {11300,0.01663063}, {11400,0.02115315}, {11500,0.02164865}, {11600,0.02169369}, {11700,0.02189189}, {11800,0.02271171}, {11900,0.02218018}, {12000,0.01789189}, {12100,0.02273874}, {12200,0.02299099}, {12300,0.03778378}, {12400,0.02325225}, {12500,0.02328829}, {12600,0.04004505}, {12700,0.02387387}, {12800,0.02374775}, {12900,0.02410811}, {13000,0.07166667}, {13100,0.02445946}, {13200,0.02475676}, {13300,0.02488288}, {13400,0.04746847}, {13500,0.02518919}, {13600,0.02548649}, {13700,0.02566667}, {13800,0.02545045}, {13900,0.02581081}, {14000,0.02119820}, {14100,0.05627928}, {14200,0.02678378}, {14300,0.02643243}, {14400,0.02663964}, {14500,0.02660360}, {14600,0.02690991}, {14700,0.02710811}, {14800,0.02749550}, {14900,0.02736036}, {15000,0.02790991}, {15100,0.02780180}, {15200,0.02812613}, {15300,0.02818919}, {15400,0.02857658}, {15500,0.02928829}, {15600,0.05998198}, {15700,0.04839640}, {15800,0.02888288}, {15900,0.02939640}, {16000,0.02957658}, {16100,0.02981982}, {16200,0.02999099}, {16300,0.04992793}, {16400,0.03051351}, {16500,0.03021622}, {16600,0.03071171}, {16700,0.03134234}, {16800,0.02546847}, {16900,0.03146847}, {17000,0.03148649}, {17100,0.05996396}, {17200,0.03212613}, {17300,0.03234234}, {17400,0.07118018}, {17500,0.03259459}, {17600,0.03272973}, {17700,0.04972973}, {17800,0.03311712}, {17900,0.03322523}, {18000,0.03343243}, {18100,0.03389189}, {18200,0.04469369}, {18300,0.03419820}, {18400,0.05450450}, {18500,0.03469369}, {18600,0.06198198}, {18700,0.03467568}, {18800,0.05499099}, {18900,0.03573874}, {19000,0.04737838}, {19100,0.03555856}, {19200,0.03593694}, {19300,0.03690090}, {19400,0.03628829}, {19500,0.05461261}, {19600,0.03662162}, {19700,0.03687387}, {19800,0.06982883}, {19900,0.03719820}, {20000,0.03744954}};
data["big_flat"]["OCaml"]["norm reif"]["system"] = {{1,0.00020721}, {2,0.00002703}, {3,0.00007207}, {4,0.00003604}, {5,0.00000000}, {6,0.00007207}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003604}, {13,0.00003604}, {14,0.00003604}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00002703}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00003604}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00003604}, {30,0.00000000}, {31,0.00000000}, {32,0.00003604}, {33,0.00000000}, {34,0.00000000}, {35,0.00002703}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00003604}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00002703}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00003604}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00003604}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00003604}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00003604}, {69,0.00000000}, {70,0.00000000}, {71,0.00003604}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00003604}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00003604}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00010811}, {99,0.00003604}, {100,0.00000000}, {101,0.00000000}, {102,0.00003604}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00003604}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00002703}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00003604}, {134,0.00000000}, {135,0.00000000}, {136,0.00003604}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00003604}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00007207}, {158,0.00003604}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00003604}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00007207}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00003604}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00003604}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00003604}, {212,0.00000000}, {213,0.00003604}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00003604}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00003604}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00003604}, {250,0.00000000}, {251,0.00000000}, {252,0.00002703}, {253,0.00000000}, {254,0.00007207}, {255,0.00000000}, {256,0.00000000}, {257,0.00003604}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00003604}, {264,0.00000000}, {265,0.00003604}, {266,0.00003604}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00003604}, {271,0.00000000}, {272,0.00002703}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00003604}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00003604}, {288,0.00000000}, {289,0.00000000}, {290,0.00003604}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00003604}, {296,0.00000000}, {297,0.00000000}, {298,0.00002703}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00003604}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00003604}, {314,0.00000000}, {315,0.00007207}, {316,0.00000000}, {317,0.00000000}, {318,0.00003604}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00003604}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00003604}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00002703}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00007207}, {351,0.00007207}, {352,0.00000000}, {353,0.00000000}, {354,0.00002703}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00003604}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00003604}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00003604}, {375,0.00003604}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00003604}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00003604}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00003604}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00003604}, {413,0.00002703}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00003604}, {422,0.00000000}, {423,0.00003604}, {424,0.00000000}, {425,0.00003604}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00003604}, {431,0.00000000}, {432,0.00000000}, {433,0.00003604}, {434,0.00000000}, {435,0.00003604}, {436,0.00000000}, {437,0.00003604}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00002703}, {442,0.00000000}, {443,0.00003604}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00003604}, {448,0.00000000}, {449,0.00000000}, {450,0.00002703}, {451,0.00000000}, {452,0.00003604}, {453,0.00003604}, {454,0.00003604}, {455,0.00000000}, {456,0.00000000}, {457,0.00002703}, {458,0.00000000}, {459,0.00003604}, {460,0.00000000}, {461,0.00000000}, {462,0.00003604}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003604}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00003604}, {476,0.00003604}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00007207}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00003604}, {490,0.00000000}, {491,0.00003604}, {492,0.00002703}, {493,0.00000000}, {494,0.00000000}, {495,0.00003604}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00003604}, {520,0.00000000}, {525,0.00003604}, {530,0.00000000}, {535,0.00000000}, {540,0.00003604}, {545,0.00000000}, {550,0.00003604}, {555,0.00000000}, {560,0.00003604}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00007207}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00003604}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00006306}, {660,0.00003604}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00003604}, {705,0.00003604}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00003604}, {735,0.00000000}, {740,0.00003604}, {745,0.00000000}, {750,0.00003604}, {755,0.00007207}, {760,0.00003604}, {765,0.00000000}, {770,0.00000000}, {775,0.00003604}, {780,0.00000000}, {785,0.00003604}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00003604}, {830,0.00000000}, {835,0.00003604}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00002703}, {860,0.00000000}, {865,0.00000000}, {870,0.00003604}, {875,0.00003604}, {880,0.00003604}, {885,0.00000000}, {890,0.00003604}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00003604}, {930,0.00003604}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00003604}, {965,0.00000000}, {970,0.00000000}, {975,0.00003604}, {980,0.00000000}, {985,0.00021622}, {990,0.00003604}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00006306}, {1050,0.00000000}, {1060,0.00003604}, {1070,0.00000000}, {1080,0.00003604}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00003604}, {1120,0.00000000}, {1130,0.00003604}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00002703}, {1170,0.00012613}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00003604}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00002703}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00003604}, {1310,0.00000000}, {1320,0.00007207}, {1330,0.00000000}, {1340,0.00007207}, {1350,0.00007207}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00017117}, {1400,0.00000000}, {1410,0.00003604}, {1420,0.00000000}, {1430,0.00003604}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003604}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00007207}, {1520,0.00000000}, {1530,0.00003604}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00007207}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00003604}, {1630,0.00010811}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003604}, {1670,0.00003604}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00003604}, {1720,0.00007207}, {1730,0.00000000}, {1740,0.00003604}, {1750,0.00003604}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00007207}, {1840,0.00003604}, {1850,0.00018018}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00002703}, {1890,0.00000000}, {1900,0.00003604}, {1910,0.00003604}, {1920,0.00006306}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00017117}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00007207}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00007207}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00003604}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00002703}, {2700,0.00002703}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00007207}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00007207}, {3050,0.00003604}, {3100,0.00007207}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00007207}, {3300,0.00007207}, {3350,0.00003604}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00003604}, {3600,0.00000000}, {3650,0.00003604}, {3700,0.00003604}, {3750,0.00007207}, {3800,0.00003604}, {3850,0.00003604}, {3900,0.00000000}, {3950,0.00007207}, {4000,0.00000000}, {4050,0.00007207}, {4100,0.00003604}, {4150,0.00010811}, {4200,0.00003604}, {4250,0.00000000}, {4300,0.00009910}, {4350,0.00000000}, {4400,0.00002703}, {4450,0.00031532}, {4500,0.00003604}, {4550,0.00003604}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00007207}, {4800,0.00010811}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00003604}, {5150,0.00007207}, {5200,0.00003604}, {5250,0.00010811}, {5300,0.00000000}, {5350,0.00007207}, {5400,0.00000000}, {5450,0.00003604}, {5500,0.00003604}, {5550,0.00003604}, {5600,0.00003604}, {5650,0.00003604}, {5700,0.00010811}, {5750,0.00035135}, {5800,0.00007207}, {5850,0.00007207}, {5900,0.00003604}, {5950,0.00003604}, {6000,0.00072072}, {6050,0.00000000}, {6100,0.00003604}, {6150,0.00000000}, {6200,0.00002703}, {6250,0.00000000}, {6300,0.00058559}, {6350,0.00000000}, {6400,0.00003604}, {6450,0.00000000}, {6500,0.00003604}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00007207}, {6700,0.00038739}, {6750,0.00000000}, {6800,0.00003604}, {6850,0.00003604}, {6900,0.00007207}, {6950,0.00006306}, {7000,0.00003604}, {7050,0.00000000}, {7100,0.00007207}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00002703}, {7350,0.00002703}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00003604}, {7550,0.00003604}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00007207}, {7750,0.00000000}, {7800,0.00003604}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00003604}, {8000,0.00000000}, {8050,0.00003604}, {8100,0.00035135}, {8150,0.00006306}, {8200,0.00003604}, {8250,0.00007207}, {8300,0.00007207}, {8350,0.00003604}, {8400,0.00003604}, {8450,0.00003604}, {8500,0.00056757}, {8550,0.00003604}, {8600,0.00010811}, {8650,0.00003604}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00027928}, {8850,0.00007207}, {8900,0.00003604}, {8950,0.00000000}, {9000,0.00003604}, {9050,0.00032432}, {9100,0.00003604}, {9150,0.00000000}, {9200,0.00003604}, {9250,0.00060360}, {9300,0.00006306}, {9350,0.00003604}, {9400,0.00002703}, {9450,0.00060360}, {9500,0.00017117}, {9550,0.00010811}, {9600,0.00007207}, {9650,0.00007207}, {9700,0.00003604}, {9750,0.00007207}, {9800,0.00002703}, {9850,0.00007207}, {9900,0.00003604}, {9950,0.00003604}, {10000,0.00003604}, {10100,0.00003604}, {10200,0.00003604}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00003604}, {10800,0.00010811}, {10900,0.00003604}, {11000,0.00003604}, {11100,0.00027928}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00014414}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00003604}, {11900,0.00007207}, {12000,0.00003604}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00003604}, {12600,0.00007207}, {12700,0.00000000}, {12800,0.00003604}, {12900,0.00000000}, {13000,0.00096396}, {13100,0.00010811}, {13200,0.00000000}, {13300,0.00007207}, {13400,0.00071171}, {13500,0.00000000}, {13600,0.00003604}, {13700,0.00007207}, {13800,0.00010811}, {13900,0.00013514}, {14000,0.00000000}, {14100,0.00075676}, {14200,0.00003604}, {14300,0.00003604}, {14400,0.00003604}, {14500,0.00003604}, {14600,0.00003604}, {14700,0.00007207}, {14800,0.00007207}, {14900,0.00000000}, {15000,0.00010811}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00003604}, {15400,0.00010811}, {15500,0.00007207}, {15600,0.00076577}, {15700,0.00007207}, {15800,0.00013514}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00007207}, {16400,0.00003604}, {16500,0.00003604}, {16600,0.00000000}, {16700,0.00007207}, {16800,0.00003604}, {16900,0.00000000}, {17000,0.00003604}, {17100,0.00003604}, {17200,0.00013514}, {17300,0.00000000}, {17400,0.00003604}, {17500,0.00003604}, {17600,0.00003604}, {17700,0.00000000}, {17800,0.00007207}, {17900,0.00003604}, {18000,0.00010811}, {18100,0.00000000}, {18200,0.00003604}, {18300,0.00003604}, {18400,0.00003604}, {18500,0.00007207}, {18600,0.00000000}, {18700,0.00003604}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00010811}, {19100,0.00003604}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00009910}, {19600,0.00003604}, {19700,0.00007207}, {19800,0.00003604}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["OCaml"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["OCaml"]["post"]["user"] = {{1,0.00000000}, {2,0.00002703}, {3,0.00006306}, {4,0.00003604}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00006306}, {9,0.00000000}, {10,0.00003604}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00006306}, {15,0.00002703}, {16,0.00003604}, {17,0.00002703}, {18,0.00000000}, {19,0.00000000}, {20,0.00002703}, {21,0.00009009}, {22,0.00000000}, {23,0.00000000}, {24,0.00005405}, {25,0.00002703}, {26,0.00000000}, {27,0.00000000}, {28,0.00003604}, {29,0.00006306}, {30,0.00000000}, {31,0.00000000}, {32,0.00007207}, {33,0.00000000}, {34,0.00003604}, {35,0.00000000}, {36,0.00011712}, {37,0.00002703}, {38,0.00000000}, {39,0.00000000}, {40,0.00003604}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00002703}, {45,0.00002703}, {46,0.00003604}, {47,0.00005405}, {48,0.00000000}, {49,0.00003604}, {50,0.00006306}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00002703}, {55,0.00005405}, {56,0.00002703}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00005405}, {62,0.00000000}, {63,0.00003604}, {64,0.00007207}, {65,0.00003604}, {66,0.00002703}, {67,0.00002703}, {68,0.00000000}, {69,0.00002703}, {70,0.00002703}, {71,0.00007207}, {72,0.00000000}, {73,0.00009009}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00003604}, {79,0.00000000}, {80,0.00007207}, {81,0.00006306}, {82,0.00002703}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00003604}, {88,0.00002703}, {89,0.00000000}, {90,0.00000000}, {91,0.00003604}, {92,0.00012613}, {93,0.00003604}, {94,0.00003604}, {95,0.00003604}, {96,0.00000000}, {97,0.00000000}, {98,0.00002703}, {99,0.00000000}, {100,0.00009910}, {101,0.00006306}, {102,0.00002703}, {103,0.00002703}, {104,0.00005405}, {105,0.00000000}, {106,0.00005405}, {107,0.00009910}, {108,0.00000000}, {109,0.00006306}, {110,0.00002703}, {111,0.00002703}, {112,0.00000000}, {113,0.00003604}, {114,0.00009910}, {115,0.00002703}, {116,0.00007207}, {117,0.00006306}, {118,0.00002703}, {119,0.00000000}, {120,0.00002703}, {121,0.00002703}, {122,0.00002703}, {123,0.00000000}, {124,0.00000000}, {125,0.00007207}, {126,0.00000000}, {127,0.00003604}, {128,0.00009910}, {129,0.00009009}, {130,0.00003604}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00002703}, {135,0.00002703}, {136,0.00000000}, {137,0.00000000}, {138,0.00002703}, {139,0.00000000}, {140,0.00003604}, {141,0.00000000}, {142,0.00000000}, {143,0.00003604}, {144,0.00003604}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00002703}, {149,0.00000000}, {150,0.00000000}, {151,0.00007207}, {152,0.00006306}, {153,0.00007207}, {154,0.00002703}, {155,0.00000000}, {156,0.00000000}, {157,0.00006306}, {158,0.00000000}, {159,0.00003604}, {160,0.00003604}, {161,0.00002703}, {162,0.00000000}, {163,0.00005405}, {164,0.00007207}, {165,0.00003604}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00002703}, {170,0.00013514}, {171,0.00006306}, {172,0.00009910}, {173,0.00000000}, {174,0.00002703}, {175,0.00002703}, {176,0.00000000}, {177,0.00000000}, {178,0.00012613}, {179,0.00003604}, {180,0.00002703}, {181,0.00000000}, {182,0.00003604}, {183,0.00003604}, {184,0.00002703}, {185,0.00000000}, {186,0.00007207}, {187,0.00006306}, {188,0.00005405}, {189,0.00005405}, {190,0.00003604}, {191,0.00003604}, {192,0.00000000}, {193,0.00002703}, {194,0.00000000}, {195,0.00009009}, {196,0.00003604}, {197,0.00000000}, {198,0.00006306}, {199,0.00003604}, {200,0.00000000}, {201,0.00006306}, {202,0.00000000}, {203,0.00000000}, {204,0.00011712}, {205,0.00003604}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00005405}, {210,0.00000000}, {211,0.00002703}, {212,0.00000000}, {213,0.00000000}, {214,0.00002703}, {215,0.00002703}, {216,0.00003604}, {217,0.00000000}, {218,0.00000000}, {219,0.00003604}, {220,0.00002703}, {221,0.00002703}, {222,0.00003604}, {223,0.00010811}, {224,0.00003604}, {225,0.00000000}, {226,0.00002703}, {227,0.00000000}, {228,0.00003604}, {229,0.00006306}, {230,0.00003604}, {231,0.00007207}, {232,0.00003604}, {233,0.00006306}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00003604}, {238,0.00000000}, {239,0.00002703}, {240,0.00002703}, {241,0.00009910}, {242,0.00002703}, {243,0.00002703}, {244,0.00003604}, {245,0.00000000}, {246,0.00008108}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00003604}, {251,0.00002703}, {252,0.00003604}, {253,0.00006306}, {254,0.00002703}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00003604}, {260,0.00002703}, {261,0.00010811}, {262,0.00006306}, {263,0.00005405}, {264,0.00003604}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00002703}, {270,0.00000000}, {271,0.00005405}, {272,0.00007207}, {273,0.00009009}, {274,0.00000000}, {275,0.00000000}, {276,0.00003604}, {277,0.00000000}, {278,0.00009009}, {279,0.00003604}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00002703}, {284,0.00012613}, {285,0.00003604}, {286,0.00003604}, {287,0.00002703}, {288,0.00000000}, {289,0.00003604}, {290,0.00000000}, {291,0.00000000}, {292,0.00017117}, {293,0.00002703}, {294,0.00006306}, {295,0.00000000}, {296,0.00003604}, {297,0.00002703}, {298,0.00000000}, {299,0.00007207}, {300,0.00000000}, {301,0.00003604}, {302,0.00002703}, {303,0.00007207}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00002703}, {308,0.00006306}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00003604}, {313,0.00006306}, {314,0.00000000}, {315,0.00000000}, {316,0.00003604}, {317,0.00007207}, {318,0.00002703}, {319,0.00006306}, {320,0.00000000}, {321,0.00009910}, {322,0.00006306}, {323,0.00000000}, {324,0.00000000}, {325,0.00003604}, {326,0.00000000}, {327,0.00003604}, {328,0.00000000}, {329,0.00002703}, {330,0.00000000}, {331,0.00007207}, {332,0.00003604}, {333,0.00005405}, {334,0.00007207}, {335,0.00007207}, {336,0.00000000}, {337,0.00000000}, {338,0.00007207}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00002703}, {343,0.00000000}, {344,0.00003604}, {345,0.00003604}, {346,0.00000000}, {347,0.00002703}, {348,0.00003604}, {349,0.00003604}, {350,0.00003604}, {351,0.00000000}, {352,0.00003604}, {353,0.00003604}, {354,0.00006306}, {355,0.00002703}, {356,0.00005405}, {357,0.00000000}, {358,0.00007207}, {359,0.00007207}, {360,0.00000000}, {361,0.00006306}, {362,0.00005405}, {363,0.00000000}, {364,0.00010811}, {365,0.00000000}, {366,0.00002703}, {367,0.00003604}, {368,0.00003604}, {369,0.00007207}, {370,0.00000000}, {371,0.00000000}, {372,0.00002703}, {373,0.00003604}, {374,0.00007207}, {375,0.00009009}, {376,0.00002703}, {377,0.00003604}, {378,0.00002703}, {379,0.00000000}, {380,0.00003604}, {381,0.00000000}, {382,0.00000000}, {383,0.00009009}, {384,0.00003604}, {385,0.00003604}, {386,0.00003604}, {387,0.00003604}, {388,0.00000000}, {389,0.00003604}, {390,0.00000000}, {391,0.00007207}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00003604}, {396,0.00003604}, {397,0.00011712}, {398,0.00000000}, {399,0.00003604}, {400,0.00003604}, {401,0.00002703}, {402,0.00000000}, {403,0.00003604}, {404,0.00003604}, {405,0.00007207}, {406,0.00003604}, {407,0.00006306}, {408,0.00000000}, {409,0.00009910}, {410,0.00003604}, {411,0.00003604}, {412,0.00009910}, {413,0.00003604}, {414,0.00003604}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00005405}, {420,0.00003604}, {421,0.00002703}, {422,0.00002703}, {423,0.00009009}, {424,0.00000000}, {425,0.00000000}, {426,0.00003604}, {427,0.00000000}, {428,0.00006306}, {429,0.00000000}, {430,0.00003604}, {431,0.00000000}, {432,0.00002703}, {433,0.00000000}, {434,0.00000000}, {435,0.00019820}, {436,0.00006306}, {437,0.00002703}, {438,0.00003604}, {439,0.00013514}, {440,0.00000000}, {441,0.00006306}, {442,0.00000000}, {443,0.00002703}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00007207}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00005405}, {452,0.00000000}, {453,0.00005405}, {454,0.00007207}, {455,0.00002703}, {456,0.00002703}, {457,0.00007207}, {458,0.00002703}, {459,0.00000000}, {460,0.00003604}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00003604}, {465,0.00013514}, {466,0.00009009}, {467,0.00003604}, {468,0.00000000}, {469,0.00006306}, {470,0.00007207}, {471,0.00000000}, {472,0.00003604}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00008108}, {477,0.00002703}, {478,0.00003604}, {479,0.00005405}, {480,0.00003604}, {481,0.00003604}, {482,0.00002703}, {483,0.00000000}, {484,0.00002703}, {485,0.00007207}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00006306}, {490,0.00002703}, {491,0.00000000}, {492,0.00006306}, {493,0.00000000}, {494,0.00005405}, {495,0.00000000}, {496,0.00003604}, {497,0.00003604}, {498,0.00000000}, {499,0.00003604}, {500,0.00000000}, {505,0.00000000}, {510,0.00003604}, {515,0.00006306}, {520,0.00003604}, {525,0.00002703}, {530,0.00000000}, {535,0.00007207}, {540,0.00011712}, {545,0.00009009}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00003604}, {580,0.00000000}, {585,0.00003604}, {590,0.00003604}, {595,0.00000000}, {600,0.00007207}, {605,0.00003604}, {610,0.00002703}, {615,0.00003604}, {620,0.00002703}, {625,0.00006306}, {630,0.00002703}, {635,0.00002703}, {640,0.00007207}, {645,0.00002703}, {650,0.00000000}, {655,0.00000000}, {660,0.00007207}, {665,0.00000000}, {670,0.00000000}, {675,0.00006306}, {680,0.00012613}, {685,0.00002703}, {690,0.00007207}, {695,0.00002703}, {700,0.00000000}, {705,0.00009009}, {710,0.00002703}, {715,0.00003604}, {720,0.00000000}, {725,0.00003604}, {730,0.00003604}, {735,0.00003604}, {740,0.00005405}, {745,0.00000000}, {750,0.00005405}, {755,0.00003604}, {760,0.00003604}, {765,0.00002703}, {770,0.00003604}, {775,0.00006306}, {780,0.00009009}, {785,0.00003604}, {790,0.00003604}, {795,0.00000000}, {800,0.00002703}, {805,0.00000000}, {810,0.00003604}, {815,0.00003604}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00009009}, {840,0.00006306}, {845,0.00007207}, {850,0.00006306}, {855,0.00003604}, {860,0.00000000}, {865,0.00000000}, {870,0.00007207}, {875,0.00003604}, {880,0.00003604}, {885,0.00006306}, {890,0.00000000}, {895,0.00003604}, {900,0.00006306}, {905,0.00003604}, {910,0.00003604}, {915,0.00009009}, {920,0.00000000}, {925,0.00003604}, {930,0.00003604}, {935,0.00000000}, {940,0.00003604}, {945,0.00007207}, {950,0.00000000}, {955,0.00000000}, {960,0.00002703}, {965,0.00002703}, {970,0.00005405}, {975,0.00002703}, {980,0.00003604}, {985,0.00003604}, {990,0.00003604}, {995,0.00000000}, {1000,0.00005405}, {1010,0.00006306}, {1020,0.00000000}, {1030,0.00006306}, {1040,0.00007207}, {1050,0.00000000}, {1060,0.00003604}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00006306}, {1100,0.00000000}, {1110,0.00006306}, {1120,0.00007207}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00003604}, {1170,0.00003604}, {1180,0.00003604}, {1190,0.00003604}, {1200,0.00003604}, {1210,0.00002703}, {1220,0.00007207}, {1230,0.00006306}, {1240,0.00003604}, {1250,0.00003604}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00007207}, {1300,0.00003604}, {1310,0.00003604}, {1320,0.00006306}, {1330,0.00002703}, {1340,0.00002703}, {1350,0.00002703}, {1360,0.00003604}, {1370,0.00000000}, {1380,0.00009009}, {1390,0.00002703}, {1400,0.00000000}, {1410,0.00006306}, {1420,0.00006306}, {1430,0.00003604}, {1440,0.00009910}, {1450,0.00000000}, {1460,0.00010811}, {1470,0.00003604}, {1480,0.00002703}, {1490,0.00002703}, {1500,0.00006306}, {1510,0.00009910}, {1520,0.00007207}, {1530,0.00009009}, {1540,0.00003604}, {1550,0.00000000}, {1560,0.00006306}, {1570,0.00007207}, {1580,0.00005405}, {1590,0.00000000}, {1600,0.00011712}, {1610,0.00003604}, {1620,0.00002703}, {1630,0.00003604}, {1640,0.00003604}, {1650,0.00000000}, {1660,0.00003604}, {1670,0.00007207}, {1680,0.00002703}, {1690,0.00007207}, {1700,0.00003604}, {1710,0.00008108}, {1720,0.00007207}, {1730,0.00000000}, {1740,0.00003604}, {1750,0.00002703}, {1760,0.00000000}, {1770,0.00002703}, {1780,0.00000000}, {1790,0.00014414}, {1800,0.00012613}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00003604}, {1840,0.00000000}, {1850,0.00002703}, {1860,0.00007207}, {1870,0.00000000}, {1880,0.00012613}, {1890,0.00003604}, {1900,0.00000000}, {1910,0.00002703}, {1920,0.00000000}, {1930,0.00006306}, {1940,0.00002703}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00002703}, {2000,0.00006306}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00007207}, {2200,0.00006306}, {2250,0.00003604}, {2300,0.00007207}, {2350,0.00000000}, {2400,0.00003604}, {2450,0.00006306}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00007207}, {2700,0.00002703}, {2750,0.00000000}, {2800,0.00007207}, {2850,0.00002703}, {2900,0.00000000}, {2950,0.00003604}, {3000,0.00006306}, {3050,0.00000000}, {3100,0.00002703}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00003604}, {3300,0.00003604}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00003604}, {3550,0.00002703}, {3600,0.00014414}, {3650,0.00003604}, {3700,0.00002703}, {3750,0.00002703}, {3800,0.00003604}, {3850,0.00002703}, {3900,0.00007207}, {3950,0.00003604}, {4000,0.00000000}, {4050,0.00002703}, {4100,0.00003604}, {4150,0.00003604}, {4200,0.00007207}, {4250,0.00000000}, {4300,0.00003604}, {4350,0.00003604}, {4400,0.00009009}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00003604}, {4600,0.00006306}, {4650,0.00002703}, {4700,0.00002703}, {4750,0.00000000}, {4800,0.00002703}, {4850,0.00000000}, {4900,0.00003604}, {4950,0.00010811}, {5000,0.00003604}, {5050,0.00003604}, {5100,0.00006306}, {5150,0.00006306}, {5200,0.00007207}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00002703}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00003604}, {5650,0.00000000}, {5700,0.00002703}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00002703}, {5900,0.00000000}, {5950,0.00003604}, {6000,0.00003604}, {6050,0.00011712}, {6100,0.00006306}, {6150,0.00007207}, {6200,0.00003604}, {6250,0.00003604}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00006306}, {6450,0.00000000}, {6500,0.00003604}, {6550,0.00006306}, {6600,0.00000000}, {6650,0.00013514}, {6700,0.00000000}, {6750,0.00002703}, {6800,0.00009009}, {6850,0.00000000}, {6900,0.00012613}, {6950,0.00000000}, {7000,0.00012613}, {7050,0.00000000}, {7100,0.00013514}, {7150,0.00000000}, {7200,0.00009009}, {7250,0.00003604}, {7300,0.00006306}, {7350,0.00000000}, {7400,0.00002703}, {7450,0.00002703}, {7500,0.00000000}, {7550,0.00010811}, {7600,0.00006306}, {7650,0.00007207}, {7700,0.00007207}, {7750,0.00000000}, {7800,0.00003604}, {7850,0.00003604}, {7900,0.00009009}, {7950,0.00003604}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00007207}, {8200,0.00003604}, {8250,0.00007207}, {8300,0.00000000}, {8350,0.00007207}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00003604}, {8650,0.00006306}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00005405}, {8850,0.00000000}, {8900,0.00002703}, {8950,0.00002703}, {9000,0.00014414}, {9050,0.00000000}, {9100,0.00009009}, {9150,0.00009009}, {9200,0.00014414}, {9250,0.00002703}, {9300,0.00007207}, {9350,0.00003604}, {9400,0.00000000}, {9450,0.00006306}, {9500,0.00000000}, {9550,0.00006306}, {9600,0.00009009}, {9650,0.00005405}, {9700,0.00006306}, {9750,0.00002703}, {9800,0.00003604}, {9850,0.00011712}, {9900,0.00002703}, {9950,0.00003604}, {10000,0.00008108}, {10100,0.00005405}, {10200,0.00000000}, {10300,0.00002703}, {10400,0.00000000}, {10500,0.00002703}, {10600,0.00002703}, {10700,0.00002703}, {10800,0.00008108}, {10900,0.00005405}, {11000,0.00009009}, {11100,0.00002703}, {11200,0.00006306}, {11300,0.00002703}, {11400,0.00003604}, {11500,0.00002703}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00003604}, {11900,0.00002703}, {12000,0.00009009}, {12100,0.00007207}, {12200,0.00005405}, {12300,0.00005405}, {12400,0.00000000}, {12500,0.00003604}, {12600,0.00006306}, {12700,0.00000000}, {12800,0.00006306}, {12900,0.00000000}, {13000,0.00006306}, {13100,0.00002703}, {13200,0.00006306}, {13300,0.00000000}, {13400,0.00006306}, {13500,0.00002703}, {13600,0.00006306}, {13700,0.00006306}, {13800,0.00000000}, {13900,0.00002703}, {14000,0.00009009}, {14100,0.00002703}, {14200,0.00002703}, {14300,0.00003604}, {14400,0.00005405}, {14500,0.00009009}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00002703}, {14900,0.00000000}, {15000,0.00002703}, {15100,0.00008108}, {15200,0.00000000}, {15300,0.00003604}, {15400,0.00002703}, {15500,0.00012613}, {15600,0.00009910}, {15700,0.00005405}, {15800,0.00002703}, {15900,0.00005405}, {16000,0.00003604}, {16100,0.00003604}, {16200,0.00007207}, {16300,0.00009009}, {16400,0.00000000}, {16500,0.00003604}, {16600,0.00007207}, {16700,0.00005405}, {16800,0.00009910}, {16900,0.00002703}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00002703}, {17500,0.00006306}, {17600,0.00014414}, {17700,0.00002703}, {17800,0.00007207}, {17900,0.00000000}, {18000,0.00002703}, {18100,0.00006306}, {18200,0.00000000}, {18300,0.00003604}, {18400,0.00009910}, {18500,0.00000000}, {18600,0.00009009}, {18700,0.00000000}, {18800,0.00003604}, {18900,0.00012613}, {19000,0.00014414}, {19100,0.00000000}, {19200,0.00003604}, {19300,0.00009910}, {19400,0.00003604}, {19500,0.00000000}, {19600,0.00007207}, {19700,0.00000000}, {19800,0.00010811}, {19900,0.00006306}, {20000,0.00003670}};
data["big_flat"]["OCaml"]["post"]["system"] = {{1,0.00003604}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00002703}, {53,0.00003604}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00003604}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00003604}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00003604}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003604}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00003604}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00003604}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00003604}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00003604}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["OCaml"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["OCaml"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00002703}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00003604}, {9,0.00000000}, {10,0.00002703}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00006306}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00002703}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00002703}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00002703}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00002703}, {82,0.00003604}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00003604}, {88,0.00000000}, {89,0.00003604}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00003604}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00003604}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00002703}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00002703}, {119,0.00002703}, {120,0.00000000}, {121,0.00000000}, {122,0.00003604}, {123,0.00000000}, {124,0.00000000}, {125,0.00006306}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00002703}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00002703}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00003604}, {161,0.00000000}, {162,0.00000000}, {163,0.00002703}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00003604}, {198,0.00000000}, {199,0.00000000}, {200,0.00002703}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00002703}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00003604}, {222,0.00003604}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00002703}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00002703}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00003604}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00002703}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003604}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00003604}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00002703}, {279,0.00000000}, {280,0.00002703}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00003604}, {301,0.00002703}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00003604}, {309,0.00000000}, {310,0.00002703}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00002703}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00002703}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00003604}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00003604}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00003604}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00007207}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00002703}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00003604}, {373,0.00000000}, {374,0.00003604}, {375,0.00000000}, {376,0.00000000}, {377,0.00003604}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00003604}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00003604}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00003604}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00002703}, {412,0.00000000}, {413,0.00003604}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00002703}, {421,0.00000000}, {422,0.00000000}, {423,0.00003604}, {424,0.00000000}, {425,0.00003604}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00002703}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00003604}, {442,0.00000000}, {443,0.00003604}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00007207}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00002703}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00002703}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00002703}, {485,0.00002703}, {486,0.00000000}, {487,0.00000000}, {488,0.00002703}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00003604}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00002703}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00003604}, {625,0.00003604}, {630,0.00000000}, {635,0.00000000}, {640,0.00007207}, {645,0.00000000}, {650,0.00002703}, {655,0.00000000}, {660,0.00000000}, {665,0.00003604}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00002703}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00003604}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00002703}, {920,0.00000000}, {925,0.00000000}, {930,0.00002703}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00006306}, {1080,0.00000000}, {1090,0.00003604}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00003604}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00003604}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00003604}, {1340,0.00002703}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00003604}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00003604}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00003604}, {1620,0.00003604}, {1630,0.00000000}, {1640,0.00003604}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00006306}, {1840,0.00003604}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00003604}, {1880,0.00000000}, {1890,0.00003604}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00003604}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00002703}, {2050,0.00003604}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00002703}, {2500,0.00003604}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00002703}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00003604}, {2950,0.00000000}, {3000,0.00003604}, {3050,0.00000000}, {3100,0.00003604}, {3150,0.00000000}, {3200,0.00002703}, {3250,0.00000000}, {3300,0.00006306}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00003604}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00003604}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00003604}, {4100,0.00000000}, {4150,0.00003604}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00003604}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00002703}, {5350,0.00003604}, {5400,0.00002703}, {5450,0.00000000}, {5500,0.00003604}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00003604}, {6000,0.00003604}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00003604}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00006306}, {6600,0.00000000}, {6650,0.00003604}, {6700,0.00003604}, {6750,0.00003604}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00003604}, {7000,0.00002703}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00007207}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00003604}, {7550,0.00000000}, {7600,0.00002703}, {7650,0.00006306}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00002703}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00002703}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00002703}, {9600,0.00003604}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00002703}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00002703}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00002703}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00002703}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00002703}, {13900,0.00000000}, {14000,0.00002703}, {14100,0.00000000}, {14200,0.00002703}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00002703}, {14600,0.00003604}, {14700,0.00006306}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00002703}, {15300,0.00003604}, {15400,0.00000000}, {15500,0.00002703}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00003604}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00003604}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00002703}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00002703}, {18500,0.00002703}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00006306}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["OCaml"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00003604}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00003604}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00003604}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00003604}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00003604}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["OCaml"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.01518919}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00001802}, {96,0.00000000}, {97,0.00000000}, {98,0.00117117}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00100901}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00001802}, {172,0.00000000}, {173,0.00170270}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000901}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000901}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00001802}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000901}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000901}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000901}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00182883}, {319,0.00000000}, {320,0.00000000}, {321,0.00000901}, {322,0.00000000}, {323,0.00000901}, {324,0.00000901}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00002703}, {330,0.00000901}, {331,0.00000901}, {332,0.00001802}, {333,0.00000000}, {334,0.00000901}, {335,0.00000000}, {336,0.00001802}, {337,0.00196396}, {338,0.00001802}, {339,0.00000901}, {340,0.00002703}, {341,0.00002703}, {342,0.00002703}, {343,0.00002703}, {344,0.00005405}, {345,0.00006306}, {346,0.00005405}, {347,0.00009009}, {348,0.00009009}, {349,0.00009009}, {350,0.00005405}, {351,0.00007207}, {352,0.00010811}, {353,0.00019820}, {354,0.00012613}, {355,0.00017117}, {356,0.00011712}, {357,0.00017117}, {358,0.00027027}, {359,0.00019820}, {360,0.00030631}, {361,0.00027027}, {362,0.00033333}, {363,0.00031532}, {364,0.00028829}, {365,0.00036937}, {366,0.00039640}, {367,0.00051351}, {368,0.00044144}, {369,0.00055856}, {370,0.00050450}, {371,0.00059459}, {372,0.00052252}, {373,0.00061261}, {374,0.00067568}, {375,0.00065766}, {376,0.00068468}, {377,0.00070270}, {378,0.00069369}, {379,0.00071171}, {380,0.00072973}, {381,0.00073874}, {382,0.00073874}, {383,0.00072973}, {384,0.00075676}, {385,0.00090090}, {386,0.00084685}, {387,0.00086486}, {388,0.00084685}, {389,0.00081982}, {390,0.00091892}, {391,0.00090991}, {392,0.00091892}, {393,0.00093694}, {394,0.00093694}, {395,0.00093694}, {396,0.00098198}, {397,0.00097297}, {398,0.00098198}, {399,0.00098198}, {400,0.00097297}, {401,0.00100000}, {402,0.00099099}, {403,0.00099099}, {404,0.00098198}, {405,0.00100000}, {406,0.00100000}, {407,0.00100000}, {408,0.00100000}, {409,0.00100000}, {410,0.00100000}, {411,0.00100000}, {412,0.00100000}, {413,0.00100000}, {414,0.00100000}, {415,0.00100000}, {416,0.00100000}, {417,0.00100000}, {418,0.00100000}, {419,0.00100000}, {420,0.00100000}, {421,0.00100000}, {422,0.00100000}, {423,0.00100000}, {424,0.00100000}, {425,0.00100000}, {426,0.00100000}, {427,0.00100000}, {428,0.00100000}, {429,0.00100000}, {430,0.00100000}, {431,0.00100000}, {432,0.00100000}, {433,0.00100000}, {434,0.00100000}, {435,0.00100000}, {436,0.00100000}, {437,0.00100000}, {438,0.00100000}, {439,0.00100000}, {440,0.00100000}, {441,0.00100000}, {442,0.00100000}, {443,0.00100000}, {444,0.00100000}, {445,0.00100000}, {446,0.00100000}, {447,0.00100000}, {448,0.00100000}, {449,0.00100000}, {450,0.00100000}, {451,0.00100000}, {452,0.00100000}, {453,0.00100000}, {454,0.00100000}, {455,0.00100000}, {456,0.00100000}, {457,0.00100000}, {458,0.00100000}, {459,0.00100000}, {460,0.00100000}, {461,0.00100000}, {462,0.00100000}, {463,0.00100000}, {464,0.00100000}, {465,0.00100000}, {466,0.00100000}, {467,0.00100000}, {468,0.00100000}, {469,0.00100000}, {470,0.00100000}, {471,0.00100000}, {472,0.00100000}, {473,0.00100000}, {474,0.00102703}, {475,0.00100000}, {476,0.00100000}, {477,0.00100000}, {478,0.00100000}, {479,0.00100000}, {480,0.00100000}, {481,0.00100000}, {482,0.00100000}, {483,0.00100000}, {484,0.00100000}, {485,0.00100000}, {486,0.00100000}, {487,0.00100000}, {488,0.00100000}, {489,0.00100000}, {490,0.00100000}, {491,0.00100901}, {492,0.00100000}, {493,0.00100000}, {494,0.00100000}, {495,0.00100000}, {496,0.00100000}, {497,0.00100000}, {498,0.00100000}, {499,0.00100000}, {500,0.00100000}, {505,0.00100000}, {510,0.00100000}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00100000}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100901}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100901}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100901}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00101802}, {820,0.00100901}, {825,0.00100901}, {830,0.00103604}, {835,0.00103604}, {840,0.00100000}, {845,0.00102703}, {850,0.00103604}, {855,0.00104505}, {860,0.00104505}, {865,0.00101802}, {870,0.00108108}, {875,0.00103604}, {880,0.00106306}, {885,0.00109009}, {890,0.00117117}, {895,0.00118919}, {900,0.00122523}, {905,0.00116216}, {910,0.00122523}, {915,0.00120721}, {920,0.00122523}, {925,0.00133333}, {930,0.00134234}, {935,0.00136937}, {940,0.00139640}, {945,0.00145946}, {950,0.00154955}, {955,0.00163063}, {960,0.00164865}, {965,0.00170270}, {970,0.00177477}, {975,0.00181081}, {980,0.00181081}, {985,0.00627928}, {990,0.00189189}, {995,0.00191892}, {1000,0.00191892}, {1010,0.00197297}, {1020,0.00199099}, {1030,0.00200000}, {1040,0.00408108}, {1050,0.00200000}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200000}, {1140,0.00200000}, {1150,0.00200000}, {1160,0.00200000}, {1170,0.00200000}, {1180,0.00200000}, {1190,0.00200000}, {1200,0.00200000}, {1210,0.00200000}, {1220,0.00200000}, {1230,0.00200000}, {1240,0.00201802}, {1250,0.00200901}, {1260,0.00201802}, {1270,0.00201802}, {1280,0.00209910}, {1290,0.00203604}, {1300,0.00206306}, {1310,0.00209009}, {1320,0.00209910}, {1330,0.00210811}, {1340,0.00209910}, {1350,0.00217117}, {1360,0.00221622}, {1370,0.00228829}, {1380,0.00233333}, {1390,0.00759459}, {1400,0.00244144}, {1410,0.00243243}, {1420,0.00255856}, {1430,0.00254054}, {1440,0.00777477}, {1450,0.00263964}, {1460,0.00273874}, {1470,0.00278378}, {1480,0.00280180}, {1490,0.00201802}, {1500,0.00290090}, {1510,0.00293694}, {1520,0.00296396}, {1530,0.00297297}, {1540,0.00295495}, {1550,0.00299099}, {1560,0.00299099}, {1570,0.00300000}, {1580,0.00306306}, {1590,0.00300000}, {1600,0.00300901}, {1610,0.00300000}, {1620,0.00301802}, {1630,0.00300000}, {1640,0.00301802}, {1650,0.00301802}, {1660,0.00300901}, {1670,0.00302703}, {1680,0.00304505}, {1690,0.00306306}, {1700,0.00303604}, {1710,0.00320721}, {1720,0.00307207}, {1730,0.00306306}, {1740,0.00308108}, {1750,0.00311712}, {1760,0.00309910}, {1770,0.00317117}, {1780,0.00323423}, {1790,0.00320721}, {1800,0.00320721}, {1810,0.00333333}, {1820,0.00327928}, {1830,0.00334234}, {1840,0.00330631}, {1850,0.00349550}, {1860,0.00349550}, {1870,0.00349550}, {1880,0.00360360}, {1890,0.00355856}, {1900,0.00364865}, {1910,0.00378378}, {1920,0.00372072}, {1930,0.00370270}, {1940,0.00372973}, {1950,0.00766667}, {1960,0.00382883}, {1970,0.00389189}, {1980,0.00389189}, {1990,0.00385586}, {2000,0.00396396}, {2050,0.00399099}, {2100,0.00411712}, {2150,0.00412613}, {2200,0.00418018}, {2250,0.00444144}, {2300,0.00442342}, {2350,0.00465766}, {2400,0.00475676}, {2450,0.00490090}, {2500,0.00507207}, {2550,0.00513514}, {2600,0.00524324}, {2650,0.00531532}, {2700,0.00569369}, {2750,0.00564865}, {2800,0.00585586}, {2850,0.00598198}, {2900,0.00604505}, {2950,0.00625225}, {3000,0.00623423}, {3050,0.00645946}, {3100,0.00656757}, {3150,0.00657658}, {3200,0.00694595}, {3250,0.00695495}, {3300,0.00715315}, {3350,0.00736036}, {3400,0.00736937}, {3450,0.00759459}, {3500,0.00775676}, {3550,0.00790090}, {3600,0.00809009}, {3650,0.00822523}, {3700,0.00836937}, {3750,0.00841441}, {3800,0.00852252}, {3850,0.00870270}, {3900,0.00897297}, {3950,0.00900901}, {4000,0.00907207}, {4050,0.00943243}, {4100,0.00969369}, {4150,0.00959459}, {4200,0.00850450}, {4250,0.00990991}, {4300,0.01009910}, {4350,0.01034234}, {4400,0.01037838}, {4450,0.02227027}, {4500,0.01077477}, {4550,0.01094595}, {4600,0.01100901}, {4650,0.01125225}, {4700,0.01146847}, {4750,0.01173874}, {4800,0.01172072}, {4850,0.00907207}, {4900,0.01208108}, {4950,0.01222523}, {5000,0.00998198}, {5050,0.01247748}, {5100,0.01260360}, {5150,0.01295495}, {5200,0.01304505}, {5250,0.01305405}, {5300,0.01320721}, {5350,0.02412613}, {5400,0.01345045}, {5450,0.01375676}, {5500,0.01390090}, {5550,0.01430631}, {5600,0.01423423}, {5650,0.01437838}, {5700,0.01452252}, {5750,0.03593694}, {5800,0.01482883}, {5850,0.01490090}, {5900,0.01510811}, {5950,0.01523423}, {6000,0.04267568}, {6050,0.01550450}, {6100,0.01561261}, {6150,0.01582883}, {6200,0.01601802}, {6250,0.01609009}, {6300,0.04221622}, {6350,0.01644144}, {6400,0.01654054}, {6450,0.01672072}, {6500,0.01689189}, {6550,0.01694595}, {6600,0.01715315}, {6650,0.01725225}, {6700,0.03266667}, {6750,0.01786486}, {6800,0.01770270}, {6850,0.01777477}, {6900,0.01804505}, {6950,0.01817117}, {7000,0.01823423}, {7050,0.01839640}, {7100,0.01862162}, {7150,0.01868468}, {7200,0.01877477}, {7250,0.01909910}, {7300,0.01909910}, {7350,0.01923423}, {7400,0.01944144}, {7450,0.01955856}, {7500,0.01972973}, {7550,0.01993694}, {7600,0.02001802}, {7650,0.02011712}, {7700,0.02032432}, {7750,0.02045045}, {7800,0.02057658}, {7850,0.02071171}, {7900,0.02076577}, {7950,0.02102703}, {8000,0.02104505}, {8050,0.04581081}, {8100,0.03546847}, {8150,0.02154054}, {8200,0.02155856}, {8250,0.02176577}, {8300,0.02178378}, {8350,0.02208108}, {8400,0.02218018}, {8450,0.02238739}, {8500,0.04224324}, {8550,0.02259459}, {8600,0.02277477}, {8650,0.02266667}, {8700,0.02291892}, {8750,0.02311712}, {8800,0.04176577}, {8850,0.02333333}, {8900,0.02340541}, {8950,0.02365766}, {9000,0.02374775}, {9050,0.03641441}, {9100,0.02410811}, {9150,0.02409910}, {9200,0.02427928}, {9250,0.05573874}, {9300,0.02457658}, {9350,0.02463964}, {9400,0.02476577}, {9450,0.04314414}, {9500,0.02506306}, {9550,0.02516216}, {9600,0.02581982}, {9650,0.02538739}, {9700,0.02554054}, {9750,0.02571171}, {9800,0.01951351}, {9850,0.02589189}, {9900,0.02608108}, {9950,0.01976577}, {10000,0.02638739}, {10100,0.02664865}, {10200,0.02690991}, {10300,0.02715315}, {10400,0.05050450}, {10500,0.02769369}, {10600,0.02796396}, {10700,0.02820721}, {10800,0.02856757}, {10900,0.02513514}, {11000,0.02901802}, {11100,0.03833333}, {11200,0.02951351}, {11300,0.02245946}, {11400,0.03008108}, {11500,0.03022523}, {11600,0.03049550}, {11700,0.03080180}, {11800,0.07188288}, {11900,0.03129730}, {12000,0.02504505}, {12100,0.03181982}, {12200,0.03209009}, {12300,0.04413514}, {12400,0.03267568}, {12500,0.03281081}, {12600,0.04659459}, {12700,0.03337838}, {12800,0.03360360}, {12900,0.03395495}, {13000,0.07902703}, {13100,0.03440541}, {13200,0.03467568}, {13300,0.03492793}, {13400,0.05492793}, {13500,0.07554955}, {13600,0.03580180}, {13700,0.03606306}, {13800,0.03626126}, {13900,0.03650450}, {14000,0.02802703}, {14100,0.06401802}, {14200,0.06541441}, {14300,0.03801802}, {14400,0.03794595}, {14500,0.03821622}, {14600,0.03835135}, {14700,0.03862162}, {14800,0.03899099}, {14900,0.03914414}, {15000,0.03935135}, {15100,0.03962162}, {15200,0.04000000}, {15300,0.04010811}, {15400,0.04097297}, {15500,0.06795495}, {15600,0.06854955}, {15700,0.05642342}, {15800,0.04143243}, {15900,0.04163964}, {16000,0.04192793}, {16100,0.04227928}, {16200,0.08616216}, {16300,0.05833333}, {16400,0.04301802}, {16500,0.04325225}, {16600,0.04352252}, {16700,0.06981081}, {16800,0.03429730}, {16900,0.04442342}, {17000,0.04468468}, {17100,0.06856757}, {17200,0.04521622}, {17300,0.04541441}, {17400,0.07972072}, {17500,0.04606306}, {17600,0.04632432}, {17700,0.05866667}, {17800,0.04681081}, {17900,3.53916216}, {18000,0.04728829}, {18100,0.04763964}, {18200,0.05385586}, {18300,0.04813514}, {18400,0.06385586}, {18500,0.04856757}, {18600,0.07089189}, {18700,0.04919820}, {18800,0.06435135}, {18900,0.04974775}, {19000,0.05656757}, {19100,0.05024324}, {19200,0.05040541}, {19300,0.08948649}, {19400,0.05100901}, {19500,0.06444144}, {19600,0.05144144}, {19700,0.05177477}, {19800,0.07928829}, {19900,0.05228829}, {20000,0.05260550}};
data["big_flat"]["OCaml"]["reif"]["user"] = {{1,0.00008108}, {2,0.00014414}, {3,0.00020721}, {4,0.00037838}, {5,0.00028829}, {6,0.00035135}, {7,0.00025225}, {8,0.00018919}, {9,0.00033333}, {10,0.00034234}, {11,0.00020721}, {12,0.00015315}, {13,0.00027928}, {14,0.00031532}, {15,0.00026126}, {16,0.00033333}, {17,0.00027027}, {18,0.00019820}, {19,0.00036036}, {20,0.00023423}, {21,0.00026126}, {22,0.00024324}, {23,0.00024324}, {24,0.00043243}, {25,0.00032432}, {26,0.00024324}, {27,0.00046847}, {28,0.00022523}, {29,0.00025225}, {30,0.00033333}, {31,0.00030631}, {32,0.00054955}, {33,0.00041441}, {34,0.00038739}, {35,0.00036937}, {36,0.00013514}, {37,0.00051351}, {38,0.00033333}, {39,0.00027928}, {40,0.00018018}, {41,0.00042342}, {42,0.01491892}, {43,0.00033333}, {44,0.00045946}, {45,0.00040541}, {46,0.00026126}, {47,0.00036036}, {48,0.00042342}, {49,0.00034234}, {50,0.00041441}, {51,0.00043243}, {52,0.00023423}, {53,0.00040541}, {54,0.00039640}, {55,0.00036036}, {56,0.00040541}, {57,0.00041441}, {58,0.00030631}, {59,0.00035135}, {60,0.00027928}, {61,0.00035135}, {62,0.00044144}, {63,0.00033333}, {64,0.00038739}, {65,0.00030631}, {66,0.00038739}, {67,0.00031532}, {68,0.00036036}, {69,0.00026126}, {70,0.00043243}, {71,0.00033333}, {72,0.00040541}, {73,0.00039640}, {74,0.00049550}, {75,0.00047748}, {76,0.00040541}, {77,0.00030631}, {78,0.00032432}, {79,0.00040541}, {80,0.00041441}, {81,0.00041441}, {82,0.00045045}, {83,0.00057658}, {84,0.00054955}, {85,0.00022523}, {86,0.00043243}, {87,0.00035135}, {88,0.00055856}, {89,0.00045946}, {90,0.00037838}, {91,0.00034234}, {92,0.00044144}, {93,0.00051351}, {94,0.00044144}, {95,0.00032432}, {96,0.00035135}, {97,0.00052252}, {98,0.00175676}, {99,0.00036036}, {100,0.00032432}, {101,0.00065766}, {102,0.00049550}, {103,0.00050450}, {104,0.00049550}, {105,0.00043243}, {106,0.00048649}, {107,0.00046847}, {108,0.00037838}, {109,0.00042342}, {110,0.00045946}, {111,0.00055856}, {112,0.00036937}, {113,0.00042342}, {114,0.00053153}, {115,0.00047748}, {116,0.00031532}, {117,0.00069369}, {118,0.00030631}, {119,0.00043243}, {120,0.00074775}, {121,0.00045946}, {122,0.00053153}, {123,0.00049550}, {124,0.00040541}, {125,0.00045946}, {126,0.00048649}, {127,0.00046847}, {128,0.00038739}, {129,0.00047748}, {130,0.00049550}, {131,0.00046847}, {132,0.00062162}, {133,0.00034234}, {134,0.00038739}, {135,0.00036937}, {136,0.00050450}, {137,0.00069369}, {138,0.00069369}, {139,0.00147748}, {140,0.00054054}, {141,0.00054054}, {142,0.00043243}, {143,0.00042342}, {144,0.00054054}, {145,0.00049550}, {146,0.00063063}, {147,0.00061261}, {148,0.00047748}, {149,0.00067568}, {150,0.00045045}, {151,0.00066667}, {152,0.00041441}, {153,0.00067568}, {154,0.00044144}, {155,0.00070270}, {156,0.00045045}, {157,0.00055856}, {158,0.00070270}, {159,0.00052252}, {160,0.00064865}, {161,0.00051351}, {162,0.00072072}, {163,0.00065766}, {164,0.00049550}, {165,0.00047748}, {166,0.00078378}, {167,0.00059459}, {168,0.00047748}, {169,0.00056757}, {170,0.00065766}, {171,0.00076577}, {172,0.00052252}, {173,0.00191892}, {174,0.00073874}, {175,0.00032432}, {176,0.00066667}, {177,0.00052252}, {178,0.00058559}, {179,0.00065766}, {180,0.00045946}, {181,0.00069369}, {182,0.00055856}, {183,0.00059459}, {184,0.00054054}, {185,0.00060360}, {186,0.00062162}, {187,0.00052252}, {188,0.00083784}, {189,0.00054955}, {190,0.00062162}, {191,0.00048649}, {192,0.00063063}, {193,0.00061261}, {194,0.00070270}, {195,0.00069369}, {196,0.00060360}, {197,0.00049550}, {198,0.00060360}, {199,0.00062162}, {200,0.00078378}, {201,0.00095495}, {202,0.00057658}, {203,0.00100901}, {204,0.00086486}, {205,0.00068468}, {206,0.00060360}, {207,0.00053153}, {208,0.00062162}, {209,0.00057658}, {210,0.00063964}, {211,0.00062162}, {212,0.00043243}, {213,0.00050450}, {214,0.00052252}, {215,0.00059459}, {216,0.00054054}, {217,0.00062162}, {218,0.00076577}, {219,0.00069369}, {220,0.00076577}, {221,0.00088288}, {222,0.00074775}, {223,0.00081982}, {224,0.00090991}, {225,0.00073874}, {226,0.00070270}, {227,0.00072072}, {228,0.00073874}, {229,0.00066667}, {230,0.00066667}, {231,0.00069369}, {232,0.00064865}, {233,0.00072072}, {234,0.00071171}, {235,0.00068468}, {236,0.00068468}, {237,0.00055856}, {238,0.00054054}, {239,0.00063964}, {240,0.00058559}, {241,0.00063964}, {242,0.00060360}, {243,0.00063063}, {244,0.00050450}, {245,0.00052252}, {246,0.00056757}, {247,0.00069369}, {248,0.00077477}, {249,0.00065766}, {250,0.00067568}, {251,0.00073874}, {252,0.00077477}, {253,0.00090991}, {254,0.00069369}, {255,0.00076577}, {256,0.00072072}, {257,0.00066667}, {258,0.00074775}, {259,0.00068468}, {260,0.00052252}, {261,0.00063964}, {262,0.00078378}, {263,0.00090090}, {264,0.00092793}, {265,0.00069369}, {266,0.00072072}, {267,0.00061261}, {268,0.00064865}, {269,0.00061261}, {270,0.00058559}, {271,0.00096396}, {272,0.00073874}, {273,0.00058559}, {274,0.00063964}, {275,0.00072072}, {276,0.00071171}, {277,0.00086486}, {278,0.00098198}, {279,0.00085586}, {280,0.00061261}, {281,0.00048649}, {282,0.00038739}, {283,0.00076577}, {284,0.00080180}, {285,0.00114414}, {286,0.00090090}, {287,0.00051351}, {288,0.00053153}, {289,0.00084685}, {290,0.00089189}, {291,0.00092793}, {292,0.00064865}, {293,0.00064865}, {294,0.00077477}, {295,0.00081081}, {296,0.00098198}, {297,0.00080180}, {298,0.00074775}, {299,0.00072973}, {300,0.00094595}, {301,0.00079279}, {302,0.00078378}, {303,0.00071171}, {304,0.00080180}, {305,0.00092793}, {306,0.00062162}, {307,0.00078378}, {308,0.00084685}, {309,0.00100901}, {310,0.00081982}, {311,0.00065766}, {312,0.00088288}, {313,0.00075676}, {314,0.00083784}, {315,0.00084685}, {316,0.00093694}, {317,0.00061261}, {318,0.00183784}, {319,0.00082883}, {320,0.00087387}, {321,0.00076577}, {322,0.00079279}, {323,0.00098198}, {324,0.00072973}, {325,0.00073874}, {326,0.00098198}, {327,0.00073874}, {328,0.00104505}, {329,0.00053153}, {330,0.00096396}, {331,0.00076577}, {332,0.00069369}, {333,0.00078378}, {334,0.00070270}, {335,0.00077477}, {336,0.00088288}, {337,0.00218018}, {338,0.00078378}, {339,0.00086486}, {340,0.00093694}, {341,0.00082883}, {342,0.00086486}, {343,0.00084685}, {344,0.00104505}, {345,0.00090991}, {346,0.00069369}, {347,0.00099099}, {348,0.00075676}, {349,0.00071171}, {350,0.00092793}, {351,0.00087387}, {352,0.00063964}, {353,0.00062162}, {354,0.00068468}, {355,0.00084685}, {356,0.00076577}, {357,0.00096396}, {358,0.00097297}, {359,0.00083784}, {360,0.00090991}, {361,0.00077477}, {362,0.00076577}, {363,0.00091892}, {364,0.00092793}, {365,0.00093694}, {366,0.00083784}, {367,0.00102703}, {368,0.00091892}, {369,0.00085586}, {370,0.00078378}, {371,0.00081982}, {372,0.00070270}, {373,0.00082883}, {374,0.00077477}, {375,0.00090090}, {376,0.00100901}, {377,0.00099099}, {378,0.00090991}, {379,0.00126126}, {380,0.00065766}, {381,0.00088288}, {382,0.00105405}, {383,0.00064865}, {384,0.00097297}, {385,0.00073874}, {386,0.00105405}, {387,0.00091892}, {388,0.00097297}, {389,0.00081982}, {390,0.00070270}, {391,0.00092793}, {392,0.00097297}, {393,0.00097297}, {394,0.00127027}, {395,0.00101802}, {396,0.00115315}, {397,0.00085586}, {398,0.00091892}, {399,0.00093694}, {400,0.00087387}, {401,0.00121622}, {402,0.00083784}, {403,0.00118919}, {404,0.00072973}, {405,0.00102703}, {406,0.00081081}, {407,0.00110811}, {408,0.00099099}, {409,0.00082883}, {410,0.00100000}, {411,0.00081081}, {412,0.00111712}, {413,0.00084685}, {414,0.00122523}, {415,0.00090991}, {416,0.00123423}, {417,0.00079279}, {418,0.00097297}, {419,0.00095495}, {420,0.00093694}, {421,0.00109910}, {422,0.00109009}, {423,0.00083784}, {424,0.00119820}, {425,0.00089189}, {426,0.00090991}, {427,0.00090991}, {428,0.00102703}, {429,0.00127027}, {430,0.00111712}, {431,0.00070270}, {432,0.00124324}, {433,0.00098198}, {434,0.00107207}, {435,0.00090090}, {436,0.00086486}, {437,0.00076577}, {438,0.00104505}, {439,0.00089189}, {440,0.00101802}, {441,0.00125225}, {442,0.00093694}, {443,0.00111712}, {444,0.00101802}, {445,0.00088288}, {446,0.00083784}, {447,0.00076577}, {448,0.00109009}, {449,0.00105405}, {450,0.00117117}, {451,0.00094595}, {452,0.00107207}, {453,0.00087387}, {454,0.00104505}, {455,0.00100000}, {456,0.00123423}, {457,0.00101802}, {458,0.00104505}, {459,0.00114414}, {460,0.00094595}, {461,0.00134234}, {462,0.00088288}, {463,0.00089189}, {464,0.00136937}, {465,0.00086486}, {466,0.00092793}, {467,0.00103604}, {468,0.00125225}, {469,0.00115315}, {470,0.00072973}, {471,0.00082883}, {472,0.00141441}, {473,0.00100000}, {474,0.00079279}, {475,0.00108108}, {476,0.00123423}, {477,0.00106306}, {478,0.00093694}, {479,0.00088288}, {480,0.00134234}, {481,0.00106306}, {482,0.00092793}, {483,0.00106306}, {484,0.00109910}, {485,0.00111712}, {486,0.00092793}, {487,0.00101802}, {488,0.00109910}, {489,0.00124324}, {490,0.00093694}, {491,0.00074775}, {492,0.00115315}, {493,0.00128829}, {494,0.00118919}, {495,0.00088288}, {496,0.00108108}, {497,0.00091892}, {498,0.00130631}, {499,0.00110811}, {500,0.00118919}, {505,0.00101802}, {510,0.00096396}, {515,0.00130631}, {520,0.00108108}, {525,0.00082883}, {530,0.00101802}, {535,0.00104505}, {540,0.00094595}, {545,0.00100000}, {550,0.00120721}, {555,0.00122523}, {560,0.00117117}, {565,0.00116216}, {570,0.00108108}, {575,0.00114414}, {580,0.00118018}, {585,0.00135135}, {590,0.00142342}, {595,0.00093694}, {600,0.00083784}, {605,0.00118018}, {610,0.00106306}, {615,0.00125225}, {620,0.00097297}, {625,0.00122523}, {630,0.00098198}, {635,0.00135135}, {640,0.00144144}, {645,0.00137838}, {650,0.00136036}, {655,0.00137838}, {660,0.00109009}, {665,0.00138739}, {670,0.00136937}, {675,0.00136036}, {680,0.00140541}, {685,0.00132432}, {690,0.00144144}, {695,0.00143243}, {700,0.00153153}, {705,0.00109910}, {710,0.00152252}, {715,0.00133333}, {720,0.00170270}, {725,0.00127027}, {730,0.00166667}, {735,0.00122523}, {740,0.00160360}, {745,0.00180180}, {750,0.00120721}, {755,0.00139640}, {760,0.00154054}, {765,0.00127928}, {770,0.00181081}, {775,0.00121622}, {780,0.00154955}, {785,0.00157658}, {790,0.00146847}, {795,0.00162162}, {800,0.00137838}, {805,0.00160360}, {810,0.00171171}, {815,0.00137838}, {820,0.00154955}, {825,0.00136036}, {830,0.00193694}, {835,0.00119820}, {840,0.00154955}, {845,0.00163964}, {850,0.00141441}, {855,0.00166667}, {860,0.00180180}, {865,0.00161261}, {870,0.00159459}, {875,0.00170270}, {880,0.00163964}, {885,0.00174775}, {890,0.00178378}, {895,0.00181081}, {900,0.00184685}, {905,0.00157658}, {910,0.00158559}, {915,0.00182883}, {920,0.00168468}, {925,0.00185586}, {930,0.00178378}, {935,0.00187387}, {940,0.00160360}, {945,0.00184685}, {950,0.00179279}, {955,0.00195495}, {960,0.00202703}, {965,0.00189189}, {970,0.00181081}, {975,0.00189189}, {980,0.00201802}, {985,0.00600000}, {990,0.00172973}, {995,0.00197297}, {1000,0.00172973}, {1010,0.00189189}, {1020,0.00196396}, {1030,0.00181081}, {1040,0.00446847}, {1050,0.00227928}, {1060,0.00187387}, {1070,0.00182883}, {1080,0.00216216}, {1090,0.00180180}, {1100,0.00240541}, {1110,0.00184685}, {1120,0.00226126}, {1130,0.00197297}, {1140,0.00227928}, {1150,0.00214414}, {1160,0.00219820}, {1170,0.00194595}, {1180,0.00236937}, {1190,0.00212613}, {1200,0.00249550}, {1210,0.00249550}, {1220,0.00249550}, {1230,0.00248649}, {1240,0.00256757}, {1250,0.00244144}, {1260,0.00234234}, {1270,0.00239640}, {1280,0.00251351}, {1290,0.00259459}, {1300,0.00290090}, {1310,0.00263063}, {1320,0.00269369}, {1330,0.00245045}, {1340,0.00253153}, {1350,0.00256757}, {1360,0.00269369}, {1370,0.00265766}, {1380,0.00254955}, {1390,0.00705405}, {1400,0.00281982}, {1410,0.00258559}, {1420,0.00252252}, {1430,0.00268468}, {1440,0.00717117}, {1450,0.00263063}, {1460,0.00280180}, {1470,0.00264865}, {1480,0.00283784}, {1490,0.00245045}, {1500,0.00289189}, {1510,0.00278378}, {1520,0.00301802}, {1530,0.00271171}, {1540,0.00269369}, {1550,0.00310811}, {1560,0.00288288}, {1570,0.00298198}, {1580,0.00288288}, {1590,0.00315315}, {1600,0.00305405}, {1610,0.00313514}, {1620,0.00305405}, {1630,0.00311712}, {1640,0.00326126}, {1650,0.00345045}, {1660,0.00327027}, {1670,0.00327928}, {1680,0.00333333}, {1690,0.00294595}, {1700,0.00343243}, {1710,0.00334234}, {1720,0.00329730}, {1730,0.00324324}, {1740,0.00339640}, {1750,0.00329730}, {1760,0.00334234}, {1770,0.00349550}, {1780,0.00339640}, {1790,0.00345045}, {1800,0.00361261}, {1810,0.00347748}, {1820,0.00341441}, {1830,0.00354955}, {1840,0.00354054}, {1850,0.00340541}, {1860,0.00372072}, {1870,0.00359459}, {1880,0.00369369}, {1890,0.00346847}, {1900,0.00372973}, {1910,0.00379279}, {1920,0.00368468}, {1930,0.00368468}, {1940,0.00366667}, {1950,0.00734234}, {1960,0.00364865}, {1970,0.00395495}, {1980,0.00415315}, {1990,0.00370270}, {2000,0.00400000}, {2050,0.00401802}, {2100,0.00404505}, {2150,0.00407207}, {2200,0.00418919}, {2250,0.00448649}, {2300,0.00438739}, {2350,0.00445946}, {2400,0.00476577}, {2450,0.00469369}, {2500,0.00463063}, {2550,0.00563964}, {2600,0.00498198}, {2650,0.00547748}, {2700,0.00540541}, {2750,0.00554054}, {2800,0.00562162}, {2850,0.00580180}, {2900,0.00586486}, {2950,0.00610811}, {3000,0.00581982}, {3050,0.00610811}, {3100,0.00617117}, {3150,0.00665766}, {3200,0.00669369}, {3250,0.00683784}, {3300,0.00674775}, {3350,0.00701802}, {3400,0.00699099}, {3450,0.00751351}, {3500,0.00767568}, {3550,0.00768468}, {3600,0.00797297}, {3650,0.00815315}, {3700,0.00839640}, {3750,0.00792793}, {3800,0.00834234}, {3850,0.00881982}, {3900,0.00899099}, {3950,0.00911712}, {4000,0.00876577}, {4050,0.00936036}, {4100,0.00981081}, {4150,0.00990991}, {4200,0.00841441}, {4250,0.01007207}, {4300,0.01010811}, {4350,0.01057658}, {4400,0.01083784}, {4450,0.02191892}, {4500,0.01096396}, {4550,0.01130631}, {4600,0.01132432}, {4650,0.01178378}, {4700,0.01167568}, {4750,0.01231532}, {4800,0.01178378}, {4850,0.00909910}, {4900,0.01236937}, {4950,0.01230631}, {5000,0.01004505}, {5050,0.01285586}, {5100,0.01272072}, {5150,0.01308108}, {5200,0.01309910}, {5250,0.01325225}, {5300,0.01329730}, {5350,0.02390090}, {5400,0.01357658}, {5450,0.01410811}, {5500,0.01430631}, {5550,0.01459459}, {5600,0.01433333}, {5650,0.01411712}, {5700,0.01453153}, {5750,0.03556757}, {5800,0.01486486}, {5850,0.01501802}, {5900,0.01504505}, {5950,0.01534234}, {6000,0.04203604}, {6050,0.01552252}, {6100,0.01565766}, {6150,0.01610811}, {6200,0.01581081}, {6250,0.01616216}, {6300,0.04132432}, {6350,0.01625225}, {6400,0.01641441}, {6450,0.01656757}, {6500,0.01640541}, {6550,0.01695495}, {6600,0.01694595}, {6650,0.01678378}, {6700,0.03222523}, {6750,0.01779279}, {6800,0.01748649}, {6850,0.01769369}, {6900,0.01774775}, {6950,0.01778378}, {7000,0.01819820}, {7050,0.01801802}, {7100,0.01840541}, {7150,0.01835135}, {7200,0.01820721}, {7250,0.01854955}, {7300,0.01878378}, {7350,0.01873874}, {7400,0.01930631}, {7450,0.01911712}, {7500,0.01927027}, {7550,0.01941441}, {7600,0.01927928}, {7650,0.01982883}, {7700,0.02013514}, {7750,0.02018919}, {7800,0.02041441}, {7850,0.02053153}, {7900,0.02067568}, {7950,0.02092793}, {8000,0.02074775}, {8050,0.04531532}, {8100,0.03513514}, {8150,0.02156757}, {8200,0.02180180}, {8250,0.02172973}, {8300,0.02194595}, {8350,0.02190090}, {8400,0.02245946}, {8450,0.02267568}, {8500,0.04172973}, {8550,0.02277477}, {8600,0.02276577}, {8650,0.02286486}, {8700,0.02304505}, {8750,0.02348649}, {8800,0.04154054}, {8850,0.02339640}, {8900,0.02329730}, {8950,0.02363964}, {9000,0.02390991}, {9050,0.03594595}, {9100,0.02414414}, {9150,0.02419820}, {9200,0.02439640}, {9250,0.05512613}, {9300,0.02471171}, {9350,0.02481081}, {9400,0.02486486}, {9450,0.04223423}, {9500,0.02509910}, {9550,0.02481982}, {9600,0.02572973}, {9650,0.02549550}, {9700,0.02561261}, {9750,0.02566667}, {9800,0.01937838}, {9850,0.02578378}, {9900,0.02585586}, {9950,0.01972973}, {10000,0.02622523}, {10100,0.02645045}, {10200,0.02660360}, {10300,0.02716216}, {10400,0.04967568}, {10500,0.02715315}, {10600,0.02793694}, {10700,0.02780180}, {10800,0.02824324}, {10900,0.02518018}, {11000,0.02895495}, {11100,0.03770270}, {11200,0.02927928}, {11300,0.02272973}, {11400,0.02985586}, {11500,0.03031532}, {11600,0.03032432}, {11700,0.03072973}, {11800,0.07206306}, {11900,0.03118919}, {12000,0.02515315}, {12100,0.03172072}, {12200,0.03235135}, {12300,0.04372973}, {12400,0.03255856}, {12500,0.03278378}, {12600,0.04643243}, {12700,0.03354955}, {12800,0.03374775}, {12900,0.03383784}, {13000,0.07835135}, {13100,0.03431532}, {13200,0.03489189}, {13300,0.03489189}, {13400,0.05427928}, {13500,0.07542342}, {13600,0.03604505}, {13700,0.03613514}, {13800,0.03647748}, {13900,0.03636036}, {14000,0.02791892}, {14100,0.06366667}, {14200,0.06499099}, {14300,0.03775676}, {14400,0.03785586}, {14500,0.03774775}, {14600,0.03815315}, {14700,0.03857658}, {14800,0.03881081}, {14900,0.03895495}, {15000,0.03929730}, {15100,0.03950450}, {15200,0.03976577}, {15300,0.03974775}, {15400,0.04080180}, {15500,0.06773874}, {15600,0.06781982}, {15700,0.05635135}, {15800,0.04100000}, {15900,0.04139640}, {16000,0.04193694}, {16100,0.04221622}, {16200,0.08584685}, {16300,0.05846847}, {16400,0.04307207}, {16500,0.04301802}, {16600,0.04336036}, {16700,0.06986486}, {16800,0.03424324}, {16900,0.04426126}, {17000,0.04464865}, {17100,0.06868468}, {17200,0.04527928}, {17300,0.04531532}, {17400,0.07976577}, {17500,0.04593694}, {17600,0.04632432}, {17700,0.05872973}, {17800,0.04662162}, {17900,3.53590991}, {18000,0.04713514}, {18100,0.04763964}, {18200,0.05331532}, {18300,0.04824324}, {18400,0.06390991}, {18500,0.04863063}, {18600,0.07110811}, {18700,0.04899099}, {18800,0.06434234}, {18900,0.04988288}, {19000,0.05670270}, {19100,0.05039640}, {19200,0.05054054}, {19300,0.08924324}, {19400,0.05097297}, {19500,0.06418919}, {19600,0.05151351}, {19700,0.05141441}, {19800,0.07956757}, {19900,0.05230631}, {20000,0.05267890}};
data["big_flat"]["OCaml"]["reif"]["system"] = {{1,0.00020721}, {2,0.00006306}, {3,0.00007207}, {4,0.00003604}, {5,0.00000000}, {6,0.00007207}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003604}, {13,0.00003604}, {14,0.00003604}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00002703}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00003604}, {25,0.00003604}, {26,0.00000000}, {27,0.00000000}, {28,0.00003604}, {29,0.00010811}, {30,0.00000000}, {31,0.00003604}, {32,0.00003604}, {33,0.00000000}, {34,0.00000000}, {35,0.00002703}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00003604}, {41,0.00000000}, {42,0.00027027}, {43,0.00000000}, {44,0.00002703}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00003604}, {50,0.00000000}, {51,0.00000000}, {52,0.00003604}, {53,0.00003604}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00003604}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00003604}, {69,0.00000000}, {70,0.00000000}, {71,0.00003604}, {72,0.00000000}, {73,0.00003604}, {74,0.00000000}, {75,0.00003604}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00003604}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00003604}, {88,0.00000000}, {89,0.00000000}, {90,0.00003604}, {91,0.00000000}, {92,0.00003604}, {93,0.00000000}, {94,0.00003604}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00014414}, {99,0.00003604}, {100,0.00000000}, {101,0.00000000}, {102,0.00003604}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00007207}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00002703}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00003604}, {131,0.00000000}, {132,0.00000000}, {133,0.00003604}, {134,0.00000000}, {135,0.00000000}, {136,0.00003604}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00003604}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00003604}, {155,0.00000000}, {156,0.00003604}, {157,0.00007207}, {158,0.00003604}, {159,0.00002703}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00002703}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00007207}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00007207}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00003604}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00003604}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00003604}, {209,0.00003604}, {210,0.00000000}, {211,0.00003604}, {212,0.00000000}, {213,0.00003604}, {214,0.00003604}, {215,0.00003604}, {216,0.00000000}, {217,0.00000000}, {218,0.00003604}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00003604}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00003604}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00003604}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00003604}, {250,0.00000000}, {251,0.00003604}, {252,0.00006306}, {253,0.00000000}, {254,0.00007207}, {255,0.00000000}, {256,0.00000000}, {257,0.00003604}, {258,0.00000000}, {259,0.00000000}, {260,0.00003604}, {261,0.00000000}, {262,0.00000000}, {263,0.00003604}, {264,0.00000000}, {265,0.00003604}, {266,0.00003604}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00003604}, {271,0.00000000}, {272,0.00002703}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00003604}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00003604}, {286,0.00003604}, {287,0.00003604}, {288,0.00000000}, {289,0.00000000}, {290,0.00003604}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00003604}, {296,0.00000000}, {297,0.00000000}, {298,0.00002703}, {299,0.00000000}, {300,0.00000000}, {301,0.00003604}, {302,0.00000000}, {303,0.00003604}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00003604}, {312,0.00000000}, {313,0.00003604}, {314,0.00000000}, {315,0.00007207}, {316,0.00000000}, {317,0.00000000}, {318,0.00007207}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00003604}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00003604}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00003604}, {336,0.00003604}, {337,0.00000000}, {338,0.00002703}, {339,0.00003604}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00002703}, {347,0.00000000}, {348,0.00002703}, {349,0.00000000}, {350,0.00007207}, {351,0.00007207}, {352,0.00000000}, {353,0.00000000}, {354,0.00002703}, {355,0.00003604}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00003604}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00003604}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00003604}, {375,0.00003604}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00003604}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00007207}, {402,0.00000000}, {403,0.00003604}, {404,0.00000000}, {405,0.00000000}, {406,0.00003604}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00003604}, {411,0.00003604}, {412,0.00003604}, {413,0.00002703}, {414,0.00003604}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00003604}, {421,0.00003604}, {422,0.00000000}, {423,0.00003604}, {424,0.00000000}, {425,0.00003604}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00003604}, {431,0.00000000}, {432,0.00000000}, {433,0.00003604}, {434,0.00000000}, {435,0.00003604}, {436,0.00000000}, {437,0.00003604}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00002703}, {442,0.00000000}, {443,0.00003604}, {444,0.00003604}, {445,0.00000000}, {446,0.00000000}, {447,0.00003604}, {448,0.00000000}, {449,0.00000000}, {450,0.00006306}, {451,0.00000000}, {452,0.00003604}, {453,0.00003604}, {454,0.00006306}, {455,0.00000000}, {456,0.00000000}, {457,0.00002703}, {458,0.00000000}, {459,0.00003604}, {460,0.00000000}, {461,0.00000000}, {462,0.00003604}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00007207}, {469,0.00000000}, {470,0.00000000}, {471,0.00003604}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00003604}, {476,0.00003604}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00007207}, {483,0.00000000}, {484,0.00002703}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00003604}, {490,0.00000000}, {491,0.00003604}, {492,0.00002703}, {493,0.00000000}, {494,0.00000000}, {495,0.00003604}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00003604}, {500,0.00000000}, {505,0.00000000}, {510,0.00003604}, {515,0.00003604}, {520,0.00000000}, {525,0.00003604}, {530,0.00000000}, {535,0.00000000}, {540,0.00003604}, {545,0.00000000}, {550,0.00003604}, {555,0.00000000}, {560,0.00003604}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00009910}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00003604}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00006306}, {660,0.00003604}, {665,0.00007207}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00003604}, {705,0.00003604}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00003604}, {735,0.00000000}, {740,0.00006306}, {745,0.00000000}, {750,0.00003604}, {755,0.00010811}, {760,0.00003604}, {765,0.00000000}, {770,0.00000000}, {775,0.00003604}, {780,0.00000000}, {785,0.00003604}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00002703}, {825,0.00003604}, {830,0.00000000}, {835,0.00003604}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00002703}, {860,0.00000000}, {865,0.00000000}, {870,0.00003604}, {875,0.00003604}, {880,0.00003604}, {885,0.00000000}, {890,0.00003604}, {895,0.00007207}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00003604}, {930,0.00003604}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00003604}, {965,0.00000000}, {970,0.00000000}, {975,0.00003604}, {980,0.00000000}, {985,0.00021622}, {990,0.00009910}, {995,0.00003604}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00006306}, {1050,0.00000000}, {1060,0.00003604}, {1070,0.00000000}, {1080,0.00003604}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00003604}, {1120,0.00003604}, {1130,0.00003604}, {1140,0.00003604}, {1150,0.00000000}, {1160,0.00006306}, {1170,0.00016216}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00003604}, {1230,0.00000000}, {1240,0.00003604}, {1250,0.00002703}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00003604}, {1300,0.00007207}, {1310,0.00000000}, {1320,0.00007207}, {1330,0.00003604}, {1340,0.00010811}, {1350,0.00007207}, {1360,0.00000000}, {1370,0.00007207}, {1380,0.00000000}, {1390,0.00017117}, {1400,0.00000000}, {1410,0.00003604}, {1420,0.00003604}, {1430,0.00003604}, {1440,0.00013514}, {1450,0.00000000}, {1460,0.00002703}, {1470,0.00003604}, {1480,0.00003604}, {1490,0.00000000}, {1500,0.00003604}, {1510,0.00007207}, {1520,0.00000000}, {1530,0.00003604}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00002703}, {1570,0.00002703}, {1580,0.00010811}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00007207}, {1630,0.00013514}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003604}, {1670,0.00006306}, {1680,0.00000000}, {1690,0.00006306}, {1700,0.00000000}, {1710,0.00007207}, {1720,0.00007207}, {1730,0.00000000}, {1740,0.00003604}, {1750,0.00003604}, {1760,0.00000000}, {1770,0.00003604}, {1780,0.00000000}, {1790,0.00007207}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00003604}, {1830,0.00007207}, {1840,0.00003604}, {1850,0.00018018}, {1860,0.00003604}, {1870,0.00000000}, {1880,0.00002703}, {1890,0.00003604}, {1900,0.00007207}, {1910,0.00003604}, {1920,0.00009910}, {1930,0.00002703}, {1940,0.00000000}, {1950,0.00017117}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00007207}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00007207}, {2350,0.00002703}, {2400,0.00000000}, {2450,0.00007207}, {2500,0.00003604}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00002703}, {2700,0.00002703}, {2750,0.00000000}, {2800,0.00003604}, {2850,0.00007207}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00007207}, {3050,0.00007207}, {3100,0.00007207}, {3150,0.00003604}, {3200,0.00006306}, {3250,0.00010811}, {3300,0.00010811}, {3350,0.00003604}, {3400,0.00000000}, {3450,0.00003604}, {3500,0.00000000}, {3550,0.00007207}, {3600,0.00003604}, {3650,0.00007207}, {3700,0.00007207}, {3750,0.00007207}, {3800,0.00003604}, {3850,0.00003604}, {3900,0.00003604}, {3950,0.00007207}, {4000,0.00003604}, {4050,0.00007207}, {4100,0.00003604}, {4150,0.00014414}, {4200,0.00003604}, {4250,0.00003604}, {4300,0.00009910}, {4350,0.00000000}, {4400,0.00002703}, {4450,0.00045946}, {4500,0.00007207}, {4550,0.00003604}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00007207}, {4800,0.00010811}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00003604}, {5150,0.00007207}, {5200,0.00003604}, {5250,0.00010811}, {5300,0.00000000}, {5350,0.00020721}, {5400,0.00000000}, {5450,0.00003604}, {5500,0.00003604}, {5550,0.00003604}, {5600,0.00007207}, {5650,0.00003604}, {5700,0.00010811}, {5750,0.00042342}, {5800,0.00007207}, {5850,0.00014414}, {5900,0.00003604}, {5950,0.00010811}, {6000,0.00074775}, {6050,0.00000000}, {6100,0.00003604}, {6150,0.00000000}, {6200,0.00002703}, {6250,0.00007207}, {6300,0.00069369}, {6350,0.00000000}, {6400,0.00010811}, {6450,0.00000000}, {6500,0.00007207}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00013514}, {6700,0.00045045}, {6750,0.00000000}, {6800,0.00003604}, {6850,0.00003604}, {6900,0.00010811}, {6950,0.00009910}, {7000,0.00010811}, {7050,0.00000000}, {7100,0.00010811}, {7150,0.00003604}, {7200,0.00006306}, {7250,0.00003604}, {7300,0.00002703}, {7350,0.00006306}, {7400,0.00000000}, {7450,0.00006306}, {7500,0.00003604}, {7550,0.00003604}, {7600,0.00002703}, {7650,0.00000000}, {7700,0.00007207}, {7750,0.00002703}, {7800,0.00009910}, {7850,0.00003604}, {7900,0.00000000}, {7950,0.00003604}, {8000,0.00003604}, {8050,0.00063063}, {8100,0.00035135}, {8150,0.00009009}, {8200,0.00003604}, {8250,0.00014414}, {8300,0.00007207}, {8350,0.00003604}, {8400,0.00010811}, {8450,0.00007207}, {8500,0.00056757}, {8550,0.00007207}, {8600,0.00014414}, {8650,0.00003604}, {8700,0.00003604}, {8750,0.00000000}, {8800,0.00031532}, {8850,0.00014414}, {8900,0.00014414}, {8950,0.00007207}, {9000,0.00003604}, {9050,0.00036036}, {9100,0.00010811}, {9150,0.00003604}, {9200,0.00007207}, {9250,0.00067568}, {9300,0.00013514}, {9350,0.00003604}, {9400,0.00006306}, {9450,0.00060360}, {9500,0.00017117}, {9550,0.00010811}, {9600,0.00007207}, {9650,0.00007207}, {9700,0.00007207}, {9750,0.00007207}, {9800,0.00009910}, {9850,0.00014414}, {9900,0.00003604}, {9950,0.00007207}, {10000,0.00003604}, {10100,0.00007207}, {10200,0.00003604}, {10300,0.00003604}, {10400,0.00089189}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00003604}, {10800,0.00010811}, {10900,0.00003604}, {11000,0.00003604}, {11100,0.00038739}, {11200,0.00002703}, {11300,0.00002703}, {11400,0.00014414}, {11500,0.00000000}, {11600,0.00005405}, {11700,0.00000000}, {11800,0.00003604}, {11900,0.00014414}, {12000,0.00007207}, {12100,0.00003604}, {12200,0.00002703}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00010811}, {12600,0.00007207}, {12700,0.00000000}, {12800,0.00003604}, {12900,0.00003604}, {13000,0.00100000}, {13100,0.00014414}, {13200,0.00000000}, {13300,0.00010811}, {13400,0.00074775}, {13500,0.00043243}, {13600,0.00007207}, {13700,0.00010811}, {13800,0.00014414}, {13900,0.00019820}, {14000,0.00000000}, {14100,0.00079279}, {14200,0.00049550}, {14300,0.00007207}, {14400,0.00003604}, {14500,0.00007207}, {14600,0.00003604}, {14700,0.00007207}, {14800,0.00007207}, {14900,0.00000000}, {15000,0.00018018}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00007207}, {15400,0.00025225}, {15500,0.00031532}, {15600,0.00076577}, {15700,0.00007207}, {15800,0.00016216}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00003604}, {16300,0.00010811}, {16400,0.00003604}, {16500,0.00007207}, {16600,0.00000000}, {16700,0.00010811}, {16800,0.00003604}, {16900,0.00007207}, {17000,0.00007207}, {17100,0.00007207}, {17200,0.00013514}, {17300,0.00003604}, {17400,0.00007207}, {17500,0.00003604}, {17600,0.00003604}, {17700,0.00000000}, {17800,0.00007207}, {17900,0.00257658}, {18000,0.00014414}, {18100,0.00000000}, {18200,0.00007207}, {18300,0.00003604}, {18400,0.00003604}, {18500,0.00010811}, {18600,0.00000000}, {18700,0.00007207}, {18800,0.00000000}, {18900,0.00003604}, {19000,0.00010811}, {19100,0.00003604}, {19200,0.00003604}, {19300,0.00003604}, {19400,0.00000000}, {19500,0.00013514}, {19600,0.00007207}, {19700,0.00007207}, {19800,0.00003604}, {19900,0.00003604}, {20000,0.00000000}};
data["big_flat"]["Parametricity; beta"]["Aggregate"]["real"] = {{1,0.001014218}, {2,0.001000000}, {3,0.001000000}, {4,0.001000000}, {5,0.001000000}, {6,0.001000000}, {7,0.001000000}, {8,0.001000000}, {9,0.001000000}, {10,0.001000000}, {11,0.001004739}, {12,0.001000000}, {13,0.001000000}, {14,0.001000000}, {15,0.001000000}, {16,0.001000000}, {17,0.001000000}, {18,0.001000000}, {19,0.001000000}, {20,0.001000000}, {21,0.001000000}, {22,0.001000000}, {23,0.001000000}, {24,0.001000000}, {25,0.001000000}, {26,0.001004739}, {27,0.001000000}, {28,0.001000000}, {29,0.009469194}, {30,0.001000000}, {31,0.001000000}, {32,0.001000000}, {33,0.008895735}, {34,0.001000000}, {35,0.001000000}, {36,0.001000000}, {37,0.001000000}, {38,0.001000000}, {39,0.001000000}, {40,0.001000000}, {41,0.001000000}, {42,0.001000000}, {43,0.001000000}, {44,0.001000000}, {45,0.001000000}, {46,0.001000000}, {47,0.001000000}, {48,0.001000000}, {49,0.001009479}, {50,0.001000000}, {51,0.001000000}, {52,0.001000000}, {53,0.001004739}, {54,0.001004739}, {55,0.001004739}, {56,0.001000000}, {57,0.001000000}, {58,0.001004739}, {59,0.001000000}, {60,0.001000000}, {61,0.001004739}, {62,0.001018957}, {63,0.001023697}, {64,0.001028436}, {65,0.001014218}, {66,0.001066351}, {67,0.001042654}, {68,0.001104265}, {69,0.001109005}, {70,0.001075829}, {71,0.001142180}, {72,0.001170616}, {73,0.001232227}, {74,0.001203791}, {75,0.001213270}, {76,0.001289100}, {77,0.001312796}, {78,0.001402844}, {79,0.001388626}, {80,0.001478673}, {81,0.001488152}, {82,0.001464455}, {83,0.001582938}, {84,0.001563981}, {85,0.001568720}, {86,0.001587678}, {87,0.001654028}, {88,0.001734597}, {89,0.001739336}, {90,0.001744076}, {91,0.001767773}, {92,0.001786730}, {93,0.001876777}, {94,0.001834123}, {95,0.001905213}, {96,0.001943128}, {97,0.001957346}, {98,0.001962085}, {99,0.001976303}, {100,0.001990521}, {101,0.001995261}, {102,0.002000000}, {103,0.001995261}, {104,0.002009479}, {105,0.001995261}, {106,0.001990521}, {107,0.002000000}, {108,0.002000000}, {109,0.002000000}, {110,0.002000000}, {111,0.002004739}, {112,0.002000000}, {113,0.002000000}, {114,0.002000000}, {115,0.002000000}, {116,0.002000000}, {117,0.002000000}, {118,0.002000000}, {119,0.002009479}, {120,0.002478673}, {121,0.002511848}, {122,0.002000000}, {123,0.002000000}, {124,0.002000000}, {125,0.002000000}, {126,0.002000000}, {127,0.002000000}, {128,0.002000000}, {129,0.002000000}, {130,0.002000000}, {131,0.002000000}, {132,0.002000000}, {133,0.002000000}, {134,0.002000000}, {135,0.002000000}, {136,0.002000000}, {137,0.002000000}, {138,0.002000000}, {139,0.002000000}, {140,0.002000000}, {141,0.002000000}, {142,0.002000000}, {143,0.002000000}, {144,0.002000000}, {145,0.002000000}, {146,0.002000000}, {147,0.002009479}, {148,0.002000000}, {149,0.002000000}, {150,0.002000000}, {151,0.002009479}, {152,0.002018957}, {153,0.002511848}, {154,0.002644550}, {155,0.002004739}, {156,0.002018957}, {157,0.002000000}, {158,0.002014218}, {159,0.002004739}, {160,0.002009479}, {161,0.002014218}, {162,0.002028436}, {163,0.002033175}, {164,0.002047393}, {165,0.002033175}, {166,0.002037915}, {167,0.002061611}, {168,0.002071090}, {169,0.002061611}, {170,0.002104265}, {171,0.002123223}, {172,0.002151659}, {173,0.002170616}, {174,0.002246445}, {175,0.002222749}, {176,0.002270142}, {177,0.002274882}, {178,0.002308057}, {179,0.002327014}, {180,0.002331754}, {181,0.002369668}, {182,0.003203791}, {183,0.002957346}, {184,0.002436019}, {185,0.002454976}, {186,0.002488152}, {187,0.002483412}, {188,0.002554502}, {189,0.002526066}, {190,0.002559242}, {191,0.002578199}, {192,0.002620853}, {193,0.002668246}, {194,0.002682464}, {195,0.002701422}, {196,0.002744076}, {197,0.002729858}, {198,0.002791469}, {199,0.002824645}, {200,0.002824645}, {201,0.002848341}, {202,0.002890995}, {203,0.002952607}, {204,0.002933649}, {205,0.002928910}, {206,0.002947867}, {207,0.002952607}, {208,0.002943128}, {209,0.003729858}, {210,0.002966825}, {211,0.002966825}, {212,0.002990521}, {213,0.002976303}, {214,0.002976303}, {215,0.002985782}, {216,0.002995261}, {217,0.002995261}, {218,0.002990521}, {219,0.002990521}, {220,0.003000000}, {221,0.003000000}, {222,0.003000000}, {223,0.003004739}, {224,0.003000000}, {225,0.003000000}, {226,0.003000000}, {227,0.003000000}, {228,0.003000000}, {229,0.003000000}, {230,0.003000000}, {231,0.003000000}, {232,0.003014218}, {233,0.004293839}, {234,0.003000000}, {235,0.003000000}, {236,0.003000000}, {237,0.003000000}, {238,0.003000000}, {239,0.003000000}, {240,0.003000000}, {241,0.003000000}, {242,0.003000000}, {243,0.003004739}, {244,0.003014218}, {245,0.003004739}, {246,0.003000000}, {247,0.003000000}, {248,0.003009479}, {249,0.003000000}, {250,0.003014218}, {251,0.003014218}, {252,0.003009479}, {253,0.003009479}, {254,0.003018957}, {255,0.003004739}, {256,0.003976303}, {257,0.003009479}, {258,0.003000000}, {259,0.003018957}, {260,0.003023697}, {261,0.003014218}, {262,0.003033175}, {263,0.003037915}, {264,0.003037915}, {265,0.003056872}, {266,0.003047393}, {267,0.003047393}, {268,0.003071090}, {269,0.003080569}, {270,0.003094787}, {271,0.003080569}, {272,0.003085308}, {273,0.003094787}, {274,0.003170616}, {275,0.003175355}, {276,0.003180095}, {277,0.004113744}, {278,0.003194313}, {279,0.003241706}, {280,0.003265403}, {281,0.003274882}, {282,0.003298578}, {283,0.003322275}, {284,0.003364929}, {285,0.003374408}, {286,0.003369668}, {287,0.003398104}, {288,0.003426540}, {289,0.003393365}, {290,0.003436019}, {291,0.003431280}, {292,0.003454976}, {293,0.003488152}, {294,0.003488152}, {295,0.003488152}, {296,0.003507109}, {297,0.004488152}, {298,0.003559242}, {299,0.003559242}, {300,0.003554502}, {301,0.003587678}, {302,0.003620853}, {303,0.003639810}, {304,0.003658768}, {305,0.003706161}, {306,0.003720379}, {307,0.003781991}, {308,0.003753555}, {309,0.003763033}, {310,0.003767773}, {311,0.003824645}, {312,0.003886256}, {313,0.003829384}, {314,0.003900474}, {315,0.003905213}, {316,0.004777251}, {317,0.003909953}, {318,0.003914692}, {319,0.003924171}, {320,0.003928910}, {321,0.003924171}, {322,0.003938389}, {323,0.003933649}, {324,0.003952607}, {325,0.003943128}, {326,0.003938389}, {327,0.003943128}, {328,0.003938389}, {329,0.003957346}, {330,0.003971564}, {331,0.003966825}, {332,0.003976303}, {333,0.003985782}, {334,0.004947867}, {335,0.003985782}, {336,0.003990521}, {337,0.003990521}, {338,0.004000000}, {339,0.004004739}, {340,0.004009479}, {341,0.004000000}, {342,0.004000000}, {343,0.004004739}, {344,0.004000000}, {345,0.004004739}, {346,0.004009479}, {347,0.004014218}, {348,0.004004739}, {349,0.004004739}, {350,0.004014218}, {351,0.004573460}, {352,0.004426540}, {353,0.004000000}, {354,0.004004739}, {355,0.004000000}, {356,0.004009479}, {357,0.004009479}, {358,0.004004739}, {359,0.004004739}, {360,0.004023697}, {361,0.004018957}, {362,0.004009479}, {363,0.004033175}, {364,0.004042654}, {365,0.004018957}, {366,0.004080569}, {367,0.004056872}, {368,0.004729858}, {369,0.004563981}, {370,0.004075829}, {371,0.004085308}, {372,0.004104265}, {373,0.004094787}, {374,0.004099526}, {375,0.004104265}, {376,0.004146919}, {377,0.004123223}, {378,0.004118483}, {379,0.004146919}, {380,0.004199052}, {381,0.004184834}, {382,0.004175355}, {383,0.004246445}, {384,0.004952607}, {385,0.004786730}, {386,0.004298578}, {387,0.004293839}, {388,0.004303318}, {389,0.004322275}, {390,0.004336493}, {391,0.004336493}, {392,0.004383886}, {393,0.004374408}, {394,0.004383886}, {395,0.004360190}, {396,0.004383886}, {397,0.004407583}, {398,0.004431280}, {399,0.004436019}, {400,0.004909953}, {401,0.004440758}, {402,0.004497630}, {403,0.004459716}, {404,0.004488152}, {405,0.004483412}, {406,0.004516588}, {407,0.004521327}, {408,0.004545024}, {409,0.004573460}, {410,0.004549763}, {411,0.004592417}, {412,0.004635071}, {413,0.004616114}, {414,0.004635071}, {415,0.005189573}, {416,0.005251185}, {417,0.004701422}, {418,0.004763033}, {419,0.004781991}, {420,0.004763033}, {421,0.004810427}, {422,0.004800948}, {423,0.004834123}, {424,0.004853081}, {425,0.004886256}, {426,0.004890995}, {427,0.004890995}, {428,0.004886256}, {429,0.004919431}, {430,0.005341232}, {431,0.004924171}, {432,0.004909953}, {433,0.004914692}, {434,0.004933649}, {435,0.004924171}, {436,0.004919431}, {437,0.004919431}, {438,0.004924171}, {439,0.004933649}, {440,0.004938389}, {441,0.004947867}, {442,0.004938389}, {443,0.004957346}, {444,0.005957346}, {445,0.005526066}, {446,0.004947867}, {447,0.004952607}, {448,0.004957346}, {449,0.004971564}, {450,0.004966825}, {451,0.004971564}, {452,0.004976303}, {453,0.004971564}, {454,0.004985782}, {455,0.004985782}, {456,0.004995261}, {457,0.005023697}, {458,0.005966825}, {459,0.005445498}, {460,0.005042654}, {461,0.005004739}, {462,0.005023697}, {463,0.005014218}, {464,0.005028436}, {465,0.005023697}, {466,0.005042654}, {467,0.005037915}, {468,0.005052133}, {469,0.005056872}, {470,0.005052133}, {471,0.005071090}, {472,0.005530806}, {473,0.005109005}, {474,0.005099526}, {475,0.005047393}, {476,0.005094787}, {477,0.005118483}, {478,0.005132701}, {479,0.005151659}, {480,0.005146919}, {481,0.005142180}, {482,0.005199052}, {483,0.005175355}, {484,0.005199052}, {485,0.005881517}, {486,0.005981043}, {487,0.005232227}, {488,0.005246445}, {489,0.005232227}, {490,0.005289100}, {491,0.005265403}, {492,0.005251185}, {493,0.005260664}, {494,0.005236967}, {495,0.005284360}, {496,0.005331754}, {497,0.005364929}, {498,0.005924171}, {499,0.005843602}, {500,0.005369668}, {505,0.005398104}, {510,0.005407583}, {515,0.005488152}, {520,0.005578199}, {525,0.005663507}, {530,0.005734597}, {535,0.005786730}, {540,0.005886256}, {545,0.005928910}, {550,0.006601896}, {555,0.006601896}, {560,0.005957346}, {565,0.005981043}, {570,0.006004739}, {575,0.006066351}, {580,0.006094787}, {585,0.006156398}, {590,0.006222749}, {595,0.006255924}, {600,0.006317536}, {605,0.006341232}, {610,0.006611374}, {615,0.006445498}, {620,0.006478673}, {625,0.006521327}, {630,0.006578199}, {635,0.006649289}, {640,0.006763033}, {645,0.006857820}, {650,0.006867299}, {655,0.006933649}, {660,0.007701422}, {665,0.007450237}, {670,0.006990521}, {675,0.007000000}, {680,0.007037915}, {685,0.007123223}, {690,0.007170616}, {695,0.007236967}, {700,0.007289100}, {705,0.007355450}, {710,0.007895735}, {715,0.007781991}, {720,0.007421801}, {725,0.007464455}, {730,0.007478673}, {735,0.007540284}, {740,0.007606635}, {745,0.007668246}, {750,0.007763033}, {755,0.008592417}, {760,0.008379147}, {765,0.007900474}, {770,0.007928910}, {775,0.007943128}, {780,0.007995261}, {785,0.008037915}, {790,0.008090047}, {795,0.008161137}, {800,0.008791469}, {805,0.008241706}, {810,0.008336493}, {815,0.008350711}, {820,0.008407583}, {825,0.008412322}, {830,0.008445498}, {835,0.008478673}, {840,0.010037915}, {845,0.009355450}, {850,0.008625592}, {855,0.008739336}, {860,0.008834123}, {865,0.008886256}, {870,0.008900474}, {875,0.008914692}, {880,0.010492891}, {885,0.009568720}, {890,0.009052133}, {895,0.009127962}, {900,0.009156398}, {905,0.009213270}, {910,0.009270142}, {915,0.009312796}, {920,0.010336493}, {925,0.009360190}, {930,0.009383886}, {935,0.009426540}, {940,0.009454976}, {945,0.009478673}, {950,0.009535545}, {955,0.011691943}, {960,0.010279621}, {965,0.009753555}, {970,0.009772512}, {975,0.009881517}, {980,0.009924171}, {985,0.009919431}, {990,0.011824645}, {995,0.010654028}, {1000,0.010066351}, {1010,0.010189573}, {1020,0.010274882}, {1030,0.010355450}, {1040,0.010402844}, {1050,0.012071090}, {1060,0.011255924}, {1070,0.010677725}, {1080,0.010786730}, {1090,0.010933649}, {1100,0.011042654}, {1110,0.011156398}, {1120,0.013781991}, {1130,0.011303318}, {1140,0.011360190}, {1150,0.011398104}, {1160,0.011521327}, {1170,0.011620853}, {1180,0.013516588}, {1190,0.011881517}, {1200,0.011976303}, {1210,0.012094787}, {1220,0.012156398}, {1230,0.012241706}, {1240,0.014146919}, {1250,0.012369668}, {1260,0.012421801}, {1270,0.012526066}, {1280,0.012677725}, {1290,0.014853081}, {1300,0.013962085}, {1310,0.012985782}, {1320,0.013090047}, {1330,0.013180095}, {1340,0.013308057}, {1350,0.016715640}, {1360,0.013383886}, {1370,0.013469194}, {1380,0.013568720}, {1390,0.013687204}, {1400,0.016710900}, {1410,0.013947867}, {1420,0.014033175}, {1430,0.014104265}, {1440,0.014151659}, {1450,0.016867299}, {1460,0.014312796}, {1470,0.014388626}, {1480,0.014497630}, {1490,0.014639810}, {1500,0.018933649}, {1510,0.014895735}, {1520,0.015014218}, {1530,0.015094787}, {1540,0.016530806}, {1550,0.016876777}, {1560,0.015322275}, {1570,0.015364929}, {1580,0.015398104}, {1590,0.016725118}, {1600,0.015668246}, {1610,0.015781991}, {1620,0.015933649}, {1630,0.017677725}, {1640,0.017161137}, {1650,0.016227488}, {1660,0.016241706}, {1670,0.016322275}, {1680,0.018938389}, {1690,0.016478673}, {1700,0.016582938}, {1710,0.016739336}, {1720,0.018805687}, {1730,0.016872038}, {1740,0.017123223}, {1750,0.017137441}, {1760,0.019819905}, {1770,0.018260664}, {1780,0.017364929}, {1790,0.017431280}, {1800,0.020265403}, {1810,0.018260664}, {1820,0.017800948}, {1830,0.017909953}, {1840,0.020843602}, {1850,0.018672986}, {1860,0.018170616}, {1870,0.018222749}, {1880,0.020729858}, {1890,0.018753555}, {1900,0.018436019}, {1910,0.018535545}, {1920,0.022772512}, {1930,0.018857820}, {1940,0.018985782}, {1950,0.019090047}, {1960,0.022127962}, {1970,0.019203791}, {1980,0.019255924}, {1990,0.021156398}, {2000,0.021919431}, {2050,0.020061611}, {2100,0.020393365}, {2150,0.024540284}, {2200,0.021393365}, {2250,0.021876777}, {2300,0.025488152}, {2350,0.023473934}, {2400,0.023298578}, {2450,0.027355450}, {2500,0.024914692}, {2550,0.024781991}, {2600,0.029488152}, {2650,0.025677725}, {2700,0.026303318}, {2750,0.032947867}, {2800,0.027251185}, {2850,0.027725118}, {2900,0.029554502}, {2950,0.028649289}, {3000,0.034298578}, {3050,0.029720379}, {3100,0.033132701}, {3150,0.031971564}, {3200,0.031218009}, {3250,0.034834123}, {3300,0.032265403}, {3350,0.036663507}, {3400,0.033222749}, {3450,0.038426540}, {3500,0.034241706}, {3550,0.040317536}, {3600,0.035639810}, {3650,0.038976303}, {3700,0.037037915}, {3750,0.039691943}, {3800,0.037786730}, {3850,0.041606635}, {3900,0.037815166}, {3950,0.047127962}, {4000,0.039317536}, {4050,0.047080569}, {4100,0.040255924}, {4150,0.046421801}, {4200,0.041317536}, {4250,0.047180095}, {4300,0.046341232}, {4350,0.043616114}, {4400,0.050123223}, {4450,0.044004739}, {4500,0.051725118}, {4550,0.050251185}, {4600,0.046554502}, {4650,0.052123223}, {4700,0.046587678}, {4750,0.050530806}, {4800,0.056739336}, {4850,0.048236967}, {4900,0.055293839}, {4950,0.053047393}, {5000,0.049810427}, {5050,0.055943128}, {5100,0.059616114}, {5150,0.051554502}, {5200,0.057478673}, {5250,0.061246445}, {5300,0.053227488}, {5350,0.054739336}, {5400,0.064777251}, {5450,0.061213270}, {5500,0.055246445}, {5550,0.061995261}, {5600,0.067322275}, {5650,0.063436019}, {5700,0.057218009}, {5750,0.062232227}, {5800,0.070052133}, {5850,0.072725118}, {5900,0.060127962}, {5950,0.061417062}, {6000,0.068720379}, {6050,0.078649289}, {6100,0.075398104}, {6150,0.063066351}, {6200,0.064459716}, {6250,0.068284360}, {6300,0.070995261}, {6350,0.073848341}, {6400,0.077928910}, {6450,0.075071090}, {6500,0.068028436}, {6550,0.070369668}, {6600,0.074568720}, {6650,0.075175355}, {6700,0.082383886}, {6750,0.084080569}, {6800,0.089369668}, {6850,0.082255924}, {6900,0.078895735}, {6950,0.071687204}, {7000,0.074464455}, {7050,0.074199052}, {7100,0.078094787}, {7150,0.081938389}, {7200,0.081222749}, {7250,0.081819905}, {7300,0.089023697}, {7350,0.088483412}, {7400,0.084341232}, {7450,0.085402844}, {7500,0.086341232}, {7550,0.086985782}, {7600,0.087165877}, {7650,0.087350711}, {7700,0.090090047}, {7750,0.091146919}, {7800,0.091966825}, {7850,0.092810427}, {7900,0.089753555}, {7950,0.089464455}, {8000,0.091758294}, {8050,0.087398104}, {8100,0.095393365}, {8150,0.093853081}, {8200,0.101549763}, {8250,0.108279621}, {8300,0.107791469}, {8350,0.105734597}, {8400,0.102559242}, {8450,0.098246445}, {8500,0.101345972}, {8550,0.101061611}, {8600,0.107199052}, {8650,0.112331754}, {8700,0.115710900}, {8750,0.107933649}, {8800,0.102507109}, {8850,0.104402844}, {8900,0.109104265}, {8950,0.114004739}, {9000,0.118004739}, {9050,0.112208531}, {9100,0.106061611}, {9150,0.111417062}, {9200,0.122085308}, {9250,0.121924171}, {9300,0.114834123}, {9350,0.115161137}, {9400,0.121303318}, {9450,0.124976303}, {9500,0.120635071}, {9550,0.119398104}, {9600,0.134540284}, {9650,0.125469194}, {9700,0.121161137}, {9750,0.128099526}, {9800,0.126549763}, {9850,0.126146919}, {9900,0.119388626}, {9950,0.132127962}, {10000,0.128753555}, {10100,0.121137441}, {10200,0.135317536}, {10300,0.133232227}, {10400,0.132781991}, {10500,0.138853081}, {10600,0.140232227}, {10700,0.146180095}, {10800,0.137763033}, {10900,0.139274882}, {11000,0.139872038}, {11100,0.139952607}, {11200,0.142113744}, {11300,0.150402844}, {11400,0.146284360}, {11500,0.154701422}, {11600,0.145170616}, {11700,0.146109005}, {11800,0.149284360}, {11900,0.161488152}, {12000,0.165815166}, {12100,0.160331754}, {12200,0.166507109}, {12300,0.156000000}, {12400,0.170734597}, {12500,0.167099526}, {12600,0.160672986}, {12700,0.174616114}, {12800,0.173270142}, {12900,0.165085308}, {13000,0.176587678}, {13100,0.188545024}, {13200,0.175398104}, {13300,0.173402844}, {13400,0.181781991}, {13500,0.195289100}, {13600,0.187606635}, {13700,0.177625592}, {13800,0.178530806}, {13900,0.192924171}, {14000,0.216672986}, {14100,0.198829384}, {14200,0.190791469}, {14300,0.182933649}, {14400,0.189976303}, {14500,0.197796209}, {14600,0.192867299}, {14700,0.207289100}, {14800,0.213881517}, {14900,0.216421801}, {15000,0.216090047}, {15100,0.223497630}, {15200,0.224848341}, {15300,0.227199052}, {15400,0.223824645}, {15500,0.218824645}, {15600,0.218521327}, {15700,0.213734597}, {15800,0.213298578}, {15900,0.211360190}, {16000,0.206739336}, {16100,0.221530806}, {16200,0.236402844}, {16300,0.248772512}, {16400,0.238545024}, {16500,1.747696682}, {16600,0.225905213}, {16700,0.230383886}, {16800,0.247336493}, {16900,0.247696682}, {17000,0.239696682}, {17100,0.244028436}, {17200,0.256071090}, {17300,0.253819905}, {17400,0.260909953}, {17500,0.247526066}, {17600,0.256417062}, {17700,0.246582938}, {17800,0.251592417}, {17900,0.260113744}, {18000,0.260625592}, {18100,0.264445498}, {18200,0.257796209}, {18300,0.246554502}, {18400,0.270616114}, {18500,0.262056872}, {18600,0.283109005}, {18700,0.256957346}, {18800,0.281895735}, {18900,0.277094787}, {19000,0.282962085}, {19100,0.278265403}, {19200,0.294530806}, {19300,0.261203791}, {19400,0.290037915}, {19500,0.282516588}, {19600,0.282417062}, {19700,0.287976303}, {19800,0.271985782}, {19900,0.303658768}, {20000,0.277114833}};
data["big_flat"]["Parametricity; beta"]["Aggregate"]["user"] = {{1,0.000483412}, {2,0.000981043}, {3,0.000815166}, {4,0.001028436}, {5,0.001075829}, {6,0.001037915}, {7,0.001189573}, {8,0.001042654}, {9,0.001052133}, {10,0.001066351}, {11,0.001246445}, {12,0.001099526}, {13,0.001075829}, {14,0.001109005}, {15,0.001085308}, {16,0.001317536}, {17,0.001222749}, {18,0.001274882}, {19,0.001184834}, {20,0.001360190}, {21,0.001175355}, {22,0.001293839}, {23,0.001270142}, {24,0.001592417}, {25,0.001161137}, {26,0.001417062}, {27,0.001170616}, {28,0.001317536}, {29,0.009184834}, {30,0.001327014}, {31,0.001199052}, {32,0.001388626}, {33,0.008900474}, {34,0.001459716}, {35,0.001199052}, {36,0.001426540}, {37,0.001350711}, {38,0.001421801}, {39,0.001360190}, {40,0.001421801}, {41,0.001317536}, {42,0.001374408}, {43,0.001308057}, {44,0.001383886}, {45,0.001374408}, {46,0.001492891}, {47,0.001331754}, {48,0.001582938}, {49,0.001355450}, {50,0.001668246}, {51,0.001398104}, {52,0.001578199}, {53,0.001497630}, {54,0.001582938}, {55,0.001554502}, {56,0.001445498}, {57,0.001687204}, {58,0.001436019}, {59,0.001540284}, {60,0.001606635}, {61,0.001587678}, {62,0.001582938}, {63,0.001559242}, {64,0.001601896}, {65,0.001725118}, {66,0.001497630}, {67,0.001819905}, {68,0.001568720}, {69,0.001758294}, {70,0.001872038}, {71,0.001488152}, {72,0.001781991}, {73,0.001597156}, {74,0.001748815}, {75,0.001767773}, {76,0.001559242}, {77,0.001796209}, {78,0.001786730}, {79,0.001597156}, {80,0.001895735}, {81,0.001843602}, {82,0.001734597}, {83,0.001862559}, {84,0.001758294}, {85,0.001691943}, {86,0.001952607}, {87,0.001573460}, {88,0.001838863}, {89,0.001824645}, {90,0.001805687}, {91,0.001962085}, {92,0.001777251}, {93,0.001895735}, {94,0.001914692}, {95,0.001549763}, {96,0.002113744}, {97,0.001943128}, {98,0.001563981}, {99,0.002194313}, {100,0.001890995}, {101,0.001706161}, {102,0.002180095}, {103,0.001881517}, {104,0.001900474}, {105,0.001924171}, {106,0.001952607}, {107,0.001995261}, {108,0.002056872}, {109,0.001890995}, {110,0.002104265}, {111,0.002203791}, {112,0.002052133}, {113,0.001895735}, {114,0.002066351}, {115,0.002018957}, {116,0.001909953}, {117,0.002175355}, {118,0.002142180}, {119,0.001976303}, {120,0.002516588}, {121,0.002616114}, {122,0.002260664}, {123,0.001962085}, {124,0.002132701}, {125,0.002156398}, {126,0.002180095}, {127,0.001966825}, {128,0.002327014}, {129,0.002165877}, {130,0.001933649}, {131,0.002132701}, {132,0.002331754}, {133,0.002246445}, {134,0.002142180}, {135,0.002151659}, {136,0.002398104}, {137,0.002364929}, {138,0.002374408}, {139,0.002080569}, {140,0.002194313}, {141,0.002388626}, {142,0.002412322}, {143,0.002360190}, {144,0.002227488}, {145,0.002161137}, {146,0.002369668}, {147,0.002388626}, {148,0.002279621}, {149,0.002289100}, {150,0.002393365}, {151,0.002327014}, {152,0.002545024}, {153,0.003014218}, {154,0.002995261}, {155,0.002388626}, {156,0.002293839}, {157,0.002436019}, {158,0.002483412}, {159,0.002483412}, {160,0.002497630}, {161,0.002492891}, {162,0.002454976}, {163,0.002559242}, {164,0.002436019}, {165,0.002279621}, {166,0.002436019}, {167,0.002597156}, {168,0.002639810}, {169,0.002668246}, {170,0.002407583}, {171,0.002464455}, {172,0.002573460}, {173,0.002478673}, {174,0.002682464}, {175,0.002620853}, {176,0.002682464}, {177,0.002379147}, {178,0.002492891}, {179,0.002715640}, {180,0.002668246}, {181,0.002706161}, {182,0.003236967}, {183,0.003255924}, {184,0.002630332}, {185,0.002725118}, {186,0.002853081}, {187,0.002563981}, {188,0.002431280}, {189,0.002563981}, {190,0.002763033}, {191,0.002720379}, {192,0.002791469}, {193,0.002682464}, {194,0.002654028}, {195,0.002701422}, {196,0.002829384}, {197,0.002843602}, {198,0.002739336}, {199,0.002763033}, {200,0.002734597}, {201,0.002763033}, {202,0.002857820}, {203,0.002862559}, {204,0.003018957}, {205,0.003085308}, {206,0.002909953}, {207,0.002862559}, {208,0.002952607}, {209,0.003895735}, {210,0.002800948}, {211,0.002767773}, {212,0.002701422}, {213,0.002943128}, {214,0.002881517}, {215,0.002838863}, {216,0.003014218}, {217,0.002838863}, {218,0.002881517}, {219,0.002857820}, {220,0.002715640}, {221,0.002867299}, {222,0.002815166}, {223,0.002729858}, {224,0.002786730}, {225,0.002819905}, {226,0.002857820}, {227,0.002905213}, {228,0.003028436}, {229,0.003004739}, {230,0.003071090}, {231,0.003047393}, {232,0.003132701}, {233,0.004549763}, {234,0.003090047}, {235,0.003132701}, {236,0.003109005}, {237,0.002947867}, {238,0.002995261}, {239,0.003085308}, {240,0.003118483}, {241,0.003175355}, {242,0.003208531}, {243,0.003109005}, {244,0.003052133}, {245,0.003109005}, {246,0.003213270}, {247,0.003071090}, {248,0.003298578}, {249,0.003298578}, {250,0.003289100}, {251,0.003146919}, {252,0.003199052}, {253,0.003056872}, {254,0.003189573}, {255,0.003113744}, {256,0.003895735}, {257,0.003175355}, {258,0.003165877}, {259,0.003104265}, {260,0.003274882}, {261,0.003336493}, {262,0.003251185}, {263,0.003284360}, {264,0.003270142}, {265,0.003260664}, {266,0.003431280}, {267,0.003251185}, {268,0.003393365}, {269,0.003265403}, {270,0.003279621}, {271,0.003327014}, {272,0.003265403}, {273,0.003398104}, {274,0.003521327}, {275,0.003379147}, {276,0.003454976}, {277,0.004118483}, {278,0.003483412}, {279,0.003369668}, {280,0.003436019}, {281,0.003464455}, {282,0.003469194}, {283,0.003545024}, {284,0.003450237}, {285,0.003573460}, {286,0.003454976}, {287,0.003540284}, {288,0.003521327}, {289,0.003559242}, {290,0.003568720}, {291,0.003563981}, {292,0.003635071}, {293,0.003540284}, {294,0.003587678}, {295,0.003616114}, {296,0.003578199}, {297,0.004379147}, {298,0.003654028}, {299,0.003573460}, {300,0.003677725}, {301,0.003606635}, {302,0.003540284}, {303,0.003710900}, {304,0.003625592}, {305,0.003758294}, {306,0.003672986}, {307,0.003701422}, {308,0.003668246}, {309,0.003753555}, {310,0.003649289}, {311,0.003696682}, {312,0.003763033}, {313,0.003706161}, {314,0.003777251}, {315,0.003796209}, {316,0.004725118}, {317,0.003781991}, {318,0.003819905}, {319,0.003696682}, {320,0.003819905}, {321,0.003895735}, {322,0.003895735}, {323,0.003867299}, {324,0.004000000}, {325,0.003767773}, {326,0.003829384}, {327,0.003824645}, {328,0.003853081}, {329,0.003815166}, {330,0.003881517}, {331,0.003815166}, {332,0.003985782}, {333,0.003867299}, {334,0.004886256}, {335,0.003990521}, {336,0.003853081}, {337,0.003900474}, {338,0.004090047}, {339,0.003995261}, {340,0.004000000}, {341,0.004146919}, {342,0.003995261}, {343,0.004028436}, {344,0.004028436}, {345,0.003943128}, {346,0.004227488}, {347,0.004028436}, {348,0.004004739}, {349,0.003985782}, {350,0.004009479}, {351,0.004289100}, {352,0.004507109}, {353,0.003971564}, {354,0.004218009}, {355,0.004180095}, {356,0.004061611}, {357,0.004170616}, {358,0.003990521}, {359,0.004118483}, {360,0.004146919}, {361,0.004137441}, {362,0.004161137}, {363,0.004052133}, {364,0.004180095}, {365,0.004208531}, {366,0.004099526}, {367,0.004284360}, {368,0.004777251}, {369,0.004511848}, {370,0.004317536}, {371,0.004232227}, {372,0.004151659}, {373,0.004355450}, {374,0.004236967}, {375,0.004109005}, {376,0.004289100}, {377,0.004146919}, {378,0.004289100}, {379,0.004293839}, {380,0.004355450}, {381,0.003914692}, {382,0.004364929}, {383,0.004322275}, {384,0.004957346}, {385,0.004857820}, {386,0.004516588}, {387,0.004374408}, {388,0.004127962}, {389,0.004251185}, {390,0.004511848}, {391,0.004412322}, {392,0.004298578}, {393,0.004369668}, {394,0.004412322}, {395,0.004218009}, {396,0.004398104}, {397,0.004454976}, {398,0.004322275}, {399,0.004635071}, {400,0.004777251}, {401,0.004625592}, {402,0.004407583}, {403,0.004478673}, {404,0.004355450}, {405,0.004625592}, {406,0.004402844}, {407,0.004573460}, {408,0.004530806}, {409,0.004644550}, {410,0.004530806}, {411,0.004497630}, {412,0.004663507}, {413,0.004445498}, {414,0.004630332}, {415,0.004909953}, {416,0.005061611}, {417,0.004739336}, {418,0.004549763}, {419,0.004758294}, {420,0.004530806}, {421,0.004781991}, {422,0.004616114}, {423,0.004582938}, {424,0.004739336}, {425,0.004649289}, {426,0.004905213}, {427,0.004597156}, {428,0.004696682}, {429,0.004682464}, {430,0.005052133}, {431,0.004739336}, {432,0.004772512}, {433,0.004744076}, {434,0.004758294}, {435,0.004682464}, {436,0.004729858}, {437,0.004734597}, {438,0.004800948}, {439,0.004810427}, {440,0.004701422}, {441,0.004928910}, {442,0.004781991}, {443,0.004933649}, {444,0.005625592}, {445,0.005502370}, {446,0.004938389}, {447,0.004819905}, {448,0.005004739}, {449,0.004781991}, {450,0.004862559}, {451,0.004819905}, {452,0.004981043}, {453,0.004492891}, {454,0.005042654}, {455,0.004857820}, {456,0.004838863}, {457,0.005118483}, {458,0.005725118}, {459,0.005350711}, {460,0.004976303}, {461,0.005109005}, {462,0.004829384}, {463,0.004966825}, {464,0.005004739}, {465,0.005066351}, {466,0.005037915}, {467,0.005075829}, {468,0.005014218}, {469,0.004872038}, {470,0.005085308}, {471,0.005194313}, {472,0.005445498}, {473,0.004962085}, {474,0.005014218}, {475,0.005194313}, {476,0.004933649}, {477,0.005075829}, {478,0.005142180}, {479,0.005222749}, {480,0.005165877}, {481,0.005142180}, {482,0.005028436}, {483,0.005232227}, {484,0.005104265}, {485,0.005649289}, {486,0.005767773}, {487,0.005317536}, {488,0.005037915}, {489,0.005175355}, {490,0.005436019}, {491,0.005132701}, {492,0.005042654}, {493,0.005303318}, {494,0.005540284}, {495,0.005374408}, {496,0.005066351}, {497,0.005398104}, {498,0.005796209}, {499,0.005763033}, {500,0.005336493}, {505,0.005023697}, {510,0.005478673}, {515,0.005535545}, {520,0.005303318}, {525,0.005464455}, {530,0.005554502}, {535,0.005668246}, {540,0.005744076}, {545,0.005616114}, {550,0.006341232}, {555,0.006526066}, {560,0.006071090}, {565,0.005962085}, {570,0.005867299}, {575,0.005947867}, {580,0.006075829}, {585,0.006146919}, {590,0.006056872}, {595,0.006042654}, {600,0.006080569}, {605,0.006194313}, {610,0.006327014}, {615,0.006109005}, {620,0.006104265}, {625,0.006170616}, {630,0.006402844}, {635,0.006417062}, {640,0.006393365}, {645,0.006639810}, {650,0.006611374}, {655,0.006582938}, {660,0.007502370}, {665,0.007189573}, {670,0.006753555}, {675,0.006772512}, {680,0.006601896}, {685,0.006687204}, {690,0.006800948}, {695,0.006886256}, {700,0.006990521}, {705,0.006924171}, {710,0.007701422}, {715,0.007454976}, {720,0.007203791}, {725,0.007194313}, {730,0.007194313}, {735,0.007478673}, {740,0.007308057}, {745,0.007459716}, {750,0.007440758}, {755,0.008469194}, {760,0.008123223}, {765,0.007658768}, {770,0.007696682}, {775,0.007658768}, {780,0.007791469}, {785,0.007867299}, {790,0.007976303}, {795,0.008009479}, {800,0.008488152}, {805,0.007919431}, {810,0.008156398}, {815,0.007990521}, {820,0.008232227}, {825,0.008398104}, {830,0.008364929}, {835,0.008459716}, {840,0.010000000}, {845,0.009341232}, {850,0.008526066}, {855,0.008668246}, {860,0.008620853}, {865,0.008549763}, {870,0.008744076}, {875,0.008909953}, {880,0.010412322}, {885,0.009587678}, {890,0.009075829}, {895,0.008938389}, {900,0.009004739}, {905,0.009127962}, {910,0.009066351}, {915,0.009236967}, {920,0.010516588}, {925,0.009341232}, {930,0.009488152}, {935,0.009161137}, {940,0.009260664}, {945,0.009398104}, {950,0.009630332}, {955,0.011715640}, {960,0.010132701}, {965,0.009829384}, {970,0.009909953}, {975,0.009862559}, {980,0.009853081}, {985,0.010142180}, {990,0.011843602}, {995,0.010810427}, {1000,0.009834123}, {1010,0.009857820}, {1020,0.010274882}, {1030,0.010715640}, {1040,0.010720379}, {1050,0.012037915}, {1060,0.011189573}, {1070,0.010957346}, {1080,0.011071090}, {1090,0.011218009}, {1100,0.011355450}, {1110,0.011412322}, {1120,0.013715640}, {1130,0.011663507}, {1140,0.011639810}, {1150,0.011559242}, {1160,0.011739336}, {1170,0.011843602}, {1180,0.013559242}, {1190,0.012052133}, {1200,0.012180095}, {1210,0.012194313}, {1220,0.012459716}, {1230,0.012559242}, {1240,0.014274882}, {1250,0.012587678}, {1260,0.012725118}, {1270,0.012853081}, {1280,0.012914692}, {1290,0.014639810}, {1300,0.014146919}, {1310,0.013213270}, {1320,0.013232227}, {1330,0.013417062}, {1340,0.013279621}, {1350,0.016336493}, {1360,0.013421801}, {1370,0.013815166}, {1380,0.013635071}, {1390,0.013682464}, {1400,0.016407583}, {1410,0.013938389}, {1420,0.013824645}, {1430,0.013985782}, {1440,0.014284360}, {1450,0.016450237}, {1460,0.014184834}, {1470,0.014464455}, {1480,0.014473934}, {1490,0.014658768}, {1500,0.018682464}, {1510,0.014819905}, {1520,0.014805687}, {1530,0.014976303}, {1540,0.016156398}, {1550,0.016445498}, {1560,0.015308057}, {1570,0.015232227}, {1580,0.015450237}, {1590,0.016492891}, {1600,0.015578199}, {1610,0.015706161}, {1620,0.015696682}, {1630,0.017260664}, {1640,0.017137441}, {1650,0.016085308}, {1660,0.015890995}, {1670,0.016085308}, {1680,0.018393365}, {1690,0.016246445}, {1700,0.016426540}, {1710,0.016734597}, {1720,0.018606635}, {1730,0.016431280}, {1740,0.016611374}, {1750,0.016800948}, {1760,0.019706161}, {1770,0.017763033}, {1780,0.017213270}, {1790,0.017341232}, {1800,0.020132701}, {1810,0.017909953}, {1820,0.017549763}, {1830,0.017526066}, {1840,0.020417062}, {1850,0.018156398}, {1860,0.017710900}, {1870,0.017881517}, {1880,0.020597156}, {1890,0.018260664}, {1900,0.018137441}, {1910,0.018298578}, {1920,0.022654028}, {1930,0.018459716}, {1940,0.018601896}, {1950,0.018521327}, {1960,0.021592417}, {1970,0.018663507}, {1980,0.018838863}, {1990,0.020933649}, {2000,0.021554502}, {2050,0.019521327}, {2100,0.019976303}, {2150,0.024483412}, {2200,0.021270142}, {2250,0.021658768}, {2300,0.025241706}, {2350,0.023331754}, {2400,0.023118483}, {2450,0.027284360}, {2500,0.024781991}, {2550,0.024725118}, {2600,0.029440758}, {2650,0.025535545}, {2700,0.026056872}, {2750,0.032995261}, {2800,0.027184834}, {2850,0.027592417}, {2900,0.029393365}, {2950,0.028374408}, {3000,0.034255924}, {3050,0.029611374}, {3100,0.033194313}, {3150,0.032312796}, {3200,0.031341232}, {3250,0.034677725}, {3300,0.032492891}, {3350,0.036521327}, {3400,0.033308057}, {3450,0.038341232}, {3500,0.034426540}, {3550,0.040284360}, {3600,0.035369668}, {3650,0.038924171}, {3700,0.036734597}, {3750,0.039672986}, {3800,0.037507109}, {3850,0.041322275}, {3900,0.037511848}, {3950,0.046862559}, {4000,0.038843602}, {4050,0.046867299}, {4100,0.040132701}, {4150,0.046303318}, {4200,0.041236967}, {4250,0.046971564}, {4300,0.046009479}, {4350,0.043450237}, {4400,0.049625592}, {4450,0.044061611}, {4500,0.051473934}, {4550,0.050132701}, {4600,0.046331754}, {4650,0.051758294}, {4700,0.046421801}, {4750,0.050161137}, {4800,0.056587678}, {4850,0.048037915}, {4900,0.054800948}, {4950,0.052777251}, {5000,0.049379147}, {5050,0.055672986}, {5100,0.059279621}, {5150,0.051208531}, {5200,0.057194313}, {5250,0.060611374}, {5300,0.052729858}, {5350,0.054412322}, {5400,0.064672986}, {5450,0.060857820}, {5500,0.054995261}, {5550,0.062028436}, {5600,0.066995261}, {5650,0.063018957}, {5700,0.057085308}, {5750,0.062037915}, {5800,0.069578199}, {5850,0.072227488}, {5900,0.059966825}, {5950,0.061369668}, {6000,0.068639810}, {6050,0.077004739}, {6100,0.074957346}, {6150,0.062881517}, {6200,0.064412322}, {6250,0.068142180}, {6300,0.070781991}, {6350,0.073312796}, {6400,0.077563981}, {6450,0.074767773}, {6500,0.067734597}, {6550,0.070023697}, {6600,0.073895735}, {6650,0.074767773}, {6700,0.081881517}, {6750,0.083597156}, {6800,0.088663507}, {6850,0.081895735}, {6900,0.078720379}, {6950,0.071630332}, {7000,0.074066351}, {7050,0.073720379}, {7100,0.077606635}, {7150,0.081492891}, {7200,0.080995261}, {7250,0.081199052}, {7300,0.088578199}, {7350,0.088080569}, {7400,0.084113744}, {7450,0.085118483}, {7500,0.085933649}, {7550,0.086483412}, {7600,0.086862559}, {7650,0.086758294}, {7700,0.089654028}, {7750,0.090805687}, {7800,0.091639810}, {7850,0.092407583}, {7900,0.089364929}, {7950,0.089094787}, {8000,0.091521327}, {8050,0.086990521}, {8100,0.095127962}, {8150,0.093341232}, {8200,0.101099526}, {8250,0.107649289}, {8300,0.107066351}, {8350,0.105369668}, {8400,0.102127962}, {8450,0.098047393}, {8500,0.101151659}, {8550,0.100431280}, {8600,0.106909953}, {8650,0.112260664}, {8700,0.115327014}, {8750,0.107853081}, {8800,0.102156398}, {8850,0.103805687}, {8900,0.108810427}, {8950,0.113341232}, {9000,0.117194313}, {9050,0.111701422}, {9100,0.105715640}, {9150,0.111099526}, {9200,0.121563981}, {9250,0.121407583}, {9300,0.114146919}, {9350,0.114611374}, {9400,0.120469194}, {9450,0.124180095}, {9500,0.119853081}, {9550,0.118687204}, {9600,0.133421801}, {9650,0.124758294}, {9700,0.120473934}, {9750,0.127279621}, {9800,0.125976303}, {9850,0.125981043}, {9900,0.118706161}, {9950,0.131734597}, {10000,0.128018957}, {10100,0.120426540}, {10200,0.134450237}, {10300,0.132497630}, {10400,0.132227488}, {10500,0.138232227}, {10600,0.139502370}, {10700,0.145327014}, {10800,0.137132701}, {10900,0.139037915}, {11000,0.139308057}, {11100,0.139151659}, {11200,0.141502370}, {11300,0.149379147}, {11400,0.145791469}, {11500,0.153872038}, {11600,0.144469194}, {11700,0.145142180}, {11800,0.148464455}, {11900,0.160545024}, {12000,0.165061611}, {12100,0.159473934}, {12200,0.165654028}, {12300,0.155388626}, {12400,0.169928910}, {12500,0.166180095}, {12600,0.160113744}, {12700,0.173218009}, {12800,0.172180095}, {12900,0.164246445}, {13000,0.175947867}, {13100,0.187530806}, {13200,0.174796209}, {13300,0.172720379}, {13400,0.181071090}, {13500,0.194379147}, {13600,0.187222749}, {13700,0.177094787}, {13800,0.178023697}, {13900,0.192137441}, {14000,0.215672986}, {14100,0.198388626}, {14200,0.190156398}, {14300,0.182464455}, {14400,0.189322275}, {14500,0.197383886}, {14600,0.192113744}, {14700,0.206208531}, {14800,0.212469194}, {14900,0.215199052}, {15000,0.215161137}, {15100,0.221995261}, {15200,0.223232227}, {15300,0.225952607}, {15400,0.222701422}, {15500,0.218303318}, {15600,0.217388626}, {15700,0.213118483}, {15800,0.212578199}, {15900,0.210687204}, {16000,0.206260664}, {16100,0.220701422}, {16200,0.235682464}, {16300,0.247791469}, {16400,0.237587678}, {16500,1.743578199}, {16600,0.225327014}, {16700,0.229578199}, {16800,0.246573460}, {16900,0.247042654}, {17000,0.238905213}, {17100,0.243037915}, {17200,0.255175355}, {17300,0.253080569}, {17400,0.260071090}, {17500,0.246616114}, {17600,0.255895735}, {17700,0.246000000}, {17800,0.250976303}, {17900,0.259843602}, {18000,0.260142180}, {18100,0.264028436}, {18200,0.257563981}, {18300,0.246412322}, {18400,0.270388626}, {18500,0.261573460}, {18600,0.282601896}, {18700,0.256853081}, {18800,0.281620853}, {18900,0.276815166}, {19000,0.282701422}, {19100,0.277881517}, {19200,0.294222749}, {19300,0.260824645}, {19400,0.289620853}, {19500,0.281976303}, {19600,0.281777251}, {19700,0.287573460}, {19800,0.271478673}, {19900,0.303203791}, {20000,0.276712919}};
data["big_flat"]["Parametricity; beta"]["Aggregate"]["system"] = {{1,0.000563981}, {2,0.000175355}, {3,0.000071090}, {4,0.000018957}, {5,0.000056872}, {6,0.000018957}, {7,0.000018957}, {8,0.000018957}, {9,0.000037915}, {10,0.000075829}, {11,0.000000000}, {12,0.000018957}, {13,0.000000000}, {14,0.000000000}, {15,0.000071090}, {16,0.000018957}, {17,0.000037915}, {18,0.000037915}, {19,0.000056872}, {20,0.000018957}, {21,0.000000000}, {22,0.000113744}, {23,0.000000000}, {24,0.000014218}, {25,0.000018957}, {26,0.000052133}, {27,0.000018957}, {28,0.000037915}, {29,0.000184834}, {30,0.000056872}, {31,0.000071090}, {32,0.000000000}, {33,0.000151659}, {34,0.000000000}, {35,0.000075829}, {36,0.000052133}, {37,0.000033175}, {38,0.000056872}, {39,0.000018957}, {40,0.000037915}, {41,0.000037915}, {42,0.000056872}, {43,0.000018957}, {44,0.000037915}, {45,0.000033175}, {46,0.000094787}, {47,0.000018957}, {48,0.000018957}, {49,0.000018957}, {50,0.000000000}, {51,0.000056872}, {52,0.000018957}, {53,0.000037915}, {54,0.000037915}, {55,0.000037915}, {56,0.000056872}, {57,0.000018957}, {58,0.000018957}, {59,0.000000000}, {60,0.000014218}, {61,0.000018957}, {62,0.000018957}, {63,0.000056872}, {64,0.000014218}, {65,0.000056872}, {66,0.000056872}, {67,0.000037915}, {68,0.000018957}, {69,0.000000000}, {70,0.000000000}, {71,0.000018957}, {72,0.000037915}, {73,0.000000000}, {74,0.000052133}, {75,0.000047393}, {76,0.000033175}, {77,0.000018957}, {78,0.000028436}, {79,0.000000000}, {80,0.000075829}, {81,0.000018957}, {82,0.000000000}, {83,0.000056872}, {84,0.000037915}, {85,0.000018957}, {86,0.000037915}, {87,0.000052133}, {88,0.000000000}, {89,0.000018957}, {90,0.000000000}, {91,0.000018957}, {92,0.000018957}, {93,0.000037915}, {94,0.000037915}, {95,0.000094787}, {96,0.000000000}, {97,0.000037915}, {98,0.000071090}, {99,0.000037915}, {100,0.000037915}, {101,0.000037915}, {102,0.000000000}, {103,0.000109005}, {104,0.000056872}, {105,0.000033175}, {106,0.000037915}, {107,0.000037915}, {108,0.000075829}, {109,0.000066351}, {110,0.000018957}, {111,0.000000000}, {112,0.000033175}, {113,0.000000000}, {114,0.000018957}, {115,0.000037915}, {116,0.000037915}, {117,0.000000000}, {118,0.000018957}, {119,0.000018957}, {120,0.000018957}, {121,0.000033175}, {122,0.000037915}, {123,0.000000000}, {124,0.000028436}, {125,0.000018957}, {126,0.000071090}, {127,0.000052133}, {128,0.000018957}, {129,0.000056872}, {130,0.000066351}, {131,0.000000000}, {132,0.000056872}, {133,0.000018957}, {134,0.000075829}, {135,0.000018957}, {136,0.000037915}, {137,0.000018957}, {138,0.000033175}, {139,0.000037915}, {140,0.000018957}, {141,0.000037915}, {142,0.000075829}, {143,0.000018957}, {144,0.000037915}, {145,0.000037915}, {146,0.000033175}, {147,0.000094787}, {148,0.000000000}, {149,0.000018957}, {150,0.000037915}, {151,0.000018957}, {152,0.000033175}, {153,0.000052133}, {154,0.000037915}, {155,0.000014218}, {156,0.000014218}, {157,0.000000000}, {158,0.000018957}, {159,0.000037915}, {160,0.000018957}, {161,0.000018957}, {162,0.000018957}, {163,0.000000000}, {164,0.000033175}, {165,0.000018957}, {166,0.000033175}, {167,0.000000000}, {168,0.000018957}, {169,0.000071090}, {170,0.000066351}, {171,0.000033175}, {172,0.000000000}, {173,0.000018957}, {174,0.000037915}, {175,0.000094787}, {176,0.000000000}, {177,0.000000000}, {178,0.000056872}, {179,0.000037915}, {180,0.000000000}, {181,0.000071090}, {182,0.000037915}, {183,0.000075829}, {184,0.000018957}, {185,0.000056872}, {186,0.000033175}, {187,0.000052133}, {188,0.000037915}, {189,0.000037915}, {190,0.000037915}, {191,0.000056872}, {192,0.000037915}, {193,0.000037915}, {194,0.000037915}, {195,0.000037915}, {196,0.000056872}, {197,0.000056872}, {198,0.000056872}, {199,0.000018957}, {200,0.000071090}, {201,0.000056872}, {202,0.000028436}, {203,0.000014218}, {204,0.000037915}, {205,0.000056872}, {206,0.000037915}, {207,0.000018957}, {208,0.000037915}, {209,0.000037915}, {210,0.000018957}, {211,0.000037915}, {212,0.000151659}, {213,0.000000000}, {214,0.000037915}, {215,0.000000000}, {216,0.000000000}, {217,0.000071090}, {218,0.000052133}, {219,0.000056872}, {220,0.000075829}, {221,0.000037915}, {222,0.000037915}, {223,0.000056872}, {224,0.000056872}, {225,0.000000000}, {226,0.000018957}, {227,0.000018957}, {228,0.000000000}, {229,0.000037915}, {230,0.000018957}, {231,0.000018957}, {232,0.000000000}, {233,0.000014218}, {234,0.000037915}, {235,0.000014218}, {236,0.000037915}, {237,0.000052133}, {238,0.000037915}, {239,0.000037915}, {240,0.000018957}, {241,0.000000000}, {242,0.000000000}, {243,0.000018957}, {244,0.000052133}, {245,0.000037915}, {246,0.000037915}, {247,0.000052133}, {248,0.000052133}, {249,0.000047393}, {250,0.000037915}, {251,0.000113744}, {252,0.000037915}, {253,0.000052133}, {254,0.000033175}, {255,0.000090047}, {256,0.000000000}, {257,0.000104265}, {258,0.000094787}, {259,0.000094787}, {260,0.000037915}, {261,0.000037915}, {262,0.000037915}, {263,0.000018957}, {264,0.000071090}, {265,0.000028436}, {266,0.000000000}, {267,0.000071090}, {268,0.000018957}, {269,0.000037915}, {270,0.000037915}, {271,0.000037915}, {272,0.000018957}, {273,0.000075829}, {274,0.000018957}, {275,0.000052133}, {276,0.000000000}, {277,0.000037915}, {278,0.000018957}, {279,0.000000000}, {280,0.000075829}, {281,0.000056872}, {282,0.000056872}, {283,0.000056872}, {284,0.000037915}, {285,0.000000000}, {286,0.000037915}, {287,0.000056872}, {288,0.000109005}, {289,0.000000000}, {290,0.000000000}, {291,0.000037915}, {292,0.000018957}, {293,0.000033175}, {294,0.000075829}, {295,0.000037915}, {296,0.000094787}, {297,0.000094787}, {298,0.000000000}, {299,0.000075829}, {300,0.000000000}, {301,0.000056872}, {302,0.000052133}, {303,0.000018957}, {304,0.000056872}, {305,0.000037915}, {306,0.000000000}, {307,0.000052133}, {308,0.000052133}, {309,0.000047393}, {310,0.000075829}, {311,0.000037915}, {312,0.000000000}, {313,0.000071090}, {314,0.000037915}, {315,0.000000000}, {316,0.000071090}, {317,0.000056872}, {318,0.000000000}, {319,0.000014218}, {320,0.000037915}, {321,0.000018957}, {322,0.000018957}, {323,0.000037915}, {324,0.000018957}, {325,0.000018957}, {326,0.000056872}, {327,0.000018957}, {328,0.000071090}, {329,0.000037915}, {330,0.000037915}, {331,0.000037915}, {332,0.000018957}, {333,0.000033175}, {334,0.000052133}, {335,0.000056872}, {336,0.000056872}, {337,0.000056872}, {338,0.000033175}, {339,0.000018957}, {340,0.000056872}, {341,0.000018957}, {342,0.000071090}, {343,0.000037915}, {344,0.000037915}, {345,0.000018957}, {346,0.000037915}, {347,0.000000000}, {348,0.000000000}, {349,0.000052133}, {350,0.000075829}, {351,0.000094787}, {352,0.000037915}, {353,0.000056872}, {354,0.000090047}, {355,0.000000000}, {356,0.000037915}, {357,0.000037915}, {358,0.000056872}, {359,0.000037915}, {360,0.000075829}, {361,0.000028436}, {362,0.000018957}, {363,0.000052133}, {364,0.000037915}, {365,0.000094787}, {366,0.000056872}, {367,0.000056872}, {368,0.000075829}, {369,0.000090047}, {370,0.000018957}, {371,0.000109005}, {372,0.000075829}, {373,0.000037915}, {374,0.000037915}, {375,0.000033175}, {376,0.000052133}, {377,0.000075829}, {378,0.000052133}, {379,0.000000000}, {380,0.000037915}, {381,0.000104265}, {382,0.000018957}, {383,0.000113744}, {384,0.000071090}, {385,0.000109005}, {386,0.000056872}, {387,0.000037915}, {388,0.000109005}, {389,0.000037915}, {390,0.000037915}, {391,0.000000000}, {392,0.000056872}, {393,0.000071090}, {394,0.000071090}, {395,0.000142180}, {396,0.000033175}, {397,0.000052133}, {398,0.000071090}, {399,0.000018957}, {400,0.000066351}, {401,0.000037915}, {402,0.000018957}, {403,0.000047393}, {404,0.000056872}, {405,0.000037915}, {406,0.000056872}, {407,0.000037915}, {408,0.000000000}, {409,0.000018957}, {410,0.000018957}, {411,0.000042654}, {412,0.000018957}, {413,0.000056872}, {414,0.000094787}, {415,0.000052133}, {416,0.000071090}, {417,0.000094787}, {418,0.000018957}, {419,0.000018957}, {420,0.000037915}, {421,0.000052133}, {422,0.000018957}, {423,0.000000000}, {424,0.000000000}, {425,0.000033175}, {426,0.000014218}, {427,0.000056872}, {428,0.000000000}, {429,0.000075829}, {430,0.000071090}, {431,0.000018957}, {432,0.000037915}, {433,0.000018957}, {434,0.000033175}, {435,0.000075829}, {436,0.000052133}, {437,0.000056872}, {438,0.000018957}, {439,0.000000000}, {440,0.000037915}, {441,0.000052133}, {442,0.000037915}, {443,0.000018957}, {444,0.000052133}, {445,0.000037915}, {446,0.000052133}, {447,0.000056872}, {448,0.000018957}, {449,0.000018957}, {450,0.000075829}, {451,0.000056872}, {452,0.000075829}, {453,0.000071090}, {454,0.000075829}, {455,0.000018957}, {456,0.000075829}, {457,0.000071090}, {458,0.000056872}, {459,0.000056872}, {460,0.000028436}, {461,0.000000000}, {462,0.000071090}, {463,0.000037915}, {464,0.000037915}, {465,0.000018957}, {466,0.000018957}, {467,0.000014218}, {468,0.000071090}, {469,0.000018957}, {470,0.000075829}, {471,0.000056872}, {472,0.000037915}, {473,0.000094787}, {474,0.000000000}, {475,0.000052133}, {476,0.000090047}, {477,0.000037915}, {478,0.000056872}, {479,0.000033175}, {480,0.000037915}, {481,0.000033175}, {482,0.000037915}, {483,0.000037915}, {484,0.000056872}, {485,0.000170616}, {486,0.000014218}, {487,0.000033175}, {488,0.000037915}, {489,0.000037915}, {490,0.000018957}, {491,0.000056872}, {492,0.000018957}, {493,0.000018957}, {494,0.000037915}, {495,0.000037915}, {496,0.000090047}, {497,0.000075829}, {498,0.000037915}, {499,0.000037915}, {500,0.000000000}, {505,0.000132701}, {510,0.000075829}, {515,0.000037915}, {520,0.000033175}, {525,0.000037915}, {530,0.000075829}, {535,0.000094787}, {540,0.000066351}, {545,0.000056872}, {550,0.000037915}, {555,0.000113744}, {560,0.000018957}, {565,0.000000000}, {570,0.000033175}, {575,0.000052133}, {580,0.000014218}, {585,0.000018957}, {590,0.000033175}, {595,0.000094787}, {600,0.000018957}, {605,0.000075829}, {610,0.000028436}, {615,0.000018957}, {620,0.000109005}, {625,0.000094787}, {630,0.000014218}, {635,0.000052133}, {640,0.000071090}, {645,0.000033175}, {650,0.000052133}, {655,0.000052133}, {660,0.000047393}, {665,0.000056872}, {670,0.000146919}, {675,0.000090047}, {680,0.000142180}, {685,0.000047393}, {690,0.000037915}, {695,0.000113744}, {700,0.000056872}, {705,0.000033175}, {710,0.000094787}, {715,0.000000000}, {720,0.000052133}, {725,0.000056872}, {730,0.000146919}, {735,0.000018957}, {740,0.000132701}, {745,0.000056872}, {750,0.000071090}, {755,0.000037915}, {760,0.000037915}, {765,0.000037915}, {770,0.000052133}, {775,0.000075829}, {780,0.000037915}, {785,0.000037915}, {790,0.000018957}, {795,0.000037915}, {800,0.000037915}, {805,0.000094787}, {810,0.000037915}, {815,0.000075829}, {820,0.000071090}, {825,0.000000000}, {830,0.000075829}, {835,0.000151659}, {840,0.000085308}, {845,0.000056872}, {850,0.000075829}, {855,0.000056872}, {860,0.000056872}, {865,0.000052133}, {870,0.000094787}, {875,0.000033175}, {880,0.000151659}, {885,0.000052133}, {890,0.000056872}, {895,0.000075829}, {900,0.000037915}, {905,0.000146919}, {910,0.000047393}, {915,0.000056872}, {920,0.000056872}, {925,0.000018957}, {930,0.000037915}, {935,0.000056872}, {940,0.000071090}, {945,0.000113744}, {950,0.000037915}, {955,0.000037915}, {960,0.000113744}, {965,0.000037915}, {970,0.000037915}, {975,0.000071090}, {980,0.000056872}, {985,0.000071090}, {990,0.000104265}, {995,0.000037915}, {1000,0.000075829}, {1010,0.000113744}, {1020,0.000056872}, {1030,0.000056872}, {1040,0.000113744}, {1050,0.000075829}, {1060,0.000094787}, {1070,0.000090047}, {1080,0.000075829}, {1090,0.000090047}, {1100,0.000075829}, {1110,0.000000000}, {1120,0.000085308}, {1130,0.000052133}, {1140,0.000085308}, {1150,0.000118483}, {1160,0.000075829}, {1170,0.000094787}, {1180,0.000151659}, {1190,0.000113744}, {1200,0.000075829}, {1210,0.000151659}, {1220,0.000056872}, {1230,0.000052133}, {1240,0.000094787}, {1250,0.000037915}, {1260,0.000109005}, {1270,0.000056872}, {1280,0.000075829}, {1290,0.000170616}, {1300,0.000075829}, {1310,0.000037915}, {1320,0.000090047}, {1330,0.000075829}, {1340,0.000094787}, {1350,0.000113744}, {1360,0.000071090}, {1370,0.000037915}, {1380,0.000037915}, {1390,0.000018957}, {1400,0.000066351}, {1410,0.000037915}, {1420,0.000142180}, {1430,0.000037915}, {1440,0.000090047}, {1450,0.000151659}, {1460,0.000071090}, {1470,0.000033175}, {1480,0.000132701}, {1490,0.000075829}, {1500,0.000165877}, {1510,0.000090047}, {1520,0.000018957}, {1530,0.000085308}, {1540,0.000071090}, {1550,0.000094787}, {1560,0.000113744}, {1570,0.000071090}, {1580,0.000075829}, {1590,0.000151659}, {1600,0.000075829}, {1610,0.000090047}, {1620,0.000000000}, {1630,0.000104265}, {1640,0.000109005}, {1650,0.000165877}, {1660,0.000075829}, {1670,0.000090047}, {1680,0.000208531}, {1690,0.000109005}, {1700,0.000109005}, {1710,0.000018957}, {1720,0.000218009}, {1730,0.000113744}, {1740,0.000075829}, {1750,0.000094787}, {1760,0.000132701}, {1770,0.000094787}, {1780,0.000018957}, {1790,0.000037915}, {1800,0.000132701}, {1810,0.000090047}, {1820,0.000071090}, {1830,0.000090047}, {1840,0.000203791}, {1850,0.000075829}, {1860,0.000184834}, {1870,0.000037915}, {1880,0.000090047}, {1890,0.000151659}, {1900,0.000037915}, {1910,0.000071090}, {1920,0.000208531}, {1930,0.000127962}, {1940,0.000018957}, {1950,0.000090047}, {1960,0.000270142}, {1970,0.000127962}, {1980,0.000109005}, {1990,0.000094787}, {2000,0.000180095}, {2050,0.000094787}, {2100,0.000113744}, {2150,0.000146919}, {2200,0.000075829}, {2250,0.000075829}, {2300,0.000170616}, {2350,0.000037915}, {2400,0.000109005}, {2450,0.000170616}, {2500,0.000170616}, {2550,0.000104265}, {2600,0.000218009}, {2650,0.000085308}, {2700,0.000175355}, {2750,0.000184834}, {2800,0.000094787}, {2850,0.000118483}, {2900,0.000170616}, {2950,0.000203791}, {3000,0.000236967}, {3050,0.000146919}, {3100,0.000123223}, {3150,0.000000000}, {3200,0.000037915}, {3250,0.000241706}, {3300,0.000094787}, {3350,0.000203791}, {3400,0.000113744}, {3450,0.000165877}, {3500,0.000094787}, {3550,0.000127962}, {3600,0.000170616}, {3650,0.000208531}, {3700,0.000255924}, {3750,0.000146919}, {3800,0.000184834}, {3850,0.000199052}, {3900,0.000132701}, {3950,0.000251185}, {4000,0.000222749}, {4050,0.000336493}, {4100,0.000113744}, {4150,0.000241706}, {4200,0.000075829}, {4250,0.000251185}, {4300,0.000260664}, {4350,0.000241706}, {4400,0.000170616}, {4450,0.000052133}, {4500,0.000184834}, {4550,0.000236967}, {4600,0.000127962}, {4650,0.000274882}, {4700,0.000056872}, {4750,0.000189573}, {4800,0.000293839}, {4850,0.000104265}, {4900,0.000393365}, {4950,0.000284360}, {5000,0.000075829}, {5050,0.000345972}, {5100,0.000345972}, {5150,0.000142180}, {5200,0.000208531}, {5250,0.000450237}, {5300,0.000218009}, {5350,0.000127962}, {5400,0.000341232}, {5450,0.000298578}, {5500,0.000127962}, {5550,0.000203791}, {5600,0.000341232}, {5650,0.000170616}, {5700,0.000109005}, {5750,0.000383886}, {5800,0.000336493}, {5850,0.000469194}, {5900,0.000180095}, {5950,0.000165877}, {6000,0.000184834}, {6050,0.001369668}, {6100,0.000459716}, {6150,0.000075829}, {6200,0.000236967}, {6250,0.000241706}, {6300,0.000255924}, {6350,0.000393365}, {6400,0.000241706}, {6450,0.000246445}, {6500,0.000132701}, {6550,0.000303318}, {6600,0.000412322}, {6650,0.000360190}, {6700,0.000483412}, {6750,0.000303318}, {6800,0.000521327}, {6850,0.000402844}, {6900,0.000369668}, {6950,0.000184834}, {7000,0.000227488}, {7050,0.000379147}, {7100,0.000312796}, {7150,0.000369668}, {7200,0.000322275}, {7250,0.000398104}, {7300,0.000355450}, {7350,0.000374408}, {7400,0.000255924}, {7450,0.000317536}, {7500,0.000322275}, {7550,0.000364929}, {7600,0.000473934}, {7650,0.000303318}, {7700,0.000265403}, {7750,0.000398104}, {7800,0.000355450}, {7850,0.000388626}, {7900,0.000293839}, {7950,0.000317536}, {8000,0.000426540}, {8050,0.000246445}, {8100,0.000369668}, {8150,0.000436019}, {8200,0.000611374}, {8250,0.000658768}, {8300,0.000691943}, {8350,0.000383886}, {8400,0.000350711}, {8450,0.000222749}, {8500,0.000170616}, {8550,0.000379147}, {8600,0.000203791}, {8650,0.000312796}, {8700,0.000203791}, {8750,0.000161137}, {8800,0.000388626}, {8850,0.000431280}, {8900,0.000341232}, {8950,0.000450237}, {9000,0.000464455}, {9050,0.000360190}, {9100,0.000146919}, {9150,0.000293839}, {9200,0.000459716}, {9250,0.000421801}, {9300,0.000469194}, {9350,0.000488152}, {9400,0.000635071}, {9450,0.000521327}, {9500,0.000710900}, {9550,0.000597156}, {9600,0.000928910}, {9650,0.000540284}, {9700,0.000592417}, {9750,0.000559242}, {9800,0.000469194}, {9850,0.000341232}, {9900,0.000497630}, {9950,0.000469194}, {10000,0.000805687}, {10100,0.000450237}, {10200,0.000777251}, {10300,0.000729858}, {10400,0.000691943}, {10500,0.000677725}, {10600,0.000682464}, {10700,0.000848341}, {10800,0.000635071}, {10900,0.000473934}, {11000,0.000440758}, {11100,0.000767773}, {11200,0.000540284}, {11300,0.000810427}, {11400,0.000606635}, {11500,0.000625592}, {11600,0.000682464}, {11700,0.000710900}, {11800,0.000805687}, {11900,0.000644550}, {12000,0.000829384}, {12100,0.000630332}, {12200,0.000725118}, {12300,0.000488152}, {12400,0.000843602}, {12500,0.000819905}, {12600,0.000568720}, {12700,0.001009479}, {12800,0.001156398}, {12900,0.000763033}, {13000,0.000635071}, {13100,0.000909953}, {13200,0.000473934}, {13300,0.000293839}, {13400,0.000450237}, {13500,0.000559242}, {13600,0.000459716}, {13700,0.000374408}, {13800,0.000355450}, {13900,0.000682464}, {14000,0.000710900}, {14100,0.000317536}, {14200,0.000374408}, {14300,0.000407583}, {14400,0.000431280}, {14500,0.000526066}, {14600,0.000701422}, {14700,0.000952607}, {14800,0.001080569}, {14900,0.001080569}, {15000,0.000848341}, {15100,0.001165877}, {15200,0.001540284}, {15300,0.000971564}, {15400,0.000748815}, {15500,0.000360190}, {15600,0.000616114}, {15700,0.000535545}, {15800,0.000511848}, {15900,0.000568720}, {16000,0.000516588}, {16100,0.000582938}, {16200,0.000696682}, {16300,0.000720379}, {16400,0.000658768}, {16500,0.002360190}, {16600,0.000492891}, {16700,0.000672986}, {16800,0.000644550}, {16900,0.000601896}, {17000,0.000710900}, {17100,0.000739336}, {17200,0.000710900}, {17300,0.000682464}, {17400,0.000796209}, {17500,0.000791469}, {17600,0.000165877}, {17700,0.000260664}, {17800,0.000241706}, {17900,0.000094787}, {18000,0.000189573}, {18100,0.000113744}, {18200,0.000222749}, {18300,0.000260664}, {18400,0.000113744}, {18500,0.000184834}, {18600,0.000227488}, {18700,0.000132701}, {18800,0.000151659}, {18900,0.000170616}, {19000,0.000146919}, {19100,0.000208531}, {19200,0.000246445}, {19300,0.000227488}, {19400,0.000170616}, {19500,0.000203791}, {19600,0.000094787}, {19700,0.000165877}, {19800,0.000265403}, {19900,0.000170616}, {20000,0.000191388}};
data["big_flat"]["Parametricity; beta"]["actual reif"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000009479}, {120,0.000478673}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000009479}, {153,0.000000000}, {154,0.000521327}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000516588}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000616114}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000004739}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000004739}, {261,0.000000000}, {262,0.000004739}, {263,0.000000000}, {264,0.000000000}, {265,0.000004739}, {266,0.000004739}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000004739}, {272,0.000004739}, {273,0.000000000}, {274,0.000004739}, {275,0.000004739}, {276,0.000004739}, {277,0.000483412}, {278,0.000009479}, {279,0.000014218}, {280,0.000004739}, {281,0.000018957}, {282,0.000014218}, {283,0.000014218}, {284,0.000014218}, {285,0.000014218}, {286,0.000009479}, {287,0.000023697}, {288,0.000056872}, {289,0.000080569}, {290,0.000056872}, {291,0.000056872}, {292,0.000071090}, {293,0.000071090}, {294,0.000118483}, {295,0.000094787}, {296,0.000161137}, {297,0.000701422}, {298,0.000113744}, {299,0.000137441}, {300,0.000170616}, {301,0.000180095}, {302,0.000232227}, {303,0.000227488}, {304,0.000241706}, {305,0.000308057}, {306,0.000308057}, {307,0.000345972}, {308,0.000322275}, {309,0.000350711}, {310,0.000341232}, {311,0.000374408}, {312,0.000388626}, {313,0.000393365}, {314,0.000436019}, {315,0.000440758}, {316,0.001109005}, {317,0.000473934}, {318,0.000483412}, {319,0.000454976}, {320,0.000502370}, {321,0.000535545}, {322,0.000559242}, {323,0.000549763}, {324,0.000540284}, {325,0.000601896}, {326,0.000620853}, {327,0.000616114}, {328,0.000691943}, {329,0.000687204}, {330,0.000715640}, {331,0.000758294}, {332,0.000744076}, {333,0.000753555}, {334,0.001180095}, {335,0.000862559}, {336,0.000848341}, {337,0.000848341}, {338,0.000876777}, {339,0.000886256}, {340,0.000905213}, {341,0.000919431}, {342,0.000933649}, {343,0.000933649}, {344,0.000943128}, {345,0.000938389}, {346,0.000933649}, {347,0.000933649}, {348,0.000933649}, {349,0.000957346}, {350,0.000957346}, {351,0.000966825}, {352,0.000985782}, {353,0.000985782}, {354,0.000985782}, {355,0.000981043}, {356,0.000985782}, {357,0.000985782}, {358,0.000990521}, {359,0.000995261}, {360,0.000995261}, {361,0.000990521}, {362,0.001000000}, {363,0.001000000}, {364,0.001000000}, {365,0.001000000}, {366,0.001000000}, {367,0.001009479}, {368,0.001511848}, {369,0.001000000}, {370,0.001000000}, {371,0.001000000}, {372,0.001000000}, {373,0.001000000}, {374,0.001000000}, {375,0.001000000}, {376,0.001000000}, {377,0.001000000}, {378,0.001000000}, {379,0.001000000}, {380,0.001000000}, {381,0.001000000}, {382,0.001000000}, {383,0.001000000}, {384,0.001000000}, {385,0.001000000}, {386,0.001000000}, {387,0.001000000}, {388,0.001000000}, {389,0.001000000}, {390,0.001000000}, {391,0.001000000}, {392,0.001000000}, {393,0.001000000}, {394,0.001000000}, {395,0.001000000}, {396,0.001000000}, {397,0.001000000}, {398,0.001000000}, {399,0.001009479}, {400,0.001492891}, {401,0.001000000}, {402,0.001000000}, {403,0.001000000}, {404,0.001000000}, {405,0.001000000}, {406,0.001000000}, {407,0.001000000}, {408,0.001000000}, {409,0.001000000}, {410,0.001000000}, {411,0.001000000}, {412,0.001000000}, {413,0.001000000}, {414,0.001000000}, {415,0.001511848}, {416,0.001000000}, {417,0.001000000}, {418,0.001000000}, {419,0.001000000}, {420,0.001000000}, {421,0.001000000}, {422,0.001000000}, {423,0.001000000}, {424,0.001000000}, {425,0.001000000}, {426,0.001000000}, {427,0.001000000}, {428,0.001000000}, {429,0.001004739}, {430,0.001000000}, {431,0.001000000}, {432,0.001000000}, {433,0.001000000}, {434,0.001000000}, {435,0.001000000}, {436,0.001000000}, {437,0.001000000}, {438,0.001000000}, {439,0.001000000}, {440,0.001000000}, {441,0.001000000}, {442,0.001000000}, {443,0.001000000}, {444,0.001000000}, {445,0.001478673}, {446,0.001000000}, {447,0.001000000}, {448,0.001000000}, {449,0.001000000}, {450,0.001000000}, {451,0.001000000}, {452,0.001000000}, {453,0.001000000}, {454,0.001000000}, {455,0.001000000}, {456,0.001000000}, {457,0.001000000}, {458,0.001890995}, {459,0.001478673}, {460,0.001000000}, {461,0.001000000}, {462,0.001000000}, {463,0.001000000}, {464,0.001000000}, {465,0.001000000}, {466,0.001000000}, {467,0.001000000}, {468,0.001000000}, {469,0.001000000}, {470,0.001000000}, {471,0.001000000}, {472,0.001000000}, {473,0.001000000}, {474,0.001000000}, {475,0.001000000}, {476,0.001000000}, {477,0.001000000}, {478,0.001000000}, {479,0.001000000}, {480,0.001000000}, {481,0.001000000}, {482,0.001000000}, {483,0.001000000}, {484,0.001000000}, {485,0.001511848}, {486,0.001000000}, {487,0.001000000}, {488,0.001000000}, {489,0.001000000}, {490,0.001000000}, {491,0.001000000}, {492,0.001000000}, {493,0.001000000}, {494,0.001000000}, {495,0.001000000}, {496,0.001000000}, {497,0.001000000}, {498,0.001516588}, {499,0.001478673}, {500,0.001000000}, {505,0.001000000}, {510,0.001000000}, {515,0.001000000}, {520,0.001000000}, {525,0.001000000}, {530,0.001000000}, {535,0.001000000}, {540,0.001000000}, {545,0.001000000}, {550,0.001000000}, {555,0.001000000}, {560,0.001000000}, {565,0.001000000}, {570,0.001000000}, {575,0.001000000}, {580,0.001000000}, {585,0.001000000}, {590,0.001000000}, {595,0.001000000}, {600,0.001000000}, {605,0.001014218}, {610,0.001000000}, {615,0.001000000}, {620,0.001000000}, {625,0.001000000}, {630,0.001000000}, {635,0.001000000}, {640,0.001000000}, {645,0.001000000}, {650,0.001000000}, {655,0.001000000}, {660,0.001971564}, {665,0.001554502}, {670,0.001000000}, {675,0.001000000}, {680,0.001000000}, {685,0.001000000}, {690,0.001000000}, {695,0.001000000}, {700,0.001004739}, {705,0.001009479}, {710,0.001004739}, {715,0.001018957}, {720,0.001014218}, {725,0.001023697}, {730,0.001042654}, {735,0.001033175}, {740,0.001085308}, {745,0.001090047}, {750,0.001142180}, {755,0.002037915}, {760,0.001222749}, {765,0.001317536}, {770,0.001341232}, {775,0.001383886}, {780,0.001417062}, {785,0.001488152}, {790,0.001521327}, {795,0.001578199}, {800,0.001706161}, {805,0.001805687}, {810,0.001848341}, {815,0.001900474}, {820,0.001933649}, {825,0.001924171}, {830,0.001938389}, {835,0.001938389}, {840,0.001947867}, {845,0.001971564}, {850,0.001985782}, {855,0.001990521}, {860,0.002000000}, {865,0.002000000}, {870,0.002000000}, {875,0.002000000}, {880,0.002000000}, {885,0.002000000}, {890,0.002000000}, {895,0.002000000}, {900,0.002000000}, {905,0.002000000}, {910,0.002000000}, {915,0.002000000}, {920,0.002000000}, {925,0.002000000}, {930,0.002000000}, {935,0.002000000}, {940,0.002000000}, {945,0.002000000}, {950,0.002000000}, {955,0.002000000}, {960,0.002000000}, {965,0.002000000}, {970,0.002000000}, {975,0.002000000}, {980,0.002000000}, {985,0.002000000}, {990,0.002000000}, {995,0.002753555}, {1000,0.002000000}, {1010,0.002000000}, {1020,0.002000000}, {1030,0.002000000}, {1040,0.002000000}, {1050,0.002000000}, {1060,0.002000000}, {1070,0.002000000}, {1080,0.002000000}, {1090,0.002000000}, {1100,0.002000000}, {1110,0.002000000}, {1120,0.002000000}, {1130,0.002004739}, {1140,0.002004739}, {1150,0.002009479}, {1160,0.002018957}, {1170,0.002014218}, {1180,0.002052133}, {1190,0.002099526}, {1200,0.002142180}, {1210,0.002189573}, {1220,0.002241706}, {1230,0.002336493}, {1240,0.002369668}, {1250,0.002445498}, {1260,0.002507109}, {1270,0.002620853}, {1280,0.002744076}, {1290,0.002862559}, {1300,0.002890995}, {1310,0.002924171}, {1320,0.002938389}, {1330,0.002952607}, {1340,0.002971564}, {1350,0.002981043}, {1360,0.002995261}, {1370,0.003000000}, {1380,0.003000000}, {1390,0.003000000}, {1400,0.003000000}, {1410,0.003000000}, {1420,0.003000000}, {1430,0.003000000}, {1440,0.003000000}, {1450,0.003000000}, {1460,0.003000000}, {1470,0.003000000}, {1480,0.003000000}, {1490,0.003000000}, {1500,0.003000000}, {1510,0.003004739}, {1520,0.003014218}, {1530,0.003009479}, {1540,0.003028436}, {1550,0.004819905}, {1560,0.003014218}, {1570,0.003000000}, {1580,0.003004739}, {1590,0.004488152}, {1600,0.003018957}, {1610,0.003028436}, {1620,0.003061611}, {1630,0.003090047}, {1640,0.004469194}, {1650,0.003161137}, {1660,0.003180095}, {1670,0.003251185}, {1680,0.003265403}, {1690,0.003336493}, {1700,0.003383886}, {1710,0.003464455}, {1720,0.005502370}, {1730,0.003573460}, {1740,0.003616114}, {1750,0.003710900}, {1760,0.003819905}, {1770,0.003862559}, {1780,0.003909953}, {1790,0.003909953}, {1800,0.003938389}, {1810,0.003924171}, {1820,0.003933649}, {1830,0.003962085}, {1840,0.004000000}, {1850,0.003990521}, {1860,0.004000000}, {1870,0.004000000}, {1880,0.004004739}, {1890,0.004000000}, {1900,0.004000000}, {1910,0.004000000}, {1920,0.006398104}, {1930,0.004004739}, {1940,0.004000000}, {1950,0.004000000}, {1960,0.004000000}, {1970,0.004009479}, {1980,0.004023697}, {1990,0.004018957}, {2000,0.004042654}, {2050,0.004118483}, {2100,0.004251185}, {2150,0.005682464}, {2200,0.004606635}, {2250,0.004905213}, {2300,0.004985782}, {2350,0.004995261}, {2400,0.005018957}, {2450,0.005132701}, {2500,0.005241706}, {2550,0.005331754}, {2600,0.005492891}, {2650,0.005601896}, {2700,0.005848341}, {2750,0.009364929}, {2800,0.005976303}, {2850,0.006094787}, {2900,0.006208531}, {2950,0.006331754}, {3000,0.009573460}, {3050,0.006507109}, {3100,0.006630332}, {3150,0.006862559}, {3200,0.007004739}, {3250,0.009417062}, {3300,0.007184834}, {3350,0.009426540}, {3400,0.007383886}, {3450,0.007521327}, {3500,0.007545024}, {3550,0.007781991}, {3600,0.007895735}, {3650,0.008061611}, {3700,0.008175355}, {3750,0.008265403}, {3800,0.008369668}, {3850,0.008469194}, {3900,0.008549763}, {3950,0.008786730}, {4000,0.008848341}, {4050,0.013928910}, {4100,0.009161137}, {4150,0.011502370}, {4200,0.009383886}, {4250,0.014123223}, {4300,0.009592417}, {4350,0.009635071}, {4400,0.009995261}, {4450,0.010061611}, {4500,0.013075829}, {4550,0.010322275}, {4600,0.010393365}, {4650,0.013829384}, {4700,0.010639810}, {4750,0.013502370}, {4800,0.010876777}, {4850,0.011004739}, {4900,0.014369668}, {4950,0.011388626}, {5000,0.011407583}, {5050,0.014691943}, {5100,0.011687204}, {5150,0.011815166}, {5200,0.014834123}, {5250,0.012165877}, {5300,0.012251185}, {5350,0.012454976}, {5400,0.016890995}, {5450,0.012706161}, {5500,0.012772512}, {5550,0.017568720}, {5600,0.019056872}, {5650,0.013137441}, {5700,0.013322275}, {5750,0.013000000}, {5800,0.017914692}, {5850,0.013715640}, {5900,0.013872038}, {5950,0.013995261}, {6000,0.018023697}, {6050,0.025511848}, {6100,0.014421801}, {6150,0.014563981}, {6200,0.014677725}, {6250,0.018094787}, {6300,0.022663507}, {6350,0.019933649}, {6400,0.015284360}, {6450,0.015336493}, {6500,0.015507109}, {6550,0.015701422}, {6600,0.019805687}, {6650,0.018658768}, {6700,0.020753555}, {6750,0.016327014}, {6800,0.016341232}, {6850,0.016502370}, {6900,0.016701422}, {6950,0.016758294}, {7000,0.017000000}, {7050,0.017080569}, {7100,0.017274882}, {7150,0.017364929}, {7200,0.022336493}, {7250,0.021606635}, {7300,0.022843602}, {7350,0.022687204}, {7400,0.020744076}, {7450,0.026502370}, {7500,0.026947867}, {7550,0.027137441}, {7600,0.027037915}, {7650,0.021985782}, {7700,0.024298578}, {7750,0.023767773}, {7800,0.024075829}, {7850,0.023739336}, {7900,0.018308057}, {7950,0.019587678}, {8000,0.019848341}, {8050,0.019890995}, {8100,0.020042654}, {8150,0.020255924}, {8200,0.020407583}, {8250,0.020464455}, {8300,0.032606635}, {8350,0.026388626}, {8400,0.034691943}, {8450,0.025658768}, {8500,0.021213270}, {8550,0.021303318}, {8600,0.021407583}, {8650,0.021601896}, {8700,0.033426540}, {8750,0.036436019}, {8800,0.026364929}, {8850,0.022241706}, {8900,0.022293839}, {8950,0.022492891}, {9000,0.031654028}, {9050,0.031213270}, {9100,0.022857820}, {9150,0.023071090}, {9200,0.023194313}, {9250,0.036113744}, {9300,0.032715640}, {9350,0.023663507}, {9400,0.023786730}, {9450,0.035090047}, {9500,0.033578199}, {9550,0.024260664}, {9600,0.024327014}, {9650,0.036781991}, {9700,0.036379147}, {9750,0.024834123}, {9800,0.032137441}, {9850,0.035909953}, {9900,0.025189573}, {9950,0.025554502}, {10000,0.044701422}, {10100,0.025938389}, {10200,0.026232227}, {10300,0.033004739}, {10400,0.026639810}, {10500,0.034421801}, {10600,0.038331754}, {10700,0.027521327}, {10800,0.045578199}, {10900,0.028028436}, {11000,0.045834123}, {11100,0.028644550}, {11200,0.036109005}, {11300,0.029246445}, {11400,0.036843602}, {11500,0.029876777}, {11600,0.044630332}, {11700,0.030431280}, {11800,0.046644550}, {11900,0.031023697}, {12000,0.039725118}, {12100,0.040876777}, {12200,0.031933649}, {12300,0.048170616}, {12400,0.032535545}, {12500,0.040000000}, {12600,0.049587678}, {12700,0.033398104}, {12800,0.040018957}, {12900,0.050369668}, {13000,0.034312796}, {13100,0.034611374}, {13200,0.042895735}, {13300,0.055364929}, {13400,0.035597156}, {13500,0.035701422}, {13600,0.042151659}, {13700,0.050284360}, {13800,0.044663507}, {13900,0.036990521}, {14000,0.037175355}, {14100,0.037445498}, {14200,0.043364929}, {14300,0.042407583}, {14400,0.054881517}, {14500,0.066303318}, {14600,0.048203791}, {14700,0.053597156}, {14800,0.050947867}, {14900,0.051616114}, {15000,0.040241706}, {15100,0.040511848}, {15200,0.040838863}, {15300,0.041033175}, {15400,0.050691943}, {15500,0.051459716}, {15600,0.054151659}, {15700,0.056549763}, {15800,0.062772512}, {15900,0.062066351}, {16000,0.057976303}, {16100,0.050573460}, {16200,0.043298578}, {16300,0.043872038}, {16400,0.051227488}, {16500,0.066218009}, {16600,0.067696682}, {16700,0.055777251}, {16800,0.045312796}, {16900,0.053545024}, {17000,0.065952607}, {17100,0.055511848}, {17200,0.046483412}, {17300,0.055312796}, {17400,0.075824645}, {17500,0.054175355}, {17600,0.047763033}, {17700,0.068900474}, {17800,0.055099526}, {17900,0.048526066}, {18000,0.073706161}, {18100,0.044194313}, {18200,0.056815166}, {18300,0.052772512}, {18400,0.050071090}, {18500,0.073023697}, {18600,0.050507109}, {18700,0.069161137}, {18800,0.046412322}, {18900,0.070080569}, {19000,0.046573460}, {19100,0.070327014}, {19200,0.050052133}, {19300,0.070393365}, {19400,0.052791469}, {19500,0.076554502}, {19600,0.062364929}, {19700,0.064886256}, {19800,0.067274882}, {19900,0.054393365}, {20000,0.072588517}};
data["big_flat"]["Parametricity; beta"]["actual reif"]["user"] = {{1,0.000127962}, {2,0.000255924}, {3,0.000236967}, {4,0.000298578}, {5,0.000322275}, {6,0.000184834}, {7,0.000232227}, {8,0.000151659}, {9,0.000293839}, {10,0.000165877}, {11,0.000293839}, {12,0.000232227}, {13,0.000241706}, {14,0.000350711}, {15,0.000274882}, {16,0.000293839}, {17,0.000265403}, {18,0.000345972}, {19,0.000265403}, {20,0.000284360}, {21,0.000279621}, {22,0.000336493}, {23,0.000341232}, {24,0.000327014}, {25,0.000251185}, {26,0.000355450}, {27,0.000303318}, {28,0.000317536}, {29,0.000270142}, {30,0.000184834}, {31,0.000293839}, {32,0.000407583}, {33,0.000284360}, {34,0.000293839}, {35,0.000308057}, {36,0.000298578}, {37,0.000341232}, {38,0.000388626}, {39,0.000312796}, {40,0.000364929}, {41,0.000293839}, {42,0.000341232}, {43,0.000222749}, {44,0.000270142}, {45,0.000308057}, {46,0.000312796}, {47,0.000436019}, {48,0.000270142}, {49,0.000308057}, {50,0.000488152}, {51,0.000236967}, {52,0.000436019}, {53,0.000222749}, {54,0.000350711}, {55,0.000473934}, {56,0.000407583}, {57,0.000459716}, {58,0.000194313}, {59,0.000374408}, {60,0.000317536}, {61,0.000289100}, {62,0.000445498}, {63,0.000270142}, {64,0.000393365}, {65,0.000445498}, {66,0.000312796}, {67,0.000521327}, {68,0.000355450}, {69,0.000345972}, {70,0.000431280}, {71,0.000336493}, {72,0.000530806}, {73,0.000379147}, {74,0.000407583}, {75,0.000502370}, {76,0.000341232}, {77,0.000398104}, {78,0.000445498}, {79,0.000393365}, {80,0.000388626}, {81,0.000336493}, {82,0.000336493}, {83,0.000473934}, {84,0.000454976}, {85,0.000345972}, {86,0.000402844}, {87,0.000383886}, {88,0.000388626}, {89,0.000426540}, {90,0.000407583}, {91,0.000417062}, {92,0.000236967}, {93,0.000526066}, {94,0.000601896}, {95,0.000222749}, {96,0.000616114}, {97,0.000407583}, {98,0.000303318}, {99,0.000483412}, {100,0.000402844}, {101,0.000345972}, {102,0.000431280}, {103,0.000535545}, {104,0.000393365}, {105,0.000440758}, {106,0.000379147}, {107,0.000530806}, {108,0.000417062}, {109,0.000398104}, {110,0.000412322}, {111,0.000516588}, {112,0.000364929}, {113,0.000545024}, {114,0.000431280}, {115,0.000469194}, {116,0.000421801}, {117,0.000431280}, {118,0.000578199}, {119,0.000469194}, {120,0.000848341}, {121,0.000327014}, {122,0.000431280}, {123,0.000578199}, {124,0.000412322}, {125,0.000597156}, {126,0.000279621}, {127,0.000620853}, {128,0.000530806}, {129,0.000587678}, {130,0.000379147}, {131,0.000488152}, {132,0.000616114}, {133,0.000483412}, {134,0.000473934}, {135,0.000540284}, {136,0.000554502}, {137,0.000658768}, {138,0.000492891}, {139,0.000587678}, {140,0.000511848}, {141,0.000611374}, {142,0.000597156}, {143,0.000601896}, {144,0.000492891}, {145,0.000516588}, {146,0.000601896}, {147,0.000563981}, {148,0.000668246}, {149,0.000473934}, {150,0.000464455}, {151,0.000644550}, {152,0.000578199}, {153,0.000568720}, {154,0.000990521}, {155,0.000582938}, {156,0.000516588}, {157,0.000658768}, {158,0.000497630}, {159,0.000630332}, {160,0.000668246}, {161,0.000526066}, {162,0.000654028}, {163,0.000611374}, {164,0.000530806}, {165,0.000620853}, {166,0.000450237}, {167,0.000625592}, {168,0.000630332}, {169,0.000658768}, {170,0.000587678}, {171,0.000426540}, {172,0.000464455}, {173,0.000696682}, {174,0.000654028}, {175,0.000601896}, {176,0.000753555}, {177,0.000530806}, {178,0.000573460}, {179,0.000616114}, {180,0.000535545}, {181,0.000658768}, {182,0.000800948}, {183,0.001255924}, {184,0.000710900}, {185,0.000601896}, {186,0.000606635}, {187,0.000710900}, {188,0.000696682}, {189,0.000625592}, {190,0.000616114}, {191,0.000549763}, {192,0.000592417}, {193,0.000654028}, {194,0.000592417}, {195,0.000535545}, {196,0.000639810}, {197,0.000677725}, {198,0.000748815}, {199,0.000729858}, {200,0.000625592}, {201,0.000763033}, {202,0.000805687}, {203,0.000739336}, {204,0.000720379}, {205,0.000687204}, {206,0.000786730}, {207,0.000834123}, {208,0.000786730}, {209,0.000715640}, {210,0.000734597}, {211,0.000616114}, {212,0.000582938}, {213,0.000559242}, {214,0.000459716}, {215,0.000454976}, {216,0.000521327}, {217,0.000488152}, {218,0.000545024}, {219,0.000540284}, {220,0.000592417}, {221,0.000573460}, {222,0.000616114}, {223,0.000710900}, {224,0.000800948}, {225,0.000701422}, {226,0.000706161}, {227,0.000715640}, {228,0.000649289}, {229,0.000725118}, {230,0.000800948}, {231,0.000744076}, {232,0.000616114}, {233,0.000952607}, {234,0.000834123}, {235,0.000777251}, {236,0.000838863}, {237,0.000914692}, {238,0.000900474}, {239,0.000805687}, {240,0.000725118}, {241,0.000630332}, {242,0.000805687}, {243,0.000725118}, {244,0.000687204}, {245,0.000791469}, {246,0.000843602}, {247,0.000734597}, {248,0.000777251}, {249,0.000644550}, {250,0.000549763}, {251,0.000725118}, {252,0.000777251}, {253,0.000691943}, {254,0.000796209}, {255,0.000767773}, {256,0.000725118}, {257,0.000725118}, {258,0.000772512}, {259,0.000853081}, {260,0.000772512}, {261,0.000725118}, {262,0.000829384}, {263,0.000881517}, {264,0.000696682}, {265,0.000739336}, {266,0.000763033}, {267,0.000663507}, {268,0.000573460}, {269,0.000710900}, {270,0.000867299}, {271,0.000691943}, {272,0.000677725}, {273,0.000691943}, {274,0.000862559}, {275,0.000834123}, {276,0.000952607}, {277,0.001194313}, {278,0.000805687}, {279,0.000943128}, {280,0.000781991}, {281,0.000748815}, {282,0.000834123}, {283,0.000962085}, {284,0.000786730}, {285,0.000748815}, {286,0.000909953}, {287,0.000720379}, {288,0.000744076}, {289,0.000838863}, {290,0.000867299}, {291,0.001014218}, {292,0.000810427}, {293,0.000810427}, {294,0.000691943}, {295,0.000886256}, {296,0.000886256}, {297,0.001322275}, {298,0.000739336}, {299,0.000781991}, {300,0.000786730}, {301,0.000805687}, {302,0.000914692}, {303,0.000990521}, {304,0.000881517}, {305,0.000786730}, {306,0.000834123}, {307,0.000924171}, {308,0.000819905}, {309,0.000777251}, {310,0.000706161}, {311,0.001042654}, {312,0.001014218}, {313,0.000744076}, {314,0.000952607}, {315,0.000829384}, {316,0.001407583}, {317,0.000668246}, {318,0.001037915}, {319,0.001127962}, {320,0.000857820}, {321,0.000725118}, {322,0.000834123}, {323,0.000976303}, {324,0.000853081}, {325,0.000848341}, {326,0.001028436}, {327,0.000829384}, {328,0.000966825}, {329,0.001071090}, {330,0.000654028}, {331,0.001109005}, {332,0.001014218}, {333,0.000872038}, {334,0.001454976}, {335,0.000867299}, {336,0.001085308}, {337,0.000843602}, {338,0.000800948}, {339,0.001061611}, {340,0.001075829}, {341,0.000800948}, {342,0.001061611}, {343,0.000819905}, {344,0.000976303}, {345,0.001142180}, {346,0.000772512}, {347,0.000976303}, {348,0.001284360}, {349,0.000663507}, {350,0.001066351}, {351,0.001241706}, {352,0.000734597}, {353,0.001137441}, {354,0.001085308}, {355,0.000772512}, {356,0.001033175}, {357,0.000890995}, {358,0.001118483}, {359,0.000876777}, {360,0.000938389}, {361,0.001090047}, {362,0.000966825}, {363,0.000962085}, {364,0.001056872}, {365,0.000890995}, {366,0.001104265}, {367,0.001028436}, {368,0.001601896}, {369,0.001071090}, {370,0.000990521}, {371,0.000857820}, {372,0.001018957}, {373,0.000995261}, {374,0.000800948}, {375,0.000938389}, {376,0.000966825}, {377,0.001028436}, {378,0.001009479}, {379,0.001232227}, {380,0.000947867}, {381,0.001071090}, {382,0.001080569}, {383,0.001094787}, {384,0.001236967}, {385,0.001132701}, {386,0.001056872}, {387,0.000853081}, {388,0.000933649}, {389,0.001014218}, {390,0.001037915}, {391,0.000981043}, {392,0.001009479}, {393,0.001023697}, {394,0.001056872}, {395,0.000952607}, {396,0.001137441}, {397,0.000971564}, {398,0.001042654}, {399,0.001142180}, {400,0.001454976}, {401,0.001052133}, {402,0.001071090}, {403,0.000843602}, {404,0.001137441}, {405,0.001061611}, {406,0.001293839}, {407,0.000900474}, {408,0.001151659}, {409,0.001094787}, {410,0.001080569}, {411,0.001156398}, {412,0.001023697}, {413,0.001194313}, {414,0.000990521}, {415,0.001781991}, {416,0.001009479}, {417,0.001056872}, {418,0.001118483}, {419,0.001023697}, {420,0.001236967}, {421,0.000971564}, {422,0.001284360}, {423,0.000872038}, {424,0.001165877}, {425,0.001175355}, {426,0.001009479}, {427,0.001146919}, {428,0.001090047}, {429,0.001009479}, {430,0.001170616}, {431,0.001218009}, {432,0.001208531}, {433,0.001165877}, {434,0.001156398}, {435,0.001090047}, {436,0.001080569}, {437,0.001170616}, {438,0.001161137}, {439,0.001218009}, {440,0.001218009}, {441,0.000976303}, {442,0.001199052}, {443,0.001037915}, {444,0.001246445}, {445,0.001672986}, {446,0.001312796}, {447,0.001127962}, {448,0.001156398}, {449,0.001170616}, {450,0.001170616}, {451,0.001180095}, {452,0.000976303}, {453,0.001127962}, {454,0.000853081}, {455,0.001184834}, {456,0.001151659}, {457,0.001118483}, {458,0.001886256}, {459,0.001620853}, {460,0.001189573}, {461,0.001142180}, {462,0.001322275}, {463,0.001184834}, {464,0.000985782}, {465,0.001189573}, {466,0.001421801}, {467,0.001137441}, {468,0.001142180}, {469,0.001345972}, {470,0.001004739}, {471,0.001274882}, {472,0.001047393}, {473,0.001165877}, {474,0.001360190}, {475,0.001042654}, {476,0.001203791}, {477,0.001327014}, {478,0.001156398}, {479,0.001189573}, {480,0.001199052}, {481,0.001208531}, {482,0.001355450}, {483,0.001146919}, {484,0.001246445}, {485,0.001815166}, {486,0.001241706}, {487,0.001274882}, {488,0.001279621}, {489,0.001094787}, {490,0.001208531}, {491,0.001322275}, {492,0.001303318}, {493,0.001184834}, {494,0.001161137}, {495,0.001194313}, {496,0.001459716}, {497,0.001189573}, {498,0.001862559}, {499,0.001620853}, {500,0.001279621}, {505,0.001450237}, {510,0.001090047}, {515,0.001236967}, {520,0.001417062}, {525,0.001345972}, {530,0.001312796}, {535,0.001274882}, {540,0.001241706}, {545,0.001398104}, {550,0.001355450}, {555,0.001113744}, {560,0.001184834}, {565,0.001402844}, {570,0.001398104}, {575,0.001293839}, {580,0.001369668}, {585,0.001383886}, {590,0.001469194}, {595,0.001658768}, {600,0.001554502}, {605,0.001545024}, {610,0.001497630}, {615,0.001592417}, {620,0.001616114}, {625,0.001729858}, {630,0.001758294}, {635,0.001611374}, {640,0.001582938}, {645,0.001620853}, {650,0.001644550}, {655,0.001545024}, {660,0.002184834}, {665,0.001928910}, {670,0.001464455}, {675,0.001393365}, {680,0.001635071}, {685,0.001734597}, {690,0.001715640}, {695,0.001492891}, {700,0.001763033}, {705,0.001568720}, {710,0.001488152}, {715,0.001744076}, {720,0.001511848}, {725,0.001729858}, {730,0.001649289}, {735,0.001644550}, {740,0.001710900}, {745,0.001635071}, {750,0.001777251}, {755,0.002478673}, {760,0.001611374}, {765,0.001857820}, {770,0.001691943}, {775,0.001691943}, {780,0.001753555}, {785,0.001867299}, {790,0.001876777}, {795,0.001914692}, {800,0.001914692}, {805,0.001890995}, {810,0.001853081}, {815,0.001753555}, {820,0.002023697}, {825,0.001805687}, {830,0.001800948}, {835,0.002018957}, {840,0.001924171}, {845,0.001800948}, {850,0.001876777}, {855,0.001914692}, {860,0.002000000}, {865,0.001895735}, {870,0.001957346}, {875,0.002018957}, {880,0.002009479}, {885,0.002037915}, {890,0.002132701}, {895,0.001962085}, {900,0.001966825}, {905,0.002099526}, {910,0.001867299}, {915,0.001981043}, {920,0.002004739}, {925,0.002146919}, {930,0.002151659}, {935,0.001772512}, {940,0.002137441}, {945,0.002156398}, {950,0.002028436}, {955,0.001947867}, {960,0.002099526}, {965,0.002104265}, {970,0.002364929}, {975,0.002194313}, {980,0.002161137}, {985,0.002393365}, {990,0.002469194}, {995,0.002872038}, {1000,0.002094787}, {1010,0.002047393}, {1020,0.002137441}, {1030,0.002270142}, {1040,0.002402844}, {1050,0.002364929}, {1060,0.002227488}, {1070,0.002260664}, {1080,0.002502370}, {1090,0.002549763}, {1100,0.002469194}, {1110,0.002454976}, {1120,0.002445498}, {1130,0.002412322}, {1140,0.002758294}, {1150,0.002426540}, {1160,0.002303318}, {1170,0.002691943}, {1180,0.002573460}, {1190,0.002454976}, {1200,0.002748815}, {1210,0.002582938}, {1220,0.002535545}, {1230,0.002625592}, {1240,0.002876777}, {1250,0.002611374}, {1260,0.002729858}, {1270,0.002753555}, {1280,0.002729858}, {1290,0.002876777}, {1300,0.002815166}, {1310,0.002763033}, {1320,0.002943128}, {1330,0.002924171}, {1340,0.002971564}, {1350,0.002853081}, {1360,0.002805687}, {1370,0.003014218}, {1380,0.002947867}, {1390,0.003052133}, {1400,0.002909953}, {1410,0.002966825}, {1420,0.003028436}, {1430,0.003279621}, {1440,0.003047393}, {1450,0.003132701}, {1460,0.003075829}, {1470,0.003132701}, {1480,0.003123223}, {1490,0.003289100}, {1500,0.003208531}, {1510,0.002938389}, {1520,0.003341232}, {1530,0.003308057}, {1540,0.003341232}, {1550,0.004706161}, {1560,0.003312796}, {1570,0.003364929}, {1580,0.003298578}, {1590,0.004573460}, {1600,0.003379147}, {1610,0.003322275}, {1620,0.003445498}, {1630,0.003526066}, {1640,0.004473934}, {1650,0.003568720}, {1660,0.003573460}, {1670,0.003483412}, {1680,0.003540284}, {1690,0.003597156}, {1700,0.003597156}, {1710,0.003606635}, {1720,0.005436019}, {1730,0.003720379}, {1740,0.003734597}, {1750,0.003767773}, {1760,0.003729858}, {1770,0.003710900}, {1780,0.003767773}, {1790,0.003748815}, {1800,0.003800948}, {1810,0.003800948}, {1820,0.003805687}, {1830,0.003881517}, {1840,0.003886256}, {1850,0.004004739}, {1860,0.003857820}, {1870,0.003805687}, {1880,0.003924171}, {1890,0.003947867}, {1900,0.003924171}, {1910,0.004075829}, {1920,0.006066351}, {1930,0.004199052}, {1940,0.004180095}, {1950,0.004004739}, {1960,0.004066351}, {1970,0.004151659}, {1980,0.004047393}, {1990,0.004014218}, {2000,0.004165877}, {2050,0.004199052}, {2100,0.004478673}, {2150,0.005781991}, {2200,0.004687204}, {2250,0.004592417}, {2300,0.004914692}, {2350,0.004739336}, {2400,0.004786730}, {2450,0.005170616}, {2500,0.005317536}, {2550,0.005222749}, {2600,0.005521327}, {2650,0.005341232}, {2700,0.005734597}, {2750,0.009526066}, {2800,0.005701422}, {2850,0.005990521}, {2900,0.005872038}, {2950,0.006379147}, {3000,0.009625592}, {3050,0.006488152}, {3100,0.006507109}, {3150,0.006654028}, {3200,0.006729858}, {3250,0.009336493}, {3300,0.006909953}, {3350,0.009431280}, {3400,0.007199052}, {3450,0.007317536}, {3500,0.007445498}, {3550,0.007507109}, {3600,0.007620853}, {3650,0.007876777}, {3700,0.007924171}, {3750,0.007957346}, {3800,0.008260664}, {3850,0.008227488}, {3900,0.008383886}, {3950,0.008488152}, {4000,0.008601896}, {4050,0.013563981}, {4100,0.009189573}, {4150,0.011710900}, {4200,0.009251185}, {4250,0.014246445}, {4300,0.009644550}, {4350,0.009611374}, {4400,0.010203791}, {4450,0.010146919}, {4500,0.012947867}, {4550,0.010165877}, {4600,0.010573460}, {4650,0.013815166}, {4700,0.010933649}, {4750,0.013492891}, {4800,0.011061611}, {4850,0.011080569}, {4900,0.014383886}, {4950,0.011568720}, {5000,0.011772512}, {5050,0.014507109}, {5100,0.012042654}, {5150,0.012251185}, {5200,0.014625592}, {5250,0.012526066}, {5300,0.012398104}, {5350,0.012838863}, {5400,0.016720379}, {5450,0.012990521}, {5500,0.013123223}, {5550,0.017672986}, {5600,0.019184834}, {5650,0.013502370}, {5700,0.013663507}, {5750,0.013146919}, {5800,0.017886256}, {5850,0.013867299}, {5900,0.014056872}, {5950,0.014033175}, {6000,0.018000000}, {6050,0.024748815}, {6100,0.014587678}, {6150,0.014516588}, {6200,0.014725118}, {6250,0.017810427}, {6300,0.022644550}, {6350,0.020023697}, {6400,0.015445498}, {6450,0.015146919}, {6500,0.015630332}, {6550,0.015573460}, {6600,0.019810427}, {6650,0.018791469}, {6700,0.020469194}, {6750,0.016469194}, {6800,0.016355450}, {6850,0.016341232}, {6900,0.016658768}, {6950,0.016696682}, {7000,0.016777251}, {7050,0.016943128}, {7100,0.017018957}, {7150,0.017213270}, {7200,0.021848341}, {7250,0.021327014}, {7300,0.022625592}, {7350,0.022549763}, {7400,0.020492891}, {7450,0.026255924}, {7500,0.026815166}, {7550,0.026957346}, {7600,0.026805687}, {7650,0.021895735}, {7700,0.024279621}, {7750,0.023526066}, {7800,0.024023697}, {7850,0.023763033}, {7900,0.018279621}, {7950,0.019260664}, {8000,0.019644550}, {8050,0.019753555}, {8100,0.019981043}, {8150,0.020056872}, {8200,0.020341232}, {8250,0.020298578}, {8300,0.032417062}, {8350,0.026232227}, {8400,0.034421801}, {8450,0.025815166}, {8500,0.021127962}, {8550,0.021270142}, {8600,0.021270142}, {8650,0.021398104}, {8700,0.033345972}, {8750,0.036658768}, {8800,0.026526066}, {8850,0.022208531}, {8900,0.022113744}, {8950,0.022535545}, {9000,0.031535545}, {9050,0.031037915}, {9100,0.022715640}, {9150,0.022943128}, {9200,0.023241706}, {9250,0.035848341}, {9300,0.032606635}, {9350,0.023549763}, {9400,0.023909953}, {9450,0.035090047}, {9500,0.033345972}, {9550,0.024350711}, {9600,0.024293839}, {9650,0.036601896}, {9700,0.035971564}, {9750,0.024947867}, {9800,0.031990521}, {9850,0.035710900}, {9900,0.025165877}, {9950,0.025483412}, {10000,0.044142180}, {10100,0.025791469}, {10200,0.026218009}, {10300,0.033052133}, {10400,0.026545024}, {10500,0.034156398}, {10600,0.038085308}, {10700,0.027540284}, {10800,0.044791469}, {10900,0.027862559}, {11000,0.045412322}, {11100,0.028658768}, {11200,0.035786730}, {11300,0.028957346}, {11400,0.036630332}, {11500,0.029943128}, {11600,0.044417062}, {11700,0.030364929}, {11800,0.046170616}, {11900,0.031161137}, {12000,0.039535545}, {12100,0.040360190}, {12200,0.031834123}, {12300,0.047800948}, {12400,0.032734597}, {12500,0.039919431}, {12600,0.049104265}, {12700,0.033388626}, {12800,0.039800948}, {12900,0.049691943}, {13000,0.034289100}, {13100,0.034497630}, {13200,0.042502370}, {13300,0.055018957}, {13400,0.035592417}, {13500,0.035857820}, {13600,0.042014218}, {13700,0.050018957}, {13800,0.044701422}, {13900,0.037109005}, {14000,0.037042654}, {14100,0.037227488}, {14200,0.043094787}, {14300,0.041876777}, {14400,0.054540284}, {14500,0.066099526}, {14600,0.047663507}, {14700,0.053222749}, {14800,0.050905213}, {14900,0.051298578}, {15000,0.039829384}, {15100,0.040075829}, {15200,0.040601896}, {15300,0.040843602}, {15400,0.050308057}, {15500,0.051199052}, {15600,0.053881517}, {15700,0.056379147}, {15800,0.062706161}, {15900,0.062023697}, {16000,0.057672986}, {16100,0.050137441}, {16200,0.043274882}, {16300,0.043895735}, {16400,0.051080569}, {16500,0.066118483}, {16600,0.067630332}, {16700,0.055819905}, {16800,0.045241706}, {16900,0.053582938}, {17000,0.065734597}, {17100,0.055526066}, {17200,0.046336493}, {17300,0.055208531}, {17400,0.075507109}, {17500,0.054066351}, {17600,0.047881517}, {17700,0.069175355}, {17800,0.055236967}, {17900,0.048459716}, {18000,0.073677725}, {18100,0.043947867}, {18200,0.056549763}, {18300,0.052616114}, {18400,0.049758294}, {18500,0.072933649}, {18600,0.050360190}, {18700,0.069118483}, {18800,0.046094787}, {18900,0.070033175}, {19000,0.046317536}, {19100,0.070298578}, {19200,0.050090047}, {19300,0.070369668}, {19400,0.052488152}, {19500,0.076696682}, {19600,0.062222749}, {19700,0.064966825}, {19800,0.067341232}, {19900,0.054218009}, {20000,0.072492823}};
data["big_flat"]["Parametricity; beta"]["actual reif"]["system"] = {{1,0.000146919}, {2,0.000052133}, {3,0.000018957}, {4,0.000018957}, {5,0.000000000}, {6,0.000000000}, {7,0.000018957}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000014218}, {16,0.000018957}, {17,0.000018957}, {18,0.000000000}, {19,0.000018957}, {20,0.000018957}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000014218}, {25,0.000000000}, {26,0.000018957}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000014218}, {32,0.000000000}, {33,0.000018957}, {34,0.000000000}, {35,0.000018957}, {36,0.000000000}, {37,0.000000000}, {38,0.000018957}, {39,0.000000000}, {40,0.000000000}, {41,0.000018957}, {42,0.000018957}, {43,0.000018957}, {44,0.000000000}, {45,0.000000000}, {46,0.000037915}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000018957}, {53,0.000000000}, {54,0.000000000}, {55,0.000018957}, {56,0.000000000}, {57,0.000018957}, {58,0.000000000}, {59,0.000000000}, {60,0.000014218}, {61,0.000000000}, {62,0.000000000}, {63,0.000018957}, {64,0.000000000}, {65,0.000037915}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000018957}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000014218}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000018957}, {84,0.000018957}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000018957}, {93,0.000018957}, {94,0.000000000}, {95,0.000018957}, {96,0.000000000}, {97,0.000000000}, {98,0.000033175}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000018957}, {104,0.000037915}, {105,0.000000000}, {106,0.000018957}, {107,0.000018957}, {108,0.000037915}, {109,0.000018957}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000018957}, {116,0.000018957}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000018957}, {123,0.000000000}, {124,0.000000000}, {125,0.000018957}, {126,0.000018957}, {127,0.000018957}, {128,0.000000000}, {129,0.000000000}, {130,0.000033175}, {131,0.000000000}, {132,0.000018957}, {133,0.000000000}, {134,0.000018957}, {135,0.000018957}, {136,0.000000000}, {137,0.000000000}, {138,0.000014218}, {139,0.000000000}, {140,0.000018957}, {141,0.000000000}, {142,0.000056872}, {143,0.000000000}, {144,0.000000000}, {145,0.000018957}, {146,0.000018957}, {147,0.000037915}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000014218}, {153,0.000000000}, {154,0.000000000}, {155,0.000014218}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000018957}, {163,0.000000000}, {164,0.000018957}, {165,0.000000000}, {166,0.000018957}, {167,0.000000000}, {168,0.000000000}, {169,0.000037915}, {170,0.000047393}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000018957}, {175,0.000037915}, {176,0.000000000}, {177,0.000000000}, {178,0.000037915}, {179,0.000000000}, {180,0.000000000}, {181,0.000018957}, {182,0.000000000}, {183,0.000018957}, {184,0.000018957}, {185,0.000000000}, {186,0.000018957}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000037915}, {192,0.000018957}, {193,0.000018957}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000018957}, {198,0.000018957}, {199,0.000018957}, {200,0.000018957}, {201,0.000000000}, {202,0.000014218}, {203,0.000000000}, {204,0.000000000}, {205,0.000018957}, {206,0.000000000}, {207,0.000018957}, {208,0.000018957}, {209,0.000018957}, {210,0.000000000}, {211,0.000018957}, {212,0.000018957}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000018957}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000037915}, {224,0.000018957}, {225,0.000000000}, {226,0.000018957}, {227,0.000000000}, {228,0.000000000}, {229,0.000018957}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000018957}, {239,0.000000000}, {240,0.000018957}, {241,0.000000000}, {242,0.000000000}, {243,0.000018957}, {244,0.000018957}, {245,0.000000000}, {246,0.000000000}, {247,0.000033175}, {248,0.000018957}, {249,0.000014218}, {250,0.000000000}, {251,0.000000000}, {252,0.000018957}, {253,0.000018957}, {254,0.000014218}, {255,0.000052133}, {256,0.000000000}, {257,0.000033175}, {258,0.000037915}, {259,0.000018957}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000018957}, {264,0.000018957}, {265,0.000014218}, {266,0.000000000}, {267,0.000018957}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000018957}, {274,0.000018957}, {275,0.000014218}, {276,0.000000000}, {277,0.000037915}, {278,0.000000000}, {279,0.000000000}, {280,0.000018957}, {281,0.000000000}, {282,0.000037915}, {283,0.000018957}, {284,0.000018957}, {285,0.000000000}, {286,0.000000000}, {287,0.000037915}, {288,0.000037915}, {289,0.000000000}, {290,0.000000000}, {291,0.000037915}, {292,0.000000000}, {293,0.000000000}, {294,0.000018957}, {295,0.000018957}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000018957}, {300,0.000000000}, {301,0.000018957}, {302,0.000018957}, {303,0.000000000}, {304,0.000018957}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000018957}, {309,0.000014218}, {310,0.000000000}, {311,0.000018957}, {312,0.000000000}, {313,0.000014218}, {314,0.000000000}, {315,0.000000000}, {316,0.000018957}, {317,0.000018957}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000018957}, {327,0.000000000}, {328,0.000000000}, {329,0.000018957}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000018957}, {335,0.000000000}, {336,0.000018957}, {337,0.000018957}, {338,0.000000000}, {339,0.000000000}, {340,0.000018957}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000018957}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000018957}, {351,0.000018957}, {352,0.000018957}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000018957}, {357,0.000037915}, {358,0.000018957}, {359,0.000000000}, {360,0.000018957}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000018957}, {366,0.000000000}, {367,0.000000000}, {368,0.000018957}, {369,0.000014218}, {370,0.000000000}, {371,0.000033175}, {372,0.000037915}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000018957}, {382,0.000000000}, {383,0.000000000}, {384,0.000037915}, {385,0.000056872}, {386,0.000000000}, {387,0.000000000}, {388,0.000018957}, {389,0.000000000}, {390,0.000018957}, {391,0.000000000}, {392,0.000000000}, {393,0.000018957}, {394,0.000014218}, {395,0.000047393}, {396,0.000000000}, {397,0.000000000}, {398,0.000014218}, {399,0.000000000}, {400,0.000033175}, {401,0.000018957}, {402,0.000000000}, {403,0.000000000}, {404,0.000037915}, {405,0.000000000}, {406,0.000018957}, {407,0.000018957}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000018957}, {415,0.000000000}, {416,0.000000000}, {417,0.000018957}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000018957}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000037915}, {430,0.000033175}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000018957}, {435,0.000000000}, {436,0.000000000}, {437,0.000018957}, {438,0.000000000}, {439,0.000000000}, {440,0.000018957}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000037915}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000014218}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000018957}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000037915}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000018957}, {471,0.000000000}, {472,0.000000000}, {473,0.000018957}, {474,0.000000000}, {475,0.000000000}, {476,0.000018957}, {477,0.000000000}, {478,0.000018957}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000018957}, {483,0.000000000}, {484,0.000000000}, {485,0.000056872}, {486,0.000000000}, {487,0.000018957}, {488,0.000018957}, {489,0.000000000}, {490,0.000000000}, {491,0.000018957}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000018957}, {496,0.000037915}, {497,0.000000000}, {498,0.000018957}, {499,0.000018957}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000014218}, {545,0.000018957}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000018957}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000018957}, {610,0.000000000}, {615,0.000000000}, {620,0.000033175}, {625,0.000075829}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000018957}, {660,0.000000000}, {665,0.000037915}, {670,0.000033175}, {675,0.000037915}, {680,0.000033175}, {685,0.000000000}, {690,0.000000000}, {695,0.000018957}, {700,0.000000000}, {705,0.000018957}, {710,0.000018957}, {715,0.000000000}, {720,0.000018957}, {725,0.000037915}, {730,0.000056872}, {735,0.000000000}, {740,0.000018957}, {745,0.000000000}, {750,0.000033175}, {755,0.000018957}, {760,0.000000000}, {765,0.000018957}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000018957}, {805,0.000018957}, {810,0.000018957}, {815,0.000037915}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000018957}, {845,0.000000000}, {850,0.000018957}, {855,0.000037915}, {860,0.000000000}, {865,0.000033175}, {870,0.000000000}, {875,0.000014218}, {880,0.000037915}, {885,0.000018957}, {890,0.000000000}, {895,0.000000000}, {900,0.000037915}, {905,0.000052133}, {910,0.000000000}, {915,0.000018957}, {920,0.000037915}, {925,0.000018957}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000018957}, {960,0.000037915}, {965,0.000000000}, {970,0.000018957}, {975,0.000018957}, {980,0.000000000}, {985,0.000014218}, {990,0.000000000}, {995,0.000018957}, {1000,0.000018957}, {1010,0.000000000}, {1020,0.000018957}, {1030,0.000000000}, {1040,0.000018957}, {1050,0.000000000}, {1060,0.000018957}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000018957}, {1100,0.000018957}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000014218}, {1150,0.000000000}, {1160,0.000018957}, {1170,0.000018957}, {1180,0.000000000}, {1190,0.000018957}, {1200,0.000000000}, {1210,0.000037915}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000037915}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000037915}, {1290,0.000000000}, {1300,0.000018957}, {1310,0.000000000}, {1320,0.000018957}, {1330,0.000037915}, {1340,0.000018957}, {1350,0.000000000}, {1360,0.000037915}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000014218}, {1410,0.000000000}, {1420,0.000033175}, {1430,0.000000000}, {1440,0.000018957}, {1450,0.000056872}, {1460,0.000018957}, {1470,0.000000000}, {1480,0.000018957}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000018957}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000075829}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000018957}, {1590,0.000037915}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000018957}, {1660,0.000018957}, {1670,0.000014218}, {1680,0.000000000}, {1690,0.000018957}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000071090}, {1730,0.000000000}, {1740,0.000018957}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000018957}, {1820,0.000000000}, {1830,0.000037915}, {1840,0.000033175}, {1850,0.000000000}, {1860,0.000052133}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000075829}, {1900,0.000000000}, {1910,0.000014218}, {1920,0.000113744}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000037915}, {1960,0.000018957}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000037915}, {2000,0.000018957}, {2050,0.000000000}, {2100,0.000018957}, {2150,0.000018957}, {2200,0.000000000}, {2250,0.000056872}, {2300,0.000000000}, {2350,0.000018957}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000018957}, {2550,0.000018957}, {2600,0.000000000}, {2650,0.000018957}, {2700,0.000018957}, {2750,0.000033175}, {2800,0.000018957}, {2850,0.000028436}, {2900,0.000037915}, {2950,0.000018957}, {3000,0.000075829}, {3050,0.000018957}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000094787}, {3300,0.000018957}, {3350,0.000018957}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000018957}, {3650,0.000056872}, {3700,0.000018957}, {3750,0.000014218}, {3800,0.000018957}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000052133}, {4000,0.000018957}, {4050,0.000109005}, {4100,0.000037915}, {4150,0.000037915}, {4200,0.000000000}, {4250,0.000071090}, {4300,0.000071090}, {4350,0.000052133}, {4400,0.000018957}, {4450,0.000000000}, {4500,0.000071090}, {4550,0.000014218}, {4600,0.000000000}, {4650,0.000127962}, {4700,0.000018957}, {4750,0.000018957}, {4800,0.000000000}, {4850,0.000018957}, {4900,0.000113744}, {4950,0.000018957}, {5000,0.000000000}, {5050,0.000071090}, {5100,0.000000000}, {5150,0.000000000}, {5200,0.000000000}, {5250,0.000000000}, {5300,0.000018957}, {5350,0.000000000}, {5400,0.000113744}, {5450,0.000037915}, {5500,0.000033175}, {5550,0.000109005}, {5600,0.000052133}, {5650,0.000075829}, {5700,0.000000000}, {5750,0.000000000}, {5800,0.000113744}, {5850,0.000018957}, {5900,0.000000000}, {5950,0.000000000}, {6000,0.000056872}, {6050,0.000933649}, {6100,0.000000000}, {6150,0.000000000}, {6200,0.000014218}, {6250,0.000052133}, {6300,0.000056872}, {6350,0.000094787}, {6400,0.000000000}, {6450,0.000000000}, {6500,0.000018957}, {6550,0.000018957}, {6600,0.000113744}, {6650,0.000142180}, {6700,0.000047393}, {6750,0.000000000}, {6800,0.000018957}, {6850,0.000018957}, {6900,0.000018957}, {6950,0.000000000}, {7000,0.000018957}, {7050,0.000000000}, {7100,0.000018957}, {7150,0.000000000}, {7200,0.000094787}, {7250,0.000151659}, {7300,0.000151659}, {7350,0.000037915}, {7400,0.000018957}, {7450,0.000075829}, {7500,0.000132701}, {7550,0.000113744}, {7600,0.000146919}, {7650,0.000056872}, {7700,0.000033175}, {7750,0.000056872}, {7800,0.000037915}, {7850,0.000075829}, {7900,0.000018957}, {7950,0.000075829}, {8000,0.000018957}, {8050,0.000000000}, {8100,0.000000000}, {8150,0.000056872}, {8200,0.000056872}, {8250,0.000000000}, {8300,0.000094787}, {8350,0.000161137}, {8400,0.000165877}, {8450,0.000000000}, {8500,0.000000000}, {8550,0.000037915}, {8600,0.000000000}, {8650,0.000000000}, {8700,0.000071090}, {8750,0.000071090}, {8800,0.000037915}, {8850,0.000018957}, {8900,0.000018957}, {8950,0.000000000}, {9000,0.000274882}, {9050,0.000000000}, {9100,0.000018957}, {9150,0.000018957}, {9200,0.000000000}, {9250,0.000232227}, {9300,0.000018957}, {9350,0.000056872}, {9400,0.000037915}, {9450,0.000113744}, {9500,0.000279621}, {9550,0.000000000}, {9600,0.000000000}, {9650,0.000184834}, {9700,0.000364929}, {9750,0.000018957}, {9800,0.000094787}, {9850,0.000170616}, {9900,0.000018957}, {9950,0.000037915}, {10000,0.000616114}, {10100,0.000052133}, {10200,0.000037915}, {10300,0.000170616}, {10400,0.000037915}, {10500,0.000146919}, {10600,0.000218009}, {10700,0.000018957}, {10800,0.000417062}, {10900,0.000056872}, {11000,0.000293839}, {11100,0.000018957}, {11200,0.000189573}, {11300,0.000056872}, {11400,0.000236967}, {11500,0.000000000}, {11600,0.000364929}, {11700,0.000052133}, {11800,0.000383886}, {11900,0.000000000}, {12000,0.000246445}, {12100,0.000165877}, {12200,0.000018957}, {12300,0.000227488}, {12400,0.000018957}, {12500,0.000189573}, {12600,0.000322275}, {12700,0.000000000}, {12800,0.000274882}, {12900,0.000521327}, {13000,0.000018957}, {13100,0.000000000}, {13200,0.000218009}, {13300,0.000184834}, {13400,0.000033175}, {13500,0.000018957}, {13600,0.000127962}, {13700,0.000189573}, {13800,0.000000000}, {13900,0.000018957}, {14000,0.000000000}, {14100,0.000000000}, {14200,0.000127962}, {14300,0.000255924}, {14400,0.000184834}, {14500,0.000374408}, {14600,0.000132701}, {14700,0.000208531}, {14800,0.000109005}, {14900,0.000208531}, {15000,0.000037915}, {15100,0.000000000}, {15200,0.000018957}, {15300,0.000037915}, {15400,0.000146919}, {15500,0.000132701}, {15600,0.000407583}, {15700,0.000260664}, {15800,0.000184834}, {15900,0.000246445}, {16000,0.000203791}, {16100,0.000018957}, {16200,0.000018957}, {16300,0.000000000}, {16400,0.000127962}, {16500,0.000255924}, {16600,0.000085308}, {16700,0.000018957}, {16800,0.000018957}, {16900,0.000151659}, {17000,0.000317536}, {17100,0.000037915}, {17200,0.000000000}, {17300,0.000132701}, {17400,0.000398104}, {17500,0.000018957}, {17600,0.000000000}, {17700,0.000000000}, {17800,0.000037915}, {17900,0.000018957}, {18000,0.000056872}, {18100,0.000000000}, {18200,0.000000000}, {18300,0.000018957}, {18400,0.000000000}, {18500,0.000000000}, {18600,0.000018957}, {18700,0.000018957}, {18800,0.000037915}, {18900,0.000000000}, {19000,0.000000000}, {19100,0.000018957}, {19200,0.000018957}, {19300,0.000056872}, {19400,0.000018957}, {19500,0.000000000}, {19600,0.000000000}, {19700,0.000018957}, {19800,0.000000000}, {19900,0.000000000}, {20000,0.000019139}};
data["big_flat"]["Parametricity; beta"]["cbv"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000080569}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000004739}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000431280}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000492891}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000469194}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000478673}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000511848}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000018957}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000597156}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000644550}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000914692}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.001236967}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000004739}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000004739}, {980,0.000000000}, {985,0.000000000}, {990,0.000018957}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000004739}, {1050,0.000004739}, {1060,0.000957346}, {1070,0.000000000}, {1080,0.000018957}, {1090,0.000075829}, {1100,0.000109005}, {1110,0.000142180}, {1120,0.000213270}, {1130,0.000289100}, {1140,0.000341232}, {1150,0.000436019}, {1160,0.000511848}, {1170,0.000568720}, {1180,0.000682464}, {1190,0.000687204}, {1200,0.000786730}, {1210,0.000800948}, {1220,0.000819905}, {1230,0.000848341}, {1240,0.000872038}, {1250,0.000867299}, {1260,0.000938389}, {1270,0.000947867}, {1280,0.000947867}, {1290,0.001000000}, {1300,0.002052133}, {1310,0.001000000}, {1320,0.001000000}, {1330,0.001000000}, {1340,0.001000000}, {1350,0.001000000}, {1360,0.001000000}, {1370,0.001000000}, {1380,0.001000000}, {1390,0.001000000}, {1400,0.001928910}, {1410,0.001000000}, {1420,0.001000000}, {1430,0.001000000}, {1440,0.001000000}, {1450,0.002483412}, {1460,0.001000000}, {1470,0.001000000}, {1480,0.001000000}, {1490,0.001000000}, {1500,0.001000000}, {1510,0.001000000}, {1520,0.001000000}, {1530,0.001000000}, {1540,0.001000000}, {1550,0.001000000}, {1560,0.001000000}, {1570,0.001000000}, {1580,0.001000000}, {1590,0.001000000}, {1600,0.001000000}, {1610,0.001000000}, {1620,0.001000000}, {1630,0.001000000}, {1640,0.001000000}, {1650,0.001000000}, {1660,0.001000000}, {1670,0.001000000}, {1680,0.001971564}, {1690,0.001000000}, {1700,0.001000000}, {1710,0.001000000}, {1720,0.001000000}, {1730,0.001000000}, {1740,0.001000000}, {1750,0.001000000}, {1760,0.001000000}, {1770,0.001000000}, {1780,0.001000000}, {1790,0.001000000}, {1800,0.001000000}, {1810,0.001000000}, {1820,0.001000000}, {1830,0.001000000}, {1840,0.001000000}, {1850,0.001000000}, {1860,0.001000000}, {1870,0.001000000}, {1880,0.001000000}, {1890,0.001000000}, {1900,0.001000000}, {1910,0.001000000}, {1920,0.001000000}, {1930,0.001009479}, {1940,0.001004739}, {1950,0.001000000}, {1960,0.001000000}, {1970,0.001000000}, {1980,0.001009479}, {1990,0.001004739}, {2000,0.003791469}, {2050,0.001018957}, {2100,0.001066351}, {2150,0.001180095}, {2200,0.001284360}, {2250,0.001393365}, {2300,0.001497630}, {2350,0.001611374}, {2400,0.001777251}, {2450,0.001890995}, {2500,0.001938389}, {2550,0.001943128}, {2600,0.001976303}, {2650,0.001995261}, {2700,0.002000000}, {2750,0.002000000}, {2800,0.002000000}, {2850,0.002000000}, {2900,0.002004739}, {2950,0.002009479}, {3000,0.002018957}, {3050,0.002118483}, {3100,0.002194313}, {3150,0.002222749}, {3200,0.002327014}, {3250,0.003606635}, {3300,0.002478673}, {3350,0.002516588}, {3400,0.002606635}, {3450,0.002748815}, {3500,0.002800948}, {3550,0.002895735}, {3600,0.002928910}, {3650,0.002952607}, {3700,0.002957346}, {3750,0.002976303}, {3800,0.002995261}, {3850,0.003000000}, {3900,0.003037915}, {3950,0.003052133}, {4000,0.003123223}, {4050,0.003194313}, {4100,0.003260664}, {4150,0.003270142}, {4200,0.003355450}, {4250,0.003364929}, {4300,0.003431280}, {4350,0.003483412}, {4400,0.003592417}, {4450,0.003644550}, {4500,0.008962085}, {4550,0.003781991}, {4600,0.003834123}, {4650,0.003928910}, {4700,0.003962085}, {4750,0.003971564}, {4800,0.003995261}, {4850,0.004090047}, {4900,0.004014218}, {4950,0.004175355}, {5000,0.004203791}, {5050,0.004018957}, {5100,0.004270142}, {5150,0.004383886}, {5200,0.004379147}, {5250,0.004478673}, {5300,0.004492891}, {5350,0.004530806}, {5400,0.004691943}, {5450,0.004701422}, {5500,0.004753555}, {5550,0.004819905}, {5600,0.004876777}, {5650,0.004957346}, {5700,0.005004739}, {5750,0.005028436}, {5800,0.005127962}, {5850,0.005109005}, {5900,0.005170616}, {5950,0.005203791}, {6000,0.010184834}, {6050,0.005331754}, {6100,0.005393365}, {6150,0.005431280}, {6200,0.005426540}, {6250,0.005488152}, {6300,0.005649289}, {6350,0.005630332}, {6400,0.005706161}, {6450,0.005800948}, {6500,0.005744076}, {6550,0.005687204}, {6600,0.005981043}, {6650,0.006142180}, {6700,0.006109005}, {6750,0.006118483}, {6800,0.006189573}, {6850,0.006227488}, {6900,0.006298578}, {6950,0.006312796}, {7000,0.006364929}, {7050,0.006412322}, {7100,0.009824645}, {7150,0.012668246}, {7200,0.006507109}, {7250,0.009957346}, {7300,0.015308057}, {7350,0.014706161}, {7400,0.006990521}, {7450,0.007061611}, {7500,0.007189573}, {7550,0.007203791}, {7600,0.007189573}, {7650,0.007303318}, {7700,0.011644550}, {7750,0.012545024}, {7800,0.012710900}, {7850,0.007232227}, {7900,0.007436019}, {7950,0.012099526}, {8000,0.007327014}, {8050,0.007502370}, {8100,0.007568720}, {8150,0.007672986}, {8200,0.007748815}, {8250,0.007763033}, {8300,0.007890995}, {8350,0.007933649}, {8400,0.008118483}, {8450,0.012075829}, {8500,0.013180095}, {8550,0.008146919}, {8600,0.008251185}, {8650,0.008308057}, {8700,0.008317536}, {8750,0.008407583}, {8800,0.012478673}, {8850,0.011881517}, {8900,0.008497630}, {8950,0.008606635}, {9000,0.008644550}, {9050,0.008862559}, {9100,0.014734597}, {9150,0.008848341}, {9200,0.008886256}, {9250,0.008962085}, {9300,0.014227488}, {9350,0.009071090}, {9400,0.009189573}, {9450,0.009227488}, {9500,0.017260664}, {9550,0.009374408}, {9600,0.009393365}, {9650,0.009436019}, {9700,0.009464455}, {9750,0.009554502}, {9800,0.009530806}, {9850,0.017483412}, {9900,0.009734597}, {9950,0.009848341}, {10000,0.009952607}, {10100,0.009450237}, {10200,0.010090047}, {10300,0.010327014}, {10400,0.010289100}, {10500,0.010383886}, {10600,0.010303318}, {10700,0.010663507}, {10800,0.011099526}, {10900,0.010829384}, {11000,0.010985782}, {11100,0.010497630}, {11200,0.011194313}, {11300,0.022459716}, {11400,0.011507109}, {11500,0.022611374}, {11600,0.011663507}, {11700,0.011848341}, {11800,0.011933649}, {11900,0.011995261}, {12000,0.027592417}, {12100,0.012213270}, {12200,0.025957346}, {12300,0.012464455}, {12400,0.012630332}, {12500,0.027090047}, {12600,0.012867299}, {12700,0.012981043}, {12800,0.012317536}, {12900,0.013199052}, {13000,0.013312796}, {13100,0.025587678}, {13200,0.024260664}, {13300,0.013691943}, {13400,0.013800948}, {13500,0.026018957}, {13600,0.026957346}, {13700,0.014142180}, {13800,0.014189573}, {13900,0.014322275}, {14000,0.014412322}, {14100,0.024905213}, {14200,0.025483412}, {14300,0.014985782}, {14400,0.014900474}, {14500,0.015085308}, {14600,0.015170616}, {14700,0.015241706}, {14800,0.015445498}, {14900,0.015507109}, {15000,0.015635071}, {15100,0.015758294}, {15200,0.015900474}, {15300,0.016023697}, {15400,0.016104265}, {15500,0.016213270}, {15600,0.016355450}, {15700,0.016450237}, {15800,0.016516588}, {15900,0.016682464}, {16000,0.017075829}, {16100,0.027805687}, {16200,0.024469194}, {16300,0.024720379}, {16400,0.017236967}, {16500,0.017450237}, {16600,0.017526066}, {16700,0.026914692}, {16800,0.029080569}, {16900,0.017857820}, {17000,0.018037915}, {17100,0.018407583}, {17200,0.030090047}, {17300,0.018317536}, {17400,0.018412322}, {17500,0.031464455}, {17600,0.017763033}, {17700,0.018810427}, {17800,0.032715640}, {17900,0.018492891}, {18000,0.019104265}, {18100,0.027421801}, {18200,0.019369668}, {18300,0.019791469}, {18400,0.025985782}, {18500,0.019734597}, {18600,0.031734597}, {18700,0.019957346}, {18800,0.041739336}, {18900,0.020175355}, {19000,0.029881517}, {19100,0.020345972}, {19200,0.039990521}, {19300,0.020672986}, {19400,0.031431280}, {19500,0.020819905}, {19600,0.019928910}, {19700,0.033672986}, {19800,0.021180095}, {19900,0.034127962}, {20000,0.021430622}};
data["big_flat"]["Parametricity; beta"]["cbv"]["user"] = {{1,0.000018957}, {2,0.000000000}, {3,0.000033175}, {4,0.000047393}, {5,0.000000000}, {6,0.000033175}, {7,0.000000000}, {8,0.000028436}, {9,0.000037915}, {10,0.000052133}, {11,0.000033175}, {12,0.000033175}, {13,0.000000000}, {14,0.000018957}, {15,0.000028436}, {16,0.000080569}, {17,0.000018957}, {18,0.000052133}, {19,0.000000000}, {20,0.000061611}, {21,0.000018957}, {22,0.000033175}, {23,0.000018957}, {24,0.000052133}, {25,0.000071090}, {26,0.000033175}, {27,0.000037915}, {28,0.000052133}, {29,0.000165877}, {30,0.000056872}, {31,0.000047393}, {32,0.000028436}, {33,0.000066351}, {34,0.000071090}, {35,0.000066351}, {36,0.000085308}, {37,0.000037915}, {38,0.000028436}, {39,0.000071090}, {40,0.000085308}, {41,0.000056872}, {42,0.000056872}, {43,0.000090047}, {44,0.000071090}, {45,0.000000000}, {46,0.000071090}, {47,0.000056872}, {48,0.000033175}, {49,0.000123223}, {50,0.000028436}, {51,0.000132701}, {52,0.000109005}, {53,0.000018957}, {54,0.000075829}, {55,0.000033175}, {56,0.000094787}, {57,0.000104265}, {58,0.000127962}, {59,0.000151659}, {60,0.000099526}, {61,0.000066351}, {62,0.000052133}, {63,0.000061611}, {64,0.000113744}, {65,0.000018957}, {66,0.000033175}, {67,0.000066351}, {68,0.000066351}, {69,0.000123223}, {70,0.000094787}, {71,0.000080569}, {72,0.000085308}, {73,0.000071090}, {74,0.000052133}, {75,0.000014218}, {76,0.000085308}, {77,0.000071090}, {78,0.000085308}, {79,0.000033175}, {80,0.000109005}, {81,0.000137441}, {82,0.000052133}, {83,0.000094787}, {84,0.000090047}, {85,0.000080569}, {86,0.000113744}, {87,0.000104265}, {88,0.000109005}, {89,0.000052133}, {90,0.000180095}, {91,0.000066351}, {92,0.000080569}, {93,0.000123223}, {94,0.000156398}, {95,0.000109005}, {96,0.000090047}, {97,0.000109005}, {98,0.000113744}, {99,0.000099526}, {100,0.000061611}, {101,0.000066351}, {102,0.000161137}, {103,0.000109005}, {104,0.000056872}, {105,0.000109005}, {106,0.000071090}, {107,0.000080569}, {108,0.000118483}, {109,0.000113744}, {110,0.000099526}, {111,0.000099526}, {112,0.000104265}, {113,0.000127962}, {114,0.000085308}, {115,0.000066351}, {116,0.000137441}, {117,0.000203791}, {118,0.000142180}, {119,0.000047393}, {120,0.000170616}, {121,0.000156398}, {122,0.000142180}, {123,0.000123223}, {124,0.000085308}, {125,0.000094787}, {126,0.000104265}, {127,0.000132701}, {128,0.000151659}, {129,0.000090047}, {130,0.000137441}, {131,0.000156398}, {132,0.000123223}, {133,0.000165877}, {134,0.000132701}, {135,0.000061611}, {136,0.000137441}, {137,0.000137441}, {138,0.000052133}, {139,0.000175355}, {140,0.000127962}, {141,0.000184834}, {142,0.000123223}, {143,0.000099526}, {144,0.000090047}, {145,0.000151659}, {146,0.000052133}, {147,0.000184834}, {148,0.000075829}, {149,0.000161137}, {150,0.000137441}, {151,0.000208531}, {152,0.000113744}, {153,0.000146919}, {154,0.000151659}, {155,0.000132701}, {156,0.000151659}, {157,0.000132701}, {158,0.000184834}, {159,0.000194313}, {160,0.000113744}, {161,0.000255924}, {162,0.000227488}, {163,0.000184834}, {164,0.000109005}, {165,0.000184834}, {166,0.000151659}, {167,0.000099526}, {168,0.000203791}, {169,0.000184834}, {170,0.000118483}, {171,0.000061611}, {172,0.000265403}, {173,0.000151659}, {174,0.000137441}, {175,0.000194313}, {176,0.000113744}, {177,0.000127962}, {178,0.000189573}, {179,0.000127962}, {180,0.000341232}, {181,0.000327014}, {182,0.000137441}, {183,0.000189573}, {184,0.000118483}, {185,0.000199052}, {186,0.000146919}, {187,0.000104265}, {188,0.000175355}, {189,0.000000000}, {190,0.000218009}, {191,0.000137441}, {192,0.000066351}, {193,0.000289100}, {194,0.000194313}, {195,0.000146919}, {196,0.000251185}, {197,0.000251185}, {198,0.000118483}, {199,0.000227488}, {200,0.000146919}, {201,0.000175355}, {202,0.000137441}, {203,0.000274882}, {204,0.000255924}, {205,0.000170616}, {206,0.000298578}, {207,0.000199052}, {208,0.000175355}, {209,0.000545024}, {210,0.000199052}, {211,0.000270142}, {212,0.000184834}, {213,0.000222749}, {214,0.000270142}, {215,0.000142180}, {216,0.000170616}, {217,0.000189573}, {218,0.000199052}, {219,0.000123223}, {220,0.000199052}, {221,0.000199052}, {222,0.000161137}, {223,0.000165877}, {224,0.000094787}, {225,0.000085308}, {226,0.000137441}, {227,0.000165877}, {228,0.000184834}, {229,0.000303318}, {230,0.000222749}, {231,0.000194313}, {232,0.000308057}, {233,0.000227488}, {234,0.000156398}, {235,0.000113744}, {236,0.000151659}, {237,0.000175355}, {238,0.000104265}, {239,0.000184834}, {240,0.000227488}, {241,0.000156398}, {242,0.000161137}, {243,0.000170616}, {244,0.000227488}, {245,0.000132701}, {246,0.000203791}, {247,0.000199052}, {248,0.000251185}, {249,0.000251185}, {250,0.000308057}, {251,0.000227488}, {252,0.000222749}, {253,0.000109005}, {254,0.000161137}, {255,0.000142180}, {256,0.000317536}, {257,0.000260664}, {258,0.000232227}, {259,0.000236967}, {260,0.000222749}, {261,0.000251185}, {262,0.000312796}, {263,0.000213270}, {264,0.000336493}, {265,0.000270142}, {266,0.000123223}, {267,0.000218009}, {268,0.000232227}, {269,0.000232227}, {270,0.000246445}, {271,0.000189573}, {272,0.000251185}, {273,0.000284360}, {274,0.000232227}, {275,0.000270142}, {276,0.000289100}, {277,0.000644550}, {278,0.000118483}, {279,0.000137441}, {280,0.000327014}, {281,0.000246445}, {282,0.000199052}, {283,0.000241706}, {284,0.000270142}, {285,0.000293839}, {286,0.000199052}, {287,0.000255924}, {288,0.000236967}, {289,0.000180095}, {290,0.000218009}, {291,0.000189573}, {292,0.000298578}, {293,0.000265403}, {294,0.000255924}, {295,0.000236967}, {296,0.000222749}, {297,0.000327014}, {298,0.000279621}, {299,0.000327014}, {300,0.000180095}, {301,0.000279621}, {302,0.000289100}, {303,0.000336493}, {304,0.000284360}, {305,0.000298578}, {306,0.000189573}, {307,0.000241706}, {308,0.000417062}, {309,0.000199052}, {310,0.000303318}, {311,0.000208531}, {312,0.000203791}, {313,0.000218009}, {314,0.000241706}, {315,0.000336493}, {316,0.000255924}, {317,0.000284360}, {318,0.000203791}, {319,0.000279621}, {320,0.000483412}, {321,0.000331754}, {322,0.000203791}, {323,0.000336493}, {324,0.000298578}, {325,0.000222749}, {326,0.000241706}, {327,0.000236967}, {328,0.000298578}, {329,0.000227488}, {330,0.000355450}, {331,0.000208531}, {332,0.000274882}, {333,0.000284360}, {334,0.000232227}, {335,0.000369668}, {336,0.000279621}, {337,0.000369668}, {338,0.000203791}, {339,0.000090047}, {340,0.000350711}, {341,0.000336493}, {342,0.000194313}, {343,0.000251185}, {344,0.000270142}, {345,0.000360190}, {346,0.000336493}, {347,0.000194313}, {348,0.000331754}, {349,0.000317536}, {350,0.000180095}, {351,0.000440758}, {352,0.000725118}, {353,0.000284360}, {354,0.000308057}, {355,0.000322275}, {356,0.000255924}, {357,0.000227488}, {358,0.000289100}, {359,0.000364929}, {360,0.000284360}, {361,0.000369668}, {362,0.000345972}, {363,0.000251185}, {364,0.000369668}, {365,0.000322275}, {366,0.000113744}, {367,0.000350711}, {368,0.000161137}, {369,0.000284360}, {370,0.000336493}, {371,0.000274882}, {372,0.000270142}, {373,0.000369668}, {374,0.000293839}, {375,0.000379147}, {376,0.000383886}, {377,0.000260664}, {378,0.000393365}, {379,0.000180095}, {380,0.000241706}, {381,0.000241706}, {382,0.000364929}, {383,0.000189573}, {384,0.000322275}, {385,0.000540284}, {386,0.000317536}, {387,0.000336493}, {388,0.000445498}, {389,0.000355450}, {390,0.000260664}, {391,0.000312796}, {392,0.000317536}, {393,0.000274882}, {394,0.000327014}, {395,0.000222749}, {396,0.000236967}, {397,0.000426540}, {398,0.000341232}, {399,0.000180095}, {400,0.000436019}, {401,0.000251185}, {402,0.000383886}, {403,0.000360190}, {404,0.000407583}, {405,0.000232227}, {406,0.000341232}, {407,0.000341232}, {408,0.000260664}, {409,0.000488152}, {410,0.000123223}, {411,0.000293839}, {412,0.000303318}, {413,0.000345972}, {414,0.000374408}, {415,0.000137441}, {416,0.000293839}, {417,0.000255924}, {418,0.000516588}, {419,0.000440758}, {420,0.000322275}, {421,0.000270142}, {422,0.000393365}, {423,0.000331754}, {424,0.000436019}, {425,0.000213270}, {426,0.000431280}, {427,0.000289100}, {428,0.000327014}, {429,0.000345972}, {430,0.000796209}, {431,0.000317536}, {432,0.000459716}, {433,0.000303318}, {434,0.000289100}, {435,0.000265403}, {436,0.000407583}, {437,0.000293839}, {438,0.000260664}, {439,0.000184834}, {440,0.000298578}, {441,0.000298578}, {442,0.000364929}, {443,0.000398104}, {444,0.000279621}, {445,0.000431280}, {446,0.000398104}, {447,0.000308057}, {448,0.000317536}, {449,0.000289100}, {450,0.000412322}, {451,0.000369668}, {452,0.000407583}, {453,0.000360190}, {454,0.000488152}, {455,0.000417062}, {456,0.000336493}, {457,0.000388626}, {458,0.000322275}, {459,0.000341232}, {460,0.000213270}, {461,0.000255924}, {462,0.000445498}, {463,0.000284360}, {464,0.000473934}, {465,0.000213270}, {466,0.000260664}, {467,0.000170616}, {468,0.000464455}, {469,0.000464455}, {470,0.000379147}, {471,0.000355450}, {472,0.000516588}, {473,0.000383886}, {474,0.000279621}, {475,0.000374408}, {476,0.000322275}, {477,0.000374408}, {478,0.000516588}, {479,0.000578199}, {480,0.000388626}, {481,0.000379147}, {482,0.000293839}, {483,0.000341232}, {484,0.000402844}, {485,0.000398104}, {486,0.000417062}, {487,0.000345972}, {488,0.000473934}, {489,0.000345972}, {490,0.000379147}, {491,0.000606635}, {492,0.000312796}, {493,0.000488152}, {494,0.000478673}, {495,0.000469194}, {496,0.000341232}, {497,0.000383886}, {498,0.000478673}, {499,0.000341232}, {500,0.000497630}, {505,0.000232227}, {510,0.000374408}, {515,0.000431280}, {520,0.000360190}, {525,0.000274882}, {530,0.000417062}, {535,0.000497630}, {540,0.000417062}, {545,0.000331754}, {550,0.000459716}, {555,0.000478673}, {560,0.000545024}, {565,0.000511848}, {570,0.000582938}, {575,0.000398104}, {580,0.000530806}, {585,0.000559242}, {590,0.000568720}, {595,0.000388626}, {600,0.000436019}, {605,0.000469194}, {610,0.000483412}, {615,0.000440758}, {620,0.000454976}, {625,0.000488152}, {630,0.000450237}, {635,0.000469194}, {640,0.000478673}, {645,0.000630332}, {650,0.000473934}, {655,0.000540284}, {660,0.000654028}, {665,0.000620853}, {670,0.000611374}, {675,0.000625592}, {680,0.000402844}, {685,0.000478673}, {690,0.000549763}, {695,0.000483412}, {700,0.000635071}, {705,0.000587678}, {710,0.000786730}, {715,0.000388626}, {720,0.000639810}, {725,0.000568720}, {730,0.000620853}, {735,0.000592417}, {740,0.000582938}, {745,0.000587678}, {750,0.000568720}, {755,0.000582938}, {760,0.001146919}, {765,0.000507109}, {770,0.000729858}, {775,0.000545024}, {780,0.000682464}, {785,0.000772512}, {790,0.000663507}, {795,0.000668246}, {800,0.001236967}, {805,0.000758294}, {810,0.000450237}, {815,0.000663507}, {820,0.000592417}, {825,0.000748815}, {830,0.000677725}, {835,0.000592417}, {840,0.000649289}, {845,0.000616114}, {850,0.000526066}, {855,0.000639810}, {860,0.000715640}, {865,0.000872038}, {870,0.000682464}, {875,0.000654028}, {880,0.000720379}, {885,0.001184834}, {890,0.000635071}, {895,0.000786730}, {900,0.000715640}, {905,0.000734597}, {910,0.000654028}, {915,0.000767773}, {920,0.001729858}, {925,0.000706161}, {930,0.000587678}, {935,0.000739336}, {940,0.000834123}, {945,0.000620853}, {950,0.000763033}, {955,0.000928910}, {960,0.000881517}, {965,0.000715640}, {970,0.000729858}, {975,0.000791469}, {980,0.000739336}, {985,0.000687204}, {990,0.000601896}, {995,0.000824645}, {1000,0.000962085}, {1010,0.000748815}, {1020,0.000872038}, {1030,0.000791469}, {1040,0.000611374}, {1050,0.000729858}, {1060,0.001488152}, {1070,0.000914692}, {1080,0.000791469}, {1090,0.000838863}, {1100,0.000895735}, {1110,0.000824645}, {1120,0.000952607}, {1130,0.001000000}, {1140,0.000734597}, {1150,0.000758294}, {1160,0.001023697}, {1170,0.000843602}, {1180,0.000895735}, {1190,0.001071090}, {1200,0.000758294}, {1210,0.000763033}, {1220,0.000890995}, {1230,0.000895735}, {1240,0.000706161}, {1250,0.000938389}, {1260,0.000928910}, {1270,0.001009479}, {1280,0.001047393}, {1290,0.000914692}, {1300,0.002189573}, {1310,0.000981043}, {1320,0.000900474}, {1330,0.000995261}, {1340,0.000819905}, {1350,0.001099526}, {1360,0.000838863}, {1370,0.001232227}, {1380,0.001298578}, {1390,0.001109005}, {1400,0.002037915}, {1410,0.001175355}, {1420,0.001161137}, {1430,0.001180095}, {1440,0.001080569}, {1450,0.002492891}, {1460,0.001161137}, {1470,0.001037915}, {1480,0.001118483}, {1490,0.001222749}, {1500,0.001194313}, {1510,0.001189573}, {1520,0.001483412}, {1530,0.001109005}, {1540,0.001203791}, {1550,0.001241706}, {1560,0.001146919}, {1570,0.001146919}, {1580,0.001364929}, {1590,0.001189573}, {1600,0.001450237}, {1610,0.001222749}, {1620,0.001402844}, {1630,0.001085308}, {1640,0.001412322}, {1650,0.001369668}, {1660,0.001104265}, {1670,0.001222749}, {1680,0.002270142}, {1690,0.001199052}, {1700,0.001473934}, {1710,0.001530806}, {1720,0.001341232}, {1730,0.001431280}, {1740,0.001274882}, {1750,0.001312796}, {1760,0.001383886}, {1770,0.001388626}, {1780,0.001379147}, {1790,0.001322275}, {1800,0.001573460}, {1810,0.001251185}, {1820,0.001511848}, {1830,0.001440758}, {1840,0.001545024}, {1850,0.001469194}, {1860,0.001355450}, {1870,0.001464455}, {1880,0.001454976}, {1890,0.001369668}, {1900,0.001421801}, {1910,0.001540284}, {1920,0.001772512}, {1930,0.001383886}, {1940,0.001635071}, {1950,0.001654028}, {1960,0.001725118}, {1970,0.001545024}, {1980,0.001436019}, {1990,0.001473934}, {2000,0.003767773}, {2050,0.001573460}, {2100,0.001521327}, {2150,0.001763033}, {2200,0.001668246}, {2250,0.001781991}, {2300,0.001829384}, {2350,0.001928910}, {2400,0.001957346}, {2450,0.001971564}, {2500,0.001805687}, {2550,0.001985782}, {2600,0.002085308}, {2650,0.002279621}, {2700,0.002066351}, {2750,0.002241706}, {2800,0.002113744}, {2850,0.002426540}, {2900,0.002184834}, {2950,0.002383886}, {3000,0.002445498}, {3050,0.002725118}, {3100,0.002511848}, {3150,0.002672986}, {3200,0.002535545}, {3250,0.003696682}, {3300,0.002696682}, {3350,0.002895735}, {3400,0.002805687}, {3450,0.002895735}, {3500,0.003033175}, {3550,0.002857820}, {3600,0.002981043}, {3650,0.003014218}, {3700,0.002985782}, {3750,0.002905213}, {3800,0.003028436}, {3850,0.003009479}, {3900,0.003232227}, {3950,0.003383886}, {4000,0.003213270}, {4050,0.003388626}, {4100,0.003412322}, {4150,0.003488152}, {4200,0.003545024}, {4250,0.003521327}, {4300,0.003535545}, {4350,0.003668246}, {4400,0.003772512}, {4450,0.003729858}, {4500,0.008933649}, {4550,0.003857820}, {4600,0.004033175}, {4650,0.003971564}, {4700,0.003933649}, {4750,0.003890995}, {4800,0.004208531}, {4850,0.004293839}, {4900,0.003890995}, {4950,0.004308057}, {5000,0.004218009}, {5050,0.004194313}, {5100,0.004341232}, {5150,0.004274882}, {5200,0.004308057}, {5250,0.004620853}, {5300,0.004559242}, {5350,0.004630332}, {5400,0.004853081}, {5450,0.004720379}, {5500,0.004829384}, {5550,0.004611374}, {5600,0.004886256}, {5650,0.004952607}, {5700,0.004725118}, {5750,0.004985782}, {5800,0.004947867}, {5850,0.005246445}, {5900,0.005180095}, {5950,0.005170616}, {6000,0.010260664}, {6050,0.005104265}, {6100,0.005279621}, {6150,0.005374408}, {6200,0.005322275}, {6250,0.005350711}, {6300,0.005549763}, {6350,0.005672986}, {6400,0.005872038}, {6450,0.005616114}, {6500,0.005786730}, {6550,0.005720379}, {6600,0.005909953}, {6650,0.005933649}, {6700,0.005938389}, {6750,0.006018957}, {6800,0.005753555}, {6850,0.005919431}, {6900,0.006075829}, {6950,0.005933649}, {7000,0.006383886}, {7050,0.006208531}, {7100,0.009800948}, {7150,0.012270142}, {7200,0.006469194}, {7250,0.010014218}, {7300,0.015146919}, {7350,0.014298578}, {7400,0.006729858}, {7450,0.006947867}, {7500,0.007004739}, {7550,0.006890995}, {7600,0.007028436}, {7650,0.006995261}, {7700,0.011454976}, {7750,0.012104265}, {7800,0.012289100}, {7850,0.007094787}, {7900,0.007322275}, {7950,0.011535545}, {8000,0.007123223}, {8050,0.007341232}, {8100,0.007255924}, {8150,0.007658768}, {8200,0.007341232}, {8250,0.007587678}, {8300,0.007507109}, {8350,0.007763033}, {8400,0.007900474}, {8450,0.011829384}, {8500,0.012919431}, {8550,0.008004739}, {8600,0.007943128}, {8650,0.008066351}, {8700,0.008440758}, {8750,0.008199052}, {8800,0.012066351}, {8850,0.011753555}, {8900,0.008393365}, {8950,0.008563981}, {9000,0.008611374}, {9050,0.008530806}, {9100,0.014521327}, {9150,0.008966825}, {9200,0.009104265}, {9250,0.009090047}, {9300,0.014033175}, {9350,0.009033175}, {9400,0.009189573}, {9450,0.009165877}, {9500,0.017213270}, {9550,0.009469194}, {9600,0.009289100}, {9650,0.009507109}, {9700,0.009469194}, {9750,0.009753555}, {9800,0.009971564}, {9850,0.017526066}, {9900,0.009928910}, {9950,0.010194313}, {10000,0.010099526}, {10100,0.009587678}, {10200,0.010630332}, {10300,0.010691943}, {10400,0.010639810}, {10500,0.010729858}, {10600,0.010616114}, {10700,0.010834123}, {10800,0.011407583}, {10900,0.011146919}, {11000,0.011303318}, {11100,0.010739336}, {11200,0.011592417}, {11300,0.022521327}, {11400,0.011677725}, {11500,0.022725118}, {11600,0.011900474}, {11700,0.012246445}, {11800,0.012312796}, {11900,0.012270142}, {12000,0.027601896}, {12100,0.012559242}, {12200,0.025379147}, {12300,0.012597156}, {12400,0.012876777}, {12500,0.026838863}, {12600,0.013151659}, {12700,0.013132701}, {12800,0.012398104}, {12900,0.013317536}, {13000,0.013488152}, {13100,0.025047393}, {13200,0.024407583}, {13300,0.013597156}, {13400,0.013720379}, {13500,0.025526066}, {13600,0.026824645}, {13700,0.014014218}, {13800,0.014170616}, {13900,0.014417062}, {14000,0.014246445}, {14100,0.024672986}, {14200,0.025502370}, {14300,0.015014218}, {14400,0.014701422}, {14500,0.014843602}, {14600,0.015023697}, {14700,0.015104265}, {14800,0.015194313}, {14900,0.015298578}, {15000,0.015502370}, {15100,0.015668246}, {15200,0.015658768}, {15300,0.015649289}, {15400,0.015976303}, {15500,0.016327014}, {15600,0.016199052}, {15700,0.016284360}, {15800,0.016308057}, {15900,0.016549763}, {16000,0.016715640}, {16100,0.027521327}, {16200,0.024293839}, {16300,0.024573460}, {16400,0.017004739}, {16500,0.017189573}, {16600,0.017232227}, {16700,0.026379147}, {16800,0.028895735}, {16900,0.017758294}, {17000,0.017924171}, {17100,0.018398104}, {17200,0.029862559}, {17300,0.018355450}, {17400,0.018265403}, {17500,0.031208531}, {17600,0.017616114}, {17700,0.018739336}, {17800,0.032725118}, {17900,0.018440758}, {18000,0.019109005}, {18100,0.027644550}, {18200,0.019327014}, {18300,0.019573460}, {18400,0.026109005}, {18500,0.019469194}, {18600,0.031838863}, {18700,0.020222749}, {18800,0.041649289}, {18900,0.020341232}, {19000,0.029838863}, {19100,0.020625592}, {19200,0.039791469}, {19300,0.020734597}, {19400,0.031393365}, {19500,0.020957346}, {19600,0.020146919}, {19700,0.033781991}, {19800,0.021469194}, {19900,0.034014218}, {20000,0.021464115}};
data["big_flat"]["Parametricity; beta"]["cbv"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000018957}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000037915}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000037915}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000018957}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000014218}, {46,0.000000000}, {47,0.000000000}, {48,0.000018957}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000018957}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000018957}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000018957}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000018957}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000018957}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000018957}, {106,0.000018957}, {107,0.000000000}, {108,0.000000000}, {109,0.000018957}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000018957}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000018957}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000018957}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000018957}, {148,0.000000000}, {149,0.000000000}, {150,0.000018957}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000018957}, {176,0.000000000}, {177,0.000000000}, {178,0.000018957}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000018957}, {184,0.000000000}, {185,0.000018957}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000018957}, {190,0.000000000}, {191,0.000000000}, {192,0.000018957}, {193,0.000000000}, {194,0.000000000}, {195,0.000018957}, {196,0.000018957}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000018957}, {202,0.000000000}, {203,0.000000000}, {204,0.000018957}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000018957}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000018957}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000014218}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000018957}, {252,0.000000000}, {253,0.000018957}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000018957}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000018957}, {279,0.000000000}, {280,0.000018957}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000018957}, {294,0.000000000}, {295,0.000000000}, {296,0.000018957}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000037915}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000018957}, {306,0.000000000}, {307,0.000033175}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000014218}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000018957}, {324,0.000000000}, {325,0.000000000}, {326,0.000018957}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000018957}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000018957}, {337,0.000018957}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000018957}, {344,0.000018957}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000018957}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000014218}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000018957}, {366,0.000018957}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000018957}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000014218}, {379,0.000000000}, {380,0.000000000}, {381,0.000033175}, {382,0.000000000}, {383,0.000000000}, {384,0.000014218}, {385,0.000018957}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000018957}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000018957}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000018957}, {410,0.000000000}, {411,0.000000000}, {412,0.000018957}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000018957}, {418,0.000000000}, {419,0.000000000}, {420,0.000037915}, {421,0.000000000}, {422,0.000018957}, {423,0.000000000}, {424,0.000000000}, {425,0.000014218}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000018957}, {431,0.000018957}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000018957}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000018957}, {446,0.000018957}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000018957}, {452,0.000018957}, {453,0.000018957}, {454,0.000018957}, {455,0.000018957}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000018957}, {474,0.000000000}, {475,0.000000000}, {476,0.000018957}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000018957}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000018957}, {495,0.000000000}, {496,0.000014218}, {497,0.000018957}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000018957}, {510,0.000037915}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000018957}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000018957}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000018957}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000018957}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000018957}, {770,0.000018957}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000018957}, {810,0.000018957}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000018957}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000018957}, {895,0.000000000}, {900,0.000000000}, {905,0.000018957}, {910,0.000000000}, {915,0.000018957}, {920,0.000018957}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000018957}, {945,0.000037915}, {950,0.000000000}, {955,0.000000000}, {960,0.000018957}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000037915}, {1020,0.000018957}, {1030,0.000018957}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000018957}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000018957}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000014218}, {1140,0.000018957}, {1150,0.000033175}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000018957}, {1300,0.000018957}, {1310,0.000000000}, {1320,0.000018957}, {1330,0.000000000}, {1340,0.000018957}, {1350,0.000018957}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000018957}, {1390,0.000000000}, {1400,0.000018957}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000018957}, {1450,0.000056872}, {1460,0.000018957}, {1470,0.000000000}, {1480,0.000037915}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000014218}, {1520,0.000000000}, {1530,0.000018957}, {1540,0.000018957}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000018957}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000018957}, {1640,0.000000000}, {1650,0.000037915}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000037915}, {1690,0.000018957}, {1700,0.000014218}, {1710,0.000018957}, {1720,0.000018957}, {1730,0.000018957}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000037915}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000014218}, {1830,0.000014218}, {1840,0.000037915}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000037915}, {1940,0.000000000}, {1950,0.000018957}, {1960,0.000033175}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000052133}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000018957}, {2250,0.000000000}, {2300,0.000056872}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000037915}, {2550,0.000018957}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000014218}, {2750,0.000018957}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000037915}, {3000,0.000018957}, {3050,0.000018957}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000018957}, {3250,0.000075829}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000018957}, {3550,0.000018957}, {3600,0.000037915}, {3650,0.000000000}, {3700,0.000037915}, {3750,0.000018957}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000018957}, {3950,0.000033175}, {4000,0.000037915}, {4050,0.000000000}, {4100,0.000018957}, {4150,0.000014218}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000018957}, {4350,0.000000000}, {4400,0.000018957}, {4450,0.000000000}, {4500,0.000037915}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000018957}, {4800,0.000018957}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000018957}, {5000,0.000018957}, {5050,0.000033175}, {5100,0.000037915}, {5150,0.000000000}, {5200,0.000018957}, {5250,0.000018957}, {5300,0.000000000}, {5350,0.000000000}, {5400,0.000000000}, {5450,0.000018957}, {5500,0.000000000}, {5550,0.000000000}, {5600,0.000014218}, {5650,0.000000000}, {5700,0.000018957}, {5750,0.000033175}, {5800,0.000000000}, {5850,0.000000000}, {5900,0.000018957}, {5950,0.000075829}, {6000,0.000071090}, {6050,0.000033175}, {6100,0.000033175}, {6150,0.000018957}, {6200,0.000056872}, {6250,0.000018957}, {6300,0.000018957}, {6350,0.000018957}, {6400,0.000000000}, {6450,0.000018957}, {6500,0.000000000}, {6550,0.000075829}, {6600,0.000000000}, {6650,0.000037915}, {6700,0.000018957}, {6750,0.000000000}, {6800,0.000000000}, {6850,0.000018957}, {6900,0.000000000}, {6950,0.000018957}, {7000,0.000018957}, {7050,0.000037915}, {7100,0.000109005}, {7150,0.000203791}, {7200,0.000000000}, {7250,0.000094787}, {7300,0.000113744}, {7350,0.000127962}, {7400,0.000000000}, {7450,0.000018957}, {7500,0.000037915}, {7550,0.000000000}, {7600,0.000000000}, {7650,0.000018957}, {7700,0.000033175}, {7750,0.000189573}, {7800,0.000184834}, {7850,0.000000000}, {7900,0.000000000}, {7950,0.000075829}, {8000,0.000018957}, {8050,0.000018957}, {8100,0.000056872}, {8150,0.000018957}, {8200,0.000014218}, {8250,0.000037915}, {8300,0.000018957}, {8350,0.000037915}, {8400,0.000037915}, {8450,0.000132701}, {8500,0.000018957}, {8550,0.000018957}, {8600,0.000037915}, {8650,0.000000000}, {8700,0.000000000}, {8750,0.000000000}, {8800,0.000109005}, {8850,0.000000000}, {8900,0.000000000}, {8950,0.000028436}, {9000,0.000000000}, {9050,0.000000000}, {9100,0.000000000}, {9150,0.000037915}, {9200,0.000018957}, {9250,0.000018957}, {9300,0.000094787}, {9350,0.000056872}, {9400,0.000000000}, {9450,0.000028436}, {9500,0.000165877}, {9550,0.000071090}, {9600,0.000000000}, {9650,0.000056872}, {9700,0.000000000}, {9750,0.000018957}, {9800,0.000000000}, {9850,0.000037915}, {9900,0.000018957}, {9950,0.000000000}, {10000,0.000000000}, {10100,0.000033175}, {10200,0.000000000}, {10300,0.000018957}, {10400,0.000037915}, {10500,0.000033175}, {10600,0.000037915}, {10700,0.000052133}, {10800,0.000000000}, {10900,0.000033175}, {11000,0.000000000}, {11100,0.000075829}, {11200,0.000000000}, {11300,0.000161137}, {11400,0.000018957}, {11500,0.000284360}, {11600,0.000056872}, {11700,0.000018957}, {11800,0.000018957}, {11900,0.000018957}, {12000,0.000184834}, {12100,0.000085308}, {12200,0.000236967}, {12300,0.000056872}, {12400,0.000037915}, {12500,0.000270142}, {12600,0.000018957}, {12700,0.000056872}, {12800,0.000056872}, {12900,0.000018957}, {13000,0.000018957}, {13100,0.000146919}, {13200,0.000109005}, {13300,0.000000000}, {13400,0.000037915}, {13500,0.000298578}, {13600,0.000018957}, {13700,0.000000000}, {13800,0.000056872}, {13900,0.000033175}, {14000,0.000037915}, {14100,0.000146919}, {14200,0.000018957}, {14300,0.000000000}, {14400,0.000000000}, {14500,0.000000000}, {14600,0.000056872}, {14700,0.000018957}, {14800,0.000018957}, {14900,0.000000000}, {15000,0.000056872}, {15100,0.000037915}, {15200,0.000075829}, {15300,0.000056872}, {15400,0.000000000}, {15500,0.000037915}, {15600,0.000018957}, {15700,0.000014218}, {15800,0.000018957}, {15900,0.000000000}, {16000,0.000056872}, {16100,0.000146919}, {16200,0.000037915}, {16300,0.000037915}, {16400,0.000056872}, {16500,0.000151659}, {16600,0.000056872}, {16700,0.000374408}, {16800,0.000000000}, {16900,0.000014218}, {17000,0.000018957}, {17100,0.000018957}, {17200,0.000000000}, {17300,0.000000000}, {17400,0.000018957}, {17500,0.000265403}, {17600,0.000000000}, {17700,0.000018957}, {17800,0.000018957}, {17900,0.000000000}, {18000,0.000000000}, {18100,0.000000000}, {18200,0.000033175}, {18300,0.000037915}, {18400,0.000000000}, {18500,0.000018957}, {18600,0.000000000}, {18700,0.000000000}, {18800,0.000000000}, {18900,0.000000000}, {19000,0.000000000}, {19100,0.000000000}, {19200,0.000018957}, {19300,0.000018957}, {19400,0.000000000}, {19500,0.000018957}, {19600,0.000000000}, {19700,0.000000000}, {19800,0.000000000}, {19900,0.000056872}, {20000,0.000019139}};
data["big_flat"]["Parametricity; beta"]["eval lazy"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000478673}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000009479}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000530806}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000009479}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000018957}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000018957}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000018957}, {444,0.001142180}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000018957}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000004739}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000004739}, {478,0.000004739}, {479,0.000009479}, {480,0.000000000}, {481,0.000000000}, {482,0.000004739}, {483,0.000009479}, {484,0.000023697}, {485,0.000009479}, {486,0.000004739}, {487,0.000004739}, {488,0.000018957}, {489,0.000004739}, {490,0.000000000}, {491,0.000004739}, {492,0.000009479}, {493,0.000014218}, {494,0.000009479}, {495,0.000018957}, {496,0.000018957}, {497,0.000047393}, {498,0.000023697}, {499,0.000018957}, {500,0.000037915}, {505,0.000047393}, {510,0.000061611}, {515,0.000142180}, {520,0.000255924}, {525,0.000345972}, {530,0.000521327}, {535,0.000601896}, {540,0.000710900}, {545,0.000815166}, {550,0.000862559}, {555,0.001445498}, {560,0.000928910}, {565,0.000947867}, {570,0.000976303}, {575,0.000990521}, {580,0.001000000}, {585,0.001000000}, {590,0.001000000}, {595,0.001000000}, {600,0.001000000}, {605,0.001000000}, {610,0.001000000}, {615,0.001000000}, {620,0.001000000}, {625,0.001000000}, {630,0.001000000}, {635,0.001000000}, {640,0.001000000}, {645,0.001000000}, {650,0.001000000}, {655,0.001000000}, {660,0.001000000}, {665,0.001000000}, {670,0.001000000}, {675,0.001000000}, {680,0.001000000}, {685,0.001000000}, {690,0.001000000}, {695,0.001000000}, {700,0.001000000}, {705,0.001018957}, {710,0.001000000}, {715,0.001000000}, {720,0.001000000}, {725,0.001000000}, {730,0.001000000}, {735,0.001000000}, {740,0.001000000}, {745,0.001000000}, {750,0.001000000}, {755,0.001000000}, {760,0.001000000}, {765,0.001000000}, {770,0.001000000}, {775,0.001000000}, {780,0.001000000}, {785,0.001000000}, {790,0.001000000}, {795,0.001018957}, {800,0.001000000}, {805,0.001000000}, {810,0.001000000}, {815,0.001000000}, {820,0.001000000}, {825,0.001000000}, {830,0.001000000}, {835,0.001000000}, {840,0.002554502}, {845,0.001000000}, {850,0.001000000}, {855,0.001000000}, {860,0.001000000}, {865,0.001000000}, {870,0.001000000}, {875,0.001000000}, {880,0.002611374}, {885,0.001000000}, {890,0.001000000}, {895,0.001000000}, {900,0.001000000}, {905,0.001000000}, {910,0.001000000}, {915,0.001000000}, {920,0.001000000}, {925,0.001000000}, {930,0.001000000}, {935,0.001000000}, {940,0.001000000}, {945,0.001000000}, {950,0.001000000}, {955,0.003355450}, {960,0.001004739}, {965,0.001000000}, {970,0.001004739}, {975,0.001009479}, {980,0.001000000}, {985,0.001009479}, {990,0.001009479}, {995,0.001004739}, {1000,0.001009479}, {1010,0.001018957}, {1020,0.001071090}, {1030,0.001075829}, {1040,0.001208531}, {1050,0.002966825}, {1060,0.001364929}, {1070,0.001473934}, {1080,0.001630332}, {1090,0.001763033}, {1100,0.001867299}, {1110,0.001924171}, {1120,0.003331754}, {1130,0.001938389}, {1140,0.001976303}, {1150,0.001971564}, {1160,0.002000000}, {1170,0.001995261}, {1180,0.002000000}, {1190,0.002000000}, {1200,0.002000000}, {1210,0.002000000}, {1220,0.002000000}, {1230,0.002028436}, {1240,0.003568720}, {1250,0.002000000}, {1260,0.002000000}, {1270,0.002000000}, {1280,0.002000000}, {1290,0.004052133}, {1300,0.002000000}, {1310,0.002000000}, {1320,0.002000000}, {1330,0.002000000}, {1340,0.002028436}, {1350,0.004592417}, {1360,0.002000000}, {1370,0.002000000}, {1380,0.002000000}, {1390,0.002000000}, {1400,0.002004739}, {1410,0.002004739}, {1420,0.002000000}, {1430,0.002000000}, {1440,0.002004739}, {1450,0.002004739}, {1460,0.002004739}, {1470,0.002004739}, {1480,0.002033175}, {1490,0.002061611}, {1500,0.005483412}, {1510,0.002085308}, {1520,0.002118483}, {1530,0.002146919}, {1540,0.002208531}, {1550,0.002255924}, {1560,0.002336493}, {1570,0.002331754}, {1580,0.002421801}, {1590,0.002464455}, {1600,0.002549763}, {1610,0.002616114}, {1620,0.002720379}, {1630,0.002843602}, {1640,0.002829384}, {1650,0.002876777}, {1660,0.002909953}, {1670,0.002928910}, {1680,0.002943128}, {1690,0.002962085}, {1700,0.002971564}, {1710,0.002981043}, {1720,0.002985782}, {1730,0.003000000}, {1740,0.003000000}, {1750,0.002995261}, {1760,0.005696682}, {1770,0.003000000}, {1780,0.003000000}, {1790,0.003000000}, {1800,0.005886256}, {1810,0.003000000}, {1820,0.003000000}, {1830,0.003000000}, {1840,0.005947867}, {1850,0.003009479}, {1860,0.003000000}, {1870,0.003004739}, {1880,0.005582938}, {1890,0.003009479}, {1900,0.003004739}, {1910,0.003014218}, {1920,0.003009479}, {1930,0.003033175}, {1940,0.003037915}, {1950,0.003056872}, {1960,0.005824645}, {1970,0.003104265}, {1980,0.003132701}, {1990,0.003184834}, {2000,0.003175355}, {2050,0.003355450}, {2100,0.003497630}, {2150,0.003706161}, {2200,0.003933649}, {2250,0.003985782}, {2300,0.007393365}, {2350,0.004009479}, {2400,0.004047393}, {2450,0.007928910}, {2500,0.004341232}, {2550,0.004478673}, {2600,0.008829384}, {2650,0.004763033}, {2700,0.004919431}, {2750,0.008236967}, {2800,0.005009479}, {2850,0.005099526}, {2900,0.005189573}, {2950,0.005327014}, {3000,0.005412322}, {3050,0.005545024}, {3100,0.005729858}, {3150,0.005777251}, {3200,0.005919431}, {3250,0.005995261}, {3300,0.006094787}, {3350,0.006132701}, {3400,0.006355450}, {3450,0.011331754}, {3500,0.006530806}, {3550,0.006739336}, {3600,0.006720379}, {3650,0.007033175}, {3700,0.007028436}, {3750,0.007213270}, {3800,0.007222749}, {3850,0.007516588}, {3900,0.007492891}, {3950,0.013028436}, {4000,0.007620853}, {4050,0.007677725}, {4100,0.007829384}, {4150,0.011905213}, {4200,0.008184834}, {4250,0.008218009}, {4300,0.008454976}, {4350,0.008488152}, {4400,0.012132701}, {4450,0.008654028}, {4500,0.008739336}, {4550,0.008862559}, {4600,0.009023697}, {4650,0.012767773}, {4700,0.009289100}, {4750,0.009327014}, {4800,0.015511848}, {4850,0.009578199}, {4900,0.009644550}, {4950,0.013985782}, {5000,0.009924171}, {5050,0.009981043}, {5100,0.015331754}, {5150,0.010336493}, {5200,0.010327014}, {5250,0.015739336}, {5300,0.010578199}, {5350,0.010725118}, {5400,0.017914692}, {5450,0.011042654}, {5500,0.011113744}, {5550,0.011127962}, {5600,0.017118483}, {5650,0.011568720}, {5700,0.011573460}, {5750,0.011601896}, {5800,0.019767773}, {5850,0.017829384}, {5900,0.012028436}, {5950,0.012165877}, {6000,0.012165877}, {6050,0.019165877}, {6100,0.018952607}, {6150,0.012545024}, {6200,0.012682464}, {6250,0.012687204}, {6300,0.012658768}, {6350,0.017919431}, {6400,0.019426540}, {6450,0.013350711}, {6500,0.013459716}, {6550,0.013549763}, {6600,0.013582938}, {6650,0.013417062}, {6700,0.023398104}, {6750,0.029142180}, {6800,0.027170616}, {6850,0.014497630}, {6900,0.014402844}, {6950,0.014535545}, {7000,0.014611374}, {7050,0.014734597}, {7100,0.014867299}, {7150,0.014981043}, {7200,0.014924171}, {7250,0.015099526}, {7300,0.015132701}, {7350,0.015241706}, {7400,0.015023697}, {7450,0.015241706}, {7500,0.015355450}, {7550,0.015483412}, {7600,0.015530806}, {7650,0.015616114}, {7700,0.016061611}, {7750,0.016218009}, {7800,0.016379147}, {7850,0.016436019}, {7900,0.016601896}, {7950,0.016867299}, {8000,0.016985782}, {8050,0.017118483}, {8100,0.017274882}, {8150,0.017488152}, {8200,0.025279621}, {8250,0.032914692}, {8300,0.025563981}, {8350,0.029218009}, {8400,0.017336493}, {8450,0.017881517}, {8500,0.018104265}, {8550,0.018270142}, {8600,0.018488152}, {8650,0.031104265}, {8700,0.029336493}, {8750,0.018203791}, {8800,0.018687204}, {8850,0.019009479}, {8900,0.019284360}, {8950,0.029905213}, {9000,0.031331754}, {9050,0.018971564}, {9100,0.019592417}, {9150,0.019872038}, {9200,0.034445498}, {9250,0.028824645}, {9300,0.019843602}, {9350,0.020104265}, {9400,0.033142180}, {9450,0.031227488}, {9500,0.020251185}, {9550,0.020668246}, {9600,0.035175355}, {9650,0.028545024}, {9700,0.020829384}, {9750,0.033052133}, {9800,0.033279621}, {9850,0.021142180}, {9900,0.021521327}, {9950,0.043981043}, {10000,0.020957346}, {10100,0.022000000}, {10200,0.044663507}, {10300,0.021734597}, {10400,0.022834123}, {10500,0.037725118}, {10600,0.022848341}, {10700,0.047549763}, {10800,0.022867299}, {10900,0.033023697}, {11000,0.023355450}, {11100,0.024549763}, {11200,0.033834123}, {11300,0.024947867}, {11400,0.035151659}, {11500,0.025388626}, {11600,0.024796209}, {11700,0.031682464}, {11800,0.025156398}, {11900,0.043407583}, {12000,0.026208531}, {12100,0.040909953}, {12200,0.027184834}, {12300,0.026388626}, {12400,0.055611374}, {12500,0.027327014}, {12600,0.026985782}, {12700,0.053853081}, {12800,0.027976303}, {12900,0.027677725}, {13000,0.053815166}, {13100,0.038018957}, {13200,0.028995261}, {13300,0.028635071}, {13400,0.054417062}, {13500,0.040763033}, {13600,0.029947867}, {13700,0.029597156}, {13800,0.040654028}, {13900,0.052393365}, {14000,0.061056872}, {14100,0.039554502}, {14200,0.031497630}, {14300,0.031000000}, {14400,0.031094787}, {14500,0.031440758}, {14600,0.040582938}, {14700,0.045042654}, {14800,0.050829384}, {14900,0.049123223}, {15000,0.058554502}, {15100,0.057516588}, {15200,0.057293839}, {15300,0.058644550}, {15400,0.051255924}, {15500,0.050928910}, {15600,0.045526066}, {15700,0.039085308}, {15800,0.034469194}, {15900,0.034625592}, {16000,0.034857820}, {16100,0.044815166}, {16200,0.051374408}, {16300,0.071895735}, {16400,0.053369668}, {16500,0.036033175}, {16600,0.036018957}, {16700,0.044289100}, {16800,0.063791469}, {16900,0.056450237}, {17000,0.037146919}, {17100,0.037511848}, {17200,0.064938389}, {17300,0.057369668}, {17400,0.038146919}, {17500,0.052516588}, {17600,0.064630332}, {17700,0.038890995}, {17800,0.051890995}, {17900,0.065146919}, {18000,0.039431280}, {18100,0.067630332}, {18200,0.050331754}, {18300,0.043383886}, {18400,0.073687204}, {18500,0.040611374}, {18600,0.078341232}, {18700,0.041123223}, {18800,0.075616114}, {18900,0.041606635}, {19000,0.074175355}, {19100,0.042080569}, {19200,0.083436019}, {19300,0.042554502}, {19400,0.077895735}, {19500,0.048985782}, {19600,0.061018957}, {19700,0.057251185}, {19800,0.043639810}, {19900,0.076857820}, {20000,0.047138756}};
data["big_flat"]["Parametricity; beta"]["eval lazy"]["user"] = {{1,0.000033175}, {2,0.000056872}, {3,0.000028436}, {4,0.000056872}, {5,0.000000000}, {6,0.000033175}, {7,0.000075829}, {8,0.000075829}, {9,0.000052133}, {10,0.000113744}, {11,0.000052133}, {12,0.000052133}, {13,0.000028436}, {14,0.000085308}, {15,0.000037915}, {16,0.000056872}, {17,0.000052133}, {18,0.000037915}, {19,0.000018957}, {20,0.000104265}, {21,0.000080569}, {22,0.000075829}, {23,0.000104265}, {24,0.000104265}, {25,0.000099526}, {26,0.000085308}, {27,0.000142180}, {28,0.000080569}, {29,0.000052133}, {30,0.000251185}, {31,0.000066351}, {32,0.000066351}, {33,0.000137441}, {34,0.000090047}, {35,0.000028436}, {36,0.000118483}, {37,0.000099526}, {38,0.000075829}, {39,0.000142180}, {40,0.000113744}, {41,0.000071090}, {42,0.000113744}, {43,0.000066351}, {44,0.000137441}, {45,0.000142180}, {46,0.000113744}, {47,0.000137441}, {48,0.000236967}, {49,0.000142180}, {50,0.000099526}, {51,0.000085308}, {52,0.000123223}, {53,0.000118483}, {54,0.000061611}, {55,0.000156398}, {56,0.000090047}, {57,0.000156398}, {58,0.000085308}, {59,0.000146919}, {60,0.000203791}, {61,0.000151659}, {62,0.000151659}, {63,0.000080569}, {64,0.000061611}, {65,0.000180095}, {66,0.000161137}, {67,0.000113744}, {68,0.000080569}, {69,0.000127962}, {70,0.000194313}, {71,0.000137441}, {72,0.000184834}, {73,0.000123223}, {74,0.000213270}, {75,0.000113744}, {76,0.000137441}, {77,0.000127962}, {78,0.000251185}, {79,0.000142180}, {80,0.000213270}, {81,0.000246445}, {82,0.000071090}, {83,0.000165877}, {84,0.000218009}, {85,0.000175355}, {86,0.000208531}, {87,0.000184834}, {88,0.000137441}, {89,0.000308057}, {90,0.000184834}, {91,0.000194313}, {92,0.000227488}, {93,0.000246445}, {94,0.000270142}, {95,0.000137441}, {96,0.000113744}, {97,0.000203791}, {98,0.000213270}, {99,0.000189573}, {100,0.000241706}, {101,0.000213270}, {102,0.000265403}, {103,0.000184834}, {104,0.000222749}, {105,0.000146919}, {106,0.000284360}, {107,0.000170616}, {108,0.000137441}, {109,0.000203791}, {110,0.000279621}, {111,0.000151659}, {112,0.000265403}, {113,0.000227488}, {114,0.000199052}, {115,0.000331754}, {116,0.000175355}, {117,0.000312796}, {118,0.000255924}, {119,0.000232227}, {120,0.000265403}, {121,0.000350711}, {122,0.000445498}, {123,0.000236967}, {124,0.000170616}, {125,0.000260664}, {126,0.000265403}, {127,0.000175355}, {128,0.000274882}, {129,0.000322275}, {130,0.000274882}, {131,0.000270142}, {132,0.000322275}, {133,0.000369668}, {134,0.000118483}, {135,0.000180095}, {136,0.000260664}, {137,0.000274882}, {138,0.000279621}, {139,0.000232227}, {140,0.000232227}, {141,0.000170616}, {142,0.000265403}, {143,0.000227488}, {144,0.000284360}, {145,0.000232227}, {146,0.000322275}, {147,0.000289100}, {148,0.000189573}, {149,0.000260664}, {150,0.000279621}, {151,0.000345972}, {152,0.000369668}, {153,0.000706161}, {154,0.000379147}, {155,0.000322275}, {156,0.000251185}, {157,0.000260664}, {158,0.000317536}, {159,0.000265403}, {160,0.000331754}, {161,0.000232227}, {162,0.000341232}, {163,0.000327014}, {164,0.000374408}, {165,0.000317536}, {166,0.000270142}, {167,0.000260664}, {168,0.000431280}, {169,0.000274882}, {170,0.000260664}, {171,0.000345972}, {172,0.000232227}, {173,0.000293839}, {174,0.000364929}, {175,0.000374408}, {176,0.000255924}, {177,0.000383886}, {178,0.000303318}, {179,0.000251185}, {180,0.000312796}, {181,0.000241706}, {182,0.000350711}, {183,0.000246445}, {184,0.000492891}, {185,0.000578199}, {186,0.000251185}, {187,0.000246445}, {188,0.000407583}, {189,0.000336493}, {190,0.000260664}, {191,0.000336493}, {192,0.000379147}, {193,0.000303318}, {194,0.000327014}, {195,0.000355450}, {196,0.000289100}, {197,0.000336493}, {198,0.000293839}, {199,0.000383886}, {200,0.000317536}, {201,0.000345972}, {202,0.000322275}, {203,0.000379147}, {204,0.000350711}, {205,0.000445498}, {206,0.000374408}, {207,0.000336493}, {208,0.000398104}, {209,0.000900474}, {210,0.000402844}, {211,0.000298578}, {212,0.000317536}, {213,0.000426540}, {214,0.000473934}, {215,0.000284360}, {216,0.000388626}, {217,0.000317536}, {218,0.000298578}, {219,0.000341232}, {220,0.000402844}, {221,0.000317536}, {222,0.000402844}, {223,0.000374408}, {224,0.000379147}, {225,0.000398104}, {226,0.000431280}, {227,0.000421801}, {228,0.000407583}, {229,0.000241706}, {230,0.000180095}, {231,0.000127962}, {232,0.000151659}, {233,0.000203791}, {234,0.000379147}, {235,0.000412322}, {236,0.000502370}, {237,0.000402844}, {238,0.000426540}, {239,0.000431280}, {240,0.000478673}, {241,0.000374408}, {242,0.000317536}, {243,0.000327014}, {244,0.000308057}, {245,0.000298578}, {246,0.000431280}, {247,0.000516588}, {248,0.000478673}, {249,0.000635071}, {250,0.000454976}, {251,0.000421801}, {252,0.000469194}, {253,0.000369668}, {254,0.000393365}, {255,0.000431280}, {256,0.000578199}, {257,0.000516588}, {258,0.000473934}, {259,0.000322275}, {260,0.000331754}, {261,0.000407583}, {262,0.000573460}, {263,0.000345972}, {264,0.000383886}, {265,0.000284360}, {266,0.000407583}, {267,0.000345972}, {268,0.000497630}, {269,0.000507109}, {270,0.000360190}, {271,0.000497630}, {272,0.000421801}, {273,0.000587678}, {274,0.000507109}, {275,0.000587678}, {276,0.000398104}, {277,0.000625592}, {278,0.000573460}, {279,0.000398104}, {280,0.000374408}, {281,0.000526066}, {282,0.000563981}, {283,0.000426540}, {284,0.000454976}, {285,0.000582938}, {286,0.000379147}, {287,0.000393365}, {288,0.000488152}, {289,0.000535545}, {290,0.000554502}, {291,0.000393365}, {292,0.000521327}, {293,0.000431280}, {294,0.000601896}, {295,0.000478673}, {296,0.000540284}, {297,0.000445498}, {298,0.000563981}, {299,0.000459716}, {300,0.000549763}, {301,0.000649289}, {302,0.000511848}, {303,0.000526066}, {304,0.000554502}, {305,0.000582938}, {306,0.000611374}, {307,0.000611374}, {308,0.000535545}, {309,0.000521327}, {310,0.000668246}, {311,0.000421801}, {312,0.000478673}, {313,0.000563981}, {314,0.000473934}, {315,0.000677725}, {316,0.000383886}, {317,0.000606635}, {318,0.000535545}, {319,0.000521327}, {320,0.000426540}, {321,0.000445498}, {322,0.000739336}, {323,0.000644550}, {324,0.000654028}, {325,0.000658768}, {326,0.000469194}, {327,0.000578199}, {328,0.000549763}, {329,0.000407583}, {330,0.000720379}, {331,0.000559242}, {332,0.000554502}, {333,0.000459716}, {334,0.000554502}, {335,0.000554502}, {336,0.000578199}, {337,0.000554502}, {338,0.000672986}, {339,0.000786730}, {340,0.000545024}, {341,0.000649289}, {342,0.000511848}, {343,0.000639810}, {344,0.000672986}, {345,0.000526066}, {346,0.000535545}, {347,0.000725118}, {348,0.000507109}, {349,0.000492891}, {350,0.000563981}, {351,0.000502370}, {352,0.000687204}, {353,0.000739336}, {354,0.000440758}, {355,0.000710900}, {356,0.000616114}, {357,0.000578199}, {358,0.000720379}, {359,0.000540284}, {360,0.000530806}, {361,0.000549763}, {362,0.000516588}, {363,0.000701422}, {364,0.000635071}, {365,0.000563981}, {366,0.000625592}, {367,0.000549763}, {368,0.000478673}, {369,0.000616114}, {370,0.000611374}, {371,0.000687204}, {372,0.000725118}, {373,0.000720379}, {374,0.000886256}, {375,0.000587678}, {376,0.000649289}, {377,0.000663507}, {378,0.000507109}, {379,0.000549763}, {380,0.000606635}, {381,0.000748815}, {382,0.000573460}, {383,0.000819905}, {384,0.000592417}, {385,0.000710900}, {386,0.000672986}, {387,0.000772512}, {388,0.000729858}, {389,0.000625592}, {390,0.000606635}, {391,0.000829384}, {392,0.000672986}, {393,0.000767773}, {394,0.000668246}, {395,0.000620853}, {396,0.000616114}, {397,0.000696682}, {398,0.000663507}, {399,0.000654028}, {400,0.000654028}, {401,0.000781991}, {402,0.000578199}, {403,0.000966825}, {404,0.000639810}, {405,0.000734597}, {406,0.000573460}, {407,0.000720379}, {408,0.000729858}, {409,0.000654028}, {410,0.000781991}, {411,0.000616114}, {412,0.000696682}, {413,0.000772512}, {414,0.000559242}, {415,0.000720379}, {416,0.000791469}, {417,0.000781991}, {418,0.000663507}, {419,0.000748815}, {420,0.000658768}, {421,0.000800948}, {422,0.000582938}, {423,0.000981043}, {424,0.000516588}, {425,0.000976303}, {426,0.000545024}, {427,0.000781991}, {428,0.000753555}, {429,0.000900474}, {430,0.000644550}, {431,0.000677725}, {432,0.000687204}, {433,0.000587678}, {434,0.000611374}, {435,0.000772512}, {436,0.000763033}, {437,0.000758294}, {438,0.000654028}, {439,0.000758294}, {440,0.000763033}, {441,0.000729858}, {442,0.000805687}, {443,0.000677725}, {444,0.001767773}, {445,0.000834123}, {446,0.000616114}, {447,0.000791469}, {448,0.000729858}, {449,0.000758294}, {450,0.000781991}, {451,0.000786730}, {452,0.000715640}, {453,0.000943128}, {454,0.000890995}, {455,0.000720379}, {456,0.000862559}, {457,0.000848341}, {458,0.000900474}, {459,0.000710900}, {460,0.000829384}, {461,0.000781991}, {462,0.000668246}, {463,0.000786730}, {464,0.000886256}, {465,0.000701422}, {466,0.000805687}, {467,0.000909953}, {468,0.000663507}, {469,0.000715640}, {470,0.000876777}, {471,0.000578199}, {472,0.000990521}, {473,0.000772512}, {474,0.000815166}, {475,0.000914692}, {476,0.000796209}, {477,0.000857820}, {478,0.000900474}, {479,0.000777251}, {480,0.000763033}, {481,0.000734597}, {482,0.000867299}, {483,0.000981043}, {484,0.000767773}, {485,0.000815166}, {486,0.000867299}, {487,0.000786730}, {488,0.000962085}, {489,0.000838863}, {490,0.000857820}, {491,0.000720379}, {492,0.001047393}, {493,0.000857820}, {494,0.000805687}, {495,0.000729858}, {496,0.000848341}, {497,0.000900474}, {498,0.000810427}, {499,0.000810427}, {500,0.000829384}, {505,0.000905213}, {510,0.000985782}, {515,0.000696682}, {520,0.000890995}, {525,0.000985782}, {530,0.000919431}, {535,0.000976303}, {540,0.000928910}, {545,0.000791469}, {550,0.001047393}, {555,0.001720379}, {560,0.001056872}, {565,0.000952607}, {570,0.000990521}, {575,0.000905213}, {580,0.000928910}, {585,0.000720379}, {590,0.000815166}, {595,0.000848341}, {600,0.000985782}, {605,0.000981043}, {610,0.001066351}, {615,0.000862559}, {620,0.000909953}, {625,0.001085308}, {630,0.001085308}, {635,0.000990521}, {640,0.001004739}, {645,0.001028436}, {650,0.001080569}, {655,0.001071090}, {660,0.001033175}, {665,0.001199052}, {670,0.001137441}, {675,0.001109005}, {680,0.001308057}, {685,0.001075829}, {690,0.001037915}, {695,0.001284360}, {700,0.001085308}, {705,0.001123223}, {710,0.001218009}, {715,0.001289100}, {720,0.001251185}, {725,0.001241706}, {730,0.001090047}, {735,0.001350711}, {740,0.001170616}, {745,0.001426540}, {750,0.001170616}, {755,0.001137441}, {760,0.001369668}, {765,0.001165877}, {770,0.001369668}, {775,0.001255924}, {780,0.001431280}, {785,0.001341232}, {790,0.001407583}, {795,0.001265403}, {800,0.001393365}, {805,0.001284360}, {810,0.001374408}, {815,0.001464455}, {820,0.001194313}, {825,0.001545024}, {830,0.001535545}, {835,0.001345972}, {840,0.002834123}, {845,0.001563981}, {850,0.001478673}, {855,0.001426540}, {860,0.001431280}, {865,0.001483412}, {870,0.001450237}, {875,0.001454976}, {880,0.002857820}, {885,0.001578199}, {890,0.001393365}, {895,0.001530806}, {900,0.001644550}, {905,0.001464455}, {910,0.001706161}, {915,0.001597156}, {920,0.001606635}, {925,0.001483412}, {930,0.001573460}, {935,0.001947867}, {940,0.001549763}, {945,0.001606635}, {950,0.001668246}, {955,0.003720379}, {960,0.001644550}, {965,0.001549763}, {970,0.001407583}, {975,0.001521327}, {980,0.001682464}, {985,0.001497630}, {990,0.001658768}, {995,0.001824645}, {1000,0.001848341}, {1010,0.001895735}, {1020,0.001744076}, {1030,0.001706161}, {1040,0.001668246}, {1050,0.003407583}, {1060,0.001919431}, {1070,0.001853081}, {1080,0.001545024}, {1090,0.001725118}, {1100,0.001767773}, {1110,0.001952607}, {1120,0.003161137}, {1130,0.001886256}, {1140,0.001620853}, {1150,0.001947867}, {1160,0.002033175}, {1170,0.001976303}, {1180,0.002075829}, {1190,0.001890995}, {1200,0.001966825}, {1210,0.001952607}, {1220,0.002137441}, {1230,0.002165877}, {1240,0.003454976}, {1250,0.002303318}, {1260,0.002014218}, {1270,0.002312796}, {1280,0.002132701}, {1290,0.004161137}, {1300,0.002113744}, {1310,0.002345972}, {1320,0.002298578}, {1330,0.002322275}, {1340,0.002526066}, {1350,0.004672986}, {1360,0.002336493}, {1370,0.002090047}, {1380,0.002298578}, {1390,0.002360190}, {1400,0.002265403}, {1410,0.002407583}, {1420,0.002303318}, {1430,0.002260664}, {1440,0.002492891}, {1450,0.002578199}, {1460,0.002507109}, {1470,0.002663507}, {1480,0.002592417}, {1490,0.002639810}, {1500,0.005701422}, {1510,0.002454976}, {1520,0.002535545}, {1530,0.002587678}, {1540,0.002720379}, {1550,0.002715640}, {1560,0.002668246}, {1570,0.002635071}, {1580,0.002663507}, {1590,0.002701422}, {1600,0.002829384}, {1610,0.002710900}, {1620,0.002696682}, {1630,0.002938389}, {1640,0.002890995}, {1650,0.002763033}, {1660,0.002710900}, {1670,0.002777251}, {1680,0.002943128}, {1690,0.003004739}, {1700,0.003009479}, {1710,0.002928910}, {1720,0.002976303}, {1730,0.002900474}, {1740,0.003094787}, {1750,0.002928910}, {1760,0.005545024}, {1770,0.003099526}, {1780,0.002928910}, {1790,0.003165877}, {1800,0.005805687}, {1810,0.003189573}, {1820,0.003270142}, {1830,0.003189573}, {1840,0.005853081}, {1850,0.003085308}, {1860,0.003037915}, {1870,0.003284360}, {1880,0.005597156}, {1890,0.003303318}, {1900,0.003393365}, {1910,0.003208531}, {1920,0.003374408}, {1930,0.003293839}, {1940,0.003298578}, {1950,0.003350711}, {1960,0.005881517}, {1970,0.003473934}, {1980,0.003383886}, {1990,0.003535545}, {2000,0.003526066}, {2050,0.003630332}, {2100,0.003545024}, {2150,0.003663507}, {2200,0.003905213}, {2250,0.003938389}, {2300,0.007369668}, {2350,0.004208531}, {2400,0.004194313}, {2450,0.008109005}, {2500,0.004374408}, {2550,0.004450237}, {2600,0.008909953}, {2650,0.004672986}, {2700,0.004805687}, {2750,0.008175355}, {2800,0.004995261}, {2850,0.004928910}, {2900,0.005218009}, {2950,0.005194313}, {3000,0.005327014}, {3050,0.005383886}, {3100,0.005620853}, {3150,0.005611374}, {3200,0.005938389}, {3250,0.005848341}, {3300,0.006104265}, {3350,0.005995261}, {3400,0.006080569}, {3450,0.011028436}, {3500,0.006592417}, {3550,0.006729858}, {3600,0.006545024}, {3650,0.006606635}, {3700,0.006805687}, {3750,0.006872038}, {3800,0.007061611}, {3850,0.007099526}, {3900,0.007298578}, {3950,0.012862559}, {4000,0.007440758}, {4050,0.007412322}, {4100,0.007748815}, {4150,0.011706161}, {4200,0.007843602}, {4250,0.007824645}, {4300,0.008104265}, {4350,0.008308057}, {4400,0.011952607}, {4450,0.008696682}, {4500,0.008710900}, {4550,0.008966825}, {4600,0.008928910}, {4650,0.012478673}, {4700,0.009028436}, {4750,0.009502370}, {4800,0.015445498}, {4850,0.009919431}, {4900,0.009644550}, {4950,0.013725118}, {5000,0.010104265}, {5050,0.010151659}, {5100,0.015056872}, {5150,0.010270142}, {5200,0.010445498}, {5250,0.015445498}, {5300,0.010791469}, {5350,0.010952607}, {5400,0.017947867}, {5450,0.011189573}, {5500,0.011478673}, {5550,0.011274882}, {5600,0.017113744}, {5650,0.011677725}, {5700,0.011701422}, {5750,0.011886256}, {5800,0.019786730}, {5850,0.017862559}, {5900,0.012355450}, {5950,0.012488152}, {6000,0.012497630}, {6050,0.018990521}, {6100,0.019194313}, {6150,0.012758294}, {6200,0.012810427}, {6250,0.012962085}, {6300,0.012753555}, {6350,0.018071090}, {6400,0.019274882}, {6450,0.013630332}, {6500,0.013364929}, {6550,0.013843602}, {6600,0.013559242}, {6650,0.013582938}, {6700,0.023625592}, {6750,0.028947867}, {6800,0.026815166}, {6850,0.014601896}, {6900,0.014364929}, {6950,0.014341232}, {7000,0.014715640}, {7050,0.014644550}, {7100,0.015052133}, {7150,0.014862559}, {7200,0.014933649}, {7250,0.014957346}, {7300,0.015127962}, {7350,0.015118483}, {7400,0.015156398}, {7450,0.015227488}, {7500,0.015398104}, {7550,0.015502370}, {7600,0.015521327}, {7650,0.015744076}, {7700,0.015909953}, {7750,0.016279621}, {7800,0.016265403}, {7850,0.016180095}, {7900,0.016270142}, {7950,0.016909953}, {8000,0.016872038}, {8050,0.016834123}, {8100,0.017066351}, {8150,0.017274882}, {8200,0.025075829}, {8250,0.032578199}, {8300,0.025355450}, {8350,0.029236967}, {8400,0.017213270}, {8450,0.017573460}, {8500,0.017985782}, {8550,0.018170616}, {8600,0.018426540}, {8650,0.030862559}, {8700,0.029184834}, {8750,0.017734597}, {8800,0.018312796}, {8850,0.018777251}, {8900,0.018796209}, {8950,0.029511848}, {9000,0.031075829}, {9050,0.018616114}, {9100,0.019488152}, {9150,0.019611374}, {9200,0.034151659}, {9250,0.028696682}, {9300,0.019815166}, {9350,0.020184834}, {9400,0.033132701}, {9450,0.030819905}, {9500,0.020113744}, {9550,0.020497630}, {9600,0.034748815}, {9650,0.028464455}, {9700,0.020606635}, {9750,0.032720379}, {9800,0.033165877}, {9850,0.021317536}, {9900,0.021540284}, {9950,0.043478673}, {10000,0.021189573}, {10100,0.022255924}, {10200,0.044189573}, {10300,0.021763033}, {10400,0.023061611}, {10500,0.037469194}, {10600,0.023085308}, {10700,0.047085308}, {10800,0.023127962}, {10900,0.033071090}, {11000,0.023417062}, {11100,0.024568720}, {11200,0.033682464}, {11300,0.025018957}, {11400,0.035146919}, {11500,0.025388626}, {11600,0.024924171}, {11700,0.031488152}, {11800,0.025203791}, {11900,0.043331754}, {12000,0.026009479}, {12100,0.040639810}, {12200,0.027047393}, {12300,0.026322275}, {12400,0.054985782}, {12500,0.027042654}, {12600,0.026706161}, {12700,0.053364929}, {12800,0.027710900}, {12900,0.027469194}, {13000,0.053303318}, {13100,0.037654028}, {13200,0.028881517}, {13300,0.028421801}, {13400,0.053938389}, {13500,0.040445498}, {13600,0.029758294}, {13700,0.029454976}, {13800,0.040213270}, {13900,0.052132701}, {14000,0.061137441}, {14100,0.039616114}, {14200,0.031274882}, {14300,0.030886256}, {14400,0.030981043}, {14500,0.031393365}, {14600,0.040488152}, {14700,0.044943128}, {14800,0.050511848}, {14900,0.048872038}, {15000,0.058350711}, {15100,0.057289100}, {15200,0.056786730}, {15300,0.058208531}, {15400,0.051270142}, {15500,0.051151659}, {15600,0.045535545}, {15700,0.039109005}, {15800,0.034421801}, {15900,0.034649289}, {16000,0.035165877}, {16100,0.044597156}, {16200,0.051118483}, {16300,0.071454976}, {16400,0.053431280}, {16500,0.035848341}, {16600,0.036241706}, {16700,0.044023697}, {16800,0.063521327}, {16900,0.056317536}, {17000,0.037009479}, {17100,0.037355450}, {17200,0.064568720}, {17300,0.057113744}, {17400,0.037848341}, {17500,0.052488152}, {17600,0.064710900}, {17700,0.038388626}, {17800,0.051853081}, {17900,0.064838863}, {18000,0.039175355}, {18100,0.067549763}, {18200,0.050270142}, {18300,0.043222749}, {18400,0.073834123}, {18500,0.040488152}, {18600,0.078303318}, {18700,0.041023697}, {18800,0.075398104}, {18900,0.041497630}, {19000,0.074047393}, {19100,0.041943128}, {19200,0.083450237}, {19300,0.042473934}, {19400,0.077909953}, {19500,0.048767773}, {19600,0.061066351}, {19700,0.057170616}, {19800,0.043454976}, {19900,0.077061611}, {20000,0.046980861}};
data["big_flat"]["Parametricity; beta"]["eval lazy"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000018957}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000018957}, {20,0.000000000}, {21,0.000000000}, {22,0.000018957}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000018957}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000033175}, {37,0.000000000}, {38,0.000018957}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000018957}, {55,0.000000000}, {56,0.000018957}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000018957}, {68,0.000018957}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000018957}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000018957}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000018957}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000018957}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000018957}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000018957}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000014218}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000014218}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000018957}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000037915}, {148,0.000000000}, {149,0.000000000}, {150,0.000018957}, {151,0.000000000}, {152,0.000000000}, {153,0.000018957}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000014218}, {165,0.000018957}, {166,0.000000000}, {167,0.000000000}, {168,0.000018957}, {169,0.000000000}, {170,0.000000000}, {171,0.000014218}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000014218}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000018957}, {195,0.000000000}, {196,0.000018957}, {197,0.000018957}, {198,0.000018957}, {199,0.000000000}, {200,0.000018957}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000018957}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000018957}, {219,0.000000000}, {220,0.000018957}, {221,0.000018957}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000018957}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000018957}, {232,0.000000000}, {233,0.000000000}, {234,0.000018957}, {235,0.000000000}, {236,0.000018957}, {237,0.000000000}, {238,0.000018957}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000018957}, {248,0.000014218}, {249,0.000018957}, {250,0.000018957}, {251,0.000018957}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000018957}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000018957}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000018957}, {270,0.000000000}, {271,0.000018957}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000018957}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000018957}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000018957}, {288,0.000037915}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000018957}, {297,0.000037915}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000018957}, {308,0.000000000}, {309,0.000000000}, {310,0.000037915}, {311,0.000000000}, {312,0.000000000}, {313,0.000018957}, {314,0.000018957}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000037915}, {321,0.000000000}, {322,0.000000000}, {323,0.000018957}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000018957}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000018957}, {345,0.000018957}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000018957}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000018957}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000037915}, {361,0.000014218}, {362,0.000018957}, {363,0.000000000}, {364,0.000000000}, {365,0.000018957}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000018957}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000018957}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000014218}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000014218}, {386,0.000018957}, {387,0.000000000}, {388,0.000018957}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000018957}, {394,0.000000000}, {395,0.000000000}, {396,0.000014218}, {397,0.000000000}, {398,0.000037915}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000018957}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000014218}, {412,0.000000000}, {413,0.000018957}, {414,0.000018957}, {415,0.000000000}, {416,0.000000000}, {417,0.000018957}, {418,0.000018957}, {419,0.000000000}, {420,0.000000000}, {421,0.000014218}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000014218}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000018957}, {441,0.000018957}, {442,0.000000000}, {443,0.000018957}, {444,0.000033175}, {445,0.000000000}, {446,0.000014218}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000018957}, {454,0.000000000}, {455,0.000000000}, {456,0.000018957}, {457,0.000000000}, {458,0.000018957}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000037915}, {463,0.000018957}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000037915}, {469,0.000018957}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000018957}, {474,0.000000000}, {475,0.000018957}, {476,0.000018957}, {477,0.000000000}, {478,0.000018957}, {479,0.000014218}, {480,0.000018957}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000018957}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000018957}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000018957}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000018957}, {515,0.000018957}, {520,0.000033175}, {525,0.000018957}, {530,0.000018957}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000018957}, {600,0.000018957}, {605,0.000000000}, {610,0.000014218}, {615,0.000018957}, {620,0.000018957}, {625,0.000000000}, {630,0.000000000}, {635,0.000037915}, {640,0.000033175}, {645,0.000000000}, {650,0.000033175}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000018957}, {675,0.000014218}, {680,0.000014218}, {685,0.000000000}, {690,0.000018957}, {695,0.000018957}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000018957}, {735,0.000000000}, {740,0.000018957}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000018957}, {780,0.000018957}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000018957}, {805,0.000018957}, {810,0.000000000}, {815,0.000000000}, {820,0.000033175}, {825,0.000000000}, {830,0.000018957}, {835,0.000056872}, {840,0.000014218}, {845,0.000018957}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000037915}, {885,0.000018957}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000018957}, {910,0.000014218}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000037915}, {950,0.000000000}, {955,0.000018957}, {960,0.000000000}, {965,0.000018957}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000018957}, {1060,0.000018957}, {1070,0.000018957}, {1080,0.000018957}, {1090,0.000000000}, {1100,0.000018957}, {1110,0.000000000}, {1120,0.000066351}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000033175}, {1160,0.000000000}, {1170,0.000018957}, {1180,0.000000000}, {1190,0.000018957}, {1200,0.000037915}, {1210,0.000018957}, {1220,0.000018957}, {1230,0.000000000}, {1240,0.000018957}, {1250,0.000000000}, {1260,0.000018957}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000094787}, {1300,0.000018957}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000018957}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000018957}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000018957}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000037915}, {1490,0.000037915}, {1500,0.000132701}, {1510,0.000018957}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000014218}, {1550,0.000000000}, {1560,0.000037915}, {1570,0.000018957}, {1580,0.000000000}, {1590,0.000037915}, {1600,0.000000000}, {1610,0.000033175}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000056872}, {1660,0.000018957}, {1670,0.000000000}, {1680,0.000018957}, {1690,0.000018957}, {1700,0.000018957}, {1710,0.000000000}, {1720,0.000018957}, {1730,0.000018957}, {1740,0.000000000}, {1750,0.000018957}, {1760,0.000037915}, {1770,0.000018957}, {1780,0.000018957}, {1790,0.000018957}, {1800,0.000037915}, {1810,0.000033175}, {1820,0.000037915}, {1830,0.000000000}, {1840,0.000075829}, {1850,0.000018957}, {1860,0.000037915}, {1870,0.000000000}, {1880,0.000033175}, {1890,0.000037915}, {1900,0.000000000}, {1910,0.000037915}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000018957}, {1960,0.000146919}, {1970,0.000000000}, {1980,0.000014218}, {1990,0.000018957}, {2000,0.000000000}, {2050,0.000018957}, {2100,0.000018957}, {2150,0.000018957}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000056872}, {2350,0.000000000}, {2400,0.000037915}, {2450,0.000113744}, {2500,0.000000000}, {2550,0.000018957}, {2600,0.000109005}, {2650,0.000018957}, {2700,0.000037915}, {2750,0.000056872}, {2800,0.000018957}, {2850,0.000000000}, {2900,0.000018957}, {2950,0.000037915}, {3000,0.000033175}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000018957}, {3250,0.000018957}, {3300,0.000018957}, {3350,0.000018957}, {3400,0.000037915}, {3450,0.000109005}, {3500,0.000018957}, {3550,0.000000000}, {3600,0.000018957}, {3650,0.000018957}, {3700,0.000037915}, {3750,0.000018957}, {3800,0.000000000}, {3850,0.000018957}, {3900,0.000000000}, {3950,0.000037915}, {4000,0.000033175}, {4050,0.000075829}, {4100,0.000018957}, {4150,0.000132701}, {4200,0.000018957}, {4250,0.000018957}, {4300,0.000018957}, {4350,0.000000000}, {4400,0.000018957}, {4450,0.000018957}, {4500,0.000018957}, {4550,0.000056872}, {4600,0.000018957}, {4650,0.000052133}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000161137}, {4850,0.000000000}, {4900,0.000056872}, {4950,0.000113744}, {5000,0.000018957}, {5050,0.000037915}, {5100,0.000109005}, {5150,0.000018957}, {5200,0.000000000}, {5250,0.000189573}, {5300,0.000033175}, {5350,0.000000000}, {5400,0.000156398}, {5450,0.000000000}, {5500,0.000018957}, {5550,0.000000000}, {5600,0.000151659}, {5650,0.000000000}, {5700,0.000018957}, {5750,0.000037915}, {5800,0.000109005}, {5850,0.000165877}, {5900,0.000014218}, {5950,0.000018957}, {6000,0.000056872}, {6050,0.000132701}, {6100,0.000104265}, {6150,0.000037915}, {6200,0.000037915}, {6250,0.000018957}, {6300,0.000056872}, {6350,0.000127962}, {6400,0.000071090}, {6450,0.000000000}, {6500,0.000000000}, {6550,0.000056872}, {6600,0.000075829}, {6650,0.000018957}, {6700,0.000227488}, {6750,0.000265403}, {6800,0.000203791}, {6850,0.000037915}, {6900,0.000000000}, {6950,0.000052133}, {7000,0.000000000}, {7050,0.000056872}, {7100,0.000000000}, {7150,0.000000000}, {7200,0.000018957}, {7250,0.000018957}, {7300,0.000018957}, {7350,0.000018957}, {7400,0.000056872}, {7450,0.000056872}, {7500,0.000000000}, {7550,0.000056872}, {7600,0.000037915}, {7650,0.000018957}, {7700,0.000018957}, {7750,0.000018957}, {7800,0.000000000}, {7850,0.000000000}, {7900,0.000018957}, {7950,0.000018957}, {8000,0.000000000}, {8050,0.000056872}, {8100,0.000000000}, {8150,0.000000000}, {8200,0.000222749}, {8250,0.000336493}, {8300,0.000251185}, {8350,0.000037915}, {8400,0.000018957}, {8450,0.000018957}, {8500,0.000018957}, {8550,0.000000000}, {8600,0.000000000}, {8650,0.000189573}, {8700,0.000056872}, {8750,0.000018957}, {8800,0.000000000}, {8850,0.000000000}, {8900,0.000018957}, {8950,0.000260664}, {9000,0.000018957}, {9050,0.000018957}, {9100,0.000018957}, {9150,0.000000000}, {9200,0.000218009}, {9250,0.000056872}, {9300,0.000090047}, {9350,0.000075829}, {9400,0.000170616}, {9450,0.000175355}, {9500,0.000018957}, {9550,0.000018957}, {9600,0.000360190}, {9650,0.000184834}, {9700,0.000056872}, {9750,0.000222749}, {9800,0.000222749}, {9850,0.000018957}, {9900,0.000018957}, {9950,0.000208531}, {10000,0.000056872}, {10100,0.000018957}, {10200,0.000454976}, {10300,0.000094787}, {10400,0.000018957}, {10500,0.000317536}, {10600,0.000018957}, {10700,0.000298578}, {10800,0.000000000}, {10900,0.000090047}, {11000,0.000056872}, {11100,0.000018957}, {11200,0.000142180}, {11300,0.000056872}, {11400,0.000132701}, {11500,0.000000000}, {11600,0.000037915}, {11700,0.000094787}, {11800,0.000075829}, {11900,0.000265403}, {12000,0.000000000}, {12100,0.000246445}, {12200,0.000018957}, {12300,0.000056872}, {12400,0.000507109}, {12500,0.000056872}, {12600,0.000094787}, {12700,0.000620853}, {12800,0.000018957}, {12900,0.000037915}, {13000,0.000350711}, {13100,0.000151659}, {13200,0.000018957}, {13300,0.000000000}, {13400,0.000170616}, {13500,0.000018957}, {13600,0.000000000}, {13700,0.000033175}, {13800,0.000184834}, {13900,0.000236967}, {14000,0.000203791}, {14100,0.000000000}, {14200,0.000037915}, {14300,0.000056872}, {14400,0.000075829}, {14500,0.000018957}, {14600,0.000132701}, {14700,0.000222749}, {14800,0.000407583}, {14900,0.000369668}, {15000,0.000322275}, {15100,0.000388626}, {15200,0.000516588}, {15300,0.000317536}, {15400,0.000113744}, {15500,0.000000000}, {15600,0.000018957}, {15700,0.000056872}, {15800,0.000037915}, {15900,0.000037915}, {16000,0.000018957}, {16100,0.000284360}, {16200,0.000303318}, {16300,0.000317536}, {16400,0.000018957}, {16500,0.000056872}, {16600,0.000018957}, {16700,0.000127962}, {16800,0.000246445}, {16900,0.000018957}, {17000,0.000033175}, {17100,0.000018957}, {17200,0.000374408}, {17300,0.000075829}, {17400,0.000075829}, {17500,0.000132701}, {17600,0.000037915}, {17700,0.000071090}, {17800,0.000075829}, {17900,0.000018957}, {18000,0.000000000}, {18100,0.000000000}, {18200,0.000018957}, {18300,0.000000000}, {18400,0.000000000}, {18500,0.000018957}, {18600,0.000056872}, {18700,0.000018957}, {18800,0.000000000}, {18900,0.000018957}, {19000,0.000000000}, {19100,0.000018957}, {19200,0.000056872}, {19300,0.000037915}, {19400,0.000018957}, {19500,0.000037915}, {19600,0.000000000}, {19700,0.000018957}, {19800,0.000056872}, {19900,0.000018957}, {20000,0.000019139}};
data["big_flat"]["Parametricity; beta"]["lazy beta iota"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000511848}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000018957}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.001616114}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.001763033}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000009479}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000004739}, {3550,0.005838863}, {3600,0.000014218}, {3650,0.000009479}, {3700,0.000028436}, {3750,0.000018957}, {3800,0.000037915}, {3850,0.004170616}, {3900,0.000071090}, {3950,0.000000000}, {4000,0.000094787}, {4050,0.000000000}, {4100,0.000109005}, {4150,0.000004739}, {4200,0.000118483}, {4250,0.000137441}, {4300,0.000184834}, {4350,0.000227488}, {4400,0.000037915}, {4450,0.000303318}, {4500,0.000289100}, {4550,0.000383886}, {4600,0.000402844}, {4650,0.000004739}, {4700,0.000578199}, {4750,0.000388626}, {4800,0.000355450}, {4850,0.000772512}, {4900,0.000407583}, {4950,0.000417062}, {5000,0.000810427}, {5050,0.000436019}, {5100,0.000445498}, {5150,0.000829384}, {5200,0.000454976}, {5250,0.000568720}, {5300,0.000919431}, {5350,0.000890995}, {5400,0.000417062}, {5450,0.000938389}, {5500,0.000962085}, {5550,0.000739336}, {5600,0.000668246}, {5650,0.001000000}, {5700,0.001004739}, {5750,0.000914692}, {5800,0.000810427}, {5850,0.000876777}, {5900,0.001000000}, {5950,0.001004739}, {6000,0.000919431}, {6050,0.000876777}, {6100,0.000938389}, {6150,0.001018957}, {6200,0.001004739}, {6250,0.000962085}, {6300,0.000947867}, {6350,0.000976303}, {6400,0.001000000}, {6450,0.001042654}, {6500,0.001047393}, {6550,0.001071090}, {6600,0.001033175}, {6650,0.001009479}, {6700,0.001000000}, {6750,0.001000000}, {6800,0.001000000}, {6850,0.012369668}, {6900,0.001156398}, {6950,0.001180095}, {7000,0.001161137}, {7050,0.001184834}, {7100,0.001218009}, {7150,0.001232227}, {7200,0.001218009}, {7250,0.001251185}, {7300,0.001236967}, {7350,0.001246445}, {7400,0.001009479}, {7450,0.001004739}, {7500,0.001009479}, {7550,0.001009479}, {7600,0.001009479}, {7650,0.001009479}, {7700,0.001336493}, {7750,0.001355450}, {7800,0.001341232}, {7850,0.001322275}, {7900,0.001374408}, {7950,0.001469194}, {8000,0.001502370}, {8050,0.001492891}, {8100,0.001521327}, {8150,0.001516588}, {8200,0.001132701}, {8250,0.001132701}, {8300,0.001000000}, {8350,0.001009479}, {8400,0.001009479}, {8450,0.001417062}, {8500,0.001696682}, {8550,0.001668246}, {8600,0.001649289}, {8650,0.001241706}, {8700,0.001000000}, {8750,0.001014218}, {8800,0.001454976}, {8850,0.001687204}, {8900,0.001744076}, {8950,0.001317536}, {9000,0.001061611}, {9050,0.001018957}, {9100,0.001815166}, {9150,0.001843602}, {9200,0.008947867}, {9250,0.001061611}, {9300,0.001592417}, {9350,0.001981043}, {9400,0.001464455}, {9450,0.001151659}, {9500,0.001644550}, {9550,0.002109005}, {9600,0.017298578}, {9650,0.001246445}, {9700,0.001720379}, {9750,0.001644550}, {9800,0.001232227}, {9850,0.001829384}, {9900,0.002488152}, {9950,0.001317536}, {10000,0.001374408}, {10100,0.002360190}, {10200,0.001407583}, {10300,0.001473934}, {10400,0.002393365}, {10500,0.001526066}, {10600,0.002037915}, {10700,0.001568720}, {10800,0.001635071}, {10900,0.002009479}, {11000,0.001744076}, {11100,0.002549763}, {11200,0.001800948}, {11300,0.002592417}, {11400,0.001838863}, {11500,0.002635071}, {11600,0.001890995}, {11700,0.002251185}, {11800,0.001924171}, {11900,0.010123223}, {12000,0.002398104}, {12100,0.001952607}, {12200,0.002838863}, {12300,0.001981043}, {12400,0.001976303}, {12500,0.002625592}, {12600,0.001985782}, {12700,0.002000000}, {12800,0.002966825}, {12900,0.002023697}, {13000,0.002000000}, {13100,0.002454976}, {13200,0.002867299}, {13300,0.002018957}, {13400,0.002018957}, {13500,0.002578199}, {13600,0.002914692}, {13700,0.002056872}, {13800,0.002270142}, {13900,0.002080569}, {14000,0.002127962}, {14100,0.002838863}, {14200,0.002900474}, {14300,0.002327014}, {14400,0.002331754}, {14500,0.002426540}, {14600,0.002327014}, {14700,0.002445498}, {14800,0.002454976}, {14900,0.002450237}, {15000,0.002473934}, {15100,0.002483412}, {15200,0.002488152}, {15300,0.002540284}, {15400,0.002554502}, {15500,0.002592417}, {15600,0.002620853}, {15700,0.002739336}, {15800,0.002800948}, {15900,0.002815166}, {16000,0.003023697}, {16100,0.002805687}, {16200,0.013810427}, {16300,0.002815166}, {16400,0.002843602}, {16500,0.002805687}, {16600,0.002829384}, {16700,0.002853081}, {16800,0.002834123}, {16900,0.002876777}, {17000,0.002938389}, {17100,0.011540284}, {17200,0.002938389}, {17300,0.002933649}, {17400,0.003033175}, {17500,0.002947867}, {17600,0.002971564}, {17700,0.003028436}, {17800,0.002981043}, {17900,0.003004739}, {18000,0.003260664}, {18100,0.003014218}, {18200,0.003270142}, {18300,0.003142180}, {18400,0.003132701}, {18500,0.003345972}, {18600,0.003151659}, {18700,0.003393365}, {18800,0.003360190}, {18900,0.003454976}, {19000,0.003312796}, {19100,0.003440758}, {19200,0.003483412}, {19300,0.003606635}, {19400,0.003431280}, {19500,0.003554502}, {19600,0.003483412}, {19700,0.010545024}, {19800,0.003563981}, {19900,0.003578199}, {20000,0.003703349}};
data["big_flat"]["Parametricity; beta"]["lazy beta iota"]["user"] = {{1,0.000033175}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000071090}, {7,0.000037915}, {8,0.000000000}, {9,0.000033175}, {10,0.000033175}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000033175}, {16,0.000018957}, {17,0.000033175}, {18,0.000018957}, {19,0.000018957}, {20,0.000000000}, {21,0.000014218}, {22,0.000014218}, {23,0.000000000}, {24,0.000018957}, {25,0.000047393}, {26,0.000033175}, {27,0.000018957}, {28,0.000014218}, {29,0.000018957}, {30,0.000018957}, {31,0.000018957}, {32,0.000000000}, {33,0.000000000}, {34,0.000018957}, {35,0.000018957}, {36,0.000047393}, {37,0.000014218}, {38,0.000018957}, {39,0.000037915}, {40,0.000000000}, {41,0.000018957}, {42,0.000018957}, {43,0.000000000}, {44,0.000028436}, {45,0.000014218}, {46,0.000000000}, {47,0.000018957}, {48,0.000033175}, {49,0.000018957}, {50,0.000047393}, {51,0.000014218}, {52,0.000000000}, {53,0.000018957}, {54,0.000014218}, {55,0.000037915}, {56,0.000018957}, {57,0.000052133}, {58,0.000000000}, {59,0.000014218}, {60,0.000018957}, {61,0.000037915}, {62,0.000018957}, {63,0.000000000}, {64,0.000014218}, {65,0.000066351}, {66,0.000018957}, {67,0.000037915}, {68,0.000000000}, {69,0.000028436}, {70,0.000018957}, {71,0.000052133}, {72,0.000014218}, {73,0.000052133}, {74,0.000033175}, {75,0.000000000}, {76,0.000014218}, {77,0.000052133}, {78,0.000037915}, {79,0.000018957}, {80,0.000033175}, {81,0.000018957}, {82,0.000000000}, {83,0.000018957}, {84,0.000028436}, {85,0.000000000}, {86,0.000042654}, {87,0.000018957}, {88,0.000066351}, {89,0.000037915}, {90,0.000090047}, {91,0.000028436}, {92,0.000037915}, {93,0.000028436}, {94,0.000047393}, {95,0.000028436}, {96,0.000000000}, {97,0.000066351}, {98,0.000033175}, {99,0.000033175}, {100,0.000056872}, {101,0.000014218}, {102,0.000028436}, {103,0.000033175}, {104,0.000071090}, {105,0.000028436}, {106,0.000033175}, {107,0.000066351}, {108,0.000037915}, {109,0.000014218}, {110,0.000018957}, {111,0.000018957}, {112,0.000028436}, {113,0.000018957}, {114,0.000080569}, {115,0.000014218}, {116,0.000018957}, {117,0.000000000}, {118,0.000018957}, {119,0.000018957}, {120,0.000018957}, {121,0.000000000}, {122,0.000052133}, {123,0.000014218}, {124,0.000018957}, {125,0.000071090}, {126,0.000014218}, {127,0.000047393}, {128,0.000037915}, {129,0.000018957}, {130,0.000000000}, {131,0.000000000}, {132,0.000033175}, {133,0.000018957}, {134,0.000052133}, {135,0.000018957}, {136,0.000018957}, {137,0.000033175}, {138,0.000075829}, {139,0.000000000}, {140,0.000052133}, {141,0.000000000}, {142,0.000000000}, {143,0.000071090}, {144,0.000000000}, {145,0.000052133}, {146,0.000061611}, {147,0.000052133}, {148,0.000000000}, {149,0.000014218}, {150,0.000014218}, {151,0.000066351}, {152,0.000047393}, {153,0.000075829}, {154,0.000094787}, {155,0.000033175}, {156,0.000042654}, {157,0.000033175}, {158,0.000047393}, {159,0.000033175}, {160,0.000033175}, {161,0.000071090}, {162,0.000061611}, {163,0.000080569}, {164,0.000071090}, {165,0.000047393}, {166,0.000033175}, {167,0.000018957}, {168,0.000052133}, {169,0.000075829}, {170,0.000052133}, {171,0.000075829}, {172,0.000014218}, {173,0.000066351}, {174,0.000052133}, {175,0.000028436}, {176,0.000056872}, {177,0.000047393}, {178,0.000094787}, {179,0.000018957}, {180,0.000104265}, {181,0.000028436}, {182,0.000052133}, {183,0.000071090}, {184,0.000052133}, {185,0.000080569}, {186,0.000104265}, {187,0.000052133}, {188,0.000018957}, {189,0.000075829}, {190,0.000094787}, {191,0.000014218}, {192,0.000071090}, {193,0.000047393}, {194,0.000085308}, {195,0.000014218}, {196,0.000014218}, {197,0.000028436}, {198,0.000071090}, {199,0.000099526}, {200,0.000104265}, {201,0.000056872}, {202,0.000018957}, {203,0.000071090}, {204,0.000042654}, {205,0.000066351}, {206,0.000056872}, {207,0.000085308}, {208,0.000018957}, {209,0.000033175}, {210,0.000033175}, {211,0.000028436}, {212,0.000033175}, {213,0.000037915}, {214,0.000037915}, {215,0.000066351}, {216,0.000052133}, {217,0.000099526}, {218,0.000085308}, {219,0.000075829}, {220,0.000033175}, {221,0.000085308}, {222,0.000099526}, {223,0.000080569}, {224,0.000066351}, {225,0.000014218}, {226,0.000071090}, {227,0.000033175}, {228,0.000033175}, {229,0.000033175}, {230,0.000056872}, {231,0.000014218}, {232,0.000071090}, {233,0.000853081}, {234,0.000033175}, {235,0.000109005}, {236,0.000033175}, {237,0.000099526}, {238,0.000061611}, {239,0.000066351}, {240,0.000075829}, {241,0.000033175}, {242,0.000056872}, {243,0.000047393}, {244,0.000018957}, {245,0.000066351}, {246,0.000033175}, {247,0.000018957}, {248,0.000047393}, {249,0.000018957}, {250,0.000033175}, {251,0.000071090}, {252,0.000018957}, {253,0.000018957}, {254,0.000094787}, {255,0.000075829}, {256,0.000109005}, {257,0.000052133}, {258,0.000037915}, {259,0.000056872}, {260,0.000014218}, {261,0.000146919}, {262,0.000033175}, {263,0.000090047}, {264,0.000037915}, {265,0.000052133}, {266,0.000066351}, {267,0.000090047}, {268,0.000118483}, {269,0.000018957}, {270,0.000056872}, {271,0.000075829}, {272,0.000052133}, {273,0.000056872}, {274,0.000056872}, {275,0.000056872}, {276,0.000075829}, {277,0.000037915}, {278,0.000014218}, {279,0.000085308}, {280,0.000047393}, {281,0.000118483}, {282,0.000037915}, {283,0.000156398}, {284,0.000151659}, {285,0.000047393}, {286,0.000132701}, {287,0.000033175}, {288,0.000052133}, {289,0.000061611}, {290,0.000052133}, {291,0.000137441}, {292,0.000090047}, {293,0.000052133}, {294,0.000028436}, {295,0.000052133}, {296,0.000104265}, {297,0.000037915}, {298,0.000071090}, {299,0.000118483}, {300,0.000061611}, {301,0.000014218}, {302,0.000127962}, {303,0.000066351}, {304,0.000056872}, {305,0.000071090}, {306,0.000018957}, {307,0.000080569}, {308,0.000075829}, {309,0.000071090}, {310,0.000123223}, {311,0.000085308}, {312,0.000037915}, {313,0.000085308}, {314,0.000033175}, {315,0.000052133}, {316,0.000075829}, {317,0.000052133}, {318,0.000056872}, {319,0.000090047}, {320,0.000033175}, {321,0.000090047}, {322,0.000047393}, {323,0.000037915}, {324,0.000033175}, {325,0.000099526}, {326,0.000033175}, {327,0.000018957}, {328,0.000123223}, {329,0.000104265}, {330,0.000085308}, {331,0.000146919}, {332,0.000056872}, {333,0.000090047}, {334,0.000052133}, {335,0.000085308}, {336,0.000104265}, {337,0.000018957}, {338,0.000090047}, {339,0.000056872}, {340,0.000071090}, {341,0.000099526}, {342,0.000047393}, {343,0.000099526}, {344,0.000156398}, {345,0.000132701}, {346,0.000109005}, {347,0.000047393}, {348,0.000056872}, {349,0.000137441}, {350,0.000203791}, {351,0.000071090}, {352,0.000113744}, {353,0.000123223}, {354,0.000033175}, {355,0.000056872}, {356,0.000066351}, {357,0.000052133}, {358,0.000047393}, {359,0.000123223}, {360,0.000090047}, {361,0.000071090}, {362,0.000127962}, {363,0.000146919}, {364,0.000104265}, {365,0.000104265}, {366,0.000052133}, {367,0.000085308}, {368,0.000042654}, {369,0.000018957}, {370,0.000033175}, {371,0.000061611}, {372,0.000052133}, {373,0.000066351}, {374,0.000071090}, {375,0.000047393}, {376,0.000080569}, {377,0.000028436}, {378,0.000104265}, {379,0.000132701}, {380,0.000104265}, {381,0.000028436}, {382,0.000037915}, {383,0.000090047}, {384,0.000052133}, {385,0.000075829}, {386,0.000052133}, {387,0.000000000}, {388,0.000047393}, {389,0.000104265}, {390,0.000127962}, {391,0.000085308}, {392,0.000094787}, {393,0.000142180}, {394,0.000085308}, {395,0.000180095}, {396,0.000037915}, {397,0.000066351}, {398,0.000109005}, {399,0.000094787}, {400,0.000033175}, {401,0.000137441}, {402,0.000161137}, {403,0.000099526}, {404,0.000047393}, {405,0.000156398}, {406,0.000094787}, {407,0.000080569}, {408,0.000175355}, {409,0.000094787}, {410,0.000109005}, {411,0.000104265}, {412,0.000018957}, {413,0.000066351}, {414,0.000109005}, {415,0.000109005}, {416,0.000118483}, {417,0.000018957}, {418,0.000094787}, {419,0.000118483}, {420,0.000113744}, {421,0.000156398}, {422,0.000071090}, {423,0.000080569}, {424,0.000090047}, {425,0.000033175}, {426,0.000170616}, {427,0.000113744}, {428,0.000047393}, {429,0.000071090}, {430,0.000118483}, {431,0.000094787}, {432,0.000137441}, {433,0.000184834}, {434,0.000085308}, {435,0.000037915}, {436,0.000071090}, {437,0.000018957}, {438,0.000113744}, {439,0.000052133}, {440,0.000127962}, {441,0.000085308}, {442,0.000061611}, {443,0.000118483}, {444,0.000090047}, {445,0.000061611}, {446,0.000085308}, {447,0.000085308}, {448,0.000142180}, {449,0.000094787}, {450,0.000085308}, {451,0.000127962}, {452,0.000113744}, {453,0.000071090}, {454,0.000127962}, {455,0.000037915}, {456,0.000109005}, {457,0.000033175}, {458,0.000075829}, {459,0.000085308}, {460,0.000033175}, {461,0.000118483}, {462,0.000052133}, {463,0.000142180}, {464,0.000085308}, {465,0.000085308}, {466,0.000099526}, {467,0.000127962}, {468,0.000118483}, {469,0.000127962}, {470,0.000184834}, {471,0.000071090}, {472,0.000109005}, {473,0.000094787}, {474,0.000090047}, {475,0.000109005}, {476,0.000014218}, {477,0.000085308}, {478,0.000127962}, {479,0.000113744}, {480,0.000104265}, {481,0.000142180}, {482,0.000052133}, {483,0.000109005}, {484,0.000052133}, {485,0.000127962}, {486,0.000151659}, {487,0.000104265}, {488,0.000066351}, {489,0.000066351}, {490,0.000137441}, {491,0.000104265}, {492,0.000047393}, {493,0.000094787}, {494,0.000156398}, {495,0.000113744}, {496,0.000137441}, {497,0.000085308}, {498,0.000090047}, {499,0.000151659}, {500,0.000056872}, {505,0.000037915}, {510,0.000146919}, {515,0.000123223}, {520,0.000113744}, {525,0.000118483}, {530,0.000137441}, {535,0.000123223}, {540,0.000090047}, {545,0.000090047}, {550,0.000156398}, {555,0.000104265}, {560,0.000080569}, {565,0.000132701}, {570,0.000137441}, {575,0.000156398}, {580,0.000170616}, {585,0.000123223}, {590,0.000156398}, {595,0.000151659}, {600,0.000109005}, {605,0.000099526}, {610,0.000123223}, {615,0.000142180}, {620,0.000104265}, {625,0.000104265}, {630,0.000104265}, {635,0.000066351}, {640,0.000104265}, {645,0.000208531}, {650,0.000137441}, {655,0.000094787}, {660,0.000066351}, {665,0.000170616}, {670,0.000099526}, {675,0.000208531}, {680,0.000161137}, {685,0.000156398}, {690,0.000142180}, {695,0.000104265}, {700,0.000151659}, {705,0.000194313}, {710,0.000137441}, {715,0.000118483}, {720,0.000203791}, {725,0.000132701}, {730,0.000184834}, {735,0.000184834}, {740,0.000118483}, {745,0.000090047}, {750,0.000189573}, {755,0.000170616}, {760,0.000109005}, {765,0.000199052}, {770,0.000118483}, {775,0.000274882}, {780,0.000156398}, {785,0.000037915}, {790,0.000170616}, {795,0.000199052}, {800,0.000132701}, {805,0.000222749}, {810,0.000189573}, {815,0.000151659}, {820,0.000127962}, {825,0.000156398}, {830,0.000123223}, {835,0.000052133}, {840,0.000170616}, {845,0.000142180}, {850,0.000208531}, {855,0.000232227}, {860,0.000151659}, {865,0.000118483}, {870,0.000227488}, {875,0.000232227}, {880,0.000180095}, {885,0.000090047}, {890,0.000208531}, {895,0.000232227}, {900,0.000099526}, {905,0.000146919}, {910,0.000194313}, {915,0.000146919}, {920,0.000175355}, {925,0.000189573}, {930,0.000222749}, {935,0.000127962}, {940,0.000213270}, {945,0.000161137}, {950,0.000113744}, {955,0.000189573}, {960,0.000184834}, {965,0.000265403}, {970,0.000255924}, {975,0.000194313}, {980,0.000222749}, {985,0.000175355}, {990,0.001687204}, {995,0.000109005}, {1000,0.000293839}, {1010,0.000355450}, {1020,0.000180095}, {1030,0.000208531}, {1040,0.000203791}, {1050,0.000142180}, {1060,0.000118483}, {1070,0.000142180}, {1080,0.000203791}, {1090,0.000199052}, {1100,0.000293839}, {1110,0.000170616}, {1120,0.000146919}, {1130,0.000218009}, {1140,0.000407583}, {1150,0.000369668}, {1160,0.000208531}, {1170,0.000246445}, {1180,0.000232227}, {1190,0.000241706}, {1200,0.000251185}, {1210,0.000279621}, {1220,0.000203791}, {1230,0.000284360}, {1240,0.000236967}, {1250,0.000194313}, {1260,0.000113744}, {1270,0.000218009}, {1280,0.000355450}, {1290,0.000194313}, {1300,0.000199052}, {1310,0.000165877}, {1320,0.000279621}, {1330,0.000303318}, {1340,0.000308057}, {1350,0.000241706}, {1360,0.000379147}, {1370,0.000355450}, {1380,0.000213270}, {1390,0.000270142}, {1400,0.000251185}, {1410,0.000345972}, {1420,0.000402844}, {1430,0.000327014}, {1440,0.000293839}, {1450,0.000227488}, {1460,0.000336493}, {1470,0.000184834}, {1480,0.000350711}, {1490,0.000360190}, {1500,0.000265403}, {1510,0.000331754}, {1520,0.000469194}, {1530,0.000322275}, {1540,0.000308057}, {1550,0.000317536}, {1560,0.000345972}, {1570,0.000308057}, {1580,0.000412322}, {1590,0.000317536}, {1600,0.000327014}, {1610,0.000388626}, {1620,0.000398104}, {1630,0.000251185}, {1640,0.000341232}, {1650,0.000331754}, {1660,0.000317536}, {1670,0.000369668}, {1680,0.001909953}, {1690,0.000213270}, {1700,0.000355450}, {1710,0.000284360}, {1720,0.000246445}, {1730,0.000298578}, {1740,0.000327014}, {1750,0.000450237}, {1760,0.000208531}, {1770,0.000260664}, {1780,0.000421801}, {1790,0.000246445}, {1800,0.000341232}, {1810,0.000260664}, {1820,0.000279621}, {1830,0.000336493}, {1840,0.000407583}, {1850,0.000364929}, {1860,0.000440758}, {1870,0.000360190}, {1880,0.000374408}, {1890,0.000355450}, {1900,0.000322275}, {1910,0.000393365}, {1920,0.000393365}, {1930,0.000454976}, {1940,0.000450237}, {1950,0.000327014}, {1960,0.000236967}, {1970,0.000355450}, {1980,0.000639810}, {1990,0.000402844}, {2000,0.000279621}, {2050,0.000341232}, {2100,0.000322275}, {2150,0.000412322}, {2200,0.000383886}, {2250,0.000322275}, {2300,0.000255924}, {2350,0.000464455}, {2400,0.000502370}, {2450,0.000450237}, {2500,0.000402844}, {2550,0.000502370}, {2600,0.000459716}, {2650,0.000582938}, {2700,0.000431280}, {2750,0.000454976}, {2800,0.000559242}, {2850,0.000464455}, {2900,0.000725118}, {2950,0.000573460}, {3000,0.000502370}, {3050,0.000739336}, {3100,0.000573460}, {3150,0.000625592}, {3200,0.000478673}, {3250,0.000549763}, {3300,0.000597156}, {3350,0.000620853}, {3400,0.000777251}, {3450,0.000639810}, {3500,0.000658768}, {3550,0.006312796}, {3600,0.000744076}, {3650,0.000701422}, {3700,0.000781991}, {3750,0.000729858}, {3800,0.000682464}, {3850,0.004388626}, {3900,0.000720379}, {3950,0.000668246}, {4000,0.000853081}, {4050,0.000725118}, {4100,0.000729858}, {4150,0.000554502}, {4200,0.000990521}, {4250,0.000644550}, {4300,0.000881517}, {4350,0.000957346}, {4400,0.000710900}, {4450,0.000639810}, {4500,0.000957346}, {4550,0.000985782}, {4600,0.000857820}, {4650,0.000748815}, {4700,0.001052133}, {4750,0.000734597}, {4800,0.000758294}, {4850,0.000843602}, {4900,0.000857820}, {4950,0.000853081}, {5000,0.001004739}, {5050,0.000843602}, {5100,0.000952607}, {5150,0.001303318}, {5200,0.001189573}, {5250,0.001042654}, {5300,0.001184834}, {5350,0.001161137}, {5400,0.000962085}, {5450,0.001345972}, {5500,0.001066351}, {5550,0.001222749}, {5600,0.001033175}, {5650,0.001374408}, {5700,0.001161137}, {5750,0.001052133}, {5800,0.000981043}, {5850,0.000905213}, {5900,0.001113744}, {5950,0.001161137}, {6000,0.001180095}, {6050,0.000909953}, {6100,0.000914692}, {6150,0.001293839}, {6200,0.001208531}, {6250,0.000952607}, {6300,0.000890995}, {6350,0.000824645}, {6400,0.001142180}, {6450,0.001317536}, {6500,0.001549763}, {6550,0.001251185}, {6600,0.001289100}, {6650,0.001146919}, {6700,0.000815166}, {6750,0.001061611}, {6800,0.001161137}, {6850,0.012350711}, {6900,0.001635071}, {6950,0.001725118}, {7000,0.001322275}, {7050,0.001426540}, {7100,0.001440758}, {7150,0.001616114}, {7200,0.001691943}, {7250,0.001710900}, {7300,0.001374408}, {7350,0.001431280}, {7400,0.001298578}, {7450,0.001483412}, {7500,0.001218009}, {7550,0.001189573}, {7600,0.001113744}, {7650,0.001327014}, {7700,0.001819905}, {7750,0.001492891}, {7800,0.001483412}, {7850,0.001488152}, {7900,0.001744076}, {7950,0.001630332}, {8000,0.001805687}, {8050,0.001857820}, {8100,0.001843602}, {8150,0.001895735}, {8200,0.001559242}, {8250,0.001350711}, {8300,0.001213270}, {8350,0.001284360}, {8400,0.001459716}, {8450,0.001635071}, {8500,0.001781991}, {8550,0.001540284}, {8600,0.001876777}, {8650,0.001616114}, {8700,0.001701422}, {8750,0.001511848}, {8800,0.001909953}, {8850,0.002071090}, {8900,0.002170616}, {8950,0.001682464}, {9000,0.001654028}, {9050,0.001905213}, {9100,0.002056872}, {9150,0.002341232}, {9200,0.009028436}, {9250,0.001630332}, {9300,0.001767773}, {9350,0.002033175}, {9400,0.001440758}, {9450,0.001540284}, {9500,0.001938389}, {9550,0.002061611}, {9600,0.017431280}, {9650,0.001682464}, {9700,0.002080569}, {9750,0.001886256}, {9800,0.001445498}, {9850,0.001952607}, {9900,0.002336493}, {9950,0.001720379}, {10000,0.001473934}, {10100,0.002308057}, {10200,0.001582938}, {10300,0.001511848}, {10400,0.002402844}, {10500,0.001649289}, {10600,0.001971564}, {10700,0.001407583}, {10800,0.001682464}, {10900,0.001928910}, {11000,0.001796209}, {11100,0.002559242}, {11200,0.001668246}, {11300,0.002744076}, {11400,0.001800948}, {11500,0.002592417}, {11600,0.001829384}, {11700,0.002388626}, {11800,0.001829384}, {11900,0.009890995}, {12000,0.002616114}, {12100,0.001848341}, {12200,0.002900474}, {12300,0.002094787}, {12400,0.001966825}, {12500,0.002563981}, {12600,0.002132701}, {12700,0.001933649}, {12800,0.002772512}, {12900,0.002047393}, {13000,0.002056872}, {13100,0.002630332}, {13200,0.002682464}, {13300,0.002094787}, {13400,0.002132701}, {13500,0.002573460}, {13600,0.002928910}, {13700,0.001867299}, {13800,0.002345972}, {13900,0.002374408}, {14000,0.001938389}, {14100,0.002739336}, {14200,0.003090047}, {14300,0.002355450}, {14400,0.002426540}, {14500,0.002398104}, {14600,0.002436019}, {14700,0.002374408}, {14800,0.002260664}, {14900,0.002236967}, {15000,0.002450237}, {15100,0.002232227}, {15200,0.002402844}, {15300,0.002691943}, {15400,0.002473934}, {15500,0.002483412}, {15600,0.002649289}, {15700,0.002483412}, {15800,0.002649289}, {15900,0.002630332}, {16000,0.002734597}, {16100,0.002654028}, {16200,0.013810427}, {16300,0.002710900}, {16400,0.002758294}, {16500,0.002701422}, {16600,0.002691943}, {16700,0.002763033}, {16800,0.002791469}, {16900,0.002734597}, {17000,0.002876777}, {17100,0.011331754}, {17200,0.003000000}, {17300,0.002886256}, {17400,0.003014218}, {17500,0.002919431}, {17600,0.002981043}, {17700,0.003066351}, {17800,0.002890995}, {17900,0.002995261}, {18000,0.003232227}, {18100,0.003004739}, {18200,0.003037915}, {18300,0.003000000}, {18400,0.002962085}, {18500,0.003246445}, {18600,0.002966825}, {18700,0.003236967}, {18800,0.003156398}, {18900,0.003284360}, {19000,0.003189573}, {19100,0.003194313}, {19200,0.003161137}, {19300,0.003454976}, {19400,0.003246445}, {19500,0.003199052}, {19600,0.003279621}, {19700,0.010142180}, {19800,0.003388626}, {19900,0.003184834}, {20000,0.003387560}};
data["big_flat"]["Parametricity; beta"]["lazy beta iota"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000018957}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000014218}, {65,0.000000000}, {66,0.000018957}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000018957}, {87,0.000000000}, {88,0.000000000}, {89,0.000018957}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000014218}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000018957}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000018957}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000014218}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000018957}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000018957}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000014218}, {335,0.000000000}, {336,0.000018957}, {337,0.000000000}, {338,0.000000000}, {339,0.000018957}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000018957}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000033175}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000018957}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000018957}, {403,0.000000000}, {404,0.000000000}, {405,0.000018957}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000018957}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000018957}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000018957}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000018957}, {455,0.000000000}, {456,0.000018957}, {457,0.000018957}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000018957}, {486,0.000000000}, {487,0.000000000}, {488,0.000018957}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000018957}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000018957}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000018957}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000018957}, {685,0.000000000}, {690,0.000018957}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000018957}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000018957}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000018957}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000018957}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000018957}, {900,0.000000000}, {905,0.000000000}, {910,0.000018957}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000071090}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000018957}, {1050,0.000018957}, {1060,0.000018957}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000037915}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000018957}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000018957}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000018957}, {1250,0.000000000}, {1260,0.000018957}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000018957}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000018957}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000018957}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000018957}, {1610,0.000018957}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000037915}, {1650,0.000000000}, {1660,0.000037915}, {1670,0.000000000}, {1680,0.000018957}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000037915}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000018957}, {1810,0.000018957}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000037915}, {1870,0.000000000}, {1880,0.000018957}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000018957}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000018957}, {1990,0.000000000}, {2000,0.000014218}, {2050,0.000018957}, {2100,0.000018957}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000018957}, {2450,0.000000000}, {2500,0.000018957}, {2550,0.000014218}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000037915}, {2900,0.000018957}, {2950,0.000000000}, {3000,0.000037915}, {3050,0.000033175}, {3100,0.000014218}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000037915}, {3600,0.000018957}, {3650,0.000000000}, {3700,0.000018957}, {3750,0.000000000}, {3800,0.000018957}, {3850,0.000132701}, {3900,0.000000000}, {3950,0.000018957}, {4000,0.000000000}, {4050,0.000037915}, {4100,0.000000000}, {4150,0.000018957}, {4200,0.000000000}, {4250,0.000056872}, {4300,0.000018957}, {4350,0.000000000}, {4400,0.000018957}, {4450,0.000014218}, {4500,0.000018957}, {4550,0.000014218}, {4600,0.000000000}, {4650,0.000018957}, {4700,0.000000000}, {4750,0.000018957}, {4800,0.000000000}, {4850,0.000018957}, {4900,0.000018957}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.000018957}, {5100,0.000018957}, {5150,0.000018957}, {5200,0.000000000}, {5250,0.000018957}, {5300,0.000000000}, {5350,0.000014218}, {5400,0.000014218}, {5450,0.000018957}, {5500,0.000000000}, {5550,0.000018957}, {5600,0.000000000}, {5650,0.000000000}, {5700,0.000037915}, {5750,0.000056872}, {5800,0.000037915}, {5850,0.000033175}, {5900,0.000000000}, {5950,0.000000000}, {6000,0.000000000}, {6050,0.000113744}, {6100,0.000000000}, {6150,0.000000000}, {6200,0.000014218}, {6250,0.000037915}, {6300,0.000033175}, {6350,0.000037915}, {6400,0.000037915}, {6450,0.000018957}, {6500,0.000018957}, {6550,0.000000000}, {6600,0.000056872}, {6650,0.000018957}, {6700,0.000113744}, {6750,0.000018957}, {6800,0.000018957}, {6850,0.000218009}, {6900,0.000052133}, {6950,0.000037915}, {7000,0.000075829}, {7050,0.000000000}, {7100,0.000018957}, {7150,0.000037915}, {7200,0.000018957}, {7250,0.000000000}, {7300,0.000000000}, {7350,0.000018957}, {7400,0.000000000}, {7450,0.000037915}, {7500,0.000037915}, {7550,0.000033175}, {7600,0.000052133}, {7650,0.000000000}, {7700,0.000000000}, {7750,0.000018957}, {7800,0.000037915}, {7850,0.000052133}, {7900,0.000000000}, {7950,0.000000000}, {8000,0.000000000}, {8050,0.000000000}, {8100,0.000014218}, {8150,0.000018957}, {8200,0.000056872}, {8250,0.000090047}, {8300,0.000028436}, {8350,0.000033175}, {8400,0.000000000}, {8450,0.000000000}, {8500,0.000000000}, {8550,0.000018957}, {8600,0.000000000}, {8650,0.000056872}, {8700,0.000018957}, {8750,0.000018957}, {8800,0.000037915}, {8850,0.000037915}, {8900,0.000000000}, {8950,0.000071090}, {9000,0.000018957}, {9050,0.000018957}, {9100,0.000014218}, {9150,0.000000000}, {9200,0.000018957}, {9250,0.000018957}, {9300,0.000037915}, {9350,0.000018957}, {9400,0.000056872}, {9450,0.000071090}, {9500,0.000037915}, {9550,0.000000000}, {9600,0.000246445}, {9650,0.000000000}, {9700,0.000037915}, {9750,0.000037915}, {9800,0.000056872}, {9850,0.000018957}, {9900,0.000037915}, {9950,0.000075829}, {10000,0.000018957}, {10100,0.000000000}, {10200,0.000094787}, {10300,0.000071090}, {10400,0.000000000}, {10500,0.000037915}, {10600,0.000052133}, {10700,0.000094787}, {10800,0.000123223}, {10900,0.000018957}, {11000,0.000037915}, {11100,0.000037915}, {11200,0.000113744}, {11300,0.000018957}, {11400,0.000075829}, {11500,0.000000000}, {11600,0.000018957}, {11700,0.000075829}, {11800,0.000037915}, {11900,0.000170616}, {12000,0.000056872}, {12100,0.000056872}, {12200,0.000018957}, {12300,0.000018957}, {12400,0.000037915}, {12500,0.000037915}, {12600,0.000000000}, {12700,0.000075829}, {12800,0.000014218}, {12900,0.000037915}, {13000,0.000018957}, {13100,0.000056872}, {13200,0.000037915}, {13300,0.000018957}, {13400,0.000056872}, {13500,0.000018957}, {13600,0.000018957}, {13700,0.000000000}, {13800,0.000056872}, {13900,0.000037915}, {14000,0.000075829}, {14100,0.000000000}, {14200,0.000018957}, {14300,0.000056872}, {14400,0.000056872}, {14500,0.000056872}, {14600,0.000094787}, {14700,0.000056872}, {14800,0.000094787}, {14900,0.000104265}, {15000,0.000018957}, {15100,0.000071090}, {15200,0.000113744}, {15300,0.000018957}, {15400,0.000056872}, {15500,0.000000000}, {15600,0.000000000}, {15700,0.000056872}, {15800,0.000033175}, {15900,0.000018957}, {16000,0.000056872}, {16100,0.000018957}, {16200,0.000018957}, {16300,0.000056872}, {16400,0.000018957}, {16500,0.000018957}, {16600,0.000000000}, {16700,0.000000000}, {16800,0.000056872}, {16900,0.000018957}, {17000,0.000037915}, {17100,0.000203791}, {17200,0.000033175}, {17300,0.000037915}, {17400,0.000018957}, {17500,0.000037915}, {17600,0.000018957}, {17700,0.000018957}, {17800,0.000037915}, {17900,0.000000000}, {18000,0.000056872}, {18100,0.000037915}, {18200,0.000000000}, {18300,0.000000000}, {18400,0.000000000}, {18500,0.000018957}, {18600,0.000056872}, {18700,0.000000000}, {18800,0.000000000}, {18900,0.000000000}, {19000,0.000056872}, {19100,0.000037915}, {19200,0.000037915}, {19300,0.000000000}, {19400,0.000037915}, {19500,0.000033175}, {19600,0.000018957}, {19700,0.000052133}, {19800,0.000037915}, {19900,0.000018957}, {20000,0.000019139}};
data["big_flat"]["Parametricity; beta"]["norm reif"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000009479}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000004739}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000018957}, {120,0.000492891}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000004739}, {126,0.000000000}, {127,0.000004739}, {128,0.000004739}, {129,0.000000000}, {130,0.000004739}, {131,0.000009479}, {132,0.000009479}, {133,0.000014218}, {134,0.000014218}, {135,0.000033175}, {136,0.000056872}, {137,0.000018957}, {138,0.000033175}, {139,0.000047393}, {140,0.000066351}, {141,0.000071090}, {142,0.000132701}, {143,0.000099526}, {144,0.000170616}, {145,0.000194313}, {146,0.000270142}, {147,0.000279621}, {148,0.000341232}, {149,0.000327014}, {150,0.000412322}, {151,0.000436019}, {152,0.000516588}, {153,0.001393365}, {154,0.001052133}, {155,0.000568720}, {156,0.000573460}, {157,0.000563981}, {158,0.000630332}, {159,0.000672986}, {160,0.000786730}, {161,0.000748815}, {162,0.000824645}, {163,0.000824645}, {164,0.000876777}, {165,0.000900474}, {166,0.000938389}, {167,0.000938389}, {168,0.000971564}, {169,0.000971564}, {170,0.000995261}, {171,0.000966825}, {172,0.000990521}, {173,0.000990521}, {174,0.001000000}, {175,0.000995261}, {176,0.001000000}, {177,0.001000000}, {178,0.001000000}, {179,0.001000000}, {180,0.001000000}, {181,0.001009479}, {182,0.001000000}, {183,0.001473934}, {184,0.001000000}, {185,0.001000000}, {186,0.001000000}, {187,0.001000000}, {188,0.001000000}, {189,0.001000000}, {190,0.001000000}, {191,0.001000000}, {192,0.001000000}, {193,0.001000000}, {194,0.001000000}, {195,0.001000000}, {196,0.001004739}, {197,0.001000000}, {198,0.001000000}, {199,0.001000000}, {200,0.001000000}, {201,0.001000000}, {202,0.001000000}, {203,0.001000000}, {204,0.001000000}, {205,0.001000000}, {206,0.001000000}, {207,0.001000000}, {208,0.001000000}, {209,0.001516588}, {210,0.001000000}, {211,0.001000000}, {212,0.001000000}, {213,0.001000000}, {214,0.001000000}, {215,0.001000000}, {216,0.001000000}, {217,0.001000000}, {218,0.001000000}, {219,0.001000000}, {220,0.001000000}, {221,0.001000000}, {222,0.001000000}, {223,0.001004739}, {224,0.001000000}, {225,0.001000000}, {226,0.001000000}, {227,0.001000000}, {228,0.001000000}, {229,0.001000000}, {230,0.001000000}, {231,0.001000000}, {232,0.001000000}, {233,0.001478673}, {234,0.001000000}, {235,0.001000000}, {236,0.001000000}, {237,0.001000000}, {238,0.001000000}, {239,0.001000000}, {240,0.001000000}, {241,0.001000000}, {242,0.001000000}, {243,0.001000000}, {244,0.001000000}, {245,0.001000000}, {246,0.001000000}, {247,0.001000000}, {248,0.001000000}, {249,0.001000000}, {250,0.001000000}, {251,0.001000000}, {252,0.001000000}, {253,0.001000000}, {254,0.001000000}, {255,0.001000000}, {256,0.001000000}, {257,0.001000000}, {258,0.001000000}, {259,0.001000000}, {260,0.001000000}, {261,0.001000000}, {262,0.001000000}, {263,0.001000000}, {264,0.001000000}, {265,0.001000000}, {266,0.001000000}, {267,0.001000000}, {268,0.001000000}, {269,0.001000000}, {270,0.001000000}, {271,0.001000000}, {272,0.001000000}, {273,0.001000000}, {274,0.001000000}, {275,0.001000000}, {276,0.001000000}, {277,0.001478673}, {278,0.001000000}, {279,0.001000000}, {280,0.001000000}, {281,0.001000000}, {282,0.001009479}, {283,0.001000000}, {284,0.001000000}, {285,0.001000000}, {286,0.001000000}, {287,0.001000000}, {288,0.001000000}, {289,0.001000000}, {290,0.001000000}, {291,0.001000000}, {292,0.001000000}, {293,0.001000000}, {294,0.001000000}, {295,0.001000000}, {296,0.001000000}, {297,0.001478673}, {298,0.001000000}, {299,0.001004739}, {300,0.001000000}, {301,0.001000000}, {302,0.001000000}, {303,0.001000000}, {304,0.001000000}, {305,0.001000000}, {306,0.001000000}, {307,0.001000000}, {308,0.001000000}, {309,0.001000000}, {310,0.001000000}, {311,0.001000000}, {312,0.001000000}, {313,0.001000000}, {314,0.001000000}, {315,0.001000000}, {316,0.001478673}, {317,0.001000000}, {318,0.001000000}, {319,0.001000000}, {320,0.001000000}, {321,0.001000000}, {322,0.001000000}, {323,0.001000000}, {324,0.001000000}, {325,0.001000000}, {326,0.001000000}, {327,0.001000000}, {328,0.001000000}, {329,0.001000000}, {330,0.001000000}, {331,0.001000000}, {332,0.001000000}, {333,0.001004739}, {334,0.001530806}, {335,0.001000000}, {336,0.001000000}, {337,0.001000000}, {338,0.001000000}, {339,0.001000000}, {340,0.001004739}, {341,0.001000000}, {342,0.001000000}, {343,0.001000000}, {344,0.001000000}, {345,0.001000000}, {346,0.001004739}, {347,0.001004739}, {348,0.001004739}, {349,0.001004739}, {350,0.001018957}, {351,0.001000000}, {352,0.001000000}, {353,0.001000000}, {354,0.001004739}, {355,0.001000000}, {356,0.001014218}, {357,0.001009479}, {358,0.001000000}, {359,0.001000000}, {360,0.001009479}, {361,0.001014218}, {362,0.001004739}, {363,0.001014218}, {364,0.001037915}, {365,0.001014218}, {366,0.001042654}, {367,0.001047393}, {368,0.001924171}, {369,0.001037915}, {370,0.001061611}, {371,0.001071090}, {372,0.001066351}, {373,0.001066351}, {374,0.001061611}, {375,0.001061611}, {376,0.001118483}, {377,0.001085308}, {378,0.001104265}, {379,0.001109005}, {380,0.001123223}, {381,0.001146919}, {382,0.001132701}, {383,0.001213270}, {384,0.002014218}, {385,0.001284360}, {386,0.001284360}, {387,0.001274882}, {388,0.001303318}, {389,0.001298578}, {390,0.001355450}, {391,0.001350711}, {392,0.001398104}, {393,0.001379147}, {394,0.001383886}, {395,0.001379147}, {396,0.001407583}, {397,0.001421801}, {398,0.001459716}, {399,0.001483412}, {400,0.001966825}, {401,0.001502370}, {402,0.001545024}, {403,0.001516588}, {404,0.001573460}, {405,0.001554502}, {406,0.001601896}, {407,0.001639810}, {408,0.001696682}, {409,0.001696682}, {410,0.001710900}, {411,0.001744076}, {412,0.001810427}, {413,0.001786730}, {414,0.001838863}, {415,0.002350711}, {416,0.001895735}, {417,0.001876777}, {418,0.001900474}, {419,0.001909953}, {420,0.001924171}, {421,0.001914692}, {422,0.001919431}, {423,0.001928910}, {424,0.001943128}, {425,0.001928910}, {426,0.001933649}, {427,0.001943128}, {428,0.001933649}, {429,0.001957346}, {430,0.001966825}, {431,0.001952607}, {432,0.001976303}, {433,0.001957346}, {434,0.001966825}, {435,0.001971564}, {436,0.001985782}, {437,0.001981043}, {438,0.001976303}, {439,0.001990521}, {440,0.001995261}, {441,0.001995261}, {442,0.002000000}, {443,0.002004739}, {444,0.002938389}, {445,0.002478673}, {446,0.002000000}, {447,0.002000000}, {448,0.002000000}, {449,0.002000000}, {450,0.002000000}, {451,0.002000000}, {452,0.002000000}, {453,0.002000000}, {454,0.002000000}, {455,0.002000000}, {456,0.002000000}, {457,0.002018957}, {458,0.002867299}, {459,0.002436019}, {460,0.002000000}, {461,0.002000000}, {462,0.002000000}, {463,0.002000000}, {464,0.002000000}, {465,0.002000000}, {466,0.002000000}, {467,0.002000000}, {468,0.002000000}, {469,0.002000000}, {470,0.002000000}, {471,0.002000000}, {472,0.002000000}, {473,0.002009479}, {474,0.002000000}, {475,0.002000000}, {476,0.002000000}, {477,0.002000000}, {478,0.002000000}, {479,0.002000000}, {480,0.002000000}, {481,0.002000000}, {482,0.002000000}, {483,0.002000000}, {484,0.002018957}, {485,0.002511848}, {486,0.002000000}, {487,0.002000000}, {488,0.002000000}, {489,0.002000000}, {490,0.002000000}, {491,0.002000000}, {492,0.002000000}, {493,0.002000000}, {494,0.002000000}, {495,0.002000000}, {496,0.002000000}, {497,0.002028436}, {498,0.002516588}, {499,0.002478673}, {500,0.002004739}, {505,0.002004739}, {510,0.002000000}, {515,0.002000000}, {520,0.002000000}, {525,0.002000000}, {530,0.002000000}, {535,0.002000000}, {540,0.002000000}, {545,0.002000000}, {550,0.002000000}, {555,0.002919431}, {560,0.002000000}, {565,0.002000000}, {570,0.002000000}, {575,0.002000000}, {580,0.002000000}, {585,0.002000000}, {590,0.002000000}, {595,0.002009479}, {600,0.002023697}, {605,0.002056872}, {610,0.002071090}, {615,0.002099526}, {620,0.002184834}, {625,0.002251185}, {630,0.002279621}, {635,0.002360190}, {640,0.002398104}, {645,0.002478673}, {650,0.002507109}, {655,0.002549763}, {660,0.003199052}, {665,0.003417062}, {670,0.002867299}, {675,0.002909953}, {680,0.002924171}, {685,0.002933649}, {690,0.002943128}, {695,0.002952607}, {700,0.002981043}, {705,0.003014218}, {710,0.003000000}, {715,0.003000000}, {720,0.003000000}, {725,0.003000000}, {730,0.003000000}, {735,0.003000000}, {740,0.003000000}, {745,0.003000000}, {750,0.003000000}, {755,0.003777251}, {760,0.003000000}, {765,0.003000000}, {770,0.003000000}, {775,0.003000000}, {780,0.003000000}, {785,0.003004739}, {790,0.003000000}, {795,0.003018957}, {800,0.003000000}, {805,0.003000000}, {810,0.003000000}, {815,0.003000000}, {820,0.003004739}, {825,0.003000000}, {830,0.003014218}, {835,0.003023697}, {840,0.004791469}, {845,0.003052133}, {850,0.003071090}, {855,0.003099526}, {860,0.003156398}, {865,0.003180095}, {870,0.003251185}, {875,0.003303318}, {880,0.004943128}, {885,0.003398104}, {890,0.003407583}, {895,0.003478673}, {900,0.003507109}, {905,0.003521327}, {910,0.003630332}, {915,0.003753555}, {920,0.003763033}, {925,0.003862559}, {930,0.003895735}, {935,0.003924171}, {940,0.003928910}, {945,0.003943128}, {950,0.003943128}, {955,0.005947867}, {960,0.003962085}, {965,0.003976303}, {970,0.003995261}, {975,0.004000000}, {980,0.004000000}, {985,0.004000000}, {990,0.004000000}, {995,0.004649289}, {1000,0.004000000}, {1010,0.004000000}, {1020,0.004000000}, {1030,0.004000000}, {1040,0.004000000}, {1050,0.005763033}, {1060,0.004000000}, {1070,0.004018957}, {1080,0.004018957}, {1090,0.004056872}, {1100,0.004123223}, {1110,0.004222749}, {1120,0.005933649}, {1130,0.004374408}, {1140,0.004407583}, {1150,0.004502370}, {1160,0.004592417}, {1170,0.004748815}, {1180,0.004881517}, {1190,0.004905213}, {1200,0.004914692}, {1210,0.004933649}, {1220,0.004952607}, {1230,0.004995261}, {1240,0.006592417}, {1250,0.004995261}, {1260,0.005000000}, {1270,0.005004739}, {1280,0.005000000}, {1290,0.007151659}, {1300,0.005014218}, {1310,0.005028436}, {1320,0.005061611}, {1330,0.005090047}, {1340,0.005189573}, {1350,0.007962085}, {1360,0.005289100}, {1370,0.005364929}, {1380,0.005417062}, {1390,0.005431280}, {1400,0.005516588}, {1410,0.005587678}, {1420,0.005729858}, {1430,0.005848341}, {1440,0.005867299}, {1450,0.005890995}, {1460,0.005928910}, {1470,0.005947867}, {1480,0.005957346}, {1490,0.006000000}, {1500,0.009298578}, {1510,0.006023697}, {1520,0.006023697}, {1530,0.006028436}, {1540,0.006066351}, {1550,0.007834123}, {1560,0.006099526}, {1570,0.006123223}, {1580,0.006189573}, {1590,0.007526066}, {1600,0.006308057}, {1610,0.006355450}, {1620,0.006374408}, {1630,0.006507109}, {1640,0.007815166}, {1650,0.006592417}, {1660,0.006649289}, {1670,0.006791469}, {1680,0.006867299}, {1690,0.006900474}, {1700,0.006909953}, {1710,0.006928910}, {1720,0.008990521}, {1730,0.006966825}, {1740,0.006990521}, {1750,0.006995261}, {1760,0.009895735}, {1770,0.007056872}, {1780,0.007080569}, {1790,0.007151659}, {1800,0.010090047}, {1810,0.007213270}, {1820,0.007298578}, {1830,0.007308057}, {1840,0.010270142}, {1850,0.007379147}, {1860,0.007417062}, {1870,0.007450237}, {1880,0.010014218}, {1890,0.007530806}, {1900,0.007601896}, {1910,0.007701422}, {1920,0.010137441}, {1930,0.007895735}, {1940,0.007900474}, {1950,0.007938389}, {1960,0.010545024}, {1970,0.007990521}, {1980,0.008023697}, {1990,0.008075829}, {2000,0.008094787}, {2050,0.008317536}, {2100,0.008436019}, {2150,0.010047393}, {2200,0.009014218}, {2250,0.009184834}, {2300,0.012644550}, {2350,0.009469194}, {2400,0.009772512}, {2450,0.013853081}, {2500,0.010289100}, {2550,0.010450237}, {2600,0.014981043}, {2650,0.010909953}, {2700,0.011236967}, {2750,0.017971564}, {2800,0.011497630}, {2850,0.011772512}, {2900,0.011895735}, {2950,0.012312796}, {3000,0.015672986}, {3050,0.012672986}, {3100,0.013071090}, {3150,0.013279621}, {3200,0.013407583}, {3250,0.015947867}, {3300,0.013867299}, {3350,0.016151659}, {3400,0.014398104}, {3450,0.019563981}, {3500,0.014819905}, {3550,0.015132701}, {3600,0.015270142}, {3650,0.015625592}, {3700,0.015663507}, {3750,0.016014218}, {3800,0.016146919}, {3850,0.016616114}, {3900,0.016682464}, {3950,0.022440758}, {4000,0.017156398}, {4050,0.022175355}, {4100,0.017616114}, {4150,0.024113744}, {4200,0.018014218}, {4250,0.022838863}, {4300,0.018687204}, {4350,0.018805687}, {4400,0.022744076}, {4450,0.019308057}, {4500,0.022393365}, {4550,0.019829384}, {4600,0.019957346}, {4650,0.027142180}, {4700,0.020511848}, {4750,0.023516588}, {4800,0.027004739}, {4850,0.021203791}, {4900,0.024644550}, {4950,0.025919431}, {5000,0.021976303}, {5050,0.025289100}, {5100,0.027592417}, {5150,0.022744076}, {5200,0.025720379}, {5250,0.028530806}, {5300,0.023412322}, {5350,0.023744076}, {5400,0.035374408}, {5450,0.024360190}, {5500,0.024521327}, {5550,0.029327014}, {5600,0.036786730}, {5650,0.025364929}, {5700,0.025535545}, {5750,0.025090047}, {5800,0.038189573}, {5850,0.032170616}, {5900,0.026526066}, {5950,0.026758294}, {6000,0.030834123}, {6050,0.045303318}, {6100,0.033981043}, {6150,0.027729858}, {6200,0.027890995}, {6250,0.031383886}, {6300,0.035900474}, {6350,0.038559242}, {6400,0.035341232}, {6450,0.029303318}, {6500,0.029545024}, {6550,0.029767773}, {6600,0.034037915}, {6650,0.032687204}, {6700,0.044763033}, {6750,0.046071090}, {6800,0.044170616}, {6850,0.031625592}, {6900,0.031672986}, {6950,0.031872038}, {7000,0.032194313}, {7050,0.032331754}, {7100,0.032720379}, {7150,0.032919431}, {7200,0.037829384}, {7250,0.037251185}, {7300,0.038606635}, {7350,0.038540284}, {7400,0.036289100}, {7450,0.042364929}, {7500,0.042938389}, {7550,0.043123223}, {7600,0.043146919}, {7650,0.038270142}, {7700,0.041023697}, {7750,0.040578199}, {7800,0.041033175}, {7850,0.040800948}, {7900,0.035540284}, {7950,0.037052133}, {8000,0.037450237}, {8050,0.037630332}, {8100,0.037914692}, {8150,0.038369668}, {8200,0.046199052}, {8250,0.053938389}, {8300,0.058668246}, {8350,0.056241706}, {8400,0.052630332}, {8450,0.044104265}, {8500,0.039981043}, {8550,0.040213270}, {8600,0.040483412}, {8650,0.053327014}, {8700,0.063336493}, {8750,0.055236967}, {8800,0.045635071}, {8850,0.041900474}, {8900,0.042118483}, {8950,0.052985782}, {9000,0.063606635}, {9050,0.050800948}, {9100,0.043056872}, {9150,0.043535545}, {9200,0.058241706}, {9250,0.065511848}, {9300,0.053175355}, {9350,0.044388626}, {9400,0.057511848}, {9450,0.066995261}, {9500,0.054436019}, {9550,0.045516588}, {9600,0.060109005}, {9650,0.065966825}, {9700,0.057744076}, {9750,0.058502370}, {9800,0.066009479}, {9850,0.057606635}, {9900,0.047322275}, {9950,0.070109005}, {10000,0.066327014}, {10100,0.048502370}, {10200,0.071469194}, {10300,0.055232227}, {10400,0.050080569}, {10500,0.072781991}, {10600,0.061758294}, {10700,0.075672986}, {10800,0.069066351}, {10900,0.061658768}, {11000,0.069753555}, {11100,0.053843602}, {11200,0.070526066}, {11300,0.054753555}, {11400,0.072597156}, {11500,0.055909953}, {11600,0.070028436}, {11700,0.062682464}, {11800,0.072421801}, {11900,0.075066351}, {12000,0.066578199}, {12100,0.082412322}, {12200,0.059706161}, {12300,0.075161137}, {12400,0.088791469}, {12500,0.067943128}, {12600,0.077151659}, {12700,0.087909953}, {12800,0.068639810}, {12900,0.078625592}, {13000,0.088786730}, {13100,0.073232227}, {13200,0.072497630}, {13300,0.084573460}, {13400,0.090644550}, {13500,0.077014218}, {13600,0.072720379}, {13700,0.080535545}, {13800,0.085881517}, {13900,0.090061611}, {14000,0.098853081}, {14100,0.077549763}, {14200,0.075431280}, {14300,0.073985782}, {14400,0.086573460}, {14500,0.098336493}, {14600,0.089369668}, {14700,0.099218009}, {14800,0.102331754}, {14900,0.101350711}, {15000,0.099369668}, {15100,0.098620853}, {15200,0.098781991}, {15300,0.100232227}, {15400,0.102521327}, {15500,0.102995261}, {15600,0.100317536}, {15700,0.096255924}, {15800,0.097838863}, {15900,0.097336493}, {16000,0.093426540}, {16100,0.095985782}, {16200,0.095308057}, {16300,0.116388626}, {16400,0.105274882}, {16500,0.102853081}, {16600,0.104312796}, {16700,0.100682464}, {16800,0.109701422}, {16900,0.110568720}, {17000,0.103701422}, {17100,0.093597156}, {17200,0.111995261}, {17300,0.113222749}, {17400,0.114563981}, {17500,0.107345972}, {17600,0.113047393}, {17700,0.108350711}, {17800,0.107573460}, {17900,0.114317536}, {18000,0.113720379}, {18100,0.112407583}, {18200,0.107715640}, {18300,0.096748815}, {18400,0.124360190}, {18500,0.114284360}, {18600,0.129450237}, {18700,0.110928910}, {18800,0.122578199}, {18900,0.112279621}, {19000,0.121308057}, {19100,0.113028436}, {19200,0.134061611}, {19300,0.113516588}, {19400,0.131279621}, {19500,0.126165877}, {19600,0.124014218}, {19700,0.122729858}, {19800,0.111502370}, {19900,0.131767773}, {20000,0.120291866}};
data["big_flat"]["Parametricity; beta"]["norm reif"]["user"] = {{1,0.000180095}, {2,0.000398104}, {3,0.000298578}, {4,0.000369668}, {5,0.000374408}, {6,0.000251185}, {7,0.000374408}, {8,0.000246445}, {9,0.000412322}, {10,0.000298578}, {11,0.000440758}, {12,0.000345972}, {13,0.000327014}, {14,0.000473934}, {15,0.000398104}, {16,0.000417062}, {17,0.000369668}, {18,0.000454976}, {19,0.000341232}, {20,0.000469194}, {21,0.000412322}, {22,0.000497630}, {23,0.000483412}, {24,0.000521327}, {25,0.000364929}, {26,0.000473934}, {27,0.000483412}, {28,0.000431280}, {29,0.000355450}, {30,0.000540284}, {31,0.000393365}, {32,0.000568720}, {33,0.000488152}, {34,0.000436019}, {35,0.000374408}, {36,0.000436019}, {37,0.000454976}, {38,0.000521327}, {39,0.000492891}, {40,0.000530806}, {41,0.000402844}, {42,0.000488152}, {43,0.000303318}, {44,0.000497630}, {45,0.000516588}, {46,0.000516588}, {47,0.000606635}, {48,0.000573460}, {49,0.000483412}, {50,0.000649289}, {51,0.000322275}, {52,0.000630332}, {53,0.000360190}, {54,0.000440758}, {55,0.000682464}, {56,0.000545024}, {57,0.000682464}, {58,0.000331754}, {59,0.000554502}, {60,0.000554502}, {61,0.000454976}, {62,0.000616114}, {63,0.000398104}, {64,0.000469194}, {65,0.000677725}, {66,0.000582938}, {67,0.000687204}, {68,0.000454976}, {69,0.000559242}, {70,0.000687204}, {71,0.000545024}, {72,0.000729858}, {73,0.000573460}, {74,0.000677725}, {75,0.000668246}, {76,0.000492891}, {77,0.000620853}, {78,0.000734597}, {79,0.000568720}, {80,0.000668246}, {81,0.000654028}, {82,0.000445498}, {83,0.000715640}, {84,0.000720379}, {85,0.000582938}, {86,0.000725118}, {87,0.000601896}, {88,0.000578199}, {89,0.000824645}, {90,0.000668246}, {91,0.000630332}, {92,0.000483412}, {93,0.000824645}, {94,0.000886256}, {95,0.000374408}, {96,0.000800948}, {97,0.000672986}, {98,0.000549763}, {99,0.000753555}, {100,0.000663507}, {101,0.000649289}, {102,0.000748815}, {103,0.000748815}, {104,0.000654028}, {105,0.000687204}, {106,0.000715640}, {107,0.000734597}, {108,0.000568720}, {109,0.000630332}, {110,0.000748815}, {111,0.000701422}, {112,0.000729858}, {113,0.000838863}, {114,0.000701422}, {115,0.000848341}, {116,0.000630332}, {117,0.000815166}, {118,0.000867299}, {119,0.000800948}, {120,0.001151659}, {121,0.000696682}, {122,0.000914692}, {123,0.000829384}, {124,0.000611374}, {125,0.000924171}, {126,0.000578199}, {127,0.000815166}, {128,0.000857820}, {129,0.000962085}, {130,0.000706161}, {131,0.000791469}, {132,0.000971564}, {133,0.000867299}, {134,0.000620853}, {135,0.000748815}, {136,0.000867299}, {137,0.000933649}, {138,0.000819905}, {139,0.000834123}, {140,0.000819905}, {141,0.000810427}, {142,0.000914692}, {143,0.000862559}, {144,0.000853081}, {145,0.000767773}, {146,0.000943128}, {147,0.000886256}, {148,0.000895735}, {149,0.000767773}, {150,0.000834123}, {151,0.001004739}, {152,0.000985782}, {153,0.001364929}, {154,0.001440758}, {155,0.000919431}, {156,0.000819905}, {157,0.000933649}, {158,0.000815166}, {159,0.000928910}, {160,0.001018957}, {161,0.000848341}, {162,0.001023697}, {163,0.000971564}, {164,0.000905213}, {165,0.000938389}, {166,0.000810427}, {167,0.000990521}, {168,0.001099526}, {169,0.000966825}, {170,0.000938389}, {171,0.000824645}, {172,0.000734597}, {173,0.001004739}, {174,0.001094787}, {175,0.001004739}, {176,0.001042654}, {177,0.000962085}, {178,0.000914692}, {179,0.000905213}, {180,0.000886256}, {181,0.001004739}, {182,0.001170616}, {183,0.001521327}, {184,0.001270142}, {185,0.001265403}, {186,0.000895735}, {187,0.001000000}, {188,0.001104265}, {189,0.001014218}, {190,0.000928910}, {191,0.000985782}, {192,0.001042654}, {193,0.000990521}, {194,0.000966825}, {195,0.000985782}, {196,0.000995261}, {197,0.001047393}, {198,0.001080569}, {199,0.001127962}, {200,0.001009479}, {201,0.001161137}, {202,0.001165877}, {203,0.001151659}, {204,0.001090047}, {205,0.001151659}, {206,0.001208531}, {207,0.001260664}, {208,0.001203791}, {209,0.001668246}, {210,0.001156398}, {211,0.000947867}, {212,0.000971564}, {213,0.001033175}, {214,0.000966825}, {215,0.000824645}, {216,0.000957346}, {217,0.000838863}, {218,0.000876777}, {219,0.000919431}, {220,0.000995261}, {221,0.000962085}, {222,0.001037915}, {223,0.001118483}, {224,0.001213270}, {225,0.001146919}, {226,0.001170616}, {227,0.001189573}, {228,0.001109005}, {229,0.001033175}, {230,0.001047393}, {231,0.000938389}, {232,0.000800948}, {233,0.001270142}, {234,0.001303318}, {235,0.001236967}, {236,0.001388626}, {237,0.001317536}, {238,0.001360190}, {239,0.001265403}, {240,0.001222749}, {241,0.001104265}, {242,0.001156398}, {243,0.001066351}, {244,0.001033175}, {245,0.001156398}, {246,0.001345972}, {247,0.001279621}, {248,0.001289100}, {249,0.001317536}, {250,0.001066351}, {251,0.001161137}, {252,0.001322275}, {253,0.001094787}, {254,0.001227488}, {255,0.001274882}, {256,0.001336493}, {257,0.001298578}, {258,0.001265403}, {259,0.001255924}, {260,0.001203791}, {261,0.001284360}, {262,0.001431280}, {263,0.001260664}, {264,0.001109005}, {265,0.001094787}, {266,0.001203791}, {267,0.001023697}, {268,0.001109005}, {269,0.001270142}, {270,0.001265403}, {271,0.001279621}, {272,0.001194313}, {273,0.001331754}, {274,0.001450237}, {275,0.001459716}, {276,0.001402844}, {277,0.001867299}, {278,0.001478673}, {279,0.001412322}, {280,0.001260664}, {281,0.001360190}, {282,0.001440758}, {283,0.001426540}, {284,0.001279621}, {285,0.001417062}, {286,0.001322275}, {287,0.001255924}, {288,0.001251185}, {289,0.001393365}, {290,0.001492891}, {291,0.001445498}, {292,0.001350711}, {293,0.001289100}, {294,0.001293839}, {295,0.001364929}, {296,0.001440758}, {297,0.001815166}, {298,0.001322275}, {299,0.001293839}, {300,0.001369668}, {301,0.001578199}, {302,0.001459716}, {303,0.001554502}, {304,0.001492891}, {305,0.001388626}, {306,0.001530806}, {307,0.001573460}, {308,0.001393365}, {309,0.001345972}, {310,0.001445498}, {311,0.001582938}, {312,0.001526066}, {313,0.001407583}, {314,0.001426540}, {315,0.001578199}, {316,0.001867299}, {317,0.001417062}, {318,0.001706161}, {319,0.001668246}, {320,0.001303318}, {321,0.001170616}, {322,0.001620853}, {323,0.001658768}, {324,0.001554502}, {325,0.001540284}, {326,0.001549763}, {327,0.001436019}, {328,0.001568720}, {329,0.001511848}, {330,0.001483412}, {331,0.001687204}, {332,0.001630332}, {333,0.001431280}, {334,0.002094787}, {335,0.001507109}, {336,0.001701422}, {337,0.001431280}, {338,0.001540284}, {339,0.001876777}, {340,0.001658768}, {341,0.001497630}, {342,0.001672986}, {343,0.001521327}, {344,0.001687204}, {345,0.001706161}, {346,0.001407583}, {347,0.001734597}, {348,0.001843602}, {349,0.001236967}, {350,0.001701422}, {351,0.001848341}, {352,0.001478673}, {353,0.001924171}, {354,0.001644550}, {355,0.001535545}, {356,0.001720379}, {357,0.001611374}, {358,0.001853081}, {359,0.001464455}, {360,0.001535545}, {361,0.001677725}, {362,0.001502370}, {363,0.001715640}, {364,0.001748815}, {365,0.001521327}, {366,0.001848341}, {367,0.001630332}, {368,0.002099526}, {369,0.001725118}, {370,0.001691943}, {371,0.001620853}, {372,0.001796209}, {373,0.001729858}, {374,0.001725118}, {375,0.001563981}, {376,0.001654028}, {377,0.001729858}, {378,0.001563981}, {379,0.001815166}, {380,0.001720379}, {381,0.001914692}, {382,0.001672986}, {383,0.001933649}, {384,0.002322275}, {385,0.001943128}, {386,0.001791469}, {387,0.001677725}, {388,0.001763033}, {389,0.001658768}, {390,0.001725118}, {391,0.001867299}, {392,0.001696682}, {393,0.001900474}, {394,0.001791469}, {395,0.001649289}, {396,0.001872038}, {397,0.001720379}, {398,0.001777251}, {399,0.001876777}, {400,0.002161137}, {401,0.001895735}, {402,0.001701422}, {403,0.001886256}, {404,0.001843602}, {405,0.001843602}, {406,0.001933649}, {407,0.001654028}, {408,0.002018957}, {409,0.001767773}, {410,0.001914692}, {411,0.001881517}, {412,0.001763033}, {413,0.002033175}, {414,0.001630332}, {415,0.002535545}, {416,0.001886256}, {417,0.001853081}, {418,0.001862559}, {419,0.001810427}, {420,0.001957346}, {421,0.001824645}, {422,0.001957346}, {423,0.001895735}, {424,0.001748815}, {425,0.002218009}, {426,0.001616114}, {427,0.002018957}, {428,0.001914692}, {429,0.001985782}, {430,0.001853081}, {431,0.001924171}, {432,0.001947867}, {433,0.001810427}, {434,0.001895735}, {435,0.001890995}, {436,0.001962085}, {437,0.002000000}, {438,0.001914692}, {439,0.002009479}, {440,0.002052133}, {441,0.001800948}, {442,0.002056872}, {443,0.001829384}, {444,0.003047393}, {445,0.002521327}, {446,0.002009479}, {447,0.001966825}, {448,0.001943128}, {449,0.002085308}, {450,0.002028436}, {451,0.002066351}, {452,0.001763033}, {453,0.002180095}, {454,0.001824645}, {455,0.001976303}, {456,0.002052133}, {457,0.002018957}, {458,0.002824645}, {459,0.002331754}, {460,0.002109005}, {461,0.001976303}, {462,0.002056872}, {463,0.002037915}, {464,0.001924171}, {465,0.001990521}, {466,0.002241706}, {467,0.002094787}, {468,0.001862559}, {469,0.002165877}, {470,0.001909953}, {471,0.001957346}, {472,0.002109005}, {473,0.001971564}, {474,0.002222749}, {475,0.002004739}, {476,0.002033175}, {477,0.002203791}, {478,0.002104265}, {479,0.002004739}, {480,0.002071090}, {481,0.002018957}, {482,0.002317536}, {483,0.002246445}, {484,0.002052133}, {485,0.002677725}, {486,0.002142180}, {487,0.002113744}, {488,0.002274882}, {489,0.001981043}, {490,0.002118483}, {491,0.002099526}, {492,0.002364929}, {493,0.002132701}, {494,0.002023697}, {495,0.002047393}, {496,0.002350711}, {497,0.002142180}, {498,0.002758294}, {499,0.002469194}, {500,0.002123223}, {505,0.002469194}, {510,0.002090047}, {515,0.002004739}, {520,0.002360190}, {525,0.002360190}, {530,0.002232227}, {535,0.002251185}, {540,0.002203791}, {545,0.002208531}, {550,0.002421801}, {555,0.002900474}, {560,0.002279621}, {565,0.002431280}, {570,0.002483412}, {575,0.002303318}, {580,0.002331754}, {585,0.002199052}, {590,0.002341232}, {595,0.002616114}, {600,0.002649289}, {605,0.002559242}, {610,0.002682464}, {615,0.002454976}, {620,0.002597156}, {625,0.002853081}, {630,0.002924171}, {635,0.002729858}, {640,0.002715640}, {645,0.002739336}, {650,0.002777251}, {655,0.002701422}, {660,0.003218009}, {665,0.003165877}, {670,0.002706161}, {675,0.002587678}, {680,0.002990521}, {685,0.002886256}, {690,0.002834123}, {695,0.002848341}, {700,0.002867299}, {705,0.002810427}, {710,0.002829384}, {715,0.003033175}, {720,0.002848341}, {725,0.002990521}, {730,0.002805687}, {735,0.003104265}, {740,0.002985782}, {745,0.003146919}, {750,0.003042654}, {755,0.003720379}, {760,0.003099526}, {765,0.003056872}, {770,0.003109005}, {775,0.003000000}, {780,0.003251185}, {785,0.003312796}, {790,0.003322275}, {795,0.003279621}, {800,0.003360190}, {805,0.003222749}, {810,0.003274882}, {815,0.003308057}, {820,0.003331754}, {825,0.003402844}, {830,0.003445498}, {835,0.003364929}, {840,0.004791469}, {845,0.003469194}, {850,0.003393365}, {855,0.003431280}, {860,0.003502370}, {865,0.003469194}, {870,0.003492891}, {875,0.003545024}, {880,0.004900474}, {885,0.003649289}, {890,0.003668246}, {895,0.003620853}, {900,0.003639810}, {905,0.003639810}, {910,0.003691943}, {915,0.003701422}, {920,0.003677725}, {925,0.003696682}, {930,0.003800948}, {935,0.003777251}, {940,0.003753555}, {945,0.003800948}, {950,0.003781991}, {955,0.005758294}, {960,0.003796209}, {965,0.003729858}, {970,0.003834123}, {975,0.003767773}, {980,0.003928910}, {985,0.003995261}, {990,0.004156398}, {995,0.004781991}, {1000,0.004047393}, {1010,0.003962085}, {1020,0.003971564}, {1030,0.004080569}, {1040,0.004151659}, {1050,0.005834123}, {1060,0.004218009}, {1070,0.004161137}, {1080,0.004151659}, {1090,0.004407583}, {1100,0.004312796}, {1110,0.004473934}, {1120,0.005715640}, {1130,0.004398104}, {1140,0.004417062}, {1150,0.004559242}, {1160,0.004374408}, {1170,0.004696682}, {1180,0.004772512}, {1190,0.004502370}, {1200,0.004800948}, {1210,0.004635071}, {1220,0.004815166}, {1230,0.004843602}, {1240,0.006559242}, {1250,0.004966825}, {1260,0.004853081}, {1270,0.005113744}, {1280,0.005061611}, {1290,0.007331754}, {1300,0.005033175}, {1310,0.005194313}, {1320,0.005274882}, {1330,0.005398104}, {1340,0.005545024}, {1350,0.008009479}, {1360,0.005199052}, {1370,0.005156398}, {1380,0.005303318}, {1390,0.005502370}, {1400,0.005331754}, {1410,0.005459716}, {1420,0.005402844}, {1430,0.005696682}, {1440,0.005606635}, {1450,0.005781991}, {1460,0.005620853}, {1470,0.005881517}, {1480,0.005800948}, {1490,0.005947867}, {1500,0.009298578}, {1510,0.005578199}, {1520,0.005914692}, {1530,0.005895735}, {1540,0.006165877}, {1550,0.007805687}, {1560,0.006047393}, {1570,0.006099526}, {1580,0.006047393}, {1590,0.007454976}, {1600,0.006227488}, {1610,0.006080569}, {1620,0.006194313}, {1630,0.006616114}, {1640,0.007635071}, {1650,0.006412322}, {1660,0.006336493}, {1670,0.006398104}, {1680,0.006502370}, {1690,0.006696682}, {1700,0.006644550}, {1710,0.006573460}, {1720,0.008957346}, {1730,0.006753555}, {1740,0.006881517}, {1750,0.006772512}, {1760,0.009706161}, {1770,0.006886256}, {1780,0.006767773}, {1790,0.006966825}, {1800,0.010127962}, {1810,0.007075829}, {1820,0.007127962}, {1830,0.007232227}, {1840,0.010118483}, {1850,0.007293839}, {1860,0.007028436}, {1870,0.007236967}, {1880,0.010033175}, {1890,0.007355450}, {1900,0.007369668}, {1910,0.007417062}, {1920,0.009947867}, {1930,0.007710900}, {1940,0.007663507}, {1950,0.007526066}, {1960,0.010407583}, {1970,0.007886256}, {1980,0.007644550}, {1990,0.007805687}, {2000,0.007938389}, {2050,0.008127962}, {2100,0.008417062}, {2150,0.010071090}, {2200,0.009000000}, {2250,0.008952607}, {2300,0.012786730}, {2350,0.009454976}, {2400,0.009630332}, {2450,0.013668246}, {2500,0.010454976}, {2550,0.010592417}, {2600,0.014919431}, {2650,0.010990521}, {2700,0.011488152}, {2750,0.017763033}, {2800,0.011729858}, {2850,0.011990521}, {2900,0.012061611}, {2950,0.012682464}, {3000,0.015540284}, {3050,0.013042654}, {3100,0.013203791}, {3150,0.013398104}, {3200,0.013777251}, {3250,0.015800948}, {3300,0.014109005}, {3350,0.015995261}, {3400,0.014298578}, {3450,0.019331754}, {3500,0.015061611}, {3550,0.015203791}, {3600,0.015142180}, {3650,0.015421801}, {3700,0.015625592}, {3750,0.015805687}, {3800,0.016113744}, {3850,0.016227488}, {3900,0.016507109}, {3950,0.022251185}, {4000,0.016777251}, {4050,0.021867299}, {4100,0.017497630}, {4150,0.024142180}, {4200,0.017620853}, {4250,0.022691943}, {4300,0.018175355}, {4350,0.018279621}, {4400,0.022568720}, {4450,0.019175355}, {4500,0.022056872}, {4550,0.019303318}, {4600,0.019715640}, {4650,0.026933649}, {4700,0.020236967}, {4750,0.023469194}, {4800,0.026843602}, {4850,0.021194313}, {4900,0.024540284}, {4950,0.025758294}, {5000,0.022075829}, {5050,0.025165877}, {5100,0.027658768}, {5150,0.022720379}, {5200,0.025478673}, {5250,0.028345972}, {5300,0.023303318}, {5350,0.023919431}, {5400,0.035184834}, {5450,0.024374408}, {5500,0.024687204}, {5550,0.029336493}, {5600,0.036563981}, {5650,0.025331754}, {5700,0.025654028}, {5750,0.025123223}, {5800,0.038109005}, {5850,0.031943128}, {5900,0.026582938}, {5950,0.026786730}, {6000,0.030981043}, {6050,0.044056872}, {6100,0.034104265}, {6150,0.027606635}, {6200,0.027857820}, {6250,0.031369668}, {6300,0.035777251}, {6350,0.038364929}, {6400,0.035127962}, {6450,0.029246445}, {6500,0.029563981}, {6550,0.030009479}, {6600,0.033924171}, {6650,0.032625592}, {6700,0.044407583}, {6750,0.045919431}, {6800,0.043933649}, {6850,0.031767773}, {6900,0.031938389}, {6950,0.031815166}, {7000,0.032516588}, {7050,0.032535545}, {7100,0.033037915}, {7150,0.033090047}, {7200,0.037545024}, {7250,0.037000000}, {7300,0.038511848}, {7350,0.038516588}, {7400,0.036464455}, {7450,0.042066351}, {7500,0.042890995}, {7550,0.043161137}, {7600,0.043061611}, {7650,0.038563981}, {7700,0.040928910}, {7750,0.040611374}, {7800,0.041004739}, {7850,0.040824645}, {7900,0.035459716}, {7950,0.037099526}, {8000,0.037398104}, {8050,0.037450237}, {8100,0.037905213}, {8150,0.038270142}, {8200,0.046004739}, {8250,0.053701422}, {8300,0.058559242}, {8350,0.056118483}, {8400,0.052398104}, {8450,0.044099526}, {8500,0.040113744}, {8550,0.040402844}, {8600,0.040696682}, {8650,0.052966825}, {8700,0.063459716}, {8750,0.055066351}, {8800,0.045530806}, {8850,0.041843602}, {8900,0.041876777}, {8950,0.052819905}, {9000,0.063488152}, {9050,0.050549763}, {9100,0.042919431}, {9150,0.043255924}, {9200,0.058028436}, {9250,0.065417062}, {9300,0.053203791}, {9350,0.044265403}, {9400,0.057497630}, {9450,0.066559242}, {9500,0.054274882}, {9550,0.045436019}, {9600,0.059654028}, {9650,0.065696682}, {9700,0.057132701}, {9750,0.058341232}, {9800,0.065890995}, {9850,0.057450237}, {9900,0.047075829}, {9950,0.069725118}, {10000,0.065872038}, {10100,0.048402844}, {10200,0.071180095}, {10300,0.055123223}, {10400,0.049924171}, {10500,0.072246445}, {10600,0.061535545}, {10700,0.075611374}, {10800,0.068767773}, {10900,0.061620853}, {11000,0.069473934}, {11100,0.053635071}, {11200,0.070383886}, {11300,0.054379147}, {11400,0.072502370}, {11500,0.055867299}, {11600,0.069872038}, {11700,0.062454976}, {11800,0.071995261}, {11900,0.074919431}, {12000,0.066284360}, {12100,0.081924171}, {12200,0.059734597}, {12300,0.075014218}, {12400,0.088289100}, {12500,0.067744076}, {12600,0.076753555}, {12700,0.087331754}, {12800,0.068298578}, {12900,0.078170616}, {13000,0.088289100}, {13100,0.073037915}, {13200,0.072298578}, {13300,0.084454976}, {13400,0.090251185}, {13500,0.077165877}, {13600,0.072701422}, {13700,0.080469194}, {13800,0.085838863}, {13900,0.089900474}, {14000,0.098781991}, {14100,0.077502370}, {14200,0.075184834}, {14300,0.073815166}, {14400,0.086260664}, {14500,0.097838863}, {14600,0.088815166}, {14700,0.098597156}, {14800,0.101900474}, {14900,0.100687204}, {15000,0.098862559}, {15100,0.098056872}, {15200,0.098156398}, {15300,0.099867299}, {15400,0.102165877}, {15500,0.102890995}, {15600,0.099919431}, {15700,0.096042654}, {15800,0.097464455}, {15900,0.097071090}, {16000,0.093170616}, {16100,0.095213270}, {16200,0.094834123}, {16300,0.115981043}, {16400,0.104938389}, {16500,0.102350711}, {16600,0.104047393}, {16700,0.100374408}, {16800,0.109312796}, {16900,0.110293839}, {17000,0.103094787}, {17100,0.093454976}, {17200,0.111364929}, {17300,0.112990521}, {17400,0.113981043}, {17500,0.107037915}, {17600,0.113052133}, {17700,0.108161137}, {17800,0.107545024}, {17900,0.114109005}, {18000,0.113459716}, {18100,0.112308057}, {18200,0.107502370}, {18300,0.096753555}, {18400,0.124189573}, {18500,0.114279621}, {18600,0.129331754}, {18700,0.110654028}, {18800,0.122426540}, {18900,0.112208531}, {19000,0.121151659}, {19100,0.113014218}, {19200,0.133957346}, {19300,0.113554502}, {19400,0.131137441}, {19500,0.126004739}, {19600,0.123905213}, {19700,0.122663507}, {19800,0.111383886}, {19900,0.132004739}, {20000,0.120315789}};
data["big_flat"]["Parametricity; beta"]["norm reif"]["system"] = {{1,0.000146919}, {2,0.000071090}, {3,0.000052133}, {4,0.000018957}, {5,0.000018957}, {6,0.000000000}, {7,0.000018957}, {8,0.000018957}, {9,0.000000000}, {10,0.000037915}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000014218}, {16,0.000018957}, {17,0.000018957}, {18,0.000000000}, {19,0.000037915}, {20,0.000018957}, {21,0.000000000}, {22,0.000056872}, {23,0.000000000}, {24,0.000014218}, {25,0.000000000}, {26,0.000018957}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000018957}, {31,0.000014218}, {32,0.000000000}, {33,0.000018957}, {34,0.000000000}, {35,0.000018957}, {36,0.000033175}, {37,0.000000000}, {38,0.000037915}, {39,0.000000000}, {40,0.000000000}, {41,0.000018957}, {42,0.000018957}, {43,0.000018957}, {44,0.000000000}, {45,0.000000000}, {46,0.000037915}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000018957}, {53,0.000000000}, {54,0.000018957}, {55,0.000018957}, {56,0.000018957}, {57,0.000018957}, {58,0.000000000}, {59,0.000000000}, {60,0.000014218}, {61,0.000000000}, {62,0.000000000}, {63,0.000018957}, {64,0.000000000}, {65,0.000037915}, {66,0.000000000}, {67,0.000018957}, {68,0.000018957}, {69,0.000000000}, {70,0.000000000}, {71,0.000018957}, {72,0.000000000}, {73,0.000000000}, {74,0.000018957}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000014218}, {79,0.000000000}, {80,0.000018957}, {81,0.000000000}, {82,0.000000000}, {83,0.000018957}, {84,0.000018957}, {85,0.000000000}, {86,0.000000000}, {87,0.000018957}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000018957}, {93,0.000018957}, {94,0.000000000}, {95,0.000018957}, {96,0.000000000}, {97,0.000018957}, {98,0.000033175}, {99,0.000000000}, {100,0.000018957}, {101,0.000018957}, {102,0.000000000}, {103,0.000037915}, {104,0.000037915}, {105,0.000000000}, {106,0.000018957}, {107,0.000018957}, {108,0.000056872}, {109,0.000018957}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000018957}, {116,0.000018957}, {117,0.000000000}, {118,0.000018957}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000018957}, {123,0.000000000}, {124,0.000000000}, {125,0.000018957}, {126,0.000033175}, {127,0.000033175}, {128,0.000000000}, {129,0.000000000}, {130,0.000047393}, {131,0.000000000}, {132,0.000018957}, {133,0.000000000}, {134,0.000018957}, {135,0.000018957}, {136,0.000000000}, {137,0.000000000}, {138,0.000033175}, {139,0.000000000}, {140,0.000018957}, {141,0.000000000}, {142,0.000056872}, {143,0.000000000}, {144,0.000000000}, {145,0.000018957}, {146,0.000018957}, {147,0.000075829}, {148,0.000000000}, {149,0.000000000}, {150,0.000018957}, {151,0.000000000}, {152,0.000014218}, {153,0.000018957}, {154,0.000000000}, {155,0.000014218}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000018957}, {163,0.000000000}, {164,0.000033175}, {165,0.000018957}, {166,0.000018957}, {167,0.000000000}, {168,0.000018957}, {169,0.000037915}, {170,0.000047393}, {171,0.000014218}, {172,0.000000000}, {173,0.000018957}, {174,0.000018957}, {175,0.000037915}, {176,0.000000000}, {177,0.000000000}, {178,0.000037915}, {179,0.000018957}, {180,0.000000000}, {181,0.000033175}, {182,0.000000000}, {183,0.000018957}, {184,0.000018957}, {185,0.000000000}, {186,0.000018957}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000037915}, {192,0.000018957}, {193,0.000018957}, {194,0.000018957}, {195,0.000000000}, {196,0.000018957}, {197,0.000037915}, {198,0.000037915}, {199,0.000018957}, {200,0.000037915}, {201,0.000000000}, {202,0.000014218}, {203,0.000000000}, {204,0.000018957}, {205,0.000018957}, {206,0.000000000}, {207,0.000018957}, {208,0.000018957}, {209,0.000018957}, {210,0.000000000}, {211,0.000018957}, {212,0.000018957}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000018957}, {218,0.000018957}, {219,0.000000000}, {220,0.000037915}, {221,0.000018957}, {222,0.000000000}, {223,0.000037915}, {224,0.000018957}, {225,0.000000000}, {226,0.000018957}, {227,0.000018957}, {228,0.000000000}, {229,0.000018957}, {230,0.000000000}, {231,0.000018957}, {232,0.000000000}, {233,0.000000000}, {234,0.000018957}, {235,0.000000000}, {236,0.000018957}, {237,0.000014218}, {238,0.000037915}, {239,0.000000000}, {240,0.000018957}, {241,0.000000000}, {242,0.000000000}, {243,0.000018957}, {244,0.000018957}, {245,0.000000000}, {246,0.000000000}, {247,0.000052133}, {248,0.000033175}, {249,0.000033175}, {250,0.000018957}, {251,0.000018957}, {252,0.000018957}, {253,0.000018957}, {254,0.000014218}, {255,0.000052133}, {256,0.000000000}, {257,0.000052133}, {258,0.000056872}, {259,0.000018957}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000018957}, {264,0.000037915}, {265,0.000014218}, {266,0.000000000}, {267,0.000018957}, {268,0.000000000}, {269,0.000018957}, {270,0.000000000}, {271,0.000018957}, {272,0.000000000}, {273,0.000018957}, {274,0.000018957}, {275,0.000033175}, {276,0.000000000}, {277,0.000037915}, {278,0.000000000}, {279,0.000000000}, {280,0.000018957}, {281,0.000018957}, {282,0.000037915}, {283,0.000018957}, {284,0.000018957}, {285,0.000000000}, {286,0.000000000}, {287,0.000056872}, {288,0.000075829}, {289,0.000000000}, {290,0.000000000}, {291,0.000037915}, {292,0.000000000}, {293,0.000000000}, {294,0.000018957}, {295,0.000018957}, {296,0.000018957}, {297,0.000056872}, {298,0.000000000}, {299,0.000018957}, {300,0.000000000}, {301,0.000018957}, {302,0.000018957}, {303,0.000000000}, {304,0.000018957}, {305,0.000000000}, {306,0.000000000}, {307,0.000018957}, {308,0.000018957}, {309,0.000014218}, {310,0.000037915}, {311,0.000018957}, {312,0.000000000}, {313,0.000033175}, {314,0.000018957}, {315,0.000000000}, {316,0.000018957}, {317,0.000018957}, {318,0.000000000}, {319,0.000000000}, {320,0.000037915}, {321,0.000000000}, {322,0.000000000}, {323,0.000018957}, {324,0.000018957}, {325,0.000000000}, {326,0.000037915}, {327,0.000000000}, {328,0.000018957}, {329,0.000037915}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000018957}, {335,0.000000000}, {336,0.000018957}, {337,0.000018957}, {338,0.000000000}, {339,0.000000000}, {340,0.000056872}, {341,0.000018957}, {342,0.000000000}, {343,0.000000000}, {344,0.000018957}, {345,0.000018957}, {346,0.000018957}, {347,0.000000000}, {348,0.000000000}, {349,0.000018957}, {350,0.000018957}, {351,0.000018957}, {352,0.000018957}, {353,0.000000000}, {354,0.000018957}, {355,0.000000000}, {356,0.000018957}, {357,0.000037915}, {358,0.000018957}, {359,0.000000000}, {360,0.000056872}, {361,0.000014218}, {362,0.000018957}, {363,0.000000000}, {364,0.000000000}, {365,0.000037915}, {366,0.000000000}, {367,0.000000000}, {368,0.000018957}, {369,0.000033175}, {370,0.000018957}, {371,0.000033175}, {372,0.000037915}, {373,0.000000000}, {374,0.000018957}, {375,0.000000000}, {376,0.000000000}, {377,0.000018957}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000033175}, {382,0.000000000}, {383,0.000000000}, {384,0.000037915}, {385,0.000071090}, {386,0.000018957}, {387,0.000000000}, {388,0.000037915}, {389,0.000000000}, {390,0.000018957}, {391,0.000000000}, {392,0.000000000}, {393,0.000037915}, {394,0.000014218}, {395,0.000047393}, {396,0.000014218}, {397,0.000000000}, {398,0.000052133}, {399,0.000000000}, {400,0.000033175}, {401,0.000018957}, {402,0.000000000}, {403,0.000000000}, {404,0.000056872}, {405,0.000000000}, {406,0.000018957}, {407,0.000018957}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000014218}, {412,0.000000000}, {413,0.000018957}, {414,0.000037915}, {415,0.000000000}, {416,0.000000000}, {417,0.000037915}, {418,0.000018957}, {419,0.000000000}, {420,0.000000000}, {421,0.000033175}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000037915}, {430,0.000033175}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000033175}, {435,0.000000000}, {436,0.000000000}, {437,0.000018957}, {438,0.000000000}, {439,0.000000000}, {440,0.000037915}, {441,0.000018957}, {442,0.000000000}, {443,0.000018957}, {444,0.000033175}, {445,0.000000000}, {446,0.000014218}, {447,0.000037915}, {448,0.000000000}, {449,0.000000000}, {450,0.000018957}, {451,0.000000000}, {452,0.000018957}, {453,0.000033175}, {454,0.000000000}, {455,0.000000000}, {456,0.000018957}, {457,0.000000000}, {458,0.000018957}, {459,0.000018957}, {460,0.000000000}, {461,0.000000000}, {462,0.000037915}, {463,0.000018957}, {464,0.000037915}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000037915}, {469,0.000018957}, {470,0.000018957}, {471,0.000000000}, {472,0.000000000}, {473,0.000037915}, {474,0.000000000}, {475,0.000018957}, {476,0.000037915}, {477,0.000000000}, {478,0.000037915}, {479,0.000033175}, {480,0.000018957}, {481,0.000000000}, {482,0.000018957}, {483,0.000000000}, {484,0.000000000}, {485,0.000075829}, {486,0.000000000}, {487,0.000018957}, {488,0.000018957}, {489,0.000000000}, {490,0.000000000}, {491,0.000018957}, {492,0.000000000}, {493,0.000018957}, {494,0.000000000}, {495,0.000018957}, {496,0.000037915}, {497,0.000018957}, {498,0.000018957}, {499,0.000018957}, {500,0.000000000}, {505,0.000018957}, {510,0.000018957}, {515,0.000018957}, {520,0.000033175}, {525,0.000018957}, {530,0.000018957}, {535,0.000000000}, {540,0.000014218}, {545,0.000018957}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000018957}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000018957}, {600,0.000018957}, {605,0.000018957}, {610,0.000028436}, {615,0.000018957}, {620,0.000052133}, {625,0.000075829}, {630,0.000000000}, {635,0.000037915}, {640,0.000033175}, {645,0.000000000}, {650,0.000033175}, {655,0.000018957}, {660,0.000000000}, {665,0.000037915}, {670,0.000052133}, {675,0.000052133}, {680,0.000047393}, {685,0.000000000}, {690,0.000018957}, {695,0.000037915}, {700,0.000000000}, {705,0.000018957}, {710,0.000018957}, {715,0.000000000}, {720,0.000018957}, {725,0.000037915}, {730,0.000075829}, {735,0.000000000}, {740,0.000037915}, {745,0.000000000}, {750,0.000033175}, {755,0.000018957}, {760,0.000000000}, {765,0.000018957}, {770,0.000000000}, {775,0.000018957}, {780,0.000018957}, {785,0.000018957}, {790,0.000000000}, {795,0.000000000}, {800,0.000037915}, {805,0.000037915}, {810,0.000018957}, {815,0.000037915}, {820,0.000033175}, {825,0.000000000}, {830,0.000018957}, {835,0.000075829}, {840,0.000033175}, {845,0.000018957}, {850,0.000018957}, {855,0.000037915}, {860,0.000000000}, {865,0.000033175}, {870,0.000000000}, {875,0.000014218}, {880,0.000075829}, {885,0.000037915}, {890,0.000000000}, {895,0.000000000}, {900,0.000037915}, {905,0.000071090}, {910,0.000014218}, {915,0.000018957}, {920,0.000037915}, {925,0.000018957}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000037915}, {950,0.000018957}, {955,0.000037915}, {960,0.000037915}, {965,0.000018957}, {970,0.000018957}, {975,0.000018957}, {980,0.000000000}, {985,0.000014218}, {990,0.000000000}, {995,0.000018957}, {1000,0.000018957}, {1010,0.000000000}, {1020,0.000018957}, {1030,0.000000000}, {1040,0.000018957}, {1050,0.000018957}, {1060,0.000037915}, {1070,0.000018957}, {1080,0.000018957}, {1090,0.000037915}, {1100,0.000037915}, {1110,0.000000000}, {1120,0.000066351}, {1130,0.000000000}, {1140,0.000014218}, {1150,0.000033175}, {1160,0.000018957}, {1170,0.000037915}, {1180,0.000000000}, {1190,0.000037915}, {1200,0.000037915}, {1210,0.000056872}, {1220,0.000018957}, {1230,0.000000000}, {1240,0.000018957}, {1250,0.000037915}, {1260,0.000018957}, {1270,0.000000000}, {1280,0.000037915}, {1290,0.000094787}, {1300,0.000037915}, {1310,0.000000000}, {1320,0.000018957}, {1330,0.000056872}, {1340,0.000018957}, {1350,0.000000000}, {1360,0.000037915}, {1370,0.000000000}, {1380,0.000018957}, {1390,0.000000000}, {1400,0.000014218}, {1410,0.000000000}, {1420,0.000052133}, {1430,0.000000000}, {1440,0.000018957}, {1450,0.000056872}, {1460,0.000018957}, {1470,0.000000000}, {1480,0.000056872}, {1490,0.000037915}, {1500,0.000132701}, {1510,0.000037915}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000014218}, {1550,0.000075829}, {1560,0.000037915}, {1570,0.000018957}, {1580,0.000018957}, {1590,0.000075829}, {1600,0.000018957}, {1610,0.000033175}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000094787}, {1660,0.000037915}, {1670,0.000014218}, {1680,0.000037915}, {1690,0.000037915}, {1700,0.000018957}, {1710,0.000000000}, {1720,0.000090047}, {1730,0.000018957}, {1740,0.000018957}, {1750,0.000018957}, {1760,0.000037915}, {1770,0.000018957}, {1780,0.000018957}, {1790,0.000018957}, {1800,0.000037915}, {1810,0.000052133}, {1820,0.000037915}, {1830,0.000037915}, {1840,0.000109005}, {1850,0.000018957}, {1860,0.000090047}, {1870,0.000018957}, {1880,0.000033175}, {1890,0.000113744}, {1900,0.000000000}, {1910,0.000052133}, {1920,0.000113744}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000056872}, {1960,0.000165877}, {1970,0.000000000}, {1980,0.000014218}, {1990,0.000056872}, {2000,0.000018957}, {2050,0.000018957}, {2100,0.000056872}, {2150,0.000037915}, {2200,0.000018957}, {2250,0.000056872}, {2300,0.000056872}, {2350,0.000018957}, {2400,0.000037915}, {2450,0.000113744}, {2500,0.000018957}, {2550,0.000037915}, {2600,0.000109005}, {2650,0.000037915}, {2700,0.000056872}, {2750,0.000090047}, {2800,0.000037915}, {2850,0.000028436}, {2900,0.000056872}, {2950,0.000056872}, {3000,0.000109005}, {3050,0.000018957}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000018957}, {3250,0.000113744}, {3300,0.000037915}, {3350,0.000037915}, {3400,0.000037915}, {3450,0.000109005}, {3500,0.000018957}, {3550,0.000000000}, {3600,0.000037915}, {3650,0.000075829}, {3700,0.000056872}, {3750,0.000033175}, {3800,0.000018957}, {3850,0.000018957}, {3900,0.000000000}, {3950,0.000090047}, {4000,0.000052133}, {4050,0.000184834}, {4100,0.000056872}, {4150,0.000170616}, {4200,0.000018957}, {4250,0.000090047}, {4300,0.000090047}, {4350,0.000052133}, {4400,0.000037915}, {4450,0.000018957}, {4500,0.000090047}, {4550,0.000071090}, {4600,0.000018957}, {4650,0.000180095}, {4700,0.000018957}, {4750,0.000018957}, {4800,0.000161137}, {4850,0.000018957}, {4900,0.000170616}, {4950,0.000151659}, {5000,0.000018957}, {5050,0.000109005}, {5100,0.000109005}, {5150,0.000018957}, {5200,0.000000000}, {5250,0.000189573}, {5300,0.000052133}, {5350,0.000000000}, {5400,0.000270142}, {5450,0.000037915}, {5500,0.000052133}, {5550,0.000109005}, {5600,0.000203791}, {5650,0.000075829}, {5700,0.000018957}, {5750,0.000037915}, {5800,0.000222749}, {5850,0.000184834}, {5900,0.000014218}, {5950,0.000018957}, {6000,0.000113744}, {6050,0.001066351}, {6100,0.000104265}, {6150,0.000037915}, {6200,0.000052133}, {6250,0.000090047}, {6300,0.000113744}, {6350,0.000222749}, {6400,0.000071090}, {6450,0.000000000}, {6500,0.000018957}, {6550,0.000075829}, {6600,0.000189573}, {6650,0.000161137}, {6700,0.000274882}, {6750,0.000265403}, {6800,0.000222749}, {6850,0.000056872}, {6900,0.000037915}, {6950,0.000052133}, {7000,0.000018957}, {7050,0.000056872}, {7100,0.000018957}, {7150,0.000000000}, {7200,0.000113744}, {7250,0.000189573}, {7300,0.000170616}, {7350,0.000056872}, {7400,0.000075829}, {7450,0.000132701}, {7500,0.000151659}, {7550,0.000170616}, {7600,0.000184834}, {7650,0.000075829}, {7700,0.000066351}, {7750,0.000075829}, {7800,0.000037915}, {7850,0.000113744}, {7900,0.000037915}, {7950,0.000094787}, {8000,0.000037915}, {8050,0.000056872}, {8100,0.000000000}, {8150,0.000056872}, {8200,0.000279621}, {8250,0.000336493}, {8300,0.000364929}, {8350,0.000199052}, {8400,0.000184834}, {8450,0.000018957}, {8500,0.000018957}, {8550,0.000056872}, {8600,0.000000000}, {8650,0.000189573}, {8700,0.000127962}, {8750,0.000090047}, {8800,0.000037915}, {8850,0.000037915}, {8900,0.000037915}, {8950,0.000260664}, {9000,0.000293839}, {9050,0.000018957}, {9100,0.000037915}, {9150,0.000018957}, {9200,0.000218009}, {9250,0.000289100}, {9300,0.000109005}, {9350,0.000132701}, {9400,0.000208531}, {9450,0.000308057}, {9500,0.000336493}, {9550,0.000018957}, {9600,0.000379147}, {9650,0.000369668}, {9700,0.000421801}, {9750,0.000241706}, {9800,0.000317536}, {9850,0.000189573}, {9900,0.000037915}, {9950,0.000246445}, {10000,0.000672986}, {10100,0.000071090}, {10200,0.000492891}, {10300,0.000265403}, {10400,0.000056872}, {10500,0.000464455}, {10600,0.000236967}, {10700,0.000317536}, {10800,0.000417062}, {10900,0.000146919}, {11000,0.000350711}, {11100,0.000037915}, {11200,0.000331754}, {11300,0.000113744}, {11400,0.000369668}, {11500,0.000000000}, {11600,0.000402844}, {11700,0.000165877}, {11800,0.000459716}, {11900,0.000265403}, {12000,0.000246445}, {12100,0.000412322}, {12200,0.000037915}, {12300,0.000284360}, {12400,0.000526066}, {12500,0.000246445}, {12600,0.000417062}, {12700,0.000620853}, {12800,0.000312796}, {12900,0.000597156}, {13000,0.000369668}, {13100,0.000151659}, {13200,0.000236967}, {13300,0.000184834}, {13400,0.000203791}, {13500,0.000037915}, {13600,0.000127962}, {13700,0.000222749}, {13800,0.000184834}, {13900,0.000255924}, {14000,0.000203791}, {14100,0.000000000}, {14200,0.000165877}, {14300,0.000312796}, {14400,0.000260664}, {14500,0.000393365}, {14600,0.000265403}, {14700,0.000431280}, {14800,0.000516588}, {14900,0.000578199}, {15000,0.000360190}, {15100,0.000388626}, {15200,0.000535545}, {15300,0.000355450}, {15400,0.000260664}, {15500,0.000151659}, {15600,0.000426540}, {15700,0.000317536}, {15800,0.000255924}, {15900,0.000284360}, {16000,0.000241706}, {16100,0.000322275}, {16200,0.000322275}, {16300,0.000317536}, {16400,0.000146919}, {16500,0.000331754}, {16600,0.000104265}, {16700,0.000146919}, {16800,0.000265403}, {16900,0.000170616}, {17000,0.000350711}, {17100,0.000056872}, {17200,0.000374408}, {17300,0.000208531}, {17400,0.000492891}, {17500,0.000151659}, {17600,0.000056872}, {17700,0.000071090}, {17800,0.000113744}, {17900,0.000037915}, {18000,0.000056872}, {18100,0.000000000}, {18200,0.000018957}, {18300,0.000018957}, {18400,0.000000000}, {18500,0.000018957}, {18600,0.000075829}, {18700,0.000056872}, {18800,0.000037915}, {18900,0.000037915}, {19000,0.000000000}, {19100,0.000037915}, {19200,0.000075829}, {19300,0.000094787}, {19400,0.000037915}, {19500,0.000037915}, {19600,0.000000000}, {19700,0.000056872}, {19800,0.000056872}, {19900,0.000018957}, {20000,0.000038278}};
data["big_flat"]["Parametricity; beta"]["post"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.000000000}, {5100,0.000000000}, {5150,0.000000000}, {5200,0.000000000}, {5250,0.000000000}, {5300,0.000000000}, {5350,0.000000000}, {5400,0.000000000}, {5450,0.000000000}, {5500,0.000000000}, {5550,0.000000000}, {5600,0.000000000}, {5650,0.000000000}, {5700,0.000000000}, {5750,0.000000000}, {5800,0.000000000}, {5850,0.000000000}, {5900,0.000000000}, {5950,0.000000000}, {6000,0.000000000}, {6050,0.000000000}, {6100,0.000000000}, {6150,0.000000000}, {6200,0.000000000}, {6250,0.000000000}, {6300,0.000000000}, {6350,0.000000000}, {6400,0.000000000}, {6450,0.000000000}, {6500,0.000000000}, {6550,0.000000000}, {6600,0.000000000}, {6650,0.000000000}, {6700,0.000000000}, {6750,0.000000000}, {6800,0.000000000}, {6850,0.000000000}, {6900,0.000000000}, {6950,0.000000000}, {7000,0.000000000}, {7050,0.000000000}, {7100,0.000000000}, {7150,0.000000000}, {7200,0.000000000}, {7250,0.000000000}, {7300,0.000000000}, {7350,0.000000000}, {7400,0.000000000}, {7450,0.000000000}, {7500,0.000000000}, {7550,0.000000000}, {7600,0.000000000}, {7650,0.000000000}, {7700,0.000000000}, {7750,0.000000000}, {7800,0.000000000}, {7850,0.000000000}, {7900,0.000000000}, {7950,0.000000000}, {8000,0.000000000}, {8050,0.000000000}, {8100,0.000000000}, {8150,0.000000000}, {8200,0.000000000}, {8250,0.000000000}, {8300,0.000000000}, {8350,0.000000000}, {8400,0.000000000}, {8450,0.000000000}, {8500,0.000000000}, {8550,0.000000000}, {8600,0.000000000}, {8650,0.000000000}, {8700,0.000000000}, {8750,0.000000000}, {8800,0.000000000}, {8850,0.000000000}, {8900,0.000000000}, {8950,0.000000000}, {9000,0.000000000}, {9050,0.000000000}, {9100,0.000000000}, {9150,0.000000000}, {9200,0.000000000}, {9250,0.000000000}, {9300,0.000000000}, {9350,0.000000000}, {9400,0.000000000}, {9450,0.000000000}, {9500,0.000000000}, {9550,0.000000000}, {9600,0.000000000}, {9650,0.000000000}, {9700,0.000000000}, {9750,0.000000000}, {9800,0.000000000}, {9850,0.000000000}, {9900,0.000000000}, {9950,0.000000000}, {10000,0.000000000}, {10100,0.000000000}, {10200,0.000000000}, {10300,0.000000000}, {10400,0.000000000}, {10500,0.000000000}, {10600,0.000000000}, {10700,0.000000000}, {10800,0.000000000}, {10900,0.000000000}, {11000,0.000000000}, {11100,0.000000000}, {11200,0.000000000}, {11300,0.000000000}, {11400,0.000000000}, {11500,0.000000000}, {11600,0.000000000}, {11700,0.000000000}, {11800,0.000000000}, {11900,0.000000000}, {12000,0.000000000}, {12100,0.000000000}, {12200,0.000000000}, {12300,0.000000000}, {12400,0.000000000}, {12500,0.000000000}, {12600,0.000000000}, {12700,0.000000000}, {12800,0.000000000}, {12900,0.000000000}, {13000,0.000000000}, {13100,0.000000000}, {13200,0.000000000}, {13300,0.000000000}, {13400,0.000000000}, {13500,0.000000000}, {13600,0.000000000}, {13700,0.000000000}, {13800,0.000000000}, {13900,0.000000000}, {14000,0.000000000}, {14100,0.000000000}, {14200,0.000000000}, {14300,0.000000000}, {14400,0.000000000}, {14500,0.000000000}, {14600,0.000000000}, {14700,0.000000000}, {14800,0.000000000}, {14900,0.000000000}, {15000,0.000000000}, {15100,0.000000000}, {15200,0.000000000}, {15300,0.000000000}, {15400,0.000000000}, {15500,0.000000000}, {15600,0.000000000}, {15700,0.000000000}, {15800,0.000000000}, {15900,0.000000000}, {16000,0.000000000}, {16100,0.000000000}, {16200,0.000000000}, {16300,0.000000000}, {16400,0.000000000}, {16500,0.000000000}, {16600,0.000000000}, {16700,0.000000000}, {16800,0.000000000}, {16900,0.000000000}, {17000,0.000000000}, {17100,0.000000000}, {17200,0.000000000}, {17300,0.000000000}, {17400,0.000000000}, {17500,0.000000000}, {17600,0.000000000}, {17700,0.000000000}, {17800,0.000000000}, {17900,0.000000000}, {18000,0.000000000}, {18100,0.000000000}, {18200,0.000000000}, {18300,0.000000000}, {18400,0.000000000}, {18500,0.000000000}, {18600,0.000000000}, {18700,0.000000000}, {18800,0.000000000}, {18900,0.000000000}, {19000,0.000000000}, {19100,0.000000000}, {19200,0.000000000}, {19300,0.000000000}, {19400,0.000000000}, {19500,0.000000000}, {19600,0.000000000}, {19700,0.000000000}, {19800,0.000000000}, {19900,0.000000000}, {20000,0.000000000}};
data["big_flat"]["Parametricity; beta"]["post"]["user"] = {{1,0.000037915}, {2,0.000000000}, {3,0.000000000}, {4,0.000018957}, {5,0.000018957}, {6,0.000028436}, {7,0.000047393}, {8,0.000014218}, {9,0.000014218}, {10,0.000000000}, {11,0.000000000}, {12,0.000018957}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000052133}, {17,0.000075829}, {18,0.000033175}, {19,0.000090047}, {20,0.000037915}, {21,0.000033175}, {22,0.000028436}, {23,0.000018957}, {24,0.000037915}, {25,0.000018957}, {26,0.000080569}, {27,0.000014218}, {28,0.000071090}, {29,0.000014218}, {30,0.000018957}, {31,0.000037915}, {32,0.000033175}, {33,0.000018957}, {34,0.000033175}, {35,0.000033175}, {36,0.000014218}, {37,0.000018957}, {38,0.000018957}, {39,0.000000000}, {40,0.000014218}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000014218}, {45,0.000047393}, {46,0.000071090}, {47,0.000018957}, {48,0.000104265}, {49,0.000018957}, {50,0.000037915}, {51,0.000000000}, {52,0.000066351}, {53,0.000018957}, {54,0.000056872}, {55,0.000071090}, {56,0.000000000}, {57,0.000080569}, {58,0.000014218}, {59,0.000037915}, {60,0.000000000}, {61,0.000047393}, {62,0.000052133}, {63,0.000104265}, {64,0.000000000}, {65,0.000014218}, {66,0.000000000}, {67,0.000018957}, {68,0.000018957}, {69,0.000052133}, {70,0.000037915}, {71,0.000000000}, {72,0.000000000}, {73,0.000047393}, {74,0.000033175}, {75,0.000075829}, {76,0.000028436}, {77,0.000018957}, {78,0.000014218}, {79,0.000028436}, {80,0.000056872}, {81,0.000047393}, {82,0.000018957}, {83,0.000037915}, {84,0.000018957}, {85,0.000028436}, {86,0.000061611}, {87,0.000028436}, {88,0.000052133}, {89,0.000018957}, {90,0.000014218}, {91,0.000018957}, {92,0.000047393}, {93,0.000000000}, {94,0.000018957}, {95,0.000071090}, {96,0.000037915}, {97,0.000056872}, {98,0.000042654}, {99,0.000037915}, {100,0.000047393}, {101,0.000000000}, {102,0.000037915}, {103,0.000066351}, {104,0.000000000}, {105,0.000033175}, {106,0.000014218}, {107,0.000037915}, {108,0.000052133}, {109,0.000047393}, {110,0.000018957}, {111,0.000014218}, {112,0.000014218}, {113,0.000000000}, {114,0.000014218}, {115,0.000000000}, {116,0.000028436}, {117,0.000085308}, {118,0.000014218}, {119,0.000000000}, {120,0.000014218}, {121,0.000075829}, {122,0.000000000}, {123,0.000037915}, {124,0.000047393}, {125,0.000066351}, {126,0.000052133}, {127,0.000094787}, {128,0.000000000}, {129,0.000014218}, {130,0.000033175}, {131,0.000047393}, {132,0.000014218}, {133,0.000018957}, {134,0.000042654}, {135,0.000028436}, {136,0.000033175}, {137,0.000028436}, {138,0.000037915}, {139,0.000018957}, {140,0.000000000}, {141,0.000014218}, {142,0.000028436}, {143,0.000047393}, {144,0.000056872}, {145,0.000042654}, {146,0.000018957}, {147,0.000018957}, {148,0.000018957}, {149,0.000018957}, {150,0.000014218}, {151,0.000014218}, {152,0.000056872}, {153,0.000071090}, {154,0.000047393}, {155,0.000033175}, {156,0.000000000}, {157,0.000052133}, {158,0.000014218}, {159,0.000018957}, {160,0.000037915}, {161,0.000014218}, {162,0.000047393}, {163,0.000075829}, {164,0.000037915}, {165,0.000056872}, {166,0.000056872}, {167,0.000018957}, {168,0.000000000}, {169,0.000037915}, {170,0.000052133}, {171,0.000000000}, {172,0.000014218}, {173,0.000000000}, {174,0.000018957}, {175,0.000052133}, {176,0.000037915}, {177,0.000000000}, {178,0.000014218}, {179,0.000033175}, {180,0.000028436}, {181,0.000014218}, {182,0.000075829}, {183,0.000047393}, {184,0.000000000}, {185,0.000033175}, {186,0.000028436}, {187,0.000018957}, {188,0.000033175}, {189,0.000018957}, {190,0.000047393}, {191,0.000037915}, {192,0.000018957}, {193,0.000014218}, {194,0.000000000}, {195,0.000056872}, {196,0.000018957}, {197,0.000018957}, {198,0.000000000}, {199,0.000000000}, {200,0.000033175}, {201,0.000014218}, {202,0.000033175}, {203,0.000000000}, {204,0.000018957}, {205,0.000000000}, {206,0.000033175}, {207,0.000014218}, {208,0.000075829}, {209,0.000000000}, {210,0.000014218}, {211,0.000018957}, {212,0.000080569}, {213,0.000018957}, {214,0.000033175}, {215,0.000042654}, {216,0.000056872}, {217,0.000037915}, {218,0.000033175}, {219,0.000056872}, {220,0.000061611}, {221,0.000000000}, {222,0.000037915}, {223,0.000014218}, {224,0.000000000}, {225,0.000018957}, {226,0.000028436}, {227,0.000014218}, {228,0.000014218}, {229,0.000090047}, {230,0.000014218}, {231,0.000000000}, {232,0.000085308}, {233,0.000052133}, {234,0.000033175}, {235,0.000000000}, {236,0.000014218}, {237,0.000000000}, {238,0.000018957}, {239,0.000018957}, {240,0.000000000}, {241,0.000018957}, {242,0.000056872}, {243,0.000014218}, {244,0.000000000}, {245,0.000037915}, {246,0.000028436}, {247,0.000018957}, {248,0.000037915}, {249,0.000033175}, {250,0.000033175}, {251,0.000033175}, {252,0.000014218}, {253,0.000071090}, {254,0.000037915}, {255,0.000033175}, {256,0.000047393}, {257,0.000000000}, {258,0.000000000}, {259,0.000018957}, {260,0.000085308}, {261,0.000037915}, {262,0.000056872}, {263,0.000033175}, {264,0.000018957}, {265,0.000071090}, {266,0.000018957}, {267,0.000037915}, {268,0.000000000}, {269,0.000066351}, {270,0.000000000}, {271,0.000080569}, {272,0.000056872}, {273,0.000037915}, {274,0.000018957}, {275,0.000018957}, {276,0.000000000}, {277,0.000018957}, {278,0.000018957}, {279,0.000014218}, {280,0.000000000}, {281,0.000033175}, {282,0.000033175}, {283,0.000033175}, {284,0.000018957}, {285,0.000037915}, {286,0.000014218}, {287,0.000000000}, {288,0.000018957}, {289,0.000037915}, {290,0.000018957}, {291,0.000071090}, {292,0.000014218}, {293,0.000075829}, {294,0.000033175}, {295,0.000014218}, {296,0.000075829}, {297,0.000000000}, {298,0.000052133}, {299,0.000037915}, {300,0.000028436}, {301,0.000000000}, {302,0.000014218}, {303,0.000033175}, {304,0.000018957}, {305,0.000056872}, {306,0.000047393}, {307,0.000033175}, {308,0.000052133}, {309,0.000104265}, {310,0.000014218}, {311,0.000000000}, {312,0.000018957}, {313,0.000018957}, {314,0.000094787}, {315,0.000028436}, {316,0.000033175}, {317,0.000018957}, {318,0.000037915}, {319,0.000018957}, {320,0.000033175}, {321,0.000018957}, {322,0.000018957}, {323,0.000033175}, {324,0.000018957}, {325,0.000033175}, {326,0.000056872}, {327,0.000028436}, {328,0.000052133}, {329,0.000066351}, {330,0.000018957}, {331,0.000037915}, {332,0.000000000}, {333,0.000014218}, {334,0.000075829}, {335,0.000052133}, {336,0.000000000}, {337,0.000090047}, {338,0.000033175}, {339,0.000000000}, {340,0.000014218}, {341,0.000052133}, {342,0.000000000}, {343,0.000014218}, {344,0.000018957}, {345,0.000037915}, {346,0.000075829}, {347,0.000047393}, {348,0.000000000}, {349,0.000071090}, {350,0.000018957}, {351,0.000000000}, {352,0.000061611}, {353,0.000056872}, {354,0.000018957}, {355,0.000052133}, {356,0.000066351}, {357,0.000018957}, {358,0.000033175}, {359,0.000000000}, {360,0.000047393}, {361,0.000037915}, {362,0.000052133}, {363,0.000047393}, {364,0.000018957}, {365,0.000080569}, {366,0.000061611}, {367,0.000000000}, {368,0.000018957}, {369,0.000028436}, {370,0.000037915}, {371,0.000018957}, {372,0.000052133}, {373,0.000018957}, {374,0.000071090}, {375,0.000066351}, {376,0.000018957}, {377,0.000014218}, {378,0.000099526}, {379,0.000033175}, {380,0.000018957}, {381,0.000000000}, {382,0.000042654}, {383,0.000018957}, {384,0.000014218}, {385,0.000052133}, {386,0.000018957}, {387,0.000018957}, {388,0.000052133}, {389,0.000037915}, {390,0.000047393}, {391,0.000000000}, {392,0.000018957}, {393,0.000000000}, {394,0.000018957}, {395,0.000014218}, {396,0.000018957}, {397,0.000000000}, {398,0.000094787}, {399,0.000037915}, {400,0.000028436}, {401,0.000033175}, {402,0.000000000}, {403,0.000000000}, {404,0.000018957}, {405,0.000000000}, {406,0.000014218}, {407,0.000066351}, {408,0.000033175}, {409,0.000014218}, {410,0.000033175}, {411,0.000000000}, {412,0.000113744}, {413,0.000094787}, {414,0.000066351}, {415,0.000018957}, {416,0.000033175}, {417,0.000066351}, {418,0.000037915}, {419,0.000018957}, {420,0.000052133}, {421,0.000052133}, {422,0.000000000}, {423,0.000090047}, {424,0.000018957}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000056872}, {429,0.000033175}, {430,0.000000000}, {431,0.000090047}, {432,0.000000000}, {433,0.000000000}, {434,0.000056872}, {435,0.000018957}, {436,0.000018957}, {437,0.000028436}, {438,0.000052133}, {439,0.000047393}, {440,0.000028436}, {441,0.000071090}, {442,0.000000000}, {443,0.000000000}, {444,0.000037915}, {445,0.000028436}, {446,0.000071090}, {447,0.000018957}, {448,0.000037915}, {449,0.000033175}, {450,0.000000000}, {451,0.000056872}, {452,0.000018957}, {453,0.000014218}, {454,0.000014218}, {455,0.000075829}, {456,0.000033175}, {457,0.000033175}, {458,0.000018957}, {459,0.000018957}, {460,0.000018957}, {461,0.000085308}, {462,0.000033175}, {463,0.000033175}, {464,0.000033175}, {465,0.000056872}, {466,0.000056872}, {467,0.000056872}, {468,0.000052133}, {469,0.000018957}, {470,0.000014218}, {471,0.000028436}, {472,0.000000000}, {473,0.000033175}, {474,0.000033175}, {475,0.000047393}, {476,0.000018957}, {477,0.000000000}, {478,0.000018957}, {479,0.000014218}, {480,0.000033175}, {481,0.000056872}, {482,0.000014218}, {483,0.000033175}, {484,0.000018957}, {485,0.000033175}, {486,0.000094787}, {487,0.000056872}, {488,0.000014218}, {489,0.000033175}, {490,0.000000000}, {491,0.000037915}, {492,0.000018957}, {493,0.000052133}, {494,0.000056872}, {495,0.000033175}, {496,0.000028436}, {497,0.000028436}, {498,0.000018957}, {499,0.000018957}, {500,0.000014218}, {505,0.000052133}, {510,0.000018957}, {515,0.000052133}, {520,0.000018957}, {525,0.000033175}, {530,0.000061611}, {535,0.000028436}, {540,0.000037915}, {545,0.000052133}, {550,0.000018957}, {555,0.000033175}, {560,0.000033175}, {565,0.000033175}, {570,0.000000000}, {575,0.000056872}, {580,0.000018957}, {585,0.000037915}, {590,0.000018957}, {595,0.000000000}, {600,0.000033175}, {605,0.000037915}, {610,0.000018957}, {615,0.000014218}, {620,0.000028436}, {625,0.000066351}, {630,0.000071090}, {635,0.000000000}, {640,0.000000000}, {645,0.000033175}, {650,0.000052133}, {655,0.000000000}, {660,0.000052133}, {665,0.000014218}, {670,0.000066351}, {675,0.000080569}, {680,0.000018957}, {685,0.000033175}, {690,0.000037915}, {695,0.000033175}, {700,0.000033175}, {705,0.000014218}, {710,0.000037915}, {715,0.000033175}, {720,0.000037915}, {725,0.000014218}, {730,0.000033175}, {735,0.000014218}, {740,0.000085308}, {745,0.000018957}, {750,0.000018957}, {755,0.000014218}, {760,0.000033175}, {765,0.000052133}, {770,0.000061611}, {775,0.000033175}, {780,0.000047393}, {785,0.000066351}, {790,0.000037915}, {795,0.000000000}, {800,0.000052133}, {805,0.000047393}, {810,0.000033175}, {815,0.000000000}, {820,0.000000000}, {825,0.000075829}, {830,0.000033175}, {835,0.000066351}, {840,0.000000000}, {845,0.000033175}, {850,0.000018957}, {855,0.000014218}, {860,0.000056872}, {865,0.000033175}, {870,0.000037915}, {875,0.000014218}, {880,0.000033175}, {885,0.000033175}, {890,0.000000000}, {895,0.000018957}, {900,0.000047393}, {905,0.000018957}, {910,0.000047393}, {915,0.000000000}, {920,0.000014218}, {925,0.000033175}, {930,0.000000000}, {935,0.000037915}, {940,0.000014218}, {945,0.000014218}, {950,0.000033175}, {955,0.000018957}, {960,0.000066351}, {965,0.000047393}, {970,0.000052133}, {975,0.000000000}, {980,0.000000000}, {985,0.000056872}, {990,0.000028436}, {995,0.000018957}, {1000,0.000018957}, {1010,0.000028436}, {1020,0.000018957}, {1030,0.000033175}, {1040,0.000014218}, {1050,0.000018957}, {1060,0.000014218}, {1070,0.000037915}, {1080,0.000037915}, {1090,0.000080569}, {1100,0.000014218}, {1110,0.000071090}, {1120,0.000018957}, {1130,0.000000000}, {1140,0.000056872}, {1150,0.000000000}, {1160,0.000018957}, {1170,0.000028436}, {1180,0.000000000}, {1190,0.000033175}, {1200,0.000000000}, {1210,0.000014218}, {1220,0.000104265}, {1230,0.000014218}, {1240,0.000033175}, {1250,0.000018957}, {1260,0.000018957}, {1270,0.000018957}, {1280,0.000014218}, {1290,0.000018957}, {1300,0.000037915}, {1310,0.000037915}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000033175}, {1350,0.000056872}, {1360,0.000109005}, {1370,0.000047393}, {1380,0.000052133}, {1390,0.000018957}, {1400,0.000056872}, {1410,0.000047393}, {1420,0.000018957}, {1430,0.000028436}, {1440,0.000056872}, {1450,0.000033175}, {1460,0.000037915}, {1470,0.000056872}, {1480,0.000014218}, {1490,0.000018957}, {1500,0.000037915}, {1510,0.000037915}, {1520,0.000014218}, {1530,0.000014218}, {1540,0.000018957}, {1550,0.000033175}, {1560,0.000028436}, {1570,0.000018957}, {1580,0.000000000}, {1590,0.000066351}, {1600,0.000033175}, {1610,0.000071090}, {1620,0.000014218}, {1630,0.000000000}, {1640,0.000028436}, {1650,0.000018957}, {1660,0.000018957}, {1670,0.000018957}, {1680,0.000033175}, {1690,0.000037915}, {1700,0.000033175}, {1710,0.000033175}, {1720,0.000018957}, {1730,0.000075829}, {1740,0.000037915}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000037915}, {1780,0.000037915}, {1790,0.000066351}, {1800,0.000047393}, {1810,0.000018957}, {1820,0.000018957}, {1830,0.000047393}, {1840,0.000056872}, {1850,0.000000000}, {1860,0.000033175}, {1870,0.000033175}, {1880,0.000000000}, {1890,0.000047393}, {1900,0.000033175}, {1910,0.000071090}, {1920,0.000052133}, {1930,0.000000000}, {1940,0.000018957}, {1950,0.000037915}, {1960,0.000000000}, {1970,0.000052133}, {1980,0.000056872}, {1990,0.000056872}, {2000,0.000014218}, {2050,0.000018957}, {2100,0.000037915}, {2150,0.000071090}, {2200,0.000052133}, {2250,0.000075829}, {2300,0.000000000}, {2350,0.000080569}, {2400,0.000037915}, {2450,0.000014218}, {2500,0.000018957}, {2550,0.000018957}, {2600,0.000037915}, {2650,0.000037915}, {2700,0.000033175}, {2750,0.000014218}, {2800,0.000037915}, {2850,0.000033175}, {2900,0.000014218}, {2950,0.000052133}, {3000,0.000071090}, {3050,0.000033175}, {3100,0.000052133}, {3150,0.000037915}, {3200,0.000052133}, {3250,0.000047393}, {3300,0.000000000}, {3350,0.000052133}, {3400,0.000037915}, {3450,0.000066351}, {3500,0.000018957}, {3550,0.000014218}, {3600,0.000047393}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000090047}, {3800,0.000014218}, {3850,0.000037915}, {3900,0.000014218}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000014218}, {4150,0.000014218}, {4200,0.000066351}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000052133}, {4450,0.000047393}, {4500,0.000066351}, {4550,0.000075829}, {4600,0.000028436}, {4650,0.000042654}, {4700,0.000028436}, {4750,0.000071090}, {4800,0.000033175}, {4850,0.000014218}, {4900,0.000018957}, {4950,0.000018957}, {5000,0.000028436}, {5050,0.000047393}, {5100,0.000018957}, {5150,0.000066351}, {5200,0.000018957}, {5250,0.000000000}, {5300,0.000052133}, {5350,0.000080569}, {5400,0.000028436}, {5450,0.000018957}, {5500,0.000037915}, {5550,0.000014218}, {5600,0.000033175}, {5650,0.000037915}, {5700,0.000047393}, {5750,0.000000000}, {5800,0.000014218}, {5850,0.000056872}, {5900,0.000018957}, {5950,0.000000000}, {6000,0.000033175}, {6050,0.000018957}, {6100,0.000018957}, {6150,0.000014218}, {6200,0.000052133}, {6250,0.000000000}, {6300,0.000047393}, {6350,0.000018957}, {6400,0.000066351}, {6450,0.000056872}, {6500,0.000000000}, {6550,0.000018957}, {6600,0.000037915}, {6650,0.000000000}, {6700,0.000037915}, {6750,0.000042654}, {6800,0.000052133}, {6850,0.000018957}, {6900,0.000000000}, {6950,0.000061611}, {7000,0.000014218}, {7050,0.000052133}, {7100,0.000014218}, {7150,0.000018957}, {7200,0.000000000}, {7250,0.000028436}, {7300,0.000075829}, {7350,0.000052133}, {7400,0.000033175}, {7450,0.000018957}, {7500,0.000028436}, {7550,0.000014218}, {7600,0.000056872}, {7650,0.000033175}, {7700,0.000047393}, {7750,0.000047393}, {7800,0.000037915}, {7850,0.000052133}, {7900,0.000018957}, {7950,0.000071090}, {8000,0.000014218}, {8050,0.000033175}, {8100,0.000037915}, {8150,0.000028436}, {8200,0.000047393}, {8250,0.000018957}, {8300,0.000052133}, {8350,0.000000000}, {8400,0.000037915}, {8450,0.000047393}, {8500,0.000037915}, {8550,0.000094787}, {8600,0.000075829}, {8650,0.000109005}, {8700,0.000066351}, {8750,0.000075829}, {8800,0.000056872}, {8850,0.000000000}, {8900,0.000037915}, {8950,0.000037915}, {9000,0.000033175}, {9050,0.000047393}, {9100,0.000033175}, {9150,0.000033175}, {9200,0.000014218}, {9250,0.000018957}, {9300,0.000061611}, {9350,0.000075829}, {9400,0.000033175}, {9450,0.000037915}, {9500,0.000123223}, {9550,0.000014218}, {9600,0.000014218}, {9650,0.000037915}, {9700,0.000028436}, {9750,0.000037915}, {9800,0.000033175}, {9850,0.000033175}, {9900,0.000000000}, {9950,0.000000000}, {10000,0.000042654}, {10100,0.000066351}, {10200,0.000033175}, {10300,0.000052133}, {10400,0.000018957}, {10500,0.000028436}, {10600,0.000028436}, {10700,0.000042654}, {10800,0.000047393}, {10900,0.000047393}, {11000,0.000071090}, {11100,0.000018957}, {11200,0.000000000}, {11300,0.000052133}, {11400,0.000085308}, {11500,0.000042654}, {11600,0.000014218}, {11700,0.000028436}, {11800,0.000052133}, {11900,0.000033175}, {12000,0.000033175}, {12100,0.000042654}, {12200,0.000056872}, {12300,0.000028436}, {12400,0.000014218}, {12500,0.000080569}, {12600,0.000014218}, {12700,0.000037915}, {12800,0.000061611}, {12900,0.000047393}, {13000,0.000014218}, {13100,0.000042654}, {13200,0.000014218}, {13300,0.000014218}, {13400,0.000014218}, {13500,0.000056872}, {13600,0.000000000}, {13700,0.000014218}, {13800,0.000014218}, {13900,0.000056872}, {14000,0.000000000}, {14100,0.000080569}, {14200,0.000071090}, {14300,0.000028436}, {14400,0.000028436}, {14500,0.000042654}, {14600,0.000014218}, {14700,0.000000000}, {14800,0.000028436}, {14900,0.000028436}, {15000,0.000066351}, {15100,0.000042654}, {15200,0.000066351}, {15300,0.000047393}, {15400,0.000028436}, {15500,0.000014218}, {15600,0.000028436}, {15700,0.000014218}, {15800,0.000099526}, {15900,0.000047393}, {16000,0.000052133}, {16100,0.000047393}, {16200,0.000047393}, {16300,0.000028436}, {16400,0.000042654}, {16500,0.000066351}, {16600,0.000037915}, {16700,0.000014218}, {16800,0.000061611}, {16900,0.000014218}, {17000,0.000061611}, {17100,0.000075829}, {17200,0.000018957}, {17300,0.000056872}, {17400,0.000042654}, {17500,0.000047393}, {17600,0.000109005}, {17700,0.000090047}, {17800,0.000052133}, {17900,0.000000000}, {18000,0.000037915}, {18100,0.000061611}, {18200,0.000033175}, {18300,0.000075829}, {18400,0.000033175}, {18500,0.000028436}, {18600,0.000080569}, {18700,0.000014218}, {18800,0.000033175}, {18900,0.000014218}, {19000,0.000047393}, {19100,0.000156398}, {19200,0.000047393}, {19300,0.000028436}, {19400,0.000047393}, {19500,0.000014218}, {19600,0.000047393}, {19700,0.000033175}, {19800,0.000037915}, {19900,0.000075829}, {20000,0.000014354}};
data["big_flat"]["Parametricity; beta"]["post"]["system"] = {{1,0.000018957}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000018957}, {39,0.000000000}, {40,0.000018957}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000018957}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000018957}, {140,0.000000000}, {141,0.000018957}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000018957}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000018957}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000018957}, {213,0.000000000}, {214,0.000018957}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000037915}, {220,0.000018957}, {221,0.000000000}, {222,0.000018957}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000014218}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000018957}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000018957}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000018957}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000018957}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000018957}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000018957}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000018957}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000018957}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000018957}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000018957}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000018957}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000018957}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000018957}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000018957}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000018957}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.000000000}, {5100,0.000000000}, {5150,0.000000000}, {5200,0.000000000}, {5250,0.000018957}, {5300,0.000000000}, {5350,0.000000000}, {5400,0.000000000}, {5450,0.000000000}, {5500,0.000000000}, {5550,0.000000000}, {5600,0.000000000}, {5650,0.000000000}, {5700,0.000000000}, {5750,0.000000000}, {5800,0.000000000}, {5850,0.000000000}, {5900,0.000000000}, {5950,0.000000000}, {6000,0.000000000}, {6050,0.000018957}, {6100,0.000000000}, {6150,0.000000000}, {6200,0.000000000}, {6250,0.000000000}, {6300,0.000000000}, {6350,0.000000000}, {6400,0.000000000}, {6450,0.000018957}, {6500,0.000018957}, {6550,0.000000000}, {6600,0.000000000}, {6650,0.000000000}, {6700,0.000000000}, {6750,0.000000000}, {6800,0.000000000}, {6850,0.000018957}, {6900,0.000000000}, {6950,0.000000000}, {7000,0.000018957}, {7050,0.000000000}, {7100,0.000000000}, {7150,0.000000000}, {7200,0.000000000}, {7250,0.000000000}, {7300,0.000000000}, {7350,0.000000000}, {7400,0.000000000}, {7450,0.000000000}, {7500,0.000018957}, {7550,0.000000000}, {7600,0.000000000}, {7650,0.000000000}, {7700,0.000000000}, {7750,0.000000000}, {7800,0.000000000}, {7850,0.000000000}, {7900,0.000000000}, {7950,0.000000000}, {8000,0.000000000}, {8050,0.000000000}, {8100,0.000000000}, {8150,0.000000000}, {8200,0.000000000}, {8250,0.000018957}, {8300,0.000000000}, {8350,0.000000000}, {8400,0.000000000}, {8450,0.000000000}, {8500,0.000000000}, {8550,0.000000000}, {8600,0.000000000}, {8650,0.000000000}, {8700,0.000000000}, {8750,0.000000000}, {8800,0.000000000}, {8850,0.000000000}, {8900,0.000000000}, {8950,0.000000000}, {9000,0.000018957}, {9050,0.000018957}, {9100,0.000000000}, {9150,0.000000000}, {9200,0.000000000}, {9250,0.000000000}, {9300,0.000000000}, {9350,0.000000000}, {9400,0.000000000}, {9450,0.000000000}, {9500,0.000018957}, {9550,0.000000000}, {9600,0.000000000}, {9650,0.000000000}, {9700,0.000000000}, {9750,0.000000000}, {9800,0.000000000}, {9850,0.000000000}, {9900,0.000000000}, {9950,0.000000000}, {10000,0.000000000}, {10100,0.000000000}, {10200,0.000000000}, {10300,0.000018957}, {10400,0.000000000}, {10500,0.000000000}, {10600,0.000018957}, {10700,0.000000000}, {10800,0.000018957}, {10900,0.000000000}, {11000,0.000000000}, {11100,0.000000000}, {11200,0.000000000}, {11300,0.000000000}, {11400,0.000000000}, {11500,0.000000000}, {11600,0.000000000}, {11700,0.000000000}, {11800,0.000000000}, {11900,0.000000000}, {12000,0.000000000}, {12100,0.000000000}, {12200,0.000000000}, {12300,0.000000000}, {12400,0.000018957}, {12500,0.000000000}, {12600,0.000000000}, {12700,0.000014218}, {12800,0.000000000}, {12900,0.000000000}, {13000,0.000000000}, {13100,0.000000000}, {13200,0.000000000}, {13300,0.000000000}, {13400,0.000000000}, {13500,0.000000000}, {13600,0.000000000}, {13700,0.000000000}, {13800,0.000000000}, {13900,0.000000000}, {14000,0.000000000}, {14100,0.000000000}, {14200,0.000000000}, {14300,0.000000000}, {14400,0.000000000}, {14500,0.000000000}, {14600,0.000018957}, {14700,0.000018957}, {14800,0.000000000}, {14900,0.000000000}, {15000,0.000018957}, {15100,0.000000000}, {15200,0.000000000}, {15300,0.000000000}, {15400,0.000000000}, {15500,0.000000000}, {15600,0.000018957}, {15700,0.000018957}, {15800,0.000000000}, {15900,0.000000000}, {16000,0.000000000}, {16100,0.000000000}, {16200,0.000000000}, {16300,0.000000000}, {16400,0.000014218}, {16500,0.000000000}, {16600,0.000018957}, {16700,0.000000000}, {16800,0.000000000}, {16900,0.000000000}, {17000,0.000000000}, {17100,0.000018957}, {17200,0.000000000}, {17300,0.000000000}, {17400,0.000000000}, {17500,0.000000000}, {17600,0.000000000}, {17700,0.000000000}, {17800,0.000000000}, {17900,0.000000000}, {18000,0.000000000}, {18100,0.000018957}, {18200,0.000018957}, {18300,0.000000000}, {18400,0.000018957}, {18500,0.000000000}, {18600,0.000000000}, {18700,0.000000000}, {18800,0.000000000}, {18900,0.000000000}, {19000,0.000000000}, {19100,0.000000000}, {19200,0.000000000}, {19300,0.000000000}, {19400,0.000000000}, {19500,0.000000000}, {19600,0.000000000}, {19700,0.000000000}, {19800,0.000000000}, {19900,0.000000000}, {20000,0.000000000}};
data["big_flat"]["Parametricity; beta"]["pre"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.000000000}, {5100,0.000000000}, {5150,0.000000000}, {5200,0.000000000}, {5250,0.000000000}, {5300,0.000000000}, {5350,0.000000000}, {5400,0.000000000}, {5450,0.000000000}, {5500,0.000000000}, {5550,0.000000000}, {5600,0.000000000}, {5650,0.000000000}, {5700,0.000000000}, {5750,0.000000000}, {5800,0.000000000}, {5850,0.000000000}, {5900,0.000000000}, {5950,0.000000000}, {6000,0.000000000}, {6050,0.000000000}, {6100,0.000000000}, {6150,0.000000000}, {6200,0.000000000}, {6250,0.000000000}, {6300,0.000000000}, {6350,0.000000000}, {6400,0.000000000}, {6450,0.000000000}, {6500,0.000000000}, {6550,0.000000000}, {6600,0.000000000}, {6650,0.000000000}, {6700,0.000000000}, {6750,0.000000000}, {6800,0.000000000}, {6850,0.000000000}, {6900,0.000000000}, {6950,0.000000000}, {7000,0.000000000}, {7050,0.000000000}, {7100,0.000000000}, {7150,0.000000000}, {7200,0.000000000}, {7250,0.000000000}, {7300,0.000000000}, {7350,0.000000000}, {7400,0.000000000}, {7450,0.000000000}, {7500,0.000000000}, {7550,0.000000000}, {7600,0.000000000}, {7650,0.000000000}, {7700,0.000000000}, {7750,0.000000000}, {7800,0.000000000}, {7850,0.000000000}, {7900,0.000000000}, {7950,0.000000000}, {8000,0.000000000}, {8050,0.000000000}, {8100,0.000000000}, {8150,0.000000000}, {8200,0.000000000}, {8250,0.000000000}, {8300,0.000000000}, {8350,0.000000000}, {8400,0.000000000}, {8450,0.000000000}, {8500,0.000000000}, {8550,0.000000000}, {8600,0.000000000}, {8650,0.000000000}, {8700,0.000000000}, {8750,0.000000000}, {8800,0.000000000}, {8850,0.000000000}, {8900,0.000000000}, {8950,0.000000000}, {9000,0.000000000}, {9050,0.000000000}, {9100,0.000000000}, {9150,0.000000000}, {9200,0.000000000}, {9250,0.000000000}, {9300,0.000000000}, {9350,0.000000000}, {9400,0.000000000}, {9450,0.000000000}, {9500,0.000000000}, {9550,0.000000000}, {9600,0.000000000}, {9650,0.000000000}, {9700,0.000000000}, {9750,0.000000000}, {9800,0.000000000}, {9850,0.000000000}, {9900,0.000000000}, {9950,0.000000000}, {10000,0.000000000}, {10100,0.000000000}, {10200,0.000000000}, {10300,0.000000000}, {10400,0.000000000}, {10500,0.000000000}, {10600,0.000000000}, {10700,0.000000000}, {10800,0.000000000}, {10900,0.000000000}, {11000,0.000000000}, {11100,0.000000000}, {11200,0.000000000}, {11300,0.000000000}, {11400,0.000000000}, {11500,0.000000000}, {11600,0.000000000}, {11700,0.000000000}, {11800,0.000000000}, {11900,0.000000000}, {12000,0.000000000}, {12100,0.000000000}, {12200,0.000000000}, {12300,0.000000000}, {12400,0.000000000}, {12500,0.000000000}, {12600,0.000000000}, {12700,0.000000000}, {12800,0.000000000}, {12900,0.000000000}, {13000,0.000000000}, {13100,0.000000000}, {13200,0.000000000}, {13300,0.000000000}, {13400,0.000000000}, {13500,0.000000000}, {13600,0.000000000}, {13700,0.000000000}, {13800,0.000000000}, {13900,0.000000000}, {14000,0.000000000}, {14100,0.000000000}, {14200,0.000000000}, {14300,0.000000000}, {14400,0.000000000}, {14500,0.000000000}, {14600,0.000000000}, {14700,0.000000000}, {14800,0.000000000}, {14900,0.000000000}, {15000,0.000000000}, {15100,0.000000000}, {15200,0.000000000}, {15300,0.000000000}, {15400,0.000000000}, {15500,0.000000000}, {15600,0.000000000}, {15700,0.000000000}, {15800,0.000000000}, {15900,0.000000000}, {16000,0.000000000}, {16100,0.000000000}, {16200,0.000000000}, {16300,0.000000000}, {16400,0.000000000}, {16500,0.000000000}, {16600,0.000000000}, {16700,0.000000000}, {16800,0.000000000}, {16900,0.000000000}, {17000,0.000000000}, {17100,0.000000000}, {17200,0.000000000}, {17300,0.000000000}, {17400,0.000000000}, {17500,0.000000000}, {17600,0.000000000}, {17700,0.000000000}, {17800,0.000000000}, {17900,0.000000000}, {18000,0.000000000}, {18100,0.000000000}, {18200,0.000000000}, {18300,0.000000000}, {18400,0.000000000}, {18500,0.000000000}, {18600,0.000000000}, {18700,0.000000000}, {18800,0.000000000}, {18900,0.000000000}, {19000,0.000000000}, {19100,0.000000000}, {19200,0.000000000}, {19300,0.000000000}, {19400,0.000000000}, {19500,0.000000000}, {19600,0.000000000}, {19700,0.000000000}, {19800,0.000000000}, {19900,0.000000000}, {20000,0.000000000}};
data["big_flat"]["Parametricity; beta"]["pre"]["user"] = {{1,0.000014218}, {2,0.000018957}, {3,0.000018957}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000018957}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000018957}, {17,0.000000000}, {18,0.000014218}, {19,0.000000000}, {20,0.000018957}, {21,0.000014218}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000018957}, {31,0.000000000}, {32,0.000000000}, {33,0.000018957}, {34,0.000000000}, {35,0.000018957}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000018957}, {51,0.000000000}, {52,0.000000000}, {53,0.000018957}, {54,0.000018957}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000037915}, {65,0.000000000}, {66,0.000014218}, {67,0.000000000}, {68,0.000000000}, {69,0.000018957}, {70,0.000014218}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000014218}, {81,0.000000000}, {82,0.000000000}, {83,0.000014218}, {84,0.000000000}, {85,0.000018957}, {86,0.000014218}, {87,0.000037915}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000018957}, {92,0.000018957}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000014218}, {97,0.000000000}, {98,0.000014218}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000014218}, {115,0.000000000}, {116,0.000018957}, {117,0.000014218}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000018957}, {129,0.000018957}, {130,0.000000000}, {131,0.000018957}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000037915}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000014218}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000028436}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000014218}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000014218}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000014218}, {160,0.000000000}, {161,0.000000000}, {162,0.000014218}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000018957}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000018957}, {173,0.000000000}, {174,0.000014218}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000014218}, {179,0.000037915}, {180,0.000000000}, {181,0.000000000}, {182,0.000014218}, {183,0.000000000}, {184,0.000018957}, {185,0.000000000}, {186,0.000000000}, {187,0.000018957}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000018957}, {193,0.000000000}, {194,0.000000000}, {195,0.000018957}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000028436}, {207,0.000000000}, {208,0.000056872}, {209,0.000000000}, {210,0.000014218}, {211,0.000000000}, {212,0.000014218}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000018957}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000018957}, {226,0.000000000}, {227,0.000000000}, {228,0.000018957}, {229,0.000014218}, {230,0.000000000}, {231,0.000018957}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000018957}, {240,0.000000000}, {241,0.000000000}, {242,0.000018957}, {243,0.000014218}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000037915}, {249,0.000018957}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000014218}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000018957}, {258,0.000014218}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000014218}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000014218}, {282,0.000000000}, {283,0.000028436}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000033175}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000018957}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000018957}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000018957}, {316,0.000000000}, {317,0.000014218}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000018957}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000018957}, {330,0.000000000}, {331,0.000014218}, {332,0.000014218}, {333,0.000000000}, {334,0.000018957}, {335,0.000000000}, {336,0.000000000}, {337,0.000018957}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000014218}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000014218}, {346,0.000037915}, {347,0.000014218}, {348,0.000033175}, {349,0.000014218}, {350,0.000018957}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000014218}, {357,0.000014218}, {358,0.000000000}, {359,0.000018957}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000014218}, {368,0.000018957}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000014218}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000014218}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000014218}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000018957}, {392,0.000018957}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000014218}, {398,0.000000000}, {399,0.000018957}, {400,0.000018957}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000018957}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000018957}, {414,0.000018957}, {415,0.000018957}, {416,0.000000000}, {417,0.000000000}, {418,0.000018957}, {419,0.000000000}, {420,0.000018957}, {421,0.000018957}, {422,0.000037915}, {423,0.000028436}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000014218}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000018957}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000014218}, {440,0.000037915}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000018957}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000014218}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000018957}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000033175}, {459,0.000018957}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000014218}, {468,0.000018957}, {469,0.000000000}, {470,0.000000000}, {471,0.000018957}, {472,0.000000000}, {473,0.000000000}, {474,0.000014218}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000014218}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000018957}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000018957}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000014218}, {497,0.000037915}, {498,0.000000000}, {499,0.000000000}, {500,0.000014218}, {505,0.000000000}, {510,0.000018957}, {515,0.000000000}, {520,0.000018957}, {525,0.000000000}, {530,0.000000000}, {535,0.000018957}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000014218}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000014218}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000018957}, {655,0.000000000}, {660,0.000000000}, {665,0.000014218}, {670,0.000000000}, {675,0.000000000}, {680,0.000018957}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000037915}, {725,0.000000000}, {730,0.000018957}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000014218}, {765,0.000014218}, {770,0.000000000}, {775,0.000000000}, {780,0.000018957}, {785,0.000000000}, {790,0.000018957}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000018957}, {825,0.000000000}, {830,0.000018957}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000018957}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000014218}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000018957}, {960,0.000000000}, {965,0.000000000}, {970,0.000014218}, {975,0.000014218}, {980,0.000000000}, {985,0.000000000}, {990,0.000018957}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000018957}, {1020,0.000014218}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000018957}, {1080,0.000033175}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000018957}, {1140,0.000000000}, {1150,0.000014218}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000014218}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000037915}, {1340,0.000018957}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000018957}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000033175}, {1530,0.000018957}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000033175}, {1670,0.000000000}, {1680,0.000018957}, {1690,0.000000000}, {1700,0.000018957}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000033175}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000014218}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000014218}, {1820,0.000014218}, {1830,0.000018957}, {1840,0.000014218}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000018957}, {1890,0.000000000}, {1900,0.000018957}, {1910,0.000000000}, {1920,0.000018957}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000018957}, {1980,0.000000000}, {1990,0.000018957}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000014218}, {2350,0.000014218}, {2400,0.000033175}, {2450,0.000018957}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000014218}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000018957}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000018957}, {3150,0.000000000}, {3200,0.000014218}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000014218}, {3550,0.000047393}, {3600,0.000018957}, {3650,0.000000000}, {3700,0.000018957}, {3750,0.000000000}, {3800,0.000018957}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000018957}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000028436}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000018957}, {4700,0.000018957}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.000014218}, {5100,0.000037915}, {5150,0.000000000}, {5200,0.000000000}, {5250,0.000000000}, {5300,0.000000000}, {5350,0.000000000}, {5400,0.000000000}, {5450,0.000000000}, {5500,0.000000000}, {5550,0.000000000}, {5600,0.000000000}, {5650,0.000000000}, {5700,0.000000000}, {5750,0.000000000}, {5800,0.000000000}, {5850,0.000018957}, {5900,0.000000000}, {5950,0.000018957}, {6000,0.000000000}, {6050,0.000000000}, {6100,0.000000000}, {6150,0.000000000}, {6200,0.000018957}, {6250,0.000000000}, {6300,0.000000000}, {6350,0.000000000}, {6400,0.000018957}, {6450,0.000018957}, {6500,0.000018957}, {6550,0.000000000}, {6600,0.000000000}, {6650,0.000018957}, {6700,0.000000000}, {6750,0.000000000}, {6800,0.000000000}, {6850,0.000000000}, {6900,0.000018957}, {6950,0.000018957}, {7000,0.000000000}, {7050,0.000018957}, {7100,0.000000000}, {7150,0.000014218}, {7200,0.000000000}, {7250,0.000014218}, {7300,0.000018957}, {7350,0.000018957}, {7400,0.000018957}, {7450,0.000000000}, {7500,0.000000000}, {7550,0.000000000}, {7600,0.000018957}, {7650,0.000000000}, {7700,0.000000000}, {7750,0.000014218}, {7800,0.000000000}, {7850,0.000000000}, {7900,0.000000000}, {7950,0.000000000}, {8000,0.000018957}, {8050,0.000000000}, {8100,0.000018957}, {8150,0.000000000}, {8200,0.000014218}, {8250,0.000000000}, {8300,0.000000000}, {8350,0.000018957}, {8400,0.000000000}, {8450,0.000018957}, {8500,0.000018957}, {8550,0.000000000}, {8600,0.000000000}, {8650,0.000018957}, {8700,0.000000000}, {8750,0.000000000}, {8800,0.000014218}, {8850,0.000018957}, {8900,0.000000000}, {8950,0.000000000}, {9000,0.000000000}, {9050,0.000000000}, {9100,0.000000000}, {9150,0.000000000}, {9200,0.000000000}, {9250,0.000000000}, {9300,0.000037915}, {9350,0.000000000}, {9400,0.000018957}, {9450,0.000000000}, {9500,0.000000000}, {9550,0.000000000}, {9600,0.000000000}, {9650,0.000000000}, {9700,0.000000000}, {9750,0.000000000}, {9800,0.000000000}, {9850,0.000028436}, {9900,0.000000000}, {9950,0.000014218}, {10000,0.000014218}, {10100,0.000000000}, {10200,0.000028436}, {10300,0.000000000}, {10400,0.000000000}, {10500,0.000000000}, {10600,0.000000000}, {10700,0.000000000}, {10800,0.000000000}, {10900,0.000000000}, {11000,0.000014218}, {11100,0.000000000}, {11200,0.000000000}, {11300,0.000014218}, {11400,0.000000000}, {11500,0.000000000}, {11600,0.000000000}, {11700,0.000014218}, {11800,0.000014218}, {11900,0.000000000}, {12000,0.000000000}, {12100,0.000000000}, {12200,0.000000000}, {12300,0.000000000}, {12400,0.000014218}, {12500,0.000028436}, {12600,0.000000000}, {12700,0.000000000}, {12800,0.000014218}, {12900,0.000018957}, {13000,0.000018957}, {13100,0.000000000}, {13200,0.000018957}, {13300,0.000000000}, {13400,0.000014218}, {13500,0.000000000}, {13600,0.000000000}, {13700,0.000000000}, {13800,0.000000000}, {13900,0.000000000}, {14000,0.000014218}, {14100,0.000014218}, {14200,0.000014218}, {14300,0.000014218}, {14400,0.000000000}, {14500,0.000000000}, {14600,0.000014218}, {14700,0.000014218}, {14800,0.000014218}, {14900,0.000000000}, {15000,0.000000000}, {15100,0.000028436}, {15200,0.000000000}, {15300,0.000000000}, {15400,0.000018957}, {15500,0.000000000}, {15600,0.000014218}, {15700,0.000033175}, {15800,0.000000000}, {15900,0.000014218}, {16000,0.000000000}, {16100,0.000014218}, {16200,0.000000000}, {16300,0.000014218}, {16400,0.000000000}, {16500,0.000000000}, {16600,0.000000000}, {16700,0.000000000}, {16800,0.000018957}, {16900,0.000014218}, {17000,0.000000000}, {17100,0.000052133}, {17200,0.000000000}, {17300,0.000000000}, {17400,0.000000000}, {17500,0.000000000}, {17600,0.000000000}, {17700,0.000000000}, {17800,0.000000000}, {17900,0.000000000}, {18000,0.000000000}, {18100,0.000000000}, {18200,0.000000000}, {18300,0.000000000}, {18400,0.000000000}, {18500,0.000000000}, {18600,0.000000000}, {18700,0.000000000}, {18800,0.000037915}, {18900,0.000000000}, {19000,0.000018957}, {19100,0.000000000}, {19200,0.000000000}, {19300,0.000018957}, {19400,0.000000000}, {19500,0.000000000}, {19600,0.000033175}, {19700,0.000018957}, {19800,0.000014218}, {19900,0.000000000}, {20000,0.000000000}};
data["big_flat"]["Parametricity; beta"]["pre"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000018957}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000018957}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000018957}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.000000000}, {5100,0.000000000}, {5150,0.000000000}, {5200,0.000000000}, {5250,0.000000000}, {5300,0.000000000}, {5350,0.000000000}, {5400,0.000000000}, {5450,0.000000000}, {5500,0.000000000}, {5550,0.000000000}, {5600,0.000000000}, {5650,0.000000000}, {5700,0.000000000}, {5750,0.000000000}, {5800,0.000000000}, {5850,0.000000000}, {5900,0.000000000}, {5950,0.000000000}, {6000,0.000000000}, {6050,0.000000000}, {6100,0.000000000}, {6150,0.000000000}, {6200,0.000000000}, {6250,0.000000000}, {6300,0.000000000}, {6350,0.000000000}, {6400,0.000000000}, {6450,0.000000000}, {6500,0.000000000}, {6550,0.000000000}, {6600,0.000000000}, {6650,0.000000000}, {6700,0.000000000}, {6750,0.000000000}, {6800,0.000000000}, {6850,0.000000000}, {6900,0.000000000}, {6950,0.000000000}, {7000,0.000000000}, {7050,0.000000000}, {7100,0.000000000}, {7150,0.000018957}, {7200,0.000000000}, {7250,0.000000000}, {7300,0.000000000}, {7350,0.000000000}, {7400,0.000000000}, {7450,0.000000000}, {7500,0.000000000}, {7550,0.000000000}, {7600,0.000000000}, {7650,0.000000000}, {7700,0.000000000}, {7750,0.000000000}, {7800,0.000000000}, {7850,0.000000000}, {7900,0.000000000}, {7950,0.000000000}, {8000,0.000000000}, {8050,0.000000000}, {8100,0.000000000}, {8150,0.000000000}, {8200,0.000000000}, {8250,0.000000000}, {8300,0.000000000}, {8350,0.000000000}, {8400,0.000000000}, {8450,0.000000000}, {8500,0.000000000}, {8550,0.000000000}, {8600,0.000000000}, {8650,0.000000000}, {8700,0.000000000}, {8750,0.000000000}, {8800,0.000000000}, {8850,0.000000000}, {8900,0.000000000}, {8950,0.000000000}, {9000,0.000000000}, {9050,0.000000000}, {9100,0.000000000}, {9150,0.000000000}, {9200,0.000000000}, {9250,0.000000000}, {9300,0.000000000}, {9350,0.000000000}, {9400,0.000000000}, {9450,0.000018957}, {9500,0.000000000}, {9550,0.000000000}, {9600,0.000000000}, {9650,0.000000000}, {9700,0.000000000}, {9750,0.000000000}, {9800,0.000000000}, {9850,0.000000000}, {9900,0.000000000}, {9950,0.000000000}, {10000,0.000000000}, {10100,0.000000000}, {10200,0.000000000}, {10300,0.000000000}, {10400,0.000000000}, {10500,0.000000000}, {10600,0.000000000}, {10700,0.000000000}, {10800,0.000000000}, {10900,0.000000000}, {11000,0.000000000}, {11100,0.000000000}, {11200,0.000000000}, {11300,0.000000000}, {11400,0.000000000}, {11500,0.000000000}, {11600,0.000000000}, {11700,0.000000000}, {11800,0.000000000}, {11900,0.000000000}, {12000,0.000000000}, {12100,0.000000000}, {12200,0.000000000}, {12300,0.000000000}, {12400,0.000000000}, {12500,0.000000000}, {12600,0.000000000}, {12700,0.000000000}, {12800,0.000000000}, {12900,0.000000000}, {13000,0.000000000}, {13100,0.000000000}, {13200,0.000000000}, {13300,0.000000000}, {13400,0.000000000}, {13500,0.000000000}, {13600,0.000000000}, {13700,0.000000000}, {13800,0.000000000}, {13900,0.000000000}, {14000,0.000000000}, {14100,0.000000000}, {14200,0.000000000}, {14300,0.000000000}, {14400,0.000000000}, {14500,0.000000000}, {14600,0.000000000}, {14700,0.000000000}, {14800,0.000000000}, {14900,0.000000000}, {15000,0.000000000}, {15100,0.000000000}, {15200,0.000000000}, {15300,0.000000000}, {15400,0.000000000}, {15500,0.000000000}, {15600,0.000000000}, {15700,0.000000000}, {15800,0.000000000}, {15900,0.000000000}, {16000,0.000000000}, {16100,0.000000000}, {16200,0.000000000}, {16300,0.000000000}, {16400,0.000000000}, {16500,0.000000000}, {16600,0.000000000}, {16700,0.000000000}, {16800,0.000000000}, {16900,0.000000000}, {17000,0.000000000}, {17100,0.000000000}, {17200,0.000000000}, {17300,0.000000000}, {17400,0.000000000}, {17500,0.000000000}, {17600,0.000000000}, {17700,0.000000000}, {17800,0.000000000}, {17900,0.000000000}, {18000,0.000000000}, {18100,0.000000000}, {18200,0.000000000}, {18300,0.000000000}, {18400,0.000000000}, {18500,0.000000000}, {18600,0.000000000}, {18700,0.000000000}, {18800,0.000000000}, {18900,0.000000000}, {19000,0.000000000}, {19100,0.000000000}, {19200,0.000000000}, {19300,0.000000000}, {19400,0.000000000}, {19500,0.000000000}, {19600,0.000000000}, {19700,0.000000000}, {19800,0.000000000}, {19900,0.000000000}, {20000,0.000000000}};
data["big_flat"]["Parametricity; beta"]["reif"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000004739}, {92,0.000009479}, {93,0.000004739}, {94,0.000000000}, {95,0.000004739}, {96,0.000000000}, {97,0.000014218}, {98,0.000009479}, {99,0.000023697}, {100,0.000042654}, {101,0.000033175}, {102,0.000061611}, {103,0.000066351}, {104,0.000109005}, {105,0.000127962}, {106,0.000156398}, {107,0.000208531}, {108,0.000222749}, {109,0.000236967}, {110,0.000279621}, {111,0.000322275}, {112,0.000412322}, {113,0.000364929}, {114,0.000417062}, {115,0.000450237}, {116,0.000497630}, {117,0.000492891}, {118,0.000521327}, {119,0.000568720}, {120,0.001156398}, {121,0.000582938}, {122,0.000616114}, {123,0.000601896}, {124,0.000682464}, {125,0.000687204}, {126,0.000763033}, {127,0.000767773}, {128,0.000862559}, {129,0.000838863}, {130,0.000924171}, {131,0.000952607}, {132,0.000957346}, {133,0.000962085}, {134,0.000976303}, {135,0.000962085}, {136,0.001000000}, {137,0.000990521}, {138,0.001000000}, {139,0.001000000}, {140,0.001000000}, {141,0.001000000}, {142,0.001000000}, {143,0.001000000}, {144,0.001000000}, {145,0.001000000}, {146,0.001000000}, {147,0.001000000}, {148,0.001000000}, {149,0.001000000}, {150,0.001000000}, {151,0.001000000}, {152,0.001009479}, {153,0.001478673}, {154,0.001511848}, {155,0.001000000}, {156,0.001000000}, {157,0.001000000}, {158,0.001000000}, {159,0.001000000}, {160,0.001000000}, {161,0.001000000}, {162,0.001000000}, {163,0.001000000}, {164,0.001000000}, {165,0.001000000}, {166,0.001000000}, {167,0.001000000}, {168,0.001000000}, {169,0.001000000}, {170,0.001000000}, {171,0.001000000}, {172,0.001000000}, {173,0.001000000}, {174,0.001000000}, {175,0.001000000}, {176,0.001000000}, {177,0.001000000}, {178,0.001000000}, {179,0.001000000}, {180,0.001000000}, {181,0.001009479}, {182,0.001000000}, {183,0.001511848}, {184,0.001000000}, {185,0.001000000}, {186,0.001000000}, {187,0.001000000}, {188,0.001000000}, {189,0.001000000}, {190,0.001000000}, {191,0.001000000}, {192,0.001000000}, {193,0.001000000}, {194,0.001000000}, {195,0.001000000}, {196,0.001004739}, {197,0.001000000}, {198,0.001000000}, {199,0.001000000}, {200,0.001000000}, {201,0.001000000}, {202,0.001000000}, {203,0.001000000}, {204,0.001000000}, {205,0.001000000}, {206,0.001000000}, {207,0.001000000}, {208,0.001000000}, {209,0.001582938}, {210,0.001000000}, {211,0.001000000}, {212,0.001000000}, {213,0.001000000}, {214,0.001000000}, {215,0.001000000}, {216,0.001000000}, {217,0.001000000}, {218,0.001000000}, {219,0.001000000}, {220,0.001000000}, {221,0.001000000}, {222,0.001000000}, {223,0.001004739}, {224,0.001000000}, {225,0.001000000}, {226,0.001000000}, {227,0.001000000}, {228,0.001000000}, {229,0.001000000}, {230,0.001000000}, {231,0.001000000}, {232,0.001000000}, {233,0.002317536}, {234,0.001000000}, {235,0.001000000}, {236,0.001000000}, {237,0.001000000}, {238,0.001000000}, {239,0.001000000}, {240,0.001000000}, {241,0.001000000}, {242,0.001000000}, {243,0.001000000}, {244,0.001000000}, {245,0.001000000}, {246,0.001000000}, {247,0.001000000}, {248,0.001000000}, {249,0.001000000}, {250,0.001000000}, {251,0.001000000}, {252,0.001000000}, {253,0.001000000}, {254,0.001000000}, {255,0.001000000}, {256,0.001000000}, {257,0.001000000}, {258,0.001000000}, {259,0.001000000}, {260,0.001000000}, {261,0.001000000}, {262,0.001000000}, {263,0.001000000}, {264,0.001000000}, {265,0.001000000}, {266,0.001000000}, {267,0.001000000}, {268,0.001000000}, {269,0.001000000}, {270,0.001000000}, {271,0.001000000}, {272,0.001000000}, {273,0.001000000}, {274,0.001000000}, {275,0.001000000}, {276,0.001000000}, {277,0.001478673}, {278,0.001000000}, {279,0.001000000}, {280,0.001000000}, {281,0.001000000}, {282,0.001014218}, {283,0.001000000}, {284,0.001000000}, {285,0.001000000}, {286,0.001000000}, {287,0.001000000}, {288,0.001004739}, {289,0.001000000}, {290,0.001000000}, {291,0.001000000}, {292,0.001000000}, {293,0.001000000}, {294,0.001000000}, {295,0.001004739}, {296,0.001004739}, {297,0.001478673}, {298,0.001000000}, {299,0.001014218}, {300,0.001009479}, {301,0.001004739}, {302,0.001000000}, {303,0.001009479}, {304,0.001004739}, {305,0.001009479}, {306,0.001000000}, {307,0.001000000}, {308,0.001004739}, {309,0.001018957}, {310,0.001004739}, {311,0.001000000}, {312,0.001009479}, {313,0.001018957}, {314,0.001018957}, {315,0.001014218}, {316,0.001545024}, {317,0.001028436}, {318,0.001023697}, {319,0.001018957}, {320,0.001056872}, {321,0.001037915}, {322,0.001042654}, {323,0.001071090}, {324,0.001085308}, {325,0.001099526}, {326,0.001118483}, {327,0.001118483}, {328,0.001161137}, {329,0.001175355}, {330,0.001184834}, {331,0.001222749}, {332,0.001232227}, {333,0.001236967}, {334,0.001791469}, {335,0.001274882}, {336,0.001331754}, {337,0.001331754}, {338,0.001312796}, {339,0.001379147}, {340,0.001369668}, {341,0.001402844}, {342,0.001388626}, {343,0.001402844}, {344,0.001431280}, {345,0.001445498}, {346,0.001436019}, {347,0.001464455}, {348,0.001497630}, {349,0.001492891}, {350,0.001540284}, {351,0.001516588}, {352,0.001587678}, {353,0.001587678}, {354,0.001563981}, {355,0.001606635}, {356,0.001630332}, {357,0.001644550}, {358,0.001663507}, {359,0.001715640}, {360,0.001739336}, {361,0.001767773}, {362,0.001800948}, {363,0.001815166}, {364,0.001853081}, {365,0.001867299}, {366,0.001881517}, {367,0.001900474}, {368,0.002412322}, {369,0.001928910}, {370,0.001914692}, {371,0.001900474}, {372,0.001914692}, {373,0.001924171}, {374,0.001928910}, {375,0.001933649}, {376,0.001924171}, {377,0.001952607}, {378,0.001943128}, {379,0.001947867}, {380,0.001947867}, {381,0.001957346}, {382,0.001957346}, {383,0.001971564}, {384,0.002488152}, {385,0.001985782}, {386,0.001971564}, {387,0.001990521}, {388,0.001995261}, {389,0.002000000}, {390,0.001990521}, {391,0.001990521}, {392,0.002000000}, {393,0.002000000}, {394,0.002000000}, {395,0.002000000}, {396,0.002000000}, {397,0.002000000}, {398,0.002000000}, {399,0.002009479}, {400,0.002502370}, {401,0.002000000}, {402,0.002000000}, {403,0.002000000}, {404,0.002000000}, {405,0.002000000}, {406,0.002004739}, {407,0.002000000}, {408,0.002000000}, {409,0.002000000}, {410,0.002000000}, {411,0.002000000}, {412,0.002000000}, {413,0.002000000}, {414,0.002014218}, {415,0.002511848}, {416,0.002000000}, {417,0.002000000}, {418,0.002000000}, {419,0.002000000}, {420,0.002000000}, {421,0.002000000}, {422,0.002000000}, {423,0.002000000}, {424,0.002000000}, {425,0.002000000}, {426,0.002000000}, {427,0.002000000}, {428,0.002000000}, {429,0.002018957}, {430,0.002000000}, {431,0.002000000}, {432,0.002000000}, {433,0.002000000}, {434,0.002000000}, {435,0.002000000}, {436,0.002000000}, {437,0.002000000}, {438,0.002000000}, {439,0.002000000}, {440,0.002000000}, {441,0.002004739}, {442,0.002000000}, {443,0.002014218}, {444,0.003023697}, {445,0.002511848}, {446,0.002000000}, {447,0.002000000}, {448,0.002004739}, {449,0.002000000}, {450,0.002000000}, {451,0.002000000}, {452,0.002000000}, {453,0.002000000}, {454,0.002000000}, {455,0.002004739}, {456,0.002000000}, {457,0.002018957}, {458,0.002981043}, {459,0.002478673}, {460,0.002000000}, {461,0.002000000}, {462,0.002000000}, {463,0.002000000}, {464,0.002000000}, {465,0.002000000}, {466,0.002000000}, {467,0.002009479}, {468,0.002000000}, {469,0.002000000}, {470,0.002000000}, {471,0.002000000}, {472,0.002000000}, {473,0.002009479}, {474,0.002000000}, {475,0.002000000}, {476,0.002000000}, {477,0.002000000}, {478,0.002000000}, {479,0.002000000}, {480,0.002000000}, {481,0.002000000}, {482,0.002000000}, {483,0.002000000}, {484,0.002018957}, {485,0.002597156}, {486,0.002000000}, {487,0.002000000}, {488,0.002000000}, {489,0.002000000}, {490,0.002000000}, {491,0.002000000}, {492,0.002000000}, {493,0.002000000}, {494,0.002000000}, {495,0.002004739}, {496,0.002000000}, {497,0.002033175}, {498,0.002654028}, {499,0.002478673}, {500,0.002014218}, {505,0.002004739}, {510,0.002000000}, {515,0.002009479}, {520,0.002000000}, {525,0.002000000}, {530,0.002014218}, {535,0.002033175}, {540,0.002023697}, {545,0.002061611}, {550,0.002066351}, {555,0.003075829}, {560,0.002184834}, {565,0.002289100}, {570,0.002360190}, {575,0.002393365}, {580,0.002445498}, {585,0.002464455}, {590,0.002545024}, {595,0.002654028}, {600,0.002734597}, {605,0.002815166}, {610,0.002881517}, {615,0.002924171}, {620,0.002928910}, {625,0.002947867}, {630,0.002952607}, {635,0.002966825}, {640,0.002990521}, {645,0.002990521}, {650,0.003000000}, {655,0.003000000}, {660,0.003606635}, {665,0.003478673}, {670,0.003000000}, {675,0.003000000}, {680,0.003000000}, {685,0.003000000}, {690,0.003000000}, {695,0.003000000}, {700,0.003000000}, {705,0.003018957}, {710,0.003000000}, {715,0.003000000}, {720,0.003000000}, {725,0.003000000}, {730,0.003000000}, {735,0.003000000}, {740,0.003000000}, {745,0.003014218}, {750,0.003023697}, {755,0.003962085}, {760,0.003009479}, {765,0.003023697}, {770,0.003052133}, {775,0.003071090}, {780,0.003132701}, {785,0.003175355}, {790,0.003208531}, {795,0.003284360}, {800,0.003360190}, {805,0.003364929}, {810,0.003393365}, {815,0.003412322}, {820,0.003502370}, {825,0.003554502}, {830,0.003587678}, {835,0.003706161}, {840,0.005189573}, {845,0.003800948}, {850,0.003876777}, {855,0.003919431}, {860,0.003928910}, {865,0.003938389}, {870,0.003947867}, {875,0.003947867}, {880,0.005450237}, {885,0.003990521}, {890,0.003976303}, {895,0.003995261}, {900,0.003995261}, {905,0.004000000}, {910,0.004000000}, {915,0.004028436}, {920,0.004000000}, {925,0.004000000}, {930,0.004000000}, {935,0.004000000}, {940,0.004000000}, {945,0.004000000}, {950,0.004004739}, {955,0.006298578}, {960,0.004014218}, {965,0.004009479}, {970,0.004014218}, {975,0.004018957}, {980,0.004018957}, {985,0.004023697}, {990,0.005985782}, {995,0.004966825}, {1000,0.004071090}, {1010,0.004142180}, {1020,0.004232227}, {1030,0.004298578}, {1040,0.004407583}, {1050,0.006000000}, {1060,0.004554502}, {1070,0.004620853}, {1080,0.004753555}, {1090,0.004867299}, {1100,0.004914692}, {1110,0.004962085}, {1120,0.006379147}, {1130,0.004947867}, {1140,0.004971564}, {1150,0.004990521}, {1160,0.005000000}, {1170,0.005000000}, {1180,0.005009479}, {1190,0.005014218}, {1200,0.005023697}, {1210,0.005037915}, {1220,0.005075829}, {1230,0.005118483}, {1240,0.006947867}, {1250,0.005222749}, {1260,0.005327014}, {1270,0.005355450}, {1280,0.005445498}, {1290,0.007511848}, {1300,0.005573460}, {1310,0.005644550}, {1320,0.005767773}, {1330,0.005848341}, {1340,0.005938389}, {1350,0.008355450}, {1360,0.005928910}, {1370,0.005962085}, {1380,0.005962085}, {1390,0.005981043}, {1400,0.006014218}, {1410,0.006018957}, {1420,0.006028436}, {1430,0.006009479}, {1440,0.006056872}, {1450,0.006075829}, {1460,0.006118483}, {1470,0.006227488}, {1480,0.006284360}, {1490,0.006341232}, {1500,0.009772512}, {1510,0.006421801}, {1520,0.006473934}, {1530,0.006507109}, {1540,0.006668246}, {1550,0.008364929}, {1560,0.006824645}, {1570,0.006867299}, {1580,0.006890995}, {1590,0.008232227}, {1600,0.006928910}, {1610,0.006943128}, {1620,0.006976303}, {1630,0.007066351}, {1640,0.008113744}, {1650,0.007071090}, {1660,0.007056872}, {1670,0.007127962}, {1680,0.009023697}, {1690,0.007194313}, {1700,0.007270142}, {1710,0.007317536}, {1720,0.009407583}, {1730,0.007398104}, {1740,0.007459716}, {1750,0.007454976}, {1760,0.010180095}, {1770,0.007592417}, {1780,0.007654028}, {1790,0.007772512}, {1800,0.010720379}, {1810,0.007867299}, {1820,0.007919431}, {1830,0.007962085}, {1840,0.010909953}, {1850,0.008018957}, {1860,0.008028436}, {1870,0.008075829}, {1880,0.010587678}, {1890,0.008142180}, {1900,0.008208531}, {1910,0.008213270}, {1920,0.010492891}, {1930,0.008317536}, {1940,0.008345972}, {1950,0.008393365}, {1960,0.011199052}, {1970,0.008436019}, {1980,0.008459716}, {1990,0.008554502}, {2000,0.008549763}, {2050,0.008938389}, {2100,0.009142180}, {2150,0.010554502}, {2200,0.009464455}, {2250,0.009763033}, {2300,0.013393365}, {2350,0.010274882}, {2400,0.010417062}, {2450,0.014327014}, {2500,0.011023697}, {2550,0.011222749}, {2600,0.015734597}, {2650,0.011587678}, {2700,0.011862559}, {2750,0.018677725}, {2800,0.012279621}, {2850,0.012545024}, {2900,0.012625592}, {2950,0.013099526}, {3000,0.016445498}, {3050,0.013454976}, {3100,0.013819905}, {3150,0.014047393}, {3200,0.014289100}, {3250,0.016829384}, {3300,0.014706161}, {3350,0.016981043}, {3400,0.015265403}, {3450,0.020426540}, {3500,0.015691943}, {3550,0.021720379}, {3600,0.016137441}, {3650,0.016545024}, {3700,0.016635071}, {3750,0.016952607}, {3800,0.017104265}, {3850,0.021587678}, {3900,0.017701422}, {3950,0.023350711}, {4000,0.018165877}, {4050,0.023061611}, {4100,0.018644550}, {4150,0.025033175}, {4200,0.019052133}, {4250,0.023853081}, {4300,0.019763033}, {4350,0.019895735}, {4400,0.023744076}, {4450,0.020417062}, {4500,0.023488152}, {4550,0.020909953}, {4600,0.021118483}, {4650,0.028127962}, {4700,0.021706161}, {4750,0.024616114}, {4800,0.028113744}, {4850,0.022426540}, {4900,0.025824645}, {4950,0.027056872}, {5000,0.023194313}, {5050,0.026473934}, {5100,0.028800948}, {5150,0.024042654}, {5200,0.026943128}, {5250,0.029710900}, {5300,0.024777251}, {5350,0.025146919}, {5400,0.036507109}, {5450,0.032426540}, {5500,0.025914692}, {5550,0.030639810}, {5600,0.037933649}, {5650,0.026748815}, {5700,0.026985782}, {5750,0.026516588}, {5800,0.039393365}, {5850,0.033440758}, {5900,0.028023697}, {5950,0.028312796}, {6000,0.032289100}, {6050,0.046578199}, {6100,0.035327014}, {6150,0.029341232}, {6200,0.029526066}, {6250,0.032867299}, {6300,0.037194313}, {6350,0.039834123}, {6400,0.036758294}, {6450,0.030985782}, {6500,0.031246445}, {6550,0.031516588}, {6600,0.035616114}, {6650,0.034037915}, {6700,0.046142180}, {6750,0.047450237}, {6800,0.045744076}, {6850,0.044620853}, {6900,0.033497630}, {6950,0.033691943}, {7000,0.034056872}, {7050,0.034213270}, {7100,0.034630332}, {7150,0.034815166}, {7200,0.039592417}, {7250,0.039037915}, {7300,0.040402844}, {7350,0.040345972}, {7400,0.037876777}, {7450,0.043919431}, {7500,0.044483412}, {7550,0.044748815}, {7600,0.044748815}, {7650,0.039886256}, {7700,0.042919431}, {7750,0.042535545}, {7800,0.043009479}, {7850,0.042691943}, {7900,0.037507109}, {7950,0.039208531}, {8000,0.039592417}, {8050,0.039872038}, {8100,0.040137441}, {8150,0.040578199}, {8200,0.048085308}, {8250,0.055853081}, {8300,0.060421801}, {8350,0.057952607}, {8400,0.054398104}, {8450,0.046246445}, {8500,0.042317536}, {8550,0.042516588}, {8600,0.042824645}, {8650,0.055336493}, {8700,0.065184834}, {8750,0.057056872}, {8800,0.047857820}, {8850,0.044383886}, {8900,0.044625592}, {8950,0.055090047}, {9000,0.065521327}, {9050,0.052658768}, {9100,0.045601896}, {9150,0.046085308}, {9200,0.067952607}, {9250,0.067464455}, {9300,0.055507109}, {9350,0.047047393}, {9400,0.059739336}, {9450,0.068966825}, {9500,0.056881517}, {9550,0.048203791}, {9600,0.078208531}, {9650,0.067966825}, {9700,0.060236967}, {9750,0.060819905}, {9800,0.068023697}, {9850,0.060146919}, {9900,0.050364929}, {9950,0.072156398}, {10000,0.068436019}, {10100,0.051469194}, {10200,0.073540284}, {10300,0.057350711}, {10400,0.053037915}, {10500,0.074943128}, {10600,0.064469194}, {10700,0.077867299}, {10800,0.071312796}, {10900,0.064298578}, {11000,0.072061611}, {11100,0.057014218}, {11200,0.072834123}, {11300,0.058056872}, {11400,0.074966825}, {11500,0.059270142}, {11600,0.072497630}, {11700,0.065559242}, {11800,0.074924171}, {11900,0.085838863}, {12000,0.069672986}, {12100,0.084872038}, {12200,0.063322275}, {12300,0.077767773}, {12400,0.091360190}, {12500,0.071165877}, {12600,0.079815166}, {12700,0.090492891}, {12800,0.072127962}, {12900,0.081407583}, {13000,0.091407583}, {13100,0.076431280}, {13200,0.075909953}, {13300,0.087364929}, {13400,0.093393365}, {13500,0.080398104}, {13600,0.076265403}, {13700,0.083388626}, {13800,0.088834123}, {13900,0.092928910}, {14000,0.101715640}, {14100,0.081099526}, {14200,0.079123223}, {14300,0.076990521}, {14400,0.089606635}, {14500,0.101417062}, {14600,0.092402844}, {14700,0.102331754}, {14800,0.105488152}, {14900,0.104469194}, {15000,0.102521327}, {15100,0.101710900}, {15200,0.101924171}, {15300,0.103454976}, {15400,0.105744076}, {15500,0.106289100}, {15600,0.103578199}, {15700,0.099526066}, {15800,0.101208531}, {15900,0.100701422}, {16000,0.097090047}, {16100,0.099327014}, {16200,0.109791469}, {16300,0.119758294}, {16400,0.108691943}, {16500,0.106303318}, {16600,0.107786730}, {16700,0.104184834}, {16800,0.113194313}, {16900,0.114151659}, {17000,0.107308057}, {17100,0.105914692}, {17200,0.115597156}, {17300,0.116881517}, {17400,0.118341232}, {17500,0.111023697}, {17600,0.116725118}, {17700,0.112151659}, {17800,0.111279621}, {17900,0.118042654}, {18000,0.117668246}, {18100,0.116180095}, {18200,0.111578199}, {18300,0.100668246}, {18400,0.128293839}, {18500,0.118293839}, {18600,0.133355450}, {18700,0.114985782}, {18800,0.126635071}, {18900,0.116369668}, {19000,0.125327014}, {19100,0.117146919}, {19200,0.138170616}, {19300,0.117720379}, {19400,0.135345972}, {19500,0.130260664}, {19600,0.128142180}, {19700,0.133890995}, {19800,0.115677725}, {19900,0.135990521}, {20000,0.124574163}};
data["big_flat"]["Parametricity; beta"]["reif"]["user"] = {{1,0.000232227}, {2,0.000545024}, {3,0.000345972}, {4,0.000473934}, {5,0.000492891}, {6,0.000383886}, {7,0.000502370}, {8,0.000360190}, {9,0.000545024}, {10,0.000421801}, {11,0.000545024}, {12,0.000431280}, {13,0.000478673}, {14,0.000507109}, {15,0.000597156}, {16,0.000540284}, {17,0.000502370}, {18,0.000578199}, {19,0.000488152}, {20,0.000563981}, {21,0.000549763}, {22,0.000582938}, {23,0.000554502}, {24,0.000668246}, {25,0.000445498}, {26,0.000616114}, {27,0.000559242}, {28,0.000559242}, {29,0.000464455}, {30,0.000559242}, {31,0.000445498}, {32,0.000701422}, {33,0.000587678}, {34,0.000563981}, {35,0.000502370}, {36,0.000625592}, {37,0.000554502}, {38,0.000672986}, {39,0.000578199}, {40,0.000597156}, {41,0.000450237}, {42,0.000587678}, {43,0.000388626}, {44,0.000639810}, {45,0.000611374}, {46,0.000563981}, {47,0.000720379}, {48,0.000734597}, {49,0.000573460}, {50,0.000872038}, {51,0.000412322}, {52,0.000682464}, {53,0.000521327}, {54,0.000473934}, {55,0.000862559}, {56,0.000620853}, {57,0.000767773}, {58,0.000492891}, {59,0.000587678}, {60,0.000668246}, {61,0.000592417}, {62,0.000729858}, {63,0.000483412}, {64,0.000597156}, {65,0.000843602}, {66,0.000663507}, {67,0.000819905}, {68,0.000601896}, {69,0.000616114}, {70,0.000805687}, {71,0.000649289}, {72,0.000829384}, {73,0.000725118}, {74,0.000739336}, {75,0.000715640}, {76,0.000625592}, {77,0.000796209}, {78,0.000800948}, {79,0.000668246}, {80,0.000824645}, {81,0.000796209}, {82,0.000601896}, {83,0.000777251}, {84,0.000834123}, {85,0.000715640}, {86,0.000905213}, {87,0.000710900}, {88,0.000715640}, {89,0.000933649}, {90,0.000872038}, {91,0.000739336}, {92,0.000587678}, {93,0.000957346}, {94,0.000995261}, {95,0.000492891}, {96,0.000928910}, {97,0.000862559}, {98,0.000630332}, {99,0.000848341}, {100,0.000853081}, {101,0.000729858}, {102,0.000881517}, {103,0.000829384}, {104,0.000853081}, {105,0.000815166}, {106,0.000829384}, {107,0.000872038}, {108,0.000777251}, {109,0.000706161}, {110,0.000924171}, {111,0.000838863}, {112,0.000805687}, {113,0.000943128}, {114,0.000853081}, {115,0.000947867}, {116,0.000649289}, {117,0.000895735}, {118,0.000952607}, {119,0.000853081}, {120,0.001274882}, {121,0.000744076}, {122,0.001056872}, {123,0.000928910}, {124,0.000706161}, {125,0.001033175}, {126,0.000691943}, {127,0.000952607}, {128,0.000957346}, {129,0.001037915}, {130,0.000772512}, {131,0.000862559}, {132,0.001085308}, {133,0.000933649}, {134,0.000791469}, {135,0.000862559}, {136,0.001018957}, {137,0.001066351}, {138,0.000966825}, {139,0.000876777}, {140,0.000943128}, {141,0.000886256}, {142,0.001071090}, {143,0.000985782}, {144,0.000938389}, {145,0.000867299}, {146,0.001099526}, {147,0.001018957}, {148,0.001042654}, {149,0.000957346}, {150,0.000928910}, {151,0.001090047}, {152,0.001137441}, {153,0.001563981}, {154,0.001616114}, {155,0.001075829}, {156,0.000933649}, {157,0.001104265}, {158,0.001009479}, {159,0.001042654}, {160,0.001189573}, {161,0.000990521}, {162,0.001123223}, {163,0.001151659}, {164,0.001009479}, {165,0.001066351}, {166,0.000928910}, {167,0.001151659}, {168,0.001199052}, {169,0.001165877}, {170,0.001175355}, {171,0.000947867}, {172,0.000872038}, {173,0.001175355}, {174,0.001265403}, {175,0.001094787}, {176,0.001236967}, {177,0.001146919}, {178,0.001061611}, {179,0.001080569}, {180,0.001113744}, {181,0.001123223}, {182,0.001293839}, {183,0.001625592}, {184,0.001383886}, {185,0.001488152}, {186,0.001052133}, {187,0.001156398}, {188,0.001189573}, {189,0.001199052}, {190,0.001094787}, {191,0.001047393}, {192,0.001232227}, {193,0.001113744}, {194,0.001142180}, {195,0.001156398}, {196,0.001090047}, {197,0.001180095}, {198,0.001293839}, {199,0.001308057}, {200,0.001246445}, {201,0.001308057}, {202,0.001350711}, {203,0.001255924}, {204,0.001218009}, {205,0.001322275}, {206,0.001454976}, {207,0.001464455}, {208,0.001364929}, {209,0.001805687}, {210,0.001260664}, {211,0.001066351}, {212,0.001071090}, {213,0.001142180}, {214,0.001132701}, {215,0.001014218}, {216,0.001142180}, {217,0.001061611}, {218,0.001113744}, {219,0.001104265}, {220,0.001109005}, {221,0.001094787}, {222,0.001175355}, {223,0.001213270}, {224,0.001388626}, {225,0.001355450}, {226,0.001322275}, {227,0.001293839}, {228,0.001232227}, {229,0.001151659}, {230,0.001175355}, {231,0.001009479}, {232,0.000962085}, {233,0.002194313}, {234,0.001407583}, {235,0.001426540}, {236,0.001568720}, {237,0.001559242}, {238,0.001540284}, {239,0.001450237}, {240,0.001350711}, {241,0.001236967}, {242,0.001232227}, {243,0.001260664}, {244,0.001161137}, {245,0.001341232}, {246,0.001502370}, {247,0.001398104}, {248,0.001464455}, {249,0.001421801}, {250,0.001180095}, {251,0.001336493}, {252,0.001393365}, {253,0.001194313}, {254,0.001388626}, {255,0.001417062}, {256,0.001630332}, {257,0.001436019}, {258,0.001355450}, {259,0.001379147}, {260,0.001312796}, {261,0.001563981}, {262,0.001526066}, {263,0.001454976}, {264,0.001241706}, {265,0.001208531}, {266,0.001289100}, {267,0.001284360}, {268,0.001355450}, {269,0.001421801}, {270,0.001431280}, {271,0.001563981}, {272,0.001350711}, {273,0.001492891}, {274,0.001630332}, {275,0.001672986}, {276,0.001526066}, {277,0.002047393}, {278,0.001606635}, {279,0.001535545}, {280,0.001421801}, {281,0.001526066}, {282,0.001545024}, {283,0.001682464}, {284,0.001540284}, {285,0.001658768}, {286,0.001559242}, {287,0.001393365}, {288,0.001388626}, {289,0.001592417}, {290,0.001682464}, {291,0.001672986}, {292,0.001606635}, {293,0.001483412}, {294,0.001436019}, {295,0.001502370}, {296,0.001606635}, {297,0.001966825}, {298,0.001412322}, {299,0.001511848}, {300,0.001587678}, {301,0.001691943}, {302,0.001715640}, {303,0.001649289}, {304,0.001663507}, {305,0.001549763}, {306,0.001606635}, {307,0.001739336}, {308,0.001611374}, {309,0.001511848}, {310,0.001630332}, {311,0.001805687}, {312,0.001649289}, {313,0.001630332}, {314,0.001587678}, {315,0.001729858}, {316,0.002023697}, {317,0.001540284}, {318,0.001985782}, {319,0.001867299}, {320,0.001421801}, {321,0.001388626}, {322,0.001753555}, {323,0.001862559}, {324,0.001654028}, {325,0.001753555}, {326,0.001654028}, {327,0.001592417}, {328,0.001748815}, {329,0.001710900}, {330,0.001725118}, {331,0.001886256}, {332,0.001796209}, {333,0.001625592}, {334,0.002289100}, {335,0.001767773}, {336,0.001867299}, {337,0.001535545}, {338,0.001701422}, {339,0.002056872}, {340,0.001853081}, {341,0.001682464}, {342,0.001829384}, {343,0.001687204}, {344,0.001876777}, {345,0.001876777}, {346,0.001601896}, {347,0.001957346}, {348,0.001966825}, {349,0.001578199}, {350,0.002127962}, {351,0.001952607}, {352,0.001772512}, {353,0.002170616}, {354,0.001744076}, {355,0.001696682}, {356,0.001905213}, {357,0.001748815}, {358,0.001966825}, {359,0.001696682}, {360,0.001796209}, {361,0.001867299}, {362,0.001763033}, {363,0.001981043}, {364,0.001924171}, {365,0.001758294}, {366,0.002061611}, {367,0.001838863}, {368,0.002222749}, {369,0.001805687}, {370,0.001824645}, {371,0.001834123}, {372,0.001909953}, {373,0.001853081}, {374,0.001900474}, {375,0.001805687}, {376,0.001876777}, {377,0.001843602}, {378,0.001729858}, {379,0.002018957}, {380,0.001862559}, {381,0.002085308}, {382,0.001777251}, {383,0.002170616}, {384,0.002436019}, {385,0.002156398}, {386,0.001900474}, {387,0.001791469}, {388,0.001952607}, {389,0.001905213}, {390,0.001957346}, {391,0.002004739}, {392,0.001905213}, {393,0.002113744}, {394,0.001995261}, {395,0.001862559}, {396,0.002004739}, {397,0.001890995}, {398,0.002014218}, {399,0.002042654}, {400,0.002350711}, {401,0.002161137}, {402,0.001924171}, {403,0.002113744}, {404,0.002014218}, {405,0.002052133}, {406,0.002099526}, {407,0.001933649}, {408,0.002341232}, {409,0.002009479}, {410,0.002151659}, {411,0.002094787}, {412,0.001928910}, {413,0.002189573}, {414,0.001909953}, {415,0.002701422}, {416,0.002142180}, {417,0.001981043}, {418,0.002071090}, {419,0.002037915}, {420,0.002123223}, {421,0.002203791}, {422,0.002151659}, {423,0.002227488}, {424,0.001976303}, {425,0.002383886}, {426,0.001862559}, {427,0.002270142}, {428,0.002042654}, {429,0.002161137}, {430,0.002156398}, {431,0.002113744}, {432,0.002184834}, {433,0.002113744}, {434,0.002175355}, {435,0.002052133}, {436,0.002203791}, {437,0.002090047}, {438,0.002184834}, {439,0.002146919}, {440,0.002289100}, {441,0.002018957}, {442,0.002218009}, {443,0.002071090}, {444,0.003222749}, {445,0.002639810}, {446,0.002189573}, {447,0.002104265}, {448,0.002246445}, {449,0.002312796}, {450,0.002180095}, {451,0.002289100}, {452,0.001966825}, {453,0.002331754}, {454,0.002037915}, {455,0.002132701}, {456,0.002246445}, {457,0.002189573}, {458,0.003047393}, {459,0.002549763}, {460,0.002308057}, {461,0.002170616}, {462,0.002222749}, {463,0.002327014}, {464,0.002075829}, {465,0.002194313}, {466,0.002459716}, {467,0.002289100}, {468,0.002137441}, {469,0.002473934}, {470,0.002232227}, {471,0.002080569}, {472,0.002383886}, {473,0.002113744}, {474,0.002469194}, {475,0.002222749}, {476,0.002213270}, {477,0.002402844}, {478,0.002407583}, {479,0.002203791}, {480,0.002279621}, {481,0.002232227}, {482,0.002459716}, {483,0.002450237}, {484,0.002203791}, {485,0.002895735}, {486,0.002374408}, {487,0.002322275}, {488,0.002549763}, {489,0.002151659}, {490,0.002364929}, {491,0.002308057}, {492,0.002554502}, {493,0.002350711}, {494,0.002383886}, {495,0.002232227}, {496,0.002601896}, {497,0.002336493}, {498,0.002976303}, {499,0.002715640}, {500,0.002289100}, {505,0.002597156}, {510,0.002355450}, {515,0.002274882}, {520,0.002545024}, {525,0.002592417}, {530,0.002473934}, {535,0.002478673}, {540,0.002445498}, {545,0.002488152}, {550,0.002672986}, {555,0.003184834}, {560,0.002492891}, {565,0.002663507}, {570,0.002668246}, {575,0.002516588}, {580,0.002677725}, {585,0.002440758}, {590,0.002677725}, {595,0.002919431}, {600,0.002872038}, {605,0.002824645}, {610,0.002853081}, {615,0.002758294}, {620,0.002791469}, {625,0.003028436}, {630,0.003118483}, {635,0.002914692}, {640,0.002872038}, {645,0.003061611}, {650,0.002952607}, {655,0.002933649}, {660,0.003473934}, {665,0.003469194}, {670,0.002890995}, {675,0.002943128}, {680,0.003184834}, {685,0.003142180}, {690,0.003066351}, {695,0.003071090}, {700,0.003118483}, {705,0.003189573}, {710,0.003161137}, {715,0.003270142}, {720,0.003132701}, {725,0.003255924}, {730,0.003184834}, {735,0.003364929}, {740,0.003232227}, {745,0.003322275}, {750,0.003393365}, {755,0.004009479}, {760,0.003336493}, {765,0.003383886}, {770,0.003374408}, {775,0.003388626}, {780,0.003488152}, {785,0.003445498}, {790,0.003606635}, {795,0.003568720}, {800,0.003511848}, {805,0.003483412}, {810,0.003573460}, {815,0.003582938}, {820,0.003597156}, {825,0.003644550}, {830,0.003677725}, {835,0.003625592}, {840,0.005080569}, {845,0.003748815}, {850,0.003677725}, {855,0.003862559}, {860,0.003753555}, {865,0.003677725}, {870,0.003810427}, {875,0.003843602}, {880,0.005279621}, {885,0.003796209}, {890,0.003966825}, {895,0.003905213}, {900,0.003890995}, {905,0.003895735}, {910,0.004000000}, {915,0.004009479}, {920,0.003981043}, {925,0.004033175}, {930,0.004113744}, {935,0.004075829}, {940,0.004099526}, {945,0.004132701}, {950,0.004000000}, {955,0.006042654}, {960,0.004104265}, {965,0.004071090}, {970,0.004170616}, {975,0.004104265}, {980,0.004260664}, {985,0.004289100}, {990,0.006080569}, {995,0.004928910}, {1000,0.004488152}, {1010,0.004502370}, {1020,0.004364929}, {1030,0.004331754}, {1040,0.004582938}, {1050,0.006099526}, {1060,0.004478673}, {1070,0.004388626}, {1080,0.004488152}, {1090,0.004810427}, {1100,0.004696682}, {1110,0.004763033}, {1120,0.005952607}, {1130,0.004767773}, {1140,0.004981043}, {1150,0.005090047}, {1160,0.004691943}, {1170,0.005028436}, {1180,0.005094787}, {1190,0.004791469}, {1200,0.005218009}, {1210,0.004995261}, {1220,0.005094787}, {1230,0.005218009}, {1240,0.007014218}, {1250,0.005298578}, {1260,0.005047393}, {1270,0.005450237}, {1280,0.005507109}, {1290,0.007616114}, {1300,0.005364929}, {1310,0.005440758}, {1320,0.005658768}, {1330,0.005781991}, {1340,0.005919431}, {1350,0.008336493}, {1360,0.005729858}, {1370,0.005611374}, {1380,0.005592417}, {1390,0.005890995}, {1400,0.005654028}, {1410,0.005872038}, {1420,0.006018957}, {1430,0.006165877}, {1440,0.006004739}, {1450,0.006142180}, {1460,0.006056872}, {1470,0.006161137}, {1480,0.006279621}, {1490,0.006369668}, {1500,0.009606635}, {1510,0.006009479}, {1520,0.006511848}, {1530,0.006407583}, {1540,0.006592417}, {1550,0.008289100}, {1560,0.006521327}, {1570,0.006568720}, {1580,0.006611374}, {1590,0.007890995}, {1600,0.006606635}, {1610,0.006592417}, {1620,0.006763033}, {1630,0.006962085}, {1640,0.008056872}, {1650,0.006952607}, {1660,0.006767773}, {1670,0.006962085}, {1680,0.008957346}, {1690,0.006943128}, {1700,0.007127962}, {1710,0.007042654}, {1720,0.009255924}, {1730,0.007189573}, {1740,0.007303318}, {1750,0.007327014}, {1760,0.010109005}, {1770,0.007360190}, {1780,0.007436019}, {1790,0.007360190}, {1800,0.010530806}, {1810,0.007516588}, {1820,0.007578199}, {1830,0.007725118}, {1840,0.010625592}, {1850,0.007819905}, {1860,0.007710900}, {1870,0.007767773}, {1880,0.010578199}, {1890,0.007909953}, {1900,0.007947867}, {1910,0.007990521}, {1920,0.010478673}, {1930,0.008421801}, {1940,0.008473934}, {1950,0.008056872}, {1960,0.010810427}, {1970,0.008417062}, {1980,0.008601896}, {1990,0.008445498}, {2000,0.008417062}, {2050,0.008710900}, {2100,0.009018957}, {2150,0.010696682}, {2200,0.009696682}, {2250,0.009445498}, {2300,0.013270142}, {2350,0.010308057}, {2400,0.010469194}, {2450,0.014312796}, {2500,0.011075829}, {2550,0.011445498}, {2600,0.015696682}, {2650,0.011796209}, {2700,0.012118483}, {2750,0.018364929}, {2800,0.012412322}, {2850,0.012601896}, {2900,0.013061611}, {2950,0.013350711}, {3000,0.016194313}, {3050,0.013838863}, {3100,0.013895735}, {3150,0.014189573}, {3200,0.014383886}, {3250,0.016526066}, {3300,0.014829384}, {3350,0.016763033}, {3400,0.015270142}, {3450,0.020094787}, {3500,0.015772512}, {3550,0.021649289}, {3600,0.015971564}, {3650,0.016293839}, {3700,0.016521327}, {3750,0.016720379}, {3800,0.016919431}, {3850,0.021189573}, {3900,0.017345972}, {3950,0.023099526}, {4000,0.017753555}, {4050,0.022867299}, {4100,0.018374408}, {4150,0.024834123}, {4200,0.018763033}, {4250,0.023578199}, {4300,0.019345972}, {4350,0.019578199}, {4400,0.023530806}, {4450,0.020080569}, {4500,0.023298578}, {4550,0.020559242}, {4600,0.020933649}, {4650,0.027947867}, {4700,0.021715640}, {4750,0.024436019}, {4800,0.027952607}, {4850,0.022355450}, {4900,0.025696682}, {4950,0.026928910}, {5000,0.023459716}, {5050,0.026251185}, {5100,0.028900474}, {5150,0.024284360}, {5200,0.026952607}, {5250,0.029668246}, {5300,0.024725118}, {5350,0.025345972}, {5400,0.036364929}, {5450,0.032526066}, {5500,0.025957346}, {5550,0.030748815}, {5600,0.037687204}, {5650,0.026895735}, {5700,0.027056872}, {5750,0.026459716}, {5800,0.039322275}, {5850,0.033042654}, {5900,0.028052133}, {5950,0.028251185}, {6000,0.032454976}, {6050,0.045161137}, {6100,0.035312796}, {6150,0.029236967}, {6200,0.029364929}, {6250,0.032601896}, {6300,0.036834123}, {6350,0.039459716}, {6400,0.036739336}, {6450,0.031023697}, {6500,0.031497630}, {6550,0.031587678}, {6600,0.035398104}, {6650,0.034061611}, {6700,0.045502370}, {6750,0.047298578}, {6800,0.045478673}, {6850,0.044417062}, {6900,0.033800948}, {6950,0.033905213}, {7000,0.034085308}, {7050,0.034241706}, {7100,0.034649289}, {7150,0.034966825}, {7200,0.039540284}, {7250,0.038928910}, {7300,0.040123223}, {7350,0.040289100}, {7400,0.037971564}, {7450,0.043919431}, {7500,0.044440758}, {7550,0.044573460}, {7600,0.044492891}, {7650,0.040047393}, {7700,0.043094787}, {7750,0.042345972}, {7800,0.042819905}, {7850,0.042620853}, {7900,0.037540284}, {7950,0.039071090}, {8000,0.039578199}, {8050,0.039677725}, {8100,0.040123223}, {8150,0.040630332}, {8200,0.047895735}, {8250,0.055383886}, {8300,0.060066351}, {8350,0.057687204}, {8400,0.054052133}, {8450,0.045976303}, {8500,0.042227488}, {8550,0.042265403}, {8600,0.042872038}, {8650,0.054924171}, {8700,0.065436019}, {8750,0.057118483}, {8800,0.047601896}, {8850,0.044369668}, {8900,0.044526066}, {8950,0.054886256}, {9000,0.065383886}, {9050,0.052876777}, {9100,0.045559242}, {9150,0.046094787}, {9200,0.067639810}, {9250,0.067502370}, {9300,0.055260664}, {9350,0.046843602}, {9400,0.059440758}, {9450,0.068545024}, {9500,0.056483412}, {9550,0.047962085}, {9600,0.077364929}, {9650,0.067853081}, {9700,0.059691943}, {9750,0.060786730}, {9800,0.067748815}, {9850,0.059943128}, {9900,0.050000000}, {9950,0.071943128}, {10000,0.067758294}, {10100,0.051260664}, {10200,0.073213270}, {10300,0.057213270}, {10400,0.052881517}, {10500,0.074540284}, {10600,0.064222749}, {10700,0.077454976}, {10800,0.070900474}, {10900,0.064052133}, {11000,0.071672986}, {11100,0.057033175}, {11200,0.072644550}, {11300,0.057928910}, {11400,0.074763033}, {11500,0.059402844}, {11600,0.072227488}, {11700,0.065620853}, {11800,0.074317536}, {11900,0.085635071}, {12000,0.069511848}, {12100,0.084222749}, {12200,0.063436019}, {12300,0.077426540}, {12400,0.090862559}, {12500,0.070971564}, {12600,0.079483412}, {12700,0.089763033}, {12800,0.071758294}, {12900,0.080824645}, {13000,0.090943128}, {13100,0.076180095}, {13200,0.075758294}, {13300,0.087033175}, {13400,0.093151659}, {13500,0.080388626}, {13600,0.076327014}, {13700,0.083033175}, {13800,0.088563981}, {13900,0.092758294}, {14000,0.101298578}, {14100,0.080985782}, {14200,0.078838863}, {14300,0.076639810}, {14400,0.089322275}, {14500,0.100881517}, {14600,0.091947867}, {14700,0.101649289}, {14800,0.104620853}, {14900,0.103521327}, {15000,0.102023697}, {15100,0.101109005}, {15200,0.101303318}, {15300,0.103355450}, {15400,0.105146919}, {15500,0.105914692}, {15600,0.103251185}, {15700,0.099052133}, {15800,0.100620853}, {15900,0.100137441}, {16000,0.096725118}, {16100,0.098559242}, {16200,0.109293839}, {16300,0.119322275}, {16400,0.108360190}, {16500,0.105559242}, {16600,0.107545024}, {16700,0.103834123}, {16800,0.112744076}, {16900,0.113838863}, {17000,0.106810427}, {17100,0.105308057}, {17200,0.115232227}, {17300,0.116720379}, {17400,0.117791469}, {17500,0.110691943}, {17600,0.116696682}, {17700,0.112009479}, {17800,0.111146919}, {17900,0.117928910}, {18000,0.117445498}, {18100,0.116127962}, {18200,0.111350711}, {18300,0.100507109}, {18400,0.127905213}, {18500,0.118232227}, {18600,0.133194313}, {18700,0.114838863}, {18800,0.126454976}, {18900,0.116421801}, {19000,0.125118483}, {19100,0.117104265}, {19200,0.137962085}, {19300,0.117938389}, {19400,0.135445498}, {19500,0.129895735}, {19600,0.128194313}, {19700,0.133834123}, {19800,0.115379147}, {19900,0.135815166}, {20000,0.124669856}};
data["big_flat"]["Parametricity; beta"]["reif"]["system"] = {{1,0.000184834}, {2,0.000071090}, {3,0.000052133}, {4,0.000018957}, {5,0.000037915}, {6,0.000000000}, {7,0.000018957}, {8,0.000018957}, {9,0.000000000}, {10,0.000037915}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000014218}, {16,0.000018957}, {17,0.000018957}, {18,0.000018957}, {19,0.000037915}, {20,0.000018957}, {21,0.000000000}, {22,0.000056872}, {23,0.000000000}, {24,0.000014218}, {25,0.000000000}, {26,0.000018957}, {27,0.000018957}, {28,0.000000000}, {29,0.000000000}, {30,0.000018957}, {31,0.000033175}, {32,0.000000000}, {33,0.000018957}, {34,0.000000000}, {35,0.000018957}, {36,0.000033175}, {37,0.000000000}, {38,0.000037915}, {39,0.000000000}, {40,0.000000000}, {41,0.000018957}, {42,0.000018957}, {43,0.000018957}, {44,0.000018957}, {45,0.000000000}, {46,0.000056872}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000018957}, {53,0.000000000}, {54,0.000018957}, {55,0.000018957}, {56,0.000018957}, {57,0.000018957}, {58,0.000000000}, {59,0.000000000}, {60,0.000014218}, {61,0.000000000}, {62,0.000000000}, {63,0.000018957}, {64,0.000014218}, {65,0.000037915}, {66,0.000018957}, {67,0.000018957}, {68,0.000018957}, {69,0.000000000}, {70,0.000000000}, {71,0.000018957}, {72,0.000000000}, {73,0.000000000}, {74,0.000018957}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000014218}, {79,0.000000000}, {80,0.000018957}, {81,0.000000000}, {82,0.000000000}, {83,0.000018957}, {84,0.000037915}, {85,0.000000000}, {86,0.000018957}, {87,0.000018957}, {88,0.000000000}, {89,0.000018957}, {90,0.000000000}, {91,0.000000000}, {92,0.000018957}, {93,0.000018957}, {94,0.000000000}, {95,0.000018957}, {96,0.000000000}, {97,0.000018957}, {98,0.000033175}, {99,0.000000000}, {100,0.000018957}, {101,0.000018957}, {102,0.000000000}, {103,0.000056872}, {104,0.000037915}, {105,0.000000000}, {106,0.000018957}, {107,0.000018957}, {108,0.000056872}, {109,0.000018957}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000037915}, {116,0.000037915}, {117,0.000000000}, {118,0.000018957}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000018957}, {123,0.000000000}, {124,0.000014218}, {125,0.000018957}, {126,0.000033175}, {127,0.000033175}, {128,0.000000000}, {129,0.000000000}, {130,0.000047393}, {131,0.000000000}, {132,0.000037915}, {133,0.000000000}, {134,0.000037915}, {135,0.000018957}, {136,0.000000000}, {137,0.000018957}, {138,0.000033175}, {139,0.000000000}, {140,0.000018957}, {141,0.000000000}, {142,0.000075829}, {143,0.000000000}, {144,0.000000000}, {145,0.000018957}, {146,0.000018957}, {147,0.000075829}, {148,0.000000000}, {149,0.000018957}, {150,0.000018957}, {151,0.000000000}, {152,0.000014218}, {153,0.000018957}, {154,0.000000000}, {155,0.000014218}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000018957}, {163,0.000000000}, {164,0.000033175}, {165,0.000018957}, {166,0.000018957}, {167,0.000000000}, {168,0.000018957}, {169,0.000037915}, {170,0.000047393}, {171,0.000014218}, {172,0.000000000}, {173,0.000018957}, {174,0.000018957}, {175,0.000037915}, {176,0.000000000}, {177,0.000000000}, {178,0.000037915}, {179,0.000037915}, {180,0.000000000}, {181,0.000033175}, {182,0.000000000}, {183,0.000018957}, {184,0.000018957}, {185,0.000000000}, {186,0.000018957}, {187,0.000014218}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000037915}, {192,0.000018957}, {193,0.000018957}, {194,0.000018957}, {195,0.000018957}, {196,0.000018957}, {197,0.000037915}, {198,0.000037915}, {199,0.000018957}, {200,0.000037915}, {201,0.000000000}, {202,0.000014218}, {203,0.000000000}, {204,0.000018957}, {205,0.000018957}, {206,0.000000000}, {207,0.000018957}, {208,0.000018957}, {209,0.000037915}, {210,0.000000000}, {211,0.000037915}, {212,0.000018957}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000018957}, {218,0.000018957}, {219,0.000000000}, {220,0.000037915}, {221,0.000018957}, {222,0.000000000}, {223,0.000037915}, {224,0.000018957}, {225,0.000000000}, {226,0.000018957}, {227,0.000018957}, {228,0.000000000}, {229,0.000018957}, {230,0.000018957}, {231,0.000018957}, {232,0.000000000}, {233,0.000000000}, {234,0.000018957}, {235,0.000000000}, {236,0.000037915}, {237,0.000014218}, {238,0.000037915}, {239,0.000000000}, {240,0.000018957}, {241,0.000000000}, {242,0.000000000}, {243,0.000018957}, {244,0.000033175}, {245,0.000000000}, {246,0.000000000}, {247,0.000052133}, {248,0.000033175}, {249,0.000033175}, {250,0.000018957}, {251,0.000018957}, {252,0.000018957}, {253,0.000018957}, {254,0.000014218}, {255,0.000052133}, {256,0.000000000}, {257,0.000066351}, {258,0.000056872}, {259,0.000037915}, {260,0.000000000}, {261,0.000000000}, {262,0.000018957}, {263,0.000018957}, {264,0.000056872}, {265,0.000014218}, {266,0.000000000}, {267,0.000018957}, {268,0.000000000}, {269,0.000018957}, {270,0.000000000}, {271,0.000018957}, {272,0.000000000}, {273,0.000037915}, {274,0.000018957}, {275,0.000033175}, {276,0.000000000}, {277,0.000037915}, {278,0.000000000}, {279,0.000000000}, {280,0.000018957}, {281,0.000018957}, {282,0.000037915}, {283,0.000018957}, {284,0.000018957}, {285,0.000000000}, {286,0.000000000}, {287,0.000056872}, {288,0.000075829}, {289,0.000000000}, {290,0.000000000}, {291,0.000037915}, {292,0.000000000}, {293,0.000014218}, {294,0.000037915}, {295,0.000018957}, {296,0.000018957}, {297,0.000056872}, {298,0.000000000}, {299,0.000037915}, {300,0.000000000}, {301,0.000018957}, {302,0.000018957}, {303,0.000000000}, {304,0.000018957}, {305,0.000000000}, {306,0.000000000}, {307,0.000018957}, {308,0.000018957}, {309,0.000033175}, {310,0.000037915}, {311,0.000018957}, {312,0.000000000}, {313,0.000033175}, {314,0.000037915}, {315,0.000000000}, {316,0.000018957}, {317,0.000018957}, {318,0.000000000}, {319,0.000000000}, {320,0.000037915}, {321,0.000018957}, {322,0.000000000}, {323,0.000018957}, {324,0.000018957}, {325,0.000000000}, {326,0.000037915}, {327,0.000000000}, {328,0.000018957}, {329,0.000037915}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000033175}, {335,0.000000000}, {336,0.000037915}, {337,0.000018957}, {338,0.000000000}, {339,0.000018957}, {340,0.000056872}, {341,0.000018957}, {342,0.000000000}, {343,0.000000000}, {344,0.000018957}, {345,0.000018957}, {346,0.000018957}, {347,0.000000000}, {348,0.000000000}, {349,0.000018957}, {350,0.000037915}, {351,0.000018957}, {352,0.000018957}, {353,0.000000000}, {354,0.000018957}, {355,0.000000000}, {356,0.000018957}, {357,0.000037915}, {358,0.000018957}, {359,0.000000000}, {360,0.000056872}, {361,0.000014218}, {362,0.000018957}, {363,0.000000000}, {364,0.000000000}, {365,0.000037915}, {366,0.000000000}, {367,0.000000000}, {368,0.000037915}, {369,0.000033175}, {370,0.000018957}, {371,0.000033175}, {372,0.000037915}, {373,0.000000000}, {374,0.000018957}, {375,0.000000000}, {376,0.000033175}, {377,0.000018957}, {378,0.000000000}, {379,0.000000000}, {380,0.000018957}, {381,0.000033175}, {382,0.000000000}, {383,0.000000000}, {384,0.000037915}, {385,0.000071090}, {386,0.000018957}, {387,0.000000000}, {388,0.000037915}, {389,0.000018957}, {390,0.000018957}, {391,0.000000000}, {392,0.000018957}, {393,0.000037915}, {394,0.000014218}, {395,0.000047393}, {396,0.000014218}, {397,0.000000000}, {398,0.000052133}, {399,0.000000000}, {400,0.000033175}, {401,0.000018957}, {402,0.000018957}, {403,0.000000000}, {404,0.000056872}, {405,0.000018957}, {406,0.000018957}, {407,0.000018957}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000014218}, {412,0.000000000}, {413,0.000018957}, {414,0.000037915}, {415,0.000000000}, {416,0.000000000}, {417,0.000037915}, {418,0.000018957}, {419,0.000018957}, {420,0.000000000}, {421,0.000033175}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000037915}, {430,0.000052133}, {431,0.000000000}, {432,0.000000000}, {433,0.000018957}, {434,0.000033175}, {435,0.000000000}, {436,0.000000000}, {437,0.000018957}, {438,0.000018957}, {439,0.000000000}, {440,0.000037915}, {441,0.000018957}, {442,0.000000000}, {443,0.000018957}, {444,0.000033175}, {445,0.000018957}, {446,0.000014218}, {447,0.000037915}, {448,0.000000000}, {449,0.000000000}, {450,0.000018957}, {451,0.000000000}, {452,0.000018957}, {453,0.000033175}, {454,0.000018957}, {455,0.000000000}, {456,0.000037915}, {457,0.000018957}, {458,0.000018957}, {459,0.000018957}, {460,0.000000000}, {461,0.000000000}, {462,0.000037915}, {463,0.000018957}, {464,0.000037915}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000037915}, {469,0.000018957}, {470,0.000018957}, {471,0.000000000}, {472,0.000000000}, {473,0.000037915}, {474,0.000000000}, {475,0.000018957}, {476,0.000037915}, {477,0.000000000}, {478,0.000037915}, {479,0.000033175}, {480,0.000018957}, {481,0.000000000}, {482,0.000018957}, {483,0.000000000}, {484,0.000018957}, {485,0.000094787}, {486,0.000000000}, {487,0.000018957}, {488,0.000037915}, {489,0.000000000}, {490,0.000018957}, {491,0.000018957}, {492,0.000000000}, {493,0.000018957}, {494,0.000018957}, {495,0.000018957}, {496,0.000037915}, {497,0.000018957}, {498,0.000018957}, {499,0.000018957}, {500,0.000000000}, {505,0.000018957}, {510,0.000037915}, {515,0.000018957}, {520,0.000033175}, {525,0.000018957}, {530,0.000018957}, {535,0.000018957}, {540,0.000014218}, {545,0.000056872}, {550,0.000018957}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000018957}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000018957}, {600,0.000018957}, {605,0.000018957}, {610,0.000028436}, {615,0.000018957}, {620,0.000052133}, {625,0.000075829}, {630,0.000000000}, {635,0.000037915}, {640,0.000033175}, {645,0.000000000}, {650,0.000033175}, {655,0.000018957}, {660,0.000000000}, {665,0.000037915}, {670,0.000071090}, {675,0.000052133}, {680,0.000066351}, {685,0.000000000}, {690,0.000037915}, {695,0.000037915}, {700,0.000000000}, {705,0.000018957}, {710,0.000037915}, {715,0.000000000}, {720,0.000018957}, {725,0.000037915}, {730,0.000075829}, {735,0.000000000}, {740,0.000075829}, {745,0.000000000}, {750,0.000052133}, {755,0.000018957}, {760,0.000000000}, {765,0.000018957}, {770,0.000000000}, {775,0.000018957}, {780,0.000018957}, {785,0.000018957}, {790,0.000000000}, {795,0.000000000}, {800,0.000037915}, {805,0.000056872}, {810,0.000018957}, {815,0.000037915}, {820,0.000033175}, {825,0.000000000}, {830,0.000018957}, {835,0.000075829}, {840,0.000033175}, {845,0.000018957}, {850,0.000018957}, {855,0.000037915}, {860,0.000018957}, {865,0.000033175}, {870,0.000018957}, {875,0.000014218}, {880,0.000075829}, {885,0.000037915}, {890,0.000000000}, {895,0.000018957}, {900,0.000037915}, {905,0.000090047}, {910,0.000033175}, {915,0.000018957}, {920,0.000037915}, {925,0.000018957}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000037915}, {950,0.000018957}, {955,0.000037915}, {960,0.000056872}, {965,0.000018957}, {970,0.000018957}, {975,0.000037915}, {980,0.000000000}, {985,0.000014218}, {990,0.000071090}, {995,0.000018957}, {1000,0.000018957}, {1010,0.000000000}, {1020,0.000018957}, {1030,0.000000000}, {1040,0.000037915}, {1050,0.000037915}, {1060,0.000056872}, {1070,0.000037915}, {1080,0.000018957}, {1090,0.000090047}, {1100,0.000037915}, {1110,0.000000000}, {1120,0.000066351}, {1130,0.000000000}, {1140,0.000033175}, {1150,0.000052133}, {1160,0.000018957}, {1170,0.000037915}, {1180,0.000018957}, {1190,0.000056872}, {1200,0.000037915}, {1210,0.000056872}, {1220,0.000018957}, {1230,0.000000000}, {1240,0.000037915}, {1250,0.000037915}, {1260,0.000037915}, {1270,0.000000000}, {1280,0.000037915}, {1290,0.000132701}, {1300,0.000037915}, {1310,0.000000000}, {1320,0.000018957}, {1330,0.000056872}, {1340,0.000018957}, {1350,0.000000000}, {1360,0.000037915}, {1370,0.000037915}, {1380,0.000018957}, {1390,0.000000000}, {1400,0.000014218}, {1410,0.000000000}, {1420,0.000052133}, {1430,0.000000000}, {1440,0.000018957}, {1450,0.000056872}, {1460,0.000018957}, {1470,0.000000000}, {1480,0.000056872}, {1490,0.000037915}, {1500,0.000132701}, {1510,0.000056872}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000014218}, {1550,0.000075829}, {1560,0.000037915}, {1570,0.000018957}, {1580,0.000018957}, {1590,0.000075829}, {1600,0.000037915}, {1610,0.000052133}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000037915}, {1650,0.000094787}, {1660,0.000075829}, {1670,0.000014218}, {1680,0.000075829}, {1690,0.000037915}, {1700,0.000018957}, {1710,0.000000000}, {1720,0.000090047}, {1730,0.000037915}, {1740,0.000018957}, {1750,0.000018957}, {1760,0.000075829}, {1770,0.000018957}, {1780,0.000018957}, {1790,0.000018957}, {1800,0.000056872}, {1810,0.000071090}, {1820,0.000037915}, {1830,0.000037915}, {1840,0.000109005}, {1850,0.000018957}, {1860,0.000127962}, {1870,0.000018957}, {1880,0.000052133}, {1890,0.000113744}, {1900,0.000000000}, {1910,0.000052133}, {1920,0.000132701}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000056872}, {1960,0.000180095}, {1970,0.000018957}, {1980,0.000033175}, {1990,0.000056872}, {2000,0.000033175}, {2050,0.000037915}, {2100,0.000075829}, {2150,0.000037915}, {2200,0.000018957}, {2250,0.000056872}, {2300,0.000075829}, {2350,0.000018957}, {2400,0.000056872}, {2450,0.000113744}, {2500,0.000037915}, {2550,0.000052133}, {2600,0.000109005}, {2650,0.000037915}, {2700,0.000056872}, {2750,0.000109005}, {2800,0.000037915}, {2850,0.000066351}, {2900,0.000075829}, {2950,0.000056872}, {3000,0.000146919}, {3050,0.000052133}, {3100,0.000014218}, {3150,0.000000000}, {3200,0.000018957}, {3250,0.000113744}, {3300,0.000037915}, {3350,0.000037915}, {3400,0.000037915}, {3450,0.000109005}, {3500,0.000018957}, {3550,0.000037915}, {3600,0.000056872}, {3650,0.000075829}, {3700,0.000075829}, {3750,0.000052133}, {3800,0.000037915}, {3850,0.000151659}, {3900,0.000000000}, {3950,0.000109005}, {4000,0.000071090}, {4050,0.000222749}, {4100,0.000056872}, {4150,0.000189573}, {4200,0.000018957}, {4250,0.000146919}, {4300,0.000109005}, {4350,0.000052133}, {4400,0.000056872}, {4450,0.000033175}, {4500,0.000109005}, {4550,0.000085308}, {4600,0.000037915}, {4650,0.000199052}, {4700,0.000018957}, {4750,0.000037915}, {4800,0.000161137}, {4850,0.000037915}, {4900,0.000189573}, {4950,0.000151659}, {5000,0.000018957}, {5050,0.000127962}, {5100,0.000127962}, {5150,0.000037915}, {5200,0.000000000}, {5250,0.000208531}, {5300,0.000071090}, {5350,0.000014218}, {5400,0.000284360}, {5450,0.000184834}, {5500,0.000052133}, {5550,0.000127962}, {5600,0.000218009}, {5650,0.000075829}, {5700,0.000056872}, {5750,0.000094787}, {5800,0.000279621}, {5850,0.000218009}, {5900,0.000033175}, {5950,0.000018957}, {6000,0.000113744}, {6050,0.001251185}, {6100,0.000104265}, {6150,0.000037915}, {6200,0.000066351}, {6250,0.000127962}, {6300,0.000146919}, {6350,0.000260664}, {6400,0.000109005}, {6450,0.000018957}, {6500,0.000037915}, {6550,0.000075829}, {6600,0.000246445}, {6650,0.000180095}, {6700,0.000407583}, {6750,0.000284360}, {6800,0.000241706}, {6850,0.000293839}, {6900,0.000109005}, {6950,0.000090047}, {7000,0.000094787}, {7050,0.000075829}, {7100,0.000037915}, {7150,0.000037915}, {7200,0.000132701}, {7250,0.000189573}, {7300,0.000170616}, {7350,0.000075829}, {7400,0.000094787}, {7450,0.000170616}, {7500,0.000189573}, {7550,0.000260664}, {7600,0.000255924}, {7650,0.000094787}, {7700,0.000104265}, {7750,0.000094787}, {7800,0.000075829}, {7850,0.000165877}, {7900,0.000037915}, {7950,0.000094787}, {8000,0.000037915}, {8050,0.000056872}, {8100,0.000014218}, {8150,0.000094787}, {8200,0.000336493}, {8250,0.000445498}, {8300,0.000393365}, {8350,0.000232227}, {8400,0.000184834}, {8450,0.000037915}, {8500,0.000018957}, {8550,0.000075829}, {8600,0.000018957}, {8650,0.000265403}, {8700,0.000146919}, {8750,0.000109005}, {8800,0.000094787}, {8850,0.000075829}, {8900,0.000037915}, {8950,0.000331754}, {9000,0.000312796}, {9050,0.000037915}, {9100,0.000052133}, {9150,0.000018957}, {9200,0.000293839}, {9250,0.000308057}, {9300,0.000146919}, {9350,0.000170616}, {9400,0.000265403}, {9450,0.000398104}, {9500,0.000374408}, {9550,0.000018957}, {9600,0.000625592}, {9650,0.000388626}, {9700,0.000459716}, {9750,0.000298578}, {9800,0.000374408}, {9850,0.000208531}, {9900,0.000075829}, {9950,0.000322275}, {10000,0.000691943}, {10100,0.000109005}, {10200,0.000625592}, {10300,0.000336493}, {10400,0.000056872}, {10500,0.000502370}, {10600,0.000308057}, {10700,0.000431280}, {10800,0.000540284}, {10900,0.000165877}, {11000,0.000388626}, {11100,0.000075829}, {11200,0.000445498}, {11300,0.000146919}, {11400,0.000464455}, {11500,0.000000000}, {11600,0.000421801}, {11700,0.000241706}, {11800,0.000516588}, {11900,0.000436019}, {12000,0.000303318}, {12100,0.000469194}, {12200,0.000056872}, {12300,0.000303318}, {12400,0.000582938}, {12500,0.000303318}, {12600,0.000417062}, {12700,0.000696682}, {12800,0.000364929}, {12900,0.000635071}, {13000,0.000388626}, {13100,0.000227488}, {13200,0.000274882}, {13300,0.000203791}, {13400,0.000260664}, {13500,0.000056872}, {13600,0.000146919}, {13700,0.000222749}, {13800,0.000241706}, {13900,0.000293839}, {14000,0.000279621}, {14100,0.000000000}, {14200,0.000203791}, {14300,0.000369668}, {14400,0.000317536}, {14500,0.000450237}, {14600,0.000379147}, {14700,0.000488152}, {14800,0.000611374}, {14900,0.000682464}, {15000,0.000398104}, {15100,0.000459716}, {15200,0.000649289}, {15300,0.000393365}, {15400,0.000317536}, {15500,0.000170616}, {15600,0.000426540}, {15700,0.000412322}, {15800,0.000289100}, {15900,0.000303318}, {16000,0.000298578}, {16100,0.000341232}, {16200,0.000341232}, {16300,0.000374408}, {16400,0.000165877}, {16500,0.000350711}, {16600,0.000104265}, {16700,0.000146919}, {16800,0.000341232}, {16900,0.000208531}, {17000,0.000407583}, {17100,0.000260664}, {17200,0.000407583}, {17300,0.000246445}, {17400,0.000511848}, {17500,0.000208531}, {17600,0.000075829}, {17700,0.000090047}, {17800,0.000165877}, {17900,0.000037915}, {18000,0.000132701}, {18100,0.000037915}, {18200,0.000018957}, {18300,0.000018957}, {18400,0.000000000}, {18500,0.000037915}, {18600,0.000132701}, {18700,0.000056872}, {18800,0.000056872}, {18900,0.000037915}, {19000,0.000056872}, {19100,0.000075829}, {19200,0.000113744}, {19300,0.000094787}, {19400,0.000075829}, {19500,0.000071090}, {19600,0.000037915}, {19700,0.000109005}, {19800,0.000094787}, {19900,0.000037915}, {20000,0.000057416}};
data["big_flat"]["Parsing"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00001724}, {12,0.00000862}, {13,0.00029310}, {14,0.00062931}, {15,0.00093966}, {16,0.00098276}, {17,0.00100000}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00100000}, {23,0.00100000}, {24,0.00100000}, {25,0.00100000}, {26,0.00100862}, {27,0.00100000}, {28,0.00112069}, {29,0.00108621}, {30,0.00137069}, {31,0.00137069}, {32,0.00162069}, {33,0.00300000}, {34,0.00188793}, {35,0.00200000}, {36,0.05306897}, {37,0.00200000}, {38,0.00200000}, {39,0.00200000}, {40,0.00200000}, {41,0.00200000}, {42,0.00200000}, {43,0.00200000}, {44,0.00200000}, {45,0.00200000}, {46,0.00200000}, {47,0.00200000}, {48,0.00200000}, {49,0.00200862}, {50,0.00200862}, {51,0.00202586}, {52,0.00212931}, {53,0.00254310}, {54,0.00283621}, {55,0.00298276}, {56,0.00300000}, {57,0.00300000}, {58,0.00300000}, {59,0.00300000}, {60,0.00300000}, {61,0.00300000}, {62,0.00300000}, {63,0.00300000}, {64,0.05392241}, {65,0.00300000}, {66,0.00300862}, {67,0.00304310}, {68,0.00302586}, {69,0.00318103}, {70,0.00347414}, {71,0.00353448}, {72,0.00393966}, {73,0.00398276}, {74,0.00400000}, {75,0.00400000}, {76,0.00400000}, {77,0.00400000}, {78,0.00400000}, {79,0.00400000}, {80,0.00400000}, {81,0.00400000}, {82,0.00400000}, {83,0.00400000}, {84,0.00403448}, {85,0.00413793}, {86,0.00421552}, {87,0.00475862}, {88,0.00488793}, {89,0.00486207}, {90,0.00498276}, {91,0.00500000}, {92,0.00500000}, {93,0.00500000}, {94,0.00500000}, {95,0.00500000}, {96,0.00500000}, {97,0.00500000}, {98,0.01676724}, {99,0.05568103}, {100,0.00500862}, {101,0.00518103}, {102,0.00540517}, {103,0.00569828}, {104,0.00549138}, {105,0.00535345}, {106,0.00566379}, {107,0.00595690}, {108,0.00599138}, {109,0.00600000}, {110,0.00599138}, {111,0.00600000}, {112,0.00600000}, {113,0.00600000}, {114,0.00600000}, {115,0.00600000}, {116,0.00600862}, {117,0.00600862}, {118,0.00601724}, {119,0.00606897}, {120,0.00646552}, {121,0.00668966}, {122,0.00685345}, {123,0.00689655}, {124,0.00684483}, {125,0.03764655}, {126,0.00698276}, {127,0.00698276}, {128,0.00699138}, {129,0.00700000}, {130,0.00700000}, {131,0.00700000}, {132,0.00700000}, {133,0.00702586}, {134,0.00702586}, {135,0.00709483}, {136,0.03979310}, {137,0.00726724}, {138,0.00777586}, {139,0.00787931}, {140,0.00737931}, {141,0.00725000}, {142,0.00756034}, {143,0.00799138}, {144,0.00795690}, {145,0.00797414}, {146,0.04404310}, {147,0.00799138}, {148,0.00799138}, {149,0.00800000}, {150,0.00800000}, {151,0.00800000}, {152,0.00800000}, {153,0.00800000}, {154,0.00801724}, {155,0.00801724}, {156,0.03825862}, {157,0.00800000}, {158,0.00804310}, {159,0.00819828}, {160,0.00866379}, {161,0.00870690}, {162,0.00887069}, {163,0.00878448}, {164,0.00893966}, {165,0.03956034}, {166,0.00900000}, {167,0.00900000}, {168,0.00900000}, {169,0.00900000}, {170,0.00900862}, {171,0.00901724}, {172,0.00900862}, {173,0.00900000}, {174,0.00903448}, {175,0.00907759}, {176,0.00905172}, {177,0.00934483}, {178,0.00932759}, {179,0.00931897}, {180,0.00981034}, {181,0.00994828}, {182,0.04349138}, {183,0.00993966}, {184,0.00999138}, {185,0.01000000}, {186,0.01000000}, {187,0.00999138}, {188,0.01000000}, {189,0.01000000}, {190,0.04440517}, {191,0.01000862}, {192,0.01000000}, {193,0.01013793}, {194,0.01050000}, {195,0.01060345}, {196,0.01063793}, {197,0.01027586}, {198,0.01081897}, {199,0.01070690}, {200,0.01081897}, {201,0.01093966}, {202,0.01099138}, {203,0.01100000}, {204,0.01100000}, {205,0.01100000}, {206,0.01100000}, {207,0.01100000}, {208,0.01100862}, {209,0.01100000}, {210,0.01101724}, {211,0.01102586}, {212,0.01186207}, {213,0.01189655}, {214,0.01197414}, {215,0.01199138}, {216,0.01199138}, {217,0.01198276}, {218,0.01200862}, {219,0.01200000}, {220,0.01200000}, {221,0.01200000}, {222,0.01200000}, {223,0.01201724}, {224,0.01207759}, {225,0.05762931}, {226,0.01240517}, {227,0.01256034}, {228,0.01244828}, {229,0.01264655}, {230,0.01282759}, {231,0.01293966}, {232,0.01292241}, {233,0.01298276}, {234,0.01299138}, {235,0.01300000}, {236,0.01300000}, {237,0.01301724}, {238,0.04280172}, {239,0.01300000}, {240,0.01304310}, {241,0.01302586}, {242,0.01306897}, {243,0.01312931}, {244,0.04774138}, {245,0.01316379}, {246,0.01362069}, {247,0.01390517}, {248,0.01378448}, {249,0.01362931}, {250,0.04441379}, {251,0.01391379}, {252,0.01394828}, {253,0.01397414}, {254,0.01399138}, {255,0.01400000}, {256,0.05812931}, {257,0.01401724}, {258,0.01403448}, {259,0.01401724}, {260,0.01402586}, {261,0.01421552}, {262,0.01443103}, {263,0.01465517}, {264,0.01469828}, {265,0.01476724}, {266,0.01478448}, {267,0.05667241}, {268,0.01495690}, {269,0.01499138}, {270,0.01498276}, {271,0.01500000}, {272,0.01500000}, {273,0.01500000}, {274,0.01501724}, {275,0.01507759}, {276,0.01509483}, {277,0.01531897}, {278,0.04813793}, {279,0.01528448}, {280,0.01543103}, {281,0.01547414}, {282,0.01503448}, {283,0.01503448}, {284,0.01501724}, {285,0.01506034}, {286,0.01512931}, {287,0.01524138}, {288,0.04181034}, {289,0.01561207}, {290,0.01566379}, {291,0.01576724}, {292,0.01586207}, {293,0.04589655}, {294,0.01597414}, {295,0.01599138}, {296,0.01600000}, {297,0.01600862}, {298,0.04493103}, {299,0.01600000}, {300,0.01601724}, {301,0.01600862}, {302,0.01602586}, {303,0.04791379}, {304,0.01603448}, {305,0.01622414}, {306,0.01633621}, {307,0.01639655}, {308,0.01661207}, {309,0.01666379}, {310,0.01674138}, {311,0.01691379}, {312,0.01690517}, {313,0.01696552}, {314,0.01698276}, {315,0.01697414}, {316,0.01700000}, {317,0.04734483}, {318,0.01700000}, {319,0.01700862}, {320,0.01700862}, {321,0.01706034}, {322,0.04856897}, {323,0.01713793}, {324,0.01735345}, {325,0.01734483}, {326,0.01758621}, {327,0.01756034}, {328,0.01775862}, {329,0.01789655}, {330,0.01791379}, {331,0.05019828}, {332,0.01796552}, {333,0.01799138}, {334,0.01800000}, {335,0.01800862}, {336,0.01800862}, {337,0.01800000}, {338,0.01800862}, {339,0.01802586}, {340,0.05068966}, {341,0.01812931}, {342,0.01814655}, {343,0.01828448}, {344,0.05074138}, {345,0.01841379}, {346,0.01860345}, {347,0.01878448}, {348,0.01884483}, {349,0.01885345}, {350,0.01891379}, {351,0.01893103}, {352,0.01899138}, {353,0.01937931}, {354,0.01948276}, {355,0.01960345}, {356,0.01979310}, {357,0.06564655}, {358,0.01986207}, {359,0.01990517}, {360,0.01994828}, {361,0.07725862}, {362,0.01997414}, {363,0.01998276}, {364,0.02002586}, {365,0.05318966}, {366,0.02007759}, {367,0.02012069}, {368,0.02017241}, {369,0.05262931}, {370,0.02019828}, {371,0.02043966}, {372,0.02046552}, {373,0.05270690}, {374,0.02078448}, {375,0.02079310}, {376,0.02080172}, {377,0.05561207}, {378,0.02093103}, {379,0.02093103}, {380,0.02097414}, {381,0.07463793}, {382,0.02100862}, {383,0.02099138}, {384,0.02100862}, {385,0.08168966}, {386,0.02112931}, {387,0.02125862}, {388,0.02141379}, {389,0.02149138}, {390,0.02150000}, {391,0.02175000}, {392,0.02179310}, {393,0.02174138}, {394,0.02185345}, {395,0.02187069}, {396,0.02193966}, {397,0.02193103}, {398,0.02200000}, {399,0.43366379}, {400,0.02121552}, {401,0.02136207}, {402,0.02159483}, {403,0.04964655}, {404,0.02172414}, {405,0.02180172}, {406,0.02189655}, {407,0.02190517}, {408,0.02194828}, {409,0.02197414}, {410,0.04852586}, {411,0.02200862}, {412,0.02201724}, {413,0.02203448}, {414,0.05203448}, {415,0.02206034}, {416,0.02206034}, {417,0.02208621}, {418,0.02234483}, {419,0.02235345}, {420,0.02247414}, {421,0.05406034}, {422,0.02268966}, {423,0.02275000}, {424,0.02285345}, {425,0.02283621}, {426,0.02287931}, {427,0.02296552}, {428,0.05279310}, {429,0.02299138}, {430,0.02299138}, {431,0.02301724}, {432,0.02300862}, {433,0.02303448}, {434,0.02307759}, {435,0.05302586}, {436,0.02321552}, {437,0.02318966}, {438,0.05401724}, {439,0.02337069}, {440,0.02354310}, {441,0.02370690}, {442,0.02375862}, {443,0.02379310}, {444,0.02390517}, {445,0.05327586}, {446,0.02393966}, {447,0.02397414}, {448,0.05415517}, {449,0.02400862}, {450,0.02401724}, {451,0.02402586}, {452,0.02406034}, {453,0.02412069}, {454,0.02412931}, {455,0.05460345}, {456,0.02437069}, {457,0.02428448}, {458,0.05762931}, {459,0.02456034}, {460,0.02469828}, {461,0.02479310}, {462,0.02484483}, {463,0.02487931}, {464,0.02491379}, {465,0.02495690}, {466,0.02497414}, {467,0.02500000}, {468,0.05435345}, {469,0.02500862}, {470,0.02501724}, {471,0.05183621}, {472,0.02508621}, {473,0.02518103}, {474,0.10650862}, {475,0.02604310}, {476,0.02600862}, {477,0.09671552}, {478,0.02620690}, {479,0.02619828}, {480,0.02638793}, {481,0.02639655}, {482,0.02648276}, {483,0.02670690}, {484,0.02666379}, {485,0.02677586}, {486,0.02680172}, {487,0.02681034}, {488,0.02687931}, {489,0.02687931}, {490,0.02693103}, {491,0.02694828}, {492,0.02698276}, {493,0.02702586}, {494,0.02702586}, {495,0.02706034}, {496,0.02716379}, {497,0.02707759}, {498,0.02723276}, {499,0.02743966}, {500,0.027445887}, {505,0.02782609}, {510,0.02797391}, {515,0.02855652}, {520,0.02886957}, {525,0.02902609}, {530,0.02924348}, {535,0.02969565}, {540,0.02988696}, {545,0.09566087}, {550,0.03046087}, {555,0.03085217}, {560,0.08988696}, {565,0.03118421}, {570,0.03164912}, {575,0.03181579}, {580,0.03201754}, {585,0.09185088}, {590,0.03270175}, {595,0.03288596}, {600,0.03307826}, {605,0.03350877}, {610,0.09338596}, {615,0.03396491}, {620,0.03414035}, {625,0.03458772}, {630,0.03487719}, {635,0.06452632}, {640,0.03559649}, {645,0.07037719}, {650,0.03593860}, {655,0.03625439}, {660,0.03658772}, {665,0.03683333}, {670,0.03702632}, {675,0.03731579}, {680,0.06914035}, {685,0.03787719}, {690,0.06946491}, {695,0.03856140}, {700,0.07136522}, {705,0.03895614}, {710,0.07475439}, {715,0.03964035}, {720,0.03982456}, {725,0.04003509}, {730,0.04032456}, {735,0.04072807}, {740,0.04094737}, {745,0.04108772}, {750,0.04153509}, {755,0.04179825}, {760,0.04195614}, {765,0.04100877}, {770,0.59543860}, {775,0.16792982}, {780,0.04222807}, {785,0.07750877}, {790,0.04269298}, {795,0.07768421}, {800,0.04308696}, {805,0.07581579}, {810,0.04373684}, {815,0.04392105}, {820,0.04412281}, {825,0.04441228}, {830,0.04478947}, {835,0.04497368}, {840,0.08016667}, {845,0.04549123}, {850,0.07754386}, {855,0.04595614}, {860,0.04626316}, {865,0.07644737}, {870,0.04683333}, {875,0.08291228}, {880,0.04733333}, {885,0.04771930}, {890,0.04792982}, {895,0.04814912}, {900,0.08585217}, {905,0.04875439}, {910,0.04891228}, {915,0.08199123}, {920,0.04949123}, {925,0.08450000}, {930,0.05004386}, {935,0.05166667}, {940,0.09599123}, {945,0.05203509}, {950,0.05246491}, {955,0.08544737}, {960,0.05300000}, {965,0.05327193}, {970,0.08724561}, {975,0.05383333}, {980,0.05400877}, {985,0.11636842}, {990,0.05470175}, {995,0.05484211}, {1000,0.12188696}, {1010,0.10900}, {1020,0.05425}, {1030,0.05675}, {1040,0.09975}, {1050,0.06850}, {1060,0.05850}, {1070,0.08550}, {1080,0.09100}, {1090,0.06025}, {1100,0.05925}, {1110,0.08350}, {1120,0.08625}, {1130,0.06075}, {1140,0.06175}, {1150,0.09000}, {1160,0.09750}, {1170,0.06300}, {1180,0.06375}, {1190,0.06375}, {1200,0.12000}, {1210,0.10925}, {1220,0.11125}, {1230,0.06800}, {1240,0.06850}, {1250,0.06925}, {1260,0.10300}, {1270,0.11250}, {1280,0.10600}, {1290,0.07150}, {1300,0.07200}, {1310,0.07250}, {1320,0.07100}, {1330,0.10025}, {1340,0.10375}, {1350,0.16300}, {1360,0.10725}, {1370,0.10925}, {1380,0.11125}, {1390,0.10775}, {1400,0.07575}, {1410,0.07775}, {1420,0.07850}, {1430,0.07900}, {1440,0.07950}, {1450,0.08025}, {1460,0.08025}, {1470,0.08150}, {1480,0.08200}, {1490,0.08250}, {1500,0.09380}, {1510,0.08350}, {1520,0.08475}, {1530,0.08500}, {1540,0.08475}, {1550,0.08625}, {1560,0.08400}, {1570,0.08450}, {1580,0.08550}, {1590,0.12150}, {1600,0.12725}, {1610,0.13275}, {1620,0.24900}, {1630,0.10900}, {1640,0.08850}, {1650,0.09075}, {1660,0.09125}, {1670,0.12825}, {1680,0.13250}, {1690,0.14875}, {1700,0.15325}, {1710,0.14450}, {1720,0.09500}, {1730,0.09450}, {1740,0.15350}, {1750,0.17900}, {1760,0.16700}, {1770,0.13025}, {1780,0.09800}, {1790,0.09825}, {1800,0.15000}, {1810,0.14600}, {1820,0.13300}, {1830,0.09800}, {1840,0.12900}, {1850,0.14550}, {1860,0.14000}, {1870,0.10050}, {1880,0.12925}, {1890,0.14950}, {1900,0.14225}, {1910,0.10250}, {1920,0.12875}, {1930,0.14150}, {1940,0.12525}, {1950,0.13275}, {1960,0.14725}, {1970,0.13600}, {1980,0.10575}, {1990,0.17025}, {2000,0.13620}, {2050,0.16225}, {2100,0.18000}, {2150,0.11950}, {2200,0.16175}, {2250,1.35075}, {2300,0.12750}, {2350,0.17200}, {2400,0.17175}, {2450,0.18450}, {2500,0.17780}, {2550,0.17375}, {2600,0.18175}, {2650,0.18400}, {2700,0.18075}, {2750,0.18800}, {2800,0.19425}, {2850,0.19800}, {2900,0.20275}, {2950,0.23800}, {3000,0.20660}, {3050,0.20575}, {3100,0.21075}, {3150,0.21225}, {3200,0.22125}, {3250,0.29525}, {3300,0.22975}, {3350,0.28025}, {3400,0.28450}, {3450,0.26450}, {3500,0.32400}, {3550,0.29300}, {3600,0.32125}, {3650,0.30525}, {3700,0.27550}, {3750,0.26325}, {3800,0.27150}, {3850,0.26725}, {3900,0.27700}, {3950,0.26200}, {4000,0.27520}, {4050,0.27225}, {4100,0.28000}, {4150,0.27150}, {4200,0.28550}, {4250,0.28875}, {4300,0.29950}, {4350,0.29325}, {4400,0.29925}, {4450,0.30250}, {4500,0.31220}, {4550,0.30600}, {4600,1.78550}, {4650,0.31950}, {4700,0.39275}, {4750,0.38575}, {4800,0.41000}, {4850,0.38325}, {4900,0.41100}, {4950,0.39525}, {5000,0.34240}};
data["big_flat"]["Parsing"]["actual reif"]["user"] = {{1,0.00000000}, {2,0.00002586}, {3,0.00032759}, {4,0.00031897}, {5,0.00024138}, {6,0.00046552}, {7,0.00050862}, {8,0.00078448}, {9,0.00062069}, {10,0.00077586}, {11,0.00066379}, {12,0.00088793}, {13,0.00080172}, {14,0.00093103}, {15,0.00125000}, {16,0.00089655}, {17,0.00100000}, {18,0.00118966}, {19,0.00120690}, {20,0.00131034}, {21,0.00141379}, {22,0.00157759}, {23,0.00155172}, {24,0.00150000}, {25,0.00160345}, {26,0.00183621}, {27,0.00185345}, {28,0.00169828}, {29,0.00162069}, {30,0.00133621}, {31,0.00166379}, {32,0.00178448}, {33,0.00323276}, {34,0.00170690}, {35,0.00218103}, {36,0.05109483}, {37,0.00212069}, {38,0.00206897}, {39,0.00209483}, {40,0.00233621}, {41,0.00224138}, {42,0.00224138}, {43,0.00250000}, {44,0.00236207}, {45,0.00255172}, {46,0.00268103}, {47,0.00247414}, {48,0.00243966}, {49,0.00253448}, {50,0.00277586}, {51,0.00302586}, {52,0.00300000}, {53,0.00286207}, {54,0.00324138}, {55,0.00292241}, {56,0.00312069}, {57,0.00319828}, {58,0.00327586}, {59,0.00324138}, {60,0.00327586}, {61,0.00330172}, {62,0.00331034}, {63,0.00330172}, {64,0.05393966}, {65,0.00377586}, {66,0.00384483}, {67,0.00373276}, {68,0.00364655}, {69,0.00389655}, {70,0.00381897}, {71,0.00394828}, {72,0.00406897}, {73,0.00417241}, {74,0.00419828}, {75,0.00423276}, {76,0.00431034}, {77,0.00434483}, {78,0.00437931}, {79,0.00443966}, {80,0.00450000}, {81,0.00444828}, {82,0.00436207}, {83,0.00483621}, {84,0.00475862}, {85,0.00451724}, {86,0.00509483}, {87,0.00473276}, {88,0.00492241}, {89,0.00516379}, {90,0.00524138}, {91,0.00510345}, {92,0.00520690}, {93,0.00529310}, {94,0.00519828}, {95,0.00537931}, {96,0.00548276}, {97,0.00562069}, {98,0.01737931}, {99,0.05550862}, {100,0.00558621}, {101,0.00559483}, {102,0.00556034}, {103,0.00600000}, {104,0.00629310}, {105,0.00615517}, {106,0.00611207}, {107,0.00616379}, {108,0.00568966}, {109,0.00606897}, {110,0.00648276}, {111,0.00613793}, {112,0.00634483}, {113,0.00639655}, {114,0.00650000}, {115,0.00651724}, {116,0.00643103}, {117,0.00658621}, {118,0.00663793}, {119,0.00659483}, {120,0.00677586}, {121,0.00688793}, {122,0.00703448}, {123,0.00710345}, {124,0.00706897}, {125,0.03755172}, {126,0.00706897}, {127,0.00748276}, {128,0.00734483}, {129,0.00744828}, {130,0.00737931}, {131,0.00758621}, {132,0.00751724}, {133,0.00779310}, {134,0.00771552}, {135,0.00766379}, {136,0.03905172}, {137,0.00773276}, {138,0.00812069}, {139,0.00798276}, {140,0.00772414}, {141,0.00782759}, {142,0.00795690}, {143,0.00816379}, {144,0.00823276}, {145,0.00811207}, {146,0.04338793}, {147,0.00817241}, {148,0.00848276}, {149,0.00824138}, {150,0.00827586}, {151,0.00848276}, {152,0.00844828}, {153,0.00813793}, {154,0.00865517}, {155,0.00872414}, {156,0.03834483}, {157,0.00865517}, {158,0.00879310}, {159,0.00888793}, {160,0.00906897}, {161,0.00898276}, {162,0.00888793}, {163,0.00877586}, {164,0.00893966}, {165,0.03937069}, {166,0.00928448}, {167,0.00931034}, {168,0.00935345}, {169,0.00926724}, {170,0.00910345}, {171,0.00968966}, {172,0.00979310}, {173,0.00993103}, {174,0.00968966}, {175,0.00993103}, {176,0.01006897}, {177,0.01006897}, {178,0.00979310}, {179,0.00965517}, {180,0.00974138}, {181,0.01002586}, {182,0.04305172}, {183,0.00974138}, {184,0.00989655}, {185,0.01018966}, {186,0.01016379}, {187,0.01030172}, {188,0.01031897}, {189,0.01029310}, {190,0.04461207}, {191,0.01043966}, {192,0.01057759}, {193,0.01089655}, {194,0.01096552}, {195,0.01106897}, {196,0.01082759}, {197,0.01086207}, {198,0.01082759}, {199,0.01083621}, {200,0.01085345}, {201,0.01096552}, {202,0.01098276}, {203,0.01140517}, {204,0.01120690}, {205,0.01112069}, {206,0.01108621}, {207,0.01151724}, {208,0.01171552}, {209,0.01148276}, {210,0.01168966}, {211,0.01165517}, {212,0.01196552}, {213,0.01190517}, {214,0.01191379}, {215,0.01200000}, {216,0.01177586}, {217,0.01194828}, {218,0.01193966}, {219,0.01214655}, {220,0.01267241}, {221,0.01245690}, {222,0.01240517}, {223,0.01270690}, {224,0.01278448}, {225,0.05731897}, {226,0.01217241}, {227,0.01261207}, {228,0.01244828}, {229,0.01242241}, {230,0.01263793}, {231,0.01253448}, {232,0.01265517}, {233,0.01292241}, {234,0.01299138}, {235,0.01283621}, {236,0.01300000}, {237,0.01306897}, {238,0.04261207}, {239,0.01295690}, {240,0.01330172}, {241,0.01324138}, {242,0.01331897}, {243,0.01337931}, {244,0.04741379}, {245,0.01364655}, {246,0.01358621}, {247,0.01390517}, {248,0.01388793}, {249,0.01372414}, {250,0.04443103}, {251,0.01409483}, {252,0.01357759}, {253,0.01394828}, {254,0.01389655}, {255,0.01408621}, {256,0.05778448}, {257,0.01427586}, {258,0.01447414}, {259,0.01453448}, {260,0.01460345}, {261,0.01459483}, {262,0.01506897}, {263,0.01439655}, {264,0.01486207}, {265,0.01487069}, {266,0.01478448}, {267,0.05624138}, {268,0.01467241}, {269,0.01527586}, {270,0.01502586}, {271,0.01507759}, {272,0.01537931}, {273,0.01537069}, {274,0.01527586}, {275,0.01538793}, {276,0.01549138}, {277,0.01579310}, {278,0.04821552}, {279,0.01573276}, {280,0.01581034}, {281,0.01590517}, {282,0.01550000}, {283,0.01548276}, {284,0.01559483}, {285,0.01564655}, {286,0.01580172}, {287,0.01583621}, {288,0.04157759}, {289,0.01574138}, {290,0.01593103}, {291,0.01587931}, {292,0.01608621}, {293,0.04550862}, {294,0.01610345}, {295,0.01631897}, {296,0.01629310}, {297,0.01628448}, {298,0.04433621}, {299,0.01637931}, {300,0.01643966}, {301,0.01635345}, {302,0.01625862}, {303,0.04697414}, {304,0.01647414}, {305,0.01662931}, {306,0.01673276}, {307,0.01635345}, {308,0.01662069}, {309,0.01680172}, {310,0.01660345}, {311,0.01710345}, {312,0.01698276}, {313,0.01689655}, {314,0.01689655}, {315,0.01694828}, {316,0.01707759}, {317,0.04696552}, {318,0.01710345}, {319,0.01733621}, {320,0.01706034}, {321,0.01726724}, {322,0.04831034}, {323,0.01747414}, {324,0.01731034}, {325,0.01735345}, {326,0.01763793}, {327,0.01748276}, {328,0.01752586}, {329,0.01775862}, {330,0.01778448}, {331,0.04980172}, {332,0.01773276}, {333,0.01787069}, {334,0.01797414}, {335,0.01820690}, {336,0.01808621}, {337,0.01806034}, {338,0.01790517}, {339,0.01801724}, {340,0.05003448}, {341,0.01809483}, {342,0.01831034}, {343,0.01814655}, {344,0.05012069}, {345,0.01816379}, {346,0.01831034}, {347,0.01850862}, {348,0.01844828}, {349,0.01840517}, {350,0.01850862}, {351,0.01854310}, {352,0.01844828}, {353,0.01906897}, {354,0.01919828}, {355,0.01924138}, {356,0.01950862}, {357,0.06552586}, {358,0.01932759}, {359,0.01930172}, {360,0.01943966}, {361,0.07721552}, {362,0.01946552}, {363,0.01943966}, {364,0.01984483}, {365,0.05230172}, {366,0.01983621}, {367,0.02000000}, {368,0.01981034}, {369,0.05194828}, {370,0.01981034}, {371,0.02008621}, {372,0.02000000}, {373,0.05219828}, {374,0.01995690}, {375,0.02000000}, {376,0.02079310}, {377,0.05468966}, {378,0.02034483}, {379,0.02051724}, {380,0.02057759}, {381,0.07412069}, {382,0.02027586}, {383,0.02111207}, {384,0.02106034}, {385,0.08083621}, {386,0.02112931}, {387,0.02069828}, {388,0.02075862}, {389,0.02121552}, {390,0.02143103}, {391,0.02153448}, {392,0.02158621}, {393,0.02126724}, {394,0.02123276}, {395,0.02141379}, {396,0.02150862}, {397,0.02168966}, {398,0.02173276}, {399,0.42562069}, {400,0.02039655}, {401,0.02089655}, {402,0.02129310}, {403,0.04884483}, {404,0.02165517}, {405,0.02191379}, {406,0.02144828}, {407,0.02119828}, {408,0.02150000}, {409,0.02150000}, {410,0.04782759}, {411,0.02159483}, {412,0.02187931}, {413,0.02184483}, {414,0.05107759}, {415,0.02143966}, {416,0.02200000}, {417,0.02181897}, {418,0.02208621}, {419,0.02212931}, {420,0.02211207}, {421,0.05366379}, {422,0.02237069}, {423,0.02250862}, {424,0.02205172}, {425,0.02235345}, {426,0.02225000}, {427,0.02281897}, {428,0.05218103}, {429,0.02248276}, {430,0.02278448}, {431,0.02294828}, {432,0.02290517}, {433,0.02310345}, {434,0.02278448}, {435,0.05265517}, {436,0.02328448}, {437,0.02289655}, {438,0.05333621}, {439,0.02328448}, {440,0.02332759}, {441,0.02343966}, {442,0.02337069}, {443,0.02360345}, {444,0.02404310}, {445,0.05246552}, {446,0.02368103}, {447,0.02366379}, {448,0.05356034}, {449,0.02376724}, {450,0.02376724}, {451,0.02381897}, {452,0.02425000}, {453,0.02444828}, {454,0.02429310}, {455,0.05402586}, {456,0.02416379}, {457,0.02430172}, {458,0.05695690}, {459,0.02445690}, {460,0.02468966}, {461,0.02450000}, {462,0.02442241}, {463,0.02464655}, {464,0.02468966}, {465,0.02477586}, {466,0.02463793}, {467,0.02503448}, {468,0.05444828}, {469,0.02463793}, {470,0.02530172}, {471,0.05144828}, {472,0.02519828}, {473,0.02500862}, {474,0.10595690}, {475,0.02590517}, {476,0.02600862}, {477,0.09630172}, {478,0.02612931}, {479,0.02622414}, {480,0.02634483}, {481,0.02630172}, {482,0.02656034}, {483,0.02647414}, {484,0.02646552}, {485,0.02643966}, {486,0.02653448}, {487,0.02668966}, {488,0.02675000}, {489,0.02665517}, {490,0.02681897}, {491,0.02687931}, {492,0.02672414}, {493,0.02668966}, {494,0.02687931}, {495,0.02693103}, {496,0.02699138}, {497,0.02710345}, {498,0.02715517}, {499,0.02734483}, {500,0.027030303}, {505,0.02737391}, {510,0.02774783}, {515,0.02837391}, {520,0.02875652}, {525,0.02893043}, {530,0.02913913}, {535,0.02936522}, {540,0.02982609}, {545,0.09458261}, {550,0.03043478}, {555,0.03086957}, {560,0.08890435}, {565,0.03133333}, {570,0.03180702}, {575,0.03200877}, {580,0.03202632}, {585,0.09111404}, {590,0.03292105}, {595,0.03306140}, {600,0.03321739}, {605,0.03350000}, {610,0.09278947}, {615,0.03406140}, {620,0.03424561}, {625,0.03446491}, {630,0.03487719}, {635,0.06383333}, {640,0.03541228}, {645,0.06981579}, {650,0.03571053}, {655,0.03600000}, {660,0.03634211}, {665,0.03663158}, {670,0.03671930}, {675,0.03717544}, {680,0.06853509}, {685,0.03726316}, {690,0.06852632}, {695,0.03830702}, {700,0.07066957}, {705,0.03848246}, {710,0.07433333}, {715,0.03907895}, {720,0.03939474}, {725,0.03969298}, {730,0.04014035}, {735,0.04013158}, {740,0.04067544}, {745,0.04104386}, {750,0.04144737}, {755,0.04157018}, {760,0.04191228}, {765,0.04074561}, {770,0.58740351}, {775,0.16233333}, {780,0.04177193}, {785,0.07628947}, {790,0.04264912}, {795,0.07656140}, {800,0.04300870}, {805,0.07492105}, {810,0.04373684}, {815,0.04402632}, {820,0.04440351}, {825,0.04436842}, {830,0.04446491}, {835,0.04493860}, {840,0.07882456}, {845,0.04539474}, {850,0.07685965}, {855,0.04597368}, {860,0.04604386}, {865,0.07623684}, {870,0.04669298}, {875,0.08211404}, {880,0.04722807}, {885,0.04751754}, {890,0.04764912}, {895,0.04803509}, {900,0.08586087}, {905,0.04797368}, {910,0.04861404}, {915,0.08122807}, {920,0.04931579}, {925,0.08376316}, {930,0.04944737}, {935,0.05089474}, {940,0.09518421}, {945,0.05152632}, {950,0.05185088}, {955,0.08456140}, {960,0.05225439}, {965,0.05284211}, {970,0.08638596}, {975,0.05343860}, {980,0.05333333}, {985,0.11570175}, {990,0.05424561}, {995,0.05453509}, {1000,0.12090435}, {1010,0.10250}, {1020,0.05475}, {1030,0.05725}, {1040,0.09625}, {1050,0.06750}, {1060,0.05975}, {1070,0.08475}, {1080,0.08850}, {1090,0.06100}, {1100,0.05950}, {1110,0.08250}, {1120,0.08600}, {1130,0.06100}, {1140,0.06200}, {1150,0.09000}, {1160,0.09575}, {1170,0.06250}, {1180,0.06400}, {1190,0.06400}, {1200,0.11650}, {1210,0.10875}, {1220,0.10900}, {1230,0.06800}, {1240,0.06750}, {1250,0.06775}, {1260,0.10275}, {1270,0.11200}, {1280,0.10425}, {1290,0.07075}, {1300,0.07175}, {1310,0.07300}, {1320,0.07175}, {1330,0.09900}, {1340,0.10175}, {1350,0.16050}, {1360,0.10550}, {1370,0.10950}, {1380,0.10975}, {1390,0.10700}, {1400,0.07575}, {1410,0.07775}, {1420,0.07825}, {1430,0.08000}, {1440,0.08075}, {1450,0.07950}, {1460,0.08000}, {1470,0.08100}, {1480,0.08150}, {1490,0.08150}, {1500,0.09320}, {1510,0.08150}, {1520,0.08400}, {1530,0.08550}, {1540,0.08400}, {1550,0.08750}, {1560,0.08350}, {1570,0.08400}, {1580,0.08700}, {1590,0.12075}, {1600,0.12550}, {1610,0.12925}, {1620,0.24425}, {1630,0.10650}, {1640,0.08750}, {1650,0.08750}, {1660,0.09250}, {1670,0.12700}, {1680,0.13100}, {1690,0.14450}, {1700,0.14525}, {1710,0.14025}, {1720,0.09600}, {1730,0.09375}, {1740,0.14975}, {1750,0.17400}, {1760,0.15875}, {1770,0.12575}, {1780,0.10025}, {1790,0.09850}, {1800,0.14550}, {1810,0.13875}, {1820,0.12600}, {1830,0.09925}, {1840,0.12050}, {1850,0.13850}, {1860,0.13150}, {1870,0.09950}, {1880,0.12550}, {1890,0.14225}, {1900,0.13775}, {1910,0.09950}, {1920,0.12850}, {1930,0.14125}, {1940,0.12450}, {1950,0.13050}, {1960,0.14600}, {1970,0.13500}, {1980,0.10575}, {1990,0.16500}, {2000,0.13180}, {2050,0.15750}, {2100,0.17225}, {2150,0.11875}, {2200,0.15550}, {2250,1.25775}, {2300,0.12675}, {2350,0.16550}, {2400,0.16625}, {2450,0.17825}, {2500,0.17520}, {2550,0.16775}, {2600,0.17625}, {2650,0.17575}, {2700,0.17725}, {2750,0.18075}, {2800,0.18950}, {2850,0.18700}, {2900,0.19650}, {2950,0.22575}, {3000,0.20020}, {3050,0.20300}, {3100,0.20975}, {3150,0.21350}, {3200,0.21025}, {3250,0.28475}, {3300,0.22225}, {3350,0.26650}, {3400,0.27750}, {3450,0.25525}, {3500,0.31020}, {3550,0.28425}, {3600,0.30250}, {3650,0.29925}, {3700,0.26875}, {3750,0.25350}, {3800,0.26575}, {3850,0.25925}, {3900,0.26725}, {3950,0.25200}, {4000,0.26760}, {4050,0.26175}, {4100,0.26725}, {4150,0.26250}, {4200,0.26675}, {4250,0.28100}, {4300,0.28625}, {4350,0.28200}, {4400,0.28850}, {4450,0.28850}, {4500,0.30020}, {4550,0.29700}, {4600,1.59275}, {4650,0.31150}, {4700,0.38650}, {4750,0.38450}, {4800,0.38125}, {4850,0.38350}, {4900,0.40825}, {4950,0.39050}, {5000,0.34100}};
data["big_flat"]["Parsing"]["actual reif"]["system"] = {{1,0.00023276}, {2,0.00006897}, {3,0.00000000}, {4,0.00003448}, {5,0.00000000}, {6,0.00006034}, {7,0.00006897}, {8,0.00008621}, {9,0.00003448}, {10,0.00003448}, {11,0.00012069}, {12,0.00009483}, {13,0.00006034}, {14,0.00008621}, {15,0.00003448}, {16,0.00010345}, {17,0.00010345}, {18,0.00006034}, {19,0.00012931}, {20,0.00013793}, {21,0.00005172}, {22,0.00019828}, {23,0.00017241}, {24,0.00012931}, {25,0.00023276}, {26,0.00017241}, {27,0.00006034}, {28,0.00021552}, {29,0.00006897}, {30,0.00020690}, {31,0.00017241}, {32,0.00018966}, {33,0.00022414}, {34,0.00022414}, {35,0.00011207}, {36,0.00178448}, {37,0.00009483}, {38,0.00000000}, {39,0.00003448}, {40,0.00000000}, {41,0.00000000}, {42,0.00003448}, {43,0.00003448}, {44,0.00006897}, {45,0.00003448}, {46,0.00003448}, {47,0.00002586}, {48,0.00000000}, {49,0.00000000}, {50,0.00003448}, {51,0.00000000}, {52,0.00003448}, {53,0.00000000}, {54,0.00003448}, {55,0.00000000}, {56,0.00003448}, {57,0.00000000}, {58,0.00000000}, {59,0.00003448}, {60,0.00003448}, {61,0.00006034}, {62,0.00000000}, {63,0.00013793}, {64,0.00038793}, {65,0.00000000}, {66,0.00006034}, {67,0.00000000}, {68,0.00003448}, {69,0.00000000}, {70,0.00010345}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00006034}, {75,0.00003448}, {76,0.00003448}, {77,0.00003448}, {78,0.00006897}, {79,0.00002586}, {80,0.00002586}, {81,0.00006034}, {82,0.00006034}, {83,0.00000000}, {84,0.00022414}, {85,0.00017241}, {86,0.00000000}, {87,0.00006897}, {88,0.00002586}, {89,0.00000000}, {90,0.00003448}, {91,0.00002586}, {92,0.00000000}, {93,0.00003448}, {94,0.00006897}, {95,0.00010345}, {96,0.00002586}, {97,0.00000000}, {98,0.00010345}, {99,0.00059483}, {100,0.00006897}, {101,0.00009483}, {102,0.00006034}, {103,0.00012931}, {104,0.00000000}, {105,0.00003448}, {106,0.00006034}, {107,0.00006897}, {108,0.00011207}, {109,0.00006034}, {110,0.00005172}, {111,0.00006034}, {112,0.00003448}, {113,0.00015517}, {114,0.00002586}, {115,0.00003448}, {116,0.00003448}, {117,0.00006034}, {118,0.00003448}, {119,0.00002586}, {120,0.00006897}, {121,0.00006897}, {122,0.00006897}, {123,0.00003448}, {124,0.00000000}, {125,0.00053448}, {126,0.00015517}, {127,0.00003448}, {128,0.00003448}, {129,0.00000000}, {130,0.00002586}, {131,0.00012931}, {132,0.00000000}, {133,0.00006897}, {134,0.00003448}, {135,0.00000000}, {136,0.00062069}, {137,0.00007759}, {138,0.00000000}, {139,0.00006897}, {140,0.00007759}, {141,0.00000000}, {142,0.00002586}, {143,0.00006034}, {144,0.00002586}, {145,0.00002586}, {146,0.00102586}, {147,0.00009483}, {148,0.00015517}, {149,0.00006897}, {150,0.00002586}, {151,0.00006034}, {152,0.00006897}, {153,0.00010345}, {154,0.00003448}, {155,0.00009483}, {156,0.00050000}, {157,0.00012931}, {158,0.00003448}, {159,0.00003448}, {160,0.00003448}, {161,0.00003448}, {162,0.00003448}, {163,0.00006034}, {164,0.00010345}, {165,0.00050000}, {166,0.00013793}, {167,0.00005172}, {168,0.00000000}, {169,0.00000000}, {170,0.00006897}, {171,0.00003448}, {172,0.00015517}, {173,0.00003448}, {174,0.00022414}, {175,0.00003448}, {176,0.00000000}, {177,0.00002586}, {178,0.00008621}, {179,0.00022414}, {180,0.00017241}, {181,0.00006034}, {182,0.00052586}, {183,0.00010345}, {184,0.00010345}, {185,0.00005172}, {186,0.00003448}, {187,0.00006897}, {188,0.00000000}, {189,0.00000000}, {190,0.00046552}, {191,0.00009483}, {192,0.00006897}, {193,0.00000000}, {194,0.00006897}, {195,0.00003448}, {196,0.00010345}, {197,0.00000000}, {198,0.00022414}, {199,0.00016379}, {200,0.00010345}, {201,0.00013793}, {202,0.00000000}, {203,0.00003448}, {204,0.00006034}, {205,0.00010345}, {206,0.00023276}, {207,0.00002586}, {208,0.00006897}, {209,0.00003448}, {210,0.00012931}, {211,0.00003448}, {212,0.00006897}, {213,0.00003448}, {214,0.00006034}, {215,0.00010345}, {216,0.00009483}, {217,0.00010345}, {218,0.00017241}, {219,0.00006034}, {220,0.00010345}, {221,0.00013793}, {222,0.00006897}, {223,0.00013793}, {224,0.00010345}, {225,0.00039655}, {226,0.00019828}, {227,0.00006034}, {228,0.00009483}, {229,0.00003448}, {230,0.00009483}, {231,0.00012931}, {232,0.00003448}, {233,0.00006897}, {234,0.00006897}, {235,0.00012931}, {236,0.00009483}, {237,0.00006897}, {238,0.00043966}, {239,0.00013793}, {240,0.00016379}, {241,0.00006897}, {242,0.00010345}, {243,0.00012931}, {244,0.00050000}, {245,0.00002586}, {246,0.00019828}, {247,0.00013793}, {248,0.00006897}, {249,0.00012931}, {250,0.00039655}, {251,0.00000000}, {252,0.00006897}, {253,0.00006897}, {254,0.00003448}, {255,0.00003448}, {256,0.00024138}, {257,0.00018966}, {258,0.00003448}, {259,0.00003448}, {260,0.00000000}, {261,0.00003448}, {262,0.00016379}, {263,0.00026724}, {264,0.00017241}, {265,0.00010345}, {266,0.00003448}, {267,0.00067241}, {268,0.00010345}, {269,0.00010345}, {270,0.00006034}, {271,0.00020690}, {272,0.00016379}, {273,0.00006897}, {274,0.00009483}, {275,0.00010345}, {276,0.00010345}, {277,0.00012931}, {278,0.00037931}, {279,0.00016379}, {280,0.00006897}, {281,0.00017241}, {282,0.00017241}, {283,0.00018966}, {284,0.00000000}, {285,0.00003448}, {286,0.00003448}, {287,0.00006897}, {288,0.00034483}, {289,0.00017241}, {290,0.00005172}, {291,0.00013793}, {292,0.00000000}, {293,0.00052586}, {294,0.00012931}, {295,0.00006897}, {296,0.00003448}, {297,0.00013793}, {298,0.00074138}, {299,0.00013793}, {300,0.00002586}, {301,0.00013793}, {302,0.00019828}, {303,0.00095690}, {304,0.00012069}, {305,0.00023276}, {306,0.00013793}, {307,0.00022414}, {308,0.00039655}, {309,0.00016379}, {310,0.00022414}, {311,0.00014655}, {312,0.00015517}, {313,0.00009483}, {314,0.00025862}, {315,0.00012931}, {316,0.00018966}, {317,0.00061207}, {318,0.00019828}, {319,0.00013793}, {320,0.00018103}, {321,0.00017241}, {322,0.00057759}, {323,0.00009483}, {324,0.00024138}, {325,0.00020690}, {326,0.00012931}, {327,0.00012931}, {328,0.00020690}, {329,0.00017241}, {330,0.00003448}, {331,0.00051724}, {332,0.00017241}, {333,0.00017241}, {334,0.00013793}, {335,0.00012069}, {336,0.00017241}, {337,0.00009483}, {338,0.00019828}, {339,0.00009483}, {340,0.00064655}, {341,0.00019828}, {342,0.00003448}, {343,0.00012931}, {344,0.00062069}, {345,0.00006034}, {346,0.00024138}, {347,0.00009483}, {348,0.00017241}, {349,0.00010345}, {350,0.00010345}, {351,0.00016379}, {352,0.00012931}, {353,0.00010345}, {354,0.00006897}, {355,0.00003448}, {356,0.00006897}, {357,0.00013793}, {358,0.00006034}, {359,0.00010345}, {360,0.00006034}, {361,0.00034483}, {362,0.00025862}, {363,0.00000000}, {364,0.00012931}, {365,0.00081034}, {366,0.00017241}, {367,0.00018966}, {368,0.00017241}, {369,0.00081034}, {370,0.00006897}, {371,0.00013793}, {372,0.00006897}, {373,0.00074138}, {374,0.00017241}, {375,0.00024138}, {376,0.00006897}, {377,0.00097414}, {378,0.00038793}, {379,0.00013793}, {380,0.00010345}, {381,0.00060345}, {382,0.00026724}, {383,0.00003448}, {384,0.00006034}, {385,0.00074138}, {386,0.00029310}, {387,0.00012931}, {388,0.00010345}, {389,0.00010345}, {390,0.00006897}, {391,0.00020690}, {392,0.00009483}, {393,0.00020690}, {394,0.00013793}, {395,0.00017241}, {396,0.00020690}, {397,0.00010345}, {398,0.00013793}, {399,0.00765517}, {400,0.00070690}, {401,0.00016379}, {402,0.00027586}, {403,0.00080172}, {404,0.00017241}, {405,0.00010345}, {406,0.00017241}, {407,0.00017241}, {408,0.00010345}, {409,0.00006034}, {410,0.00068103}, {411,0.00023276}, {412,0.00012931}, {413,0.00020690}, {414,0.00083621}, {415,0.00011207}, {416,0.00017241}, {417,0.00018966}, {418,0.00026724}, {419,0.00024138}, {420,0.00016379}, {421,0.00043966}, {422,0.00017241}, {423,0.00010345}, {424,0.00013793}, {425,0.00021552}, {426,0.00008621}, {427,0.00006897}, {428,0.00081897}, {429,0.00025000}, {430,0.00020690}, {431,0.00010345}, {432,0.00017241}, {433,0.00003448}, {434,0.00013793}, {435,0.00062069}, {436,0.00009483}, {437,0.00027586}, {438,0.00047414}, {439,0.00017241}, {440,0.00010345}, {441,0.00008621}, {442,0.00017241}, {443,0.00017241}, {444,0.00012931}, {445,0.00077586}, {446,0.00009483}, {447,0.00006034}, {448,0.00054310}, {449,0.00013793}, {450,0.00010345}, {451,0.00009483}, {452,0.00017241}, {453,0.00003448}, {454,0.00009483}, {455,0.00061207}, {456,0.00020690}, {457,0.00017241}, {458,0.00067241}, {459,0.00017241}, {460,0.00013793}, {461,0.00020690}, {462,0.00037931}, {463,0.00006897}, {464,0.00016379}, {465,0.00019828}, {466,0.00027586}, {467,0.00009483}, {468,0.00003448}, {469,0.00022414}, {470,0.00017241}, {471,0.00010345}, {472,0.00006897}, {473,0.00031034}, {474,0.00055172}, {475,0.00023276}, {476,0.00012931}, {477,0.00058621}, {478,0.00012931}, {479,0.00010345}, {480,0.00010345}, {481,0.00023276}, {482,0.00010345}, {483,0.00022414}, {484,0.00013793}, {485,0.00027586}, {486,0.00017241}, {487,0.00006897}, {488,0.00016379}, {489,0.00010345}, {490,0.00006897}, {491,0.00020690}, {492,0.00024138}, {493,0.00006897}, {494,0.00025862}, {495,0.00016379}, {496,0.00017241}, {497,0.00010345}, {498,0.00024138}, {499,0.00013793}, {500,0.000212121}, {505,0.00023478}, {510,0.00020870}, {515,0.00006957}, {520,0.00020000}, {525,0.00017391}, {530,0.00031304}, {535,0.00026957}, {540,0.00030435}, {545,0.00082609}, {550,0.00010435}, {555,0.00013043}, {560,0.00072174}, {565,0.00017544}, {570,0.00017544}, {575,0.00014035}, {580,0.00025439}, {585,0.00083333}, {590,0.00014035}, {595,0.00026316}, {600,0.00031304}, {605,0.00014035}, {610,0.00080702}, {615,0.00015789}, {620,0.00024561}, {625,0.00014035}, {630,0.00021053}, {635,0.00111404}, {640,0.00024561}, {645,0.00041228}, {650,0.00010526}, {655,0.00030702}, {660,0.00027193}, {665,0.00007018}, {670,0.00023684}, {675,0.00016667}, {680,0.00065789}, {685,0.00043860}, {690,0.00097368}, {695,0.00028070}, {700,0.00071304}, {705,0.00023684}, {710,0.00076316}, {715,0.00021053}, {720,0.00021053}, {725,0.00010526}, {730,0.00006140}, {735,0.00023684}, {740,0.00016667}, {745,0.00041228}, {750,0.00021053}, {755,0.00023684}, {760,0.00024561}, {765,0.00031579}, {770,0.00759649}, {775,0.00560526}, {780,0.00041228}, {785,0.00093860}, {790,0.00034211}, {795,0.00126316}, {800,0.00045217}, {805,0.00089474}, {810,0.00031579}, {815,0.00022807}, {820,0.00021053}, {825,0.00028070}, {830,0.00041228}, {835,0.00030702}, {840,0.00128070}, {845,0.00031579}, {850,0.00063158}, {855,0.00021053}, {860,0.00028070}, {865,0.00016667}, {870,0.00017544}, {875,0.00030702}, {880,0.00023684}, {885,0.00017544}, {890,0.00014035}, {895,0.00013158}, {900,0.00033043}, {905,0.00056140}, {910,0.00024561}, {915,0.00035088}, {920,0.00016667}, {925,0.00085088}, {930,0.00048246}, {935,0.00038596}, {940,0.00093860}, {945,0.00013158}, {950,0.00038596}, {955,0.00093860}, {960,0.00034211}, {965,0.00021053}, {970,0.00099123}, {975,0.00028070}, {980,0.00063158}, {985,0.00080702}, {990,0.00035088}, {995,0.00028070}, {1000,0.00093913}, {1010,0.00550}, {1020,0.00000}, {1030,0.00000}, {1040,0.00300}, {1050,0.00000}, {1060,0.00000}, {1070,0.00000}, {1080,0.00300}, {1090,0.00000}, {1100,0.00075}, {1110,0.00000}, {1120,0.00100}, {1130,0.00100}, {1140,0.00000}, {1150,0.00100}, {1160,0.00200}, {1170,0.00000}, {1180,0.00000}, {1190,0.00000}, {1200,0.00200}, {1210,0.00100}, {1220,0.00275}, {1230,0.00100}, {1240,0.00000}, {1250,0.00000}, {1260,0.00100}, {1270,0.00100}, {1280,0.00200}, {1290,0.00100}, {1300,0.00075}, {1310,0.00000}, {1320,0.00000}, {1330,0.00175}, {1340,0.00300}, {1350,0.00400}, {1360,0.00000}, {1370,0.00100}, {1380,0.00100}, {1390,0.00000}, {1400,0.00000}, {1410,0.00000}, {1420,0.00000}, {1430,0.00000}, {1440,0.00000}, {1450,0.00000}, {1460,0.00100}, {1470,0.00000}, {1480,0.00000}, {1490,0.00000}, {1500,0.00000}, {1510,0.00200}, {1520,0.00000}, {1530,0.00000}, {1540,0.00000}, {1550,0.00000}, {1560,0.00100}, {1570,0.00000}, {1580,0.00000}, {1590,0.00000}, {1600,0.00100}, {1610,0.00375}, {1620,0.00375}, {1630,0.00100}, {1640,0.00100}, {1650,0.00100}, {1660,0.00000}, {1670,0.00000}, {1680,0.00100}, {1690,0.00400}, {1700,0.00775}, {1710,0.00400}, {1720,0.00000}, {1730,0.00000}, {1740,0.00375}, {1750,0.00400}, {1760,0.00875}, {1770,0.00600}, {1780,0.00000}, {1790,0.00000}, {1800,0.00500}, {1810,0.00700}, {1820,0.00575}, {1830,0.00000}, {1840,0.00700}, {1850,0.00775}, {1860,0.00800}, {1870,0.00100}, {1880,0.00400}, {1890,0.00600}, {1900,0.00500}, {1910,0.00200}, {1920,0.00000}, {1930,0.00000}, {1940,0.00000}, {1950,0.00200}, {1960,0.00100}, {1970,0.00000}, {1980,0.00000}, {1990,0.00700}, {2000,0.00460}, {2050,0.00400}, {2100,0.00675}, {2150,0.00000}, {2200,0.00600}, {2250,0.09375}, {2300,0.00100}, {2350,0.00700}, {2400,0.00600}, {2450,0.00575}, {2500,0.00160}, {2550,0.00700}, {2600,0.00600}, {2650,0.01000}, {2700,0.00500}, {2750,0.00700}, {2800,0.00500}, {2850,0.00975}, {2900,0.00700}, {2950,0.01200}, {3000,0.00640}, {3050,0.00200}, {3100,0.00075}, {3150,0.00000}, {3200,0.01000}, {3250,0.00900}, {3300,0.00700}, {3350,0.01400}, {3400,0.00675}, {3450,0.00900}, {3500,0.01280}, {3550,0.00775}, {3600,0.00800}, {3650,0.00500}, {3700,0.00800}, {3750,0.01100}, {3800,0.00600}, {3850,0.00800}, {3900,0.00900}, {3950,0.00900}, {4000,0.00640}, {4050,0.01000}, {4100,0.01200}, {4150,0.01100}, {4200,0.01400}, {4250,0.00900}, {4300,0.01200}, {4350,0.01075}, {4400,0.01000}, {4450,0.01100}, {4500,0.01280}, {4550,0.00900}, {4600,0.18125}, {4650,0.00800}, {4700,0.00375}, {4750,0.00000}, {4800,0.00200}, {4850,0.00000}, {4900,0.00100}, {4950,0.00300}, {5000,0.00080}};
data["big_flat"]["Parsing"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00001724}, {12,0.00000862}, {13,0.00029310}, {14,0.00062931}, {15,0.00093966}, {16,0.00098276}, {17,0.00100000}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00100000}, {23,0.00100000}, {24,0.00100000}, {25,0.00100000}, {26,0.00100862}, {27,0.00100000}, {28,0.00112069}, {29,0.00108621}, {30,0.00137069}, {31,0.00137069}, {32,0.00162069}, {33,0.00300000}, {34,0.00188793}, {35,0.00200000}, {36,0.05306897}, {37,0.00200000}, {38,0.00200000}, {39,0.00200000}, {40,0.00200000}, {41,0.00200000}, {42,0.00200000}, {43,0.00200000}, {44,0.00200000}, {45,0.00200000}, {46,0.00200000}, {47,0.00200000}, {48,0.00200000}, {49,0.00200862}, {50,0.00200862}, {51,0.00202586}, {52,0.00212931}, {53,0.00254310}, {54,0.00283621}, {55,0.00298276}, {56,0.00300000}, {57,0.00300000}, {58,0.00300000}, {59,0.00300000}, {60,0.00300000}, {61,0.00300000}, {62,0.00300000}, {63,0.00300000}, {64,0.05392241}, {65,0.00300000}, {66,0.00300862}, {67,0.00304310}, {68,0.00302586}, {69,0.00318103}, {70,0.00347414}, {71,0.00353448}, {72,0.00393966}, {73,0.00398276}, {74,0.00400000}, {75,0.00400000}, {76,0.00400000}, {77,0.00400000}, {78,0.00400000}, {79,0.00400000}, {80,0.00400000}, {81,0.00400000}, {82,0.00400000}, {83,0.00400000}, {84,0.00403448}, {85,0.00413793}, {86,0.00421552}, {87,0.00475862}, {88,0.00488793}, {89,0.00486207}, {90,0.00498276}, {91,0.00500000}, {92,0.00500000}, {93,0.00500000}, {94,0.00500000}, {95,0.00500000}, {96,0.00500000}, {97,0.00500000}, {98,0.01676724}, {99,0.05568103}, {100,0.00500862}, {101,0.00518103}, {102,0.00540517}, {103,0.00569828}, {104,0.00549138}, {105,0.00535345}, {106,0.00566379}, {107,0.00595690}, {108,0.00599138}, {109,0.00600000}, {110,0.00599138}, {111,0.00600000}, {112,0.00600000}, {113,0.00600000}, {114,0.00600000}, {115,0.00600000}, {116,0.00600862}, {117,0.00600862}, {118,0.00601724}, {119,0.00606897}, {120,0.00646552}, {121,0.00668966}, {122,0.00685345}, {123,0.00689655}, {124,0.00684483}, {125,0.03764655}, {126,0.00698276}, {127,0.00698276}, {128,0.00699138}, {129,0.00700000}, {130,0.00700000}, {131,0.00700000}, {132,0.00700000}, {133,0.00702586}, {134,0.00702586}, {135,0.00709483}, {136,0.03979310}, {137,0.00726724}, {138,0.00777586}, {139,0.00787931}, {140,0.00737931}, {141,0.00725000}, {142,0.00756034}, {143,0.00799138}, {144,0.00795690}, {145,0.00797414}, {146,0.04404310}, {147,0.00799138}, {148,0.00799138}, {149,0.00800000}, {150,0.00800000}, {151,0.00800000}, {152,0.00800000}, {153,0.00800000}, {154,0.00801724}, {155,0.00801724}, {156,0.03825862}, {157,0.00800000}, {158,0.00804310}, {159,0.00819828}, {160,0.00866379}, {161,0.00870690}, {162,0.00887069}, {163,0.00878448}, {164,0.00893966}, {165,0.03956034}, {166,0.00900000}, {167,0.00900000}, {168,0.00900000}, {169,0.00900000}, {170,0.00900862}, {171,0.00901724}, {172,0.00900862}, {173,0.00900000}, {174,0.00903448}, {175,0.00907759}, {176,0.00905172}, {177,0.00934483}, {178,0.00932759}, {179,0.00931897}, {180,0.00981034}, {181,0.00994828}, {182,0.04349138}, {183,0.00993966}, {184,0.00999138}, {185,0.01000000}, {186,0.01000000}, {187,0.00999138}, {188,0.01000000}, {189,0.01000000}, {190,0.04440517}, {191,0.01000862}, {192,0.01000000}, {193,0.01013793}, {194,0.01050000}, {195,0.01060345}, {196,0.01063793}, {197,0.01027586}, {198,0.01081897}, {199,0.01070690}, {200,0.01081897}, {201,0.01093966}, {202,0.01099138}, {203,0.01100000}, {204,0.01100000}, {205,0.01100000}, {206,0.01100000}, {207,0.01100000}, {208,0.01100862}, {209,0.01100000}, {210,0.01101724}, {211,0.01102586}, {212,0.01186207}, {213,0.01189655}, {214,0.01197414}, {215,0.01199138}, {216,0.01199138}, {217,0.01198276}, {218,0.01200862}, {219,0.01200000}, {220,0.01200000}, {221,0.01200000}, {222,0.01200000}, {223,0.01201724}, {224,0.01207759}, {225,0.05762931}, {226,0.01240517}, {227,0.01256034}, {228,0.01244828}, {229,0.01264655}, {230,0.01282759}, {231,0.01293966}, {232,0.01292241}, {233,0.01298276}, {234,0.01299138}, {235,0.01300000}, {236,0.01300000}, {237,0.01301724}, {238,0.04280172}, {239,0.01300000}, {240,0.01304310}, {241,0.01302586}, {242,0.01306897}, {243,0.01312931}, {244,0.04774138}, {245,0.01316379}, {246,0.01362069}, {247,0.01390517}, {248,0.01378448}, {249,0.01362931}, {250,0.04441379}, {251,0.01391379}, {252,0.01394828}, {253,0.01397414}, {254,0.01399138}, {255,0.01400000}, {256,0.05812931}, {257,0.01401724}, {258,0.01403448}, {259,0.01401724}, {260,0.01402586}, {261,0.01421552}, {262,0.01443103}, {263,0.01465517}, {264,0.01469828}, {265,0.01476724}, {266,0.01478448}, {267,0.05667241}, {268,0.01495690}, {269,0.01499138}, {270,0.01498276}, {271,0.01500000}, {272,0.01500000}, {273,0.01500000}, {274,0.01501724}, {275,0.01507759}, {276,0.01509483}, {277,0.01531897}, {278,0.04813793}, {279,0.01528448}, {280,0.01543103}, {281,0.01547414}, {282,0.01503448}, {283,0.01503448}, {284,0.01501724}, {285,0.01506034}, {286,0.01512931}, {287,0.01524138}, {288,0.04181034}, {289,0.01561207}, {290,0.01566379}, {291,0.01576724}, {292,0.01586207}, {293,0.04589655}, {294,0.01597414}, {295,0.01599138}, {296,0.01600000}, {297,0.01600862}, {298,0.04493103}, {299,0.01600000}, {300,0.01601724}, {301,0.01600862}, {302,0.01602586}, {303,0.04791379}, {304,0.01603448}, {305,0.01622414}, {306,0.01633621}, {307,0.01639655}, {308,0.01661207}, {309,0.01666379}, {310,0.01674138}, {311,0.01691379}, {312,0.01690517}, {313,0.01696552}, {314,0.01698276}, {315,0.01697414}, {316,0.01700000}, {317,0.04734483}, {318,0.01700000}, {319,0.01700862}, {320,0.01700862}, {321,0.01706034}, {322,0.04856897}, {323,0.01713793}, {324,0.01735345}, {325,0.01734483}, {326,0.01758621}, {327,0.01756034}, {328,0.01775862}, {329,0.01789655}, {330,0.01791379}, {331,0.05019828}, {332,0.01796552}, {333,0.01799138}, {334,0.01800000}, {335,0.01800862}, {336,0.01800862}, {337,0.01800000}, {338,0.01800862}, {339,0.01802586}, {340,0.05068966}, {341,0.01812931}, {342,0.01814655}, {343,0.01828448}, {344,0.05074138}, {345,0.01841379}, {346,0.01860345}, {347,0.01878448}, {348,0.01884483}, {349,0.01885345}, {350,0.01891379}, {351,0.01893103}, {352,0.01899138}, {353,0.01937931}, {354,0.01948276}, {355,0.01960345}, {356,0.01979310}, {357,0.06564655}, {358,0.01986207}, {359,0.01990517}, {360,0.01994828}, {361,0.07725862}, {362,0.01997414}, {363,0.01998276}, {364,0.02002586}, {365,0.05318966}, {366,0.02007759}, {367,0.02012069}, {368,0.02017241}, {369,0.05262931}, {370,0.02019828}, {371,0.02043966}, {372,0.02046552}, {373,0.05270690}, {374,0.02078448}, {375,0.02079310}, {376,0.02080172}, {377,0.05561207}, {378,0.02093103}, {379,0.02093103}, {380,0.02097414}, {381,0.07463793}, {382,0.02100862}, {383,0.02099138}, {384,0.02100862}, {385,0.08168966}, {386,0.02112931}, {387,0.02125862}, {388,0.02141379}, {389,0.02149138}, {390,0.02150000}, {391,0.02175000}, {392,0.02179310}, {393,0.02174138}, {394,0.02185345}, {395,0.02187069}, {396,0.02193966}, {397,0.02193103}, {398,0.02200000}, {399,0.43366379}, {400,0.02121552}, {401,0.02136207}, {402,0.02159483}, {403,0.04964655}, {404,0.02172414}, {405,0.02180172}, {406,0.02189655}, {407,0.02190517}, {408,0.02194828}, {409,0.02197414}, {410,0.04852586}, {411,0.02200862}, {412,0.02201724}, {413,0.02203448}, {414,0.05203448}, {415,0.02206034}, {416,0.02206034}, {417,0.02208621}, {418,0.02234483}, {419,0.02235345}, {420,0.02247414}, {421,0.05406034}, {422,0.02268966}, {423,0.02275000}, {424,0.02285345}, {425,0.02283621}, {426,0.02287931}, {427,0.02296552}, {428,0.05279310}, {429,0.02299138}, {430,0.02299138}, {431,0.02301724}, {432,0.02300862}, {433,0.02303448}, {434,0.02307759}, {435,0.05302586}, {436,0.02321552}, {437,0.02318966}, {438,0.05401724}, {439,0.02337069}, {440,0.02354310}, {441,0.02370690}, {442,0.02375862}, {443,0.02379310}, {444,0.02390517}, {445,0.05327586}, {446,0.02393966}, {447,0.02397414}, {448,0.05415517}, {449,0.02400862}, {450,0.02401724}, {451,0.02402586}, {452,0.02406034}, {453,0.02412069}, {454,0.02412931}, {455,0.05460345}, {456,0.02437069}, {457,0.02428448}, {458,0.05762931}, {459,0.02456034}, {460,0.02469828}, {461,0.02479310}, {462,0.02484483}, {463,0.02487931}, {464,0.02491379}, {465,0.02495690}, {466,0.02497414}, {467,0.02500000}, {468,0.05435345}, {469,0.02500862}, {470,0.02501724}, {471,0.05183621}, {472,0.02508621}, {473,0.02518103}, {474,0.10650862}, {475,0.02604310}, {476,0.02600862}, {477,0.09671552}, {478,0.02620690}, {479,0.02619828}, {480,0.02638793}, {481,0.02639655}, {482,0.02648276}, {483,0.02670690}, {484,0.02666379}, {485,0.02677586}, {486,0.02680172}, {487,0.02681034}, {488,0.02687931}, {489,0.02687931}, {490,0.02693103}, {491,0.02694828}, {492,0.02698276}, {493,0.02702586}, {494,0.02702586}, {495,0.02706034}, {496,0.02716379}, {497,0.02707759}, {498,0.02723276}, {499,0.02743966}, {500,0.027445887}, {505,0.02782609}, {510,0.02797391}, {515,0.02855652}, {520,0.02886957}, {525,0.02902609}, {530,0.02924348}, {535,0.02969565}, {540,0.02988696}, {545,0.09566087}, {550,0.03046087}, {555,0.03085217}, {560,0.08988696}, {565,0.03118421}, {570,0.03164912}, {575,0.03181579}, {580,0.03201754}, {585,0.09185088}, {590,0.03270175}, {595,0.03288596}, {600,0.03307826}, {605,0.03350877}, {610,0.09338596}, {615,0.03396491}, {620,0.03414035}, {625,0.03458772}, {630,0.03487719}, {635,0.06452632}, {640,0.03559649}, {645,0.07037719}, {650,0.03593860}, {655,0.03625439}, {660,0.03658772}, {665,0.03683333}, {670,0.03702632}, {675,0.03731579}, {680,0.06914035}, {685,0.03787719}, {690,0.06946491}, {695,0.03856140}, {700,0.07136522}, {705,0.03895614}, {710,0.07475439}, {715,0.03964035}, {720,0.03982456}, {725,0.04003509}, {730,0.04032456}, {735,0.04072807}, {740,0.04094737}, {745,0.04108772}, {750,0.04153509}, {755,0.04179825}, {760,0.04195614}, {765,0.04100877}, {770,0.59543860}, {775,0.16792982}, {780,0.04222807}, {785,0.07750877}, {790,0.04269298}, {795,0.07768421}, {800,0.04308696}, {805,0.07581579}, {810,0.04373684}, {815,0.04392105}, {820,0.04412281}, {825,0.04441228}, {830,0.04478947}, {835,0.04497368}, {840,0.08016667}, {845,0.04549123}, {850,0.07754386}, {855,0.04595614}, {860,0.04626316}, {865,0.07644737}, {870,0.04683333}, {875,0.08291228}, {880,0.04733333}, {885,0.04771930}, {890,0.04792982}, {895,0.04814912}, {900,0.08585217}, {905,0.04875439}, {910,0.04891228}, {915,0.08199123}, {920,0.04949123}, {925,0.08450000}, {930,0.05004386}, {935,0.05166667}, {940,0.09599123}, {945,0.05203509}, {950,0.05246491}, {955,0.08544737}, {960,0.05300000}, {965,0.05327193}, {970,0.08724561}, {975,0.05383333}, {980,0.05400877}, {985,0.11636842}, {990,0.05470175}, {995,0.05484211}, {1000,0.12188696}, {1010,0.10900}, {1020,0.05425}, {1030,0.05675}, {1040,0.09975}, {1050,0.06850}, {1060,0.05850}, {1070,0.08550}, {1080,0.09100}, {1090,0.06025}, {1100,0.05925}, {1110,0.08350}, {1120,0.08625}, {1130,0.06075}, {1140,0.06175}, {1150,0.09000}, {1160,0.09750}, {1170,0.06300}, {1180,0.06375}, {1190,0.06375}, {1200,0.12000}, {1210,0.10925}, {1220,0.11125}, {1230,0.06800}, {1240,0.06850}, {1250,0.06925}, {1260,0.10300}, {1270,0.11250}, {1280,0.10600}, {1290,0.07150}, {1300,0.07200}, {1310,0.07250}, {1320,0.07100}, {1330,0.10025}, {1340,0.10375}, {1350,0.16300}, {1360,0.10725}, {1370,0.10925}, {1380,0.11125}, {1390,0.10775}, {1400,0.07575}, {1410,0.07775}, {1420,0.07850}, {1430,0.07900}, {1440,0.07950}, {1450,0.08025}, {1460,0.08025}, {1470,0.08150}, {1480,0.08200}, {1490,0.08250}, {1500,0.09380}, {1510,0.08350}, {1520,0.08475}, {1530,0.08500}, {1540,0.08475}, {1550,0.08625}, {1560,0.08400}, {1570,0.08450}, {1580,0.08550}, {1590,0.12150}, {1600,0.12725}, {1610,0.13275}, {1620,0.24900}, {1630,0.10900}, {1640,0.08850}, {1650,0.09075}, {1660,0.09125}, {1670,0.12825}, {1680,0.13250}, {1690,0.14875}, {1700,0.15325}, {1710,0.14450}, {1720,0.09500}, {1730,0.09450}, {1740,0.15350}, {1750,0.17900}, {1760,0.16700}, {1770,0.13025}, {1780,0.09800}, {1790,0.09825}, {1800,0.15000}, {1810,0.14600}, {1820,0.13300}, {1830,0.09800}, {1840,0.12900}, {1850,0.14550}, {1860,0.14000}, {1870,0.10050}, {1880,0.12925}, {1890,0.14950}, {1900,0.14225}, {1910,0.10250}, {1920,0.12875}, {1930,0.14150}, {1940,0.12525}, {1950,0.13275}, {1960,0.14725}, {1970,0.13600}, {1980,0.10575}, {1990,0.17025}, {2000,0.13620}, {2050,0.16225}, {2100,0.18000}, {2150,0.11950}, {2200,0.16175}, {2250,1.35075}, {2300,0.12750}, {2350,0.17200}, {2400,0.17175}, {2450,0.18450}, {2500,0.17780}, {2550,0.17375}, {2600,0.18175}, {2650,0.18400}, {2700,0.18075}, {2750,0.18800}, {2800,0.19425}, {2850,0.19800}, {2900,0.20275}, {2950,0.23800}, {3000,0.20660}, {3050,0.20575}, {3100,0.21075}, {3150,0.21225}, {3200,0.22125}, {3250,0.29525}, {3300,0.22975}, {3350,0.28025}, {3400,0.28450}, {3450,0.26450}, {3500,0.32400}, {3550,0.29300}, {3600,0.32125}, {3650,0.30525}, {3700,0.27550}, {3750,0.26325}, {3800,0.27150}, {3850,0.26725}, {3900,0.27700}, {3950,0.26200}, {4000,0.27520}, {4050,0.27225}, {4100,0.28000}, {4150,0.27150}, {4200,0.28550}, {4250,0.28875}, {4300,0.29950}, {4350,0.29325}, {4400,0.29925}, {4450,0.30250}, {4500,0.31220}, {4550,0.30600}, {4600,1.78550}, {4650,0.31950}, {4700,0.39275}, {4750,0.38575}, {4800,0.41000}, {4850,0.38325}, {4900,0.41100}, {4950,0.39525}, {5000,0.34240}};
data["big_flat"]["Parsing"]["norm reif"]["user"] = {{1,0.00000000}, {2,0.00002586}, {3,0.00032759}, {4,0.00031897}, {5,0.00024138}, {6,0.00046552}, {7,0.00050862}, {8,0.00078448}, {9,0.00062069}, {10,0.00077586}, {11,0.00066379}, {12,0.00088793}, {13,0.00080172}, {14,0.00093103}, {15,0.00125000}, {16,0.00089655}, {17,0.00100000}, {18,0.00118966}, {19,0.00120690}, {20,0.00131034}, {21,0.00141379}, {22,0.00157759}, {23,0.00155172}, {24,0.00150000}, {25,0.00160345}, {26,0.00183621}, {27,0.00185345}, {28,0.00169828}, {29,0.00162069}, {30,0.00133621}, {31,0.00166379}, {32,0.00178448}, {33,0.00323276}, {34,0.00170690}, {35,0.00218103}, {36,0.05109483}, {37,0.00212069}, {38,0.00206897}, {39,0.00209483}, {40,0.00233621}, {41,0.00224138}, {42,0.00224138}, {43,0.00250000}, {44,0.00236207}, {45,0.00255172}, {46,0.00268103}, {47,0.00247414}, {48,0.00243966}, {49,0.00253448}, {50,0.00277586}, {51,0.00302586}, {52,0.00300000}, {53,0.00286207}, {54,0.00324138}, {55,0.00292241}, {56,0.00312069}, {57,0.00319828}, {58,0.00327586}, {59,0.00324138}, {60,0.00327586}, {61,0.00330172}, {62,0.00331034}, {63,0.00330172}, {64,0.05393966}, {65,0.00377586}, {66,0.00384483}, {67,0.00373276}, {68,0.00364655}, {69,0.00389655}, {70,0.00381897}, {71,0.00394828}, {72,0.00406897}, {73,0.00417241}, {74,0.00419828}, {75,0.00423276}, {76,0.00431034}, {77,0.00434483}, {78,0.00437931}, {79,0.00443966}, {80,0.00450000}, {81,0.00444828}, {82,0.00436207}, {83,0.00483621}, {84,0.00475862}, {85,0.00451724}, {86,0.00509483}, {87,0.00473276}, {88,0.00492241}, {89,0.00516379}, {90,0.00524138}, {91,0.00510345}, {92,0.00520690}, {93,0.00529310}, {94,0.00519828}, {95,0.00537931}, {96,0.00548276}, {97,0.00562069}, {98,0.01737931}, {99,0.05550862}, {100,0.00558621}, {101,0.00559483}, {102,0.00556034}, {103,0.00600000}, {104,0.00629310}, {105,0.00615517}, {106,0.00611207}, {107,0.00616379}, {108,0.00568966}, {109,0.00606897}, {110,0.00648276}, {111,0.00613793}, {112,0.00634483}, {113,0.00639655}, {114,0.00650000}, {115,0.00651724}, {116,0.00643103}, {117,0.00658621}, {118,0.00663793}, {119,0.00659483}, {120,0.00677586}, {121,0.00688793}, {122,0.00703448}, {123,0.00710345}, {124,0.00706897}, {125,0.03755172}, {126,0.00706897}, {127,0.00748276}, {128,0.00734483}, {129,0.00744828}, {130,0.00737931}, {131,0.00758621}, {132,0.00751724}, {133,0.00779310}, {134,0.00771552}, {135,0.00766379}, {136,0.03905172}, {137,0.00773276}, {138,0.00812069}, {139,0.00798276}, {140,0.00772414}, {141,0.00782759}, {142,0.00795690}, {143,0.00816379}, {144,0.00823276}, {145,0.00811207}, {146,0.04338793}, {147,0.00817241}, {148,0.00848276}, {149,0.00824138}, {150,0.00827586}, {151,0.00848276}, {152,0.00844828}, {153,0.00813793}, {154,0.00865517}, {155,0.00872414}, {156,0.03834483}, {157,0.00865517}, {158,0.00879310}, {159,0.00888793}, {160,0.00906897}, {161,0.00898276}, {162,0.00888793}, {163,0.00877586}, {164,0.00893966}, {165,0.03937069}, {166,0.00928448}, {167,0.00931034}, {168,0.00935345}, {169,0.00926724}, {170,0.00910345}, {171,0.00968966}, {172,0.00979310}, {173,0.00993103}, {174,0.00968966}, {175,0.00993103}, {176,0.01006897}, {177,0.01006897}, {178,0.00979310}, {179,0.00965517}, {180,0.00974138}, {181,0.01002586}, {182,0.04305172}, {183,0.00974138}, {184,0.00989655}, {185,0.01018966}, {186,0.01016379}, {187,0.01030172}, {188,0.01031897}, {189,0.01029310}, {190,0.04461207}, {191,0.01043966}, {192,0.01057759}, {193,0.01089655}, {194,0.01096552}, {195,0.01106897}, {196,0.01082759}, {197,0.01086207}, {198,0.01082759}, {199,0.01083621}, {200,0.01085345}, {201,0.01096552}, {202,0.01098276}, {203,0.01140517}, {204,0.01120690}, {205,0.01112069}, {206,0.01108621}, {207,0.01151724}, {208,0.01171552}, {209,0.01148276}, {210,0.01168966}, {211,0.01165517}, {212,0.01196552}, {213,0.01190517}, {214,0.01191379}, {215,0.01200000}, {216,0.01177586}, {217,0.01194828}, {218,0.01193966}, {219,0.01214655}, {220,0.01267241}, {221,0.01245690}, {222,0.01240517}, {223,0.01270690}, {224,0.01278448}, {225,0.05731897}, {226,0.01217241}, {227,0.01261207}, {228,0.01244828}, {229,0.01242241}, {230,0.01263793}, {231,0.01253448}, {232,0.01265517}, {233,0.01292241}, {234,0.01299138}, {235,0.01283621}, {236,0.01300000}, {237,0.01306897}, {238,0.04261207}, {239,0.01295690}, {240,0.01330172}, {241,0.01324138}, {242,0.01331897}, {243,0.01337931}, {244,0.04741379}, {245,0.01364655}, {246,0.01358621}, {247,0.01390517}, {248,0.01388793}, {249,0.01372414}, {250,0.04443103}, {251,0.01409483}, {252,0.01357759}, {253,0.01394828}, {254,0.01389655}, {255,0.01408621}, {256,0.05778448}, {257,0.01427586}, {258,0.01447414}, {259,0.01453448}, {260,0.01460345}, {261,0.01459483}, {262,0.01506897}, {263,0.01439655}, {264,0.01486207}, {265,0.01487069}, {266,0.01478448}, {267,0.05624138}, {268,0.01467241}, {269,0.01527586}, {270,0.01502586}, {271,0.01507759}, {272,0.01537931}, {273,0.01537069}, {274,0.01527586}, {275,0.01538793}, {276,0.01549138}, {277,0.01579310}, {278,0.04821552}, {279,0.01573276}, {280,0.01581034}, {281,0.01590517}, {282,0.01550000}, {283,0.01548276}, {284,0.01559483}, {285,0.01564655}, {286,0.01580172}, {287,0.01583621}, {288,0.04157759}, {289,0.01574138}, {290,0.01593103}, {291,0.01587931}, {292,0.01608621}, {293,0.04550862}, {294,0.01610345}, {295,0.01631897}, {296,0.01629310}, {297,0.01628448}, {298,0.04433621}, {299,0.01637931}, {300,0.01643966}, {301,0.01635345}, {302,0.01625862}, {303,0.04697414}, {304,0.01647414}, {305,0.01662931}, {306,0.01673276}, {307,0.01635345}, {308,0.01662069}, {309,0.01680172}, {310,0.01660345}, {311,0.01710345}, {312,0.01698276}, {313,0.01689655}, {314,0.01689655}, {315,0.01694828}, {316,0.01707759}, {317,0.04696552}, {318,0.01710345}, {319,0.01733621}, {320,0.01706034}, {321,0.01726724}, {322,0.04831034}, {323,0.01747414}, {324,0.01731034}, {325,0.01735345}, {326,0.01763793}, {327,0.01748276}, {328,0.01752586}, {329,0.01775862}, {330,0.01778448}, {331,0.04980172}, {332,0.01773276}, {333,0.01787069}, {334,0.01797414}, {335,0.01820690}, {336,0.01808621}, {337,0.01806034}, {338,0.01790517}, {339,0.01801724}, {340,0.05003448}, {341,0.01809483}, {342,0.01831034}, {343,0.01814655}, {344,0.05012069}, {345,0.01816379}, {346,0.01831034}, {347,0.01850862}, {348,0.01844828}, {349,0.01840517}, {350,0.01850862}, {351,0.01854310}, {352,0.01844828}, {353,0.01906897}, {354,0.01919828}, {355,0.01924138}, {356,0.01950862}, {357,0.06552586}, {358,0.01932759}, {359,0.01930172}, {360,0.01943966}, {361,0.07721552}, {362,0.01946552}, {363,0.01943966}, {364,0.01984483}, {365,0.05230172}, {366,0.01983621}, {367,0.02000000}, {368,0.01981034}, {369,0.05194828}, {370,0.01981034}, {371,0.02008621}, {372,0.02000000}, {373,0.05219828}, {374,0.01995690}, {375,0.02000000}, {376,0.02079310}, {377,0.05468966}, {378,0.02034483}, {379,0.02051724}, {380,0.02057759}, {381,0.07412069}, {382,0.02027586}, {383,0.02111207}, {384,0.02106034}, {385,0.08083621}, {386,0.02112931}, {387,0.02069828}, {388,0.02075862}, {389,0.02121552}, {390,0.02143103}, {391,0.02153448}, {392,0.02158621}, {393,0.02126724}, {394,0.02123276}, {395,0.02141379}, {396,0.02150862}, {397,0.02168966}, {398,0.02173276}, {399,0.42562069}, {400,0.02039655}, {401,0.02089655}, {402,0.02129310}, {403,0.04884483}, {404,0.02165517}, {405,0.02191379}, {406,0.02144828}, {407,0.02119828}, {408,0.02150000}, {409,0.02150000}, {410,0.04782759}, {411,0.02159483}, {412,0.02187931}, {413,0.02184483}, {414,0.05107759}, {415,0.02143966}, {416,0.02200000}, {417,0.02181897}, {418,0.02208621}, {419,0.02212931}, {420,0.02211207}, {421,0.05366379}, {422,0.02237069}, {423,0.02250862}, {424,0.02205172}, {425,0.02235345}, {426,0.02225000}, {427,0.02281897}, {428,0.05218103}, {429,0.02248276}, {430,0.02278448}, {431,0.02294828}, {432,0.02290517}, {433,0.02310345}, {434,0.02278448}, {435,0.05265517}, {436,0.02328448}, {437,0.02289655}, {438,0.05333621}, {439,0.02328448}, {440,0.02332759}, {441,0.02343966}, {442,0.02337069}, {443,0.02360345}, {444,0.02404310}, {445,0.05246552}, {446,0.02368103}, {447,0.02366379}, {448,0.05356034}, {449,0.02376724}, {450,0.02376724}, {451,0.02381897}, {452,0.02425000}, {453,0.02444828}, {454,0.02429310}, {455,0.05402586}, {456,0.02416379}, {457,0.02430172}, {458,0.05695690}, {459,0.02445690}, {460,0.02468966}, {461,0.02450000}, {462,0.02442241}, {463,0.02464655}, {464,0.02468966}, {465,0.02477586}, {466,0.02463793}, {467,0.02503448}, {468,0.05444828}, {469,0.02463793}, {470,0.02530172}, {471,0.05144828}, {472,0.02519828}, {473,0.02500862}, {474,0.10595690}, {475,0.02590517}, {476,0.02600862}, {477,0.09630172}, {478,0.02612931}, {479,0.02622414}, {480,0.02634483}, {481,0.02630172}, {482,0.02656034}, {483,0.02647414}, {484,0.02646552}, {485,0.02643966}, {486,0.02653448}, {487,0.02668966}, {488,0.02675000}, {489,0.02665517}, {490,0.02681897}, {491,0.02687931}, {492,0.02672414}, {493,0.02668966}, {494,0.02687931}, {495,0.02693103}, {496,0.02699138}, {497,0.02710345}, {498,0.02715517}, {499,0.02734483}, {500,0.027030303}, {505,0.02737391}, {510,0.02774783}, {515,0.02837391}, {520,0.02875652}, {525,0.02893043}, {530,0.02913913}, {535,0.02936522}, {540,0.02982609}, {545,0.09458261}, {550,0.03043478}, {555,0.03086957}, {560,0.08890435}, {565,0.03133333}, {570,0.03180702}, {575,0.03200877}, {580,0.03202632}, {585,0.09111404}, {590,0.03292105}, {595,0.03306140}, {600,0.03321739}, {605,0.03350000}, {610,0.09278947}, {615,0.03406140}, {620,0.03424561}, {625,0.03446491}, {630,0.03487719}, {635,0.06383333}, {640,0.03541228}, {645,0.06981579}, {650,0.03571053}, {655,0.03600000}, {660,0.03634211}, {665,0.03663158}, {670,0.03671930}, {675,0.03717544}, {680,0.06853509}, {685,0.03726316}, {690,0.06852632}, {695,0.03830702}, {700,0.07066957}, {705,0.03848246}, {710,0.07433333}, {715,0.03907895}, {720,0.03939474}, {725,0.03969298}, {730,0.04014035}, {735,0.04013158}, {740,0.04067544}, {745,0.04104386}, {750,0.04144737}, {755,0.04157018}, {760,0.04191228}, {765,0.04074561}, {770,0.58740351}, {775,0.16233333}, {780,0.04177193}, {785,0.07628947}, {790,0.04264912}, {795,0.07656140}, {800,0.04300870}, {805,0.07492105}, {810,0.04373684}, {815,0.04402632}, {820,0.04440351}, {825,0.04436842}, {830,0.04446491}, {835,0.04493860}, {840,0.07882456}, {845,0.04539474}, {850,0.07685965}, {855,0.04597368}, {860,0.04604386}, {865,0.07623684}, {870,0.04669298}, {875,0.08211404}, {880,0.04722807}, {885,0.04751754}, {890,0.04764912}, {895,0.04803509}, {900,0.08586087}, {905,0.04797368}, {910,0.04861404}, {915,0.08122807}, {920,0.04931579}, {925,0.08376316}, {930,0.04944737}, {935,0.05089474}, {940,0.09518421}, {945,0.05152632}, {950,0.05185088}, {955,0.08456140}, {960,0.05225439}, {965,0.05284211}, {970,0.08638596}, {975,0.05343860}, {980,0.05333333}, {985,0.11570175}, {990,0.05424561}, {995,0.05453509}, {1000,0.12090435}, {1010,0.10250}, {1020,0.05475}, {1030,0.05725}, {1040,0.09625}, {1050,0.06750}, {1060,0.05975}, {1070,0.08475}, {1080,0.08850}, {1090,0.06100}, {1100,0.05950}, {1110,0.08250}, {1120,0.08600}, {1130,0.06100}, {1140,0.06200}, {1150,0.09000}, {1160,0.09575}, {1170,0.06250}, {1180,0.06400}, {1190,0.06400}, {1200,0.11650}, {1210,0.10875}, {1220,0.10900}, {1230,0.06800}, {1240,0.06750}, {1250,0.06775}, {1260,0.10275}, {1270,0.11200}, {1280,0.10425}, {1290,0.07075}, {1300,0.07175}, {1310,0.07300}, {1320,0.07175}, {1330,0.09900}, {1340,0.10175}, {1350,0.16050}, {1360,0.10550}, {1370,0.10950}, {1380,0.10975}, {1390,0.10700}, {1400,0.07575}, {1410,0.07775}, {1420,0.07825}, {1430,0.08000}, {1440,0.08075}, {1450,0.07950}, {1460,0.08000}, {1470,0.08100}, {1480,0.08150}, {1490,0.08150}, {1500,0.09320}, {1510,0.08150}, {1520,0.08400}, {1530,0.08550}, {1540,0.08400}, {1550,0.08750}, {1560,0.08350}, {1570,0.08400}, {1580,0.08700}, {1590,0.12075}, {1600,0.12550}, {1610,0.12925}, {1620,0.24425}, {1630,0.10650}, {1640,0.08750}, {1650,0.08750}, {1660,0.09250}, {1670,0.12700}, {1680,0.13100}, {1690,0.14450}, {1700,0.14525}, {1710,0.14025}, {1720,0.09600}, {1730,0.09375}, {1740,0.14975}, {1750,0.17400}, {1760,0.15875}, {1770,0.12575}, {1780,0.10025}, {1790,0.09850}, {1800,0.14550}, {1810,0.13875}, {1820,0.12600}, {1830,0.09925}, {1840,0.12050}, {1850,0.13850}, {1860,0.13150}, {1870,0.09950}, {1880,0.12550}, {1890,0.14225}, {1900,0.13775}, {1910,0.09950}, {1920,0.12850}, {1930,0.14125}, {1940,0.12450}, {1950,0.13050}, {1960,0.14600}, {1970,0.13500}, {1980,0.10575}, {1990,0.16500}, {2000,0.13180}, {2050,0.15750}, {2100,0.17225}, {2150,0.11875}, {2200,0.15550}, {2250,1.25775}, {2300,0.12675}, {2350,0.16550}, {2400,0.16625}, {2450,0.17825}, {2500,0.17520}, {2550,0.16775}, {2600,0.17625}, {2650,0.17575}, {2700,0.17725}, {2750,0.18075}, {2800,0.18950}, {2850,0.18700}, {2900,0.19650}, {2950,0.22575}, {3000,0.20020}, {3050,0.20300}, {3100,0.20975}, {3150,0.21350}, {3200,0.21025}, {3250,0.28475}, {3300,0.22225}, {3350,0.26650}, {3400,0.27750}, {3450,0.25525}, {3500,0.31020}, {3550,0.28425}, {3600,0.30250}, {3650,0.29925}, {3700,0.26875}, {3750,0.25350}, {3800,0.26575}, {3850,0.25925}, {3900,0.26725}, {3950,0.25200}, {4000,0.26760}, {4050,0.26175}, {4100,0.26725}, {4150,0.26250}, {4200,0.26675}, {4250,0.28100}, {4300,0.28625}, {4350,0.28200}, {4400,0.28850}, {4450,0.28850}, {4500,0.30020}, {4550,0.29700}, {4600,1.59275}, {4650,0.31150}, {4700,0.38650}, {4750,0.38450}, {4800,0.38125}, {4850,0.38350}, {4900,0.40825}, {4950,0.39050}, {5000,0.34100}};
data["big_flat"]["Parsing"]["norm reif"]["system"] = {{1,0.00023276}, {2,0.00006897}, {3,0.00000000}, {4,0.00003448}, {5,0.00000000}, {6,0.00006034}, {7,0.00006897}, {8,0.00008621}, {9,0.00003448}, {10,0.00003448}, {11,0.00012069}, {12,0.00009483}, {13,0.00006034}, {14,0.00008621}, {15,0.00003448}, {16,0.00010345}, {17,0.00010345}, {18,0.00006034}, {19,0.00012931}, {20,0.00013793}, {21,0.00005172}, {22,0.00019828}, {23,0.00017241}, {24,0.00012931}, {25,0.00023276}, {26,0.00017241}, {27,0.00006034}, {28,0.00021552}, {29,0.00006897}, {30,0.00020690}, {31,0.00017241}, {32,0.00018966}, {33,0.00022414}, {34,0.00022414}, {35,0.00011207}, {36,0.00178448}, {37,0.00009483}, {38,0.00000000}, {39,0.00003448}, {40,0.00000000}, {41,0.00000000}, {42,0.00003448}, {43,0.00003448}, {44,0.00006897}, {45,0.00003448}, {46,0.00003448}, {47,0.00002586}, {48,0.00000000}, {49,0.00000000}, {50,0.00003448}, {51,0.00000000}, {52,0.00003448}, {53,0.00000000}, {54,0.00003448}, {55,0.00000000}, {56,0.00003448}, {57,0.00000000}, {58,0.00000000}, {59,0.00003448}, {60,0.00003448}, {61,0.00006034}, {62,0.00000000}, {63,0.00013793}, {64,0.00038793}, {65,0.00000000}, {66,0.00006034}, {67,0.00000000}, {68,0.00003448}, {69,0.00000000}, {70,0.00010345}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00006034}, {75,0.00003448}, {76,0.00003448}, {77,0.00003448}, {78,0.00006897}, {79,0.00002586}, {80,0.00002586}, {81,0.00006034}, {82,0.00006034}, {83,0.00000000}, {84,0.00022414}, {85,0.00017241}, {86,0.00000000}, {87,0.00006897}, {88,0.00002586}, {89,0.00000000}, {90,0.00003448}, {91,0.00002586}, {92,0.00000000}, {93,0.00003448}, {94,0.00006897}, {95,0.00010345}, {96,0.00002586}, {97,0.00000000}, {98,0.00010345}, {99,0.00059483}, {100,0.00006897}, {101,0.00009483}, {102,0.00006034}, {103,0.00012931}, {104,0.00000000}, {105,0.00003448}, {106,0.00006034}, {107,0.00006897}, {108,0.00011207}, {109,0.00006034}, {110,0.00005172}, {111,0.00006034}, {112,0.00003448}, {113,0.00015517}, {114,0.00002586}, {115,0.00003448}, {116,0.00003448}, {117,0.00006034}, {118,0.00003448}, {119,0.00002586}, {120,0.00006897}, {121,0.00006897}, {122,0.00006897}, {123,0.00003448}, {124,0.00000000}, {125,0.00053448}, {126,0.00015517}, {127,0.00003448}, {128,0.00003448}, {129,0.00000000}, {130,0.00002586}, {131,0.00012931}, {132,0.00000000}, {133,0.00006897}, {134,0.00003448}, {135,0.00000000}, {136,0.00062069}, {137,0.00007759}, {138,0.00000000}, {139,0.00006897}, {140,0.00007759}, {141,0.00000000}, {142,0.00002586}, {143,0.00006034}, {144,0.00002586}, {145,0.00002586}, {146,0.00102586}, {147,0.00009483}, {148,0.00015517}, {149,0.00006897}, {150,0.00002586}, {151,0.00006034}, {152,0.00006897}, {153,0.00010345}, {154,0.00003448}, {155,0.00009483}, {156,0.00050000}, {157,0.00012931}, {158,0.00003448}, {159,0.00003448}, {160,0.00003448}, {161,0.00003448}, {162,0.00003448}, {163,0.00006034}, {164,0.00010345}, {165,0.00050000}, {166,0.00013793}, {167,0.00005172}, {168,0.00000000}, {169,0.00000000}, {170,0.00006897}, {171,0.00003448}, {172,0.00015517}, {173,0.00003448}, {174,0.00022414}, {175,0.00003448}, {176,0.00000000}, {177,0.00002586}, {178,0.00008621}, {179,0.00022414}, {180,0.00017241}, {181,0.00006034}, {182,0.00052586}, {183,0.00010345}, {184,0.00010345}, {185,0.00005172}, {186,0.00003448}, {187,0.00006897}, {188,0.00000000}, {189,0.00000000}, {190,0.00046552}, {191,0.00009483}, {192,0.00006897}, {193,0.00000000}, {194,0.00006897}, {195,0.00003448}, {196,0.00010345}, {197,0.00000000}, {198,0.00022414}, {199,0.00016379}, {200,0.00010345}, {201,0.00013793}, {202,0.00000000}, {203,0.00003448}, {204,0.00006034}, {205,0.00010345}, {206,0.00023276}, {207,0.00002586}, {208,0.00006897}, {209,0.00003448}, {210,0.00012931}, {211,0.00003448}, {212,0.00006897}, {213,0.00003448}, {214,0.00006034}, {215,0.00010345}, {216,0.00009483}, {217,0.00010345}, {218,0.00017241}, {219,0.00006034}, {220,0.00010345}, {221,0.00013793}, {222,0.00006897}, {223,0.00013793}, {224,0.00010345}, {225,0.00039655}, {226,0.00019828}, {227,0.00006034}, {228,0.00009483}, {229,0.00003448}, {230,0.00009483}, {231,0.00012931}, {232,0.00003448}, {233,0.00006897}, {234,0.00006897}, {235,0.00012931}, {236,0.00009483}, {237,0.00006897}, {238,0.00043966}, {239,0.00013793}, {240,0.00016379}, {241,0.00006897}, {242,0.00010345}, {243,0.00012931}, {244,0.00050000}, {245,0.00002586}, {246,0.00019828}, {247,0.00013793}, {248,0.00006897}, {249,0.00012931}, {250,0.00039655}, {251,0.00000000}, {252,0.00006897}, {253,0.00006897}, {254,0.00003448}, {255,0.00003448}, {256,0.00024138}, {257,0.00018966}, {258,0.00003448}, {259,0.00003448}, {260,0.00000000}, {261,0.00003448}, {262,0.00016379}, {263,0.00026724}, {264,0.00017241}, {265,0.00010345}, {266,0.00003448}, {267,0.00067241}, {268,0.00010345}, {269,0.00010345}, {270,0.00006034}, {271,0.00020690}, {272,0.00016379}, {273,0.00006897}, {274,0.00009483}, {275,0.00010345}, {276,0.00010345}, {277,0.00012931}, {278,0.00037931}, {279,0.00016379}, {280,0.00006897}, {281,0.00017241}, {282,0.00017241}, {283,0.00018966}, {284,0.00000000}, {285,0.00003448}, {286,0.00003448}, {287,0.00006897}, {288,0.00034483}, {289,0.00017241}, {290,0.00005172}, {291,0.00013793}, {292,0.00000000}, {293,0.00052586}, {294,0.00012931}, {295,0.00006897}, {296,0.00003448}, {297,0.00013793}, {298,0.00074138}, {299,0.00013793}, {300,0.00002586}, {301,0.00013793}, {302,0.00019828}, {303,0.00095690}, {304,0.00012069}, {305,0.00023276}, {306,0.00013793}, {307,0.00022414}, {308,0.00039655}, {309,0.00016379}, {310,0.00022414}, {311,0.00014655}, {312,0.00015517}, {313,0.00009483}, {314,0.00025862}, {315,0.00012931}, {316,0.00018966}, {317,0.00061207}, {318,0.00019828}, {319,0.00013793}, {320,0.00018103}, {321,0.00017241}, {322,0.00057759}, {323,0.00009483}, {324,0.00024138}, {325,0.00020690}, {326,0.00012931}, {327,0.00012931}, {328,0.00020690}, {329,0.00017241}, {330,0.00003448}, {331,0.00051724}, {332,0.00017241}, {333,0.00017241}, {334,0.00013793}, {335,0.00012069}, {336,0.00017241}, {337,0.00009483}, {338,0.00019828}, {339,0.00009483}, {340,0.00064655}, {341,0.00019828}, {342,0.00003448}, {343,0.00012931}, {344,0.00062069}, {345,0.00006034}, {346,0.00024138}, {347,0.00009483}, {348,0.00017241}, {349,0.00010345}, {350,0.00010345}, {351,0.00016379}, {352,0.00012931}, {353,0.00010345}, {354,0.00006897}, {355,0.00003448}, {356,0.00006897}, {357,0.00013793}, {358,0.00006034}, {359,0.00010345}, {360,0.00006034}, {361,0.00034483}, {362,0.00025862}, {363,0.00000000}, {364,0.00012931}, {365,0.00081034}, {366,0.00017241}, {367,0.00018966}, {368,0.00017241}, {369,0.00081034}, {370,0.00006897}, {371,0.00013793}, {372,0.00006897}, {373,0.00074138}, {374,0.00017241}, {375,0.00024138}, {376,0.00006897}, {377,0.00097414}, {378,0.00038793}, {379,0.00013793}, {380,0.00010345}, {381,0.00060345}, {382,0.00026724}, {383,0.00003448}, {384,0.00006034}, {385,0.00074138}, {386,0.00029310}, {387,0.00012931}, {388,0.00010345}, {389,0.00010345}, {390,0.00006897}, {391,0.00020690}, {392,0.00009483}, {393,0.00020690}, {394,0.00013793}, {395,0.00017241}, {396,0.00020690}, {397,0.00010345}, {398,0.00013793}, {399,0.00765517}, {400,0.00070690}, {401,0.00016379}, {402,0.00027586}, {403,0.00080172}, {404,0.00017241}, {405,0.00010345}, {406,0.00017241}, {407,0.00017241}, {408,0.00010345}, {409,0.00006034}, {410,0.00068103}, {411,0.00023276}, {412,0.00012931}, {413,0.00020690}, {414,0.00083621}, {415,0.00011207}, {416,0.00017241}, {417,0.00018966}, {418,0.00026724}, {419,0.00024138}, {420,0.00016379}, {421,0.00043966}, {422,0.00017241}, {423,0.00010345}, {424,0.00013793}, {425,0.00021552}, {426,0.00008621}, {427,0.00006897}, {428,0.00081897}, {429,0.00025000}, {430,0.00020690}, {431,0.00010345}, {432,0.00017241}, {433,0.00003448}, {434,0.00013793}, {435,0.00062069}, {436,0.00009483}, {437,0.00027586}, {438,0.00047414}, {439,0.00017241}, {440,0.00010345}, {441,0.00008621}, {442,0.00017241}, {443,0.00017241}, {444,0.00012931}, {445,0.00077586}, {446,0.00009483}, {447,0.00006034}, {448,0.00054310}, {449,0.00013793}, {450,0.00010345}, {451,0.00009483}, {452,0.00017241}, {453,0.00003448}, {454,0.00009483}, {455,0.00061207}, {456,0.00020690}, {457,0.00017241}, {458,0.00067241}, {459,0.00017241}, {460,0.00013793}, {461,0.00020690}, {462,0.00037931}, {463,0.00006897}, {464,0.00016379}, {465,0.00019828}, {466,0.00027586}, {467,0.00009483}, {468,0.00003448}, {469,0.00022414}, {470,0.00017241}, {471,0.00010345}, {472,0.00006897}, {473,0.00031034}, {474,0.00055172}, {475,0.00023276}, {476,0.00012931}, {477,0.00058621}, {478,0.00012931}, {479,0.00010345}, {480,0.00010345}, {481,0.00023276}, {482,0.00010345}, {483,0.00022414}, {484,0.00013793}, {485,0.00027586}, {486,0.00017241}, {487,0.00006897}, {488,0.00016379}, {489,0.00010345}, {490,0.00006897}, {491,0.00020690}, {492,0.00024138}, {493,0.00006897}, {494,0.00025862}, {495,0.00016379}, {496,0.00017241}, {497,0.00010345}, {498,0.00024138}, {499,0.00013793}, {500,0.000212121}, {505,0.00023478}, {510,0.00020870}, {515,0.00006957}, {520,0.00020000}, {525,0.00017391}, {530,0.00031304}, {535,0.00026957}, {540,0.00030435}, {545,0.00082609}, {550,0.00010435}, {555,0.00013043}, {560,0.00072174}, {565,0.00017544}, {570,0.00017544}, {575,0.00014035}, {580,0.00025439}, {585,0.00083333}, {590,0.00014035}, {595,0.00026316}, {600,0.00031304}, {605,0.00014035}, {610,0.00080702}, {615,0.00015789}, {620,0.00024561}, {625,0.00014035}, {630,0.00021053}, {635,0.00111404}, {640,0.00024561}, {645,0.00041228}, {650,0.00010526}, {655,0.00030702}, {660,0.00027193}, {665,0.00007018}, {670,0.00023684}, {675,0.00016667}, {680,0.00065789}, {685,0.00043860}, {690,0.00097368}, {695,0.00028070}, {700,0.00071304}, {705,0.00023684}, {710,0.00076316}, {715,0.00021053}, {720,0.00021053}, {725,0.00010526}, {730,0.00006140}, {735,0.00023684}, {740,0.00016667}, {745,0.00041228}, {750,0.00021053}, {755,0.00023684}, {760,0.00024561}, {765,0.00031579}, {770,0.00759649}, {775,0.00560526}, {780,0.00041228}, {785,0.00093860}, {790,0.00034211}, {795,0.00126316}, {800,0.00045217}, {805,0.00089474}, {810,0.00031579}, {815,0.00022807}, {820,0.00021053}, {825,0.00028070}, {830,0.00041228}, {835,0.00030702}, {840,0.00128070}, {845,0.00031579}, {850,0.00063158}, {855,0.00021053}, {860,0.00028070}, {865,0.00016667}, {870,0.00017544}, {875,0.00030702}, {880,0.00023684}, {885,0.00017544}, {890,0.00014035}, {895,0.00013158}, {900,0.00033043}, {905,0.00056140}, {910,0.00024561}, {915,0.00035088}, {920,0.00016667}, {925,0.00085088}, {930,0.00048246}, {935,0.00038596}, {940,0.00093860}, {945,0.00013158}, {950,0.00038596}, {955,0.00093860}, {960,0.00034211}, {965,0.00021053}, {970,0.00099123}, {975,0.00028070}, {980,0.00063158}, {985,0.00080702}, {990,0.00035088}, {995,0.00028070}, {1000,0.00093913}, {1010,0.00550}, {1020,0.00000}, {1030,0.00000}, {1040,0.00300}, {1050,0.00000}, {1060,0.00000}, {1070,0.00000}, {1080,0.00300}, {1090,0.00000}, {1100,0.00075}, {1110,0.00000}, {1120,0.00100}, {1130,0.00100}, {1140,0.00000}, {1150,0.00100}, {1160,0.00200}, {1170,0.00000}, {1180,0.00000}, {1190,0.00000}, {1200,0.00200}, {1210,0.00100}, {1220,0.00275}, {1230,0.00100}, {1240,0.00000}, {1250,0.00000}, {1260,0.00100}, {1270,0.00100}, {1280,0.00200}, {1290,0.00100}, {1300,0.00075}, {1310,0.00000}, {1320,0.00000}, {1330,0.00175}, {1340,0.00300}, {1350,0.00400}, {1360,0.00000}, {1370,0.00100}, {1380,0.00100}, {1390,0.00000}, {1400,0.00000}, {1410,0.00000}, {1420,0.00000}, {1430,0.00000}, {1440,0.00000}, {1450,0.00000}, {1460,0.00100}, {1470,0.00000}, {1480,0.00000}, {1490,0.00000}, {1500,0.00000}, {1510,0.00200}, {1520,0.00000}, {1530,0.00000}, {1540,0.00000}, {1550,0.00000}, {1560,0.00100}, {1570,0.00000}, {1580,0.00000}, {1590,0.00000}, {1600,0.00100}, {1610,0.00375}, {1620,0.00375}, {1630,0.00100}, {1640,0.00100}, {1650,0.00100}, {1660,0.00000}, {1670,0.00000}, {1680,0.00100}, {1690,0.00400}, {1700,0.00775}, {1710,0.00400}, {1720,0.00000}, {1730,0.00000}, {1740,0.00375}, {1750,0.00400}, {1760,0.00875}, {1770,0.00600}, {1780,0.00000}, {1790,0.00000}, {1800,0.00500}, {1810,0.00700}, {1820,0.00575}, {1830,0.00000}, {1840,0.00700}, {1850,0.00775}, {1860,0.00800}, {1870,0.00100}, {1880,0.00400}, {1890,0.00600}, {1900,0.00500}, {1910,0.00200}, {1920,0.00000}, {1930,0.00000}, {1940,0.00000}, {1950,0.00200}, {1960,0.00100}, {1970,0.00000}, {1980,0.00000}, {1990,0.00700}, {2000,0.00460}, {2050,0.00400}, {2100,0.00675}, {2150,0.00000}, {2200,0.00600}, {2250,0.09375}, {2300,0.00100}, {2350,0.00700}, {2400,0.00600}, {2450,0.00575}, {2500,0.00160}, {2550,0.00700}, {2600,0.00600}, {2650,0.01000}, {2700,0.00500}, {2750,0.00700}, {2800,0.00500}, {2850,0.00975}, {2900,0.00700}, {2950,0.01200}, {3000,0.00640}, {3050,0.00200}, {3100,0.00075}, {3150,0.00000}, {3200,0.01000}, {3250,0.00900}, {3300,0.00700}, {3350,0.01400}, {3400,0.00675}, {3450,0.00900}, {3500,0.01280}, {3550,0.00775}, {3600,0.00800}, {3650,0.00500}, {3700,0.00800}, {3750,0.01100}, {3800,0.00600}, {3850,0.00800}, {3900,0.00900}, {3950,0.00900}, {4000,0.00640}, {4050,0.01000}, {4100,0.01200}, {4150,0.01100}, {4200,0.01400}, {4250,0.00900}, {4300,0.01200}, {4350,0.01075}, {4400,0.01000}, {4450,0.01100}, {4500,0.01280}, {4550,0.00900}, {4600,0.18125}, {4650,0.00800}, {4700,0.00375}, {4750,0.00000}, {4800,0.00200}, {4850,0.00000}, {4900,0.00100}, {4950,0.00300}, {5000,0.00080}};
data["big_flat"]["Parsing"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00001724}, {12,0.00000862}, {13,0.00029310}, {14,0.00062931}, {15,0.00093966}, {16,0.00098276}, {17,0.00100000}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00100000}, {23,0.00100000}, {24,0.00100000}, {25,0.00100000}, {26,0.00100862}, {27,0.00100000}, {28,0.00112069}, {29,0.00108621}, {30,0.00137069}, {31,0.00137069}, {32,0.00162069}, {33,0.00300000}, {34,0.00188793}, {35,0.00200000}, {36,0.05306897}, {37,0.00200000}, {38,0.00200000}, {39,0.00200000}, {40,0.00200000}, {41,0.00200000}, {42,0.00200000}, {43,0.00200000}, {44,0.00200000}, {45,0.00200000}, {46,0.00200000}, {47,0.00200000}, {48,0.00200000}, {49,0.00200862}, {50,0.00200862}, {51,0.00202586}, {52,0.00212931}, {53,0.00254310}, {54,0.00283621}, {55,0.00298276}, {56,0.00300000}, {57,0.00300000}, {58,0.00300000}, {59,0.00300000}, {60,0.00300000}, {61,0.00300000}, {62,0.00300000}, {63,0.00300000}, {64,0.05392241}, {65,0.00300000}, {66,0.00300862}, {67,0.00304310}, {68,0.00302586}, {69,0.00318103}, {70,0.00347414}, {71,0.00353448}, {72,0.00393966}, {73,0.00398276}, {74,0.00400000}, {75,0.00400000}, {76,0.00400000}, {77,0.00400000}, {78,0.00400000}, {79,0.00400000}, {80,0.00400000}, {81,0.00400000}, {82,0.00400000}, {83,0.00400000}, {84,0.00403448}, {85,0.00413793}, {86,0.00421552}, {87,0.00475862}, {88,0.00488793}, {89,0.00486207}, {90,0.00498276}, {91,0.00500000}, {92,0.00500000}, {93,0.00500000}, {94,0.00500000}, {95,0.00500000}, {96,0.00500000}, {97,0.00500000}, {98,0.01676724}, {99,0.05568103}, {100,0.00500862}, {101,0.00518103}, {102,0.00540517}, {103,0.00569828}, {104,0.00549138}, {105,0.00535345}, {106,0.00566379}, {107,0.00595690}, {108,0.00599138}, {109,0.00600000}, {110,0.00599138}, {111,0.00600000}, {112,0.00600000}, {113,0.00600000}, {114,0.00600000}, {115,0.00600000}, {116,0.00600862}, {117,0.00600862}, {118,0.00601724}, {119,0.00606897}, {120,0.00646552}, {121,0.00668966}, {122,0.00685345}, {123,0.00689655}, {124,0.00684483}, {125,0.03764655}, {126,0.00698276}, {127,0.00698276}, {128,0.00699138}, {129,0.00700000}, {130,0.00700000}, {131,0.00700000}, {132,0.00700000}, {133,0.00702586}, {134,0.00702586}, {135,0.00709483}, {136,0.03979310}, {137,0.00726724}, {138,0.00777586}, {139,0.00787931}, {140,0.00737931}, {141,0.00725000}, {142,0.00756034}, {143,0.00799138}, {144,0.00795690}, {145,0.00797414}, {146,0.04404310}, {147,0.00799138}, {148,0.00799138}, {149,0.00800000}, {150,0.00800000}, {151,0.00800000}, {152,0.00800000}, {153,0.00800000}, {154,0.00801724}, {155,0.00801724}, {156,0.03825862}, {157,0.00800000}, {158,0.00804310}, {159,0.00819828}, {160,0.00866379}, {161,0.00870690}, {162,0.00887069}, {163,0.00878448}, {164,0.00893966}, {165,0.03956034}, {166,0.00900000}, {167,0.00900000}, {168,0.00900000}, {169,0.00900000}, {170,0.00900862}, {171,0.00901724}, {172,0.00900862}, {173,0.00900000}, {174,0.00903448}, {175,0.00907759}, {176,0.00905172}, {177,0.00934483}, {178,0.00932759}, {179,0.00931897}, {180,0.00981034}, {181,0.00994828}, {182,0.04349138}, {183,0.00993966}, {184,0.00999138}, {185,0.01000000}, {186,0.01000000}, {187,0.00999138}, {188,0.01000000}, {189,0.01000000}, {190,0.04440517}, {191,0.01000862}, {192,0.01000000}, {193,0.01013793}, {194,0.01050000}, {195,0.01060345}, {196,0.01063793}, {197,0.01027586}, {198,0.01081897}, {199,0.01070690}, {200,0.01081897}, {201,0.01093966}, {202,0.01099138}, {203,0.01100000}, {204,0.01100000}, {205,0.01100000}, {206,0.01100000}, {207,0.01100000}, {208,0.01100862}, {209,0.01100000}, {210,0.01101724}, {211,0.01102586}, {212,0.01186207}, {213,0.01189655}, {214,0.01197414}, {215,0.01199138}, {216,0.01199138}, {217,0.01198276}, {218,0.01200862}, {219,0.01200000}, {220,0.01200000}, {221,0.01200000}, {222,0.01200000}, {223,0.01201724}, {224,0.01207759}, {225,0.05762931}, {226,0.01240517}, {227,0.01256034}, {228,0.01244828}, {229,0.01264655}, {230,0.01282759}, {231,0.01293966}, {232,0.01292241}, {233,0.01298276}, {234,0.01299138}, {235,0.01300000}, {236,0.01300000}, {237,0.01301724}, {238,0.04280172}, {239,0.01300000}, {240,0.01304310}, {241,0.01302586}, {242,0.01306897}, {243,0.01312931}, {244,0.04774138}, {245,0.01316379}, {246,0.01362069}, {247,0.01390517}, {248,0.01378448}, {249,0.01362931}, {250,0.04441379}, {251,0.01391379}, {252,0.01394828}, {253,0.01397414}, {254,0.01399138}, {255,0.01400000}, {256,0.05812931}, {257,0.01401724}, {258,0.01403448}, {259,0.01401724}, {260,0.01402586}, {261,0.01421552}, {262,0.01443103}, {263,0.01465517}, {264,0.01469828}, {265,0.01476724}, {266,0.01478448}, {267,0.05667241}, {268,0.01495690}, {269,0.01499138}, {270,0.01498276}, {271,0.01500000}, {272,0.01500000}, {273,0.01500000}, {274,0.01501724}, {275,0.01507759}, {276,0.01509483}, {277,0.01531897}, {278,0.04813793}, {279,0.01528448}, {280,0.01543103}, {281,0.01547414}, {282,0.01503448}, {283,0.01503448}, {284,0.01501724}, {285,0.01506034}, {286,0.01512931}, {287,0.01524138}, {288,0.04181034}, {289,0.01561207}, {290,0.01566379}, {291,0.01576724}, {292,0.01586207}, {293,0.04589655}, {294,0.01597414}, {295,0.01599138}, {296,0.01600000}, {297,0.01600862}, {298,0.04493103}, {299,0.01600000}, {300,0.01601724}, {301,0.01600862}, {302,0.01602586}, {303,0.04791379}, {304,0.01603448}, {305,0.01622414}, {306,0.01633621}, {307,0.01639655}, {308,0.01661207}, {309,0.01666379}, {310,0.01674138}, {311,0.01691379}, {312,0.01690517}, {313,0.01696552}, {314,0.01698276}, {315,0.01697414}, {316,0.01700000}, {317,0.04734483}, {318,0.01700000}, {319,0.01700862}, {320,0.01700862}, {321,0.01706034}, {322,0.04856897}, {323,0.01713793}, {324,0.01735345}, {325,0.01734483}, {326,0.01758621}, {327,0.01756034}, {328,0.01775862}, {329,0.01789655}, {330,0.01791379}, {331,0.05019828}, {332,0.01796552}, {333,0.01799138}, {334,0.01800000}, {335,0.01800862}, {336,0.01800862}, {337,0.01800000}, {338,0.01800862}, {339,0.01802586}, {340,0.05068966}, {341,0.01812931}, {342,0.01814655}, {343,0.01828448}, {344,0.05074138}, {345,0.01841379}, {346,0.01860345}, {347,0.01878448}, {348,0.01884483}, {349,0.01885345}, {350,0.01891379}, {351,0.01893103}, {352,0.01899138}, {353,0.01937931}, {354,0.01948276}, {355,0.01960345}, {356,0.01979310}, {357,0.06564655}, {358,0.01986207}, {359,0.01990517}, {360,0.01994828}, {361,0.07725862}, {362,0.01997414}, {363,0.01998276}, {364,0.02002586}, {365,0.05318966}, {366,0.02007759}, {367,0.02012069}, {368,0.02017241}, {369,0.05262931}, {370,0.02019828}, {371,0.02043966}, {372,0.02046552}, {373,0.05270690}, {374,0.02078448}, {375,0.02079310}, {376,0.02080172}, {377,0.05561207}, {378,0.02093103}, {379,0.02093103}, {380,0.02097414}, {381,0.07463793}, {382,0.02100862}, {383,0.02099138}, {384,0.02100862}, {385,0.08168966}, {386,0.02112931}, {387,0.02125862}, {388,0.02141379}, {389,0.02149138}, {390,0.02150000}, {391,0.02175000}, {392,0.02179310}, {393,0.02174138}, {394,0.02185345}, {395,0.02187069}, {396,0.02193966}, {397,0.02193103}, {398,0.02200000}, {399,0.43366379}, {400,0.02121552}, {401,0.02136207}, {402,0.02159483}, {403,0.04964655}, {404,0.02172414}, {405,0.02180172}, {406,0.02189655}, {407,0.02190517}, {408,0.02194828}, {409,0.02197414}, {410,0.04852586}, {411,0.02200862}, {412,0.02201724}, {413,0.02203448}, {414,0.05203448}, {415,0.02206034}, {416,0.02206034}, {417,0.02208621}, {418,0.02234483}, {419,0.02235345}, {420,0.02247414}, {421,0.05406034}, {422,0.02268966}, {423,0.02275000}, {424,0.02285345}, {425,0.02283621}, {426,0.02287931}, {427,0.02296552}, {428,0.05279310}, {429,0.02299138}, {430,0.02299138}, {431,0.02301724}, {432,0.02300862}, {433,0.02303448}, {434,0.02307759}, {435,0.05302586}, {436,0.02321552}, {437,0.02318966}, {438,0.05401724}, {439,0.02337069}, {440,0.02354310}, {441,0.02370690}, {442,0.02375862}, {443,0.02379310}, {444,0.02390517}, {445,0.05327586}, {446,0.02393966}, {447,0.02397414}, {448,0.05415517}, {449,0.02400862}, {450,0.02401724}, {451,0.02402586}, {452,0.02406034}, {453,0.02412069}, {454,0.02412931}, {455,0.05460345}, {456,0.02437069}, {457,0.02428448}, {458,0.05762931}, {459,0.02456034}, {460,0.02469828}, {461,0.02479310}, {462,0.02484483}, {463,0.02487931}, {464,0.02491379}, {465,0.02495690}, {466,0.02497414}, {467,0.02500000}, {468,0.05435345}, {469,0.02500862}, {470,0.02501724}, {471,0.05183621}, {472,0.02508621}, {473,0.02518103}, {474,0.10650862}, {475,0.02604310}, {476,0.02600862}, {477,0.09671552}, {478,0.02620690}, {479,0.02619828}, {480,0.02638793}, {481,0.02639655}, {482,0.02648276}, {483,0.02670690}, {484,0.02666379}, {485,0.02677586}, {486,0.02680172}, {487,0.02681034}, {488,0.02687931}, {489,0.02687931}, {490,0.02693103}, {491,0.02694828}, {492,0.02698276}, {493,0.02702586}, {494,0.02702586}, {495,0.02706034}, {496,0.02716379}, {497,0.02707759}, {498,0.02723276}, {499,0.02743966}, {500,0.027445887}, {505,0.02782609}, {510,0.02797391}, {515,0.02855652}, {520,0.02886957}, {525,0.02902609}, {530,0.02924348}, {535,0.02969565}, {540,0.02988696}, {545,0.09566087}, {550,0.03046087}, {555,0.03085217}, {560,0.08988696}, {565,0.03118421}, {570,0.03164912}, {575,0.03181579}, {580,0.03201754}, {585,0.09185088}, {590,0.03270175}, {595,0.03288596}, {600,0.03307826}, {605,0.03350877}, {610,0.09338596}, {615,0.03396491}, {620,0.03414035}, {625,0.03458772}, {630,0.03487719}, {635,0.06452632}, {640,0.03559649}, {645,0.07037719}, {650,0.03593860}, {655,0.03625439}, {660,0.03658772}, {665,0.03683333}, {670,0.03702632}, {675,0.03731579}, {680,0.06914035}, {685,0.03787719}, {690,0.06946491}, {695,0.03856140}, {700,0.07136522}, {705,0.03895614}, {710,0.07475439}, {715,0.03964035}, {720,0.03982456}, {725,0.04003509}, {730,0.04032456}, {735,0.04072807}, {740,0.04094737}, {745,0.04108772}, {750,0.04153509}, {755,0.04179825}, {760,0.04195614}, {765,0.04100877}, {770,0.59543860}, {775,0.16792982}, {780,0.04222807}, {785,0.07750877}, {790,0.04269298}, {795,0.07768421}, {800,0.04308696}, {805,0.07581579}, {810,0.04373684}, {815,0.04392105}, {820,0.04412281}, {825,0.04441228}, {830,0.04478947}, {835,0.04497368}, {840,0.08016667}, {845,0.04549123}, {850,0.07754386}, {855,0.04595614}, {860,0.04626316}, {865,0.07644737}, {870,0.04683333}, {875,0.08291228}, {880,0.04733333}, {885,0.04771930}, {890,0.04792982}, {895,0.04814912}, {900,0.08585217}, {905,0.04875439}, {910,0.04891228}, {915,0.08199123}, {920,0.04949123}, {925,0.08450000}, {930,0.05004386}, {935,0.05166667}, {940,0.09599123}, {945,0.05203509}, {950,0.05246491}, {955,0.08544737}, {960,0.05300000}, {965,0.05327193}, {970,0.08724561}, {975,0.05383333}, {980,0.05400877}, {985,0.11636842}, {990,0.05470175}, {995,0.05484211}, {1000,0.12188696}, {1010,0.10900}, {1020,0.05425}, {1030,0.05675}, {1040,0.09975}, {1050,0.06850}, {1060,0.05850}, {1070,0.08550}, {1080,0.09100}, {1090,0.06025}, {1100,0.05925}, {1110,0.08350}, {1120,0.08625}, {1130,0.06075}, {1140,0.06175}, {1150,0.09000}, {1160,0.09750}, {1170,0.06300}, {1180,0.06375}, {1190,0.06375}, {1200,0.12000}, {1210,0.10925}, {1220,0.11125}, {1230,0.06800}, {1240,0.06850}, {1250,0.06925}, {1260,0.10300}, {1270,0.11250}, {1280,0.10600}, {1290,0.07150}, {1300,0.07200}, {1310,0.07250}, {1320,0.07100}, {1330,0.10025}, {1340,0.10375}, {1350,0.16300}, {1360,0.10725}, {1370,0.10925}, {1380,0.11125}, {1390,0.10775}, {1400,0.07575}, {1410,0.07775}, {1420,0.07850}, {1430,0.07900}, {1440,0.07950}, {1450,0.08025}, {1460,0.08025}, {1470,0.08150}, {1480,0.08200}, {1490,0.08250}, {1500,0.09380}, {1510,0.08350}, {1520,0.08475}, {1530,0.08500}, {1540,0.08475}, {1550,0.08625}, {1560,0.08400}, {1570,0.08450}, {1580,0.08550}, {1590,0.12150}, {1600,0.12725}, {1610,0.13275}, {1620,0.24900}, {1630,0.10900}, {1640,0.08850}, {1650,0.09075}, {1660,0.09125}, {1670,0.12825}, {1680,0.13250}, {1690,0.14875}, {1700,0.15325}, {1710,0.14450}, {1720,0.09500}, {1730,0.09450}, {1740,0.15350}, {1750,0.17900}, {1760,0.16700}, {1770,0.13025}, {1780,0.09800}, {1790,0.09825}, {1800,0.15000}, {1810,0.14600}, {1820,0.13300}, {1830,0.09800}, {1840,0.12900}, {1850,0.14550}, {1860,0.14000}, {1870,0.10050}, {1880,0.12925}, {1890,0.14950}, {1900,0.14225}, {1910,0.10250}, {1920,0.12875}, {1930,0.14150}, {1940,0.12525}, {1950,0.13275}, {1960,0.14725}, {1970,0.13600}, {1980,0.10575}, {1990,0.17025}, {2000,0.13620}, {2050,0.16225}, {2100,0.18000}, {2150,0.11950}, {2200,0.16175}, {2250,1.35075}, {2300,0.12750}, {2350,0.17200}, {2400,0.17175}, {2450,0.18450}, {2500,0.17780}, {2550,0.17375}, {2600,0.18175}, {2650,0.18400}, {2700,0.18075}, {2750,0.18800}, {2800,0.19425}, {2850,0.19800}, {2900,0.20275}, {2950,0.23800}, {3000,0.20660}, {3050,0.20575}, {3100,0.21075}, {3150,0.21225}, {3200,0.22125}, {3250,0.29525}, {3300,0.22975}, {3350,0.28025}, {3400,0.28450}, {3450,0.26450}, {3500,0.32400}, {3550,0.29300}, {3600,0.32125}, {3650,0.30525}, {3700,0.27550}, {3750,0.26325}, {3800,0.27150}, {3850,0.26725}, {3900,0.27700}, {3950,0.26200}, {4000,0.27520}, {4050,0.27225}, {4100,0.28000}, {4150,0.27150}, {4200,0.28550}, {4250,0.28875}, {4300,0.29950}, {4350,0.29325}, {4400,0.29925}, {4450,0.30250}, {4500,0.31220}, {4550,0.30600}, {4600,1.78550}, {4650,0.31950}, {4700,0.39275}, {4750,0.38575}, {4800,0.41000}, {4850,0.38325}, {4900,0.41100}, {4950,0.39525}, {5000,0.34240}};
data["big_flat"]["Parsing"]["reif"]["user"] = {{1,0.00000000}, {2,0.00002586}, {3,0.00032759}, {4,0.00031897}, {5,0.00024138}, {6,0.00046552}, {7,0.00050862}, {8,0.00078448}, {9,0.00062069}, {10,0.00077586}, {11,0.00066379}, {12,0.00088793}, {13,0.00080172}, {14,0.00093103}, {15,0.00125000}, {16,0.00089655}, {17,0.00100000}, {18,0.00118966}, {19,0.00120690}, {20,0.00131034}, {21,0.00141379}, {22,0.00157759}, {23,0.00155172}, {24,0.00150000}, {25,0.00160345}, {26,0.00183621}, {27,0.00185345}, {28,0.00169828}, {29,0.00162069}, {30,0.00133621}, {31,0.00166379}, {32,0.00178448}, {33,0.00323276}, {34,0.00170690}, {35,0.00218103}, {36,0.05109483}, {37,0.00212069}, {38,0.00206897}, {39,0.00209483}, {40,0.00233621}, {41,0.00224138}, {42,0.00224138}, {43,0.00250000}, {44,0.00236207}, {45,0.00255172}, {46,0.00268103}, {47,0.00247414}, {48,0.00243966}, {49,0.00253448}, {50,0.00277586}, {51,0.00302586}, {52,0.00300000}, {53,0.00286207}, {54,0.00324138}, {55,0.00292241}, {56,0.00312069}, {57,0.00319828}, {58,0.00327586}, {59,0.00324138}, {60,0.00327586}, {61,0.00330172}, {62,0.00331034}, {63,0.00330172}, {64,0.05393966}, {65,0.00377586}, {66,0.00384483}, {67,0.00373276}, {68,0.00364655}, {69,0.00389655}, {70,0.00381897}, {71,0.00394828}, {72,0.00406897}, {73,0.00417241}, {74,0.00419828}, {75,0.00423276}, {76,0.00431034}, {77,0.00434483}, {78,0.00437931}, {79,0.00443966}, {80,0.00450000}, {81,0.00444828}, {82,0.00436207}, {83,0.00483621}, {84,0.00475862}, {85,0.00451724}, {86,0.00509483}, {87,0.00473276}, {88,0.00492241}, {89,0.00516379}, {90,0.00524138}, {91,0.00510345}, {92,0.00520690}, {93,0.00529310}, {94,0.00519828}, {95,0.00537931}, {96,0.00548276}, {97,0.00562069}, {98,0.01737931}, {99,0.05550862}, {100,0.00558621}, {101,0.00559483}, {102,0.00556034}, {103,0.00600000}, {104,0.00629310}, {105,0.00615517}, {106,0.00611207}, {107,0.00616379}, {108,0.00568966}, {109,0.00606897}, {110,0.00648276}, {111,0.00613793}, {112,0.00634483}, {113,0.00639655}, {114,0.00650000}, {115,0.00651724}, {116,0.00643103}, {117,0.00658621}, {118,0.00663793}, {119,0.00659483}, {120,0.00677586}, {121,0.00688793}, {122,0.00703448}, {123,0.00710345}, {124,0.00706897}, {125,0.03755172}, {126,0.00706897}, {127,0.00748276}, {128,0.00734483}, {129,0.00744828}, {130,0.00737931}, {131,0.00758621}, {132,0.00751724}, {133,0.00779310}, {134,0.00771552}, {135,0.00766379}, {136,0.03905172}, {137,0.00773276}, {138,0.00812069}, {139,0.00798276}, {140,0.00772414}, {141,0.00782759}, {142,0.00795690}, {143,0.00816379}, {144,0.00823276}, {145,0.00811207}, {146,0.04338793}, {147,0.00817241}, {148,0.00848276}, {149,0.00824138}, {150,0.00827586}, {151,0.00848276}, {152,0.00844828}, {153,0.00813793}, {154,0.00865517}, {155,0.00872414}, {156,0.03834483}, {157,0.00865517}, {158,0.00879310}, {159,0.00888793}, {160,0.00906897}, {161,0.00898276}, {162,0.00888793}, {163,0.00877586}, {164,0.00893966}, {165,0.03937069}, {166,0.00928448}, {167,0.00931034}, {168,0.00935345}, {169,0.00926724}, {170,0.00910345}, {171,0.00968966}, {172,0.00979310}, {173,0.00993103}, {174,0.00968966}, {175,0.00993103}, {176,0.01006897}, {177,0.01006897}, {178,0.00979310}, {179,0.00965517}, {180,0.00974138}, {181,0.01002586}, {182,0.04305172}, {183,0.00974138}, {184,0.00989655}, {185,0.01018966}, {186,0.01016379}, {187,0.01030172}, {188,0.01031897}, {189,0.01029310}, {190,0.04461207}, {191,0.01043966}, {192,0.01057759}, {193,0.01089655}, {194,0.01096552}, {195,0.01106897}, {196,0.01082759}, {197,0.01086207}, {198,0.01082759}, {199,0.01083621}, {200,0.01085345}, {201,0.01096552}, {202,0.01098276}, {203,0.01140517}, {204,0.01120690}, {205,0.01112069}, {206,0.01108621}, {207,0.01151724}, {208,0.01171552}, {209,0.01148276}, {210,0.01168966}, {211,0.01165517}, {212,0.01196552}, {213,0.01190517}, {214,0.01191379}, {215,0.01200000}, {216,0.01177586}, {217,0.01194828}, {218,0.01193966}, {219,0.01214655}, {220,0.01267241}, {221,0.01245690}, {222,0.01240517}, {223,0.01270690}, {224,0.01278448}, {225,0.05731897}, {226,0.01217241}, {227,0.01261207}, {228,0.01244828}, {229,0.01242241}, {230,0.01263793}, {231,0.01253448}, {232,0.01265517}, {233,0.01292241}, {234,0.01299138}, {235,0.01283621}, {236,0.01300000}, {237,0.01306897}, {238,0.04261207}, {239,0.01295690}, {240,0.01330172}, {241,0.01324138}, {242,0.01331897}, {243,0.01337931}, {244,0.04741379}, {245,0.01364655}, {246,0.01358621}, {247,0.01390517}, {248,0.01388793}, {249,0.01372414}, {250,0.04443103}, {251,0.01409483}, {252,0.01357759}, {253,0.01394828}, {254,0.01389655}, {255,0.01408621}, {256,0.05778448}, {257,0.01427586}, {258,0.01447414}, {259,0.01453448}, {260,0.01460345}, {261,0.01459483}, {262,0.01506897}, {263,0.01439655}, {264,0.01486207}, {265,0.01487069}, {266,0.01478448}, {267,0.05624138}, {268,0.01467241}, {269,0.01527586}, {270,0.01502586}, {271,0.01507759}, {272,0.01537931}, {273,0.01537069}, {274,0.01527586}, {275,0.01538793}, {276,0.01549138}, {277,0.01579310}, {278,0.04821552}, {279,0.01573276}, {280,0.01581034}, {281,0.01590517}, {282,0.01550000}, {283,0.01548276}, {284,0.01559483}, {285,0.01564655}, {286,0.01580172}, {287,0.01583621}, {288,0.04157759}, {289,0.01574138}, {290,0.01593103}, {291,0.01587931}, {292,0.01608621}, {293,0.04550862}, {294,0.01610345}, {295,0.01631897}, {296,0.01629310}, {297,0.01628448}, {298,0.04433621}, {299,0.01637931}, {300,0.01643966}, {301,0.01635345}, {302,0.01625862}, {303,0.04697414}, {304,0.01647414}, {305,0.01662931}, {306,0.01673276}, {307,0.01635345}, {308,0.01662069}, {309,0.01680172}, {310,0.01660345}, {311,0.01710345}, {312,0.01698276}, {313,0.01689655}, {314,0.01689655}, {315,0.01694828}, {316,0.01707759}, {317,0.04696552}, {318,0.01710345}, {319,0.01733621}, {320,0.01706034}, {321,0.01726724}, {322,0.04831034}, {323,0.01747414}, {324,0.01731034}, {325,0.01735345}, {326,0.01763793}, {327,0.01748276}, {328,0.01752586}, {329,0.01775862}, {330,0.01778448}, {331,0.04980172}, {332,0.01773276}, {333,0.01787069}, {334,0.01797414}, {335,0.01820690}, {336,0.01808621}, {337,0.01806034}, {338,0.01790517}, {339,0.01801724}, {340,0.05003448}, {341,0.01809483}, {342,0.01831034}, {343,0.01814655}, {344,0.05012069}, {345,0.01816379}, {346,0.01831034}, {347,0.01850862}, {348,0.01844828}, {349,0.01840517}, {350,0.01850862}, {351,0.01854310}, {352,0.01844828}, {353,0.01906897}, {354,0.01919828}, {355,0.01924138}, {356,0.01950862}, {357,0.06552586}, {358,0.01932759}, {359,0.01930172}, {360,0.01943966}, {361,0.07721552}, {362,0.01946552}, {363,0.01943966}, {364,0.01984483}, {365,0.05230172}, {366,0.01983621}, {367,0.02000000}, {368,0.01981034}, {369,0.05194828}, {370,0.01981034}, {371,0.02008621}, {372,0.02000000}, {373,0.05219828}, {374,0.01995690}, {375,0.02000000}, {376,0.02079310}, {377,0.05468966}, {378,0.02034483}, {379,0.02051724}, {380,0.02057759}, {381,0.07412069}, {382,0.02027586}, {383,0.02111207}, {384,0.02106034}, {385,0.08083621}, {386,0.02112931}, {387,0.02069828}, {388,0.02075862}, {389,0.02121552}, {390,0.02143103}, {391,0.02153448}, {392,0.02158621}, {393,0.02126724}, {394,0.02123276}, {395,0.02141379}, {396,0.02150862}, {397,0.02168966}, {398,0.02173276}, {399,0.42562069}, {400,0.02039655}, {401,0.02089655}, {402,0.02129310}, {403,0.04884483}, {404,0.02165517}, {405,0.02191379}, {406,0.02144828}, {407,0.02119828}, {408,0.02150000}, {409,0.02150000}, {410,0.04782759}, {411,0.02159483}, {412,0.02187931}, {413,0.02184483}, {414,0.05107759}, {415,0.02143966}, {416,0.02200000}, {417,0.02181897}, {418,0.02208621}, {419,0.02212931}, {420,0.02211207}, {421,0.05366379}, {422,0.02237069}, {423,0.02250862}, {424,0.02205172}, {425,0.02235345}, {426,0.02225000}, {427,0.02281897}, {428,0.05218103}, {429,0.02248276}, {430,0.02278448}, {431,0.02294828}, {432,0.02290517}, {433,0.02310345}, {434,0.02278448}, {435,0.05265517}, {436,0.02328448}, {437,0.02289655}, {438,0.05333621}, {439,0.02328448}, {440,0.02332759}, {441,0.02343966}, {442,0.02337069}, {443,0.02360345}, {444,0.02404310}, {445,0.05246552}, {446,0.02368103}, {447,0.02366379}, {448,0.05356034}, {449,0.02376724}, {450,0.02376724}, {451,0.02381897}, {452,0.02425000}, {453,0.02444828}, {454,0.02429310}, {455,0.05402586}, {456,0.02416379}, {457,0.02430172}, {458,0.05695690}, {459,0.02445690}, {460,0.02468966}, {461,0.02450000}, {462,0.02442241}, {463,0.02464655}, {464,0.02468966}, {465,0.02477586}, {466,0.02463793}, {467,0.02503448}, {468,0.05444828}, {469,0.02463793}, {470,0.02530172}, {471,0.05144828}, {472,0.02519828}, {473,0.02500862}, {474,0.10595690}, {475,0.02590517}, {476,0.02600862}, {477,0.09630172}, {478,0.02612931}, {479,0.02622414}, {480,0.02634483}, {481,0.02630172}, {482,0.02656034}, {483,0.02647414}, {484,0.02646552}, {485,0.02643966}, {486,0.02653448}, {487,0.02668966}, {488,0.02675000}, {489,0.02665517}, {490,0.02681897}, {491,0.02687931}, {492,0.02672414}, {493,0.02668966}, {494,0.02687931}, {495,0.02693103}, {496,0.02699138}, {497,0.02710345}, {498,0.02715517}, {499,0.02734483}, {500,0.027030303}, {505,0.02737391}, {510,0.02774783}, {515,0.02837391}, {520,0.02875652}, {525,0.02893043}, {530,0.02913913}, {535,0.02936522}, {540,0.02982609}, {545,0.09458261}, {550,0.03043478}, {555,0.03086957}, {560,0.08890435}, {565,0.03133333}, {570,0.03180702}, {575,0.03200877}, {580,0.03202632}, {585,0.09111404}, {590,0.03292105}, {595,0.03306140}, {600,0.03321739}, {605,0.03350000}, {610,0.09278947}, {615,0.03406140}, {620,0.03424561}, {625,0.03446491}, {630,0.03487719}, {635,0.06383333}, {640,0.03541228}, {645,0.06981579}, {650,0.03571053}, {655,0.03600000}, {660,0.03634211}, {665,0.03663158}, {670,0.03671930}, {675,0.03717544}, {680,0.06853509}, {685,0.03726316}, {690,0.06852632}, {695,0.03830702}, {700,0.07066957}, {705,0.03848246}, {710,0.07433333}, {715,0.03907895}, {720,0.03939474}, {725,0.03969298}, {730,0.04014035}, {735,0.04013158}, {740,0.04067544}, {745,0.04104386}, {750,0.04144737}, {755,0.04157018}, {760,0.04191228}, {765,0.04074561}, {770,0.58740351}, {775,0.16233333}, {780,0.04177193}, {785,0.07628947}, {790,0.04264912}, {795,0.07656140}, {800,0.04300870}, {805,0.07492105}, {810,0.04373684}, {815,0.04402632}, {820,0.04440351}, {825,0.04436842}, {830,0.04446491}, {835,0.04493860}, {840,0.07882456}, {845,0.04539474}, {850,0.07685965}, {855,0.04597368}, {860,0.04604386}, {865,0.07623684}, {870,0.04669298}, {875,0.08211404}, {880,0.04722807}, {885,0.04751754}, {890,0.04764912}, {895,0.04803509}, {900,0.08586087}, {905,0.04797368}, {910,0.04861404}, {915,0.08122807}, {920,0.04931579}, {925,0.08376316}, {930,0.04944737}, {935,0.05089474}, {940,0.09518421}, {945,0.05152632}, {950,0.05185088}, {955,0.08456140}, {960,0.05225439}, {965,0.05284211}, {970,0.08638596}, {975,0.05343860}, {980,0.05333333}, {985,0.11570175}, {990,0.05424561}, {995,0.05453509}, {1000,0.12090435}, {1010,0.10250}, {1020,0.05475}, {1030,0.05725}, {1040,0.09625}, {1050,0.06750}, {1060,0.05975}, {1070,0.08475}, {1080,0.08850}, {1090,0.06100}, {1100,0.05950}, {1110,0.08250}, {1120,0.08600}, {1130,0.06100}, {1140,0.06200}, {1150,0.09000}, {1160,0.09575}, {1170,0.06250}, {1180,0.06400}, {1190,0.06400}, {1200,0.11650}, {1210,0.10875}, {1220,0.10900}, {1230,0.06800}, {1240,0.06750}, {1250,0.06775}, {1260,0.10275}, {1270,0.11200}, {1280,0.10425}, {1290,0.07075}, {1300,0.07175}, {1310,0.07300}, {1320,0.07175}, {1330,0.09900}, {1340,0.10175}, {1350,0.16050}, {1360,0.10550}, {1370,0.10950}, {1380,0.10975}, {1390,0.10700}, {1400,0.07575}, {1410,0.07775}, {1420,0.07825}, {1430,0.08000}, {1440,0.08075}, {1450,0.07950}, {1460,0.08000}, {1470,0.08100}, {1480,0.08150}, {1490,0.08150}, {1500,0.09320}, {1510,0.08150}, {1520,0.08400}, {1530,0.08550}, {1540,0.08400}, {1550,0.08750}, {1560,0.08350}, {1570,0.08400}, {1580,0.08700}, {1590,0.12075}, {1600,0.12550}, {1610,0.12925}, {1620,0.24425}, {1630,0.10650}, {1640,0.08750}, {1650,0.08750}, {1660,0.09250}, {1670,0.12700}, {1680,0.13100}, {1690,0.14450}, {1700,0.14525}, {1710,0.14025}, {1720,0.09600}, {1730,0.09375}, {1740,0.14975}, {1750,0.17400}, {1760,0.15875}, {1770,0.12575}, {1780,0.10025}, {1790,0.09850}, {1800,0.14550}, {1810,0.13875}, {1820,0.12600}, {1830,0.09925}, {1840,0.12050}, {1850,0.13850}, {1860,0.13150}, {1870,0.09950}, {1880,0.12550}, {1890,0.14225}, {1900,0.13775}, {1910,0.09950}, {1920,0.12850}, {1930,0.14125}, {1940,0.12450}, {1950,0.13050}, {1960,0.14600}, {1970,0.13500}, {1980,0.10575}, {1990,0.16500}, {2000,0.13180}, {2050,0.15750}, {2100,0.17225}, {2150,0.11875}, {2200,0.15550}, {2250,1.25775}, {2300,0.12675}, {2350,0.16550}, {2400,0.16625}, {2450,0.17825}, {2500,0.17520}, {2550,0.16775}, {2600,0.17625}, {2650,0.17575}, {2700,0.17725}, {2750,0.18075}, {2800,0.18950}, {2850,0.18700}, {2900,0.19650}, {2950,0.22575}, {3000,0.20020}, {3050,0.20300}, {3100,0.20975}, {3150,0.21350}, {3200,0.21025}, {3250,0.28475}, {3300,0.22225}, {3350,0.26650}, {3400,0.27750}, {3450,0.25525}, {3500,0.31020}, {3550,0.28425}, {3600,0.30250}, {3650,0.29925}, {3700,0.26875}, {3750,0.25350}, {3800,0.26575}, {3850,0.25925}, {3900,0.26725}, {3950,0.25200}, {4000,0.26760}, {4050,0.26175}, {4100,0.26725}, {4150,0.26250}, {4200,0.26675}, {4250,0.28100}, {4300,0.28625}, {4350,0.28200}, {4400,0.28850}, {4450,0.28850}, {4500,0.30020}, {4550,0.29700}, {4600,1.59275}, {4650,0.31150}, {4700,0.38650}, {4750,0.38450}, {4800,0.38125}, {4850,0.38350}, {4900,0.40825}, {4950,0.39050}, {5000,0.34100}};
data["big_flat"]["Parsing"]["reif"]["system"] = {{1,0.00023276}, {2,0.00006897}, {3,0.00000000}, {4,0.00003448}, {5,0.00000000}, {6,0.00006034}, {7,0.00006897}, {8,0.00008621}, {9,0.00003448}, {10,0.00003448}, {11,0.00012069}, {12,0.00009483}, {13,0.00006034}, {14,0.00008621}, {15,0.00003448}, {16,0.00010345}, {17,0.00010345}, {18,0.00006034}, {19,0.00012931}, {20,0.00013793}, {21,0.00005172}, {22,0.00019828}, {23,0.00017241}, {24,0.00012931}, {25,0.00023276}, {26,0.00017241}, {27,0.00006034}, {28,0.00021552}, {29,0.00006897}, {30,0.00020690}, {31,0.00017241}, {32,0.00018966}, {33,0.00022414}, {34,0.00022414}, {35,0.00011207}, {36,0.00178448}, {37,0.00009483}, {38,0.00000000}, {39,0.00003448}, {40,0.00000000}, {41,0.00000000}, {42,0.00003448}, {43,0.00003448}, {44,0.00006897}, {45,0.00003448}, {46,0.00003448}, {47,0.00002586}, {48,0.00000000}, {49,0.00000000}, {50,0.00003448}, {51,0.00000000}, {52,0.00003448}, {53,0.00000000}, {54,0.00003448}, {55,0.00000000}, {56,0.00003448}, {57,0.00000000}, {58,0.00000000}, {59,0.00003448}, {60,0.00003448}, {61,0.00006034}, {62,0.00000000}, {63,0.00013793}, {64,0.00038793}, {65,0.00000000}, {66,0.00006034}, {67,0.00000000}, {68,0.00003448}, {69,0.00000000}, {70,0.00010345}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00006034}, {75,0.00003448}, {76,0.00003448}, {77,0.00003448}, {78,0.00006897}, {79,0.00002586}, {80,0.00002586}, {81,0.00006034}, {82,0.00006034}, {83,0.00000000}, {84,0.00022414}, {85,0.00017241}, {86,0.00000000}, {87,0.00006897}, {88,0.00002586}, {89,0.00000000}, {90,0.00003448}, {91,0.00002586}, {92,0.00000000}, {93,0.00003448}, {94,0.00006897}, {95,0.00010345}, {96,0.00002586}, {97,0.00000000}, {98,0.00010345}, {99,0.00059483}, {100,0.00006897}, {101,0.00009483}, {102,0.00006034}, {103,0.00012931}, {104,0.00000000}, {105,0.00003448}, {106,0.00006034}, {107,0.00006897}, {108,0.00011207}, {109,0.00006034}, {110,0.00005172}, {111,0.00006034}, {112,0.00003448}, {113,0.00015517}, {114,0.00002586}, {115,0.00003448}, {116,0.00003448}, {117,0.00006034}, {118,0.00003448}, {119,0.00002586}, {120,0.00006897}, {121,0.00006897}, {122,0.00006897}, {123,0.00003448}, {124,0.00000000}, {125,0.00053448}, {126,0.00015517}, {127,0.00003448}, {128,0.00003448}, {129,0.00000000}, {130,0.00002586}, {131,0.00012931}, {132,0.00000000}, {133,0.00006897}, {134,0.00003448}, {135,0.00000000}, {136,0.00062069}, {137,0.00007759}, {138,0.00000000}, {139,0.00006897}, {140,0.00007759}, {141,0.00000000}, {142,0.00002586}, {143,0.00006034}, {144,0.00002586}, {145,0.00002586}, {146,0.00102586}, {147,0.00009483}, {148,0.00015517}, {149,0.00006897}, {150,0.00002586}, {151,0.00006034}, {152,0.00006897}, {153,0.00010345}, {154,0.00003448}, {155,0.00009483}, {156,0.00050000}, {157,0.00012931}, {158,0.00003448}, {159,0.00003448}, {160,0.00003448}, {161,0.00003448}, {162,0.00003448}, {163,0.00006034}, {164,0.00010345}, {165,0.00050000}, {166,0.00013793}, {167,0.00005172}, {168,0.00000000}, {169,0.00000000}, {170,0.00006897}, {171,0.00003448}, {172,0.00015517}, {173,0.00003448}, {174,0.00022414}, {175,0.00003448}, {176,0.00000000}, {177,0.00002586}, {178,0.00008621}, {179,0.00022414}, {180,0.00017241}, {181,0.00006034}, {182,0.00052586}, {183,0.00010345}, {184,0.00010345}, {185,0.00005172}, {186,0.00003448}, {187,0.00006897}, {188,0.00000000}, {189,0.00000000}, {190,0.00046552}, {191,0.00009483}, {192,0.00006897}, {193,0.00000000}, {194,0.00006897}, {195,0.00003448}, {196,0.00010345}, {197,0.00000000}, {198,0.00022414}, {199,0.00016379}, {200,0.00010345}, {201,0.00013793}, {202,0.00000000}, {203,0.00003448}, {204,0.00006034}, {205,0.00010345}, {206,0.00023276}, {207,0.00002586}, {208,0.00006897}, {209,0.00003448}, {210,0.00012931}, {211,0.00003448}, {212,0.00006897}, {213,0.00003448}, {214,0.00006034}, {215,0.00010345}, {216,0.00009483}, {217,0.00010345}, {218,0.00017241}, {219,0.00006034}, {220,0.00010345}, {221,0.00013793}, {222,0.00006897}, {223,0.00013793}, {224,0.00010345}, {225,0.00039655}, {226,0.00019828}, {227,0.00006034}, {228,0.00009483}, {229,0.00003448}, {230,0.00009483}, {231,0.00012931}, {232,0.00003448}, {233,0.00006897}, {234,0.00006897}, {235,0.00012931}, {236,0.00009483}, {237,0.00006897}, {238,0.00043966}, {239,0.00013793}, {240,0.00016379}, {241,0.00006897}, {242,0.00010345}, {243,0.00012931}, {244,0.00050000}, {245,0.00002586}, {246,0.00019828}, {247,0.00013793}, {248,0.00006897}, {249,0.00012931}, {250,0.00039655}, {251,0.00000000}, {252,0.00006897}, {253,0.00006897}, {254,0.00003448}, {255,0.00003448}, {256,0.00024138}, {257,0.00018966}, {258,0.00003448}, {259,0.00003448}, {260,0.00000000}, {261,0.00003448}, {262,0.00016379}, {263,0.00026724}, {264,0.00017241}, {265,0.00010345}, {266,0.00003448}, {267,0.00067241}, {268,0.00010345}, {269,0.00010345}, {270,0.00006034}, {271,0.00020690}, {272,0.00016379}, {273,0.00006897}, {274,0.00009483}, {275,0.00010345}, {276,0.00010345}, {277,0.00012931}, {278,0.00037931}, {279,0.00016379}, {280,0.00006897}, {281,0.00017241}, {282,0.00017241}, {283,0.00018966}, {284,0.00000000}, {285,0.00003448}, {286,0.00003448}, {287,0.00006897}, {288,0.00034483}, {289,0.00017241}, {290,0.00005172}, {291,0.00013793}, {292,0.00000000}, {293,0.00052586}, {294,0.00012931}, {295,0.00006897}, {296,0.00003448}, {297,0.00013793}, {298,0.00074138}, {299,0.00013793}, {300,0.00002586}, {301,0.00013793}, {302,0.00019828}, {303,0.00095690}, {304,0.00012069}, {305,0.00023276}, {306,0.00013793}, {307,0.00022414}, {308,0.00039655}, {309,0.00016379}, {310,0.00022414}, {311,0.00014655}, {312,0.00015517}, {313,0.00009483}, {314,0.00025862}, {315,0.00012931}, {316,0.00018966}, {317,0.00061207}, {318,0.00019828}, {319,0.00013793}, {320,0.00018103}, {321,0.00017241}, {322,0.00057759}, {323,0.00009483}, {324,0.00024138}, {325,0.00020690}, {326,0.00012931}, {327,0.00012931}, {328,0.00020690}, {329,0.00017241}, {330,0.00003448}, {331,0.00051724}, {332,0.00017241}, {333,0.00017241}, {334,0.00013793}, {335,0.00012069}, {336,0.00017241}, {337,0.00009483}, {338,0.00019828}, {339,0.00009483}, {340,0.00064655}, {341,0.00019828}, {342,0.00003448}, {343,0.00012931}, {344,0.00062069}, {345,0.00006034}, {346,0.00024138}, {347,0.00009483}, {348,0.00017241}, {349,0.00010345}, {350,0.00010345}, {351,0.00016379}, {352,0.00012931}, {353,0.00010345}, {354,0.00006897}, {355,0.00003448}, {356,0.00006897}, {357,0.00013793}, {358,0.00006034}, {359,0.00010345}, {360,0.00006034}, {361,0.00034483}, {362,0.00025862}, {363,0.00000000}, {364,0.00012931}, {365,0.00081034}, {366,0.00017241}, {367,0.00018966}, {368,0.00017241}, {369,0.00081034}, {370,0.00006897}, {371,0.00013793}, {372,0.00006897}, {373,0.00074138}, {374,0.00017241}, {375,0.00024138}, {376,0.00006897}, {377,0.00097414}, {378,0.00038793}, {379,0.00013793}, {380,0.00010345}, {381,0.00060345}, {382,0.00026724}, {383,0.00003448}, {384,0.00006034}, {385,0.00074138}, {386,0.00029310}, {387,0.00012931}, {388,0.00010345}, {389,0.00010345}, {390,0.00006897}, {391,0.00020690}, {392,0.00009483}, {393,0.00020690}, {394,0.00013793}, {395,0.00017241}, {396,0.00020690}, {397,0.00010345}, {398,0.00013793}, {399,0.00765517}, {400,0.00070690}, {401,0.00016379}, {402,0.00027586}, {403,0.00080172}, {404,0.00017241}, {405,0.00010345}, {406,0.00017241}, {407,0.00017241}, {408,0.00010345}, {409,0.00006034}, {410,0.00068103}, {411,0.00023276}, {412,0.00012931}, {413,0.00020690}, {414,0.00083621}, {415,0.00011207}, {416,0.00017241}, {417,0.00018966}, {418,0.00026724}, {419,0.00024138}, {420,0.00016379}, {421,0.00043966}, {422,0.00017241}, {423,0.00010345}, {424,0.00013793}, {425,0.00021552}, {426,0.00008621}, {427,0.00006897}, {428,0.00081897}, {429,0.00025000}, {430,0.00020690}, {431,0.00010345}, {432,0.00017241}, {433,0.00003448}, {434,0.00013793}, {435,0.00062069}, {436,0.00009483}, {437,0.00027586}, {438,0.00047414}, {439,0.00017241}, {440,0.00010345}, {441,0.00008621}, {442,0.00017241}, {443,0.00017241}, {444,0.00012931}, {445,0.00077586}, {446,0.00009483}, {447,0.00006034}, {448,0.00054310}, {449,0.00013793}, {450,0.00010345}, {451,0.00009483}, {452,0.00017241}, {453,0.00003448}, {454,0.00009483}, {455,0.00061207}, {456,0.00020690}, {457,0.00017241}, {458,0.00067241}, {459,0.00017241}, {460,0.00013793}, {461,0.00020690}, {462,0.00037931}, {463,0.00006897}, {464,0.00016379}, {465,0.00019828}, {466,0.00027586}, {467,0.00009483}, {468,0.00003448}, {469,0.00022414}, {470,0.00017241}, {471,0.00010345}, {472,0.00006897}, {473,0.00031034}, {474,0.00055172}, {475,0.00023276}, {476,0.00012931}, {477,0.00058621}, {478,0.00012931}, {479,0.00010345}, {480,0.00010345}, {481,0.00023276}, {482,0.00010345}, {483,0.00022414}, {484,0.00013793}, {485,0.00027586}, {486,0.00017241}, {487,0.00006897}, {488,0.00016379}, {489,0.00010345}, {490,0.00006897}, {491,0.00020690}, {492,0.00024138}, {493,0.00006897}, {494,0.00025862}, {495,0.00016379}, {496,0.00017241}, {497,0.00010345}, {498,0.00024138}, {499,0.00013793}, {500,0.000212121}, {505,0.00023478}, {510,0.00020870}, {515,0.00006957}, {520,0.00020000}, {525,0.00017391}, {530,0.00031304}, {535,0.00026957}, {540,0.00030435}, {545,0.00082609}, {550,0.00010435}, {555,0.00013043}, {560,0.00072174}, {565,0.00017544}, {570,0.00017544}, {575,0.00014035}, {580,0.00025439}, {585,0.00083333}, {590,0.00014035}, {595,0.00026316}, {600,0.00031304}, {605,0.00014035}, {610,0.00080702}, {615,0.00015789}, {620,0.00024561}, {625,0.00014035}, {630,0.00021053}, {635,0.00111404}, {640,0.00024561}, {645,0.00041228}, {650,0.00010526}, {655,0.00030702}, {660,0.00027193}, {665,0.00007018}, {670,0.00023684}, {675,0.00016667}, {680,0.00065789}, {685,0.00043860}, {690,0.00097368}, {695,0.00028070}, {700,0.00071304}, {705,0.00023684}, {710,0.00076316}, {715,0.00021053}, {720,0.00021053}, {725,0.00010526}, {730,0.00006140}, {735,0.00023684}, {740,0.00016667}, {745,0.00041228}, {750,0.00021053}, {755,0.00023684}, {760,0.00024561}, {765,0.00031579}, {770,0.00759649}, {775,0.00560526}, {780,0.00041228}, {785,0.00093860}, {790,0.00034211}, {795,0.00126316}, {800,0.00045217}, {805,0.00089474}, {810,0.00031579}, {815,0.00022807}, {820,0.00021053}, {825,0.00028070}, {830,0.00041228}, {835,0.00030702}, {840,0.00128070}, {845,0.00031579}, {850,0.00063158}, {855,0.00021053}, {860,0.00028070}, {865,0.00016667}, {870,0.00017544}, {875,0.00030702}, {880,0.00023684}, {885,0.00017544}, {890,0.00014035}, {895,0.00013158}, {900,0.00033043}, {905,0.00056140}, {910,0.00024561}, {915,0.00035088}, {920,0.00016667}, {925,0.00085088}, {930,0.00048246}, {935,0.00038596}, {940,0.00093860}, {945,0.00013158}, {950,0.00038596}, {955,0.00093860}, {960,0.00034211}, {965,0.00021053}, {970,0.00099123}, {975,0.00028070}, {980,0.00063158}, {985,0.00080702}, {990,0.00035088}, {995,0.00028070}, {1000,0.00093913}, {1010,0.00550}, {1020,0.00000}, {1030,0.00000}, {1040,0.00300}, {1050,0.00000}, {1060,0.00000}, {1070,0.00000}, {1080,0.00300}, {1090,0.00000}, {1100,0.00075}, {1110,0.00000}, {1120,0.00100}, {1130,0.00100}, {1140,0.00000}, {1150,0.00100}, {1160,0.00200}, {1170,0.00000}, {1180,0.00000}, {1190,0.00000}, {1200,0.00200}, {1210,0.00100}, {1220,0.00275}, {1230,0.00100}, {1240,0.00000}, {1250,0.00000}, {1260,0.00100}, {1270,0.00100}, {1280,0.00200}, {1290,0.00100}, {1300,0.00075}, {1310,0.00000}, {1320,0.00000}, {1330,0.00175}, {1340,0.00300}, {1350,0.00400}, {1360,0.00000}, {1370,0.00100}, {1380,0.00100}, {1390,0.00000}, {1400,0.00000}, {1410,0.00000}, {1420,0.00000}, {1430,0.00000}, {1440,0.00000}, {1450,0.00000}, {1460,0.00100}, {1470,0.00000}, {1480,0.00000}, {1490,0.00000}, {1500,0.00000}, {1510,0.00200}, {1520,0.00000}, {1530,0.00000}, {1540,0.00000}, {1550,0.00000}, {1560,0.00100}, {1570,0.00000}, {1580,0.00000}, {1590,0.00000}, {1600,0.00100}, {1610,0.00375}, {1620,0.00375}, {1630,0.00100}, {1640,0.00100}, {1650,0.00100}, {1660,0.00000}, {1670,0.00000}, {1680,0.00100}, {1690,0.00400}, {1700,0.00775}, {1710,0.00400}, {1720,0.00000}, {1730,0.00000}, {1740,0.00375}, {1750,0.00400}, {1760,0.00875}, {1770,0.00600}, {1780,0.00000}, {1790,0.00000}, {1800,0.00500}, {1810,0.00700}, {1820,0.00575}, {1830,0.00000}, {1840,0.00700}, {1850,0.00775}, {1860,0.00800}, {1870,0.00100}, {1880,0.00400}, {1890,0.00600}, {1900,0.00500}, {1910,0.00200}, {1920,0.00000}, {1930,0.00000}, {1940,0.00000}, {1950,0.00200}, {1960,0.00100}, {1970,0.00000}, {1980,0.00000}, {1990,0.00700}, {2000,0.00460}, {2050,0.00400}, {2100,0.00675}, {2150,0.00000}, {2200,0.00600}, {2250,0.09375}, {2300,0.00100}, {2350,0.00700}, {2400,0.00600}, {2450,0.00575}, {2500,0.00160}, {2550,0.00700}, {2600,0.00600}, {2650,0.01000}, {2700,0.00500}, {2750,0.00700}, {2800,0.00500}, {2850,0.00975}, {2900,0.00700}, {2950,0.01200}, {3000,0.00640}, {3050,0.00200}, {3100,0.00075}, {3150,0.00000}, {3200,0.01000}, {3250,0.00900}, {3300,0.00700}, {3350,0.01400}, {3400,0.00675}, {3450,0.00900}, {3500,0.01280}, {3550,0.00775}, {3600,0.00800}, {3650,0.00500}, {3700,0.00800}, {3750,0.01100}, {3800,0.00600}, {3850,0.00800}, {3900,0.00900}, {3950,0.00900}, {4000,0.00640}, {4050,0.01000}, {4100,0.01200}, {4150,0.01100}, {4200,0.01400}, {4250,0.00900}, {4300,0.01200}, {4350,0.01075}, {4400,0.01000}, {4450,0.01100}, {4500,0.01280}, {4550,0.00900}, {4600,0.18125}, {4650,0.00800}, {4700,0.00375}, {4750,0.00000}, {4800,0.00200}, {4850,0.00000}, {4900,0.00100}, {4950,0.00300}, {5000,0.00080}};
data["big_flat"]["ParsingElaborated"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00013793}, {12,0.00000000}, {13,0.00000000}, {14,0.00003448}, {15,0.00054310}, {16,0.00100000}, {17,0.00062931}, {18,0.00098276}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00100000}, {23,0.00199138}, {24,0.00100000}, {25,0.00100000}, {26,0.00100000}, {27,0.00100000}, {28,0.00100000}, {29,0.00100000}, {30,0.00100862}, {31,0.00100000}, {32,0.00105172}, {33,0.00101724}, {34,0.00139655}, {35,0.00138793}, {36,0.00136207}, {37,0.00145690}, {38,0.00135345}, {39,0.00181897}, {40,0.00200000}, {41,0.00200000}, {42,0.00200000}, {43,0.00200000}, {44,0.00200000}, {45,0.00200000}, {46,0.00200000}, {47,0.00200000}, {48,0.00500862}, {49,0.00200000}, {50,0.00200000}, {51,0.00200000}, {52,0.00200862}, {53,0.00203448}, {54,0.00205172}, {55,0.00204310}, {56,0.00206034}, {57,0.00233621}, {58,0.00243966}, {59,0.00281034}, {60,0.00289655}, {61,0.00280172}, {62,0.00294828}, {63,0.00300000}, {64,0.00300000}, {65,0.00300000}, {66,0.00300000}, {67,0.00300000}, {68,0.00300000}, {69,0.00857759}, {70,0.00300000}, {71,0.00300000}, {72,0.00300862}, {73,0.00300862}, {74,0.00304310}, {75,0.00309483}, {76,0.00312931}, {77,0.00339655}, {78,0.00317241}, {79,0.00347414}, {80,0.00357759}, {81,0.00396552}, {82,0.00394828}, {83,0.00400000}, {84,0.06087069}, {85,0.00400000}, {86,0.00400000}, {87,0.00400000}, {88,0.00400000}, {89,0.00400000}, {90,0.00400862}, {91,0.00400862}, {92,0.00404310}, {93,0.00402586}, {94,0.00405172}, {95,0.00420690}, {96,0.00443966}, {97,0.00474138}, {98,0.00491379}, {99,0.00488793}, {100,0.00499138}, {101,0.00500000}, {102,0.00500000}, {103,0.00500000}, {104,0.00500000}, {105,0.00500000}, {106,0.00500000}, {107,0.00500000}, {108,0.00500000}, {109,0.00501724}, {110,0.00500862}, {111,0.00506034}, {112,0.00512069}, {113,0.03656034}, {114,0.00581897}, {115,0.00589655}, {116,0.00588793}, {117,0.00593966}, {118,0.00592241}, {119,0.00598276}, {120,0.00600000}, {121,0.00600000}, {122,0.00600000}, {123,0.00600000}, {124,0.00600000}, {125,0.00600000}, {126,0.00600000}, {127,0.00600862}, {128,0.00602586}, {129,0.00616379}, {130,0.00606897}, {131,0.00608621}, {132,0.00636207}, {133,0.00680172}, {134,0.00689655}, {135,0.00690517}, {136,0.00692241}, {137,0.00698276}, {138,0.00700000}, {139,0.00700862}, {140,0.03193103}, {141,0.00690517}, {142,0.00698276}, {143,0.00699138}, {144,0.00699138}, {145,0.00699138}, {146,0.00700000}, {147,0.00699138}, {148,0.00700000}, {149,0.00700000}, {150,0.00700000}, {151,0.00700000}, {152,0.00701724}, {153,0.00700862}, {154,0.00711207}, {155,0.00736207}, {156,0.00748276}, {157,0.00722414}, {158,0.00731034}, {159,0.00762069}, {160,0.00793103}, {161,0.00799138}, {162,0.00797414}, {163,0.00800000}, {164,0.00800000}, {165,0.00800000}, {166,0.00800000}, {167,0.00800000}, {168,0.00800000}, {169,0.00800000}, {170,0.00800862}, {171,0.00800000}, {172,0.00800000}, {173,0.00802586}, {174,0.03996552}, {175,0.00829310}, {176,0.00840517}, {177,0.00861207}, {178,0.00851724}, {179,0.00846552}, {180,0.00857759}, {181,0.00893103}, {182,0.00897414}, {183,0.00899138}, {184,0.00898276}, {185,0.00900000}, {186,0.00900000}, {187,0.00900000}, {188,0.00900000}, {189,0.00900000}, {190,0.00900862}, {191,0.00900000}, {192,0.00901724}, {193,0.00902586}, {194,0.00932759}, {195,0.00926724}, {196,0.00968103}, {197,0.00935345}, {198,0.04266379}, {199,0.05896552}, {200,0.00965517}, {201,0.00990517}, {202,0.00994828}, {203,0.00999138}, {204,0.01000000}, {205,0.06245690}, {206,0.01000000}, {207,0.01000000}, {208,0.01000000}, {209,0.01000000}, {210,0.01000862}, {211,0.01000862}, {212,0.07080172}, {213,0.01092241}, {214,0.01093103}, {215,0.01099138}, {216,0.01098276}, {217,0.01098276}, {218,0.01099138}, {219,0.05416379}, {220,0.01100000}, {221,0.01100862}, {222,0.01100862}, {223,0.01100862}, {224,0.01103448}, {225,0.01120690}, {226,0.01118103}, {227,0.01157759}, {228,0.01149138}, {229,0.01135345}, {230,0.01162931}, {231,0.01174138}, {232,0.04485345}, {233,0.01195690}, {234,0.01193966}, {235,0.01199138}, {236,0.01195690}, {237,0.01199138}, {238,0.01200000}, {239,0.01200862}, {240,0.01200862}, {241,0.01203448}, {242,0.01200000}, {243,0.01200862}, {244,0.01223276}, {245,0.01209483}, {246,0.01218966}, {247,0.01254310}, {248,0.01262069}, {249,0.01243966}, {250,0.01236207}, {251,0.01287069}, {252,0.01285345}, {253,0.01283621}, {254,0.01293966}, {255,0.01295690}, {256,0.01299138}, {257,0.01295690}, {258,0.01300000}, {259,0.01300000}, {260,0.01300862}, {261,0.01301724}, {262,0.07289655}, {263,0.01304310}, {264,0.01302586}, {265,0.01304310}, {266,0.01312931}, {267,0.01325000}, {268,0.01337069}, {269,0.01332759}, {270,0.01370690}, {271,0.01381034}, {272,0.01374138}, {273,0.04712069}, {274,0.01393966}, {275,0.01394828}, {276,0.01397414}, {277,0.01399138}, {278,0.01400000}, {279,0.01400000}, {280,0.01400000}, {281,0.01400862}, {282,0.11437069}, {283,0.06771552}, {284,0.01388793}, {285,0.01396552}, {286,0.01399138}, {287,0.01400000}, {288,0.01400000}, {289,0.01400000}, {290,0.01400862}, {291,0.01400862}, {292,0.01400000}, {293,0.01400862}, {294,0.01401724}, {295,0.01406034}, {296,0.01406034}, {297,0.01408621}, {298,0.01423276}, {299,0.01439655}, {300,0.01455172}, {301,0.01465517}, {302,0.01475000}, {303,0.01482759}, {304,0.01483621}, {305,0.01493103}, {306,0.01496552}, {307,0.01494828}, {308,0.04481897}, {309,0.01500000}, {310,0.01500000}, {311,0.01500000}, {312,0.01504310}, {313,0.04541379}, {314,0.01501724}, {315,0.01504310}, {316,0.01506034}, {317,0.01524138}, {318,0.01519828}, {319,0.01528448}, {320,0.01544828}, {321,0.01564655}, {322,0.01574138}, {323,0.01583621}, {324,0.01587931}, {325,0.01593103}, {326,0.01593103}, {327,0.04510345}, {328,0.01598276}, {329,0.01599138}, {330,0.01599138}, {331,0.01600862}, {332,0.01600862}, {333,0.01600862}, {334,0.01601724}, {335,0.01602586}, {336,0.04802586}, {337,0.01614655}, {338,0.01618966}, {339,0.01636207}, {340,0.01626724}, {341,0.01661207}, {342,0.01675862}, {343,0.01668966}, {344,0.01683621}, {345,0.01678448}, {346,0.01688793}, {347,0.01693966}, {348,0.01693966}, {349,0.04654310}, {350,0.01698276}, {351,0.01701724}, {352,0.01700862}, {353,0.08748276}, {354,0.01794828}, {355,0.01796552}, {356,0.01798276}, {357,0.01798276}, {358,0.01800862}, {359,0.01801724}, {360,0.01803448}, {361,0.01806897}, {362,0.01817241}, {363,0.01815517}, {364,0.01825000}, {365,0.01843966}, {366,0.01848276}, {367,0.01862931}, {368,0.01863793}, {369,0.01874138}, {370,0.01881034}, {371,0.01886207}, {372,0.01887069}, {373,0.01890517}, {374,0.01898276}, {375,0.01895690}, {376,0.01898276}, {377,0.01900000}, {378,0.01901724}, {379,0.01902586}, {380,0.01906034}, {381,0.01903448}, {382,0.01917241}, {383,0.01925862}, {384,0.01925000}, {385,0.01925862}, {386,0.01944828}, {387,0.01958621}, {388,0.01968103}, {389,0.07831897}, {390,0.01981034}, {391,0.01987069}, {392,0.01991379}, {393,0.08237069}, {394,0.01996552}, {395,0.01996552}, {396,0.02000000}, {397,0.07309483}, {398,0.02019828}, {399,0.02016379}, {400,0.01915517}, {401,0.01929310}, {402,0.01946552}, {403,0.01942241}, {404,0.01958621}, {405,0.01966379}, {406,0.01985345}, {407,0.04967241}, {408,0.01986207}, {409,0.01987069}, {410,0.01987931}, {411,0.01999138}, {412,0.01999138}, {413,0.01999138}, {414,0.02002586}, {415,0.02004310}, {416,0.02002586}, {417,0.02004310}, {418,0.06037069}, {419,0.02013793}, {420,0.02018103}, {421,0.02027586}, {422,0.02035345}, {423,0.02040517}, {424,0.02060345}, {425,0.04904310}, {426,0.02078448}, {427,0.02080172}, {428,0.02086207}, {429,0.02085345}, {430,0.02093103}, {431,0.02098276}, {432,0.04781897}, {433,0.02097414}, {434,0.02098276}, {435,0.02102586}, {436,0.02105172}, {437,0.02100862}, {438,0.02111207}, {439,0.02109483}, {440,0.02119828}, {441,0.02123276}, {442,0.05396552}, {443,0.02153448}, {444,0.02139655}, {445,0.02144828}, {446,0.02175862}, {447,0.02177586}, {448,0.02182759}, {449,0.02183621}, {450,0.02192241}, {451,0.02190517}, {452,0.05483621}, {453,0.02196552}, {454,0.02197414}, {455,0.02198276}, {456,0.02199138}, {457,0.02206897}, {458,0.02205172}, {459,0.02207759}, {460,0.02217241}, {461,0.02222414}, {462,0.05517241}, {463,0.02237931}, {464,0.02244828}, {465,0.05657759}, {466,0.02262069}, {467,0.02271552}, {468,0.02282759}, {469,0.02289655}, {470,0.02286207}, {471,0.02288793}, {472,0.02291379}, {473,0.02295690}, {474,0.02295690}, {475,0.02392241}, {476,0.02400000}, {477,0.02398276}, {478,0.02405172}, {479,0.02405172}, {480,0.02408621}, {481,0.06633621}, {482,0.02430172}, {483,0.02426724}, {484,0.05740517}, {485,0.02452586}, {486,0.02463793}, {487,0.05401724}, {488,0.02468966}, {489,0.02475862}, {490,0.05493103}, {491,0.02487069}, {492,0.02486207}, {493,0.05651724}, {494,0.02486207}, {495,0.02495690}, {496,0.07406034}, {497,0.02497414}, {498,0.02496552}, {499,0.08568966}, {500,0.025129870}, {505,0.08590435}, {510,0.02581739}, {515,0.02595652}, {520,0.08586087}, {525,0.02665217}, {530,0.02680870}, {535,0.07754783}, {540,0.02714783}, {545,0.02766957}, {550,0.02782609}, {555,0.02793043}, {560,0.02819130}, {565,0.02864348}, {570,0.02881579}, {575,0.08823684}, {580,0.02936842}, {585,0.02971930}, {590,0.02986842}, {595,0.03000000}, {600,0.09078261}, {605,0.03073684}, {610,0.03081579}, {615,0.03102632}, {620,0.03130702}, {625,0.08928947}, {630,0.03183333}, {635,0.03211404}, {640,0.03247368}, {645,0.03280702}, {650,0.03285965}, {655,0.03307895}, {660,0.06481579}, {665,0.03381579}, {670,0.06727193}, {675,0.03404386}, {680,0.03453509}, {685,0.03479825}, {690,0.03491228}, {695,0.03527193}, {700,0.03613043}, {705,0.03581579}, {710,0.03600000}, {715,0.03627193}, {720,0.03661404}, {725,0.06826316}, {730,0.03695614}, {735,0.06871053}, {740,0.03765789}, {745,0.06759649}, {750,0.03801754}, {755,0.06711404}, {760,0.03875439}, {765,0.06206140}, {770,0.03731579}, {775,0.03808772}, {780,0.03828947}, {785,0.03850877}, {790,0.03879825}, {795,0.03894737}, {800,0.03920000}, {805,0.03957018}, {810,0.03977193}, {815,0.06935965}, {820,0.04010526}, {825,0.07260526}, {830,0.04074561}, {835,0.06498246}, {840,0.04106140}, {845,0.04142105}, {850,0.04173684}, {855,0.04185965}, {860,0.07108772}, {865,0.04221930}, {870,0.04257895}, {875,0.04286842}, {880,0.04306140}, {885,0.07531579}, {890,0.04359649}, {895,0.07329825}, {900,0.04453913}, {905,0.04427193}, {910,0.08035088}, {915,0.04481579}, {920,0.04504386}, {925,0.04522807}, {930,0.04557895}, {935,0.13868421}, {940,0.04772807}, {945,0.04790351}, {950,0.09597368}, {955,0.04859649}, {960,0.04878947}, {965,0.08433333}, {970,0.04926316}, {975,0.04964912}, {980,0.09338596}, {985,0.05007018}, {990,0.05030702}, {995,0.11947368}, {1000,0.05083478}, {1010,0.05350}, {1020,0.05200}, {1030,0.11350}, {1040,0.05150}, {1050,0.05275}, {1060,0.09350}, {1070,0.05400}, {1080,0.05475}, {1090,0.05475}, {1100,0.12825}, {1110,0.05350}, {1120,0.05450}, {1130,0.05500}, {1140,0.08925}, {1150,0.05575}, {1160,0.05650}, {1170,0.05725}, {1180,0.09000}, {1190,0.15575}, {1200,0.05850}, {1210,0.06125}, {1220,0.06125}, {1230,0.06200}, {1240,0.10050}, {1250,0.09150}, {1260,0.06350}, {1270,0.06425}, {1280,0.06500}, {1290,0.06525}, {1300,0.10275}, {1310,0.12100}, {1320,0.10125}, {1330,0.06525}, {1340,0.06500}, {1350,0.16100}, {1360,0.06625}, {1370,0.06675}, {1380,0.06750}, {1390,0.06800}, {1400,0.06800}, {1410,0.13125}, {1420,0.11925}, {1430,0.11650}, {1440,0.10000}, {1450,0.10300}, {1460,0.10575}, {1470,0.11225}, {1480,0.11300}, {1490,0.10975}, {1500,0.10380}, {1510,0.11975}, {1520,0.11725}, {1530,0.13800}, {1540,0.13850}, {1550,0.13550}, {1560,0.12675}, {1570,0.09600}, {1580,0.09700}, {1590,0.09800}, {1600,0.07800}, {1610,0.07825}, {1620,0.26900}, {1630,0.07950}, {1640,0.11175}, {1650,0.14850}, {1660,0.12750}, {1670,0.11425}, {1680,0.08450}, {1690,0.08550}, {1700,0.08525}, {1710,0.08575}, {1720,0.14900}, {1730,0.15825}, {1740,0.14150}, {1750,0.08825}, {1760,0.08850}, {1770,0.08900}, {1780,0.12475}, {1790,0.12925}, {1800,0.11150}, {1810,0.09100}, {1820,0.09175}, {1830,0.12825}, {1840,0.11825}, {1850,0.08975}, {1860,0.09050}, {1870,0.12400}, {1880,0.12925}, {1890,0.09150}, {1900,0.09225}, {1910,0.12800}, {1920,0.12150}, {1930,0.09325}, {1940,0.09425}, {1950,0.12925}, {1960,0.09450}, {1970,0.09550}, {1980,0.13175}, {1990,0.12375}, {2000,0.10920}, {2050,0.18950}, {2100,0.10575}, {2150,0.14700}, {2200,0.14825}, {2250,0.11375}, {2300,0.16125}, {2350,0.15525}, {2400,0.16075}, {2450,0.12375}, {2500,0.16380}, {2550,0.17875}, {2600,0.12725}, {2650,0.15425}, {2700,0.16400}, {2750,0.17500}, {2800,0.18625}, {2850,0.19025}, {2900,0.19275}, {2950,0.14400}, {3000,0.17020}, {3050,0.19825}, {3100,0.19725}, {3150,0.20275}, {3200,0.23175}, {3250,0.21325}, {3300,0.21850}, {3350,0.18125}, {3400,0.25375}, {3450,0.27925}, {3500,0.22340}, {3550,0.29900}, {3600,0.29750}, {3650,0.30400}, {3700,0.29500}, {3750,0.28375}, {3800,0.24800}, {3850,0.26375}, {3900,0.24475}, {3950,0.26525}, {4000,0.26940}, {4050,0.25350}, {4100,0.25875}, {4150,0.27450}, {4200,0.27725}, {4250,0.28200}, {4300,0.25300}, {4350,0.26475}, {4400,0.27900}, {4450,0.27425}, {4500,0.29660}, {4550,0.27550}, {4600,0.27550}, {4650,0.34525}, {4700,0.32350}, {4750,0.37675}, {4800,0.36250}, {4850,0.40400}, {4900,0.39925}, {4950,0.38275}, {5000,0.33440}};
data["big_flat"]["ParsingElaborated"]["actual reif"]["user"] = {{1,0.00000000}, {2,0.00017241}, {3,0.00016379}, {4,0.00031034}, {5,0.00048276}, {6,0.00045690}, {7,0.00050862}, {8,0.00055172}, {9,0.00064655}, {10,0.00044828}, {11,0.00071552}, {12,0.00065517}, {13,0.00084483}, {14,0.00097414}, {15,0.00081897}, {16,0.00128448}, {17,0.00110345}, {18,0.00114655}, {19,0.00103448}, {20,0.00081897}, {21,0.00096552}, {22,0.00096552}, {23,0.00171552}, {24,0.00109483}, {25,0.00109483}, {26,0.00113793}, {27,0.00112069}, {28,0.00140517}, {29,0.00138793}, {30,0.00173276}, {31,0.00193966}, {32,0.00168966}, {33,0.00156034}, {34,0.00166379}, {35,0.00191379}, {36,0.00179310}, {37,0.00154310}, {38,0.00212931}, {39,0.00220690}, {40,0.00195690}, {41,0.00185345}, {42,0.00222414}, {43,0.00223276}, {44,0.00220690}, {45,0.00234483}, {46,0.00217241}, {47,0.00225000}, {48,0.00533621}, {49,0.00238793}, {50,0.00281034}, {51,0.00251724}, {52,0.00271552}, {53,0.00286207}, {54,0.00279310}, {55,0.00275000}, {56,0.00267241}, {57,0.00268966}, {58,0.00326724}, {59,0.00312069}, {60,0.00298276}, {61,0.00302586}, {62,0.00293103}, {63,0.00297414}, {64,0.00322414}, {65,0.00358621}, {66,0.00350000}, {67,0.00343103}, {68,0.00334483}, {69,0.00887931}, {70,0.00346552}, {71,0.00379310}, {72,0.00374138}, {73,0.00366379}, {74,0.00372414}, {75,0.00382759}, {76,0.00375862}, {77,0.00396552}, {78,0.00386207}, {79,0.00403448}, {80,0.00400862}, {81,0.00409483}, {82,0.00406897}, {83,0.00420690}, {84,0.06047414}, {85,0.00458621}, {86,0.00440517}, {87,0.00453448}, {88,0.00458621}, {89,0.00465517}, {90,0.00444828}, {91,0.00473276}, {92,0.00492241}, {93,0.00464655}, {94,0.00472414}, {95,0.00462931}, {96,0.00489655}, {97,0.00489655}, {98,0.00506897}, {99,0.00524138}, {100,0.00533621}, {101,0.00542241}, {102,0.00549138}, {103,0.00546552}, {104,0.00546552}, {105,0.00511207}, {106,0.00525862}, {107,0.00540517}, {108,0.00584483}, {109,0.00596552}, {110,0.00544828}, {111,0.00586207}, {112,0.00606897}, {113,0.03618966}, {114,0.00594828}, {115,0.00588793}, {116,0.00596552}, {117,0.00616379}, {118,0.00583621}, {119,0.00650862}, {120,0.00633621}, {121,0.00654310}, {122,0.00648276}, {123,0.00627586}, {124,0.00662069}, {125,0.00655172}, {126,0.00634483}, {127,0.00665517}, {128,0.00693103}, {129,0.00665517}, {130,0.00672414}, {131,0.00682759}, {132,0.00672414}, {133,0.00686207}, {134,0.00684483}, {135,0.00692241}, {136,0.00681034}, {137,0.00678448}, {138,0.00681897}, {139,0.00723276}, {140,0.03175000}, {141,0.00673276}, {142,0.00698276}, {143,0.00715517}, {144,0.00728448}, {145,0.00740517}, {146,0.00745690}, {147,0.00748276}, {148,0.00748276}, {149,0.00782759}, {150,0.00755172}, {151,0.00758621}, {152,0.00737931}, {153,0.00762069}, {154,0.00772414}, {155,0.00779310}, {156,0.00796552}, {157,0.00782759}, {158,0.00779310}, {159,0.00791379}, {160,0.00807759}, {161,0.00818966}, {162,0.00818966}, {163,0.00810345}, {164,0.00801724}, {165,0.00818103}, {166,0.00841379}, {167,0.00825862}, {168,0.00843103}, {169,0.00850862}, {170,0.00879310}, {171,0.00865517}, {172,0.00858621}, {173,0.00858621}, {174,0.03934483}, {175,0.00879310}, {176,0.00882759}, {177,0.00882759}, {178,0.00879310}, {179,0.00882759}, {180,0.00884483}, {181,0.00883621}, {182,0.00893103}, {183,0.00905172}, {184,0.00915517}, {185,0.00919828}, {186,0.00900000}, {187,0.00905172}, {188,0.00923276}, {189,0.00931897}, {190,0.00956034}, {191,0.00933621}, {192,0.00950862}, {193,0.00940517}, {194,0.00968966}, {195,0.01003448}, {196,0.00968966}, {197,0.00986207}, {198,0.04234483}, {199,0.05916379}, {200,0.00976724}, {201,0.00987931}, {202,0.01007759}, {203,0.01018966}, {204,0.00995690}, {205,0.06127586}, {206,0.00985345}, {207,0.01022414}, {208,0.01075862}, {209,0.01030172}, {210,0.01041379}, {211,0.01058621}, {212,0.07031034}, {213,0.01122414}, {214,0.01124138}, {215,0.01073276}, {216,0.01075000}, {217,0.01071552}, {218,0.01104310}, {219,0.05394828}, {220,0.01150862}, {221,0.01160345}, {222,0.01165517}, {223,0.01133621}, {224,0.01150000}, {225,0.01173276}, {226,0.01139655}, {227,0.01149138}, {228,0.01137069}, {229,0.01129310}, {230,0.01162931}, {231,0.01168103}, {232,0.04463793}, {233,0.01163793}, {234,0.01170690}, {235,0.01168966}, {236,0.01175862}, {237,0.01213793}, {238,0.01211207}, {239,0.01184483}, {240,0.01198276}, {241,0.01241379}, {242,0.01213793}, {243,0.01205172}, {244,0.01221552}, {245,0.01226724}, {246,0.01242241}, {247,0.01262069}, {248,0.01261207}, {249,0.01244828}, {250,0.01266379}, {251,0.01265517}, {252,0.01267241}, {253,0.01287931}, {254,0.01265517}, {255,0.01284483}, {256,0.01294828}, {257,0.01321552}, {258,0.01293103}, {259,0.01314655}, {260,0.01303448}, {261,0.01261207}, {262,0.07254310}, {263,0.01320690}, {264,0.01346552}, {265,0.01312069}, {266,0.01395690}, {267,0.01307759}, {268,0.01343103}, {269,0.01363793}, {270,0.01373276}, {271,0.01344828}, {272,0.01370690}, {273,0.04710345}, {274,0.01377586}, {275,0.01353448}, {276,0.01365517}, {277,0.01404310}, {278,0.01426724}, {279,0.01403448}, {280,0.01381034}, {281,0.01401724}, {282,0.11393966}, {283,0.06504310}, {284,0.01350000}, {285,0.01384483}, {286,0.01362931}, {287,0.01373276}, {288,0.01415517}, {289,0.01463793}, {290,0.01443103}, {291,0.01450000}, {292,0.01398276}, {293,0.01414655}, {294,0.01369828}, {295,0.01424138}, {296,0.01424138}, {297,0.01459483}, {298,0.01460345}, {299,0.01475000}, {300,0.01490517}, {301,0.01480172}, {302,0.01514655}, {303,0.01502586}, {304,0.01494828}, {305,0.01497414}, {306,0.01518966}, {307,0.01510345}, {308,0.04442241}, {309,0.01513793}, {310,0.01548276}, {311,0.01556034}, {312,0.01534483}, {313,0.04517241}, {314,0.01535345}, {315,0.01559483}, {316,0.01578448}, {317,0.01555172}, {318,0.01575000}, {319,0.01573276}, {320,0.01575862}, {321,0.01575000}, {322,0.01588793}, {323,0.01602586}, {324,0.01618966}, {325,0.01599138}, {326,0.01625862}, {327,0.04525862}, {328,0.01631897}, {329,0.01623276}, {330,0.01606034}, {331,0.01636207}, {332,0.01613793}, {333,0.01631034}, {334,0.01631034}, {335,0.01654310}, {336,0.04764655}, {337,0.01625862}, {338,0.01660345}, {339,0.01679310}, {340,0.01678448}, {341,0.01643966}, {342,0.01664655}, {343,0.01684483}, {344,0.01677586}, {345,0.01647414}, {346,0.01706034}, {347,0.01697414}, {348,0.01695690}, {349,0.04662069}, {350,0.01696552}, {351,0.01692241}, {352,0.01716379}, {353,0.08692241}, {354,0.01770690}, {355,0.01786207}, {356,0.01785345}, {357,0.01779310}, {358,0.01802586}, {359,0.01834483}, {360,0.01808621}, {361,0.01821552}, {362,0.01815517}, {363,0.01818966}, {364,0.01821552}, {365,0.01842241}, {366,0.01785345}, {367,0.01811207}, {368,0.01839655}, {369,0.01823276}, {370,0.01840517}, {371,0.01862931}, {372,0.01837931}, {373,0.01854310}, {374,0.01833621}, {375,0.01896552}, {376,0.01873276}, {377,0.01867241}, {378,0.01886207}, {379,0.01874138}, {380,0.01878448}, {381,0.01912069}, {382,0.01905172}, {383,0.01898276}, {384,0.01928448}, {385,0.01896552}, {386,0.01907759}, {387,0.01926724}, {388,0.01918966}, {389,0.07823276}, {390,0.01942241}, {391,0.01944828}, {392,0.01929310}, {393,0.08115517}, {394,0.01957759}, {395,0.01961207}, {396,0.01963793}, {397,0.07279310}, {398,0.01962069}, {399,0.01988793}, {400,0.01896552}, {401,0.01912069}, {402,0.01912069}, {403,0.01911207}, {404,0.01909483}, {405,0.01918966}, {406,0.01918966}, {407,0.04914655}, {408,0.01931897}, {409,0.01959483}, {410,0.01963793}, {411,0.01944828}, {412,0.01976724}, {413,0.01963793}, {414,0.01969828}, {415,0.02002586}, {416,0.01982759}, {417,0.01991379}, {418,0.05940517}, {419,0.01999138}, {420,0.02011207}, {421,0.02007759}, {422,0.02044828}, {423,0.01965517}, {424,0.02001724}, {425,0.04850000}, {426,0.02048276}, {427,0.02022414}, {428,0.02029310}, {429,0.02040517}, {430,0.02058621}, {431,0.02025862}, {432,0.04736207}, {433,0.02053448}, {434,0.02080172}, {435,0.02043966}, {436,0.02101724}, {437,0.02049138}, {438,0.02102586}, {439,0.02112069}, {440,0.02075000}, {441,0.02093966}, {442,0.05327586}, {443,0.02106897}, {444,0.02104310}, {445,0.02090517}, {446,0.02163793}, {447,0.02137931}, {448,0.02150000}, {449,0.02148276}, {450,0.02182759}, {451,0.02177586}, {452,0.05398276}, {453,0.02149138}, {454,0.02153448}, {455,0.02172414}, {456,0.02167241}, {457,0.02195690}, {458,0.02162931}, {459,0.02190517}, {460,0.02179310}, {461,0.02188793}, {462,0.05434483}, {463,0.02237931}, {464,0.02220690}, {465,0.05633621}, {466,0.02226724}, {467,0.02253448}, {468,0.02249138}, {469,0.02256897}, {470,0.02261207}, {471,0.02235345}, {472,0.02256034}, {473,0.02279310}, {474,0.02277586}, {475,0.02362069}, {476,0.02402586}, {477,0.02429310}, {478,0.02412069}, {479,0.02417241}, {480,0.02410345}, {481,0.06601724}, {482,0.02395690}, {483,0.02446552}, {484,0.05692241}, {485,0.02450862}, {486,0.02424138}, {487,0.05365517}, {488,0.02456034}, {489,0.02427586}, {490,0.05431034}, {491,0.02471552}, {492,0.02479310}, {493,0.05581034}, {494,0.02485345}, {495,0.02462069}, {496,0.07351724}, {497,0.02479310}, {498,0.02489655}, {499,0.08530172}, {500,0.025147186}, {505,0.08482609}, {510,0.02567826}, {515,0.02582609}, {520,0.08553913}, {525,0.02636522}, {530,0.02624348}, {535,0.07726087}, {540,0.02719130}, {545,0.02754783}, {550,0.02758261}, {555,0.02813913}, {560,0.02786087}, {565,0.02817391}, {570,0.02843860}, {575,0.08783333}, {580,0.02921930}, {585,0.02959649}, {590,0.02954386}, {595,0.03000877}, {600,0.09014783}, {605,0.03085088}, {610,0.03090351}, {615,0.03128947}, {620,0.03147368}, {625,0.08807018}, {630,0.03236842}, {635,0.03237719}, {640,0.03228947}, {645,0.03268421}, {650,0.03314035}, {655,0.03331579}, {660,0.06428947}, {665,0.03380702}, {670,0.06690351}, {675,0.03422807}, {680,0.03449123}, {685,0.03457018}, {690,0.03506140}, {695,0.03530702}, {700,0.03565217}, {705,0.03570175}, {710,0.03571053}, {715,0.03578947}, {720,0.03630702}, {725,0.06759649}, {730,0.03682456}, {735,0.06813158}, {740,0.03772807}, {745,0.06682456}, {750,0.03796491}, {755,0.06679825}, {760,0.03835965}, {765,0.06165789}, {770,0.03703509}, {775,0.03739474}, {780,0.03749123}, {785,0.03819298}, {790,0.03832456}, {795,0.03868421}, {800,0.03898261}, {805,0.03898246}, {810,0.03930702}, {815,0.06850000}, {820,0.03964035}, {825,0.07171930}, {830,0.04009649}, {835,0.06417544}, {840,0.04094737}, {845,0.04107018}, {850,0.04140351}, {855,0.04173684}, {860,0.07078070}, {865,0.04185965}, {870,0.04245614}, {875,0.04291228}, {880,0.04277193}, {885,0.07486842}, {890,0.04379825}, {895,0.07310526}, {900,0.04459130}, {905,0.04439474}, {910,0.07741228}, {915,0.04466667}, {920,0.04459649}, {925,0.04534211}, {930,0.04525439}, {935,0.13683333}, {940,0.04738596}, {945,0.04771930}, {950,0.09521053}, {955,0.04832456}, {960,0.04809649}, {965,0.08342105}, {970,0.04872807}, {975,0.04904386}, {980,0.09258772}, {985,0.04943860}, {990,0.04998246}, {995,0.11824561}, {1000,0.04995652}, {1010,0.05000}, {1020,0.05125}, {1030,0.11125}, {1040,0.05175}, {1050,0.05350}, {1060,0.09175}, {1070,0.05350}, {1080,0.05475}, {1090,0.05500}, {1100,0.12650}, {1110,0.05450}, {1120,0.05300}, {1130,0.05500}, {1140,0.08775}, {1150,0.05650}, {1160,0.05500}, {1170,0.05700}, {1180,0.08675}, {1190,0.15375}, {1200,0.05900}, {1210,0.06175}, {1220,0.06200}, {1230,0.06050}, {1240,0.10050}, {1250,0.09175}, {1260,0.06375}, {1270,0.06400}, {1280,0.06475}, {1290,0.06575}, {1300,0.10250}, {1310,0.12050}, {1320,0.09950}, {1330,0.06300}, {1340,0.06350}, {1350,0.15975}, {1360,0.06650}, {1370,0.06675}, {1380,0.06825}, {1390,0.06625}, {1400,0.06850}, {1410,0.12875}, {1420,0.11850}, {1430,0.11475}, {1440,0.09875}, {1450,0.10175}, {1460,0.10375}, {1470,0.11150}, {1480,0.11450}, {1490,0.10600}, {1500,0.10240}, {1510,0.11850}, {1520,0.11600}, {1530,0.13750}, {1540,0.13750}, {1550,0.13475}, {1560,0.12350}, {1570,0.09575}, {1580,0.09675}, {1590,0.09825}, {1600,0.07700}, {1610,0.07775}, {1620,0.26700}, {1630,0.07900}, {1640,0.11250}, {1650,0.14775}, {1660,0.12750}, {1670,0.11300}, {1680,0.08550}, {1690,0.08625}, {1700,0.08675}, {1710,0.08500}, {1720,0.14600}, {1730,0.15400}, {1740,0.13850}, {1750,0.08725}, {1760,0.08675}, {1770,0.08725}, {1780,0.11975}, {1790,0.12250}, {1800,0.10750}, {1810,0.09050}, {1820,0.09275}, {1830,0.12450}, {1840,0.11150}, {1850,0.09075}, {1860,0.08925}, {1870,0.11950}, {1880,0.12300}, {1890,0.09175}, {1900,0.09250}, {1910,0.11900}, {1920,0.11925}, {1930,0.09300}, {1940,0.09600}, {1950,0.12950}, {1960,0.09275}, {1970,0.09700}, {1980,0.13050}, {1990,0.12325}, {2000,0.10840}, {2050,0.18350}, {2100,0.10550}, {2150,0.14125}, {2200,0.14050}, {2250,0.11300}, {2300,0.15350}, {2350,0.15025}, {2400,0.15575}, {2450,0.12350}, {2500,0.15900}, {2550,0.16850}, {2600,0.12675}, {2650,0.15125}, {2700,0.15450}, {2750,0.16650}, {2800,0.17850}, {2850,0.18425}, {2900,0.18250}, {2950,0.14325}, {3000,0.16360}, {3050,0.19425}, {3100,0.19450}, {3150,0.20075}, {3200,0.22175}, {3250,0.19950}, {3300,0.21250}, {3350,0.18075}, {3400,0.24200}, {3450,0.27175}, {3500,0.21920}, {3550,0.29000}, {3600,0.27550}, {3650,0.29350}, {3700,0.28550}, {3750,0.27250}, {3800,0.23600}, {3850,0.25500}, {3900,0.23650}, {3950,0.25575}, {4000,0.26000}, {4050,0.24425}, {4100,0.25150}, {4150,0.26375}, {4200,0.25975}, {4250,0.27050}, {4300,0.23925}, {4350,0.25300}, {4400,0.25625}, {4450,0.26550}, {4500,0.26440}, {4550,0.26250}, {4600,0.26475}, {4650,0.32550}, {4700,0.31825}, {4750,0.36475}, {4800,0.36025}, {4850,0.38525}, {4900,0.39775}, {4950,0.38275}, {5000,0.33360}};
data["big_flat"]["ParsingElaborated"]["actual reif"]["system"] = {{1,0.00018103}, {2,0.00024138}, {3,0.00019828}, {4,0.00006897}, {5,0.00009483}, {6,0.00000000}, {7,0.00003448}, {8,0.00000000}, {9,0.00006897}, {10,0.00014655}, {11,0.00016379}, {12,0.00003448}, {13,0.00006897}, {14,0.00009483}, {15,0.00012931}, {16,0.00006897}, {17,0.00006897}, {18,0.00006897}, {19,0.00010345}, {20,0.00018966}, {21,0.00017241}, {22,0.00023276}, {23,0.00019828}, {24,0.00012931}, {25,0.00010345}, {26,0.00012931}, {27,0.00008621}, {28,0.00010345}, {29,0.00026724}, {30,0.00023276}, {31,0.00012931}, {32,0.00002586}, {33,0.00009483}, {34,0.00041379}, {35,0.00013793}, {36,0.00007759}, {37,0.00030172}, {38,0.00006897}, {39,0.00000000}, {40,0.00009483}, {41,0.00008621}, {42,0.00006897}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00003448}, {47,0.00003448}, {48,0.00000000}, {49,0.00003448}, {50,0.00003448}, {51,0.00003448}, {52,0.00006897}, {53,0.00000000}, {54,0.00006897}, {55,0.00006034}, {56,0.00015517}, {57,0.00003448}, {58,0.00000000}, {59,0.00003448}, {60,0.00003448}, {61,0.00000000}, {62,0.00003448}, {63,0.00006034}, {64,0.00010345}, {65,0.00000000}, {66,0.00003448}, {67,0.00000000}, {68,0.00003448}, {69,0.00023276}, {70,0.00000000}, {71,0.00006897}, {72,0.00002586}, {73,0.00002586}, {74,0.00006034}, {75,0.00006897}, {76,0.00006897}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00003448}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00044828}, {85,0.00006897}, {86,0.00006034}, {87,0.00006897}, {88,0.00006897}, {89,0.00003448}, {90,0.00003448}, {91,0.00003448}, {92,0.00000000}, {93,0.00006034}, {94,0.00003448}, {95,0.00012069}, {96,0.00013793}, {97,0.00003448}, {98,0.00003448}, {99,0.00000000}, {100,0.00020690}, {101,0.00003448}, {102,0.00006897}, {103,0.00006897}, {104,0.00000000}, {105,0.00003448}, {106,0.00003448}, {107,0.00000000}, {108,0.00006034}, {109,0.00003448}, {110,0.00006897}, {111,0.00010345}, {112,0.00002586}, {113,0.00060345}, {114,0.00006897}, {115,0.00003448}, {116,0.00010345}, {117,0.00003448}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00003448}, {122,0.00002586}, {123,0.00009483}, {124,0.00003448}, {125,0.00000000}, {126,0.00019828}, {127,0.00013793}, {128,0.00009483}, {129,0.00012931}, {130,0.00017241}, {131,0.00013793}, {132,0.00002586}, {133,0.00010345}, {134,0.00013793}, {135,0.00006897}, {136,0.00006897}, {137,0.00010345}, {138,0.00013793}, {139,0.00012931}, {140,0.00015517}, {141,0.00012069}, {142,0.00002586}, {143,0.00000000}, {144,0.00003448}, {145,0.00009483}, {146,0.00009483}, {147,0.00006034}, {148,0.00006897}, {149,0.00003448}, {150,0.00006034}, {151,0.00003448}, {152,0.00000000}, {153,0.00006897}, {154,0.00003448}, {155,0.00006897}, {156,0.00003448}, {157,0.00010345}, {158,0.00003448}, {159,0.00003448}, {160,0.00003448}, {161,0.00006897}, {162,0.00010345}, {163,0.00010345}, {164,0.00003448}, {165,0.00000000}, {166,0.00006897}, {167,0.00003448}, {168,0.00000000}, {169,0.00003448}, {170,0.00000000}, {171,0.00006034}, {172,0.00000000}, {173,0.00006897}, {174,0.00088793}, {175,0.00003448}, {176,0.00009483}, {177,0.00006034}, {178,0.00010345}, {179,0.00003448}, {180,0.00003448}, {181,0.00012931}, {182,0.00003448}, {183,0.00020690}, {184,0.00006897}, {185,0.00010345}, {186,0.00016379}, {187,0.00000000}, {188,0.00013793}, {189,0.00000000}, {190,0.00012931}, {191,0.00013793}, {192,0.00008621}, {193,0.00006897}, {194,0.00002586}, {195,0.00010345}, {196,0.00010345}, {197,0.00018966}, {198,0.00071552}, {199,0.00030172}, {200,0.00003448}, {201,0.00016379}, {202,0.00006897}, {203,0.00011207}, {204,0.00013793}, {205,0.00158621}, {206,0.00019828}, {207,0.00020690}, {208,0.00020690}, {209,0.00012931}, {210,0.00002586}, {211,0.00006897}, {212,0.00097414}, {213,0.00016379}, {214,0.00003448}, {215,0.00009483}, {216,0.00010345}, {217,0.00017241}, {218,0.00006897}, {219,0.00043103}, {220,0.00006897}, {221,0.00000000}, {222,0.00003448}, {223,0.00010345}, {224,0.00006897}, {225,0.00010345}, {226,0.00002586}, {227,0.00018966}, {228,0.00003448}, {229,0.00006897}, {230,0.00010345}, {231,0.00006897}, {232,0.00056034}, {233,0.00018966}, {234,0.00012069}, {235,0.00016379}, {236,0.00016379}, {237,0.00002586}, {238,0.00006897}, {239,0.00013793}, {240,0.00020690}, {241,0.00006034}, {242,0.00006034}, {243,0.00009483}, {244,0.00013793}, {245,0.00006897}, {246,0.00006897}, {247,0.00003448}, {248,0.00003448}, {249,0.00012069}, {250,0.00006897}, {251,0.00003448}, {252,0.00013793}, {253,0.00006897}, {254,0.00003448}, {255,0.00005172}, {256,0.00013793}, {257,0.00030172}, {258,0.00013793}, {259,0.00022414}, {260,0.00010345}, {261,0.00029310}, {262,0.00068966}, {263,0.00020690}, {264,0.00010345}, {265,0.00006897}, {266,0.00003448}, {267,0.00003448}, {268,0.00030172}, {269,0.00000000}, {270,0.00013793}, {271,0.00030172}, {272,0.00006034}, {273,0.00048276}, {274,0.00026724}, {275,0.00021552}, {276,0.00022414}, {277,0.00006034}, {278,0.00012931}, {279,0.00016379}, {280,0.00013793}, {281,0.00016379}, {282,0.00065517}, {283,0.00234483}, {284,0.00057759}, {285,0.00044828}, {286,0.00003448}, {287,0.00006897}, {288,0.00003448}, {289,0.00018966}, {290,0.00027586}, {291,0.00013793}, {292,0.00012931}, {293,0.00006034}, {294,0.00016379}, {295,0.00010345}, {296,0.00016379}, {297,0.00000000}, {298,0.00006897}, {299,0.00019828}, {300,0.00009483}, {301,0.00010345}, {302,0.00002586}, {303,0.00006897}, {304,0.00006897}, {305,0.00002586}, {306,0.00010345}, {307,0.00010345}, {308,0.00070690}, {309,0.00013793}, {310,0.00003448}, {311,0.00003448}, {312,0.00017241}, {313,0.00075000}, {314,0.00010345}, {315,0.00006897}, {316,0.00006034}, {317,0.00017241}, {318,0.00006897}, {319,0.00010345}, {320,0.00003448}, {321,0.00019828}, {322,0.00017241}, {323,0.00010345}, {324,0.00016379}, {325,0.00020690}, {326,0.00006897}, {327,0.00050862}, {328,0.00000000}, {329,0.00006897}, {330,0.00006897}, {331,0.00000000}, {332,0.00026724}, {333,0.00003448}, {334,0.00017241}, {335,0.00003448}, {336,0.00039655}, {337,0.00027586}, {338,0.00010345}, {339,0.00006897}, {340,0.00006897}, {341,0.00016379}, {342,0.00023276}, {343,0.00013793}, {344,0.00012931}, {345,0.00024138}, {346,0.00015517}, {347,0.00010345}, {348,0.00017241}, {349,0.00016379}, {350,0.00012931}, {351,0.00020690}, {352,0.00010345}, {353,0.00063793}, {354,0.00020690}, {355,0.00010345}, {356,0.00012931}, {357,0.00006034}, {358,0.00013793}, {359,0.00003448}, {360,0.00016379}, {361,0.00006897}, {362,0.00006897}, {363,0.00016379}, {364,0.00024138}, {365,0.00010345}, {366,0.00022414}, {367,0.00025862}, {368,0.00016379}, {369,0.00012931}, {370,0.00019828}, {371,0.00010345}, {372,0.00012931}, {373,0.00013793}, {374,0.00010345}, {375,0.00002586}, {376,0.00006897}, {377,0.00009483}, {378,0.00023276}, {379,0.00013793}, {380,0.00020690}, {381,0.00000000}, {382,0.00017241}, {383,0.00017241}, {384,0.00003448}, {385,0.00010345}, {386,0.00010345}, {387,0.00015517}, {388,0.00003448}, {389,0.00050862}, {390,0.00010345}, {391,0.00003448}, {392,0.00012931}, {393,0.00087069}, {394,0.00012069}, {395,0.00009483}, {396,0.00012931}, {397,0.00054310}, {398,0.00020690}, {399,0.00012931}, {400,0.00013793}, {401,0.00003448}, {402,0.00017241}, {403,0.00010345}, {404,0.00003448}, {405,0.00006897}, {406,0.00020690}, {407,0.00057759}, {408,0.00010345}, {409,0.00010345}, {410,0.00006897}, {411,0.00026724}, {412,0.00012931}, {413,0.00025862}, {414,0.00010345}, {415,0.00023276}, {416,0.00012069}, {417,0.00013793}, {418,0.00109483}, {419,0.00010345}, {420,0.00017241}, {421,0.00020690}, {422,0.00020690}, {423,0.00020690}, {424,0.00017241}, {425,0.00067241}, {426,0.00012069}, {427,0.00023276}, {428,0.00000000}, {429,0.00006897}, {430,0.00019828}, {431,0.00029310}, {432,0.00070690}, {433,0.00016379}, {434,0.00013793}, {435,0.00012931}, {436,0.00027586}, {437,0.00018966}, {438,0.00020690}, {439,0.00020690}, {440,0.00012931}, {441,0.00016379}, {442,0.00079310}, {443,0.00027586}, {444,0.00019828}, {445,0.00006897}, {446,0.00013793}, {447,0.00020690}, {448,0.00010345}, {449,0.00017241}, {450,0.00013793}, {451,0.00013793}, {452,0.00054310}, {453,0.00010345}, {454,0.00013793}, {455,0.00017241}, {456,0.00003448}, {457,0.00013793}, {458,0.00026724}, {459,0.00016379}, {460,0.00006897}, {461,0.00017241}, {462,0.00083621}, {463,0.00003448}, {464,0.00006897}, {465,0.00026724}, {466,0.00026724}, {467,0.00012931}, {468,0.00006897}, {469,0.00017241}, {470,0.00012931}, {471,0.00030172}, {472,0.00027586}, {473,0.00017241}, {474,0.00017241}, {475,0.00031034}, {476,0.00009483}, {477,0.00013793}, {478,0.00010345}, {479,0.00010345}, {480,0.00017241}, {481,0.00047414}, {482,0.00017241}, {483,0.00006897}, {484,0.00041379}, {485,0.00017241}, {486,0.00033621}, {487,0.00062069}, {488,0.00019828}, {489,0.00020690}, {490,0.00076724}, {491,0.00023276}, {492,0.00013793}, {493,0.00058621}, {494,0.00017241}, {495,0.00016379}, {496,0.00081897}, {497,0.00034483}, {498,0.00020690}, {499,0.00068966}, {500,0.000212121}, {505,0.00088696}, {510,0.00020870}, {515,0.00012174}, {520,0.00059130}, {525,0.00027826}, {530,0.00017391}, {535,0.00046957}, {540,0.00006957}, {545,0.00002609}, {550,0.00013913}, {555,0.00010435}, {560,0.00006087}, {565,0.00024348}, {570,0.00028070}, {575,0.00057018}, {580,0.00031579}, {585,0.00017544}, {590,0.00059649}, {595,0.00014035}, {600,0.00066087}, {605,0.00020175}, {610,0.00014035}, {615,0.00020175}, {620,0.00023684}, {625,0.00092982}, {630,0.00010526}, {635,0.00030702}, {640,0.00038596}, {645,0.00048246}, {650,0.00013158}, {655,0.00031579}, {660,0.00071930}, {665,0.00017544}, {670,0.00056140}, {675,0.00031579}, {680,0.00009649}, {685,0.00017544}, {690,0.00014035}, {695,0.00016667}, {700,0.00029565}, {705,0.00024561}, {710,0.00028070}, {715,0.00030702}, {720,0.00035088}, {725,0.00073684}, {730,0.00031579}, {735,0.00071930}, {740,0.00021053}, {745,0.00072807}, {750,0.00006140}, {755,0.00056140}, {760,0.00009649}, {765,0.00088596}, {770,0.00045614}, {775,0.00056140}, {780,0.00054386}, {785,0.00017544}, {790,0.00030702}, {795,0.00016667}, {800,0.00013913}, {805,0.00027193}, {810,0.00020175}, {815,0.00061404}, {820,0.00034211}, {825,0.00092105}, {830,0.00038596}, {835,0.00086842}, {840,0.00017544}, {845,0.00017544}, {850,0.00031579}, {855,0.00020175}, {860,0.00010526}, {865,0.00021053}, {870,0.00021053}, {875,0.00023684}, {880,0.00035088}, {885,0.00049123}, {890,0.00024561}, {895,0.00035088}, {900,0.00020870}, {905,0.00021053}, {910,0.00049123}, {915,0.00024561}, {920,0.00048246}, {925,0.00003509}, {930,0.00021053}, {935,0.00190351}, {940,0.00030702}, {945,0.00029825}, {950,0.00106140}, {955,0.00038596}, {960,0.00042105}, {965,0.00086842}, {970,0.00059649}, {975,0.00024561}, {980,0.00094737}, {985,0.00024561}, {990,0.00030702}, {995,0.00106140}, {1000,0.00041739}, {1010,0.00300}, {1020,0.00100}, {1030,0.00175}, {1040,0.00000}, {1050,0.00100}, {1060,0.00175}, {1070,0.00000}, {1080,0.00000}, {1090,0.00000}, {1100,0.00100}, {1110,0.00000}, {1120,0.00100}, {1130,0.00000}, {1140,0.00000}, {1150,0.00000}, {1160,0.00075}, {1170,0.00000}, {1180,0.00275}, {1190,0.00275}, {1200,0.00000}, {1210,0.00000}, {1220,0.00000}, {1230,0.00100}, {1240,0.00075}, {1250,0.00100}, {1260,0.00000}, {1270,0.00000}, {1280,0.00000}, {1290,0.00000}, {1300,0.00000}, {1310,0.00000}, {1320,0.00200}, {1330,0.00250}, {1340,0.00200}, {1350,0.00000}, {1360,0.00000}, {1370,0.00000}, {1380,0.00000}, {1390,0.00000}, {1400,0.00100}, {1410,0.00200}, {1420,0.00100}, {1430,0.00000}, {1440,0.00100}, {1450,0.00175}, {1460,0.00175}, {1470,0.00000}, {1480,0.00000}, {1490,0.00375}, {1500,0.00240}, {1510,0.00100}, {1520,0.00100}, {1530,0.00000}, {1540,0.00000}, {1550,0.00000}, {1560,0.00200}, {1570,0.00000}, {1580,0.00000}, {1590,0.00000}, {1600,0.00000}, {1610,0.00000}, {1620,0.00200}, {1630,0.00075}, {1640,0.00000}, {1650,0.00000}, {1660,0.00000}, {1670,0.00100}, {1680,0.00000}, {1690,0.00000}, {1700,0.00100}, {1710,0.00000}, {1720,0.00375}, {1730,0.00500}, {1740,0.00475}, {1750,0.00000}, {1760,0.00200}, {1770,0.00100}, {1780,0.00500}, {1790,0.00500}, {1800,0.00500}, {1810,0.00000}, {1820,0.00000}, {1830,0.00500}, {1840,0.00600}, {1850,0.00100}, {1860,0.00000}, {1870,0.00400}, {1880,0.00775}, {1890,0.00175}, {1900,0.00000}, {1910,0.00700}, {1920,0.00200}, {1930,0.00100}, {1940,0.00100}, {1950,0.00000}, {1960,0.00200}, {1970,0.00000}, {1980,0.00200}, {1990,0.00000}, {2000,0.00000}, {2050,0.00500}, {2100,0.00100}, {2150,0.00600}, {2200,0.00875}, {2250,0.00000}, {2300,0.00800}, {2350,0.00400}, {2400,0.00400}, {2450,0.00000}, {2500,0.00480}, {2550,0.00875}, {2600,0.00000}, {2650,0.00400}, {2700,0.00900}, {2750,0.00800}, {2800,0.00875}, {2850,0.00500}, {2900,0.00975}, {2950,0.00000}, {3000,0.00560}, {3050,0.00400}, {3100,0.00300}, {3150,0.00200}, {3200,0.01100}, {3250,0.01100}, {3300,0.00600}, {3350,0.00000}, {3400,0.01175}, {3450,0.00775}, {3500,0.00320}, {3550,0.01100}, {3600,0.00800}, {3650,0.01000}, {3700,0.00800}, {3750,0.01100}, {3800,0.01200}, {3850,0.01000}, {3900,0.00800}, {3950,0.01175}, {4000,0.01080}, {4050,0.00775}, {4100,0.00800}, {4150,0.00975}, {4200,0.01400}, {4250,0.01000}, {4300,0.01175}, {4350,0.00400}, {4400,0.00800}, {4450,0.00900}, {4500,0.00720}, {4550,0.01100}, {4600,0.01000}, {4650,0.01600}, {4700,0.00400}, {4750,0.00300}, {4800,0.00100}, {4850,0.00200}, {4900,0.00100}, {4950,0.00000}, {5000,0.00060}};
data["big_flat"]["ParsingElaborated"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00013793}, {12,0.00000000}, {13,0.00000000}, {14,0.00003448}, {15,0.00054310}, {16,0.00100000}, {17,0.00062931}, {18,0.00098276}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00100000}, {23,0.00199138}, {24,0.00100000}, {25,0.00100000}, {26,0.00100000}, {27,0.00100000}, {28,0.00100000}, {29,0.00100000}, {30,0.00100862}, {31,0.00100000}, {32,0.00105172}, {33,0.00101724}, {34,0.00139655}, {35,0.00138793}, {36,0.00136207}, {37,0.00145690}, {38,0.00135345}, {39,0.00181897}, {40,0.00200000}, {41,0.00200000}, {42,0.00200000}, {43,0.00200000}, {44,0.00200000}, {45,0.00200000}, {46,0.00200000}, {47,0.00200000}, {48,0.00500862}, {49,0.00200000}, {50,0.00200000}, {51,0.00200000}, {52,0.00200862}, {53,0.00203448}, {54,0.00205172}, {55,0.00204310}, {56,0.00206034}, {57,0.00233621}, {58,0.00243966}, {59,0.00281034}, {60,0.00289655}, {61,0.00280172}, {62,0.00294828}, {63,0.00300000}, {64,0.00300000}, {65,0.00300000}, {66,0.00300000}, {67,0.00300000}, {68,0.00300000}, {69,0.00857759}, {70,0.00300000}, {71,0.00300000}, {72,0.00300862}, {73,0.00300862}, {74,0.00304310}, {75,0.00309483}, {76,0.00312931}, {77,0.00339655}, {78,0.00317241}, {79,0.00347414}, {80,0.00357759}, {81,0.00396552}, {82,0.00394828}, {83,0.00400000}, {84,0.06087069}, {85,0.00400000}, {86,0.00400000}, {87,0.00400000}, {88,0.00400000}, {89,0.00400000}, {90,0.00400862}, {91,0.00400862}, {92,0.00404310}, {93,0.00402586}, {94,0.00405172}, {95,0.00420690}, {96,0.00443966}, {97,0.00474138}, {98,0.00491379}, {99,0.00488793}, {100,0.00499138}, {101,0.00500000}, {102,0.00500000}, {103,0.00500000}, {104,0.00500000}, {105,0.00500000}, {106,0.00500000}, {107,0.00500000}, {108,0.00500000}, {109,0.00501724}, {110,0.00500862}, {111,0.00506034}, {112,0.00512069}, {113,0.03656034}, {114,0.00581897}, {115,0.00589655}, {116,0.00588793}, {117,0.00593966}, {118,0.00592241}, {119,0.00598276}, {120,0.00600000}, {121,0.00600000}, {122,0.00600000}, {123,0.00600000}, {124,0.00600000}, {125,0.00600000}, {126,0.00600000}, {127,0.00600862}, {128,0.00602586}, {129,0.00616379}, {130,0.00606897}, {131,0.00608621}, {132,0.00636207}, {133,0.00680172}, {134,0.00689655}, {135,0.00690517}, {136,0.00692241}, {137,0.00698276}, {138,0.00700000}, {139,0.00700862}, {140,0.03193103}, {141,0.00690517}, {142,0.00698276}, {143,0.00699138}, {144,0.00699138}, {145,0.00699138}, {146,0.00700000}, {147,0.00699138}, {148,0.00700000}, {149,0.00700000}, {150,0.00700000}, {151,0.00700000}, {152,0.00701724}, {153,0.00700862}, {154,0.00711207}, {155,0.00736207}, {156,0.00748276}, {157,0.00722414}, {158,0.00731034}, {159,0.00762069}, {160,0.00793103}, {161,0.00799138}, {162,0.00797414}, {163,0.00800000}, {164,0.00800000}, {165,0.00800000}, {166,0.00800000}, {167,0.00800000}, {168,0.00800000}, {169,0.00800000}, {170,0.00800862}, {171,0.00800000}, {172,0.00800000}, {173,0.00802586}, {174,0.03996552}, {175,0.00829310}, {176,0.00840517}, {177,0.00861207}, {178,0.00851724}, {179,0.00846552}, {180,0.00857759}, {181,0.00893103}, {182,0.00897414}, {183,0.00899138}, {184,0.00898276}, {185,0.00900000}, {186,0.00900000}, {187,0.00900000}, {188,0.00900000}, {189,0.00900000}, {190,0.00900862}, {191,0.00900000}, {192,0.00901724}, {193,0.00902586}, {194,0.00932759}, {195,0.00926724}, {196,0.00968103}, {197,0.00935345}, {198,0.04266379}, {199,0.05896552}, {200,0.00965517}, {201,0.00990517}, {202,0.00994828}, {203,0.00999138}, {204,0.01000000}, {205,0.06245690}, {206,0.01000000}, {207,0.01000000}, {208,0.01000000}, {209,0.01000000}, {210,0.01000862}, {211,0.01000862}, {212,0.07080172}, {213,0.01092241}, {214,0.01093103}, {215,0.01099138}, {216,0.01098276}, {217,0.01098276}, {218,0.01099138}, {219,0.05416379}, {220,0.01100000}, {221,0.01100862}, {222,0.01100862}, {223,0.01100862}, {224,0.01103448}, {225,0.01120690}, {226,0.01118103}, {227,0.01157759}, {228,0.01149138}, {229,0.01135345}, {230,0.01162931}, {231,0.01174138}, {232,0.04485345}, {233,0.01195690}, {234,0.01193966}, {235,0.01199138}, {236,0.01195690}, {237,0.01199138}, {238,0.01200000}, {239,0.01200862}, {240,0.01200862}, {241,0.01203448}, {242,0.01200000}, {243,0.01200862}, {244,0.01223276}, {245,0.01209483}, {246,0.01218966}, {247,0.01254310}, {248,0.01262069}, {249,0.01243966}, {250,0.01236207}, {251,0.01287069}, {252,0.01285345}, {253,0.01283621}, {254,0.01293966}, {255,0.01295690}, {256,0.01299138}, {257,0.01295690}, {258,0.01300000}, {259,0.01300000}, {260,0.01300862}, {261,0.01301724}, {262,0.07289655}, {263,0.01304310}, {264,0.01302586}, {265,0.01304310}, {266,0.01312931}, {267,0.01325000}, {268,0.01337069}, {269,0.01332759}, {270,0.01370690}, {271,0.01381034}, {272,0.01374138}, {273,0.04712069}, {274,0.01393966}, {275,0.01394828}, {276,0.01397414}, {277,0.01399138}, {278,0.01400000}, {279,0.01400000}, {280,0.01400000}, {281,0.01400862}, {282,0.11437069}, {283,0.06771552}, {284,0.01388793}, {285,0.01396552}, {286,0.01399138}, {287,0.01400000}, {288,0.01400000}, {289,0.01400000}, {290,0.01400862}, {291,0.01400862}, {292,0.01400000}, {293,0.01400862}, {294,0.01401724}, {295,0.01406034}, {296,0.01406034}, {297,0.01408621}, {298,0.01423276}, {299,0.01439655}, {300,0.01455172}, {301,0.01465517}, {302,0.01475000}, {303,0.01482759}, {304,0.01483621}, {305,0.01493103}, {306,0.01496552}, {307,0.01494828}, {308,0.04481897}, {309,0.01500000}, {310,0.01500000}, {311,0.01500000}, {312,0.01504310}, {313,0.04541379}, {314,0.01501724}, {315,0.01504310}, {316,0.01506034}, {317,0.01524138}, {318,0.01519828}, {319,0.01528448}, {320,0.01544828}, {321,0.01564655}, {322,0.01574138}, {323,0.01583621}, {324,0.01587931}, {325,0.01593103}, {326,0.01593103}, {327,0.04510345}, {328,0.01598276}, {329,0.01599138}, {330,0.01599138}, {331,0.01600862}, {332,0.01600862}, {333,0.01600862}, {334,0.01601724}, {335,0.01602586}, {336,0.04802586}, {337,0.01614655}, {338,0.01618966}, {339,0.01636207}, {340,0.01626724}, {341,0.01661207}, {342,0.01675862}, {343,0.01668966}, {344,0.01683621}, {345,0.01678448}, {346,0.01688793}, {347,0.01693966}, {348,0.01693966}, {349,0.04654310}, {350,0.01698276}, {351,0.01701724}, {352,0.01700862}, {353,0.08748276}, {354,0.01794828}, {355,0.01796552}, {356,0.01798276}, {357,0.01798276}, {358,0.01800862}, {359,0.01801724}, {360,0.01803448}, {361,0.01806897}, {362,0.01817241}, {363,0.01815517}, {364,0.01825000}, {365,0.01843966}, {366,0.01848276}, {367,0.01862931}, {368,0.01863793}, {369,0.01874138}, {370,0.01881034}, {371,0.01886207}, {372,0.01887069}, {373,0.01890517}, {374,0.01898276}, {375,0.01895690}, {376,0.01898276}, {377,0.01900000}, {378,0.01901724}, {379,0.01902586}, {380,0.01906034}, {381,0.01903448}, {382,0.01917241}, {383,0.01925862}, {384,0.01925000}, {385,0.01925862}, {386,0.01944828}, {387,0.01958621}, {388,0.01968103}, {389,0.07831897}, {390,0.01981034}, {391,0.01987069}, {392,0.01991379}, {393,0.08237069}, {394,0.01996552}, {395,0.01996552}, {396,0.02000000}, {397,0.07309483}, {398,0.02019828}, {399,0.02016379}, {400,0.01915517}, {401,0.01929310}, {402,0.01946552}, {403,0.01942241}, {404,0.01958621}, {405,0.01966379}, {406,0.01985345}, {407,0.04967241}, {408,0.01986207}, {409,0.01987069}, {410,0.01987931}, {411,0.01999138}, {412,0.01999138}, {413,0.01999138}, {414,0.02002586}, {415,0.02004310}, {416,0.02002586}, {417,0.02004310}, {418,0.06037069}, {419,0.02013793}, {420,0.02018103}, {421,0.02027586}, {422,0.02035345}, {423,0.02040517}, {424,0.02060345}, {425,0.04904310}, {426,0.02078448}, {427,0.02080172}, {428,0.02086207}, {429,0.02085345}, {430,0.02093103}, {431,0.02098276}, {432,0.04781897}, {433,0.02097414}, {434,0.02098276}, {435,0.02102586}, {436,0.02105172}, {437,0.02100862}, {438,0.02111207}, {439,0.02109483}, {440,0.02119828}, {441,0.02123276}, {442,0.05396552}, {443,0.02153448}, {444,0.02139655}, {445,0.02144828}, {446,0.02175862}, {447,0.02177586}, {448,0.02182759}, {449,0.02183621}, {450,0.02192241}, {451,0.02190517}, {452,0.05483621}, {453,0.02196552}, {454,0.02197414}, {455,0.02198276}, {456,0.02199138}, {457,0.02206897}, {458,0.02205172}, {459,0.02207759}, {460,0.02217241}, {461,0.02222414}, {462,0.05517241}, {463,0.02237931}, {464,0.02244828}, {465,0.05657759}, {466,0.02262069}, {467,0.02271552}, {468,0.02282759}, {469,0.02289655}, {470,0.02286207}, {471,0.02288793}, {472,0.02291379}, {473,0.02295690}, {474,0.02295690}, {475,0.02392241}, {476,0.02400000}, {477,0.02398276}, {478,0.02405172}, {479,0.02405172}, {480,0.02408621}, {481,0.06633621}, {482,0.02430172}, {483,0.02426724}, {484,0.05740517}, {485,0.02452586}, {486,0.02463793}, {487,0.05401724}, {488,0.02468966}, {489,0.02475862}, {490,0.05493103}, {491,0.02487069}, {492,0.02486207}, {493,0.05651724}, {494,0.02486207}, {495,0.02495690}, {496,0.07406034}, {497,0.02497414}, {498,0.02496552}, {499,0.08568966}, {500,0.025129870}, {505,0.08590435}, {510,0.02581739}, {515,0.02595652}, {520,0.08586087}, {525,0.02665217}, {530,0.02680870}, {535,0.07754783}, {540,0.02714783}, {545,0.02766957}, {550,0.02782609}, {555,0.02793043}, {560,0.02819130}, {565,0.02864348}, {570,0.02881579}, {575,0.08823684}, {580,0.02936842}, {585,0.02971930}, {590,0.02986842}, {595,0.03000000}, {600,0.09078261}, {605,0.03073684}, {610,0.03081579}, {615,0.03102632}, {620,0.03130702}, {625,0.08928947}, {630,0.03183333}, {635,0.03211404}, {640,0.03247368}, {645,0.03280702}, {650,0.03285965}, {655,0.03307895}, {660,0.06481579}, {665,0.03381579}, {670,0.06727193}, {675,0.03404386}, {680,0.03453509}, {685,0.03479825}, {690,0.03491228}, {695,0.03527193}, {700,0.03613043}, {705,0.03581579}, {710,0.03600000}, {715,0.03627193}, {720,0.03661404}, {725,0.06826316}, {730,0.03695614}, {735,0.06871053}, {740,0.03765789}, {745,0.06759649}, {750,0.03801754}, {755,0.06711404}, {760,0.03875439}, {765,0.06206140}, {770,0.03731579}, {775,0.03808772}, {780,0.03828947}, {785,0.03850877}, {790,0.03879825}, {795,0.03894737}, {800,0.03920000}, {805,0.03957018}, {810,0.03977193}, {815,0.06935965}, {820,0.04010526}, {825,0.07260526}, {830,0.04074561}, {835,0.06498246}, {840,0.04106140}, {845,0.04142105}, {850,0.04173684}, {855,0.04185965}, {860,0.07108772}, {865,0.04221930}, {870,0.04257895}, {875,0.04286842}, {880,0.04306140}, {885,0.07531579}, {890,0.04359649}, {895,0.07329825}, {900,0.04453913}, {905,0.04427193}, {910,0.08035088}, {915,0.04481579}, {920,0.04504386}, {925,0.04522807}, {930,0.04557895}, {935,0.13868421}, {940,0.04772807}, {945,0.04790351}, {950,0.09597368}, {955,0.04859649}, {960,0.04878947}, {965,0.08433333}, {970,0.04926316}, {975,0.04964912}, {980,0.09338596}, {985,0.05007018}, {990,0.05030702}, {995,0.11947368}, {1000,0.05083478}, {1010,0.05350}, {1020,0.05200}, {1030,0.11350}, {1040,0.05150}, {1050,0.05275}, {1060,0.09350}, {1070,0.05400}, {1080,0.05475}, {1090,0.05475}, {1100,0.12825}, {1110,0.05350}, {1120,0.05450}, {1130,0.05500}, {1140,0.08925}, {1150,0.05575}, {1160,0.05650}, {1170,0.05725}, {1180,0.09000}, {1190,0.15575}, {1200,0.05850}, {1210,0.06125}, {1220,0.06125}, {1230,0.06200}, {1240,0.10050}, {1250,0.09150}, {1260,0.06350}, {1270,0.06425}, {1280,0.06500}, {1290,0.06525}, {1300,0.10275}, {1310,0.12100}, {1320,0.10125}, {1330,0.06525}, {1340,0.06500}, {1350,0.16100}, {1360,0.06625}, {1370,0.06675}, {1380,0.06750}, {1390,0.06800}, {1400,0.06800}, {1410,0.13125}, {1420,0.11925}, {1430,0.11650}, {1440,0.10000}, {1450,0.10300}, {1460,0.10575}, {1470,0.11225}, {1480,0.11300}, {1490,0.10975}, {1500,0.10380}, {1510,0.11975}, {1520,0.11725}, {1530,0.13800}, {1540,0.13850}, {1550,0.13550}, {1560,0.12675}, {1570,0.09600}, {1580,0.09700}, {1590,0.09800}, {1600,0.07800}, {1610,0.07825}, {1620,0.26900}, {1630,0.07950}, {1640,0.11175}, {1650,0.14850}, {1660,0.12750}, {1670,0.11425}, {1680,0.08450}, {1690,0.08550}, {1700,0.08525}, {1710,0.08575}, {1720,0.14900}, {1730,0.15825}, {1740,0.14150}, {1750,0.08825}, {1760,0.08850}, {1770,0.08900}, {1780,0.12475}, {1790,0.12925}, {1800,0.11150}, {1810,0.09100}, {1820,0.09175}, {1830,0.12825}, {1840,0.11825}, {1850,0.08975}, {1860,0.09050}, {1870,0.12400}, {1880,0.12925}, {1890,0.09150}, {1900,0.09225}, {1910,0.12800}, {1920,0.12150}, {1930,0.09325}, {1940,0.09425}, {1950,0.12925}, {1960,0.09450}, {1970,0.09550}, {1980,0.13175}, {1990,0.12375}, {2000,0.10920}, {2050,0.18950}, {2100,0.10575}, {2150,0.14700}, {2200,0.14825}, {2250,0.11375}, {2300,0.16125}, {2350,0.15525}, {2400,0.16075}, {2450,0.12375}, {2500,0.16380}, {2550,0.17875}, {2600,0.12725}, {2650,0.15425}, {2700,0.16400}, {2750,0.17500}, {2800,0.18625}, {2850,0.19025}, {2900,0.19275}, {2950,0.14400}, {3000,0.17020}, {3050,0.19825}, {3100,0.19725}, {3150,0.20275}, {3200,0.23175}, {3250,0.21325}, {3300,0.21850}, {3350,0.18125}, {3400,0.25375}, {3450,0.27925}, {3500,0.22340}, {3550,0.29900}, {3600,0.29750}, {3650,0.30400}, {3700,0.29500}, {3750,0.28375}, {3800,0.24800}, {3850,0.26375}, {3900,0.24475}, {3950,0.26525}, {4000,0.26940}, {4050,0.25350}, {4100,0.25875}, {4150,0.27450}, {4200,0.27725}, {4250,0.28200}, {4300,0.25300}, {4350,0.26475}, {4400,0.27900}, {4450,0.27425}, {4500,0.29660}, {4550,0.27550}, {4600,0.27550}, {4650,0.34525}, {4700,0.32350}, {4750,0.37675}, {4800,0.36250}, {4850,0.40400}, {4900,0.39925}, {4950,0.38275}, {5000,0.33440}};
data["big_flat"]["ParsingElaborated"]["norm reif"]["user"] = {{1,0.00000000}, {2,0.00017241}, {3,0.00016379}, {4,0.00031034}, {5,0.00048276}, {6,0.00045690}, {7,0.00050862}, {8,0.00055172}, {9,0.00064655}, {10,0.00044828}, {11,0.00071552}, {12,0.00065517}, {13,0.00084483}, {14,0.00097414}, {15,0.00081897}, {16,0.00128448}, {17,0.00110345}, {18,0.00114655}, {19,0.00103448}, {20,0.00081897}, {21,0.00096552}, {22,0.00096552}, {23,0.00171552}, {24,0.00109483}, {25,0.00109483}, {26,0.00113793}, {27,0.00112069}, {28,0.00140517}, {29,0.00138793}, {30,0.00173276}, {31,0.00193966}, {32,0.00168966}, {33,0.00156034}, {34,0.00166379}, {35,0.00191379}, {36,0.00179310}, {37,0.00154310}, {38,0.00212931}, {39,0.00220690}, {40,0.00195690}, {41,0.00185345}, {42,0.00222414}, {43,0.00223276}, {44,0.00220690}, {45,0.00234483}, {46,0.00217241}, {47,0.00225000}, {48,0.00533621}, {49,0.00238793}, {50,0.00281034}, {51,0.00251724}, {52,0.00271552}, {53,0.00286207}, {54,0.00279310}, {55,0.00275000}, {56,0.00267241}, {57,0.00268966}, {58,0.00326724}, {59,0.00312069}, {60,0.00298276}, {61,0.00302586}, {62,0.00293103}, {63,0.00297414}, {64,0.00322414}, {65,0.00358621}, {66,0.00350000}, {67,0.00343103}, {68,0.00334483}, {69,0.00887931}, {70,0.00346552}, {71,0.00379310}, {72,0.00374138}, {73,0.00366379}, {74,0.00372414}, {75,0.00382759}, {76,0.00375862}, {77,0.00396552}, {78,0.00386207}, {79,0.00403448}, {80,0.00400862}, {81,0.00409483}, {82,0.00406897}, {83,0.00420690}, {84,0.06047414}, {85,0.00458621}, {86,0.00440517}, {87,0.00453448}, {88,0.00458621}, {89,0.00465517}, {90,0.00444828}, {91,0.00473276}, {92,0.00492241}, {93,0.00464655}, {94,0.00472414}, {95,0.00462931}, {96,0.00489655}, {97,0.00489655}, {98,0.00506897}, {99,0.00524138}, {100,0.00533621}, {101,0.00542241}, {102,0.00549138}, {103,0.00546552}, {104,0.00546552}, {105,0.00511207}, {106,0.00525862}, {107,0.00540517}, {108,0.00584483}, {109,0.00596552}, {110,0.00544828}, {111,0.00586207}, {112,0.00606897}, {113,0.03618966}, {114,0.00594828}, {115,0.00588793}, {116,0.00596552}, {117,0.00616379}, {118,0.00583621}, {119,0.00650862}, {120,0.00633621}, {121,0.00654310}, {122,0.00648276}, {123,0.00627586}, {124,0.00662069}, {125,0.00655172}, {126,0.00634483}, {127,0.00665517}, {128,0.00693103}, {129,0.00665517}, {130,0.00672414}, {131,0.00682759}, {132,0.00672414}, {133,0.00686207}, {134,0.00684483}, {135,0.00692241}, {136,0.00681034}, {137,0.00678448}, {138,0.00681897}, {139,0.00723276}, {140,0.03175000}, {141,0.00673276}, {142,0.00698276}, {143,0.00715517}, {144,0.00728448}, {145,0.00740517}, {146,0.00745690}, {147,0.00748276}, {148,0.00748276}, {149,0.00782759}, {150,0.00755172}, {151,0.00758621}, {152,0.00737931}, {153,0.00762069}, {154,0.00772414}, {155,0.00779310}, {156,0.00796552}, {157,0.00782759}, {158,0.00779310}, {159,0.00791379}, {160,0.00807759}, {161,0.00818966}, {162,0.00818966}, {163,0.00810345}, {164,0.00801724}, {165,0.00818103}, {166,0.00841379}, {167,0.00825862}, {168,0.00843103}, {169,0.00850862}, {170,0.00879310}, {171,0.00865517}, {172,0.00858621}, {173,0.00858621}, {174,0.03934483}, {175,0.00879310}, {176,0.00882759}, {177,0.00882759}, {178,0.00879310}, {179,0.00882759}, {180,0.00884483}, {181,0.00883621}, {182,0.00893103}, {183,0.00905172}, {184,0.00915517}, {185,0.00919828}, {186,0.00900000}, {187,0.00905172}, {188,0.00923276}, {189,0.00931897}, {190,0.00956034}, {191,0.00933621}, {192,0.00950862}, {193,0.00940517}, {194,0.00968966}, {195,0.01003448}, {196,0.00968966}, {197,0.00986207}, {198,0.04234483}, {199,0.05916379}, {200,0.00976724}, {201,0.00987931}, {202,0.01007759}, {203,0.01018966}, {204,0.00995690}, {205,0.06127586}, {206,0.00985345}, {207,0.01022414}, {208,0.01075862}, {209,0.01030172}, {210,0.01041379}, {211,0.01058621}, {212,0.07031034}, {213,0.01122414}, {214,0.01124138}, {215,0.01073276}, {216,0.01075000}, {217,0.01071552}, {218,0.01104310}, {219,0.05394828}, {220,0.01150862}, {221,0.01160345}, {222,0.01165517}, {223,0.01133621}, {224,0.01150000}, {225,0.01173276}, {226,0.01139655}, {227,0.01149138}, {228,0.01137069}, {229,0.01129310}, {230,0.01162931}, {231,0.01168103}, {232,0.04463793}, {233,0.01163793}, {234,0.01170690}, {235,0.01168966}, {236,0.01175862}, {237,0.01213793}, {238,0.01211207}, {239,0.01184483}, {240,0.01198276}, {241,0.01241379}, {242,0.01213793}, {243,0.01205172}, {244,0.01221552}, {245,0.01226724}, {246,0.01242241}, {247,0.01262069}, {248,0.01261207}, {249,0.01244828}, {250,0.01266379}, {251,0.01265517}, {252,0.01267241}, {253,0.01287931}, {254,0.01265517}, {255,0.01284483}, {256,0.01294828}, {257,0.01321552}, {258,0.01293103}, {259,0.01314655}, {260,0.01303448}, {261,0.01261207}, {262,0.07254310}, {263,0.01320690}, {264,0.01346552}, {265,0.01312069}, {266,0.01395690}, {267,0.01307759}, {268,0.01343103}, {269,0.01363793}, {270,0.01373276}, {271,0.01344828}, {272,0.01370690}, {273,0.04710345}, {274,0.01377586}, {275,0.01353448}, {276,0.01365517}, {277,0.01404310}, {278,0.01426724}, {279,0.01403448}, {280,0.01381034}, {281,0.01401724}, {282,0.11393966}, {283,0.06504310}, {284,0.01350000}, {285,0.01384483}, {286,0.01362931}, {287,0.01373276}, {288,0.01415517}, {289,0.01463793}, {290,0.01443103}, {291,0.01450000}, {292,0.01398276}, {293,0.01414655}, {294,0.01369828}, {295,0.01424138}, {296,0.01424138}, {297,0.01459483}, {298,0.01460345}, {299,0.01475000}, {300,0.01490517}, {301,0.01480172}, {302,0.01514655}, {303,0.01502586}, {304,0.01494828}, {305,0.01497414}, {306,0.01518966}, {307,0.01510345}, {308,0.04442241}, {309,0.01513793}, {310,0.01548276}, {311,0.01556034}, {312,0.01534483}, {313,0.04517241}, {314,0.01535345}, {315,0.01559483}, {316,0.01578448}, {317,0.01555172}, {318,0.01575000}, {319,0.01573276}, {320,0.01575862}, {321,0.01575000}, {322,0.01588793}, {323,0.01602586}, {324,0.01618966}, {325,0.01599138}, {326,0.01625862}, {327,0.04525862}, {328,0.01631897}, {329,0.01623276}, {330,0.01606034}, {331,0.01636207}, {332,0.01613793}, {333,0.01631034}, {334,0.01631034}, {335,0.01654310}, {336,0.04764655}, {337,0.01625862}, {338,0.01660345}, {339,0.01679310}, {340,0.01678448}, {341,0.01643966}, {342,0.01664655}, {343,0.01684483}, {344,0.01677586}, {345,0.01647414}, {346,0.01706034}, {347,0.01697414}, {348,0.01695690}, {349,0.04662069}, {350,0.01696552}, {351,0.01692241}, {352,0.01716379}, {353,0.08692241}, {354,0.01770690}, {355,0.01786207}, {356,0.01785345}, {357,0.01779310}, {358,0.01802586}, {359,0.01834483}, {360,0.01808621}, {361,0.01821552}, {362,0.01815517}, {363,0.01818966}, {364,0.01821552}, {365,0.01842241}, {366,0.01785345}, {367,0.01811207}, {368,0.01839655}, {369,0.01823276}, {370,0.01840517}, {371,0.01862931}, {372,0.01837931}, {373,0.01854310}, {374,0.01833621}, {375,0.01896552}, {376,0.01873276}, {377,0.01867241}, {378,0.01886207}, {379,0.01874138}, {380,0.01878448}, {381,0.01912069}, {382,0.01905172}, {383,0.01898276}, {384,0.01928448}, {385,0.01896552}, {386,0.01907759}, {387,0.01926724}, {388,0.01918966}, {389,0.07823276}, {390,0.01942241}, {391,0.01944828}, {392,0.01929310}, {393,0.08115517}, {394,0.01957759}, {395,0.01961207}, {396,0.01963793}, {397,0.07279310}, {398,0.01962069}, {399,0.01988793}, {400,0.01896552}, {401,0.01912069}, {402,0.01912069}, {403,0.01911207}, {404,0.01909483}, {405,0.01918966}, {406,0.01918966}, {407,0.04914655}, {408,0.01931897}, {409,0.01959483}, {410,0.01963793}, {411,0.01944828}, {412,0.01976724}, {413,0.01963793}, {414,0.01969828}, {415,0.02002586}, {416,0.01982759}, {417,0.01991379}, {418,0.05940517}, {419,0.01999138}, {420,0.02011207}, {421,0.02007759}, {422,0.02044828}, {423,0.01965517}, {424,0.02001724}, {425,0.04850000}, {426,0.02048276}, {427,0.02022414}, {428,0.02029310}, {429,0.02040517}, {430,0.02058621}, {431,0.02025862}, {432,0.04736207}, {433,0.02053448}, {434,0.02080172}, {435,0.02043966}, {436,0.02101724}, {437,0.02049138}, {438,0.02102586}, {439,0.02112069}, {440,0.02075000}, {441,0.02093966}, {442,0.05327586}, {443,0.02106897}, {444,0.02104310}, {445,0.02090517}, {446,0.02163793}, {447,0.02137931}, {448,0.02150000}, {449,0.02148276}, {450,0.02182759}, {451,0.02177586}, {452,0.05398276}, {453,0.02149138}, {454,0.02153448}, {455,0.02172414}, {456,0.02167241}, {457,0.02195690}, {458,0.02162931}, {459,0.02190517}, {460,0.02179310}, {461,0.02188793}, {462,0.05434483}, {463,0.02237931}, {464,0.02220690}, {465,0.05633621}, {466,0.02226724}, {467,0.02253448}, {468,0.02249138}, {469,0.02256897}, {470,0.02261207}, {471,0.02235345}, {472,0.02256034}, {473,0.02279310}, {474,0.02277586}, {475,0.02362069}, {476,0.02402586}, {477,0.02429310}, {478,0.02412069}, {479,0.02417241}, {480,0.02410345}, {481,0.06601724}, {482,0.02395690}, {483,0.02446552}, {484,0.05692241}, {485,0.02450862}, {486,0.02424138}, {487,0.05365517}, {488,0.02456034}, {489,0.02427586}, {490,0.05431034}, {491,0.02471552}, {492,0.02479310}, {493,0.05581034}, {494,0.02485345}, {495,0.02462069}, {496,0.07351724}, {497,0.02479310}, {498,0.02489655}, {499,0.08530172}, {500,0.025147186}, {505,0.08482609}, {510,0.02567826}, {515,0.02582609}, {520,0.08553913}, {525,0.02636522}, {530,0.02624348}, {535,0.07726087}, {540,0.02719130}, {545,0.02754783}, {550,0.02758261}, {555,0.02813913}, {560,0.02786087}, {565,0.02817391}, {570,0.02843860}, {575,0.08783333}, {580,0.02921930}, {585,0.02959649}, {590,0.02954386}, {595,0.03000877}, {600,0.09014783}, {605,0.03085088}, {610,0.03090351}, {615,0.03128947}, {620,0.03147368}, {625,0.08807018}, {630,0.03236842}, {635,0.03237719}, {640,0.03228947}, {645,0.03268421}, {650,0.03314035}, {655,0.03331579}, {660,0.06428947}, {665,0.03380702}, {670,0.06690351}, {675,0.03422807}, {680,0.03449123}, {685,0.03457018}, {690,0.03506140}, {695,0.03530702}, {700,0.03565217}, {705,0.03570175}, {710,0.03571053}, {715,0.03578947}, {720,0.03630702}, {725,0.06759649}, {730,0.03682456}, {735,0.06813158}, {740,0.03772807}, {745,0.06682456}, {750,0.03796491}, {755,0.06679825}, {760,0.03835965}, {765,0.06165789}, {770,0.03703509}, {775,0.03739474}, {780,0.03749123}, {785,0.03819298}, {790,0.03832456}, {795,0.03868421}, {800,0.03898261}, {805,0.03898246}, {810,0.03930702}, {815,0.06850000}, {820,0.03964035}, {825,0.07171930}, {830,0.04009649}, {835,0.06417544}, {840,0.04094737}, {845,0.04107018}, {850,0.04140351}, {855,0.04173684}, {860,0.07078070}, {865,0.04185965}, {870,0.04245614}, {875,0.04291228}, {880,0.04277193}, {885,0.07486842}, {890,0.04379825}, {895,0.07310526}, {900,0.04459130}, {905,0.04439474}, {910,0.07741228}, {915,0.04466667}, {920,0.04459649}, {925,0.04534211}, {930,0.04525439}, {935,0.13683333}, {940,0.04738596}, {945,0.04771930}, {950,0.09521053}, {955,0.04832456}, {960,0.04809649}, {965,0.08342105}, {970,0.04872807}, {975,0.04904386}, {980,0.09258772}, {985,0.04943860}, {990,0.04998246}, {995,0.11824561}, {1000,0.04995652}, {1010,0.05000}, {1020,0.05125}, {1030,0.11125}, {1040,0.05175}, {1050,0.05350}, {1060,0.09175}, {1070,0.05350}, {1080,0.05475}, {1090,0.05500}, {1100,0.12650}, {1110,0.05450}, {1120,0.05300}, {1130,0.05500}, {1140,0.08775}, {1150,0.05650}, {1160,0.05500}, {1170,0.05700}, {1180,0.08675}, {1190,0.15375}, {1200,0.05900}, {1210,0.06175}, {1220,0.06200}, {1230,0.06050}, {1240,0.10050}, {1250,0.09175}, {1260,0.06375}, {1270,0.06400}, {1280,0.06475}, {1290,0.06575}, {1300,0.10250}, {1310,0.12050}, {1320,0.09950}, {1330,0.06300}, {1340,0.06350}, {1350,0.15975}, {1360,0.06650}, {1370,0.06675}, {1380,0.06825}, {1390,0.06625}, {1400,0.06850}, {1410,0.12875}, {1420,0.11850}, {1430,0.11475}, {1440,0.09875}, {1450,0.10175}, {1460,0.10375}, {1470,0.11150}, {1480,0.11450}, {1490,0.10600}, {1500,0.10240}, {1510,0.11850}, {1520,0.11600}, {1530,0.13750}, {1540,0.13750}, {1550,0.13475}, {1560,0.12350}, {1570,0.09575}, {1580,0.09675}, {1590,0.09825}, {1600,0.07700}, {1610,0.07775}, {1620,0.26700}, {1630,0.07900}, {1640,0.11250}, {1650,0.14775}, {1660,0.12750}, {1670,0.11300}, {1680,0.08550}, {1690,0.08625}, {1700,0.08675}, {1710,0.08500}, {1720,0.14600}, {1730,0.15400}, {1740,0.13850}, {1750,0.08725}, {1760,0.08675}, {1770,0.08725}, {1780,0.11975}, {1790,0.12250}, {1800,0.10750}, {1810,0.09050}, {1820,0.09275}, {1830,0.12450}, {1840,0.11150}, {1850,0.09075}, {1860,0.08925}, {1870,0.11950}, {1880,0.12300}, {1890,0.09175}, {1900,0.09250}, {1910,0.11900}, {1920,0.11925}, {1930,0.09300}, {1940,0.09600}, {1950,0.12950}, {1960,0.09275}, {1970,0.09700}, {1980,0.13050}, {1990,0.12325}, {2000,0.10840}, {2050,0.18350}, {2100,0.10550}, {2150,0.14125}, {2200,0.14050}, {2250,0.11300}, {2300,0.15350}, {2350,0.15025}, {2400,0.15575}, {2450,0.12350}, {2500,0.15900}, {2550,0.16850}, {2600,0.12675}, {2650,0.15125}, {2700,0.15450}, {2750,0.16650}, {2800,0.17850}, {2850,0.18425}, {2900,0.18250}, {2950,0.14325}, {3000,0.16360}, {3050,0.19425}, {3100,0.19450}, {3150,0.20075}, {3200,0.22175}, {3250,0.19950}, {3300,0.21250}, {3350,0.18075}, {3400,0.24200}, {3450,0.27175}, {3500,0.21920}, {3550,0.29000}, {3600,0.27550}, {3650,0.29350}, {3700,0.28550}, {3750,0.27250}, {3800,0.23600}, {3850,0.25500}, {3900,0.23650}, {3950,0.25575}, {4000,0.26000}, {4050,0.24425}, {4100,0.25150}, {4150,0.26375}, {4200,0.25975}, {4250,0.27050}, {4300,0.23925}, {4350,0.25300}, {4400,0.25625}, {4450,0.26550}, {4500,0.26440}, {4550,0.26250}, {4600,0.26475}, {4650,0.32550}, {4700,0.31825}, {4750,0.36475}, {4800,0.36025}, {4850,0.38525}, {4900,0.39775}, {4950,0.38275}, {5000,0.33360}};
data["big_flat"]["ParsingElaborated"]["norm reif"]["system"] = {{1,0.00018103}, {2,0.00024138}, {3,0.00019828}, {4,0.00006897}, {5,0.00009483}, {6,0.00000000}, {7,0.00003448}, {8,0.00000000}, {9,0.00006897}, {10,0.00014655}, {11,0.00016379}, {12,0.00003448}, {13,0.00006897}, {14,0.00009483}, {15,0.00012931}, {16,0.00006897}, {17,0.00006897}, {18,0.00006897}, {19,0.00010345}, {20,0.00018966}, {21,0.00017241}, {22,0.00023276}, {23,0.00019828}, {24,0.00012931}, {25,0.00010345}, {26,0.00012931}, {27,0.00008621}, {28,0.00010345}, {29,0.00026724}, {30,0.00023276}, {31,0.00012931}, {32,0.00002586}, {33,0.00009483}, {34,0.00041379}, {35,0.00013793}, {36,0.00007759}, {37,0.00030172}, {38,0.00006897}, {39,0.00000000}, {40,0.00009483}, {41,0.00008621}, {42,0.00006897}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00003448}, {47,0.00003448}, {48,0.00000000}, {49,0.00003448}, {50,0.00003448}, {51,0.00003448}, {52,0.00006897}, {53,0.00000000}, {54,0.00006897}, {55,0.00006034}, {56,0.00015517}, {57,0.00003448}, {58,0.00000000}, {59,0.00003448}, {60,0.00003448}, {61,0.00000000}, {62,0.00003448}, {63,0.00006034}, {64,0.00010345}, {65,0.00000000}, {66,0.00003448}, {67,0.00000000}, {68,0.00003448}, {69,0.00023276}, {70,0.00000000}, {71,0.00006897}, {72,0.00002586}, {73,0.00002586}, {74,0.00006034}, {75,0.00006897}, {76,0.00006897}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00003448}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00044828}, {85,0.00006897}, {86,0.00006034}, {87,0.00006897}, {88,0.00006897}, {89,0.00003448}, {90,0.00003448}, {91,0.00003448}, {92,0.00000000}, {93,0.00006034}, {94,0.00003448}, {95,0.00012069}, {96,0.00013793}, {97,0.00003448}, {98,0.00003448}, {99,0.00000000}, {100,0.00020690}, {101,0.00003448}, {102,0.00006897}, {103,0.00006897}, {104,0.00000000}, {105,0.00003448}, {106,0.00003448}, {107,0.00000000}, {108,0.00006034}, {109,0.00003448}, {110,0.00006897}, {111,0.00010345}, {112,0.00002586}, {113,0.00060345}, {114,0.00006897}, {115,0.00003448}, {116,0.00010345}, {117,0.00003448}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00003448}, {122,0.00002586}, {123,0.00009483}, {124,0.00003448}, {125,0.00000000}, {126,0.00019828}, {127,0.00013793}, {128,0.00009483}, {129,0.00012931}, {130,0.00017241}, {131,0.00013793}, {132,0.00002586}, {133,0.00010345}, {134,0.00013793}, {135,0.00006897}, {136,0.00006897}, {137,0.00010345}, {138,0.00013793}, {139,0.00012931}, {140,0.00015517}, {141,0.00012069}, {142,0.00002586}, {143,0.00000000}, {144,0.00003448}, {145,0.00009483}, {146,0.00009483}, {147,0.00006034}, {148,0.00006897}, {149,0.00003448}, {150,0.00006034}, {151,0.00003448}, {152,0.00000000}, {153,0.00006897}, {154,0.00003448}, {155,0.00006897}, {156,0.00003448}, {157,0.00010345}, {158,0.00003448}, {159,0.00003448}, {160,0.00003448}, {161,0.00006897}, {162,0.00010345}, {163,0.00010345}, {164,0.00003448}, {165,0.00000000}, {166,0.00006897}, {167,0.00003448}, {168,0.00000000}, {169,0.00003448}, {170,0.00000000}, {171,0.00006034}, {172,0.00000000}, {173,0.00006897}, {174,0.00088793}, {175,0.00003448}, {176,0.00009483}, {177,0.00006034}, {178,0.00010345}, {179,0.00003448}, {180,0.00003448}, {181,0.00012931}, {182,0.00003448}, {183,0.00020690}, {184,0.00006897}, {185,0.00010345}, {186,0.00016379}, {187,0.00000000}, {188,0.00013793}, {189,0.00000000}, {190,0.00012931}, {191,0.00013793}, {192,0.00008621}, {193,0.00006897}, {194,0.00002586}, {195,0.00010345}, {196,0.00010345}, {197,0.00018966}, {198,0.00071552}, {199,0.00030172}, {200,0.00003448}, {201,0.00016379}, {202,0.00006897}, {203,0.00011207}, {204,0.00013793}, {205,0.00158621}, {206,0.00019828}, {207,0.00020690}, {208,0.00020690}, {209,0.00012931}, {210,0.00002586}, {211,0.00006897}, {212,0.00097414}, {213,0.00016379}, {214,0.00003448}, {215,0.00009483}, {216,0.00010345}, {217,0.00017241}, {218,0.00006897}, {219,0.00043103}, {220,0.00006897}, {221,0.00000000}, {222,0.00003448}, {223,0.00010345}, {224,0.00006897}, {225,0.00010345}, {226,0.00002586}, {227,0.00018966}, {228,0.00003448}, {229,0.00006897}, {230,0.00010345}, {231,0.00006897}, {232,0.00056034}, {233,0.00018966}, {234,0.00012069}, {235,0.00016379}, {236,0.00016379}, {237,0.00002586}, {238,0.00006897}, {239,0.00013793}, {240,0.00020690}, {241,0.00006034}, {242,0.00006034}, {243,0.00009483}, {244,0.00013793}, {245,0.00006897}, {246,0.00006897}, {247,0.00003448}, {248,0.00003448}, {249,0.00012069}, {250,0.00006897}, {251,0.00003448}, {252,0.00013793}, {253,0.00006897}, {254,0.00003448}, {255,0.00005172}, {256,0.00013793}, {257,0.00030172}, {258,0.00013793}, {259,0.00022414}, {260,0.00010345}, {261,0.00029310}, {262,0.00068966}, {263,0.00020690}, {264,0.00010345}, {265,0.00006897}, {266,0.00003448}, {267,0.00003448}, {268,0.00030172}, {269,0.00000000}, {270,0.00013793}, {271,0.00030172}, {272,0.00006034}, {273,0.00048276}, {274,0.00026724}, {275,0.00021552}, {276,0.00022414}, {277,0.00006034}, {278,0.00012931}, {279,0.00016379}, {280,0.00013793}, {281,0.00016379}, {282,0.00065517}, {283,0.00234483}, {284,0.00057759}, {285,0.00044828}, {286,0.00003448}, {287,0.00006897}, {288,0.00003448}, {289,0.00018966}, {290,0.00027586}, {291,0.00013793}, {292,0.00012931}, {293,0.00006034}, {294,0.00016379}, {295,0.00010345}, {296,0.00016379}, {297,0.00000000}, {298,0.00006897}, {299,0.00019828}, {300,0.00009483}, {301,0.00010345}, {302,0.00002586}, {303,0.00006897}, {304,0.00006897}, {305,0.00002586}, {306,0.00010345}, {307,0.00010345}, {308,0.00070690}, {309,0.00013793}, {310,0.00003448}, {311,0.00003448}, {312,0.00017241}, {313,0.00075000}, {314,0.00010345}, {315,0.00006897}, {316,0.00006034}, {317,0.00017241}, {318,0.00006897}, {319,0.00010345}, {320,0.00003448}, {321,0.00019828}, {322,0.00017241}, {323,0.00010345}, {324,0.00016379}, {325,0.00020690}, {326,0.00006897}, {327,0.00050862}, {328,0.00000000}, {329,0.00006897}, {330,0.00006897}, {331,0.00000000}, {332,0.00026724}, {333,0.00003448}, {334,0.00017241}, {335,0.00003448}, {336,0.00039655}, {337,0.00027586}, {338,0.00010345}, {339,0.00006897}, {340,0.00006897}, {341,0.00016379}, {342,0.00023276}, {343,0.00013793}, {344,0.00012931}, {345,0.00024138}, {346,0.00015517}, {347,0.00010345}, {348,0.00017241}, {349,0.00016379}, {350,0.00012931}, {351,0.00020690}, {352,0.00010345}, {353,0.00063793}, {354,0.00020690}, {355,0.00010345}, {356,0.00012931}, {357,0.00006034}, {358,0.00013793}, {359,0.00003448}, {360,0.00016379}, {361,0.00006897}, {362,0.00006897}, {363,0.00016379}, {364,0.00024138}, {365,0.00010345}, {366,0.00022414}, {367,0.00025862}, {368,0.00016379}, {369,0.00012931}, {370,0.00019828}, {371,0.00010345}, {372,0.00012931}, {373,0.00013793}, {374,0.00010345}, {375,0.00002586}, {376,0.00006897}, {377,0.00009483}, {378,0.00023276}, {379,0.00013793}, {380,0.00020690}, {381,0.00000000}, {382,0.00017241}, {383,0.00017241}, {384,0.00003448}, {385,0.00010345}, {386,0.00010345}, {387,0.00015517}, {388,0.00003448}, {389,0.00050862}, {390,0.00010345}, {391,0.00003448}, {392,0.00012931}, {393,0.00087069}, {394,0.00012069}, {395,0.00009483}, {396,0.00012931}, {397,0.00054310}, {398,0.00020690}, {399,0.00012931}, {400,0.00013793}, {401,0.00003448}, {402,0.00017241}, {403,0.00010345}, {404,0.00003448}, {405,0.00006897}, {406,0.00020690}, {407,0.00057759}, {408,0.00010345}, {409,0.00010345}, {410,0.00006897}, {411,0.00026724}, {412,0.00012931}, {413,0.00025862}, {414,0.00010345}, {415,0.00023276}, {416,0.00012069}, {417,0.00013793}, {418,0.00109483}, {419,0.00010345}, {420,0.00017241}, {421,0.00020690}, {422,0.00020690}, {423,0.00020690}, {424,0.00017241}, {425,0.00067241}, {426,0.00012069}, {427,0.00023276}, {428,0.00000000}, {429,0.00006897}, {430,0.00019828}, {431,0.00029310}, {432,0.00070690}, {433,0.00016379}, {434,0.00013793}, {435,0.00012931}, {436,0.00027586}, {437,0.00018966}, {438,0.00020690}, {439,0.00020690}, {440,0.00012931}, {441,0.00016379}, {442,0.00079310}, {443,0.00027586}, {444,0.00019828}, {445,0.00006897}, {446,0.00013793}, {447,0.00020690}, {448,0.00010345}, {449,0.00017241}, {450,0.00013793}, {451,0.00013793}, {452,0.00054310}, {453,0.00010345}, {454,0.00013793}, {455,0.00017241}, {456,0.00003448}, {457,0.00013793}, {458,0.00026724}, {459,0.00016379}, {460,0.00006897}, {461,0.00017241}, {462,0.00083621}, {463,0.00003448}, {464,0.00006897}, {465,0.00026724}, {466,0.00026724}, {467,0.00012931}, {468,0.00006897}, {469,0.00017241}, {470,0.00012931}, {471,0.00030172}, {472,0.00027586}, {473,0.00017241}, {474,0.00017241}, {475,0.00031034}, {476,0.00009483}, {477,0.00013793}, {478,0.00010345}, {479,0.00010345}, {480,0.00017241}, {481,0.00047414}, {482,0.00017241}, {483,0.00006897}, {484,0.00041379}, {485,0.00017241}, {486,0.00033621}, {487,0.00062069}, {488,0.00019828}, {489,0.00020690}, {490,0.00076724}, {491,0.00023276}, {492,0.00013793}, {493,0.00058621}, {494,0.00017241}, {495,0.00016379}, {496,0.00081897}, {497,0.00034483}, {498,0.00020690}, {499,0.00068966}, {500,0.000212121}, {505,0.00088696}, {510,0.00020870}, {515,0.00012174}, {520,0.00059130}, {525,0.00027826}, {530,0.00017391}, {535,0.00046957}, {540,0.00006957}, {545,0.00002609}, {550,0.00013913}, {555,0.00010435}, {560,0.00006087}, {565,0.00024348}, {570,0.00028070}, {575,0.00057018}, {580,0.00031579}, {585,0.00017544}, {590,0.00059649}, {595,0.00014035}, {600,0.00066087}, {605,0.00020175}, {610,0.00014035}, {615,0.00020175}, {620,0.00023684}, {625,0.00092982}, {630,0.00010526}, {635,0.00030702}, {640,0.00038596}, {645,0.00048246}, {650,0.00013158}, {655,0.00031579}, {660,0.00071930}, {665,0.00017544}, {670,0.00056140}, {675,0.00031579}, {680,0.00009649}, {685,0.00017544}, {690,0.00014035}, {695,0.00016667}, {700,0.00029565}, {705,0.00024561}, {710,0.00028070}, {715,0.00030702}, {720,0.00035088}, {725,0.00073684}, {730,0.00031579}, {735,0.00071930}, {740,0.00021053}, {745,0.00072807}, {750,0.00006140}, {755,0.00056140}, {760,0.00009649}, {765,0.00088596}, {770,0.00045614}, {775,0.00056140}, {780,0.00054386}, {785,0.00017544}, {790,0.00030702}, {795,0.00016667}, {800,0.00013913}, {805,0.00027193}, {810,0.00020175}, {815,0.00061404}, {820,0.00034211}, {825,0.00092105}, {830,0.00038596}, {835,0.00086842}, {840,0.00017544}, {845,0.00017544}, {850,0.00031579}, {855,0.00020175}, {860,0.00010526}, {865,0.00021053}, {870,0.00021053}, {875,0.00023684}, {880,0.00035088}, {885,0.00049123}, {890,0.00024561}, {895,0.00035088}, {900,0.00020870}, {905,0.00021053}, {910,0.00049123}, {915,0.00024561}, {920,0.00048246}, {925,0.00003509}, {930,0.00021053}, {935,0.00190351}, {940,0.00030702}, {945,0.00029825}, {950,0.00106140}, {955,0.00038596}, {960,0.00042105}, {965,0.00086842}, {970,0.00059649}, {975,0.00024561}, {980,0.00094737}, {985,0.00024561}, {990,0.00030702}, {995,0.00106140}, {1000,0.00041739}, {1010,0.00300}, {1020,0.00100}, {1030,0.00175}, {1040,0.00000}, {1050,0.00100}, {1060,0.00175}, {1070,0.00000}, {1080,0.00000}, {1090,0.00000}, {1100,0.00100}, {1110,0.00000}, {1120,0.00100}, {1130,0.00000}, {1140,0.00000}, {1150,0.00000}, {1160,0.00075}, {1170,0.00000}, {1180,0.00275}, {1190,0.00275}, {1200,0.00000}, {1210,0.00000}, {1220,0.00000}, {1230,0.00100}, {1240,0.00075}, {1250,0.00100}, {1260,0.00000}, {1270,0.00000}, {1280,0.00000}, {1290,0.00000}, {1300,0.00000}, {1310,0.00000}, {1320,0.00200}, {1330,0.00250}, {1340,0.00200}, {1350,0.00000}, {1360,0.00000}, {1370,0.00000}, {1380,0.00000}, {1390,0.00000}, {1400,0.00100}, {1410,0.00200}, {1420,0.00100}, {1430,0.00000}, {1440,0.00100}, {1450,0.00175}, {1460,0.00175}, {1470,0.00000}, {1480,0.00000}, {1490,0.00375}, {1500,0.00240}, {1510,0.00100}, {1520,0.00100}, {1530,0.00000}, {1540,0.00000}, {1550,0.00000}, {1560,0.00200}, {1570,0.00000}, {1580,0.00000}, {1590,0.00000}, {1600,0.00000}, {1610,0.00000}, {1620,0.00200}, {1630,0.00075}, {1640,0.00000}, {1650,0.00000}, {1660,0.00000}, {1670,0.00100}, {1680,0.00000}, {1690,0.00000}, {1700,0.00100}, {1710,0.00000}, {1720,0.00375}, {1730,0.00500}, {1740,0.00475}, {1750,0.00000}, {1760,0.00200}, {1770,0.00100}, {1780,0.00500}, {1790,0.00500}, {1800,0.00500}, {1810,0.00000}, {1820,0.00000}, {1830,0.00500}, {1840,0.00600}, {1850,0.00100}, {1860,0.00000}, {1870,0.00400}, {1880,0.00775}, {1890,0.00175}, {1900,0.00000}, {1910,0.00700}, {1920,0.00200}, {1930,0.00100}, {1940,0.00100}, {1950,0.00000}, {1960,0.00200}, {1970,0.00000}, {1980,0.00200}, {1990,0.00000}, {2000,0.00000}, {2050,0.00500}, {2100,0.00100}, {2150,0.00600}, {2200,0.00875}, {2250,0.00000}, {2300,0.00800}, {2350,0.00400}, {2400,0.00400}, {2450,0.00000}, {2500,0.00480}, {2550,0.00875}, {2600,0.00000}, {2650,0.00400}, {2700,0.00900}, {2750,0.00800}, {2800,0.00875}, {2850,0.00500}, {2900,0.00975}, {2950,0.00000}, {3000,0.00560}, {3050,0.00400}, {3100,0.00300}, {3150,0.00200}, {3200,0.01100}, {3250,0.01100}, {3300,0.00600}, {3350,0.00000}, {3400,0.01175}, {3450,0.00775}, {3500,0.00320}, {3550,0.01100}, {3600,0.00800}, {3650,0.01000}, {3700,0.00800}, {3750,0.01100}, {3800,0.01200}, {3850,0.01000}, {3900,0.00800}, {3950,0.01175}, {4000,0.01080}, {4050,0.00775}, {4100,0.00800}, {4150,0.00975}, {4200,0.01400}, {4250,0.01000}, {4300,0.01175}, {4350,0.00400}, {4400,0.00800}, {4450,0.00900}, {4500,0.00720}, {4550,0.01100}, {4600,0.01000}, {4650,0.01600}, {4700,0.00400}, {4750,0.00300}, {4800,0.00100}, {4850,0.00200}, {4900,0.00100}, {4950,0.00000}, {5000,0.00060}};
data["big_flat"]["ParsingElaborated"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00013793}, {12,0.00000000}, {13,0.00000000}, {14,0.00003448}, {15,0.00054310}, {16,0.00100000}, {17,0.00062931}, {18,0.00098276}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00100000}, {23,0.00199138}, {24,0.00100000}, {25,0.00100000}, {26,0.00100000}, {27,0.00100000}, {28,0.00100000}, {29,0.00100000}, {30,0.00100862}, {31,0.00100000}, {32,0.00105172}, {33,0.00101724}, {34,0.00139655}, {35,0.00138793}, {36,0.00136207}, {37,0.00145690}, {38,0.00135345}, {39,0.00181897}, {40,0.00200000}, {41,0.00200000}, {42,0.00200000}, {43,0.00200000}, {44,0.00200000}, {45,0.00200000}, {46,0.00200000}, {47,0.00200000}, {48,0.00500862}, {49,0.00200000}, {50,0.00200000}, {51,0.00200000}, {52,0.00200862}, {53,0.00203448}, {54,0.00205172}, {55,0.00204310}, {56,0.00206034}, {57,0.00233621}, {58,0.00243966}, {59,0.00281034}, {60,0.00289655}, {61,0.00280172}, {62,0.00294828}, {63,0.00300000}, {64,0.00300000}, {65,0.00300000}, {66,0.00300000}, {67,0.00300000}, {68,0.00300000}, {69,0.00857759}, {70,0.00300000}, {71,0.00300000}, {72,0.00300862}, {73,0.00300862}, {74,0.00304310}, {75,0.00309483}, {76,0.00312931}, {77,0.00339655}, {78,0.00317241}, {79,0.00347414}, {80,0.00357759}, {81,0.00396552}, {82,0.00394828}, {83,0.00400000}, {84,0.06087069}, {85,0.00400000}, {86,0.00400000}, {87,0.00400000}, {88,0.00400000}, {89,0.00400000}, {90,0.00400862}, {91,0.00400862}, {92,0.00404310}, {93,0.00402586}, {94,0.00405172}, {95,0.00420690}, {96,0.00443966}, {97,0.00474138}, {98,0.00491379}, {99,0.00488793}, {100,0.00499138}, {101,0.00500000}, {102,0.00500000}, {103,0.00500000}, {104,0.00500000}, {105,0.00500000}, {106,0.00500000}, {107,0.00500000}, {108,0.00500000}, {109,0.00501724}, {110,0.00500862}, {111,0.00506034}, {112,0.00512069}, {113,0.03656034}, {114,0.00581897}, {115,0.00589655}, {116,0.00588793}, {117,0.00593966}, {118,0.00592241}, {119,0.00598276}, {120,0.00600000}, {121,0.00600000}, {122,0.00600000}, {123,0.00600000}, {124,0.00600000}, {125,0.00600000}, {126,0.00600000}, {127,0.00600862}, {128,0.00602586}, {129,0.00616379}, {130,0.00606897}, {131,0.00608621}, {132,0.00636207}, {133,0.00680172}, {134,0.00689655}, {135,0.00690517}, {136,0.00692241}, {137,0.00698276}, {138,0.00700000}, {139,0.00700862}, {140,0.03193103}, {141,0.00690517}, {142,0.00698276}, {143,0.00699138}, {144,0.00699138}, {145,0.00699138}, {146,0.00700000}, {147,0.00699138}, {148,0.00700000}, {149,0.00700000}, {150,0.00700000}, {151,0.00700000}, {152,0.00701724}, {153,0.00700862}, {154,0.00711207}, {155,0.00736207}, {156,0.00748276}, {157,0.00722414}, {158,0.00731034}, {159,0.00762069}, {160,0.00793103}, {161,0.00799138}, {162,0.00797414}, {163,0.00800000}, {164,0.00800000}, {165,0.00800000}, {166,0.00800000}, {167,0.00800000}, {168,0.00800000}, {169,0.00800000}, {170,0.00800862}, {171,0.00800000}, {172,0.00800000}, {173,0.00802586}, {174,0.03996552}, {175,0.00829310}, {176,0.00840517}, {177,0.00861207}, {178,0.00851724}, {179,0.00846552}, {180,0.00857759}, {181,0.00893103}, {182,0.00897414}, {183,0.00899138}, {184,0.00898276}, {185,0.00900000}, {186,0.00900000}, {187,0.00900000}, {188,0.00900000}, {189,0.00900000}, {190,0.00900862}, {191,0.00900000}, {192,0.00901724}, {193,0.00902586}, {194,0.00932759}, {195,0.00926724}, {196,0.00968103}, {197,0.00935345}, {198,0.04266379}, {199,0.05896552}, {200,0.00965517}, {201,0.00990517}, {202,0.00994828}, {203,0.00999138}, {204,0.01000000}, {205,0.06245690}, {206,0.01000000}, {207,0.01000000}, {208,0.01000000}, {209,0.01000000}, {210,0.01000862}, {211,0.01000862}, {212,0.07080172}, {213,0.01092241}, {214,0.01093103}, {215,0.01099138}, {216,0.01098276}, {217,0.01098276}, {218,0.01099138}, {219,0.05416379}, {220,0.01100000}, {221,0.01100862}, {222,0.01100862}, {223,0.01100862}, {224,0.01103448}, {225,0.01120690}, {226,0.01118103}, {227,0.01157759}, {228,0.01149138}, {229,0.01135345}, {230,0.01162931}, {231,0.01174138}, {232,0.04485345}, {233,0.01195690}, {234,0.01193966}, {235,0.01199138}, {236,0.01195690}, {237,0.01199138}, {238,0.01200000}, {239,0.01200862}, {240,0.01200862}, {241,0.01203448}, {242,0.01200000}, {243,0.01200862}, {244,0.01223276}, {245,0.01209483}, {246,0.01218966}, {247,0.01254310}, {248,0.01262069}, {249,0.01243966}, {250,0.01236207}, {251,0.01287069}, {252,0.01285345}, {253,0.01283621}, {254,0.01293966}, {255,0.01295690}, {256,0.01299138}, {257,0.01295690}, {258,0.01300000}, {259,0.01300000}, {260,0.01300862}, {261,0.01301724}, {262,0.07289655}, {263,0.01304310}, {264,0.01302586}, {265,0.01304310}, {266,0.01312931}, {267,0.01325000}, {268,0.01337069}, {269,0.01332759}, {270,0.01370690}, {271,0.01381034}, {272,0.01374138}, {273,0.04712069}, {274,0.01393966}, {275,0.01394828}, {276,0.01397414}, {277,0.01399138}, {278,0.01400000}, {279,0.01400000}, {280,0.01400000}, {281,0.01400862}, {282,0.11437069}, {283,0.06771552}, {284,0.01388793}, {285,0.01396552}, {286,0.01399138}, {287,0.01400000}, {288,0.01400000}, {289,0.01400000}, {290,0.01400862}, {291,0.01400862}, {292,0.01400000}, {293,0.01400862}, {294,0.01401724}, {295,0.01406034}, {296,0.01406034}, {297,0.01408621}, {298,0.01423276}, {299,0.01439655}, {300,0.01455172}, {301,0.01465517}, {302,0.01475000}, {303,0.01482759}, {304,0.01483621}, {305,0.01493103}, {306,0.01496552}, {307,0.01494828}, {308,0.04481897}, {309,0.01500000}, {310,0.01500000}, {311,0.01500000}, {312,0.01504310}, {313,0.04541379}, {314,0.01501724}, {315,0.01504310}, {316,0.01506034}, {317,0.01524138}, {318,0.01519828}, {319,0.01528448}, {320,0.01544828}, {321,0.01564655}, {322,0.01574138}, {323,0.01583621}, {324,0.01587931}, {325,0.01593103}, {326,0.01593103}, {327,0.04510345}, {328,0.01598276}, {329,0.01599138}, {330,0.01599138}, {331,0.01600862}, {332,0.01600862}, {333,0.01600862}, {334,0.01601724}, {335,0.01602586}, {336,0.04802586}, {337,0.01614655}, {338,0.01618966}, {339,0.01636207}, {340,0.01626724}, {341,0.01661207}, {342,0.01675862}, {343,0.01668966}, {344,0.01683621}, {345,0.01678448}, {346,0.01688793}, {347,0.01693966}, {348,0.01693966}, {349,0.04654310}, {350,0.01698276}, {351,0.01701724}, {352,0.01700862}, {353,0.08748276}, {354,0.01794828}, {355,0.01796552}, {356,0.01798276}, {357,0.01798276}, {358,0.01800862}, {359,0.01801724}, {360,0.01803448}, {361,0.01806897}, {362,0.01817241}, {363,0.01815517}, {364,0.01825000}, {365,0.01843966}, {366,0.01848276}, {367,0.01862931}, {368,0.01863793}, {369,0.01874138}, {370,0.01881034}, {371,0.01886207}, {372,0.01887069}, {373,0.01890517}, {374,0.01898276}, {375,0.01895690}, {376,0.01898276}, {377,0.01900000}, {378,0.01901724}, {379,0.01902586}, {380,0.01906034}, {381,0.01903448}, {382,0.01917241}, {383,0.01925862}, {384,0.01925000}, {385,0.01925862}, {386,0.01944828}, {387,0.01958621}, {388,0.01968103}, {389,0.07831897}, {390,0.01981034}, {391,0.01987069}, {392,0.01991379}, {393,0.08237069}, {394,0.01996552}, {395,0.01996552}, {396,0.02000000}, {397,0.07309483}, {398,0.02019828}, {399,0.02016379}, {400,0.01915517}, {401,0.01929310}, {402,0.01946552}, {403,0.01942241}, {404,0.01958621}, {405,0.01966379}, {406,0.01985345}, {407,0.04967241}, {408,0.01986207}, {409,0.01987069}, {410,0.01987931}, {411,0.01999138}, {412,0.01999138}, {413,0.01999138}, {414,0.02002586}, {415,0.02004310}, {416,0.02002586}, {417,0.02004310}, {418,0.06037069}, {419,0.02013793}, {420,0.02018103}, {421,0.02027586}, {422,0.02035345}, {423,0.02040517}, {424,0.02060345}, {425,0.04904310}, {426,0.02078448}, {427,0.02080172}, {428,0.02086207}, {429,0.02085345}, {430,0.02093103}, {431,0.02098276}, {432,0.04781897}, {433,0.02097414}, {434,0.02098276}, {435,0.02102586}, {436,0.02105172}, {437,0.02100862}, {438,0.02111207}, {439,0.02109483}, {440,0.02119828}, {441,0.02123276}, {442,0.05396552}, {443,0.02153448}, {444,0.02139655}, {445,0.02144828}, {446,0.02175862}, {447,0.02177586}, {448,0.02182759}, {449,0.02183621}, {450,0.02192241}, {451,0.02190517}, {452,0.05483621}, {453,0.02196552}, {454,0.02197414}, {455,0.02198276}, {456,0.02199138}, {457,0.02206897}, {458,0.02205172}, {459,0.02207759}, {460,0.02217241}, {461,0.02222414}, {462,0.05517241}, {463,0.02237931}, {464,0.02244828}, {465,0.05657759}, {466,0.02262069}, {467,0.02271552}, {468,0.02282759}, {469,0.02289655}, {470,0.02286207}, {471,0.02288793}, {472,0.02291379}, {473,0.02295690}, {474,0.02295690}, {475,0.02392241}, {476,0.02400000}, {477,0.02398276}, {478,0.02405172}, {479,0.02405172}, {480,0.02408621}, {481,0.06633621}, {482,0.02430172}, {483,0.02426724}, {484,0.05740517}, {485,0.02452586}, {486,0.02463793}, {487,0.05401724}, {488,0.02468966}, {489,0.02475862}, {490,0.05493103}, {491,0.02487069}, {492,0.02486207}, {493,0.05651724}, {494,0.02486207}, {495,0.02495690}, {496,0.07406034}, {497,0.02497414}, {498,0.02496552}, {499,0.08568966}, {500,0.025129870}, {505,0.08590435}, {510,0.02581739}, {515,0.02595652}, {520,0.08586087}, {525,0.02665217}, {530,0.02680870}, {535,0.07754783}, {540,0.02714783}, {545,0.02766957}, {550,0.02782609}, {555,0.02793043}, {560,0.02819130}, {565,0.02864348}, {570,0.02881579}, {575,0.08823684}, {580,0.02936842}, {585,0.02971930}, {590,0.02986842}, {595,0.03000000}, {600,0.09078261}, {605,0.03073684}, {610,0.03081579}, {615,0.03102632}, {620,0.03130702}, {625,0.08928947}, {630,0.03183333}, {635,0.03211404}, {640,0.03247368}, {645,0.03280702}, {650,0.03285965}, {655,0.03307895}, {660,0.06481579}, {665,0.03381579}, {670,0.06727193}, {675,0.03404386}, {680,0.03453509}, {685,0.03479825}, {690,0.03491228}, {695,0.03527193}, {700,0.03613043}, {705,0.03581579}, {710,0.03600000}, {715,0.03627193}, {720,0.03661404}, {725,0.06826316}, {730,0.03695614}, {735,0.06871053}, {740,0.03765789}, {745,0.06759649}, {750,0.03801754}, {755,0.06711404}, {760,0.03875439}, {765,0.06206140}, {770,0.03731579}, {775,0.03808772}, {780,0.03828947}, {785,0.03850877}, {790,0.03879825}, {795,0.03894737}, {800,0.03920000}, {805,0.03957018}, {810,0.03977193}, {815,0.06935965}, {820,0.04010526}, {825,0.07260526}, {830,0.04074561}, {835,0.06498246}, {840,0.04106140}, {845,0.04142105}, {850,0.04173684}, {855,0.04185965}, {860,0.07108772}, {865,0.04221930}, {870,0.04257895}, {875,0.04286842}, {880,0.04306140}, {885,0.07531579}, {890,0.04359649}, {895,0.07329825}, {900,0.04453913}, {905,0.04427193}, {910,0.08035088}, {915,0.04481579}, {920,0.04504386}, {925,0.04522807}, {930,0.04557895}, {935,0.13868421}, {940,0.04772807}, {945,0.04790351}, {950,0.09597368}, {955,0.04859649}, {960,0.04878947}, {965,0.08433333}, {970,0.04926316}, {975,0.04964912}, {980,0.09338596}, {985,0.05007018}, {990,0.05030702}, {995,0.11947368}, {1000,0.05083478}, {1010,0.05350}, {1020,0.05200}, {1030,0.11350}, {1040,0.05150}, {1050,0.05275}, {1060,0.09350}, {1070,0.05400}, {1080,0.05475}, {1090,0.05475}, {1100,0.12825}, {1110,0.05350}, {1120,0.05450}, {1130,0.05500}, {1140,0.08925}, {1150,0.05575}, {1160,0.05650}, {1170,0.05725}, {1180,0.09000}, {1190,0.15575}, {1200,0.05850}, {1210,0.06125}, {1220,0.06125}, {1230,0.06200}, {1240,0.10050}, {1250,0.09150}, {1260,0.06350}, {1270,0.06425}, {1280,0.06500}, {1290,0.06525}, {1300,0.10275}, {1310,0.12100}, {1320,0.10125}, {1330,0.06525}, {1340,0.06500}, {1350,0.16100}, {1360,0.06625}, {1370,0.06675}, {1380,0.06750}, {1390,0.06800}, {1400,0.06800}, {1410,0.13125}, {1420,0.11925}, {1430,0.11650}, {1440,0.10000}, {1450,0.10300}, {1460,0.10575}, {1470,0.11225}, {1480,0.11300}, {1490,0.10975}, {1500,0.10380}, {1510,0.11975}, {1520,0.11725}, {1530,0.13800}, {1540,0.13850}, {1550,0.13550}, {1560,0.12675}, {1570,0.09600}, {1580,0.09700}, {1590,0.09800}, {1600,0.07800}, {1610,0.07825}, {1620,0.26900}, {1630,0.07950}, {1640,0.11175}, {1650,0.14850}, {1660,0.12750}, {1670,0.11425}, {1680,0.08450}, {1690,0.08550}, {1700,0.08525}, {1710,0.08575}, {1720,0.14900}, {1730,0.15825}, {1740,0.14150}, {1750,0.08825}, {1760,0.08850}, {1770,0.08900}, {1780,0.12475}, {1790,0.12925}, {1800,0.11150}, {1810,0.09100}, {1820,0.09175}, {1830,0.12825}, {1840,0.11825}, {1850,0.08975}, {1860,0.09050}, {1870,0.12400}, {1880,0.12925}, {1890,0.09150}, {1900,0.09225}, {1910,0.12800}, {1920,0.12150}, {1930,0.09325}, {1940,0.09425}, {1950,0.12925}, {1960,0.09450}, {1970,0.09550}, {1980,0.13175}, {1990,0.12375}, {2000,0.10920}, {2050,0.18950}, {2100,0.10575}, {2150,0.14700}, {2200,0.14825}, {2250,0.11375}, {2300,0.16125}, {2350,0.15525}, {2400,0.16075}, {2450,0.12375}, {2500,0.16380}, {2550,0.17875}, {2600,0.12725}, {2650,0.15425}, {2700,0.16400}, {2750,0.17500}, {2800,0.18625}, {2850,0.19025}, {2900,0.19275}, {2950,0.14400}, {3000,0.17020}, {3050,0.19825}, {3100,0.19725}, {3150,0.20275}, {3200,0.23175}, {3250,0.21325}, {3300,0.21850}, {3350,0.18125}, {3400,0.25375}, {3450,0.27925}, {3500,0.22340}, {3550,0.29900}, {3600,0.29750}, {3650,0.30400}, {3700,0.29500}, {3750,0.28375}, {3800,0.24800}, {3850,0.26375}, {3900,0.24475}, {3950,0.26525}, {4000,0.26940}, {4050,0.25350}, {4100,0.25875}, {4150,0.27450}, {4200,0.27725}, {4250,0.28200}, {4300,0.25300}, {4350,0.26475}, {4400,0.27900}, {4450,0.27425}, {4500,0.29660}, {4550,0.27550}, {4600,0.27550}, {4650,0.34525}, {4700,0.32350}, {4750,0.37675}, {4800,0.36250}, {4850,0.40400}, {4900,0.39925}, {4950,0.38275}, {5000,0.33440}};
data["big_flat"]["ParsingElaborated"]["reif"]["user"] = {{1,0.00000000}, {2,0.00017241}, {3,0.00016379}, {4,0.00031034}, {5,0.00048276}, {6,0.00045690}, {7,0.00050862}, {8,0.00055172}, {9,0.00064655}, {10,0.00044828}, {11,0.00071552}, {12,0.00065517}, {13,0.00084483}, {14,0.00097414}, {15,0.00081897}, {16,0.00128448}, {17,0.00110345}, {18,0.00114655}, {19,0.00103448}, {20,0.00081897}, {21,0.00096552}, {22,0.00096552}, {23,0.00171552}, {24,0.00109483}, {25,0.00109483}, {26,0.00113793}, {27,0.00112069}, {28,0.00140517}, {29,0.00138793}, {30,0.00173276}, {31,0.00193966}, {32,0.00168966}, {33,0.00156034}, {34,0.00166379}, {35,0.00191379}, {36,0.00179310}, {37,0.00154310}, {38,0.00212931}, {39,0.00220690}, {40,0.00195690}, {41,0.00185345}, {42,0.00222414}, {43,0.00223276}, {44,0.00220690}, {45,0.00234483}, {46,0.00217241}, {47,0.00225000}, {48,0.00533621}, {49,0.00238793}, {50,0.00281034}, {51,0.00251724}, {52,0.00271552}, {53,0.00286207}, {54,0.00279310}, {55,0.00275000}, {56,0.00267241}, {57,0.00268966}, {58,0.00326724}, {59,0.00312069}, {60,0.00298276}, {61,0.00302586}, {62,0.00293103}, {63,0.00297414}, {64,0.00322414}, {65,0.00358621}, {66,0.00350000}, {67,0.00343103}, {68,0.00334483}, {69,0.00887931}, {70,0.00346552}, {71,0.00379310}, {72,0.00374138}, {73,0.00366379}, {74,0.00372414}, {75,0.00382759}, {76,0.00375862}, {77,0.00396552}, {78,0.00386207}, {79,0.00403448}, {80,0.00400862}, {81,0.00409483}, {82,0.00406897}, {83,0.00420690}, {84,0.06047414}, {85,0.00458621}, {86,0.00440517}, {87,0.00453448}, {88,0.00458621}, {89,0.00465517}, {90,0.00444828}, {91,0.00473276}, {92,0.00492241}, {93,0.00464655}, {94,0.00472414}, {95,0.00462931}, {96,0.00489655}, {97,0.00489655}, {98,0.00506897}, {99,0.00524138}, {100,0.00533621}, {101,0.00542241}, {102,0.00549138}, {103,0.00546552}, {104,0.00546552}, {105,0.00511207}, {106,0.00525862}, {107,0.00540517}, {108,0.00584483}, {109,0.00596552}, {110,0.00544828}, {111,0.00586207}, {112,0.00606897}, {113,0.03618966}, {114,0.00594828}, {115,0.00588793}, {116,0.00596552}, {117,0.00616379}, {118,0.00583621}, {119,0.00650862}, {120,0.00633621}, {121,0.00654310}, {122,0.00648276}, {123,0.00627586}, {124,0.00662069}, {125,0.00655172}, {126,0.00634483}, {127,0.00665517}, {128,0.00693103}, {129,0.00665517}, {130,0.00672414}, {131,0.00682759}, {132,0.00672414}, {133,0.00686207}, {134,0.00684483}, {135,0.00692241}, {136,0.00681034}, {137,0.00678448}, {138,0.00681897}, {139,0.00723276}, {140,0.03175000}, {141,0.00673276}, {142,0.00698276}, {143,0.00715517}, {144,0.00728448}, {145,0.00740517}, {146,0.00745690}, {147,0.00748276}, {148,0.00748276}, {149,0.00782759}, {150,0.00755172}, {151,0.00758621}, {152,0.00737931}, {153,0.00762069}, {154,0.00772414}, {155,0.00779310}, {156,0.00796552}, {157,0.00782759}, {158,0.00779310}, {159,0.00791379}, {160,0.00807759}, {161,0.00818966}, {162,0.00818966}, {163,0.00810345}, {164,0.00801724}, {165,0.00818103}, {166,0.00841379}, {167,0.00825862}, {168,0.00843103}, {169,0.00850862}, {170,0.00879310}, {171,0.00865517}, {172,0.00858621}, {173,0.00858621}, {174,0.03934483}, {175,0.00879310}, {176,0.00882759}, {177,0.00882759}, {178,0.00879310}, {179,0.00882759}, {180,0.00884483}, {181,0.00883621}, {182,0.00893103}, {183,0.00905172}, {184,0.00915517}, {185,0.00919828}, {186,0.00900000}, {187,0.00905172}, {188,0.00923276}, {189,0.00931897}, {190,0.00956034}, {191,0.00933621}, {192,0.00950862}, {193,0.00940517}, {194,0.00968966}, {195,0.01003448}, {196,0.00968966}, {197,0.00986207}, {198,0.04234483}, {199,0.05916379}, {200,0.00976724}, {201,0.00987931}, {202,0.01007759}, {203,0.01018966}, {204,0.00995690}, {205,0.06127586}, {206,0.00985345}, {207,0.01022414}, {208,0.01075862}, {209,0.01030172}, {210,0.01041379}, {211,0.01058621}, {212,0.07031034}, {213,0.01122414}, {214,0.01124138}, {215,0.01073276}, {216,0.01075000}, {217,0.01071552}, {218,0.01104310}, {219,0.05394828}, {220,0.01150862}, {221,0.01160345}, {222,0.01165517}, {223,0.01133621}, {224,0.01150000}, {225,0.01173276}, {226,0.01139655}, {227,0.01149138}, {228,0.01137069}, {229,0.01129310}, {230,0.01162931}, {231,0.01168103}, {232,0.04463793}, {233,0.01163793}, {234,0.01170690}, {235,0.01168966}, {236,0.01175862}, {237,0.01213793}, {238,0.01211207}, {239,0.01184483}, {240,0.01198276}, {241,0.01241379}, {242,0.01213793}, {243,0.01205172}, {244,0.01221552}, {245,0.01226724}, {246,0.01242241}, {247,0.01262069}, {248,0.01261207}, {249,0.01244828}, {250,0.01266379}, {251,0.01265517}, {252,0.01267241}, {253,0.01287931}, {254,0.01265517}, {255,0.01284483}, {256,0.01294828}, {257,0.01321552}, {258,0.01293103}, {259,0.01314655}, {260,0.01303448}, {261,0.01261207}, {262,0.07254310}, {263,0.01320690}, {264,0.01346552}, {265,0.01312069}, {266,0.01395690}, {267,0.01307759}, {268,0.01343103}, {269,0.01363793}, {270,0.01373276}, {271,0.01344828}, {272,0.01370690}, {273,0.04710345}, {274,0.01377586}, {275,0.01353448}, {276,0.01365517}, {277,0.01404310}, {278,0.01426724}, {279,0.01403448}, {280,0.01381034}, {281,0.01401724}, {282,0.11393966}, {283,0.06504310}, {284,0.01350000}, {285,0.01384483}, {286,0.01362931}, {287,0.01373276}, {288,0.01415517}, {289,0.01463793}, {290,0.01443103}, {291,0.01450000}, {292,0.01398276}, {293,0.01414655}, {294,0.01369828}, {295,0.01424138}, {296,0.01424138}, {297,0.01459483}, {298,0.01460345}, {299,0.01475000}, {300,0.01490517}, {301,0.01480172}, {302,0.01514655}, {303,0.01502586}, {304,0.01494828}, {305,0.01497414}, {306,0.01518966}, {307,0.01510345}, {308,0.04442241}, {309,0.01513793}, {310,0.01548276}, {311,0.01556034}, {312,0.01534483}, {313,0.04517241}, {314,0.01535345}, {315,0.01559483}, {316,0.01578448}, {317,0.01555172}, {318,0.01575000}, {319,0.01573276}, {320,0.01575862}, {321,0.01575000}, {322,0.01588793}, {323,0.01602586}, {324,0.01618966}, {325,0.01599138}, {326,0.01625862}, {327,0.04525862}, {328,0.01631897}, {329,0.01623276}, {330,0.01606034}, {331,0.01636207}, {332,0.01613793}, {333,0.01631034}, {334,0.01631034}, {335,0.01654310}, {336,0.04764655}, {337,0.01625862}, {338,0.01660345}, {339,0.01679310}, {340,0.01678448}, {341,0.01643966}, {342,0.01664655}, {343,0.01684483}, {344,0.01677586}, {345,0.01647414}, {346,0.01706034}, {347,0.01697414}, {348,0.01695690}, {349,0.04662069}, {350,0.01696552}, {351,0.01692241}, {352,0.01716379}, {353,0.08692241}, {354,0.01770690}, {355,0.01786207}, {356,0.01785345}, {357,0.01779310}, {358,0.01802586}, {359,0.01834483}, {360,0.01808621}, {361,0.01821552}, {362,0.01815517}, {363,0.01818966}, {364,0.01821552}, {365,0.01842241}, {366,0.01785345}, {367,0.01811207}, {368,0.01839655}, {369,0.01823276}, {370,0.01840517}, {371,0.01862931}, {372,0.01837931}, {373,0.01854310}, {374,0.01833621}, {375,0.01896552}, {376,0.01873276}, {377,0.01867241}, {378,0.01886207}, {379,0.01874138}, {380,0.01878448}, {381,0.01912069}, {382,0.01905172}, {383,0.01898276}, {384,0.01928448}, {385,0.01896552}, {386,0.01907759}, {387,0.01926724}, {388,0.01918966}, {389,0.07823276}, {390,0.01942241}, {391,0.01944828}, {392,0.01929310}, {393,0.08115517}, {394,0.01957759}, {395,0.01961207}, {396,0.01963793}, {397,0.07279310}, {398,0.01962069}, {399,0.01988793}, {400,0.01896552}, {401,0.01912069}, {402,0.01912069}, {403,0.01911207}, {404,0.01909483}, {405,0.01918966}, {406,0.01918966}, {407,0.04914655}, {408,0.01931897}, {409,0.01959483}, {410,0.01963793}, {411,0.01944828}, {412,0.01976724}, {413,0.01963793}, {414,0.01969828}, {415,0.02002586}, {416,0.01982759}, {417,0.01991379}, {418,0.05940517}, {419,0.01999138}, {420,0.02011207}, {421,0.02007759}, {422,0.02044828}, {423,0.01965517}, {424,0.02001724}, {425,0.04850000}, {426,0.02048276}, {427,0.02022414}, {428,0.02029310}, {429,0.02040517}, {430,0.02058621}, {431,0.02025862}, {432,0.04736207}, {433,0.02053448}, {434,0.02080172}, {435,0.02043966}, {436,0.02101724}, {437,0.02049138}, {438,0.02102586}, {439,0.02112069}, {440,0.02075000}, {441,0.02093966}, {442,0.05327586}, {443,0.02106897}, {444,0.02104310}, {445,0.02090517}, {446,0.02163793}, {447,0.02137931}, {448,0.02150000}, {449,0.02148276}, {450,0.02182759}, {451,0.02177586}, {452,0.05398276}, {453,0.02149138}, {454,0.02153448}, {455,0.02172414}, {456,0.02167241}, {457,0.02195690}, {458,0.02162931}, {459,0.02190517}, {460,0.02179310}, {461,0.02188793}, {462,0.05434483}, {463,0.02237931}, {464,0.02220690}, {465,0.05633621}, {466,0.02226724}, {467,0.02253448}, {468,0.02249138}, {469,0.02256897}, {470,0.02261207}, {471,0.02235345}, {472,0.02256034}, {473,0.02279310}, {474,0.02277586}, {475,0.02362069}, {476,0.02402586}, {477,0.02429310}, {478,0.02412069}, {479,0.02417241}, {480,0.02410345}, {481,0.06601724}, {482,0.02395690}, {483,0.02446552}, {484,0.05692241}, {485,0.02450862}, {486,0.02424138}, {487,0.05365517}, {488,0.02456034}, {489,0.02427586}, {490,0.05431034}, {491,0.02471552}, {492,0.02479310}, {493,0.05581034}, {494,0.02485345}, {495,0.02462069}, {496,0.07351724}, {497,0.02479310}, {498,0.02489655}, {499,0.08530172}, {500,0.025147186}, {505,0.08482609}, {510,0.02567826}, {515,0.02582609}, {520,0.08553913}, {525,0.02636522}, {530,0.02624348}, {535,0.07726087}, {540,0.02719130}, {545,0.02754783}, {550,0.02758261}, {555,0.02813913}, {560,0.02786087}, {565,0.02817391}, {570,0.02843860}, {575,0.08783333}, {580,0.02921930}, {585,0.02959649}, {590,0.02954386}, {595,0.03000877}, {600,0.09014783}, {605,0.03085088}, {610,0.03090351}, {615,0.03128947}, {620,0.03147368}, {625,0.08807018}, {630,0.03236842}, {635,0.03237719}, {640,0.03228947}, {645,0.03268421}, {650,0.03314035}, {655,0.03331579}, {660,0.06428947}, {665,0.03380702}, {670,0.06690351}, {675,0.03422807}, {680,0.03449123}, {685,0.03457018}, {690,0.03506140}, {695,0.03530702}, {700,0.03565217}, {705,0.03570175}, {710,0.03571053}, {715,0.03578947}, {720,0.03630702}, {725,0.06759649}, {730,0.03682456}, {735,0.06813158}, {740,0.03772807}, {745,0.06682456}, {750,0.03796491}, {755,0.06679825}, {760,0.03835965}, {765,0.06165789}, {770,0.03703509}, {775,0.03739474}, {780,0.03749123}, {785,0.03819298}, {790,0.03832456}, {795,0.03868421}, {800,0.03898261}, {805,0.03898246}, {810,0.03930702}, {815,0.06850000}, {820,0.03964035}, {825,0.07171930}, {830,0.04009649}, {835,0.06417544}, {840,0.04094737}, {845,0.04107018}, {850,0.04140351}, {855,0.04173684}, {860,0.07078070}, {865,0.04185965}, {870,0.04245614}, {875,0.04291228}, {880,0.04277193}, {885,0.07486842}, {890,0.04379825}, {895,0.07310526}, {900,0.04459130}, {905,0.04439474}, {910,0.07741228}, {915,0.04466667}, {920,0.04459649}, {925,0.04534211}, {930,0.04525439}, {935,0.13683333}, {940,0.04738596}, {945,0.04771930}, {950,0.09521053}, {955,0.04832456}, {960,0.04809649}, {965,0.08342105}, {970,0.04872807}, {975,0.04904386}, {980,0.09258772}, {985,0.04943860}, {990,0.04998246}, {995,0.11824561}, {1000,0.04995652}, {1010,0.05000}, {1020,0.05125}, {1030,0.11125}, {1040,0.05175}, {1050,0.05350}, {1060,0.09175}, {1070,0.05350}, {1080,0.05475}, {1090,0.05500}, {1100,0.12650}, {1110,0.05450}, {1120,0.05300}, {1130,0.05500}, {1140,0.08775}, {1150,0.05650}, {1160,0.05500}, {1170,0.05700}, {1180,0.08675}, {1190,0.15375}, {1200,0.05900}, {1210,0.06175}, {1220,0.06200}, {1230,0.06050}, {1240,0.10050}, {1250,0.09175}, {1260,0.06375}, {1270,0.06400}, {1280,0.06475}, {1290,0.06575}, {1300,0.10250}, {1310,0.12050}, {1320,0.09950}, {1330,0.06300}, {1340,0.06350}, {1350,0.15975}, {1360,0.06650}, {1370,0.06675}, {1380,0.06825}, {1390,0.06625}, {1400,0.06850}, {1410,0.12875}, {1420,0.11850}, {1430,0.11475}, {1440,0.09875}, {1450,0.10175}, {1460,0.10375}, {1470,0.11150}, {1480,0.11450}, {1490,0.10600}, {1500,0.10240}, {1510,0.11850}, {1520,0.11600}, {1530,0.13750}, {1540,0.13750}, {1550,0.13475}, {1560,0.12350}, {1570,0.09575}, {1580,0.09675}, {1590,0.09825}, {1600,0.07700}, {1610,0.07775}, {1620,0.26700}, {1630,0.07900}, {1640,0.11250}, {1650,0.14775}, {1660,0.12750}, {1670,0.11300}, {1680,0.08550}, {1690,0.08625}, {1700,0.08675}, {1710,0.08500}, {1720,0.14600}, {1730,0.15400}, {1740,0.13850}, {1750,0.08725}, {1760,0.08675}, {1770,0.08725}, {1780,0.11975}, {1790,0.12250}, {1800,0.10750}, {1810,0.09050}, {1820,0.09275}, {1830,0.12450}, {1840,0.11150}, {1850,0.09075}, {1860,0.08925}, {1870,0.11950}, {1880,0.12300}, {1890,0.09175}, {1900,0.09250}, {1910,0.11900}, {1920,0.11925}, {1930,0.09300}, {1940,0.09600}, {1950,0.12950}, {1960,0.09275}, {1970,0.09700}, {1980,0.13050}, {1990,0.12325}, {2000,0.10840}, {2050,0.18350}, {2100,0.10550}, {2150,0.14125}, {2200,0.14050}, {2250,0.11300}, {2300,0.15350}, {2350,0.15025}, {2400,0.15575}, {2450,0.12350}, {2500,0.15900}, {2550,0.16850}, {2600,0.12675}, {2650,0.15125}, {2700,0.15450}, {2750,0.16650}, {2800,0.17850}, {2850,0.18425}, {2900,0.18250}, {2950,0.14325}, {3000,0.16360}, {3050,0.19425}, {3100,0.19450}, {3150,0.20075}, {3200,0.22175}, {3250,0.19950}, {3300,0.21250}, {3350,0.18075}, {3400,0.24200}, {3450,0.27175}, {3500,0.21920}, {3550,0.29000}, {3600,0.27550}, {3650,0.29350}, {3700,0.28550}, {3750,0.27250}, {3800,0.23600}, {3850,0.25500}, {3900,0.23650}, {3950,0.25575}, {4000,0.26000}, {4050,0.24425}, {4100,0.25150}, {4150,0.26375}, {4200,0.25975}, {4250,0.27050}, {4300,0.23925}, {4350,0.25300}, {4400,0.25625}, {4450,0.26550}, {4500,0.26440}, {4550,0.26250}, {4600,0.26475}, {4650,0.32550}, {4700,0.31825}, {4750,0.36475}, {4800,0.36025}, {4850,0.38525}, {4900,0.39775}, {4950,0.38275}, {5000,0.33360}};
data["big_flat"]["ParsingElaborated"]["reif"]["system"] = {{1,0.00018103}, {2,0.00024138}, {3,0.00019828}, {4,0.00006897}, {5,0.00009483}, {6,0.00000000}, {7,0.00003448}, {8,0.00000000}, {9,0.00006897}, {10,0.00014655}, {11,0.00016379}, {12,0.00003448}, {13,0.00006897}, {14,0.00009483}, {15,0.00012931}, {16,0.00006897}, {17,0.00006897}, {18,0.00006897}, {19,0.00010345}, {20,0.00018966}, {21,0.00017241}, {22,0.00023276}, {23,0.00019828}, {24,0.00012931}, {25,0.00010345}, {26,0.00012931}, {27,0.00008621}, {28,0.00010345}, {29,0.00026724}, {30,0.00023276}, {31,0.00012931}, {32,0.00002586}, {33,0.00009483}, {34,0.00041379}, {35,0.00013793}, {36,0.00007759}, {37,0.00030172}, {38,0.00006897}, {39,0.00000000}, {40,0.00009483}, {41,0.00008621}, {42,0.00006897}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00003448}, {47,0.00003448}, {48,0.00000000}, {49,0.00003448}, {50,0.00003448}, {51,0.00003448}, {52,0.00006897}, {53,0.00000000}, {54,0.00006897}, {55,0.00006034}, {56,0.00015517}, {57,0.00003448}, {58,0.00000000}, {59,0.00003448}, {60,0.00003448}, {61,0.00000000}, {62,0.00003448}, {63,0.00006034}, {64,0.00010345}, {65,0.00000000}, {66,0.00003448}, {67,0.00000000}, {68,0.00003448}, {69,0.00023276}, {70,0.00000000}, {71,0.00006897}, {72,0.00002586}, {73,0.00002586}, {74,0.00006034}, {75,0.00006897}, {76,0.00006897}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00003448}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00044828}, {85,0.00006897}, {86,0.00006034}, {87,0.00006897}, {88,0.00006897}, {89,0.00003448}, {90,0.00003448}, {91,0.00003448}, {92,0.00000000}, {93,0.00006034}, {94,0.00003448}, {95,0.00012069}, {96,0.00013793}, {97,0.00003448}, {98,0.00003448}, {99,0.00000000}, {100,0.00020690}, {101,0.00003448}, {102,0.00006897}, {103,0.00006897}, {104,0.00000000}, {105,0.00003448}, {106,0.00003448}, {107,0.00000000}, {108,0.00006034}, {109,0.00003448}, {110,0.00006897}, {111,0.00010345}, {112,0.00002586}, {113,0.00060345}, {114,0.00006897}, {115,0.00003448}, {116,0.00010345}, {117,0.00003448}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00003448}, {122,0.00002586}, {123,0.00009483}, {124,0.00003448}, {125,0.00000000}, {126,0.00019828}, {127,0.00013793}, {128,0.00009483}, {129,0.00012931}, {130,0.00017241}, {131,0.00013793}, {132,0.00002586}, {133,0.00010345}, {134,0.00013793}, {135,0.00006897}, {136,0.00006897}, {137,0.00010345}, {138,0.00013793}, {139,0.00012931}, {140,0.00015517}, {141,0.00012069}, {142,0.00002586}, {143,0.00000000}, {144,0.00003448}, {145,0.00009483}, {146,0.00009483}, {147,0.00006034}, {148,0.00006897}, {149,0.00003448}, {150,0.00006034}, {151,0.00003448}, {152,0.00000000}, {153,0.00006897}, {154,0.00003448}, {155,0.00006897}, {156,0.00003448}, {157,0.00010345}, {158,0.00003448}, {159,0.00003448}, {160,0.00003448}, {161,0.00006897}, {162,0.00010345}, {163,0.00010345}, {164,0.00003448}, {165,0.00000000}, {166,0.00006897}, {167,0.00003448}, {168,0.00000000}, {169,0.00003448}, {170,0.00000000}, {171,0.00006034}, {172,0.00000000}, {173,0.00006897}, {174,0.00088793}, {175,0.00003448}, {176,0.00009483}, {177,0.00006034}, {178,0.00010345}, {179,0.00003448}, {180,0.00003448}, {181,0.00012931}, {182,0.00003448}, {183,0.00020690}, {184,0.00006897}, {185,0.00010345}, {186,0.00016379}, {187,0.00000000}, {188,0.00013793}, {189,0.00000000}, {190,0.00012931}, {191,0.00013793}, {192,0.00008621}, {193,0.00006897}, {194,0.00002586}, {195,0.00010345}, {196,0.00010345}, {197,0.00018966}, {198,0.00071552}, {199,0.00030172}, {200,0.00003448}, {201,0.00016379}, {202,0.00006897}, {203,0.00011207}, {204,0.00013793}, {205,0.00158621}, {206,0.00019828}, {207,0.00020690}, {208,0.00020690}, {209,0.00012931}, {210,0.00002586}, {211,0.00006897}, {212,0.00097414}, {213,0.00016379}, {214,0.00003448}, {215,0.00009483}, {216,0.00010345}, {217,0.00017241}, {218,0.00006897}, {219,0.00043103}, {220,0.00006897}, {221,0.00000000}, {222,0.00003448}, {223,0.00010345}, {224,0.00006897}, {225,0.00010345}, {226,0.00002586}, {227,0.00018966}, {228,0.00003448}, {229,0.00006897}, {230,0.00010345}, {231,0.00006897}, {232,0.00056034}, {233,0.00018966}, {234,0.00012069}, {235,0.00016379}, {236,0.00016379}, {237,0.00002586}, {238,0.00006897}, {239,0.00013793}, {240,0.00020690}, {241,0.00006034}, {242,0.00006034}, {243,0.00009483}, {244,0.00013793}, {245,0.00006897}, {246,0.00006897}, {247,0.00003448}, {248,0.00003448}, {249,0.00012069}, {250,0.00006897}, {251,0.00003448}, {252,0.00013793}, {253,0.00006897}, {254,0.00003448}, {255,0.00005172}, {256,0.00013793}, {257,0.00030172}, {258,0.00013793}, {259,0.00022414}, {260,0.00010345}, {261,0.00029310}, {262,0.00068966}, {263,0.00020690}, {264,0.00010345}, {265,0.00006897}, {266,0.00003448}, {267,0.00003448}, {268,0.00030172}, {269,0.00000000}, {270,0.00013793}, {271,0.00030172}, {272,0.00006034}, {273,0.00048276}, {274,0.00026724}, {275,0.00021552}, {276,0.00022414}, {277,0.00006034}, {278,0.00012931}, {279,0.00016379}, {280,0.00013793}, {281,0.00016379}, {282,0.00065517}, {283,0.00234483}, {284,0.00057759}, {285,0.00044828}, {286,0.00003448}, {287,0.00006897}, {288,0.00003448}, {289,0.00018966}, {290,0.00027586}, {291,0.00013793}, {292,0.00012931}, {293,0.00006034}, {294,0.00016379}, {295,0.00010345}, {296,0.00016379}, {297,0.00000000}, {298,0.00006897}, {299,0.00019828}, {300,0.00009483}, {301,0.00010345}, {302,0.00002586}, {303,0.00006897}, {304,0.00006897}, {305,0.00002586}, {306,0.00010345}, {307,0.00010345}, {308,0.00070690}, {309,0.00013793}, {310,0.00003448}, {311,0.00003448}, {312,0.00017241}, {313,0.00075000}, {314,0.00010345}, {315,0.00006897}, {316,0.00006034}, {317,0.00017241}, {318,0.00006897}, {319,0.00010345}, {320,0.00003448}, {321,0.00019828}, {322,0.00017241}, {323,0.00010345}, {324,0.00016379}, {325,0.00020690}, {326,0.00006897}, {327,0.00050862}, {328,0.00000000}, {329,0.00006897}, {330,0.00006897}, {331,0.00000000}, {332,0.00026724}, {333,0.00003448}, {334,0.00017241}, {335,0.00003448}, {336,0.00039655}, {337,0.00027586}, {338,0.00010345}, {339,0.00006897}, {340,0.00006897}, {341,0.00016379}, {342,0.00023276}, {343,0.00013793}, {344,0.00012931}, {345,0.00024138}, {346,0.00015517}, {347,0.00010345}, {348,0.00017241}, {349,0.00016379}, {350,0.00012931}, {351,0.00020690}, {352,0.00010345}, {353,0.00063793}, {354,0.00020690}, {355,0.00010345}, {356,0.00012931}, {357,0.00006034}, {358,0.00013793}, {359,0.00003448}, {360,0.00016379}, {361,0.00006897}, {362,0.00006897}, {363,0.00016379}, {364,0.00024138}, {365,0.00010345}, {366,0.00022414}, {367,0.00025862}, {368,0.00016379}, {369,0.00012931}, {370,0.00019828}, {371,0.00010345}, {372,0.00012931}, {373,0.00013793}, {374,0.00010345}, {375,0.00002586}, {376,0.00006897}, {377,0.00009483}, {378,0.00023276}, {379,0.00013793}, {380,0.00020690}, {381,0.00000000}, {382,0.00017241}, {383,0.00017241}, {384,0.00003448}, {385,0.00010345}, {386,0.00010345}, {387,0.00015517}, {388,0.00003448}, {389,0.00050862}, {390,0.00010345}, {391,0.00003448}, {392,0.00012931}, {393,0.00087069}, {394,0.00012069}, {395,0.00009483}, {396,0.00012931}, {397,0.00054310}, {398,0.00020690}, {399,0.00012931}, {400,0.00013793}, {401,0.00003448}, {402,0.00017241}, {403,0.00010345}, {404,0.00003448}, {405,0.00006897}, {406,0.00020690}, {407,0.00057759}, {408,0.00010345}, {409,0.00010345}, {410,0.00006897}, {411,0.00026724}, {412,0.00012931}, {413,0.00025862}, {414,0.00010345}, {415,0.00023276}, {416,0.00012069}, {417,0.00013793}, {418,0.00109483}, {419,0.00010345}, {420,0.00017241}, {421,0.00020690}, {422,0.00020690}, {423,0.00020690}, {424,0.00017241}, {425,0.00067241}, {426,0.00012069}, {427,0.00023276}, {428,0.00000000}, {429,0.00006897}, {430,0.00019828}, {431,0.00029310}, {432,0.00070690}, {433,0.00016379}, {434,0.00013793}, {435,0.00012931}, {436,0.00027586}, {437,0.00018966}, {438,0.00020690}, {439,0.00020690}, {440,0.00012931}, {441,0.00016379}, {442,0.00079310}, {443,0.00027586}, {444,0.00019828}, {445,0.00006897}, {446,0.00013793}, {447,0.00020690}, {448,0.00010345}, {449,0.00017241}, {450,0.00013793}, {451,0.00013793}, {452,0.00054310}, {453,0.00010345}, {454,0.00013793}, {455,0.00017241}, {456,0.00003448}, {457,0.00013793}, {458,0.00026724}, {459,0.00016379}, {460,0.00006897}, {461,0.00017241}, {462,0.00083621}, {463,0.00003448}, {464,0.00006897}, {465,0.00026724}, {466,0.00026724}, {467,0.00012931}, {468,0.00006897}, {469,0.00017241}, {470,0.00012931}, {471,0.00030172}, {472,0.00027586}, {473,0.00017241}, {474,0.00017241}, {475,0.00031034}, {476,0.00009483}, {477,0.00013793}, {478,0.00010345}, {479,0.00010345}, {480,0.00017241}, {481,0.00047414}, {482,0.00017241}, {483,0.00006897}, {484,0.00041379}, {485,0.00017241}, {486,0.00033621}, {487,0.00062069}, {488,0.00019828}, {489,0.00020690}, {490,0.00076724}, {491,0.00023276}, {492,0.00013793}, {493,0.00058621}, {494,0.00017241}, {495,0.00016379}, {496,0.00081897}, {497,0.00034483}, {498,0.00020690}, {499,0.00068966}, {500,0.000212121}, {505,0.00088696}, {510,0.00020870}, {515,0.00012174}, {520,0.00059130}, {525,0.00027826}, {530,0.00017391}, {535,0.00046957}, {540,0.00006957}, {545,0.00002609}, {550,0.00013913}, {555,0.00010435}, {560,0.00006087}, {565,0.00024348}, {570,0.00028070}, {575,0.00057018}, {580,0.00031579}, {585,0.00017544}, {590,0.00059649}, {595,0.00014035}, {600,0.00066087}, {605,0.00020175}, {610,0.00014035}, {615,0.00020175}, {620,0.00023684}, {625,0.00092982}, {630,0.00010526}, {635,0.00030702}, {640,0.00038596}, {645,0.00048246}, {650,0.00013158}, {655,0.00031579}, {660,0.00071930}, {665,0.00017544}, {670,0.00056140}, {675,0.00031579}, {680,0.00009649}, {685,0.00017544}, {690,0.00014035}, {695,0.00016667}, {700,0.00029565}, {705,0.00024561}, {710,0.00028070}, {715,0.00030702}, {720,0.00035088}, {725,0.00073684}, {730,0.00031579}, {735,0.00071930}, {740,0.00021053}, {745,0.00072807}, {750,0.00006140}, {755,0.00056140}, {760,0.00009649}, {765,0.00088596}, {770,0.00045614}, {775,0.00056140}, {780,0.00054386}, {785,0.00017544}, {790,0.00030702}, {795,0.00016667}, {800,0.00013913}, {805,0.00027193}, {810,0.00020175}, {815,0.00061404}, {820,0.00034211}, {825,0.00092105}, {830,0.00038596}, {835,0.00086842}, {840,0.00017544}, {845,0.00017544}, {850,0.00031579}, {855,0.00020175}, {860,0.00010526}, {865,0.00021053}, {870,0.00021053}, {875,0.00023684}, {880,0.00035088}, {885,0.00049123}, {890,0.00024561}, {895,0.00035088}, {900,0.00020870}, {905,0.00021053}, {910,0.00049123}, {915,0.00024561}, {920,0.00048246}, {925,0.00003509}, {930,0.00021053}, {935,0.00190351}, {940,0.00030702}, {945,0.00029825}, {950,0.00106140}, {955,0.00038596}, {960,0.00042105}, {965,0.00086842}, {970,0.00059649}, {975,0.00024561}, {980,0.00094737}, {985,0.00024561}, {990,0.00030702}, {995,0.00106140}, {1000,0.00041739}, {1010,0.00300}, {1020,0.00100}, {1030,0.00175}, {1040,0.00000}, {1050,0.00100}, {1060,0.00175}, {1070,0.00000}, {1080,0.00000}, {1090,0.00000}, {1100,0.00100}, {1110,0.00000}, {1120,0.00100}, {1130,0.00000}, {1140,0.00000}, {1150,0.00000}, {1160,0.00075}, {1170,0.00000}, {1180,0.00275}, {1190,0.00275}, {1200,0.00000}, {1210,0.00000}, {1220,0.00000}, {1230,0.00100}, {1240,0.00075}, {1250,0.00100}, {1260,0.00000}, {1270,0.00000}, {1280,0.00000}, {1290,0.00000}, {1300,0.00000}, {1310,0.00000}, {1320,0.00200}, {1330,0.00250}, {1340,0.00200}, {1350,0.00000}, {1360,0.00000}, {1370,0.00000}, {1380,0.00000}, {1390,0.00000}, {1400,0.00100}, {1410,0.00200}, {1420,0.00100}, {1430,0.00000}, {1440,0.00100}, {1450,0.00175}, {1460,0.00175}, {1470,0.00000}, {1480,0.00000}, {1490,0.00375}, {1500,0.00240}, {1510,0.00100}, {1520,0.00100}, {1530,0.00000}, {1540,0.00000}, {1550,0.00000}, {1560,0.00200}, {1570,0.00000}, {1580,0.00000}, {1590,0.00000}, {1600,0.00000}, {1610,0.00000}, {1620,0.00200}, {1630,0.00075}, {1640,0.00000}, {1650,0.00000}, {1660,0.00000}, {1670,0.00100}, {1680,0.00000}, {1690,0.00000}, {1700,0.00100}, {1710,0.00000}, {1720,0.00375}, {1730,0.00500}, {1740,0.00475}, {1750,0.00000}, {1760,0.00200}, {1770,0.00100}, {1780,0.00500}, {1790,0.00500}, {1800,0.00500}, {1810,0.00000}, {1820,0.00000}, {1830,0.00500}, {1840,0.00600}, {1850,0.00100}, {1860,0.00000}, {1870,0.00400}, {1880,0.00775}, {1890,0.00175}, {1900,0.00000}, {1910,0.00700}, {1920,0.00200}, {1930,0.00100}, {1940,0.00100}, {1950,0.00000}, {1960,0.00200}, {1970,0.00000}, {1980,0.00200}, {1990,0.00000}, {2000,0.00000}, {2050,0.00500}, {2100,0.00100}, {2150,0.00600}, {2200,0.00875}, {2250,0.00000}, {2300,0.00800}, {2350,0.00400}, {2400,0.00400}, {2450,0.00000}, {2500,0.00480}, {2550,0.00875}, {2600,0.00000}, {2650,0.00400}, {2700,0.00900}, {2750,0.00800}, {2800,0.00875}, {2850,0.00500}, {2900,0.00975}, {2950,0.00000}, {3000,0.00560}, {3050,0.00400}, {3100,0.00300}, {3150,0.00200}, {3200,0.01100}, {3250,0.01100}, {3300,0.00600}, {3350,0.00000}, {3400,0.01175}, {3450,0.00775}, {3500,0.00320}, {3550,0.01100}, {3600,0.00800}, {3650,0.01000}, {3700,0.00800}, {3750,0.01100}, {3800,0.01200}, {3850,0.01000}, {3900,0.00800}, {3950,0.01175}, {4000,0.01080}, {4050,0.00775}, {4100,0.00800}, {4150,0.00975}, {4200,0.01400}, {4250,0.01000}, {4300,0.01175}, {4350,0.00400}, {4400,0.00800}, {4450,0.00900}, {4500,0.00720}, {4550,0.01100}, {4600,0.01000}, {4650,0.01600}, {4700,0.00400}, {4750,0.00300}, {4800,0.00100}, {4850,0.00200}, {4900,0.00100}, {4950,0.00000}, {5000,0.00060}};
data["big_flat"]["QuoteFlat"]["Aggregate"]["real"] = {{1,0.00100909}, {2,0.00034545}, {3,0.00047273}, {4,0.00073636}, {5,0.00089091}, {6,0.00099091}, {7,0.00097273}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00100000}, {16,0.00100000}, {17,0.00100000}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00100000}, {23,0.00100000}, {24,0.00100000}, {25,0.00100000}, {26,0.00100000}, {27,0.00100000}, {28,0.00100000}, {29,0.00100000}, {30,0.00100000}, {31,0.00100000}, {32,0.00100000}, {33,0.00100000}, {34,0.00100000}, {35,0.00131818}, {36,0.00100000}, {37,0.00100000}, {38,0.00100000}, {39,0.01618182}, {40,0.00100000}, {41,0.00100000}, {42,0.00100000}, {43,0.00100000}, {44,0.00100909}, {45,0.00100000}, {46,0.00100000}, {47,0.00100000}, {48,0.00100000}, {49,0.00100000}, {50,0.00100000}, {51,0.00100000}, {52,0.00100000}, {53,0.00100000}, {54,0.00100000}, {55,0.00100000}, {56,0.00100000}, {57,0.00100000}, {58,0.00100000}, {59,0.00100000}, {60,0.00100000}, {61,0.00100000}, {62,0.00100000}, {63,0.00100909}, {64,0.00100000}, {65,0.00102727}, {66,0.00100909}, {67,0.00102727}, {68,0.00106364}, {69,0.00110909}, {70,0.00116364}, {71,0.00125455}, {72,0.00130000}, {73,0.00136364}, {74,0.00148182}, {75,0.00142727}, {76,0.00153636}, {77,0.00166364}, {78,0.00166364}, {79,0.00183636}, {80,0.00182727}, {81,0.00190909}, {82,0.00191818}, {83,0.00196364}, {84,0.00199091}, {85,0.00200000}, {86,0.00200000}, {87,0.00201818}, {88,0.00200909}, {89,0.00200909}, {90,0.00298182}, {91,0.00200000}, {92,0.00200000}, {93,0.00200000}, {94,0.00200000}, {95,0.00200000}, {96,0.00200000}, {97,0.00200000}, {98,0.00200000}, {99,0.00200000}, {100,0.00200000}, {101,0.00200000}, {102,0.00200000}, {103,0.00200000}, {104,0.00200000}, {105,0.00200000}, {106,0.00200000}, {107,0.00200000}, {108,0.00200000}, {109,0.00200000}, {110,0.00200000}, {111,0.00200000}, {112,0.00200000}, {113,0.00200000}, {114,0.00200000}, {115,0.00200000}, {116,0.00200000}, {117,0.00200000}, {118,0.00200000}, {119,0.00200000}, {120,0.00200000}, {121,0.00200909}, {122,0.00200000}, {123,0.00200000}, {124,0.00200000}, {125,0.00201818}, {126,0.00200000}, {127,0.00300909}, {128,0.00200000}, {129,0.00200000}, {130,0.00200000}, {131,0.00200000}, {132,0.00200909}, {133,0.00200000}, {134,0.00200000}, {135,0.00200000}, {136,0.00203636}, {137,0.00204545}, {138,0.00201818}, {139,0.00202727}, {140,0.00203636}, {141,0.00206364}, {142,0.00206364}, {143,0.00207273}, {144,0.00208182}, {145,0.00212727}, {146,0.00223636}, {147,0.00217273}, {148,0.00222727}, {149,0.00227273}, {150,0.00231818}, {151,0.00241818}, {152,0.00251818}, {153,0.00255455}, {154,0.00264545}, {155,0.00268182}, {156,0.00273636}, {157,0.00277273}, {158,0.00285455}, {159,0.00281818}, {160,0.00289091}, {161,0.00290000}, {162,0.00292727}, {163,0.00291818}, {164,0.00294545}, {165,0.00298182}, {166,0.00300909}, {167,0.00299091}, {168,0.00300000}, {169,0.00300000}, {170,0.00300000}, {171,0.00300000}, {172,0.00300000}, {173,0.00300000}, {174,0.00300000}, {175,0.00300000}, {176,0.00300000}, {177,0.00300000}, {178,0.00300000}, {179,0.00300000}, {180,0.00300000}, {181,0.00300000}, {182,0.00300000}, {183,0.00301818}, {184,0.00398182}, {185,0.00300000}, {186,0.00300000}, {187,0.00300000}, {188,0.00300000}, {189,0.00300000}, {190,0.00301818}, {191,0.00301818}, {192,0.00300000}, {193,0.00300000}, {194,0.00300000}, {195,0.00300000}, {196,0.00300000}, {197,0.00300000}, {198,0.00300000}, {199,0.00300909}, {200,0.00300000}, {201,0.00300000}, {202,0.00300000}, {203,0.00302727}, {204,0.00300909}, {205,0.00300000}, {206,0.00300909}, {207,0.00303636}, {208,0.00455455}, {209,0.00301818}, {210,0.00300909}, {211,0.00303636}, {212,0.00302727}, {213,0.00308182}, {214,0.00304545}, {215,0.00306364}, {216,0.00312727}, {217,0.00310000}, {218,0.00315455}, {219,0.00317273}, {220,0.00320909}, {221,0.00323636}, {222,0.00321818}, {223,0.00332727}, {224,0.00332727}, {225,0.00340909}, {226,0.00340000}, {227,0.00350909}, {228,0.00355455}, {229,0.00360909}, {230,0.00504545}, {231,0.00370000}, {232,0.00376364}, {233,0.00375455}, {234,0.00378182}, {235,0.00380909}, {236,0.00386364}, {237,0.00383636}, {238,0.00390000}, {239,0.00390909}, {240,0.00396364}, {241,0.00391818}, {242,0.00392727}, {243,0.00394545}, {244,0.00395455}, {245,0.00398182}, {246,0.00397273}, {247,0.00399091}, {248,0.00399091}, {249,0.00400000}, {250,0.00400000}, {251,0.00400000}, {252,0.00400000}, {253,0.00400909}, {254,0.00400000}, {255,0.00400000}, {256,0.00400000}, {257,0.00400000}, {258,0.00400000}, {259,0.00400000}, {260,0.00400000}, {261,0.00400000}, {262,0.00400000}, {263,0.00400000}, {264,0.00400000}, {265,0.00400000}, {266,0.00400000}, {267,0.00400000}, {268,0.00402727}, {269,0.00400000}, {270,0.00400000}, {271,0.00400000}, {272,0.00400000}, {273,0.00400000}, {274,0.00400909}, {275,0.00400909}, {276,0.00400909}, {277,0.00401818}, {278,0.00402727}, {279,0.00401818}, {280,0.00402727}, {281,0.00401818}, {282,0.00400909}, {283,0.00402727}, {284,0.00401818}, {285,0.00407273}, {286,0.00407273}, {287,0.00407273}, {288,0.00406364}, {289,0.00410000}, {290,0.00412727}, {291,0.00416364}, {292,0.00418182}, {293,0.00422727}, {294,0.00418182}, {295,0.00423636}, {296,0.00429091}, {297,0.00436364}, {298,0.00436364}, {299,0.00442727}, {300,0.00453636}, {301,0.00457273}, {302,0.00457273}, {303,0.00455455}, {304,0.00462727}, {305,0.00505455}, {306,0.00468182}, {307,0.00469091}, {308,0.00472727}, {309,0.00474545}, {310,0.00478182}, {311,0.00475455}, {312,0.00479091}, {313,0.00482727}, {314,0.00482727}, {315,0.00485455}, {316,0.00486364}, {317,0.00490000}, {318,0.00493636}, {319,0.00492727}, {320,0.00498182}, {321,0.00593636}, {322,0.00497273}, {323,0.00498182}, {324,0.00498182}, {325,0.00499091}, {326,0.00500000}, {327,0.00499091}, {328,0.00500000}, {329,0.00499091}, {330,0.00500000}, {331,0.00500000}, {332,0.00500000}, {333,0.00500000}, {334,0.00500000}, {335,0.00500000}, {336,0.00501818}, {337,0.00579091}, {338,0.00500000}, {339,0.00500909}, {340,0.00500000}, {341,0.00500000}, {342,0.00500000}, {343,0.00500000}, {344,0.00500000}, {345,0.00500909}, {346,0.00500909}, {347,0.00500909}, {348,0.00502727}, {349,0.00500000}, {350,0.00500000}, {351,0.00501818}, {352,0.00590909}, {353,0.00503636}, {354,0.00500000}, {355,0.00503636}, {356,0.00503636}, {357,0.00502727}, {358,0.00506364}, {359,0.00505455}, {360,0.00507273}, {361,0.00510909}, {362,0.00515455}, {363,0.00512727}, {364,0.00520909}, {365,0.00522727}, {366,0.00718182}, {367,0.00521818}, {368,0.00528182}, {369,0.00525455}, {370,0.00535455}, {371,0.00542727}, {372,0.00541818}, {373,0.00549091}, {374,0.00555455}, {375,0.00554545}, {376,0.00560000}, {377,0.00564545}, {378,0.00562727}, {379,0.00564545}, {380,0.00775455}, {381,0.00574545}, {382,0.00576364}, {383,0.00577273}, {384,0.00580000}, {385,0.00580000}, {386,0.00580909}, {387,0.00586364}, {388,0.00586364}, {389,0.00584545}, {390,0.00585455}, {391,0.00585455}, {392,0.00590000}, {393,0.00587273}, {394,0.00682727}, {395,0.00587273}, {396,0.00592727}, {397,0.00594545}, {398,0.00593636}, {399,0.00594545}, {400,0.00595455}, {401,0.00595455}, {402,0.00594545}, {403,0.00598182}, {404,0.00599091}, {405,0.00600000}, {406,0.00603636}, {407,0.00696364}, {408,0.00600000}, {409,0.00599091}, {410,0.00599091}, {411,0.00600000}, {412,0.00600909}, {413,0.00600000}, {414,0.00600909}, {415,0.00600909}, {416,0.00600909}, {417,0.00601818}, {418,0.00600909}, {419,0.00604545}, {420,0.00692727}, {421,0.00600000}, {422,0.00604545}, {423,0.00601818}, {424,0.00601818}, {425,0.00601818}, {426,0.00603636}, {427,0.00606364}, {428,0.00605455}, {429,0.00609091}, {430,0.00611818}, {431,0.00612727}, {432,0.00856364}, {433,0.00612727}, {434,0.00613636}, {435,0.00610909}, {436,0.00614545}, {437,0.00620909}, {438,0.00627273}, {439,0.00620000}, {440,0.00630000}, {441,0.00634545}, {442,0.00630909}, {443,0.00641818}, {444,0.00789091}, {445,0.00642727}, {446,0.00649091}, {447,0.00646364}, {448,0.00658182}, {449,0.00659091}, {450,0.00661818}, {451,0.00666364}, {452,0.00670000}, {453,0.00674545}, {454,0.00672727}, {455,0.00676364}, {456,0.00890000}, {457,0.00676364}, {458,0.00676364}, {459,0.00675455}, {460,0.00680909}, {461,0.00678182}, {462,0.00679091}, {463,0.00679091}, {464,0.00680000}, {465,0.00680000}, {466,0.00685455}, {467,0.00688182}, {468,0.00779091}, {469,0.00688182}, {470,0.00689091}, {471,0.00685455}, {472,0.00690000}, {473,0.00695455}, {474,0.00693636}, {475,0.00694545}, {476,0.00694545}, {477,0.00693636}, {478,0.00702727}, {479,0.00953636}, {480,0.00695455}, {481,0.00699091}, {482,0.00699091}, {483,0.00700909}, {484,0.00699091}, {485,0.00699091}, {486,0.00700000}, {487,0.00699091}, {488,0.00700909}, {489,0.00702727}, {490,0.00970909}, {491,0.00701818}, {492,0.00701818}, {493,0.00702727}, {494,0.00704545}, {495,0.00701818}, {496,0.00703636}, {497,0.00703636}, {498,0.00702727}, {499,0.00704545}, {500,0.00709091}, {505,0.00944545}, {510,0.00722727}, {515,0.00743636}, {520,0.00755455}, {525,0.00766364}, {530,0.00776364}, {535,0.00777273}, {540,0.00777273}, {545,0.00787273}, {550,0.00787273}, {555,0.01050000}, {560,0.00799091}, {565,0.00801818}, {570,0.00805455}, {575,0.00812727}, {580,0.00817273}, {585,0.00826364}, {590,0.00845455}, {595,0.00865455}, {600,0.00879091}, {605,0.00942727}, {610,0.00880000}, {615,0.00878182}, {620,0.00881818}, {625,0.00884545}, {630,0.00888182}, {635,0.00894545}, {640,0.00900909}, {645,0.00909091}, {650,0.00912727}, {655,0.00922727}, {660,0.00940909}, {665,0.00948182}, {670,0.00968182}, {675,0.00970909}, {680,0.00975455}, {685,0.00982727}, {690,0.01193636}, {695,0.00982727}, {700,0.00987273}, {705,0.00990909}, {710,0.00996364}, {715,0.01001818}, {720,0.01008182}, {725,0.01017273}, {730,0.01180909}, {735,0.01044545}, {740,0.01050000}, {745,0.01070000}, {750,0.01071818}, {755,0.01076364}, {760,0.01079091}, {765,0.01342727}, {770,0.01081818}, {775,0.01084545}, {780,0.01085455}, {785,0.01096364}, {790,0.01104545}, {795,0.01112727}, {800,0.01430000}, {805,0.01124545}, {810,0.01138182}, {815,0.01153636}, {820,0.01169091}, {825,0.01174545}, {830,0.01175455}, {835,0.01410000}, {840,0.01180000}, {845,0.01184545}, {850,0.01180909}, {855,0.01185455}, {860,0.01195455}, {865,0.01207273}, {870,0.01448182}, {875,0.01228182}, {880,0.01237273}, {885,0.01249091}, {890,0.01263636}, {895,0.01271818}, {900,0.01474545}, {905,0.01273636}, {910,0.01277273}, {915,0.01280000}, {920,0.01281818}, {925,0.01286364}, {930,0.01791818}, {935,0.01295455}, {940,0.01306364}, {945,0.01325455}, {950,0.01331818}, {955,0.01341818}, {960,0.01876364}, {965,0.01360000}, {970,0.01375455}, {975,0.01377273}, {980,0.01380000}, {985,0.01386364}, {990,0.01574545}, {995,0.01387273}, {1000,0.01391818}, {1010,0.01408182}, {1020,0.01428182}, {1030,0.01453636}, {1040,0.01516364}, {1050,0.01480000}, {1060,0.01480000}, {1070,0.01487273}, {1080,0.01506364}, {1090,0.01689091}, {1100,0.01543636}, {1110,0.01563636}, {1120,0.01576364}, {1130,0.01582727}, {1140,0.01866364}, {1150,0.01606364}, {1160,0.01616364}, {1170,0.01641818}, {1180,0.01658182}, {1190,0.02076364}, {1200,0.01682727}, {1210,0.01690000}, {1220,0.01707273}, {1230,0.01728182}, {1240,0.01824545}, {1250,0.01765455}, {1260,0.01771818}, {1270,0.01782727}, {1280,0.02181818}, {1290,0.01816364}, {1300,0.01831818}, {1310,0.01844545}, {1320,0.01861818}, {1330,0.02001818}, {1340,0.01888182}, {1350,0.01900909}, {1360,0.01916364}, {1370,0.02186364}, {1380,0.01941818}, {1390,0.01963636}, {1400,0.01972727}, {1410,0.02293636}, {1420,0.02009091}, {1430,0.02029091}, {1440,0.02040000}, {1450,0.02327273}, {1460,0.02063636}, {1470,0.02080909}, {1480,0.02096364}, {1490,0.02670000}, {1500,0.02132727}, {1510,0.02151818}, {1520,0.02170909}, {1530,0.02420000}, {1540,0.02188182}, {1550,0.02200909}, {1560,0.02229091}, {1570,0.02238182}, {1580,0.02239091}, {1590,0.02259091}, {1600,0.02859091}, {1610,0.02296364}, {1620,0.02308182}, {1630,0.02329091}, {1640,0.02610909}, {1650,0.02353636}, {1660,0.02369091}, {1670,0.02849091}, {1680,0.02418182}, {1690,0.02421818}, {1700,0.02454545}, {1710,0.02703636}, {1720,0.02467273}, {1730,0.02481818}, {1740,0.02750000}, {1750,0.02522727}, {1760,0.02535455}, {1770,0.02873636}, {1780,0.02571818}, {1790,0.02577273}, {1800,0.02608182}, {1810,0.02608182}, {1820,0.02638182}, {1830,0.02644545}, {1840,0.02923636}, {1850,0.02685455}, {1860,0.02700909}, {1870,0.03120000}, {1880,0.02735455}, {1890,0.02749091}, {1900,0.03108182}, {1910,0.02786364}, {1920,0.02818182}, {1930,0.03043636}, {1940,0.02840000}, {1950,0.02880909}, {1960,0.03090000}, {1970,0.02888182}, {1980,0.02897273}, {1990,0.03170000}, {2000,0.02950000}, {2050,0.03033636}, {2100,0.03510000}, {2150,0.03211818}, {2200,0.04079091}, {2250,0.03394545}, {2300,0.03481818}, {2350,0.03936364}, {2400,0.03667273}, {2450,0.04897273}, {2500,0.03872727}, {2550,0.03951818}, {2600,0.04308182}, {2650,0.04091818}, {2700,0.04784545}, {2750,0.04293636}, {2800,0.05127273}, {2850,0.04490909}, {2900,0.06052727}, {2950,0.04646364}, {3000,0.06000000}, {3050,0.04837273}, {3100,0.05861818}, {3150,0.05056364}, {3200,0.06107273}, {3250,0.05210909}, {3300,0.05592727}, {3350,0.06281818}, {3400,0.05476364}, {3450,0.07194545}, {3500,0.05679091}, {3550,0.06280000}, {3600,0.05898182}, {3650,0.05919091}, {3700,0.07397273}, {3750,0.06139091}, {3800,0.06870000}, {3850,0.07296364}, {3900,0.06442727}, {3950,0.06899091}, {4000,0.08164545}, {4050,0.06730909}, {4100,0.07120000}, {4150,0.08088182}, {4200,0.07068182}, {4250,0.07088182}, {4300,0.07863636}, {4350,0.07897273}, {4400,0.07430000}, {4450,0.07774545}, {4500,0.08057273}, {4550,0.09687273}, {4600,0.07847273}, {4650,0.08005455}, {4700,0.09596364}, {4750,0.09458182}, {4800,0.10792727}, {4850,0.09766364}, {4900,0.08515455}, {4950,0.08868182}, {5000,0.09632727}, {5050,0.10042727}, {5100,0.11396364}, {5150,0.10416364}, {5200,0.09189091}, {5250,0.09220909}, {5300,0.09654545}, {5350,0.09939091}, {5400,0.11570000}, {5450,0.10747273}, {5500,0.10453636}, {5550,0.11228182}, {5600,0.13092727}, {5650,0.13110909}, {5700,0.12088182}, {5750,0.11197273}, {5800,0.10677273}, {5850,0.10700000}, {5900,0.10844545}, {5950,0.10879091}, {6000,0.10661818}, {6050,0.11574545}, {6100,0.13448182}, {6150,0.14240000}, {6200,0.13749091}, {6250,0.13873636}, {6300,0.13897273}, {6350,0.14064545}, {6400,0.12672727}, {6450,0.13941818}, {6500,0.13588182}, {6550,0.13490000}, {6600,0.13672727}, {6650,0.13339091}, {6700,0.14683636}, {6750,0.15091818}, {6800,0.14593636}, {6850,0.14620000}, {6900,0.14216364}, {6950,0.14044545}, {7000,0.13123636}, {7050,0.15551818}, {7100,0.15300000}, {7150,0.14855455}, {7200,0.15471818}, {7250,0.15300909}, {7300,0.16296364}, {7350,0.17145455}, {7400,0.16390000}, {7450,0.14466364}, {7500,0.16049091}, {7550,0.17860000}, {7600,0.16786364}, {7650,0.17929091}, {7700,0.15706364}, {7750,0.16571818}, {7800,0.16003636}, {7850,0.16716364}, {7900,0.16302727}, {7950,0.15845455}, {8000,0.16775455}, {8050,0.18022727}, {8100,0.19314545}, {8150,0.16459091}, {8200,0.17171818}, {8250,0.18320909}, {8300,0.19606364}, {8350,0.17968182}, {8400,0.18094545}, {8450,0.17420000}, {8500,0.18370000}, {8550,0.21192727}, {8600,0.19582727}, {8650,0.20032727}, {8700,0.20603636}, {8750,0.18925455}, {8800,0.19552727}, {8850,0.19138182}, {8900,0.19850909}, {8950,0.19012727}, {9000,0.19673636}, {9050,0.20237273}, {9100,0.21864545}, {9150,0.22368182}, {9200,0.20798182}, {9250,0.22512727}, {9300,0.19986364}, {9350,0.21071818}, {9400,0.19127273}, {9450,0.20544545}, {9500,0.22522727}, {9550,0.21101818}, {9600,0.21290909}, {9650,0.20102727}, {9700,0.23600909}, {9750,0.23081818}, {9800,0.20147273}, {9850,0.23065455}, {9900,0.24146364}, {9950,0.20846364}, {10000,0.24828182}, {10100,0.23470000}, {10200,0.21314545}, {10300,0.23711818}, {10400,0.23502727}, {10500,0.26270000}, {10600,0.21863636}, {10700,0.23265455}, {10800,0.27222727}, {10900,0.23354545}, {11000,0.26232727}, {11100,0.26036364}, {11200,0.24143636}, {11300,0.23654545}, {11400,0.25410000}, {11500,0.25112727}, {11600,0.28543636}, {11700,0.27941818}, {11800,0.27127273}, {11900,0.28259091}, {12000,0.28279091}, {12100,0.28280000}, {12200,0.28115455}, {12300,0.29227273}, {12400,0.30869091}, {12500,0.27035455}, {12600,0.26885455}, {12700,0.29448182}, {12800,0.29319091}, {12900,0.31376364}, {13000,0.29148182}, {13100,0.28458182}, {13200,0.27828182}, {13300,0.30839091}, {13400,0.32029091}, {13500,0.35149091}, {13600,0.29271818}, {13700,0.32853636}, {13800,0.31416364}, {13900,0.29022727}, {14000,0.33881818}, {14100,0.36662727}, {14200,0.30320909}, {14300,0.34610909}, {14400,0.30647273}, {14500,0.35562727}, {14600,0.35181818}, {14700,0.35048182}, {14800,0.36283636}, {14900,0.34360909}, {15000,3.85866364}, {15100,0.43187273}, {15200,0.32816364}, {15300,0.40184545}, {15400,0.31560909}, {15500,0.39118182}, {15600,0.34533636}, {15700,0.39553636}, {15800,0.39843636}, {15900,0.33470000}, {16000,0.38680909}, {16100,0.41586364}, {16200,0.40011818}, {16300,0.33573636}, {16400,0.41045455}, {16500,0.43031818}, {16600,0.39693636}, {16700,0.31067273}, {16800,0.34725455}, {16900,0.42255455}, {17000,0.44744545}, {17100,0.45230000}, {17200,0.44628182}, {17300,0.41688182}, {17400,0.35938182}, {17500,0.33263636}, {17600,0.32292727}, {17700,0.33511818}, {17800,0.32987273}, {17900,0.35056364}, {18000,0.34689091}, {18100,0.32547273}, {18200,0.34452727}, {18300,0.44067273}, {18400,0.42293636}, {18500,0.49584545}, {18600,0.51311818}, {18700,0.50931818}, {18800,0.46450000}, {18900,0.38129091}, {19000,0.38705455}, {19100,0.49806364}, {19200,0.51564545}, {19300,0.48752727}, {19400,0.37597273}, {19500,0.51747273}, {19600,0.53433636}, {19700,0.40890909}, {19800,0.42378182}, {19900,0.55850909}, {20000,0.40483333}};
data["big_flat"]["QuoteFlat"]["Aggregate"]["user"] = {{1,0.00024545}, {2,0.00070909}, {3,0.00061818}, {4,0.00050909}, {5,0.00125455}, {6,0.00081818}, {7,0.00060909}, {8,0.00123636}, {9,0.00086364}, {10,0.00071818}, {11,0.00136364}, {12,0.00063636}, {13,0.00089091}, {14,0.00150909}, {15,0.00077273}, {16,0.00105455}, {17,0.00115455}, {18,0.00077273}, {19,0.00132727}, {20,0.00088182}, {21,0.00093636}, {22,0.00135455}, {23,0.00081818}, {24,0.00130000}, {25,0.00106364}, {26,0.00109091}, {27,0.00137273}, {28,0.00100000}, {29,0.00134545}, {30,0.00092727}, {31,0.00131818}, {32,0.00131818}, {33,0.00097273}, {34,0.00160000}, {35,0.00143636}, {36,0.00163636}, {37,0.00107273}, {38,0.00145455}, {39,0.01582727}, {40,0.00099091}, {41,0.00140000}, {42,0.00102727}, {43,0.00168182}, {44,0.00115455}, {45,0.00158182}, {46,0.00129091}, {47,0.00150000}, {48,0.00112727}, {49,0.00160000}, {50,0.00107273}, {51,0.00168182}, {52,0.00103636}, {53,0.00180000}, {54,0.00111818}, {55,0.00177273}, {56,0.00125455}, {57,0.00166364}, {58,0.00130000}, {59,0.00157273}, {60,0.00139091}, {61,0.00176364}, {62,0.00142727}, {63,0.00162727}, {64,0.00158182}, {65,0.00154545}, {66,0.00173636}, {67,0.00141818}, {68,0.00197273}, {69,0.00155455}, {70,0.00190909}, {71,0.00167273}, {72,0.00174545}, {73,0.00164545}, {74,0.00183636}, {75,0.00184545}, {76,0.00156364}, {77,0.00169091}, {78,0.00176364}, {79,0.00203636}, {80,0.00174545}, {81,0.00178182}, {82,0.00174545}, {83,0.00197273}, {84,0.00193636}, {85,0.00161818}, {86,0.00190000}, {87,0.00189091}, {88,0.00181818}, {89,0.00193636}, {90,0.00290000}, {91,0.00185455}, {92,0.00190909}, {93,0.00179091}, {94,0.00180909}, {95,0.00216364}, {96,0.00200909}, {97,0.00193636}, {98,0.00207273}, {99,0.00200909}, {100,0.00195455}, {101,0.00210000}, {102,0.00210000}, {103,0.00211818}, {104,0.00217273}, {105,0.00192727}, {106,0.00214545}, {107,0.00229091}, {108,0.00205455}, {109,0.00218182}, {110,0.00193636}, {111,0.00214545}, {112,0.00210000}, {113,0.00216364}, {114,0.00220000}, {115,0.00213636}, {116,0.00212727}, {117,0.00208182}, {118,0.00229091}, {119,0.00250909}, {120,0.00217273}, {121,0.00212727}, {122,0.00242727}, {123,0.00243636}, {124,0.00235455}, {125,0.00215455}, {126,0.00236364}, {127,0.00311818}, {128,0.00232727}, {129,0.00263636}, {130,0.00215455}, {131,0.00239091}, {132,0.00220000}, {133,0.00270909}, {134,0.00240909}, {135,0.00251818}, {136,0.00214545}, {137,0.00233636}, {138,0.00288182}, {139,0.00260000}, {140,0.00250000}, {141,0.00240909}, {142,0.00225455}, {143,0.00252727}, {144,0.00295455}, {145,0.00245455}, {146,0.00240909}, {147,0.00258182}, {148,0.00249091}, {149,0.00266364}, {150,0.00264545}, {151,0.00240909}, {152,0.00253636}, {153,0.00273636}, {154,0.00280000}, {155,0.00260000}, {156,0.00267273}, {157,0.00233636}, {158,0.00263636}, {159,0.00250909}, {160,0.00254545}, {161,0.00299091}, {162,0.00280909}, {163,0.00297273}, {164,0.00300000}, {165,0.00273636}, {166,0.00261818}, {167,0.00260909}, {168,0.00258182}, {169,0.00279091}, {170,0.00284545}, {171,0.00270000}, {172,0.00283636}, {173,0.00290000}, {174,0.00305455}, {175,0.00289091}, {176,0.00277273}, {177,0.00279091}, {178,0.00293636}, {179,0.00296364}, {180,0.00300000}, {181,0.00280909}, {182,0.00291818}, {183,0.00300000}, {184,0.00376364}, {185,0.00297273}, {186,0.00298182}, {187,0.00298182}, {188,0.00307273}, {189,0.00294545}, {190,0.00308182}, {191,0.00302727}, {192,0.00304545}, {193,0.00299091}, {194,0.00304545}, {195,0.00320000}, {196,0.00316364}, {197,0.00310000}, {198,0.00316364}, {199,0.00319091}, {200,0.00321818}, {201,0.00329091}, {202,0.00327273}, {203,0.00318182}, {204,0.00327273}, {205,0.00323636}, {206,0.00323636}, {207,0.00337273}, {208,0.00439091}, {209,0.00318182}, {210,0.00333636}, {211,0.00323636}, {212,0.00337273}, {213,0.00325455}, {214,0.00324545}, {215,0.00320909}, {216,0.00341818}, {217,0.00342727}, {218,0.00343636}, {219,0.00334545}, {220,0.00340000}, {221,0.00355455}, {222,0.00340000}, {223,0.00355455}, {224,0.00345455}, {225,0.00353636}, {226,0.00358182}, {227,0.00342727}, {228,0.00349091}, {229,0.00342727}, {230,0.00538182}, {231,0.00343636}, {232,0.00360000}, {233,0.00366364}, {234,0.00357273}, {235,0.00350000}, {236,0.00365455}, {237,0.00355455}, {238,0.00358182}, {239,0.00345455}, {240,0.00375455}, {241,0.00357273}, {242,0.00352727}, {243,0.00372727}, {244,0.00383636}, {245,0.00383636}, {246,0.00361818}, {247,0.00376364}, {248,0.00386364}, {249,0.00378182}, {250,0.00389091}, {251,0.00388182}, {252,0.00377273}, {253,0.00376364}, {254,0.00404545}, {255,0.00363636}, {256,0.00385455}, {257,0.00395455}, {258,0.00414545}, {259,0.00401818}, {260,0.00378182}, {261,0.00403636}, {262,0.00406364}, {263,0.00408182}, {264,0.00399091}, {265,0.00412727}, {266,0.00415455}, {267,0.00396364}, {268,0.00396364}, {269,0.00429091}, {270,0.00405455}, {271,0.00408182}, {272,0.00426364}, {273,0.00409091}, {274,0.00401818}, {275,0.00421818}, {276,0.00433636}, {277,0.00400000}, {278,0.00440909}, {279,0.00420000}, {280,0.00426364}, {281,0.00430000}, {282,0.00429091}, {283,0.00419091}, {284,0.00432727}, {285,0.00422727}, {286,0.00440909}, {287,0.00440909}, {288,0.00430000}, {289,0.00430000}, {290,0.00437273}, {291,0.00433636}, {292,0.00431818}, {293,0.00450000}, {294,0.00467273}, {295,0.00440909}, {296,0.00446364}, {297,0.00448182}, {298,0.00466364}, {299,0.00445455}, {300,0.00466364}, {301,0.00459091}, {302,0.00429091}, {303,0.00442727}, {304,0.00463636}, {305,0.00512727}, {306,0.00441818}, {307,0.00460909}, {308,0.00476364}, {309,0.00464545}, {310,0.00452727}, {311,0.00471818}, {312,0.00477273}, {313,0.00428182}, {314,0.00480909}, {315,0.00454545}, {316,0.00474545}, {317,0.00458182}, {318,0.00469091}, {319,0.00472727}, {320,0.00454545}, {321,0.00571818}, {322,0.00460909}, {323,0.00448182}, {324,0.00465455}, {325,0.00460000}, {326,0.00481818}, {327,0.00458182}, {328,0.00487273}, {329,0.00469091}, {330,0.00498182}, {331,0.00463636}, {332,0.00491818}, {333,0.00485455}, {334,0.00487273}, {335,0.00490000}, {336,0.00495455}, {337,0.00556364}, {338,0.00492727}, {339,0.00491818}, {340,0.00474545}, {341,0.00504545}, {342,0.00487273}, {343,0.00510000}, {344,0.00511818}, {345,0.00500000}, {346,0.00492727}, {347,0.00501818}, {348,0.00530909}, {349,0.00512727}, {350,0.00523636}, {351,0.00521818}, {352,0.00544545}, {353,0.00512727}, {354,0.00540000}, {355,0.00493636}, {356,0.00551818}, {357,0.00500000}, {358,0.00518182}, {359,0.00520909}, {360,0.00511818}, {361,0.00513636}, {362,0.00556364}, {363,0.00520000}, {364,0.00530000}, {365,0.00569091}, {366,0.00696364}, {367,0.00510000}, {368,0.00548182}, {369,0.00523636}, {370,0.00542727}, {371,0.00519091}, {372,0.00521818}, {373,0.00547273}, {374,0.00511818}, {375,0.00557273}, {376,0.00542727}, {377,0.00543636}, {378,0.00538182}, {379,0.00547273}, {380,0.00760000}, {381,0.00548182}, {382,0.00553636}, {383,0.00533636}, {384,0.00553636}, {385,0.00550909}, {386,0.00571818}, {387,0.00560000}, {388,0.00565455}, {389,0.00555455}, {390,0.00538182}, {391,0.00554545}, {392,0.00594545}, {393,0.00561818}, {394,0.00661818}, {395,0.00570909}, {396,0.00544545}, {397,0.00553636}, {398,0.00595455}, {399,0.00593636}, {400,0.00550909}, {401,0.00570000}, {402,0.00570909}, {403,0.00560000}, {404,0.00574545}, {405,0.00585455}, {406,0.00576364}, {407,0.00669091}, {408,0.00558182}, {409,0.00581818}, {410,0.00580000}, {411,0.00570909}, {412,0.00575455}, {413,0.00594545}, {414,0.00588182}, {415,0.00568182}, {416,0.00591818}, {417,0.00604545}, {418,0.00580000}, {419,0.00597273}, {420,0.00660909}, {421,0.00601818}, {422,0.00604545}, {423,0.00600909}, {424,0.00603636}, {425,0.00624545}, {426,0.00608182}, {427,0.00582727}, {428,0.00571818}, {429,0.00612727}, {430,0.00601818}, {431,0.00607273}, {432,0.00821818}, {433,0.00590000}, {434,0.00616364}, {435,0.00615455}, {436,0.00600909}, {437,0.00649091}, {438,0.00634545}, {439,0.00615455}, {440,0.00610909}, {441,0.00588182}, {442,0.00595455}, {443,0.00623636}, {444,0.00772727}, {445,0.00602727}, {446,0.00612727}, {447,0.00602727}, {448,0.00628182}, {449,0.00612727}, {450,0.00631818}, {451,0.00608182}, {452,0.00620909}, {453,0.00622727}, {454,0.00629091}, {455,0.00619091}, {456,0.00860909}, {457,0.00630909}, {458,0.00633636}, {459,0.00660000}, {460,0.00660000}, {461,0.00650909}, {462,0.00640909}, {463,0.00634545}, {464,0.00640909}, {465,0.00649091}, {466,0.00647273}, {467,0.00654545}, {468,0.00746364}, {469,0.00643636}, {470,0.00641818}, {471,0.00651818}, {472,0.00655455}, {473,0.00674545}, {474,0.00653636}, {475,0.00649091}, {476,0.00665455}, {477,0.00670909}, {478,0.00674545}, {479,0.00968182}, {480,0.00662727}, {481,0.00667273}, {482,0.00687273}, {483,0.00685455}, {484,0.00672727}, {485,0.00679091}, {486,0.00682727}, {487,0.00682727}, {488,0.00659091}, {489,0.00702727}, {490,0.00926364}, {491,0.00674545}, {492,0.00682727}, {493,0.00690000}, {494,0.00674545}, {495,0.00695455}, {496,0.00677273}, {497,0.00660000}, {498,0.00690909}, {499,0.00688182}, {500,0.00690000}, {505,0.00907273}, {510,0.00700909}, {515,0.00710909}, {520,0.00703636}, {525,0.00710909}, {530,0.00748182}, {535,0.00725455}, {540,0.00783636}, {545,0.00764545}, {550,0.00731818}, {555,0.01039091}, {560,0.00799091}, {565,0.00773636}, {570,0.00800000}, {575,0.00810000}, {580,0.00797273}, {585,0.00787273}, {590,0.00802727}, {595,0.00840909}, {600,0.00817273}, {605,0.00964545}, {610,0.00855455}, {615,0.00868182}, {620,0.00875455}, {625,0.00875455}, {630,0.00910000}, {635,0.00892727}, {640,0.00889091}, {645,0.00913636}, {650,0.00924545}, {655,0.00948182}, {660,0.00937273}, {665,0.00940909}, {670,0.00912727}, {675,0.00957273}, {680,0.00981818}, {685,0.00960909}, {690,0.01200909}, {695,0.00983636}, {700,0.01010909}, {705,0.00997273}, {710,0.01027273}, {715,0.01028182}, {720,0.01017273}, {725,0.01055455}, {730,0.01203636}, {735,0.01034545}, {740,0.01032727}, {745,0.01054545}, {750,0.01068182}, {755,0.01058182}, {760,0.01053636}, {765,0.01339091}, {770,0.01079091}, {775,0.01101818}, {780,0.01121818}, {785,0.01150000}, {790,0.01133636}, {795,0.01128182}, {800,0.01408182}, {805,0.01128182}, {810,0.01142727}, {815,0.01178182}, {820,0.01182727}, {825,0.01172727}, {830,0.01194545}, {835,0.01430000}, {840,0.01203636}, {845,0.01217273}, {850,0.01225455}, {855,0.01220000}, {860,0.01244545}, {865,0.01242727}, {870,0.01464545}, {875,0.01262727}, {880,0.01225455}, {885,0.01264545}, {890,0.01245455}, {895,0.01276364}, {900,0.01461818}, {905,0.01301818}, {910,0.01293636}, {915,0.01257273}, {920,0.01320000}, {925,0.01327273}, {930,0.01768182}, {935,0.01320000}, {940,0.01350909}, {945,0.01336364}, {950,0.01383636}, {955,0.01339091}, {960,0.01819091}, {965,0.01385455}, {970,0.01362727}, {975,0.01346364}, {980,0.01380909}, {985,0.01373636}, {990,0.01555455}, {995,0.01417273}, {1000,0.01425455}, {1010,0.01407273}, {1020,0.01413636}, {1030,0.01440000}, {1040,0.01528182}, {1050,0.01463636}, {1060,0.01504545}, {1070,0.01495455}, {1080,0.01517273}, {1090,0.01661818}, {1100,0.01531818}, {1110,0.01540000}, {1120,0.01539091}, {1130,0.01570909}, {1140,0.01804545}, {1150,0.01618182}, {1160,0.01608182}, {1170,0.01625455}, {1180,0.01593636}, {1190,0.02036364}, {1200,0.01670000}, {1210,0.01666364}, {1220,0.01692727}, {1230,0.01697273}, {1240,0.01790000}, {1250,0.01724545}, {1260,0.01751818}, {1270,0.01765455}, {1280,0.02184545}, {1290,0.01800909}, {1300,0.01808182}, {1310,0.01827273}, {1320,0.01816364}, {1330,0.01960909}, {1340,0.01857273}, {1350,0.01860000}, {1360,0.01880000}, {1370,0.02181818}, {1380,0.01917273}, {1390,0.01903636}, {1400,0.01942727}, {1410,0.02278182}, {1420,0.01961818}, {1430,0.02009091}, {1440,0.02015455}, {1450,0.02340909}, {1460,0.02034545}, {1470,0.02059091}, {1480,0.02073636}, {1490,0.02643636}, {1500,0.02131818}, {1510,0.02126364}, {1520,0.02187273}, {1530,0.02405455}, {1540,0.02179091}, {1550,0.02200909}, {1560,0.02253636}, {1570,0.02210000}, {1580,0.02258182}, {1590,0.02262727}, {1600,0.02837273}, {1610,0.02308182}, {1620,0.02310000}, {1630,0.02344545}, {1640,0.02582727}, {1650,0.02350909}, {1660,0.02374545}, {1670,0.02809091}, {1680,0.02410000}, {1690,0.02401818}, {1700,0.02461818}, {1710,0.02738182}, {1720,0.02490000}, {1730,0.02478182}, {1740,0.02720909}, {1750,0.02532727}, {1760,0.02519091}, {1770,0.02847273}, {1780,0.02560000}, {1790,0.02566364}, {1800,0.02602727}, {1810,0.02587273}, {1820,0.02630909}, {1830,0.02631818}, {1840,0.02899091}, {1850,0.02665455}, {1860,0.02708182}, {1870,0.03158182}, {1880,0.02727273}, {1890,0.02758182}, {1900,0.03112727}, {1910,0.02775455}, {1920,0.02822727}, {1930,0.03065455}, {1940,0.02857273}, {1950,0.02891818}, {1960,0.03127273}, {1970,0.02898182}, {1980,0.02895455}, {1990,0.03183636}, {2000,0.02949091}, {2050,0.03023636}, {2100,0.03475455}, {2150,0.03211818}, {2200,0.04049091}, {2250,0.03410000}, {2300,0.03485455}, {2350,0.03871818}, {2400,0.03701818}, {2450,0.04867273}, {2500,0.03862727}, {2550,0.03918182}, {2600,0.04308182}, {2650,0.04097273}, {2700,0.04757273}, {2750,0.04255455}, {2800,0.05104545}, {2850,0.04489091}, {2900,0.06055455}, {2950,0.04640909}, {3000,0.05961818}, {3050,0.04819091}, {3100,0.05846364}, {3150,0.05026364}, {3200,0.06108182}, {3250,0.05174545}, {3300,0.05555455}, {3350,0.06263636}, {3400,0.05468182}, {3450,0.07161818}, {3500,0.05666364}, {3550,0.06286364}, {3600,0.05893636}, {3650,0.05882727}, {3700,0.07394545}, {3750,0.06162727}, {3800,0.06822727}, {3850,0.07277273}, {3900,0.06457273}, {3950,0.06906364}, {4000,0.08139091}, {4050,0.06690000}, {4100,0.07096364}, {4150,0.08058182}, {4200,0.07046364}, {4250,0.07040000}, {4300,0.07866364}, {4350,0.07878182}, {4400,0.07436364}, {4450,0.07758182}, {4500,0.08012727}, {4550,0.09657273}, {4600,0.07838182}, {4650,0.07998182}, {4700,0.09571818}, {4750,0.09466364}, {4800,0.10534545}, {4850,0.09711818}, {4900,0.08501818}, {4950,0.08842727}, {5000,0.09624545}, {5050,0.09980000}, {5100,0.11349091}, {5150,0.10363636}, {5200,0.09172727}, {5250,0.09227273}, {5300,0.09632727}, {5350,0.09930909}, {5400,0.11527273}, {5450,0.10750000}, {5500,0.10424545}, {5550,0.11210909}, {5600,0.13047273}, {5650,0.13054545}, {5700,0.12065455}, {5750,0.11187273}, {5800,0.10671818}, {5850,0.10650000}, {5900,0.10815455}, {5950,0.10818182}, {6000,0.10612727}, {6050,0.11505455}, {6100,0.13404545}, {6150,0.14161818}, {6200,0.13690000}, {6250,0.13842727}, {6300,0.13830000}, {6350,0.13991818}, {6400,0.12641818}, {6450,0.13899091}, {6500,0.13538182}, {6550,0.13450909}, {6600,0.13597273}, {6650,0.13313636}, {6700,0.14602727}, {6750,0.15044545}, {6800,0.14525455}, {6850,0.14564545}, {6900,0.14165455}, {6950,0.14005455}, {7000,0.13068182}, {7050,0.15521818}, {7100,0.15208182}, {7150,0.14830909}, {7200,0.15392727}, {7250,0.15264545}, {7300,0.16198182}, {7350,0.17073636}, {7400,0.16294545}, {7450,0.14358182}, {7500,0.16010909}, {7550,0.17749091}, {7600,0.16719091}, {7650,0.17847273}, {7700,0.15637273}, {7750,0.16546364}, {7800,0.15967273}, {7850,0.16623636}, {7900,0.16253636}, {7950,0.15795455}, {8000,0.16696364}, {8050,0.17927273}, {8100,0.19248182}, {8150,0.16404545}, {8200,0.17096364}, {8250,0.18241818}, {8300,0.19497273}, {8350,0.17934545}, {8400,0.17960909}, {8450,0.17348182}, {8500,0.18313636}, {8550,0.21101818}, {8600,0.19509091}, {8650,0.19918182}, {8700,0.20471818}, {8750,0.18881818}, {8800,0.19494545}, {8850,0.19110909}, {8900,0.19768182}, {8950,0.18928182}, {9000,0.19647273}, {9050,0.20158182}, {9100,0.21740000}, {9150,0.22194545}, {9200,0.20712727}, {9250,0.22403636}, {9300,0.19980909}, {9350,0.21057273}, {9400,0.19118182}, {9450,0.20536364}, {9500,0.22523636}, {9550,0.21079091}, {9600,0.21281818}, {9650,0.20092727}, {9700,0.23602727}, {9750,0.23064545}, {9800,0.20144545}, {9850,0.23007273}, {9900,0.24134545}, {9950,0.20831818}, {10000,0.24736364}, {10100,0.23383636}, {10200,0.21252727}, {10300,0.23618182}, {10400,0.23390909}, {10500,0.26110000}, {10600,0.21827273}, {10700,0.23204545}, {10800,0.27102727}, {10900,0.23259091}, {11000,0.26084545}, {11100,0.25897273}, {11200,0.24003636}, {11300,0.23580909}, {11400,0.25324545}, {11500,0.25037273}, {11600,0.28378182}, {11700,0.27796364}, {11800,0.26985455}, {11900,0.28131818}, {12000,0.28153636}, {12100,0.28229091}, {12200,0.27983636}, {12300,0.29115455}, {12400,0.30715455}, {12500,0.26910000}, {12600,0.26754545}, {12700,0.29384545}, {12800,0.29289091}, {12900,0.31391818}, {13000,0.29134545}, {13100,0.28464545}, {13200,0.27808182}, {13300,0.30815455}, {13400,0.31980909}, {13500,0.35133636}, {13600,0.29270000}, {13700,0.32832727}, {13800,0.31372727}, {13900,0.29023636}, {14000,0.33814545}, {14100,0.36675455}, {14200,0.30287273}, {14300,0.34588182}, {14400,0.30648182}, {14500,0.35491818}, {14600,0.35164545}, {14700,0.35036364}, {14800,0.36226364}, {14900,0.34371818}, {15000,3.85443636}, {15100,0.43119091}, {15200,0.32817273}, {15300,0.40146364}, {15400,0.31540000}, {15500,0.39074545}, {15600,0.34495455}, {15700,0.39543636}, {15800,0.39843636}, {15900,0.33448182}, {16000,0.38647273}, {16100,0.41574545}, {16200,0.39960909}, {16300,0.33510909}, {16400,0.41040000}, {16500,0.43023636}, {16600,0.39662727}, {16700,0.31085455}, {16800,0.34679091}, {16900,0.42214545}, {17000,0.44728182}, {17100,0.45220000}, {17200,0.44590909}, {17300,0.41682727}, {17400,0.35930909}, {17500,0.33203636}, {17600,0.32257273}, {17700,0.33483636}, {17800,0.32951818}, {17900,0.35003636}, {18000,0.34620000}, {18100,0.32546364}, {18200,0.34426364}, {18300,0.44030909}, {18400,0.42270909}, {18500,0.49560000}, {18600,0.51323636}, {18700,0.50908182}, {18800,0.46430909}, {18900,0.38113636}, {19000,0.38664545}, {19100,0.49792727}, {19200,0.51528182}, {19300,0.48735455}, {19400,0.37586364}, {19500,0.51722727}, {19600,0.53340909}, {19700,0.40772727}, {19800,0.42330909}, {19900,0.55607273}, {20000,0.40400000}};
data["big_flat"]["QuoteFlat"]["Aggregate"]["system"] = {{1,0.00028182}, {2,0.00060000}, {3,0.00018182}, {4,0.00000000}, {5,0.00002727}, {6,0.00010909}, {7,0.00003636}, {8,0.00002727}, {9,0.00000000}, {10,0.00000000}, {11,0.00003636}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00007273}, {18,0.00000000}, {19,0.00003636}, {20,0.00007273}, {21,0.00000000}, {22,0.00003636}, {23,0.00002727}, {24,0.00000000}, {25,0.00006364}, {26,0.00003636}, {27,0.00003636}, {28,0.00003636}, {29,0.00003636}, {30,0.00003636}, {31,0.00000000}, {32,0.00003636}, {33,0.00003636}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00007273}, {38,0.00007273}, {39,0.00038182}, {40,0.00000000}, {41,0.00007273}, {42,0.00007273}, {43,0.00000000}, {44,0.00007273}, {45,0.00000000}, {46,0.00000000}, {47,0.00007273}, {48,0.00003636}, {49,0.00003636}, {50,0.00003636}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00006364}, {55,0.00003636}, {56,0.00000000}, {57,0.00000000}, {58,0.00007273}, {59,0.00014545}, {60,0.00003636}, {61,0.00007273}, {62,0.00006364}, {63,0.00003636}, {64,0.00000000}, {65,0.00007273}, {66,0.00000000}, {67,0.00007273}, {68,0.00000000}, {69,0.00000000}, {70,0.00003636}, {71,0.00002727}, {72,0.00003636}, {73,0.00000000}, {74,0.00003636}, {75,0.00003636}, {76,0.00006364}, {77,0.00000000}, {78,0.00000000}, {79,0.00002727}, {80,0.00003636}, {81,0.00000000}, {82,0.00003636}, {83,0.00000000}, {84,0.00000000}, {85,0.00003636}, {86,0.00000000}, {87,0.00003636}, {88,0.00003636}, {89,0.00009091}, {90,0.00010909}, {91,0.00007273}, {92,0.00000000}, {93,0.00010000}, {94,0.00000000}, {95,0.00000000}, {96,0.00010909}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00003636}, {101,0.00007273}, {102,0.00000000}, {103,0.00000000}, {104,0.00007273}, {105,0.00000000}, {106,0.00000000}, {107,0.00003636}, {108,0.00007273}, {109,0.00000000}, {110,0.00010000}, {111,0.00010000}, {112,0.00003636}, {113,0.00000000}, {114,0.00010909}, {115,0.00003636}, {116,0.00000000}, {117,0.00000000}, {118,0.00010000}, {119,0.00007273}, {120,0.00000000}, {121,0.00000000}, {122,0.00003636}, {123,0.00003636}, {124,0.00000000}, {125,0.00003636}, {126,0.00000000}, {127,0.00006364}, {128,0.00003636}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00003636}, {135,0.00003636}, {136,0.00000000}, {137,0.00007273}, {138,0.00000000}, {139,0.00000000}, {140,0.00003636}, {141,0.00010909}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00010000}, {146,0.00007273}, {147,0.00000000}, {148,0.00003636}, {149,0.00000000}, {150,0.00003636}, {151,0.00007273}, {152,0.00010909}, {153,0.00000000}, {154,0.00003636}, {155,0.00003636}, {156,0.00000000}, {157,0.00010000}, {158,0.00000000}, {159,0.00007273}, {160,0.00003636}, {161,0.00000000}, {162,0.00014545}, {163,0.00010000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00003636}, {168,0.00006364}, {169,0.00003636}, {170,0.00000000}, {171,0.00006364}, {172,0.00002727}, {173,0.00007273}, {174,0.00007273}, {175,0.00000000}, {176,0.00006364}, {177,0.00003636}, {178,0.00000000}, {179,0.00007273}, {180,0.00003636}, {181,0.00010000}, {182,0.00007273}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00003636}, {187,0.00006364}, {188,0.00014545}, {189,0.00007273}, {190,0.00000000}, {191,0.00003636}, {192,0.00007273}, {193,0.00007273}, {194,0.00003636}, {195,0.00003636}, {196,0.00003636}, {197,0.00007273}, {198,0.00003636}, {199,0.00003636}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00007273}, {204,0.00000000}, {205,0.00007273}, {206,0.00007273}, {207,0.00000000}, {208,0.00003636}, {209,0.00003636}, {210,0.00000000}, {211,0.00007273}, {212,0.00003636}, {213,0.00000000}, {214,0.00009091}, {215,0.00006364}, {216,0.00003636}, {217,0.00002727}, {218,0.00007273}, {219,0.00003636}, {220,0.00003636}, {221,0.00000000}, {222,0.00010000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00003636}, {228,0.00000000}, {229,0.00010000}, {230,0.00000000}, {231,0.00010909}, {232,0.00003636}, {233,0.00007273}, {234,0.00003636}, {235,0.00003636}, {236,0.00010909}, {237,0.00000000}, {238,0.00007273}, {239,0.00010909}, {240,0.00003636}, {241,0.00010000}, {242,0.00007273}, {243,0.00003636}, {244,0.00003636}, {245,0.00000000}, {246,0.00007273}, {247,0.00003636}, {248,0.00000000}, {249,0.00003636}, {250,0.00000000}, {251,0.00000000}, {252,0.00007273}, {253,0.00003636}, {254,0.00003636}, {255,0.00002727}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00007273}, {264,0.00003636}, {265,0.00007273}, {266,0.00007273}, {267,0.00007273}, {268,0.00000000}, {269,0.00007273}, {270,0.00006364}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00007273}, {276,0.00002727}, {277,0.00002727}, {278,0.00002727}, {279,0.00002727}, {280,0.00000000}, {281,0.00003636}, {282,0.00000000}, {283,0.00003636}, {284,0.00003636}, {285,0.00003636}, {286,0.00006364}, {287,0.00000000}, {288,0.00005455}, {289,0.00006364}, {290,0.00006364}, {291,0.00000000}, {292,0.00000000}, {293,0.00003636}, {294,0.00000000}, {295,0.00003636}, {296,0.00003636}, {297,0.00003636}, {298,0.00007273}, {299,0.00007273}, {300,0.00010000}, {301,0.00003636}, {302,0.00003636}, {303,0.00007273}, {304,0.00003636}, {305,0.00003636}, {306,0.00003636}, {307,0.00003636}, {308,0.00007273}, {309,0.00003636}, {310,0.00010000}, {311,0.00003636}, {312,0.00007273}, {313,0.00007273}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00002727}, {318,0.00000000}, {319,0.00007273}, {320,0.00007273}, {321,0.00010909}, {322,0.00002727}, {323,0.00006364}, {324,0.00003636}, {325,0.00003636}, {326,0.00006364}, {327,0.00003636}, {328,0.00006364}, {329,0.00010909}, {330,0.00003636}, {331,0.00003636}, {332,0.00010000}, {333,0.00003636}, {334,0.00003636}, {335,0.00000000}, {336,0.00000000}, {337,0.00003636}, {338,0.00000000}, {339,0.00007273}, {340,0.00018182}, {341,0.00002727}, {342,0.00010909}, {343,0.00003636}, {344,0.00000000}, {345,0.00007273}, {346,0.00000000}, {347,0.00007273}, {348,0.00000000}, {349,0.00000000}, {350,0.00003636}, {351,0.00000000}, {352,0.00000000}, {353,0.00010909}, {354,0.00000000}, {355,0.00006364}, {356,0.00012727}, {357,0.00003636}, {358,0.00003636}, {359,0.00002727}, {360,0.00006364}, {361,0.00007273}, {362,0.00000000}, {363,0.00003636}, {364,0.00003636}, {365,0.00003636}, {366,0.00007273}, {367,0.00007273}, {368,0.00007273}, {369,0.00000000}, {370,0.00007273}, {371,0.00003636}, {372,0.00020909}, {373,0.00000000}, {374,0.00003636}, {375,0.00007273}, {376,0.00014545}, {377,0.00000000}, {378,0.00003636}, {379,0.00003636}, {380,0.00003636}, {381,0.00018182}, {382,0.00007273}, {383,0.00002727}, {384,0.00003636}, {385,0.00002727}, {386,0.00000000}, {387,0.00000000}, {388,0.00007273}, {389,0.00010000}, {390,0.00009091}, {391,0.00007273}, {392,0.00002727}, {393,0.00003636}, {394,0.00000000}, {395,0.00010909}, {396,0.00018182}, {397,0.00003636}, {398,0.00000000}, {399,0.00010909}, {400,0.00007273}, {401,0.00003636}, {402,0.00003636}, {403,0.00010000}, {404,0.00007273}, {405,0.00003636}, {406,0.00010909}, {407,0.00007273}, {408,0.00000000}, {409,0.00007273}, {410,0.00013636}, {411,0.00003636}, {412,0.00010909}, {413,0.00010909}, {414,0.00003636}, {415,0.00003636}, {416,0.00010000}, {417,0.00000000}, {418,0.00010909}, {419,0.00007273}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00014545}, {424,0.00000000}, {425,0.00007273}, {426,0.00003636}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00006364}, {431,0.00003636}, {432,0.00014545}, {433,0.00010000}, {434,0.00014545}, {435,0.00003636}, {436,0.00010909}, {437,0.00003636}, {438,0.00010909}, {439,0.00003636}, {440,0.00007273}, {441,0.00018182}, {442,0.00010909}, {443,0.00000000}, {444,0.00003636}, {445,0.00003636}, {446,0.00003636}, {447,0.00003636}, {448,0.00000000}, {449,0.00003636}, {450,0.00007273}, {451,0.00010000}, {452,0.00014545}, {453,0.00010909}, {454,0.00010000}, {455,0.00006364}, {456,0.00010000}, {457,0.00003636}, {458,0.00007273}, {459,0.00010909}, {460,0.00002727}, {461,0.00014545}, {462,0.00000000}, {463,0.00000000}, {464,0.00007273}, {465,0.00013636}, {466,0.00003636}, {467,0.00003636}, {468,0.00014545}, {469,0.00003636}, {470,0.00007273}, {471,0.00007273}, {472,0.00003636}, {473,0.00007273}, {474,0.00009091}, {475,0.00013636}, {476,0.00000000}, {477,0.00003636}, {478,0.00010909}, {479,0.00006364}, {480,0.00007273}, {481,0.00002727}, {482,0.00003636}, {483,0.00017273}, {484,0.00010909}, {485,0.00010909}, {486,0.00014545}, {487,0.00007273}, {488,0.00010909}, {489,0.00000000}, {490,0.00010909}, {491,0.00003636}, {492,0.00007273}, {493,0.00003636}, {494,0.00014545}, {495,0.00007273}, {496,0.00007273}, {497,0.00015455}, {498,0.00003636}, {499,0.00007273}, {500,0.00010000}, {505,0.00018182}, {510,0.00006364}, {515,0.00010000}, {520,0.00007273}, {525,0.00010909}, {530,0.00000000}, {535,0.00006364}, {540,0.00000000}, {545,0.00012727}, {550,0.00006364}, {555,0.00010000}, {560,0.00002727}, {565,0.00007273}, {570,0.00007273}, {575,0.00007273}, {580,0.00003636}, {585,0.00010000}, {590,0.00002727}, {595,0.00007273}, {600,0.00007273}, {605,0.00000000}, {610,0.00010909}, {615,0.00003636}, {620,0.00007273}, {625,0.00007273}, {630,0.00007273}, {635,0.00003636}, {640,0.00007273}, {645,0.00003636}, {650,0.00000000}, {655,0.00000000}, {660,0.00003636}, {665,0.00010909}, {670,0.00024545}, {675,0.00000000}, {680,0.00003636}, {685,0.00010000}, {690,0.00025455}, {695,0.00003636}, {700,0.00003636}, {705,0.00007273}, {710,0.00009091}, {715,0.00003636}, {720,0.00015455}, {725,0.00000000}, {730,0.00007273}, {735,0.00007273}, {740,0.00010909}, {745,0.00012727}, {750,0.00010909}, {755,0.00007273}, {760,0.00014545}, {765,0.00013636}, {770,0.00003636}, {775,0.00021818}, {780,0.00003636}, {785,0.00007273}, {790,0.00010909}, {795,0.00007273}, {800,0.00014545}, {805,0.00003636}, {810,0.00010909}, {815,0.00003636}, {820,0.00003636}, {825,0.00014545}, {830,0.00003636}, {835,0.00003636}, {840,0.00010909}, {845,0.00014545}, {850,0.00007273}, {855,0.00003636}, {860,0.00013636}, {865,0.00000000}, {870,0.00007273}, {875,0.00003636}, {880,0.00002727}, {885,0.00010909}, {890,0.00010909}, {895,0.00003636}, {900,0.00018182}, {905,0.00007273}, {910,0.00003636}, {915,0.00018182}, {920,0.00012727}, {925,0.00007273}, {930,0.00007273}, {935,0.00000000}, {940,0.00010000}, {945,0.00014545}, {950,0.00007273}, {955,0.00014545}, {960,0.00006364}, {965,0.00010909}, {970,0.00010000}, {975,0.00010000}, {980,0.00007273}, {985,0.00007273}, {990,0.00010909}, {995,0.00010909}, {1000,0.00003636}, {1010,0.00010909}, {1020,0.00010000}, {1030,0.00014545}, {1040,0.00003636}, {1050,0.00014545}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00003636}, {1090,0.00003636}, {1100,0.00006364}, {1110,0.00007273}, {1120,0.00003636}, {1130,0.00007273}, {1140,0.00020909}, {1150,0.00000000}, {1160,0.00003636}, {1170,0.00010909}, {1180,0.00018182}, {1190,0.00014545}, {1200,0.00003636}, {1210,0.00014545}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00010909}, {1250,0.00003636}, {1260,0.00003636}, {1270,0.00007273}, {1280,0.00017273}, {1290,0.00000000}, {1300,0.00007273}, {1310,0.00010000}, {1320,0.00010000}, {1330,0.00025455}, {1340,0.00007273}, {1350,0.00010909}, {1360,0.00010000}, {1370,0.00013636}, {1380,0.00017273}, {1390,0.00017273}, {1400,0.00010909}, {1410,0.00007273}, {1420,0.00010909}, {1430,0.00007273}, {1440,0.00020909}, {1450,0.00003636}, {1460,0.00013636}, {1470,0.00007273}, {1480,0.00007273}, {1490,0.00034545}, {1500,0.00003636}, {1510,0.00003636}, {1520,0.00000000}, {1530,0.00010909}, {1540,0.00017273}, {1550,0.00002727}, {1560,0.00010909}, {1570,0.00014545}, {1580,0.00007273}, {1590,0.00000000}, {1600,0.00017273}, {1610,0.00003636}, {1620,0.00002727}, {1630,0.00013636}, {1640,0.00021818}, {1650,0.00007273}, {1660,0.00002727}, {1670,0.00021818}, {1680,0.00010000}, {1690,0.00016364}, {1700,0.00006364}, {1710,0.00003636}, {1720,0.00007273}, {1730,0.00010909}, {1740,0.00017273}, {1750,0.00013636}, {1760,0.00000000}, {1770,0.00020000}, {1780,0.00003636}, {1790,0.00014545}, {1800,0.00000000}, {1810,0.00006364}, {1820,0.00007273}, {1830,0.00010909}, {1840,0.00021818}, {1850,0.00014545}, {1860,0.00013636}, {1870,0.00002727}, {1880,0.00006364}, {1890,0.00018182}, {1900,0.00018182}, {1910,0.00000000}, {1920,0.00010909}, {1930,0.00017273}, {1940,0.00010909}, {1950,0.00014545}, {1960,0.00013636}, {1970,0.00007273}, {1980,0.00014545}, {1990,0.00021818}, {2000,0.00007273}, {2050,0.00007273}, {2100,0.00021818}, {2150,0.00014545}, {2200,0.00018182}, {2250,0.00013636}, {2300,0.00017273}, {2350,0.00018182}, {2400,0.00007273}, {2450,0.00014545}, {2500,0.00003636}, {2550,0.00014545}, {2600,0.00025455}, {2650,0.00010909}, {2700,0.00025455}, {2750,0.00010000}, {2800,0.00025455}, {2850,0.00007273}, {2900,0.00030909}, {2950,0.00010909}, {3000,0.00043636}, {3050,0.00014545}, {3100,0.00030909}, {3150,0.00010909}, {3200,0.00034545}, {3250,0.00017273}, {3300,0.00024545}, {3350,0.00027273}, {3400,0.00014545}, {3450,0.00035455}, {3500,0.00014545}, {3550,0.00007273}, {3600,0.00003636}, {3650,0.00010909}, {3700,0.00020909}, {3750,0.00007273}, {3800,0.00035455}, {3850,0.00024545}, {3900,0.00017273}, {3950,0.00010909}, {4000,0.00024545}, {4050,0.00023636}, {4100,0.00038182}, {4150,0.00026364}, {4200,0.00003636}, {4250,0.00018182}, {4300,0.00021818}, {4350,0.00034545}, {4400,0.00014545}, {4450,0.00010909}, {4500,0.00032727}, {4550,0.00025455}, {4600,0.00006364}, {4650,0.00024545}, {4700,0.00047273}, {4750,0.00045455}, {4800,0.00208182}, {4850,0.00052727}, {4900,0.00021818}, {4950,0.00024545}, {5000,0.00040000}, {5050,0.00040909}, {5100,0.00035455}, {5150,0.00024545}, {5200,0.00017273}, {5250,0.00007273}, {5300,0.00009091}, {5350,0.00039091}, {5400,0.00029091}, {5450,0.00025455}, {5500,0.00040000}, {5550,0.00040909}, {5600,0.00064545}, {5650,0.00083636}, {5700,0.00032727}, {5750,0.00021818}, {5800,0.00034545}, {5850,0.00038182}, {5900,0.00024545}, {5950,0.00046364}, {6000,0.00044545}, {6050,0.00043636}, {6100,0.00057273}, {6150,0.00070909}, {6200,0.00063636}, {6250,0.00029091}, {6300,0.00050000}, {6350,0.00086364}, {6400,0.00023636}, {6450,0.00047273}, {6500,0.00053636}, {6550,0.00040000}, {6600,0.00049091}, {6650,0.00034545}, {6700,0.00065455}, {6750,0.00064545}, {6800,0.00060000}, {6850,0.00052727}, {6900,0.00040000}, {6950,0.00049091}, {7000,0.00038182}, {7050,0.00052727}, {7100,0.00088182}, {7150,0.00029091}, {7200,0.00072727}, {7250,0.00044545}, {7300,0.00053636}, {7350,0.00071818}, {7400,0.00064545}, {7450,0.00107273}, {7500,0.00029091}, {7550,0.00100909}, {7600,0.00060909}, {7650,0.00075455}, {7700,0.00042727}, {7750,0.00018182}, {7800,0.00030909}, {7850,0.00071818}, {7900,0.00046364}, {7950,0.00064545}, {8000,0.00053636}, {8050,0.00100000}, {8100,0.00069091}, {8150,0.00053636}, {8200,0.00045455}, {8250,0.00069091}, {8300,0.00089091}, {8350,0.00033636}, {8400,0.00086364}, {8450,0.00043636}, {8500,0.00050909}, {8550,0.00096364}, {8600,0.00069091}, {8650,0.00096364}, {8700,0.00109091}, {8750,0.00031818}, {8800,0.00046364}, {8850,0.00047273}, {8900,0.00095455}, {8950,0.00066364}, {9000,0.00060000}, {9050,0.00084545}, {9100,0.00093636}, {9150,0.00138182}, {9200,0.00076364}, {9250,0.00096364}, {9300,0.00021818}, {9350,0.00029091}, {9400,0.00013636}, {9450,0.00003636}, {9500,0.00010909}, {9550,0.00018182}, {9600,0.00003636}, {9650,0.00003636}, {9700,0.00010909}, {9750,0.00018182}, {9800,0.00003636}, {9850,0.00007273}, {9900,0.00014545}, {9950,0.00014545}, {10000,0.00093636}, {10100,0.00097273}, {10200,0.00037273}, {10300,0.00096364}, {10400,0.00080909}, {10500,0.00190909}, {10600,0.00041818}, {10700,0.00060000}, {10800,0.00106364}, {10900,0.00091818}, {11000,0.00132727}, {11100,0.00143636}, {11200,0.00092727}, {11300,0.00054545}, {11400,0.00071818}, {11500,0.00087273}, {11600,0.00149091}, {11700,0.00130909}, {11800,0.00116364}, {11900,0.00100000}, {12000,0.00114545}, {12100,0.00075455}, {12200,0.00118182}, {12300,0.00110909}, {12400,0.00148182}, {12500,0.00107273}, {12600,0.00099091}, {12700,0.00050909}, {12800,0.00014545}, {12900,0.00007273}, {13000,0.00007273}, {13100,0.00003636}, {13200,0.00017273}, {13300,0.00021818}, {13400,0.00021818}, {13500,0.00018182}, {13600,0.00025455}, {13700,0.00017273}, {13800,0.00031818}, {13900,0.00007273}, {14000,0.00021818}, {14100,0.00018182}, {14200,0.00014545}, {14300,0.00014545}, {14400,0.00020909}, {14500,0.00032727}, {14600,0.00021818}, {14700,0.00010909}, {14800,0.00021818}, {14900,0.00010909}, {15000,0.00356364}, {15100,0.00045455}, {15200,0.00007273}, {15300,0.00035455}, {15400,0.00014545}, {15500,0.00036364}, {15600,0.00028182}, {15700,0.00014545}, {15800,0.00025455}, {15900,0.00014545}, {16000,0.00020909}, {16100,0.00010909}, {16200,0.00018182}, {16300,0.00018182}, {16400,0.00007273}, {16500,0.00028182}, {16600,0.00013636}, {16700,0.00010909}, {16800,0.00010909}, {16900,0.00020909}, {17000,0.00017273}, {17100,0.00002727}, {17200,0.00039091}, {17300,0.00010909}, {17400,0.00003636}, {17500,0.00014545}, {17600,0.00029091}, {17700,0.00010909}, {17800,0.00007273}, {17900,0.00010909}, {18000,0.00029091}, {18100,0.00010909}, {18200,0.00010909}, {18300,0.00025455}, {18400,0.00014545}, {18500,0.00010909}, {18600,0.00018182}, {18700,0.00003636}, {18800,0.00017273}, {18900,0.00003636}, {19000,0.00024545}, {19100,0.00021818}, {19200,0.00031818}, {19300,0.00023636}, {19400,0.00018182}, {19500,0.00025455}, {19600,0.00086364}, {19700,0.00078182}, {19800,0.00052727}, {19900,0.00210000}, {20000,0.00068519}};
data["big_flat"]["QuoteFlat"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00029091}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00098182}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00098182}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00001818}, {321,0.00100000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000909}, {590,0.00000909}, {595,0.00001818}, {600,0.00001818}, {605,0.00002727}, {610,0.00003636}, {615,0.00009091}, {620,0.00008182}, {625,0.00011818}, {630,0.00012727}, {635,0.00028182}, {640,0.00033636}, {645,0.00048182}, {650,0.00062727}, {655,0.00075455}, {660,0.00081818}, {665,0.00089091}, {670,0.00093636}, {675,0.00096364}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00100000}, {830,0.00100000}, {835,0.00100000}, {840,0.00100000}, {845,0.00100000}, {850,0.00100000}, {855,0.00100000}, {860,0.00100000}, {865,0.00100000}, {870,0.00100000}, {875,0.00100000}, {880,0.00100000}, {885,0.00100000}, {890,0.00100000}, {895,0.00100000}, {900,0.00100000}, {905,0.00100000}, {910,0.00100000}, {915,0.00100000}, {920,0.00100000}, {925,0.00100000}, {930,0.00100000}, {935,0.00100000}, {940,0.00100000}, {945,0.00100000}, {950,0.00100000}, {955,0.00100000}, {960,0.00100000}, {965,0.00100000}, {970,0.00100000}, {975,0.00100000}, {980,0.00100000}, {985,0.00100000}, {990,0.00297273}, {995,0.00100000}, {1000,0.00100000}, {1010,0.00100000}, {1020,0.00100000}, {1030,0.00100000}, {1040,0.00100000}, {1050,0.00100000}, {1060,0.00100000}, {1070,0.00100000}, {1080,0.00100909}, {1090,0.00298182}, {1100,0.00100000}, {1110,0.00100909}, {1120,0.00102727}, {1130,0.00102727}, {1140,0.00100909}, {1150,0.00103636}, {1160,0.00101818}, {1170,0.00105455}, {1180,0.00105455}, {1190,0.00577273}, {1200,0.00110909}, {1210,0.00118182}, {1220,0.00124545}, {1230,0.00126364}, {1240,0.00131818}, {1250,0.00148182}, {1260,0.00146364}, {1270,0.00159091}, {1280,0.00170000}, {1290,0.00177273}, {1300,0.00181818}, {1310,0.00180909}, {1320,0.00177273}, {1330,0.00182727}, {1340,0.00193636}, {1350,0.00195455}, {1360,0.00196364}, {1370,0.00197273}, {1380,0.00198182}, {1390,0.00199091}, {1400,0.00200000}, {1410,0.00199091}, {1420,0.00200000}, {1430,0.00200909}, {1440,0.00200000}, {1450,0.00200000}, {1460,0.00200000}, {1470,0.00200000}, {1480,0.00200000}, {1490,0.00776364}, {1500,0.00200000}, {1510,0.00200000}, {1520,0.00200000}, {1530,0.00200000}, {1540,0.00200000}, {1550,0.00200909}, {1560,0.00200000}, {1570,0.00201818}, {1580,0.00200000}, {1590,0.00200909}, {1600,0.00200909}, {1610,0.00200909}, {1620,0.00204545}, {1630,0.00200909}, {1640,0.00201818}, {1650,0.00203636}, {1660,0.00205455}, {1670,0.00214545}, {1680,0.00214545}, {1690,0.00215455}, {1700,0.00217273}, {1710,0.00219091}, {1720,0.00225455}, {1730,0.00230000}, {1740,0.00540000}, {1750,0.00241818}, {1760,0.00247273}, {1770,0.00246364}, {1780,0.00248182}, {1790,0.00260000}, {1800,0.00262727}, {1810,0.00264545}, {1820,0.00274545}, {1830,0.00277273}, {1840,0.00267273}, {1850,0.00281818}, {1860,0.00283636}, {1870,0.00284545}, {1880,0.00289091}, {1890,0.00293636}, {1900,0.00673636}, {1910,0.00293636}, {1920,0.00292727}, {1930,0.00552727}, {1940,0.00299091}, {1950,0.00299091}, {1960,0.00559091}, {1970,0.00299091}, {1980,0.00300000}, {1990,0.00299091}, {2000,0.00299091}, {2050,0.00300909}, {2100,0.00304545}, {2150,0.00309091}, {2200,0.00312727}, {2250,0.00331818}, {2300,0.00354545}, {2350,0.00376364}, {2400,0.00382727}, {2450,0.00392727}, {2500,0.00400909}, {2550,0.00401818}, {2600,0.00403636}, {2650,0.00405455}, {2700,0.01076364}, {2750,0.00426364}, {2800,0.00450909}, {2850,0.00461818}, {2900,0.00476364}, {2950,0.00479091}, {3000,0.00513636}, {3050,0.00491818}, {3100,0.00503636}, {3150,0.00512727}, {3200,0.00473636}, {3250,0.00523636}, {3300,0.00537273}, {3350,0.00558182}, {3400,0.00566364}, {3450,0.00577273}, {3500,0.00582727}, {3550,0.00590000}, {3600,0.00605455}, {3650,0.00612727}, {3700,0.00620909}, {3750,0.00626364}, {3800,0.00635455}, {3850,0.00654545}, {3900,0.00656364}, {3950,0.00670000}, {4000,0.00680909}, {4050,0.00685455}, {4100,0.00694545}, {4150,0.00711818}, {4200,0.00717273}, {4250,0.00728182}, {4300,0.00718182}, {4350,0.00752727}, {4400,0.00758182}, {4450,0.00770000}, {4500,0.00608182}, {4550,0.00781818}, {4600,0.00791818}, {4650,0.00809091}, {4700,0.00820909}, {4750,0.00845455}, {4800,0.00840000}, {4850,0.00858182}, {4900,0.00862727}, {4950,0.00869091}, {5000,0.00877273}, {5050,0.00910000}, {5100,0.00894545}, {5150,0.00902727}, {5200,0.00920909}, {5250,0.00927273}, {5300,0.00951818}, {5350,0.00955455}, {5400,0.00968182}, {5450,0.00779091}, {5500,0.01879091}, {5550,0.00995455}, {5600,0.00984545}, {5650,0.00999091}, {5700,0.01020000}, {5750,0.01031818}, {5800,0.01053636}, {5850,0.01060909}, {5900,0.01065455}, {5950,0.01071818}, {6000,0.01072727}, {6050,0.01080000}, {6100,0.01084545}, {6150,0.01096364}, {6200,0.01107273}, {6250,0.01121818}, {6300,0.01194545}, {6350,0.03663636}, {6400,0.01096364}, {6450,0.01170909}, {6500,0.01174545}, {6550,0.01179091}, {6600,0.01185455}, {6650,0.01187273}, {6700,0.01200000}, {6750,0.01221818}, {6800,0.03225455}, {6850,0.01253636}, {6900,0.01264545}, {6950,0.01268182}, {7000,0.01272727}, {7050,0.01276364}, {7100,0.03185455}, {7150,0.01288182}, {7200,0.01295455}, {7250,0.01311818}, {7300,0.01347273}, {7350,0.01335455}, {7400,0.01361818}, {7450,0.01363636}, {7500,0.01369091}, {7550,0.01370909}, {7600,0.01377273}, {7650,0.01377273}, {7700,0.02572727}, {7750,0.01396364}, {7800,0.01410000}, {7850,0.03371818}, {7900,0.01441818}, {7950,0.01453636}, {8000,0.03151818}, {8050,0.01470000}, {8100,0.01470909}, {8150,0.02330000}, {8200,0.01479091}, {8250,0.01493636}, {8300,0.01510000}, {8350,0.01519091}, {8400,0.03497273}, {8450,0.01540909}, {8500,0.01550000}, {8550,0.01568182}, {8600,0.01569091}, {8650,0.01577273}, {8700,0.01580000}, {8750,0.01592727}, {8800,0.01590000}, {8850,0.01609091}, {8900,0.01624545}, {8950,0.01638182}, {9000,0.01650909}, {9050,0.01654545}, {9100,0.01670000}, {9150,0.01670000}, {9200,0.01671818}, {9250,0.01685455}, {9300,0.01718182}, {9350,0.01701818}, {9400,0.02694545}, {9450,0.01714545}, {9500,0.01729091}, {9550,0.01736364}, {9600,0.01760000}, {9650,0.03227273}, {9700,0.01770909}, {9750,0.01779091}, {9800,0.03063636}, {9850,0.01796364}, {9900,0.01810000}, {9950,0.03571818}, {10000,0.01827273}, {10100,0.01840909}, {10200,0.03327273}, {10300,0.01879091}, {10400,0.01899091}, {10500,0.01920909}, {10600,0.03228182}, {10700,0.01950909}, {10800,0.01971818}, {10900,0.01993636}, {11000,0.02014545}, {11100,0.02029091}, {11200,0.03413636}, {11300,0.03885455}, {11400,0.02122727}, {11500,0.02100909}, {11600,0.02123636}, {11700,0.02140000}, {11800,0.02159091}, {11900,0.02179091}, {12000,0.02198182}, {12100,0.02215455}, {12200,0.02239091}, {12300,0.02247273}, {12400,0.02297273}, {12500,0.04084545}, {12600,0.01855455}, {12700,0.02332727}, {12800,0.02347273}, {12900,0.02354545}, {13000,0.02386364}, {13100,0.02454545}, {13200,0.02114545}, {13300,0.02442727}, {13400,0.02450909}, {13500,0.02516364}, {13600,0.02336364}, {13700,0.02508182}, {13800,0.02529091}, {13900,0.03932727}, {14000,0.02559091}, {14100,0.02591818}, {14200,0.02607273}, {14300,0.02626364}, {14400,0.04460000}, {14500,0.02660909}, {14600,0.02708182}, {14700,0.02690909}, {14800,0.02710909}, {14900,0.02730909}, {15000,0.02747273}, {15100,0.02731818}, {15200,0.02778182}, {15300,0.02760909}, {15400,0.04377273}, {15500,0.02794545}, {15600,0.02826364}, {15700,0.02864545}, {15800,0.02851818}, {15900,0.02872727}, {16000,0.02914545}, {16100,0.02915455}, {16200,0.02936364}, {16300,0.04447273}, {16400,0.02958182}, {16500,0.02980000}, {16600,0.03000000}, {16700,0.02419091}, {16800,0.04521818}, {16900,0.03058182}, {17000,0.03075455}, {17100,0.03097273}, {17200,0.03107273}, {17300,0.03129091}, {17400,0.02911818}, {17500,0.04004545}, {17600,0.04247273}, {17700,0.04382727}, {17800,0.03997273}, {17900,0.05180000}, {18000,0.05038182}, {18100,0.04317273}, {18200,0.03905455}, {18300,0.02974545}, {18400,0.03333636}, {18500,0.03344545}, {18600,0.03368182}, {18700,0.03391818}, {18800,0.03411818}, {18900,0.05125455}, {19000,0.04279091}, {19100,0.03471818}, {19200,0.03496364}, {19300,0.03495455}, {19400,0.04896364}, {19500,0.03534545}, {19600,0.03556364}, {19700,0.05603636}, {19800,0.03282727}, {19900,0.03610000}, {20000,0.05359259}};
data["big_flat"]["QuoteFlat"]["actual reif"]["user"] = {{1,0.00006364}, {2,0.00010909}, {3,0.00010000}, {4,0.00005455}, {5,0.00012727}, {6,0.00010909}, {7,0.00005455}, {8,0.00006364}, {9,0.00009091}, {10,0.00003636}, {11,0.00010909}, {12,0.00010000}, {13,0.00006364}, {14,0.00010000}, {15,0.00000000}, {16,0.00019091}, {17,0.00011818}, {18,0.00016364}, {19,0.00023636}, {20,0.00005455}, {21,0.00012727}, {22,0.00011818}, {23,0.00013636}, {24,0.00016364}, {25,0.00020000}, {26,0.00012727}, {27,0.00027273}, {28,0.00010000}, {29,0.00015455}, {30,0.00010000}, {31,0.00003636}, {32,0.00012727}, {33,0.00006364}, {34,0.00010909}, {35,0.00040909}, {36,0.00027273}, {37,0.00012727}, {38,0.00031818}, {39,0.00013636}, {40,0.00000000}, {41,0.00010000}, {42,0.00003636}, {43,0.00019091}, {44,0.00010000}, {45,0.00015455}, {46,0.00010000}, {47,0.00011818}, {48,0.00009091}, {49,0.00024545}, {50,0.00003636}, {51,0.00012727}, {52,0.00010000}, {53,0.00021818}, {54,0.00007273}, {55,0.00009091}, {56,0.00009091}, {57,0.00025455}, {58,0.00006364}, {59,0.00028182}, {60,0.00023636}, {61,0.00020000}, {62,0.00016364}, {63,0.00025455}, {64,0.00010909}, {65,0.00019091}, {66,0.00019091}, {67,0.00013636}, {68,0.00018182}, {69,0.00017273}, {70,0.00009091}, {71,0.00020909}, {72,0.00026364}, {73,0.00015455}, {74,0.00020909}, {75,0.00016364}, {76,0.00022727}, {77,0.00025455}, {78,0.00012727}, {79,0.00009091}, {80,0.00023636}, {81,0.00019091}, {82,0.00020000}, {83,0.00019091}, {84,0.00029091}, {85,0.00017273}, {86,0.00027273}, {87,0.00011818}, {88,0.00019091}, {89,0.00025455}, {90,0.00123636}, {91,0.00029091}, {92,0.00028182}, {93,0.00038182}, {94,0.00014545}, {95,0.00023636}, {96,0.00027273}, {97,0.00020000}, {98,0.00026364}, {99,0.00018182}, {100,0.00011818}, {101,0.00016364}, {102,0.00017273}, {103,0.00021818}, {104,0.00016364}, {105,0.00027273}, {106,0.00022727}, {107,0.00024545}, {108,0.00025455}, {109,0.00010909}, {110,0.00020909}, {111,0.00027273}, {112,0.00015455}, {113,0.00020909}, {114,0.00023636}, {115,0.00015455}, {116,0.00012727}, {117,0.00028182}, {118,0.00037273}, {119,0.00025455}, {120,0.00020000}, {121,0.00009091}, {122,0.00026364}, {123,0.00030000}, {124,0.00020000}, {125,0.00017273}, {126,0.00030000}, {127,0.00130909}, {128,0.00024545}, {129,0.00026364}, {130,0.00030909}, {131,0.00010909}, {132,0.00024545}, {133,0.00027273}, {134,0.00043636}, {135,0.00014545}, {136,0.00022727}, {137,0.00009091}, {138,0.00017273}, {139,0.00044545}, {140,0.00003636}, {141,0.00020000}, {142,0.00019091}, {143,0.00032727}, {144,0.00017273}, {145,0.00043636}, {146,0.00010000}, {147,0.00028182}, {148,0.00035455}, {149,0.00030909}, {150,0.00018182}, {151,0.00040909}, {152,0.00026364}, {153,0.00024545}, {154,0.00033636}, {155,0.00015455}, {156,0.00030000}, {157,0.00025455}, {158,0.00030000}, {159,0.00023636}, {160,0.00025455}, {161,0.00029091}, {162,0.00024545}, {163,0.00034545}, {164,0.00043636}, {165,0.00030909}, {166,0.00022727}, {167,0.00012727}, {168,0.00025455}, {169,0.00024545}, {170,0.00041818}, {171,0.00034545}, {172,0.00038182}, {173,0.00057273}, {174,0.00040909}, {175,0.00052727}, {176,0.00036364}, {177,0.00026364}, {178,0.00036364}, {179,0.00014545}, {180,0.00029091}, {181,0.00044545}, {182,0.00025455}, {183,0.00040000}, {184,0.00032727}, {185,0.00020909}, {186,0.00029091}, {187,0.00035455}, {188,0.00033636}, {189,0.00030000}, {190,0.00035455}, {191,0.00034545}, {192,0.00034545}, {193,0.00031818}, {194,0.00038182}, {195,0.00044545}, {196,0.00040909}, {197,0.00024545}, {198,0.00030000}, {199,0.00042727}, {200,0.00037273}, {201,0.00035455}, {202,0.00060000}, {203,0.00040909}, {204,0.00045455}, {205,0.00037273}, {206,0.00033636}, {207,0.00040909}, {208,0.00055455}, {209,0.00045455}, {210,0.00052727}, {211,0.00034545}, {212,0.00036364}, {213,0.00036364}, {214,0.00053636}, {215,0.00050000}, {216,0.00028182}, {217,0.00020909}, {218,0.00019091}, {219,0.00021818}, {220,0.00050909}, {221,0.00052727}, {222,0.00046364}, {223,0.00031818}, {224,0.00033636}, {225,0.00030909}, {226,0.00039091}, {227,0.00029091}, {228,0.00057273}, {229,0.00025455}, {230,0.00047273}, {231,0.00021818}, {232,0.00071818}, {233,0.00040909}, {234,0.00034545}, {235,0.00031818}, {236,0.00038182}, {237,0.00033636}, {238,0.00051818}, {239,0.00049091}, {240,0.00043636}, {241,0.00041818}, {242,0.00027273}, {243,0.00050909}, {244,0.00040909}, {245,0.00026364}, {246,0.00034545}, {247,0.00038182}, {248,0.00051818}, {249,0.00030000}, {250,0.00053636}, {251,0.00039091}, {252,0.00043636}, {253,0.00046364}, {254,0.00038182}, {255,0.00030000}, {256,0.00054545}, {257,0.00039091}, {258,0.00036364}, {259,0.00051818}, {260,0.00056364}, {261,0.00040000}, {262,0.00035455}, {263,0.00030909}, {264,0.00060909}, {265,0.00039091}, {266,0.00036364}, {267,0.00089091}, {268,0.00044545}, {269,0.00036364}, {270,0.00057273}, {271,0.00054545}, {272,0.00045455}, {273,0.00048182}, {274,0.00054545}, {275,0.00043636}, {276,0.00032727}, {277,0.00030000}, {278,0.00048182}, {279,0.00050000}, {280,0.00042727}, {281,0.00052727}, {282,0.00056364}, {283,0.00060000}, {284,0.00050909}, {285,0.00060000}, {286,0.00045455}, {287,0.00042727}, {288,0.00043636}, {289,0.00054545}, {290,0.00060909}, {291,0.00026364}, {292,0.00038182}, {293,0.00066364}, {294,0.00037273}, {295,0.00035455}, {296,0.00035455}, {297,0.00058182}, {298,0.00046364}, {299,0.00033636}, {300,0.00040000}, {301,0.00035455}, {302,0.00047273}, {303,0.00038182}, {304,0.00060000}, {305,0.00055455}, {306,0.00047273}, {307,0.00070000}, {308,0.00060000}, {309,0.00056364}, {310,0.00057273}, {311,0.00045455}, {312,0.00037273}, {313,0.00066364}, {314,0.00058182}, {315,0.00056364}, {316,0.00065455}, {317,0.00034545}, {318,0.00059091}, {319,0.00040000}, {320,0.00052727}, {321,0.00143636}, {322,0.00044545}, {323,0.00036364}, {324,0.00052727}, {325,0.00048182}, {326,0.00048182}, {327,0.00040909}, {328,0.00046364}, {329,0.00060000}, {330,0.00047273}, {331,0.00047273}, {332,0.00050000}, {333,0.00059091}, {334,0.00041818}, {335,0.00062727}, {336,0.00047273}, {337,0.00042727}, {338,0.00025455}, {339,0.00045455}, {340,0.00050000}, {341,0.00056364}, {342,0.00062727}, {343,0.00047273}, {344,0.00049091}, {345,0.00060000}, {346,0.00053636}, {347,0.00044545}, {348,0.00023636}, {349,0.00070000}, {350,0.00059091}, {351,0.00063636}, {352,0.00058182}, {353,0.00049091}, {354,0.00065455}, {355,0.00083636}, {356,0.00029091}, {357,0.00058182}, {358,0.00050909}, {359,0.00049091}, {360,0.00064545}, {361,0.00055455}, {362,0.00029091}, {363,0.00061818}, {364,0.00026364}, {365,0.00060909}, {366,0.00056364}, {367,0.00053636}, {368,0.00061818}, {369,0.00067273}, {370,0.00068182}, {371,0.00072727}, {372,0.00029091}, {373,0.00067273}, {374,0.00084545}, {375,0.00040000}, {376,0.00041818}, {377,0.00042727}, {378,0.00062727}, {379,0.00066364}, {380,0.00056364}, {381,0.00044545}, {382,0.00090000}, {383,0.00060000}, {384,0.00050909}, {385,0.00053636}, {386,0.00069091}, {387,0.00061818}, {388,0.00052727}, {389,0.00053636}, {390,0.00075455}, {391,0.00052727}, {392,0.00059091}, {393,0.00060000}, {394,0.00042727}, {395,0.00064545}, {396,0.00066364}, {397,0.00062727}, {398,0.00046364}, {399,0.00059091}, {400,0.00064545}, {401,0.00052727}, {402,0.00060000}, {403,0.00068182}, {404,0.00042727}, {405,0.00073636}, {406,0.00053636}, {407,0.00064545}, {408,0.00069091}, {409,0.00041818}, {410,0.00072727}, {411,0.00051818}, {412,0.00083636}, {413,0.00048182}, {414,0.00083636}, {415,0.00075455}, {416,0.00041818}, {417,0.00055455}, {418,0.00056364}, {419,0.00080909}, {420,0.00062727}, {421,0.00070000}, {422,0.00044545}, {423,0.00059091}, {424,0.00052727}, {425,0.00053636}, {426,0.00086364}, {427,0.00096364}, {428,0.00068182}, {429,0.00066364}, {430,0.00057273}, {431,0.00035455}, {432,0.00047273}, {433,0.00071818}, {434,0.00066364}, {435,0.00061818}, {436,0.00050000}, {437,0.00059091}, {438,0.00067273}, {439,0.00051818}, {440,0.00069091}, {441,0.00069091}, {442,0.00079091}, {443,0.00065455}, {444,0.00076364}, {445,0.00070909}, {446,0.00064545}, {447,0.00063636}, {448,0.00072727}, {449,0.00062727}, {450,0.00063636}, {451,0.00067273}, {452,0.00079091}, {453,0.00080909}, {454,0.00059091}, {455,0.00055455}, {456,0.00072727}, {457,0.00055455}, {458,0.00052727}, {459,0.00067273}, {460,0.00050000}, {461,0.00044545}, {462,0.00068182}, {463,0.00044545}, {464,0.00058182}, {465,0.00068182}, {466,0.00065455}, {467,0.00058182}, {468,0.00079091}, {469,0.00082727}, {470,0.00064545}, {471,0.00062727}, {472,0.00071818}, {473,0.00073636}, {474,0.00073636}, {475,0.00070000}, {476,0.00067273}, {477,0.00064545}, {478,0.00082727}, {479,0.00074545}, {480,0.00072727}, {481,0.00074545}, {482,0.00071818}, {483,0.00069091}, {484,0.00050000}, {485,0.00040909}, {486,0.00052727}, {487,0.00050909}, {488,0.00065455}, {489,0.00093636}, {490,0.00077273}, {491,0.00093636}, {492,0.00081818}, {493,0.00102727}, {494,0.00074545}, {495,0.00100000}, {496,0.00056364}, {497,0.00082727}, {498,0.00101818}, {499,0.00097273}, {500,0.00064545}, {505,0.00064545}, {510,0.00079091}, {515,0.00073636}, {520,0.00065455}, {525,0.00086364}, {530,0.00092727}, {535,0.00086364}, {540,0.00055455}, {545,0.00069091}, {550,0.00088182}, {555,0.00076364}, {560,0.00079091}, {565,0.00099091}, {570,0.00069091}, {575,0.00100000}, {580,0.00080909}, {585,0.00109091}, {590,0.00095455}, {595,0.00091818}, {600,0.00100000}, {605,0.00087273}, {610,0.00082727}, {615,0.00101818}, {620,0.00094545}, {625,0.00084545}, {630,0.00090909}, {635,0.00075455}, {640,0.00103636}, {645,0.00100909}, {650,0.00080000}, {655,0.00102727}, {660,0.00079091}, {665,0.00097273}, {670,0.00088182}, {675,0.00085455}, {680,0.00100000}, {685,0.00089091}, {690,0.00082727}, {695,0.00078182}, {700,0.00100909}, {705,0.00089091}, {710,0.00104545}, {715,0.00129091}, {720,0.00106364}, {725,0.00122727}, {730,0.00082727}, {735,0.00099091}, {740,0.00105455}, {745,0.00122727}, {750,0.00110909}, {755,0.00085455}, {760,0.00071818}, {765,0.00120000}, {770,0.00112727}, {775,0.00098182}, {780,0.00096364}, {785,0.00089091}, {790,0.00118182}, {795,0.00114545}, {800,0.00103636}, {805,0.00114545}, {810,0.00110909}, {815,0.00117273}, {820,0.00108182}, {825,0.00107273}, {830,0.00111818}, {835,0.00120909}, {840,0.00107273}, {845,0.00140909}, {850,0.00125455}, {855,0.00082727}, {860,0.00116364}, {865,0.00103636}, {870,0.00089091}, {875,0.00138182}, {880,0.00114545}, {885,0.00119091}, {890,0.00118182}, {895,0.00112727}, {900,0.00131818}, {905,0.00116364}, {910,0.00156364}, {915,0.00098182}, {920,0.00134545}, {925,0.00176364}, {930,0.00129091}, {935,0.00125455}, {940,0.00117273}, {945,0.00131818}, {950,0.00147273}, {955,0.00131818}, {960,0.00116364}, {965,0.00139091}, {970,0.00144545}, {975,0.00143636}, {980,0.00144545}, {985,0.00146364}, {990,0.00300909}, {995,0.00149091}, {1000,0.00149091}, {1010,0.00148182}, {1020,0.00146364}, {1030,0.00147273}, {1040,0.00153636}, {1050,0.00161818}, {1060,0.00163636}, {1070,0.00131818}, {1080,0.00161818}, {1090,0.00315455}, {1100,0.00130909}, {1110,0.00167273}, {1120,0.00155455}, {1130,0.00152727}, {1140,0.00163636}, {1150,0.00186364}, {1160,0.00176364}, {1170,0.00141818}, {1180,0.00190909}, {1190,0.00577273}, {1200,0.00161818}, {1210,0.00161818}, {1220,0.00187273}, {1230,0.00192727}, {1240,0.00200909}, {1250,0.00171818}, {1260,0.00180909}, {1270,0.00173636}, {1280,0.00175455}, {1290,0.00164545}, {1300,0.00181818}, {1310,0.00224545}, {1320,0.00172727}, {1330,0.00183636}, {1340,0.00183636}, {1350,0.00194545}, {1360,0.00192727}, {1370,0.00173636}, {1380,0.00179091}, {1390,0.00204545}, {1400,0.00210909}, {1410,0.00216364}, {1420,0.00229091}, {1430,0.00210000}, {1440,0.00185455}, {1450,0.00237273}, {1460,0.00219091}, {1470,0.00239091}, {1480,0.00198182}, {1490,0.00765455}, {1500,0.00210000}, {1510,0.00223636}, {1520,0.00235455}, {1530,0.00213636}, {1540,0.00216364}, {1550,0.00252727}, {1560,0.00250000}, {1570,0.00197273}, {1580,0.00236364}, {1590,0.00252727}, {1600,0.00221818}, {1610,0.00227273}, {1620,0.00231818}, {1630,0.00269091}, {1640,0.00252727}, {1650,0.00254545}, {1660,0.00240909}, {1670,0.00253636}, {1680,0.00254545}, {1690,0.00258182}, {1700,0.00244545}, {1710,0.00233636}, {1720,0.00254545}, {1730,0.00259091}, {1740,0.00504545}, {1750,0.00247273}, {1760,0.00296364}, {1770,0.00264545}, {1780,0.00239091}, {1790,0.00273636}, {1800,0.00268182}, {1810,0.00299091}, {1820,0.00265455}, {1830,0.00296364}, {1840,0.00283636}, {1850,0.00288182}, {1860,0.00268182}, {1870,0.00262727}, {1880,0.00300909}, {1890,0.00250000}, {1900,0.00639091}, {1910,0.00302727}, {1920,0.00301818}, {1930,0.00513636}, {1940,0.00294545}, {1950,0.00293636}, {1960,0.00539091}, {1970,0.00307273}, {1980,0.00290000}, {1990,0.00311818}, {2000,0.00320909}, {2050,0.00328182}, {2100,0.00318182}, {2150,0.00354545}, {2200,0.00347273}, {2250,0.00358182}, {2300,0.00342727}, {2350,0.00385455}, {2400,0.00388182}, {2450,0.00384545}, {2500,0.00400000}, {2550,0.00402727}, {2600,0.00425455}, {2650,0.00420000}, {2700,0.01113636}, {2750,0.00453636}, {2800,0.00470909}, {2850,0.00466364}, {2900,0.00487273}, {2950,0.00455455}, {3000,0.00513636}, {3050,0.00494545}, {3100,0.00492727}, {3150,0.00492727}, {3200,0.00440909}, {3250,0.00519091}, {3300,0.00544545}, {3350,0.00536364}, {3400,0.00580909}, {3450,0.00558182}, {3500,0.00578182}, {3550,0.00571818}, {3600,0.00578182}, {3650,0.00610909}, {3700,0.00606364}, {3750,0.00603636}, {3800,0.00627273}, {3850,0.00635455}, {3900,0.00645455}, {3950,0.00637273}, {4000,0.00662727}, {4050,0.00651818}, {4100,0.00695455}, {4150,0.00681818}, {4200,0.00690000}, {4250,0.00692727}, {4300,0.00693636}, {4350,0.00731818}, {4400,0.00739091}, {4450,0.00770000}, {4500,0.00598182}, {4550,0.00772727}, {4600,0.00771818}, {4650,0.00811818}, {4700,0.00808182}, {4750,0.00842727}, {4800,0.00829091}, {4850,0.00830909}, {4900,0.00840000}, {4950,0.00879091}, {5000,0.00876364}, {5050,0.00893636}, {5100,0.00920000}, {5150,0.00890000}, {5200,0.00923636}, {5250,0.00925455}, {5300,0.00959091}, {5350,0.00940909}, {5400,0.00964545}, {5450,0.00760000}, {5500,0.01819091}, {5550,0.00990000}, {5600,0.01004545}, {5650,0.01008182}, {5700,0.01036364}, {5750,0.01023636}, {5800,0.01013636}, {5850,0.01066364}, {5900,0.01082727}, {5950,0.01114545}, {6000,0.01088182}, {6050,0.01119091}, {6100,0.01137273}, {6150,0.01132727}, {6200,0.01173636}, {6250,0.01139091}, {6300,0.01204545}, {6350,0.03614545}, {6400,0.01158182}, {6450,0.01189091}, {6500,0.01216364}, {6550,0.01240909}, {6600,0.01212727}, {6650,0.01216364}, {6700,0.01245455}, {6750,0.01239091}, {6800,0.03172727}, {6850,0.01239091}, {6900,0.01289091}, {6950,0.01274545}, {7000,0.01293636}, {7050,0.01298182}, {7100,0.03141818}, {7150,0.01312727}, {7200,0.01358182}, {7250,0.01333636}, {7300,0.01387273}, {7350,0.01356364}, {7400,0.01379091}, {7450,0.01336364}, {7500,0.01370000}, {7550,0.01399091}, {7600,0.01385455}, {7650,0.01400000}, {7700,0.02520909}, {7750,0.01401818}, {7800,0.01425455}, {7850,0.03348182}, {7900,0.01447273}, {7950,0.01420909}, {8000,0.03101818}, {8050,0.01451818}, {8100,0.01476364}, {8150,0.02313636}, {8200,0.01460909}, {8250,0.01490000}, {8300,0.01482727}, {8350,0.01495455}, {8400,0.03412727}, {8450,0.01520000}, {8500,0.01532727}, {8550,0.01532727}, {8600,0.01561818}, {8650,0.01558182}, {8700,0.01561818}, {8750,0.01587273}, {8800,0.01550000}, {8850,0.01608182}, {8900,0.01611818}, {8950,0.01616364}, {9000,0.01656364}, {9050,0.01672727}, {9100,0.01629091}, {9150,0.01654545}, {9200,0.01640000}, {9250,0.01668182}, {9300,0.01730909}, {9350,0.01676364}, {9400,0.02712727}, {9450,0.01713636}, {9500,0.01725455}, {9550,0.01745455}, {9600,0.01743636}, {9650,0.03191818}, {9700,0.01757273}, {9750,0.01767273}, {9800,0.03070909}, {9850,0.01780909}, {9900,0.01807273}, {9950,0.03591818}, {10000,0.01830909}, {10100,0.01834545}, {10200,0.03331818}, {10300,0.01884545}, {10400,0.01885455}, {10500,0.01946364}, {10600,0.03220909}, {10700,0.01969091}, {10800,0.01980909}, {10900,0.02018182}, {11000,0.02007273}, {11100,0.02028182}, {11200,0.03362727}, {11300,0.03828182}, {11400,0.02155455}, {11500,0.02128182}, {11600,0.02126364}, {11700,0.02146364}, {11800,0.02191818}, {11900,0.02202727}, {12000,0.02225455}, {12100,0.02196364}, {12200,0.02261818}, {12300,0.02288182}, {12400,0.02300909}, {12500,0.04050000}, {12600,0.01846364}, {12700,0.02369091}, {12800,0.02375455}, {12900,0.02404545}, {13000,0.02410000}, {13100,0.02459091}, {13200,0.02140909}, {13300,0.02468182}, {13400,0.02494545}, {13500,0.02545455}, {13600,0.02357273}, {13700,0.02527273}, {13800,0.02546364}, {13900,0.03909091}, {14000,0.02552727}, {14100,0.02570000}, {14200,0.02610000}, {14300,0.02623636}, {14400,0.04470000}, {14500,0.02655455}, {14600,0.02693636}, {14700,0.02664545}, {14800,0.02661818}, {14900,0.02698182}, {15000,0.02735455}, {15100,0.02712727}, {15200,0.02766364}, {15300,0.02750000}, {15400,0.04348182}, {15500,0.02777273}, {15600,0.02828182}, {15700,0.02851818}, {15800,0.02828182}, {15900,0.02821818}, {16000,0.02898182}, {16100,0.02916364}, {16200,0.02906364}, {16300,0.04472727}, {16400,0.02941818}, {16500,0.02982727}, {16600,0.02988182}, {16700,0.02423636}, {16800,0.04506364}, {16900,0.03076364}, {17000,0.03060909}, {17100,0.03062727}, {17200,0.03100000}, {17300,0.03078182}, {17400,0.02927273}, {17500,0.04027273}, {17600,0.04209091}, {17700,0.04374545}, {17800,0.03993636}, {17900,0.05179091}, {18000,0.05032727}, {18100,0.04314545}, {18200,0.03908182}, {18300,0.02951818}, {18400,0.03337273}, {18500,0.03361818}, {18600,0.03370909}, {18700,0.03394545}, {18800,0.03418182}, {18900,0.05163636}, {19000,0.04284545}, {19100,0.03517273}, {19200,0.03498182}, {19300,0.03542727}, {19400,0.04900000}, {19500,0.03543636}, {19600,0.03570909}, {19700,0.05564545}, {19800,0.03257273}, {19900,0.03633636}, {20000,0.05328704}};
data["big_flat"]["QuoteFlat"]["actual reif"]["system"] = {{1,0.00003636}, {2,0.00010909}, {3,0.00003636}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00003636}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00003636}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00003636}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00010909}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00003636}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00003636}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00003636}, {112,0.00000000}, {113,0.00000000}, {114,0.00003636}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00007273}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00003636}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00003636}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00003636}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00002727}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00002727}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00003636}, {180,0.00000000}, {181,0.00003636}, {182,0.00003636}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00003636}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00003636}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00003636}, {212,0.00000000}, {213,0.00000000}, {214,0.00003636}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00003636}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00003636}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00003636}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00003636}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00002727}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00003636}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00003636}, {313,0.00003636}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00003636}, {320,0.00003636}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00003636}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00003636}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00003636}, {343,0.00003636}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00003636}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00007273}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00003636}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00003636}, {390,0.00002727}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00007273}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00003636}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00003636}, {411,0.00003636}, {412,0.00000000}, {413,0.00000000}, {414,0.00003636}, {415,0.00000000}, {416,0.00002727}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00003636}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00003636}, {431,0.00000000}, {432,0.00000000}, {433,0.00003636}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00010909}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00003636}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00003636}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003636}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00003636}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00003636}, {478,0.00003636}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00003636}, {485,0.00003636}, {486,0.00003636}, {487,0.00003636}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00003636}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00003636}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00003636}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00002727}, {590,0.00000000}, {595,0.00000000}, {600,0.00003636}, {605,0.00000000}, {610,0.00003636}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00003636}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00003636}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00003636}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00003636}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00003636}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00003636}, {795,0.00003636}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00003636}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00003636}, {860,0.00006364}, {865,0.00000000}, {870,0.00003636}, {875,0.00000000}, {880,0.00000000}, {885,0.00003636}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00003636}, {910,0.00000000}, {915,0.00000000}, {920,0.00003636}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00003636}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00007273}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00003636}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00003636}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00003636}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00003636}, {1340,0.00000000}, {1350,0.00003636}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00002727}, {1390,0.00000000}, {1400,0.00007273}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00003636}, {1470,0.00000000}, {1480,0.00003636}, {1490,0.00013636}, {1500,0.00003636}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00003636}, {1540,0.00003636}, {1550,0.00000000}, {1560,0.00003636}, {1570,0.00003636}, {1580,0.00003636}, {1590,0.00000000}, {1600,0.00002727}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00003636}, {1640,0.00003636}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00010000}, {1750,0.00003636}, {1760,0.00000000}, {1770,0.00003636}, {1780,0.00000000}, {1790,0.00003636}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00003636}, {1860,0.00003636}, {1870,0.00000000}, {1880,0.00002727}, {1890,0.00003636}, {1900,0.00014545}, {1910,0.00000000}, {1920,0.00003636}, {1930,0.00006364}, {1940,0.00003636}, {1950,0.00003636}, {1960,0.00003636}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00007273}, {2000,0.00007273}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00003636}, {2250,0.00002727}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00007273}, {2750,0.00003636}, {2800,0.00003636}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00003636}, {3050,0.00007273}, {3100,0.00003636}, {3150,0.00000000}, {3200,0.00003636}, {3250,0.00000000}, {3300,0.00003636}, {3350,0.00000000}, {3400,0.00003636}, {3450,0.00000000}, {3500,0.00007273}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00003636}, {3700,0.00003636}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00002727}, {4150,0.00003636}, {4200,0.00000000}, {4250,0.00003636}, {4300,0.00000000}, {4350,0.00002727}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00003636}, {4550,0.00003636}, {4600,0.00003636}, {4650,0.00000000}, {4700,0.00003636}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00003636}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00007273}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00002727}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00002727}, {5350,0.00003636}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00025455}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00003636}, {5700,0.00003636}, {5750,0.00003636}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00007273}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00003636}, {6300,0.00003636}, {6350,0.00060909}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00007273}, {6550,0.00000000}, {6600,0.00002727}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00041818}, {6850,0.00014545}, {6900,0.00003636}, {6950,0.00000000}, {7000,0.00006364}, {7050,0.00000000}, {7100,0.00060000}, {7150,0.00000000}, {7200,0.00003636}, {7250,0.00002727}, {7300,0.00003636}, {7350,0.00003636}, {7400,0.00000000}, {7450,0.00003636}, {7500,0.00000000}, {7550,0.00002727}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00024545}, {7750,0.00003636}, {7800,0.00000000}, {7850,0.00046364}, {7900,0.00000000}, {7950,0.00007273}, {8000,0.00030000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00035455}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00057273}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00003636}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00010909}, {8900,0.00000000}, {8950,0.00003636}, {9000,0.00000000}, {9050,0.00003636}, {9100,0.00007273}, {9150,0.00000000}, {9200,0.00003636}, {9250,0.00005455}, {9300,0.00003636}, {9350,0.00003636}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00003636}, {9600,0.00000000}, {9650,0.00003636}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00003636}, {10100,0.00000000}, {10200,0.00010909}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00003636}, {10600,0.00020909}, {10700,0.00003636}, {10800,0.00000000}, {10900,0.00007273}, {11000,0.00000000}, {11100,0.00003636}, {11200,0.00042727}, {11300,0.00036364}, {11400,0.00000000}, {11500,0.00003636}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00003636}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00003636}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00028182}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00003636}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00003636}, {13800,0.00007273}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00003636}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00003636}, {14700,0.00003636}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00002727}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00003636}, {15400,0.00000000}, {15500,0.00007273}, {15600,0.00000000}, {15700,0.00003636}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00003636}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00007273}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00003636}, {18500,0.00000000}, {18600,0.00003636}, {18700,0.00000000}, {18800,0.00006364}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00007273}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00010909}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00018519}};
data["big_flat"]["QuoteFlat"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00001818}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00001818}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000909}, {229,0.00002727}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000909}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00003636}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000909}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000909}, {406,0.00000000}, {407,0.00122727}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000909}, {413,0.00000909}, {414,0.00000909}, {415,0.00000909}, {416,0.00000909}, {417,0.00003636}, {418,0.00000909}, {419,0.00004545}, {420,0.00000909}, {421,0.00000000}, {422,0.00001818}, {423,0.00000909}, {424,0.00002727}, {425,0.00001818}, {426,0.00002727}, {427,0.00004545}, {428,0.00002727}, {429,0.00006364}, {430,0.00006364}, {431,0.00007273}, {432,0.00004545}, {433,0.00008182}, {434,0.00007273}, {435,0.00014545}, {436,0.00014545}, {437,0.00016364}, {438,0.00022727}, {439,0.00019091}, {440,0.00028182}, {441,0.00023636}, {442,0.00030909}, {443,0.00030909}, {444,0.00032727}, {445,0.00040909}, {446,0.00040909}, {447,0.00045455}, {448,0.00050000}, {449,0.00059091}, {450,0.00060000}, {451,0.00067273}, {452,0.00070000}, {453,0.00068182}, {454,0.00070000}, {455,0.00074545}, {456,0.00075455}, {457,0.00076364}, {458,0.00078182}, {459,0.00079091}, {460,0.00079091}, {461,0.00078182}, {462,0.00080909}, {463,0.00078182}, {464,0.00085455}, {465,0.00086364}, {466,0.00087273}, {467,0.00089091}, {468,0.00180909}, {469,0.00090000}, {470,0.00089091}, {471,0.00089091}, {472,0.00096364}, {473,0.00097273}, {474,0.00095455}, {475,0.00095455}, {476,0.00096364}, {477,0.00099091}, {478,0.00099091}, {479,0.00099091}, {480,0.00099091}, {481,0.00099091}, {482,0.00099091}, {483,0.00100000}, {484,0.00100000}, {485,0.00100000}, {486,0.00100000}, {487,0.00100000}, {488,0.00100000}, {489,0.00100000}, {490,0.00100000}, {491,0.00100000}, {492,0.00100000}, {493,0.00100000}, {494,0.00100000}, {495,0.00100000}, {496,0.00100000}, {497,0.00100000}, {498,0.00100000}, {499,0.00100000}, {500,0.00100000}, {505,0.00100000}, {510,0.00100000}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00100000}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00346364}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00103636}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00101818}, {830,0.00104545}, {835,0.00102727}, {840,0.00105455}, {845,0.00103636}, {850,0.00109091}, {855,0.00115455}, {860,0.00130909}, {865,0.00128182}, {870,0.00148182}, {875,0.00157273}, {880,0.00155455}, {885,0.00169091}, {890,0.00169091}, {895,0.00177273}, {900,0.00180909}, {905,0.00182727}, {910,0.00185455}, {915,0.00189091}, {920,0.00191818}, {925,0.00197273}, {930,0.00201818}, {935,0.00199091}, {940,0.00198182}, {945,0.00199091}, {950,0.00200000}, {955,0.00200000}, {960,0.00207273}, {965,0.00200000}, {970,0.00200000}, {975,0.00200000}, {980,0.00200000}, {985,0.00200000}, {990,0.00200000}, {995,0.00200000}, {1000,0.00200000}, {1010,0.00200000}, {1020,0.00200000}, {1030,0.00200000}, {1040,0.00200000}, {1050,0.00200000}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200000}, {1140,0.00203636}, {1150,0.00200000}, {1160,0.00200000}, {1170,0.00200000}, {1180,0.00200000}, {1190,0.00200000}, {1200,0.00200000}, {1210,0.00200000}, {1220,0.00200000}, {1230,0.00204545}, {1240,0.00200909}, {1250,0.00207273}, {1260,0.00210000}, {1270,0.00213636}, {1280,0.00229091}, {1290,0.00250909}, {1300,0.00259091}, {1310,0.00272727}, {1320,0.00274545}, {1330,0.00281818}, {1340,0.00282727}, {1350,0.00290000}, {1360,0.00293636}, {1370,0.00551818}, {1380,0.00298182}, {1390,0.00299091}, {1400,0.00300000}, {1410,0.00303636}, {1420,0.00300000}, {1430,0.00300000}, {1440,0.00300000}, {1450,0.00309091}, {1460,0.00300000}, {1470,0.00300000}, {1480,0.00300000}, {1490,0.00300000}, {1500,0.00300000}, {1510,0.00300000}, {1520,0.00300000}, {1530,0.00583636}, {1540,0.00300000}, {1550,0.00301818}, {1560,0.00300000}, {1570,0.00300000}, {1580,0.00301818}, {1590,0.00301818}, {1600,0.00301818}, {1610,0.00300000}, {1620,0.00309091}, {1630,0.00304545}, {1640,0.00300909}, {1650,0.00308182}, {1660,0.00311818}, {1670,0.00321818}, {1680,0.00342727}, {1690,0.00338182}, {1700,0.00354545}, {1710,0.00361818}, {1720,0.00366364}, {1730,0.00372727}, {1740,0.00390909}, {1750,0.00383636}, {1760,0.00387273}, {1770,0.00389091}, {1780,0.00391818}, {1790,0.00395455}, {1800,0.00396364}, {1810,0.00398182}, {1820,0.00400000}, {1830,0.00400000}, {1840,0.00400000}, {1850,0.00400000}, {1860,0.00400000}, {1870,0.00840909}, {1880,0.00400000}, {1890,0.00400000}, {1900,0.00406364}, {1910,0.00400000}, {1920,0.00400000}, {1930,0.00412727}, {1940,0.00400909}, {1950,0.00400000}, {1960,0.00410909}, {1970,0.00400909}, {1980,0.00400909}, {1990,0.00697273}, {2000,0.00404545}, {2050,0.00421818}, {2100,0.00873636}, {2150,0.00480909}, {2200,0.00492727}, {2250,0.00499091}, {2300,0.00500909}, {2350,0.00514545}, {2400,0.00510909}, {2450,0.00533636}, {2500,0.00558182}, {2550,0.00584545}, {2600,0.00920909}, {2650,0.00598182}, {2700,0.00614545}, {2750,0.00610000}, {2800,0.00625455}, {2850,0.00647273}, {2900,0.00674545}, {2950,0.00682727}, {3000,0.00693636}, {3050,0.00699091}, {3100,0.00705455}, {3150,0.00718182}, {3200,0.01909091}, {3250,0.00758182}, {3300,0.00742727}, {3350,0.00787273}, {3400,0.00798182}, {3450,0.00800909}, {3500,0.00812727}, {3550,0.01429091}, {3600,0.00854545}, {3650,0.00869091}, {3700,0.00883636}, {3750,0.00895455}, {3800,0.00895455}, {3850,0.00913636}, {3900,0.00929091}, {3950,0.01374545}, {4000,0.00966364}, {4050,0.00981818}, {4100,0.00983636}, {4150,0.00997273}, {4200,0.01010909}, {4250,0.01030000}, {4300,0.01778182}, {4350,0.01057273}, {4400,0.01074545}, {4450,0.01079091}, {4500,0.01129091}, {4550,0.01108182}, {4600,0.01121818}, {4650,0.01136364}, {4700,0.02762727}, {4750,0.01172727}, {4800,0.01181818}, {4850,0.01190000}, {4900,0.01206364}, {4950,0.01214545}, {5000,0.02269091}, {5050,0.01259091}, {5100,0.01270909}, {5150,0.01277273}, {5200,0.01287273}, {5250,0.01303636}, {5300,0.01312727}, {5350,0.01876364}, {5400,0.03427273}, {5450,0.01408182}, {5500,0.01376364}, {5550,0.01384545}, {5600,0.01399091}, {5650,0.01412727}, {5700,0.01426364}, {5750,0.01448182}, {5800,0.01468182}, {5850,0.01473636}, {5900,0.01490000}, {5950,0.01505455}, {6000,0.01507273}, {6050,0.01525455}, {6100,0.01540909}, {6150,0.01560909}, {6200,0.01569091}, {6250,0.01577273}, {6300,0.01590000}, {6350,0.01610000}, {6400,0.02567273}, {6450,0.03605455}, {6500,0.03110909}, {6550,0.01672727}, {6600,0.01678182}, {6650,0.01690000}, {6700,0.01703636}, {6750,0.01714545}, {6800,0.01737273}, {6850,0.03450000}, {6900,0.01756364}, {6950,0.01776364}, {7000,0.01793636}, {7050,0.01808182}, {7100,0.01879091}, {7150,0.03082727}, {7200,0.01846364}, {7250,0.01864545}, {7300,0.01875455}, {7350,0.05074545}, {7400,0.01890000}, {7450,0.01917273}, {7500,0.01928182}, {7550,0.05370909}, {7600,0.01960000}, {7650,0.01969091}, {7700,0.02011818}, {7750,0.01918182}, {7800,0.01995455}, {7850,0.02015455}, {7900,0.03140909}, {7950,0.02051818}, {8000,0.02066364}, {8050,0.02834545}, {8100,0.02095455}, {8150,0.02140000}, {8200,0.02109091}, {8250,0.02132727}, {8300,0.05717273}, {8350,0.02164545}, {8400,0.02190909}, {8450,0.02178182}, {8500,0.02203636}, {8550,0.05213636}, {8600,0.02230909}, {8650,0.05480909}, {8700,0.02260909}, {8750,0.04203636}, {8800,0.02275455}, {8850,0.04240909}, {8900,0.02320000}, {8950,0.03953636}, {9000,0.02335455}, {9050,0.04964545}, {9100,0.02377273}, {9150,0.05107273}, {9200,0.02391818}, {9250,0.05021818}, {9300,0.02427273}, {9350,0.02430000}, {9400,0.02464545}, {9450,0.02457273}, {9500,0.04863636}, {9550,0.02481818}, {9600,0.02499091}, {9650,0.02540909}, {9700,0.02540000}, {9750,0.05097273}, {9800,0.02562727}, {9850,0.02576364}, {9900,0.04707273}, {9950,0.02597273}, {10000,0.02613636}, {10100,0.04776364}, {10200,0.02697273}, {10300,0.02685455}, {10400,0.02725455}, {10500,0.06646364}, {10600,0.02813636}, {10700,0.02810909}, {10800,0.02847273}, {10900,0.02851818}, {11000,0.06208182}, {11100,0.05389091}, {11200,0.02975455}, {11300,0.02969091}, {11400,0.02998182}, {11500,0.03032727}, {11600,0.03057273}, {11700,0.03089091}, {11800,0.03119091}, {11900,0.03149091}, {12000,0.03173636}, {12100,0.03199091}, {12200,0.03229091}, {12300,0.03250000}, {12400,0.03270909}, {12500,0.03301818}, {12600,0.03367273}, {12700,0.06669091}, {12800,0.06543636}, {12900,0.03272727}, {13000,0.03449091}, {13100,0.03462727}, {13200,0.05234545}, {13300,0.07130000}, {13400,0.03558182}, {13500,0.03580909}, {13600,0.05792727}, {13700,0.06243636}, {13800,0.03664545}, {13900,0.03719091}, {14000,0.06813636}, {14100,0.03751818}, {14200,0.05857273}, {14300,0.05027273}, {14400,0.03835455}, {14500,0.07550909}, {14600,0.03894545}, {14700,0.07750909}, {14800,0.03941818}, {14900,0.07395455}, {15000,0.04012727}, {15100,0.12606364}, {15200,0.04069091}, {15300,0.07294545}, {15400,0.04104545}, {15500,0.05510000}, {15600,0.07111818}, {15700,0.04219091}, {15800,0.07175455}, {15900,0.07676364}, {16000,0.04302727}, {16100,0.06531818}, {16200,0.07903636}, {16300,0.04360909}, {16400,0.04390909}, {16500,0.07340000}, {16600,0.08047273}, {16700,0.04510000}, {16800,0.04510909}, {16900,0.04534545}, {17000,0.06930909}, {17100,0.08319091}, {17200,0.08592727}, {17300,0.08490000}, {17400,0.06207273}, {17500,0.04747273}, {17600,0.04740909}, {17700,0.04771818}, {17800,0.04804545}, {17900,0.04810000}, {18000,0.04859091}, {18100,0.04882727}, {18200,0.04940909}, {18300,0.06853636}, {18400,0.08090000}, {18500,0.10251818}, {18600,0.09806364}, {18700,0.08703636}, {18800,0.06869091}, {18900,0.05122727}, {19000,0.05140000}, {19100,0.08200000}, {19200,0.09503636}, {19300,0.06740000}, {19400,0.05228182}, {19500,0.08889091}, {19600,0.09439091}, {19700,0.05327273}, {19800,0.06295455}, {19900,0.10506364}, {20000,0.05414815}};
data["big_flat"]["QuoteFlat"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00003636}, {3,0.00002727}, {4,0.00000000}, {5,0.00003636}, {6,0.00000000}, {7,0.00003636}, {8,0.00000000}, {9,0.00010000}, {10,0.00003636}, {11,0.00012727}, {12,0.00003636}, {13,0.00000000}, {14,0.00006364}, {15,0.00000000}, {16,0.00000000}, {17,0.00002727}, {18,0.00000000}, {19,0.00009091}, {20,0.00008182}, {21,0.00003636}, {22,0.00016364}, {23,0.00000000}, {24,0.00002727}, {25,0.00010909}, {26,0.00010000}, {27,0.00010000}, {28,0.00002727}, {29,0.00020000}, {30,0.00006364}, {31,0.00012727}, {32,0.00017273}, {33,0.00020000}, {34,0.00008182}, {35,0.00006364}, {36,0.00013636}, {37,0.00006364}, {38,0.00006364}, {39,0.00005455}, {40,0.00006364}, {41,0.00012727}, {42,0.00009091}, {43,0.00014545}, {44,0.00010000}, {45,0.00011818}, {46,0.00017273}, {47,0.00007273}, {48,0.00012727}, {49,0.00018182}, {50,0.00019091}, {51,0.00017273}, {52,0.00014545}, {53,0.00003636}, {54,0.00005455}, {55,0.00000000}, {56,0.00010000}, {57,0.00009091}, {58,0.00013636}, {59,0.00007273}, {60,0.00003636}, {61,0.00028182}, {62,0.00014545}, {63,0.00007273}, {64,0.00024545}, {65,0.00023636}, {66,0.00002727}, {67,0.00012727}, {68,0.00016364}, {69,0.00014545}, {70,0.00010000}, {71,0.00020909}, {72,0.00011818}, {73,0.00010000}, {74,0.00014545}, {75,0.00040000}, {76,0.00020909}, {77,0.00006364}, {78,0.00009091}, {79,0.00022727}, {80,0.00020000}, {81,0.00012727}, {82,0.00015455}, {83,0.00014545}, {84,0.00016364}, {85,0.00019091}, {86,0.00012727}, {87,0.00017273}, {88,0.00011818}, {89,0.00019091}, {90,0.00011818}, {91,0.00007273}, {92,0.00023636}, {93,0.00020909}, {94,0.00031818}, {95,0.00019091}, {96,0.00015455}, {97,0.00026364}, {98,0.00020909}, {99,0.00010000}, {100,0.00029091}, {101,0.00015455}, {102,0.00022727}, {103,0.00026364}, {104,0.00019091}, {105,0.00010909}, {106,0.00031818}, {107,0.00017273}, {108,0.00027273}, {109,0.00037273}, {110,0.00017273}, {111,0.00020000}, {112,0.00012727}, {113,0.00045455}, {114,0.00031818}, {115,0.00033636}, {116,0.00015455}, {117,0.00021818}, {118,0.00020000}, {119,0.00030909}, {120,0.00019091}, {121,0.00025455}, {122,0.00023636}, {123,0.00010909}, {124,0.00023636}, {125,0.00021818}, {126,0.00021818}, {127,0.00017273}, {128,0.00032727}, {129,0.00026364}, {130,0.00024545}, {131,0.00040909}, {132,0.00020909}, {133,0.00033636}, {134,0.00024545}, {135,0.00021818}, {136,0.00036364}, {137,0.00036364}, {138,0.00036364}, {139,0.00014545}, {140,0.00035455}, {141,0.00022727}, {142,0.00052727}, {143,0.00027273}, {144,0.00041818}, {145,0.00010000}, {146,0.00020909}, {147,0.00043636}, {148,0.00033636}, {149,0.00013636}, {150,0.00037273}, {151,0.00032727}, {152,0.00030000}, {153,0.00035455}, {154,0.00026364}, {155,0.00019091}, {156,0.00025455}, {157,0.00026364}, {158,0.00011818}, {159,0.00037273}, {160,0.00025455}, {161,0.00048182}, {162,0.00042727}, {163,0.00036364}, {164,0.00022727}, {165,0.00026364}, {166,0.00016364}, {167,0.00023636}, {168,0.00034545}, {169,0.00042727}, {170,0.00039091}, {171,0.00039091}, {172,0.00055455}, {173,0.00045455}, {174,0.00022727}, {175,0.00020000}, {176,0.00040000}, {177,0.00048182}, {178,0.00040909}, {179,0.00031818}, {180,0.00020000}, {181,0.00031818}, {182,0.00034545}, {183,0.00038182}, {184,0.00036364}, {185,0.00040909}, {186,0.00031818}, {187,0.00026364}, {188,0.00029091}, {189,0.00044545}, {190,0.00038182}, {191,0.00043636}, {192,0.00050909}, {193,0.00043636}, {194,0.00047273}, {195,0.00041818}, {196,0.00036364}, {197,0.00038182}, {198,0.00037273}, {199,0.00041818}, {200,0.00035455}, {201,0.00045455}, {202,0.00043636}, {203,0.00041818}, {204,0.00059091}, {205,0.00034545}, {206,0.00049091}, {207,0.00049091}, {208,0.00033636}, {209,0.00029091}, {210,0.00040909}, {211,0.00042727}, {212,0.00052727}, {213,0.00050909}, {214,0.00037273}, {215,0.00044545}, {216,0.00050909}, {217,0.00055455}, {218,0.00023636}, {219,0.00036364}, {220,0.00020909}, {221,0.00048182}, {222,0.00034545}, {223,0.00046364}, {224,0.00050909}, {225,0.00049091}, {226,0.00026364}, {227,0.00032727}, {228,0.00063636}, {229,0.00070000}, {230,0.00028182}, {231,0.00031818}, {232,0.00049091}, {233,0.00051818}, {234,0.00061818}, {235,0.00036364}, {236,0.00038182}, {237,0.00041818}, {238,0.00050909}, {239,0.00057273}, {240,0.00057273}, {241,0.00045455}, {242,0.00053636}, {243,0.00039091}, {244,0.00063636}, {245,0.00050909}, {246,0.00042727}, {247,0.00048182}, {248,0.00038182}, {249,0.00070909}, {250,0.00050000}, {251,0.00050909}, {252,0.00064545}, {253,0.00065455}, {254,0.00041818}, {255,0.00025455}, {256,0.00040909}, {257,0.00066364}, {258,0.00060000}, {259,0.00034545}, {260,0.00069091}, {261,0.00051818}, {262,0.00076364}, {263,0.00051818}, {264,0.00054545}, {265,0.00061818}, {266,0.00058182}, {267,0.00055455}, {268,0.00080000}, {269,0.00048182}, {270,0.00050909}, {271,0.00057273}, {272,0.00042727}, {273,0.00043636}, {274,0.00058182}, {275,0.00067273}, {276,0.00053636}, {277,0.00085455}, {278,0.00059091}, {279,0.00048182}, {280,0.00053636}, {281,0.00040909}, {282,0.00050909}, {283,0.00057273}, {284,0.00048182}, {285,0.00057273}, {286,0.00050000}, {287,0.00060909}, {288,0.00079091}, {289,0.00042727}, {290,0.00057273}, {291,0.00082727}, {292,0.00050909}, {293,0.00056364}, {294,0.00050909}, {295,0.00073636}, {296,0.00067273}, {297,0.00051818}, {298,0.00045455}, {299,0.00055455}, {300,0.00063636}, {301,0.00057273}, {302,0.00082727}, {303,0.00054545}, {304,0.00050909}, {305,0.00081818}, {306,0.00048182}, {307,0.00039091}, {308,0.00059091}, {309,0.00063636}, {310,0.00046364}, {311,0.00060909}, {312,0.00054545}, {313,0.00067273}, {314,0.00061818}, {315,0.00035455}, {316,0.00068182}, {317,0.00042727}, {318,0.00074545}, {319,0.00065455}, {320,0.00071818}, {321,0.00051818}, {322,0.00060000}, {323,0.00073636}, {324,0.00059091}, {325,0.00056364}, {326,0.00070909}, {327,0.00066364}, {328,0.00080909}, {329,0.00065455}, {330,0.00091818}, {331,0.00070909}, {332,0.00074545}, {333,0.00079091}, {334,0.00080000}, {335,0.00064545}, {336,0.00054545}, {337,0.00080909}, {338,0.00068182}, {339,0.00061818}, {340,0.00069091}, {341,0.00053636}, {342,0.00076364}, {343,0.00070000}, {344,0.00079091}, {345,0.00056364}, {346,0.00074545}, {347,0.00080909}, {348,0.00087273}, {349,0.00064545}, {350,0.00063636}, {351,0.00073636}, {352,0.00100909}, {353,0.00049091}, {354,0.00078182}, {355,0.00050909}, {356,0.00086364}, {357,0.00080000}, {358,0.00056364}, {359,0.00068182}, {360,0.00078182}, {361,0.00086364}, {362,0.00088182}, {363,0.00082727}, {364,0.00071818}, {365,0.00080000}, {366,0.00042727}, {367,0.00080000}, {368,0.00083636}, {369,0.00078182}, {370,0.00090000}, {371,0.00074545}, {372,0.00076364}, {373,0.00103636}, {374,0.00044545}, {375,0.00082727}, {376,0.00088182}, {377,0.00062727}, {378,0.00060909}, {379,0.00066364}, {380,0.00099091}, {381,0.00073636}, {382,0.00070909}, {383,0.00053636}, {384,0.00084545}, {385,0.00075455}, {386,0.00070909}, {387,0.00088182}, {388,0.00076364}, {389,0.00089091}, {390,0.00068182}, {391,0.00066364}, {392,0.00086364}, {393,0.00086364}, {394,0.00100000}, {395,0.00071818}, {396,0.00089091}, {397,0.00074545}, {398,0.00087273}, {399,0.00086364}, {400,0.00102727}, {401,0.00075455}, {402,0.00075455}, {403,0.00072727}, {404,0.00089091}, {405,0.00084545}, {406,0.00094545}, {407,0.00166364}, {408,0.00063636}, {409,0.00064545}, {410,0.00098182}, {411,0.00082727}, {412,0.00069091}, {413,0.00113636}, {414,0.00070909}, {415,0.00060000}, {416,0.00080909}, {417,0.00105455}, {418,0.00080000}, {419,0.00069091}, {420,0.00076364}, {421,0.00091818}, {422,0.00083636}, {423,0.00098182}, {424,0.00090909}, {425,0.00089091}, {426,0.00102727}, {427,0.00080000}, {428,0.00077273}, {429,0.00056364}, {430,0.00058182}, {431,0.00092727}, {432,0.00077273}, {433,0.00084545}, {434,0.00097273}, {435,0.00062727}, {436,0.00089091}, {437,0.00100000}, {438,0.00109091}, {439,0.00105455}, {440,0.00110000}, {441,0.00084545}, {442,0.00066364}, {443,0.00053636}, {444,0.00061818}, {445,0.00101818}, {446,0.00102727}, {447,0.00090909}, {448,0.00084545}, {449,0.00087273}, {450,0.00077273}, {451,0.00070909}, {452,0.00088182}, {453,0.00094545}, {454,0.00079091}, {455,0.00085455}, {456,0.00079091}, {457,0.00102727}, {458,0.00090000}, {459,0.00093636}, {460,0.00099091}, {461,0.00100909}, {462,0.00110000}, {463,0.00102727}, {464,0.00092727}, {465,0.00091818}, {466,0.00093636}, {467,0.00080000}, {468,0.00172727}, {469,0.00080000}, {470,0.00090909}, {471,0.00080909}, {472,0.00093636}, {473,0.00100000}, {474,0.00100909}, {475,0.00095455}, {476,0.00101818}, {477,0.00105455}, {478,0.00112727}, {479,0.00104545}, {480,0.00093636}, {481,0.00120909}, {482,0.00115455}, {483,0.00128182}, {484,0.00117273}, {485,0.00096364}, {486,0.00108182}, {487,0.00109091}, {488,0.00107273}, {489,0.00104545}, {490,0.00089091}, {491,0.00101818}, {492,0.00073636}, {493,0.00082727}, {494,0.00088182}, {495,0.00097273}, {496,0.00091818}, {497,0.00074545}, {498,0.00073636}, {499,0.00096364}, {500,0.00106364}, {505,0.00123636}, {510,0.00082727}, {515,0.00094545}, {520,0.00102727}, {525,0.00105455}, {530,0.00120000}, {535,0.00132727}, {540,0.00118182}, {545,0.00082727}, {550,0.00131818}, {555,0.00104545}, {560,0.00102727}, {565,0.00109091}, {570,0.00130000}, {575,0.00104545}, {580,0.00133636}, {585,0.00099091}, {590,0.00142727}, {595,0.00106364}, {600,0.00139091}, {605,0.00115455}, {610,0.00148182}, {615,0.00115455}, {620,0.00128182}, {625,0.00124545}, {630,0.00100909}, {635,0.00145455}, {640,0.00122727}, {645,0.00120000}, {650,0.00147273}, {655,0.00120909}, {660,0.00137273}, {665,0.00129091}, {670,0.00150909}, {675,0.00120909}, {680,0.00140909}, {685,0.00139091}, {690,0.00342727}, {695,0.00143636}, {700,0.00154545}, {705,0.00130909}, {710,0.00155455}, {715,0.00153636}, {720,0.00137273}, {725,0.00135455}, {730,0.00141818}, {735,0.00139091}, {740,0.00135455}, {745,0.00140909}, {750,0.00141818}, {755,0.00142727}, {760,0.00141818}, {765,0.00147273}, {770,0.00124545}, {775,0.00160000}, {780,0.00190909}, {785,0.00184545}, {790,0.00130000}, {795,0.00145455}, {800,0.00185455}, {805,0.00158182}, {810,0.00194545}, {815,0.00184545}, {820,0.00185455}, {825,0.00192727}, {830,0.00170909}, {835,0.00170909}, {840,0.00182727}, {845,0.00150909}, {850,0.00161818}, {855,0.00192727}, {860,0.00175455}, {865,0.00188182}, {870,0.00214545}, {875,0.00147273}, {880,0.00179091}, {885,0.00173636}, {890,0.00176364}, {895,0.00199091}, {900,0.00172727}, {905,0.00184545}, {910,0.00155455}, {915,0.00213636}, {920,0.00182727}, {925,0.00154545}, {930,0.00220909}, {935,0.00207273}, {940,0.00203636}, {945,0.00200000}, {950,0.00180000}, {955,0.00174545}, {960,0.00226364}, {965,0.00200909}, {970,0.00169091}, {975,0.00220909}, {980,0.00191818}, {985,0.00213636}, {990,0.00233636}, {995,0.00192727}, {1000,0.00190909}, {1010,0.00190000}, {1020,0.00195455}, {1030,0.00218182}, {1040,0.00208182}, {1050,0.00192727}, {1060,0.00195455}, {1070,0.00210909}, {1080,0.00245455}, {1090,0.00213636}, {1100,0.00247273}, {1110,0.00214545}, {1120,0.00239091}, {1130,0.00247273}, {1140,0.00234545}, {1150,0.00238182}, {1160,0.00241818}, {1170,0.00230000}, {1180,0.00250909}, {1190,0.00252727}, {1200,0.00270000}, {1210,0.00232727}, {1220,0.00253636}, {1230,0.00253636}, {1240,0.00254545}, {1250,0.00261818}, {1260,0.00263636}, {1270,0.00245455}, {1280,0.00245455}, {1290,0.00273636}, {1300,0.00300000}, {1310,0.00262727}, {1320,0.00259091}, {1330,0.00269091}, {1340,0.00268182}, {1350,0.00301818}, {1360,0.00278182}, {1370,0.00518182}, {1380,0.00270000}, {1390,0.00320000}, {1400,0.00291818}, {1410,0.00315455}, {1420,0.00300000}, {1430,0.00280909}, {1440,0.00290000}, {1450,0.00313636}, {1460,0.00305455}, {1470,0.00321818}, {1480,0.00300000}, {1490,0.00327273}, {1500,0.00315455}, {1510,0.00316364}, {1520,0.00320909}, {1530,0.00582727}, {1540,0.00326364}, {1550,0.00343636}, {1560,0.00354545}, {1570,0.00322727}, {1580,0.00333636}, {1590,0.00340000}, {1600,0.00337273}, {1610,0.00349091}, {1620,0.00350000}, {1630,0.00358182}, {1640,0.00354545}, {1650,0.00344545}, {1660,0.00355455}, {1670,0.00344545}, {1680,0.00368182}, {1690,0.00354545}, {1700,0.00356364}, {1710,0.00362727}, {1720,0.00363636}, {1730,0.00363636}, {1740,0.00370909}, {1750,0.00376364}, {1760,0.00368182}, {1770,0.00383636}, {1780,0.00404545}, {1790,0.00367273}, {1800,0.00390909}, {1810,0.00376364}, {1820,0.00388182}, {1830,0.00390909}, {1840,0.00383636}, {1850,0.00385455}, {1860,0.00387273}, {1870,0.00830000}, {1880,0.00385455}, {1890,0.00400909}, {1900,0.00416364}, {1910,0.00414545}, {1920,0.00422727}, {1930,0.00419091}, {1940,0.00431818}, {1950,0.00430000}, {1960,0.00439091}, {1970,0.00440909}, {1980,0.00430000}, {1990,0.00692727}, {2000,0.00411818}, {2050,0.00419091}, {2100,0.00844545}, {2150,0.00460000}, {2200,0.00488182}, {2250,0.00495455}, {2300,0.00547273}, {2350,0.00492727}, {2400,0.00550909}, {2450,0.00509091}, {2500,0.00549091}, {2550,0.00568182}, {2600,0.00897273}, {2650,0.00585455}, {2700,0.00621818}, {2750,0.00632727}, {2800,0.00619091}, {2850,0.00676364}, {2900,0.00615455}, {2950,0.00660909}, {3000,0.00662727}, {3050,0.00672727}, {3100,0.00690909}, {3150,0.00700000}, {3200,0.01875455}, {3250,0.00768182}, {3300,0.00726364}, {3350,0.00758182}, {3400,0.00784545}, {3450,0.00755455}, {3500,0.00811818}, {3550,0.01434545}, {3600,0.00861818}, {3650,0.00828182}, {3700,0.00884545}, {3750,0.00900909}, {3800,0.00889091}, {3850,0.00915455}, {3900,0.00936364}, {3950,0.01357273}, {4000,0.00980000}, {4050,0.00941818}, {4100,0.00985455}, {4150,0.01037273}, {4200,0.01021818}, {4250,0.01054545}, {4300,0.01724545}, {4350,0.01049091}, {4400,0.01093636}, {4450,0.01114545}, {4500,0.01133636}, {4550,0.01139091}, {4600,0.01148182}, {4650,0.01147273}, {4700,0.02718182}, {4750,0.01181818}, {4800,0.01240909}, {4850,0.01225455}, {4900,0.01229091}, {4950,0.01230000}, {5000,0.02245455}, {5050,0.01286364}, {5100,0.01316364}, {5150,0.01281818}, {5200,0.01300909}, {5250,0.01329091}, {5300,0.01298182}, {5350,0.01828182}, {5400,0.03420909}, {5450,0.01421818}, {5500,0.01408182}, {5550,0.01400000}, {5600,0.01426364}, {5650,0.01428182}, {5700,0.01445455}, {5750,0.01447273}, {5800,0.01441818}, {5850,0.01468182}, {5900,0.01494545}, {5950,0.01511818}, {6000,0.01487273}, {6050,0.01538182}, {6100,0.01537273}, {6150,0.01549091}, {6200,0.01571818}, {6250,0.01564545}, {6300,0.01607273}, {6350,0.01618182}, {6400,0.02591818}, {6450,0.03567273}, {6500,0.03120000}, {6550,0.01663636}, {6600,0.01702727}, {6650,0.01688182}, {6700,0.01668182}, {6750,0.01682727}, {6800,0.01705455}, {6850,0.03445455}, {6900,0.01710909}, {6950,0.01727273}, {7000,0.01780909}, {7050,0.01830909}, {7100,0.01862727}, {7150,0.03090000}, {7200,0.01827273}, {7250,0.01838182}, {7300,0.01841818}, {7350,0.05021818}, {7400,0.01890909}, {7450,0.01903636}, {7500,0.01923636}, {7550,0.05255455}, {7600,0.01976364}, {7650,0.01973636}, {7700,0.02000909}, {7750,0.01932727}, {7800,0.02030000}, {7850,0.02040000}, {7900,0.03114545}, {7950,0.02048182}, {8000,0.02072727}, {8050,0.02800000}, {8100,0.02128182}, {8150,0.02153636}, {8200,0.02109091}, {8250,0.02149091}, {8300,0.05674545}, {8350,0.02180909}, {8400,0.02215455}, {8450,0.02210000}, {8500,0.02212727}, {8550,0.05128182}, {8600,0.02227273}, {8650,0.05400909}, {8700,0.02274545}, {8750,0.04180000}, {8800,0.02296364}, {8850,0.04219091}, {8900,0.02379091}, {8950,0.03886364}, {9000,0.02377273}, {9050,0.04900909}, {9100,0.02389091}, {9150,0.04990909}, {9200,0.02390909}, {9250,0.04973636}, {9300,0.02460909}, {9350,0.02469091}, {9400,0.02474545}, {9450,0.02461818}, {9500,0.04860000}, {9550,0.02496364}, {9600,0.02547273}, {9650,0.02544545}, {9700,0.02527273}, {9750,0.05060000}, {9800,0.02543636}, {9850,0.02574545}, {9900,0.04742727}, {9950,0.02552727}, {10000,0.02613636}, {10100,0.04753636}, {10200,0.02659091}, {10300,0.02676364}, {10400,0.02720909}, {10500,0.06548182}, {10600,0.02767273}, {10700,0.02778182}, {10800,0.02806364}, {10900,0.02853636}, {11000,0.06194545}, {11100,0.05290909}, {11200,0.02960909}, {11300,0.02965455}, {11400,0.02989091}, {11500,0.03007273}, {11600,0.03048182}, {11700,0.03077273}, {11800,0.03120909}, {11900,0.03141818}, {12000,0.03163636}, {12100,0.03209091}, {12200,0.03255455}, {12300,0.03276364}, {12400,0.03305455}, {12500,0.03308182}, {12600,0.03374545}, {12700,0.06660000}, {12800,0.06566364}, {12900,0.03291818}, {13000,0.03448182}, {13100,0.03466364}, {13200,0.05187273}, {13300,0.07167273}, {13400,0.03569091}, {13500,0.03604545}, {13600,0.05782727}, {13700,0.06263636}, {13800,0.03656364}, {13900,0.03717273}, {14000,0.06807273}, {14100,0.03756364}, {14200,0.05860000}, {14300,0.04994545}, {14400,0.03801818}, {14500,0.07543636}, {14600,0.03866364}, {14700,0.07743636}, {14800,0.03915455}, {14900,0.07426364}, {15000,0.03986364}, {15100,0.12623636}, {15200,0.04052727}, {15300,0.07265455}, {15400,0.04105455}, {15500,0.05489091}, {15600,0.07100000}, {15700,0.04220000}, {15800,0.07170909}, {15900,0.07666364}, {16000,0.04290000}, {16100,0.06538182}, {16200,0.07902727}, {16300,0.04377273}, {16400,0.04370909}, {16500,0.07338182}, {16600,0.08063636}, {16700,0.04488182}, {16800,0.04503636}, {16900,0.04523636}, {17000,0.06925455}, {17100,0.08309091}, {17200,0.08555455}, {17300,0.08491818}, {17400,0.06194545}, {17500,0.04752727}, {17600,0.04752727}, {17700,0.04827273}, {17800,0.04825455}, {17900,0.04822727}, {18000,0.04890000}, {18100,0.04907273}, {18200,0.04953636}, {18300,0.06845455}, {18400,0.08059091}, {18500,0.10230909}, {18600,0.09788182}, {18700,0.08692727}, {18800,0.06827273}, {18900,0.05090909}, {19000,0.05144545}, {19100,0.08195455}, {19200,0.09519091}, {19300,0.06738182}, {19400,0.05227273}, {19500,0.08880000}, {19600,0.09426364}, {19700,0.05320909}, {19800,0.06290000}, {19900,0.10431818}, {20000,0.05373148}};
data["big_flat"]["QuoteFlat"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003636}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00002727}, {26,0.00003636}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00003636}, {49,0.00000000}, {50,0.00003636}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00003636}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00003636}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00003636}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00003636}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00003636}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00002727}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00002727}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00007273}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00003636}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00003636}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00003636}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00002727}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00003636}, {181,0.00002727}, {182,0.00003636}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00003636}, {189,0.00000000}, {190,0.00000000}, {191,0.00003636}, {192,0.00003636}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00003636}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00003636}, {237,0.00000000}, {238,0.00000000}, {239,0.00003636}, {240,0.00000000}, {241,0.00003636}, {242,0.00000000}, {243,0.00003636}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00003636}, {255,0.00002727}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003636}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00002727}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003636}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00003636}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00003636}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00003636}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00003636}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00003636}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00003636}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00003636}, {330,0.00000000}, {331,0.00000000}, {332,0.00003636}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00007273}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00003636}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00003636}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00003636}, {389,0.00000000}, {390,0.00002727}, {391,0.00000000}, {392,0.00000000}, {393,0.00003636}, {394,0.00000000}, {395,0.00003636}, {396,0.00003636}, {397,0.00000000}, {398,0.00000000}, {399,0.00003636}, {400,0.00003636}, {401,0.00000000}, {402,0.00000000}, {403,0.00006364}, {404,0.00000000}, {405,0.00000000}, {406,0.00007273}, {407,0.00003636}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00003636}, {413,0.00003636}, {414,0.00000000}, {415,0.00000000}, {416,0.00003636}, {417,0.00000000}, {418,0.00007273}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00007273}, {424,0.00000000}, {425,0.00003636}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00003636}, {432,0.00003636}, {433,0.00000000}, {434,0.00003636}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00003636}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00003636}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00003636}, {451,0.00000000}, {452,0.00003636}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00003636}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00003636}, {462,0.00000000}, {463,0.00000000}, {464,0.00003636}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00002727}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00002727}, {480,0.00003636}, {481,0.00000000}, {482,0.00000000}, {483,0.00003636}, {484,0.00003636}, {485,0.00007273}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00003636}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00002727}, {498,0.00000000}, {499,0.00000000}, {500,0.00006364}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00007273}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00002727}, {550,0.00000000}, {555,0.00000000}, {560,0.00002727}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00002727}, {595,0.00003636}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00003636}, {665,0.00003636}, {670,0.00003636}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00010909}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00003636}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00003636}, {755,0.00003636}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00003636}, {780,0.00003636}, {785,0.00000000}, {790,0.00003636}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00003636}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00003636}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00003636}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00003636}, {905,0.00000000}, {910,0.00003636}, {915,0.00007273}, {920,0.00003636}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00003636}, {960,0.00000000}, {965,0.00003636}, {970,0.00002727}, {975,0.00000000}, {980,0.00003636}, {985,0.00003636}, {990,0.00000000}, {995,0.00000000}, {1000,0.00003636}, {1010,0.00000000}, {1020,0.00003636}, {1030,0.00003636}, {1040,0.00003636}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00003636}, {1190,0.00000000}, {1200,0.00003636}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00003636}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00003636}, {1340,0.00007273}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00002727}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00007273}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00003636}, {1470,0.00000000}, {1480,0.00003636}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00007273}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00003636}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00002727}, {1670,0.00000000}, {1680,0.00003636}, {1690,0.00000000}, {1700,0.00002727}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00003636}, {1980,0.00000000}, {1990,0.00003636}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00014545}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00003636}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00010909}, {2650,0.00000000}, {2700,0.00007273}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00003636}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00003636}, {3200,0.00017273}, {3250,0.00000000}, {3300,0.00003636}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00003636}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00003636}, {3800,0.00003636}, {3850,0.00003636}, {3900,0.00000000}, {3950,0.00003636}, {4000,0.00000000}, {4050,0.00014545}, {4100,0.00003636}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00010909}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00003636}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00003636}, {4700,0.00025455}, {4750,0.00003636}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00003636}, {4950,0.00003636}, {5000,0.00021818}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00006364}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00006364}, {5400,0.00025455}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00003636}, {5800,0.00000000}, {5850,0.00003636}, {5900,0.00000000}, {5950,0.00003636}, {6000,0.00003636}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00003636}, {6200,0.00003636}, {6250,0.00003636}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00010909}, {6450,0.00021818}, {6500,0.00025455}, {6550,0.00000000}, {6600,0.00003636}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00010909}, {6800,0.00003636}, {6850,0.00016364}, {6900,0.00003636}, {6950,0.00007273}, {7000,0.00002727}, {7050,0.00000000}, {7100,0.00003636}, {7150,0.00010909}, {7200,0.00007273}, {7250,0.00000000}, {7300,0.00003636}, {7350,0.00035455}, {7400,0.00010909}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00073636}, {7600,0.00003636}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00003636}, {7900,0.00025455}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00020909}, {8100,0.00003636}, {8150,0.00000000}, {8200,0.00003636}, {8250,0.00000000}, {8300,0.00060909}, {8350,0.00007273}, {8400,0.00000000}, {8450,0.00003636}, {8500,0.00003636}, {8550,0.00040000}, {8600,0.00010909}, {8650,0.00060909}, {8700,0.00000000}, {8750,0.00018182}, {8800,0.00003636}, {8850,0.00014545}, {8900,0.00000000}, {8950,0.00040909}, {9000,0.00003636}, {9050,0.00048182}, {9100,0.00000000}, {9150,0.00092727}, {9200,0.00003636}, {9250,0.00029091}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00003636}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00003636}, {9850,0.00000000}, {9900,0.00003636}, {9950,0.00003636}, {10000,0.00000000}, {10100,0.00043636}, {10200,0.00002727}, {10300,0.00002727}, {10400,0.00000000}, {10500,0.00101818}, {10600,0.00003636}, {10700,0.00000000}, {10800,0.00006364}, {10900,0.00003636}, {11000,0.00060909}, {11100,0.00065455}, {11200,0.00003636}, {11300,0.00003636}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00003636}, {11700,0.00003636}, {11800,0.00000000}, {11900,0.00003636}, {12000,0.00007273}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00010909}, {12400,0.00010000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00010909}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00003636}, {13600,0.00000000}, {13700,0.00003636}, {13800,0.00000000}, {13900,0.00003636}, {14000,0.00003636}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00003636}, {14800,0.00000000}, {14900,0.00003636}, {15000,0.00000000}, {15100,0.00005455}, {15200,0.00003636}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00003636}, {15600,0.00007273}, {15700,0.00000000}, {15800,0.00007273}, {15900,0.00003636}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00003636}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00007273}, {17100,0.00000000}, {17200,0.00007273}, {17300,0.00000000}, {17400,0.00003636}, {17500,0.00003636}, {17600,0.00003636}, {17700,0.00000000}, {17800,0.00003636}, {17900,0.00000000}, {18000,0.00003636}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00007273}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00003636}, {19100,0.00003636}, {19200,0.00003636}, {19300,0.00000000}, {19400,0.00003636}, {19500,0.00003636}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00018182}, {19900,0.00074545}, {20000,0.00000000}};
data["big_flat"]["QuoteFlat"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000909}, {230,0.00157273}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000909}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00201818}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00270000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000909}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000909}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000909}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00004545}, {407,0.00000909}, {408,0.00000909}, {409,0.00000909}, {410,0.00000000}, {411,0.00000000}, {412,0.00000909}, {413,0.00000909}, {414,0.00000909}, {415,0.00002727}, {416,0.00002727}, {417,0.00003636}, {418,0.00001818}, {419,0.00001818}, {420,0.00001818}, {421,0.00000000}, {422,0.00005455}, {423,0.00003636}, {424,0.00008182}, {425,0.00004545}, {426,0.00004545}, {427,0.00009091}, {428,0.00008182}, {429,0.00010000}, {430,0.00008182}, {431,0.00010000}, {432,0.00290000}, {433,0.00017273}, {434,0.00016364}, {435,0.00018182}, {436,0.00019091}, {437,0.00028182}, {438,0.00025455}, {439,0.00024545}, {440,0.00036364}, {441,0.00040909}, {442,0.00038182}, {443,0.00048182}, {444,0.00043636}, {445,0.00051818}, {446,0.00053636}, {447,0.00060000}, {448,0.00066364}, {449,0.00064545}, {450,0.00060909}, {451,0.00071818}, {452,0.00073636}, {453,0.00077273}, {454,0.00076364}, {455,0.00079091}, {456,0.00295455}, {457,0.00082727}, {458,0.00084545}, {459,0.00082727}, {460,0.00088182}, {461,0.00086364}, {462,0.00084545}, {463,0.00087273}, {464,0.00090909}, {465,0.00091818}, {466,0.00094545}, {467,0.00098182}, {468,0.00096364}, {469,0.00095455}, {470,0.00097273}, {471,0.00098182}, {472,0.00099091}, {473,0.00099091}, {474,0.00099091}, {475,0.00098182}, {476,0.00100000}, {477,0.00100000}, {478,0.00099091}, {479,0.00301818}, {480,0.00100000}, {481,0.00100000}, {482,0.00100000}, {483,0.00100000}, {484,0.00100000}, {485,0.00100000}, {486,0.00100000}, {487,0.00100000}, {488,0.00100000}, {489,0.00100000}, {490,0.00100000}, {491,0.00100000}, {492,0.00100000}, {493,0.00100000}, {494,0.00100000}, {495,0.00100000}, {496,0.00100000}, {497,0.00100000}, {498,0.00100000}, {499,0.00100000}, {500,0.00100000}, {505,0.00296364}, {510,0.00100000}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00100000}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00105455}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00105455}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00395455}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100909}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00100909}, {830,0.00100909}, {835,0.00395455}, {840,0.00101818}, {845,0.00102727}, {850,0.00104545}, {855,0.00104545}, {860,0.00108182}, {865,0.00111818}, {870,0.00121818}, {875,0.00130909}, {880,0.00138182}, {885,0.00151818}, {890,0.00161818}, {895,0.00167273}, {900,0.00393636}, {905,0.00177273}, {910,0.00181818}, {915,0.00185455}, {920,0.00188182}, {925,0.00192727}, {930,0.00197273}, {935,0.00197273}, {940,0.00199091}, {945,0.00200000}, {950,0.00200000}, {955,0.00200000}, {960,0.00690909}, {965,0.00200000}, {970,0.00200000}, {975,0.00200000}, {980,0.00200000}, {985,0.00200000}, {990,0.00200000}, {995,0.00200000}, {1000,0.00200000}, {1010,0.00200000}, {1020,0.00200000}, {1030,0.00200000}, {1040,0.00200000}, {1050,0.00200000}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200000}, {1140,0.00495455}, {1150,0.00200000}, {1160,0.00200000}, {1170,0.00200000}, {1180,0.00200000}, {1190,0.00200000}, {1200,0.00200000}, {1210,0.00200000}, {1220,0.00200000}, {1230,0.00200000}, {1240,0.00200000}, {1250,0.00202727}, {1260,0.00200909}, {1270,0.00203636}, {1280,0.00203636}, {1290,0.00208182}, {1300,0.00211818}, {1310,0.00221818}, {1320,0.00240000}, {1330,0.00252727}, {1340,0.00266364}, {1350,0.00278182}, {1360,0.00283636}, {1370,0.00287273}, {1380,0.00288182}, {1390,0.00290909}, {1400,0.00298182}, {1410,0.00594545}, {1420,0.00300000}, {1430,0.00300000}, {1440,0.00300000}, {1450,0.00591818}, {1460,0.00300000}, {1470,0.00300000}, {1480,0.00300000}, {1490,0.00300000}, {1500,0.00300000}, {1510,0.00300000}, {1520,0.00300000}, {1530,0.00300000}, {1540,0.00300000}, {1550,0.00300000}, {1560,0.00300000}, {1570,0.00300000}, {1580,0.00300000}, {1590,0.00300000}, {1600,0.00947273}, {1610,0.00300000}, {1620,0.00300000}, {1630,0.00300000}, {1640,0.00300000}, {1650,0.00300000}, {1660,0.00300000}, {1670,0.00300909}, {1680,0.00303636}, {1690,0.00302727}, {1700,0.00302727}, {1710,0.00306364}, {1720,0.00306364}, {1730,0.00313636}, {1740,0.00300000}, {1750,0.00335455}, {1760,0.00335455}, {1770,0.00363636}, {1780,0.00359091}, {1790,0.00376364}, {1800,0.00381818}, {1810,0.00383636}, {1820,0.00382727}, {1830,0.00383636}, {1840,0.00387273}, {1850,0.00390000}, {1860,0.00396364}, {1870,0.00396364}, {1880,0.00399091}, {1890,0.00399091}, {1900,0.00400000}, {1910,0.00400000}, {1920,0.00400000}, {1930,0.00400000}, {1940,0.00400000}, {1950,0.00400000}, {1960,0.00400000}, {1970,0.00400000}, {1980,0.00400000}, {1990,0.00400000}, {2000,0.00400000}, {2050,0.00400909}, {2100,0.00405455}, {2150,0.00408182}, {2200,0.00440909}, {2250,0.00477273}, {2300,0.00485455}, {2350,0.00894545}, {2400,0.00500000}, {2450,0.00500000}, {2500,0.00504545}, {2550,0.00506364}, {2600,0.00525455}, {2650,0.00542727}, {2700,0.00550909}, {2750,0.00585455}, {2800,0.01386364}, {2850,0.00600000}, {2900,0.02180909}, {2950,0.00607273}, {3000,0.01965455}, {3050,0.00625455}, {3100,0.01709091}, {3150,0.00679091}, {3200,0.00685455}, {3250,0.00693636}, {3300,0.00701818}, {3350,0.00707273}, {3400,0.00711818}, {3450,0.02486364}, {3500,0.00739091}, {3550,0.00760000}, {3600,0.00781818}, {3650,0.00782727}, {3700,0.02275455}, {3750,0.00807273}, {3800,0.00812727}, {3850,0.00845455}, {3900,0.00837273}, {3950,0.00850000}, {4000,0.00896364}, {4050,0.00881818}, {4100,0.00888182}, {4150,0.02178182}, {4200,0.00910909}, {4250,0.00923636}, {4300,0.00930909}, {4350,0.00985455}, {4400,0.00963636}, {4450,0.00980000}, {4500,0.00984545}, {4550,0.01028182}, {4600,0.01007273}, {4650,0.01026364}, {4700,0.01040909}, {4750,0.02517273}, {4800,0.01100000}, {4850,0.01070909}, {4900,0.01082727}, {4950,0.01094545}, {5000,0.01106364}, {5050,0.02580000}, {5100,0.01170909}, {5150,0.01150909}, {5200,0.01157273}, {5250,0.01166364}, {5300,0.01181818}, {5350,0.01187273}, {5400,0.01200000}, {5450,0.01218182}, {5500,0.01156364}, {5550,0.02680909}, {5600,0.04412727}, {5650,0.04430909}, {5700,0.01335455}, {5750,0.01348182}, {5800,0.01309091}, {5850,0.01324545}, {5900,0.01339091}, {5950,0.01350000}, {6000,0.01361818}, {6050,0.01439091}, {6100,0.01421818}, {6150,0.04461818}, {6200,0.03930000}, {6250,0.03877273}, {6300,0.03767273}, {6350,0.01370909}, {6400,0.01460000}, {6450,0.01468182}, {6500,0.01476364}, {6550,0.01488182}, {6600,0.01496364}, {6650,0.01506364}, {6700,0.01579091}, {6750,0.03980909}, {6800,0.01462727}, {6850,0.01571818}, {6900,0.01575455}, {6950,0.01578182}, {7000,0.01585455}, {7050,0.03935455}, {7100,0.01601818}, {7150,0.01643636}, {7200,0.01657273}, {7250,0.01734545}, {7300,0.04131818}, {7350,0.01677273}, {7400,0.01687273}, {7450,0.01688182}, {7500,0.03532727}, {7550,0.01727273}, {7600,0.01753636}, {7650,0.05110909}, {7700,0.01711818}, {7750,0.01771818}, {7800,0.01849091}, {7850,0.01662727}, {7900,0.01800000}, {7950,0.01818182}, {8000,0.01678182}, {8050,0.01858182}, {8100,0.05705455}, {8150,0.01870909}, {8200,0.01879091}, {8250,0.04410000}, {8300,0.01886364}, {8350,0.01980909}, {8400,0.01888182}, {8450,0.01942727}, {8500,0.04065455}, {8550,0.01972727}, {8600,0.05048182}, {8650,0.01977273}, {8700,0.05827273}, {8750,0.02003636}, {8800,0.02085455}, {8850,0.02039091}, {8900,0.02140909}, {8950,0.02070000}, {9000,0.02163636}, {9050,0.02081818}, {9100,0.06464545}, {9150,0.02090000}, {9200,0.05207273}, {9250,0.02129091}, {9300,0.04109091}, {9350,0.02152727}, {9400,0.02131818}, {9450,0.02249091}, {9500,0.02175455}, {9550,0.04831818}, {9600,0.02199091}, {9650,0.02209091}, {9700,0.07298182}, {9750,0.02248182}, {9800,0.02105455}, {9850,0.06121818}, {9900,0.02277273}, {9950,0.02120909}, {10000,0.07294545}, {10100,0.02324545}, {10200,0.02340909}, {10300,0.06169091}, {10400,0.02386364}, {10500,0.02421818}, {10600,0.02431818}, {10700,0.04894545}, {10800,0.06112727}, {10900,0.02507273}, {11000,0.02526364}, {11100,0.02554545}, {11200,0.02579091}, {11300,0.02420909}, {11400,0.05772727}, {11500,0.05652727}, {11600,0.06059091}, {11700,0.06034545}, {11800,0.05296364}, {11900,0.06226364}, {12000,0.06158182}, {12100,0.05945455}, {12200,0.05611818}, {12300,0.05520000}, {12400,0.05462727}, {12500,0.02763636}, {12600,0.02907273}, {12700,0.02929091}, {12800,0.02956364}, {12900,0.07536364}, {13000,0.06254545}, {13100,0.05041818}, {13200,0.03043636}, {13300,0.03069091}, {13400,0.07365455}, {13500,0.05420000}, {13600,0.03136364}, {13700,0.03274545}, {13800,0.05980000}, {13900,0.03207273}, {14000,0.03340909}, {14100,0.05730000}, {14200,0.03278182}, {14300,0.08774545}, {14400,0.03164545}, {14500,0.03478182}, {14600,0.05175455}, {14700,0.03390000}, {14800,0.05768182}, {14900,0.03438182}, {15000,0.32190000}, {15100,0.03639091}, {15200,0.04831818}, {15300,0.10560000}, {15400,0.03500000}, {15500,0.07050000}, {15600,0.03609091}, {15700,0.05252727}, {15800,0.09510909}, {15900,0.03680909}, {16000,0.05380000}, {16100,0.09240909}, {16200,0.03892727}, {16300,0.03665455}, {16400,0.06409091}, {16500,0.09505455}, {16600,0.03976364}, {16700,0.03861818}, {16800,0.03626364}, {16900,0.06618182}, {17000,0.09012727}, {17100,0.10002727}, {17200,0.10815455}, {17300,0.04147273}, {17400,0.04037273}, {17500,0.04053636}, {17600,0.04030000}, {17700,0.03990000}, {17800,0.03981818}, {17900,0.04010909}, {18000,0.04060909}, {18100,0.04143636}, {18200,0.04222727}, {18300,0.04246364}, {18400,0.04399091}, {18500,0.11176364}, {18600,0.10694545}, {18700,0.09616364}, {18800,0.06568182}, {18900,0.04103636}, {19000,0.04407273}, {19100,0.11167273}, {19200,0.10238182}, {19300,0.08392727}, {19400,0.04365455}, {19500,0.11458182}, {19600,0.10038182}, {19700,0.04192727}, {19800,0.04739091}, {19900,0.10900909}, {20000,0.04264815}};
data["big_flat"]["QuoteFlat"]["eval lazy"]["user"] = {{1,0.00000000}, {2,0.00002727}, {3,0.00003636}, {4,0.00003636}, {5,0.00009091}, {6,0.00000000}, {7,0.00000000}, {8,0.00012727}, {9,0.00003636}, {10,0.00010000}, {11,0.00007273}, {12,0.00006364}, {13,0.00009091}, {14,0.00013636}, {15,0.00000000}, {16,0.00000000}, {17,0.00013636}, {18,0.00009091}, {19,0.00011818}, {20,0.00009091}, {21,0.00008182}, {22,0.00010909}, {23,0.00009091}, {24,0.00019091}, {25,0.00006364}, {26,0.00003636}, {27,0.00006364}, {28,0.00009091}, {29,0.00009091}, {30,0.00008182}, {31,0.00012727}, {32,0.00009091}, {33,0.00007273}, {34,0.00013636}, {35,0.00019091}, {36,0.00006364}, {37,0.00003636}, {38,0.00019091}, {39,0.00006364}, {40,0.00010000}, {41,0.00002727}, {42,0.00009091}, {43,0.00003636}, {44,0.00003636}, {45,0.00008182}, {46,0.00009091}, {47,0.00026364}, {48,0.00007273}, {49,0.00005455}, {50,0.00009091}, {51,0.00009091}, {52,0.00007273}, {53,0.00016364}, {54,0.00006364}, {55,0.00020000}, {56,0.00000000}, {57,0.00028182}, {58,0.00010909}, {59,0.00018182}, {60,0.00020000}, {61,0.00025455}, {62,0.00016364}, {63,0.00016364}, {64,0.00019091}, {65,0.00007273}, {66,0.00005455}, {67,0.00016364}, {68,0.00020000}, {69,0.00007273}, {70,0.00022727}, {71,0.00018182}, {72,0.00015455}, {73,0.00030000}, {74,0.00020000}, {75,0.00006364}, {76,0.00022727}, {77,0.00022727}, {78,0.00038182}, {79,0.00021818}, {80,0.00015455}, {81,0.00031818}, {82,0.00028182}, {83,0.00015455}, {84,0.00015455}, {85,0.00023636}, {86,0.00017273}, {87,0.00023636}, {88,0.00020000}, {89,0.00024545}, {90,0.00026364}, {91,0.00019091}, {92,0.00022727}, {93,0.00023636}, {94,0.00024545}, {95,0.00030909}, {96,0.00027273}, {97,0.00010000}, {98,0.00026364}, {99,0.00020909}, {100,0.00016364}, {101,0.00027273}, {102,0.00023636}, {103,0.00027273}, {104,0.00025455}, {105,0.00026364}, {106,0.00016364}, {107,0.00018182}, {108,0.00029091}, {109,0.00017273}, {110,0.00034545}, {111,0.00019091}, {112,0.00044545}, {113,0.00020909}, {114,0.00016364}, {115,0.00024545}, {116,0.00019091}, {117,0.00024545}, {118,0.00035455}, {119,0.00024545}, {120,0.00014545}, {121,0.00029091}, {122,0.00031818}, {123,0.00038182}, {124,0.00012727}, {125,0.00032727}, {126,0.00025455}, {127,0.00013636}, {128,0.00034545}, {129,0.00032727}, {130,0.00045455}, {131,0.00026364}, {132,0.00049091}, {133,0.00023636}, {134,0.00046364}, {135,0.00034545}, {136,0.00020000}, {137,0.00044545}, {138,0.00040000}, {139,0.00040909}, {140,0.00031818}, {141,0.00026364}, {142,0.00041818}, {143,0.00033636}, {144,0.00037273}, {145,0.00040909}, {146,0.00047273}, {147,0.00023636}, {148,0.00028182}, {149,0.00030909}, {150,0.00034545}, {151,0.00028182}, {152,0.00033636}, {153,0.00047273}, {154,0.00028182}, {155,0.00038182}, {156,0.00031818}, {157,0.00032727}, {158,0.00017273}, {159,0.00028182}, {160,0.00031818}, {161,0.00052727}, {162,0.00040000}, {163,0.00045455}, {164,0.00031818}, {165,0.00039091}, {166,0.00039091}, {167,0.00029091}, {168,0.00017273}, {169,0.00027273}, {170,0.00021818}, {171,0.00042727}, {172,0.00044545}, {173,0.00025455}, {174,0.00045455}, {175,0.00035455}, {176,0.00040909}, {177,0.00039091}, {178,0.00039091}, {179,0.00040909}, {180,0.00041818}, {181,0.00019091}, {182,0.00030909}, {183,0.00023636}, {184,0.00039091}, {185,0.00049091}, {186,0.00033636}, {187,0.00033636}, {188,0.00033636}, {189,0.00041818}, {190,0.00039091}, {191,0.00035455}, {192,0.00028182}, {193,0.00025455}, {194,0.00034545}, {195,0.00022727}, {196,0.00035455}, {197,0.00047273}, {198,0.00066364}, {199,0.00058182}, {200,0.00058182}, {201,0.00059091}, {202,0.00032727}, {203,0.00046364}, {204,0.00044545}, {205,0.00037273}, {206,0.00047273}, {207,0.00050000}, {208,0.00027273}, {209,0.00053636}, {210,0.00041818}, {211,0.00033636}, {212,0.00046364}, {213,0.00051818}, {214,0.00050000}, {215,0.00034545}, {216,0.00030000}, {217,0.00026364}, {218,0.00040909}, {219,0.00066364}, {220,0.00055455}, {221,0.00049091}, {222,0.00034545}, {223,0.00051818}, {224,0.00044545}, {225,0.00036364}, {226,0.00047273}, {227,0.00061818}, {228,0.00039091}, {229,0.00050909}, {230,0.00146364}, {231,0.00069091}, {232,0.00047273}, {233,0.00049091}, {234,0.00023636}, {235,0.00047273}, {236,0.00033636}, {237,0.00061818}, {238,0.00041818}, {239,0.00056364}, {240,0.00048182}, {241,0.00043636}, {242,0.00030000}, {243,0.00044545}, {244,0.00045455}, {245,0.00032727}, {246,0.00067273}, {247,0.00040000}, {248,0.00062727}, {249,0.00043636}, {250,0.00041818}, {251,0.00055455}, {252,0.00063636}, {253,0.00042727}, {254,0.00041818}, {255,0.00064545}, {256,0.00061818}, {257,0.00055455}, {258,0.00034545}, {259,0.00048182}, {260,0.00041818}, {261,0.00058182}, {262,0.00037273}, {263,0.00062727}, {264,0.00049091}, {265,0.00037273}, {266,0.00040909}, {267,0.00050000}, {268,0.00049091}, {269,0.00040000}, {270,0.00072727}, {271,0.00034545}, {272,0.00040909}, {273,0.00068182}, {274,0.00061818}, {275,0.00046364}, {276,0.00077273}, {277,0.00061818}, {278,0.00038182}, {279,0.00060000}, {280,0.00052727}, {281,0.00041818}, {282,0.00052727}, {283,0.00055455}, {284,0.00053636}, {285,0.00056364}, {286,0.00057273}, {287,0.00065455}, {288,0.00055455}, {289,0.00043636}, {290,0.00079091}, {291,0.00042727}, {292,0.00058182}, {293,0.00048182}, {294,0.00079091}, {295,0.00064545}, {296,0.00043636}, {297,0.00052727}, {298,0.00061818}, {299,0.00066364}, {300,0.00059091}, {301,0.00071818}, {302,0.00039091}, {303,0.00058182}, {304,0.00054545}, {305,0.00050909}, {306,0.00030909}, {307,0.00060000}, {308,0.00076364}, {309,0.00059091}, {310,0.00064545}, {311,0.00056364}, {312,0.00067273}, {313,0.00064545}, {314,0.00040000}, {315,0.00075455}, {316,0.00045455}, {317,0.00070909}, {318,0.00070909}, {319,0.00054545}, {320,0.00057273}, {321,0.00080000}, {322,0.00053636}, {323,0.00077273}, {324,0.00035455}, {325,0.00082727}, {326,0.00050000}, {327,0.00079091}, {328,0.00060000}, {329,0.00075455}, {330,0.00062727}, {331,0.00077273}, {332,0.00061818}, {333,0.00077273}, {334,0.00068182}, {335,0.00046364}, {336,0.00074545}, {337,0.00098182}, {338,0.00088182}, {339,0.00078182}, {340,0.00085455}, {341,0.00069091}, {342,0.00070909}, {343,0.00071818}, {344,0.00080000}, {345,0.00065455}, {346,0.00053636}, {347,0.00071818}, {348,0.00095455}, {349,0.00077273}, {350,0.00073636}, {351,0.00060909}, {352,0.00090000}, {353,0.00080909}, {354,0.00054545}, {355,0.00070000}, {356,0.00064545}, {357,0.00086364}, {358,0.00071818}, {359,0.00055455}, {360,0.00055455}, {361,0.00081818}, {362,0.00086364}, {363,0.00080000}, {364,0.00102727}, {365,0.00073636}, {366,0.00233636}, {367,0.00088182}, {368,0.00067273}, {369,0.00070909}, {370,0.00061818}, {371,0.00067273}, {372,0.00077273}, {373,0.00072727}, {374,0.00073636}, {375,0.00070909}, {376,0.00079091}, {377,0.00094545}, {378,0.00074545}, {379,0.00062727}, {380,0.00278182}, {381,0.00063636}, {382,0.00062727}, {383,0.00060909}, {384,0.00086364}, {385,0.00096364}, {386,0.00069091}, {387,0.00081818}, {388,0.00083636}, {389,0.00079091}, {390,0.00077273}, {391,0.00096364}, {392,0.00062727}, {393,0.00090000}, {394,0.00094545}, {395,0.00071818}, {396,0.00082727}, {397,0.00099091}, {398,0.00070000}, {399,0.00062727}, {400,0.00092727}, {401,0.00107273}, {402,0.00070909}, {403,0.00098182}, {404,0.00095455}, {405,0.00059091}, {406,0.00097273}, {407,0.00087273}, {408,0.00095455}, {409,0.00094545}, {410,0.00055455}, {411,0.00097273}, {412,0.00063636}, {413,0.00087273}, {414,0.00056364}, {415,0.00106364}, {416,0.00084545}, {417,0.00087273}, {418,0.00086364}, {419,0.00072727}, {420,0.00087273}, {421,0.00070000}, {422,0.00097273}, {423,0.00093636}, {424,0.00076364}, {425,0.00065455}, {426,0.00066364}, {427,0.00094545}, {428,0.00104545}, {429,0.00113636}, {430,0.00090000}, {431,0.00098182}, {432,0.00303636}, {433,0.00100909}, {434,0.00097273}, {435,0.00070909}, {436,0.00080909}, {437,0.00075455}, {438,0.00055455}, {439,0.00074545}, {440,0.00101818}, {441,0.00097273}, {442,0.00104545}, {443,0.00101818}, {444,0.00090000}, {445,0.00110000}, {446,0.00090000}, {447,0.00107273}, {448,0.00113636}, {449,0.00100909}, {450,0.00109091}, {451,0.00099091}, {452,0.00102727}, {453,0.00103636}, {454,0.00116364}, {455,0.00091818}, {456,0.00302727}, {457,0.00112727}, {458,0.00100909}, {459,0.00091818}, {460,0.00096364}, {461,0.00098182}, {462,0.00101818}, {463,0.00104545}, {464,0.00110909}, {465,0.00100000}, {466,0.00089091}, {467,0.00109091}, {468,0.00104545}, {469,0.00113636}, {470,0.00120000}, {471,0.00114545}, {472,0.00106364}, {473,0.00110000}, {474,0.00095455}, {475,0.00109091}, {476,0.00095455}, {477,0.00084545}, {478,0.00078182}, {479,0.00326364}, {480,0.00100909}, {481,0.00078182}, {482,0.00070909}, {483,0.00068182}, {484,0.00088182}, {485,0.00100909}, {486,0.00096364}, {487,0.00124545}, {488,0.00110909}, {489,0.00086364}, {490,0.00080909}, {491,0.00102727}, {492,0.00107273}, {493,0.00092727}, {494,0.00098182}, {495,0.00097273}, {496,0.00124545}, {497,0.00108182}, {498,0.00091818}, {499,0.00098182}, {500,0.00100909}, {505,0.00300000}, {510,0.00112727}, {515,0.00110909}, {520,0.00124545}, {525,0.00110000}, {530,0.00114545}, {535,0.00062727}, {540,0.00111818}, {545,0.00133636}, {550,0.00090000}, {555,0.00134545}, {560,0.00130909}, {565,0.00093636}, {570,0.00116364}, {575,0.00111818}, {580,0.00099091}, {585,0.00126364}, {590,0.00099091}, {595,0.00130909}, {600,0.00110000}, {605,0.00122727}, {610,0.00122727}, {615,0.00113636}, {620,0.00120909}, {625,0.00117273}, {630,0.00135455}, {635,0.00123636}, {640,0.00111818}, {645,0.00129091}, {650,0.00131818}, {655,0.00121818}, {660,0.00149091}, {665,0.00140000}, {670,0.00120000}, {675,0.00143636}, {680,0.00137273}, {685,0.00137273}, {690,0.00143636}, {695,0.00141818}, {700,0.00140909}, {705,0.00164545}, {710,0.00145455}, {715,0.00132727}, {720,0.00137273}, {725,0.00139091}, {730,0.00151818}, {735,0.00162727}, {740,0.00140909}, {745,0.00134545}, {750,0.00158182}, {755,0.00151818}, {760,0.00149091}, {765,0.00383636}, {770,0.00145455}, {775,0.00160000}, {780,0.00171818}, {785,0.00186364}, {790,0.00160909}, {795,0.00148182}, {800,0.00156364}, {805,0.00140909}, {810,0.00164545}, {815,0.00164545}, {820,0.00158182}, {825,0.00175455}, {830,0.00176364}, {835,0.00410000}, {840,0.00191818}, {845,0.00160909}, {850,0.00139091}, {855,0.00171818}, {860,0.00165455}, {865,0.00207273}, {870,0.00214545}, {875,0.00166364}, {880,0.00183636}, {885,0.00181818}, {890,0.00197273}, {895,0.00185455}, {900,0.00382727}, {905,0.00169091}, {910,0.00156364}, {915,0.00227273}, {920,0.00190000}, {925,0.00142727}, {930,0.00191818}, {935,0.00193636}, {940,0.00216364}, {945,0.00187273}, {950,0.00171818}, {955,0.00171818}, {960,0.00684545}, {965,0.00199091}, {970,0.00181818}, {975,0.00199091}, {980,0.00193636}, {985,0.00210000}, {990,0.00200909}, {995,0.00198182}, {1000,0.00189091}, {1010,0.00200909}, {1020,0.00209091}, {1030,0.00205455}, {1040,0.00197273}, {1050,0.00204545}, {1060,0.00190909}, {1070,0.00240000}, {1080,0.00220000}, {1090,0.00239091}, {1100,0.00228182}, {1110,0.00230000}, {1120,0.00227273}, {1130,0.00237273}, {1140,0.00474545}, {1150,0.00223636}, {1160,0.00223636}, {1170,0.00276364}, {1180,0.00218182}, {1190,0.00233636}, {1200,0.00232727}, {1210,0.00246364}, {1220,0.00241818}, {1230,0.00242727}, {1240,0.00251818}, {1250,0.00254545}, {1260,0.00253636}, {1270,0.00278182}, {1280,0.00259091}, {1290,0.00254545}, {1300,0.00273636}, {1310,0.00256364}, {1320,0.00270000}, {1330,0.00288182}, {1340,0.00279091}, {1350,0.00268182}, {1360,0.00290000}, {1370,0.00302727}, {1380,0.00299091}, {1390,0.00276364}, {1400,0.00283636}, {1410,0.00580000}, {1420,0.00278182}, {1430,0.00292727}, {1440,0.00285455}, {1450,0.00539091}, {1460,0.00287273}, {1470,0.00301818}, {1480,0.00309091}, {1490,0.00297273}, {1500,0.00294545}, {1510,0.00308182}, {1520,0.00283636}, {1530,0.00323636}, {1540,0.00303636}, {1550,0.00329091}, {1560,0.00315455}, {1570,0.00323636}, {1580,0.00306364}, {1590,0.00311818}, {1600,0.00933636}, {1610,0.00340909}, {1620,0.00329091}, {1630,0.00320909}, {1640,0.00322727}, {1650,0.00321818}, {1660,0.00334545}, {1670,0.00358182}, {1680,0.00351818}, {1690,0.00340909}, {1700,0.00337273}, {1710,0.00351818}, {1720,0.00348182}, {1730,0.00363636}, {1740,0.00356364}, {1750,0.00338182}, {1760,0.00353636}, {1770,0.00384545}, {1780,0.00376364}, {1790,0.00356364}, {1800,0.00373636}, {1810,0.00359091}, {1820,0.00368182}, {1830,0.00365455}, {1840,0.00360000}, {1850,0.00377273}, {1860,0.00400909}, {1870,0.00385455}, {1880,0.00388182}, {1890,0.00404545}, {1900,0.00380909}, {1910,0.00381818}, {1920,0.00396364}, {1930,0.00390000}, {1940,0.00386364}, {1950,0.00400909}, {1960,0.00403636}, {1970,0.00398182}, {1980,0.00410000}, {1990,0.00404545}, {2000,0.00409091}, {2050,0.00420000}, {2100,0.00431818}, {2150,0.00431818}, {2200,0.00465455}, {2250,0.00462727}, {2300,0.00448182}, {2350,0.00904545}, {2400,0.00474545}, {2450,0.00497273}, {2500,0.00496364}, {2550,0.00505455}, {2600,0.00521818}, {2650,0.00554545}, {2700,0.00523636}, {2750,0.00560000}, {2800,0.01405455}, {2850,0.00583636}, {2900,0.02149091}, {2950,0.00612727}, {3000,0.01926364}, {3050,0.00619091}, {3100,0.01663636}, {3150,0.00646364}, {3200,0.00679091}, {3250,0.00660909}, {3300,0.00679091}, {3350,0.00698182}, {3400,0.00660909}, {3450,0.02465455}, {3500,0.00727273}, {3550,0.00744545}, {3600,0.00742727}, {3650,0.00753636}, {3700,0.02275455}, {3750,0.00814545}, {3800,0.00790909}, {3850,0.00823636}, {3900,0.00821818}, {3950,0.00838182}, {4000,0.00875455}, {4050,0.00898182}, {4100,0.00890000}, {4150,0.02189091}, {4200,0.00939091}, {4250,0.00949091}, {4300,0.00927273}, {4350,0.00999091}, {4400,0.00946364}, {4450,0.00972727}, {4500,0.01020000}, {4550,0.01044545}, {4600,0.01030909}, {4650,0.01024545}, {4700,0.01062727}, {4750,0.02463636}, {4800,0.01117273}, {4850,0.01109091}, {4900,0.01120000}, {4950,0.01113636}, {5000,0.01110000}, {5050,0.02532727}, {5100,0.01183636}, {5150,0.01170909}, {5200,0.01181818}, {5250,0.01205455}, {5300,0.01219091}, {5350,0.01230000}, {5400,0.01238182}, {5450,0.01265455}, {5500,0.01189091}, {5550,0.02646364}, {5600,0.04395455}, {5650,0.04414545}, {5700,0.01359091}, {5750,0.01387273}, {5800,0.01350909}, {5850,0.01320909}, {5900,0.01341818}, {5950,0.01341818}, {6000,0.01386364}, {6050,0.01470000}, {6100,0.01430909}, {6150,0.04427273}, {6200,0.03866364}, {6250,0.03835455}, {6300,0.03721818}, {6350,0.01336364}, {6400,0.01451818}, {6450,0.01483636}, {6500,0.01507273}, {6550,0.01493636}, {6600,0.01501818}, {6650,0.01511818}, {6700,0.01574545}, {6750,0.03927273}, {6800,0.01452727}, {6850,0.01566364}, {6900,0.01547273}, {6950,0.01591818}, {7000,0.01576364}, {7050,0.03869091}, {7100,0.01607273}, {7150,0.01647273}, {7200,0.01610000}, {7250,0.01680000}, {7300,0.04075455}, {7350,0.01677273}, {7400,0.01673636}, {7450,0.01687273}, {7500,0.03542727}, {7550,0.01681818}, {7600,0.01733636}, {7650,0.05017273}, {7700,0.01704545}, {7750,0.01777273}, {7800,0.01840000}, {7850,0.01637273}, {7900,0.01776364}, {7950,0.01830000}, {8000,0.01690000}, {8050,0.01819091}, {8100,0.05660000}, {8150,0.01859091}, {8200,0.01880909}, {8250,0.04306364}, {8300,0.01908182}, {8350,0.02010909}, {8400,0.01934545}, {8450,0.01948182}, {8500,0.03991818}, {8550,0.01985455}, {8600,0.04975455}, {8650,0.02007273}, {8700,0.05773636}, {8750,0.02020000}, {8800,0.02094545}, {8850,0.02056364}, {8900,0.02150909}, {8950,0.02059091}, {9000,0.02176364}, {9050,0.02068182}, {9100,0.06417273}, {9150,0.02103636}, {9200,0.05135455}, {9250,0.02146364}, {9300,0.04072727}, {9350,0.02170909}, {9400,0.02133636}, {9450,0.02265455}, {9500,0.02215455}, {9550,0.04798182}, {9600,0.02254545}, {9650,0.02274545}, {9700,0.07321818}, {9750,0.02267273}, {9800,0.02118182}, {9850,0.06155455}, {9900,0.02319091}, {9950,0.02136364}, {10000,0.07260000}, {10100,0.02361818}, {10200,0.02368182}, {10300,0.06126364}, {10400,0.02428182}, {10500,0.02442727}, {10600,0.02445455}, {10700,0.04813636}, {10800,0.06081818}, {10900,0.02491818}, {11000,0.02537273}, {11100,0.02562727}, {11200,0.02592727}, {11300,0.02427273}, {11400,0.05742727}, {11500,0.05603636}, {11600,0.06032727}, {11700,0.06011818}, {11800,0.05203636}, {11900,0.06204545}, {12000,0.06107273}, {12100,0.05940909}, {12200,0.05522727}, {12300,0.05457273}, {12400,0.05417273}, {12500,0.02738182}, {12600,0.02880909}, {12700,0.02875455}, {12800,0.02946364}, {12900,0.07508182}, {13000,0.06286364}, {13100,0.05023636}, {13200,0.03009091}, {13300,0.03066364}, {13400,0.07375455}, {13500,0.05391818}, {13600,0.03114545}, {13700,0.03264545}, {13800,0.05983636}, {13900,0.03216364}, {14000,0.03349091}, {14100,0.05740909}, {14200,0.03280909}, {14300,0.08769091}, {14400,0.03188182}, {14500,0.03492727}, {14600,0.05112727}, {14700,0.03401818}, {14800,0.05773636}, {14900,0.03445455}, {15000,0.32150000}, {15100,0.03681818}, {15200,0.04844545}, {15300,0.10548182}, {15400,0.03526364}, {15500,0.07067273}, {15600,0.03656364}, {15700,0.05221818}, {15800,0.09536364}, {15900,0.03721818}, {16000,0.05337273}, {16100,0.09238182}, {16200,0.03900909}, {16300,0.03671818}, {16400,0.06402727}, {16500,0.09501818}, {16600,0.03986364}, {16700,0.03893636}, {16800,0.03624545}, {16900,0.06590909}, {17000,0.09015455}, {17100,0.09984545}, {17200,0.10791818}, {17300,0.04160909}, {17400,0.04031818}, {17500,0.04036364}, {17600,0.04036364}, {17700,0.03979091}, {17800,0.04017273}, {17900,0.03977273}, {18000,0.04053636}, {18100,0.04124545}, {18200,0.04204545}, {18300,0.04226364}, {18400,0.04367273}, {18500,0.11151818}, {18600,0.10684545}, {18700,0.09630909}, {18800,0.06557273}, {18900,0.04078182}, {19000,0.04360000}, {19100,0.11117273}, {19200,0.10253636}, {19300,0.08384545}, {19400,0.04350909}, {19500,0.11461818}, {19600,0.10010000}, {19700,0.04160000}, {19800,0.04751818}, {19900,0.10824545}, {20000,0.04231481}};
data["big_flat"]["QuoteFlat"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00003636}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00003636}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00003636}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00006364}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003636}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00002727}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00003636}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00003636}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00003636}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00003636}, {163,0.00003636}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00002727}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00003636}, {175,0.00000000}, {176,0.00000000}, {177,0.00003636}, {178,0.00000000}, {179,0.00003636}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00003636}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00003636}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00003636}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00003636}, {285,0.00000000}, {286,0.00003636}, {287,0.00000000}, {288,0.00002727}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00003636}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00003636}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00003636}, {311,0.00003636}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00002727}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00003636}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00003636}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00003636}, {334,0.00003636}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00003636}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00003636}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00003636}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00003636}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00003636}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00007273}, {382,0.00003636}, {383,0.00002727}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00003636}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00007273}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00003636}, {433,0.00002727}, {434,0.00003636}, {435,0.00000000}, {436,0.00007273}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00003636}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00003636}, {454,0.00002727}, {455,0.00006364}, {456,0.00006364}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00002727}, {466,0.00000000}, {467,0.00000000}, {468,0.00007273}, {469,0.00003636}, {470,0.00000000}, {471,0.00003636}, {472,0.00003636}, {473,0.00000000}, {474,0.00003636}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00003636}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00002727}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00003636}, {489,0.00000000}, {490,0.00000000}, {491,0.00003636}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00003636}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00003636}, {520,0.00000000}, {525,0.00003636}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00006364}, {555,0.00002727}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00003636}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00003636}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00003636}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00003636}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00007273}, {695,0.00000000}, {700,0.00003636}, {705,0.00003636}, {710,0.00000000}, {715,0.00000000}, {720,0.00003636}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00009091}, {750,0.00003636}, {755,0.00000000}, {760,0.00003636}, {765,0.00007273}, {770,0.00000000}, {775,0.00003636}, {780,0.00000000}, {785,0.00003636}, {790,0.00000000}, {795,0.00000000}, {800,0.00003636}, {805,0.00000000}, {810,0.00003636}, {815,0.00000000}, {820,0.00000000}, {825,0.00003636}, {830,0.00000000}, {835,0.00003636}, {840,0.00003636}, {845,0.00003636}, {850,0.00003636}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00003636}, {895,0.00003636}, {900,0.00007273}, {905,0.00003636}, {910,0.00000000}, {915,0.00000000}, {920,0.00002727}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00007273}, {950,0.00003636}, {955,0.00007273}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00002727}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00003636}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00003636}, {1040,0.00000000}, {1050,0.00003636}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00003636}, {1140,0.00013636}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00003636}, {1190,0.00003636}, {1200,0.00000000}, {1210,0.00010909}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00003636}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003636}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00002727}, {1320,0.00003636}, {1330,0.00007273}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00003636}, {1380,0.00000000}, {1390,0.00003636}, {1400,0.00000000}, {1410,0.00003636}, {1420,0.00003636}, {1430,0.00000000}, {1440,0.00010909}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00003636}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00007273}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00007273}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00007273}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00007273}, {1640,0.00000000}, {1650,0.00007273}, {1660,0.00000000}, {1670,0.00007273}, {1680,0.00003636}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00003636}, {1840,0.00003636}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00003636}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00003636}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00002727}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00003636}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00010000}, {2350,0.00010909}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00007273}, {2600,0.00000000}, {2650,0.00003636}, {2700,0.00003636}, {2750,0.00003636}, {2800,0.00010909}, {2850,0.00000000}, {2900,0.00013636}, {2950,0.00000000}, {3000,0.00021818}, {3050,0.00000000}, {3100,0.00018182}, {3150,0.00000000}, {3200,0.00002727}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00003636}, {3450,0.00031818}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00006364}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00002727}, {3900,0.00000000}, {3950,0.00003636}, {4000,0.00000000}, {4050,0.00003636}, {4100,0.00003636}, {4150,0.00012727}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00007273}, {4350,0.00003636}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00003636}, {4750,0.00034545}, {4800,0.00002727}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00007273}, {5050,0.00023636}, {5100,0.00003636}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00003636}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00003636}, {5550,0.00020000}, {5600,0.00039091}, {5650,0.00061818}, {5700,0.00003636}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00003636}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00007273}, {6150,0.00045455}, {6200,0.00046364}, {6250,0.00014545}, {6300,0.00032727}, {6350,0.00010909}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00003636}, {6650,0.00000000}, {6700,0.00003636}, {6750,0.00040000}, {6800,0.00007273}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00038182}, {7100,0.00003636}, {7150,0.00003636}, {7200,0.00003636}, {7250,0.00000000}, {7300,0.00036364}, {7350,0.00003636}, {7400,0.00000000}, {7450,0.00007273}, {7500,0.00021818}, {7550,0.00000000}, {7600,0.00003636}, {7650,0.00058182}, {7700,0.00010909}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00003636}, {7900,0.00000000}, {7950,0.00003636}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00043636}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00054545}, {8300,0.00003636}, {8350,0.00002727}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00032727}, {8550,0.00003636}, {8600,0.00032727}, {8650,0.00010909}, {8700,0.00069091}, {8750,0.00000000}, {8800,0.00002727}, {8850,0.00000000}, {8900,0.00003636}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00014545}, {9100,0.00060909}, {9150,0.00006364}, {9200,0.00032727}, {9250,0.00000000}, {9300,0.00010909}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00003636}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00007273}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00054545}, {10100,0.00007273}, {10200,0.00007273}, {10300,0.00064545}, {10400,0.00000000}, {10500,0.00010909}, {10600,0.00002727}, {10700,0.00035455}, {10800,0.00056364}, {10900,0.00007273}, {11000,0.00003636}, {11100,0.00003636}, {11200,0.00003636}, {11300,0.00000000}, {11400,0.00047273}, {11500,0.00029091}, {11600,0.00056364}, {11700,0.00054545}, {11800,0.00061818}, {11900,0.00030909}, {12000,0.00063636}, {12100,0.00031818}, {12200,0.00054545}, {12300,0.00054545}, {12400,0.00040000}, {12500,0.00000000}, {12600,0.00003636}, {12700,0.00000000}, {12800,0.00003636}, {12900,0.00003636}, {13000,0.00000000}, {13100,0.00003636}, {13200,0.00010909}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00003636}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00003636}, {14100,0.00000000}, {14200,0.00003636}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00007273}, {14700,0.00003636}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00018182}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00003636}, {15400,0.00003636}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00003636}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00010909}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00007273}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00003636}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00007273}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00003636}, {17700,0.00003636}, {17800,0.00000000}, {17900,0.00003636}, {18000,0.00003636}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00014545}, {18400,0.00000000}, {18500,0.00003636}, {18600,0.00003636}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00006364}, {19100,0.00007273}, {19200,0.00006364}, {19300,0.00000000}, {19400,0.00003636}, {19500,0.00007273}, {19600,0.00000000}, {19700,0.00010909}, {19800,0.00006364}, {19900,0.00042727}, {20000,0.00007407}};
data["big_flat"]["QuoteFlat"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00098182}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00210000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00491818}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000909}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000909}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000909}, {1260,0.00001818}, {1270,0.00000000}, {1280,0.00415455}, {1290,0.00000000}, {1300,0.00000909}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000909}, {1340,0.00000909}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000909}, {1380,0.00000909}, {1390,0.00003636}, {1400,0.00003636}, {1410,0.00000000}, {1420,0.00004545}, {1430,0.00007273}, {1440,0.00005455}, {1450,0.00000000}, {1460,0.00012727}, {1470,0.00009091}, {1480,0.00009091}, {1490,0.00000000}, {1500,0.00017273}, {1510,0.00013636}, {1520,0.00015455}, {1530,0.00020000}, {1540,0.00023636}, {1550,0.00024545}, {1560,0.00022727}, {1570,0.00021818}, {1580,0.00020909}, {1590,0.00023636}, {1600,0.00000000}, {1610,0.00040000}, {1620,0.00040000}, {1630,0.00044545}, {1640,0.00053636}, {1650,0.00057273}, {1660,0.00069091}, {1670,0.00505455}, {1680,0.00072727}, {1690,0.00075455}, {1700,0.00080909}, {1710,0.00078182}, {1720,0.00082727}, {1730,0.00081818}, {1740,0.00001818}, {1750,0.00091818}, {1760,0.00090909}, {1770,0.00091818}, {1780,0.00090000}, {1790,0.00090909}, {1800,0.00093636}, {1810,0.00095455}, {1820,0.00096364}, {1830,0.00100000}, {1840,0.00096364}, {1850,0.00096364}, {1860,0.00100000}, {1870,0.00099091}, {1880,0.00099091}, {1890,0.00100000}, {1900,0.00001818}, {1910,0.00100000}, {1920,0.00100000}, {1930,0.00002727}, {1940,0.00100000}, {1950,0.00100000}, {1960,0.00002727}, {1970,0.00100000}, {1980,0.00100000}, {1990,0.00100000}, {2000,0.00100000}, {2050,0.00100000}, {2100,0.00100000}, {2150,0.00100000}, {2200,0.00100909}, {2250,0.00100000}, {2300,0.00101818}, {2350,0.00090000}, {2400,0.00102727}, {2450,0.00102727}, {2500,0.00108182}, {2550,0.00110909}, {2600,0.00119091}, {2650,0.00117273}, {2700,0.00100909}, {2750,0.00129091}, {2800,0.00100000}, {2850,0.00150909}, {2900,0.00100000}, {2950,0.00162727}, {3000,0.00100000}, {3050,0.00180000}, {3100,0.00100000}, {3150,0.00189091}, {3200,0.00126364}, {3250,0.00196364}, {3300,0.00197273}, {3350,0.00200000}, {3400,0.00200000}, {3450,0.00100909}, {3500,0.00200909}, {3550,0.00203636}, {3600,0.00200909}, {3650,0.00210000}, {3700,0.00100909}, {3750,0.00225455}, {3800,0.00234545}, {3850,0.00241818}, {3900,0.00256364}, {3950,0.00260909}, {4000,0.01852727}, {4050,0.00270000}, {4100,0.00270000}, {4150,0.00170000}, {4200,0.00281818}, {4250,0.00280909}, {4300,0.00280000}, {4350,0.00289091}, {4400,0.00297273}, {4450,0.00298182}, {4500,0.00194545}, {4550,0.02243636}, {4600,0.00301818}, {4650,0.00300000}, {4700,0.00300909}, {4750,0.00200000}, {4800,0.00307273}, {4850,0.00318182}, {4900,0.00330000}, {4950,0.00332727}, {5000,0.00343636}, {5050,0.00200000}, {5100,0.02789091}, {5150,0.00365455}, {5200,0.00369091}, {5250,0.00370909}, {5300,0.00373636}, {5350,0.00376364}, {5400,0.00375455}, {5450,0.00203636}, {5500,0.00200000}, {5550,0.00200000}, {5600,0.00200000}, {5650,0.00200909}, {5700,0.02201818}, {5750,0.00395455}, {5800,0.00428182}, {5850,0.00447273}, {5900,0.00442727}, {5950,0.00441818}, {6000,0.00440909}, {6050,0.00412727}, {6100,0.02650909}, {6150,0.00273636}, {6200,0.00273636}, {6250,0.00274545}, {6300,0.00277273}, {6350,0.00275455}, {6400,0.00406364}, {6450,0.00471818}, {6500,0.00474545}, {6550,0.00474545}, {6600,0.00475455}, {6650,0.00475455}, {6700,0.02530000}, {6750,0.00299091}, {6800,0.00297273}, {6850,0.00480909}, {6900,0.00480000}, {6950,0.00484545}, {7000,0.00512727}, {7050,0.00300000}, {7100,0.00304545}, {7150,0.00500909}, {7200,0.00503636}, {7250,0.00500909}, {7300,0.00300000}, {7350,0.00520909}, {7400,0.00538182}, {7450,0.00580000}, {7500,0.00300000}, {7550,0.00549091}, {7600,0.00557273}, {7650,0.00308182}, {7700,0.00312727}, {7750,0.00569091}, {7800,0.00565455}, {7850,0.00335455}, {7900,0.00569091}, {7950,0.00606364}, {8000,0.00360000}, {8050,0.00570000}, {8100,0.00367273}, {8150,0.00372727}, {8200,0.00577273}, {8250,0.00369091}, {8300,0.00580000}, {8350,0.00580000}, {8400,0.00376364}, {8450,0.00588182}, {8500,0.00372727}, {8550,0.00613636}, {8600,0.00376364}, {8650,0.00635455}, {8700,0.00386364}, {8750,0.00641818}, {8800,0.03127273}, {8850,0.00656364}, {8900,0.03245455}, {8950,0.00666364}, {9000,0.02792727}, {9050,0.00665455}, {9100,0.00400000}, {9150,0.00669091}, {9200,0.00400000}, {9250,0.00670909}, {9300,0.00400909}, {9350,0.00669091}, {9400,0.00406364}, {9450,0.02535455}, {9500,0.00670000}, {9550,0.00466364}, {9600,0.00680000}, {9650,0.00420909}, {9700,0.00419091}, {9750,0.00692727}, {9800,0.00425455}, {9850,0.00446364}, {9900,0.00715455}, {9950,0.00449091}, {10000,0.00470000}, {10100,0.00745455}, {10200,0.00470909}, {10300,0.00468182}, {10400,0.00800000}, {10500,0.00768182}, {10600,0.00473636}, {10700,0.00474545}, {10800,0.00478182}, {10900,0.00820000}, {11000,0.00783636}, {11100,0.00803636}, {11200,0.00504545}, {11300,0.00500909}, {11400,0.00503636}, {11500,0.00509091}, {11600,0.00520000}, {11700,0.00516364}, {11800,0.00542727}, {11900,0.00556364}, {12000,0.00559091}, {12100,0.00566364}, {12200,0.00567273}, {12300,0.00567273}, {12400,0.00567273}, {12500,0.00568182}, {12600,0.00575455}, {12700,0.00944545}, {12800,0.01026364}, {12900,0.00571818}, {13000,0.00579091}, {13100,0.00582727}, {13200,0.00761818}, {13300,0.01047273}, {13400,0.00607273}, {13500,0.00608182}, {13600,0.00876364}, {13700,0.04016364}, {13800,0.00636364}, {13900,0.00659091}, {14000,0.04051818}, {14100,0.00665455}, {14200,0.01047273}, {14300,0.00667273}, {14400,0.00667273}, {14500,0.04078182}, {14600,0.00667273}, {14700,0.01146364}, {14800,0.00667273}, {14900,0.01165455}, {15000,0.00677273}, {15100,0.05707273}, {15200,0.00684545}, {15300,0.00685455}, {15400,0.00695455}, {15500,0.00717273}, {15600,0.01230909}, {15700,0.00737273}, {15800,0.00748182}, {15900,0.01170000}, {16000,0.00760000}, {16100,0.00764545}, {16200,0.05310000}, {16300,0.00763636}, {16400,0.00763636}, {16500,0.00763636}, {16600,0.04157273}, {16700,0.00770909}, {16800,0.00765455}, {16900,0.00764545}, {17000,0.00768182}, {17100,0.00767273}, {17200,0.00770000}, {17300,0.04699091}, {17400,0.01181818}, {17500,0.00813636}, {17600,0.00820000}, {17700,0.00832727}, {17800,0.00843636}, {17900,0.00848182}, {18000,0.00858182}, {18100,0.00863636}, {18200,0.00952727}, {18300,0.05298182}, {18400,0.03844545}, {18500,0.00865455}, {18600,0.00865455}, {18700,0.00866364}, {18800,0.00865455}, {18900,0.00866364}, {19000,0.00936364}, {19100,0.00868182}, {19200,0.00876364}, {19300,0.00877273}, {19400,0.00881818}, {19500,0.00893636}, {19600,0.00910909}, {19700,0.00930000}, {19800,0.03633636}, {19900,0.00955455}, {20000,0.00958333}};
data["big_flat"]["QuoteFlat"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00002727}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00002727}, {9,0.00003636}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00003636}, {14,0.00006364}, {15,0.00000000}, {16,0.00003636}, {17,0.00002727}, {18,0.00000000}, {19,0.00003636}, {20,0.00000000}, {21,0.00003636}, {22,0.00002727}, {23,0.00006364}, {24,0.00003636}, {25,0.00000000}, {26,0.00000000}, {27,0.00003636}, {28,0.00000000}, {29,0.00003636}, {30,0.00000000}, {31,0.00000000}, {32,0.00003636}, {33,0.00000000}, {34,0.00000000}, {35,0.00002727}, {36,0.00010000}, {37,0.00000000}, {38,0.00007273}, {39,0.00000000}, {40,0.00006364}, {41,0.00006364}, {42,0.00000000}, {43,0.00003636}, {44,0.00000000}, {45,0.00009091}, {46,0.00003636}, {47,0.00003636}, {48,0.00005455}, {49,0.00000000}, {50,0.00005455}, {51,0.00003636}, {52,0.00003636}, {53,0.00000000}, {54,0.00003636}, {55,0.00006364}, {56,0.00002727}, {57,0.00002727}, {58,0.00002727}, {59,0.00000000}, {60,0.00000000}, {61,0.00006364}, {62,0.00000000}, {63,0.00002727}, {64,0.00010000}, {65,0.00000000}, {66,0.00010000}, {67,0.00009091}, {68,0.00007273}, {69,0.00002727}, {70,0.00010000}, {71,0.00000000}, {72,0.00003636}, {73,0.00005455}, {74,0.00000000}, {75,0.00000000}, {76,0.00007273}, {77,0.00003636}, {78,0.00006364}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00002727}, {83,0.00013636}, {84,0.00002727}, {85,0.00003636}, {86,0.00003636}, {87,0.00003636}, {88,0.00000000}, {89,0.00003636}, {90,0.00007273}, {91,0.00002727}, {92,0.00000000}, {93,0.00000000}, {94,0.00010000}, {95,0.00000000}, {96,0.00002727}, {97,0.00012727}, {98,0.00007273}, {99,0.00003636}, {100,0.00006364}, {101,0.00007273}, {102,0.00012727}, {103,0.00000000}, {104,0.00007273}, {105,0.00006364}, {106,0.00010000}, {107,0.00010000}, {108,0.00002727}, {109,0.00002727}, {110,0.00019091}, {111,0.00002727}, {112,0.00017273}, {113,0.00003636}, {114,0.00005455}, {115,0.00010000}, {116,0.00015455}, {117,0.00002727}, {118,0.00002727}, {119,0.00006364}, {120,0.00002727}, {121,0.00002727}, {122,0.00002727}, {123,0.00000000}, {124,0.00007273}, {125,0.00006364}, {126,0.00006364}, {127,0.00006364}, {128,0.00010909}, {129,0.00005455}, {130,0.00006364}, {131,0.00000000}, {132,0.00003636}, {133,0.00003636}, {134,0.00006364}, {135,0.00010000}, {136,0.00002727}, {137,0.00003636}, {138,0.00000000}, {139,0.00002727}, {140,0.00010000}, {141,0.00003636}, {142,0.00002727}, {143,0.00002727}, {144,0.00000000}, {145,0.00000000}, {146,0.00009091}, {147,0.00002727}, {148,0.00010000}, {149,0.00010909}, {150,0.00005455}, {151,0.00003636}, {152,0.00009091}, {153,0.00000000}, {154,0.00009091}, {155,0.00002727}, {156,0.00000000}, {157,0.00006364}, {158,0.00000000}, {159,0.00003636}, {160,0.00000000}, {161,0.00017273}, {162,0.00018182}, {163,0.00010000}, {164,0.00010000}, {165,0.00012727}, {166,0.00012727}, {167,0.00006364}, {168,0.00005455}, {169,0.00003636}, {170,0.00003636}, {171,0.00014545}, {172,0.00003636}, {173,0.00010909}, {174,0.00006364}, {175,0.00012727}, {176,0.00009091}, {177,0.00003636}, {178,0.00010909}, {179,0.00006364}, {180,0.00008182}, {181,0.00016364}, {182,0.00013636}, {183,0.00009091}, {184,0.00003636}, {185,0.00006364}, {186,0.00009091}, {187,0.00007273}, {188,0.00002727}, {189,0.00009091}, {190,0.00011818}, {191,0.00010000}, {192,0.00009091}, {193,0.00011818}, {194,0.00018182}, {195,0.00018182}, {196,0.00016364}, {197,0.00014545}, {198,0.00006364}, {199,0.00010000}, {200,0.00002727}, {201,0.00013636}, {202,0.00000000}, {203,0.00009091}, {204,0.00009091}, {205,0.00009091}, {206,0.00009091}, {207,0.00002727}, {208,0.00127273}, {209,0.00010909}, {210,0.00003636}, {211,0.00012727}, {212,0.00010000}, {213,0.00006364}, {214,0.00016364}, {215,0.00010000}, {216,0.00000000}, {217,0.00014545}, {218,0.00005455}, {219,0.00013636}, {220,0.00009091}, {221,0.00016364}, {222,0.00024545}, {223,0.00006364}, {224,0.00005455}, {225,0.00019091}, {226,0.00012727}, {227,0.00006364}, {228,0.00012727}, {229,0.00017273}, {230,0.00025455}, {231,0.00016364}, {232,0.00017273}, {233,0.00007273}, {234,0.00010000}, {235,0.00002727}, {236,0.00006364}, {237,0.00012727}, {238,0.00021818}, {239,0.00015455}, {240,0.00020000}, {241,0.00010000}, {242,0.00028182}, {243,0.00016364}, {244,0.00002727}, {245,0.00021818}, {246,0.00000000}, {247,0.00026364}, {248,0.00002727}, {249,0.00017273}, {250,0.00009091}, {251,0.00022727}, {252,0.00005455}, {253,0.00012727}, {254,0.00018182}, {255,0.00009091}, {256,0.00018182}, {257,0.00017273}, {258,0.00025455}, {259,0.00010909}, {260,0.00012727}, {261,0.00007273}, {262,0.00010000}, {263,0.00034545}, {264,0.00012727}, {265,0.00006364}, {266,0.00022727}, {267,0.00013636}, {268,0.00010000}, {269,0.00006364}, {270,0.00009091}, {271,0.00010000}, {272,0.00020000}, {273,0.00012727}, {274,0.00013636}, {275,0.00002727}, {276,0.00016364}, {277,0.00015455}, {278,0.00012727}, {279,0.00027273}, {280,0.00014545}, {281,0.00013636}, {282,0.00027273}, {283,0.00002727}, {284,0.00013636}, {285,0.00016364}, {286,0.00010000}, {287,0.00017273}, {288,0.00006364}, {289,0.00015455}, {290,0.00012727}, {291,0.00018182}, {292,0.00023636}, {293,0.00012727}, {294,0.00015455}, {295,0.00026364}, {296,0.00022727}, {297,0.00016364}, {298,0.00015455}, {299,0.00014545}, {300,0.00013636}, {301,0.00028182}, {302,0.00026364}, {303,0.00010909}, {304,0.00020000}, {305,0.00017273}, {306,0.00026364}, {307,0.00010000}, {308,0.00007273}, {309,0.00015455}, {310,0.00020000}, {311,0.00016364}, {312,0.00029091}, {313,0.00013636}, {314,0.00002727}, {315,0.00013636}, {316,0.00021818}, {317,0.00011818}, {318,0.00025455}, {319,0.00015455}, {320,0.00031818}, {321,0.00017273}, {322,0.00016364}, {323,0.00010909}, {324,0.00025455}, {325,0.00006364}, {326,0.00015455}, {327,0.00017273}, {328,0.00022727}, {329,0.00016364}, {330,0.00007273}, {331,0.00013636}, {332,0.00015455}, {333,0.00016364}, {334,0.00006364}, {335,0.00036364}, {336,0.00013636}, {337,0.00013636}, {338,0.00010000}, {339,0.00020909}, {340,0.00003636}, {341,0.00024545}, {342,0.00011818}, {343,0.00019091}, {344,0.00007273}, {345,0.00017273}, {346,0.00027273}, {347,0.00014545}, {348,0.00020909}, {349,0.00017273}, {350,0.00017273}, {351,0.00002727}, {352,0.00005455}, {353,0.00024545}, {354,0.00010909}, {355,0.00023636}, {356,0.00012727}, {357,0.00010000}, {358,0.00010909}, {359,0.00023636}, {360,0.00023636}, {361,0.00016364}, {362,0.00010909}, {363,0.00028182}, {364,0.00028182}, {365,0.00003636}, {366,0.00023636}, {367,0.00009091}, {368,0.00017273}, {369,0.00009091}, {370,0.00019091}, {371,0.00022727}, {372,0.00020000}, {373,0.00016364}, {374,0.00022727}, {375,0.00017273}, {376,0.00010000}, {377,0.00014545}, {378,0.00019091}, {379,0.00020000}, {380,0.00022727}, {381,0.00016364}, {382,0.00030909}, {383,0.00031818}, {384,0.00022727}, {385,0.00020909}, {386,0.00027273}, {387,0.00016364}, {388,0.00009091}, {389,0.00016364}, {390,0.00022727}, {391,0.00032727}, {392,0.00028182}, {393,0.00007273}, {394,0.00022727}, {395,0.00009091}, {396,0.00008182}, {397,0.00030000}, {398,0.00040000}, {399,0.00013636}, {400,0.00019091}, {401,0.00023636}, {402,0.00022727}, {403,0.00013636}, {404,0.00018182}, {405,0.00013636}, {406,0.00018182}, {407,0.00023636}, {408,0.00020909}, {409,0.00010909}, {410,0.00020000}, {411,0.00025455}, {412,0.00032727}, {413,0.00022727}, {414,0.00030909}, {415,0.00021818}, {416,0.00024545}, {417,0.00015455}, {418,0.00031818}, {419,0.00033636}, {420,0.00033636}, {421,0.00022727}, {422,0.00020909}, {423,0.00026364}, {424,0.00030000}, {425,0.00027273}, {426,0.00024545}, {427,0.00009091}, {428,0.00029091}, {429,0.00039091}, {430,0.00031818}, {431,0.00025455}, {432,0.00015455}, {433,0.00013636}, {434,0.00030909}, {435,0.00029091}, {436,0.00033636}, {437,0.00034545}, {438,0.00014545}, {439,0.00013636}, {440,0.00017273}, {441,0.00038182}, {442,0.00030909}, {443,0.00024545}, {444,0.00036364}, {445,0.00018182}, {446,0.00033636}, {447,0.00027273}, {448,0.00020909}, {449,0.00023636}, {450,0.00020000}, {451,0.00018182}, {452,0.00023636}, {453,0.00012727}, {454,0.00012727}, {455,0.00028182}, {456,0.00026364}, {457,0.00030000}, {458,0.00024545}, {459,0.00025455}, {460,0.00013636}, {461,0.00026364}, {462,0.00015455}, {463,0.00019091}, {464,0.00019091}, {465,0.00018182}, {466,0.00024545}, {467,0.00020000}, {468,0.00027273}, {469,0.00026364}, {470,0.00024545}, {471,0.00026364}, {472,0.00027273}, {473,0.00006364}, {474,0.00020000}, {475,0.00021818}, {476,0.00016364}, {477,0.00018182}, {478,0.00029091}, {479,0.00013636}, {480,0.00030000}, {481,0.00029091}, {482,0.00023636}, {483,0.00037273}, {484,0.00022727}, {485,0.00037273}, {486,0.00037273}, {487,0.00016364}, {488,0.00025455}, {489,0.00030000}, {490,0.00260000}, {491,0.00026364}, {492,0.00027273}, {493,0.00025455}, {494,0.00014545}, {495,0.00038182}, {496,0.00030909}, {497,0.00023636}, {498,0.00023636}, {499,0.00005455}, {500,0.00012727}, {505,0.00025455}, {510,0.00043636}, {515,0.00032727}, {520,0.00020909}, {525,0.00026364}, {530,0.00006364}, {535,0.00050000}, {540,0.00040000}, {545,0.00007273}, {550,0.00020909}, {555,0.00029091}, {560,0.00045455}, {565,0.00030000}, {570,0.00020909}, {575,0.00030000}, {580,0.00056364}, {585,0.00033636}, {590,0.00051818}, {595,0.00021818}, {600,0.00046364}, {605,0.00033636}, {610,0.00055455}, {615,0.00038182}, {620,0.00040000}, {625,0.00027273}, {630,0.00020000}, {635,0.00053636}, {640,0.00052727}, {645,0.00049091}, {650,0.00032727}, {655,0.00027273}, {660,0.00022727}, {665,0.00045455}, {670,0.00048182}, {675,0.00036364}, {680,0.00037273}, {685,0.00033636}, {690,0.00040909}, {695,0.00040909}, {700,0.00026364}, {705,0.00028182}, {710,0.00021818}, {715,0.00044545}, {720,0.00040000}, {725,0.00069091}, {730,0.00036364}, {735,0.00040000}, {740,0.00044545}, {745,0.00031818}, {750,0.00034545}, {755,0.00038182}, {760,0.00049091}, {765,0.00036364}, {770,0.00038182}, {775,0.00050909}, {780,0.00049091}, {785,0.00052727}, {790,0.00040000}, {795,0.00043636}, {800,0.00058182}, {805,0.00052727}, {810,0.00054545}, {815,0.00060909}, {820,0.00050000}, {825,0.00053636}, {830,0.00043636}, {835,0.00027273}, {840,0.00047273}, {845,0.00037273}, {850,0.00062727}, {855,0.00069091}, {860,0.00043636}, {865,0.00044545}, {870,0.00032727}, {875,0.00048182}, {880,0.00044545}, {885,0.00047273}, {890,0.00037273}, {895,0.00048182}, {900,0.00037273}, {905,0.00073636}, {910,0.00053636}, {915,0.00041818}, {920,0.00043636}, {925,0.00048182}, {930,0.00470909}, {935,0.00059091}, {940,0.00041818}, {945,0.00075455}, {950,0.00061818}, {955,0.00048182}, {960,0.00033636}, {965,0.00049091}, {970,0.00060909}, {975,0.00054545}, {980,0.00048182}, {985,0.00033636}, {990,0.00050000}, {995,0.00055455}, {1000,0.00062727}, {1010,0.00076364}, {1020,0.00058182}, {1030,0.00054545}, {1040,0.00056364}, {1050,0.00078182}, {1060,0.00087273}, {1070,0.00050909}, {1080,0.00044545}, {1090,0.00030000}, {1100,0.00055455}, {1110,0.00073636}, {1120,0.00054545}, {1130,0.00041818}, {1140,0.00046364}, {1150,0.00060000}, {1160,0.00060909}, {1170,0.00043636}, {1180,0.00073636}, {1190,0.00057273}, {1200,0.00091818}, {1210,0.00059091}, {1220,0.00070909}, {1230,0.00077273}, {1240,0.00080000}, {1250,0.00082727}, {1260,0.00075455}, {1270,0.00059091}, {1280,0.00417273}, {1290,0.00072727}, {1300,0.00068182}, {1310,0.00064545}, {1320,0.00061818}, {1330,0.00063636}, {1340,0.00051818}, {1350,0.00066364}, {1360,0.00044545}, {1370,0.00065455}, {1380,0.00077273}, {1390,0.00090000}, {1400,0.00075455}, {1410,0.00067273}, {1420,0.00077273}, {1430,0.00080000}, {1440,0.00087273}, {1450,0.00068182}, {1460,0.00091818}, {1470,0.00077273}, {1480,0.00108182}, {1490,0.00061818}, {1500,0.00097273}, {1510,0.00088182}, {1520,0.00092727}, {1530,0.00080000}, {1540,0.00112727}, {1550,0.00089091}, {1560,0.00100000}, {1570,0.00083636}, {1580,0.00109091}, {1590,0.00089091}, {1600,0.00065455}, {1610,0.00080909}, {1620,0.00090909}, {1630,0.00085455}, {1640,0.00093636}, {1650,0.00068182}, {1660,0.00101818}, {1670,0.00503636}, {1680,0.00086364}, {1690,0.00076364}, {1700,0.00128182}, {1710,0.00099091}, {1720,0.00115455}, {1730,0.00093636}, {1740,0.00070000}, {1750,0.00101818}, {1760,0.00075455}, {1770,0.00104545}, {1780,0.00107273}, {1790,0.00104545}, {1800,0.00102727}, {1810,0.00083636}, {1820,0.00132727}, {1830,0.00083636}, {1840,0.00110909}, {1850,0.00117273}, {1860,0.00114545}, {1870,0.00130909}, {1880,0.00090000}, {1890,0.00098182}, {1900,0.00079091}, {1910,0.00085455}, {1920,0.00094545}, {1930,0.00069091}, {1940,0.00091818}, {1950,0.00123636}, {1960,0.00061818}, {1970,0.00117273}, {1980,0.00120000}, {1990,0.00112727}, {2000,0.00117273}, {2050,0.00114545}, {2100,0.00143636}, {2150,0.00138182}, {2200,0.00142727}, {2250,0.00128182}, {2300,0.00154545}, {2350,0.00070000}, {2400,0.00159091}, {2450,0.00177273}, {2500,0.00169091}, {2550,0.00168182}, {2600,0.00165455}, {2650,0.00130909}, {2700,0.00110909}, {2750,0.00185455}, {2800,0.00129091}, {2850,0.00190909}, {2900,0.00122727}, {2950,0.00204545}, {3000,0.00126364}, {3050,0.00210909}, {3100,0.00143636}, {3150,0.00206364}, {3200,0.00171818}, {3250,0.00205455}, {3300,0.00221818}, {3350,0.00220909}, {3400,0.00225455}, {3450,0.00142727}, {3500,0.00210000}, {3550,0.00252727}, {3600,0.00259091}, {3650,0.00231818}, {3700,0.00151818}, {3750,0.00237273}, {3800,0.00290909}, {3850,0.00268182}, {3900,0.00258182}, {3950,0.00273636}, {4000,0.01815455}, {4050,0.00260000}, {4100,0.00270909}, {4150,0.00142727}, {4200,0.00290000}, {4250,0.00270909}, {4300,0.00286364}, {4350,0.00300000}, {4400,0.00290000}, {4450,0.00309091}, {4500,0.00200000}, {4550,0.02224545}, {4600,0.00331818}, {4650,0.00336364}, {4700,0.00347273}, {4750,0.00218182}, {4800,0.00334545}, {4850,0.00340000}, {4900,0.00341818}, {4950,0.00352727}, {5000,0.00370000}, {5050,0.00249091}, {5100,0.02780909}, {5150,0.00364545}, {5200,0.00363636}, {5250,0.00370909}, {5300,0.00385455}, {5350,0.00368182}, {5400,0.00372727}, {5450,0.00242727}, {5500,0.00252727}, {5550,0.00275455}, {5600,0.00217273}, {5650,0.00216364}, {5700,0.02180909}, {5750,0.00391818}, {5800,0.00433636}, {5850,0.00457273}, {5900,0.00443636}, {5950,0.00465455}, {6000,0.00437273}, {6050,0.00397273}, {6100,0.02615455}, {6150,0.00257273}, {6200,0.00261818}, {6250,0.00263636}, {6300,0.00280909}, {6350,0.00289091}, {6400,0.00415455}, {6450,0.00442727}, {6500,0.00421818}, {6550,0.00459091}, {6600,0.00468182}, {6650,0.00511818}, {6700,0.02498182}, {6750,0.00307273}, {6800,0.00330909}, {6850,0.00488182}, {6900,0.00485455}, {6950,0.00492727}, {7000,0.00504545}, {7050,0.00300000}, {7100,0.00299091}, {7150,0.00486364}, {7200,0.00504545}, {7250,0.00510000}, {7300,0.00309091}, {7350,0.00512727}, {7400,0.00540000}, {7450,0.00569091}, {7500,0.00287273}, {7550,0.00525455}, {7600,0.00512727}, {7650,0.00316364}, {7700,0.00312727}, {7750,0.00554545}, {7800,0.00540909}, {7850,0.00337273}, {7900,0.00571818}, {7950,0.00589091}, {8000,0.00317273}, {8050,0.00585455}, {8100,0.00334545}, {8150,0.00330909}, {8200,0.00601818}, {8250,0.00350000}, {8300,0.00590000}, {8350,0.00569091}, {8400,0.00347273}, {8450,0.00600909}, {8500,0.00367273}, {8550,0.00601818}, {8600,0.00369091}, {8650,0.00605455}, {8700,0.00368182}, {8750,0.00655455}, {8800,0.03130000}, {8850,0.00632727}, {8900,0.03200000}, {8950,0.00665455}, {9000,0.02724545}, {9050,0.00678182}, {9100,0.00391818}, {9150,0.00655455}, {9200,0.00383636}, {9250,0.00660909}, {9300,0.00419091}, {9350,0.00688182}, {9400,0.00397273}, {9450,0.02540909}, {9500,0.00686364}, {9550,0.00457273}, {9600,0.00696364}, {9650,0.00400000}, {9700,0.00390909}, {9750,0.00708182}, {9800,0.00434545}, {9850,0.00461818}, {9900,0.00712727}, {9950,0.00437273}, {10000,0.00442727}, {10100,0.00734545}, {10200,0.00442727}, {10300,0.00469091}, {10400,0.00779091}, {10500,0.00779091}, {10600,0.00480000}, {10700,0.00498182}, {10800,0.00455455}, {10900,0.00840909}, {11000,0.00808182}, {11100,0.00817273}, {11200,0.00454545}, {11300,0.00532727}, {11400,0.00478182}, {11500,0.00517273}, {11600,0.00493636}, {11700,0.00501818}, {11800,0.00518182}, {11900,0.00536364}, {12000,0.00535455}, {12100,0.00510000}, {12200,0.00567273}, {12300,0.00533636}, {12400,0.00519091}, {12500,0.00520000}, {12600,0.00584545}, {12700,0.01007273}, {12800,0.01024545}, {12900,0.00606364}, {13000,0.00600909}, {13100,0.00612727}, {13200,0.00775455}, {13300,0.01071818}, {13400,0.00599091}, {13500,0.00606364}, {13600,0.00904545}, {13700,0.04018182}, {13800,0.00630000}, {13900,0.00643636}, {14000,0.04032727}, {14100,0.00661818}, {14200,0.01090909}, {14300,0.00667273}, {14400,0.00663636}, {14500,0.04035455}, {14600,0.00687273}, {14700,0.01183636}, {14800,0.00681818}, {14900,0.01185455}, {15000,0.00691818}, {15100,0.05681818}, {15200,0.00702727}, {15300,0.00709091}, {15400,0.00701818}, {15500,0.00700000}, {15600,0.01270000}, {15700,0.00701818}, {15800,0.00728182}, {15900,0.01186364}, {16000,0.00756364}, {16100,0.00740000}, {16200,0.05280909}, {16300,0.00725455}, {16400,0.00755455}, {16500,0.00751818}, {16600,0.04125455}, {16700,0.00780000}, {16800,0.00778182}, {16900,0.00780000}, {17000,0.00785455}, {17100,0.00773636}, {17200,0.00770000}, {17300,0.04685455}, {17400,0.01230000}, {17500,0.00796364}, {17600,0.00827273}, {17700,0.00850000}, {17800,0.00800000}, {17900,0.00830909}, {18000,0.00826364}, {18100,0.00848182}, {18200,0.00915455}, {18300,0.05281818}, {18400,0.03867273}, {18500,0.00850909}, {18600,0.00857273}, {18700,0.00827273}, {18800,0.00912727}, {18900,0.00860000}, {19000,0.01000909}, {19100,0.00904545}, {19200,0.00884545}, {19300,0.00868182}, {19400,0.00903636}, {19500,0.00897273}, {19600,0.00956364}, {19700,0.00970909}, {19800,0.03627273}, {19900,0.00964545}, {20000,0.00932407}};
data["big_flat"]["QuoteFlat"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00010909}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00003636}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00003636}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00003636}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00003636}, {153,0.00000000}, {154,0.00003636}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00003636}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00003636}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00003636}, {206,0.00000000}, {207,0.00000000}, {208,0.00003636}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00003636}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00003636}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00003636}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00003636}, {286,0.00002727}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00003636}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00003636}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00003636}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00002727}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00003636}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00002727}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00003636}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00003636}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00003636}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00003636}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00003636}, {488,0.00000000}, {489,0.00000000}, {490,0.00007273}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00003636}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00003636}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00003636}, {620,0.00000000}, {625,0.00003636}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00003636}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00003636}, {765,0.00000000}, {770,0.00003636}, {775,0.00007273}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00003636}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00003636}, {845,0.00003636}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00003636}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00003636}, {920,0.00000000}, {925,0.00003636}, {930,0.00007273}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00003636}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00003636}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00003636}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00006364}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00003636}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00003636}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00002727}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00002727}, {1550,0.00002727}, {1560,0.00003636}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00003636}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00010909}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00003636}, {1730,0.00000000}, {1740,0.00003636}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00003636}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00003636}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00003636}, {2100,0.00007273}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00003636}, {2300,0.00003636}, {2350,0.00003636}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00003636}, {2650,0.00000000}, {2700,0.00003636}, {2750,0.00000000}, {2800,0.00003636}, {2850,0.00000000}, {2900,0.00007273}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00007273}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00003636}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00003636}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00003636}, {3750,0.00000000}, {3800,0.00007273}, {3850,0.00000000}, {3900,0.00003636}, {3950,0.00000000}, {4000,0.00017273}, {4050,0.00002727}, {4100,0.00000000}, {4150,0.00002727}, {4200,0.00000000}, {4250,0.00007273}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00007273}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00018182}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00003636}, {4800,0.00003636}, {4850,0.00000000}, {4900,0.00003636}, {4950,0.00003636}, {5000,0.00000000}, {5050,0.00003636}, {5100,0.00020909}, {5150,0.00007273}, {5200,0.00003636}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00003636}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00003636}, {5550,0.00002727}, {5600,0.00014545}, {5650,0.00003636}, {5700,0.00025455}, {5750,0.00000000}, {5800,0.00003636}, {5850,0.00003636}, {5900,0.00006364}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00003636}, {6100,0.00035455}, {6150,0.00003636}, {6200,0.00000000}, {6250,0.00003636}, {6300,0.00000000}, {6350,0.00003636}, {6400,0.00002727}, {6450,0.00003636}, {6500,0.00003636}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00003636}, {6700,0.00058182}, {6750,0.00000000}, {6800,0.00007273}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00010909}, {7050,0.00003636}, {7100,0.00003636}, {7150,0.00003636}, {7200,0.00003636}, {7250,0.00003636}, {7300,0.00002727}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00007273}, {7500,0.00000000}, {7550,0.00007273}, {7600,0.00002727}, {7650,0.00007273}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00003636}, {7950,0.00000000}, {8000,0.00003636}, {8050,0.00010909}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00006364}, {8350,0.00000000}, {8400,0.00003636}, {8450,0.00000000}, {8500,0.00003636}, {8550,0.00000000}, {8600,0.00003636}, {8650,0.00003636}, {8700,0.00003636}, {8750,0.00000000}, {8800,0.00021818}, {8850,0.00000000}, {8900,0.00063636}, {8950,0.00003636}, {9000,0.00038182}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00003636}, {9200,0.00018182}, {9250,0.00003636}, {9300,0.00003636}, {9350,0.00007273}, {9400,0.00003636}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00003636}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00003636}, {9750,0.00003636}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00007273}, {10100,0.00000000}, {10200,0.00003636}, {10300,0.00010909}, {10400,0.00003636}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00006364}, {10800,0.00000000}, {10900,0.00003636}, {11000,0.00003636}, {11100,0.00003636}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00010909}, {11500,0.00010909}, {11600,0.00010909}, {11700,0.00014545}, {11800,0.00010909}, {11900,0.00014545}, {12000,0.00000000}, {12100,0.00003636}, {12200,0.00014545}, {12300,0.00003636}, {12400,0.00003636}, {12500,0.00007273}, {12600,0.00000000}, {12700,0.00003636}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00003636}, {13400,0.00000000}, {13500,0.00003636}, {13600,0.00003636}, {13700,0.00000000}, {13800,0.00006364}, {13900,0.00000000}, {14000,0.00003636}, {14100,0.00003636}, {14200,0.00003636}, {14300,0.00003636}, {14400,0.00000000}, {14500,0.00003636}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00003636}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00003636}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00014545}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00003636}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00003636}, {16600,0.00002727}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00003636}, {17000,0.00003636}, {17100,0.00000000}, {17200,0.00003636}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00007273}, {17600,0.00003636}, {17700,0.00003636}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00003636}, {18200,0.00003636}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00007273}, {18700,0.00000000}, {18800,0.00003636}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00003636}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00007273}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00013636}, {19900,0.00003636}, {20000,0.00002778}};
data["big_flat"]["QuoteFlat"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00030000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00103636}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00098182}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00001818}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000909}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000909}, {197,0.00000000}, {198,0.00000000}, {199,0.00000909}, {200,0.00000000}, {201,0.00000909}, {202,0.00000909}, {203,0.00002727}, {204,0.00001818}, {205,0.00000909}, {206,0.00001818}, {207,0.00001818}, {208,0.00005455}, {209,0.00000909}, {210,0.00001818}, {211,0.00004545}, {212,0.00005455}, {213,0.00008182}, {214,0.00011818}, {215,0.00008182}, {216,0.00018182}, {217,0.00011818}, {218,0.00024545}, {219,0.00029091}, {220,0.00028182}, {221,0.00035455}, {222,0.00046364}, {223,0.00042727}, {224,0.00046364}, {225,0.00057273}, {226,0.00065455}, {227,0.00069091}, {228,0.00078182}, {229,0.00077273}, {230,0.00200909}, {231,0.00085455}, {232,0.00086364}, {233,0.00090000}, {234,0.00093636}, {235,0.00096364}, {236,0.00096364}, {237,0.00098182}, {238,0.00099091}, {239,0.00099091}, {240,0.00100000}, {241,0.00100000}, {242,0.00100000}, {243,0.00100000}, {244,0.00100000}, {245,0.00100000}, {246,0.00100000}, {247,0.00100000}, {248,0.00100000}, {249,0.00100000}, {250,0.00100000}, {251,0.00100000}, {252,0.00100000}, {253,0.00100000}, {254,0.00100000}, {255,0.00100000}, {256,0.00100000}, {257,0.00100000}, {258,0.00100000}, {259,0.00100000}, {260,0.00100000}, {261,0.00100000}, {262,0.00100000}, {263,0.00100000}, {264,0.00100000}, {265,0.00100000}, {266,0.00100000}, {267,0.00100000}, {268,0.00100000}, {269,0.00100000}, {270,0.00100000}, {271,0.00100000}, {272,0.00100000}, {273,0.00100000}, {274,0.00100000}, {275,0.00100000}, {276,0.00100000}, {277,0.00100000}, {278,0.00100000}, {279,0.00100000}, {280,0.00100000}, {281,0.00100000}, {282,0.00100000}, {283,0.00100000}, {284,0.00100000}, {285,0.00100000}, {286,0.00100000}, {287,0.00100000}, {288,0.00100000}, {289,0.00100000}, {290,0.00100000}, {291,0.00100000}, {292,0.00100000}, {293,0.00100000}, {294,0.00100000}, {295,0.00100000}, {296,0.00100000}, {297,0.00100000}, {298,0.00100000}, {299,0.00100000}, {300,0.00100000}, {301,0.00100909}, {302,0.00100909}, {303,0.00100000}, {304,0.00100000}, {305,0.00100000}, {306,0.00100000}, {307,0.00100000}, {308,0.00100000}, {309,0.00100000}, {310,0.00100000}, {311,0.00100000}, {312,0.00100000}, {313,0.00100000}, {314,0.00100000}, {315,0.00100000}, {316,0.00100000}, {317,0.00100000}, {318,0.00100000}, {319,0.00100000}, {320,0.00101818}, {321,0.00198182}, {322,0.00100000}, {323,0.00100000}, {324,0.00100000}, {325,0.00100000}, {326,0.00100000}, {327,0.00100000}, {328,0.00100000}, {329,0.00100000}, {330,0.00100000}, {331,0.00100000}, {332,0.00100000}, {333,0.00100000}, {334,0.00100000}, {335,0.00100000}, {336,0.00100000}, {337,0.00100000}, {338,0.00100000}, {339,0.00100000}, {340,0.00100000}, {341,0.00100000}, {342,0.00100000}, {343,0.00100000}, {344,0.00100000}, {345,0.00100000}, {346,0.00100000}, {347,0.00100000}, {348,0.00100000}, {349,0.00100000}, {350,0.00100000}, {351,0.00100000}, {352,0.00100000}, {353,0.00100000}, {354,0.00100000}, {355,0.00100000}, {356,0.00100000}, {357,0.00100000}, {358,0.00100000}, {359,0.00100000}, {360,0.00100000}, {361,0.00100000}, {362,0.00100000}, {363,0.00100000}, {364,0.00100000}, {365,0.00100000}, {366,0.00294545}, {367,0.00100000}, {368,0.00100000}, {369,0.00100000}, {370,0.00100000}, {371,0.00100000}, {372,0.00100000}, {373,0.00100000}, {374,0.00100000}, {375,0.00100000}, {376,0.00100000}, {377,0.00100000}, {378,0.00100000}, {379,0.00100000}, {380,0.00315455}, {381,0.00100000}, {382,0.00100000}, {383,0.00100000}, {384,0.00100000}, {385,0.00100000}, {386,0.00100000}, {387,0.00100000}, {388,0.00100000}, {389,0.00100000}, {390,0.00100000}, {391,0.00100000}, {392,0.00100000}, {393,0.00100000}, {394,0.00100000}, {395,0.00100000}, {396,0.00100000}, {397,0.00100000}, {398,0.00100000}, {399,0.00100000}, {400,0.00100000}, {401,0.00100000}, {402,0.00100000}, {403,0.00100000}, {404,0.00100000}, {405,0.00100000}, {406,0.00103636}, {407,0.00100000}, {408,0.00100000}, {409,0.00100000}, {410,0.00100000}, {411,0.00100000}, {412,0.00100000}, {413,0.00100000}, {414,0.00100000}, {415,0.00100000}, {416,0.00100000}, {417,0.00100000}, {418,0.00100000}, {419,0.00100000}, {420,0.00100000}, {421,0.00100000}, {422,0.00100000}, {423,0.00100000}, {424,0.00100000}, {425,0.00100000}, {426,0.00100000}, {427,0.00100000}, {428,0.00100000}, {429,0.00100000}, {430,0.00100000}, {431,0.00100000}, {432,0.00361818}, {433,0.00100000}, {434,0.00100000}, {435,0.00100000}, {436,0.00100000}, {437,0.00100000}, {438,0.00100000}, {439,0.00100000}, {440,0.00100000}, {441,0.00100000}, {442,0.00100000}, {443,0.00100000}, {444,0.00100000}, {445,0.00100000}, {446,0.00100000}, {447,0.00100000}, {448,0.00100000}, {449,0.00100000}, {450,0.00100000}, {451,0.00100000}, {452,0.00100000}, {453,0.00100000}, {454,0.00100000}, {455,0.00100000}, {456,0.00381818}, {457,0.00100000}, {458,0.00100909}, {459,0.00100909}, {460,0.00100000}, {461,0.00100000}, {462,0.00100000}, {463,0.00100000}, {464,0.00100000}, {465,0.00100000}, {466,0.00100000}, {467,0.00104545}, {468,0.00100000}, {469,0.00100909}, {470,0.00100000}, {471,0.00100909}, {472,0.00100909}, {473,0.00101818}, {474,0.00104545}, {475,0.00101818}, {476,0.00103636}, {477,0.00106364}, {478,0.00106364}, {479,0.00396364}, {480,0.00102727}, {481,0.00102727}, {482,0.00107273}, {483,0.00105455}, {484,0.00110000}, {485,0.00106364}, {486,0.00110000}, {487,0.00111818}, {488,0.00112727}, {489,0.00110909}, {490,0.00117273}, {491,0.00113636}, {492,0.00117273}, {493,0.00119091}, {494,0.00128182}, {495,0.00128182}, {496,0.00131818}, {497,0.00134545}, {498,0.00134545}, {499,0.00139091}, {500,0.00144545}, {505,0.00385455}, {510,0.00171818}, {515,0.00185455}, {520,0.00187273}, {525,0.00195455}, {530,0.00200000}, {535,0.00200000}, {540,0.00200000}, {545,0.00200000}, {550,0.00200000}, {555,0.00200000}, {560,0.00200000}, {565,0.00200000}, {570,0.00200000}, {575,0.00200000}, {580,0.00200000}, {585,0.00200000}, {590,0.00200000}, {595,0.00200000}, {600,0.00205455}, {605,0.00200000}, {610,0.00200000}, {615,0.00200000}, {620,0.00200000}, {625,0.00200000}, {630,0.00200000}, {635,0.00200000}, {640,0.00200000}, {645,0.00203636}, {650,0.00200000}, {655,0.00200000}, {660,0.00200000}, {665,0.00200000}, {670,0.00200000}, {675,0.00200000}, {680,0.00200000}, {685,0.00200000}, {690,0.00200000}, {695,0.00200000}, {700,0.00200909}, {705,0.00200000}, {710,0.00201818}, {715,0.00200000}, {720,0.00200000}, {725,0.00207273}, {730,0.00200909}, {735,0.00206364}, {740,0.00202727}, {745,0.00211818}, {750,0.00209091}, {755,0.00220000}, {760,0.00226364}, {765,0.00511818}, {770,0.00244545}, {775,0.00257273}, {780,0.00266364}, {785,0.00278182}, {790,0.00281818}, {795,0.00287273}, {800,0.00293636}, {805,0.00294545}, {810,0.00299091}, {815,0.00297273}, {820,0.00297273}, {825,0.00300000}, {830,0.00300000}, {835,0.00540000}, {840,0.00300000}, {845,0.00300000}, {850,0.00300000}, {855,0.00300000}, {860,0.00300000}, {865,0.00300000}, {870,0.00300000}, {875,0.00300909}, {880,0.00300000}, {885,0.00300000}, {890,0.00300000}, {895,0.00300000}, {900,0.00521818}, {905,0.00300000}, {910,0.00300000}, {915,0.00300000}, {920,0.00300909}, {925,0.00300000}, {930,0.00300909}, {935,0.00300909}, {940,0.00300909}, {945,0.00300909}, {950,0.00303636}, {955,0.00301818}, {960,0.00865455}, {965,0.00302727}, {970,0.00301818}, {975,0.00302727}, {980,0.00306364}, {985,0.00307273}, {990,0.00521818}, {995,0.00310909}, {1000,0.00313636}, {1010,0.00325455}, {1020,0.00336364}, {1030,0.00348182}, {1040,0.00360909}, {1050,0.00374545}, {1060,0.00383636}, {1070,0.00385455}, {1080,0.00393636}, {1090,0.00565455}, {1100,0.00397273}, {1110,0.00400000}, {1120,0.00400000}, {1130,0.00400000}, {1140,0.00687273}, {1150,0.00400909}, {1160,0.00400000}, {1170,0.00401818}, {1180,0.00401818}, {1190,0.00862727}, {1200,0.00403636}, {1210,0.00403636}, {1220,0.00405455}, {1230,0.00414545}, {1240,0.00413636}, {1250,0.00425455}, {1260,0.00436364}, {1270,0.00445455}, {1280,0.00460909}, {1290,0.00468182}, {1300,0.00476364}, {1310,0.00482727}, {1320,0.00483636}, {1330,0.00485455}, {1340,0.00491818}, {1350,0.00496364}, {1360,0.00496364}, {1370,0.00499091}, {1380,0.00500909}, {1390,0.00500909}, {1400,0.00500909}, {1410,0.00842727}, {1420,0.00501818}, {1430,0.00506364}, {1440,0.00507273}, {1450,0.00830909}, {1460,0.00513636}, {1470,0.00514545}, {1480,0.00525455}, {1490,0.01140000}, {1500,0.00543636}, {1510,0.00553636}, {1520,0.00560000}, {1530,0.00561818}, {1540,0.00570909}, {1550,0.00577273}, {1560,0.00582727}, {1570,0.00584545}, {1580,0.00591818}, {1590,0.00593636}, {1600,0.01210909}, {1610,0.00593636}, {1620,0.00598182}, {1630,0.00600909}, {1640,0.00600000}, {1650,0.00600000}, {1660,0.00600909}, {1670,0.00613636}, {1680,0.00613636}, {1690,0.00612727}, {1700,0.00616364}, {1710,0.00617273}, {1720,0.00627273}, {1730,0.00635455}, {1740,0.00930000}, {1750,0.00654545}, {1760,0.00665455}, {1770,0.00672727}, {1780,0.00668182}, {1790,0.00678182}, {1800,0.00681818}, {1810,0.00683636}, {1820,0.00690000}, {1830,0.00690000}, {1840,0.00689091}, {1850,0.00694545}, {1860,0.00697273}, {1870,0.00695455}, {1880,0.00702727}, {1890,0.00702727}, {1900,0.01100000}, {1910,0.00706364}, {1920,0.00711818}, {1930,0.00986364}, {1940,0.00724545}, {1950,0.00726364}, {1960,0.00999091}, {1970,0.00737273}, {1980,0.00744545}, {1990,0.00745455}, {2000,0.00761818}, {2050,0.00780000}, {2100,0.00791818}, {2150,0.00811818}, {2200,0.00835455}, {2250,0.00868182}, {2300,0.00884545}, {2350,0.01323636}, {2400,0.00915455}, {2450,0.00939091}, {2500,0.00972727}, {2550,0.00987273}, {2600,0.01000000}, {2650,0.01014545}, {2700,0.01686364}, {2750,0.01077273}, {2800,0.01910000}, {2850,0.01110909}, {2900,0.02710000}, {2950,0.01156364}, {3000,0.02541818}, {3050,0.01191818}, {3100,0.02256364}, {3150,0.01234545}, {3200,0.01192727}, {3250,0.01288182}, {3300,0.01303636}, {3350,0.01314545}, {3400,0.01334545}, {3450,0.03120000}, {3500,0.01391818}, {3550,0.01405455}, {3600,0.01427273}, {3650,0.01446364}, {3700,0.02963636}, {3750,0.01493636}, {3800,0.01513636}, {3850,0.01560000}, {3900,0.01554545}, {3950,0.01588182}, {4000,0.01631818}, {4050,0.01618182}, {4100,0.01637273}, {4150,0.02955455}, {4200,0.01689091}, {4250,0.01708182}, {4300,0.01710000}, {4350,0.01792727}, {4400,0.01788182}, {4450,0.01809091}, {4500,0.01668182}, {4550,0.01873636}, {4600,0.01860909}, {4650,0.01893636}, {4700,0.01918182}, {4750,0.03429091}, {4800,0.01992727}, {4850,0.01981818}, {4900,0.02009091}, {4950,0.02029091}, {5000,0.02050000}, {5050,0.03553636}, {5100,0.02128182}, {5150,0.02115455}, {5200,0.02135455}, {5250,0.02153636}, {5300,0.02185455}, {5350,0.02190909}, {5400,0.02228182}, {5450,0.02044545}, {5500,0.03083636}, {5550,0.03740909}, {5600,0.05471818}, {5650,0.05498182}, {5700,0.02417273}, {5750,0.02444545}, {5800,0.02411818}, {5850,0.02434545}, {5900,0.02451818}, {5950,0.02469091}, {6000,0.02500000}, {6050,0.02590000}, {6100,0.02586364}, {6150,0.05628182}, {6200,0.05107273}, {6250,0.05061818}, {6300,0.05007273}, {6350,0.05081818}, {6400,0.02620909}, {6450,0.02690000}, {6500,0.02712727}, {6550,0.02744545}, {6600,0.02758182}, {6650,0.02763636}, {6700,0.02848182}, {6750,0.05260000}, {6800,0.04738182}, {6850,0.02860000}, {6900,0.02887273}, {6950,0.02896364}, {7000,0.02934545}, {7050,0.05281818}, {7100,0.04853636}, {7150,0.02988182}, {7200,0.03017273}, {7250,0.03111818}, {7300,0.05547273}, {7350,0.03065455}, {7400,0.03098182}, {7450,0.03127273}, {7500,0.04960000}, {7550,0.03153636}, {7600,0.03180000}, {7650,0.06560909}, {7700,0.04342727}, {7750,0.03242727}, {7800,0.03335455}, {7850,0.05083636}, {7900,0.03303636}, {7950,0.03326364}, {8000,0.04899091}, {8050,0.03363636}, {8100,0.07238182}, {8150,0.04250909}, {8200,0.03434545}, {8250,0.05971818}, {8300,0.03469091}, {8350,0.03570000}, {8400,0.05459091}, {8450,0.03538182}, {8500,0.05665455}, {8550,0.03583636}, {8600,0.06667273}, {8650,0.03625455}, {8700,0.07476364}, {8750,0.03668182}, {8800,0.03747273}, {8850,0.03713636}, {8900,0.03816364}, {8950,0.03748182}, {9000,0.03863636}, {9050,0.03789091}, {9100,0.08189091}, {9150,0.03826364}, {9200,0.06942727}, {9250,0.03870909}, {9300,0.05890909}, {9350,0.03912727}, {9400,0.04891818}, {9450,0.04019091}, {9500,0.03970000}, {9550,0.06619091}, {9600,0.04022727}, {9650,0.05501818}, {9700,0.09126364}, {9750,0.04079091}, {9800,0.05239091}, {9850,0.07980909}, {9900,0.04149091}, {9950,0.05759091}, {10000,0.09178182}, {10100,0.04225455}, {10200,0.05723636}, {10300,0.08109091}, {10400,0.04340000}, {10500,0.04400000}, {10600,0.05717273}, {10700,0.06909091}, {10800,0.08142727}, {10900,0.04560909}, {11000,0.04599091}, {11100,0.04643636}, {11200,0.06052727}, {11300,0.06374545}, {11400,0.07957273}, {11500,0.07811818}, {11600,0.08239091}, {11700,0.08235455}, {11800,0.07516364}, {11900,0.08459091}, {12000,0.08419091}, {12100,0.08213636}, {12200,0.07906364}, {12300,0.07830000}, {12400,0.07819091}, {12500,0.06898182}, {12600,0.04814545}, {12700,0.05315455}, {12800,0.05358182}, {12900,0.09945455}, {13000,0.08699091}, {13100,0.07557273}, {13200,0.05224545}, {13300,0.05573636}, {13400,0.09881818}, {13500,0.07994545}, {13600,0.05523636}, {13700,0.05841818}, {13800,0.08565455}, {13900,0.07207273}, {14000,0.05961818}, {14100,0.08381818}, {14200,0.05941818}, {14300,0.11461818}, {14400,0.07696364}, {14500,0.06197273}, {14600,0.07943636}, {14700,0.06149091}, {14800,0.08536364}, {14900,0.06220909}, {15000,0.35006364}, {15100,0.06428182}, {15200,0.07668182}, {15300,0.13379091}, {15400,0.07930909}, {15500,0.09915455}, {15600,0.06494545}, {15700,0.08179091}, {15800,0.12420000}, {15900,0.06617273}, {16000,0.08357273}, {16100,0.12210909}, {16200,0.06881818}, {16300,0.08173636}, {16400,0.09427273}, {16500,0.12539091}, {16600,0.07036364}, {16700,0.06341818}, {16800,0.08206364}, {16900,0.09739091}, {17000,0.12144545}, {17100,0.13163636}, {17200,0.13986364}, {17300,0.07334545}, {17400,0.07007273}, {17500,0.08120000}, {17600,0.08329091}, {17700,0.08430000}, {17800,0.08040000}, {17900,0.09253636}, {18000,0.09160000}, {18100,0.08518182}, {18200,0.08185455}, {18300,0.07281818}, {18400,0.07800000}, {18500,0.14587273}, {18600,0.14118182}, {18700,0.13064545}, {18800,0.10047273}, {18900,0.09297273}, {19000,0.08745455}, {19100,0.14699091}, {19200,0.13800000}, {19300,0.11951818}, {19400,0.09320000}, {19500,0.15051818}, {19600,0.13662727}, {19700,0.09852727}, {19800,0.08074545}, {19900,0.14574545}, {20000,0.09687037}};
data["big_flat"]["QuoteFlat"]["norm reif"]["user"] = {{1,0.00006364}, {2,0.00016364}, {3,0.00016364}, {4,0.00012727}, {5,0.00025455}, {6,0.00017273}, {7,0.00010909}, {8,0.00036364}, {9,0.00015455}, {10,0.00016364}, {11,0.00018182}, {12,0.00019091}, {13,0.00019091}, {14,0.00023636}, {15,0.00000000}, {16,0.00021818}, {17,0.00030909}, {18,0.00025455}, {19,0.00035455}, {20,0.00017273}, {21,0.00024545}, {22,0.00022727}, {23,0.00022727}, {24,0.00038182}, {25,0.00026364}, {26,0.00019091}, {27,0.00043636}, {28,0.00022727}, {29,0.00024545}, {30,0.00018182}, {31,0.00016364}, {32,0.00024545}, {33,0.00013636}, {34,0.00030909}, {35,0.00060000}, {36,0.00036364}, {37,0.00022727}, {38,0.00054545}, {39,0.00027273}, {40,0.00016364}, {41,0.00025455}, {42,0.00012727}, {43,0.00036364}, {44,0.00020000}, {45,0.00039091}, {46,0.00021818}, {47,0.00038182}, {48,0.00022727}, {49,0.00032727}, {50,0.00015455}, {51,0.00024545}, {52,0.00023636}, {53,0.00038182}, {54,0.00013636}, {55,0.00031818}, {56,0.00012727}, {57,0.00056364}, {58,0.00017273}, {59,0.00049091}, {60,0.00047273}, {61,0.00049091}, {62,0.00038182}, {63,0.00056364}, {64,0.00037273}, {65,0.00026364}, {66,0.00028182}, {67,0.00037273}, {68,0.00052727}, {69,0.00024545}, {70,0.00031818}, {71,0.00039091}, {72,0.00041818}, {73,0.00048182}, {74,0.00047273}, {75,0.00022727}, {76,0.00045455}, {77,0.00056364}, {78,0.00054545}, {79,0.00040909}, {80,0.00039091}, {81,0.00054545}, {82,0.00050909}, {83,0.00034545}, {84,0.00048182}, {85,0.00046364}, {86,0.00053636}, {87,0.00035455}, {88,0.00041818}, {89,0.00052727}, {90,0.00153636}, {91,0.00051818}, {92,0.00060000}, {93,0.00061818}, {94,0.00041818}, {95,0.00063636}, {96,0.00057273}, {97,0.00035455}, {98,0.00055455}, {99,0.00039091}, {100,0.00038182}, {101,0.00046364}, {102,0.00040909}, {103,0.00063636}, {104,0.00044545}, {105,0.00061818}, {106,0.00039091}, {107,0.00046364}, {108,0.00060000}, {109,0.00028182}, {110,0.00060909}, {111,0.00046364}, {112,0.00063636}, {113,0.00044545}, {114,0.00043636}, {115,0.00043636}, {116,0.00035455}, {117,0.00056364}, {118,0.00072727}, {119,0.00060000}, {120,0.00037273}, {121,0.00044545}, {122,0.00071818}, {123,0.00077273}, {124,0.00040000}, {125,0.00052727}, {126,0.00058182}, {127,0.00151818}, {128,0.00065455}, {129,0.00062727}, {130,0.00076364}, {131,0.00043636}, {132,0.00073636}, {133,0.00057273}, {134,0.00090000}, {135,0.00052727}, {136,0.00045455}, {137,0.00057273}, {138,0.00060909}, {139,0.00099091}, {140,0.00041818}, {141,0.00049091}, {142,0.00060909}, {143,0.00072727}, {144,0.00064545}, {145,0.00088182}, {146,0.00060000}, {147,0.00055455}, {148,0.00063636}, {149,0.00071818}, {150,0.00056364}, {151,0.00072727}, {152,0.00066364}, {153,0.00075455}, {154,0.00065455}, {155,0.00053636}, {156,0.00064545}, {157,0.00060909}, {158,0.00056364}, {159,0.00058182}, {160,0.00070000}, {161,0.00081818}, {162,0.00067273}, {163,0.00080000}, {164,0.00075455}, {165,0.00070000}, {166,0.00061818}, {167,0.00041818}, {168,0.00042727}, {169,0.00051818}, {170,0.00078182}, {171,0.00080909}, {172,0.00089091}, {173,0.00086364}, {174,0.00092727}, {175,0.00090909}, {176,0.00087273}, {177,0.00070909}, {178,0.00079091}, {179,0.00059091}, {180,0.00073636}, {181,0.00067273}, {182,0.00063636}, {183,0.00063636}, {184,0.00077273}, {185,0.00072727}, {186,0.00070000}, {187,0.00072727}, {188,0.00067273}, {189,0.00071818}, {190,0.00074545}, {191,0.00077273}, {192,0.00079091}, {193,0.00066364}, {194,0.00072727}, {195,0.00074545}, {196,0.00087273}, {197,0.00083636}, {198,0.00100000}, {199,0.00110000}, {200,0.00099091}, {201,0.00097273}, {202,0.00101818}, {203,0.00090000}, {204,0.00096364}, {205,0.00077273}, {206,0.00087273}, {207,0.00093636}, {208,0.00085455}, {209,0.00099091}, {210,0.00094545}, {211,0.00075455}, {212,0.00082727}, {213,0.00090909}, {214,0.00103636}, {215,0.00088182}, {216,0.00061818}, {217,0.00050909}, {218,0.00067273}, {219,0.00090909}, {220,0.00106364}, {221,0.00105455}, {222,0.00084545}, {223,0.00090000}, {224,0.00080909}, {225,0.00075455}, {226,0.00092727}, {227,0.00100909}, {228,0.00101818}, {229,0.00079091}, {230,0.00202727}, {231,0.00100909}, {232,0.00121818}, {233,0.00092727}, {234,0.00065455}, {235,0.00086364}, {236,0.00075455}, {237,0.00098182}, {238,0.00102727}, {239,0.00108182}, {240,0.00098182}, {241,0.00092727}, {242,0.00060000}, {243,0.00101818}, {244,0.00092727}, {245,0.00068182}, {246,0.00107273}, {247,0.00081818}, {248,0.00114545}, {249,0.00090000}, {250,0.00099091}, {251,0.00098182}, {252,0.00117273}, {253,0.00094545}, {254,0.00083636}, {255,0.00094545}, {256,0.00116364}, {257,0.00098182}, {258,0.00080000}, {259,0.00106364}, {260,0.00098182}, {261,0.00115455}, {262,0.00072727}, {263,0.00100000}, {264,0.00120909}, {265,0.00080000}, {266,0.00090000}, {267,0.00141818}, {268,0.00097273}, {269,0.00079091}, {270,0.00147273}, {271,0.00094545}, {272,0.00096364}, {273,0.00123636}, {274,0.00119091}, {275,0.00092727}, {276,0.00116364}, {277,0.00094545}, {278,0.00100909}, {279,0.00113636}, {280,0.00102727}, {281,0.00101818}, {282,0.00112727}, {283,0.00118182}, {284,0.00104545}, {285,0.00116364}, {286,0.00113636}, {287,0.00108182}, {288,0.00106364}, {289,0.00101818}, {290,0.00143636}, {291,0.00072727}, {292,0.00100000}, {293,0.00117273}, {294,0.00130000}, {295,0.00103636}, {296,0.00081818}, {297,0.00113636}, {298,0.00110909}, {299,0.00106364}, {300,0.00108182}, {301,0.00110000}, {302,0.00092727}, {303,0.00103636}, {304,0.00121818}, {305,0.00109091}, {306,0.00080909}, {307,0.00139091}, {308,0.00136364}, {309,0.00118182}, {310,0.00125455}, {311,0.00109091}, {312,0.00108182}, {313,0.00134545}, {314,0.00098182}, {315,0.00131818}, {316,0.00110909}, {317,0.00111818}, {318,0.00130000}, {319,0.00102727}, {320,0.00120909}, {321,0.00227273}, {322,0.00107273}, {323,0.00117273}, {324,0.00095455}, {325,0.00130909}, {326,0.00104545}, {327,0.00122727}, {328,0.00106364}, {329,0.00142727}, {330,0.00110000}, {331,0.00130909}, {332,0.00111818}, {333,0.00136364}, {334,0.00120909}, {335,0.00112727}, {336,0.00128182}, {337,0.00148182}, {338,0.00134545}, {339,0.00123636}, {340,0.00142727}, {341,0.00125455}, {342,0.00136364}, {343,0.00125455}, {344,0.00135455}, {345,0.00128182}, {346,0.00113636}, {347,0.00120000}, {348,0.00119091}, {349,0.00150909}, {350,0.00139091}, {351,0.00128182}, {352,0.00150909}, {353,0.00132727}, {354,0.00123636}, {355,0.00171818}, {356,0.00097273}, {357,0.00147273}, {358,0.00132727}, {359,0.00117273}, {360,0.00126364}, {361,0.00137273}, {362,0.00118182}, {363,0.00149091}, {364,0.00132727}, {365,0.00138182}, {366,0.00300000}, {367,0.00154545}, {368,0.00136364}, {369,0.00143636}, {370,0.00130000}, {371,0.00145455}, {372,0.00106364}, {373,0.00149091}, {374,0.00161818}, {375,0.00117273}, {376,0.00126364}, {377,0.00140000}, {378,0.00144545}, {379,0.00132727}, {380,0.00340909}, {381,0.00114545}, {382,0.00155455}, {383,0.00129091}, {384,0.00140000}, {385,0.00157273}, {386,0.00138182}, {387,0.00147273}, {388,0.00141818}, {389,0.00139091}, {390,0.00161818}, {391,0.00156364}, {392,0.00121818}, {393,0.00150000}, {394,0.00140000}, {395,0.00147273}, {396,0.00149091}, {397,0.00176364}, {398,0.00123636}, {399,0.00128182}, {400,0.00157273}, {401,0.00160000}, {402,0.00130909}, {403,0.00170000}, {404,0.00138182}, {405,0.00141818}, {406,0.00154545}, {407,0.00162727}, {408,0.00170909}, {409,0.00139091}, {410,0.00134545}, {411,0.00152727}, {412,0.00153636}, {413,0.00139091}, {414,0.00146364}, {415,0.00184545}, {416,0.00145455}, {417,0.00149091}, {418,0.00145455}, {419,0.00167273}, {420,0.00156364}, {421,0.00147273}, {422,0.00144545}, {423,0.00152727}, {424,0.00132727}, {425,0.00122727}, {426,0.00152727}, {427,0.00198182}, {428,0.00179091}, {429,0.00183636}, {430,0.00147273}, {431,0.00148182}, {432,0.00360000}, {433,0.00179091}, {434,0.00167273}, {435,0.00140000}, {436,0.00134545}, {437,0.00145455}, {438,0.00132727}, {439,0.00139091}, {440,0.00177273}, {441,0.00172727}, {442,0.00190000}, {443,0.00184545}, {444,0.00170000}, {445,0.00180909}, {446,0.00157273}, {447,0.00170909}, {448,0.00186364}, {449,0.00180909}, {450,0.00182727}, {451,0.00166364}, {452,0.00181818}, {453,0.00195455}, {454,0.00179091}, {455,0.00157273}, {456,0.00379091}, {457,0.00168182}, {458,0.00163636}, {459,0.00162727}, {460,0.00160000}, {461,0.00150000}, {462,0.00170000}, {463,0.00166364}, {464,0.00179091}, {465,0.00177273}, {466,0.00161818}, {467,0.00174545}, {468,0.00192727}, {469,0.00203636}, {470,0.00190000}, {471,0.00180909}, {472,0.00184545}, {473,0.00193636}, {474,0.00176364}, {475,0.00182727}, {476,0.00166364}, {477,0.00151818}, {478,0.00163636}, {479,0.00408182}, {480,0.00179091}, {481,0.00156364}, {482,0.00146364}, {483,0.00137273}, {484,0.00138182}, {485,0.00141818}, {486,0.00156364}, {487,0.00180909}, {488,0.00179091}, {489,0.00180000}, {490,0.00169091}, {491,0.00203636}, {492,0.00192727}, {493,0.00199091}, {494,0.00176364}, {495,0.00200000}, {496,0.00187273}, {497,0.00194545}, {498,0.00196364}, {499,0.00205455}, {500,0.00175455}, {505,0.00380909}, {510,0.00198182}, {515,0.00184545}, {520,0.00192727}, {525,0.00200000}, {530,0.00207273}, {535,0.00163636}, {540,0.00175455}, {545,0.00218182}, {550,0.00180909}, {555,0.00217273}, {560,0.00218182}, {565,0.00199091}, {570,0.00199091}, {575,0.00219091}, {580,0.00190000}, {585,0.00235455}, {590,0.00197273}, {595,0.00243636}, {600,0.00217273}, {605,0.00212727}, {610,0.00205455}, {615,0.00219091}, {620,0.00221818}, {625,0.00208182}, {630,0.00236364}, {635,0.00205455}, {640,0.00219091}, {645,0.00232727}, {650,0.00228182}, {655,0.00233636}, {660,0.00231818}, {665,0.00240909}, {670,0.00208182}, {675,0.00229091}, {680,0.00244545}, {685,0.00226364}, {690,0.00233636}, {695,0.00230909}, {700,0.00258182}, {705,0.00257273}, {710,0.00252727}, {715,0.00264545}, {720,0.00255455}, {725,0.00261818}, {730,0.00241818}, {735,0.00265455}, {740,0.00246364}, {745,0.00260909}, {750,0.00272727}, {755,0.00243636}, {760,0.00227273}, {765,0.00506364}, {770,0.00269091}, {775,0.00264545}, {780,0.00274545}, {785,0.00275455}, {790,0.00290909}, {795,0.00272727}, {800,0.00270000}, {805,0.00259091}, {810,0.00279091}, {815,0.00284545}, {820,0.00272727}, {825,0.00286364}, {830,0.00295455}, {835,0.00546364}, {840,0.00309091}, {845,0.00304545}, {850,0.00286364}, {855,0.00264545}, {860,0.00290909}, {865,0.00321818}, {870,0.00315455}, {875,0.00307273}, {880,0.00309091}, {885,0.00303636}, {890,0.00319091}, {895,0.00301818}, {900,0.00521818}, {905,0.00294545}, {910,0.00316364}, {915,0.00331818}, {920,0.00328182}, {925,0.00321818}, {930,0.00330909}, {935,0.00322727}, {940,0.00339091}, {945,0.00329091}, {950,0.00331818}, {955,0.00318182}, {960,0.00839091}, {965,0.00345455}, {970,0.00332727}, {975,0.00346364}, {980,0.00345455}, {985,0.00363636}, {990,0.00511818}, {995,0.00353636}, {1000,0.00345455}, {1010,0.00352727}, {1020,0.00372727}, {1030,0.00365455}, {1040,0.00357273}, {1050,0.00379091}, {1060,0.00368182}, {1070,0.00377273}, {1080,0.00389091}, {1090,0.00564545}, {1100,0.00364545}, {1110,0.00400000}, {1120,0.00385455}, {1130,0.00393636}, {1140,0.00650000}, {1150,0.00416364}, {1160,0.00419091}, {1170,0.00420909}, {1180,0.00418182}, {1190,0.00855455}, {1200,0.00394545}, {1210,0.00423636}, {1220,0.00435455}, {1230,0.00439091}, {1240,0.00455455}, {1250,0.00440000}, {1260,0.00444545}, {1270,0.00454545}, {1280,0.00445455}, {1290,0.00429091}, {1300,0.00462727}, {1310,0.00484545}, {1320,0.00448182}, {1330,0.00471818}, {1340,0.00472727}, {1350,0.00483636}, {1360,0.00490000}, {1370,0.00482727}, {1380,0.00478182}, {1390,0.00483636}, {1400,0.00500909}, {1410,0.00839091}, {1420,0.00514545}, {1430,0.00506364}, {1440,0.00480909}, {1450,0.00800909}, {1460,0.00520000}, {1470,0.00540909}, {1480,0.00510909}, {1490,0.01150000}, {1500,0.00504545}, {1510,0.00535455}, {1520,0.00529091}, {1530,0.00550000}, {1540,0.00527273}, {1550,0.00584545}, {1560,0.00571818}, {1570,0.00524545}, {1580,0.00550000}, {1590,0.00578182}, {1600,0.01210000}, {1610,0.00578182}, {1620,0.00567273}, {1630,0.00596364}, {1640,0.00586364}, {1650,0.00583636}, {1660,0.00581818}, {1670,0.00615455}, {1680,0.00615455}, {1690,0.00606364}, {1700,0.00598182}, {1710,0.00594545}, {1720,0.00608182}, {1730,0.00632727}, {1740,0.00916364}, {1750,0.00606364}, {1760,0.00670909}, {1770,0.00651818}, {1780,0.00630909}, {1790,0.00643636}, {1800,0.00655455}, {1810,0.00667273}, {1820,0.00653636}, {1830,0.00675455}, {1840,0.00662727}, {1850,0.00675455}, {1860,0.00672727}, {1870,0.00654545}, {1880,0.00692727}, {1890,0.00680000}, {1900,0.01120909}, {1910,0.00691818}, {1920,0.00705455}, {1930,0.00973636}, {1940,0.00688182}, {1950,0.00695455}, {1960,0.01004545}, {1970,0.00717273}, {1980,0.00718182}, {1990,0.00717273}, {2000,0.00743636}, {2050,0.00752727}, {2100,0.00763636}, {2150,0.00806364}, {2200,0.00850909}, {2250,0.00850909}, {2300,0.00840909}, {2350,0.01357273}, {2400,0.00912727}, {2450,0.00930000}, {2500,0.00954545}, {2550,0.00975455}, {2600,0.01021818}, {2650,0.01051818}, {2700,0.01673636}, {2750,0.01097273}, {2800,0.01880909}, {2850,0.01162727}, {2900,0.02701818}, {2950,0.01175455}, {3000,0.02530000}, {3050,0.01218182}, {3100,0.02221818}, {3150,0.01266364}, {3200,0.01222727}, {3250,0.01300909}, {3300,0.01330909}, {3350,0.01351818}, {3400,0.01359091}, {3450,0.03116364}, {3500,0.01410000}, {3550,0.01420000}, {3600,0.01424545}, {3650,0.01470909}, {3700,0.02976364}, {3750,0.01507273}, {3800,0.01506364}, {3850,0.01556364}, {3900,0.01556364}, {3950,0.01555455}, {4000,0.01618182}, {4050,0.01628182}, {4100,0.01655455}, {4150,0.02967273}, {4200,0.01695455}, {4250,0.01700909}, {4300,0.01685455}, {4350,0.01779091}, {4400,0.01743636}, {4450,0.01790000}, {4500,0.01662727}, {4550,0.01856364}, {4600,0.01833636}, {4650,0.01859091}, {4700,0.01894545}, {4750,0.03393636}, {4800,0.01970000}, {4850,0.01962727}, {4900,0.01970909}, {4950,0.02004545}, {5000,0.02001818}, {5050,0.03518182}, {5100,0.02119091}, {5150,0.02072727}, {5200,0.02126364}, {5250,0.02155455}, {5300,0.02199091}, {5350,0.02196364}, {5400,0.02234545}, {5450,0.02049091}, {5500,0.03094545}, {5550,0.03690909}, {5600,0.05441818}, {5650,0.05459091}, {5700,0.02434545}, {5750,0.02445455}, {5800,0.02399091}, {5850,0.02421818}, {5900,0.02447273}, {5950,0.02479091}, {6000,0.02501818}, {6050,0.02616364}, {6100,0.02592727}, {6150,0.05570000}, {6200,0.05047273}, {6250,0.04998182}, {6300,0.04938182}, {6350,0.04968182}, {6400,0.02620909}, {6450,0.02675455}, {6500,0.02736364}, {6550,0.02754545}, {6600,0.02740000}, {6650,0.02739091}, {6700,0.02841818}, {6750,0.05179091}, {6800,0.04646364}, {6850,0.02834545}, {6900,0.02884545}, {6950,0.02907273}, {7000,0.02904545}, {7050,0.05197273}, {7100,0.04795455}, {7150,0.03018182}, {7200,0.03020909}, {7250,0.03071818}, {7300,0.05511818}, {7350,0.03090000}, {7400,0.03116364}, {7450,0.03087273}, {7500,0.04929091}, {7550,0.03149091}, {7600,0.03199091}, {7650,0.06498182}, {7700,0.04300000}, {7750,0.03267273}, {7800,0.03341818}, {7850,0.05020000}, {7900,0.03309091}, {7950,0.03329091}, {8000,0.04859091}, {8050,0.03348182}, {8100,0.07234545}, {8150,0.04195455}, {8200,0.03439091}, {8250,0.05893636}, {8300,0.03485455}, {8350,0.03604545}, {8400,0.05360909}, {8450,0.03560909}, {8500,0.05611818}, {8550,0.03606364}, {8600,0.06643636}, {8650,0.03645455}, {8700,0.07433636}, {8750,0.03680000}, {8800,0.03719091}, {8850,0.03721818}, {8900,0.03824545}, {8950,0.03736364}, {9000,0.03885455}, {9050,0.03778182}, {9100,0.08126364}, {9150,0.03812727}, {9200,0.06883636}, {9250,0.03850909}, {9300,0.05904545}, {9350,0.03876364}, {9400,0.04886364}, {9450,0.04005455}, {9500,0.03961818}, {9550,0.06629091}, {9600,0.04025455}, {9650,0.05475455}, {9700,0.09130000}, {9750,0.04055455}, {9800,0.05209091}, {9850,0.07975455}, {9900,0.04146364}, {9950,0.05752727}, {10000,0.09133636}, {10100,0.04216364}, {10200,0.05720000}, {10300,0.08043636}, {10400,0.04343636}, {10500,0.04420000}, {10600,0.05695455}, {10700,0.06841818}, {10800,0.08100909}, {10900,0.04554545}, {11000,0.04590909}, {11100,0.04650000}, {11200,0.06037273}, {11300,0.06333636}, {11400,0.07939091}, {11500,0.07790909}, {11600,0.08182727}, {11700,0.08185455}, {11800,0.07456364}, {11900,0.08434545}, {12000,0.08360000}, {12100,0.08176364}, {12200,0.07851818}, {12300,0.07791818}, {12400,0.07775455}, {12500,0.06910000}, {12600,0.04812727}, {12700,0.05275455}, {12800,0.05345455}, {12900,0.09921818}, {13000,0.08703636}, {13100,0.07549091}, {13200,0.05174545}, {13300,0.05574545}, {13400,0.09882727}, {13500,0.08019091}, {13600,0.05487273}, {13700,0.05835455}, {13800,0.08575455}, {13900,0.07222727}, {14000,0.05964545}, {14100,0.08373636}, {14200,0.05960909}, {14300,0.11461818}, {14400,0.07709091}, {14500,0.06228182}, {14600,0.07909091}, {14700,0.06161818}, {14800,0.08517273}, {14900,0.06241818}, {15000,0.34987273}, {15100,0.06446364}, {15200,0.07648182}, {15300,0.13380000}, {15400,0.07924545}, {15500,0.09872727}, {15600,0.06517273}, {15700,0.08185455}, {15800,0.12444545}, {15900,0.06597273}, {16000,0.08336364}, {16100,0.12220909}, {16200,0.06859091}, {16300,0.08169091}, {16400,0.09423636}, {16500,0.12573636}, {16600,0.07030909}, {16700,0.06339091}, {16800,0.08168182}, {16900,0.09722727}, {17000,0.12153636}, {17100,0.13149091}, {17200,0.13996364}, {17300,0.07320909}, {17400,0.07023636}, {17500,0.08125455}, {17600,0.08301818}, {17700,0.08402727}, {17800,0.08051818}, {17900,0.09208182}, {18000,0.09148182}, {18100,0.08516364}, {18200,0.08171818}, {18300,0.07274545}, {18400,0.07772727}, {18500,0.14593636}, {18600,0.14115455}, {18700,0.13070909}, {18800,0.10019091}, {18900,0.09306364}, {19000,0.08722727}, {19100,0.14713636}, {19200,0.13818182}, {19300,0.11964545}, {19400,0.09323636}, {19500,0.15056364}, {19600,0.13671818}, {19700,0.09802727}, {19800,0.08058182}, {19900,0.14522727}, {20000,0.09649074}};
data["big_flat"]["QuoteFlat"]["norm reif"]["system"] = {{1,0.00003636}, {2,0.00010909}, {3,0.00003636}, {4,0.00000000}, {5,0.00000000}, {6,0.00003636}, {7,0.00003636}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00003636}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00003636}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00007273}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00003636}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00010909}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00003636}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00003636}, {89,0.00000000}, {90,0.00007273}, {91,0.00000000}, {92,0.00000000}, {93,0.00006364}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003636}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00002727}, {111,0.00003636}, {112,0.00000000}, {113,0.00000000}, {114,0.00003636}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00007273}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00003636}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00003636}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00003636}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00003636}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00003636}, {158,0.00000000}, {159,0.00003636}, {160,0.00000000}, {161,0.00000000}, {162,0.00003636}, {163,0.00006364}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00002727}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00002727}, {173,0.00000000}, {174,0.00003636}, {175,0.00000000}, {176,0.00000000}, {177,0.00003636}, {178,0.00000000}, {179,0.00007273}, {180,0.00000000}, {181,0.00003636}, {182,0.00003636}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00003636}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00003636}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00003636}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00003636}, {212,0.00000000}, {213,0.00000000}, {214,0.00003636}, {215,0.00002727}, {216,0.00000000}, {217,0.00000000}, {218,0.00003636}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00003636}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00003636}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00003636}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00003636}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00003636}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00003636}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00003636}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00003636}, {285,0.00000000}, {286,0.00003636}, {287,0.00000000}, {288,0.00005455}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00003636}, {297,0.00003636}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00003636}, {305,0.00000000}, {306,0.00003636}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00006364}, {311,0.00003636}, {312,0.00003636}, {313,0.00003636}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00002727}, {318,0.00000000}, {319,0.00003636}, {320,0.00007273}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00003636}, {325,0.00000000}, {326,0.00003636}, {327,0.00000000}, {328,0.00000000}, {329,0.00003636}, {330,0.00000000}, {331,0.00003636}, {332,0.00000000}, {333,0.00003636}, {334,0.00003636}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00003636}, {341,0.00000000}, {342,0.00003636}, {343,0.00003636}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00003636}, {348,0.00000000}, {349,0.00000000}, {350,0.00003636}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00003636}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00010909}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00003636}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00010909}, {382,0.00003636}, {383,0.00002727}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00007273}, {390,0.00002727}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00007273}, {396,0.00007273}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00003636}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00003636}, {411,0.00003636}, {412,0.00000000}, {413,0.00000000}, {414,0.00003636}, {415,0.00000000}, {416,0.00002727}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00003636}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00003636}, {431,0.00000000}, {432,0.00003636}, {433,0.00006364}, {434,0.00003636}, {435,0.00000000}, {436,0.00007273}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00014545}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00003636}, {451,0.00000000}, {452,0.00000000}, {453,0.00003636}, {454,0.00006364}, {455,0.00006364}, {456,0.00006364}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00002727}, {466,0.00000000}, {467,0.00000000}, {468,0.00010909}, {469,0.00003636}, {470,0.00000000}, {471,0.00003636}, {472,0.00003636}, {473,0.00003636}, {474,0.00003636}, {475,0.00000000}, {476,0.00000000}, {477,0.00003636}, {478,0.00003636}, {479,0.00003636}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00002727}, {484,0.00003636}, {485,0.00003636}, {486,0.00003636}, {487,0.00003636}, {488,0.00003636}, {489,0.00000000}, {490,0.00000000}, {491,0.00003636}, {492,0.00000000}, {493,0.00000000}, {494,0.00003636}, {495,0.00003636}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00003636}, {510,0.00000000}, {515,0.00003636}, {520,0.00000000}, {525,0.00003636}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00003636}, {550,0.00006364}, {555,0.00002727}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00003636}, {585,0.00002727}, {590,0.00000000}, {595,0.00000000}, {600,0.00007273}, {605,0.00000000}, {610,0.00003636}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00003636}, {635,0.00000000}, {640,0.00003636}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00007273}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00010909}, {695,0.00000000}, {700,0.00003636}, {705,0.00003636}, {710,0.00000000}, {715,0.00000000}, {720,0.00003636}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00003636}, {745,0.00009091}, {750,0.00003636}, {755,0.00000000}, {760,0.00007273}, {765,0.00007273}, {770,0.00000000}, {775,0.00003636}, {780,0.00000000}, {785,0.00003636}, {790,0.00003636}, {795,0.00003636}, {800,0.00003636}, {805,0.00000000}, {810,0.00003636}, {815,0.00000000}, {820,0.00000000}, {825,0.00003636}, {830,0.00003636}, {835,0.00003636}, {840,0.00003636}, {845,0.00007273}, {850,0.00003636}, {855,0.00003636}, {860,0.00006364}, {865,0.00000000}, {870,0.00003636}, {875,0.00000000}, {880,0.00000000}, {885,0.00003636}, {890,0.00003636}, {895,0.00003636}, {900,0.00007273}, {905,0.00007273}, {910,0.00000000}, {915,0.00000000}, {920,0.00006364}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00007273}, {950,0.00007273}, {955,0.00007273}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00002727}, {980,0.00000000}, {985,0.00000000}, {990,0.00007273}, {995,0.00003636}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00003636}, {1040,0.00000000}, {1050,0.00003636}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00003636}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00003636}, {1140,0.00013636}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00003636}, {1190,0.00007273}, {1200,0.00000000}, {1210,0.00010909}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00003636}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00003636}, {1280,0.00003636}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00002727}, {1320,0.00003636}, {1330,0.00010909}, {1340,0.00000000}, {1350,0.00003636}, {1360,0.00000000}, {1370,0.00003636}, {1380,0.00002727}, {1390,0.00003636}, {1400,0.00007273}, {1410,0.00003636}, {1420,0.00007273}, {1430,0.00000000}, {1440,0.00010909}, {1450,0.00000000}, {1460,0.00003636}, {1470,0.00000000}, {1480,0.00003636}, {1490,0.00017273}, {1500,0.00003636}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00003636}, {1540,0.00010909}, {1550,0.00000000}, {1560,0.00003636}, {1570,0.00010909}, {1580,0.00003636}, {1590,0.00000000}, {1600,0.00010000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00010909}, {1640,0.00003636}, {1650,0.00007273}, {1660,0.00000000}, {1670,0.00007273}, {1680,0.00003636}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00010000}, {1750,0.00003636}, {1760,0.00000000}, {1770,0.00003636}, {1780,0.00000000}, {1790,0.00003636}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00003636}, {1840,0.00003636}, {1850,0.00003636}, {1860,0.00003636}, {1870,0.00000000}, {1880,0.00002727}, {1890,0.00007273}, {1900,0.00014545}, {1910,0.00000000}, {1920,0.00003636}, {1930,0.00010000}, {1940,0.00003636}, {1950,0.00003636}, {1960,0.00010000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00007273}, {2000,0.00007273}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00003636}, {2200,0.00003636}, {2250,0.00002727}, {2300,0.00010000}, {2350,0.00010909}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00007273}, {2600,0.00000000}, {2650,0.00003636}, {2700,0.00010909}, {2750,0.00007273}, {2800,0.00014545}, {2850,0.00000000}, {2900,0.00013636}, {2950,0.00003636}, {3000,0.00025455}, {3050,0.00007273}, {3100,0.00021818}, {3150,0.00000000}, {3200,0.00006364}, {3250,0.00000000}, {3300,0.00003636}, {3350,0.00000000}, {3400,0.00007273}, {3450,0.00031818}, {3500,0.00007273}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00003636}, {3700,0.00010000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00002727}, {3900,0.00000000}, {3950,0.00003636}, {4000,0.00000000}, {4050,0.00003636}, {4100,0.00006364}, {4150,0.00016364}, {4200,0.00000000}, {4250,0.00003636}, {4300,0.00007273}, {4350,0.00006364}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00003636}, {4550,0.00003636}, {4600,0.00003636}, {4650,0.00000000}, {4700,0.00007273}, {4750,0.00038182}, {4800,0.00002727}, {4850,0.00003636}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00014545}, {5050,0.00023636}, {5100,0.00003636}, {5150,0.00002727}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00002727}, {5350,0.00007273}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00029091}, {5550,0.00020000}, {5600,0.00039091}, {5650,0.00065455}, {5700,0.00007273}, {5750,0.00007273}, {5800,0.00000000}, {5850,0.00003636}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00007273}, {6100,0.00007273}, {6150,0.00045455}, {6200,0.00049091}, {6250,0.00018182}, {6300,0.00036364}, {6350,0.00071818}, {6400,0.00003636}, {6450,0.00000000}, {6500,0.00007273}, {6550,0.00000000}, {6600,0.00006364}, {6650,0.00000000}, {6700,0.00003636}, {6750,0.00043636}, {6800,0.00049091}, {6850,0.00014545}, {6900,0.00003636}, {6950,0.00000000}, {7000,0.00006364}, {7050,0.00038182}, {7100,0.00063636}, {7150,0.00003636}, {7200,0.00007273}, {7250,0.00002727}, {7300,0.00043636}, {7350,0.00007273}, {7400,0.00000000}, {7450,0.00010909}, {7500,0.00021818}, {7550,0.00002727}, {7600,0.00003636}, {7650,0.00058182}, {7700,0.00039091}, {7750,0.00003636}, {7800,0.00000000}, {7850,0.00053636}, {7900,0.00000000}, {7950,0.00010909}, {8000,0.00030000}, {8050,0.00000000}, {8100,0.00043636}, {8150,0.00035455}, {8200,0.00000000}, {8250,0.00054545}, {8300,0.00003636}, {8350,0.00002727}, {8400,0.00057273}, {8450,0.00000000}, {8500,0.00036364}, {8550,0.00003636}, {8600,0.00032727}, {8650,0.00014545}, {8700,0.00072727}, {8750,0.00000000}, {8800,0.00002727}, {8850,0.00010909}, {8900,0.00003636}, {8950,0.00003636}, {9000,0.00003636}, {9050,0.00018182}, {9100,0.00068182}, {9150,0.00006364}, {9200,0.00036364}, {9250,0.00005455}, {9300,0.00014545}, {9350,0.00003636}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00003636}, {9600,0.00003636}, {9650,0.00003636}, {9700,0.00000000}, {9750,0.00007273}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00003636}, {9950,0.00000000}, {10000,0.00058182}, {10100,0.00007273}, {10200,0.00018182}, {10300,0.00064545}, {10400,0.00000000}, {10500,0.00014545}, {10600,0.00023636}, {10700,0.00039091}, {10800,0.00056364}, {10900,0.00014545}, {11000,0.00003636}, {11100,0.00007273}, {11200,0.00046364}, {11300,0.00040000}, {11400,0.00047273}, {11500,0.00032727}, {11600,0.00060000}, {11700,0.00054545}, {11800,0.00065455}, {11900,0.00030909}, {12000,0.00063636}, {12100,0.00035455}, {12200,0.00058182}, {12300,0.00054545}, {12400,0.00040000}, {12500,0.00028182}, {12600,0.00003636}, {12700,0.00000000}, {12800,0.00007273}, {12900,0.00003636}, {13000,0.00000000}, {13100,0.00003636}, {13200,0.00010909}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00007273}, {13800,0.00007273}, {13900,0.00000000}, {14000,0.00003636}, {14100,0.00000000}, {14200,0.00007273}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00010909}, {14700,0.00007273}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00020909}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00014545}, {15400,0.00007273}, {15500,0.00007273}, {15600,0.00000000}, {15700,0.00010909}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00010909}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00007273}, {16400,0.00000000}, {16500,0.00003636}, {16600,0.00000000}, {16700,0.00003636}, {16800,0.00000000}, {16900,0.00003636}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00007273}, {17300,0.00007273}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00003636}, {17700,0.00003636}, {17800,0.00000000}, {17900,0.00003636}, {18000,0.00003636}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00014545}, {18400,0.00003636}, {18500,0.00003636}, {18600,0.00007273}, {18700,0.00003636}, {18800,0.00006364}, {18900,0.00000000}, {19000,0.00006364}, {19100,0.00007273}, {19200,0.00017273}, {19300,0.00000000}, {19400,0.00003636}, {19500,0.00007273}, {19600,0.00000000}, {19700,0.00021818}, {19800,0.00006364}, {19900,0.00042727}, {20000,0.00025926}};
data["big_flat"]["QuoteFlat"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.01454545}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00042727}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00001818}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00001818}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["QuoteFlat"]["post"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00007273}, {8,0.00000000}, {9,0.00000000}, {10,0.00002727}, {11,0.00006364}, {12,0.00000000}, {13,0.00007273}, {14,0.00000000}, {15,0.00000000}, {16,0.00005455}, {17,0.00003636}, {18,0.00002727}, {19,0.00005455}, {20,0.00000000}, {21,0.00000000}, {22,0.00002727}, {23,0.00000000}, {24,0.00003636}, {25,0.00006364}, {26,0.00002727}, {27,0.00003636}, {28,0.00002727}, {29,0.00007273}, {30,0.00000000}, {31,0.00002727}, {32,0.00000000}, {33,0.00002727}, {34,0.00003636}, {35,0.00003636}, {36,0.00000000}, {37,0.00006364}, {38,0.00002727}, {39,0.01442727}, {40,0.00003636}, {41,0.00002727}, {42,0.00000000}, {43,0.00002727}, {44,0.00000000}, {45,0.00000000}, {46,0.00007273}, {47,0.00006364}, {48,0.00000000}, {49,0.00002727}, {50,0.00000000}, {51,0.00003636}, {52,0.00002727}, {53,0.00005455}, {54,0.00000000}, {55,0.00003636}, {56,0.00002727}, {57,0.00003636}, {58,0.00003636}, {59,0.00006364}, {60,0.00002727}, {61,0.00000000}, {62,0.00000000}, {63,0.00007273}, {64,0.00000000}, {65,0.00000000}, {66,0.00007273}, {67,0.00000000}, {68,0.00000000}, {69,0.00007273}, {70,0.00002727}, {71,0.00002727}, {72,0.00002727}, {73,0.00000000}, {74,0.00007273}, {75,0.00000000}, {76,0.00003636}, {77,0.00006364}, {78,0.00003636}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00007273}, {84,0.00000000}, {85,0.00000000}, {86,0.00005455}, {87,0.00003636}, {88,0.00000000}, {89,0.00006364}, {90,0.00000000}, {91,0.00003636}, {92,0.00010000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00002727}, {97,0.00000000}, {98,0.00000000}, {99,0.00006364}, {100,0.00000000}, {101,0.00003636}, {102,0.00009091}, {103,0.00007273}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00008182}, {108,0.00003636}, {109,0.00000000}, {110,0.00003636}, {111,0.00003636}, {112,0.00011818}, {113,0.00003636}, {114,0.00002727}, {115,0.00002727}, {116,0.00000000}, {117,0.00002727}, {118,0.00000000}, {119,0.00007273}, {120,0.00003636}, {121,0.00000000}, {122,0.00006364}, {123,0.00003636}, {124,0.00007273}, {125,0.00000000}, {126,0.00002727}, {127,0.00000000}, {128,0.00003636}, {129,0.00003636}, {130,0.00003636}, {131,0.00000000}, {132,0.00003636}, {133,0.00006364}, {134,0.00002727}, {135,0.00015455}, {136,0.00000000}, {137,0.00000000}, {138,0.00003636}, {139,0.00000000}, {140,0.00010000}, {141,0.00000000}, {142,0.00000000}, {143,0.00008182}, {144,0.00008182}, {145,0.00002727}, {146,0.00002727}, {147,0.00003636}, {148,0.00006364}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00003636}, {153,0.00002727}, {154,0.00010909}, {155,0.00003636}, {156,0.00007273}, {157,0.00003636}, {158,0.00006364}, {159,0.00003636}, {160,0.00000000}, {161,0.00000000}, {162,0.00005455}, {163,0.00000000}, {164,0.00006364}, {165,0.00002727}, {166,0.00000000}, {167,0.00002727}, {168,0.00003636}, {169,0.00003636}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00003636}, {176,0.00002727}, {177,0.00007273}, {178,0.00003636}, {179,0.00002727}, {180,0.00007273}, {181,0.00000000}, {182,0.00002727}, {183,0.00005455}, {184,0.00098182}, {185,0.00003636}, {186,0.00003636}, {187,0.00000000}, {188,0.00003636}, {189,0.00000000}, {190,0.00010000}, {191,0.00000000}, {192,0.00003636}, {193,0.00000000}, {194,0.00003636}, {195,0.00000000}, {196,0.00005455}, {197,0.00008182}, {198,0.00005455}, {199,0.00006364}, {200,0.00000000}, {201,0.00013636}, {202,0.00000000}, {203,0.00002727}, {204,0.00000000}, {205,0.00006364}, {206,0.00000000}, {207,0.00003636}, {208,0.00006364}, {209,0.00002727}, {210,0.00006364}, {211,0.00000000}, {212,0.00000000}, {213,0.00003636}, {214,0.00002727}, {215,0.00000000}, {216,0.00005455}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00006364}, {222,0.00002727}, {223,0.00000000}, {224,0.00009091}, {225,0.00006364}, {226,0.00003636}, {227,0.00003636}, {228,0.00003636}, {229,0.00003636}, {230,0.00010909}, {231,0.00005455}, {232,0.00002727}, {233,0.00000000}, {234,0.00003636}, {235,0.00000000}, {236,0.00006364}, {237,0.00006364}, {238,0.00010000}, {239,0.00000000}, {240,0.00003636}, {241,0.00002727}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00010000}, {246,0.00006364}, {247,0.00016364}, {248,0.00000000}, {249,0.00002727}, {250,0.00003636}, {251,0.00003636}, {252,0.00000000}, {253,0.00003636}, {254,0.00000000}, {255,0.00003636}, {256,0.00000000}, {257,0.00007273}, {258,0.00000000}, {259,0.00013636}, {260,0.00010909}, {261,0.00003636}, {262,0.00006364}, {263,0.00003636}, {264,0.00008182}, {265,0.00003636}, {266,0.00002727}, {267,0.00003636}, {268,0.00000000}, {269,0.00010000}, {270,0.00002727}, {271,0.00002727}, {272,0.00006364}, {273,0.00003636}, {274,0.00002727}, {275,0.00002727}, {276,0.00000000}, {277,0.00007273}, {278,0.00007273}, {279,0.00002727}, {280,0.00000000}, {281,0.00006364}, {282,0.00000000}, {283,0.00000000}, {284,0.00007273}, {285,0.00003636}, {286,0.00000000}, {287,0.00000000}, {288,0.00006364}, {289,0.00010909}, {290,0.00000000}, {291,0.00003636}, {292,0.00007273}, {293,0.00000000}, {294,0.00003636}, {295,0.00000000}, {296,0.00014545}, {297,0.00002727}, {298,0.00003636}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00002727}, {307,0.00003636}, {308,0.00000000}, {309,0.00003636}, {310,0.00000000}, {311,0.00003636}, {312,0.00000000}, {313,0.00002727}, {314,0.00010000}, {315,0.00000000}, {316,0.00003636}, {317,0.00003636}, {318,0.00003636}, {319,0.00003636}, {320,0.00003636}, {321,0.00007273}, {322,0.00002727}, {323,0.00003636}, {324,0.00003636}, {325,0.00002727}, {326,0.00006364}, {327,0.00003636}, {328,0.00000000}, {329,0.00000000}, {330,0.00006364}, {331,0.00007273}, {332,0.00006364}, {333,0.00003636}, {334,0.00002727}, {335,0.00000000}, {336,0.00002727}, {337,0.00003636}, {338,0.00000000}, {339,0.00013636}, {340,0.00000000}, {341,0.00009091}, {342,0.00000000}, {343,0.00005455}, {344,0.00005455}, {345,0.00003636}, {346,0.00000000}, {347,0.00003636}, {348,0.00002727}, {349,0.00007273}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00007273}, {354,0.00000000}, {355,0.00011818}, {356,0.00006364}, {357,0.00002727}, {358,0.00003636}, {359,0.00000000}, {360,0.00006364}, {361,0.00003636}, {362,0.00002727}, {363,0.00003636}, {364,0.00000000}, {365,0.00007273}, {366,0.00000000}, {367,0.00006364}, {368,0.00003636}, {369,0.00006364}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00003636}, {374,0.00007273}, {375,0.00008182}, {376,0.00003636}, {377,0.00000000}, {378,0.00002727}, {379,0.00002727}, {380,0.00003636}, {381,0.00002727}, {382,0.00003636}, {383,0.00000000}, {384,0.00005455}, {385,0.00003636}, {386,0.00000000}, {387,0.00006364}, {388,0.00017273}, {389,0.00003636}, {390,0.00000000}, {391,0.00006364}, {392,0.00003636}, {393,0.00003636}, {394,0.00000000}, {395,0.00015455}, {396,0.00003636}, {397,0.00002727}, {398,0.00006364}, {399,0.00002727}, {400,0.00002727}, {401,0.00000000}, {402,0.00000000}, {403,0.00002727}, {404,0.00002727}, {405,0.00002727}, {406,0.00000000}, {407,0.00003636}, {408,0.00007273}, {409,0.00007273}, {410,0.00003636}, {411,0.00002727}, {412,0.00007273}, {413,0.00000000}, {414,0.00000000}, {415,0.00003636}, {416,0.00002727}, {417,0.00002727}, {418,0.00006364}, {419,0.00000000}, {420,0.00002727}, {421,0.00000000}, {422,0.00003636}, {423,0.00005455}, {424,0.00002727}, {425,0.00003636}, {426,0.00000000}, {427,0.00002727}, {428,0.00006364}, {429,0.00002727}, {430,0.00009091}, {431,0.00010000}, {432,0.00003636}, {433,0.00000000}, {434,0.00003636}, {435,0.00003636}, {436,0.00003636}, {437,0.00003636}, {438,0.00000000}, {439,0.00000000}, {440,0.00002727}, {441,0.00000000}, {442,0.00000000}, {443,0.00006364}, {444,0.00006364}, {445,0.00000000}, {446,0.00000000}, {447,0.00010909}, {448,0.00000000}, {449,0.00003636}, {450,0.00000000}, {451,0.00013636}, {452,0.00000000}, {453,0.00008182}, {454,0.00000000}, {455,0.00000000}, {456,0.00002727}, {457,0.00000000}, {458,0.00005455}, {459,0.00013636}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00003636}, {464,0.00002727}, {465,0.00000000}, {466,0.00003636}, {467,0.00002727}, {468,0.00003636}, {469,0.00002727}, {470,0.00002727}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00002727}, {477,0.00007273}, {478,0.00000000}, {479,0.00000000}, {480,0.00002727}, {481,0.00006364}, {482,0.00002727}, {483,0.00006364}, {484,0.00006364}, {485,0.00010909}, {486,0.00000000}, {487,0.00002727}, {488,0.00006364}, {489,0.00000000}, {490,0.00000000}, {491,0.00003636}, {492,0.00002727}, {493,0.00010000}, {494,0.00003636}, {495,0.00003636}, {496,0.00003636}, {497,0.00002727}, {498,0.00006364}, {499,0.00000000}, {500,0.00003636}, {505,0.00000000}, {510,0.00002727}, {515,0.00002727}, {520,0.00006364}, {525,0.00000000}, {530,0.00002727}, {535,0.00006364}, {540,0.00002727}, {545,0.00000000}, {550,0.00009091}, {555,0.00000000}, {560,0.00003636}, {565,0.00000000}, {570,0.00003636}, {575,0.00003636}, {580,0.00010000}, {585,0.00000000}, {590,0.00014545}, {595,0.00006364}, {600,0.00002727}, {605,0.00002727}, {610,0.00003636}, {615,0.00002727}, {620,0.00010000}, {625,0.00002727}, {630,0.00000000}, {635,0.00007273}, {640,0.00010000}, {645,0.00000000}, {650,0.00010000}, {655,0.00000000}, {660,0.00007273}, {665,0.00006364}, {670,0.00002727}, {675,0.00005455}, {680,0.00006364}, {685,0.00006364}, {690,0.00006364}, {695,0.00003636}, {700,0.00006364}, {705,0.00000000}, {710,0.00009091}, {715,0.00010000}, {720,0.00003636}, {725,0.00000000}, {730,0.00003636}, {735,0.00000000}, {740,0.00006364}, {745,0.00003636}, {750,0.00003636}, {755,0.00007273}, {760,0.00002727}, {765,0.00002727}, {770,0.00003636}, {775,0.00010000}, {780,0.00006364}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00007273}, {805,0.00003636}, {810,0.00002727}, {815,0.00000000}, {820,0.00010909}, {825,0.00000000}, {830,0.00006364}, {835,0.00014545}, {840,0.00000000}, {845,0.00000000}, {850,0.00010000}, {855,0.00009091}, {860,0.00003636}, {865,0.00000000}, {870,0.00000000}, {875,0.00003636}, {880,0.00003636}, {885,0.00003636}, {890,0.00006364}, {895,0.00013636}, {900,0.00000000}, {905,0.00000000}, {910,0.00002727}, {915,0.00000000}, {920,0.00002727}, {925,0.00005455}, {930,0.00003636}, {935,0.00003636}, {940,0.00000000}, {945,0.00006364}, {950,0.00006364}, {955,0.00003636}, {960,0.00002727}, {965,0.00000000}, {970,0.00006364}, {975,0.00000000}, {980,0.00006364}, {985,0.00005455}, {990,0.00003636}, {995,0.00000000}, {1000,0.00003636}, {1010,0.00003636}, {1020,0.00007273}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00010000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00003636}, {1100,0.00003636}, {1110,0.00003636}, {1120,0.00003636}, {1130,0.00002727}, {1140,0.00003636}, {1150,0.00000000}, {1160,0.00003636}, {1170,0.00006364}, {1180,0.00007273}, {1190,0.00000000}, {1200,0.00002727}, {1210,0.00003636}, {1220,0.00000000}, {1230,0.00003636}, {1240,0.00000000}, {1250,0.00010909}, {1260,0.00000000}, {1270,0.00005455}, {1280,0.00007273}, {1290,0.00003636}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00003636}, {1330,0.00000000}, {1340,0.00002727}, {1350,0.00003636}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00006364}, {1400,0.00007273}, {1410,0.00006364}, {1420,0.00006364}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00003636}, {1460,0.00010909}, {1470,0.00003636}, {1480,0.00002727}, {1490,0.00002727}, {1500,0.00000000}, {1510,0.00003636}, {1520,0.00000000}, {1530,0.00003636}, {1540,0.00002727}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00003636}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00002727}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00007273}, {1660,0.00000000}, {1670,0.00003636}, {1680,0.00003636}, {1690,0.00000000}, {1700,0.00003636}, {1710,0.00003636}, {1720,0.00005455}, {1730,0.00002727}, {1740,0.00000000}, {1750,0.00007273}, {1760,0.00006364}, {1770,0.00007273}, {1780,0.00010909}, {1790,0.00002727}, {1800,0.00000000}, {1810,0.00010000}, {1820,0.00010909}, {1830,0.00007273}, {1840,0.00000000}, {1850,0.00002727}, {1860,0.00002727}, {1870,0.00007273}, {1880,0.00003636}, {1890,0.00000000}, {1900,0.00006364}, {1910,0.00000000}, {1920,0.00005455}, {1930,0.00010000}, {1940,0.00003636}, {1950,0.00000000}, {1960,0.00005455}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00010000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00010000}, {2500,0.00002727}, {2550,0.00002727}, {2600,0.00003636}, {2650,0.00003636}, {2700,0.00000000}, {2750,0.00003636}, {2800,0.00003636}, {2850,0.00000000}, {2900,0.00002727}, {2950,0.00000000}, {3000,0.00003636}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00003636}, {3200,0.00000000}, {3250,0.00006364}, {3300,0.00003636}, {3350,0.00002727}, {3400,0.00003636}, {3450,0.00006364}, {3500,0.00003636}, {3550,0.00000000}, {3600,0.00005455}, {3650,0.00005455}, {3700,0.00003636}, {3750,0.00012727}, {3800,0.00006364}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00009091}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00002727}, {4150,0.00003636}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00010000}, {4350,0.00003636}, {4400,0.00007273}, {4450,0.00003636}, {4500,0.00003636}, {4550,0.00002727}, {4600,0.00000000}, {4650,0.00006364}, {4700,0.00000000}, {4750,0.00002727}, {4800,0.00006364}, {4850,0.00007273}, {4900,0.00002727}, {4950,0.00000000}, {5000,0.00013636}, {5050,0.00003636}, {5100,0.00000000}, {5150,0.00006364}, {5200,0.00007273}, {5250,0.00006364}, {5300,0.00005455}, {5350,0.00002727}, {5400,0.00003636}, {5450,0.00000000}, {5500,0.00006364}, {5550,0.00012727}, {5600,0.00003636}, {5650,0.00007273}, {5700,0.00003636}, {5750,0.00003636}, {5800,0.00006364}, {5850,0.00007273}, {5900,0.00003636}, {5950,0.00000000}, {6000,0.00003636}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00003636}, {6200,0.00006364}, {6250,0.00006364}, {6300,0.00006364}, {6350,0.00000000}, {6400,0.00003636}, {6450,0.00000000}, {6500,0.00005455}, {6550,0.00000000}, {6600,0.00002727}, {6650,0.00006364}, {6700,0.00000000}, {6750,0.00002727}, {6800,0.00000000}, {6850,0.00006364}, {6900,0.00003636}, {6950,0.00002727}, {7000,0.00005455}, {7050,0.00006364}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00006364}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00008182}, {7400,0.00002727}, {7450,0.00003636}, {7500,0.00006364}, {7550,0.00006364}, {7600,0.00000000}, {7650,0.00005455}, {7700,0.00000000}, {7750,0.00006364}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00002727}, {8050,0.00005455}, {8100,0.00006364}, {8150,0.00005455}, {8200,0.00006364}, {8250,0.00010909}, {8300,0.00002727}, {8350,0.00002727}, {8400,0.00002727}, {8450,0.00008182}, {8500,0.00002727}, {8550,0.00011818}, {8600,0.00000000}, {8650,0.00003636}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00005455}, {8850,0.00002727}, {8900,0.00003636}, {8950,0.00002727}, {9000,0.00000000}, {9050,0.00002727}, {9100,0.00002727}, {9150,0.00009091}, {9200,0.00010000}, {9250,0.00005455}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00003636}, {9450,0.00003636}, {9500,0.00002727}, {9550,0.00003636}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00005455}, {9750,0.00002727}, {9800,0.00000000}, {9850,0.00005455}, {9900,0.00000000}, {9950,0.00002727}, {10000,0.00006364}, {10100,0.00009091}, {10200,0.00002727}, {10300,0.00006364}, {10400,0.00002727}, {10500,0.00010909}, {10600,0.00002727}, {10700,0.00006364}, {10800,0.00012727}, {10900,0.00000000}, {11000,0.00006364}, {11100,0.00000000}, {11200,0.00005455}, {11300,0.00002727}, {11400,0.00005455}, {11500,0.00002727}, {11600,0.00002727}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00009091}, {12200,0.00005455}, {12300,0.00006364}, {12400,0.00008182}, {12500,0.00011818}, {12600,0.00006364}, {12700,0.00000000}, {12800,0.00013636}, {12900,0.00000000}, {13000,0.00012727}, {13100,0.00002727}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00006364}, {13500,0.00013636}, {13600,0.00002727}, {13700,0.00010000}, {13800,0.00009091}, {13900,0.00006364}, {14000,0.00000000}, {14100,0.00002727}, {14200,0.00008182}, {14300,0.00014545}, {14400,0.00000000}, {14500,0.00011818}, {14600,0.00000000}, {14700,0.00002727}, {14800,0.00007273}, {14900,0.00000000}, {15000,0.00006364}, {15100,0.00007273}, {15200,0.00020000}, {15300,0.00009091}, {15400,0.00007273}, {15500,0.00003636}, {15600,0.00000000}, {15700,0.00005455}, {15800,0.00000000}, {15900,0.00013636}, {16000,0.00003636}, {16100,0.00012727}, {16200,0.00007273}, {16300,0.00000000}, {16400,0.00003636}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00005455}, {16800,0.00012727}, {16900,0.00007273}, {17000,0.00003636}, {17100,0.00010909}, {17200,0.00000000}, {17300,0.00007273}, {17400,0.00000000}, {17500,0.00013636}, {17600,0.00013636}, {17700,0.00003636}, {17800,0.00002727}, {17900,0.00003636}, {18000,0.00000000}, {18100,0.00010000}, {18200,0.00006364}, {18300,0.00010000}, {18400,0.00002727}, {18500,0.00003636}, {18600,0.00006364}, {18700,0.00003636}, {18800,0.00003636}, {18900,0.00002727}, {19000,0.00003636}, {19100,0.00015455}, {19200,0.00000000}, {19300,0.00002727}, {19400,0.00006364}, {19500,0.00006364}, {19600,0.00020000}, {19700,0.00006364}, {19800,0.00003636}, {19900,0.00002727}, {20000,0.00007407}};
data["big_flat"]["QuoteFlat"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00003636}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00030909}, {40,0.00000000}, {41,0.00000000}, {42,0.00003636}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00003636}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00002727}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00003636}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00002727}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00003636}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00003636}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00003636}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00003636}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00003636}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00003636}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00003636}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00003636}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00002727}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00003636}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00003636}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00003636}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00007273}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00003636}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00003636}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00003636}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["QuoteFlat"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["QuoteFlat"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00002727}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00003636}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00003636}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00002727}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00002727}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00002727}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00003636}, {73,0.00000000}, {74,0.00003636}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00006364}, {83,0.00000000}, {84,0.00000000}, {85,0.00002727}, {86,0.00003636}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00002727}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00002727}, {114,0.00000000}, {115,0.00000000}, {116,0.00002727}, {117,0.00000000}, {118,0.00003636}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00002727}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00003636}, {137,0.00000000}, {138,0.00000000}, {139,0.00002727}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00003636}, {144,0.00000000}, {145,0.00003636}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00002727}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00003636}, {159,0.00002727}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00002727}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00002727}, {180,0.00002727}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00002727}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00006364}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00002727}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00002727}, {224,0.00003636}, {225,0.00000000}, {226,0.00003636}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00006364}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00002727}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00003636}, {253,0.00000000}, {254,0.00003636}, {255,0.00003636}, {256,0.00003636}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00002727}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00003636}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00002727}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00003636}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00002727}, {316,0.00002727}, {317,0.00002727}, {318,0.00000000}, {319,0.00003636}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00002727}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00003636}, {334,0.00003636}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00002727}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00002727}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00003636}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00002727}, {382,0.00000000}, {383,0.00000000}, {384,0.00002727}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00002727}, {393,0.00000000}, {394,0.00003636}, {395,0.00000000}, {396,0.00000000}, {397,0.00006364}, {398,0.00000000}, {399,0.00002727}, {400,0.00000000}, {401,0.00003636}, {402,0.00002727}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00003636}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00002727}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00003636}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00003636}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00002727}, {436,0.00006364}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00002727}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00002727}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00003636}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00003636}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00003636}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00003636}, {482,0.00002727}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00003636}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00003636}, {575,0.00000000}, {580,0.00000000}, {585,0.00002727}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00002727}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00003636}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00002727}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00003636}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00003636}, {775,0.00003636}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00003636}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00002727}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00006364}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00003636}, {940,0.00000000}, {945,0.00003636}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00002727}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00007273}, {1020,0.00000000}, {1030,0.00002727}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00002727}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00002727}, {1250,0.00002727}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003636}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00002727}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00002727}, {1440,0.00003636}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00003636}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00003636}, {1580,0.00003636}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00002727}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00003636}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00003636}, {1760,0.00002727}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00007273}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00002727}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00002727}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00003636}, {2300,0.00003636}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00003636}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00005455}, {4850,0.00005455}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00003636}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00003636}, {5200,0.00002727}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00003636}, {5700,0.00002727}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00002727}, {5900,0.00003636}, {5950,0.00003636}, {6000,0.00003636}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00003636}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00006364}, {6450,0.00000000}, {6500,0.00003636}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00003636}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00003636}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00002727}, {7450,0.00002727}, {7500,0.00000000}, {7550,0.00005455}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00002727}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00002727}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00002727}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00002727}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00003636}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00002727}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00003636}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00002727}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00002727}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00002727}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00003636}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00002727}, {12400,0.00000000}, {12500,0.00002727}, {12600,0.00002727}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00006364}, {13000,0.00003636}, {13100,0.00000000}, {13200,0.00003636}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00002727}, {13600,0.00000000}, {13700,0.00005455}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00006364}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00003636}, {15900,0.00003636}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00003636}, {16400,0.00000000}, {16500,0.00003636}, {16600,0.00005455}, {16700,0.00003636}, {16800,0.00003636}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00002727}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00003636}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00002727}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00003636}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00003636}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00003636}, {20000,0.00000000}};
data["big_flat"]["QuoteFlat"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00002727}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00003636}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00003636}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00003636}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00003636}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["QuoteFlat"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00031818}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00126364}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00108182}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000909}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000909}, {142,0.00000000}, {143,0.00001818}, {144,0.00001818}, {145,0.00000909}, {146,0.00002727}, {147,0.00001818}, {148,0.00001818}, {149,0.00002727}, {150,0.00001818}, {151,0.00001818}, {152,0.00007273}, {153,0.00010909}, {154,0.00011818}, {155,0.00009091}, {156,0.00018182}, {157,0.00018182}, {158,0.00011818}, {159,0.00021818}, {160,0.00015455}, {161,0.00028182}, {162,0.00031818}, {163,0.00033636}, {164,0.00039091}, {165,0.00049091}, {166,0.00054545}, {167,0.00065455}, {168,0.00068182}, {169,0.00070000}, {170,0.00081818}, {171,0.00088182}, {172,0.00093636}, {173,0.00091818}, {174,0.00090909}, {175,0.00093636}, {176,0.00095455}, {177,0.00099091}, {178,0.00097273}, {179,0.00099091}, {180,0.00100000}, {181,0.00100000}, {182,0.00100000}, {183,0.00100000}, {184,0.00100000}, {185,0.00100000}, {186,0.00100000}, {187,0.00100000}, {188,0.00100000}, {189,0.00100000}, {190,0.00100000}, {191,0.00100000}, {192,0.00100000}, {193,0.00100000}, {194,0.00100000}, {195,0.00100000}, {196,0.00100000}, {197,0.00100000}, {198,0.00100000}, {199,0.00100000}, {200,0.00100000}, {201,0.00100000}, {202,0.00100000}, {203,0.00100000}, {204,0.00100000}, {205,0.00100000}, {206,0.00100000}, {207,0.00100000}, {208,0.00198182}, {209,0.00100000}, {210,0.00100000}, {211,0.00100000}, {212,0.00100000}, {213,0.00100000}, {214,0.00100000}, {215,0.00100000}, {216,0.00100000}, {217,0.00100000}, {218,0.00100000}, {219,0.00100000}, {220,0.00100000}, {221,0.00100000}, {222,0.00100000}, {223,0.00100000}, {224,0.00100000}, {225,0.00100000}, {226,0.00100000}, {227,0.00100000}, {228,0.00100909}, {229,0.00100909}, {230,0.00218182}, {231,0.00100000}, {232,0.00100000}, {233,0.00100000}, {234,0.00100000}, {235,0.00100000}, {236,0.00100000}, {237,0.00100000}, {238,0.00100000}, {239,0.00100000}, {240,0.00100000}, {241,0.00100000}, {242,0.00100000}, {243,0.00100000}, {244,0.00100000}, {245,0.00100000}, {246,0.00100000}, {247,0.00100000}, {248,0.00100000}, {249,0.00100000}, {250,0.00100000}, {251,0.00100000}, {252,0.00100000}, {253,0.00100000}, {254,0.00100000}, {255,0.00100000}, {256,0.00100000}, {257,0.00100000}, {258,0.00100000}, {259,0.00100000}, {260,0.00100000}, {261,0.00100000}, {262,0.00100000}, {263,0.00100000}, {264,0.00100000}, {265,0.00100000}, {266,0.00100000}, {267,0.00100000}, {268,0.00100000}, {269,0.00100000}, {270,0.00100000}, {271,0.00100000}, {272,0.00100000}, {273,0.00100000}, {274,0.00100000}, {275,0.00100000}, {276,0.00100000}, {277,0.00100000}, {278,0.00100000}, {279,0.00100000}, {280,0.00100000}, {281,0.00100000}, {282,0.00100000}, {283,0.00100000}, {284,0.00100000}, {285,0.00100000}, {286,0.00100000}, {287,0.00100000}, {288,0.00100909}, {289,0.00101818}, {290,0.00100000}, {291,0.00100000}, {292,0.00100000}, {293,0.00100000}, {294,0.00100000}, {295,0.00100000}, {296,0.00100000}, {297,0.00100000}, {298,0.00100000}, {299,0.00100000}, {300,0.00100909}, {301,0.00100909}, {302,0.00100909}, {303,0.00100000}, {304,0.00100000}, {305,0.00100000}, {306,0.00100000}, {307,0.00100000}, {308,0.00100000}, {309,0.00100000}, {310,0.00100000}, {311,0.00100000}, {312,0.00100000}, {313,0.00100000}, {314,0.00100000}, {315,0.00100000}, {316,0.00100000}, {317,0.00100000}, {318,0.00100000}, {319,0.00100000}, {320,0.00101818}, {321,0.00203636}, {322,0.00100000}, {323,0.00100000}, {324,0.00100000}, {325,0.00100000}, {326,0.00100000}, {327,0.00100000}, {328,0.00100000}, {329,0.00100000}, {330,0.00100000}, {331,0.00100000}, {332,0.00100000}, {333,0.00100000}, {334,0.00100000}, {335,0.00100000}, {336,0.00100000}, {337,0.00100000}, {338,0.00100000}, {339,0.00100000}, {340,0.00100000}, {341,0.00100000}, {342,0.00100000}, {343,0.00100000}, {344,0.00100000}, {345,0.00100000}, {346,0.00100000}, {347,0.00100000}, {348,0.00100000}, {349,0.00100000}, {350,0.00100000}, {351,0.00100000}, {352,0.00100000}, {353,0.00100909}, {354,0.00100000}, {355,0.00100000}, {356,0.00100000}, {357,0.00100909}, {358,0.00100000}, {359,0.00101818}, {360,0.00100000}, {361,0.00100909}, {362,0.00100000}, {363,0.00100000}, {364,0.00100909}, {365,0.00100000}, {366,0.00306364}, {367,0.00100000}, {368,0.00101818}, {369,0.00100909}, {370,0.00100000}, {371,0.00102727}, {372,0.00103636}, {373,0.00101818}, {374,0.00100000}, {375,0.00101818}, {376,0.00101818}, {377,0.00106364}, {378,0.00104545}, {379,0.00102727}, {380,0.00370909}, {381,0.00110000}, {382,0.00109091}, {383,0.00110000}, {384,0.00108182}, {385,0.00108182}, {386,0.00115455}, {387,0.00113636}, {388,0.00118182}, {389,0.00121818}, {390,0.00119091}, {391,0.00125455}, {392,0.00128182}, {393,0.00127273}, {394,0.00130909}, {395,0.00124545}, {396,0.00133636}, {397,0.00137273}, {398,0.00141818}, {399,0.00143636}, {400,0.00147273}, {401,0.00148182}, {402,0.00151818}, {403,0.00151818}, {404,0.00151818}, {405,0.00155455}, {406,0.00171818}, {407,0.00168182}, {408,0.00168182}, {409,0.00168182}, {410,0.00170000}, {411,0.00183636}, {412,0.00180000}, {413,0.00180000}, {414,0.00181818}, {415,0.00180909}, {416,0.00183636}, {417,0.00181818}, {418,0.00184545}, {419,0.00190000}, {420,0.00190000}, {421,0.00187273}, {422,0.00191818}, {423,0.00195455}, {424,0.00195455}, {425,0.00197273}, {426,0.00198182}, {427,0.00198182}, {428,0.00197273}, {429,0.00198182}, {430,0.00195455}, {431,0.00197273}, {432,0.00394545}, {433,0.00200000}, {434,0.00200000}, {435,0.00200000}, {436,0.00200000}, {437,0.00200000}, {438,0.00200000}, {439,0.00200000}, {440,0.00200000}, {441,0.00200000}, {442,0.00200000}, {443,0.00200909}, {444,0.00200000}, {445,0.00200000}, {446,0.00200000}, {447,0.00200000}, {448,0.00200000}, {449,0.00200000}, {450,0.00200000}, {451,0.00200000}, {452,0.00200000}, {453,0.00200000}, {454,0.00200000}, {455,0.00200000}, {456,0.00400909}, {457,0.00200000}, {458,0.00200000}, {459,0.00200000}, {460,0.00200000}, {461,0.00200000}, {462,0.00200000}, {463,0.00200000}, {464,0.00200000}, {465,0.00200000}, {466,0.00200000}, {467,0.00201818}, {468,0.00200000}, {469,0.00200000}, {470,0.00200000}, {471,0.00200000}, {472,0.00200000}, {473,0.00200000}, {474,0.00200000}, {475,0.00200000}, {476,0.00200000}, {477,0.00200000}, {478,0.00200000}, {479,0.00442727}, {480,0.00200000}, {481,0.00200000}, {482,0.00200000}, {483,0.00200000}, {484,0.00200000}, {485,0.00200000}, {486,0.00200000}, {487,0.00200000}, {488,0.00200000}, {489,0.00200000}, {490,0.00437273}, {491,0.00200000}, {492,0.00200000}, {493,0.00200000}, {494,0.00200000}, {495,0.00200000}, {496,0.00200000}, {497,0.00200000}, {498,0.00200000}, {499,0.00200000}, {500,0.00200000}, {505,0.00400000}, {510,0.00200000}, {515,0.00200000}, {520,0.00200000}, {525,0.00200000}, {530,0.00200909}, {535,0.00200000}, {540,0.00200000}, {545,0.00200000}, {550,0.00200000}, {555,0.00200000}, {560,0.00200000}, {565,0.00200000}, {570,0.00200000}, {575,0.00201818}, {580,0.00200000}, {585,0.00201818}, {590,0.00201818}, {595,0.00203636}, {600,0.00208182}, {605,0.00205455}, {610,0.00211818}, {615,0.00222727}, {620,0.00221818}, {625,0.00232727}, {630,0.00245455}, {635,0.00261818}, {640,0.00267273}, {645,0.00277273}, {650,0.00280909}, {655,0.00282727}, {660,0.00288182}, {665,0.00292727}, {670,0.00296364}, {675,0.00299091}, {680,0.00300000}, {685,0.00300000}, {690,0.00300000}, {695,0.00300000}, {700,0.00300000}, {705,0.00300000}, {710,0.00300000}, {715,0.00300000}, {720,0.00300000}, {725,0.00305455}, {730,0.00300000}, {735,0.00300000}, {740,0.00300000}, {745,0.00300000}, {750,0.00300000}, {755,0.00300000}, {760,0.00300000}, {765,0.00581818}, {770,0.00300000}, {775,0.00300909}, {780,0.00300000}, {785,0.00300909}, {790,0.00302727}, {795,0.00300909}, {800,0.00301818}, {805,0.00301818}, {810,0.00300909}, {815,0.00302727}, {820,0.00304545}, {825,0.00304545}, {830,0.00308182}, {835,0.00590909}, {840,0.00315455}, {845,0.00325455}, {850,0.00329091}, {855,0.00339091}, {860,0.00350909}, {865,0.00359091}, {870,0.00368182}, {875,0.00371818}, {880,0.00378182}, {885,0.00379091}, {890,0.00380909}, {895,0.00390909}, {900,0.00591818}, {905,0.00392727}, {910,0.00394545}, {915,0.00400000}, {920,0.00399091}, {925,0.00400909}, {930,0.00871818}, {935,0.00400000}, {940,0.00399091}, {945,0.00400000}, {950,0.00400909}, {955,0.00400000}, {960,0.00910909}, {965,0.00400000}, {970,0.00400909}, {975,0.00400000}, {980,0.00400000}, {985,0.00401818}, {990,0.00596364}, {995,0.00400909}, {1000,0.00402727}, {1010,0.00401818}, {1020,0.00405455}, {1030,0.00408182}, {1040,0.00410000}, {1050,0.00413636}, {1060,0.00426364}, {1070,0.00436364}, {1080,0.00440000}, {1090,0.00614545}, {1100,0.00474545}, {1110,0.00479091}, {1120,0.00484545}, {1130,0.00488182}, {1140,0.00765455}, {1150,0.00496364}, {1160,0.00498182}, {1170,0.00501818}, {1180,0.00500909}, {1190,0.00915455}, {1200,0.00501818}, {1210,0.00503636}, {1220,0.00503636}, {1230,0.00509091}, {1240,0.00510909}, {1250,0.00510909}, {1260,0.00519091}, {1270,0.00523636}, {1280,0.00951818}, {1290,0.00556364}, {1300,0.00557273}, {1310,0.00568182}, {1320,0.00570909}, {1330,0.00578182}, {1340,0.00583636}, {1350,0.00589091}, {1360,0.00592727}, {1370,0.00590909}, {1380,0.00598182}, {1390,0.00599091}, {1400,0.00600000}, {1410,0.00920909}, {1420,0.00605455}, {1430,0.00611818}, {1440,0.00615455}, {1450,0.00905455}, {1460,0.00626364}, {1470,0.00626364}, {1480,0.00631818}, {1490,0.01210000}, {1500,0.00656364}, {1510,0.00663636}, {1520,0.00672727}, {1530,0.00672727}, {1540,0.00678182}, {1550,0.00683636}, {1560,0.00690909}, {1570,0.00692727}, {1580,0.00693636}, {1590,0.00695455}, {1600,0.01290000}, {1610,0.00698182}, {1620,0.00704545}, {1630,0.00711818}, {1640,0.00709091}, {1650,0.00712727}, {1660,0.00716364}, {1670,0.01200909}, {1680,0.00738182}, {1690,0.00740000}, {1700,0.00750000}, {1710,0.00756364}, {1720,0.00765455}, {1730,0.00771818}, {1740,0.01022727}, {1750,0.00779091}, {1760,0.00782727}, {1770,0.00799091}, {1780,0.00795455}, {1790,0.00793636}, {1800,0.00800909}, {1810,0.00799091}, {1820,0.00807273}, {1830,0.00807273}, {1840,0.00806364}, {1850,0.00820909}, {1860,0.00822727}, {1870,0.00824545}, {1880,0.00830909}, {1890,0.00835455}, {1900,0.01202727}, {1910,0.00857273}, {1920,0.00866364}, {1930,0.01090000}, {1940,0.00871818}, {1950,0.00880000}, {1960,0.01102727}, {1970,0.00887273}, {1980,0.00889091}, {1990,0.00893636}, {2000,0.00892727}, {2050,0.00920000}, {2100,0.00943636}, {2150,0.00978182}, {2200,0.01001818}, {2250,0.01014545}, {2300,0.01046364}, {2350,0.01459091}, {2400,0.01100000}, {2450,0.01115455}, {2500,0.01154545}, {2550,0.01187273}, {2600,0.01196364}, {2650,0.01213636}, {2700,0.01840909}, {2750,0.01280000}, {2800,0.02063636}, {2850,0.01324545}, {2900,0.02855455}, {2950,0.01380000}, {3000,0.02696364}, {3050,0.01419091}, {3100,0.02424545}, {3150,0.01490909}, {3200,0.01405455}, {3250,0.01530000}, {3300,0.01565455}, {3350,0.01591818}, {3400,0.01606364}, {3450,0.03293636}, {3500,0.01660909}, {3550,0.01690909}, {3600,0.01715455}, {3650,0.01734545}, {3700,0.03155455}, {3750,0.01790909}, {3800,0.01811818}, {3850,0.02899091}, {3900,0.01874545}, {3950,0.01890909}, {4000,0.03534545}, {4050,0.01943636}, {4100,0.01981818}, {4150,0.03179091}, {4200,0.02028182}, {4250,0.02046364}, {4300,0.02042727}, {4350,0.02144545}, {4400,0.02142727}, {4450,0.02168182}, {4500,0.01911818}, {4550,0.04187273}, {4600,0.02236364}, {4650,0.02274545}, {4700,0.02295455}, {4750,0.03666364}, {4800,0.02380909}, {4850,0.02379091}, {4900,0.02402727}, {4950,0.02434545}, {5000,0.02460000}, {5050,0.03815455}, {5100,0.04990000}, {5150,0.02532727}, {5200,0.02559091}, {5250,0.02581818}, {5300,0.02618182}, {5350,0.02626364}, {5400,0.02661818}, {5450,0.02332727}, {5500,0.03371818}, {5550,0.04037273}, {5600,0.05768182}, {5650,0.05789091}, {5700,0.04689091}, {5750,0.02907273}, {5800,0.02906364}, {5850,0.02954545}, {5900,0.02969091}, {5950,0.02990909}, {6000,0.03014545}, {6050,0.03079091}, {6100,0.05299091}, {6150,0.05951818}, {6200,0.05430909}, {6250,0.05382727}, {6300,0.05330909}, {6350,0.05411818}, {6400,0.03106364}, {6450,0.03212727}, {6500,0.03244545}, {6550,0.03275455}, {6600,0.03296364}, {6650,0.03304545}, {6700,0.05450000}, {6750,0.05621818}, {6800,0.05089091}, {6850,0.03416364}, {6900,0.03450909}, {6950,0.03462727}, {7000,0.03511818}, {7050,0.05644545}, {7100,0.05232727}, {7150,0.03569091}, {7200,0.03592727}, {7250,0.03684545}, {7300,0.05924545}, {7350,0.03662727}, {7400,0.03700909}, {7450,0.03761818}, {7500,0.05349091}, {7550,0.03756364}, {7600,0.03796364}, {7650,0.06957273}, {7700,0.04746364}, {7750,0.03867273}, {7800,0.03956364}, {7850,0.05480909}, {7900,0.03937273}, {7950,0.03998182}, {8000,0.05304545}, {8050,0.04008182}, {8100,0.07656364}, {8150,0.04679091}, {8200,0.04081818}, {8250,0.06399091}, {8300,0.04130909}, {8350,0.04230909}, {8400,0.05896364}, {8450,0.04210000}, {8500,0.06104545}, {8550,0.04268182}, {8600,0.07107273}, {8650,0.04315455}, {8700,0.07927273}, {8750,0.04366364}, {8800,0.06944545}, {8850,0.04418182}, {8900,0.07133636}, {8950,0.04467273}, {9000,0.06727273}, {9050,0.04517273}, {9100,0.08660909}, {9150,0.04549091}, {9200,0.07409091}, {9250,0.04607273}, {9300,0.06378182}, {9350,0.04658182}, {9400,0.05379091}, {9450,0.06623636}, {9500,0.04725455}, {9550,0.07153636}, {9600,0.04780000}, {9650,0.06000909}, {9700,0.09621818}, {9750,0.04846364}, {9800,0.05739091}, {9850,0.08484545}, {9900,0.04937273}, {9950,0.06266364}, {10000,0.09699091}, {10100,0.05028182}, {10200,0.06248182}, {10300,0.08636364}, {10400,0.05198182}, {10500,0.05238182}, {10600,0.06264545}, {10700,0.07452727}, {10800,0.08696364}, {10900,0.05460000}, {11000,0.05458182}, {11100,0.05520000}, {11200,0.06628182}, {11300,0.06950000}, {11400,0.08540909}, {11500,0.08393636}, {11600,0.08828182}, {11700,0.08827273}, {11800,0.08121818}, {11900,0.09063636}, {12000,0.09026364}, {12100,0.08834545}, {12200,0.08523636}, {12300,0.08452727}, {12400,0.08446364}, {12500,0.07529091}, {12600,0.05460909}, {12700,0.06319091}, {12800,0.06448182}, {12900,0.10604545}, {13000,0.09357273}, {13100,0.08219091}, {13200,0.06038182}, {13300,0.06687273}, {13400,0.10555455}, {13500,0.08675455}, {13600,0.06466364}, {13700,0.09925455}, {13800,0.09262727}, {13900,0.07917273}, {14000,0.10083636}, {14100,0.09100000}, {14200,0.07049091}, {14300,0.12174545}, {14400,0.08417273}, {14500,0.10335455}, {14600,0.08684545}, {14700,0.07357273}, {14800,0.09286364}, {14900,0.07457273}, {15000,0.35763636}, {15100,0.12208182}, {15200,0.08438182}, {15300,0.14147273}, {15400,0.08710909}, {15500,0.10693636}, {15600,0.07796364}, {15700,0.08966364}, {15800,0.13217273}, {15900,0.07857273}, {16000,0.09161818}, {16100,0.13020909}, {16200,0.12260909}, {16300,0.08995455}, {16400,0.10252727}, {16500,0.13369091}, {16600,0.11262727}, {16700,0.07192727}, {16800,0.09043636}, {16900,0.10584545}, {17000,0.13000000}, {17100,0.14025455}, {17200,0.14849091}, {17300,0.12107273}, {17400,0.08258182}, {17500,0.09004545}, {17600,0.09207273}, {17700,0.09320909}, {17800,0.08928182}, {17900,0.10150909}, {18000,0.10058182}, {18100,0.09419091}, {18200,0.09186364}, {18300,0.12654545}, {18400,0.11700000}, {18500,0.15504545}, {18600,0.15051818}, {18700,0.14000000}, {18800,0.10990909}, {18900,0.10243636}, {19000,0.09767273}, {19100,0.15657273}, {19200,0.14763636}, {19300,0.12912727}, {19400,0.10288182}, {19500,0.16030000}, {19600,0.14642727}, {19700,0.10839091}, {19800,0.11770000}, {19900,0.15570000}, {20000,0.10681481}};
data["big_flat"]["QuoteFlat"]["reif"]["user"] = {{1,0.00009091}, {2,0.00023636}, {3,0.00021818}, {4,0.00021818}, {5,0.00040000}, {6,0.00028182}, {7,0.00014545}, {8,0.00042727}, {9,0.00024545}, {10,0.00021818}, {11,0.00031818}, {12,0.00025455}, {13,0.00030000}, {14,0.00042727}, {15,0.00012727}, {16,0.00025455}, {17,0.00040000}, {18,0.00031818}, {19,0.00042727}, {20,0.00028182}, {21,0.00031818}, {22,0.00030909}, {23,0.00039091}, {24,0.00057273}, {25,0.00029091}, {26,0.00022727}, {27,0.00059091}, {28,0.00040909}, {29,0.00044545}, {30,0.00021818}, {31,0.00042727}, {32,0.00041818}, {33,0.00022727}, {34,0.00050000}, {35,0.00069091}, {36,0.00062727}, {37,0.00040909}, {38,0.00069091}, {39,0.00030909}, {40,0.00031818}, {41,0.00042727}, {42,0.00012727}, {43,0.00043636}, {44,0.00023636}, {45,0.00058182}, {46,0.00029091}, {47,0.00049091}, {48,0.00030909}, {49,0.00046364}, {50,0.00030909}, {51,0.00038182}, {52,0.00030000}, {53,0.00049091}, {54,0.00029091}, {55,0.00050909}, {56,0.00021818}, {57,0.00065455}, {58,0.00043636}, {59,0.00055455}, {60,0.00059091}, {61,0.00058182}, {62,0.00044545}, {63,0.00061818}, {64,0.00052727}, {65,0.00029091}, {66,0.00047273}, {67,0.00052727}, {68,0.00070000}, {69,0.00040000}, {70,0.00057273}, {71,0.00053636}, {72,0.00048182}, {73,0.00064545}, {74,0.00053636}, {75,0.00032727}, {76,0.00056364}, {77,0.00079091}, {78,0.00067273}, {79,0.00048182}, {80,0.00045455}, {81,0.00057273}, {82,0.00057273}, {83,0.00057273}, {84,0.00060909}, {85,0.00058182}, {86,0.00079091}, {87,0.00061818}, {88,0.00048182}, {89,0.00062727}, {90,0.00169091}, {91,0.00058182}, {92,0.00070000}, {93,0.00073636}, {94,0.00060909}, {95,0.00080000}, {96,0.00067273}, {97,0.00060909}, {98,0.00073636}, {99,0.00051818}, {100,0.00054545}, {101,0.00056364}, {102,0.00062727}, {103,0.00063636}, {104,0.00054545}, {105,0.00080909}, {106,0.00062727}, {107,0.00059091}, {108,0.00073636}, {109,0.00037273}, {110,0.00090000}, {111,0.00058182}, {112,0.00084545}, {113,0.00057273}, {114,0.00058182}, {115,0.00060909}, {116,0.00070000}, {117,0.00064545}, {118,0.00082727}, {119,0.00076364}, {120,0.00050000}, {121,0.00055455}, {122,0.00083636}, {123,0.00094545}, {124,0.00058182}, {125,0.00062727}, {126,0.00068182}, {127,0.00176364}, {128,0.00090909}, {129,0.00077273}, {130,0.00089091}, {131,0.00049091}, {132,0.00090000}, {133,0.00068182}, {134,0.00105455}, {135,0.00072727}, {136,0.00060909}, {137,0.00072727}, {138,0.00071818}, {139,0.00116364}, {140,0.00069091}, {141,0.00052727}, {142,0.00072727}, {143,0.00094545}, {144,0.00081818}, {145,0.00095455}, {146,0.00075455}, {147,0.00065455}, {148,0.00083636}, {149,0.00085455}, {150,0.00074545}, {151,0.00082727}, {152,0.00088182}, {153,0.00088182}, {154,0.00086364}, {155,0.00068182}, {156,0.00070909}, {157,0.00076364}, {158,0.00056364}, {159,0.00061818}, {160,0.00080909}, {161,0.00106364}, {162,0.00100909}, {163,0.00106364}, {164,0.00107273}, {165,0.00091818}, {166,0.00090909}, {167,0.00057273}, {168,0.00048182}, {169,0.00062727}, {170,0.00089091}, {171,0.00105455}, {172,0.00101818}, {173,0.00107273}, {174,0.00104545}, {175,0.00109091}, {176,0.00102727}, {177,0.00087273}, {178,0.00103636}, {179,0.00074545}, {180,0.00097273}, {181,0.00108182}, {182,0.00080909}, {183,0.00098182}, {184,0.00087273}, {185,0.00086364}, {186,0.00086364}, {187,0.00089091}, {188,0.00081818}, {189,0.00084545}, {190,0.00086364}, {191,0.00096364}, {192,0.00090909}, {193,0.00090909}, {194,0.00100909}, {195,0.00109091}, {196,0.00120000}, {197,0.00118182}, {198,0.00123636}, {199,0.00123636}, {200,0.00120909}, {201,0.00117273}, {202,0.00120000}, {203,0.00110000}, {204,0.00109091}, {205,0.00095455}, {206,0.00101818}, {207,0.00103636}, {208,0.00221818}, {209,0.00110000}, {210,0.00107273}, {211,0.00110909}, {212,0.00100909}, {213,0.00107273}, {214,0.00122727}, {215,0.00098182}, {216,0.00064545}, {217,0.00074545}, {218,0.00078182}, {219,0.00115455}, {220,0.00121818}, {221,0.00124545}, {222,0.00124545}, {223,0.00112727}, {224,0.00095455}, {225,0.00097273}, {226,0.00115455}, {227,0.00120000}, {228,0.00123636}, {229,0.00111818}, {230,0.00234545}, {231,0.00138182}, {232,0.00147273}, {233,0.00107273}, {234,0.00089091}, {235,0.00106364}, {236,0.00097273}, {237,0.00114545}, {238,0.00128182}, {239,0.00127273}, {240,0.00128182}, {241,0.00117273}, {242,0.00102727}, {243,0.00130909}, {244,0.00104545}, {245,0.00104545}, {246,0.00119091}, {247,0.00114545}, {248,0.00130909}, {249,0.00110000}, {250,0.00114545}, {251,0.00130909}, {252,0.00132727}, {253,0.00113636}, {254,0.00109091}, {255,0.00107273}, {256,0.00147273}, {257,0.00121818}, {258,0.00105455}, {259,0.00131818}, {260,0.00125455}, {261,0.00131818}, {262,0.00086364}, {263,0.00134545}, {264,0.00144545}, {265,0.00105455}, {266,0.00116364}, {267,0.00170909}, {268,0.00114545}, {269,0.00089091}, {270,0.00161818}, {271,0.00120000}, {272,0.00127273}, {273,0.00157273}, {274,0.00142727}, {275,0.00108182}, {276,0.00140000}, {277,0.00120909}, {278,0.00124545}, {279,0.00151818}, {280,0.00135455}, {281,0.00130909}, {282,0.00147273}, {283,0.00131818}, {284,0.00135455}, {285,0.00142727}, {286,0.00130909}, {287,0.00131818}, {288,0.00122727}, {289,0.00123636}, {290,0.00166364}, {291,0.00116364}, {292,0.00130000}, {293,0.00136364}, {294,0.00151818}, {295,0.00140000}, {296,0.00115455}, {297,0.00143636}, {298,0.00135455}, {299,0.00134545}, {300,0.00136364}, {301,0.00150000}, {302,0.00140909}, {303,0.00124545}, {304,0.00148182}, {305,0.00137273}, {306,0.00116364}, {307,0.00162727}, {308,0.00143636}, {309,0.00137273}, {310,0.00158182}, {311,0.00139091}, {312,0.00144545}, {313,0.00168182}, {314,0.00113636}, {315,0.00168182}, {316,0.00136364}, {317,0.00142727}, {318,0.00165455}, {319,0.00131818}, {320,0.00162727}, {321,0.00251818}, {322,0.00136364}, {323,0.00139091}, {324,0.00124545}, {325,0.00147273}, {326,0.00130909}, {327,0.00156364}, {328,0.00131818}, {329,0.00165455}, {330,0.00143636}, {331,0.00153636}, {332,0.00141818}, {333,0.00159091}, {334,0.00140000}, {335,0.00152727}, {336,0.00145455}, {337,0.00164545}, {338,0.00148182}, {339,0.00166364}, {340,0.00161818}, {341,0.00160000}, {342,0.00157273}, {343,0.00160909}, {344,0.00150000}, {345,0.00154545}, {346,0.00160909}, {347,0.00162727}, {348,0.00146364}, {349,0.00175455}, {350,0.00159091}, {351,0.00139091}, {352,0.00162727}, {353,0.00164545}, {354,0.00143636}, {355,0.00195455}, {356,0.00120909}, {357,0.00172727}, {358,0.00163636}, {359,0.00144545}, {360,0.00157273}, {361,0.00156364}, {362,0.00129091}, {363,0.00180909}, {364,0.00164545}, {365,0.00144545}, {366,0.00340000}, {367,0.00178182}, {368,0.00160000}, {369,0.00176364}, {370,0.00151818}, {371,0.00190000}, {372,0.00145455}, {373,0.00171818}, {374,0.00193636}, {375,0.00141818}, {376,0.00146364}, {377,0.00165455}, {378,0.00173636}, {379,0.00173636}, {380,0.00367273}, {381,0.00155455}, {382,0.00196364}, {383,0.00188182}, {384,0.00162727}, {385,0.00188182}, {386,0.00181818}, {387,0.00175455}, {388,0.00165455}, {389,0.00155455}, {390,0.00188182}, {391,0.00202727}, {392,0.00166364}, {393,0.00173636}, {394,0.00180909}, {395,0.00166364}, {396,0.00173636}, {397,0.00216364}, {398,0.00180000}, {399,0.00155455}, {400,0.00183636}, {401,0.00183636}, {402,0.00166364}, {403,0.00190000}, {404,0.00174545}, {405,0.00171818}, {406,0.00185455}, {407,0.00190000}, {408,0.00198182}, {409,0.00166364}, {410,0.00169091}, {411,0.00186364}, {412,0.00196364}, {413,0.00175455}, {414,0.00201818}, {415,0.00220000}, {416,0.00180909}, {417,0.00173636}, {418,0.00194545}, {419,0.00200909}, {420,0.00200909}, {421,0.00183636}, {422,0.00173636}, {423,0.00184545}, {424,0.00180909}, {425,0.00156364}, {426,0.00177273}, {427,0.00213636}, {428,0.00218182}, {429,0.00225455}, {430,0.00191818}, {431,0.00199091}, {432,0.00380909}, {433,0.00205455}, {434,0.00214545}, {435,0.00180000}, {436,0.00175455}, {437,0.00193636}, {438,0.00177273}, {439,0.00155455}, {440,0.00197273}, {441,0.00220909}, {442,0.00226364}, {443,0.00222727}, {444,0.00225455}, {445,0.00205455}, {446,0.00197273}, {447,0.00205455}, {448,0.00213636}, {449,0.00220000}, {450,0.00217273}, {451,0.00193636}, {452,0.00214545}, {453,0.00229091}, {454,0.00204545}, {455,0.00195455}, {456,0.00414545}, {457,0.00210909}, {458,0.00204545}, {459,0.00197273}, {460,0.00191818}, {461,0.00187273}, {462,0.00201818}, {463,0.00205455}, {464,0.00200909}, {465,0.00201818}, {466,0.00196364}, {467,0.00207273}, {468,0.00230000}, {469,0.00240000}, {470,0.00235455}, {471,0.00221818}, {472,0.00215455}, {473,0.00207273}, {474,0.00202727}, {475,0.00210909}, {476,0.00195455}, {477,0.00182727}, {478,0.00199091}, {479,0.00434545}, {480,0.00219091}, {481,0.00192727}, {482,0.00184545}, {483,0.00184545}, {484,0.00167273}, {485,0.00191818}, {486,0.00203636}, {487,0.00218182}, {488,0.00220000}, {489,0.00213636}, {490,0.00446364}, {491,0.00233636}, {492,0.00233636}, {493,0.00234545}, {494,0.00200909}, {495,0.00241818}, {496,0.00220909}, {497,0.00228182}, {498,0.00235455}, {499,0.00216364}, {500,0.00197273}, {505,0.00409091}, {510,0.00254545}, {515,0.00224545}, {520,0.00224545}, {525,0.00250000}, {530,0.00223636}, {535,0.00224545}, {540,0.00236364}, {545,0.00247273}, {550,0.00216364}, {555,0.00246364}, {560,0.00272727}, {565,0.00245455}, {570,0.00238182}, {575,0.00255455}, {580,0.00253636}, {585,0.00279091}, {590,0.00259091}, {595,0.00282727}, {600,0.00267273}, {605,0.00260909}, {610,0.00267273}, {615,0.00264545}, {620,0.00279091}, {625,0.00245455}, {630,0.00274545}, {635,0.00278182}, {640,0.00280909}, {645,0.00301818}, {650,0.00268182}, {655,0.00286364}, {660,0.00268182}, {665,0.00290000}, {670,0.00270000}, {675,0.00275455}, {680,0.00294545}, {685,0.00273636}, {690,0.00284545}, {695,0.00279091}, {700,0.00290909}, {705,0.00292727}, {710,0.00285455}, {715,0.00312727}, {720,0.00302727}, {725,0.00330909}, {730,0.00292727}, {735,0.00326364}, {740,0.00300000}, {745,0.00305455}, {750,0.00313636}, {755,0.00300909}, {760,0.00290000}, {765,0.00542727}, {770,0.00312727}, {775,0.00324545}, {780,0.00331818}, {785,0.00334545}, {790,0.00337273}, {795,0.00316364}, {800,0.00335455}, {805,0.00319091}, {810,0.00337273}, {815,0.00345455}, {820,0.00331818}, {825,0.00343636}, {830,0.00346364}, {835,0.00583636}, {840,0.00356364}, {845,0.00348182}, {850,0.00362727}, {855,0.00350000}, {860,0.00358182}, {865,0.00370000}, {870,0.00361818}, {875,0.00365455}, {880,0.00362727}, {885,0.00360909}, {890,0.00380000}, {895,0.00366364}, {900,0.00559091}, {905,0.00379091}, {910,0.00377273}, {915,0.00380000}, {920,0.00384545}, {925,0.00380000}, {930,0.00855455}, {935,0.00388182}, {940,0.00393636}, {945,0.00404545}, {950,0.00404545}, {955,0.00382727}, {960,0.00889091}, {965,0.00404545}, {970,0.00417273}, {975,0.00410000}, {980,0.00410000}, {985,0.00413636}, {990,0.00576364}, {995,0.00424545}, {1000,0.00429091}, {1010,0.00445455}, {1020,0.00440909}, {1030,0.00426364}, {1040,0.00437273}, {1050,0.00460909}, {1060,0.00464545}, {1070,0.00435455}, {1080,0.00446364}, {1090,0.00610909}, {1100,0.00437273}, {1110,0.00486364}, {1120,0.00461818}, {1130,0.00452727}, {1140,0.00715455}, {1150,0.00483636}, {1160,0.00493636}, {1170,0.00474545}, {1180,0.00505455}, {1190,0.00940000}, {1200,0.00490000}, {1210,0.00492727}, {1220,0.00519091}, {1230,0.00527273}, {1240,0.00541818}, {1250,0.00526364}, {1260,0.00520000}, {1270,0.00520909}, {1280,0.00917273}, {1290,0.00517273}, {1300,0.00540909}, {1310,0.00562727}, {1320,0.00529091}, {1330,0.00540909}, {1340,0.00553636}, {1350,0.00580909}, {1360,0.00549091}, {1370,0.00548182}, {1380,0.00561818}, {1390,0.00580909}, {1400,0.00590000}, {1410,0.00932727}, {1420,0.00600909}, {1430,0.00593636}, {1440,0.00582727}, {1450,0.00915455}, {1460,0.00625455}, {1470,0.00634545}, {1480,0.00629091}, {1490,0.01220909}, {1500,0.00609091}, {1510,0.00633636}, {1520,0.00631818}, {1530,0.00645455}, {1540,0.00654545}, {1550,0.00679091}, {1560,0.00680909}, {1570,0.00634545}, {1580,0.00666364}, {1590,0.00690000}, {1600,0.01300000}, {1610,0.00682727}, {1620,0.00661818}, {1630,0.00696364}, {1640,0.00700909}, {1650,0.00669091}, {1660,0.00700909}, {1670,0.01222727}, {1680,0.00721818}, {1690,0.00696364}, {1700,0.00727273}, {1710,0.00725455}, {1720,0.00739091}, {1730,0.00740909}, {1740,0.01016364}, {1750,0.00724545}, {1760,0.00764545}, {1770,0.00774545}, {1780,0.00763636}, {1790,0.00773636}, {1800,0.00796364}, {1810,0.00770909}, {1820,0.00811818}, {1830,0.00794545}, {1840,0.00797273}, {1850,0.00845455}, {1860,0.00810909}, {1870,0.00816364}, {1880,0.00810909}, {1890,0.00814545}, {1900,0.01224545}, {1910,0.00818182}, {1920,0.00840000}, {1930,0.01071818}, {1940,0.00810909}, {1950,0.00850909}, {1960,0.01101818}, {1970,0.00871818}, {1980,0.00870909}, {1990,0.00874545}, {2000,0.00906364}, {2050,0.00919091}, {2100,0.00965455}, {2150,0.01003636}, {2200,0.01040000}, {2250,0.01036364}, {2300,0.01047273}, {2350,0.01435455}, {2400,0.01131818}, {2450,0.01176364}, {2500,0.01184545}, {2550,0.01204545}, {2600,0.01229091}, {2650,0.01240909}, {2700,0.01795455}, {2750,0.01304545}, {2800,0.02040000}, {2850,0.01370909}, {2900,0.02845455}, {2950,0.01401818}, {3000,0.02673636}, {3050,0.01439091}, {3100,0.02401818}, {3150,0.01490000}, {3200,0.01407273}, {3250,0.01515455}, {3300,0.01571818}, {3350,0.01579091}, {3400,0.01596364}, {3450,0.03290000}, {3500,0.01623636}, {3550,0.01672727}, {3600,0.01700000}, {3650,0.01722727}, {3700,0.03164545}, {3750,0.01756364}, {3800,0.01800909}, {3850,0.02853636}, {3900,0.01829091}, {3950,0.01844545}, {4000,0.03541818}, {4050,0.01907273}, {4100,0.01951818}, {4150,0.03152727}, {4200,0.02013636}, {4250,0.02026364}, {4300,0.02004545}, {4350,0.02136364}, {4400,0.02085455}, {4450,0.02182727}, {4500,0.01872727}, {4550,0.04184545}, {4600,0.02247273}, {4650,0.02280000}, {4700,0.02325455}, {4750,0.03631818}, {4800,0.02381818}, {4850,0.02394545}, {4900,0.02403636}, {4950,0.02440909}, {5000,0.02450000}, {5050,0.03776364}, {5100,0.04950000}, {5150,0.02509091}, {5200,0.02550909}, {5250,0.02595455}, {5300,0.02630000}, {5350,0.02610909}, {5400,0.02666364}, {5450,0.02364545}, {5500,0.03381818}, {5550,0.04011818}, {5600,0.05699091}, {5650,0.05712727}, {5700,0.04663636}, {5750,0.02886364}, {5800,0.02888182}, {5850,0.02929091}, {5900,0.02955455}, {5950,0.03001818}, {6000,0.02995455}, {6050,0.03098182}, {6100,0.05252727}, {6150,0.05882727}, {6200,0.05392727}, {6250,0.05339091}, {6300,0.05292727}, {6350,0.05324545}, {6400,0.03135455}, {6450,0.03223636}, {6500,0.03254545}, {6550,0.03312727}, {6600,0.03319091}, {6650,0.03356364}, {6700,0.05399091}, {6750,0.05558182}, {6800,0.04996364}, {6850,0.03420000}, {6900,0.03448182}, {6950,0.03483636}, {7000,0.03501818}, {7050,0.05576364}, {7100,0.05154545}, {7150,0.03595455}, {7200,0.03620000}, {7250,0.03665455}, {7300,0.05911818}, {7350,0.03669091}, {7400,0.03727273}, {7450,0.03714545}, {7500,0.05293636}, {7550,0.03739091}, {7600,0.03760909}, {7650,0.06908182}, {7700,0.04707273}, {7750,0.03851818}, {7800,0.03920909}, {7850,0.05435455}, {7900,0.03910909}, {7950,0.03952727}, {8000,0.05254545}, {8050,0.03978182}, {8100,0.07621818}, {8150,0.04645455}, {8200,0.04059091}, {8250,0.06330909}, {8300,0.04110000}, {8350,0.04200000}, {8400,0.05820909}, {8450,0.04190000}, {8500,0.06085455}, {8550,0.04237273}, {8600,0.07096364}, {8650,0.04288182}, {8700,0.07867273}, {8750,0.04387273}, {8800,0.06900000}, {8850,0.04429091}, {8900,0.07102727}, {8950,0.04465455}, {9000,0.06694545}, {9050,0.04522727}, {9100,0.08572727}, {9150,0.04564545}, {9200,0.07341818}, {9250,0.04611818}, {9300,0.06383636}, {9350,0.04661818}, {9400,0.05360909}, {9450,0.06641818}, {9500,0.04734545}, {9550,0.07168182}, {9600,0.04805455}, {9650,0.06000000}, {9700,0.09605455}, {9750,0.04834545}, {9800,0.05746364}, {9850,0.08503636}, {9900,0.04910000}, {9950,0.06290909}, {10000,0.09647273}, {10100,0.05001818}, {10200,0.06258182}, {10300,0.08590000}, {10400,0.05161818}, {10500,0.05220000}, {10600,0.06275455}, {10700,0.07429091}, {10800,0.08633636}, {10900,0.05417273}, {11000,0.05426364}, {11100,0.05481818}, {11200,0.06550909}, {11300,0.06913636}, {11400,0.08499091}, {11500,0.08379091}, {11600,0.08742727}, {11700,0.08750909}, {11800,0.08042727}, {11900,0.09015455}, {12000,0.08938182}, {12100,0.08720000}, {12200,0.08492727}, {12300,0.08402727}, {12400,0.08372727}, {12500,0.07508182}, {12600,0.05421818}, {12700,0.06376364}, {12800,0.06455455}, {12900,0.10605455}, {13000,0.09377273}, {13100,0.08217273}, {13200,0.06038182}, {13300,0.06690909}, {13400,0.10565455}, {13500,0.08677273}, {13600,0.06457273}, {13700,0.09924545}, {13800,0.09258182}, {13900,0.07902727}, {14000,0.10057273}, {14100,0.09076364}, {14200,0.07070909}, {14300,0.12214545}, {14400,0.08450909}, {14500,0.10316364}, {14600,0.08647273}, {14700,0.07366364}, {14800,0.09250000}, {14900,0.07453636}, {15000,0.35724545}, {15100,0.12176364}, {15200,0.08424545}, {15300,0.14139091}, {15400,0.08678182}, {15500,0.10670909}, {15600,0.07797273}, {15700,0.08940909}, {15800,0.13243636}, {15900,0.07816364}, {16000,0.09166364}, {16100,0.13046364}, {16200,0.12232727}, {16300,0.08965455}, {16400,0.10249091}, {16500,0.13410000}, {16600,0.11204545}, {16700,0.07182727}, {16800,0.08990000}, {16900,0.10588182}, {17000,0.13023636}, {17100,0.14010000}, {17200,0.14865455}, {17300,0.12055455}, {17400,0.08262727}, {17500,0.08997273}, {17600,0.09204545}, {17700,0.09317273}, {17800,0.08910909}, {17900,0.10100909}, {18000,0.10039091}, {18100,0.09439091}, {18200,0.09135455}, {18300,0.12655455}, {18400,0.11703636}, {18500,0.15496364}, {18600,0.15060909}, {18700,0.13980909}, {18800,0.10987273}, {18900,0.10223636}, {19000,0.09758182}, {19100,0.15659091}, {19200,0.14765455}, {19300,0.12917273}, {19400,0.10277273}, {19500,0.16008182}, {19600,0.14650909}, {19700,0.10817273}, {19800,0.11729091}, {19900,0.15520909}, {20000,0.10639815}};
data["big_flat"]["QuoteFlat"]["reif"]["system"] = {{1,0.00007273}, {2,0.00021818}, {3,0.00003636}, {4,0.00000000}, {5,0.00002727}, {6,0.00010909}, {7,0.00003636}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00003636}, {20,0.00003636}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00003636}, {28,0.00000000}, {29,0.00003636}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00003636}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00007273}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00003636}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00010909}, {60,0.00000000}, {61,0.00003636}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00003636}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00003636}, {89,0.00000000}, {90,0.00010909}, {91,0.00003636}, {92,0.00000000}, {93,0.00006364}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003636}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00002727}, {111,0.00003636}, {112,0.00000000}, {113,0.00000000}, {114,0.00003636}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00007273}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00003636}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00003636}, {138,0.00000000}, {139,0.00000000}, {140,0.00003636}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00003636}, {146,0.00003636}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00007273}, {153,0.00000000}, {154,0.00003636}, {155,0.00000000}, {156,0.00000000}, {157,0.00003636}, {158,0.00000000}, {159,0.00003636}, {160,0.00000000}, {161,0.00000000}, {162,0.00007273}, {163,0.00006364}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00002727}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00002727}, {173,0.00000000}, {174,0.00007273}, {175,0.00000000}, {176,0.00000000}, {177,0.00003636}, {178,0.00000000}, {179,0.00007273}, {180,0.00000000}, {181,0.00003636}, {182,0.00003636}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00003636}, {189,0.00003636}, {190,0.00000000}, {191,0.00000000}, {192,0.00003636}, {193,0.00000000}, {194,0.00000000}, {195,0.00003636}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00003636}, {204,0.00000000}, {205,0.00003636}, {206,0.00000000}, {207,0.00000000}, {208,0.00003636}, {209,0.00000000}, {210,0.00000000}, {211,0.00003636}, {212,0.00000000}, {213,0.00000000}, {214,0.00003636}, {215,0.00002727}, {216,0.00000000}, {217,0.00002727}, {218,0.00003636}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00007273}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00006364}, {230,0.00000000}, {231,0.00003636}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00003636}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00003636}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00003636}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00003636}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00003636}, {267,0.00000000}, {268,0.00000000}, {269,0.00003636}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00003636}, {276,0.00002727}, {277,0.00002727}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00003636}, {285,0.00003636}, {286,0.00006364}, {287,0.00000000}, {288,0.00005455}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00003636}, {297,0.00003636}, {298,0.00000000}, {299,0.00003636}, {300,0.00003636}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00003636}, {305,0.00003636}, {306,0.00003636}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00010000}, {311,0.00003636}, {312,0.00003636}, {313,0.00003636}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00002727}, {318,0.00000000}, {319,0.00003636}, {320,0.00007273}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00003636}, {325,0.00000000}, {326,0.00003636}, {327,0.00000000}, {328,0.00000000}, {329,0.00003636}, {330,0.00000000}, {331,0.00003636}, {332,0.00000000}, {333,0.00003636}, {334,0.00003636}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00003636}, {340,0.00003636}, {341,0.00000000}, {342,0.00003636}, {343,0.00003636}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00003636}, {348,0.00000000}, {349,0.00000000}, {350,0.00003636}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00003636}, {359,0.00000000}, {360,0.00002727}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00003636}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00010909}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00003636}, {377,0.00000000}, {378,0.00003636}, {379,0.00000000}, {380,0.00000000}, {381,0.00010909}, {382,0.00003636}, {383,0.00002727}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00007273}, {390,0.00002727}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00007273}, {396,0.00007273}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00003636}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00006364}, {411,0.00003636}, {412,0.00000000}, {413,0.00000000}, {414,0.00003636}, {415,0.00000000}, {416,0.00002727}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00007273}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00003636}, {431,0.00000000}, {432,0.00003636}, {433,0.00006364}, {434,0.00003636}, {435,0.00000000}, {436,0.00007273}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00014545}, {442,0.00003636}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00003636}, {451,0.00003636}, {452,0.00000000}, {453,0.00003636}, {454,0.00006364}, {455,0.00006364}, {456,0.00006364}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00010000}, {466,0.00000000}, {467,0.00000000}, {468,0.00010909}, {469,0.00003636}, {470,0.00000000}, {471,0.00003636}, {472,0.00003636}, {473,0.00003636}, {474,0.00003636}, {475,0.00000000}, {476,0.00000000}, {477,0.00003636}, {478,0.00003636}, {479,0.00003636}, {480,0.00000000}, {481,0.00000000}, {482,0.00003636}, {483,0.00002727}, {484,0.00003636}, {485,0.00003636}, {486,0.00003636}, {487,0.00007273}, {488,0.00003636}, {489,0.00000000}, {490,0.00007273}, {491,0.00003636}, {492,0.00000000}, {493,0.00000000}, {494,0.00007273}, {495,0.00003636}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00003636}, {510,0.00000000}, {515,0.00003636}, {520,0.00000000}, {525,0.00003636}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00003636}, {550,0.00006364}, {555,0.00002727}, {560,0.00000000}, {565,0.00000000}, {570,0.00003636}, {575,0.00000000}, {580,0.00003636}, {585,0.00002727}, {590,0.00000000}, {595,0.00000000}, {600,0.00007273}, {605,0.00000000}, {610,0.00003636}, {615,0.00003636}, {620,0.00000000}, {625,0.00003636}, {630,0.00007273}, {635,0.00000000}, {640,0.00003636}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00003636}, {670,0.00007273}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00010909}, {695,0.00000000}, {700,0.00003636}, {705,0.00003636}, {710,0.00000000}, {715,0.00000000}, {720,0.00003636}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00003636}, {745,0.00009091}, {750,0.00003636}, {755,0.00000000}, {760,0.00010909}, {765,0.00007273}, {770,0.00003636}, {775,0.00010909}, {780,0.00000000}, {785,0.00003636}, {790,0.00003636}, {795,0.00003636}, {800,0.00003636}, {805,0.00000000}, {810,0.00007273}, {815,0.00000000}, {820,0.00000000}, {825,0.00003636}, {830,0.00003636}, {835,0.00003636}, {840,0.00007273}, {845,0.00010909}, {850,0.00003636}, {855,0.00003636}, {860,0.00010000}, {865,0.00000000}, {870,0.00003636}, {875,0.00000000}, {880,0.00000000}, {885,0.00010909}, {890,0.00003636}, {895,0.00003636}, {900,0.00007273}, {905,0.00007273}, {910,0.00000000}, {915,0.00007273}, {920,0.00006364}, {925,0.00003636}, {930,0.00007273}, {935,0.00000000}, {940,0.00000000}, {945,0.00007273}, {950,0.00007273}, {955,0.00007273}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00002727}, {980,0.00000000}, {985,0.00000000}, {990,0.00010909}, {995,0.00003636}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00007273}, {1040,0.00000000}, {1050,0.00003636}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00003636}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00003636}, {1140,0.00013636}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00003636}, {1190,0.00007273}, {1200,0.00000000}, {1210,0.00014545}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00003636}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00003636}, {1280,0.00010000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00002727}, {1320,0.00003636}, {1330,0.00010909}, {1340,0.00000000}, {1350,0.00003636}, {1360,0.00003636}, {1370,0.00003636}, {1380,0.00002727}, {1390,0.00003636}, {1400,0.00007273}, {1410,0.00003636}, {1420,0.00010909}, {1430,0.00000000}, {1440,0.00014545}, {1450,0.00000000}, {1460,0.00003636}, {1470,0.00000000}, {1480,0.00003636}, {1490,0.00027273}, {1500,0.00003636}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00003636}, {1540,0.00013636}, {1550,0.00002727}, {1560,0.00007273}, {1570,0.00010909}, {1580,0.00003636}, {1590,0.00000000}, {1600,0.00013636}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00010909}, {1640,0.00003636}, {1650,0.00007273}, {1660,0.00000000}, {1670,0.00018182}, {1680,0.00003636}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00003636}, {1730,0.00000000}, {1740,0.00013636}, {1750,0.00003636}, {1760,0.00000000}, {1770,0.00003636}, {1780,0.00000000}, {1790,0.00003636}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00003636}, {1840,0.00003636}, {1850,0.00003636}, {1860,0.00003636}, {1870,0.00000000}, {1880,0.00002727}, {1890,0.00007273}, {1900,0.00018182}, {1910,0.00000000}, {1920,0.00007273}, {1930,0.00010000}, {1940,0.00003636}, {1950,0.00007273}, {1960,0.00010000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00007273}, {2000,0.00007273}, {2050,0.00003636}, {2100,0.00007273}, {2150,0.00003636}, {2200,0.00003636}, {2250,0.00010000}, {2300,0.00013636}, {2350,0.00014545}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00007273}, {2600,0.00003636}, {2650,0.00003636}, {2700,0.00014545}, {2750,0.00007273}, {2800,0.00018182}, {2850,0.00000000}, {2900,0.00020909}, {2950,0.00003636}, {3000,0.00029091}, {3050,0.00014545}, {3100,0.00021818}, {3150,0.00000000}, {3200,0.00006364}, {3250,0.00003636}, {3300,0.00003636}, {3350,0.00000000}, {3400,0.00007273}, {3450,0.00031818}, {3500,0.00007273}, {3550,0.00003636}, {3600,0.00000000}, {3650,0.00003636}, {3700,0.00013636}, {3750,0.00000000}, {3800,0.00007273}, {3850,0.00013636}, {3900,0.00003636}, {3950,0.00003636}, {4000,0.00017273}, {4050,0.00006364}, {4100,0.00006364}, {4150,0.00019091}, {4200,0.00000000}, {4250,0.00014545}, {4300,0.00007273}, {4350,0.00006364}, {4400,0.00007273}, {4450,0.00000000}, {4500,0.00003636}, {4550,0.00021818}, {4600,0.00003636}, {4650,0.00000000}, {4700,0.00007273}, {4750,0.00041818}, {4800,0.00010000}, {4850,0.00003636}, {4900,0.00007273}, {4950,0.00003636}, {5000,0.00014545}, {5050,0.00030909}, {5100,0.00024545}, {5150,0.00010000}, {5200,0.00003636}, {5250,0.00000000}, {5300,0.00002727}, {5350,0.00010909}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00032727}, {5550,0.00022727}, {5600,0.00053636}, {5650,0.00069091}, {5700,0.00032727}, {5750,0.00007273}, {5800,0.00003636}, {5850,0.00007273}, {5900,0.00006364}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00010909}, {6100,0.00042727}, {6150,0.00052727}, {6200,0.00049091}, {6250,0.00021818}, {6300,0.00036364}, {6350,0.00075455}, {6400,0.00006364}, {6450,0.00010909}, {6500,0.00010909}, {6550,0.00000000}, {6600,0.00006364}, {6650,0.00003636}, {6700,0.00061818}, {6750,0.00047273}, {6800,0.00056364}, {6850,0.00018182}, {6900,0.00003636}, {6950,0.00000000}, {7000,0.00017273}, {7050,0.00041818}, {7100,0.00067273}, {7150,0.00007273}, {7200,0.00010909}, {7250,0.00006364}, {7300,0.00046364}, {7350,0.00007273}, {7400,0.00000000}, {7450,0.00018182}, {7500,0.00021818}, {7550,0.00010000}, {7600,0.00006364}, {7650,0.00065455}, {7700,0.00039091}, {7750,0.00003636}, {7800,0.00000000}, {7850,0.00053636}, {7900,0.00003636}, {7950,0.00010909}, {8000,0.00033636}, {8050,0.00010909}, {8100,0.00043636}, {8150,0.00035455}, {8200,0.00000000}, {8250,0.00054545}, {8300,0.00010000}, {8350,0.00002727}, {8400,0.00060909}, {8450,0.00000000}, {8500,0.00040000}, {8550,0.00003636}, {8600,0.00036364}, {8650,0.00018182}, {8700,0.00076364}, {8750,0.00003636}, {8800,0.00028182}, {8850,0.00014545}, {8900,0.00067273}, {8950,0.00007273}, {9000,0.00041818}, {9050,0.00018182}, {9100,0.00068182}, {9150,0.00010000}, {9200,0.00054545}, {9250,0.00009091}, {9300,0.00018182}, {9350,0.00010909}, {9400,0.00003636}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00007273}, {9600,0.00003636}, {9650,0.00003636}, {9700,0.00003636}, {9750,0.00010909}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00003636}, {9950,0.00000000}, {10000,0.00069091}, {10100,0.00007273}, {10200,0.00021818}, {10300,0.00075455}, {10400,0.00003636}, {10500,0.00014545}, {10600,0.00023636}, {10700,0.00045455}, {10800,0.00056364}, {10900,0.00018182}, {11000,0.00007273}, {11100,0.00010909}, {11200,0.00050000}, {11300,0.00040000}, {11400,0.00058182}, {11500,0.00047273}, {11600,0.00073636}, {11700,0.00069091}, {11800,0.00076364}, {11900,0.00045455}, {12000,0.00074545}, {12100,0.00039091}, {12200,0.00072727}, {12300,0.00058182}, {12400,0.00043636}, {12500,0.00039091}, {12600,0.00003636}, {12700,0.00007273}, {12800,0.00007273}, {12900,0.00003636}, {13000,0.00000000}, {13100,0.00003636}, {13200,0.00010909}, {13300,0.00003636}, {13400,0.00000000}, {13500,0.00003636}, {13600,0.00003636}, {13700,0.00007273}, {13800,0.00013636}, {13900,0.00000000}, {14000,0.00007273}, {14100,0.00003636}, {14200,0.00010909}, {14300,0.00003636}, {14400,0.00000000}, {14500,0.00003636}, {14600,0.00010909}, {14700,0.00007273}, {14800,0.00003636}, {14900,0.00000000}, {15000,0.00020909}, {15100,0.00003636}, {15200,0.00000000}, {15300,0.00014545}, {15400,0.00007273}, {15500,0.00021818}, {15600,0.00000000}, {15700,0.00010909}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00010909}, {16100,0.00003636}, {16200,0.00000000}, {16300,0.00007273}, {16400,0.00000000}, {16500,0.00007273}, {16600,0.00002727}, {16700,0.00003636}, {16800,0.00000000}, {16900,0.00007273}, {17000,0.00003636}, {17100,0.00000000}, {17200,0.00010909}, {17300,0.00007273}, {17400,0.00000000}, {17500,0.00007273}, {17600,0.00007273}, {17700,0.00007273}, {17800,0.00000000}, {17900,0.00003636}, {18000,0.00003636}, {18100,0.00003636}, {18200,0.00003636}, {18300,0.00014545}, {18400,0.00003636}, {18500,0.00003636}, {18600,0.00014545}, {18700,0.00003636}, {18800,0.00010000}, {18900,0.00000000}, {19000,0.00006364}, {19100,0.00007273}, {19200,0.00020909}, {19300,0.00000000}, {19400,0.00003636}, {19500,0.00014545}, {19600,0.00000000}, {19700,0.00021818}, {19800,0.00020000}, {19900,0.00049091}, {20000,0.00032407}};
data["big_flat"]["TemplateCoq"]["Aggregate"]["real"] = {{1,0.00101802}, {2,0.00058559}, {3,0.00091892}, {4,0.00100000}, {5,0.00100000}, {6,0.00100000}, {7,0.00100000}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100901}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00100000}, {16,0.00100000}, {17,0.00100000}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00100000}, {23,0.00100000}, {24,0.00100000}, {25,0.00100000}, {26,0.00100000}, {27,0.00100000}, {28,0.00102703}, {29,0.00107207}, {30,0.00118018}, {31,0.00147748}, {32,0.00127928}, {33,0.00142342}, {34,0.00168468}, {35,0.00185586}, {36,0.00194595}, {37,0.00200000}, {38,0.00200000}, {39,0.00201802}, {40,0.00200000}, {41,0.00200000}, {42,0.00200000}, {43,0.00200000}, {44,0.00200000}, {45,0.00200000}, {46,0.00200000}, {47,0.00200000}, {48,0.00200000}, {49,0.00200000}, {50,0.00200000}, {51,0.00200000}, {52,0.00200000}, {53,0.00200000}, {54,0.00200000}, {55,0.00200000}, {56,0.00200000}, {57,0.00200901}, {58,0.00200000}, {59,0.00200000}, {60,0.00204505}, {61,0.00204505}, {62,0.00212613}, {63,0.00218919}, {64,0.00229730}, {65,0.00269369}, {66,0.00259459}, {67,0.00279279}, {68,0.00286486}, {69,0.00293694}, {70,0.00299099}, {71,0.00300000}, {72,0.00300000}, {73,0.00300000}, {74,0.00300000}, {75,0.00300000}, {76,0.00300000}, {77,0.00300000}, {78,0.00300000}, {79,0.00300000}, {80,0.00300000}, {81,0.00300000}, {82,0.00300000}, {83,0.00300000}, {84,0.00300000}, {85,0.00300000}, {86,0.00300901}, {87,0.00301802}, {88,0.00470270}, {89,0.00300901}, {90,0.00302703}, {91,0.00302703}, {92,0.00301802}, {93,0.00306306}, {94,0.00308108}, {95,0.00314414}, {96,0.00319820}, {97,0.00329730}, {98,0.00342342}, {99,0.00356757}, {100,0.00365766}, {101,0.00381081}, {102,0.00387387}, {103,0.00391892}, {104,0.00395495}, {105,0.00397297}, {106,0.00397297}, {107,0.00398198}, {108,0.00484685}, {109,0.00400000}, {110,0.00400000}, {111,0.00400000}, {112,0.00400000}, {113,0.00400000}, {114,0.00400000}, {115,0.00400000}, {116,0.00400000}, {117,0.00400901}, {118,0.00400000}, {119,0.00400000}, {120,0.00401802}, {121,0.00400901}, {122,0.00400901}, {123,0.00402703}, {124,0.00407207}, {125,0.00498198}, {126,0.00408108}, {127,0.00416216}, {128,0.00418919}, {129,0.00430631}, {130,0.00438739}, {131,0.00448649}, {132,0.00462162}, {133,0.00466667}, {134,0.00479279}, {135,0.00485586}, {136,0.00491892}, {137,0.00491892}, {138,0.00494595}, {139,0.00499099}, {140,0.00574775}, {141,0.00499099}, {142,0.00500000}, {143,0.00500000}, {144,0.00500000}, {145,0.00500000}, {146,0.00500000}, {147,0.00500000}, {148,0.00501802}, {149,0.00500901}, {150,0.00500901}, {151,0.00500901}, {152,0.00505405}, {153,0.00505405}, {154,0.00597297}, {155,0.00504505}, {156,0.00509009}, {157,0.00512613}, {158,0.00520721}, {159,0.00525225}, {160,0.00531532}, {161,0.00545946}, {162,0.00555856}, {163,0.00564865}, {164,0.00570270}, {165,0.00580180}, {166,0.00638739}, {167,0.00589189}, {168,0.00592793}, {169,0.00596396}, {170,0.00597297}, {171,0.00598198}, {172,0.00599099}, {173,0.00599099}, {174,0.00600000}, {175,0.00599099}, {176,0.00600000}, {177,0.00600000}, {178,0.00686486}, {179,0.00600000}, {180,0.00600000}, {181,0.00600000}, {182,0.00600901}, {183,0.00604505}, {184,0.00600901}, {185,0.00602703}, {186,0.00605405}, {187,0.00609009}, {188,0.00610811}, {189,0.00620721}, {190,0.00702703}, {191,0.00629730}, {192,0.00638739}, {193,0.00642342}, {194,0.00654054}, {195,0.00657658}, {196,0.00663964}, {197,0.00671171}, {198,0.00681982}, {199,0.00686486}, {200,0.00763063}, {201,0.00690991}, {202,0.00690090}, {203,0.00698198}, {204,0.00695495}, {205,0.00698198}, {206,0.00699099}, {207,0.00700000}, {208,0.00699099}, {209,0.00700000}, {210,0.00701802}, {211,0.00772072}, {212,0.00700000}, {213,0.00701802}, {214,0.00700901}, {215,0.00701802}, {216,0.00706306}, {217,0.00706306}, {218,0.00706306}, {219,0.00713514}, {220,0.00803604}, {221,0.00721622}, {222,0.00727027}, {223,0.00734234}, {224,0.00738739}, {225,0.00751351}, {226,0.00755856}, {227,0.00758559}, {228,0.00769369}, {229,0.00773874}, {230,0.00858559}, {231,0.00783784}, {232,0.00785586}, {233,0.00783784}, {234,0.00786486}, {235,0.00790991}, {236,0.00793694}, {237,0.00796396}, {238,0.00800901}, {239,0.00898198}, {240,0.00798198}, {241,0.00799099}, {242,0.00798198}, {243,0.00800000}, {244,0.00798198}, {245,0.00800901}, {246,0.00801802}, {247,0.00805405}, {248,0.00881982}, {249,0.00809910}, {250,0.00815315}, {251,0.00822523}, {252,0.00818018}, {253,0.00822523}, {254,0.00828829}, {255,0.00835135}, {256,0.00962162}, {257,0.00850450}, {258,0.00858559}, {259,0.00867568}, {260,0.00871171}, {261,0.00872973}, {262,0.00876577}, {263,0.00880180}, {264,0.01073874}, {265,0.00883784}, {266,0.00886486}, {267,0.00895495}, {268,0.00894595}, {269,0.00895495}, {270,0.00896396}, {271,0.00899099}, {272,0.01180180}, {273,0.00900000}, {274,0.00900000}, {275,0.00902703}, {276,0.00900901}, {277,0.00901802}, {278,0.00900000}, {279,0.00900000}, {280,0.01149550}, {281,0.00909009}, {282,0.00908108}, {283,0.00912613}, {284,0.00916216}, {285,0.00925225}, {286,0.00932432}, {287,0.00936036}, {288,0.01025225}, {289,0.00946847}, {290,0.00955856}, {291,0.00963063}, {292,0.00965766}, {293,0.00970270}, {294,0.00972973}, {295,0.01109910}, {296,0.00981081}, {297,0.00980180}, {298,0.00981982}, {299,0.00987387}, {300,0.00992793}, {301,0.00993694}, {302,0.01193694}, {303,0.00995495}, {304,0.00994595}, {305,0.00996396}, {306,0.00998198}, {307,0.01001802}, {308,0.00997297}, {309,0.01447748}, {310,0.01003604}, {311,0.01005405}, {312,0.01005405}, {313,0.01007207}, {314,0.01014414}, {315,0.01018919}, {316,0.01266667}, {317,0.01023423}, {318,0.01036937}, {319,0.01035135}, {320,0.01042342}, {321,0.01046847}, {322,0.01055856}, {323,0.01304505}, {324,0.01065766}, {325,0.01068468}, {326,0.01072973}, {327,0.01076577}, {328,0.01077477}, {329,0.01087387}, {330,0.01174775}, {331,0.01086486}, {332,0.01085586}, {333,0.01087387}, {334,0.01093694}, {335,0.01096396}, {336,0.01269369}, {337,0.01095495}, {338,0.01098198}, {339,0.01100901}, {340,0.01100000}, {341,0.01102703}, {342,0.01109910}, {343,0.01381982}, {344,0.01108108}, {345,0.01110811}, {346,0.01112613}, {347,0.01121622}, {348,0.01124324}, {349,0.01285586}, {350,0.01136036}, {351,0.01142342}, {352,0.01146847}, {353,0.01149550}, {354,0.01149550}, {355,0.01295495}, {356,0.01167568}, {357,0.01165766}, {358,0.01168468}, {359,0.01172973}, {360,0.01173874}, {361,0.01362162}, {362,0.01180180}, {363,0.01181982}, {364,0.01181081}, {365,0.01188288}, {366,0.01189189}, {367,0.01563063}, {368,0.01190991}, {369,0.01190090}, {370,0.01190991}, {371,0.01200901}, {372,0.01196396}, {373,0.01555856}, {374,0.01199099}, {375,0.01204505}, {376,0.01209910}, {377,0.01209910}, {378,0.01216216}, {379,0.01365766}, {380,0.01223423}, {381,0.01230631}, {382,0.01234234}, {383,0.01233333}, {384,0.01250450}, {385,0.01345946}, {386,0.01258559}, {387,0.01259459}, {388,0.01260360}, {389,0.01270270}, {390,0.01460360}, {391,0.01272072}, {392,0.01274775}, {393,0.01273874}, {394,0.01276577}, {395,0.01283784}, {396,0.01416216}, {397,0.01286486}, {398,0.01286486}, {399,0.01289189}, {400,0.01290991}, {401,0.01432432}, {402,0.01291892}, {403,0.01294595}, {404,0.01295495}, {405,0.01297297}, {406,0.01298198}, {407,0.01467568}, {408,0.01305405}, {409,0.01304505}, {410,0.01310811}, {411,0.01319820}, {412,0.01541441}, {413,0.01327928}, {414,0.01335135}, {415,0.01339091}, {416,0.01343636}, {417,0.01355455}, {418,0.01603636}, {419,0.01359091}, {420,0.01357273}, {421,0.01365455}, {422,0.01373636}, {423,0.01498182}, {424,0.01375455}, {425,0.01380000}, {426,0.01379091}, {427,0.01378182}, {428,0.01512727}, {429,0.01383636}, {430,0.01381818}, {431,0.01385455}, {432,0.01390909}, {433,0.01564545}, {434,0.01390000}, {435,0.01396364}, {436,0.01395455}, {437,0.01400000}, {438,0.01576364}, {439,0.01412727}, {440,0.01407273}, {441,0.01412727}, {442,0.01415455}, {443,0.01589091}, {444,0.01430909}, {445,0.01433636}, {446,0.01434545}, {447,0.01432727}, {448,0.01591818}, {449,0.01443636}, {450,0.01455455}, {451,0.01462727}, {452,0.01466364}, {453,0.01599091}, {454,0.01472727}, {455,0.01470000}, {456,0.01473636}, {457,0.01472727}, {458,0.01612727}, {459,0.01480000}, {460,0.01478182}, {461,0.01482727}, {462,0.01490909}, {463,0.01586364}, {464,0.01485455}, {465,0.01485455}, {466,0.01487273}, {467,0.01670000}, {468,0.01497273}, {469,0.01495455}, {470,0.01500000}, {471,0.01501818}, {472,0.01685455}, {473,0.01506364}, {474,0.01510000}, {475,0.01518182}, {476,0.01519091}, {477,0.01672727}, {478,0.01529091}, {479,0.01530909}, {480,0.01533636}, {481,0.01646364}, {482,0.01547273}, {483,0.01553636}, {484,0.01552727}, {485,0.01555455}, {486,0.01708182}, {487,0.01570000}, {488,0.01569091}, {489,0.01572727}, {490,0.01578182}, {491,0.01575455}, {492,0.01576364}, {493,0.01577273}, {494,0.01577273}, {495,0.01751818}, {496,0.01579091}, {497,0.01581818}, {498,0.01585455}, {499,0.01766364}, {500,0.01583636}, {505,0.01601818}, {510,0.01630909}, {515,0.01655455}, {520,0.01817273}, {525,0.01678182}, {530,0.01689091}, {535,0.01703636}, {540,0.01890000}, {545,0.01747273}, {550,0.01766364}, {555,0.01771818}, {560,0.01970000}, {565,0.01798182}, {570,0.01803636}, {575,0.01830000}, {580,0.02017273}, {585,0.01871818}, {590,0.01877273}, {595,0.01882727}, {600,0.02072727}, {605,0.01916364}, {610,0.01946364}, {615,0.02094545}, {620,0.01973636}, {625,0.01978182}, {630,0.01985455}, {635,0.02202727}, {640,0.02027273}, {645,0.02054545}, {650,0.02229091}, {655,0.02074545}, {660,0.02083636}, {665,0.02100909}, {670,0.02323636}, {675,0.02147273}, {680,0.02161818}, {685,0.02389091}, {690,0.02179091}, {695,0.02186364}, {700,0.02370000}, {705,0.02232727}, {710,0.02249091}, {715,0.02277273}, {720,0.02336364}, {725,0.02289091}, {730,0.02307273}, {735,0.02483636}, {740,0.02340000}, {745,0.02363636}, {750,0.02518182}, {755,0.02380909}, {760,0.02401818}, {765,0.02572727}, {770,0.02436364}, {775,0.02461818}, {780,0.02580000}, {785,0.02476364}, {790,0.02680909}, {795,0.02502727}, {800,0.02517273}, {805,0.02881818}, {810,0.02560000}, {815,0.02574545}, {820,0.03260909}, {825,0.02590909}, {830,0.02610000}, {835,0.02842727}, {840,0.02647273}, {845,0.02841818}, {850,0.02675455}, {855,0.02693636}, {860,0.02964545}, {865,0.02724545}, {870,0.02739091}, {875,0.02885455}, {880,0.02770000}, {885,0.03103636}, {890,0.02794545}, {895,0.02816364}, {900,0.03054545}, {905,0.02849091}, {910,0.03180909}, {915,0.02876364}, {920,0.02891818}, {925,0.03610909}, {930,0.02925455}, {935,0.03221818}, {940,0.02955455}, {945,0.02990000}, {950,0.02961818}, {955,0.02998182}, {960,0.03262727}, {965,0.03024545}, {970,0.03374545}, {975,0.03062727}, {980,0.03077273}, {985,0.03727273}, {990,0.03114545}, {995,0.03384545}, {1000,0.03139091}, {1010,0.03459091}, {1020,0.03207273}, {1030,0.03899091}, {1040,0.03264545}, {1050,0.03881818}, {1060,0.03324545}, {1070,0.03367273}, {1080,0.03530000}, {1090,0.03431818}, {1100,0.03748182}, {1110,0.03478182}, {1120,0.03769091}, {1130,0.03547273}, {1140,0.03843636}, {1150,0.03619091}, {1160,0.03909091}, {1170,0.03680909}, {1180,0.03828182}, {1190,0.03747273}, {1200,0.03864545}, {1210,0.04158182}, {1220,0.03828182}, {1230,0.04660909}, {1240,0.03884545}, {1250,0.04634545}, {1260,0.03964545}, {1270,0.04390909}, {1280,0.04022727}, {1290,0.04365455}, {1300,0.04392727}, {1310,0.04124545}, {1320,0.04551818}, {1330,0.04186364}, {1340,0.04530909}, {1350,0.04254545}, {1360,0.04360909}, {1370,0.05003636}, {1380,0.04338182}, {1390,0.05368182}, {1400,0.04420909}, {1410,0.04462727}, {1420,0.04888182}, {1430,0.04508182}, {1440,0.04841818}, {1450,0.05439091}, {1460,0.04604545}, {1470,0.05392727}, {1480,0.05000909}, {1490,0.04694545}, {1500,0.05136364}, {1510,0.05124545}, {1520,0.04790000}, {1530,0.05230909}, {1540,0.05153636}, {1550,0.04898182}, {1560,0.05294545}, {1570,0.06146364}, {1580,0.04993636}, {1590,0.06000909}, {1600,0.05780909}, {1610,0.05085455}, {1620,0.05742727}, {1630,0.06038182}, {1640,0.05546364}, {1650,0.05218182}, {1660,0.05696364}, {1670,0.05793636}, {1680,0.05341818}, {1690,0.05355455}, {1700,0.05830000}, {1710,0.05944545}, {1720,0.05450909}, {1730,0.05587273}, {1740,0.05996364}, {1750,0.06846364}, {1760,0.06110000}, {1770,0.05625455}, {1780,0.06111818}, {1790,0.06197273}, {1800,0.06826364}, {1810,0.05754545}, {1820,0.06567273}, {1830,0.06316364}, {1840,0.06419091}, {1850,0.06940000}, {1860,0.05933636}, {1870,0.05942727}, {1880,0.06539091}, {1890,0.06548182}, {1900,0.06622727}, {1910,0.07720000}, {1920,0.06170909}, {1930,0.06543636}, {1940,0.06698182}, {1950,0.06746364}, {1960,0.06818182}, {1970,0.06908182}, {1980,0.08288182}, {1990,0.06404545}, {2000,0.06356364}, {2050,0.06780000}, {2100,0.07273636}, {2150,0.07481818}, {2200,0.07676364}, {2250,0.07833636}, {2300,0.08053636}, {2350,0.08252727}, {2400,0.08432727}, {2450,0.08604545}, {2500,0.08751818}, {2550,0.08638182}, {2600,0.09015455}, {2650,0.10546364}, {2700,0.10420000}, {2750,0.09781818}, {2800,0.09920000}, {2850,0.10176364}, {2900,0.10568182}, {2950,0.12270909}, {3000,0.10650000}, {3050,0.12166364}, {3100,0.12082727}, {3150,0.11190909}, {3200,0.11642727}, {3250,0.11658182}, {3300,0.14030909}, {3350,0.12696364}, {3400,0.14328182}, {3450,0.12486364}, {3500,0.14524545}, {3550,0.13087273}, {3600,0.14272727}, {3650,0.13930000}, {3700,0.13200000}, {3750,0.13508182}, {3800,0.14000909}, {3850,0.14712727}, {3900,0.14339091}, {3950,0.14697273}, {4000,0.14632727}, {4050,0.15103636}, {4100,0.17162727}, {4150,0.15500000}, {4200,0.15649091}, {4250,0.15629091}, {4300,0.15697273}, {4350,0.16150909}, {4400,0.19595455}, {4450,0.19720909}, {4500,0.19761818}, {4550,0.19875455}, {4600,0.19870000}, {4650,0.19868182}, {4700,0.19826364}, {4750,0.19890909}, {4800,0.19843636}, {4850,0.20251818}, {4900,0.18062727}, {4950,0.19615455}, {5000,0.18852727}, {5050,0.22019091}, {5100,0.20044545}, {5150,0.21250000}, {5200,0.20754545}, {5250,0.23233636}, {5300,0.20132727}, {5350,0.22954545}, {5400,0.20963636}, {5450,0.20572727}, {5500,0.24399091}, {5550,0.22953636}, {5600,0.22317273}, {5650,0.24430909}, {5700,0.21755455}, {5750,0.24849091}, {5800,0.22804545}, {5850,0.26309091}, {5900,0.22812727}, {5950,0.23617273}, {6000,0.25472727}, {6050,0.23544545}, {6100,0.27113636}, {6150,0.24989091}, {6200,0.23698182}, {6250,0.26125455}, {6300,0.25229091}, {6350,0.24911818}, {6400,0.24541818}, {6450,0.26193636}, {6500,0.31973636}, {6550,0.25548182}, {6600,0.25931818}, {6650,0.26105455}, {6700,0.25811818}, {6750,0.26060000}, {6800,0.25920000}, {6850,0.26372727}, {6900,0.26551818}, {6950,0.26795455}, {7000,0.27055455}, {7050,0.27150909}, {7100,0.27189091}, {7150,0.27885455}, {7200,0.26108182}, {7250,0.31844545}, {7300,0.31289091}, {7350,0.33320000}, {7400,0.33170909}, {7450,0.28463636}, {7500,0.32646364}, {7550,0.32113636}, {7600,0.33977273}, {7650,0.34436364}, {7700,0.31446364}, {7750,0.34412727}, {7800,0.34114545}, {7850,0.33144545}, {7900,0.31922727}, {7950,0.32053636}, {8000,0.33684545}, {8050,0.32547273}, {8100,0.33270909}, {8150,0.32523636}, {8200,0.41017273}, {8250,0.31922727}, {8300,0.35697273}, {8350,0.35869091}, {8400,0.33556364}, {8450,0.41627273}, {8500,0.36152727}, {8550,0.40308182}, {8600,0.38720000}, {8650,0.40577273}, {8700,0.36284545}, {8750,0.34784545}, {8800,0.35636364}, {8850,0.41530909}, {8900,0.41627273}, {8950,0.43180000}, {9000,0.36624545}, {9050,0.34555455}, {9100,0.35294545}, {9150,0.35813636}, {9200,0.35854545}, {9250,0.35887273}, {9300,0.35459091}, {9350,0.33912727}, {9400,0.37592727}, {9450,0.44004545}, {9500,0.43380000}, {9550,0.41456364}, {9600,0.41311818}, {9650,0.38110000}, {9700,0.36865455}, {9750,0.44204545}, {9800,0.41466364}, {9850,0.38456364}, {9900,0.39750909}, {9950,0.44824545}, {10000,0.43426364}, {10100,0.47556364}, {10200,0.43569091}, {10300,0.39913636}, {10400,0.46184545}, {10500,0.42584545}, {10600,0.51622727}, {10700,0.46612727}, {10800,0.43423636}, {10900,0.53662727}, {11000,0.46390000}, {11100,0.48814545}, {11200,0.51788182}, {11300,0.46057273}, {11400,0.47193636}, {11500,0.47773636}, {11600,0.50193636}, {11700,0.55136364}, {11800,0.53152727}, {11900,0.52762727}, {12000,0.55485455}, {12100,0.54690909}, {12200,0.58037273}, {12300,0.51383636}, {12400,0.55082727}, {12500,0.59035455}, {12600,0.59895455}, {12700,0.59360000}, {12800,0.59505455}, {12900,0.58995455}, {13000,0.53404545}, {13100,0.59620909}, {13200,0.63660909}, {13300,0.59390909}, {13400,0.55632727}, {13500,0.59399091}, {13600,0.63263636}, {13700,0.65022727}, {13800,0.66571818}, {13900,0.67290000}, {14000,0.66434545}, {14100,0.63539091}, {14200,0.56984545}, {14300,0.99103636}, {14400,0.67224545}, {14500,0.69075455}, {14600,0.66160909}, {14700,0.68228182}, {14800,0.69735455}, {14900,0.69223636}, {15000,0.66962727}, {15100,0.69210000}, {15200,0.72802727}, {15300,0.70598182}, {15400,0.74120909}, {15500,0.73303636}, {15600,0.68984545}, {15700,0.72137273}, {15800,0.75941818}, {15900,0.77643636}, {16000,0.79379091}, {16100,0.78894545}, {16200,0.78648182}, {16300,0.79555455}, {16400,0.80292727}, {16500,0.78517273}, {16600,0.73974545}, {16700,0.74428182}, {16800,0.80032727}, {16900,0.80466364}, {17000,0.77961818}, {17100,0.82683636}, {17200,0.82749091}, {17300,0.81122727}, {17400,0.81662727}, {17500,0.81520000}, {17600,0.81922727}, {17700,0.85806364}, {17800,0.83410909}, {17900,0.83913636}, {18000,0.87154545}, {18100,0.87735455}, {18200,0.89735455}, {18300,0.85670000}, {18400,0.85138182}, {18500,0.85771818}, {18600,0.89678182}, {18700,0.87470000}, {18800,0.94181818}, {18900,0.92339091}, {19000,0.88050000}, {19100,0.89426364}, {19200,0.93130000}, {19300,0.91659091}, {19400,0.89858182}, {19500,0.95802727}, {19600,0.89770000}, {19700,0.97513636}, {19800,0.91940909}, {19900,0.91473636}, {20000,0.95550000}};
data["big_flat"]["TemplateCoq"]["Aggregate"]["user"] = {{1,0.00017117}, {2,0.00063964}, {3,0.00072072}, {4,0.00090090}, {5,0.00104505}, {6,0.00094595}, {7,0.00072072}, {8,0.00098198}, {9,0.00122523}, {10,0.00112613}, {11,0.00119820}, {12,0.00094595}, {13,0.00124324}, {14,0.00141441}, {15,0.00109910}, {16,0.00133333}, {17,0.00122523}, {18,0.00142342}, {19,0.00121622}, {20,0.00146847}, {21,0.00131532}, {22,0.00159459}, {23,0.00125225}, {24,0.00148649}, {25,0.00134234}, {26,0.00151351}, {27,0.00138739}, {28,0.00184685}, {29,0.00166667}, {30,0.00168468}, {31,0.00150450}, {32,0.00192793}, {33,0.00151351}, {34,0.00190090}, {35,0.00165766}, {36,0.00171171}, {37,0.00212613}, {38,0.00159459}, {39,0.00208108}, {40,0.00208108}, {41,0.00175676}, {42,0.00218018}, {43,0.00204505}, {44,0.00178378}, {45,0.00212613}, {46,0.00198198}, {47,0.00201802}, {48,0.00231532}, {49,0.00209009}, {50,0.00214414}, {51,0.00236937}, {52,0.00237838}, {53,0.00223423}, {54,0.00233333}, {55,0.00255856}, {56,0.00230631}, {57,0.00229730}, {58,0.00232432}, {59,0.00250450}, {60,0.00278378}, {61,0.00239640}, {62,0.00231532}, {63,0.00259459}, {64,0.00254054}, {65,0.00267568}, {66,0.00273874}, {67,0.00278378}, {68,0.00273874}, {69,0.00268468}, {70,0.00290090}, {71,0.00256757}, {72,0.00262162}, {73,0.00282883}, {74,0.00296396}, {75,0.00294595}, {76,0.00293694}, {77,0.00303604}, {78,0.00309910}, {79,0.00315315}, {80,0.00304505}, {81,0.00324324}, {82,0.00314414}, {83,0.00312613}, {84,0.00301802}, {85,0.00325225}, {86,0.00313514}, {87,0.00315315}, {88,0.00420721}, {89,0.00316216}, {90,0.00331532}, {91,0.00329730}, {92,0.00347748}, {93,0.00339640}, {94,0.00336937}, {95,0.00341441}, {96,0.00328829}, {97,0.00356757}, {98,0.00345946}, {99,0.00349550}, {100,0.00357658}, {101,0.00362162}, {102,0.00362162}, {103,0.00372072}, {104,0.00367568}, {105,0.00361261}, {106,0.00359459}, {107,0.00381982}, {108,0.00481982}, {109,0.00387387}, {110,0.00361261}, {111,0.00391892}, {112,0.00386486}, {113,0.00382883}, {114,0.00385586}, {115,0.00390991}, {116,0.00400901}, {117,0.00390090}, {118,0.00396396}, {119,0.00408108}, {120,0.00407207}, {121,0.00440541}, {122,0.00412613}, {123,0.00411712}, {124,0.00428829}, {125,0.00497297}, {126,0.00421622}, {127,0.00455856}, {128,0.00418919}, {129,0.00409009}, {130,0.00485586}, {131,0.00416216}, {132,0.00454955}, {133,0.00462162}, {134,0.00427928}, {135,0.00481081}, {136,0.00451351}, {137,0.00448649}, {138,0.00477477}, {139,0.00453153}, {140,0.00569369}, {141,0.00476577}, {142,0.00484685}, {143,0.00481081}, {144,0.00498198}, {145,0.00492793}, {146,0.00479279}, {147,0.00504505}, {148,0.00484685}, {149,0.00524324}, {150,0.00488288}, {151,0.00512613}, {152,0.00506306}, {153,0.00512613}, {154,0.00554054}, {155,0.00524324}, {156,0.00524324}, {157,0.00528829}, {158,0.00528829}, {159,0.00537838}, {160,0.00536036}, {161,0.00528829}, {162,0.00526126}, {163,0.00537838}, {164,0.00562162}, {165,0.00528829}, {166,0.00610811}, {167,0.00542342}, {168,0.00527027}, {169,0.00543243}, {170,0.00572072}, {171,0.00549550}, {172,0.00586486}, {173,0.00581081}, {174,0.00551351}, {175,0.00573874}, {176,0.00595495}, {177,0.00576577}, {178,0.00674775}, {179,0.00554955}, {180,0.00571171}, {181,0.00624324}, {182,0.00598198}, {183,0.00574775}, {184,0.00550450}, {185,0.00584685}, {186,0.00650450}, {187,0.00616216}, {188,0.00612613}, {189,0.00604505}, {190,0.00688288}, {191,0.00630631}, {192,0.00604505}, {193,0.00606306}, {194,0.00641441}, {195,0.00640541}, {196,0.00623423}, {197,0.00654054}, {198,0.00651351}, {199,0.00647748}, {200,0.00732432}, {201,0.00646847}, {202,0.00658559}, {203,0.00659459}, {204,0.00651351}, {205,0.00637838}, {206,0.00644144}, {207,0.00636036}, {208,0.00645946}, {209,0.00645946}, {210,0.00655856}, {211,0.00710811}, {212,0.00682883}, {213,0.00697297}, {214,0.00690991}, {215,0.00681982}, {216,0.00697297}, {217,0.00707207}, {218,0.00695495}, {219,0.00691892}, {220,0.00800000}, {221,0.00693694}, {222,0.00697297}, {223,0.00702703}, {224,0.00719820}, {225,0.00720721}, {226,0.00722523}, {227,0.00730631}, {228,0.00745946}, {229,0.00720721}, {230,0.00860360}, {231,0.00735135}, {232,0.00761261}, {233,0.00731532}, {234,0.00768468}, {235,0.00754054}, {236,0.00770270}, {237,0.00759459}, {238,0.00772973}, {239,0.00859459}, {240,0.00748649}, {241,0.00792793}, {242,0.00758559}, {243,0.00773874}, {244,0.00786486}, {245,0.00767568}, {246,0.00804505}, {247,0.00790991}, {248,0.00862162}, {249,0.00805405}, {250,0.00794595}, {251,0.00836937}, {252,0.00823423}, {253,0.00836937}, {254,0.00837838}, {255,0.00805405}, {256,0.00970270}, {257,0.00848649}, {258,0.00840541}, {259,0.00832432}, {260,0.00833333}, {261,0.00846847}, {262,0.00809910}, {263,0.00853153}, {264,0.01083784}, {265,0.00875676}, {266,0.00853153}, {267,0.00884685}, {268,0.00855856}, {269,0.00914414}, {270,0.00873874}, {271,0.00926126}, {272,0.01179279}, {273,0.00896396}, {274,0.00898198}, {275,0.00900000}, {276,0.00918018}, {277,0.00889189}, {278,0.00910811}, {279,0.00894595}, {280,0.01162162}, {281,0.00924324}, {282,0.00903604}, {283,0.00925225}, {284,0.00941441}, {285,0.00920721}, {286,0.00986486}, {287,0.00955856}, {288,0.00997297}, {289,0.00923423}, {290,0.00982883}, {291,0.00937838}, {292,0.00974775}, {293,0.00962162}, {294,0.00928829}, {295,0.01138739}, {296,0.00986486}, {297,0.00972072}, {298,0.00962162}, {299,0.00981081}, {300,0.00994595}, {301,0.00984685}, {302,0.01216216}, {303,0.00988288}, {304,0.01023423}, {305,0.01001802}, {306,0.01013514}, {307,0.01006306}, {308,0.00996396}, {309,0.01460360}, {310,0.01074775}, {311,0.01016216}, {312,0.00986486}, {313,0.01007207}, {314,0.01037838}, {315,0.01032432}, {316,0.01311712}, {317,0.01063063}, {318,0.01055856}, {319,0.01029730}, {320,0.01013514}, {321,0.01061261}, {322,0.01072973}, {323,0.01328829}, {324,0.01108108}, {325,0.01101802}, {326,0.01088288}, {327,0.01098198}, {328,0.01099099}, {329,0.01072072}, {330,0.01177477}, {331,0.01084685}, {332,0.01086486}, {333,0.01092793}, {334,0.01104505}, {335,0.01106306}, {336,0.01290090}, {337,0.01108108}, {338,0.01126126}, {339,0.01129730}, {340,0.01135135}, {341,0.01148649}, {342,0.01162162}, {343,0.01400000}, {344,0.01125225}, {345,0.01150450}, {346,0.01154054}, {347,0.01150450}, {348,0.01168468}, {349,0.01318919}, {350,0.01171171}, {351,0.01169369}, {352,0.01168468}, {353,0.01180180}, {354,0.01166667}, {355,0.01301802}, {356,0.01190991}, {357,0.01184685}, {358,0.01185586}, {359,0.01181081}, {360,0.01202703}, {361,0.01344144}, {362,0.01208108}, {363,0.01205405}, {364,0.01201802}, {365,0.01211712}, {366,0.01192793}, {367,0.01557658}, {368,0.01203604}, {369,0.01232432}, {370,0.01220721}, {371,0.01233333}, {372,0.01226126}, {373,0.01524324}, {374,0.01223423}, {375,0.01243243}, {376,0.01235135}, {377,0.01253153}, {378,0.01263964}, {379,0.01336937}, {380,0.01270270}, {381,0.01234234}, {382,0.01254054}, {383,0.01263964}, {384,0.01254054}, {385,0.01340541}, {386,0.01300000}, {387,0.01282883}, {388,0.01254054}, {389,0.01287387}, {390,0.01443243}, {391,0.01262162}, {392,0.01307207}, {393,0.01291892}, {394,0.01298198}, {395,0.01305405}, {396,0.01450450}, {397,0.01302703}, {398,0.01300000}, {399,0.01319820}, {400,0.01310811}, {401,0.01439640}, {402,0.01281081}, {403,0.01311712}, {404,0.01344144}, {405,0.01300000}, {406,0.01332432}, {407,0.01475676}, {408,0.01323423}, {409,0.01335135}, {410,0.01354054}, {411,0.01324324}, {412,0.01529730}, {413,0.01330631}, {414,0.01380180}, {415,0.01352727}, {416,0.01346364}, {417,0.01355455}, {418,0.01612727}, {419,0.01320000}, {420,0.01360000}, {421,0.01369091}, {422,0.01350000}, {423,0.01469091}, {424,0.01380909}, {425,0.01401818}, {426,0.01363636}, {427,0.01377273}, {428,0.01495455}, {429,0.01380000}, {430,0.01410909}, {431,0.01384545}, {432,0.01418182}, {433,0.01552727}, {434,0.01418182}, {435,0.01398182}, {436,0.01416364}, {437,0.01413636}, {438,0.01545455}, {439,0.01399091}, {440,0.01421818}, {441,0.01432727}, {442,0.01441818}, {443,0.01565455}, {444,0.01417273}, {445,0.01438182}, {446,0.01444545}, {447,0.01413636}, {448,0.01595455}, {449,0.01463636}, {450,0.01430909}, {451,0.01450909}, {452,0.01434545}, {453,0.01589091}, {454,0.01456364}, {455,0.01446364}, {456,0.01450909}, {457,0.01470909}, {458,0.01618182}, {459,0.01469091}, {460,0.01487273}, {461,0.01488182}, {462,0.01520000}, {463,0.01550909}, {464,0.01492727}, {465,0.01506364}, {466,0.01495455}, {467,0.01629091}, {468,0.01478182}, {469,0.01497273}, {470,0.01511818}, {471,0.01509091}, {472,0.01686364}, {473,0.01504545}, {474,0.01493636}, {475,0.01536364}, {476,0.01508182}, {477,0.01622727}, {478,0.01510909}, {479,0.01528182}, {480,0.01508182}, {481,0.01611818}, {482,0.01520000}, {483,0.01512727}, {484,0.01529091}, {485,0.01545455}, {486,0.01688182}, {487,0.01561818}, {488,0.01561818}, {489,0.01572727}, {490,0.01561818}, {491,0.01564545}, {492,0.01543636}, {493,0.01577273}, {494,0.01565455}, {495,0.01720000}, {496,0.01584545}, {497,0.01580909}, {498,0.01576364}, {499,0.01728182}, {500,0.01597273}, {505,0.01618182}, {510,0.01597273}, {515,0.01620000}, {520,0.01775455}, {525,0.01650000}, {530,0.01680000}, {535,0.01658182}, {540,0.01837273}, {545,0.01750000}, {550,0.01739091}, {555,0.01697273}, {560,0.01920000}, {565,0.01793636}, {570,0.01756364}, {575,0.01768182}, {580,0.01984545}, {585,0.01828182}, {590,0.01850909}, {595,0.01869091}, {600,0.02023636}, {605,0.01881818}, {610,0.01881818}, {615,0.02055455}, {620,0.01920000}, {625,0.01942727}, {630,0.01967273}, {635,0.02200000}, {640,0.01963636}, {645,0.02035455}, {650,0.02234545}, {655,0.02051818}, {660,0.02113636}, {665,0.02082727}, {670,0.02352727}, {675,0.02115455}, {680,0.02165455}, {685,0.02397273}, {690,0.02186364}, {695,0.02164545}, {700,0.02350909}, {705,0.02222727}, {710,0.02245455}, {715,0.02280000}, {720,0.02347273}, {725,0.02286364}, {730,0.02300909}, {735,0.02507273}, {740,0.02326364}, {745,0.02350909}, {750,0.02493636}, {755,0.02404545}, {760,0.02388182}, {765,0.02602727}, {770,0.02420909}, {775,0.02448182}, {780,0.02577273}, {785,0.02500909}, {790,0.02648182}, {795,0.02517273}, {800,0.02510000}, {805,0.02880000}, {810,0.02535455}, {815,0.02553636}, {820,0.03263636}, {825,0.02567273}, {830,0.02608182}, {835,0.02814545}, {840,0.02634545}, {845,0.02810909}, {850,0.02650000}, {855,0.02691818}, {860,0.02959091}, {865,0.02680000}, {870,0.02711818}, {875,0.02892727}, {880,0.02752727}, {885,0.03124545}, {890,0.02789091}, {895,0.02830909}, {900,0.03078182}, {905,0.02852727}, {910,0.03200000}, {915,0.02890000}, {920,0.02911818}, {925,0.03574545}, {930,0.02948182}, {935,0.03285455}, {940,0.02968182}, {945,0.03000000}, {950,0.02956364}, {955,0.02997273}, {960,0.03248182}, {965,0.03038182}, {970,0.03374545}, {975,0.03079091}, {980,0.03097273}, {985,0.03744545}, {990,0.03164545}, {995,0.03380000}, {1000,0.03167273}, {1010,0.03486364}, {1020,0.03226364}, {1030,0.03866364}, {1040,0.03307273}, {1050,0.03858182}, {1060,0.03352727}, {1070,0.03373636}, {1080,0.03536364}, {1090,0.03419091}, {1100,0.03712727}, {1110,0.03483636}, {1120,0.03770000}, {1130,0.03556364}, {1140,0.03820000}, {1150,0.03606364}, {1160,0.03860909}, {1170,0.03679091}, {1180,0.03807273}, {1190,0.03739091}, {1200,0.03850909}, {1210,0.04147273}, {1220,0.03830000}, {1230,0.04634545}, {1240,0.03870000}, {1250,0.04591818}, {1260,0.03956364}, {1270,0.04405455}, {1280,0.03977273}, {1290,0.04363636}, {1300,0.04419091}, {1310,0.04081818}, {1320,0.04562727}, {1330,0.04145455}, {1340,0.04529091}, {1350,0.04274545}, {1360,0.04375455}, {1370,0.04964545}, {1380,0.04352727}, {1390,0.05323636}, {1400,0.04412727}, {1410,0.04470000}, {1420,0.04852727}, {1430,0.04531818}, {1440,0.04812727}, {1450,0.05400909}, {1460,0.04598182}, {1470,0.05354545}, {1480,0.04938182}, {1490,0.04663636}, {1500,0.05082727}, {1510,0.05089091}, {1520,0.04795455}, {1530,0.05164545}, {1540,0.05091818}, {1550,0.04870000}, {1560,0.05220000}, {1570,0.06136364}, {1580,0.04951818}, {1590,0.05984545}, {1600,0.05746364}, {1610,0.05043636}, {1620,0.05747273}, {1630,0.06020909}, {1640,0.05544545}, {1650,0.05151818}, {1660,0.05646364}, {1670,0.05764545}, {1680,0.05318182}, {1690,0.05350909}, {1700,0.05767273}, {1710,0.05885455}, {1720,0.05426364}, {1730,0.05591818}, {1740,0.05979091}, {1750,0.06629091}, {1760,0.06068182}, {1770,0.05609091}, {1780,0.06094545}, {1790,0.06189091}, {1800,0.06760000}, {1810,0.05765455}, {1820,0.06540000}, {1830,0.06290000}, {1840,0.06412727}, {1850,0.06922727}, {1860,0.05943636}, {1870,0.05911818}, {1880,0.06539091}, {1890,0.06540000}, {1900,0.06614545}, {1910,0.07661818}, {1920,0.06179091}, {1930,0.06530909}, {1940,0.06680909}, {1950,0.06748182}, {1960,0.06825455}, {1970,0.06889091}, {1980,0.08238182}, {1990,0.06440000}, {2000,0.06359091}, {2050,0.06757273}, {2100,0.07257273}, {2150,0.07480000}, {2200,0.07668182}, {2250,0.07830000}, {2300,0.08027273}, {2350,0.08207273}, {2400,0.08398182}, {2450,0.08572727}, {2500,0.08694545}, {2550,0.08595455}, {2600,0.08968182}, {2650,0.10478182}, {2700,0.10364545}, {2750,0.09775455}, {2800,0.09901818}, {2850,0.10133636}, {2900,0.10570909}, {2950,0.12222727}, {3000,0.10614545}, {3050,0.12079091}, {3100,0.12019091}, {3150,0.11127273}, {3200,0.11599091}, {3250,0.11625455}, {3300,0.13904545}, {3350,0.12629091}, {3400,0.14247273}, {3450,0.12440000}, {3500,0.14435455}, {3550,0.13041818}, {3600,0.14155455}, {3650,0.13861818}, {3700,0.13195455}, {3750,0.13480000}, {3800,0.13977273}, {3850,0.14678182}, {3900,0.14284545}, {3950,0.14640000}, {4000,0.14594545}, {4050,0.15025455}, {4100,0.17080909}, {4150,0.15431818}, {4200,0.15594545}, {4250,0.15571818}, {4300,0.15629091}, {4350,0.16112727}, {4400,0.19467273}, {4450,0.19618182}, {4500,0.19703636}, {4550,0.19798182}, {4600,0.19770000}, {4650,0.19779091}, {4700,0.19748182}, {4750,0.19762727}, {4800,0.19779091}, {4850,0.20141818}, {4900,0.18026364}, {4950,0.19544545}, {5000,0.18782727}, {5050,0.21902727}, {5100,0.19959091}, {5150,0.21110909}, {5200,0.20664545}, {5250,0.23060909}, {5300,0.20074545}, {5350,0.22840909}, {5400,0.20902727}, {5450,0.20544545}, {5500,0.24256364}, {5550,0.22904545}, {5600,0.22273636}, {5650,0.24390909}, {5700,0.21728182}, {5750,0.24854545}, {5800,0.22807273}, {5850,0.26297273}, {5900,0.22812727}, {5950,0.23618182}, {6000,0.25448182}, {6050,0.23519091}, {6100,0.27031818}, {6150,0.24929091}, {6200,0.23649091}, {6250,0.26038182}, {6300,0.25076364}, {6350,0.24890909}, {6400,0.24443636}, {6450,0.26098182}, {6500,0.31775455}, {6550,0.25410909}, {6600,0.25829091}, {6650,0.26024545}, {6700,0.25745455}, {6750,0.25960000}, {6800,0.25878182}, {6850,0.26285455}, {6900,0.26491818}, {6950,0.26716364}, {7000,0.27002727}, {7050,0.27107273}, {7100,0.27097273}, {7150,0.27812727}, {7200,0.26001818}, {7250,0.31641818}, {7300,0.31135455}, {7350,0.33149091}, {7400,0.32954545}, {7450,0.28370000}, {7500,0.32564545}, {7550,0.32088182}, {7600,0.33949091}, {7650,0.34377273}, {7700,0.31402727}, {7750,0.34381818}, {7800,0.34060000}, {7850,0.33097273}, {7900,0.31855455}, {7950,0.32024545}, {8000,0.33669091}, {8050,0.32547273}, {8100,0.33234545}, {8150,0.32513636}, {8200,0.41015455}, {8250,0.31915455}, {8300,0.35674545}, {8350,0.35867273}, {8400,0.33565455}, {8450,0.41613636}, {8500,0.36142727}, {8550,0.40283636}, {8600,0.38650909}, {8650,0.40539091}, {8700,0.36224545}, {8750,0.34725455}, {8800,0.35640909}, {8850,0.41508182}, {8900,0.41618182}, {8950,0.43157273}, {9000,0.36579091}, {9050,0.34532727}, {9100,0.35264545}, {9150,0.35783636}, {9200,0.35793636}, {9250,0.35856364}, {9300,0.35438182}, {9350,0.33906364}, {9400,0.37561818}, {9450,0.43967273}, {9500,0.43346364}, {9550,0.41445455}, {9600,0.41294545}, {9650,0.38121818}, {9700,0.36827273}, {9750,0.44183636}, {9800,0.41445455}, {9850,0.38385455}, {9900,0.39739091}, {9950,0.44819091}, {10000,0.43428182}, {10100,0.47540000}, {10200,0.43548182}, {10300,0.39904545}, {10400,0.46108182}, {10500,0.42574545}, {10600,0.51580909}, {10700,0.46591818}, {10800,0.43377273}, {10900,0.53660909}, {11000,0.46360000}, {11100,0.48827273}, {11200,0.51774545}, {11300,0.46059091}, {11400,0.47160000}, {11500,0.47726364}, {11600,0.50151818}, {11700,0.54886364}, {11800,0.52931818}, {11900,0.52631818}, {12000,0.55281818}, {12100,0.54528182}, {12200,0.57790909}, {12300,0.51249091}, {12400,0.54938182}, {12500,0.58987273}, {12600,0.59851818}, {12700,0.59278182}, {12800,0.59443636}, {12900,0.58970000}, {13000,0.53400000}, {13100,0.59560000}, {13200,0.63577273}, {13300,0.59227273}, {13400,0.55560909}, {13500,0.59286364}, {13600,0.63090909}, {13700,0.64853636}, {13800,0.66396364}, {13900,0.67212727}, {14000,0.66407273}, {14100,0.63460000}, {14200,0.56922727}, {14300,0.98936364}, {14400,0.67224545}, {14500,0.69062727}, {14600,0.66140000}, {14700,0.68198182}, {14800,0.69645455}, {14900,0.69153636}, {15000,0.66929091}, {15100,0.69210909}, {15200,0.72767273}, {15300,0.70564545}, {15400,0.74100000}, {15500,0.73315455}, {15600,0.68961818}, {15700,0.72120909}, {15800,0.75910909}, {15900,0.77610000}, {16000,0.79337273}, {16100,0.78813636}, {16200,0.78616364}, {16300,0.79505455}, {16400,0.80251818}, {16500,0.78494545}, {16600,0.74001818}, {16700,0.74394545}, {16800,0.79960000}, {16900,0.80453636}, {17000,0.77941818}, {17100,0.82658182}, {17200,0.82726364}, {17300,0.81085455}, {17400,0.81576364}, {17500,0.81467273}, {17600,0.81848182}, {17700,0.85729091}, {17800,0.83388182}, {17900,0.83869091}, {18000,0.87118182}, {18100,0.87711818}, {18200,0.89676364}, {18300,0.85594545}, {18400,0.85109091}, {18500,0.85744545}, {18600,0.89581818}, {18700,0.87445455}, {18800,0.94140909}, {18900,0.92306364}, {19000,0.88020000}, {19100,0.89423636}, {19200,0.93085455}, {19300,0.91630000}, {19400,0.89821818}, {19500,0.95778182}, {19600,0.89740909}, {19700,0.97494545}, {19800,0.91886364}, {19900,0.91432727}, {20000,0.95518519}};
data["big_flat"]["TemplateCoq"]["Aggregate"]["system"] = {{1,0.00063964}, {2,0.00038739}, {3,0.00032432}, {4,0.00003604}, {5,0.00006306}, {6,0.00014414}, {7,0.00007207}, {8,0.00009910}, {9,0.00002703}, {10,0.00003604}, {11,0.00007207}, {12,0.00007207}, {13,0.00000000}, {14,0.00009910}, {15,0.00003604}, {16,0.00003604}, {17,0.00000000}, {18,0.00003604}, {19,0.00006306}, {20,0.00002703}, {21,0.00000000}, {22,0.00003604}, {23,0.00007207}, {24,0.00009910}, {25,0.00000000}, {26,0.00003604}, {27,0.00000000}, {28,0.00007207}, {29,0.00003604}, {30,0.00000000}, {31,0.00007207}, {32,0.00003604}, {33,0.00006306}, {34,0.00003604}, {35,0.00000000}, {36,0.00000000}, {37,0.00003604}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003604}, {42,0.00010811}, {43,0.00003604}, {44,0.00000000}, {45,0.00007207}, {46,0.00000000}, {47,0.00003604}, {48,0.00007207}, {49,0.00000000}, {50,0.00000000}, {51,0.00007207}, {52,0.00000000}, {53,0.00000000}, {54,0.00007207}, {55,0.00000000}, {56,0.00003604}, {57,0.00000000}, {58,0.00000000}, {59,0.00007207}, {60,0.00000000}, {61,0.00003604}, {62,0.00007207}, {63,0.00000000}, {64,0.00009910}, {65,0.00003604}, {66,0.00006306}, {67,0.00002703}, {68,0.00007207}, {69,0.00000000}, {70,0.00003604}, {71,0.00007207}, {72,0.00003604}, {73,0.00000000}, {74,0.00000000}, {75,0.00007207}, {76,0.00000000}, {77,0.00003604}, {78,0.00003604}, {79,0.00000000}, {80,0.00010811}, {81,0.00003604}, {82,0.00002703}, {83,0.00003604}, {84,0.00014414}, {85,0.00000000}, {86,0.00007207}, {87,0.00003604}, {88,0.00006306}, {89,0.00010811}, {90,0.00003604}, {91,0.00000000}, {92,0.00003604}, {93,0.00000000}, {94,0.00003604}, {95,0.00006306}, {96,0.00003604}, {97,0.00000000}, {98,0.00000000}, {99,0.00007207}, {100,0.00003604}, {101,0.00002703}, {102,0.00003604}, {103,0.00000000}, {104,0.00014414}, {105,0.00007207}, {106,0.00009910}, {107,0.00003604}, {108,0.00000000}, {109,0.00000000}, {110,0.00021622}, {111,0.00000000}, {112,0.00006306}, {113,0.00000000}, {114,0.00003604}, {115,0.00007207}, {116,0.00009910}, {117,0.00009009}, {118,0.00003604}, {119,0.00007207}, {120,0.00003604}, {121,0.00000000}, {122,0.00014414}, {123,0.00007207}, {124,0.00000000}, {125,0.00007207}, {126,0.00000000}, {127,0.00010811}, {128,0.00010811}, {129,0.00007207}, {130,0.00000000}, {131,0.00000000}, {132,0.00003604}, {133,0.00000000}, {134,0.00007207}, {135,0.00007207}, {136,0.00010811}, {137,0.00002703}, {138,0.00003604}, {139,0.00000000}, {140,0.00002703}, {141,0.00000000}, {142,0.00003604}, {143,0.00009910}, {144,0.00003604}, {145,0.00003604}, {146,0.00013514}, {147,0.00010811}, {148,0.00006306}, {149,0.00000000}, {150,0.00000000}, {151,0.00007207}, {152,0.00007207}, {153,0.00014414}, {154,0.00003604}, {155,0.00006306}, {156,0.00007207}, {157,0.00003604}, {158,0.00006306}, {159,0.00003604}, {160,0.00000000}, {161,0.00003604}, {162,0.00000000}, {163,0.00000000}, {164,0.00003604}, {165,0.00003604}, {166,0.00010811}, {167,0.00013514}, {168,0.00010811}, {169,0.00010811}, {170,0.00007207}, {171,0.00003604}, {172,0.00003604}, {173,0.00006306}, {174,0.00007207}, {175,0.00003604}, {176,0.00010811}, {177,0.00003604}, {178,0.00002703}, {179,0.00000000}, {180,0.00000000}, {181,0.00007207}, {182,0.00010811}, {183,0.00003604}, {184,0.00009910}, {185,0.00006306}, {186,0.00003604}, {187,0.00010811}, {188,0.00000000}, {189,0.00003604}, {190,0.00018018}, {191,0.00007207}, {192,0.00003604}, {193,0.00007207}, {194,0.00000000}, {195,0.00002703}, {196,0.00006306}, {197,0.00007207}, {198,0.00003604}, {199,0.00007207}, {200,0.00009910}, {201,0.00006306}, {202,0.00002703}, {203,0.00003604}, {204,0.00007207}, {205,0.00007207}, {206,0.00002703}, {207,0.00007207}, {208,0.00006306}, {209,0.00003604}, {210,0.00007207}, {211,0.00018018}, {212,0.00000000}, {213,0.00003604}, {214,0.00000000}, {215,0.00010811}, {216,0.00007207}, {217,0.00010811}, {218,0.00003604}, {219,0.00007207}, {220,0.00003604}, {221,0.00009910}, {222,0.00009910}, {223,0.00000000}, {224,0.00003604}, {225,0.00007207}, {226,0.00000000}, {227,0.00003604}, {228,0.00003604}, {229,0.00010811}, {230,0.00003604}, {231,0.00003604}, {232,0.00003604}, {233,0.00010811}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00010811}, {238,0.00007207}, {239,0.00006306}, {240,0.00002703}, {241,0.00006306}, {242,0.00006306}, {243,0.00003604}, {244,0.00014414}, {245,0.00003604}, {246,0.00010811}, {247,0.00007207}, {248,0.00003604}, {249,0.00007207}, {250,0.00010811}, {251,0.00010811}, {252,0.00006306}, {253,0.00017117}, {254,0.00003604}, {255,0.00010811}, {256,0.00013514}, {257,0.00000000}, {258,0.00003604}, {259,0.00003604}, {260,0.00003604}, {261,0.00003604}, {262,0.00010811}, {263,0.00000000}, {264,0.00003604}, {265,0.00003604}, {266,0.00002703}, {267,0.00006306}, {268,0.00006306}, {269,0.00000000}, {270,0.00007207}, {271,0.00000000}, {272,0.00017117}, {273,0.00010811}, {274,0.00007207}, {275,0.00007207}, {276,0.00000000}, {277,0.00009910}, {278,0.00007207}, {279,0.00003604}, {280,0.00003604}, {281,0.00007207}, {282,0.00009009}, {283,0.00000000}, {284,0.00006306}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00013514}, {289,0.00007207}, {290,0.00014414}, {291,0.00007207}, {292,0.00003604}, {293,0.00010811}, {294,0.00010811}, {295,0.00007207}, {296,0.00000000}, {297,0.00007207}, {298,0.00000000}, {299,0.00010811}, {300,0.00003604}, {301,0.00003604}, {302,0.00014414}, {303,0.00005405}, {304,0.00003604}, {305,0.00007207}, {306,0.00009910}, {307,0.00007207}, {308,0.00000000}, {309,0.00007207}, {310,0.00014414}, {311,0.00017117}, {312,0.00013514}, {313,0.00003604}, {314,0.00000000}, {315,0.00003604}, {316,0.00007207}, {317,0.00007207}, {318,0.00007207}, {319,0.00007207}, {320,0.00000000}, {321,0.00006306}, {322,0.00007207}, {323,0.00007207}, {324,0.00007207}, {325,0.00003604}, {326,0.00009910}, {327,0.00014414}, {328,0.00007207}, {329,0.00006306}, {330,0.00003604}, {331,0.00014414}, {332,0.00014414}, {333,0.00007207}, {334,0.00006306}, {335,0.00003604}, {336,0.00018018}, {337,0.00003604}, {338,0.00003604}, {339,0.00016216}, {340,0.00003604}, {341,0.00005405}, {342,0.00003604}, {343,0.00002703}, {344,0.00003604}, {345,0.00000000}, {346,0.00014414}, {347,0.00000000}, {348,0.00007207}, {349,0.00014414}, {350,0.00003604}, {351,0.00007207}, {352,0.00003604}, {353,0.00003604}, {354,0.00007207}, {355,0.00006306}, {356,0.00007207}, {357,0.00000000}, {358,0.00003604}, {359,0.00021622}, {360,0.00007207}, {361,0.00006306}, {362,0.00000000}, {363,0.00007207}, {364,0.00003604}, {365,0.00007207}, {366,0.00012613}, {367,0.00010811}, {368,0.00007207}, {369,0.00003604}, {370,0.00007207}, {371,0.00007207}, {372,0.00009910}, {373,0.00017117}, {374,0.00010811}, {375,0.00002703}, {376,0.00003604}, {377,0.00006306}, {378,0.00007207}, {379,0.00025225}, {380,0.00018018}, {381,0.00010811}, {382,0.00003604}, {383,0.00000000}, {384,0.00010811}, {385,0.00018018}, {386,0.00000000}, {387,0.00007207}, {388,0.00007207}, {389,0.00002703}, {390,0.00010811}, {391,0.00003604}, {392,0.00007207}, {393,0.00000000}, {394,0.00007207}, {395,0.00007207}, {396,0.00007207}, {397,0.00000000}, {398,0.00007207}, {399,0.00003604}, {400,0.00014414}, {401,0.00006306}, {402,0.00013514}, {403,0.00007207}, {404,0.00009910}, {405,0.00009009}, {406,0.00003604}, {407,0.00014414}, {408,0.00007207}, {409,0.00003604}, {410,0.00003604}, {411,0.00013514}, {412,0.00018018}, {413,0.00000000}, {414,0.00003604}, {415,0.00000000}, {416,0.00010909}, {417,0.00010000}, {418,0.00010000}, {419,0.00007273}, {420,0.00005455}, {421,0.00003636}, {422,0.00006364}, {423,0.00014545}, {424,0.00010909}, {425,0.00010909}, {426,0.00010909}, {427,0.00003636}, {428,0.00007273}, {429,0.00003636}, {430,0.00012727}, {431,0.00006364}, {432,0.00000000}, {433,0.00003636}, {434,0.00007273}, {435,0.00002727}, {436,0.00000000}, {437,0.00003636}, {438,0.00010909}, {439,0.00014545}, {440,0.00007273}, {441,0.00003636}, {442,0.00007273}, {443,0.00010000}, {444,0.00003636}, {445,0.00007273}, {446,0.00003636}, {447,0.00014545}, {448,0.00007273}, {449,0.00003636}, {450,0.00007273}, {451,0.00003636}, {452,0.00002727}, {453,0.00003636}, {454,0.00013636}, {455,0.00007273}, {456,0.00010909}, {457,0.00003636}, {458,0.00016364}, {459,0.00007273}, {460,0.00003636}, {461,0.00003636}, {462,0.00003636}, {463,0.00013636}, {464,0.00003636}, {465,0.00000000}, {466,0.00010909}, {467,0.00007273}, {468,0.00010909}, {469,0.00010909}, {470,0.00010909}, {471,0.00010000}, {472,0.00025455}, {473,0.00007273}, {474,0.00007273}, {475,0.00003636}, {476,0.00007273}, {477,0.00017273}, {478,0.00010909}, {479,0.00007273}, {480,0.00021818}, {481,0.00010909}, {482,0.00007273}, {483,0.00016364}, {484,0.00003636}, {485,0.00000000}, {486,0.00010000}, {487,0.00007273}, {488,0.00007273}, {489,0.00000000}, {490,0.00010909}, {491,0.00010909}, {492,0.00007273}, {493,0.00010909}, {494,0.00018182}, {495,0.00018182}, {496,0.00000000}, {497,0.00010909}, {498,0.00017273}, {499,0.00003636}, {500,0.00010909}, {505,0.00010909}, {510,0.00006364}, {515,0.00000000}, {520,0.00013636}, {525,0.00003636}, {530,0.00006364}, {535,0.00003636}, {540,0.00007273}, {545,0.00003636}, {550,0.00007273}, {555,0.00017273}, {560,0.00014545}, {565,0.00003636}, {570,0.00010909}, {575,0.00007273}, {580,0.00006364}, {585,0.00007273}, {590,0.00007273}, {595,0.00002727}, {600,0.00018182}, {605,0.00007273}, {610,0.00003636}, {615,0.00010909}, {620,0.00003636}, {625,0.00000000}, {630,0.00000000}, {635,0.00010909}, {640,0.00028182}, {645,0.00002727}, {650,0.00007273}, {655,0.00003636}, {660,0.00010909}, {665,0.00003636}, {670,0.00007273}, {675,0.00007273}, {680,0.00005455}, {685,0.00013636}, {690,0.00010000}, {695,0.00007273}, {700,0.00017273}, {705,0.00010909}, {710,0.00010909}, {715,0.00003636}, {720,0.00003636}, {725,0.00013636}, {730,0.00010000}, {735,0.00000000}, {740,0.00014545}, {745,0.00018182}, {750,0.00006364}, {755,0.00002727}, {760,0.00007273}, {765,0.00021818}, {770,0.00010909}, {775,0.00010909}, {780,0.00010909}, {785,0.00005455}, {790,0.00003636}, {795,0.00003636}, {800,0.00018182}, {805,0.00014545}, {810,0.00014545}, {815,0.00006364}, {820,0.00025455}, {825,0.00018182}, {830,0.00007273}, {835,0.00017273}, {840,0.00007273}, {845,0.00018182}, {850,0.00000000}, {855,0.00002727}, {860,0.00010909}, {865,0.00012727}, {870,0.00007273}, {875,0.00007273}, {880,0.00010909}, {885,0.00021818}, {890,0.00013636}, {895,0.00007273}, {900,0.00010000}, {905,0.00007273}, {910,0.00013636}, {915,0.00003636}, {920,0.00003636}, {925,0.00025455}, {930,0.00007273}, {935,0.00010909}, {940,0.00010909}, {945,0.00013636}, {950,0.00006364}, {955,0.00007273}, {960,0.00018182}, {965,0.00000000}, {970,0.00010909}, {975,0.00009091}, {980,0.00018182}, {985,0.00018182}, {990,0.00000000}, {995,0.00020909}, {1000,0.00010909}, {1010,0.00006364}, {1020,0.00014545}, {1030,0.00021818}, {1040,0.00003636}, {1050,0.00017273}, {1060,0.00007273}, {1070,0.00003636}, {1080,0.00010000}, {1090,0.00010909}, {1100,0.00025455}, {1110,0.00010909}, {1120,0.00010909}, {1130,0.00000000}, {1140,0.00012727}, {1150,0.00010909}, {1160,0.00017273}, {1170,0.00007273}, {1180,0.00003636}, {1190,0.00010909}, {1200,0.00013636}, {1210,0.00014545}, {1220,0.00007273}, {1230,0.00021818}, {1240,0.00007273}, {1250,0.00028182}, {1260,0.00006364}, {1270,0.00016364}, {1280,0.00007273}, {1290,0.00026364}, {1300,0.00003636}, {1310,0.00014545}, {1320,0.00013636}, {1330,0.00013636}, {1340,0.00020909}, {1350,0.00003636}, {1360,0.00017273}, {1370,0.00030909}, {1380,0.00010909}, {1390,0.00043636}, {1400,0.00014545}, {1410,0.00018182}, {1420,0.00017273}, {1430,0.00007273}, {1440,0.00034545}, {1450,0.00032727}, {1460,0.00010909}, {1470,0.00031818}, {1480,0.00013636}, {1490,0.00020909}, {1500,0.00013636}, {1510,0.00013636}, {1520,0.00000000}, {1530,0.00018182}, {1540,0.00021818}, {1550,0.00010909}, {1560,0.00029091}, {1570,0.00029091}, {1580,0.00005455}, {1590,0.00025455}, {1600,0.00018182}, {1610,0.00010909}, {1620,0.00014545}, {1630,0.00030000}, {1640,0.00007273}, {1650,0.00014545}, {1660,0.00046364}, {1670,0.00028182}, {1680,0.00010000}, {1690,0.00012727}, {1700,0.00035455}, {1710,0.00029091}, {1720,0.00002727}, {1730,0.00003636}, {1740,0.00029091}, {1750,0.00220000}, {1760,0.00036364}, {1770,0.00007273}, {1780,0.00027273}, {1790,0.00029091}, {1800,0.00057273}, {1810,0.00007273}, {1820,0.00039091}, {1830,0.00036364}, {1840,0.00024545}, {1850,0.00035455}, {1860,0.00010909}, {1870,0.00030909}, {1880,0.00031818}, {1890,0.00030909}, {1900,0.00010000}, {1910,0.00064545}, {1920,0.00021818}, {1930,0.00018182}, {1940,0.00018182}, {1950,0.00013636}, {1960,0.00017273}, {1970,0.00029091}, {1980,0.00046364}, {1990,0.00017273}, {2000,0.00012727}, {2050,0.00010909}, {2100,0.00021818}, {2150,0.00025455}, {2200,0.00021818}, {2250,0.00031818}, {2300,0.00024545}, {2350,0.00031818}, {2400,0.00039091}, {2450,0.00038182}, {2500,0.00047273}, {2550,0.00017273}, {2600,0.00010909}, {2650,0.00062727}, {2700,0.00061818}, {2750,0.00031818}, {2800,0.00040000}, {2850,0.00039091}, {2900,0.00021818}, {2950,0.00064545}, {3000,0.00043636}, {3050,0.00067273}, {3100,0.00043636}, {3150,0.00047273}, {3200,0.00043636}, {3250,0.00028182}, {3300,0.00093636}, {3350,0.00060000}, {3400,0.00079091}, {3450,0.00028182}, {3500,0.00085455}, {3550,0.00051818}, {3600,0.00096364}, {3650,0.00070909}, {3700,0.00020909}, {3750,0.00050000}, {3800,0.00049091}, {3850,0.00038182}, {3900,0.00050000}, {3950,0.00068182}, {4000,0.00039091}, {4050,0.00063636}, {4100,0.00097273}, {4150,0.00055455}, {4200,0.00061818}, {4250,0.00056364}, {4300,0.00053636}, {4350,0.00061818}, {4400,0.00131818}, {4450,0.00110909}, {4500,0.00111818}, {4550,0.00090909}, {4600,0.00097273}, {4650,0.00083636}, {4700,0.00096364}, {4750,0.00102727}, {4800,0.00066364}, {4850,0.00100909}, {4900,0.00032727}, {4950,0.00092727}, {5000,0.00065455}, {5050,0.00110909}, {5100,0.00076364}, {5150,0.00117273}, {5200,0.00070909}, {5250,0.00157273}, {5300,0.00065455}, {5350,0.00114545}, {5400,0.00087273}, {5450,0.00040000}, {5500,0.00139091}, {5550,0.00048182}, {5600,0.00020909}, {5650,0.00006364}, {5700,0.00018182}, {5750,0.00020909}, {5800,0.00018182}, {5850,0.00029091}, {5900,0.00007273}, {5950,0.00007273}, {6000,0.00020909}, {6050,0.00021818}, {6100,0.00100909}, {6150,0.00067273}, {6200,0.00053636}, {6250,0.00102727}, {6300,0.00161818}, {6350,0.00042727}, {6400,0.00091818}, {6450,0.00116364}, {6500,0.00195455}, {6550,0.00126364}, {6600,0.00111818}, {6650,0.00077273}, {6700,0.00042727}, {6750,0.00092727}, {6800,0.00058182}, {6850,0.00090909}, {6900,0.00058182}, {6950,0.00070909}, {7000,0.00070909}, {7050,0.00070909}, {7100,0.00083636}, {7150,0.00072727}, {7200,0.00100909}, {7250,0.00161818}, {7300,0.00160909}, {7350,0.00178182}, {7400,0.00213636}, {7450,0.00071818}, {7500,0.00064545}, {7550,0.00021818}, {7600,0.00028182}, {7650,0.00044545}, {7700,0.00024545}, {7750,0.00010909}, {7800,0.00021818}, {7850,0.00030909}, {7900,0.00046364}, {7950,0.00028182}, {8000,0.00013636}, {8050,0.00014545}, {8100,0.00014545}, {8150,0.00018182}, {8200,0.00018182}, {8250,0.00014545}, {8300,0.00021818}, {8350,0.00003636}, {8400,0.00018182}, {8450,0.00021818}, {8500,0.00007273}, {8550,0.00010909}, {8600,0.00034545}, {8650,0.00018182}, {8700,0.00021818}, {8750,0.00025455}, {8800,0.00003636}, {8850,0.00018182}, {8900,0.00017273}, {8950,0.00024545}, {9000,0.00017273}, {9050,0.00018182}, {9100,0.00007273}, {9150,0.00014545}, {9200,0.00035455}, {9250,0.00010909}, {9300,0.00010909}, {9350,0.00010909}, {9400,0.00025455}, {9450,0.00010909}, {9500,0.00014545}, {9550,0.00014545}, {9600,0.00014545}, {9650,0.00007273}, {9700,0.00025455}, {9750,0.00017273}, {9800,0.00028182}, {9850,0.00031818}, {9900,0.00010909}, {9950,0.00016364}, {10000,0.00024545}, {10100,0.00010909}, {10200,0.00029091}, {10300,0.00017273}, {10400,0.00025455}, {10500,0.00014545}, {10600,0.00021818}, {10700,0.00025455}, {10800,0.00010909}, {10900,0.00014545}, {11000,0.00007273}, {11100,0.00018182}, {11200,0.00006364}, {11300,0.00007273}, {11400,0.00010909}, {11500,0.00030909}, {11600,0.00014545}, {11700,0.00247273}, {11800,0.00213636}, {11900,0.00135455}, {12000,0.00187273}, {12100,0.00149091}, {12200,0.00241818}, {12300,0.00107273}, {12400,0.00118182}, {12500,0.00036364}, {12600,0.00053636}, {12700,0.00052727}, {12800,0.00030909}, {12900,0.00013636}, {13000,0.00014545}, {13100,0.00018182}, {13200,0.00080000}, {13300,0.00152727}, {13400,0.00077273}, {13500,0.00115455}, {13600,0.00158182}, {13700,0.00151818}, {13800,0.00132727}, {13900,0.00065455}, {14000,0.00036364}, {14100,0.00050000}, {14200,0.00050000}, {14300,0.00158182}, {14400,0.00018182}, {14500,0.00028182}, {14600,0.00025455}, {14700,0.00039091}, {14800,0.00056364}, {14900,0.00058182}, {15000,0.00014545}, {15100,0.00029091}, {15200,0.00014545}, {15300,0.00018182}, {15400,0.00036364}, {15500,0.00014545}, {15600,0.00021818}, {15700,0.00007273}, {15800,0.00007273}, {15900,0.00021818}, {16000,0.00010909}, {16100,0.00040000}, {16200,0.00021818}, {16300,0.00049091}, {16400,0.00025455}, {16500,0.00024545}, {16600,0.00010909}, {16700,0.00025455}, {16800,0.00028182}, {16900,0.00000000}, {17000,0.00020000}, {17100,0.00010909}, {17200,0.00013636}, {17300,0.00025455}, {17400,0.00050909}, {17500,0.00042727}, {17600,0.00050909}, {17700,0.00056364}, {17800,0.00024545}, {17900,0.00021818}, {18000,0.00020909}, {18100,0.00024545}, {18200,0.00036364}, {18300,0.00029091}, {18400,0.00032727}, {18500,0.00007273}, {18600,0.00032727}, {18700,0.00018182}, {18800,0.00021818}, {18900,0.00031818}, {19000,0.00014545}, {19100,0.00010909}, {19200,0.00010909}, {19300,0.00029091}, {19400,0.00014545}, {19500,0.00021818}, {19600,0.00017273}, {19700,0.00018182}, {19800,0.00025455}, {19900,0.00024545}, {20000,0.00018519}};
data["big_flat"]["TemplateCoq"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00001802}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000901}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000901}, {98,0.00003604}, {99,0.00001802}, {100,0.00006306}, {101,0.00011712}, {102,0.00022523}, {103,0.00032432}, {104,0.00054955}, {105,0.00066667}, {106,0.00077477}, {107,0.00090991}, {108,0.00116216}, {109,0.00097297}, {110,0.00099099}, {111,0.00100000}, {112,0.00100000}, {113,0.00100000}, {114,0.00100000}, {115,0.00100000}, {116,0.00100000}, {117,0.00100000}, {118,0.00100000}, {119,0.00100000}, {120,0.00100000}, {121,0.00100000}, {122,0.00100000}, {123,0.00100000}, {124,0.00100000}, {125,0.00100000}, {126,0.00100000}, {127,0.00100000}, {128,0.00100000}, {129,0.00100000}, {130,0.00100000}, {131,0.00100000}, {132,0.00100000}, {133,0.00100000}, {134,0.00100000}, {135,0.00100000}, {136,0.00100000}, {137,0.00100000}, {138,0.00100000}, {139,0.00101802}, {140,0.00198198}, {141,0.00100000}, {142,0.00100000}, {143,0.00100000}, {144,0.00100000}, {145,0.00100000}, {146,0.00100000}, {147,0.00100000}, {148,0.00100000}, {149,0.00100000}, {150,0.00100000}, {151,0.00100000}, {152,0.00100000}, {153,0.00101802}, {154,0.00100000}, {155,0.00100000}, {156,0.00100000}, {157,0.00100000}, {158,0.00100000}, {159,0.00100000}, {160,0.00100000}, {161,0.00100000}, {162,0.00100000}, {163,0.00100000}, {164,0.00100000}, {165,0.00100000}, {166,0.00100000}, {167,0.00100000}, {168,0.00100000}, {169,0.00100000}, {170,0.00100000}, {171,0.00100000}, {172,0.00100000}, {173,0.00100000}, {174,0.00100000}, {175,0.00100000}, {176,0.00100000}, {177,0.00100000}, {178,0.00100000}, {179,0.00100000}, {180,0.00100000}, {181,0.00100000}, {182,0.00100000}, {183,0.00100000}, {184,0.00100000}, {185,0.00100000}, {186,0.00100000}, {187,0.00100000}, {188,0.00100000}, {189,0.00103604}, {190,0.00100000}, {191,0.00100000}, {192,0.00100901}, {193,0.00100000}, {194,0.00100000}, {195,0.00100901}, {196,0.00100000}, {197,0.00100000}, {198,0.00100901}, {199,0.00100000}, {200,0.00101802}, {201,0.00100000}, {202,0.00101802}, {203,0.00104505}, {204,0.00102703}, {205,0.00105405}, {206,0.00108108}, {207,0.00114414}, {208,0.00117117}, {209,0.00118018}, {210,0.00136937}, {211,0.00149550}, {212,0.00147748}, {213,0.00153153}, {214,0.00171171}, {215,0.00169369}, {216,0.00174775}, {217,0.00181081}, {218,0.00191892}, {219,0.00191892}, {220,0.00193694}, {221,0.00198198}, {222,0.00199099}, {223,0.00198198}, {224,0.00200000}, {225,0.00198198}, {226,0.00200000}, {227,0.00200000}, {228,0.00200000}, {229,0.00200000}, {230,0.00296396}, {231,0.00200000}, {232,0.00200000}, {233,0.00200000}, {234,0.00200000}, {235,0.00200000}, {236,0.00200000}, {237,0.00200000}, {238,0.00200000}, {239,0.00298198}, {240,0.00200000}, {241,0.00200000}, {242,0.00200000}, {243,0.00200000}, {244,0.00200000}, {245,0.00200000}, {246,0.00200000}, {247,0.00200000}, {248,0.00200000}, {249,0.00200000}, {250,0.00200000}, {251,0.00200000}, {252,0.00200000}, {253,0.00200000}, {254,0.00200000}, {255,0.00200000}, {256,0.00200000}, {257,0.00200000}, {258,0.00200000}, {259,0.00200901}, {260,0.00200000}, {261,0.00200000}, {262,0.00200000}, {263,0.00200000}, {264,0.00202703}, {265,0.00200000}, {266,0.00200000}, {267,0.00200000}, {268,0.00200000}, {269,0.00200000}, {270,0.00200000}, {271,0.00200000}, {272,0.00201802}, {273,0.00200000}, {274,0.00200000}, {275,0.00200000}, {276,0.00200000}, {277,0.00200000}, {278,0.00200000}, {279,0.00200000}, {280,0.00200000}, {281,0.00200000}, {282,0.00200000}, {283,0.00200000}, {284,0.00200000}, {285,0.00200000}, {286,0.00200000}, {287,0.00200000}, {288,0.00200000}, {289,0.00200000}, {290,0.00200000}, {291,0.00200000}, {292,0.00200000}, {293,0.00200000}, {294,0.00200000}, {295,0.00200901}, {296,0.00200000}, {297,0.00200000}, {298,0.00200000}, {299,0.00200000}, {300,0.00200901}, {301,0.00200000}, {302,0.00203604}, {303,0.00200000}, {304,0.00200901}, {305,0.00203604}, {306,0.00200901}, {307,0.00204505}, {308,0.00201802}, {309,0.00209009}, {310,0.00208108}, {311,0.00212613}, {312,0.00213514}, {313,0.00221622}, {314,0.00228829}, {315,0.00233333}, {316,0.00241441}, {317,0.00234234}, {318,0.00249550}, {319,0.00251351}, {320,0.00258559}, {321,0.00267568}, {322,0.00274775}, {323,0.00274775}, {324,0.00277477}, {325,0.00281982}, {326,0.00287387}, {327,0.00291892}, {328,0.00293694}, {329,0.00293694}, {330,0.00393694}, {331,0.00297297}, {332,0.00299099}, {333,0.00297297}, {334,0.00300000}, {335,0.00300000}, {336,0.00302703}, {337,0.00299099}, {338,0.00300000}, {339,0.00300000}, {340,0.00300000}, {341,0.00300000}, {342,0.00300000}, {343,0.00300000}, {344,0.00300000}, {345,0.00300000}, {346,0.00300000}, {347,0.00300000}, {348,0.00300000}, {349,0.00463063}, {350,0.00300000}, {351,0.00300000}, {352,0.00300000}, {353,0.00300000}, {354,0.00300000}, {355,0.00301802}, {356,0.00300000}, {357,0.00300000}, {358,0.00300000}, {359,0.00300000}, {360,0.00300000}, {361,0.00303604}, {362,0.00300000}, {363,0.00300000}, {364,0.00300000}, {365,0.00300000}, {366,0.00300000}, {367,0.00302703}, {368,0.00300000}, {369,0.00300000}, {370,0.00300000}, {371,0.00300000}, {372,0.00300000}, {373,0.00301802}, {374,0.00300000}, {375,0.00300000}, {376,0.00300000}, {377,0.00300000}, {378,0.00300000}, {379,0.00300000}, {380,0.00300000}, {381,0.00300000}, {382,0.00300000}, {383,0.00300000}, {384,0.00300000}, {385,0.00412613}, {386,0.00300000}, {387,0.00300000}, {388,0.00300000}, {389,0.00300000}, {390,0.00300000}, {391,0.00300000}, {392,0.00300000}, {393,0.00300000}, {394,0.00300000}, {395,0.00302703}, {396,0.00496396}, {397,0.00300000}, {398,0.00300000}, {399,0.00300000}, {400,0.00300000}, {401,0.00301802}, {402,0.00300000}, {403,0.00300000}, {404,0.00300000}, {405,0.00300000}, {406,0.00300000}, {407,0.00496396}, {408,0.00300000}, {409,0.00301802}, {410,0.00301802}, {411,0.00302703}, {412,0.00307207}, {413,0.00304505}, {414,0.00305405}, {415,0.00307273}, {416,0.00306364}, {417,0.00308182}, {418,0.00311818}, {419,0.00317273}, {420,0.00317273}, {421,0.00316364}, {422,0.00330000}, {423,0.00502727}, {424,0.00351818}, {425,0.00354545}, {426,0.00359091}, {427,0.00361818}, {428,0.00508182}, {429,0.00367273}, {430,0.00369091}, {431,0.00376364}, {432,0.00379091}, {433,0.00389091}, {434,0.00378182}, {435,0.00386364}, {436,0.00386364}, {437,0.00387273}, {438,0.00392727}, {439,0.00391818}, {440,0.00390909}, {441,0.00391818}, {442,0.00396364}, {443,0.00400909}, {444,0.00397273}, {445,0.00398182}, {446,0.00398182}, {447,0.00400000}, {448,0.00400909}, {449,0.00400000}, {450,0.00400000}, {451,0.00400000}, {452,0.00400000}, {453,0.00401818}, {454,0.00400000}, {455,0.00400000}, {456,0.00400000}, {457,0.00400000}, {458,0.00575455}, {459,0.00400000}, {460,0.00400000}, {461,0.00400000}, {462,0.00400000}, {463,0.00400000}, {464,0.00400000}, {465,0.00400000}, {466,0.00400000}, {467,0.00400000}, {468,0.00400000}, {469,0.00400000}, {470,0.00400000}, {471,0.00400000}, {472,0.00403636}, {473,0.00400000}, {474,0.00400000}, {475,0.00400000}, {476,0.00400000}, {477,0.00587273}, {478,0.00400000}, {479,0.00400000}, {480,0.00400000}, {481,0.00400000}, {482,0.00400000}, {483,0.00400000}, {484,0.00400000}, {485,0.00400000}, {486,0.00598182}, {487,0.00400000}, {488,0.00400000}, {489,0.00400000}, {490,0.00400000}, {491,0.00400000}, {492,0.00400000}, {493,0.00400000}, {494,0.00400000}, {495,0.00403636}, {496,0.00400000}, {497,0.00400000}, {498,0.00400000}, {499,0.00400000}, {500,0.00400000}, {505,0.00400000}, {510,0.00401818}, {515,0.00401818}, {520,0.00623636}, {525,0.00413636}, {530,0.00438182}, {535,0.00463636}, {540,0.00479091}, {545,0.00481818}, {550,0.00489091}, {555,0.00497273}, {560,0.00503636}, {565,0.00499091}, {570,0.00500000}, {575,0.00500000}, {580,0.00701818}, {585,0.00500000}, {590,0.00500000}, {595,0.00500000}, {600,0.00704545}, {605,0.00500000}, {610,0.00500909}, {615,0.00500909}, {620,0.00500909}, {625,0.00506364}, {630,0.00512727}, {635,0.00540909}, {640,0.00549091}, {645,0.00567273}, {650,0.00577273}, {655,0.00581818}, {660,0.00588182}, {665,0.00595455}, {670,0.00809091}, {675,0.00600000}, {680,0.00600000}, {685,0.00605455}, {690,0.00600000}, {695,0.00600000}, {700,0.00600000}, {705,0.00600000}, {710,0.00600000}, {715,0.00600909}, {720,0.00600000}, {725,0.00603636}, {730,0.00607273}, {735,0.00611818}, {740,0.00624545}, {745,0.00646364}, {750,0.00811818}, {755,0.00672727}, {760,0.00677273}, {765,0.00681818}, {770,0.00690000}, {775,0.00695455}, {780,0.00698182}, {785,0.00700000}, {790,0.00700000}, {795,0.00700000}, {800,0.00700000}, {805,0.00700000}, {810,0.00700909}, {815,0.00700909}, {820,0.00705455}, {825,0.00702727}, {830,0.00703636}, {835,0.00994545}, {840,0.00718182}, {845,0.00724545}, {850,0.00733636}, {855,0.00751818}, {860,0.00776364}, {865,0.00772727}, {870,0.00777273}, {875,0.00781818}, {880,0.00786364}, {885,0.00790000}, {890,0.00796364}, {895,0.00800000}, {900,0.01079091}, {905,0.00800000}, {910,0.00800000}, {915,0.00800000}, {920,0.00800000}, {925,0.01563636}, {930,0.00800000}, {935,0.00801818}, {940,0.00805455}, {945,0.00812727}, {950,0.00818182}, {955,0.00830909}, {960,0.01176364}, {965,0.00851818}, {970,0.00872727}, {975,0.00874545}, {980,0.00873636}, {985,0.00878182}, {990,0.00886364}, {995,0.01211818}, {1000,0.00896364}, {1010,0.00905455}, {1020,0.00900000}, {1030,0.00900000}, {1040,0.00910000}, {1050,0.00921818}, {1060,0.00933636}, {1070,0.00955455}, {1080,0.00971818}, {1090,0.00984545}, {1100,0.01320000}, {1110,0.00993636}, {1120,0.01346364}, {1130,0.01000000}, {1140,0.01369091}, {1150,0.01014545}, {1160,0.01384545}, {1170,0.01055455}, {1180,0.01060000}, {1190,0.01073636}, {1200,0.01080000}, {1210,0.01090000}, {1220,0.01096364}, {1230,0.01097273}, {1240,0.01103636}, {1250,0.01110000}, {1260,0.01124545}, {1270,0.01660000}, {1280,0.01157273}, {1290,0.01568182}, {1300,0.01177273}, {1310,0.01182727}, {1320,0.01187273}, {1330,0.01197273}, {1340,0.01647273}, {1350,0.01208182}, {1360,0.01213636}, {1370,0.01233636}, {1380,0.01255455}, {1390,0.02360000}, {1400,0.01270000}, {1410,0.01277273}, {1420,0.01280000}, {1430,0.01292727}, {1440,0.01724545}, {1450,0.01305455}, {1460,0.01314545}, {1470,0.02219091}, {1480,0.01342727}, {1490,0.01360909}, {1500,0.01884545}, {1510,0.01373636}, {1520,0.01380909}, {1530,0.01926364}, {1540,0.01393636}, {1550,0.01406364}, {1560,0.01905455}, {1570,0.01434545}, {1580,0.01438182}, {1590,0.02551818}, {1600,0.01464545}, {1610,0.01470909}, {1620,0.01477273}, {1630,0.01500000}, {1640,0.01490000}, {1650,0.01499091}, {1660,0.02093636}, {1670,0.01531818}, {1680,0.01545455}, {1690,0.01552727}, {1700,0.02146364}, {1710,0.01570909}, {1720,0.01574545}, {1730,0.01579091}, {1740,0.02213636}, {1750,0.01600000}, {1760,0.01606364}, {1770,0.01625455}, {1780,0.02247273}, {1790,0.01663636}, {1800,0.01660000}, {1810,0.01673636}, {1820,0.01672727}, {1830,0.02313636}, {1840,0.01688182}, {1850,0.01690909}, {1860,0.01704545}, {1870,0.01720000}, {1880,0.02426364}, {1890,0.02406364}, {1900,0.01756364}, {1910,0.01762727}, {1920,0.01772727}, {1930,0.01774545}, {1940,0.02446364}, {1950,0.02475455}, {1960,0.01802727}, {1970,0.01808182}, {1980,0.01829091}, {1990,0.01840909}, {2000,0.01845455}, {2050,0.01849091}, {2100,0.02626364}, {2150,0.02719091}, {2200,0.02790909}, {2250,0.02860909}, {2300,0.02930909}, {2350,0.03000000}, {2400,0.03056364}, {2450,0.03092727}, {2500,0.03127273}, {2550,0.02763636}, {2600,0.02423636}, {2650,0.02478182}, {2700,0.02522727}, {2750,0.02590909}, {2800,0.03547273}, {2850,0.02676364}, {2900,0.02710000}, {2950,0.02768182}, {3000,0.03789091}, {3050,0.02875455}, {3100,0.02917273}, {3150,0.03970000}, {3200,0.03003636}, {3250,0.04170909}, {3300,0.03115455}, {3350,0.03155455}, {3400,0.04219091}, {3450,0.03262727}, {3500,0.04381818}, {3550,0.03355455}, {3600,0.03340909}, {3650,0.05476364}, {3700,0.03501818}, {3750,0.04678182}, {3800,0.03632727}, {3850,0.03645455}, {3900,0.04881818}, {3950,0.05471818}, {4000,0.03803636}, {4050,0.04734545}, {4100,0.07180909}, {4150,0.05299091}, {4200,0.03997273}, {4250,0.04043636}, {4300,0.03909091}, {4350,0.05397273}, {4400,0.07853636}, {4450,0.07202727}, {4500,0.06605455}, {4550,0.06300000}, {4600,0.06149091}, {4650,0.06212727}, {4700,0.06477273}, {4750,0.06975455}, {4800,0.07625455}, {4850,0.08513636}, {4900,0.05634545}, {4950,0.04740000}, {5000,0.04788182}, {5050,0.06590909}, {5100,0.06549091}, {5150,0.08690000}, {5200,0.04992727}, {5250,0.07106364}, {5300,0.06797273}, {5350,0.08982727}, {5400,0.06680909}, {5450,0.07179091}, {5500,0.05190909}, {5550,0.07182727}, {5600,0.08423636}, {5650,0.07013636}, {5700,0.07628182}, {5750,0.05570909}, {5800,0.08335455}, {5850,0.07869091}, {5900,0.08018182}, {5950,0.07425455}, {6000,0.08652727}, {6050,0.08287273}, {6100,0.07563636}, {6150,0.08973636}, {6200,0.08041818}, {6250,0.07822727}, {6300,0.08975455}, {6350,0.08196364}, {6400,0.08255455}, {6450,0.08054545}, {6500,0.06287273}, {6550,0.09078182}, {6600,0.08879091}, {6650,0.08603636}, {6700,0.08685455}, {6750,0.08849091}, {6800,0.08401818}, {6850,0.08490909}, {6900,0.08600909}, {6950,0.08667273}, {7000,0.08710000}, {7050,0.08847273}, {7100,0.08422727}, {7150,0.09130000}, {7200,0.09140000}, {7250,0.09114545}, {7300,0.08791818}, {7350,0.09520909}, {7400,0.09227273}, {7450,0.09590000}, {7500,0.09576364}, {7550,0.09266364}, {7600,0.09408182}, {7650,0.09897273}, {7700,0.08771818}, {7750,0.09576364}, {7800,0.10018182}, {7850,0.09786364}, {7900,0.10173636}, {7950,0.09360909}, {8000,0.09848182}, {8050,0.09884545}, {8100,0.09977273}, {8150,0.09726364}, {8200,0.10018182}, {8250,0.09210000}, {8300,0.10546364}, {8350,0.10744545}, {8400,0.10748182}, {8450,0.10696364}, {8500,0.10897273}, {8550,0.17693636}, {8600,0.12563636}, {8650,0.10227273}, {8700,0.11001818}, {8750,0.11110000}, {8800,0.11121818}, {8850,0.11061818}, {8900,0.10824545}, {8950,0.11351818}, {9000,0.11126364}, {9050,0.10450909}, {9100,0.11457273}, {9150,0.11701818}, {9200,0.11666364}, {9250,0.11640000}, {9300,0.11569091}, {9350,0.11661818}, {9400,0.10809091}, {9450,0.11590000}, {9500,0.11973636}, {9550,0.11357273}, {9600,0.11533636}, {9650,0.12064545}, {9700,0.12191818}, {9750,0.11799091}, {9800,0.11478182}, {9850,0.12045455}, {9900,0.12413636}, {9950,0.12436364}, {10000,0.10892727}, {10100,0.14114545}, {10200,0.12635455}, {10300,0.13449091}, {10400,0.13047273}, {10500,0.13621818}, {10600,0.13440000}, {10700,0.13476364}, {10800,0.13064545}, {10900,0.13790909}, {11000,0.13923636}, {11100,0.14480000}, {11200,0.13463636}, {11300,0.13570000}, {11400,0.14418182}, {11500,0.14409091}, {11600,0.14609091}, {11700,0.14975455}, {11800,0.14408182}, {11900,0.14447273}, {12000,0.15292727}, {12100,0.15017273}, {12200,0.15250000}, {12300,0.13881818}, {12400,0.15649091}, {12500,0.16488182}, {12600,0.15753636}, {12700,0.15761818}, {12800,0.15497273}, {12900,0.16270909}, {13000,0.16667273}, {13100,0.15781818}, {13200,0.16473636}, {13300,0.16547273}, {13400,0.16221818}, {13500,0.16177273}, {13600,0.17293636}, {13700,0.17171818}, {13800,0.17332727}, {13900,0.17600909}, {14000,0.17650000}, {14100,0.17813636}, {14200,0.17103636}, {14300,0.52457273}, {14400,0.18355455}, {14500,0.17909091}, {14600,0.17145455}, {14700,0.17987273}, {14800,0.18339091}, {14900,0.17790909}, {15000,0.18018182}, {15100,0.17980000}, {15200,0.18466364}, {15300,0.18219091}, {15400,0.19483636}, {15500,0.18640000}, {15600,0.19013636}, {15700,0.19313636}, {15800,0.19139091}, {15900,0.20340909}, {16000,0.19981818}, {16100,0.19855455}, {16200,0.19898182}, {16300,0.20188182}, {16400,0.20572727}, {16500,0.20825455}, {16600,0.19996364}, {16700,0.19799091}, {16800,0.19947273}, {16900,0.21294545}, {17000,0.21010000}, {17100,0.19732727}, {17200,0.22132727}, {17300,0.18947273}, {17400,0.22039091}, {17500,0.20745455}, {17600,0.21045455}, {17700,0.22080909}, {17800,0.19683636}, {17900,0.21516364}, {18000,0.22795455}, {18100,0.22682727}, {18200,0.22140909}, {18300,0.21920909}, {18400,0.21416364}, {18500,0.21390909}, {18600,0.22067273}, {18700,0.22584545}, {18800,0.23306364}, {18900,0.23760909}, {19000,0.22619091}, {19100,0.22836364}, {19200,0.23355455}, {19300,0.24450909}, {19400,0.23821818}, {19500,0.25505455}, {19600,0.23347273}, {19700,0.24669091}, {19800,0.23532727}, {19900,0.24920000}, {20000,0.23797222}};
data["big_flat"]["TemplateCoq"]["actual reif"]["user"] = {{1,0.00000000}, {2,0.00007207}, {3,0.00002703}, {4,0.00006306}, {5,0.00015315}, {6,0.00022523}, {7,0.00011712}, {8,0.00015315}, {9,0.00018919}, {10,0.00022523}, {11,0.00025225}, {12,0.00018919}, {13,0.00013514}, {14,0.00012613}, {15,0.00029730}, {16,0.00021622}, {17,0.00015315}, {18,0.00015315}, {19,0.00013514}, {20,0.00010811}, {21,0.00022523}, {22,0.00003604}, {23,0.00021622}, {24,0.00014414}, {25,0.00021622}, {26,0.00027027}, {27,0.00021622}, {28,0.00033333}, {29,0.00023423}, {30,0.00020721}, {31,0.00025225}, {32,0.00027027}, {33,0.00025225}, {34,0.00030631}, {35,0.00038739}, {36,0.00047748}, {37,0.00042342}, {38,0.00036036}, {39,0.00038739}, {40,0.00036036}, {41,0.00038739}, {42,0.00033333}, {43,0.00029730}, {44,0.00031532}, {45,0.00045045}, {46,0.00026126}, {47,0.00055856}, {48,0.00051351}, {49,0.00057658}, {50,0.00045946}, {51,0.00063063}, {52,0.00043243}, {53,0.00051351}, {54,0.00062162}, {55,0.00061261}, {56,0.00047748}, {57,0.00036036}, {58,0.00049550}, {59,0.00058559}, {60,0.00045045}, {61,0.00062162}, {62,0.00049550}, {63,0.00055856}, {64,0.00078378}, {65,0.00077477}, {66,0.00050450}, {67,0.00062162}, {68,0.00044144}, {69,0.00048649}, {70,0.00060360}, {71,0.00052252}, {72,0.00071171}, {73,0.00056757}, {74,0.00060360}, {75,0.00068468}, {76,0.00088288}, {77,0.00085586}, {78,0.00081081}, {79,0.00076577}, {80,0.00085586}, {81,0.00081081}, {82,0.00073874}, {83,0.00076577}, {84,0.00071171}, {85,0.00075676}, {86,0.00082883}, {87,0.00079279}, {88,0.00086486}, {89,0.00081081}, {90,0.00074775}, {91,0.00066667}, {92,0.00054955}, {93,0.00059459}, {94,0.00042342}, {95,0.00054054}, {96,0.00056757}, {97,0.00068468}, {98,0.00080180}, {99,0.00100000}, {100,0.00122523}, {101,0.00106306}, {102,0.00093694}, {103,0.00064865}, {104,0.00061261}, {105,0.00068468}, {106,0.00081982}, {107,0.00131532}, {108,0.00167568}, {109,0.00084685}, {110,0.00074775}, {111,0.00109009}, {112,0.00077477}, {113,0.00096396}, {114,0.00085586}, {115,0.00104505}, {116,0.00095495}, {117,0.00080180}, {118,0.00100901}, {119,0.00095495}, {120,0.00114414}, {121,0.00101802}, {122,0.00098198}, {123,0.00087387}, {124,0.00151351}, {125,0.00090090}, {126,0.00127027}, {127,0.00106306}, {128,0.00084685}, {129,0.00131532}, {130,0.00109910}, {131,0.00094595}, {132,0.00124324}, {133,0.00099099}, {134,0.00114414}, {135,0.00110811}, {136,0.00085586}, {137,0.00118018}, {138,0.00124324}, {139,0.00124324}, {140,0.00184685}, {141,0.00116216}, {142,0.00110811}, {143,0.00108108}, {144,0.00107207}, {145,0.00105405}, {146,0.00117117}, {147,0.00121622}, {148,0.00112613}, {149,0.00125225}, {150,0.00139640}, {151,0.00112613}, {152,0.00127928}, {153,0.00099099}, {154,0.00163063}, {155,0.00112613}, {156,0.00134234}, {157,0.00115315}, {158,0.00125225}, {159,0.00142342}, {160,0.00133333}, {161,0.00134234}, {162,0.00125225}, {163,0.00127928}, {164,0.00152252}, {165,0.00135135}, {166,0.00127928}, {167,0.00132432}, {168,0.00137838}, {169,0.00131532}, {170,0.00134234}, {171,0.00128829}, {172,0.00140541}, {173,0.00158559}, {174,0.00150450}, {175,0.00127928}, {176,0.00139640}, {177,0.00158559}, {178,0.00156757}, {179,0.00141441}, {180,0.00122523}, {181,0.00148649}, {182,0.00184685}, {183,0.00195495}, {184,0.00127928}, {185,0.00103604}, {186,0.00145045}, {187,0.00190090}, {188,0.00178378}, {189,0.00166667}, {190,0.00163964}, {191,0.00182883}, {192,0.00154955}, {193,0.00170270}, {194,0.00154955}, {195,0.00142342}, {196,0.00163063}, {197,0.00162162}, {198,0.00159459}, {199,0.00182883}, {200,0.00188288}, {201,0.00172072}, {202,0.00156757}, {203,0.00140541}, {204,0.00153153}, {205,0.00133333}, {206,0.00132432}, {207,0.00136036}, {208,0.00138739}, {209,0.00140541}, {210,0.00136036}, {211,0.00209009}, {212,0.00199099}, {213,0.00210811}, {214,0.00194595}, {215,0.00199099}, {216,0.00183784}, {217,0.00173874}, {218,0.00181081}, {219,0.00176577}, {220,0.00155856}, {221,0.00184685}, {222,0.00199099}, {223,0.00204505}, {224,0.00216216}, {225,0.00220721}, {226,0.00218919}, {227,0.00181081}, {228,0.00166667}, {229,0.00195495}, {230,0.00300000}, {231,0.00192793}, {232,0.00191892}, {233,0.00194595}, {234,0.00209910}, {235,0.00190991}, {236,0.00207207}, {237,0.00159459}, {238,0.00179279}, {239,0.00315315}, {240,0.00189189}, {241,0.00187387}, {242,0.00209009}, {243,0.00217117}, {244,0.00174775}, {245,0.00211712}, {246,0.00219820}, {247,0.00194595}, {248,0.00209009}, {249,0.00230631}, {250,0.00203604}, {251,0.00209009}, {252,0.00218018}, {253,0.00187387}, {254,0.00210811}, {255,0.00216216}, {256,0.00208108}, {257,0.00209910}, {258,0.00231532}, {259,0.00220721}, {260,0.00218018}, {261,0.00219820}, {262,0.00227027}, {263,0.00220721}, {264,0.00243243}, {265,0.00210811}, {266,0.00227928}, {267,0.00215315}, {268,0.00238739}, {269,0.00223423}, {270,0.00240541}, {271,0.00210811}, {272,0.00230631}, {273,0.00214414}, {274,0.00239640}, {275,0.00234234}, {276,0.00227027}, {277,0.00223423}, {278,0.00236937}, {279,0.00245946}, {280,0.00237838}, {281,0.00248649}, {282,0.00223423}, {283,0.00246847}, {284,0.00223423}, {285,0.00275676}, {286,0.00244144}, {287,0.00237838}, {288,0.00248649}, {289,0.00265766}, {290,0.00218018}, {291,0.00259459}, {292,0.00245946}, {293,0.00272072}, {294,0.00280180}, {295,0.00228829}, {296,0.00252252}, {297,0.00233333}, {298,0.00290090}, {299,0.00234234}, {300,0.00245946}, {301,0.00266667}, {302,0.00246847}, {303,0.00274775}, {304,0.00247748}, {305,0.00245946}, {306,0.00257658}, {307,0.00260360}, {308,0.00258559}, {309,0.00263964}, {310,0.00222523}, {311,0.00253153}, {312,0.00294595}, {313,0.00288288}, {314,0.00276577}, {315,0.00265766}, {316,0.00269369}, {317,0.00271171}, {318,0.00250450}, {319,0.00272072}, {320,0.00287387}, {321,0.00284685}, {322,0.00274775}, {323,0.00290991}, {324,0.00254054}, {325,0.00289189}, {326,0.00289189}, {327,0.00284685}, {328,0.00294595}, {329,0.00293694}, {330,0.00372973}, {331,0.00272973}, {332,0.00271171}, {333,0.00288288}, {334,0.00289189}, {335,0.00293694}, {336,0.00266667}, {337,0.00290090}, {338,0.00263964}, {339,0.00263063}, {340,0.00263964}, {341,0.00286486}, {342,0.00279279}, {343,0.00295495}, {344,0.00303604}, {345,0.00288288}, {346,0.00298198}, {347,0.00288288}, {348,0.00313514}, {349,0.00422523}, {350,0.00285586}, {351,0.00309910}, {352,0.00315315}, {353,0.00319820}, {354,0.00302703}, {355,0.00277477}, {356,0.00300901}, {357,0.00336036}, {358,0.00300000}, {359,0.00290090}, {360,0.00302703}, {361,0.00289189}, {362,0.00327027}, {363,0.00295495}, {364,0.00285586}, {365,0.00299099}, {366,0.00307207}, {367,0.00304505}, {368,0.00289189}, {369,0.00332432}, {370,0.00324324}, {371,0.00321622}, {372,0.00330631}, {373,0.00317117}, {374,0.00310811}, {375,0.00323423}, {376,0.00321622}, {377,0.00303604}, {378,0.00310811}, {379,0.00328829}, {380,0.00331532}, {381,0.00320721}, {382,0.00323423}, {383,0.00343243}, {384,0.00309910}, {385,0.00423423}, {386,0.00334234}, {387,0.00329730}, {388,0.00336036}, {389,0.00333333}, {390,0.00326126}, {391,0.00326126}, {392,0.00342342}, {393,0.00333333}, {394,0.00326126}, {395,0.00341441}, {396,0.00459459}, {397,0.00345045}, {398,0.00341441}, {399,0.00327928}, {400,0.00334234}, {401,0.00335135}, {402,0.00334234}, {403,0.00331532}, {404,0.00345946}, {405,0.00346847}, {406,0.00354955}, {407,0.00468468}, {408,0.00345946}, {409,0.00347748}, {410,0.00358559}, {411,0.00351351}, {412,0.00347748}, {413,0.00350450}, {414,0.00342342}, {415,0.00351818}, {416,0.00350000}, {417,0.00341818}, {418,0.00356364}, {419,0.00343636}, {420,0.00360000}, {421,0.00346364}, {422,0.00356364}, {423,0.00494545}, {424,0.00362727}, {425,0.00368182}, {426,0.00358182}, {427,0.00375455}, {428,0.00530000}, {429,0.00374545}, {430,0.00357273}, {431,0.00356364}, {432,0.00371818}, {433,0.00371818}, {434,0.00357273}, {435,0.00367273}, {436,0.00374545}, {437,0.00376364}, {438,0.00387273}, {439,0.00360909}, {440,0.00370000}, {441,0.00385455}, {442,0.00362727}, {443,0.00381818}, {444,0.00383636}, {445,0.00374545}, {446,0.00376364}, {447,0.00373636}, {448,0.00380000}, {449,0.00382727}, {450,0.00397273}, {451,0.00392727}, {452,0.00377273}, {453,0.00389091}, {454,0.00373636}, {455,0.00384545}, {456,0.00382727}, {457,0.00370909}, {458,0.00553636}, {459,0.00401818}, {460,0.00404545}, {461,0.00402727}, {462,0.00394545}, {463,0.00373636}, {464,0.00390000}, {465,0.00381818}, {466,0.00399091}, {467,0.00381818}, {468,0.00384545}, {469,0.00393636}, {470,0.00400909}, {471,0.00409091}, {472,0.00399091}, {473,0.00395455}, {474,0.00397273}, {475,0.00395455}, {476,0.00409091}, {477,0.00521818}, {478,0.00378182}, {479,0.00410000}, {480,0.00410000}, {481,0.00391818}, {482,0.00409091}, {483,0.00380909}, {484,0.00411818}, {485,0.00410909}, {486,0.00604545}, {487,0.00440000}, {488,0.00412727}, {489,0.00410909}, {490,0.00396364}, {491,0.00412727}, {492,0.00428182}, {493,0.00395455}, {494,0.00420000}, {495,0.00434545}, {496,0.00440000}, {497,0.00403636}, {498,0.00410000}, {499,0.00428182}, {500,0.00415455}, {505,0.00439091}, {510,0.00444545}, {515,0.00449091}, {520,0.00598182}, {525,0.00435455}, {530,0.00435455}, {535,0.00479091}, {540,0.00467273}, {545,0.00465455}, {550,0.00426364}, {555,0.00474545}, {560,0.00497273}, {565,0.00457273}, {570,0.00468182}, {575,0.00499091}, {580,0.00696364}, {585,0.00506364}, {590,0.00487273}, {595,0.00499091}, {600,0.00695455}, {605,0.00526364}, {610,0.00516364}, {615,0.00496364}, {620,0.00540000}, {625,0.00516364}, {630,0.00534545}, {635,0.00530000}, {640,0.00540909}, {645,0.00558182}, {650,0.00530000}, {655,0.00535455}, {660,0.00588182}, {665,0.00562727}, {670,0.00781818}, {675,0.00550909}, {680,0.00580000}, {685,0.00575455}, {690,0.00585455}, {695,0.00587273}, {700,0.00590909}, {705,0.00570000}, {710,0.00613636}, {715,0.00628182}, {720,0.00601818}, {725,0.00583636}, {730,0.00619091}, {735,0.00584545}, {740,0.00620000}, {745,0.00629091}, {750,0.00809091}, {755,0.00633636}, {760,0.00631818}, {765,0.00617273}, {770,0.00670909}, {775,0.00652727}, {780,0.00634545}, {785,0.00657273}, {790,0.00674545}, {795,0.00666364}, {800,0.00675455}, {805,0.00686364}, {810,0.00701818}, {815,0.00690909}, {820,0.00701818}, {825,0.00686364}, {830,0.00694545}, {835,0.01004545}, {840,0.00703636}, {845,0.00718182}, {850,0.00720000}, {855,0.00712727}, {860,0.00737273}, {865,0.00736364}, {870,0.00733636}, {875,0.00746364}, {880,0.00765455}, {885,0.00760909}, {890,0.00760909}, {895,0.00793636}, {900,0.01117273}, {905,0.00786364}, {910,0.00780000}, {915,0.00778182}, {920,0.00780909}, {925,0.01551818}, {930,0.00814545}, {935,0.00810000}, {940,0.00808182}, {945,0.00815455}, {950,0.00809091}, {955,0.00806364}, {960,0.01202727}, {965,0.00798182}, {970,0.00856364}, {975,0.00835455}, {980,0.00856364}, {985,0.00883636}, {990,0.00851818}, {995,0.01241818}, {1000,0.00890000}, {1010,0.00880909}, {1020,0.00892727}, {1030,0.00908182}, {1040,0.00914545}, {1050,0.00898182}, {1060,0.00941818}, {1070,0.00964545}, {1080,0.00963636}, {1090,0.00997273}, {1100,0.01334545}, {1110,0.01021818}, {1120,0.01333636}, {1130,0.01016364}, {1140,0.01361818}, {1150,0.00997273}, {1160,0.01396364}, {1170,0.01083636}, {1180,0.01067273}, {1190,0.01094545}, {1200,0.01110909}, {1210,0.01102727}, {1220,0.01098182}, {1230,0.01147273}, {1240,0.01161818}, {1250,0.01164545}, {1260,0.01173636}, {1270,0.01611818}, {1280,0.01192727}, {1290,0.01560000}, {1300,0.01198182}, {1310,0.01214545}, {1320,0.01220000}, {1330,0.01240000}, {1340,0.01637273}, {1350,0.01254545}, {1360,0.01253636}, {1370,0.01243636}, {1380,0.01288182}, {1390,0.02348182}, {1400,0.01302727}, {1410,0.01270909}, {1420,0.01311818}, {1430,0.01308182}, {1440,0.01666364}, {1450,0.01335455}, {1460,0.01331818}, {1470,0.02180000}, {1480,0.01384545}, {1490,0.01357273}, {1500,0.01858182}, {1510,0.01390000}, {1520,0.01420909}, {1530,0.01870000}, {1540,0.01409091}, {1550,0.01432727}, {1560,0.01862727}, {1570,0.01415455}, {1580,0.01449091}, {1590,0.02545455}, {1600,0.01450909}, {1610,0.01472727}, {1620,0.01478182}, {1630,0.01500909}, {1640,0.01495455}, {1650,0.01512727}, {1660,0.02021818}, {1670,0.01543636}, {1680,0.01535455}, {1690,0.01535455}, {1700,0.02093636}, {1710,0.01559091}, {1720,0.01569091}, {1730,0.01597273}, {1740,0.02197273}, {1750,0.01612727}, {1760,0.01617273}, {1770,0.01617273}, {1780,0.02222727}, {1790,0.01622727}, {1800,0.01644545}, {1810,0.01664545}, {1820,0.01659091}, {1830,0.02311818}, {1840,0.01690000}, {1850,0.01695455}, {1860,0.01695455}, {1870,0.01690909}, {1880,0.02430000}, {1890,0.02430000}, {1900,0.01724545}, {1910,0.01740000}, {1920,0.01761818}, {1930,0.01721818}, {1940,0.02409091}, {1950,0.02454545}, {1960,0.01730909}, {1970,0.01749091}, {1980,0.01810909}, {1990,0.01836364}, {2000,0.01814545}, {2050,0.01820909}, {2100,0.02595455}, {2150,0.02687273}, {2200,0.02778182}, {2250,0.02851818}, {2300,0.02943636}, {2350,0.02984545}, {2400,0.03080909}, {2450,0.03080000}, {2500,0.03170000}, {2550,0.02737273}, {2600,0.02438182}, {2650,0.02490909}, {2700,0.02541818}, {2750,0.02614545}, {2800,0.03535455}, {2850,0.02648182}, {2900,0.02692727}, {2950,0.02748182}, {3000,0.03767273}, {3050,0.02889091}, {3100,0.02902727}, {3150,0.03932727}, {3200,0.03002727}, {3250,0.04163636}, {3300,0.03153636}, {3350,0.03183636}, {3400,0.04192727}, {3450,0.03282727}, {3500,0.04375455}, {3550,0.03363636}, {3600,0.03343636}, {3650,0.05405455}, {3700,0.03509091}, {3750,0.04649091}, {3800,0.03669091}, {3850,0.03668182}, {3900,0.04835455}, {3950,0.05405455}, {4000,0.03800909}, {4050,0.04725455}, {4100,0.07139091}, {4150,0.05199091}, {4200,0.03979091}, {4250,0.04017273}, {4300,0.03884545}, {4350,0.05339091}, {4400,0.07734545}, {4450,0.07146364}, {4500,0.06590909}, {4550,0.06297273}, {4600,0.06139091}, {4650,0.06207273}, {4700,0.06411818}, {4750,0.06899091}, {4800,0.07577273}, {4850,0.08451818}, {4900,0.05591818}, {4950,0.04755455}, {5000,0.04804545}, {5050,0.06553636}, {5100,0.06520000}, {5150,0.08600909}, {5200,0.04952727}, {5250,0.07042727}, {5300,0.06756364}, {5350,0.08900909}, {5400,0.06647273}, {5450,0.07165455}, {5500,0.05163636}, {5550,0.07175455}, {5600,0.08427273}, {5650,0.07003636}, {5700,0.07657273}, {5750,0.05561818}, {5800,0.08327273}, {5850,0.07884545}, {5900,0.07990000}, {5950,0.07476364}, {6000,0.08688182}, {6050,0.08304545}, {6100,0.07542727}, {6150,0.08916364}, {6200,0.08017273}, {6250,0.07780000}, {6300,0.08891818}, {6350,0.08145455}, {6400,0.08176364}, {6450,0.07955455}, {6500,0.06324545}, {6550,0.09014545}, {6600,0.08808182}, {6650,0.08578182}, {6700,0.08687273}, {6750,0.08796364}, {6800,0.08343636}, {6850,0.08470909}, {6900,0.08595455}, {6950,0.08658182}, {7000,0.08681818}, {7050,0.08825455}, {7100,0.08385455}, {7150,0.09110909}, {7200,0.09090000}, {7250,0.09040000}, {7300,0.08756364}, {7350,0.09472727}, {7400,0.09157273}, {7450,0.09551818}, {7500,0.09533636}, {7550,0.09220000}, {7600,0.09428182}, {7650,0.09883636}, {7700,0.08772727}, {7750,0.09575455}, {7800,0.09999091}, {7850,0.09803636}, {7900,0.10120909}, {7950,0.09368182}, {8000,0.09840000}, {8050,0.09911818}, {8100,0.09984545}, {8150,0.09730909}, {8200,0.09991818}, {8250,0.09212727}, {8300,0.10508182}, {8350,0.10729091}, {8400,0.10730000}, {8450,0.10694545}, {8500,0.10912727}, {8550,0.17708182}, {8600,0.12576364}, {8650,0.10223636}, {8700,0.11010000}, {8750,0.11101818}, {8800,0.11119091}, {8850,0.11075455}, {8900,0.10799091}, {8950,0.11340000}, {9000,0.11088182}, {9050,0.10467273}, {9100,0.11421818}, {9150,0.11712727}, {9200,0.11640909}, {9250,0.11656364}, {9300,0.11572727}, {9350,0.11663636}, {9400,0.10819091}, {9450,0.11599091}, {9500,0.11957273}, {9550,0.11347273}, {9600,0.11494545}, {9650,0.12065455}, {9700,0.12185455}, {9750,0.11818182}, {9800,0.11431818}, {9850,0.12035455}, {9900,0.12451818}, {9950,0.12459091}, {10000,0.10854545}, {10100,0.14102727}, {10200,0.12634545}, {10300,0.13497273}, {10400,0.13049091}, {10500,0.13656364}, {10600,0.13458182}, {10700,0.13484545}, {10800,0.13060000}, {10900,0.13824545}, {11000,0.13943636}, {11100,0.14459091}, {11200,0.13493636}, {11300,0.13598182}, {11400,0.14387273}, {11500,0.14394545}, {11600,0.14615455}, {11700,0.14951818}, {11800,0.14380909}, {11900,0.14403636}, {12000,0.15240000}, {12100,0.15002727}, {12200,0.15220909}, {12300,0.13843636}, {12400,0.15624545}, {12500,0.16458182}, {12600,0.15769091}, {12700,0.15780909}, {12800,0.15495455}, {12900,0.16295455}, {13000,0.16679091}, {13100,0.15784545}, {13200,0.16464545}, {13300,0.16500909}, {13400,0.16201818}, {13500,0.16155455}, {13600,0.17228182}, {13700,0.17138182}, {13800,0.17292727}, {13900,0.17618182}, {14000,0.17648182}, {14100,0.17776364}, {14200,0.17111818}, {14300,0.52280000}, {14400,0.18380000}, {14500,0.17893636}, {14600,0.17154545}, {14700,0.17976364}, {14800,0.18324545}, {14900,0.17768182}, {15000,0.18016364}, {15100,0.17960909}, {15200,0.18469091}, {15300,0.18185455}, {15400,0.19462727}, {15500,0.18646364}, {15600,0.18991818}, {15700,0.19321818}, {15800,0.19136364}, {15900,0.20342727}, {16000,0.19956364}, {16100,0.19837273}, {16200,0.19899091}, {16300,0.20131818}, {16400,0.20566364}, {16500,0.20802727}, {16600,0.19978182}, {16700,0.19768182}, {16800,0.19938182}, {16900,0.21271818}, {17000,0.20990909}, {17100,0.19696364}, {17200,0.22099091}, {17300,0.18920909}, {17400,0.21995455}, {17500,0.20767273}, {17600,0.21055455}, {17700,0.22067273}, {17800,0.19685455}, {17900,0.21501818}, {18000,0.22756364}, {18100,0.22672727}, {18200,0.22129091}, {18300,0.21899091}, {18400,0.21380909}, {18500,0.21378182}, {18600,0.22044545}, {18700,0.22563636}, {18800,0.23299091}, {18900,0.23733636}, {19000,0.22629091}, {19100,0.22813636}, {19200,0.23330909}, {19300,0.24410000}, {19400,0.23803636}, {19500,0.25502727}, {19600,0.23348182}, {19700,0.24665455}, {19800,0.23524545}, {19900,0.24935455}, {20000,0.23786111}};
data["big_flat"]["TemplateCoq"]["actual reif"]["system"] = {{1,0.00007273}, {2,0.00003604}, {3,0.00003604}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00003604}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00003604}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00003604}, {27,0.00000000}, {28,0.00003604}, {29,0.00000000}, {30,0.00000000}, {31,0.00003604}, {32,0.00000000}, {33,0.00003604}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00003604}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00003604}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00007207}, {49,0.00000000}, {50,0.00000000}, {51,0.00003604}, {52,0.00000000}, {53,0.00000000}, {54,0.00003604}, {55,0.00000000}, {56,0.00003604}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00003604}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00003604}, {67,0.00002703}, {68,0.00003604}, {69,0.00000000}, {70,0.00003604}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00002703}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00003604}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00007207}, {100,0.00000000}, {101,0.00002703}, {102,0.00000000}, {103,0.00000000}, {104,0.00003604}, {105,0.00000000}, {106,0.00000000}, {107,0.00003604}, {108,0.00000000}, {109,0.00000000}, {110,0.00007207}, {111,0.00000000}, {112,0.00006306}, {113,0.00000000}, {114,0.00000000}, {115,0.00003604}, {116,0.00000000}, {117,0.00003604}, {118,0.00003604}, {119,0.00000000}, {120,0.00003604}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00007207}, {128,0.00003604}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00003604}, {135,0.00000000}, {136,0.00007207}, {137,0.00002703}, {138,0.00000000}, {139,0.00000000}, {140,0.00002703}, {141,0.00000000}, {142,0.00003604}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00002703}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00003604}, {156,0.00003604}, {157,0.00000000}, {158,0.00003604}, {159,0.00000000}, {160,0.00000000}, {161,0.00003604}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00003604}, {168,0.00003604}, {169,0.00007207}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00003604}, {174,0.00003604}, {175,0.00000000}, {176,0.00003604}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00006306}, {185,0.00000000}, {186,0.00000000}, {187,0.00003604}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00003604}, {194,0.00000000}, {195,0.00000000}, {196,0.00002703}, {197,0.00000000}, {198,0.00003604}, {199,0.00000000}, {200,0.00003604}, {201,0.00000000}, {202,0.00002703}, {203,0.00003604}, {204,0.00003604}, {205,0.00000000}, {206,0.00002703}, {207,0.00003604}, {208,0.00006306}, {209,0.00003604}, {210,0.00003604}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00003604}, {218,0.00000000}, {219,0.00003604}, {220,0.00000000}, {221,0.00000000}, {222,0.00007207}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00003604}, {230,0.00000000}, {231,0.00003604}, {232,0.00000000}, {233,0.00007207}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00010811}, {238,0.00003604}, {239,0.00003604}, {240,0.00000000}, {241,0.00002703}, {242,0.00000000}, {243,0.00003604}, {244,0.00007207}, {245,0.00003604}, {246,0.00007207}, {247,0.00000000}, {248,0.00003604}, {249,0.00000000}, {250,0.00003604}, {251,0.00000000}, {252,0.00000000}, {253,0.00007207}, {254,0.00000000}, {255,0.00003604}, {256,0.00003604}, {257,0.00000000}, {258,0.00003604}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00003604}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00003604}, {269,0.00000000}, {270,0.00003604}, {271,0.00000000}, {272,0.00009910}, {273,0.00003604}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00002703}, {278,0.00003604}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00002703}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00003604}, {289,0.00003604}, {290,0.00003604}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00003604}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00010811}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00002703}, {307,0.00003604}, {308,0.00000000}, {309,0.00000000}, {310,0.00003604}, {311,0.00007207}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00003604}, {318,0.00003604}, {319,0.00003604}, {320,0.00000000}, {321,0.00000000}, {322,0.00003604}, {323,0.00003604}, {324,0.00003604}, {325,0.00000000}, {326,0.00003604}, {327,0.00003604}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00003604}, {332,0.00000000}, {333,0.00003604}, {334,0.00002703}, {335,0.00000000}, {336,0.00003604}, {337,0.00000000}, {338,0.00003604}, {339,0.00002703}, {340,0.00003604}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00003604}, {347,0.00000000}, {348,0.00000000}, {349,0.00003604}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00003604}, {355,0.00000000}, {356,0.00003604}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00003604}, {361,0.00006306}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00003604}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00003604}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00003604}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00003604}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00003604}, {392,0.00003604}, {393,0.00000000}, {394,0.00003604}, {395,0.00007207}, {396,0.00003604}, {397,0.00000000}, {398,0.00000000}, {399,0.00003604}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00003604}, {404,0.00000000}, {405,0.00003604}, {406,0.00000000}, {407,0.00003604}, {408,0.00003604}, {409,0.00000000}, {410,0.00003604}, {411,0.00002703}, {412,0.00003604}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00003636}, {417,0.00003636}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00014545}, {424,0.00000000}, {425,0.00000000}, {426,0.00003636}, {427,0.00000000}, {428,0.00007273}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00007273}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00003636}, {440,0.00003636}, {441,0.00000000}, {442,0.00000000}, {443,0.00003636}, {444,0.00003636}, {445,0.00000000}, {446,0.00003636}, {447,0.00007273}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00003636}, {456,0.00007273}, {457,0.00000000}, {458,0.00013636}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00003636}, {468,0.00000000}, {469,0.00007273}, {470,0.00003636}, {471,0.00000000}, {472,0.00000000}, {473,0.00003636}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00007273}, {478,0.00000000}, {479,0.00000000}, {480,0.00010909}, {481,0.00000000}, {482,0.00000000}, {483,0.00003636}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00003636}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00003636}, {498,0.00003636}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00010909}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00003636}, {550,0.00000000}, {555,0.00002727}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00003636}, {595,0.00000000}, {600,0.00010909}, {605,0.00000000}, {610,0.00000000}, {615,0.00003636}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00003636}, {640,0.00003636}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00003636}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00003636}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00003636}, {710,0.00003636}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00003636}, {750,0.00002727}, {755,0.00000000}, {760,0.00000000}, {765,0.00003636}, {770,0.00007273}, {775,0.00000000}, {780,0.00000000}, {785,0.00002727}, {790,0.00003636}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00007273}, {830,0.00000000}, {835,0.00006364}, {840,0.00003636}, {845,0.00000000}, {850,0.00000000}, {855,0.00002727}, {860,0.00007273}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00003636}, {905,0.00003636}, {910,0.00002727}, {915,0.00000000}, {920,0.00000000}, {925,0.00021818}, {930,0.00000000}, {935,0.00003636}, {940,0.00003636}, {945,0.00000000}, {950,0.00003636}, {955,0.00000000}, {960,0.00007273}, {965,0.00000000}, {970,0.00000000}, {975,0.00006364}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00013636}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00003636}, {1090,0.00003636}, {1100,0.00014545}, {1110,0.00003636}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00003636}, {1150,0.00000000}, {1160,0.00007273}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00003636}, {1220,0.00003636}, {1230,0.00003636}, {1240,0.00000000}, {1250,0.00007273}, {1260,0.00000000}, {1270,0.00002727}, {1280,0.00000000}, {1290,0.00016364}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00003636}, {1330,0.00000000}, {1340,0.00006364}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00003636}, {1390,0.00032727}, {1400,0.00000000}, {1410,0.00014545}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00017273}, {1450,0.00003636}, {1460,0.00000000}, {1470,0.00025455}, {1480,0.00003636}, {1490,0.00007273}, {1500,0.00006364}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00010909}, {1540,0.00007273}, {1550,0.00000000}, {1560,0.00018182}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00021818}, {1600,0.00000000}, {1610,0.00003636}, {1620,0.00007273}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00007273}, {1660,0.00024545}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00003636}, {1700,0.00024545}, {1710,0.00000000}, {1720,0.00002727}, {1730,0.00000000}, {1740,0.00014545}, {1750,0.00003636}, {1760,0.00000000}, {1770,0.00003636}, {1780,0.00006364}, {1790,0.00000000}, {1800,0.00003636}, {1810,0.00000000}, {1820,0.00007273}, {1830,0.00029091}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00003636}, {1870,0.00006364}, {1880,0.00010909}, {1890,0.00013636}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00003636}, {1930,0.00000000}, {1940,0.00014545}, {1950,0.00010000}, {1960,0.00000000}, {1970,0.00003636}, {1980,0.00000000}, {1990,0.00006364}, {2000,0.00000000}, {2050,0.00003636}, {2100,0.00010909}, {2150,0.00014545}, {2200,0.00018182}, {2250,0.00021818}, {2300,0.00020909}, {2350,0.00020909}, {2400,0.00021818}, {2450,0.00020909}, {2500,0.00018182}, {2550,0.00007273}, {2600,0.00000000}, {2650,0.00003636}, {2700,0.00000000}, {2750,0.00007273}, {2800,0.00014545}, {2850,0.00000000}, {2900,0.00003636}, {2950,0.00003636}, {3000,0.00032727}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00029091}, {3200,0.00007273}, {3250,0.00007273}, {3300,0.00007273}, {3350,0.00000000}, {3400,0.00020909}, {3450,0.00000000}, {3500,0.00035455}, {3550,0.00003636}, {3600,0.00002727}, {3650,0.00053636}, {3700,0.00000000}, {3750,0.00036364}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00025455}, {3950,0.00039091}, {4000,0.00000000}, {4050,0.00025455}, {4100,0.00072727}, {4150,0.00041818}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00030909}, {4400,0.00096364}, {4450,0.00056364}, {4500,0.00036364}, {4550,0.00017273}, {4600,0.00021818}, {4650,0.00040000}, {4700,0.00046364}, {4750,0.00058182}, {4800,0.00055455}, {4850,0.00075455}, {4900,0.00010909}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00028182}, {5100,0.00040000}, {5150,0.00091818}, {5200,0.00003636}, {5250,0.00049091}, {5300,0.00040000}, {5350,0.00082727}, {5400,0.00036364}, {5450,0.00025455}, {5500,0.00003636}, {5550,0.00034545}, {5600,0.00003636}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00003636}, {5850,0.00003636}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00003636}, {6050,0.00010909}, {6100,0.00039091}, {6150,0.00049091}, {6200,0.00035455}, {6250,0.00029091}, {6300,0.00087273}, {6350,0.00024545}, {6400,0.00057273}, {6450,0.00043636}, {6500,0.00010909}, {6550,0.00068182}, {6600,0.00071818}, {6650,0.00044545}, {6700,0.00031818}, {6750,0.00063636}, {6800,0.00047273}, {6850,0.00043636}, {6900,0.00040000}, {6950,0.00038182}, {7000,0.00038182}, {7050,0.00039091}, {7100,0.00054545}, {7150,0.00036364}, {7200,0.00050909}, {7250,0.00039091}, {7300,0.00044545}, {7350,0.00058182}, {7400,0.00061818}, {7450,0.00039091}, {7500,0.00028182}, {7550,0.00000000}, {7600,0.00007273}, {7650,0.00010000}, {7700,0.00002727}, {7750,0.00003636}, {7800,0.00003636}, {7850,0.00010909}, {7900,0.00014545}, {7950,0.00002727}, {8000,0.00006364}, {8050,0.00003636}, {8100,0.00000000}, {8150,0.00003636}, {8200,0.00003636}, {8250,0.00003636}, {8300,0.00007273}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00007273}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00007273}, {8700,0.00000000}, {8750,0.00007273}, {8800,0.00000000}, {8850,0.00007273}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00006364}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00014545}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00003636}, {9550,0.00003636}, {9600,0.00003636}, {9650,0.00003636}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00003636}, {9850,0.00003636}, {9900,0.00000000}, {9950,0.00002727}, {10000,0.00003636}, {10100,0.00003636}, {10200,0.00007273}, {10300,0.00002727}, {10400,0.00007273}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00007273}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00007273}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00074545}, {11800,0.00041818}, {11900,0.00049091}, {12000,0.00043636}, {12100,0.00053636}, {12200,0.00036364}, {12300,0.00029091}, {12400,0.00048182}, {12500,0.00003636}, {12600,0.00007273}, {12700,0.00010909}, {12800,0.00007273}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00007273}, {13300,0.00043636}, {13400,0.00013636}, {13500,0.00018182}, {13600,0.00036364}, {13700,0.00032727}, {13800,0.00039091}, {13900,0.00010909}, {14000,0.00007273}, {14100,0.00010909}, {14200,0.00007273}, {14300,0.00129091}, {14400,0.00003636}, {14500,0.00000000}, {14600,0.00007273}, {14700,0.00006364}, {14800,0.00018182}, {14900,0.00010909}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00018182}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00003636}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00010909}, {16400,0.00003636}, {16500,0.00003636}, {16600,0.00003636}, {16700,0.00003636}, {16800,0.00003636}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00003636}, {17300,0.00003636}, {17400,0.00014545}, {17500,0.00007273}, {17600,0.00007273}, {17700,0.00010909}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00014545}, {18100,0.00010909}, {18200,0.00007273}, {18300,0.00000000}, {18400,0.00003636}, {18500,0.00000000}, {18600,0.00007273}, {18700,0.00000000}, {18800,0.00010909}, {18900,0.00006364}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00003636}, {19600,0.00000000}, {19700,0.00003636}, {19800,0.00003636}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["TemplateCoq"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00001802}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00001802}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00098198}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000901}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00098198}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00001802}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00294595}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00001802}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000901}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00001802}, {415,0.00001802}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000909}, {420,0.00000000}, {421,0.00000909}, {422,0.00000909}, {423,0.00003636}, {424,0.00003636}, {425,0.00000000}, {426,0.00003636}, {427,0.00006364}, {428,0.00005455}, {429,0.00001818}, {430,0.00003636}, {431,0.00008182}, {432,0.00010000}, {433,0.00010000}, {434,0.00005455}, {435,0.00013636}, {436,0.00006364}, {437,0.00017273}, {438,0.00014545}, {439,0.00019091}, {440,0.00022727}, {441,0.00020909}, {442,0.00026364}, {443,0.00029091}, {444,0.00045455}, {445,0.00040909}, {446,0.00040909}, {447,0.00044545}, {448,0.00050909}, {449,0.00047273}, {450,0.00061818}, {451,0.00062727}, {452,0.00064545}, {453,0.00071818}, {454,0.00075455}, {455,0.00075455}, {456,0.00078182}, {457,0.00076364}, {458,0.00080000}, {459,0.00081818}, {460,0.00083636}, {461,0.00082727}, {462,0.00081818}, {463,0.00186364}, {464,0.00085455}, {465,0.00082727}, {466,0.00090000}, {467,0.00085455}, {468,0.00088182}, {469,0.00089091}, {470,0.00089091}, {471,0.00094545}, {472,0.00095455}, {473,0.00090000}, {474,0.00095455}, {475,0.00098182}, {476,0.00094545}, {477,0.00094545}, {478,0.00097273}, {479,0.00096364}, {480,0.00098182}, {481,0.00098182}, {482,0.00100000}, {483,0.00100000}, {484,0.00099091}, {485,0.00100000}, {486,0.00099091}, {487,0.00100000}, {488,0.00100000}, {489,0.00099091}, {490,0.00100000}, {491,0.00099091}, {492,0.00099091}, {493,0.00100000}, {494,0.00100000}, {495,0.00100000}, {496,0.00100000}, {497,0.00100000}, {498,0.00100000}, {499,0.00100000}, {500,0.00100000}, {505,0.00100000}, {510,0.00100000}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00100000}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00109091}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00296364}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00295455}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100909}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00101818}, {815,0.00100909}, {820,0.00100909}, {825,0.00100909}, {830,0.00100909}, {835,0.00101818}, {840,0.00100909}, {845,0.00106364}, {850,0.00106364}, {855,0.00107273}, {860,0.00111818}, {865,0.00119091}, {870,0.00125455}, {875,0.00297273}, {880,0.00147273}, {885,0.00153636}, {890,0.00160909}, {895,0.00172727}, {900,0.00172727}, {905,0.00180000}, {910,0.00180000}, {915,0.00182727}, {920,0.00185455}, {925,0.00193636}, {930,0.00193636}, {935,0.00198182}, {940,0.00198182}, {945,0.00198182}, {950,0.00200000}, {955,0.00200000}, {960,0.00200000}, {965,0.00200000}, {970,0.00199091}, {975,0.00200000}, {980,0.00200000}, {985,0.00200000}, {990,0.00200000}, {995,0.00200000}, {1000,0.00200000}, {1010,0.00200000}, {1020,0.00200000}, {1030,0.00200000}, {1040,0.00200000}, {1050,0.00200000}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00356364}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00202727}, {1130,0.00200000}, {1140,0.00207273}, {1150,0.00200000}, {1160,0.00206364}, {1170,0.00200000}, {1180,0.00373636}, {1190,0.00200000}, {1200,0.00200000}, {1210,0.00200909}, {1220,0.00202727}, {1230,0.00200909}, {1240,0.00202727}, {1250,0.00202727}, {1260,0.00207273}, {1270,0.00219091}, {1280,0.00224545}, {1290,0.00237273}, {1300,0.00253636}, {1310,0.00267273}, {1320,0.00273636}, {1330,0.00276364}, {1340,0.00280000}, {1350,0.00283636}, {1360,0.00387273}, {1370,0.00292727}, {1380,0.00294545}, {1390,0.00297273}, {1400,0.00299091}, {1410,0.00300000}, {1420,0.00300000}, {1430,0.00300000}, {1440,0.00307273}, {1450,0.00300000}, {1460,0.00300000}, {1470,0.00300000}, {1480,0.00300000}, {1490,0.00300000}, {1500,0.00300000}, {1510,0.00300000}, {1520,0.00300000}, {1530,0.00300000}, {1540,0.00300000}, {1550,0.00300000}, {1560,0.00300909}, {1570,0.00300909}, {1580,0.00300909}, {1590,0.00300909}, {1600,0.00301818}, {1610,0.00300909}, {1620,0.00967273}, {1630,0.00302727}, {1640,0.00307273}, {1650,0.00310000}, {1660,0.00308182}, {1670,0.00317273}, {1680,0.00328182}, {1690,0.00333636}, {1700,0.00340909}, {1710,0.00351818}, {1720,0.00352727}, {1730,0.00363636}, {1740,0.00373636}, {1750,0.00380909}, {1760,0.00381818}, {1770,0.00383636}, {1780,0.00382727}, {1790,0.00392727}, {1800,0.00394545}, {1810,0.00395455}, {1820,0.00397273}, {1830,0.00400000}, {1840,0.00400000}, {1850,0.00400000}, {1860,0.00400000}, {1870,0.00400000}, {1880,0.00405455}, {1890,0.00400000}, {1900,0.00400000}, {1910,0.00400000}, {1920,0.00400909}, {1930,0.00400000}, {1940,0.00408182}, {1950,0.00401818}, {1960,0.00400000}, {1970,0.00400000}, {1980,0.00400000}, {1990,0.00402727}, {2000,0.00404545}, {2050,0.00428182}, {2100,0.00441818}, {2150,0.00475455}, {2200,0.00492727}, {2250,0.00500000}, {2300,0.00500000}, {2350,0.00502727}, {2400,0.00510909}, {2450,0.00524545}, {2500,0.00558182}, {2550,0.00589091}, {2600,0.00587273}, {2650,0.00599091}, {2700,0.00604545}, {2750,0.00605455}, {2800,0.00625455}, {2850,0.01117273}, {2900,0.00661818}, {2950,0.00680000}, {3000,0.00690000}, {3050,0.00698182}, {3100,0.00704545}, {3150,0.00715455}, {3200,0.00727273}, {3250,0.00757273}, {3300,0.01407273}, {3350,0.00780909}, {3400,0.00790909}, {3450,0.00799091}, {3500,0.00810909}, {3550,0.00830000}, {3600,0.01402727}, {3650,0.00861818}, {3700,0.00871818}, {3750,0.00888182}, {3800,0.00899091}, {3850,0.01635455}, {3900,0.00919091}, {3950,0.00943636}, {4000,0.00950909}, {4050,0.00979091}, {4100,0.00981818}, {4150,0.00997273}, {4200,0.01002727}, {4250,0.00991818}, {4300,0.01056364}, {4350,0.01054545}, {4400,0.01070000}, {4450,0.01072727}, {4500,0.01085455}, {4550,0.01104545}, {4600,0.01114545}, {4650,0.01136364}, {4700,0.01150909}, {4750,0.01169091}, {4800,0.01170000}, {4850,0.01182727}, {4900,0.01206364}, {4950,0.02528182}, {5000,0.01226364}, {5050,0.01245455}, {5100,0.01261818}, {5150,0.01276364}, {5200,0.02659091}, {5250,0.01288182}, {5300,0.01305455}, {5350,0.01329091}, {5400,0.01343636}, {5450,0.01358182}, {5500,0.05282727}, {5550,0.01380909}, {5600,0.01388182}, {5650,0.01396364}, {5700,0.01421818}, {5750,0.01431818}, {5800,0.01454545}, {5850,0.01460909}, {5900,0.01477273}, {5950,0.01484545}, {6000,0.01564545}, {6050,0.01516364}, {6100,0.03030000}, {6150,0.01545455}, {6200,0.01556364}, {6250,0.01568182}, {6300,0.01645455}, {6350,0.01600000}, {6400,0.01602727}, {6450,0.01620000}, {6500,0.05759091}, {6550,0.01656364}, {6600,0.01668182}, {6650,0.01688182}, {6700,0.01695455}, {6750,0.01704545}, {6800,0.01714545}, {6850,0.01732727}, {6900,0.01751818}, {6950,0.01764545}, {7000,0.01779091}, {7050,0.01793636}, {7100,0.01795455}, {7150,0.01810909}, {7200,0.01834545}, {7250,0.01850000}, {7300,0.01902727}, {7350,0.06194545}, {7400,0.01881818}, {7450,0.01914545}, {7500,0.01911818}, {7550,0.04419091}, {7600,0.01948182}, {7650,0.01959091}, {7700,0.02007273}, {7750,0.01988182}, {7800,0.02000909}, {7850,0.04956364}, {7900,0.02023636}, {7950,0.02039091}, {8000,0.02055455}, {8050,0.02073636}, {8100,0.02096364}, {8150,0.02099091}, {8200,0.02113636}, {8250,0.02331818}, {8300,0.02137273}, {8350,0.05573636}, {8400,0.02173636}, {8450,0.02181818}, {8500,0.05467273}, {8550,0.02205455}, {8600,0.02226364}, {8650,0.02235455}, {8700,0.04886364}, {8750,0.02251818}, {8800,0.02270000}, {8850,0.02285455}, {8900,0.02297273}, {8950,0.05264545}, {9000,0.04580000}, {9050,0.03977273}, {9100,0.02388182}, {9150,0.02368182}, {9200,0.02390000}, {9250,0.02398182}, {9300,0.02410909}, {9350,0.02438182}, {9400,0.03367273}, {9450,0.05035455}, {9500,0.04968182}, {9550,0.02491818}, {9600,0.02510909}, {9650,0.02516364}, {9700,0.02530000}, {9750,0.04756364}, {9800,0.04526364}, {9850,0.02566364}, {9900,0.02589091}, {9950,0.05460000}, {10000,0.02622727}, {10100,0.02650000}, {10200,0.04652727}, {10300,0.02695455}, {10400,0.05910000}, {10500,0.02747273}, {10600,0.05614545}, {10700,0.02807273}, {10800,0.02838182}, {10900,0.05965455}, {11000,0.02923636}, {11100,0.02919091}, {11200,0.02960000}, {11300,0.02977273}, {11400,0.05134545}, {11500,0.05941818}, {11600,0.05827273}, {11700,0.04677273}, {11800,0.03127273}, {11900,0.03142727}, {12000,0.03167273}, {12100,0.03216364}, {12200,0.06511818}, {12300,0.03250000}, {12400,0.03289091}, {12500,0.06733636}, {12600,0.03339091}, {12700,0.06658182}, {12800,0.03400909}, {12900,0.06506364}, {13000,0.03436364}, {13100,0.03476364}, {13200,0.07038182}, {13300,0.03549091}, {13400,0.03566364}, {13500,0.03584545}, {13600,0.04839091}, {13700,0.06113636}, {13800,0.06866364}, {13900,0.06915455}, {14000,0.06320909}, {14100,0.05336364}, {14200,0.03780000}, {14300,0.03806364}, {14400,0.03832727}, {14500,0.07550000}, {14600,0.03720000}, {14700,0.03920909}, {14800,0.07923636}, {14900,0.03980000}, {15000,0.06968182}, {15100,0.04034545}, {15200,0.07766364}, {15300,0.04093636}, {15400,0.06143636}, {15500,0.07502727}, {15600,0.04184545}, {15700,0.04214545}, {15800,0.06216364}, {15900,0.07529091}, {16000,0.08956364}, {16100,0.08330909}, {16200,0.08206364}, {16300,0.08653636}, {16400,0.08345455}, {16500,0.07117273}, {16600,0.04467273}, {16700,0.04511818}, {16800,0.07835455}, {16900,0.08229091}, {17000,0.04593636}, {17100,0.08634545}, {17200,0.06673636}, {17300,0.07028182}, {17400,0.06873636}, {17500,0.07497273}, {17600,0.04769091}, {17700,0.09279091}, {17800,0.06690909}, {17900,0.04859091}, {18000,0.07100909}, {18100,0.09543636}, {18200,0.10075455}, {18300,0.07898182}, {18400,0.06463636}, {18500,0.06398182}, {18600,0.07973636}, {18700,0.09033636}, {18800,0.11481818}, {18900,0.08907273}, {19000,0.05048182}, {19100,0.05200000}, {19200,0.09724545}, {19300,0.07944545}, {19400,0.05278182}, {19500,0.09500000}, {19600,0.05324545}, {19700,0.12229091}, {19800,0.05372727}, {19900,0.08613636}, {20000,0.08194444}};
data["big_flat"]["TemplateCoq"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00003604}, {5,0.00000000}, {6,0.00013514}, {7,0.00000000}, {8,0.00003604}, {9,0.00000000}, {10,0.00000000}, {11,0.00003604}, {12,0.00003604}, {13,0.00002703}, {14,0.00002703}, {15,0.00002703}, {16,0.00007207}, {17,0.00000000}, {18,0.00003604}, {19,0.00006306}, {20,0.00007207}, {21,0.00009910}, {22,0.00015315}, {23,0.00006306}, {24,0.00003604}, {25,0.00011712}, {26,0.00000000}, {27,0.00003604}, {28,0.00003604}, {29,0.00010811}, {30,0.00003604}, {31,0.00014414}, {32,0.00006306}, {33,0.00009910}, {34,0.00012613}, {35,0.00002703}, {36,0.00018018}, {37,0.00018919}, {38,0.00012613}, {39,0.00006306}, {40,0.00003604}, {41,0.00009009}, {42,0.00016216}, {43,0.00012613}, {44,0.00012613}, {45,0.00016216}, {46,0.00009009}, {47,0.00013514}, {48,0.00003604}, {49,0.00011712}, {50,0.00011712}, {51,0.00002703}, {52,0.00011712}, {53,0.00009009}, {54,0.00007207}, {55,0.00017117}, {56,0.00017117}, {57,0.00017117}, {58,0.00020721}, {59,0.00009009}, {60,0.00019820}, {61,0.00003604}, {62,0.00000000}, {63,0.00018919}, {64,0.00023423}, {65,0.00017117}, {66,0.00009009}, {67,0.00011712}, {68,0.00018919}, {69,0.00016216}, {70,0.00022523}, {71,0.00026126}, {72,0.00013514}, {73,0.00012613}, {74,0.00019820}, {75,0.00022523}, {76,0.00015315}, {77,0.00018919}, {78,0.00009009}, {79,0.00016216}, {80,0.00020721}, {81,0.00012613}, {82,0.00009910}, {83,0.00012613}, {84,0.00009910}, {85,0.00013514}, {86,0.00018018}, {87,0.00014414}, {88,0.00019820}, {89,0.00017117}, {90,0.00032432}, {91,0.00026126}, {92,0.00020721}, {93,0.00036937}, {94,0.00034234}, {95,0.00012613}, {96,0.00015315}, {97,0.00007207}, {98,0.00025225}, {99,0.00009910}, {100,0.00027928}, {101,0.00016216}, {102,0.00033333}, {103,0.00027928}, {104,0.00022523}, {105,0.00009910}, {106,0.00014414}, {107,0.00017117}, {108,0.00036937}, {109,0.00016216}, {110,0.00020721}, {111,0.00013514}, {112,0.00034234}, {113,0.00037838}, {114,0.00018919}, {115,0.00025225}, {116,0.00026126}, {117,0.00023423}, {118,0.00022523}, {119,0.00022523}, {120,0.00016216}, {121,0.00027027}, {122,0.00012613}, {123,0.00025225}, {124,0.00025225}, {125,0.00028829}, {126,0.00021622}, {127,0.00054955}, {128,0.00011712}, {129,0.00027928}, {130,0.00040541}, {131,0.00012613}, {132,0.00017117}, {133,0.00033333}, {134,0.00018018}, {135,0.00033333}, {136,0.00033333}, {137,0.00034234}, {138,0.00018919}, {139,0.00019820}, {140,0.00047748}, {141,0.00037838}, {142,0.00032432}, {143,0.00036036}, {144,0.00023423}, {145,0.00034234}, {146,0.00025225}, {147,0.00036036}, {148,0.00018018}, {149,0.00038739}, {150,0.00027027}, {151,0.00027928}, {152,0.00022523}, {153,0.00018919}, {154,0.00027027}, {155,0.00027928}, {156,0.00040541}, {157,0.00044144}, {158,0.00036937}, {159,0.00038739}, {160,0.00024324}, {161,0.00040541}, {162,0.00040541}, {163,0.00037838}, {164,0.00024324}, {165,0.00023423}, {166,0.00038739}, {167,0.00043243}, {168,0.00043243}, {169,0.00040541}, {170,0.00034234}, {171,0.00040541}, {172,0.00025225}, {173,0.00030631}, {174,0.00023423}, {175,0.00028829}, {176,0.00034234}, {177,0.00032432}, {178,0.00022523}, {179,0.00039640}, {180,0.00016216}, {181,0.00062162}, {182,0.00026126}, {183,0.00018919}, {184,0.00034234}, {185,0.00042342}, {186,0.00042342}, {187,0.00040541}, {188,0.00027928}, {189,0.00035135}, {190,0.00090090}, {191,0.00032432}, {192,0.00046847}, {193,0.00027027}, {194,0.00044144}, {195,0.00052252}, {196,0.00046847}, {197,0.00047748}, {198,0.00032432}, {199,0.00047748}, {200,0.00034234}, {201,0.00045946}, {202,0.00038739}, {203,0.00049550}, {204,0.00045045}, {205,0.00059459}, {206,0.00050450}, {207,0.00038739}, {208,0.00055856}, {209,0.00045045}, {210,0.00042342}, {211,0.00016216}, {212,0.00030631}, {213,0.00038739}, {214,0.00051351}, {215,0.00044144}, {216,0.00038739}, {217,0.00052252}, {218,0.00047748}, {219,0.00046847}, {220,0.00052252}, {221,0.00032432}, {222,0.00028829}, {223,0.00035135}, {224,0.00037838}, {225,0.00053153}, {226,0.00051351}, {227,0.00054955}, {228,0.00062162}, {229,0.00039640}, {230,0.00035135}, {231,0.00062162}, {232,0.00054955}, {233,0.00049550}, {234,0.00053153}, {235,0.00063964}, {236,0.00036937}, {237,0.00069369}, {238,0.00039640}, {239,0.00056757}, {240,0.00085586}, {241,0.00043243}, {242,0.00055856}, {243,0.00045946}, {244,0.00060360}, {245,0.00063964}, {246,0.00034234}, {247,0.00069369}, {248,0.00071171}, {249,0.00029730}, {250,0.00072072}, {251,0.00035135}, {252,0.00046847}, {253,0.00047748}, {254,0.00039640}, {255,0.00065766}, {256,0.00045045}, {257,0.00056757}, {258,0.00053153}, {259,0.00070270}, {260,0.00045946}, {261,0.00045045}, {262,0.00057658}, {263,0.00055856}, {264,0.00039640}, {265,0.00053153}, {266,0.00046847}, {267,0.00059459}, {268,0.00061261}, {269,0.00056757}, {270,0.00061261}, {271,0.00068468}, {272,0.00057658}, {273,0.00058559}, {274,0.00078378}, {275,0.00067568}, {276,0.00070270}, {277,0.00054955}, {278,0.00064865}, {279,0.00054955}, {280,0.00052252}, {281,0.00044144}, {282,0.00064865}, {283,0.00057658}, {284,0.00082883}, {285,0.00031532}, {286,0.00054955}, {287,0.00059459}, {288,0.00107207}, {289,0.00050450}, {290,0.00072973}, {291,0.00063063}, {292,0.00043243}, {293,0.00056757}, {294,0.00041441}, {295,0.00068468}, {296,0.00068468}, {297,0.00063063}, {298,0.00042342}, {299,0.00076577}, {300,0.00058559}, {301,0.00055856}, {302,0.00058559}, {303,0.00057658}, {304,0.00072973}, {305,0.00074775}, {306,0.00046847}, {307,0.00070270}, {308,0.00067568}, {309,0.00054054}, {310,0.00080180}, {311,0.00050450}, {312,0.00047748}, {313,0.00043243}, {314,0.00049550}, {315,0.00068468}, {316,0.00060360}, {317,0.00055856}, {318,0.00072072}, {319,0.00058559}, {320,0.00054054}, {321,0.00049550}, {322,0.00057658}, {323,0.00060360}, {324,0.00069369}, {325,0.00057658}, {326,0.00062162}, {327,0.00069369}, {328,0.00048649}, {329,0.00072973}, {330,0.00063964}, {331,0.00060360}, {332,0.00085586}, {333,0.00082883}, {334,0.00069369}, {335,0.00062162}, {336,0.00081982}, {337,0.00066667}, {338,0.00076577}, {339,0.00079279}, {340,0.00099099}, {341,0.00103604}, {342,0.00051351}, {343,0.00325225}, {344,0.00062162}, {345,0.00061261}, {346,0.00087387}, {347,0.00083784}, {348,0.00084685}, {349,0.00054955}, {350,0.00087387}, {351,0.00090090}, {352,0.00066667}, {353,0.00051351}, {354,0.00061261}, {355,0.00084685}, {356,0.00076577}, {357,0.00048649}, {358,0.00068468}, {359,0.00079279}, {360,0.00076577}, {361,0.00074775}, {362,0.00066667}, {363,0.00083784}, {364,0.00081081}, {365,0.00066667}, {366,0.00046847}, {367,0.00068468}, {368,0.00099099}, {369,0.00075676}, {370,0.00063964}, {371,0.00081081}, {372,0.00071171}, {373,0.00059459}, {374,0.00095495}, {375,0.00087387}, {376,0.00068468}, {377,0.00074775}, {378,0.00044144}, {379,0.00073874}, {380,0.00058559}, {381,0.00080180}, {382,0.00077477}, {383,0.00081081}, {384,0.00088288}, {385,0.00063964}, {386,0.00083784}, {387,0.00063964}, {388,0.00114414}, {389,0.00059459}, {390,0.00080180}, {391,0.00070270}, {392,0.00068468}, {393,0.00079279}, {394,0.00083784}, {395,0.00067568}, {396,0.00088288}, {397,0.00097297}, {398,0.00067568}, {399,0.00087387}, {400,0.00068468}, {401,0.00079279}, {402,0.00090991}, {403,0.00076577}, {404,0.00067568}, {405,0.00106306}, {406,0.00057658}, {407,0.00101802}, {408,0.00086486}, {409,0.00088288}, {410,0.00074775}, {411,0.00108108}, {412,0.00068468}, {413,0.00066667}, {414,0.00097297}, {415,0.00090090}, {416,0.00078182}, {417,0.00078182}, {418,0.00109091}, {419,0.00069091}, {420,0.00075455}, {421,0.00090909}, {422,0.00074545}, {423,0.00077273}, {424,0.00076364}, {425,0.00099091}, {426,0.00096364}, {427,0.00075455}, {428,0.00080909}, {429,0.00069091}, {430,0.00094545}, {431,0.00084545}, {432,0.00100000}, {433,0.00112727}, {434,0.00106364}, {435,0.00093636}, {436,0.00077273}, {437,0.00076364}, {438,0.00084545}, {439,0.00085455}, {440,0.00080909}, {441,0.00084545}, {442,0.00090909}, {443,0.00077273}, {444,0.00080909}, {445,0.00075455}, {446,0.00101818}, {447,0.00074545}, {448,0.00071818}, {449,0.00106364}, {450,0.00079091}, {451,0.00083636}, {452,0.00095455}, {453,0.00106364}, {454,0.00078182}, {455,0.00087273}, {456,0.00072727}, {457,0.00070909}, {458,0.00090909}, {459,0.00086364}, {460,0.00088182}, {461,0.00100909}, {462,0.00113636}, {463,0.00248182}, {464,0.00081818}, {465,0.00067273}, {466,0.00081818}, {467,0.00111818}, {468,0.00098182}, {469,0.00084545}, {470,0.00103636}, {471,0.00081818}, {472,0.00098182}, {473,0.00084545}, {474,0.00092727}, {475,0.00091818}, {476,0.00086364}, {477,0.00103636}, {478,0.00084545}, {479,0.00062727}, {480,0.00095455}, {481,0.00115455}, {482,0.00086364}, {483,0.00098182}, {484,0.00089091}, {485,0.00074545}, {486,0.00093636}, {487,0.00071818}, {488,0.00120909}, {489,0.00102727}, {490,0.00102727}, {491,0.00100000}, {492,0.00093636}, {493,0.00108182}, {494,0.00080000}, {495,0.00087273}, {496,0.00100909}, {497,0.00105455}, {498,0.00088182}, {499,0.00074545}, {500,0.00099091}, {505,0.00070909}, {510,0.00092727}, {515,0.00101818}, {520,0.00120909}, {525,0.00112727}, {530,0.00103636}, {535,0.00115455}, {540,0.00105455}, {545,0.00116364}, {550,0.00135455}, {555,0.00125455}, {560,0.00102727}, {565,0.00129091}, {570,0.00115455}, {575,0.00090909}, {580,0.00107273}, {585,0.00120909}, {590,0.00124545}, {595,0.00117273}, {600,0.00152727}, {605,0.00108182}, {610,0.00106364}, {615,0.00140000}, {620,0.00119091}, {625,0.00127273}, {630,0.00134545}, {635,0.00150000}, {640,0.00128182}, {645,0.00126364}, {650,0.00156364}, {655,0.00142727}, {660,0.00120000}, {665,0.00151818}, {670,0.00150909}, {675,0.00146364}, {680,0.00128182}, {685,0.00147273}, {690,0.00119091}, {695,0.00157273}, {700,0.00138182}, {705,0.00164545}, {710,0.00141818}, {715,0.00116364}, {720,0.00130000}, {725,0.00143636}, {730,0.00182727}, {735,0.00315455}, {740,0.00162727}, {745,0.00124545}, {750,0.00172727}, {755,0.00123636}, {760,0.00159091}, {765,0.00299091}, {770,0.00134545}, {775,0.00168182}, {780,0.00181818}, {785,0.00153636}, {790,0.00176364}, {795,0.00159091}, {800,0.00159091}, {805,0.00150909}, {810,0.00178182}, {815,0.00193636}, {820,0.00185455}, {825,0.00156364}, {830,0.00136364}, {835,0.00172727}, {840,0.00152727}, {845,0.00164545}, {850,0.00170909}, {855,0.00158182}, {860,0.00172727}, {865,0.00168182}, {870,0.00190000}, {875,0.00317273}, {880,0.00170909}, {885,0.00166364}, {890,0.00182727}, {895,0.00187273}, {900,0.00191818}, {905,0.00179091}, {910,0.00182727}, {915,0.00185455}, {920,0.00181818}, {925,0.00203636}, {930,0.00189091}, {935,0.00183636}, {940,0.00196364}, {945,0.00203636}, {950,0.00199091}, {955,0.00215455}, {960,0.00201818}, {965,0.00224545}, {970,0.00210000}, {975,0.00200000}, {980,0.00215455}, {985,0.00180909}, {990,0.00228182}, {995,0.00216364}, {1000,0.00193636}, {1010,0.00210000}, {1020,0.00201818}, {1030,0.00200909}, {1040,0.00233636}, {1050,0.00210000}, {1060,0.00222727}, {1070,0.00218182}, {1080,0.00378182}, {1090,0.00227273}, {1100,0.00242727}, {1110,0.00229091}, {1120,0.00224545}, {1130,0.00237273}, {1140,0.00240909}, {1150,0.00240909}, {1160,0.00241818}, {1170,0.00237273}, {1180,0.00370000}, {1190,0.00247273}, {1200,0.00299091}, {1210,0.00267273}, {1220,0.00270000}, {1230,0.00270000}, {1240,0.00251818}, {1250,0.00265455}, {1260,0.00259091}, {1270,0.00273636}, {1280,0.00233636}, {1290,0.00295455}, {1300,0.00258182}, {1310,0.00260000}, {1320,0.00300000}, {1330,0.00272727}, {1340,0.00289091}, {1350,0.00287273}, {1360,0.00374545}, {1370,0.00286364}, {1380,0.00280909}, {1390,0.00323636}, {1400,0.00298182}, {1410,0.00293636}, {1420,0.00310000}, {1430,0.00310909}, {1440,0.00310909}, {1450,0.00278182}, {1460,0.00305455}, {1470,0.00310000}, {1480,0.00309091}, {1490,0.00292727}, {1500,0.00326364}, {1510,0.00305455}, {1520,0.00316364}, {1530,0.00305455}, {1540,0.00335455}, {1550,0.00338182}, {1560,0.00330909}, {1570,0.00339091}, {1580,0.00341818}, {1590,0.00329091}, {1600,0.00337273}, {1610,0.00337273}, {1620,0.00973636}, {1630,0.00358182}, {1640,0.00352727}, {1650,0.00351818}, {1660,0.00349091}, {1670,0.00352727}, {1680,0.00377273}, {1690,0.00347273}, {1700,0.00350909}, {1710,0.00360909}, {1720,0.00378182}, {1730,0.00369091}, {1740,0.00368182}, {1750,0.00368182}, {1760,0.00382727}, {1770,0.00379091}, {1780,0.00380909}, {1790,0.00382727}, {1800,0.00389091}, {1810,0.00377273}, {1820,0.00385455}, {1830,0.00369091}, {1840,0.00384545}, {1850,0.00388182}, {1860,0.00401818}, {1870,0.00401818}, {1880,0.00420909}, {1890,0.00397273}, {1900,0.00384545}, {1910,0.00411818}, {1920,0.00410000}, {1930,0.00409091}, {1940,0.00405455}, {1950,0.00403636}, {1960,0.00471818}, {1970,0.00417273}, {1980,0.00433636}, {1990,0.00420000}, {2000,0.00457273}, {2050,0.00447273}, {2100,0.00457273}, {2150,0.00475455}, {2200,0.00460000}, {2250,0.00487273}, {2300,0.00520909}, {2350,0.00499091}, {2400,0.00502727}, {2450,0.00511818}, {2500,0.00553636}, {2550,0.00584545}, {2600,0.00555455}, {2650,0.00580909}, {2700,0.00590909}, {2750,0.00596364}, {2800,0.00622727}, {2850,0.01157273}, {2900,0.00627273}, {2950,0.00639091}, {3000,0.00672727}, {3050,0.00666364}, {3100,0.00693636}, {3150,0.00708182}, {3200,0.00714545}, {3250,0.00711818}, {3300,0.01442727}, {3350,0.00747273}, {3400,0.00783636}, {3450,0.00796364}, {3500,0.00820909}, {3550,0.00838182}, {3600,0.01390909}, {3650,0.00862727}, {3700,0.00878182}, {3750,0.00896364}, {3800,0.00940000}, {3850,0.01597273}, {3900,0.00975455}, {3950,0.00957273}, {4000,0.00965455}, {4050,0.00991818}, {4100,0.01017273}, {4150,0.01006364}, {4200,0.01042727}, {4250,0.01020000}, {4300,0.01091818}, {4350,0.01076364}, {4400,0.01103636}, {4450,0.01093636}, {4500,0.01129091}, {4550,0.01136364}, {4600,0.01151818}, {4650,0.01187273}, {4700,0.01181818}, {4750,0.01205455}, {4800,0.01208182}, {4850,0.01207273}, {4900,0.01219091}, {4950,0.02498182}, {5000,0.01261818}, {5050,0.01286364}, {5100,0.01287273}, {5150,0.01310000}, {5200,0.02628182}, {5250,0.01288182}, {5300,0.01307273}, {5350,0.01357273}, {5400,0.01339091}, {5450,0.01350909}, {5500,0.05206364}, {5550,0.01376364}, {5600,0.01388182}, {5650,0.01426364}, {5700,0.01417273}, {5750,0.01436364}, {5800,0.01441818}, {5850,0.01450909}, {5900,0.01467273}, {5950,0.01485455}, {6000,0.01551818}, {6050,0.01510909}, {6100,0.03019091}, {6150,0.01534545}, {6200,0.01549091}, {6250,0.01550909}, {6300,0.01630000}, {6350,0.01578182}, {6400,0.01597273}, {6450,0.01603636}, {6500,0.05712727}, {6550,0.01657273}, {6600,0.01646364}, {6650,0.01679091}, {6700,0.01665455}, {6750,0.01704545}, {6800,0.01707273}, {6850,0.01716364}, {6900,0.01745455}, {6950,0.01763636}, {7000,0.01752727}, {7050,0.01764545}, {7100,0.01781818}, {7150,0.01814545}, {7200,0.01830909}, {7250,0.01870909}, {7300,0.01902727}, {7350,0.06145455}, {7400,0.01873636}, {7450,0.01930000}, {7500,0.01905455}, {7550,0.04392727}, {7600,0.01950909}, {7650,0.01950000}, {7700,0.02017273}, {7750,0.01994545}, {7800,0.01994545}, {7850,0.04940000}, {7900,0.02063636}, {7950,0.02070000}, {8000,0.02087273}, {8050,0.02100000}, {8100,0.02113636}, {8150,0.02104545}, {8200,0.02107273}, {8250,0.02365455}, {8300,0.02159091}, {8350,0.05552727}, {8400,0.02150000}, {8450,0.02191818}, {8500,0.05445455}, {8550,0.02253636}, {8600,0.02240000}, {8650,0.02310000}, {8700,0.04878182}, {8750,0.02282727}, {8800,0.02302727}, {8850,0.02316364}, {8900,0.02337273}, {8950,0.05230000}, {9000,0.04551818}, {9050,0.03963636}, {9100,0.02405455}, {9150,0.02393636}, {9200,0.02411818}, {9250,0.02436364}, {9300,0.02450909}, {9350,0.02457273}, {9400,0.03350000}, {9450,0.05015455}, {9500,0.04956364}, {9550,0.02530909}, {9600,0.02532727}, {9650,0.02529091}, {9700,0.02572727}, {9750,0.04770909}, {9800,0.04537273}, {9850,0.02583636}, {9900,0.02614545}, {9950,0.05417273}, {10000,0.02635455}, {10100,0.02670909}, {10200,0.04673636}, {10300,0.02708182}, {10400,0.05910000}, {10500,0.02747273}, {10600,0.05608182}, {10700,0.02796364}, {10800,0.02850909}, {10900,0.05973636}, {11000,0.02915455}, {11100,0.02909091}, {11200,0.02940909}, {11300,0.02983636}, {11400,0.05128182}, {11500,0.05945455}, {11600,0.05820909}, {11700,0.04643636}, {11800,0.03108182}, {11900,0.03130000}, {12000,0.03211818}, {12100,0.03199091}, {12200,0.06457273}, {12300,0.03201818}, {12400,0.03234545}, {12500,0.06724545}, {12600,0.03338182}, {12700,0.06649091}, {12800,0.03404545}, {12900,0.06480000}, {13000,0.03453636}, {13100,0.03500000}, {13200,0.07061818}, {13300,0.03570000}, {13400,0.03586364}, {13500,0.03639091}, {13600,0.04828182}, {13700,0.06106364}, {13800,0.06825455}, {13900,0.06940909}, {14000,0.06312727}, {14100,0.05340909}, {14200,0.03784545}, {14300,0.03821818}, {14400,0.03830909}, {14500,0.07536364}, {14600,0.03739091}, {14700,0.03941818}, {14800,0.07922727}, {14900,0.03987273}, {15000,0.06960909}, {15100,0.04023636}, {15200,0.07742727}, {15300,0.04077273}, {15400,0.06127273}, {15500,0.07502727}, {15600,0.04160000}, {15700,0.04179091}, {15800,0.06180909}, {15900,0.07500000}, {16000,0.08940000}, {16100,0.08315455}, {16200,0.08239091}, {16300,0.08640000}, {16400,0.08347273}, {16500,0.07110909}, {16600,0.04441818}, {16700,0.04531818}, {16800,0.07796364}, {16900,0.08244545}, {17000,0.04585455}, {17100,0.08660909}, {17200,0.06659091}, {17300,0.07034545}, {17400,0.06904545}, {17500,0.07482727}, {17600,0.04775455}, {17700,0.09299091}, {17800,0.06694545}, {17900,0.04865455}, {18000,0.07130000}, {18100,0.09509091}, {18200,0.10060909}, {18300,0.07906364}, {18400,0.06460909}, {18500,0.06407273}, {18600,0.07957273}, {18700,0.09032727}, {18800,0.11476364}, {18900,0.08925455}, {19000,0.05045455}, {19100,0.05162727}, {19200,0.09732727}, {19300,0.07974545}, {19400,0.05250909}, {19500,0.09495455}, {19600,0.05310909}, {19700,0.12255455}, {19800,0.05363636}, {19900,0.08626364}, {20000,0.08200926}};
data["big_flat"]["TemplateCoq"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00002703}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00002703}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00003604}, {46,0.00000000}, {47,0.00003604}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00003604}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00003604}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00003604}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00002703}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00003604}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00003604}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00003604}, {154,0.00003604}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00003604}, {167,0.00003604}, {168,0.00003604}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00002703}, {174,0.00000000}, {175,0.00003604}, {176,0.00003604}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00003604}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00003604}, {186,0.00003604}, {187,0.00003604}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00002703}, {196,0.00000000}, {197,0.00003604}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00003604}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00003604}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00003604}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00003604}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00003604}, {250,0.00000000}, {251,0.00003604}, {252,0.00000000}, {253,0.00003604}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00003604}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00003604}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003604}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00003604}, {289,0.00000000}, {290,0.00000000}, {291,0.00003604}, {292,0.00003604}, {293,0.00000000}, {294,0.00003604}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00002703}, {304,0.00000000}, {305,0.00000000}, {306,0.00003604}, {307,0.00000000}, {308,0.00000000}, {309,0.00003604}, {310,0.00000000}, {311,0.00003604}, {312,0.00003604}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00003604}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00007207}, {329,0.00000000}, {330,0.00000000}, {331,0.00003604}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00003604}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00002703}, {344,0.00000000}, {345,0.00000000}, {346,0.00003604}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00003604}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00003604}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00003604}, {379,0.00003604}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00003604}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00007207}, {401,0.00000000}, {402,0.00002703}, {403,0.00000000}, {404,0.00003604}, {405,0.00002703}, {406,0.00000000}, {407,0.00003604}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00003604}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00002727}, {419,0.00003636}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00003636}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00003636}, {440,0.00003636}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00003636}, {446,0.00000000}, {447,0.00003636}, {448,0.00000000}, {449,0.00003636}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00002727}, {455,0.00000000}, {456,0.00000000}, {457,0.00003636}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00003636}, {463,0.00002727}, {464,0.00000000}, {465,0.00000000}, {466,0.00003636}, {467,0.00000000}, {468,0.00003636}, {469,0.00000000}, {470,0.00000000}, {471,0.00003636}, {472,0.00003636}, {473,0.00003636}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00003636}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00003636}, {483,0.00003636}, {484,0.00003636}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00003636}, {495,0.00003636}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00003636}, {505,0.00003636}, {510,0.00002727}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00003636}, {535,0.00000000}, {540,0.00003636}, {545,0.00000000}, {550,0.00000000}, {555,0.00003636}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00003636}, {580,0.00002727}, {585,0.00000000}, {590,0.00003636}, {595,0.00002727}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00003636}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00003636}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00003636}, {715,0.00000000}, {720,0.00000000}, {725,0.00003636}, {730,0.00002727}, {735,0.00000000}, {740,0.00007273}, {745,0.00003636}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00018182}, {770,0.00000000}, {775,0.00000000}, {780,0.00003636}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00003636}, {805,0.00000000}, {810,0.00003636}, {815,0.00003636}, {820,0.00000000}, {825,0.00003636}, {830,0.00003636}, {835,0.00000000}, {840,0.00000000}, {845,0.00003636}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00006364}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00002727}, {895,0.00003636}, {900,0.00000000}, {905,0.00003636}, {910,0.00000000}, {915,0.00000000}, {920,0.00003636}, {925,0.00000000}, {930,0.00003636}, {935,0.00000000}, {940,0.00003636}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00003636}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00003636}, {1040,0.00003636}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00003636}, {1200,0.00003636}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003636}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00007273}, {1320,0.00000000}, {1330,0.00003636}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00010909}, {1370,0.00000000}, {1380,0.00007273}, {1390,0.00000000}, {1400,0.00003636}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00003636}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00007273}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00003636}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00003636}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00007273}, {1610,0.00000000}, {1620,0.00003636}, {1630,0.00000000}, {1640,0.00003636}, {1650,0.00000000}, {1660,0.00003636}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00003636}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00003636}, {1890,0.00003636}, {1900,0.00003636}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00003636}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00003636}, {2550,0.00000000}, {2600,0.00003636}, {2650,0.00003636}, {2700,0.00007273}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00014545}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00003636}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00002727}, {3300,0.00003636}, {3350,0.00000000}, {3400,0.00003636}, {3450,0.00003636}, {3500,0.00000000}, {3550,0.00007273}, {3600,0.00025455}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00017273}, {3900,0.00000000}, {3950,0.00003636}, {4000,0.00000000}, {4050,0.00003636}, {4100,0.00000000}, {4150,0.00002727}, {4200,0.00000000}, {4250,0.00003636}, {4300,0.00003636}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00003636}, {4500,0.00003636}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00018182}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00029091}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00003636}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00074545}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00003636}, {5800,0.00000000}, {5850,0.00003636}, {5900,0.00000000}, {5950,0.00003636}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00003636}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00006364}, {6350,0.00000000}, {6400,0.00003636}, {6450,0.00000000}, {6500,0.00054545}, {6550,0.00003636}, {6600,0.00003636}, {6650,0.00003636}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00003636}, {6900,0.00000000}, {6950,0.00003636}, {7000,0.00003636}, {7050,0.00003636}, {7100,0.00000000}, {7150,0.00007273}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00003636}, {7350,0.00070909}, {7400,0.00003636}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00003636}, {7800,0.00000000}, {7850,0.00003636}, {7900,0.00003636}, {7950,0.00003636}, {8000,0.00000000}, {8050,0.00003636}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00003636}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00007273}, {8900,0.00000000}, {8950,0.00010909}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00003636}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00003636}, {9750,0.00000000}, {9800,0.00003636}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00003636}, {10200,0.00003636}, {10300,0.00000000}, {10400,0.00003636}, {10500,0.00000000}, {10600,0.00003636}, {10700,0.00000000}, {10800,0.00003636}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00002727}, {11300,0.00003636}, {11400,0.00000000}, {11500,0.00003636}, {11600,0.00003636}, {11700,0.00046364}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00003636}, {12100,0.00000000}, {12200,0.00047273}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00003636}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00003636}, {12900,0.00003636}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00003636}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00018182}, {13700,0.00021818}, {13800,0.00025455}, {13900,0.00003636}, {14000,0.00000000}, {14100,0.00002727}, {14200,0.00003636}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00006364}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00007273}, {14900,0.00007273}, {15000,0.00003636}, {15100,0.00003636}, {15200,0.00003636}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00003636}, {15600,0.00003636}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00007273}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00003636}, {16700,0.00000000}, {16800,0.00006364}, {16900,0.00000000}, {17000,0.00003636}, {17100,0.00000000}, {17200,0.00003636}, {17300,0.00003636}, {17400,0.00000000}, {17500,0.00003636}, {17600,0.00003636}, {17700,0.00007273}, {17800,0.00003636}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00003636}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00003636}, {18800,0.00003636}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00003636}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00003636}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["TemplateCoq"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00003604}, {81,0.00007207}, {82,0.00009009}, {83,0.00021622}, {84,0.00033333}, {85,0.00044144}, {86,0.00065766}, {87,0.00079279}, {88,0.00198198}, {89,0.00093694}, {90,0.00096396}, {91,0.00099099}, {92,0.00099099}, {93,0.00100000}, {94,0.00100000}, {95,0.00100000}, {96,0.00100000}, {97,0.00100000}, {98,0.00100000}, {99,0.00100000}, {100,0.00100000}, {101,0.00100000}, {102,0.00100000}, {103,0.00100000}, {104,0.00100000}, {105,0.00100000}, {106,0.00100000}, {107,0.00100000}, {108,0.00100000}, {109,0.00100000}, {110,0.00100000}, {111,0.00100000}, {112,0.00100000}, {113,0.00100000}, {114,0.00100000}, {115,0.00100000}, {116,0.00100000}, {117,0.00100000}, {118,0.00100000}, {119,0.00100000}, {120,0.00100000}, {121,0.00100000}, {122,0.00100000}, {123,0.00100000}, {124,0.00100000}, {125,0.00100000}, {126,0.00100000}, {127,0.00100000}, {128,0.00100000}, {129,0.00100000}, {130,0.00100000}, {131,0.00100000}, {132,0.00100000}, {133,0.00100000}, {134,0.00100000}, {135,0.00100000}, {136,0.00100000}, {137,0.00100000}, {138,0.00100000}, {139,0.00100000}, {140,0.00100000}, {141,0.00100000}, {142,0.00100000}, {143,0.00100000}, {144,0.00100000}, {145,0.00100000}, {146,0.00100000}, {147,0.00100000}, {148,0.00100000}, {149,0.00100901}, {150,0.00100000}, {151,0.00100901}, {152,0.00100000}, {153,0.00100901}, {154,0.00101802}, {155,0.00100901}, {156,0.00102703}, {157,0.00102703}, {158,0.00102703}, {159,0.00101802}, {160,0.00115315}, {161,0.00120721}, {162,0.00122523}, {163,0.00132432}, {164,0.00150450}, {165,0.00154955}, {166,0.00165766}, {167,0.00172072}, {168,0.00182883}, {169,0.00188288}, {170,0.00190991}, {171,0.00191892}, {172,0.00195495}, {173,0.00198198}, {174,0.00195495}, {175,0.00197297}, {176,0.00198198}, {177,0.00200000}, {178,0.00200000}, {179,0.00200000}, {180,0.00200000}, {181,0.00200000}, {182,0.00200000}, {183,0.00200000}, {184,0.00200000}, {185,0.00200000}, {186,0.00200000}, {187,0.00200000}, {188,0.00200000}, {189,0.00200000}, {190,0.00200000}, {191,0.00200000}, {192,0.00200000}, {193,0.00200000}, {194,0.00200000}, {195,0.00200000}, {196,0.00200000}, {197,0.00200000}, {198,0.00200000}, {199,0.00200000}, {200,0.00200000}, {201,0.00200000}, {202,0.00200000}, {203,0.00200000}, {204,0.00200000}, {205,0.00200000}, {206,0.00200000}, {207,0.00200000}, {208,0.00200000}, {209,0.00200000}, {210,0.00200000}, {211,0.00200000}, {212,0.00200000}, {213,0.00200000}, {214,0.00200000}, {215,0.00200000}, {216,0.00200000}, {217,0.00200000}, {218,0.00200000}, {219,0.00200000}, {220,0.00200000}, {221,0.00200000}, {222,0.00200000}, {223,0.00200000}, {224,0.00200000}, {225,0.00200000}, {226,0.00200000}, {227,0.00200000}, {228,0.00200000}, {229,0.00201802}, {230,0.00200000}, {231,0.00200000}, {232,0.00200901}, {233,0.00200000}, {234,0.00200000}, {235,0.00200901}, {236,0.00201802}, {237,0.00202703}, {238,0.00206306}, {239,0.00200000}, {240,0.00209009}, {241,0.00209009}, {242,0.00210811}, {243,0.00227027}, {244,0.00233333}, {245,0.00234234}, {246,0.00246847}, {247,0.00259459}, {248,0.00268468}, {249,0.00276577}, {250,0.00277477}, {251,0.00285586}, {252,0.00286486}, {253,0.00284685}, {254,0.00287387}, {255,0.00292793}, {256,0.00398198}, {257,0.00295495}, {258,0.00296396}, {259,0.00300000}, {260,0.00296396}, {261,0.00300000}, {262,0.00300000}, {263,0.00300000}, {264,0.00490991}, {265,0.00300000}, {266,0.00300000}, {267,0.00300000}, {268,0.00300000}, {269,0.00300000}, {270,0.00300000}, {271,0.00300000}, {272,0.00580180}, {273,0.00300000}, {274,0.00300000}, {275,0.00300000}, {276,0.00300000}, {277,0.00300000}, {278,0.00300000}, {279,0.00300000}, {280,0.00500901}, {281,0.00300000}, {282,0.00300000}, {283,0.00300000}, {284,0.00300000}, {285,0.00300000}, {286,0.00300000}, {287,0.00301802}, {288,0.00300000}, {289,0.00300000}, {290,0.00300000}, {291,0.00300000}, {292,0.00300000}, {293,0.00300000}, {294,0.00300000}, {295,0.00480180}, {296,0.00300000}, {297,0.00300000}, {298,0.00300000}, {299,0.00300000}, {300,0.00300000}, {301,0.00300000}, {302,0.00518919}, {303,0.00300000}, {304,0.00300000}, {305,0.00300000}, {306,0.00300000}, {307,0.00300000}, {308,0.00300000}, {309,0.00768468}, {310,0.00300000}, {311,0.00300000}, {312,0.00300901}, {313,0.00300000}, {314,0.00300000}, {315,0.00300901}, {316,0.00576577}, {317,0.00300901}, {318,0.00301802}, {319,0.00302703}, {320,0.00304505}, {321,0.00304505}, {322,0.00309910}, {323,0.00595495}, {324,0.00316216}, {325,0.00320721}, {326,0.00324324}, {327,0.00319820}, {328,0.00334234}, {329,0.00345946}, {330,0.00301802}, {331,0.00363964}, {332,0.00363063}, {333,0.00372072}, {334,0.00372973}, {335,0.00377477}, {336,0.00520721}, {337,0.00381982}, {338,0.00382883}, {339,0.00385586}, {340,0.00391892}, {341,0.00389189}, {342,0.00393694}, {343,0.00396396}, {344,0.00395495}, {345,0.00399099}, {346,0.00400000}, {347,0.00400000}, {348,0.00400000}, {349,0.00378378}, {350,0.00400000}, {351,0.00400000}, {352,0.00400000}, {353,0.00400000}, {354,0.00400000}, {355,0.00507207}, {356,0.00400000}, {357,0.00400000}, {358,0.00400000}, {359,0.00400000}, {360,0.00400000}, {361,0.00586486}, {362,0.00400000}, {363,0.00400000}, {364,0.00400000}, {365,0.00403604}, {366,0.00400000}, {367,0.00773874}, {368,0.00400000}, {369,0.00400000}, {370,0.00400000}, {371,0.00400000}, {372,0.00400000}, {373,0.00754955}, {374,0.00400000}, {375,0.00400000}, {376,0.00400000}, {377,0.00400000}, {378,0.00400000}, {379,0.00551351}, {380,0.00400000}, {381,0.00400000}, {382,0.00400000}, {383,0.00400000}, {384,0.00407207}, {385,0.00400000}, {386,0.00400000}, {387,0.00400000}, {388,0.00400000}, {389,0.00400901}, {390,0.00403604}, {391,0.00400000}, {392,0.00400000}, {393,0.00400000}, {394,0.00400000}, {395,0.00404505}, {396,0.00400901}, {397,0.00400901}, {398,0.00401802}, {399,0.00401802}, {400,0.00403604}, {401,0.00409910}, {402,0.00402703}, {403,0.00403604}, {404,0.00408108}, {405,0.00404505}, {406,0.00404505}, {407,0.00400000}, {408,0.00420721}, {409,0.00422523}, {410,0.00431532}, {411,0.00437838}, {412,0.00674775}, {413,0.00447748}, {414,0.00456757}, {415,0.00465455}, {416,0.00466364}, {417,0.00475455}, {418,0.00472727}, {419,0.00476364}, {420,0.00478182}, {421,0.00479091}, {422,0.00480000}, {423,0.00409091}, {424,0.00482727}, {425,0.00482727}, {426,0.00485455}, {427,0.00486364}, {428,0.00414545}, {429,0.00491818}, {430,0.00495455}, {431,0.00493636}, {432,0.00495455}, {433,0.00626364}, {434,0.00499091}, {435,0.00500000}, {436,0.00497273}, {437,0.00499091}, {438,0.00652727}, {439,0.00500000}, {440,0.00500000}, {441,0.00500000}, {442,0.00500000}, {443,0.00671818}, {444,0.00500000}, {445,0.00500000}, {446,0.00500000}, {447,0.00500000}, {448,0.00668182}, {449,0.00500000}, {450,0.00500000}, {451,0.00500000}, {452,0.00500000}, {453,0.00674545}, {454,0.00500000}, {455,0.00500000}, {456,0.00500000}, {457,0.00500000}, {458,0.00500000}, {459,0.00500000}, {460,0.00500000}, {461,0.00500000}, {462,0.00507273}, {463,0.00500000}, {464,0.00500000}, {465,0.00500000}, {466,0.00500000}, {467,0.00503636}, {468,0.00500000}, {469,0.00500000}, {470,0.00500000}, {471,0.00500000}, {472,0.00696364}, {473,0.00500000}, {474,0.00500000}, {475,0.00500909}, {476,0.00500909}, {477,0.00500000}, {478,0.00500909}, {479,0.00500000}, {480,0.00500000}, {481,0.00503636}, {482,0.00501818}, {483,0.00504545}, {484,0.00504545}, {485,0.00505455}, {486,0.00500000}, {487,0.00506364}, {488,0.00507273}, {489,0.00513636}, {490,0.00513636}, {491,0.00521818}, {492,0.00521818}, {493,0.00528182}, {494,0.00528182}, {495,0.00700909}, {496,0.00544545}, {497,0.00546364}, {498,0.00552727}, {499,0.00562727}, {500,0.00566364}, {505,0.00574545}, {510,0.00579091}, {515,0.00589091}, {520,0.00547273}, {525,0.00600000}, {530,0.00600000}, {535,0.00600000}, {540,0.00789091}, {545,0.00600000}, {550,0.00600000}, {555,0.00600000}, {560,0.00799091}, {565,0.00601818}, {570,0.00610000}, {575,0.00621818}, {580,0.00600000}, {585,0.00666364}, {590,0.00679091}, {595,0.00678182}, {600,0.00611818}, {605,0.00690000}, {610,0.00699091}, {615,0.00704545}, {620,0.00700000}, {625,0.00700000}, {630,0.00700000}, {635,0.00904545}, {640,0.00700909}, {645,0.00700000}, {650,0.00708182}, {655,0.00710000}, {660,0.00727273}, {665,0.00751818}, {670,0.00700909}, {675,0.00773636}, {680,0.00777273}, {685,0.00993636}, {690,0.00790909}, {695,0.00797273}, {700,0.00803636}, {705,0.00800000}, {710,0.00800000}, {715,0.00811818}, {720,0.00800000}, {725,0.00802727}, {730,0.00803636}, {735,0.00805455}, {740,0.00820909}, {745,0.00833636}, {750,0.00861818}, {755,0.00867273}, {760,0.00874545}, {765,0.00878182}, {770,0.00882727}, {775,0.00886364}, {780,0.00894545}, {785,0.00899091}, {790,0.00907273}, {795,0.00900000}, {800,0.00900000}, {805,0.01278182}, {810,0.00900909}, {815,0.00906364}, {820,0.01625455}, {825,0.00920000}, {830,0.00937273}, {835,0.00900909}, {840,0.00969091}, {845,0.00979091}, {850,0.00976364}, {855,0.00983636}, {860,0.01250909}, {865,0.00990000}, {870,0.00997273}, {875,0.00999091}, {880,0.01000000}, {885,0.01354545}, {890,0.01000000}, {895,0.01004545}, {900,0.00984545}, {905,0.01015455}, {910,0.01377273}, {915,0.01045455}, {920,0.01060000}, {925,0.01005455}, {930,0.01070909}, {935,0.01375455}, {940,0.01077273}, {945,0.01096364}, {950,0.01086364}, {955,0.01094545}, {960,0.01042727}, {965,0.01100000}, {970,0.01462727}, {975,0.01101818}, {980,0.01105455}, {985,0.01110000}, {990,0.01123636}, {995,0.01092727}, {1000,0.01155455}, {1010,0.01467273}, {1020,0.01177273}, {1030,0.01869091}, {1040,0.01196364}, {1050,0.01218182}, {1060,0.01201818}, {1070,0.01213636}, {1080,0.01240000}, {1090,0.01260000}, {1100,0.01262727}, {1110,0.01275455}, {1120,0.01210909}, {1130,0.01295455}, {1140,0.01267273}, {1150,0.01310909}, {1160,0.01276364}, {1170,0.01362727}, {1180,0.01371818}, {1190,0.01372727}, {1200,0.01377273}, {1210,0.01402727}, {1220,0.01395455}, {1230,0.02258182}, {1240,0.01419091}, {1250,0.02175455}, {1260,0.01470000}, {1270,0.01390909}, {1280,0.01477273}, {1290,0.01407273}, {1300,0.01515455}, {1310,0.01506364}, {1320,0.01973636}, {1330,0.01540000}, {1340,0.01478182}, {1350,0.01572727}, {1360,0.01573636}, {1370,0.02317273}, {1380,0.01586364}, {1390,0.01524545}, {1400,0.01610000}, {1410,0.01628182}, {1420,0.02089091}, {1430,0.01672727}, {1440,0.01580000}, {1450,0.02580909}, {1460,0.01680909}, {1470,0.01611818}, {1480,0.01728182}, {1490,0.01720000}, {1500,0.01672727}, {1510,0.01788182}, {1520,0.01772727}, {1530,0.01681818}, {1540,0.01797273}, {1550,0.01780909}, {1560,0.01722727}, {1570,0.03050909}, {1580,0.01843636}, {1590,0.01770909}, {1600,0.02636364}, {1610,0.01872727}, {1620,0.01876364}, {1630,0.02799091}, {1640,0.01915455}, {1650,0.01904545}, {1660,0.01849091}, {1670,0.02484545}, {1680,0.01968182}, {1690,0.01969091}, {1700,0.01873636}, {1710,0.02570909}, {1720,0.01983636}, {1730,0.01996364}, {1740,0.01927273}, {1750,0.03360909}, {1760,0.02094545}, {1770,0.02071818}, {1780,0.01976364}, {1790,0.02643636}, {1800,0.03254545}, {1810,0.02085455}, {1820,0.02122727}, {1830,0.02036364}, {1840,0.02749091}, {1850,0.03257273}, {1860,0.02173636}, {1870,0.02175455}, {1880,0.02081818}, {1890,0.02082727}, {1900,0.02834545}, {1910,0.03909091}, {1920,0.02248182}, {1930,0.02261818}, {1940,0.02168182}, {1950,0.02172727}, {1960,0.02892727}, {1970,0.02960909}, {1980,0.04327273}, {1990,0.02317273}, {2000,0.02337273}, {2050,0.02379091}, {2100,0.02351818}, {2150,0.02381818}, {2200,0.02466364}, {2250,0.02488182}, {2300,0.02569091}, {2350,0.02612727}, {2400,0.02674545}, {2450,0.02740000}, {2500,0.02773636}, {2550,0.02973636}, {2600,0.03045455}, {2650,0.05034545}, {2700,0.04793636}, {2750,0.04018182}, {2800,0.03128182}, {2850,0.03339091}, {2900,0.04495455}, {2950,0.06056364}, {3000,0.03357273}, {3050,0.05546364}, {3100,0.05539091}, {3150,0.03514545}, {3200,0.04886364}, {3250,0.03633636}, {3300,0.06390000}, {3350,0.05579091}, {3400,0.06067273}, {3450,0.05120909}, {3500,0.05960000}, {3550,0.05496364}, {3600,0.06075455}, {3650,0.04082727}, {3700,0.05024545}, {3750,0.04235455}, {3800,0.05762727}, {3850,0.05686364}, {3900,0.04404545}, {3950,0.04427273}, {4000,0.05682727}, {4050,0.05396364}, {4100,0.04623636}, {4150,0.04653636}, {4200,0.06480000}, {4250,0.05941818}, {4300,0.05814545}, {4350,0.05294545}, {4400,0.06220909}, {4450,0.06963636}, {4500,0.07479091}, {4550,0.07765455}, {4600,0.07871818}, {4650,0.07731818}, {4700,0.07372727}, {4750,0.06828182}, {4800,0.06062727}, {4850,0.05466364}, {4900,0.06120909}, {4950,0.07235455}, {5000,0.07050000}, {5050,0.08857273}, {5100,0.06813636}, {5150,0.05810000}, {5200,0.07615455}, {5250,0.09217273}, {5300,0.06340000}, {5350,0.06830000}, {5400,0.06130909}, {5450,0.06198182}, {5500,0.07538182}, {5550,0.08256364}, {5600,0.06340000}, {5650,0.09575455}, {5700,0.06426364}, {5750,0.11073636}, {5800,0.06560000}, {5850,0.10097273}, {5900,0.06652727}, {5950,0.08114545}, {6000,0.07990000}, {6050,0.06832727}, {6100,0.09699091}, {6150,0.06944545}, {6200,0.07003636}, {6250,0.09157273}, {6300,0.08170909}, {6350,0.07163636}, {6400,0.07229091}, {6450,0.08717273}, {6500,0.12457273}, {6550,0.07730000}, {6600,0.07452727}, {6650,0.07495455}, {6700,0.07561818}, {6750,0.07620909}, {6800,0.07677273}, {6850,0.07729091}, {6900,0.07778182}, {6950,0.07849091}, {7000,0.07899091}, {7050,0.07955455}, {7100,0.08013636}, {7150,0.08064545}, {7200,0.08133636}, {7250,0.12164545}, {7300,0.11829091}, {7350,0.08866364}, {7400,0.08353636}, {7450,0.08410909}, {7500,0.12064545}, {7550,0.09333636}, {7600,0.08567273}, {7650,0.13270909}, {7700,0.11274545}, {7750,0.08740000}, {7800,0.12563636}, {7850,0.08864545}, {7900,0.09011818}, {7950,0.10926364}, {8000,0.09028182}, {8050,0.10700000}, {8100,0.09136364}, {8150,0.10657273}, {8200,0.14437273}, {8250,0.09317273}, {8300,0.12776364}, {8350,0.09427273}, {8400,0.10259091}, {8450,0.13609091}, {8500,0.09578182}, {8550,0.09790909}, {8600,0.13302727}, {8650,0.14496364}, {8700,0.09814545}, {8750,0.09866364}, {8800,0.11336364}, {8850,0.12953636}, {8900,0.14382727}, {8950,0.15560909}, {9000,0.10152727}, {9050,0.10187273}, {9100,0.10261818}, {9150,0.10310909}, {9200,0.10375455}, {9250,0.10410909}, {9300,0.10475455}, {9350,0.10533636}, {9400,0.10692727}, {9450,0.15805455}, {9500,0.14737273}, {9550,0.13421818}, {9600,0.11918182}, {9650,0.10910000}, {9700,0.10927273}, {9750,0.15604545}, {9800,0.13280000}, {9850,0.11116364}, {9900,0.11253636}, {9950,0.14524545}, {10000,0.11380909}, {10100,0.18046364}, {10200,0.13500909}, {10300,0.11609091}, {10400,0.14238182}, {10500,0.11969091}, {10600,0.13090909}, {10700,0.16773636}, {10800,0.12200909}, {10900,0.13074545}, {11000,0.15435455}, {11100,0.17360000}, {11200,0.18879091}, {11300,0.12890909}, {11400,0.12886364}, {11500,0.12993636}, {11600,0.13263636}, {11700,0.20728182}, {11800,0.19656364}, {11900,0.18246364}, {12000,0.16303636}, {12100,0.13960909}, {12200,0.20859091}, {12300,0.17518182}, {12400,0.14420000}, {12500,0.19938182}, {12600,0.16030000}, {12700,0.20848182}, {12800,0.15624545}, {12900,0.19771818}, {13000,0.14825455}, {13100,0.16947273}, {13200,0.19735455}, {13300,0.22160909}, {13400,0.15288182}, {13500,0.16067273}, {13600,0.17153636}, {13700,0.17847273}, {13800,0.18277273}, {13900,0.18240909}, {14000,0.17646364}, {14100,0.16824545}, {14200,0.16195455}, {14300,0.24478182}, {14400,0.21360000}, {14500,0.18429091}, {14600,0.25101818}, {14700,0.21630000}, {14800,0.17680000}, {14900,0.22970000}, {15000,0.18302727}, {15100,0.22730000}, {15200,0.17470000}, {15300,0.21100000}, {15400,0.24343636}, {15500,0.27226364}, {15600,0.19936364}, {15700,0.21857273}, {15800,0.24553636}, {15900,0.24793636}, {16000,0.25548182}, {16100,0.25722727}, {16200,0.25819091}, {16300,0.25260000}, {16400,0.24299091}, {16500,0.23091818}, {16600,0.21317273}, {16700,0.28473636}, {16800,0.26222727}, {16900,0.23241818}, {17000,0.29381818}, {17100,0.26689091}, {17200,0.21339091}, {17300,0.26366364}, {17400,0.21377273}, {17500,0.25376364}, {17600,0.29021818}, {17700,0.22718182}, {17800,0.25621818}, {17900,0.28340000}, {18000,0.30175455}, {18100,0.31822727}, {18200,0.22947273}, {18300,0.23659091}, {18400,0.24896364}, {18500,0.24466364}, {18600,0.23994545}, {18700,0.31534545}, {18800,0.31381818}, {18900,0.29680909}, {19000,0.27550909}, {19100,0.24938182}, {19200,0.31702727}, {19300,0.28338182}, {19400,0.34387273}, {19500,0.29655455}, {19600,0.25448182}, {19700,0.29930000}, {19800,0.34014545}, {19900,0.28050000}, {20000,0.31300000}};
data["big_flat"]["TemplateCoq"]["eval lazy"]["user"] = {{1,0.00000000}, {2,0.00003604}, {3,0.00006306}, {4,0.00007207}, {5,0.00006306}, {6,0.00008108}, {7,0.00010811}, {8,0.00013514}, {9,0.00009910}, {10,0.00017117}, {11,0.00006306}, {12,0.00012613}, {13,0.00017117}, {14,0.00018018}, {15,0.00020721}, {16,0.00023423}, {17,0.00029730}, {18,0.00043243}, {19,0.00006306}, {20,0.00042342}, {21,0.00016216}, {22,0.00047748}, {23,0.00014414}, {24,0.00041441}, {25,0.00024324}, {26,0.00027928}, {27,0.00018018}, {28,0.00018919}, {29,0.00030631}, {30,0.00042342}, {31,0.00030631}, {32,0.00054955}, {33,0.00025225}, {34,0.00040541}, {35,0.00034234}, {36,0.00025225}, {37,0.00049550}, {38,0.00017117}, {39,0.00047748}, {40,0.00055856}, {41,0.00037838}, {42,0.00052252}, {43,0.00054054}, {44,0.00052252}, {45,0.00040541}, {46,0.00059459}, {47,0.00036937}, {48,0.00056757}, {49,0.00040541}, {50,0.00042342}, {51,0.00051351}, {52,0.00056757}, {53,0.00041441}, {54,0.00049550}, {55,0.00048649}, {56,0.00070270}, {57,0.00049550}, {58,0.00056757}, {59,0.00075676}, {60,0.00086486}, {61,0.00058559}, {62,0.00060360}, {63,0.00057658}, {64,0.00044144}, {65,0.00054054}, {66,0.00092793}, {67,0.00081081}, {68,0.00090090}, {69,0.00072072}, {70,0.00054054}, {71,0.00067568}, {72,0.00072973}, {73,0.00072973}, {74,0.00067568}, {75,0.00070270}, {76,0.00086486}, {77,0.00081982}, {78,0.00091892}, {79,0.00099099}, {80,0.00077477}, {81,0.00098198}, {82,0.00094595}, {83,0.00090991}, {84,0.00093694}, {85,0.00104505}, {86,0.00099099}, {87,0.00094595}, {88,0.00208108}, {89,0.00072072}, {90,0.00081081}, {91,0.00067568}, {92,0.00088288}, {93,0.00081982}, {94,0.00104505}, {95,0.00100000}, {96,0.00117117}, {97,0.00135135}, {98,0.00131532}, {99,0.00123423}, {100,0.00095495}, {101,0.00088288}, {102,0.00066667}, {103,0.00078378}, {104,0.00101802}, {105,0.00134234}, {106,0.00146847}, {107,0.00099099}, {108,0.00090991}, {109,0.00123423}, {110,0.00127928}, {111,0.00118919}, {112,0.00110811}, {113,0.00117117}, {114,0.00123423}, {115,0.00090090}, {116,0.00105405}, {117,0.00125225}, {118,0.00125225}, {119,0.00124324}, {120,0.00132432}, {121,0.00111712}, {122,0.00121622}, {123,0.00144144}, {124,0.00108108}, {125,0.00149550}, {126,0.00125225}, {127,0.00101802}, {128,0.00164865}, {129,0.00125225}, {130,0.00124324}, {131,0.00170270}, {132,0.00119820}, {133,0.00144144}, {134,0.00136036}, {135,0.00122523}, {136,0.00164865}, {137,0.00133333}, {138,0.00138739}, {139,0.00150450}, {140,0.00155856}, {141,0.00143243}, {142,0.00149550}, {143,0.00145946}, {144,0.00171171}, {145,0.00154955}, {146,0.00159459}, {147,0.00162162}, {148,0.00165766}, {149,0.00153153}, {150,0.00165766}, {151,0.00159459}, {152,0.00172973}, {153,0.00163964}, {154,0.00145045}, {155,0.00184685}, {156,0.00142342}, {157,0.00184685}, {158,0.00157658}, {159,0.00179279}, {160,0.00200000}, {161,0.00164865}, {162,0.00173874}, {163,0.00183784}, {164,0.00182883}, {165,0.00185586}, {166,0.00185586}, {167,0.00172072}, {168,0.00180180}, {169,0.00192793}, {170,0.00169369}, {171,0.00189189}, {172,0.00195495}, {173,0.00176577}, {174,0.00182883}, {175,0.00213514}, {176,0.00184685}, {177,0.00176577}, {178,0.00201802}, {179,0.00207207}, {180,0.00211712}, {181,0.00208108}, {182,0.00166667}, {183,0.00154955}, {184,0.00213514}, {185,0.00247748}, {186,0.00206306}, {187,0.00190090}, {188,0.00190991}, {189,0.00191892}, {190,0.00216216}, {191,0.00172973}, {192,0.00199099}, {193,0.00191892}, {194,0.00221622}, {195,0.00227027}, {196,0.00191892}, {197,0.00217117}, {198,0.00231532}, {199,0.00199099}, {200,0.00195495}, {201,0.00218018}, {202,0.00239640}, {203,0.00236036}, {204,0.00222523}, {205,0.00251351}, {206,0.00258559}, {207,0.00245946}, {208,0.00228829}, {209,0.00240541}, {210,0.00234234}, {211,0.00186486}, {212,0.00194595}, {213,0.00211712}, {214,0.00211712}, {215,0.00228829}, {216,0.00234234}, {217,0.00240541}, {218,0.00245045}, {219,0.00241441}, {220,0.00254054}, {221,0.00236937}, {222,0.00234234}, {223,0.00207207}, {224,0.00221622}, {225,0.00226126}, {226,0.00243243}, {227,0.00260360}, {228,0.00265766}, {229,0.00250450}, {230,0.00230631}, {231,0.00250450}, {232,0.00256757}, {233,0.00250450}, {234,0.00242342}, {235,0.00272973}, {236,0.00271171}, {237,0.00274775}, {238,0.00271171}, {239,0.00271171}, {240,0.00279279}, {241,0.00268468}, {242,0.00263063}, {243,0.00267568}, {244,0.00299099}, {245,0.00239640}, {246,0.00268468}, {247,0.00296396}, {248,0.00254955}, {249,0.00275676}, {250,0.00279279}, {251,0.00278378}, {252,0.00286486}, {253,0.00290090}, {254,0.00290090}, {255,0.00269369}, {256,0.00407207}, {257,0.00282883}, {258,0.00281982}, {259,0.00281982}, {260,0.00283784}, {261,0.00287387}, {262,0.00280180}, {263,0.00287387}, {264,0.00468468}, {265,0.00293694}, {266,0.00305405}, {267,0.00296396}, {268,0.00291892}, {269,0.00300901}, {270,0.00309910}, {271,0.00305405}, {272,0.00554955}, {273,0.00305405}, {274,0.00301802}, {275,0.00286486}, {276,0.00323423}, {277,0.00315315}, {278,0.00298198}, {279,0.00296396}, {280,0.00507207}, {281,0.00300000}, {282,0.00337838}, {283,0.00318018}, {284,0.00304505}, {285,0.00293694}, {286,0.00290991}, {287,0.00321622}, {288,0.00316216}, {289,0.00290090}, {290,0.00301802}, {291,0.00309009}, {292,0.00314414}, {293,0.00311712}, {294,0.00300901}, {295,0.00486486}, {296,0.00313514}, {297,0.00324324}, {298,0.00331532}, {299,0.00320721}, {300,0.00335135}, {301,0.00338739}, {302,0.00512613}, {303,0.00329730}, {304,0.00334234}, {305,0.00333333}, {306,0.00336937}, {307,0.00330631}, {308,0.00337838}, {309,0.00745946}, {310,0.00339640}, {311,0.00338739}, {312,0.00330631}, {313,0.00347748}, {314,0.00336937}, {315,0.00343243}, {316,0.00545946}, {317,0.00349550}, {318,0.00360360}, {319,0.00348649}, {320,0.00345946}, {321,0.00356757}, {322,0.00352252}, {323,0.00580180}, {324,0.00366667}, {325,0.00365766}, {326,0.00363063}, {327,0.00350450}, {328,0.00352252}, {329,0.00357658}, {330,0.00359459}, {331,0.00366667}, {332,0.00369369}, {333,0.00365766}, {334,0.00362162}, {335,0.00362162}, {336,0.00501802}, {337,0.00358559}, {338,0.00372072}, {339,0.00368468}, {340,0.00372072}, {341,0.00376577}, {342,0.00384685}, {343,0.00372072}, {344,0.00373874}, {345,0.00381982}, {346,0.00381982}, {347,0.00388288}, {348,0.00373874}, {349,0.00371171}, {350,0.00396396}, {351,0.00378378}, {352,0.00373874}, {353,0.00375676}, {354,0.00375676}, {355,0.00554054}, {356,0.00390991}, {357,0.00377477}, {358,0.00400901}, {359,0.00387387}, {360,0.00395495}, {361,0.00595495}, {362,0.00387387}, {363,0.00401802}, {364,0.00420721}, {365,0.00413514}, {366,0.00403604}, {367,0.00745045}, {368,0.00418018}, {369,0.00400901}, {370,0.00405405}, {371,0.00397297}, {372,0.00393694}, {373,0.00698198}, {374,0.00414414}, {375,0.00400000}, {376,0.00420721}, {377,0.00422523}, {378,0.00425225}, {379,0.00545946}, {380,0.00400901}, {381,0.00427928}, {382,0.00414414}, {383,0.00412613}, {384,0.00427027}, {385,0.00429730}, {386,0.00418919}, {387,0.00412613}, {388,0.00414414}, {389,0.00421622}, {390,0.00436036}, {391,0.00450450}, {392,0.00409910}, {393,0.00423423}, {394,0.00443243}, {395,0.00437838}, {396,0.00401802}, {397,0.00437838}, {398,0.00441441}, {399,0.00461261}, {400,0.00445045}, {401,0.00453153}, {402,0.00450450}, {403,0.00446847}, {404,0.00423423}, {405,0.00477477}, {406,0.00429730}, {407,0.00421622}, {408,0.00433333}, {409,0.00469369}, {410,0.00447748}, {411,0.00442342}, {412,0.00647748}, {413,0.00466667}, {414,0.00443243}, {415,0.00463636}, {416,0.00464545}, {417,0.00470909}, {418,0.00471818}, {419,0.00456364}, {420,0.00426364}, {421,0.00443636}, {422,0.00480909}, {423,0.00457273}, {424,0.00446364}, {425,0.00433636}, {426,0.00465455}, {427,0.00474545}, {428,0.00448182}, {429,0.00486364}, {430,0.00456364}, {431,0.00483636}, {432,0.00463636}, {433,0.00609091}, {434,0.00465455}, {435,0.00485455}, {436,0.00473636}, {437,0.00477273}, {438,0.00630000}, {439,0.00510000}, {440,0.00463636}, {441,0.00463636}, {442,0.00482727}, {443,0.00637273}, {444,0.00489091}, {445,0.00495455}, {446,0.00492727}, {447,0.00496364}, {448,0.00646364}, {449,0.00463636}, {450,0.00487273}, {451,0.00499091}, {452,0.00490000}, {453,0.00647273}, {454,0.00499091}, {455,0.00492727}, {456,0.00495455}, {457,0.00506364}, {458,0.00481818}, {459,0.00494545}, {460,0.00498182}, {461,0.00474545}, {462,0.00469091}, {463,0.00484545}, {464,0.00494545}, {465,0.00500909}, {466,0.00506364}, {467,0.00509091}, {468,0.00530000}, {469,0.00524545}, {470,0.00503636}, {471,0.00500909}, {472,0.00683636}, {473,0.00530000}, {474,0.00529091}, {475,0.00537273}, {476,0.00520000}, {477,0.00526364}, {478,0.00550000}, {479,0.00540000}, {480,0.00498182}, {481,0.00501818}, {482,0.00542727}, {483,0.00545455}, {484,0.00531818}, {485,0.00557273}, {486,0.00489091}, {487,0.00519091}, {488,0.00502727}, {489,0.00506364}, {490,0.00568182}, {491,0.00527273}, {492,0.00550909}, {493,0.00548182}, {494,0.00532727}, {495,0.00690909}, {496,0.00519091}, {497,0.00530000}, {498,0.00551818}, {499,0.00555455}, {500,0.00540000}, {505,0.00556364}, {510,0.00553636}, {515,0.00565455}, {520,0.00552727}, {525,0.00573636}, {530,0.00606364}, {535,0.00572727}, {540,0.00761818}, {545,0.00591818}, {550,0.00644545}, {555,0.00582727}, {560,0.00769091}, {565,0.00638182}, {570,0.00639091}, {575,0.00637273}, {580,0.00615455}, {585,0.00632727}, {590,0.00650000}, {595,0.00670909}, {600,0.00594545}, {605,0.00659091}, {610,0.00666364}, {615,0.00687273}, {620,0.00655455}, {625,0.00672727}, {630,0.00692727}, {635,0.00937273}, {640,0.00682727}, {645,0.00690000}, {650,0.00712727}, {655,0.00712727}, {660,0.00717273}, {665,0.00736364}, {670,0.00707273}, {675,0.00750909}, {680,0.00755455}, {685,0.00986364}, {690,0.00768182}, {695,0.00746364}, {700,0.00766364}, {705,0.00809091}, {710,0.00750909}, {715,0.00791818}, {720,0.00799091}, {725,0.00819091}, {730,0.00791818}, {735,0.00850000}, {740,0.00816364}, {745,0.00804545}, {750,0.00794545}, {755,0.00850000}, {760,0.00855455}, {765,0.00888182}, {770,0.00835455}, {775,0.00871818}, {780,0.00887273}, {785,0.00863636}, {790,0.00880909}, {795,0.00890000}, {800,0.00903636}, {805,0.01294545}, {810,0.00895455}, {815,0.00907273}, {820,0.01576364}, {825,0.00924545}, {830,0.00970909}, {835,0.00912727}, {840,0.00969091}, {845,0.00954545}, {850,0.01010000}, {855,0.00981818}, {860,0.01256364}, {865,0.00997273}, {870,0.00987273}, {875,0.00997273}, {880,0.01030909}, {885,0.01339091}, {890,0.01023636}, {895,0.01023636}, {900,0.00970909}, {905,0.01040000}, {910,0.01421818}, {915,0.01094545}, {920,0.01059091}, {925,0.01048182}, {930,0.01079091}, {935,0.01370000}, {940,0.01111818}, {945,0.01118182}, {950,0.01109091}, {955,0.01117273}, {960,0.01082727}, {965,0.01140909}, {970,0.01452727}, {975,0.01136364}, {980,0.01155455}, {985,0.01149091}, {990,0.01161818}, {995,0.01105455}, {1000,0.01181818}, {1010,0.01484545}, {1020,0.01203636}, {1030,0.01844545}, {1040,0.01231818}, {1050,0.01264545}, {1060,0.01249091}, {1070,0.01250909}, {1080,0.01280000}, {1090,0.01271818}, {1100,0.01261818}, {1110,0.01282727}, {1120,0.01250909}, {1130,0.01324545}, {1140,0.01292727}, {1150,0.01349091}, {1160,0.01288182}, {1170,0.01345455}, {1180,0.01366364}, {1190,0.01351818}, {1200,0.01369091}, {1210,0.01410909}, {1220,0.01400000}, {1230,0.02252727}, {1240,0.01454545}, {1250,0.02155455}, {1260,0.01460000}, {1270,0.01429091}, {1280,0.01481818}, {1290,0.01454545}, {1300,0.01551818}, {1310,0.01514545}, {1320,0.01940909}, {1330,0.01545455}, {1340,0.01480909}, {1350,0.01560000}, {1360,0.01573636}, {1370,0.02310000}, {1380,0.01576364}, {1390,0.01520000}, {1400,0.01629091}, {1410,0.01632727}, {1420,0.02090000}, {1430,0.01668182}, {1440,0.01585455}, {1450,0.02553636}, {1460,0.01686364}, {1470,0.01615455}, {1480,0.01694545}, {1490,0.01728182}, {1500,0.01640909}, {1510,0.01760000}, {1520,0.01703636}, {1530,0.01654545}, {1540,0.01776364}, {1550,0.01777273}, {1560,0.01681818}, {1570,0.03067273}, {1580,0.01792727}, {1590,0.01729091}, {1600,0.02612727}, {1610,0.01810000}, {1620,0.01834545}, {1630,0.02794545}, {1640,0.01901818}, {1650,0.01887273}, {1660,0.01798182}, {1670,0.02472727}, {1680,0.01910909}, {1690,0.01929091}, {1700,0.01855455}, {1710,0.02581818}, {1720,0.01959091}, {1730,0.02002727}, {1740,0.01885455}, {1750,0.03213636}, {1760,0.02047273}, {1770,0.02005455}, {1780,0.01945455}, {1790,0.02629091}, {1800,0.03230909}, {1810,0.02089091}, {1820,0.02081818}, {1830,0.02002727}, {1840,0.02729091}, {1850,0.03234545}, {1860,0.02144545}, {1870,0.02169091}, {1880,0.02065455}, {1890,0.02049091}, {1900,0.02826364}, {1910,0.03844545}, {1920,0.02209091}, {1930,0.02280909}, {1940,0.02197273}, {1950,0.02139091}, {1960,0.02921818}, {1970,0.02983636}, {1980,0.04298182}, {1990,0.02348182}, {2000,0.02342727}, {2050,0.02415455}, {2100,0.02361818}, {2150,0.02385455}, {2200,0.02449091}, {2250,0.02520000}, {2300,0.02555455}, {2350,0.02623636}, {2400,0.02664545}, {2450,0.02724545}, {2500,0.02770000}, {2550,0.03006364}, {2600,0.03085455}, {2650,0.04977273}, {2700,0.04730909}, {2750,0.03974545}, {2800,0.03143636}, {2850,0.03399091}, {2900,0.04520909}, {2950,0.05988182}, {3000,0.03351818}, {3050,0.05478182}, {3100,0.05530909}, {3150,0.03520000}, {3200,0.04840909}, {3250,0.03655455}, {3300,0.06339091}, {3350,0.05549091}, {3400,0.06064545}, {3450,0.05088182}, {3500,0.05930909}, {3550,0.05481818}, {3600,0.06064545}, {3650,0.04056364}, {3700,0.04980909}, {3750,0.04216364}, {3800,0.05700909}, {3850,0.05667273}, {3900,0.04400909}, {3950,0.04418182}, {4000,0.05667273}, {4050,0.05352727}, {4100,0.04617273}, {4150,0.04683636}, {4200,0.06447273}, {4250,0.05942727}, {4300,0.05776364}, {4350,0.05269091}, {4400,0.06237273}, {4450,0.06942727}, {4500,0.07431818}, {4550,0.07701818}, {4600,0.07810909}, {4650,0.07700909}, {4700,0.07380000}, {4750,0.06840909}, {4800,0.06081818}, {4850,0.05450000}, {4900,0.06164545}, {4950,0.07198182}, {5000,0.07015455}, {5050,0.08820909}, {5100,0.06808182}, {5150,0.05824545}, {5200,0.07616364}, {5250,0.09110909}, {5300,0.06363636}, {5350,0.06800909}, {5400,0.06160000}, {5450,0.06230000}, {5500,0.07568182}, {5550,0.08241818}, {5600,0.06354545}, {5650,0.09603636}, {5700,0.06425455}, {5750,0.11050000}, {5800,0.06569091}, {5850,0.10050909}, {5900,0.06642727}, {5950,0.08094545}, {6000,0.07974545}, {6050,0.06797273}, {6100,0.09640909}, {6150,0.06903636}, {6200,0.06965455}, {6250,0.09108182}, {6300,0.08125455}, {6350,0.07193636}, {6400,0.07259091}, {6450,0.08696364}, {6500,0.12356364}, {6550,0.07731818}, {6600,0.07497273}, {6650,0.07502727}, {6700,0.07590000}, {6750,0.07616364}, {6800,0.07690000}, {6850,0.07729091}, {6900,0.07777273}, {6950,0.07828182}, {7000,0.07883636}, {7050,0.07931818}, {7100,0.08001818}, {7150,0.08053636}, {7200,0.08098182}, {7250,0.12065455}, {7300,0.11731818}, {7350,0.08822727}, {7400,0.08343636}, {7450,0.08430000}, {7500,0.12042727}, {7550,0.09340000}, {7600,0.08572727}, {7650,0.13280909}, {7700,0.11256364}, {7750,0.08763636}, {7800,0.12579091}, {7850,0.08860000}, {7900,0.09021818}, {7950,0.10905455}, {8000,0.08996364}, {8050,0.10706364}, {8100,0.09129091}, {8150,0.10661818}, {8200,0.14431818}, {8250,0.09283636}, {8300,0.12808182}, {8350,0.09436364}, {8400,0.10270909}, {8450,0.13652727}, {8500,0.09563636}, {8550,0.09796364}, {8600,0.13314545}, {8650,0.14508182}, {8700,0.09811818}, {8750,0.09874545}, {8800,0.11320000}, {8850,0.12950909}, {8900,0.14371818}, {8950,0.15535455}, {9000,0.10107273}, {9050,0.10162727}, {9100,0.10221818}, {9150,0.10297273}, {9200,0.10376364}, {9250,0.10348182}, {9300,0.10483636}, {9350,0.10506364}, {9400,0.10667273}, {9450,0.15770909}, {9500,0.14742727}, {9550,0.13409091}, {9600,0.11903636}, {9650,0.10876364}, {9700,0.10930909}, {9750,0.15572727}, {9800,0.13288182}, {9850,0.11072727}, {9900,0.11217273}, {9950,0.14567273}, {10000,0.11351818}, {10100,0.18040909}, {10200,0.13488182}, {10300,0.11560000}, {10400,0.14242727}, {10500,0.11949091}, {10600,0.13103636}, {10700,0.16790909}, {10800,0.12220909}, {10900,0.13064545}, {11000,0.15441818}, {11100,0.17381818}, {11200,0.18870000}, {11300,0.12923636}, {11400,0.12920000}, {11500,0.12990000}, {11600,0.13282727}, {11700,0.20588182}, {11800,0.19548182}, {11900,0.18186364}, {12000,0.16293636}, {12100,0.13969091}, {12200,0.20714545}, {12300,0.17478182}, {12400,0.14402727}, {12500,0.19917273}, {12600,0.16015455}, {12700,0.20833636}, {12800,0.15632727}, {12900,0.19774545}, {13000,0.14850909}, {13100,0.16943636}, {13200,0.19720000}, {13300,0.22083636}, {13400,0.15314545}, {13500,0.16086364}, {13600,0.17174545}, {13700,0.17830909}, {13800,0.18280000}, {13900,0.18187273}, {14000,0.17666364}, {14100,0.16828182}, {14200,0.16204545}, {14300,0.24477273}, {14400,0.21307273}, {14500,0.18427273}, {14600,0.25088182}, {14700,0.21612727}, {14800,0.17646364}, {14900,0.22944545}, {15000,0.18280000}, {15100,0.22682727}, {15200,0.17468182}, {15300,0.21120909}, {15400,0.24352727}, {15500,0.27234545}, {15600,0.19940909}, {15700,0.21875455}, {15800,0.24558182}, {15900,0.24780000}, {16000,0.25565455}, {16100,0.25707273}, {16200,0.25786364}, {16300,0.25275455}, {16400,0.24270000}, {16500,0.23077273}, {16600,0.21301818}, {16700,0.28471818}, {16800,0.26259091}, {16900,0.23261818}, {17000,0.29410909}, {17100,0.26691818}, {17200,0.21335455}, {17300,0.26378182}, {17400,0.21379091}, {17500,0.25373636}, {17600,0.28998182}, {17700,0.22666364}, {17800,0.25610909}, {17900,0.28320909}, {18000,0.30184545}, {18100,0.31810909}, {18200,0.22932727}, {18300,0.23655455}, {18400,0.24902727}, {18500,0.24435455}, {18600,0.23967273}, {18700,0.31536364}, {18800,0.31323636}, {18900,0.29681818}, {19000,0.27560909}, {19100,0.24974545}, {19200,0.31686364}, {19300,0.28364545}, {19400,0.34374545}, {19500,0.29619091}, {19600,0.25450000}, {19700,0.29954545}, {19800,0.34020000}, {19900,0.28039091}, {20000,0.31277778}};
data["big_flat"]["TemplateCoq"]["eval lazy"]["system"] = {{1,0.00007273}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003604}, {13,0.00000000}, {14,0.00002703}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00003604}, {23,0.00003604}, {24,0.00003604}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00003604}, {32,0.00000000}, {33,0.00000000}, {34,0.00003604}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003604}, {42,0.00000000}, {43,0.00003604}, {44,0.00000000}, {45,0.00003604}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00003604}, {60,0.00000000}, {61,0.00000000}, {62,0.00007207}, {63,0.00000000}, {64,0.00007207}, {65,0.00003604}, {66,0.00002703}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00003604}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00007207}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00003604}, {81,0.00000000}, {82,0.00000000}, {83,0.00003604}, {84,0.00007207}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00006306}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00003604}, {101,0.00000000}, {102,0.00003604}, {103,0.00000000}, {104,0.00003604}, {105,0.00000000}, {106,0.00002703}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00010811}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00003604}, {115,0.00003604}, {116,0.00006306}, {117,0.00000000}, {118,0.00000000}, {119,0.00003604}, {120,0.00000000}, {121,0.00000000}, {122,0.00003604}, {123,0.00003604}, {124,0.00000000}, {125,0.00003604}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00003604}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00003604}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00003604}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00003604}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00003604}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00003604}, {153,0.00003604}, {154,0.00000000}, {155,0.00002703}, {156,0.00003604}, {157,0.00000000}, {158,0.00000000}, {159,0.00003604}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00003604}, {167,0.00002703}, {168,0.00000000}, {169,0.00003604}, {170,0.00000000}, {171,0.00003604}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00003604}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00003604}, {197,0.00003604}, {198,0.00000000}, {199,0.00007207}, {200,0.00003604}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00003604}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00007207}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00003604}, {216,0.00003604}, {217,0.00000000}, {218,0.00000000}, {219,0.00003604}, {220,0.00003604}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00003604}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00003604}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00003604}, {239,0.00002703}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00003604}, {248,0.00000000}, {249,0.00003604}, {250,0.00003604}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00006306}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00003604}, {265,0.00000000}, {266,0.00002703}, {267,0.00003604}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00003604}, {273,0.00003604}, {274,0.00003604}, {275,0.00003604}, {276,0.00000000}, {277,0.00000000}, {278,0.00003604}, {279,0.00000000}, {280,0.00003604}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00003604}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00002703}, {289,0.00003604}, {290,0.00000000}, {291,0.00003604}, {292,0.00000000}, {293,0.00003604}, {294,0.00003604}, {295,0.00003604}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00003604}, {302,0.00014414}, {303,0.00000000}, {304,0.00003604}, {305,0.00000000}, {306,0.00000000}, {307,0.00003604}, {308,0.00000000}, {309,0.00003604}, {310,0.00003604}, {311,0.00000000}, {312,0.00009910}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00003604}, {317,0.00003604}, {318,0.00003604}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00003604}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00003604}, {335,0.00003604}, {336,0.00010811}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00003604}, {350,0.00000000}, {351,0.00003604}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00003604}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00003604}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00003604}, {368,0.00000000}, {369,0.00000000}, {370,0.00003604}, {371,0.00003604}, {372,0.00000000}, {373,0.00017117}, {374,0.00000000}, {375,0.00002703}, {376,0.00000000}, {377,0.00000000}, {378,0.00003604}, {379,0.00007207}, {380,0.00003604}, {381,0.00003604}, {382,0.00000000}, {383,0.00000000}, {384,0.00003604}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00002703}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00003604}, {401,0.00002703}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00003604}, {410,0.00000000}, {411,0.00003604}, {412,0.00010811}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00002727}, {418,0.00007273}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00002727}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00003636}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00003636}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00003636}, {439,0.00007273}, {440,0.00000000}, {441,0.00003636}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00002727}, {453,0.00000000}, {454,0.00003636}, {455,0.00003636}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00003636}, {461,0.00000000}, {462,0.00000000}, {463,0.00007273}, {464,0.00003636}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00007273}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00007273}, {473,0.00000000}, {474,0.00000000}, {475,0.00003636}, {476,0.00003636}, {477,0.00003636}, {478,0.00003636}, {479,0.00003636}, {480,0.00003636}, {481,0.00000000}, {482,0.00003636}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00003636}, {487,0.00003636}, {488,0.00000000}, {489,0.00000000}, {490,0.00003636}, {491,0.00007273}, {492,0.00003636}, {493,0.00003636}, {494,0.00003636}, {495,0.00003636}, {496,0.00000000}, {497,0.00003636}, {498,0.00006364}, {499,0.00003636}, {500,0.00000000}, {505,0.00000000}, {510,0.00003636}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00003636}, {555,0.00003636}, {560,0.00007273}, {565,0.00000000}, {570,0.00003636}, {575,0.00000000}, {580,0.00000000}, {585,0.00003636}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00003636}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00003636}, {645,0.00000000}, {650,0.00003636}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00010000}, {690,0.00000000}, {695,0.00003636}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00006364}, {730,0.00000000}, {735,0.00000000}, {740,0.00003636}, {745,0.00003636}, {750,0.00003636}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00003636}, {805,0.00000000}, {810,0.00003636}, {815,0.00000000}, {820,0.00018182}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00003636}, {850,0.00000000}, {855,0.00000000}, {860,0.00003636}, {865,0.00002727}, {870,0.00000000}, {875,0.00000000}, {880,0.00007273}, {885,0.00014545}, {890,0.00000000}, {895,0.00000000}, {900,0.00006364}, {905,0.00000000}, {910,0.00003636}, {915,0.00000000}, {920,0.00000000}, {925,0.00003636}, {930,0.00003636}, {935,0.00007273}, {940,0.00000000}, {945,0.00003636}, {950,0.00002727}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00007273}, {975,0.00000000}, {980,0.00003636}, {985,0.00000000}, {990,0.00000000}, {995,0.00003636}, {1000,0.00003636}, {1010,0.00000000}, {1020,0.00003636}, {1030,0.00014545}, {1040,0.00000000}, {1050,0.00002727}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00003636}, {1110,0.00003636}, {1120,0.00003636}, {1130,0.00000000}, {1140,0.00002727}, {1150,0.00000000}, {1160,0.00006364}, {1170,0.00000000}, {1180,0.00003636}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00003636}, {1220,0.00000000}, {1230,0.00007273}, {1240,0.00003636}, {1250,0.00007273}, {1260,0.00000000}, {1270,0.00006364}, {1280,0.00000000}, {1290,0.00006364}, {1300,0.00000000}, {1310,0.00007273}, {1320,0.00003636}, {1330,0.00000000}, {1340,0.00003636}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00018182}, {1380,0.00000000}, {1390,0.00003636}, {1400,0.00003636}, {1410,0.00000000}, {1420,0.00010000}, {1430,0.00000000}, {1440,0.00002727}, {1450,0.00021818}, {1460,0.00007273}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00003636}, {1510,0.00002727}, {1520,0.00000000}, {1530,0.00003636}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00003636}, {1570,0.00025455}, {1580,0.00005455}, {1590,0.00000000}, {1600,0.00003636}, {1610,0.00003636}, {1620,0.00000000}, {1630,0.00026364}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00018182}, {1680,0.00000000}, {1690,0.00006364}, {1700,0.00000000}, {1710,0.00010909}, {1720,0.00000000}, {1730,0.00003636}, {1740,0.00007273}, {1750,0.00177273}, {1760,0.00014545}, {1770,0.00003636}, {1780,0.00006364}, {1790,0.00014545}, {1800,0.00046364}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00013636}, {1850,0.00020909}, {1860,0.00003636}, {1870,0.00003636}, {1880,0.00000000}, {1890,0.00003636}, {1900,0.00003636}, {1910,0.00042727}, {1920,0.00003636}, {1930,0.00003636}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00014545}, {1970,0.00014545}, {1980,0.00039091}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00003636}, {2150,0.00003636}, {2200,0.00000000}, {2250,0.00007273}, {2300,0.00000000}, {2350,0.00007273}, {2400,0.00000000}, {2450,0.00002727}, {2500,0.00003636}, {2550,0.00002727}, {2600,0.00000000}, {2650,0.00044545}, {2700,0.00043636}, {2750,0.00013636}, {2800,0.00014545}, {2850,0.00003636}, {2900,0.00010909}, {2950,0.00053636}, {3000,0.00003636}, {3050,0.00047273}, {3100,0.00025455}, {3150,0.00003636}, {3200,0.00029091}, {3250,0.00003636}, {3300,0.00060909}, {3350,0.00045455}, {3400,0.00032727}, {3450,0.00020909}, {3500,0.00029091}, {3550,0.00023636}, {3600,0.00046364}, {3650,0.00006364}, {3700,0.00007273}, {3750,0.00000000}, {3800,0.00045455}, {3850,0.00006364}, {3900,0.00000000}, {3950,0.00018182}, {4000,0.00032727}, {4050,0.00014545}, {4100,0.00003636}, {4150,0.00000000}, {4200,0.00043636}, {4250,0.00028182}, {4300,0.00020909}, {4350,0.00006364}, {4400,0.00010909}, {4450,0.00032727}, {4500,0.00046364}, {4550,0.00056364}, {4600,0.00057273}, {4650,0.00032727}, {4700,0.00024545}, {4750,0.00023636}, {4800,0.00007273}, {4850,0.00007273}, {4900,0.00010909}, {4950,0.00050000}, {5000,0.00032727}, {5050,0.00060909}, {5100,0.00018182}, {5150,0.00003636}, {5200,0.00020909}, {5250,0.00075455}, {5300,0.00010909}, {5350,0.00017273}, {5400,0.00007273}, {5450,0.00000000}, {5500,0.00017273}, {5550,0.00003636}, {5600,0.00003636}, {5650,0.00000000}, {5700,0.00007273}, {5750,0.00007273}, {5800,0.00003636}, {5850,0.00010909}, {5900,0.00003636}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00047273}, {6150,0.00003636}, {6200,0.00000000}, {6250,0.00038182}, {6300,0.00029091}, {6350,0.00003636}, {6400,0.00003636}, {6450,0.00040000}, {6500,0.00104545}, {6550,0.00007273}, {6600,0.00003636}, {6650,0.00003636}, {6700,0.00000000}, {6750,0.00018182}, {6800,0.00007273}, {6850,0.00003636}, {6900,0.00003636}, {6950,0.00003636}, {7000,0.00003636}, {7050,0.00000000}, {7100,0.00007273}, {7150,0.00000000}, {7200,0.00003636}, {7250,0.00093636}, {7300,0.00069091}, {7350,0.00024545}, {7400,0.00007273}, {7450,0.00003636}, {7500,0.00010909}, {7550,0.00010909}, {7600,0.00000000}, {7650,0.00010000}, {7700,0.00003636}, {7750,0.00000000}, {7800,0.00003636}, {7850,0.00003636}, {7900,0.00007273}, {7950,0.00007273}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00003636}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00007273}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00003636}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00003636}, {8650,0.00000000}, {8700,0.00007273}, {8750,0.00003636}, {8800,0.00000000}, {8850,0.00003636}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00003636}, {9050,0.00000000}, {9100,0.00003636}, {9150,0.00000000}, {9200,0.00007273}, {9250,0.00003636}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00007273}, {9450,0.00003636}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00010909}, {9750,0.00000000}, {9800,0.00003636}, {9850,0.00006364}, {9900,0.00003636}, {9950,0.00000000}, {10000,0.00003636}, {10100,0.00000000}, {10200,0.00003636}, {10300,0.00003636}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00003636}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00003636}, {11000,0.00003636}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00003636}, {11500,0.00010000}, {11600,0.00003636}, {11700,0.00105455}, {11800,0.00110000}, {11900,0.00046364}, {12000,0.00029091}, {12100,0.00003636}, {12200,0.00127273}, {12300,0.00036364}, {12400,0.00014545}, {12500,0.00010909}, {12600,0.00000000}, {12700,0.00014545}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00003636}, {13200,0.00047273}, {13300,0.00077273}, {13400,0.00007273}, {13500,0.00007273}, {13600,0.00013636}, {13700,0.00013636}, {13800,0.00014545}, {13900,0.00014545}, {14000,0.00003636}, {14100,0.00003636}, {14200,0.00007273}, {14300,0.00007273}, {14400,0.00007273}, {14500,0.00007273}, {14600,0.00003636}, {14700,0.00003636}, {14800,0.00007273}, {14900,0.00014545}, {15000,0.00003636}, {15100,0.00003636}, {15200,0.00010909}, {15300,0.00003636}, {15400,0.00007273}, {15500,0.00003636}, {15600,0.00000000}, {15700,0.00003636}, {15800,0.00000000}, {15900,0.00003636}, {16000,0.00000000}, {16100,0.00014545}, {16200,0.00000000}, {16300,0.00017273}, {16400,0.00007273}, {16500,0.00000000}, {16600,0.00003636}, {16700,0.00010909}, {16800,0.00007273}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00003636}, {17200,0.00003636}, {17300,0.00003636}, {17400,0.00007273}, {17500,0.00003636}, {17600,0.00018182}, {17700,0.00010000}, {17800,0.00000000}, {17900,0.00003636}, {18000,0.00000000}, {18100,0.00006364}, {18200,0.00003636}, {18300,0.00003636}, {18400,0.00003636}, {18500,0.00000000}, {18600,0.00003636}, {18700,0.00003636}, {18800,0.00003636}, {18900,0.00007273}, {19000,0.00003636}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00003636}, {19400,0.00010909}, {19500,0.00010909}, {19600,0.00006364}, {19700,0.00003636}, {19800,0.00007273}, {19900,0.00000000}, {20000,0.00007407}};
data["big_flat"]["TemplateCoq"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00005455}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000909}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00002727}, {1360,0.00000909}, {1370,0.00000000}, {1380,0.00005455}, {1390,0.00000000}, {1400,0.00002727}, {1410,0.00005455}, {1420,0.00000000}, {1430,0.00006364}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00009091}, {1470,0.00000000}, {1480,0.00017273}, {1490,0.00010909}, {1500,0.00000000}, {1510,0.00017273}, {1520,0.00012727}, {1530,0.00000000}, {1540,0.00022727}, {1550,0.00020000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00031818}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00040000}, {1620,0.00044545}, {1630,0.00000000}, {1640,0.00049091}, {1650,0.00059091}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00066364}, {1690,0.00071818}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00078182}, {1730,0.00080909}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00080000}, {1770,0.00086364}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00090909}, {1820,0.00091818}, {1830,0.00000000}, {1840,0.00000909}, {1850,0.00000000}, {1860,0.00098182}, {1870,0.00099091}, {1880,0.00001818}, {1890,0.00000000}, {1900,0.00000909}, {1910,0.00000000}, {1920,0.00100000}, {1930,0.00100000}, {1940,0.00002727}, {1950,0.00001818}, {1960,0.00000000}, {1970,0.00002727}, {1980,0.00000000}, {1990,0.00100000}, {2000,0.00100000}, {2050,0.00006364}, {2100,0.00021818}, {2150,0.00032727}, {2200,0.00058182}, {2250,0.00075455}, {2300,0.00080909}, {2350,0.00087273}, {2400,0.00097273}, {2450,0.00100000}, {2500,0.00100000}, {2550,0.00100000}, {2600,0.00112727}, {2650,0.00100000}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00147273}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00100000}, {3150,0.00100000}, {3200,0.00100000}, {3250,0.00100000}, {3300,0.00100000}, {3350,0.00100000}, {3400,0.00100000}, {3450,0.00100000}, {3500,0.00100000}, {3550,0.00100000}, {3600,0.00100909}, {3650,0.00100000}, {3700,0.00100000}, {3750,0.00100909}, {3800,0.00103636}, {3850,0.00105455}, {3900,0.00468182}, {3950,0.00113636}, {4000,0.00129091}, {4050,0.00134545}, {4100,0.00462727}, {4150,0.00149091}, {4200,0.00162727}, {4250,0.00167273}, {4300,0.00170909}, {4350,0.00175455}, {4400,0.00178182}, {4450,0.00180909}, {4500,0.00183636}, {4550,0.00192727}, {4600,0.00197273}, {4650,0.00196364}, {4700,0.00199091}, {4750,0.00200000}, {4800,0.00199091}, {4850,0.00200000}, {4900,0.00200000}, {4950,0.00200000}, {5000,0.00200000}, {5050,0.00200000}, {5100,0.00200000}, {5150,0.00200000}, {5200,0.00200000}, {5250,0.00200000}, {5300,0.00200909}, {5350,0.00200000}, {5400,0.01005455}, {5450,0.00200000}, {5500,0.00200000}, {5550,0.00200000}, {5600,0.00200000}, {5650,0.00203636}, {5700,0.00204545}, {5750,0.00210000}, {5800,0.00207273}, {5850,0.00218182}, {5900,0.00293636}, {5950,0.00238182}, {6000,0.00247273}, {6050,0.00257273}, {6100,0.00265455}, {6150,0.00268182}, {6200,0.00273636}, {6250,0.00272727}, {6300,0.00282727}, {6350,0.00273636}, {6400,0.00277273}, {6450,0.00279091}, {6500,0.00280000}, {6550,0.00279091}, {6600,0.00284545}, {6650,0.00286364}, {6700,0.00290909}, {6750,0.00297273}, {6800,0.00299091}, {6850,0.00300000}, {6900,0.00299091}, {6950,0.00300000}, {7000,0.00300000}, {7050,0.00300000}, {7100,0.00300000}, {7150,0.00300000}, {7200,0.00320000}, {7250,0.00300000}, {7300,0.00300000}, {7350,0.00300000}, {7400,0.00300909}, {7450,0.00300000}, {7500,0.00301818}, {7550,0.00304545}, {7600,0.00302727}, {7650,0.00304545}, {7700,0.00309091}, {7750,0.00314545}, {7800,0.00322727}, {7850,0.00336364}, {7900,0.01564545}, {7950,0.00347273}, {8000,0.00380909}, {8050,0.00362727}, {8100,0.00390000}, {8150,0.00371818}, {8200,0.00370909}, {8250,0.00373636}, {8300,0.00372727}, {8350,0.00373636}, {8400,0.00373636}, {8450,0.00375455}, {8500,0.00376364}, {8550,0.00376364}, {8600,0.00379091}, {8650,0.00380000}, {8700,0.00381818}, {8750,0.00388182}, {8800,0.00391818}, {8850,0.00394545}, {8900,0.00395455}, {8950,0.00397273}, {9000,0.00410909}, {9050,0.00400000}, {9100,0.00399091}, {9150,0.00400000}, {9200,0.00400000}, {9250,0.00400000}, {9300,0.00400909}, {9350,0.00430909}, {9400,0.01606364}, {9450,0.00403636}, {9500,0.00400909}, {9550,0.00408182}, {9600,0.00410000}, {9650,0.00412727}, {9700,0.00437273}, {9750,0.00426364}, {9800,0.00430909}, {9850,0.00440909}, {9900,0.01612727}, {9950,0.00456364}, {10000,0.00456364}, {10100,0.00469091}, {10200,0.00468182}, {10300,0.00492727}, {10400,0.00470000}, {10500,0.01610000}, {10600,0.00474545}, {10700,0.00476364}, {10800,0.00505455}, {10900,0.00488182}, {11000,0.00492727}, {11100,0.00495455}, {11200,0.00500000}, {11300,0.01565455}, {11400,0.00523636}, {11500,0.00528182}, {11600,0.02371818}, {11700,0.00523636}, {11800,0.00525455}, {11900,0.00555455}, {12000,0.00560909}, {12100,0.00568182}, {12200,0.00570000}, {12300,0.00571818}, {12400,0.00570909}, {12500,0.00570909}, {12600,0.00570909}, {12700,0.00570909}, {12800,0.00573636}, {12900,0.00575455}, {13000,0.02557273}, {13100,0.00588182}, {13200,0.00595455}, {13300,0.00600000}, {13400,0.02863636}, {13500,0.00610909}, {13600,0.00614545}, {13700,0.00624545}, {13800,0.00643636}, {13900,0.00656364}, {14000,0.00662727}, {14100,0.00668182}, {14200,0.01676364}, {14300,0.00672727}, {14400,0.00672727}, {14500,0.00672727}, {14600,0.00670909}, {14700,0.00670000}, {14800,0.00857273}, {14900,0.00670909}, {15000,0.00670909}, {15100,0.00680909}, {15200,0.10324545}, {15300,0.00690000}, {15400,0.00693636}, {15500,0.00708182}, {15600,0.00716364}, {15700,0.00733636}, {15800,0.00745455}, {15900,0.00756364}, {16000,0.00763636}, {16100,0.00768182}, {16200,0.00770909}, {16300,0.00770909}, {16400,0.00771818}, {16500,0.00770909}, {16600,0.00770909}, {16700,0.00773636}, {16800,0.00772727}, {16900,0.00773636}, {17000,0.00772727}, {17100,0.00776364}, {17200,0.11105455}, {17300,0.00790909}, {17400,0.09506364}, {17500,0.00813636}, {17600,0.00826364}, {17700,0.01022727}, {17800,0.00851818}, {17900,0.00863636}, {18000,0.00869091}, {18100,0.00869091}, {18200,0.11855455}, {18300,0.01066364}, {18400,0.00872727}, {18500,0.01057273}, {18600,0.10838182}, {18700,0.00872727}, {18800,0.00874545}, {18900,0.00874545}, {19000,0.00875455}, {19100,0.11700909}, {19200,0.00878182}, {19300,0.00885455}, {19400,0.00891818}, {19500,0.00909091}, {19600,0.10548182}, {19700,0.00930909}, {19800,0.00950909}, {19900,0.00957273}, {20000,0.00964815}};
data["big_flat"]["TemplateCoq"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003604}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00006306}, {10,0.00000000}, {11,0.00002703}, {12,0.00006306}, {13,0.00000000}, {14,0.00002703}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00002703}, {23,0.00003604}, {24,0.00002703}, {25,0.00007207}, {26,0.00003604}, {27,0.00002703}, {28,0.00000000}, {29,0.00005405}, {30,0.00006306}, {31,0.00002703}, {32,0.00000000}, {33,0.00000000}, {34,0.00003604}, {35,0.00003604}, {36,0.00009910}, {37,0.00002703}, {38,0.00006306}, {39,0.00003604}, {40,0.00006306}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00007207}, {46,0.00009910}, {47,0.00000000}, {48,0.00003604}, {49,0.00003604}, {50,0.00012613}, {51,0.00013514}, {52,0.00012613}, {53,0.00003604}, {54,0.00010811}, {55,0.00005405}, {56,0.00002703}, {57,0.00010811}, {58,0.00006306}, {59,0.00000000}, {60,0.00002703}, {61,0.00000000}, {62,0.00005405}, {63,0.00006306}, {64,0.00006306}, {65,0.00013514}, {66,0.00002703}, {67,0.00005405}, {68,0.00006306}, {69,0.00007207}, {70,0.00000000}, {71,0.00006306}, {72,0.00000000}, {73,0.00009910}, {74,0.00000000}, {75,0.00000000}, {76,0.00002703}, {77,0.00015315}, {78,0.00005405}, {79,0.00009009}, {80,0.00008108}, {81,0.00000000}, {82,0.00009910}, {83,0.00000000}, {84,0.00000000}, {85,0.00003604}, {86,0.00003604}, {87,0.00006306}, {88,0.00002703}, {89,0.00009009}, {90,0.00000000}, {91,0.00005405}, {92,0.00000000}, {93,0.00009009}, {94,0.00003604}, {95,0.00007207}, {96,0.00016216}, {97,0.00002703}, {98,0.00002703}, {99,0.00015315}, {100,0.00002703}, {101,0.00002703}, {102,0.00009009}, {103,0.00006306}, {104,0.00022523}, {105,0.00009009}, {106,0.00009910}, {107,0.00009910}, {108,0.00012613}, {109,0.00017117}, {110,0.00000000}, {111,0.00009009}, {112,0.00009910}, {113,0.00002703}, {114,0.00007207}, {115,0.00009910}, {116,0.00006306}, {117,0.00009009}, {118,0.00009009}, {119,0.00009910}, {120,0.00010811}, {121,0.00007207}, {122,0.00014414}, {123,0.00006306}, {124,0.00003604}, {125,0.00017117}, {126,0.00010811}, {127,0.00003604}, {128,0.00009910}, {129,0.00015315}, {130,0.00009910}, {131,0.00003604}, {132,0.00016216}, {133,0.00013514}, {134,0.00018919}, {135,0.00012613}, {136,0.00013514}, {137,0.00009009}, {138,0.00029730}, {139,0.00003604}, {140,0.00003604}, {141,0.00013514}, {142,0.00009009}, {143,0.00009009}, {144,0.00009009}, {145,0.00015315}, {146,0.00013514}, {147,0.00009009}, {148,0.00016216}, {149,0.00006306}, {150,0.00003604}, {151,0.00000000}, {152,0.00006306}, {153,0.00017117}, {154,0.00006306}, {155,0.00009910}, {156,0.00009910}, {157,0.00009910}, {158,0.00009910}, {159,0.00014414}, {160,0.00002703}, {161,0.00018919}, {162,0.00019820}, {163,0.00009009}, {164,0.00003604}, {165,0.00000000}, {166,0.00007207}, {167,0.00024324}, {168,0.00016216}, {169,0.00009910}, {170,0.00033333}, {171,0.00018919}, {172,0.00018018}, {173,0.00007207}, {174,0.00013514}, {175,0.00010811}, {176,0.00013514}, {177,0.00009910}, {178,0.00007207}, {179,0.00009009}, {180,0.00012613}, {181,0.00017117}, {182,0.00013514}, {183,0.00000000}, {184,0.00005405}, {185,0.00003604}, {186,0.00014414}, {187,0.00010811}, {188,0.00005405}, {189,0.00019820}, {190,0.00003604}, {191,0.00009910}, {192,0.00019820}, {193,0.00009009}, {194,0.00008108}, {195,0.00010811}, {196,0.00009009}, {197,0.00002703}, {198,0.00009009}, {199,0.00025225}, {200,0.00009009}, {201,0.00002703}, {202,0.00000000}, {203,0.00010811}, {204,0.00020721}, {205,0.00009910}, {206,0.00003604}, {207,0.00009009}, {208,0.00009009}, {209,0.00021622}, {210,0.00010811}, {211,0.00011712}, {212,0.00009910}, {213,0.00007207}, {214,0.00032432}, {215,0.00023423}, {216,0.00017117}, {217,0.00017117}, {218,0.00019820}, {219,0.00005405}, {220,0.00012613}, {221,0.00003604}, {222,0.00013514}, {223,0.00014414}, {224,0.00022523}, {225,0.00012613}, {226,0.00017117}, {227,0.00016216}, {228,0.00009910}, {229,0.00009910}, {230,0.00018919}, {231,0.00023423}, {232,0.00026126}, {233,0.00020721}, {234,0.00011712}, {235,0.00014414}, {236,0.00009910}, {237,0.00021622}, {238,0.00006306}, {239,0.00002703}, {240,0.00008108}, {241,0.00013514}, {242,0.00019820}, {243,0.00006306}, {244,0.00003604}, {245,0.00012613}, {246,0.00006306}, {247,0.00022523}, {248,0.00018018}, {249,0.00021622}, {250,0.00014414}, {251,0.00003604}, {252,0.00018919}, {253,0.00016216}, {254,0.00020721}, {255,0.00029730}, {256,0.00023423}, {257,0.00010811}, {258,0.00008108}, {259,0.00020721}, {260,0.00016216}, {261,0.00014414}, {262,0.00010811}, {263,0.00019820}, {264,0.00009009}, {265,0.00019820}, {266,0.00021622}, {267,0.00009910}, {268,0.00036937}, {269,0.00013514}, {270,0.00009910}, {271,0.00009009}, {272,0.00006306}, {273,0.00009009}, {274,0.00017117}, {275,0.00019820}, {276,0.00015315}, {277,0.00019820}, {278,0.00000000}, {279,0.00025225}, {280,0.00029730}, {281,0.00027027}, {282,0.00009910}, {283,0.00016216}, {284,0.00017117}, {285,0.00024324}, {286,0.00027928}, {287,0.00015315}, {288,0.00015315}, {289,0.00018018}, {290,0.00027027}, {291,0.00013514}, {292,0.00024324}, {293,0.00023423}, {294,0.00023423}, {295,0.00019820}, {296,0.00029730}, {297,0.00020721}, {298,0.00006306}, {299,0.00015315}, {300,0.00009009}, {301,0.00009910}, {302,0.00011712}, {303,0.00013514}, {304,0.00006306}, {305,0.00022523}, {306,0.00010811}, {307,0.00027027}, {308,0.00016216}, {309,0.00025225}, {310,0.00030631}, {311,0.00031532}, {312,0.00003604}, {313,0.00000000}, {314,0.00035135}, {315,0.00007207}, {316,0.00009910}, {317,0.00014414}, {318,0.00026126}, {319,0.00027928}, {320,0.00016216}, {321,0.00021622}, {322,0.00019820}, {323,0.00015315}, {324,0.00009910}, {325,0.00005405}, {326,0.00019820}, {327,0.00021622}, {328,0.00025225}, {329,0.00024324}, {330,0.00007207}, {331,0.00017117}, {332,0.00019820}, {333,0.00003604}, {334,0.00025225}, {335,0.00019820}, {336,0.00009009}, {337,0.00018919}, {338,0.00027928}, {339,0.00036036}, {340,0.00022523}, {341,0.00028829}, {342,0.00011712}, {343,0.00019820}, {344,0.00006306}, {345,0.00019820}, {346,0.00017117}, {347,0.00020721}, {348,0.00009910}, {349,0.00018919}, {350,0.00031532}, {351,0.00021622}, {352,0.00013514}, {353,0.00023423}, {354,0.00024324}, {355,0.00015315}, {356,0.00020721}, {357,0.00017117}, {358,0.00015315}, {359,0.00023423}, {360,0.00012613}, {361,0.00013514}, {362,0.00013514}, {363,0.00028829}, {364,0.00009910}, {365,0.00012613}, {366,0.00017117}, {367,0.00010811}, {368,0.00007207}, {369,0.00009009}, {370,0.00027027}, {371,0.00026126}, {372,0.00037838}, {373,0.00042342}, {374,0.00023423}, {375,0.00024324}, {376,0.00010811}, {377,0.00027027}, {378,0.00028829}, {379,0.00009009}, {380,0.00013514}, {381,0.00032432}, {382,0.00009910}, {383,0.00021622}, {384,0.00020721}, {385,0.00032432}, {386,0.00005405}, {387,0.00028829}, {388,0.00026126}, {389,0.00015315}, {390,0.00017117}, {391,0.00029730}, {392,0.00029730}, {393,0.00030631}, {394,0.00027027}, {395,0.00024324}, {396,0.00026126}, {397,0.00022523}, {398,0.00018018}, {399,0.00017117}, {400,0.00009009}, {401,0.00022523}, {402,0.00018018}, {403,0.00027027}, {404,0.00012613}, {405,0.00003604}, {406,0.00031532}, {407,0.00009910}, {408,0.00012613}, {409,0.00019820}, {410,0.00024324}, {411,0.00022523}, {412,0.00019820}, {413,0.00022523}, {414,0.00026126}, {415,0.00020909}, {416,0.00018182}, {417,0.00006364}, {418,0.00011818}, {419,0.00031818}, {420,0.00026364}, {421,0.00018182}, {422,0.00020909}, {423,0.00027273}, {424,0.00029091}, {425,0.00012727}, {426,0.00028182}, {427,0.00023636}, {428,0.00023636}, {429,0.00023636}, {430,0.00040000}, {431,0.00032727}, {432,0.00031818}, {433,0.00019091}, {434,0.00020000}, {435,0.00033636}, {436,0.00043636}, {437,0.00030909}, {438,0.00021818}, {439,0.00026364}, {440,0.00043636}, {441,0.00023636}, {442,0.00014545}, {443,0.00022727}, {444,0.00033636}, {445,0.00036364}, {446,0.00030909}, {447,0.00014545}, {448,0.00015455}, {449,0.00014545}, {450,0.00017273}, {451,0.00028182}, {452,0.00030000}, {453,0.00020909}, {454,0.00023636}, {455,0.00020909}, {456,0.00038182}, {457,0.00033636}, {458,0.00021818}, {459,0.00021818}, {460,0.00015455}, {461,0.00012727}, {462,0.00016364}, {463,0.00040909}, {464,0.00057273}, {465,0.00056364}, {466,0.00024545}, {467,0.00015455}, {468,0.00038182}, {469,0.00017273}, {470,0.00039091}, {471,0.00026364}, {472,0.00022727}, {473,0.00021818}, {474,0.00039091}, {475,0.00039091}, {476,0.00020000}, {477,0.00015455}, {478,0.00024545}, {479,0.00031818}, {480,0.00011818}, {481,0.00040000}, {482,0.00026364}, {483,0.00016364}, {484,0.00026364}, {485,0.00016364}, {486,0.00026364}, {487,0.00020000}, {488,0.00035455}, {489,0.00039091}, {490,0.00043636}, {491,0.00016364}, {492,0.00032727}, {493,0.00039091}, {494,0.00034545}, {495,0.00022727}, {496,0.00039091}, {497,0.00039091}, {498,0.00020909}, {499,0.00018182}, {500,0.00057273}, {505,0.00015455}, {510,0.00026364}, {515,0.00027273}, {520,0.00020000}, {525,0.00034545}, {530,0.00025455}, {535,0.00025455}, {540,0.00020909}, {545,0.00024545}, {550,0.00010000}, {555,0.00030909}, {560,0.00024545}, {565,0.00020000}, {570,0.00025455}, {575,0.00038182}, {580,0.00016364}, {585,0.00024545}, {590,0.00030909}, {595,0.00014545}, {600,0.00030000}, {605,0.00026364}, {610,0.00036364}, {615,0.00032727}, {620,0.00045455}, {625,0.00046364}, {630,0.00030000}, {635,0.00023636}, {640,0.00035455}, {645,0.00040909}, {650,0.00023636}, {655,0.00030000}, {660,0.00052727}, {665,0.00043636}, {670,0.00025455}, {675,0.00041818}, {680,0.00022727}, {685,0.00041818}, {690,0.00027273}, {695,0.00046364}, {700,0.00040000}, {705,0.00026364}, {710,0.00041818}, {715,0.00023636}, {720,0.00045455}, {725,0.00044545}, {730,0.00035455}, {735,0.00050909}, {740,0.00029091}, {745,0.00042727}, {750,0.00034545}, {755,0.00040909}, {760,0.00020909}, {765,0.00027273}, {770,0.00048182}, {775,0.00048182}, {780,0.00050909}, {785,0.00066364}, {790,0.00050000}, {795,0.00054545}, {800,0.00034545}, {805,0.00036364}, {810,0.00054545}, {815,0.00039091}, {820,0.00037273}, {825,0.00033636}, {830,0.00036364}, {835,0.00016364}, {840,0.00029091}, {845,0.00029091}, {850,0.00038182}, {855,0.00040909}, {860,0.00038182}, {865,0.00030000}, {870,0.00054545}, {875,0.00040000}, {880,0.00041818}, {885,0.00046364}, {890,0.00035455}, {895,0.00055455}, {900,0.00055455}, {905,0.00050909}, {910,0.00032727}, {915,0.00041818}, {920,0.00052727}, {925,0.00039091}, {930,0.00059091}, {935,0.00040909}, {940,0.00040000}, {945,0.00043636}, {950,0.00059091}, {955,0.00058182}, {960,0.00016364}, {965,0.00042727}, {970,0.00030909}, {975,0.00049091}, {980,0.00039091}, {985,0.00053636}, {990,0.00057273}, {995,0.00045455}, {1000,0.00036364}, {1010,0.00036364}, {1020,0.00060909}, {1030,0.00043636}, {1040,0.00050000}, {1050,0.00056364}, {1060,0.00050000}, {1070,0.00067273}, {1080,0.00050000}, {1090,0.00053636}, {1100,0.00043636}, {1110,0.00048182}, {1120,0.00067273}, {1130,0.00054545}, {1140,0.00044545}, {1150,0.00073636}, {1160,0.00041818}, {1170,0.00061818}, {1180,0.00070909}, {1190,0.00079091}, {1200,0.00087273}, {1210,0.00089091}, {1220,0.00071818}, {1230,0.00040909}, {1240,0.00077273}, {1250,0.00032727}, {1260,0.00065455}, {1270,0.00040909}, {1280,0.00080000}, {1290,0.00039091}, {1300,0.00040909}, {1310,0.00084545}, {1320,0.00064545}, {1330,0.00083636}, {1340,0.00048182}, {1350,0.00073636}, {1360,0.00073636}, {1370,0.00069091}, {1380,0.00069091}, {1390,0.00057273}, {1400,0.00085455}, {1410,0.00083636}, {1420,0.00050909}, {1430,0.00054545}, {1440,0.00059091}, {1450,0.00061818}, {1460,0.00084545}, {1470,0.00068182}, {1480,0.00088182}, {1490,0.00076364}, {1500,0.00041818}, {1510,0.00081818}, {1520,0.00114545}, {1530,0.00069091}, {1540,0.00101818}, {1550,0.00081818}, {1560,0.00053636}, {1570,0.00076364}, {1580,0.00088182}, {1590,0.00070909}, {1600,0.00085455}, {1610,0.00104545}, {1620,0.00088182}, {1630,0.00062727}, {1640,0.00081818}, {1650,0.00075455}, {1660,0.00090909}, {1670,0.00082727}, {1680,0.00082727}, {1690,0.00110909}, {1700,0.00068182}, {1710,0.00048182}, {1720,0.00081818}, {1730,0.00097273}, {1740,0.00073636}, {1750,0.00034545}, {1760,0.00065455}, {1770,0.00108182}, {1780,0.00057273}, {1790,0.00080909}, {1800,0.00071818}, {1810,0.00083636}, {1820,0.00110000}, {1830,0.00080909}, {1840,0.00059091}, {1850,0.00077273}, {1860,0.00116364}, {1870,0.00100000}, {1880,0.00088182}, {1890,0.00083636}, {1900,0.00087273}, {1910,0.00089091}, {1920,0.00150000}, {1930,0.00093636}, {1940,0.00078182}, {1950,0.00095455}, {1960,0.00085455}, {1970,0.00067273}, {1980,0.00080000}, {1990,0.00091818}, {2000,0.00108182}, {2050,0.00090909}, {2100,0.00079091}, {2150,0.00110000}, {2200,0.00107273}, {2250,0.00084545}, {2300,0.00104545}, {2350,0.00064545}, {2400,0.00094545}, {2450,0.00120000}, {2500,0.00097273}, {2550,0.00087273}, {2600,0.00152727}, {2650,0.00093636}, {2700,0.00143636}, {2750,0.00108182}, {2800,0.00131818}, {2850,0.00159091}, {2900,0.00144545}, {2950,0.00121818}, {3000,0.00135455}, {3050,0.00114545}, {3100,0.00135455}, {3150,0.00119091}, {3200,0.00134545}, {3250,0.00118182}, {3300,0.00130000}, {3350,0.00122727}, {3400,0.00126364}, {3450,0.00128182}, {3500,0.00150000}, {3550,0.00134545}, {3600,0.00129091}, {3650,0.00139091}, {3700,0.00159091}, {3750,0.00148182}, {3800,0.00170909}, {3850,0.00158182}, {3900,0.00480909}, {3950,0.00156364}, {4000,0.00158182}, {4050,0.00170909}, {4100,0.00452727}, {4150,0.00155455}, {4200,0.00160909}, {4250,0.00172727}, {4300,0.00167273}, {4350,0.00175455}, {4400,0.00183636}, {4450,0.00179091}, {4500,0.00185455}, {4550,0.00160000}, {4600,0.00164545}, {4650,0.00190909}, {4700,0.00196364}, {4750,0.00158182}, {4800,0.00200909}, {4850,0.00183636}, {4900,0.00169091}, {4950,0.00173636}, {5000,0.00198182}, {5050,0.00189091}, {5100,0.00188182}, {5150,0.00200000}, {5200,0.00188182}, {5250,0.00219091}, {5300,0.00203636}, {5350,0.00210909}, {5400,0.00979091}, {5450,0.00213636}, {5500,0.00203636}, {5550,0.00234545}, {5600,0.00240909}, {5650,0.00221818}, {5700,0.00249091}, {5750,0.00204545}, {5800,0.00238182}, {5850,0.00250000}, {5900,0.00295455}, {5950,0.00238182}, {6000,0.00254545}, {6050,0.00264545}, {6100,0.00265455}, {6150,0.00262727}, {6200,0.00242727}, {6250,0.00243636}, {6300,0.00260000}, {6350,0.00243636}, {6400,0.00251818}, {6450,0.00262727}, {6500,0.00258182}, {6550,0.00256364}, {6600,0.00278182}, {6650,0.00295455}, {6700,0.00268182}, {6750,0.00268182}, {6800,0.00285455}, {6850,0.00285455}, {6900,0.00299091}, {6950,0.00282727}, {7000,0.00274545}, {7050,0.00296364}, {7100,0.00284545}, {7150,0.00287273}, {7200,0.00310000}, {7250,0.00275455}, {7300,0.00294545}, {7350,0.00323636}, {7400,0.00304545}, {7450,0.00270909}, {7500,0.00290909}, {7550,0.00325455}, {7600,0.00314545}, {7650,0.00300909}, {7700,0.00307273}, {7750,0.00310909}, {7800,0.00322727}, {7850,0.00317273}, {7900,0.01504545}, {7950,0.00323636}, {8000,0.00362727}, {8050,0.00340909}, {8100,0.00339091}, {8150,0.00331818}, {8200,0.00339091}, {8250,0.00347273}, {8300,0.00338182}, {8350,0.00354545}, {8400,0.00338182}, {8450,0.00346364}, {8500,0.00349091}, {8550,0.00352727}, {8600,0.00346364}, {8650,0.00361818}, {8700,0.00379091}, {8750,0.00367273}, {8800,0.00382727}, {8850,0.00382727}, {8900,0.00402727}, {8950,0.00374545}, {9000,0.00400909}, {9050,0.00393636}, {9100,0.00379091}, {9150,0.00400000}, {9200,0.00396364}, {9250,0.00434545}, {9300,0.00415455}, {9350,0.00450909}, {9400,0.01614545}, {9450,0.00417273}, {9500,0.00414545}, {9550,0.00418182}, {9600,0.00432727}, {9650,0.00437273}, {9700,0.00447273}, {9750,0.00433636}, {9800,0.00456364}, {9850,0.00440909}, {9900,0.01620000}, {9950,0.00428182}, {10000,0.00447273}, {10100,0.00443636}, {10200,0.00448182}, {10300,0.00511818}, {10400,0.00474545}, {10500,0.01613636}, {10600,0.00476364}, {10700,0.00449091}, {10800,0.00500909}, {10900,0.00489091}, {11000,0.00477273}, {11100,0.00524545}, {11200,0.00510909}, {11300,0.01578182}, {11400,0.00534545}, {11500,0.00569091}, {11600,0.02409091}, {11700,0.00528182}, {11800,0.00496364}, {11900,0.00520000}, {12000,0.00525455}, {12100,0.00541818}, {12200,0.00555455}, {12300,0.00546364}, {12400,0.00548182}, {12500,0.00576364}, {12600,0.00590909}, {12700,0.00570000}, {12800,0.00584545}, {12900,0.00585455}, {13000,0.02573636}, {13100,0.00586364}, {13200,0.00565455}, {13300,0.00593636}, {13400,0.02830000}, {13500,0.00610909}, {13600,0.00628182}, {13700,0.00598182}, {13800,0.00637273}, {13900,0.00631818}, {14000,0.00611818}, {14100,0.00620000}, {14200,0.01679091}, {14300,0.00664545}, {14400,0.00670000}, {14500,0.00655455}, {14600,0.00660909}, {14700,0.00634545}, {14800,0.00868182}, {14900,0.00680000}, {15000,0.00692727}, {15100,0.00694545}, {15200,0.10328182}, {15300,0.00690000}, {15400,0.00687273}, {15500,0.00684545}, {15600,0.00728182}, {15700,0.00723636}, {15800,0.00717273}, {15900,0.00707273}, {16000,0.00725455}, {16100,0.00727273}, {16200,0.00743636}, {16300,0.00724545}, {16400,0.00731818}, {16500,0.00773636}, {16600,0.00775455}, {16700,0.00771818}, {16800,0.00743636}, {16900,0.00785455}, {17000,0.00780909}, {17100,0.00800000}, {17200,0.11046364}, {17300,0.00811818}, {17400,0.09501818}, {17500,0.00785455}, {17600,0.00785455}, {17700,0.01021818}, {17800,0.00846364}, {17900,0.00861818}, {18000,0.00839091}, {18100,0.00849091}, {18200,0.11864545}, {18300,0.01074545}, {18400,0.00891818}, {18500,0.01080909}, {18600,0.10865455}, {18700,0.00879091}, {18800,0.00908182}, {18900,0.00893636}, {19000,0.00901818}, {19100,0.11673636}, {19200,0.00930000}, {19300,0.00912727}, {19400,0.00952727}, {19500,0.00941818}, {19600,0.10540909}, {19700,0.00938182}, {19800,0.00924545}, {19900,0.00975455}, {20000,0.00983333}};
data["big_flat"]["TemplateCoq"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00003604}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00003604}, {120,0.00000000}, {121,0.00000000}, {122,0.00003604}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00003604}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00003604}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00003604}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00002703}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00003604}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00003604}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00003604}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00003604}, {367,0.00000000}, {368,0.00003604}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00003604}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00003604}, {407,0.00000000}, {408,0.00003604}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00003636}, {418,0.00000000}, {419,0.00000000}, {420,0.00002727}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00003636}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00003636}, {451,0.00000000}, {452,0.00000000}, {453,0.00003636}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00003636}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00003636}, {482,0.00000000}, {483,0.00002727}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00003636}, {560,0.00003636}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00003636}, {605,0.00003636}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00003636}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00003636}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00003636}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00010909}, {810,0.00000000}, {815,0.00000000}, {820,0.00003636}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00003636}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00003636}, {890,0.00003636}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00002727}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00002727}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00003636}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00006364}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00002727}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00003636}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00002727}, {1330,0.00002727}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00002727}, {1380,0.00000000}, {1390,0.00003636}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00003636}, {1440,0.00007273}, {1450,0.00003636}, {1460,0.00000000}, {1470,0.00002727}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00003636}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00003636}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00003636}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00007273}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00007273}, {1750,0.00024545}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00003636}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00003636}, {1860,0.00003636}, {1870,0.00003636}, {1880,0.00003636}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00007273}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00003636}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00003636}, {1980,0.00000000}, {1990,0.00003636}, {2000,0.00005455}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00003636}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00003636}, {2450,0.00003636}, {2500,0.00007273}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00003636}, {2700,0.00003636}, {2750,0.00003636}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00010909}, {3100,0.00007273}, {3150,0.00010909}, {3200,0.00000000}, {3250,0.00003636}, {3300,0.00003636}, {3350,0.00007273}, {3400,0.00014545}, {3450,0.00000000}, {3500,0.00006364}, {3550,0.00003636}, {3600,0.00003636}, {3650,0.00003636}, {3700,0.00002727}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00003636}, {3900,0.00010909}, {3950,0.00003636}, {4000,0.00000000}, {4050,0.00002727}, {4100,0.00003636}, {4150,0.00003636}, {4200,0.00007273}, {4250,0.00003636}, {4300,0.00000000}, {4350,0.00003636}, {4400,0.00010909}, {4450,0.00003636}, {4500,0.00007273}, {4550,0.00010909}, {4600,0.00000000}, {4650,0.00010909}, {4700,0.00010909}, {4750,0.00003636}, {4800,0.00000000}, {4850,0.00007273}, {4900,0.00003636}, {4950,0.00013636}, {5000,0.00003636}, {5050,0.00010909}, {5100,0.00007273}, {5150,0.00010909}, {5200,0.00007273}, {5250,0.00010909}, {5300,0.00007273}, {5350,0.00000000}, {5400,0.00025455}, {5450,0.00007273}, {5500,0.00003636}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00003636}, {5750,0.00003636}, {5800,0.00000000}, {5850,0.00003636}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00007273}, {6150,0.00003636}, {6200,0.00003636}, {6250,0.00007273}, {6300,0.00003636}, {6350,0.00000000}, {6400,0.00010909}, {6450,0.00000000}, {6500,0.00010909}, {6550,0.00007273}, {6600,0.00007273}, {6650,0.00003636}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00003636}, {6900,0.00000000}, {6950,0.00003636}, {7000,0.00003636}, {7050,0.00003636}, {7100,0.00003636}, {7150,0.00007273}, {7200,0.00007273}, {7250,0.00014545}, {7300,0.00010909}, {7350,0.00007273}, {7400,0.00003636}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00003636}, {7750,0.00003636}, {7800,0.00003636}, {7850,0.00002727}, {7900,0.00003636}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00003636}, {8150,0.00003636}, {8200,0.00003636}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00003636}, {8650,0.00007273}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00003636}, {9050,0.00003636}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00006364}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00003636}, {9450,0.00003636}, {9500,0.00003636}, {9550,0.00000000}, {9600,0.00003636}, {9650,0.00003636}, {9700,0.00000000}, {9750,0.00003636}, {9800,0.00002727}, {9850,0.00000000}, {9900,0.00003636}, {9950,0.00003636}, {10000,0.00007273}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00003636}, {10400,0.00007273}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00003636}, {10800,0.00003636}, {10900,0.00003636}, {11000,0.00000000}, {11100,0.00003636}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00003636}, {11600,0.00000000}, {11700,0.00017273}, {11800,0.00014545}, {11900,0.00010909}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00006364}, {12300,0.00007273}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00007273}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00007273}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00013636}, {13400,0.00020909}, {13500,0.00007273}, {13600,0.00007273}, {13700,0.00003636}, {13800,0.00000000}, {13900,0.00010909}, {14000,0.00000000}, {14100,0.00003636}, {14200,0.00007273}, {14300,0.00003636}, {14400,0.00000000}, {14500,0.00007273}, {14600,0.00003636}, {14700,0.00003636}, {14800,0.00000000}, {14900,0.00003636}, {15000,0.00000000}, {15100,0.00003636}, {15200,0.00000000}, {15300,0.00003636}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00003636}, {16000,0.00000000}, {16100,0.00003636}, {16200,0.00000000}, {16300,0.00007273}, {16400,0.00000000}, {16500,0.00003636}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00003636}, {16900,0.00000000}, {17000,0.00003636}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00018182}, {17500,0.00000000}, {17600,0.00003636}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00003636}, {18000,0.00000000}, {18100,0.00003636}, {18200,0.00010909}, {18300,0.00003636}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00010909}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00003636}, {19000,0.00003636}, {19100,0.00003636}, {19200,0.00003636}, {19300,0.00003636}, {19400,0.00003636}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["TemplateCoq"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00005405}, {39,0.00012613}, {40,0.00019820}, {41,0.00045946}, {42,0.00084685}, {43,0.00099099}, {44,0.00100000}, {45,0.00100000}, {46,0.00100000}, {47,0.00100000}, {48,0.00100000}, {49,0.00100000}, {50,0.00100000}, {51,0.00100000}, {52,0.00100000}, {53,0.00100000}, {54,0.00100000}, {55,0.00100000}, {56,0.00100000}, {57,0.00100000}, {58,0.00100000}, {59,0.00100000}, {60,0.00100000}, {61,0.00100000}, {62,0.00100000}, {63,0.00100000}, {64,0.00100000}, {65,0.00100000}, {66,0.00100000}, {67,0.00100000}, {68,0.00100000}, {69,0.00100000}, {70,0.00100000}, {71,0.00100000}, {72,0.00100000}, {73,0.00100000}, {74,0.00100000}, {75,0.00100000}, {76,0.00100000}, {77,0.00100000}, {78,0.00100000}, {79,0.00100000}, {80,0.00100000}, {81,0.00100000}, {82,0.00100000}, {83,0.00100901}, {84,0.00100901}, {85,0.00105405}, {86,0.00105405}, {87,0.00114414}, {88,0.00296396}, {89,0.00135135}, {90,0.00145045}, {91,0.00172973}, {92,0.00178378}, {93,0.00187387}, {94,0.00193694}, {95,0.00197297}, {96,0.00199099}, {97,0.00200000}, {98,0.00200000}, {99,0.00200000}, {100,0.00200000}, {101,0.00200000}, {102,0.00200000}, {103,0.00200000}, {104,0.00200000}, {105,0.00200000}, {106,0.00200000}, {107,0.00200000}, {108,0.00297297}, {109,0.00200000}, {110,0.00200000}, {111,0.00200000}, {112,0.00200000}, {113,0.00200000}, {114,0.00200000}, {115,0.00200000}, {116,0.00200000}, {117,0.00200000}, {118,0.00200000}, {119,0.00200000}, {120,0.00200000}, {121,0.00200000}, {122,0.00200000}, {123,0.00200000}, {124,0.00200000}, {125,0.00201802}, {126,0.00201802}, {127,0.00200000}, {128,0.00200901}, {129,0.00206306}, {130,0.00207207}, {131,0.00209009}, {132,0.00212613}, {133,0.00218018}, {134,0.00232432}, {135,0.00240541}, {136,0.00249550}, {137,0.00256757}, {138,0.00271171}, {139,0.00280180}, {140,0.00337838}, {141,0.00284685}, {142,0.00293694}, {143,0.00295495}, {144,0.00295495}, {145,0.00299099}, {146,0.00300000}, {147,0.00300000}, {148,0.00300000}, {149,0.00300000}, {150,0.00300000}, {151,0.00300000}, {152,0.00300000}, {153,0.00301802}, {154,0.00300000}, {155,0.00300000}, {156,0.00300000}, {157,0.00300000}, {158,0.00300000}, {159,0.00300000}, {160,0.00300000}, {161,0.00300000}, {162,0.00300000}, {163,0.00300000}, {164,0.00300901}, {165,0.00300000}, {166,0.00300901}, {167,0.00300000}, {168,0.00300000}, {169,0.00300000}, {170,0.00300000}, {171,0.00300000}, {172,0.00302703}, {173,0.00301802}, {174,0.00304505}, {175,0.00306306}, {176,0.00306306}, {177,0.00316216}, {178,0.00326126}, {179,0.00334234}, {180,0.00344144}, {181,0.00353153}, {182,0.00363063}, {183,0.00372072}, {184,0.00377477}, {185,0.00385586}, {186,0.00388288}, {187,0.00394595}, {188,0.00394595}, {189,0.00399099}, {190,0.00397297}, {191,0.00400000}, {192,0.00400000}, {193,0.00400000}, {194,0.00399099}, {195,0.00400000}, {196,0.00399099}, {197,0.00400000}, {198,0.00400000}, {199,0.00400000}, {200,0.00400901}, {201,0.00400000}, {202,0.00400000}, {203,0.00400000}, {204,0.00400000}, {205,0.00400000}, {206,0.00400000}, {207,0.00400000}, {208,0.00400000}, {209,0.00400000}, {210,0.00401802}, {211,0.00400000}, {212,0.00400000}, {213,0.00400000}, {214,0.00400000}, {215,0.00400000}, {216,0.00400000}, {217,0.00400000}, {218,0.00403604}, {219,0.00403604}, {220,0.00407207}, {221,0.00406306}, {222,0.00409910}, {223,0.00413514}, {224,0.00420721}, {225,0.00432432}, {226,0.00437838}, {227,0.00448649}, {228,0.00457658}, {229,0.00465766}, {230,0.00557658}, {231,0.00480180}, {232,0.00481081}, {233,0.00484685}, {234,0.00488288}, {235,0.00490991}, {236,0.00493694}, {237,0.00495495}, {238,0.00500000}, {239,0.00594595}, {240,0.00499099}, {241,0.00499099}, {242,0.00498198}, {243,0.00499099}, {244,0.00499099}, {245,0.00500000}, {246,0.00500000}, {247,0.00503604}, {248,0.00500000}, {249,0.00500000}, {250,0.00500000}, {251,0.00500000}, {252,0.00500000}, {253,0.00500000}, {254,0.00500000}, {255,0.00500000}, {256,0.00613514}, {257,0.00500000}, {258,0.00500901}, {259,0.00504505}, {260,0.00500901}, {261,0.00500000}, {262,0.00500901}, {263,0.00501802}, {264,0.00736036}, {265,0.00502703}, {266,0.00504505}, {267,0.00506306}, {268,0.00511712}, {269,0.00510811}, {270,0.00518919}, {271,0.00529730}, {272,0.00832432}, {273,0.00545946}, {274,0.00555856}, {275,0.00567568}, {276,0.00575676}, {277,0.00573874}, {278,0.00581982}, {279,0.00583784}, {280,0.00792793}, {281,0.00586486}, {282,0.00589189}, {283,0.00587387}, {284,0.00591892}, {285,0.00596396}, {286,0.00597297}, {287,0.00600000}, {288,0.00599099}, {289,0.00600000}, {290,0.00599099}, {291,0.00600000}, {292,0.00600000}, {293,0.00600000}, {294,0.00600000}, {295,0.00761261}, {296,0.00600000}, {297,0.00600000}, {298,0.00600000}, {299,0.00600000}, {300,0.00600000}, {301,0.00600000}, {302,0.00814414}, {303,0.00600000}, {304,0.00600000}, {305,0.00600000}, {306,0.00600000}, {307,0.00601802}, {308,0.00600000}, {309,0.01071171}, {310,0.00602703}, {311,0.00604505}, {312,0.00605405}, {313,0.00608108}, {314,0.00611712}, {315,0.00618919}, {316,0.00880180}, {317,0.00622523}, {318,0.00638739}, {319,0.00638739}, {320,0.00646847}, {321,0.00652252}, {322,0.00663063}, {323,0.00903604}, {324,0.00672973}, {325,0.00675676}, {326,0.00679279}, {327,0.00684685}, {328,0.00690991}, {329,0.00695495}, {330,0.00782883}, {331,0.00690991}, {332,0.00694595}, {333,0.00695495}, {334,0.00697297}, {335,0.00697297}, {336,0.00870270}, {337,0.00700000}, {338,0.00700000}, {339,0.00700000}, {340,0.00700000}, {341,0.00700000}, {342,0.00703604}, {343,0.00700000}, {344,0.00700000}, {345,0.00700000}, {346,0.00700000}, {347,0.00700000}, {348,0.00700901}, {349,0.00878378}, {350,0.00700000}, {351,0.00700000}, {352,0.00700901}, {353,0.00700000}, {354,0.00701802}, {355,0.00883784}, {356,0.00702703}, {357,0.00706306}, {358,0.00702703}, {359,0.00704505}, {360,0.00711712}, {361,0.00924324}, {362,0.00717117}, {363,0.00722523}, {364,0.00720721}, {365,0.00727928}, {366,0.00736937}, {367,0.01125225}, {368,0.00750450}, {369,0.00762162}, {370,0.00764865}, {371,0.00774775}, {372,0.00772973}, {373,0.01096396}, {374,0.00779279}, {375,0.00783784}, {376,0.00787387}, {377,0.00785586}, {378,0.00789189}, {379,0.00903604}, {380,0.00790991}, {381,0.00795495}, {382,0.00794595}, {383,0.00794595}, {384,0.00805405}, {385,0.00897297}, {386,0.00799099}, {387,0.00799099}, {388,0.00800000}, {389,0.00800000}, {390,0.00990991}, {391,0.00800000}, {392,0.00801802}, {393,0.00800000}, {394,0.00800000}, {395,0.00805405}, {396,0.00967568}, {397,0.00800901}, {398,0.00800901}, {399,0.00800000}, {400,0.00801802}, {401,0.00807207}, {402,0.00802703}, {403,0.00804505}, {404,0.00806306}, {405,0.00802703}, {406,0.00804505}, {407,0.00983784}, {408,0.00816216}, {409,0.00815315}, {410,0.00826126}, {411,0.00831532}, {412,0.01067568}, {413,0.00840541}, {414,0.00851351}, {415,0.00860000}, {416,0.00858182}, {417,0.00871818}, {418,0.00870000}, {419,0.00872727}, {420,0.00874545}, {421,0.00877273}, {422,0.00880000}, {423,0.01008182}, {424,0.00883636}, {425,0.00884545}, {426,0.00886364}, {427,0.00888182}, {428,0.01018182}, {429,0.00891818}, {430,0.00894545}, {431,0.00895455}, {432,0.00895455}, {433,0.01066364}, {434,0.00898182}, {435,0.00900000}, {436,0.00899091}, {437,0.00899091}, {438,0.01078182}, {439,0.00900000}, {440,0.00900000}, {441,0.00900000}, {442,0.00900000}, {443,0.01091818}, {444,0.00900000}, {445,0.00901818}, {446,0.00900000}, {447,0.00904545}, {448,0.01087273}, {449,0.00900000}, {450,0.00902727}, {451,0.00903636}, {452,0.00908182}, {453,0.01091818}, {454,0.00912727}, {455,0.00917273}, {456,0.00916364}, {457,0.00927273}, {458,0.01093636}, {459,0.00935455}, {460,0.00942727}, {461,0.00951818}, {462,0.00955455}, {463,0.00963636}, {464,0.00970000}, {465,0.00969091}, {466,0.00967273}, {467,0.00979091}, {468,0.00977273}, {469,0.00979091}, {470,0.00978182}, {471,0.00976364}, {472,0.01166364}, {473,0.00982727}, {474,0.00984545}, {475,0.00990000}, {476,0.00990000}, {477,0.01121818}, {478,0.00990000}, {479,0.00992727}, {480,0.00989091}, {481,0.00996364}, {482,0.00997273}, {483,0.00996364}, {484,0.00999091}, {485,0.01000000}, {486,0.01175455}, {487,0.00999091}, {488,0.01000000}, {489,0.01000000}, {490,0.01005455}, {491,0.01000000}, {492,0.01000000}, {493,0.01001818}, {494,0.01000000}, {495,0.01187273}, {496,0.01002727}, {497,0.01008182}, {498,0.01002727}, {499,0.01008182}, {500,0.01006364}, {505,0.01026364}, {510,0.01060000}, {515,0.01073636}, {520,0.01243636}, {525,0.01090909}, {530,0.01099091}, {535,0.01100000}, {540,0.01295455}, {545,0.01115455}, {550,0.01126364}, {555,0.01147273}, {560,0.01358182}, {565,0.01176364}, {570,0.01182727}, {575,0.01190909}, {580,0.01383636}, {585,0.01200000}, {590,0.01204545}, {595,0.01220000}, {600,0.01410000}, {605,0.01265455}, {610,0.01272727}, {615,0.01283636}, {620,0.01288182}, {625,0.01290000}, {630,0.01300000}, {635,0.01517273}, {640,0.01314545}, {645,0.01330000}, {650,0.01353636}, {655,0.01369091}, {660,0.01375455}, {665,0.01378182}, {670,0.01588182}, {675,0.01395455}, {680,0.01400000}, {685,0.01670909}, {690,0.01428182}, {695,0.01445455}, {700,0.01470909}, {705,0.01470000}, {710,0.01476364}, {715,0.01494545}, {720,0.01488182}, {725,0.01499091}, {730,0.01502727}, {735,0.01510909}, {740,0.01540000}, {745,0.01553636}, {750,0.01728182}, {755,0.01575455}, {760,0.01577273}, {765,0.01580909}, {770,0.01590000}, {775,0.01601818}, {780,0.01618182}, {785,0.01628182}, {790,0.01660000}, {795,0.01669091}, {800,0.01674545}, {805,0.02036364}, {810,0.01679091}, {815,0.01688182}, {820,0.02395455}, {825,0.01702727}, {830,0.01718182}, {835,0.01971818}, {840,0.01756364}, {845,0.01773636}, {850,0.01771818}, {855,0.01779091}, {860,0.02072727}, {865,0.01787273}, {870,0.01806364}, {875,0.01820000}, {880,0.01830909}, {885,0.02180000}, {890,0.01862727}, {895,0.01873636}, {900,0.02113636}, {905,0.01880909}, {910,0.02250000}, {915,0.01898182}, {920,0.01914545}, {925,0.02657273}, {930,0.01949091}, {935,0.02263636}, {940,0.01967273}, {945,0.01988182}, {950,0.01974545}, {955,0.01981818}, {960,0.02277273}, {965,0.02001818}, {970,0.02370000}, {975,0.02046364}, {980,0.02050909}, {985,0.02066364}, {990,0.02071818}, {995,0.02373636}, {1000,0.02077273}, {1010,0.02430909}, {1020,0.02139091}, {1030,0.02842727}, {1040,0.02174545}, {1050,0.02200000}, {1060,0.02204545}, {1070,0.02239091}, {1080,0.02269091}, {1090,0.02280000}, {1100,0.02626364}, {1110,0.02313636}, {1120,0.02623636}, {1130,0.02371818}, {1140,0.02670909}, {1150,0.02397273}, {1160,0.02719091}, {1170,0.02463636}, {1180,0.02472727}, {1190,0.02481818}, {1200,0.02504545}, {1210,0.02560909}, {1220,0.02563636}, {1230,0.03413636}, {1240,0.02587273}, {1250,0.03363636}, {1260,0.02650000}, {1270,0.03101818}, {1280,0.02682727}, {1290,0.03060000}, {1300,0.02759091}, {1310,0.02760000}, {1320,0.03206364}, {1330,0.02791818}, {1340,0.03176364}, {1350,0.02844545}, {1360,0.02862727}, {1370,0.03616364}, {1380,0.02891818}, {1390,0.03955455}, {1400,0.02950000}, {1410,0.02970000}, {1420,0.03447273}, {1430,0.02999091}, {1440,0.03368182}, {1450,0.03957273}, {1460,0.03075455}, {1470,0.03899091}, {1480,0.03130909}, {1490,0.03137273}, {1500,0.03610000}, {1510,0.03208182}, {1520,0.03191818}, {1530,0.03674545}, {1540,0.03269091}, {1550,0.03267273}, {1560,0.03700909}, {1570,0.04541818}, {1580,0.03331818}, {1590,0.04370909}, {1600,0.04149091}, {1610,0.03398182}, {1620,0.03413636}, {1630,0.04361818}, {1640,0.03489091}, {1650,0.03481818}, {1660,0.03990000}, {1670,0.04077273}, {1680,0.03550909}, {1690,0.03572727}, {1700,0.04080909}, {1710,0.04185455}, {1720,0.03633636}, {1730,0.03647273}, {1740,0.04204545}, {1750,0.05029091}, {1760,0.03755455}, {1770,0.03747273}, {1780,0.04274545}, {1790,0.04349091}, {1800,0.04962727}, {1810,0.03820909}, {1820,0.03848182}, {1830,0.04413636}, {1840,0.04491818}, {1850,0.05014545}, {1860,0.03939091}, {1870,0.03960000}, {1880,0.04574545}, {1890,0.04564545}, {1900,0.04644545}, {1910,0.05726364}, {1920,0.04070909}, {1930,0.04078182}, {1940,0.04655455}, {1950,0.04695455}, {1960,0.04770000}, {1970,0.04832727}, {1980,0.06209091}, {1990,0.04219091}, {2000,0.04236364}, {2050,0.04285455}, {2100,0.05028182}, {2150,0.05170000}, {2200,0.05300000}, {2250,0.05423636}, {2300,0.05548182}, {2350,0.05677273}, {2400,0.05790909}, {2450,0.05886364}, {2500,0.05975455}, {2550,0.05789091}, {2600,0.05519091}, {2650,0.07571818}, {2700,0.07383636}, {2750,0.06658182}, {2800,0.06736364}, {2850,0.06057273}, {2900,0.07275455}, {2950,0.08876364}, {3000,0.07196364}, {3050,0.08467273}, {3100,0.08520000}, {3150,0.07557273}, {3200,0.07948182}, {3250,0.07869091}, {3300,0.09563636}, {3350,0.08797273}, {3400,0.10347273}, {3450,0.08442727}, {3500,0.10405455}, {3550,0.08914545}, {3600,0.09481818}, {3650,0.09617273}, {3700,0.08577273}, {3750,0.08977273}, {3800,0.09459091}, {3850,0.09393636}, {3900,0.09345455}, {3950,0.09951818}, {4000,0.09550000}, {4050,0.10190000}, {4100,0.11868182}, {4150,0.10009091}, {4200,0.10530909}, {4250,0.10050000}, {4300,0.09790000}, {4350,0.10751818}, {4400,0.14141818}, {4450,0.14222727}, {4500,0.14147273}, {4550,0.14122727}, {4600,0.14071818}, {4650,0.14006364}, {4700,0.13910909}, {4750,0.13862727}, {4800,0.13742727}, {4850,0.14040000}, {4900,0.11817273}, {4950,0.12040909}, {5000,0.11895455}, {5050,0.15514545}, {5100,0.13423636}, {5150,0.14560000}, {5200,0.12657273}, {5250,0.16378182}, {5300,0.13197273}, {5350,0.15868182}, {5400,0.12867273}, {5450,0.13438182}, {5500,0.12789091}, {5550,0.15507273}, {5600,0.14818182}, {5650,0.16651818}, {5700,0.14116364}, {5750,0.16701818}, {5800,0.14958182}, {5850,0.18017273}, {5900,0.14730000}, {5950,0.15607273}, {6000,0.16705455}, {6050,0.15175455}, {6100,0.17323636}, {6150,0.15981818}, {6200,0.15100909}, {6250,0.17039091}, {6300,0.17210000}, {6350,0.15418182}, {6400,0.15544545}, {6450,0.16828182}, {6500,0.18815455}, {6550,0.16869091}, {6600,0.16391818}, {6650,0.16161818}, {6700,0.16317273}, {6750,0.16533636}, {6800,0.16140000}, {6850,0.16281818}, {6900,0.16451818}, {6950,0.16568182}, {7000,0.16659091}, {7050,0.16867273}, {7100,0.16499091}, {7150,0.17250000}, {7200,0.17332727}, {7250,0.21331818}, {7300,0.20695455}, {7350,0.18451818}, {7400,0.17640909}, {7450,0.18060909}, {7500,0.21702727}, {7550,0.18662727}, {7600,0.18035455}, {7650,0.23234545}, {7700,0.20118182}, {7750,0.18380000}, {7800,0.22643636}, {7850,0.18716364}, {7900,0.19246364}, {7950,0.20345455}, {8000,0.18929091}, {8050,0.20651818}, {8100,0.19181818}, {8150,0.20446364}, {8200,0.24507273}, {8250,0.18590909}, {8300,0.23381818}, {8350,0.20235455}, {8400,0.21067273}, {8450,0.24370909}, {8500,0.20531818}, {8550,0.27548182}, {8600,0.25930909}, {8650,0.24781818}, {8700,0.20880000}, {8750,0.21040909}, {8800,0.22526364}, {8850,0.24077273}, {8900,0.25265455}, {8950,0.26968182}, {9000,0.21340000}, {9050,0.20710909}, {9100,0.21781818}, {9150,0.22080909}, {9200,0.22094545}, {9250,0.22110909}, {9300,0.22103636}, {9350,0.22260909}, {9400,0.21571818}, {9450,0.27456364}, {9500,0.26767273}, {9550,0.24832727}, {9600,0.23513636}, {9650,0.23023636}, {9700,0.23179091}, {9750,0.27460909}, {9800,0.24831818}, {9850,0.23231818}, {9900,0.23724545}, {9950,0.27026364}, {10000,0.22325455}, {10100,0.32220909}, {10200,0.26191818}, {10300,0.25118182}, {10400,0.27356364}, {10500,0.25654545}, {10600,0.26585455}, {10700,0.30309091}, {10800,0.25323636}, {10900,0.26923636}, {11000,0.29419091}, {11100,0.31899091}, {11200,0.32410909}, {11300,0.26524545}, {11400,0.27371818}, {11500,0.27465455}, {11600,0.27936364}, {11700,0.35760909}, {11800,0.34121818}, {11900,0.32748182}, {12000,0.31660000}, {12100,0.29047273}, {12200,0.36159091}, {12300,0.31461818}, {12400,0.30134545}, {12500,0.36490909}, {12600,0.31845455}, {12700,0.36681818}, {12800,0.31186364}, {12900,0.36100000}, {13000,0.31557273}, {13100,0.32794545}, {13200,0.36267273}, {13300,0.38762727}, {13400,0.31580000}, {13500,0.32309091}, {13600,0.34516364}, {13700,0.35083636}, {13800,0.35673636}, {13900,0.35904545}, {14000,0.35360000}, {14100,0.34695455}, {14200,0.33358182}, {14300,0.76995455}, {14400,0.39776364}, {14500,0.36399091}, {14600,0.42310000}, {14700,0.39676364}, {14800,0.36080000}, {14900,0.40820909}, {15000,0.36388182}, {15100,0.40768182}, {15200,0.36000909}, {15300,0.39383636}, {15400,0.43890000}, {15500,0.45917273}, {15600,0.39010909}, {15700,0.41231818}, {15800,0.43755455}, {15900,0.45194545}, {16000,0.45587273}, {16100,0.45642727}, {16200,0.45770909}, {16300,0.45507273}, {16400,0.44933636}, {16500,0.43977273}, {16600,0.41374545}, {16700,0.48334545}, {16800,0.46229091}, {16900,0.44590000}, {17000,0.50448182}, {17100,0.46484545}, {17200,0.43531818}, {17300,0.45372727}, {17400,0.43477273}, {17500,0.46178182}, {17600,0.50130909}, {17700,0.44858182}, {17800,0.45365455}, {17900,0.49916364}, {18000,0.53028182}, {18100,0.54570909}, {18200,0.45143636}, {18300,0.45646364}, {18400,0.46372727}, {18500,0.45928182}, {18600,0.46118182}, {18700,0.54175455}, {18800,0.54740909}, {18900,0.53495455}, {19000,0.50228182}, {19100,0.47833636}, {19200,0.55122727}, {19300,0.52852727}, {19400,0.58258182}, {19500,0.55230909}, {19600,0.48862727}, {19700,0.54661818}, {19800,0.57604545}, {19900,0.53039091}, {20000,0.55161111}};
data["big_flat"]["TemplateCoq"]["norm reif"]["user"] = {{1,0.00002727}, {2,0.00010811}, {3,0.00009009}, {4,0.00020721}, {5,0.00021622}, {6,0.00036937}, {7,0.00026126}, {8,0.00035135}, {9,0.00032432}, {10,0.00049550}, {11,0.00041441}, {12,0.00031532}, {13,0.00034234}, {14,0.00034234}, {15,0.00050450}, {16,0.00055856}, {17,0.00047748}, {18,0.00065766}, {19,0.00028829}, {20,0.00059459}, {21,0.00045045}, {22,0.00051351}, {23,0.00036036}, {24,0.00055856}, {25,0.00048649}, {26,0.00066667}, {27,0.00042342}, {28,0.00059459}, {29,0.00056757}, {30,0.00080180}, {31,0.00059459}, {32,0.00087387}, {33,0.00055856}, {34,0.00073874}, {35,0.00080180}, {36,0.00078378}, {37,0.00098198}, {38,0.00055856}, {39,0.00089189}, {40,0.00095495}, {41,0.00076577}, {42,0.00085586}, {43,0.00086486}, {44,0.00086486}, {45,0.00100000}, {46,0.00089189}, {47,0.00096396}, {48,0.00111712}, {49,0.00100901}, {50,0.00090991}, {51,0.00120721}, {52,0.00106306}, {53,0.00100000}, {54,0.00118919}, {55,0.00109910}, {56,0.00120721}, {57,0.00091892}, {58,0.00109910}, {59,0.00146847}, {60,0.00136937}, {61,0.00124324}, {62,0.00116216}, {63,0.00113514}, {64,0.00132432}, {65,0.00138739}, {66,0.00145946}, {67,0.00149550}, {68,0.00136937}, {69,0.00127027}, {70,0.00114414}, {71,0.00123423}, {72,0.00146847}, {73,0.00149550}, {74,0.00130631}, {75,0.00153153}, {76,0.00180180}, {77,0.00174775}, {78,0.00185586}, {79,0.00179279}, {80,0.00168468}, {81,0.00196396}, {82,0.00177477}, {83,0.00175676}, {84,0.00164865}, {85,0.00180180}, {86,0.00185586}, {87,0.00180180}, {88,0.00300901}, {89,0.00160360}, {90,0.00155856}, {91,0.00141441}, {92,0.00145946}, {93,0.00144144}, {94,0.00150450}, {95,0.00163964}, {96,0.00173874}, {97,0.00209910}, {98,0.00215315}, {99,0.00230631}, {100,0.00218018}, {101,0.00210811}, {102,0.00168468}, {103,0.00145946}, {104,0.00166667}, {105,0.00209910}, {106,0.00238739}, {107,0.00240541}, {108,0.00267568}, {109,0.00214414}, {110,0.00210811}, {111,0.00231532}, {112,0.00191892}, {113,0.00218919}, {114,0.00216216}, {115,0.00205405}, {116,0.00207207}, {117,0.00214414}, {118,0.00236036}, {119,0.00228829}, {120,0.00257658}, {121,0.00220721}, {122,0.00223423}, {123,0.00238739}, {124,0.00270270}, {125,0.00248649}, {126,0.00257658}, {127,0.00214414}, {128,0.00249550}, {129,0.00259459}, {130,0.00241441}, {131,0.00274775}, {132,0.00256757}, {133,0.00243243}, {134,0.00267568}, {135,0.00252252}, {136,0.00253153}, {137,0.00251351}, {138,0.00265766}, {139,0.00277477}, {140,0.00346847}, {141,0.00266667}, {142,0.00277477}, {143,0.00268468}, {144,0.00281081}, {145,0.00279279}, {146,0.00276577}, {147,0.00290090}, {148,0.00284685}, {149,0.00285586}, {150,0.00310811}, {151,0.00274775}, {152,0.00307207}, {153,0.00272072}, {154,0.00318018}, {155,0.00297297}, {156,0.00280180}, {157,0.00313514}, {158,0.00295495}, {159,0.00325225}, {160,0.00333333}, {161,0.00302703}, {162,0.00305405}, {163,0.00327928}, {164,0.00344144}, {165,0.00320721}, {166,0.00316216}, {167,0.00308108}, {168,0.00321622}, {169,0.00327027}, {170,0.00309910}, {171,0.00325225}, {172,0.00336036}, {173,0.00338739}, {174,0.00336937}, {175,0.00353153}, {176,0.00339640}, {177,0.00344144}, {178,0.00365766}, {179,0.00358559}, {180,0.00344144}, {181,0.00366667}, {182,0.00358559}, {183,0.00358559}, {184,0.00358559}, {185,0.00359459}, {186,0.00354054}, {187,0.00383784}, {188,0.00372072}, {189,0.00363964}, {190,0.00383784}, {191,0.00375676}, {192,0.00364865}, {193,0.00381982}, {194,0.00386486}, {195,0.00382883}, {196,0.00369369}, {197,0.00382883}, {198,0.00407207}, {199,0.00384685}, {200,0.00394595}, {201,0.00394595}, {202,0.00399099}, {203,0.00390991}, {204,0.00380180}, {205,0.00401802}, {206,0.00398198}, {207,0.00385586}, {208,0.00375676}, {209,0.00384685}, {210,0.00380180}, {211,0.00408108}, {212,0.00415315}, {213,0.00436036}, {214,0.00416216}, {215,0.00431532}, {216,0.00433333}, {217,0.00427027}, {218,0.00433333}, {219,0.00425225}, {220,0.00418919}, {221,0.00429730}, {222,0.00442342}, {223,0.00424324}, {224,0.00440541}, {225,0.00466667}, {226,0.00471171}, {227,0.00447748}, {228,0.00441441}, {229,0.00448649}, {230,0.00553153}, {231,0.00454054}, {232,0.00454955}, {233,0.00465766}, {234,0.00466667}, {235,0.00467568}, {236,0.00481081}, {237,0.00441441}, {238,0.00460360}, {239,0.00590090}, {240,0.00475676}, {241,0.00472973}, {242,0.00478378}, {243,0.00484685}, {244,0.00480180}, {245,0.00461261}, {246,0.00494595}, {247,0.00494595}, {248,0.00473874}, {249,0.00513514}, {250,0.00489189}, {251,0.00494595}, {252,0.00510811}, {253,0.00487387}, {254,0.00507207}, {255,0.00500901}, {256,0.00627027}, {257,0.00500000}, {258,0.00519820}, {259,0.00511712}, {260,0.00511712}, {261,0.00515315}, {262,0.00513514}, {263,0.00511712}, {264,0.00718919}, {265,0.00515315}, {266,0.00539640}, {267,0.00514414}, {268,0.00530631}, {269,0.00529730}, {270,0.00556757}, {271,0.00519820}, {272,0.00811712}, {273,0.00529730}, {274,0.00548649}, {275,0.00536036}, {276,0.00553153}, {277,0.00549550}, {278,0.00545045}, {279,0.00552252}, {280,0.00753153}, {281,0.00554955}, {282,0.00564865}, {283,0.00572072}, {284,0.00530631}, {285,0.00580180}, {286,0.00535135}, {287,0.00563063}, {288,0.00575676}, {289,0.00579279}, {290,0.00528829}, {291,0.00572072}, {292,0.00560360}, {293,0.00590090}, {294,0.00587387}, {295,0.00717117}, {296,0.00576577}, {297,0.00577477}, {298,0.00627027}, {299,0.00568468}, {300,0.00608108}, {301,0.00611712}, {302,0.00801802}, {303,0.00604505}, {304,0.00589189}, {305,0.00582883}, {306,0.00600901}, {307,0.00598198}, {308,0.00605405}, {309,0.01082883}, {310,0.00565766}, {311,0.00598198}, {312,0.00632432}, {313,0.00643243}, {314,0.00619820}, {315,0.00616216}, {316,0.00862162}, {317,0.00628829}, {318,0.00614414}, {319,0.00627928}, {320,0.00653153}, {321,0.00644144}, {322,0.00632432}, {323,0.00916216}, {324,0.00630631}, {325,0.00660360}, {326,0.00652252}, {327,0.00640541}, {328,0.00653153}, {329,0.00655856}, {330,0.00739640}, {331,0.00643243}, {332,0.00646847}, {333,0.00667568}, {334,0.00659459}, {335,0.00661261}, {336,0.00800901}, {337,0.00652252}, {338,0.00642342}, {339,0.00645946}, {340,0.00645045}, {341,0.00670270}, {342,0.00668468}, {343,0.00677477}, {344,0.00686486}, {345,0.00672973}, {346,0.00691892}, {347,0.00681982}, {348,0.00690991}, {349,0.00823423}, {350,0.00685586}, {351,0.00695495}, {352,0.00698198}, {353,0.00699099}, {354,0.00681081}, {355,0.00876577}, {356,0.00709009}, {357,0.00719820}, {358,0.00706306}, {359,0.00693694}, {360,0.00704505}, {361,0.00935135}, {362,0.00718018}, {363,0.00712613}, {364,0.00707207}, {365,0.00720721}, {366,0.00714414}, {367,0.01151351}, {368,0.00713514}, {369,0.00745045}, {370,0.00735135}, {371,0.00725225}, {372,0.00729730}, {373,0.01093694}, {374,0.00736036}, {375,0.00732432}, {376,0.00750450}, {377,0.00752252}, {378,0.00749550}, {379,0.00933333}, {380,0.00745946}, {381,0.00770270}, {382,0.00749550}, {383,0.00772072}, {384,0.00762162}, {385,0.00887387}, {386,0.00768468}, {387,0.00760360}, {388,0.00767568}, {389,0.00766667}, {390,0.00995495}, {391,0.00804505}, {392,0.00765766}, {393,0.00781982}, {394,0.00797297}, {395,0.00802703}, {396,0.00918919}, {397,0.00807207}, {398,0.00802703}, {399,0.00815315}, {400,0.00799099}, {401,0.00821622}, {402,0.00809910}, {403,0.00802703}, {404,0.00790991}, {405,0.00860360}, {406,0.00810811}, {407,0.00947748}, {408,0.00802703}, {409,0.00851351}, {410,0.00836937}, {411,0.00820721}, {412,0.01076577}, {413,0.00857658}, {414,0.00824324}, {415,0.00845455}, {416,0.00847273}, {417,0.00850000}, {418,0.00871818}, {419,0.00839091}, {420,0.00811818}, {421,0.00828182}, {422,0.00873636}, {423,0.01023636}, {424,0.00840000}, {425,0.00843636}, {426,0.00862727}, {427,0.00888182}, {428,0.01061818}, {429,0.00901818}, {430,0.00848182}, {431,0.00876364}, {432,0.00872727}, {433,0.01058182}, {434,0.00850000}, {435,0.00900000}, {436,0.00887273}, {437,0.00890000}, {438,0.01095455}, {439,0.00919091}, {440,0.00889091}, {441,0.00887273}, {442,0.00906364}, {443,0.01128182}, {444,0.00922727}, {445,0.00910909}, {446,0.00930000}, {447,0.00927273}, {448,0.01112727}, {449,0.00900000}, {450,0.00948182}, {451,0.00948182}, {452,0.00924545}, {453,0.01127273}, {454,0.00930000}, {455,0.00933636}, {456,0.00949091}, {457,0.00930000}, {458,0.01125455}, {459,0.00957273}, {460,0.00961818}, {461,0.00943636}, {462,0.00912727}, {463,0.00905455}, {464,0.00930000}, {465,0.00949091}, {466,0.00964545}, {467,0.00944545}, {468,0.00970000}, {469,0.00971818}, {470,0.00960000}, {471,0.00977273}, {472,0.01186364}, {473,0.00989091}, {474,0.01003636}, {475,0.00991818}, {476,0.01006364}, {477,0.01151818}, {478,0.00990909}, {479,0.01014545}, {480,0.00968182}, {481,0.00949091}, {482,0.01031818}, {483,0.00995455}, {484,0.01014545}, {485,0.01045455}, {486,0.01210000}, {487,0.01031818}, {488,0.00970909}, {489,0.00979091}, {490,0.01042727}, {491,0.01005455}, {492,0.01055455}, {493,0.01010909}, {494,0.01019091}, {495,0.01230000}, {496,0.01036364}, {497,0.00990909}, {498,0.01040909}, {499,0.01072727}, {500,0.01022727}, {505,0.01074545}, {510,0.01077273}, {515,0.01102727}, {520,0.01247273}, {525,0.01091818}, {530,0.01128182}, {535,0.01140000}, {540,0.01323636}, {545,0.01165455}, {550,0.01166364}, {555,0.01174545}, {560,0.01360000}, {565,0.01204545}, {570,0.01213636}, {575,0.01240909}, {580,0.01422727}, {585,0.01238182}, {590,0.01242727}, {595,0.01275455}, {600,0.01390909}, {605,0.01289091}, {610,0.01282727}, {615,0.01288182}, {620,0.01302727}, {625,0.01298182}, {630,0.01333636}, {635,0.01520909}, {640,0.01331818}, {645,0.01361818}, {650,0.01342727}, {655,0.01351818}, {660,0.01410000}, {665,0.01397273}, {670,0.01586364}, {675,0.01395455}, {680,0.01437273}, {685,0.01616364}, {690,0.01443636}, {695,0.01444545}, {700,0.01451818}, {705,0.01470000}, {710,0.01472727}, {715,0.01510909}, {720,0.01498182}, {725,0.01493636}, {730,0.01505455}, {735,0.01520909}, {740,0.01537273}, {745,0.01525455}, {750,0.01676364}, {755,0.01559091}, {760,0.01568182}, {765,0.01583636}, {770,0.01584545}, {775,0.01592727}, {780,0.01600909}, {785,0.01598182}, {790,0.01633636}, {795,0.01636364}, {800,0.01642727}, {805,0.02014545}, {810,0.01662727}, {815,0.01670000}, {820,0.02389091}, {825,0.01676364}, {830,0.01719091}, {835,0.01925455}, {840,0.01735455}, {845,0.01740000}, {850,0.01774545}, {855,0.01745455}, {860,0.02023636}, {865,0.01775455}, {870,0.01777273}, {875,0.01797273}, {880,0.01825455}, {885,0.02157273}, {890,0.01818182}, {895,0.01840000}, {900,0.02100000}, {905,0.01852727}, {910,0.02271818}, {915,0.01895455}, {920,0.01861818}, {925,0.02632727}, {930,0.01901818}, {935,0.02252727}, {940,0.01924545}, {945,0.01943636}, {950,0.01928182}, {955,0.01938182}, {960,0.02302727}, {965,0.01954545}, {970,0.02387273}, {975,0.01984545}, {980,0.02017273}, {985,0.02046364}, {990,0.02021818}, {995,0.02377273}, {1000,0.02085455}, {1010,0.02443636}, {1020,0.02111818}, {1030,0.02846364}, {1040,0.02177273}, {1050,0.02190000}, {1060,0.02216364}, {1070,0.02243636}, {1080,0.02273636}, {1090,0.02307273}, {1100,0.02608182}, {1110,0.02330909}, {1120,0.02596364}, {1130,0.02391818}, {1140,0.02661818}, {1150,0.02388182}, {1160,0.02701818}, {1170,0.02460909}, {1180,0.02462727}, {1190,0.02476364}, {1200,0.02499091}, {1210,0.02550000}, {1220,0.02527273}, {1230,0.03441818}, {1240,0.02620909}, {1250,0.03378182}, {1260,0.02643636}, {1270,0.03124545}, {1280,0.02685455}, {1290,0.03090000}, {1300,0.02768182}, {1310,0.02740909}, {1320,0.03251818}, {1330,0.02812727}, {1340,0.03226364}, {1350,0.02840909}, {1360,0.02862727}, {1370,0.03582727}, {1380,0.02917273}, {1390,0.03897273}, {1400,0.02989091}, {1410,0.02950909}, {1420,0.03479091}, {1430,0.03049091}, {1440,0.03380000}, {1450,0.03914545}, {1460,0.03101818}, {1470,0.03840909}, {1480,0.03175455}, {1490,0.03182727}, {1500,0.03605455}, {1510,0.03251818}, {1520,0.03230909}, {1530,0.03631818}, {1540,0.03287273}, {1550,0.03326364}, {1560,0.03661818}, {1570,0.04533636}, {1580,0.03350909}, {1590,0.04363636}, {1600,0.04108182}, {1610,0.03389091}, {1620,0.03426364}, {1630,0.04372727}, {1640,0.03504545}, {1650,0.03502727}, {1660,0.03908182}, {1670,0.04066364}, {1680,0.03559091}, {1690,0.03564545}, {1700,0.04049091}, {1710,0.04208182}, {1720,0.03621818}, {1730,0.03687273}, {1740,0.04192727}, {1750,0.04845455}, {1760,0.03746364}, {1770,0.03704545}, {1780,0.04286364}, {1790,0.04354545}, {1800,0.04899091}, {1810,0.03822727}, {1820,0.03809091}, {1830,0.04400909}, {1840,0.04519091}, {1850,0.04949091}, {1860,0.03896364}, {1870,0.03925455}, {1880,0.04567273}, {1890,0.04563636}, {1900,0.04648182}, {1910,0.05670909}, {1920,0.04048182}, {1930,0.04070000}, {1940,0.04650909}, {1950,0.04648182}, {1960,0.04718182}, {1970,0.04796364}, {1980,0.06193636}, {1990,0.04273636}, {2000,0.04239091}, {2050,0.04322727}, {2100,0.04970909}, {2150,0.05093636}, {2200,0.05256364}, {2250,0.05416364}, {2300,0.05544545}, {2350,0.05660909}, {2400,0.05771818}, {2450,0.05839091}, {2500,0.05963636}, {2550,0.05786364}, {2600,0.05545455}, {2650,0.07549091}, {2700,0.07329091}, {2750,0.06676364}, {2800,0.06700909}, {2850,0.06095455}, {2900,0.07249091}, {2950,0.08781818}, {3000,0.07160909}, {3050,0.08418182}, {3100,0.08475455}, {3150,0.07517273}, {3200,0.07891818}, {3250,0.07867273}, {3300,0.09503636}, {3350,0.08770909}, {3400,0.10300000}, {3450,0.08425455}, {3500,0.10336364}, {3550,0.08875455}, {3600,0.09430909}, {3650,0.09568182}, {3700,0.08552727}, {3750,0.08919091}, {3800,0.09414545}, {3850,0.09390000}, {3900,0.09285455}, {3950,0.09897273}, {4000,0.09542727}, {4050,0.10134545}, {4100,0.11781818}, {4150,0.09949091}, {4200,0.10489091}, {4250,0.10030000}, {4300,0.09762727}, {4350,0.10711818}, {4400,0.13990000}, {4450,0.14114545}, {4500,0.14041818}, {4550,0.14018182}, {4600,0.13980000}, {4650,0.13939091}, {4700,0.13811818}, {4750,0.13810909}, {4800,0.13697273}, {4850,0.13956364}, {4900,0.11781818}, {4950,0.11980909}, {5000,0.11848182}, {5050,0.15430000}, {5100,0.13396364}, {5150,0.14480000}, {5200,0.12653636}, {5250,0.16200000}, {5300,0.13152727}, {5350,0.15797273}, {5400,0.12851818}, {5450,0.13420000}, {5500,0.12800000}, {5550,0.15448182}, {5600,0.14818182}, {5650,0.16640000}, {5700,0.14107273}, {5750,0.16685455}, {5800,0.14942727}, {5850,0.17993636}, {5900,0.14701818}, {5950,0.15602727}, {6000,0.16717273}, {6050,0.15170000}, {6100,0.17222727}, {6150,0.15889091}, {6200,0.15060000}, {6250,0.16952727}, {6300,0.17100000}, {6350,0.15383636}, {6400,0.15473636}, {6450,0.16689091}, {6500,0.18703636}, {6550,0.16770909}, {6600,0.16319091}, {6650,0.16090909}, {6700,0.16290000}, {6750,0.16429091}, {6800,0.16084545}, {6850,0.16240000}, {6900,0.16396364}, {6950,0.16521818}, {7000,0.16607273}, {7050,0.16810909}, {7100,0.16427273}, {7150,0.17241818}, {7200,0.17273636}, {7250,0.21183636}, {7300,0.20549091}, {7350,0.18339091}, {7400,0.17550000}, {7450,0.18018182}, {7500,0.21623636}, {7550,0.18648182}, {7600,0.18025455}, {7650,0.23190000}, {7700,0.20119091}, {7750,0.18374545}, {7800,0.22609091}, {7850,0.18712727}, {7900,0.19224545}, {7950,0.20318182}, {8000,0.18921818}, {8050,0.20664545}, {8100,0.19205455}, {8150,0.20431818}, {8200,0.24475455}, {8250,0.18583636}, {8300,0.23365455}, {8350,0.20240000}, {8400,0.21090000}, {8450,0.24362727}, {8500,0.20520909}, {8550,0.27552727}, {8600,0.25922727}, {8650,0.24812727}, {8700,0.20862727}, {8750,0.21040000}, {8800,0.22511818}, {8850,0.24060909}, {8900,0.25240909}, {8950,0.26960000}, {9000,0.21284545}, {9050,0.20703636}, {9100,0.21730909}, {9150,0.22106364}, {9200,0.22103636}, {9250,0.22106364}, {9300,0.22149091}, {9350,0.22248182}, {9400,0.21536364}, {9450,0.27457273}, {9500,0.26757273}, {9550,0.24831818}, {9600,0.23475455}, {9650,0.23013636}, {9700,0.23186364}, {9750,0.27489091}, {9800,0.24793636}, {9850,0.23195455}, {9900,0.23697273}, {9950,0.27048182}, {10000,0.22306364}, {10100,0.32228182}, {10200,0.26171818}, {10300,0.25121818}, {10400,0.27339091}, {10500,0.25661818}, {10600,0.26614545}, {10700,0.30345455}, {10800,0.25353636}, {10900,0.26915455}, {11000,0.29440000}, {11100,0.31880909}, {11200,0.32402727}, {11300,0.26555455}, {11400,0.27355455}, {11500,0.27442727}, {11600,0.27968182}, {11700,0.35573636}, {11800,0.33955455}, {11900,0.32651818}, {12000,0.31575455}, {12100,0.29019091}, {12200,0.35967273}, {12300,0.31358182}, {12400,0.30080909}, {12500,0.36418182}, {12600,0.31824545}, {12700,0.36642727}, {12800,0.31196364}, {12900,0.36088182}, {13000,0.31559091}, {13100,0.32775455}, {13200,0.36201818}, {13300,0.38648182}, {13400,0.31540909}, {13500,0.32260000}, {13600,0.34420000}, {13700,0.35010000}, {13800,0.35600909}, {13900,0.35860909}, {14000,0.35357273}, {14100,0.34670909}, {14200,0.33337273}, {14300,0.76828182}, {14400,0.39763636}, {14500,0.36373636}, {14600,0.42294545}, {14700,0.39687273}, {14800,0.36028182}, {14900,0.40801818}, {15000,0.36342727}, {15100,0.40750909}, {15200,0.35960000}, {15300,0.39386364}, {15400,0.43880909}, {15500,0.45941818}, {15600,0.39010909}, {15700,0.41255455}, {15800,0.43771818}, {15900,0.45189091}, {16000,0.45557273}, {16100,0.45599091}, {16200,0.45739091}, {16300,0.45456364}, {16400,0.44915455}, {16500,0.43947273}, {16600,0.41365455}, {16700,0.48267273}, {16800,0.46227273}, {16900,0.44598182}, {17000,0.50467273}, {17100,0.46455455}, {17200,0.43528182}, {17300,0.45322727}, {17400,0.43430000}, {17500,0.46175455}, {17600,0.50140909}, {17700,0.44812727}, {17800,0.45333636}, {17900,0.49906364}, {18000,0.53035455}, {18100,0.54569091}, {18200,0.45122727}, {18300,0.45642727}, {18400,0.46338182}, {18500,0.45871818}, {18600,0.46095455}, {18700,0.54184545}, {18800,0.54702727}, {18900,0.53484545}, {19000,0.50254545}, {19100,0.47841818}, {19200,0.55094545}, {19300,0.52852727}, {19400,0.58222727}, {19500,0.55193636}, {19600,0.48833636}, {19700,0.54663636}, {19800,0.57610909}, {19900,0.53036364}, {20000,0.55154630}};
data["big_flat"]["TemplateCoq"]["norm reif"]["system"] = {{1,0.00014545}, {2,0.00003604}, {3,0.00003604}, {4,0.00000000}, {5,0.00000000}, {6,0.00003604}, {7,0.00003604}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003604}, {13,0.00000000}, {14,0.00006306}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00002703}, {20,0.00000000}, {21,0.00000000}, {22,0.00003604}, {23,0.00003604}, {24,0.00003604}, {25,0.00000000}, {26,0.00003604}, {27,0.00000000}, {28,0.00003604}, {29,0.00000000}, {30,0.00000000}, {31,0.00007207}, {32,0.00000000}, {33,0.00003604}, {34,0.00003604}, {35,0.00000000}, {36,0.00000000}, {37,0.00003604}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003604}, {42,0.00003604}, {43,0.00003604}, {44,0.00000000}, {45,0.00003604}, {46,0.00000000}, {47,0.00000000}, {48,0.00007207}, {49,0.00000000}, {50,0.00000000}, {51,0.00003604}, {52,0.00000000}, {53,0.00000000}, {54,0.00003604}, {55,0.00000000}, {56,0.00003604}, {57,0.00000000}, {58,0.00000000}, {59,0.00003604}, {60,0.00000000}, {61,0.00003604}, {62,0.00007207}, {63,0.00000000}, {64,0.00007207}, {65,0.00003604}, {66,0.00006306}, {67,0.00002703}, {68,0.00003604}, {69,0.00000000}, {70,0.00003604}, {71,0.00003604}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00007207}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00003604}, {81,0.00000000}, {82,0.00002703}, {83,0.00003604}, {84,0.00007207}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00003604}, {90,0.00000000}, {91,0.00000000}, {92,0.00003604}, {93,0.00000000}, {94,0.00000000}, {95,0.00006306}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00007207}, {100,0.00003604}, {101,0.00002703}, {102,0.00003604}, {103,0.00000000}, {104,0.00007207}, {105,0.00000000}, {106,0.00002703}, {107,0.00003604}, {108,0.00000000}, {109,0.00000000}, {110,0.00018018}, {111,0.00000000}, {112,0.00006306}, {113,0.00000000}, {114,0.00003604}, {115,0.00007207}, {116,0.00006306}, {117,0.00003604}, {118,0.00003604}, {119,0.00003604}, {120,0.00003604}, {121,0.00000000}, {122,0.00003604}, {123,0.00003604}, {124,0.00000000}, {125,0.00003604}, {126,0.00000000}, {127,0.00007207}, {128,0.00003604}, {129,0.00003604}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00007207}, {135,0.00000000}, {136,0.00007207}, {137,0.00002703}, {138,0.00003604}, {139,0.00000000}, {140,0.00002703}, {141,0.00000000}, {142,0.00003604}, {143,0.00003604}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00006306}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00003604}, {153,0.00003604}, {154,0.00000000}, {155,0.00006306}, {156,0.00007207}, {157,0.00000000}, {158,0.00003604}, {159,0.00003604}, {160,0.00000000}, {161,0.00003604}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00003604}, {167,0.00006306}, {168,0.00003604}, {169,0.00010811}, {170,0.00000000}, {171,0.00003604}, {172,0.00000000}, {173,0.00003604}, {174,0.00003604}, {175,0.00000000}, {176,0.00003604}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00009910}, {185,0.00000000}, {186,0.00000000}, {187,0.00003604}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00003604}, {194,0.00000000}, {195,0.00000000}, {196,0.00006306}, {197,0.00003604}, {198,0.00003604}, {199,0.00007207}, {200,0.00007207}, {201,0.00000000}, {202,0.00002703}, {203,0.00003604}, {204,0.00003604}, {205,0.00003604}, {206,0.00002703}, {207,0.00003604}, {208,0.00006306}, {209,0.00003604}, {210,0.00003604}, {211,0.00007207}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00003604}, {216,0.00003604}, {217,0.00003604}, {218,0.00000000}, {219,0.00007207}, {220,0.00003604}, {221,0.00000000}, {222,0.00007207}, {223,0.00000000}, {224,0.00000000}, {225,0.00003604}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00007207}, {230,0.00003604}, {231,0.00003604}, {232,0.00000000}, {233,0.00007207}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00010811}, {238,0.00007207}, {239,0.00006306}, {240,0.00000000}, {241,0.00002703}, {242,0.00000000}, {243,0.00003604}, {244,0.00007207}, {245,0.00003604}, {246,0.00007207}, {247,0.00003604}, {248,0.00003604}, {249,0.00003604}, {250,0.00007207}, {251,0.00000000}, {252,0.00000000}, {253,0.00007207}, {254,0.00000000}, {255,0.00003604}, {256,0.00009910}, {257,0.00000000}, {258,0.00003604}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00003604}, {263,0.00000000}, {264,0.00003604}, {265,0.00000000}, {266,0.00002703}, {267,0.00006306}, {268,0.00003604}, {269,0.00000000}, {270,0.00003604}, {271,0.00000000}, {272,0.00013514}, {273,0.00007207}, {274,0.00003604}, {275,0.00003604}, {276,0.00000000}, {277,0.00002703}, {278,0.00007207}, {279,0.00000000}, {280,0.00003604}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00006306}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00006306}, {289,0.00007207}, {290,0.00003604}, {291,0.00003604}, {292,0.00000000}, {293,0.00003604}, {294,0.00007207}, {295,0.00003604}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00010811}, {300,0.00000000}, {301,0.00003604}, {302,0.00014414}, {303,0.00000000}, {304,0.00003604}, {305,0.00000000}, {306,0.00002703}, {307,0.00007207}, {308,0.00000000}, {309,0.00003604}, {310,0.00007207}, {311,0.00007207}, {312,0.00009910}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00003604}, {317,0.00007207}, {318,0.00007207}, {319,0.00003604}, {320,0.00000000}, {321,0.00000000}, {322,0.00003604}, {323,0.00003604}, {324,0.00003604}, {325,0.00000000}, {326,0.00003604}, {327,0.00003604}, {328,0.00000000}, {329,0.00003604}, {330,0.00000000}, {331,0.00003604}, {332,0.00000000}, {333,0.00003604}, {334,0.00006306}, {335,0.00003604}, {336,0.00014414}, {337,0.00000000}, {338,0.00003604}, {339,0.00002703}, {340,0.00003604}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00003604}, {347,0.00000000}, {348,0.00000000}, {349,0.00007207}, {350,0.00000000}, {351,0.00003604}, {352,0.00000000}, {353,0.00000000}, {354,0.00003604}, {355,0.00003604}, {356,0.00003604}, {357,0.00000000}, {358,0.00000000}, {359,0.00003604}, {360,0.00003604}, {361,0.00006306}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00003604}, {366,0.00000000}, {367,0.00003604}, {368,0.00000000}, {369,0.00000000}, {370,0.00003604}, {371,0.00007207}, {372,0.00000000}, {373,0.00017117}, {374,0.00000000}, {375,0.00002703}, {376,0.00000000}, {377,0.00000000}, {378,0.00003604}, {379,0.00010811}, {380,0.00003604}, {381,0.00003604}, {382,0.00000000}, {383,0.00000000}, {384,0.00003604}, {385,0.00000000}, {386,0.00000000}, {387,0.00003604}, {388,0.00000000}, {389,0.00002703}, {390,0.00003604}, {391,0.00003604}, {392,0.00003604}, {393,0.00000000}, {394,0.00003604}, {395,0.00007207}, {396,0.00003604}, {397,0.00000000}, {398,0.00000000}, {399,0.00003604}, {400,0.00003604}, {401,0.00002703}, {402,0.00000000}, {403,0.00003604}, {404,0.00000000}, {405,0.00003604}, {406,0.00000000}, {407,0.00003604}, {408,0.00003604}, {409,0.00003604}, {410,0.00003604}, {411,0.00006306}, {412,0.00014414}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00007273}, {417,0.00006364}, {418,0.00007273}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00002727}, {423,0.00014545}, {424,0.00003636}, {425,0.00000000}, {426,0.00007273}, {427,0.00000000}, {428,0.00007273}, {429,0.00000000}, {430,0.00000000}, {431,0.00003636}, {432,0.00000000}, {433,0.00000000}, {434,0.00007273}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00003636}, {439,0.00010909}, {440,0.00003636}, {441,0.00003636}, {442,0.00000000}, {443,0.00003636}, {444,0.00003636}, {445,0.00000000}, {446,0.00003636}, {447,0.00007273}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00002727}, {453,0.00000000}, {454,0.00003636}, {455,0.00007273}, {456,0.00007273}, {457,0.00000000}, {458,0.00016364}, {459,0.00000000}, {460,0.00003636}, {461,0.00000000}, {462,0.00000000}, {463,0.00007273}, {464,0.00003636}, {465,0.00000000}, {466,0.00000000}, {467,0.00003636}, {468,0.00007273}, {469,0.00007273}, {470,0.00003636}, {471,0.00000000}, {472,0.00007273}, {473,0.00003636}, {474,0.00000000}, {475,0.00003636}, {476,0.00003636}, {477,0.00010909}, {478,0.00003636}, {479,0.00003636}, {480,0.00014545}, {481,0.00000000}, {482,0.00003636}, {483,0.00003636}, {484,0.00000000}, {485,0.00000000}, {486,0.00003636}, {487,0.00003636}, {488,0.00000000}, {489,0.00000000}, {490,0.00003636}, {491,0.00007273}, {492,0.00003636}, {493,0.00007273}, {494,0.00003636}, {495,0.00003636}, {496,0.00000000}, {497,0.00007273}, {498,0.00010000}, {499,0.00003636}, {500,0.00000000}, {505,0.00000000}, {510,0.00003636}, {515,0.00000000}, {520,0.00010909}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00003636}, {550,0.00007273}, {555,0.00006364}, {560,0.00007273}, {565,0.00000000}, {570,0.00003636}, {575,0.00000000}, {580,0.00000000}, {585,0.00003636}, {590,0.00003636}, {595,0.00000000}, {600,0.00010909}, {605,0.00003636}, {610,0.00000000}, {615,0.00003636}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00003636}, {640,0.00007273}, {645,0.00000000}, {650,0.00003636}, {655,0.00000000}, {660,0.00003636}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00013636}, {690,0.00000000}, {695,0.00003636}, {700,0.00003636}, {705,0.00003636}, {710,0.00003636}, {715,0.00000000}, {720,0.00000000}, {725,0.00006364}, {730,0.00000000}, {735,0.00000000}, {740,0.00003636}, {745,0.00007273}, {750,0.00006364}, {755,0.00000000}, {760,0.00000000}, {765,0.00003636}, {770,0.00007273}, {775,0.00000000}, {780,0.00000000}, {785,0.00002727}, {790,0.00003636}, {795,0.00000000}, {800,0.00007273}, {805,0.00000000}, {810,0.00003636}, {815,0.00000000}, {820,0.00018182}, {825,0.00007273}, {830,0.00003636}, {835,0.00006364}, {840,0.00003636}, {845,0.00003636}, {850,0.00000000}, {855,0.00002727}, {860,0.00010909}, {865,0.00002727}, {870,0.00000000}, {875,0.00003636}, {880,0.00007273}, {885,0.00014545}, {890,0.00000000}, {895,0.00000000}, {900,0.00010000}, {905,0.00003636}, {910,0.00006364}, {915,0.00000000}, {920,0.00000000}, {925,0.00025455}, {930,0.00003636}, {935,0.00010909}, {940,0.00003636}, {945,0.00003636}, {950,0.00006364}, {955,0.00000000}, {960,0.00007273}, {965,0.00000000}, {970,0.00007273}, {975,0.00006364}, {980,0.00003636}, {985,0.00000000}, {990,0.00000000}, {995,0.00017273}, {1000,0.00003636}, {1010,0.00000000}, {1020,0.00003636}, {1030,0.00014545}, {1040,0.00000000}, {1050,0.00002727}, {1060,0.00000000}, {1070,0.00003636}, {1080,0.00003636}, {1090,0.00003636}, {1100,0.00018182}, {1110,0.00007273}, {1120,0.00003636}, {1130,0.00000000}, {1140,0.00006364}, {1150,0.00000000}, {1160,0.00013636}, {1170,0.00000000}, {1180,0.00003636}, {1190,0.00000000}, {1200,0.00003636}, {1210,0.00007273}, {1220,0.00003636}, {1230,0.00010909}, {1240,0.00003636}, {1250,0.00014545}, {1260,0.00000000}, {1270,0.00009091}, {1280,0.00000000}, {1290,0.00022727}, {1300,0.00000000}, {1310,0.00007273}, {1320,0.00007273}, {1330,0.00000000}, {1340,0.00010000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00018182}, {1380,0.00003636}, {1390,0.00036364}, {1400,0.00003636}, {1410,0.00014545}, {1420,0.00010000}, {1430,0.00000000}, {1440,0.00020000}, {1450,0.00025455}, {1460,0.00007273}, {1470,0.00025455}, {1480,0.00003636}, {1490,0.00007273}, {1500,0.00010000}, {1510,0.00002727}, {1520,0.00000000}, {1530,0.00014545}, {1540,0.00007273}, {1550,0.00000000}, {1560,0.00021818}, {1570,0.00025455}, {1580,0.00005455}, {1590,0.00021818}, {1600,0.00003636}, {1610,0.00007273}, {1620,0.00007273}, {1630,0.00026364}, {1640,0.00000000}, {1650,0.00007273}, {1660,0.00028182}, {1670,0.00018182}, {1680,0.00000000}, {1690,0.00010000}, {1700,0.00024545}, {1710,0.00010909}, {1720,0.00002727}, {1730,0.00003636}, {1740,0.00021818}, {1750,0.00180909}, {1760,0.00014545}, {1770,0.00007273}, {1780,0.00012727}, {1790,0.00014545}, {1800,0.00050000}, {1810,0.00000000}, {1820,0.00007273}, {1830,0.00029091}, {1840,0.00013636}, {1850,0.00020909}, {1860,0.00007273}, {1870,0.00013636}, {1880,0.00010909}, {1890,0.00017273}, {1900,0.00003636}, {1910,0.00042727}, {1920,0.00007273}, {1930,0.00003636}, {1940,0.00014545}, {1950,0.00010000}, {1960,0.00014545}, {1970,0.00018182}, {1980,0.00039091}, {1990,0.00006364}, {2000,0.00000000}, {2050,0.00003636}, {2100,0.00018182}, {2150,0.00018182}, {2200,0.00018182}, {2250,0.00029091}, {2300,0.00020909}, {2350,0.00028182}, {2400,0.00021818}, {2450,0.00023636}, {2500,0.00021818}, {2550,0.00010000}, {2600,0.00000000}, {2650,0.00048182}, {2700,0.00043636}, {2750,0.00020909}, {2800,0.00029091}, {2850,0.00003636}, {2900,0.00014545}, {2950,0.00060909}, {3000,0.00036364}, {3050,0.00047273}, {3100,0.00025455}, {3150,0.00032727}, {3200,0.00036364}, {3250,0.00010909}, {3300,0.00068182}, {3350,0.00045455}, {3400,0.00053636}, {3450,0.00020909}, {3500,0.00064545}, {3550,0.00030000}, {3600,0.00049091}, {3650,0.00060000}, {3700,0.00007273}, {3750,0.00040000}, {3800,0.00045455}, {3850,0.00006364}, {3900,0.00025455}, {3950,0.00057273}, {4000,0.00032727}, {4050,0.00040000}, {4100,0.00079091}, {4150,0.00041818}, {4200,0.00043636}, {4250,0.00028182}, {4300,0.00020909}, {4350,0.00037273}, {4400,0.00110000}, {4450,0.00089091}, {4500,0.00082727}, {4550,0.00073636}, {4600,0.00079091}, {4650,0.00072727}, {4700,0.00070909}, {4750,0.00081818}, {4800,0.00062727}, {4850,0.00082727}, {4900,0.00021818}, {4950,0.00053636}, {5000,0.00032727}, {5050,0.00089091}, {5100,0.00058182}, {5150,0.00095455}, {5200,0.00024545}, {5250,0.00124545}, {5300,0.00054545}, {5350,0.00100000}, {5400,0.00043636}, {5450,0.00025455}, {5500,0.00020909}, {5550,0.00038182}, {5600,0.00007273}, {5650,0.00000000}, {5700,0.00007273}, {5750,0.00007273}, {5800,0.00007273}, {5850,0.00014545}, {5900,0.00003636}, {5950,0.00000000}, {6000,0.00003636}, {6050,0.00010909}, {6100,0.00086364}, {6150,0.00052727}, {6200,0.00035455}, {6250,0.00070909}, {6300,0.00116364}, {6350,0.00028182}, {6400,0.00060909}, {6450,0.00083636}, {6500,0.00115455}, {6550,0.00075455}, {6600,0.00075455}, {6650,0.00048182}, {6700,0.00031818}, {6750,0.00081818}, {6800,0.00054545}, {6850,0.00047273}, {6900,0.00047273}, {6950,0.00041818}, {7000,0.00045455}, {7050,0.00039091}, {7100,0.00065455}, {7150,0.00036364}, {7200,0.00054545}, {7250,0.00136364}, {7300,0.00113636}, {7350,0.00082727}, {7400,0.00069091}, {7450,0.00042727}, {7500,0.00042727}, {7550,0.00010909}, {7600,0.00007273}, {7650,0.00020000}, {7700,0.00006364}, {7750,0.00003636}, {7800,0.00007273}, {7850,0.00014545}, {7900,0.00021818}, {7950,0.00010000}, {8000,0.00006364}, {8050,0.00003636}, {8100,0.00000000}, {8150,0.00007273}, {8200,0.00003636}, {8250,0.00003636}, {8300,0.00014545}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00010909}, {8500,0.00000000}, {8550,0.00003636}, {8600,0.00003636}, {8650,0.00007273}, {8700,0.00007273}, {8750,0.00010909}, {8800,0.00000000}, {8850,0.00010909}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00010000}, {9050,0.00000000}, {9100,0.00003636}, {9150,0.00014545}, {9200,0.00007273}, {9250,0.00003636}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00007273}, {9450,0.00003636}, {9500,0.00003636}, {9550,0.00003636}, {9600,0.00003636}, {9650,0.00003636}, {9700,0.00010909}, {9750,0.00000000}, {9800,0.00007273}, {9850,0.00010000}, {9900,0.00003636}, {9950,0.00002727}, {10000,0.00007273}, {10100,0.00003636}, {10200,0.00010909}, {10300,0.00006364}, {10400,0.00007273}, {10500,0.00000000}, {10600,0.00003636}, {10700,0.00007273}, {10800,0.00000000}, {10900,0.00003636}, {11000,0.00003636}, {11100,0.00007273}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00003636}, {11500,0.00010000}, {11600,0.00003636}, {11700,0.00180000}, {11800,0.00151818}, {11900,0.00095455}, {12000,0.00072727}, {12100,0.00057273}, {12200,0.00163636}, {12300,0.00065455}, {12400,0.00062727}, {12500,0.00014545}, {12600,0.00007273}, {12700,0.00025455}, {12800,0.00007273}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00003636}, {13200,0.00054545}, {13300,0.00120909}, {13400,0.00024545}, {13500,0.00025455}, {13600,0.00050000}, {13700,0.00046364}, {13800,0.00053636}, {13900,0.00029091}, {14000,0.00010909}, {14100,0.00014545}, {14200,0.00014545}, {14300,0.00140000}, {14400,0.00010909}, {14500,0.00007273}, {14600,0.00014545}, {14700,0.00010000}, {14800,0.00025455}, {14900,0.00025455}, {15000,0.00003636}, {15100,0.00003636}, {15200,0.00010909}, {15300,0.00003636}, {15400,0.00025455}, {15500,0.00003636}, {15600,0.00000000}, {15700,0.00003636}, {15800,0.00000000}, {15900,0.00007273}, {16000,0.00000000}, {16100,0.00014545}, {16200,0.00000000}, {16300,0.00028182}, {16400,0.00010909}, {16500,0.00003636}, {16600,0.00007273}, {16700,0.00014545}, {16800,0.00010909}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00003636}, {17200,0.00007273}, {17300,0.00007273}, {17400,0.00021818}, {17500,0.00010909}, {17600,0.00025455}, {17700,0.00020909}, {17800,0.00000000}, {17900,0.00003636}, {18000,0.00014545}, {18100,0.00017273}, {18200,0.00010909}, {18300,0.00003636}, {18400,0.00007273}, {18500,0.00000000}, {18600,0.00010909}, {18700,0.00003636}, {18800,0.00014545}, {18900,0.00013636}, {19000,0.00003636}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00003636}, {19400,0.00010909}, {19500,0.00014545}, {19600,0.00006364}, {19700,0.00007273}, {19800,0.00010909}, {19900,0.00000000}, {20000,0.00007407}};
data["big_flat"]["TemplateCoq"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00082727}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["TemplateCoq"]["post"]["user"] = {{1,0.00000000}, {2,0.00003604}, {3,0.00003604}, {4,0.00000000}, {5,0.00009009}, {6,0.00000000}, {7,0.00000000}, {8,0.00003604}, {9,0.00003604}, {10,0.00002703}, {11,0.00000000}, {12,0.00002703}, {13,0.00000000}, {14,0.00007207}, {15,0.00000000}, {16,0.00006306}, {17,0.00003604}, {18,0.00007207}, {19,0.00007207}, {20,0.00000000}, {21,0.00002703}, {22,0.00006306}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00006306}, {27,0.00003604}, {28,0.00002703}, {29,0.00000000}, {30,0.00007207}, {31,0.00000000}, {32,0.00002703}, {33,0.00006306}, {34,0.00000000}, {35,0.00003604}, {36,0.00002703}, {37,0.00007207}, {38,0.00000000}, {39,0.00006306}, {40,0.00000000}, {41,0.00006306}, {42,0.00000000}, {43,0.00003604}, {44,0.00011712}, {45,0.00003604}, {46,0.00003604}, {47,0.00002703}, {48,0.00007207}, {49,0.00007207}, {50,0.00002703}, {51,0.00002703}, {52,0.00003604}, {53,0.00000000}, {54,0.00000000}, {55,0.00009910}, {56,0.00000000}, {57,0.00003604}, {58,0.00000000}, {59,0.00002703}, {60,0.00000000}, {61,0.00005405}, {62,0.00002703}, {63,0.00003604}, {64,0.00002703}, {65,0.00000000}, {66,0.00000000}, {67,0.00003604}, {68,0.00003604}, {69,0.00006306}, {70,0.00007207}, {71,0.00000000}, {72,0.00007207}, {73,0.00000000}, {74,0.00009009}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00011712}, {79,0.00000000}, {80,0.00003604}, {81,0.00007207}, {82,0.00003604}, {83,0.00005405}, {84,0.00007207}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00006306}, {91,0.00002703}, {92,0.00002703}, {93,0.00009910}, {94,0.00002703}, {95,0.00000000}, {96,0.00009009}, {97,0.00002703}, {98,0.00000000}, {99,0.00000000}, {100,0.00006306}, {101,0.00000000}, {102,0.00000000}, {103,0.00009009}, {104,0.00000000}, {105,0.00006306}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00007207}, {110,0.00000000}, {111,0.00003604}, {112,0.00000000}, {113,0.00007207}, {114,0.00000000}, {115,0.00000000}, {116,0.00003604}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00002703}, {122,0.00007207}, {123,0.00006306}, {124,0.00003604}, {125,0.00002703}, {126,0.00000000}, {127,0.00006306}, {128,0.00007207}, {129,0.00003604}, {130,0.00006306}, {131,0.00003604}, {132,0.00007207}, {133,0.00002703}, {134,0.00005405}, {135,0.00003604}, {136,0.00000000}, {137,0.00000000}, {138,0.00003604}, {139,0.00006306}, {140,0.00000000}, {141,0.00005405}, {142,0.00002703}, {143,0.00009009}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00005405}, {148,0.00000000}, {149,0.00003604}, {150,0.00006306}, {151,0.00002703}, {152,0.00003604}, {153,0.00000000}, {154,0.00009009}, {155,0.00002703}, {156,0.00009009}, {157,0.00000000}, {158,0.00002703}, {159,0.00003604}, {160,0.00000000}, {161,0.00002703}, {162,0.00009009}, {163,0.00000000}, {164,0.00000000}, {165,0.00007207}, {166,0.00003604}, {167,0.00000000}, {168,0.00002703}, {169,0.00000000}, {170,0.00002703}, {171,0.00000000}, {172,0.00002703}, {173,0.00006306}, {174,0.00000000}, {175,0.00007207}, {176,0.00007207}, {177,0.00003604}, {178,0.00000000}, {179,0.00000000}, {180,0.00002703}, {181,0.00000000}, {182,0.00017117}, {183,0.00000000}, {184,0.00005405}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00002703}, {189,0.00000000}, {190,0.00000000}, {191,0.00016216}, {192,0.00000000}, {193,0.00002703}, {194,0.00005405}, {195,0.00000000}, {196,0.00002703}, {197,0.00007207}, {198,0.00012613}, {199,0.00003604}, {200,0.00002703}, {201,0.00000000}, {202,0.00003604}, {203,0.00000000}, {204,0.00003604}, {205,0.00011712}, {206,0.00003604}, {207,0.00000000}, {208,0.00002703}, {209,0.00003604}, {210,0.00000000}, {211,0.00000000}, {212,0.00002703}, {213,0.00007207}, {214,0.00000000}, {215,0.00002703}, {216,0.00002703}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00003604}, {221,0.00002703}, {222,0.00000000}, {223,0.00000000}, {224,0.00005405}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00007207}, {229,0.00002703}, {230,0.00000000}, {231,0.00003604}, {232,0.00005405}, {233,0.00000000}, {234,0.00000000}, {235,0.00003604}, {236,0.00003604}, {237,0.00000000}, {238,0.00000000}, {239,0.00003604}, {240,0.00009009}, {241,0.00003604}, {242,0.00007207}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00003604}, {248,0.00003604}, {249,0.00007207}, {250,0.00003604}, {251,0.00002703}, {252,0.00003604}, {253,0.00000000}, {254,0.00002703}, {255,0.00000000}, {256,0.00003604}, {257,0.00003604}, {258,0.00000000}, {259,0.00000000}, {260,0.00007207}, {261,0.00000000}, {262,0.00009910}, {263,0.00003604}, {264,0.00003604}, {265,0.00003604}, {266,0.00000000}, {267,0.00002703}, {268,0.00000000}, {269,0.00007207}, {270,0.00002703}, {271,0.00003604}, {272,0.00006306}, {273,0.00000000}, {274,0.00000000}, {275,0.00003604}, {276,0.00000000}, {277,0.00000000}, {278,0.00014414}, {279,0.00000000}, {280,0.00002703}, {281,0.00003604}, {282,0.00002703}, {283,0.00003604}, {284,0.00000000}, {285,0.00003604}, {286,0.00000000}, {287,0.00003604}, {288,0.00000000}, {289,0.00005405}, {290,0.00007207}, {291,0.00000000}, {292,0.00003604}, {293,0.00003604}, {294,0.00003604}, {295,0.00000000}, {296,0.00002703}, {297,0.00005405}, {298,0.00003604}, {299,0.00002703}, {300,0.00000000}, {301,0.00000000}, {302,0.00002703}, {303,0.00000000}, {304,0.00003604}, {305,0.00009009}, {306,0.00003604}, {307,0.00000000}, {308,0.00006306}, {309,0.00002703}, {310,0.00007207}, {311,0.00002703}, {312,0.00000000}, {313,0.00006306}, {314,0.00007207}, {315,0.00002703}, {316,0.00002703}, {317,0.00006306}, {318,0.00000000}, {319,0.00003604}, {320,0.00002703}, {321,0.00002703}, {322,0.00000000}, {323,0.00006306}, {324,0.00000000}, {325,0.00009910}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00003604}, {331,0.00005405}, {332,0.00002703}, {333,0.00010811}, {334,0.00003604}, {335,0.00003604}, {336,0.00000000}, {337,0.00007207}, {338,0.00003604}, {339,0.00007207}, {340,0.00014414}, {341,0.00002703}, {342,0.00006306}, {343,0.00002703}, {344,0.00003604}, {345,0.00005405}, {346,0.00000000}, {347,0.00009910}, {348,0.00000000}, {349,0.00003604}, {350,0.00006306}, {351,0.00007207}, {352,0.00003604}, {353,0.00002703}, {354,0.00006306}, {355,0.00003604}, {356,0.00000000}, {357,0.00002703}, {358,0.00002703}, {359,0.00005405}, {360,0.00003604}, {361,0.00000000}, {362,0.00007207}, {363,0.00000000}, {364,0.00002703}, {365,0.00000000}, {366,0.00006306}, {367,0.00007207}, {368,0.00006306}, {369,0.00002703}, {370,0.00006306}, {371,0.00003604}, {372,0.00002703}, {373,0.00003604}, {374,0.00006306}, {375,0.00000000}, {376,0.00000000}, {377,0.00003604}, {378,0.00000000}, {379,0.00003604}, {380,0.00007207}, {381,0.00000000}, {382,0.00006306}, {383,0.00009910}, {384,0.00007207}, {385,0.00002703}, {386,0.00003604}, {387,0.00012613}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00009910}, {392,0.00003604}, {393,0.00003604}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00007207}, {399,0.00003604}, {400,0.00002703}, {401,0.00000000}, {402,0.00002703}, {403,0.00000000}, {404,0.00005405}, {405,0.00002703}, {406,0.00002703}, {407,0.00000000}, {408,0.00009910}, {409,0.00000000}, {410,0.00002703}, {411,0.00000000}, {412,0.00000000}, {413,0.00007207}, {414,0.00003604}, {415,0.00002727}, {416,0.00003636}, {417,0.00003636}, {418,0.00000000}, {419,0.00003636}, {420,0.00003636}, {421,0.00000000}, {422,0.00003636}, {423,0.00003636}, {424,0.00002727}, {425,0.00007273}, {426,0.00000000}, {427,0.00000000}, {428,0.00007273}, {429,0.00005455}, {430,0.00000000}, {431,0.00003636}, {432,0.00000000}, {433,0.00007273}, {434,0.00003636}, {435,0.00000000}, {436,0.00000000}, {437,0.00002727}, {438,0.00010909}, {439,0.00000000}, {440,0.00003636}, {441,0.00003636}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00003636}, {446,0.00000000}, {447,0.00000000}, {448,0.00002727}, {449,0.00002727}, {450,0.00000000}, {451,0.00003636}, {452,0.00003636}, {453,0.00006364}, {454,0.00005455}, {455,0.00000000}, {456,0.00006364}, {457,0.00000000}, {458,0.00002727}, {459,0.00003636}, {460,0.00000000}, {461,0.00000000}, {462,0.00003636}, {463,0.00005455}, {464,0.00000000}, {465,0.00003636}, {466,0.00002727}, {467,0.00003636}, {468,0.00000000}, {469,0.00000000}, {470,0.00003636}, {471,0.00007273}, {472,0.00000000}, {473,0.00006364}, {474,0.00000000}, {475,0.00003636}, {476,0.00003636}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00003636}, {481,0.00117273}, {482,0.00003636}, {483,0.00003636}, {484,0.00000000}, {485,0.00000000}, {486,0.00002727}, {487,0.00003636}, {488,0.00002727}, {489,0.00000000}, {490,0.00002727}, {491,0.00003636}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00003636}, {499,0.00000000}, {500,0.00002727}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00007273}, {525,0.00002727}, {530,0.00000000}, {535,0.00003636}, {540,0.00005455}, {545,0.00005455}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00002727}, {570,0.00002727}, {575,0.00003636}, {580,0.00007273}, {585,0.00017273}, {590,0.00007273}, {595,0.00000000}, {600,0.00002727}, {605,0.00003636}, {610,0.00003636}, {615,0.00003636}, {620,0.00000000}, {625,0.00009091}, {630,0.00002727}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00002727}, {655,0.00003636}, {660,0.00003636}, {665,0.00000000}, {670,0.00003636}, {675,0.00003636}, {680,0.00000000}, {685,0.00007273}, {690,0.00010909}, {695,0.00000000}, {700,0.00000000}, {705,0.00010000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00009091}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00011818}, {755,0.00002727}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00003636}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00006364}, {810,0.00018182}, {815,0.00000000}, {820,0.00003636}, {825,0.00010909}, {830,0.00000000}, {835,0.00005455}, {840,0.00000000}, {845,0.00000000}, {850,0.00002727}, {855,0.00000000}, {860,0.00003636}, {865,0.00009091}, {870,0.00000000}, {875,0.00006364}, {880,0.00000000}, {885,0.00003636}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00003636}, {935,0.00003636}, {940,0.00007273}, {945,0.00007273}, {950,0.00000000}, {955,0.00006364}, {960,0.00000000}, {965,0.00005455}, {970,0.00003636}, {975,0.00010000}, {980,0.00000000}, {985,0.00009091}, {990,0.00002727}, {995,0.00002727}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00003636}, {1030,0.00010909}, {1040,0.00002727}, {1050,0.00003636}, {1060,0.00003636}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00003636}, {1100,0.00006364}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00003636}, {1140,0.00003636}, {1150,0.00000000}, {1160,0.00002727}, {1170,0.00002727}, {1180,0.00014545}, {1190,0.00000000}, {1200,0.00002727}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00003636}, {1240,0.00000000}, {1250,0.00007273}, {1260,0.00013636}, {1270,0.00003636}, {1280,0.00007273}, {1290,0.00000000}, {1300,0.00002727}, {1310,0.00006364}, {1320,0.00005455}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00003636}, {1360,0.00009091}, {1370,0.00000000}, {1380,0.00010909}, {1390,0.00007273}, {1400,0.00002727}, {1410,0.00002727}, {1420,0.00002727}, {1430,0.00007273}, {1440,0.00003636}, {1450,0.00010909}, {1460,0.00010000}, {1470,0.00006364}, {1480,0.00007273}, {1490,0.00000000}, {1500,0.00010000}, {1510,0.00002727}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00003636}, {1550,0.00002727}, {1560,0.00003636}, {1570,0.00003636}, {1580,0.00002727}, {1590,0.00006364}, {1600,0.00000000}, {1610,0.00003636}, {1620,0.00003636}, {1630,0.00000000}, {1640,0.00010000}, {1650,0.00000000}, {1660,0.00003636}, {1670,0.00006364}, {1680,0.00003636}, {1690,0.00002727}, {1700,0.00009091}, {1710,0.00003636}, {1720,0.00003636}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00006364}, {1760,0.00003636}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00003636}, {1820,0.00000000}, {1830,0.00003636}, {1840,0.00012727}, {1850,0.00007273}, {1860,0.00006364}, {1870,0.00006364}, {1880,0.00010000}, {1890,0.00010909}, {1900,0.00010000}, {1910,0.00003636}, {1920,0.00002727}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00007273}, {1960,0.00000000}, {1970,0.00006364}, {1980,0.00002727}, {1990,0.00000000}, {2000,0.00002727}, {2050,0.00006364}, {2100,0.00006364}, {2150,0.00006364}, {2200,0.00000000}, {2250,0.00002727}, {2300,0.00003636}, {2350,0.00007273}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00006364}, {2550,0.00002727}, {2600,0.00006364}, {2650,0.00003636}, {2700,0.00007273}, {2750,0.00000000}, {2800,0.00010909}, {2850,0.00007273}, {2900,0.00003636}, {2950,0.00000000}, {3000,0.00006364}, {3050,0.00006364}, {3100,0.00003636}, {3150,0.00002727}, {3200,0.00006364}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00005455}, {3550,0.00002727}, {3600,0.00000000}, {3650,0.00003636}, {3700,0.00003636}, {3750,0.00006364}, {3800,0.00002727}, {3850,0.00002727}, {3900,0.00000000}, {3950,0.00009091}, {4000,0.00002727}, {4050,0.00005455}, {4100,0.00002727}, {4150,0.00000000}, {4200,0.00002727}, {4250,0.00003636}, {4300,0.00002727}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00002727}, {4600,0.00005455}, {4650,0.00006364}, {4700,0.00002727}, {4750,0.00005455}, {4800,0.00005455}, {4850,0.00003636}, {4900,0.00006364}, {4950,0.00002727}, {5000,0.00002727}, {5050,0.00005455}, {5100,0.00002727}, {5150,0.00006364}, {5200,0.00000000}, {5250,0.00003636}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00002727}, {5450,0.00006364}, {5500,0.00005455}, {5550,0.00000000}, {5600,0.00002727}, {5650,0.00000000}, {5700,0.00005455}, {5750,0.00002727}, {5800,0.00006364}, {5850,0.00000000}, {5900,0.00003636}, {5950,0.00005455}, {6000,0.00000000}, {6050,0.00006364}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00009091}, {6250,0.00002727}, {6300,0.00002727}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00002727}, {6600,0.00002727}, {6650,0.00002727}, {6700,0.00000000}, {6750,0.00005455}, {6800,0.00006364}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00002727}, {7000,0.00000000}, {7050,0.00002727}, {7100,0.00002727}, {7150,0.00006364}, {7200,0.00000000}, {7250,0.00010909}, {7300,0.00000000}, {7350,0.00008182}, {7400,0.00002727}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00007273}, {7600,0.00002727}, {7650,0.00003636}, {7700,0.00000000}, {7750,0.00009091}, {7800,0.00008182}, {7850,0.00003636}, {7900,0.00000000}, {7950,0.00010000}, {8000,0.00010000}, {8050,0.00000000}, {8100,0.00002727}, {8150,0.00000000}, {8200,0.00006364}, {8250,0.00010000}, {8300,0.00000000}, {8350,0.00006364}, {8400,0.00003636}, {8450,0.00005455}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00008182}, {8650,0.00006364}, {8700,0.00005455}, {8750,0.00006364}, {8800,0.00005455}, {8850,0.00006364}, {8900,0.00009091}, {8950,0.00003636}, {9000,0.00006364}, {9050,0.00002727}, {9100,0.00012727}, {9150,0.00010909}, {9200,0.00003636}, {9250,0.00003636}, {9300,0.00000000}, {9350,0.00006364}, {9400,0.00003636}, {9450,0.00000000}, {9500,0.00002727}, {9550,0.00010000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00003636}, {9750,0.00007273}, {9800,0.00006364}, {9850,0.00010909}, {9900,0.00000000}, {9950,0.00003636}, {10000,0.00006364}, {10100,0.00019091}, {10200,0.00002727}, {10300,0.00007273}, {10400,0.00005455}, {10500,0.00002727}, {10600,0.00003636}, {10700,0.00005455}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00006364}, {11200,0.00000000}, {11300,0.00010000}, {11400,0.00010000}, {11500,0.00000000}, {11600,0.00006364}, {11700,0.00002727}, {11800,0.00007273}, {11900,0.00003636}, {12000,0.00000000}, {12100,0.00011818}, {12200,0.00003636}, {12300,0.00003636}, {12400,0.00003636}, {12500,0.00000000}, {12600,0.00003636}, {12700,0.00006364}, {12800,0.00003636}, {12900,0.00000000}, {13000,0.00008182}, {13100,0.00003636}, {13200,0.00000000}, {13300,0.00003636}, {13400,0.00007273}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00013636}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00007273}, {14100,0.00006364}, {14200,0.00009091}, {14300,0.00017273}, {14400,0.00006364}, {14500,0.00007273}, {14600,0.00009091}, {14700,0.00010000}, {14800,0.00006364}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00007273}, {15200,0.00000000}, {15300,0.00006364}, {15400,0.00002727}, {15500,0.00003636}, {15600,0.00006364}, {15700,0.00005455}, {15800,0.00003636}, {15900,0.00003636}, {16000,0.00003636}, {16100,0.00006364}, {16200,0.00002727}, {16300,0.00006364}, {16400,0.00000000}, {16500,0.00006364}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00007273}, {17000,0.00002727}, {17100,0.00003636}, {17200,0.00000000}, {17300,0.00006364}, {17400,0.00008182}, {17500,0.00003636}, {17600,0.00003636}, {17700,0.00000000}, {17800,0.00009091}, {17900,0.00002727}, {18000,0.00003636}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00014545}, {18400,0.00003636}, {18500,0.00002727}, {18600,0.00006364}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00002727}, {19000,0.00002727}, {19100,0.00002727}, {19200,0.00005455}, {19300,0.00000000}, {19400,0.00002727}, {19500,0.00002727}, {19600,0.00002727}, {19700,0.00006364}, {19800,0.00003636}, {19900,0.00006364}, {20000,0.00010185}};
data["big_flat"]["TemplateCoq"]["post"]["system"] = {{1,0.00003604}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00003604}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00002703}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00003604}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00003604}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00003604}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00003636}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00003636}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00003636}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00002727}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00003636}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00003636}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00003636}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00003636}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00003636}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00003636}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00003636}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00003636}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00003636}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00003636}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00003636}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00003636}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00003636}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["TemplateCoq"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["TemplateCoq"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00003604}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00003604}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00002703}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00002703}, {61,0.00000000}, {62,0.00000000}, {63,0.00003604}, {64,0.00000000}, {65,0.00000000}, {66,0.00003604}, {67,0.00003604}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00003604}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00002703}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00003604}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00003604}, {108,0.00000000}, {109,0.00003604}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00003604}, {117,0.00000000}, {118,0.00003604}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00002703}, {129,0.00000000}, {130,0.00002703}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00003604}, {149,0.00000000}, {150,0.00002703}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00002703}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00003604}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00003604}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00003604}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00002703}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00002703}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00003604}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00002703}, {245,0.00003604}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00003604}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00002703}, {262,0.00003604}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00007207}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00003604}, {283,0.00000000}, {284,0.00003604}, {285,0.00002703}, {286,0.00000000}, {287,0.00002703}, {288,0.00002703}, {289,0.00000000}, {290,0.00000000}, {291,0.00003604}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00005405}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00002703}, {306,0.00000000}, {307,0.00003604}, {308,0.00000000}, {309,0.00000000}, {310,0.00002703}, {311,0.00000000}, {312,0.00003604}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00003604}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00002703}, {338,0.00000000}, {339,0.00003604}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00002703}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00003604}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00003604}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00003604}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00002727}, {424,0.00000000}, {425,0.00000000}, {426,0.00002727}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00002727}, {441,0.00000000}, {442,0.00000000}, {443,0.00003636}, {444,0.00000000}, {445,0.00002727}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00003636}, {450,0.00000000}, {451,0.00000000}, {452,0.00003636}, {453,0.00003636}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00002727}, {468,0.00000000}, {469,0.00007273}, {470,0.00003636}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00003636}, {477,0.00000000}, {478,0.00000000}, {479,0.00003636}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00003636}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00002727}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00002727}, {510,0.00000000}, {515,0.00000000}, {520,0.00003636}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00003636}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00003636}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00003636}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00005455}, {720,0.00003636}, {725,0.00003636}, {730,0.00003636}, {735,0.00003636}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00003636}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00002727}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00002727}, {910,0.00003636}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00002727}, {970,0.00000000}, {975,0.00003636}, {980,0.00000000}, {985,0.00000000}, {990,0.00002727}, {995,0.00006364}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00003636}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00003636}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00003636}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00002727}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00003636}, {1260,0.00003636}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00003636}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00003636}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00002727}, {1500,0.00007273}, {1510,0.00002727}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00003636}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00003636}, {1630,0.00003636}, {1640,0.00000000}, {1650,0.00006364}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00002727}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00002727}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00002727}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00002727}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00002727}, {2900,0.00000000}, {2950,0.00003636}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00002727}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00005455}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00002727}, {4600,0.00010000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00002727}, {4850,0.00002727}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00003636}, {5050,0.00000000}, {5100,0.00003636}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00005455}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00002727}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00003636}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00003636}, {6650,0.00002727}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00002727}, {7250,0.00002727}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00002727}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00002727}, {8150,0.00005455}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00003636}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00007273}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00003636}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00003636}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00006364}, {9900,0.00003636}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00003636}, {10400,0.00003636}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00003636}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00003636}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00003636}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00002727}, {13300,0.00002727}, {13400,0.00000000}, {13500,0.00003636}, {13600,0.00006364}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00003636}, {14600,0.00002727}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00003636}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00003636}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00003636}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00003636}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00003636}, {17300,0.00000000}, {17400,0.00002727}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00002727}, {18200,0.00000000}, {18300,0.00002727}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00002727}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00006364}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["TemplateCoq"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00003604}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00003604}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00003604}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00003604}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00003636}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00003636}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00000000}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000000}, {12700,0.00000000}, {12800,0.00000000}, {12900,0.00000000}, {13000,0.00000000}, {13100,0.00000000}, {13200,0.00000000}, {13300,0.00000000}, {13400,0.00000000}, {13500,0.00000000}, {13600,0.00000000}, {13700,0.00000000}, {13800,0.00000000}, {13900,0.00000000}, {14000,0.00000000}, {14100,0.00000000}, {14200,0.00000000}, {14300,0.00000000}, {14400,0.00000000}, {14500,0.00000000}, {14600,0.00000000}, {14700,0.00000000}, {14800,0.00000000}, {14900,0.00000000}, {15000,0.00000000}, {15100,0.00000000}, {15200,0.00000000}, {15300,0.00000000}, {15400,0.00000000}, {15500,0.00000000}, {15600,0.00000000}, {15700,0.00000000}, {15800,0.00000000}, {15900,0.00000000}, {16000,0.00000000}, {16100,0.00000000}, {16200,0.00000000}, {16300,0.00000000}, {16400,0.00000000}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00000000}, {16800,0.00000000}, {16900,0.00000000}, {17000,0.00000000}, {17100,0.00000000}, {17200,0.00000000}, {17300,0.00000000}, {17400,0.00000000}, {17500,0.00000000}, {17600,0.00000000}, {17700,0.00000000}, {17800,0.00000000}, {17900,0.00000000}, {18000,0.00000000}, {18100,0.00000000}, {18200,0.00000000}, {18300,0.00000000}, {18400,0.00000000}, {18500,0.00000000}, {18600,0.00000000}, {18700,0.00000000}, {18800,0.00000000}, {18900,0.00000000}, {19000,0.00000000}, {19100,0.00000000}, {19200,0.00000000}, {19300,0.00000000}, {19400,0.00000000}, {19500,0.00000000}, {19600,0.00000000}, {19700,0.00000000}, {19800,0.00000000}, {19900,0.00000000}, {20000,0.00000000}};
data["big_flat"]["TemplateCoq"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00001802}, {31,0.00000901}, {32,0.00009009}, {33,0.00018919}, {34,0.00045045}, {35,0.00077477}, {36,0.00092793}, {37,0.00100000}, {38,0.00100000}, {39,0.00100000}, {40,0.00100000}, {41,0.00100000}, {42,0.00100000}, {43,0.00100000}, {44,0.00100000}, {45,0.00100000}, {46,0.00100000}, {47,0.00100000}, {48,0.00100000}, {49,0.00100000}, {50,0.00100000}, {51,0.00100000}, {52,0.00100000}, {53,0.00100000}, {54,0.00100000}, {55,0.00100000}, {56,0.00100000}, {57,0.00100000}, {58,0.00100000}, {59,0.00100000}, {60,0.00100000}, {61,0.00100000}, {62,0.00100000}, {63,0.00100000}, {64,0.00100000}, {65,0.00100000}, {66,0.00100000}, {67,0.00100000}, {68,0.00100000}, {69,0.00100000}, {70,0.00100000}, {71,0.00100000}, {72,0.00100901}, {73,0.00101802}, {74,0.00101802}, {75,0.00102703}, {76,0.00107207}, {77,0.00106306}, {78,0.00109009}, {79,0.00120721}, {80,0.00132432}, {81,0.00151351}, {82,0.00164865}, {83,0.00182883}, {84,0.00188288}, {85,0.00195495}, {86,0.00197297}, {87,0.00200000}, {88,0.00298198}, {89,0.00200000}, {90,0.00200000}, {91,0.00200000}, {92,0.00200000}, {93,0.00200000}, {94,0.00200000}, {95,0.00200000}, {96,0.00200000}, {97,0.00200000}, {98,0.00200000}, {99,0.00200000}, {100,0.00200000}, {101,0.00200000}, {102,0.00200901}, {103,0.00200000}, {104,0.00200000}, {105,0.00200000}, {106,0.00200000}, {107,0.00200000}, {108,0.00298198}, {109,0.00200000}, {110,0.00200000}, {111,0.00200000}, {112,0.00200000}, {113,0.00200000}, {114,0.00200901}, {115,0.00200901}, {116,0.00200901}, {117,0.00201802}, {118,0.00200901}, {119,0.00200901}, {120,0.00203604}, {121,0.00205405}, {122,0.00208108}, {123,0.00213514}, {124,0.00225225}, {125,0.00229730}, {126,0.00247748}, {127,0.00253153}, {128,0.00268468}, {129,0.00275676}, {130,0.00281982}, {131,0.00289189}, {132,0.00295495}, {133,0.00297297}, {134,0.00299099}, {135,0.00299099}, {136,0.00300000}, {137,0.00300000}, {138,0.00300000}, {139,0.00301802}, {140,0.00385586}, {141,0.00300000}, {142,0.00300000}, {143,0.00300000}, {144,0.00300000}, {145,0.00300000}, {146,0.00300000}, {147,0.00300000}, {148,0.00300000}, {149,0.00300000}, {150,0.00300000}, {151,0.00300000}, {152,0.00300000}, {153,0.00301802}, {154,0.00300000}, {155,0.00300000}, {156,0.00300000}, {157,0.00300901}, {158,0.00300000}, {159,0.00300000}, {160,0.00302703}, {161,0.00301802}, {162,0.00302703}, {163,0.00308108}, {164,0.00311712}, {165,0.00315315}, {166,0.00325225}, {167,0.00334234}, {168,0.00341441}, {169,0.00345946}, {170,0.00352252}, {171,0.00364865}, {172,0.00376577}, {173,0.00375676}, {174,0.00383784}, {175,0.00384685}, {176,0.00388288}, {177,0.00394595}, {178,0.00393694}, {179,0.00394595}, {180,0.00395495}, {181,0.00395495}, {182,0.00400000}, {183,0.00399099}, {184,0.00400000}, {185,0.00400000}, {186,0.00400000}, {187,0.00400000}, {188,0.00400000}, {189,0.00401802}, {190,0.00400000}, {191,0.00400000}, {192,0.00400000}, {193,0.00400000}, {194,0.00400000}, {195,0.00400000}, {196,0.00400000}, {197,0.00400000}, {198,0.00400901}, {199,0.00400000}, {200,0.00401802}, {201,0.00400000}, {202,0.00400000}, {203,0.00400000}, {204,0.00402703}, {205,0.00402703}, {206,0.00403604}, {207,0.00400901}, {208,0.00406306}, {209,0.00409910}, {210,0.00416216}, {211,0.00428829}, {212,0.00430631}, {213,0.00436036}, {214,0.00453153}, {215,0.00455856}, {216,0.00467568}, {217,0.00467568}, {218,0.00472973}, {219,0.00480180}, {220,0.00483784}, {221,0.00488288}, {222,0.00492793}, {223,0.00494595}, {224,0.00496396}, {225,0.00498198}, {226,0.00500000}, {227,0.00500000}, {228,0.00499099}, {229,0.00501802}, {230,0.00589189}, {231,0.00499099}, {232,0.00500000}, {233,0.00500000}, {234,0.00500000}, {235,0.00500000}, {236,0.00500000}, {237,0.00500000}, {238,0.00503604}, {239,0.00603604}, {240,0.00500000}, {241,0.00500000}, {242,0.00500000}, {243,0.00500901}, {244,0.00500000}, {245,0.00500901}, {246,0.00500000}, {247,0.00504505}, {248,0.00502703}, {249,0.00500901}, {250,0.00504505}, {251,0.00506306}, {252,0.00509910}, {253,0.00509910}, {254,0.00511712}, {255,0.00517117}, {256,0.00668468}, {257,0.00528829}, {258,0.00543243}, {259,0.00551351}, {260,0.00558559}, {261,0.00565766}, {262,0.00573874}, {263,0.00576577}, {264,0.00772072}, {265,0.00581081}, {266,0.00583784}, {267,0.00591892}, {268,0.00594595}, {269,0.00592793}, {270,0.00594595}, {271,0.00597297}, {272,0.00877477}, {273,0.00599099}, {274,0.00600000}, {275,0.00600000}, {276,0.00600000}, {277,0.00600000}, {278,0.00600000}, {279,0.00600000}, {280,0.00806306}, {281,0.00600000}, {282,0.00600000}, {283,0.00600000}, {284,0.00600000}, {285,0.00600000}, {286,0.00600000}, {287,0.00601802}, {288,0.00600901}, {289,0.00600000}, {290,0.00600000}, {291,0.00601802}, {292,0.00601802}, {293,0.00601802}, {294,0.00600901}, {295,0.00784685}, {296,0.00607207}, {297,0.00605405}, {298,0.00609009}, {299,0.00610811}, {300,0.00611712}, {301,0.00619820}, {302,0.00859459}, {303,0.00625225}, {304,0.00641441}, {305,0.00649550}, {306,0.00657658}, {307,0.00665766}, {308,0.00669369}, {309,0.01085586}, {310,0.00678378}, {311,0.00681982}, {312,0.00681081}, {313,0.00688288}, {314,0.00686486}, {315,0.00687387}, {316,0.00897297}, {317,0.00695495}, {318,0.00695495}, {319,0.00695495}, {320,0.00696396}, {321,0.00700000}, {322,0.00699099}, {323,0.00953153}, {324,0.00700000}, {325,0.00700000}, {326,0.00700000}, {327,0.00700000}, {328,0.00700000}, {329,0.00705405}, {330,0.00798198}, {331,0.00700000}, {332,0.00700000}, {333,0.00700000}, {334,0.00700901}, {335,0.00700000}, {336,0.00900901}, {337,0.00700000}, {338,0.00700901}, {339,0.00701802}, {340,0.00701802}, {341,0.00706306}, {342,0.00711712}, {343,0.00711712}, {344,0.00711712}, {345,0.00718018}, {346,0.00721622}, {347,0.00729730}, {348,0.00734234}, {349,0.00895495}, {350,0.00753153}, {351,0.00757658}, {352,0.00764865}, {353,0.00769369}, {354,0.00770270}, {355,0.00900901}, {356,0.00778378}, {357,0.00778378}, {358,0.00781081}, {359,0.00781982}, {360,0.00783784}, {361,0.00967568}, {362,0.00786486}, {363,0.00790090}, {364,0.00790991}, {365,0.00800000}, {366,0.00797297}, {367,0.01163063}, {368,0.00796396}, {369,0.00799099}, {370,0.00799099}, {371,0.00800000}, {372,0.00800000}, {373,0.01146847}, {374,0.00800000}, {375,0.00800000}, {376,0.00800901}, {377,0.00800000}, {378,0.00801802}, {379,0.00950450}, {380,0.00800000}, {381,0.00800000}, {382,0.00801802}, {383,0.00804505}, {384,0.00809910}, {385,0.00911712}, {386,0.00809009}, {387,0.00807207}, {388,0.00809910}, {389,0.00813514}, {390,0.01021622}, {391,0.00812613}, {392,0.00824324}, {393,0.00831532}, {394,0.00831532}, {395,0.00846847}, {396,0.00993694}, {397,0.00854054}, {398,0.00864865}, {399,0.00864865}, {400,0.00868468}, {401,0.00874775}, {402,0.00876577}, {403,0.00876577}, {404,0.00881081}, {405,0.00884685}, {406,0.00883784}, {407,0.01008108}, {408,0.00884685}, {409,0.00887387}, {410,0.00888288}, {411,0.00890991}, {412,0.01088288}, {413,0.00894595}, {414,0.00894595}, {415,0.00897273}, {416,0.00897273}, {417,0.00901818}, {418,0.00899091}, {419,0.00900000}, {420,0.00899091}, {421,0.00900000}, {422,0.00900000}, {423,0.01057273}, {424,0.00900000}, {425,0.00902727}, {426,0.00901818}, {427,0.00900909}, {428,0.01077273}, {429,0.00904545}, {430,0.00902727}, {431,0.00904545}, {432,0.00905455}, {433,0.01095455}, {434,0.00907273}, {435,0.00913636}, {436,0.00919091}, {437,0.00921818}, {438,0.01101818}, {439,0.00936364}, {440,0.00940909}, {441,0.00950000}, {442,0.00956364}, {443,0.01107273}, {444,0.00964545}, {445,0.00965455}, {446,0.00967273}, {447,0.00970909}, {448,0.01109091}, {449,0.00976364}, {450,0.00977273}, {451,0.00977273}, {452,0.00982727}, {453,0.01124545}, {454,0.00986364}, {455,0.00983636}, {456,0.00983636}, {457,0.00985455}, {458,0.01130000}, {459,0.00994545}, {460,0.00994545}, {461,0.00998182}, {462,0.01001818}, {463,0.01000000}, {464,0.00998182}, {465,0.01000909}, {466,0.01000000}, {467,0.01004545}, {468,0.01001818}, {469,0.01000909}, {470,0.01001818}, {471,0.01000000}, {472,0.01188182}, {473,0.01002727}, {474,0.01000000}, {475,0.01001818}, {476,0.01008182}, {477,0.01175455}, {478,0.01007273}, {479,0.01007273}, {480,0.01009091}, {481,0.01014545}, {482,0.01020000}, {483,0.01025455}, {484,0.01024545}, {485,0.01029091}, {486,0.01201818}, {487,0.01044545}, {488,0.01045455}, {489,0.01057273}, {490,0.01063636}, {491,0.01063636}, {492,0.01071818}, {493,0.01073636}, {494,0.01073636}, {495,0.01228182}, {496,0.01073636}, {497,0.01075455}, {498,0.01080909}, {499,0.01081818}, {500,0.01080000}, {505,0.01089091}, {510,0.01099091}, {515,0.01100909}, {520,0.01280000}, {525,0.01110909}, {530,0.01130000}, {535,0.01155455}, {540,0.01342727}, {545,0.01176364}, {550,0.01184545}, {555,0.01190909}, {560,0.01389091}, {565,0.01202727}, {570,0.01214545}, {575,0.01228182}, {580,0.01426364}, {585,0.01272727}, {590,0.01278182}, {595,0.01280909}, {600,0.01470000}, {605,0.01298182}, {610,0.01301818}, {615,0.01313636}, {620,0.01321818}, {625,0.01348182}, {630,0.01368182}, {635,0.01571818}, {640,0.01380909}, {645,0.01386364}, {650,0.01402727}, {655,0.01401818}, {660,0.01414545}, {665,0.01431818}, {670,0.01654545}, {675,0.01467273}, {680,0.01475455}, {685,0.01691818}, {690,0.01488182}, {695,0.01492727}, {700,0.01500909}, {705,0.01510000}, {710,0.01520909}, {715,0.01550000}, {720,0.01566364}, {725,0.01574545}, {730,0.01579091}, {735,0.01581818}, {740,0.01586364}, {745,0.01590909}, {750,0.01771818}, {755,0.01620909}, {760,0.01644545}, {765,0.01662727}, {770,0.01669091}, {775,0.01681818}, {780,0.01678182}, {785,0.01680909}, {790,0.01699091}, {795,0.01705455}, {800,0.01720909}, {805,0.02081818}, {810,0.01755455}, {815,0.01770000}, {820,0.02455455}, {825,0.01780000}, {830,0.01784545}, {835,0.02009091}, {840,0.01805455}, {845,0.01823636}, {850,0.01831818}, {855,0.01851818}, {860,0.02116364}, {865,0.01870909}, {870,0.01876364}, {875,0.01880000}, {880,0.01881818}, {885,0.02239091}, {890,0.01920000}, {895,0.01942727}, {900,0.02168182}, {905,0.01964545}, {910,0.02285455}, {915,0.01972727}, {920,0.01977273}, {925,0.02705455}, {930,0.02000000}, {935,0.02307273}, {940,0.02029091}, {945,0.02065455}, {950,0.02065455}, {955,0.02068182}, {960,0.02333636}, {965,0.02079091}, {970,0.02428182}, {975,0.02095455}, {980,0.02108182}, {985,0.02133636}, {990,0.02150909}, {995,0.02420000}, {1000,0.02170000}, {1010,0.02481818}, {1020,0.02200909}, {1030,0.02901818}, {1040,0.02263636}, {1050,0.02291818}, {1060,0.02286364}, {1070,0.02306364}, {1080,0.02336364}, {1090,0.02366364}, {1100,0.02683636}, {1110,0.02392727}, {1120,0.02680000}, {1130,0.02457273}, {1140,0.02742727}, {1150,0.02484545}, {1160,0.02787273}, {1170,0.02542727}, {1180,0.02558182}, {1190,0.02576364}, {1200,0.02593636}, {1210,0.02632727}, {1220,0.02649091}, {1230,0.03480000}, {1240,0.02680909}, {1250,0.03430000}, {1260,0.02736364}, {1270,0.03169091}, {1280,0.02777273}, {1290,0.03124545}, {1300,0.02845455}, {1310,0.02851818}, {1320,0.03280909}, {1330,0.02887273}, {1340,0.03249091}, {1350,0.02935455}, {1360,0.02957273}, {1370,0.03690000}, {1380,0.02993636}, {1390,0.04030909}, {1400,0.03050000}, {1410,0.03065455}, {1420,0.03528182}, {1430,0.03103636}, {1440,0.03451818}, {1450,0.04040909}, {1460,0.03174545}, {1470,0.03971818}, {1480,0.03240909}, {1490,0.03241818}, {1500,0.03688182}, {1510,0.03310909}, {1520,0.03302727}, {1530,0.03757273}, {1540,0.03376364}, {1550,0.03379091}, {1560,0.03785455}, {1570,0.04632727}, {1580,0.03443636}, {1590,0.04455455}, {1600,0.04234545}, {1610,0.03512727}, {1620,0.03527273}, {1630,0.04451818}, {1640,0.03601818}, {1650,0.03593636}, {1660,0.04080000}, {1670,0.04168182}, {1680,0.03666364}, {1690,0.03688182}, {1700,0.04171818}, {1710,0.04276364}, {1720,0.03752727}, {1730,0.03775455}, {1740,0.04297273}, {1750,0.05126364}, {1760,0.03879091}, {1770,0.03866364}, {1780,0.04366364}, {1790,0.04446364}, {1800,0.05058182}, {1810,0.03951818}, {1820,0.03976364}, {1830,0.04510909}, {1840,0.04592727}, {1850,0.05113636}, {1860,0.04067273}, {1870,0.04086364}, {1880,0.04672727}, {1890,0.04666364}, {1900,0.04745455}, {1910,0.05826364}, {1920,0.04208182}, {1930,0.04210909}, {1940,0.04754545}, {1950,0.04800000}, {1960,0.04871818}, {1970,0.04936364}, {1980,0.06317273}, {1990,0.04362727}, {2000,0.04373636}, {2050,0.04392727}, {2100,0.05135455}, {2150,0.05282727}, {2200,0.05418182}, {2250,0.05538182}, {2300,0.05672727}, {2350,0.05795455}, {2400,0.05914545}, {2450,0.06012727}, {2500,0.06102727}, {2550,0.05926364}, {2600,0.05707273}, {2650,0.07704545}, {2700,0.07521818}, {2750,0.06807273}, {2800,0.06877273}, {2850,0.06279091}, {2900,0.07429091}, {2950,0.09029091}, {3000,0.07352727}, {3050,0.08625455}, {3100,0.08680909}, {3150,0.07710909}, {3200,0.08109091}, {3250,0.08030909}, {3300,0.09728182}, {3350,0.08965455}, {3400,0.10522727}, {3450,0.08619091}, {3500,0.10586364}, {3550,0.09087273}, {3600,0.09670909}, {3650,0.09807273}, {3700,0.08766364}, {3750,0.09171818}, {3800,0.09655455}, {3850,0.09593636}, {3900,0.09889091}, {3950,0.10152727}, {4000,0.09754545}, {4050,0.10400000}, {4100,0.12383636}, {4150,0.10224545}, {4200,0.10750000}, {4250,0.10271818}, {4300,0.10005455}, {4350,0.10974545}, {4400,0.14360000}, {4450,0.14458182}, {4500,0.14383636}, {4550,0.14357273}, {4600,0.14318182}, {4650,0.14243636}, {4700,0.14142727}, {4750,0.14110909}, {4800,0.13996364}, {4850,0.14290909}, {4900,0.12077273}, {4950,0.12297273}, {5000,0.12153636}, {5050,0.15772727}, {5100,0.13688182}, {5150,0.14823636}, {5200,0.12931818}, {5250,0.16650000}, {5300,0.13471818}, {5350,0.16147273}, {5400,0.13945455}, {5450,0.13721818}, {5500,0.13074545}, {5550,0.15790909}, {5600,0.15110909}, {5650,0.16948182}, {5700,0.14409091}, {5750,0.16995455}, {5800,0.15258182}, {5850,0.18326364}, {5900,0.15080909}, {5950,0.15916364}, {6000,0.17011818}, {6050,0.15494545}, {6100,0.17639091}, {6150,0.16297273}, {6200,0.15423636}, {6250,0.17356364}, {6300,0.17548182}, {6350,0.15748182}, {6400,0.15868182}, {6450,0.17164545}, {6500,0.19138182}, {6550,0.17206364}, {6600,0.16730909}, {6650,0.16506364}, {6700,0.16658182}, {6750,0.16883636}, {6800,0.16490909}, {6850,0.16634545}, {6900,0.16802727}, {6950,0.16931818}, {7000,0.17030909}, {7050,0.17234545}, {7100,0.16871818}, {7150,0.17614545}, {7200,0.17732727}, {7250,0.21706364}, {7300,0.21060909}, {7350,0.18830000}, {7400,0.18020000}, {7450,0.18448182}, {7500,0.22083636}, {7550,0.19050909}, {7600,0.18424545}, {7650,0.23625455}, {7700,0.20510000}, {7750,0.18772727}, {7800,0.23040909}, {7850,0.19123636}, {7900,0.20874545}, {7950,0.20750909}, {8000,0.19369091}, {8050,0.21063636}, {8100,0.19619091}, {8150,0.20869091}, {8200,0.24930000}, {8250,0.19011818}, {8300,0.23807273}, {8350,0.20662727}, {8400,0.21496364}, {8450,0.24805455}, {8500,0.20970909}, {8550,0.27985455}, {8600,0.26372727}, {8650,0.25230909}, {8700,0.21320000}, {8750,0.21484545}, {8800,0.22977273}, {8850,0.24530000}, {8900,0.25715455}, {8950,0.27435455}, {9000,0.21815455}, {9050,0.21170000}, {9100,0.22246364}, {9150,0.22544545}, {9200,0.22559091}, {9250,0.22583636}, {9300,0.22580909}, {9350,0.22766364}, {9400,0.23239091}, {9450,0.27942727}, {9500,0.27251818}, {9550,0.25320000}, {9600,0.24006364}, {9650,0.23518182}, {9700,0.23702727}, {9750,0.27953636}, {9800,0.25326364}, {9850,0.23727273}, {9900,0.25396364}, {9950,0.27529091}, {10000,0.22837273}, {10100,0.32739091}, {10200,0.26709091}, {10300,0.25668182}, {10400,0.27875455}, {10500,0.27327273}, {10600,0.27130000}, {10700,0.30852727}, {10800,0.25902727}, {10900,0.27484545}, {11000,0.29982727}, {11100,0.32460909}, {11200,0.32978182}, {11300,0.28165455}, {11400,0.27971818}, {11500,0.28072727}, {11600,0.30377273}, {11700,0.36364545}, {11800,0.34714545}, {11900,0.33350909}, {12000,0.32266364}, {12100,0.29655455}, {12200,0.36782727}, {12300,0.32081818}, {12400,0.30760909}, {12500,0.37118182}, {12600,0.32481818}, {12700,0.37326364}, {12800,0.31833636}, {12900,0.36755455}, {13000,0.34180909}, {13100,0.33457273}, {13200,0.36936364}, {13300,0.39437273}, {13400,0.34501818}, {13500,0.32991818}, {13600,0.35203636}, {13700,0.35775455}, {13800,0.36371818}, {13900,0.36602727}, {14000,0.36076364}, {14100,0.35420000}, {14200,0.35099091}, {14300,0.77714545}, {14400,0.40505455}, {14500,0.37133636}, {14600,0.43043636}, {14700,0.40413636}, {14800,0.37018182}, {14900,0.41575455}, {15000,0.37145455}, {15100,0.41530909}, {15200,0.46390909}, {15300,0.40152727}, {15400,0.44666364}, {15500,0.46697273}, {15600,0.39790909}, {15700,0.42025455}, {15800,0.44550000}, {15900,0.45990909}, {16000,0.46394545}, {16100,0.46453636}, {16200,0.46588182}, {16300,0.46335455}, {16400,0.45754545}, {16500,0.44814545}, {16600,0.42217273}, {16700,0.49180909}, {16800,0.47071818}, {16900,0.45451818}, {17000,0.51308182}, {17100,0.47346364}, {17200,0.54700000}, {17300,0.46250000}, {17400,0.53053636}, {17500,0.47054545}, {17600,0.51020000}, {17700,0.45936364}, {17800,0.46259091}, {17900,0.50824545}, {18000,0.53938182}, {18100,0.55482727}, {18200,0.57070000}, {18300,0.46761818}, {18400,0.47305455}, {18500,0.47037273}, {18600,0.57024545}, {18700,0.55127273}, {18800,0.55692727}, {18900,0.54458182}, {19000,0.51189091}, {19100,0.59599091}, {19200,0.56088182}, {19300,0.53820909}, {19400,0.59234545}, {19500,0.56210000}, {19600,0.59474545}, {19700,0.55660000}, {19800,0.58604545}, {19900,0.54032727}, {20000,0.56174074}};
data["big_flat"]["TemplateCoq"]["reif"]["user"] = {{1,0.00002727}, {2,0.00027027}, {3,0.00018919}, {4,0.00020721}, {5,0.00030631}, {6,0.00039640}, {7,0.00026126}, {8,0.00046847}, {9,0.00042342}, {10,0.00062162}, {11,0.00053153}, {12,0.00041441}, {13,0.00060360}, {14,0.00036937}, {15,0.00059459}, {16,0.00078378}, {17,0.00063063}, {18,0.00072072}, {19,0.00043243}, {20,0.00068468}, {21,0.00048649}, {22,0.00067568}, {23,0.00049550}, {24,0.00064865}, {25,0.00063063}, {26,0.00075676}, {27,0.00052252}, {28,0.00072072}, {29,0.00080180}, {30,0.00096396}, {31,0.00064865}, {32,0.00087387}, {33,0.00059459}, {34,0.00090991}, {35,0.00096396}, {36,0.00104505}, {37,0.00109910}, {38,0.00072973}, {39,0.00096396}, {40,0.00123423}, {41,0.00085586}, {42,0.00096396}, {43,0.00096396}, {44,0.00097297}, {45,0.00110811}, {46,0.00116216}, {47,0.00109009}, {48,0.00121622}, {49,0.00122523}, {50,0.00116216}, {51,0.00136937}, {52,0.00131532}, {53,0.00109910}, {54,0.00129730}, {55,0.00139640}, {56,0.00136036}, {57,0.00118919}, {58,0.00123423}, {59,0.00154054}, {60,0.00153153}, {61,0.00130631}, {62,0.00124324}, {63,0.00127027}, {64,0.00155856}, {65,0.00158559}, {66,0.00158559}, {67,0.00177477}, {68,0.00149550}, {69,0.00152252}, {70,0.00127027}, {71,0.00136036}, {72,0.00153153}, {73,0.00172973}, {74,0.00146847}, {75,0.00160360}, {76,0.00186486}, {77,0.00202703}, {78,0.00200000}, {79,0.00198198}, {80,0.00195495}, {81,0.00206306}, {82,0.00194595}, {83,0.00192793}, {84,0.00175676}, {85,0.00197297}, {86,0.00199099}, {87,0.00192793}, {88,0.00306306}, {89,0.00169369}, {90,0.00155856}, {91,0.00156757}, {92,0.00152252}, {93,0.00166667}, {94,0.00171171}, {95,0.00186486}, {96,0.00206306}, {97,0.00231532}, {98,0.00244144}, {99,0.00263063}, {100,0.00227027}, {101,0.00228829}, {102,0.00181081}, {103,0.00169369}, {104,0.00201802}, {105,0.00231532}, {106,0.00254955}, {107,0.00263063}, {108,0.00287387}, {109,0.00234234}, {110,0.00224324}, {111,0.00253153}, {112,0.00214414}, {113,0.00227027}, {114,0.00242342}, {115,0.00230631}, {116,0.00228829}, {117,0.00236937}, {118,0.00257658}, {119,0.00254955}, {120,0.00281982}, {121,0.00234234}, {122,0.00250450}, {123,0.00251351}, {124,0.00286486}, {125,0.00277477}, {126,0.00274775}, {127,0.00234234}, {128,0.00273874}, {129,0.00281081}, {130,0.00254955}, {131,0.00283784}, {132,0.00275676}, {133,0.00256757}, {134,0.00289189}, {135,0.00279279}, {136,0.00279279}, {137,0.00274775}, {138,0.00301802}, {139,0.00287387}, {140,0.00359459}, {141,0.00293694}, {142,0.00292793}, {143,0.00292793}, {144,0.00299099}, {145,0.00301802}, {146,0.00301802}, {147,0.00308108}, {148,0.00307207}, {149,0.00321622}, {150,0.00319820}, {151,0.00290090}, {152,0.00317117}, {153,0.00304505}, {154,0.00327928}, {155,0.00313514}, {156,0.00305405}, {157,0.00333333}, {158,0.00315315}, {159,0.00346847}, {160,0.00339640}, {161,0.00338739}, {162,0.00338739}, {163,0.00343243}, {164,0.00355856}, {165,0.00339640}, {166,0.00336937}, {167,0.00347748}, {168,0.00351351}, {169,0.00336937}, {170,0.00348649}, {171,0.00361261}, {172,0.00371171}, {173,0.00356757}, {174,0.00363063}, {175,0.00373874}, {176,0.00371171}, {177,0.00367568}, {178,0.00372973}, {179,0.00371171}, {180,0.00365766}, {181,0.00394595}, {182,0.00379279}, {183,0.00367568}, {184,0.00364865}, {185,0.00383784}, {186,0.00376577}, {187,0.00422523}, {188,0.00390090}, {189,0.00386486}, {190,0.00394595}, {191,0.00403604}, {192,0.00397297}, {193,0.00397297}, {194,0.00398198}, {195,0.00397297}, {196,0.00405405}, {197,0.00406306}, {198,0.00427027}, {199,0.00417117}, {200,0.00420721}, {201,0.00406306}, {202,0.00409009}, {203,0.00415315}, {204,0.00428829}, {205,0.00411712}, {206,0.00409009}, {207,0.00401802}, {208,0.00398198}, {209,0.00409910}, {210,0.00403604}, {211,0.00423423}, {212,0.00432432}, {213,0.00443243}, {214,0.00465766}, {215,0.00458559}, {216,0.00454054}, {217,0.00451351}, {218,0.00453153}, {219,0.00454054}, {220,0.00448649}, {221,0.00449550}, {222,0.00462162}, {223,0.00463063}, {224,0.00476577}, {225,0.00485586}, {226,0.00504505}, {227,0.00481081}, {228,0.00461261}, {229,0.00465766}, {230,0.00575676}, {231,0.00481081}, {232,0.00494595}, {233,0.00496396}, {234,0.00494595}, {235,0.00491892}, {236,0.00505405}, {237,0.00473874}, {238,0.00475676}, {239,0.00605405}, {240,0.00487387}, {241,0.00489189}, {242,0.00511712}, {243,0.00500000}, {244,0.00500901}, {245,0.00484685}, {246,0.00509910}, {247,0.00526126}, {248,0.00500901}, {249,0.00538739}, {250,0.00509009}, {251,0.00520721}, {252,0.00533333}, {253,0.00527027}, {254,0.00537838}, {255,0.00547748}, {256,0.00653153}, {257,0.00524324}, {258,0.00531532}, {259,0.00540541}, {260,0.00531532}, {261,0.00538739}, {262,0.00540541}, {263,0.00534234}, {264,0.00742342}, {265,0.00552252}, {266,0.00561261}, {267,0.00540541}, {268,0.00573874}, {269,0.00552252}, {270,0.00575676}, {271,0.00538739}, {272,0.00845946}, {273,0.00542342}, {274,0.00575676}, {275,0.00564865}, {276,0.00579279}, {277,0.00578378}, {278,0.00562162}, {279,0.00600000}, {280,0.00809910}, {281,0.00587387}, {282,0.00577477}, {283,0.00588288}, {284,0.00562162}, {285,0.00615315}, {286,0.00582883}, {287,0.00588288}, {288,0.00598198}, {289,0.00608108}, {290,0.00578378}, {291,0.00602703}, {292,0.00600901}, {293,0.00624324}, {294,0.00624324}, {295,0.00748649}, {296,0.00606306}, {297,0.00601802}, {298,0.00640541}, {299,0.00604505}, {300,0.00628829}, {301,0.00627928}, {302,0.00827928}, {303,0.00635135}, {304,0.00611712}, {305,0.00622523}, {306,0.00627928}, {307,0.00642342}, {308,0.00625225}, {309,0.01130631}, {310,0.00606306}, {311,0.00640541}, {312,0.00652252}, {313,0.00649550}, {314,0.00665766}, {315,0.00639640}, {316,0.00886486}, {317,0.00661261}, {318,0.00652252}, {319,0.00662162}, {320,0.00669369}, {321,0.00665766}, {322,0.00669369}, {323,0.00956757}, {324,0.00660360}, {325,0.00675676}, {326,0.00681081}, {327,0.00668468}, {328,0.00684685}, {329,0.00688288}, {330,0.00766667}, {331,0.00674775}, {332,0.00690090}, {333,0.00673874}, {334,0.00690090}, {335,0.00687387}, {336,0.00826126}, {337,0.00681982}, {338,0.00672973}, {339,0.00685586}, {340,0.00683784}, {341,0.00705405}, {342,0.00703604}, {343,0.00724324}, {344,0.00708108}, {345,0.00707207}, {346,0.00716216}, {347,0.00721622}, {348,0.00709910}, {349,0.00856757}, {350,0.00727928}, {351,0.00725225}, {352,0.00719820}, {353,0.00725225}, {354,0.00727027}, {355,0.00912613}, {356,0.00731532}, {357,0.00752252}, {358,0.00741441}, {359,0.00733333}, {360,0.00721622}, {361,0.00976577}, {362,0.00740541}, {363,0.00762162}, {364,0.00728829}, {365,0.00744144}, {366,0.00741441}, {367,0.01181982}, {368,0.00739640}, {369,0.00767568}, {370,0.00784685}, {371,0.00769369}, {372,0.00784685}, {373,0.01157658}, {374,0.00785586}, {375,0.00780180}, {376,0.00788288}, {377,0.00790991}, {378,0.00793694}, {379,0.00958559}, {380,0.00782883}, {381,0.00824324}, {382,0.00771171}, {383,0.00809009}, {384,0.00788288}, {385,0.00945946}, {386,0.00793694}, {387,0.00821622}, {388,0.00813514}, {389,0.00806306}, {390,0.01034234}, {391,0.00845946}, {392,0.00828829}, {393,0.00836937}, {394,0.00843243}, {395,0.00846847}, {396,0.00979279}, {397,0.00844144}, {398,0.00842342}, {399,0.00853153}, {400,0.00827928}, {401,0.00870270}, {402,0.00845045}, {403,0.00863063}, {404,0.00823423}, {405,0.00876577}, {406,0.00867568}, {407,0.00988288}, {408,0.00838739}, {409,0.00881081}, {410,0.00877477}, {411,0.00861261}, {412,0.01115315}, {413,0.00890991}, {414,0.00866667}, {415,0.00893636}, {416,0.00880000}, {417,0.00878182}, {418,0.00891818}, {419,0.00896364}, {420,0.00867273}, {421,0.00879091}, {422,0.00911818}, {423,0.01075455}, {424,0.00898182}, {425,0.00860000}, {426,0.00906364}, {427,0.00942727}, {428,0.01104545}, {429,0.00943636}, {430,0.00911818}, {431,0.00918182}, {432,0.00925455}, {433,0.01095455}, {434,0.00907273}, {435,0.00953636}, {436,0.00951818}, {437,0.00938182}, {438,0.01130909}, {439,0.00952727}, {440,0.00953636}, {441,0.00940000}, {442,0.00954545}, {443,0.01165455}, {444,0.00982727}, {445,0.00960909}, {446,0.00984545}, {447,0.00970909}, {448,0.01152727}, {449,0.00933636}, {450,0.00990909}, {451,0.00988182}, {452,0.00983636}, {453,0.01166364}, {454,0.00976364}, {455,0.00985455}, {456,0.01002727}, {457,0.00986364}, {458,0.01152727}, {459,0.00998182}, {460,0.00998182}, {461,0.00975455}, {462,0.00941818}, {463,0.00999091}, {464,0.01018182}, {465,0.01034545}, {466,0.01016364}, {467,0.00977273}, {468,0.01018182}, {469,0.01014545}, {470,0.01020000}, {471,0.01026364}, {472,0.01220909}, {473,0.01030000}, {474,0.01057273}, {475,0.01061818}, {476,0.01044545}, {477,0.01177273}, {478,0.01035455}, {479,0.01069091}, {480,0.01003636}, {481,0.01016364}, {482,0.01073636}, {483,0.01033636}, {484,0.01074545}, {485,0.01074545}, {486,0.01246364}, {487,0.01066364}, {488,0.01029091}, {489,0.01038182}, {490,0.01101818}, {491,0.01039091}, {492,0.01101818}, {493,0.01080909}, {494,0.01062727}, {495,0.01257273}, {496,0.01090909}, {497,0.01054545}, {498,0.01071818}, {499,0.01120000}, {500,0.01114545}, {505,0.01107273}, {510,0.01123636}, {515,0.01146364}, {520,0.01280909}, {525,0.01164545}, {530,0.01175455}, {535,0.01184545}, {540,0.01368182}, {545,0.01199091}, {550,0.01184545}, {555,0.01219091}, {560,0.01391818}, {565,0.01227273}, {570,0.01252727}, {575,0.01290909}, {580,0.01442727}, {585,0.01265455}, {590,0.01285455}, {595,0.01304545}, {600,0.01421818}, {605,0.01324545}, {610,0.01330000}, {615,0.01330909}, {620,0.01366364}, {625,0.01367273}, {630,0.01375455}, {635,0.01559091}, {640,0.01380909}, {645,0.01411818}, {650,0.01376364}, {655,0.01391818}, {660,0.01465455}, {665,0.01443636}, {670,0.01618182}, {675,0.01457273}, {680,0.01466364}, {685,0.01670000}, {690,0.01480909}, {695,0.01500909}, {700,0.01504545}, {705,0.01500000}, {710,0.01523636}, {715,0.01543636}, {720,0.01562727}, {725,0.01566364}, {730,0.01554545}, {735,0.01579091}, {740,0.01579091}, {745,0.01578182}, {750,0.01721818}, {755,0.01628182}, {760,0.01599091}, {765,0.01610909}, {770,0.01647273}, {775,0.01647273}, {780,0.01659091}, {785,0.01664545}, {790,0.01702727}, {795,0.01701818}, {800,0.01692727}, {805,0.02076364}, {810,0.01727273}, {815,0.01725455}, {820,0.02437273}, {825,0.01719091}, {830,0.01772727}, {835,0.01963636}, {840,0.01771818}, {845,0.01781818}, {850,0.01831818}, {855,0.01802727}, {860,0.02094545}, {865,0.01813636}, {870,0.01844545}, {875,0.01850000}, {880,0.01873636}, {885,0.02224545}, {890,0.01878182}, {895,0.01910000}, {900,0.02182727}, {905,0.01917273}, {910,0.02318182}, {915,0.01952727}, {920,0.01949091}, {925,0.02679091}, {930,0.01978182}, {935,0.02322727}, {940,0.01982727}, {945,0.02018182}, {950,0.02011818}, {955,0.02027273}, {960,0.02342727}, {965,0.02017273}, {970,0.02422727}, {975,0.02058182}, {980,0.02089091}, {985,0.02128182}, {990,0.02094545}, {995,0.02442727}, {1000,0.02152727}, {1010,0.02486364}, {1020,0.02206364}, {1030,0.02913636}, {1040,0.02259091}, {1050,0.02270909}, {1060,0.02293636}, {1070,0.02336364}, {1080,0.02350000}, {1090,0.02379091}, {1100,0.02661818}, {1110,0.02383636}, {1120,0.02679091}, {1130,0.02458182}, {1140,0.02718182}, {1150,0.02473636}, {1160,0.02761818}, {1170,0.02540000}, {1180,0.02537273}, {1190,0.02569091}, {1200,0.02593636}, {1210,0.02649091}, {1220,0.02605455}, {1230,0.03500000}, {1240,0.02708182}, {1250,0.03418182}, {1260,0.02721818}, {1270,0.03183636}, {1280,0.02788182}, {1290,0.03150909}, {1300,0.02834545}, {1310,0.02860000}, {1320,0.03330909}, {1330,0.02932727}, {1340,0.03286364}, {1350,0.02947273}, {1360,0.02957273}, {1370,0.03666364}, {1380,0.03009091}, {1390,0.03974545}, {1400,0.03111818}, {1410,0.03065455}, {1420,0.03544545}, {1430,0.03130000}, {1440,0.03451818}, {1450,0.04002727}, {1460,0.03215455}, {1470,0.03933636}, {1480,0.03290000}, {1490,0.03277273}, {1500,0.03660909}, {1510,0.03361818}, {1520,0.03355455}, {1530,0.03710909}, {1540,0.03393636}, {1550,0.03423636}, {1560,0.03740909}, {1570,0.04622727}, {1580,0.03453636}, {1590,0.04450909}, {1600,0.04239091}, {1610,0.03511818}, {1620,0.03528182}, {1630,0.04461818}, {1640,0.03607273}, {1650,0.03585455}, {1660,0.04028182}, {1670,0.04177273}, {1680,0.03648182}, {1690,0.03691818}, {1700,0.04143636}, {1710,0.04284545}, {1720,0.03710909}, {1730,0.03790909}, {1740,0.04314545}, {1750,0.04906364}, {1760,0.03823636}, {1770,0.03826364}, {1780,0.04368182}, {1790,0.04449091}, {1800,0.04973636}, {1810,0.03928182}, {1820,0.03950909}, {1830,0.04502727}, {1840,0.04582727}, {1850,0.05046364}, {1860,0.04046364}, {1870,0.04052727}, {1880,0.04665455}, {1890,0.04660000}, {1900,0.04745455}, {1910,0.05789091}, {1920,0.04254545}, {1930,0.04209091}, {1940,0.04733636}, {1950,0.04752727}, {1960,0.04814545}, {1970,0.04875455}, {1980,0.06300909}, {1990,0.04403636}, {2000,0.04378182}, {2050,0.04427273}, {2100,0.05061818}, {2150,0.05242727}, {2200,0.05415455}, {2250,0.05525455}, {2300,0.05672727}, {2350,0.05740000}, {2400,0.05897273}, {2450,0.05994545}, {2500,0.06105455}, {2550,0.05893636}, {2600,0.05718182}, {2650,0.07659091}, {2700,0.07502727}, {2750,0.06793636}, {2800,0.06840000}, {2850,0.06300909}, {2900,0.07431818}, {2950,0.08932727}, {3000,0.07338182}, {3050,0.08561818}, {3100,0.08640909}, {3150,0.07664545}, {3200,0.08040909}, {3250,0.07995455}, {3300,0.09658182}, {3350,0.08919091}, {3400,0.10450909}, {3450,0.08593636}, {3500,0.10528182}, {3550,0.09032727}, {3600,0.09604545}, {3650,0.09750909}, {3700,0.08750909}, {3750,0.09094545}, {3800,0.09635455}, {3850,0.09595455}, {3900,0.09855455}, {3950,0.10084545}, {4000,0.09750909}, {4050,0.10348182}, {4100,0.12333636}, {4150,0.10142727}, {4200,0.10699091}, {4250,0.10228182}, {4300,0.09970000}, {4350,0.10946364}, {4400,0.14226364}, {4450,0.14353636}, {4500,0.14283636}, {4550,0.14229091}, {4600,0.14204545}, {4650,0.14173636}, {4700,0.14045455}, {4750,0.14006364}, {4800,0.13925455}, {4850,0.14191818}, {4900,0.12021818}, {4950,0.12224545}, {5000,0.12112727}, {5050,0.15680909}, {5100,0.13634545}, {5150,0.14732727}, {5200,0.12876364}, {5250,0.16474545}, {5300,0.13420909}, {5350,0.16048182}, {5400,0.13880909}, {5450,0.13692727}, {5500,0.13056364}, {5550,0.15769091}, {5600,0.15097273}, {5650,0.16943636}, {5700,0.14416364}, {5750,0.16963636}, {5800,0.15217273}, {5850,0.18334545}, {5900,0.15072727}, {5950,0.15911818}, {6000,0.17062727}, {6050,0.15488182}, {6100,0.17546364}, {6150,0.16230909}, {6200,0.15355455}, {6250,0.17259091}, {6300,0.17401818}, {6350,0.15710909}, {6400,0.15788182}, {6450,0.17037273}, {6500,0.19026364}, {6550,0.17100000}, {6600,0.16658182}, {6650,0.16444545}, {6700,0.16602727}, {6750,0.16774545}, {6800,0.16418182}, {6850,0.16568182}, {6900,0.16770909}, {6950,0.16883636}, {7000,0.16955455}, {7050,0.17183636}, {7100,0.16788182}, {7150,0.17565455}, {7200,0.17621818}, {7250,0.21528182}, {7300,0.20935455}, {7350,0.18747273}, {7400,0.17929091}, {7450,0.18392727}, {7500,0.22012727}, {7550,0.19054545}, {7600,0.18423636}, {7650,0.23600000}, {7700,0.20477273}, {7750,0.18782727}, {7800,0.22997273}, {7850,0.19118182}, {7900,0.20819091}, {7950,0.20728182}, {8000,0.19334545}, {8050,0.21115455}, {8100,0.19627273}, {8150,0.20866364}, {8200,0.24938182}, {8250,0.19024545}, {8300,0.23772727}, {8350,0.20649091}, {8400,0.21474545}, {8450,0.24817273}, {8500,0.20965455}, {8550,0.27998182}, {8600,0.26358182}, {8650,0.25259091}, {8700,0.21333636}, {8750,0.21470000}, {8800,0.22960000}, {8850,0.24543636}, {8900,0.25692727}, {8950,0.27419091}, {9000,0.21756364}, {9050,0.21169091}, {9100,0.22187273}, {9150,0.22526364}, {9200,0.22545455}, {9250,0.22565455}, {9300,0.22584545}, {9350,0.22728182}, {9400,0.23227273}, {9450,0.27908182}, {9500,0.27240909}, {9550,0.25312727}, {9600,0.23942727}, {9650,0.23517273}, {9700,0.23661818}, {9750,0.27950909}, {9800,0.25327273}, {9850,0.23661818}, {9900,0.25393636}, {9950,0.27541818}, {10000,0.22785455}, {10100,0.32701818}, {10200,0.26690909}, {10300,0.25687273}, {10400,0.27885455}, {10500,0.27328182}, {10600,0.27133636}, {10700,0.30828182}, {10800,0.25908182}, {10900,0.27489091}, {11000,0.29994545}, {11100,0.32460909}, {11200,0.32961818}, {11300,0.28169091}, {11400,0.27970000}, {11500,0.28071818}, {11600,0.30402727}, {11700,0.36163636}, {11800,0.34527273}, {11900,0.33243636}, {12000,0.32175455}, {12100,0.29603636}, {12200,0.36600909}, {12300,0.31981818}, {12400,0.30702727}, {12500,0.37086364}, {12600,0.32485455}, {12700,0.37287273}, {12800,0.31819091}, {12900,0.36745455}, {13000,0.34173636}, {13100,0.33442727}, {13200,0.36864545}, {13300,0.39294545}, {13400,0.34426364}, {13500,0.32942727}, {13600,0.35122727}, {13700,0.35704545}, {13800,0.36311818}, {13900,0.36544545}, {14000,0.36049091}, {14100,0.35352727}, {14200,0.35078182}, {14300,0.77540909}, {14400,0.40505455}, {14500,0.37100909}, {14600,0.43012727}, {14700,0.40402727}, {14800,0.36969091}, {14900,0.41566364}, {15000,0.37127273}, {15100,0.41535455}, {15200,0.46358182}, {15300,0.40166364}, {15400,0.44653636}, {15500,0.46694545}, {15600,0.39807273}, {15700,0.42065455}, {15800,0.44566364}, {15900,0.45973636}, {16000,0.46363636}, {16100,0.46401818}, {16200,0.46549091}, {16300,0.46268182}, {16400,0.45724545}, {16500,0.44799091}, {16600,0.42197273}, {16700,0.49116364}, {16800,0.47050909}, {16900,0.45454545}, {17000,0.51310909}, {17100,0.47319091}, {17200,0.54675455}, {17300,0.46220000}, {17400,0.53002727}, {17500,0.47034545}, {17600,0.50977273}, {17700,0.45883636}, {17800,0.46259091}, {17900,0.50825455}, {18000,0.53940909}, {18100,0.55481818}, {18200,0.57053636}, {18300,0.46760000}, {18400,0.47269091}, {18500,0.47015455}, {18600,0.57029091}, {18700,0.55101818}, {18800,0.55646364}, {18900,0.54419091}, {19000,0.51200000}, {19100,0.59612727}, {19200,0.56062727}, {19300,0.53804545}, {19400,0.59225455}, {19500,0.56176364}, {19600,0.59466364}, {19700,0.55631818}, {19800,0.58565455}, {19900,0.54049091}, {20000,0.56170370}};
data["big_flat"]["TemplateCoq"]["reif"]["system"] = {{1,0.00018182}, {2,0.00003604}, {3,0.00003604}, {4,0.00000000}, {5,0.00003604}, {6,0.00003604}, {7,0.00003604}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003604}, {13,0.00000000}, {14,0.00006306}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00002703}, {20,0.00000000}, {21,0.00000000}, {22,0.00003604}, {23,0.00003604}, {24,0.00003604}, {25,0.00000000}, {26,0.00003604}, {27,0.00000000}, {28,0.00003604}, {29,0.00000000}, {30,0.00000000}, {31,0.00007207}, {32,0.00000000}, {33,0.00003604}, {34,0.00003604}, {35,0.00000000}, {36,0.00000000}, {37,0.00003604}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00003604}, {42,0.00003604}, {43,0.00003604}, {44,0.00000000}, {45,0.00003604}, {46,0.00000000}, {47,0.00000000}, {48,0.00007207}, {49,0.00000000}, {50,0.00000000}, {51,0.00003604}, {52,0.00000000}, {53,0.00000000}, {54,0.00003604}, {55,0.00000000}, {56,0.00003604}, {57,0.00000000}, {58,0.00000000}, {59,0.00003604}, {60,0.00000000}, {61,0.00003604}, {62,0.00007207}, {63,0.00000000}, {64,0.00007207}, {65,0.00003604}, {66,0.00006306}, {67,0.00002703}, {68,0.00003604}, {69,0.00000000}, {70,0.00003604}, {71,0.00003604}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00007207}, {76,0.00000000}, {77,0.00000000}, {78,0.00003604}, {79,0.00000000}, {80,0.00003604}, {81,0.00000000}, {82,0.00002703}, {83,0.00003604}, {84,0.00010811}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00003604}, {90,0.00000000}, {91,0.00000000}, {92,0.00003604}, {93,0.00000000}, {94,0.00000000}, {95,0.00006306}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00007207}, {100,0.00003604}, {101,0.00002703}, {102,0.00003604}, {103,0.00000000}, {104,0.00007207}, {105,0.00000000}, {106,0.00002703}, {107,0.00003604}, {108,0.00000000}, {109,0.00000000}, {110,0.00018018}, {111,0.00000000}, {112,0.00006306}, {113,0.00000000}, {114,0.00003604}, {115,0.00007207}, {116,0.00006306}, {117,0.00003604}, {118,0.00003604}, {119,0.00007207}, {120,0.00003604}, {121,0.00000000}, {122,0.00010811}, {123,0.00003604}, {124,0.00000000}, {125,0.00003604}, {126,0.00000000}, {127,0.00007207}, {128,0.00007207}, {129,0.00003604}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00007207}, {135,0.00000000}, {136,0.00010811}, {137,0.00002703}, {138,0.00003604}, {139,0.00000000}, {140,0.00002703}, {141,0.00000000}, {142,0.00003604}, {143,0.00003604}, {144,0.00000000}, {145,0.00000000}, {146,0.00002703}, {147,0.00000000}, {148,0.00006306}, {149,0.00000000}, {150,0.00000000}, {151,0.00003604}, {152,0.00003604}, {153,0.00003604}, {154,0.00000000}, {155,0.00006306}, {156,0.00007207}, {157,0.00000000}, {158,0.00003604}, {159,0.00003604}, {160,0.00000000}, {161,0.00003604}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00003604}, {167,0.00006306}, {168,0.00003604}, {169,0.00010811}, {170,0.00000000}, {171,0.00003604}, {172,0.00000000}, {173,0.00003604}, {174,0.00003604}, {175,0.00000000}, {176,0.00007207}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00003604}, {183,0.00000000}, {184,0.00009910}, {185,0.00002703}, {186,0.00000000}, {187,0.00003604}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00003604}, {194,0.00000000}, {195,0.00000000}, {196,0.00006306}, {197,0.00003604}, {198,0.00003604}, {199,0.00007207}, {200,0.00007207}, {201,0.00006306}, {202,0.00002703}, {203,0.00003604}, {204,0.00003604}, {205,0.00003604}, {206,0.00002703}, {207,0.00003604}, {208,0.00006306}, {209,0.00003604}, {210,0.00003604}, {211,0.00010811}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00003604}, {216,0.00003604}, {217,0.00007207}, {218,0.00000000}, {219,0.00007207}, {220,0.00003604}, {221,0.00000000}, {222,0.00007207}, {223,0.00000000}, {224,0.00000000}, {225,0.00007207}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00007207}, {230,0.00003604}, {231,0.00003604}, {232,0.00000000}, {233,0.00007207}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00010811}, {238,0.00007207}, {239,0.00006306}, {240,0.00000000}, {241,0.00002703}, {242,0.00000000}, {243,0.00003604}, {244,0.00007207}, {245,0.00003604}, {246,0.00007207}, {247,0.00003604}, {248,0.00003604}, {249,0.00003604}, {250,0.00007207}, {251,0.00000000}, {252,0.00000000}, {253,0.00007207}, {254,0.00000000}, {255,0.00003604}, {256,0.00009910}, {257,0.00000000}, {258,0.00003604}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00003604}, {263,0.00000000}, {264,0.00003604}, {265,0.00000000}, {266,0.00002703}, {267,0.00006306}, {268,0.00003604}, {269,0.00000000}, {270,0.00003604}, {271,0.00000000}, {272,0.00013514}, {273,0.00007207}, {274,0.00003604}, {275,0.00003604}, {276,0.00000000}, {277,0.00002703}, {278,0.00007207}, {279,0.00000000}, {280,0.00003604}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00006306}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00006306}, {289,0.00007207}, {290,0.00003604}, {291,0.00003604}, {292,0.00000000}, {293,0.00003604}, {294,0.00007207}, {295,0.00003604}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00010811}, {300,0.00000000}, {301,0.00003604}, {302,0.00014414}, {303,0.00000000}, {304,0.00003604}, {305,0.00000000}, {306,0.00002703}, {307,0.00007207}, {308,0.00000000}, {309,0.00003604}, {310,0.00007207}, {311,0.00007207}, {312,0.00009910}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00003604}, {317,0.00007207}, {318,0.00007207}, {319,0.00003604}, {320,0.00000000}, {321,0.00000000}, {322,0.00003604}, {323,0.00003604}, {324,0.00003604}, {325,0.00000000}, {326,0.00003604}, {327,0.00003604}, {328,0.00000000}, {329,0.00003604}, {330,0.00000000}, {331,0.00003604}, {332,0.00000000}, {333,0.00003604}, {334,0.00006306}, {335,0.00003604}, {336,0.00014414}, {337,0.00000000}, {338,0.00003604}, {339,0.00002703}, {340,0.00003604}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00003604}, {347,0.00000000}, {348,0.00000000}, {349,0.00010811}, {350,0.00000000}, {351,0.00003604}, {352,0.00000000}, {353,0.00000000}, {354,0.00003604}, {355,0.00006306}, {356,0.00003604}, {357,0.00000000}, {358,0.00000000}, {359,0.00003604}, {360,0.00003604}, {361,0.00006306}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00003604}, {366,0.00003604}, {367,0.00003604}, {368,0.00003604}, {369,0.00000000}, {370,0.00003604}, {371,0.00007207}, {372,0.00000000}, {373,0.00017117}, {374,0.00003604}, {375,0.00002703}, {376,0.00000000}, {377,0.00000000}, {378,0.00003604}, {379,0.00010811}, {380,0.00007207}, {381,0.00003604}, {382,0.00003604}, {383,0.00000000}, {384,0.00003604}, {385,0.00000000}, {386,0.00000000}, {387,0.00003604}, {388,0.00000000}, {389,0.00002703}, {390,0.00007207}, {391,0.00003604}, {392,0.00003604}, {393,0.00000000}, {394,0.00003604}, {395,0.00007207}, {396,0.00003604}, {397,0.00000000}, {398,0.00000000}, {399,0.00003604}, {400,0.00003604}, {401,0.00002703}, {402,0.00000000}, {403,0.00003604}, {404,0.00000000}, {405,0.00003604}, {406,0.00003604}, {407,0.00003604}, {408,0.00007207}, {409,0.00003604}, {410,0.00003604}, {411,0.00006306}, {412,0.00014414}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00007273}, {417,0.00010000}, {418,0.00007273}, {419,0.00000000}, {420,0.00002727}, {421,0.00000000}, {422,0.00002727}, {423,0.00014545}, {424,0.00003636}, {425,0.00000000}, {426,0.00007273}, {427,0.00000000}, {428,0.00007273}, {429,0.00003636}, {430,0.00000000}, {431,0.00003636}, {432,0.00000000}, {433,0.00000000}, {434,0.00007273}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00003636}, {439,0.00010909}, {440,0.00003636}, {441,0.00003636}, {442,0.00000000}, {443,0.00003636}, {444,0.00003636}, {445,0.00000000}, {446,0.00003636}, {447,0.00007273}, {448,0.00000000}, {449,0.00000000}, {450,0.00003636}, {451,0.00000000}, {452,0.00002727}, {453,0.00003636}, {454,0.00003636}, {455,0.00007273}, {456,0.00007273}, {457,0.00000000}, {458,0.00016364}, {459,0.00003636}, {460,0.00003636}, {461,0.00000000}, {462,0.00000000}, {463,0.00007273}, {464,0.00003636}, {465,0.00000000}, {466,0.00000000}, {467,0.00003636}, {468,0.00007273}, {469,0.00007273}, {470,0.00003636}, {471,0.00000000}, {472,0.00007273}, {473,0.00003636}, {474,0.00000000}, {475,0.00003636}, {476,0.00003636}, {477,0.00010909}, {478,0.00003636}, {479,0.00003636}, {480,0.00014545}, {481,0.00003636}, {482,0.00003636}, {483,0.00006364}, {484,0.00000000}, {485,0.00000000}, {486,0.00003636}, {487,0.00003636}, {488,0.00003636}, {489,0.00000000}, {490,0.00003636}, {491,0.00007273}, {492,0.00003636}, {493,0.00007273}, {494,0.00007273}, {495,0.00003636}, {496,0.00000000}, {497,0.00007273}, {498,0.00010000}, {499,0.00003636}, {500,0.00000000}, {505,0.00000000}, {510,0.00003636}, {515,0.00000000}, {520,0.00010909}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00003636}, {550,0.00007273}, {555,0.00013636}, {560,0.00010909}, {565,0.00000000}, {570,0.00003636}, {575,0.00000000}, {580,0.00000000}, {585,0.00003636}, {590,0.00003636}, {595,0.00000000}, {600,0.00014545}, {605,0.00007273}, {610,0.00000000}, {615,0.00003636}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00003636}, {640,0.00007273}, {645,0.00000000}, {650,0.00003636}, {655,0.00000000}, {660,0.00003636}, {665,0.00000000}, {670,0.00003636}, {675,0.00000000}, {680,0.00000000}, {685,0.00013636}, {690,0.00000000}, {695,0.00003636}, {700,0.00003636}, {705,0.00007273}, {710,0.00003636}, {715,0.00000000}, {720,0.00000000}, {725,0.00006364}, {730,0.00000000}, {735,0.00000000}, {740,0.00003636}, {745,0.00007273}, {750,0.00006364}, {755,0.00000000}, {760,0.00003636}, {765,0.00003636}, {770,0.00007273}, {775,0.00000000}, {780,0.00000000}, {785,0.00002727}, {790,0.00003636}, {795,0.00000000}, {800,0.00007273}, {805,0.00014545}, {810,0.00003636}, {815,0.00000000}, {820,0.00021818}, {825,0.00010909}, {830,0.00003636}, {835,0.00006364}, {840,0.00003636}, {845,0.00007273}, {850,0.00000000}, {855,0.00002727}, {860,0.00010909}, {865,0.00002727}, {870,0.00000000}, {875,0.00003636}, {880,0.00007273}, {885,0.00018182}, {890,0.00003636}, {895,0.00000000}, {900,0.00010000}, {905,0.00003636}, {910,0.00006364}, {915,0.00000000}, {920,0.00000000}, {925,0.00025455}, {930,0.00003636}, {935,0.00010909}, {940,0.00003636}, {945,0.00006364}, {950,0.00006364}, {955,0.00000000}, {960,0.00007273}, {965,0.00000000}, {970,0.00007273}, {975,0.00009091}, {980,0.00003636}, {985,0.00000000}, {990,0.00000000}, {995,0.00017273}, {1000,0.00007273}, {1010,0.00000000}, {1020,0.00003636}, {1030,0.00014545}, {1040,0.00000000}, {1050,0.00002727}, {1060,0.00000000}, {1070,0.00003636}, {1080,0.00003636}, {1090,0.00003636}, {1100,0.00021818}, {1110,0.00007273}, {1120,0.00003636}, {1130,0.00000000}, {1140,0.00012727}, {1150,0.00000000}, {1160,0.00013636}, {1170,0.00000000}, {1180,0.00003636}, {1190,0.00000000}, {1200,0.00006364}, {1210,0.00007273}, {1220,0.00003636}, {1230,0.00010909}, {1240,0.00003636}, {1250,0.00014545}, {1260,0.00000000}, {1270,0.00012727}, {1280,0.00000000}, {1290,0.00022727}, {1300,0.00000000}, {1310,0.00007273}, {1320,0.00010000}, {1330,0.00002727}, {1340,0.00010000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00020909}, {1380,0.00003636}, {1390,0.00040000}, {1400,0.00003636}, {1410,0.00014545}, {1420,0.00010000}, {1430,0.00003636}, {1440,0.00027273}, {1450,0.00029091}, {1460,0.00007273}, {1470,0.00028182}, {1480,0.00003636}, {1490,0.00007273}, {1500,0.00010000}, {1510,0.00006364}, {1520,0.00000000}, {1530,0.00018182}, {1540,0.00007273}, {1550,0.00000000}, {1560,0.00029091}, {1570,0.00025455}, {1580,0.00005455}, {1590,0.00025455}, {1600,0.00003636}, {1610,0.00007273}, {1620,0.00007273}, {1630,0.00026364}, {1640,0.00000000}, {1650,0.00007273}, {1660,0.00028182}, {1670,0.00018182}, {1680,0.00000000}, {1690,0.00010000}, {1700,0.00031818}, {1710,0.00010909}, {1720,0.00002727}, {1730,0.00003636}, {1740,0.00029091}, {1750,0.00205455}, {1760,0.00014545}, {1770,0.00007273}, {1780,0.00016364}, {1790,0.00021818}, {1800,0.00050000}, {1810,0.00000000}, {1820,0.00014545}, {1830,0.00032727}, {1840,0.00013636}, {1850,0.00024545}, {1860,0.00010909}, {1870,0.00017273}, {1880,0.00014545}, {1890,0.00017273}, {1900,0.00003636}, {1910,0.00050000}, {1920,0.00007273}, {1930,0.00003636}, {1940,0.00018182}, {1950,0.00013636}, {1960,0.00014545}, {1970,0.00021818}, {1980,0.00039091}, {1990,0.00010000}, {2000,0.00005455}, {2050,0.00003636}, {2100,0.00018182}, {2150,0.00018182}, {2200,0.00021818}, {2250,0.00029091}, {2300,0.00020909}, {2350,0.00028182}, {2400,0.00025455}, {2450,0.00027273}, {2500,0.00029091}, {2550,0.00010000}, {2600,0.00000000}, {2650,0.00055455}, {2700,0.00047273}, {2750,0.00024545}, {2800,0.00029091}, {2850,0.00007273}, {2900,0.00014545}, {2950,0.00060909}, {3000,0.00036364}, {3050,0.00058182}, {3100,0.00036364}, {3150,0.00043636}, {3200,0.00036364}, {3250,0.00014545}, {3300,0.00071818}, {3350,0.00052727}, {3400,0.00071818}, {3450,0.00020909}, {3500,0.00074545}, {3550,0.00037273}, {3600,0.00052727}, {3650,0.00063636}, {3700,0.00010000}, {3750,0.00040000}, {3800,0.00045455}, {3850,0.00010000}, {3900,0.00036364}, {3950,0.00064545}, {4000,0.00032727}, {4050,0.00042727}, {4100,0.00082727}, {4150,0.00045455}, {4200,0.00050909}, {4250,0.00031818}, {4300,0.00020909}, {4350,0.00040909}, {4400,0.00120909}, {4450,0.00092727}, {4500,0.00093636}, {4550,0.00084545}, {4600,0.00082727}, {4650,0.00083636}, {4700,0.00081818}, {4750,0.00085455}, {4800,0.00062727}, {4850,0.00093636}, {4900,0.00032727}, {4950,0.00067273}, {5000,0.00040000}, {5050,0.00103636}, {5100,0.00065455}, {5150,0.00106364}, {5200,0.00034545}, {5250,0.00135455}, {5300,0.00061818}, {5350,0.00100000}, {5400,0.00072727}, {5450,0.00032727}, {5500,0.00028182}, {5550,0.00038182}, {5600,0.00010909}, {5650,0.00000000}, {5700,0.00010909}, {5750,0.00010909}, {5800,0.00007273}, {5850,0.00018182}, {5900,0.00003636}, {5950,0.00000000}, {6000,0.00003636}, {6050,0.00010909}, {6100,0.00093636}, {6150,0.00056364}, {6200,0.00039091}, {6250,0.00081818}, {6300,0.00123636}, {6350,0.00028182}, {6400,0.00071818}, {6450,0.00083636}, {6500,0.00126364}, {6550,0.00082727}, {6600,0.00086364}, {6650,0.00051818}, {6700,0.00031818}, {6750,0.00081818}, {6800,0.00054545}, {6850,0.00050909}, {6900,0.00047273}, {6950,0.00045455}, {7000,0.00049091}, {7050,0.00042727}, {7100,0.00069091}, {7150,0.00043636}, {7200,0.00061818}, {7250,0.00150909}, {7300,0.00124545}, {7350,0.00090000}, {7400,0.00072727}, {7450,0.00042727}, {7500,0.00042727}, {7550,0.00010909}, {7600,0.00007273}, {7650,0.00022727}, {7700,0.00010000}, {7750,0.00007273}, {7800,0.00010909}, {7850,0.00017273}, {7900,0.00025455}, {7950,0.00010000}, {8000,0.00006364}, {8050,0.00003636}, {8100,0.00003636}, {8150,0.00010909}, {8200,0.00007273}, {8250,0.00003636}, {8300,0.00014545}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00010909}, {8500,0.00000000}, {8550,0.00003636}, {8600,0.00007273}, {8650,0.00014545}, {8700,0.00007273}, {8750,0.00010909}, {8800,0.00000000}, {8850,0.00010909}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00013636}, {9050,0.00003636}, {9100,0.00003636}, {9150,0.00014545}, {9200,0.00013636}, {9250,0.00003636}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00014545}, {9450,0.00007273}, {9500,0.00010909}, {9550,0.00003636}, {9600,0.00007273}, {9650,0.00007273}, {9700,0.00010909}, {9750,0.00003636}, {9800,0.00010000}, {9850,0.00010000}, {9900,0.00007273}, {9950,0.00006364}, {10000,0.00017273}, {10100,0.00003636}, {10200,0.00010909}, {10300,0.00010000}, {10400,0.00014545}, {10500,0.00000000}, {10600,0.00003636}, {10700,0.00010909}, {10800,0.00003636}, {10900,0.00007273}, {11000,0.00003636}, {11100,0.00010909}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00003636}, {11500,0.00013636}, {11600,0.00003636}, {11700,0.00197273}, {11800,0.00170000}, {11900,0.00106364}, {12000,0.00072727}, {12100,0.00060909}, {12200,0.00170000}, {12300,0.00076364}, {12400,0.00062727}, {12500,0.00014545}, {12600,0.00014545}, {12700,0.00025455}, {12800,0.00007273}, {12900,0.00000000}, {13000,0.00007273}, {13100,0.00003636}, {13200,0.00054545}, {13300,0.00138182}, {13400,0.00049091}, {13500,0.00032727}, {13600,0.00060909}, {13700,0.00050000}, {13800,0.00053636}, {13900,0.00040000}, {14000,0.00010909}, {14100,0.00018182}, {14200,0.00021818}, {14300,0.00143636}, {14400,0.00010909}, {14500,0.00014545}, {14600,0.00018182}, {14700,0.00013636}, {14800,0.00028182}, {14900,0.00029091}, {15000,0.00003636}, {15100,0.00010909}, {15200,0.00010909}, {15300,0.00007273}, {15400,0.00025455}, {15500,0.00003636}, {15600,0.00000000}, {15700,0.00003636}, {15800,0.00000000}, {15900,0.00010909}, {16000,0.00000000}, {16100,0.00018182}, {16200,0.00000000}, {16300,0.00035455}, {16400,0.00010909}, {16500,0.00007273}, {16600,0.00007273}, {16700,0.00014545}, {16800,0.00014545}, {16900,0.00000000}, {17000,0.00003636}, {17100,0.00003636}, {17200,0.00007273}, {17300,0.00007273}, {17400,0.00040000}, {17500,0.00010909}, {17600,0.00029091}, {17700,0.00020909}, {17800,0.00000000}, {17900,0.00007273}, {18000,0.00014545}, {18100,0.00020909}, {18200,0.00021818}, {18300,0.00007273}, {18400,0.00010909}, {18500,0.00000000}, {18600,0.00021818}, {18700,0.00003636}, {18800,0.00014545}, {18900,0.00017273}, {19000,0.00007273}, {19100,0.00003636}, {19200,0.00003636}, {19300,0.00007273}, {19400,0.00014545}, {19500,0.00014545}, {19600,0.00006364}, {19700,0.00007273}, {19800,0.00010909}, {19900,0.00000000}, {20000,0.00007407}};
data["big_flat"]["TypeClasses"]["Aggregate"]["real"] = {{1,0.001000000}, {2,0.001000000}, {3,0.001000000}, {4,0.001039823}, {5,0.002000000}, {6,0.002000000}, {7,0.002004425}, {8,0.002212389}, {9,0.003000000}, {10,0.003000000}, {11,0.003101770}, {12,0.003579646}, {13,0.004000000}, {14,0.004026549}, {15,0.004646018}, {16,0.004672566}, {17,0.005008850}, {18,0.005106195}, {19,0.005783186}, {20,0.005849558}, {21,0.006115044}, {22,0.013455752}, {23,0.007115044}, {24,0.006982301}, {25,0.007442478}, {26,0.007752212}, {27,0.008738938}, {28,0.008066372}, {29,0.008871681}, {30,0.009061947}, {31,0.009685841}, {32,0.009185841}, {33,0.009920354}, {34,0.010172566}, {35,0.011557522}, {36,0.010668142}, {37,0.011407080}, {38,0.011654867}, {39,0.012402655}, {40,0.011690265}, {41,0.013000000}, {42,0.012730088}, {43,0.013646018}, {44,0.014110619}, {45,0.014212389}, {46,0.015283186}, {47,0.015252212}, {48,0.014053097}, {49,0.014933628}, {50,0.015203540}, {51,0.016672566}, {52,0.016261062}, {53,0.016676991}, {54,0.016884956}, {55,0.017969027}, {56,0.016712389}, {57,0.017805310}, {58,0.019176991}, {59,0.019115044}, {60,0.018641593}, {61,0.019814159}, {62,0.019889381}, {63,0.020960177}, {64,0.020783186}, {65,0.020203540}, {66,0.020628319}, {67,0.022672566}, {68,0.020964602}, {69,0.022221239}, {70,0.022548673}, {71,0.023690265}, {72,0.022159292}, {73,0.023389381}, {74,0.025469027}, {75,0.024831858}, {76,0.023977876}, {77,0.026871681}, {78,0.025707965}, {79,0.028522124}, {80,0.025221239}, {81,0.025849558}, {82,0.025991150}, {83,0.029694690}, {84,0.026685841}, {85,0.028057522}, {86,0.028190265}, {87,0.031234513}, {88,0.028845133}, {89,0.029269912}, {90,0.029615044}, {91,0.033181416}, {92,0.030008850}, {93,0.033283186}, {94,0.031849558}, {95,0.035115044}, {96,0.029840708}, {97,0.031061947}, {98,0.032367257}, {99,0.033637168}, {100,0.031853982}, {101,0.033646018}, {102,0.035738938}, {103,0.036619469}, {104,0.032955752}, {105,0.038787611}, {106,0.034977876}, {107,0.038066372}, {108,0.035769912}, {109,0.037469027}, {110,0.037508850}, {111,0.040769912}, {112,0.035380531}, {113,0.037469027}, {114,0.037433628}, {115,0.039969027}, {116,0.038327434}, {117,0.040030973}, {118,0.041278761}, {119,0.042557522}, {120,0.040672566}, {121,0.043000000}, {122,0.041584071}, {123,0.047986726}, {124,0.042039823}, {125,0.046438053}, {126,0.045513274}, {127,0.046893805}, {128,0.042323009}, {129,0.042615044}, {130,0.044053097}, {131,0.047659292}, {132,0.044367257}, {133,0.045641593}, {134,0.047300885}, {135,0.047929204}, {136,0.048252212}, {137,0.048982301}, {138,0.046849558}, {139,0.051199115}, {140,0.047362832}, {141,0.053150442}, {142,0.051995575}, {143,0.055190265}, {144,0.046681416}, {145,0.051141593}, {146,0.050376106}, {147,0.053575221}, {148,0.053132743}, {149,0.052433628}, {150,0.059889381}, {151,0.058123894}, {152,0.053668142}, {153,0.054951327}, {154,0.060960177}, {155,0.056500000}, {156,0.058849558}, {157,0.059938053}, {158,0.060048673}, {159,0.059623894}, {160,0.053628319}, {161,0.056685841}, {162,0.054681416}, {163,0.060305310}, {164,0.058216814}, {165,0.060398230}, {166,0.058451327}, {167,0.065216814}, {168,0.059199115}, {169,0.060969027}, {170,0.059345133}, {171,0.065871681}, {172,0.066650442}, {173,0.062876106}, {174,0.065672566}, {175,0.066738938}, {176,0.063044248}, {177,0.064424779}, {178,0.065849558}, {179,0.064809735}, {180,0.065809735}, {181,0.069756637}, {182,0.069278761}, {183,0.075053097}, {184,0.063508850}, {185,0.067951327}, {186,0.067491150}, {187,0.075504425}, {188,0.073190265}, {189,0.073411504}, {190,0.076141593}, {191,0.074079646}, {192,0.064327434}, {193,0.068752212}, {194,0.067814159}, {195,0.075955752}, {196,0.068787611}, {197,0.074088496}, {198,0.069902655}, {199,0.074557522}, {200,0.072168142}, {201,0.071982301}, {202,0.077778761}, {203,0.082146018}, {204,0.076110619}, {205,0.082579646}, {206,0.078964602}, {207,0.082553097}, {208,0.080256637}, {209,0.073500000}, {210,0.075407080}, {211,0.081535398}, {212,0.074659292}, {213,0.080566372}, {214,0.082172566}, {215,0.082159292}, {216,0.077287611}, {217,0.082787611}, {218,0.079300885}, {219,0.084818584}, {220,0.086057522}, {221,0.087526549}, {222,0.084053097}, {223,0.090044248}, {224,0.079106195}, {225,0.079314159}, {226,0.081460177}, {227,0.086451327}, {228,0.080061947}, {229,0.084079646}, {230,0.092561947}, {231,0.094389381}, {232,0.084469027}, {233,0.089915929}, {234,0.096318584}, {235,0.097876106}, {236,0.089261062}, {237,0.094460177}, {238,0.096915929}, {239,0.097101770}, {240,0.083371681}, {241,0.089088496}, {242,0.098225664}, {243,0.098566372}, {244,0.094429204}, {245,0.096721239}, {246,0.097070796}, {247,0.101703540}, {248,0.092628319}, {249,0.097309735}, {250,0.097849558}, {251,0.104110619}, {252,0.101398230}, {253,0.101823009}, {254,0.106592920}, {255,0.113654867}, {256,0.089092920}, {257,0.094858407}, {258,0.099199115}, {259,0.097933628}, {260,0.095694690}, {261,0.099163717}, {262,0.106234513}, {263,0.108092920}, {264,0.095252212}, {265,0.104008850}, {266,0.100119469}, {267,0.108084071}, {268,0.103982301}, {269,0.107858407}, {270,0.109066372}, {271,0.116203540}, {272,0.101530973}, {273,0.098942478}, {274,0.104606195}, {275,0.114469027}, {276,0.107743363}, {277,0.107176991}, {278,0.113774336}, {279,0.120889381}, {280,0.107685841}, {281,0.110659292}, {282,0.114991150}, {283,0.113464602}, {284,0.116190265}, {285,0.121845133}, {286,0.116491150}, {287,0.125292035}, {288,0.109163717}, {289,0.113061947}, {290,0.112491150}, {291,0.119561947}, {292,0.111615044}, {293,0.119535398}, {294,0.120663717}, {295,0.119163717}, {296,0.109743363}, {297,0.116030973}, {298,0.119194690}, {299,0.125938053}, {300,0.116252212}, {301,0.125858407}, {302,0.123455752}, {303,0.128150442}, {304,0.115761062}, {305,0.122610619}, {306,0.124637168}, {307,0.123889381}, {308,0.122371681}, {309,0.127340708}, {310,0.128168142}, {311,0.131477876}, {312,0.122508850}, {313,0.127309735}, {314,0.128088496}, {315,0.137800885}, {316,0.131092920}, {317,0.134690265}, {318,0.135035398}, {319,0.189075221}, {320,0.125898230}, {321,0.119663717}, {322,0.127212389}, {323,0.130566372}, {324,0.126384956}, {325,0.129150442}, {326,0.138008850}, {327,0.138420354}, {328,0.136128319}, {329,0.131853982}, {330,0.132141593}, {331,0.135619469}, {332,0.133738938}, {333,0.136946903}, {334,0.142066372}, {335,0.144402655}, {336,0.128292035}, {337,0.136694690}, {338,0.133553097}, {339,0.147482301}, {340,0.136796460}, {341,0.141292035}, {342,0.140154867}, {343,0.151889381}, {344,0.137761062}, {345,0.142460177}, {346,0.139823009}, {347,0.150703540}, {348,0.142137168}, {349,0.587858407}, {350,0.151787611}, {351,0.164907080}, {352,0.139960177}, {353,0.141402655}, {354,0.140185841}, {355,0.147110619}, {356,0.144650442}, {357,0.148066372}, {358,0.149115044}, {359,0.154548673}, {360,0.145358407}, {361,0.152411504}, {362,0.148504425}, {363,0.157433628}, {364,0.152676991}, {365,0.153690265}, {366,0.160880531}, {367,0.163464602}, {368,0.151619469}, {369,0.150597345}, {370,0.156902655}, {371,0.157752212}, {372,0.159712389}, {373,0.157871681}, {374,0.161199115}, {375,0.167420354}, {376,0.156539823}, {377,0.160730088}, {378,0.163508850}, {379,0.175566372}, {380,0.159252212}, {381,0.170123894}, {382,0.171606195}, {383,0.176938053}, {384,0.146876106}, {385,0.152738938}, {386,0.156035398}, {387,0.159057522}, {388,0.151168142}, {389,0.160486726}, {390,0.160407080}, {391,0.165442478}, {392,0.155221239}, {393,0.162287611}, {394,0.163884956}, {395,0.168053097}, {396,0.165141593}, {397,0.165840708}, {398,0.169088496}, {399,0.174274336}, {400,0.153362832}, {401,0.165716814}, {402,0.164761062}, {403,0.170084071}, {404,0.168026549}, {405,0.814823009}, {406,0.185460177}, {407,0.186557522}, {408,0.165818584}, {409,0.170345133}, {410,0.171389381}, {411,0.178101770}, {412,0.173827434}, {413,0.179960177}, {414,0.176716814}, {415,0.196548673}, {416,0.164955752}, {417,0.171557522}, {418,0.165451327}, {419,0.173933628}, {420,0.171929204}, {421,0.181778761}, {422,0.178420354}, {423,0.186553097}, {424,0.169261062}, {425,0.180477876}, {426,0.178734513}, {427,0.185168142}, {428,0.183889381}, {429,0.187907080}, {430,0.194066372}, {431,0.196694690}, {432,0.175818584}, {433,0.180849558}, {434,0.183482301}, {435,0.188424779}, {436,0.183079646}, {437,0.187902655}, {438,0.194252212}, {439,0.197823009}, {440,0.186048673}, {441,0.190672566}, {442,0.191327434}, {443,0.194185841}, {444,0.194557522}, {445,0.201185841}, {446,0.202548673}, {447,0.211553097}, {448,0.174836283}, {449,0.184137168}, {450,0.183969027}, {451,0.188181416}, {452,0.184761062}, {453,0.188982301}, {454,0.200318584}, {455,0.197132743}, {456,0.197676991}, {457,0.190579646}, {458,0.200269912}, {459,0.195933628}, {460,0.191398230}, {461,0.204716814}, {462,0.204703540}, {463,0.219380531}, {464,0.181159292}, {465,0.202044248}, {466,0.194146018}, {467,0.207247788}, {468,0.198606195}, {469,0.205128319}, {470,0.208371681}, {471,0.210008850}, {472,0.201783186}, {473,0.210982301}, {474,0.203336283}, {475,0.219924779}, {476,0.211243363}, {477,0.211464602}, {478,0.221676991}, {479,0.223159292}, {480,0.191261062}, {481,0.209606195}, {482,0.200203540}, {483,0.210393805}, {484,0.206181416}, {485,0.210969027}, {486,0.211115044}, {487,0.224367257}, {488,0.200407080}, {489,0.217269912}, {490,0.217132743}, {491,0.216393805}, {492,0.218185841}, {493,0.224247788}, {494,0.226092920}, {495,0.224986726}, {496,0.211579646}, {497,0.211530973}, {498,0.213292035}, {499,0.227619469}, {500,0.222995575}, {505,0.226632743}, {510,0.239203540}, {515,0.218407080}, {520,0.217991150}, {525,0.231398230}, {530,0.218075221}, {535,0.246544248}, {540,0.244079646}, {545,0.238592920}, {550,0.247681416}, {555,0.255022124}, {560,0.238123894}, {565,0.249477876}, {570,0.251654867}, {575,0.280907080}, {580,0.243477876}, {585,0.259176991}, {590,0.270323009}, {595,0.278185841}, {600,0.270070796}, {605,0.288725664}, {610,0.269314159}, {615,0.288172566}, {620,0.278827434}, {625,0.280203540}, {630,0.298592920}, {635,0.312438053}, {640,0.263920354}, {645,0.286030973}, {650,0.287654867}, {655,0.309185841}, {660,0.284044248}, {665,0.307137168}, {670,0.322039823}, {675,0.313561947}, {680,0.305415929}, {685,0.320628319}, {690,0.315075221}, {695,0.341500000}, {700,0.334867257}, {705,0.307008850}, {710,0.319699115}, {715,0.338225664}, {720,0.310477876}, {725,0.344632743}, {730,0.340871681}, {735,0.364588496}, {740,0.334601770}, {745,0.345681416}, {750,0.365849558}, {755,0.363955752}, {760,0.359252212}, {765,0.393933628}, {770,0.336327434}, {775,0.357137168}, {780,0.350398230}, {785,0.352252212}, {790,0.366800885}, {795,0.385491150}, {800,0.350097345}, {805,0.375256637}, {810,0.375792035}, {815,0.401699115}, {820,0.378053097}, {825,0.391327434}, {830,0.416225664}, {835,0.383610619}, {840,0.366163717}, {845,0.406584071}, {850,0.394243363}, {855,0.420668142}, {860,0.404995575}, {865,0.400212389}, {870,0.409681416}, {875,0.432831858}, {880,0.405787611}, {885,0.446849558}, {890,0.443212389}, {895,0.475110619}, {900,0.392880531}, {905,0.418039823}, {910,0.430314159}, {915,0.440774336}, {920,0.427026549}, {925,0.461632743}, {930,0.427269912}, {935,0.472146018}, {940,0.453203540}, {945,0.452491150}, {950,0.467690265}, {955,0.486535398}, {960,0.426185841}, {965,0.462367257}, {970,0.462137168}, {975,0.497323009}, {980,0.471606195}, {985,0.488747788}, {990,0.500088496}, {995,0.495783186}, {1000,0.472827434}, {1010,0.493783186}, {1020,0.507969027}, {1030,0.477340708}, {1040,0.468690265}, {1050,0.510946903}, {1060,0.488420354}, {1070,0.522889381}, {1080,0.507827434}, {1090,0.499420354}, {1100,0.521323009}, {1110,0.546588496}, {1120,0.518566372}, {1130,0.562995575}, {1140,0.555168142}, {1150,0.609380531}, {1160,0.529181416}, {1170,0.551982301}, {1180,0.569942478}, {1190,0.595486726}, {1200,0.568592920}, {1210,0.616327434}, {1220,0.571955752}, {1230,0.618318584}, {1240,0.600225664}, {1250,0.618482301}, {1260,0.634261062}, {1270,0.662137168}, {1280,0.583871681}, {1290,0.610929204}, {1300,0.626787611}, {1310,0.665539823}, {1320,0.626544248}, {1330,0.649420354}, {1340,0.683584071}, {1350,0.663004425}, {1360,0.636535398}, {1370,0.689734513}, {1380,0.674902655}, {1390,0.731526549}, {1400,0.701690265}, {1410,0.664061947}, {1420,0.710376106}, {1430,0.725672566}, {1440,0.676584071}, {1450,0.729508850}, {1460,0.728690265}, {1470,0.781823009}, {1480,0.735986726}, {1490,0.746221239}, {1500,0.772230088}, {1510,0.777278761}, {1520,0.757606195}, {1530,0.811756637}, {1540,0.722411504}, {1550,0.772446903}, {1560,0.748000000}, {1570,0.751867257}, {1580,0.777030973}, {1590,0.813292035}, {1600,0.745734513}, {1610,0.800796460}, {1620,0.805964602}, {1630,0.857707965}, {1640,0.801703540}, {1650,0.834469027}, {1660,0.883168142}, {1670,0.820088496}, {1680,0.796433628}, {1690,0.852495575}, {1700,0.839756637}, {1710,0.899402655}, {1720,0.867004425}, {1730,0.837982301}, {1740,0.879889381}, {1750,0.907539823}, {1760,0.862504425}, {1770,0.928676991}, {1780,0.926977876}, {1790,0.985141593}, {1800,0.849831858}, {1810,0.906238938}, {1820,0.921349558}, {1830,0.921544248}, {1840,0.896823009}, {1850,0.972314159}, {1860,0.913013274}, {1870,0.976203540}, {1880,0.946190265}, {1890,0.953977876}, {1900,0.989845133}, {1910,1.025221239}, {1920,0.900123894}, {1930,0.967110619}, {1940,0.966915929}, {1950,1.046168142}, {1960,0.989022124}, {1970,1.017924779}, {1980,1.062544248}, {1990,1.036526549}, {2000,1.005230088}, {2050,0.967898230}, {2100,1.055340708}, {2150,1.130730088}, {2200,1.129203540}, {2250,1.164654867}, {2300,1.270725664}, {2350,1.270168142}, {2400,1.214849558}, {2450,1.272305310}, {2500,1.297429204}, {2550,1.471535398}, {2600,1.321278761}, {2650,1.423836283}, {2700,1.414380531}, {2750,1.586699115}, {2800,1.494765487}, {2850,1.490663717}, {2900,1.548079646}, {2950,1.590039823}, {3000,1.658278761}, {3050,1.738995575}, {3100,1.692911504}, {3150,1.987553097}, {3200,1.585588496}, {3250,1.754088496}, {3300,1.801871681}, {3350,2.125969027}, {3400,1.797433628}, {3450,1.979769912}, {3500,1.941876106}, {3550,2.113623894}, {3600,1.835287611}, {3650,1.913942478}, {3700,2.056451327}, {3750,2.090269912}, {3800,2.115070796}, {3850,2.062371681}, {3900,2.252977876}, {3950,2.344752212}, {4000,2.134212389}, {4050,2.313362832}, {4100,2.094482301}, {4150,2.336761062}, {4200,2.278889381}, {4250,2.375969027}, {4300,2.418646018}, {4350,2.664287611}, {4400,2.377964602}, {4450,2.496893805}, {4500,2.507123894}, {4550,2.619256637}, {4600,2.711924779}, {4650,2.965495575}, {4700,2.683030973}, {4750,2.719752212}, {4800,2.578004425}, {4850,2.871809735}, {4900,2.710862832}, {4950,2.917716814}, {5000,2.758376106}, {5050,3.060265487}, {5100,3.082659292}, {5150,3.065013274}, {5200,2.808573333}, {5250,2.834466667}, {5300,3.054684444}, {5350,3.270906667}, {5400,3.264791111}, {5450,3.117551111}, {5500,3.350164444}, {5550,3.372262222}, {5600,3.205808889}, {5650,3.132266667}, {5700,3.148800000}, {5750,3.503546667}, {5800,3.300595556}, {5850,3.543311111}, {5900,3.350146667}, {5950,3.726955556}, {6000,3.494493333}, {6050,3.508111}, {6100,3.654111}, {6150,3.322611}, {6200,3.489500}, {6250,3.626167}, {6300,3.611000}, {6350,3.761833}, {6400,3.340056}, {6450,3.658944}, {6500,3.708722}, {6550,4.008833}, {6600,3.749500}, {6650,4.171556}, {6700,3.813222}, {6750,4.108333}, {6800,3.754500}, {6850,3.878722}, {6900,4.187056}, {6950,4.062944}, {7000,4.093111}, {7050,4.325222}, {7100,4.423167}, {7150,4.584500}, {7200,3.814278}, {7250,4.165167}, {7300,4.041056}, {7350,4.464111}, {7400,4.366222}, {7450,4.360667}, {7500,4.426833}, {7550,4.838389}, {7600,4.459333}, {7650,4.579111}, {7700,4.334167}, {7750,4.544722}, {7800,4.676500}, {7850,4.749944}, {7900,4.829056}, {7950,4.786944}, {8000,4.472611}, {8050,4.964056}, {8100,4.779722}, {8150,5.161444}, {8200,4.399000}, {8250,4.914500}, {8300,4.910944}, {8350,5.107611}, {8400,4.771833}, {8450,4.639167}, {8500,4.999444}, {8550,5.175611}, {8600,5.034444}, {8650,5.255222}, {8700,5.584389}, {8750,5.313889}, {8800,4.969944}, {8850,5.226222}, {8900,5.219000}, {8950,5.744611}, {9000,5.260222}, {9050,5.652333}, {9100,5.495500}, {9150,6.071778}, {9200,5.689111}, {9250,5.287667}, {9300,5.446611}, {9350,5.508889}, {9400,5.669500}, {9450,5.890278}, {9500,5.716667}, {9550,5.900056}, {9600,5.411167}, {9650,5.961444}, {9700,6.010333}, {9750,5.841167}, {9800,5.691667}, {9850,6.247222}, {9900,6.081000}, {9950,6.487222}, {10000,5.760444}, {10100,6.400111}, {10200,6.429111}, {10300,6.220278}, {10400,5.894778}, {10500,5.938722}, {10600,6.389056}, {10700,6.579222}, {10800,6.283000}, {10900,6.504611}, {11000,6.959000}, {11100,7.095611}, {11200,6.685222}, {11300,6.558000}, {11400,6.594833}, {11500,7.295333}, {11600,6.921000}, {11700,7.429167}, {11800,7.014889}, {11900,7.741556}, {12000,7.350111}, {12100,7.708722}, {12200,7.643222}, {12300,7.049444}, {12400,7.360500}, {12500,7.609444}, {12600,7.672611}, {12700,7.996833}, {12800,7.075722}, {12900,7.823944}, {13000,7.851333}, {13100,8.486000}, {13200,7.985889}, {13300,8.783444}, {13400,8.110667}, {13500,9.399278}, {13600,8.264167}, {13700,8.260611}, {13800,8.807444}, {13900,8.621389}, {14000,9.357833}, {14100,8.802500}, {14200,9.338167}, {14300,10.004389}, {14400,8.150000}, {14500,8.756222}, {14600,8.492611}, {14700,9.419111}, {14800,9.198167}, {14900,9.198944}, {15000,9.296944}, {15100,10.230778}, {15200,9.339778}, {15300,9.662222}, {15400,9.224611}, {15500,9.577667}, {15600,9.958500}, {15700,9.959278}, {15800,10.482444}, {15900,10.279944}, {16000,9.523278}, {16100,10.521889}, {16200,10.208944}, {16300,10.931667}, {16400,9.378833}, {16500,10.371778}, {16600,10.389000}, {16700,10.755111}, {16800,10.163222}, {16900,10.072278}, {17000,10.775611}, {17100,11.410556}, {17200,10.745611}, {17300,11.489722}, {17400,12.052167}, {17500,11.626222}, {17600,10.828444}, {17700,11.013167}, {17800,11.015444}, {17900,12.113333}, {18000,11.711889}, {18100,12.209833}, {18200,11.782500}, {18300,12.904611}, {18400,12.022333}, {18500,11.305722}, {18600,11.676444}, {18700,11.569333}, {18800,12.330944}, {18900,12.644667}, {19000,12.137222}, {19100,13.153778}, {19200,11.635611}, {19300,12.647111}, {19400,12.855944}, {19500,12.424056}, {19600,12.296722}, {19700,14.073556}, {19800,12.983722}, {19900,14.002611}, {20000,12.458812}};
data["big_flat"]["TypeClasses"]["Aggregate"]["user"] = {{1,0.000610619}, {2,0.001119469}, {3,0.001070796}, {4,0.001623894}, {5,0.001500000}, {6,0.001929204}, {7,0.002415929}, {8,0.002500000}, {9,0.002818584}, {10,0.002889381}, {11,0.003362832}, {12,0.003433628}, {13,0.004013274}, {14,0.004199115}, {15,0.004367257}, {16,0.004862832}, {17,0.005000000}, {18,0.005389381}, {19,0.005902655}, {20,0.005898230}, {21,0.006610619}, {22,0.013597345}, {23,0.007398230}, {24,0.007137168}, {25,0.007738938}, {26,0.008146018}, {27,0.009057522}, {28,0.008508850}, {29,0.009079646}, {30,0.009283186}, {31,0.009893805}, {32,0.009544248}, {33,0.010283186}, {34,0.010500000}, {35,0.011681416}, {36,0.010579646}, {37,0.011597345}, {38,0.011615044}, {39,0.012442478}, {40,0.011836283}, {41,0.012734513}, {42,0.012929204}, {43,0.013862832}, {44,0.014500000}, {45,0.014314159}, {46,0.015477876}, {47,0.015548673}, {48,0.014274336}, {49,0.015300885}, {50,0.015420354}, {51,0.017216814}, {52,0.016451327}, {53,0.016969027}, {54,0.017048673}, {55,0.018097345}, {56,0.017030973}, {57,0.017783186}, {58,0.019469027}, {59,0.019146018}, {60,0.018672566}, {61,0.019792035}, {62,0.020088496}, {63,0.020951327}, {64,0.020845133}, {65,0.020278761}, {66,0.020641593}, {67,0.022699115}, {68,0.020969027}, {69,0.022500000}, {70,0.022752212}, {71,0.024057522}, {72,0.022340708}, {73,0.023800885}, {74,0.025252212}, {75,0.025084071}, {76,0.024300885}, {77,0.026853982}, {78,0.025929204}, {79,0.028384956}, {80,0.025358407}, {81,0.026123894}, {82,0.025973451}, {83,0.029734513}, {84,0.026694690}, {85,0.028123894}, {86,0.028389381}, {87,0.031376106}, {88,0.028876106}, {89,0.029141593}, {90,0.029606195}, {91,0.033353982}, {92,0.030486726}, {93,0.033522124}, {94,0.032150442}, {95,0.035349558}, {96,0.029977876}, {97,0.031455752}, {98,0.032544248}, {99,0.033650442}, {100,0.032185841}, {101,0.033712389}, {102,0.035964602}, {103,0.036486726}, {104,0.033261062}, {105,0.038853982}, {106,0.034783186}, {107,0.037845133}, {108,0.035849558}, {109,0.037438053}, {110,0.037331858}, {111,0.040734513}, {112,0.035402655}, {113,0.037274336}, {114,0.037628319}, {115,0.039893805}, {116,0.038274336}, {117,0.040084071}, {118,0.041234513}, {119,0.042371681}, {120,0.040495575}, {121,0.042778761}, {122,0.041530973}, {123,0.047960177}, {124,0.041898230}, {125,0.046455752}, {126,0.045796460}, {127,0.047128319}, {128,0.042238938}, {129,0.042676991}, {130,0.044084071}, {131,0.047500000}, {132,0.044517699}, {133,0.045721239}, {134,0.047610619}, {135,0.048323009}, {136,0.048225664}, {137,0.049048673}, {138,0.047300885}, {139,0.050827434}, {140,0.047690265}, {141,0.053176991}, {142,0.051384956}, {143,0.055008850}, {144,0.047252212}, {145,0.050761062}, {146,0.050234513}, {147,0.053261062}, {148,0.052924779}, {149,0.052146018}, {150,0.059592920}, {151,0.058026549}, {152,0.053508850}, {153,0.055000000}, {154,0.061132743}, {155,0.056570796}, {156,0.058765487}, {157,0.059823009}, {158,0.060110619}, {159,0.059818584}, {160,0.053278761}, {161,0.056469027}, {162,0.054584071}, {163,0.060247788}, {164,0.058075221}, {165,0.060411504}, {166,0.058230088}, {167,0.065274336}, {168,0.059115044}, {169,0.061154867}, {170,0.059500000}, {171,0.065734513}, {172,0.066424779}, {173,0.063084071}, {174,0.065473451}, {175,0.066588496}, {176,0.063216814}, {177,0.064482301}, {178,0.065752212}, {179,0.065101770}, {180,0.065601770}, {181,0.069482301}, {182,0.068765487}, {183,0.074862832}, {184,0.063672566}, {185,0.067924779}, {186,0.067137168}, {187,0.075398230}, {188,0.072915929}, {189,0.073504425}, {190,0.076256637}, {191,0.074199115}, {192,0.064539823}, {193,0.068986726}, {194,0.067367257}, {195,0.075969027}, {196,0.068455752}, {197,0.074039823}, {198,0.069738938}, {199,0.074309735}, {200,0.072097345}, {201,0.071486726}, {202,0.077646018}, {203,0.081668142}, {204,0.075915929}, {205,0.082256637}, {206,0.078831858}, {207,0.082384956}, {208,0.079982301}, {209,0.073331858}, {210,0.075238938}, {211,0.081398230}, {212,0.074734513}, {213,0.080482301}, {214,0.082132743}, {215,0.081818584}, {216,0.077442478}, {217,0.082902655}, {218,0.079247788}, {219,0.084610619}, {220,0.085699115}, {221,0.087376106}, {222,0.083752212}, {223,0.090106195}, {224,0.079030973}, {225,0.079455752}, {226,0.081221239}, {227,0.086314159}, {228,0.080075221}, {229,0.083672566}, {230,0.092278761}, {231,0.094442478}, {232,0.084110619}, {233,0.089778761}, {234,0.095451327}, {235,0.097685841}, {236,0.088721239}, {237,0.094482301}, {238,0.096495575}, {239,0.096796460}, {240,0.083101770}, {241,0.089022124}, {242,0.096853982}, {243,0.098212389}, {244,0.093938053}, {245,0.096699115}, {246,0.097154867}, {247,0.101730088}, {248,0.092628319}, {249,0.097185841}, {250,0.097738938}, {251,0.103433628}, {252,0.101420354}, {253,0.101876106}, {254,0.106331858}, {255,0.113101770}, {256,0.088707965}, {257,0.094535398}, {258,0.099088496}, {259,0.097681416}, {260,0.095358407}, {261,0.099141593}, {262,0.105703540}, {263,0.107340708}, {264,0.095053097}, {265,0.103769912}, {266,0.099884956}, {267,0.107491150}, {268,0.103668142}, {269,0.107699115}, {270,0.108756637}, {271,0.115389381}, {272,0.101398230}, {273,0.098845133}, {274,0.104230088}, {275,0.113610619}, {276,0.107079646}, {277,0.106995575}, {278,0.113035398}, {279,0.120305310}, {280,0.107066372}, {281,0.110482301}, {282,0.114951327}, {283,0.112960177}, {284,0.115522124}, {285,0.121066372}, {286,0.116039823}, {287,0.124955752}, {288,0.108783186}, {289,0.112805310}, {290,0.111831858}, {291,0.119168142}, {292,0.110849558}, {293,0.119048673}, {294,0.120168142}, {295,0.119185841}, {296,0.109336283}, {297,0.115287611}, {298,0.118747788}, {299,0.125681416}, {300,0.116128319}, {301,0.125314159}, {302,0.123026549}, {303,0.127800885}, {304,0.115287611}, {305,0.121969027}, {306,0.124092920}, {307,0.123805310}, {308,0.121867257}, {309,0.126845133}, {310,0.127995575}, {311,0.131115044}, {312,0.121924779}, {313,0.127274336}, {314,0.127818584}, {315,0.137376106}, {316,0.131000000}, {317,0.134606195}, {318,0.134712389}, {319,0.188588496}, {320,0.125420354}, {321,0.119305310}, {322,0.127044248}, {323,0.130345133}, {324,0.126451327}, {325,0.129154867}, {326,0.137721239}, {327,0.138092920}, {328,0.136132743}, {329,0.131831858}, {330,0.131893805}, {331,0.135566372}, {332,0.133557522}, {333,0.136672566}, {334,0.141858407}, {335,0.143884956}, {336,0.128150442}, {337,0.136535398}, {338,0.133415929}, {339,0.147026549}, {340,0.136575221}, {341,0.140880531}, {342,0.140203540}, {343,0.151730088}, {344,0.137446903}, {345,0.142026549}, {346,0.139628319}, {347,0.150455752}, {348,0.141951327}, {349,0.585769912}, {350,0.150314159}, {351,0.162061947}, {352,0.138743363}, {353,0.140876106}, {354,0.139902655}, {355,0.146615044}, {356,0.144438053}, {357,0.147398230}, {358,0.148862832}, {359,0.154057522}, {360,0.145221239}, {361,0.152159292}, {362,0.148128319}, {363,0.157274336}, {364,0.152088496}, {365,0.152676991}, {366,0.160380531}, {367,0.161871681}, {368,0.151066372}, {369,0.150269912}, {370,0.156884956}, {371,0.157646018}, {372,0.159407080}, {373,0.157796460}, {374,0.160597345}, {375,0.167238938}, {376,0.156477876}, {377,0.160668142}, {378,0.163376106}, {379,0.175345133}, {380,0.159159292}, {381,0.168371681}, {382,0.171194690}, {383,0.176867257}, {384,0.146827434}, {385,0.152530973}, {386,0.155862832}, {387,0.158743363}, {388,0.150805310}, {389,0.160287611}, {390,0.160185841}, {391,0.165358407}, {392,0.155088496}, {393,0.161933628}, {394,0.163623894}, {395,0.167592920}, {396,0.165004425}, {397,0.165513274}, {398,0.168884956}, {399,0.174013274}, {400,0.153185841}, {401,0.165384956}, {402,0.164460177}, {403,0.169756637}, {404,0.167867257}, {405,0.813676991}, {406,0.184902655}, {407,0.185796460}, {408,0.165420354}, {409,0.170026549}, {410,0.171013274}, {411,0.177548673}, {412,0.173407080}, {413,0.179814159}, {414,0.176345133}, {415,0.196057522}, {416,0.164668142}, {417,0.171269912}, {418,0.165362832}, {419,0.173460177}, {420,0.171646018}, {421,0.181327434}, {422,0.177969027}, {423,0.186252212}, {424,0.169159292}, {425,0.180008850}, {426,0.178553097}, {427,0.184703540}, {428,0.183703540}, {429,0.187805310}, {430,0.193973451}, {431,0.196389381}, {432,0.175185841}, {433,0.180451327}, {434,0.183247788}, {435,0.188101770}, {436,0.182977876}, {437,0.187309735}, {438,0.194110619}, {439,0.197659292}, {440,0.185734513}, {441,0.190336283}, {442,0.191154867}, {443,0.193911504}, {444,0.194473451}, {445,0.201035398}, {446,0.202659292}, {447,0.211123894}, {448,0.174495575}, {449,0.184008850}, {450,0.183938053}, {451,0.188026549}, {452,0.184783186}, {453,0.188814159}, {454,0.200030973}, {455,0.196809735}, {456,0.197548673}, {457,0.190495575}, {458,0.200300885}, {459,0.195663717}, {460,0.191035398}, {461,0.204575221}, {462,0.204588496}, {463,0.219199115}, {464,0.181190265}, {465,0.201730088}, {466,0.194008850}, {467,0.207000000}, {468,0.198296460}, {469,0.205115044}, {470,0.208380531}, {471,0.209703540}, {472,0.201641593}, {473,0.210738938}, {474,0.203123894}, {475,0.219734513}, {476,0.210796460}, {477,0.211221239}, {478,0.221274336}, {479,0.222805310}, {480,0.191026549}, {481,0.209243363}, {482,0.199827434}, {483,0.209597345}, {484,0.205911504}, {485,0.210659292}, {486,0.210601770}, {487,0.223814159}, {488,0.200181416}, {489,0.216871681}, {490,0.216867257}, {491,0.216115044}, {492,0.217681416}, {493,0.223840708}, {494,0.225716814}, {495,0.224216814}, {496,0.211353982}, {497,0.211159292}, {498,0.213017699}, {499,0.227172566}, {500,0.222433628}, {505,0.226207965}, {510,0.238946903}, {515,0.218168142}, {520,0.217681416}, {525,0.230827434}, {530,0.218225664}, {535,0.246362832}, {540,0.243783186}, {545,0.238482301}, {550,0.247283186}, {555,0.254765487}, {560,0.237867257}, {565,0.249181416}, {570,0.251513274}, {575,0.280650442}, {580,0.243199115}, {585,0.259128319}, {590,0.270044248}, {595,0.277818584}, {600,0.269814159}, {605,0.288353982}, {610,0.268606195}, {615,0.288017699}, {620,0.278389381}, {625,0.279889381}, {630,0.298243363}, {635,0.311955752}, {640,0.263685841}, {645,0.285601770}, {650,0.287438053}, {655,0.308805310}, {660,0.283818584}, {665,0.306929204}, {670,0.321814159}, {675,0.313247788}, {680,0.305026549}, {685,0.320146018}, {690,0.314969027}, {695,0.340951327}, {700,0.334442478}, {705,0.306690265}, {710,0.319181416}, {715,0.337707965}, {720,0.310278761}, {725,0.344530973}, {730,0.340384956}, {735,0.364101770}, {740,0.334097345}, {745,0.345261062}, {750,0.365433628}, {755,0.363526549}, {760,0.358792035}, {765,0.393424779}, {770,0.336000000}, {775,0.356769912}, {780,0.349986726}, {785,0.351818584}, {790,0.366137168}, {795,0.385154867}, {800,0.349752212}, {805,0.374769912}, {810,0.375482301}, {815,0.401420354}, {820,0.377628319}, {825,0.390730088}, {830,0.415707965}, {835,0.383269912}, {840,0.365800885}, {845,0.406287611}, {850,0.393880531}, {855,0.420314159}, {860,0.404871681}, {865,0.399876106}, {870,0.409269912}, {875,0.432323009}, {880,0.405376106}, {885,0.446513274}, {890,0.442818584}, {895,0.474849558}, {900,0.392252212}, {905,0.417778761}, {910,0.429955752}, {915,0.440367257}, {920,0.426650442}, {925,0.461296460}, {930,0.426946903}, {935,0.471606195}, {940,0.452769912}, {945,0.452150442}, {950,0.467261062}, {955,0.486176991}, {960,0.425951327}, {965,0.462030973}, {970,0.461508850}, {975,0.496960177}, {980,0.471022124}, {985,0.488212389}, {990,0.499654867}, {995,0.495190265}, {1000,0.472150442}, {1010,0.493367257}, {1020,0.507460177}, {1030,0.476991150}, {1040,0.468207965}, {1050,0.510623894}, {1060,0.487814159}, {1070,0.522393805}, {1080,0.507300885}, {1090,0.499013274}, {1100,0.520592920}, {1110,0.545920354}, {1120,0.518190265}, {1130,0.562402655}, {1140,0.554438053}, {1150,0.608632743}, {1160,0.528570796}, {1170,0.551292035}, {1180,0.569278761}, {1190,0.594818584}, {1200,0.567969027}, {1210,0.615725664}, {1220,0.571464602}, {1230,0.617942478}, {1240,0.599676991}, {1250,0.617845133}, {1260,0.633601770}, {1270,0.661477876}, {1280,0.583296460}, {1290,0.610305310}, {1300,0.626504425}, {1310,0.665026549}, {1320,0.626252212}, {1330,0.648681416}, {1340,0.682632743}, {1350,0.662252212}, {1360,0.635964602}, {1370,0.688907080}, {1380,0.674154867}, {1390,0.729491150}, {1400,0.699362832}, {1410,0.663181416}, {1420,0.709548673}, {1430,0.724955752}, {1440,0.675730088}, {1450,0.728738938}, {1460,0.728115044}, {1470,0.781172566}, {1480,0.735420354}, {1490,0.745517699}, {1500,0.771672566}, {1510,0.776827434}, {1520,0.757013274}, {1530,0.811035398}, {1540,0.721659292}, {1550,0.771929204}, {1560,0.747469027}, {1570,0.751084071}, {1580,0.776548673}, {1590,0.812575221}, {1600,0.745061947}, {1610,0.800022124}, {1620,0.805323009}, {1630,0.856747788}, {1640,0.801154867}, {1650,0.833853982}, {1660,0.882247788}, {1670,0.819168142}, {1680,0.795986726}, {1690,0.851778761}, {1700,0.838982301}, {1710,0.898619469}, {1720,0.866230088}, {1730,0.837305310}, {1740,0.879283186}, {1750,0.906597345}, {1760,0.861929204}, {1770,0.927690265}, {1780,0.926092920}, {1790,0.984106195}, {1800,0.849181416}, {1810,0.905429204}, {1820,0.920460177}, {1830,0.920619469}, {1840,0.895969027}, {1850,0.971469027}, {1860,0.912057522}, {1870,0.975380531}, {1880,0.945367257}, {1890,0.953274336}, {1900,0.988796460}, {1910,1.024278761}, {1920,0.899553097}, {1930,0.966411504}, {1940,0.966057522}, {1950,1.045340708}, {1960,0.988163717}, {1970,1.017234513}, {1980,1.061641593}, {1990,1.035473451}, {2000,1.004486726}, {2050,0.966951327}, {2100,1.054495575}, {2150,1.129659292}, {2200,1.128411504}, {2250,1.163318584}, {2300,1.269579646}, {2350,1.268986726}, {2400,1.213539823}, {2450,1.271305310}, {2500,1.296482301}, {2550,1.470323009}, {2600,1.320053097}, {2650,1.422455752}, {2700,1.413106195}, {2750,1.585146018}, {2800,1.493486726}, {2850,1.488969027}, {2900,1.546314159}, {2950,1.588420354}, {3000,1.656862832}, {3050,1.737225664}, {3100,1.690256637}, {3150,1.985154867}, {3200,1.584199115}, {3250,1.752424779}, {3300,1.799154867}, {3350,2.122712389}, {3400,1.795393805}, {3450,1.977840708}, {3500,1.940039823}, {3550,2.111800885}, {3600,1.833035398}, {3650,1.911128319}, {3700,2.054628319}, {3750,2.087840708}, {3800,2.113451327}, {3850,2.059862832}, {3900,2.250805310}, {3950,2.341668142}, {4000,2.132225664}, {4050,2.311287611}, {4100,2.091853982}, {4150,2.334756637}, {4200,2.276415929}, {4250,2.373778761}, {4300,2.416438053}, {4350,2.661752212}, {4400,2.375995575}, {4450,2.494623894}, {4500,2.504915929}, {4550,2.616234513}, {4600,2.704911504}, {4650,2.962495575}, {4700,2.680738938}, {4750,2.717460177}, {4800,2.575592920}, {4850,2.866008850}, {4900,2.708048673}, {4950,2.915128319}, {5000,2.755703540}, {5050,3.057721239}, {5100,3.079048673}, {5150,3.062575221}, {5200,2.806257778}, {5250,2.831257778}, {5300,3.050555556}, {5350,3.262426667}, {5400,3.261231111}, {5450,3.114782222}, {5500,3.345826667}, {5550,3.366164444}, {5600,3.201955556}, {5650,3.129484444}, {5700,3.146017778}, {5750,3.500737778}, {5800,3.297746667}, {5850,3.540320000}, {5900,3.346888889}, {5950,3.723555556}, {6000,3.491404444}, {6050,3.499056}, {6100,3.633389}, {6150,3.307722}, {6200,3.485222}, {6250,3.618667}, {6300,3.607111}, {6350,3.758222}, {6400,3.336778}, {6450,3.653333}, {6500,3.702278}, {6550,4.002667}, {6600,3.747000}, {6650,4.169000}, {6700,3.809389}, {6750,4.104056}, {6800,3.751111}, {6850,3.876111}, {6900,4.182444}, {6950,4.057111}, {7000,4.088611}, {7050,4.317444}, {7100,4.417500}, {7150,4.579500}, {7200,3.809167}, {7250,4.159333}, {7300,4.032778}, {7350,4.459111}, {7400,4.360778}, {7450,4.355278}, {7500,4.421944}, {7550,4.832222}, {7600,4.454333}, {7650,4.572944}, {7700,4.329056}, {7750,4.540167}, {7800,4.672222}, {7850,4.745111}, {7900,4.823556}, {7950,4.780778}, {8000,4.467611}, {8050,4.958278}, {8100,4.774833}, {8150,5.155222}, {8200,4.393611}, {8250,4.909556}, {8300,4.906056}, {8350,5.101222}, {8400,4.765833}, {8450,4.632667}, {8500,4.992278}, {8550,5.168611}, {8600,5.028111}, {8650,5.247611}, {8700,5.576889}, {8750,5.306667}, {8800,4.962167}, {8850,5.218667}, {8900,5.211000}, {8950,5.736722}, {9000,5.252500}, {9050,5.644667}, {9100,5.488000}, {9150,6.065611}, {9200,5.683500}, {9250,5.281944}, {9300,5.441278}, {9350,5.502722}, {9400,5.663222}, {9450,5.884722}, {9500,5.710000}, {9550,5.893778}, {9600,5.404833}, {9650,5.955000}, {9700,6.004389}, {9750,5.835833}, {9800,5.686556}, {9850,6.240722}, {9900,6.074056}, {9950,6.481167}, {10000,5.753889}, {10100,6.392667}, {10200,6.421444}, {10300,6.213556}, {10400,5.888389}, {10500,5.932222}, {10600,6.383056}, {10700,6.571944}, {10800,6.277500}, {10900,6.497833}, {11000,6.951167}, {11100,7.087722}, {11200,6.679056}, {11300,6.549778}, {11400,6.589611}, {11500,7.289000}, {11600,6.914500}, {11700,7.423111}, {11800,7.009111}, {11900,7.735556}, {12000,7.343556}, {12100,7.699389}, {12200,7.636056}, {12300,7.040944}, {12400,7.351833}, {12500,7.600333}, {12600,7.664278}, {12700,7.988222}, {12800,7.069278}, {12900,7.817222}, {13000,7.843444}, {13100,8.478889}, {13200,7.979000}, {13300,8.776333}, {13400,8.097833}, {13500,9.391556}, {13600,8.256722}, {13700,8.251722}, {13800,8.799389}, {13900,8.605667}, {14000,9.344278}, {14100,8.794667}, {14200,9.328056}, {14300,9.995000}, {14400,8.142833}, {14500,8.748167}, {14600,8.480889}, {14700,9.409000}, {14800,9.189889}, {14900,9.191833}, {15000,9.287500}, {15100,10.215667}, {15200,9.332167}, {15300,9.651611}, {15400,9.211833}, {15500,9.565778}, {15600,9.947056}, {15700,9.944611}, {15800,10.470278}, {15900,10.264944}, {16000,9.510778}, {16100,10.511000}, {16200,10.198222}, {16300,10.920167}, {16400,9.367556}, {16500,10.357222}, {16600,10.375111}, {16700,10.740500}, {16800,10.151278}, {16900,10.060611}, {17000,10.761611}, {17100,11.393722}, {17200,10.732444}, {17300,11.475000}, {17400,12.037278}, {17500,11.607889}, {17600,10.809056}, {17700,10.997833}, {17800,10.999944}, {17900,12.091000}, {18000,11.677722}, {18100,12.191389}, {18200,11.765944}, {18300,12.882333}, {18400,12.003556}, {18500,11.287556}, {18600,11.660111}, {18700,11.552000}, {18800,12.302111}, {18900,12.624444}, {19000,12.118833}, {19100,13.136611}, {19200,11.619389}, {19300,12.627444}, {19400,12.831056}, {19500,12.406111}, {19600,12.277778}, {19700,14.025500}, {19800,12.965500}, {19900,13.981500}, {20000,12.438375}};
data["big_flat"]["TypeClasses"]["Aggregate"]["system"] = {{1,0.000398230}, {2,0.000106195}, {3,0.000048673}, {4,0.000030973}, {5,0.000013274}, {6,0.000053097}, {7,0.000017699}, {8,0.000035398}, {9,0.000048673}, {10,0.000017699}, {11,0.000000000}, {12,0.000017699}, {13,0.000017699}, {14,0.000017699}, {15,0.000048673}, {16,0.000075221}, {17,0.000070796}, {18,0.000030973}, {19,0.000035398}, {20,0.000017699}, {21,0.000000000}, {22,0.000123894}, {23,0.000061947}, {24,0.000026549}, {25,0.000075221}, {26,0.000017699}, {27,0.000066372}, {28,0.000061947}, {29,0.000035398}, {30,0.000048673}, {31,0.000030973}, {32,0.000035398}, {33,0.000013274}, {34,0.000013274}, {35,0.000057522}, {36,0.000044248}, {37,0.000017699}, {38,0.000070796}, {39,0.000079646}, {40,0.000053097}, {41,0.000000000}, {42,0.000053097}, {43,0.000053097}, {44,0.000048673}, {45,0.000066372}, {46,0.000035398}, {47,0.000035398}, {48,0.000030973}, {49,0.000137168}, {50,0.000066372}, {51,0.000079646}, {52,0.000030973}, {53,0.000119469}, {54,0.000030973}, {55,0.000017699}, {56,0.000066372}, {57,0.000048673}, {58,0.000128319}, {59,0.000132743}, {60,0.000053097}, {61,0.000092920}, {62,0.000030973}, {63,0.000030973}, {64,0.000066372}, {65,0.000084071}, {66,0.000017699}, {67,0.000070796}, {68,0.000017699}, {69,0.000035398}, {70,0.000030973}, {71,0.000079646}, {72,0.000053097}, {73,0.000053097}, {74,0.000101770}, {75,0.000035398}, {76,0.000053097}, {77,0.000141593}, {78,0.000137168}, {79,0.000066372}, {80,0.000084071}, {81,0.000000000}, {82,0.000026549}, {83,0.000128319}, {84,0.000035398}, {85,0.000053097}, {86,0.000030973}, {87,0.000101770}, {88,0.000061947}, {89,0.000035398}, {90,0.000053097}, {91,0.000106195}, {92,0.000017699}, {93,0.000066372}, {94,0.000017699}, {95,0.000132743}, {96,0.000035398}, {97,0.000088496}, {98,0.000110619}, {99,0.000101770}, {100,0.000030973}, {101,0.000053097}, {102,0.000137168}, {103,0.000092920}, {104,0.000115044}, {105,0.000084071}, {106,0.000048673}, {107,0.000070796}, {108,0.000017699}, {109,0.000079646}, {110,0.000017699}, {111,0.000088496}, {112,0.000017699}, {113,0.000053097}, {114,0.000048673}, {115,0.000079646}, {116,0.000035398}, {117,0.000066372}, {118,0.000061947}, {119,0.000039823}, {120,0.000066372}, {121,0.000199115}, {122,0.000030973}, {123,0.000194690}, {124,0.000066372}, {125,0.000084071}, {126,0.000053097}, {127,0.000070796}, {128,0.000066372}, {129,0.000048673}, {130,0.000092920}, {131,0.000097345}, {132,0.000070796}, {133,0.000017699}, {134,0.000017699}, {135,0.000017699}, {136,0.000159292}, {137,0.000070796}, {138,0.000070796}, {139,0.000119469}, {140,0.000030973}, {141,0.000128319}, {142,0.000168142}, {143,0.000119469}, {144,0.000017699}, {145,0.000088496}, {146,0.000141593}, {147,0.000115044}, {148,0.000137168}, {149,0.000066372}, {150,0.000230088}, {151,0.000123894}, {152,0.000088496}, {153,0.000035398}, {154,0.000243363}, {155,0.000061947}, {156,0.000154867}, {157,0.000115044}, {158,0.000066372}, {159,0.000000000}, {160,0.000106195}, {161,0.000123894}, {162,0.000017699}, {163,0.000176991}, {164,0.000150442}, {165,0.000035398}, {166,0.000097345}, {167,0.000141593}, {168,0.000106195}, {169,0.000115044}, {170,0.000048673}, {171,0.000132743}, {172,0.000207965}, {173,0.000070796}, {174,0.000132743}, {175,0.000044248}, {176,0.000261062}, {177,0.000150442}, {178,0.000101770}, {179,0.000053097}, {180,0.000079646}, {181,0.000185841}, {182,0.000216814}, {183,0.000340708}, {184,0.000000000}, {185,0.000066372}, {186,0.000115044}, {187,0.000172566}, {188,0.000212389}, {189,0.000053097}, {190,0.000216814}, {191,0.000106195}, {192,0.000035398}, {193,0.000168142}, {194,0.000128319}, {195,0.000199115}, {196,0.000141593}, {197,0.000119469}, {198,0.000030973}, {199,0.000079646}, {200,0.000154867}, {201,0.000150442}, {202,0.000265487}, {203,0.000207965}, {204,0.000194690}, {205,0.000252212}, {206,0.000176991}, {207,0.000150442}, {208,0.000221239}, {209,0.000088496}, {210,0.000084071}, {211,0.000185841}, {212,0.000057522}, {213,0.000154867}, {214,0.000141593}, {215,0.000150442}, {216,0.000088496}, {217,0.000141593}, {218,0.000084071}, {219,0.000097345}, {220,0.000367257}, {221,0.000159292}, {222,0.000057522}, {223,0.000070796}, {224,0.000115044}, {225,0.000035398}, {226,0.000061947}, {227,0.000119469}, {228,0.000053097}, {229,0.000176991}, {230,0.000323009}, {231,0.000119469}, {232,0.000132743}, {233,0.000190265}, {234,0.000800885}, {235,0.000362832}, {236,0.000292035}, {237,0.000274336}, {238,0.000300885}, {239,0.000079646}, {240,0.000048673}, {241,0.000172566}, {242,0.001137168}, {243,0.000216814}, {244,0.000376106}, {245,0.000225664}, {246,0.000159292}, {247,0.000106195}, {248,0.000181416}, {249,0.000243363}, {250,0.000234513}, {251,0.000358407}, {252,0.000207965}, {253,0.000070796}, {254,0.000367257}, {255,0.000491150}, {256,0.000243363}, {257,0.000287611}, {258,0.000243363}, {259,0.000070796}, {260,0.000269912}, {261,0.000168142}, {262,0.000451327}, {263,0.000238938}, {264,0.000190265}, {265,0.000371681}, {266,0.000212389}, {267,0.000340708}, {268,0.000384956}, {269,0.000203540}, {270,0.000230088}, {271,0.000530973}, {272,0.000287611}, {273,0.000128319}, {274,0.000305310}, {275,0.000610619}, {276,0.000402655}, {277,0.000048673}, {278,0.000407080}, {279,0.000146018}, {280,0.000256637}, {281,0.000101770}, {282,0.000194690}, {283,0.000252212}, {284,0.000287611}, {285,0.000522124}, {286,0.000323009}, {287,0.000433628}, {288,0.000349558}, {289,0.000221239}, {290,0.000305310}, {291,0.000464602}, {292,0.000353982}, {293,0.000265487}, {294,0.000535398}, {295,0.000221239}, {296,0.000252212}, {297,0.000438053}, {298,0.000323009}, {299,0.000491150}, {300,0.000101770}, {301,0.000451327}, {302,0.000292035}, {303,0.000376106}, {304,0.000349558}, {305,0.000331858}, {306,0.000592920}, {307,0.000247788}, {308,0.000442478}, {309,0.000353982}, {310,0.000261062}, {311,0.000283186}, {312,0.000398230}, {313,0.000402655}, {314,0.000278761}, {315,0.000256637}, {316,0.000128319}, {317,0.000225664}, {318,0.000141593}, {319,0.000433628}, {320,0.000274336}, {321,0.000137168}, {322,0.000106195}, {323,0.000128319}, {324,0.000216814}, {325,0.000137168}, {326,0.000345133}, {327,0.000190265}, {328,0.000070796}, {329,0.000061947}, {330,0.000053097}, {331,0.000088496}, {332,0.000194690}, {333,0.000154867}, {334,0.000181416}, {335,0.000185841}, {336,0.000079646}, {337,0.000150442}, {338,0.000172566}, {339,0.000265487}, {340,0.000203540}, {341,0.000212389}, {342,0.000221239}, {343,0.000225664}, {344,0.000225664}, {345,0.000163717}, {346,0.000212389}, {347,0.000292035}, {348,0.000123894}, {349,0.001535398}, {350,0.000274336}, {351,0.000269912}, {352,0.000296460}, {353,0.000331858}, {354,0.000221239}, {355,0.000203540}, {356,0.000154867}, {357,0.000212389}, {358,0.000238938}, {359,0.000331858}, {360,0.000168142}, {361,0.000274336}, {362,0.000278761}, {363,0.000243363}, {364,0.000504425}, {365,0.000300885}, {366,0.000451327}, {367,0.000367257}, {368,0.000398230}, {369,0.000261062}, {370,0.000106195}, {371,0.000101770}, {372,0.000154867}, {373,0.000053097}, {374,0.000101770}, {375,0.000048673}, {376,0.000053097}, {377,0.000084071}, {378,0.000088496}, {379,0.000053097}, {380,0.000053097}, {381,0.000048673}, {382,0.000053097}, {383,0.000017699}, {384,0.000053097}, {385,0.000053097}, {386,0.000123894}, {387,0.000115044}, {388,0.000088496}, {389,0.000070796}, {390,0.000053097}, {391,0.000048673}, {392,0.000088496}, {393,0.000066372}, {394,0.000123894}, {395,0.000137168}, {396,0.000053097}, {397,0.000101770}, {398,0.000044248}, {399,0.000084071}, {400,0.000030973}, {401,0.000137168}, {402,0.000106195}, {403,0.000084071}, {404,0.000070796}, {405,0.000986726}, {406,0.000362832}, {407,0.000557522}, {408,0.000190265}, {409,0.000154867}, {410,0.000119469}, {411,0.000115044}, {412,0.000207965}, {413,0.000101770}, {414,0.000128319}, {415,0.000243363}, {416,0.000168142}, {417,0.000115044}, {418,0.000017699}, {419,0.000066372}, {420,0.000053097}, {421,0.000088496}, {422,0.000159292}, {423,0.000079646}, {424,0.000123894}, {425,0.000181416}, {426,0.000101770}, {427,0.000053097}, {428,0.000035398}, {429,0.000115044}, {430,0.000053097}, {431,0.000088496}, {432,0.000146018}, {433,0.000119469}, {434,0.000141593}, {435,0.000053097}, {436,0.000084071}, {437,0.000119469}, {438,0.000132743}, {439,0.000203540}, {440,0.000146018}, {441,0.000048673}, {442,0.000168142}, {443,0.000154867}, {444,0.000119469}, {445,0.000132743}, {446,0.000030973}, {447,0.000066372}, {448,0.000141593}, {449,0.000035398}, {450,0.000053097}, {451,0.000084071}, {452,0.000044248}, {453,0.000101770}, {454,0.000101770}, {455,0.000070796}, {456,0.000097345}, {457,0.000048673}, {458,0.000053097}, {459,0.000066372}, {460,0.000101770}, {461,0.000066372}, {462,0.000053097}, {463,0.000092920}, {464,0.000115044}, {465,0.000154867}, {466,0.000066372}, {467,0.000101770}, {468,0.000106195}, {469,0.000084071}, {470,0.000035398}, {471,0.000048673}, {472,0.000066372}, {473,0.000101770}, {474,0.000123894}, {475,0.000017699}, {476,0.000101770}, {477,0.000048673}, {478,0.000053097}, {479,0.000061947}, {480,0.000053097}, {481,0.000243363}, {482,0.000340708}, {483,0.000433628}, {484,0.000256637}, {485,0.000141593}, {486,0.000225664}, {487,0.000415929}, {488,0.000159292}, {489,0.000265487}, {490,0.000115044}, {491,0.000172566}, {492,0.000225664}, {493,0.000212389}, {494,0.000101770}, {495,0.000119469}, {496,0.000141593}, {497,0.000150442}, {498,0.000106195}, {499,0.000212389}, {500,0.000159292}, {505,0.000207965}, {510,0.000053097}, {515,0.000172566}, {520,0.000132743}, {525,0.000132743}, {530,0.000084071}, {535,0.000070796}, {540,0.000088496}, {545,0.000053097}, {550,0.000088496}, {555,0.000137168}, {560,0.000079646}, {565,0.000070796}, {570,0.000088496}, {575,0.000070796}, {580,0.000053097}, {585,0.000084071}, {590,0.000154867}, {595,0.000190265}, {600,0.000230088}, {605,0.000207965}, {610,0.000384956}, {615,0.000194690}, {620,0.000185841}, {625,0.000141593}, {630,0.000137168}, {635,0.000194690}, {640,0.000172566}, {645,0.000154867}, {650,0.000119469}, {655,0.000123894}, {660,0.000097345}, {665,0.000035398}, {670,0.000030973}, {675,0.000137168}, {680,0.000079646}, {685,0.000053097}, {690,0.000070796}, {695,0.000053097}, {700,0.000097345}, {705,0.000088496}, {710,0.000194690}, {715,0.000066372}, {720,0.000061947}, {725,0.000070796}, {730,0.000194690}, {735,0.000053097}, {740,0.000030973}, {745,0.000053097}, {750,0.000119469}, {755,0.000035398}, {760,0.000035398}, {765,0.000172566}, {770,0.000084071}, {775,0.000070796}, {780,0.000053097}, {785,0.000066372}, {790,0.000088496}, {795,0.000132743}, {800,0.000084071}, {805,0.000123894}, {810,0.000053097}, {815,0.000053097}, {820,0.000088496}, {825,0.000084071}, {830,0.000053097}, {835,0.000070796}, {840,0.000048673}, {845,0.000101770}, {850,0.000146018}, {855,0.000141593}, {860,0.000088496}, {865,0.000132743}, {870,0.000088496}, {875,0.000176991}, {880,0.000123894}, {885,0.000119469}, {890,0.000137168}, {895,0.000123894}, {900,0.000163717}, {905,0.000115044}, {910,0.000079646}, {915,0.000159292}, {920,0.000119469}, {925,0.000115044}, {930,0.000070796}, {935,0.000053097}, {940,0.000088496}, {945,0.000035398}, {950,0.000128319}, {955,0.000084071}, {960,0.000132743}, {965,0.000088496}, {970,0.000132743}, {975,0.000123894}, {980,0.000141593}, {985,0.000123894}, {990,0.000123894}, {995,0.000190265}, {1000,0.000137168}, {1010,0.000084071}, {1020,0.000185841}, {1030,0.000137168}, {1040,0.000106195}, {1050,0.000035398}, {1060,0.000066372}, {1070,0.000132743}, {1080,0.000141593}, {1090,0.000070796}, {1100,0.000194690}, {1110,0.000159292}, {1120,0.000172566}, {1130,0.000035398}, {1140,0.000168142}, {1150,0.000172566}, {1160,0.000061947}, {1170,0.000203540}, {1180,0.000101770}, {1190,0.000088496}, {1200,0.000097345}, {1210,0.000070796}, {1220,0.000159292}, {1230,0.000141593}, {1240,0.000172566}, {1250,0.000194690}, {1260,0.000190265}, {1270,0.000132743}, {1280,0.000088496}, {1290,0.000088496}, {1300,0.000141593}, {1310,0.000101770}, {1320,0.000053097}, {1330,0.000150442}, {1340,0.000234513}, {1350,0.000238938}, {1360,0.000185841}, {1370,0.000199115}, {1380,0.000398230}, {1390,0.001424779}, {1400,0.001659292}, {1410,0.000398230}, {1420,0.000137168}, {1430,0.000066372}, {1440,0.000159292}, {1450,0.000101770}, {1460,0.000088496}, {1470,0.000194690}, {1480,0.000106195}, {1490,0.000030973}, {1500,0.000088496}, {1510,0.000137168}, {1520,0.000141593}, {1530,0.000070796}, {1540,0.000230088}, {1550,0.000066372}, {1560,0.000066372}, {1570,0.000154867}, {1580,0.000035398}, {1590,0.000172566}, {1600,0.000088496}, {1610,0.000097345}, {1620,0.000137168}, {1630,0.000141593}, {1640,0.000088496}, {1650,0.000137168}, {1660,0.000221239}, {1670,0.000238938}, {1680,0.000017699}, {1690,0.000176991}, {1700,0.000176991}, {1710,0.000190265}, {1720,0.000212389}, {1730,0.000172566}, {1740,0.000168142}, {1750,0.000123894}, {1760,0.000154867}, {1770,0.000278761}, {1780,0.000141593}, {1790,0.000154867}, {1800,0.000265487}, {1810,0.000238938}, {1820,0.000292035}, {1830,0.000190265}, {1840,0.000141593}, {1850,0.000176991}, {1860,0.000185841}, {1870,0.000123894}, {1880,0.000088496}, {1890,0.000119469}, {1900,0.000225664}, {1910,0.000225664}, {1920,0.000132743}, {1930,0.000106195}, {1940,0.000154867}, {1950,0.000168142}, {1960,0.000123894}, {1970,0.000150442}, {1980,0.000106195}, {1990,0.000141593}, {2000,0.000119469}, {2050,0.000154867}, {2100,0.000212389}, {2150,0.000261062}, {2200,0.000119469}, {2250,0.000265487}, {2300,0.000168142}, {2350,0.000203540}, {2400,0.000194690}, {2450,0.000101770}, {2500,0.000066372}, {2550,0.000221239}, {2600,0.000172566}, {2650,0.000247788}, {2700,0.000225664}, {2750,0.000181416}, {2800,0.000212389}, {2850,0.000442478}, {2900,0.000566372}, {2950,0.000433628}, {3000,0.000137168}, {3050,0.000570796}, {3100,0.001292035}, {3150,0.000867257}, {3200,0.000119469}, {3250,0.000278761}, {3300,0.001234513}, {3350,0.001796460}, {3400,0.000659292}, {3450,0.000345133}, {3500,0.000283186}, {3550,0.000349558}, {3600,0.000823009}, {3650,0.001252212}, {3700,0.000371681}, {3750,0.000659292}, {3800,0.000225664}, {3850,0.000933628}, {3900,0.000486726}, {3950,0.001407080}, {4000,0.000535398}, {4050,0.000261062}, {4100,0.000969027}, {4150,0.000234513}, {4200,0.000553097}, {4250,0.000340708}, {4300,0.000234513}, {4350,0.000504425}, {4400,0.000309735}, {4450,0.000292035}, {4500,0.000327434}, {4550,0.000924779}, {4600,0.004809735}, {4650,0.000699115}, {4700,0.000380531}, {4750,0.000402655}, {4800,0.000327434}, {4850,0.003615044}, {4900,0.000681416}, {4950,0.000402655}, {5000,0.000278761}, {5050,0.000265487}, {5100,0.001176991}, {5150,0.000300885}, {5200,0.000280000}, {5250,0.000982222}, {5300,0.001200000}, {5350,0.005102222}, {5400,0.000746667}, {5450,0.000351111}, {5500,0.001724444}, {5550,0.003608889}, {5600,0.001320000}, {5650,0.000382222}, {5700,0.000297778}, {5750,0.000288889}, {5800,0.000448889}, {5850,0.000333333}, {5900,0.000604444}, {5950,0.000546667}, {6000,0.000395556}, {6050,0.005222}, {6100,0.016667}, {6150,0.010833}, {6200,0.000611}, {6250,0.004000}, {6300,0.000444}, {6350,0.000222}, {6400,0.000000}, {6450,0.001278}, {6500,0.002556}, {6550,0.002889}, {6600,0.000222}, {6650,0.000222}, {6700,0.001667}, {6750,0.000889}, {6800,0.000222}, {6850,0.000222}, {6900,0.000444}, {6950,0.001222}, {7000,0.000389}, {7050,0.002667}, {7100,0.000222}, {7150,0.000444}, {7200,0.000889}, {7250,0.001333}, {7300,0.003667}, {7350,0.000444}, {7400,0.000667}, {7450,0.000611}, {7500,0.000444}, {7550,0.000667}, {7600,0.000222}, {7650,0.000389}, {7700,0.000444}, {7750,0.000000}, {7800,0.000000}, {7850,0.000444}, {7900,0.000667}, {7950,0.000667}, {8000,0.000889}, {8050,0.000389}, {8100,0.000000}, {8150,0.000444}, {8200,0.000444}, {8250,0.000389}, {8300,0.000000}, {8350,0.001000}, {8400,0.001333}, {8450,0.000611}, {8500,0.000389}, {8550,0.000444}, {8600,0.000222}, {8650,0.000444}, {8700,0.000667}, {8750,0.000444}, {8800,0.000833}, {8850,0.000444}, {8900,0.001333}, {8950,0.000667}, {9000,0.000889}, {9050,0.000444}, {9100,0.000833}, {9150,0.000389}, {9200,0.000667}, {9250,0.000667}, {9300,0.000000}, {9350,0.000444}, {9400,0.000444}, {9450,0.000444}, {9500,0.000667}, {9550,0.000444}, {9600,0.000611}, {9650,0.000444}, {9700,0.000667}, {9750,0.000000}, {9800,0.000222}, {9850,0.000444}, {9900,0.001278}, {9950,0.000222}, {10000,0.000667}, {10100,0.001722}, {10200,0.001333}, {10300,0.000667}, {10400,0.000667}, {10500,0.000444}, {10600,0.000222}, {10700,0.000667}, {10800,0.000000}, {10900,0.000667}, {11000,0.001056}, {11100,0.000611}, {11200,0.000444}, {11300,0.001222}, {11400,0.000444}, {11500,0.000667}, {11600,0.000444}, {11700,0.000389}, {11800,0.000889}, {11900,0.000611}, {12000,0.001111}, {12100,0.001444}, {12200,0.000000}, {12300,0.001778}, {12400,0.001778}, {12500,0.001500}, {12600,0.000889}, {12700,0.000444}, {12800,0.000222}, {12900,0.000444}, {13000,0.001500}, {13100,0.000667}, {13200,0.000667}, {13300,0.000889}, {13400,0.006556}, {13500,0.001111}, {13600,0.000889}, {13700,0.002000}, {13800,0.001944}, {13900,0.008667}, {14000,0.006333}, {14100,0.000833}, {14200,0.003111}, {14300,0.002167}, {14400,0.001111}, {14500,0.001333}, {14600,0.005556}, {14700,0.003500}, {14800,0.001333}, {14900,0.000333}, {15000,0.002389}, {15100,0.006889}, {15200,0.000889}, {15300,0.003500}, {15400,0.004167}, {15500,0.001944}, {15600,0.002000}, {15700,0.004667}, {15800,0.002444}, {15900,0.004722}, {16000,0.003111}, {16100,0.001111}, {16200,0.000222}, {16300,0.000667}, {16400,0.001278}, {16500,0.004667}, {16600,0.003556}, {16700,0.004167}, {16800,0.001944}, {16900,0.001111}, {17000,0.003778}, {17100,0.005000}, {17200,0.002611}, {17300,0.003333}, {17400,0.001111}, {17500,0.005000}, {17600,0.006389}, {17700,0.002389}, {17800,0.002167}, {17900,0.007556}, {18000,0.021222}, {18100,0.003333}, {18200,0.002000}, {18300,0.006833}, {18400,0.004444}, {18500,0.003500}, {18600,0.003000}, {18700,0.002889}, {18800,0.010556}, {18900,0.004611}, {19000,0.003778}, {19100,0.001722}, {19200,0.000667}, {19300,0.000889}, {19400,0.008111}, {19500,0.002111}, {19600,0.003722}, {19700,0.031222}, {19800,0.002444}, {19900,0.003944}, {20000,0.003250}};
data["big_flat"]["TypeClasses"]["actual reif"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000039823}, {5,0.001000000}, {6,0.001000000}, {7,0.001000000}, {8,0.001115044}, {9,0.002000000}, {10,0.002000000}, {11,0.002061947}, {12,0.002225664}, {13,0.003000000}, {14,0.003000000}, {15,0.003256637}, {16,0.003371681}, {17,0.004000000}, {18,0.004022124}, {19,0.004606195}, {20,0.004663717}, {21,0.005017699}, {22,0.012376106}, {23,0.006097345}, {24,0.005699115}, {25,0.006141593}, {26,0.006353982}, {27,0.007561947}, {28,0.007000000}, {29,0.007619469}, {30,0.007769912}, {31,0.008274336}, {32,0.008000000}, {33,0.008619469}, {34,0.008818584}, {35,0.010150442}, {36,0.009225664}, {37,0.010097345}, {38,0.010199115}, {39,0.011079646}, {40,0.010225664}, {41,0.011623894}, {42,0.011283186}, {43,0.012181416}, {44,0.012393805}, {45,0.012676991}, {46,0.013685841}, {47,0.013703540}, {48,0.012628319}, {49,0.013517699}, {50,0.013681416}, {51,0.015349558}, {52,0.015044248}, {53,0.015119469}, {54,0.015491150}, {55,0.016526549}, {56,0.015176991}, {57,0.016221239}, {58,0.017699115}, {59,0.017637168}, {60,0.016858407}, {61,0.018039823}, {62,0.018207965}, {63,0.019446903}, {64,0.019176991}, {65,0.018663717}, {66,0.018845133}, {67,0.020818584}, {68,0.019243363}, {69,0.020610619}, {70,0.020734513}, {71,0.021991150}, {72,0.020522124}, {73,0.021668142}, {74,0.023853982}, {75,0.023199115}, {76,0.022331858}, {77,0.025066372}, {78,0.023845133}, {79,0.026809735}, {80,0.023500000}, {81,0.023960177}, {82,0.024168142}, {83,0.027831858}, {84,0.024774336}, {85,0.026243363}, {86,0.026367257}, {87,0.029371681}, {88,0.026929204}, {89,0.027367257}, {90,0.027699115}, {91,0.031292035}, {92,0.028088496}, {93,0.031331858}, {94,0.029911504}, {95,0.033176991}, {96,0.027588496}, {97,0.029079646}, {98,0.030389381}, {99,0.031199115}, {100,0.029840708}, {101,0.031637168}, {102,0.033730088}, {103,0.034606195}, {104,0.030920354}, {105,0.036765487}, {106,0.032893805}, {107,0.036000000}, {108,0.033716814}, {109,0.035389381}, {110,0.035433628}, {111,0.037491150}, {112,0.033309735}, {113,0.035362832}, {114,0.035345133}, {115,0.037871681}, {116,0.036110619}, {117,0.037853982}, {118,0.038185841}, {119,0.040398230}, {120,0.038464602}, {121,0.040800885}, {122,0.039407080}, {123,0.045783186}, {124,0.039730088}, {125,0.044137168}, {126,0.043309735}, {127,0.044146018}, {128,0.040075221}, {129,0.040376106}, {130,0.040367257}, {131,0.045402655}, {132,0.042017699}, {133,0.043318584}, {134,0.044955752}, {135,0.045597345}, {136,0.046008850}, {137,0.046707965}, {138,0.044495575}, {139,0.048787611}, {140,0.044964602}, {141,0.050783186}, {142,0.049367257}, {143,0.052823009}, {144,0.044256637}, {145,0.048668142}, {146,0.047969027}, {147,0.051146018}, {148,0.050641593}, {149,0.049969027}, {150,0.057464602}, {151,0.055610619}, {152,0.051203540}, {153,0.052442478}, {154,0.058513274}, {155,0.054035398}, {156,0.056327434}, {157,0.057190265}, {158,0.054548673}, {159,0.057123894}, {160,0.051092920}, {161,0.052066372}, {162,0.052097345}, {163,0.057747788}, {164,0.055619469}, {165,0.057787611}, {166,0.055721239}, {167,0.062575221}, {168,0.056495575}, {169,0.058327434}, {170,0.056668142}, {171,0.063203540}, {172,0.063929204}, {173,0.060225664}, {174,0.063026549}, {175,0.063168142}, {176,0.060358407}, {177,0.061623894}, {178,0.063084071}, {179,0.062163717}, {180,0.063079646}, {181,0.066951327}, {182,0.066530973}, {183,0.069716814}, {184,0.060725664}, {185,0.065168142}, {186,0.064654867}, {187,0.072730088}, {188,0.070384956}, {189,0.070535398}, {190,0.073269912}, {191,0.071181416}, {192,0.061469027}, {193,0.062889381}, {194,0.064911504}, {195,0.073053097}, {196,0.065840708}, {197,0.071154867}, {198,0.066933628}, {199,0.071513274}, {200,0.069141593}, {201,0.068991150}, {202,0.074845133}, {203,0.079190265}, {204,0.073088496}, {205,0.079588496}, {206,0.075946903}, {207,0.079544248}, {208,0.077238938}, {209,0.070415929}, {210,0.072389381}, {211,0.078500000}, {212,0.071575221}, {213,0.077464602}, {214,0.079075221}, {215,0.079017699}, {216,0.074190265}, {217,0.079659292}, {218,0.076128319}, {219,0.081703540}, {220,0.082924779}, {221,0.084287611}, {222,0.080765487}, {223,0.086902655}, {224,0.075933628}, {225,0.076079646}, {226,0.078238938}, {227,0.083212389}, {228,0.076853982}, {229,0.080876106}, {230,0.089349558}, {231,0.091101770}, {232,0.081150442}, {233,0.086588496}, {234,0.093146018}, {235,0.094650442}, {236,0.085973451}, {237,0.091115044}, {238,0.093623894}, {239,0.093761062}, {240,0.080057522}, {241,0.085774336}, {242,0.094765487}, {243,0.095110619}, {244,0.091017699}, {245,0.091960177}, {246,0.093703540}, {247,0.098287611}, {248,0.089190265}, {249,0.093907080}, {250,0.093460177}, {251,0.100668142}, {252,0.097973451}, {253,0.098407080}, {254,0.103137168}, {255,0.110159292}, {256,0.085566372}, {257,0.091336283}, {258,0.093933628}, {259,0.094389381}, {260,0.092110619}, {261,0.095685841}, {262,0.102668142}, {263,0.104464602}, {264,0.091694690}, {265,0.097761062}, {266,0.096526549}, {267,0.104469027}, {268,0.100407080}, {269,0.104212389}, {270,0.105486726}, {271,0.112610619}, {272,0.097884956}, {273,0.095243363}, {274,0.100986726}, {275,0.110672566}, {276,0.104061947}, {277,0.103429204}, {278,0.110008850}, {279,0.116991150}, {280,0.102548673}, {281,0.106907080}, {282,0.110747788}, {283,0.109690265}, {284,0.112460177}, {285,0.118061947}, {286,0.112721239}, {287,0.121566372}, {288,0.105402655}, {289,0.107867257}, {290,0.108668142}, {291,0.115769912}, {292,0.107792035}, {293,0.115734513}, {294,0.116867257}, {295,0.115274336}, {296,0.105884956}, {297,0.112199115}, {298,0.115309735}, {299,0.122075221}, {300,0.112327434}, {301,0.121907080}, {302,0.119535398}, {303,0.124247788}, {304,0.111840708}, {305,0.118646018}, {306,0.120623894}, {307,0.119946903}, {308,0.118323009}, {309,0.123247788}, {310,0.124017699}, {311,0.127176991}, {312,0.118486726}, {313,0.123292035}, {314,0.124061947}, {315,0.133699115}, {316,0.127039823}, {317,0.130615044}, {318,0.130969027}, {319,0.183685841}, {320,0.121752212}, {321,0.115553097}, {322,0.123079646}, {323,0.126455752}, {324,0.122292035}, {325,0.125004425}, {326,0.133924779}, {327,0.134274336}, {328,0.131995575}, {329,0.127676991}, {330,0.127960177}, {331,0.131429204}, {332,0.129491150}, {333,0.132212389}, {334,0.135464602}, {335,0.140190265}, {336,0.123995575}, {337,0.132402655}, {338,0.129154867}, {339,0.143221239}, {340,0.132464602}, {341,0.136982301}, {342,0.135915929}, {343,0.147588496}, {344,0.133477876}, {345,0.137584071}, {346,0.135477876}, {347,0.146323009}, {348,0.137769912}, {349,0.583415929}, {350,0.146287611}, {351,0.157884956}, {352,0.134933628}, {353,0.136955752}, {354,0.135725664}, {355,0.142668142}, {356,0.137929204}, {357,0.143504425}, {358,0.144584071}, {359,0.150017699}, {360,0.140814159}, {361,0.147915929}, {362,0.143823009}, {363,0.152884956}, {364,0.147951327}, {365,0.148327434}, {366,0.156256637}, {367,0.157721239}, {368,0.147070796}, {369,0.145942478}, {370,0.152247788}, {371,0.153097345}, {372,0.155084071}, {373,0.153194690}, {374,0.156092920}, {375,0.162716814}, {376,0.149991150}, {377,0.153663717}, {378,0.158761062}, {379,0.170814159}, {380,0.154539823}, {381,0.163991150}, {382,0.166840708}, {383,0.172150442}, {384,0.139115044}, {385,0.148013274}, {386,0.151243363}, {387,0.154221239}, {388,0.143800885}, {389,0.155676991}, {390,0.155570796}, {391,0.160632743}, {392,0.150415929}, {393,0.157420354}, {394,0.159070796}, {395,0.163199115}, {396,0.160309735}, {397,0.161008850}, {398,0.164203540}, {399,0.169402655}, {400,0.148442478}, {401,0.160778761}, {402,0.159827434}, {403,0.165123894}, {404,0.163053097}, {405,0.809849558}, {406,0.180486726}, {407,0.181438053}, {408,0.160871681}, {409,0.165305310}, {410,0.166411504}, {411,0.172805310}, {412,0.168827434}, {413,0.174898230}, {414,0.171663717}, {415,0.191323009}, {416,0.159907080}, {417,0.166522124}, {418,0.160407080}, {419,0.168862832}, {420,0.166823009}, {421,0.173911504}, {422,0.170845133}, {423,0.179513274}, {424,0.164190265}, {425,0.175296460}, {426,0.173522124}, {427,0.179991150}, {428,0.178716814}, {429,0.182685841}, {430,0.188840708}, {431,0.191557522}, {432,0.170601770}, {433,0.175676991}, {434,0.178283186}, {435,0.183203540}, {436,0.177862832}, {437,0.182668142}, {438,0.189000000}, {439,0.191305310}, {440,0.180800885}, {441,0.185367257}, {442,0.186039823}, {443,0.188836283}, {444,0.187535398}, {445,0.195561947}, {446,0.197123894}, {447,0.206146018}, {448,0.169473451}, {449,0.178730088}, {450,0.178553097}, {451,0.182831858}, {452,0.178061947}, {453,0.183570796}, {454,0.190473451}, {455,0.191606195}, {456,0.192212389}, {457,0.184969027}, {458,0.194787611}, {459,0.190460177}, {460,0.185929204}, {461,0.199194690}, {462,0.199194690}, {463,0.213880531}, {464,0.175584071}, {465,0.196482301}, {466,0.187119469}, {467,0.201703540}, {468,0.191323009}, {469,0.199588496}, {470,0.202814159}, {471,0.204398230}, {472,0.196181416}, {473,0.205398230}, {474,0.197685841}, {475,0.214314159}, {476,0.205628319}, {477,0.205716814}, {478,0.213500000}, {479,0.217486726}, {480,0.184526549}, {481,0.203752212}, {482,0.194438053}, {483,0.202676991}, {484,0.200460177}, {485,0.205269912}, {486,0.205327434}, {487,0.218539823}, {488,0.194641593}, {489,0.211384956}, {490,0.211331858}, {491,0.209128319}, {492,0.212429204}, {493,0.218464602}, {494,0.220300885}, {495,0.219159292}, {496,0.205778761}, {497,0.205566372}, {498,0.207455752}, {499,0.221787611}, {500,0.217070796}, {505,0.220707965}, {510,0.233132743}, {515,0.212380531}, {520,0.211911504}, {525,0.225256637}, {530,0.211929204}, {535,0.240243363}, {540,0.237823009}, {545,0.232278761}, {550,0.241314159}, {555,0.247831858}, {560,0.231756637}, {565,0.243008850}, {570,0.245141593}, {575,0.271650442}, {580,0.236796460}, {585,0.252500000}, {590,0.263508850}, {595,0.270827434}, {600,0.263199115}, {605,0.281823009}, {610,0.262389381}, {615,0.281146018}, {620,0.271712389}, {625,0.273150442}, {630,0.291446903}, {635,0.305247788}, {640,0.256694690}, {645,0.278013274}, {650,0.280261062}, {655,0.301420354}, {660,0.276544248}, {665,0.299641593}, {670,0.314535398}, {675,0.305924779}, {680,0.297207965}, {685,0.312915929}, {690,0.307323009}, {695,0.330690265}, {700,0.326933628}, {705,0.298942478}, {710,0.311730088}, {715,0.330247788}, {720,0.302464602}, {725,0.336566372}, {730,0.332407080}, {735,0.356464602}, {740,0.321876106}, {745,0.337433628}, {750,0.352756637}, {755,0.355460177}, {760,0.350827434}, {765,0.385061947}, {770,0.326685841}, {775,0.348491150}, {780,0.341827434}, {785,0.339871681}, {790,0.358066372}, {795,0.376716814}, {800,0.341309735}, {805,0.366438053}, {810,0.366893805}, {815,0.392349558}, {820,0.363331858}, {825,0.382092920}, {830,0.407079646}, {835,0.374433628}, {840,0.356924779}, {845,0.386982301}, {850,0.380013274}, {855,0.407800885}, {860,0.395225664}, {865,0.390716814}, {870,0.400181416}, {875,0.423234513}, {880,0.396203540}, {885,0.437207965}, {890,0.433530973}, {895,0.465238938}, {900,0.383061947}, {905,0.408128319}, {910,0.420000000}, {915,0.430420354}, {920,0.411446903}, {925,0.451579646}, {930,0.417123894}, {935,0.461606195}, {940,0.438827434}, {945,0.442207965}, {950,0.457420354}, {955,0.476159292}, {960,0.415707965}, {965,0.451964602}, {970,0.451646018}, {975,0.486769912}, {980,0.461026549}, {985,0.478088496}, {990,0.489402655}, {995,0.484955752}, {1000,0.461946903}, {1010,0.482924779}, {1020,0.496884956}, {1030,0.465840708}, {1040,0.452287611}, {1050,0.499672566}, {1060,0.476991150}, {1070,0.508185841}, {1080,0.496181416}, {1090,0.487707965}, {1100,0.509530973}, {1110,0.534703540}, {1120,0.506579646}, {1130,0.550911504}, {1140,0.542650442}, {1150,0.592407080}, {1160,0.516694690}, {1170,0.538986726}, {1180,0.557323009}, {1190,0.577991150}, {1200,0.550349558}, {1210,0.599261062}, {1220,0.558969027}, {1230,0.605168142}, {1240,0.587044248}, {1250,0.605181416}, {1260,0.611225664}, {1270,0.642274336}, {1280,0.570132743}, {1290,0.597252212}, {1300,0.612393805}, {1310,0.650969027}, {1320,0.612469027}, {1330,0.627314159}, {1340,0.659592920}, {1350,0.648615044}, {1360,0.621539823}, {1370,0.675088496}, {1380,0.660265487}, {1390,0.716730088}, {1400,0.686907080}, {1410,0.644106195}, {1420,0.683783186}, {1430,0.710526549}, {1440,0.661393805}, {1450,0.709053097}, {1460,0.710274336}, {1470,0.766300885}, {1480,0.720278761}, {1490,0.725146018}, {1500,0.756309735}, {1510,0.760991150}, {1520,0.736199115}, {1530,0.794964602}, {1540,0.702221239}, {1550,0.756123894}, {1560,0.731261062}, {1570,0.735230088}, {1580,0.760327434}, {1590,0.796615044}, {1600,0.728911504}, {1610,0.783902655}, {1620,0.785013274}, {1630,0.835066372}, {1640,0.784504425}, {1650,0.817154867}, {1660,0.865818584}, {1670,0.802646018}, {1680,0.775544248}, {1690,0.830769912}, {1700,0.816526549}, {1710,0.881393805}, {1720,0.848907080}, {1730,0.819867257}, {1740,0.861650442}, {1750,0.889106195}, {1760,0.843955752}, {1770,0.909588496}, {1780,0.908309735}, {1790,0.966278761}, {1800,0.830526549}, {1810,0.887123894}, {1820,0.896929204}, {1830,0.892092920}, {1840,0.877371681}, {1850,0.946690265}, {1860,0.893420354}, {1870,0.956469027}, {1880,0.926402655}, {1890,0.933318584}, {1900,0.969814159}, {1910,0.999026549}, {1920,0.879730088}, {1930,0.942867257}, {1940,0.946491150}, {1950,1.025460177}, {1960,0.959561947}, {1970,0.997075221}, {1980,1.034827434}, {1990,1.008106195}, {2000,0.984008850}, {2050,0.946084071}, {2100,1.026889381}, {2150,1.107243363}, {2200,1.100256637}, {2250,1.140362832}, {2300,1.240473451}, {2350,1.244566372}, {2400,1.182915929}, {2450,1.244774336}, {2500,1.264424779}, {2550,1.436681416}, {2600,1.288150442}, {2650,1.384022124}, {2700,1.384610619}, {2750,1.556353982}, {2800,1.463738938}, {2850,1.459154867}, {2900,1.511889381}, {2950,1.549911504}, {3000,1.624632743}, {3050,1.691880531}, {3100,1.650110619}, {3150,1.946243363}, {3200,1.544300885}, {3250,1.712017699}, {3300,1.755119469}, {3350,2.082650442}, {3400,1.751561947}, {3450,1.928460177}, {3500,1.896455752}, {3550,2.073584071}, {3600,1.775831858}, {3650,1.863849558}, {3700,2.014411504}, {3750,2.046597345}, {3800,2.066460177}, {3850,2.018584071}, {3900,2.197168142}, {3950,2.299336283}, {4000,2.085522124}, {4050,2.266469027}, {4100,2.042013274}, {4150,2.283805310}, {4200,2.230092920}, {4250,2.326539823}, {4300,2.359663717}, {4350,2.605092920}, {4400,2.323849558}, {4450,2.444464602}, {4500,2.443358407}, {4550,2.550862832}, {4600,2.645641593}, {4650,2.900323009}, {4700,2.627433628}, {4750,2.662836283}, {4800,2.520070796}, {4850,2.800778761}, {4900,2.643902655}, {4950,2.857823009}, {5000,2.682867257}, {5050,2.996761062}, {5100,3.010234513}, {5150,2.991730088}, {5200,2.735995575}, {5250,2.769400000}, {5300,2.970648889}, {5350,3.204128889}, {5400,3.181551111}, {5450,3.042315556}, {5500,3.269555556}, {5550,3.295062222}, {5600,3.127760000}, {5650,3.049200000}, {5700,3.077924444}, {5750,3.417564444}, {5800,3.215911111}, {5850,3.460800000}, {5900,3.264977778}, {5950,3.632897778}, {6000,3.414733333}, {6050,3.429889}, {6100,3.563389}, {6150,3.251778}, {6200,3.403556}, {6250,3.551833}, {6300,3.520889}, {6350,3.686667}, {6400,3.248111}, {6450,3.564500}, {6500,3.612778}, {6550,3.917500}, {6600,3.669833}, {6650,4.080611}, {6700,3.722722}, {6750,4.012111}, {6800,3.674889}, {6850,3.791833}, {6900,4.098111}, {6950,3.979611}, {7000,4.000944}, {7050,4.223333}, {7100,4.303000}, {7150,4.473556}, {7200,3.723000}, {7250,4.062611}, {7300,3.932667}, {7350,4.367944}, {7400,4.273778}, {7450,4.268333}, {7500,4.338000}, {7550,4.714667}, {7600,4.367278}, {7650,4.478833}, {7700,4.234722}, {7750,4.441278}, {7800,4.561944}, {7850,4.651778}, {7900,4.729056}, {7950,4.685444}, {8000,4.365444}, {8050,4.863389}, {8100,4.682556}, {8150,5.059611}, {8200,4.280722}, {8250,4.793000}, {8300,4.801000}, {8350,4.991556}, {8400,4.658278}, {8450,4.528167}, {8500,4.879167}, {8550,5.060611}, {8600,4.900278}, {8650,5.125000}, {8700,5.469778}, {8750,5.203778}, {8800,4.856667}, {8850,5.085000}, {8900,5.069722}, {8950,5.626778}, {9000,5.130111}, {9050,5.513611}, {9100,5.351722}, {9150,5.936889}, {9200,5.572278}, {9250,5.164611}, {9300,5.312278}, {9350,5.377778}, {9400,5.530444}, {9450,5.761833}, {9500,5.597722}, {9550,5.762667}, {9600,5.277000}, {9650,5.833944}, {9700,5.888889}, {9750,5.696944}, {9800,5.562722}, {9850,6.116889}, {9900,5.946889}, {9950,6.358444}, {10000,5.601722}, {10100,6.269556}, {10200,6.289278}, {10300,6.078722}, {10400,5.743056}, {10500,5.778389}, {10600,6.241778}, {10700,6.435778}, {10800,6.120444}, {10900,6.357722}, {11000,6.813500}, {11100,6.941111}, {11200,6.530167}, {11300,6.391333}, {11400,6.447667}, {11500,7.119000}, {11600,6.753056}, {11700,7.257333}, {11800,6.856056}, {11900,7.564333}, {12000,7.164611}, {12100,7.543944}, {12200,7.455278}, {12300,6.884833}, {12400,7.193444}, {12500,7.436889}, {12600,7.493944}, {12700,7.820389}, {12800,6.884056}, {12900,7.631056}, {13000,7.665056}, {13100,8.313556}, {13200,7.771611}, {13300,8.573889}, {13400,7.901333}, {13500,9.193444}, {13600,8.044778}, {13700,8.052556}, {13800,8.610056}, {13900,8.412778}, {14000,9.164611}, {14100,8.597667}, {14200,9.106111}, {14300,9.788889}, {14400,7.930500}, {14500,8.533944}, {14600,8.280444}, {14700,9.198778}, {14800,8.957889}, {14900,8.967000}, {15000,9.063111}, {15100,9.987056}, {15200,9.118667}, {15300,9.432778}, {15400,8.970056}, {15500,9.347389}, {15600,9.710000}, {15700,9.729111}, {15800,10.228500}, {15900,10.025889}, {16000,9.270000}, {16100,10.273167}, {16200,9.961611}, {16300,10.671278}, {16400,9.122111}, {16500,10.109000}, {16600,10.129889}, {16700,10.503889}, {16800,9.885556}, {16900,9.796889}, {17000,10.507000}, {17100,11.140056}, {17200,10.452278}, {17300,11.187333}, {17400,11.759556}, {17500,11.342944}, {17600,10.545944}, {17700,10.722278}, {17800,10.718389}, {17900,11.834333}, {18000,11.238500}, {18100,11.898833}, {18200,11.484389}, {18300,12.600333}, {18400,11.732222}, {18500,11.019222}, {18600,11.379611}, {18700,11.283667}, {18800,12.023056}, {18900,12.322722}, {19000,11.845389}, {19100,12.657389}, {19200,11.326278}, {19300,12.330167}, {19400,12.527444}, {19500,12.097500}, {19600,11.991944}, {19700,13.766722}, {19800,12.658333}, {19900,13.699222}, {20000,12.139313}};
data["big_flat"]["TypeClasses"]["actual reif"]["user"] = {{1,0.000208889}, {2,0.000442478}, {3,0.000424779}, {4,0.000818584}, {5,0.000787611}, {6,0.001207965}, {7,0.001592920}, {8,0.001778761}, {9,0.001769912}, {10,0.001977876}, {11,0.002336283}, {12,0.002402655}, {13,0.002809735}, {14,0.003084071}, {15,0.003376106}, {16,0.003486726}, {17,0.003867257}, {18,0.004172566}, {19,0.004575221}, {20,0.004654867}, {21,0.005517699}, {22,0.012446903}, {23,0.006097345}, {24,0.005862832}, {25,0.006455752}, {26,0.006721239}, {27,0.007924779}, {28,0.007115044}, {29,0.008061947}, {30,0.008207965}, {31,0.008867257}, {32,0.008314159}, {33,0.008986726}, {34,0.009212389}, {35,0.010216814}, {36,0.009615044}, {37,0.010199115}, {38,0.010415929}, {39,0.011000000}, {40,0.010438053}, {41,0.011535398}, {42,0.011300885}, {43,0.012230088}, {44,0.012756637}, {45,0.012933628}, {46,0.013818584}, {47,0.013632743}, {48,0.012800885}, {49,0.013615044}, {50,0.013814159}, {51,0.015526549}, {52,0.015141593}, {53,0.015398230}, {54,0.015858407}, {55,0.016858407}, {56,0.015446903}, {57,0.016561947}, {58,0.017663717}, {59,0.017836283}, {60,0.017194690}, {61,0.018221239}, {62,0.018575221}, {63,0.019411504}, {64,0.019221239}, {65,0.018681416}, {66,0.018929204}, {67,0.020867257}, {68,0.019296460}, {69,0.020734513}, {70,0.020946903}, {71,0.022030973}, {72,0.020420354}, {73,0.021716814}, {74,0.023893805}, {75,0.023420354}, {76,0.022504425}, {77,0.025296460}, {78,0.024079646}, {79,0.026862832}, {80,0.023707965}, {81,0.024261062}, {82,0.024588496}, {83,0.027867257}, {84,0.025061947}, {85,0.026163717}, {86,0.026438053}, {87,0.029646018}, {88,0.026991150}, {89,0.027367257}, {90,0.027721239}, {91,0.031588496}, {92,0.028199115}, {93,0.031314159}, {94,0.030442478}, {95,0.033340708}, {96,0.027548673}, {97,0.029053097}, {98,0.030438053}, {99,0.031398230}, {100,0.030137168}, {101,0.031995575}, {102,0.033924779}, {103,0.034650442}, {104,0.031146018}, {105,0.036637168}, {106,0.033013274}, {107,0.035862832}, {108,0.033792035}, {109,0.035446903}, {110,0.035323009}, {111,0.037296460}, {112,0.033323009}, {113,0.035119469}, {114,0.035261062}, {115,0.037787611}, {116,0.036154867}, {117,0.037796460}, {118,0.038137168}, {119,0.040340708}, {120,0.038513274}, {121,0.040862832}, {122,0.039597345}, {123,0.045902655}, {124,0.040035398}, {125,0.044402655}, {126,0.043411504}, {127,0.044265487}, {128,0.040070796}, {129,0.040451327}, {130,0.040331858}, {131,0.045535398}, {132,0.041964602}, {133,0.043535398}, {134,0.045513274}, {135,0.046026549}, {136,0.045920354}, {137,0.046836283}, {138,0.044592920}, {139,0.048818584}, {140,0.045292035}, {141,0.050792035}, {142,0.049283186}, {143,0.052840708}, {144,0.044128319}, {145,0.048787611}, {146,0.048110619}, {147,0.050938053}, {148,0.050725664}, {149,0.049787611}, {150,0.057309735}, {151,0.055420354}, {152,0.051106195}, {153,0.052150442}, {154,0.058535398}, {155,0.053867257}, {156,0.056101770}, {157,0.057061947}, {158,0.054389381}, {159,0.057123894}, {160,0.050991150}, {161,0.051823009}, {162,0.051876106}, {163,0.057778761}, {164,0.055721239}, {165,0.057907080}, {166,0.055743363}, {167,0.062933628}, {168,0.056659292}, {169,0.058305310}, {170,0.056637168}, {171,0.063407080}, {172,0.063853982}, {173,0.060216814}, {174,0.062995575}, {175,0.063353982}, {176,0.060106195}, {177,0.061783186}, {178,0.063008850}, {179,0.062252212}, {180,0.063150442}, {181,0.066796460}, {182,0.066199115}, {183,0.069699115}, {184,0.061247788}, {185,0.065172566}, {186,0.065008850}, {187,0.072486726}, {188,0.070234513}, {189,0.070411504}, {190,0.073039823}, {191,0.071079646}, {192,0.061535398}, {193,0.063283186}, {194,0.065039823}, {195,0.073026549}, {196,0.065699115}, {197,0.071336283}, {198,0.066792035}, {199,0.071407080}, {200,0.069008850}, {201,0.068579646}, {202,0.074623894}, {203,0.078977876}, {204,0.072924779}, {205,0.079203540}, {206,0.075831858}, {207,0.079345133}, {208,0.076929204}, {209,0.070283186}, {210,0.072460177}, {211,0.078194690}, {212,0.071548673}, {213,0.077234513}, {214,0.078668142}, {215,0.079190265}, {216,0.074044248}, {217,0.079349558}, {218,0.076504425}, {219,0.081411504}, {220,0.082535398}, {221,0.084212389}, {222,0.080814159}, {223,0.086433628}, {224,0.075730088}, {225,0.076309735}, {226,0.078203540}, {227,0.083132743}, {228,0.077137168}, {229,0.080619469}, {230,0.089004425}, {231,0.091092920}, {232,0.081146018}, {233,0.086274336}, {234,0.092283186}, {235,0.094650442}, {236,0.085663717}, {237,0.090809735}, {238,0.093243363}, {239,0.093792035}, {240,0.080057522}, {241,0.085566372}, {242,0.093818584}, {243,0.095150442}, {244,0.090659292}, {245,0.091849558}, {246,0.093455752}, {247,0.098190265}, {248,0.089004425}, {249,0.093654867}, {250,0.093362832}, {251,0.100256637}, {252,0.097659292}, {253,0.098230088}, {254,0.102561947}, {255,0.109783186}, {256,0.085300885}, {257,0.091061947}, {258,0.093464602}, {259,0.094438053}, {260,0.091796460}, {261,0.095756637}, {262,0.102323009}, {263,0.104389381}, {264,0.091730088}, {265,0.097623894}, {266,0.096274336}, {267,0.104101770}, {268,0.100110619}, {269,0.103862832}, {270,0.105256637}, {271,0.111849558}, {272,0.097800885}, {273,0.095553097}, {274,0.100539823}, {275,0.110008850}, {276,0.104022124}, {277,0.103442478}, {278,0.109805310}, {279,0.116548673}, {280,0.102681416}, {281,0.106725664}, {282,0.110168142}, {283,0.109469027}, {284,0.111951327}, {285,0.117575221}, {286,0.112579646}, {287,0.121212389}, {288,0.105092920}, {289,0.107734513}, {290,0.108690265}, {291,0.114911504}, {292,0.107411504}, {293,0.115513274}, {294,0.116132743}, {295,0.115101770}, {296,0.105699115}, {297,0.111765487}, {298,0.114712389}, {299,0.121433628}, {300,0.112017699}, {301,0.121601770}, {302,0.119212389}, {303,0.123977876}, {304,0.111345133}, {305,0.118314159}, {306,0.119969027}, {307,0.119535398}, {308,0.117712389}, {309,0.123008850}, {310,0.123986726}, {311,0.126871681}, {312,0.118132743}, {313,0.122756637}, {314,0.123862832}, {315,0.133623894}, {316,0.126946903}, {317,0.130402655}, {318,0.130964602}, {319,0.183500000}, {320,0.121615044}, {321,0.115433628}, {322,0.123221239}, {323,0.126269912}, {324,0.121915929}, {325,0.125146018}, {326,0.133654867}, {327,0.134203540}, {328,0.131960177}, {329,0.127619469}, {330,0.128168142}, {331,0.131446903}, {332,0.129389381}, {333,0.132030973}, {334,0.135225664}, {335,0.140305310}, {336,0.123995575}, {337,0.132168142}, {338,0.129115044}, {339,0.142818584}, {340,0.132092920}, {341,0.136818584}, {342,0.135712389}, {343,0.147309735}, {344,0.133168142}, {345,0.137517699}, {346,0.135566372}, {347,0.145938053}, {348,0.137734513}, {349,0.581659292}, {350,0.145889381}, {351,0.157464602}, {352,0.134654867}, {353,0.136920354}, {354,0.135747788}, {355,0.142402655}, {356,0.137814159}, {357,0.143411504}, {358,0.144163717}, {359,0.149672566}, {360,0.140880531}, {361,0.147694690}, {362,0.143455752}, {363,0.152911504}, {364,0.147694690}, {365,0.147884956}, {366,0.155915929}, {367,0.157482301}, {368,0.146747788}, {369,0.145721239}, {370,0.152066372}, {371,0.153119469}, {372,0.154960177}, {373,0.153026549}, {374,0.156022124}, {375,0.162544248}, {376,0.149920354}, {377,0.153495575}, {378,0.158672566}, {379,0.170637168}, {380,0.154380531}, {381,0.163938053}, {382,0.166769912}, {383,0.171836283}, {384,0.138871681}, {385,0.148004425}, {386,0.151150442}, {387,0.154314159}, {388,0.143942478}, {389,0.155650442}, {390,0.155424779}, {391,0.160500000}, {392,0.150588496}, {393,0.157429204}, {394,0.158805310}, {395,0.162915929}, {396,0.160247788}, {397,0.160827434}, {398,0.164084071}, {399,0.169168142}, {400,0.148287611}, {401,0.160668142}, {402,0.159500000}, {403,0.164880531}, {404,0.162756637}, {405,0.808619469}, {406,0.180000000}, {407,0.180929204}, {408,0.160712389}, {409,0.164929204}, {410,0.166168142}, {411,0.172464602}, {412,0.168429204}, {413,0.174597345}, {414,0.171234513}, {415,0.190920354}, {416,0.159694690}, {417,0.166168142}, {418,0.160225664}, {419,0.168756637}, {420,0.166774336}, {421,0.173650442}, {422,0.170725664}, {423,0.179287611}, {424,0.163827434}, {425,0.175013274}, {426,0.173287611}, {427,0.180013274}, {428,0.178367257}, {429,0.182446903}, {430,0.188575221}, {431,0.191508850}, {432,0.170349558}, {433,0.175256637}, {434,0.178203540}, {435,0.183230088}, {436,0.177796460}, {437,0.182637168}, {438,0.188907080}, {439,0.191256637}, {440,0.180584071}, {441,0.185340708}, {442,0.185769912}, {443,0.188530973}, {444,0.187446903}, {445,0.195296460}, {446,0.196867257}, {447,0.206287611}, {448,0.169190265}, {449,0.178628319}, {450,0.178323009}, {451,0.182566372}, {452,0.177743363}, {453,0.183393805}, {454,0.190393805}, {455,0.191292035}, {456,0.191938053}, {457,0.184831858}, {458,0.194783186}, {459,0.190482301}, {460,0.185752212}, {461,0.198831858}, {462,0.198867257}, {463,0.213473451}, {464,0.175123894}, {465,0.196371681}, {466,0.187216814}, {467,0.201362832}, {468,0.191283186}, {469,0.199619469}, {470,0.202615044}, {471,0.204212389}, {472,0.196327434}, {473,0.205146018}, {474,0.197380531}, {475,0.214159292}, {476,0.205663717}, {477,0.205787611}, {478,0.213632743}, {479,0.217318584}, {480,0.184486726}, {481,0.203601770}, {482,0.194008850}, {483,0.202176991}, {484,0.200252212}, {485,0.205070796}, {486,0.204995575}, {487,0.218022124}, {488,0.194566372}, {489,0.211022124}, {490,0.210938053}, {491,0.209075221}, {492,0.212022124}, {493,0.218181416}, {494,0.220044248}, {495,0.219017699}, {496,0.205561947}, {497,0.205451327}, {498,0.207318584}, {499,0.221402655}, {500,0.216898230}, {505,0.220305310}, {510,0.232911504}, {515,0.211951327}, {520,0.211712389}, {525,0.224942478}, {530,0.211902655}, {535,0.239840708}, {540,0.237415929}, {545,0.232039823}, {550,0.241057522}, {555,0.247862832}, {560,0.231305310}, {565,0.242734513}, {570,0.244761062}, {575,0.271323009}, {580,0.236460177}, {585,0.252398230}, {590,0.263115044}, {595,0.270380531}, {600,0.262787611}, {605,0.281619469}, {610,0.262030973}, {615,0.280818584}, {620,0.271619469}, {625,0.273017699}, {630,0.291331858}, {635,0.304769912}, {640,0.256402655}, {645,0.277827434}, {650,0.280181416}, {655,0.301110619}, {660,0.276402655}, {665,0.299185841}, {670,0.314340708}, {675,0.305814159}, {680,0.297008850}, {685,0.312663717}, {690,0.307190265}, {695,0.330402655}, {700,0.326544248}, {705,0.298659292}, {710,0.311384956}, {715,0.329982301}, {720,0.302190265}, {725,0.336433628}, {730,0.332238938}, {735,0.356022124}, {740,0.321566372}, {745,0.337420354}, {750,0.352433628}, {755,0.355349558}, {760,0.350592920}, {765,0.384796460}, {770,0.326451327}, {775,0.348252212}, {780,0.341530973}, {785,0.339774336}, {790,0.357628319}, {795,0.376442478}, {800,0.341097345}, {805,0.366163717}, {810,0.366570796}, {815,0.392106195}, {820,0.363017699}, {825,0.381774336}, {830,0.406876106}, {835,0.374159292}, {840,0.356659292}, {845,0.386805310}, {850,0.379845133}, {855,0.407411504}, {860,0.394964602}, {865,0.390455752}, {870,0.399986726}, {875,0.422933628}, {880,0.395938053}, {885,0.437097345}, {890,0.433137168}, {895,0.465115044}, {900,0.382920354}, {905,0.407915929}, {910,0.419654867}, {915,0.430318584}, {920,0.411172566}, {925,0.451345133}, {930,0.417026549}, {935,0.461207965}, {940,0.438654867}, {945,0.441809735}, {950,0.457075221}, {955,0.475818584}, {960,0.415747788}, {965,0.451522124}, {970,0.451314159}, {975,0.486513274}, {980,0.460818584}, {985,0.477508850}, {990,0.489013274}, {995,0.484809735}, {1000,0.461446903}, {1010,0.482486726}, {1020,0.496278761}, {1030,0.465234513}, {1040,0.451809735}, {1050,0.499238938}, {1060,0.476371681}, {1070,0.507840708}, {1080,0.495889381}, {1090,0.487287611}, {1100,0.509057522}, {1110,0.534407080}, {1120,0.506101770}, {1130,0.550526549}, {1140,0.542261062}, {1150,0.591805310}, {1160,0.516274336}, {1170,0.538769912}, {1180,0.556946903}, {1190,0.577628319}, {1200,0.550004425}, {1210,0.598853982}, {1220,0.558477876}, {1230,0.604438053}, {1240,0.586632743}, {1250,0.604946903}, {1260,0.610800885}, {1270,0.641761062}, {1280,0.569960177}, {1290,0.596774336}, {1300,0.611884956}, {1310,0.650716814}, {1320,0.612053097}, {1330,0.626867257}, {1340,0.658933628}, {1350,0.648123894}, {1360,0.621097345}, {1370,0.674535398}, {1380,0.659455752}, {1390,0.715044248}, {1400,0.684898230}, {1410,0.643349558}, {1420,0.683048673}, {1430,0.709964602}, {1440,0.660884956}, {1450,0.708309735}, {1460,0.709730088}, {1470,0.765699115}, {1480,0.719482301}, {1490,0.724615044}, {1500,0.755867257}, {1510,0.760340708}, {1520,0.735646018}, {1530,0.794438053}, {1540,0.701517699}, {1550,0.755398230}, {1560,0.730517699}, {1570,0.734743363}, {1580,0.760000000}, {1590,0.795823009}, {1600,0.728557522}, {1610,0.783123894}, {1620,0.784513274}, {1630,0.834460177}, {1640,0.783845133}, {1650,0.816491150}, {1660,0.865353982}, {1670,0.802168142}, {1680,0.775110619}, {1690,0.830212389}, {1700,0.816132743}, {1710,0.880809735}, {1720,0.848349558}, {1730,0.819159292}, {1740,0.861048673}, {1750,0.888544248}, {1760,0.843300885}, {1770,0.908756637}, {1780,0.907513274}, {1790,0.965504425}, {1800,0.829911504}, {1810,0.886451327}, {1820,0.896079646}, {1830,0.891238938}, {1840,0.876964602}, {1850,0.945858407}, {1860,0.892867257}, {1870,0.955827434}, {1880,0.925606195}, {1890,0.932619469}, {1900,0.968982301}, {1910,0.998123894}, {1920,0.879128319}, {1930,0.942194690}, {1940,0.945823009}, {1950,1.024721239}, {1960,0.958898230}, {1970,0.996380531}, {1980,1.034415929}, {1990,1.007384956}, {2000,0.983455752}, {2050,0.945185841}, {2100,1.026066372}, {2150,1.106261062}, {2200,1.099539823}, {2250,1.139353982}, {2300,1.239345133}, {2350,1.243420354}, {2400,1.181858407}, {2450,1.243911504}, {2500,1.263420354}, {2550,1.435402655}, {2600,1.286969027}, {2650,1.382871681}, {2700,1.383433628}, {2750,1.555004425}, {2800,1.462415929}, {2850,1.457615044}, {2900,1.510243363}, {2950,1.548429204}, {3000,1.623106195}, {3050,1.690362832}, {3100,1.647756637}, {3150,1.944221239}, {3200,1.543238938}, {3250,1.710685841}, {3300,1.752646018}, {3350,2.079659292}, {3400,1.749597345}, {3450,1.926809735}, {3500,1.894880531}, {3550,2.071500000}, {3600,1.773818584}, {3650,1.861163717}, {3700,2.012694690}, {3750,2.044522124}, {3800,2.064769912}, {3850,2.016039823}, {3900,2.195495575}, {3950,2.296469027}, {4000,2.083477876}, {4050,2.264694690}, {4100,2.039500000}, {4150,2.281933628}, {4200,2.227867257}, {4250,2.324442478}, {4300,2.357553097}, {4350,2.602535398}, {4400,2.321924779}, {4450,2.442314159}, {4500,2.441283186}, {4550,2.548079646}, {4600,2.639207965}, {4650,2.897221239}, {4700,2.625384956}, {4750,2.660703540}, {4800,2.517774336}, {4850,2.795030973}, {4900,2.641420354}, {4950,2.855398230}, {5000,2.680384956}, {5050,2.994327434}, {5100,3.007044248}, {5150,2.989057522}, {5200,2.733725664}, {5250,2.766560000}, {5300,2.966613333}, {5350,3.195826667}, {5400,3.178097778}, {5450,3.039782222}, {5500,3.265542222}, {5550,3.289115556}, {5600,3.124071111}, {5650,3.046764444}, {5700,3.075182222}, {5750,3.414733333}, {5800,3.213173333}, {5850,3.457844444}, {5900,3.261875556}, {5950,3.629675556}, {6000,3.412026667}, {6050,3.421111}, {6100,3.544333}, {6150,3.237611}, {6200,3.399944}, {6250,3.543444}, {6300,3.516722}, {6350,3.682889}, {6400,3.245333}, {6450,3.560222}, {6500,3.606778}, {6550,3.910889}, {6600,3.667778}, {6650,4.078222}, {6700,3.718667}, {6750,4.008056}, {6800,3.671500}, {6850,3.788278}, {6900,4.094000}, {6950,3.974611}, {7000,3.996500}, {7050,4.217389}, {7100,4.298444}, {7150,4.468611}, {7200,3.718722}, {7250,4.056556}, {7300,3.924500}, {7350,4.362944}, {7400,4.268722}, {7450,4.264167}, {7500,4.332889}, {7550,4.709500}, {7600,4.362722}, {7650,4.474222}, {7700,4.228778}, {7750,4.436333}, {7800,4.557389}, {7850,4.646556}, {7900,4.723778}, {7950,4.679944}, {8000,4.360167}, {8050,4.858056}, {8100,4.676722}, {8150,5.054389}, {8200,4.275333}, {8250,4.787333}, {8300,4.796611}, {8350,4.985389}, {8400,4.652556}, {8450,4.522389}, {8500,4.872944}, {8550,5.053833}, {8600,4.893889}, {8650,5.118222}, {8700,5.462556}, {8750,5.196611}, {8800,4.849222}, {8850,5.078222}, {8900,5.062111}, {8950,5.618944}, {9000,5.123056}, {9050,5.505278}, {9100,5.344222}, {9150,5.930222}, {9200,5.566056}, {9250,5.158556}, {9300,5.306278}, {9350,5.371500}, {9400,5.524722}, {9450,5.755222}, {9500,5.591222}, {9550,5.756611}, {9600,5.271278}, {9650,5.827278}, {9700,5.882611}, {9750,5.691000}, {9800,5.556667}, {9850,6.110389}, {9900,5.939833}, {9950,6.352333}, {10000,5.595222}, {10100,6.261667}, {10200,6.281667}, {10300,6.072778}, {10400,5.737611}, {10500,5.772111}, {10600,6.235500}, {10700,6.428889}, {10800,6.114333}, {10900,6.351611}, {11000,6.806667}, {11100,6.933444}, {11200,6.523278}, {11300,6.383556}, {11400,6.443389}, {11500,7.113333}, {11600,6.747667}, {11700,7.251889}, {11800,6.850222}, {11900,7.558500}, {12000,7.157833}, {12100,7.535333}, {12200,7.448222}, {12300,6.876111}, {12400,7.184222}, {12500,7.427778}, {12600,7.485944}, {12700,7.812389}, {12800,6.877722}, {12900,7.625000}, {13000,7.657111}, {13100,8.307556}, {13200,7.765444}, {13300,8.566944}, {13400,7.888611}, {13500,9.185722}, {13600,8.037889}, {13700,8.044667}, {13800,8.602667}, {13900,8.398278}, {14000,9.151167}, {14100,8.590389}, {14200,9.096778}, {14300,9.779389}, {14400,7.923111}, {14500,8.525722}, {14600,8.267944}, {14700,9.189556}, {14800,8.949889}, {14900,8.960556}, {15000,9.054667}, {15100,9.972778}, {15200,9.110333}, {15300,9.422389}, {15400,8.956667}, {15500,9.336444}, {15600,9.698556}, {15700,9.714500}, {15800,10.215722}, {15900,10.010222}, {16000,9.257167}, {16100,10.262000}, {16200,9.952167}, {16300,10.660389}, {16400,9.112056}, {16500,10.094833}, {16600,10.116389}, {16700,10.489333}, {16800,9.874056}, {16900,9.786667}, {17000,10.493667}, {17100,11.124333}, {17200,10.439611}, {17300,11.172778}, {17400,11.744389}, {17500,11.324778}, {17600,10.527056}, {17700,10.707556}, {17800,10.704278}, {17900,11.813167}, {18000,11.204889}, {18100,11.881833}, {18200,11.469056}, {18300,12.578611}, {18400,11.714389}, {18500,11.002056}, {18600,11.362556}, {18700,11.267500}, {18800,11.995778}, {18900,12.303167}, {19000,11.827611}, {19100,12.640389}, {19200,11.310944}, {19300,12.310889}, {19400,12.503722}, {19500,12.079889}, {19600,11.973167}, {19700,13.719278}, {19800,12.640333}, {19900,13.678889}, {20000,12.119375}};
data["big_flat"]["TypeClasses"]["actual reif"]["system"] = {{1,0.000115556}, {2,0.000017699}, {3,0.000000000}, {4,0.000000000}, {5,0.000013274}, {6,0.000000000}, {7,0.000017699}, {8,0.000017699}, {9,0.000017699}, {10,0.000000000}, {11,0.000000000}, {12,0.000017699}, {13,0.000000000}, {14,0.000000000}, {15,0.000013274}, {16,0.000026549}, {17,0.000000000}, {18,0.000030973}, {19,0.000017699}, {20,0.000000000}, {21,0.000000000}, {22,0.000088496}, {23,0.000013274}, {24,0.000013274}, {25,0.000030973}, {26,0.000017699}, {27,0.000035398}, {28,0.000017699}, {29,0.000000000}, {30,0.000013274}, {31,0.000000000}, {32,0.000000000}, {33,0.000013274}, {34,0.000000000}, {35,0.000013274}, {36,0.000026549}, {37,0.000000000}, {38,0.000053097}, {39,0.000035398}, {40,0.000000000}, {41,0.000000000}, {42,0.000017699}, {43,0.000035398}, {44,0.000017699}, {45,0.000000000}, {46,0.000017699}, {47,0.000000000}, {48,0.000000000}, {49,0.000053097}, {50,0.000048673}, {51,0.000013274}, {52,0.000017699}, {53,0.000066372}, {54,0.000000000}, {55,0.000000000}, {56,0.000048673}, {57,0.000030973}, {58,0.000066372}, {59,0.000066372}, {60,0.000017699}, {61,0.000017699}, {62,0.000000000}, {63,0.000000000}, {64,0.000048673}, {65,0.000017699}, {66,0.000000000}, {67,0.000035398}, {68,0.000017699}, {69,0.000000000}, {70,0.000013274}, {71,0.000035398}, {72,0.000017699}, {73,0.000000000}, {74,0.000066372}, {75,0.000000000}, {76,0.000017699}, {77,0.000088496}, {78,0.000053097}, {79,0.000030973}, {80,0.000084071}, {81,0.000000000}, {82,0.000000000}, {83,0.000048673}, {84,0.000017699}, {85,0.000000000}, {86,0.000030973}, {87,0.000070796}, {88,0.000044248}, {89,0.000000000}, {90,0.000053097}, {91,0.000053097}, {92,0.000017699}, {93,0.000048673}, {94,0.000017699}, {95,0.000053097}, {96,0.000017699}, {97,0.000017699}, {98,0.000097345}, {99,0.000066372}, {100,0.000013274}, {101,0.000017699}, {102,0.000119469}, {103,0.000061947}, {104,0.000048673}, {105,0.000066372}, {106,0.000035398}, {107,0.000017699}, {108,0.000000000}, {109,0.000013274}, {110,0.000000000}, {111,0.000017699}, {112,0.000017699}, {113,0.000035398}, {114,0.000013274}, {115,0.000026549}, {116,0.000017699}, {117,0.000013274}, {118,0.000017699}, {119,0.000013274}, {120,0.000017699}, {121,0.000115044}, {122,0.000017699}, {123,0.000176991}, {124,0.000013274}, {125,0.000066372}, {126,0.000035398}, {127,0.000053097}, {128,0.000030973}, {129,0.000017699}, {130,0.000044248}, {131,0.000066372}, {132,0.000070796}, {133,0.000000000}, {134,0.000017699}, {135,0.000017699}, {136,0.000088496}, {137,0.000035398}, {138,0.000000000}, {139,0.000053097}, {140,0.000000000}, {141,0.000097345}, {142,0.000119469}, {143,0.000035398}, {144,0.000017699}, {145,0.000070796}, {146,0.000088496}, {147,0.000030973}, {148,0.000106195}, {149,0.000000000}, {150,0.000106195}, {151,0.000079646}, {152,0.000017699}, {153,0.000017699}, {154,0.000190265}, {155,0.000048673}, {156,0.000084071}, {157,0.000097345}, {158,0.000053097}, {159,0.000000000}, {160,0.000088496}, {161,0.000053097}, {162,0.000000000}, {163,0.000070796}, {164,0.000084071}, {165,0.000017699}, {166,0.000044248}, {167,0.000106195}, {168,0.000035398}, {169,0.000053097}, {170,0.000030973}, {171,0.000101770}, {172,0.000137168}, {173,0.000000000}, {174,0.000066372}, {175,0.000000000}, {176,0.000243363}, {177,0.000097345}, {178,0.000066372}, {179,0.000053097}, {180,0.000030973}, {181,0.000115044}, {182,0.000146018}, {183,0.000119469}, {184,0.000000000}, {185,0.000066372}, {186,0.000048673}, {187,0.000119469}, {188,0.000176991}, {189,0.000035398}, {190,0.000132743}, {191,0.000035398}, {192,0.000017699}, {193,0.000000000}, {194,0.000061947}, {195,0.000154867}, {196,0.000088496}, {197,0.000084071}, {198,0.000030973}, {199,0.000061947}, {200,0.000101770}, {201,0.000088496}, {202,0.000221239}, {203,0.000190265}, {204,0.000194690}, {205,0.000185841}, {206,0.000137168}, {207,0.000119469}, {208,0.000185841}, {209,0.000017699}, {210,0.000035398}, {211,0.000115044}, {212,0.000013274}, {213,0.000088496}, {214,0.000106195}, {215,0.000061947}, {216,0.000070796}, {217,0.000070796}, {218,0.000035398}, {219,0.000066372}, {220,0.000296460}, {221,0.000066372}, {222,0.000030973}, {223,0.000070796}, {224,0.000070796}, {225,0.000017699}, {226,0.000048673}, {227,0.000066372}, {228,0.000017699}, {229,0.000176991}, {230,0.000221239}, {231,0.000088496}, {232,0.000119469}, {233,0.000106195}, {234,0.000632743}, {235,0.000269912}, {236,0.000185841}, {237,0.000207965}, {238,0.000185841}, {239,0.000061947}, {240,0.000017699}, {241,0.000101770}, {242,0.001013274}, {243,0.000199115}, {244,0.000340708}, {245,0.000176991}, {246,0.000106195}, {247,0.000070796}, {248,0.000128319}, {249,0.000141593}, {250,0.000119469}, {251,0.000278761}, {252,0.000137168}, {253,0.000053097}, {254,0.000265487}, {255,0.000384956}, {256,0.000207965}, {257,0.000154867}, {258,0.000154867}, {259,0.000053097}, {260,0.000185841}, {261,0.000154867}, {262,0.000349558}, {263,0.000203540}, {264,0.000084071}, {265,0.000141593}, {266,0.000194690}, {267,0.000243363}, {268,0.000296460}, {269,0.000172566}, {270,0.000176991}, {271,0.000464602}, {272,0.000234513}, {273,0.000000000}, {274,0.000269912}, {275,0.000473451}, {276,0.000300885}, {277,0.000000000}, {278,0.000274336}, {279,0.000110619}, {280,0.000159292}, {281,0.000066372}, {282,0.000194690}, {283,0.000172566}, {284,0.000287611}, {285,0.000473451}, {286,0.000190265}, {287,0.000345133}, {288,0.000283186}, {289,0.000101770}, {290,0.000238938}, {291,0.000446903}, {292,0.000252212}, {293,0.000194690}, {294,0.000482301}, {295,0.000132743}, {296,0.000137168}, {297,0.000349558}, {298,0.000274336}, {299,0.000455752}, {300,0.000084071}, {301,0.000327434}, {302,0.000203540}, {303,0.000287611}, {304,0.000278761}, {305,0.000296460}, {306,0.000469027}, {307,0.000212389}, {308,0.000300885}, {309,0.000283186}, {310,0.000199115}, {311,0.000247788}, {312,0.000331858}, {313,0.000296460}, {314,0.000199115}, {315,0.000185841}, {316,0.000092920}, {317,0.000119469}, {318,0.000123894}, {319,0.000234513}, {320,0.000185841}, {321,0.000088496}, {322,0.000035398}, {323,0.000110619}, {324,0.000084071}, {325,0.000070796}, {326,0.000261062}, {327,0.000123894}, {328,0.000017699}, {329,0.000017699}, {330,0.000000000}, {331,0.000017699}, {332,0.000141593}, {333,0.000048673}, {334,0.000084071}, {335,0.000115044}, {336,0.000030973}, {337,0.000048673}, {338,0.000137168}, {339,0.000168142}, {340,0.000088496}, {341,0.000176991}, {342,0.000172566}, {343,0.000154867}, {344,0.000123894}, {345,0.000110619}, {346,0.000088496}, {347,0.000137168}, {348,0.000070796}, {349,0.001327434}, {350,0.000141593}, {351,0.000150442}, {352,0.000176991}, {353,0.000207965}, {354,0.000132743}, {355,0.000150442}, {356,0.000092920}, {357,0.000176991}, {358,0.000172566}, {359,0.000230088}, {360,0.000115044}, {361,0.000176991}, {362,0.000190265}, {363,0.000141593}, {364,0.000300885}, {365,0.000221239}, {366,0.000367257}, {367,0.000300885}, {368,0.000327434}, {369,0.000154867}, {370,0.000039823}, {371,0.000017699}, {372,0.000088496}, {373,0.000017699}, {374,0.000048673}, {375,0.000013274}, {376,0.000000000}, {377,0.000048673}, {378,0.000070796}, {379,0.000017699}, {380,0.000017699}, {381,0.000030973}, {382,0.000035398}, {383,0.000017699}, {384,0.000035398}, {385,0.000035398}, {386,0.000035398}, {387,0.000048673}, {388,0.000035398}, {389,0.000017699}, {390,0.000017699}, {391,0.000030973}, {392,0.000017699}, {393,0.000030973}, {394,0.000017699}, {395,0.000101770}, {396,0.000017699}, {397,0.000070796}, {398,0.000044248}, {399,0.000084071}, {400,0.000017699}, {401,0.000066372}, {402,0.000035398}, {403,0.000030973}, {404,0.000017699}, {405,0.000783186}, {406,0.000314159}, {407,0.000469027}, {408,0.000123894}, {409,0.000106195}, {410,0.000070796}, {411,0.000061947}, {412,0.000101770}, {413,0.000101770}, {414,0.000115044}, {415,0.000172566}, {416,0.000115044}, {417,0.000070796}, {418,0.000000000}, {419,0.000017699}, {420,0.000000000}, {421,0.000088496}, {422,0.000088496}, {423,0.000017699}, {424,0.000017699}, {425,0.000084071}, {426,0.000053097}, {427,0.000017699}, {428,0.000017699}, {429,0.000044248}, {430,0.000035398}, {431,0.000070796}, {432,0.000084071}, {433,0.000070796}, {434,0.000088496}, {435,0.000017699}, {436,0.000048673}, {437,0.000066372}, {438,0.000088496}, {439,0.000097345}, {440,0.000092920}, {441,0.000017699}, {442,0.000097345}, {443,0.000101770}, {444,0.000088496}, {445,0.000066372}, {446,0.000013274}, {447,0.000035398}, {448,0.000088496}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000030973}, {453,0.000084071}, {454,0.000030973}, {455,0.000000000}, {456,0.000066372}, {457,0.000030973}, {458,0.000017699}, {459,0.000035398}, {460,0.000048673}, {461,0.000035398}, {462,0.000035398}, {463,0.000075221}, {464,0.000097345}, {465,0.000070796}, {466,0.000030973}, {467,0.000084071}, {468,0.000035398}, {469,0.000017699}, {470,0.000000000}, {471,0.000030973}, {472,0.000017699}, {473,0.000030973}, {474,0.000053097}, {475,0.000017699}, {476,0.000048673}, {477,0.000013274}, {478,0.000035398}, {479,0.000000000}, {480,0.000000000}, {481,0.000154867}, {482,0.000274336}, {483,0.000318584}, {484,0.000123894}, {485,0.000106195}, {486,0.000190265}, {487,0.000345133}, {488,0.000053097}, {489,0.000176991}, {490,0.000066372}, {491,0.000084071}, {492,0.000137168}, {493,0.000106195}, {494,0.000101770}, {495,0.000035398}, {496,0.000070796}, {497,0.000101770}, {498,0.000070796}, {499,0.000106195}, {500,0.000088496}, {505,0.000123894}, {510,0.000035398}, {515,0.000101770}, {520,0.000061947}, {525,0.000084071}, {530,0.000030973}, {535,0.000035398}, {540,0.000035398}, {545,0.000017699}, {550,0.000053097}, {555,0.000070796}, {560,0.000030973}, {565,0.000035398}, {570,0.000088496}, {575,0.000035398}, {580,0.000017699}, {585,0.000066372}, {590,0.000137168}, {595,0.000137168}, {600,0.000176991}, {605,0.000172566}, {610,0.000181416}, {615,0.000123894}, {620,0.000084071}, {625,0.000070796}, {630,0.000088496}, {635,0.000106195}, {640,0.000123894}, {645,0.000084071}, {650,0.000053097}, {655,0.000088496}, {660,0.000053097}, {665,0.000017699}, {670,0.000000000}, {675,0.000017699}, {680,0.000048673}, {685,0.000000000}, {690,0.000035398}, {695,0.000000000}, {700,0.000061947}, {705,0.000000000}, {710,0.000141593}, {715,0.000017699}, {720,0.000000000}, {725,0.000017699}, {730,0.000048673}, {735,0.000000000}, {740,0.000017699}, {745,0.000000000}, {750,0.000053097}, {755,0.000000000}, {760,0.000000000}, {765,0.000066372}, {770,0.000035398}, {775,0.000000000}, {780,0.000017699}, {785,0.000035398}, {790,0.000053097}, {795,0.000101770}, {800,0.000000000}, {805,0.000053097}, {810,0.000000000}, {815,0.000053097}, {820,0.000000000}, {825,0.000017699}, {830,0.000017699}, {835,0.000035398}, {840,0.000017699}, {845,0.000030973}, {850,0.000048673}, {855,0.000035398}, {860,0.000053097}, {865,0.000061947}, {870,0.000053097}, {875,0.000070796}, {880,0.000070796}, {885,0.000017699}, {890,0.000053097}, {895,0.000035398}, {900,0.000017699}, {905,0.000035398}, {910,0.000013274}, {915,0.000035398}, {920,0.000048673}, {925,0.000048673}, {930,0.000017699}, {935,0.000035398}, {940,0.000035398}, {945,0.000000000}, {950,0.000013274}, {955,0.000035398}, {960,0.000066372}, {965,0.000017699}, {970,0.000066372}, {975,0.000123894}, {980,0.000070796}, {985,0.000106195}, {990,0.000053097}, {995,0.000053097}, {1000,0.000066372}, {1010,0.000053097}, {1020,0.000115044}, {1030,0.000106195}, {1040,0.000070796}, {1050,0.000017699}, {1060,0.000048673}, {1070,0.000048673}, {1080,0.000053097}, {1090,0.000035398}, {1100,0.000053097}, {1110,0.000070796}, {1120,0.000053097}, {1130,0.000017699}, {1140,0.000070796}, {1150,0.000119469}, {1160,0.000000000}, {1170,0.000101770}, {1180,0.000035398}, {1190,0.000053097}, {1200,0.000017699}, {1210,0.000017699}, {1220,0.000070796}, {1230,0.000088496}, {1240,0.000053097}, {1250,0.000092920}, {1260,0.000141593}, {1270,0.000030973}, {1280,0.000017699}, {1290,0.000017699}, {1300,0.000053097}, {1310,0.000101770}, {1320,0.000053097}, {1330,0.000066372}, {1340,0.000084071}, {1350,0.000106195}, {1360,0.000115044}, {1370,0.000084071}, {1380,0.000362832}, {1390,0.001300885}, {1400,0.001522124}, {1410,0.000331858}, {1420,0.000066372}, {1430,0.000017699}, {1440,0.000035398}, {1450,0.000013274}, {1460,0.000070796}, {1470,0.000115044}, {1480,0.000070796}, {1490,0.000000000}, {1500,0.000035398}, {1510,0.000066372}, {1520,0.000070796}, {1530,0.000053097}, {1540,0.000106195}, {1550,0.000066372}, {1560,0.000048673}, {1570,0.000106195}, {1580,0.000000000}, {1590,0.000084071}, {1600,0.000035398}, {1610,0.000066372}, {1620,0.000101770}, {1630,0.000017699}, {1640,0.000070796}, {1650,0.000066372}, {1660,0.000084071}, {1670,0.000101770}, {1680,0.000000000}, {1690,0.000053097}, {1700,0.000053097}, {1710,0.000119469}, {1720,0.000088496}, {1730,0.000123894}, {1740,0.000066372}, {1750,0.000088496}, {1760,0.000088496}, {1770,0.000123894}, {1780,0.000123894}, {1790,0.000119469}, {1800,0.000159292}, {1810,0.000154867}, {1820,0.000141593}, {1830,0.000123894}, {1840,0.000070796}, {1850,0.000106195}, {1860,0.000048673}, {1870,0.000088496}, {1880,0.000017699}, {1890,0.000101770}, {1900,0.000088496}, {1910,0.000119469}, {1920,0.000035398}, {1930,0.000017699}, {1940,0.000084071}, {1950,0.000101770}, {1960,0.000053097}, {1970,0.000070796}, {1980,0.000070796}, {1990,0.000088496}, {2000,0.000030973}, {2050,0.000137168}, {2100,0.000106195}, {2150,0.000172566}, {2200,0.000048673}, {2250,0.000141593}, {2300,0.000097345}, {2350,0.000150442}, {2400,0.000053097}, {2450,0.000053097}, {2500,0.000017699}, {2550,0.000150442}, {2600,0.000141593}, {2650,0.000159292}, {2700,0.000137168}, {2750,0.000101770}, {2800,0.000159292}, {2850,0.000371681}, {2900,0.000491150}, {2950,0.000362832}, {3000,0.000101770}, {3050,0.000504425}, {3100,0.001194690}, {3150,0.000699115}, {3200,0.000017699}, {3250,0.000207965}, {3300,0.001146018}, {3350,0.001659292}, {3400,0.000597345}, {3450,0.000256637}, {3500,0.000159292}, {3550,0.000261062}, {3600,0.000628319}, {3650,0.001092920}, {3700,0.000212389}, {3750,0.000575221}, {3800,0.000154867}, {3850,0.000831858}, {3900,0.000367257}, {3950,0.001287611}, {4000,0.000433628}, {4050,0.000176991}, {4100,0.000867257}, {4150,0.000168142}, {4200,0.000504425}, {4250,0.000185841}, {4300,0.000199115}, {4350,0.000438053}, {4400,0.000225664}, {4450,0.000243363}, {4500,0.000212389}, {4550,0.000889381}, {4600,0.004287611}, {4650,0.000601770}, {4700,0.000327434}, {4750,0.000176991}, {4800,0.000207965}, {4850,0.003508850}, {4900,0.000495575}, {4950,0.000296460}, {5000,0.000230088}, {5050,0.000176991}, {5100,0.001008850}, {5150,0.000265487}, {5200,0.000207965}, {5250,0.000933333}, {5300,0.001057778}, {5350,0.005000000}, {5400,0.000657778}, {5450,0.000231111}, {5500,0.001640000}, {5550,0.003520000}, {5600,0.001142222}, {5650,0.000244444}, {5700,0.000173333}, {5750,0.000168889}, {5800,0.000306667}, {5850,0.000297778}, {5900,0.000515556}, {5950,0.000440000}, {6000,0.000191111}, {6050,0.004556}, {6100,0.014944}, {6150,0.010611}, {6200,0.000000}, {6250,0.003778}, {6300,0.000444}, {6350,0.000222}, {6400,0.000000}, {6450,0.000667}, {6500,0.002556}, {6550,0.002889}, {6600,0.000222}, {6650,0.000000}, {6700,0.001444}, {6750,0.000667}, {6800,0.000000}, {6850,0.000222}, {6900,0.000444}, {6950,0.000778}, {7000,0.000000}, {7050,0.002222}, {7100,0.000000}, {7150,0.000444}, {7200,0.000667}, {7250,0.001333}, {7300,0.003667}, {7350,0.000000}, {7400,0.000444}, {7450,0.000444}, {7500,0.000444}, {7550,0.000222}, {7600,0.000222}, {7650,0.000389}, {7700,0.000444}, {7750,0.000000}, {7800,0.000000}, {7850,0.000222}, {7900,0.000444}, {7950,0.000667}, {8000,0.000889}, {8050,0.000222}, {8100,0.000000}, {8150,0.000444}, {8200,0.000444}, {8250,0.000222}, {8300,0.000000}, {8350,0.001000}, {8400,0.001333}, {8450,0.000222}, {8500,0.000000}, {8550,0.000222}, {8600,0.000000}, {8650,0.000222}, {8700,0.000444}, {8750,0.000444}, {8800,0.000833}, {8850,0.000222}, {8900,0.001111}, {8950,0.000667}, {9000,0.000667}, {9050,0.000222}, {9100,0.000611}, {9150,0.000389}, {9200,0.000444}, {9250,0.000444}, {9300,0.000000}, {9350,0.000444}, {9400,0.000222}, {9450,0.000222}, {9500,0.000444}, {9550,0.000222}, {9600,0.000611}, {9650,0.000000}, {9700,0.000667}, {9750,0.000000}, {9800,0.000222}, {9850,0.000444}, {9900,0.001278}, {9950,0.000000}, {10000,0.000444}, {10100,0.001722}, {10200,0.001333}, {10300,0.000667}, {10400,0.000444}, {10500,0.000444}, {10600,0.000222}, {10700,0.000667}, {10800,0.000000}, {10900,0.000667}, {11000,0.000833}, {11100,0.000611}, {11200,0.000444}, {11300,0.001222}, {11400,0.000000}, {11500,0.000444}, {11600,0.000444}, {11700,0.000389}, {11800,0.000889}, {11900,0.000611}, {12000,0.000667}, {12100,0.001056}, {12200,0.000000}, {12300,0.001778}, {12400,0.001778}, {12500,0.001500}, {12600,0.000889}, {12700,0.000444}, {12800,0.000222}, {12900,0.000222}, {13000,0.001500}, {13100,0.000667}, {13200,0.000222}, {13300,0.000667}, {13400,0.006556}, {13500,0.001111}, {13600,0.000889}, {13700,0.001778}, {13800,0.001556}, {13900,0.008000}, {14000,0.006111}, {14100,0.000611}, {14200,0.002889}, {14300,0.001944}, {14400,0.000889}, {14500,0.001111}, {14600,0.005556}, {14700,0.003056}, {14800,0.001111}, {14900,0.000333}, {15000,0.002389}, {15100,0.006667}, {15200,0.000889}, {15300,0.003500}, {15400,0.004167}, {15500,0.001722}, {15600,0.001778}, {15700,0.004667}, {15800,0.002444}, {15900,0.004722}, {16000,0.002889}, {16100,0.000889}, {16200,0.000222}, {16300,0.000667}, {16400,0.000833}, {16500,0.004000}, {16600,0.003556}, {16700,0.003722}, {16800,0.001944}, {16900,0.001111}, {17000,0.003111}, {17100,0.004556}, {17200,0.002611}, {17300,0.003111}, {17400,0.000889}, {17500,0.004778}, {17600,0.005944}, {17700,0.001944}, {17800,0.001944}, {17900,0.007278}, {18000,0.020778}, {18100,0.003111}, {18200,0.001778}, {18300,0.006833}, {18400,0.004222}, {18500,0.003500}, {18600,0.003000}, {18700,0.002444}, {18800,0.009889}, {18900,0.004611}, {19000,0.003556}, {19100,0.001722}, {19200,0.000444}, {19300,0.000889}, {19400,0.007889}, {19500,0.002111}, {19600,0.003278}, {19700,0.031222}, {19800,0.002222}, {19900,0.003722}, {20000,0.003250}};
data["big_flat"]["TypeClasses"]["cbv"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000008850}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000893805}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000008850}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.001455752}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000004425}, {257,0.000000000}, {258,0.001800885}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000141593}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.001358407}, {320,0.000000000}, {321,0.000022124}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000044248}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000048673}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000004425}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000048673}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000004425}, {412,0.000000000}, {413,0.000000000}, {414,0.000035398}, {415,0.000017699}, {416,0.000004425}, {417,0.000000000}, {418,0.000004425}, {419,0.000008850}, {420,0.000004425}, {421,0.002907080}, {422,0.000004425}, {423,0.000004425}, {424,0.000000000}, {425,0.000004425}, {426,0.000000000}, {427,0.000004425}, {428,0.000008850}, {429,0.000022124}, {430,0.000017699}, {431,0.000017699}, {432,0.000026549}, {433,0.000044248}, {434,0.000066372}, {435,0.000070796}, {436,0.000088496}, {437,0.000106195}, {438,0.000110619}, {439,0.000150442}, {440,0.000172566}, {441,0.000207965}, {442,0.000238938}, {443,0.000292035}, {444,0.000283186}, {445,0.000314159}, {446,0.000323009}, {447,0.000345133}, {448,0.000358407}, {449,0.000371681}, {450,0.000402655}, {451,0.000407080}, {452,0.000402655}, {453,0.000411504}, {454,0.000442478}, {455,0.000469027}, {456,0.000424779}, {457,0.000486726}, {458,0.000433628}, {459,0.000482301}, {460,0.000477876}, {461,0.000504425}, {462,0.000469027}, {463,0.000513274}, {464,0.000623894}, {465,0.000637168}, {466,0.000637168}, {467,0.000646018}, {468,0.002464602}, {469,0.000690265}, {470,0.000676991}, {471,0.000676991}, {472,0.000769912}, {473,0.000703540}, {474,0.000743363}, {475,0.000792035}, {476,0.000743363}, {477,0.000716814}, {478,0.000792035}, {479,0.000778761}, {480,0.001774336}, {481,0.000796460}, {482,0.000796460}, {483,0.000845133}, {484,0.000800885}, {485,0.000836283}, {486,0.000871681}, {487,0.000876106}, {488,0.000862832}, {489,0.000898230}, {490,0.000915929}, {491,0.002252212}, {492,0.000898230}, {493,0.000915929}, {494,0.000938053}, {495,0.000942478}, {496,0.000969027}, {497,0.000938053}, {498,0.001000000}, {499,0.000938053}, {500,0.000960177}, {505,0.000964602}, {510,0.000995575}, {515,0.001000000}, {520,0.001000000}, {525,0.001000000}, {530,0.001000000}, {535,0.001000000}, {540,0.001000000}, {545,0.001000000}, {550,0.001000000}, {555,0.001000000}, {560,0.001008850}, {565,0.001000000}, {570,0.001000000}, {575,0.001000000}, {580,0.001017699}, {585,0.001000000}, {590,0.001000000}, {595,0.001000000}, {600,0.001000000}, {605,0.001000000}, {610,0.001000000}, {615,0.001004425}, {620,0.001004425}, {625,0.001000000}, {630,0.001000000}, {635,0.001000000}, {640,0.001000000}, {645,0.001044248}, {650,0.001000000}, {655,0.001000000}, {660,0.001000000}, {665,0.001008850}, {670,0.001000000}, {675,0.001000000}, {680,0.001000000}, {685,0.001035398}, {690,0.001000000}, {695,0.001000000}, {700,0.001000000}, {705,0.001000000}, {710,0.001000000}, {715,0.001000000}, {720,0.001000000}, {725,0.001000000}, {730,0.001000000}, {735,0.001000000}, {740,0.001000000}, {745,0.001000000}, {750,0.001000000}, {755,0.001097345}, {760,0.001000000}, {765,0.001000000}, {770,0.001008850}, {775,0.001079646}, {780,0.001000000}, {785,0.001075221}, {790,0.001000000}, {795,0.001000000}, {800,0.001000000}, {805,0.001075221}, {810,0.001000000}, {815,0.001000000}, {820,0.001004425}, {825,0.001000000}, {830,0.001000000}, {835,0.001004425}, {840,0.001026549}, {845,0.006650442}, {850,0.001044248}, {855,0.004646018}, {860,0.001146018}, {865,0.001163717}, {870,0.001238938}, {875,0.001323009}, {880,0.001393805}, {885,0.001380531}, {890,0.001407080}, {895,0.001415929}, {900,0.001442478}, {905,0.001438053}, {910,0.001831858}, {915,0.001473451}, {920,0.001486726}, {925,0.001553097}, {930,0.001606195}, {935,0.002061947}, {940,0.001712389}, {945,0.001778761}, {950,0.001858407}, {955,0.001818584}, {960,0.001836283}, {965,0.001871681}, {970,0.001898230}, {975,0.001907080}, {980,0.001911504}, {985,0.001933628}, {990,0.001946903}, {995,0.001969027}, {1000,0.001986726}, {1010,0.001986726}, {1020,0.001977876}, {1030,0.001995575}, {1040,0.007185841}, {1050,0.002000000}, {1060,0.002004425}, {1070,0.002000000}, {1080,0.002000000}, {1090,0.002000000}, {1100,0.002000000}, {1110,0.002000000}, {1120,0.002000000}, {1130,0.002000000}, {1140,0.002000000}, {1150,0.002000000}, {1160,0.002000000}, {1170,0.002000000}, {1180,0.002000000}, {1190,0.002000000}, {1200,0.002000000}, {1210,0.002000000}, {1220,0.002004425}, {1230,0.002004425}, {1240,0.002000000}, {1250,0.002022124}, {1260,0.002070796}, {1270,0.002172566}, {1280,0.002185841}, {1290,0.002287611}, {1300,0.002398230}, {1310,0.002420354}, {1320,0.002433628}, {1330,0.002446903}, {1340,0.002464602}, {1350,0.002491150}, {1360,0.002513274}, {1370,0.002526549}, {1380,0.002601770}, {1390,0.002641593}, {1400,0.002659292}, {1410,0.002752212}, {1420,0.008181416}, {1430,0.002862832}, {1440,0.002845133}, {1450,0.002915929}, {1460,0.002915929}, {1470,0.002924779}, {1480,0.003053097}, {1490,0.008389381}, {1500,0.003057522}, {1510,0.003000000}, {1520,0.003000000}, {1530,0.003101770}, {1540,0.002995575}, {1550,0.003000000}, {1560,0.003000000}, {1570,0.003000000}, {1580,0.003000000}, {1590,0.003000000}, {1600,0.003004425}, {1610,0.003004425}, {1620,0.007000000}, {1630,0.003061947}, {1640,0.003022124}, {1650,0.003035398}, {1660,0.003053097}, {1670,0.003119469}, {1680,0.003199115}, {1690,0.003225664}, {1700,0.003323009}, {1710,0.003336283}, {1720,0.003384956}, {1730,0.003415929}, {1740,0.003429204}, {1750,0.003429204}, {1760,0.003446903}, {1770,0.003460177}, {1780,0.003553097}, {1790,0.003491150}, {1800,0.003517699}, {1810,0.003517699}, {1820,0.003566372}, {1830,0.003557522}, {1840,0.003592920}, {1850,0.003986726}, {1860,0.003694690}, {1870,0.003765487}, {1880,0.003774336}, {1890,0.004141593}, {1900,0.003778761}, {1910,0.003884956}, {1920,0.003893805}, {1930,0.007380531}, {1940,0.003831858}, {1950,0.003942478}, {1960,0.004022124}, {1970,0.003955752}, {1980,0.003973451}, {1990,0.003995575}, {2000,0.004022124}, {2050,0.004168142}, {2100,0.004362832}, {2150,0.004424779}, {2200,0.004500000}, {2250,0.004535398}, {2300,0.010039823}, {2350,0.004761062}, {2400,0.010787611}, {2450,0.005247788}, {2500,0.005398230}, {2550,0.012283186}, {2600,0.005491150}, {2650,0.005500000}, {2700,0.005588496}, {2750,0.005699115}, {2800,0.005942478}, {2850,0.006150442}, {2900,0.010336283}, {2950,0.013615044}, {3000,0.006482301}, {3050,0.013473451}, {3100,0.006716814}, {3150,0.012203540}, {3200,0.007035398}, {3250,0.007146018}, {3300,0.007287611}, {3350,0.007402655}, {3400,0.015305310}, {3450,0.007681416}, {3500,0.007628319}, {3550,0.007725664}, {3600,0.019030973}, {3650,0.011964602}, {3700,0.008243363}, {3750,0.008685841}, {3800,0.008592920}, {3850,0.008584071}, {3900,0.019070796}, {3950,0.008871681}, {4000,0.008955752}, {4050,0.009061947}, {4100,0.014336283}, {4150,0.013898230}, {4200,0.009482301}, {4250,0.009570796}, {4300,0.016287611}, {4350,0.009845133}, {4400,0.009973451}, {4450,0.010079646}, {4500,0.010216814}, {4550,0.010353982}, {4600,0.010495575}, {4650,0.015924779}, {4700,0.010769912}, {4750,0.011451327}, {4800,0.010977876}, {4850,0.017535398}, {4900,0.019225664}, {4950,0.011469027}, {5000,0.011632743}, {5050,0.011707965}, {5100,0.011783186}, {5150,0.015026549}, {5200,0.017287611}, {5250,0.012146667}, {5300,0.012133333}, {5350,0.012408889}, {5400,0.012648889}, {5450,0.012857778}, {5500,0.015911111}, {5550,0.021617778}, {5600,0.013542222}, {5650,0.019373333}, {5700,0.013297778}, {5750,0.013448889}, {5800,0.019684444}, {5850,0.013737778}, {5900,0.018217778}, {5950,0.014377778}, {6000,0.014137778}, {6050,0.021556}, {6100,0.014389}, {6150,0.013889}, {6200,0.026333}, {6250,0.014611}, {6300,0.021722}, {6350,0.014667}, {6400,0.014722}, {6450,0.014778}, {6500,0.014833}, {6550,0.017944}, {6600,0.016000}, {6650,0.026278}, {6700,0.027833}, {6750,0.020944}, {6800,0.015722}, {6850,0.020500}, {6900,0.020611}, {6950,0.015944}, {7000,0.016167}, {7050,0.034611}, {7100,0.024889}, {7150,0.016722}, {7200,0.022500}, {7250,0.016889}, {7300,0.020778}, {7350,0.017056}, {7400,0.017056}, {7450,0.017500}, {7500,0.017667}, {7550,0.017722}, {7600,0.017944}, {7650,0.017944}, {7700,0.021056}, {7750,0.021889}, {7800,0.018222}, {7850,0.020833}, {7900,0.018722}, {7950,0.018722}, {8000,0.022278}, {8050,0.019833}, {8100,0.018944}, {8150,0.021333}, {8200,0.032389}, {8250,0.019111}, {8300,0.019500}, {8350,0.027333}, {8400,0.023444}, {8450,0.019722}, {8500,0.028444}, {8550,0.021000}, {8600,0.030667}, {8650,0.044833}, {8700,0.020222}, {8750,0.022444}, {8800,0.021000}, {8850,0.028944}, {8900,0.040778}, {8950,0.021111}, {9000,0.021389}, {9050,0.048000}, {9100,0.034722}, {9150,0.039611}, {9200,0.022056}, {9250,0.022000}, {9300,0.022167}, {9350,0.023833}, {9400,0.044444}, {9450,0.033500}, {9500,0.023167}, {9550,0.022833}, {9600,0.023056}, {9650,0.027167}, {9700,0.023111}, {9750,0.023167}, {9800,0.024556}, {9850,0.023722}, {9900,0.023722}, {9950,0.023833}, {10000,0.043278}, {10100,0.024111}, {10200,0.025389}, {10300,0.024778}, {10400,0.025611}, {10500,0.042056}, {10600,0.032611}, {10700,0.035722}, {10800,0.032333}, {10900,0.035111}, {11000,0.026389}, {11100,0.026889}, {11200,0.026944}, {11300,0.048833}, {11400,0.028833}, {11500,0.028000}, {11600,0.033833}, {11700,0.047278}, {11800,0.029833}, {11900,0.028833}, {12000,0.049222}, {12100,0.032778}, {12200,0.031167}, {12300,0.030944}, {12400,0.030222}, {12500,0.034889}, {12600,0.034444}, {12700,0.038222}, {12800,0.048444}, {12900,0.043111}, {13000,0.031833}, {13100,0.033944}, {13200,0.058333}, {13300,0.039389}, {13400,0.042500}, {13500,0.055278}, {13600,0.056500}, {13700,0.052611}, {13800,0.034000}, {13900,0.036500}, {14000,0.034778}, {14100,0.034611}, {14200,0.069389}, {14300,0.061722}, {14400,0.049333}, {14500,0.043278}, {14600,0.036278}, {14700,0.044111}, {14800,0.058444}, {14900,0.036833}, {15000,0.048444}, {15100,0.065167}, {15200,0.047278}, {15300,0.038944}, {15400,0.043556}, {15500,0.048667}, {15600,0.060667}, {15700,0.041778}, {15800,0.065833}, {15900,0.040611}, {16000,0.059278}, {16100,0.065833}, {16200,0.046778}, {16300,0.079778}, {16400,0.057889}, {16500,0.069222}, {16600,0.049778}, {16700,0.041889}, {16800,0.070222}, {16900,0.070611}, {17000,0.043389}, {17100,0.043000}, {17200,0.079167}, {17300,0.077111}, {17400,0.056944}, {17500,0.064667}, {17600,0.069500}, {17700,0.073778}, {17800,0.076611}, {17900,0.079222}, {18000,0.078944}, {18100,0.078167}, {18200,0.047667}, {18300,0.074278}, {18400,0.053056}, {18500,0.058389}, {18600,0.084056}, {18700,0.065500}, {18800,0.085111}, {18900,0.092667}, {19000,0.056500}, {19100,0.051056}, {19200,0.071333}, {19300,0.062722}, {19400,0.088222}, {19500,0.088222}, {19600,0.084167}, {19700,0.051889}, {19800,0.078500}, {19900,0.065889}, {20000,0.071875}};
data["big_flat"]["TypeClasses"]["cbv"]["user"] = {{1,0.000017699}, {2,0.000030973}, {3,0.000013274}, {4,0.000066372}, {5,0.000044248}, {6,0.000017699}, {7,0.000017699}, {8,0.000044248}, {9,0.000079646}, {10,0.000026549}, {11,0.000030973}, {12,0.000048673}, {13,0.000070796}, {14,0.000075221}, {15,0.000030973}, {16,0.000079646}, {17,0.000030973}, {18,0.000048673}, {19,0.000048673}, {20,0.000079646}, {21,0.000030973}, {22,0.000048673}, {23,0.000110619}, {24,0.000061947}, {25,0.000101770}, {26,0.000115044}, {27,0.000048673}, {28,0.000106195}, {29,0.000079646}, {30,0.000092920}, {31,0.000084071}, {32,0.000115044}, {33,0.000057522}, {34,0.000061947}, {35,0.000146018}, {36,0.000092920}, {37,0.000084071}, {38,0.000146018}, {39,0.000061947}, {40,0.000044248}, {41,0.000079646}, {42,0.000176991}, {43,0.000097345}, {44,0.000115044}, {45,0.000066372}, {46,0.000110619}, {47,0.000044248}, {48,0.000097345}, {49,0.000115044}, {50,0.000115044}, {51,0.000168142}, {52,0.000075221}, {53,0.000141593}, {54,0.000132743}, {55,0.000092920}, {56,0.000141593}, {57,0.000123894}, {58,0.000163717}, {59,0.000092920}, {60,0.000123894}, {61,0.000194690}, {62,0.000115044}, {63,0.000154867}, {64,0.000190265}, {65,0.000088496}, {66,0.000110619}, {67,0.000101770}, {68,0.000168142}, {69,0.000123894}, {70,0.000079646}, {71,0.000079646}, {72,0.000207965}, {73,0.000137168}, {74,0.000097345}, {75,0.000221239}, {76,0.000190265}, {77,0.000137168}, {78,0.000265487}, {79,0.000101770}, {80,0.000150442}, {81,0.000172566}, {82,0.000115044}, {83,0.000141593}, {84,0.000123894}, {85,0.000194690}, {86,0.000274336}, {87,0.000150442}, {88,0.000141593}, {89,0.000163717}, {90,0.000137168}, {91,0.000110619}, {92,0.000216814}, {93,0.000159292}, {94,0.000207965}, {95,0.000154867}, {96,0.000212389}, {97,0.000185841}, {98,0.000154867}, {99,0.000203540}, {100,0.000159292}, {101,0.000194690}, {102,0.000234513}, {103,0.000203540}, {104,0.000278761}, {105,0.000159292}, {106,0.000172566}, {107,0.000176991}, {108,0.000300885}, {109,0.000181416}, {110,0.000154867}, {111,0.000238938}, {112,0.000318584}, {113,0.000256637}, {114,0.000176991}, {115,0.000234513}, {116,0.000141593}, {117,0.000150442}, {118,0.000265487}, {119,0.000150442}, {120,0.000230088}, {121,0.000252212}, {122,0.000278761}, {123,0.000221239}, {124,0.000247788}, {125,0.000194690}, {126,0.000194690}, {127,0.000225664}, {128,0.000221239}, {129,0.000274336}, {130,0.000323009}, {131,0.000278761}, {132,0.000274336}, {133,0.000261062}, {134,0.000199115}, {135,0.000212389}, {136,0.000296460}, {137,0.000283186}, {138,0.000336283}, {139,0.000287611}, {140,0.000327434}, {141,0.000309735}, {142,0.000216814}, {143,0.000287611}, {144,0.000292035}, {145,0.000234513}, {146,0.000221239}, {147,0.000252212}, {148,0.000212389}, {149,0.000336283}, {150,0.000345133}, {151,0.000353982}, {152,0.000349558}, {153,0.000353982}, {154,0.000278761}, {155,0.000455752}, {156,0.000278761}, {157,0.000256637}, {158,0.000296460}, {159,0.000327434}, {160,0.000296460}, {161,0.000384956}, {162,0.000221239}, {163,0.000269912}, {164,0.000340708}, {165,0.000393805}, {166,0.000181416}, {167,0.000234513}, {168,0.000265487}, {169,0.000309735}, {170,0.000415929}, {171,0.000234513}, {172,0.000296460}, {173,0.000362832}, {174,0.000353982}, {175,0.001008850}, {176,0.000451327}, {177,0.000265487}, {178,0.000380531}, {179,0.000393805}, {180,0.000323009}, {181,0.000345133}, {182,0.000300885}, {183,0.000380531}, {184,0.000336283}, {185,0.000349558}, {186,0.000163717}, {187,0.000309735}, {188,0.000265487}, {189,0.000384956}, {190,0.000371681}, {191,0.000455752}, {192,0.000513274}, {193,0.000411504}, {194,0.000424779}, {195,0.000318584}, {196,0.000469027}, {197,0.000442478}, {198,0.000438053}, {199,0.000407080}, {200,0.000393805}, {201,0.000336283}, {202,0.000274336}, {203,0.000429204}, {204,0.000358407}, {205,0.000305310}, {206,0.000482301}, {207,0.000570796}, {208,0.000362832}, {209,0.000345133}, {210,0.000464602}, {211,0.000336283}, {212,0.000446903}, {213,0.000380531}, {214,0.000296460}, {215,0.000327434}, {216,0.000469027}, {217,0.000508850}, {218,0.000358407}, {219,0.000473451}, {220,0.000433628}, {221,0.000287611}, {222,0.000460177}, {223,0.000530973}, {224,0.000535398}, {225,0.000345133}, {226,0.000353982}, {227,0.000389381}, {228,0.000358407}, {229,0.000389381}, {230,0.000314159}, {231,0.000327434}, {232,0.000420354}, {233,0.000637168}, {234,0.000455752}, {235,0.000424779}, {236,0.000407080}, {237,0.000473451}, {238,0.000570796}, {239,0.000261062}, {240,0.000495575}, {241,0.000420354}, {242,0.000446903}, {243,0.000402655}, {244,0.000411504}, {245,0.001809735}, {246,0.000721239}, {247,0.000508850}, {248,0.000668142}, {249,0.000433628}, {250,0.000477876}, {251,0.000491150}, {252,0.000508850}, {253,0.000539823}, {254,0.000486726}, {255,0.000646018}, {256,0.000460177}, {257,0.000623894}, {258,0.002017699}, {259,0.000553097}, {260,0.000548673}, {261,0.000517699}, {262,0.000398230}, {263,0.000517699}, {264,0.000628319}, {265,0.000429204}, {266,0.000446903}, {267,0.000371681}, {268,0.000601770}, {269,0.000570796}, {270,0.000464602}, {271,0.000407080}, {272,0.000438053}, {273,0.000504425}, {274,0.000526549}, {275,0.000610619}, {276,0.000340708}, {277,0.000707965}, {278,0.000433628}, {279,0.000699115}, {280,0.000553097}, {281,0.000424779}, {282,0.000659292}, {283,0.000482301}, {284,0.000623894}, {285,0.000482301}, {286,0.000522124}, {287,0.000380531}, {288,0.000694690}, {289,0.000544248}, {290,0.000544248}, {291,0.000561947}, {292,0.000420354}, {293,0.000522124}, {294,0.000641593}, {295,0.000738938}, {296,0.000641593}, {297,0.000570796}, {298,0.000792035}, {299,0.000579646}, {300,0.000747788}, {301,0.000482301}, {302,0.000641593}, {303,0.000623894}, {304,0.000690265}, {305,0.000513274}, {306,0.000517699}, {307,0.000606195}, {308,0.000469027}, {309,0.000646018}, {310,0.000460177}, {311,0.000787611}, {312,0.000584071}, {313,0.000592920}, {314,0.000615044}, {315,0.000526549}, {316,0.000553097}, {317,0.000539823}, {318,0.000482301}, {319,0.001495575}, {320,0.000535398}, {321,0.000628319}, {322,0.000725664}, {323,0.000588496}, {324,0.000659292}, {325,0.000756637}, {326,0.000588496}, {327,0.000482301}, {328,0.000610619}, {329,0.000623894}, {330,0.000632743}, {331,0.000676991}, {332,0.000637168}, {333,0.000654867}, {334,0.000601770}, {335,0.000646018}, {336,0.000561947}, {337,0.000676991}, {338,0.000654867}, {339,0.000446903}, {340,0.000778761}, {341,0.000831858}, {342,0.000659292}, {343,0.000548673}, {344,0.000628319}, {345,0.000592920}, {346,0.000632743}, {347,0.000628319}, {348,0.000615044}, {349,0.000517699}, {350,0.000668142}, {351,0.000871681}, {352,0.000690265}, {353,0.000623894}, {354,0.000517699}, {355,0.000712389}, {356,0.000544248}, {357,0.000548673}, {358,0.000650442}, {359,0.000646018}, {360,0.000553097}, {361,0.000495575}, {362,0.000615044}, {363,0.000823009}, {364,0.000579646}, {365,0.000884956}, {366,0.000672566}, {367,0.000787611}, {368,0.000584071}, {369,0.000836283}, {370,0.000761062}, {371,0.000508850}, {372,0.000778761}, {373,0.000646018}, {374,0.000800885}, {375,0.000663717}, {376,0.000792035}, {377,0.000703540}, {378,0.000769912}, {379,0.000588496}, {380,0.000716814}, {381,0.000601770}, {382,0.000637168}, {383,0.000615044}, {384,0.000805310}, {385,0.000703540}, {386,0.000539823}, {387,0.000584071}, {388,0.000486726}, {389,0.000721239}, {390,0.000796460}, {391,0.000557522}, {392,0.000663717}, {393,0.000699115}, {394,0.000769912}, {395,0.000796460}, {396,0.000641593}, {397,0.000694690}, {398,0.000756637}, {399,0.000734513}, {400,0.000721239}, {401,0.000632743}, {402,0.000681416}, {403,0.000703540}, {404,0.000800885}, {405,0.000787611}, {406,0.000792035}, {407,0.000685841}, {408,0.000915929}, {409,0.000654867}, {410,0.000809735}, {411,0.000553097}, {412,0.000734513}, {413,0.000761062}, {414,0.000902655}, {415,0.000845133}, {416,0.000800885}, {417,0.000747788}, {418,0.000743363}, {419,0.000699115}, {420,0.000637168}, {421,0.003283186}, {422,0.000907080}, {423,0.000849558}, {424,0.000827434}, {425,0.000712389}, {426,0.000672566}, {427,0.000840708}, {428,0.000792035}, {429,0.000836283}, {430,0.000796460}, {431,0.000884956}, {432,0.000738938}, {433,0.000818584}, {434,0.000796460}, {435,0.000650442}, {436,0.000738938}, {437,0.000783186}, {438,0.000703540}, {439,0.000792035}, {440,0.000584071}, {441,0.000668142}, {442,0.000672566}, {443,0.000752212}, {444,0.000774336}, {445,0.000818584}, {446,0.000840708}, {447,0.000637168}, {448,0.000685841}, {449,0.000778761}, {450,0.000774336}, {451,0.000836283}, {452,0.000845133}, {453,0.000707965}, {454,0.000805310}, {455,0.000871681}, {456,0.000712389}, {457,0.000858407}, {458,0.000893805}, {459,0.000933628}, {460,0.000761062}, {461,0.000924779}, {462,0.001053097}, {463,0.000836283}, {464,0.001141593}, {465,0.000800885}, {466,0.000823009}, {467,0.000973451}, {468,0.002309735}, {469,0.000915929}, {470,0.000787611}, {471,0.000747788}, {472,0.000685841}, {473,0.000800885}, {474,0.000743363}, {475,0.001053097}, {476,0.000787611}, {477,0.000769912}, {478,0.000730088}, {479,0.000951327}, {480,0.001592920}, {481,0.000756637}, {482,0.000893805}, {483,0.000774336}, {484,0.000827434}, {485,0.000774336}, {486,0.000787611}, {487,0.000800885}, {488,0.000853982}, {489,0.000831858}, {490,0.000995575}, {491,0.002212389}, {492,0.000920354}, {493,0.000685841}, {494,0.001022124}, {495,0.000973451}, {496,0.000902655}, {497,0.000960177}, {498,0.000946903}, {499,0.000960177}, {500,0.001004425}, {505,0.000862832}, {510,0.000995575}, {515,0.000924779}, {520,0.000942478}, {525,0.000915929}, {530,0.001017699}, {535,0.001150442}, {540,0.001088496}, {545,0.000862832}, {550,0.001163717}, {555,0.000951327}, {560,0.001057522}, {565,0.001013274}, {570,0.001128319}, {575,0.001199115}, {580,0.001110619}, {585,0.000902655}, {590,0.001154867}, {595,0.001141593}, {600,0.001278761}, {605,0.001066372}, {610,0.001172566}, {615,0.001261062}, {620,0.001176991}, {625,0.001265487}, {630,0.001256637}, {635,0.001296460}, {640,0.001110619}, {645,0.001429204}, {650,0.001336283}, {655,0.001380531}, {660,0.001101770}, {665,0.001234513}, {670,0.001075221}, {675,0.001185841}, {680,0.001530973}, {685,0.001544248}, {690,0.001323009}, {695,0.001535398}, {700,0.001491150}, {705,0.001464602}, {710,0.001566372}, {715,0.001486726}, {720,0.001393805}, {725,0.001460177}, {730,0.001513274}, {735,0.001703540}, {740,0.001207965}, {745,0.001300885}, {750,0.001495575}, {755,0.001553097}, {760,0.001526549}, {765,0.001358407}, {770,0.001446903}, {775,0.001597345}, {780,0.001575221}, {785,0.001495575}, {790,0.001561947}, {795,0.001619469}, {800,0.001588496}, {805,0.001672566}, {810,0.001681416}, {815,0.001646018}, {820,0.001721239}, {825,0.001743363}, {830,0.001469027}, {835,0.001606195}, {840,0.001831858}, {845,0.007150442}, {850,0.001730088}, {855,0.005238938}, {860,0.001703540}, {865,0.001690265}, {870,0.001712389}, {875,0.001889381}, {880,0.001761062}, {885,0.001508850}, {890,0.001650442}, {895,0.001738938}, {900,0.001526549}, {905,0.001836283}, {910,0.002123894}, {915,0.001579646}, {920,0.001920354}, {925,0.001827434}, {930,0.001730088}, {935,0.002508850}, {940,0.002013274}, {945,0.001880531}, {950,0.001805310}, {955,0.001964602}, {960,0.001920354}, {965,0.001818584}, {970,0.001845133}, {975,0.002234513}, {980,0.002004425}, {985,0.002181416}, {990,0.001858407}, {995,0.001747788}, {1000,0.002172566}, {1010,0.002022124}, {1020,0.002048673}, {1030,0.002097345}, {1040,0.007292035}, {1050,0.002185841}, {1060,0.002137168}, {1070,0.002039823}, {1080,0.002092920}, {1090,0.002199115}, {1100,0.002323009}, {1110,0.002092920}, {1120,0.002278761}, {1130,0.001907080}, {1140,0.002278761}, {1150,0.002336283}, {1160,0.002323009}, {1170,0.002340708}, {1180,0.002323009}, {1190,0.002181416}, {1200,0.002384956}, {1210,0.002283186}, {1220,0.002119469}, {1230,0.002597345}, {1240,0.002469027}, {1250,0.002243363}, {1260,0.002500000}, {1270,0.002358407}, {1280,0.002398230}, {1290,0.002522124}, {1300,0.002535398}, {1310,0.002646018}, {1320,0.002513274}, {1330,0.002592920}, {1340,0.002584071}, {1350,0.002615044}, {1360,0.002610619}, {1370,0.002610619}, {1380,0.002933628}, {1390,0.002849558}, {1400,0.002615044}, {1410,0.002619469}, {1420,0.008225664}, {1430,0.002756637}, {1440,0.002646018}, {1450,0.002761062}, {1460,0.002840708}, {1470,0.002694690}, {1480,0.002849558}, {1490,0.008407080}, {1500,0.002911504}, {1510,0.002889381}, {1520,0.002792035}, {1530,0.002862832}, {1540,0.002938053}, {1550,0.002862832}, {1560,0.003044248}, {1570,0.002880531}, {1580,0.002889381}, {1590,0.002902655}, {1600,0.002955752}, {1610,0.002876106}, {1620,0.007261062}, {1630,0.003101770}, {1640,0.002946903}, {1650,0.002955752}, {1660,0.003048673}, {1670,0.003176991}, {1680,0.003159292}, {1690,0.003110619}, {1700,0.003247788}, {1710,0.003159292}, {1720,0.003207965}, {1730,0.003172566}, {1740,0.003287611}, {1750,0.003292035}, {1760,0.003362832}, {1770,0.003305310}, {1780,0.003309735}, {1790,0.003331858}, {1800,0.003367257}, {1810,0.003429204}, {1820,0.003402655}, {1830,0.003508850}, {1840,0.003451327}, {1850,0.003818584}, {1860,0.003588496}, {1870,0.003500000}, {1880,0.003637168}, {1890,0.003946903}, {1900,0.003615044}, {1910,0.003606195}, {1920,0.003805310}, {1930,0.007557522}, {1940,0.003707965}, {1950,0.003676991}, {1960,0.003743363}, {1970,0.003743363}, {1980,0.003743363}, {1990,0.003743363}, {2000,0.003814159}, {2050,0.004048673}, {2100,0.004234513}, {2150,0.004269912}, {2200,0.004398230}, {2250,0.004553097}, {2300,0.010048673}, {2350,0.004902655}, {2400,0.010681416}, {2450,0.005092920}, {2500,0.005132743}, {2550,0.012159292}, {2600,0.005460177}, {2650,0.005699115}, {2700,0.005849558}, {2750,0.005893805}, {2800,0.005955752}, {2850,0.006269912}, {2900,0.010283186}, {2950,0.013681416}, {3000,0.006663717}, {3050,0.013601770}, {3100,0.006792035}, {3150,0.012256637}, {3200,0.006938053}, {3250,0.007039823}, {3300,0.007234513}, {3350,0.007411504}, {3400,0.015269912}, {3450,0.007597345}, {3500,0.007566372}, {3550,0.007836283}, {3600,0.019075221}, {3650,0.012017699}, {3700,0.008269912}, {3750,0.008783186}, {3800,0.008747788}, {3850,0.008610619}, {3900,0.019141593}, {3950,0.008805310}, {4000,0.009185841}, {4050,0.009420354}, {4100,0.014464602}, {4150,0.014044248}, {4200,0.009393805}, {4250,0.009668142}, {4300,0.016513274}, {4350,0.010216814}, {4400,0.010376106}, {4450,0.010362832}, {4500,0.010522124}, {4550,0.010407080}, {4600,0.010730088}, {4650,0.016336283}, {4700,0.010969027}, {4750,0.011977876}, {4800,0.011345133}, {4850,0.017911504}, {4900,0.019221239}, {4950,0.012000000}, {5000,0.012057522}, {5050,0.012106195}, {5100,0.012146018}, {5150,0.015243363}, {5200,0.017442478}, {5250,0.012591111}, {5300,0.012502222}, {5350,0.012595556}, {5400,0.012920000}, {5450,0.013280000}, {5500,0.016124444}, {5550,0.022026667}, {5600,0.013826667}, {5650,0.019702222}, {5700,0.013346667}, {5750,0.013537778}, {5800,0.019884444}, {5850,0.014328889}, {5900,0.018502222}, {5950,0.014711111}, {6000,0.014391111}, {6050,0.021167}, {6100,0.014278}, {6150,0.014333}, {6200,0.026000}, {6250,0.014167}, {6300,0.022000}, {6350,0.014778}, {6400,0.014500}, {6450,0.014278}, {6500,0.014500}, {6550,0.017667}, {6600,0.016333}, {6650,0.026056}, {6700,0.028056}, {6750,0.021111}, {6800,0.015833}, {6850,0.020444}, {6900,0.021000}, {6950,0.016333}, {7000,0.016000}, {7050,0.033833}, {7100,0.025611}, {7150,0.017222}, {7200,0.023333}, {7250,0.016444}, {7300,0.020778}, {7350,0.017556}, {7400,0.016944}, {7450,0.017556}, {7500,0.017222}, {7550,0.017500}, {7600,0.018889}, {7650,0.017333}, {7700,0.020722}, {7750,0.021778}, {7800,0.018389}, {7850,0.020889}, {7900,0.019167}, {7950,0.018500}, {8000,0.022444}, {8050,0.019611}, {8100,0.020111}, {8150,0.021444}, {8200,0.032167}, {8250,0.019444}, {8300,0.019833}, {8350,0.026389}, {8400,0.023556}, {8450,0.019556}, {8500,0.028167}, {8550,0.021167}, {8600,0.030500}, {8650,0.044778}, {8700,0.019667}, {8750,0.022833}, {8800,0.020556}, {8850,0.029778}, {8900,0.041056}, {8950,0.021944}, {9000,0.021611}, {9050,0.047667}, {9100,0.034500}, {9150,0.039944}, {9200,0.022778}, {9250,0.021611}, {9300,0.022056}, {9350,0.024667}, {9400,0.044389}, {9450,0.033444}, {9500,0.023889}, {9550,0.022778}, {9600,0.023611}, {9650,0.026500}, {9700,0.022889}, {9750,0.024056}, {9800,0.024889}, {9850,0.023611}, {9900,0.024444}, {9950,0.023667}, {10000,0.042667}, {10100,0.024333}, {10200,0.025944}, {10300,0.024833}, {10400,0.026278}, {10500,0.042000}, {10600,0.033278}, {10700,0.035556}, {10800,0.032833}, {10900,0.035278}, {11000,0.027278}, {11100,0.026778}, {11200,0.027056}, {11300,0.049389}, {11400,0.028611}, {11500,0.028556}, {11600,0.034056}, {11700,0.046944}, {11800,0.029667}, {11900,0.029111}, {12000,0.049000}, {12100,0.032611}, {12200,0.030833}, {12300,0.030278}, {12400,0.030444}, {12500,0.035444}, {12600,0.034167}, {12700,0.038056}, {12800,0.048444}, {12900,0.042889}, {13000,0.032167}, {13100,0.033889}, {13200,0.057889}, {13300,0.039222}, {13400,0.042833}, {13500,0.055167}, {13600,0.056944}, {13700,0.053389}, {13800,0.034278}, {13900,0.036278}, {14000,0.034667}, {14100,0.034556}, {14200,0.069222}, {14300,0.061556}, {14400,0.049167}, {14500,0.043944}, {14600,0.035889}, {14700,0.043944}, {14800,0.058278}, {14900,0.037000}, {15000,0.048333}, {15100,0.064389}, {15200,0.047556}, {15300,0.039111}, {15400,0.043167}, {15500,0.049389}, {15600,0.060167}, {15700,0.041111}, {15800,0.065778}, {15900,0.039833}, {16000,0.059000}, {16100,0.066056}, {16200,0.046889}, {16300,0.079667}, {16400,0.057111}, {16500,0.069278}, {16600,0.049111}, {16700,0.041389}, {16800,0.070556}, {16900,0.070333}, {17000,0.042778}, {17100,0.043333}, {17200,0.079833}, {17300,0.076667}, {17400,0.056611}, {17500,0.064667}, {17600,0.069111}, {17700,0.073778}, {17800,0.076278}, {17900,0.079111}, {18000,0.078222}, {18100,0.077611}, {18200,0.048222}, {18300,0.073722}, {18400,0.053000}, {18500,0.059111}, {18600,0.084000}, {18700,0.065111}, {18800,0.085389}, {18900,0.092000}, {19000,0.056222}, {19100,0.051611}, {19200,0.070833}, {19300,0.062722}, {19400,0.087556}, {19500,0.087833}, {19600,0.083000}, {19700,0.052222}, {19800,0.078444}, {19900,0.065167}, {20000,0.071875}};
data["big_flat"]["TypeClasses"]["cbv"]["system"] = {{1,0.000017699}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000017699}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000017699}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000017699}, {37,0.000000000}, {38,0.000000000}, {39,0.000017699}, {40,0.000017699}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000017699}, {46,0.000017699}, {47,0.000017699}, {48,0.000000000}, {49,0.000017699}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000017699}, {55,0.000000000}, {56,0.000017699}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000017699}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000017699}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000017699}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000017699}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000013274}, {83,0.000017699}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000017699}, {94,0.000000000}, {95,0.000017699}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000017699}, {114,0.000017699}, {115,0.000017699}, {116,0.000000000}, {117,0.000017699}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000017699}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000017699}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000017699}, {138,0.000000000}, {139,0.000017699}, {140,0.000017699}, {141,0.000013274}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000017699}, {153,0.000000000}, {154,0.000017699}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000030973}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000017699}, {172,0.000000000}, {173,0.000017699}, {174,0.000017699}, {175,0.000030973}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000035398}, {189,0.000000000}, {190,0.000017699}, {191,0.000017699}, {192,0.000000000}, {193,0.000000000}, {194,0.000013274}, {195,0.000000000}, {196,0.000017699}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000013274}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000017699}, {213,0.000000000}, {214,0.000000000}, {215,0.000017699}, {216,0.000017699}, {217,0.000017699}, {218,0.000000000}, {219,0.000013274}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000017699}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000013274}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000017699}, {244,0.000017699}, {245,0.000013274}, {246,0.000000000}, {247,0.000000000}, {248,0.000017699}, {249,0.000017699}, {250,0.000000000}, {251,0.000017699}, {252,0.000000000}, {253,0.000017699}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000017699}, {258,0.000088496}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000035398}, {265,0.000017699}, {266,0.000000000}, {267,0.000030973}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000017699}, {273,0.000017699}, {274,0.000000000}, {275,0.000035398}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000017699}, {282,0.000000000}, {283,0.000013274}, {284,0.000000000}, {285,0.000000000}, {286,0.000035398}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000017699}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000030973}, {299,0.000000000}, {300,0.000000000}, {301,0.000017699}, {302,0.000000000}, {303,0.000017699}, {304,0.000017699}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000017699}, {314,0.000000000}, {315,0.000017699}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000017699}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000035398}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000017699}, {340,0.000030973}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000017699}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000017699}, {349,0.000000000}, {350,0.000017699}, {351,0.000000000}, {352,0.000013274}, {353,0.000000000}, {354,0.000017699}, {355,0.000000000}, {356,0.000017699}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000017699}, {362,0.000017699}, {363,0.000013274}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000017699}, {368,0.000000000}, {369,0.000017699}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000017699}, {379,0.000000000}, {380,0.000017699}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000017699}, {385,0.000000000}, {386,0.000000000}, {387,0.000030973}, {388,0.000017699}, {389,0.000000000}, {390,0.000017699}, {391,0.000000000}, {392,0.000000000}, {393,0.000017699}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000013274}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000035398}, {402,0.000017699}, {403,0.000000000}, {404,0.000000000}, {405,0.000017699}, {406,0.000017699}, {407,0.000000000}, {408,0.000000000}, {409,0.000017699}, {410,0.000000000}, {411,0.000017699}, {412,0.000035398}, {413,0.000000000}, {414,0.000013274}, {415,0.000017699}, {416,0.000017699}, {417,0.000013274}, {418,0.000000000}, {419,0.000000000}, {420,0.000017699}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000017699}, {425,0.000000000}, {426,0.000030973}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000013274}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000017699}, {438,0.000000000}, {439,0.000017699}, {440,0.000000000}, {441,0.000000000}, {442,0.000017699}, {443,0.000000000}, {444,0.000013274}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000017699}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000017699}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000017699}, {463,0.000000000}, {464,0.000000000}, {465,0.000013274}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000013274}, {473,0.000017699}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000017699}, {478,0.000000000}, {479,0.000030973}, {480,0.000035398}, {481,0.000000000}, {482,0.000017699}, {483,0.000017699}, {484,0.000030973}, {485,0.000000000}, {486,0.000000000}, {487,0.000017699}, {488,0.000070796}, {489,0.000017699}, {490,0.000035398}, {491,0.000053097}, {492,0.000017699}, {493,0.000000000}, {494,0.000000000}, {495,0.000030973}, {496,0.000017699}, {497,0.000013274}, {498,0.000000000}, {499,0.000017699}, {500,0.000053097}, {505,0.000000000}, {510,0.000000000}, {515,0.000017699}, {520,0.000017699}, {525,0.000017699}, {530,0.000000000}, {535,0.000000000}, {540,0.000017699}, {545,0.000000000}, {550,0.000017699}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000017699}, {590,0.000017699}, {595,0.000017699}, {600,0.000000000}, {605,0.000000000}, {610,0.000017699}, {615,0.000000000}, {620,0.000030973}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000013274}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000017699}, {705,0.000000000}, {710,0.000017699}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000017699}, {735,0.000000000}, {740,0.000000000}, {745,0.000035398}, {750,0.000000000}, {755,0.000035398}, {760,0.000000000}, {765,0.000000000}, {770,0.000013274}, {775,0.000000000}, {780,0.000017699}, {785,0.000000000}, {790,0.000017699}, {795,0.000013274}, {800,0.000017699}, {805,0.000000000}, {810,0.000017699}, {815,0.000000000}, {820,0.000017699}, {825,0.000053097}, {830,0.000000000}, {835,0.000017699}, {840,0.000000000}, {845,0.000017699}, {850,0.000030973}, {855,0.000000000}, {860,0.000000000}, {865,0.000017699}, {870,0.000000000}, {875,0.000000000}, {880,0.000017699}, {885,0.000017699}, {890,0.000000000}, {895,0.000000000}, {900,0.000035398}, {905,0.000013274}, {910,0.000000000}, {915,0.000017699}, {920,0.000017699}, {925,0.000013274}, {930,0.000035398}, {935,0.000017699}, {940,0.000017699}, {945,0.000000000}, {950,0.000017699}, {955,0.000017699}, {960,0.000013274}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000017699}, {985,0.000017699}, {990,0.000035398}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000013274}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000035398}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000035398}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000013274}, {1170,0.000017699}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000053097}, {1260,0.000013274}, {1270,0.000048673}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000035398}, {1350,0.000017699}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000017699}, {1410,0.000017699}, {1420,0.000017699}, {1430,0.000000000}, {1440,0.000053097}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000035398}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000017699}, {1510,0.000017699}, {1520,0.000035398}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000017699}, {1600,0.000000000}, {1610,0.000017699}, {1620,0.000017699}, {1630,0.000017699}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000035398}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000035398}, {1700,0.000017699}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000017699}, {1770,0.000017699}, {1780,0.000017699}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000013274}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000017699}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000017699}, {2250,0.000035398}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000013274}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000035398}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000013274}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000017699}, {3150,0.000048673}, {3200,0.000053097}, {3250,0.000017699}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000035398}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000017699}, {3750,0.000000000}, {3800,0.000017699}, {3850,0.000013274}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000017699}, {4100,0.000017699}, {4150,0.000000000}, {4200,0.000017699}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000017699}, {4700,0.000017699}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000044248}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.000000000}, {5100,0.000000000}, {5150,0.000000000}, {5200,0.000000000}, {5250,0.000000000}, {5300,0.000000000}, {5350,0.000000000}, {5400,0.000000000}, {5450,0.000000000}, {5500,0.000035556}, {5550,0.000000000}, {5600,0.000017778}, {5650,0.000000000}, {5700,0.000017778}, {5750,0.000000000}, {5800,0.000000000}, {5850,0.000000000}, {5900,0.000000000}, {5950,0.000017778}, {6000,0.000017778}, {6050,0.000000}, {6100,0.000167}, {6150,0.000000}, {6200,0.000222}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000167}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000222}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000167}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000222}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000222}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000222}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000167}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000222}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000444}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000222}, {17400,0.000000}, {17500,0.000000}, {17600,0.000222}, {17700,0.000000}, {17800,0.000222}, {17900,0.000000}, {18000,0.000000}, {18100,0.000222}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000222}, {19500,0.000000}, {19600,0.000444}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClasses"]["eval lazy"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000004425}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000296460}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000278761}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.004283186}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000030973}, {478,0.002495575}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000022124}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000482301}, {1310,0.000588496}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.006845133}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.005756637}, {1430,0.000004425}, {1440,0.000004425}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000008850}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000008850}, {1540,0.000022124}, {1550,0.000013274}, {1560,0.000035398}, {1570,0.000106195}, {1580,0.000070796}, {1590,0.000092920}, {1600,0.000132743}, {1610,0.000216814}, {1620,0.000287611}, {1630,0.000327434}, {1640,0.000415929}, {1650,0.000438053}, {1660,0.000491150}, {1670,0.000517699}, {1680,0.000539823}, {1690,0.000650442}, {1700,0.000699115}, {1710,0.000707965}, {1720,0.000734513}, {1730,0.000778761}, {1740,0.000818584}, {1750,0.000876106}, {1760,0.000867257}, {1770,0.000929204}, {1780,0.000964602}, {1790,0.000995575}, {1800,0.001000000}, {1810,0.001000000}, {1820,0.001000000}, {1830,0.001464602}, {1840,0.001000000}, {1850,0.001000000}, {1860,0.001000000}, {1870,0.001000000}, {1880,0.001000000}, {1890,0.001000000}, {1900,0.001000000}, {1910,0.001415929}, {1920,0.001000000}, {1930,0.001000000}, {1940,0.001000000}, {1950,0.001000000}, {1960,0.001000000}, {1970,0.001000000}, {1980,0.001000000}, {1990,0.001000000}, {2000,0.001000000}, {2050,0.001000000}, {2100,0.006460177}, {2150,0.001000000}, {2200,0.001000000}, {2250,0.001000000}, {2300,0.001000000}, {2350,0.001000000}, {2400,0.001000000}, {2450,0.001000000}, {2500,0.006380531}, {2550,0.001004425}, {2600,0.001000000}, {2650,0.001008850}, {2700,0.001000000}, {2750,0.001008850}, {2800,0.001035398}, {2850,0.001101770}, {2900,0.001199115}, {2950,0.001318584}, {3000,0.001380531}, {3050,0.001420354}, {3100,0.001451327}, {3150,0.001473451}, {3200,0.001619469}, {3250,0.001500000}, {3300,0.001495575}, {3350,0.001522124}, {3400,0.001539823}, {3450,0.001615044}, {3500,0.001774336}, {3550,0.001796460}, {3600,0.001858407}, {3650,0.001995575}, {3700,0.002168142}, {3750,0.002725664}, {3800,0.002234513}, {3850,0.002092920}, {3900,0.003075221}, {3950,0.002203540}, {4000,0.002115044}, {4050,0.002221239}, {4100,0.002247788}, {4150,0.002283186}, {4200,0.002207965}, {4250,0.002362832}, {4300,0.002362832}, {4350,0.002389381}, {4400,0.002415929}, {4450,0.002460177}, {4500,0.002473451}, {4550,0.013699115}, {4600,0.002482301}, {4650,0.002495575}, {4700,0.002513274}, {4750,0.002530973}, {4800,0.002557522}, {4850,0.002623894}, {4900,0.002632743}, {4950,0.002730088}, {5000,0.002778761}, {5050,0.002800885}, {5100,0.013212389}, {5150,0.003039823}, {5200,0.003022124}, {5250,0.003173333}, {5300,0.003213333}, {5350,0.003275556}, {5400,0.012995556}, {5450,0.003360000}, {5500,0.004613333}, {5550,0.003435556}, {5600,0.003453333}, {5650,0.003462222}, {5700,0.003431111}, {5750,0.003480000}, {5800,0.003493333}, {5850,0.003502222}, {5900,0.003497778}, {5950,0.003777778}, {6000,0.003591111}, {6050,0.003167}, {6100,0.009500}, {6150,0.003222}, {6200,0.003389}, {6250,0.003278}, {6300,0.003333}, {6350,0.003389}, {6400,0.003611}, {6450,0.009444}, {6500,0.004833}, {6550,0.003556}, {6600,0.003722}, {6650,0.003556}, {6700,0.003722}, {6750,0.003722}, {6800,0.003722}, {6850,0.003889}, {6900,0.003833}, {6950,0.004056}, {7000,0.012889}, {7050,0.004222}, {7100,0.010944}, {7150,0.004167}, {7200,0.004167}, {7250,0.005444}, {7300,0.019167}, {7350,0.004389}, {7400,0.004278}, {7450,0.004444}, {7500,0.004333}, {7550,0.004444}, {7600,0.004389}, {7650,0.004500}, {7700,0.004444}, {7750,0.004500}, {7800,0.004222}, {7850,0.004667}, {7900,0.004722}, {7950,0.004722}, {8000,0.004722}, {8050,0.004722}, {8100,0.004667}, {8150,0.004778}, {8200,0.004833}, {8250,0.004833}, {8300,0.004833}, {8350,0.010500}, {8400,0.004944}, {8450,0.005000}, {8500,0.005167}, {8550,0.005167}, {8600,0.021611}, {8650,0.005222}, {8700,0.005278}, {8750,0.005333}, {8800,0.006444}, {8850,0.026333}, {8900,0.022889}, {8950,0.006611}, {9000,0.023278}, {9050,0.005444}, {9100,0.022444}, {9150,0.006556}, {9200,0.007000}, {9250,0.005778}, {9300,0.018722}, {9350,0.009889}, {9400,0.005778}, {9450,0.005778}, {9500,0.005778}, {9550,0.005833}, {9600,0.006611}, {9650,0.005778}, {9700,0.005833}, {9750,0.005889}, {9800,0.005889}, {9850,0.005889}, {9900,0.006000}, {9950,0.006167}, {10000,0.021389}, {10100,0.006333}, {10200,0.006556}, {10300,0.016333}, {10400,0.006611}, {10500,0.017889}, {10600,0.006667}, {10700,0.006667}, {10800,0.006722}, {10900,0.006667}, {11000,0.006833}, {11100,0.017556}, {11200,0.007111}, {11300,0.007056}, {11400,0.007222}, {11500,0.007556}, {11600,0.013222}, {11700,0.007611}, {11800,0.007500}, {11900,0.011000}, {12000,0.007667}, {12100,0.007722}, {12200,0.007889}, {12300,0.007944}, {12400,0.007889}, {12500,0.008056}, {12600,0.008222}, {12700,0.008167}, {12800,0.008500}, {12900,0.011111}, {13000,0.009667}, {13100,0.009333}, {13200,0.008722}, {13300,0.021444}, {13400,0.028389}, {13500,0.008889}, {13600,0.009000}, {13700,0.014056}, {13800,0.009278}, {13900,0.014611}, {14000,0.014056}, {14100,0.009333}, {14200,0.009389}, {14300,0.009778}, {14400,0.018722}, {14500,0.018167}, {14600,0.010000}, {14700,0.010833}, {14800,0.029444}, {14900,0.010667}, {15000,0.025333}, {15100,0.026333}, {15200,0.010278}, {15300,0.010278}, {15400,0.010444}, {15500,0.010333}, {15600,0.010778}, {15700,0.010611}, {15800,0.010889}, {15900,0.030111}, {16000,0.011278}, {16100,0.017000}, {16200,0.011111}, {16300,0.011222}, {16400,0.011167}, {16500,0.015333}, {16600,0.011500}, {16700,0.011222}, {16800,0.025333}, {16900,0.021722}, {17000,0.011611}, {17100,0.038611}, {17200,0.030167}, {17300,0.018056}, {17400,0.037778}, {17500,0.012278}, {17600,0.012222}, {17700,0.011167}, {17800,0.012333}, {17900,0.014500}, {18000,0.021833}, {18100,0.038944}, {18200,0.012000}, {18300,0.012889}, {18400,0.015889}, {18500,0.013222}, {18600,0.013111}, {18700,0.012556}, {18800,0.013333}, {18900,0.012611}, {19000,0.013333}, {19100,0.013333}, {19200,0.013444}, {19300,0.018778}, {19400,0.013611}, {19500,0.013389}, {19600,0.014000}, {19700,0.012278}, {19800,0.014167}, {19900,0.024111}, {20000,0.018813}};
data["big_flat"]["TypeClasses"]["eval lazy"]["user"] = {{1,0.000026667}, {2,0.000017699}, {3,0.000013274}, {4,0.000013274}, {5,0.000013274}, {6,0.000017699}, {7,0.000048673}, {8,0.000035398}, {9,0.000039823}, {10,0.000053097}, {11,0.000000000}, {12,0.000048673}, {13,0.000048673}, {14,0.000066372}, {15,0.000084071}, {16,0.000013274}, {17,0.000044248}, {18,0.000035398}, {19,0.000044248}, {20,0.000026549}, {21,0.000044248}, {22,0.000000000}, {23,0.000000000}, {24,0.000017699}, {25,0.000013274}, {26,0.000088496}, {27,0.000053097}, {28,0.000110619}, {29,0.000044248}, {30,0.000070796}, {31,0.000075221}, {32,0.000044248}, {33,0.000030973}, {34,0.000061947}, {35,0.000057522}, {36,0.000110619}, {37,0.000026549}, {38,0.000075221}, {39,0.000066372}, {40,0.000079646}, {41,0.000057522}, {42,0.000070796}, {43,0.000137168}, {44,0.000044248}, {45,0.000097345}, {46,0.000044248}, {47,0.000030973}, {48,0.000030973}, {49,0.000057522}, {50,0.000123894}, {51,0.000088496}, {52,0.000026549}, {53,0.000061947}, {54,0.000035398}, {55,0.000013274}, {56,0.000057522}, {57,0.000061947}, {58,0.000128319}, {59,0.000084071}, {60,0.000119469}, {61,0.000137168}, {62,0.000035398}, {63,0.000075221}, {64,0.000097345}, {65,0.000092920}, {66,0.000110619}, {67,0.000084071}, {68,0.000061947}, {69,0.000075221}, {70,0.000092920}, {71,0.000176991}, {72,0.000088496}, {73,0.000088496}, {74,0.000097345}, {75,0.000088496}, {76,0.000061947}, {77,0.000079646}, {78,0.000110619}, {79,0.000097345}, {80,0.000128319}, {81,0.000154867}, {82,0.000030973}, {83,0.000039823}, {84,0.000092920}, {85,0.000057522}, {86,0.000075221}, {87,0.000088496}, {88,0.000061947}, {89,0.000101770}, {90,0.000123894}, {91,0.000115044}, {92,0.000101770}, {93,0.000123894}, {94,0.000066372}, {95,0.000088496}, {96,0.000075221}, {97,0.000048673}, {98,0.000084071}, {99,0.000119469}, {100,0.000075221}, {101,0.000115044}, {102,0.000079646}, {103,0.000137168}, {104,0.000057522}, {105,0.000075221}, {106,0.000066372}, {107,0.000137168}, {108,0.000066372}, {109,0.000123894}, {110,0.000106195}, {111,0.000070796}, {112,0.000088496}, {113,0.000088496}, {114,0.000168142}, {115,0.000115044}, {116,0.000119469}, {117,0.000132743}, {118,0.000066372}, {119,0.000154867}, {120,0.000150442}, {121,0.000084071}, {122,0.000039823}, {123,0.000079646}, {124,0.000084071}, {125,0.000106195}, {126,0.000123894}, {127,0.000092920}, {128,0.000110619}, {129,0.000110619}, {130,0.000154867}, {131,0.000070796}, {132,0.000146018}, {133,0.000070796}, {134,0.000092920}, {135,0.000084071}, {136,0.000110619}, {137,0.000039823}, {138,0.000137168}, {139,0.000101770}, {140,0.000097345}, {141,0.000044248}, {142,0.000115044}, {143,0.000181416}, {144,0.000132743}, {145,0.000088496}, {146,0.000070796}, {147,0.000128319}, {148,0.000119469}, {149,0.000128319}, {150,0.000119469}, {151,0.000137168}, {152,0.000207965}, {153,0.000101770}, {154,0.000119469}, {155,0.000106195}, {156,0.000159292}, {157,0.000101770}, {158,0.000106195}, {159,0.000141593}, {160,0.000106195}, {161,0.000132743}, {162,0.000154867}, {163,0.000030973}, {164,0.000106195}, {165,0.000115044}, {166,0.000137168}, {167,0.000150442}, {168,0.000110619}, {169,0.000084071}, {170,0.000141593}, {171,0.000119469}, {172,0.000159292}, {173,0.000154867}, {174,0.000101770}, {175,0.000154867}, {176,0.000199115}, {177,0.000163717}, {178,0.000159292}, {179,0.000070796}, {180,0.000110619}, {181,0.000176991}, {182,0.000141593}, {183,0.000181416}, {184,0.000075221}, {185,0.000075221}, {186,0.000128319}, {187,0.000110619}, {188,0.000203540}, {189,0.000115044}, {190,0.000234513}, {191,0.000106195}, {192,0.000190265}, {193,0.000185841}, {194,0.000123894}, {195,0.000097345}, {196,0.000150442}, {197,0.000110619}, {198,0.000168142}, {199,0.000128319}, {200,0.000185841}, {201,0.000150442}, {202,0.000176991}, {203,0.000128319}, {204,0.000159292}, {205,0.000199115}, {206,0.000088496}, {207,0.000185841}, {208,0.000154867}, {209,0.000106195}, {210,0.000212389}, {211,0.000225664}, {212,0.000128319}, {213,0.000119469}, {214,0.000168142}, {215,0.000137168}, {216,0.000261062}, {217,0.000159292}, {218,0.000075221}, {219,0.000039823}, {220,0.000256637}, {221,0.000115044}, {222,0.000132743}, {223,0.000181416}, {224,0.000203540}, {225,0.000185841}, {226,0.000088496}, {227,0.000101770}, {228,0.000132743}, {229,0.000079646}, {230,0.000097345}, {231,0.000137168}, {232,0.000176991}, {233,0.000132743}, {234,0.000119469}, {235,0.000181416}, {236,0.000190265}, {237,0.000137168}, {238,0.000168142}, {239,0.000176991}, {240,0.000132743}, {241,0.000150442}, {242,0.000172566}, {243,0.000163717}, {244,0.000238938}, {245,0.000292035}, {246,0.000168142}, {247,0.000132743}, {248,0.000221239}, {249,0.000181416}, {250,0.000199115}, {251,0.000194690}, {252,0.000207965}, {253,0.000194690}, {254,0.000234513}, {255,0.000070796}, {256,0.000225664}, {257,0.000278761}, {258,0.000230088}, {259,0.000119469}, {260,0.000154867}, {261,0.000150442}, {262,0.000146018}, {263,0.000185841}, {264,0.000168142}, {265,0.000168142}, {266,0.000393805}, {267,0.000181416}, {268,0.000190265}, {269,0.000265487}, {270,0.000221239}, {271,0.000176991}, {272,0.000137168}, {273,0.000194690}, {274,0.000190265}, {275,0.000172566}, {276,0.000163717}, {277,0.000181416}, {278,0.000300885}, {279,0.000234513}, {280,0.000176991}, {281,0.000256637}, {282,0.000247788}, {283,0.000128319}, {284,0.000119469}, {285,0.000190265}, {286,0.000168142}, {287,0.000269912}, {288,0.000207965}, {289,0.000203540}, {290,0.000137168}, {291,0.000128319}, {292,0.000314159}, {293,0.000230088}, {294,0.000234513}, {295,0.000274336}, {296,0.000176991}, {297,0.000225664}, {298,0.000119469}, {299,0.000269912}, {300,0.000185841}, {301,0.000092920}, {302,0.000141593}, {303,0.000234513}, {304,0.000221239}, {305,0.000234513}, {306,0.000230088}, {307,0.000141593}, {308,0.000256637}, {309,0.000194690}, {310,0.000274336}, {311,0.000451327}, {312,0.000261062}, {313,0.000305310}, {314,0.000154867}, {315,0.000163717}, {316,0.000168142}, {317,0.000163717}, {318,0.000252212}, {319,0.000110619}, {320,0.000207965}, {321,0.000216814}, {322,0.000154867}, {323,0.000287611}, {324,0.000212389}, {325,0.000088496}, {326,0.000221239}, {327,0.000141593}, {328,0.000238938}, {329,0.000212389}, {330,0.000212389}, {331,0.000203540}, {332,0.000190265}, {333,0.000327434}, {334,0.000256637}, {335,0.000225664}, {336,0.000185841}, {337,0.000323009}, {338,0.000119469}, {339,0.000296460}, {340,0.000265487}, {341,0.000238938}, {342,0.000132743}, {343,0.000150442}, {344,0.000212389}, {345,0.000238938}, {346,0.000092920}, {347,0.000243363}, {348,0.000221239}, {349,0.000176991}, {350,0.000190265}, {351,0.000283186}, {352,0.000225664}, {353,0.000194690}, {354,0.000185841}, {355,0.000110619}, {356,0.000252212}, {357,0.000221239}, {358,0.000203540}, {359,0.000194690}, {360,0.000314159}, {361,0.000340708}, {362,0.000203540}, {363,0.000207965}, {364,0.000230088}, {365,0.000172566}, {366,0.000287611}, {367,0.000194690}, {368,0.000132743}, {369,0.000274336}, {370,0.000203540}, {371,0.000185841}, {372,0.000154867}, {373,0.000199115}, {374,0.000212389}, {375,0.000132743}, {376,0.000261062}, {377,0.000216814}, {378,0.000199115}, {379,0.000185841}, {380,0.000212389}, {381,0.000194690}, {382,0.000154867}, {383,0.000336283}, {384,0.000203540}, {385,0.000278761}, {386,0.000247788}, {387,0.000265487}, {388,0.000141593}, {389,0.000194690}, {390,0.000247788}, {391,0.000088496}, {392,0.000185841}, {393,0.000194690}, {394,0.000234513}, {395,0.000203540}, {396,0.000194690}, {397,0.000137168}, {398,0.000309735}, {399,0.000221239}, {400,0.000362832}, {401,0.000256637}, {402,0.000199115}, {403,0.000225664}, {404,0.000265487}, {405,0.000212389}, {406,0.000172566}, {407,0.000185841}, {408,0.000287611}, {409,0.000331858}, {410,0.000243363}, {411,0.000517699}, {412,0.000327434}, {413,0.000256637}, {414,0.000234513}, {415,0.000194690}, {416,0.000296460}, {417,0.000323009}, {418,0.000137168}, {419,0.000252212}, {420,0.000212389}, {421,0.000216814}, {422,0.000216814}, {423,0.000176991}, {424,0.000265487}, {425,0.000243363}, {426,0.000292035}, {427,0.000207965}, {428,0.000269912}, {429,0.000340708}, {430,0.000296460}, {431,0.000225664}, {432,0.000181416}, {433,0.000278761}, {434,0.000190265}, {435,0.000190265}, {436,0.000203540}, {437,0.000199115}, {438,0.000212389}, {439,0.000265487}, {440,0.000340708}, {441,0.000203540}, {442,0.000261062}, {443,0.000207965}, {444,0.000159292}, {445,0.000230088}, {446,0.000274336}, {447,0.000252212}, {448,0.000287611}, {449,0.000300885}, {450,0.000243363}, {451,0.000238938}, {452,0.000305310}, {453,0.000252212}, {454,0.004575221}, {455,0.000221239}, {456,0.000292035}, {457,0.000230088}, {458,0.000230088}, {459,0.000269912}, {460,0.000252212}, {461,0.000305310}, {462,0.000305310}, {463,0.000163717}, {464,0.000274336}, {465,0.000256637}, {466,0.000318584}, {467,0.000415929}, {468,0.000216814}, {469,0.000212389}, {470,0.000234513}, {471,0.000278761}, {472,0.000309735}, {473,0.000212389}, {474,0.000287611}, {475,0.000327434}, {476,0.000331858}, {477,0.000309735}, {478,0.002650442}, {479,0.000314159}, {480,0.000296460}, {481,0.000274336}, {482,0.000327434}, {483,0.000318584}, {484,0.000216814}, {485,0.000283186}, {486,0.000380531}, {487,0.000407080}, {488,0.000137168}, {489,0.000380531}, {490,0.000398230}, {491,0.000199115}, {492,0.000393805}, {493,0.000393805}, {494,0.000296460}, {495,0.000287611}, {496,0.000230088}, {497,0.000238938}, {498,0.000207965}, {499,0.000309735}, {500,0.000203540}, {505,0.000314159}, {510,0.000283186}, {515,0.000314159}, {520,0.000309735}, {525,0.000336283}, {530,0.000314159}, {535,0.000265487}, {540,0.000345133}, {545,0.000331858}, {550,0.000345133}, {555,0.000278761}, {560,0.000376106}, {565,0.000287611}, {570,0.000358407}, {575,0.000261062}, {580,0.000323009}, {585,0.000269912}, {590,0.000398230}, {595,0.000340708}, {600,0.000367257}, {605,0.000380531}, {610,0.000486726}, {615,0.000323009}, {620,0.000367257}, {625,0.000340708}, {630,0.000376106}, {635,0.000362832}, {640,0.000495575}, {645,0.000261062}, {650,0.000331858}, {655,0.000433628}, {660,0.000557522}, {665,0.000522124}, {670,0.000438053}, {675,0.000451327}, {680,0.000451327}, {685,0.000371681}, {690,0.000323009}, {695,0.000526549}, {700,0.000327434}, {705,0.000508850}, {710,0.000451327}, {715,0.000331858}, {720,0.000566372}, {725,0.000517699}, {730,0.000287611}, {735,0.000517699}, {740,0.000486726}, {745,0.000349558}, {750,0.000526549}, {755,0.000451327}, {760,0.000380531}, {765,0.000561947}, {770,0.000389381}, {775,0.000340708}, {780,0.000384956}, {785,0.000283186}, {790,0.000517699}, {795,0.000495575}, {800,0.000455752}, {805,0.000371681}, {810,0.000451327}, {815,0.000526549}, {820,0.000526549}, {825,0.000380531}, {830,0.000433628}, {835,0.000491150}, {840,0.000460177}, {845,0.000530973}, {850,0.000323009}, {855,0.000575221}, {860,0.000606195}, {865,0.000548673}, {870,0.000442478}, {875,0.000376106}, {880,0.000584071}, {885,0.000486726}, {890,0.000530973}, {895,0.000553097}, {900,0.000491150}, {905,0.000579646}, {910,0.000672566}, {915,0.000464602}, {920,0.000610619}, {925,0.000561947}, {930,0.000619469}, {935,0.000455752}, {940,0.000433628}, {945,0.000566372}, {950,0.000407080}, {955,0.000646018}, {960,0.000473451}, {965,0.000615044}, {970,0.000535398}, {975,0.000579646}, {980,0.000353982}, {985,0.000530973}, {990,0.000566372}, {995,0.000566372}, {1000,0.000535398}, {1010,0.000725664}, {1020,0.000597345}, {1030,0.000676991}, {1040,0.000685841}, {1050,0.000610619}, {1060,0.000606195}, {1070,0.000597345}, {1080,0.000619469}, {1090,0.000641593}, {1100,0.000672566}, {1110,0.000469027}, {1120,0.000699115}, {1130,0.000774336}, {1140,0.000703540}, {1150,0.000597345}, {1160,0.000743363}, {1170,0.000650442}, {1180,0.000615044}, {1190,0.000561947}, {1200,0.000623894}, {1210,0.000606195}, {1220,0.000694690}, {1230,0.000597345}, {1240,0.000712389}, {1250,0.000654867}, {1260,0.000632743}, {1270,0.000774336}, {1280,0.000725664}, {1290,0.000765487}, {1300,0.001088496}, {1310,0.001176991}, {1320,0.000641593}, {1330,0.000623894}, {1340,0.007159292}, {1350,0.000632743}, {1360,0.000619469}, {1370,0.000853982}, {1380,0.000734513}, {1390,0.000615044}, {1400,0.000734513}, {1410,0.000685841}, {1420,0.006261062}, {1430,0.000676991}, {1440,0.000752212}, {1450,0.000836283}, {1460,0.000752212}, {1470,0.000902655}, {1480,0.000876106}, {1490,0.000747788}, {1500,0.000800885}, {1510,0.000716814}, {1520,0.000818584}, {1530,0.000761062}, {1540,0.000946903}, {1550,0.000929204}, {1560,0.000836283}, {1570,0.000774336}, {1580,0.000712389}, {1590,0.000902655}, {1600,0.000557522}, {1610,0.000743363}, {1620,0.000707965}, {1630,0.000938053}, {1640,0.000898230}, {1650,0.000977876}, {1660,0.000668142}, {1670,0.000778761}, {1680,0.000986726}, {1690,0.000889381}, {1700,0.000610619}, {1710,0.000889381}, {1720,0.000924779}, {1730,0.000893805}, {1740,0.000707965}, {1750,0.000823009}, {1760,0.000898230}, {1770,0.001000000}, {1780,0.000809735}, {1790,0.000836283}, {1800,0.000831858}, {1810,0.000725664}, {1820,0.000907080}, {1830,0.001230088}, {1840,0.000783186}, {1850,0.001035398}, {1860,0.000699115}, {1870,0.000907080}, {1880,0.001026549}, {1890,0.000955752}, {1900,0.000960177}, {1910,0.001420354}, {1920,0.000977876}, {1930,0.000924779}, {1940,0.000951327}, {1950,0.000880531}, {1960,0.000964602}, {1970,0.001044248}, {1980,0.000845133}, {1990,0.000911504}, {2000,0.000986726}, {2050,0.001097345}, {2100,0.006340708}, {2150,0.001101770}, {2200,0.000964602}, {2250,0.000964602}, {2300,0.001132743}, {2350,0.001278761}, {2400,0.001119469}, {2450,0.001168142}, {2500,0.006880531}, {2550,0.001362832}, {2600,0.001287611}, {2650,0.001415929}, {2700,0.001247788}, {2750,0.001141593}, {2800,0.001508850}, {2850,0.001597345}, {2900,0.001442478}, {2950,0.001500000}, {3000,0.001707965}, {3050,0.001561947}, {3100,0.001517699}, {3150,0.001491150}, {3200,0.001792035}, {3250,0.001853982}, {3300,0.001800885}, {3350,0.001632743}, {3400,0.001982301}, {3450,0.001929204}, {3500,0.001964602}, {3550,0.002017699}, {3600,0.001858407}, {3650,0.001867257}, {3700,0.002203540}, {3750,0.002827434}, {3800,0.002323009}, {3850,0.002221239}, {3900,0.002920354}, {3950,0.002075221}, {4000,0.002221239}, {4050,0.002190265}, {4100,0.002305310}, {4150,0.002371681}, {4200,0.002367257}, {4250,0.002694690}, {4300,0.002455752}, {4350,0.002610619}, {4400,0.002668142}, {4450,0.002738938}, {4500,0.002769912}, {4550,0.013756637}, {4600,0.002951327}, {4650,0.002991150}, {4700,0.002818584}, {4750,0.002778761}, {4800,0.003048673}, {4850,0.002933628}, {4900,0.002946903}, {4950,0.003115044}, {5000,0.003048673}, {5050,0.003190265}, {5100,0.013703540}, {5150,0.003367257}, {5200,0.003110619}, {5250,0.003284444}, {5300,0.003346667}, {5350,0.003400000}, {5400,0.013080000}, {5450,0.003395556}, {5500,0.004640000}, {5550,0.003315556}, {5600,0.003586667}, {5650,0.003488889}, {5700,0.003448889}, {5750,0.003613333}, {5800,0.003826667}, {5850,0.003635556}, {5900,0.003635556}, {5950,0.003937778}, {6000,0.003755556}, {6050,0.003778}, {6100,0.009278}, {6150,0.003778}, {6200,0.003111}, {6250,0.003389}, {6300,0.003556}, {6350,0.003389}, {6400,0.003333}, {6450,0.008889}, {6500,0.004611}, {6550,0.004222}, {6600,0.003833}, {6650,0.003889}, {6700,0.003889}, {6750,0.004056}, {6800,0.004111}, {6850,0.004556}, {6900,0.003944}, {6950,0.004111}, {7000,0.012611}, {7050,0.003889}, {7100,0.010222}, {7150,0.003722}, {7200,0.004000}, {7250,0.005278}, {7300,0.019611}, {7350,0.004278}, {7400,0.004667}, {7450,0.003944}, {7500,0.004056}, {7550,0.004667}, {7600,0.004556}, {7650,0.003278}, {7700,0.005167}, {7750,0.004889}, {7800,0.004278}, {7850,0.003667}, {7900,0.004167}, {7950,0.004167}, {8000,0.004556}, {8050,0.004556}, {8100,0.005778}, {8150,0.004333}, {8200,0.005778}, {8250,0.005389}, {8300,0.005056}, {8350,0.010667}, {8400,0.004778}, {8450,0.005278}, {8500,0.004722}, {8550,0.004611}, {8600,0.021389}, {8650,0.005167}, {8700,0.005611}, {8750,0.005111}, {8800,0.006556}, {8850,0.026833}, {8900,0.022222}, {8950,0.007111}, {9000,0.023222}, {9050,0.006278}, {9100,0.022722}, {9150,0.007444}, {9200,0.007000}, {9250,0.005944}, {9300,0.019833}, {9350,0.009611}, {9400,0.005722}, {9450,0.005333}, {9500,0.006278}, {9550,0.005833}, {9600,0.006222}, {9650,0.006278}, {9700,0.006389}, {9750,0.006500}, {9800,0.006056}, {9850,0.005833}, {9900,0.006556}, {9950,0.006111}, {10000,0.022111}, {10100,0.006389}, {10200,0.006778}, {10300,0.016167}, {10400,0.006056}, {10500,0.019000}, {10600,0.007000}, {10700,0.006778}, {10800,0.006167}, {10900,0.006389}, {11000,0.006500}, {11100,0.016944}, {11200,0.007833}, {11300,0.007944}, {11400,0.007222}, {11500,0.007222}, {11600,0.013222}, {11700,0.007500}, {11800,0.007500}, {11900,0.011000}, {12000,0.008278}, {12100,0.008056}, {12200,0.008167}, {12300,0.008611}, {12400,0.008444}, {12500,0.008167}, {12600,0.008556}, {12700,0.008278}, {12800,0.008167}, {12900,0.010722}, {13000,0.009667}, {13100,0.008889}, {13200,0.008889}, {13300,0.022000}, {13400,0.028389}, {13500,0.009000}, {13600,0.008556}, {13700,0.014111}, {13800,0.008889}, {13900,0.014722}, {14000,0.014833}, {14100,0.009333}, {14200,0.009889}, {14300,0.009611}, {14400,0.018778}, {14500,0.018944}, {14600,0.009611}, {14700,0.009833}, {14800,0.028889}, {14900,0.010444}, {15000,0.025278}, {15100,0.026611}, {15200,0.010611}, {15300,0.010389}, {15400,0.010722}, {15500,0.010444}, {15600,0.009944}, {15700,0.010444}, {15800,0.011278}, {15900,0.030056}, {16000,0.011222}, {16100,0.016667}, {16200,0.010833}, {16300,0.011333}, {16400,0.011611}, {16500,0.015333}, {16600,0.011833}, {16700,0.010722}, {16800,0.025278}, {16900,0.021000}, {17000,0.011722}, {17100,0.038611}, {17200,0.030167}, {17300,0.017944}, {17400,0.038722}, {17500,0.012111}, {17600,0.012278}, {17700,0.011278}, {17800,0.011889}, {17900,0.014000}, {18000,0.021444}, {18100,0.039444}, {18200,0.011722}, {18300,0.012222}, {18400,0.015222}, {18500,0.012722}, {18600,0.012500}, {18700,0.012278}, {18800,0.013000}, {18900,0.012444}, {19000,0.013667}, {19100,0.013778}, {19200,0.013722}, {19300,0.018556}, {19400,0.013167}, {19500,0.013167}, {19600,0.013056}, {19700,0.012056}, {19800,0.014167}, {19900,0.024667}, {20000,0.018875}};
data["big_flat"]["TypeClasses"]["eval lazy"]["system"] = {{1,0.000017778}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000017699}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000017699}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000035398}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000013274}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000017699}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000017699}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000017699}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000017699}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000017699}, {108,0.000000000}, {109,0.000017699}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000017699}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000017699}, {137,0.000000000}, {138,0.000017699}, {139,0.000000000}, {140,0.000013274}, {141,0.000000000}, {142,0.000000000}, {143,0.000017699}, {144,0.000000000}, {145,0.000000000}, {146,0.000017699}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000017699}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000017699}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000017699}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000017699}, {173,0.000000000}, {174,0.000000000}, {175,0.000013274}, {176,0.000000000}, {177,0.000017699}, {178,0.000017699}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000017699}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000017699}, {200,0.000000000}, {201,0.000013274}, {202,0.000013274}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000017699}, {212,0.000000000}, {213,0.000017699}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000017699}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000017699}, {229,0.000000000}, {230,0.000017699}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000030973}, {235,0.000000000}, {236,0.000000000}, {237,0.000017699}, {238,0.000000000}, {239,0.000017699}, {240,0.000000000}, {241,0.000000000}, {242,0.000017699}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000017699}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000017699}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000035398}, {255,0.000017699}, {256,0.000000000}, {257,0.000013274}, {258,0.000000000}, {259,0.000017699}, {260,0.000000000}, {261,0.000000000}, {262,0.000013274}, {263,0.000000000}, {264,0.000000000}, {265,0.000017699}, {266,0.000000000}, {267,0.000017699}, {268,0.000035398}, {269,0.000017699}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000017699}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000017699}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000017699}, {287,0.000017699}, {288,0.000030973}, {289,0.000035398}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000035398}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000035398}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000017699}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000017699}, {315,0.000017699}, {316,0.000000000}, {317,0.000017699}, {318,0.000000000}, {319,0.000013274}, {320,0.000000000}, {321,0.000013274}, {322,0.000017699}, {323,0.000000000}, {324,0.000030973}, {325,0.000013274}, {326,0.000000000}, {327,0.000000000}, {328,0.000017699}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000017699}, {333,0.000000000}, {334,0.000017699}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000017699}, {340,0.000017699}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000017699}, {345,0.000017699}, {346,0.000017699}, {347,0.000017699}, {348,0.000017699}, {349,0.000053097}, {350,0.000030973}, {351,0.000017699}, {352,0.000017699}, {353,0.000000000}, {354,0.000017699}, {355,0.000017699}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000017699}, {364,0.000026549}, {365,0.000000000}, {366,0.000013274}, {367,0.000000000}, {368,0.000017699}, {369,0.000035398}, {370,0.000000000}, {371,0.000000000}, {372,0.000017699}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000017699}, {377,0.000017699}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000017699}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000017699}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000017699}, {406,0.000000000}, {407,0.000017699}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000017699}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000017699}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000013274}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000013274}, {452,0.000000000}, {453,0.000000000}, {454,0.000035398}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000017699}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000017699}, {477,0.000000000}, {478,0.000017699}, {479,0.000000000}, {480,0.000017699}, {481,0.000000000}, {482,0.000000000}, {483,0.000013274}, {484,0.000000000}, {485,0.000017699}, {486,0.000017699}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000017699}, {494,0.000000000}, {495,0.000000000}, {496,0.000017699}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000017699}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000017699}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000017699}, {605,0.000000000}, {610,0.000035398}, {615,0.000000000}, {620,0.000000000}, {625,0.000017699}, {630,0.000000000}, {635,0.000017699}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000017699}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000035398}, {710,0.000017699}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000017699}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000017699}, {810,0.000017699}, {815,0.000000000}, {820,0.000017699}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000035398}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000017699}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000017699}, {1010,0.000017699}, {1020,0.000013274}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000017699}, {1100,0.000035398}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000017699}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000017699}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000017699}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000030973}, {1380,0.000017699}, {1390,0.000035398}, {1400,0.000035398}, {1410,0.000000000}, {1420,0.000017699}, {1430,0.000000000}, {1440,0.000017699}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000017699}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000017699}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000017699}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000035398}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000070796}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000035398}, {1730,0.000000000}, {1740,0.000030973}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000017699}, {1820,0.000000000}, {1830,0.000017699}, {1840,0.000017699}, {1850,0.000017699}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000035398}, {1910,0.000000000}, {1920,0.000035398}, {1930,0.000000000}, {1940,0.000017699}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000017699}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000017699}, {2150,0.000053097}, {2200,0.000017699}, {2250,0.000000000}, {2300,0.000035398}, {2350,0.000000000}, {2400,0.000017699}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000048673}, {2800,0.000000000}, {2850,0.000017699}, {2900,0.000044248}, {2950,0.000017699}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000030973}, {3150,0.000035398}, {3200,0.000013274}, {3250,0.000000000}, {3300,0.000017699}, {3350,0.000017699}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000035398}, {3650,0.000035398}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000053097}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000017699}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000017699}, {4200,0.000017699}, {4250,0.000017699}, {4300,0.000017699}, {4350,0.000000000}, {4400,0.000017699}, {4450,0.000035398}, {4500,0.000000000}, {4550,0.000017699}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000017699}, {4750,0.000000000}, {4800,0.000017699}, {4850,0.000000000}, {4900,0.000017699}, {4950,0.000000000}, {5000,0.000030973}, {5050,0.000017699}, {5100,0.000017699}, {5150,0.000000000}, {5200,0.000000000}, {5250,0.000000000}, {5300,0.000000000}, {5350,0.000017778}, {5400,0.000000000}, {5450,0.000035556}, {5500,0.000017778}, {5550,0.000000000}, {5600,0.000017778}, {5650,0.000035556}, {5700,0.000000000}, {5750,0.000017778}, {5800,0.000017778}, {5850,0.000000000}, {5900,0.000017778}, {5950,0.000000000}, {6000,0.000000000}, {6050,0.000000}, {6100,0.000444}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000222}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000222}, {7000,0.000389}, {7050,0.000444}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000222}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000222}, {7900,0.000222}, {7950,0.000000}, {8000,0.000000}, {8050,0.000167}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000167}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000222}, {8500,0.000000}, {8550,0.000222}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000222}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000222}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000222}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000222}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000222}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000222}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000222}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000222}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClasses"]["lazy beta iota"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000008850}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000207965}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000247788}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000017699}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.002433628}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.005553097}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000429204}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000420354}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000004425}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000004425}, {1990,0.007336283}, {2000,0.000022124}, {2050,0.000035398}, {2100,0.000132743}, {2150,0.000274336}, {2200,0.000393805}, {2250,0.000415929}, {2300,0.000522124}, {2350,0.000548673}, {2400,0.000668142}, {2450,0.000641593}, {2500,0.000951327}, {2550,0.000827434}, {2600,0.000871681}, {2650,0.000995575}, {2700,0.001000000}, {2750,0.001000000}, {2800,0.001000000}, {2850,0.001000000}, {2900,0.001000000}, {2950,0.001000000}, {3000,0.001000000}, {3050,0.001000000}, {3100,0.001000000}, {3150,0.001486726}, {3200,0.001000000}, {3250,0.001000000}, {3300,0.008464602}, {3350,0.001000000}, {3400,0.001000000}, {3450,0.008566372}, {3500,0.001000000}, {3550,0.001000000}, {3600,0.001137168}, {3650,0.001106195}, {3700,0.001004425}, {3750,0.001075221}, {3800,0.001008850}, {3850,0.001017699}, {3900,0.001066372}, {3950,0.001137168}, {4000,0.001137168}, {4050,0.001261062}, {4100,0.001398230}, {4150,0.001323009}, {4200,0.001376106}, {4250,0.001393805}, {4300,0.001402655}, {4350,0.001415929}, {4400,0.002000000}, {4450,0.001482301}, {4500,0.001486726}, {4550,0.001513274}, {4600,0.001539823}, {4650,0.001579646}, {4700,0.001615044}, {4750,0.001712389}, {4800,0.001787611}, {4850,0.001787611}, {4900,0.001800885}, {4950,0.002026549}, {5000,0.001862832}, {5050,0.001924779}, {5100,0.002185841}, {5150,0.002000000}, {5200,0.002000000}, {5250,0.002000000}, {5300,0.012080000}, {5350,0.002008889}, {5400,0.002000000}, {5450,0.002000000}, {5500,0.002004444}, {5550,0.002000000}, {5600,0.010146667}, {5650,0.002995556}, {5700,0.002022222}, {5750,0.002040000}, {5800,0.002102222}, {5850,0.002151111}, {5900,0.003128889}, {5950,0.002231111}, {6000,0.002280000}, {6050,0.002167}, {6100,0.002167}, {6150,0.002056}, {6200,0.002167}, {6250,0.002167}, {6300,0.002167}, {6350,0.002167}, {6400,0.002167}, {6450,0.002167}, {6500,0.002167}, {6550,0.002167}, {6600,0.003278}, {6650,0.002222}, {6700,0.002222}, {6750,0.002278}, {6800,0.002444}, {6850,0.002556}, {6900,0.003833}, {6950,0.002611}, {7000,0.002667}, {7050,0.002667}, {7100,0.022000}, {7150,0.028333}, {7200,0.003000}, {7250,0.003000}, {7300,0.003000}, {7350,0.003000}, {7400,0.003000}, {7450,0.003000}, {7500,0.003056}, {7550,0.003000}, {7600,0.003000}, {7650,0.003000}, {7700,0.003000}, {7750,0.003111}, {7800,0.019833}, {7850,0.003056}, {7900,0.003111}, {7950,0.003111}, {8000,0.007778}, {8050,0.003167}, {8100,0.003167}, {8150,0.003111}, {8200,0.003167}, {8250,0.008167}, {8300,0.003167}, {8350,0.003167}, {8400,0.007833}, {8450,0.003167}, {8500,0.003167}, {8550,0.003167}, {8600,0.004000}, {8650,0.003278}, {8700,0.003222}, {8750,0.003500}, {8800,0.003333}, {8850,0.003611}, {8900,0.003611}, {8950,0.003556}, {9000,0.003611}, {9050,0.003556}, {9100,0.003667}, {9150,0.003556}, {9200,0.003611}, {9250,0.003667}, {9300,0.003722}, {9350,0.003944}, {9400,0.004000}, {9450,0.003944}, {9500,0.003944}, {9550,0.003944}, {9600,0.003889}, {9650,0.003944}, {9700,0.003944}, {9750,0.020500}, {9800,0.004056}, {9850,0.004000}, {9900,0.004167}, {9950,0.004167}, {10000,0.004222}, {10100,0.004222}, {10200,0.004222}, {10300,0.004222}, {10400,0.004389}, {10500,0.004278}, {10600,0.004222}, {10700,0.005611}, {10800,0.019111}, {10900,0.004556}, {11000,0.004444}, {11100,0.004500}, {11200,0.004500}, {11300,0.004500}, {11400,0.004500}, {11500,0.004611}, {11600,0.004889}, {11700,0.005889}, {11800,0.005167}, {11900,0.005222}, {12000,0.005167}, {12100,0.006167}, {12200,0.019500}, {12300,0.005222}, {12400,0.005222}, {12500,0.005222}, {12600,0.005222}, {12700,0.005278}, {12800,0.005278}, {12900,0.005333}, {13000,0.005444}, {13100,0.005500}, {13200,0.005556}, {13300,0.005500}, {13400,0.005556}, {13500,0.005611}, {13600,0.022444}, {13700,0.007167}, {13800,0.006111}, {13900,0.006222}, {14000,0.006167}, {14100,0.006167}, {14200,0.006222}, {14300,0.006222}, {14400,0.006222}, {14500,0.006278}, {14600,0.006222}, {14700,0.006278}, {14800,0.006333}, {14900,0.006389}, {15000,0.006500}, {15100,0.006500}, {15200,0.006500}, {15300,0.006444}, {15400,0.024000}, {15500,0.006667}, {15600,0.012778}, {15700,0.007000}, {15800,0.007111}, {15900,0.014722}, {16000,0.022167}, {16100,0.007222}, {16200,0.007167}, {16300,0.007222}, {16400,0.007222}, {16500,0.008556}, {16600,0.015056}, {16700,0.007278}, {16800,0.007333}, {16900,0.007333}, {17000,0.007556}, {17100,0.007556}, {17200,0.007556}, {17300,0.030000}, {17400,0.007556}, {17500,0.008833}, {17600,0.007611}, {17700,0.007889}, {17800,0.015667}, {17900,0.008111}, {18000,0.008056}, {18100,0.008111}, {18200,0.032056}, {18300,0.025222}, {18400,0.008111}, {18500,0.015556}, {18600,0.008278}, {18700,0.008389}, {18800,0.008389}, {18900,0.008556}, {19000,0.008556}, {19100,0.216444}, {19200,0.014278}, {19300,0.008722}, {19400,0.008667}, {19500,0.008778}, {19600,0.008944}, {19700,0.011056}, {19800,0.009167}, {19900,0.010778}, {20000,0.009062}};
data["big_flat"]["TypeClasses"]["lazy beta iota"]["user"] = {{1,0.000013333}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000017699}, {9,0.000000000}, {10,0.000017699}, {11,0.000013274}, {12,0.000026549}, {13,0.000048673}, {14,0.000000000}, {15,0.000030973}, {16,0.000013274}, {17,0.000013274}, {18,0.000030973}, {19,0.000000000}, {20,0.000017699}, {21,0.000030973}, {22,0.000000000}, {23,0.000035398}, {24,0.000000000}, {25,0.000000000}, {26,0.000017699}, {27,0.000048673}, {28,0.000026549}, {29,0.000026549}, {30,0.000013274}, {31,0.000000000}, {32,0.000000000}, {33,0.000061947}, {34,0.000048673}, {35,0.000035398}, {36,0.000013274}, {37,0.000070796}, {38,0.000048673}, {39,0.000017699}, {40,0.000044248}, {41,0.000030973}, {42,0.000013274}, {43,0.000053097}, {44,0.000035398}, {45,0.000035398}, {46,0.000013274}, {47,0.000110619}, {48,0.000035398}, {49,0.000053097}, {50,0.000035398}, {51,0.000030973}, {52,0.000030973}, {53,0.000026549}, {54,0.000035398}, {55,0.000057522}, {56,0.000092920}, {57,0.000000000}, {58,0.000035398}, {59,0.000044248}, {60,0.000097345}, {61,0.000044248}, {62,0.000061947}, {63,0.000066372}, {64,0.000013274}, {65,0.000092920}, {66,0.000017699}, {67,0.000053097}, {68,0.000079646}, {69,0.000053097}, {70,0.000026549}, {71,0.000035398}, {72,0.000075221}, {73,0.000026549}, {74,0.000061947}, {75,0.000026549}, {76,0.000048673}, {77,0.000026549}, {78,0.000181416}, {79,0.000092920}, {80,0.000013274}, {81,0.000013274}, {82,0.000013274}, {83,0.000000000}, {84,0.000017699}, {85,0.000061947}, {86,0.000030973}, {87,0.000057522}, {88,0.000079646}, {89,0.000101770}, {90,0.000066372}, {91,0.000075221}, {92,0.000066372}, {93,0.000092920}, {94,0.000044248}, {95,0.000017699}, {96,0.000128319}, {97,0.000017699}, {98,0.000061947}, {99,0.000017699}, {100,0.000044248}, {101,0.000088496}, {102,0.000057522}, {103,0.000057522}, {104,0.000057522}, {105,0.000097345}, {106,0.000048673}, {107,0.000026549}, {108,0.000084071}, {109,0.000035398}, {110,0.000088496}, {111,0.000088496}, {112,0.000110619}, {113,0.000128319}, {114,0.000075221}, {115,0.000039823}, {116,0.000057522}, {117,0.000075221}, {118,0.000057522}, {119,0.000075221}, {120,0.000079646}, {121,0.000066372}, {122,0.000075221}, {123,0.000066372}, {124,0.000088496}, {125,0.000061947}, {126,0.000075221}, {127,0.000075221}, {128,0.000044248}, {129,0.000110619}, {130,0.000000000}, {131,0.000013274}, {132,0.000053097}, {133,0.000119469}, {134,0.000026549}, {135,0.000066372}, {136,0.000079646}, {137,0.000053097}, {138,0.000057522}, {139,0.000048673}, {140,0.000057522}, {141,0.000075221}, {142,0.000066372}, {143,0.000084071}, {144,0.000119469}, {145,0.000079646}, {146,0.000079646}, {147,0.000013274}, {148,0.000053097}, {149,0.000066372}, {150,0.000061947}, {151,0.000092920}, {152,0.000084071}, {153,0.000075221}, {154,0.000075221}, {155,0.000039823}, {156,0.000097345}, {157,0.000261062}, {158,0.000070796}, {159,0.000039823}, {160,0.000066372}, {161,0.000115044}, {162,0.000172566}, {163,0.000101770}, {164,0.000079646}, {165,0.000066372}, {166,0.000115044}, {167,0.000079646}, {168,0.000013274}, {169,0.000075221}, {170,0.000057522}, {171,0.000057522}, {172,0.000061947}, {173,0.000123894}, {174,0.000053097}, {175,0.000137168}, {176,0.000088496}, {177,0.000123894}, {178,0.000053097}, {179,0.000079646}, {180,0.000106195}, {181,0.000123894}, {182,0.000084071}, {183,0.000048673}, {184,0.000075221}, {185,0.000088496}, {186,0.000163717}, {187,0.000079646}, {188,0.000119469}, {189,0.000128319}, {190,0.000115044}, {191,0.000150442}, {192,0.000150442}, {193,0.000101770}, {194,0.000088496}, {195,0.000084071}, {196,0.000159292}, {197,0.000070796}, {198,0.000101770}, {199,0.000044248}, {200,0.000079646}, {201,0.000123894}, {202,0.000039823}, {203,0.000110619}, {204,0.000123894}, {205,0.000106195}, {206,0.000097345}, {207,0.000101770}, {208,0.000132743}, {209,0.000101770}, {210,0.000115044}, {211,0.000057522}, {212,0.000119469}, {213,0.000092920}, {214,0.000199115}, {215,0.000084071}, {216,0.000137168}, {217,0.000057522}, {218,0.000141593}, {219,0.000079646}, {220,0.000044248}, {221,0.000079646}, {222,0.000159292}, {223,0.000119469}, {224,0.000061947}, {225,0.000128319}, {226,0.000159292}, {227,0.000079646}, {228,0.000119469}, {229,0.000146018}, {230,0.000097345}, {231,0.000079646}, {232,0.000150442}, {233,0.000185841}, {234,0.000176991}, {235,0.000123894}, {236,0.000079646}, {237,0.000079646}, {238,0.000110619}, {239,0.000141593}, {240,0.000079646}, {241,0.000106195}, {242,0.000070796}, {243,0.000084071}, {244,0.000097345}, {245,0.000221239}, {246,0.000092920}, {247,0.000057522}, {248,0.000176991}, {249,0.000097345}, {250,0.000061947}, {251,0.000079646}, {252,0.000092920}, {253,0.000221239}, {254,0.000128319}, {255,0.000141593}, {256,0.000048673}, {257,0.000092920}, {258,0.000084071}, {259,0.000146018}, {260,0.000106195}, {261,0.000044248}, {262,0.000132743}, {263,0.000119469}, {264,0.000168142}, {265,0.000092920}, {266,0.000159292}, {267,0.000132743}, {268,0.000079646}, {269,0.000110619}, {270,0.000119469}, {271,0.000190265}, {272,0.000207965}, {273,0.000119469}, {274,0.000084071}, {275,0.000159292}, {276,0.000146018}, {277,0.000110619}, {278,0.000146018}, {279,0.000075221}, {280,0.000123894}, {281,0.000061947}, {282,0.000154867}, {283,0.000079646}, {284,0.000092920}, {285,0.000159292}, {286,0.000115044}, {287,0.000053097}, {288,0.000106195}, {289,0.000115044}, {290,0.000172566}, {291,0.000106195}, {292,0.000092920}, {293,0.000084071}, {294,0.000146018}, {295,0.000141593}, {296,0.000110619}, {297,0.000154867}, {298,0.000194690}, {299,0.000119469}, {300,0.000163717}, {301,0.000194690}, {302,0.000088496}, {303,0.000097345}, {304,0.000092920}, {305,0.000128319}, {306,0.000092920}, {307,0.000163717}, {308,0.000234513}, {309,0.000079646}, {310,0.000106195}, {311,0.000132743}, {312,0.000048673}, {313,0.000159292}, {314,0.000110619}, {315,0.000154867}, {316,0.000141593}, {317,0.000123894}, {318,0.000106195}, {319,0.000119469}, {320,0.000123894}, {321,0.000203540}, {322,0.000097345}, {323,0.000163717}, {324,0.000106195}, {325,0.000132743}, {326,0.000048673}, {327,0.000141593}, {328,0.000092920}, {329,0.000247788}, {330,0.000194690}, {331,0.000061947}, {332,0.000146018}, {333,0.000092920}, {334,0.000234513}, {335,0.000216814}, {336,0.000154867}, {337,0.000150442}, {338,0.000234513}, {339,0.000115044}, {340,0.000199115}, {341,0.000150442}, {342,0.000070796}, {343,0.000088496}, {344,0.000137168}, {345,0.000092920}, {346,0.000261062}, {347,0.000044248}, {348,0.000150442}, {349,0.000119469}, {350,0.000203540}, {351,0.000163717}, {352,0.000128319}, {353,0.000092920}, {354,0.000221239}, {355,0.000092920}, {356,0.000110619}, {357,0.000128319}, {358,0.000123894}, {359,0.000154867}, {360,0.000154867}, {361,0.000119469}, {362,0.000230088}, {363,0.000097345}, {364,0.000190265}, {365,0.000199115}, {366,0.000168142}, {367,0.000070796}, {368,0.000132743}, {369,0.000106195}, {370,0.000101770}, {371,0.000150442}, {372,0.000146018}, {373,0.000154867}, {374,0.000084071}, {375,0.000141593}, {376,0.000088496}, {377,0.000146018}, {378,0.000176991}, {379,0.000141593}, {380,0.000141593}, {381,0.000070796}, {382,0.000119469}, {383,0.000185841}, {384,0.000057522}, {385,0.000061947}, {386,0.000243363}, {387,0.000216814}, {388,0.000176991}, {389,0.000163717}, {390,0.000176991}, {391,0.000097345}, {392,0.000097345}, {393,0.000190265}, {394,0.000159292}, {395,0.000132743}, {396,0.000159292}, {397,0.000101770}, {398,0.000199115}, {399,0.000194690}, {400,0.000154867}, {401,0.000137168}, {402,0.000185841}, {403,0.000159292}, {404,0.000115044}, {405,0.000075221}, {406,0.000084071}, {407,0.000048673}, {408,0.000075221}, {409,0.000203540}, {410,0.000181416}, {411,0.000203540}, {412,0.000128319}, {413,0.000084071}, {414,0.000225664}, {415,0.000225664}, {416,0.000092920}, {417,0.000123894}, {418,0.000101770}, {419,0.000203540}, {420,0.000225664}, {421,0.000216814}, {422,0.000115044}, {423,0.000150442}, {424,0.000168142}, {425,0.000261062}, {426,0.000185841}, {427,0.000194690}, {428,0.000132743}, {429,0.000154867}, {430,0.000115044}, {431,0.000146018}, {432,0.000084071}, {433,0.000212389}, {434,0.000176991}, {435,0.000243363}, {436,0.000123894}, {437,0.000199115}, {438,0.000075221}, {439,0.000123894}, {440,0.000247788}, {441,0.000181416}, {442,0.000238938}, {443,0.000163717}, {444,0.000132743}, {445,0.000477876}, {446,0.000199115}, {447,0.000075221}, {448,0.000106195}, {449,0.000238938}, {450,0.000230088}, {451,0.000172566}, {452,0.000088496}, {453,0.000216814}, {454,0.000203540}, {455,0.000247788}, {456,0.000216814}, {457,0.000234513}, {458,0.000075221}, {459,0.000238938}, {460,0.000207965}, {461,0.000159292}, {462,0.000238938}, {463,0.000106195}, {464,0.000101770}, {465,0.000097345}, {466,0.000137168}, {467,0.000212389}, {468,0.000190265}, {469,0.000123894}, {470,0.000141593}, {471,0.000154867}, {472,0.000092920}, {473,0.000216814}, {474,0.000287611}, {475,0.000287611}, {476,0.000221239}, {477,0.000225664}, {478,0.000238938}, {479,0.000296460}, {480,0.000194690}, {481,0.000092920}, {482,0.000176991}, {483,0.000176991}, {484,0.000238938}, {485,0.000172566}, {486,0.000194690}, {487,0.000176991}, {488,0.000199115}, {489,0.000110619}, {490,0.000238938}, {491,0.000123894}, {492,0.000252212}, {493,0.000225664}, {494,0.000216814}, {495,0.000203540}, {496,0.000163717}, {497,0.000146018}, {498,0.000172566}, {499,0.000247788}, {500,0.000367257}, {505,0.000212389}, {510,0.000168142}, {515,0.000079646}, {520,0.000225664}, {525,0.000216814}, {530,0.000163717}, {535,0.000146018}, {540,0.000274336}, {545,0.000199115}, {550,0.000261062}, {555,0.000247788}, {560,0.000234513}, {565,0.000300885}, {570,0.000137168}, {575,0.002707965}, {580,0.000238938}, {585,0.000305310}, {590,0.000168142}, {595,0.000323009}, {600,0.000371681}, {605,0.000345133}, {610,0.000150442}, {615,0.000207965}, {620,0.000256637}, {625,0.000252212}, {630,0.000287611}, {635,0.000336283}, {640,0.000323009}, {645,0.000376106}, {650,0.000216814}, {655,0.000323009}, {660,0.000261062}, {665,0.000283186}, {670,0.000287611}, {675,0.000261062}, {680,0.000128319}, {685,0.000269912}, {690,0.000265487}, {695,0.000305310}, {700,0.000314159}, {705,0.000216814}, {710,0.000314159}, {715,0.000371681}, {720,0.000292035}, {725,0.000216814}, {730,0.000283186}, {735,0.000323009}, {740,0.000278761}, {745,0.000300885}, {750,0.000185841}, {755,0.000309735}, {760,0.000345133}, {765,0.000221239}, {770,0.000380531}, {775,0.000287611}, {780,0.000212389}, {785,0.000261062}, {790,0.000212389}, {795,0.000340708}, {800,0.000296460}, {805,0.000274336}, {810,0.000442478}, {815,0.000367257}, {820,0.005800885}, {825,0.000274336}, {830,0.000327434}, {835,0.000362832}, {840,0.000199115}, {845,0.000362832}, {850,0.000398230}, {855,0.000424779}, {860,0.000415929}, {865,0.000283186}, {870,0.000336283}, {875,0.000340708}, {880,0.000247788}, {885,0.000287611}, {890,0.000433628}, {895,0.000327434}, {900,0.000238938}, {905,0.000402655}, {910,0.000420354}, {915,0.000212389}, {920,0.000769912}, {925,0.000407080}, {930,0.000345133}, {935,0.000318584}, {940,0.000517699}, {945,0.000469027}, {950,0.000433628}, {955,0.000362832}, {960,0.000309735}, {965,0.000376106}, {970,0.000283186}, {975,0.000274336}, {980,0.000384956}, {985,0.000477876}, {990,0.000393805}, {995,0.000340708}, {1000,0.000278761}, {1010,0.000371681}, {1020,0.000384956}, {1030,0.000380531}, {1040,0.000486726}, {1050,0.000455752}, {1060,0.000442478}, {1070,0.000393805}, {1080,0.000402655}, {1090,0.000530973}, {1100,0.000358407}, {1110,0.000588496}, {1120,0.000429204}, {1130,0.000438053}, {1140,0.000362832}, {1150,0.000455752}, {1160,0.000438053}, {1170,0.000809735}, {1180,0.000420354}, {1190,0.000455752}, {1200,0.000464602}, {1210,0.000513274}, {1220,0.000420354}, {1230,0.000446903}, {1240,0.000522124}, {1250,0.000442478}, {1260,0.000460177}, {1270,0.000561947}, {1280,0.000495575}, {1290,0.000539823}, {1300,0.000641593}, {1310,0.000415929}, {1320,0.000553097}, {1330,0.000517699}, {1340,0.000606195}, {1350,0.000641593}, {1360,0.000632743}, {1370,0.000592920}, {1380,0.000398230}, {1390,0.000495575}, {1400,0.000561947}, {1410,0.000606195}, {1420,0.000646018}, {1430,0.000654867}, {1440,0.000632743}, {1450,0.000548673}, {1460,0.000446903}, {1470,0.000561947}, {1480,0.000504425}, {1490,0.000535398}, {1500,0.000464602}, {1510,0.000606195}, {1520,0.000522124}, {1530,0.000455752}, {1540,0.000473451}, {1550,0.000646018}, {1560,0.000628319}, {1570,0.000685841}, {1580,0.000535398}, {1590,0.000659292}, {1600,0.000615044}, {1610,0.000632743}, {1620,0.000486726}, {1630,0.000504425}, {1640,0.000579646}, {1650,0.000460177}, {1660,0.000628319}, {1670,0.000460177}, {1680,0.000442478}, {1690,0.000548673}, {1700,0.000752212}, {1710,0.000464602}, {1720,0.000597345}, {1730,0.000637168}, {1740,0.000610619}, {1750,0.000712389}, {1760,0.000641593}, {1770,0.000601770}, {1780,0.000491150}, {1790,0.000787611}, {1800,0.000619469}, {1810,0.000694690}, {1820,0.000601770}, {1830,0.000809735}, {1840,0.000557522}, {1850,0.000566372}, {1860,0.000774336}, {1870,0.000654867}, {1880,0.000610619}, {1890,0.000725664}, {1900,0.000588496}, {1910,0.000721239}, {1920,0.000592920}, {1930,0.000699115}, {1940,0.000659292}, {1950,0.000814159}, {1960,0.000703540}, {1970,0.000646018}, {1980,0.000592920}, {1990,0.007734513}, {2000,0.000668142}, {2050,0.000690265}, {2100,0.000845133}, {2150,0.000601770}, {2200,0.000907080}, {2250,0.000991150}, {2300,0.000831858}, {2350,0.000756637}, {2400,0.001013274}, {2450,0.000942478}, {2500,0.000818584}, {2550,0.000747788}, {2600,0.000977876}, {2650,0.000924779}, {2700,0.001292035}, {2750,0.001053097}, {2800,0.000889381}, {2850,0.001035398}, {2900,0.001128319}, {2950,0.001194690}, {3000,0.001110619}, {3050,0.001216814}, {3100,0.001146018}, {3150,0.001911504}, {3200,0.001327434}, {3250,0.001061947}, {3300,0.008597345}, {3350,0.001371681}, {3400,0.001230088}, {3450,0.008787611}, {3500,0.001181416}, {3550,0.001349558}, {3600,0.001446903}, {3650,0.001668142}, {3700,0.001389381}, {3750,0.001415929}, {3800,0.001500000}, {3850,0.001486726}, {3900,0.001668142}, {3950,0.001522124}, {4000,0.001646018}, {4050,0.001646018}, {4100,0.001783186}, {4150,0.001641593}, {4200,0.001703540}, {4250,0.001429204}, {4300,0.001694690}, {4350,0.001752212}, {4400,0.002154867}, {4450,0.001796460}, {4500,0.001716814}, {4550,0.001721239}, {4600,0.001703540}, {4650,0.002008850}, {4700,0.001703540}, {4750,0.001951327}, {4800,0.001973451}, {4850,0.002004425}, {4900,0.001929204}, {4950,0.002194690}, {5000,0.002030973}, {5050,0.001946903}, {5100,0.002079646}, {5150,0.002079646}, {5200,0.002194690}, {5250,0.002235556}, {5300,0.012320000}, {5350,0.002160000}, {5400,0.002440000}, {5450,0.002315556}, {5500,0.002226667}, {5550,0.002368889}, {5600,0.010297778}, {5650,0.003097778}, {5700,0.002333333}, {5750,0.002484444}, {5800,0.002244444}, {5850,0.002533333}, {5900,0.003480000}, {5950,0.002657778}, {6000,0.002480000}, {6050,0.002056}, {6100,0.001500}, {6150,0.002556}, {6200,0.002611}, {6250,0.002889}, {6300,0.002500}, {6350,0.002833}, {6400,0.001833}, {6450,0.001833}, {6500,0.002389}, {6550,0.002167}, {6600,0.003778}, {6650,0.002722}, {6700,0.003222}, {6750,0.002389}, {6800,0.002778}, {6850,0.001833}, {6900,0.004167}, {6950,0.002278}, {7000,0.002389}, {7050,0.002611}, {7100,0.022167}, {7150,0.028889}, {7200,0.002389}, {7250,0.002278}, {7300,0.002444}, {7350,0.002389}, {7400,0.002833}, {7450,0.002944}, {7500,0.003056}, {7550,0.002611}, {7600,0.003000}, {7650,0.003167}, {7700,0.002833}, {7750,0.002333}, {7800,0.019833}, {7850,0.003222}, {7900,0.002944}, {7950,0.002944}, {8000,0.007611}, {8050,0.003000}, {8100,0.002333}, {8150,0.003333}, {8200,0.002556}, {8250,0.008222}, {8300,0.003500}, {8350,0.002889}, {8400,0.008389}, {8450,0.003389}, {8500,0.003389}, {8550,0.003000}, {8600,0.004056}, {8650,0.003556}, {8700,0.002889}, {8750,0.003667}, {8800,0.003722}, {8850,0.003611}, {8900,0.003944}, {8950,0.003722}, {9000,0.003833}, {9050,0.003833}, {9100,0.003500}, {9150,0.003944}, {9200,0.004167}, {9250,0.003556}, {9300,0.003389}, {9350,0.003667}, {9400,0.004333}, {9450,0.003778}, {9500,0.004000}, {9550,0.003889}, {9600,0.004556}, {9650,0.004444}, {9700,0.004056}, {9750,0.020222}, {9800,0.004444}, {9850,0.004000}, {9900,0.003667}, {9950,0.004167}, {10000,0.003944}, {10100,0.004389}, {10200,0.004222}, {10300,0.004167}, {10400,0.004278}, {10500,0.004222}, {10600,0.004000}, {10700,0.006278}, {10800,0.020278}, {10900,0.004722}, {11000,0.005000}, {11100,0.005556}, {11200,0.004500}, {11300,0.004278}, {11400,0.004889}, {11500,0.005222}, {11600,0.005167}, {11700,0.005722}, {11800,0.005611}, {11900,0.005611}, {12000,0.004444}, {12100,0.005611}, {12200,0.019444}, {12300,0.005444}, {12400,0.005611}, {12500,0.005889}, {12600,0.004833}, {12700,0.005778}, {12800,0.005389}, {12900,0.006278}, {13000,0.006444}, {13100,0.006278}, {13200,0.005556}, {13300,0.005500}, {13400,0.005611}, {13500,0.005889}, {13600,0.023111}, {13700,0.006944}, {13800,0.006611}, {13900,0.006389}, {14000,0.005778}, {14100,0.006778}, {14200,0.005667}, {14300,0.005833}, {14400,0.006889}, {14500,0.006278}, {14600,0.006111}, {14700,0.007500}, {14800,0.007167}, {14900,0.006167}, {15000,0.006722}, {15100,0.006167}, {15200,0.007000}, {15300,0.006500}, {15400,0.024167}, {15500,0.006778}, {15600,0.013611}, {15700,0.007389}, {15800,0.006611}, {15900,0.015111}, {16000,0.022000}, {16100,0.006944}, {16200,0.007333}, {16300,0.007222}, {16400,0.007000}, {16500,0.009167}, {16600,0.014667}, {16700,0.007722}, {16800,0.007444}, {16900,0.007667}, {17000,0.007889}, {17100,0.008333}, {17200,0.008111}, {17300,0.030222}, {17400,0.007944}, {17500,0.008667}, {17600,0.008444}, {17700,0.008500}, {17800,0.015778}, {17900,0.008667}, {18000,0.008000}, {18100,0.008444}, {18200,0.032000}, {18300,0.025944}, {18400,0.008500}, {18500,0.015500}, {18600,0.008889}, {18700,0.008333}, {18800,0.008389}, {18900,0.008000}, {19000,0.009389}, {19100,0.216556}, {19200,0.014278}, {19300,0.008944}, {19400,0.009167}, {19500,0.009000}, {19600,0.009111}, {19700,0.011500}, {19800,0.008556}, {19900,0.010389}, {20000,0.009188}};
data["big_flat"]["TypeClasses"]["lazy beta iota"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000017699}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000013274}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000017699}, {56,0.000000000}, {57,0.000000000}, {58,0.000030973}, {59,0.000000000}, {60,0.000000000}, {61,0.000013274}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000017699}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000017699}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000017699}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000017699}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000017699}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000017699}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000017699}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000017699}, {202,0.000013274}, {203,0.000000000}, {204,0.000000000}, {205,0.000017699}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000017699}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000017699}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000017699}, {234,0.000000000}, {235,0.000017699}, {236,0.000000000}, {237,0.000013274}, {238,0.000013274}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000017699}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000030973}, {252,0.000035398}, {253,0.000000000}, {254,0.000017699}, {255,0.000000000}, {256,0.000000000}, {257,0.000017699}, {258,0.000000000}, {259,0.000000000}, {260,0.000013274}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000017699}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000017699}, {277,0.000013274}, {278,0.000013274}, {279,0.000017699}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000013274}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000017699}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000030973}, {302,0.000000000}, {303,0.000000000}, {304,0.000017699}, {305,0.000000000}, {306,0.000035398}, {307,0.000000000}, {308,0.000017699}, {309,0.000000000}, {310,0.000017699}, {311,0.000000000}, {312,0.000017699}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000035398}, {320,0.000000000}, {321,0.000000000}, {322,0.000017699}, {323,0.000000000}, {324,0.000013274}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000017699}, {336,0.000000000}, {337,0.000017699}, {338,0.000017699}, {339,0.000000000}, {340,0.000017699}, {341,0.000000000}, {342,0.000000000}, {343,0.000017699}, {344,0.000000000}, {345,0.000000000}, {346,0.000017699}, {347,0.000017699}, {348,0.000000000}, {349,0.000035398}, {350,0.000017699}, {351,0.000035398}, {352,0.000000000}, {353,0.000017699}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000017699}, {360,0.000017699}, {361,0.000013274}, {362,0.000017699}, {363,0.000000000}, {364,0.000053097}, {365,0.000013274}, {366,0.000000000}, {367,0.000017699}, {368,0.000000000}, {369,0.000017699}, {370,0.000000000}, {371,0.000000000}, {372,0.000017699}, {373,0.000000000}, {374,0.000017699}, {375,0.000017699}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000017699}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000017699}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000035398}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000017699}, {450,0.000000000}, {451,0.000017699}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000017699}, {456,0.000000000}, {457,0.000000000}, {458,0.000017699}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000017699}, {465,0.000017699}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000017699}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000017699}, {493,0.000017699}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000017699}, {498,0.000017699}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000017699}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000017699}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000017699}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000017699}, {600,0.000000000}, {605,0.000000000}, {610,0.000017699}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000017699}, {635,0.000017699}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000017699}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000017699}, {770,0.000000000}, {775,0.000017699}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000035398}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000017699}, {855,0.000017699}, {860,0.000017699}, {865,0.000000000}, {870,0.000000000}, {875,0.000017699}, {880,0.000000000}, {885,0.000013274}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000017699}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000035398}, {970,0.000000000}, {975,0.000000000}, {980,0.000017699}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000017699}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000017699}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000035398}, {1180,0.000017699}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000017699}, {1230,0.000017699}, {1240,0.000000000}, {1250,0.000017699}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000017699}, {1300,0.000017699}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000017699}, {1340,0.000017699}, {1350,0.000013274}, {1360,0.000017699}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000017699}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000035398}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000035398}, {1550,0.000000000}, {1560,0.000017699}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000070796}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000017699}, {1750,0.000000000}, {1760,0.000013274}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000017699}, {1810,0.000017699}, {1820,0.000035398}, {1830,0.000000000}, {1840,0.000017699}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000030973}, {1910,0.000035398}, {1920,0.000000000}, {1930,0.000017699}, {1940,0.000017699}, {1950,0.000013274}, {1960,0.000017699}, {1970,0.000017699}, {1980,0.000000000}, {1990,0.000017699}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000017699}, {2400,0.000017699}, {2450,0.000000000}, {2500,0.000017699}, {2550,0.000035398}, {2600,0.000017699}, {2650,0.000017699}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000017699}, {3000,0.000000000}, {3050,0.000017699}, {3100,0.000013274}, {3150,0.000000000}, {3200,0.000017699}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000035398}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000017699}, {3550,0.000017699}, {3600,0.000035398}, {3650,0.000035398}, {3700,0.000017699}, {3750,0.000000000}, {3800,0.000017699}, {3850,0.000000000}, {3900,0.000013274}, {3950,0.000017699}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000017699}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000017699}, {4300,0.000000000}, {4350,0.000013274}, {4400,0.000013274}, {4450,0.000000000}, {4500,0.000013274}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000017699}, {4700,0.000000000}, {4750,0.000035398}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000017699}, {5000,0.000000000}, {5050,0.000017699}, {5100,0.000017699}, {5150,0.000000000}, {5200,0.000053097}, {5250,0.000017778}, {5300,0.000017778}, {5350,0.000017778}, {5400,0.000000000}, {5450,0.000035556}, {5500,0.000000000}, {5550,0.000053333}, {5600,0.000026667}, {5650,0.000000000}, {5700,0.000017778}, {5750,0.000017778}, {5800,0.000000000}, {5850,0.000000000}, {5900,0.000017778}, {5950,0.000017778}, {6000,0.000035556}, {6050,0.000667}, {6100,0.000444}, {6150,0.000000}, {6200,0.000167}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000222}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000167}, {8500,0.000167}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000222}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000222}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000222}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000222}, {12100,0.000222}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000222}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000222}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClasses"]["norm reif"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000725664}, {5,0.001000000}, {6,0.001000000}, {7,0.001004425}, {8,0.001570796}, {9,0.002000000}, {10,0.002000000}, {11,0.002154867}, {12,0.002650442}, {13,0.003000000}, {14,0.003000000}, {15,0.003650442}, {16,0.003694690}, {17,0.004000000}, {18,0.004092920}, {19,0.004902655}, {20,0.004982301}, {21,0.005066372}, {22,0.012411504}, {23,0.006101770}, {24,0.005977876}, {25,0.006230088}, {26,0.006681416}, {27,0.007632743}, {28,0.007026549}, {29,0.007734513}, {30,0.008008850}, {31,0.008513274}, {32,0.008039823}, {33,0.008747788}, {34,0.009022124}, {35,0.010212389}, {36,0.009424779}, {37,0.010181416}, {38,0.010323009}, {39,0.011181416}, {40,0.010424779}, {41,0.011654867}, {42,0.011517699}, {43,0.012265487}, {44,0.012703540}, {45,0.012800885}, {46,0.013800885}, {47,0.013840708}, {48,0.012699115}, {49,0.013659292}, {50,0.013827434}, {51,0.015504425}, {52,0.015084071}, {53,0.015371681}, {54,0.015601770}, {55,0.016681416}, {56,0.015314159}, {57,0.016424779}, {58,0.017818584}, {59,0.017716814}, {60,0.017039823}, {61,0.018269912}, {62,0.018451327}, {63,0.019659292}, {64,0.019221239}, {65,0.018792035}, {66,0.018955752}, {67,0.020942478}, {68,0.019535398}, {69,0.020716814}, {70,0.020876106}, {71,0.022243363}, {72,0.020734513}, {73,0.021778761}, {74,0.024013274}, {75,0.023438053}, {76,0.022592920}, {77,0.025190265}, {78,0.023960177}, {79,0.027119469}, {80,0.023650442}, {81,0.024141593}, {82,0.024407080}, {83,0.027982301}, {84,0.024929204}, {85,0.026455752}, {86,0.026601770}, {87,0.029610619}, {88,0.027044248}, {89,0.027526549}, {90,0.027876106}, {91,0.031526549}, {92,0.028398230}, {93,0.031544248}, {94,0.030075221}, {95,0.033438053}, {96,0.027730088}, {97,0.029234513}, {98,0.030646018}, {99,0.031398230}, {100,0.030039823}, {101,0.031823009}, {102,0.033955752}, {103,0.034774336}, {104,0.031128319}, {105,0.036982301}, {106,0.033168142}, {107,0.036212389}, {108,0.033858407}, {109,0.035539823}, {110,0.035632743}, {111,0.037623894}, {112,0.033424779}, {113,0.035526549}, {114,0.035495575}, {115,0.038057522}, {116,0.036362832}, {117,0.038119469}, {118,0.038353982}, {119,0.040606195}, {120,0.038712389}, {121,0.041022124}, {122,0.039601770}, {123,0.046000000}, {124,0.040008850}, {125,0.044451327}, {126,0.043508850}, {127,0.044327434}, {128,0.040243363}, {129,0.040579646}, {130,0.040557522}, {131,0.045575221}, {132,0.042238938}, {133,0.043539823}, {134,0.045190265}, {135,0.045836283}, {136,0.046190265}, {137,0.046898230}, {138,0.044716814}, {139,0.049039823}, {140,0.045150442}, {141,0.051035398}, {142,0.049845133}, {143,0.053017699}, {144,0.044460177}, {145,0.048915929}, {146,0.048168142}, {147,0.051389381}, {148,0.050915929}, {149,0.050154867}, {150,0.057712389}, {151,0.055862832}, {152,0.051407080}, {153,0.052690265}, {154,0.058738938}, {155,0.054230088}, {156,0.056588496}, {157,0.057424779}, {158,0.057690265}, {159,0.057380531}, {160,0.051318584}, {161,0.052292035}, {162,0.052331858}, {163,0.058035398}, {164,0.055907080}, {165,0.058039823}, {166,0.056039823}, {167,0.062800885}, {168,0.056756637}, {169,0.058597345}, {170,0.056902655}, {171,0.063415929}, {172,0.064150442}, {173,0.060460177}, {174,0.063216814}, {175,0.063393805}, {176,0.060570796}, {177,0.061933628}, {178,0.063393805}, {179,0.062389381}, {180,0.063305310}, {181,0.067221239}, {182,0.066738938}, {183,0.069942478}, {184,0.060991150}, {185,0.065424779}, {186,0.064982301}, {187,0.072982301}, {188,0.070659292}, {189,0.070787611}, {190,0.073535398}, {191,0.071455752}, {192,0.061694690}, {193,0.063110619}, {194,0.065154867}, {195,0.073353982}, {196,0.066150442}, {197,0.071473451}, {198,0.067190265}, {199,0.071902655}, {200,0.069424779}, {201,0.069230088}, {202,0.075044248}, {203,0.079433628}, {204,0.073305310}, {205,0.079898230}, {206,0.076247788}, {207,0.079845133}, {208,0.077526549}, {209,0.070765487}, {210,0.072588496}, {211,0.078721239}, {212,0.071827434}, {213,0.077792035}, {214,0.079358407}, {215,0.079314159}, {216,0.074438053}, {217,0.079964602}, {218,0.076424779}, {219,0.082013274}, {220,0.083176991}, {221,0.084570796}, {222,0.081141593}, {223,0.087110619}, {224,0.076216814}, {225,0.076367257}, {226,0.078526549}, {227,0.083526549}, {228,0.077119469}, {229,0.081132743}, {230,0.089628319}, {231,0.091424779}, {232,0.081446903}, {233,0.086907080}, {234,0.093362832}, {235,0.094871681}, {236,0.086247788}, {237,0.091438053}, {238,0.093880531}, {239,0.094048673}, {240,0.080287611}, {241,0.086017699}, {242,0.095123894}, {243,0.095500000}, {244,0.091305310}, {245,0.092194690}, {246,0.093982301}, {247,0.098606195}, {248,0.089513274}, {249,0.094185841}, {250,0.093725664}, {251,0.100951327}, {252,0.098247788}, {253,0.098641593}, {254,0.103398230}, {255,0.110429204}, {256,0.085898230}, {257,0.091601770}, {258,0.094212389}, {259,0.094743363}, {260,0.092433628}, {261,0.095951327}, {262,0.103048673}, {263,0.104823009}, {264,0.092004425}, {265,0.098079646}, {266,0.096831858}, {267,0.104765487}, {268,0.100721239}, {269,0.104513274}, {270,0.105774336}, {271,0.112862832}, {272,0.098181416}, {273,0.095553097}, {274,0.101283186}, {275,0.110969027}, {276,0.104349558}, {277,0.103747788}, {278,0.110424779}, {279,0.117477876}, {280,0.102809735}, {281,0.107247788}, {282,0.111066372}, {283,0.109995575}, {284,0.112712389}, {285,0.118469027}, {286,0.113066372}, {287,0.121876106}, {288,0.105712389}, {289,0.108212389}, {290,0.108986726}, {291,0.116070796}, {292,0.108119469}, {293,0.116004425}, {294,0.117176991}, {295,0.115561947}, {296,0.106163717}, {297,0.112500000}, {298,0.115646018}, {299,0.122367257}, {300,0.112654867}, {301,0.122225664}, {302,0.119845133}, {303,0.124539823}, {304,0.112137168}, {305,0.118933628}, {306,0.120973451}, {307,0.120269912}, {308,0.118641593}, {309,0.123637168}, {310,0.124473451}, {311,0.127756637}, {312,0.118818584}, {313,0.123637168}, {314,0.124362832}, {315,0.134084071}, {316,0.127442478}, {317,0.130942478}, {318,0.131309735}, {319,0.184000000}, {320,0.122097345}, {321,0.115893805}, {322,0.123491150}, {323,0.126774336}, {324,0.122628319}, {325,0.125362832}, {326,0.134225664}, {327,0.134584071}, {328,0.132292035}, {329,0.128008850}, {330,0.128300885}, {331,0.131765487}, {332,0.129884956}, {333,0.132539823}, {334,0.135889381}, {335,0.140526549}, {336,0.124402655}, {337,0.132796460}, {338,0.129646018}, {339,0.143539823}, {340,0.132893805}, {341,0.137318584}, {342,0.136265487}, {343,0.147867257}, {344,0.133796460}, {345,0.138163717}, {346,0.135800885}, {347,0.146668142}, {348,0.138101770}, {349,0.583867257}, {350,0.147685841}, {351,0.160858407}, {352,0.135893805}, {353,0.137318584}, {354,0.136119469}, {355,0.143017699}, {356,0.138247788}, {357,0.143876106}, {358,0.144991150}, {359,0.150438053}, {360,0.141234513}, {361,0.148274336}, {362,0.144265487}, {363,0.153234513}, {364,0.148367257}, {365,0.149482301}, {366,0.156703540}, {367,0.159225664}, {368,0.147402655}, {369,0.146318584}, {370,0.152588496}, {371,0.153477876}, {372,0.155407080}, {373,0.153535398}, {374,0.156853982}, {375,0.163092920}, {376,0.150362832}, {377,0.154030973}, {378,0.159092920}, {379,0.171216814}, {380,0.154898230}, {381,0.165783186}, {382,0.167238938}, {383,0.172610619}, {384,0.139477876}, {385,0.148349558}, {386,0.151637168}, {387,0.154672566}, {388,0.144185841}, {389,0.156079646}, {390,0.155977876}, {391,0.161030973}, {392,0.150845133}, {393,0.157805310}, {394,0.159407080}, {395,0.163544248}, {396,0.160646018}, {397,0.161340708}, {398,0.164588496}, {399,0.169827434}, {400,0.148778761}, {401,0.161199115}, {402,0.160146018}, {403,0.165539823}, {404,0.163464602}, {405,0.810274336}, {406,0.180933628}, {407,0.181867257}, {408,0.161274336}, {409,0.165716814}, {410,0.166787611}, {411,0.173544248}, {412,0.169216814}, {413,0.175296460}, {414,0.172053097}, {415,0.191712389}, {416,0.160331858}, {417,0.166880531}, {418,0.160783186}, {419,0.169238938}, {420,0.167243363}, {421,0.174323009}, {422,0.171221239}, {423,0.179911504}, {424,0.164482301}, {425,0.175787611}, {426,0.173995575}, {427,0.180424779}, {428,0.179115044}, {429,0.183132743}, {430,0.189234513}, {431,0.191938053}, {432,0.171017699}, {433,0.176053097}, {434,0.178637168}, {435,0.183597345}, {436,0.178234513}, {437,0.183035398}, {438,0.189424779}, {439,0.191730088}, {440,0.181176991}, {441,0.185747788}, {442,0.186438053}, {443,0.189296460}, {444,0.187982301}, {445,0.195960177}, {446,0.197659292}, {447,0.206601770}, {448,0.169871681}, {449,0.179181416}, {450,0.178982301}, {451,0.183176991}, {452,0.178451327}, {453,0.184004425}, {454,0.195287611}, {455,0.192035398}, {456,0.192646018}, {457,0.185464602}, {458,0.195212389}, {459,0.190867257}, {460,0.186300885}, {461,0.199641593}, {462,0.199650442}, {463,0.214292035}, {464,0.175991150}, {465,0.196920354}, {466,0.187566372}, {467,0.202159292}, {468,0.191734513}, {469,0.200022124}, {470,0.203234513}, {471,0.204800885}, {472,0.196606195}, {473,0.205792035}, {474,0.198150442}, {475,0.214747788}, {476,0.206048673}, {477,0.206261062}, {478,0.216491150}, {479,0.217924779}, {480,0.184915929}, {481,0.204207965}, {482,0.194920354}, {483,0.203119469}, {484,0.200915929}, {485,0.205668142}, {486,0.205805310}, {487,0.219070796}, {488,0.195119469}, {489,0.211823009}, {490,0.211747788}, {491,0.209561947}, {492,0.212867257}, {493,0.218898230}, {494,0.220738938}, {495,0.219610619}, {496,0.206194690}, {497,0.206004425}, {498,0.207907080}, {499,0.222225664}, {500,0.217592920}, {505,0.221154867}, {510,0.233628319}, {515,0.212871681}, {520,0.212424779}, {525,0.225707965}, {530,0.212371681}, {535,0.240796460}, {540,0.238331858}, {545,0.232743363}, {550,0.241792035}, {555,0.248261062}, {560,0.232181416}, {565,0.243469027}, {570,0.245619469}, {575,0.272150442}, {580,0.237305310}, {585,0.252938053}, {590,0.264061947}, {595,0.271318584}, {600,0.263690265}, {605,0.282345133}, {610,0.262889381}, {615,0.281663717}, {620,0.272212389}, {625,0.273650442}, {630,0.291986726}, {635,0.305818584}, {640,0.257141593}, {645,0.278575221}, {650,0.280805310}, {655,0.301955752}, {660,0.277137168}, {665,0.300190265}, {670,0.315017699}, {675,0.306530973}, {680,0.297765487}, {685,0.313389381}, {690,0.307907080}, {695,0.331225664}, {700,0.327517699}, {705,0.299526549}, {710,0.312283186}, {715,0.330823009}, {720,0.303044248}, {725,0.337128319}, {730,0.332960177}, {735,0.357004425}, {740,0.322500000}, {745,0.338000000}, {750,0.353336283}, {755,0.356101770}, {760,0.351446903}, {765,0.385721239}, {770,0.327314159}, {775,0.349092920}, {780,0.342411504}, {785,0.340455752}, {790,0.358734513}, {795,0.377345133}, {800,0.341929204}, {805,0.366991150}, {810,0.367482301}, {815,0.392964602}, {820,0.363951327}, {825,0.382787611}, {830,0.407676991}, {835,0.375084071}, {840,0.357588496}, {845,0.387641593}, {850,0.380685841}, {855,0.408469027}, {860,0.395831858}, {865,0.391455752}, {870,0.400867257}, {875,0.423938053}, {880,0.396893805}, {885,0.437818584}, {890,0.434176991}, {895,0.465889381}, {900,0.383725664}, {905,0.408831858}, {910,0.420716814}, {915,0.431146018}, {920,0.412110619}, {925,0.452274336}, {930,0.417827434}, {935,0.462340708}, {940,0.439539823}, {945,0.442929204}, {950,0.458110619}, {955,0.476884956}, {960,0.416469027}, {965,0.452646018}, {970,0.452353982}, {975,0.487460177}, {980,0.461743363}, {985,0.478800885}, {990,0.490110619}, {995,0.485800885}, {1000,0.462761062}, {1010,0.483623894}, {1020,0.497623894}, {1030,0.466623894}, {1040,0.453022124}, {1050,0.500407080}, {1060,0.477862832}, {1070,0.509004425}, {1080,0.496973451}, {1090,0.488469027}, {1100,0.510336283}, {1110,0.535482301}, {1120,0.507380531}, {1130,0.551725664}, {1140,0.543504425}, {1150,0.593252212}, {1160,0.517504425}, {1170,0.539858407}, {1180,0.558163717}, {1190,0.578831858}, {1200,0.551221239}, {1210,0.600172566}, {1220,0.559871681}, {1230,0.606013274}, {1240,0.587924779}, {1250,0.606057522}, {1260,0.612057522}, {1270,0.643181416}, {1280,0.571044248}, {1290,0.598115044}, {1300,0.613730088}, {1310,0.652464602}, {1320,0.613353982}, {1330,0.628216814}, {1340,0.667154867}, {1350,0.649535398}, {1360,0.622477876}, {1370,0.676030973}, {1380,0.661243363}, {1390,0.717761062}, {1400,0.687902655}, {1410,0.645084071}, {1420,0.690362832}, {1430,0.711513274}, {1440,0.662398230}, {1450,0.710061947}, {1460,0.711283186}, {1470,0.767296460}, {1480,0.721274336}, {1490,0.726154867}, {1500,0.757318584}, {1510,0.762039823}, {1520,0.737203540}, {1530,0.795973451}, {1540,0.703261062}, {1550,0.757176991}, {1560,0.732305310}, {1570,0.736345133}, {1580,0.761384956}, {1590,0.797650442}, {1600,0.730013274}, {1610,0.784991150}, {1620,0.786115044}, {1630,0.836221239}, {1640,0.785570796}, {1650,0.818274336}, {1660,0.866920354}, {1670,0.803769912}, {1680,0.776676991}, {1690,0.831907080}, {1700,0.817668142}, {1710,0.882544248}, {1720,0.850053097}, {1730,0.821022124}, {1740,0.862800885}, {1750,0.890336283}, {1760,0.845154867}, {1770,0.910738938}, {1780,0.909486726}, {1790,0.967433628}, {1800,0.831685841}, {1810,0.888296460}, {1820,0.898128319}, {1830,0.893787611}, {1840,0.878615044}, {1850,0.947924779}, {1860,0.894650442}, {1870,0.957699115}, {1880,0.927659292}, {1890,0.934526549}, {1900,0.971044248}, {1910,1.000703540}, {1920,0.881013274}, {1930,0.944163717}, {1940,0.947725664}, {1950,1.026730088}, {1960,0.960902655}, {1970,0.998371681}, {1980,1.036123894}, {1990,1.009362832}, {2000,0.985314159}, {2050,0.947424779}, {2100,1.033853982}, {2150,1.108637168}, {2200,1.101721239}, {2250,1.141836283}, {2300,1.242039823}, {2350,1.246079646}, {2400,1.184500000}, {2450,1.246327434}, {2500,1.271486726}, {2550,1.438398230}, {2600,1.289845133}, {2650,1.385805310}, {2700,1.386402655}, {2750,1.558115044}, {2800,1.465570796}, {2850,1.461022124}, {2900,1.513778761}, {2950,1.551898230}, {3000,1.626650442}, {3050,1.693915929}, {3100,1.652172566}, {3150,1.948358407}, {3200,1.546504425}, {3250,1.714203540}, {3300,1.757292035}, {3350,2.084876106}, {3400,1.753827434}, {3450,1.930761062}, {3500,1.898769912}, {3550,2.075955752}, {3600,1.778216814}, {3650,1.866309735}, {3700,2.017057522}, {3750,2.049831858}, {3800,2.069159292}, {3850,2.021154867}, {3900,2.200827434}, {3950,2.301977876}, {4000,2.088141593}, {4050,2.269256637}, {4100,2.044800885}, {4150,2.286601770}, {4200,2.232871681}, {4250,2.329451327}, {4300,2.362575221}, {4350,2.608030973}, {4400,2.326862832}, {4450,2.447597345}, {4500,2.446420354}, {4550,2.565106195}, {4600,2.648792035}, {4650,2.903504425}, {4700,2.630694690}, {4750,2.666128319}, {4800,2.523402655}, {4850,2.804128319}, {4900,2.647261062}, {4950,2.861278761}, {5000,2.686362832}, {5050,3.000199115}, {5100,3.024119469}, {5150,2.995446903}, {5200,2.739588496}, {5250,2.773084444}, {5300,2.974337778}, {5350,3.207862222}, {5400,3.195071111}, {5450,3.046151111}, {5500,3.274644444}, {5550,3.298880000}, {5600,3.131680000}, {5650,3.053173333}, {5700,3.081840000}, {5750,3.421613333}, {5800,3.220013333}, {5850,3.464920000}, {5900,3.269040000}, {5950,3.637284444}, {6000,3.418982222}, {6050,3.433722}, {6100,3.573667}, {6150,3.255778}, {6200,3.407722}, {6250,3.556000}, {6300,3.525000}, {6350,3.691000}, {6400,3.252278}, {6450,3.574556}, {6500,3.618333}, {6550,3.921944}, {6600,3.674222}, {6650,4.085000}, {6700,3.727167}, {6750,4.016611}, {6800,3.679444}, {6850,3.796389}, {6900,4.102944}, {6950,3.984111}, {7000,4.014500}, {7050,4.228111}, {7100,4.314500}, {7150,4.478333}, {7200,3.727778}, {7250,4.068611}, {7300,3.952500}, {7350,4.372778}, {7400,4.278722}, {7450,4.273278}, {7500,4.343000}, {7550,4.719667}, {7600,4.372111}, {7650,4.483944}, {7700,4.239889}, {7750,4.446500}, {7800,4.566889}, {7850,4.657000}, {7900,4.734222}, {7950,4.690556}, {8000,4.370722}, {8050,4.868778}, {8100,4.687556}, {8150,5.065111}, {8200,4.286111}, {8250,4.798611}, {8300,4.806611}, {8350,5.002833}, {8400,4.663722}, {8450,4.533667}, {8500,4.884778}, {8550,5.066222}, {8600,4.922500}, {8650,5.130778}, {8700,5.475556}, {8750,5.209556}, {8800,4.863722}, {8850,5.112111}, {8900,5.093000}, {8950,5.634000}, {9000,5.153944}, {9050,5.519500}, {9100,5.374611}, {9150,5.944111}, {9200,5.579944}, {9250,5.170778}, {9300,5.331500}, {9350,5.388278}, {9400,5.536944}, {9450,5.767889}, {9500,5.604111}, {9550,5.769278}, {9600,5.284444}, {9650,5.840389}, {9700,5.895389}, {9750,5.703444}, {9800,5.569389}, {9850,6.123444}, {9900,5.953556}, {9950,6.365167}, {10000,5.623778}, {10100,6.276278}, {10200,6.296389}, {10300,6.095722}, {10400,5.750167}, {10500,5.796833}, {10600,6.249056}, {10700,6.443056}, {10800,6.127833}, {10900,6.365111}, {11000,6.821111}, {11100,6.959333}, {11200,6.538000}, {11300,6.399111}, {11400,6.455556}, {11500,7.126944}, {11600,6.766889}, {11700,7.265333}, {11800,6.864333}, {11900,7.575944}, {12000,7.172889}, {12100,7.552222}, {12200,7.463778}, {12300,6.893389}, {12400,7.202167}, {12500,7.445667}, {12600,7.502889}, {12700,7.829222}, {12800,6.893000}, {12900,7.642667}, {13000,7.675222}, {13100,8.323389}, {13200,7.780778}, {13300,8.595833}, {13400,7.930278}, {13500,9.203000}, {13600,8.054444}, {13700,8.067111}, {13800,8.620056}, {13900,8.428000}, {14000,9.179222}, {14100,8.607833}, {14200,9.116167}, {14300,9.799167}, {14400,7.950000}, {14500,8.552556}, {14600,8.290944}, {14700,9.209944}, {14800,8.987944}, {14900,8.978389}, {15000,9.089111}, {15100,10.013833}, {15200,9.129667}, {15300,9.443778}, {15400,8.981222}, {15500,9.358556}, {15600,9.721278}, {15700,9.740333}, {15800,10.239889}, {15900,10.056389}, {16000,9.282000}, {16100,10.290444}, {16200,9.973389}, {16300,10.683278}, {16400,9.133889}, {16500,10.125111}, {16600,10.142000}, {16700,10.515889}, {16800,9.911333}, {16900,9.819278}, {17000,10.519167}, {17100,11.179222}, {17200,10.483167}, {17300,11.205833}, {17400,11.798056}, {17500,11.355722}, {17600,10.558889}, {17700,10.733944}, {17800,10.731444}, {17900,11.849444}, {18000,11.260889}, {18100,11.938444}, {18200,11.497167}, {18300,12.613667}, {18400,11.748667}, {18500,11.032889}, {18600,11.393056}, {18700,11.296889}, {18800,12.036944}, {18900,12.335944}, {19000,11.859444}, {19100,12.671556}, {19200,11.340444}, {19300,12.349722}, {19400,12.541833}, {19500,12.111444}, {19600,12.006278}, {19700,13.779500}, {19800,12.673167}, {19900,13.723889}, {20000,12.158563}};
data["big_flat"]["TypeClasses"]["norm reif"]["user"] = {{1,0.000266667}, {2,0.000522124}, {3,0.000500000}, {4,0.000898230}, {5,0.000814159}, {6,0.001331858}, {7,0.001707965}, {8,0.001884956}, {9,0.001845133}, {10,0.002079646}, {11,0.002420354}, {12,0.002508850}, {13,0.002955752}, {14,0.003207965}, {15,0.003517699}, {16,0.003561947}, {17,0.004066372}, {18,0.004314159}, {19,0.004694690}, {20,0.004707965}, {21,0.005646018}, {22,0.012548673}, {23,0.006132743}, {24,0.005942478}, {25,0.006557522}, {26,0.006911504}, {27,0.008084071}, {28,0.007292035}, {29,0.008132743}, {30,0.008407080}, {31,0.009004425}, {32,0.008424779}, {33,0.009150442}, {34,0.009371681}, {35,0.010376106}, {36,0.009769912}, {37,0.010318584}, {38,0.010557522}, {39,0.011092920}, {40,0.010553097}, {41,0.011712389}, {42,0.011469027}, {43,0.012526549}, {44,0.012893805}, {45,0.013115044}, {46,0.014035398}, {47,0.013845133}, {48,0.012964602}, {49,0.013814159}, {50,0.014075221}, {51,0.015716814}, {52,0.015247788}, {53,0.015561947}, {54,0.015951327}, {55,0.016938053}, {56,0.015646018}, {57,0.016699115}, {58,0.017911504}, {59,0.018000000}, {60,0.017429204}, {61,0.018473451}, {62,0.018672566}, {63,0.019606195}, {64,0.019389381}, {65,0.018907080}, {66,0.019137168}, {67,0.021088496}, {68,0.019398230}, {69,0.020973451}, {70,0.021110619}, {71,0.022482301}, {72,0.020592920}, {73,0.021893805}, {74,0.024070796}, {75,0.023601770}, {76,0.022641593}, {77,0.025482301}, {78,0.024278761}, {79,0.027035398}, {80,0.023911504}, {81,0.024486726}, {82,0.024623894}, {83,0.028030973}, {84,0.025207965}, {85,0.026331858}, {86,0.026579646}, {87,0.029858407}, {88,0.027128319}, {89,0.027553097}, {90,0.027942478}, {91,0.031765487}, {92,0.028389381}, {93,0.031522124}, {94,0.030592920}, {95,0.033500000}, {96,0.027712389}, {97,0.029212389}, {98,0.030663717}, {99,0.031588496}, {100,0.030327434}, {101,0.032128319}, {102,0.034154867}, {103,0.034862832}, {104,0.031340708}, {105,0.036867257}, {106,0.033185841}, {107,0.036097345}, {108,0.033884956}, {109,0.035685841}, {110,0.035508850}, {111,0.037495575}, {112,0.033438053}, {113,0.035309735}, {114,0.035539823}, {115,0.038097345}, {116,0.036327434}, {117,0.038022124}, {118,0.038323009}, {119,0.040641593}, {120,0.038721239}, {121,0.041070796}, {122,0.039681416}, {123,0.046150442}, {124,0.040194690}, {125,0.044584071}, {126,0.043668142}, {127,0.044513274}, {128,0.040225664}, {129,0.040668142}, {130,0.040619469}, {131,0.045659292}, {132,0.042243363}, {133,0.043809735}, {134,0.045734513}, {135,0.046292035}, {136,0.046097345}, {137,0.046964602}, {138,0.044880531}, {139,0.048991150}, {140,0.045584071}, {141,0.050938053}, {142,0.049504425}, {143,0.053128319}, {144,0.044358407}, {145,0.049044248}, {146,0.048331858}, {147,0.051150442}, {148,0.050955752}, {149,0.049977876}, {150,0.057517699}, {151,0.055676991}, {152,0.051442478}, {153,0.052407080}, {154,0.058747788}, {155,0.054088496}, {156,0.056415929}, {157,0.057283186}, {158,0.057606195}, {159,0.057384956}, {160,0.051141593}, {161,0.052075221}, {162,0.052163717}, {163,0.057880531}, {164,0.055915929}, {165,0.058230088}, {166,0.056115044}, {167,0.063137168}, {168,0.056884956}, {169,0.058469027}, {170,0.056982301}, {171,0.063623894}, {172,0.064075221}, {173,0.060522124}, {174,0.063190265}, {175,0.063575221}, {176,0.060442478}, {177,0.062053097}, {178,0.063336283}, {179,0.062398230}, {180,0.063331858}, {181,0.067079646}, {182,0.066384956}, {183,0.070004425}, {184,0.061407080}, {185,0.065336283}, {186,0.065163717}, {187,0.072685841}, {188,0.070530973}, {189,0.070615044}, {190,0.073473451}, {191,0.071269912}, {192,0.061876106}, {193,0.063588496}, {194,0.065234513}, {195,0.073261062}, {196,0.065938053}, {197,0.071561947}, {198,0.067106195}, {199,0.071628319}, {200,0.069380531}, {201,0.068858407}, {202,0.074871681}, {203,0.079203540}, {204,0.073176991}, {205,0.079504425}, {206,0.076048673}, {207,0.079663717}, {208,0.077101770}, {209,0.070500000}, {210,0.072774336}, {211,0.078544248}, {212,0.071792035}, {213,0.077473451}, {214,0.078946903}, {215,0.079424779}, {216,0.074367257}, {217,0.079637168}, {218,0.076628319}, {219,0.081592920}, {220,0.082889381}, {221,0.084424779}, {222,0.081026549}, {223,0.086743363}, {224,0.076070796}, {225,0.076575221}, {226,0.078380531}, {227,0.083318584}, {228,0.077380531}, {229,0.080747788}, {230,0.089234513}, {231,0.091371681}, {232,0.081402655}, {233,0.086654867}, {234,0.092482301}, {235,0.094893805}, {236,0.085951327}, {237,0.091044248}, {238,0.093579646}, {239,0.094088496}, {240,0.080345133}, {241,0.085796460}, {242,0.094115044}, {243,0.095491150}, {244,0.091048673}, {245,0.092225664}, {246,0.093796460}, {247,0.098446903}, {248,0.089411504}, {249,0.093938053}, {250,0.093659292}, {251,0.100544248}, {252,0.097964602}, {253,0.098539823}, {254,0.102915929}, {255,0.109960177}, {256,0.085632743}, {257,0.091491150}, {258,0.093876106}, {259,0.094650442}, {260,0.092110619}, {261,0.095964602}, {262,0.102601770}, {263,0.104690265}, {264,0.091991150}, {265,0.097933628}, {266,0.096792035}, {267,0.104371681}, {268,0.100446903}, {269,0.104216814}, {270,0.105566372}, {271,0.112092920}, {272,0.097982301}, {273,0.095840708}, {274,0.100898230}, {275,0.110300885}, {276,0.104234513}, {277,0.103659292}, {278,0.110141593}, {279,0.116942478}, {280,0.102893805}, {281,0.107066372}, {282,0.110508850}, {283,0.109681416}, {284,0.112110619}, {285,0.117929204}, {286,0.112853982}, {287,0.121610619}, {288,0.105384956}, {289,0.108044248}, {290,0.108924779}, {291,0.115190265}, {292,0.107756637}, {293,0.115805310}, {294,0.116517699}, {295,0.115446903}, {296,0.106008850}, {297,0.112070796}, {298,0.114938053}, {299,0.121823009}, {300,0.112247788}, {301,0.121774336}, {302,0.119429204}, {303,0.124327434}, {304,0.111632743}, {305,0.118650442}, {306,0.120340708}, {307,0.119792035}, {308,0.118150442}, {309,0.123278761}, {310,0.124429204}, {311,0.127429204}, {312,0.118561947}, {313,0.123163717}, {314,0.124132743}, {315,0.133862832}, {316,0.127194690}, {317,0.130597345}, {318,0.131362832}, {319,0.183699115}, {320,0.121929204}, {321,0.115778761}, {322,0.123433628}, {323,0.126663717}, {324,0.122269912}, {325,0.125331858}, {326,0.133991150}, {327,0.134491150}, {328,0.132464602}, {329,0.127929204}, {330,0.128500000}, {331,0.131769912}, {332,0.129672566}, {333,0.132522124}, {334,0.135623894}, {335,0.140592920}, {336,0.124309735}, {337,0.132610619}, {338,0.129327434}, {339,0.143274336}, {340,0.132451327}, {341,0.137176991}, {342,0.135969027}, {343,0.147610619}, {344,0.133473451}, {345,0.137814159}, {346,0.135730088}, {347,0.146345133}, {348,0.138084071}, {349,0.581982301}, {350,0.146172566}, {351,0.157889381}, {352,0.134991150}, {353,0.137221239}, {354,0.136004425}, {355,0.142579646}, {356,0.138221239}, {357,0.143694690}, {358,0.144420354}, {359,0.150061947}, {360,0.141358407}, {361,0.148194690}, {362,0.143796460}, {363,0.153199115}, {364,0.148066372}, {365,0.148150442}, {366,0.156305310}, {367,0.157831858}, {368,0.146960177}, {369,0.146115044}, {370,0.152384956}, {371,0.153367257}, {372,0.155238938}, {373,0.153384956}, {374,0.156309735}, {375,0.162800885}, {376,0.150345133}, {377,0.153809735}, {378,0.159035398}, {379,0.170889381}, {380,0.154853982}, {381,0.164323009}, {382,0.167022124}, {383,0.172345133}, {384,0.139230088}, {385,0.148460177}, {386,0.151610619}, {387,0.154725664}, {388,0.144141593}, {389,0.155938053}, {390,0.155853982}, {391,0.160676991}, {392,0.150969027}, {393,0.157796460}, {394,0.159203540}, {395,0.163287611}, {396,0.160553097}, {397,0.161035398}, {398,0.164601770}, {399,0.169491150}, {400,0.148761062}, {401,0.161057522}, {402,0.159853982}, {403,0.165185841}, {404,0.163212389}, {405,0.808982301}, {406,0.180393805}, {407,0.181331858}, {408,0.161115044}, {409,0.165491150}, {410,0.166592920}, {411,0.173123894}, {412,0.168898230}, {413,0.174969027}, {414,0.171584071}, {415,0.191283186}, {416,0.160194690}, {417,0.166637168}, {418,0.160526549}, {419,0.169128319}, {420,0.167092920}, {421,0.173986726}, {422,0.171044248}, {423,0.179659292}, {424,0.164212389}, {425,0.175500000}, {426,0.173743363}, {427,0.180424779}, {428,0.178783186}, {429,0.182902655}, {430,0.189048673}, {431,0.191814159}, {432,0.170672566}, {433,0.175628319}, {434,0.178486726}, {435,0.183517699}, {436,0.178110619}, {437,0.183030973}, {438,0.189230088}, {439,0.191654867}, {440,0.181088496}, {441,0.185676991}, {442,0.186115044}, {443,0.188898230}, {444,0.187721239}, {445,0.195730088}, {446,0.197252212}, {447,0.206659292}, {448,0.169610619}, {449,0.179044248}, {450,0.178721239}, {451,0.182880531}, {452,0.178097345}, {453,0.183836283}, {454,0.195079646}, {455,0.191796460}, {456,0.192371681}, {457,0.185212389}, {458,0.195079646}, {459,0.190814159}, {460,0.186092920}, {461,0.199305310}, {462,0.199345133}, {463,0.213761062}, {464,0.175522124}, {465,0.196765487}, {466,0.187646018}, {467,0.201920354}, {468,0.191623894}, {469,0.199942478}, {470,0.202924779}, {471,0.204615044}, {472,0.196800885}, {473,0.205504425}, {474,0.197818584}, {475,0.214561947}, {476,0.206137168}, {477,0.206190265}, {478,0.216632743}, {479,0.217681416}, {480,0.185017699}, {481,0.203982301}, {482,0.194522124}, {483,0.202650442}, {484,0.200588496}, {485,0.205566372}, {486,0.205526549}, {487,0.218588496}, {488,0.194774336}, {489,0.211553097}, {490,0.211438053}, {491,0.209424779}, {492,0.212659292}, {493,0.218769912}, {494,0.220460177}, {495,0.219424779}, {496,0.205907080}, {497,0.205840708}, {498,0.207632743}, {499,0.221792035}, {500,0.217181416}, {505,0.220814159}, {510,0.233309735}, {515,0.212442478}, {520,0.212146018}, {525,0.225455752}, {530,0.212256637}, {535,0.240212389}, {540,0.237938053}, {545,0.232482301}, {550,0.241610619}, {555,0.248309735}, {560,0.231836283}, {565,0.243137168}, {570,0.245309735}, {575,0.271703540}, {580,0.236853982}, {585,0.252814159}, {590,0.263712389}, {595,0.270884956}, {600,0.263234513}, {605,0.282150442}, {610,0.262619469}, {615,0.281269912}, {620,0.272146018}, {625,0.273433628}, {630,0.291792035}, {635,0.305243363}, {640,0.256986726}, {645,0.278190265}, {650,0.280584071}, {655,0.301703540}, {660,0.277119469}, {665,0.299915929}, {670,0.314836283}, {675,0.306371681}, {680,0.297570796}, {685,0.313176991}, {690,0.307570796}, {695,0.331097345}, {700,0.326951327}, {705,0.299371681}, {710,0.311924779}, {715,0.330438053}, {720,0.302907080}, {725,0.337092920}, {730,0.332619469}, {735,0.356694690}, {740,0.322230088}, {745,0.337889381}, {750,0.353150442}, {755,0.355915929}, {760,0.351030973}, {765,0.385446903}, {770,0.326973451}, {775,0.348694690}, {780,0.342092920}, {785,0.340137168}, {790,0.358274336}, {795,0.377026549}, {800,0.341668142}, {805,0.366641593}, {810,0.367137168}, {815,0.392716814}, {820,0.363730088}, {825,0.382283186}, {830,0.407384956}, {835,0.374752212}, {840,0.357274336}, {845,0.387433628}, {850,0.380300885}, {855,0.408088496}, {860,0.395734513}, {865,0.391159292}, {870,0.400553097}, {875,0.423402655}, {880,0.396641593}, {885,0.437721239}, {890,0.433814159}, {895,0.465743363}, {900,0.383513274}, {905,0.408597345}, {910,0.420469027}, {915,0.430911504}, {920,0.411893805}, {925,0.452035398}, {930,0.417818584}, {935,0.461862832}, {940,0.439163717}, {945,0.442477876}, {950,0.457584071}, {955,0.476579646}, {960,0.416371681}, {965,0.452353982}, {970,0.451995575}, {975,0.487256637}, {980,0.461402655}, {985,0.478243363}, {990,0.489738938}, {995,0.485526549}, {1000,0.462101770}, {1010,0.483398230}, {1020,0.497017699}, {1030,0.465977876}, {1040,0.452641593}, {1050,0.500008850}, {1060,0.477123894}, {1070,0.508623894}, {1080,0.496654867}, {1090,0.488039823}, {1100,0.509884956}, {1110,0.535044248}, {1120,0.506938053}, {1130,0.551495575}, {1140,0.543146018}, {1150,0.592561947}, {1160,0.517199115}, {1170,0.539628319}, {1180,0.557823009}, {1190,0.578362832}, {1200,0.550862832}, {1210,0.599641593}, {1220,0.559376106}, {1230,0.605225664}, {1240,0.587517699}, {1250,0.605809735}, {1260,0.611654867}, {1270,0.642818584}, {1280,0.570845133}, {1290,0.597783186}, {1300,0.613163717}, {1310,0.652030973}, {1320,0.612889381}, {1330,0.627663717}, {1340,0.666539823}, {1350,0.648991150}, {1360,0.621911504}, {1370,0.675646018}, {1380,0.660486726}, {1390,0.715840708}, {1400,0.685792035}, {1410,0.644221239}, {1420,0.689548673}, {1430,0.710831858}, {1440,0.661853982}, {1450,0.709389381}, {1460,0.710721239}, {1470,0.766769912}, {1480,0.720570796}, {1490,0.725548673}, {1500,0.756823009}, {1510,0.761309735}, {1520,0.736712389}, {1530,0.795451327}, {1540,0.702769912}, {1550,0.756637168}, {1560,0.731650442}, {1570,0.735743363}, {1580,0.760911504}, {1590,0.797057522}, {1600,0.729278761}, {1610,0.784168142}, {1620,0.785402655}, {1630,0.835659292}, {1640,0.785000000}, {1650,0.817743363}, {1660,0.866221239}, {1670,0.803168142}, {1680,0.776473451}, {1690,0.831331858}, {1700,0.816960177}, {1710,0.881946903}, {1720,0.849460177}, {1730,0.820429204}, {1740,0.861986726}, {1750,0.889668142}, {1760,0.844411504}, {1770,0.910106195}, {1780,0.908597345}, {1790,0.966646018}, {1800,0.830986726}, {1810,0.887464602}, {1820,0.897238938}, {1830,0.892734513}, {1840,0.877973451}, {1850,0.947176991}, {1860,0.893853982}, {1870,0.957000000}, {1880,0.926858407}, {1890,0.933840708}, {1900,0.970269912}, {1910,0.999876106}, {1920,0.880362832}, {1930,0.943393805}, {1940,0.947048673}, {1950,1.025867257}, {1960,0.960163717}, {1970,0.997707965}, {1980,1.035508850}, {1990,1.008592920}, {2000,0.984725664}, {2050,0.946641593}, {2100,1.032814159}, {2150,1.107712389}, {2200,1.100765487}, {2250,1.140597345}, {2300,1.240858407}, {2350,1.245079646}, {2400,1.183261062}, {2450,1.245411504}, {2500,1.270601770}, {2550,1.437185841}, {2600,1.288637168}, {2650,1.384615044}, {2700,1.385101770}, {2750,1.556504425}, {2800,1.464225664}, {2850,1.459610619}, {2900,1.512132743}, {2950,1.550230088}, {3000,1.625199115}, {3050,1.692256637}, {3100,1.649610619}, {3150,1.946159292}, {3200,1.545318584}, {3250,1.712862832}, {3300,1.754836283}, {3350,2.081579646}, {3400,1.752035398}, {3450,1.929088496}, {3500,1.897256637}, {3550,2.073893805}, {3600,1.776079646}, {3650,1.863415929}, {3700,2.015283186}, {3750,2.047818584}, {3800,2.067570796}, {3850,2.018703540}, {3900,2.198831858}, {3950,2.299026549}, {4000,2.086150442}, {4050,2.267398230}, {4100,2.042243363}, {4150,2.284792035}, {4200,2.230681416}, {4250,2.327628319}, {4300,2.360477876}, {4350,2.605513274}, {4400,2.324969027}, {4450,2.445411504}, {4500,2.444477876}, {4550,2.562207965}, {4600,2.642526549}, {4650,2.900623894}, {4700,2.628539823}, {4750,2.663884956}, {4800,2.521128319}, {4850,2.798398230}, {4900,2.644699115}, {4950,2.858902655}, {5000,2.683814159}, {5050,2.997938053}, {5100,3.020933628}, {5150,2.992853982}, {5200,2.737181416}, {5250,2.770186667}, {5300,2.970355556}, {5350,3.199715556}, {5400,3.191515556}, {5450,3.043537778}, {5500,3.270564444}, {5550,3.292786667}, {5600,3.128124444}, {5650,3.050657778}, {5700,3.079031111}, {5750,3.418831111}, {5800,3.217417778}, {5850,3.462004444}, {5900,3.265888889}, {5950,3.634031111}, {6000,3.416253333}, {6050,3.425222}, {6100,3.554111}, {6150,3.241667}, {6200,3.404056}, {6250,3.547944}, {6300,3.521056}, {6350,3.686778}, {6400,3.249611}, {6450,3.569889}, {6500,3.612222}, {6550,3.915389}, {6600,3.672222}, {6650,4.082611}, {6700,3.722889}, {6750,4.012833}, {6800,3.676222}, {6850,3.793167}, {6900,4.098722}, {6950,3.979333}, {7000,4.010000}, {7050,4.221722}, {7100,4.309278}, {7150,4.472889}, {7200,3.723389}, {7250,4.062389}, {7300,3.944556}, {7350,4.368167}, {7400,4.273833}, {7450,4.268833}, {7500,4.337833}, {7550,4.714778}, {7600,4.367722}, {7650,4.478111}, {7700,4.234667}, {7750,4.442222}, {7800,4.562722}, {7850,4.650944}, {7900,4.728556}, {7950,4.684667}, {8000,4.365611}, {8050,4.863556}, {8100,4.683111}, {8150,5.059722}, {8200,4.281667}, {8250,4.793444}, {8300,4.802000}, {8350,4.996778}, {8400,4.657833}, {8450,4.528056}, {8500,4.878222}, {8550,5.059556}, {8600,4.915778}, {8650,5.123944}, {8700,5.469000}, {8750,5.202333}, {8800,4.856111}, {8850,5.105889}, {8900,5.084778}, {8950,5.626667}, {9000,5.146944}, {9050,5.512222}, {9100,5.367833}, {9150,5.938056}, {9200,5.573722}, {9250,5.165278}, {9300,5.326889}, {9350,5.381778}, {9400,5.531056}, {9450,5.761222}, {9500,5.598278}, {9550,5.763278}, {9600,5.277833}, {9650,5.834444}, {9700,5.889389}, {9750,5.698500}, {9800,5.563333}, {9850,6.117278}, {9900,5.946944}, {9950,6.359056}, {10000,5.617778}, {10100,6.268389}, {10200,6.289056}, {10300,6.089889}, {10400,5.744111}, {10500,5.791667}, {10600,6.242833}, {10700,6.436000}, {10800,6.121056}, {10900,6.358167}, {11000,6.813667}, {11100,6.951222}, {11200,6.531444}, {11300,6.391667}, {11400,6.451000}, {11500,7.120778}, {11600,6.761333}, {11700,7.260056}, {11800,6.858000}, {11900,7.569722}, {12000,7.166278}, {12100,7.543722}, {12200,7.457000}, {12300,6.885056}, {12400,7.192944}, {12500,7.436389}, {12600,7.494611}, {12700,7.821333}, {12800,6.886500}, {12900,7.636444}, {13000,7.667000}, {13100,8.316778}, {13200,7.774889}, {13300,8.589222}, {13400,7.918111}, {13500,9.195056}, {13600,8.046944}, {13700,8.059778}, {13800,8.612222}, {13900,8.413444}, {14000,9.166667}, {14100,8.600389}, {14200,9.107611}, {14300,9.789833}, {14400,7.942389}, {14500,8.545167}, {14600,8.278278}, {14700,9.199778}, {14800,8.979556}, {14900,8.971611}, {15000,9.080278}, {15100,9.999944}, {15200,9.121556}, {15300,9.433500}, {15400,8.968056}, {15500,9.347389}, {15600,9.708833}, {15700,9.725389}, {15800,10.227611}, {15900,10.041167}, {16000,9.269389}, {16100,10.279611}, {16200,9.963556}, {16300,10.672611}, {16400,9.124611}, {16500,10.110778}, {16600,10.128889}, {16700,10.501333}, {16800,9.900000}, {16900,9.808389}, {17000,10.506167}, {17100,11.163500}, {17200,10.470389}, {17300,11.191278}, {17400,11.783333}, {17500,11.337556}, {17600,10.539833}, {17700,10.719667}, {17800,10.716667}, {17900,11.828056}, {18000,11.226611}, {18100,11.921389}, {18200,11.481556}, {18300,12.591389}, {18400,11.730111}, {18500,11.015889}, {18600,11.375889}, {18700,11.280778}, {18800,12.009667}, {18900,12.316222}, {19000,11.841722}, {19100,12.654722}, {19200,11.325222}, {19300,12.330167}, {19400,12.517611}, {19500,12.093667}, {19600,11.986667}, {19700,13.732167}, {19800,12.655278}, {19900,13.703889}, {20000,12.138813}};
data["big_flat"]["TypeClasses"]["norm reif"]["system"] = {{1,0.000146667}, {2,0.000017699}, {3,0.000000000}, {4,0.000000000}, {5,0.000013274}, {6,0.000035398}, {7,0.000017699}, {8,0.000017699}, {9,0.000017699}, {10,0.000000000}, {11,0.000000000}, {12,0.000017699}, {13,0.000000000}, {14,0.000000000}, {15,0.000013274}, {16,0.000044248}, {17,0.000017699}, {18,0.000030973}, {19,0.000017699}, {20,0.000000000}, {21,0.000000000}, {22,0.000088496}, {23,0.000026549}, {24,0.000013274}, {25,0.000030973}, {26,0.000017699}, {27,0.000035398}, {28,0.000017699}, {29,0.000000000}, {30,0.000030973}, {31,0.000000000}, {32,0.000000000}, {33,0.000013274}, {34,0.000000000}, {35,0.000013274}, {36,0.000026549}, {37,0.000000000}, {38,0.000053097}, {39,0.000035398}, {40,0.000035398}, {41,0.000000000}, {42,0.000017699}, {43,0.000035398}, {44,0.000030973}, {45,0.000000000}, {46,0.000017699}, {47,0.000000000}, {48,0.000000000}, {49,0.000070796}, {50,0.000048673}, {51,0.000013274}, {52,0.000030973}, {53,0.000066372}, {54,0.000000000}, {55,0.000000000}, {56,0.000048673}, {57,0.000048673}, {58,0.000066372}, {59,0.000084071}, {60,0.000035398}, {61,0.000017699}, {62,0.000000000}, {63,0.000000000}, {64,0.000048673}, {65,0.000017699}, {66,0.000000000}, {67,0.000035398}, {68,0.000017699}, {69,0.000000000}, {70,0.000013274}, {71,0.000035398}, {72,0.000017699}, {73,0.000017699}, {74,0.000066372}, {75,0.000000000}, {76,0.000017699}, {77,0.000106195}, {78,0.000053097}, {79,0.000030973}, {80,0.000084071}, {81,0.000000000}, {82,0.000000000}, {83,0.000048673}, {84,0.000017699}, {85,0.000017699}, {86,0.000030973}, {87,0.000070796}, {88,0.000044248}, {89,0.000000000}, {90,0.000053097}, {91,0.000053097}, {92,0.000017699}, {93,0.000048673}, {94,0.000017699}, {95,0.000053097}, {96,0.000017699}, {97,0.000017699}, {98,0.000097345}, {99,0.000066372}, {100,0.000013274}, {101,0.000017699}, {102,0.000119469}, {103,0.000079646}, {104,0.000048673}, {105,0.000066372}, {106,0.000035398}, {107,0.000035398}, {108,0.000000000}, {109,0.000030973}, {110,0.000000000}, {111,0.000017699}, {112,0.000017699}, {113,0.000035398}, {114,0.000013274}, {115,0.000026549}, {116,0.000017699}, {117,0.000013274}, {118,0.000017699}, {119,0.000013274}, {120,0.000017699}, {121,0.000146018}, {122,0.000017699}, {123,0.000176991}, {124,0.000013274}, {125,0.000066372}, {126,0.000035398}, {127,0.000053097}, {128,0.000030973}, {129,0.000017699}, {130,0.000057522}, {131,0.000066372}, {132,0.000070796}, {133,0.000000000}, {134,0.000017699}, {135,0.000017699}, {136,0.000106195}, {137,0.000035398}, {138,0.000017699}, {139,0.000066372}, {140,0.000013274}, {141,0.000097345}, {142,0.000119469}, {143,0.000053097}, {144,0.000017699}, {145,0.000070796}, {146,0.000106195}, {147,0.000030973}, {148,0.000106195}, {149,0.000000000}, {150,0.000123894}, {151,0.000079646}, {152,0.000017699}, {153,0.000017699}, {154,0.000190265}, {155,0.000048673}, {156,0.000084071}, {157,0.000097345}, {158,0.000066372}, {159,0.000000000}, {160,0.000088496}, {161,0.000053097}, {162,0.000000000}, {163,0.000106195}, {164,0.000084071}, {165,0.000017699}, {166,0.000044248}, {167,0.000106195}, {168,0.000053097}, {169,0.000053097}, {170,0.000048673}, {171,0.000101770}, {172,0.000154867}, {173,0.000000000}, {174,0.000066372}, {175,0.000013274}, {176,0.000243363}, {177,0.000115044}, {178,0.000084071}, {179,0.000053097}, {180,0.000030973}, {181,0.000115044}, {182,0.000146018}, {183,0.000119469}, {184,0.000000000}, {185,0.000066372}, {186,0.000048673}, {187,0.000119469}, {188,0.000176991}, {189,0.000035398}, {190,0.000150442}, {191,0.000053097}, {192,0.000017699}, {193,0.000000000}, {194,0.000061947}, {195,0.000154867}, {196,0.000088496}, {197,0.000084071}, {198,0.000030973}, {199,0.000079646}, {200,0.000101770}, {201,0.000119469}, {202,0.000234513}, {203,0.000190265}, {204,0.000194690}, {205,0.000185841}, {206,0.000150442}, {207,0.000119469}, {208,0.000185841}, {209,0.000017699}, {210,0.000035398}, {211,0.000132743}, {212,0.000013274}, {213,0.000106195}, {214,0.000106195}, {215,0.000061947}, {216,0.000070796}, {217,0.000088496}, {218,0.000035398}, {219,0.000066372}, {220,0.000314159}, {221,0.000066372}, {222,0.000030973}, {223,0.000070796}, {224,0.000070796}, {225,0.000017699}, {226,0.000048673}, {227,0.000066372}, {228,0.000035398}, {229,0.000176991}, {230,0.000238938}, {231,0.000088496}, {232,0.000119469}, {233,0.000106195}, {234,0.000663717}, {235,0.000287611}, {236,0.000185841}, {237,0.000225664}, {238,0.000185841}, {239,0.000079646}, {240,0.000017699}, {241,0.000101770}, {242,0.001030973}, {243,0.000199115}, {244,0.000340708}, {245,0.000176991}, {246,0.000123894}, {247,0.000070796}, {248,0.000128319}, {249,0.000141593}, {250,0.000137168}, {251,0.000278761}, {252,0.000137168}, {253,0.000053097}, {254,0.000300885}, {255,0.000420354}, {256,0.000207965}, {257,0.000185841}, {258,0.000154867}, {259,0.000070796}, {260,0.000185841}, {261,0.000154867}, {262,0.000362832}, {263,0.000203540}, {264,0.000101770}, {265,0.000159292}, {266,0.000194690}, {267,0.000278761}, {268,0.000331858}, {269,0.000190265}, {270,0.000176991}, {271,0.000464602}, {272,0.000234513}, {273,0.000017699}, {274,0.000269912}, {275,0.000473451}, {276,0.000300885}, {277,0.000017699}, {278,0.000274336}, {279,0.000110619}, {280,0.000159292}, {281,0.000066372}, {282,0.000194690}, {283,0.000172566}, {284,0.000287611}, {285,0.000473451}, {286,0.000207965}, {287,0.000380531}, {288,0.000314159}, {289,0.000137168}, {290,0.000238938}, {291,0.000446903}, {292,0.000252212}, {293,0.000194690}, {294,0.000482301}, {295,0.000132743}, {296,0.000172566}, {297,0.000367257}, {298,0.000274336}, {299,0.000455752}, {300,0.000084071}, {301,0.000340708}, {302,0.000238938}, {303,0.000305310}, {304,0.000278761}, {305,0.000296460}, {306,0.000486726}, {307,0.000212389}, {308,0.000318584}, {309,0.000283186}, {310,0.000199115}, {311,0.000247788}, {312,0.000331858}, {313,0.000296460}, {314,0.000216814}, {315,0.000203540}, {316,0.000092920}, {317,0.000137168}, {318,0.000123894}, {319,0.000247788}, {320,0.000185841}, {321,0.000101770}, {322,0.000053097}, {323,0.000110619}, {324,0.000115044}, {325,0.000101770}, {326,0.000261062}, {327,0.000123894}, {328,0.000035398}, {329,0.000017699}, {330,0.000000000}, {331,0.000017699}, {332,0.000159292}, {333,0.000048673}, {334,0.000101770}, {335,0.000115044}, {336,0.000048673}, {337,0.000066372}, {338,0.000137168}, {339,0.000185841}, {340,0.000106195}, {341,0.000176991}, {342,0.000172566}, {343,0.000154867}, {344,0.000159292}, {345,0.000128319}, {346,0.000123894}, {347,0.000154867}, {348,0.000088496}, {349,0.001398230}, {350,0.000172566}, {351,0.000168142}, {352,0.000194690}, {353,0.000207965}, {354,0.000150442}, {355,0.000168142}, {356,0.000092920}, {357,0.000176991}, {358,0.000172566}, {359,0.000230088}, {360,0.000115044}, {361,0.000176991}, {362,0.000207965}, {363,0.000159292}, {364,0.000327434}, {365,0.000221239}, {366,0.000380531}, {367,0.000300885}, {368,0.000345133}, {369,0.000190265}, {370,0.000039823}, {371,0.000017699}, {372,0.000106195}, {373,0.000017699}, {374,0.000048673}, {375,0.000013274}, {376,0.000017699}, {377,0.000066372}, {378,0.000070796}, {379,0.000017699}, {380,0.000017699}, {381,0.000030973}, {382,0.000035398}, {383,0.000017699}, {384,0.000035398}, {385,0.000035398}, {386,0.000053097}, {387,0.000048673}, {388,0.000035398}, {389,0.000035398}, {390,0.000035398}, {391,0.000048673}, {392,0.000017699}, {393,0.000030973}, {394,0.000017699}, {395,0.000101770}, {396,0.000017699}, {397,0.000070796}, {398,0.000044248}, {399,0.000084071}, {400,0.000017699}, {401,0.000066372}, {402,0.000035398}, {403,0.000030973}, {404,0.000017699}, {405,0.000818584}, {406,0.000314159}, {407,0.000486726}, {408,0.000123894}, {409,0.000106195}, {410,0.000088496}, {411,0.000097345}, {412,0.000101770}, {413,0.000101770}, {414,0.000115044}, {415,0.000172566}, {416,0.000115044}, {417,0.000070796}, {418,0.000000000}, {419,0.000017699}, {420,0.000000000}, {421,0.000088496}, {422,0.000088496}, {423,0.000035398}, {424,0.000017699}, {425,0.000101770}, {426,0.000053097}, {427,0.000035398}, {428,0.000035398}, {429,0.000044248}, {430,0.000035398}, {431,0.000070796}, {432,0.000084071}, {433,0.000070796}, {434,0.000088496}, {435,0.000017699}, {436,0.000048673}, {437,0.000066372}, {438,0.000101770}, {439,0.000097345}, {440,0.000092920}, {441,0.000035398}, {442,0.000097345}, {443,0.000101770}, {444,0.000088496}, {445,0.000066372}, {446,0.000013274}, {447,0.000035398}, {448,0.000088496}, {449,0.000000000}, {450,0.000000000}, {451,0.000013274}, {452,0.000030973}, {453,0.000084071}, {454,0.000066372}, {455,0.000000000}, {456,0.000066372}, {457,0.000030973}, {458,0.000017699}, {459,0.000053097}, {460,0.000048673}, {461,0.000035398}, {462,0.000035398}, {463,0.000075221}, {464,0.000097345}, {465,0.000088496}, {466,0.000030973}, {467,0.000084071}, {468,0.000035398}, {469,0.000017699}, {470,0.000000000}, {471,0.000030973}, {472,0.000017699}, {473,0.000030973}, {474,0.000053097}, {475,0.000017699}, {476,0.000066372}, {477,0.000013274}, {478,0.000053097}, {479,0.000000000}, {480,0.000017699}, {481,0.000154867}, {482,0.000274336}, {483,0.000331858}, {484,0.000123894}, {485,0.000123894}, {486,0.000207965}, {487,0.000345133}, {488,0.000053097}, {489,0.000176991}, {490,0.000066372}, {491,0.000084071}, {492,0.000137168}, {493,0.000123894}, {494,0.000101770}, {495,0.000035398}, {496,0.000088496}, {497,0.000101770}, {498,0.000070796}, {499,0.000106195}, {500,0.000088496}, {505,0.000123894}, {510,0.000035398}, {515,0.000101770}, {520,0.000061947}, {525,0.000084071}, {530,0.000048673}, {535,0.000053097}, {540,0.000035398}, {545,0.000017699}, {550,0.000053097}, {555,0.000088496}, {560,0.000030973}, {565,0.000035398}, {570,0.000088496}, {575,0.000035398}, {580,0.000017699}, {585,0.000066372}, {590,0.000137168}, {595,0.000137168}, {600,0.000194690}, {605,0.000172566}, {610,0.000234513}, {615,0.000123894}, {620,0.000084071}, {625,0.000088496}, {630,0.000088496}, {635,0.000141593}, {640,0.000123894}, {645,0.000084071}, {650,0.000070796}, {655,0.000088496}, {660,0.000053097}, {665,0.000017699}, {670,0.000000000}, {675,0.000035398}, {680,0.000048673}, {685,0.000000000}, {690,0.000035398}, {695,0.000000000}, {700,0.000061947}, {705,0.000035398}, {710,0.000159292}, {715,0.000017699}, {720,0.000000000}, {725,0.000017699}, {730,0.000066372}, {735,0.000000000}, {740,0.000017699}, {745,0.000000000}, {750,0.000053097}, {755,0.000000000}, {760,0.000000000}, {765,0.000066372}, {770,0.000035398}, {775,0.000017699}, {780,0.000017699}, {785,0.000035398}, {790,0.000053097}, {795,0.000101770}, {800,0.000000000}, {805,0.000070796}, {810,0.000017699}, {815,0.000053097}, {820,0.000017699}, {825,0.000017699}, {830,0.000017699}, {835,0.000035398}, {840,0.000017699}, {845,0.000030973}, {850,0.000048673}, {855,0.000035398}, {860,0.000053097}, {865,0.000061947}, {870,0.000070796}, {875,0.000070796}, {880,0.000070796}, {885,0.000017699}, {890,0.000053097}, {895,0.000070796}, {900,0.000017699}, {905,0.000035398}, {910,0.000013274}, {915,0.000035398}, {920,0.000048673}, {925,0.000048673}, {930,0.000017699}, {935,0.000035398}, {940,0.000035398}, {945,0.000000000}, {950,0.000030973}, {955,0.000035398}, {960,0.000066372}, {965,0.000017699}, {970,0.000066372}, {975,0.000123894}, {980,0.000070796}, {985,0.000106195}, {990,0.000053097}, {995,0.000053097}, {1000,0.000084071}, {1010,0.000070796}, {1020,0.000128319}, {1030,0.000106195}, {1040,0.000070796}, {1050,0.000017699}, {1060,0.000048673}, {1070,0.000048673}, {1080,0.000053097}, {1090,0.000053097}, {1100,0.000088496}, {1110,0.000070796}, {1120,0.000053097}, {1130,0.000017699}, {1140,0.000070796}, {1150,0.000119469}, {1160,0.000000000}, {1170,0.000101770}, {1180,0.000035398}, {1190,0.000070796}, {1200,0.000017699}, {1210,0.000017699}, {1220,0.000088496}, {1230,0.000088496}, {1240,0.000053097}, {1250,0.000092920}, {1260,0.000159292}, {1270,0.000030973}, {1280,0.000017699}, {1290,0.000017699}, {1300,0.000053097}, {1310,0.000101770}, {1320,0.000053097}, {1330,0.000066372}, {1340,0.000084071}, {1350,0.000106195}, {1360,0.000115044}, {1370,0.000115044}, {1380,0.000380531}, {1390,0.001336283}, {1400,0.001557522}, {1410,0.000331858}, {1420,0.000084071}, {1430,0.000017699}, {1440,0.000053097}, {1450,0.000013274}, {1460,0.000070796}, {1470,0.000115044}, {1480,0.000070796}, {1490,0.000000000}, {1500,0.000035398}, {1510,0.000084071}, {1520,0.000070796}, {1530,0.000053097}, {1540,0.000123894}, {1550,0.000066372}, {1560,0.000048673}, {1570,0.000106195}, {1580,0.000000000}, {1590,0.000101770}, {1600,0.000035398}, {1610,0.000066372}, {1620,0.000101770}, {1630,0.000053097}, {1640,0.000070796}, {1650,0.000066372}, {1660,0.000084071}, {1670,0.000172566}, {1680,0.000000000}, {1690,0.000053097}, {1700,0.000053097}, {1710,0.000137168}, {1720,0.000123894}, {1730,0.000123894}, {1740,0.000097345}, {1750,0.000088496}, {1760,0.000088496}, {1770,0.000123894}, {1780,0.000123894}, {1790,0.000119469}, {1800,0.000159292}, {1810,0.000172566}, {1820,0.000141593}, {1830,0.000141593}, {1840,0.000088496}, {1850,0.000123894}, {1860,0.000066372}, {1870,0.000088496}, {1880,0.000017699}, {1890,0.000101770}, {1900,0.000123894}, {1910,0.000119469}, {1920,0.000084071}, {1930,0.000017699}, {1940,0.000101770}, {1950,0.000101770}, {1960,0.000053097}, {1970,0.000070796}, {1980,0.000088496}, {1990,0.000088496}, {2000,0.000030973}, {2050,0.000137168}, {2100,0.000123894}, {2150,0.000225664}, {2200,0.000066372}, {2250,0.000141593}, {2300,0.000132743}, {2350,0.000150442}, {2400,0.000070796}, {2450,0.000053097}, {2500,0.000017699}, {2550,0.000150442}, {2600,0.000141593}, {2650,0.000159292}, {2700,0.000137168}, {2750,0.000150442}, {2800,0.000159292}, {2850,0.000389381}, {2900,0.000535398}, {2950,0.000380531}, {3000,0.000101770}, {3050,0.000504425}, {3100,0.001225664}, {3150,0.000769912}, {3200,0.000030973}, {3250,0.000207965}, {3300,0.001163717}, {3350,0.001676991}, {3400,0.000597345}, {3450,0.000256637}, {3500,0.000159292}, {3550,0.000261062}, {3600,0.000663717}, {3650,0.001128319}, {3700,0.000212389}, {3750,0.000575221}, {3800,0.000154867}, {3850,0.000884956}, {3900,0.000384956}, {3950,0.001287611}, {4000,0.000451327}, {4050,0.000176991}, {4100,0.000867257}, {4150,0.000185841}, {4200,0.000522124}, {4250,0.000216814}, {4300,0.000216814}, {4350,0.000438053}, {4400,0.000243363}, {4450,0.000292035}, {4500,0.000212389}, {4550,0.000907080}, {4600,0.004287611}, {4650,0.000601770}, {4700,0.000345133}, {4750,0.000194690}, {4800,0.000225664}, {4850,0.003508850}, {4900,0.000513274}, {4950,0.000296460}, {5000,0.000261062}, {5050,0.000194690}, {5100,0.001026549}, {5150,0.000265487}, {5200,0.000207965}, {5250,0.000933333}, {5300,0.001057778}, {5350,0.005017778}, {5400,0.000657778}, {5450,0.000266667}, {5500,0.001657778}, {5550,0.003520000}, {5600,0.001160000}, {5650,0.000280000}, {5700,0.000173333}, {5750,0.000186667}, {5800,0.000324444}, {5850,0.000297778}, {5900,0.000533333}, {5950,0.000440000}, {6000,0.000191111}, {6050,0.004556}, {6100,0.015611}, {6150,0.010611}, {6200,0.000222}, {6250,0.003778}, {6300,0.000444}, {6350,0.000222}, {6400,0.000000}, {6450,0.000667}, {6500,0.002556}, {6550,0.002889}, {6600,0.000222}, {6650,0.000000}, {6700,0.001667}, {6750,0.000667}, {6800,0.000000}, {6850,0.000222}, {6900,0.000444}, {6950,0.001000}, {7000,0.000389}, {7050,0.002667}, {7100,0.000000}, {7150,0.000444}, {7200,0.000667}, {7250,0.001333}, {7300,0.003667}, {7350,0.000222}, {7400,0.000444}, {7450,0.000444}, {7500,0.000444}, {7550,0.000222}, {7600,0.000222}, {7650,0.000389}, {7700,0.000444}, {7750,0.000000}, {7800,0.000000}, {7850,0.000444}, {7900,0.000667}, {7950,0.000667}, {8000,0.000889}, {8050,0.000389}, {8100,0.000000}, {8150,0.000444}, {8200,0.000444}, {8250,0.000389}, {8300,0.000000}, {8350,0.001000}, {8400,0.001333}, {8450,0.000444}, {8500,0.000000}, {8550,0.000444}, {8600,0.000000}, {8650,0.000222}, {8700,0.000444}, {8750,0.000444}, {8800,0.000833}, {8850,0.000222}, {8900,0.001111}, {8950,0.000667}, {9000,0.000667}, {9050,0.000222}, {9100,0.000611}, {9150,0.000389}, {9200,0.000444}, {9250,0.000444}, {9300,0.000000}, {9350,0.000444}, {9400,0.000222}, {9450,0.000444}, {9500,0.000444}, {9550,0.000222}, {9600,0.000611}, {9650,0.000000}, {9700,0.000667}, {9750,0.000000}, {9800,0.000222}, {9850,0.000444}, {9900,0.001278}, {9950,0.000000}, {10000,0.000667}, {10100,0.001722}, {10200,0.001333}, {10300,0.000667}, {10400,0.000444}, {10500,0.000444}, {10600,0.000222}, {10700,0.000667}, {10800,0.000000}, {10900,0.000667}, {11000,0.001056}, {11100,0.000611}, {11200,0.000444}, {11300,0.001222}, {11400,0.000222}, {11500,0.000444}, {11600,0.000444}, {11700,0.000389}, {11800,0.000889}, {11900,0.000611}, {12000,0.000889}, {12100,0.001056}, {12200,0.000000}, {12300,0.001778}, {12400,0.001778}, {12500,0.001500}, {12600,0.000889}, {12700,0.000444}, {12800,0.000222}, {12900,0.000222}, {13000,0.001500}, {13100,0.000667}, {13200,0.000222}, {13300,0.000667}, {13400,0.006556}, {13500,0.001111}, {13600,0.000889}, {13700,0.001778}, {13800,0.001556}, {13900,0.008000}, {14000,0.006111}, {14100,0.000611}, {14200,0.002889}, {14300,0.001944}, {14400,0.000889}, {14500,0.001111}, {14600,0.005556}, {14700,0.003056}, {14800,0.001111}, {14900,0.000333}, {15000,0.002389}, {15100,0.006667}, {15200,0.000889}, {15300,0.003500}, {15400,0.004167}, {15500,0.001722}, {15600,0.001778}, {15700,0.004667}, {15800,0.002444}, {15900,0.004722}, {16000,0.002889}, {16100,0.000889}, {16200,0.000222}, {16300,0.000667}, {16400,0.000833}, {16500,0.004000}, {16600,0.003556}, {16700,0.003944}, {16800,0.001944}, {16900,0.001111}, {17000,0.003111}, {17100,0.004556}, {17200,0.002611}, {17300,0.003111}, {17400,0.001111}, {17500,0.004778}, {17600,0.005944}, {17700,0.001944}, {17800,0.001944}, {17900,0.007278}, {18000,0.021000}, {18100,0.003111}, {18200,0.001778}, {18300,0.006833}, {18400,0.004222}, {18500,0.003500}, {18600,0.003000}, {18700,0.002667}, {18800,0.009889}, {18900,0.004611}, {19000,0.003556}, {19100,0.001722}, {19200,0.000444}, {19300,0.000889}, {19400,0.007889}, {19500,0.002111}, {19600,0.003278}, {19700,0.031222}, {19800,0.002222}, {19900,0.003722}, {20000,0.003250}};
data["big_flat"]["TypeClasses"]["post"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000973451}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.001318584}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000035398}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.000000000}, {5100,0.000000000}, {5150,0.000000000}, {5200,0.000000000}, {5250,0.000000000}, {5300,0.000000000}, {5350,0.000000000}, {5400,0.000000000}, {5450,0.000000000}, {5500,0.000000000}, {5550,0.000000000}, {5600,0.000000000}, {5650,0.000000000}, {5700,0.000000000}, {5750,0.000000000}, {5800,0.000000000}, {5850,0.000000000}, {5900,0.000000000}, {5950,0.000000000}, {6000,0.000000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000611}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000000}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClasses"]["post"]["user"] = {{1,0.000013274}, {2,0.000013274}, {3,0.000053097}, {4,0.000030973}, {5,0.000013274}, {6,0.000092920}, {7,0.000017699}, {8,0.000048673}, {9,0.000017699}, {10,0.000000000}, {11,0.000017699}, {12,0.000039823}, {13,0.000030973}, {14,0.000048673}, {15,0.000048673}, {16,0.000053097}, {17,0.000000000}, {18,0.000035398}, {19,0.000000000}, {20,0.000013274}, {21,0.000053097}, {22,0.000048673}, {23,0.000061947}, {24,0.000017699}, {25,0.000000000}, {26,0.000030973}, {27,0.000030973}, {28,0.000026549}, {29,0.000030973}, {30,0.000017699}, {31,0.000013274}, {32,0.000044248}, {33,0.000044248}, {34,0.000039823}, {35,0.000044248}, {36,0.000053097}, {37,0.000030973}, {38,0.000026549}, {39,0.000053097}, {40,0.000030973}, {41,0.000013274}, {42,0.000048673}, {43,0.000017699}, {44,0.000053097}, {45,0.000035398}, {46,0.000053097}, {47,0.000035398}, {48,0.000026549}, {49,0.000000000}, {50,0.000030973}, {51,0.000035398}, {52,0.000026549}, {53,0.000000000}, {54,0.000048673}, {55,0.000030973}, {56,0.000048673}, {57,0.000030973}, {58,0.000013274}, {59,0.000030973}, {60,0.000053097}, {61,0.000026549}, {62,0.000017699}, {63,0.000017699}, {64,0.000017699}, {65,0.000026549}, {66,0.000000000}, {67,0.000075221}, {68,0.000017699}, {69,0.000053097}, {70,0.000030973}, {71,0.000061947}, {72,0.000030973}, {73,0.000013274}, {74,0.000013274}, {75,0.000017699}, {76,0.000044248}, {77,0.000044248}, {78,0.000097345}, {79,0.000030973}, {80,0.000075221}, {81,0.000026549}, {82,0.000017699}, {83,0.000017699}, {84,0.000017699}, {85,0.000013274}, {86,0.000044248}, {87,0.000017699}, {88,0.000017699}, {89,0.000026549}, {90,0.000039823}, {91,0.000026549}, {92,0.000030973}, {93,0.000026549}, {94,0.000030973}, {95,0.000048673}, {96,0.000039823}, {97,0.000044248}, {98,0.000092920}, {99,0.000039823}, {100,0.000044248}, {101,0.000013274}, {102,0.000026549}, {103,0.000044248}, {104,0.000044248}, {105,0.000013274}, {106,0.000057522}, {107,0.000000000}, {108,0.000017699}, {109,0.000017699}, {110,0.000000000}, {111,0.001035398}, {112,0.000030973}, {113,0.000017699}, {114,0.000000000}, {115,0.000030973}, {116,0.000017699}, {117,0.000013274}, {118,0.000000000}, {119,0.000017699}, {120,0.000000000}, {121,0.000030973}, {122,0.000030973}, {123,0.000039823}, {124,0.000053097}, {125,0.000026549}, {126,0.000013274}, {127,0.000013274}, {128,0.000017699}, {129,0.000030973}, {130,0.001190265}, {131,0.000044248}, {132,0.000013274}, {133,0.000044248}, {134,0.000048673}, {135,0.000053097}, {136,0.000013274}, {137,0.000057522}, {138,0.000000000}, {139,0.000000000}, {140,0.000044248}, {141,0.000044248}, {142,0.000017699}, {143,0.000057522}, {144,0.000026549}, {145,0.000013274}, {146,0.000000000}, {147,0.000013274}, {148,0.000030973}, {149,0.000000000}, {150,0.000026549}, {151,0.000000000}, {152,0.000013274}, {153,0.000026549}, {154,0.000044248}, {155,0.000026549}, {156,0.000053097}, {157,0.000000000}, {158,0.000057522}, {159,0.000026549}, {160,0.000030973}, {161,0.000057522}, {162,0.000013274}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000053097}, {167,0.000013274}, {168,0.000000000}, {169,0.000013274}, {170,0.000013274}, {171,0.000013274}, {172,0.000000000}, {173,0.000044248}, {174,0.000026549}, {175,0.000066372}, {176,0.000030973}, {177,0.000026549}, {178,0.000017699}, {179,0.000026549}, {180,0.000035398}, {181,0.000000000}, {182,0.000030973}, {183,0.000013274}, {184,0.000000000}, {185,0.000092920}, {186,0.000013274}, {187,0.000035398}, {188,0.000026549}, {189,0.000030973}, {190,0.000044248}, {191,0.000013274}, {192,0.000026549}, {193,0.000017699}, {194,0.000057522}, {195,0.000026549}, {196,0.000013274}, {197,0.000000000}, {198,0.000013274}, {199,0.000030973}, {200,0.000039823}, {201,0.000017699}, {202,0.000061947}, {203,0.000013274}, {204,0.000000000}, {205,0.000048673}, {206,0.000035398}, {207,0.000017699}, {208,0.000061947}, {209,0.000000000}, {210,0.000013274}, {211,0.000013274}, {212,0.000030973}, {213,0.000048673}, {214,0.000088496}, {215,0.000044248}, {216,0.000013274}, {217,0.000000000}, {218,0.000013274}, {219,0.000057522}, {220,0.000035398}, {221,0.000044248}, {222,0.000017699}, {223,0.000053097}, {224,0.000013274}, {225,0.000017699}, {226,0.000017699}, {227,0.000035398}, {228,0.000053097}, {229,0.000026549}, {230,0.000013274}, {231,0.000017699}, {232,0.000030973}, {233,0.000035398}, {234,0.000026549}, {235,0.000013274}, {236,0.000013274}, {237,0.000026549}, {238,0.000000000}, {239,0.000017699}, {240,0.000017699}, {241,0.000061947}, {242,0.000035398}, {243,0.000048673}, {244,0.000035398}, {245,0.000000000}, {246,0.000026549}, {247,0.000035398}, {248,0.000000000}, {249,0.000030973}, {250,0.000035398}, {251,0.000013274}, {252,0.000035398}, {253,0.000048673}, {254,0.000013274}, {255,0.000039823}, {256,0.000088496}, {257,0.000035398}, {258,0.000053097}, {259,0.000017699}, {260,0.000035398}, {261,0.000017699}, {262,0.000000000}, {263,0.000030973}, {264,0.000017699}, {265,0.000013274}, {266,0.000070796}, {267,0.000070796}, {268,0.000030973}, {269,0.000053097}, {270,0.000035398}, {271,0.000013274}, {272,0.000044248}, {273,0.000000000}, {274,0.000053097}, {275,0.000013274}, {276,0.000030973}, {277,0.000075221}, {278,0.000030973}, {279,0.000030973}, {280,0.000013274}, {281,0.000053097}, {282,0.000017699}, {283,0.000035398}, {284,0.000000000}, {285,0.000048673}, {286,0.000030973}, {287,0.000061947}, {288,0.000084071}, {289,0.000013274}, {290,0.000000000}, {291,0.000061947}, {292,0.000017699}, {293,0.000030973}, {294,0.000030973}, {295,0.000030973}, {296,0.000053097}, {297,0.000000000}, {298,0.000035398}, {299,0.000017699}, {300,0.000000000}, {301,0.000030973}, {302,0.000000000}, {303,0.000017699}, {304,0.000044248}, {305,0.000000000}, {306,0.000017699}, {307,0.000070796}, {308,0.000000000}, {309,0.000030973}, {310,0.000000000}, {311,0.000030973}, {312,0.000017699}, {313,0.000057522}, {314,0.000013274}, {315,0.000017699}, {316,0.000039823}, {317,0.000044248}, {318,0.000035398}, {319,0.000000000}, {320,0.000000000}, {321,0.000035398}, {322,0.000000000}, {323,0.000017699}, {324,0.000013274}, {325,0.000013274}, {326,0.000017699}, {327,0.000017699}, {328,0.000048673}, {329,0.000000000}, {330,0.000030973}, {331,0.000061947}, {332,0.000044248}, {333,0.000013274}, {334,0.000070796}, {335,0.000013274}, {336,0.000070796}, {337,0.000017699}, {338,0.000048673}, {339,0.000044248}, {340,0.000035398}, {341,0.000035398}, {342,0.000017699}, {343,0.000013274}, {344,0.000066372}, {345,0.000026549}, {346,0.000017699}, {347,0.000000000}, {348,0.000048673}, {349,0.000000000}, {350,0.000044248}, {351,0.000013274}, {352,0.000017699}, {353,0.000030973}, {354,0.000017699}, {355,0.000000000}, {356,0.000013274}, {357,0.000044248}, {358,0.000030973}, {359,0.000017699}, {360,0.000000000}, {361,0.000013274}, {362,0.000026549}, {363,0.000017699}, {364,0.000017699}, {365,0.000013274}, {366,0.000026549}, {367,0.000000000}, {368,0.000075221}, {369,0.000057522}, {370,0.000057522}, {371,0.000013274}, {372,0.000013274}, {373,0.000044248}, {374,0.000000000}, {375,0.000000000}, {376,0.000017699}, {377,0.000030973}, {378,0.000026549}, {379,0.000053097}, {380,0.000026549}, {381,0.000044248}, {382,0.000026549}, {383,0.000044248}, {384,0.000000000}, {385,0.000017699}, {386,0.000026549}, {387,0.000030973}, {388,0.000030973}, {389,0.000000000}, {390,0.000013274}, {391,0.000035398}, {392,0.000013274}, {393,0.000066372}, {394,0.000013274}, {395,0.000044248}, {396,0.000017699}, {397,0.000030973}, {398,0.000000000}, {399,0.000030973}, {400,0.000026549}, {401,0.000000000}, {402,0.000013274}, {403,0.000039823}, {404,0.000013274}, {405,0.000030973}, {406,0.000013274}, {407,0.000017699}, {408,0.000030973}, {409,0.000013274}, {410,0.000013274}, {411,0.000026549}, {412,0.000044248}, {413,0.000057522}, {414,0.000013274}, {415,0.000017699}, {416,0.000057522}, {417,0.000026549}, {418,0.000048673}, {419,0.000035398}, {420,0.000000000}, {421,0.000013274}, {422,0.000057522}, {423,0.000026549}, {424,0.000030973}, {425,0.000044248}, {426,0.000066372}, {427,0.000039823}, {428,0.000030973}, {429,0.000013274}, {430,0.000013274}, {431,0.000013274}, {432,0.000057522}, {433,0.000000000}, {434,0.000030973}, {435,0.000017699}, {436,0.000017699}, {437,0.000057522}, {438,0.000013274}, {439,0.000017699}, {440,0.000013274}, {441,0.000030973}, {442,0.000044248}, {443,0.000035398}, {444,0.000017699}, {445,0.000026549}, {446,0.000013274}, {447,0.000039823}, {448,0.000017699}, {449,0.000035398}, {450,0.000044248}, {451,0.000061947}, {452,0.000070796}, {453,0.000013274}, {454,0.000030973}, {455,0.000035398}, {456,0.000026549}, {457,0.000035398}, {458,0.000017699}, {459,0.000088496}, {460,0.000030973}, {461,0.000026549}, {462,0.000048673}, {463,0.000000000}, {464,0.000013274}, {465,0.000000000}, {466,0.000000000}, {467,0.000048673}, {468,0.000079646}, {469,0.000048673}, {470,0.000048673}, {471,0.000092920}, {472,0.000013274}, {473,0.000048673}, {474,0.000013274}, {475,0.000048673}, {476,0.000017699}, {477,0.000000000}, {478,0.000000000}, {479,0.000017699}, {480,0.000017699}, {481,0.000000000}, {482,0.000000000}, {483,0.000030973}, {484,0.000030973}, {485,0.000053097}, {486,0.000030973}, {487,0.000057522}, {488,0.000026549}, {489,0.000044248}, {490,0.000030973}, {491,0.000030973}, {492,0.000030973}, {493,0.000035398}, {494,0.000017699}, {495,0.000013274}, {496,0.000017699}, {497,0.000048673}, {498,0.000030973}, {499,0.000017699}, {500,0.000048673}, {505,0.000044248}, {510,0.000066372}, {515,0.000017699}, {520,0.000000000}, {525,0.000053097}, {530,0.000017699}, {535,0.000044248}, {540,0.000000000}, {545,0.000026549}, {550,0.000013274}, {555,0.000030973}, {560,0.000044248}, {565,0.000044248}, {570,0.000048673}, {575,0.000000000}, {580,0.000013274}, {585,0.000017699}, {590,0.000053097}, {595,0.000000000}, {600,0.000035398}, {605,0.000053097}, {610,0.000030973}, {615,0.000013274}, {620,0.000030973}, {625,0.000017699}, {630,0.000044248}, {635,0.000066372}, {640,0.000017699}, {645,0.000000000}, {650,0.000035398}, {655,0.000035398}, {660,0.000035398}, {665,0.000048673}, {670,0.000017699}, {675,0.000030973}, {680,0.000017699}, {685,0.000000000}, {690,0.000017699}, {695,0.000030973}, {700,0.000044248}, {705,0.000030973}, {710,0.000048673}, {715,0.000017699}, {720,0.000013274}, {725,0.000044248}, {730,0.000048673}, {735,0.000048673}, {740,0.000030973}, {745,0.000013274}, {750,0.000017699}, {755,0.000044248}, {760,0.000026549}, {765,0.000013274}, {770,0.000061947}, {775,0.000017699}, {780,0.000035398}, {785,0.000017699}, {790,0.000035398}, {795,0.000017699}, {800,0.000057522}, {805,0.000030973}, {810,0.000035398}, {815,0.000017699}, {820,0.000017699}, {825,0.000070796}, {830,0.000030973}, {835,0.000000000}, {840,0.000000000}, {845,0.000035398}, {850,0.000026549}, {855,0.000013274}, {860,0.000000000}, {865,0.000048673}, {870,0.000035398}, {875,0.000061947}, {880,0.000017699}, {885,0.000035398}, {890,0.000048673}, {895,0.000044248}, {900,0.000053097}, {905,0.000048673}, {910,0.000079646}, {915,0.000053097}, {920,0.000035398}, {925,0.000017699}, {930,0.000017699}, {935,0.000066372}, {940,0.000030973}, {945,0.000048673}, {950,0.000079646}, {955,0.000000000}, {960,0.000044248}, {965,0.000035398}, {970,0.000035398}, {975,0.000066372}, {980,0.000013274}, {985,0.000079646}, {990,0.000035398}, {995,0.000044248}, {1000,0.000017699}, {1010,0.000017699}, {1020,0.000000000}, {1030,0.000075221}, {1040,0.000000000}, {1050,0.000017699}, {1060,0.000017699}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000039823}, {1100,0.000035398}, {1110,0.000013274}, {1120,0.000119469}, {1130,0.000000000}, {1140,0.000013274}, {1150,0.000026549}, {1160,0.000044248}, {1170,0.000000000}, {1180,0.000061947}, {1190,0.000053097}, {1200,0.000017699}, {1210,0.000026549}, {1220,0.000017699}, {1230,0.000048673}, {1240,0.000017699}, {1250,0.000013274}, {1260,0.000053097}, {1270,0.000013274}, {1280,0.000017699}, {1290,0.000053097}, {1300,0.000013274}, {1310,0.000017699}, {1320,0.000013274}, {1330,0.000053097}, {1340,0.000013274}, {1350,0.000044248}, {1360,0.000013274}, {1370,0.000017699}, {1380,0.000013274}, {1390,0.000013274}, {1400,0.000030973}, {1410,0.000035398}, {1420,0.000030973}, {1430,0.000048673}, {1440,0.000039823}, {1450,0.000061947}, {1460,0.000026549}, {1470,0.000035398}, {1480,0.000030973}, {1490,0.000017699}, {1500,0.000000000}, {1510,0.000026549}, {1520,0.000030973}, {1530,0.000057522}, {1540,0.000061947}, {1550,0.000013274}, {1560,0.000013274}, {1570,0.000026549}, {1580,0.000013274}, {1590,0.000013274}, {1600,0.000013274}, {1610,0.000030973}, {1620,0.000026549}, {1630,0.000026549}, {1640,0.000039823}, {1650,0.000017699}, {1660,0.000030973}, {1670,0.000013274}, {1680,0.000013274}, {1690,0.000013274}, {1700,0.000030973}, {1710,0.000044248}, {1720,0.000044248}, {1730,0.000030973}, {1740,0.000000000}, {1750,0.000030973}, {1760,0.000044248}, {1770,0.000017699}, {1780,0.000013274}, {1790,0.000000000}, {1800,0.000053097}, {1810,0.000048673}, {1820,0.000026549}, {1830,0.000013274}, {1840,0.000066372}, {1850,0.000048673}, {1860,0.000026549}, {1870,0.000044248}, {1880,0.000061947}, {1890,0.000039823}, {1900,0.000000000}, {1910,0.000026549}, {1920,0.000061947}, {1930,0.000013274}, {1940,0.000057522}, {1950,0.000044248}, {1960,0.000026549}, {1970,0.000026549}, {1980,0.000013274}, {1990,0.000044248}, {2000,0.000030973}, {2050,0.000017699}, {2100,0.000061947}, {2150,0.000013274}, {2200,0.000013274}, {2250,0.000066372}, {2300,0.000013274}, {2350,0.000044248}, {2400,0.000030973}, {2450,0.000030973}, {2500,0.000013274}, {2550,0.000026549}, {2600,0.000030973}, {2650,0.000044248}, {2700,0.000000000}, {2750,0.000030973}, {2800,0.000013274}, {2850,0.000084071}, {2900,0.000000000}, {2950,0.000061947}, {3000,0.000000000}, {3050,0.000030973}, {3100,0.000017699}, {3150,0.000061947}, {3200,0.000061947}, {3250,0.000066372}, {3300,0.000035398}, {3350,0.000030973}, {3400,0.000030973}, {3450,0.000013274}, {3500,0.000000000}, {3550,0.000035398}, {3600,0.000053097}, {3650,0.000026549}, {3700,0.000053097}, {3750,0.000030973}, {3800,0.000013274}, {3850,0.000070796}, {3900,0.000044248}, {3950,0.000017699}, {4000,0.000044248}, {4050,0.000017699}, {4100,0.000039823}, {4150,0.000030973}, {4200,0.000013274}, {4250,0.000048673}, {4300,0.000017699}, {4350,0.000013274}, {4400,0.000000000}, {4450,0.000013274}, {4500,0.000000000}, {4550,0.000044248}, {4600,0.000017699}, {4650,0.000026549}, {4700,0.000066372}, {4750,0.000030973}, {4800,0.000026549}, {4850,0.000035398}, {4900,0.000026549}, {4950,0.000026549}, {5000,0.000000000}, {5050,0.000000000}, {5100,0.000079646}, {5150,0.000048673}, {5200,0.000000000}, {5250,0.000044444}, {5300,0.000062222}, {5350,0.000017778}, {5400,0.000026667}, {5450,0.000013333}, {5500,0.000053333}, {5550,0.000084444}, {5600,0.000048889}, {5650,0.000044444}, {5700,0.000057778}, {5750,0.000031111}, {5800,0.000048889}, {5850,0.000080000}, {5900,0.000017778}, {5950,0.000031111}, {6000,0.000035556}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000222}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000222}, {6850,0.000000}, {6900,0.000222}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000667}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000167}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000222}, {8350,0.000167}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000222}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000167}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000167}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000222}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000222}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000222}, {12200,0.000000}, {12300,0.000167}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000222}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000222}, {13800,0.000444}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000222}, {14900,0.000222}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000167}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000389}, {16600,0.000222}, {16700,0.000167}, {16800,0.000000}, {16900,0.000000}, {17000,0.000222}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000167}, {17800,0.000000}, {17900,0.000000}, {18000,0.000000}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000333}, {19200,0.000000}, {19300,0.000167}, {19400,0.000222}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000167}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClasses"]["post"]["system"] = {{1,0.000017699}, {2,0.000017699}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000017699}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000017699}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000013274}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000017699}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000035398}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000017699}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000017699}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000017699}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000013274}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000017699}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000017699}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000017699}, {193,0.000017699}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000017699}, {209,0.000000000}, {210,0.000000000}, {211,0.000017699}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000017699}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000017699}, {237,0.000017699}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000017699}, {245,0.000000000}, {246,0.000017699}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000017699}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000017699}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000017699}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000017699}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000017699}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000017699}, {353,0.000000000}, {354,0.000000000}, {355,0.000017699}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000017699}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000017699}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000017699}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000017699}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000017699}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000013274}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000017699}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000017699}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000017699}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000017699}, {3750,0.000035398}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.000000000}, {5100,0.000000000}, {5150,0.000000000}, {5200,0.000000000}, {5250,0.000000000}, {5300,0.000000000}, {5350,0.000000000}, {5400,0.000000000}, {5450,0.000000000}, {5500,0.000000000}, {5550,0.000000000}, {5600,0.000000000}, {5650,0.000000000}, {5700,0.000000000}, {5750,0.000000000}, {5800,0.000000000}, {5850,0.000000000}, {5900,0.000000000}, {5950,0.000000000}, {6000,0.000000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000000}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClasses"]["pre"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.000000000}, {5100,0.000000000}, {5150,0.000000000}, {5200,0.000000000}, {5250,0.000000000}, {5300,0.000000000}, {5350,0.000000000}, {5400,0.000000000}, {5450,0.000000000}, {5500,0.000000000}, {5550,0.000000000}, {5600,0.000000000}, {5650,0.000000000}, {5700,0.000000000}, {5750,0.000000000}, {5800,0.000000000}, {5850,0.000000000}, {5900,0.000000000}, {5950,0.000000000}, {6000,0.000000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000000}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClasses"]["pre"]["user"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000017699}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000017699}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000013274}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000017699}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000017699}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000030973}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000017699}, {47,0.000000000}, {48,0.000017699}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000017699}, {53,0.000013274}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000017699}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000013274}, {67,0.000017699}, {68,0.000000000}, {69,0.000000000}, {70,0.000017699}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000013274}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000026549}, {87,0.000000000}, {88,0.000000000}, {89,0.000017699}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000030973}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000017699}, {100,0.000000000}, {101,0.000000000}, {102,0.000013274}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000013274}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000013274}, {119,0.000017699}, {120,0.000000000}, {121,0.000000000}, {122,0.000013274}, {123,0.000013274}, {124,0.000013274}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000017699}, {131,0.000000000}, {132,0.000013274}, {133,0.000000000}, {134,0.000000000}, {135,0.000013274}, {136,0.000026549}, {137,0.000013274}, {138,0.000000000}, {139,0.000017699}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000013274}, {145,0.000000000}, {146,0.000000000}, {147,0.000013274}, {148,0.000013274}, {149,0.000013274}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000017699}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000013274}, {165,0.000000000}, {166,0.000013274}, {167,0.000013274}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000026549}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000017699}, {182,0.000000000}, {183,0.000000000}, {184,0.000013274}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000013274}, {189,0.000000000}, {190,0.000013274}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000017699}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000013274}, {203,0.000026549}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000013274}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000026549}, {212,0.000000000}, {213,0.000013274}, {214,0.000000000}, {215,0.000000000}, {216,0.000017699}, {217,0.000013274}, {218,0.000013274}, {219,0.000017699}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000035398}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000013274}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000013274}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000035398}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000017699}, {256,0.000000000}, {257,0.000013274}, {258,0.000013274}, {259,0.000017699}, {260,0.000013274}, {261,0.000000000}, {262,0.000030973}, {263,0.000000000}, {264,0.000017699}, {265,0.000030973}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000013274}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000017699}, {287,0.000000000}, {288,0.000017699}, {289,0.000000000}, {290,0.000017699}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000013274}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000017699}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000013274}, {314,0.000000000}, {315,0.000017699}, {316,0.000013274}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000017699}, {329,0.000013274}, {330,0.000017699}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000017699}, {338,0.000000000}, {339,0.000017699}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000013274}, {353,0.000013274}, {354,0.000000000}, {355,0.000013274}, {356,0.000000000}, {357,0.000026549}, {358,0.000000000}, {359,0.000000000}, {360,0.000017699}, {361,0.000000000}, {362,0.000035398}, {363,0.000000000}, {364,0.000017699}, {365,0.000035398}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000013274}, {372,0.000013274}, {373,0.000000000}, {374,0.000000000}, {375,0.000013274}, {376,0.000030973}, {377,0.000000000}, {378,0.000000000}, {379,0.000030973}, {380,0.000017699}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000013274}, {388,0.000000000}, {389,0.000000000}, {390,0.000017699}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000017699}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000030973}, {402,0.000000000}, {403,0.000000000}, {404,0.000017699}, {405,0.000000000}, {406,0.000000000}, {407,0.000030973}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000017699}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000017699}, {425,0.000017699}, {426,0.000000000}, {427,0.000013274}, {428,0.000017699}, {429,0.000017699}, {430,0.000017699}, {431,0.000017699}, {432,0.000030973}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000013274}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000013274}, {446,0.000013274}, {447,0.000013274}, {448,0.000013274}, {449,0.000000000}, {450,0.000000000}, {451,0.000013274}, {452,0.000013274}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000013274}, {457,0.000013274}, {458,0.000026549}, {459,0.000000000}, {460,0.000000000}, {461,0.000017699}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000017699}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000013274}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000017699}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000013274}, {498,0.000000000}, {499,0.000017699}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000017699}, {530,0.000000000}, {535,0.000013274}, {540,0.000000000}, {545,0.000000000}, {550,0.000013274}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000035398}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000044248}, {630,0.000000000}, {635,0.000017699}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000017699}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000017699}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000017699}, {725,0.000000000}, {730,0.000000000}, {735,0.000017699}, {740,0.000000000}, {745,0.000013274}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000017699}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000013274}, {855,0.000000000}, {860,0.000013274}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000017699}, {885,0.000000000}, {890,0.000000000}, {895,0.000013274}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000017699}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000017699}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000017699}, {985,0.000000000}, {990,0.000026549}, {995,0.000017699}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000013274}, {1030,0.000017699}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000017699}, {1100,0.000000000}, {1110,0.000017699}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000013274}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000017699}, {1200,0.000030973}, {1210,0.000000000}, {1220,0.000013274}, {1230,0.000000000}, {1240,0.000013274}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000030973}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000013274}, {1350,0.000013274}, {1360,0.000000000}, {1370,0.000017699}, {1380,0.000000000}, {1390,0.000017699}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000017699}, {1430,0.000017699}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000026549}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000013274}, {1540,0.000000000}, {1550,0.000013274}, {1560,0.000044248}, {1570,0.000013274}, {1580,0.000017699}, {1590,0.000030973}, {1600,0.000000000}, {1610,0.000017699}, {1620,0.000017699}, {1630,0.000000000}, {1640,0.000013274}, {1650,0.000017699}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000013274}, {1700,0.000000000}, {1710,0.000048673}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000013274}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000017699}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000017699}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000026549}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000013274}, {2050,0.000013274}, {2100,0.000017699}, {2150,0.000000000}, {2200,0.000017699}, {2250,0.000013274}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000013274}, {2500,0.000000000}, {2550,0.000017699}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000013274}, {2750,0.000000000}, {2800,0.000013274}, {2850,0.000000000}, {2900,0.000017699}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000013274}, {3100,0.000000000}, {3150,0.000030973}, {3200,0.000000000}, {3250,0.000013274}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000017699}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000013274}, {3900,0.000000000}, {3950,0.000026549}, {4000,0.000017699}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000026549}, {4250,0.000013274}, {4300,0.000017699}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000013274}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000017699}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.000000000}, {5100,0.000000000}, {5150,0.000017699}, {5200,0.000013274}, {5250,0.000017778}, {5300,0.000000000}, {5350,0.000017778}, {5400,0.000000000}, {5450,0.000000000}, {5500,0.000000000}, {5550,0.000000000}, {5600,0.000000000}, {5650,0.000000000}, {5700,0.000053333}, {5750,0.000000000}, {5800,0.000017778}, {5850,0.000000000}, {5900,0.000000000}, {5950,0.000000000}, {6000,0.000000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000167}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000167}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000222}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000222}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClasses"]["pre"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000017699}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.000000000}, {5100,0.000000000}, {5150,0.000000000}, {5200,0.000000000}, {5250,0.000000000}, {5300,0.000000000}, {5350,0.000000000}, {5400,0.000000000}, {5450,0.000000000}, {5500,0.000000000}, {5550,0.000000000}, {5600,0.000000000}, {5650,0.000000000}, {5700,0.000000000}, {5750,0.000000000}, {5800,0.000000000}, {5850,0.000000000}, {5900,0.000000000}, {5950,0.000000000}, {6000,0.000000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000000}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClasses"]["reif"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000004425}, {4,0.001000000}, {5,0.001000000}, {6,0.001000000}, {7,0.001199115}, {8,0.002000000}, {9,0.002000000}, {10,0.002000000}, {11,0.002610619}, {12,0.003000000}, {13,0.003000000}, {14,0.003092920}, {15,0.003964602}, {16,0.004000000}, {17,0.004061947}, {18,0.004159292}, {19,0.005000000}, {20,0.005000000}, {21,0.005159292}, {22,0.012544248}, {23,0.006123894}, {24,0.006000000}, {25,0.006495575}, {26,0.006840708}, {27,0.007792035}, {28,0.007097345}, {29,0.007982301}, {30,0.008061947}, {31,0.008694690}, {32,0.008181416}, {33,0.008938053}, {34,0.009159292}, {35,0.010482301}, {36,0.009650442}, {37,0.010256637}, {38,0.010632743}, {39,0.011216814}, {40,0.010659292}, {41,0.011836283}, {42,0.011681416}, {43,0.012561947}, {44,0.013022124}, {45,0.013066372}, {46,0.013977876}, {47,0.014106195}, {48,0.012831858}, {49,0.013743363}, {50,0.014044248}, {51,0.015601770}, {52,0.015137168}, {53,0.015566372}, {54,0.015699115}, {55,0.016800885}, {56,0.015592920}, {57,0.016690265}, {58,0.017924779}, {59,0.017814159}, {60,0.017424779}, {61,0.018588496}, {62,0.018694690}, {63,0.019765487}, {64,0.019336283}, {65,0.018915929}, {66,0.019070796}, {67,0.021274336}, {68,0.019734513}, {69,0.020862832}, {70,0.021101770}, {71,0.022433628}, {72,0.020884956}, {73,0.021929204}, {74,0.024132743}, {75,0.023606195}, {76,0.022725664}, {77,0.025327434}, {78,0.024207965}, {79,0.027203540}, {80,0.023743363}, {81,0.024424779}, {82,0.024663717}, {83,0.028146018}, {84,0.025181416}, {85,0.026676991}, {86,0.026721239}, {87,0.029783186}, {88,0.027380531}, {89,0.027712389}, {90,0.028022124}, {91,0.031747788}, {92,0.028553097}, {93,0.031747788}, {94,0.030314159}, {95,0.033659292}, {96,0.027915929}, {97,0.029460177}, {98,0.030858407}, {99,0.031530973}, {100,0.030314159}, {101,0.032039823}, {102,0.034185841}, {103,0.035084071}, {104,0.031367257}, {105,0.037256637}, {106,0.033340708}, {107,0.036486726}, {108,0.034092920}, {109,0.035721239}, {110,0.035867257}, {111,0.037871681}, {112,0.033548673}, {113,0.035690265}, {114,0.035654867}, {115,0.038176991}, {116,0.036539823}, {117,0.038296460}, {118,0.038504425}, {119,0.040734513}, {120,0.038867257}, {121,0.041199115}, {122,0.039769912}, {123,0.046212389}, {124,0.040296460}, {125,0.044637168}, {126,0.043699115}, {127,0.044517699}, {128,0.040495575}, {129,0.040761062}, {130,0.040765487}, {131,0.045809735}, {132,0.042455752}, {133,0.043721239}, {134,0.045460177}, {135,0.046004425}, {136,0.046376106}, {137,0.047044248}, {138,0.044942478}, {139,0.049278761}, {140,0.045429204}, {141,0.051207965}, {142,0.050066372}, {143,0.053265487}, {144,0.044668142}, {145,0.049176991}, {146,0.048384956}, {147,0.051570796}, {148,0.051101770}, {149,0.050398230}, {150,0.057884956}, {151,0.056075221}, {152,0.051606195}, {153,0.052898230}, {154,0.058929204}, {155,0.054429204}, {156,0.056787611}, {157,0.057867257}, {158,0.057929204}, {159,0.057513274}, {160,0.051522124}, {161,0.052486726}, {162,0.052561947}, {163,0.058194690}, {164,0.056137168}, {165,0.058256637}, {166,0.056314159}, {167,0.063035398}, {168,0.057053097}, {169,0.058792035}, {170,0.057190265}, {171,0.063632743}, {172,0.064438053}, {173,0.060601770}, {174,0.063446903}, {175,0.063579646}, {176,0.060765487}, {177,0.062190265}, {178,0.063641593}, {179,0.062566372}, {180,0.063508850}, {181,0.067486726}, {182,0.066933628}, {183,0.070212389}, {184,0.061256637}, {185,0.065628319}, {186,0.065225664}, {187,0.073194690}, {188,0.070853982}, {189,0.071057522}, {190,0.073778761}, {191,0.071721239}, {192,0.061942478}, {193,0.063424779}, {194,0.065384956}, {195,0.073570796}, {196,0.066349558}, {197,0.071725664}, {198,0.067495575}, {199,0.072066372}, {200,0.069716814}, {201,0.069482301}, {202,0.075278761}, {203,0.079668142}, {204,0.073566372}, {205,0.080106195}, {206,0.076495575}, {207,0.080017699}, {208,0.077778761}, {209,0.071008850}, {210,0.072858407}, {211,0.078982301}, {212,0.072168142}, {213,0.078061947}, {214,0.079584071}, {215,0.079495575}, {216,0.074716814}, {217,0.080194690}, {218,0.076716814}, {219,0.082230088}, {220,0.083429204}, {221,0.084809735}, {222,0.081336283}, {223,0.087398230}, {224,0.076517699}, {225,0.076619469}, {226,0.078800885}, {227,0.083743363}, {228,0.077376106}, {229,0.081371681}, {230,0.089880531}, {231,0.091690265}, {232,0.081707965}, {233,0.087168142}, {234,0.093654867}, {235,0.095119469}, {236,0.086455752}, {237,0.091685841}, {238,0.094141593}, {239,0.094305310}, {240,0.080561947}, {241,0.086287611}, {242,0.095429204}, {243,0.095716814}, {244,0.091584071}, {245,0.092553097}, {246,0.094203540}, {247,0.098858407}, {248,0.089734513}, {249,0.094424779}, {250,0.093995575}, {251,0.101212389}, {252,0.098500000}, {253,0.098938053}, {254,0.103676991}, {255,0.110694690}, {256,0.086163717}, {257,0.091915929}, {258,0.094446903}, {259,0.094982301}, {260,0.092716814}, {261,0.096234513}, {262,0.103247788}, {263,0.105110619}, {264,0.092230088}, {265,0.098336283}, {266,0.097119469}, {267,0.105075221}, {268,0.100960177}, {269,0.104809735}, {270,0.106022124}, {271,0.113181416}, {272,0.098469027}, {273,0.095845133}, {274,0.101508850}, {275,0.111225664}, {276,0.104641593}, {277,0.104075221}, {278,0.110685841}, {279,0.117765487}, {280,0.103115044}, {281,0.107526549}, {282,0.111287611}, {283,0.110261062}, {284,0.113004425}, {285,0.118672566}, {286,0.113358407}, {287,0.122123894}, {288,0.105973451}, {289,0.108451327}, {290,0.109247788}, {291,0.116327434}, {292,0.108407080}, {293,0.116287611}, {294,0.117429204}, {295,0.115862832}, {296,0.106473451}, {297,0.112769912}, {298,0.115893805}, {299,0.122641593}, {300,0.112933628}, {301,0.122500000}, {302,0.120172566}, {303,0.124827434}, {304,0.112464602}, {305,0.119207965}, {306,0.121243363}, {307,0.120508850}, {308,0.118955752}, {309,0.123938053}, {310,0.124738938}, {311,0.128084071}, {312,0.119110619}, {313,0.123924779}, {314,0.124663717}, {315,0.134323009}, {316,0.127681416}, {317,0.131181416}, {318,0.131615044}, {319,0.184278761}, {320,0.122424779}, {321,0.116128319}, {322,0.123734513}, {323,0.127035398}, {324,0.122889381}, {325,0.125632743}, {326,0.134522124}, {327,0.134871681}, {328,0.132592920}, {329,0.128278761}, {330,0.128646018}, {331,0.132088496}, {332,0.130137168}, {333,0.132809735}, {334,0.136146018}, {335,0.140809735}, {336,0.124685841}, {337,0.133106195}, {338,0.129938053}, {339,0.143845133}, {340,0.133163717}, {341,0.137601770}, {342,0.136522124}, {343,0.148181416}, {344,0.134097345}, {345,0.138477876}, {346,0.136159292}, {347,0.146969027}, {348,0.138420354}, {349,0.584163717}, {350,0.148039823}, {351,0.161172566}, {352,0.136181416}, {353,0.137592920}, {354,0.136420354}, {355,0.143300885}, {356,0.138557522}, {357,0.144247788}, {358,0.145269912}, {359,0.150690265}, {360,0.141491150}, {361,0.148575221}, {362,0.144566372}, {363,0.153561947}, {364,0.148584071}, {365,0.149792035}, {366,0.156964602}, {367,0.159566372}, {368,0.147694690}, {369,0.146663717}, {370,0.152898230}, {371,0.153769912}, {372,0.155725664}, {373,0.153880531}, {374,0.157176991}, {375,0.163407080}, {376,0.150725664}, {377,0.154292035}, {378,0.159446903}, {379,0.171539823}, {380,0.155212389}, {381,0.166097345}, {382,0.167535398}, {383,0.172889381}, {384,0.139809735}, {385,0.148676991}, {386,0.151977876}, {387,0.154955752}, {388,0.144522124}, {389,0.156407080}, {390,0.156283186}, {391,0.161323009}, {392,0.151106195}, {393,0.158070796}, {394,0.159725664}, {395,0.163902655}, {396,0.161008850}, {397,0.161681416}, {398,0.164898230}, {399,0.170084071}, {400,0.149097345}, {401,0.161491150}, {402,0.160508850}, {403,0.165862832}, {404,0.163783186}, {405,0.810597345}, {406,0.181230088}, {407,0.182163717}, {408,0.161584071}, {409,0.166061947}, {410,0.167101770}, {411,0.173831858}, {412,0.169517699}, {413,0.175619469}, {414,0.172349558}, {415,0.192044248}, {416,0.160668142}, {417,0.167225664}, {418,0.161123894}, {419,0.169584071}, {420,0.167561947}, {421,0.174681416}, {422,0.171584071}, {423,0.180230088}, {424,0.164884956}, {425,0.176070796}, {426,0.174287611}, {427,0.180796460}, {428,0.179491150}, {429,0.183451327}, {430,0.189610619}, {431,0.192261062}, {432,0.171305310}, {433,0.176420354}, {434,0.178982301}, {435,0.183986726}, {436,0.178575221}, {437,0.183402655}, {438,0.189774336}, {439,0.192048673}, {440,0.181504425}, {441,0.186097345}, {442,0.186796460}, {443,0.189610619}, {444,0.188252212}, {445,0.196592920}, {446,0.197960177}, {447,0.206964602}, {448,0.170221239}, {449,0.179539823}, {450,0.179353982}, {451,0.183535398}, {452,0.178800885}, {453,0.184380531}, {454,0.195623894}, {455,0.192376106}, {456,0.193004425}, {457,0.185792035}, {458,0.195566372}, {459,0.191212389}, {460,0.186690265}, {461,0.199991150}, {462,0.199982301}, {463,0.214650442}, {464,0.176371681}, {465,0.197287611}, {466,0.187880531}, {467,0.202513274}, {468,0.192084071}, {469,0.200362832}, {470,0.203561947}, {471,0.205146018}, {472,0.196982301}, {473,0.206168142}, {474,0.198473451}, {475,0.215075221}, {476,0.206407080}, {477,0.206579646}, {478,0.216853982}, {479,0.218278761}, {480,0.185314159}, {481,0.204539823}, {482,0.195256637}, {483,0.203473451}, {484,0.201323009}, {485,0.206066372}, {486,0.206154867}, {487,0.219411504}, {488,0.195460177}, {489,0.212159292}, {490,0.212128319}, {491,0.209924779}, {492,0.213230088}, {493,0.219256637}, {494,0.221106195}, {495,0.219982301}, {496,0.206553097}, {497,0.206380531}, {498,0.208238938}, {499,0.222592920}, {500,0.217902655}, {505,0.221544248}, {510,0.234022124}, {515,0.213274336}, {520,0.212765487}, {525,0.226070796}, {530,0.212765487}, {535,0.241132743}, {540,0.238615044}, {545,0.233154867}, {550,0.242185841}, {555,0.248690265}, {560,0.232584071}, {565,0.243884956}, {570,0.246013274}, {575,0.275190265}, {580,0.237681416}, {585,0.253424779}, {590,0.264407080}, {595,0.271734513}, {600,0.264110619}, {605,0.282725664}, {610,0.263296460}, {615,0.282048673}, {620,0.272632743}, {625,0.274053097}, {630,0.292353982}, {635,0.306221239}, {640,0.257654867}, {645,0.278991150}, {650,0.281225664}, {655,0.302438053}, {660,0.277544248}, {665,0.300632743}, {670,0.315508850}, {675,0.306915929}, {680,0.298203540}, {685,0.313920354}, {690,0.308300885}, {695,0.331681416}, {700,0.327955752}, {705,0.299951327}, {710,0.312756637}, {715,0.331300885}, {720,0.303513274}, {725,0.337575221}, {730,0.333429204}, {735,0.357500000}, {740,0.322902655}, {745,0.338482301}, {750,0.353796460}, {755,0.356553097}, {760,0.351915929}, {765,0.386172566}, {770,0.327823009}, {775,0.349601770}, {780,0.342911504}, {785,0.340960177}, {790,0.359168142}, {795,0.377783186}, {800,0.342424779}, {805,0.367508850}, {810,0.368017699}, {815,0.393464602}, {820,0.370150442}, {825,0.383265487}, {830,0.408199115}, {835,0.375601770}, {840,0.358106195}, {845,0.388176991}, {850,0.381154867}, {855,0.408946903}, {860,0.396380531}, {865,0.391977876}, {870,0.401384956}, {875,0.424500000}, {880,0.397420354}, {885,0.438407080}, {890,0.434730088}, {895,0.466482301}, {900,0.384269912}, {905,0.409380531}, {910,0.421318584}, {915,0.431690265}, {920,0.413084071}, {925,0.452845133}, {930,0.418393805}, {935,0.462858407}, {940,0.440097345}, {945,0.443446903}, {950,0.458676991}, {955,0.477491150}, {960,0.416995575}, {965,0.453199115}, {970,0.452964602}, {975,0.488048673}, {980,0.462327434}, {985,0.479376106}, {990,0.490694690}, {995,0.486336283}, {1000,0.463283186}, {1010,0.484221239}, {1020,0.498221239}, {1030,0.467207965}, {1040,0.453619469}, {1050,0.501017699}, {1060,0.478415929}, {1070,0.509637168}, {1080,0.497619469}, {1090,0.489088496}, {1100,0.510951327}, {1110,0.536154867}, {1120,0.508030973}, {1130,0.552376106}, {1140,0.544123894}, {1150,0.593876106}, {1160,0.518163717}, {1170,0.540951327}, {1180,0.558849558}, {1190,0.579508850}, {1200,0.551902655}, {1210,0.600876106}, {1220,0.560495575}, {1230,0.606712389}, {1240,0.588637168}, {1250,0.606725664}, {1260,0.612752212}, {1270,0.643871681}, {1280,0.571756637}, {1290,0.598831858}, {1300,0.614438053}, {1310,0.653190265}, {1320,0.614061947}, {1330,0.628942478}, {1340,0.667915929}, {1350,0.650287611}, {1360,0.623212389}, {1370,0.676787611}, {1380,0.661982301}, {1390,0.718486726}, {1400,0.688641593}, {1410,0.645836283}, {1420,0.691168142}, {1430,0.712274336}, {1440,0.663115044}, {1450,0.710827434}, {1460,0.712057522}, {1470,0.768119469}, {1480,0.722057522}, {1490,0.726977876}, {1500,0.758106195}, {1510,0.762818584}, {1520,0.738039823}, {1530,0.796818584}, {1540,0.704084071}, {1550,0.758004425}, {1560,0.733092920}, {1570,0.737163717}, {1580,0.762216814}, {1590,0.798495575}, {1600,0.730889381}, {1610,0.785836283}, {1620,0.786942478}, {1630,0.837101770}, {1640,0.786451327}, {1650,0.819159292}, {1660,0.867827434}, {1670,0.804632743}, {1680,0.777522124}, {1690,0.832800885}, {1700,0.818544248}, {1710,0.883451327}, {1720,0.850982301}, {1730,0.821933628}, {1740,0.863699115}, {1750,0.891243363}, {1760,0.846061947}, {1770,0.911668142}, {1780,0.910407080}, {1790,0.968336283}, {1800,0.832610619}, {1810,0.889212389}, {1820,0.899070796}, {1830,0.894730088}, {1840,0.879539823}, {1850,0.948889381}, {1860,0.895570796}, {1870,0.958646018}, {1880,0.928601770}, {1890,0.935473451}, {1900,0.972000000}, {1910,1.001668142}, {1920,0.881995575}, {1930,0.945154867}, {1940,0.948699115}, {1950,1.027685841}, {1960,0.961880531}, {1970,0.999393805}, {1980,1.037128319}, {1990,1.017623894}, {2000,0.986345133}, {2050,0.948469027}, {2100,1.034893805}, {2150,1.109707965}, {2200,1.102827434}, {2250,1.142955752}, {2300,1.243185841}, {2350,1.247234513}, {2400,1.185734513}, {2450,1.247570796}, {2500,1.272858407}, {2550,1.439654867}, {2600,1.291150442}, {2650,1.387070796}, {2700,1.387725664}, {2750,1.559557522}, {2800,1.466982301}, {2850,1.462393805}, {2900,1.515203540}, {2950,1.553336283}, {3000,1.628101770}, {3050,1.695442478}, {3100,1.653690265}, {3150,1.950438053}, {3200,1.548119469}, {3250,1.715818584}, {3300,1.766495575}, {3350,2.086495575}, {3400,1.755477876}, {3450,1.940092920}, {3500,1.900411504}, {3550,2.077646018}, {3600,1.780106195}, {3650,1.868176991}, {3700,2.018876106}, {3750,2.051769912}, {3800,2.071035398}, {3850,2.023004425}, {3900,2.202738938}, {3950,2.303942478}, {4000,2.090128319}, {4050,2.271225664}, {4100,2.046960177}, {4150,2.288641593}, {4200,2.234911504}, {4250,2.331526549}, {4300,2.364694690}, {4350,2.610132743}, {4400,2.329553097}, {4450,2.449752212}, {4500,2.448654867}, {4550,2.567323009}, {4600,2.651000000}, {4650,2.905769912}, {4700,2.632946903}, {4750,2.668429204}, {4800,2.525730088}, {4850,2.806446903}, {4900,2.649646018}, {4950,2.863911504}, {5000,2.688809735}, {5050,3.002685841}, {5100,3.026880531}, {5150,2.997942478}, {5200,2.742163717}, {5250,2.775662222}, {5300,2.986933333}, {5350,3.210448889}, {5400,3.197706667}, {5450,3.048840000}, {5500,3.277284444}, {5550,3.301644444}, {5600,3.142648889}, {5650,3.056920000}, {5700,3.084635556}, {5750,3.424391111}, {5800,3.222822222}, {5850,3.467760000}, {5900,3.272897778}, {5950,3.640186667}, {6000,3.421853333}, {6050,3.436611}, {6100,3.576444}, {6150,3.258722}, {6200,3.410500}, {6250,3.558944}, {6300,3.528000}, {6350,3.694056}, {6400,3.255389}, {6450,3.577500}, {6500,3.621500}, {6550,3.925000}, {6600,3.678333}, {6650,4.088056}, {6700,3.730444}, {6750,4.019778}, {6800,3.682556}, {6850,3.799556}, {6900,4.107500}, {6950,3.987389}, {7000,4.017778}, {7050,4.231444}, {7100,4.337111}, {7150,4.507222}, {7200,3.731278}, {7250,4.072222}, {7300,3.955778}, {7350,4.376333}, {7400,4.282056}, {7450,4.277111}, {7500,4.346389}, {7550,4.723444}, {7600,4.375889}, {7650,4.487444}, {7700,4.243333}, {7750,4.450000}, {7800,4.587444}, {7850,4.660611}, {7900,4.737833}, {7950,4.694167}, {8000,4.378944}, {8050,4.872500}, {8100,4.691500}, {8150,5.068778}, {8200,4.289944}, {8250,4.807500}, {8300,4.810278}, {8350,5.006778}, {8400,4.672556}, {8450,4.537722}, {8500,4.888722}, {8550,5.070222}, {8600,4.927333}, {8650,5.134778}, {8700,5.479778}, {8750,5.213722}, {8800,4.868000}, {8850,5.116167}, {8900,5.097333}, {8950,5.638222}, {9000,5.158333}, {9050,5.524056}, {9100,5.379167}, {9150,5.948333}, {9200,5.584389}, {9250,5.175222}, {9300,5.335889}, {9350,5.392778}, {9400,5.541389}, {9450,5.772556}, {9500,5.608611}, {9550,5.773722}, {9600,5.288833}, {9650,5.844944}, {9700,5.900000}, {9750,5.724722}, {9800,5.573944}, {9850,6.127944}, {9900,5.958278}, {9950,6.369833}, {10000,5.628278}, {10100,6.281056}, {10200,6.301167}, {10300,6.100667}, {10400,5.755056}, {10500,5.801667}, {10600,6.253889}, {10700,6.449444}, {10800,6.147778}, {10900,6.370389}, {11000,6.826444}, {11100,6.964611}, {11200,6.543389}, {11300,6.404389}, {11400,6.460889}, {11500,7.132444}, {11600,6.772444}, {11700,7.271778}, {11800,6.869889}, {11900,7.581611}, {12000,7.178500}, {12100,7.558889}, {12200,7.484000}, {12300,6.899278}, {12400,7.207889}, {12500,7.451611}, {12600,7.508833}, {12700,7.835222}, {12800,6.899056}, {12900,7.648722}, {13000,7.681389}, {13100,8.329778}, {13200,7.787111}, {13300,8.602222}, {13400,7.936611}, {13500,9.209444}, {13600,8.077667}, {13700,8.075000}, {13800,8.626556}, {13900,8.434833}, {14000,9.186000}, {14100,8.614722}, {14200,9.123000}, {14300,9.806111}, {14400,7.957056}, {14500,8.559500}, {14600,8.297778}, {14700,9.217111}, {14800,8.995111}, {14900,8.985333}, {15000,9.096167}, {15100,10.021056}, {15200,9.136889}, {15300,9.451167}, {15400,9.006111}, {15500,9.366056}, {15600,9.734722}, {15700,9.748000}, {15800,10.247556}, {15900,10.071833}, {16000,9.304722}, {16100,10.298333}, {16200,9.981222}, {16300,10.691111}, {16400,9.141833}, {16500,10.134389}, {16600,10.157889}, {16700,10.523944}, {16800,9.919333}, {16900,9.827389}, {17000,10.527444}, {17100,11.187722}, {17200,10.491500}, {17300,11.236611}, {17400,11.806444}, {17500,11.365333}, {17600,10.567278}, {17700,10.742500}, {17800,10.747667}, {17900,11.858111}, {18000,11.269611}, {18100,11.947444}, {18200,11.529889}, {18300,12.639667}, {18400,11.757389}, {18500,11.049167}, {18600,11.402056}, {18700,11.305889}, {18800,12.046056}, {18900,12.345056}, {19000,11.868611}, {19100,12.888611}, {19200,11.355389}, {19300,12.359222}, {19400,12.551167}, {19500,12.121000}, {19600,12.015778}, {19700,13.791167}, {19800,12.682667}, {19900,13.735222}, {20000,12.168250}};
data["big_flat"]["TypeClasses"]["reif"]["user"] = {{1,0.000324444}, {2,0.000588496}, {3,0.000579646}, {4,0.001008850}, {5,0.000942478}, {6,0.001358407}, {7,0.001845133}, {8,0.001969027}, {9,0.001955752}, {10,0.002278761}, {11,0.002557522}, {12,0.002610619}, {13,0.003084071}, {14,0.003309735}, {15,0.003619469}, {16,0.003752212}, {17,0.004176991}, {18,0.004451327}, {19,0.004880531}, {20,0.004902655}, {21,0.005738938}, {22,0.012646018}, {23,0.006216814}, {24,0.006092920}, {25,0.006690265}, {26,0.007061947}, {27,0.008274336}, {28,0.007610619}, {29,0.008274336}, {30,0.008557522}, {31,0.009097345}, {32,0.008495575}, {33,0.009336283}, {34,0.009623894}, {35,0.010530973}, {36,0.009876106}, {37,0.010500000}, {38,0.010668142}, {39,0.011252212}, {40,0.010676991}, {41,0.011849558}, {42,0.011615044}, {43,0.012884956}, {44,0.013061947}, {45,0.013362832}, {46,0.014190265}, {47,0.014238938}, {48,0.013101770}, {49,0.014044248}, {50,0.014221239}, {51,0.015849558}, {52,0.015482301}, {53,0.015800885}, {54,0.016013274}, {55,0.017088496}, {56,0.015902655}, {57,0.016774336}, {58,0.018154867}, {59,0.018168142}, {60,0.017659292}, {61,0.018646018}, {62,0.018836283}, {63,0.019761062}, {64,0.019517699}, {65,0.019075221}, {66,0.019429204}, {67,0.021274336}, {68,0.019592920}, {69,0.021141593}, {70,0.021296460}, {71,0.022610619}, {72,0.020805310}, {73,0.022066372}, {74,0.024243363}, {75,0.023756637}, {76,0.022889381}, {77,0.025570796}, {78,0.024610619}, {79,0.027230088}, {80,0.023995575}, {81,0.024663717}, {82,0.024712389}, {83,0.028181416}, {84,0.025331858}, {85,0.026539823}, {86,0.026663717}, {87,0.030048673}, {88,0.027402655}, {89,0.027778761}, {90,0.028154867}, {91,0.032044248}, {92,0.028646018}, {93,0.031823009}, {94,0.030730088}, {95,0.033716814}, {96,0.027977876}, {97,0.029438053}, {98,0.030827434}, {99,0.031703540}, {100,0.030632743}, {101,0.032327434}, {102,0.034305310}, {103,0.035035398}, {104,0.031566372}, {105,0.037115044}, {106,0.033362832}, {107,0.036274336}, {108,0.034057522}, {109,0.035889381}, {110,0.035707965}, {111,0.037752212}, {112,0.033712389}, {113,0.035522124}, {114,0.035703540}, {115,0.038327434}, {116,0.036584071}, {117,0.038278761}, {118,0.038491150}, {119,0.040823009}, {120,0.038955752}, {121,0.041269912}, {122,0.039849558}, {123,0.046380531}, {124,0.040384956}, {125,0.044703540}, {126,0.043893805}, {127,0.044787611}, {128,0.040349558}, {129,0.040849558}, {130,0.040747788}, {131,0.045911504}, {132,0.042371681}, {133,0.044044248}, {134,0.045924779}, {135,0.046491150}, {136,0.046376106}, {137,0.047097345}, {138,0.044991150}, {139,0.049146018}, {140,0.045743363}, {141,0.051172566}, {142,0.049765487}, {143,0.053349558}, {144,0.044676991}, {145,0.049314159}, {146,0.048526549}, {147,0.051371681}, {148,0.051137168}, {149,0.050172566}, {150,0.057716814}, {151,0.055982301}, {152,0.051623894}, {153,0.052592920}, {154,0.058986726}, {155,0.054199115}, {156,0.056654867}, {157,0.057747788}, {158,0.057884956}, {159,0.057517699}, {160,0.051371681}, {161,0.052269912}, {162,0.052482301}, {163,0.058101770}, {164,0.056150442}, {165,0.058455752}, {166,0.056283186}, {167,0.063314159}, {168,0.057008850}, {169,0.058774336}, {170,0.057221239}, {171,0.063836283}, {172,0.064287611}, {173,0.060840708}, {174,0.063407080}, {175,0.063871681}, {176,0.060703540}, {177,0.062380531}, {178,0.063566372}, {179,0.062628319}, {180,0.063557522}, {181,0.067393805}, {182,0.066566372}, {183,0.070119469}, {184,0.061641593}, {185,0.065606195}, {186,0.065464602}, {187,0.072951327}, {188,0.070747788}, {189,0.070898230}, {190,0.073805310}, {191,0.071628319}, {192,0.062137168}, {193,0.063792035}, {194,0.065433628}, {195,0.073504425}, {196,0.066199115}, {197,0.071747788}, {198,0.067300885}, {199,0.071787611}, {200,0.069615044}, {201,0.069172566}, {202,0.075017699}, {203,0.079446903}, {204,0.073446903}, {205,0.079703540}, {206,0.076269912}, {207,0.079853982}, {208,0.077398230}, {209,0.070805310}, {210,0.073044248}, {211,0.078752212}, {212,0.072035398}, {213,0.077712389}, {214,0.079296460}, {215,0.079646018}, {216,0.074836283}, {217,0.079827434}, {218,0.076915929}, {219,0.081836283}, {220,0.083088496}, {221,0.084712389}, {222,0.081265487}, {223,0.087044248}, {224,0.076207965}, {225,0.076951327}, {226,0.078761062}, {227,0.083584071}, {228,0.077668142}, {229,0.081088496}, {230,0.089548673}, {231,0.091668142}, {232,0.081712389}, {233,0.086982301}, {234,0.092783186}, {235,0.095190265}, {236,0.086128319}, {237,0.091265487}, {238,0.093747788}, {239,0.094327434}, {240,0.080517699}, {241,0.086035398}, {242,0.094327434}, {243,0.095646018}, {244,0.091287611}, {245,0.092601770}, {246,0.094154867}, {247,0.098699115}, {248,0.089730088}, {249,0.094141593}, {250,0.093858407}, {251,0.100787611}, {252,0.098181416}, {253,0.098880531}, {254,0.103216814}, {255,0.110168142}, {256,0.085765487}, {257,0.091685841}, {258,0.094070796}, {259,0.094933628}, {260,0.092415929}, {261,0.096159292}, {262,0.102853982}, {263,0.104889381}, {264,0.092305310}, {265,0.098190265}, {266,0.097106195}, {267,0.104694690}, {268,0.100681416}, {269,0.104526549}, {270,0.105977876}, {271,0.112411504}, {272,0.098327434}, {273,0.096092920}, {274,0.101137168}, {275,0.110641593}, {276,0.104477876}, {277,0.103951327}, {278,0.110384956}, {279,0.117128319}, {280,0.103137168}, {281,0.107292035}, {282,0.110769912}, {283,0.109884956}, {284,0.112353982}, {285,0.118207965}, {286,0.113128319}, {287,0.121796460}, {288,0.105606195}, {289,0.108234513}, {290,0.109194690}, {291,0.115464602}, {292,0.107964602}, {293,0.115951327}, {294,0.116805310}, {295,0.115699115}, {296,0.106314159}, {297,0.112345133}, {298,0.115420354}, {299,0.122243363}, {300,0.112575221}, {301,0.122163717}, {302,0.119681416}, {303,0.124597345}, {304,0.111840708}, {305,0.118893805}, {306,0.120592920}, {307,0.120199115}, {308,0.118535398}, {309,0.123446903}, {310,0.124738938}, {311,0.127734513}, {312,0.118694690}, {313,0.123504425}, {314,0.124451327}, {315,0.134154867}, {316,0.127442478}, {317,0.130938053}, {318,0.131544248}, {319,0.184008850}, {320,0.122221239}, {321,0.116132743}, {322,0.123659292}, {323,0.127004425}, {324,0.122504425}, {325,0.125588496}, {326,0.134137168}, {327,0.134818584}, {328,0.132654867}, {329,0.128327434}, {330,0.128809735}, {331,0.131915929}, {332,0.130030973}, {333,0.132712389}, {334,0.136030973}, {335,0.140902655}, {336,0.124637168}, {337,0.132893805}, {338,0.129676991}, {339,0.143486726}, {340,0.132836283}, {341,0.137486726}, {342,0.136150442}, {343,0.147920354}, {344,0.133800885}, {345,0.138039823}, {346,0.136238938}, {347,0.146522124}, {348,0.138464602}, {349,0.582331858}, {350,0.146579646}, {351,0.158216814}, {352,0.135323009}, {353,0.137429204}, {354,0.136420354}, {355,0.142814159}, {356,0.138504425}, {357,0.143964602}, {358,0.144676991}, {359,0.150411504}, {360,0.141623894}, {361,0.148455752}, {362,0.144207965}, {363,0.153438053}, {364,0.148349558}, {365,0.148513274}, {366,0.156668142}, {367,0.158035398}, {368,0.147265487}, {369,0.146318584}, {370,0.152628319}, {371,0.153783186}, {372,0.155482301}, {373,0.153818584}, {374,0.156539823}, {375,0.163075221}, {376,0.150495575}, {377,0.154115044}, {378,0.159367257}, {379,0.171146018}, {380,0.155176991}, {381,0.164566372}, {382,0.167230088}, {383,0.172747788}, {384,0.139566372}, {385,0.148676991}, {386,0.152053097}, {387,0.155075221}, {388,0.144517699}, {389,0.156265487}, {390,0.156278761}, {391,0.160960177}, {392,0.151190265}, {393,0.158128319}, {394,0.159623894}, {395,0.163632743}, {396,0.160858407}, {397,0.161230088}, {398,0.165013274}, {399,0.169796460}, {400,0.149066372}, {401,0.161353982}, {402,0.160212389}, {403,0.165482301}, {404,0.163522124}, {405,0.809238938}, {406,0.180588496}, {407,0.181446903}, {408,0.161314159}, {409,0.165893805}, {410,0.166969027}, {411,0.173544248}, {412,0.169163717}, {413,0.175203540}, {414,0.171955752}, {415,0.191699115}, {416,0.160380531}, {417,0.166884956}, {418,0.160778761}, {419,0.169575221}, {420,0.167486726}, {421,0.174424779}, {422,0.171278761}, {423,0.180035398}, {424,0.164544248}, {425,0.175871681}, {426,0.174084071}, {427,0.180792035}, {428,0.179008850}, {429,0.183137168}, {430,0.189393805}, {431,0.192088496}, {432,0.170827434}, {433,0.176048673}, {434,0.178774336}, {435,0.183977876}, {436,0.178407080}, {437,0.183362832}, {438,0.189513274}, {439,0.191911504}, {440,0.181415929}, {441,0.186088496}, {442,0.186420354}, {443,0.189323009}, {444,0.187955752}, {445,0.196362832}, {446,0.197730088}, {447,0.206938053}, {448,0.169761062}, {449,0.179464602}, {450,0.179150442}, {451,0.183247788}, {452,0.178398230}, {453,0.184274336}, {454,0.195455752}, {455,0.192238938}, {456,0.192663717}, {457,0.185637168}, {458,0.195252212}, {459,0.191168142}, {460,0.186526549}, {461,0.199668142}, {462,0.199747788}, {463,0.214141593}, {464,0.175778761}, {465,0.197004425}, {466,0.187902655}, {467,0.202362832}, {468,0.191924779}, {469,0.200159292}, {470,0.203256637}, {471,0.204964602}, {472,0.197048673}, {473,0.206026549}, {474,0.198274336}, {475,0.215022124}, {476,0.206455752}, {477,0.206623894}, {478,0.216991150}, {479,0.218154867}, {480,0.185309735}, {481,0.204265487}, {482,0.194911504}, {483,0.203048673}, {484,0.200986726}, {485,0.205893805}, {486,0.205946903}, {487,0.218924779}, {488,0.195119469}, {489,0.211809735}, {490,0.211862832}, {491,0.209606195}, {492,0.213044248}, {493,0.219168142}, {494,0.220756637}, {495,0.219712389}, {496,0.206261062}, {497,0.206181416}, {498,0.207938053}, {499,0.222163717}, {500,0.217650442}, {505,0.221150442}, {510,0.233570796}, {515,0.212707965}, {520,0.212566372}, {525,0.225889381}, {530,0.212557522}, {535,0.240539823}, {540,0.238376106}, {545,0.232867257}, {550,0.241995575}, {555,0.248716814}, {560,0.232181416}, {565,0.243548673}, {570,0.245610619}, {575,0.274871681}, {580,0.237252212}, {585,0.253265487}, {590,0.263951327}, {595,0.271327434}, {600,0.263858407}, {605,0.282659292}, {610,0.262920354}, {615,0.281721239}, {620,0.272650442}, {625,0.273893805}, {630,0.292221239}, {635,0.305769912}, {640,0.257464602}, {645,0.278707965}, {650,0.280893805}, {655,0.302141593}, {660,0.277526549}, {665,0.300371681}, {670,0.315296460}, {675,0.306672566}, {680,0.297893805}, {685,0.313716814}, {690,0.308030973}, {695,0.331544248}, {700,0.327411504}, {705,0.299827434}, {710,0.312402655}, {715,0.330938053}, {720,0.303353982}, {725,0.337420354}, {730,0.333123894}, {735,0.357163717}, {740,0.322623894}, {745,0.338411504}, {750,0.353566372}, {755,0.356384956}, {760,0.351646018}, {765,0.385862832}, {770,0.327460177}, {775,0.349035398}, {780,0.342522124}, {785,0.340500000}, {790,0.358690265}, {795,0.377544248}, {800,0.342061947}, {805,0.367088496}, {810,0.367805310}, {815,0.393314159}, {820,0.369933628}, {825,0.382725664}, {830,0.407818584}, {835,0.375274336}, {840,0.357632743}, {845,0.387933628}, {850,0.380823009}, {855,0.408659292}, {860,0.396389381}, {865,0.391566372}, {870,0.401044248}, {875,0.423880531}, {880,0.397008850}, {885,0.438185841}, {890,0.434349558}, {895,0.466190265}, {900,0.383876106}, {905,0.409163717}, {910,0.421017699}, {915,0.431256637}, {920,0.412814159}, {925,0.452522124}, {930,0.418243363}, {935,0.462327434}, {940,0.439827434}, {945,0.443092920}, {950,0.458150442}, {955,0.477066372}, {960,0.416858407}, {965,0.452898230}, {970,0.452433628}, {975,0.487619469}, {980,0.461898230}, {985,0.478845133}, {990,0.490349558}, {995,0.485938053}, {1000,0.462597345}, {1010,0.483889381}, {1020,0.497694690}, {1030,0.466526549}, {1040,0.453256637}, {1050,0.500663717}, {1060,0.477862832}, {1070,0.509221239}, {1080,0.497261062}, {1090,0.488730088}, {1100,0.510389381}, {1110,0.535849558}, {1120,0.507570796}, {1130,0.552097345}, {1140,0.543721239}, {1150,0.593212389}, {1160,0.517814159}, {1170,0.540610619}, {1180,0.558438053}, {1190,0.579008850}, {1200,0.551530973}, {1210,0.600331858}, {1220,0.559991150}, {1230,0.605893805}, {1240,0.588221239}, {1250,0.606398230}, {1260,0.612296460}, {1270,0.643539823}, {1280,0.571544248}, {1290,0.598522124}, {1300,0.614128319}, {1310,0.652628319}, {1320,0.613730088}, {1330,0.628358407}, {1340,0.667535398}, {1350,0.649840708}, {1360,0.622761062}, {1370,0.676398230}, {1380,0.661061947}, {1390,0.716561947}, {1400,0.686553097}, {1410,0.645084071}, {1420,0.690358407}, {1430,0.711650442}, {1440,0.662707965}, {1450,0.710181416}, {1460,0.711296460}, {1470,0.767548673}, {1480,0.721287611}, {1490,0.726292035}, {1500,0.757526549}, {1510,0.762115044}, {1520,0.737482301}, {1530,0.796106195}, {1540,0.703424779}, {1550,0.757548673}, {1560,0.732623894}, {1570,0.736747788}, {1580,0.761743363}, {1590,0.797991150}, {1600,0.730194690}, {1610,0.785207965}, {1620,0.786088496}, {1630,0.836362832}, {1640,0.785893805}, {1650,0.818504425}, {1660,0.867044248}, {1670,0.803840708}, {1680,0.777115044}, {1690,0.832216814}, {1700,0.818066372}, {1710,0.882615044}, {1720,0.850345133}, {1730,0.821340708}, {1740,0.862982301}, {1750,0.890676991}, {1760,0.845407080}, {1770,0.910938053}, {1780,0.909318584}, {1790,0.967743363}, {1800,0.831800885}, {1810,0.888504425}, {1820,0.898225664}, {1830,0.893876106}, {1840,0.878707965}, {1850,0.948039823}, {1860,0.894960177}, {1870,0.957911504}, {1880,0.927761062}, {1890,0.934840708}, {1900,0.971203540}, {1910,1.000827434}, {1920,0.881265487}, {1930,0.944380531}, {1940,0.947977876}, {1950,1.027000000}, {1960,0.961150442}, {1970,0.998601770}, {1980,1.036340708}, {1990,1.016902655}, {2000,0.985712389}, {2050,0.947615044}, {2100,1.033955752}, {2150,1.108601770}, {2200,1.101946903}, {2250,1.141946903}, {2300,1.242004425}, {2350,1.246181416}, {2400,1.184566372}, {2450,1.246659292}, {2500,1.271699115}, {2550,1.438225664}, {2600,1.290004425}, {2650,1.385942478}, {2700,1.386792035}, {2750,1.557964602}, {2800,1.465513274}, {2850,1.460964602}, {2900,1.513632743}, {2950,1.551849558}, {3000,1.626628319}, {3050,1.693769912}, {3100,1.651207965}, {3150,1.948367257}, {3200,1.547057522}, {3250,1.714230088}, {3300,1.763995575}, {3350,2.083309735}, {3400,1.753517699}, {3450,1.938389381}, {3500,1.898738938}, {3550,2.075672566}, {3600,1.777938053}, {3650,1.865500000}, {3700,2.017066372}, {3750,2.049663717}, {3800,2.069442478}, {3850,2.020584071}, {3900,2.200880531}, {3950,2.300884956}, {4000,2.088097345}, {4050,2.269473451}, {4100,2.044349558}, {4150,2.286792035}, {4200,2.232836283}, {4250,2.329376106}, {4300,2.362584071}, {4350,2.607619469}, {4400,2.327438053}, {4450,2.447513274}, {4500,2.446561947}, {4550,2.564283186}, {4600,2.644601770}, {4650,2.902933628}, {4700,2.630570796}, {4750,2.666159292}, {4800,2.523446903}, {4850,2.800734513}, {4900,2.647137168}, {4950,2.861464602}, {5000,2.686181416}, {5050,3.000256637}, {5100,3.023353982}, {5150,2.995292035}, {5200,2.739752212}, {5250,2.772826667}, {5300,2.983031111}, {5350,3.202293333}, {5400,3.194337778}, {5450,3.046244444}, {5500,3.273120000}, {5550,3.295520000}, {5600,3.138848889}, {5650,3.054146667}, {5700,3.081902222}, {5750,3.421666667}, {5800,3.220000000}, {5850,3.464928889}, {5900,3.269715556}, {5950,3.637137778}, {6000,3.419111111}, {6050,3.427611}, {6100,3.555833}, {6150,3.244500}, {6200,3.407389}, {6250,3.551500}, {6300,3.524000}, {6350,3.690278}, {6400,3.251944}, {6450,3.572222}, {6500,3.615111}, {6550,3.917778}, {6600,3.676833}, {6650,4.086000}, {6700,3.726611}, {6750,4.015611}, {6800,3.679389}, {6850,3.795333}, {6900,4.103611}, {6950,3.982222}, {7000,4.012889}, {7050,4.224889}, {7100,4.332833}, {7150,4.502389}, {7200,3.726444}, {7250,4.065667}, {7300,3.947889}, {7350,4.371500}, {7400,4.277222}, {7450,4.272333}, {7500,4.341611}, {7550,4.718056}, {7600,4.371278}, {7650,4.482167}, {7700,4.238611}, {7750,4.445778}, {7800,4.583000}, {7850,4.654889}, {7900,4.732444}, {7950,4.688222}, {8000,4.373722}, {8050,4.866889}, {8100,4.686278}, {8150,5.063556}, {8200,4.284889}, {8250,4.802167}, {8300,4.805944}, {8350,4.999944}, {8400,4.666722}, {8450,4.531889}, {8500,4.881944}, {8550,5.063222}, {8600,4.920611}, {8650,5.128111}, {8700,5.472667}, {8750,5.206611}, {8800,4.860556}, {8850,5.110111}, {8900,5.089389}, {8950,5.630611}, {9000,5.151444}, {9050,5.516333}, {9100,5.371833}, {9150,5.942722}, {9200,5.578389}, {9250,5.169389}, {9300,5.330944}, {9350,5.386222}, {9400,5.535611}, {9450,5.766111}, {9500,5.602667}, {9550,5.767556}, {9600,5.283222}, {9650,5.839222}, {9700,5.894111}, {9750,5.719056}, {9800,5.568167}, {9850,6.121722}, {9900,5.951333}, {9950,6.363778}, {10000,5.621944}, {10100,6.273000}, {10200,6.293556}, {10300,6.094278}, {10400,5.748556}, {10500,5.796556}, {10600,6.246944}, {10700,6.442556}, {10800,6.141667}, {10900,6.363333}, {11000,6.819056}, {11100,6.957778}, {11200,6.536222}, {11300,6.396222}, {11400,6.456111}, {11500,7.126500}, {11600,6.767000}, {11700,7.266500}, {11800,6.863833}, {11900,7.575722}, {12000,7.171444}, {12100,7.550111}, {12200,7.476944}, {12300,6.890778}, {12400,7.199056}, {12500,7.443111}, {12600,7.500389}, {12700,7.827222}, {12800,6.892278}, {12900,7.643500}, {13000,7.674056}, {13100,8.323167}, {13200,7.781056}, {13300,8.595278}, {13400,7.923722}, {13500,9.201222}, {13600,8.070778}, {13700,8.066889}, {13800,8.619111}, {13900,8.420889}, {14000,9.173278}, {14100,8.607556}, {14200,9.113722}, {14300,9.796111}, {14400,7.949444}, {14500,8.551778}, {14600,8.285000}, {14700,9.207611}, {14800,8.986833}, {14900,8.978333}, {15000,9.087333}, {15100,10.006556}, {15200,9.128778}, {15300,9.440500}, {15400,8.992722}, {15500,9.354500}, {15600,9.722889}, {15700,9.733056}, {15800,10.234722}, {15900,10.056944}, {16000,9.291944}, {16100,10.286722}, {16200,9.971167}, {16300,10.680611}, {16400,9.132111}, {16500,10.120222}, {16600,10.143944}, {16700,10.509556}, {16800,9.907833}, {16900,9.816556}, {17000,10.514833}, {17100,11.172389}, {17200,10.479222}, {17300,11.221778}, {17400,11.791833}, {17500,11.346778}, {17600,10.548667}, {17700,10.728722}, {17800,10.733111}, {17900,11.837111}, {18000,11.235111}, {18100,11.930167}, {18200,11.514167}, {18300,12.618056}, {18400,11.739222}, {18500,11.031833}, {18600,11.385222}, {18700,11.289333}, {18800,12.018278}, {18900,12.324667}, {19000,11.851778}, {19100,12.871889}, {19200,11.339889}, {19300,12.340222}, {19400,12.527389}, {19500,12.103167}, {19600,11.996500}, {19700,13.744278}, {19800,12.664556}, {19900,13.714889}, {20000,12.148500}};
data["big_flat"]["TypeClasses"]["reif"]["system"] = {{1,0.000160000}, {2,0.000035398}, {3,0.000017699}, {4,0.000017699}, {5,0.000013274}, {6,0.000035398}, {7,0.000017699}, {8,0.000035398}, {9,0.000017699}, {10,0.000000000}, {11,0.000000000}, {12,0.000017699}, {13,0.000000000}, {14,0.000000000}, {15,0.000013274}, {16,0.000044248}, {17,0.000017699}, {18,0.000030973}, {19,0.000017699}, {20,0.000000000}, {21,0.000000000}, {22,0.000088496}, {23,0.000026549}, {24,0.000026549}, {25,0.000030973}, {26,0.000017699}, {27,0.000048673}, {28,0.000030973}, {29,0.000000000}, {30,0.000048673}, {31,0.000000000}, {32,0.000000000}, {33,0.000013274}, {34,0.000000000}, {35,0.000013274}, {36,0.000026549}, {37,0.000000000}, {38,0.000053097}, {39,0.000035398}, {40,0.000035398}, {41,0.000000000}, {42,0.000017699}, {43,0.000035398}, {44,0.000030973}, {45,0.000000000}, {46,0.000017699}, {47,0.000017699}, {48,0.000000000}, {49,0.000070796}, {50,0.000048673}, {51,0.000030973}, {52,0.000030973}, {53,0.000066372}, {54,0.000000000}, {55,0.000017699}, {56,0.000048673}, {57,0.000048673}, {58,0.000097345}, {59,0.000115044}, {60,0.000035398}, {61,0.000030973}, {62,0.000000000}, {63,0.000000000}, {64,0.000048673}, {65,0.000017699}, {66,0.000000000}, {67,0.000035398}, {68,0.000017699}, {69,0.000000000}, {70,0.000013274}, {71,0.000035398}, {72,0.000017699}, {73,0.000017699}, {74,0.000066372}, {75,0.000000000}, {76,0.000017699}, {77,0.000106195}, {78,0.000053097}, {79,0.000048673}, {80,0.000084071}, {81,0.000000000}, {82,0.000000000}, {83,0.000066372}, {84,0.000017699}, {85,0.000035398}, {86,0.000030973}, {87,0.000084071}, {88,0.000044248}, {89,0.000017699}, {90,0.000053097}, {91,0.000053097}, {92,0.000017699}, {93,0.000048673}, {94,0.000017699}, {95,0.000070796}, {96,0.000017699}, {97,0.000017699}, {98,0.000097345}, {99,0.000066372}, {100,0.000013274}, {101,0.000017699}, {102,0.000119469}, {103,0.000079646}, {104,0.000048673}, {105,0.000084071}, {106,0.000035398}, {107,0.000035398}, {108,0.000000000}, {109,0.000048673}, {110,0.000000000}, {111,0.000017699}, {112,0.000017699}, {113,0.000035398}, {114,0.000013274}, {115,0.000026549}, {116,0.000017699}, {117,0.000013274}, {118,0.000017699}, {119,0.000026549}, {120,0.000035398}, {121,0.000146018}, {122,0.000017699}, {123,0.000176991}, {124,0.000013274}, {125,0.000066372}, {126,0.000035398}, {127,0.000053097}, {128,0.000030973}, {129,0.000017699}, {130,0.000057522}, {131,0.000066372}, {132,0.000070796}, {133,0.000000000}, {134,0.000017699}, {135,0.000017699}, {136,0.000123894}, {137,0.000035398}, {138,0.000017699}, {139,0.000066372}, {140,0.000013274}, {141,0.000097345}, {142,0.000119469}, {143,0.000053097}, {144,0.000017699}, {145,0.000070796}, {146,0.000106195}, {147,0.000030973}, {148,0.000123894}, {149,0.000000000}, {150,0.000123894}, {151,0.000079646}, {152,0.000017699}, {153,0.000017699}, {154,0.000190265}, {155,0.000048673}, {156,0.000084071}, {157,0.000097345}, {158,0.000066372}, {159,0.000000000}, {160,0.000088496}, {161,0.000053097}, {162,0.000000000}, {163,0.000106195}, {164,0.000101770}, {165,0.000017699}, {166,0.000044248}, {167,0.000106195}, {168,0.000053097}, {169,0.000053097}, {170,0.000048673}, {171,0.000101770}, {172,0.000172566}, {173,0.000017699}, {174,0.000066372}, {175,0.000013274}, {176,0.000243363}, {177,0.000115044}, {178,0.000101770}, {179,0.000053097}, {180,0.000030973}, {181,0.000115044}, {182,0.000146018}, {183,0.000119469}, {184,0.000000000}, {185,0.000066372}, {186,0.000066372}, {187,0.000119469}, {188,0.000176991}, {189,0.000035398}, {190,0.000168142}, {191,0.000088496}, {192,0.000017699}, {193,0.000000000}, {194,0.000061947}, {195,0.000168142}, {196,0.000088496}, {197,0.000084071}, {198,0.000030973}, {199,0.000079646}, {200,0.000101770}, {201,0.000137168}, {202,0.000247788}, {203,0.000190265}, {204,0.000194690}, {205,0.000203540}, {206,0.000150442}, {207,0.000119469}, {208,0.000185841}, {209,0.000035398}, {210,0.000035398}, {211,0.000132743}, {212,0.000013274}, {213,0.000137168}, {214,0.000123894}, {215,0.000061947}, {216,0.000070796}, {217,0.000088496}, {218,0.000035398}, {219,0.000066372}, {220,0.000331858}, {221,0.000066372}, {222,0.000030973}, {223,0.000070796}, {224,0.000088496}, {225,0.000017699}, {226,0.000048673}, {227,0.000084071}, {228,0.000053097}, {229,0.000176991}, {230,0.000238938}, {231,0.000088496}, {232,0.000119469}, {233,0.000123894}, {234,0.000681416}, {235,0.000305310}, {236,0.000203540}, {237,0.000238938}, {238,0.000199115}, {239,0.000079646}, {240,0.000017699}, {241,0.000101770}, {242,0.001066372}, {243,0.000199115}, {244,0.000340708}, {245,0.000176991}, {246,0.000123894}, {247,0.000070796}, {248,0.000128319}, {249,0.000141593}, {250,0.000154867}, {251,0.000309735}, {252,0.000172566}, {253,0.000053097}, {254,0.000318584}, {255,0.000420354}, {256,0.000207965}, {257,0.000203540}, {258,0.000154867}, {259,0.000070796}, {260,0.000199115}, {261,0.000154867}, {262,0.000362832}, {263,0.000203540}, {264,0.000101770}, {265,0.000159292}, {266,0.000194690}, {267,0.000278761}, {268,0.000331858}, {269,0.000190265}, {270,0.000176991}, {271,0.000464602}, {272,0.000252212}, {273,0.000035398}, {274,0.000269912}, {275,0.000491150}, {276,0.000371681}, {277,0.000030973}, {278,0.000287611}, {279,0.000128319}, {280,0.000159292}, {281,0.000066372}, {282,0.000194690}, {283,0.000172566}, {284,0.000287611}, {285,0.000473451}, {286,0.000225664}, {287,0.000380531}, {288,0.000314159}, {289,0.000154867}, {290,0.000252212}, {291,0.000446903}, {292,0.000252212}, {293,0.000194690}, {294,0.000500000}, {295,0.000132743}, {296,0.000172566}, {297,0.000367257}, {298,0.000292035}, {299,0.000455752}, {300,0.000084071}, {301,0.000384956}, {302,0.000238938}, {303,0.000305310}, {304,0.000296460}, {305,0.000296460}, {306,0.000522124}, {307,0.000212389}, {308,0.000336283}, {309,0.000300885}, {310,0.000216814}, {311,0.000247788}, {312,0.000362832}, {313,0.000296460}, {314,0.000234513}, {315,0.000203540}, {316,0.000092920}, {317,0.000137168}, {318,0.000123894}, {319,0.000283186}, {320,0.000185841}, {321,0.000101770}, {322,0.000088496}, {323,0.000110619}, {324,0.000128319}, {325,0.000101770}, {326,0.000261062}, {327,0.000154867}, {328,0.000035398}, {329,0.000017699}, {330,0.000000000}, {331,0.000017699}, {332,0.000159292}, {333,0.000048673}, {334,0.000101770}, {335,0.000132743}, {336,0.000048673}, {337,0.000084071}, {338,0.000154867}, {339,0.000203540}, {340,0.000141593}, {341,0.000176991}, {342,0.000185841}, {343,0.000172566}, {344,0.000159292}, {345,0.000146018}, {346,0.000141593}, {347,0.000172566}, {348,0.000088496}, {349,0.001433628}, {350,0.000221239}, {351,0.000203540}, {352,0.000194690}, {353,0.000243363}, {354,0.000150442}, {355,0.000168142}, {356,0.000092920}, {357,0.000176991}, {358,0.000172566}, {359,0.000247788}, {360,0.000132743}, {361,0.000190265}, {362,0.000225664}, {363,0.000176991}, {364,0.000415929}, {365,0.000252212}, {366,0.000398230}, {367,0.000318584}, {368,0.000345133}, {369,0.000207965}, {370,0.000039823}, {371,0.000017699}, {372,0.000123894}, {373,0.000017699}, {374,0.000066372}, {375,0.000048673}, {376,0.000017699}, {377,0.000066372}, {378,0.000070796}, {379,0.000017699}, {380,0.000017699}, {381,0.000030973}, {382,0.000035398}, {383,0.000017699}, {384,0.000035398}, {385,0.000035398}, {386,0.000070796}, {387,0.000048673}, {388,0.000053097}, {389,0.000035398}, {390,0.000035398}, {391,0.000048673}, {392,0.000017699}, {393,0.000030973}, {394,0.000017699}, {395,0.000101770}, {396,0.000035398}, {397,0.000070796}, {398,0.000044248}, {399,0.000084071}, {400,0.000017699}, {401,0.000066372}, {402,0.000035398}, {403,0.000030973}, {404,0.000017699}, {405,0.000818584}, {406,0.000314159}, {407,0.000486726}, {408,0.000123894}, {409,0.000106195}, {410,0.000088496}, {411,0.000097345}, {412,0.000101770}, {413,0.000101770}, {414,0.000115044}, {415,0.000172566}, {416,0.000115044}, {417,0.000070796}, {418,0.000000000}, {419,0.000017699}, {420,0.000000000}, {421,0.000088496}, {422,0.000088496}, {423,0.000035398}, {424,0.000017699}, {425,0.000101770}, {426,0.000070796}, {427,0.000035398}, {428,0.000035398}, {429,0.000061947}, {430,0.000035398}, {431,0.000070796}, {432,0.000084071}, {433,0.000070796}, {434,0.000088496}, {435,0.000017699}, {436,0.000048673}, {437,0.000066372}, {438,0.000101770}, {439,0.000097345}, {440,0.000092920}, {441,0.000035398}, {442,0.000115044}, {443,0.000137168}, {444,0.000088496}, {445,0.000101770}, {446,0.000013274}, {447,0.000035398}, {448,0.000088496}, {449,0.000017699}, {450,0.000000000}, {451,0.000030973}, {452,0.000030973}, {453,0.000084071}, {454,0.000066372}, {455,0.000035398}, {456,0.000066372}, {457,0.000030973}, {458,0.000035398}, {459,0.000053097}, {460,0.000048673}, {461,0.000035398}, {462,0.000035398}, {463,0.000075221}, {464,0.000115044}, {465,0.000123894}, {466,0.000030973}, {467,0.000084071}, {468,0.000053097}, {469,0.000017699}, {470,0.000000000}, {471,0.000030973}, {472,0.000017699}, {473,0.000030973}, {474,0.000053097}, {475,0.000017699}, {476,0.000066372}, {477,0.000013274}, {478,0.000053097}, {479,0.000000000}, {480,0.000017699}, {481,0.000190265}, {482,0.000274336}, {483,0.000331858}, {484,0.000123894}, {485,0.000123894}, {486,0.000207965}, {487,0.000362832}, {488,0.000053097}, {489,0.000176991}, {490,0.000066372}, {491,0.000084071}, {492,0.000172566}, {493,0.000141593}, {494,0.000101770}, {495,0.000035398}, {496,0.000088496}, {497,0.000119469}, {498,0.000088496}, {499,0.000106195}, {500,0.000088496}, {505,0.000123894}, {510,0.000035398}, {515,0.000119469}, {520,0.000061947}, {525,0.000084071}, {530,0.000048673}, {535,0.000053097}, {540,0.000035398}, {545,0.000017699}, {550,0.000070796}, {555,0.000106195}, {560,0.000030973}, {565,0.000035398}, {570,0.000088496}, {575,0.000053097}, {580,0.000017699}, {585,0.000066372}, {590,0.000137168}, {595,0.000154867}, {600,0.000194690}, {605,0.000172566}, {610,0.000252212}, {615,0.000123894}, {620,0.000084071}, {625,0.000088496}, {630,0.000106195}, {635,0.000159292}, {640,0.000159292}, {645,0.000084071}, {650,0.000070796}, {655,0.000088496}, {660,0.000053097}, {665,0.000017699}, {670,0.000000000}, {675,0.000035398}, {680,0.000048673}, {685,0.000017699}, {690,0.000035398}, {695,0.000000000}, {700,0.000061947}, {705,0.000035398}, {710,0.000176991}, {715,0.000017699}, {720,0.000017699}, {725,0.000017699}, {730,0.000079646}, {735,0.000000000}, {740,0.000017699}, {745,0.000000000}, {750,0.000053097}, {755,0.000000000}, {760,0.000000000}, {765,0.000101770}, {770,0.000035398}, {775,0.000035398}, {780,0.000017699}, {785,0.000035398}, {790,0.000053097}, {795,0.000101770}, {800,0.000035398}, {805,0.000070796}, {810,0.000017699}, {815,0.000053097}, {820,0.000017699}, {825,0.000017699}, {830,0.000017699}, {835,0.000035398}, {840,0.000017699}, {845,0.000030973}, {850,0.000084071}, {855,0.000053097}, {860,0.000070796}, {865,0.000061947}, {870,0.000070796}, {875,0.000088496}, {880,0.000070796}, {885,0.000030973}, {890,0.000053097}, {895,0.000070796}, {900,0.000017699}, {905,0.000035398}, {910,0.000013274}, {915,0.000053097}, {920,0.000048673}, {925,0.000048673}, {930,0.000017699}, {935,0.000035398}, {940,0.000035398}, {945,0.000000000}, {950,0.000030973}, {955,0.000035398}, {960,0.000066372}, {965,0.000053097}, {970,0.000066372}, {975,0.000123894}, {980,0.000088496}, {985,0.000106195}, {990,0.000053097}, {995,0.000053097}, {1000,0.000101770}, {1010,0.000070796}, {1020,0.000128319}, {1030,0.000106195}, {1040,0.000070796}, {1050,0.000017699}, {1060,0.000048673}, {1070,0.000066372}, {1080,0.000053097}, {1090,0.000053097}, {1100,0.000088496}, {1110,0.000070796}, {1120,0.000053097}, {1130,0.000017699}, {1140,0.000070796}, {1150,0.000119469}, {1160,0.000000000}, {1170,0.000137168}, {1180,0.000053097}, {1190,0.000070796}, {1200,0.000017699}, {1210,0.000017699}, {1220,0.000106195}, {1230,0.000106195}, {1240,0.000053097}, {1250,0.000110619}, {1260,0.000159292}, {1270,0.000030973}, {1280,0.000035398}, {1290,0.000035398}, {1300,0.000070796}, {1310,0.000101770}, {1320,0.000053097}, {1330,0.000084071}, {1340,0.000101770}, {1350,0.000119469}, {1360,0.000132743}, {1370,0.000128319}, {1380,0.000380531}, {1390,0.001353982}, {1400,0.001575221}, {1410,0.000331858}, {1420,0.000084071}, {1430,0.000017699}, {1440,0.000053097}, {1450,0.000048673}, {1460,0.000070796}, {1470,0.000115044}, {1480,0.000070796}, {1490,0.000000000}, {1500,0.000035398}, {1510,0.000101770}, {1520,0.000070796}, {1530,0.000053097}, {1540,0.000159292}, {1550,0.000066372}, {1560,0.000066372}, {1570,0.000106195}, {1580,0.000000000}, {1590,0.000101770}, {1600,0.000035398}, {1610,0.000066372}, {1620,0.000101770}, {1630,0.000053097}, {1640,0.000070796}, {1650,0.000084071}, {1660,0.000154867}, {1670,0.000172566}, {1680,0.000000000}, {1690,0.000053097}, {1700,0.000053097}, {1710,0.000137168}, {1720,0.000123894}, {1730,0.000123894}, {1740,0.000115044}, {1750,0.000088496}, {1760,0.000101770}, {1770,0.000141593}, {1780,0.000123894}, {1790,0.000119469}, {1800,0.000176991}, {1810,0.000190265}, {1820,0.000190265}, {1830,0.000159292}, {1840,0.000106195}, {1850,0.000123894}, {1860,0.000066372}, {1870,0.000088496}, {1880,0.000035398}, {1890,0.000101770}, {1900,0.000154867}, {1910,0.000154867}, {1920,0.000084071}, {1930,0.000035398}, {1940,0.000137168}, {1950,0.000115044}, {1960,0.000070796}, {1970,0.000088496}, {1980,0.000088496}, {1990,0.000106195}, {2000,0.000030973}, {2050,0.000137168}, {2100,0.000123894}, {2150,0.000225664}, {2200,0.000066372}, {2250,0.000141593}, {2300,0.000132743}, {2350,0.000168142}, {2400,0.000088496}, {2450,0.000053097}, {2500,0.000035398}, {2550,0.000185841}, {2600,0.000159292}, {2650,0.000176991}, {2700,0.000154867}, {2750,0.000150442}, {2800,0.000159292}, {2850,0.000389381}, {2900,0.000535398}, {2950,0.000398230}, {3000,0.000101770}, {3050,0.000522124}, {3100,0.001238938}, {3150,0.000769912}, {3200,0.000048673}, {3250,0.000207965}, {3300,0.001181416}, {3350,0.001725664}, {3400,0.000597345}, {3450,0.000256637}, {3500,0.000176991}, {3550,0.000278761}, {3600,0.000699115}, {3650,0.001163717}, {3700,0.000230088}, {3750,0.000575221}, {3800,0.000172566}, {3850,0.000884956}, {3900,0.000415929}, {3950,0.001305310}, {4000,0.000451327}, {4050,0.000176991}, {4100,0.000884956}, {4150,0.000185841}, {4200,0.000522124}, {4250,0.000234513}, {4300,0.000216814}, {4350,0.000451327}, {4400,0.000256637}, {4450,0.000292035}, {4500,0.000243363}, {4550,0.000907080}, {4600,0.004287611}, {4650,0.000619469}, {4700,0.000345133}, {4750,0.000230088}, {4800,0.000225664}, {4850,0.003508850}, {4900,0.000513274}, {4950,0.000314159}, {5000,0.000261062}, {5050,0.000212389}, {5100,0.001044248}, {5150,0.000265487}, {5200,0.000261062}, {5250,0.000951111}, {5300,0.001075556}, {5350,0.005035556}, {5400,0.000657778}, {5450,0.000302222}, {5500,0.001657778}, {5550,0.003573333}, {5600,0.001186667}, {5650,0.000297778}, {5700,0.000191111}, {5750,0.000204444}, {5800,0.000324444}, {5850,0.000297778}, {5900,0.000568889}, {5950,0.000457778}, {6000,0.000226667}, {6050,0.005222}, {6100,0.016056}, {6150,0.010611}, {6200,0.000389}, {6250,0.003778}, {6300,0.000444}, {6350,0.000222}, {6400,0.000000}, {6450,0.000889}, {6500,0.002556}, {6550,0.002889}, {6600,0.000222}, {6650,0.000000}, {6700,0.001667}, {6750,0.000667}, {6800,0.000000}, {6850,0.000222}, {6900,0.000444}, {6950,0.001000}, {7000,0.000389}, {7050,0.002667}, {7100,0.000000}, {7150,0.000444}, {7200,0.000667}, {7250,0.001333}, {7300,0.003667}, {7350,0.000222}, {7400,0.000444}, {7450,0.000444}, {7500,0.000444}, {7550,0.000222}, {7600,0.000222}, {7650,0.000389}, {7700,0.000444}, {7750,0.000000}, {7800,0.000000}, {7850,0.000444}, {7900,0.000667}, {7950,0.000667}, {8000,0.000889}, {8050,0.000389}, {8100,0.000000}, {8150,0.000444}, {8200,0.000444}, {8250,0.000389}, {8300,0.000000}, {8350,0.001000}, {8400,0.001333}, {8450,0.000611}, {8500,0.000167}, {8550,0.000444}, {8600,0.000222}, {8650,0.000444}, {8700,0.000444}, {8750,0.000444}, {8800,0.000833}, {8850,0.000222}, {8900,0.001111}, {8950,0.000667}, {9000,0.000667}, {9050,0.000222}, {9100,0.000611}, {9150,0.000389}, {9200,0.000444}, {9250,0.000444}, {9300,0.000000}, {9350,0.000444}, {9400,0.000222}, {9450,0.000444}, {9500,0.000667}, {9550,0.000222}, {9600,0.000611}, {9650,0.000000}, {9700,0.000667}, {9750,0.000000}, {9800,0.000222}, {9850,0.000444}, {9900,0.001278}, {9950,0.000000}, {10000,0.000667}, {10100,0.001722}, {10200,0.001333}, {10300,0.000667}, {10400,0.000667}, {10500,0.000444}, {10600,0.000222}, {10700,0.000667}, {10800,0.000000}, {10900,0.000667}, {11000,0.001056}, {11100,0.000611}, {11200,0.000444}, {11300,0.001222}, {11400,0.000444}, {11500,0.000444}, {11600,0.000444}, {11700,0.000389}, {11800,0.000889}, {11900,0.000611}, {12000,0.001111}, {12100,0.001278}, {12200,0.000000}, {12300,0.001778}, {12400,0.001778}, {12500,0.001500}, {12600,0.000889}, {12700,0.000444}, {12800,0.000222}, {12900,0.000222}, {13000,0.001500}, {13100,0.000667}, {13200,0.000222}, {13300,0.000667}, {13400,0.006556}, {13500,0.001111}, {13600,0.000889}, {13700,0.001778}, {13800,0.001556}, {13900,0.008000}, {14000,0.006111}, {14100,0.000833}, {14200,0.002889}, {14300,0.001944}, {14400,0.000889}, {14500,0.001111}, {14600,0.005556}, {14700,0.003056}, {14800,0.001111}, {14900,0.000333}, {15000,0.002389}, {15100,0.006667}, {15200,0.000889}, {15300,0.003500}, {15400,0.004167}, {15500,0.001722}, {15600,0.001778}, {15700,0.004667}, {15800,0.002444}, {15900,0.004722}, {16000,0.002889}, {16100,0.000889}, {16200,0.000222}, {16300,0.000667}, {16400,0.000833}, {16500,0.004000}, {16600,0.003556}, {16700,0.003944}, {16800,0.001944}, {16900,0.001111}, {17000,0.003111}, {17100,0.004556}, {17200,0.002611}, {17300,0.003111}, {17400,0.001111}, {17500,0.004778}, {17600,0.005944}, {17700,0.001944}, {17800,0.001944}, {17900,0.007278}, {18000,0.021222}, {18100,0.003111}, {18200,0.001778}, {18300,0.006833}, {18400,0.004222}, {18500,0.003500}, {18600,0.003000}, {18700,0.002667}, {18800,0.009889}, {18900,0.004611}, {19000,0.003556}, {19100,0.001722}, {19200,0.000444}, {19300,0.000889}, {19400,0.007889}, {19500,0.002111}, {19600,0.003278}, {19700,0.031222}, {19800,0.002222}, {19900,0.003722}, {20000,0.003250}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["Aggregate"]["real"] = {{1,0.00100000}, {2,0.00100000}, {3,0.00100000}, {4,0.00100000}, {5,0.00100000}, {6,0.00100000}, {7,0.00100000}, {8,0.00102632}, {9,0.00140351}, {10,0.00200000}, {11,0.00200000}, {12,0.00200000}, {13,0.00200000}, {14,0.00269298}, {15,0.00201754}, {16,0.00207895}, {17,0.00876316}, {18,0.00292982}, {19,0.00300000}, {20,0.00300000}, {21,0.00300000}, {22,0.00300000}, {23,0.00314912}, {24,0.00307018}, {25,0.00342105}, {26,0.00367544}, {27,0.00400000}, {28,0.00400000}, {29,0.00400000}, {30,0.00403509}, {31,0.00427193}, {32,0.00412281}, {33,0.00442105}, {34,0.00468421}, {35,0.00584211}, {36,0.00500000}, {37,0.00501754}, {38,0.00506140}, {39,0.00526316}, {40,0.00523684}, {41,0.00548246}, {42,0.00566667}, {43,0.00600000}, {44,0.00600000}, {45,0.00609649}, {46,0.00618421}, {47,0.00626316}, {48,0.00618421}, {49,0.00642105}, {50,0.00664035}, {51,0.00700000}, {52,0.00709649}, {53,0.00710526}, {54,0.00719298}, {55,0.00738596}, {56,0.00828947}, {57,0.00755263}, {58,0.00784211}, {59,0.00810526}, {60,0.00890351}, {61,0.00819298}, {62,0.00823684}, {63,0.00875439}, {64,0.00883333}, {65,0.00846491}, {66,0.00869298}, {67,0.00928947}, {68,0.00903509}, {69,0.00926316}, {70,0.00936842}, {71,0.01103509}, {72,0.00919298}, {73,0.00983333}, {74,0.01000877}, {75,0.01028070}, {76,0.01011404}, {77,0.01019298}, {78,0.01023684}, {79,0.01107895}, {80,0.01021053}, {81,0.01064035}, {82,0.01116667}, {83,0.01110526}, {84,0.01109649}, {85,0.01130702}, {86,0.01321930}, {87,0.01211404}, {88,0.01119298}, {89,0.01202632}, {90,0.01214912}, {91,0.01223684}, {92,0.01213158}, {93,0.01258772}, {94,0.01278947}, {95,0.01318421}, {96,0.01219298}, {97,0.01273684}, {98,0.01314035}, {99,0.01324561}, {100,0.01320175}, {101,0.01490351}, {102,0.01352632}, {103,0.01414912}, {104,0.01327193}, {105,0.01411404}, {106,0.01413158}, {107,0.01452632}, {108,0.01424561}, {109,0.01491228}, {110,0.01507018}, {111,0.01523684}, {112,0.01435965}, {113,0.01510526}, {114,0.01608772}, {115,0.01577193}, {116,0.01664912}, {117,0.01590351}, {118,0.01748246}, {119,0.01630702}, {120,0.01572807}, {121,0.01645614}, {122,0.01629825}, {123,0.01711404}, {124,0.01671053}, {125,0.01715789}, {126,0.01715789}, {127,0.01790351}, {128,0.01645614}, {129,0.01805263}, {130,0.01714035}, {131,0.01777193}, {132,0.01719298}, {133,0.01799123}, {134,0.01815789}, {135,0.01868421}, {136,0.01992982}, {137,0.01830702}, {138,0.01833333}, {139,0.01929825}, {140,0.01860526}, {141,0.02153509}, {142,0.01937719}, {143,0.02020175}, {144,0.02043860}, {145,0.01923684}, {146,0.01935088}, {147,0.02014912}, {148,0.01955263}, {149,0.02214035}, {150,0.02061404}, {151,0.02135965}, {152,0.02021053}, {153,0.02075439}, {154,0.02095614}, {155,0.02149123}, {156,0.02116667}, {157,0.02178947}, {158,0.02204386}, {159,0.02542982}, {160,0.02093860}, {161,0.02130702}, {162,0.02156140}, {163,0.02229825}, {164,0.02169298}, {165,0.02243860}, {166,0.02502632}, {167,0.02331579}, {168,0.02226316}, {169,0.02301754}, {170,0.02530702}, {171,0.02388596}, {172,0.02330702}, {173,0.02405263}, {174,0.02620175}, {175,0.02477193}, {176,0.02330702}, {177,0.02387719}, {178,0.02412281}, {179,0.02707018}, {180,0.02434211}, {181,0.02509649}, {182,0.02514035}, {183,0.02585088}, {184,0.02461404}, {185,0.02733333}, {186,0.02557895}, {187,0.02642105}, {188,0.02614912}, {189,0.02671930}, {190,0.02657018}, {191,0.02740351}, {192,0.02552632}, {193,0.02871053}, {194,0.02578947}, {195,0.02661404}, {196,0.02612281}, {197,0.02697368}, {198,0.02713158}, {199,0.02943860}, {200,0.02925439}, {201,0.02742105}, {202,0.02744737}, {203,0.02832456}, {204,0.02798246}, {205,0.02871930}, {206,0.02863158}, {207,0.02946491}, {208,0.02741228}, {209,0.02873684}, {210,0.02934211}, {211,0.03057018}, {212,0.03101754}, {213,0.03352632}, {214,0.03227193}, {215,0.03313158}, {216,0.03131579}, {217,0.03191228}, {218,0.03299123}, {219,0.03377193}, {220,0.03248246}, {221,0.03414035}, {222,0.03338596}, {223,0.03468421}, {224,0.03102632}, {225,0.03299123}, {226,0.03279825}, {227,0.03378070}, {228,0.03300877}, {229,0.03413158}, {230,0.03391228}, {231,0.03316667}, {232,0.03141228}, {233,0.03216667}, {234,0.03261404}, {235,0.03335088}, {236,0.03310526}, {237,0.03361404}, {238,0.03373684}, {239,0.04078947}, {240,0.03371053}, {241,0.03558772}, {242,0.03336842}, {243,0.03434211}, {244,0.03376316}, {245,0.03452632}, {246,0.03476316}, {247,0.04114035}, {248,0.03579825}, {249,0.03656140}, {250,0.03521930}, {251,0.03595614}, {252,0.03576316}, {253,0.04219298}, {254,0.03814912}, {255,0.03756140}, {256,0.03363158}, {257,0.03475439}, {258,0.03510526}, {259,0.03828070}, {260,0.03695614}, {261,0.03632456}, {262,0.03664912}, {263,0.03733333}, {264,0.04054386}, {265,0.03845614}, {266,0.03724561}, {267,0.03777193}, {268,0.03721053}, {269,0.04402632}, {270,0.03931579}, {271,0.03946491}, {272,0.03659649}, {273,0.04294737}, {274,0.03962281}, {275,0.03902632}, {276,0.03816667}, {277,0.04685965}, {278,0.04042982}, {279,0.04091228}, {280,0.03842105}, {281,0.04180702}, {282,0.04007018}, {283,0.04092105}, {284,0.04688596}, {285,0.04163158}, {286,0.04154386}, {287,0.04777193}, {288,0.03865789}, {289,0.04029825}, {290,0.04118421}, {291,0.04097368}, {292,0.04050877}, {293,0.04651754}, {294,0.04113158}, {295,0.04271053}, {296,0.04159649}, {297,0.04183333}, {298,0.04714035}, {299,0.04289474}, {300,0.04254386}, {301,0.04935088}, {302,0.04334211}, {303,0.04926316}, {304,0.04133333}, {305,0.04752632}, {306,0.04345614}, {307,0.04449123}, {308,0.04771930}, {309,0.04412281}, {310,0.04904386}, {311,0.04574561}, {312,0.04784211}, {313,0.04530702}, {314,0.04992982}, {315,0.04644737}, {316,0.04957895}, {317,0.04676316}, {318,0.05090351}, {319,0.04835965}, {320,0.04297368}, {321,0.04392105}, {322,0.04869298}, {323,0.04528947}, {324,0.04926316}, {325,0.04620175}, {326,0.05076316}, {327,0.04737719}, {328,0.04963158}, {329,0.04643860}, {330,0.05088596}, {331,0.04735965}, {332,0.05073684}, {333,0.04767544}, {334,0.04789474}, {335,0.05390351}, {336,0.04624561}, {337,0.05238596}, {338,0.04721053}, {339,0.05271053}, {340,0.05225439}, {341,0.04911404}, {342,0.05342105}, {343,0.05069298}, {344,0.04830702}, {345,0.05379825}, {346,0.04926316}, {347,0.05468421}, {348,0.05307895}, {349,0.05098246}, {350,0.05115789}, {351,0.05806140}, {352,0.05170175}, {353,0.04876316}, {354,0.05493860}, {355,0.05040351}, {356,0.04907018}, {357,0.05466667}, {358,0.05116667}, {359,0.05280702}, {360,0.05320175}, {361,0.05537719}, {362,0.05098246}, {363,0.05693860}, {364,0.05566667}, {365,0.05772807}, {366,0.05303509}, {367,0.05454386}, {368,0.05402632}, {369,0.05582456}, {370,0.05181579}, {371,0.05395614}, {372,0.05606140}, {373,0.05719298}, {374,0.06148246}, {375,0.05593860}, {376,0.05258772}, {377,0.05459649}, {378,0.05842982}, {379,0.05930702}, {380,0.05782456}, {381,0.06134211}, {382,0.05675439}, {383,0.05852632}, {384,0.05118421}, {385,0.05300877}, {386,0.05821930}, {387,0.05483333}, {388,0.05276316}, {389,0.06023684}, {390,0.05969298}, {391,0.05955263}, {392,0.06126316}, {393,0.05544737}, {394,0.05535965}, {395,0.06061404}, {396,0.05921930}, {397,0.06070175}, {398,0.06115789}, {399,0.06470175}, {400,0.06263158}, {401,0.05665789}, {402,0.05598246}, {403,0.06172807}, {404,0.05983333}, {405,0.06215789}, {406,0.06185088}, {407,0.06347368}, {408,0.05939474}, {409,0.06408772}, {410,0.06600000}, {411,0.06792982}, {412,0.06599123}, {413,0.06888596}, {414,0.06741228}, {415,0.06568421}, {416,0.05905263}, {417,0.06170175}, {418,0.06463158}, {419,0.06707895}, {420,0.06696491}, {421,0.06040351}, {422,0.05997368}, {423,0.07271053}, {424,0.06878947}, {425,0.06928070}, {426,0.06859649}, {427,0.06949123}, {428,0.06435088}, {429,0.06655263}, {430,0.06557895}, {431,0.06764912}, {432,0.05977193}, {433,0.06178070}, {434,0.06207018}, {435,0.06414035}, {436,0.06185088}, {437,0.07128947}, {438,0.07117544}, {439,0.06900877}, {440,0.06205263}, {441,0.06423684}, {442,0.06451754}, {443,0.07381579}, {444,0.06852632}, {445,0.06895614}, {446,0.06607018}, {447,0.07603509}, {448,0.06235088}, {449,0.06633333}, {450,0.06531579}, {451,0.06764035}, {452,0.06337719}, {453,0.06442982}, {454,0.06522807}, {455,0.07725439}, {456,0.06853509}, {457,0.06832456}, {458,0.06853509}, {459,0.06771053}, {460,0.07372807}, {461,0.07506140}, {462,0.07000000}, {463,0.06929825}, {464,0.07114912}, {465,0.07020175}, {466,0.06945614}, {467,0.06835088}, {468,0.06691228}, {469,0.07466667}, {470,0.07061404}, {471,0.07011404}, {472,0.07392105}, {473,0.07107018}, {474,0.06870175}, {475,0.07807895}, {476,0.07102632}, {477,0.07123684}, {478,0.07750000}, {479,0.07264912}, {480,0.07384211}, {481,0.07271053}, {482,0.06780702}, {483,0.07013158}, {484,0.07767544}, {485,0.07316667}, {486,0.07821930}, {487,0.07535965}, {488,0.06889474}, {489,0.07842105}, {490,0.07312281}, {491,0.07277193}, {492,0.07327193}, {493,0.07352632}, {494,0.08118421}, {495,0.07519298}, {496,0.07621930}, {497,0.07185965}, {498,0.07888596}, {499,0.07588596}, {500,0.07975439}, {505,0.07697368}, {510,0.08468421}, {515,0.07327193}, {520,0.07843860}, {525,0.07876316}, {530,0.08245614}, {535,0.08370175}, {540,0.08791228}, {545,0.08714912}, {550,0.08278070}, {555,0.08966667}, {560,0.08698246}, {565,0.08589474}, {570,0.09261404}, {575,0.09752632}, {580,0.08920175}, {585,0.09218421}, {590,0.09497368}, {595,0.09462281}, {600,0.09402632}, {605,0.09930702}, {610,0.09578947}, {615,0.10007895}, {620,0.09865789}, {625,0.10217544}, {630,0.10577193}, {635,0.10650877}, {640,0.09600000}, {645,0.09418421}, {650,0.10223684}, {655,0.10704386}, {660,0.10349123}, {665,0.10036842}, {670,0.10879825}, {675,0.10842105}, {680,0.10479825}, {685,0.11070175}, {690,0.10989474}, {695,0.11458772}, {700,0.11716667}, {705,0.11235965}, {710,0.11509649}, {715,0.11671053}, {720,0.11097368}, {725,0.11760526}, {730,0.11748246}, {735,0.12264912}, {740,0.11520175}, {745,0.12015789}, {750,0.12383333}, {755,0.12468421}, {760,0.12129825}, {765,0.12714035}, {770,0.12034211}, {775,0.12295614}, {780,0.12091228}, {785,0.12317544}, {790,0.12397368}, {795,0.12947368}, {800,0.12143860}, {805,0.12664035}, {810,0.12771930}, {815,0.13560526}, {820,0.13665789}, {825,0.13205263}, {830,0.14020175}, {835,0.14059649}, {840,0.13723684}, {845,0.13678947}, {850,0.13120175}, {855,0.14255263}, {860,0.13795614}, {865,0.13599123}, {870,0.14580702}, {875,0.14359649}, {880,0.13632456}, {885,0.14863158}, {890,0.14619298}, {895,0.16249123}, {900,0.14664035}, {905,0.14160526}, {910,0.15280702}, {915,0.14656140}, {920,0.14239474}, {925,0.15781579}, {930,0.15313158}, {935,0.15655263}, {940,0.15242982}, {945,0.15098246}, {950,0.16363158}, {955,0.16690351}, {960,0.14528947}, {965,0.16055263}, {970,0.16130702}, {975,0.16857895}, {980,0.17089474}, {985,0.16825439}, {990,0.16439474}, {995,0.16682456}, {1000,0.16464035}, {1010,0.16989474}, {1020,0.16712281}, {1030,0.16750000}, {1040,0.16363158}, {1050,0.17790351}, {1060,0.16410526}, {1070,0.17418421}, {1080,0.17913158}, {1090,0.17707895}, {1100,0.17965789}, {1110,0.18514035}, {1120,0.17146491}, {1130,0.19314912}, {1140,0.19107895}, {1150,0.20218421}, {1160,0.17833333}, {1170,0.18985088}, {1180,0.19509649}, {1190,0.19879825}, {1200,0.18713158}, {1210,0.20156140}, {1220,0.19779825}, {1230,0.20878070}, {1240,0.20417544}, {1250,0.20628070}, {1260,0.21096491}, {1270,0.21693860}, {1280,0.19290351}, {1290,0.20967544}, {1300,0.21000000}, {1310,0.22082456}, {1320,0.21111404}, {1330,0.22077193}, {1340,0.22655263}, {1350,0.22585088}, {1360,0.21642105}, {1370,0.24417544}, {1380,0.22535965}, {1390,0.23830702}, {1400,0.23143860}, {1410,0.22442982}, {1420,0.23671930}, {1430,0.23891228}, {1440,0.22922807}, {1450,0.24932456}, {1460,0.24240351}, {1470,0.25546491}, {1480,0.24900000}, {1490,0.24761404}, {1500,0.25517544}, {1510,0.26399123}, {1520,0.24791228}, {1530,0.26164912}, {1540,0.24918421}, {1550,0.25431579}, {1560,0.24939474}, {1570,0.24878070}, {1580,0.25528070}, {1590,0.27196491}, {1600,0.24859649}, {1610,0.26164912}, {1620,0.26246491}, {1630,0.28355263}, {1640,0.26414035}, {1650,0.27784211}, {1660,0.29315789}, {1670,0.27679825}, {1680,0.26255263}, {1690,0.28448246}, {1700,0.26631579}, {1710,0.29796491}, {1720,0.29418421}, {1730,0.28365789}, {1740,0.28508772}, {1750,0.29878947}, {1760,0.28431579}, {1770,0.30300000}, {1780,0.30350877}, {1790,0.31749123}, {1800,0.27978070}, {1810,0.29457895}, {1820,0.30431579}, {1830,0.30508772}, {1840,0.28808772}, {1850,0.31302632}, {1860,0.31256140}, {1870,0.32083333}, {1880,0.31433333}, {1890,0.31114912}, {1900,0.32183333}, {1910,0.33910526}, {1920,0.30392982}, {1930,0.31825439}, {1940,0.31536842}, {1950,0.33377193}, {1960,0.32404386}, {1970,0.32748246}, {1980,0.34725439}, {1990,0.32943860}, {2000,0.33258772}, {2050,0.32501754}, {2100,0.35075439}, {2150,0.35832456}, {2200,0.37111404}, {2250,0.38196491}, {2300,0.40449123}, {2350,0.40135965}, {2400,0.40504386}, {2450,0.40822807}, {2500,0.41609649}, {2550,0.44946491}, {2600,0.42590351}, {2650,0.45173684}, {2700,0.44692982}, {2750,0.49629825}, {2800,0.47273684}, {2850,0.47699123}, {2900,0.49571053}, {2950,0.50169298}, {3000,0.52171930}, {3050,0.54290351}, {3100,0.51842105}, {3150,0.54225439}, {3200,0.51731579}, {3250,0.55745614}, {3300,0.56528947}, {3350,0.57307018}, {3400,0.56350877}, {3450,0.62728070}, {3500,0.60789474}, {3550,0.65504386}, {3600,0.58524561}, {3650,0.60723684}, {3700,0.65550000}, {3750,0.65562281}, {3800,0.68142982}, {3850,0.66784211}, {3900,0.70935965}, {3950,0.72512281}, {4000,0.68885965}, {4050,0.71854386}, {4100,0.67805263}, {4150,0.72928947}, {4200,0.74369298}, {4250,0.74421053}, {4300,0.78414035}, {4350,0.81873684}, {4400,0.76411404}, {4450,0.78413158}, {4500,0.80652632}, {4550,0.81911404}, {4600,0.85029825}, {4650,0.81409649}, {4700,0.85490351}, {4750,0.85851754}, {4800,0.81747368}, {4850,0.90563158}, {4900,0.85898246}, {4950,0.91314035}, {5000,0.87528070}, {5050,0.94506140}, {5100,0.95842982}, {5150,0.94117544}, {5200,0.89268421}, {5250,0.89950000}, {5300,0.96072807}, {5350,0.99662281}, {5400,0.95889474}, {5450,0.97936842}, {5500,1.04246491}, {5550,1.05819298}, {5600,1.02663158}, {5650,0.99203509}, {5700,1.01186842}, {5750,1.09597368}, {5800,1.03668421}, {5850,1.12527193}, {5900,1.05701754}, {5950,1.15307895}, {6000,1.13506140}, {6050,1.170429}, {6100,1.188929}, {6150,1.105500}, {6200,1.131571}, {6250,1.179571}, {6300,1.181214}, {6350,1.219357}, {6400,1.112643}, {6450,1.195071}, {6500,1.204643}, {6550,1.261143}, {6600,1.227786}, {6650,1.350143}, {6700,1.246429}, {6750,1.318786}, {6800,1.253643}, {6850,1.275571}, {6900,1.374357}, {6950,1.330500}, {7000,1.305571}, {7050,1.378714}, {7100,1.430714}, {7150,1.481143}, {7200,1.272500}, {7250,1.345429}, {7300,1.334571}, {7350,1.457429}, {7400,1.428143}, {7450,1.456571}, {7500,1.451357}, {7550,1.591786}, {7600,1.449000}, {7650,1.514786}, {7700,1.422286}, {7750,1.495214}, {7800,1.523500}, {7850,1.540143}, {7900,1.590214}, {7950,1.560214}, {8000,1.453071}, {8050,1.624214}, {8100,1.587071}, {8150,1.706143}, {8200,1.473357}, {8250,1.599929}, {8300,1.611571}, {8350,1.662857}, {8400,1.581143}, {8450,1.536857}, {8500,1.665857}, {8550,1.687000}, {8600,1.678214}, {8650,1.745071}, {8700,1.814071}, {8750,1.727143}, {8800,1.640857}, {8850,1.707643}, {8900,1.736000}, {8950,1.892929}, {9000,1.717500}, {9050,1.855714}, {9100,1.804000}, {9150,1.993071}, {9200,1.880929}, {9250,1.726571}, {9300,1.791500}, {9350,1.819286}, {9400,1.866143}, {9450,1.917714}, {9500,1.855786}, {9550,1.920786}, {9600,1.750286}, {9650,1.951929}, {9700,1.937714}, {9750,1.910786}, {9800,1.871143}, {9850,2.020143}, {9900,1.994429}, {9950,2.098571}, {10000,1.885000}, {10100,2.083143}, {10200,2.052357}, {10300,2.039286}, {10400,1.939857}, {10500,1.968714}, {10600,2.088214}, {10700,2.166571}, {10800,2.062214}, {10900,2.140429}, {11000,2.275929}, {11100,2.300143}, {11200,2.173214}, {11300,2.174786}, {11400,2.172000}, {11500,2.378000}, {11600,2.249071}, {11700,2.426571}, {11800,2.322286}, {11900,2.540786}, {12000,2.409786}, {12100,2.412357}, {12200,2.505786}, {12300,2.336429}, {12400,2.393857}, {12500,2.514571}, {12600,2.518143}, {12700,2.625357}, {12800,2.281857}, {12900,2.564571}, {13000,2.609500}, {13100,2.660643}, {13200,2.621357}, {13300,2.845857}, {13400,2.675357}, {13500,2.836500}, {13600,2.601571}, {13700,2.692214}, {13800,2.856714}, {13900,2.845071}, {14000,2.843429}, {14100,2.821214}, {14200,3.045857}, {14300,3.179643}, {14400,2.669071}, {14500,2.899714}, {14600,2.792143}, {14700,3.124214}, {14800,3.030929}, {14900,3.388929}, {15000,3.059714}, {15100,3.327214}, {15200,3.234000}, {15300,3.170357}, {15400,3.410357}, {15500,3.139286}, {15600,3.304286}, {15700,3.459643}, {15800,3.546643}, {15900,3.330143}, {16000,3.083786}, {16100,3.413143}, {16200,3.340786}, {16300,3.566214}, {16400,3.075786}, {16500,3.440500}, {16600,3.741857}, {16700,3.528429}, {16800,3.350286}, {16900,3.809071}, {17000,3.493857}, {17100,3.650286}, {17200,3.542500}, {17300,3.691500}, {17400,3.846500}, {17500,3.714786}, {17600,3.520286}, {17700,3.803429}, {17800,4.028143}, {17900,4.129786}, {18000,3.655857}, {18100,3.970357}, {18200,3.999214}, {18300,4.192071}, {18400,3.941286}, {18500,3.684643}, {18600,3.977643}, {18700,4.155571}, {18800,4.147929}, {18900,4.146286}, {19000,3.972429}, {19100,4.098214}, {19200,3.840214}, {19300,4.344214}, {19400,4.131714}, {19500,4.106500}, {19600,4.047786}, {19700,4.362214}, {19800,4.322071}, {19900,4.766929}, {20000,4.100286}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["Aggregate"]["user"] = {{1,0.00042105}, {2,0.00117544}, {3,0.00118421}, {4,0.00123684}, {5,0.00135088}, {6,0.00158772}, {7,0.00170175}, {8,0.00135965}, {9,0.00165789}, {10,0.00193860}, {11,0.00194737}, {12,0.00205263}, {13,0.00210526}, {14,0.00282456}, {15,0.00244737}, {16,0.00234211}, {17,0.00862281}, {18,0.00264912}, {19,0.00278070}, {20,0.00280702}, {21,0.00292982}, {22,0.00314912}, {23,0.00326316}, {24,0.00335965}, {25,0.00336842}, {26,0.00374561}, {27,0.00396491}, {28,0.00375439}, {29,0.00406140}, {30,0.00414035}, {31,0.00448246}, {32,0.00401754}, {33,0.00443860}, {34,0.00434211}, {35,0.00542105}, {36,0.00538596}, {37,0.00486842}, {38,0.00562281}, {39,0.00578947}, {40,0.00535088}, {41,0.00594737}, {42,0.00599123}, {43,0.00616667}, {44,0.00592982}, {45,0.00634211}, {46,0.00651754}, {47,0.00660526}, {48,0.00609649}, {49,0.00683333}, {50,0.00697368}, {51,0.00739474}, {52,0.00712281}, {53,0.00714912}, {54,0.00764035}, {55,0.00772807}, {56,0.00853509}, {57,0.00809649}, {58,0.00810526}, {59,0.00814035}, {60,0.00913158}, {61,0.00840351}, {62,0.00857895}, {63,0.00913158}, {64,0.00915789}, {65,0.00908772}, {66,0.00908772}, {67,0.00907895}, {68,0.00941228}, {69,0.00945614}, {70,0.00949123}, {71,0.01101754}, {72,0.00946491}, {73,0.00992105}, {74,0.00985088}, {75,0.01060526}, {76,0.01027193}, {77,0.01019298}, {78,0.01023684}, {79,0.01098246}, {80,0.01069298}, {81,0.01050000}, {82,0.01089474}, {83,0.01126316}, {84,0.01099123}, {85,0.01128070}, {86,0.01342982}, {87,0.01207895}, {88,0.01139474}, {89,0.01212281}, {90,0.01213158}, {91,0.01248246}, {92,0.01250877}, {93,0.01256140}, {94,0.01273684}, {95,0.01307018}, {96,0.01232456}, {97,0.01299123}, {98,0.01303509}, {99,0.01311404}, {100,0.01356140}, {101,0.01526316}, {102,0.01404386}, {103,0.01447368}, {104,0.01363158}, {105,0.01414035}, {106,0.01422807}, {107,0.01515789}, {108,0.01428070}, {109,0.01556140}, {110,0.01528070}, {111,0.01568421}, {112,0.01487719}, {113,0.01524561}, {114,0.01614035}, {115,0.01622807}, {116,0.01672807}, {117,0.01629825}, {118,0.01738596}, {119,0.01655263}, {120,0.01610526}, {121,0.01679825}, {122,0.01678947}, {123,0.01714035}, {124,0.01686842}, {125,0.01754386}, {126,0.01760526}, {127,0.01772807}, {128,0.01673684}, {129,0.01787719}, {130,0.01728070}, {131,0.01754386}, {132,0.01722807}, {133,0.01799123}, {134,0.01791228}, {135,0.01898246}, {136,0.01959649}, {137,0.01834211}, {138,0.01816667}, {139,0.01880702}, {140,0.01852632}, {141,0.02128070}, {142,0.01917544}, {143,0.01967544}, {144,0.02014912}, {145,0.01892982}, {146,0.01912281}, {147,0.01983333}, {148,0.01919298}, {149,0.02206140}, {150,0.02043860}, {151,0.02107018}, {152,0.01986842}, {153,0.02055263}, {154,0.02034211}, {155,0.02098246}, {156,0.02100000}, {157,0.02105263}, {158,0.02172807}, {159,0.02530702}, {160,0.02056140}, {161,0.02118421}, {162,0.02141228}, {163,0.02223684}, {164,0.02168421}, {165,0.02248246}, {166,0.02514912}, {167,0.02323684}, {168,0.02227193}, {169,0.02280702}, {170,0.02527193}, {171,0.02393860}, {172,0.02303509}, {173,0.02382456}, {174,0.02621930}, {175,0.02492982}, {176,0.02318421}, {177,0.02390351}, {178,0.02368421}, {179,0.02703509}, {180,0.02434211}, {181,0.02491228}, {182,0.02521930}, {183,0.02550877}, {184,0.02480702}, {185,0.02740351}, {186,0.02579825}, {187,0.02674561}, {188,0.02615789}, {189,0.02676316}, {190,0.02679825}, {191,0.02765789}, {192,0.02566667}, {193,0.02849123}, {194,0.02609649}, {195,0.02682456}, {196,0.02603509}, {197,0.02699123}, {198,0.02690351}, {199,0.02960526}, {200,0.02918421}, {201,0.02761404}, {202,0.02733333}, {203,0.02807018}, {204,0.02777193}, {205,0.02867544}, {206,0.02849123}, {207,0.02924561}, {208,0.02717544}, {209,0.02894737}, {210,0.02919298}, {211,0.03086842}, {212,0.03133333}, {213,0.03338596}, {214,0.03244737}, {215,0.03312281}, {216,0.03135965}, {217,0.03211404}, {218,0.03341228}, {219,0.03396491}, {220,0.03281579}, {221,0.03435088}, {222,0.03335088}, {223,0.03448246}, {224,0.03132456}, {225,0.03321930}, {226,0.03292105}, {227,0.03387719}, {228,0.03319298}, {229,0.03411404}, {230,0.03371053}, {231,0.03344737}, {232,0.03163158}, {233,0.03221053}, {234,0.03269298}, {235,0.03351754}, {236,0.03370175}, {237,0.03390351}, {238,0.03358772}, {239,0.04071930}, {240,0.03385088}, {241,0.03578947}, {242,0.03390351}, {243,0.03454386}, {244,0.03419298}, {245,0.03425439}, {246,0.03483333}, {247,0.04028947}, {248,0.03587719}, {249,0.03663158}, {250,0.03529825}, {251,0.03606140}, {252,0.03584211}, {253,0.04185965}, {254,0.03785965}, {255,0.03697368}, {256,0.03400000}, {257,0.03493860}, {258,0.03502632}, {259,0.03804386}, {260,0.03678947}, {261,0.03626316}, {262,0.03658772}, {263,0.03721053}, {264,0.04012281}, {265,0.03796491}, {266,0.03718421}, {267,0.03731579}, {268,0.03734211}, {269,0.04392105}, {270,0.03891228}, {271,0.03915789}, {272,0.03642105}, {273,0.04296491}, {274,0.03948246}, {275,0.03859649}, {276,0.03804386}, {277,0.04623684}, {278,0.04014912}, {279,0.04070175}, {280,0.03808772}, {281,0.04206140}, {282,0.03954386}, {283,0.04076316}, {284,0.04635088}, {285,0.04180702}, {286,0.04151754}, {287,0.04750877}, {288,0.03826316}, {289,0.03993860}, {290,0.04080702}, {291,0.04087719}, {292,0.04001754}, {293,0.04616667}, {294,0.04072807}, {295,0.04305263}, {296,0.04157018}, {297,0.04187719}, {298,0.04681579}, {299,0.04287719}, {300,0.04231579}, {301,0.04896491}, {302,0.04339474}, {303,0.04884211}, {304,0.04121930}, {305,0.04710526}, {306,0.04352632}, {307,0.04473684}, {308,0.04750000}, {309,0.04417544}, {310,0.04857018}, {311,0.04550000}, {312,0.04771053}, {313,0.04521053}, {314,0.04927193}, {315,0.04623684}, {316,0.04942982}, {317,0.04654386}, {318,0.05050000}, {319,0.04843860}, {320,0.04263158}, {321,0.04360526}, {322,0.04841228}, {323,0.04540351}, {324,0.04920175}, {325,0.04640351}, {326,0.05030702}, {327,0.04735965}, {328,0.04951754}, {329,0.04628947}, {330,0.05067544}, {331,0.04719298}, {332,0.05035965}, {333,0.04756140}, {334,0.04785088}, {335,0.05354386}, {336,0.04652632}, {337,0.05184211}, {338,0.04723684}, {339,0.05221053}, {340,0.05182456}, {341,0.04884211}, {342,0.05315789}, {343,0.05042982}, {344,0.04825439}, {345,0.05351754}, {346,0.04921930}, {347,0.05468421}, {348,0.05268421}, {349,0.05071053}, {350,0.05058772}, {351,0.05789474}, {352,0.05117544}, {353,0.04860526}, {354,0.05473684}, {355,0.05025439}, {356,0.04909649}, {357,0.05458772}, {358,0.05077193}, {359,0.05221053}, {360,0.05309649}, {361,0.05503509}, {362,0.05052632}, {363,0.05675439}, {364,0.05550000}, {365,0.05738596}, {366,0.05272807}, {367,0.05406140}, {368,0.05369298}, {369,0.05571053}, {370,0.05135965}, {371,0.05332456}, {372,0.05594737}, {373,0.05695614}, {374,0.06132456}, {375,0.05542105}, {376,0.05217544}, {377,0.05416667}, {378,0.05852632}, {379,0.05925439}, {380,0.05771930}, {381,0.06134211}, {382,0.05662281}, {383,0.05828070}, {384,0.05083333}, {385,0.05263158}, {386,0.05807018}, {387,0.05462281}, {388,0.05214035}, {389,0.06035088}, {390,0.05996491}, {391,0.05971930}, {392,0.06156140}, {393,0.05490351}, {394,0.05528947}, {395,0.06075439}, {396,0.05911404}, {397,0.06071053}, {398,0.06108772}, {399,0.06467544}, {400,0.06304386}, {401,0.05664035}, {402,0.05578070}, {403,0.06208772}, {404,0.05975439}, {405,0.06226316}, {406,0.06175439}, {407,0.06327193}, {408,0.05932456}, {409,0.06406140}, {410,0.06609649}, {411,0.06745614}, {412,0.06608772}, {413,0.06824561}, {414,0.06710526}, {415,0.06536842}, {416,0.05883333}, {417,0.06167544}, {418,0.06457018}, {419,0.06706140}, {420,0.06683333}, {421,0.06035088}, {422,0.05980702}, {423,0.07252632}, {424,0.06874561}, {425,0.06896491}, {426,0.06840351}, {427,0.06937719}, {428,0.06457018}, {429,0.06651754}, {430,0.06571053}, {431,0.06753509}, {432,0.05989474}, {433,0.06178947}, {434,0.06244737}, {435,0.06438596}, {436,0.06172807}, {437,0.07065789}, {438,0.07082456}, {439,0.06863158}, {440,0.06237719}, {441,0.06458772}, {442,0.06428070}, {443,0.07390351}, {444,0.06821053}, {445,0.06878947}, {446,0.06600000}, {447,0.07573684}, {448,0.06248246}, {449,0.06609649}, {450,0.06528070}, {451,0.06728947}, {452,0.06336842}, {453,0.06448246}, {454,0.06496491}, {455,0.07712281}, {456,0.06832456}, {457,0.06810526}, {458,0.06807895}, {459,0.06757018}, {460,0.07391228}, {461,0.07507895}, {462,0.06987719}, {463,0.06944737}, {464,0.07102632}, {465,0.07016667}, {466,0.06925439}, {467,0.06782456}, {468,0.06684211}, {469,0.07442982}, {470,0.07023684}, {471,0.07003509}, {472,0.07385088}, {473,0.07096491}, {474,0.06839474}, {475,0.07771053}, {476,0.07077193}, {477,0.07107018}, {478,0.07705263}, {479,0.07279825}, {480,0.07390351}, {481,0.07256140}, {482,0.06724561}, {483,0.06993860}, {484,0.07708772}, {485,0.07317544}, {486,0.07803509}, {487,0.07513158}, {488,0.06885088}, {489,0.07778070}, {490,0.07274561}, {491,0.07287719}, {492,0.07325439}, {493,0.07337719}, {494,0.08097368}, {495,0.07497368}, {496,0.07571053}, {497,0.07192982}, {498,0.07848246}, {499,0.07590351}, {500,0.07942982}, {505,0.07687719}, {510,0.08478947}, {515,0.07315789}, {520,0.07803509}, {525,0.07819298}, {530,0.08255263}, {535,0.08302632}, {540,0.08770175}, {545,0.08689474}, {550,0.08253509}, {555,0.08921930}, {560,0.08683333}, {565,0.08576316}, {570,0.09250000}, {575,0.09735965}, {580,0.08910526}, {585,0.09190351}, {590,0.09466667}, {595,0.09444737}, {600,0.09392105}, {605,0.09894737}, {610,0.09582456}, {615,0.09978947}, {620,0.09851754}, {625,0.10161404}, {630,0.10543860}, {635,0.10616667}, {640,0.09570175}, {645,0.09360526}, {650,0.10198246}, {655,0.10688596}, {660,0.10285088}, {665,0.09990351}, {670,0.10833333}, {675,0.10822807}, {680,0.10442982}, {685,0.11026316}, {690,0.10978947}, {695,0.11423684}, {700,0.11700877}, {705,0.11198246}, {710,0.11480702}, {715,0.11607895}, {720,0.11074561}, {725,0.11717544}, {730,0.11682456}, {735,0.12274561}, {740,0.11446491}, {745,0.11953509}, {750,0.12383333}, {755,0.12425439}, {760,0.12107895}, {765,0.12694737}, {770,0.12007895}, {775,0.12282456}, {780,0.12089474}, {785,0.12312281}, {790,0.12380702}, {795,0.12973684}, {800,0.12137719}, {805,0.12672807}, {810,0.12765789}, {815,0.13564035}, {820,0.13646491}, {825,0.13199123}, {830,0.14014912}, {835,0.14053509}, {840,0.13688596}, {845,0.13655263}, {850,0.13108772}, {855,0.14247368}, {860,0.13785965}, {865,0.13602632}, {870,0.14524561}, {875,0.14358772}, {880,0.13621053}, {885,0.14826316}, {890,0.14630702}, {895,0.16242105}, {900,0.14661404}, {905,0.14137719}, {910,0.15255263}, {915,0.14648246}, {920,0.14235088}, {925,0.15777193}, {930,0.15321053}, {935,0.15631579}, {940,0.15208772}, {945,0.15046491}, {950,0.16343860}, {955,0.16684211}, {960,0.14528947}, {965,0.16009649}, {970,0.16107895}, {975,0.16840351}, {980,0.17080702}, {985,0.16777193}, {990,0.16414035}, {995,0.16658772}, {1000,0.16455263}, {1010,0.16953509}, {1020,0.16678947}, {1030,0.16714035}, {1040,0.16343860}, {1050,0.17719298}, {1060,0.16370175}, {1070,0.17391228}, {1080,0.17885088}, {1090,0.17664035}, {1100,0.17928947}, {1110,0.18476316}, {1120,0.17106140}, {1130,0.19272807}, {1140,0.19061404}, {1150,0.20155263}, {1160,0.17771053}, {1170,0.18950000}, {1180,0.19451754}, {1190,0.19808772}, {1200,0.18661404}, {1210,0.20106140}, {1220,0.19724561}, {1230,0.20829825}, {1240,0.20336842}, {1250,0.20580702}, {1260,0.21082456}, {1270,0.21660526}, {1280,0.19252632}, {1290,0.20900000}, {1300,0.20936842}, {1310,0.22025439}, {1320,0.21075439}, {1330,0.21988596}, {1340,0.22587719}, {1350,0.22535965}, {1360,0.21582456}, {1370,0.24343860}, {1380,0.22450000}, {1390,0.23715789}, {1400,0.23028947}, {1410,0.22310526}, {1420,0.23625439}, {1430,0.23847368}, {1440,0.22862281}, {1450,0.24883333}, {1460,0.24180702}, {1470,0.25506140}, {1480,0.24878947}, {1490,0.24721053}, {1500,0.25471053}, {1510,0.26385088}, {1520,0.24750877}, {1530,0.26149123}, {1540,0.24861404}, {1550,0.25389474}, {1560,0.24900877}, {1570,0.24848246}, {1580,0.25499123}, {1590,0.27135965}, {1600,0.24803509}, {1610,0.26138596}, {1620,0.26203509}, {1630,0.28312281}, {1640,0.26364035}, {1650,0.27739474}, {1660,0.29290351}, {1670,0.27632456}, {1680,0.26205263}, {1690,0.28422807}, {1700,0.26620175}, {1710,0.29772807}, {1720,0.29353509}, {1730,0.28306140}, {1740,0.28504386}, {1750,0.29814035}, {1760,0.28376316}, {1770,0.30281579}, {1780,0.30302632}, {1790,0.31698246}, {1800,0.27926316}, {1810,0.29393860}, {1820,0.30371930}, {1830,0.30461404}, {1840,0.28746491}, {1850,0.31215789}, {1860,0.31219298}, {1870,0.32050000}, {1880,0.31391228}, {1890,0.31061404}, {1900,0.32136842}, {1910,0.33871930}, {1920,0.30333333}, {1930,0.31750000}, {1940,0.31467544}, {1950,0.33330702}, {1960,0.32337719}, {1970,0.32692105}, {1980,0.34674561}, {1990,0.32928947}, {2000,0.33223684}, {2050,0.32439474}, {2100,0.35028070}, {2150,0.35763158}, {2200,0.37042982}, {2250,0.38103509}, {2300,0.40361404}, {2350,0.40041228}, {2400,0.40398246}, {2450,0.40732456}, {2500,0.41535088}, {2550,0.44821053}, {2600,0.42538596}, {2650,0.45051754}, {2700,0.44598246}, {2750,0.49560526}, {2800,0.47172807}, {2850,0.47607018}, {2900,0.49485965}, {2950,0.50107895}, {3000,0.52056140}, {3050,0.54193860}, {3100,0.51772807}, {3150,0.54157895}, {3200,0.51607018}, {3250,0.55668421}, {3300,0.56444737}, {3350,0.57234211}, {3400,0.56236842}, {3450,0.62614035}, {3500,0.60697368}, {3550,0.65380702}, {3600,0.58375439}, {3650,0.60596491}, {3700,0.65428070}, {3750,0.65479825}, {3800,0.68014035}, {3850,0.66644737}, {3900,0.70796491}, {3950,0.72405263}, {4000,0.68765789}, {4050,0.71735088}, {4100,0.67694737}, {4150,0.72741228}, {4200,0.74251754}, {4250,0.74290351}, {4300,0.78251754}, {4350,0.81715789}, {4400,0.76261404}, {4450,0.78250877}, {4500,0.80491228}, {4550,0.81747368}, {4600,0.84872807}, {4650,0.81085965}, {4700,0.85339474}, {4750,0.85715789}, {4800,0.81614035}, {4850,0.90392105}, {4900,0.85719298}, {4950,0.91107018}, {5000,0.87347368}, {5050,0.94313158}, {5100,0.95647368}, {5150,0.93964035}, {5200,0.89071930}, {5250,0.89767544}, {5300,0.95868421}, {5350,0.99480702}, {5400,0.95676316}, {5450,0.97745614}, {5500,1.04056140}, {5550,1.05570175}, {5600,1.02256140}, {5650,0.99000000}, {5700,1.01014912}, {5750,1.09395614}, {5800,1.03495614}, {5850,1.12335088}, {5900,1.05490351}, {5950,1.15087719}, {6000,1.13299123}, {6050,1.161714}, {6100,1.183786}, {6150,1.101286}, {6200,1.129214}, {6250,1.178571}, {6300,1.178714}, {6350,1.217571}, {6400,1.111071}, {6450,1.192929}, {6500,1.202500}, {6550,1.259786}, {6600,1.226143}, {6650,1.350357}, {6700,1.244857}, {6750,1.316714}, {6800,1.252571}, {6850,1.273571}, {6900,1.372000}, {6950,1.329286}, {7000,1.303500}, {7050,1.375786}, {7100,1.427857}, {7150,1.479286}, {7200,1.270143}, {7250,1.343429}, {7300,1.332071}, {7350,1.454571}, {7400,1.425500}, {7450,1.454571}, {7500,1.449143}, {7550,1.589429}, {7600,1.445786}, {7650,1.512286}, {7700,1.420643}, {7750,1.492571}, {7800,1.520571}, {7850,1.537286}, {7900,1.587857}, {7950,1.558071}, {8000,1.449571}, {8050,1.621000}, {8100,1.584786}, {8150,1.703929}, {8200,1.471643}, {8250,1.597429}, {8300,1.608071}, {8350,1.660357}, {8400,1.579214}, {8450,1.533857}, {8500,1.662571}, {8550,1.684000}, {8600,1.675143}, {8650,1.741143}, {8700,1.810214}, {8750,1.724071}, {8800,1.637357}, {8850,1.703786}, {8900,1.732357}, {8950,1.888571}, {9000,1.713571}, {9050,1.852357}, {9100,1.800714}, {9150,1.989357}, {9200,1.877786}, {9250,1.724071}, {9300,1.788571}, {9350,1.816857}, {9400,1.863786}, {9450,1.914143}, {9500,1.852286}, {9550,1.917571}, {9600,1.747643}, {9650,1.948429}, {9700,1.935000}, {9750,1.908286}, {9800,1.867857}, {9850,2.017071}, {9900,1.990857}, {9950,2.095929}, {10000,1.881500}, {10100,2.080643}, {10200,2.049143}, {10300,2.035500}, {10400,1.936714}, {10500,1.965571}, {10600,2.084214}, {10700,2.162571}, {10800,2.057857}, {10900,2.137929}, {11000,2.272143}, {11100,2.296429}, {11200,2.169929}, {11300,2.171786}, {11400,2.168643}, {11500,2.375143}, {11600,2.245571}, {11700,2.424286}, {11800,2.319786}, {11900,2.537929}, {12000,2.407214}, {12100,2.408929}, {12200,2.501571}, {12300,2.333000}, {12400,2.390643}, {12500,2.511429}, {12600,2.514857}, {12700,2.621000}, {12800,2.278857}, {12900,2.561071}, {13000,2.605929}, {13100,2.656929}, {13200,2.618143}, {13300,2.841857}, {13400,2.672000}, {13500,2.833429}, {13600,2.598786}, {13700,2.688714}, {13800,2.851071}, {13900,2.839429}, {14000,2.838500}, {14100,2.817857}, {14200,3.042286}, {14300,3.173929}, {14400,2.666071}, {14500,2.896643}, {14600,2.787000}, {14700,3.120214}, {14800,3.027429}, {14900,3.384429}, {15000,3.055857}, {15100,3.322000}, {15200,3.229929}, {15300,3.166500}, {15400,3.404500}, {15500,3.134357}, {15600,3.298714}, {15700,3.454500}, {15800,3.539786}, {15900,3.324571}, {16000,3.078786}, {16100,3.405357}, {16200,3.336500}, {16300,3.561714}, {16400,3.071000}, {16500,3.433929}, {16600,3.733929}, {16700,3.522143}, {16800,3.345643}, {16900,3.802143}, {17000,3.487786}, {17100,3.643714}, {17200,3.535929}, {17300,3.686214}, {17400,3.840000}, {17500,3.708214}, {17600,3.512857}, {17700,3.796357}, {17800,4.019857}, {17900,4.121286}, {18000,3.645643}, {18100,3.960571}, {18200,3.991786}, {18300,4.180929}, {18400,3.932143}, {18500,3.676857}, {18600,3.969714}, {18700,4.147071}, {18800,4.138429}, {18900,4.134357}, {19000,3.963429}, {19100,4.091286}, {19200,3.833429}, {19300,4.334357}, {19400,4.123214}, {19500,4.099571}, {19600,4.038786}, {19700,4.352786}, {19800,4.313286}, {19900,4.757429}, {20000,4.091786}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["Aggregate"]["system"] = {{1,0.00043860}, {2,0.00007018}, {3,0.00010526}, {4,0.00003509}, {5,0.00007018}, {6,0.00003509}, {7,0.00000000}, {8,0.00007018}, {9,0.00002632}, {10,0.00000000}, {11,0.00010526}, {12,0.00009649}, {13,0.00007018}, {14,0.00003509}, {15,0.00000000}, {16,0.00003509}, {17,0.00039474}, {18,0.00009649}, {19,0.00002632}, {20,0.00003509}, {21,0.00003509}, {22,0.00003509}, {23,0.00007018}, {24,0.00007018}, {25,0.00007018}, {26,0.00000000}, {27,0.00000000}, {28,0.00009649}, {29,0.00000000}, {30,0.00000000}, {31,0.00010526}, {32,0.00002632}, {33,0.00007018}, {34,0.00007018}, {35,0.00009649}, {36,0.00000000}, {37,0.00010526}, {38,0.00000000}, {39,0.00003509}, {40,0.00000000}, {41,0.00000000}, {42,0.00017544}, {43,0.00003509}, {44,0.00005263}, {45,0.00003509}, {46,0.00003509}, {47,0.00003509}, {48,0.00005263}, {49,0.00007018}, {50,0.00003509}, {51,0.00007018}, {52,0.00000000}, {53,0.00003509}, {54,0.00005263}, {55,0.00010526}, {56,0.00006140}, {57,0.00000000}, {58,0.00002632}, {59,0.00013158}, {60,0.00003509}, {61,0.00000000}, {62,0.00002632}, {63,0.00000000}, {64,0.00003509}, {65,0.00003509}, {66,0.00002632}, {67,0.00003509}, {68,0.00003509}, {69,0.00003509}, {70,0.00003509}, {71,0.00007018}, {72,0.00006140}, {73,0.00000000}, {74,0.00013158}, {75,0.00003509}, {76,0.00009649}, {77,0.00002632}, {78,0.00003509}, {79,0.00009649}, {80,0.00000000}, {81,0.00008772}, {82,0.00007018}, {83,0.00007018}, {84,0.00000000}, {85,0.00007018}, {86,0.00009649}, {87,0.00003509}, {88,0.00003509}, {89,0.00000000}, {90,0.00007018}, {91,0.00003509}, {92,0.00003509}, {93,0.00000000}, {94,0.00007018}, {95,0.00007018}, {96,0.00003509}, {97,0.00003509}, {98,0.00021930}, {99,0.00006140}, {100,0.00002632}, {101,0.00006140}, {102,0.00010526}, {103,0.00010526}, {104,0.00010526}, {105,0.00007018}, {106,0.00000000}, {107,0.00003509}, {108,0.00007018}, {109,0.00003509}, {110,0.00006140}, {111,0.00006140}, {112,0.00000000}, {113,0.00007018}, {114,0.00005263}, {115,0.00009649}, {116,0.00010526}, {117,0.00003509}, {118,0.00012281}, {119,0.00010526}, {120,0.00019298}, {121,0.00007018}, {122,0.00000000}, {123,0.00003509}, {124,0.00009649}, {125,0.00000000}, {126,0.00007018}, {127,0.00006140}, {128,0.00006140}, {129,0.00003509}, {130,0.00003509}, {131,0.00007895}, {132,0.00014035}, {133,0.00000000}, {134,0.00000000}, {135,0.00003509}, {136,0.00007018}, {137,0.00005263}, {138,0.00000000}, {139,0.00006140}, {140,0.00007018}, {141,0.00014035}, {142,0.00005263}, {143,0.00000000}, {144,0.00010526}, {145,0.00005263}, {146,0.00009649}, {147,0.00000000}, {148,0.00007018}, {149,0.00005263}, {150,0.00000000}, {151,0.00003509}, {152,0.00000000}, {153,0.00003509}, {154,0.00006140}, {155,0.00003509}, {156,0.00010526}, {157,0.00010526}, {158,0.00000000}, {159,0.00007018}, {160,0.00003509}, {161,0.00003509}, {162,0.00013158}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00010526}, {167,0.00003509}, {168,0.00005263}, {169,0.00000000}, {170,0.00013158}, {171,0.00003509}, {172,0.00009649}, {173,0.00009649}, {174,0.00000000}, {175,0.00010526}, {176,0.00010526}, {177,0.00000000}, {178,0.00012281}, {179,0.00010526}, {180,0.00003509}, {181,0.00003509}, {182,0.00000000}, {183,0.00006140}, {184,0.00000000}, {185,0.00020175}, {186,0.00006140}, {187,0.00007018}, {188,0.00000000}, {189,0.00010526}, {190,0.00007018}, {191,0.00002632}, {192,0.00000000}, {193,0.00030702}, {194,0.00003509}, {195,0.00003509}, {196,0.00010526}, {197,0.00009649}, {198,0.00003509}, {199,0.00014035}, {200,0.00006140}, {201,0.00007018}, {202,0.00007018}, {203,0.00009649}, {204,0.00003509}, {205,0.00000000}, {206,0.00003509}, {207,0.00006140}, {208,0.00002632}, {209,0.00000000}, {210,0.00010526}, {211,0.00010526}, {212,0.00020175}, {213,0.00006140}, {214,0.00013158}, {215,0.00010526}, {216,0.00015789}, {217,0.00009649}, {218,0.00009649}, {219,0.00016667}, {220,0.00007018}, {221,0.00017544}, {222,0.00012281}, {223,0.00015789}, {224,0.00007018}, {225,0.00017544}, {226,0.00007018}, {227,0.00014035}, {228,0.00010526}, {229,0.00015789}, {230,0.00013158}, {231,0.00000000}, {232,0.00003509}, {233,0.00010526}, {234,0.00010526}, {235,0.00003509}, {236,0.00003509}, {237,0.00003509}, {238,0.00002632}, {239,0.00003509}, {240,0.00010526}, {241,0.00007018}, {242,0.00000000}, {243,0.00011404}, {244,0.00003509}, {245,0.00013158}, {246,0.00006140}, {247,0.00034211}, {248,0.00010526}, {249,0.00003509}, {250,0.00006140}, {251,0.00017544}, {252,0.00003509}, {253,0.00033333}, {254,0.00016667}, {255,0.00002632}, {256,0.00003509}, {257,0.00003509}, {258,0.00000000}, {259,0.00016667}, {260,0.00010526}, {261,0.00000000}, {262,0.00003509}, {263,0.00009649}, {264,0.00030702}, {265,0.00020175}, {266,0.00007018}, {267,0.00007018}, {268,0.00007018}, {269,0.00023684}, {270,0.00009649}, {271,0.00000000}, {272,0.00000000}, {273,0.00036842}, {274,0.00014035}, {275,0.00003509}, {276,0.00006140}, {277,0.00042105}, {278,0.00010526}, {279,0.00010526}, {280,0.00003509}, {281,0.00003509}, {282,0.00002632}, {283,0.00010526}, {284,0.00033333}, {285,0.00000000}, {286,0.00007018}, {287,0.00032456}, {288,0.00009649}, {289,0.00010526}, {290,0.00022807}, {291,0.00007018}, {292,0.00013158}, {293,0.00024561}, {294,0.00003509}, {295,0.00007018}, {296,0.00003509}, {297,0.00003509}, {298,0.00045614}, {299,0.00010526}, {300,0.00014035}, {301,0.00036842}, {302,0.00003509}, {303,0.00028070}, {304,0.00000000}, {305,0.00016667}, {306,0.00000000}, {307,0.00000000}, {308,0.00040351}, {309,0.00003509}, {310,0.00031579}, {311,0.00007018}, {312,0.00028070}, {313,0.00017544}, {314,0.00037719}, {315,0.00003509}, {316,0.00000000}, {317,0.00003509}, {318,0.00003509}, {319,0.00000000}, {320,0.00013158}, {321,0.00003509}, {322,0.00002632}, {323,0.00003509}, {324,0.00003509}, {325,0.00000000}, {326,0.00010526}, {327,0.00010526}, {328,0.00013158}, {329,0.00000000}, {330,0.00003509}, {331,0.00000000}, {332,0.00006140}, {333,0.00002632}, {334,0.00000000}, {335,0.00003509}, {336,0.00010526}, {337,0.00007018}, {338,0.00003509}, {339,0.00014035}, {340,0.00006140}, {341,0.00016667}, {342,0.00007018}, {343,0.00007018}, {344,0.00003509}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00007018}, {349,0.00002632}, {350,0.00007018}, {351,0.00003509}, {352,0.00003509}, {353,0.00007018}, {354,0.00003509}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00007018}, {359,0.00006140}, {360,0.00003509}, {361,0.00003509}, {362,0.00000000}, {363,0.00003509}, {364,0.00000000}, {365,0.00007018}, {366,0.00014035}, {367,0.00007018}, {368,0.00014035}, {369,0.00007018}, {370,0.00003509}, {371,0.00009649}, {372,0.00003509}, {373,0.00003509}, {374,0.00007018}, {375,0.00003509}, {376,0.00006140}, {377,0.00000000}, {378,0.00000000}, {379,0.00002632}, {380,0.00007018}, {381,0.00000000}, {382,0.00003509}, {383,0.00010526}, {384,0.00007018}, {385,0.00011404}, {386,0.00005263}, {387,0.00003509}, {388,0.00010526}, {389,0.00003509}, {390,0.00003509}, {391,0.00010526}, {392,0.00000000}, {393,0.00003509}, {394,0.00003509}, {395,0.00003509}, {396,0.00007018}, {397,0.00007018}, {398,0.00003509}, {399,0.00003509}, {400,0.00003509}, {401,0.00003509}, {402,0.00007018}, {403,0.00000000}, {404,0.00010526}, {405,0.00003509}, {406,0.00037719}, {407,0.00014035}, {408,0.00013158}, {409,0.00017544}, {410,0.00014035}, {411,0.00027193}, {412,0.00003509}, {413,0.00020175}, {414,0.00017544}, {415,0.00017544}, {416,0.00009649}, {417,0.00021053}, {418,0.00013158}, {419,0.00003509}, {420,0.00010526}, {421,0.00010526}, {422,0.00003509}, {423,0.00014035}, {424,0.00003509}, {425,0.00010526}, {426,0.00017544}, {427,0.00007018}, {428,0.00003509}, {429,0.00003509}, {430,0.00014035}, {431,0.00003509}, {432,0.00003509}, {433,0.00000000}, {434,0.00000000}, {435,0.00002632}, {436,0.00007018}, {437,0.00021053}, {438,0.00013158}, {439,0.00013158}, {440,0.00000000}, {441,0.00000000}, {442,0.00003509}, {443,0.00014035}, {444,0.00010526}, {445,0.00010526}, {446,0.00010526}, {447,0.00003509}, {448,0.00010526}, {449,0.00000000}, {450,0.00000000}, {451,0.00003509}, {452,0.00007018}, {453,0.00009649}, {454,0.00003509}, {455,0.00000000}, {456,0.00007018}, {457,0.00002632}, {458,0.00003509}, {459,0.00003509}, {460,0.00006140}, {461,0.00002632}, {462,0.00000000}, {463,0.00012281}, {464,0.00014035}, {465,0.00014035}, {466,0.00000000}, {467,0.00000000}, {468,0.00013158}, {469,0.00003509}, {470,0.00007018}, {471,0.00000000}, {472,0.00007018}, {473,0.00010526}, {474,0.00009649}, {475,0.00014035}, {476,0.00007018}, {477,0.00009649}, {478,0.00003509}, {479,0.00003509}, {480,0.00000000}, {481,0.00010526}, {482,0.00003509}, {483,0.00010526}, {484,0.00009649}, {485,0.00000000}, {486,0.00000000}, {487,0.00010526}, {488,0.00003509}, {489,0.00010526}, {490,0.00007018}, {491,0.00003509}, {492,0.00007018}, {493,0.00000000}, {494,0.00000000}, {495,0.00003509}, {496,0.00003509}, {497,0.00003509}, {498,0.00013158}, {499,0.00003509}, {500,0.00003509}, {505,0.00003509}, {510,0.00000000}, {515,0.00014035}, {520,0.00020175}, {525,0.00007018}, {530,0.00003509}, {535,0.00000000}, {540,0.00002632}, {545,0.00000000}, {550,0.00010526}, {555,0.00007018}, {560,0.00010526}, {565,0.00003509}, {570,0.00000000}, {575,0.00003509}, {580,0.00003509}, {585,0.00003509}, {590,0.00000000}, {595,0.00003509}, {600,0.00013158}, {605,0.00009649}, {610,0.00010526}, {615,0.00010526}, {620,0.00003509}, {625,0.00023684}, {630,0.00007018}, {635,0.00010526}, {640,0.00009649}, {645,0.00009649}, {650,0.00014035}, {655,0.00003509}, {660,0.00007018}, {665,0.00003509}, {670,0.00007018}, {675,0.00003509}, {680,0.00007018}, {685,0.00007018}, {690,0.00000000}, {695,0.00000000}, {700,0.00012281}, {705,0.00006140}, {710,0.00017544}, {715,0.00006140}, {720,0.00000000}, {725,0.00003509}, {730,0.00003509}, {735,0.00000000}, {740,0.00010526}, {745,0.00006140}, {750,0.00003509}, {755,0.00010526}, {760,0.00003509}, {765,0.00007018}, {770,0.00007018}, {775,0.00006140}, {780,0.00003509}, {785,0.00007018}, {790,0.00010526}, {795,0.00003509}, {800,0.00007018}, {805,0.00007018}, {810,0.00007018}, {815,0.00002632}, {820,0.00007018}, {825,0.00006140}, {830,0.00007018}, {835,0.00007018}, {840,0.00014035}, {845,0.00010526}, {850,0.00010526}, {855,0.00007018}, {860,0.00007018}, {865,0.00014035}, {870,0.00009649}, {875,0.00007018}, {880,0.00006140}, {885,0.00014035}, {890,0.00003509}, {895,0.00000000}, {900,0.00012281}, {905,0.00007018}, {910,0.00016667}, {915,0.00000000}, {920,0.00010526}, {925,0.00010526}, {930,0.00000000}, {935,0.00000000}, {940,0.00014035}, {945,0.00014035}, {950,0.00010526}, {955,0.00007018}, {960,0.00011404}, {965,0.00021053}, {970,0.00010526}, {975,0.00017544}, {980,0.00006140}, {985,0.00014035}, {990,0.00006140}, {995,0.00010526}, {1000,0.00007018}, {1010,0.00003509}, {1020,0.00010526}, {1030,0.00014035}, {1040,0.00010526}, {1050,0.00028070}, {1060,0.00002632}, {1070,0.00003509}, {1080,0.00013158}, {1090,0.00003509}, {1100,0.00009649}, {1110,0.00010526}, {1120,0.00003509}, {1130,0.00017544}, {1140,0.00014035}, {1150,0.00003509}, {1160,0.00014035}, {1170,0.00003509}, {1180,0.00013158}, {1190,0.00009649}, {1200,0.00014035}, {1210,0.00008772}, {1220,0.00017544}, {1230,0.00007018}, {1240,0.00013158}, {1250,0.00013158}, {1260,0.00003509}, {1270,0.00003509}, {1280,0.00010526}, {1290,0.00007018}, {1300,0.00006140}, {1310,0.00017544}, {1320,0.00009649}, {1330,0.00014035}, {1340,0.00002632}, {1350,0.00003509}, {1360,0.00007018}, {1370,0.00024561}, {1380,0.00013158}, {1390,0.00043860}, {1400,0.00071930}, {1410,0.00069298}, {1420,0.00010526}, {1430,0.00003509}, {1440,0.00010526}, {1450,0.00007018}, {1460,0.00010526}, {1470,0.00007018}, {1480,0.00014035}, {1490,0.00006140}, {1500,0.00009649}, {1510,0.00010526}, {1520,0.00017544}, {1530,0.00000000}, {1540,0.00014035}, {1550,0.00003509}, {1560,0.00002632}, {1570,0.00017544}, {1580,0.00007018}, {1590,0.00010526}, {1600,0.00006140}, {1610,0.00007018}, {1620,0.00007018}, {1630,0.00006140}, {1640,0.00007018}, {1650,0.00010526}, {1660,0.00014035}, {1670,0.00010526}, {1680,0.00021053}, {1690,0.00003509}, {1700,0.00010526}, {1710,0.00014035}, {1720,0.00020175}, {1730,0.00014035}, {1740,0.00000000}, {1750,0.00014035}, {1760,0.00024561}, {1770,0.00010526}, {1780,0.00007018}, {1790,0.00007018}, {1800,0.00007018}, {1810,0.00009649}, {1820,0.00007018}, {1830,0.00010526}, {1840,0.00010526}, {1850,0.00017544}, {1860,0.00003509}, {1870,0.00000000}, {1880,0.00014035}, {1890,0.00014035}, {1900,0.00017544}, {1910,0.00007018}, {1920,0.00014035}, {1930,0.00017544}, {1940,0.00010526}, {1950,0.00013158}, {1960,0.00020175}, {1970,0.00014035}, {1980,0.00006140}, {1990,0.00006140}, {2000,0.00003509}, {2050,0.00013158}, {2100,0.00014035}, {2150,0.00021053}, {2200,0.00010526}, {2250,0.00017544}, {2300,0.00014035}, {2350,0.00014035}, {2400,0.00014035}, {2450,0.00010526}, {2500,0.00014035}, {2550,0.00021053}, {2600,0.00007018}, {2650,0.00003509}, {2700,0.00003509}, {2750,0.00003509}, {2800,0.00009649}, {2850,0.00007018}, {2900,0.00021053}, {2950,0.00010526}, {3000,0.00024561}, {3050,0.00017544}, {3100,0.00022807}, {3150,0.00010526}, {3200,0.00038596}, {3250,0.00013158}, {3300,0.00007018}, {3350,0.00000000}, {3400,0.00013158}, {3450,0.00010526}, {3500,0.00000000}, {3550,0.00016667}, {3600,0.00033333}, {3650,0.00021053}, {3700,0.00029825}, {3750,0.00010526}, {3800,0.00014035}, {3850,0.00014035}, {3900,0.00017544}, {3950,0.00028070}, {4000,0.00014035}, {4050,0.00021053}, {4100,0.00021053}, {4150,0.00053509}, {4200,0.00017544}, {4250,0.00017544}, {4300,0.00007018}, {4350,0.00023684}, {4400,0.00014035}, {4450,0.00016667}, {4500,0.00014035}, {4550,0.00024561}, {4600,0.00016667}, {4650,0.00178070}, {4700,0.00021053}, {4750,0.00020175}, {4800,0.00010526}, {4850,0.00013158}, {4900,0.00014035}, {4950,0.00037719}, {5000,0.00014035}, {5050,0.00013158}, {5100,0.00023684}, {5150,0.00014035}, {5200,0.00024561}, {5250,0.00013158}, {5300,0.00020175}, {5350,0.00048246}, {5400,0.00030702}, {5450,0.00017544}, {5500,0.00030702}, {5550,0.00052632}, {5600,0.00224561}, {5650,0.00031579}, {5700,0.00010526}, {5750,0.00017544}, {5800,0.00014035}, {5850,0.00023684}, {5900,0.00010526}, {5950,0.00037719}, {6000,0.00017544}, {6050,0.006071}, {6100,0.003357}, {6150,0.002357}, {6200,0.000000}, {6250,0.000000}, {6300,0.000571}, {6350,0.000286}, {6400,0.000000}, {6450,0.000286}, {6500,0.000286}, {6550,0.000286}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000286}, {6800,0.000000}, {6850,0.000286}, {6900,0.000286}, {6950,0.000000}, {7000,0.000286}, {7050,0.000286}, {7100,0.000571}, {7150,0.000286}, {7200,0.000286}, {7250,0.000000}, {7300,0.000000}, {7350,0.000857}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000571}, {7600,0.000000}, {7650,0.000500}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000571}, {7900,0.000000}, {7950,0.000000}, {8000,0.000286}, {8050,0.000286}, {8100,0.000000}, {8150,0.000286}, {8200,0.000000}, {8250,0.000000}, {8300,0.000214}, {8350,0.000000}, {8400,0.000000}, {8450,0.000857}, {8500,0.000000}, {8550,0.000286}, {8600,0.000286}, {8650,0.000214}, {8700,0.000571}, {8750,0.000286}, {8800,0.000000}, {8850,0.000286}, {8900,0.000571}, {8950,0.000571}, {9000,0.000571}, {9050,0.000286}, {9100,0.000000}, {9150,0.000286}, {9200,0.000286}, {9250,0.000000}, {9300,0.000286}, {9350,0.000000}, {9400,0.000286}, {9450,0.000571}, {9500,0.000286}, {9550,0.000000}, {9600,0.000000}, {9650,0.000857}, {9700,0.000286}, {9750,0.000000}, {9800,0.000500}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000571}, {10300,0.001143}, {10400,0.000857}, {10500,0.000000}, {10600,0.000571}, {10700,0.000571}, {10800,0.000571}, {10900,0.000000}, {11000,0.000286}, {11100,0.000286}, {11200,0.000571}, {11300,0.001143}, {11400,0.000286}, {11500,0.000286}, {11600,0.000571}, {11700,0.000000}, {11800,0.000286}, {11900,0.000286}, {12000,0.000000}, {12100,0.000286}, {12200,0.001143}, {12300,0.000000}, {12400,0.000286}, {12500,0.000000}, {12600,0.000000}, {12700,0.000286}, {12800,0.000286}, {12900,0.000286}, {13000,0.000286}, {13100,0.001071}, {13200,0.000286}, {13300,0.000286}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000857}, {13800,0.002000}, {13900,0.002857}, {14000,0.000786}, {14100,0.000286}, {14200,0.000286}, {14300,0.002000}, {14400,0.000000}, {14500,0.000286}, {14600,0.001714}, {14700,0.000857}, {14800,0.000857}, {14900,0.000571}, {15000,0.000000}, {15100,0.001429}, {15200,0.000286}, {15300,0.000000}, {15400,0.001429}, {15500,0.000000}, {15600,0.000857}, {15700,0.000571}, {15800,0.001143}, {15900,0.000571}, {16000,0.000571}, {16100,0.003143}, {16200,0.000000}, {16300,0.000000}, {16400,0.000286}, {16500,0.001143}, {16600,0.003143}, {16700,0.000857}, {16800,0.000286}, {16900,0.001643}, {17000,0.000571}, {17100,0.001143}, {17200,0.001429}, {17300,0.000000}, {17400,0.000286}, {17500,0.000286}, {17600,0.000286}, {17700,0.000571}, {17800,0.001643}, {17900,0.001071}, {18000,0.002857}, {18100,0.002286}, {18200,0.000286}, {18300,0.003429}, {18400,0.001857}, {18500,0.001429}, {18600,0.001429}, {18700,0.001143}, {18800,0.001714}, {18900,0.003071}, {19000,0.002000}, {19100,0.000000}, {19200,0.000571}, {19300,0.000286}, {19400,0.000571}, {19500,0.000571}, {19600,0.001429}, {19700,0.000857}, {19800,0.001143}, {19900,0.001143}, {20000,0.000571}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00016667}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00100000}, {16,0.00100000}, {17,0.00101754}, {18,0.00115789}, {19,0.00200000}, {20,0.00200000}, {21,0.00200000}, {22,0.00200000}, {23,0.00200000}, {24,0.00200000}, {25,0.00200000}, {26,0.00215789}, {27,0.00245614}, {28,0.00234211}, {29,0.00300000}, {30,0.00300877}, {31,0.00300000}, {32,0.00300000}, {33,0.00300000}, {34,0.00303509}, {35,0.00428070}, {36,0.00326316}, {37,0.00392982}, {38,0.00400000}, {39,0.00400000}, {40,0.00400000}, {41,0.00400877}, {42,0.00402632}, {43,0.00435088}, {44,0.00422807}, {45,0.00463158}, {46,0.00498246}, {47,0.00500000}, {48,0.00499123}, {49,0.00500000}, {50,0.00501754}, {51,0.00523684}, {52,0.00521053}, {53,0.00520175}, {54,0.00566667}, {55,0.00600000}, {56,0.00682456}, {57,0.00600000}, {58,0.00605263}, {59,0.00621930}, {60,0.00613158}, {61,0.00630702}, {62,0.00664912}, {63,0.00700877}, {64,0.00702632}, {65,0.00700000}, {66,0.00700000}, {67,0.00729825}, {68,0.00714035}, {69,0.00732456}, {70,0.00742105}, {71,0.00916667}, {72,0.00725439}, {73,0.00804386}, {74,0.00809649}, {75,0.00821930}, {76,0.00811404}, {77,0.00826316}, {78,0.00842105}, {79,0.00909649}, {80,0.00821930}, {81,0.00892982}, {82,0.00919298}, {83,0.00909649}, {84,0.00908772}, {85,0.00928070}, {86,0.01121930}, {87,0.01009649}, {88,0.00914912}, {89,0.01003509}, {90,0.01014035}, {91,0.01020175}, {92,0.01012281}, {93,0.01046491}, {94,0.01060526}, {95,0.01114035}, {96,0.01013158}, {97,0.01049123}, {98,0.01091228}, {99,0.01121053}, {100,0.01114035}, {101,0.01285088}, {102,0.01121053}, {103,0.01207018}, {104,0.01115789}, {105,0.01185965}, {106,0.01205263}, {107,0.01228947}, {108,0.01219298}, {109,0.01237719}, {110,0.01251754}, {111,0.01315789}, {112,0.01223684}, {113,0.01256140}, {114,0.01384211}, {115,0.01353509}, {116,0.01435088}, {117,0.01331579}, {118,0.01524561}, {119,0.01414912}, {120,0.01323684}, {121,0.01422807}, {122,0.01410526}, {123,0.01437719}, {124,0.01436842}, {125,0.01468421}, {126,0.01487719}, {127,0.01525439}, {128,0.01428947}, {129,0.01540351}, {130,0.01452632}, {131,0.01538596}, {132,0.01468421}, {133,0.01528070}, {134,0.01538596}, {135,0.01627193}, {136,0.01735965}, {137,0.01579825}, {138,0.01592982}, {139,0.01661404}, {140,0.01617544}, {141,0.01897368}, {142,0.01669298}, {143,0.01729825}, {144,0.01792982}, {145,0.01663158}, {146,0.01673684}, {147,0.01736842}, {148,0.01709649}, {149,0.01756140}, {150,0.01784211}, {151,0.01825439}, {152,0.01729825}, {153,0.01811404}, {154,0.01815789}, {155,0.01882456}, {156,0.01828070}, {157,0.01914035}, {158,0.01926316}, {159,0.02260526}, {160,0.01818421}, {161,0.01844737}, {162,0.01865789}, {163,0.01935965}, {164,0.01890351}, {165,0.01952632}, {166,0.02215789}, {167,0.02035965}, {168,0.01932456}, {169,0.02012281}, {170,0.02250000}, {171,0.02095614}, {172,0.02031579}, {173,0.02113158}, {174,0.02321930}, {175,0.02176316}, {176,0.02031579}, {177,0.02089474}, {178,0.02108772}, {179,0.02407018}, {180,0.02130702}, {181,0.02202632}, {182,0.02210526}, {183,0.02275439}, {184,0.02152632}, {185,0.02427193}, {186,0.02246491}, {187,0.02330702}, {188,0.02300877}, {189,0.02357018}, {190,0.02336842}, {191,0.02430702}, {192,0.02235965}, {193,0.02261404}, {194,0.02260526}, {195,0.02340351}, {196,0.02287719}, {197,0.02364912}, {198,0.02387719}, {199,0.02626316}, {200,0.02600000}, {201,0.02415789}, {202,0.02424561}, {203,0.02499123}, {204,0.02464912}, {205,0.02543860}, {206,0.02537719}, {207,0.02617544}, {208,0.02421053}, {209,0.02508772}, {210,0.02510526}, {211,0.02728947}, {212,0.02777193}, {213,0.03017544}, {214,0.02895614}, {215,0.02971930}, {216,0.02807018}, {217,0.02852632}, {218,0.02969298}, {219,0.03041228}, {220,0.02909649}, {221,0.03066667}, {222,0.02998246}, {223,0.03124561}, {224,0.02755263}, {225,0.02947368}, {226,0.02928947}, {227,0.03025439}, {228,0.02946491}, {229,0.03051754}, {230,0.02836842}, {231,0.02939474}, {232,0.02782456}, {233,0.02844737}, {234,0.02890351}, {235,0.02960526}, {236,0.02946491}, {237,0.02987719}, {238,0.02995614}, {239,0.03705263}, {240,0.03014035}, {241,0.03191228}, {242,0.02947368}, {243,0.03045614}, {244,0.02990351}, {245,0.03065789}, {246,0.03095614}, {247,0.03191228}, {248,0.03212281}, {249,0.03273684}, {250,0.03136842}, {251,0.03214035}, {252,0.03188596}, {253,0.03834211}, {254,0.03413158}, {255,0.03354386}, {256,0.02976316}, {257,0.03085965}, {258,0.03109649}, {259,0.03444737}, {260,0.03307018}, {261,0.03238596}, {262,0.03271930}, {263,0.03334211}, {264,0.03172807}, {265,0.03452632}, {266,0.03306140}, {267,0.03374561}, {268,0.03317544}, {269,0.04014912}, {270,0.03531579}, {271,0.03535088}, {272,0.03257018}, {273,0.03900000}, {274,0.03559649}, {275,0.03485088}, {276,0.03399123}, {277,0.04281579}, {278,0.03634211}, {279,0.03666667}, {280,0.03427193}, {281,0.03771053}, {282,0.03585088}, {283,0.03666667}, {284,0.04267544}, {285,0.03745614}, {286,0.03738596}, {287,0.04351754}, {288,0.03445614}, {289,0.03602632}, {290,0.03694737}, {291,0.03673684}, {292,0.03626316}, {293,0.04232456}, {294,0.03686842}, {295,0.03828947}, {296,0.03679825}, {297,0.03737719}, {298,0.04285965}, {299,0.03850000}, {300,0.03818421}, {301,0.04492982}, {302,0.03894737}, {303,0.04489474}, {304,0.03692105}, {305,0.04312281}, {306,0.03898246}, {307,0.03993860}, {308,0.04332456}, {309,0.03962281}, {310,0.04453509}, {311,0.04118421}, {312,0.04346491}, {313,0.04071053}, {314,0.04540351}, {315,0.04191228}, {316,0.04508772}, {317,0.04228070}, {318,0.04629825}, {319,0.04365789}, {320,0.03840351}, {321,0.03927193}, {322,0.04428070}, {323,0.04073684}, {324,0.04463158}, {325,0.04149123}, {326,0.04617544}, {327,0.04264912}, {328,0.04512281}, {329,0.04124561}, {330,0.04617544}, {331,0.04266667}, {332,0.04166667}, {333,0.04291228}, {334,0.04306140}, {335,0.04878947}, {336,0.04150877}, {337,0.04721930}, {338,0.04238596}, {339,0.04790351}, {340,0.04758772}, {341,0.04428070}, {342,0.04868421}, {343,0.04582456}, {344,0.04338596}, {345,0.04896491}, {346,0.04437719}, {347,0.04591228}, {348,0.04828947}, {349,0.04598246}, {350,0.04617544}, {351,0.05311404}, {352,0.04697368}, {353,0.04377193}, {354,0.05014912}, {355,0.04544737}, {356,0.04407018}, {357,0.04969298}, {358,0.04612281}, {359,0.04768421}, {360,0.04826316}, {361,0.05042982}, {362,0.04590351}, {363,0.05188596}, {364,0.05056140}, {365,0.04764035}, {366,0.04773684}, {367,0.04937719}, {368,0.04864035}, {369,0.05092982}, {370,0.04673684}, {371,0.04864035}, {372,0.05096491}, {373,0.05208772}, {374,0.05577193}, {375,0.05062281}, {376,0.04732456}, {377,0.04930702}, {378,0.05320175}, {379,0.05411404}, {380,0.05271930}, {381,0.05627193}, {382,0.05076316}, {383,0.05308772}, {384,0.04590351}, {385,0.04766667}, {386,0.05296491}, {387,0.04907895}, {388,0.04734211}, {389,0.04957018}, {390,0.05422807}, {391,0.05428947}, {392,0.05607018}, {393,0.04997368}, {394,0.04987719}, {395,0.05515789}, {396,0.05385965}, {397,0.05529825}, {398,0.05585088}, {399,0.05935088}, {400,0.04963158}, {401,0.05107895}, {402,0.05043860}, {403,0.05614035}, {404,0.05434211}, {405,0.05672807}, {406,0.05641228}, {407,0.05786842}, {408,0.05391228}, {409,0.05787719}, {410,0.06064035}, {411,0.06250000}, {412,0.06053509}, {413,0.06336842}, {414,0.06186842}, {415,0.06007018}, {416,0.05357018}, {417,0.05619298}, {418,0.05915789}, {419,0.05421053}, {420,0.05242982}, {421,0.05445614}, {422,0.05410526}, {423,0.05650877}, {424,0.06331579}, {425,0.06371930}, {426,0.06302632}, {427,0.06379825}, {428,0.05884211}, {429,0.06083333}, {430,0.05973684}, {431,0.06171053}, {432,0.05383333}, {433,0.05577193}, {434,0.05617544}, {435,0.05814035}, {436,0.05592105}, {437,0.06556140}, {438,0.06535088}, {439,0.06305263}, {440,0.05606140}, {441,0.05819298}, {442,0.05844737}, {443,0.06801754}, {444,0.06179825}, {445,0.06293860}, {446,0.05991228}, {447,0.07007018}, {448,0.05646491}, {449,0.06043860}, {450,0.05935965}, {451,0.06163158}, {452,0.05731579}, {453,0.05822807}, {454,0.05907018}, {455,0.07130702}, {456,0.06260526}, {457,0.06223684}, {458,0.06237719}, {459,0.06142105}, {460,0.05977193}, {461,0.06818421}, {462,0.06382456}, {463,0.06290351}, {464,0.06514912}, {465,0.06415789}, {466,0.06318421}, {467,0.06199123}, {468,0.06057018}, {469,0.06850000}, {470,0.06429825}, {471,0.06364035}, {472,0.06778947}, {473,0.06482456}, {474,0.06234211}, {475,0.07191228}, {476,0.06470175}, {477,0.06443860}, {478,0.07118421}, {479,0.06602632}, {480,0.06671930}, {481,0.06635965}, {482,0.06133333}, {483,0.06371053}, {484,0.07139474}, {485,0.06663158}, {486,0.06367544}, {487,0.06890351}, {488,0.06238596}, {489,0.07181579}, {490,0.06664035}, {491,0.06609649}, {492,0.06680702}, {493,0.06617544}, {494,0.07471053}, {495,0.06849123}, {496,0.06964035}, {497,0.06518421}, {498,0.07247368}, {499,0.06921053}, {500,0.07255263}, {505,0.07023684}, {510,0.07811404}, {515,0.06642105}, {520,0.07183333}, {525,0.07178947}, {530,0.07575439}, {535,0.07660526}, {540,0.08086842}, {545,0.08024561}, {550,0.07540351}, {555,0.08254386}, {560,0.07999123}, {565,0.07830702}, {570,0.08519298}, {575,0.08997368}, {580,0.08177193}, {585,0.08485965}, {590,0.08752632}, {595,0.08697368}, {600,0.08663158}, {605,0.08376316}, {610,0.08809649}, {615,0.09235965}, {620,0.09089474}, {625,0.09428947}, {630,0.09760526}, {635,0.09822807}, {640,0.08821930}, {645,0.08567544}, {650,0.09421053}, {655,0.09877193}, {660,0.09514035}, {665,0.09152632}, {670,0.10033333}, {675,0.09978070}, {680,0.08935965}, {685,0.10202632}, {690,0.10101754}, {695,0.10574561}, {700,0.10850000}, {705,0.10343860}, {710,0.09588596}, {715,0.10758772}, {720,0.10213158}, {725,0.10828070}, {730,0.10829825}, {735,0.11350877}, {740,0.10614912}, {745,0.11053509}, {750,0.11428947}, {755,0.11498246}, {760,0.11171053}, {765,0.11737719}, {770,0.11078070}, {775,0.11339474}, {780,0.11129825}, {785,0.11314035}, {790,0.11397368}, {795,0.11932456}, {800,0.11126316}, {805,0.11650000}, {810,0.11742982}, {815,0.12498246}, {820,0.11869298}, {825,0.12192105}, {830,0.12968421}, {835,0.12266667}, {840,0.11909649}, {845,0.12566667}, {850,0.12042982}, {855,0.13086842}, {860,0.12703509}, {865,0.12514035}, {870,0.13516667}, {875,0.13244737}, {880,0.12552632}, {885,0.13730702}, {890,0.13430702}, {895,0.15121053}, {900,0.13562281}, {905,0.13029825}, {910,0.14175439}, {915,0.13498246}, {920,0.13105263}, {925,0.14643860}, {930,0.13438596}, {935,0.14469298}, {940,0.14046491}, {945,0.13850000}, {950,0.15186842}, {955,0.15483333}, {960,0.13357895}, {965,0.14814035}, {970,0.14958772}, {975,0.15646491}, {980,0.14654386}, {985,0.14731579}, {990,0.15185088}, {995,0.15458772}, {1000,0.15240351}, {1010,0.15741228}, {1020,0.15418421}, {1030,0.15437719}, {1040,0.15108772}, {1050,0.16503509}, {1060,0.15116667}, {1070,0.16064912}, {1080,0.15764035}, {1090,0.15542982}, {1100,0.16616667}, {1110,0.17168421}, {1120,0.15764912}, {1130,0.17916667}, {1140,0.17713158}, {1150,0.18707018}, {1160,0.16345614}, {1170,0.17560526}, {1180,0.18062281}, {1190,0.18407895}, {1200,0.17210526}, {1210,0.18601754}, {1220,0.18299123}, {1230,0.19352632}, {1240,0.18826316}, {1250,0.19001754}, {1260,0.19555263}, {1270,0.19407895}, {1280,0.17715789}, {1290,0.18623684}, {1300,0.19409649}, {1310,0.20480702}, {1320,0.19447368}, {1330,0.19542982}, {1340,0.20948246}, {1350,0.20927193}, {1360,0.20016667}, {1370,0.20719298}, {1380,0.20843860}, {1390,0.22058772}, {1400,0.21431579}, {1410,0.20706140}, {1420,0.21899123}, {1430,0.22139474}, {1440,0.21146491}, {1450,0.22189474}, {1460,0.22398246}, {1470,0.23659649}, {1480,0.23115789}, {1490,0.22901754}, {1500,0.23544737}, {1510,0.23707018}, {1520,0.22957895}, {1530,0.24240351}, {1540,0.23035088}, {1550,0.23456140}, {1560,0.23036842}, {1570,0.22975439}, {1580,0.23605263}, {1590,0.24376316}, {1600,0.22959649}, {1610,0.24197368}, {1620,0.24235965}, {1630,0.25450000}, {1640,0.24421930}, {1650,0.25789474}, {1660,0.27321930}, {1670,0.25692982}, {1680,0.24232456}, {1690,0.25466667}, {1700,0.24598246}, {1710,0.27701754}, {1720,0.26253509}, {1730,0.26308772}, {1740,0.26384211}, {1750,0.26946491}, {1760,0.26326316}, {1770,0.28125439}, {1780,0.28177193}, {1790,0.29490351}, {1800,0.25725439}, {1810,0.27184211}, {1820,0.28151754}, {1830,0.27576316}, {1840,0.26575439}, {1850,0.29021930}, {1860,0.28985088}, {1870,0.29779825}, {1880,0.29100877}, {1890,0.28806140}, {1900,0.28994737}, {1910,0.31547368}, {1920,0.28142982}, {1930,0.28657018}, {1940,0.29231579}, {1950,0.30983333}, {1960,0.30041228}, {1970,0.30383333}, {1980,0.30780702}, {1990,0.30526316}, {2000,0.30891228}, {2050,0.30073684}, {2100,0.31751754}, {2150,0.33240351}, {2200,0.33905263}, {2250,0.35502632}, {2300,0.36826316}, {2350,0.37246491}, {2400,0.37642982}, {2450,0.37137719}, {2500,0.38593860}, {2550,0.41797368}, {2600,0.39490351}, {2650,0.41878070}, {2700,0.41450000}, {2750,0.46237719}, {2800,0.43853509}, {2850,0.43322807}, {2900,0.46026316}, {2950,0.45951754}, {3000,0.47587719}, {3050,0.49776316}, {3100,0.48036842}, {3150,0.49721053}, {3200,0.47008772}, {3250,0.51585965}, {3300,0.52480702}, {3350,0.53202632}, {3400,0.52239474}, {3450,0.58449123}, {3500,0.56314912}, {3550,0.61057895}, {3600,0.54061404}, {3650,0.56116667}, {3700,0.60058772}, {3750,0.60713158}, {3800,0.61271053}, {3850,0.60447368}, {3900,0.66032456}, {3950,0.66671930}, {4000,0.63843860}, {4050,0.66793860}, {4100,0.62666667}, {4150,0.67200877}, {4200,0.67928947}, {4250,0.68401754}, {4300,0.71221053}, {4350,0.75513158}, {4400,0.69634211}, {4450,0.72811404}, {4500,0.73085965}, {4550,0.75203509}, {4600,0.78463158}, {4650,0.75436842}, {4700,0.78405263}, {4750,0.79842105}, {4800,0.74807018}, {4850,0.82402632}, {4900,0.78420175}, {4950,0.83506140}, {5000,0.80704386}, {5050,0.87916667}, {5100,0.88206140}, {5150,0.87395614}, {5200,0.82678070}, {5250,0.83373684}, {5300,0.88692982}, {5350,0.92013158}, {5400,0.87529825}, {5450,0.90365789}, {5500,0.97064912}, {5550,0.98400877}, {5600,0.93307895}, {5650,0.91926316}, {5700,0.93971930}, {5750,1.01234211}, {5800,0.96101754}, {5850,1.03805263}, {5900,0.98030702}, {5950,1.07304386}, {6000,1.04836842}, {6050,1.058643}, {6100,1.091857}, {6150,1.011929}, {6200,1.047786}, {6250,1.095214}, {6300,1.095929}, {6350,1.126286}, {6400,1.028286}, {6450,1.108071}, {6500,1.116929}, {6550,1.173214}, {6600,1.129429}, {6650,1.248429}, {6700,1.155143}, {6750,1.220857}, {6800,1.150071}, {6850,1.168214}, {6900,1.261786}, {6950,1.215357}, {7000,1.200643}, {7050,1.263357}, {7100,1.329786}, {7150,1.370643}, {7200,1.174286}, {7250,1.240929}, {7300,1.234857}, {7350,1.349857}, {7400,1.325857}, {7450,1.325571}, {7500,1.327214}, {7550,1.460286}, {7600,1.337857}, {7650,1.393000}, {7700,1.316714}, {7750,1.381357}, {7800,1.414000}, {7850,1.421643}, {7900,1.473143}, {7950,1.448857}, {8000,1.332071}, {8050,1.507357}, {8100,1.473786}, {8150,1.562857}, {8200,1.338786}, {8250,1.472143}, {8300,1.489857}, {8350,1.535857}, {8400,1.464714}, {8450,1.408714}, {8500,1.537214}, {8550,1.558571}, {8600,1.546929}, {8650,1.581786}, {8700,1.673429}, {8750,1.597214}, {8800,1.509429}, {8850,1.567071}, {8900,1.572214}, {8950,1.743000}, {9000,1.581786}, {9050,1.692643}, {9100,1.657071}, {9150,1.816357}, {9200,1.733500}, {9250,1.589357}, {9300,1.659643}, {9350,1.653286}, {9400,1.712857}, {9450,1.765786}, {9500,1.710786}, {9550,1.771786}, {9600,1.616643}, {9650,1.806429}, {9700,1.792857}, {9750,1.756357}, {9800,1.709643}, {9850,1.859929}, {9900,1.844000}, {9950,1.938357}, {10000,1.734357}, {10100,1.911929}, {10200,1.899929}, {10300,1.884786}, {10400,1.760929}, {10500,1.779786}, {10600,1.918857}, {10700,1.986143}, {10800,1.892571}, {10900,1.959571}, {11000,2.104929}, {11100,2.136929}, {11200,1.996429}, {11300,1.984929}, {11400,1.992857}, {11500,2.195143}, {11600,2.081000}, {11700,2.229286}, {11800,2.105643}, {11900,2.339286}, {12000,2.204071}, {12100,2.221786}, {12200,2.299000}, {12300,2.128571}, {12400,2.204429}, {12500,2.302214}, {12600,2.321071}, {12700,2.411571}, {12800,2.096786}, {12900,2.355429}, {13000,2.360429}, {13100,2.457357}, {13200,2.402786}, {13300,2.622714}, {13400,2.446571}, {13500,2.611214}, {13600,2.369429}, {13700,2.465214}, {13800,2.622857}, {13900,2.575786}, {14000,2.601214}, {14100,2.588286}, {14200,2.791429}, {14300,2.906071}, {14400,2.426857}, {14500,2.626286}, {14600,2.553286}, {14700,2.833357}, {14800,2.764214}, {14900,3.140000}, {15000,2.798429}, {15100,3.063000}, {15200,2.993357}, {15300,2.908429}, {15400,2.949500}, {15500,2.859571}, {15600,3.028214}, {15700,3.192857}, {15800,3.260357}, {15900,3.042857}, {16000,2.799714}, {16100,3.137786}, {16200,3.076500}, {16300,3.264929}, {16400,2.799714}, {16500,3.121500}, {16600,3.479714}, {16700,3.252571}, {16800,3.035714}, {16900,3.283429}, {17000,3.184286}, {17100,3.343214}, {17200,3.202643}, {17300,3.335071}, {17400,3.546357}, {17500,3.381714}, {17600,3.196929}, {17700,3.447500}, {17800,3.648714}, {17900,3.653786}, {18000,3.322500}, {18100,3.577214}, {18200,3.635000}, {18300,3.845857}, {18400,3.583571}, {18500,3.374929}, {18600,3.634857}, {18700,3.625286}, {18800,3.773357}, {18900,3.784500}, {19000,3.632429}, {19100,3.760071}, {19200,3.469929}, {19300,4.001000}, {19400,3.799357}, {19500,3.742286}, {19600,3.643500}, {19700,3.982786}, {19800,3.912286}, {19900,4.359571}, {20000,3.679357}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["actual reif"]["user"] = {{1,0.00009649}, {2,0.00028947}, {3,0.00021053}, {4,0.00031579}, {5,0.00034211}, {6,0.00064035}, {7,0.00101754}, {8,0.00067544}, {9,0.00070175}, {10,0.00079825}, {11,0.00096491}, {12,0.00101754}, {13,0.00138596}, {14,0.00126316}, {15,0.00132456}, {16,0.00171053}, {17,0.00168421}, {18,0.00182456}, {19,0.00177193}, {20,0.00210526}, {21,0.00164912}, {22,0.00200877}, {23,0.00219298}, {24,0.00213158}, {25,0.00239474}, {26,0.00242105}, {27,0.00255263}, {28,0.00256140}, {29,0.00285965}, {30,0.00300877}, {31,0.00300000}, {32,0.00311404}, {33,0.00321930}, {34,0.00325439}, {35,0.00432456}, {36,0.00329825}, {37,0.00350877}, {38,0.00383333}, {39,0.00413158}, {40,0.00380702}, {41,0.00431579}, {42,0.00430702}, {43,0.00471930}, {44,0.00437719}, {45,0.00444737}, {46,0.00484211}, {47,0.00474561}, {48,0.00433333}, {49,0.00509649}, {50,0.00521930}, {51,0.00537719}, {52,0.00555263}, {53,0.00568421}, {54,0.00592982}, {55,0.00606140}, {56,0.00705263}, {57,0.00598246}, {58,0.00666667}, {59,0.00671053}, {60,0.00680702}, {61,0.00688596}, {62,0.00698246}, {63,0.00717544}, {64,0.00725439}, {65,0.00704386}, {66,0.00719298}, {67,0.00768421}, {68,0.00728947}, {69,0.00778070}, {70,0.00792105}, {71,0.00943860}, {72,0.00791228}, {73,0.00824561}, {74,0.00824561}, {75,0.00885965}, {76,0.00871930}, {77,0.00876316}, {78,0.00858772}, {79,0.00928070}, {80,0.00893860}, {81,0.00886842}, {82,0.00893860}, {83,0.00939474}, {84,0.00919298}, {85,0.00965789}, {86,0.01127193}, {87,0.00981579}, {88,0.00964035}, {89,0.01006140}, {90,0.00985965}, {91,0.01020175}, {92,0.01054386}, {93,0.01071930}, {94,0.01058772}, {95,0.01128947}, {96,0.01057895}, {97,0.01080702}, {98,0.01100877}, {99,0.01135088}, {100,0.01100000}, {101,0.01323684}, {102,0.01147368}, {103,0.01185965}, {104,0.01160526}, {105,0.01206140}, {106,0.01194737}, {107,0.01264912}, {108,0.01249123}, {109,0.01270175}, {110,0.01280702}, {111,0.01336842}, {112,0.01249123}, {113,0.01283333}, {114,0.01407018}, {115,0.01367544}, {116,0.01466667}, {117,0.01370175}, {118,0.01553509}, {119,0.01413158}, {120,0.01369298}, {121,0.01456140}, {122,0.01428947}, {123,0.01487719}, {124,0.01474561}, {125,0.01485965}, {126,0.01492105}, {127,0.01571053}, {128,0.01453509}, {129,0.01584211}, {130,0.01487719}, {131,0.01559649}, {132,0.01503509}, {133,0.01587719}, {134,0.01571930}, {135,0.01650877}, {136,0.01759649}, {137,0.01616667}, {138,0.01627193}, {139,0.01671930}, {140,0.01636842}, {141,0.01886842}, {142,0.01690351}, {143,0.01751754}, {144,0.01810526}, {145,0.01717544}, {146,0.01695614}, {147,0.01747368}, {148,0.01722807}, {149,0.01768421}, {150,0.01785088}, {151,0.01815789}, {152,0.01752632}, {153,0.01803509}, {154,0.01824561}, {155,0.01888596}, {156,0.01819298}, {157,0.01888596}, {158,0.01892105}, {159,0.02250877}, {160,0.01823684}, {161,0.01827193}, {162,0.01855263}, {163,0.01926316}, {164,0.01866667}, {165,0.01930702}, {166,0.02198246}, {167,0.01978947}, {168,0.01902632}, {169,0.01976316}, {170,0.02239474}, {171,0.02094737}, {172,0.02026316}, {173,0.02102632}, {174,0.02314912}, {175,0.02161404}, {176,0.01999123}, {177,0.02036842}, {178,0.02076316}, {179,0.02400000}, {180,0.02112281}, {181,0.02195614}, {182,0.02195614}, {183,0.02303509}, {184,0.02127193}, {185,0.02411404}, {186,0.02217544}, {187,0.02316667}, {188,0.02280702}, {189,0.02346491}, {190,0.02335965}, {191,0.02442982}, {192,0.02221930}, {193,0.02264035}, {194,0.02232456}, {195,0.02323684}, {196,0.02291228}, {197,0.02361404}, {198,0.02408772}, {199,0.02621930}, {200,0.02604386}, {201,0.02425439}, {202,0.02431579}, {203,0.02500000}, {204,0.02455263}, {205,0.02560526}, {206,0.02521930}, {207,0.02611404}, {208,0.02438596}, {209,0.02520175}, {210,0.02514912}, {211,0.02713158}, {212,0.02746491}, {213,0.03042105}, {214,0.02877193}, {215,0.03003509}, {216,0.02792982}, {217,0.02885088}, {218,0.02978947}, {219,0.03051754}, {220,0.02917544}, {221,0.03066667}, {222,0.03014035}, {223,0.03176316}, {224,0.02709649}, {225,0.02940351}, {226,0.02921053}, {227,0.03005263}, {228,0.02938596}, {229,0.03064912}, {230,0.02821053}, {231,0.02919298}, {232,0.02764912}, {233,0.02883333}, {234,0.02902632}, {235,0.02981579}, {236,0.02933333}, {237,0.03020175}, {238,0.03070175}, {239,0.03714912}, {240,0.03034211}, {241,0.03193860}, {242,0.02931579}, {243,0.03059649}, {244,0.02977193}, {245,0.03096491}, {246,0.03141228}, {247,0.03228070}, {248,0.03242982}, {249,0.03282456}, {250,0.03160526}, {251,0.03223684}, {252,0.03226316}, {253,0.03820175}, {254,0.03431579}, {255,0.03382456}, {256,0.02981579}, {257,0.03093860}, {258,0.03147368}, {259,0.03438596}, {260,0.03333333}, {261,0.03268421}, {262,0.03315789}, {263,0.03328947}, {264,0.03211404}, {265,0.03453509}, {266,0.03341228}, {267,0.03421053}, {268,0.03328070}, {269,0.03997368}, {270,0.03521053}, {271,0.03562281}, {272,0.03303509}, {273,0.03831579}, {274,0.03563158}, {275,0.03528070}, {276,0.03437719}, {277,0.04275439}, {278,0.03618421}, {279,0.03659649}, {280,0.03448246}, {281,0.03731579}, {282,0.03603509}, {283,0.03647368}, {284,0.04271053}, {285,0.03743860}, {286,0.03731579}, {287,0.04323684}, {288,0.03456140}, {289,0.03600000}, {290,0.03666667}, {291,0.03649123}, {292,0.03662281}, {293,0.04234211}, {294,0.03708772}, {295,0.03794737}, {296,0.03678947}, {297,0.03739474}, {298,0.04245614}, {299,0.03815789}, {300,0.03786842}, {301,0.04470175}, {302,0.03864912}, {303,0.04442982}, {304,0.03701754}, {305,0.04320175}, {306,0.03868421}, {307,0.03959649}, {308,0.04309649}, {309,0.03921930}, {310,0.04460526}, {311,0.04120175}, {312,0.04329825}, {313,0.04051754}, {314,0.04540351}, {315,0.04188596}, {316,0.04479825}, {317,0.04242105}, {318,0.04637719}, {319,0.04328070}, {320,0.03846491}, {321,0.03917544}, {322,0.04391228}, {323,0.04028947}, {324,0.04458772}, {325,0.04085088}, {326,0.04635088}, {327,0.04242105}, {328,0.04515789}, {329,0.04082456}, {330,0.04627193}, {331,0.04229825}, {332,0.04147368}, {333,0.04286842}, {334,0.04290351}, {335,0.04859649}, {336,0.04086842}, {337,0.04715789}, {338,0.04235088}, {339,0.04791228}, {340,0.04757018}, {341,0.04417544}, {342,0.04842982}, {343,0.04579825}, {344,0.04300877}, {345,0.04871053}, {346,0.04460526}, {347,0.04608772}, {348,0.04814912}, {349,0.04610526}, {350,0.04599123}, {351,0.05285965}, {352,0.04716667}, {353,0.04357895}, {354,0.04957018}, {355,0.04558772}, {356,0.04380702}, {357,0.04946491}, {358,0.04602632}, {359,0.04784211}, {360,0.04816667}, {361,0.05014912}, {362,0.04596491}, {363,0.05176316}, {364,0.05039474}, {365,0.04772807}, {366,0.04801754}, {367,0.04944737}, {368,0.04851754}, {369,0.05089474}, {370,0.04660526}, {371,0.04871053}, {372,0.05050877}, {373,0.05173684}, {374,0.05565789}, {375,0.05051754}, {376,0.04721053}, {377,0.04921930}, {378,0.05273684}, {379,0.05390351}, {380,0.05222807}, {381,0.05625439}, {382,0.05035965}, {383,0.05271053}, {384,0.04592105}, {385,0.04760526}, {386,0.05235965}, {387,0.04884211}, {388,0.04742982}, {389,0.04944737}, {390,0.05406140}, {391,0.05411404}, {392,0.05588596}, {393,0.04991228}, {394,0.04951754}, {395,0.05501754}, {396,0.05321930}, {397,0.05526316}, {398,0.05554386}, {399,0.05953509}, {400,0.04953509}, {401,0.05067544}, {402,0.05038596}, {403,0.05598246}, {404,0.05442982}, {405,0.05680702}, {406,0.05602632}, {407,0.05772807}, {408,0.05357018}, {409,0.05743860}, {410,0.06062281}, {411,0.06250877}, {412,0.06036842}, {413,0.06344737}, {414,0.06205263}, {415,0.06018421}, {416,0.05311404}, {417,0.05582456}, {418,0.05938596}, {419,0.05396491}, {420,0.05192105}, {421,0.05421053}, {422,0.05393860}, {423,0.05643860}, {424,0.06350877}, {425,0.06391228}, {426,0.06314912}, {427,0.06402632}, {428,0.05864035}, {429,0.06075439}, {430,0.05989474}, {431,0.06192982}, {432,0.05351754}, {433,0.05566667}, {434,0.05608772}, {435,0.05832456}, {436,0.05574561}, {437,0.06541228}, {438,0.06513158}, {439,0.06316667}, {440,0.05569298}, {441,0.05835088}, {442,0.05804386}, {443,0.06753509}, {444,0.06221053}, {445,0.06268421}, {446,0.05985088}, {447,0.06979825}, {448,0.05633333}, {449,0.06050000}, {450,0.05936842}, {451,0.06156140}, {452,0.05721053}, {453,0.05817544}, {454,0.05910526}, {455,0.07143860}, {456,0.06248246}, {457,0.06221930}, {458,0.06253509}, {459,0.06153509}, {460,0.05947368}, {461,0.06767544}, {462,0.06368421}, {463,0.06276316}, {464,0.06482456}, {465,0.06390351}, {466,0.06331579}, {467,0.06209649}, {468,0.06065789}, {469,0.06836842}, {470,0.06442105}, {471,0.06352632}, {472,0.06771053}, {473,0.06454386}, {474,0.06233333}, {475,0.07169298}, {476,0.06450000}, {477,0.06444737}, {478,0.07127193}, {479,0.06603509}, {480,0.06641228}, {481,0.06609649}, {482,0.06157895}, {483,0.06364912}, {484,0.07123684}, {485,0.06642105}, {486,0.06371053}, {487,0.06857018}, {488,0.06234211}, {489,0.07201754}, {490,0.06617544}, {491,0.06605263}, {492,0.06635965}, {493,0.06562281}, {494,0.07463158}, {495,0.06835088}, {496,0.06970175}, {497,0.06492982}, {498,0.07247368}, {499,0.06929825}, {500,0.07240351}, {505,0.07011404}, {510,0.07772807}, {515,0.06608772}, {520,0.07170175}, {525,0.07195614}, {530,0.07558772}, {535,0.07612281}, {540,0.08041228}, {545,0.07980702}, {550,0.07516667}, {555,0.08245614}, {560,0.07969298}, {565,0.07798246}, {570,0.08526316}, {575,0.08967544}, {580,0.08186842}, {585,0.08453509}, {590,0.08757018}, {595,0.08679825}, {600,0.08654386}, {605,0.08357895}, {610,0.08786842}, {615,0.09225439}, {620,0.09056140}, {625,0.09398246}, {630,0.09710526}, {635,0.09814035}, {640,0.08789474}, {645,0.08548246}, {650,0.09411404}, {655,0.09853509}, {660,0.09518421}, {665,0.09139474}, {670,0.10021930}, {675,0.09936842}, {680,0.08914035}, {685,0.10151754}, {690,0.10065789}, {695,0.10567544}, {700,0.10828947}, {705,0.10308772}, {710,0.09542982}, {715,0.10724561}, {720,0.10173684}, {725,0.10830702}, {730,0.10782456}, {735,0.11285088}, {740,0.10585965}, {745,0.11071930}, {750,0.11383333}, {755,0.11453509}, {760,0.11120175}, {765,0.11731579}, {770,0.11069298}, {775,0.11305263}, {780,0.11128947}, {785,0.11323684}, {790,0.11389474}, {795,0.11892105}, {800,0.11096491}, {805,0.11614035}, {810,0.11719298}, {815,0.12500000}, {820,0.11863158}, {825,0.12178070}, {830,0.12957018}, {835,0.12233333}, {840,0.11900877}, {845,0.12559649}, {850,0.12008772}, {855,0.13099123}, {860,0.12715789}, {865,0.12507018}, {870,0.13496491}, {875,0.13266667}, {880,0.12548246}, {885,0.13714035}, {890,0.13436842}, {895,0.15135965}, {900,0.13574561}, {905,0.13021930}, {910,0.14155263}, {915,0.13447368}, {920,0.13117544}, {925,0.14620175}, {930,0.13414035}, {935,0.14472807}, {940,0.14033333}, {945,0.13857895}, {950,0.15156140}, {955,0.15484211}, {960,0.13338596}, {965,0.14815789}, {970,0.14957018}, {975,0.15630702}, {980,0.14652632}, {985,0.14685088}, {990,0.15182456}, {995,0.15445614}, {1000,0.15228070}, {1010,0.15705263}, {1020,0.15407895}, {1030,0.15431579}, {1040,0.15068421}, {1050,0.16454386}, {1060,0.15081579}, {1070,0.16024561}, {1080,0.15715789}, {1090,0.15507018}, {1100,0.16572807}, {1110,0.17136842}, {1120,0.15724561}, {1130,0.17887719}, {1140,0.17675439}, {1150,0.18694737}, {1160,0.16312281}, {1170,0.17518421}, {1180,0.18030702}, {1190,0.18366667}, {1200,0.17186842}, {1210,0.18556140}, {1220,0.18244737}, {1230,0.19322807}, {1240,0.18800877}, {1250,0.18965789}, {1260,0.19505263}, {1270,0.19384211}, {1280,0.17684211}, {1290,0.18570175}, {1300,0.19350000}, {1310,0.20424561}, {1320,0.19391228}, {1330,0.19506140}, {1340,0.20913158}, {1350,0.20887719}, {1360,0.19970175}, {1370,0.20648246}, {1380,0.20798246}, {1390,0.21953509}, {1400,0.21363158}, {1410,0.20593860}, {1420,0.21846491}, {1430,0.22080702}, {1440,0.21106140}, {1450,0.22116667}, {1460,0.22338596}, {1470,0.23599123}, {1480,0.23042982}, {1490,0.22864035}, {1500,0.23478070}, {1510,0.23649123}, {1520,0.22900877}, {1530,0.24192105}, {1540,0.22987719}, {1550,0.23425439}, {1560,0.22992105}, {1570,0.22938596}, {1580,0.23569298}, {1590,0.24307018}, {1600,0.22901754}, {1610,0.24107895}, {1620,0.24184211}, {1630,0.25427193}, {1640,0.24366667}, {1650,0.25765789}, {1660,0.27294737}, {1670,0.25670175}, {1680,0.24186842}, {1690,0.25471053}, {1700,0.24573684}, {1710,0.27677193}, {1720,0.26236842}, {1730,0.26285965}, {1740,0.26377193}, {1750,0.26906140}, {1760,0.26276316}, {1770,0.28108772}, {1780,0.28114035}, {1790,0.29447368}, {1800,0.25686842}, {1810,0.27150000}, {1820,0.28163158}, {1830,0.27531579}, {1840,0.26536842}, {1850,0.28992982}, {1860,0.28987719}, {1870,0.29760526}, {1880,0.29062281}, {1890,0.28759649}, {1900,0.28961404}, {1910,0.31515789}, {1920,0.28121053}, {1930,0.28628070}, {1940,0.29189474}, {1950,0.30961404}, {1960,0.29997368}, {1970,0.30346491}, {1980,0.30746491}, {1990,0.30484211}, {2000,0.30828947}, {2050,0.30035088}, {2100,0.31701754}, {2150,0.33187719}, {2200,0.33850000}, {2250,0.35428070}, {2300,0.36740351}, {2350,0.37186842}, {2400,0.37577193}, {2450,0.37060526}, {2500,0.38532456}, {2550,0.41716667}, {2600,0.39442982}, {2650,0.41790351}, {2700,0.41372807}, {2750,0.46135965}, {2800,0.43757018}, {2850,0.43227193}, {2900,0.45920175}, {2950,0.45850000}, {3000,0.47480702}, {3050,0.49719298}, {3100,0.47923684}, {3150,0.49628070}, {3200,0.46919298}, {3250,0.51491228}, {3300,0.52421053}, {3350,0.53164035}, {3400,0.52153509}, {3450,0.58374561}, {3500,0.56238596}, {3550,0.60957895}, {3600,0.53955263}, {3650,0.56051754}, {3700,0.59939474}, {3750,0.60614035}, {3800,0.61193860}, {3850,0.60345614}, {3900,0.65908772}, {3950,0.66550877}, {4000,0.63719298}, {4050,0.66681579}, {4100,0.62583333}, {4150,0.67063158}, {4200,0.67809649}, {4250,0.68269298}, {4300,0.71122807}, {4350,0.75388596}, {4400,0.69492105}, {4450,0.72691228}, {4500,0.72999123}, {4550,0.75066667}, {4600,0.78317544}, {4650,0.75145614}, {4700,0.78228070}, {4750,0.79685088}, {4800,0.74689474}, {4850,0.82273684}, {4900,0.78269298}, {4950,0.83321053}, {5000,0.80567544}, {5050,0.87760526}, {5100,0.88048246}, {5150,0.87215789}, {5200,0.82493860}, {5250,0.83253509}, {5300,0.88510526}, {5350,0.91820175}, {5400,0.87345614}, {5450,0.90185965}, {5500,0.96850877}, {5550,0.98207018}, {5600,0.92978070}, {5650,0.91715789}, {5700,0.93792105}, {5750,1.01064035}, {5800,0.95932456}, {5850,1.03637719}, {5900,0.97867544}, {5950,1.07141228}, {6000,1.04671930}, {6050,1.052714}, {6100,1.087429}, {6150,1.009286}, {6200,1.046071}, {6250,1.092929}, {6300,1.094429}, {6350,1.124000}, {6400,1.026571}, {6450,1.105857}, {6500,1.115000}, {6550,1.171286}, {6600,1.128000}, {6650,1.248071}, {6700,1.154286}, {6750,1.219857}, {6800,1.149143}, {6850,1.167071}, {6900,1.261214}, {6950,1.213714}, {7000,1.198714}, {7050,1.261286}, {7100,1.327643}, {7150,1.368500}, {7200,1.171857}, {7250,1.239214}, {7300,1.233571}, {7350,1.346500}, {7400,1.324214}, {7450,1.323714}, {7500,1.325714}, {7550,1.458786}, {7600,1.335929}, {7650,1.390643}, {7700,1.315071}, {7750,1.379286}, {7800,1.412429}, {7850,1.420214}, {7900,1.471000}, {7950,1.446429}, {8000,1.330000}, {8050,1.504929}, {8100,1.471429}, {8150,1.560714}, {8200,1.336500}, {8250,1.470286}, {8300,1.487786}, {8350,1.534214}, {8400,1.462571}, {8450,1.406143}, {8500,1.534929}, {8550,1.555143}, {8600,1.544571}, {8650,1.579357}, {8700,1.670143}, {8750,1.594429}, {8800,1.507071}, {8850,1.564429}, {8900,1.569000}, {8950,1.739500}, {9000,1.579214}, {9050,1.689500}, {9100,1.653786}, {9150,1.813357}, {9200,1.730500}, {9250,1.587000}, {9300,1.656143}, {9350,1.650857}, {9400,1.710714}, {9450,1.763714}, {9500,1.709286}, {9550,1.769286}, {9600,1.614357}, {9650,1.804214}, {9700,1.789214}, {9750,1.754143}, {9800,1.706500}, {9850,1.857357}, {9900,1.840786}, {9950,1.935500}, {10000,1.731714}, {10100,1.909857}, {10200,1.896286}, {10300,1.881357}, {10400,1.757786}, {10500,1.777286}, {10600,1.915357}, {10700,1.983643}, {10800,1.890286}, {10900,1.957357}, {11000,2.101571}, {11100,2.133071}, {11200,1.992214}, {11300,1.981357}, {11400,1.990071}, {11500,2.192143}, {11600,2.078286}, {11700,2.226786}, {11800,2.103071}, {11900,2.337357}, {12000,2.200571}, {12100,2.218214}, {12200,2.295143}, {12300,2.125500}, {12400,2.201000}, {12500,2.299071}, {12600,2.318071}, {12700,2.407643}, {12800,2.093429}, {12900,2.352643}, {13000,2.357429}, {13100,2.453429}, {13200,2.399571}, {13300,2.619143}, {13400,2.443357}, {13500,2.608357}, {13600,2.367571}, {13700,2.461500}, {13800,2.618286}, {13900,2.571357}, {14000,2.597071}, {14100,2.585357}, {14200,2.788000}, {14300,2.902214}, {14400,2.423929}, {14500,2.623214}, {14600,2.549857}, {14700,2.829714}, {14800,2.760571}, {14900,3.135500}, {15000,2.795643}, {15100,3.059000}, {15200,2.989286}, {15300,2.905643}, {15400,2.945429}, {15500,2.855714}, {15600,3.023714}, {15700,3.188143}, {15800,3.254571}, {15900,3.038000}, {16000,2.795643}, {16100,3.130143}, {16200,3.071571}, {16300,3.261000}, {16400,2.795571}, {16500,3.116929}, {16600,3.472500}, {16700,3.247714}, {16800,3.031429}, {16900,3.278071}, {17000,3.179929}, {17100,3.336571}, {17200,3.197500}, {17300,3.330286}, {17400,3.539357}, {17500,3.376071}, {17600,3.191000}, {17700,3.441000}, {17800,3.641500}, {17900,3.646286}, {18000,3.315286}, {18100,3.568357}, {18200,3.628214}, {18300,3.835643}, {18400,3.574214}, {18500,3.368429}, {18600,3.627571}, {18700,3.617643}, {18800,3.765929}, {18900,3.773714}, {19000,3.624786}, {19100,3.753786}, {19200,3.463143}, {19300,3.990643}, {19400,3.792000}, {19500,3.734500}, {19600,3.636000}, {19700,3.974714}, {19800,3.905071}, {19900,4.351857}, {20000,3.671500}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["actual reif"]["system"] = {{1,0.00007018}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00007018}, {6,0.00003509}, {7,0.00000000}, {8,0.00003509}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003509}, {13,0.00007018}, {14,0.00000000}, {15,0.00000000}, {16,0.00003509}, {17,0.00007018}, {18,0.00009649}, {19,0.00000000}, {20,0.00000000}, {21,0.00003509}, {22,0.00003509}, {23,0.00003509}, {24,0.00003509}, {25,0.00007018}, {26,0.00000000}, {27,0.00000000}, {28,0.00006140}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00003509}, {34,0.00003509}, {35,0.00007018}, {36,0.00000000}, {37,0.00003509}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00003509}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00005263}, {49,0.00003509}, {50,0.00003509}, {51,0.00007018}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00003509}, {56,0.00002632}, {57,0.00000000}, {58,0.00002632}, {59,0.00009649}, {60,0.00003509}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00003509}, {69,0.00003509}, {70,0.00000000}, {71,0.00003509}, {72,0.00006140}, {73,0.00000000}, {74,0.00006140}, {75,0.00000000}, {76,0.00006140}, {77,0.00002632}, {78,0.00003509}, {79,0.00002632}, {80,0.00000000}, {81,0.00003509}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00009649}, {87,0.00003509}, {88,0.00003509}, {89,0.00000000}, {90,0.00003509}, {91,0.00003509}, {92,0.00003509}, {93,0.00000000}, {94,0.00000000}, {95,0.00007018}, {96,0.00003509}, {97,0.00000000}, {98,0.00002632}, {99,0.00000000}, {100,0.00002632}, {101,0.00003509}, {102,0.00003509}, {103,0.00003509}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00003509}, {108,0.00000000}, {109,0.00000000}, {110,0.00002632}, {111,0.00002632}, {112,0.00000000}, {113,0.00007018}, {114,0.00002632}, {115,0.00003509}, {116,0.00007018}, {117,0.00000000}, {118,0.00002632}, {119,0.00003509}, {120,0.00006140}, {121,0.00003509}, {122,0.00000000}, {123,0.00003509}, {124,0.00000000}, {125,0.00000000}, {126,0.00003509}, {127,0.00003509}, {128,0.00003509}, {129,0.00003509}, {130,0.00000000}, {131,0.00005263}, {132,0.00003509}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00003509}, {137,0.00002632}, {138,0.00000000}, {139,0.00002632}, {140,0.00003509}, {141,0.00014035}, {142,0.00000000}, {143,0.00000000}, {144,0.00007018}, {145,0.00002632}, {146,0.00002632}, {147,0.00000000}, {148,0.00003509}, {149,0.00002632}, {150,0.00000000}, {151,0.00003509}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00003509}, {156,0.00007018}, {157,0.00010526}, {158,0.00000000}, {159,0.00007018}, {160,0.00000000}, {161,0.00000000}, {162,0.00007018}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00010526}, {167,0.00000000}, {168,0.00002632}, {169,0.00000000}, {170,0.00013158}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00003509}, {176,0.00003509}, {177,0.00000000}, {178,0.00002632}, {179,0.00007018}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00003509}, {184,0.00000000}, {185,0.00013158}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00003509}, {190,0.00003509}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00003509}, {196,0.00003509}, {197,0.00002632}, {198,0.00000000}, {199,0.00007018}, {200,0.00002632}, {201,0.00003509}, {202,0.00000000}, {203,0.00007018}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00003509}, {208,0.00002632}, {209,0.00000000}, {210,0.00003509}, {211,0.00007018}, {212,0.00016667}, {213,0.00006140}, {214,0.00009649}, {215,0.00007018}, {216,0.00009649}, {217,0.00009649}, {218,0.00009649}, {219,0.00007018}, {220,0.00003509}, {221,0.00010526}, {222,0.00009649}, {223,0.00009649}, {224,0.00007018}, {225,0.00010526}, {226,0.00007018}, {227,0.00010526}, {228,0.00010526}, {229,0.00013158}, {230,0.00002632}, {231,0.00000000}, {232,0.00003509}, {233,0.00003509}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00003509}, {238,0.00000000}, {239,0.00000000}, {240,0.00003509}, {241,0.00003509}, {242,0.00000000}, {243,0.00000000}, {244,0.00003509}, {245,0.00007018}, {246,0.00000000}, {247,0.00007018}, {248,0.00003509}, {249,0.00003509}, {250,0.00000000}, {251,0.00003509}, {252,0.00000000}, {253,0.00023684}, {254,0.00003509}, {255,0.00002632}, {256,0.00000000}, {257,0.00003509}, {258,0.00000000}, {259,0.00014035}, {260,0.00010526}, {261,0.00000000}, {262,0.00000000}, {263,0.00003509}, {264,0.00003509}, {265,0.00010526}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00020175}, {270,0.00009649}, {271,0.00000000}, {272,0.00000000}, {273,0.00034211}, {274,0.00003509}, {275,0.00003509}, {276,0.00002632}, {277,0.00029825}, {278,0.00010526}, {279,0.00003509}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00007018}, {284,0.00026316}, {285,0.00000000}, {286,0.00003509}, {287,0.00025439}, {288,0.00003509}, {289,0.00003509}, {290,0.00016667}, {291,0.00003509}, {292,0.00007018}, {293,0.00024561}, {294,0.00000000}, {295,0.00003509}, {296,0.00000000}, {297,0.00000000}, {298,0.00038596}, {299,0.00007018}, {300,0.00007018}, {301,0.00029825}, {302,0.00000000}, {303,0.00028070}, {304,0.00000000}, {305,0.00013158}, {306,0.00000000}, {307,0.00000000}, {308,0.00027193}, {309,0.00000000}, {310,0.00021053}, {311,0.00000000}, {312,0.00028070}, {313,0.00010526}, {314,0.00037719}, {315,0.00000000}, {316,0.00000000}, {317,0.00003509}, {318,0.00000000}, {319,0.00000000}, {320,0.00003509}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00003509}, {336,0.00003509}, {337,0.00003509}, {338,0.00000000}, {339,0.00007018}, {340,0.00000000}, {341,0.00003509}, {342,0.00003509}, {343,0.00003509}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00002632}, {350,0.00003509}, {351,0.00000000}, {352,0.00000000}, {353,0.00003509}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00003509}, {359,0.00002632}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00003509}, {366,0.00007018}, {367,0.00003509}, {368,0.00007018}, {369,0.00000000}, {370,0.00003509}, {371,0.00003509}, {372,0.00000000}, {373,0.00003509}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00002632}, {380,0.00003509}, {381,0.00000000}, {382,0.00003509}, {383,0.00003509}, {384,0.00000000}, {385,0.00000000}, {386,0.00002632}, {387,0.00003509}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00003509}, {392,0.00000000}, {393,0.00003509}, {394,0.00000000}, {395,0.00003509}, {396,0.00007018}, {397,0.00003509}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00007018}, {403,0.00000000}, {404,0.00003509}, {405,0.00000000}, {406,0.00023684}, {407,0.00014035}, {408,0.00009649}, {409,0.00014035}, {410,0.00010526}, {411,0.00020175}, {412,0.00000000}, {413,0.00017544}, {414,0.00017544}, {415,0.00014035}, {416,0.00003509}, {417,0.00017544}, {418,0.00010526}, {419,0.00000000}, {420,0.00003509}, {421,0.00007018}, {422,0.00000000}, {423,0.00003509}, {424,0.00000000}, {425,0.00003509}, {426,0.00014035}, {427,0.00007018}, {428,0.00003509}, {429,0.00000000}, {430,0.00007018}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00007018}, {437,0.00017544}, {438,0.00009649}, {439,0.00013158}, {440,0.00000000}, {441,0.00000000}, {442,0.00003509}, {443,0.00014035}, {444,0.00003509}, {445,0.00003509}, {446,0.00003509}, {447,0.00000000}, {448,0.00003509}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00003509}, {453,0.00000000}, {454,0.00003509}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00002632}, {462,0.00000000}, {463,0.00007018}, {464,0.00003509}, {465,0.00003509}, {466,0.00000000}, {467,0.00000000}, {468,0.00003509}, {469,0.00000000}, {470,0.00003509}, {471,0.00000000}, {472,0.00003509}, {473,0.00003509}, {474,0.00000000}, {475,0.00003509}, {476,0.00007018}, {477,0.00000000}, {478,0.00000000}, {479,0.00003509}, {480,0.00000000}, {481,0.00003509}, {482,0.00000000}, {483,0.00003509}, {484,0.00002632}, {485,0.00000000}, {486,0.00000000}, {487,0.00010526}, {488,0.00000000}, {489,0.00000000}, {490,0.00007018}, {491,0.00000000}, {492,0.00003509}, {493,0.00000000}, {494,0.00000000}, {495,0.00003509}, {496,0.00000000}, {497,0.00000000}, {498,0.00002632}, {499,0.00000000}, {500,0.00000000}, {505,0.00003509}, {510,0.00000000}, {515,0.00003509}, {520,0.00006140}, {525,0.00003509}, {530,0.00000000}, {535,0.00000000}, {540,0.00002632}, {545,0.00000000}, {550,0.00007018}, {555,0.00003509}, {560,0.00003509}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00003509}, {590,0.00000000}, {595,0.00003509}, {600,0.00003509}, {605,0.00002632}, {610,0.00007018}, {615,0.00007018}, {620,0.00003509}, {625,0.00017544}, {630,0.00000000}, {635,0.00010526}, {640,0.00007018}, {645,0.00006140}, {650,0.00007018}, {655,0.00000000}, {660,0.00007018}, {665,0.00003509}, {670,0.00000000}, {675,0.00003509}, {680,0.00003509}, {685,0.00003509}, {690,0.00000000}, {695,0.00000000}, {700,0.00006140}, {705,0.00000000}, {710,0.00000000}, {715,0.00006140}, {720,0.00000000}, {725,0.00000000}, {730,0.00003509}, {735,0.00000000}, {740,0.00007018}, {745,0.00006140}, {750,0.00000000}, {755,0.00003509}, {760,0.00000000}, {765,0.00003509}, {770,0.00003509}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00003509}, {795,0.00000000}, {800,0.00000000}, {805,0.00007018}, {810,0.00003509}, {815,0.00000000}, {820,0.00003509}, {825,0.00000000}, {830,0.00003509}, {835,0.00003509}, {840,0.00003509}, {845,0.00000000}, {850,0.00003509}, {855,0.00003509}, {860,0.00000000}, {865,0.00003509}, {870,0.00003509}, {875,0.00003509}, {880,0.00002632}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00002632}, {905,0.00003509}, {910,0.00006140}, {915,0.00000000}, {920,0.00003509}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00003509}, {950,0.00007018}, {955,0.00003509}, {960,0.00006140}, {965,0.00007018}, {970,0.00003509}, {975,0.00007018}, {980,0.00006140}, {985,0.00003509}, {990,0.00000000}, {995,0.00000000}, {1000,0.00003509}, {1010,0.00000000}, {1020,0.00003509}, {1030,0.00010526}, {1040,0.00003509}, {1050,0.00017544}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00003509}, {1090,0.00000000}, {1100,0.00003509}, {1110,0.00000000}, {1120,0.00003509}, {1130,0.00014035}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00006140}, {1200,0.00003509}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00002632}, {1250,0.00006140}, {1260,0.00003509}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00003509}, {1300,0.00003509}, {1310,0.00017544}, {1320,0.00000000}, {1330,0.00003509}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00003509}, {1370,0.00010526}, {1380,0.00000000}, {1390,0.00043860}, {1400,0.00055263}, {1410,0.00065789}, {1420,0.00007018}, {1430,0.00000000}, {1440,0.00003509}, {1450,0.00003509}, {1460,0.00007018}, {1470,0.00000000}, {1480,0.00003509}, {1490,0.00000000}, {1500,0.00006140}, {1510,0.00007018}, {1520,0.00003509}, {1530,0.00000000}, {1540,0.00003509}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00007018}, {1580,0.00000000}, {1590,0.00007018}, {1600,0.00002632}, {1610,0.00007018}, {1620,0.00003509}, {1630,0.00000000}, {1640,0.00003509}, {1650,0.00007018}, {1660,0.00007018}, {1670,0.00003509}, {1680,0.00007018}, {1690,0.00000000}, {1700,0.00003509}, {1710,0.00003509}, {1720,0.00003509}, {1730,0.00007018}, {1740,0.00000000}, {1750,0.00003509}, {1760,0.00007018}, {1770,0.00003509}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00007018}, {1810,0.00006140}, {1820,0.00000000}, {1830,0.00003509}, {1840,0.00003509}, {1850,0.00010526}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00003509}, {1890,0.00010526}, {1900,0.00007018}, {1910,0.00000000}, {1920,0.00007018}, {1930,0.00003509}, {1940,0.00003509}, {1950,0.00006140}, {1960,0.00014035}, {1970,0.00007018}, {1980,0.00000000}, {1990,0.00006140}, {2000,0.00003509}, {2050,0.00000000}, {2100,0.00003509}, {2150,0.00017544}, {2200,0.00007018}, {2250,0.00003509}, {2300,0.00003509}, {2350,0.00007018}, {2400,0.00003509}, {2450,0.00000000}, {2500,0.00007018}, {2550,0.00010526}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00003509}, {2750,0.00003509}, {2800,0.00009649}, {2850,0.00000000}, {2900,0.00010526}, {2950,0.00003509}, {3000,0.00014035}, {3050,0.00007018}, {3100,0.00013158}, {3150,0.00007018}, {3200,0.00021053}, {3250,0.00003509}, {3300,0.00003509}, {3350,0.00000000}, {3400,0.00003509}, {3450,0.00007018}, {3500,0.00000000}, {3550,0.00003509}, {3600,0.00023684}, {3650,0.00010526}, {3700,0.00015789}, {3750,0.00007018}, {3800,0.00000000}, {3850,0.00007018}, {3900,0.00014035}, {3950,0.00017544}, {4000,0.00010526}, {4050,0.00014035}, {4100,0.00007018}, {4150,0.00050877}, {4200,0.00010526}, {4250,0.00014035}, {4300,0.00000000}, {4350,0.00007018}, {4400,0.00007018}, {4450,0.00009649}, {4500,0.00000000}, {4550,0.00014035}, {4600,0.00010526}, {4650,0.00157018}, {4700,0.00014035}, {4750,0.00003509}, {4800,0.00007018}, {4850,0.00003509}, {4900,0.00003509}, {4950,0.00028070}, {5000,0.00003509}, {5050,0.00009649}, {5100,0.00007018}, {5150,0.00007018}, {5200,0.00017544}, {5250,0.00007018}, {5300,0.00016667}, {5350,0.00037719}, {5400,0.00017544}, {5450,0.00003509}, {5500,0.00020175}, {5550,0.00031579}, {5600,0.00171930}, {5650,0.00017544}, {5700,0.00007018}, {5750,0.00007018}, {5800,0.00007018}, {5850,0.00014035}, {5900,0.00007018}, {5950,0.00021053}, {6000,0.00003509}, {6050,0.004429}, {6100,0.002214}, {6150,0.001429}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000286}, {6400,0.000000}, {6450,0.000286}, {6500,0.000286}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000286}, {7100,0.000571}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000571}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000214}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000286}, {8050,0.000000}, {8100,0.000000}, {8150,0.000286}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000571}, {8500,0.000000}, {8550,0.000286}, {8600,0.000286}, {8650,0.000000}, {8700,0.000571}, {8750,0.000000}, {8800,0.000000}, {8850,0.000286}, {8900,0.000571}, {8950,0.000571}, {9000,0.000000}, {9050,0.000286}, {9100,0.000000}, {9150,0.000000}, {9200,0.000286}, {9250,0.000000}, {9300,0.000286}, {9350,0.000000}, {9400,0.000286}, {9450,0.000286}, {9500,0.000286}, {9550,0.000000}, {9600,0.000000}, {9650,0.000286}, {9700,0.000286}, {9750,0.000000}, {9800,0.000500}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000571}, {10300,0.000000}, {10400,0.000857}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000571}, {10900,0.000000}, {11000,0.000286}, {11100,0.000286}, {11200,0.000286}, {11300,0.000571}, {11400,0.000000}, {11500,0.000286}, {11600,0.000286}, {11700,0.000000}, {11800,0.000286}, {11900,0.000000}, {12000,0.000000}, {12100,0.000286}, {12200,0.000857}, {12300,0.000000}, {12400,0.000286}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000286}, {12900,0.000000}, {13000,0.000286}, {13100,0.001071}, {13200,0.000286}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000571}, {13800,0.001429}, {13900,0.001714}, {14000,0.000786}, {14100,0.000000}, {14200,0.000000}, {14300,0.001429}, {14400,0.000000}, {14500,0.000286}, {14600,0.001429}, {14700,0.000571}, {14800,0.000857}, {14900,0.000571}, {15000,0.000000}, {15100,0.000857}, {15200,0.000286}, {15300,0.000000}, {15400,0.001429}, {15500,0.000000}, {15600,0.000286}, {15700,0.000571}, {15800,0.000857}, {15900,0.000571}, {16000,0.000286}, {16100,0.003143}, {16200,0.000000}, {16300,0.000000}, {16400,0.000286}, {16500,0.000857}, {16600,0.002857}, {16700,0.000857}, {16800,0.000000}, {16900,0.000857}, {17000,0.000000}, {17100,0.001143}, {17200,0.000857}, {17300,0.000000}, {17400,0.000286}, {17500,0.000000}, {17600,0.000286}, {17700,0.000286}, {17800,0.001357}, {17900,0.000786}, {18000,0.002000}, {18100,0.002286}, {18200,0.000286}, {18300,0.003429}, {18400,0.001857}, {18500,0.001143}, {18600,0.001429}, {18700,0.001143}, {18800,0.000857}, {18900,0.002786}, {19000,0.001429}, {19100,0.000000}, {19200,0.000571}, {19300,0.000286}, {19400,0.000286}, {19500,0.000571}, {19600,0.001143}, {19700,0.000857}, {19800,0.000857}, {19900,0.001143}, {20000,0.000571}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00003509}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00180702}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00001754}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00008772}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00006140}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00454386}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000877}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00035088}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00003509}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00039474}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000877}, {421,0.00000000}, {422,0.00007018}, {423,0.00000877}, {424,0.00000000}, {425,0.00001754}, {426,0.00000877}, {427,0.00000000}, {428,0.00000877}, {429,0.00002632}, {430,0.00001754}, {431,0.00004386}, {432,0.00000877}, {433,0.00001754}, {434,0.00002632}, {435,0.00000877}, {436,0.00002632}, {437,0.00000877}, {438,0.00001754}, {439,0.00001754}, {440,0.00001754}, {441,0.00002632}, {442,0.00000877}, {443,0.00000877}, {444,0.00007018}, {445,0.00001754}, {446,0.00002632}, {447,0.00004386}, {448,0.00004386}, {449,0.00002632}, {450,0.00003509}, {451,0.00000877}, {452,0.00005263}, {453,0.00003509}, {454,0.00004386}, {455,0.00005263}, {456,0.00007895}, {457,0.00012281}, {458,0.00011404}, {459,0.00013158}, {460,0.00013158}, {461,0.00014912}, {462,0.00022807}, {463,0.00024561}, {464,0.00036842}, {465,0.00036842}, {466,0.00047368}, {467,0.00052632}, {468,0.00054386}, {469,0.00063158}, {470,0.00060526}, {471,0.00065789}, {472,0.00064035}, {473,0.00066667}, {474,0.00064912}, {475,0.00069298}, {476,0.00071930}, {477,0.00088596}, {478,0.00065789}, {479,0.00069298}, {480,0.00067544}, {481,0.00069298}, {482,0.00071053}, {483,0.00070175}, {484,0.00068421}, {485,0.00071053}, {486,0.00074561}, {487,0.00073684}, {488,0.00082456}, {489,0.00105263}, {490,0.00084211}, {491,0.00086842}, {492,0.00087719}, {493,0.00091228}, {494,0.00090351}, {495,0.00090351}, {496,0.00104386}, {497,0.00097368}, {498,0.00096491}, {499,0.00099123}, {500,0.00099123}, {505,0.00103509}, {510,0.00100000}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00100000}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00117544}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00107018}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00114912}, {805,0.00100000}, {810,0.00100000}, {815,0.00116667}, {820,0.00100000}, {825,0.00100000}, {830,0.00100000}, {835,0.00100000}, {840,0.00914912}, {845,0.00100000}, {850,0.00100000}, {855,0.00100000}, {860,0.00100000}, {865,0.00100000}, {870,0.00100000}, {875,0.00100877}, {880,0.00100000}, {885,0.00100877}, {890,0.00100000}, {895,0.00100000}, {900,0.00102632}, {905,0.00101754}, {910,0.00103509}, {915,0.00103509}, {920,0.00111404}, {925,0.00111404}, {930,0.00131579}, {935,0.00146491}, {940,0.00162281}, {945,0.00172807}, {950,0.00175439}, {955,0.00178947}, {960,0.00180702}, {965,0.00179825}, {970,0.00180702}, {975,0.00185965}, {980,0.01385088}, {985,0.01024561}, {990,0.00192982}, {995,0.00195614}, {1000,0.00199123}, {1010,0.00199123}, {1020,0.00200000}, {1030,0.00200000}, {1040,0.00200000}, {1050,0.00200000}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00200000}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200000}, {1140,0.00200000}, {1150,0.00200000}, {1160,0.00200000}, {1170,0.00200000}, {1180,0.00200000}, {1190,0.00200000}, {1200,0.00200000}, {1210,0.00216667}, {1220,0.00200000}, {1230,0.00200000}, {1240,0.00285965}, {1250,0.00200000}, {1260,0.00200000}, {1270,0.00292982}, {1280,0.00200000}, {1290,0.00218421}, {1300,0.00200000}, {1310,0.00200000}, {1320,0.00200877}, {1330,0.01085965}, {1340,0.00201754}, {1350,0.00228070}, {1360,0.00205263}, {1370,0.01209649}, {1380,0.00219298}, {1390,0.00228070}, {1400,0.00240351}, {1410,0.00259649}, {1420,0.00272807}, {1430,0.00275439}, {1440,0.00279825}, {1450,0.01180702}, {1460,0.00284211}, {1470,0.00288596}, {1480,0.00291228}, {1490,0.00292982}, {1500,0.00296491}, {1510,0.00300000}, {1520,0.00299123}, {1530,0.00300000}, {1540,0.00300000}, {1550,0.00300000}, {1560,0.00300000}, {1570,0.00300000}, {1580,0.00300000}, {1590,0.00300000}, {1600,0.00300000}, {1610,0.00300000}, {1620,0.00300000}, {1630,0.01194737}, {1640,0.00300000}, {1650,0.00300000}, {1660,0.00300000}, {1670,0.00300000}, {1680,0.00300000}, {1690,0.01235965}, {1700,0.00300000}, {1710,0.00300000}, {1720,0.00441228}, {1730,0.00300000}, {1740,0.00300000}, {1750,0.00300000}, {1760,0.00300000}, {1770,0.00300877}, {1780,0.00301754}, {1790,0.00324561}, {1800,0.00307018}, {1810,0.00307018}, {1820,0.00314035}, {1830,0.00315789}, {1840,0.00318421}, {1850,0.00327193}, {1860,0.00340351}, {1870,0.00356140}, {1880,0.00377193}, {1890,0.00357895}, {1900,0.00358772}, {1910,0.00354386}, {1920,0.00360526}, {1930,0.01183333}, {1940,0.00363158}, {1950,0.00368421}, {1960,0.00384211}, {1970,0.00387719}, {1980,0.01366667}, {1990,0.00398246}, {2000,0.00399123}, {2050,0.00400000}, {2100,0.01200877}, {2150,0.00400000}, {2200,0.00402632}, {2250,0.00409649}, {2300,0.00421930}, {2350,0.00447368}, {2400,0.00465789}, {2450,0.00500000}, {2500,0.00500000}, {2550,0.00500000}, {2600,0.00500000}, {2650,0.00503509}, {2700,0.00510526}, {2750,0.00526316}, {2800,0.00552632}, {2850,0.00565789}, {2900,0.00587719}, {2950,0.00600000}, {3000,0.01508772}, {3050,0.00602632}, {3100,0.00607018}, {3150,0.00614912}, {3200,0.00636842}, {3250,0.00757895}, {3300,0.00669298}, {3350,0.00705263}, {3400,0.00698246}, {3450,0.00702632}, {3500,0.00845614}, {3550,0.00706140}, {3600,0.00722807}, {3650,0.00885088}, {3700,0.00868421}, {3750,0.00903509}, {3800,0.00782456}, {3850,0.02296491}, {3900,0.00806140}, {3950,0.00807895}, {4000,0.00818421}, {4050,0.00829825}, {4100,0.01001754}, {4150,0.00937719}, {4200,0.00870175}, {4250,0.00955263}, {4300,0.02670175}, {4350,0.00916667}, {4400,0.00946491}, {4450,0.00927193}, {4500,0.02111404}, {4550,0.00971053}, {4600,0.00966667}, {4650,0.00992105}, {4700,0.02084211}, {4750,0.01032456}, {4800,0.01155263}, {4850,0.02244737}, {4900,0.01027193}, {4950,0.01045614}, {5000,0.01428947}, {5050,0.01076316}, {5100,0.01088596}, {5150,0.01095614}, {5200,0.01134211}, {5250,0.01118421}, {5300,0.01128947}, {5350,0.01164912}, {5400,0.01164912}, {5450,0.01176316}, {5500,0.01178070}, {5550,0.01220175}, {5600,0.02421930}, {5650,0.01218421}, {5700,0.01221930}, {5750,0.01240351}, {5800,0.01261404}, {5850,0.02255263}, {5900,0.01284211}, {5950,0.01307018}, {6000,0.01307895}, {6050,0.043786}, {6100,0.013500}, {6150,0.013643}, {6200,0.014786}, {6250,0.014000}, {6300,0.014143}, {6350,0.014286}, {6400,0.014429}, {6450,0.014500}, {6500,0.014429}, {6550,0.014500}, {6600,0.014714}, {6650,0.024643}, {6700,0.015000}, {6750,0.015000}, {6800,0.015357}, {6850,0.029071}, {6900,0.031500}, {6950,0.027500}, {7000,0.015571}, {7050,0.032714}, {7100,0.016143}, {7150,0.016357}, {7200,0.016286}, {7250,0.020714}, {7300,0.016500}, {7350,0.017286}, {7400,0.016857}, {7450,0.026500}, {7500,0.030714}, {7550,0.032071}, {7600,0.017429}, {7650,0.017500}, {7700,0.017500}, {7750,0.018071}, {7800,0.017714}, {7850,0.017857}, {7900,0.018071}, {7950,0.018429}, {8000,0.018429}, {8050,0.018429}, {8100,0.018571}, {8150,0.032929}, {8200,0.032571}, {8250,0.018929}, {8300,0.019071}, {8350,0.019429}, {8400,0.019357}, {8450,0.019500}, {8500,0.020000}, {8550,0.019714}, {8600,0.021071}, {8650,0.046500}, {8700,0.020929}, {8750,0.020143}, {8800,0.020357}, {8850,0.027857}, {8900,0.040286}, {8950,0.043000}, {9000,0.023071}, {9050,0.037214}, {9100,0.021429}, {9150,0.045286}, {9200,0.022857}, {9250,0.022929}, {9300,0.021429}, {9350,0.051714}, {9400,0.021857}, {9450,0.022786}, {9500,0.031071}, {9550,0.022286}, {9600,0.022500}, {9650,0.023500}, {9700,0.022714}, {9750,0.022571}, {9800,0.047071}, {9850,0.034357}, {9900,0.023714}, {9950,0.041500}, {10000,0.023286}, {10100,0.041214}, {10200,0.023571}, {10300,0.024214}, {10400,0.047929}, {10500,0.039857}, {10600,0.044714}, {10700,0.046643}, {10800,0.026571}, {10900,0.045643}, {11000,0.025857}, {11100,0.026214}, {11200,0.027786}, {11300,0.050286}, {11400,0.026786}, {11500,0.028214}, {11600,0.028357}, {11700,0.049286}, {11800,0.045143}, {11900,0.029714}, {12000,0.055643}, {12100,0.028857}, {12200,0.028857}, {12300,0.029357}, {12400,0.030714}, {12500,0.029857}, {12600,0.030143}, {12700,0.040857}, {12800,0.030643}, {12900,0.051071}, {13000,0.061929}, {13100,0.031500}, {13200,0.039571}, {13300,0.034143}, {13400,0.032071}, {13500,0.032071}, {13600,0.054071}, {13700,0.032786}, {13800,0.033143}, {13900,0.066429}, {14000,0.053071}, {14100,0.034000}, {14200,0.055929}, {14300,0.069000}, {14400,0.034714}, {14500,0.034786}, {14600,0.066143}, {14700,0.070571}, {14800,0.067286}, {14900,0.037357}, {15000,0.059643}, {15100,0.036643}, {15200,0.037500}, {15300,0.037000}, {15400,0.040643}, {15500,0.037643}, {15600,0.059357}, {15700,0.055571}, {15800,0.058857}, {15900,0.076286}, {16000,0.039500}, {16100,0.039357}, {16200,0.039786}, {16300,0.039929}, {16400,0.040071}, {16500,0.074786}, {16600,0.040643}, {16700,0.040714}, {16800,0.064857}, {16900,0.250500}, {17000,0.088357}, {17100,0.077714}, {17200,0.079429}, {17300,0.085643}, {17400,0.058571}, {17500,0.076929}, {17600,0.066857}, {17700,0.073214}, {17800,0.083000}, {17900,0.044071}, {18000,0.046643}, {18100,0.088071}, {18200,0.094571}, {18300,0.076786}, {18400,0.089786}, {18500,0.068286}, {18600,0.045786}, {18700,0.240500}, {18800,0.046214}, {18900,0.046643}, {19000,0.047000}, {19100,0.049786}, {19200,0.091000}, {19300,0.048357}, {19400,0.048000}, {19500,0.047929}, {19600,0.071357}, {19700,0.069571}, {19800,0.074071}, {19900,0.049286}, {20000,0.085714}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["cbv"]["user"] = {{1,0.00000000}, {2,0.00007895}, {3,0.00002632}, {4,0.00000000}, {5,0.00006140}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00002632}, {10,0.00007018}, {11,0.00000000}, {12,0.00006140}, {13,0.00002632}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00005263}, {18,0.00002632}, {19,0.00002632}, {20,0.00005263}, {21,0.00009649}, {22,0.00013158}, {23,0.00008772}, {24,0.00000000}, {25,0.00003509}, {26,0.00009649}, {27,0.00000000}, {28,0.00006140}, {29,0.00009649}, {30,0.00002632}, {31,0.00000000}, {32,0.00000000}, {33,0.00002632}, {34,0.00002632}, {35,0.00002632}, {36,0.00003509}, {37,0.00009649}, {38,0.00018421}, {39,0.00002632}, {40,0.00009649}, {41,0.00015789}, {42,0.00000000}, {43,0.00006140}, {44,0.00008772}, {45,0.00011404}, {46,0.00013158}, {47,0.00005263}, {48,0.00013158}, {49,0.00014912}, {50,0.00016667}, {51,0.00009649}, {52,0.00010526}, {53,0.00013158}, {54,0.00012281}, {55,0.00024561}, {56,0.00009649}, {57,0.00008772}, {58,0.00016667}, {59,0.00015789}, {60,0.00012281}, {61,0.00006140}, {62,0.00020175}, {63,0.00017544}, {64,0.00012281}, {65,0.00021053}, {66,0.00019298}, {67,0.00009649}, {68,0.00021930}, {69,0.00020175}, {70,0.00032456}, {71,0.00002632}, {72,0.00013158}, {73,0.00018421}, {74,0.00007895}, {75,0.00014912}, {76,0.00006140}, {77,0.00016667}, {78,0.00014912}, {79,0.00012281}, {80,0.00015789}, {81,0.00018421}, {82,0.00015789}, {83,0.00035965}, {84,0.00028070}, {85,0.00022807}, {86,0.00026316}, {87,0.00009649}, {88,0.00020175}, {89,0.00024561}, {90,0.00026316}, {91,0.00014912}, {92,0.00009649}, {93,0.00021930}, {94,0.00014035}, {95,0.00006140}, {96,0.00010526}, {97,0.00021930}, {98,0.00020175}, {99,0.00015789}, {100,0.00005263}, {101,0.00025439}, {102,0.00024561}, {103,0.00010526}, {104,0.00015789}, {105,0.00014035}, {106,0.00012281}, {107,0.00017544}, {108,0.00011404}, {109,0.00034211}, {110,0.00027193}, {111,0.00014035}, {112,0.00039474}, {113,0.00042105}, {114,0.00021930}, {115,0.00025439}, {116,0.00027193}, {117,0.00005263}, {118,0.00027193}, {119,0.00028070}, {120,0.00024561}, {121,0.00007895}, {122,0.00023684}, {123,0.00031579}, {124,0.00007018}, {125,0.00018421}, {126,0.00041228}, {127,0.00033333}, {128,0.00014035}, {129,0.00011404}, {130,0.00029825}, {131,0.00021930}, {132,0.00031579}, {133,0.00019298}, {134,0.00023684}, {135,0.00031579}, {136,0.00013158}, {137,0.00021930}, {138,0.00037719}, {139,0.00011404}, {140,0.00010526}, {141,0.00012281}, {142,0.00014912}, {143,0.00026316}, {144,0.00022807}, {145,0.00021053}, {146,0.00042105}, {147,0.00030702}, {148,0.00028947}, {149,0.00031579}, {150,0.00035965}, {151,0.00018421}, {152,0.00036842}, {153,0.00026316}, {154,0.00017544}, {155,0.00024561}, {156,0.00029825}, {157,0.00017544}, {158,0.00022807}, {159,0.00011404}, {160,0.00018421}, {161,0.00033333}, {162,0.00017544}, {163,0.00025439}, {164,0.00039474}, {165,0.00047368}, {166,0.00026316}, {167,0.00035965}, {168,0.00056140}, {169,0.00028070}, {170,0.00021053}, {171,0.00028947}, {172,0.00039474}, {173,0.00020175}, {174,0.00040351}, {175,0.00029825}, {176,0.00055263}, {177,0.00034211}, {178,0.00052632}, {179,0.00028947}, {180,0.00035965}, {181,0.00041228}, {182,0.00037719}, {183,0.00017544}, {184,0.00036842}, {185,0.00049123}, {186,0.00021930}, {187,0.00043860}, {188,0.00021930}, {189,0.00041228}, {190,0.00057018}, {191,0.00035965}, {192,0.00021930}, {193,0.00022807}, {194,0.00046491}, {195,0.00047368}, {196,0.00034211}, {197,0.00032456}, {198,0.00022807}, {199,0.00039474}, {200,0.00034211}, {201,0.00021053}, {202,0.00031579}, {203,0.00038596}, {204,0.00050000}, {205,0.00054386}, {206,0.00021053}, {207,0.00039474}, {208,0.00029825}, {209,0.00043860}, {210,0.00040351}, {211,0.00052632}, {212,0.00024561}, {213,0.00040351}, {214,0.00033333}, {215,0.00038596}, {216,0.00062281}, {217,0.00035965}, {218,0.00046491}, {219,0.00062281}, {220,0.00050877}, {221,0.00025439}, {222,0.00041228}, {223,0.00035965}, {224,0.00050000}, {225,0.00033333}, {226,0.00035965}, {227,0.00054386}, {228,0.00039474}, {229,0.00042982}, {230,0.00231579}, {231,0.00058772}, {232,0.00035088}, {233,0.00032456}, {234,0.00040351}, {235,0.00047368}, {236,0.00045614}, {237,0.00062281}, {238,0.00011404}, {239,0.00052632}, {240,0.00049123}, {241,0.00054386}, {242,0.00081579}, {243,0.00054386}, {244,0.00053509}, {245,0.00035088}, {246,0.00043860}, {247,0.00045614}, {248,0.00046491}, {249,0.00051754}, {250,0.00050877}, {251,0.00046491}, {252,0.00041228}, {253,0.00037719}, {254,0.00044737}, {255,0.00037719}, {256,0.00072807}, {257,0.00067544}, {258,0.00036842}, {259,0.00056140}, {260,0.00059649}, {261,0.00050877}, {262,0.00063158}, {263,0.00072807}, {264,0.00051754}, {265,0.00057895}, {266,0.00050000}, {267,0.00044737}, {268,0.00057895}, {269,0.00055263}, {270,0.00068421}, {271,0.00048246}, {272,0.00065789}, {273,0.00071930}, {274,0.00044737}, {275,0.00051754}, {276,0.00060526}, {277,0.00042105}, {278,0.00062281}, {279,0.00073684}, {280,0.00057018}, {281,0.00057895}, {282,0.00044737}, {283,0.00069298}, {284,0.00042105}, {285,0.00060526}, {286,0.00055263}, {287,0.00061404}, {288,0.00056140}, {289,0.00065789}, {290,0.00064912}, {291,0.00052632}, {292,0.00029825}, {293,0.00058772}, {294,0.00040351}, {295,0.00083333}, {296,0.00073684}, {297,0.00057895}, {298,0.00057018}, {299,0.00038596}, {300,0.00060526}, {301,0.00063158}, {302,0.00045614}, {303,0.00067544}, {304,0.00046491}, {305,0.00068421}, {306,0.00069298}, {307,0.00064035}, {308,0.00062281}, {309,0.00075439}, {310,0.00037719}, {311,0.00057895}, {312,0.00053509}, {313,0.00064912}, {314,0.00054386}, {315,0.00046491}, {316,0.00051754}, {317,0.00058772}, {318,0.00059649}, {319,0.00057895}, {320,0.00048246}, {321,0.00055263}, {322,0.00075439}, {323,0.00051754}, {324,0.00083333}, {325,0.00058772}, {326,0.00038596}, {327,0.00050877}, {328,0.00053509}, {329,0.00075439}, {330,0.00064035}, {331,0.00064035}, {332,0.00436842}, {333,0.00062281}, {334,0.00059649}, {335,0.00068421}, {336,0.00071053}, {337,0.00059649}, {338,0.00050000}, {339,0.00057018}, {340,0.00066667}, {341,0.00074561}, {342,0.00064912}, {343,0.00054386}, {344,0.00060526}, {345,0.00079825}, {346,0.00068421}, {347,0.00042105}, {348,0.00050877}, {349,0.00070175}, {350,0.00077193}, {351,0.00071930}, {352,0.00065789}, {353,0.00076316}, {354,0.00075439}, {355,0.00070175}, {356,0.00071930}, {357,0.00085965}, {358,0.00080702}, {359,0.00062281}, {360,0.00072807}, {361,0.00061404}, {362,0.00057895}, {363,0.00072807}, {364,0.00042982}, {365,0.00049123}, {366,0.00046491}, {367,0.00063158}, {368,0.00076316}, {369,0.00057895}, {370,0.00052632}, {371,0.00060526}, {372,0.00061404}, {373,0.00043860}, {374,0.00072807}, {375,0.00066667}, {376,0.00066667}, {377,0.00067544}, {378,0.00088596}, {379,0.00075439}, {380,0.00064912}, {381,0.00061404}, {382,0.00079825}, {383,0.00053509}, {384,0.00079825}, {385,0.00071053}, {386,0.00068421}, {387,0.00128070}, {388,0.00062281}, {389,0.00057018}, {390,0.00064912}, {391,0.00054386}, {392,0.00068421}, {393,0.00044737}, {394,0.00073684}, {395,0.00069298}, {396,0.00083333}, {397,0.00070175}, {398,0.00078070}, {399,0.00041228}, {400,0.00070175}, {401,0.00069298}, {402,0.00059649}, {403,0.00087719}, {404,0.00057018}, {405,0.00081579}, {406,0.00075439}, {407,0.00071930}, {408,0.00079825}, {409,0.00079825}, {410,0.00052632}, {411,0.00082456}, {412,0.00090351}, {413,0.00071930}, {414,0.00070175}, {415,0.00090351}, {416,0.00081579}, {417,0.00069298}, {418,0.00062281}, {419,0.00081579}, {420,0.00067544}, {421,0.00063158}, {422,0.00065789}, {423,0.00076316}, {424,0.00067544}, {425,0.00062281}, {426,0.00075439}, {427,0.00069298}, {428,0.00076316}, {429,0.00087719}, {430,0.00081579}, {431,0.00085088}, {432,0.00079825}, {433,0.00084211}, {434,0.00057018}, {435,0.00081579}, {436,0.00075439}, {437,0.00057895}, {438,0.00073684}, {439,0.00078070}, {440,0.00092982}, {441,0.00064035}, {442,0.00077193}, {443,0.00101754}, {444,0.00087719}, {445,0.00071930}, {446,0.00074561}, {447,0.00072807}, {448,0.00078947}, {449,0.00100877}, {450,0.00083333}, {451,0.00086842}, {452,0.00053509}, {453,0.00089474}, {454,0.00061404}, {455,0.00077193}, {456,0.00094737}, {457,0.00094737}, {458,0.00060526}, {459,0.00115789}, {460,0.00093860}, {461,0.00109649}, {462,0.00085088}, {463,0.00078947}, {464,0.00098246}, {465,0.00125439}, {466,0.00071930}, {467,0.00100000}, {468,0.00076316}, {469,0.00102632}, {470,0.00061404}, {471,0.00124561}, {472,0.00105263}, {473,0.00114035}, {474,0.00088596}, {475,0.00121930}, {476,0.00066667}, {477,0.00082456}, {478,0.00087719}, {479,0.00075439}, {480,0.00082456}, {481,0.00085088}, {482,0.00074561}, {483,0.00095614}, {484,0.00080702}, {485,0.00099123}, {486,0.00092982}, {487,0.00078070}, {488,0.00095614}, {489,0.00114035}, {490,0.00107018}, {491,0.00092105}, {492,0.00115789}, {493,0.00086842}, {494,0.00073684}, {495,0.00074561}, {496,0.00121930}, {497,0.00092982}, {498,0.00088596}, {499,0.00074561}, {500,0.00125439}, {505,0.00121053}, {510,0.00106140}, {515,0.00102632}, {520,0.00117544}, {525,0.00091228}, {530,0.00097368}, {535,0.00113158}, {540,0.00098246}, {545,0.00120175}, {550,0.00110526}, {555,0.00087719}, {560,0.00100000}, {565,0.00133333}, {570,0.00114035}, {575,0.00075439}, {580,0.00114035}, {585,0.00121930}, {590,0.00105263}, {595,0.00134211}, {600,0.00130702}, {605,0.00125439}, {610,0.00095614}, {615,0.00116667}, {620,0.00129825}, {625,0.00104386}, {630,0.00126316}, {635,0.00126316}, {640,0.00093860}, {645,0.00150000}, {650,0.00122807}, {655,0.00133333}, {660,0.00119298}, {665,0.00124561}, {670,0.00142105}, {675,0.00124561}, {680,0.00129825}, {685,0.00140351}, {690,0.00122807}, {695,0.00138596}, {700,0.00134211}, {705,0.00103509}, {710,0.00138596}, {715,0.00157018}, {720,0.00133333}, {725,0.00129825}, {730,0.00171053}, {735,0.00157895}, {740,0.00170175}, {745,0.00122807}, {750,0.00142105}, {755,0.00189474}, {760,0.00150877}, {765,0.00125439}, {770,0.00127193}, {775,0.00130702}, {780,0.00128070}, {785,0.00136842}, {790,0.00135088}, {795,0.00147368}, {800,0.00178947}, {805,0.00135965}, {810,0.00152632}, {815,0.00165789}, {820,0.00145614}, {825,0.00175439}, {830,0.00163158}, {835,0.00146491}, {840,0.00920175}, {845,0.00193860}, {850,0.00190351}, {855,0.00144737}, {860,0.00170175}, {865,0.00165789}, {870,0.00160526}, {875,0.00133333}, {880,0.00154386}, {885,0.00183333}, {890,0.00150877}, {895,0.00164912}, {900,0.00143860}, {905,0.00182456}, {910,0.00178947}, {915,0.00178947}, {920,0.00183333}, {925,0.00184211}, {930,0.00165789}, {935,0.00170175}, {940,0.00204386}, {945,0.00195614}, {950,0.00185965}, {955,0.00200000}, {960,0.00172807}, {965,0.00189474}, {970,0.00168421}, {975,0.00194737}, {980,0.01392982}, {985,0.01065789}, {990,0.00182456}, {995,0.00197368}, {1000,0.00195614}, {1010,0.00201754}, {1020,0.00173684}, {1030,0.00173684}, {1040,0.00201754}, {1050,0.00198246}, {1060,0.00184211}, {1070,0.00208772}, {1080,0.00234211}, {1090,0.00209649}, {1100,0.00174561}, {1110,0.00183333}, {1120,0.00201754}, {1130,0.00192105}, {1140,0.00208772}, {1150,0.00199123}, {1160,0.00216667}, {1170,0.00228947}, {1180,0.00206140}, {1190,0.00214912}, {1200,0.00215789}, {1210,0.00231579}, {1220,0.00242105}, {1230,0.00203509}, {1240,0.00313158}, {1250,0.00224561}, {1260,0.00201754}, {1270,0.00303509}, {1280,0.00242105}, {1290,0.00248246}, {1300,0.00245614}, {1310,0.00233333}, {1320,0.00235088}, {1330,0.01108772}, {1340,0.00222807}, {1350,0.00277193}, {1360,0.00210526}, {1370,0.01203509}, {1380,0.00236842}, {1390,0.00218421}, {1400,0.00250877}, {1410,0.00255263}, {1420,0.00264912}, {1430,0.00264035}, {1440,0.00255263}, {1450,0.01218421}, {1460,0.00254386}, {1470,0.00256140}, {1480,0.00277193}, {1490,0.00275439}, {1500,0.00251754}, {1510,0.00262281}, {1520,0.00257018}, {1530,0.00287719}, {1540,0.00275439}, {1550,0.00282456}, {1560,0.00264912}, {1570,0.00266667}, {1580,0.00265789}, {1590,0.00264035}, {1600,0.00281579}, {1610,0.00274561}, {1620,0.00278070}, {1630,0.01230702}, {1640,0.00268421}, {1650,0.00290351}, {1660,0.00305263}, {1670,0.00281579}, {1680,0.00272807}, {1690,0.01248246}, {1700,0.00294737}, {1710,0.00283333}, {1720,0.00442105}, {1730,0.00308772}, {1740,0.00306140}, {1750,0.00299123}, {1760,0.00307895}, {1770,0.00303509}, {1780,0.00298246}, {1790,0.00340351}, {1800,0.00314912}, {1810,0.00310526}, {1820,0.00317544}, {1830,0.00325439}, {1840,0.00315789}, {1850,0.00331579}, {1860,0.00346491}, {1870,0.00319298}, {1880,0.00365789}, {1890,0.00341228}, {1900,0.00338596}, {1910,0.00326316}, {1920,0.00346491}, {1930,0.01210526}, {1940,0.00341228}, {1950,0.00341228}, {1960,0.00355263}, {1970,0.00348246}, {1980,0.01355263}, {1990,0.00358772}, {2000,0.00364035}, {2050,0.00362281}, {2100,0.01214035}, {2150,0.00381579}, {2200,0.00408772}, {2250,0.00410526}, {2300,0.00443860}, {2350,0.00444737}, {2400,0.00458772}, {2450,0.00438596}, {2500,0.00464035}, {2550,0.00514912}, {2600,0.00523684}, {2650,0.00514035}, {2700,0.00522807}, {2750,0.00535965}, {2800,0.00546491}, {2850,0.00549123}, {2900,0.00572807}, {2950,0.00575439}, {3000,0.01521930}, {3050,0.00610526}, {3100,0.00612281}, {3150,0.00616667}, {3200,0.00653509}, {3250,0.00732456}, {3300,0.00663158}, {3350,0.00710526}, {3400,0.00673684}, {3450,0.00678947}, {3500,0.00817544}, {3550,0.00699123}, {3600,0.00716667}, {3650,0.00901754}, {3700,0.00833333}, {3750,0.00890351}, {3800,0.00756140}, {3850,0.02305263}, {3900,0.00821053}, {3950,0.00809649}, {4000,0.00813158}, {4050,0.00849123}, {4100,0.00989474}, {4150,0.00928947}, {4200,0.00866667}, {4250,0.00951754}, {4300,0.02667544}, {4350,0.00951754}, {4400,0.00935088}, {4450,0.00942982}, {4500,0.02146491}, {4550,0.00973684}, {4600,0.00966667}, {4650,0.01028070}, {4700,0.02077193}, {4750,0.01028070}, {4800,0.01178070}, {4850,0.02302632}, {4900,0.01042105}, {4950,0.01069298}, {5000,0.01421930}, {5050,0.01126316}, {5100,0.01133333}, {5150,0.01133333}, {5200,0.01182456}, {5250,0.01168421}, {5300,0.01188596}, {5350,0.01211404}, {5400,0.01213158}, {5450,0.01224561}, {5500,0.01209649}, {5550,0.01268421}, {5600,0.02413158}, {5650,0.01258772}, {5700,0.01271053}, {5750,0.01275439}, {5800,0.01298246}, {5850,0.02309649}, {5900,0.01343860}, {5950,0.01353509}, {6000,0.01349123}, {6050,0.043000}, {6100,0.013500}, {6150,0.014286}, {6200,0.015643}, {6250,0.013643}, {6300,0.013643}, {6350,0.013857}, {6400,0.014429}, {6450,0.014286}, {6500,0.015143}, {6550,0.014357}, {6600,0.015357}, {6650,0.024929}, {6700,0.014857}, {6750,0.014857}, {6800,0.015500}, {6850,0.029000}, {6900,0.031500}, {6950,0.028000}, {7000,0.016143}, {7050,0.032857}, {7100,0.016071}, {7150,0.016286}, {7200,0.016357}, {7250,0.020286}, {7300,0.017286}, {7350,0.016929}, {7400,0.017000}, {7450,0.026214}, {7500,0.029929}, {7550,0.033429}, {7600,0.017786}, {7650,0.018214}, {7700,0.018786}, {7750,0.017714}, {7800,0.017071}, {7850,0.018071}, {7900,0.017286}, {7950,0.018500}, {8000,0.017857}, {8050,0.017714}, {8100,0.018786}, {8150,0.032786}, {8200,0.032357}, {8250,0.017929}, {8300,0.019429}, {8350,0.019071}, {8400,0.019929}, {8450,0.019357}, {8500,0.019643}, {8550,0.019214}, {8600,0.020429}, {8650,0.047429}, {8700,0.021214}, {8750,0.019500}, {8800,0.019857}, {8850,0.028500}, {8900,0.040214}, {8950,0.042143}, {9000,0.023214}, {9050,0.037714}, {9100,0.021000}, {9150,0.045429}, {9200,0.022000}, {9250,0.023429}, {9300,0.021571}, {9350,0.052286}, {9400,0.021714}, {9450,0.023071}, {9500,0.031571}, {9550,0.021643}, {9600,0.023071}, {9650,0.023643}, {9700,0.022429}, {9750,0.023143}, {9800,0.048286}, {9850,0.035214}, {9900,0.024857}, {9950,0.041000}, {10000,0.023643}, {10100,0.041000}, {10200,0.024214}, {10300,0.024214}, {10400,0.048071}, {10500,0.039786}, {10600,0.044571}, {10700,0.047286}, {10800,0.027500}, {10900,0.045929}, {11000,0.026500}, {11100,0.025857}, {11200,0.027929}, {11300,0.050429}, {11400,0.027286}, {11500,0.027929}, {11600,0.028000}, {11700,0.050000}, {11800,0.045214}, {11900,0.030143}, {12000,0.056143}, {12100,0.029286}, {12200,0.029571}, {12300,0.029500}, {12400,0.031786}, {12500,0.030429}, {12600,0.030357}, {12700,0.040929}, {12800,0.030786}, {12900,0.050714}, {13000,0.061786}, {13100,0.031929}, {13200,0.038786}, {13300,0.035429}, {13400,0.032071}, {13500,0.032929}, {13600,0.054143}, {13700,0.032500}, {13800,0.033857}, {13900,0.065857}, {14000,0.052357}, {14100,0.033714}, {14200,0.056214}, {14300,0.069286}, {14400,0.035071}, {14500,0.034929}, {14600,0.065714}, {14700,0.070500}, {14800,0.066643}, {14900,0.037286}, {15000,0.058929}, {15100,0.036643}, {15200,0.038357}, {15300,0.037071}, {15400,0.040071}, {15500,0.037071}, {15600,0.058857}, {15700,0.055357}, {15800,0.058714}, {15900,0.076143}, {16000,0.038357}, {16100,0.038929}, {16200,0.039429}, {16300,0.040357}, {16400,0.039857}, {16500,0.074357}, {16600,0.040357}, {16700,0.039929}, {16800,0.064357}, {16900,0.249286}, {17000,0.088143}, {17100,0.078143}, {17200,0.079000}, {17300,0.085429}, {17400,0.058857}, {17500,0.076500}, {17600,0.066357}, {17700,0.072857}, {17800,0.082214}, {17900,0.044500}, {18000,0.046429}, {18100,0.088071}, {18200,0.094857}, {18300,0.076786}, {18400,0.090000}, {18500,0.068071}, {18600,0.046071}, {18700,0.240071}, {18800,0.046786}, {18900,0.047286}, {19000,0.047000}, {19100,0.049929}, {19200,0.091500}, {19300,0.049286}, {19400,0.047500}, {19500,0.048214}, {19600,0.071571}, {19700,0.069429}, {19800,0.073714}, {19900,0.049071}, {20000,0.086357}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00002632}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00003509}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00007018}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00002632}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00003509}, {98,0.00000000}, {99,0.00002632}, {100,0.00000000}, {101,0.00000000}, {102,0.00007018}, {103,0.00003509}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00003509}, {117,0.00000000}, {118,0.00002632}, {119,0.00000000}, {120,0.00003509}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00003509}, {125,0.00000000}, {126,0.00000000}, {127,0.00002632}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00003509}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00003509}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00002632}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00002632}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00003509}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00003509}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00002632}, {192,0.00000000}, {193,0.00003509}, {194,0.00000000}, {195,0.00000000}, {196,0.00003509}, {197,0.00003509}, {198,0.00003509}, {199,0.00000000}, {200,0.00000000}, {201,0.00003509}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00003509}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00007018}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00003509}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00003509}, {241,0.00000000}, {242,0.00000000}, {243,0.00003509}, {244,0.00000000}, {245,0.00000000}, {246,0.00003509}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00002632}, {251,0.00003509}, {252,0.00000000}, {253,0.00002632}, {254,0.00003509}, {255,0.00000000}, {256,0.00003509}, {257,0.00000000}, {258,0.00000000}, {259,0.00002632}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00003509}, {264,0.00002632}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00003509}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00002632}, {274,0.00003509}, {275,0.00000000}, {276,0.00000000}, {277,0.00003509}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00003509}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00003509}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00003509}, {311,0.00003509}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00003509}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00002632}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00002632}, {333,0.00002632}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00003509}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00003509}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00003509}, {353,0.00000000}, {354,0.00003509}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00003509}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00003509}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00003509}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00003509}, {398,0.00000000}, {399,0.00003509}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00007018}, {407,0.00000000}, {408,0.00000000}, {409,0.00003509}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00003509}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00003509}, {420,0.00000000}, {421,0.00000000}, {422,0.00003509}, {423,0.00000000}, {424,0.00000000}, {425,0.00003509}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00003509}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00003509}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003509}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00003509}, {474,0.00000000}, {475,0.00003509}, {476,0.00000000}, {477,0.00003509}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00003509}, {520,0.00003509}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00003509}, {620,0.00000000}, {625,0.00002632}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00003509}, {655,0.00003509}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00003509}, {760,0.00003509}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00003509}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00003509}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00003509}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00003509}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00003509}, {1410,0.00000000}, {1420,0.00003509}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00003509}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00003509}, {1580,0.00003509}, {1590,0.00003509}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00003509}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00003509}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00003509}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00003509}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00003509}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00003509}, {3700,0.00003509}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00003509}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00007018}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00003509}, {5550,0.00000000}, {5600,0.00028070}, {5650,0.00003509}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.001071}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000286}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000286}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000286}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000286}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000286}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000286}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000857}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000571}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000286}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000214}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000286}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000286}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00006140}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00001754}, {205,0.00005263}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00026316}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00003509}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000877}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00488596}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00010526}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00001754}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00002632}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000877}, {316,0.00000000}, {317,0.00001754}, {318,0.00000000}, {319,0.00002632}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000877}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00042982}, {330,0.00000000}, {331,0.00001754}, {332,0.00001754}, {333,0.00000877}, {334,0.00001754}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000877}, {342,0.00000000}, {343,0.00001754}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00001754}, {348,0.00000000}, {349,0.00000877}, {350,0.00003509}, {351,0.00000000}, {352,0.00000000}, {353,0.00000877}, {354,0.00000000}, {355,0.00000877}, {356,0.00000877}, {357,0.00000000}, {358,0.00000000}, {359,0.00011404}, {360,0.00000000}, {361,0.00000000}, {362,0.00000877}, {363,0.00001754}, {364,0.00008772}, {365,0.00003509}, {366,0.00003509}, {367,0.00009649}, {368,0.00000000}, {369,0.00000000}, {370,0.00000877}, {371,0.00005263}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00008772}, {376,0.00001754}, {377,0.00007018}, {378,0.00001754}, {379,0.00000877}, {380,0.00000000}, {381,0.00000877}, {382,0.00082456}, {383,0.00033333}, {384,0.00001754}, {385,0.00001754}, {386,0.00000000}, {387,0.00003509}, {388,0.00000877}, {389,0.00007895}, {390,0.00000877}, {391,0.00000000}, {392,0.00000000}, {393,0.00007018}, {394,0.00006140}, {395,0.00006140}, {396,0.00001754}, {397,0.00000877}, {398,0.00000000}, {399,0.00000000}, {400,0.00004386}, {401,0.00010526}, {402,0.00005263}, {403,0.00009649}, {404,0.00007895}, {405,0.00004386}, {406,0.00001754}, {407,0.00008772}, {408,0.00000877}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00002632}, {415,0.00007895}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00757895}, {420,0.00012281}, {421,0.00022807}, {422,0.00024561}, {423,0.00062281}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00004386}, {428,0.00000877}, {429,0.00005263}, {430,0.00028070}, {431,0.00085088}, {432,0.00013158}, {433,0.00043860}, {434,0.00035088}, {435,0.00072807}, {436,0.00037719}, {437,0.00005263}, {438,0.00007018}, {439,0.00054386}, {440,0.00046491}, {441,0.00077193}, {442,0.00077193}, {443,0.00005263}, {444,0.00027193}, {445,0.00092982}, {446,0.00098246}, {447,0.00026316}, {448,0.00003509}, {449,0.00007018}, {450,0.00013158}, {451,0.00053509}, {452,0.00047368}, {453,0.00073684}, {454,0.00071930}, {455,0.00004386}, {456,0.00001754}, {457,0.00037719}, {458,0.00075439}, {459,0.00092105}, {460,0.00835088}, {461,0.00029825}, {462,0.00098246}, {463,0.00100000}, {464,0.00001754}, {465,0.00014912}, {466,0.00054386}, {467,0.00090351}, {468,0.00082456}, {469,0.00032456}, {470,0.00092105}, {471,0.00100000}, {472,0.00016667}, {473,0.00085965}, {474,0.00098246}, {475,0.00042982}, {476,0.00097368}, {477,0.00100000}, {478,0.00089474}, {479,0.00100000}, {480,0.00013158}, {481,0.00068421}, {482,0.00095614}, {483,0.00099123}, {484,0.00048246}, {485,0.00098246}, {486,0.00098246}, {487,0.00099123}, {488,0.00098246}, {489,0.00036842}, {490,0.00100000}, {491,0.00100000}, {492,0.00094737}, {493,0.00161404}, {494,0.00097368}, {495,0.00100000}, {496,0.00083333}, {497,0.00099123}, {498,0.00057895}, {499,0.00100000}, {500,0.00121053}, {505,0.00095614}, {510,0.00100000}, {515,0.00100000}, {520,0.00043860}, {525,0.00100000}, {530,0.00071053}, {535,0.00100000}, {540,0.00100000}, {545,0.00096491}, {550,0.00100000}, {555,0.00100877}, {560,0.00084211}, {565,0.00104386}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100877}, {600,0.00100000}, {605,0.00116667}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00107895}, {635,0.00116667}, {640,0.00100000}, {645,0.00110526}, {650,0.00100000}, {655,0.00100000}, {660,0.00105263}, {665,0.00143860}, {670,0.00102632}, {675,0.00112281}, {680,0.00792105}, {685,0.00104386}, {690,0.00125439}, {695,0.00111404}, {700,0.00100000}, {705,0.00102632}, {710,0.00147368}, {715,0.00114035}, {720,0.00100877}, {725,0.00124561}, {730,0.00103509}, {735,0.00107895}, {740,0.00101754}, {745,0.00141228}, {750,0.00137719}, {755,0.00136842}, {760,0.00117544}, {765,0.00137719}, {770,0.00112281}, {775,0.00109649}, {780,0.00103509}, {785,0.00145614}, {790,0.00141228}, {795,0.00150877}, {800,0.00122807}, {805,0.00133333}, {810,0.00140351}, {815,0.00167544}, {820,0.00104386}, {825,0.00121930}, {830,0.00155263}, {835,0.00167544}, {840,0.00110526}, {845,0.00134211}, {850,0.00150000}, {855,0.00208772}, {860,0.00147368}, {865,0.00158772}, {870,0.00129825}, {875,0.00194737}, {880,0.00128947}, {885,0.00207895}, {890,0.00238596}, {895,0.00191228}, {900,0.00119298}, {905,0.00159649}, {910,0.00142105}, {915,0.00198246}, {920,0.00148246}, {925,0.00163158}, {930,0.00205263}, {935,0.00208772}, {940,0.00202632}, {945,0.00184211}, {950,0.00194737}, {955,0.00208772}, {960,0.00150000}, {965,0.00166667}, {970,0.00150877}, {975,0.00200000}, {980,0.00196491}, {985,0.00209649}, {990,0.00224561}, {995,0.00197368}, {1000,0.00196491}, {1010,0.00207895}, {1020,0.00233333}, {1030,0.00190351}, {1040,0.00175439}, {1050,0.00206140}, {1060,0.00214912}, {1070,0.00246491}, {1080,0.00218421}, {1090,0.01047368}, {1100,0.00220175}, {1110,0.00210526}, {1120,0.00235088}, {1130,0.00232456}, {1140,0.00227193}, {1150,0.00256140}, {1160,0.00232456}, {1170,0.00228070}, {1180,0.00235088}, {1190,0.00242982}, {1200,0.00250000}, {1210,0.00306140}, {1220,0.00230702}, {1230,0.00286842}, {1240,0.00236842}, {1250,0.00278947}, {1260,0.00253509}, {1270,0.00916667}, {1280,0.00268421}, {1290,0.00316667}, {1300,0.00264912}, {1310,0.00278947}, {1320,0.00255263}, {1330,0.00336842}, {1340,0.00346491}, {1350,0.00274561}, {1360,0.00249123}, {1370,0.01353509}, {1380,0.00313158}, {1390,0.00353509}, {1400,0.00326316}, {1410,0.00332456}, {1420,0.00345614}, {1430,0.00328947}, {1440,0.00337719}, {1450,0.00393860}, {1460,0.00376316}, {1470,0.00426316}, {1480,0.00302632}, {1490,0.00378070}, {1500,0.00411404}, {1510,0.01186842}, {1520,0.00337719}, {1530,0.00413158}, {1540,0.00349123}, {1550,0.00375439}, {1560,0.00357018}, {1570,0.00353509}, {1580,0.00377193}, {1590,0.01267544}, {1600,0.00337719}, {1610,0.00374561}, {1620,0.00413158}, {1630,0.00420175}, {1640,0.00392105}, {1650,0.00392982}, {1660,0.00397368}, {1670,0.00382456}, {1680,0.00410526}, {1690,0.00421930}, {1700,0.00407018}, {1710,0.00446491}, {1720,0.01357895}, {1730,0.00391228}, {1740,0.00439474}, {1750,0.00473684}, {1760,0.00408772}, {1770,0.00469298}, {1780,0.00454386}, {1790,0.00512281}, {1800,0.00425439}, {1810,0.00457018}, {1820,0.00445614}, {1830,0.00507895}, {1840,0.00464912}, {1850,0.00501754}, {1860,0.00459649}, {1870,0.00499123}, {1880,0.00498246}, {1890,0.00507018}, {1900,0.00534211}, {1910,0.00529825}, {1920,0.00423684}, {1930,0.00514912}, {1940,0.00457895}, {1950,0.00538596}, {1960,0.00507895}, {1970,0.00500000}, {1980,0.01091228}, {1990,0.00528947}, {2000,0.00475439}, {2050,0.00490351}, {2100,0.00478947}, {2150,0.00562281}, {2200,0.00541228}, {2250,0.00564912}, {2300,0.00672807}, {2350,0.00700000}, {2400,0.00612281}, {2450,0.01315789}, {2500,0.00663158}, {2550,0.00746491}, {2600,0.00653509}, {2650,0.00743860}, {2700,0.00728070}, {2750,0.00828947}, {2800,0.00787719}, {2850,0.00748246}, {2900,0.00844737}, {2950,0.00848246}, {3000,0.00864035}, {3050,0.00940351}, {3100,0.00877193}, {3150,0.01514035}, {3200,0.00847368}, {3250,0.00949123}, {3300,0.00951754}, {3350,0.00948246}, {3400,0.00946491}, {3450,0.01048246}, {3500,0.01043860}, {3550,0.01115789}, {3600,0.00950000}, {3650,0.01028070}, {3700,0.01125439}, {3750,0.01097368}, {3800,0.01151754}, {3850,0.01128070}, {3900,0.01203509}, {3950,0.02008772}, {4000,0.01155263}, {4050,0.01215789}, {4100,0.01087719}, {4150,0.01234211}, {4200,0.01217544}, {4250,0.01880702}, {4300,0.01277193}, {4350,0.01435965}, {4400,0.01259649}, {4450,0.01309649}, {4500,0.01341228}, {4550,0.01404386}, {4600,0.01466667}, {4650,0.01364912}, {4700,0.01490351}, {4750,0.01400877}, {4800,0.01449123}, {4850,0.01603509}, {4900,0.01456140}, {4950,0.02232456}, {5000,0.01485965}, {5050,0.01621053}, {5100,0.02577193}, {5150,0.01546491}, {5200,0.01471053}, {5250,0.01397368}, {5300,0.01617544}, {5350,0.01709649}, {5400,0.01637719}, {5450,0.01696491}, {5500,0.01746491}, {5550,0.01818421}, {5600,0.01714035}, {5650,0.01578070}, {5700,0.01561404}, {5750,0.02541228}, {5800,0.01728070}, {5850,0.01905263}, {5900,0.01778070}, {5950,0.01988596}, {6000,0.01915789}, {6050,0.020000}, {6100,0.028643}, {6150,0.018643}, {6200,0.019000}, {6250,0.019143}, {6300,0.020000}, {6350,0.021429}, {6400,0.018286}, {6450,0.020429}, {6500,0.020714}, {6550,0.020214}, {6600,0.020857}, {6650,0.022786}, {6700,0.022071}, {6750,0.022786}, {6800,0.020857}, {6850,0.021857}, {6900,0.023214}, {6950,0.031286}, {7000,0.031429}, {7050,0.024214}, {7100,0.025214}, {7150,0.035071}, {7200,0.022143}, {7250,0.023071}, {7300,0.022429}, {7350,0.026857}, {7400,0.024000}, {7450,0.042214}, {7500,0.024929}, {7550,0.036071}, {7600,0.025071}, {7650,0.025714}, {7700,0.023929}, {7750,0.025071}, {7800,0.026071}, {7850,0.026143}, {7900,0.027214}, {7950,0.026357}, {8000,0.024929}, {8050,0.027857}, {8100,0.026786}, {8150,0.029571}, {8200,0.034214}, {8250,0.027071}, {8300,0.027143}, {8350,0.036286}, {8400,0.026143}, {8450,0.025714}, {8500,0.036357}, {8550,0.028357}, {8600,0.036929}, {8650,0.043357}, {8700,0.030571}, {8750,0.030643}, {8800,0.027357}, {8850,0.038357}, {8900,0.047429}, {8950,0.030929}, {9000,0.029357}, {9050,0.048857}, {9100,0.030143}, {9150,0.054214}, {9200,0.031143}, {9250,0.029071}, {9300,0.030429}, {9350,0.031571}, {9400,0.031500}, {9450,0.042357}, {9500,0.031000}, {9550,0.040857}, {9600,0.028786}, {9650,0.034000}, {9700,0.032929}, {9750,0.042143}, {9800,0.030643}, {9850,0.033714}, {9900,0.042214}, {9950,0.033786}, {10000,0.031857}, {10100,0.043214}, {10200,0.036071}, {10300,0.034143}, {10400,0.041714}, {10500,0.058643}, {10600,0.033214}, {10700,0.036714}, {10800,0.043929}, {10900,0.035643}, {11000,0.047071}, {11100,0.037786}, {11200,0.044643}, {11300,0.037214}, {11400,0.035786}, {11500,0.052714}, {11600,0.036071}, {11700,0.040357}, {11800,0.066571}, {11900,0.042571}, {12000,0.039786}, {12100,0.048929}, {12200,0.041929}, {12300,0.048286}, {12400,0.048357}, {12500,0.068714}, {12600,0.052000}, {12700,0.041714}, {12800,0.037857}, {12900,0.042429}, {13000,0.068643}, {13100,0.053500}, {13200,0.042714}, {13300,0.048286}, {13400,0.053643}, {13500,0.045786}, {13600,0.041786}, {13700,0.043357}, {13800,0.057571}, {13900,0.046643}, {14000,0.055714}, {14100,0.047643}, {14200,0.050000}, {14300,0.060786}, {14400,0.052786}, {14500,0.079786}, {14600,0.045714}, {14700,0.053571}, {14800,0.050143}, {14900,0.059214}, {15000,0.049429}, {15100,0.053786}, {15200,0.050929}, {15300,0.067714}, {15400,0.257786}, {15500,0.077357}, {15600,0.053071}, {15700,0.054786}, {15800,0.073500}, {15900,0.055786}, {16000,0.064429}, {16100,0.068000}, {16200,0.054571}, {16300,0.071143}, {16400,0.048071}, {16500,0.065357}, {16600,0.057714}, {16700,0.057286}, {16800,0.084286}, {16900,0.065643}, {17000,0.059714}, {17100,0.059714}, {17200,0.089929}, {17300,0.098000}, {17400,0.061786}, {17500,0.070929}, {17600,0.067143}, {17700,0.081857}, {17800,0.079000}, {17900,0.065714}, {18000,0.099571}, {18100,0.083214}, {18200,0.072571}, {18300,0.067714}, {18400,0.074000}, {18500,0.058357}, {18600,0.063786}, {18700,0.073000}, {18800,0.089143}, {18900,0.111071}, {19000,0.076500}, {19100,0.078000}, {19200,0.072571}, {19300,0.079429}, {19400,0.067786}, {19500,0.067429}, {19600,0.096857}, {19700,0.084286}, {19800,0.097714}, {19900,0.093357}, {20000,0.080286}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["eval lazy"]["user"] = {{1,0.00000000}, {2,0.00002632}, {3,0.00002632}, {4,0.00002632}, {5,0.00003509}, {6,0.00003509}, {7,0.00000000}, {8,0.00002632}, {9,0.00000000}, {10,0.00000000}, {11,0.00008772}, {12,0.00010526}, {13,0.00000000}, {14,0.00007895}, {15,0.00003509}, {16,0.00008772}, {17,0.00006140}, {18,0.00000000}, {19,0.00002632}, {20,0.00002632}, {21,0.00007018}, {22,0.00008772}, {23,0.00003509}, {24,0.00007895}, {25,0.00002632}, {26,0.00005263}, {27,0.00000000}, {28,0.00007018}, {29,0.00006140}, {30,0.00014035}, {31,0.00007018}, {32,0.00000000}, {33,0.00005263}, {34,0.00008772}, {35,0.00003509}, {36,0.00006140}, {37,0.00008772}, {38,0.00006140}, {39,0.00008772}, {40,0.00007018}, {41,0.00002632}, {42,0.00005263}, {43,0.00002632}, {44,0.00000000}, {45,0.00012281}, {46,0.00006140}, {47,0.00005263}, {48,0.00017544}, {49,0.00012281}, {50,0.00012281}, {51,0.00005263}, {52,0.00006140}, {53,0.00003509}, {54,0.00026316}, {55,0.00006140}, {56,0.00012281}, {57,0.00006140}, {58,0.00006140}, {59,0.00016667}, {60,0.00002632}, {61,0.00018421}, {62,0.00018421}, {63,0.00015789}, {64,0.00025439}, {65,0.00015789}, {66,0.00009649}, {67,0.00013158}, {68,0.00009649}, {69,0.00018421}, {70,0.00011404}, {71,0.00018421}, {72,0.00008772}, {73,0.00022807}, {74,0.00006140}, {75,0.00014035}, {76,0.00015789}, {77,0.00028947}, {78,0.00023684}, {79,0.00012281}, {80,0.00022807}, {81,0.00013158}, {82,0.00027193}, {83,0.00009649}, {84,0.00035088}, {85,0.00020175}, {86,0.00012281}, {87,0.00027193}, {88,0.00021053}, {89,0.00009649}, {90,0.00014035}, {91,0.00020175}, {92,0.00015789}, {93,0.00000000}, {94,0.00023684}, {95,0.00006140}, {96,0.00014035}, {97,0.00010526}, {98,0.00007895}, {99,0.00022807}, {100,0.00033333}, {101,0.00021053}, {102,0.00016667}, {103,0.00030702}, {104,0.00007895}, {105,0.00021053}, {106,0.00014035}, {107,0.00020175}, {108,0.00006140}, {109,0.00021930}, {110,0.00014912}, {111,0.00016667}, {112,0.00013158}, {113,0.00013158}, {114,0.00025439}, {115,0.00023684}, {116,0.00018421}, {117,0.00030702}, {118,0.00022807}, {119,0.00034211}, {120,0.00014035}, {121,0.00017544}, {122,0.00031579}, {123,0.00033333}, {124,0.00018421}, {125,0.00038596}, {126,0.00016667}, {127,0.00030702}, {128,0.00019298}, {129,0.00020175}, {130,0.00014035}, {131,0.00019298}, {132,0.00029825}, {133,0.00022807}, {134,0.00025439}, {135,0.00027193}, {136,0.00010526}, {137,0.00020175}, {138,0.00017544}, {139,0.00040351}, {140,0.00015789}, {141,0.00017544}, {142,0.00026316}, {143,0.00030702}, {144,0.00015789}, {145,0.00028947}, {146,0.00033333}, {147,0.00033333}, {148,0.00035965}, {149,0.00020175}, {150,0.00029825}, {151,0.00021930}, {152,0.00027193}, {153,0.00028947}, {154,0.00016667}, {155,0.00026316}, {156,0.00018421}, {157,0.00015789}, {158,0.00040351}, {159,0.00035965}, {160,0.00029825}, {161,0.00055263}, {162,0.00026316}, {163,0.00014912}, {164,0.00035088}, {165,0.00028070}, {166,0.00039474}, {167,0.00020175}, {168,0.00028947}, {169,0.00029825}, {170,0.00015789}, {171,0.00028070}, {172,0.00034211}, {173,0.00042982}, {174,0.00033333}, {175,0.00035088}, {176,0.00018421}, {177,0.00044737}, {178,0.00025439}, {179,0.00025439}, {180,0.00037719}, {181,0.00020175}, {182,0.00042982}, {183,0.00030702}, {184,0.00026316}, {185,0.00029825}, {186,0.00039474}, {187,0.00034211}, {188,0.00041228}, {189,0.00033333}, {190,0.00042982}, {191,0.00048246}, {192,0.00046491}, {193,0.00033333}, {194,0.00039474}, {195,0.00032456}, {196,0.00038596}, {197,0.00040351}, {198,0.00022807}, {199,0.00038596}, {200,0.00033333}, {201,0.00027193}, {202,0.00021930}, {203,0.00048246}, {204,0.00056140}, {205,0.00025439}, {206,0.00051754}, {207,0.00058772}, {208,0.00021930}, {209,0.00066667}, {210,0.00059649}, {211,0.00042982}, {212,0.00035088}, {213,0.00026316}, {214,0.00053509}, {215,0.00042982}, {216,0.00049123}, {217,0.00028947}, {218,0.00026316}, {219,0.00029825}, {220,0.00037719}, {221,0.00048246}, {222,0.00041228}, {223,0.00032456}, {224,0.00042982}, {225,0.00042105}, {226,0.00050000}, {227,0.00050877}, {228,0.00057895}, {229,0.00051754}, {230,0.00035088}, {231,0.00069298}, {232,0.00042105}, {233,0.00029825}, {234,0.00052632}, {235,0.00071930}, {236,0.00047368}, {237,0.00040351}, {238,0.00021930}, {239,0.00051754}, {240,0.00042982}, {241,0.00046491}, {242,0.00054386}, {243,0.00039474}, {244,0.00057895}, {245,0.00070175}, {246,0.00059649}, {247,0.00047368}, {248,0.00069298}, {249,0.00081579}, {250,0.00062281}, {251,0.00057018}, {252,0.00033333}, {253,0.00028947}, {254,0.00038596}, {255,0.00067544}, {256,0.00047368}, {257,0.00054386}, {258,0.00043860}, {259,0.00038596}, {260,0.00036842}, {261,0.00044737}, {262,0.00052632}, {263,0.00047368}, {264,0.00471930}, {265,0.00054386}, {266,0.00064035}, {267,0.00042105}, {268,0.00059649}, {269,0.00043860}, {270,0.00058772}, {271,0.00045614}, {272,0.00031579}, {273,0.00061404}, {274,0.00053509}, {275,0.00026316}, {276,0.00040351}, {277,0.00071930}, {278,0.00050000}, {279,0.00075439}, {280,0.00063158}, {281,0.00055263}, {282,0.00064912}, {283,0.00072807}, {284,0.00070175}, {285,0.00053509}, {286,0.00059649}, {287,0.00058772}, {288,0.00064035}, {289,0.00037719}, {290,0.00053509}, {291,0.00064912}, {292,0.00034211}, {293,0.00044737}, {294,0.00062281}, {295,0.00071930}, {296,0.00059649}, {297,0.00051754}, {298,0.00053509}, {299,0.00082456}, {300,0.00077193}, {301,0.00061404}, {302,0.00063158}, {303,0.00072807}, {304,0.00045614}, {305,0.00040351}, {306,0.00069298}, {307,0.00074561}, {308,0.00050000}, {309,0.00080702}, {310,0.00046491}, {311,0.00075439}, {312,0.00067544}, {313,0.00057018}, {314,0.00044737}, {315,0.00066667}, {316,0.00065789}, {317,0.00050877}, {318,0.00063158}, {319,0.00088596}, {320,0.00044737}, {321,0.00030702}, {322,0.00084211}, {323,0.00050000}, {324,0.00049123}, {325,0.00072807}, {326,0.00062281}, {327,0.00055263}, {328,0.00030702}, {329,0.00128947}, {330,0.00046491}, {331,0.00064912}, {332,0.00060526}, {333,0.00051754}, {334,0.00059649}, {335,0.00064912}, {336,0.00064912}, {337,0.00064035}, {338,0.00055263}, {339,0.00045614}, {340,0.00064912}, {341,0.00054386}, {342,0.00063158}, {343,0.00075439}, {344,0.00077193}, {345,0.00059649}, {346,0.00043860}, {347,0.00057018}, {348,0.00070175}, {349,0.00048246}, {350,0.00070175}, {351,0.00073684}, {352,0.00059649}, {353,0.00061404}, {354,0.00085088}, {355,0.00053509}, {356,0.00070175}, {357,0.00059649}, {358,0.00069298}, {359,0.00060526}, {360,0.00051754}, {361,0.00066667}, {362,0.00072807}, {363,0.00042982}, {364,0.00064035}, {365,0.00070175}, {366,0.00053509}, {367,0.00064912}, {368,0.00078070}, {369,0.00062281}, {370,0.00079825}, {371,0.00085965}, {372,0.00070175}, {373,0.00064912}, {374,0.00072807}, {375,0.00091228}, {376,0.00066667}, {377,0.00112281}, {378,0.00060526}, {379,0.00058772}, {380,0.00069298}, {381,0.00071930}, {382,0.00149123}, {383,0.00082456}, {384,0.00052632}, {385,0.00080702}, {386,0.00077193}, {387,0.00078070}, {388,0.00076316}, {389,0.00081579}, {390,0.00052632}, {391,0.00072807}, {392,0.00050877}, {393,0.00078070}, {394,0.00091228}, {395,0.00060526}, {396,0.00107895}, {397,0.00057018}, {398,0.00080702}, {399,0.00057895}, {400,0.00071053}, {401,0.00084211}, {402,0.00064035}, {403,0.00078947}, {404,0.00059649}, {405,0.00053509}, {406,0.00075439}, {407,0.00085088}, {408,0.00061404}, {409,0.00068421}, {410,0.00045614}, {411,0.00050877}, {412,0.00069298}, {413,0.00091228}, {414,0.00055263}, {415,0.00064912}, {416,0.00083333}, {417,0.00071930}, {418,0.00060526}, {419,0.00792982}, {420,0.00068421}, {421,0.00057018}, {422,0.00084211}, {423,0.00073684}, {424,0.00059649}, {425,0.00071053}, {426,0.00056140}, {427,0.00033333}, {428,0.00079825}, {429,0.00071053}, {430,0.00069298}, {431,0.00081579}, {432,0.00083333}, {433,0.00071930}, {434,0.00076316}, {435,0.00094737}, {436,0.00070175}, {437,0.00071930}, {438,0.00090351}, {439,0.00079825}, {440,0.00095614}, {441,0.00090351}, {442,0.00118421}, {443,0.00105263}, {444,0.00070175}, {445,0.00128947}, {446,0.00085965}, {447,0.00106140}, {448,0.00053509}, {449,0.00075439}, {450,0.00071053}, {451,0.00091228}, {452,0.00098246}, {453,0.00106140}, {454,0.00104386}, {455,0.00064035}, {456,0.00093860}, {457,0.00086842}, {458,0.00091228}, {459,0.00089474}, {460,0.00861404}, {461,0.00107018}, {462,0.00085088}, {463,0.00089474}, {464,0.00069298}, {465,0.00091228}, {466,0.00094737}, {467,0.00093860}, {468,0.00082456}, {469,0.00078947}, {470,0.00106140}, {471,0.00112281}, {472,0.00086842}, {473,0.00099123}, {474,0.00089474}, {475,0.00089474}, {476,0.00116667}, {477,0.00099123}, {478,0.00097368}, {479,0.00116667}, {480,0.00085965}, {481,0.00095614}, {482,0.00092982}, {483,0.00096491}, {484,0.00097368}, {485,0.00114912}, {486,0.00122807}, {487,0.00124561}, {488,0.00113158}, {489,0.00095614}, {490,0.00115789}, {491,0.00093860}, {492,0.00085965}, {493,0.00206140}, {494,0.00102632}, {495,0.00114912}, {496,0.00091228}, {497,0.00112281}, {498,0.00088596}, {499,0.00084211}, {500,0.00152632}, {505,0.00101754}, {510,0.00125439}, {515,0.00107018}, {520,0.00090351}, {525,0.00110526}, {530,0.00073684}, {535,0.00152632}, {540,0.00121930}, {545,0.00100877}, {550,0.00112281}, {555,0.00126316}, {560,0.00080702}, {565,0.00134211}, {570,0.00122807}, {575,0.00121930}, {580,0.00092105}, {585,0.00099123}, {590,0.00096491}, {595,0.00110526}, {600,0.00111404}, {605,0.00174561}, {610,0.00089474}, {615,0.00092982}, {620,0.00100877}, {625,0.00127193}, {630,0.00156140}, {635,0.00143860}, {640,0.00126316}, {645,0.00148246}, {650,0.00111404}, {655,0.00133333}, {660,0.00102632}, {665,0.00162281}, {670,0.00128070}, {675,0.00160526}, {680,0.00796491}, {685,0.00137719}, {690,0.00145614}, {695,0.00159649}, {700,0.00130702}, {705,0.00157018}, {710,0.00205263}, {715,0.00154386}, {720,0.00142982}, {725,0.00135088}, {730,0.00163158}, {735,0.00198246}, {740,0.00114912}, {745,0.00144737}, {750,0.00191228}, {755,0.00174561}, {760,0.00193860}, {765,0.00164912}, {770,0.00150000}, {775,0.00154386}, {780,0.00128070}, {785,0.00174561}, {790,0.00180702}, {795,0.00211404}, {800,0.00175439}, {805,0.00174561}, {810,0.00164912}, {815,0.00197368}, {820,0.00143860}, {825,0.00131579}, {830,0.00225439}, {835,0.00197368}, {840,0.00122807}, {845,0.00192982}, {850,0.00215789}, {855,0.00194737}, {860,0.00160526}, {865,0.00216667}, {870,0.00164035}, {875,0.00200877}, {880,0.00172807}, {885,0.00232456}, {890,0.00266667}, {895,0.00197368}, {900,0.00184211}, {905,0.00189474}, {910,0.00196491}, {915,0.00269298}, {920,0.00171053}, {925,0.00196491}, {930,0.00240351}, {935,0.00190351}, {940,0.00201754}, {945,0.00188596}, {950,0.00222807}, {955,0.00199123}, {960,0.00200877}, {965,0.00196491}, {970,0.00178070}, {975,0.00188596}, {980,0.00191228}, {985,0.00249123}, {990,0.00230702}, {995,0.00220175}, {1000,0.00204386}, {1010,0.00233333}, {1020,0.00259649}, {1030,0.00184211}, {1040,0.00205263}, {1050,0.00207895}, {1060,0.00268421}, {1070,0.00279825}, {1080,0.00224561}, {1090,0.01099123}, {1100,0.00242105}, {1110,0.00210526}, {1120,0.00252632}, {1130,0.00222807}, {1140,0.00219298}, {1150,0.00251754}, {1160,0.00247368}, {1170,0.00246491}, {1180,0.00242982}, {1190,0.00247368}, {1200,0.00254386}, {1210,0.00290351}, {1220,0.00228070}, {1230,0.00269298}, {1240,0.00233333}, {1250,0.00268421}, {1260,0.00254386}, {1270,0.00911404}, {1280,0.00292105}, {1290,0.00299123}, {1300,0.00269298}, {1310,0.00267544}, {1320,0.00256140}, {1330,0.00315789}, {1340,0.00360526}, {1350,0.00282456}, {1360,0.00268421}, {1370,0.01389474}, {1380,0.00308772}, {1390,0.00350000}, {1400,0.00307018}, {1410,0.00314912}, {1420,0.00360526}, {1430,0.00311404}, {1440,0.00319298}, {1450,0.00386842}, {1460,0.00363158}, {1470,0.00426316}, {1480,0.00307018}, {1490,0.00361404}, {1500,0.00406140}, {1510,0.01223684}, {1520,0.00337719}, {1530,0.00392105}, {1540,0.00339474}, {1550,0.00357895}, {1560,0.00353509}, {1570,0.00348246}, {1580,0.00380702}, {1590,0.01280702}, {1600,0.00320175}, {1610,0.00350877}, {1620,0.00382456}, {1630,0.00419298}, {1640,0.00362281}, {1650,0.00375439}, {1660,0.00397368}, {1670,0.00351754}, {1680,0.00395614}, {1690,0.00407018}, {1700,0.00376316}, {1710,0.00433333}, {1720,0.01362281}, {1730,0.00371053}, {1740,0.00407018}, {1750,0.00479825}, {1760,0.00415789}, {1770,0.00459649}, {1780,0.00500000}, {1790,0.00514035}, {1800,0.00417544}, {1810,0.00467544}, {1820,0.00418421}, {1830,0.00534211}, {1840,0.00469298}, {1850,0.00486842}, {1860,0.00415789}, {1870,0.00506140}, {1880,0.00487719}, {1890,0.00500877}, {1900,0.00514035}, {1910,0.00557895}, {1920,0.00392982}, {1930,0.00506140}, {1940,0.00451754}, {1950,0.00514912}, {1960,0.00500877}, {1970,0.00448246}, {1980,0.01140351}, {1990,0.00503509}, {2000,0.00448246}, {2050,0.00484211}, {2100,0.00479825}, {2150,0.00565789}, {2200,0.00514912}, {2250,0.00592105}, {2300,0.00677193}, {2350,0.00699123}, {2400,0.00627193}, {2450,0.01300877}, {2500,0.00673684}, {2550,0.00750000}, {2600,0.00661404}, {2650,0.00734211}, {2700,0.00712281}, {2750,0.00836842}, {2800,0.00800000}, {2850,0.00770175}, {2900,0.00867544}, {2950,0.00906140}, {3000,0.00915789}, {3050,0.00939474}, {3100,0.00895614}, {3150,0.01515789}, {3200,0.00829825}, {3250,0.00979825}, {3300,0.00961404}, {3350,0.00954386}, {3400,0.00926316}, {3450,0.01050877}, {3500,0.01103509}, {3550,0.01151754}, {3600,0.00991228}, {3650,0.01003509}, {3700,0.01150000}, {3750,0.01151754}, {3800,0.01186842}, {3850,0.01190351}, {3900,0.01253509}, {3950,0.02006140}, {4000,0.01218421}, {4050,0.01237719}, {4100,0.01144737}, {4150,0.01243860}, {4200,0.01242982}, {4250,0.01902632}, {4300,0.01295614}, {4350,0.01464035}, {4400,0.01315789}, {4450,0.01329825}, {4500,0.01334211}, {4550,0.01423684}, {4600,0.01468421}, {4650,0.01392982}, {4700,0.01520175}, {4750,0.01439474}, {4800,0.01459649}, {4850,0.01603509}, {4900,0.01485088}, {4950,0.02258772}, {5000,0.01503509}, {5050,0.01641228}, {5100,0.02587719}, {5150,0.01570175}, {5200,0.01490351}, {5250,0.01395614}, {5300,0.01630702}, {5350,0.01702632}, {5400,0.01642982}, {5450,0.01679825}, {5500,0.01763158}, {5550,0.01791228}, {5600,0.01681579}, {5650,0.01623684}, {5700,0.01550000}, {5750,0.02537719}, {5800,0.01745614}, {5850,0.01866667}, {5900,0.01768421}, {5950,0.01924561}, {6000,0.01878070}, {6050,0.019071}, {6100,0.029357}, {6150,0.018000}, {6200,0.018786}, {6250,0.019714}, {6300,0.020571}, {6350,0.021714}, {6400,0.018214}, {6450,0.020143}, {6500,0.021143}, {6550,0.020143}, {6600,0.021000}, {6650,0.023286}, {6700,0.021786}, {6750,0.023000}, {6800,0.020286}, {6850,0.021000}, {6900,0.023571}, {6950,0.031143}, {7000,0.030857}, {7050,0.025071}, {7100,0.025071}, {7150,0.035929}, {7200,0.023286}, {7250,0.023643}, {7300,0.022071}, {7350,0.027500}, {7400,0.024000}, {7450,0.042143}, {7500,0.024214}, {7550,0.035643}, {7600,0.024929}, {7650,0.026000}, {7700,0.024429}, {7750,0.025357}, {7800,0.026214}, {7850,0.025500}, {7900,0.026786}, {7950,0.026429}, {8000,0.025214}, {8050,0.028143}, {8100,0.026857}, {8150,0.028643}, {8200,0.034357}, {8250,0.026929}, {8300,0.027357}, {8350,0.036000}, {8400,0.026643}, {8450,0.026000}, {8500,0.036429}, {8550,0.028214}, {8600,0.036714}, {8650,0.043500}, {8700,0.029857}, {8750,0.029643}, {8800,0.027429}, {8850,0.037857}, {8900,0.048286}, {8950,0.030286}, {9000,0.030000}, {9050,0.049143}, {9100,0.029714}, {9150,0.054214}, {9200,0.031143}, {9250,0.029357}, {9300,0.030214}, {9350,0.031214}, {9400,0.031000}, {9450,0.042000}, {9500,0.030714}, {9550,0.041000}, {9600,0.028857}, {9650,0.032214}, {9700,0.033929}, {9750,0.041929}, {9800,0.030571}, {9850,0.034000}, {9900,0.042071}, {9950,0.034071}, {10000,0.031857}, {10100,0.041786}, {10200,0.036214}, {10300,0.033929}, {10400,0.040714}, {10500,0.058643}, {10600,0.033357}, {10700,0.036071}, {10800,0.043357}, {10900,0.035286}, {11000,0.046929}, {11100,0.038071}, {11200,0.046143}, {11300,0.037357}, {11400,0.035786}, {11500,0.053429}, {11600,0.036357}, {11700,0.040214}, {11800,0.066714}, {11900,0.041500}, {12000,0.039786}, {12100,0.049714}, {12200,0.041857}, {12300,0.048286}, {12400,0.048714}, {12500,0.069357}, {12600,0.052357}, {12700,0.041786}, {12800,0.037571}, {12900,0.042143}, {13000,0.068786}, {13100,0.054071}, {13200,0.042429}, {13300,0.048857}, {13400,0.054357}, {13500,0.046286}, {13600,0.041000}, {13700,0.043714}, {13800,0.056929}, {13900,0.046571}, {14000,0.055357}, {14100,0.047786}, {14200,0.050714}, {14300,0.060714}, {14400,0.052857}, {14500,0.079643}, {14600,0.045357}, {14700,0.053214}, {14800,0.050571}, {14900,0.058714}, {15000,0.049286}, {15100,0.053500}, {15200,0.050929}, {15300,0.067143}, {15400,0.256429}, {15500,0.076929}, {15600,0.052429}, {15700,0.055286}, {15800,0.074500}, {15900,0.056071}, {16000,0.063929}, {16100,0.067786}, {16200,0.054143}, {16300,0.070571}, {16400,0.048143}, {16500,0.064929}, {16600,0.058071}, {16700,0.057500}, {16800,0.084000}, {16900,0.065500}, {17000,0.059714}, {17100,0.059643}, {17200,0.090214}, {17300,0.098286}, {17400,0.061786}, {17500,0.069714}, {17600,0.067214}, {17700,0.081857}, {17800,0.078429}, {17900,0.064857}, {18000,0.098071}, {18100,0.083071}, {18200,0.072857}, {18300,0.067643}, {18400,0.074357}, {18500,0.058071}, {18600,0.063000}, {18700,0.072357}, {18800,0.088357}, {18900,0.110714}, {19000,0.077143}, {19100,0.076929}, {19200,0.072786}, {19300,0.080500}, {19400,0.068357}, {19500,0.067571}, {19600,0.096714}, {19700,0.083643}, {19800,0.097571}, {19900,0.093286}, {20000,0.079786}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00003509}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00003509}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00003509}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00003509}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00003509}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00003509}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00003509}, {154,0.00000000}, {155,0.00000000}, {156,0.00003509}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00003509}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00003509}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00002632}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00003509}, {215,0.00003509}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00003509}, {222,0.00002632}, {223,0.00000000}, {224,0.00000000}, {225,0.00007018}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00002632}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00006140}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00003509}, {263,0.00002632}, {264,0.00021053}, {265,0.00000000}, {266,0.00000000}, {267,0.00003509}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00003509}, {277,0.00006140}, {278,0.00000000}, {279,0.00000000}, {280,0.00003509}, {281,0.00003509}, {282,0.00000000}, {283,0.00000000}, {284,0.00007018}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00003509}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00006140}, {309,0.00000000}, {310,0.00000000}, {311,0.00003509}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00003509}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00003509}, {375,0.00000000}, {376,0.00002632}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00003509}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00003509}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00003509}, {418,0.00000000}, {419,0.00000000}, {420,0.00003509}, {421,0.00003509}, {422,0.00000000}, {423,0.00000000}, {424,0.00003509}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00002632}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00003509}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00002632}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00006140}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00002632}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00003509}, {473,0.00000000}, {474,0.00003509}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00003509}, {483,0.00000000}, {484,0.00003509}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00003509}, {490,0.00000000}, {491,0.00003509}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00003509}, {497,0.00000000}, {498,0.00003509}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00003509}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00003509}, {570,0.00000000}, {575,0.00000000}, {580,0.00003509}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00003509}, {605,0.00003509}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00003509}, {690,0.00000000}, {695,0.00000000}, {700,0.00002632}, {705,0.00000000}, {710,0.00003509}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00003509}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00003509}, {770,0.00003509}, {775,0.00002632}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00003509}, {815,0.00000000}, {820,0.00003509}, {825,0.00002632}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00003509}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00007018}, {890,0.00000000}, {895,0.00000000}, {900,0.00002632}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00003509}, {925,0.00007018}, {930,0.00000000}, {935,0.00000000}, {940,0.00007018}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00002632}, {965,0.00003509}, {970,0.00003509}, {975,0.00007018}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00003509}, {1010,0.00003509}, {1020,0.00003509}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00003509}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00002632}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00003509}, {1140,0.00003509}, {1150,0.00000000}, {1160,0.00003509}, {1170,0.00000000}, {1180,0.00002632}, {1190,0.00000000}, {1200,0.00003509}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00003509}, {1280,0.00000000}, {1290,0.00003509}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00007018}, {1340,0.00000000}, {1350,0.00003509}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00003509}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00003509}, {1450,0.00003509}, {1460,0.00000000}, {1470,0.00007018}, {1480,0.00000000}, {1490,0.00002632}, {1500,0.00003509}, {1510,0.00000000}, {1520,0.00003509}, {1530,0.00000000}, {1540,0.00007018}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00003509}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00003509}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00003509}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00007018}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00003509}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00003509}, {1920,0.00000000}, {1930,0.00003509}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00003509}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00007018}, {2300,0.00003509}, {2350,0.00000000}, {2400,0.00007018}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00003509}, {2650,0.00003509}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00003509}, {2950,0.00003509}, {3000,0.00000000}, {3050,0.00007018}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00009649}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00003509}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00003509}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00003509}, {4550,0.00000000}, {4600,0.00003509}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00003509}, {4800,0.00003509}, {4850,0.00006140}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00003509}, {5050,0.00000000}, {5100,0.00003509}, {5150,0.00000000}, {5200,0.00003509}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00003509}, {5500,0.00000000}, {5550,0.00003509}, {5600,0.00003509}, {5650,0.00000000}, {5700,0.00003509}, {5750,0.00007018}, {5800,0.00000000}, {5850,0.00002632}, {5900,0.00000000}, {5950,0.00003509}, {6000,0.00000000}, {6050,0.000000}, {6100,0.000286}, {6150,0.000214}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000286}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000286}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000286}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000286}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000286}, {17600,0.000000}, {17700,0.000286}, {17800,0.000286}, {17900,0.000000}, {18000,0.000286}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000286}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00500877}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00006140}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00863158}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00743860}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00076316}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000877}, {2250,0.00000877}, {2300,0.00007018}, {2350,0.00012281}, {2400,0.00021053}, {2450,0.00042105}, {2500,0.00058772}, {2550,0.00071053}, {2600,0.00082456}, {2650,0.00099123}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00100000}, {3150,0.00100000}, {3200,0.00100000}, {3250,0.00100000}, {3300,0.00100000}, {3350,0.00100000}, {3400,0.00100000}, {3450,0.00100000}, {3500,0.00100000}, {3550,0.00100000}, {3600,0.00100000}, {3650,0.00100000}, {3700,0.00100000}, {3750,0.00100000}, {3800,0.01064035}, {3850,0.00100000}, {3900,0.00100000}, {3950,0.00100000}, {4000,0.00100000}, {4050,0.00100000}, {4100,0.00100000}, {4150,0.00100000}, {4200,0.00100000}, {4250,0.00100000}, {4300,0.00100877}, {4350,0.00100000}, {4400,0.00100877}, {4450,0.00104386}, {4500,0.00102632}, {4550,0.00103509}, {4600,0.00108772}, {4650,0.00116667}, {4700,0.00121930}, {4750,0.00142982}, {4800,0.00155263}, {4850,0.00156140}, {4900,0.00159649}, {4950,0.00159649}, {5000,0.00164035}, {5050,0.00174561}, {5100,0.00192105}, {5150,0.00199123}, {5200,0.00200000}, {5250,0.00200000}, {5300,0.00219298}, {5350,0.00200000}, {5400,0.01608772}, {5450,0.00200000}, {5500,0.00200000}, {5550,0.00200000}, {5600,0.00200000}, {5650,0.00200000}, {5700,0.00200000}, {5750,0.00227193}, {5800,0.00200000}, {5850,0.00200000}, {5900,0.00200000}, {5950,0.00200000}, {6000,0.00200000}, {6050,0.002000}, {6100,0.002000}, {6150,0.003071}, {6200,0.002000}, {6250,0.002000}, {6300,0.002000}, {6350,0.002000}, {6400,0.002000}, {6450,0.002000}, {6500,0.002000}, {6550,0.002071}, {6600,0.002071}, {6650,0.002071}, {6700,0.002071}, {6750,0.002143}, {6800,0.002071}, {6850,0.002357}, {6900,0.003429}, {6950,0.002357}, {7000,0.002500}, {7050,0.002571}, {7100,0.002643}, {7150,0.003000}, {7200,0.002929}, {7250,0.003000}, {7300,0.003000}, {7350,0.003000}, {7400,0.003000}, {7450,0.003000}, {7500,0.003000}, {7550,0.003000}, {7600,0.003000}, {7650,0.002929}, {7700,0.003000}, {7750,0.003000}, {7800,0.003000}, {7850,0.003000}, {7900,0.003000}, {7950,0.003000}, {8000,0.003000}, {8050,0.003000}, {8100,0.003000}, {8150,0.016143}, {8200,0.003000}, {8250,0.015571}, {8300,0.003000}, {8350,0.003000}, {8400,0.003000}, {8450,0.003000}, {8500,0.003000}, {8550,0.003000}, {8600,0.003000}, {8650,0.003857}, {8700,0.003214}, {8750,0.003357}, {8800,0.003357}, {8850,0.003286}, {8900,0.003500}, {8950,0.003500}, {9000,0.003500}, {9050,0.003500}, {9100,0.017214}, {9150,0.003429}, {9200,0.003500}, {9250,0.003500}, {9300,0.003429}, {9350,0.003786}, {9400,0.022714}, {9450,0.003929}, {9500,0.003857}, {9550,0.003857}, {9600,0.003857}, {9650,0.003929}, {9700,0.003929}, {9750,0.004000}, {9800,0.003929}, {9850,0.003929}, {9900,0.004000}, {9950,0.003857}, {10000,0.003929}, {10100,0.003929}, {10200,0.003929}, {10300,0.004000}, {10400,0.004000}, {10500,0.004000}, {10600,0.004000}, {10700,0.004071}, {10800,0.004000}, {10900,0.004286}, {11000,0.006143}, {11100,0.004357}, {11200,0.004357}, {11300,0.004357}, {11400,0.004500}, {11500,0.004500}, {11600,0.004714}, {11700,0.004857}, {11800,0.004929}, {11900,0.020857}, {12000,0.005000}, {12100,0.005000}, {12200,0.025286}, {12300,0.005000}, {12400,0.005000}, {12500,0.005000}, {12600,0.005000}, {12700,0.005143}, {12800,0.005286}, {12900,0.005214}, {13000,0.005357}, {13100,0.005357}, {13200,0.005357}, {13300,0.025357}, {13400,0.005429}, {13500,0.005357}, {13600,0.005500}, {13700,0.005857}, {13800,0.005857}, {13900,0.033286}, {14000,0.005857}, {14100,0.023571}, {14200,0.006000}, {14300,0.006000}, {14400,0.006000}, {14500,0.006000}, {14600,0.006000}, {14700,0.034786}, {14800,0.006214}, {14900,0.006214}, {15000,0.006357}, {15100,0.006357}, {15200,0.006357}, {15300,0.006357}, {15400,0.006429}, {15500,0.006500}, {15600,0.006571}, {15700,0.006786}, {15800,0.006929}, {15900,0.006929}, {16000,0.006929}, {16100,0.006929}, {16200,0.007000}, {16300,0.006929}, {16400,0.007000}, {16500,0.007000}, {16600,0.007071}, {16700,0.007071}, {16800,0.007143}, {16900,0.007286}, {17000,0.007429}, {17100,0.007429}, {17200,0.007500}, {17300,0.007357}, {17400,0.009214}, {17500,0.008929}, {17600,0.007429}, {17700,0.007500}, {17800,0.007857}, {17900,0.026786}, {18000,0.007857}, {18100,0.007929}, {18200,0.007857}, {18300,0.007857}, {18400,0.007857}, {18500,0.009714}, {18600,0.044071}, {18700,0.007929}, {18800,0.008357}, {18900,0.008286}, {19000,0.008286}, {19100,0.008357}, {19200,0.008429}, {19300,0.008357}, {19400,0.008500}, {19500,0.038786}, {19600,0.008643}, {19700,0.008786}, {19800,0.008786}, {19900,0.008929}, {20000,0.008929}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00003509}, {4,0.00000000}, {5,0.00000000}, {6,0.00003509}, {7,0.00000000}, {8,0.00000000}, {9,0.00002632}, {10,0.00000000}, {11,0.00003509}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00008772}, {16,0.00000000}, {17,0.00003509}, {18,0.00005263}, {19,0.00000000}, {20,0.00000000}, {21,0.00003509}, {22,0.00000000}, {23,0.00000000}, {24,0.00006140}, {25,0.00000000}, {26,0.00000000}, {27,0.00003509}, {28,0.00003509}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00006140}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00003509}, {37,0.00003509}, {38,0.00007018}, {39,0.00007018}, {40,0.00000000}, {41,0.00007895}, {42,0.00002632}, {43,0.00000000}, {44,0.00003509}, {45,0.00003509}, {46,0.00011404}, {47,0.00002632}, {48,0.00000000}, {49,0.00003509}, {50,0.00006140}, {51,0.00006140}, {52,0.00008772}, {53,0.00007018}, {54,0.00000000}, {55,0.00002632}, {56,0.00000000}, {57,0.00002632}, {58,0.00000000}, {59,0.00000000}, {60,0.00005263}, {61,0.00008772}, {62,0.00000000}, {63,0.00013158}, {64,0.00002632}, {65,0.00005263}, {66,0.00005263}, {67,0.00006140}, {68,0.00006140}, {69,0.00003509}, {70,0.00008772}, {71,0.00007018}, {72,0.00007895}, {73,0.00003509}, {74,0.00003509}, {75,0.00005263}, {76,0.00002632}, {77,0.00002632}, {78,0.00005263}, {79,0.00006140}, {80,0.00006140}, {81,0.00009649}, {82,0.00003509}, {83,0.00008772}, {84,0.00003509}, {85,0.00002632}, {86,0.00003509}, {87,0.00002632}, {88,0.00010526}, {89,0.00003509}, {90,0.00008772}, {91,0.00014912}, {92,0.00000000}, {93,0.00000000}, {94,0.00002632}, {95,0.00005263}, {96,0.00002632}, {97,0.00006140}, {98,0.00000000}, {99,0.00003509}, {100,0.00005263}, {101,0.00000000}, {102,0.00003509}, {103,0.00007018}, {104,0.00005263}, {105,0.00000000}, {106,0.00010526}, {107,0.00005263}, {108,0.00005263}, {109,0.00005263}, {110,0.00002632}, {111,0.00008772}, {112,0.00000000}, {113,0.00009649}, {114,0.00007895}, {115,0.00014035}, {116,0.00002632}, {117,0.00005263}, {118,0.00002632}, {119,0.00016667}, {120,0.00002632}, {121,0.00011404}, {122,0.00008772}, {123,0.00011404}, {124,0.00007895}, {125,0.00007895}, {126,0.00011404}, {127,0.00012281}, {128,0.00000000}, {129,0.00010526}, {130,0.00006140}, {131,0.00005263}, {132,0.00014035}, {133,0.00007895}, {134,0.00006140}, {135,0.00007895}, {136,0.00003509}, {137,0.00006140}, {138,0.00000000}, {139,0.00002632}, {140,0.00014035}, {141,0.00002632}, {142,0.00010526}, {143,0.00008772}, {144,0.00013158}, {145,0.00008772}, {146,0.00012281}, {147,0.00005263}, {148,0.00008772}, {149,0.00000000}, {150,0.00007018}, {151,0.00011404}, {152,0.00005263}, {153,0.00000000}, {154,0.00012281}, {155,0.00002632}, {156,0.00005263}, {157,0.00002632}, {158,0.00006140}, {159,0.00002632}, {160,0.00010526}, {161,0.00005263}, {162,0.00016667}, {163,0.00006140}, {164,0.00007895}, {165,0.00011404}, {166,0.00008772}, {167,0.00006140}, {168,0.00010526}, {169,0.00011404}, {170,0.00010526}, {171,0.00007895}, {172,0.00011404}, {173,0.00000000}, {174,0.00010526}, {175,0.00006140}, {176,0.00008772}, {177,0.00000000}, {178,0.00002632}, {179,0.00002632}, {180,0.00014035}, {181,0.00006140}, {182,0.00005263}, {183,0.00000000}, {184,0.00005263}, {185,0.00008772}, {186,0.00011404}, {187,0.00002632}, {188,0.00007895}, {189,0.00007895}, {190,0.00019298}, {191,0.00010526}, {192,0.00003509}, {193,0.00011404}, {194,0.00012281}, {195,0.00011404}, {196,0.00000000}, {197,0.00011404}, {198,0.00002632}, {199,0.00005263}, {200,0.00006140}, {201,0.00009649}, {202,0.00007895}, {203,0.00006140}, {204,0.00010526}, {205,0.00006140}, {206,0.00010526}, {207,0.00006140}, {208,0.00007895}, {209,0.00002632}, {210,0.00008772}, {211,0.00009649}, {212,0.00009649}, {213,0.00008772}, {214,0.00000000}, {215,0.00003509}, {216,0.00003509}, {217,0.00003509}, {218,0.00016667}, {219,0.00007018}, {220,0.00022807}, {221,0.00006140}, {222,0.00006140}, {223,0.00012281}, {224,0.00012281}, {225,0.00018421}, {226,0.00000000}, {227,0.00000000}, {228,0.00027193}, {229,0.00015789}, {230,0.00009649}, {231,0.00007018}, {232,0.00015789}, {233,0.00006140}, {234,0.00016667}, {235,0.00006140}, {236,0.00013158}, {237,0.00015789}, {238,0.00010526}, {239,0.00011404}, {240,0.00003509}, {241,0.00014035}, {242,0.00002632}, {243,0.00015789}, {244,0.00008772}, {245,0.00006140}, {246,0.00009649}, {247,0.00500000}, {248,0.00002632}, {249,0.00000000}, {250,0.00026316}, {251,0.00011404}, {252,0.00008772}, {253,0.00008772}, {254,0.00032456}, {255,0.00010526}, {256,0.00012281}, {257,0.00021053}, {258,0.00013158}, {259,0.00002632}, {260,0.00003509}, {261,0.00023684}, {262,0.00019298}, {263,0.00014035}, {264,0.00005263}, {265,0.00013158}, {266,0.00010526}, {267,0.00009649}, {268,0.00007018}, {269,0.00019298}, {270,0.00017544}, {271,0.00023684}, {272,0.00028947}, {273,0.00016667}, {274,0.00021053}, {275,0.00011404}, {276,0.00010526}, {277,0.00011404}, {278,0.00008772}, {279,0.00002632}, {280,0.00008772}, {281,0.00009649}, {282,0.00021930}, {283,0.00019298}, {284,0.00006140}, {285,0.00023684}, {286,0.00020175}, {287,0.00019298}, {288,0.00000000}, {289,0.00015789}, {290,0.00014035}, {291,0.00021930}, {292,0.00009649}, {293,0.00016667}, {294,0.00024561}, {295,0.00021930}, {296,0.00016667}, {297,0.00009649}, {298,0.00015789}, {299,0.00029825}, {300,0.00010526}, {301,0.00018421}, {302,0.00019298}, {303,0.00008772}, {304,0.00000000}, {305,0.00010526}, {306,0.00007018}, {307,0.00016667}, {308,0.00013158}, {309,0.00026316}, {310,0.00011404}, {311,0.00014912}, {312,0.00007018}, {313,0.00015789}, {314,0.00016667}, {315,0.00010526}, {316,0.00026316}, {317,0.00012281}, {318,0.00011404}, {319,0.00021053}, {320,0.00009649}, {321,0.00013158}, {322,0.00009649}, {323,0.00013158}, {324,0.00018421}, {325,0.00011404}, {326,0.00012281}, {327,0.00013158}, {328,0.00014035}, {329,0.00008772}, {330,0.00014035}, {331,0.00026316}, {332,0.00014035}, {333,0.00021930}, {334,0.00000000}, {335,0.00003509}, {336,0.00017544}, {337,0.00011404}, {338,0.00010526}, {339,0.00014912}, {340,0.00012281}, {341,0.00021930}, {342,0.00021053}, {343,0.00022807}, {344,0.00025439}, {345,0.00013158}, {346,0.00012281}, {347,0.00013158}, {348,0.00014912}, {349,0.00014912}, {350,0.00021930}, {351,0.00006140}, {352,0.00013158}, {353,0.00005263}, {354,0.00014035}, {355,0.00024561}, {356,0.00008772}, {357,0.00006140}, {358,0.00021930}, {359,0.00017544}, {360,0.00005263}, {361,0.00002632}, {362,0.00005263}, {363,0.00017544}, {364,0.00014035}, {365,0.00014035}, {366,0.00014035}, {367,0.00025439}, {368,0.00007018}, {369,0.00020175}, {370,0.00015789}, {371,0.00014912}, {372,0.00020175}, {373,0.00019298}, {374,0.00020175}, {375,0.00024561}, {376,0.00035088}, {377,0.00020175}, {378,0.00030702}, {379,0.00011404}, {380,0.00016667}, {381,0.00011404}, {382,0.00015789}, {383,0.00014035}, {384,0.00016667}, {385,0.00016667}, {386,0.00013158}, {387,0.00011404}, {388,0.00017544}, {389,0.00023684}, {390,0.00015789}, {391,0.00008772}, {392,0.00022807}, {393,0.00020175}, {394,0.00013158}, {395,0.00015789}, {396,0.00007895}, {397,0.00014035}, {398,0.00017544}, {399,0.00030702}, {400,0.00011404}, {401,0.00014912}, {402,0.00019298}, {403,0.00014912}, {404,0.00021053}, {405,0.00008772}, {406,0.00009649}, {407,0.00016667}, {408,0.00007895}, {409,0.00016667}, {410,0.00019298}, {411,0.00014035}, {412,0.00014035}, {413,0.00010526}, {414,0.00017544}, {415,0.00014035}, {416,0.00015789}, {417,0.00027193}, {418,0.00011404}, {419,0.00014035}, {420,0.00879825}, {421,0.00007895}, {422,0.00008772}, {423,0.00021053}, {424,0.00028070}, {425,0.00008772}, {426,0.00002632}, {427,0.00023684}, {428,0.00021053}, {429,0.00007895}, {430,0.00027193}, {431,0.00014912}, {432,0.00022807}, {433,0.00020175}, {434,0.00018421}, {435,0.00018421}, {436,0.00036842}, {437,0.00014912}, {438,0.00014912}, {439,0.00014035}, {440,0.00031579}, {441,0.00015789}, {442,0.00017544}, {443,0.00016667}, {444,0.00020175}, {445,0.00013158}, {446,0.00019298}, {447,0.00017544}, {448,0.00025439}, {449,0.00017544}, {450,0.00007895}, {451,0.00017544}, {452,0.00006140}, {453,0.00018421}, {454,0.00014035}, {455,0.00020175}, {456,0.00018421}, {457,0.00017544}, {458,0.00025439}, {459,0.00007018}, {460,0.00022807}, {461,0.00024561}, {462,0.00025439}, {463,0.00028947}, {464,0.00015789}, {465,0.00027193}, {466,0.00016667}, {467,0.00022807}, {468,0.00026316}, {469,0.00019298}, {470,0.00019298}, {471,0.00021930}, {472,0.00016667}, {473,0.00022807}, {474,0.00018421}, {475,0.00028947}, {476,0.00020175}, {477,0.00019298}, {478,0.00029825}, {479,0.00013158}, {480,0.00017544}, {481,0.00019298}, {482,0.00026316}, {483,0.00024561}, {484,0.00029825}, {485,0.00022807}, {486,0.00013158}, {487,0.00018421}, {488,0.00003509}, {489,0.00015789}, {490,0.00006140}, {491,0.00023684}, {492,0.00025439}, {493,0.00031579}, {494,0.00018421}, {495,0.00019298}, {496,0.00024561}, {497,0.00018421}, {498,0.00010526}, {499,0.00020175}, {500,0.00023684}, {505,0.00019298}, {510,0.00016667}, {515,0.00014912}, {520,0.00016667}, {525,0.00003509}, {530,0.00021053}, {535,0.00011404}, {540,0.00012281}, {545,0.00012281}, {550,0.00026316}, {555,0.00021930}, {560,0.00020175}, {565,0.00037719}, {570,0.00014035}, {575,0.00019298}, {580,0.00016667}, {585,0.00054386}, {590,0.00032456}, {595,0.00034211}, {600,0.00015789}, {605,0.00696491}, {610,0.00031579}, {615,0.00022807}, {620,0.00021053}, {625,0.00027193}, {630,0.00009649}, {635,0.00022807}, {640,0.00023684}, {645,0.00021930}, {650,0.00032456}, {655,0.00019298}, {660,0.00034211}, {665,0.00015789}, {670,0.00033333}, {675,0.00028070}, {680,0.00035088}, {685,0.00048246}, {690,0.00022807}, {695,0.00041228}, {700,0.00014912}, {705,0.00027193}, {710,0.00028947}, {715,0.00025439}, {720,0.00028070}, {725,0.00045614}, {730,0.00022807}, {735,0.00014035}, {740,0.00054386}, {745,0.00030702}, {750,0.00016667}, {755,0.00012281}, {760,0.00025439}, {765,0.00028070}, {770,0.00021053}, {775,0.00028070}, {780,0.00035965}, {785,0.00019298}, {790,0.00034211}, {795,0.00035965}, {800,0.00035965}, {805,0.00017544}, {810,0.00060526}, {815,0.00016667}, {820,0.00029825}, {825,0.00053509}, {830,0.00020175}, {835,0.00039474}, {840,0.00034211}, {845,0.00040351}, {850,0.00028947}, {855,0.00037719}, {860,0.00064912}, {865,0.00028070}, {870,0.00024561}, {875,0.00030702}, {880,0.00042982}, {885,0.00026316}, {890,0.00031579}, {895,0.00031579}, {900,0.00033333}, {905,0.00030702}, {910,0.00029825}, {915,0.00027193}, {920,0.00051754}, {925,0.00016667}, {930,0.00040351}, {935,0.00038596}, {940,0.00019298}, {945,0.00042105}, {950,0.00035088}, {955,0.00040351}, {960,0.00046491}, {965,0.00039474}, {970,0.00032456}, {975,0.00064035}, {980,0.00030702}, {985,0.00019298}, {990,0.00052632}, {995,0.00032456}, {1000,0.00038596}, {1010,0.00031579}, {1020,0.00027193}, {1030,0.00034211}, {1040,0.00037719}, {1050,0.00032456}, {1060,0.00021053}, {1070,0.00037719}, {1080,0.00047368}, {1090,0.00024561}, {1100,0.00028070}, {1110,0.00042105}, {1120,0.00035965}, {1130,0.00050000}, {1140,0.00034211}, {1150,0.00042105}, {1160,0.00044737}, {1170,0.00024561}, {1180,0.00035088}, {1190,0.00054386}, {1200,0.00043860}, {1210,0.00041228}, {1220,0.00047368}, {1230,0.00063158}, {1240,0.00050877}, {1250,0.00035088}, {1260,0.00045614}, {1270,0.00055263}, {1280,0.00041228}, {1290,0.00030702}, {1300,0.00069298}, {1310,0.00065789}, {1320,0.00033333}, {1330,0.00038596}, {1340,0.00025439}, {1350,0.00042105}, {1360,0.00050877}, {1370,0.00050000}, {1380,0.00030702}, {1390,0.00042982}, {1400,0.00027193}, {1410,0.00064912}, {1420,0.00020175}, {1430,0.00048246}, {1440,0.00035965}, {1450,0.00061404}, {1460,0.00074561}, {1470,0.00039474}, {1480,0.00038596}, {1490,0.00040351}, {1500,0.00041228}, {1510,0.00043860}, {1520,0.00051754}, {1530,0.00051754}, {1540,0.00049123}, {1550,0.00044737}, {1560,0.00036842}, {1570,0.00021930}, {1580,0.00045614}, {1590,0.00044737}, {1600,0.00053509}, {1610,0.00070175}, {1620,0.00043860}, {1630,0.00048246}, {1640,0.00069298}, {1650,0.00050877}, {1660,0.00026316}, {1670,0.00041228}, {1680,0.00050877}, {1690,0.00070175}, {1700,0.00062281}, {1710,0.00057895}, {1720,0.00034211}, {1730,0.00050000}, {1740,0.00042982}, {1750,0.00058772}, {1760,0.00054386}, {1770,0.00078070}, {1780,0.00043860}, {1790,0.00049123}, {1800,0.00051754}, {1810,0.00057895}, {1820,0.00126316}, {1830,0.00043860}, {1840,0.00039474}, {1850,0.00048246}, {1860,0.00061404}, {1870,0.00064912}, {1880,0.00076316}, {1890,0.00068421}, {1900,0.00048246}, {1910,0.00062281}, {1920,0.00070175}, {1930,0.00086842}, {1940,0.00066667}, {1950,0.00082456}, {1960,0.00068421}, {1970,0.00069298}, {1980,0.00055263}, {1990,0.00078947}, {2000,0.00087719}, {2050,0.00057895}, {2100,0.00071930}, {2150,0.00093860}, {2200,0.00062281}, {2250,0.00072807}, {2300,0.00063158}, {2350,0.00079825}, {2400,0.00064035}, {2450,0.00078947}, {2500,0.00095614}, {2550,0.00092105}, {2600,0.00100877}, {2650,0.00086842}, {2700,0.00106140}, {2750,0.00089474}, {2800,0.00128070}, {2850,0.00100877}, {2900,0.00092982}, {2950,0.00100877}, {3000,0.00096491}, {3050,0.00129825}, {3100,0.00121930}, {3150,0.00131579}, {3200,0.00100000}, {3250,0.00111404}, {3300,0.00126316}, {3350,0.00121930}, {3400,0.00121053}, {3450,0.00153509}, {3500,0.00120175}, {3550,0.00126316}, {3600,0.00132456}, {3650,0.00164035}, {3700,0.00159649}, {3750,0.00113158}, {3800,0.01121053}, {3850,0.00121053}, {3900,0.00092982}, {3950,0.00147368}, {4000,0.00135965}, {4050,0.00142982}, {4100,0.00124561}, {4150,0.00162281}, {4200,0.00183333}, {4250,0.00177193}, {4300,0.00177193}, {4350,0.00175439}, {4400,0.00164912}, {4450,0.00171930}, {4500,0.00178070}, {4550,0.00197368}, {4600,0.00180702}, {4650,0.00165789}, {4700,0.00202632}, {4750,0.00169298}, {4800,0.00162281}, {4850,0.00169298}, {4900,0.00179825}, {4950,0.00171053}, {5000,0.00193860}, {5050,0.00205263}, {5100,0.00195614}, {5150,0.00214912}, {5200,0.00203509}, {5250,0.00215789}, {5300,0.00199123}, {5350,0.00196491}, {5400,0.01587719}, {5450,0.00209649}, {5500,0.00204386}, {5550,0.00230702}, {5600,0.00214035}, {5650,0.00217544}, {5700,0.00250877}, {5750,0.00263158}, {5800,0.00232456}, {5850,0.00235088}, {5900,0.00208772}, {5950,0.00250000}, {6000,0.00250000}, {6050,0.002286}, {6100,0.001571}, {6150,0.003429}, {6200,0.003357}, {6250,0.002357}, {6300,0.002214}, {6350,0.002714}, {6400,0.002429}, {6450,0.002571}, {6500,0.002286}, {6550,0.002429}, {6600,0.002857}, {6650,0.003214}, {6700,0.003143}, {6750,0.002714}, {6800,0.002500}, {6850,0.003000}, {6900,0.003714}, {6950,0.002643}, {7000,0.003000}, {7050,0.002000}, {7100,0.003143}, {7150,0.002143}, {7200,0.002571}, {7250,0.002357}, {7300,0.002643}, {7350,0.002571}, {7400,0.002643}, {7450,0.002429}, {7500,0.003214}, {7550,0.002071}, {7600,0.002786}, {7650,0.002929}, {7700,0.003071}, {7750,0.002857}, {7800,0.002929}, {7850,0.002786}, {7900,0.003143}, {7950,0.002571}, {8000,0.003071}, {8050,0.002429}, {8100,0.003357}, {8150,0.016143}, {8200,0.003214}, {8250,0.016000}, {8300,0.003143}, {8350,0.003000}, {8400,0.003429}, {8450,0.003214}, {8500,0.003571}, {8550,0.003286}, {8600,0.003571}, {8650,0.003857}, {8700,0.003714}, {8750,0.003643}, {8800,0.003143}, {8850,0.003786}, {8900,0.003500}, {8950,0.003929}, {9000,0.003286}, {9050,0.003500}, {9100,0.016929}, {9150,0.003357}, {9200,0.003714}, {9250,0.003571}, {9300,0.003357}, {9350,0.004214}, {9400,0.023643}, {9450,0.003929}, {9500,0.003500}, {9550,0.004214}, {9600,0.003500}, {9650,0.003714}, {9700,0.004071}, {9750,0.004286}, {9800,0.003429}, {9850,0.004071}, {9900,0.003929}, {9950,0.003500}, {10000,0.004071}, {10100,0.004714}, {10200,0.004571}, {10300,0.004429}, {10400,0.004143}, {10500,0.004571}, {10600,0.004500}, {10700,0.005000}, {10800,0.004071}, {10900,0.004214}, {11000,0.006643}, {11100,0.004357}, {11200,0.003857}, {11300,0.004357}, {11400,0.004929}, {11500,0.004786}, {11600,0.005286}, {11700,0.005000}, {11800,0.004929}, {11900,0.020786}, {12000,0.005214}, {12100,0.004357}, {12200,0.025500}, {12300,0.005571}, {12400,0.005214}, {12500,0.005143}, {12600,0.005571}, {12700,0.004429}, {12800,0.005571}, {12900,0.005643}, {13000,0.005643}, {13100,0.004929}, {13200,0.005714}, {13300,0.025357}, {13400,0.005714}, {13500,0.005500}, {13600,0.005643}, {13700,0.005357}, {13800,0.006071}, {13900,0.033286}, {14000,0.006357}, {14100,0.024214}, {14200,0.005643}, {14300,0.005857}, {14400,0.006643}, {14500,0.006214}, {14600,0.006214}, {14700,0.034857}, {14800,0.005214}, {14900,0.007214}, {15000,0.006714}, {15100,0.007000}, {15200,0.006429}, {15300,0.006929}, {15400,0.006857}, {15500,0.007357}, {15600,0.007214}, {15700,0.006571}, {15800,0.006357}, {15900,0.006429}, {16000,0.007214}, {16100,0.006857}, {16200,0.006357}, {16300,0.007071}, {16400,0.007500}, {16500,0.007214}, {16600,0.007500}, {16700,0.007214}, {16800,0.007500}, {16900,0.007714}, {17000,0.006714}, {17100,0.007571}, {17200,0.008000}, {17300,0.007929}, {17400,0.009286}, {17500,0.009071}, {17600,0.008000}, {17700,0.007929}, {17800,0.007357}, {17900,0.027143}, {18000,0.007857}, {18100,0.008071}, {18200,0.007786}, {18300,0.008500}, {18400,0.008286}, {18500,0.009857}, {18600,0.043929}, {18700,0.008357}, {18800,0.008214}, {18900,0.007857}, {19000,0.008714}, {19100,0.008500}, {19200,0.008000}, {19300,0.008143}, {19400,0.007929}, {19500,0.038214}, {19600,0.008643}, {19700,0.008786}, {19800,0.008643}, {19900,0.008500}, {20000,0.009571}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["lazy beta iota"]["system"] = {{1,0.00002632}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00003509}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00002632}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00003509}, {120,0.00002632}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00002632}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00002632}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00021053}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00002632}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00003509}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00003509}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00003509}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00003509}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00003509}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00003509}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00003509}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00003509}, {499,0.00003509}, {500,0.00003509}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00003509}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00003509}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00003509}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00003509}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00003509}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00003509}, {1210,0.00000000}, {1220,0.00003509}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00003509}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00003509}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00003509}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00003509}, {1980,0.00002632}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00003509}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00003509}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00003509}, {3250,0.00002632}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00003509}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00007018}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00003509}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00003509}, {4400,0.00003509}, {4450,0.00000000}, {4500,0.00003509}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00007018}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00003509}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00003509}, {5450,0.00003509}, {5500,0.00003509}, {5550,0.00003509}, {5600,0.00000000}, {5650,0.00003509}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.000000}, {6100,0.000286}, {6150,0.000500}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000286}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000214}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000286}, {10400,0.000000}, {10500,0.000000}, {10600,0.000286}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000286}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000286}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000286}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000286}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000286}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000286}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00017544}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00169298}, {15,0.00100000}, {16,0.00100000}, {17,0.00137719}, {18,0.00198246}, {19,0.00200000}, {20,0.00200000}, {21,0.00200000}, {22,0.00200000}, {23,0.00200000}, {24,0.00200000}, {25,0.00228947}, {26,0.00241228}, {27,0.00300000}, {28,0.00300000}, {29,0.00300000}, {30,0.00300877}, {31,0.00300877}, {32,0.00300000}, {33,0.00321053}, {34,0.00331579}, {35,0.00460526}, {36,0.00364912}, {37,0.00400000}, {38,0.00400000}, {39,0.00402632}, {40,0.00400000}, {41,0.00417544}, {42,0.00424561}, {43,0.00468421}, {44,0.00443860}, {45,0.00500000}, {46,0.00500000}, {47,0.00502632}, {48,0.00500000}, {49,0.00507018}, {50,0.00521930}, {51,0.00542105}, {52,0.00533333}, {53,0.00598246}, {54,0.00600877}, {55,0.00612281}, {56,0.00699123}, {57,0.00619298}, {58,0.00618421}, {59,0.00646491}, {60,0.00619298}, {61,0.00699123}, {62,0.00700877}, {63,0.00714912}, {64,0.00719298}, {65,0.00712281}, {66,0.00723684}, {67,0.00735965}, {68,0.00721930}, {69,0.00782456}, {70,0.00816667}, {71,0.00950877}, {72,0.00798246}, {73,0.00818421}, {74,0.00817544}, {75,0.00841228}, {76,0.00818421}, {77,0.00901754}, {78,0.00901754}, {79,0.00914912}, {80,0.00857018}, {81,0.00913158}, {82,0.00930702}, {83,0.00927193}, {84,0.00917544}, {85,0.00988596}, {86,0.01178070}, {87,0.01016667}, {88,0.00990351}, {89,0.01008772}, {90,0.01021053}, {91,0.01054386}, {92,0.01021053}, {93,0.01110526}, {94,0.01106140}, {95,0.01127193}, {96,0.01032456}, {97,0.01108772}, {98,0.01128070}, {99,0.01130702}, {100,0.01129825}, {101,0.01305263}, {102,0.01185965}, {103,0.01219298}, {104,0.01148246}, {105,0.01214035}, {106,0.01215789}, {107,0.01271053}, {108,0.01228070}, {109,0.01307018}, {110,0.01310526}, {111,0.01329825}, {112,0.01238596}, {113,0.01314912}, {114,0.01409649}, {115,0.01389474}, {116,0.01475439}, {117,0.01398246}, {118,0.01550000}, {119,0.01430702}, {120,0.01374561}, {121,0.01443860}, {122,0.01424561}, {123,0.01510526}, {124,0.01465789}, {125,0.01514912}, {126,0.01514912}, {127,0.01583333}, {128,0.01440351}, {129,0.01595614}, {130,0.01507895}, {131,0.01564912}, {132,0.01511404}, {133,0.01580702}, {134,0.01592982}, {135,0.01645614}, {136,0.01785965}, {137,0.01625439}, {138,0.01621930}, {139,0.01718421}, {140,0.01640351}, {141,0.01937719}, {142,0.01728070}, {143,0.01790351}, {144,0.01821053}, {145,0.01714035}, {146,0.01719298}, {147,0.01785088}, {148,0.01733333}, {149,0.01814912}, {150,0.01836842}, {151,0.01871053}, {152,0.01775439}, {153,0.01836842}, {154,0.01850877}, {155,0.01928947}, {156,0.01878947}, {157,0.01940351}, {158,0.01957018}, {159,0.02307018}, {160,0.01854386}, {161,0.01909649}, {162,0.01919298}, {163,0.01979825}, {164,0.01928070}, {165,0.02019298}, {166,0.02273684}, {167,0.02083333}, {168,0.01971930}, {169,0.02044737}, {170,0.02292982}, {171,0.02147368}, {172,0.02079825}, {173,0.02146491}, {174,0.02369298}, {175,0.02224561}, {176,0.02063158}, {177,0.02135965}, {178,0.02145614}, {179,0.02456140}, {180,0.02171930}, {181,0.02241228}, {182,0.02242982}, {183,0.02328070}, {184,0.02221053}, {185,0.02480702}, {186,0.02305263}, {187,0.02377193}, {188,0.02357895}, {189,0.02416667}, {190,0.02413158}, {191,0.02484211}, {192,0.02294737}, {193,0.02317544}, {194,0.02327193}, {195,0.02394737}, {196,0.02334211}, {197,0.02435088}, {198,0.02447368}, {199,0.02682456}, {200,0.02654386}, {201,0.02467544}, {202,0.02465789}, {203,0.02548246}, {204,0.02525439}, {205,0.02588596}, {206,0.02585965}, {207,0.02666667}, {208,0.02460526}, {209,0.02585965}, {210,0.02654386}, {211,0.02777193}, {212,0.02820175}, {213,0.03076316}, {214,0.02950877}, {215,0.03027193}, {216,0.02846491}, {217,0.02914912}, {218,0.03021930}, {219,0.03091228}, {220,0.02967544}, {221,0.03127193}, {222,0.03047368}, {223,0.03176316}, {224,0.02820175}, {225,0.03014035}, {226,0.02989474}, {227,0.03080702}, {228,0.03011404}, {229,0.03113158}, {230,0.02889474}, {231,0.03005263}, {232,0.02839474}, {233,0.02918421}, {234,0.02959649}, {235,0.03032456}, {236,0.03008772}, {237,0.03054386}, {238,0.03065789}, {239,0.03778070}, {240,0.03067544}, {241,0.03256140}, {242,0.03019298}, {243,0.03120175}, {244,0.03062281}, {245,0.03136842}, {246,0.03169298}, {247,0.03264912}, {248,0.03271053}, {249,0.03346491}, {250,0.03198246}, {251,0.03278070}, {252,0.03258772}, {253,0.03900000}, {254,0.03483333}, {255,0.03429825}, {256,0.03039474}, {257,0.03150877}, {258,0.03181579}, {259,0.03505263}, {260,0.03373684}, {261,0.03306140}, {262,0.03337719}, {263,0.03393860}, {264,0.03728947}, {265,0.03521930}, {266,0.03373684}, {267,0.03445614}, {268,0.03388596}, {269,0.04084211}, {270,0.03602632}, {271,0.03613158}, {272,0.03321053}, {273,0.03958772}, {274,0.03631579}, {275,0.03557895}, {276,0.03485965}, {277,0.04342982}, {278,0.03701754}, {279,0.03747368}, {280,0.03494737}, {281,0.03842982}, {282,0.03666667}, {283,0.03736842}, {284,0.04340351}, {285,0.03825439}, {286,0.03820175}, {287,0.04435088}, {288,0.03514912}, {289,0.03672807}, {290,0.03766667}, {291,0.03750877}, {292,0.03699123}, {293,0.04310526}, {294,0.03764035}, {295,0.03915789}, {296,0.03761404}, {297,0.03810526}, {298,0.04357018}, {299,0.03931579}, {300,0.03888596}, {301,0.04573684}, {302,0.03975439}, {303,0.04559649}, {304,0.03765789}, {305,0.04381579}, {306,0.03977193}, {307,0.04070175}, {308,0.04399123}, {309,0.04042105}, {310,0.04542105}, {311,0.04205263}, {312,0.04431579}, {313,0.04158772}, {314,0.04615789}, {315,0.04275439}, {316,0.04583333}, {317,0.04305263}, {318,0.04718421}, {319,0.04456140}, {320,0.03915789}, {321,0.04006140}, {322,0.04502632}, {323,0.04152632}, {324,0.04540351}, {325,0.04234211}, {326,0.04695614}, {327,0.04352632}, {328,0.04584211}, {329,0.04254386}, {330,0.04710526}, {331,0.04355263}, {332,0.04245614}, {333,0.04376316}, {334,0.04399123}, {335,0.04963158}, {336,0.04237719}, {337,0.04813158}, {338,0.04326316}, {339,0.04878947}, {340,0.04830702}, {341,0.04515789}, {342,0.04949123}, {343,0.04670175}, {344,0.04424561}, {345,0.04984211}, {346,0.04527193}, {347,0.04682456}, {348,0.04908772}, {349,0.04692982}, {350,0.04714035}, {351,0.05400877}, {352,0.04768421}, {353,0.04468421}, {354,0.05091228}, {355,0.04637719}, {356,0.04495614}, {357,0.05051754}, {358,0.04700877}, {359,0.04873684}, {360,0.04909649}, {361,0.05130702}, {362,0.04683333}, {363,0.05282456}, {364,0.05144737}, {365,0.04856140}, {366,0.04871053}, {367,0.05039474}, {368,0.04958772}, {369,0.05170175}, {370,0.04765789}, {371,0.04959649}, {372,0.05190351}, {373,0.05299123}, {374,0.05664912}, {375,0.05165789}, {376,0.04828070}, {377,0.05029825}, {378,0.05414912}, {379,0.05505263}, {380,0.05363158}, {381,0.05716667}, {382,0.05247368}, {383,0.05415789}, {384,0.04682456}, {385,0.04861404}, {386,0.05379825}, {387,0.05003509}, {388,0.04826316}, {389,0.05059649}, {390,0.05514035}, {391,0.05514035}, {392,0.05691228}, {393,0.05097368}, {394,0.05088596}, {395,0.05614912}, {396,0.05480702}, {397,0.05625439}, {398,0.05671930}, {399,0.06023684}, {400,0.05052632}, {401,0.05208772}, {402,0.05144737}, {403,0.05721053}, {404,0.05531579}, {405,0.05766667}, {406,0.05740351}, {407,0.05893860}, {408,0.05482456}, {409,0.05881579}, {410,0.06154386}, {411,0.06342982}, {412,0.06144737}, {413,0.06428947}, {414,0.06283333}, {415,0.06106140}, {416,0.05446491}, {417,0.05710526}, {418,0.06009649}, {419,0.06253509}, {420,0.05347368}, {421,0.05551754}, {422,0.05516667}, {423,0.05765789}, {424,0.06415789}, {425,0.06457895}, {426,0.06397368}, {427,0.06479825}, {428,0.05979825}, {429,0.06185965}, {430,0.06082456}, {431,0.06286842}, {432,0.05488596}, {433,0.05688596}, {434,0.05727193}, {435,0.05928070}, {436,0.05703509}, {437,0.06653509}, {438,0.06635965}, {439,0.06419298}, {440,0.05711404}, {441,0.05938596}, {442,0.05962281}, {443,0.06903509}, {444,0.06289474}, {445,0.06413158}, {446,0.06114035}, {447,0.07119298}, {448,0.05742105}, {449,0.06145614}, {450,0.06039474}, {451,0.06272807}, {452,0.05838596}, {453,0.05942982}, {454,0.06020175}, {455,0.07231579}, {456,0.06358772}, {457,0.06334211}, {458,0.06356140}, {459,0.06257895}, {460,0.06876316}, {461,0.06929825}, {462,0.06499123}, {463,0.06420175}, {464,0.06613158}, {465,0.06521930}, {466,0.06433333}, {467,0.06325439}, {468,0.06177193}, {469,0.06961404}, {470,0.06553509}, {471,0.06492105}, {472,0.06884211}, {473,0.06596491}, {474,0.06351754}, {475,0.07300000}, {476,0.06588596}, {477,0.06578947}, {478,0.07234211}, {479,0.06737719}, {480,0.06772807}, {481,0.06752632}, {482,0.06250000}, {483,0.06492105}, {484,0.07248246}, {485,0.06794737}, {486,0.06492982}, {487,0.07007895}, {488,0.06364035}, {489,0.07293860}, {490,0.06790351}, {491,0.06742982}, {492,0.06800000}, {493,0.06813158}, {494,0.07581579}, {495,0.06993860}, {496,0.07078070}, {497,0.06651754}, {498,0.07363158}, {499,0.07050877}, {500,0.07435965}, {505,0.07155263}, {510,0.07934211}, {515,0.06772807}, {520,0.07292982}, {525,0.07314035}, {530,0.07693860}, {535,0.07811404}, {540,0.08214035}, {545,0.08143860}, {550,0.07683333}, {555,0.08384211}, {560,0.08115789}, {565,0.07982456}, {570,0.08660526}, {575,0.09153509}, {580,0.08315789}, {585,0.08609649}, {590,0.08879825}, {595,0.08838596}, {600,0.08778947}, {605,0.08548246}, {610,0.08948246}, {615,0.09376316}, {620,0.09220175}, {625,0.09568421}, {630,0.09928070}, {635,0.10001754}, {640,0.08947368}, {645,0.08741228}, {650,0.09557895}, {655,0.10036842}, {660,0.09671053}, {665,0.09357895}, {670,0.10199123}, {675,0.10155263}, {680,0.09786842}, {685,0.10362281}, {690,0.10287719}, {695,0.10746491}, {700,0.11005263}, {705,0.10511404}, {710,0.09799123}, {715,0.10939474}, {720,0.10366667}, {725,0.11023684}, {730,0.11011404}, {735,0.11528947}, {740,0.10776316}, {745,0.11264912}, {750,0.11634211}, {755,0.11708772}, {760,0.11371053}, {765,0.11951754}, {770,0.11262281}, {775,0.11520175}, {780,0.11293860}, {785,0.11527193}, {790,0.11610526}, {795,0.12147368}, {800,0.11324561}, {805,0.11858772}, {810,0.11952632}, {815,0.12727193}, {820,0.12059649}, {825,0.12383333}, {830,0.13187719}, {835,0.12500000}, {840,0.12090351}, {845,0.12773684}, {850,0.12275439}, {855,0.13341228}, {860,0.12929825}, {865,0.12745614}, {870,0.13717544}, {875,0.13491228}, {880,0.12757018}, {885,0.13981579}, {890,0.13723684}, {895,0.15361404}, {900,0.13762281}, {905,0.13255263}, {910,0.14383333}, {915,0.13749123}, {920,0.13318421}, {925,0.14867544}, {930,0.13689474}, {935,0.14727193}, {940,0.14292982}, {945,0.14082456}, {950,0.15422807}, {955,0.15742105}, {960,0.13581579}, {965,0.15038596}, {970,0.15179825}, {975,0.15892105}, {980,0.14891228}, {985,0.14982456}, {990,0.15468421}, {995,0.15705263}, {1000,0.15478947}, {1010,0.15994737}, {1020,0.15707018}, {1030,0.15670175}, {1040,0.15336842}, {1050,0.16757895}, {1060,0.15382456}, {1070,0.16372807}, {1080,0.16036842}, {1090,0.16643860}, {1100,0.16892105}, {1110,0.17440351}, {1120,0.16050877}, {1130,0.18212281}, {1140,0.18000000}, {1150,0.19095614}, {1160,0.16637719}, {1170,0.17840351}, {1180,0.18360526}, {1190,0.18721930}, {1200,0.17536842}, {1210,0.18964035}, {1220,0.18586842}, {1230,0.19692105}, {1240,0.19132456}, {1250,0.19332456}, {1260,0.19880702}, {1270,0.20383333}, {1280,0.18048246}, {1290,0.18991228}, {1300,0.19744737}, {1310,0.20818421}, {1320,0.19769298}, {1330,0.19930702}, {1340,0.21362281}, {1350,0.21270175}, {1360,0.20339474}, {1370,0.22135088}, {1380,0.21211404}, {1390,0.22481579}, {1400,0.21807895}, {1410,0.21085965}, {1420,0.22310526}, {1430,0.22524561}, {1440,0.21545614}, {1450,0.22632456}, {1460,0.22843860}, {1470,0.24136842}, {1480,0.23485088}, {1490,0.23342982}, {1500,0.24003509}, {1510,0.24957018}, {1520,0.23364912}, {1530,0.24700000}, {1540,0.23452632}, {1550,0.23893860}, {1560,0.23462281}, {1570,0.23385965}, {1580,0.24044737}, {1590,0.25707018}, {1600,0.23347368}, {1610,0.24631579}, {1620,0.24707895}, {1630,0.25937719}, {1640,0.24880702}, {1650,0.26242105}, {1660,0.27770175}, {1670,0.26131579}, {1680,0.24700877}, {1690,0.25951754}, {1700,0.25059649}, {1710,0.28208772}, {1720,0.27672807}, {1730,0.26764035}, {1740,0.26887719}, {1750,0.27482456}, {1760,0.26791228}, {1770,0.28657895}, {1780,0.28693860}, {1790,0.30060526}, {1800,0.26214912}, {1810,0.27710526}, {1820,0.28657895}, {1830,0.28142982}, {1840,0.27100877}, {1850,0.29581579}, {1860,0.29512281}, {1870,0.30329825}, {1880,0.29656140}, {1890,0.29364912}, {1900,0.29596491}, {1910,0.32144737}, {1920,0.28624561}, {1930,0.29228070}, {1940,0.29750000}, {1950,0.31585088}, {1960,0.30607895}, {1970,0.30940351}, {1980,0.31929825}, {1990,0.31106140}, {2000,0.31428070}, {2050,0.30621930}, {2100,0.32300877}, {2150,0.33872807}, {2200,0.34509649}, {2250,0.36145614}, {2300,0.37566667}, {2350,0.38003509}, {2400,0.38300877}, {2450,0.38503509}, {2500,0.39319298}, {2550,0.42611404}, {2600,0.40217544}, {2650,0.42670175}, {2700,0.42228947}, {2750,0.47114035}, {2800,0.44705263}, {2850,0.44138596}, {2900,0.46920175}, {2950,0.46874561}, {3000,0.48528947}, {3050,0.50786842}, {3100,0.48984211}, {3150,0.51300000}, {3200,0.47903509}, {3250,0.52576316}, {3300,0.53507018}, {3350,0.54222807}, {3400,0.53216667}, {3450,0.59553509}, {3500,0.57432456}, {3550,0.62232456}, {3600,0.55078070}, {3650,0.57193860}, {3700,0.61248246}, {3750,0.61878947}, {3800,0.62488596}, {3850,0.61634211}, {3900,0.67296491}, {3950,0.68740351}, {4000,0.65058772}, {4050,0.68066667}, {4100,0.63830702}, {4150,0.68500877}, {4200,0.69213158}, {4250,0.70346491}, {4300,0.72557018}, {4350,0.77016667}, {4400,0.70966667}, {4450,0.74172807}, {4500,0.74500000}, {4550,0.76664912}, {4600,0.79989474}, {4650,0.76864912}, {4700,0.79959649}, {4750,0.81292982}, {4800,0.76315789}, {4850,0.84075439}, {4900,0.79950000}, {4950,0.85796491}, {5000,0.82244737}, {5050,0.89612281}, {5100,0.90845614}, {5150,0.89015789}, {5200,0.84208772}, {5250,0.84826316}, {5300,0.90365789}, {5350,0.93785088}, {5400,0.89227193}, {5450,0.92123684}, {5500,0.98887719}, {5550,1.00276316}, {5600,0.95066667}, {5650,0.93582456}, {5700,0.95603509}, {5750,1.03833333}, {5800,0.97900877}, {5850,1.05760526}, {5900,0.99867544}, {5950,1.09352632}, {6000,1.06801754}, {6050,1.079143}, {6100,1.121071}, {6150,1.030929}, {6200,1.067429}, {6250,1.115000}, {6300,1.116500}, {6350,1.148286}, {6400,1.047214}, {6450,1.129000}, {6500,1.138286}, {6550,1.193929}, {6600,1.150929}, {6650,1.272143}, {6700,1.177643}, {6750,1.244286}, {6800,1.171571}, {6850,1.190571}, {6900,1.285786}, {6950,1.247643}, {7000,1.232429}, {7050,1.288143}, {7100,1.355643}, {7150,1.406286}, {7200,1.197214}, {7250,1.264571}, {7300,1.257786}, {7350,1.377357}, {7400,1.350571}, {7450,1.368071}, {7500,1.352786}, {7550,1.496857}, {7600,1.363429}, {7650,1.419429}, {7700,1.341286}, {7750,1.407143}, {7800,1.440714}, {7850,1.448286}, {7900,1.501000}, {7950,1.475786}, {8000,1.357643}, {8050,1.535929}, {8100,1.501286}, {8150,1.592857}, {8200,1.373357}, {8250,1.499714}, {8300,1.517357}, {8350,1.572929}, {8400,1.491643}, {8450,1.435071}, {8500,1.574214}, {8550,1.587571}, {8600,1.584286}, {8650,1.625714}, {8700,1.714500}, {8750,1.628286}, {8800,1.537571}, {8850,1.606214}, {8900,1.620214}, {8950,1.774357}, {9000,1.611643}, {9050,1.742143}, {9100,1.687643}, {9150,1.871214}, {9200,1.765429}, {9250,1.619071}, {9300,1.690429}, {9350,1.685357}, {9400,1.745071}, {9450,1.808714}, {9500,1.742714}, {9550,1.813286}, {9600,1.645857}, {9650,1.840929}, {9700,1.826143}, {9750,1.799000}, {9800,1.740571}, {9850,1.894429}, {9900,1.886857}, {9950,1.973000}, {10000,1.766786}, {10100,1.955786}, {10200,1.936857}, {10300,1.919357}, {10400,1.803286}, {10500,1.839000}, {10600,1.952643}, {10700,2.023429}, {10800,1.937143}, {10900,1.995500}, {11000,2.152929}, {11100,2.175357}, {11200,2.041786}, {11300,2.022429}, {11400,2.029357}, {11500,2.248286}, {11600,2.117929}, {11700,2.269929}, {11800,2.172643}, {11900,2.382286}, {12000,2.244643}, {12100,2.271286}, {12200,2.341571}, {12300,2.177500}, {12400,2.253357}, {12500,2.371643}, {12600,2.373714}, {12700,2.453357}, {12800,2.135286}, {12900,2.398357}, {13000,2.429857}, {13100,2.511357}, {13200,2.445929}, {13300,2.671714}, {13400,2.500714}, {13500,2.657500}, {13600,2.411714}, {13700,2.509286}, {13800,2.681143}, {13900,2.623286}, {14000,2.657500}, {14100,2.636357}, {14200,2.842214}, {14300,2.967500}, {14400,2.480214}, {14500,2.706571}, {14600,2.599714}, {14700,2.887571}, {14800,2.814714}, {14900,3.200000}, {15000,2.848357}, {15100,3.117143}, {15200,3.044929}, {15300,2.976857}, {15400,3.208071}, {15500,2.937500}, {15600,3.081786}, {15700,3.248286}, {15800,3.334500}, {15900,3.099071}, {16000,2.864714}, {16100,3.206071}, {16200,3.131857}, {16300,3.336714}, {16400,2.848571}, {16500,3.187500}, {16600,3.538143}, {16700,3.310643}, {16800,3.120500}, {16900,3.349714}, {17000,3.244500}, {17100,3.403500}, {17200,3.293214}, {17300,3.433786}, {17400,3.608714}, {17500,3.453429}, {17600,3.264786}, {17700,3.530071}, {17800,3.728357}, {17900,3.720214}, {18000,3.422714}, {18100,3.661071}, {18200,3.708214}, {18300,3.914429}, {18400,3.658000}, {18500,3.434000}, {18600,3.699429}, {18700,3.698929}, {18800,3.863071}, {18900,3.896071}, {19000,3.709714}, {19100,3.838357}, {19200,3.543000}, {19300,4.081071}, {19400,3.867929}, {19500,3.810429}, {19600,3.741071}, {19700,4.067714}, {19800,4.010357}, {19900,4.453571}, {20000,3.760143}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["norm reif"]["user"] = {{1,0.00009649}, {2,0.00037719}, {3,0.00027193}, {4,0.00042982}, {5,0.00047368}, {6,0.00076316}, {7,0.00105263}, {8,0.00072807}, {9,0.00073684}, {10,0.00085965}, {11,0.00111404}, {12,0.00115789}, {13,0.00142105}, {14,0.00204386}, {15,0.00138596}, {16,0.00179825}, {17,0.00177193}, {18,0.00185088}, {19,0.00183333}, {20,0.00218421}, {21,0.00179825}, {22,0.00212281}, {23,0.00228947}, {24,0.00227193}, {25,0.00244737}, {26,0.00256140}, {27,0.00255263}, {28,0.00275439}, {29,0.00295614}, {30,0.00317544}, {31,0.00307018}, {32,0.00311404}, {33,0.00335965}, {34,0.00343860}, {35,0.00440351}, {36,0.00352632}, {37,0.00362281}, {38,0.00402632}, {39,0.00441228}, {40,0.00401754}, {41,0.00454386}, {42,0.00444737}, {43,0.00483333}, {44,0.00450000}, {45,0.00467544}, {46,0.00503509}, {47,0.00492982}, {48,0.00463158}, {49,0.00544737}, {50,0.00546491}, {51,0.00556140}, {52,0.00563158}, {53,0.00591228}, {54,0.00639474}, {55,0.00617544}, {56,0.00736842}, {57,0.00621053}, {58,0.00678070}, {59,0.00705263}, {60,0.00695614}, {61,0.00731579}, {62,0.00725439}, {63,0.00757895}, {64,0.00768421}, {65,0.00735088}, {66,0.00742105}, {67,0.00800877}, {68,0.00750000}, {69,0.00804386}, {70,0.00811404}, {71,0.00964912}, {72,0.00812281}, {73,0.00858772}, {74,0.00839474}, {75,0.00908772}, {76,0.00887719}, {77,0.00913158}, {78,0.00885088}, {79,0.00943860}, {80,0.00923684}, {81,0.00900877}, {82,0.00924561}, {83,0.00955263}, {84,0.00958772}, {85,0.01000000}, {86,0.01157018}, {87,0.01021053}, {88,0.00992982}, {89,0.01022807}, {90,0.01014912}, {91,0.01048246}, {92,0.01077193}, {93,0.01078070}, {94,0.01100877}, {95,0.01143860}, {96,0.01076316}, {97,0.01101754}, {98,0.01142105}, {99,0.01164035}, {100,0.01156140}, {101,0.01363158}, {102,0.01187719}, {103,0.01239474}, {104,0.01174561}, {105,0.01246491}, {106,0.01224561}, {107,0.01303509}, {108,0.01260526}, {109,0.01313158}, {110,0.01307018}, {111,0.01361404}, {112,0.01273684}, {113,0.01300877}, {114,0.01446491}, {115,0.01398246}, {116,0.01501754}, {117,0.01418421}, {118,0.01595614}, {119,0.01473684}, {120,0.01391228}, {121,0.01488596}, {122,0.01469298}, {123,0.01534211}, {124,0.01507018}, {125,0.01546491}, {126,0.01528070}, {127,0.01617544}, {128,0.01488596}, {129,0.01610526}, {130,0.01521930}, {131,0.01592105}, {132,0.01542105}, {133,0.01623684}, {134,0.01607018}, {135,0.01685965}, {136,0.01788596}, {137,0.01646491}, {138,0.01647368}, {139,0.01725439}, {140,0.01664912}, {141,0.01905263}, {142,0.01719298}, {143,0.01797368}, {144,0.01826316}, {145,0.01753509}, {146,0.01738596}, {147,0.01789474}, {148,0.01774561}, {149,0.01796491}, {150,0.01827193}, {151,0.01838596}, {152,0.01785088}, {153,0.01838596}, {154,0.01860526}, {155,0.01925439}, {156,0.01840351}, {157,0.01914035}, {158,0.01936842}, {159,0.02320175}, {160,0.01864035}, {161,0.01886842}, {162,0.01885965}, {163,0.01953509}, {164,0.01913158}, {165,0.01967544}, {166,0.02250000}, {167,0.02015789}, {168,0.01936842}, {169,0.02028947}, {170,0.02280702}, {171,0.02138596}, {172,0.02078070}, {173,0.02165789}, {174,0.02362281}, {175,0.02212281}, {176,0.02047368}, {177,0.02103509}, {178,0.02124561}, {179,0.02450877}, {180,0.02168421}, {181,0.02225439}, {182,0.02251754}, {183,0.02355263}, {184,0.02170175}, {185,0.02461404}, {186,0.02280702}, {187,0.02379825}, {188,0.02342105}, {189,0.02392982}, {190,0.02400000}, {191,0.02504386}, {192,0.02299123}, {193,0.02314035}, {194,0.02294737}, {195,0.02385088}, {196,0.02350000}, {197,0.02424561}, {198,0.02446491}, {199,0.02673684}, {200,0.02657895}, {201,0.02457018}, {202,0.02458772}, {203,0.02559649}, {204,0.02518421}, {205,0.02588596}, {206,0.02584211}, {207,0.02679825}, {208,0.02463158}, {209,0.02601754}, {210,0.02649123}, {211,0.02767544}, {212,0.02801754}, {213,0.03078070}, {214,0.02969298}, {215,0.03064912}, {216,0.02857895}, {217,0.02935965}, {218,0.03034211}, {219,0.03098246}, {220,0.02964035}, {221,0.03141228}, {222,0.03096491}, {223,0.03217544}, {224,0.02771053}, {225,0.03011404}, {226,0.03004386}, {227,0.03098246}, {228,0.03024561}, {229,0.03124561}, {230,0.02881579}, {231,0.03011404}, {232,0.02825439}, {233,0.02936842}, {234,0.02988596}, {235,0.03089474}, {236,0.03002632}, {237,0.03074561}, {238,0.03114912}, {239,0.03771053}, {240,0.03101754}, {241,0.03266667}, {242,0.03004386}, {243,0.03114035}, {244,0.03057895}, {245,0.03189474}, {246,0.03221930}, {247,0.03286842}, {248,0.03320175}, {249,0.03379825}, {250,0.03237719}, {251,0.03296491}, {252,0.03268421}, {253,0.03856140}, {254,0.03489474}, {255,0.03457018}, {256,0.03046491}, {257,0.03183333}, {258,0.03220175}, {259,0.03481579}, {260,0.03372807}, {261,0.03346491}, {262,0.03370175}, {263,0.03379825}, {264,0.03701754}, {265,0.03514035}, {266,0.03412281}, {267,0.03469298}, {268,0.03405263}, {269,0.04061404}, {270,0.03590351}, {271,0.03614912}, {272,0.03347368}, {273,0.03907018}, {274,0.03635088}, {275,0.03564035}, {276,0.03484211}, {277,0.04352632}, {278,0.03671930}, {279,0.03743860}, {280,0.03528070}, {281,0.03803509}, {282,0.03670175}, {283,0.03720175}, {284,0.04353509}, {285,0.03805263}, {286,0.03802632}, {287,0.04393860}, {288,0.03528947}, {289,0.03643860}, {290,0.03725439}, {291,0.03723684}, {292,0.03704386}, {293,0.04293860}, {294,0.03783333}, {295,0.03871930}, {296,0.03740351}, {297,0.03793860}, {298,0.04312281}, {299,0.03909649}, {300,0.03885965}, {301,0.04536842}, {302,0.03942982}, {303,0.04524561}, {304,0.03769298}, {305,0.04372807}, {306,0.03952632}, {307,0.04066667}, {308,0.04364912}, {309,0.04014912}, {310,0.04521053}, {311,0.04228070}, {312,0.04411404}, {313,0.04135088}, {314,0.04598246}, {315,0.04285965}, {316,0.04566667}, {317,0.04322807}, {318,0.04721053}, {319,0.04472807}, {320,0.03898246}, {321,0.03955263}, {322,0.04508772}, {323,0.04107895}, {324,0.04527193}, {325,0.04182456}, {326,0.04722807}, {327,0.04321053}, {328,0.04555263}, {329,0.04251754}, {330,0.04694737}, {331,0.04329825}, {332,0.04250877}, {333,0.04361404}, {334,0.04389474}, {335,0.04930702}, {336,0.04188596}, {337,0.04804386}, {338,0.04316667}, {339,0.04855263}, {340,0.04836842}, {341,0.04489474}, {342,0.04921930}, {343,0.04682456}, {344,0.04408772}, {345,0.04948246}, {346,0.04532456}, {347,0.04682456}, {348,0.04892982}, {349,0.04685965}, {350,0.04691228}, {351,0.05380702}, {352,0.04796491}, {353,0.04456140}, {354,0.05052632}, {355,0.04630702}, {356,0.04478947}, {357,0.05021930}, {358,0.04695614}, {359,0.04864035}, {360,0.04879825}, {361,0.05101754}, {362,0.04693860}, {363,0.05244737}, {364,0.05113158}, {365,0.04861404}, {366,0.04871930}, {367,0.05017544}, {368,0.04935965}, {369,0.05169298}, {370,0.04764912}, {371,0.04974561}, {372,0.05135088}, {373,0.05259649}, {374,0.05658772}, {375,0.05160526}, {376,0.04808772}, {377,0.05050877}, {378,0.05368421}, {379,0.05481579}, {380,0.05324561}, {381,0.05729825}, {382,0.05209649}, {383,0.05384211}, {384,0.04661404}, {385,0.04864912}, {386,0.05356140}, {387,0.04973684}, {388,0.04842982}, {389,0.05037719}, {390,0.05479825}, {391,0.05515789}, {392,0.05663158}, {393,0.05076316}, {394,0.05062281}, {395,0.05582456}, {396,0.05477193}, {397,0.05614912}, {398,0.05673684}, {399,0.06050000}, {400,0.05029825}, {401,0.05166667}, {402,0.05120175}, {403,0.05713158}, {404,0.05524561}, {405,0.05750000}, {406,0.05712281}, {407,0.05890351}, {408,0.05443860}, {409,0.05853509}, {410,0.06128070}, {411,0.06310526}, {412,0.06134211}, {413,0.06450877}, {414,0.06288596}, {415,0.06101754}, {416,0.05436842}, {417,0.05678070}, {418,0.06025439}, {419,0.06278070}, {420,0.05287719}, {421,0.05502632}, {422,0.05529825}, {423,0.05742105}, {424,0.06425439}, {425,0.06478070}, {426,0.06389474}, {427,0.06455263}, {428,0.05981579}, {429,0.06169298}, {430,0.06077193}, {431,0.06298246}, {432,0.05476316}, {433,0.05670175}, {434,0.05711404}, {435,0.05953509}, {436,0.05669298}, {437,0.06635965}, {438,0.06627193}, {439,0.06414035}, {440,0.05702632}, {441,0.05953509}, {442,0.05964912}, {443,0.06887719}, {444,0.06316667}, {445,0.06417544}, {446,0.06104386}, {447,0.07137719}, {448,0.05720175}, {449,0.06156140}, {450,0.06048246}, {451,0.06301754}, {452,0.05849123}, {453,0.05958772}, {454,0.06063158}, {455,0.07229825}, {456,0.06375439}, {457,0.06336842}, {458,0.06367544}, {459,0.06259649}, {460,0.06841228}, {461,0.06910526}, {462,0.06474561}, {463,0.06372807}, {464,0.06560526}, {465,0.06487719}, {466,0.06431579}, {467,0.06315789}, {468,0.06161404}, {469,0.06937719}, {470,0.06558772}, {471,0.06477193}, {472,0.06880702}, {473,0.06564912}, {474,0.06333333}, {475,0.07273684}, {476,0.06582456}, {477,0.06556140}, {478,0.07236842}, {479,0.06741228}, {480,0.06759649}, {481,0.06717544}, {482,0.06268421}, {483,0.06485088}, {484,0.07240351}, {485,0.06776316}, {486,0.06507018}, {487,0.07020175}, {488,0.06364912}, {489,0.07307895}, {490,0.06745614}, {491,0.06714035}, {492,0.06747368}, {493,0.06803509}, {494,0.07565789}, {495,0.06977193}, {496,0.07076316}, {497,0.06616667}, {498,0.07352632}, {499,0.07037719}, {500,0.07411404}, {505,0.07145614}, {510,0.07930702}, {515,0.06729825}, {520,0.07272807}, {525,0.07322807}, {530,0.07640351}, {535,0.07777193}, {540,0.08183333}, {545,0.08105263}, {550,0.07641228}, {555,0.08396491}, {560,0.08076316}, {565,0.07954386}, {570,0.08667544}, {575,0.09113158}, {580,0.08306140}, {585,0.08562281}, {590,0.08866667}, {595,0.08800877}, {600,0.08772807}, {605,0.08556140}, {610,0.08892105}, {615,0.09348246}, {620,0.09177193}, {625,0.09552632}, {630,0.09881579}, {635,0.09972807}, {640,0.08930702}, {645,0.08721930}, {650,0.09549123}, {655,0.09989474}, {660,0.09639474}, {665,0.09325439}, {670,0.10161404}, {675,0.10113158}, {680,0.09774561}, {685,0.10314035}, {690,0.10231579}, {695,0.10759649}, {700,0.10988596}, {705,0.10510526}, {710,0.09777193}, {715,0.10908772}, {720,0.10342982}, {725,0.10989474}, {730,0.10971053}, {735,0.11510526}, {740,0.10727193}, {745,0.11228947}, {750,0.11607895}, {755,0.11663158}, {760,0.11329825}, {765,0.11925439}, {770,0.11236842}, {775,0.11478947}, {780,0.11273684}, {785,0.11524561}, {790,0.11592105}, {795,0.12156140}, {800,0.11282456}, {805,0.11833333}, {810,0.11911404}, {815,0.12727193}, {820,0.12038596}, {825,0.12326316}, {830,0.13200000}, {835,0.12464035}, {840,0.12055263}, {845,0.12786842}, {850,0.12270175}, {855,0.13332456}, {860,0.12903509}, {865,0.12761404}, {870,0.13696491}, {875,0.13490351}, {880,0.12751754}, {885,0.13983333}, {890,0.13743860}, {895,0.15356140}, {900,0.13787719}, {905,0.13228070}, {910,0.14378070}, {915,0.13759649}, {920,0.13301754}, {925,0.14850877}, {930,0.13697368}, {935,0.14694737}, {940,0.14270175}, {945,0.14075439}, {950,0.15412281}, {955,0.15710526}, {960,0.13570175}, {965,0.15035088}, {970,0.15164035}, {975,0.15857895}, {980,0.14870175}, {985,0.14976316}, {990,0.15444737}, {995,0.15692982}, {1000,0.15447368}, {1010,0.15978947}, {1020,0.15685088}, {1030,0.15636842}, {1040,0.15300000}, {1050,0.16695614}, {1060,0.15382456}, {1070,0.16348246}, {1080,0.15989474}, {1090,0.16628070}, {1100,0.16857895}, {1110,0.17396491}, {1120,0.16021930}, {1130,0.18160526}, {1140,0.17961404}, {1150,0.19068421}, {1160,0.16616667}, {1170,0.17824561}, {1180,0.18317544}, {1190,0.18673684}, {1200,0.17504386}, {1210,0.18917544}, {1220,0.18530702}, {1230,0.19650000}, {1240,0.19087719}, {1250,0.19284211}, {1260,0.19832456}, {1270,0.20328070}, {1280,0.18050000}, {1290,0.18940351}, {1300,0.19688596}, {1310,0.20742105}, {1320,0.19707895}, {1330,0.19884211}, {1340,0.21356140}, {1350,0.21234211}, {1360,0.20300877}, {1370,0.22089474}, {1380,0.21179825}, {1390,0.22384211}, {1400,0.21725439}, {1410,0.20972807}, {1420,0.22278947}, {1430,0.22460526}, {1440,0.21501754}, {1450,0.22568421}, {1460,0.22768421}, {1470,0.24085088}, {1480,0.23438596}, {1490,0.23297368}, {1500,0.23960526}, {1510,0.24927193}, {1520,0.23300877}, {1530,0.24656140}, {1540,0.23397368}, {1550,0.23856140}, {1560,0.23420175}, {1570,0.23363158}, {1580,0.24020175}, {1590,0.25668421}, {1600,0.23295614}, {1610,0.24557895}, {1620,0.24656140}, {1630,0.25914035}, {1640,0.24814035}, {1650,0.26207895}, {1660,0.27761404}, {1670,0.26102632}, {1680,0.24664912}, {1690,0.25952632}, {1700,0.25026316}, {1710,0.28186842}, {1720,0.27657018}, {1730,0.26718421}, {1740,0.26858772}, {1750,0.27460526}, {1760,0.26754386}, {1770,0.28628947}, {1780,0.28665789}, {1790,0.30028947}, {1800,0.26192105}, {1810,0.27680702}, {1820,0.28650877}, {1830,0.28119298}, {1840,0.27080702}, {1850,0.29542982}, {1860,0.29477193}, {1870,0.30320175}, {1880,0.29597368}, {1890,0.29330702}, {1900,0.29541228}, {1910,0.32135088}, {1920,0.28581579}, {1930,0.29178947}, {1940,0.29708772}, {1950,0.31528947}, {1960,0.30549123}, {1970,0.30864035}, {1980,0.31908772}, {1990,0.31056140}, {2000,0.31353509}, {2050,0.30587719}, {2100,0.32254386}, {2150,0.33803509}, {2200,0.34422807}, {2250,0.36082456}, {2300,0.37492982}, {2350,0.37928947}, {2400,0.38257018}, {2450,0.38411404}, {2500,0.39255263}, {2550,0.42525439}, {2600,0.40153509}, {2650,0.42575439}, {2700,0.42129825}, {2750,0.47016667}, {2800,0.44593860}, {2850,0.44050877}, {2900,0.46814035}, {2950,0.46782456}, {3000,0.48442982}, {3050,0.50687719}, {3100,0.48878947}, {3150,0.51213158}, {3200,0.47811404}, {3250,0.52505263}, {3300,0.53422807}, {3350,0.54153509}, {3400,0.53131579}, {3450,0.59460526}, {3500,0.57367544}, {3550,0.62138596}, {3600,0.54984211}, {3650,0.57092982}, {3700,0.61108772}, {3750,0.61778070}, {3800,0.62392982}, {3850,0.61550877}, {3900,0.67180702}, {3950,0.68600000}, {4000,0.64956140}, {4050,0.67943860}, {4100,0.63748246}, {4150,0.68319298}, {4200,0.69072807}, {4250,0.70226316}, {4300,0.72449123}, {4350,0.76893860}, {4400,0.70828947}, {4450,0.74035088}, {4500,0.74361404}, {4550,0.76513158}, {4600,0.79831579}, {4650,0.76584211}, {4700,0.79783333}, {4750,0.81159649}, {4800,0.76182456}, {4850,0.83939474}, {4900,0.79793860}, {4950,0.85619298}, {5000,0.82098246}, {5050,0.89451754}, {5100,0.90684211}, {5150,0.88837719}, {5200,0.84030702}, {5250,0.84670175}, {5300,0.90194737}, {5350,0.93582456}, {5400,0.89051754}, {5450,0.91921053}, {5500,0.98695614}, {5550,1.00059649}, {5600,0.94706140}, {5650,0.93381579}, {5700,0.95386842}, {5750,1.03645614}, {5800,0.97738596}, {5850,1.05569298}, {5900,0.99708772}, {5950,1.09127193}, {6000,1.06613158}, {6050,1.072571}, {6100,1.117071}, {6150,1.028357}, {6200,1.065643}, {6250,1.113143}, {6300,1.115214}, {6350,1.146214}, {6400,1.045643}, {6450,1.126286}, {6500,1.136500}, {6550,1.191786}, {6600,1.149571}, {6650,1.271500}, {6700,1.176500}, {6750,1.243071}, {6800,1.170429}, {6850,1.188643}, {6900,1.284857}, {6950,1.245357}, {7000,1.230357}, {7050,1.286643}, {7100,1.353143}, {7150,1.404857}, {7200,1.195214}, {7250,1.263000}, {7300,1.256429}, {7350,1.374929}, {7400,1.348214}, {7450,1.366429}, {7500,1.350000}, {7550,1.494929}, {7600,1.361357}, {7650,1.417429}, {7700,1.339500}, {7750,1.404857}, {7800,1.439214}, {7850,1.446214}, {7900,1.498857}, {7950,1.473714}, {8000,1.355357}, {8050,1.533857}, {8100,1.498929}, {8150,1.589929}, {8200,1.371286}, {8250,1.497714}, {8300,1.515429}, {8350,1.570429}, {8400,1.489500}, {8450,1.432786}, {8500,1.571500}, {8550,1.584429}, {8600,1.581429}, {8650,1.623143}, {8700,1.710786}, {8750,1.624857}, {8800,1.534929}, {8850,1.602786}, {8900,1.617571}, {8950,1.770429}, {9000,1.609857}, {9050,1.739143}, {9100,1.684286}, {9150,1.868357}, {9200,1.762429}, {9250,1.616929}, {9300,1.687000}, {9350,1.682571}, {9400,1.742286}, {9450,1.806214}, {9500,1.740571}, {9550,1.810714}, {9600,1.644143}, {9650,1.837071}, {9700,1.823143}, {9750,1.796500}, {9800,1.738000}, {9850,1.891571}, {9900,1.883286}, {9950,1.969857}, {10000,1.764000}, {10100,1.952500}, {10200,1.933143}, {10300,1.916214}, {10400,1.799714}, {10500,1.836357}, {10600,1.949214}, {10700,2.020571}, {10800,1.934643}, {10900,1.993071}, {11000,2.148643}, {11100,2.172143}, {11200,2.038571}, {11300,2.019429}, {11400,2.026571}, {11500,2.246000}, {11600,2.115286}, {11700,2.267643}, {11800,2.170143}, {11900,2.379571}, {12000,2.241357}, {12100,2.268286}, {12200,2.337786}, {12300,2.174000}, {12400,2.249929}, {12500,2.368500}, {12600,2.370571}, {12700,2.450357}, {12800,2.131714}, {12900,2.395571}, {13000,2.426714}, {13100,2.507857}, {13200,2.442929}, {13300,2.668500}, {13400,2.498143}, {13500,2.654786}, {13600,2.409214}, {13700,2.505929}, {13800,2.675500}, {13900,2.618143}, {14000,2.653143}, {14100,2.633214}, {14200,2.839143}, {14300,2.963500}, {14400,2.477929}, {14500,2.703214}, {14600,2.595714}, {14700,2.883286}, {14800,2.811643}, {14900,3.194786}, {15000,2.845357}, {15100,3.112786}, {15200,3.040643}, {15300,2.973643}, {15400,3.202500}, {15500,2.933214}, {15600,3.076643}, {15700,3.244143}, {15800,3.329429}, {15900,3.094357}, {16000,2.860357}, {16100,3.198714}, {16200,3.126643}, {16300,3.332357}, {16400,2.843714}, {16500,3.182571}, {16600,3.530857}, {16700,3.305714}, {16800,3.115786}, {16900,3.345000}, {17000,3.240143}, {17100,3.397571}, {17200,3.287929}, {17300,3.429000}, {17400,3.601857}, {17500,3.447143}, {17600,3.258857}, {17700,3.523286}, {17800,3.720286}, {17900,3.712000}, {18000,3.414071}, {18100,3.652000}, {18200,3.701357}, {18300,3.904000}, {18400,3.649000}, {18500,3.427429}, {18600,3.691071}, {18700,3.690714}, {18800,3.854857}, {18900,3.885214}, {19000,3.702643}, {19100,3.831429}, {19200,3.536214}, {19300,4.071786}, {19400,3.861214}, {19500,3.803000}, {19600,3.733214}, {19700,4.058857}, {19800,4.003357}, {19900,4.445214}, {20000,3.751786}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["norm reif"]["system"] = {{1,0.00010526}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00007018}, {6,0.00003509}, {7,0.00000000}, {8,0.00003509}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00003509}, {13,0.00007018}, {14,0.00003509}, {15,0.00000000}, {16,0.00003509}, {17,0.00010526}, {18,0.00009649}, {19,0.00000000}, {20,0.00000000}, {21,0.00003509}, {22,0.00003509}, {23,0.00003509}, {24,0.00003509}, {25,0.00007018}, {26,0.00000000}, {27,0.00000000}, {28,0.00006140}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00003509}, {34,0.00003509}, {35,0.00007018}, {36,0.00000000}, {37,0.00003509}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00003509}, {43,0.00000000}, {44,0.00000000}, {45,0.00003509}, {46,0.00000000}, {47,0.00003509}, {48,0.00005263}, {49,0.00003509}, {50,0.00003509}, {51,0.00007018}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00003509}, {56,0.00002632}, {57,0.00000000}, {58,0.00002632}, {59,0.00009649}, {60,0.00003509}, {61,0.00000000}, {62,0.00002632}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00003509}, {69,0.00003509}, {70,0.00000000}, {71,0.00007018}, {72,0.00006140}, {73,0.00000000}, {74,0.00006140}, {75,0.00000000}, {76,0.00006140}, {77,0.00002632}, {78,0.00003509}, {79,0.00006140}, {80,0.00000000}, {81,0.00003509}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00009649}, {87,0.00003509}, {88,0.00003509}, {89,0.00000000}, {90,0.00003509}, {91,0.00003509}, {92,0.00003509}, {93,0.00000000}, {94,0.00000000}, {95,0.00007018}, {96,0.00003509}, {97,0.00000000}, {98,0.00002632}, {99,0.00000000}, {100,0.00002632}, {101,0.00003509}, {102,0.00003509}, {103,0.00003509}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00003509}, {108,0.00000000}, {109,0.00000000}, {110,0.00002632}, {111,0.00002632}, {112,0.00000000}, {113,0.00007018}, {114,0.00002632}, {115,0.00003509}, {116,0.00007018}, {117,0.00000000}, {118,0.00002632}, {119,0.00003509}, {120,0.00006140}, {121,0.00003509}, {122,0.00000000}, {123,0.00003509}, {124,0.00003509}, {125,0.00000000}, {126,0.00003509}, {127,0.00003509}, {128,0.00003509}, {129,0.00003509}, {130,0.00000000}, {131,0.00005263}, {132,0.00007018}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00003509}, {137,0.00002632}, {138,0.00000000}, {139,0.00002632}, {140,0.00003509}, {141,0.00014035}, {142,0.00000000}, {143,0.00000000}, {144,0.00007018}, {145,0.00002632}, {146,0.00006140}, {147,0.00000000}, {148,0.00003509}, {149,0.00002632}, {150,0.00000000}, {151,0.00003509}, {152,0.00000000}, {153,0.00003509}, {154,0.00000000}, {155,0.00003509}, {156,0.00010526}, {157,0.00010526}, {158,0.00000000}, {159,0.00007018}, {160,0.00000000}, {161,0.00000000}, {162,0.00007018}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00010526}, {167,0.00000000}, {168,0.00002632}, {169,0.00000000}, {170,0.00013158}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00003509}, {176,0.00007018}, {177,0.00000000}, {178,0.00002632}, {179,0.00007018}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00006140}, {184,0.00000000}, {185,0.00016667}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00010526}, {190,0.00007018}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00003509}, {196,0.00003509}, {197,0.00002632}, {198,0.00000000}, {199,0.00010526}, {200,0.00002632}, {201,0.00003509}, {202,0.00000000}, {203,0.00009649}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00003509}, {208,0.00002632}, {209,0.00000000}, {210,0.00007018}, {211,0.00007018}, {212,0.00016667}, {213,0.00006140}, {214,0.00013158}, {215,0.00010526}, {216,0.00009649}, {217,0.00009649}, {218,0.00009649}, {219,0.00007018}, {220,0.00003509}, {221,0.00014035}, {222,0.00012281}, {223,0.00009649}, {224,0.00007018}, {225,0.00017544}, {226,0.00007018}, {227,0.00010526}, {228,0.00010526}, {229,0.00013158}, {230,0.00002632}, {231,0.00000000}, {232,0.00003509}, {233,0.00007018}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00003509}, {238,0.00000000}, {239,0.00000000}, {240,0.00003509}, {241,0.00003509}, {242,0.00000000}, {243,0.00000000}, {244,0.00003509}, {245,0.00007018}, {246,0.00002632}, {247,0.00007018}, {248,0.00003509}, {249,0.00003509}, {250,0.00000000}, {251,0.00003509}, {252,0.00000000}, {253,0.00023684}, {254,0.00009649}, {255,0.00002632}, {256,0.00000000}, {257,0.00003509}, {258,0.00000000}, {259,0.00014035}, {260,0.00010526}, {261,0.00000000}, {262,0.00003509}, {263,0.00006140}, {264,0.00024561}, {265,0.00010526}, {266,0.00000000}, {267,0.00003509}, {268,0.00000000}, {269,0.00020175}, {270,0.00009649}, {271,0.00000000}, {272,0.00000000}, {273,0.00034211}, {274,0.00003509}, {275,0.00003509}, {276,0.00006140}, {277,0.00035965}, {278,0.00010526}, {279,0.00003509}, {280,0.00003509}, {281,0.00003509}, {282,0.00002632}, {283,0.00010526}, {284,0.00033333}, {285,0.00000000}, {286,0.00003509}, {287,0.00025439}, {288,0.00003509}, {289,0.00003509}, {290,0.00020175}, {291,0.00003509}, {292,0.00007018}, {293,0.00024561}, {294,0.00000000}, {295,0.00003509}, {296,0.00000000}, {297,0.00000000}, {298,0.00042105}, {299,0.00007018}, {300,0.00010526}, {301,0.00033333}, {302,0.00000000}, {303,0.00028070}, {304,0.00000000}, {305,0.00013158}, {306,0.00000000}, {307,0.00000000}, {308,0.00033333}, {309,0.00000000}, {310,0.00021053}, {311,0.00003509}, {312,0.00028070}, {313,0.00010526}, {314,0.00037719}, {315,0.00000000}, {316,0.00000000}, {317,0.00003509}, {318,0.00000000}, {319,0.00000000}, {320,0.00003509}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00003509}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00003509}, {336,0.00003509}, {337,0.00003509}, {338,0.00000000}, {339,0.00007018}, {340,0.00000000}, {341,0.00003509}, {342,0.00003509}, {343,0.00003509}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00002632}, {350,0.00003509}, {351,0.00000000}, {352,0.00000000}, {353,0.00003509}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00003509}, {359,0.00002632}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00003509}, {366,0.00007018}, {367,0.00003509}, {368,0.00007018}, {369,0.00000000}, {370,0.00003509}, {371,0.00003509}, {372,0.00000000}, {373,0.00003509}, {374,0.00003509}, {375,0.00000000}, {376,0.00002632}, {377,0.00000000}, {378,0.00000000}, {379,0.00002632}, {380,0.00003509}, {381,0.00000000}, {382,0.00003509}, {383,0.00007018}, {384,0.00003509}, {385,0.00000000}, {386,0.00002632}, {387,0.00003509}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00003509}, {392,0.00000000}, {393,0.00003509}, {394,0.00000000}, {395,0.00003509}, {396,0.00007018}, {397,0.00003509}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00007018}, {403,0.00000000}, {404,0.00003509}, {405,0.00000000}, {406,0.00027193}, {407,0.00014035}, {408,0.00009649}, {409,0.00014035}, {410,0.00010526}, {411,0.00020175}, {412,0.00000000}, {413,0.00017544}, {414,0.00017544}, {415,0.00014035}, {416,0.00003509}, {417,0.00021053}, {418,0.00010526}, {419,0.00000000}, {420,0.00010526}, {421,0.00010526}, {422,0.00000000}, {423,0.00007018}, {424,0.00003509}, {425,0.00003509}, {426,0.00014035}, {427,0.00007018}, {428,0.00003509}, {429,0.00000000}, {430,0.00007018}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00002632}, {436,0.00007018}, {437,0.00017544}, {438,0.00009649}, {439,0.00013158}, {440,0.00000000}, {441,0.00000000}, {442,0.00003509}, {443,0.00014035}, {444,0.00003509}, {445,0.00007018}, {446,0.00003509}, {447,0.00000000}, {448,0.00003509}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00003509}, {453,0.00002632}, {454,0.00003509}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00006140}, {461,0.00002632}, {462,0.00000000}, {463,0.00007018}, {464,0.00007018}, {465,0.00003509}, {466,0.00000000}, {467,0.00000000}, {468,0.00006140}, {469,0.00000000}, {470,0.00003509}, {471,0.00000000}, {472,0.00007018}, {473,0.00003509}, {474,0.00003509}, {475,0.00003509}, {476,0.00007018}, {477,0.00000000}, {478,0.00000000}, {479,0.00003509}, {480,0.00000000}, {481,0.00003509}, {482,0.00003509}, {483,0.00003509}, {484,0.00006140}, {485,0.00000000}, {486,0.00000000}, {487,0.00010526}, {488,0.00000000}, {489,0.00003509}, {490,0.00007018}, {491,0.00003509}, {492,0.00003509}, {493,0.00000000}, {494,0.00000000}, {495,0.00003509}, {496,0.00003509}, {497,0.00000000}, {498,0.00006140}, {499,0.00000000}, {500,0.00000000}, {505,0.00003509}, {510,0.00000000}, {515,0.00003509}, {520,0.00006140}, {525,0.00003509}, {530,0.00003509}, {535,0.00000000}, {540,0.00002632}, {545,0.00000000}, {550,0.00007018}, {555,0.00003509}, {560,0.00003509}, {565,0.00003509}, {570,0.00000000}, {575,0.00000000}, {580,0.00003509}, {585,0.00003509}, {590,0.00000000}, {595,0.00003509}, {600,0.00007018}, {605,0.00006140}, {610,0.00007018}, {615,0.00007018}, {620,0.00003509}, {625,0.00017544}, {630,0.00000000}, {635,0.00010526}, {640,0.00007018}, {645,0.00006140}, {650,0.00007018}, {655,0.00000000}, {660,0.00007018}, {665,0.00003509}, {670,0.00000000}, {675,0.00003509}, {680,0.00003509}, {685,0.00007018}, {690,0.00000000}, {695,0.00000000}, {700,0.00008772}, {705,0.00000000}, {710,0.00003509}, {715,0.00006140}, {720,0.00000000}, {725,0.00000000}, {730,0.00003509}, {735,0.00000000}, {740,0.00010526}, {745,0.00006140}, {750,0.00000000}, {755,0.00003509}, {760,0.00000000}, {765,0.00007018}, {770,0.00007018}, {775,0.00002632}, {780,0.00000000}, {785,0.00000000}, {790,0.00003509}, {795,0.00000000}, {800,0.00000000}, {805,0.00007018}, {810,0.00007018}, {815,0.00000000}, {820,0.00007018}, {825,0.00002632}, {830,0.00003509}, {835,0.00003509}, {840,0.00003509}, {845,0.00000000}, {850,0.00007018}, {855,0.00003509}, {860,0.00000000}, {865,0.00003509}, {870,0.00003509}, {875,0.00003509}, {880,0.00002632}, {885,0.00007018}, {890,0.00000000}, {895,0.00000000}, {900,0.00005263}, {905,0.00003509}, {910,0.00006140}, {915,0.00000000}, {920,0.00007018}, {925,0.00007018}, {930,0.00000000}, {935,0.00000000}, {940,0.00007018}, {945,0.00003509}, {950,0.00007018}, {955,0.00003509}, {960,0.00008772}, {965,0.00010526}, {970,0.00007018}, {975,0.00014035}, {980,0.00006140}, {985,0.00003509}, {990,0.00000000}, {995,0.00000000}, {1000,0.00007018}, {1010,0.00003509}, {1020,0.00007018}, {1030,0.00010526}, {1040,0.00003509}, {1050,0.00021053}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00006140}, {1090,0.00000000}, {1100,0.00003509}, {1110,0.00000000}, {1120,0.00003509}, {1130,0.00017544}, {1140,0.00003509}, {1150,0.00000000}, {1160,0.00003509}, {1170,0.00000000}, {1180,0.00002632}, {1190,0.00006140}, {1200,0.00007018}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00002632}, {1250,0.00006140}, {1260,0.00003509}, {1270,0.00003509}, {1280,0.00000000}, {1290,0.00007018}, {1300,0.00003509}, {1310,0.00017544}, {1320,0.00000000}, {1330,0.00010526}, {1340,0.00000000}, {1350,0.00003509}, {1360,0.00003509}, {1370,0.00010526}, {1380,0.00000000}, {1390,0.00043860}, {1400,0.00055263}, {1410,0.00069298}, {1420,0.00007018}, {1430,0.00000000}, {1440,0.00007018}, {1450,0.00007018}, {1460,0.00007018}, {1470,0.00007018}, {1480,0.00003509}, {1490,0.00002632}, {1500,0.00009649}, {1510,0.00007018}, {1520,0.00007018}, {1530,0.00000000}, {1540,0.00010526}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00010526}, {1580,0.00000000}, {1590,0.00007018}, {1600,0.00006140}, {1610,0.00007018}, {1620,0.00003509}, {1630,0.00000000}, {1640,0.00003509}, {1650,0.00010526}, {1660,0.00007018}, {1670,0.00003509}, {1680,0.00007018}, {1690,0.00000000}, {1700,0.00003509}, {1710,0.00003509}, {1720,0.00003509}, {1730,0.00007018}, {1740,0.00000000}, {1750,0.00003509}, {1760,0.00014035}, {1770,0.00003509}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00007018}, {1810,0.00009649}, {1820,0.00000000}, {1830,0.00003509}, {1840,0.00003509}, {1850,0.00010526}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00003509}, {1890,0.00010526}, {1900,0.00007018}, {1910,0.00003509}, {1920,0.00007018}, {1930,0.00007018}, {1940,0.00003509}, {1950,0.00006140}, {1960,0.00014035}, {1970,0.00007018}, {1980,0.00000000}, {1990,0.00006140}, {2000,0.00003509}, {2050,0.00000000}, {2100,0.00007018}, {2150,0.00017544}, {2200,0.00007018}, {2250,0.00010526}, {2300,0.00007018}, {2350,0.00007018}, {2400,0.00010526}, {2450,0.00000000}, {2500,0.00007018}, {2550,0.00010526}, {2600,0.00003509}, {2650,0.00003509}, {2700,0.00003509}, {2750,0.00003509}, {2800,0.00009649}, {2850,0.00000000}, {2900,0.00014035}, {2950,0.00007018}, {3000,0.00014035}, {3050,0.00014035}, {3100,0.00013158}, {3150,0.00007018}, {3200,0.00021053}, {3250,0.00003509}, {3300,0.00003509}, {3350,0.00000000}, {3400,0.00003509}, {3450,0.00007018}, {3500,0.00000000}, {3550,0.00007018}, {3600,0.00033333}, {3650,0.00010526}, {3700,0.00015789}, {3750,0.00007018}, {3800,0.00003509}, {3850,0.00007018}, {3900,0.00014035}, {3950,0.00021053}, {4000,0.00010526}, {4050,0.00014035}, {4100,0.00007018}, {4150,0.00050877}, {4200,0.00010526}, {4250,0.00014035}, {4300,0.00003509}, {4350,0.00007018}, {4400,0.00007018}, {4450,0.00009649}, {4500,0.00003509}, {4550,0.00014035}, {4600,0.00014035}, {4650,0.00157018}, {4700,0.00014035}, {4750,0.00007018}, {4800,0.00010526}, {4850,0.00009649}, {4900,0.00003509}, {4950,0.00028070}, {5000,0.00007018}, {5050,0.00009649}, {5100,0.00010526}, {5150,0.00007018}, {5200,0.00021053}, {5250,0.00007018}, {5300,0.00016667}, {5350,0.00037719}, {5400,0.00017544}, {5450,0.00007018}, {5500,0.00020175}, {5550,0.00035088}, {5600,0.00175439}, {5650,0.00017544}, {5700,0.00010526}, {5750,0.00014035}, {5800,0.00007018}, {5850,0.00016667}, {5900,0.00007018}, {5950,0.00024561}, {6000,0.00003509}, {6050,0.004429}, {6100,0.002500}, {6150,0.001643}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000286}, {6400,0.000000}, {6450,0.000286}, {6500,0.000286}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000286}, {7100,0.000571}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000571}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000214}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000286}, {8050,0.000000}, {8100,0.000000}, {8150,0.000286}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000571}, {8500,0.000000}, {8550,0.000286}, {8600,0.000286}, {8650,0.000000}, {8700,0.000571}, {8750,0.000000}, {8800,0.000000}, {8850,0.000286}, {8900,0.000571}, {8950,0.000571}, {9000,0.000000}, {9050,0.000286}, {9100,0.000000}, {9150,0.000000}, {9200,0.000286}, {9250,0.000000}, {9300,0.000286}, {9350,0.000000}, {9400,0.000286}, {9450,0.000286}, {9500,0.000286}, {9550,0.000000}, {9600,0.000000}, {9650,0.000286}, {9700,0.000286}, {9750,0.000000}, {9800,0.000500}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000571}, {10300,0.000000}, {10400,0.000857}, {10500,0.000000}, {10600,0.000000}, {10700,0.000286}, {10800,0.000571}, {10900,0.000000}, {11000,0.000286}, {11100,0.000286}, {11200,0.000286}, {11300,0.000571}, {11400,0.000000}, {11500,0.000286}, {11600,0.000286}, {11700,0.000000}, {11800,0.000286}, {11900,0.000286}, {12000,0.000000}, {12100,0.000286}, {12200,0.000857}, {12300,0.000000}, {12400,0.000286}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000286}, {12900,0.000000}, {13000,0.000286}, {13100,0.001071}, {13200,0.000286}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000571}, {13800,0.002000}, {13900,0.001714}, {14000,0.000786}, {14100,0.000000}, {14200,0.000000}, {14300,0.001429}, {14400,0.000000}, {14500,0.000286}, {14600,0.001429}, {14700,0.000571}, {14800,0.000857}, {14900,0.000571}, {15000,0.000000}, {15100,0.000857}, {15200,0.000286}, {15300,0.000000}, {15400,0.001429}, {15500,0.000000}, {15600,0.000571}, {15700,0.000571}, {15800,0.000857}, {15900,0.000571}, {16000,0.000286}, {16100,0.003143}, {16200,0.000000}, {16300,0.000000}, {16400,0.000286}, {16500,0.000857}, {16600,0.002857}, {16700,0.000857}, {16800,0.000000}, {16900,0.000857}, {17000,0.000000}, {17100,0.001143}, {17200,0.000857}, {17300,0.000000}, {17400,0.000286}, {17500,0.000286}, {17600,0.000286}, {17700,0.000571}, {17800,0.001643}, {17900,0.000786}, {18000,0.002286}, {18100,0.002286}, {18200,0.000286}, {18300,0.003429}, {18400,0.001857}, {18500,0.001143}, {18600,0.001429}, {18700,0.001143}, {18800,0.001143}, {18900,0.002786}, {19000,0.001429}, {19100,0.000000}, {19200,0.000571}, {19300,0.000286}, {19400,0.000286}, {19500,0.000571}, {19600,0.001143}, {19700,0.000857}, {19800,0.000857}, {19900,0.001143}, {20000,0.000571}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00006140}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000000}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["post"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00002632}, {7,0.00002632}, {8,0.00003509}, {9,0.00005263}, {10,0.00005263}, {11,0.00003509}, {12,0.00000000}, {13,0.00002632}, {14,0.00000000}, {15,0.00007018}, {16,0.00000000}, {17,0.00003509}, {18,0.00003509}, {19,0.00002632}, {20,0.00000000}, {21,0.00002632}, {22,0.00000000}, {23,0.00000000}, {24,0.00002632}, {25,0.00003509}, {26,0.00000000}, {27,0.00002632}, {28,0.00000000}, {29,0.00000000}, {30,0.00002632}, {31,0.00000000}, {32,0.00000000}, {33,0.00007018}, {34,0.00000000}, {35,0.00002632}, {36,0.00000000}, {37,0.00002632}, {38,0.00002632}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00016667}, {45,0.00000000}, {46,0.00000000}, {47,0.00002632}, {48,0.00000000}, {49,0.00007018}, {50,0.00003509}, {51,0.00006140}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00003509}, {58,0.00002632}, {59,0.00003509}, {60,0.00007895}, {61,0.00000000}, {62,0.00002632}, {63,0.00003509}, {64,0.00000000}, {65,0.00000000}, {66,0.00002632}, {67,0.00006140}, {68,0.00016667}, {69,0.00002632}, {70,0.00000000}, {71,0.00000000}, {72,0.00008772}, {73,0.00000000}, {74,0.00003509}, {75,0.00000000}, {76,0.00005263}, {77,0.00000000}, {78,0.00005263}, {79,0.00006140}, {80,0.00003509}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00007018}, {85,0.00000000}, {86,0.00000000}, {87,0.00005263}, {88,0.00005263}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00009649}, {93,0.00000000}, {94,0.00002632}, {95,0.00002632}, {96,0.00000000}, {97,0.00002632}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00009649}, {103,0.00003509}, {104,0.00002632}, {105,0.00008772}, {106,0.00008772}, {107,0.00007895}, {108,0.00000000}, {109,0.00003509}, {110,0.00003509}, {111,0.00000000}, {112,0.00000000}, {113,0.00002632}, {114,0.00005263}, {115,0.00007018}, {116,0.00000000}, {117,0.00000000}, {118,0.00002632}, {119,0.00002632}, {120,0.00005263}, {121,0.00000000}, {122,0.00002632}, {123,0.00003509}, {124,0.00006140}, {125,0.00007895}, {126,0.00006140}, {127,0.00002632}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00002632}, {132,0.00005263}, {133,0.00003509}, {134,0.00002632}, {135,0.00003509}, {136,0.00000000}, {137,0.00007895}, {138,0.00000000}, {139,0.00000000}, {140,0.00005263}, {141,0.00003509}, {142,0.00006140}, {143,0.00006140}, {144,0.00000000}, {145,0.00002632}, {146,0.00002632}, {147,0.00000000}, {148,0.00000000}, {149,0.00003509}, {150,0.00000000}, {151,0.00008772}, {152,0.00000000}, {153,0.00000000}, {154,0.00006140}, {155,0.00000000}, {156,0.00002632}, {157,0.00000000}, {158,0.00005263}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00008772}, {164,0.00000000}, {165,0.00002632}, {166,0.00000000}, {167,0.00002632}, {168,0.00006140}, {169,0.00000000}, {170,0.00002632}, {171,0.00003509}, {172,0.00003509}, {173,0.00000000}, {174,0.00012281}, {175,0.00000000}, {176,0.00002632}, {177,0.00002632}, {178,0.00000000}, {179,0.00002632}, {180,0.00000000}, {181,0.00002632}, {182,0.00003509}, {183,0.00003509}, {184,0.00008772}, {185,0.00000000}, {186,0.00000000}, {187,0.00003509}, {188,0.00000000}, {189,0.00002632}, {190,0.00002632}, {191,0.00000000}, {192,0.00002632}, {193,0.00000000}, {194,0.00000000}, {195,0.00002632}, {196,0.00006140}, {197,0.00003509}, {198,0.00010526}, {199,0.00000000}, {200,0.00000000}, {201,0.00002632}, {202,0.00000000}, {203,0.00006140}, {204,0.00007018}, {205,0.00006140}, {206,0.00011404}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00002632}, {211,0.00000000}, {212,0.00002632}, {213,0.00003509}, {214,0.00003509}, {215,0.00003509}, {216,0.00003509}, {217,0.00003509}, {218,0.00000000}, {219,0.00006140}, {220,0.00005263}, {221,0.00013158}, {222,0.00007018}, {223,0.00000000}, {224,0.00007018}, {225,0.00003509}, {226,0.00002632}, {227,0.00006140}, {228,0.00009649}, {229,0.00006140}, {230,0.00000000}, {231,0.00003509}, {232,0.00003509}, {233,0.00006140}, {234,0.00000000}, {235,0.00002632}, {236,0.00002632}, {237,0.00000000}, {238,0.00002632}, {239,0.00002632}, {240,0.00000000}, {241,0.00007018}, {242,0.00002632}, {243,0.00000000}, {244,0.00003509}, {245,0.00000000}, {246,0.00007895}, {247,0.00002632}, {248,0.00003509}, {249,0.00007018}, {250,0.00005263}, {251,0.00006140}, {252,0.00000000}, {253,0.00002632}, {254,0.00002632}, {255,0.00003509}, {256,0.00003509}, {257,0.00003509}, {258,0.00000000}, {259,0.00007018}, {260,0.00003509}, {261,0.00000000}, {262,0.00000000}, {263,0.00008772}, {264,0.00000000}, {265,0.00005263}, {266,0.00000000}, {267,0.00002632}, {268,0.00003509}, {269,0.00003509}, {270,0.00013158}, {271,0.00006140}, {272,0.00006140}, {273,0.00003509}, {274,0.00000000}, {275,0.00000000}, {276,0.00006140}, {277,0.00006140}, {278,0.00003509}, {279,0.00002632}, {280,0.00000000}, {281,0.00000000}, {282,0.00003509}, {283,0.00000000}, {284,0.00000000}, {285,0.00003509}, {286,0.00003509}, {287,0.00003509}, {288,0.00003509}, {289,0.00006140}, {290,0.00008772}, {291,0.00002632}, {292,0.00005263}, {293,0.00009649}, {294,0.00000000}, {295,0.00000000}, {296,0.00003509}, {297,0.00003509}, {298,0.00003509}, {299,0.00003509}, {300,0.00006140}, {301,0.00003509}, {302,0.00006140}, {303,0.00009649}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00003509}, {308,0.00003509}, {309,0.00000000}, {310,0.00003509}, {311,0.00000000}, {312,0.00000000}, {313,0.00006140}, {314,0.00007018}, {315,0.00000000}, {316,0.00007018}, {317,0.00003509}, {318,0.00002632}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00002632}, {325,0.00011404}, {326,0.00000000}, {327,0.00002632}, {328,0.00000000}, {329,0.00005263}, {330,0.00002632}, {331,0.00002632}, {332,0.00002632}, {333,0.00000000}, {334,0.00000000}, {335,0.00003509}, {336,0.00002632}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00006140}, {341,0.00002632}, {342,0.00002632}, {343,0.00008772}, {344,0.00000000}, {345,0.00000000}, {346,0.00002632}, {347,0.00003509}, {348,0.00002632}, {349,0.00006140}, {350,0.00002632}, {351,0.00006140}, {352,0.00002632}, {353,0.00000000}, {354,0.00005263}, {355,0.00005263}, {356,0.00000000}, {357,0.00002632}, {358,0.00000000}, {359,0.00007018}, {360,0.00002632}, {361,0.00002632}, {362,0.00002632}, {363,0.00005263}, {364,0.00003509}, {365,0.00002632}, {366,0.00000000}, {367,0.00000000}, {368,0.00003509}, {369,0.00005263}, {370,0.00000000}, {371,0.00002632}, {372,0.00000000}, {373,0.00003509}, {374,0.00000000}, {375,0.00002632}, {376,0.00002632}, {377,0.00002632}, {378,0.00000000}, {379,0.00000000}, {380,0.00005263}, {381,0.00000000}, {382,0.00002632}, {383,0.00002632}, {384,0.00000000}, {385,0.00000000}, {386,0.00002632}, {387,0.00006140}, {388,0.00006140}, {389,0.00000000}, {390,0.00002632}, {391,0.00000000}, {392,0.00006140}, {393,0.00002632}, {394,0.00003509}, {395,0.00000000}, {396,0.00000000}, {397,0.00002632}, {398,0.00002632}, {399,0.00002632}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00002632}, {404,0.00009649}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00005263}, {409,0.00005263}, {410,0.00000000}, {411,0.00006140}, {412,0.00006140}, {413,0.00000000}, {414,0.00002632}, {415,0.00008772}, {416,0.00000000}, {417,0.00003509}, {418,0.00002632}, {419,0.00002632}, {420,0.00000000}, {421,0.00000000}, {422,0.00002632}, {423,0.00008772}, {424,0.00003509}, {425,0.00000000}, {426,0.00002632}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00003509}, {433,0.00008772}, {434,0.00000000}, {435,0.00002632}, {436,0.00002632}, {437,0.00000000}, {438,0.00003509}, {439,0.00000000}, {440,0.00002632}, {441,0.00000000}, {442,0.00000000}, {443,0.00003509}, {444,0.00002632}, {445,0.00003509}, {446,0.00011404}, {447,0.00003509}, {448,0.00003509}, {449,0.00005263}, {450,0.00005263}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00002632}, {457,0.00000000}, {458,0.00003509}, {459,0.00005263}, {460,0.00000000}, {461,0.00003509}, {462,0.00000000}, {463,0.00009649}, {464,0.00002632}, {465,0.00006140}, {466,0.00000000}, {467,0.00007018}, {468,0.00007018}, {469,0.00000000}, {470,0.00010526}, {471,0.00003509}, {472,0.00000000}, {473,0.00003509}, {474,0.00002632}, {475,0.00002632}, {476,0.00002632}, {477,0.00000000}, {478,0.00003509}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00006140}, {483,0.00003509}, {484,0.00002632}, {485,0.00002632}, {486,0.00000000}, {487,0.00009649}, {488,0.00006140}, {489,0.00000000}, {490,0.00006140}, {491,0.00002632}, {492,0.00003509}, {493,0.00000000}, {494,0.00003509}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00006140}, {510,0.00003509}, {515,0.00002632}, {520,0.00002632}, {525,0.00000000}, {530,0.00003509}, {535,0.00000000}, {540,0.00006140}, {545,0.00000000}, {550,0.00000000}, {555,0.00002632}, {560,0.00000000}, {565,0.00000000}, {570,0.00006140}, {575,0.00000000}, {580,0.00006140}, {585,0.00000000}, {590,0.00005263}, {595,0.00000000}, {600,0.00003509}, {605,0.00003509}, {610,0.00007018}, {615,0.00003509}, {620,0.00003509}, {625,0.00000000}, {630,0.00009649}, {635,0.00000000}, {640,0.00000000}, {645,0.00002632}, {650,0.00000000}, {655,0.00003509}, {660,0.00000000}, {665,0.00003509}, {670,0.00003509}, {675,0.00012281}, {680,0.00000000}, {685,0.00000000}, {690,0.00002632}, {695,0.00000000}, {700,0.00000000}, {705,0.00003509}, {710,0.00003509}, {715,0.00000000}, {720,0.00007018}, {725,0.00000000}, {730,0.00007018}, {735,0.00000000}, {740,0.00003509}, {745,0.00015789}, {750,0.00003509}, {755,0.00000000}, {760,0.00003509}, {765,0.00009649}, {770,0.00003509}, {775,0.00000000}, {780,0.00003509}, {785,0.00007018}, {790,0.00008772}, {795,0.00007018}, {800,0.00014035}, {805,0.00000000}, {810,0.00009649}, {815,0.00005263}, {820,0.00002632}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00002632}, {855,0.00007018}, {860,0.00008772}, {865,0.00000000}, {870,0.00000000}, {875,0.00003509}, {880,0.00000000}, {885,0.00000000}, {890,0.00002632}, {895,0.00003509}, {900,0.00006140}, {905,0.00000000}, {910,0.00000000}, {915,0.00005263}, {920,0.00003509}, {925,0.00006140}, {930,0.00000000}, {935,0.00000000}, {940,0.00007018}, {945,0.00000000}, {950,0.00002632}, {955,0.00003509}, {960,0.00000000}, {965,0.00003509}, {970,0.00000000}, {975,0.00012281}, {980,0.00003509}, {985,0.00000000}, {990,0.00000000}, {995,0.00003509}, {1000,0.00003509}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00007018}, {1040,0.00000000}, {1050,0.00005263}, {1060,0.00000000}, {1070,0.00002632}, {1080,0.00003509}, {1090,0.00002632}, {1100,0.00002632}, {1110,0.00002632}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00003509}, {1160,0.00000000}, {1170,0.00006140}, {1180,0.00000000}, {1190,0.00002632}, {1200,0.00000000}, {1210,0.00002632}, {1220,0.00006140}, {1230,0.00000000}, {1240,0.00002632}, {1250,0.00002632}, {1260,0.00002632}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00005263}, {1330,0.00000000}, {1340,0.00002632}, {1350,0.00002632}, {1360,0.00000000}, {1370,0.00002632}, {1380,0.00008772}, {1390,0.00003509}, {1400,0.00002632}, {1410,0.00000000}, {1420,0.00003509}, {1430,0.00000000}, {1440,0.00013158}, {1450,0.00002632}, {1460,0.00002632}, {1470,0.00007018}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00002632}, {1530,0.00007895}, {1540,0.00005263}, {1550,0.00000000}, {1560,0.00002632}, {1570,0.00007895}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00003509}, {1620,0.00006140}, {1630,0.00002632}, {1640,0.00000000}, {1650,0.00002632}, {1660,0.00002632}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00011404}, {1710,0.00003509}, {1720,0.00002632}, {1730,0.00006140}, {1740,0.00003509}, {1750,0.00002632}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00005263}, {1800,0.00002632}, {1810,0.00002632}, {1820,0.00011404}, {1830,0.00005263}, {1840,0.00000000}, {1850,0.00005263}, {1860,0.00002632}, {1870,0.00005263}, {1880,0.00000000}, {1890,0.00005263}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00003509}, {1930,0.00002632}, {1940,0.00000000}, {1950,0.00003509}, {1960,0.00000000}, {1970,0.00002632}, {1980,0.00009649}, {1990,0.00002632}, {2000,0.00007895}, {2050,0.00002632}, {2100,0.00011404}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00002632}, {2400,0.00000000}, {2450,0.00002632}, {2500,0.00000000}, {2550,0.00002632}, {2600,0.00002632}, {2650,0.00006140}, {2700,0.00000000}, {2750,0.00002632}, {2800,0.00000000}, {2850,0.00006140}, {2900,0.00006140}, {2950,0.00000000}, {3000,0.00014035}, {3050,0.00006140}, {3100,0.00007018}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00002632}, {3300,0.00002632}, {3350,0.00000000}, {3400,0.00003509}, {3450,0.00008772}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00006140}, {3650,0.00000000}, {3700,0.00003509}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00003509}, {3900,0.00003509}, {3950,0.00000000}, {4000,0.00003509}, {4050,0.00002632}, {4100,0.00007018}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00002632}, {4350,0.00009649}, {4400,0.00000000}, {4450,0.00002632}, {4500,0.00000000}, {4550,0.00006140}, {4600,0.00007018}, {4650,0.00003509}, {4700,0.00000000}, {4750,0.00013158}, {4800,0.00005263}, {4850,0.00000000}, {4900,0.00002632}, {4950,0.00003509}, {5000,0.00002632}, {5050,0.00000000}, {5100,0.00007018}, {5150,0.00003509}, {5200,0.00002632}, {5250,0.00000000}, {5300,0.00002632}, {5350,0.00007018}, {5400,0.00010526}, {5450,0.00000000}, {5500,0.00010526}, {5550,0.00000000}, {5600,0.00007018}, {5650,0.00000000}, {5700,0.00003509}, {5750,0.00003509}, {5800,0.00000000}, {5850,0.00003509}, {5900,0.00006140}, {5950,0.00003509}, {6000,0.00000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000214}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000214}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000286}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000214}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000286}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000214}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000286}, {11700,0.000000}, {11800,0.000214}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000286}, {13400,0.000000}, {13500,0.000000}, {13600,0.000286}, {13700,0.000286}, {13800,0.000000}, {13900,0.000000}, {14000,0.000286}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000214}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000286}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000214}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000214}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000000}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000286}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000214}, {20000,0.000000}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["post"]["system"] = {{1,0.00000000}, {2,0.00003509}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00003509}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00003509}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00003509}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000000}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000000}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00003509}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00003509}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00002632}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00002632}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00003509}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00002632}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00003509}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00002632}, {110,0.00000000}, {111,0.00002632}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00002632}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00002632}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00002632}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00002632}, {169,0.00000000}, {170,0.00000000}, {171,0.00002632}, {172,0.00002632}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00002632}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00003509}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00003509}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00003509}, {196,0.00000000}, {197,0.00000000}, {198,0.00002632}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00002632}, {203,0.00000000}, {204,0.00000000}, {205,0.00003509}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00002632}, {212,0.00000000}, {213,0.00003509}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00003509}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00003509}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00002632}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00003509}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003509}, {266,0.00003509}, {267,0.00002632}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00002632}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00003509}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00003509}, {323,0.00000000}, {324,0.00000000}, {325,0.00003509}, {326,0.00000000}, {327,0.00002632}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00003509}, {338,0.00003509}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00002632}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00002632}, {365,0.00000000}, {366,0.00000000}, {367,0.00003509}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00003509}, {372,0.00003509}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00002632}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00007018}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00002632}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00002632}, {432,0.00002632}, {433,0.00000000}, {434,0.00002632}, {435,0.00000000}, {436,0.00002632}, {437,0.00000000}, {438,0.00002632}, {439,0.00002632}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00002632}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00002632}, {465,0.00002632}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00002632}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00003509}, {535,0.00002632}, {540,0.00003509}, {545,0.00000000}, {550,0.00000000}, {555,0.00006140}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00003509}, {580,0.00000000}, {585,0.00002632}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00002632}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00006140}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00003509}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00003509}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00003509}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00002632}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00003509}, {970,0.00002632}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00003509}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00002632}, {1020,0.00002632}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00006140}, {1060,0.00003509}, {1070,0.00002632}, {1080,0.00003509}, {1090,0.00002632}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00005263}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00002632}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003509}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00002632}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00002632}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00003509}, {1430,0.00000000}, {1440,0.00003509}, {1450,0.00002632}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00003509}, {1550,0.00002632}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00002632}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00003509}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00003509}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00002632}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00002632}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00002632}, {1820,0.00000000}, {1830,0.00002632}, {1840,0.00000000}, {1850,0.00002632}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00002632}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00003509}, {1940,0.00003509}, {1950,0.00003509}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00002632}, {2200,0.00000000}, {2250,0.00003509}, {2300,0.00002632}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00006140}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00003509}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00003509}, {3850,0.00006140}, {3900,0.00000000}, {3950,0.00002632}, {4000,0.00002632}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00003509}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00003509}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00003509}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00002632}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00003509}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00003509}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000214}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000286}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000000}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00003509}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000286}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000000}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00079825}, {8,0.00100000}, {9,0.00100000}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00171053}, {15,0.00120175}, {16,0.00129825}, {17,0.00200000}, {18,0.00200000}, {19,0.00200000}, {20,0.00200000}, {21,0.00200000}, {22,0.00200000}, {23,0.00217544}, {24,0.00212281}, {25,0.00251754}, {26,0.00300000}, {27,0.00300000}, {28,0.00300000}, {29,0.00300000}, {30,0.00301754}, {31,0.00324561}, {32,0.00305263}, {33,0.00334211}, {34,0.00358772}, {35,0.00484211}, {36,0.00400000}, {37,0.00400000}, {38,0.00400000}, {39,0.00422807}, {40,0.00406140}, {41,0.00426316}, {42,0.00440351}, {43,0.00500000}, {44,0.00499123}, {45,0.00500000}, {46,0.00501754}, {47,0.00515789}, {48,0.00501754}, {49,0.00518421}, {50,0.00528070}, {51,0.00594737}, {52,0.00572807}, {53,0.00600000}, {54,0.00601754}, {55,0.00620175}, {56,0.00706140}, {57,0.00626316}, {58,0.00623684}, {59,0.00697368}, {60,0.00663158}, {61,0.00703509}, {62,0.00714035}, {63,0.00719298}, {64,0.00723684}, {65,0.00719298}, {66,0.00726316}, {67,0.00774561}, {68,0.00733333}, {69,0.00802632}, {70,0.00824561}, {71,0.00975439}, {72,0.00801754}, {73,0.00821930}, {74,0.00821053}, {75,0.00898246}, {76,0.00842105}, {77,0.00913158}, {78,0.00903509}, {79,0.00918421}, {80,0.00903509}, {81,0.00914912}, {82,0.00937719}, {83,0.00970175}, {84,0.00928070}, {85,0.01014035}, {86,0.01186842}, {87,0.01021053}, {88,0.01007895}, {89,0.01015789}, {90,0.01029825}, {91,0.01103509}, {92,0.01055263}, {93,0.01118421}, {94,0.01109649}, {95,0.01154386}, {96,0.01064035}, {97,0.01115789}, {98,0.01133333}, {99,0.01158772}, {100,0.01135088}, {101,0.01329825}, {102,0.01203509}, {103,0.01228070}, {104,0.01200877}, {105,0.01220175}, {106,0.01221053}, {107,0.01319298}, {108,0.01252632}, {109,0.01314912}, {110,0.01314912}, {111,0.01359649}, {112,0.01279825}, {113,0.01319298}, {114,0.01421930}, {115,0.01428947}, {116,0.01489474}, {117,0.01412281}, {118,0.01570175}, {119,0.01459649}, {120,0.01411404}, {121,0.01457018}, {122,0.01442105}, {123,0.01520175}, {124,0.01501754}, {125,0.01521053}, {126,0.01519298}, {127,0.01611404}, {128,0.01459649}, {129,0.01611404}, {130,0.01517544}, {131,0.01591228}, {132,0.01521053}, {133,0.01614035}, {134,0.01622807}, {135,0.01673684}, {136,0.01797368}, {137,0.01631579}, {138,0.01634211}, {139,0.01732456}, {140,0.01667544}, {141,0.01959649}, {142,0.01736842}, {143,0.01820175}, {144,0.01846491}, {145,0.01722807}, {146,0.01732456}, {147,0.01813158}, {148,0.01751754}, {149,0.02011404}, {150,0.01856140}, {151,0.01910526}, {152,0.01815789}, {153,0.01862281}, {154,0.01885088}, {155,0.01940351}, {156,0.01912281}, {157,0.01962281}, {158,0.01983333}, {159,0.02330702}, {160,0.01877193}, {161,0.01920175}, {162,0.01935088}, {163,0.02019298}, {164,0.01949123}, {165,0.02032456}, {166,0.02287719}, {167,0.02123684}, {168,0.02010526}, {169,0.02074561}, {170,0.02312281}, {171,0.02157018}, {172,0.02116667}, {173,0.02177193}, {174,0.02392982}, {175,0.02245614}, {176,0.02094737}, {177,0.02150000}, {178,0.02168421}, {179,0.02480702}, {180,0.02200877}, {181,0.02265789}, {182,0.02271930}, {183,0.02349123}, {184,0.02230702}, {185,0.02500000}, {186,0.02331579}, {187,0.02414035}, {188,0.02371930}, {189,0.02436842}, {190,0.02421930}, {191,0.02522807}, {192,0.02312281}, {193,0.02342105}, {194,0.02338596}, {195,0.02431579}, {196,0.02356140}, {197,0.02450000}, {198,0.02466667}, {199,0.02707018}, {200,0.02678947}, {201,0.02498246}, {202,0.02494737}, {203,0.02579825}, {204,0.02554386}, {205,0.02622807}, {206,0.02615789}, {207,0.02692105}, {208,0.02488596}, {209,0.02611404}, {210,0.02677193}, {211,0.02807895}, {212,0.02851754}, {213,0.03101754}, {214,0.02973684}, {215,0.03049123}, {216,0.02874561}, {217,0.02935088}, {218,0.03047368}, {219,0.03123684}, {220,0.02992982}, {221,0.03154386}, {222,0.03075439}, {223,0.03210526}, {224,0.02837719}, {225,0.03037719}, {226,0.03017544}, {227,0.03110526}, {228,0.03033333}, {229,0.03142982}, {230,0.02914912}, {231,0.03032456}, {232,0.02866667}, {233,0.02937719}, {234,0.02981579}, {235,0.03053509}, {236,0.03034211}, {237,0.03078070}, {238,0.03086842}, {239,0.03792105}, {240,0.03096491}, {241,0.03278947}, {242,0.03042982}, {243,0.03145614}, {244,0.03086842}, {245,0.03159649}, {246,0.03187719}, {247,0.03830702}, {248,0.03292105}, {249,0.03367544}, {250,0.03227193}, {251,0.03308772}, {252,0.03280702}, {253,0.03927193}, {254,0.03507895}, {255,0.03455263}, {256,0.03066667}, {257,0.03177193}, {258,0.03203509}, {259,0.03531579}, {260,0.03398246}, {261,0.03331579}, {262,0.03365789}, {263,0.03432456}, {264,0.03754386}, {265,0.03545614}, {266,0.03402632}, {267,0.03474561}, {268,0.03414035}, {269,0.04103509}, {270,0.03628070}, {271,0.03638596}, {272,0.03350877}, {273,0.03989474}, {274,0.03653509}, {275,0.03588596}, {276,0.03508772}, {277,0.04376316}, {278,0.03731579}, {279,0.03777193}, {280,0.03526316}, {281,0.03869298}, {282,0.03690351}, {283,0.03773684}, {284,0.04366667}, {285,0.03849123}, {286,0.03842105}, {287,0.04453509}, {288,0.03541228}, {289,0.03704386}, {290,0.03796491}, {291,0.03778070}, {292,0.03728070}, {293,0.04331579}, {294,0.03792105}, {295,0.03939474}, {296,0.03781579}, {297,0.03844737}, {298,0.04378947}, {299,0.03966667}, {300,0.03928070}, {301,0.04600877}, {302,0.04006140}, {303,0.04592105}, {304,0.03795614}, {305,0.04406140}, {306,0.04004386}, {307,0.04107895}, {308,0.04442982}, {309,0.04073684}, {310,0.04561404}, {311,0.04233333}, {312,0.04449123}, {313,0.04184211}, {314,0.04646491}, {315,0.04301754}, {316,0.04616667}, {317,0.04342105}, {318,0.04748246}, {319,0.04485088}, {320,0.03944737}, {321,0.04036842}, {322,0.04530702}, {323,0.04181579}, {324,0.04566667}, {325,0.04257018}, {326,0.04721053}, {327,0.04375439}, {328,0.04620175}, {329,0.04278947}, {330,0.04732456}, {331,0.04384211}, {332,0.04285965}, {333,0.04404386}, {334,0.04421930}, {335,0.04992105}, {336,0.04265789}, {337,0.04835088}, {338,0.04359649}, {339,0.04909649}, {340,0.04860526}, {341,0.04547368}, {342,0.04978947}, {343,0.04707895}, {344,0.04456140}, {345,0.05008772}, {346,0.04561404}, {347,0.04717544}, {348,0.04947368}, {349,0.04722807}, {350,0.04742982}, {351,0.05440351}, {352,0.04801754}, {353,0.04494737}, {354,0.05126316}, {355,0.04668421}, {356,0.04533333}, {357,0.05090351}, {358,0.04739474}, {359,0.04900877}, {360,0.04938596}, {361,0.05151754}, {362,0.04713158}, {363,0.05311404}, {364,0.05179825}, {365,0.04885088}, {366,0.04902632}, {367,0.05067544}, {368,0.04983333}, {369,0.05206140}, {370,0.04786842}, {371,0.05009649}, {372,0.05215789}, {373,0.05324561}, {374,0.05692105}, {375,0.05197368}, {376,0.04864035}, {377,0.05061404}, {378,0.05450877}, {379,0.05530702}, {380,0.05388596}, {381,0.05736842}, {382,0.05271930}, {383,0.05450000}, {384,0.04712281}, {385,0.04891228}, {386,0.05417544}, {387,0.05037719}, {388,0.04869298}, {389,0.05084211}, {390,0.05549123}, {391,0.05551754}, {392,0.05722807}, {393,0.05128947}, {394,0.05123684}, {395,0.05650877}, {396,0.05510526}, {397,0.05655263}, {398,0.05700877}, {399,0.06057018}, {400,0.05083333}, {401,0.05244737}, {402,0.05178070}, {403,0.05757895}, {404,0.05564035}, {405,0.05797368}, {406,0.05769298}, {407,0.05929825}, {408,0.05516667}, {409,0.05914912}, {410,0.06185088}, {411,0.06368421}, {412,0.06178070}, {413,0.06467544}, {414,0.06314912}, {415,0.06142105}, {416,0.05476316}, {417,0.05745614}, {418,0.06034211}, {419,0.06280702}, {420,0.06269298}, {421,0.05578947}, {422,0.05543860}, {423,0.06835088}, {424,0.06447368}, {425,0.06494737}, {426,0.06428947}, {427,0.06510526}, {428,0.06007018}, {429,0.06214912}, {430,0.06125439}, {431,0.06315789}, {432,0.05521930}, {433,0.05730702}, {434,0.05765789}, {435,0.05969298}, {436,0.05739474}, {437,0.06684211}, {438,0.06664912}, {439,0.06451754}, {440,0.05749123}, {441,0.05972807}, {442,0.05994737}, {443,0.06934211}, {444,0.06323684}, {445,0.06442982}, {446,0.06148246}, {447,0.07146491}, {448,0.05790351}, {449,0.06174561}, {450,0.06081579}, {451,0.06308772}, {452,0.05872807}, {453,0.05980702}, {454,0.06057895}, {455,0.07268421}, {456,0.06398246}, {457,0.06376316}, {458,0.06388596}, {459,0.06312281}, {460,0.06912281}, {461,0.06970175}, {462,0.06535088}, {463,0.06463158}, {464,0.06650877}, {465,0.06551754}, {466,0.06472807}, {467,0.06360526}, {468,0.06209649}, {469,0.06993860}, {470,0.06590351}, {471,0.06535088}, {472,0.06921053}, {473,0.06632456}, {474,0.06388596}, {475,0.07331579}, {476,0.06627193}, {477,0.06611404}, {478,0.07278070}, {479,0.06781579}, {480,0.06807895}, {481,0.06793860}, {482,0.06291228}, {483,0.06526316}, {484,0.07280702}, {485,0.06835965}, {486,0.06534211}, {487,0.07049123}, {488,0.06392982}, {489,0.07332456}, {490,0.06823684}, {491,0.06782456}, {492,0.06840351}, {493,0.06849123}, {494,0.07628070}, {495,0.07024561}, {496,0.07117544}, {497,0.06684211}, {498,0.07393860}, {499,0.07092982}, {500,0.07470175}, {505,0.07193860}, {510,0.07970175}, {515,0.06814035}, {520,0.07331579}, {525,0.07357018}, {530,0.07723684}, {535,0.07842982}, {540,0.08260526}, {545,0.08182456}, {550,0.07712281}, {555,0.08428947}, {560,0.08152632}, {565,0.08022807}, {570,0.08701754}, {575,0.09189474}, {580,0.08347368}, {585,0.08651754}, {590,0.08925439}, {595,0.08877193}, {600,0.08824561}, {605,0.09347368}, {610,0.08986842}, {615,0.09414912}, {620,0.09266667}, {625,0.09613158}, {630,0.09964912}, {635,0.10034211}, {640,0.08991228}, {645,0.08786842}, {650,0.09598246}, {655,0.10075439}, {660,0.09723684}, {665,0.09399123}, {670,0.10234211}, {675,0.10198246}, {680,0.09835088}, {685,0.10414912}, {690,0.10328947}, {695,0.10794737}, {700,0.11050877}, {705,0.10560526}, {710,0.09851754}, {715,0.10985088}, {720,0.10411404}, {725,0.11066667}, {730,0.11050000}, {735,0.11572807}, {740,0.10828947}, {745,0.11314035}, {750,0.11674561}, {755,0.11749123}, {760,0.11404386}, {765,0.11996491}, {770,0.11311404}, {775,0.11569298}, {780,0.11345614}, {785,0.11576316}, {790,0.11653509}, {795,0.12203509}, {800,0.11374561}, {805,0.11902632}, {810,0.11996491}, {815,0.12774561}, {820,0.12103509}, {825,0.12433333}, {830,0.13238596}, {835,0.12548246}, {840,0.12141228}, {845,0.12820175}, {850,0.12318421}, {855,0.13384211}, {860,0.12968421}, {865,0.12792982}, {870,0.13771053}, {875,0.13542982}, {880,0.12807018}, {885,0.14038596}, {890,0.13777193}, {895,0.15416667}, {900,0.13813158}, {905,0.13310526}, {910,0.14432456}, {915,0.13798246}, {920,0.13378070}, {925,0.14915789}, {930,0.13747368}, {935,0.14785088}, {940,0.14342982}, {945,0.14141228}, {950,0.15475439}, {955,0.15795614}, {960,0.13628947}, {965,0.15099123}, {970,0.15228070}, {975,0.15950000}, {980,0.14956140}, {985,0.15033333}, {990,0.15524561}, {995,0.15756140}, {1000,0.15535965}, {1010,0.16047368}, {1020,0.15759649}, {1030,0.15729825}, {1040,0.15393860}, {1050,0.16818421}, {1060,0.15437719}, {1070,0.16437719}, {1080,0.16093860}, {1090,0.16709649}, {1100,0.16955263}, {1110,0.17496491}, {1120,0.16117544}, {1130,0.18277193}, {1140,0.18058772}, {1150,0.19154386}, {1160,0.16700000}, {1170,0.17911404}, {1180,0.18430702}, {1190,0.18788596}, {1200,0.17607895}, {1210,0.19029825}, {1220,0.18655263}, {1230,0.19755263}, {1240,0.19199123}, {1250,0.19407018}, {1260,0.19950000}, {1270,0.20451754}, {1280,0.18119298}, {1290,0.19054386}, {1300,0.19813158}, {1310,0.20893860}, {1320,0.19835088}, {1330,0.20003509}, {1340,0.21425439}, {1350,0.21333333}, {1360,0.20411404}, {1370,0.22201754}, {1380,0.21289474}, {1390,0.22554386}, {1400,0.21876316}, {1410,0.21160526}, {1420,0.22382456}, {1430,0.22603509}, {1440,0.21615789}, {1450,0.22709649}, {1460,0.22924561}, {1470,0.24210526}, {1480,0.23568421}, {1490,0.23418421}, {1500,0.24079825}, {1510,0.25038596}, {1520,0.23441228}, {1530,0.24782456}, {1540,0.23528070}, {1550,0.23976316}, {1560,0.23541228}, {1570,0.23465789}, {1580,0.24126316}, {1590,0.25791228}, {1600,0.23439474}, {1610,0.24714912}, {1620,0.24780702}, {1630,0.26012281}, {1640,0.24951754}, {1650,0.26325439}, {1660,0.27857018}, {1670,0.26215789}, {1680,0.24781579}, {1690,0.26034211}, {1700,0.25146491}, {1710,0.28293860}, {1720,0.27764035}, {1730,0.26842982}, {1740,0.26968421}, {1750,0.27568421}, {1760,0.26881579}, {1770,0.28744737}, {1780,0.28783333}, {1790,0.30146491}, {1800,0.26307018}, {1810,0.27802632}, {1820,0.28823684}, {1830,0.28233333}, {1840,0.27192982}, {1850,0.29673684}, {1860,0.29607895}, {1870,0.30426316}, {1880,0.29747368}, {1890,0.29455263}, {1900,0.29689474}, {1910,0.32237719}, {1920,0.28715789}, {1930,0.29322807}, {1940,0.29844737}, {1950,0.31680702}, {1960,0.30707018}, {1970,0.31038596}, {1980,0.32028070}, {1990,0.31202632}, {2000,0.31529825}, {2050,0.30718421}, {2100,0.32398246}, {2150,0.33974561}, {2200,0.34611404}, {2250,0.36252632}, {2300,0.37677193}, {2350,0.38110526}, {2400,0.38418421}, {2450,0.38625439}, {2500,0.39442105}, {2550,0.42733333}, {2600,0.40336842}, {2650,0.42799123}, {2700,0.42356140}, {2750,0.47241228}, {2800,0.44842105}, {2850,0.45226316}, {2900,0.47058772}, {2950,0.47007895}, {3000,0.48668421}, {3050,0.50928070}, {3100,0.49135088}, {3150,0.51447368}, {3200,0.48053509}, {3250,0.52728947}, {3300,0.53660526}, {3350,0.54371053}, {3400,0.53376316}, {3450,0.59713158}, {3500,0.57590351}, {3550,0.62391228}, {3600,0.55246491}, {3650,0.57361404}, {3700,0.61414912}, {3750,0.62043860}, {3800,0.63627193}, {3850,0.61810526}, {3900,0.67476316}, {3950,0.68917544}, {4000,0.65240351}, {4050,0.68256140}, {4100,0.64015789}, {4150,0.68678947}, {4200,0.69403509}, {4250,0.70536842}, {4300,0.72750877}, {4350,0.77214912}, {4400,0.71163158}, {4450,0.74375439}, {4500,0.74701754}, {4550,0.76869298}, {4600,0.80196491}, {4650,0.77078947}, {4700,0.80174561}, {4750,0.81501754}, {4800,0.76525439}, {4850,0.84296491}, {4900,0.80170175}, {4950,0.86022807}, {5000,0.82470175}, {5050,0.89834211}, {5100,0.91077193}, {5150,0.89245614}, {5200,0.84447368}, {5250,0.85068421}, {5300,0.90621930}, {5350,0.94014912}, {5400,0.90897368}, {5450,0.92364035}, {5500,0.99135965}, {5550,1.00521053}, {5600,0.95317544}, {5650,0.93824561}, {5700,0.95861404}, {5750,1.04119298}, {5800,0.98162281}, {5850,1.06025439}, {5900,1.00135088}, {5950,1.09625439}, {6000,1.07069298}, {6050,1.081857}, {6100,1.123929}, {6150,1.034929}, {6200,1.070286}, {6250,1.118000}, {6300,1.119571}, {6350,1.151286}, {6400,1.050143}, {6450,1.132071}, {6500,1.141214}, {6550,1.196929}, {6600,1.154000}, {6650,1.275214}, {6700,1.180786}, {6750,1.247357}, {6800,1.174714}, {6850,1.193643}, {6900,1.290143}, {6950,1.250714}, {7000,1.235643}, {7050,1.291429}, {7100,1.359000}, {7150,1.409429}, {7200,1.200357}, {7250,1.268071}, {7300,1.261500}, {7350,1.380786}, {7400,1.353929}, {7450,1.371643}, {7500,1.356357}, {7550,1.500214}, {7600,1.367143}, {7650,1.422857}, {7700,1.344643}, {7750,1.410571}, {7800,1.444429}, {7850,1.451786}, {7900,1.504429}, {7950,1.479429}, {8000,1.361286}, {8050,1.539571}, {8100,1.504786}, {8150,1.609857}, {8200,1.377214}, {8250,1.515857}, {8300,1.521214}, {8350,1.576714}, {8400,1.495429}, {8450,1.438857}, {8500,1.578143}, {8550,1.591571}, {8600,1.588429}, {8650,1.630357}, {8700,1.718357}, {8750,1.632286}, {8800,1.541714}, {8850,1.610286}, {8900,1.624214}, {8950,1.778500}, {9000,1.616000}, {9050,1.746143}, {9100,1.705571}, {9150,1.875286}, {9200,1.769643}, {9250,1.623429}, {9300,1.694857}, {9350,1.689786}, {9400,1.768643}, {9450,1.813000}, {9500,1.747000}, {9550,1.817714}, {9600,1.650286}, {9650,1.845429}, {9700,1.830643}, {9750,1.803571}, {9800,1.745000}, {9850,1.898643}, {9900,1.891357}, {9950,1.977429}, {10000,1.771143}, {10100,1.960357}, {10200,1.941429}, {10300,1.924143}, {10400,1.808000}, {10500,1.843857}, {10600,1.957429}, {10700,2.028357}, {10800,1.942143}, {10900,2.000643}, {11000,2.159929}, {11100,2.180500}, {11200,2.046857}, {11300,2.027714}, {11400,2.034571}, {11500,2.253643}, {11600,2.123071}, {11700,2.275500}, {11800,2.178071}, {11900,2.403857}, {12000,2.250071}, {12100,2.276929}, {12200,2.367643}, {12300,2.183357}, {12400,2.259000}, {12500,2.377500}, {12600,2.379571}, {12700,2.459429}, {12800,2.141143}, {12900,2.404286}, {13000,2.435714}, {13100,2.517643}, {13200,2.452214}, {13300,2.698000}, {13400,2.507000}, {13500,2.663786}, {13600,2.418071}, {13700,2.515643}, {13800,2.687500}, {13900,2.656929}, {14000,2.663857}, {14100,2.660571}, {14200,2.848714}, {14300,2.974214}, {14400,2.486929}, {14500,2.713214}, {14600,2.606429}, {14700,2.923143}, {14800,2.821643}, {14900,3.206929}, {15000,2.855429}, {15100,3.124357}, {15200,3.051929}, {15300,2.983929}, {15400,3.215429}, {15500,2.944714}, {15600,3.089143}, {15700,3.255571}, {15800,3.341857}, {15900,3.106500}, {16000,2.872286}, {16100,3.213786}, {16200,3.139429}, {16300,3.344429}, {16400,2.856214}, {16500,3.195214}, {16600,3.545929}, {16700,3.318500}, {16800,3.128500}, {16900,3.357714}, {17000,3.252571}, {17100,3.411714}, {17200,3.301357}, {17300,3.441929}, {17400,3.618714}, {17500,3.463071}, {17600,3.273143}, {17700,3.538500}, {17800,3.736929}, {17900,3.747643}, {18000,3.431071}, {18100,3.669357}, {18200,3.716714}, {18300,3.922929}, {18400,3.666643}, {18500,3.444500}, {18600,3.744000}, {18700,3.707714}, {18800,3.872000}, {18900,3.905000}, {19000,3.718429}, {19100,3.847429}, {19200,3.552286}, {19300,4.090214}, {19400,3.877071}, {19500,3.849786}, {19600,3.750500}, {19700,4.077286}, {19800,4.020071}, {19900,4.463143}, {20000,3.769786}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["reif"]["user"] = {{1,0.00012281}, {2,0.00057018}, {3,0.00049123}, {4,0.00057895}, {5,0.00054386}, {6,0.00096491}, {7,0.00108772}, {8,0.00085965}, {9,0.00092105}, {10,0.00100000}, {11,0.00121053}, {12,0.00122807}, {13,0.00145614}, {14,0.00221053}, {15,0.00161404}, {16,0.00185965}, {17,0.00204386}, {18,0.00196491}, {19,0.00195614}, {20,0.00221053}, {21,0.00190351}, {22,0.00224561}, {23,0.00243860}, {24,0.00242982}, {25,0.00248246}, {26,0.00275439}, {27,0.00265789}, {28,0.00285088}, {29,0.00310526}, {30,0.00323684}, {31,0.00334211}, {32,0.00330702}, {33,0.00339474}, {34,0.00346491}, {35,0.00460526}, {36,0.00396491}, {37,0.00375439}, {38,0.00415789}, {39,0.00474561}, {40,0.00421930}, {41,0.00472807}, {42,0.00457018}, {43,0.00499123}, {44,0.00458772}, {45,0.00484211}, {46,0.00528947}, {47,0.00500000}, {48,0.00483333}, {49,0.00560526}, {50,0.00575439}, {51,0.00578947}, {52,0.00598246}, {53,0.00615789}, {54,0.00642982}, {55,0.00633333}, {56,0.00758772}, {57,0.00651754}, {58,0.00698246}, {59,0.00716667}, {60,0.00709649}, {61,0.00754386}, {62,0.00741228}, {63,0.00792982}, {64,0.00790351}, {65,0.00775439}, {66,0.00765789}, {67,0.00815789}, {68,0.00778947}, {69,0.00826316}, {70,0.00830702}, {71,0.00992982}, {72,0.00822807}, {73,0.00868421}, {74,0.00864035}, {75,0.00923684}, {76,0.00897368}, {77,0.00924561}, {78,0.00898246}, {79,0.00959649}, {80,0.00930702}, {81,0.00926316}, {82,0.00937719}, {83,0.00969298}, {84,0.00971930}, {85,0.01011404}, {86,0.01172807}, {87,0.01040351}, {88,0.01008772}, {89,0.01045614}, {90,0.01035965}, {91,0.01086842}, {92,0.01086842}, {93,0.01092105}, {94,0.01116667}, {95,0.01159649}, {96,0.01086842}, {97,0.01118421}, {98,0.01161404}, {99,0.01179825}, {100,0.01173684}, {101,0.01366667}, {102,0.01207018}, {103,0.01259649}, {104,0.01195614}, {105,0.01253509}, {106,0.01242105}, {107,0.01335965}, {108,0.01278070}, {109,0.01345614}, {110,0.01322807}, {111,0.01379825}, {112,0.01297368}, {113,0.01317544}, {114,0.01476316}, {115,0.01424561}, {116,0.01521930}, {117,0.01432456}, {118,0.01601754}, {119,0.01511404}, {120,0.01408772}, {121,0.01518421}, {122,0.01491228}, {123,0.01552632}, {124,0.01530702}, {125,0.01567544}, {126,0.01557895}, {127,0.01632456}, {128,0.01500000}, {129,0.01644737}, {130,0.01544737}, {131,0.01608772}, {132,0.01563158}, {133,0.01639474}, {134,0.01616667}, {135,0.01707018}, {136,0.01809649}, {137,0.01664035}, {138,0.01652632}, {139,0.01750000}, {140,0.01691228}, {141,0.01930702}, {142,0.01745614}, {143,0.01816667}, {144,0.01857895}, {145,0.01764912}, {146,0.01763158}, {147,0.01800000}, {148,0.01792982}, {149,0.01956140}, {150,0.01843860}, {151,0.01874561}, {152,0.01792982}, {153,0.01850877}, {154,0.01884211}, {155,0.01935088}, {156,0.01857018}, {157,0.01927193}, {158,0.01960526}, {159,0.02338596}, {160,0.01878070}, {161,0.01907018}, {162,0.01913158}, {163,0.01964035}, {164,0.01937719}, {165,0.02000000}, {166,0.02283333}, {167,0.02035088}, {168,0.01953509}, {169,0.02055263}, {170,0.02294737}, {171,0.02156140}, {172,0.02112281}, {173,0.02172807}, {174,0.02379825}, {175,0.02228070}, {176,0.02058772}, {177,0.02119298}, {178,0.02131579}, {179,0.02469298}, {180,0.02197368}, {181,0.02248246}, {182,0.02278070}, {183,0.02366667}, {184,0.02184211}, {185,0.02486842}, {186,0.02321930}, {187,0.02407895}, {188,0.02368421}, {189,0.02425439}, {190,0.02435088}, {191,0.02540351}, {192,0.02307018}, {193,0.02341228}, {194,0.02314035}, {195,0.02410526}, {196,0.02363158}, {197,0.02457018}, {198,0.02464035}, {199,0.02696491}, {200,0.02679825}, {201,0.02479825}, {202,0.02487719}, {203,0.02574561}, {204,0.02550000}, {205,0.02607895}, {206,0.02622807}, {207,0.02697368}, {208,0.02484211}, {209,0.02614035}, {210,0.02681579}, {211,0.02792105}, {212,0.02820175}, {213,0.03110526}, {214,0.02987719}, {215,0.03076316}, {216,0.02875439}, {217,0.02944737}, {218,0.03062281}, {219,0.03114035}, {220,0.03004386}, {221,0.03167544}, {222,0.03119298}, {223,0.03240351}, {224,0.02811404}, {225,0.03065789}, {226,0.03012281}, {227,0.03124561}, {228,0.03072807}, {229,0.03153509}, {230,0.02897368}, {231,0.03032456}, {232,0.02862281}, {233,0.02978070}, {234,0.03018421}, {235,0.03108772}, {236,0.03043860}, {237,0.03112281}, {238,0.03135088}, {239,0.03788596}, {240,0.03123684}, {241,0.03300000}, {242,0.03023684}, {243,0.03137719}, {244,0.03088596}, {245,0.03207018}, {246,0.03243860}, {247,0.03812281}, {248,0.03336842}, {249,0.03403509}, {250,0.03281579}, {251,0.03311404}, {252,0.03297368}, {253,0.03874561}, {254,0.03541228}, {255,0.03479825}, {256,0.03078947}, {257,0.03222807}, {258,0.03247368}, {259,0.03490351}, {260,0.03376316}, {261,0.03370175}, {262,0.03404386}, {263,0.03409649}, {264,0.03723684}, {265,0.03534211}, {266,0.03435088}, {267,0.03489474}, {268,0.03426316}, {269,0.04105263}, {270,0.03621053}, {271,0.03645614}, {272,0.03393860}, {273,0.03938596}, {274,0.03682456}, {275,0.03581579}, {276,0.03507018}, {277,0.04371053}, {278,0.03690351}, {279,0.03750000}, {280,0.03548246}, {281,0.03828070}, {282,0.03695614}, {283,0.03755263}, {284,0.04366667}, {285,0.03840351}, {286,0.03830702}, {287,0.04436842}, {288,0.03545614}, {289,0.03682456}, {290,0.03739474}, {291,0.03764912}, {292,0.03741228}, {293,0.04324561}, {294,0.03815789}, {295,0.03913158}, {296,0.03771930}, {297,0.03815789}, {298,0.04342982}, {299,0.03952632}, {300,0.03906140}, {301,0.04578070}, {302,0.03983333}, {303,0.04535965}, {304,0.03772807}, {305,0.04401754}, {306,0.03980702}, {307,0.04103509}, {308,0.04395614}, {309,0.04050877}, {310,0.04535088}, {311,0.04254386}, {312,0.04439474}, {313,0.04167544}, {314,0.04622807}, {315,0.04307895}, {316,0.04616667}, {317,0.04356140}, {318,0.04748246}, {319,0.04503509}, {320,0.03924561}, {321,0.03981579}, {322,0.04521053}, {323,0.04147368}, {324,0.04565789}, {325,0.04213158}, {326,0.04742105}, {327,0.04346491}, {328,0.04592105}, {329,0.04280702}, {330,0.04728947}, {331,0.04367544}, {332,0.04287719}, {333,0.04405263}, {334,0.04414035}, {335,0.04951754}, {336,0.04219298}, {337,0.04828947}, {338,0.04349123}, {339,0.04878070}, {340,0.04863158}, {341,0.04528070}, {342,0.04945614}, {343,0.04717544}, {344,0.04456140}, {345,0.04964912}, {346,0.04565789}, {347,0.04708772}, {348,0.04913158}, {349,0.04710526}, {350,0.04724561}, {351,0.05405263}, {352,0.04827193}, {353,0.04470175}, {354,0.05085965}, {355,0.04672807}, {356,0.04510526}, {357,0.05042982}, {358,0.04724561}, {359,0.04892105}, {360,0.04891228}, {361,0.05116667}, {362,0.04731579}, {363,0.05273684}, {364,0.05142105}, {365,0.04892105}, {366,0.04892105}, {367,0.05057018}, {368,0.04951754}, {369,0.05205263}, {370,0.04798246}, {371,0.05006140}, {372,0.05189474}, {373,0.05288596}, {374,0.05707895}, {375,0.05194737}, {376,0.04861404}, {377,0.05076316}, {378,0.05419298}, {379,0.05515789}, {380,0.05356140}, {381,0.05754386}, {382,0.05250877}, {383,0.05413158}, {384,0.04700877}, {385,0.04897368}, {386,0.05379825}, {387,0.04988596}, {388,0.04871053}, {389,0.05076316}, {390,0.05520175}, {391,0.05530702}, {392,0.05710526}, {393,0.05102632}, {394,0.05079825}, {395,0.05636842}, {396,0.05494737}, {397,0.05633333}, {398,0.05712281}, {399,0.06116667}, {400,0.05050000}, {401,0.05205263}, {402,0.05157018}, {403,0.05740351}, {404,0.05575439}, {405,0.05777193}, {406,0.05753509}, {407,0.05935088}, {408,0.05458772}, {409,0.05896491}, {410,0.06179825}, {411,0.06347368}, {412,0.06173684}, {413,0.06472807}, {414,0.06308772}, {415,0.06144737}, {416,0.05472807}, {417,0.05727193}, {418,0.06059649}, {419,0.06299123}, {420,0.06252632}, {421,0.05535965}, {422,0.05555263}, {423,0.06837719}, {424,0.06470175}, {425,0.06498246}, {426,0.06407895}, {427,0.06484211}, {428,0.06019298}, {429,0.06208772}, {430,0.06126316}, {431,0.06336842}, {432,0.05515789}, {433,0.05711404}, {434,0.05745614}, {435,0.05988596}, {436,0.05731579}, {437,0.06658772}, {438,0.06652632}, {439,0.06440351}, {440,0.05763158}, {441,0.05978947}, {442,0.05999123}, {443,0.06922807}, {444,0.06342105}, {445,0.06451754}, {446,0.06137719}, {447,0.07174561}, {448,0.05770175}, {449,0.06188596}, {450,0.06081579}, {451,0.06346491}, {452,0.05867544}, {453,0.05992982}, {454,0.06083333}, {455,0.07269298}, {456,0.06401754}, {457,0.06374561}, {458,0.06400000}, {459,0.06292105}, {460,0.06876316}, {461,0.06954386}, {462,0.06519298}, {463,0.06426316}, {464,0.06600877}, {465,0.06535088}, {466,0.06467544}, {467,0.06353509}, {468,0.06207018}, {469,0.06974561}, {470,0.06595614}, {471,0.06517544}, {472,0.06907018}, {473,0.06599123}, {474,0.06373684}, {475,0.07314035}, {476,0.06607018}, {477,0.06594737}, {478,0.07287719}, {479,0.06757895}, {480,0.06803509}, {481,0.06768421}, {482,0.06307018}, {483,0.06517544}, {484,0.07278947}, {485,0.06814035}, {486,0.06530702}, {487,0.07051754}, {488,0.06392982}, {489,0.07345614}, {490,0.06770175}, {491,0.06755263}, {492,0.06793860}, {493,0.06850877}, {494,0.07604386}, {495,0.07014912}, {496,0.07114912}, {497,0.06648246}, {498,0.07377193}, {499,0.07071930}, {500,0.07452632}, {505,0.07174561}, {510,0.07961404}, {515,0.06750000}, {520,0.07322807}, {525,0.07357018}, {530,0.07682456}, {535,0.07802632}, {540,0.08227193}, {545,0.08153509}, {550,0.07683333}, {555,0.08446491}, {560,0.08121930}, {565,0.08008772}, {570,0.08698246}, {575,0.09152632}, {580,0.08357018}, {585,0.08628947}, {590,0.08909649}, {595,0.08842982}, {600,0.08792105}, {605,0.09307895}, {610,0.08934211}, {615,0.09388596}, {620,0.09207018}, {625,0.09599123}, {630,0.09898246}, {635,0.10007895}, {640,0.08968421}, {645,0.08754386}, {650,0.09588596}, {655,0.10027193}, {660,0.09685965}, {665,0.09363158}, {670,0.10196491}, {675,0.10164912}, {680,0.09830702}, {685,0.10381579}, {690,0.10278947}, {695,0.10810526}, {700,0.11013158}, {705,0.10554386}, {710,0.09827193}, {715,0.10959649}, {720,0.10385965}, {725,0.11042105}, {730,0.10999123}, {735,0.11544737}, {740,0.10797368}, {745,0.11279825}, {750,0.11643860}, {755,0.11683333}, {760,0.11379825}, {765,0.11970175}, {770,0.11262281}, {775,0.11525439}, {780,0.11322807}, {785,0.11566667}, {790,0.11631579}, {795,0.12211404}, {800,0.11340351}, {805,0.11880702}, {810,0.11992982}, {815,0.12763158}, {820,0.12091228}, {825,0.12412281}, {830,0.13242105}, {835,0.12530702}, {840,0.12121053}, {845,0.12838596}, {850,0.12311404}, {855,0.13381579}, {860,0.12977193}, {865,0.12812281}, {870,0.13726316}, {875,0.13543860}, {880,0.12816667}, {885,0.14024561}, {890,0.13787719}, {895,0.15400000}, {900,0.13852632}, {905,0.13264912}, {910,0.14437719}, {915,0.13800000}, {920,0.13366667}, {925,0.14890351}, {930,0.13760526}, {935,0.14755263}, {940,0.14301754}, {945,0.14128070}, {950,0.15459649}, {955,0.15761404}, {960,0.13630702}, {965,0.15090351}, {970,0.15210526}, {975,0.15938596}, {980,0.14921053}, {985,0.15003509}, {990,0.15507895}, {995,0.15745614}, {1000,0.15518421}, {1010,0.16029825}, {1020,0.15730702}, {1030,0.15692105}, {1040,0.15351754}, {1050,0.16750877}, {1060,0.15428070}, {1070,0.16414912}, {1080,0.16046491}, {1090,0.16674561}, {1100,0.16908772}, {1110,0.17463158}, {1120,0.16074561}, {1130,0.18237719}, {1140,0.18024561}, {1150,0.19132456}, {1160,0.16691228}, {1170,0.17862281}, {1180,0.18384211}, {1190,0.18752632}, {1200,0.17564912}, {1210,0.18985965}, {1220,0.18615789}, {1230,0.19728947}, {1240,0.19164035}, {1250,0.19345614}, {1260,0.19905263}, {1270,0.20403509}, {1280,0.18114035}, {1290,0.19007018}, {1300,0.19783333}, {1310,0.20850000}, {1320,0.19767544}, {1330,0.19957018}, {1340,0.21406140}, {1350,0.21289474}, {1360,0.20378947}, {1370,0.22163158}, {1380,0.21238596}, {1390,0.22453509}, {1400,0.21768421}, {1410,0.21056140}, {1420,0.22320175}, {1430,0.22555263}, {1440,0.21564912}, {1450,0.22661404}, {1460,0.22871053}, {1470,0.24156140}, {1480,0.23512281}, {1490,0.23355263}, {1500,0.24022807}, {1510,0.24985088}, {1520,0.23381579}, {1530,0.24739474}, {1540,0.23475439}, {1550,0.23925439}, {1560,0.23468421}, {1570,0.23400877}, {1580,0.24092105}, {1590,0.25731579}, {1600,0.23364035}, {1610,0.24660526}, {1620,0.24733333}, {1630,0.25988596}, {1640,0.24912281}, {1650,0.26291228}, {1660,0.27807895}, {1670,0.26171053}, {1680,0.24738596}, {1690,0.26055263}, {1700,0.25112281}, {1710,0.28258772}, {1720,0.27708772}, {1730,0.26787719}, {1740,0.26927193}, {1750,0.27543860}, {1760,0.26829825}, {1770,0.28730702}, {1780,0.28736842}, {1790,0.30096491}, {1800,0.26278070}, {1810,0.27764035}, {1820,0.28811404}, {1830,0.28200877}, {1840,0.27157895}, {1850,0.29614912}, {1860,0.29566667}, {1870,0.30409649}, {1880,0.29706140}, {1890,0.29426316}, {1900,0.29628070}, {1910,0.32221930}, {1920,0.28687719}, {1930,0.29285965}, {1940,0.29795614}, {1950,0.31635965}, {1960,0.30650877}, {1970,0.30965789}, {1980,0.32005263}, {1990,0.31177193}, {2000,0.31455263}, {2050,0.30681579}, {2100,0.32348246}, {2150,0.33933333}, {2200,0.34531579}, {2250,0.36178070}, {2300,0.37588596}, {2350,0.38035965}, {2400,0.38346491}, {2450,0.38524561}, {2500,0.39381579}, {2550,0.42648246}, {2600,0.40287719}, {2650,0.42690351}, {2700,0.42270175}, {2750,0.47143860}, {2800,0.44769298}, {2850,0.45144737}, {2900,0.46940351}, {2950,0.46914912}, {3000,0.48579825}, {3050,0.50857895}, {3100,0.49022807}, {3150,0.51374561}, {3200,0.47945614}, {3250,0.52637719}, {3300,0.53578947}, {3350,0.54307895}, {3400,0.53290351}, {3450,0.59641228}, {3500,0.57505263}, {3550,0.62305263}, {3600,0.55136842}, {3650,0.57279825}, {3700,0.61307895}, {3750,0.61906140}, {3800,0.63541228}, {3850,0.61692105}, {3900,0.67308772}, {3950,0.68778947}, {4000,0.65110526}, {4050,0.68118421}, {4100,0.63907018}, {4150,0.68517544}, {4200,0.69273684}, {4250,0.70428070}, {4300,0.72661404}, {4350,0.77097368}, {4400,0.71013158}, {4450,0.74243860}, {4500,0.74573684}, {4550,0.76729825}, {4600,0.80039474}, {4650,0.76772807}, {4700,0.80019298}, {4750,0.81371053}, {4800,0.76380702}, {4850,0.84146491}, {4900,0.80027193}, {4950,0.85818421}, {5000,0.82335965}, {5050,0.89692982}, {5100,0.90914912}, {5150,0.89077193}, {5200,0.84265789}, {5250,0.84928070}, {5300,0.90428947}, {5350,0.93804386}, {5400,0.90699123}, {5450,0.92167544}, {5500,0.98933333}, {5550,1.00336842}, {5600,0.94950877}, {5650,0.93625439}, {5700,0.95675439}, {5750,1.03952632}, {5800,0.98014912}, {5850,1.05841228}, {5900,0.99954386}, {5950,1.09420175}, {6000,1.06904386}, {6050,1.075857}, {6100,1.119143}, {6150,1.031857}, {6200,1.069429}, {6250,1.116000}, {6300,1.117929}, {6350,1.149571}, {6400,1.048714}, {6450,1.129786}, {6500,1.139571}, {6550,1.194857}, {6600,1.152714}, {6650,1.275143}, {6700,1.179929}, {6750,1.246143}, {6800,1.173643}, {6850,1.192143}, {6900,1.289214}, {6950,1.248714}, {7000,1.233429}, {7050,1.288786}, {7100,1.356714}, {7150,1.407500}, {7200,1.198929}, {7250,1.266071}, {7300,1.259857}, {7350,1.378143}, {7400,1.352286}, {7450,1.369929}, {7500,1.353929}, {7550,1.498214}, {7600,1.365143}, {7650,1.421000}, {7700,1.343071}, {7750,1.408643}, {7800,1.442714}, {7850,1.450143}, {7900,1.503000}, {7950,1.477071}, {8000,1.359071}, {8050,1.536714}, {8100,1.502929}, {8150,1.606500}, {8200,1.375143}, {8250,1.514286}, {8300,1.519214}, {8350,1.574143}, {8400,1.493429}, {8450,1.436143}, {8500,1.575286}, {8550,1.588143}, {8600,1.585286}, {8650,1.627429}, {8700,1.714643}, {8750,1.628714}, {8800,1.538429}, {8850,1.607071}, {8900,1.622000}, {8950,1.774643}, {9000,1.613357}, {9050,1.743214}, {9100,1.702071}, {9150,1.872571}, {9200,1.766571}, {9250,1.620857}, {9300,1.690929}, {9350,1.687714}, {9400,1.766071}, {9450,1.810714}, {9500,1.745000}, {9550,1.815286}, {9600,1.648000}, {9650,1.841071}, {9700,1.827857}, {9750,1.801214}, {9800,1.742286}, {9850,1.895929}, {9900,1.887786}, {9950,1.973500}, {10000,1.768429}, {10100,1.958500}, {10200,1.938000}, {10300,1.921000}, {10400,1.804357}, {10500,1.841286}, {10600,1.954286}, {10700,2.025714}, {10800,1.938786}, {10900,1.997500}, {11000,2.156357}, {11100,2.176929}, {11200,2.042500}, {11300,2.023857}, {11400,2.031643}, {11500,2.250786}, {11600,2.121214}, {11700,2.273000}, {11800,2.175571}, {11900,2.400929}, {12000,2.246786}, {12100,2.272786}, {12200,2.364071}, {12300,2.180214}, {12400,2.255571}, {12500,2.374500}, {12600,2.376214}, {12700,2.455429}, {12800,2.137500}, {12900,2.401429}, {13000,2.432714}, {13100,2.513143}, {13200,2.449786}, {13300,2.694429}, {13400,2.504429}, {13500,2.660643}, {13600,2.415214}, {13700,2.511714}, {13800,2.682071}, {13900,2.652214}, {14000,2.659714}, {14100,2.657571}, {14200,2.844929}, {14300,2.969929}, {14400,2.484714}, {14500,2.709929}, {14600,2.602143}, {14700,2.919214}, {14800,2.817429}, {14900,3.202500}, {15000,2.852571}, {15100,3.120143}, {15200,3.047786}, {15300,2.980643}, {15400,3.210071}, {15500,2.940857}, {15600,3.084357}, {15700,3.251571}, {15800,3.336214}, {15900,3.101143}, {16000,2.867857}, {16100,3.206214}, {16200,3.133786}, {16300,3.340000}, {16400,2.851429}, {16500,3.189929}, {16600,3.538500}, {16700,3.313000}, {16800,3.123429}, {16900,3.352786}, {17000,3.247929}, {17100,3.405429}, {17200,3.296143}, {17300,3.437214}, {17400,3.611786}, {17500,3.456786}, {17600,3.267143}, {17700,3.531714}, {17800,3.728714}, {17900,3.739643}, {18000,3.422500}, {18100,3.660143}, {18200,3.709714}, {18300,3.912786}, {18400,3.658714}, {18500,3.437643}, {18600,3.735500}, {18700,3.699357}, {18800,3.863429}, {18900,3.893286}, {19000,3.711500}, {19100,3.840071}, {19200,3.544357}, {19300,4.080214}, {19400,3.869429}, {19500,3.842143}, {19600,3.742286}, {19700,4.068071}, {19800,4.012500}, {19900,4.453929}, {20000,3.761857}};
data["big_flat"]["TypeClassesBodyFlatPHOAS"]["reif"]["system"] = {{1,0.00013158}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00007018}, {6,0.00003509}, {7,0.00000000}, {8,0.00007018}, {9,0.00000000}, {10,0.00000000}, {11,0.00003509}, {12,0.00003509}, {13,0.00007018}, {14,0.00003509}, {15,0.00000000}, {16,0.00003509}, {17,0.00010526}, {18,0.00009649}, {19,0.00000000}, {20,0.00000000}, {21,0.00003509}, {22,0.00003509}, {23,0.00007018}, {24,0.00003509}, {25,0.00007018}, {26,0.00000000}, {27,0.00000000}, {28,0.00006140}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00007018}, {34,0.00003509}, {35,0.00007018}, {36,0.00000000}, {37,0.00003509}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00003509}, {43,0.00003509}, {44,0.00000000}, {45,0.00003509}, {46,0.00000000}, {47,0.00003509}, {48,0.00005263}, {49,0.00003509}, {50,0.00003509}, {51,0.00007018}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00007018}, {56,0.00002632}, {57,0.00000000}, {58,0.00002632}, {59,0.00009649}, {60,0.00003509}, {61,0.00000000}, {62,0.00002632}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00003509}, {69,0.00003509}, {70,0.00003509}, {71,0.00007018}, {72,0.00006140}, {73,0.00000000}, {74,0.00006140}, {75,0.00000000}, {76,0.00006140}, {77,0.00002632}, {78,0.00003509}, {79,0.00006140}, {80,0.00000000}, {81,0.00003509}, {82,0.00003509}, {83,0.00003509}, {84,0.00000000}, {85,0.00000000}, {86,0.00009649}, {87,0.00003509}, {88,0.00003509}, {89,0.00000000}, {90,0.00003509}, {91,0.00003509}, {92,0.00003509}, {93,0.00000000}, {94,0.00000000}, {95,0.00007018}, {96,0.00003509}, {97,0.00000000}, {98,0.00002632}, {99,0.00000000}, {100,0.00002632}, {101,0.00003509}, {102,0.00003509}, {103,0.00003509}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00003509}, {108,0.00000000}, {109,0.00003509}, {110,0.00002632}, {111,0.00002632}, {112,0.00000000}, {113,0.00007018}, {114,0.00005263}, {115,0.00003509}, {116,0.00007018}, {117,0.00000000}, {118,0.00002632}, {119,0.00007018}, {120,0.00012281}, {121,0.00003509}, {122,0.00000000}, {123,0.00003509}, {124,0.00006140}, {125,0.00000000}, {126,0.00003509}, {127,0.00003509}, {128,0.00003509}, {129,0.00003509}, {130,0.00000000}, {131,0.00005263}, {132,0.00007018}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00003509}, {137,0.00002632}, {138,0.00000000}, {139,0.00002632}, {140,0.00003509}, {141,0.00014035}, {142,0.00000000}, {143,0.00000000}, {144,0.00007018}, {145,0.00002632}, {146,0.00006140}, {147,0.00000000}, {148,0.00003509}, {149,0.00005263}, {150,0.00000000}, {151,0.00003509}, {152,0.00000000}, {153,0.00003509}, {154,0.00003509}, {155,0.00003509}, {156,0.00010526}, {157,0.00010526}, {158,0.00000000}, {159,0.00007018}, {160,0.00000000}, {161,0.00000000}, {162,0.00007018}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00010526}, {167,0.00003509}, {168,0.00002632}, {169,0.00000000}, {170,0.00013158}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00003509}, {176,0.00007018}, {177,0.00000000}, {178,0.00002632}, {179,0.00007018}, {180,0.00003509}, {181,0.00000000}, {182,0.00000000}, {183,0.00006140}, {184,0.00000000}, {185,0.00016667}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00010526}, {190,0.00007018}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00003509}, {196,0.00003509}, {197,0.00002632}, {198,0.00000000}, {199,0.00010526}, {200,0.00002632}, {201,0.00003509}, {202,0.00000000}, {203,0.00009649}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00003509}, {208,0.00002632}, {209,0.00000000}, {210,0.00007018}, {211,0.00007018}, {212,0.00016667}, {213,0.00006140}, {214,0.00013158}, {215,0.00010526}, {216,0.00012281}, {217,0.00009649}, {218,0.00009649}, {219,0.00007018}, {220,0.00007018}, {221,0.00014035}, {222,0.00012281}, {223,0.00009649}, {224,0.00007018}, {225,0.00017544}, {226,0.00007018}, {227,0.00010526}, {228,0.00010526}, {229,0.00013158}, {230,0.00002632}, {231,0.00000000}, {232,0.00003509}, {233,0.00007018}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00003509}, {238,0.00000000}, {239,0.00000000}, {240,0.00003509}, {241,0.00003509}, {242,0.00000000}, {243,0.00000000}, {244,0.00003509}, {245,0.00007018}, {246,0.00002632}, {247,0.00028070}, {248,0.00003509}, {249,0.00003509}, {250,0.00000000}, {251,0.00003509}, {252,0.00000000}, {253,0.00023684}, {254,0.00009649}, {255,0.00002632}, {256,0.00000000}, {257,0.00003509}, {258,0.00000000}, {259,0.00014035}, {260,0.00010526}, {261,0.00000000}, {262,0.00003509}, {263,0.00006140}, {264,0.00024561}, {265,0.00010526}, {266,0.00000000}, {267,0.00003509}, {268,0.00000000}, {269,0.00020175}, {270,0.00009649}, {271,0.00000000}, {272,0.00000000}, {273,0.00034211}, {274,0.00003509}, {275,0.00003509}, {276,0.00006140}, {277,0.00038596}, {278,0.00010526}, {279,0.00003509}, {280,0.00003509}, {281,0.00003509}, {282,0.00002632}, {283,0.00010526}, {284,0.00033333}, {285,0.00000000}, {286,0.00003509}, {287,0.00025439}, {288,0.00003509}, {289,0.00007018}, {290,0.00020175}, {291,0.00003509}, {292,0.00007018}, {293,0.00024561}, {294,0.00000000}, {295,0.00003509}, {296,0.00000000}, {297,0.00000000}, {298,0.00042105}, {299,0.00007018}, {300,0.00010526}, {301,0.00033333}, {302,0.00000000}, {303,0.00028070}, {304,0.00000000}, {305,0.00016667}, {306,0.00000000}, {307,0.00000000}, {308,0.00033333}, {309,0.00000000}, {310,0.00021053}, {311,0.00003509}, {312,0.00028070}, {313,0.00014035}, {314,0.00037719}, {315,0.00000000}, {316,0.00000000}, {317,0.00003509}, {318,0.00000000}, {319,0.00000000}, {320,0.00003509}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00003509}, {328,0.00003509}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00003509}, {336,0.00003509}, {337,0.00003509}, {338,0.00000000}, {339,0.00007018}, {340,0.00000000}, {341,0.00007018}, {342,0.00003509}, {343,0.00003509}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00002632}, {350,0.00003509}, {351,0.00003509}, {352,0.00000000}, {353,0.00003509}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00003509}, {359,0.00002632}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00003509}, {364,0.00000000}, {365,0.00003509}, {366,0.00007018}, {367,0.00003509}, {368,0.00007018}, {369,0.00000000}, {370,0.00003509}, {371,0.00003509}, {372,0.00003509}, {373,0.00003509}, {374,0.00003509}, {375,0.00000000}, {376,0.00002632}, {377,0.00000000}, {378,0.00000000}, {379,0.00002632}, {380,0.00007018}, {381,0.00000000}, {382,0.00003509}, {383,0.00007018}, {384,0.00003509}, {385,0.00000000}, {386,0.00002632}, {387,0.00003509}, {388,0.00003509}, {389,0.00000000}, {390,0.00000000}, {391,0.00003509}, {392,0.00000000}, {393,0.00003509}, {394,0.00000000}, {395,0.00003509}, {396,0.00007018}, {397,0.00003509}, {398,0.00003509}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00007018}, {403,0.00000000}, {404,0.00003509}, {405,0.00000000}, {406,0.00027193}, {407,0.00014035}, {408,0.00009649}, {409,0.00014035}, {410,0.00014035}, {411,0.00020175}, {412,0.00000000}, {413,0.00017544}, {414,0.00017544}, {415,0.00014035}, {416,0.00003509}, {417,0.00021053}, {418,0.00010526}, {419,0.00000000}, {420,0.00010526}, {421,0.00010526}, {422,0.00000000}, {423,0.00010526}, {424,0.00003509}, {425,0.00003509}, {426,0.00014035}, {427,0.00007018}, {428,0.00003509}, {429,0.00000000}, {430,0.00007018}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00002632}, {436,0.00007018}, {437,0.00017544}, {438,0.00009649}, {439,0.00013158}, {440,0.00000000}, {441,0.00000000}, {442,0.00003509}, {443,0.00014035}, {444,0.00003509}, {445,0.00007018}, {446,0.00003509}, {447,0.00000000}, {448,0.00003509}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00003509}, {453,0.00002632}, {454,0.00003509}, {455,0.00000000}, {456,0.00003509}, {457,0.00000000}, {458,0.00000000}, {459,0.00003509}, {460,0.00006140}, {461,0.00002632}, {462,0.00000000}, {463,0.00007018}, {464,0.00007018}, {465,0.00003509}, {466,0.00000000}, {467,0.00000000}, {468,0.00006140}, {469,0.00000000}, {470,0.00003509}, {471,0.00000000}, {472,0.00007018}, {473,0.00003509}, {474,0.00003509}, {475,0.00003509}, {476,0.00007018}, {477,0.00003509}, {478,0.00000000}, {479,0.00003509}, {480,0.00000000}, {481,0.00003509}, {482,0.00003509}, {483,0.00003509}, {484,0.00006140}, {485,0.00000000}, {486,0.00000000}, {487,0.00010526}, {488,0.00000000}, {489,0.00003509}, {490,0.00007018}, {491,0.00003509}, {492,0.00003509}, {493,0.00000000}, {494,0.00000000}, {495,0.00003509}, {496,0.00003509}, {497,0.00000000}, {498,0.00009649}, {499,0.00003509}, {500,0.00003509}, {505,0.00003509}, {510,0.00000000}, {515,0.00003509}, {520,0.00006140}, {525,0.00003509}, {530,0.00003509}, {535,0.00000000}, {540,0.00002632}, {545,0.00000000}, {550,0.00007018}, {555,0.00003509}, {560,0.00007018}, {565,0.00003509}, {570,0.00000000}, {575,0.00000000}, {580,0.00003509}, {585,0.00003509}, {590,0.00000000}, {595,0.00003509}, {600,0.00007018}, {605,0.00006140}, {610,0.00007018}, {615,0.00007018}, {620,0.00003509}, {625,0.00017544}, {630,0.00000000}, {635,0.00010526}, {640,0.00007018}, {645,0.00006140}, {650,0.00007018}, {655,0.00000000}, {660,0.00007018}, {665,0.00003509}, {670,0.00000000}, {675,0.00003509}, {680,0.00007018}, {685,0.00007018}, {690,0.00000000}, {695,0.00000000}, {700,0.00008772}, {705,0.00000000}, {710,0.00003509}, {715,0.00006140}, {720,0.00000000}, {725,0.00000000}, {730,0.00003509}, {735,0.00000000}, {740,0.00010526}, {745,0.00006140}, {750,0.00003509}, {755,0.00003509}, {760,0.00000000}, {765,0.00007018}, {770,0.00007018}, {775,0.00002632}, {780,0.00000000}, {785,0.00000000}, {790,0.00007018}, {795,0.00000000}, {800,0.00000000}, {805,0.00007018}, {810,0.00007018}, {815,0.00000000}, {820,0.00007018}, {825,0.00002632}, {830,0.00003509}, {835,0.00003509}, {840,0.00007018}, {845,0.00000000}, {850,0.00007018}, {855,0.00003509}, {860,0.00003509}, {865,0.00007018}, {870,0.00003509}, {875,0.00003509}, {880,0.00002632}, {885,0.00007018}, {890,0.00000000}, {895,0.00000000}, {900,0.00005263}, {905,0.00003509}, {910,0.00006140}, {915,0.00000000}, {920,0.00007018}, {925,0.00007018}, {930,0.00000000}, {935,0.00000000}, {940,0.00007018}, {945,0.00003509}, {950,0.00007018}, {955,0.00003509}, {960,0.00008772}, {965,0.00014035}, {970,0.00007018}, {975,0.00014035}, {980,0.00006140}, {985,0.00007018}, {990,0.00002632}, {995,0.00000000}, {1000,0.00007018}, {1010,0.00003509}, {1020,0.00007018}, {1030,0.00010526}, {1040,0.00003509}, {1050,0.00021053}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00006140}, {1090,0.00000000}, {1100,0.00003509}, {1110,0.00003509}, {1120,0.00003509}, {1130,0.00017544}, {1140,0.00003509}, {1150,0.00000000}, {1160,0.00003509}, {1170,0.00000000}, {1180,0.00002632}, {1190,0.00006140}, {1200,0.00010526}, {1210,0.00000000}, {1220,0.00003509}, {1230,0.00000000}, {1240,0.00006140}, {1250,0.00006140}, {1260,0.00003509}, {1270,0.00003509}, {1280,0.00000000}, {1290,0.00007018}, {1300,0.00003509}, {1310,0.00017544}, {1320,0.00000000}, {1330,0.00010526}, {1340,0.00000000}, {1350,0.00003509}, {1360,0.00003509}, {1370,0.00010526}, {1380,0.00000000}, {1390,0.00043860}, {1400,0.00058772}, {1410,0.00069298}, {1420,0.00007018}, {1430,0.00000000}, {1440,0.00007018}, {1450,0.00007018}, {1460,0.00007018}, {1470,0.00007018}, {1480,0.00003509}, {1490,0.00002632}, {1500,0.00009649}, {1510,0.00007018}, {1520,0.00007018}, {1530,0.00000000}, {1540,0.00010526}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00010526}, {1580,0.00000000}, {1590,0.00007018}, {1600,0.00006140}, {1610,0.00007018}, {1620,0.00003509}, {1630,0.00000000}, {1640,0.00003509}, {1650,0.00010526}, {1660,0.00007018}, {1670,0.00003509}, {1680,0.00007018}, {1690,0.00000000}, {1700,0.00003509}, {1710,0.00003509}, {1720,0.00003509}, {1730,0.00007018}, {1740,0.00000000}, {1750,0.00003509}, {1760,0.00014035}, {1770,0.00003509}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00007018}, {1810,0.00009649}, {1820,0.00000000}, {1830,0.00003509}, {1840,0.00003509}, {1850,0.00014035}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00003509}, {1890,0.00010526}, {1900,0.00010526}, {1910,0.00003509}, {1920,0.00007018}, {1930,0.00007018}, {1940,0.00003509}, {1950,0.00006140}, {1960,0.00014035}, {1970,0.00010526}, {1980,0.00002632}, {1990,0.00006140}, {2000,0.00003509}, {2050,0.00000000}, {2100,0.00010526}, {2150,0.00017544}, {2200,0.00007018}, {2250,0.00010526}, {2300,0.00007018}, {2350,0.00007018}, {2400,0.00010526}, {2450,0.00000000}, {2500,0.00007018}, {2550,0.00010526}, {2600,0.00003509}, {2650,0.00003509}, {2700,0.00003509}, {2750,0.00003509}, {2800,0.00009649}, {2850,0.00003509}, {2900,0.00014035}, {2950,0.00007018}, {3000,0.00014035}, {3050,0.00014035}, {3100,0.00013158}, {3150,0.00007018}, {3200,0.00028070}, {3250,0.00006140}, {3300,0.00003509}, {3350,0.00000000}, {3400,0.00003509}, {3450,0.00007018}, {3500,0.00000000}, {3550,0.00007018}, {3600,0.00033333}, {3650,0.00014035}, {3700,0.00015789}, {3750,0.00007018}, {3800,0.00010526}, {3850,0.00007018}, {3900,0.00014035}, {3950,0.00024561}, {4000,0.00010526}, {4050,0.00014035}, {4100,0.00007018}, {4150,0.00050877}, {4200,0.00010526}, {4250,0.00014035}, {4300,0.00003509}, {4350,0.00010526}, {4400,0.00010526}, {4450,0.00009649}, {4500,0.00007018}, {4550,0.00014035}, {4600,0.00014035}, {4650,0.00164035}, {4700,0.00014035}, {4750,0.00007018}, {4800,0.00010526}, {4850,0.00009649}, {4900,0.00003509}, {4950,0.00028070}, {5000,0.00007018}, {5050,0.00009649}, {5100,0.00014035}, {5150,0.00007018}, {5200,0.00021053}, {5250,0.00007018}, {5300,0.00016667}, {5350,0.00037719}, {5400,0.00021053}, {5450,0.00010526}, {5500,0.00023684}, {5550,0.00038596}, {5600,0.00175439}, {5650,0.00021053}, {5700,0.00010526}, {5750,0.00014035}, {5800,0.00007018}, {5850,0.00016667}, {5900,0.00007018}, {5950,0.00024561}, {6000,0.00003509}, {6050,0.004429}, {6100,0.002786}, {6150,0.002143}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000286}, {6400,0.000000}, {6450,0.000286}, {6500,0.000286}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000286}, {6950,0.000000}, {7000,0.000000}, {7050,0.000286}, {7100,0.000571}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000571}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000286}, {7600,0.000000}, {7650,0.000214}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000286}, {8050,0.000000}, {8100,0.000000}, {8150,0.000286}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000571}, {8500,0.000000}, {8550,0.000286}, {8600,0.000286}, {8650,0.000214}, {8700,0.000571}, {8750,0.000000}, {8800,0.000000}, {8850,0.000286}, {8900,0.000571}, {8950,0.000571}, {9000,0.000000}, {9050,0.000286}, {9100,0.000000}, {9150,0.000000}, {9200,0.000286}, {9250,0.000000}, {9300,0.000286}, {9350,0.000000}, {9400,0.000286}, {9450,0.000286}, {9500,0.000286}, {9550,0.000000}, {9600,0.000000}, {9650,0.000286}, {9700,0.000286}, {9750,0.000000}, {9800,0.000500}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000571}, {10300,0.000286}, {10400,0.000857}, {10500,0.000000}, {10600,0.000286}, {10700,0.000286}, {10800,0.000571}, {10900,0.000000}, {11000,0.000286}, {11100,0.000286}, {11200,0.000286}, {11300,0.000571}, {11400,0.000000}, {11500,0.000286}, {11600,0.000571}, {11700,0.000000}, {11800,0.000286}, {11900,0.000286}, {12000,0.000000}, {12100,0.000286}, {12200,0.000857}, {12300,0.000000}, {12400,0.000286}, {12500,0.000000}, {12600,0.000000}, {12700,0.000286}, {12800,0.000286}, {12900,0.000000}, {13000,0.000286}, {13100,0.001071}, {13200,0.000286}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000571}, {13800,0.002000}, {13900,0.002000}, {14000,0.000786}, {14100,0.000000}, {14200,0.000000}, {14300,0.001429}, {14400,0.000000}, {14500,0.000286}, {14600,0.001429}, {14700,0.000571}, {14800,0.000857}, {14900,0.000571}, {15000,0.000000}, {15100,0.001143}, {15200,0.000286}, {15300,0.000000}, {15400,0.001429}, {15500,0.000000}, {15600,0.000571}, {15700,0.000571}, {15800,0.000857}, {15900,0.000571}, {16000,0.000286}, {16100,0.003143}, {16200,0.000000}, {16300,0.000000}, {16400,0.000286}, {16500,0.000857}, {16600,0.002857}, {16700,0.000857}, {16800,0.000286}, {16900,0.000857}, {17000,0.000000}, {17100,0.001143}, {17200,0.000857}, {17300,0.000000}, {17400,0.000286}, {17500,0.000286}, {17600,0.000286}, {17700,0.000571}, {17800,0.001643}, {17900,0.000786}, {18000,0.002571}, {18100,0.002286}, {18200,0.000286}, {18300,0.003429}, {18400,0.001857}, {18500,0.001143}, {18600,0.001429}, {18700,0.001143}, {18800,0.001143}, {18900,0.002786}, {19000,0.001429}, {19100,0.000000}, {19200,0.000571}, {19300,0.000286}, {19400,0.000286}, {19500,0.000571}, {19600,0.001143}, {19700,0.000857}, {19800,0.000857}, {19900,0.001143}, {20000,0.000571}};
data["big_flat"]["TypeClassesBodyHOAS"]["Aggregate"]["real"] = {{1,0.00108772}, {2,0.00100000}, {3,0.00100000}, {4,0.00100000}, {5,0.00100000}, {6,0.00100000}, {7,0.00100000}, {8,0.00100000}, {9,0.00100000}, {10,0.00100877}, {11,0.00117544}, {12,0.00141228}, {13,0.00200000}, {14,0.00212281}, {15,0.00200000}, {16,0.00200000}, {17,0.00200000}, {18,0.01484211}, {19,0.00200000}, {20,0.00200000}, {21,0.00217544}, {22,0.00235965}, {23,0.00301754}, {24,0.00299123}, {25,0.00300000}, {26,0.00300000}, {27,0.00300000}, {28,0.00300877}, {29,0.00313158}, {30,0.00333333}, {31,0.00357018}, {32,0.00346491}, {33,0.00389474}, {34,0.00400000}, {35,0.00409649}, {36,0.00400000}, {37,0.00402632}, {38,0.00414035}, {39,0.00450877}, {40,0.00438596}, {41,0.00461404}, {42,0.00587719}, {43,0.00500877}, {44,0.00500000}, {45,0.00501754}, {46,0.00509649}, {47,0.00541228}, {48,0.00518421}, {49,0.00549123}, {50,0.00552632}, {51,0.00590351}, {52,0.00578070}, {53,0.00600877}, {54,0.00601754}, {55,0.00651754}, {56,0.00603509}, {57,0.00646491}, {58,0.00726316}, {59,0.00682456}, {60,0.00664035}, {61,0.00700000}, {62,0.00705263}, {63,0.00747368}, {64,0.00696491}, {65,0.00730702}, {66,0.00744737}, {67,0.00756140}, {68,0.00749123}, {69,0.00783333}, {70,0.00929825}, {71,0.00835965}, {72,0.00790351}, {73,0.00839474}, {74,0.00853509}, {75,0.00868421}, {76,0.00858772}, {77,0.00884211}, {78,0.00897368}, {79,0.00954386}, {80,0.00860526}, {81,0.00952632}, {82,0.00928070}, {83,0.00951754}, {84,0.00955263}, {85,0.00964912}, {86,0.00974561}, {87,0.01042105}, {88,0.00957018}, {89,0.01037719}, {90,0.01129825}, {91,0.01051754}, {92,0.01045614}, {93,0.01071930}, {94,0.01111404}, {95,0.01148246}, {96,0.01060526}, {97,0.01071053}, {98,0.01274561}, {99,0.01145614}, {100,0.01114035}, {101,0.01150877}, {102,0.01153509}, {103,0.01219298}, {104,0.01153509}, {105,0.01207018}, {106,0.01344737}, {107,0.01242105}, {108,0.01232456}, {109,0.01250000}, {110,0.01265789}, {111,0.01319298}, {112,0.01234211}, {113,0.01414035}, {114,0.01250000}, {115,0.01335088}, {116,0.01301754}, {117,0.01345614}, {118,0.01352632}, {119,0.01428070}, {120,0.01512281}, {121,0.01386842}, {122,0.01412281}, {123,0.01450877}, {124,0.01432456}, {125,0.01488596}, {126,0.01480702}, {127,0.01607018}, {128,0.01378070}, {129,0.01452632}, {130,0.01455263}, {131,0.01526316}, {132,0.01499123}, {133,0.01718421}, {134,0.01526316}, {135,0.01583333}, {136,0.01531579}, {137,0.01558772}, {138,0.01573684}, {139,0.01763158}, {140,0.01618421}, {141,0.01652632}, {142,0.01659649}, {143,0.01729825}, {144,0.01821930}, {145,0.01644737}, {146,0.01642982}, {147,0.01721053}, {148,0.01679825}, {149,0.01750000}, {150,0.01850877}, {151,0.01819298}, {152,0.01745614}, {153,0.01789474}, {154,0.01798246}, {155,0.02057895}, {156,0.01795614}, {157,0.01868421}, {158,0.01876316}, {159,0.01946491}, {160,0.01891228}, {161,0.01839474}, {162,0.01848246}, {163,0.01903509}, {164,0.01861404}, {165,0.02072807}, {166,0.01919298}, {167,0.01989474}, {168,0.01899123}, {169,0.01975439}, {170,0.02080702}, {171,0.02050000}, {172,0.01995614}, {173,0.02084211}, {174,0.02366667}, {175,0.02121053}, {176,0.01966667}, {177,0.02045614}, {178,0.02057018}, {179,0.02218421}, {180,0.02087719}, {181,0.02157018}, {182,0.02161404}, {183,0.02484211}, {184,0.02092105}, {185,0.02221053}, {186,0.02210526}, {187,0.02550877}, {188,0.02179825}, {189,0.02276316}, {190,0.02292105}, {191,0.02625439}, {192,0.02098246}, {193,0.02191228}, {194,0.02206140}, {195,0.02542105}, {196,0.02192105}, {197,0.02309649}, {198,0.02309649}, {199,0.02632456}, {200,0.02230702}, {201,0.02321053}, {202,0.02355263}, {203,0.02694737}, {204,0.02346491}, {205,0.02431579}, {206,0.02456140}, {207,0.02736842}, {208,0.02349123}, {209,0.02422807}, {210,0.02436842}, {211,0.02702632}, {212,0.02431579}, {213,0.02571930}, {214,0.02558772}, {215,0.02772807}, {216,0.02484211}, {217,0.02626316}, {218,0.02963158}, {219,0.02644737}, {220,0.02627193}, {221,0.02692105}, {222,0.02812281}, {223,0.02814912}, {224,0.02504386}, {225,0.02921930}, {226,0.02574561}, {227,0.02725439}, {228,0.02628070}, {229,0.02829825}, {230,0.02755263}, {231,0.02828070}, {232,0.02980702}, {233,0.02775439}, {234,0.02758772}, {235,0.03128070}, {236,0.02755263}, {237,0.02857018}, {238,0.02913158}, {239,0.03083333}, {240,0.02781579}, {241,0.02874561}, {242,0.03190351}, {243,0.02982456}, {244,0.02878947}, {245,0.03312281}, {246,0.02965789}, {247,0.03123684}, {248,0.03186842}, {249,0.03004386}, {250,0.02993860}, {251,0.03429825}, {252,0.02995614}, {253,0.03170175}, {254,0.03446491}, {255,0.03267544}, {256,0.02874561}, {257,0.03289474}, {258,0.02945614}, {259,0.03125439}, {260,0.03230702}, {261,0.03105263}, {262,0.03101754}, {263,0.03497368}, {264,0.03002632}, {265,0.03177193}, {266,0.03436842}, {267,0.03271930}, {268,0.03142982}, {269,0.03521930}, {270,0.03297368}, {271,0.03373684}, {272,0.03357895}, {273,0.03187719}, {274,0.03224561}, {275,0.03576316}, {276,0.03235088}, {277,0.03391228}, {278,0.03604386}, {279,0.03461404}, {280,0.03301754}, {281,0.03567544}, {282,0.03395614}, {283,0.04054386}, {284,0.03362281}, {285,0.03549123}, {286,0.03768421}, {287,0.03648246}, {288,0.03263158}, {289,0.03574561}, {290,0.03432456}, {291,0.03985965}, {292,0.03373684}, {293,0.03572807}, {294,0.03839474}, {295,0.03644737}, {296,0.03471053}, {297,0.03787719}, {298,0.03648246}, {299,0.04195614}, {300,0.03521053}, {301,0.03707895}, {302,0.03957895}, {303,0.03925439}, {304,0.03967544}, {305,0.03613158}, {306,0.03673684}, {307,0.04000000}, {308,0.03703509}, {309,0.04305263}, {310,0.03809649}, {311,0.03938596}, {312,0.03914035}, {313,0.03868421}, {314,0.04316667}, {315,0.03952632}, {316,0.03890351}, {317,0.04164035}, {318,0.04038596}, {319,0.04600000}, {320,0.03617544}, {321,0.04202632}, {322,0.03811404}, {323,0.03918421}, {324,0.03973684}, {325,0.03948246}, {326,0.04354386}, {327,0.04023684}, {328,0.03831579}, {329,0.04123684}, {330,0.03999123}, {331,0.04545614}, {332,0.03963158}, {333,0.04578070}, {334,0.04102632}, {335,0.04257018}, {336,0.03971930}, {337,0.04062281}, {338,0.04515789}, {339,0.04179825}, {340,0.04464912}, {341,0.04159649}, {342,0.04594737}, {343,0.04293860}, {344,0.04078947}, {345,0.04359649}, {346,0.04278947}, {347,0.04854386}, {348,0.04298246}, {349,0.04829825}, {350,0.04385965}, {351,0.04913158}, {352,0.04092105}, {353,0.04628070}, {354,0.04192105}, {355,0.04388596}, {356,0.04328947}, {357,0.04442982}, {358,0.04533333}, {359,0.04572807}, {360,0.04676316}, {361,0.04453509}, {362,0.04824561}, {363,0.04552632}, {364,0.04814035}, {365,0.04638596}, {366,0.04992105}, {367,0.04710526}, {368,0.04664035}, {369,0.04530702}, {370,0.04926316}, {371,0.04641228}, {372,0.04863158}, {373,0.04696491}, {374,0.05017544}, {375,0.04779825}, {376,0.04941228}, {377,0.04678947}, {378,0.05077193}, {379,0.04875439}, {380,0.05078947}, {381,0.04893860}, {382,0.05232456}, {383,0.05121930}, {384,0.04667544}, {385,0.04516667}, {386,0.04853509}, {387,0.04733333}, {388,0.04890351}, {389,0.04682456}, {390,0.05014912}, {391,0.04891228}, {392,0.04910526}, {393,0.04748246}, {394,0.05232456}, {395,0.04958772}, {396,0.05058772}, {397,0.04951754}, {398,0.05243860}, {399,0.05137719}, {400,0.04946491}, {401,0.04804386}, {402,0.05204386}, {403,0.05021930}, {404,0.05211404}, {405,0.05007895}, {406,0.05385965}, {407,0.05932456}, {408,0.04845614}, {409,0.05414912}, {410,0.05081579}, {411,0.05530702}, {412,0.05092982}, {413,0.05562281}, {414,0.05274561}, {415,0.05707895}, {416,0.04830702}, {417,0.05300877}, {418,0.05454386}, {419,0.05157018}, {420,0.05464035}, {421,0.05146491}, {422,0.05627193}, {423,0.05423684}, {424,0.05369298}, {425,0.05291228}, {426,0.05528070}, {427,0.06222807}, {428,0.05260526}, {429,0.05746491}, {430,0.05450000}, {431,0.05997368}, {432,0.05147368}, {433,0.05683333}, {434,0.06128070}, {435,0.05443860}, {436,0.05671930}, {437,0.05550000}, {438,0.05792982}, {439,0.05687719}, {440,0.05644737}, {441,0.06000877}, {442,0.05570175}, {443,0.06068421}, {444,0.05599123}, {445,0.06086842}, {446,0.06619298}, {447,0.06015789}, {448,0.05527193}, {449,0.05375439}, {450,0.05678947}, {451,0.06330702}, {452,0.05352632}, {453,0.05918421}, {454,0.05706140}, {455,0.06057018}, {456,0.06171930}, {457,0.05573684}, {458,0.06018421}, {459,0.05784211}, {460,0.05955263}, {461,0.06636842}, {462,0.05819298}, {463,0.06362281}, {464,0.05571053}, {465,0.06028070}, {466,0.06481579}, {467,0.05869298}, {468,0.06000000}, {469,0.06660526}, {470,0.05891228}, {471,0.06428070}, {472,0.05789474}, {473,0.06196491}, {474,0.06787719}, {475,0.06182456}, {476,0.06244737}, {477,0.06948246}, {478,0.06168421}, {479,0.06681579}, {480,0.06414912}, {481,0.05890351}, {482,0.06200877}, {483,0.06941228}, {484,0.05900877}, {485,0.06459649}, {486,0.06153509}, {487,0.06548246}, {488,0.06706140}, {489,0.06152632}, {490,0.06377193}, {491,0.07159649}, {492,0.06188596}, {493,0.06599123}, {494,0.07140351}, {495,0.06614035}, {496,0.06192982}, {497,0.07046491}, {498,0.06206140}, {499,0.06678947}, {500,0.07050877}, {505,0.06480702}, {510,0.06949123}, {515,0.06625439}, {520,0.06260526}, {525,0.06644737}, {530,0.06724561}, {535,0.07790351}, {540,0.06778070}, {545,0.06872807}, {550,0.07686842}, {555,0.07958772}, {560,0.06818421}, {565,0.07554386}, {570,0.08078947}, {575,0.08554386}, {580,0.07044737}, {585,0.07556140}, {590,0.08341228}, {595,0.08375439}, {600,0.08164035}, {605,0.08001754}, {610,0.07735088}, {615,0.08830702}, {620,0.08578947}, {625,0.08607018}, {630,0.08883333}, {635,0.09242105}, {640,0.07528947}, {645,0.08218421}, {650,0.08771930}, {655,0.09434211}, {660,0.08886842}, {665,0.09260526}, {670,0.09635965}, {675,0.09426316}, {680,0.08437719}, {685,0.09119298}, {690,0.08935088}, {695,0.10191228}, {700,0.10178947}, {705,0.09685088}, {710,0.09950000}, {715,0.10264035}, {720,0.09675439}, {725,0.10373684}, {730,0.10438596}, {735,0.11068421}, {740,0.10256140}, {745,0.10533333}, {750,0.10795614}, {755,0.10917544}, {760,0.10617544}, {765,0.12213158}, {770,0.10052632}, {775,0.10780702}, {780,0.10436842}, {785,0.10557895}, {790,0.10901754}, {795,0.11246491}, {800,0.10445614}, {805,0.11053509}, {810,0.11123684}, {815,0.11900877}, {820,0.11296491}, {825,0.12526316}, {830,0.12097368}, {835,0.11444737}, {840,0.11164912}, {845,0.11885965}, {850,0.11642982}, {855,0.13261404}, {860,0.12103509}, {865,0.11733333}, {870,0.12247368}, {875,0.12618421}, {880,0.12804386}, {885,0.12714912}, {890,0.12682456}, {895,0.13664912}, {900,0.12485965}, {905,0.12352632}, {910,0.12676316}, {915,0.12765789}, {920,0.13107895}, {925,0.13189474}, {930,0.12503509}, {935,0.13412281}, {940,0.13768421}, {945,0.13082456}, {950,0.13603509}, {955,0.14785965}, {960,0.12518421}, {965,0.13374561}, {970,0.14128070}, {975,0.14256140}, {980,0.16685965}, {985,0.14013158}, {990,0.14325439}, {995,0.14807895}, {1000,0.13770175}, {1010,0.14974561}, {1020,0.14748246}, {1030,0.13902632}, {1040,0.14457895}, {1050,0.14508772}, {1060,0.14923684}, {1070,0.15034211}, {1080,0.15478070}, {1090,0.14507018}, {1100,0.15685088}, {1110,0.15695614}, {1120,0.15691228}, {1130,0.15842105}, {1140,0.16623684}, {1150,0.17769298}, {1160,0.15442982}, {1170,0.16662281}, {1180,0.16580702}, {1190,0.17361404}, {1200,0.16940351}, {1210,0.17342982}, {1220,0.17245614}, {1230,0.18234211}, {1240,0.17959649}, {1250,0.17295614}, {1260,0.18595614}, {1270,0.19131579}, {1280,0.18311404}, {1290,0.25642105}, {1300,0.18325439}, {1310,0.19571053}, {1320,0.18479825}, {1330,0.87942105}, {1340,0.19950000}, {1350,0.19638596}, {1360,0.18493860}, {1370,0.20509649}, {1380,0.19843860}, {1390,0.20856140}, {1400,0.20419298}, {1410,0.19571930}, {1420,0.20155263}, {1430,0.20965789}, {1440,0.19879825}, {1450,0.21089474}, {1460,0.21322807}, {1470,0.23302632}, {1480,0.21075439}, {1490,0.21754386}, {1500,0.22177193}, {1510,0.22382456}, {1520,0.21777193}, {1530,0.24081579}, {1540,0.21110526}, {1550,0.22167544}, {1560,0.21616667}, {1570,0.21798246}, {1580,0.22619298}, {1590,0.24012281}, {1600,0.21795614}, {1610,0.22839474}, {1620,0.22872807}, {1630,0.25021930}, {1640,0.23186842}, {1650,0.24098246}, {1660,0.25421930}, {1670,0.23708772}, {1680,0.23165789}, {1690,0.25427193}, {1700,0.23770175}, {1710,0.26131579}, {1720,0.24814035}, {1730,0.24939474}, {1740,0.25197368}, {1750,0.26522807}, {1760,0.24720175}, {1770,0.26741228}, {1780,0.26637719}, {1790,0.28923684}, {1800,0.25721930}, {1810,0.25436842}, {1820,0.26899123}, {1830,0.26362281}, {1840,0.26428947}, {1850,0.28232456}, {1860,0.25994737}, {1870,0.28351754}, {1880,0.27779825}, {1890,0.27303509}, {1900,0.28349123}, {1910,0.29132456}, {1920,0.26656140}, {1930,0.27603509}, {1940,0.28134211}, {1950,0.29914035}, {1960,0.28464912}, {1970,0.29325439}, {1980,0.30077193}, {1990,0.29547368}, {2000,0.28242105}, {2050,0.28630702}, {2100,0.30524561}, {2150,0.31915789}, {2200,0.31931579}, {2250,0.34081579}, {2300,0.35733333}, {2350,0.36257895}, {2400,0.34286842}, {2450,0.36666667}, {2500,0.36577193}, {2550,0.40757018}, {2600,0.37909649}, {2650,0.40398246}, {2700,0.39816667}, {2750,0.44066667}, {2800,0.42522807}, {2850,0.42188596}, {2900,0.44780702}, {2950,0.44389474}, {3000,0.46061404}, {3050,0.47675439}, {3100,0.46734211}, {3150,0.48033333}, {3200,0.45456140}, {3250,0.49792105}, {3300,0.50578070}, {3350,0.51199123}, {3400,0.49599123}, {3450,0.55321053}, {3500,0.54336842}, {3550,0.58276316}, {3600,0.51871053}, {3650,0.53864912}, {3700,0.57764035}, {3750,0.58687719}, {3800,0.58928070}, {3850,0.59355263}, {3900,0.62213158}, {3950,0.65181579}, {4000,0.66479825}, {4050,0.64408772}, {4100,0.59405263}, {4150,0.64830702}, {4200,0.64791228}, {4250,0.68655263}, {4300,0.67955263}, {4350,0.74235088}, {4400,0.66801754}, {4450,0.69316667}, {4500,0.70538596}, {4550,0.72833333}, {4600,0.75591228}, {4650,0.72559649}, {4700,0.75300877}, {4750,0.77891228}, {4800,0.73363158}, {4850,0.80791228}, {4900,0.78083333}, {4950,0.81642105}, {5000,0.77905263}, {5050,0.85587719}, {5100,0.86471930}, {5150,0.83504386}, {5200,0.80249123}, {5250,0.79626316}, {5300,0.85841228}, {5350,0.88849123}, {5400,0.84215789}, {5450,0.87229825}, {5500,0.93192982}, {5550,0.94599123}, {5600,0.90155263}, {5650,0.88002632}, {5700,0.91005263}, {5750,0.98097368}, {5800,0.92564912}, {5850,1.00725439}, {5900,0.94366667}, {5950,1.03833333}, {6000,0.99701754}, {6050,1.020857}, {6100,1.046286}, {6150,0.980214}, {6200,1.017286}, {6250,1.037857}, {6300,1.053071}, {6350,1.087071}, {6400,0.969786}, {6450,1.078786}, {6500,1.084929}, {6550,1.126000}, {6600,1.100429}, {6650,1.197571}, {6700,1.105643}, {6750,1.175214}, {6800,1.079714}, {6850,1.143643}, {6900,1.205000}, {6950,1.179857}, {7000,1.185500}, {7050,1.194357}, {7100,1.280857}, {7150,1.314714}, {7200,1.116500}, {7250,1.199643}, {7300,1.152857}, {7350,1.301143}, {7400,1.267571}, {7450,1.252429}, {7500,1.256000}, {7550,1.409214}, {7600,1.293286}, {7650,1.307429}, {7700,1.276643}, {7750,1.294500}, {7800,1.366643}, {7850,1.347000}, {7900,1.407714}, {7950,1.369357}, {8000,1.302143}, {8050,1.436071}, {8100,1.383000}, {8150,1.508857}, {8200,1.273071}, {8250,1.404071}, {8300,1.716071}, {8350,1.456714}, {8400,1.389000}, {8450,1.348857}, {8500,1.437286}, {8550,1.500071}, {8600,1.482643}, {8650,1.522429}, {8700,1.658143}, {8750,1.546857}, {8800,1.463714}, {8850,1.500143}, {8900,1.516500}, {8950,1.670000}, {9000,1.519000}, {9050,1.615143}, {9100,1.582000}, {9150,1.777857}, {9200,1.649643}, {9250,1.513000}, {9300,1.571429}, {9350,1.571571}, {9400,1.631571}, {9450,1.695143}, {9500,1.652214}, {9550,1.701786}, {9600,1.582500}, {9650,1.724286}, {9700,1.735929}, {9750,1.723857}, {9800,1.657857}, {9850,1.811429}, {9900,1.750857}, {9950,1.868786}, {10000,1.672500}, {10100,1.839857}, {10200,1.866071}, {10300,1.811071}, {10400,1.718786}, {10500,1.700857}, {10600,1.837714}, {10700,1.928571}, {10800,1.842786}, {10900,1.876929}, {11000,2.065286}, {11100,2.031000}, {11200,1.921857}, {11300,1.890286}, {11400,1.921714}, {11500,2.127214}, {11600,2.009929}, {11700,2.162571}, {11800,2.049786}, {11900,2.294929}, {12000,2.127000}, {12100,2.142214}, {12200,2.246571}, {12300,2.065000}, {12400,2.129643}, {12500,2.217000}, {12600,2.247786}, {12700,2.309429}, {12800,2.053500}, {12900,2.281500}, {13000,2.301500}, {13100,2.373643}, {13200,2.283500}, {13300,2.591643}, {13400,2.358714}, {13500,2.531429}, {13600,2.299000}, {13700,2.408143}, {13800,2.619357}, {13900,2.526929}, {14000,2.499500}, {14100,2.543286}, {14200,2.717714}, {14300,2.806857}, {14400,2.378929}, {14500,2.589143}, {14600,2.521571}, {14700,2.782500}, {14800,2.734286}, {14900,2.718786}, {15000,2.735857}, {15100,3.000929}, {15200,2.768929}, {15300,2.835214}, {15400,2.694000}, {15500,2.808857}, {15600,2.925357}, {15700,2.958500}, {15800,3.052000}, {15900,2.966143}, {16000,2.770500}, {16100,3.053000}, {16200,2.965643}, {16300,3.179000}, {16400,2.707571}, {16500,3.078000}, {16600,3.052857}, {16700,3.111786}, {16800,2.965500}, {16900,2.879000}, {17000,3.084071}, {17100,3.190143}, {17200,3.122929}, {17300,3.206643}, {17400,3.479143}, {17500,3.314071}, {17600,3.120000}, {17700,3.178214}, {17800,3.237143}, {17900,3.581143}, {18000,3.285857}, {18100,3.498143}, {18200,3.411643}, {18300,3.734786}, {18400,3.530357}, {18500,3.278143}, {18600,3.330786}, {18700,3.313857}, {18800,3.464429}, {18900,3.602429}, {19000,3.519571}, {19100,3.733714}, {19200,3.369357}, {19300,3.721714}, {19400,3.721857}, {19500,3.700857}, {19600,3.541500}, {19700,3.929357}, {19800,3.780786}, {19900,4.022714}, {20000,3.620143}};
data["big_flat"]["TypeClassesBodyHOAS"]["Aggregate"]["user"] = {{1,0.00085088}, {2,0.00100000}, {3,0.00088596}, {4,0.00104386}, {5,0.00122807}, {6,0.00125439}, {7,0.00134211}, {8,0.00121930}, {9,0.00164912}, {10,0.00153509}, {11,0.00172807}, {12,0.00190351}, {13,0.00181579}, {14,0.00221053}, {15,0.00192982}, {16,0.00198246}, {17,0.00246491}, {18,0.01480702}, {19,0.00252632}, {20,0.00255263}, {21,0.00254386}, {22,0.00257018}, {23,0.00291228}, {24,0.00293860}, {25,0.00287719}, {26,0.00289474}, {27,0.00330702}, {28,0.00327193}, {29,0.00339474}, {30,0.00346491}, {31,0.00365789}, {32,0.00367544}, {33,0.00383333}, {34,0.00390351}, {35,0.00435965}, {36,0.00395614}, {37,0.00392982}, {38,0.00447368}, {39,0.00431579}, {40,0.00451754}, {41,0.00476316}, {42,0.00579825}, {43,0.00476316}, {44,0.00474561}, {45,0.00501754}, {46,0.00521930}, {47,0.00546491}, {48,0.00534211}, {49,0.00539474}, {50,0.00569298}, {51,0.00571053}, {52,0.00579825}, {53,0.00587719}, {54,0.00599123}, {55,0.00634211}, {56,0.00570175}, {57,0.00617544}, {58,0.00723684}, {59,0.00664035}, {60,0.00640351}, {61,0.00687719}, {62,0.00692982}, {63,0.00714912}, {64,0.00686842}, {65,0.00714912}, {66,0.00729825}, {67,0.00771930}, {68,0.00720175}, {69,0.00772807}, {70,0.00915789}, {71,0.00815789}, {72,0.00769298}, {73,0.00821053}, {74,0.00821053}, {75,0.00878070}, {76,0.00864912}, {77,0.00907018}, {78,0.00894737}, {79,0.00984211}, {80,0.00850877}, {81,0.00953509}, {82,0.00942105}, {83,0.00962281}, {84,0.00957018}, {85,0.01007018}, {86,0.00988596}, {87,0.01027193}, {88,0.00978947}, {89,0.01064912}, {90,0.01138596}, {91,0.01089474}, {92,0.01053509}, {93,0.01111404}, {94,0.01151754}, {95,0.01173684}, {96,0.01084211}, {97,0.01121930}, {98,0.01317544}, {99,0.01166667}, {100,0.01135965}, {101,0.01193860}, {102,0.01233333}, {103,0.01235965}, {104,0.01183333}, {105,0.01264035}, {106,0.01362281}, {107,0.01273684}, {108,0.01262281}, {109,0.01295614}, {110,0.01300877}, {111,0.01341228}, {112,0.01227193}, {113,0.01425439}, {114,0.01349123}, {115,0.01313158}, {116,0.01333333}, {117,0.01385965}, {118,0.01380702}, {119,0.01423684}, {120,0.01534211}, {121,0.01413158}, {122,0.01387719}, {123,0.01481579}, {124,0.01455263}, {125,0.01511404}, {126,0.01491228}, {127,0.01627193}, {128,0.01428947}, {129,0.01457895}, {130,0.01478070}, {131,0.01543860}, {132,0.01535088}, {133,0.01717544}, {134,0.01541228}, {135,0.01596491}, {136,0.01537719}, {137,0.01569298}, {138,0.01591228}, {139,0.01747368}, {140,0.01628070}, {141,0.01647368}, {142,0.01667544}, {143,0.01744737}, {144,0.01803509}, {145,0.01632456}, {146,0.01659649}, {147,0.01730702}, {148,0.01678070}, {149,0.01746491}, {150,0.01840351}, {151,0.01800877}, {152,0.01737719}, {153,0.01766667}, {154,0.01786842}, {155,0.02053509}, {156,0.01771930}, {157,0.01853509}, {158,0.01850877}, {159,0.01914912}, {160,0.01864912}, {161,0.01813158}, {162,0.01824561}, {163,0.01888596}, {164,0.01847368}, {165,0.02040351}, {166,0.01904386}, {167,0.01976316}, {168,0.01865789}, {169,0.01958772}, {170,0.02073684}, {171,0.02068421}, {172,0.01945614}, {173,0.02085088}, {174,0.02394737}, {175,0.02122807}, {176,0.01958772}, {177,0.02016667}, {178,0.02045614}, {179,0.02289474}, {180,0.02051754}, {181,0.02165789}, {182,0.02161404}, {183,0.02529825}, {184,0.02072807}, {185,0.02242982}, {186,0.02200877}, {187,0.02582456}, {188,0.02198246}, {189,0.02290351}, {190,0.02307895}, {191,0.02646491}, {192,0.02101754}, {193,0.02176316}, {194,0.02221053}, {195,0.02591228}, {196,0.02200000}, {197,0.02321053}, {198,0.02348246}, {199,0.02662281}, {200,0.02239474}, {201,0.02365789}, {202,0.02370175}, {203,0.02686842}, {204,0.02362281}, {205,0.02473684}, {206,0.02495614}, {207,0.02726316}, {208,0.02381579}, {209,0.02432456}, {210,0.02481579}, {211,0.02704386}, {212,0.02460526}, {213,0.02612281}, {214,0.02582456}, {215,0.02782456}, {216,0.02517544}, {217,0.02660526}, {218,0.02957018}, {219,0.02629825}, {220,0.02670175}, {221,0.02707018}, {222,0.02797368}, {223,0.02817544}, {224,0.02534211}, {225,0.02914035}, {226,0.02592105}, {227,0.02724561}, {228,0.02641228}, {229,0.02812281}, {230,0.02770175}, {231,0.02813158}, {232,0.02971053}, {233,0.02746491}, {234,0.02750000}, {235,0.03107895}, {236,0.02739474}, {237,0.02843860}, {238,0.02902632}, {239,0.03057018}, {240,0.02776316}, {241,0.02874561}, {242,0.03185088}, {243,0.02970175}, {244,0.02862281}, {245,0.03318421}, {246,0.02973684}, {247,0.03109649}, {248,0.03163158}, {249,0.03006140}, {250,0.02971053}, {251,0.03435965}, {252,0.03007895}, {253,0.03121053}, {254,0.03431579}, {255,0.03265789}, {256,0.02841228}, {257,0.03281579}, {258,0.02948246}, {259,0.03104386}, {260,0.03230702}, {261,0.03093860}, {262,0.03085088}, {263,0.03500000}, {264,0.03000877}, {265,0.03157018}, {266,0.03451754}, {267,0.03257895}, {268,0.03154386}, {269,0.03556140}, {270,0.03265789}, {271,0.03385088}, {272,0.03350877}, {273,0.03181579}, {274,0.03215789}, {275,0.03595614}, {276,0.03218421}, {277,0.03385965}, {278,0.03623684}, {279,0.03482456}, {280,0.03271053}, {281,0.03584211}, {282,0.03427193}, {283,0.04077193}, {284,0.03359649}, {285,0.03558772}, {286,0.03775439}, {287,0.03675439}, {288,0.03251754}, {289,0.03600000}, {290,0.03442982}, {291,0.03971053}, {292,0.03400877}, {293,0.03553509}, {294,0.03836842}, {295,0.03661404}, {296,0.03482456}, {297,0.03808772}, {298,0.03692105}, {299,0.04171930}, {300,0.03516667}, {301,0.03711404}, {302,0.03948246}, {303,0.03958772}, {304,0.03969298}, {305,0.03659649}, {306,0.03701754}, {307,0.04014035}, {308,0.03737719}, {309,0.04302632}, {310,0.03811404}, {311,0.03935965}, {312,0.03914912}, {313,0.03878947}, {314,0.04314912}, {315,0.03960526}, {316,0.03900000}, {317,0.04157895}, {318,0.04066667}, {319,0.04589474}, {320,0.03656140}, {321,0.04185965}, {322,0.03809649}, {323,0.03916667}, {324,0.03954386}, {325,0.03953509}, {326,0.04313158}, {327,0.04035965}, {328,0.03842105}, {329,0.04081579}, {330,0.03977193}, {331,0.04525439}, {332,0.03974561}, {333,0.04557895}, {334,0.04094737}, {335,0.04221930}, {336,0.03962281}, {337,0.04058772}, {338,0.04526316}, {339,0.04158772}, {340,0.04456140}, {341,0.04155263}, {342,0.04575439}, {343,0.04257895}, {344,0.04063158}, {345,0.04338596}, {346,0.04241228}, {347,0.04882456}, {348,0.04247368}, {349,0.04872807}, {350,0.04362281}, {351,0.04920175}, {352,0.04090351}, {353,0.04616667}, {354,0.04184211}, {355,0.04371053}, {356,0.04307895}, {357,0.04431579}, {358,0.04530702}, {359,0.04561404}, {360,0.04650877}, {361,0.04450877}, {362,0.04852632}, {363,0.04543860}, {364,0.04828947}, {365,0.04652632}, {366,0.04978947}, {367,0.04758772}, {368,0.04700000}, {369,0.04538596}, {370,0.04964035}, {371,0.04657895}, {372,0.04896491}, {373,0.04696491}, {374,0.05028070}, {375,0.04802632}, {376,0.04929825}, {377,0.04687719}, {378,0.05053509}, {379,0.04898246}, {380,0.05080702}, {381,0.04899123}, {382,0.05214035}, {383,0.05128070}, {384,0.04685088}, {385,0.04500877}, {386,0.04880702}, {387,0.04732456}, {388,0.04907895}, {389,0.04725439}, {390,0.05001754}, {391,0.04901754}, {392,0.04933333}, {393,0.04728947}, {394,0.05212281}, {395,0.04955263}, {396,0.05054386}, {397,0.04946491}, {398,0.05243860}, {399,0.05124561}, {400,0.04951754}, {401,0.04821930}, {402,0.05181579}, {403,0.05027193}, {404,0.05207018}, {405,0.05029825}, {406,0.05400000}, {407,0.05943860}, {408,0.04861404}, {409,0.05379825}, {410,0.05071930}, {411,0.05516667}, {412,0.05071930}, {413,0.05518421}, {414,0.05258772}, {415,0.05718421}, {416,0.04849123}, {417,0.05293860}, {418,0.05408772}, {419,0.05177193}, {420,0.05419298}, {421,0.05135088}, {422,0.05613158}, {423,0.05428947}, {424,0.05345614}, {425,0.05256140}, {426,0.05539474}, {427,0.06200000}, {428,0.05263158}, {429,0.05740351}, {430,0.05424561}, {431,0.05987719}, {432,0.05157018}, {433,0.05671053}, {434,0.06126316}, {435,0.05407018}, {436,0.05645614}, {437,0.05534211}, {438,0.05771053}, {439,0.05665789}, {440,0.05634211}, {441,0.05978947}, {442,0.05532456}, {443,0.06085965}, {444,0.05550877}, {445,0.06051754}, {446,0.06573684}, {447,0.06036842}, {448,0.05503509}, {449,0.05375439}, {450,0.05671053}, {451,0.06266667}, {452,0.05347368}, {453,0.05896491}, {454,0.05676316}, {455,0.06047368}, {456,0.06116667}, {457,0.05557018}, {458,0.06000000}, {459,0.05783333}, {460,0.05951754}, {461,0.06573684}, {462,0.05818421}, {463,0.06370175}, {464,0.05564035}, {465,0.06002632}, {466,0.06421053}, {467,0.05891228}, {468,0.06006140}, {469,0.06633333}, {470,0.05900000}, {471,0.06384211}, {472,0.05788596}, {473,0.06179825}, {474,0.06739474}, {475,0.06201754}, {476,0.06251754}, {477,0.06924561}, {478,0.06169298}, {479,0.06623684}, {480,0.06375439}, {481,0.05882456}, {482,0.06209649}, {483,0.06926316}, {484,0.05885965}, {485,0.06424561}, {486,0.06157895}, {487,0.06552632}, {488,0.06686842}, {489,0.06161404}, {490,0.06390351}, {491,0.07134211}, {492,0.06180702}, {493,0.06583333}, {494,0.07118421}, {495,0.06601754}, {496,0.06190351}, {497,0.07001754}, {498,0.06202632}, {499,0.06651754}, {500,0.06991228}, {505,0.06473684}, {510,0.06950877}, {515,0.06584211}, {520,0.06237719}, {525,0.06632456}, {530,0.06657895}, {535,0.07735088}, {540,0.06766667}, {545,0.06839474}, {550,0.07622807}, {555,0.07900000}, {560,0.06792105}, {565,0.07534211}, {570,0.08028070}, {575,0.08500877}, {580,0.07065789}, {585,0.07529825}, {590,0.08343860}, {595,0.08353509}, {600,0.08116667}, {605,0.07966667}, {610,0.07677193}, {615,0.08812281}, {620,0.08541228}, {625,0.08584211}, {630,0.08836842}, {635,0.09218421}, {640,0.07512281}, {645,0.08201754}, {650,0.08751754}, {655,0.09387719}, {660,0.08835088}, {665,0.09224561}, {670,0.09583333}, {675,0.09392982}, {680,0.08446491}, {685,0.09115789}, {690,0.08925439}, {695,0.10143860}, {700,0.10132456}, {705,0.09615789}, {710,0.09890351}, {715,0.10195614}, {720,0.09618421}, {725,0.10332456}, {730,0.10379825}, {735,0.11009649}, {740,0.10192982}, {745,0.10435965}, {750,0.10742982}, {755,0.10857018}, {760,0.10511404}, {765,0.12057018}, {770,0.09957895}, {775,0.10685088}, {780,0.10357895}, {785,0.10462281}, {790,0.10821053}, {795,0.11160526}, {800,0.10310526}, {805,0.10978947}, {810,0.11056140}, {815,0.11826316}, {820,0.11219298}, {825,0.12403509}, {830,0.12011404}, {835,0.11350877}, {840,0.11047368}, {845,0.11818421}, {850,0.11544737}, {855,0.13104386}, {860,0.12023684}, {865,0.11676316}, {870,0.12173684}, {875,0.12526316}, {880,0.12667544}, {885,0.12605263}, {890,0.12603509}, {895,0.13596491}, {900,0.12369298}, {905,0.12278947}, {910,0.12617544}, {915,0.12679825}, {920,0.12998246}, {925,0.13080702}, {930,0.12443860}, {935,0.13342105}, {940,0.13628947}, {945,0.13036842}, {950,0.13537719}, {955,0.14677193}, {960,0.12469298}, {965,0.13338596}, {970,0.14011404}, {975,0.14168421}, {980,0.16592105}, {985,0.13928070}, {990,0.14240351}, {995,0.14672807}, {1000,0.13739474}, {1010,0.14891228}, {1020,0.14641228}, {1030,0.13814035}, {1040,0.14326316}, {1050,0.14414035}, {1060,0.14782456}, {1070,0.14949123}, {1080,0.15392982}, {1090,0.14400877}, {1100,0.15550877}, {1110,0.15656140}, {1120,0.15576316}, {1130,0.15787719}, {1140,0.16506140}, {1150,0.17645614}, {1160,0.15371053}, {1170,0.16537719}, {1180,0.16518421}, {1190,0.17327193}, {1200,0.16928947}, {1210,0.17316667}, {1220,0.17235965}, {1230,0.18187719}, {1240,0.17918421}, {1250,0.17257895}, {1260,0.18567544}, {1270,0.19078947}, {1280,0.18256140}, {1290,0.25586842}, {1300,0.18279825}, {1310,0.19511404}, {1320,0.18414912}, {1330,0.87700877}, {1340,0.19949123}, {1350,0.19589474}, {1360,0.18450000}, {1370,0.20462281}, {1380,0.19798246}, {1390,0.20840351}, {1400,0.20416667}, {1410,0.19551754}, {1420,0.20134211}, {1430,0.20915789}, {1440,0.19829825}, {1450,0.21032456}, {1460,0.21231579}, {1470,0.23264035}, {1480,0.21006140}, {1490,0.21700877}, {1500,0.22100000}, {1510,0.22333333}, {1520,0.21725439}, {1530,0.24041228}, {1540,0.21073684}, {1550,0.22110526}, {1560,0.21587719}, {1570,0.21748246}, {1580,0.22545614}, {1590,0.23944737}, {1600,0.21759649}, {1610,0.22774561}, {1620,0.22813158}, {1630,0.24989474}, {1640,0.23143860}, {1650,0.24033333}, {1660,0.25361404}, {1670,0.23668421}, {1680,0.23123684}, {1690,0.25399123}, {1700,0.23737719}, {1710,0.26079825}, {1720,0.24728947}, {1730,0.24907018}, {1740,0.25125439}, {1750,0.26453509}, {1760,0.24680702}, {1770,0.26699123}, {1780,0.26599123}, {1790,0.28866667}, {1800,0.25653509}, {1810,0.25409649}, {1820,0.26857895}, {1830,0.26330702}, {1840,0.26370175}, {1850,0.28171053}, {1860,0.25924561}, {1870,0.28334211}, {1880,0.27735965}, {1890,0.27280702}, {1900,0.28278070}, {1910,0.29080702}, {1920,0.26560526}, {1930,0.27534211}, {1940,0.28077193}, {1950,0.29844737}, {1960,0.28404386}, {1970,0.29271053}, {1980,0.30007018}, {1990,0.29517544}, {2000,0.28192105}, {2050,0.28544737}, {2100,0.30415789}, {2150,0.31741228}, {2200,0.31801754}, {2250,0.33994737}, {2300,0.35627193}, {2350,0.36157018}, {2400,0.34193860}, {2450,0.36556140}, {2500,0.36484211}, {2550,0.40629825}, {2600,0.37788596}, {2650,0.40288596}, {2700,0.39701754}, {2750,0.43950877}, {2800,0.42426316}, {2850,0.42108772}, {2900,0.44667544}, {2950,0.44302632}, {3000,0.45972807}, {3050,0.47583333}, {3100,0.46631579}, {3150,0.47931579}, {3200,0.45319298}, {3250,0.49717544}, {3300,0.50485965}, {3350,0.51114912}, {3400,0.49484211}, {3450,0.55192982}, {3500,0.54175439}, {3550,0.58109649}, {3600,0.51771930}, {3650,0.53744737}, {3700,0.57622807}, {3750,0.58539474}, {3800,0.58860526}, {3850,0.59199123}, {3900,0.62137719}, {3950,0.65078947}, {4000,0.66350000}, {4050,0.64314035}, {4100,0.59285088}, {4150,0.64707895}, {4200,0.64643860}, {4250,0.68494737}, {4300,0.67858772}, {4350,0.74059649}, {4400,0.66674561}, {4450,0.69167544}, {4500,0.70395614}, {4550,0.72700877}, {4600,0.75471053}, {4650,0.72416667}, {4700,0.75185965}, {4750,0.77738596}, {4800,0.73241228}, {4850,0.80648246}, {4900,0.77915789}, {4950,0.81466667}, {5000,0.77772807}, {5050,0.85407018}, {5100,0.86308772}, {5150,0.83353509}, {5200,0.80071930}, {5250,0.79485965}, {5300,0.85701754}, {5350,0.88676316}, {5400,0.84059649}, {5450,0.87041228}, {5500,0.92998246}, {5550,0.94400877}, {5600,0.89971930}, {5650,0.87844737}, {5700,0.90856140}, {5750,0.97894737}, {5800,0.92406140}, {5850,1.00514912}, {5900,0.94152632}, {5950,1.03673684}, {6000,0.99526316}, {6050,1.015571}, {6100,1.037214}, {6150,0.971357}, {6200,1.010000}, {6250,1.028929}, {6300,1.047571}, {6350,1.084286}, {6400,0.967643}, {6450,1.075857}, {6500,1.082214}, {6550,1.122786}, {6600,1.098214}, {6650,1.195929}, {6700,1.103143}, {6750,1.172500}, {6800,1.077500}, {6850,1.141929}, {6900,1.202000}, {6950,1.176286}, {7000,1.182143}, {7050,1.191500}, {7100,1.279214}, {7150,1.311857}, {7200,1.115214}, {7250,1.197571}, {7300,1.150143}, {7350,1.298786}, {7400,1.265071}, {7450,1.250643}, {7500,1.254000}, {7550,1.405929}, {7600,1.291071}, {7650,1.305143}, {7700,1.275286}, {7750,1.291571}, {7800,1.364357}, {7850,1.344643}, {7900,1.405357}, {7950,1.367857}, {8000,1.300000}, {8050,1.433571}, {8100,1.379214}, {8150,1.507000}, {8200,1.271286}, {8250,1.402500}, {8300,1.712643}, {8350,1.453357}, {8400,1.386929}, {8450,1.346857}, {8500,1.435214}, {8550,1.497429}, {8600,1.478571}, {8650,1.519643}, {8700,1.618429}, {8750,1.544500}, {8800,1.460929}, {8850,1.497857}, {8900,1.515000}, {8950,1.667643}, {9000,1.516071}, {9050,1.612571}, {9100,1.578429}, {9150,1.773786}, {9200,1.647929}, {9250,1.510643}, {9300,1.568857}, {9350,1.568357}, {9400,1.629857}, {9450,1.692286}, {9500,1.649571}, {9550,1.699571}, {9600,1.580500}, {9650,1.721429}, {9700,1.733714}, {9750,1.721786}, {9800,1.654786}, {9850,1.808286}, {9900,1.748286}, {9950,1.866143}, {10000,1.670143}, {10100,1.836429}, {10200,1.863500}, {10300,1.808786}, {10400,1.716000}, {10500,1.698286}, {10600,1.834929}, {10700,1.926214}, {10800,1.840214}, {10900,1.874500}, {11000,2.061214}, {11100,2.027857}, {11200,1.918643}, {11300,1.888214}, {11400,1.919786}, {11500,2.123071}, {11600,2.008357}, {11700,2.159929}, {11800,2.047500}, {11900,2.292643}, {12000,2.123929}, {12100,2.139286}, {12200,2.242643}, {12300,2.063071}, {12400,2.127143}, {12500,2.214143}, {12600,2.245000}, {12700,2.306429}, {12800,2.051357}, {12900,2.279214}, {13000,2.298786}, {13100,2.371214}, {13200,2.280500}, {13300,2.589071}, {13400,2.355643}, {13500,2.528929}, {13600,2.296500}, {13700,2.405000}, {13800,2.616357}, {13900,2.524214}, {14000,2.496429}, {14100,2.539929}, {14200,2.714643}, {14300,2.803571}, {14400,2.376571}, {14500,2.585714}, {14600,2.515714}, {14700,2.764143}, {14800,2.716714}, {14900,2.710786}, {15000,2.733286}, {15100,2.998500}, {15200,2.766071}, {15300,2.830500}, {15400,2.691500}, {15500,2.806214}, {15600,2.921714}, {15700,2.954500}, {15800,3.049857}, {15900,2.962714}, {16000,2.766929}, {16100,3.049000}, {16200,2.963071}, {16300,3.175000}, {16400,2.704500}, {16500,3.074071}, {16600,3.049429}, {16700,3.108214}, {16800,2.963286}, {16900,2.874143}, {17000,3.081857}, {17100,3.186429}, {17200,3.119071}, {17300,3.203929}, {17400,3.476357}, {17500,3.310714}, {17600,3.116286}, {17700,3.175071}, {17800,3.232429}, {17900,3.575929}, {18000,3.281643}, {18100,3.493143}, {18200,3.406714}, {18300,3.729143}, {18400,3.524857}, {18500,3.273071}, {18600,3.325143}, {18700,3.309929}, {18800,3.459214}, {18900,3.597786}, {19000,3.514214}, {19100,3.728786}, {19200,3.365071}, {19300,3.716500}, {19400,3.716643}, {19500,3.694500}, {19600,3.535786}, {19700,3.923429}, {19800,3.775214}, {19900,4.016286}, {20000,3.604357}};
data["big_flat"]["TypeClassesBodyHOAS"]["Aggregate"]["system"] = {{1,0.00009649}, {2,0.00010526}, {3,0.00000000}, {4,0.00010526}, {5,0.00000000}, {6,0.00000000}, {7,0.00003509}, {8,0.00007018}, {9,0.00000000}, {10,0.00000000}, {11,0.00002632}, {12,0.00000000}, {13,0.00000000}, {14,0.00010526}, {15,0.00010526}, {16,0.00003509}, {17,0.00002632}, {18,0.00003509}, {19,0.00003509}, {20,0.00007018}, {21,0.00003509}, {22,0.00002632}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00003509}, {28,0.00007018}, {29,0.00003509}, {30,0.00003509}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00007018}, {35,0.00000000}, {36,0.00003509}, {37,0.00010526}, {38,0.00007018}, {39,0.00007018}, {40,0.00013158}, {41,0.00003509}, {42,0.00007018}, {43,0.00007018}, {44,0.00007018}, {45,0.00000000}, {46,0.00000000}, {47,0.00003509}, {48,0.00010526}, {49,0.00007018}, {50,0.00002632}, {51,0.00003509}, {52,0.00006140}, {53,0.00005263}, {54,0.00007018}, {55,0.00003509}, {56,0.00010526}, {57,0.00010526}, {58,0.00007018}, {59,0.00003509}, {60,0.00007018}, {61,0.00003509}, {62,0.00007018}, {63,0.00006140}, {64,0.00002632}, {65,0.00003509}, {66,0.00003509}, {67,0.00000000}, {68,0.00010526}, {69,0.00007018}, {70,0.00000000}, {71,0.00014035}, {72,0.00007018}, {73,0.00003509}, {74,0.00000000}, {75,0.00010526}, {76,0.00007018}, {77,0.00009649}, {78,0.00003509}, {79,0.00000000}, {80,0.00000000}, {81,0.00010526}, {82,0.00000000}, {83,0.00010526}, {84,0.00006140}, {85,0.00003509}, {86,0.00003509}, {87,0.00000000}, {88,0.00000000}, {89,0.00003509}, {90,0.00000000}, {91,0.00000000}, {92,0.00014035}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00007018}, {97,0.00007018}, {98,0.00007018}, {99,0.00000000}, {100,0.00002632}, {101,0.00006140}, {102,0.00007018}, {103,0.00003509}, {104,0.00007018}, {105,0.00003509}, {106,0.00010526}, {107,0.00007018}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00003509}, {112,0.00000000}, {113,0.00000000}, {114,0.00003509}, {115,0.00000000}, {116,0.00007018}, {117,0.00003509}, {118,0.00009649}, {119,0.00003509}, {120,0.00009649}, {121,0.00003509}, {122,0.00003509}, {123,0.00007018}, {124,0.00003509}, {125,0.00003509}, {126,0.00003509}, {127,0.00007018}, {128,0.00007018}, {129,0.00003509}, {130,0.00003509}, {131,0.00003509}, {132,0.00000000}, {133,0.00009649}, {134,0.00003509}, {135,0.00000000}, {136,0.00010526}, {137,0.00003509}, {138,0.00000000}, {139,0.00003509}, {140,0.00007018}, {141,0.00006140}, {142,0.00010526}, {143,0.00003509}, {144,0.00003509}, {145,0.00007018}, {146,0.00003509}, {147,0.00003509}, {148,0.00010526}, {149,0.00003509}, {150,0.00003509}, {151,0.00013158}, {152,0.00003509}, {153,0.00000000}, {154,0.00003509}, {155,0.00000000}, {156,0.00006140}, {157,0.00002632}, {158,0.00003509}, {159,0.00013158}, {160,0.00003509}, {161,0.00007018}, {162,0.00007018}, {163,0.00003509}, {164,0.00000000}, {165,0.00003509}, {166,0.00009649}, {167,0.00007018}, {168,0.00007018}, {169,0.00010526}, {170,0.00000000}, {171,0.00010526}, {172,0.00007018}, {173,0.00000000}, {174,0.00003509}, {175,0.00000000}, {176,0.00010526}, {177,0.00007018}, {178,0.00014035}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00003509}, {184,0.00010526}, {185,0.00000000}, {186,0.00003509}, {187,0.00007018}, {188,0.00003509}, {189,0.00007018}, {190,0.00007018}, {191,0.00007018}, {192,0.00007018}, {193,0.00003509}, {194,0.00007018}, {195,0.00010526}, {196,0.00003509}, {197,0.00007018}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00003509}, {202,0.00003509}, {203,0.00003509}, {204,0.00003509}, {205,0.00000000}, {206,0.00000000}, {207,0.00010526}, {208,0.00003509}, {209,0.00006140}, {210,0.00007018}, {211,0.00000000}, {212,0.00003509}, {213,0.00007018}, {214,0.00003509}, {215,0.00010526}, {216,0.00000000}, {217,0.00000000}, {218,0.00007018}, {219,0.00014035}, {220,0.00010526}, {221,0.00006140}, {222,0.00006140}, {223,0.00003509}, {224,0.00007018}, {225,0.00003509}, {226,0.00000000}, {227,0.00007018}, {228,0.00010526}, {229,0.00000000}, {230,0.00007018}, {231,0.00006140}, {232,0.00003509}, {233,0.00014035}, {234,0.00003509}, {235,0.00000000}, {236,0.00007018}, {237,0.00003509}, {238,0.00007018}, {239,0.00010526}, {240,0.00007018}, {241,0.00000000}, {242,0.00007018}, {243,0.00000000}, {244,0.00007018}, {245,0.00000000}, {246,0.00003509}, {247,0.00010526}, {248,0.00000000}, {249,0.00003509}, {250,0.00006140}, {251,0.00000000}, {252,0.00010526}, {253,0.00003509}, {254,0.00009649}, {255,0.00003509}, {256,0.00000000}, {257,0.00007018}, {258,0.00003509}, {259,0.00003509}, {260,0.00007018}, {261,0.00003509}, {262,0.00006140}, {263,0.00007018}, {264,0.00000000}, {265,0.00003509}, {266,0.00003509}, {267,0.00007018}, {268,0.00007018}, {269,0.00003509}, {270,0.00003509}, {271,0.00006140}, {272,0.00003509}, {273,0.00007018}, {274,0.00003509}, {275,0.00007018}, {276,0.00007018}, {277,0.00009649}, {278,0.00007018}, {279,0.00007018}, {280,0.00022807}, {281,0.00007018}, {282,0.00003509}, {283,0.00002632}, {284,0.00003509}, {285,0.00010526}, {286,0.00003509}, {287,0.00010526}, {288,0.00003509}, {289,0.00000000}, {290,0.00010526}, {291,0.00003509}, {292,0.00000000}, {293,0.00009649}, {294,0.00010526}, {295,0.00010526}, {296,0.00007018}, {297,0.00010526}, {298,0.00003509}, {299,0.00010526}, {300,0.00003509}, {301,0.00002632}, {302,0.00000000}, {303,0.00007018}, {304,0.00003509}, {305,0.00003509}, {306,0.00003509}, {307,0.00000000}, {308,0.00003509}, {309,0.00000000}, {310,0.00013158}, {311,0.00003509}, {312,0.00003509}, {313,0.00007018}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00007018}, {319,0.00014035}, {320,0.00003509}, {321,0.00010526}, {322,0.00000000}, {323,0.00003509}, {324,0.00003509}, {325,0.00007018}, {326,0.00003509}, {327,0.00000000}, {328,0.00010526}, {329,0.00006140}, {330,0.00003509}, {331,0.00000000}, {332,0.00003509}, {333,0.00013158}, {334,0.00000000}, {335,0.00003509}, {336,0.00010526}, {337,0.00000000}, {338,0.00003509}, {339,0.00007018}, {340,0.00003509}, {341,0.00000000}, {342,0.00003509}, {343,0.00007018}, {344,0.00007018}, {345,0.00010526}, {346,0.00000000}, {347,0.00010526}, {348,0.00010526}, {349,0.00003509}, {350,0.00009649}, {351,0.00007018}, {352,0.00010526}, {353,0.00000000}, {354,0.00009649}, {355,0.00007018}, {356,0.00000000}, {357,0.00003509}, {358,0.00003509}, {359,0.00003509}, {360,0.00000000}, {361,0.00000000}, {362,0.00002632}, {363,0.00010526}, {364,0.00003509}, {365,0.00003509}, {366,0.00007018}, {367,0.00000000}, {368,0.00010526}, {369,0.00010526}, {370,0.00003509}, {371,0.00003509}, {372,0.00003509}, {373,0.00000000}, {374,0.00003509}, {375,0.00000000}, {376,0.00003509}, {377,0.00017544}, {378,0.00003509}, {379,0.00000000}, {380,0.00007018}, {381,0.00000000}, {382,0.00003509}, {383,0.00008772}, {384,0.00007018}, {385,0.00007018}, {386,0.00000000}, {387,0.00003509}, {388,0.00007018}, {389,0.00003509}, {390,0.00003509}, {391,0.00003509}, {392,0.00014035}, {393,0.00002632}, {394,0.00014035}, {395,0.00010526}, {396,0.00009649}, {397,0.00009649}, {398,0.00007018}, {399,0.00009649}, {400,0.00007018}, {401,0.00014035}, {402,0.00003509}, {403,0.00000000}, {404,0.00003509}, {405,0.00000000}, {406,0.00000000}, {407,0.00010526}, {408,0.00010526}, {409,0.00010526}, {410,0.00000000}, {411,0.00003509}, {412,0.00009649}, {413,0.00014035}, {414,0.00006140}, {415,0.00000000}, {416,0.00003509}, {417,0.00003509}, {418,0.00007018}, {419,0.00003509}, {420,0.00017544}, {421,0.00003509}, {422,0.00014035}, {423,0.00003509}, {424,0.00007018}, {425,0.00003509}, {426,0.00007018}, {427,0.00024561}, {428,0.00007018}, {429,0.00014035}, {430,0.00014035}, {431,0.00013158}, {432,0.00010526}, {433,0.00007018}, {434,0.00017544}, {435,0.00000000}, {436,0.00017544}, {437,0.00007018}, {438,0.00031579}, {439,0.00007018}, {440,0.00009649}, {441,0.00020175}, {442,0.00010526}, {443,0.00020175}, {444,0.00010526}, {445,0.00017544}, {446,0.00024561}, {447,0.00003509}, {448,0.00017544}, {449,0.00007018}, {450,0.00010526}, {451,0.00063158}, {452,0.00000000}, {453,0.00021053}, {454,0.00010526}, {455,0.00017544}, {456,0.00040351}, {457,0.00017544}, {458,0.00017544}, {459,0.00003509}, {460,0.00014035}, {461,0.00057895}, {462,0.00007018}, {463,0.00020175}, {464,0.00007018}, {465,0.00024561}, {466,0.00037719}, {467,0.00007018}, {468,0.00021053}, {469,0.00031579}, {470,0.00003509}, {471,0.00024561}, {472,0.00003509}, {473,0.00031579}, {474,0.00038596}, {475,0.00003509}, {476,0.00007018}, {477,0.00041228}, {478,0.00007018}, {479,0.00028070}, {480,0.00042105}, {481,0.00003509}, {482,0.00030702}, {483,0.00038596}, {484,0.00000000}, {485,0.00037719}, {486,0.00003509}, {487,0.00010526}, {488,0.00037719}, {489,0.00003509}, {490,0.00020175}, {491,0.00049123}, {492,0.00010526}, {493,0.00017544}, {494,0.00044737}, {495,0.00000000}, {496,0.00017544}, {497,0.00044737}, {498,0.00005263}, {499,0.00007018}, {500,0.00037719}, {505,0.00000000}, {510,0.00010526}, {515,0.00007018}, {520,0.00010526}, {525,0.00007018}, {530,0.00024561}, {535,0.00052632}, {540,0.00000000}, {545,0.00010526}, {550,0.00055263}, {555,0.00056140}, {560,0.00006140}, {565,0.00014035}, {570,0.00041228}, {575,0.00044737}, {580,0.00003509}, {585,0.00021053}, {590,0.00044737}, {595,0.00056140}, {600,0.00048246}, {605,0.00007018}, {610,0.00017544}, {615,0.00035088}, {620,0.00041228}, {625,0.00010526}, {630,0.00014035}, {635,0.00017544}, {640,0.00007018}, {645,0.00017544}, {650,0.00014035}, {655,0.00029825}, {660,0.00030702}, {665,0.00023684}, {670,0.00073684}, {675,0.00043860}, {680,0.00000000}, {685,0.00017544}, {690,0.00002632}, {695,0.00070175}, {700,0.00041228}, {705,0.00073684}, {710,0.00041228}, {715,0.00042105}, {720,0.00063158}, {725,0.00035088}, {730,0.00068421}, {735,0.00052632}, {740,0.00057895}, {745,0.00062281}, {750,0.00073684}, {755,0.00056140}, {760,0.00058772}, {765,0.00140351}, {770,0.00072807}, {775,0.00078070}, {780,0.00079825}, {785,0.00084211}, {790,0.00059649}, {795,0.00084211}, {800,0.00072807}, {805,0.00072807}, {810,0.00062281}, {815,0.00094737}, {820,0.00064912}, {825,0.00124561}, {830,0.00084211}, {835,0.00070175}, {840,0.00087719}, {845,0.00061404}, {850,0.00069298}, {855,0.00134211}, {860,0.00079825}, {865,0.00073684}, {870,0.00061404}, {875,0.00075439}, {880,0.00121053}, {885,0.00076316}, {890,0.00078947}, {895,0.00044737}, {900,0.00108772}, {905,0.00066667}, {910,0.00048246}, {915,0.00058772}, {920,0.00092982}, {925,0.00080702}, {930,0.00041228}, {935,0.00048246}, {940,0.00107018}, {945,0.00063158}, {950,0.00062281}, {955,0.00087719}, {960,0.00048246}, {965,0.00051754}, {970,0.00087719}, {975,0.00066667}, {980,0.00083333}, {985,0.00069298}, {990,0.00059649}, {995,0.00104386}, {1000,0.00030702}, {1010,0.00079825}, {1020,0.00063158}, {1030,0.00052632}, {1040,0.00090351}, {1050,0.00057895}, {1060,0.00094737}, {1070,0.00051754}, {1080,0.00066667}, {1090,0.00070175}, {1100,0.00100000}, {1110,0.00042105}, {1120,0.00085965}, {1130,0.00063158}, {1140,0.00076316}, {1150,0.00077193}, {1160,0.00055263}, {1170,0.00077193}, {1180,0.00021053}, {1190,0.00009649}, {1200,0.00010526}, {1210,0.00007018}, {1220,0.00007018}, {1230,0.00010526}, {1240,0.00010526}, {1250,0.00000000}, {1260,0.00003509}, {1270,0.00007018}, {1280,0.00010526}, {1290,0.00014035}, {1300,0.00010526}, {1310,0.00007018}, {1320,0.00007018}, {1330,0.00091228}, {1340,0.00000000}, {1350,0.00014035}, {1360,0.00010526}, {1370,0.00014035}, {1380,0.00013158}, {1390,0.00010526}, {1400,0.00007018}, {1410,0.00010526}, {1420,0.00007018}, {1430,0.00010526}, {1440,0.00003509}, {1450,0.00017544}, {1460,0.00024561}, {1470,0.00016667}, {1480,0.00017544}, {1490,0.00013158}, {1500,0.00007018}, {1510,0.00006140}, {1520,0.00017544}, {1530,0.00003509}, {1540,0.00007018}, {1550,0.00010526}, {1560,0.00010526}, {1570,0.00016667}, {1580,0.00021053}, {1590,0.00010526}, {1600,0.00014035}, {1610,0.00007018}, {1620,0.00021053}, {1630,0.00003509}, {1640,0.00007018}, {1650,0.00014035}, {1660,0.00007018}, {1670,0.00000000}, {1680,0.00007018}, {1690,0.00003509}, {1700,0.00017544}, {1710,0.00014035}, {1720,0.00014035}, {1730,0.00006140}, {1740,0.00007018}, {1750,0.00010526}, {1760,0.00010526}, {1770,0.00014035}, {1780,0.00014035}, {1790,0.00014035}, {1800,0.00020175}, {1810,0.00007018}, {1820,0.00023684}, {1830,0.00003509}, {1840,0.00023684}, {1850,0.00017544}, {1860,0.00017544}, {1870,0.00000000}, {1880,0.00028070}, {1890,0.00010526}, {1900,0.00021053}, {1910,0.00007018}, {1920,0.00007018}, {1930,0.00000000}, {1940,0.00003509}, {1950,0.00010526}, {1960,0.00014035}, {1970,0.00009649}, {1980,0.00000000}, {1990,0.00007018}, {2000,0.00006140}, {2050,0.00007018}, {2100,0.00044737}, {2150,0.00081579}, {2200,0.00055263}, {2250,0.00042105}, {2300,0.00044737}, {2350,0.00058772}, {2400,0.00035088}, {2450,0.00058772}, {2500,0.00035088}, {2550,0.00049123}, {2600,0.00045614}, {2650,0.00041228}, {2700,0.00035088}, {2750,0.00028070}, {2800,0.00021053}, {2850,0.00022807}, {2900,0.00031579}, {2950,0.00021053}, {3000,0.00017544}, {3050,0.00007018}, {3100,0.00017544}, {3150,0.00024561}, {3200,0.00040351}, {3250,0.00009649}, {3300,0.00007018}, {3350,0.00027193}, {3400,0.00042105}, {3450,0.00058772}, {3500,0.00072807}, {3550,0.00069298}, {3600,0.00017544}, {3650,0.00064912}, {3700,0.00059649}, {3750,0.00055263}, {3800,0.00014035}, {3850,0.00009649}, {3900,0.00010526}, {3950,0.00010526}, {4000,0.00017544}, {4050,0.00010526}, {4100,0.00020175}, {4150,0.00044737}, {4200,0.00028070}, {4250,0.00031579}, {4300,0.00014035}, {4350,0.00038596}, {4400,0.00044737}, {4450,0.00035088}, {4500,0.00059649}, {4550,0.00023684}, {4600,0.00020175}, {4650,0.00020175}, {4700,0.00023684}, {4750,0.00007018}, {4800,0.00017544}, {4850,0.00014035}, {4900,0.00021053}, {4950,0.00023684}, {5000,0.00010526}, {5050,0.00014035}, {5100,0.00010526}, {5150,0.00014035}, {5200,0.00024561}, {5250,0.00016667}, {5300,0.00010526}, {5350,0.00007018}, {5400,0.00014035}, {5450,0.00021053}, {5500,0.00024561}, {5550,0.00024561}, {5600,0.00017544}, {5650,0.00010526}, {5700,0.00007018}, {5750,0.00038596}, {5800,0.00010526}, {5850,0.00013158}, {5900,0.00028070}, {5950,0.00013158}, {6000,0.00021053}, {6050,0.003357}, {6100,0.006143}, {6150,0.006500}, {6200,0.005357}, {6250,0.006286}, {6300,0.002857}, {6350,0.000000}, {6400,0.000000}, {6450,0.000286}, {6500,0.000000}, {6550,0.000286}, {6600,0.000286}, {6650,0.000000}, {6700,0.000571}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000857}, {6950,0.001714}, {7000,0.000286}, {7050,0.000786}, {7100,0.000286}, {7150,0.001143}, {7200,0.000500}, {7250,0.000286}, {7300,0.001429}, {7350,0.001714}, {7400,0.000857}, {7450,0.000571}, {7500,0.000571}, {7550,0.001143}, {7600,0.000857}, {7650,0.000286}, {7700,0.000571}, {7750,0.000857}, {7800,0.000857}, {7850,0.000571}, {7900,0.000571}, {7950,0.000571}, {8000,0.000571}, {8050,0.000571}, {8100,0.001429}, {8150,0.000857}, {8200,0.000000}, {8250,0.000000}, {8300,0.000286}, {8350,0.000571}, {8400,0.000286}, {8450,0.000286}, {8500,0.000000}, {8550,0.000000}, {8600,0.000786}, {8650,0.000000}, {8700,0.000286}, {8750,0.000286}, {8800,0.000571}, {8850,0.000286}, {8900,0.000286}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000786}, {9150,0.000571}, {9200,0.000000}, {9250,0.000286}, {9300,0.000000}, {9350,0.000857}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000286}, {9650,0.000286}, {9700,0.000000}, {9750,0.000286}, {9800,0.000571}, {9850,0.000286}, {9900,0.000286}, {9950,0.000000}, {10000,0.000000}, {10100,0.000286}, {10200,0.000286}, {10300,0.000286}, {10400,0.000571}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000286}, {11000,0.000857}, {11100,0.000571}, {11200,0.000857}, {11300,0.000286}, {11400,0.000000}, {11500,0.000857}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000286}, {12200,0.001143}, {12300,0.000286}, {12400,0.000571}, {12500,0.000571}, {12600,0.000000}, {12700,0.000571}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000286}, {13300,0.000286}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000286}, {13900,0.000286}, {14000,0.000000}, {14100,0.000286}, {14200,0.000000}, {14300,0.000286}, {14400,0.000286}, {14500,0.000571}, {14600,0.002857}, {14700,0.014571}, {14800,0.014286}, {14900,0.005071}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000857}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000286}, {15800,0.000000}, {15900,0.000000}, {16000,0.000286}, {16100,0.000286}, {16200,0.000000}, {16300,0.000286}, {16400,0.000000}, {16500,0.000786}, {16600,0.000286}, {16700,0.000286}, {16800,0.000000}, {16900,0.002500}, {17000,0.000000}, {17100,0.000286}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000286}, {17900,0.000286}, {18000,0.000000}, {18100,0.000000}, {18200,0.000286}, {18300,0.000571}, {18400,0.000571}, {18500,0.000000}, {18600,0.000571}, {18700,0.000000}, {18800,0.000571}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000571}, {19400,0.000214}, {19500,0.001429}, {19600,0.000286}, {19700,0.000286}, {19800,0.000286}, {19900,0.000857}, {20000,0.011357}};
data["big_flat"]["TypeClassesBodyHOAS"]["actual reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00001754}, {12,0.00036842}, {13,0.00100000}, {14,0.00100000}, {15,0.00100000}, {16,0.00100000}, {17,0.00100000}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00103509}, {23,0.00134211}, {24,0.00129825}, {25,0.00200000}, {26,0.00200000}, {27,0.00200000}, {28,0.00200000}, {29,0.00200000}, {30,0.00200000}, {31,0.00208772}, {32,0.00200000}, {33,0.00238596}, {34,0.00248246}, {35,0.00295614}, {36,0.00281579}, {37,0.00300000}, {38,0.00300000}, {39,0.00300000}, {40,0.00301754}, {41,0.00300000}, {42,0.00440351}, {43,0.00342105}, {44,0.00337719}, {45,0.00370175}, {46,0.00394737}, {47,0.00400000}, {48,0.00390351}, {49,0.00400000}, {50,0.00400000}, {51,0.00418421}, {52,0.00403509}, {53,0.00450000}, {54,0.00450000}, {55,0.00492982}, {56,0.00453509}, {57,0.00496491}, {58,0.00554386}, {59,0.00503509}, {60,0.00500000}, {61,0.00540351}, {62,0.00545614}, {63,0.00559649}, {64,0.00509649}, {65,0.00548246}, {66,0.00550877}, {67,0.00599123}, {68,0.00577193}, {69,0.00602632}, {70,0.00737719}, {71,0.00644737}, {72,0.00601754}, {73,0.00651754}, {74,0.00660526}, {75,0.00692105}, {76,0.00662281}, {77,0.00701754}, {78,0.00708772}, {79,0.00757895}, {80,0.00681579}, {81,0.00720175}, {82,0.00742982}, {83,0.00754386}, {84,0.00760526}, {85,0.00772807}, {86,0.00785088}, {87,0.00842982}, {88,0.00760526}, {89,0.00828947}, {90,0.00931579}, {91,0.00851754}, {92,0.00844737}, {93,0.00866667}, {94,0.00903509}, {95,0.00945614}, {96,0.00854386}, {97,0.00864912}, {98,0.01063158}, {99,0.00942105}, {100,0.00897368}, {101,0.00950000}, {102,0.00950000}, {103,0.00983333}, {104,0.00950000}, {105,0.00985965}, {106,0.01130702}, {107,0.01041228}, {108,0.01000877}, {109,0.01043860}, {110,0.01050000}, {111,0.01094737}, {112,0.01004386}, {113,0.01048246}, {114,0.01035965}, {115,0.01115789}, {116,0.01046491}, {117,0.01137719}, {118,0.01146491}, {119,0.01160526}, {120,0.01285965}, {121,0.01150877}, {122,0.01154386}, {123,0.01241228}, {124,0.01162281}, {125,0.01247368}, {126,0.01251754}, {127,0.01368421}, {128,0.01150877}, {129,0.01213158}, {130,0.01230702}, {131,0.01265789}, {132,0.01279825}, {133,0.01470175}, {134,0.01265789}, {135,0.01342982}, {136,0.01275439}, {137,0.01328070}, {138,0.01345614}, {139,0.01513158}, {140,0.01363158}, {141,0.01398246}, {142,0.01414912}, {143,0.01459649}, {144,0.01573684}, {145,0.01361404}, {146,0.01385965}, {147,0.01450877}, {148,0.01431579}, {149,0.01471930}, {150,0.01591228}, {151,0.01558772}, {152,0.01469298}, {153,0.01535088}, {154,0.01540351}, {155,0.01788596}, {156,0.01534211}, {157,0.01593860}, {158,0.01607895}, {159,0.01671930}, {160,0.01623684}, {161,0.01559649}, {162,0.01566667}, {163,0.01628947}, {164,0.01577193}, {165,0.01795614}, {166,0.01642982}, {167,0.01707895}, {168,0.01614035}, {169,0.01687719}, {170,0.01798246}, {171,0.01760526}, {172,0.01701754}, {173,0.01789474}, {174,0.02085965}, {175,0.01828947}, {176,0.01671930}, {177,0.01756140}, {178,0.01761404}, {179,0.01926316}, {180,0.01787719}, {181,0.01855263}, {182,0.01861404}, {183,0.02183333}, {184,0.01793860}, {185,0.01881579}, {186,0.01909649}, {187,0.02253509}, {188,0.01874561}, {189,0.01971930}, {190,0.01991228}, {191,0.02322807}, {192,0.01792105}, {193,0.01882456}, {194,0.01900000}, {195,0.02241228}, {196,0.01885965}, {197,0.01979825}, {198,0.01993860}, {199,0.02322807}, {200,0.01914912}, {201,0.02005263}, {202,0.02024561}, {203,0.02383333}, {204,0.02019298}, {205,0.02104386}, {206,0.02119298}, {207,0.02417544}, {208,0.02025439}, {209,0.02103509}, {210,0.02111404}, {211,0.02378070}, {212,0.02097368}, {213,0.02236842}, {214,0.02212281}, {215,0.02440351}, {216,0.02149123}, {217,0.02284211}, {218,0.02635088}, {219,0.02297368}, {220,0.02297368}, {221,0.02352632}, {222,0.02464912}, {223,0.02478947}, {224,0.02171053}, {225,0.02584211}, {226,0.02230702}, {227,0.02382456}, {228,0.02287719}, {229,0.02482456}, {230,0.02413158}, {231,0.02479825}, {232,0.02630702}, {233,0.02415789}, {234,0.02397368}, {235,0.02498246}, {236,0.02392105}, {237,0.02491228}, {238,0.02552632}, {239,0.02719298}, {240,0.02423684}, {241,0.02515789}, {242,0.02832456}, {243,0.02617544}, {244,0.02504386}, {245,0.02959649}, {246,0.02592105}, {247,0.02739474}, {248,0.02831579}, {249,0.02640351}, {250,0.02624561}, {251,0.03066667}, {252,0.02625439}, {253,0.02792105}, {254,0.03085965}, {255,0.02889474}, {256,0.02502632}, {257,0.02925439}, {258,0.02565789}, {259,0.02733333}, {260,0.02622807}, {261,0.02720175}, {262,0.02708772}, {263,0.02851754}, {264,0.02614912}, {265,0.02787719}, {266,0.02778947}, {267,0.02876316}, {268,0.02756140}, {269,0.03142982}, {270,0.02850000}, {271,0.02973684}, {272,0.02973684}, {273,0.02792982}, {274,0.02822807}, {275,0.03187719}, {276,0.02835965}, {277,0.02984211}, {278,0.03200000}, {279,0.03049123}, {280,0.02888596}, {281,0.03163158}, {282,0.02985965}, {283,0.03658772}, {284,0.02951754}, {285,0.03132456}, {286,0.03367544}, {287,0.03232456}, {288,0.02858772}, {289,0.03169298}, {290,0.03013158}, {291,0.03125439}, {292,0.02957018}, {293,0.03148246}, {294,0.03421930}, {295,0.03220175}, {296,0.03044737}, {297,0.03372807}, {298,0.03228070}, {299,0.03781579}, {300,0.03089474}, {301,0.03270175}, {302,0.03540351}, {303,0.03490351}, {304,0.03554386}, {305,0.03177193}, {306,0.03236842}, {307,0.03576316}, {308,0.03258772}, {309,0.03432456}, {310,0.03320175}, {311,0.03491228}, {312,0.03477193}, {313,0.03428070}, {314,0.03885965}, {315,0.03510526}, {316,0.03449123}, {317,0.03711404}, {318,0.03583333}, {319,0.04144737}, {320,0.03166667}, {321,0.03355263}, {322,0.03359649}, {323,0.03465789}, {324,0.03532456}, {325,0.03485965}, {326,0.03916667}, {327,0.03561404}, {328,0.03370175}, {329,0.03669298}, {330,0.03527193}, {331,0.04090351}, {332,0.03504386}, {333,0.04128947}, {334,0.03629825}, {335,0.03785088}, {336,0.03520175}, {337,0.03591228}, {338,0.04054386}, {339,0.03706140}, {340,0.04010526}, {341,0.03692105}, {342,0.03740351}, {343,0.03806140}, {344,0.03607895}, {345,0.03878070}, {346,0.03795614}, {347,0.04372807}, {348,0.03817544}, {349,0.04350877}, {350,0.03902632}, {351,0.04429825}, {352,0.03565789}, {353,0.04157018}, {354,0.03712281}, {355,0.03893860}, {356,0.03835965}, {357,0.03913158}, {358,0.04038596}, {359,0.04071930}, {360,0.04136842}, {361,0.03956140}, {362,0.04326316}, {363,0.04046491}, {364,0.04319298}, {365,0.04132456}, {366,0.04485965}, {367,0.04200877}, {368,0.04171053}, {369,0.04027193}, {370,0.04435088}, {371,0.04126316}, {372,0.04366667}, {373,0.04178947}, {374,0.04521930}, {375,0.04257895}, {376,0.04442105}, {377,0.04161404}, {378,0.04575439}, {379,0.04350000}, {380,0.04573684}, {381,0.04360526}, {382,0.04714912}, {383,0.04587719}, {384,0.04128070}, {385,0.03987719}, {386,0.04342982}, {387,0.04161404}, {388,0.04375439}, {389,0.04155263}, {390,0.04496491}, {391,0.04353509}, {392,0.04384211}, {393,0.04196491}, {394,0.04707018}, {395,0.04368421}, {396,0.04531579}, {397,0.04414035}, {398,0.04714035}, {399,0.04585088}, {400,0.04414912}, {401,0.04259649}, {402,0.04666667}, {403,0.04467544}, {404,0.04671053}, {405,0.04464912}, {406,0.04839474}, {407,0.05408772}, {408,0.04300877}, {409,0.04878070}, {410,0.04522807}, {411,0.04991228}, {412,0.04534211}, {413,0.05014035}, {414,0.04712281}, {415,0.05138596}, {416,0.04281579}, {417,0.04738596}, {418,0.04529825}, {419,0.04577193}, {420,0.04925439}, {421,0.04576316}, {422,0.05075439}, {423,0.04848246}, {424,0.04814035}, {425,0.04722807}, {426,0.04971930}, {427,0.04921930}, {428,0.04692982}, {429,0.05191228}, {430,0.04864035}, {431,0.05426316}, {432,0.04572807}, {433,0.05102632}, {434,0.05567544}, {435,0.04843860}, {436,0.05110526}, {437,0.04964035}, {438,0.05216667}, {439,0.05085088}, {440,0.04792982}, {441,0.05429825}, {442,0.04963158}, {443,0.05478947}, {444,0.04996491}, {445,0.05482456}, {446,0.06037719}, {447,0.05406140}, {448,0.04952632}, {449,0.04785965}, {450,0.05091228}, {451,0.05753509}, {452,0.04750877}, {453,0.05326316}, {454,0.05103509}, {455,0.05456140}, {456,0.05589474}, {457,0.04970175}, {458,0.05427193}, {459,0.05165789}, {460,0.05352632}, {461,0.06042982}, {462,0.05204386}, {463,0.05754386}, {464,0.04951754}, {465,0.05421053}, {466,0.05882456}, {467,0.05242105}, {468,0.05388596}, {469,0.06055263}, {470,0.05267544}, {471,0.05809649}, {472,0.05151754}, {473,0.05572807}, {474,0.06178947}, {475,0.05541228}, {476,0.05615789}, {477,0.06335088}, {478,0.05501754}, {479,0.06037719}, {480,0.05807895}, {481,0.05232456}, {482,0.05583333}, {483,0.05511404}, {484,0.05248246}, {485,0.05835088}, {486,0.05505263}, {487,0.05900877}, {488,0.06081579}, {489,0.05507018}, {490,0.05729825}, {491,0.06528947}, {492,0.05530702}, {493,0.05952632}, {494,0.06495614}, {495,0.05943860}, {496,0.05552632}, {497,0.06411404}, {498,0.05546491}, {499,0.06021930}, {500,0.06422807}, {505,0.05804386}, {510,0.06057018}, {515,0.05968421}, {520,0.05584211}, {525,0.05950000}, {530,0.06054386}, {535,0.07108772}, {540,0.06066667}, {545,0.06178947}, {550,0.06988596}, {555,0.06459649}, {560,0.06087719}, {565,0.06829825}, {570,0.07358772}, {575,0.07823684}, {580,0.06267544}, {585,0.06807895}, {590,0.07594737}, {595,0.07636842}, {600,0.07430702}, {605,0.07200877}, {610,0.06954386}, {615,0.08042982}, {620,0.07802632}, {625,0.07828947}, {630,0.08100877}, {635,0.07692982}, {640,0.06722807}, {645,0.07401754}, {650,0.07954386}, {655,0.08607895}, {660,0.08072807}, {665,0.08444737}, {670,0.08809649}, {675,0.08614912}, {680,0.07567544}, {685,0.08137719}, {690,0.07957895}, {695,0.09285088}, {700,0.09276316}, {705,0.08808772}, {710,0.08975439}, {715,0.09361404}, {720,0.08791228}, {725,0.09461404}, {730,0.09522807}, {735,0.10131579}, {740,0.09334211}, {745,0.09585965}, {750,0.09830702}, {755,0.09941228}, {760,0.09638596}, {765,0.10345614}, {770,0.09068421}, {775,0.09855263}, {780,0.09513158}, {785,0.09616667}, {790,0.09938596}, {795,0.10254386}, {800,0.09479825}, {805,0.10062281}, {810,0.10125439}, {815,0.10864035}, {820,0.10265789}, {825,0.10654386}, {830,0.11028947}, {835,0.10421053}, {840,0.10142982}, {845,0.10835965}, {850,0.10584211}, {855,0.11245614}, {860,0.11064035}, {865,0.10671930}, {870,0.11180702}, {875,0.11513158}, {880,0.10848246}, {885,0.11640351}, {890,0.11583333}, {895,0.12514912}, {900,0.11433333}, {905,0.11272807}, {910,0.11554386}, {915,0.11627193}, {920,0.12010526}, {925,0.12035088}, {930,0.11367544}, {935,0.12219298}, {940,0.11944737}, {945,0.11934211}, {950,0.12389474}, {955,0.12723684}, {960,0.11362281}, {965,0.12171930}, {970,0.12966667}, {975,0.13042982}, {980,0.14702632}, {985,0.12812281}, {990,0.13069298}, {995,0.13607895}, {1000,0.12548246}, {1010,0.12997368}, {1020,0.13486842}, {1030,0.12644737}, {1040,0.12382456}, {1050,0.13223684}, {1060,0.13609649}, {1070,0.13722807}, {1080,0.14154386}, {1090,0.13185088}, {1100,0.14390351}, {1110,0.14257895}, {1120,0.14389474}, {1130,0.14465789}, {1140,0.15265789}, {1150,0.15531579}, {1160,0.14059649}, {1170,0.15280702}, {1180,0.15128947}, {1190,0.15927193}, {1200,0.15541228}, {1210,0.15839474}, {1220,0.15781579}, {1230,0.16734211}, {1240,0.15700877}, {1250,0.15769298}, {1260,0.17058772}, {1270,0.17517544}, {1280,0.16838596}, {1290,0.24070175}, {1300,0.16771930}, {1310,0.17883333}, {1320,0.16918421}, {1330,0.86359649}, {1340,0.18350000}, {1350,0.17247368}, {1360,0.16850000}, {1370,0.18815789}, {1380,0.18142982}, {1390,0.19118421}, {1400,0.18695614}, {1410,0.17872807}, {1420,0.18435965}, {1430,0.19214912}, {1440,0.18160526}, {1450,0.19318421}, {1460,0.19377193}, {1470,0.20665789}, {1480,0.18559649}, {1490,0.19986842}, {1500,0.20351754}, {1510,0.20519298}, {1520,0.19923684}, {1530,0.21371053}, {1540,0.19317544}, {1550,0.20327193}, {1560,0.19764035}, {1570,0.19928947}, {1580,0.20682456}, {1590,0.21401754}, {1600,0.19880702}, {1610,0.20842105}, {1620,0.20905263}, {1630,0.23037719}, {1640,0.21167544}, {1650,0.22008772}, {1660,0.23408772}, {1670,0.21697368}, {1680,0.21083333}, {1690,0.22566667}, {1700,0.21715789}, {1710,0.24002632}, {1720,0.22621053}, {1730,0.22148246}, {1740,0.23096491}, {1750,0.24425439}, {1760,0.22622807}, {1770,0.24506140}, {1780,0.24352632}, {1790,0.26677193}, {1800,0.22723684}, {1810,0.23264912}, {1820,0.24719298}, {1830,0.24054386}, {1840,0.24184211}, {1850,0.24985965}, {1860,0.23748246}, {1870,0.26012281}, {1880,0.24713158}, {1890,0.25001754}, {1900,0.26029825}, {1910,0.26786842}, {1920,0.23552632}, {1930,0.25243860}, {1940,0.25732456}, {1950,0.27492982}, {1960,0.26123684}, {1970,0.26949123}, {1980,0.27687719}, {1990,0.26429825}, {2000,0.25798246}, {2050,0.25395614}, {2100,0.27914912}, {2150,0.29271053}, {2200,0.29259649}, {2250,0.30678947}, {2300,0.32863158}, {2350,0.33386842}, {2400,0.31324561}, {2450,0.32835088}, {2500,0.33476316}, {2550,0.37559649}, {2600,0.34755263}, {2650,0.37185088}, {2700,0.36486842}, {2750,0.40558772}, {2800,0.39084211}, {2850,0.38733333}, {2900,0.39569298}, {2950,0.40773684}, {3000,0.42347368}, {3050,0.43844737}, {3100,0.43005263}, {3150,0.44164912}, {3200,0.41032456}, {3250,0.44893860}, {3300,0.45700877}, {3350,0.46166667}, {3400,0.45459649}, {3450,0.51014035}, {3500,0.50002632}, {3550,0.53783333}, {3600,0.47541228}, {3650,0.49412281}, {3700,0.53182456}, {3750,0.53224561}, {3800,0.54135088}, {3850,0.53549123}, {3900,0.57350000}, {3950,0.60203509}, {4000,0.60939474}, {4050,0.58641228}, {4100,0.54428947}, {4150,0.59650877}, {4200,0.58557895}, {4250,0.62372807}, {4300,0.61628070}, {4350,0.67542982}, {4400,0.61300877}, {4450,0.63007018}, {4500,0.64165789}, {4550,0.66437719}, {4600,0.69704386}, {4650,0.66729825}, {4700,0.69361404}, {4750,0.69947368}, {4800,0.66355263}, {4850,0.74473684}, {4900,0.69786842}, {4950,0.75289474}, {5000,0.70283333}, {5050,0.79071053}, {5100,0.79740351}, {5150,0.75859649}, {5200,0.71493860}, {5250,0.72978070}, {5300,0.77593860}, {5350,0.81947368}, {5400,0.77278070}, {5450,0.80190351}, {5500,0.86046491}, {5550,0.86767544}, {5600,0.81817544}, {5650,0.80792105}, {5700,0.82060526}, {5750,0.90504386}, {5800,0.85064035}, {5850,0.92868421}, {5900,0.86278070}, {5950,0.95446491}, {6000,0.89868421}, {6050,0.940500}, {6100,0.960214}, {6150,0.886071}, {6200,0.913286}, {6250,0.955357}, {6300,0.962214}, {6350,1.001786}, {6400,0.877714}, {6450,0.979857}, {6500,0.987214}, {6550,1.026714}, {6600,1.001786}, {6650,1.099857}, {6700,1.017857}, {6750,1.076000}, {6800,0.989071}, {6850,1.028000}, {6900,1.102929}, {6950,1.079714}, {7000,1.085143}, {7050,1.089786}, {7100,1.174071}, {7150,1.208786}, {7200,1.021000}, {7250,1.088286}, {7300,1.050500}, {7350,1.176643}, {7400,1.148429}, {7450,1.151429}, {7500,1.150500}, {7550,1.282000}, {7600,1.168714}, {7650,1.203571}, {7700,1.148071}, {7750,1.181714}, {7800,1.236857}, {7850,1.239429}, {7900,1.292214}, {7950,1.245429}, {8000,1.166929}, {8050,1.307571}, {8100,1.269571}, {8150,1.375643}, {8200,1.140357}, {8250,1.285500}, {8300,1.598000}, {8350,1.342286}, {8400,1.262286}, {8450,1.220429}, {8500,1.315643}, {8550,1.371286}, {8600,1.346071}, {8650,1.382143}, {8700,1.487786}, {8750,1.415071}, {8800,1.321786}, {8850,1.361786}, {8900,1.382429}, {8950,1.537286}, {9000,1.387429}, {9050,1.488357}, {9100,1.441786}, {9150,1.615357}, {9200,1.515714}, {9250,1.379929}, {9300,1.442214}, {9350,1.431857}, {9400,1.495786}, {9450,1.563714}, {9500,1.515286}, {9550,1.553786}, {9600,1.426714}, {9650,1.580643}, {9700,1.580857}, {9750,1.555000}, {9800,1.511714}, {9850,1.664857}, {9900,1.609000}, {9950,1.722214}, {10000,1.529286}, {10100,1.675429}, {10200,1.712214}, {10300,1.649714}, {10400,1.548143}, {10500,1.544929}, {10600,1.687143}, {10700,1.773714}, {10800,1.659643}, {10900,1.719571}, {11000,1.879286}, {11100,1.856786}, {11200,1.751786}, {11300,1.724857}, {11400,1.736143}, {11500,1.958500}, {11600,1.835357}, {11700,1.967286}, {11800,1.868786}, {11900,2.074357}, {12000,1.938857}, {12100,1.964357}, {12200,2.038214}, {12300,1.857071}, {12400,1.933214}, {12500,2.021143}, {12600,2.026571}, {12700,2.122571}, {12800,1.846429}, {12900,2.064500}, {13000,2.091786}, {13100,2.161000}, {13200,2.086500}, {13300,2.369071}, {13400,2.140714}, {13500,2.328286}, {13600,2.084071}, {13700,2.184214}, {13800,2.371643}, {13900,2.279857}, {14000,2.292357}, {14100,2.319714}, {14200,2.471643}, {14300,2.549286}, {14400,2.133643}, {14500,2.328857}, {14600,2.246071}, {14700,2.530571}, {14800,2.462214}, {14900,2.459643}, {15000,2.477929}, {15100,2.744714}, {15200,2.486214}, {15300,2.567429}, {15400,2.422357}, {15500,2.547214}, {15600,2.662286}, {15700,2.679929}, {15800,2.763857}, {15900,2.677429}, {16000,2.512071}, {16100,2.785786}, {16200,2.708286}, {16300,2.914643}, {16400,2.428143}, {16500,2.759929}, {16600,2.756143}, {16700,2.847500}, {16800,2.691357}, {16900,2.569786}, {17000,2.797929}, {17100,2.924357}, {17200,2.844500}, {17300,2.905500}, {17400,3.147071}, {17500,2.995714}, {17600,2.795571}, {17700,2.872643}, {17800,2.924143}, {17900,3.242071}, {18000,2.930786}, {18100,3.179714}, {18200,3.107643}, {18300,3.407571}, {18400,3.178429}, {18500,2.913857}, {18600,3.034714}, {18700,3.026286}, {18800,3.157786}, {18900,3.290143}, {19000,3.185571}, {19100,3.332500}, {19200,3.001286}, {19300,3.357143}, {19400,3.343500}, {19500,3.305286}, {19600,3.186286}, {19700,3.580643}, {19800,3.456571}, {19900,3.672500}, {20000,3.263500}};
data["big_flat"]["TypeClassesBodyHOAS"]["actual reif"]["user"] = {{1,0.00010526}, {2,0.00028070}, {3,0.00011404}, {4,0.00041228}, {5,0.00034211}, {6,0.00025439}, {7,0.00047368}, {8,0.00048246}, {9,0.00057018}, {10,0.00059649}, {11,0.00081579}, {12,0.00083333}, {13,0.00096491}, {14,0.00120175}, {15,0.00094737}, {16,0.00097368}, {17,0.00137719}, {18,0.00159649}, {19,0.00139474}, {20,0.00145614}, {21,0.00165789}, {22,0.00162281}, {23,0.00183333}, {24,0.00178947}, {25,0.00202632}, {26,0.00208772}, {27,0.00211404}, {28,0.00207895}, {29,0.00221053}, {30,0.00229825}, {31,0.00246491}, {32,0.00257895}, {33,0.00288596}, {34,0.00245614}, {35,0.00283333}, {36,0.00300877}, {37,0.00285965}, {38,0.00312281}, {39,0.00307895}, {40,0.00325439}, {41,0.00321053}, {42,0.00462281}, {43,0.00344737}, {44,0.00369298}, {45,0.00370175}, {46,0.00386842}, {47,0.00409649}, {48,0.00382456}, {49,0.00398246}, {50,0.00433333}, {51,0.00436842}, {52,0.00422807}, {53,0.00478947}, {54,0.00447368}, {55,0.00493860}, {56,0.00412281}, {57,0.00464912}, {58,0.00575439}, {59,0.00505263}, {60,0.00497368}, {61,0.00542105}, {62,0.00550877}, {63,0.00561404}, {64,0.00535965}, {65,0.00561404}, {66,0.00571930}, {67,0.00567544}, {68,0.00562281}, {69,0.00586842}, {70,0.00742105}, {71,0.00619298}, {72,0.00621930}, {73,0.00634211}, {74,0.00645614}, {75,0.00655263}, {76,0.00652632}, {77,0.00679825}, {78,0.00714035}, {79,0.00754386}, {80,0.00720175}, {81,0.00713158}, {82,0.00725439}, {83,0.00735965}, {84,0.00737719}, {85,0.00752632}, {86,0.00769298}, {87,0.00814035}, {88,0.00771053}, {89,0.00818421}, {90,0.00967544}, {91,0.00878947}, {92,0.00860526}, {93,0.00907895}, {94,0.00907018}, {95,0.00920175}, {96,0.00812281}, {97,0.00885965}, {98,0.01082456}, {99,0.00920175}, {100,0.00932456}, {101,0.01016667}, {102,0.00978070}, {103,0.01050000}, {104,0.00957895}, {105,0.01017544}, {106,0.01140351}, {107,0.01032456}, {108,0.01003509}, {109,0.01075439}, {110,0.01109649}, {111,0.01124561}, {112,0.01064035}, {113,0.01064035}, {114,0.01029825}, {115,0.01152632}, {116,0.01064912}, {117,0.01165789}, {118,0.01154386}, {119,0.01214035}, {120,0.01322807}, {121,0.01175439}, {122,0.01213158}, {123,0.01245614}, {124,0.01215789}, {125,0.01264912}, {126,0.01278070}, {127,0.01399123}, {128,0.01174561}, {129,0.01253509}, {130,0.01245614}, {131,0.01328947}, {132,0.01307018}, {133,0.01493860}, {134,0.01318421}, {135,0.01366667}, {136,0.01306140}, {137,0.01333333}, {138,0.01357018}, {139,0.01523684}, {140,0.01379825}, {141,0.01448246}, {142,0.01443860}, {143,0.01489474}, {144,0.01583333}, {145,0.01417544}, {146,0.01429825}, {147,0.01482456}, {148,0.01452632}, {149,0.01512281}, {150,0.01602632}, {151,0.01571930}, {152,0.01509649}, {153,0.01530702}, {154,0.01548246}, {155,0.01754386}, {156,0.01557018}, {157,0.01599123}, {158,0.01605263}, {159,0.01691228}, {160,0.01610526}, {161,0.01592982}, {162,0.01590351}, {163,0.01618421}, {164,0.01603509}, {165,0.01810526}, {166,0.01624561}, {167,0.01700877}, {168,0.01630702}, {169,0.01673684}, {170,0.01777193}, {171,0.01738596}, {172,0.01741228}, {173,0.01785088}, {174,0.02110526}, {175,0.01821053}, {176,0.01672807}, {177,0.01759649}, {178,0.01764035}, {179,0.01907018}, {180,0.01782456}, {181,0.01850877}, {182,0.01857018}, {183,0.02175439}, {184,0.01791228}, {185,0.01849123}, {186,0.01893860}, {187,0.02262281}, {188,0.01865789}, {189,0.01975439}, {190,0.01957895}, {191,0.02326316}, {192,0.01785965}, {193,0.01845614}, {194,0.01872807}, {195,0.02217544}, {196,0.01892982}, {197,0.01980702}, {198,0.02002632}, {199,0.02356140}, {200,0.01900877}, {201,0.02016667}, {202,0.02023684}, {203,0.02416667}, {204,0.02002632}, {205,0.02091228}, {206,0.02098246}, {207,0.02456140}, {208,0.01998246}, {209,0.02153509}, {210,0.02087719}, {211,0.02406140}, {212,0.02091228}, {213,0.02247368}, {214,0.02235088}, {215,0.02485088}, {216,0.02169298}, {217,0.02310526}, {218,0.02635965}, {219,0.02318421}, {220,0.02296491}, {221,0.02381579}, {222,0.02484211}, {223,0.02497368}, {224,0.02225439}, {225,0.02586842}, {226,0.02277193}, {227,0.02422807}, {228,0.02304386}, {229,0.02523684}, {230,0.02421053}, {231,0.02501754}, {232,0.02643860}, {233,0.02447368}, {234,0.02443860}, {235,0.02521930}, {236,0.02431579}, {237,0.02532456}, {238,0.02562281}, {239,0.02728947}, {240,0.02434211}, {241,0.02534211}, {242,0.02842105}, {243,0.02613158}, {244,0.02550000}, {245,0.02935965}, {246,0.02604386}, {247,0.02759649}, {248,0.02840351}, {249,0.02664035}, {250,0.02628070}, {251,0.03086842}, {252,0.02632456}, {253,0.02834211}, {254,0.03069298}, {255,0.02887719}, {256,0.02520175}, {257,0.02911404}, {258,0.02576316}, {259,0.02767544}, {260,0.02634211}, {261,0.02742982}, {262,0.02732456}, {263,0.02880702}, {264,0.02627193}, {265,0.02826316}, {266,0.02784211}, {267,0.02867544}, {268,0.02753509}, {269,0.03146491}, {270,0.02852632}, {271,0.02950877}, {272,0.03000000}, {273,0.02794737}, {274,0.02844737}, {275,0.03159649}, {276,0.02821930}, {277,0.02960526}, {278,0.03174561}, {279,0.03052632}, {280,0.02863158}, {281,0.03142105}, {282,0.03002632}, {283,0.03675439}, {284,0.02961404}, {285,0.03121053}, {286,0.03374561}, {287,0.03226316}, {288,0.02857018}, {289,0.03177193}, {290,0.03002632}, {291,0.03114035}, {292,0.02939474}, {293,0.03154386}, {294,0.03435088}, {295,0.03195614}, {296,0.03013158}, {297,0.03363158}, {298,0.03215789}, {299,0.03807018}, {300,0.03039474}, {301,0.03282456}, {302,0.03558772}, {303,0.03514912}, {304,0.03570175}, {305,0.03163158}, {306,0.03234211}, {307,0.03600877}, {308,0.03255263}, {309,0.03414035}, {310,0.03303509}, {311,0.03528947}, {312,0.03491228}, {313,0.03442982}, {314,0.03894737}, {315,0.03543860}, {316,0.03452632}, {317,0.03730702}, {318,0.03581579}, {319,0.04158772}, {320,0.03171053}, {321,0.03371930}, {322,0.03347368}, {323,0.03468421}, {324,0.03571930}, {325,0.03506140}, {326,0.03942982}, {327,0.03602632}, {328,0.03384211}, {329,0.03697368}, {330,0.03545614}, {331,0.04091228}, {332,0.03516667}, {333,0.04107018}, {334,0.03684211}, {335,0.03827193}, {336,0.03541228}, {337,0.03612281}, {338,0.04057018}, {339,0.03757018}, {340,0.04007018}, {341,0.03728070}, {342,0.03782456}, {343,0.03856140}, {344,0.03634211}, {345,0.03881579}, {346,0.03827193}, {347,0.04368421}, {348,0.03860526}, {349,0.04327193}, {350,0.03896491}, {351,0.04440351}, {352,0.03592105}, {353,0.04143860}, {354,0.03727193}, {355,0.03907018}, {356,0.03861404}, {357,0.03919298}, {358,0.04043860}, {359,0.04107895}, {360,0.04134211}, {361,0.03964912}, {362,0.04352632}, {363,0.04065789}, {364,0.04314035}, {365,0.04142982}, {366,0.04478947}, {367,0.04182456}, {368,0.04120175}, {369,0.04021053}, {370,0.04400877}, {371,0.04129825}, {372,0.04352632}, {373,0.04184211}, {374,0.04522807}, {375,0.04250877}, {376,0.04417544}, {377,0.04149123}, {378,0.04574561}, {379,0.04333333}, {380,0.04595614}, {381,0.04323684}, {382,0.04735088}, {383,0.04572807}, {384,0.04106140}, {385,0.03994737}, {386,0.04354386}, {387,0.04158772}, {388,0.04369298}, {389,0.04164912}, {390,0.04462281}, {391,0.04325439}, {392,0.04370175}, {393,0.04204386}, {394,0.04741228}, {395,0.04385965}, {396,0.04528947}, {397,0.04391228}, {398,0.04714912}, {399,0.04608772}, {400,0.04430702}, {401,0.04253509}, {402,0.04704386}, {403,0.04446491}, {404,0.04688596}, {405,0.04488596}, {406,0.04868421}, {407,0.05378070}, {408,0.04278070}, {409,0.04905263}, {410,0.04518421}, {411,0.05012281}, {412,0.04544737}, {413,0.05033333}, {414,0.04742105}, {415,0.05157018}, {416,0.04276316}, {417,0.04770175}, {418,0.04554386}, {419,0.04616667}, {420,0.04964912}, {421,0.04580702}, {422,0.05064035}, {423,0.04859649}, {424,0.04835088}, {425,0.04769298}, {426,0.04970175}, {427,0.04899123}, {428,0.04704386}, {429,0.05152632}, {430,0.04907018}, {431,0.05403509}, {432,0.04592982}, {433,0.05087719}, {434,0.05544737}, {435,0.04892982}, {436,0.05117544}, {437,0.04980702}, {438,0.05204386}, {439,0.05107895}, {440,0.04817544}, {441,0.05400000}, {442,0.04984211}, {443,0.05465789}, {444,0.05036842}, {445,0.05486842}, {446,0.06030702}, {447,0.05404386}, {448,0.04965789}, {449,0.04794737}, {450,0.05065789}, {451,0.05712281}, {452,0.04821053}, {453,0.05310526}, {454,0.05093860}, {455,0.05436842}, {456,0.05572807}, {457,0.04978947}, {458,0.05430702}, {459,0.05192105}, {460,0.05321053}, {461,0.05998246}, {462,0.05197368}, {463,0.05743860}, {464,0.04975439}, {465,0.05393860}, {466,0.05857018}, {467,0.05235965}, {468,0.05371053}, {469,0.06053509}, {470,0.05259649}, {471,0.05818421}, {472,0.05146491}, {473,0.05576316}, {474,0.06177193}, {475,0.05556140}, {476,0.05608772}, {477,0.06301754}, {478,0.05494737}, {479,0.06039474}, {480,0.05780702}, {481,0.05234211}, {482,0.05518421}, {483,0.05507895}, {484,0.05262281}, {485,0.05793860}, {486,0.05483333}, {487,0.05914912}, {488,0.06057018}, {489,0.05475439}, {490,0.05695614}, {491,0.06471053}, {492,0.05525439}, {493,0.05950000}, {494,0.06441228}, {495,0.05950877}, {496,0.05497368}, {497,0.06360526}, {498,0.05496491}, {499,0.06018421}, {500,0.06364912}, {505,0.05834211}, {510,0.06057895}, {515,0.05967544}, {520,0.05558772}, {525,0.05935088}, {530,0.06076316}, {535,0.07056140}, {540,0.06072807}, {545,0.06171930}, {550,0.06957018}, {555,0.06428947}, {560,0.06085965}, {565,0.06829825}, {570,0.07325439}, {575,0.07775439}, {580,0.06255263}, {585,0.06741228}, {590,0.07565789}, {595,0.07574561}, {600,0.07371930}, {605,0.07206140}, {610,0.06939474}, {615,0.08012281}, {620,0.07763158}, {625,0.07799123}, {630,0.08111404}, {635,0.07699123}, {640,0.06727193}, {645,0.07409649}, {650,0.07930702}, {655,0.08594737}, {660,0.08047368}, {665,0.08446491}, {670,0.08763158}, {675,0.08592982}, {680,0.07599123}, {685,0.08129825}, {690,0.07971053}, {695,0.09209649}, {700,0.09214912}, {705,0.08728947}, {710,0.08895614}, {715,0.09297368}, {720,0.08766667}, {725,0.09407895}, {730,0.09451754}, {735,0.10052632}, {740,0.09221053}, {745,0.09535965}, {750,0.09773684}, {755,0.09876316}, {760,0.09609649}, {765,0.10265789}, {770,0.09014035}, {775,0.09775439}, {780,0.09474561}, {785,0.09537719}, {790,0.09852632}, {795,0.10171053}, {800,0.09414035}, {805,0.09974561}, {810,0.10066667}, {815,0.10757018}, {820,0.10170175}, {825,0.10591228}, {830,0.10934211}, {835,0.10347368}, {840,0.10035088}, {845,0.10761404}, {850,0.10512281}, {855,0.11186842}, {860,0.10976316}, {865,0.10626316}, {870,0.11129825}, {875,0.11442105}, {880,0.10761404}, {885,0.11569298}, {890,0.11487719}, {895,0.12485088}, {900,0.11314912}, {905,0.11208772}, {910,0.11482456}, {915,0.11556140}, {920,0.11924561}, {925,0.11938596}, {930,0.11299123}, {935,0.12169298}, {940,0.11852632}, {945,0.11858772}, {950,0.12330702}, {955,0.12623684}, {960,0.11300877}, {965,0.12136842}, {970,0.12863158}, {975,0.12959649}, {980,0.14624561}, {985,0.12740351}, {990,0.13015789}, {995,0.13489474}, {1000,0.12500000}, {1010,0.12964035}, {1020,0.13404386}, {1030,0.12579825}, {1040,0.12319298}, {1050,0.13142105}, {1060,0.13502632}, {1070,0.13628070}, {1080,0.14065789}, {1090,0.13082456}, {1100,0.14278070}, {1110,0.14163158}, {1120,0.14298246}, {1130,0.14407018}, {1140,0.15165789}, {1150,0.15472807}, {1160,0.13966667}, {1170,0.15197368}, {1180,0.15074561}, {1190,0.15914912}, {1200,0.15547368}, {1210,0.15791228}, {1220,0.15767544}, {1230,0.16707018}, {1240,0.15680702}, {1250,0.15749123}, {1260,0.17059649}, {1270,0.17463158}, {1280,0.16834211}, {1290,0.24030702}, {1300,0.16742105}, {1310,0.17864035}, {1320,0.16913158}, {1330,0.86186842}, {1340,0.18310526}, {1350,0.17206140}, {1360,0.16836842}, {1370,0.18775439}, {1380,0.18116667}, {1390,0.19080702}, {1400,0.18686842}, {1410,0.17816667}, {1420,0.18386842}, {1430,0.19173684}, {1440,0.18142105}, {1450,0.19277193}, {1460,0.19346491}, {1470,0.20642105}, {1480,0.18501754}, {1490,0.19963158}, {1500,0.20316667}, {1510,0.20475439}, {1520,0.19880702}, {1530,0.21300877}, {1540,0.19264912}, {1550,0.20298246}, {1560,0.19730702}, {1570,0.19885965}, {1580,0.20654386}, {1590,0.21380702}, {1600,0.19850877}, {1610,0.20800000}, {1620,0.20854386}, {1630,0.23003509}, {1640,0.21128947}, {1650,0.21983333}, {1660,0.23354386}, {1670,0.21662281}, {1680,0.21055263}, {1690,0.22544737}, {1700,0.21685965}, {1710,0.23961404}, {1720,0.22580702}, {1730,0.22129825}, {1740,0.23047368}, {1750,0.24360526}, {1760,0.22550877}, {1770,0.24445614}, {1780,0.24325439}, {1790,0.26589474}, {1800,0.22677193}, {1810,0.23212281}, {1820,0.24669298}, {1830,0.24002632}, {1840,0.24128070}, {1850,0.24911404}, {1860,0.23695614}, {1870,0.25967544}, {1880,0.24666667}, {1890,0.24957895}, {1900,0.25994737}, {1910,0.26735965}, {1920,0.23492982}, {1930,0.25213158}, {1940,0.25685088}, {1950,0.27422807}, {1960,0.26108772}, {1970,0.26898246}, {1980,0.27613158}, {1990,0.26365789}, {2000,0.25738596}, {2050,0.25361404}, {2100,0.27835965}, {2150,0.29167544}, {2200,0.29175439}, {2250,0.30583333}, {2300,0.32768421}, {2350,0.33266667}, {2400,0.31242105}, {2450,0.32721930}, {2500,0.33385965}, {2550,0.37461404}, {2600,0.34665789}, {2650,0.37083333}, {2700,0.36426316}, {2750,0.40453509}, {2800,0.38999123}, {2850,0.38637719}, {2900,0.39488596}, {2950,0.40699123}, {3000,0.42273684}, {3050,0.43764912}, {3100,0.42928947}, {3150,0.44033333}, {3200,0.40914912}, {3250,0.44807018}, {3300,0.45645614}, {3350,0.46071930}, {3400,0.45370175}, {3450,0.50862281}, {3500,0.49858772}, {3550,0.53650000}, {3600,0.47432456}, {3650,0.49286842}, {3700,0.53050000}, {3750,0.53096491}, {3800,0.54029825}, {3850,0.53505263}, {3900,0.57228947}, {3950,0.60110526}, {4000,0.60867544}, {4050,0.58555263}, {4100,0.54340351}, {4150,0.59514912}, {4200,0.58463158}, {4250,0.62256140}, {4300,0.61509649}, {4350,0.67413158}, {4400,0.61149123}, {4450,0.62862281}, {4500,0.64011404}, {4550,0.66315789}, {4600,0.69603509}, {4650,0.66591228}, {4700,0.69226316}, {4750,0.69810526}, {4800,0.66276316}, {4850,0.74339474}, {4900,0.69654386}, {4950,0.75164035}, {5000,0.70135088}, {5050,0.78942105}, {5100,0.79623684}, {5150,0.75747368}, {5200,0.71375439}, {5250,0.72843860}, {5300,0.77479825}, {5350,0.81795614}, {5400,0.77154386}, {5450,0.80052632}, {5500,0.85885965}, {5550,0.86591228}, {5600,0.81671053}, {5650,0.80641228}, {5700,0.81938596}, {5750,0.90307895}, {5800,0.84907895}, {5850,0.92724561}, {5900,0.86093860}, {5950,0.95257018}, {6000,0.89687719}, {6050,0.935071}, {6100,0.951857}, {6150,0.878357}, {6200,0.906071}, {6250,0.947286}, {6300,0.958143}, {6350,0.999786}, {6400,0.875286}, {6450,0.977429}, {6500,0.984929}, {6550,1.024500}, {6600,0.999857}, {6650,1.098500}, {6700,1.015857}, {6750,1.073857}, {6800,0.987929}, {6850,1.026571}, {6900,1.099929}, {6950,1.076500}, {7000,1.082429}, {7050,1.087857}, {7100,1.171643}, {7150,1.205929}, {7200,1.018286}, {7250,1.086643}, {7300,1.047857}, {7350,1.174071}, {7400,1.146714}, {7450,1.149571}, {7500,1.148857}, {7550,1.280071}, {7600,1.167643}, {7650,1.201571}, {7700,1.146286}, {7750,1.178857}, {7800,1.234857}, {7850,1.238000}, {7900,1.289643}, {7950,1.243857}, {8000,1.165286}, {8050,1.305857}, {8100,1.267857}, {8150,1.373143}, {8200,1.139500}, {8250,1.284429}, {8300,1.594214}, {8350,1.339500}, {8400,1.260000}, {8450,1.219643}, {8500,1.314143}, {8550,1.368929}, {8600,1.342786}, {8650,1.380143}, {8700,1.485000}, {8750,1.411643}, {8800,1.318857}, {8850,1.358357}, {8900,1.379929}, {8950,1.535000}, {9000,1.385286}, {9050,1.486714}, {9100,1.439357}, {9150,1.612286}, {9200,1.513429}, {9250,1.378643}, {9300,1.440214}, {9350,1.429000}, {9400,1.494214}, {9450,1.561571}, {9500,1.514286}, {9550,1.551000}, {9600,1.424357}, {9650,1.577643}, {9700,1.578571}, {9750,1.551929}, {9800,1.508714}, {9850,1.662786}, {9900,1.606786}, {9950,1.719714}, {10000,1.526714}, {10100,1.672714}, {10200,1.709714}, {10300,1.647071}, {10400,1.545500}, {10500,1.543571}, {10600,1.685500}, {10700,1.771571}, {10800,1.658071}, {10900,1.718214}, {11000,1.876143}, {11100,1.854857}, {11200,1.749429}, {11300,1.722357}, {11400,1.734500}, {11500,1.955500}, {11600,1.833571}, {11700,1.965071}, {11800,1.867000}, {11900,2.071786}, {12000,1.937000}, {12100,1.962500}, {12200,2.034786}, {12300,1.854429}, {12400,1.931286}, {12500,2.017857}, {12600,2.024143}, {12700,2.120643}, {12800,1.844214}, {12900,2.062643}, {13000,2.089643}, {13100,2.159214}, {13200,2.083857}, {13300,2.367000}, {13400,2.138214}, {13500,2.325643}, {13600,2.081571}, {13700,2.182286}, {13800,2.368786}, {13900,2.276786}, {14000,2.289857}, {14100,2.317500}, {14200,2.468786}, {14300,2.546429}, {14400,2.131143}, {14500,2.325929}, {14600,2.240929}, {14700,2.514929}, {14800,2.448143}, {14900,2.453143}, {15000,2.474286}, {15100,2.741929}, {15200,2.483429}, {15300,2.564286}, {15400,2.419429}, {15500,2.544286}, {15600,2.659714}, {15700,2.676571}, {15800,2.761286}, {15900,2.674786}, {16000,2.508643}, {16100,2.782429}, {16200,2.705357}, {16300,2.911714}, {16400,2.425286}, {16500,2.756500}, {16600,2.752357}, {16700,2.844214}, {16800,2.689143}, {16900,2.564714}, {17000,2.795714}, {17100,2.921000}, {17200,2.842643}, {17300,2.902714}, {17400,3.144500}, {17500,2.992143}, {17600,2.793143}, {17700,2.869286}, {17800,2.921000}, {17900,3.236929}, {18000,2.926643}, {18100,3.175286}, {18200,3.102786}, {18300,3.403286}, {18400,3.173929}, {18500,2.910714}, {18600,3.029857}, {18700,3.021643}, {18800,3.152929}, {18900,3.286429}, {19000,3.181357}, {19100,3.327857}, {19200,2.997000}, {19300,3.352214}, {19400,3.338357}, {19500,3.300143}, {19600,3.181714}, {19700,3.575357}, {19800,3.450786}, {19900,3.666286}, {20000,3.248786}};
data["big_flat"]["TypeClassesBodyHOAS"]["actual reif"]["system"] = {{1,0.00000000}, {2,0.00007018}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00002632}, {12,0.00000000}, {13,0.00000000}, {14,0.00003509}, {15,0.00007018}, {16,0.00003509}, {17,0.00002632}, {18,0.00000000}, {19,0.00000000}, {20,0.00003509}, {21,0.00003509}, {22,0.00002632}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00003509}, {28,0.00003509}, {29,0.00003509}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00007018}, {35,0.00000000}, {36,0.00003509}, {37,0.00007018}, {38,0.00000000}, {39,0.00003509}, {40,0.00010526}, {41,0.00003509}, {42,0.00003509}, {43,0.00007018}, {44,0.00003509}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00007018}, {49,0.00003509}, {50,0.00002632}, {51,0.00000000}, {52,0.00003509}, {53,0.00002632}, {54,0.00003509}, {55,0.00003509}, {56,0.00010526}, {57,0.00010526}, {58,0.00003509}, {59,0.00003509}, {60,0.00007018}, {61,0.00000000}, {62,0.00003509}, {63,0.00006140}, {64,0.00002632}, {65,0.00003509}, {66,0.00000000}, {67,0.00000000}, {68,0.00010526}, {69,0.00003509}, {70,0.00000000}, {71,0.00003509}, {72,0.00003509}, {73,0.00003509}, {74,0.00000000}, {75,0.00010526}, {76,0.00003509}, {77,0.00009649}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00003509}, {82,0.00000000}, {83,0.00007018}, {84,0.00003509}, {85,0.00003509}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00003509}, {90,0.00000000}, {91,0.00000000}, {92,0.00007018}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00007018}, {97,0.00007018}, {98,0.00007018}, {99,0.00000000}, {100,0.00002632}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003509}, {105,0.00003509}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00007018}, {117,0.00000000}, {118,0.00006140}, {119,0.00000000}, {120,0.00006140}, {121,0.00003509}, {122,0.00000000}, {123,0.00007018}, {124,0.00003509}, {125,0.00003509}, {126,0.00000000}, {127,0.00003509}, {128,0.00003509}, {129,0.00003509}, {130,0.00000000}, {131,0.00003509}, {132,0.00000000}, {133,0.00003509}, {134,0.00003509}, {135,0.00000000}, {136,0.00007018}, {137,0.00003509}, {138,0.00000000}, {139,0.00003509}, {140,0.00003509}, {141,0.00006140}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00003509}, {149,0.00003509}, {150,0.00003509}, {151,0.00006140}, {152,0.00003509}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00003509}, {159,0.00013158}, {160,0.00000000}, {161,0.00007018}, {162,0.00003509}, {163,0.00003509}, {164,0.00000000}, {165,0.00003509}, {166,0.00007018}, {167,0.00007018}, {168,0.00003509}, {169,0.00007018}, {170,0.00000000}, {171,0.00003509}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00003509}, {177,0.00003509}, {178,0.00010526}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00010526}, {185,0.00000000}, {186,0.00003509}, {187,0.00000000}, {188,0.00000000}, {189,0.00003509}, {190,0.00003509}, {191,0.00007018}, {192,0.00000000}, {193,0.00003509}, {194,0.00000000}, {195,0.00003509}, {196,0.00003509}, {197,0.00003509}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00003509}, {203,0.00003509}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00007018}, {208,0.00003509}, {209,0.00000000}, {210,0.00003509}, {211,0.00000000}, {212,0.00000000}, {213,0.00003509}, {214,0.00000000}, {215,0.00003509}, {216,0.00000000}, {217,0.00000000}, {218,0.00007018}, {219,0.00007018}, {220,0.00007018}, {221,0.00002632}, {222,0.00002632}, {223,0.00000000}, {224,0.00007018}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00007018}, {231,0.00003509}, {232,0.00000000}, {233,0.00007018}, {234,0.00000000}, {235,0.00000000}, {236,0.00003509}, {237,0.00000000}, {238,0.00003509}, {239,0.00007018}, {240,0.00007018}, {241,0.00000000}, {242,0.00003509}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00003509}, {247,0.00007018}, {248,0.00000000}, {249,0.00003509}, {250,0.00003509}, {251,0.00000000}, {252,0.00003509}, {253,0.00003509}, {254,0.00006140}, {255,0.00000000}, {256,0.00000000}, {257,0.00003509}, {258,0.00000000}, {259,0.00000000}, {260,0.00003509}, {261,0.00003509}, {262,0.00002632}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00003509}, {267,0.00007018}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00002632}, {272,0.00003509}, {273,0.00000000}, {274,0.00000000}, {275,0.00003509}, {276,0.00007018}, {277,0.00003509}, {278,0.00000000}, {279,0.00000000}, {280,0.00009649}, {281,0.00003509}, {282,0.00000000}, {283,0.00000000}, {284,0.00003509}, {285,0.00003509}, {286,0.00000000}, {287,0.00003509}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00009649}, {294,0.00003509}, {295,0.00003509}, {296,0.00000000}, {297,0.00003509}, {298,0.00000000}, {299,0.00010526}, {300,0.00003509}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00003509}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00007018}, {311,0.00000000}, {312,0.00000000}, {313,0.00003509}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00003509}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00003509}, {325,0.00003509}, {326,0.00000000}, {327,0.00000000}, {328,0.00003509}, {329,0.00000000}, {330,0.00003509}, {331,0.00000000}, {332,0.00000000}, {333,0.00010526}, {334,0.00000000}, {335,0.00003509}, {336,0.00003509}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00003509}, {345,0.00003509}, {346,0.00000000}, {347,0.00007018}, {348,0.00007018}, {349,0.00003509}, {350,0.00003509}, {351,0.00003509}, {352,0.00003509}, {353,0.00000000}, {354,0.00003509}, {355,0.00003509}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00003509}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00007018}, {369,0.00003509}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00003509}, {377,0.00007018}, {378,0.00003509}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00003509}, {383,0.00006140}, {384,0.00000000}, {385,0.00003509}, {386,0.00000000}, {387,0.00003509}, {388,0.00007018}, {389,0.00000000}, {390,0.00003509}, {391,0.00000000}, {392,0.00010526}, {393,0.00002632}, {394,0.00003509}, {395,0.00000000}, {396,0.00007018}, {397,0.00003509}, {398,0.00007018}, {399,0.00003509}, {400,0.00000000}, {401,0.00010526}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00003509}, {408,0.00007018}, {409,0.00003509}, {410,0.00000000}, {411,0.00000000}, {412,0.00002632}, {413,0.00007018}, {414,0.00002632}, {415,0.00000000}, {416,0.00003509}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00007018}, {421,0.00000000}, {422,0.00014035}, {423,0.00003509}, {424,0.00007018}, {425,0.00000000}, {426,0.00007018}, {427,0.00000000}, {428,0.00000000}, {429,0.00014035}, {430,0.00000000}, {431,0.00006140}, {432,0.00003509}, {433,0.00007018}, {434,0.00010526}, {435,0.00000000}, {436,0.00010526}, {437,0.00000000}, {438,0.00024561}, {439,0.00000000}, {440,0.00002632}, {441,0.00020175}, {442,0.00000000}, {443,0.00016667}, {444,0.00000000}, {445,0.00010526}, {446,0.00021053}, {447,0.00003509}, {448,0.00017544}, {449,0.00000000}, {450,0.00010526}, {451,0.00056140}, {452,0.00000000}, {453,0.00014035}, {454,0.00000000}, {455,0.00010526}, {456,0.00036842}, {457,0.00007018}, {458,0.00017544}, {459,0.00003509}, {460,0.00014035}, {461,0.00047368}, {462,0.00000000}, {463,0.00016667}, {464,0.00003509}, {465,0.00021053}, {466,0.00037719}, {467,0.00000000}, {468,0.00017544}, {469,0.00031579}, {470,0.00003509}, {471,0.00021053}, {472,0.00003509}, {473,0.00010526}, {474,0.00035088}, {475,0.00000000}, {476,0.00003509}, {477,0.00034211}, {478,0.00003509}, {479,0.00024561}, {480,0.00038596}, {481,0.00000000}, {482,0.00030702}, {483,0.00000000}, {484,0.00000000}, {485,0.00034211}, {486,0.00003509}, {487,0.00007018}, {488,0.00034211}, {489,0.00003509}, {490,0.00017544}, {491,0.00049123}, {492,0.00003509}, {493,0.00014035}, {494,0.00044737}, {495,0.00000000}, {496,0.00014035}, {497,0.00041228}, {498,0.00002632}, {499,0.00007018}, {500,0.00037719}, {505,0.00000000}, {510,0.00000000}, {515,0.00007018}, {520,0.00000000}, {525,0.00003509}, {530,0.00014035}, {535,0.00045614}, {540,0.00000000}, {545,0.00010526}, {550,0.00051754}, {555,0.00003509}, {560,0.00000000}, {565,0.00007018}, {570,0.00038596}, {575,0.00031579}, {580,0.00000000}, {585,0.00021053}, {590,0.00038596}, {595,0.00049123}, {600,0.00041228}, {605,0.00000000}, {610,0.00017544}, {615,0.00031579}, {620,0.00030702}, {625,0.00007018}, {630,0.00014035}, {635,0.00000000}, {640,0.00003509}, {645,0.00014035}, {650,0.00010526}, {655,0.00026316}, {660,0.00024561}, {665,0.00020175}, {670,0.00059649}, {675,0.00036842}, {680,0.00000000}, {685,0.00003509}, {690,0.00002632}, {695,0.00059649}, {700,0.00037719}, {705,0.00063158}, {710,0.00041228}, {715,0.00042105}, {720,0.00047368}, {725,0.00028070}, {730,0.00061404}, {735,0.00049123}, {740,0.00047368}, {745,0.00062281}, {750,0.00059649}, {755,0.00056140}, {760,0.00058772}, {765,0.00072807}, {770,0.00065789}, {775,0.00078070}, {780,0.00065789}, {785,0.00080702}, {790,0.00059649}, {795,0.00073684}, {800,0.00062281}, {805,0.00069298}, {810,0.00058772}, {815,0.00091228}, {820,0.00061404}, {825,0.00069298}, {830,0.00084211}, {835,0.00063158}, {840,0.00080702}, {845,0.00057895}, {850,0.00062281}, {855,0.00072807}, {860,0.00076316}, {865,0.00066667}, {870,0.00057895}, {875,0.00062281}, {880,0.00062281}, {885,0.00062281}, {890,0.00075439}, {895,0.00041228}, {900,0.00105263}, {905,0.00045614}, {910,0.00044737}, {915,0.00055263}, {920,0.00083333}, {925,0.00066667}, {930,0.00037719}, {935,0.00048246}, {940,0.00072807}, {945,0.00056140}, {950,0.00044737}, {955,0.00059649}, {960,0.00048246}, {965,0.00044737}, {970,0.00087719}, {975,0.00063158}, {980,0.00044737}, {985,0.00052632}, {990,0.00049123}, {995,0.00097368}, {1000,0.00028070}, {1010,0.00042105}, {1020,0.00059649}, {1030,0.00052632}, {1040,0.00044737}, {1050,0.00050877}, {1060,0.00091228}, {1070,0.00051754}, {1080,0.00059649}, {1090,0.00063158}, {1100,0.00097368}, {1110,0.00042105}, {1120,0.00083333}, {1130,0.00056140}, {1140,0.00072807}, {1150,0.00049123}, {1160,0.00051754}, {1170,0.00063158}, {1180,0.00014035}, {1190,0.00003509}, {1200,0.00003509}, {1210,0.00003509}, {1220,0.00007018}, {1230,0.00000000}, {1240,0.00003509}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00003509}, {1280,0.00007018}, {1290,0.00007018}, {1300,0.00003509}, {1310,0.00003509}, {1320,0.00000000}, {1330,0.00091228}, {1340,0.00000000}, {1350,0.00003509}, {1360,0.00007018}, {1370,0.00003509}, {1380,0.00003509}, {1390,0.00003509}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00003509}, {1440,0.00003509}, {1450,0.00007018}, {1460,0.00010526}, {1470,0.00000000}, {1480,0.00003509}, {1490,0.00003509}, {1500,0.00003509}, {1510,0.00002632}, {1520,0.00007018}, {1530,0.00003509}, {1540,0.00003509}, {1550,0.00000000}, {1560,0.00003509}, {1570,0.00000000}, {1580,0.00014035}, {1590,0.00000000}, {1600,0.00003509}, {1610,0.00000000}, {1620,0.00010526}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00007018}, {1660,0.00007018}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00010526}, {1710,0.00003509}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00010526}, {1760,0.00000000}, {1770,0.00003509}, {1780,0.00003509}, {1790,0.00007018}, {1800,0.00009649}, {1810,0.00000000}, {1820,0.00013158}, {1830,0.00000000}, {1840,0.00017544}, {1850,0.00003509}, {1860,0.00010526}, {1870,0.00000000}, {1880,0.00003509}, {1890,0.00003509}, {1900,0.00003509}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00007018}, {1960,0.00003509}, {1970,0.00003509}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00002632}, {2050,0.00000000}, {2100,0.00034211}, {2150,0.00064912}, {2200,0.00042105}, {2250,0.00028070}, {2300,0.00031579}, {2350,0.00048246}, {2400,0.00035088}, {2450,0.00044737}, {2500,0.00024561}, {2550,0.00045614}, {2600,0.00031579}, {2650,0.00031579}, {2700,0.00024561}, {2750,0.00014035}, {2800,0.00014035}, {2850,0.00009649}, {2900,0.00010526}, {2950,0.00010526}, {3000,0.00014035}, {3050,0.00007018}, {3100,0.00003509}, {3150,0.00017544}, {3200,0.00028070}, {3250,0.00009649}, {3300,0.00003509}, {3350,0.00016667}, {3400,0.00024561}, {3450,0.00051754}, {3500,0.00055263}, {3550,0.00065789}, {3600,0.00017544}, {3650,0.00062281}, {3700,0.00049123}, {3750,0.00041228}, {3800,0.00014035}, {3850,0.00003509}, {3900,0.00007018}, {3950,0.00010526}, {4000,0.00014035}, {4050,0.00007018}, {4100,0.00013158}, {4150,0.00034211}, {4200,0.00007018}, {4250,0.00028070}, {4300,0.00007018}, {4350,0.00028070}, {4400,0.00037719}, {4450,0.00024561}, {4500,0.00042105}, {4550,0.00014035}, {4600,0.00007018}, {4650,0.00006140}, {4700,0.00013158}, {4750,0.00003509}, {4800,0.00007018}, {4850,0.00003509}, {4900,0.00010526}, {4950,0.00016667}, {5000,0.00010526}, {5050,0.00010526}, {5100,0.00007018}, {5150,0.00003509}, {5200,0.00021053}, {5250,0.00013158}, {5300,0.00007018}, {5350,0.00003509}, {5400,0.00010526}, {5450,0.00014035}, {5500,0.00014035}, {5550,0.00017544}, {5600,0.00003509}, {5650,0.00003509}, {5700,0.00000000}, {5750,0.00017544}, {5800,0.00007018}, {5850,0.00009649}, {5900,0.00017544}, {5950,0.00007018}, {6000,0.00017544}, {6050,0.003071}, {6100,0.005929}, {6150,0.005357}, {6200,0.004214}, {6250,0.006286}, {6300,0.002571}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000286}, {6650,0.000000}, {6700,0.000571}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000571}, {6950,0.000857}, {7000,0.000286}, {7050,0.000214}, {7100,0.000286}, {7150,0.001143}, {7200,0.000500}, {7250,0.000286}, {7300,0.001429}, {7350,0.001143}, {7400,0.000857}, {7450,0.000571}, {7500,0.000571}, {7550,0.000571}, {7600,0.000571}, {7650,0.000286}, {7700,0.000571}, {7750,0.000857}, {7800,0.000857}, {7850,0.000571}, {7900,0.000571}, {7950,0.000571}, {8000,0.000286}, {8050,0.000571}, {8100,0.000857}, {8150,0.000857}, {8200,0.000000}, {8250,0.000000}, {8300,0.000286}, {8350,0.000286}, {8400,0.000286}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000786}, {8650,0.000000}, {8700,0.000286}, {8750,0.000286}, {8800,0.000571}, {8850,0.000286}, {8900,0.000286}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000500}, {9150,0.000571}, {9200,0.000000}, {9250,0.000286}, {9300,0.000000}, {9350,0.000571}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000286}, {9650,0.000286}, {9700,0.000000}, {9750,0.000286}, {9800,0.000286}, {9850,0.000000}, {9900,0.000286}, {9950,0.000000}, {10000,0.000000}, {10100,0.000286}, {10200,0.000000}, {10300,0.000000}, {10400,0.000286}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000857}, {11100,0.000000}, {11200,0.000571}, {11300,0.000286}, {11400,0.000000}, {11500,0.000857}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.001143}, {12300,0.000286}, {12400,0.000286}, {12500,0.000286}, {12600,0.000000}, {12700,0.000286}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000286}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000286}, {13900,0.000000}, {14000,0.000000}, {14100,0.000286}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.001714}, {14700,0.012571}, {14800,0.011714}, {14900,0.004000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000571}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000286}, {16100,0.000000}, {16200,0.000000}, {16300,0.000286}, {16400,0.000000}, {16500,0.000571}, {16600,0.000286}, {16700,0.000286}, {16800,0.000000}, {16900,0.002214}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000286}, {17900,0.000286}, {18000,0.000000}, {18100,0.000000}, {18200,0.000286}, {18300,0.000286}, {18400,0.000286}, {18500,0.000000}, {18600,0.000571}, {18700,0.000000}, {18800,0.000571}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000286}, {19400,0.000000}, {19500,0.001143}, {19600,0.000000}, {19700,0.000286}, {19800,0.000286}, {19900,0.000571}, {20000,0.010500}};
data["big_flat"]["TypeClassesBodyHOAS"]["cbv"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000877}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000877}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00016667}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00028947}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00044737}, {385,0.00000000}, {386,0.00007895}, {387,0.00000877}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00008772}, {394,0.00000000}, {395,0.00004386}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000877}, {426,0.00000000}, {427,0.00000877}, {428,0.00000000}, {429,0.00000877}, {430,0.00000000}, {431,0.00000000}, {432,0.00000877}, {433,0.00000000}, {434,0.00000000}, {435,0.00000877}, {436,0.00000000}, {437,0.00000000}, {438,0.00001754}, {439,0.00000877}, {440,0.00000000}, {441,0.00001754}, {442,0.00007895}, {443,0.00000877}, {444,0.00004386}, {445,0.00000000}, {446,0.00000877}, {447,0.00002632}, {448,0.00000000}, {449,0.00000000}, {450,0.00001754}, {451,0.00001754}, {452,0.00002632}, {453,0.00002632}, {454,0.00009649}, {455,0.00004386}, {456,0.00007895}, {457,0.00010526}, {458,0.00012281}, {459,0.00016667}, {460,0.00006140}, {461,0.00015789}, {462,0.00020175}, {463,0.00018421}, {464,0.00028947}, {465,0.00026316}, {466,0.00032456}, {467,0.00048246}, {468,0.00035965}, {469,0.00041228}, {470,0.00071930}, {471,0.00050877}, {472,0.00058772}, {473,0.00050000}, {474,0.00055263}, {475,0.00065789}, {476,0.00055263}, {477,0.00052632}, {478,0.00066667}, {479,0.00057895}, {480,0.00067544}, {481,0.00073684}, {482,0.00064912}, {483,0.00068421}, {484,0.00084211}, {485,0.00077193}, {486,0.00078070}, {487,0.00080702}, {488,0.00088596}, {489,0.00086842}, {490,0.00086842}, {491,0.00085088}, {492,0.00089474}, {493,0.00087719}, {494,0.00083333}, {495,0.00090351}, {496,0.00092982}, {497,0.00090351}, {498,0.00096491}, {499,0.00088596}, {500,0.00094737}, {505,0.00095614}, {510,0.00277193}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00100000}, {535,0.00103509}, {540,0.00100000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00126316}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100000}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00103509}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00103509}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.01041228}, {770,0.00106140}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00100000}, {830,0.00164035}, {835,0.00100000}, {840,0.00100000}, {845,0.00100000}, {850,0.00100000}, {855,0.00100000}, {860,0.00100000}, {865,0.00100000}, {870,0.00100000}, {875,0.00100000}, {880,0.00100000}, {885,0.00100000}, {890,0.00100000}, {895,0.00100000}, {900,0.00100877}, {905,0.00104386}, {910,0.00106140}, {915,0.00103509}, {920,0.00109649}, {925,0.00113158}, {930,0.00120175}, {935,0.00130702}, {940,0.00157018}, {945,0.00157895}, {950,0.00154386}, {955,0.00958772}, {960,0.00166667}, {965,0.00160526}, {970,0.00166667}, {975,0.00177193}, {980,0.00174561}, {985,0.00186842}, {990,0.00187719}, {995,0.00192982}, {1000,0.00194737}, {1010,0.00194737}, {1020,0.00200000}, {1030,0.00198246}, {1040,0.01014035}, {1050,0.00200000}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00200000}, {1090,0.00217544}, {1100,0.00200000}, {1110,0.00212281}, {1120,0.00200000}, {1130,0.00200000}, {1140,0.00200000}, {1150,0.00200000}, {1160,0.00200000}, {1170,0.00200000}, {1180,0.00200000}, {1190,0.00200000}, {1200,0.00200000}, {1210,0.00200000}, {1220,0.00200000}, {1230,0.00219298}, {1240,0.00200000}, {1250,0.00200000}, {1260,0.00200000}, {1270,0.00207018}, {1280,0.00200000}, {1290,0.00200000}, {1300,0.00200000}, {1310,0.00200000}, {1320,0.00200000}, {1330,0.00200000}, {1340,0.00201754}, {1350,0.00204386}, {1360,0.00205263}, {1370,0.00210526}, {1380,0.00231579}, {1390,0.00228070}, {1400,0.00239474}, {1410,0.00255263}, {1420,0.00271053}, {1430,0.00271930}, {1440,0.00273684}, {1450,0.00281579}, {1460,0.00290351}, {1470,0.00285088}, {1480,0.00293860}, {1490,0.00294737}, {1500,0.00295614}, {1510,0.00298246}, {1520,0.00300000}, {1530,0.00300000}, {1540,0.00300000}, {1550,0.00300000}, {1560,0.00300000}, {1570,0.00300000}, {1580,0.00300000}, {1590,0.00300000}, {1600,0.00364035}, {1610,0.00370175}, {1620,0.00300000}, {1630,0.00300000}, {1640,0.00305263}, {1650,0.00355263}, {1660,0.00300000}, {1670,0.00300000}, {1680,0.00300000}, {1690,0.01157018}, {1700,0.00300000}, {1710,0.00300000}, {1720,0.00300000}, {1730,0.00300000}, {1740,0.00300000}, {1750,0.00300877}, {1760,0.00300877}, {1770,0.00316667}, {1780,0.00385965}, {1790,0.00304386}, {1800,0.00308772}, {1810,0.00313158}, {1820,0.00318421}, {1830,0.00343860}, {1840,0.00412281}, {1850,0.00333333}, {1860,0.00342982}, {1870,0.00352632}, {1880,0.00362281}, {1890,0.00371053}, {1900,0.00371930}, {1910,0.00377193}, {1920,0.00386842}, {1930,0.00384211}, {1940,0.00385965}, {1950,0.00387719}, {1960,0.00391228}, {1970,0.00395614}, {1980,0.00397368}, {1990,0.00399123}, {2000,0.00410526}, {2050,0.01199123}, {2100,0.00400000}, {2150,0.00400000}, {2200,0.00400877}, {2250,0.01151754}, {2300,0.00440351}, {2350,0.00474561}, {2400,0.00569298}, {2450,0.00498246}, {2500,0.00500000}, {2550,0.00517544}, {2600,0.00500877}, {2650,0.00501754}, {2700,0.00603509}, {2750,0.00618421}, {2800,0.00587719}, {2850,0.00578070}, {2900,0.01350877}, {2950,0.00623684}, {3000,0.00614035}, {3050,0.00600000}, {3100,0.00616667}, {3150,0.00622807}, {3200,0.00651754}, {3250,0.00676316}, {3300,0.00681579}, {3350,0.00689474}, {3400,0.00700877}, {3450,0.00700877}, {3500,0.00709649}, {3550,0.00716667}, {3600,0.00755263}, {3650,0.00764912}, {3700,0.00777193}, {3750,0.00779825}, {3800,0.00800000}, {3850,0.01927193}, {3900,0.00804386}, {3950,0.00815789}, {4000,0.00822807}, {4050,0.01537719}, {4100,0.00871930}, {4150,0.00879825}, {4200,0.00883333}, {4250,0.01819298}, {4300,0.00962281}, {4350,0.00914912}, {4400,0.00947368}, {4450,0.00935965}, {4500,0.01065789}, {4550,0.00991228}, {4600,0.00981579}, {4650,0.00999123}, {4700,0.00999123}, {4750,0.02205263}, {4800,0.01041228}, {4850,0.01049123}, {4900,0.02171053}, {4950,0.01064035}, {5000,0.01080702}, {5050,0.01106140}, {5100,0.01092982}, {5150,0.02197368}, {5200,0.01914035}, {5250,0.01133333}, {5300,0.01135965}, {5350,0.01155263}, {5400,0.01174561}, {5450,0.01185965}, {5500,0.01192105}, {5550,0.01195614}, {5600,0.01213158}, {5650,0.01224561}, {5700,0.01231579}, {5750,0.01248246}, {5800,0.01266667}, {5850,0.01371053}, {5900,0.01287719}, {5950,0.01299123}, {6000,0.02565789}, {6050,0.013500}, {6100,0.013500}, {6150,0.027500}, {6200,0.026214}, {6250,0.013714}, {6300,0.022429}, {6350,0.014357}, {6400,0.024214}, {6450,0.028000}, {6500,0.025571}, {6550,0.026429}, {6600,0.014643}, {6650,0.014857}, {6700,0.015071}, {6750,0.015714}, {6800,0.015429}, {6850,0.029929}, {6900,0.015571}, {6950,0.015500}, {7000,0.015571}, {7050,0.015929}, {7100,0.016571}, {7150,0.016357}, {7200,0.016500}, {7250,0.030357}, {7300,0.016357}, {7350,0.033786}, {7400,0.026786}, {7450,0.016714}, {7500,0.017571}, {7550,0.032500}, {7600,0.026786}, {7650,0.017286}, {7700,0.028214}, {7750,0.017357}, {7800,0.033786}, {7850,0.018714}, {7900,0.025786}, {7950,0.017857}, {8000,0.039143}, {8050,0.036071}, {8100,0.018357}, {8150,0.019214}, {8200,0.037857}, {8250,0.018786}, {8300,0.019071}, {8350,0.019143}, {8400,0.019286}, {8450,0.035429}, {8500,0.019357}, {8550,0.019429}, {8600,0.019571}, {8650,0.038714}, {8700,0.021643}, {8750,0.021714}, {8800,0.020286}, {8850,0.029786}, {8900,0.020500}, {8950,0.020643}, {9000,0.020571}, {9050,0.021000}, {9100,0.021071}, {9150,0.048500}, {9200,0.021357}, {9250,0.021500}, {9300,0.023786}, {9350,0.022857}, {9400,0.021500}, {9450,0.021929}, {9500,0.022000}, {9550,0.022071}, {9600,0.047286}, {9650,0.024071}, {9700,0.022429}, {9750,0.046500}, {9800,0.023929}, {9850,0.022857}, {9900,0.022857}, {9950,0.023000}, {10000,0.023286}, {10100,0.025286}, {10200,0.025143}, {10300,0.023929}, {10400,0.043071}, {10500,0.024357}, {10600,0.026000}, {10700,0.026571}, {10800,0.045643}, {10900,0.025357}, {11000,0.047929}, {11100,0.026000}, {11200,0.039714}, {11300,0.026429}, {11400,0.044857}, {11500,0.026857}, {11600,0.029429}, {11700,0.046929}, {11800,0.027643}, {11900,0.054000}, {12000,0.029429}, {12100,0.030071}, {12200,0.054429}, {12300,0.051286}, {12400,0.046571}, {12500,0.042929}, {12600,0.042643}, {12700,0.030071}, {12800,0.045429}, {12900,0.052643}, {13000,0.031071}, {13100,0.045429}, {13200,0.032143}, {13300,0.031857}, {13400,0.032000}, {13500,0.033071}, {13600,0.034643}, {13700,0.034214}, {13800,0.063929}, {13900,0.069357}, {14000,0.035714}, {14100,0.033786}, {14200,0.046857}, {14300,0.036643}, {14400,0.036643}, {14500,0.067643}, {14600,0.071643}, {14700,0.035500}, {14800,0.069571}, {14900,0.069714}, {15000,0.052143}, {15100,0.037429}, {15200,0.073286}, {15300,0.038500}, {15400,0.069214}, {15500,0.056857}, {15600,0.051714}, {15700,0.066429}, {15800,0.063571}, {15900,0.077357}, {16000,0.037714}, {16100,0.041143}, {16200,0.038929}, {16300,0.039357}, {16400,0.041214}, {16500,0.080643}, {16600,0.059143}, {16700,0.040500}, {16800,0.042000}, {16900,0.071714}, {17000,0.058786}, {17100,0.062857}, {17200,0.044643}, {17300,0.040643}, {17400,0.075071}, {17500,0.065071}, {17600,0.063143}, {17700,0.056500}, {17800,0.061286}, {17900,0.076571}, {18000,0.092071}, {18100,0.073714}, {18200,0.047214}, {18300,0.044643}, {18400,0.086357}, {18500,0.088929}, {18600,0.076429}, {18700,0.057643}, {18800,0.061429}, {18900,0.059143}, {19000,0.046786}, {19100,0.091643}, {19200,0.078357}, {19300,0.102429}, {19400,0.048714}, {19500,0.078571}, {19600,0.077857}, {19700,0.050643}, {19800,0.051786}, {19900,0.063571}, {20000,0.091857}};
data["big_flat"]["TypeClassesBodyHOAS"]["cbv"]["user"] = {{1,0.00003509}, {2,0.00002632}, {3,0.00002632}, {4,0.00000000}, {5,0.00000000}, {6,0.00002632}, {7,0.00003509}, {8,0.00003509}, {9,0.00003509}, {10,0.00003509}, {11,0.00003509}, {12,0.00011404}, {13,0.00003509}, {14,0.00000000}, {15,0.00003509}, {16,0.00009649}, {17,0.00003509}, {18,0.00012281}, {19,0.00007018}, {20,0.00005263}, {21,0.00003509}, {22,0.00009649}, {23,0.00007895}, {24,0.00000000}, {25,0.00015789}, {26,0.00006140}, {27,0.00009649}, {28,0.00014035}, {29,0.00011404}, {30,0.00020175}, {31,0.00008772}, {32,0.00005263}, {33,0.00002632}, {34,0.00012281}, {35,0.00003509}, {36,0.00010526}, {37,0.00021053}, {38,0.00022807}, {39,0.00003509}, {40,0.00007018}, {41,0.00007018}, {42,0.00002632}, {43,0.00017544}, {44,0.00007018}, {45,0.00013158}, {46,0.00017544}, {47,0.00017544}, {48,0.00002632}, {49,0.00019298}, {50,0.00009649}, {51,0.00020175}, {52,0.00010526}, {53,0.00013158}, {54,0.00012281}, {55,0.00015789}, {56,0.00015789}, {57,0.00009649}, {58,0.00014912}, {59,0.00013158}, {60,0.00013158}, {61,0.00010526}, {62,0.00013158}, {63,0.00015789}, {64,0.00022807}, {65,0.00018421}, {66,0.00010526}, {67,0.00027193}, {68,0.00008772}, {69,0.00006140}, {70,0.00015789}, {71,0.00015789}, {72,0.00015789}, {73,0.00025439}, {74,0.00015789}, {75,0.00021930}, {76,0.00021930}, {77,0.00026316}, {78,0.00025439}, {79,0.00014912}, {80,0.00002632}, {81,0.00021930}, {82,0.00020175}, {83,0.00009649}, {84,0.00031579}, {85,0.00027193}, {86,0.00009649}, {87,0.00019298}, {88,0.00008772}, {89,0.00024561}, {90,0.00013158}, {91,0.00021053}, {92,0.00014912}, {93,0.00023684}, {94,0.00027193}, {95,0.00014912}, {96,0.00021930}, {97,0.00024561}, {98,0.00026316}, {99,0.00026316}, {100,0.00015789}, {101,0.00008772}, {102,0.00019298}, {103,0.00020175}, {104,0.00015789}, {105,0.00015789}, {106,0.00029825}, {107,0.00021053}, {108,0.00011404}, {109,0.00030702}, {110,0.00012281}, {111,0.00023684}, {112,0.00021930}, {113,0.00021053}, {114,0.00034211}, {115,0.00013158}, {116,0.00037719}, {117,0.00032456}, {118,0.00022807}, {119,0.00007895}, {120,0.00028947}, {121,0.00038596}, {122,0.00030702}, {123,0.00030702}, {124,0.00035965}, {125,0.00025439}, {126,0.00021930}, {127,0.00020175}, {128,0.00030702}, {129,0.00019298}, {130,0.00033333}, {131,0.00035088}, {132,0.00042105}, {133,0.00024561}, {134,0.00026316}, {135,0.00035965}, {136,0.00019298}, {137,0.00049123}, {138,0.00038596}, {139,0.00032456}, {140,0.00018421}, {141,0.00025439}, {142,0.00022807}, {143,0.00025439}, {144,0.00033333}, {145,0.00039474}, {146,0.00032456}, {147,0.00034211}, {148,0.00040351}, {149,0.00019298}, {150,0.00036842}, {151,0.00016667}, {152,0.00016667}, {153,0.00034211}, {154,0.00037719}, {155,0.00036842}, {156,0.00028070}, {157,0.00035088}, {158,0.00014912}, {159,0.00017544}, {160,0.00018421}, {161,0.00017544}, {162,0.00033333}, {163,0.00049123}, {164,0.00016667}, {165,0.00022807}, {166,0.00027193}, {167,0.00028947}, {168,0.00036842}, {169,0.00043860}, {170,0.00032456}, {171,0.00039474}, {172,0.00011404}, {173,0.00022807}, {174,0.00023684}, {175,0.00034211}, {176,0.00023684}, {177,0.00027193}, {178,0.00035965}, {179,0.00035965}, {180,0.00038596}, {181,0.00035965}, {182,0.00044737}, {183,0.00045614}, {184,0.00029825}, {185,0.00045614}, {186,0.00052632}, {187,0.00049123}, {188,0.00038596}, {189,0.00038596}, {190,0.00029825}, {191,0.00032456}, {192,0.00050877}, {193,0.00028947}, {194,0.00041228}, {195,0.00041228}, {196,0.00031579}, {197,0.00033333}, {198,0.00027193}, {199,0.00062281}, {200,0.00050877}, {201,0.00025439}, {202,0.00045614}, {203,0.00037719}, {204,0.00040351}, {205,0.00038596}, {206,0.00042982}, {207,0.00021053}, {208,0.00028070}, {209,0.00035965}, {210,0.00040351}, {211,0.00048246}, {212,0.00042982}, {213,0.00050000}, {214,0.00052632}, {215,0.00047368}, {216,0.00025439}, {217,0.00058772}, {218,0.00042105}, {219,0.00043860}, {220,0.00050877}, {221,0.00045614}, {222,0.00035965}, {223,0.00027193}, {224,0.00016667}, {225,0.00038596}, {226,0.00041228}, {227,0.00057895}, {228,0.00039474}, {229,0.00015789}, {230,0.00039474}, {231,0.00044737}, {232,0.00050877}, {233,0.00032456}, {234,0.00037719}, {235,0.00042105}, {236,0.00034211}, {237,0.00031579}, {238,0.00048246}, {239,0.00048246}, {240,0.00058772}, {241,0.00051754}, {242,0.00050000}, {243,0.00062281}, {244,0.00075439}, {245,0.00053509}, {246,0.00033333}, {247,0.00044737}, {248,0.00044737}, {249,0.00053509}, {250,0.00041228}, {251,0.00055263}, {252,0.00050000}, {253,0.00042105}, {254,0.00035088}, {255,0.00040351}, {256,0.00035965}, {257,0.00045614}, {258,0.00070175}, {259,0.00029825}, {260,0.00059649}, {261,0.00048246}, {262,0.00051754}, {263,0.00039474}, {264,0.00057018}, {265,0.00050877}, {266,0.00036842}, {267,0.00035088}, {268,0.00053509}, {269,0.00049123}, {270,0.00042982}, {271,0.00054386}, {272,0.00044737}, {273,0.00039474}, {274,0.00043860}, {275,0.00050000}, {276,0.00050000}, {277,0.00071053}, {278,0.00056140}, {279,0.00041228}, {280,0.00058772}, {281,0.00094737}, {282,0.00057018}, {283,0.00045614}, {284,0.00052632}, {285,0.00040351}, {286,0.00069298}, {287,0.00061404}, {288,0.00056140}, {289,0.00038596}, {290,0.00059649}, {291,0.00071053}, {292,0.00059649}, {293,0.00039474}, {294,0.00061404}, {295,0.00054386}, {296,0.00047368}, {297,0.00065789}, {298,0.00046491}, {299,0.00037719}, {300,0.00072807}, {301,0.00079825}, {302,0.00050877}, {303,0.00076316}, {304,0.00052632}, {305,0.00028947}, {306,0.00057895}, {307,0.00056140}, {308,0.00046491}, {309,0.00085965}, {310,0.00054386}, {311,0.00040351}, {312,0.00045614}, {313,0.00049123}, {314,0.00056140}, {315,0.00065789}, {316,0.00077193}, {317,0.00086842}, {318,0.00057018}, {319,0.00066667}, {320,0.00037719}, {321,0.00059649}, {322,0.00077193}, {323,0.00080702}, {324,0.00053509}, {325,0.00070175}, {326,0.00049123}, {327,0.00053509}, {328,0.00077193}, {329,0.00062281}, {330,0.00073684}, {331,0.00067544}, {332,0.00066667}, {333,0.00067544}, {334,0.00054386}, {335,0.00059649}, {336,0.00057018}, {337,0.00061404}, {338,0.00057895}, {339,0.00054386}, {340,0.00070175}, {341,0.00060526}, {342,0.00050000}, {343,0.00054386}, {344,0.00054386}, {345,0.00050000}, {346,0.00071053}, {347,0.00059649}, {348,0.00044737}, {349,0.00075439}, {350,0.00058772}, {351,0.00081579}, {352,0.00065789}, {353,0.00077193}, {354,0.00095614}, {355,0.00066667}, {356,0.00077193}, {357,0.00078070}, {358,0.00066667}, {359,0.00052632}, {360,0.00047368}, {361,0.00063158}, {362,0.00047368}, {363,0.00065789}, {364,0.00064912}, {365,0.00057018}, {366,0.00073684}, {367,0.00062281}, {368,0.00072807}, {369,0.00085088}, {370,0.00069298}, {371,0.00092105}, {372,0.00071053}, {373,0.00082456}, {374,0.00076316}, {375,0.00079825}, {376,0.00058772}, {377,0.00078947}, {378,0.00074561}, {379,0.00092105}, {380,0.00079825}, {381,0.00051754}, {382,0.00104386}, {383,0.00073684}, {384,0.00101754}, {385,0.00064912}, {386,0.00061404}, {387,0.00077193}, {388,0.00071930}, {389,0.00061404}, {390,0.00112281}, {391,0.00050000}, {392,0.00074561}, {393,0.00064912}, {394,0.00067544}, {395,0.00073684}, {396,0.00088596}, {397,0.00067544}, {398,0.00096491}, {399,0.00084211}, {400,0.00065789}, {401,0.00063158}, {402,0.00088596}, {403,0.00069298}, {404,0.00085088}, {405,0.00040351}, {406,0.00051754}, {407,0.00074561}, {408,0.00056140}, {409,0.00079825}, {410,0.00048246}, {411,0.00077193}, {412,0.00071053}, {413,0.00085088}, {414,0.00075439}, {415,0.00069298}, {416,0.00084211}, {417,0.00065789}, {418,0.00072807}, {419,0.00082456}, {420,0.00061404}, {421,0.00085088}, {422,0.00067544}, {423,0.00077193}, {424,0.00095614}, {425,0.00056140}, {426,0.00078947}, {427,0.00109649}, {428,0.00103509}, {429,0.00120175}, {430,0.00083333}, {431,0.00071930}, {432,0.00065789}, {433,0.00098246}, {434,0.00091228}, {435,0.00058772}, {436,0.00092105}, {437,0.00098246}, {438,0.00062281}, {439,0.00088596}, {440,0.00080702}, {441,0.00077193}, {442,0.00079825}, {443,0.00076316}, {444,0.00068421}, {445,0.00043860}, {446,0.00073684}, {447,0.00078070}, {448,0.00077193}, {449,0.00105263}, {450,0.00088596}, {451,0.00060526}, {452,0.00064035}, {453,0.00092982}, {454,0.00088596}, {455,0.00096491}, {456,0.00095614}, {457,0.00084211}, {458,0.00084211}, {459,0.00071930}, {460,0.00099123}, {461,0.00092982}, {462,0.00095614}, {463,0.00082456}, {464,0.00089474}, {465,0.00074561}, {466,0.00114912}, {467,0.00085088}, {468,0.00107018}, {469,0.00094737}, {470,0.00095614}, {471,0.00082456}, {472,0.00087719}, {473,0.00086842}, {474,0.00097368}, {475,0.00109649}, {476,0.00093860}, {477,0.00094737}, {478,0.00107018}, {479,0.00091228}, {480,0.00076316}, {481,0.00050877}, {482,0.00087719}, {483,0.00081579}, {484,0.00100000}, {485,0.00098246}, {486,0.00104386}, {487,0.00075439}, {488,0.00083333}, {489,0.00100000}, {490,0.00112281}, {491,0.00111404}, {492,0.00100000}, {493,0.00085965}, {494,0.00100000}, {495,0.00107895}, {496,0.00114912}, {497,0.00099123}, {498,0.00107895}, {499,0.00097368}, {500,0.00107018}, {505,0.00084211}, {510,0.00254386}, {515,0.00108772}, {520,0.00097368}, {525,0.00141228}, {530,0.00080702}, {535,0.00121930}, {540,0.00100877}, {545,0.00108772}, {550,0.00103509}, {555,0.00106140}, {560,0.00109649}, {565,0.00085088}, {570,0.00135088}, {575,0.00114035}, {580,0.00150000}, {585,0.00095614}, {590,0.00107018}, {595,0.00127193}, {600,0.00121930}, {605,0.00111404}, {610,0.00130702}, {615,0.00102632}, {620,0.00113158}, {625,0.00117544}, {630,0.00117544}, {635,0.00121053}, {640,0.00116667}, {645,0.00113158}, {650,0.00130702}, {655,0.00112281}, {660,0.00122807}, {665,0.00116667}, {670,0.00129825}, {675,0.00141228}, {680,0.00145614}, {685,0.00147368}, {690,0.00131579}, {695,0.00115789}, {700,0.00145614}, {705,0.00138596}, {710,0.00126316}, {715,0.00183333}, {720,0.00118421}, {725,0.00140351}, {730,0.00147368}, {735,0.00159649}, {740,0.00165789}, {745,0.00138596}, {750,0.00113158}, {755,0.00150877}, {760,0.00155263}, {765,0.01014035}, {770,0.00147368}, {775,0.00122807}, {780,0.00115789}, {785,0.00102632}, {790,0.00163158}, {795,0.00156140}, {800,0.00175439}, {805,0.00171053}, {810,0.00154386}, {815,0.00164912}, {820,0.00149123}, {825,0.00155263}, {830,0.00225439}, {835,0.00171053}, {840,0.00174561}, {845,0.00151754}, {850,0.00162281}, {855,0.00155263}, {860,0.00142982}, {865,0.00130702}, {870,0.00164035}, {875,0.00179825}, {880,0.00181579}, {885,0.00167544}, {890,0.00146491}, {895,0.00183333}, {900,0.00180702}, {905,0.00168421}, {910,0.00158772}, {915,0.00171930}, {920,0.00189474}, {925,0.00179825}, {930,0.00172807}, {935,0.00171930}, {940,0.00181579}, {945,0.00157895}, {950,0.00180702}, {955,0.00909649}, {960,0.00190351}, {965,0.00157018}, {970,0.00198246}, {975,0.00184211}, {980,0.00221053}, {985,0.00183333}, {990,0.00192982}, {995,0.00182456}, {1000,0.00197368}, {1010,0.00177193}, {1020,0.00181579}, {1030,0.00208772}, {1040,0.01017544}, {1050,0.00233333}, {1060,0.00187719}, {1070,0.00232456}, {1080,0.00214912}, {1090,0.00243860}, {1100,0.00248246}, {1110,0.00228070}, {1120,0.00223684}, {1130,0.00179825}, {1140,0.00206140}, {1150,0.00223684}, {1160,0.00227193}, {1170,0.00247368}, {1180,0.00236842}, {1190,0.00210526}, {1200,0.00207895}, {1210,0.00217544}, {1220,0.00260526}, {1230,0.00230702}, {1240,0.00255263}, {1250,0.00251754}, {1260,0.00271930}, {1270,0.00274561}, {1280,0.00260526}, {1290,0.00262281}, {1300,0.00274561}, {1310,0.00214912}, {1320,0.00248246}, {1330,0.00254386}, {1340,0.00269298}, {1350,0.00252632}, {1360,0.00269298}, {1370,0.00271053}, {1380,0.00277193}, {1390,0.00279825}, {1400,0.00273684}, {1410,0.00278947}, {1420,0.00258772}, {1430,0.00288596}, {1440,0.00238596}, {1450,0.00276316}, {1460,0.00288596}, {1470,0.00291228}, {1480,0.00289474}, {1490,0.00269298}, {1500,0.00289474}, {1510,0.00262281}, {1520,0.00298246}, {1530,0.00283333}, {1540,0.00337719}, {1550,0.00307018}, {1560,0.00302632}, {1570,0.00298246}, {1580,0.00320175}, {1590,0.00301754}, {1600,0.00371053}, {1610,0.00390351}, {1620,0.00313158}, {1630,0.00323684}, {1640,0.00324561}, {1650,0.00407895}, {1660,0.00328947}, {1670,0.00318421}, {1680,0.00342982}, {1690,0.01192982}, {1700,0.00342105}, {1710,0.00303509}, {1720,0.00333333}, {1730,0.00334211}, {1740,0.00328947}, {1750,0.00335088}, {1760,0.00326316}, {1770,0.00374561}, {1780,0.00434211}, {1790,0.00348246}, {1800,0.00346491}, {1810,0.00349123}, {1820,0.00342105}, {1830,0.00385965}, {1840,0.00450877}, {1850,0.00350000}, {1860,0.00361404}, {1870,0.00368421}, {1880,0.00376316}, {1890,0.00366667}, {1900,0.00376316}, {1910,0.00372807}, {1920,0.00385088}, {1930,0.00380702}, {1940,0.00384211}, {1950,0.00375439}, {1960,0.00372807}, {1970,0.00378947}, {1980,0.00409649}, {1990,0.00410526}, {2000,0.00403509}, {2050,0.01221930}, {2100,0.00424561}, {2150,0.00424561}, {2200,0.00431579}, {2250,0.01170175}, {2300,0.00474561}, {2350,0.00480702}, {2400,0.00566667}, {2450,0.00497368}, {2500,0.00506140}, {2550,0.00533333}, {2600,0.00529825}, {2650,0.00508772}, {2700,0.00614912}, {2750,0.00628947}, {2800,0.00589474}, {2850,0.00569298}, {2900,0.01377193}, {2950,0.00624561}, {3000,0.00628070}, {3050,0.00621930}, {3100,0.00674561}, {3150,0.00624561}, {3200,0.00635965}, {3250,0.00671930}, {3300,0.00690351}, {3350,0.00687719}, {3400,0.00693860}, {3450,0.00704386}, {3500,0.00740351}, {3550,0.00735088}, {3600,0.00771930}, {3650,0.00778070}, {3700,0.00787719}, {3750,0.00793860}, {3800,0.00801754}, {3850,0.01888596}, {3900,0.00828947}, {3950,0.00834211}, {4000,0.00872807}, {4050,0.01505263}, {4100,0.00866667}, {4150,0.00872807}, {4200,0.00891228}, {4250,0.01825439}, {4300,0.00958772}, {4350,0.00938596}, {4400,0.00938596}, {4450,0.00965789}, {4500,0.01099123}, {4550,0.00969298}, {4600,0.00971930}, {4650,0.00993860}, {4700,0.00960526}, {4750,0.02202632}, {4800,0.01049123}, {4850,0.01052632}, {4900,0.02207018}, {4950,0.01079825}, {5000,0.01071053}, {5050,0.01142105}, {5100,0.01100877}, {5150,0.02218421}, {5200,0.01921930}, {5250,0.01134211}, {5300,0.01125439}, {5350,0.01156140}, {5400,0.01179825}, {5450,0.01197368}, {5500,0.01192105}, {5550,0.01195614}, {5600,0.01198246}, {5650,0.01236842}, {5700,0.01235088}, {5750,0.01228070}, {5800,0.01245614}, {5850,0.01381579}, {5900,0.01248246}, {5950,0.01286842}, {6000,0.02602632}, {6050,0.014000}, {6100,0.013500}, {6150,0.027000}, {6200,0.025643}, {6250,0.013929}, {6300,0.021929}, {6350,0.013357}, {6400,0.024500}, {6450,0.028000}, {6500,0.026000}, {6550,0.026429}, {6600,0.014286}, {6650,0.014929}, {6700,0.014929}, {6750,0.016000}, {6800,0.015571}, {6850,0.030000}, {6900,0.015500}, {6950,0.015714}, {7000,0.015214}, {7050,0.015500}, {7100,0.016571}, {7150,0.016786}, {7200,0.016000}, {7250,0.030429}, {7300,0.016357}, {7350,0.033214}, {7400,0.026857}, {7450,0.017000}, {7500,0.017429}, {7550,0.033071}, {7600,0.026429}, {7650,0.017643}, {7700,0.028786}, {7750,0.017071}, {7800,0.034214}, {7850,0.019429}, {7900,0.025429}, {7950,0.017786}, {8000,0.038714}, {8050,0.035857}, {8100,0.017500}, {8150,0.018214}, {8200,0.037143}, {8250,0.018714}, {8300,0.018714}, {8350,0.018857}, {8400,0.018571}, {8450,0.035000}, {8500,0.018857}, {8550,0.019714}, {8600,0.018571}, {8650,0.038429}, {8700,0.020571}, {8750,0.020643}, {8800,0.019429}, {8850,0.029714}, {8900,0.019857}, {8950,0.020857}, {9000,0.020071}, {9050,0.020857}, {9100,0.021071}, {9150,0.048857}, {9200,0.021571}, {9250,0.020000}, {9300,0.024143}, {9350,0.022571}, {9400,0.021143}, {9450,0.021571}, {9500,0.021786}, {9550,0.020929}, {9600,0.047429}, {9650,0.024286}, {9700,0.023286}, {9750,0.046857}, {9800,0.023786}, {9850,0.022357}, {9900,0.022571}, {9950,0.022929}, {10000,0.023571}, {10100,0.025286}, {10200,0.024929}, {10300,0.023786}, {10400,0.043286}, {10500,0.023929}, {10600,0.026500}, {10700,0.026786}, {10800,0.045571}, {10900,0.025857}, {11000,0.047500}, {11100,0.025429}, {11200,0.039143}, {11300,0.027071}, {11400,0.045571}, {11500,0.027214}, {11600,0.030000}, {11700,0.047357}, {11800,0.028357}, {11900,0.054000}, {12000,0.029857}, {12100,0.029714}, {12200,0.054214}, {12300,0.051357}, {12400,0.047000}, {12500,0.042857}, {12600,0.043286}, {12700,0.029857}, {12800,0.044714}, {12900,0.052786}, {13000,0.030857}, {13100,0.045929}, {13200,0.032071}, {13300,0.031714}, {13400,0.031643}, {13500,0.033214}, {13600,0.033643}, {13700,0.033429}, {13800,0.063500}, {13900,0.069643}, {14000,0.036214}, {14100,0.033357}, {14200,0.047500}, {14300,0.036071}, {14400,0.037071}, {14500,0.067643}, {14600,0.071357}, {14700,0.035429}, {14800,0.067714}, {14900,0.068857}, {15000,0.053357}, {15100,0.037429}, {15200,0.073286}, {15300,0.038643}, {15400,0.069357}, {15500,0.057429}, {15600,0.051929}, {15700,0.066857}, {15800,0.064000}, {15900,0.077286}, {16000,0.038214}, {16100,0.041071}, {16200,0.039071}, {16300,0.038143}, {16400,0.041000}, {16500,0.080143}, {16600,0.059214}, {16700,0.040071}, {16800,0.042143}, {16900,0.072286}, {17000,0.058071}, {17100,0.063071}, {17200,0.043429}, {17300,0.040214}, {17400,0.074429}, {17500,0.064857}, {17600,0.063071}, {17700,0.057071}, {17800,0.061071}, {17900,0.077071}, {18000,0.091357}, {18100,0.074500}, {18200,0.046500}, {18300,0.044714}, {18400,0.085500}, {18500,0.089214}, {18600,0.076000}, {18700,0.056786}, {18800,0.060643}, {18900,0.058571}, {19000,0.046929}, {19100,0.091857}, {19200,0.078500}, {19300,0.101286}, {19400,0.048357}, {19500,0.077929}, {19600,0.078071}, {19700,0.051143}, {19800,0.052929}, {19900,0.063786}, {20000,0.091643}};
data["big_flat"]["TypeClassesBodyHOAS"]["cbv"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00003509}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00003509}, {38,0.00000000}, {39,0.00000000}, {40,0.00002632}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00003509}, {107,0.00003509}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00003509}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00003509}, {144,0.00000000}, {145,0.00003509}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00002632}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00002632}, {167,0.00000000}, {168,0.00000000}, {169,0.00003509}, {170,0.00000000}, {171,0.00003509}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00003509}, {188,0.00000000}, {189,0.00003509}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00003509}, {211,0.00000000}, {212,0.00003509}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00003509}, {223,0.00000000}, {224,0.00000000}, {225,0.00003509}, {226,0.00000000}, {227,0.00000000}, {228,0.00003509}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00003509}, {235,0.00000000}, {236,0.00003509}, {237,0.00000000}, {238,0.00003509}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00003509}, {269,0.00000000}, {270,0.00003509}, {271,0.00003509}, {272,0.00000000}, {273,0.00003509}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00002632}, {281,0.00003509}, {282,0.00000000}, {283,0.00002632}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00003509}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00003509}, {295,0.00003509}, {296,0.00000000}, {297,0.00003509}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00003509}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00003509}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00003509}, {329,0.00003509}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00003509}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00003509}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00003509}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00003509}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00003509}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00003509}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00003509}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00003509}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00007018}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00003509}, {441,0.00000000}, {442,0.00003509}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00003509}, {474,0.00000000}, {475,0.00003509}, {476,0.00003509}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00007018}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00003509}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00003509}, {560,0.00003509}, {565,0.00000000}, {570,0.00000000}, {575,0.00002632}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00003509}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00003509}, {660,0.00000000}, {665,0.00000000}, {670,0.00003509}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00007018}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00003509}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00058772}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00003509}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00002632}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00007018}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00003509}, {955,0.00028070}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00003509}, {980,0.00000000}, {985,0.00003509}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00042105}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00003509}, {1200,0.00003509}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003509}, {1290,0.00000000}, {1300,0.00003509}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00003509}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00003509}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00003509}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003509}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00003509}, {1570,0.00003509}, {1580,0.00000000}, {1590,0.00003509}, {1600,0.00000000}, {1610,0.00003509}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00003509}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00003509}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00003509}, {1910,0.00000000}, {1920,0.00003509}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00010526}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00002632}, {2900,0.00010526}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00003509}, {4100,0.00000000}, {4150,0.00003509}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00003509}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.000286}, {6100,0.000000}, {6150,0.000286}, {6200,0.000571}, {6250,0.000000}, {6300,0.000286}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000286}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000286}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000286}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000286}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000286}, {8050,0.000000}, {8100,0.000286}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000286}, {11200,0.000286}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000286}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.001714}, {14900,0.000786}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000286}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000000}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000286}, {19400,0.000000}, {19500,0.000286}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClassesBodyHOAS"]["eval lazy"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00261404}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00051754}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00009649}, {309,0.00000000}, {310,0.00048246}, {311,0.00000877}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000877}, {335,0.00001754}, {336,0.00000000}, {337,0.00000877}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000877}, {342,0.00000877}, {343,0.00000877}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000877}, {349,0.00000000}, {350,0.00000877}, {351,0.00000000}, {352,0.00042105}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00008772}, {357,0.00002632}, {358,0.00000877}, {359,0.00003509}, {360,0.00050000}, {361,0.00001754}, {362,0.00007018}, {363,0.00001754}, {364,0.00000000}, {365,0.00002632}, {366,0.00000000}, {367,0.00005263}, {368,0.00000000}, {369,0.00002632}, {370,0.00000000}, {371,0.00004386}, {372,0.00000000}, {373,0.00001754}, {374,0.00000000}, {375,0.00003509}, {376,0.00000000}, {377,0.00002632}, {378,0.00000877}, {379,0.00006140}, {380,0.00000877}, {381,0.00005263}, {382,0.00000000}, {383,0.00009649}, {384,0.00000000}, {385,0.00000877}, {386,0.00000000}, {387,0.00040351}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00002632}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00001754}, {396,0.00001754}, {397,0.00001754}, {398,0.00000000}, {399,0.00009649}, {400,0.00000000}, {401,0.00001754}, {402,0.00000877}, {403,0.00005263}, {404,0.00000877}, {405,0.00003509}, {406,0.00007018}, {407,0.00000000}, {408,0.00001754}, {409,0.00000000}, {410,0.00007895}, {411,0.00000000}, {412,0.00006140}, {413,0.00002632}, {414,0.00013158}, {415,0.00009649}, {416,0.00002632}, {417,0.00002632}, {418,0.00408772}, {419,0.00008772}, {420,0.00000000}, {421,0.00007018}, {422,0.00000877}, {423,0.00016667}, {424,0.00000877}, {425,0.00007895}, {426,0.00003509}, {427,0.00765789}, {428,0.00006140}, {429,0.00002632}, {430,0.00019298}, {431,0.00006140}, {432,0.00004386}, {433,0.00007895}, {434,0.00000000}, {435,0.00019298}, {436,0.00000877}, {437,0.00030702}, {438,0.00009649}, {439,0.00053509}, {440,0.00013158}, {441,0.00001754}, {442,0.00028947}, {443,0.00012281}, {444,0.00035088}, {445,0.00059649}, {446,0.00006140}, {447,0.00089474}, {448,0.00000000}, {449,0.00009649}, {450,0.00009649}, {451,0.00001754}, {452,0.00011404}, {453,0.00004386}, {454,0.00025439}, {455,0.00023684}, {456,0.00000000}, {457,0.00024561}, {458,0.00001754}, {459,0.00065789}, {460,0.00018421}, {461,0.00003509}, {462,0.00059649}, {463,0.00022807}, {464,0.00011404}, {465,0.00027193}, {466,0.00001754}, {467,0.00073684}, {468,0.00009649}, {469,0.00005263}, {470,0.00066667}, {471,0.00020175}, {472,0.00050877}, {473,0.00063158}, {474,0.00004386}, {475,0.00090351}, {476,0.00050000}, {477,0.00007018}, {478,0.00095614}, {479,0.00094737}, {480,0.00000877}, {481,0.00053509}, {482,0.00007895}, {483,0.00085965}, {484,0.00057018}, {485,0.00012281}, {486,0.00086842}, {487,0.00091228}, {488,0.00003509}, {489,0.00090351}, {490,0.00079825}, {491,0.00023684}, {492,0.00093860}, {493,0.00097368}, {494,0.00035088}, {495,0.00090351}, {496,0.00065789}, {497,0.00021053}, {498,0.00092982}, {499,0.00096491}, {500,0.00022807}, {505,0.00100000}, {510,0.00092105}, {515,0.00031579}, {520,0.00075439}, {525,0.00098246}, {530,0.00064912}, {535,0.00040351}, {540,0.00098246}, {545,0.00099123}, {550,0.00075439}, {555,0.00864912}, {560,0.00092105}, {565,0.00100000}, {570,0.00098246}, {575,0.00100877}, {580,0.00100000}, {585,0.00098246}, {590,0.00100000}, {595,0.00100000}, {600,0.00085088}, {605,0.00114912}, {610,0.00100000}, {615,0.00102632}, {620,0.00100877}, {625,0.00100877}, {630,0.00100877}, {635,0.00840351}, {640,0.00093860}, {645,0.00103509}, {650,0.00100877}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00111404}, {685,0.00132456}, {690,0.00197368}, {695,0.00130702}, {700,0.00125439}, {705,0.00108772}, {710,0.00112281}, {715,0.00114912}, {720,0.00103509}, {725,0.00113158}, {730,0.00113158}, {735,0.00133333}, {740,0.00114035}, {745,0.00124561}, {750,0.00133333}, {755,0.00142105}, {760,0.00145614}, {765,0.00102632}, {770,0.00100877}, {775,0.00101754}, {780,0.00100877}, {785,0.00101754}, {790,0.00107895}, {795,0.00117544}, {800,0.00102632}, {805,0.00116667}, {810,0.00120175}, {815,0.00153509}, {820,0.00140351}, {825,0.00169298}, {830,0.00116667}, {835,0.00113158}, {840,0.00118421}, {845,0.00134211}, {850,0.00140351}, {855,0.00201754}, {860,0.00120175}, {865,0.00115789}, {870,0.00135088}, {875,0.00166667}, {880,0.00159649}, {885,0.00132456}, {890,0.00147368}, {895,0.00221930}, {900,0.00101754}, {905,0.00119298}, {910,0.00148246}, {915,0.00169298}, {920,0.00111404}, {925,0.00150877}, {930,0.00145614}, {935,0.00219298}, {940,0.00121930}, {945,0.00144737}, {950,0.00216667}, {955,0.00172807}, {960,0.00133333}, {965,0.00207895}, {970,0.00135965}, {975,0.00210526}, {980,0.00215789}, {985,0.00180702}, {990,0.00230702}, {995,0.00167544}, {1000,0.00188596}, {1010,0.00934211}, {1020,0.00215789}, {1030,0.00205263}, {1040,0.00128947}, {1050,0.00206140}, {1060,0.00205263}, {1070,0.00221930}, {1080,0.00160526}, {1090,0.00198246}, {1100,0.00187719}, {1110,0.00231579}, {1120,0.00153509}, {1130,0.00229825}, {1140,0.00213158}, {1150,0.00278947}, {1160,0.00213158}, {1170,0.00203509}, {1180,0.00239474}, {1190,0.00231579}, {1200,0.00201754}, {1210,0.00257895}, {1220,0.00228947}, {1230,0.00229825}, {1240,0.00263158}, {1250,0.00248246}, {1260,0.00245614}, {1270,0.00253509}, {1280,0.00202632}, {1290,0.00253509}, {1300,0.00239474}, {1310,0.00265789}, {1320,0.00234211}, {1330,0.00234211}, {1340,0.00253509}, {1350,0.00315789}, {1360,0.00270175}, {1370,0.00325439}, {1380,0.00301754}, {1390,0.00341228}, {1400,0.00321930}, {1410,0.00274561}, {1420,0.00314912}, {1430,0.00328947}, {1440,0.00264912}, {1450,0.00331579}, {1460,0.00345614}, {1470,0.00407895}, {1480,0.01042105}, {1490,0.00299123}, {1500,0.00333333}, {1510,0.00355263}, {1520,0.00342982}, {1530,0.00422807}, {1540,0.00282456}, {1550,0.00316667}, {1560,0.00315789}, {1570,0.00329825}, {1580,0.00358772}, {1590,0.01039474}, {1600,0.00269298}, {1610,0.00335088}, {1620,0.00359649}, {1630,0.00363158}, {1640,0.00344737}, {1650,0.00414912}, {1660,0.00376316}, {1670,0.00359649}, {1680,0.00424561}, {1690,0.00362281}, {1700,0.00384211}, {1710,0.00452632}, {1720,0.00427193}, {1730,0.01085088}, {1740,0.00414912}, {1750,0.00394737}, {1760,0.00380702}, {1770,0.00407018}, {1780,0.00455263}, {1790,0.00483333}, {1800,0.00424561}, {1810,0.00405263}, {1820,0.00413158}, {1830,0.00505263}, {1840,0.00390351}, {1850,0.01439474}, {1860,0.00428070}, {1870,0.00513158}, {1880,0.01228070}, {1890,0.00466667}, {1900,0.00478947}, {1910,0.00491228}, {1920,0.00440351}, {1930,0.00481579}, {1940,0.00455263}, {1950,0.00513158}, {1960,0.00429825}, {1970,0.00445614}, {1980,0.00478947}, {1990,0.00535088}, {2000,0.00508772}, {2050,0.00439474}, {2100,0.00520175}, {2150,0.00566667}, {2200,0.00559649}, {2250,0.00524561}, {2300,0.00666667}, {2350,0.00591228}, {2400,0.00577193}, {2450,0.01491228}, {2500,0.00648246}, {2550,0.00746491}, {2600,0.00630702}, {2650,0.00683333}, {2700,0.00688596}, {2750,0.00815789}, {2800,0.00765789}, {2850,0.00754386}, {2900,0.00860526}, {2950,0.00790351}, {3000,0.00870175}, {3050,0.00873684}, {3100,0.00741228}, {3150,0.00866667}, {3200,0.00745614}, {3250,0.00917544}, {3300,0.00924561}, {3350,0.00959649}, {3400,0.00903509}, {3450,0.00978070}, {3500,0.00974561}, {3550,0.01125439}, {3600,0.00873684}, {3650,0.00973684}, {3700,0.00999123}, {3750,0.01074561}, {3800,0.01141228}, {3850,0.01012281}, {3900,0.01121930}, {3950,0.01185965}, {4000,0.01090351}, {4050,0.01179825}, {4100,0.01008772}, {4150,0.01178070}, {4200,0.01170175}, {4250,0.01178070}, {4300,0.01249123}, {4350,0.02439474}, {4400,0.01202632}, {4450,0.01202632}, {4500,0.01274561}, {4550,0.01342105}, {4600,0.01354386}, {4650,0.01264035}, {4700,0.01351754}, {4750,0.01384211}, {4800,0.01363158}, {4850,0.01464035}, {4900,0.01435088}, {4950,0.01465789}, {5000,0.02213158}, {5050,0.01522807}, {5100,0.01555263}, {5150,0.01457018}, {5200,0.01421053}, {5250,0.01399123}, {5300,0.01547368}, {5350,0.01566667}, {5400,0.01471053}, {5450,0.01618421}, {5500,0.01667544}, {5550,0.01698246}, {5600,0.02286842}, {5650,0.01544737}, {5700,0.01615789}, {5750,0.01744737}, {5800,0.01647368}, {5850,0.01789474}, {5900,0.01656140}, {5950,0.01855263}, {6000,0.01762281}, {6050,0.018500}, {6100,0.018643}, {6150,0.016857}, {6200,0.017857}, {6250,0.018429}, {6300,0.017857}, {6350,0.019143}, {6400,0.016571}, {6450,0.018857}, {6500,0.018929}, {6550,0.019857}, {6600,0.019357}, {6650,0.022643}, {6700,0.018429}, {6750,0.028429}, {6800,0.018857}, {6850,0.020214}, {6900,0.022286}, {6950,0.021286}, {7000,0.021357}, {7050,0.022143}, {7100,0.023000}, {7150,0.024143}, {7200,0.019143}, {7250,0.020786}, {7300,0.020071}, {7350,0.030000}, {7400,0.023143}, {7450,0.022214}, {7500,0.022214}, {7550,0.032714}, {7600,0.023000}, {7650,0.023143}, {7700,0.037571}, {7750,0.030571}, {7800,0.023929}, {7850,0.023571}, {7900,0.024643}, {7950,0.032786}, {8000,0.030071}, {8050,0.025714}, {8100,0.024357}, {8150,0.039071}, {8200,0.021929}, {8250,0.024429}, {8300,0.024643}, {8350,0.025286}, {8400,0.031000}, {8450,0.023000}, {8500,0.025286}, {8550,0.026286}, {8600,0.043929}, {8650,0.026714}, {8700,0.028214}, {8750,0.027429}, {8800,0.025286}, {8850,0.026071}, {8900,0.026071}, {8950,0.029286}, {9000,0.026286}, {9050,0.028357}, {9100,0.028000}, {9150,0.030929}, {9200,0.029071}, {9250,0.026214}, {9300,0.026143}, {9350,0.027429}, {9400,0.028571}, {9450,0.028286}, {9500,0.028286}, {9550,0.045500}, {9600,0.026643}, {9650,0.037500}, {9700,0.045500}, {9750,0.029214}, {9800,0.029500}, {9850,0.038714}, {9900,0.029786}, {9950,0.032571}, {10000,0.028929}, {10100,0.032357}, {10200,0.033714}, {10300,0.046786}, {10400,0.029071}, {10500,0.029214}, {10600,0.031357}, {10700,0.033214}, {10800,0.030929}, {10900,0.032500}, {11000,0.042429}, {11100,0.036500}, {11200,0.032357}, {11300,0.032857}, {11400,0.040571}, {11500,0.036286}, {11600,0.036000}, {11700,0.044714}, {11800,0.035143}, {11900,0.039643}, {12000,0.036786}, {12100,0.037714}, {12200,0.038857}, {12300,0.034786}, {12400,0.037286}, {12500,0.038000}, {12600,0.065000}, {12700,0.040357}, {12800,0.034500}, {12900,0.048214}, {13000,0.039143}, {13100,0.048357}, {13200,0.047000}, {13300,0.046071}, {13400,0.047571}, {13500,0.043357}, {13600,0.039143}, {13700,0.041357}, {13800,0.043643}, {13900,0.050571}, {14000,0.043714}, {14100,0.043429}, {14200,0.046643}, {14300,0.048429}, {14400,0.039571}, {14500,0.042429}, {14600,0.042214}, {14700,0.045929}, {14800,0.046286}, {14900,0.047786}, {15000,0.046143}, {15100,0.050714}, {15200,0.046571}, {15300,0.056214}, {15400,0.045143}, {15500,0.047286}, {15600,0.048929}, {15700,0.049071}, {15800,0.059000}, {15900,0.050000}, {16000,0.049143}, {16100,0.052071}, {16200,0.051000}, {16300,0.055429}, {16400,0.053429}, {16500,0.074000}, {16600,0.050786}, {16700,0.052786}, {16800,0.060143}, {16900,0.048786}, {17000,0.049500}, {17100,0.053929}, {17200,0.050857}, {17300,0.071714}, {17400,0.066286}, {17500,0.063000}, {17600,0.051357}, {17700,0.061786}, {17800,0.054857}, {17900,0.084071}, {18000,0.054929}, {18100,0.057000}, {18200,0.055643}, {18300,0.064143}, {18400,0.059286}, {18500,0.054214}, {18600,0.056429}, {18700,0.057143}, {18800,0.059500}, {18900,0.060500}, {19000,0.059357}, {19100,0.069929}, {19200,0.093214}, {19300,0.060286}, {19400,0.079786}, {19500,0.076643}, {19600,0.067000}, {19700,0.075143}, {19800,0.064000}, {19900,0.068571}, {20000,0.059714}};
data["big_flat"]["TypeClassesBodyHOAS"]["eval lazy"]["user"] = {{1,0.00007018}, {2,0.00000000}, {3,0.00003509}, {4,0.00000000}, {5,0.00006140}, {6,0.00009649}, {7,0.00007018}, {8,0.00003509}, {9,0.00003509}, {10,0.00000000}, {11,0.00002632}, {12,0.00007018}, {13,0.00006140}, {14,0.00014035}, {15,0.00019298}, {16,0.00006140}, {17,0.00000000}, {18,0.00014035}, {19,0.00009649}, {20,0.00013158}, {21,0.00010526}, {22,0.00000000}, {23,0.00000000}, {24,0.00003509}, {25,0.00003509}, {26,0.00007018}, {27,0.00013158}, {28,0.00006140}, {29,0.00015789}, {30,0.00003509}, {31,0.00009649}, {32,0.00003509}, {33,0.00009649}, {34,0.00008772}, {35,0.00014035}, {36,0.00006140}, {37,0.00007018}, {38,0.00003509}, {39,0.00009649}, {40,0.00009649}, {41,0.00008772}, {42,0.00008772}, {43,0.00009649}, {44,0.00000000}, {45,0.00014035}, {46,0.00014035}, {47,0.00009649}, {48,0.00003509}, {49,0.00010526}, {50,0.00009649}, {51,0.00007018}, {52,0.00015789}, {53,0.00003509}, {54,0.00023684}, {55,0.00008772}, {56,0.00009649}, {57,0.00009649}, {58,0.00020175}, {59,0.00013158}, {60,0.00034211}, {61,0.00014035}, {62,0.00003509}, {63,0.00024561}, {64,0.00007895}, {65,0.00014912}, {66,0.00021053}, {67,0.00002632}, {68,0.00032456}, {69,0.00025439}, {70,0.00015789}, {71,0.00008772}, {72,0.00021930}, {73,0.00014035}, {74,0.00027193}, {75,0.00018421}, {76,0.00006140}, {77,0.00013158}, {78,0.00019298}, {79,0.00007018}, {80,0.00008772}, {81,0.00010526}, {82,0.00019298}, {83,0.00013158}, {84,0.00013158}, {85,0.00021930}, {86,0.00013158}, {87,0.00012281}, {88,0.00017544}, {89,0.00026316}, {90,0.00021930}, {91,0.00015789}, {92,0.00012281}, {93,0.00009649}, {94,0.00026316}, {95,0.00021930}, {96,0.00018421}, {97,0.00019298}, {98,0.00028947}, {99,0.00019298}, {100,0.00021930}, {101,0.00024561}, {102,0.00021053}, {103,0.00013158}, {104,0.00008772}, {105,0.00019298}, {106,0.00016667}, {107,0.00029825}, {108,0.00028947}, {109,0.00025439}, {110,0.00009649}, {111,0.00028947}, {112,0.00014912}, {113,0.00031579}, {114,0.00031579}, {115,0.00021053}, {116,0.00021930}, {117,0.00022807}, {118,0.00023684}, {119,0.00032456}, {120,0.00020175}, {121,0.00034211}, {122,0.00017544}, {123,0.00018421}, {124,0.00028947}, {125,0.00023684}, {126,0.00026316}, {127,0.00037719}, {128,0.00017544}, {129,0.00016667}, {130,0.00012281}, {131,0.00020175}, {132,0.00031579}, {133,0.00021930}, {134,0.00025439}, {135,0.00021930}, {136,0.00023684}, {137,0.00038596}, {138,0.00025439}, {139,0.00009649}, {140,0.00031579}, {141,0.00016667}, {142,0.00047368}, {143,0.00005263}, {144,0.00019298}, {145,0.00022807}, {146,0.00030702}, {147,0.00021930}, {148,0.00041228}, {149,0.00014912}, {150,0.00021053}, {151,0.00040351}, {152,0.00017544}, {153,0.00036842}, {154,0.00034211}, {155,0.00055263}, {156,0.00025439}, {157,0.00048246}, {158,0.00040351}, {159,0.00029825}, {160,0.00042982}, {161,0.00010526}, {162,0.00024561}, {163,0.00021053}, {164,0.00026316}, {165,0.00036842}, {166,0.00042105}, {167,0.00028070}, {168,0.00030702}, {169,0.00019298}, {170,0.00024561}, {171,0.00042105}, {172,0.00033333}, {173,0.00034211}, {174,0.00014035}, {175,0.00029825}, {176,0.00033333}, {177,0.00050000}, {178,0.00020175}, {179,0.00046491}, {180,0.00035965}, {181,0.00036842}, {182,0.00042982}, {183,0.00036842}, {184,0.00028947}, {185,0.00021930}, {186,0.00029825}, {187,0.00046491}, {188,0.00037719}, {189,0.00023684}, {190,0.00049123}, {191,0.00059649}, {192,0.00032456}, {193,0.00029825}, {194,0.00026316}, {195,0.00044737}, {196,0.00038596}, {197,0.00034211}, {198,0.00046491}, {199,0.00013158}, {200,0.00038596}, {201,0.00018421}, {202,0.00034211}, {203,0.00029825}, {204,0.00026316}, {205,0.00040351}, {206,0.00031579}, {207,0.00027193}, {208,0.00034211}, {209,0.00025439}, {210,0.00036842}, {211,0.00024561}, {212,0.00040351}, {213,0.00050877}, {214,0.00053509}, {215,0.00030702}, {216,0.00043860}, {217,0.00036842}, {218,0.00044737}, {219,0.00028070}, {220,0.00045614}, {221,0.00050877}, {222,0.00061404}, {223,0.00072807}, {224,0.00035088}, {225,0.00029825}, {226,0.00036842}, {227,0.00030702}, {228,0.00038596}, {229,0.00052632}, {230,0.00050877}, {231,0.00051754}, {232,0.00038596}, {233,0.00031579}, {234,0.00049123}, {235,0.00051754}, {236,0.00035965}, {237,0.00031579}, {238,0.00049123}, {239,0.00046491}, {240,0.00042982}, {241,0.00049123}, {242,0.00046491}, {243,0.00064035}, {244,0.00035965}, {245,0.00062281}, {246,0.00055263}, {247,0.00042982}, {248,0.00038596}, {249,0.00042105}, {250,0.00070175}, {251,0.00045614}, {252,0.00050000}, {253,0.00037719}, {254,0.00053509}, {255,0.00025439}, {256,0.00067544}, {257,0.00045614}, {258,0.00057018}, {259,0.00055263}, {260,0.00043860}, {261,0.00035965}, {262,0.00050877}, {263,0.00261404}, {264,0.00042982}, {265,0.00040351}, {266,0.00057895}, {267,0.00063158}, {268,0.00040351}, {269,0.00037719}, {270,0.00110526}, {271,0.00041228}, {272,0.00028070}, {273,0.00048246}, {274,0.00055263}, {275,0.00059649}, {276,0.00072807}, {277,0.00057895}, {278,0.00045614}, {279,0.00068421}, {280,0.00047368}, {281,0.00050000}, {282,0.00053509}, {283,0.00042982}, {284,0.00042982}, {285,0.00066667}, {286,0.00050000}, {287,0.00050000}, {288,0.00050877}, {289,0.00050000}, {290,0.00063158}, {291,0.00052632}, {292,0.00038596}, {293,0.00055263}, {294,0.00046491}, {295,0.00051754}, {296,0.00085088}, {297,0.00052632}, {298,0.00050877}, {299,0.00040351}, {300,0.00090351}, {301,0.00048246}, {302,0.00070175}, {303,0.00057018}, {304,0.00033333}, {305,0.00054386}, {306,0.00053509}, {307,0.00053509}, {308,0.00083333}, {309,0.00064912}, {310,0.00102632}, {311,0.00071053}, {312,0.00075439}, {313,0.00056140}, {314,0.00061404}, {315,0.00055263}, {316,0.00078947}, {317,0.00056140}, {318,0.00088596}, {319,0.00032456}, {320,0.00035965}, {321,0.00057895}, {322,0.00038596}, {323,0.00060526}, {324,0.00055263}, {325,0.00048246}, {326,0.00046491}, {327,0.00057018}, {328,0.00057018}, {329,0.00053509}, {330,0.00071053}, {331,0.00050877}, {332,0.00064035}, {333,0.00047368}, {334,0.00041228}, {335,0.00057018}, {336,0.00049123}, {337,0.00060526}, {338,0.00050877}, {339,0.00070175}, {340,0.00045614}, {341,0.00057018}, {342,0.00050877}, {343,0.00069298}, {344,0.00070175}, {345,0.00052632}, {346,0.00063158}, {347,0.00043860}, {348,0.00079825}, {349,0.00052632}, {350,0.00064912}, {351,0.00048246}, {352,0.00094737}, {353,0.00044737}, {354,0.00052632}, {355,0.00054386}, {356,0.00064912}, {357,0.00077193}, {358,0.00088596}, {359,0.00063158}, {360,0.00100877}, {361,0.00065789}, {362,0.00069298}, {363,0.00078947}, {364,0.00073684}, {365,0.00062281}, {366,0.00074561}, {367,0.00074561}, {368,0.00078947}, {369,0.00085965}, {370,0.00051754}, {371,0.00071930}, {372,0.00038596}, {373,0.00058772}, {374,0.00066667}, {375,0.00081579}, {376,0.00065789}, {377,0.00073684}, {378,0.00057895}, {379,0.00090351}, {380,0.00063158}, {381,0.00080702}, {382,0.00071053}, {383,0.00092105}, {384,0.00080702}, {385,0.00070175}, {386,0.00052632}, {387,0.00109649}, {388,0.00079825}, {389,0.00024561}, {390,0.00094737}, {391,0.00106140}, {392,0.00052632}, {393,0.00080702}, {394,0.00049123}, {395,0.00041228}, {396,0.00051754}, {397,0.00075439}, {398,0.00080702}, {399,0.00073684}, {400,0.00080702}, {401,0.00067544}, {402,0.00063158}, {403,0.00082456}, {404,0.00074561}, {405,0.00091228}, {406,0.00078947}, {407,0.00078070}, {408,0.00064035}, {409,0.00080702}, {410,0.00061404}, {411,0.00053509}, {412,0.00060526}, {413,0.00065789}, {414,0.00077193}, {415,0.00078947}, {416,0.00094737}, {417,0.00091228}, {418,0.00415789}, {419,0.00059649}, {420,0.00059649}, {421,0.00114035}, {422,0.00081579}, {423,0.00079825}, {424,0.00079825}, {425,0.00092105}, {426,0.00052632}, {427,0.00762281}, {428,0.00055263}, {429,0.00078947}, {430,0.00078070}, {431,0.00090351}, {432,0.00061404}, {433,0.00090351}, {434,0.00078947}, {435,0.00116667}, {436,0.00066667}, {437,0.00088596}, {438,0.00076316}, {439,0.00078947}, {440,0.00089474}, {441,0.00081579}, {442,0.00100000}, {443,0.00089474}, {444,0.00085088}, {445,0.00101754}, {446,0.00087719}, {447,0.00076316}, {448,0.00050000}, {449,0.00088596}, {450,0.00086842}, {451,0.00086842}, {452,0.00065789}, {453,0.00059649}, {454,0.00103509}, {455,0.00103509}, {456,0.00065789}, {457,0.00105263}, {458,0.00077193}, {459,0.00091228}, {460,0.00111404}, {461,0.00065789}, {462,0.00103509}, {463,0.00085965}, {464,0.00093860}, {465,0.00104386}, {466,0.00079825}, {467,0.00090351}, {468,0.00078947}, {469,0.00065789}, {470,0.00097368}, {471,0.00073684}, {472,0.00117544}, {473,0.00099123}, {474,0.00086842}, {475,0.00091228}, {476,0.00092105}, {477,0.00090351}, {478,0.00113158}, {479,0.00107895}, {480,0.00092105}, {481,0.00090351}, {482,0.00084211}, {483,0.00092105}, {484,0.00101754}, {485,0.00095614}, {486,0.00114912}, {487,0.00076316}, {488,0.00061404}, {489,0.00071053}, {490,0.00083333}, {491,0.00092105}, {492,0.00112281}, {493,0.00098246}, {494,0.00064035}, {495,0.00114035}, {496,0.00108772}, {497,0.00112281}, {498,0.00127193}, {499,0.00120175}, {500,0.00112281}, {505,0.00094737}, {510,0.00120175}, {515,0.00108772}, {520,0.00108772}, {525,0.00140351}, {530,0.00094737}, {535,0.00107895}, {540,0.00122807}, {545,0.00106140}, {550,0.00077193}, {555,0.00853509}, {560,0.00128070}, {565,0.00110526}, {570,0.00086842}, {575,0.00091228}, {580,0.00125439}, {585,0.00131579}, {590,0.00109649}, {595,0.00092105}, {600,0.00085088}, {605,0.00135965}, {610,0.00112281}, {615,0.00146491}, {620,0.00120175}, {625,0.00126316}, {630,0.00085965}, {635,0.00824561}, {640,0.00105263}, {645,0.00116667}, {650,0.00130702}, {655,0.00143860}, {660,0.00093860}, {665,0.00109649}, {670,0.00096491}, {675,0.00103509}, {680,0.00127193}, {685,0.00173684}, {690,0.00215789}, {695,0.00178947}, {700,0.00168421}, {705,0.00137719}, {710,0.00186842}, {715,0.00148246}, {720,0.00130702}, {725,0.00154386}, {730,0.00153509}, {735,0.00188596}, {740,0.00192105}, {745,0.00160526}, {750,0.00199123}, {755,0.00184211}, {760,0.00138596}, {765,0.00119298}, {770,0.00098246}, {775,0.00127193}, {780,0.00109649}, {785,0.00136842}, {790,0.00155263}, {795,0.00142105}, {800,0.00121930}, {805,0.00158772}, {810,0.00161404}, {815,0.00245614}, {820,0.00220175}, {825,0.00200877}, {830,0.00149123}, {835,0.00150000}, {840,0.00150877}, {845,0.00203509}, {850,0.00185965}, {855,0.00200877}, {860,0.00171930}, {865,0.00144737}, {870,0.00119298}, {875,0.00187719}, {880,0.00215789}, {885,0.00171930}, {890,0.00192105}, {895,0.00212281}, {900,0.00153509}, {905,0.00169298}, {910,0.00190351}, {915,0.00221930}, {920,0.00162281}, {925,0.00196491}, {930,0.00193860}, {935,0.00242105}, {940,0.00200000}, {945,0.00183333}, {950,0.00235088}, {955,0.00231579}, {960,0.00190351}, {965,0.00212281}, {970,0.00207895}, {975,0.00210526}, {980,0.00239474}, {985,0.00178947}, {990,0.00256140}, {995,0.00213158}, {1000,0.00183333}, {1010,0.00916667}, {1020,0.00250000}, {1030,0.00207895}, {1040,0.00174561}, {1050,0.00228070}, {1060,0.00249123}, {1070,0.00252632}, {1080,0.00194737}, {1090,0.00252632}, {1100,0.00185965}, {1110,0.00273684}, {1120,0.00188596}, {1130,0.00214035}, {1140,0.00242982}, {1150,0.00315789}, {1160,0.00245614}, {1170,0.00233333}, {1180,0.00277193}, {1190,0.00243860}, {1200,0.00197368}, {1210,0.00287719}, {1220,0.00237719}, {1230,0.00264035}, {1240,0.00270175}, {1250,0.00281579}, {1260,0.00265789}, {1270,0.00305263}, {1280,0.00205263}, {1290,0.00285088}, {1300,0.00247368}, {1310,0.00293860}, {1320,0.00232456}, {1330,0.00228947}, {1340,0.00252632}, {1350,0.00328947}, {1360,0.00287719}, {1370,0.00327193}, {1380,0.00309649}, {1390,0.00354386}, {1400,0.00317544}, {1410,0.00297368}, {1420,0.00322807}, {1430,0.00341228}, {1440,0.00305263}, {1450,0.00321930}, {1460,0.00373684}, {1470,0.00385965}, {1480,0.01066667}, {1490,0.00316667}, {1500,0.00349123}, {1510,0.00378070}, {1520,0.00354386}, {1530,0.00450877}, {1540,0.00300877}, {1550,0.00321930}, {1560,0.00319298}, {1570,0.00341228}, {1580,0.00380702}, {1590,0.01057018}, {1600,0.00297368}, {1610,0.00350000}, {1620,0.00376316}, {1630,0.00359649}, {1640,0.00354386}, {1650,0.00400877}, {1660,0.00392982}, {1670,0.00385965}, {1680,0.00452632}, {1690,0.00385088}, {1700,0.00402632}, {1710,0.00450000}, {1720,0.00427193}, {1730,0.01085088}, {1740,0.00397368}, {1750,0.00388596}, {1760,0.00400000}, {1770,0.00434211}, {1780,0.00467544}, {1790,0.00501754}, {1800,0.00406140}, {1810,0.00428070}, {1820,0.00428070}, {1830,0.00521053}, {1840,0.00411404}, {1850,0.01445614}, {1860,0.00450000}, {1870,0.00516667}, {1880,0.01256140}, {1890,0.00484211}, {1900,0.00475439}, {1910,0.00498246}, {1920,0.00490351}, {1930,0.00497368}, {1940,0.00500000}, {1950,0.00551754}, {1960,0.00417544}, {1970,0.00499123}, {1980,0.00485965}, {1990,0.00548246}, {2000,0.00535088}, {2050,0.00437719}, {2100,0.00528947}, {2150,0.00581579}, {2200,0.00584211}, {2250,0.00519298}, {2300,0.00690351}, {2350,0.00607895}, {2400,0.00580702}, {2450,0.01496491}, {2500,0.00670175}, {2550,0.00742982}, {2600,0.00606140}, {2650,0.00692105}, {2700,0.00650000}, {2750,0.00823684}, {2800,0.00747368}, {2850,0.00743860}, {2900,0.00871930}, {2950,0.00775439}, {3000,0.00845614}, {3050,0.00855263}, {3100,0.00742982}, {3150,0.00903509}, {3200,0.00750000}, {3250,0.00913158}, {3300,0.00913158}, {3350,0.00971053}, {3400,0.00912281}, {3450,0.01020175}, {3500,0.00987719}, {3550,0.01080702}, {3600,0.00917544}, {3650,0.00960526}, {3700,0.01016667}, {3750,0.01110526}, {3800,0.01145614}, {3850,0.01032456}, {3900,0.01132456}, {3950,0.01168421}, {4000,0.01079825}, {4050,0.01184211}, {4100,0.00992105}, {4150,0.01190351}, {4200,0.01151754}, {4250,0.01174561}, {4300,0.01250000}, {4350,0.02469298}, {4400,0.01203509}, {4450,0.01243860}, {4500,0.01302632}, {4550,0.01337719}, {4600,0.01356140}, {4650,0.01263158}, {4700,0.01341228}, {4750,0.01381579}, {4800,0.01300877}, {4850,0.01435965}, {4900,0.01422807}, {4950,0.01450877}, {5000,0.02256140}, {5050,0.01500877}, {5100,0.01518421}, {5150,0.01473684}, {5200,0.01400000}, {5250,0.01400000}, {5300,0.01505263}, {5350,0.01571930}, {5400,0.01468421}, {5450,0.01618421}, {5500,0.01643860}, {5550,0.01697368}, {5600,0.02295614}, {5650,0.01532456}, {5700,0.01598246}, {5750,0.01700000}, {5800,0.01653509}, {5850,0.01771053}, {5900,0.01644737}, {5950,0.01833333}, {6000,0.01736842}, {6050,0.018286}, {6100,0.018286}, {6150,0.017143}, {6200,0.017929}, {6250,0.017429}, {6300,0.017286}, {6350,0.018714}, {6400,0.016500}, {6450,0.018286}, {6500,0.018929}, {6550,0.020071}, {6600,0.019286}, {6650,0.022571}, {6700,0.017643}, {6750,0.029286}, {6800,0.018143}, {6850,0.019357}, {6900,0.022500}, {6950,0.021429}, {7000,0.021357}, {7050,0.020929}, {7100,0.023429}, {7150,0.024000}, {7200,0.018929}, {7250,0.021143}, {7300,0.019214}, {7350,0.030000}, {7400,0.023000}, {7450,0.022286}, {7500,0.022500}, {7550,0.033000}, {7600,0.022500}, {7650,0.022571}, {7700,0.037571}, {7750,0.030857}, {7800,0.023429}, {7850,0.023500}, {7900,0.024929}, {7950,0.032500}, {8000,0.030000}, {8050,0.025286}, {8100,0.023214}, {8150,0.038429}, {8200,0.021857}, {8250,0.024286}, {8300,0.025071}, {8350,0.025286}, {8400,0.031643}, {8450,0.022429}, {8500,0.024143}, {8550,0.026500}, {8600,0.044143}, {8650,0.026571}, {8700,0.027929}, {8750,0.028000}, {8800,0.025500}, {8850,0.026643}, {8900,0.027071}, {8950,0.029286}, {9000,0.026500}, {9050,0.028857}, {9100,0.027571}, {9150,0.031643}, {9200,0.029000}, {9250,0.026500}, {9300,0.026071}, {9350,0.027357}, {9400,0.028071}, {9450,0.028429}, {9500,0.028143}, {9550,0.046214}, {9600,0.027071}, {9650,0.037357}, {9700,0.045857}, {9750,0.029714}, {9800,0.029714}, {9850,0.038214}, {9900,0.030071}, {9950,0.033429}, {10000,0.029071}, {10100,0.032000}, {10200,0.033143}, {10300,0.047714}, {10400,0.029714}, {10500,0.028143}, {10600,0.030500}, {10700,0.033071}, {10800,0.031143}, {10900,0.032286}, {11000,0.042071}, {11100,0.037286}, {11200,0.031714}, {11300,0.032714}, {11400,0.040786}, {11500,0.036357}, {11600,0.035071}, {11700,0.045429}, {11800,0.035214}, {11900,0.039143}, {12000,0.037286}, {12100,0.037000}, {12200,0.038714}, {12300,0.035143}, {12400,0.037000}, {12500,0.038071}, {12600,0.063643}, {12700,0.040071}, {12800,0.034714}, {12900,0.047643}, {13000,0.038571}, {13100,0.048357}, {13200,0.047571}, {13300,0.045500}, {13400,0.047929}, {13500,0.042786}, {13600,0.038643}, {13700,0.040214}, {13800,0.044714}, {13900,0.050786}, {14000,0.044000}, {14100,0.042857}, {14200,0.046643}, {14300,0.049143}, {14400,0.040000}, {14500,0.042500}, {14600,0.042857}, {14700,0.046143}, {14800,0.045714}, {14900,0.048429}, {15000,0.047429}, {15100,0.051071}, {15200,0.046857}, {15300,0.056214}, {15400,0.045357}, {15500,0.047500}, {15600,0.049071}, {15700,0.049429}, {15800,0.058929}, {15900,0.049571}, {16000,0.049429}, {16100,0.052643}, {16200,0.051500}, {16300,0.055429}, {16400,0.054000}, {16500,0.074214}, {16600,0.051429}, {16700,0.053357}, {16800,0.059286}, {16900,0.049143}, {17000,0.049143}, {17100,0.054071}, {17200,0.050500}, {17300,0.071357}, {17400,0.066286}, {17500,0.063214}, {17600,0.050429}, {17700,0.062214}, {17800,0.055214}, {17900,0.084286}, {18000,0.055357}, {18100,0.057071}, {18200,0.055500}, {18300,0.064357}, {18400,0.059143}, {18500,0.054000}, {18600,0.056571}, {18700,0.056929}, {18800,0.060214}, {18900,0.060286}, {19000,0.059000}, {19100,0.069500}, {19200,0.093571}, {19300,0.059571}, {19400,0.078786}, {19500,0.076500}, {19600,0.066000}, {19700,0.075214}, {19800,0.064214}, {19900,0.068500}, {20000,0.059000}};
data["big_flat"]["TypeClassesBodyHOAS"]["eval lazy"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00003509}, {72,0.00003509}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00003509}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00003509}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00003509}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00003509}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00003509}, {169,0.00000000}, {170,0.00000000}, {171,0.00003509}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00003509}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00003509}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00003509}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00003509}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00003509}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00003509}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00003509}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00003509}, {288,0.00000000}, {289,0.00000000}, {290,0.00003509}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00003509}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00003509}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00003509}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00003509}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00003509}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00003509}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00003509}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00003509}, {410,0.00000000}, {411,0.00003509}, {412,0.00000000}, {413,0.00003509}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00021053}, {428,0.00003509}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00003509}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00003509}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00003509}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00003509}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00003509}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00003509}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00003509}, {488,0.00003509}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00003509}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00045614}, {560,0.00000000}, {565,0.00003509}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00003509}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00014035}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00003509}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00003509}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00007018}, {730,0.00000000}, {735,0.00000000}, {740,0.00003509}, {745,0.00000000}, {750,0.00003509}, {755,0.00000000}, {760,0.00000000}, {765,0.00002632}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00003509}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00003509}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00003509}, {870,0.00003509}, {875,0.00003509}, {880,0.00000000}, {885,0.00000000}, {890,0.00003509}, {895,0.00003509}, {900,0.00000000}, {905,0.00003509}, {910,0.00000000}, {915,0.00003509}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00007018}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00003509}, {985,0.00007018}, {990,0.00000000}, {995,0.00003509}, {1000,0.00000000}, {1010,0.00030702}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00003509}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00003509}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00002632}, {1200,0.00003509}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00003509}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00003509}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00003509}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00003509}, {1400,0.00003509}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00003509}, {1440,0.00000000}, {1450,0.00007018}, {1460,0.00000000}, {1470,0.00010526}, {1480,0.00003509}, {1490,0.00003509}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00003509}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00007018}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00007018}, {1630,0.00003509}, {1640,0.00003509}, {1650,0.00003509}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00003509}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00003509}, {1730,0.00000000}, {1740,0.00003509}, {1750,0.00000000}, {1760,0.00007018}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00003509}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00007018}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00010526}, {1890,0.00000000}, {1900,0.00007018}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00007018}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00003509}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00003509}, {2150,0.00006140}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00003509}, {2400,0.00000000}, {2450,0.00010526}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00007018}, {2650,0.00000000}, {2700,0.00003509}, {2750,0.00007018}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00007018}, {2950,0.00007018}, {3000,0.00003509}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00003509}, {3200,0.00003509}, {3250,0.00000000}, {3300,0.00003509}, {3350,0.00003509}, {3400,0.00003509}, {3450,0.00003509}, {3500,0.00003509}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00002632}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00003509}, {4050,0.00000000}, {4100,0.00003509}, {4150,0.00000000}, {4200,0.00007018}, {4250,0.00000000}, {4300,0.00003509}, {4350,0.00000000}, {4400,0.00003509}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00003509}, {4700,0.00003509}, {4750,0.00000000}, {4800,0.00007018}, {4850,0.00003509}, {4900,0.00000000}, {4950,0.00003509}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00003509}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00003509}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00003509}, {5550,0.00000000}, {5600,0.00007018}, {5650,0.00000000}, {5700,0.00003509}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00003509}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000286}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000000}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClassesBodyHOAS"]["lazy beta iota"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00009649}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00014035}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00013158}, {955,0.00075439}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00785088}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00008772}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00089474}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00008772}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000877}, {2250,0.00002632}, {2300,0.00009649}, {2350,0.00024561}, {2400,0.00035088}, {2450,0.00071053}, {2500,0.00074561}, {2550,0.00085088}, {2600,0.00085965}, {2650,0.00096491}, {2700,0.00100000}, {2750,0.00100000}, {2800,0.00100000}, {2850,0.00100000}, {2900,0.00100000}, {2950,0.00100000}, {3000,0.00100000}, {3050,0.00100000}, {3100,0.00100000}, {3150,0.00100000}, {3200,0.00100000}, {3250,0.00966667}, {3300,0.00100000}, {3350,0.00100000}, {3400,0.00100000}, {3450,0.00100000}, {3500,0.00100000}, {3550,0.00100000}, {3600,0.00100000}, {3650,0.00100000}, {3700,0.00100000}, {3750,0.00100000}, {3800,0.00100000}, {3850,0.00100000}, {3900,0.00100000}, {3950,0.00100000}, {4000,0.00100000}, {4050,0.00100000}, {4100,0.00100877}, {4150,0.00100000}, {4200,0.00100000}, {4250,0.00100000}, {4300,0.00201754}, {4350,0.00100000}, {4400,0.00103509}, {4450,0.00203509}, {4500,0.00103509}, {4550,0.00107018}, {4600,0.00115789}, {4650,0.00123684}, {4700,0.00142105}, {4750,0.00160526}, {4800,0.00174561}, {4850,0.00177193}, {4900,0.00179825}, {4950,0.00182456}, {5000,0.00179825}, {5050,0.00182456}, {5100,0.00303509}, {5150,0.00200000}, {5200,0.01528947}, {5250,0.00200000}, {5300,0.00200000}, {5350,0.00200000}, {5400,0.00200000}, {5450,0.00200000}, {5500,0.00200000}, {5550,0.00200000}, {5600,0.00200000}, {5650,0.00200000}, {5700,0.01324561}, {5750,0.00200000}, {5800,0.00200000}, {5850,0.00200000}, {5900,0.00200000}, {5950,0.00200000}, {6000,0.00200000}, {6050,0.002000}, {6100,0.002000}, {6150,0.003000}, {6200,0.002000}, {6250,0.002000}, {6300,0.002071}, {6350,0.002071}, {6400,0.002000}, {6450,0.002071}, {6500,0.002071}, {6550,0.002071}, {6600,0.002214}, {6650,0.002071}, {6700,0.002143}, {6750,0.002357}, {6800,0.002357}, {6850,0.002357}, {6900,0.002429}, {6950,0.002429}, {7000,0.002429}, {7050,0.002571}, {7100,0.002857}, {7150,0.002929}, {7200,0.002929}, {7250,0.002857}, {7300,0.002857}, {7350,0.002857}, {7400,0.002857}, {7450,0.002857}, {7500,0.002929}, {7550,0.002857}, {7600,0.015500}, {7650,0.002857}, {7700,0.003000}, {7750,0.003000}, {7800,0.003929}, {7850,0.003000}, {7900,0.003000}, {7950,0.003000}, {8000,0.003000}, {8050,0.003000}, {8100,0.003000}, {8150,0.003000}, {8200,0.003000}, {8250,0.003000}, {8300,0.003000}, {8350,0.003000}, {8400,0.003000}, {8450,0.003071}, {8500,0.004357}, {8550,0.003000}, {8600,0.003071}, {8650,0.003143}, {8700,0.003143}, {8750,0.003214}, {8800,0.025214}, {8850,0.003357}, {8900,0.003500}, {8950,0.003500}, {9000,0.003500}, {9050,0.003429}, {9100,0.017571}, {9150,0.003500}, {9200,0.003500}, {9250,0.003571}, {9300,0.003571}, {9350,0.003571}, {9400,0.003643}, {9450,0.003714}, {9500,0.003786}, {9550,0.003786}, {9600,0.003786}, {9650,0.003786}, {9700,0.003857}, {9750,0.003857}, {9800,0.003929}, {9850,0.003857}, {9900,0.003857}, {9950,0.003929}, {10000,0.003857}, {10100,0.003929}, {10200,0.004000}, {10300,0.004000}, {10400,0.004000}, {10500,0.004071}, {10600,0.004000}, {10700,0.004286}, {10800,0.004357}, {10900,0.004357}, {11000,0.004357}, {11100,0.004429}, {11200,0.004429}, {11300,0.004429}, {11400,0.004429}, {11500,0.004643}, {11600,0.004643}, {11700,0.004786}, {11800,0.004857}, {11900,0.026643}, {12000,0.004929}, {12100,0.004929}, {12200,0.004929}, {12300,0.004929}, {12400,0.004929}, {12500,0.004929}, {12600,0.005000}, {12700,0.005071}, {12800,0.005143}, {12900,0.006571}, {13000,0.005286}, {13100,0.005429}, {13200,0.005357}, {13300,0.025429}, {13400,0.005357}, {13500,0.005429}, {13600,0.005500}, {13700,0.005786}, {13800,0.005786}, {13900,0.005786}, {14000,0.005857}, {14100,0.005929}, {14200,0.027214}, {14300,0.027286}, {14400,0.007429}, {14500,0.005929}, {14600,0.031357}, {14700,0.006000}, {14800,0.006214}, {14900,0.006143}, {15000,0.025143}, {15100,0.006357}, {15200,0.026857}, {15300,0.006429}, {15400,0.006357}, {15500,0.006429}, {15600,0.006571}, {15700,0.006786}, {15800,0.006786}, {15900,0.006714}, {16000,0.006786}, {16100,0.006786}, {16200,0.006786}, {16300,0.006857}, {16400,0.008357}, {16500,0.006929}, {16600,0.033286}, {16700,0.006929}, {16800,0.007071}, {16900,0.026500}, {17000,0.007214}, {17100,0.007286}, {17200,0.007357}, {17300,0.007429}, {17400,0.007429}, {17500,0.009071}, {17600,0.040500}, {17700,0.007571}, {17800,0.027643}, {17900,0.007786}, {18000,0.034714}, {18100,0.009286}, {18200,0.007786}, {18300,0.026357}, {18400,0.028786}, {18500,0.044643}, {18600,0.009786}, {18700,0.007857}, {18800,0.008071}, {18900,0.009571}, {19000,0.037286}, {19100,0.010500}, {19200,0.008286}, {19300,0.008357}, {19400,0.008429}, {19500,0.008429}, {19600,0.008643}, {19700,0.008500}, {19800,0.008786}, {19900,0.008786}, {20000,0.008786}};
data["big_flat"]["TypeClassesBodyHOAS"]["lazy beta iota"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00003509}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00002632}, {12,0.00000000}, {13,0.00003509}, {14,0.00000000}, {15,0.00002632}, {16,0.00006140}, {17,0.00003509}, {18,0.00006140}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00006140}, {23,0.00003509}, {24,0.00003509}, {25,0.00000000}, {26,0.00003509}, {27,0.00003509}, {28,0.00007018}, {29,0.00000000}, {30,0.00006140}, {31,0.00002632}, {32,0.00000000}, {33,0.00000000}, {34,0.00003509}, {35,0.00003509}, {36,0.00000000}, {37,0.00005263}, {38,0.00000000}, {39,0.00000000}, {40,0.00003509}, {41,0.00007018}, {42,0.00002632}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00006140}, {48,0.00007018}, {49,0.00008772}, {50,0.00006140}, {51,0.00000000}, {52,0.00002632}, {53,0.00003509}, {54,0.00009649}, {55,0.00002632}, {56,0.00003509}, {57,0.00003509}, {58,0.00003509}, {59,0.00000000}, {60,0.00007018}, {61,0.00000000}, {62,0.00006140}, {63,0.00002632}, {64,0.00009649}, {65,0.00003509}, {66,0.00006140}, {67,0.00000000}, {68,0.00003509}, {69,0.00009649}, {70,0.00010526}, {71,0.00006140}, {72,0.00003509}, {73,0.00000000}, {74,0.00006140}, {75,0.00007018}, {76,0.00012281}, {77,0.00007895}, {78,0.00003509}, {79,0.00002632}, {80,0.00003509}, {81,0.00013158}, {82,0.00003509}, {83,0.00000000}, {84,0.00003509}, {85,0.00002632}, {86,0.00006140}, {87,0.00002632}, {88,0.00014035}, {89,0.00005263}, {90,0.00000000}, {91,0.00007018}, {92,0.00000000}, {93,0.00000000}, {94,0.00003509}, {95,0.00003509}, {96,0.00003509}, {97,0.00008772}, {98,0.00003509}, {99,0.00007895}, {100,0.00000000}, {101,0.00000000}, {102,0.00007018}, {103,0.00003509}, {104,0.00008772}, {105,0.00003509}, {106,0.00006140}, {107,0.00017544}, {108,0.00002632}, {109,0.00014035}, {110,0.00000000}, {111,0.00003509}, {112,0.00000000}, {113,0.00012281}, {114,0.00013158}, {115,0.00000000}, {116,0.00003509}, {117,0.00011404}, {118,0.00012281}, {119,0.00003509}, {120,0.00003509}, {121,0.00002632}, {122,0.00002632}, {123,0.00012281}, {124,0.00012281}, {125,0.00006140}, {126,0.00000000}, {127,0.00013158}, {128,0.00006140}, {129,0.00005263}, {130,0.00000000}, {131,0.00006140}, {132,0.00009649}, {133,0.00003509}, {134,0.00006140}, {135,0.00006140}, {136,0.00013158}, {137,0.00007018}, {138,0.00000000}, {139,0.00006140}, {140,0.00006140}, {141,0.00003509}, {142,0.00007895}, {143,0.00012281}, {144,0.00010526}, {145,0.00017544}, {146,0.00003509}, {147,0.00008772}, {148,0.00006140}, {149,0.00014912}, {150,0.00007018}, {151,0.00000000}, {152,0.00002632}, {153,0.00012281}, {154,0.00010526}, {155,0.00010526}, {156,0.00019298}, {157,0.00003509}, {158,0.00006140}, {159,0.00007018}, {160,0.00006140}, {161,0.00008772}, {162,0.00002632}, {163,0.00013158}, {164,0.00013158}, {165,0.00002632}, {166,0.00008772}, {167,0.00010526}, {168,0.00014912}, {169,0.00009649}, {170,0.00006140}, {171,0.00014035}, {172,0.00000000}, {173,0.00015789}, {174,0.00010526}, {175,0.00012281}, {176,0.00016667}, {177,0.00009649}, {178,0.00002632}, {179,0.00008772}, {180,0.00000000}, {181,0.00000000}, {182,0.00009649}, {183,0.00012281}, {184,0.00009649}, {185,0.00003509}, {186,0.00021053}, {187,0.00008772}, {188,0.00003509}, {189,0.00003509}, {190,0.00012281}, {191,0.00003509}, {192,0.00003509}, {193,0.00021930}, {194,0.00017544}, {195,0.00003509}, {196,0.00007018}, {197,0.00009649}, {198,0.00012281}, {199,0.00011404}, {200,0.00010526}, {201,0.00026316}, {202,0.00003509}, {203,0.00014035}, {204,0.00007018}, {205,0.00007018}, {206,0.00013158}, {207,0.00000000}, {208,0.00010526}, {209,0.00025439}, {210,0.00003509}, {211,0.00013158}, {212,0.00006140}, {213,0.00005263}, {214,0.00003509}, {215,0.00014035}, {216,0.00008772}, {217,0.00003509}, {218,0.00006140}, {219,0.00009649}, {220,0.00008772}, {221,0.00012281}, {222,0.00007018}, {223,0.00013158}, {224,0.00000000}, {225,0.00022807}, {226,0.00012281}, {227,0.00013158}, {228,0.00019298}, {229,0.00009649}, {230,0.00012281}, {231,0.00011404}, {232,0.00010526}, {233,0.00028070}, {234,0.00014035}, {235,0.00009649}, {236,0.00012281}, {237,0.00014035}, {238,0.00017544}, {239,0.00005263}, {240,0.00012281}, {241,0.00014912}, {242,0.00006140}, {243,0.00009649}, {244,0.00013158}, {245,0.00014035}, {246,0.00007018}, {247,0.00010526}, {248,0.00006140}, {249,0.00020175}, {250,0.00018421}, {251,0.00002632}, {252,0.00013158}, {253,0.00008772}, {254,0.00007018}, {255,0.00014035}, {256,0.00008772}, {257,0.00015789}, {258,0.00007018}, {259,0.00014035}, {260,0.00022807}, {261,0.00013158}, {262,0.00005263}, {263,0.00021930}, {264,0.00024561}, {265,0.00002632}, {266,0.00016667}, {267,0.00014035}, {268,0.00022807}, {269,0.00007018}, {270,0.00013158}, {271,0.00006140}, {272,0.00014912}, {273,0.00009649}, {274,0.00009649}, {275,0.00007018}, {276,0.00014912}, {277,0.00009649}, {278,0.00028070}, {279,0.00007018}, {280,0.00015789}, {281,0.00008772}, {282,0.00007018}, {283,0.00003509}, {284,0.00015789}, {285,0.00000000}, {286,0.00007895}, {287,0.00011404}, {288,0.00025439}, {289,0.00005263}, {290,0.00015789}, {291,0.00017544}, {292,0.00020175}, {293,0.00003509}, {294,0.00019298}, {295,0.00014035}, {296,0.00009649}, {297,0.00015789}, {298,0.00019298}, {299,0.00014035}, {300,0.00019298}, {301,0.00007018}, {302,0.00003509}, {303,0.00009649}, {304,0.00017544}, {305,0.00018421}, {306,0.00016667}, {307,0.00015789}, {308,0.00008772}, {309,0.00019298}, {310,0.00021053}, {311,0.00010526}, {312,0.00009649}, {313,0.00014035}, {314,0.00013158}, {315,0.00025439}, {316,0.00029825}, {317,0.00011404}, {318,0.00006140}, {319,0.00010526}, {320,0.00020175}, {321,0.00019298}, {322,0.00022807}, {323,0.00018421}, {324,0.00010526}, {325,0.00008772}, {326,0.00006140}, {327,0.00010526}, {328,0.00009649}, {329,0.00021053}, {330,0.00022807}, {331,0.00008772}, {332,0.00020175}, {333,0.00018421}, {334,0.00017544}, {335,0.00008772}, {336,0.00026316}, {337,0.00016667}, {338,0.00016667}, {339,0.00012281}, {340,0.00016667}, {341,0.00014035}, {342,0.00018421}, {343,0.00020175}, {344,0.00016667}, {345,0.00023684}, {346,0.00005263}, {347,0.00012281}, {348,0.00033333}, {349,0.00022807}, {350,0.00017544}, {351,0.00023684}, {352,0.00014912}, {353,0.00017544}, {354,0.00013158}, {355,0.00008772}, {356,0.00025439}, {357,0.00014912}, {358,0.00007018}, {359,0.00007018}, {360,0.00012281}, {361,0.00003509}, {362,0.00013158}, {363,0.00015789}, {364,0.00013158}, {365,0.00023684}, {366,0.00021053}, {367,0.00016667}, {368,0.00035088}, {369,0.00014035}, {370,0.00019298}, {371,0.00021053}, {372,0.00028070}, {373,0.00027193}, {374,0.00016667}, {375,0.00005263}, {376,0.00030702}, {377,0.00013158}, {378,0.00034211}, {379,0.00015789}, {380,0.00006140}, {381,0.00027193}, {382,0.00018421}, {383,0.00005263}, {384,0.00013158}, {385,0.00013158}, {386,0.00017544}, {387,0.00018421}, {388,0.00008772}, {389,0.00027193}, {390,0.00013158}, {391,0.00013158}, {392,0.00015789}, {393,0.00019298}, {394,0.00009649}, {395,0.00017544}, {396,0.00022807}, {397,0.00014035}, {398,0.00012281}, {399,0.00014912}, {400,0.00013158}, {401,0.00018421}, {402,0.00025439}, {403,0.00019298}, {404,0.00009649}, {405,0.00023684}, {406,0.00024561}, {407,0.00022807}, {408,0.00035088}, {409,0.00009649}, {410,0.00021053}, {411,0.00028070}, {412,0.00020175}, {413,0.00029825}, {414,0.00014912}, {415,0.00022807}, {416,0.00012281}, {417,0.00009649}, {418,0.00024561}, {419,0.00019298}, {420,0.00028947}, {421,0.00013158}, {422,0.00008772}, {423,0.00031579}, {424,0.00024561}, {425,0.00019298}, {426,0.00024561}, {427,0.00010526}, {428,0.00010526}, {429,0.00018421}, {430,0.00006140}, {431,0.00023684}, {432,0.00018421}, {433,0.00010526}, {434,0.00023684}, {435,0.00013158}, {436,0.00009649}, {437,0.00016667}, {438,0.00020175}, {439,0.00012281}, {440,0.00028070}, {441,0.00010526}, {442,0.00013158}, {443,0.00016667}, {444,0.00015789}, {445,0.00024561}, {446,0.00015789}, {447,0.00021930}, {448,0.00032456}, {449,0.00012281}, {450,0.00026316}, {451,0.00016667}, {452,0.00017544}, {453,0.00021930}, {454,0.00008772}, {455,0.00014035}, {456,0.00025439}, {457,0.00019298}, {458,0.00014035}, {459,0.00022807}, {460,0.00015789}, {461,0.00028070}, {462,0.00017544}, {463,0.00016667}, {464,0.00022807}, {465,0.00015789}, {466,0.00027193}, {467,0.00025439}, {468,0.00024561}, {469,0.00018421}, {470,0.00017544}, {471,0.00020175}, {472,0.00015789}, {473,0.00006140}, {474,0.00014035}, {475,0.00013158}, {476,0.00036842}, {477,0.00013158}, {478,0.00012281}, {479,0.00014035}, {480,0.00029825}, {481,0.00028947}, {482,0.00019298}, {483,0.00019298}, {484,0.00015789}, {485,0.00017544}, {486,0.00028070}, {487,0.00021053}, {488,0.00016667}, {489,0.00021930}, {490,0.00008772}, {491,0.00023684}, {492,0.00026316}, {493,0.00015789}, {494,0.00010526}, {495,0.00015789}, {496,0.00014912}, {497,0.00012281}, {498,0.00018421}, {499,0.00023684}, {500,0.00022807}, {505,0.00033333}, {510,0.00014035}, {515,0.00018421}, {520,0.00020175}, {525,0.00008772}, {530,0.00019298}, {535,0.00020175}, {540,0.00036842}, {545,0.00042982}, {550,0.00025439}, {555,0.00028070}, {560,0.00017544}, {565,0.00019298}, {570,0.00025439}, {575,0.00015789}, {580,0.00032456}, {585,0.00020175}, {590,0.00035088}, {595,0.00028070}, {600,0.00048246}, {605,0.00032456}, {610,0.00019298}, {615,0.00019298}, {620,0.00016667}, {625,0.00036842}, {630,0.00040351}, {635,0.00036842}, {640,0.00021053}, {645,0.00019298}, {650,0.00031579}, {655,0.00018421}, {660,0.00041228}, {665,0.00028947}, {670,0.00034211}, {675,0.00030702}, {680,0.00019298}, {685,0.00040351}, {690,0.00008772}, {695,0.00009649}, {700,0.00025439}, {705,0.00019298}, {710,0.00016667}, {715,0.00025439}, {720,0.00024561}, {725,0.00015789}, {730,0.00020175}, {735,0.00037719}, {740,0.00023684}, {745,0.00027193}, {750,0.00020175}, {755,0.00016667}, {760,0.00039474}, {765,0.00028947}, {770,0.00037719}, {775,0.00027193}, {780,0.00010526}, {785,0.00026316}, {790,0.00028947}, {795,0.00030702}, {800,0.00027193}, {805,0.00025439}, {810,0.00029825}, {815,0.00022807}, {820,0.00028070}, {825,0.00037719}, {830,0.00032456}, {835,0.00039474}, {840,0.00036842}, {845,0.00034211}, {850,0.00030702}, {855,0.00039474}, {860,0.00031579}, {865,0.00057895}, {870,0.00057018}, {875,0.00037719}, {880,0.00048246}, {885,0.00015789}, {890,0.00025439}, {895,0.00032456}, {900,0.00019298}, {905,0.00029825}, {910,0.00024561}, {915,0.00029825}, {920,0.00035088}, {925,0.00028070}, {930,0.00029825}, {935,0.00045614}, {940,0.00028947}, {945,0.00048246}, {950,0.00062281}, {955,0.00104386}, {960,0.00041228}, {965,0.00044737}, {970,0.00025439}, {975,0.00027193}, {980,0.00042105}, {985,0.00055263}, {990,0.00034211}, {995,0.00028070}, {1000,0.00048246}, {1010,0.00050000}, {1020,0.00029825}, {1030,0.00031579}, {1040,0.00032456}, {1050,0.00035965}, {1060,0.00036842}, {1070,0.00035088}, {1080,0.00020175}, {1090,0.00028070}, {1100,0.00043860}, {1110,0.00028070}, {1120,0.00053509}, {1130,0.00069298}, {1140,0.00050000}, {1150,0.00032456}, {1160,0.00038596}, {1170,0.00049123}, {1180,0.00035965}, {1190,0.00041228}, {1200,0.00035088}, {1210,0.00040351}, {1220,0.00040351}, {1230,0.00044737}, {1240,0.00072807}, {1250,0.00059649}, {1260,0.00054386}, {1270,0.00056140}, {1280,0.00070175}, {1290,0.00032456}, {1300,0.00060526}, {1310,0.00028947}, {1320,0.00054386}, {1330,0.00070175}, {1340,0.00065789}, {1350,0.00048246}, {1360,0.00054386}, {1370,0.00056140}, {1380,0.00053509}, {1390,0.00049123}, {1400,0.00059649}, {1410,0.00050000}, {1420,0.00056140}, {1430,0.00052632}, {1440,0.00057895}, {1450,0.00074561}, {1460,0.00056140}, {1470,0.00064035}, {1480,0.00056140}, {1490,0.00062281}, {1500,0.00050000}, {1510,0.00052632}, {1520,0.00065789}, {1530,0.00795614}, {1540,0.00059649}, {1550,0.00064912}, {1560,0.00057018}, {1570,0.00063158}, {1580,0.00049123}, {1590,0.00072807}, {1600,0.00070175}, {1610,0.00058772}, {1620,0.00085088}, {1630,0.00078070}, {1640,0.00052632}, {1650,0.00065789}, {1660,0.00066667}, {1670,0.00063158}, {1680,0.00061404}, {1690,0.00040351}, {1700,0.00047368}, {1710,0.00067544}, {1720,0.00056140}, {1730,0.00072807}, {1740,0.00084211}, {1750,0.00073684}, {1760,0.00091228}, {1770,0.00149123}, {1780,0.00052632}, {1790,0.00057895}, {1800,0.00076316}, {1810,0.00070175}, {1820,0.00063158}, {1830,0.00079825}, {1840,0.00057018}, {1850,0.00101754}, {1860,0.00052632}, {1870,0.00081579}, {1880,0.00093860}, {1890,0.00061404}, {1900,0.00089474}, {1910,0.00054386}, {1920,0.00058772}, {1930,0.00041228}, {1940,0.00047368}, {1950,0.00062281}, {1960,0.00071053}, {1970,0.00079825}, {1980,0.00072807}, {1990,0.00061404}, {2000,0.00075439}, {2050,0.00069298}, {2100,0.00077193}, {2150,0.00079825}, {2200,0.00073684}, {2250,0.00094737}, {2300,0.00075439}, {2350,0.00076316}, {2400,0.00100000}, {2450,0.00082456}, {2500,0.00098246}, {2550,0.00078070}, {2600,0.00118421}, {2650,0.00099123}, {2700,0.00104386}, {2750,0.00122807}, {2800,0.00122807}, {2850,0.00117544}, {2900,0.00109649}, {2950,0.00106140}, {3000,0.00124561}, {3050,0.00155263}, {3100,0.00124561}, {3150,0.00131579}, {3200,0.00150877}, {3250,0.00971930}, {3300,0.00124561}, {3350,0.00117544}, {3400,0.00127193}, {3450,0.00116667}, {3500,0.00135088}, {3550,0.00160526}, {3600,0.00115789}, {3650,0.00153509}, {3700,0.00147368}, {3750,0.00107895}, {3800,0.00173684}, {3850,0.00129825}, {3900,0.00178070}, {3950,0.00192105}, {4000,0.00173684}, {4050,0.00159649}, {4100,0.00187719}, {4150,0.00152632}, {4200,0.00142982}, {4250,0.00193860}, {4300,0.00274561}, {4350,0.00191228}, {4400,0.00176316}, {4450,0.00262281}, {4500,0.00171053}, {4550,0.00173684}, {4600,0.00173684}, {4650,0.00198246}, {4700,0.00204386}, {4750,0.00197368}, {4800,0.00201754}, {4850,0.00175439}, {4900,0.00200000}, {4950,0.00174561}, {5000,0.00199123}, {5050,0.00199123}, {5100,0.00330702}, {5150,0.00201754}, {5200,0.01500877}, {5250,0.00189474}, {5300,0.00225439}, {5350,0.00216667}, {5400,0.00190351}, {5450,0.00187719}, {5500,0.00226316}, {5550,0.00200000}, {5600,0.00234211}, {5650,0.00221053}, {5700,0.01315789}, {5750,0.00247368}, {5800,0.00218421}, {5850,0.00225439}, {5900,0.00256140}, {5950,0.00230702}, {6000,0.00243860}, {6050,0.002571}, {6100,0.001857}, {6150,0.002643}, {6200,0.002500}, {6250,0.002929}, {6300,0.002786}, {6350,0.002071}, {6400,0.001643}, {6450,0.002214}, {6500,0.002643}, {6550,0.002286}, {6600,0.001929}, {6650,0.001929}, {6700,0.002643}, {6750,0.002571}, {6800,0.002857}, {6850,0.003143}, {6900,0.002643}, {6950,0.001929}, {7000,0.002143}, {7050,0.003000}, {7100,0.002929}, {7150,0.003286}, {7200,0.002714}, {7250,0.002357}, {7300,0.002786}, {7350,0.002357}, {7400,0.001286}, {7450,0.002500}, {7500,0.002286}, {7550,0.002929}, {7600,0.015214}, {7650,0.003000}, {7700,0.003143}, {7750,0.003071}, {7800,0.003714}, {7850,0.002929}, {7900,0.003000}, {7950,0.003071}, {8000,0.002500}, {8050,0.002929}, {8100,0.002714}, {8150,0.003429}, {8200,0.002714}, {8250,0.003214}, {8300,0.002786}, {8350,0.003357}, {8400,0.002643}, {8450,0.003357}, {8500,0.004500}, {8550,0.002786}, {8600,0.003071}, {8650,0.003071}, {8700,0.003500}, {8750,0.003071}, {8800,0.025571}, {8850,0.003143}, {8900,0.003429}, {8950,0.003429}, {9000,0.003786}, {9050,0.003429}, {9100,0.017429}, {9150,0.003714}, {9200,0.003571}, {9250,0.003714}, {9300,0.003857}, {9350,0.003571}, {9400,0.003143}, {9450,0.003357}, {9500,0.003643}, {9550,0.003500}, {9600,0.003429}, {9650,0.003214}, {9700,0.003786}, {9750,0.003714}, {9800,0.003714}, {9850,0.003500}, {9900,0.004071}, {9950,0.003786}, {10000,0.003571}, {10100,0.004071}, {10200,0.003857}, {10300,0.003643}, {10400,0.004000}, {10500,0.005000}, {10600,0.003643}, {10700,0.004929}, {10800,0.004214}, {10900,0.004071}, {11000,0.003714}, {11100,0.003643}, {11200,0.004429}, {11300,0.004429}, {11400,0.004429}, {11500,0.004929}, {11600,0.004929}, {11700,0.004357}, {11800,0.004500}, {11900,0.026857}, {12000,0.004357}, {12100,0.005357}, {12200,0.004929}, {12300,0.004643}, {12400,0.005500}, {12500,0.005000}, {12600,0.005643}, {12700,0.005714}, {12800,0.005643}, {12900,0.007357}, {13000,0.005786}, {13100,0.005000}, {13200,0.005500}, {13300,0.026500}, {13400,0.005429}, {13500,0.006786}, {13600,0.006286}, {13700,0.007000}, {13800,0.005071}, {13900,0.005429}, {14000,0.005500}, {14100,0.005929}, {14200,0.028214}, {14300,0.027071}, {14400,0.008071}, {14500,0.006857}, {14600,0.030786}, {14700,0.006429}, {14800,0.005929}, {14900,0.004714}, {15000,0.025143}, {15100,0.006214}, {15200,0.027500}, {15300,0.006429}, {15400,0.006786}, {15500,0.006786}, {15600,0.006929}, {15700,0.005714}, {15800,0.006929}, {15900,0.006929}, {16000,0.007500}, {16100,0.005857}, {16200,0.007214}, {16300,0.007286}, {16400,0.008500}, {16500,0.006929}, {16600,0.033286}, {16700,0.007357}, {16800,0.007143}, {16900,0.026286}, {17000,0.006929}, {17100,0.007143}, {17200,0.007357}, {17300,0.007357}, {17400,0.007214}, {17500,0.009143}, {17600,0.040500}, {17700,0.007929}, {17800,0.027500}, {17900,0.007357}, {18000,0.033929}, {18100,0.009786}, {18200,0.008000}, {18300,0.026071}, {18400,0.028857}, {18500,0.044571}, {18600,0.009286}, {18700,0.008214}, {18800,0.007857}, {18900,0.009500}, {19000,0.036714}, {19100,0.011000}, {19200,0.007786}, {19300,0.008286}, {19400,0.009071}, {19500,0.008643}, {19600,0.009643}, {19700,0.008714}, {19800,0.008357}, {19900,0.009143}, {20000,0.009071}};
data["big_flat"]["TypeClassesBodyHOAS"]["lazy beta iota"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00003509}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00003509}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00003509}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00003509}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003509}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00003509}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00003509}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00003509}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00003509}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00003509}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00007018}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00003509}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00002632}, {725,0.00000000}, {730,0.00000000}, {735,0.00003509}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00003509}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00003509}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00003509}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00003509}, {890,0.00000000}, {895,0.00000000}, {900,0.00003509}, {905,0.00003509}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00003509}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00003509}, {1480,0.00000000}, {1490,0.00003509}, {1500,0.00000000}, {1510,0.00003509}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00003509}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00003509}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00003509}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00002632}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00003509}, {3450,0.00000000}, {3500,0.00003509}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00002632}, {3700,0.00000000}, {3750,0.00003509}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00003509}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00003509}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00003509}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00003509}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00003509}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00003509}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00003509}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00003509}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000571}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000286}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000286}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000286}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000286}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000286}, {14400,0.000000}, {14500,0.000000}, {14600,0.000857}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000286}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000000}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClassesBodyHOAS"]["norm reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000877}, {11,0.00089474}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00100000}, {16,0.00100000}, {17,0.00100000}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00115789}, {22,0.00124561}, {23,0.00201754}, {24,0.00200000}, {25,0.00200000}, {26,0.00200000}, {27,0.00200000}, {28,0.00200000}, {29,0.00200000}, {30,0.00200877}, {31,0.00243860}, {32,0.00218421}, {33,0.00255263}, {34,0.00287719}, {35,0.00300000}, {36,0.00300000}, {37,0.00300000}, {38,0.00300000}, {39,0.00318421}, {40,0.00303509}, {41,0.00335088}, {42,0.00457895}, {43,0.00378947}, {44,0.00351754}, {45,0.00400000}, {46,0.00400000}, {47,0.00401754}, {48,0.00400000}, {49,0.00400877}, {50,0.00402632}, {51,0.00449123}, {52,0.00447368}, {53,0.00462281}, {54,0.00483333}, {55,0.00500000}, {56,0.00481579}, {57,0.00500000}, {58,0.00585965}, {59,0.00542982}, {60,0.00520175}, {61,0.00548246}, {62,0.00550877}, {63,0.00600000}, {64,0.00544737}, {65,0.00572807}, {66,0.00592105}, {67,0.00609649}, {68,0.00600000}, {69,0.00642982}, {70,0.00753509}, {71,0.00655263}, {72,0.00642982}, {73,0.00660526}, {74,0.00677193}, {75,0.00709649}, {76,0.00696491}, {77,0.00746491}, {78,0.00757895}, {79,0.00767544}, {80,0.00707895}, {81,0.00747368}, {82,0.00753509}, {83,0.00789474}, {84,0.00774561}, {85,0.00817544}, {86,0.00830702}, {87,0.00847368}, {88,0.00805263}, {89,0.00847368}, {90,0.00939474}, {91,0.00885088}, {92,0.00850877}, {93,0.00919298}, {94,0.00961404}, {95,0.00955263}, {96,0.00859649}, {97,0.00912281}, {98,0.01110526}, {99,0.00949123}, {100,0.00939474}, {101,0.00953509}, {102,0.00963158}, {103,0.01045614}, {104,0.00957895}, {105,0.01042105}, {106,0.01150877}, {107,0.01043860}, {108,0.01040351}, {109,0.01057018}, {110,0.01081579}, {111,0.01128070}, {112,0.01036842}, {113,0.01065789}, {114,0.01062281}, {115,0.01138596}, {116,0.01119298}, {117,0.01145614}, {118,0.01151754}, {119,0.01236842}, {120,0.01315789}, {121,0.01186842}, {122,0.01213158}, {123,0.01250877}, {124,0.01237719}, {125,0.01258772}, {126,0.01268421}, {127,0.01406140}, {128,0.01169298}, {129,0.01250000}, {130,0.01254386}, {131,0.01316667}, {132,0.01291228}, {133,0.01514912}, {134,0.01325439}, {135,0.01362281}, {136,0.01313158}, {137,0.01347368}, {138,0.01360526}, {139,0.01550000}, {140,0.01384211}, {141,0.01442982}, {142,0.01451754}, {143,0.01515789}, {144,0.01602632}, {145,0.01428070}, {146,0.01437719}, {147,0.01497368}, {148,0.01458772}, {149,0.01535965}, {150,0.01631579}, {151,0.01591228}, {152,0.01509649}, {153,0.01557895}, {154,0.01565789}, {155,0.01838596}, {156,0.01561404}, {157,0.01641228}, {158,0.01644737}, {159,0.01721930}, {160,0.01660526}, {161,0.01598246}, {162,0.01607895}, {163,0.01668421}, {164,0.01628070}, {165,0.01836842}, {166,0.01682456}, {167,0.01754386}, {168,0.01650877}, {169,0.01728947}, {170,0.01850877}, {171,0.01804386}, {172,0.01748246}, {173,0.01829825}, {174,0.02135088}, {175,0.01868421}, {176,0.01720175}, {177,0.01800000}, {178,0.01813158}, {179,0.01986842}, {180,0.01824561}, {181,0.01899123}, {182,0.01899123}, {183,0.02228947}, {184,0.01839474}, {185,0.01921053}, {186,0.01951754}, {187,0.02306140}, {188,0.01931579}, {189,0.02019298}, {190,0.02037719}, {191,0.02361404}, {192,0.01842105}, {193,0.01927193}, {194,0.01940351}, {195,0.02275439}, {196,0.01938596}, {197,0.02027193}, {198,0.02048246}, {199,0.02364912}, {200,0.01959649}, {201,0.02060526}, {202,0.02080702}, {203,0.02433333}, {204,0.02071930}, {205,0.02171930}, {206,0.02178947}, {207,0.02464035}, {208,0.02084211}, {209,0.02150000}, {210,0.02163158}, {211,0.02433333}, {212,0.02166667}, {213,0.02301754}, {214,0.02280702}, {215,0.02494737}, {216,0.02198246}, {217,0.02339474}, {218,0.02678947}, {219,0.02358772}, {220,0.02341228}, {221,0.02400877}, {222,0.02527193}, {223,0.02528070}, {224,0.02214035}, {225,0.02630702}, {226,0.02280702}, {227,0.02435965}, {228,0.02331579}, {229,0.02539474}, {230,0.02458772}, {231,0.02528070}, {232,0.02683333}, {233,0.02477193}, {234,0.02463158}, {235,0.02563158}, {236,0.02454386}, {237,0.02556140}, {238,0.02616667}, {239,0.02778070}, {240,0.02471053}, {241,0.02568421}, {242,0.02888596}, {243,0.02675439}, {244,0.02568421}, {245,0.03009649}, {246,0.02657895}, {247,0.02813158}, {248,0.02881579}, {249,0.02694737}, {250,0.02678947}, {251,0.03121053}, {252,0.02682456}, {253,0.02851754}, {254,0.03133333}, {255,0.02946491}, {256,0.02549123}, {257,0.02970175}, {258,0.02621930}, {259,0.02804386}, {260,0.02685965}, {261,0.02791228}, {262,0.02785088}, {263,0.03173684}, {264,0.02673684}, {265,0.02850877}, {266,0.02836842}, {267,0.02943860}, {268,0.02818421}, {269,0.03200000}, {270,0.02968421}, {271,0.03043860}, {272,0.03029825}, {273,0.02862281}, {274,0.02895614}, {275,0.03241228}, {276,0.02896491}, {277,0.03054386}, {278,0.03270175}, {279,0.03135088}, {280,0.02954386}, {281,0.03231579}, {282,0.03064035}, {283,0.03722807}, {284,0.03017544}, {285,0.03201754}, {286,0.03427193}, {287,0.03309649}, {288,0.02915789}, {289,0.03227193}, {290,0.03081579}, {291,0.03196491}, {292,0.03018421}, {293,0.03213158}, {294,0.03477193}, {295,0.03300000}, {296,0.03113158}, {297,0.03445614}, {298,0.03290351}, {299,0.03848246}, {300,0.03167544}, {301,0.03339474}, {302,0.03610526}, {303,0.03568421}, {304,0.03613158}, {305,0.03244737}, {306,0.03301754}, {307,0.03644737}, {308,0.03337719}, {309,0.03508772}, {310,0.03440351}, {311,0.03564912}, {312,0.03542982}, {313,0.03500000}, {314,0.03950000}, {315,0.03590351}, {316,0.03523684}, {317,0.03787719}, {318,0.03660526}, {319,0.04221930}, {320,0.03242105}, {321,0.03428070}, {322,0.03433333}, {323,0.03539474}, {324,0.03597368}, {325,0.03567544}, {326,0.03980702}, {327,0.03642105}, {328,0.03445614}, {329,0.03741228}, {330,0.03608772}, {331,0.04167544}, {332,0.03578070}, {333,0.04200000}, {334,0.03714912}, {335,0.03871053}, {336,0.03587719}, {337,0.03666667}, {338,0.04130702}, {339,0.03783333}, {340,0.04076316}, {341,0.03771930}, {342,0.03820175}, {343,0.03899123}, {344,0.03681579}, {345,0.03960526}, {346,0.03872807}, {347,0.04456140}, {348,0.03893860}, {349,0.04433333}, {350,0.03987719}, {351,0.04517544}, {352,0.03678070}, {353,0.04228947}, {354,0.03784211}, {355,0.03977193}, {356,0.03926316}, {357,0.03998246}, {358,0.04126316}, {359,0.04162281}, {360,0.04264035}, {361,0.04044737}, {362,0.04414035}, {363,0.04135965}, {364,0.04404386}, {365,0.04222807}, {366,0.04566667}, {367,0.04293860}, {368,0.04250877}, {369,0.04115789}, {370,0.04513158}, {371,0.04220175}, {372,0.04443860}, {373,0.04270175}, {374,0.04607018}, {375,0.04350877}, {376,0.04523684}, {377,0.04253509}, {378,0.04659649}, {379,0.04447368}, {380,0.04659649}, {381,0.04455263}, {382,0.04802632}, {383,0.04685965}, {384,0.04202632}, {385,0.04068421}, {386,0.04414035}, {387,0.04292982}, {388,0.04452632}, {389,0.04241228}, {390,0.04581579}, {391,0.04446491}, {392,0.04466667}, {393,0.04291228}, {394,0.04789474}, {395,0.04467544}, {396,0.04614912}, {397,0.04507018}, {398,0.04803509}, {399,0.04683333}, {400,0.04504386}, {401,0.04349123}, {402,0.04755263}, {403,0.04566667}, {404,0.04765789}, {405,0.04559649}, {406,0.04935965}, {407,0.05491228}, {408,0.04393860}, {409,0.04963158}, {410,0.04613158}, {411,0.05078070}, {412,0.04634211}, {413,0.05104386}, {414,0.04815789}, {415,0.05241228}, {416,0.04376316}, {417,0.04837719}, {418,0.04998246}, {419,0.04675439}, {420,0.05008772}, {421,0.04674561}, {422,0.05164912}, {423,0.04955263}, {424,0.04906140}, {425,0.04825439}, {426,0.05069298}, {427,0.05751754}, {428,0.04789474}, {429,0.05278947}, {430,0.04970175}, {431,0.05529825}, {432,0.04671930}, {433,0.05206140}, {434,0.05657895}, {435,0.04956140}, {436,0.05198246}, {437,0.05070175}, {438,0.05318421}, {439,0.05199123}, {440,0.04894737}, {441,0.05523684}, {442,0.05072807}, {443,0.05585965}, {444,0.05107018}, {445,0.05602632}, {446,0.06133333}, {447,0.05524561}, {448,0.05040351}, {449,0.04886842}, {450,0.05191228}, {451,0.05843860}, {452,0.04850877}, {453,0.05424561}, {454,0.05207018}, {455,0.05559649}, {456,0.05678947}, {457,0.05074561}, {458,0.05522807}, {459,0.05277193}, {460,0.05457895}, {461,0.06140351}, {462,0.05314912}, {463,0.05858772}, {464,0.05056140}, {465,0.05525439}, {466,0.05978947}, {467,0.05355263}, {468,0.05491228}, {469,0.06159649}, {470,0.05378070}, {471,0.05914912}, {472,0.05274561}, {473,0.05688596}, {474,0.06278070}, {475,0.05659649}, {476,0.05728947}, {477,0.06436842}, {478,0.05630702}, {479,0.06166667}, {480,0.05903509}, {481,0.05349123}, {482,0.05685088}, {483,0.05638596}, {484,0.05360526}, {485,0.05940351}, {486,0.05628947}, {487,0.06016667}, {488,0.06180702}, {489,0.05622807}, {490,0.05842982}, {491,0.06636842}, {492,0.05648246}, {493,0.06069298}, {494,0.06608772}, {495,0.06078070}, {496,0.05667544}, {497,0.06515789}, {498,0.05672807}, {499,0.06138596}, {500,0.06527193}, {505,0.05935965}, {510,0.06192982}, {515,0.06075439}, {520,0.05695614}, {525,0.06076316}, {530,0.06169298}, {535,0.07219298}, {540,0.06207018}, {545,0.06295614}, {550,0.07111404}, {555,0.07378947}, {560,0.06217544}, {565,0.06960526}, {570,0.07479825}, {575,0.07955263}, {580,0.06400877}, {585,0.06949123}, {590,0.07727193}, {595,0.07754386}, {600,0.07545614}, {605,0.07364912}, {610,0.07099123}, {615,0.08192105}, {620,0.07935965}, {625,0.07965789}, {630,0.08232456}, {635,0.08591228}, {640,0.06864912}, {645,0.07550000}, {650,0.08107895}, {655,0.08762281}, {660,0.08211404}, {665,0.08585088}, {670,0.08952632}, {675,0.08739474}, {680,0.07732456}, {685,0.08328070}, {690,0.08227193}, {695,0.09483333}, {700,0.09461404}, {705,0.08971053}, {710,0.09145614}, {715,0.09544737}, {720,0.08942105}, {725,0.09635965}, {730,0.09695614}, {735,0.10328070}, {740,0.09509649}, {745,0.09780702}, {750,0.10042105}, {755,0.10150877}, {760,0.09857018}, {765,0.10517544}, {770,0.09216667}, {775,0.10000877}, {780,0.09655263}, {785,0.09771930}, {790,0.10105263}, {795,0.10435965}, {800,0.09644737}, {805,0.10241228}, {810,0.10311404}, {815,0.11086842}, {820,0.10476316}, {825,0.10892982}, {830,0.11207018}, {835,0.10599123}, {840,0.10328947}, {845,0.11042982}, {850,0.10793860}, {855,0.11498246}, {860,0.11247368}, {865,0.10860526}, {870,0.11386842}, {875,0.11745614}, {880,0.11082456}, {885,0.11842105}, {890,0.11799123}, {895,0.12781579}, {900,0.11605263}, {905,0.11459649}, {910,0.11771930}, {915,0.11857018}, {920,0.12207018}, {925,0.12253509}, {930,0.11581579}, {935,0.12488596}, {940,0.12141228}, {945,0.12156140}, {950,0.12651754}, {955,0.12960526}, {960,0.11570175}, {965,0.12417544}, {970,0.13172807}, {975,0.13299123}, {980,0.14958772}, {985,0.13046491}, {990,0.13354386}, {995,0.13835088}, {1000,0.12789474}, {1010,0.13992982}, {1020,0.13748246}, {1030,0.12895614}, {1040,0.12589474}, {1050,0.13484211}, {1060,0.13886842}, {1070,0.13996491}, {1080,0.14376316}, {1090,0.13428947}, {1100,0.14617544}, {1110,0.14530702}, {1120,0.14604386}, {1130,0.14750000}, {1140,0.15522807}, {1150,0.15874561}, {1160,0.14311404}, {1170,0.15526316}, {1180,0.15435965}, {1190,0.16211404}, {1200,0.15789474}, {1210,0.16169298}, {1220,0.16068421}, {1230,0.17026316}, {1240,0.16040351}, {1250,0.16092105}, {1260,0.17381579}, {1270,0.17851754}, {1280,0.17085088}, {1290,0.24395614}, {1300,0.17071930}, {1310,0.18224561}, {1320,0.17214035}, {1330,0.86661404}, {1340,0.18668421}, {1350,0.17607895}, {1360,0.17193860}, {1370,0.19188596}, {1380,0.18500000}, {1390,0.19517544}, {1400,0.19078070}, {1410,0.18217544}, {1420,0.18799123}, {1430,0.19591228}, {1440,0.18498246}, {1450,0.19702632}, {1460,0.19792982}, {1470,0.21117544}, {1480,0.19658772}, {1490,0.20341228}, {1500,0.20746491}, {1510,0.20934211}, {1520,0.20328947}, {1530,0.21848246}, {1540,0.19645614}, {1550,0.20692982}, {1560,0.20130702}, {1570,0.20305263}, {1580,0.21099123}, {1590,0.22501754}, {1600,0.20217544}, {1610,0.21235088}, {1620,0.21330702}, {1630,0.23465789}, {1640,0.21571053}, {1650,0.22476316}, {1660,0.23852632}, {1670,0.22120175}, {1680,0.21577193}, {1690,0.22996491}, {1700,0.22163158}, {1710,0.24509649}, {1720,0.23092982}, {1730,0.23292982}, {1740,0.23559649}, {1750,0.24876316}, {1760,0.23064912}, {1770,0.24965789}, {1780,0.24876316}, {1790,0.27222807}, {1800,0.23203509}, {1810,0.23722807}, {1820,0.25189474}, {1830,0.24631579}, {1840,0.24630702}, {1850,0.26485088}, {1860,0.24239474}, {1870,0.26595614}, {1880,0.26006140}, {1890,0.25532456}, {1900,0.26564912}, {1910,0.27342105}, {1920,0.24061404}, {1930,0.25788596}, {1940,0.26251754}, {1950,0.28063158}, {1960,0.26616667}, {1970,0.27465789}, {1980,0.28226316}, {1990,0.27035965}, {2000,0.26359649}, {2050,0.25906140}, {2100,0.28491228}, {2150,0.29900877}, {2200,0.29876316}, {2250,0.31258772}, {2300,0.33581579}, {2350,0.34051754}, {2400,0.31964035}, {2450,0.34389474}, {2500,0.34192105}, {2550,0.38360526}, {2600,0.35443860}, {2650,0.37930702}, {2700,0.37235088}, {2750,0.41446491}, {2800,0.39900877}, {2850,0.39538596}, {2900,0.40500000}, {2950,0.41621053}, {3000,0.43257895}, {3050,0.44791228}, {3100,0.43805263}, {3150,0.45099123}, {3200,0.41833333}, {3250,0.45879825}, {3300,0.46683333}, {3350,0.47174561}, {3400,0.46430702}, {3450,0.52057895}, {3500,0.51049123}, {3550,0.54963158}, {3600,0.48482456}, {3650,0.50433333}, {3700,0.54260526}, {3750,0.54368421}, {3800,0.55334211}, {3850,0.54628947}, {3900,0.58537719}, {3950,0.61462281}, {4000,0.62093860}, {4050,0.59893860}, {4100,0.55508772}, {4150,0.60900877}, {4200,0.59785965}, {4250,0.63618421}, {4300,0.62926316}, {4350,0.70043860}, {4400,0.62564035}, {4450,0.64280702}, {4500,0.65511404}, {4550,0.67845614}, {4600,0.71119298}, {4650,0.68059649}, {4700,0.70768421}, {4750,0.71394737}, {4800,0.67788596}, {4850,0.75987719}, {4900,0.71293860}, {4950,0.76822807}, {5000,0.72557895}, {5050,0.80650000}, {5100,0.81361404}, {5150,0.77391228}, {5200,0.72970175}, {5250,0.74439474}, {5300,0.79193860}, {5350,0.83590351}, {5400,0.78823684}, {5450,0.81878070}, {5500,0.87779825}, {5550,0.88534211}, {5600,0.84160526}, {5650,0.82393860}, {5700,0.83741228}, {5750,0.92294737}, {5800,0.86776316}, {5850,0.94722807}, {5900,0.88007895}, {5950,0.97364035}, {6000,0.91693860}, {6050,0.959643}, {6100,0.979286}, {6150,0.903357}, {6200,0.931857}, {6250,0.974357}, {6300,0.980643}, {6350,1.021500}, {6400,0.894857}, {6450,0.999286}, {6500,1.006643}, {6550,1.047286}, {6600,1.021929}, {6650,1.123000}, {6700,1.036786}, {6750,1.104857}, {6800,1.008500}, {6850,1.048786}, {6900,1.125929}, {6950,1.101643}, {7000,1.107071}, {7050,1.112357}, {7100,1.197857}, {7150,1.233571}, {7200,1.040929}, {7250,1.109786}, {7300,1.070929}, {7350,1.207286}, {7400,1.172000}, {7450,1.174286}, {7500,1.173500}, {7550,1.315571}, {7600,1.192143}, {7650,1.227071}, {7700,1.186429}, {7750,1.212714}, {7800,1.261286}, {7850,1.263714}, {7900,1.317429}, {7950,1.278786}, {8000,1.197286}, {8050,1.333929}, {8100,1.294286}, {8150,1.415000}, {8200,1.162857}, {8250,1.310714}, {8300,1.623429}, {8350,1.368214}, {8400,1.293786}, {8450,1.243857}, {8500,1.341571}, {8550,1.398071}, {8600,1.390643}, {8650,1.409214}, {8700,1.516357}, {8750,1.443000}, {8800,1.347714}, {8850,1.388500}, {8900,1.409143}, {8950,1.567000}, {9000,1.414429}, {9050,1.517571}, {9100,1.470571}, {9150,1.646786}, {9200,1.545643}, {9250,1.407071}, {9300,1.469071}, {9350,1.459714}, {9400,1.524786}, {9450,1.592571}, {9500,1.544214}, {9550,1.599929}, {9600,1.454071}, {9650,1.618929}, {9700,1.626929}, {9750,1.584786}, {9800,1.541714}, {9850,1.704214}, {9900,1.639500}, {9950,1.755286}, {10000,1.558857}, {10100,1.708214}, {10200,1.746500}, {10300,1.697214}, {10400,1.577929}, {10500,1.574786}, {10600,1.719000}, {10700,1.807429}, {10800,1.691000}, {10900,1.752929}, {11000,1.922286}, {11100,1.893857}, {11200,1.784786}, {11300,1.758500}, {11400,1.777500}, {11500,1.995571}, {11600,1.871857}, {11700,2.012714}, {11800,1.904714}, {11900,2.114643}, {12000,1.976429}, {12100,2.002786}, {12200,2.077643}, {12300,1.892286}, {12400,1.970786}, {12500,2.059786}, {12600,2.092071}, {12700,2.163643}, {12800,1.881286}, {12900,2.113286}, {13000,2.131786}, {13100,2.209929}, {13200,2.134357}, {13300,2.415786}, {13400,2.188929}, {13500,2.372143}, {13600,2.123786}, {13700,2.226143}, {13800,2.416000}, {13900,2.331071}, {14000,2.336429}, {14100,2.363857}, {14200,2.519143}, {14300,2.598429}, {14400,2.173857}, {14500,2.372000}, {14600,2.288929}, {14700,2.577071}, {14800,2.509000}, {14900,2.508143}, {15000,2.524786}, {15100,2.796143}, {15200,2.533214}, {15300,2.624143}, {15400,2.468357}, {15500,2.595071}, {15600,2.711643}, {15700,2.729643}, {15800,2.823571}, {15900,2.727786}, {16000,2.561786}, {16100,2.838857}, {16200,2.759571}, {16300,2.970643}, {16400,2.482000}, {16500,2.834357}, {16600,2.807571}, {16700,2.900929}, {16800,2.751857}, {16900,2.619000}, {17000,2.848214}, {17100,2.978643}, {17200,2.895786}, {17300,2.977929}, {17400,3.214214}, {17500,3.059286}, {17600,2.847714}, {17700,2.935071}, {17800,2.979714}, {17900,3.326500}, {18000,2.986500}, {18100,3.237500}, {18200,3.163500}, {18300,3.472286}, {18400,3.238357}, {18500,2.968643}, {18600,3.091714}, {18700,3.084000}, {18800,3.217929}, {18900,3.351143}, {19000,3.245643}, {19100,3.403286}, {19200,3.095071}, {19300,3.418000}, {19400,3.423786}, {19500,3.382786}, {19600,3.254000}, {19700,3.656286}, {19800,3.521000}, {19900,3.741643}, {20000,3.323857}};
data["big_flat"]["TypeClassesBodyHOAS"]["norm reif"]["user"] = {{1,0.00021053}, {2,0.00031579}, {3,0.00014912}, {4,0.00043860}, {5,0.00046491}, {6,0.00042105}, {7,0.00061404}, {8,0.00055263}, {9,0.00073684}, {10,0.00064912}, {11,0.00090351}, {12,0.00092982}, {13,0.00106140}, {14,0.00137719}, {15,0.00122807}, {16,0.00107018}, {17,0.00141228}, {18,0.00173684}, {19,0.00155263}, {20,0.00165789}, {21,0.00178947}, {22,0.00168421}, {23,0.00183333}, {24,0.00189474}, {25,0.00206140}, {26,0.00219298}, {27,0.00229825}, {28,0.00214035}, {29,0.00242982}, {30,0.00242982}, {31,0.00258772}, {32,0.00268421}, {33,0.00305263}, {34,0.00262281}, {35,0.00307895}, {36,0.00307018}, {37,0.00305263}, {38,0.00319298}, {39,0.00339474}, {40,0.00345614}, {41,0.00332456}, {42,0.00481579}, {43,0.00357018}, {44,0.00378947}, {45,0.00391228}, {46,0.00402632}, {47,0.00428947}, {48,0.00399123}, {49,0.00414035}, {50,0.00450000}, {51,0.00460526}, {52,0.00442982}, {53,0.00485088}, {54,0.00497368}, {55,0.00509649}, {56,0.00432456}, {57,0.00484211}, {58,0.00596491}, {59,0.00530702}, {60,0.00535965}, {61,0.00561404}, {62,0.00557895}, {63,0.00589474}, {64,0.00565789}, {65,0.00591228}, {66,0.00596491}, {67,0.00585965}, {68,0.00608772}, {69,0.00621930}, {70,0.00770175}, {71,0.00634211}, {72,0.00654386}, {73,0.00662281}, {74,0.00686842}, {75,0.00681579}, {76,0.00678947}, {77,0.00713158}, {78,0.00735088}, {79,0.00766667}, {80,0.00729825}, {81,0.00729825}, {82,0.00748246}, {83,0.00767544}, {84,0.00753509}, {85,0.00793860}, {86,0.00800000}, {87,0.00838596}, {88,0.00798246}, {89,0.00855263}, {90,0.01011404}, {91,0.00911404}, {92,0.00875439}, {93,0.00928947}, {94,0.00963158}, {95,0.00959649}, {96,0.00843860}, {97,0.00914912}, {98,0.01141228}, {99,0.00960526}, {100,0.00969298}, {101,0.01051754}, {102,0.01018421}, {103,0.01082456}, {104,0.00985965}, {105,0.01045614}, {106,0.01171053}, {107,0.01082456}, {108,0.01060526}, {109,0.01115789}, {110,0.01139474}, {111,0.01173684}, {112,0.01092105}, {113,0.01129825}, {114,0.01070175}, {115,0.01194737}, {116,0.01106140}, {117,0.01196491}, {118,0.01189474}, {119,0.01257895}, {120,0.01350877}, {121,0.01223684}, {122,0.01246491}, {123,0.01273684}, {124,0.01258772}, {125,0.01291228}, {126,0.01307895}, {127,0.01450000}, {128,0.01206140}, {129,0.01275439}, {130,0.01277193}, {131,0.01363158}, {132,0.01341228}, {133,0.01524561}, {134,0.01350877}, {135,0.01397368}, {136,0.01341228}, {137,0.01378070}, {138,0.01392982}, {139,0.01539474}, {140,0.01421053}, {141,0.01467544}, {142,0.01492105}, {143,0.01510526}, {144,0.01629825}, {145,0.01448246}, {146,0.01464912}, {147,0.01505263}, {148,0.01499123}, {149,0.01542982}, {150,0.01634211}, {151,0.01615789}, {152,0.01540351}, {153,0.01585088}, {154,0.01593860}, {155,0.01814035}, {156,0.01589474}, {157,0.01657018}, {158,0.01665789}, {159,0.01729825}, {160,0.01670175}, {161,0.01613158}, {162,0.01618421}, {163,0.01646491}, {164,0.01635965}, {165,0.01853509}, {166,0.01670175}, {167,0.01742105}, {168,0.01664912}, {169,0.01696491}, {170,0.01810526}, {171,0.01783333}, {172,0.01781579}, {173,0.01822807}, {174,0.02139474}, {175,0.01858772}, {176,0.01706140}, {177,0.01816667}, {178,0.01800000}, {179,0.01967544}, {180,0.01831579}, {181,0.01904386}, {182,0.01912281}, {183,0.02232456}, {184,0.01822807}, {185,0.01885088}, {186,0.01929825}, {187,0.02323684}, {188,0.01914912}, {189,0.02014912}, {190,0.02018421}, {191,0.02407018}, {192,0.01835088}, {193,0.01883333}, {194,0.01904386}, {195,0.02290351}, {196,0.01940351}, {197,0.02035965}, {198,0.02074561}, {199,0.02392105}, {200,0.01945614}, {201,0.02056140}, {202,0.02074561}, {203,0.02456140}, {204,0.02043860}, {205,0.02150000}, {206,0.02151754}, {207,0.02503509}, {208,0.02064035}, {209,0.02190351}, {210,0.02138596}, {211,0.02453509}, {212,0.02146491}, {213,0.02328070}, {214,0.02321930}, {215,0.02519298}, {216,0.02225439}, {217,0.02363158}, {218,0.02684211}, {219,0.02363158}, {220,0.02356140}, {221,0.02439474}, {222,0.02555263}, {223,0.02579825}, {224,0.02270175}, {225,0.02621930}, {226,0.02321930}, {227,0.02463158}, {228,0.02355263}, {229,0.02589474}, {230,0.02488596}, {231,0.02568421}, {232,0.02696491}, {233,0.02492105}, {234,0.02494737}, {235,0.02580702}, {236,0.02480702}, {237,0.02570175}, {238,0.02624561}, {239,0.02776316}, {240,0.02486842}, {241,0.02593860}, {242,0.02897368}, {243,0.02685965}, {244,0.02588596}, {245,0.03011404}, {246,0.02671930}, {247,0.02806140}, {248,0.02888596}, {249,0.02707018}, {250,0.02709649}, {251,0.03144737}, {252,0.02685965}, {253,0.02871930}, {254,0.03130702}, {255,0.02921930}, {256,0.02594737}, {257,0.02963158}, {258,0.02635965}, {259,0.02824561}, {260,0.02689474}, {261,0.02790351}, {262,0.02794737}, {263,0.03177193}, {264,0.02676316}, {265,0.02872807}, {266,0.02850000}, {267,0.02945614}, {268,0.02797368}, {269,0.03198246}, {270,0.02980702}, {271,0.03004386}, {272,0.03037719}, {273,0.02854386}, {274,0.02910526}, {275,0.03240351}, {276,0.02901754}, {277,0.03039474}, {278,0.03253509}, {279,0.03134211}, {280,0.02915789}, {281,0.03210526}, {282,0.03064035}, {283,0.03734211}, {284,0.03008772}, {285,0.03202632}, {286,0.03447368}, {287,0.03290351}, {288,0.02921053}, {289,0.03238596}, {290,0.03069298}, {291,0.03183333}, {292,0.02989474}, {293,0.03229825}, {294,0.03488596}, {295,0.03267544}, {296,0.03114912}, {297,0.03438596}, {298,0.03288596}, {299,0.03855263}, {300,0.03150877}, {301,0.03346491}, {302,0.03660526}, {303,0.03589474}, {304,0.03610526}, {305,0.03239474}, {306,0.03307895}, {307,0.03679825}, {308,0.03363158}, {309,0.03509649}, {310,0.03421053}, {311,0.03611404}, {312,0.03589474}, {313,0.03522807}, {314,0.03964912}, {315,0.03620175}, {316,0.03550877}, {317,0.03793860}, {318,0.03698246}, {319,0.04200000}, {320,0.03221053}, {321,0.03449123}, {322,0.03409649}, {323,0.03548246}, {324,0.03644737}, {325,0.03583333}, {326,0.03992982}, {327,0.03674561}, {328,0.03466667}, {329,0.03770175}, {330,0.03626316}, {331,0.04163158}, {332,0.03599123}, {333,0.04174561}, {334,0.03732456}, {335,0.03889474}, {336,0.03601754}, {337,0.03682456}, {338,0.04112281}, {339,0.03834211}, {340,0.04053509}, {341,0.03792105}, {342,0.03840351}, {343,0.03931579}, {344,0.03715789}, {345,0.03943860}, {346,0.03894737}, {347,0.04427193}, {348,0.03945614}, {349,0.04397368}, {350,0.03970175}, {351,0.04503509}, {352,0.03709649}, {353,0.04202632}, {354,0.03779825}, {355,0.03974561}, {356,0.03937719}, {357,0.04014912}, {358,0.04144737}, {359,0.04178947}, {360,0.04250000}, {361,0.04041228}, {362,0.04449123}, {363,0.04149123}, {364,0.04404386}, {365,0.04214912}, {366,0.04599123}, {367,0.04273684}, {368,0.04210526}, {369,0.04118421}, {370,0.04472807}, {371,0.04211404}, {372,0.04407895}, {373,0.04249123}, {374,0.04605263}, {375,0.04351754}, {376,0.04522807}, {377,0.04239474}, {378,0.04655263}, {379,0.04438596}, {380,0.04682456}, {381,0.04424561}, {382,0.04826316}, {383,0.04701754}, {384,0.04194737}, {385,0.04076316}, {386,0.04428070}, {387,0.04301754}, {388,0.04469298}, {389,0.04200000}, {390,0.04600000}, {391,0.04450877}, {392,0.04439474}, {393,0.04300000}, {394,0.04808772}, {395,0.04436842}, {396,0.04595614}, {397,0.04493860}, {398,0.04814912}, {399,0.04703509}, {400,0.04534211}, {401,0.04329825}, {402,0.04785088}, {403,0.04564912}, {404,0.04793860}, {405,0.04605263}, {406,0.04970175}, {407,0.05480702}, {408,0.04355263}, {409,0.04997368}, {410,0.04616667}, {411,0.05075439}, {412,0.04620175}, {413,0.05103509}, {414,0.04839474}, {415,0.05248246}, {416,0.04388596}, {417,0.04875439}, {418,0.05031579}, {419,0.04700000}, {420,0.05037719}, {421,0.04723684}, {422,0.05157895}, {423,0.04953509}, {424,0.04924561}, {425,0.04872807}, {426,0.05047368}, {427,0.05693860}, {428,0.04782456}, {429,0.05254386}, {430,0.05002632}, {431,0.05501754}, {432,0.04667544}, {433,0.05187719}, {434,0.05651754}, {435,0.05016667}, {436,0.05189474}, {437,0.05075439}, {438,0.05289474}, {439,0.05196491}, {440,0.04926316}, {441,0.05492105}, {442,0.05094737}, {443,0.05573684}, {444,0.05132456}, {445,0.05615789}, {446,0.06139474}, {447,0.05493860}, {448,0.05028070}, {449,0.04899123}, {450,0.05166667}, {451,0.05827193}, {452,0.04900877}, {453,0.05384211}, {454,0.05199123}, {455,0.05558772}, {456,0.05659649}, {457,0.05092105}, {458,0.05522807}, {459,0.05284211}, {460,0.05439474}, {461,0.06070175}, {462,0.05314912}, {463,0.05866667}, {464,0.05075439}, {465,0.05510526}, {466,0.05954386}, {467,0.05336842}, {468,0.05456140}, {469,0.06129825}, {470,0.05359649}, {471,0.05923684}, {472,0.05278070}, {473,0.05708772}, {474,0.06271053}, {475,0.05656140}, {476,0.05725439}, {477,0.06397368}, {478,0.05635088}, {479,0.06160526}, {480,0.05896491}, {481,0.05342982}, {482,0.05623684}, {483,0.05625439}, {484,0.05369298}, {485,0.05914912}, {486,0.05613158}, {487,0.06014912}, {488,0.06131579}, {489,0.05557895}, {490,0.05811404}, {491,0.06579825}, {492,0.05668421}, {493,0.06064035}, {494,0.06522807}, {495,0.06091228}, {496,0.05626316}, {497,0.06473684}, {498,0.05677193}, {499,0.06150877}, {500,0.06496491}, {505,0.05953509}, {510,0.06208772}, {515,0.06100877}, {520,0.05703509}, {525,0.06105263}, {530,0.06185965}, {535,0.07186842}, {540,0.06219298}, {545,0.06284211}, {550,0.07070175}, {555,0.07342105}, {560,0.06236842}, {565,0.06962281}, {570,0.07421930}, {575,0.07897368}, {580,0.06389474}, {585,0.06909649}, {590,0.07688596}, {595,0.07680702}, {600,0.07467544}, {605,0.07372807}, {610,0.07082456}, {615,0.08181579}, {620,0.07902632}, {625,0.07954386}, {630,0.08213158}, {635,0.08574561}, {640,0.06850000}, {645,0.07539474}, {650,0.08092982}, {655,0.08753509}, {660,0.08161404}, {665,0.08572807}, {670,0.08875439}, {675,0.08707895}, {680,0.07736842}, {685,0.08325439}, {690,0.08214035}, {695,0.09420175}, {700,0.09414035}, {705,0.08887719}, {710,0.09107895}, {715,0.09463158}, {720,0.08919298}, {725,0.09597368}, {730,0.09631579}, {735,0.10261404}, {740,0.09440351}, {745,0.09720175}, {750,0.09984211}, {755,0.10089474}, {760,0.09762281}, {765,0.10401754}, {770,0.09126316}, {775,0.09916667}, {780,0.09607018}, {785,0.09695614}, {790,0.10018421}, {795,0.10342105}, {800,0.09567544}, {805,0.10156140}, {810,0.10250000}, {815,0.11022807}, {820,0.10420175}, {825,0.10822807}, {830,0.11100000}, {835,0.10526316}, {840,0.10211404}, {845,0.10983333}, {850,0.10728070}, {855,0.11402632}, {860,0.11177193}, {865,0.10802632}, {870,0.11256140}, {875,0.11658772}, {880,0.11004386}, {885,0.11792105}, {890,0.11721053}, {895,0.12730702}, {900,0.11491228}, {905,0.11403509}, {910,0.11713158}, {915,0.11811404}, {920,0.12098246}, {925,0.12168421}, {930,0.11519298}, {935,0.12432456}, {940,0.12078947}, {945,0.12069298}, {950,0.12592105}, {955,0.12893860}, {960,0.11511404}, {965,0.12369298}, {970,0.13095614}, {975,0.13208772}, {980,0.14885088}, {985,0.12954386}, {990,0.13293860}, {995,0.13732456}, {1000,0.12722807}, {1010,0.13921053}, {1020,0.13680702}, {1030,0.12819298}, {1040,0.12521930}, {1050,0.13405263}, {1060,0.13795614}, {1070,0.13924561}, {1080,0.14290351}, {1090,0.13357895}, {1100,0.14493860}, {1110,0.14470175}, {1120,0.14511404}, {1130,0.14642982}, {1140,0.15450000}, {1150,0.15829825}, {1160,0.14258772}, {1170,0.15457018}, {1180,0.15392982}, {1190,0.16187719}, {1200,0.15770175}, {1210,0.16125439}, {1220,0.16022807}, {1230,0.17001754}, {1240,0.15982456}, {1250,0.16057018}, {1260,0.17350000}, {1270,0.17811404}, {1280,0.17065789}, {1290,0.24353509}, {1300,0.17010526}, {1310,0.18191228}, {1320,0.17183333}, {1330,0.86445614}, {1340,0.18614035}, {1350,0.17585965}, {1360,0.17155263}, {1370,0.19146491}, {1380,0.18467544}, {1390,0.19477193}, {1400,0.19053509}, {1410,0.18158772}, {1420,0.18760526}, {1430,0.19553509}, {1440,0.18485088}, {1450,0.19650877}, {1460,0.19764035}, {1470,0.21071930}, {1480,0.19604386}, {1490,0.20336842}, {1500,0.20706140}, {1510,0.20895614}, {1520,0.20285965}, {1530,0.21802632}, {1540,0.19598246}, {1550,0.20661404}, {1560,0.20109649}, {1570,0.20264035}, {1580,0.21080702}, {1590,0.22467544}, {1600,0.20185965}, {1610,0.21205263}, {1620,0.21279825}, {1630,0.23418421}, {1640,0.21528947}, {1650,0.22431579}, {1660,0.23800000}, {1670,0.22091228}, {1680,0.21568421}, {1690,0.22969298}, {1700,0.22136842}, {1710,0.24458772}, {1720,0.23050877}, {1730,0.23251754}, {1740,0.23492982}, {1750,0.24799123}, {1760,0.22997368}, {1770,0.24926316}, {1780,0.24834211}, {1790,0.27150877}, {1800,0.23140351}, {1810,0.23701754}, {1820,0.25155263}, {1830,0.24571930}, {1840,0.24581579}, {1850,0.26415789}, {1860,0.24200000}, {1870,0.26528070}, {1880,0.25950877}, {1890,0.25488596}, {1900,0.26509649}, {1910,0.27296491}, {1920,0.24049123}, {1930,0.25753509}, {1940,0.26236842}, {1950,0.28016667}, {1960,0.26561404}, {1970,0.27444737}, {1980,0.28150000}, {1990,0.26975439}, {2000,0.26322807}, {2050,0.25841228}, {2100,0.28426316}, {2150,0.29794737}, {2200,0.29817544}, {2250,0.31167544}, {2300,0.33525439}, {2350,0.33926316}, {2400,0.31875439}, {2450,0.34299123}, {2500,0.34101754}, {2550,0.38260526}, {2600,0.35330702}, {2650,0.37835965}, {2700,0.37134211}, {2750,0.41324561}, {2800,0.39800000}, {2850,0.39436842}, {2900,0.40413158}, {2950,0.41536842}, {3000,0.43180702}, {3050,0.44672807}, {3100,0.43731579}, {3150,0.44992982}, {3200,0.41707018}, {3250,0.45785965}, {3300,0.46600877}, {3350,0.47087719}, {3400,0.46330702}, {3450,0.51945614}, {3500,0.50894737}, {3550,0.54800877}, {3600,0.48414912}, {3650,0.50306140}, {3700,0.54123684}, {3750,0.54264035}, {3800,0.55239474}, {3850,0.54585965}, {3900,0.58398246}, {3950,0.61323684}, {4000,0.61993860}, {4050,0.59797368}, {4100,0.55385088}, {4150,0.60771930}, {4200,0.59678070}, {4250,0.63471930}, {4300,0.62817544}, {4350,0.69907895}, {4400,0.62411404}, {4450,0.64150877}, {4500,0.65376316}, {4550,0.67727193}, {4600,0.71024561}, {4650,0.67917544}, {4700,0.70611404}, {4750,0.71249123}, {4800,0.67657018}, {4850,0.75850000}, {4900,0.71150000}, {4950,0.76685965}, {5000,0.72420175}, {5050,0.80507895}, {5100,0.81207018}, {5150,0.77283333}, {5200,0.72838596}, {5250,0.74319298}, {5300,0.79067544}, {5350,0.83437719}, {5400,0.78695614}, {5450,0.81756140}, {5500,0.87598246}, {5550,0.88366667}, {5600,0.84001754}, {5650,0.82242982}, {5700,0.83607018}, {5750,0.92093860}, {5800,0.86631579}, {5850,0.94572807}, {5900,0.87817544}, {5950,0.97183333}, {6000,0.91527193}, {6050,0.954000}, {6100,0.971286}, {6150,0.896214}, {6200,0.924786}, {6250,0.965357}, {6300,0.975857}, {6350,1.019571}, {6400,0.892714}, {6450,0.996714}, {6500,1.004714}, {6550,1.045286}, {6600,1.020143}, {6650,1.121929}, {6700,1.034214}, {6750,1.103357}, {6800,1.006714}, {6850,1.046571}, {6900,1.122857}, {6950,1.098786}, {7000,1.104643}, {7050,1.109786}, {7100,1.195929}, {7150,1.230143}, {7200,1.038214}, {7250,1.108500}, {7300,1.068143}, {7350,1.204786}, {7400,1.170500}, {7450,1.172357}, {7500,1.171929}, {7550,1.313286}, {7600,1.190929}, {7650,1.224571}, {7700,1.184857}, {7750,1.210357}, {7800,1.259000}, {7850,1.262143}, {7900,1.315143}, {7950,1.276643}, {8000,1.195500}, {8050,1.331786}, {8100,1.291929}, {8150,1.412214}, {8200,1.162071}, {8250,1.309143}, {8300,1.620286}, {8350,1.365000}, {8400,1.292071}, {8450,1.242857}, {8500,1.339429}, {8550,1.395786}, {8600,1.387214}, {8650,1.407071}, {8700,1.513143}, {8750,1.439857}, {8800,1.344857}, {8850,1.385357}, {8900,1.407214}, {8950,1.564571}, {9000,1.411857}, {9050,1.516000}, {9100,1.467071}, {9150,1.644643}, {9200,1.543143}, {9250,1.405571}, {9300,1.466929}, {9350,1.456643}, {9400,1.522429}, {9450,1.590571}, {9500,1.542714}, {9550,1.597286}, {9600,1.451857}, {9650,1.615929}, {9700,1.624429}, {9750,1.582000}, {9800,1.538786}, {9850,1.701500}, {9900,1.637286}, {9950,1.753714}, {10000,1.556571}, {10100,1.705214}, {10200,1.743500}, {10300,1.695000}, {10400,1.575643}, {10500,1.572071}, {10600,1.716500}, {10700,1.805357}, {10800,1.689929}, {10900,1.751071}, {11000,1.919000}, {11100,1.892429}, {11200,1.782214}, {11300,1.755929}, {11400,1.776000}, {11500,1.992500}, {11600,1.870143}, {11700,2.010714}, {11800,1.903214}, {11900,2.111857}, {12000,1.974500}, {12100,2.000571}, {12200,2.073929}, {12300,1.889857}, {12400,1.968643}, {12500,2.056643}, {12600,2.088929}, {12700,2.161286}, {12800,1.879214}, {12900,2.110643}, {13000,2.128929}, {13100,2.208286}, {13200,2.132071}, {13300,2.413071}, {13400,2.186571}, {13500,2.369000}, {13600,2.121286}, {13700,2.223143}, {13800,2.413714}, {13900,2.327786}, {14000,2.334214}, {14100,2.360643}, {14200,2.515714}, {14300,2.595929}, {14400,2.171571}, {14500,2.369000}, {14600,2.284357}, {14700,2.561357}, {14800,2.494286}, {14900,2.502143}, {15000,2.522000}, {15100,2.793571}, {15200,2.530500}, {15300,2.621143}, {15400,2.465500}, {15500,2.592000}, {15600,2.709357}, {15700,2.726571}, {15800,2.820929}, {15900,2.725071}, {16000,2.558357}, {16100,2.835500}, {16200,2.757143}, {16300,2.967500}, {16400,2.479429}, {16500,2.831286}, {16600,2.804571}, {16700,2.897786}, {16800,2.748786}, {16900,2.614071}, {17000,2.845571}, {17100,2.975714}, {17200,2.893500}, {17300,2.974714}, {17400,3.211214}, {17500,3.056214}, {17600,2.843643}, {17700,2.931857}, {17800,2.976500}, {17900,3.321429}, {18000,2.983214}, {18100,3.232857}, {18200,3.159071}, {18300,3.467929}, {18400,3.233571}, {18500,2.964786}, {18600,3.087000}, {18700,3.079000}, {18800,3.213786}, {18900,3.347500}, {19000,3.240929}, {19100,3.397857}, {19200,3.091000}, {19300,3.412857}, {19400,3.417429}, {19500,3.377000}, {19600,3.248500}, {19700,3.650857}, {19800,3.515714}, {19900,3.735571}, {20000,3.308571}};
data["big_flat"]["TypeClassesBodyHOAS"]["norm reif"]["system"] = {{1,0.00000000}, {2,0.00007018}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00003509}, {9,0.00000000}, {10,0.00000000}, {11,0.00002632}, {12,0.00000000}, {13,0.00000000}, {14,0.00003509}, {15,0.00007018}, {16,0.00003509}, {17,0.00002632}, {18,0.00000000}, {19,0.00000000}, {20,0.00003509}, {21,0.00003509}, {22,0.00002632}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00003509}, {28,0.00003509}, {29,0.00003509}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00007018}, {35,0.00000000}, {36,0.00003509}, {37,0.00007018}, {38,0.00000000}, {39,0.00003509}, {40,0.00010526}, {41,0.00003509}, {42,0.00003509}, {43,0.00007018}, {44,0.00003509}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00007018}, {49,0.00003509}, {50,0.00002632}, {51,0.00000000}, {52,0.00003509}, {53,0.00002632}, {54,0.00003509}, {55,0.00003509}, {56,0.00010526}, {57,0.00010526}, {58,0.00003509}, {59,0.00003509}, {60,0.00007018}, {61,0.00000000}, {62,0.00003509}, {63,0.00006140}, {64,0.00002632}, {65,0.00003509}, {66,0.00000000}, {67,0.00000000}, {68,0.00010526}, {69,0.00003509}, {70,0.00000000}, {71,0.00007018}, {72,0.00007018}, {73,0.00003509}, {74,0.00000000}, {75,0.00010526}, {76,0.00003509}, {77,0.00009649}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00003509}, {82,0.00000000}, {83,0.00010526}, {84,0.00003509}, {85,0.00003509}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00003509}, {90,0.00000000}, {91,0.00000000}, {92,0.00007018}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00007018}, {97,0.00007018}, {98,0.00007018}, {99,0.00000000}, {100,0.00002632}, {101,0.00000000}, {102,0.00003509}, {103,0.00000000}, {104,0.00003509}, {105,0.00003509}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00007018}, {117,0.00000000}, {118,0.00006140}, {119,0.00000000}, {120,0.00009649}, {121,0.00003509}, {122,0.00000000}, {123,0.00007018}, {124,0.00003509}, {125,0.00003509}, {126,0.00000000}, {127,0.00003509}, {128,0.00007018}, {129,0.00003509}, {130,0.00000000}, {131,0.00003509}, {132,0.00000000}, {133,0.00003509}, {134,0.00003509}, {135,0.00000000}, {136,0.00007018}, {137,0.00003509}, {138,0.00000000}, {139,0.00003509}, {140,0.00003509}, {141,0.00006140}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00003509}, {146,0.00000000}, {147,0.00000000}, {148,0.00003509}, {149,0.00003509}, {150,0.00003509}, {151,0.00006140}, {152,0.00003509}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00003509}, {159,0.00013158}, {160,0.00000000}, {161,0.00007018}, {162,0.00007018}, {163,0.00003509}, {164,0.00000000}, {165,0.00003509}, {166,0.00007018}, {167,0.00007018}, {168,0.00007018}, {169,0.00007018}, {170,0.00000000}, {171,0.00007018}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00003509}, {177,0.00003509}, {178,0.00010526}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00010526}, {185,0.00000000}, {186,0.00003509}, {187,0.00000000}, {188,0.00000000}, {189,0.00003509}, {190,0.00003509}, {191,0.00007018}, {192,0.00003509}, {193,0.00003509}, {194,0.00000000}, {195,0.00007018}, {196,0.00003509}, {197,0.00003509}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00003509}, {203,0.00003509}, {204,0.00003509}, {205,0.00000000}, {206,0.00000000}, {207,0.00007018}, {208,0.00003509}, {209,0.00000000}, {210,0.00003509}, {211,0.00000000}, {212,0.00000000}, {213,0.00003509}, {214,0.00000000}, {215,0.00003509}, {216,0.00000000}, {217,0.00000000}, {218,0.00007018}, {219,0.00007018}, {220,0.00007018}, {221,0.00002632}, {222,0.00002632}, {223,0.00003509}, {224,0.00007018}, {225,0.00000000}, {226,0.00000000}, {227,0.00003509}, {228,0.00000000}, {229,0.00000000}, {230,0.00007018}, {231,0.00003509}, {232,0.00000000}, {233,0.00007018}, {234,0.00000000}, {235,0.00000000}, {236,0.00003509}, {237,0.00000000}, {238,0.00003509}, {239,0.00007018}, {240,0.00007018}, {241,0.00000000}, {242,0.00003509}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00003509}, {247,0.00007018}, {248,0.00000000}, {249,0.00003509}, {250,0.00003509}, {251,0.00000000}, {252,0.00003509}, {253,0.00003509}, {254,0.00006140}, {255,0.00000000}, {256,0.00000000}, {257,0.00003509}, {258,0.00000000}, {259,0.00003509}, {260,0.00003509}, {261,0.00003509}, {262,0.00002632}, {263,0.00003509}, {264,0.00000000}, {265,0.00000000}, {266,0.00003509}, {267,0.00007018}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00002632}, {272,0.00003509}, {273,0.00000000}, {274,0.00000000}, {275,0.00003509}, {276,0.00007018}, {277,0.00003509}, {278,0.00000000}, {279,0.00000000}, {280,0.00013158}, {281,0.00003509}, {282,0.00000000}, {283,0.00000000}, {284,0.00003509}, {285,0.00003509}, {286,0.00000000}, {287,0.00007018}, {288,0.00000000}, {289,0.00000000}, {290,0.00003509}, {291,0.00000000}, {292,0.00000000}, {293,0.00009649}, {294,0.00003509}, {295,0.00003509}, {296,0.00003509}, {297,0.00003509}, {298,0.00000000}, {299,0.00010526}, {300,0.00003509}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00003509}, {305,0.00000000}, {306,0.00003509}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00007018}, {311,0.00000000}, {312,0.00000000}, {313,0.00003509}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00003509}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00003509}, {325,0.00007018}, {326,0.00000000}, {327,0.00000000}, {328,0.00003509}, {329,0.00000000}, {330,0.00003509}, {331,0.00000000}, {332,0.00000000}, {333,0.00010526}, {334,0.00000000}, {335,0.00003509}, {336,0.00003509}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00003509}, {345,0.00003509}, {346,0.00000000}, {347,0.00007018}, {348,0.00007018}, {349,0.00003509}, {350,0.00003509}, {351,0.00003509}, {352,0.00003509}, {353,0.00000000}, {354,0.00003509}, {355,0.00003509}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00003509}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00010526}, {369,0.00003509}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00003509}, {375,0.00000000}, {376,0.00003509}, {377,0.00007018}, {378,0.00003509}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00003509}, {383,0.00006140}, {384,0.00000000}, {385,0.00003509}, {386,0.00000000}, {387,0.00003509}, {388,0.00007018}, {389,0.00000000}, {390,0.00003509}, {391,0.00000000}, {392,0.00014035}, {393,0.00002632}, {394,0.00003509}, {395,0.00000000}, {396,0.00007018}, {397,0.00003509}, {398,0.00007018}, {399,0.00003509}, {400,0.00003509}, {401,0.00010526}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00003509}, {408,0.00007018}, {409,0.00007018}, {410,0.00000000}, {411,0.00003509}, {412,0.00002632}, {413,0.00010526}, {414,0.00002632}, {415,0.00000000}, {416,0.00003509}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00007018}, {421,0.00000000}, {422,0.00014035}, {423,0.00003509}, {424,0.00007018}, {425,0.00000000}, {426,0.00007018}, {427,0.00021053}, {428,0.00003509}, {429,0.00014035}, {430,0.00000000}, {431,0.00006140}, {432,0.00007018}, {433,0.00007018}, {434,0.00010526}, {435,0.00000000}, {436,0.00010526}, {437,0.00000000}, {438,0.00024561}, {439,0.00003509}, {440,0.00002632}, {441,0.00020175}, {442,0.00000000}, {443,0.00016667}, {444,0.00000000}, {445,0.00014035}, {446,0.00021053}, {447,0.00003509}, {448,0.00017544}, {449,0.00000000}, {450,0.00010526}, {451,0.00056140}, {452,0.00000000}, {453,0.00014035}, {454,0.00000000}, {455,0.00010526}, {456,0.00040351}, {457,0.00007018}, {458,0.00017544}, {459,0.00003509}, {460,0.00014035}, {461,0.00047368}, {462,0.00000000}, {463,0.00016667}, {464,0.00007018}, {465,0.00021053}, {466,0.00037719}, {467,0.00000000}, {468,0.00017544}, {469,0.00031579}, {470,0.00003509}, {471,0.00021053}, {472,0.00003509}, {473,0.00014035}, {474,0.00035088}, {475,0.00000000}, {476,0.00003509}, {477,0.00034211}, {478,0.00003509}, {479,0.00028070}, {480,0.00038596}, {481,0.00000000}, {482,0.00030702}, {483,0.00000000}, {484,0.00000000}, {485,0.00034211}, {486,0.00003509}, {487,0.00010526}, {488,0.00037719}, {489,0.00003509}, {490,0.00017544}, {491,0.00049123}, {492,0.00003509}, {493,0.00014035}, {494,0.00044737}, {495,0.00000000}, {496,0.00017544}, {497,0.00041228}, {498,0.00002632}, {499,0.00007018}, {500,0.00037719}, {505,0.00000000}, {510,0.00000000}, {515,0.00007018}, {520,0.00003509}, {525,0.00003509}, {530,0.00014035}, {535,0.00045614}, {540,0.00000000}, {545,0.00010526}, {550,0.00051754}, {555,0.00049123}, {560,0.00000000}, {565,0.00010526}, {570,0.00038596}, {575,0.00031579}, {580,0.00000000}, {585,0.00021053}, {590,0.00038596}, {595,0.00052632}, {600,0.00041228}, {605,0.00000000}, {610,0.00017544}, {615,0.00031579}, {620,0.00030702}, {625,0.00007018}, {630,0.00014035}, {635,0.00014035}, {640,0.00003509}, {645,0.00014035}, {650,0.00010526}, {655,0.00026316}, {660,0.00024561}, {665,0.00020175}, {670,0.00063158}, {675,0.00036842}, {680,0.00000000}, {685,0.00003509}, {690,0.00002632}, {695,0.00059649}, {700,0.00037719}, {705,0.00066667}, {710,0.00041228}, {715,0.00042105}, {720,0.00047368}, {725,0.00035088}, {730,0.00061404}, {735,0.00049123}, {740,0.00050877}, {745,0.00062281}, {750,0.00063158}, {755,0.00056140}, {760,0.00058772}, {765,0.00075439}, {770,0.00065789}, {775,0.00078070}, {780,0.00069298}, {785,0.00080702}, {790,0.00059649}, {795,0.00077193}, {800,0.00062281}, {805,0.00072807}, {810,0.00058772}, {815,0.00091228}, {820,0.00061404}, {825,0.00069298}, {830,0.00084211}, {835,0.00066667}, {840,0.00080702}, {845,0.00057895}, {850,0.00062281}, {855,0.00072807}, {860,0.00076316}, {865,0.00070175}, {870,0.00061404}, {875,0.00065789}, {880,0.00062281}, {885,0.00062281}, {890,0.00078947}, {895,0.00044737}, {900,0.00105263}, {905,0.00049123}, {910,0.00044737}, {915,0.00058772}, {920,0.00083333}, {925,0.00066667}, {930,0.00037719}, {935,0.00048246}, {940,0.00072807}, {945,0.00056140}, {950,0.00051754}, {955,0.00059649}, {960,0.00048246}, {965,0.00044737}, {970,0.00087719}, {975,0.00063158}, {980,0.00048246}, {985,0.00059649}, {990,0.00049123}, {995,0.00100877}, {1000,0.00028070}, {1010,0.00072807}, {1020,0.00059649}, {1030,0.00052632}, {1040,0.00048246}, {1050,0.00050877}, {1060,0.00091228}, {1070,0.00051754}, {1080,0.00059649}, {1090,0.00063158}, {1100,0.00097368}, {1110,0.00042105}, {1120,0.00083333}, {1130,0.00056140}, {1140,0.00072807}, {1150,0.00049123}, {1160,0.00055263}, {1170,0.00063158}, {1180,0.00014035}, {1190,0.00006140}, {1200,0.00007018}, {1210,0.00003509}, {1220,0.00007018}, {1230,0.00003509}, {1240,0.00003509}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00003509}, {1280,0.00007018}, {1290,0.00007018}, {1300,0.00003509}, {1310,0.00007018}, {1320,0.00000000}, {1330,0.00091228}, {1340,0.00000000}, {1350,0.00007018}, {1360,0.00007018}, {1370,0.00003509}, {1380,0.00003509}, {1390,0.00007018}, {1400,0.00003509}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00007018}, {1440,0.00003509}, {1450,0.00014035}, {1460,0.00010526}, {1470,0.00010526}, {1480,0.00007018}, {1490,0.00007018}, {1500,0.00003509}, {1510,0.00002632}, {1520,0.00007018}, {1530,0.00003509}, {1540,0.00003509}, {1550,0.00003509}, {1560,0.00003509}, {1570,0.00000000}, {1580,0.00021053}, {1590,0.00003509}, {1600,0.00003509}, {1610,0.00000000}, {1620,0.00017544}, {1630,0.00003509}, {1640,0.00003509}, {1650,0.00010526}, {1660,0.00007018}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00003509}, {1700,0.00010526}, {1710,0.00003509}, {1720,0.00003509}, {1730,0.00000000}, {1740,0.00003509}, {1750,0.00010526}, {1760,0.00007018}, {1770,0.00003509}, {1780,0.00003509}, {1790,0.00010526}, {1800,0.00009649}, {1810,0.00000000}, {1820,0.00020175}, {1830,0.00000000}, {1840,0.00017544}, {1850,0.00003509}, {1860,0.00010526}, {1870,0.00000000}, {1880,0.00014035}, {1890,0.00007018}, {1900,0.00010526}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00007018}, {1960,0.00010526}, {1970,0.00003509}, {1980,0.00000000}, {1990,0.00003509}, {2000,0.00002632}, {2050,0.00000000}, {2100,0.00041228}, {2150,0.00071053}, {2200,0.00042105}, {2250,0.00028070}, {2300,0.00031579}, {2350,0.00051754}, {2400,0.00035088}, {2450,0.00055263}, {2500,0.00024561}, {2550,0.00045614}, {2600,0.00038596}, {2650,0.00034211}, {2700,0.00028070}, {2750,0.00021053}, {2800,0.00014035}, {2850,0.00009649}, {2900,0.00017544}, {2950,0.00017544}, {3000,0.00017544}, {3050,0.00007018}, {3100,0.00003509}, {3150,0.00021053}, {3200,0.00031579}, {3250,0.00009649}, {3300,0.00007018}, {3350,0.00020175}, {3400,0.00028070}, {3450,0.00055263}, {3500,0.00058772}, {3550,0.00065789}, {3600,0.00017544}, {3650,0.00062281}, {3700,0.00049123}, {3750,0.00041228}, {3800,0.00014035}, {3850,0.00006140}, {3900,0.00007018}, {3950,0.00010526}, {4000,0.00017544}, {4050,0.00007018}, {4100,0.00016667}, {4150,0.00034211}, {4200,0.00014035}, {4250,0.00028070}, {4300,0.00010526}, {4350,0.00028070}, {4400,0.00041228}, {4450,0.00024561}, {4500,0.00042105}, {4550,0.00014035}, {4600,0.00007018}, {4650,0.00009649}, {4700,0.00016667}, {4750,0.00003509}, {4800,0.00014035}, {4850,0.00007018}, {4900,0.00010526}, {4950,0.00020175}, {5000,0.00010526}, {5050,0.00010526}, {5100,0.00010526}, {5150,0.00003509}, {5200,0.00021053}, {5250,0.00013158}, {5300,0.00010526}, {5350,0.00003509}, {5400,0.00010526}, {5450,0.00014035}, {5500,0.00017544}, {5550,0.00017544}, {5600,0.00010526}, {5650,0.00003509}, {5700,0.00003509}, {5750,0.00017544}, {5800,0.00007018}, {5850,0.00013158}, {5900,0.00017544}, {5950,0.00007018}, {6000,0.00017544}, {6050,0.003071}, {6100,0.005929}, {6150,0.005357}, {6200,0.004214}, {6250,0.006286}, {6300,0.002571}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000286}, {6650,0.000000}, {6700,0.000571}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000571}, {6950,0.000857}, {7000,0.000286}, {7050,0.000214}, {7100,0.000286}, {7150,0.001143}, {7200,0.000500}, {7250,0.000286}, {7300,0.001429}, {7350,0.001143}, {7400,0.000857}, {7450,0.000571}, {7500,0.000571}, {7550,0.000857}, {7600,0.000571}, {7650,0.000286}, {7700,0.000571}, {7750,0.000857}, {7800,0.000857}, {7850,0.000571}, {7900,0.000571}, {7950,0.000571}, {8000,0.000286}, {8050,0.000571}, {8100,0.000857}, {8150,0.000857}, {8200,0.000000}, {8250,0.000000}, {8300,0.000286}, {8350,0.000286}, {8400,0.000286}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000786}, {8650,0.000000}, {8700,0.000286}, {8750,0.000286}, {8800,0.000571}, {8850,0.000286}, {8900,0.000286}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000500}, {9150,0.000571}, {9200,0.000000}, {9250,0.000286}, {9300,0.000000}, {9350,0.000571}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000286}, {9650,0.000286}, {9700,0.000000}, {9750,0.000286}, {9800,0.000286}, {9850,0.000000}, {9900,0.000286}, {9950,0.000000}, {10000,0.000000}, {10100,0.000286}, {10200,0.000000}, {10300,0.000000}, {10400,0.000286}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000857}, {11100,0.000000}, {11200,0.000571}, {11300,0.000286}, {11400,0.000000}, {11500,0.000857}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.001143}, {12300,0.000286}, {12400,0.000286}, {12500,0.000286}, {12600,0.000000}, {12700,0.000286}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000286}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000286}, {13900,0.000000}, {14000,0.000000}, {14100,0.000286}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.001714}, {14700,0.012571}, {14800,0.011714}, {14900,0.004000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000571}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000286}, {16100,0.000000}, {16200,0.000000}, {16300,0.000286}, {16400,0.000000}, {16500,0.000571}, {16600,0.000286}, {16700,0.000286}, {16800,0.000000}, {16900,0.002214}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000286}, {17900,0.000286}, {18000,0.000000}, {18100,0.000000}, {18200,0.000286}, {18300,0.000286}, {18400,0.000286}, {18500,0.000000}, {18600,0.000571}, {18700,0.000000}, {18800,0.000571}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000286}, {19400,0.000000}, {19500,0.001143}, {19600,0.000000}, {19700,0.000286}, {19800,0.000286}, {19900,0.000571}, {20000,0.010500}};
data["big_flat"]["TypeClassesBodyHOAS"]["post"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00328070}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000643}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000000}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClassesBodyHOAS"]["post"]["user"] = {{1,0.00009649}, {2,0.00002632}, {3,0.00000000}, {4,0.00003509}, {5,0.00005263}, {6,0.00003509}, {7,0.00007018}, {8,0.00000000}, {9,0.00006140}, {10,0.00003509}, {11,0.00003509}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00010526}, {16,0.00002632}, {17,0.00000000}, {18,0.00010526}, {19,0.00003509}, {20,0.00006140}, {21,0.00000000}, {22,0.00000000}, {23,0.00007018}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00007018}, {28,0.00003509}, {29,0.00003509}, {30,0.00000000}, {31,0.00007018}, {32,0.00000000}, {33,0.00006140}, {34,0.00007018}, {35,0.00000000}, {36,0.00000000}, {37,0.00003509}, {38,0.00010526}, {39,0.00000000}, {40,0.00002632}, {41,0.00006140}, {42,0.00010526}, {43,0.00002632}, {44,0.00000000}, {45,0.00000000}, {46,0.00002632}, {47,0.00000000}, {48,0.00000000}, {49,0.00003509}, {50,0.00002632}, {51,0.00002632}, {52,0.00007018}, {53,0.00000000}, {54,0.00006140}, {55,0.00003509}, {56,0.00000000}, {57,0.00003509}, {58,0.00000000}, {59,0.00000000}, {60,0.00006140}, {61,0.00000000}, {62,0.00007018}, {63,0.00007018}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00003509}, {68,0.00003509}, {69,0.00000000}, {70,0.00000000}, {71,0.00003509}, {72,0.00002632}, {73,0.00000000}, {74,0.00003509}, {75,0.00003509}, {76,0.00000000}, {77,0.00009649}, {78,0.00000000}, {79,0.00002632}, {80,0.00003509}, {81,0.00006140}, {82,0.00000000}, {83,0.00003509}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00008772}, {88,0.00000000}, {89,0.00000000}, {90,0.00003509}, {91,0.00000000}, {92,0.00000000}, {93,0.00002632}, {94,0.00000000}, {95,0.00007018}, {96,0.00007018}, {97,0.00010526}, {98,0.00002632}, {99,0.00003509}, {100,0.00002632}, {101,0.00003509}, {102,0.00003509}, {103,0.00003509}, {104,0.00003509}, {105,0.00003509}, {106,0.00003509}, {107,0.00000000}, {108,0.00003509}, {109,0.00000000}, {110,0.00000000}, {111,0.00007018}, {112,0.00003509}, {113,0.00000000}, {114,0.00006140}, {115,0.00006140}, {116,0.00003509}, {117,0.00000000}, {118,0.00003509}, {119,0.00002632}, {120,0.00000000}, {121,0.00000000}, {122,0.00006140}, {123,0.00002632}, {124,0.00000000}, {125,0.00003509}, {126,0.00006140}, {127,0.00000000}, {128,0.00007018}, {129,0.00006140}, {130,0.00000000}, {131,0.00000000}, {132,0.00003509}, {133,0.00007018}, {134,0.00003509}, {135,0.00006140}, {136,0.00002632}, {137,0.00003509}, {138,0.00000000}, {139,0.00003509}, {140,0.00000000}, {141,0.00008772}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00003509}, {147,0.00000000}, {148,0.00006140}, {149,0.00002632}, {150,0.00009649}, {151,0.00006140}, {152,0.00000000}, {153,0.00006140}, {154,0.00000000}, {155,0.00000000}, {156,0.00002632}, {157,0.00000000}, {158,0.00002632}, {159,0.00000000}, {160,0.00002632}, {161,0.00005263}, {162,0.00003509}, {163,0.00000000}, {164,0.00002632}, {165,0.00006140}, {166,0.00000000}, {167,0.00002632}, {168,0.00000000}, {169,0.00006140}, {170,0.00002632}, {171,0.00010526}, {172,0.00003509}, {173,0.00005263}, {174,0.00002632}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00002632}, {182,0.00003509}, {183,0.00002632}, {184,0.00000000}, {185,0.00002632}, {186,0.00000000}, {187,0.00006140}, {188,0.00000000}, {189,0.00003509}, {190,0.00009649}, {191,0.00003509}, {192,0.00003509}, {193,0.00003509}, {194,0.00003509}, {195,0.00002632}, {196,0.00000000}, {197,0.00010526}, {198,0.00000000}, {199,0.00000000}, {200,0.00006140}, {201,0.00000000}, {202,0.00006140}, {203,0.00000000}, {204,0.00010526}, {205,0.00003509}, {206,0.00006140}, {207,0.00003509}, {208,0.00002632}, {209,0.00000000}, {210,0.00003509}, {211,0.00000000}, {212,0.00000000}, {213,0.00008772}, {214,0.00000000}, {215,0.00000000}, {216,0.00003509}, {217,0.00000000}, {218,0.00003509}, {219,0.00009649}, {220,0.00007018}, {221,0.00005263}, {222,0.00003509}, {223,0.00002632}, {224,0.00000000}, {225,0.00014035}, {226,0.00018421}, {227,0.00002632}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00003509}, {232,0.00007018}, {233,0.00006140}, {234,0.00007018}, {235,0.00003509}, {236,0.00006140}, {237,0.00000000}, {238,0.00003509}, {239,0.00000000}, {240,0.00003509}, {241,0.00008772}, {242,0.00002632}, {243,0.00003509}, {244,0.00000000}, {245,0.00000000}, {246,0.00006140}, {247,0.00007018}, {248,0.00006140}, {249,0.00000000}, {250,0.00007018}, {251,0.00006140}, {252,0.00000000}, {253,0.00002632}, {254,0.00003509}, {255,0.00000000}, {256,0.00002632}, {257,0.00002632}, {258,0.00012281}, {259,0.00000000}, {260,0.00000000}, {261,0.00013158}, {262,0.00007018}, {263,0.00000000}, {264,0.00002632}, {265,0.00000000}, {266,0.00007018}, {267,0.00003509}, {268,0.00007018}, {269,0.00000000}, {270,0.00000000}, {271,0.00007018}, {272,0.00003509}, {273,0.00002632}, {274,0.00002632}, {275,0.00009649}, {276,0.00003509}, {277,0.00000000}, {278,0.00007018}, {279,0.00003509}, {280,0.00002632}, {281,0.00002632}, {282,0.00000000}, {283,0.00007895}, {284,0.00007018}, {285,0.00003509}, {286,0.00000000}, {287,0.00002632}, {288,0.00002632}, {289,0.00003509}, {290,0.00002632}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00003509}, {298,0.00003509}, {299,0.00003509}, {300,0.00010526}, {301,0.00003509}, {302,0.00008772}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00002632}, {308,0.00000000}, {309,0.00003509}, {310,0.00007018}, {311,0.00000000}, {312,0.00006140}, {313,0.00002632}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00003509}, {318,0.00003509}, {319,0.00003509}, {320,0.00000000}, {321,0.00000000}, {322,0.00009649}, {323,0.00000000}, {324,0.00000000}, {325,0.00006140}, {326,0.00000000}, {327,0.00010526}, {328,0.00000000}, {329,0.00009649}, {330,0.00006140}, {331,0.00013158}, {332,0.00002632}, {333,0.00000000}, {334,0.00005263}, {335,0.00000000}, {336,0.00000000}, {337,0.00002632}, {338,0.00000000}, {339,0.00003509}, {340,0.00006140}, {341,0.00000000}, {342,0.00331579}, {343,0.00000000}, {344,0.00000000}, {345,0.00003509}, {346,0.00000000}, {347,0.00003509}, {348,0.00002632}, {349,0.00000000}, {350,0.00013158}, {351,0.00006140}, {352,0.00003509}, {353,0.00003509}, {354,0.00006140}, {355,0.00000000}, {356,0.00002632}, {357,0.00000000}, {358,0.00002632}, {359,0.00002632}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00003509}, {365,0.00003509}, {366,0.00000000}, {367,0.00000000}, {368,0.00008772}, {369,0.00003509}, {370,0.00002632}, {371,0.00006140}, {372,0.00000000}, {373,0.00006140}, {374,0.00016667}, {375,0.00003509}, {376,0.00003509}, {377,0.00002632}, {378,0.00003509}, {379,0.00007018}, {380,0.00003509}, {381,0.00000000}, {382,0.00007018}, {383,0.00007018}, {384,0.00005263}, {385,0.00008772}, {386,0.00000000}, {387,0.00006140}, {388,0.00003509}, {389,0.00006140}, {390,0.00000000}, {391,0.00006140}, {392,0.00000000}, {393,0.00000000}, {394,0.00007018}, {395,0.00002632}, {396,0.00002632}, {397,0.00002632}, {398,0.00003509}, {399,0.00000000}, {400,0.00003509}, {401,0.00003509}, {402,0.00003509}, {403,0.00002632}, {404,0.00003509}, {405,0.00000000}, {406,0.00000000}, {407,0.00006140}, {408,0.00003509}, {409,0.00000000}, {410,0.00003509}, {411,0.00000000}, {412,0.00005263}, {413,0.00003509}, {414,0.00003509}, {415,0.00003509}, {416,0.00000000}, {417,0.00000000}, {418,0.00003509}, {419,0.00000000}, {420,0.00003509}, {421,0.00000000}, {422,0.00003509}, {423,0.00006140}, {424,0.00003509}, {425,0.00003509}, {426,0.00000000}, {427,0.00000000}, {428,0.00003509}, {429,0.00002632}, {430,0.00002632}, {431,0.00003509}, {432,0.00007018}, {433,0.00000000}, {434,0.00000000}, {435,0.00002632}, {436,0.00000000}, {437,0.00003509}, {438,0.00003509}, {439,0.00009649}, {440,0.00002632}, {441,0.00000000}, {442,0.00009649}, {443,0.00002632}, {444,0.00007018}, {445,0.00000000}, {446,0.00003509}, {447,0.00006140}, {448,0.00000000}, {449,0.00000000}, {450,0.00010526}, {451,0.00002632}, {452,0.00006140}, {453,0.00002632}, {454,0.00003509}, {455,0.00003509}, {456,0.00002632}, {457,0.00003509}, {458,0.00003509}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00003509}, {463,0.00000000}, {464,0.00000000}, {465,0.00003509}, {466,0.00003509}, {467,0.00000000}, {468,0.00005263}, {469,0.00000000}, {470,0.00003509}, {471,0.00000000}, {472,0.00007018}, {473,0.00000000}, {474,0.00010526}, {475,0.00000000}, {476,0.00002632}, {477,0.00005263}, {478,0.00003509}, {479,0.00007018}, {480,0.00003509}, {481,0.00003509}, {482,0.00006140}, {483,0.00002632}, {484,0.00006140}, {485,0.00007018}, {486,0.00000000}, {487,0.00007018}, {488,0.00003509}, {489,0.00000000}, {490,0.00000000}, {491,0.00003509}, {492,0.00005263}, {493,0.00009649}, {494,0.00003509}, {495,0.00003509}, {496,0.00003509}, {497,0.00009649}, {498,0.00003509}, {499,0.00000000}, {500,0.00000000}, {505,0.00006140}, {510,0.00000000}, {515,0.00003509}, {520,0.00003509}, {525,0.00000000}, {530,0.00006140}, {535,0.00003509}, {540,0.00007018}, {545,0.00000000}, {550,0.00003509}, {555,0.00000000}, {560,0.00003509}, {565,0.00000000}, {570,0.00000000}, {575,0.00003509}, {580,0.00003509}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00003509}, {610,0.00007018}, {615,0.00010526}, {620,0.00000000}, {625,0.00000000}, {630,0.00005263}, {635,0.00000000}, {640,0.00000000}, {645,0.00007018}, {650,0.00003509}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00003509}, {675,0.00003509}, {680,0.00000000}, {685,0.00003509}, {690,0.00000000}, {695,0.00003509}, {700,0.00003509}, {705,0.00013158}, {710,0.00003509}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00002632}, {750,0.00007018}, {755,0.00000000}, {760,0.00000000}, {765,0.00003509}, {770,0.00006140}, {775,0.00008772}, {780,0.00003509}, {785,0.00007018}, {790,0.00002632}, {795,0.00007018}, {800,0.00003509}, {805,0.00002632}, {810,0.00002632}, {815,0.00003509}, {820,0.00003509}, {825,0.00000000}, {830,0.00003509}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00003509}, {855,0.00006140}, {860,0.00003509}, {865,0.00009649}, {870,0.00000000}, {875,0.00002632}, {880,0.00000000}, {885,0.00002632}, {890,0.00000000}, {895,0.00003509}, {900,0.00000000}, {905,0.00009649}, {910,0.00006140}, {915,0.00000000}, {920,0.00007018}, {925,0.00006140}, {930,0.00000000}, {935,0.00006140}, {940,0.00000000}, {945,0.00007018}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00003509}, {970,0.00000000}, {975,0.00007018}, {980,0.00016667}, {985,0.00007018}, {990,0.00000000}, {995,0.00006140}, {1000,0.00009649}, {1010,0.00000000}, {1020,0.00006140}, {1030,0.00007018}, {1040,0.00000000}, {1050,0.00003509}, {1060,0.00002632}, {1070,0.00006140}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00003509}, {1120,0.00002632}, {1130,0.00002632}, {1140,0.00000000}, {1150,0.00002632}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00007018}, {1190,0.00000000}, {1200,0.00003509}, {1210,0.00002632}, {1220,0.00003509}, {1230,0.00003509}, {1240,0.00006140}, {1250,0.00003509}, {1260,0.00002632}, {1270,0.00003509}, {1280,0.00006140}, {1290,0.00011404}, {1300,0.00000000}, {1310,0.00002632}, {1320,0.00007018}, {1330,0.00002632}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00008772}, {1370,0.00003509}, {1380,0.00003509}, {1390,0.00003509}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00003509}, {1430,0.00003509}, {1440,0.00000000}, {1450,0.00007018}, {1460,0.00002632}, {1470,0.00003509}, {1480,0.00000000}, {1490,0.00009649}, {1500,0.00006140}, {1510,0.00000000}, {1520,0.00003509}, {1530,0.00002632}, {1540,0.00008772}, {1550,0.00010526}, {1560,0.00003509}, {1570,0.00000000}, {1580,0.00003509}, {1590,0.00000000}, {1600,0.00002632}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00007018}, {1640,0.00009649}, {1650,0.00000000}, {1660,0.00002632}, {1670,0.00002632}, {1680,0.00000000}, {1690,0.00003509}, {1700,0.00006140}, {1710,0.00003509}, {1720,0.00002632}, {1730,0.00007018}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00003509}, {1770,0.00003509}, {1780,0.00000000}, {1790,0.00007018}, {1800,0.00008772}, {1810,0.00000000}, {1820,0.00006140}, {1830,0.00006140}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00003509}, {1870,0.00007018}, {1880,0.00000000}, {1890,0.00003509}, {1900,0.00006140}, {1910,0.00000000}, {1920,0.00002632}, {1930,0.00007018}, {1940,0.00006140}, {1950,0.00000000}, {1960,0.00003509}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00006140}, {2000,0.00003509}, {2050,0.00000000}, {2100,0.00007018}, {2150,0.00007018}, {2200,0.00008772}, {2250,0.00000000}, {2300,0.00003509}, {2350,0.00003509}, {2400,0.00003509}, {2450,0.00000000}, {2500,0.00003509}, {2550,0.00006140}, {2600,0.00000000}, {2650,0.00007018}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00009649}, {2900,0.00003509}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00003509}, {3150,0.00003509}, {3200,0.00006140}, {3250,0.00003509}, {3300,0.00000000}, {3350,0.00006140}, {3400,0.00002632}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00003509}, {3600,0.00000000}, {3650,0.00003509}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00010526}, {3900,0.00003509}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00007018}, {4150,0.00003509}, {4200,0.00009649}, {4250,0.00000000}, {4300,0.00003509}, {4350,0.00007018}, {4400,0.00000000}, {4450,0.00006140}, {4500,0.00003509}, {4550,0.00000000}, {4600,0.00006140}, {4650,0.00000000}, {4700,0.00003509}, {4750,0.00003509}, {4800,0.00000000}, {4850,0.00003509}, {4900,0.00003509}, {4950,0.00000000}, {5000,0.00003509}, {5050,0.00007018}, {5100,0.00007018}, {5150,0.00010526}, {5200,0.00006140}, {5250,0.00000000}, {5300,0.00003509}, {5350,0.00003509}, {5400,0.00003509}, {5450,0.00003509}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00014035}, {5650,0.00003509}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00003509}, {5850,0.00000000}, {5900,0.00003509}, {5950,0.00003509}, {6000,0.00002632}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000214}, {6300,0.000000}, {6350,0.000714}, {6400,0.000000}, {6450,0.000286}, {6500,0.000000}, {6550,0.000286}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000286}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000214}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000286}, {8050,0.000214}, {8100,0.000000}, {8150,0.000214}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000214}, {8400,0.000286}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000214}, {9050,0.000000}, {9100,0.000214}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000286}, {9450,0.000000}, {9500,0.000214}, {9550,0.000286}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000286}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000214}, {11000,0.000214}, {11100,0.000000}, {11200,0.000000}, {11300,0.000286}, {11400,0.000000}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000214}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000214}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000429}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000214}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000214}, {18900,0.000214}, {19000,0.000214}, {19100,0.000000}, {19200,0.000000}, {19300,0.000214}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClassesBodyHOAS"]["post"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00003509}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00003509}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00003509}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00003509}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00003509}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00003509}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00003509}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00003509}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00003509}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00003509}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000000}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClassesBodyHOAS"]["pre"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000000}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClassesBodyHOAS"]["pre"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00002632}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00003509}, {18,0.00003509}, {19,0.00000000}, {20,0.00000000}, {21,0.00002632}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00002632}, {36,0.00000000}, {37,0.00000000}, {38,0.00003509}, {39,0.00000000}, {40,0.00000000}, {41,0.00003509}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00002632}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00003509}, {53,0.00002632}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00002632}, {80,0.00000000}, {81,0.00064035}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00002632}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00006140}, {112,0.00000000}, {113,0.00000000}, {114,0.00003509}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00002632}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00003509}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00002632}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00002632}, {169,0.00000000}, {170,0.00003509}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00003509}, {180,0.00002632}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00002632}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00002632}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00003509}, {203,0.00000000}, {204,0.00003509}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00003509}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00003509}, {255,0.00000000}, {256,0.00000000}, {257,0.00003509}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00002632}, {262,0.00000000}, {263,0.00000000}, {264,0.00003509}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00003509}, {270,0.00000000}, {271,0.00006140}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00002632}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00003509}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00003509}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00003509}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00002632}, {303,0.00000000}, {304,0.00003509}, {305,0.00003509}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00002632}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00003509}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00003509}, {334,0.00003509}, {335,0.00000000}, {336,0.00002632}, {337,0.00005263}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00005263}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00002632}, {361,0.00002632}, {362,0.00003509}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00003509}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00003509}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00007018}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00002632}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00003509}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00002632}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00002632}, {436,0.00000000}, {437,0.00000000}, {438,0.00005263}, {439,0.00000000}, {440,0.00003509}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00003509}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00003509}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00002632}, {461,0.00007018}, {462,0.00003509}, {463,0.00002632}, {464,0.00000000}, {465,0.00000000}, {466,0.00003509}, {467,0.00003509}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00006140}, {476,0.00000000}, {477,0.00005263}, {478,0.00000000}, {479,0.00000000}, {480,0.00002632}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00002632}, {496,0.00002632}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00003509}, {600,0.00000000}, {605,0.00003509}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00003509}, {675,0.00003509}, {680,0.00000000}, {685,0.00003509}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00003509}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00003509}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00003509}, {790,0.00003509}, {795,0.00000000}, {800,0.00002632}, {805,0.00002632}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00003509}, {840,0.00000000}, {845,0.00000000}, {850,0.00002632}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00003509}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00003509}, {895,0.00000000}, {900,0.00000000}, {905,0.00007018}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00002632}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00002632}, {985,0.00000000}, {990,0.00000000}, {995,0.00003509}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00003509}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00006140}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00002632}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00003509}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00002632}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00006140}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00003509}, {1640,0.00000000}, {1650,0.00003509}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00003509}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00003509}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00003509}, {1770,0.00000000}, {1780,0.00003509}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00002632}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00003509}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00003509}, {1940,0.00003509}, {1950,0.00000000}, {1960,0.00003509}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00003509}, {2100,0.00003509}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00003509}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00003509}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00003509}, {3450,0.00000000}, {3500,0.00003509}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00002632}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00003509}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00002632}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00003509}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00002632}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00003509}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00003509}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000286}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000000}, {11700,0.000286}, {11800,0.000286}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000214}, {17900,0.000000}, {18000,0.000000}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClassesBodyHOAS"]["pre"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.000000}, {6100,0.000000}, {6150,0.000000}, {6200,0.000000}, {6250,0.000000}, {6300,0.000000}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000000}, {6650,0.000000}, {6700,0.000000}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000000}, {6950,0.000000}, {7000,0.000000}, {7050,0.000000}, {7100,0.000000}, {7150,0.000000}, {7200,0.000000}, {7250,0.000000}, {7300,0.000000}, {7350,0.000000}, {7400,0.000000}, {7450,0.000000}, {7500,0.000000}, {7550,0.000000}, {7600,0.000000}, {7650,0.000000}, {7700,0.000000}, {7750,0.000000}, {7800,0.000000}, {7850,0.000000}, {7900,0.000000}, {7950,0.000000}, {8000,0.000000}, {8050,0.000000}, {8100,0.000000}, {8150,0.000000}, {8200,0.000000}, {8250,0.000000}, {8300,0.000000}, {8350,0.000000}, {8400,0.000000}, {8450,0.000000}, {8500,0.000000}, {8550,0.000000}, {8600,0.000000}, {8650,0.000000}, {8700,0.000000}, {8750,0.000000}, {8800,0.000000}, {8850,0.000000}, {8900,0.000000}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000000}, {9150,0.000000}, {9200,0.000000}, {9250,0.000000}, {9300,0.000000}, {9350,0.000000}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000000}, {9650,0.000000}, {9700,0.000000}, {9750,0.000000}, {9800,0.000000}, {9850,0.000000}, {9900,0.000000}, {9950,0.000000}, {10000,0.000000}, {10100,0.000000}, {10200,0.000000}, {10300,0.000000}, {10400,0.000000}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000000}, {11000,0.000000}, {11100,0.000000}, {11200,0.000000}, {11300,0.000000}, {11400,0.000000}, {11500,0.000000}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.000000}, {12300,0.000000}, {12400,0.000000}, {12500,0.000000}, {12600,0.000000}, {12700,0.000000}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000000}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000000}, {13900,0.000000}, {14000,0.000000}, {14100,0.000000}, {14200,0.000000}, {14300,0.000000}, {14400,0.000000}, {14500,0.000000}, {14600,0.000000}, {14700,0.000000}, {14800,0.000000}, {14900,0.000000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000000}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000000}, {15800,0.000000}, {15900,0.000000}, {16000,0.000000}, {16100,0.000000}, {16200,0.000000}, {16300,0.000000}, {16400,0.000000}, {16500,0.000000}, {16600,0.000000}, {16700,0.000000}, {16800,0.000000}, {16900,0.000000}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000000}, {17900,0.000000}, {18000,0.000000}, {18100,0.000000}, {18200,0.000000}, {18300,0.000000}, {18400,0.000000}, {18500,0.000000}, {18600,0.000000}, {18700,0.000000}, {18800,0.000000}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000000}, {19400,0.000000}, {19500,0.000000}, {19600,0.000000}, {19700,0.000000}, {19800,0.000000}, {19900,0.000000}, {20000,0.000000}};
data["big_flat"]["TypeClassesBodyHOAS"]["reif"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00038596}, {10,0.00100000}, {11,0.00100000}, {12,0.00100000}, {13,0.00100000}, {14,0.00100000}, {15,0.00100000}, {16,0.00100000}, {17,0.00100000}, {18,0.00100000}, {19,0.00106140}, {20,0.00106140}, {21,0.00177193}, {22,0.00200000}, {23,0.00201754}, {24,0.00200000}, {25,0.00200000}, {26,0.00200000}, {27,0.00200000}, {28,0.00200000}, {29,0.00213158}, {30,0.00241228}, {31,0.00273684}, {32,0.00247368}, {33,0.00300000}, {34,0.00300000}, {35,0.00308772}, {36,0.00300000}, {37,0.00300000}, {38,0.00301754}, {39,0.00346491}, {40,0.00315789}, {41,0.00350000}, {42,0.00481579}, {43,0.00400000}, {44,0.00399123}, {45,0.00400000}, {46,0.00400000}, {47,0.00427193}, {48,0.00400000}, {49,0.00425439}, {50,0.00447368}, {51,0.00462281}, {52,0.00450000}, {53,0.00497368}, {54,0.00500000}, {55,0.00504386}, {56,0.00500000}, {57,0.00506140}, {58,0.00592105}, {59,0.00547368}, {60,0.00546491}, {61,0.00568421}, {62,0.00587719}, {63,0.00602632}, {64,0.00549123}, {65,0.00600000}, {66,0.00600000}, {67,0.00645614}, {68,0.00612281}, {69,0.00649123}, {70,0.00783333}, {71,0.00692105}, {72,0.00647368}, {73,0.00693860}, {74,0.00696491}, {75,0.00753509}, {76,0.00711404}, {77,0.00754386}, {78,0.00758772}, {79,0.00789474}, {80,0.00741228}, {81,0.00751754}, {82,0.00760526}, {83,0.00815789}, {84,0.00793860}, {85,0.00850877}, {86,0.00854386}, {87,0.00858772}, {88,0.00836842}, {89,0.00854386}, {90,0.00954386}, {91,0.00920175}, {92,0.00879825}, {93,0.00942105}, {94,0.00976316}, {95,0.00961404}, {96,0.00871930}, {97,0.00944737}, {98,0.01130702}, {99,0.00957895}, {100,0.00945614}, {101,0.00981579}, {102,0.00997368}, {103,0.01052632}, {104,0.00965789}, {105,0.01071930}, {106,0.01173684}, {107,0.01053509}, {108,0.01042982}, {109,0.01092105}, {110,0.01121930}, {111,0.01131579}, {112,0.01039474}, {113,0.01113158}, {114,0.01119298}, {115,0.01140351}, {116,0.01134211}, {117,0.01153509}, {118,0.01170175}, {119,0.01246491}, {120,0.01341228}, {121,0.01232456}, {122,0.01242105}, {123,0.01261404}, {124,0.01249123}, {125,0.01288596}, {126,0.01307018}, {127,0.01431579}, {128,0.01219298}, {129,0.01254386}, {130,0.01257018}, {131,0.01344737}, {132,0.01307018}, {133,0.01528947}, {134,0.01334211}, {135,0.01400000}, {136,0.01350000}, {137,0.01364912}, {138,0.01378947}, {139,0.01572807}, {140,0.01421930}, {141,0.01452632}, {142,0.01460526}, {143,0.01536842}, {144,0.01624561}, {145,0.01436842}, {146,0.01442982}, {147,0.01527193}, {148,0.01469298}, {149,0.01551754}, {150,0.01648246}, {151,0.01617544}, {152,0.01545614}, {153,0.01574561}, {154,0.01588596}, {155,0.01854386}, {156,0.01591228}, {157,0.01657895}, {158,0.01664912}, {159,0.01741228}, {160,0.01684211}, {161,0.01624561}, {162,0.01638596}, {163,0.01692982}, {164,0.01650877}, {165,0.01860526}, {166,0.01701754}, {167,0.01780702}, {168,0.01669298}, {169,0.01750000}, {170,0.01871930}, {171,0.01828070}, {172,0.01768421}, {173,0.01853509}, {174,0.02147368}, {175,0.01889474}, {176,0.01740351}, {177,0.01822807}, {178,0.01831579}, {179,0.01996491}, {180,0.01850000}, {181,0.01920175}, {182,0.01922807}, {183,0.02247368}, {184,0.01871053}, {185,0.01944737}, {186,0.01981579}, {187,0.02328947}, {188,0.01958772}, {189,0.02050877}, {190,0.02072807}, {191,0.02390351}, {192,0.01862281}, {193,0.01948246}, {194,0.01966667}, {195,0.02304386}, {196,0.01963158}, {197,0.02050877}, {198,0.02070175}, {199,0.02387719}, {200,0.01977193}, {201,0.02082456}, {202,0.02107018}, {203,0.02458772}, {204,0.02090351}, {205,0.02184211}, {206,0.02191228}, {207,0.02487719}, {208,0.02102632}, {209,0.02185965}, {210,0.02195614}, {211,0.02449123}, {212,0.02178947}, {213,0.02326316}, {214,0.02300877}, {215,0.02516667}, {216,0.02217544}, {217,0.02362281}, {218,0.02702632}, {219,0.02377193}, {220,0.02373684}, {221,0.02428070}, {222,0.02546491}, {223,0.02551754}, {224,0.02238596}, {225,0.02650877}, {226,0.02301754}, {227,0.02457018}, {228,0.02359649}, {229,0.02564035}, {230,0.02495614}, {231,0.02559649}, {232,0.02709649}, {233,0.02500877}, {234,0.02484211}, {235,0.02584211}, {236,0.02474561}, {237,0.02575439}, {238,0.02635965}, {239,0.02806140}, {240,0.02510526}, {241,0.02603509}, {242,0.02911404}, {243,0.02708772}, {244,0.02598246}, {245,0.03033333}, {246,0.02674561}, {247,0.02834211}, {248,0.02903509}, {249,0.02714912}, {250,0.02710526}, {251,0.03146491}, {252,0.02707895}, {253,0.02883333}, {254,0.03166667}, {255,0.02982456}, {256,0.02585088}, {257,0.02994737}, {258,0.02653509}, {259,0.02825439}, {260,0.02708772}, {261,0.02807018}, {262,0.02800877}, {263,0.03203509}, {264,0.02700000}, {265,0.02873684}, {266,0.02869298}, {267,0.02973684}, {268,0.02842982}, {269,0.03227193}, {270,0.02993860}, {271,0.03071053}, {272,0.03057018}, {273,0.02883333}, {274,0.02914912}, {275,0.03269298}, {276,0.02926316}, {277,0.03082456}, {278,0.03296491}, {279,0.03157018}, {280,0.02985965}, {281,0.03261404}, {282,0.03084211}, {283,0.03744737}, {284,0.03050877}, {285,0.03231579}, {286,0.03463158}, {287,0.03333333}, {288,0.02947368}, {289,0.03257018}, {290,0.03106140}, {291,0.03221053}, {292,0.03045614}, {293,0.03245614}, {294,0.03507018}, {295,0.03321930}, {296,0.03142105}, {297,0.03467544}, {298,0.03325439}, {299,0.03873684}, {300,0.03186842}, {301,0.03371053}, {302,0.03634211}, {303,0.03594737}, {304,0.03642982}, {305,0.03277193}, {306,0.03336842}, {307,0.03674561}, {308,0.03371053}, {309,0.03971930}, {310,0.03466667}, {311,0.03600877}, {312,0.03574561}, {313,0.03528947}, {314,0.03973684}, {315,0.03620175}, {316,0.03550877}, {317,0.03820175}, {318,0.03689474}, {319,0.04250877}, {320,0.03266667}, {321,0.03452632}, {322,0.03457895}, {323,0.03570175}, {324,0.03628070}, {325,0.03590351}, {326,0.04011404}, {327,0.03668421}, {328,0.03475439}, {329,0.03771053}, {330,0.03637719}, {331,0.04192982}, {332,0.03611404}, {333,0.04223684}, {334,0.03740351}, {335,0.03900000}, {336,0.03621930}, {337,0.03695614}, {338,0.04153509}, {339,0.03818421}, {340,0.04110526}, {341,0.03801754}, {342,0.03850877}, {343,0.03932456}, {344,0.03715789}, {345,0.03986842}, {346,0.03907895}, {347,0.04486842}, {348,0.03928070}, {349,0.04458772}, {350,0.04014912}, {351,0.04539474}, {352,0.03715789}, {353,0.04257018}, {354,0.03822807}, {355,0.04006140}, {356,0.03953509}, {357,0.04040351}, {358,0.04153509}, {359,0.04188596}, {360,0.04296491}, {361,0.04069298}, {362,0.04444737}, {363,0.04171053}, {364,0.04429825}, {365,0.04253509}, {366,0.04607895}, {367,0.04321930}, {368,0.04278947}, {369,0.04150000}, {370,0.04541228}, {371,0.04246491}, {372,0.04475439}, {373,0.04300000}, {374,0.04630702}, {375,0.04388596}, {376,0.04547368}, {377,0.04286842}, {378,0.04688596}, {379,0.04474561}, {380,0.04687719}, {381,0.04492105}, {382,0.04833333}, {383,0.04721053}, {384,0.04235088}, {385,0.04113158}, {386,0.04450000}, {387,0.04320175}, {388,0.04488596}, {389,0.04278070}, {390,0.04610526}, {391,0.04485965}, {392,0.04506140}, {393,0.04324561}, {394,0.04822807}, {395,0.04492105}, {396,0.04646491}, {397,0.04540351}, {398,0.04832456}, {399,0.04713158}, {400,0.04535088}, {401,0.04388596}, {402,0.04784211}, {403,0.04597368}, {404,0.04788596}, {405,0.04591228}, {406,0.04969298}, {407,0.05523684}, {408,0.04425439}, {409,0.04996491}, {410,0.04653509}, {411,0.05114035}, {412,0.04669298}, {413,0.05141228}, {414,0.04842105}, {415,0.05281579}, {416,0.04401754}, {417,0.04878947}, {418,0.05031579}, {419,0.04714035}, {420,0.05041228}, {421,0.04715789}, {422,0.05204386}, {423,0.04987719}, {424,0.04935088}, {425,0.04858772}, {426,0.05096491}, {427,0.05790351}, {428,0.04821053}, {429,0.05316667}, {430,0.05008772}, {431,0.05561404}, {432,0.04704386}, {433,0.05232456}, {434,0.05686842}, {435,0.04999123}, {436,0.05234211}, {437,0.05102632}, {438,0.05347368}, {439,0.05238596}, {440,0.04925439}, {441,0.05544737}, {442,0.05099123}, {443,0.05623684}, {444,0.05142982}, {445,0.05634211}, {446,0.06171053}, {447,0.05557895}, {448,0.05077193}, {449,0.04909649}, {450,0.05224561}, {451,0.05875439}, {452,0.04885088}, {453,0.05456140}, {454,0.05235088}, {455,0.05601754}, {456,0.05707018}, {457,0.05108772}, {458,0.05561404}, {459,0.05308772}, {460,0.05492982}, {461,0.06172807}, {462,0.05350877}, {463,0.05892105}, {464,0.05092105}, {465,0.05555263}, {466,0.06014035}, {467,0.05392105}, {468,0.05529825}, {469,0.06192105}, {470,0.05417544}, {471,0.05951754}, {472,0.05307018}, {473,0.05725439}, {474,0.06305263}, {475,0.05700000}, {476,0.05765789}, {477,0.06470175}, {478,0.05672807}, {479,0.06191228}, {480,0.05936842}, {481,0.05394737}, {482,0.05717544}, {483,0.05670175}, {484,0.05408772}, {485,0.05978947}, {486,0.05657895}, {487,0.06061404}, {488,0.06215789}, {489,0.05658772}, {490,0.05884211}, {491,0.06670175}, {492,0.05688596}, {493,0.06104386}, {494,0.06642982}, {495,0.06116667}, {496,0.05696491}, {497,0.06551754}, {498,0.05701754}, {499,0.06175439}, {500,0.06551754}, {505,0.05975439}, {510,0.06224561}, {515,0.06115789}, {520,0.05736842}, {525,0.06118421}, {530,0.06193860}, {535,0.07261404}, {540,0.06239474}, {545,0.06332456}, {550,0.07145614}, {555,0.07418421}, {560,0.06255263}, {565,0.07000877}, {570,0.07510526}, {575,0.07984211}, {580,0.06442105}, {585,0.06980702}, {590,0.07771930}, {595,0.07798246}, {600,0.07587719}, {605,0.07406140}, {610,0.07140351}, {615,0.08235965}, {620,0.07978947}, {625,0.08006140}, {630,0.08277193}, {635,0.08636842}, {640,0.06902632}, {645,0.07593860}, {650,0.08139474}, {655,0.08807018}, {660,0.08249123}, {665,0.08622807}, {670,0.08994737}, {675,0.08788596}, {680,0.07774561}, {685,0.08374561}, {690,0.08272807}, {695,0.09528070}, {700,0.09507895}, {705,0.09014035}, {710,0.09195614}, {715,0.09580702}, {720,0.08996491}, {725,0.09679825}, {730,0.09747368}, {735,0.10373684}, {740,0.09552632}, {745,0.09825439}, {750,0.10092982}, {755,0.10202632}, {760,0.09897368}, {765,0.10561404}, {770,0.09267544}, {775,0.10057895}, {780,0.09714912}, {785,0.09817544}, {790,0.10149123}, {795,0.10486842}, {800,0.09685965}, {805,0.10296491}, {810,0.10361404}, {815,0.11135965}, {820,0.10519298}, {825,0.10940351}, {830,0.11262281}, {835,0.10653509}, {840,0.10376316}, {845,0.11095614}, {850,0.10843860}, {855,0.11544737}, {860,0.11304386}, {865,0.10921930}, {870,0.11437719}, {875,0.11797368}, {880,0.11125439}, {885,0.11897368}, {890,0.11850877}, {895,0.12831579}, {900,0.11652632}, {905,0.11512281}, {910,0.11820175}, {915,0.11911404}, {920,0.12257018}, {925,0.12312281}, {930,0.11639474}, {935,0.12540351}, {940,0.12188596}, {945,0.12197368}, {950,0.12723684}, {955,0.13091228}, {960,0.11622807}, {965,0.12483333}, {970,0.13228947}, {975,0.13351754}, {980,0.15015789}, {985,0.13102632}, {990,0.13402632}, {995,0.13894737}, {1000,0.12843860}, {1010,0.14043860}, {1020,0.13800877}, {1030,0.12953509}, {1040,0.12645614}, {1050,0.13542105}, {1060,0.13952632}, {1070,0.14052632}, {1080,0.14433333}, {1090,0.13492105}, {1100,0.14678947}, {1110,0.14600000}, {1120,0.14664912}, {1130,0.14812281}, {1140,0.15584211}, {1150,0.15937719}, {1160,0.14374561}, {1170,0.15594737}, {1180,0.15496491}, {1190,0.16273684}, {1200,0.15853509}, {1210,0.16233333}, {1220,0.16129825}, {1230,0.17094737}, {1240,0.16101754}, {1250,0.16150000}, {1260,0.17447368}, {1270,0.17907895}, {1280,0.17150877}, {1290,0.24464035}, {1300,0.17143860}, {1310,0.18288596}, {1320,0.17278947}, {1330,0.86734211}, {1340,0.18737719}, {1350,0.17686842}, {1360,0.17255263}, {1370,0.19260526}, {1380,0.18577193}, {1390,0.19591228}, {1400,0.19146491}, {1410,0.18292105}, {1420,0.18865789}, {1430,0.19671053}, {1440,0.18572807}, {1450,0.19780702}, {1460,0.19864912}, {1470,0.21194737}, {1480,0.19739474}, {1490,0.20414912}, {1500,0.20822807}, {1510,0.21017544}, {1520,0.20402632}, {1530,0.22710526}, {1540,0.19721053}, {1550,0.20774561}, {1560,0.20207895}, {1570,0.20381579}, {1580,0.21184211}, {1590,0.22585965}, {1600,0.20294737}, {1610,0.21318421}, {1620,0.21417544}, {1630,0.23550877}, {1640,0.21651754}, {1650,0.22557895}, {1660,0.23932456}, {1670,0.22204386}, {1680,0.21661404}, {1690,0.23078947}, {1700,0.22249123}, {1710,0.24602632}, {1720,0.23179825}, {1730,0.23383333}, {1740,0.23641228}, {1750,0.24960526}, {1760,0.23154386}, {1770,0.25141228}, {1780,0.24955263}, {1790,0.27313158}, {1800,0.23287719}, {1810,0.23814035}, {1820,0.25281579}, {1830,0.24721930}, {1840,0.24722807}, {1850,0.26579825}, {1860,0.24329825}, {1870,0.26692982}, {1880,0.26109649}, {1890,0.25623684}, {1900,0.26662281}, {1910,0.27434211}, {1920,0.24158772}, {1930,0.25881579}, {1940,0.26345614}, {1950,0.28159649}, {1960,0.26711404}, {1970,0.27562281}, {1980,0.28319298}, {1990,0.27128947}, {2000,0.26456140}, {2050,0.26001754}, {2100,0.28591228}, {2150,0.30003509}, {2200,0.29980702}, {2250,0.31367544}, {2300,0.33692105}, {2350,0.34159649}, {2400,0.32078070}, {2450,0.34506140}, {2500,0.34307018}, {2550,0.38478947}, {2600,0.35562281}, {2650,0.38062281}, {2700,0.37354386}, {2750,0.41573684}, {2800,0.40027193}, {2850,0.39677193}, {2900,0.40635088}, {2950,0.41759649}, {3000,0.43404386}, {3050,0.44931579}, {3100,0.43945614}, {3150,0.45253509}, {3200,0.41981579}, {3250,0.46918421}, {3300,0.46837719}, {3350,0.47325439}, {3400,0.46588596}, {3450,0.52214912}, {3500,0.51216667}, {3550,0.55119298}, {3600,0.48649123}, {3650,0.50600877}, {3700,0.54421053}, {3750,0.54543860}, {3800,0.55507018}, {3850,0.54805263}, {3900,0.58708772}, {3950,0.61645614}, {4000,0.62281579}, {4050,0.60081579}, {4100,0.55699123}, {4150,0.61091228}, {4200,0.59980702}, {4250,0.63811404}, {4300,0.63220175}, {4350,0.70242982}, {4400,0.62764035}, {4450,0.64585965}, {4500,0.65714035}, {4550,0.68051754}, {4600,0.71330702}, {4650,0.68271930}, {4700,0.70979825}, {4750,0.71616667}, {4800,0.68009649}, {4850,0.76206140}, {4900,0.71522807}, {4950,0.77045614}, {5000,0.72783333}, {5050,0.80876316}, {5100,0.81703509}, {5150,0.77633333}, {5200,0.74568421}, {5250,0.74674561}, {5300,0.79435965}, {5350,0.83828947}, {5400,0.79064912}, {5450,0.82120175}, {5500,0.88032456}, {5550,0.88786842}, {5600,0.84410526}, {5650,0.82646491}, {5700,0.85128947}, {5750,0.92549123}, {5800,0.87036842}, {5850,0.94988596}, {5900,0.88269298}, {5950,0.97628947}, {6000,0.91963158}, {6050,0.962429}, {6100,0.982143}, {6150,0.907286}, {6200,0.934571}, {6250,0.977357}, {6300,0.983643}, {6350,1.024429}, {6400,0.897714}, {6450,1.002214}, {6500,1.009571}, {6550,1.050429}, {6600,1.025071}, {6650,1.126071}, {6700,1.039857}, {6750,1.108214}, {6800,1.011643}, {6850,1.051857}, {6900,1.129000}, {6950,1.104786}, {7000,1.110143}, {7050,1.115571}, {7100,1.201000}, {7150,1.236857}, {7200,1.044071}, {7250,1.113143}, {7300,1.074357}, {7350,1.210643}, {7400,1.175571}, {7450,1.177714}, {7500,1.176857}, {7550,1.319000}, {7600,1.208000}, {7650,1.230500}, {7700,1.189929}, {7750,1.216286}, {7800,1.265786}, {7850,1.267286}, {7900,1.321000}, {7950,1.282429}, {8000,1.200929}, {8050,1.337643}, {8100,1.298143}, {8150,1.418786}, {8200,1.166571}, {8250,1.314286}, {8300,1.627214}, {8350,1.371929}, {8400,1.297571}, {8450,1.247571}, {8500,1.346714}, {8550,1.402143}, {8600,1.394429}, {8650,1.413143}, {8700,1.556786}, {8750,1.447143}, {8800,1.373429}, {8850,1.392571}, {8900,1.413214}, {8950,1.571214}, {9000,1.418571}, {9050,1.521714}, {9100,1.488786}, {9150,1.650929}, {9200,1.549714}, {9250,1.411214}, {9300,1.473357}, {9350,1.464000}, {9400,1.529286}, {9450,1.596929}, {9500,1.548786}, {9550,1.604286}, {9600,1.458286}, {9650,1.623214}, {9700,1.631571}, {9750,1.589143}, {9800,1.546143}, {9850,1.708500}, {9900,1.644071}, {9950,1.759786}, {10000,1.563429}, {10100,1.712786}, {10200,1.751071}, {10300,1.701714}, {10400,1.582714}, {10500,1.579500}, {10600,1.723714}, {10700,1.812429}, {10800,1.696143}, {10900,1.757929}, {11000,1.927357}, {11100,1.899000}, {11200,1.790071}, {11300,1.763643}, {11400,1.782500}, {11500,2.000714}, {11600,1.877286}, {11700,2.018000}, {11800,1.910071}, {11900,2.141857}, {12000,1.982071}, {12100,2.008357}, {12200,2.083286}, {12300,1.898000}, {12400,1.976643}, {12500,2.065714}, {12600,2.097929}, {12700,2.169214}, {12800,1.887357}, {12900,2.120500}, {13000,2.137714}, {13100,2.216071}, {13200,2.140143}, {13300,2.441786}, {13400,2.195214}, {13500,2.378429}, {13600,2.129929}, {13700,2.232429}, {13800,2.422214}, {13900,2.337571}, {14000,2.343143}, {14100,2.370429}, {14200,2.547071}, {14300,2.626429}, {14400,2.182214}, {14500,2.378643}, {14600,2.320857}, {14700,2.583929}, {14800,2.515786}, {14900,2.515000}, {15000,2.550714}, {15100,2.803071}, {15200,2.560857}, {15300,2.631143}, {15400,2.475214}, {15500,2.602500}, {15600,2.718786}, {15700,2.736786}, {15800,2.830929}, {15900,2.735357}, {16000,2.569286}, {16100,2.846429}, {16200,2.767357}, {16300,2.978000}, {16400,2.491143}, {16500,2.842143}, {16600,2.841643}, {16700,2.908643}, {16800,2.759929}, {16900,2.646357}, {17000,2.856071}, {17100,2.986571}, {17200,2.904000}, {17300,2.985929}, {17400,3.222214}, {17500,3.069143}, {17600,2.888929}, {17700,2.943500}, {17800,3.008000}, {17900,3.334857}, {18000,3.022071}, {18100,3.247500}, {18200,3.172143}, {18300,3.499429}, {18400,3.267643}, {18500,3.013786}, {18600,3.102214}, {18700,3.092714}, {18800,3.226500}, {18900,3.361357}, {19000,3.283357}, {19100,3.414357}, {19200,3.104143}, {19300,3.427000}, {19400,3.433000}, {19500,3.391929}, {19600,3.263214}, {19700,3.665571}, {19800,3.530500}, {19900,3.751143}, {20000,3.333214}};
data["big_flat"]["TypeClassesBodyHOAS"]["reif"]["user"] = {{1,0.00024561}, {2,0.00043860}, {3,0.00028070}, {4,0.00046491}, {5,0.00056140}, {6,0.00058772}, {7,0.00075439}, {8,0.00069298}, {9,0.00083333}, {10,0.00078070}, {11,0.00106140}, {12,0.00103509}, {13,0.00121930}, {14,0.00147368}, {15,0.00125439}, {16,0.00125439}, {17,0.00155263}, {18,0.00183333}, {19,0.00164035}, {20,0.00190351}, {21,0.00185965}, {22,0.00188596}, {23,0.00202632}, {24,0.00212281}, {25,0.00213158}, {26,0.00231579}, {27,0.00239474}, {28,0.00233333}, {29,0.00252632}, {30,0.00262281}, {31,0.00268421}, {32,0.00278070}, {33,0.00307895}, {34,0.00279825}, {35,0.00325439}, {36,0.00314035}, {37,0.00314035}, {38,0.00335088}, {39,0.00342105}, {40,0.00356140}, {41,0.00348246}, {42,0.00493860}, {43,0.00373684}, {44,0.00389474}, {45,0.00413158}, {46,0.00409649}, {47,0.00457018}, {48,0.00413158}, {49,0.00438596}, {50,0.00466667}, {51,0.00467544}, {52,0.00449123}, {53,0.00505263}, {54,0.00509649}, {55,0.00526316}, {56,0.00449123}, {57,0.00500877}, {58,0.00614912}, {59,0.00552632}, {60,0.00549123}, {61,0.00578947}, {62,0.00571053}, {63,0.00607018}, {64,0.00579825}, {65,0.00605263}, {66,0.00613158}, {67,0.00599123}, {68,0.00628070}, {69,0.00638596}, {70,0.00799123}, {71,0.00650000}, {72,0.00657895}, {73,0.00671930}, {74,0.00697368}, {75,0.00720175}, {76,0.00699123}, {77,0.00750000}, {78,0.00758772}, {79,0.00783333}, {80,0.00733333}, {81,0.00750877}, {82,0.00762281}, {83,0.00779825}, {84,0.00771930}, {85,0.00813158}, {86,0.00823684}, {87,0.00863158}, {88,0.00838596}, {89,0.00879825}, {90,0.01015789}, {91,0.00935965}, {92,0.00902632}, {93,0.00948246}, {94,0.00975439}, {95,0.00976316}, {96,0.00851754}, {97,0.00935088}, {98,0.01168421}, {99,0.00983333}, {100,0.00980702}, {101,0.01071053}, {102,0.01038596}, {103,0.01106140}, {104,0.01009649}, {105,0.01065789}, {106,0.01193860}, {107,0.01112281}, {108,0.01077193}, {109,0.01136842}, {110,0.01167544}, {111,0.01189474}, {112,0.01096491}, {113,0.01151754}, {114,0.01114035}, {115,0.01201754}, {116,0.01116667}, {117,0.01213158}, {118,0.01206140}, {119,0.01269298}, {120,0.01368421}, {121,0.01233333}, {122,0.01252632}, {123,0.01290351}, {124,0.01279825}, {125,0.01305263}, {126,0.01314912}, {127,0.01474561}, {128,0.01216667}, {129,0.01293860}, {130,0.01293860}, {131,0.01378070}, {132,0.01373684}, {133,0.01530702}, {134,0.01371053}, {135,0.01414912}, {136,0.01371930}, {137,0.01408772}, {138,0.01402632}, {139,0.01556140}, {140,0.01434211}, {141,0.01479825}, {142,0.01513158}, {143,0.01529825}, {144,0.01653509}, {145,0.01471930}, {146,0.01471053}, {147,0.01530702}, {148,0.01512281}, {149,0.01569298}, {150,0.01651754}, {151,0.01631579}, {152,0.01557895}, {153,0.01600000}, {154,0.01621930}, {155,0.01837719}, {156,0.01613158}, {157,0.01671930}, {158,0.01684211}, {159,0.01745614}, {160,0.01698246}, {161,0.01625439}, {162,0.01631579}, {163,0.01685088}, {164,0.01651754}, {165,0.01865789}, {166,0.01691228}, {167,0.01766667}, {168,0.01691228}, {169,0.01727193}, {170,0.01838596}, {171,0.01803509}, {172,0.01793860}, {173,0.01846491}, {174,0.02157018}, {175,0.01886842}, {176,0.01744737}, {177,0.01835965}, {178,0.01815789}, {179,0.01986842}, {180,0.01845614}, {181,0.01904386}, {182,0.01931579}, {183,0.02273684}, {184,0.01846491}, {185,0.01917544}, {186,0.01959649}, {187,0.02345614}, {188,0.01928070}, {189,0.02021930}, {190,0.02050000}, {191,0.02413158}, {192,0.01842105}, {193,0.01918421}, {194,0.01935965}, {195,0.02300877}, {196,0.01960526}, {197,0.02064035}, {198,0.02103509}, {199,0.02418421}, {200,0.01964035}, {201,0.02093860}, {202,0.02090351}, {203,0.02483333}, {204,0.02065789}, {205,0.02167544}, {206,0.02181579}, {207,0.02513158}, {208,0.02115789}, {209,0.02234211}, {210,0.02159649}, {211,0.02476316}, {212,0.02166667}, {213,0.02342982}, {214,0.02340351}, {215,0.02552632}, {216,0.02252632}, {217,0.02392982}, {218,0.02717544}, {219,0.02385965}, {220,0.02381579}, {221,0.02459649}, {222,0.02578070}, {223,0.02602632}, {224,0.02273684}, {225,0.02661404}, {226,0.02350000}, {227,0.02494737}, {228,0.02385965}, {229,0.02608772}, {230,0.02514912}, {231,0.02586842}, {232,0.02716667}, {233,0.02521930}, {234,0.02515789}, {235,0.02603509}, {236,0.02501754}, {237,0.02609649}, {238,0.02651754}, {239,0.02794737}, {240,0.02520175}, {241,0.02621930}, {242,0.02913158}, {243,0.02705263}, {244,0.02607895}, {245,0.03036842}, {246,0.02691228}, {247,0.02825439}, {248,0.02898246}, {249,0.02744737}, {250,0.02738596}, {251,0.03156140}, {252,0.02712281}, {253,0.02890351}, {254,0.03148246}, {255,0.02949123}, {256,0.02613158}, {257,0.02982456}, {258,0.02656140}, {259,0.02844737}, {260,0.02721053}, {261,0.02807018}, {262,0.02800000}, {263,0.03216667}, {264,0.02719298}, {265,0.02890351}, {266,0.02877193}, {267,0.02977193}, {268,0.02831579}, {269,0.03216667}, {270,0.03000000}, {271,0.03035088}, {272,0.03067544}, {273,0.02884211}, {274,0.02933333}, {275,0.03269298}, {276,0.02923684}, {277,0.03055263}, {278,0.03304386}, {279,0.03150000}, {280,0.02941228}, {281,0.03225439}, {282,0.03086842}, {283,0.03744737}, {284,0.03034211}, {285,0.03215789}, {286,0.03460526}, {287,0.03317544}, {288,0.02953509}, {289,0.03245614}, {290,0.03091228}, {291,0.03220175}, {292,0.03024561}, {293,0.03248246}, {294,0.03531579}, {295,0.03301754}, {296,0.03140351}, {297,0.03462281}, {298,0.03319298}, {299,0.03884211}, {300,0.03185088}, {301,0.03371053}, {302,0.03672807}, {303,0.03620175}, {304,0.03658772}, {305,0.03294737}, {306,0.03355263}, {307,0.03702632}, {308,0.03386842}, {309,0.03972807}, {310,0.03458772}, {311,0.03628947}, {312,0.03612281}, {313,0.03563158}, {314,0.03985088}, {315,0.03658772}, {316,0.03600000}, {317,0.03811404}, {318,0.03721053}, {319,0.04217544}, {320,0.03261404}, {321,0.03485965}, {322,0.03454386}, {323,0.03573684}, {324,0.03673684}, {325,0.03603509}, {326,0.04026316}, {327,0.03698246}, {328,0.03500000}, {329,0.03801754}, {330,0.03663158}, {331,0.04182456}, {332,0.03632456}, {333,0.04200000}, {334,0.03770175}, {335,0.03922807}, {336,0.03648246}, {337,0.03707018}, {338,0.04136842}, {339,0.03857895}, {340,0.04086842}, {341,0.03816667}, {342,0.03864912}, {343,0.03954386}, {344,0.03732456}, {345,0.03987719}, {346,0.03920175}, {347,0.04442982}, {348,0.03984211}, {349,0.04433333}, {350,0.04003509}, {351,0.04542982}, {352,0.03735965}, {353,0.04249123}, {354,0.03805263}, {355,0.03992982}, {356,0.03971053}, {357,0.04041228}, {358,0.04154386}, {359,0.04196491}, {360,0.04270175}, {361,0.04059649}, {362,0.04475439}, {363,0.04174561}, {364,0.04430702}, {365,0.04257895}, {366,0.04640351}, {367,0.04300877}, {368,0.04264912}, {369,0.04145614}, {370,0.04505263}, {371,0.04237719}, {372,0.04461404}, {373,0.04288596}, {374,0.04643860}, {375,0.04373684}, {376,0.04574561}, {377,0.04264912}, {378,0.04721053}, {379,0.04464035}, {380,0.04704386}, {381,0.04468421}, {382,0.04862281}, {383,0.04713158}, {384,0.04211404}, {385,0.04103509}, {386,0.04460526}, {387,0.04332456}, {388,0.04500877}, {389,0.04239474}, {390,0.04625439}, {391,0.04479825}, {392,0.04474561}, {393,0.04335965}, {394,0.04818421}, {395,0.04480702}, {396,0.04649123}, {397,0.04538596}, {398,0.04859649}, {399,0.04740351}, {400,0.04564912}, {401,0.04355263}, {402,0.04821930}, {403,0.04600877}, {404,0.04821930}, {405,0.04643860}, {406,0.04997368}, {407,0.05516667}, {408,0.04399123}, {409,0.05024561}, {410,0.04650877}, {411,0.05111404}, {412,0.04670175}, {413,0.05143860}, {414,0.04865789}, {415,0.05283333}, {416,0.04412281}, {417,0.04895614}, {418,0.05068421}, {419,0.04734211}, {420,0.05076316}, {421,0.04760526}, {422,0.05178947}, {423,0.05007895}, {424,0.04964912}, {425,0.04901754}, {426,0.05092105}, {427,0.05731579}, {428,0.04806140}, {429,0.05285088}, {430,0.05015789}, {431,0.05554386}, {432,0.04709649}, {433,0.05201754}, {434,0.05685965}, {435,0.05038596}, {436,0.05213158}, {437,0.05108772}, {438,0.05325439}, {439,0.05230702}, {440,0.04961404}, {441,0.05518421}, {442,0.05111404}, {443,0.05607018}, {444,0.05154386}, {445,0.05664912}, {446,0.06158772}, {447,0.05529825}, {448,0.05080702}, {449,0.04927193}, {450,0.05207018}, {451,0.05866667}, {452,0.04923684}, {453,0.05426316}, {454,0.05228070}, {455,0.05579825}, {456,0.05690351}, {457,0.05121053}, {458,0.05560526}, {459,0.05318421}, {460,0.05471053}, {461,0.06114035}, {462,0.05339474}, {463,0.05887719}, {464,0.05111404}, {465,0.05541228}, {466,0.05998246}, {467,0.05377193}, {468,0.05500000}, {469,0.06158772}, {470,0.05398246}, {471,0.05950877}, {472,0.05318421}, {473,0.05723684}, {474,0.06305263}, {475,0.05673684}, {476,0.05773684}, {477,0.06413158}, {478,0.05663158}, {479,0.06186842}, {480,0.05935088}, {481,0.05387719}, {482,0.05660526}, {483,0.05675439}, {484,0.05397368}, {485,0.05939474}, {486,0.05654386}, {487,0.06061404}, {488,0.06183333}, {489,0.05609649}, {490,0.05835088}, {491,0.06612281}, {492,0.05706140}, {493,0.06095614}, {494,0.06542982}, {495,0.06112281}, {496,0.05659649}, {497,0.06500000}, {498,0.05705263}, {499,0.06192105}, {500,0.06528070}, {505,0.05991228}, {510,0.06250000}, {515,0.06129825}, {520,0.05751754}, {525,0.06127193}, {530,0.06216667}, {535,0.07227193}, {540,0.06275439}, {545,0.06342982}, {550,0.07108772}, {555,0.07392105}, {560,0.06264912}, {565,0.06990351}, {570,0.07460526}, {575,0.07923684}, {580,0.06443860}, {585,0.06948246}, {590,0.07746491}, {595,0.07730702}, {600,0.07528070}, {605,0.07417544}, {610,0.07111404}, {615,0.08213158}, {620,0.07931579}, {625,0.08007895}, {630,0.08262281}, {635,0.08619298}, {640,0.06890351}, {645,0.07565789}, {650,0.08150877}, {655,0.08781579}, {660,0.08230702}, {665,0.08621930}, {670,0.08915789}, {675,0.08750877}, {680,0.07769298}, {685,0.08384211}, {690,0.08244737}, {695,0.09442105}, {700,0.09463158}, {705,0.08925439}, {710,0.09138596}, {715,0.09514912}, {720,0.08963158}, {725,0.09640351}, {730,0.09678070}, {735,0.10322807}, {740,0.09479825}, {745,0.09759649}, {750,0.10032456}, {755,0.10121053}, {760,0.09818421}, {765,0.10446491}, {770,0.09191228}, {775,0.09952632}, {780,0.09626316}, {785,0.09730702}, {790,0.10060526}, {795,0.10400877}, {800,0.09626316}, {805,0.10199123}, {810,0.10302632}, {815,0.11057018}, {820,0.10464035}, {825,0.10882456}, {830,0.11155263}, {835,0.10584211}, {840,0.10257895}, {845,0.11022807}, {850,0.10770175}, {855,0.11455263}, {860,0.11225439}, {865,0.10870175}, {870,0.11341228}, {875,0.11714035}, {880,0.11065789}, {885,0.11818421}, {890,0.11775439}, {895,0.12780702}, {900,0.11530702}, {905,0.11446491}, {910,0.11753509}, {915,0.11855263}, {920,0.12147368}, {925,0.12213158}, {930,0.11565789}, {935,0.12500000}, {940,0.12120175}, {945,0.12141228}, {950,0.12675439}, {955,0.13011404}, {960,0.11567544}, {965,0.12432456}, {970,0.13133333}, {975,0.13258772}, {980,0.14939474}, {985,0.13035088}, {990,0.13335088}, {995,0.13781579}, {1000,0.12778070}, {1010,0.13982456}, {1020,0.13727193}, {1030,0.12871930}, {1040,0.12560526}, {1050,0.13450000}, {1060,0.13856140}, {1070,0.13977193}, {1080,0.14325439}, {1090,0.13398246}, {1100,0.14554386}, {1110,0.14509649}, {1120,0.14585088}, {1130,0.14736842}, {1140,0.15517544}, {1150,0.15875439}, {1160,0.14309649}, {1170,0.15519298}, {1180,0.15450877}, {1190,0.16251754}, {1200,0.15835088}, {1210,0.16191228}, {1220,0.16089474}, {1230,0.17059649}, {1240,0.16078070}, {1250,0.16135088}, {1260,0.17442982}, {1270,0.17884211}, {1280,0.17147368}, {1290,0.24398246}, {1300,0.17106140}, {1310,0.18243860}, {1320,0.17265789}, {1330,0.86535088}, {1340,0.18710526}, {1350,0.17651754}, {1360,0.17228070}, {1370,0.19237719}, {1380,0.18541228}, {1390,0.19550000}, {1400,0.19127193}, {1410,0.18232456}, {1420,0.18842105}, {1430,0.19637719}, {1440,0.18549123}, {1450,0.19755263}, {1460,0.19847368}, {1470,0.21162281}, {1480,0.19678070}, {1490,0.20406140}, {1500,0.20780702}, {1510,0.20968421}, {1520,0.20376316}, {1530,0.22656140}, {1540,0.19672807}, {1550,0.20750877}, {1560,0.20180702}, {1570,0.20347368}, {1580,0.21144737}, {1590,0.22571053}, {1600,0.20274561}, {1610,0.21283333}, {1620,0.21396491}, {1630,0.23517544}, {1640,0.21600000}, {1650,0.22527193}, {1660,0.23895614}, {1670,0.22162281}, {1680,0.21647368}, {1690,0.23028070}, {1700,0.22190351}, {1710,0.24547368}, {1720,0.23131579}, {1730,0.23343860}, {1740,0.23600000}, {1750,0.24894737}, {1760,0.23103509}, {1770,0.25089474}, {1780,0.24913158}, {1790,0.27235965}, {1800,0.23243860}, {1810,0.23785965}, {1820,0.25238596}, {1830,0.24683333}, {1840,0.24650000}, {1850,0.26542982}, {1860,0.24272807}, {1870,0.26652632}, {1880,0.26077193}, {1890,0.25578947}, {1900,0.26615789}, {1910,0.27363158}, {1920,0.24118421}, {1930,0.25827193}, {1940,0.26305263}, {1950,0.28114912}, {1960,0.26640351}, {1970,0.27532456}, {1980,0.28260526}, {1990,0.27054386}, {2000,0.26420175}, {2050,0.25944737}, {2100,0.28515789}, {2150,0.29900000}, {2200,0.29898246}, {2250,0.31278070}, {2300,0.33614912}, {2350,0.34018421}, {2400,0.31998246}, {2450,0.34400000}, {2500,0.34216667}, {2550,0.38371053}, {2600,0.35478947}, {2650,0.37959649}, {2700,0.37273684}, {2750,0.41460526}, {2800,0.39934211}, {2850,0.39597368}, {2900,0.40540351}, {2950,0.41655263}, {3000,0.43330702}, {3050,0.44851754}, {3100,0.43873684}, {3150,0.45147368}, {3200,0.41866667}, {3250,0.46819298}, {3300,0.46750000}, {3350,0.47235088}, {3400,0.46471930}, {3450,0.52083333}, {3500,0.51061404}, {3550,0.54976316}, {3600,0.48550877}, {3650,0.50481579}, {3700,0.54289474}, {3750,0.54389474}, {3800,0.55442105}, {3850,0.54742105}, {3900,0.58594737}, {3950,0.61534211}, {4000,0.62186842}, {4050,0.59992982}, {4100,0.55600000}, {4150,0.60943860}, {4200,0.59846491}, {4250,0.63700877}, {4300,0.63111404}, {4350,0.70124561}, {4400,0.62631579}, {4450,0.64437719}, {4500,0.65564912}, {4550,0.67934211}, {4600,0.71218421}, {4650,0.68149123}, {4700,0.70839474}, {4750,0.71480702}, {4800,0.67872807}, {4850,0.76041228}, {4900,0.71374561}, {4950,0.76886842}, {5000,0.72635965}, {5050,0.80744737}, {5100,0.81566667}, {5150,0.77507895}, {5200,0.74429825}, {5250,0.74532456}, {5300,0.79316667}, {5350,0.83678070}, {5400,0.78907018}, {5450,0.81960526}, {5500,0.87847368}, {5550,0.88613158}, {5600,0.84267544}, {5650,0.82503509}, {5700,0.85010526}, {5750,0.92373684}, {5800,0.86891228}, {5850,0.94814035}, {5900,0.88102632}, {5950,0.97442105}, {6000,0.91810526}, {6050,0.956929}, {6100,0.973429}, {6150,0.899429}, {6200,0.928500}, {6250,0.969071}, {6300,0.979500}, {6350,1.022000}, {6400,0.894714}, {6450,0.999857}, {6500,1.007786}, {6550,1.047929}, {6600,1.022714}, {6650,1.124071}, {6700,1.037500}, {6750,1.106500}, {6800,1.010143}, {6850,1.050286}, {6900,1.126571}, {6950,1.101143}, {7000,1.107429}, {7050,1.113357}, {7100,1.199357}, {7150,1.234571}, {7200,1.041571}, {7250,1.111714}, {7300,1.071214}, {7350,1.207714}, {7400,1.173286}, {7450,1.175786}, {7500,1.174929}, {7550,1.317214}, {7600,1.206714}, {7650,1.228643}, {7700,1.188357}, {7750,1.213857}, {7800,1.263571}, {7850,1.266000}, {7900,1.318571}, {7950,1.280643}, {8000,1.198643}, {8050,1.335286}, {8100,1.295071}, {8150,1.416571}, {8200,1.165286}, {8250,1.313071}, {8300,1.623571}, {8350,1.369429}, {8400,1.295357}, {8450,1.246500}, {8500,1.344643}, {8550,1.399786}, {8600,1.390929}, {8650,1.410500}, {8700,1.517357}, {8750,1.443857}, {8800,1.370786}, {8850,1.389357}, {8900,1.411357}, {8950,1.569000}, {9000,1.416286}, {9050,1.520143}, {9100,1.485500}, {9150,1.648786}, {9200,1.547214}, {9250,1.409571}, {9300,1.471286}, {9350,1.461000}, {9400,1.526357}, {9450,1.594714}, {9500,1.546929}, {9550,1.601500}, {9600,1.455786}, {9650,1.619786}, {9700,1.628857}, {9750,1.586214}, {9800,1.543214}, {9850,1.705643}, {9900,1.641857}, {9950,1.757929}, {10000,1.560643}, {10100,1.709643}, {10200,1.748643}, {10300,1.699357}, {10400,1.580071}, {10500,1.577714}, {10600,1.721071}, {10700,1.810929}, {10800,1.695214}, {10900,1.756429}, {11000,1.923071}, {11100,1.896929}, {11200,1.787357}, {11300,1.760786}, {11400,1.781000}, {11500,1.997857}, {11600,1.875786}, {11700,2.015500}, {11800,1.908500}, {11900,2.138929}, {12000,1.979857}, {12100,2.006786}, {12200,2.079500}, {12300,1.895071}, {12400,1.974571}, {12500,2.063143}, {12600,2.094929}, {12700,2.167643}, {12800,1.885643}, {12900,2.119000}, {13000,2.135571}, {13100,2.213714}, {13200,2.137857}, {13300,2.439857}, {13400,2.192643}, {13500,2.376143}, {13600,2.127714}, {13700,2.230643}, {13800,2.419429}, {13900,2.334214}, {14000,2.340071}, {14100,2.367000}, {14200,2.544714}, {14300,2.623357}, {14400,2.180286}, {14500,2.376000}, {14600,2.315929}, {14700,2.568071}, {14800,2.500929}, {14900,2.507357}, {15000,2.547500}, {15100,2.799929}, {15200,2.558857}, {15300,2.628143}, {15400,2.473071}, {15500,2.599500}, {15600,2.716643}, {15700,2.733071}, {15800,2.828643}, {15900,2.732571}, {16000,2.566571}, {16100,2.841929}, {16200,2.764929}, {16300,2.975143}, {16400,2.488643}, {16500,2.838857}, {16600,2.838143}, {16700,2.906571}, {16800,2.756714}, {16900,2.640857}, {17000,2.853214}, {17100,2.983286}, {17200,2.901500}, {17300,2.982500}, {17400,3.219571}, {17500,3.065857}, {17600,2.885071}, {17700,2.940929}, {17800,3.004786}, {17900,3.329714}, {18000,3.017500}, {18100,3.243500}, {18200,3.167643}, {18300,3.494643}, {18400,3.262929}, {18500,3.010143}, {18600,3.097071}, {18700,3.087929}, {18800,3.222143}, {18900,3.357500}, {19000,3.278214}, {19100,3.409286}, {19200,3.099500}, {19300,3.421857}, {19400,3.427929}, {19500,3.386929}, {19600,3.258500}, {19700,3.660286}, {19800,3.524786}, {19900,3.745214}, {20000,3.317929}};
data["big_flat"]["TypeClassesBodyHOAS"]["reif"]["system"] = {{1,0.00000000}, {2,0.00007018}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00003509}, {8,0.00003509}, {9,0.00000000}, {10,0.00000000}, {11,0.00002632}, {12,0.00000000}, {13,0.00000000}, {14,0.00003509}, {15,0.00007018}, {16,0.00003509}, {17,0.00002632}, {18,0.00003509}, {19,0.00003509}, {20,0.00003509}, {21,0.00003509}, {22,0.00002632}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00003509}, {28,0.00003509}, {29,0.00003509}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00007018}, {35,0.00000000}, {36,0.00003509}, {37,0.00007018}, {38,0.00003509}, {39,0.00003509}, {40,0.00010526}, {41,0.00003509}, {42,0.00003509}, {43,0.00007018}, {44,0.00003509}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00007018}, {49,0.00003509}, {50,0.00002632}, {51,0.00000000}, {52,0.00003509}, {53,0.00002632}, {54,0.00003509}, {55,0.00003509}, {56,0.00010526}, {57,0.00010526}, {58,0.00003509}, {59,0.00003509}, {60,0.00007018}, {61,0.00003509}, {62,0.00003509}, {63,0.00006140}, {64,0.00002632}, {65,0.00003509}, {66,0.00000000}, {67,0.00000000}, {68,0.00010526}, {69,0.00003509}, {70,0.00000000}, {71,0.00010526}, {72,0.00007018}, {73,0.00003509}, {74,0.00000000}, {75,0.00010526}, {76,0.00003509}, {77,0.00009649}, {78,0.00003509}, {79,0.00000000}, {80,0.00000000}, {81,0.00003509}, {82,0.00000000}, {83,0.00010526}, {84,0.00006140}, {85,0.00003509}, {86,0.00003509}, {87,0.00000000}, {88,0.00000000}, {89,0.00003509}, {90,0.00000000}, {91,0.00000000}, {92,0.00007018}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00007018}, {97,0.00007018}, {98,0.00007018}, {99,0.00000000}, {100,0.00002632}, {101,0.00000000}, {102,0.00003509}, {103,0.00000000}, {104,0.00007018}, {105,0.00003509}, {106,0.00003509}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00007018}, {117,0.00000000}, {118,0.00006140}, {119,0.00000000}, {120,0.00009649}, {121,0.00003509}, {122,0.00000000}, {123,0.00007018}, {124,0.00003509}, {125,0.00003509}, {126,0.00000000}, {127,0.00003509}, {128,0.00007018}, {129,0.00003509}, {130,0.00000000}, {131,0.00003509}, {132,0.00000000}, {133,0.00003509}, {134,0.00003509}, {135,0.00000000}, {136,0.00007018}, {137,0.00003509}, {138,0.00000000}, {139,0.00003509}, {140,0.00003509}, {141,0.00006140}, {142,0.00000000}, {143,0.00000000}, {144,0.00003509}, {145,0.00003509}, {146,0.00000000}, {147,0.00000000}, {148,0.00003509}, {149,0.00003509}, {150,0.00003509}, {151,0.00006140}, {152,0.00003509}, {153,0.00000000}, {154,0.00003509}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00003509}, {159,0.00013158}, {160,0.00000000}, {161,0.00007018}, {162,0.00007018}, {163,0.00003509}, {164,0.00000000}, {165,0.00003509}, {166,0.00007018}, {167,0.00007018}, {168,0.00007018}, {169,0.00007018}, {170,0.00000000}, {171,0.00007018}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00003509}, {177,0.00003509}, {178,0.00010526}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00010526}, {185,0.00000000}, {186,0.00003509}, {187,0.00000000}, {188,0.00000000}, {189,0.00003509}, {190,0.00003509}, {191,0.00007018}, {192,0.00003509}, {193,0.00003509}, {194,0.00000000}, {195,0.00007018}, {196,0.00003509}, {197,0.00003509}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00003509}, {203,0.00003509}, {204,0.00003509}, {205,0.00000000}, {206,0.00000000}, {207,0.00007018}, {208,0.00003509}, {209,0.00000000}, {210,0.00003509}, {211,0.00000000}, {212,0.00000000}, {213,0.00003509}, {214,0.00000000}, {215,0.00003509}, {216,0.00000000}, {217,0.00000000}, {218,0.00007018}, {219,0.00010526}, {220,0.00007018}, {221,0.00002632}, {222,0.00002632}, {223,0.00003509}, {224,0.00007018}, {225,0.00000000}, {226,0.00000000}, {227,0.00003509}, {228,0.00000000}, {229,0.00000000}, {230,0.00007018}, {231,0.00003509}, {232,0.00000000}, {233,0.00007018}, {234,0.00000000}, {235,0.00000000}, {236,0.00003509}, {237,0.00000000}, {238,0.00003509}, {239,0.00007018}, {240,0.00007018}, {241,0.00000000}, {242,0.00003509}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00003509}, {247,0.00007018}, {248,0.00000000}, {249,0.00003509}, {250,0.00006140}, {251,0.00000000}, {252,0.00003509}, {253,0.00003509}, {254,0.00006140}, {255,0.00000000}, {256,0.00000000}, {257,0.00003509}, {258,0.00000000}, {259,0.00003509}, {260,0.00003509}, {261,0.00003509}, {262,0.00002632}, {263,0.00003509}, {264,0.00000000}, {265,0.00003509}, {266,0.00003509}, {267,0.00007018}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00002632}, {272,0.00003509}, {273,0.00003509}, {274,0.00000000}, {275,0.00003509}, {276,0.00007018}, {277,0.00003509}, {278,0.00000000}, {279,0.00000000}, {280,0.00013158}, {281,0.00003509}, {282,0.00000000}, {283,0.00000000}, {284,0.00003509}, {285,0.00003509}, {286,0.00000000}, {287,0.00007018}, {288,0.00000000}, {289,0.00000000}, {290,0.00003509}, {291,0.00000000}, {292,0.00000000}, {293,0.00009649}, {294,0.00003509}, {295,0.00003509}, {296,0.00003509}, {297,0.00003509}, {298,0.00000000}, {299,0.00010526}, {300,0.00003509}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00003509}, {305,0.00000000}, {306,0.00003509}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00009649}, {311,0.00000000}, {312,0.00000000}, {313,0.00003509}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00003509}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00003509}, {325,0.00007018}, {326,0.00000000}, {327,0.00000000}, {328,0.00003509}, {329,0.00000000}, {330,0.00003509}, {331,0.00000000}, {332,0.00000000}, {333,0.00010526}, {334,0.00000000}, {335,0.00003509}, {336,0.00003509}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00003509}, {345,0.00003509}, {346,0.00000000}, {347,0.00007018}, {348,0.00007018}, {349,0.00003509}, {350,0.00007018}, {351,0.00003509}, {352,0.00003509}, {353,0.00000000}, {354,0.00003509}, {355,0.00003509}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00003509}, {364,0.00003509}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00010526}, {369,0.00003509}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00003509}, {375,0.00000000}, {376,0.00003509}, {377,0.00007018}, {378,0.00003509}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00003509}, {383,0.00006140}, {384,0.00000000}, {385,0.00003509}, {386,0.00000000}, {387,0.00003509}, {388,0.00007018}, {389,0.00000000}, {390,0.00003509}, {391,0.00000000}, {392,0.00014035}, {393,0.00002632}, {394,0.00007018}, {395,0.00003509}, {396,0.00007018}, {397,0.00003509}, {398,0.00007018}, {399,0.00003509}, {400,0.00003509}, {401,0.00010526}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00003509}, {408,0.00007018}, {409,0.00007018}, {410,0.00000000}, {411,0.00003509}, {412,0.00002632}, {413,0.00010526}, {414,0.00002632}, {415,0.00000000}, {416,0.00003509}, {417,0.00000000}, {418,0.00003509}, {419,0.00000000}, {420,0.00007018}, {421,0.00000000}, {422,0.00014035}, {423,0.00003509}, {424,0.00007018}, {425,0.00000000}, {426,0.00007018}, {427,0.00021053}, {428,0.00003509}, {429,0.00014035}, {430,0.00000000}, {431,0.00009649}, {432,0.00007018}, {433,0.00007018}, {434,0.00010526}, {435,0.00000000}, {436,0.00010526}, {437,0.00000000}, {438,0.00024561}, {439,0.00003509}, {440,0.00002632}, {441,0.00020175}, {442,0.00000000}, {443,0.00016667}, {444,0.00000000}, {445,0.00014035}, {446,0.00021053}, {447,0.00003509}, {448,0.00017544}, {449,0.00003509}, {450,0.00010526}, {451,0.00056140}, {452,0.00000000}, {453,0.00014035}, {454,0.00000000}, {455,0.00014035}, {456,0.00040351}, {457,0.00007018}, {458,0.00017544}, {459,0.00003509}, {460,0.00014035}, {461,0.00047368}, {462,0.00000000}, {463,0.00016667}, {464,0.00007018}, {465,0.00024561}, {466,0.00037719}, {467,0.00000000}, {468,0.00017544}, {469,0.00031579}, {470,0.00003509}, {471,0.00021053}, {472,0.00003509}, {473,0.00014035}, {474,0.00035088}, {475,0.00000000}, {476,0.00003509}, {477,0.00037719}, {478,0.00003509}, {479,0.00028070}, {480,0.00038596}, {481,0.00000000}, {482,0.00030702}, {483,0.00000000}, {484,0.00000000}, {485,0.00034211}, {486,0.00003509}, {487,0.00010526}, {488,0.00037719}, {489,0.00003509}, {490,0.00017544}, {491,0.00049123}, {492,0.00003509}, {493,0.00014035}, {494,0.00044737}, {495,0.00000000}, {496,0.00017544}, {497,0.00041228}, {498,0.00002632}, {499,0.00007018}, {500,0.00037719}, {505,0.00000000}, {510,0.00000000}, {515,0.00007018}, {520,0.00010526}, {525,0.00003509}, {530,0.00014035}, {535,0.00045614}, {540,0.00000000}, {545,0.00010526}, {550,0.00051754}, {555,0.00049123}, {560,0.00000000}, {565,0.00010526}, {570,0.00038596}, {575,0.00031579}, {580,0.00000000}, {585,0.00021053}, {590,0.00038596}, {595,0.00052632}, {600,0.00041228}, {605,0.00000000}, {610,0.00017544}, {615,0.00031579}, {620,0.00034211}, {625,0.00007018}, {630,0.00014035}, {635,0.00014035}, {640,0.00003509}, {645,0.00014035}, {650,0.00010526}, {655,0.00026316}, {660,0.00024561}, {665,0.00023684}, {670,0.00063158}, {675,0.00036842}, {680,0.00000000}, {685,0.00003509}, {690,0.00002632}, {695,0.00059649}, {700,0.00037719}, {705,0.00066667}, {710,0.00041228}, {715,0.00042105}, {720,0.00050000}, {725,0.00035088}, {730,0.00061404}, {735,0.00052632}, {740,0.00050877}, {745,0.00062281}, {750,0.00063158}, {755,0.00056140}, {760,0.00058772}, {765,0.00078947}, {770,0.00065789}, {775,0.00078070}, {780,0.00069298}, {785,0.00080702}, {790,0.00059649}, {795,0.00080702}, {800,0.00062281}, {805,0.00072807}, {810,0.00058772}, {815,0.00091228}, {820,0.00061404}, {825,0.00069298}, {830,0.00084211}, {835,0.00066667}, {840,0.00080702}, {845,0.00061404}, {850,0.00065789}, {855,0.00076316}, {860,0.00076316}, {865,0.00070175}, {870,0.00061404}, {875,0.00065789}, {880,0.00062281}, {885,0.00065789}, {890,0.00078947}, {895,0.00044737}, {900,0.00108772}, {905,0.00052632}, {910,0.00044737}, {915,0.00058772}, {920,0.00083333}, {925,0.00066667}, {930,0.00037719}, {935,0.00048246}, {940,0.00072807}, {945,0.00056140}, {950,0.00051754}, {955,0.00059649}, {960,0.00048246}, {965,0.00048246}, {970,0.00087719}, {975,0.00063158}, {980,0.00048246}, {985,0.00059649}, {990,0.00052632}, {995,0.00100877}, {1000,0.00028070}, {1010,0.00072807}, {1020,0.00059649}, {1030,0.00052632}, {1040,0.00048246}, {1050,0.00054386}, {1060,0.00091228}, {1070,0.00051754}, {1080,0.00059649}, {1090,0.00063158}, {1100,0.00097368}, {1110,0.00042105}, {1120,0.00083333}, {1130,0.00056140}, {1140,0.00072807}, {1150,0.00049123}, {1160,0.00055263}, {1170,0.00063158}, {1180,0.00014035}, {1190,0.00006140}, {1200,0.00007018}, {1210,0.00003509}, {1220,0.00007018}, {1230,0.00003509}, {1240,0.00003509}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00003509}, {1280,0.00007018}, {1290,0.00007018}, {1300,0.00003509}, {1310,0.00007018}, {1320,0.00000000}, {1330,0.00091228}, {1340,0.00000000}, {1350,0.00007018}, {1360,0.00007018}, {1370,0.00003509}, {1380,0.00003509}, {1390,0.00007018}, {1400,0.00003509}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00007018}, {1440,0.00003509}, {1450,0.00014035}, {1460,0.00010526}, {1470,0.00014035}, {1480,0.00007018}, {1490,0.00010526}, {1500,0.00003509}, {1510,0.00006140}, {1520,0.00007018}, {1530,0.00003509}, {1540,0.00003509}, {1550,0.00003509}, {1560,0.00003509}, {1570,0.00000000}, {1580,0.00021053}, {1590,0.00003509}, {1600,0.00003509}, {1610,0.00000000}, {1620,0.00017544}, {1630,0.00003509}, {1640,0.00003509}, {1650,0.00010526}, {1660,0.00007018}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00003509}, {1700,0.00010526}, {1710,0.00003509}, {1720,0.00003509}, {1730,0.00000000}, {1740,0.00003509}, {1750,0.00010526}, {1760,0.00007018}, {1770,0.00003509}, {1780,0.00003509}, {1790,0.00010526}, {1800,0.00009649}, {1810,0.00000000}, {1820,0.00020175}, {1830,0.00000000}, {1840,0.00017544}, {1850,0.00003509}, {1860,0.00010526}, {1870,0.00000000}, {1880,0.00017544}, {1890,0.00007018}, {1900,0.00010526}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00007018}, {1960,0.00010526}, {1970,0.00003509}, {1980,0.00000000}, {1990,0.00003509}, {2000,0.00002632}, {2050,0.00000000}, {2100,0.00041228}, {2150,0.00071053}, {2200,0.00042105}, {2250,0.00028070}, {2300,0.00035088}, {2350,0.00051754}, {2400,0.00035088}, {2450,0.00055263}, {2500,0.00028070}, {2550,0.00045614}, {2600,0.00038596}, {2650,0.00034211}, {2700,0.00028070}, {2750,0.00021053}, {2800,0.00014035}, {2850,0.00009649}, {2900,0.00017544}, {2950,0.00017544}, {3000,0.00017544}, {3050,0.00007018}, {3100,0.00003509}, {3150,0.00021053}, {3200,0.00034211}, {3250,0.00009649}, {3300,0.00007018}, {3350,0.00020175}, {3400,0.00031579}, {3450,0.00055263}, {3500,0.00062281}, {3550,0.00065789}, {3600,0.00017544}, {3650,0.00064912}, {3700,0.00049123}, {3750,0.00044737}, {3800,0.00014035}, {3850,0.00006140}, {3900,0.00007018}, {3950,0.00010526}, {4000,0.00017544}, {4050,0.00007018}, {4100,0.00016667}, {4150,0.00034211}, {4200,0.00017544}, {4250,0.00028070}, {4300,0.00014035}, {4350,0.00028070}, {4400,0.00041228}, {4450,0.00028070}, {4500,0.00042105}, {4550,0.00014035}, {4600,0.00007018}, {4650,0.00013158}, {4700,0.00016667}, {4750,0.00003509}, {4800,0.00017544}, {4850,0.00007018}, {4900,0.00010526}, {4950,0.00023684}, {5000,0.00010526}, {5050,0.00010526}, {5100,0.00010526}, {5150,0.00003509}, {5200,0.00021053}, {5250,0.00016667}, {5300,0.00010526}, {5350,0.00003509}, {5400,0.00010526}, {5450,0.00014035}, {5500,0.00017544}, {5550,0.00017544}, {5600,0.00010526}, {5650,0.00007018}, {5700,0.00003509}, {5750,0.00017544}, {5800,0.00007018}, {5850,0.00013158}, {5900,0.00021053}, {5950,0.00007018}, {6000,0.00017544}, {6050,0.003071}, {6100,0.005929}, {6150,0.005929}, {6200,0.004214}, {6250,0.006286}, {6300,0.002571}, {6350,0.000000}, {6400,0.000000}, {6450,0.000000}, {6500,0.000000}, {6550,0.000000}, {6600,0.000286}, {6650,0.000000}, {6700,0.000571}, {6750,0.000000}, {6800,0.000000}, {6850,0.000000}, {6900,0.000571}, {6950,0.000857}, {7000,0.000286}, {7050,0.000214}, {7100,0.000286}, {7150,0.001143}, {7200,0.000500}, {7250,0.000286}, {7300,0.001429}, {7350,0.001143}, {7400,0.000857}, {7450,0.000571}, {7500,0.000571}, {7550,0.000857}, {7600,0.000571}, {7650,0.000286}, {7700,0.000571}, {7750,0.000857}, {7800,0.000857}, {7850,0.000571}, {7900,0.000571}, {7950,0.000571}, {8000,0.000286}, {8050,0.000571}, {8100,0.001143}, {8150,0.000857}, {8200,0.000000}, {8250,0.000000}, {8300,0.000286}, {8350,0.000286}, {8400,0.000286}, {8450,0.000286}, {8500,0.000000}, {8550,0.000000}, {8600,0.000786}, {8650,0.000000}, {8700,0.000286}, {8750,0.000286}, {8800,0.000571}, {8850,0.000286}, {8900,0.000286}, {8950,0.000000}, {9000,0.000000}, {9050,0.000000}, {9100,0.000500}, {9150,0.000571}, {9200,0.000000}, {9250,0.000286}, {9300,0.000000}, {9350,0.000571}, {9400,0.000000}, {9450,0.000000}, {9500,0.000000}, {9550,0.000000}, {9600,0.000286}, {9650,0.000286}, {9700,0.000000}, {9750,0.000286}, {9800,0.000571}, {9850,0.000000}, {9900,0.000286}, {9950,0.000000}, {10000,0.000000}, {10100,0.000286}, {10200,0.000000}, {10300,0.000000}, {10400,0.000286}, {10500,0.000000}, {10600,0.000000}, {10700,0.000000}, {10800,0.000000}, {10900,0.000286}, {11000,0.000857}, {11100,0.000000}, {11200,0.000571}, {11300,0.000286}, {11400,0.000000}, {11500,0.000857}, {11600,0.000000}, {11700,0.000000}, {11800,0.000000}, {11900,0.000000}, {12000,0.000000}, {12100,0.000000}, {12200,0.001143}, {12300,0.000286}, {12400,0.000286}, {12500,0.000286}, {12600,0.000000}, {12700,0.000286}, {12800,0.000000}, {12900,0.000000}, {13000,0.000000}, {13100,0.000000}, {13200,0.000286}, {13300,0.000000}, {13400,0.000000}, {13500,0.000000}, {13600,0.000000}, {13700,0.000000}, {13800,0.000286}, {13900,0.000000}, {14000,0.000000}, {14100,0.000286}, {14200,0.000000}, {14300,0.000286}, {14400,0.000000}, {14500,0.000000}, {14600,0.002571}, {14700,0.012571}, {14800,0.011714}, {14900,0.004000}, {15000,0.000000}, {15100,0.000000}, {15200,0.000000}, {15300,0.000571}, {15400,0.000000}, {15500,0.000000}, {15600,0.000000}, {15700,0.000286}, {15800,0.000000}, {15900,0.000000}, {16000,0.000286}, {16100,0.000000}, {16200,0.000000}, {16300,0.000286}, {16400,0.000000}, {16500,0.000571}, {16600,0.000286}, {16700,0.000286}, {16800,0.000000}, {16900,0.002214}, {17000,0.000000}, {17100,0.000000}, {17200,0.000000}, {17300,0.000000}, {17400,0.000000}, {17500,0.000000}, {17600,0.000000}, {17700,0.000000}, {17800,0.000286}, {17900,0.000286}, {18000,0.000000}, {18100,0.000000}, {18200,0.000286}, {18300,0.000286}, {18400,0.000286}, {18500,0.000000}, {18600,0.000571}, {18700,0.000000}, {18800,0.000571}, {18900,0.000000}, {19000,0.000000}, {19100,0.000000}, {19200,0.000000}, {19300,0.000286}, {19400,0.000000}, {19500,0.001143}, {19600,0.000000}, {19700,0.000286}, {19800,0.000286}, {19900,0.000571}, {20000,0.010500}};
data["big_flat"]["beta; Parametricity"]["Aggregate"]["real"] = {{1,0.001004739}, {2,0.001000000}, {3,0.001000000}, {4,0.001000000}, {5,0.001000000}, {6,0.001000000}, {7,0.001004739}, {8,0.001000000}, {9,0.001000000}, {10,0.001000000}, {11,0.001009479}, {12,0.001009479}, {13,0.001000000}, {14,0.001000000}, {15,0.001000000}, {16,0.001000000}, {17,0.001000000}, {18,0.001000000}, {19,0.001000000}, {20,0.001000000}, {21,0.001009479}, {22,0.001000000}, {23,0.001000000}, {24,0.001000000}, {25,0.001000000}, {26,0.001000000}, {27,0.001000000}, {28,0.001000000}, {29,0.001000000}, {30,0.001000000}, {31,0.001000000}, {32,0.001000000}, {33,0.001009479}, {34,0.001018957}, {35,0.001004739}, {36,0.001004739}, {37,0.010924171}, {38,0.001009479}, {39,0.001018957}, {40,0.001028436}, {41,0.001023697}, {42,0.001066351}, {43,0.001085308}, {44,0.001118483}, {45,0.001151659}, {46,0.001279621}, {47,0.001331754}, {48,0.001341232}, {49,0.001450237}, {50,0.001526066}, {51,0.001620853}, {52,0.001663507}, {53,0.001696682}, {54,0.001706161}, {55,0.001753555}, {56,0.001815166}, {57,0.001919431}, {58,0.001943128}, {59,0.001990521}, {60,0.001990521}, {61,0.001995261}, {62,0.002464455}, {63,0.002000000}, {64,0.002009479}, {65,0.002004739}, {66,0.002000000}, {67,0.002000000}, {68,0.002000000}, {69,0.002009479}, {70,0.002000000}, {71,0.002000000}, {72,0.002000000}, {73,0.002000000}, {74,0.002000000}, {75,0.002000000}, {76,0.002000000}, {77,0.002000000}, {78,0.002511848}, {79,0.002000000}, {80,0.002000000}, {81,0.002000000}, {82,0.002004739}, {83,0.002000000}, {84,0.002000000}, {85,0.002000000}, {86,0.002000000}, {87,0.002000000}, {88,0.002000000}, {89,0.002000000}, {90,0.002014218}, {91,0.002004739}, {92,0.002004739}, {93,0.002018957}, {94,0.002018957}, {95,0.002004739}, {96,0.002014218}, {97,0.002521327}, {98,0.002052133}, {99,0.002047393}, {100,0.002080569}, {101,0.002080569}, {102,0.002104265}, {103,0.002151659}, {104,0.002218009}, {105,0.002232227}, {106,0.002251185}, {107,0.002298578}, {108,0.002336493}, {109,0.003009479}, {110,0.002459716}, {111,0.002521327}, {112,0.002601896}, {113,0.002601896}, {114,0.002663507}, {115,0.002658768}, {116,0.002715640}, {117,0.002739336}, {118,0.002758294}, {119,0.002886256}, {120,0.002890995}, {121,0.002962085}, {122,0.002971564}, {123,0.002976303}, {124,0.002981043}, {125,0.003445498}, {126,0.003000000}, {127,0.002995261}, {128,0.002995261}, {129,0.003000000}, {130,0.003000000}, {131,0.003000000}, {132,0.003000000}, {133,0.003000000}, {134,0.003000000}, {135,0.003511848}, {136,0.003000000}, {137,0.003000000}, {138,0.003000000}, {139,0.003000000}, {140,0.003000000}, {141,0.003000000}, {142,0.003000000}, {143,0.003000000}, {144,0.003004739}, {145,0.003004739}, {146,0.003009479}, {147,0.003000000}, {148,0.003000000}, {149,0.003478673}, {150,0.003014218}, {151,0.003009479}, {152,0.003014218}, {153,0.003037915}, {154,0.003014218}, {155,0.003033175}, {156,0.003033175}, {157,0.003056872}, {158,0.003696682}, {159,0.003085308}, {160,0.003075829}, {161,0.003146919}, {162,0.003113744}, {163,0.003189573}, {164,0.003213270}, {165,0.003260664}, {166,0.003289100}, {167,0.003341232}, {168,0.003369668}, {169,0.003431280}, {170,0.003459716}, {171,0.004014218}, {172,0.003545024}, {173,0.003549763}, {174,0.003559242}, {175,0.003616114}, {176,0.003625592}, {177,0.003658768}, {178,0.003691943}, {179,0.004199052}, {180,0.003706161}, {181,0.003805687}, {182,0.003815166}, {183,0.003881517}, {184,0.003928910}, {185,0.003938389}, {186,0.003943128}, {187,0.003962085}, {188,0.003962085}, {189,0.003962085}, {190,0.003971564}, {191,0.004421801}, {192,0.003990521}, {193,0.003990521}, {194,0.004000000}, {195,0.004000000}, {196,0.004000000}, {197,0.004000000}, {198,0.004516588}, {199,0.004000000}, {200,0.004000000}, {201,0.004004739}, {202,0.004000000}, {203,0.004009479}, {204,0.004018957}, {205,0.004009479}, {206,0.004009479}, {207,0.004004739}, {208,0.004023697}, {209,0.004492891}, {210,0.004018957}, {211,0.004028436}, {212,0.004018957}, {213,0.004014218}, {214,0.004052133}, {215,0.004028436}, {216,0.004578199}, {217,0.004085308}, {218,0.004118483}, {219,0.004094787}, {220,0.004165877}, {221,0.004194313}, {222,0.004194313}, {223,0.004227488}, {224,0.004232227}, {225,0.004284360}, {226,0.004834123}, {227,0.004402844}, {228,0.004407583}, {229,0.004412322}, {230,0.004412322}, {231,0.004464455}, {232,0.004473934}, {233,0.004876777}, {234,0.004535545}, {235,0.004578199}, {236,0.004592417}, {237,0.004625592}, {238,0.004625592}, {239,0.004663507}, {240,0.004687204}, {241,0.004734597}, {242,0.004796209}, {243,0.005004739}, {244,0.004857820}, {245,0.004857820}, {246,0.004886256}, {247,0.004938389}, {248,0.004952607}, {249,0.004957346}, {250,0.004962085}, {251,0.004947867}, {252,0.004957346}, {253,0.004971564}, {254,0.004957346}, {255,0.004966825}, {256,0.004990521}, {257,0.004995261}, {258,0.005431280}, {259,0.005000000}, {260,0.004995261}, {261,0.005000000}, {262,0.005004739}, {263,0.005412322}, {264,0.005009479}, {265,0.005009479}, {266,0.005014218}, {267,0.005014218}, {268,0.005004739}, {269,0.005028436}, {270,0.005037915}, {271,0.005037915}, {272,0.005047393}, {273,0.005033175}, {274,0.005042654}, {275,0.005056872}, {276,0.005090047}, {277,0.005104265}, {278,0.005682464}, {279,0.005151659}, {280,0.005175355}, {281,0.005184834}, {282,0.005189573}, {283,0.005218009}, {284,0.005251185}, {285,0.005274882}, {286,0.005293839}, {287,0.005360190}, {288,0.005364929}, {289,0.005402844}, {290,0.005421801}, {291,0.005450237}, {292,0.005483412}, {293,0.005483412}, {294,0.005545024}, {295,0.005530806}, {296,0.005545024}, {297,0.005597156}, {298,0.005592417}, {299,0.005672986}, {300,0.006047393}, {301,0.005672986}, {302,0.005715640}, {303,0.005767773}, {304,0.005786730}, {305,0.006142180}, {306,0.005848341}, {307,0.005914692}, {308,0.005890995}, {309,0.005919431}, {310,0.005933649}, {311,0.005943128}, {312,0.005957346}, {313,0.006284360}, {314,0.005952607}, {315,0.005947867}, {316,0.005971564}, {317,0.006568720}, {318,0.005985782}, {319,0.006004739}, {320,0.006000000}, {321,0.006004739}, {322,0.006004739}, {323,0.006000000}, {324,0.006004739}, {325,0.006511848}, {326,0.006023697}, {327,0.006042654}, {328,0.006014218}, {329,0.006009479}, {330,0.006554502}, {331,0.006052133}, {332,0.006033175}, {333,0.006033175}, {334,0.006047393}, {335,0.006080569}, {336,0.006099526}, {337,0.006109005}, {338,0.006127962}, {339,0.006180095}, {340,0.006170616}, {341,0.006199052}, {342,0.006800948}, {343,0.006251185}, {344,0.006279621}, {345,0.006331754}, {346,0.006298578}, {347,0.006360190}, {348,0.006374408}, {349,0.006952607}, {350,0.006398104}, {351,0.006431280}, {352,0.006459716}, {353,0.007075829}, {354,0.006507109}, {355,0.006545024}, {356,0.006540284}, {357,0.006535545}, {358,0.006568720}, {359,0.006568720}, {360,0.006625592}, {361,0.007000000}, {362,0.006710900}, {363,0.006710900}, {364,0.006753555}, {365,0.006796209}, {366,0.006810427}, {367,0.006867299}, {368,0.006857820}, {369,0.006876777}, {370,0.006928910}, {371,0.006957346}, {372,0.007393365}, {373,0.006938389}, {374,0.006962085}, {375,0.007180095}, {376,0.006943128}, {377,0.006962085}, {378,0.006962085}, {379,0.006957346}, {380,0.007000000}, {381,0.006990521}, {382,0.006995261}, {383,0.007004739}, {384,0.006995261}, {385,0.007009479}, {386,0.007630332}, {387,0.007014218}, {388,0.007014218}, {389,0.007023697}, {390,0.007023697}, {391,0.007028436}, {392,0.007080569}, {393,0.007526066}, {394,0.007090047}, {395,0.007113744}, {396,0.007127962}, {397,0.007511848}, {398,0.007189573}, {399,0.007222749}, {400,0.007218009}, {401,0.007246445}, {402,0.007274882}, {403,0.008132701}, {404,0.007331754}, {405,0.007345972}, {406,0.007388626}, {407,0.007687204}, {408,0.007360190}, {409,0.007393365}, {410,0.007407583}, {411,0.007436019}, {412,0.007450237}, {413,0.007469194}, {414,0.007469194}, {415,0.007516588}, {416,0.007473934}, {417,0.008033175}, {418,0.007540284}, {419,0.007540284}, {420,0.007611374}, {421,0.007668246}, {422,0.007635071}, {423,0.008454976}, {424,0.007696682}, {425,0.007729858}, {426,0.007734597}, {427,0.008194313}, {428,0.007829384}, {429,0.007857820}, {430,0.007886256}, {431,0.007928910}, {432,0.007928910}, {433,0.008421801}, {434,0.007933649}, {435,0.007943128}, {436,0.008511848}, {437,0.007938389}, {438,0.007947867}, {439,0.007943128}, {440,0.007962085}, {441,0.007952607}, {442,0.007962085}, {443,0.008080569}, {444,0.007947867}, {445,0.007962085}, {446,0.008355450}, {447,0.007985782}, {448,0.008009479}, {449,0.008033175}, {450,0.008052133}, {451,0.008075829}, {452,0.008473934}, {453,0.008090047}, {454,0.008090047}, {455,0.008606635}, {456,0.008109005}, {457,0.008151659}, {458,0.008123223}, {459,0.008146919}, {460,0.008175355}, {461,0.008644550}, {462,0.008203791}, {463,0.008284360}, {464,0.008777251}, {465,0.008308057}, {466,0.008322275}, {467,0.008345972}, {468,0.008364929}, {469,0.008383886}, {470,0.008976303}, {471,0.008412322}, {472,0.008402844}, {473,0.008976303}, {474,0.008454976}, {475,0.008497630}, {476,0.008488152}, {477,0.008502370}, {478,0.008535545}, {479,0.009028436}, {480,0.008592417}, {481,0.008616114}, {482,0.008630332}, {483,0.008706161}, {484,0.008715640}, {485,0.008729858}, {486,0.008763033}, {487,0.008810427}, {488,0.008758294}, {489,0.008838863}, {490,0.009459716}, {491,0.008857820}, {492,0.008886256}, {493,0.008900474}, {494,0.008924171}, {495,0.008919431}, {496,0.009478673}, {497,0.008938389}, {498,0.008943128}, {499,0.009317536}, {500,0.008957346}, {505,0.008976303}, {510,0.009014218}, {515,0.009075829}, {520,0.009985782}, {525,0.009345972}, {530,0.009412322}, {535,0.009966825}, {540,0.009511848}, {545,0.009644550}, {550,0.009810427}, {555,0.009886256}, {560,0.010791469}, {565,0.009966825}, {570,0.010004739}, {575,0.010061611}, {580,0.010222749}, {585,0.010341232}, {590,0.010407583}, {595,0.010502370}, {600,0.010957346}, {605,0.010668246}, {610,0.011791469}, {615,0.010862559}, {620,0.010909953}, {625,0.010947867}, {630,0.011014218}, {635,0.011535545}, {640,0.011203791}, {645,0.011938389}, {650,0.011417062}, {655,0.011445498}, {660,0.011488152}, {665,0.012355450}, {670,0.011767773}, {675,0.012715640}, {680,0.011895735}, {685,0.011943128}, {690,0.012009479}, {695,0.012118483}, {700,0.012620853}, {705,0.013412322}, {710,0.012369668}, {715,0.012421801}, {720,0.012492891}, {725,0.012563981}, {730,0.013018957}, {735,0.014203791}, {740,0.012867299}, {745,0.012933649}, {750,0.013023697}, {755,0.013137441}, {760,0.013194313}, {765,0.014109005}, {770,0.013308057}, {775,0.013383886}, {780,0.013473934}, {785,0.014554502}, {790,0.013663507}, {795,0.014753555}, {800,0.013919431}, {805,0.014004739}, {810,0.014104265}, {815,0.014597156}, {820,0.015350711}, {825,0.014255924}, {830,0.014308057}, {835,0.014412322}, {840,0.015255924}, {845,0.015781991}, {850,0.014644550}, {855,0.014777251}, {860,0.014876777}, {865,0.015540284}, {870,0.015047393}, {875,0.015000000}, {880,0.015184834}, {885,0.015293839}, {890,0.016165877}, {895,0.015388626}, {900,0.015450237}, {905,0.015559242}, {910,0.015687204}, {915,0.016388626}, {920,0.017047393}, {925,0.016023697}, {930,0.016061611}, {935,0.016161137}, {940,0.017184834}, {945,0.017061611}, {950,0.016322275}, {955,0.016383886}, {960,0.018327014}, {965,0.016507109}, {970,0.017170616}, {975,0.016781991}, {980,0.016928910}, {985,0.017725118}, {990,0.018753555}, {995,0.017170616}, {1000,0.017213270}, {1010,0.018639810}, {1020,0.017469194}, {1030,0.018037915}, {1040,0.017924171}, {1050,0.018137441}, {1060,0.018758294}, {1070,0.018938389}, {1080,0.018497630}, {1090,0.018687204}, {1100,0.020227488}, {1110,0.020085308}, {1120,0.019331754}, {1130,0.019454976}, {1140,0.020763033}, {1150,0.020379147}, {1160,0.019995261}, {1170,0.020222749}, {1180,0.020957346}, {1190,0.020990521}, {1200,0.020616114}, {1210,0.022355450}, {1220,0.022635071}, {1230,0.021312796}, {1240,0.021454976}, {1250,0.022478673}, {1260,0.022876777}, {1270,0.021886256}, {1280,0.022132701}, {1290,0.022094787}, {1300,0.022530806}, {1310,0.022672986}, {1320,0.023616114}, {1330,0.023838863}, {1340,0.023151659}, {1350,0.024791469}, {1360,0.025028436}, {1370,0.023781991}, {1380,0.023924171}, {1390,0.024649289}, {1400,0.024289100}, {1410,0.024573460}, {1420,0.025383886}, {1430,0.025412322}, {1440,0.025033175}, {1450,0.026279621}, {1460,0.027597156}, {1470,0.025630332}, {1480,0.026772512}, {1490,0.027047393}, {1500,0.026142180}, {1510,0.027644550}, {1520,0.027203791}, {1530,0.026715640}, {1540,0.028127962}, {1550,0.028483412}, {1560,0.027341232}, {1570,0.029819905}, {1580,0.028744076}, {1590,0.027938389}, {1600,0.029563981}, {1610,0.028194313}, {1620,0.028417062}, {1630,0.031990521}, {1640,0.028819905}, {1650,0.030540284}, {1660,0.030635071}, {1670,0.029426540}, {1680,0.030715640}, {1690,0.032052133}, {1700,0.029924171}, {1710,0.035023697}, {1720,0.030236967}, {1730,0.033236967}, {1740,0.031701422}, {1750,0.030725118}, {1760,0.032317536}, {1770,0.031819905}, {1780,0.031379147}, {1790,0.032914692}, {1800,0.031739336}, {1810,0.033800948}, {1820,0.032938389}, {1830,0.032379147}, {1840,0.033715640}, {1850,0.032635071}, {1860,0.034677725}, {1870,0.033767773}, {1880,0.035744076}, {1890,0.034454976}, {1900,0.033701422}, {1910,0.037905213}, {1920,0.034165877}, {1930,0.036180095}, {1940,0.036928910}, {1950,0.034800948}, {1960,0.037199052}, {1970,0.034971564}, {1980,0.039260664}, {1990,0.035492891}, {2000,0.037123223}, {2050,0.037450237}, {2100,0.039255924}, {2150,0.039767773}, {2200,0.042625592}, {2250,0.042042654}, {2300,0.044947867}, {2350,0.043985782}, {2400,0.046071090}, {2450,0.045549763}, {2500,0.047848341}, {2550,0.047990521}, {2600,0.052279621}, {2650,0.049189573}, {2700,0.054161137}, {2750,0.055805687}, {2800,0.054270142}, {2850,0.057985782}, {2900,0.054464455}, {2950,0.057853081}, {3000,0.058417062}, {3050,0.057497630}, {3100,0.061331754}, {3150,0.063071090}, {3200,0.060601896}, {3250,0.064436019}, {3300,0.066146919}, {3350,0.066739336}, {3400,0.067298578}, {3450,0.072938389}, {3500,0.074274882}, {3550,0.071829384}, {3600,0.070729858}, {3650,0.074388626}, {3700,0.075805687}, {3750,0.079028436}, {3800,0.077563981}, {3850,0.076497630}, {3900,0.076417062}, {3950,0.082066351}, {4000,0.084483412}, {4050,0.084843602}, {4100,0.090293839}, {4150,0.087085308}, {4200,0.088232227}, {4250,0.090886256}, {4300,0.089066351}, {4350,0.092938389}, {4400,0.092194313}, {4450,0.091085308}, {4500,0.093151659}, {4550,0.098857820}, {4600,0.100838863}, {4650,0.102199052}, {4700,0.102976303}, {4750,0.102601896}, {4800,0.102890995}, {4850,0.100199052}, {4900,0.104398104}, {4950,0.113492891}, {5000,0.110616114}, {5050,0.12271}, {5100,0.10614}, {5150,0.10686}, {5200,0.11043}, {5250,0.11343}, {5300,0.11029}, {5350,0.10971}, {5400,0.10929}, {5450,0.11243}, {5500,0.11757}, {5550,0.11971}, {5600,0.11857}, {5650,0.11643}, {5700,0.11743}, {5750,0.11929}, {5800,0.12257}, {5850,0.12057}, {5900,0.12400}, {5950,0.12757}, {6000,0.12729}, {6050,0.12543}, {6100,0.13314}, {6150,0.13400}, {6200,0.12714}, {6250,0.13300}, {6300,0.13000}, {6350,0.13057}, {6400,0.13400}, {6450,0.13514}, {6500,0.14329}, {6550,0.14571}, {6600,0.14100}, {6650,0.14286}, {6700,0.14343}, {6750,0.14614}, {6800,0.14329}, {6850,0.15514}, {6900,0.14800}, {6950,0.15586}, {7000,0.15186}, {7050,0.16071}, {7100,0.15129}, {7150,0.16057}, {7200,0.15014}, {7250,0.15814}, {7300,0.15357}, {7350,0.16286}, {7400,0.16171}, {7450,0.16114}, {7500,0.17486}, {7550,0.16057}, {7600,0.16514}, {7650,0.17457}, {7700,0.16657}, {7750,0.17229}, {7800,0.17643}, {7850,0.16814}, {7900,0.17571}, {7950,0.18500}, {8000,0.17371}, {8050,0.17429}, {8100,0.18114}, {8150,0.19043}, {8200,0.17686}, {8250,0.17929}, {8300,0.18529}, {8350,0.19314}, {8400,0.19086}, {8450,0.18429}, {8500,0.18414}, {8550,0.19271}, {8600,0.19271}, {8650,0.20071}, {8700,0.20486}, {8750,0.19057}, {8800,0.19757}, {8850,0.19586}, {8900,0.19486}, {8950,0.20129}, {9000,0.20443}, {9050,0.21486}, {9100,0.21500}, {9150,0.20857}, {9200,0.20771}, {9250,0.20529}, {9300,0.20786}, {9350,0.20843}, {9400,0.21771}, {9450,0.22829}, {9500,0.22629}, {9550,0.22000}, {9600,0.22743}, {9650,0.22043}, {9700,0.22014}, {9750,0.22500}, {9800,0.22457}, {9850,0.22471}, {9900,0.23786}, {9950,0.23471}, {10000,0.23857}, {10100,0.23457}, {10200,0.23286}, {10300,0.22686}, {10400,0.24929}, {10500,0.24671}, {10600,0.24371}, {10700,0.64686}, {10800,0.26771}, {10900,0.25857}, {11000,0.24800}, {11100,0.26843}, {11200,0.26086}, {11300,0.26000}, {11400,0.27471}, {11500,0.26543}, {11600,0.28443}, {11700,0.26900}, {11800,0.28657}, {11900,0.27571}, {12000,0.28671}, {12100,0.29943}, {12200,0.28671}, {12300,0.30543}, {12400,0.30257}, {12500,0.29386}, {12600,0.30771}, {12700,0.31929}, {12800,0.29686}, {12900,0.30214}, {13000,0.32700}, {13100,0.32986}, {13200,0.31671}, {13300,0.30914}, {13400,0.32414}, {13500,0.32600}, {13600,0.31714}, {13700,0.32343}, {13800,0.32671}, {13900,0.33757}, {14000,0.33986}, {14100,0.33829}, {14200,0.33129}, {14300,0.34071}, {14400,0.34786}, {14500,0.34886}, {14600,0.35386}, {14700,0.35143}, {14800,0.36814}, {14900,0.37043}, {15000,0.36486}, {15100,0.36514}, {15200,0.37186}, {15300,0.37929}, {15400,0.38729}, {15500,0.38214}, {15600,0.38757}, {15700,0.38571}, {15800,0.38357}, {15900,0.39157}, {16000,0.39743}, {16100,0.39257}, {16200,0.40429}, {16300,0.40114}, {16400,0.40843}, {16500,0.40357}, {16600,0.41229}, {16700,0.41957}, {16800,0.40729}, {16900,0.42743}, {17000,0.40200}, {17100,0.42114}, {17200,0.44371}, {17300,0.42071}, {17400,0.42129}, {17500,0.43886}, {17600,0.44529}, {17700,0.42986}, {17800,0.40729}, {17900,0.43671}, {18000,0.45000}, {18100,0.47257}, {18200,0.47857}, {18300,0.45971}, {18400,0.46429}, {18500,0.46214}, {18600,0.46757}, {18700,0.46957}, {18800,0.46457}, {18900,0.48971}, {19000,0.49900}, {19100,0.50186}, {19200,0.51857}, {19300,0.49471}, {19400,0.46800}, {19500,0.45271}, {19600,0.48814}, {19700,0.52757}, {19800,0.50571}, {19900,0.45700}, {20000,0.51380}};
data["big_flat"]["beta; Parametricity"]["Aggregate"]["user"] = {{1,0.000928910}, {2,0.000862559}, {3,0.001047393}, {4,0.001080569}, {5,0.000876777}, {6,0.000952607}, {7,0.001094787}, {8,0.001151659}, {9,0.001118483}, {10,0.001151659}, {11,0.001341232}, {12,0.001137441}, {13,0.001071090}, {14,0.001137441}, {15,0.001165877}, {16,0.001336493}, {17,0.001099526}, {18,0.001308057}, {19,0.001180095}, {20,0.001246445}, {21,0.001417062}, {22,0.001331754}, {23,0.001331754}, {24,0.001208531}, {25,0.001312796}, {26,0.001374408}, {27,0.001445498}, {28,0.001492891}, {29,0.001507109}, {30,0.001436019}, {31,0.001459716}, {32,0.001473934}, {33,0.001507109}, {34,0.001511848}, {35,0.001473934}, {36,0.001535545}, {37,0.011061611}, {38,0.001630332}, {39,0.001578199}, {40,0.001696682}, {41,0.001540284}, {42,0.001744076}, {43,0.001582938}, {44,0.001682464}, {45,0.001928910}, {46,0.001497630}, {47,0.001867299}, {48,0.001502370}, {49,0.001601896}, {50,0.002052133}, {51,0.001530806}, {52,0.001933649}, {53,0.001829384}, {54,0.001563981}, {55,0.002080569}, {56,0.001725118}, {57,0.001848341}, {58,0.002037915}, {59,0.001890995}, {60,0.001810427}, {61,0.001857820}, {62,0.002497630}, {63,0.001862559}, {64,0.002014218}, {65,0.001928910}, {66,0.001914692}, {67,0.001966825}, {68,0.002066351}, {69,0.001919431}, {70,0.001995261}, {71,0.002033175}, {72,0.002161137}, {73,0.002018957}, {74,0.002161137}, {75,0.002004739}, {76,0.002360190}, {77,0.001990521}, {78,0.002492891}, {79,0.002146919}, {80,0.002293839}, {81,0.002298578}, {82,0.001990521}, {83,0.002213270}, {84,0.002478673}, {85,0.002379147}, {86,0.002066351}, {87,0.002194313}, {88,0.002298578}, {89,0.002530806}, {90,0.002213270}, {91,0.002322275}, {92,0.002298578}, {93,0.002464455}, {94,0.002388626}, {95,0.002454976}, {96,0.002421801}, {97,0.002824645}, {98,0.002364929}, {99,0.002436019}, {100,0.002440758}, {101,0.002502370}, {102,0.002473934}, {103,0.002668246}, {104,0.002682464}, {105,0.002312796}, {106,0.002393365}, {107,0.002440758}, {108,0.002616114}, {109,0.003165877}, {110,0.002578199}, {111,0.002710900}, {112,0.002663507}, {113,0.002597156}, {114,0.002744076}, {115,0.002781991}, {116,0.002867299}, {117,0.002682464}, {118,0.002710900}, {119,0.002611374}, {120,0.002815166}, {121,0.002696682}, {122,0.002682464}, {123,0.002834123}, {124,0.002729858}, {125,0.003274882}, {126,0.002976303}, {127,0.002957346}, {128,0.002981043}, {129,0.002981043}, {130,0.002962085}, {131,0.002981043}, {132,0.002867299}, {133,0.002777251}, {134,0.002905213}, {135,0.003412322}, {136,0.002971564}, {137,0.003170616}, {138,0.002938389}, {139,0.002886256}, {140,0.003094787}, {141,0.003028436}, {142,0.003009479}, {143,0.003023697}, {144,0.002938389}, {145,0.003094787}, {146,0.003161137}, {147,0.003023697}, {148,0.003132701}, {149,0.003559242}, {150,0.003094787}, {151,0.003142180}, {152,0.003175355}, {153,0.003284360}, {154,0.003265403}, {155,0.003369668}, {156,0.003251185}, {157,0.003260664}, {158,0.003668246}, {159,0.003355450}, {160,0.003350711}, {161,0.003360190}, {162,0.003388626}, {163,0.003336493}, {164,0.003421801}, {165,0.003469194}, {166,0.003521327}, {167,0.003336493}, {168,0.003450237}, {169,0.003559242}, {170,0.003402844}, {171,0.004023697}, {172,0.003483412}, {173,0.003445498}, {174,0.003710900}, {175,0.003549763}, {176,0.003578199}, {177,0.003592417}, {178,0.003573460}, {179,0.004312796}, {180,0.003706161}, {181,0.003663507}, {182,0.003663507}, {183,0.003715640}, {184,0.003691943}, {185,0.003763033}, {186,0.003800948}, {187,0.003805687}, {188,0.003649289}, {189,0.003796209}, {190,0.003815166}, {191,0.004312796}, {192,0.003957346}, {193,0.003952607}, {194,0.003957346}, {195,0.003981043}, {196,0.003943128}, {197,0.003966825}, {198,0.004440758}, {199,0.003890995}, {200,0.003947867}, {201,0.004009479}, {202,0.003962085}, {203,0.003966825}, {204,0.003909953}, {205,0.003943128}, {206,0.003966825}, {207,0.003857820}, {208,0.004151659}, {209,0.004559242}, {210,0.004042654}, {211,0.004071090}, {212,0.004308057}, {213,0.004241706}, {214,0.003985782}, {215,0.004322275}, {216,0.004677725}, {217,0.004146919}, {218,0.004379147}, {219,0.004189573}, {220,0.004440758}, {221,0.004255924}, {222,0.004241706}, {223,0.004293839}, {224,0.004260664}, {225,0.004464455}, {226,0.004895735}, {227,0.004454976}, {228,0.004540284}, {229,0.004227488}, {230,0.004597156}, {231,0.004364929}, {232,0.004492891}, {233,0.004763033}, {234,0.004554502}, {235,0.004497630}, {236,0.004421801}, {237,0.004767773}, {238,0.004421801}, {239,0.004511848}, {240,0.004516588}, {241,0.004601896}, {242,0.004867299}, {243,0.004739336}, {244,0.004734597}, {245,0.004597156}, {246,0.004739336}, {247,0.004601896}, {248,0.004729858}, {249,0.004895735}, {250,0.004848341}, {251,0.005014218}, {252,0.004672986}, {253,0.005004739}, {254,0.004710900}, {255,0.004928910}, {256,0.004568720}, {257,0.004938389}, {258,0.005109005}, {259,0.004976303}, {260,0.004966825}, {261,0.004985782}, {262,0.005014218}, {263,0.005241706}, {264,0.004947867}, {265,0.004971564}, {266,0.004900474}, {267,0.004966825}, {268,0.005080569}, {269,0.004947867}, {270,0.005208531}, {271,0.004919431}, {272,0.005208531}, {273,0.005014218}, {274,0.005274882}, {275,0.004947867}, {276,0.005156398}, {277,0.005028436}, {278,0.005867299}, {279,0.005018957}, {280,0.005265403}, {281,0.005369668}, {282,0.005033175}, {283,0.005402844}, {284,0.005322275}, {285,0.005170616}, {286,0.005469194}, {287,0.005208531}, {288,0.005502370}, {289,0.005379147}, {290,0.005289100}, {291,0.005563981}, {292,0.005398104}, {293,0.005270142}, {294,0.005454976}, {295,0.005369668}, {296,0.005573460}, {297,0.005611374}, {298,0.005478673}, {299,0.005601896}, {300,0.006014218}, {301,0.005687204}, {302,0.005511848}, {303,0.005440758}, {304,0.005682464}, {305,0.006066351}, {306,0.005635071}, {307,0.005606635}, {308,0.005791469}, {309,0.005696682}, {310,0.005535545}, {311,0.005729858}, {312,0.005734597}, {313,0.006255924}, {314,0.005853081}, {315,0.005568720}, {316,0.005791469}, {317,0.006483412}, {318,0.005843602}, {319,0.005791469}, {320,0.005834123}, {321,0.006042654}, {322,0.005957346}, {323,0.005497630}, {324,0.006000000}, {325,0.006654028}, {326,0.006132701}, {327,0.005867299}, {328,0.005772512}, {329,0.005938389}, {330,0.006606635}, {331,0.005834123}, {332,0.005900474}, {333,0.005981043}, {334,0.006165877}, {335,0.006436019}, {336,0.006014218}, {337,0.006180095}, {338,0.005957346}, {339,0.005909953}, {340,0.006056872}, {341,0.006194313}, {342,0.006744076}, {343,0.006331754}, {344,0.006090047}, {345,0.006123223}, {346,0.006298578}, {347,0.006312796}, {348,0.006284360}, {349,0.006829384}, {350,0.006260664}, {351,0.006469194}, {352,0.006464455}, {353,0.007009479}, {354,0.006369668}, {355,0.006369668}, {356,0.006578199}, {357,0.006459716}, {358,0.006417062}, {359,0.006440758}, {360,0.006331754}, {361,0.006758294}, {362,0.006587678}, {363,0.006582938}, {364,0.006545024}, {365,0.006402844}, {366,0.006516588}, {367,0.006459716}, {368,0.006526066}, {369,0.006511848}, {370,0.006516588}, {371,0.006426540}, {372,0.007014218}, {373,0.006478673}, {374,0.006459716}, {375,0.006616114}, {376,0.006483412}, {377,0.006582938}, {378,0.006559242}, {379,0.006573460}, {380,0.006611374}, {381,0.006639810}, {382,0.006895735}, {383,0.006900474}, {384,0.006957346}, {385,0.006928910}, {386,0.007360190}, {387,0.006838863}, {388,0.006706161}, {389,0.006848341}, {390,0.006834123}, {391,0.006786730}, {392,0.006947867}, {393,0.007507109}, {394,0.006872038}, {395,0.006966825}, {396,0.006957346}, {397,0.007407583}, {398,0.007033175}, {399,0.007033175}, {400,0.007255924}, {401,0.007099526}, {402,0.007066351}, {403,0.007791469}, {404,0.007194313}, {405,0.007289100}, {406,0.007170616}, {407,0.007526066}, {408,0.007303318}, {409,0.007132701}, {410,0.007227488}, {411,0.007293839}, {412,0.007270142}, {413,0.007473934}, {414,0.007194313}, {415,0.007227488}, {416,0.007440758}, {417,0.007928910}, {418,0.007421801}, {419,0.007483412}, {420,0.007417062}, {421,0.007473934}, {422,0.007407583}, {423,0.008507109}, {424,0.007331754}, {425,0.007526066}, {426,0.007492891}, {427,0.007815166}, {428,0.007497630}, {429,0.007616114}, {430,0.007720379}, {431,0.007696682}, {432,0.007540284}, {433,0.008317536}, {434,0.007767773}, {435,0.007687204}, {436,0.008545024}, {437,0.007606635}, {438,0.007715640}, {439,0.007606635}, {440,0.007905213}, {441,0.007990521}, {442,0.007701422}, {443,0.007838863}, {444,0.007872038}, {445,0.007810427}, {446,0.008156398}, {447,0.007800948}, {448,0.007971564}, {449,0.007971564}, {450,0.008071090}, {451,0.007995261}, {452,0.008530806}, {453,0.008052133}, {454,0.007843602}, {455,0.008758294}, {456,0.008146919}, {457,0.008028436}, {458,0.008156398}, {459,0.007952607}, {460,0.008056872}, {461,0.008649289}, {462,0.008109005}, {463,0.007952607}, {464,0.008876777}, {465,0.008383886}, {466,0.008251185}, {467,0.008227488}, {468,0.008431280}, {469,0.008194313}, {470,0.009004739}, {471,0.008417062}, {472,0.008421801}, {473,0.008900474}, {474,0.008232227}, {475,0.008616114}, {476,0.008464455}, {477,0.008682464}, {478,0.008241706}, {479,0.009085308}, {480,0.008516588}, {481,0.008483412}, {482,0.008630332}, {483,0.008345972}, {484,0.008492891}, {485,0.008663507}, {486,0.008606635}, {487,0.008568720}, {488,0.008654028}, {489,0.008748815}, {490,0.009431280}, {491,0.008691943}, {492,0.008677725}, {493,0.008559242}, {494,0.009042654}, {495,0.008677725}, {496,0.009701422}, {497,0.008815166}, {498,0.008843602}, {499,0.009341232}, {500,0.009104265}, {505,0.008952607}, {510,0.009208531}, {515,0.009222749}, {520,0.010047393}, {525,0.009194313}, {530,0.009800948}, {535,0.010009479}, {540,0.009663507}, {545,0.009592417}, {550,0.009592417}, {555,0.009924171}, {560,0.011199052}, {565,0.010227488}, {570,0.010156398}, {575,0.010246445}, {580,0.010469194}, {585,0.010213270}, {590,0.010345972}, {595,0.010597156}, {600,0.011227488}, {605,0.010933649}, {610,0.011981043}, {615,0.011142180}, {620,0.011085308}, {625,0.011246445}, {630,0.011289100}, {635,0.011658768}, {640,0.011407583}, {645,0.012033175}, {650,0.011729858}, {655,0.011876777}, {660,0.011834123}, {665,0.012767773}, {670,0.012056872}, {675,0.012876777}, {680,0.012279621}, {685,0.012274882}, {690,0.012274882}, {695,0.012388626}, {700,0.012938389}, {705,0.013597156}, {710,0.012483412}, {715,0.012834123}, {720,0.013014218}, {725,0.012876777}, {730,0.013284360}, {735,0.014208531}, {740,0.013104265}, {745,0.013199052}, {750,0.013492891}, {755,0.013274882}, {760,0.013227488}, {765,0.014360190}, {770,0.013772512}, {775,0.013706161}, {780,0.013464455}, {785,0.014606635}, {790,0.013886256}, {795,0.014966825}, {800,0.014009479}, {805,0.014075829}, {810,0.014194313}, {815,0.014677725}, {820,0.015507109}, {825,0.014379147}, {830,0.014388626}, {835,0.014587678}, {840,0.015227488}, {845,0.015672986}, {850,0.014753555}, {855,0.014895735}, {860,0.014857820}, {865,0.015559242}, {870,0.015113744}, {875,0.015184834}, {880,0.015118483}, {885,0.015132701}, {890,0.015938389}, {895,0.015521327}, {900,0.015454976}, {905,0.015530806}, {910,0.015824645}, {915,0.016492891}, {920,0.016928910}, {925,0.015805687}, {930,0.015938389}, {935,0.016241706}, {940,0.016791469}, {945,0.016943128}, {950,0.016350711}, {955,0.016597156}, {960,0.018184834}, {965,0.016568720}, {970,0.017056872}, {975,0.016720379}, {980,0.016957346}, {985,0.017687204}, {990,0.018521327}, {995,0.016658768}, {1000,0.017071090}, {1010,0.018682464}, {1020,0.017426540}, {1030,0.017748815}, {1040,0.017573460}, {1050,0.017938389}, {1060,0.018393365}, {1070,0.018635071}, {1080,0.018265403}, {1090,0.018691943}, {1100,0.020056872}, {1110,0.019900474}, {1120,0.019156398}, {1130,0.019251185}, {1140,0.020611374}, {1150,0.020436019}, {1160,0.019744076}, {1170,0.020255924}, {1180,0.020663507}, {1190,0.020981043}, {1200,0.020402844}, {1210,0.022279621}, {1220,0.022706161}, {1230,0.021142180}, {1240,0.021559242}, {1250,0.022976303}, {1260,0.023004739}, {1270,0.022436019}, {1280,0.022265403}, {1290,0.022450237}, {1300,0.022905213}, {1310,0.022843602}, {1320,0.023767773}, {1330,0.024066351}, {1340,0.023364929}, {1350,0.024957346}, {1360,0.024952607}, {1370,0.024042654}, {1380,0.024199052}, {1390,0.024625592}, {1400,0.024345972}, {1410,0.024592417}, {1420,0.025545024}, {1430,0.025578199}, {1440,0.025094787}, {1450,0.026355450}, {1460,0.027654028}, {1470,0.025720379}, {1480,0.026905213}, {1490,0.027042654}, {1500,0.026170616}, {1510,0.027630332}, {1520,0.027341232}, {1530,0.027000000}, {1540,0.028118483}, {1550,0.028312796}, {1560,0.027426540}, {1570,0.029431280}, {1580,0.028687204}, {1590,0.028028436}, {1600,0.029236967}, {1610,0.028085308}, {1620,0.028066351}, {1630,0.031791469}, {1640,0.028725118}, {1650,0.030208531}, {1660,0.030530806}, {1670,0.029236967}, {1680,0.030554502}, {1690,0.031867299}, {1700,0.029701422}, {1710,0.034805687}, {1720,0.030014218}, {1730,0.033293839}, {1740,0.031445498}, {1750,0.030327014}, {1760,0.032161137}, {1770,0.031492891}, {1780,0.031052133}, {1790,0.032815166}, {1800,0.031635071}, {1810,0.033748815}, {1820,0.032905213}, {1830,0.032075829}, {1840,0.033511848}, {1850,0.032497630}, {1860,0.034781991}, {1870,0.033805687}, {1880,0.035791469}, {1890,0.034255924}, {1900,0.033635071}, {1910,0.037772512}, {1920,0.034161137}, {1930,0.036142180}, {1940,0.036748815}, {1950,0.034725118}, {1960,0.037127962}, {1970,0.034952607}, {1980,0.039028436}, {1990,0.035587678}, {2000,0.037066351}, {2050,0.037383886}, {2100,0.039218009}, {2150,0.039587678}, {2200,0.042293839}, {2250,0.041928910}, {2300,0.044720379}, {2350,0.043687204}, {2400,0.046137441}, {2450,0.045625592}, {2500,0.047995261}, {2550,0.047677725}, {2600,0.052052133}, {2650,0.049037915}, {2700,0.053829384}, {2750,0.055473934}, {2800,0.054071090}, {2850,0.057781991}, {2900,0.054189573}, {2950,0.057753555}, {3000,0.058127962}, {3050,0.057355450}, {3100,0.061180095}, {3150,0.062909953}, {3200,0.060445498}, {3250,0.064327014}, {3300,0.065791469}, {3350,0.066236967}, {3400,0.067156398}, {3450,0.072654028}, {3500,0.074009479}, {3550,0.071715640}, {3600,0.070507109}, {3650,0.074151659}, {3700,0.075592417}, {3750,0.078777251}, {3800,0.077161137}, {3850,0.076374408}, {3900,0.076398104}, {3950,0.081568720}, {4000,0.084000000}, {4050,0.084464455}, {4100,0.090018957}, {4150,0.086734597}, {4200,0.087725118}, {4250,0.090464455}, {4300,0.088985782}, {4350,0.092625592}, {4400,0.091981043}, {4450,0.091028436}, {4500,0.093061611}, {4550,0.098516588}, {4600,0.100199052}, {4650,0.101900474}, {4700,0.102635071}, {4750,0.102151659}, {4800,0.102587678}, {4850,0.099985782}, {4900,0.104085308}, {4950,0.113284360}, {5000,0.110336493}, {5050,0.12214}, {5100,0.10543}, {5150,0.10614}, {5200,0.11043}, {5250,0.11300}, {5300,0.10786}, {5350,0.10943}, {5400,0.10957}, {5450,0.11271}, {5500,0.11600}, {5550,0.11957}, {5600,0.11814}, {5650,0.11429}, {5700,0.11743}, {5750,0.11986}, {5800,0.12300}, {5850,0.11886}, {5900,0.12457}, {5950,0.12729}, {6000,0.12729}, {6050,0.12514}, {6100,0.13171}, {6150,0.13257}, {6200,0.12671}, {6250,0.13114}, {6300,0.13000}, {6350,0.13043}, {6400,0.13386}, {6450,0.13500}, {6500,0.14314}, {6550,0.14471}, {6600,0.14171}, {6650,0.14386}, {6700,0.14186}, {6750,0.14600}, {6800,0.14371}, {6850,0.15386}, {6900,0.14671}, {6950,0.15629}, {7000,0.15143}, {7050,0.15857}, {7100,0.15157}, {7150,0.16029}, {7200,0.14986}, {7250,0.15814}, {7300,0.15200}, {7350,0.16071}, {7400,0.16057}, {7450,0.16186}, {7500,0.17414}, {7550,0.15943}, {7600,0.16400}, {7650,0.17343}, {7700,0.16686}, {7750,0.17186}, {7800,0.17314}, {7850,0.16671}, {7900,0.17243}, {7950,0.18457}, {8000,0.17286}, {8050,0.17529}, {8100,0.18057}, {8150,0.19029}, {8200,0.17614}, {8250,0.17986}, {8300,0.18529}, {8350,0.19171}, {8400,0.18957}, {8450,0.18400}, {8500,0.18429}, {8550,0.19157}, {8600,0.19129}, {8650,0.20100}, {8700,0.20371}, {8750,0.19014}, {8800,0.19800}, {8850,0.19657}, {8900,0.19471}, {8950,0.20186}, {9000,0.20457}, {9050,0.21486}, {9100,0.21414}, {9150,0.20643}, {9200,0.20629}, {9250,0.20400}, {9300,0.20714}, {9350,0.20700}, {9400,0.21771}, {9450,0.22886}, {9500,0.22471}, {9550,0.22043}, {9600,0.22714}, {9650,0.22043}, {9700,0.22029}, {9750,0.22400}, {9800,0.22486}, {9850,0.22386}, {9900,0.23729}, {9950,0.23414}, {10000,0.23729}, {10100,0.23414}, {10200,0.23229}, {10300,0.22657}, {10400,0.25000}, {10500,0.24629}, {10600,0.24371}, {10700,0.64614}, {10800,0.26757}, {10900,0.25786}, {11000,0.24757}, {11100,0.26757}, {11200,0.26100}, {11300,0.25886}, {11400,0.27314}, {11500,0.26600}, {11600,0.28171}, {11700,0.27014}, {11800,0.28629}, {11900,0.27543}, {12000,0.28600}, {12100,0.29857}, {12200,0.28657}, {12300,0.30529}, {12400,0.30200}, {12500,0.29429}, {12600,0.30614}, {12700,0.31943}, {12800,0.29600}, {12900,0.30143}, {13000,0.32743}, {13100,0.32957}, {13200,0.31614}, {13300,0.30871}, {13400,0.32257}, {13500,0.32671}, {13600,0.31629}, {13700,0.32243}, {13800,0.32629}, {13900,0.33729}, {14000,0.33900}, {14100,0.33857}, {14200,0.33100}, {14300,0.34071}, {14400,0.34786}, {14500,0.34857}, {14600,0.35414}, {14700,0.35086}, {14800,0.36743}, {14900,0.36929}, {15000,0.36443}, {15100,0.36529}, {15200,0.37329}, {15300,0.37914}, {15400,0.38757}, {15500,0.38171}, {15600,0.38757}, {15700,0.38600}, {15800,0.38229}, {15900,0.39100}, {16000,0.39600}, {16100,0.39200}, {16200,0.40343}, {16300,0.40043}, {16400,0.40757}, {16500,0.40286}, {16600,0.41143}, {16700,0.41914}, {16800,0.40771}, {16900,0.42671}, {17000,0.40171}, {17100,0.42000}, {17200,0.44300}, {17300,0.41900}, {17400,0.42100}, {17500,0.43814}, {17600,0.44300}, {17700,0.43000}, {17800,0.40614}, {17900,0.43586}, {18000,0.45100}, {18100,0.47157}, {18200,0.47829}, {18300,0.45843}, {18400,0.46229}, {18500,0.46000}, {18600,0.46686}, {18700,0.46986}, {18800,0.46386}, {18900,0.48914}, {19000,0.49829}, {19100,0.50214}, {19200,0.51671}, {19300,0.49286}, {19400,0.46800}, {19500,0.45329}, {19600,0.48714}, {19700,0.52814}, {19800,0.50586}, {19900,0.45629}, {20000,0.51240}};
data["big_flat"]["beta; Parametricity"]["Aggregate"]["system"] = {{1,0.000132701}, {2,0.000075829}, {3,0.000018957}, {4,0.000014218}, {5,0.000075829}, {6,0.000056872}, {7,0.000000000}, {8,0.000018957}, {9,0.000018957}, {10,0.000000000}, {11,0.000000000}, {12,0.000018957}, {13,0.000094787}, {14,0.000018957}, {15,0.000056872}, {16,0.000000000}, {17,0.000018957}, {18,0.000037915}, {19,0.000000000}, {20,0.000018957}, {21,0.000000000}, {22,0.000000000}, {23,0.000037915}, {24,0.000018957}, {25,0.000037915}, {26,0.000056872}, {27,0.000094787}, {28,0.000056872}, {29,0.000037915}, {30,0.000000000}, {31,0.000033175}, {32,0.000056872}, {33,0.000000000}, {34,0.000052133}, {35,0.000037915}, {36,0.000000000}, {37,0.000056872}, {38,0.000018957}, {39,0.000000000}, {40,0.000018957}, {41,0.000014218}, {42,0.000018957}, {43,0.000000000}, {44,0.000047393}, {45,0.000018957}, {46,0.000037915}, {47,0.000037915}, {48,0.000018957}, {49,0.000113744}, {50,0.000052133}, {51,0.000018957}, {52,0.000018957}, {53,0.000018957}, {54,0.000094787}, {55,0.000033175}, {56,0.000075829}, {57,0.000018957}, {58,0.000033175}, {59,0.000000000}, {60,0.000075829}, {61,0.000052133}, {62,0.000018957}, {63,0.000037915}, {64,0.000037915}, {65,0.000018957}, {66,0.000037915}, {67,0.000018957}, {68,0.000056872}, {69,0.000000000}, {70,0.000000000}, {71,0.000018957}, {72,0.000037915}, {73,0.000056872}, {74,0.000037915}, {75,0.000014218}, {76,0.000033175}, {77,0.000075829}, {78,0.000037915}, {79,0.000000000}, {80,0.000000000}, {81,0.000075829}, {82,0.000018957}, {83,0.000000000}, {84,0.000000000}, {85,0.000056872}, {86,0.000018957}, {87,0.000037915}, {88,0.000056872}, {89,0.000037915}, {90,0.000109005}, {91,0.000037915}, {92,0.000056872}, {93,0.000037915}, {94,0.000037915}, {95,0.000000000}, {96,0.000037915}, {97,0.000018957}, {98,0.000037915}, {99,0.000056872}, {100,0.000018957}, {101,0.000056872}, {102,0.000033175}, {103,0.000037915}, {104,0.000037915}, {105,0.000090047}, {106,0.000018957}, {107,0.000000000}, {108,0.000018957}, {109,0.000056872}, {110,0.000018957}, {111,0.000037915}, {112,0.000037915}, {113,0.000037915}, {114,0.000000000}, {115,0.000018957}, {116,0.000075829}, {117,0.000109005}, {118,0.000052133}, {119,0.000056872}, {120,0.000075829}, {121,0.000075829}, {122,0.000037915}, {123,0.000037915}, {124,0.000047393}, {125,0.000056872}, {126,0.000056872}, {127,0.000056872}, {128,0.000037915}, {129,0.000000000}, {130,0.000037915}, {131,0.000014218}, {132,0.000037915}, {133,0.000113744}, {134,0.000056872}, {135,0.000018957}, {136,0.000037915}, {137,0.000018957}, {138,0.000000000}, {139,0.000056872}, {140,0.000037915}, {141,0.000037915}, {142,0.000018957}, {143,0.000018957}, {144,0.000018957}, {145,0.000037915}, {146,0.000037915}, {147,0.000094787}, {148,0.000018957}, {149,0.000052133}, {150,0.000033175}, {151,0.000037915}, {152,0.000090047}, {153,0.000037915}, {154,0.000075829}, {155,0.000037915}, {156,0.000075829}, {157,0.000000000}, {158,0.000037915}, {159,0.000000000}, {160,0.000037915}, {161,0.000018957}, {162,0.000056872}, {163,0.000075829}, {164,0.000018957}, {165,0.000018957}, {166,0.000056872}, {167,0.000090047}, {168,0.000056872}, {169,0.000037915}, {170,0.000037915}, {171,0.000066351}, {172,0.000075829}, {173,0.000056872}, {174,0.000000000}, {175,0.000056872}, {176,0.000037915}, {177,0.000052133}, {178,0.000066351}, {179,0.000075829}, {180,0.000094787}, {181,0.000037915}, {182,0.000056872}, {183,0.000018957}, {184,0.000037915}, {185,0.000075829}, {186,0.000018957}, {187,0.000014218}, {188,0.000056872}, {189,0.000056872}, {190,0.000037915}, {191,0.000094787}, {192,0.000075829}, {193,0.000000000}, {194,0.000056872}, {195,0.000056872}, {196,0.000037915}, {197,0.000056872}, {198,0.000037915}, {199,0.000113744}, {200,0.000037915}, {201,0.000056872}, {202,0.000033175}, {203,0.000014218}, {204,0.000018957}, {205,0.000075829}, {206,0.000094787}, {207,0.000000000}, {208,0.000075829}, {209,0.000018957}, {210,0.000037915}, {211,0.000056872}, {212,0.000018957}, {213,0.000109005}, {214,0.000033175}, {215,0.000056872}, {216,0.000094787}, {217,0.000075829}, {218,0.000132701}, {219,0.000037915}, {220,0.000037915}, {221,0.000018957}, {222,0.000018957}, {223,0.000018957}, {224,0.000085308}, {225,0.000075829}, {226,0.000018957}, {227,0.000037915}, {228,0.000071090}, {229,0.000037915}, {230,0.000018957}, {231,0.000018957}, {232,0.000056872}, {233,0.000000000}, {234,0.000094787}, {235,0.000056872}, {236,0.000094787}, {237,0.000037915}, {238,0.000037915}, {239,0.000052133}, {240,0.000056872}, {241,0.000018957}, {242,0.000000000}, {243,0.000094787}, {244,0.000018957}, {245,0.000056872}, {246,0.000037915}, {247,0.000018957}, {248,0.000037915}, {249,0.000018957}, {250,0.000037915}, {251,0.000056872}, {252,0.000075829}, {253,0.000056872}, {254,0.000056872}, {255,0.000075829}, {256,0.000018957}, {257,0.000037915}, {258,0.000056872}, {259,0.000056872}, {260,0.000018957}, {261,0.000000000}, {262,0.000033175}, {263,0.000000000}, {264,0.000056872}, {265,0.000000000}, {266,0.000033175}, {267,0.000037915}, {268,0.000037915}, {269,0.000056872}, {270,0.000000000}, {271,0.000000000}, {272,0.000075829}, {273,0.000018957}, {274,0.000018957}, {275,0.000113744}, {276,0.000094787}, {277,0.000033175}, {278,0.000094787}, {279,0.000018957}, {280,0.000094787}, {281,0.000018957}, {282,0.000018957}, {283,0.000037915}, {284,0.000033175}, {285,0.000000000}, {286,0.000037915}, {287,0.000075829}, {288,0.000018957}, {289,0.000018957}, {290,0.000037915}, {291,0.000037915}, {292,0.000018957}, {293,0.000075829}, {294,0.000071090}, {295,0.000109005}, {296,0.000018957}, {297,0.000037915}, {298,0.000056872}, {299,0.000056872}, {300,0.000037915}, {301,0.000037915}, {302,0.000094787}, {303,0.000056872}, {304,0.000014218}, {305,0.000037915}, {306,0.000037915}, {307,0.000071090}, {308,0.000056872}, {309,0.000018957}, {310,0.000018957}, {311,0.000037915}, {312,0.000075829}, {313,0.000056872}, {314,0.000000000}, {315,0.000056872}, {316,0.000094787}, {317,0.000075829}, {318,0.000075829}, {319,0.000052133}, {320,0.000071090}, {321,0.000018957}, {322,0.000037915}, {323,0.000109005}, {324,0.000018957}, {325,0.000075829}, {326,0.000109005}, {327,0.000018957}, {328,0.000113744}, {329,0.000037915}, {330,0.000018957}, {331,0.000056872}, {332,0.000056872}, {333,0.000037915}, {334,0.000075829}, {335,0.000000000}, {336,0.000056872}, {337,0.000037915}, {338,0.000094787}, {339,0.000075829}, {340,0.000056872}, {341,0.000071090}, {342,0.000113744}, {343,0.000018957}, {344,0.000094787}, {345,0.000056872}, {346,0.000037915}, {347,0.000033175}, {348,0.000056872}, {349,0.000018957}, {350,0.000037915}, {351,0.000056872}, {352,0.000052133}, {353,0.000018957}, {354,0.000056872}, {355,0.000052133}, {356,0.000018957}, {357,0.000075829}, {358,0.000075829}, {359,0.000056872}, {360,0.000075829}, {361,0.000075829}, {362,0.000018957}, {363,0.000018957}, {364,0.000018957}, {365,0.000056872}, {366,0.000028436}, {367,0.000018957}, {368,0.000056872}, {369,0.000018957}, {370,0.000018957}, {371,0.000090047}, {372,0.000056872}, {373,0.000037915}, {374,0.000018957}, {375,0.000090047}, {376,0.000056872}, {377,0.000037915}, {378,0.000094787}, {379,0.000075829}, {380,0.000056872}, {381,0.000037915}, {382,0.000056872}, {383,0.000090047}, {384,0.000037915}, {385,0.000018957}, {386,0.000000000}, {387,0.000018957}, {388,0.000113744}, {389,0.000018957}, {390,0.000052133}, {391,0.000075829}, {392,0.000056872}, {393,0.000037915}, {394,0.000113744}, {395,0.000104265}, {396,0.000113744}, {397,0.000056872}, {398,0.000094787}, {399,0.000056872}, {400,0.000018957}, {401,0.000037915}, {402,0.000052133}, {403,0.000056872}, {404,0.000056872}, {405,0.000056872}, {406,0.000094787}, {407,0.000056872}, {408,0.000052133}, {409,0.000037915}, {410,0.000075829}, {411,0.000037915}, {412,0.000037915}, {413,0.000018957}, {414,0.000090047}, {415,0.000094787}, {416,0.000075829}, {417,0.000000000}, {418,0.000056872}, {419,0.000056872}, {420,0.000000000}, {421,0.000018957}, {422,0.000056872}, {423,0.000056872}, {424,0.000113744}, {425,0.000037915}, {426,0.000056872}, {427,0.000170616}, {428,0.000018957}, {429,0.000075829}, {430,0.000056872}, {431,0.000033175}, {432,0.000056872}, {433,0.000033175}, {434,0.000018957}, {435,0.000075829}, {436,0.000109005}, {437,0.000094787}, {438,0.000071090}, {439,0.000090047}, {440,0.000075829}, {441,0.000094787}, {442,0.000052133}, {443,0.000056872}, {444,0.000037915}, {445,0.000037915}, {446,0.000000000}, {447,0.000037915}, {448,0.000075829}, {449,0.000056872}, {450,0.000018957}, {451,0.000037915}, {452,0.000037915}, {453,0.000052133}, {454,0.000075829}, {455,0.000018957}, {456,0.000000000}, {457,0.000056872}, {458,0.000056872}, {459,0.000018957}, {460,0.000075829}, {461,0.000094787}, {462,0.000094787}, {463,0.000037915}, {464,0.000075829}, {465,0.000037915}, {466,0.000056872}, {467,0.000056872}, {468,0.000052133}, {469,0.000094787}, {470,0.000094787}, {471,0.000018957}, {472,0.000037915}, {473,0.000056872}, {474,0.000109005}, {475,0.000052133}, {476,0.000052133}, {477,0.000066351}, {478,0.000094787}, {479,0.000056872}, {480,0.000037915}, {481,0.000037915}, {482,0.000090047}, {483,0.000075829}, {484,0.000018957}, {485,0.000014218}, {486,0.000056872}, {487,0.000094787}, {488,0.000037915}, {489,0.000075829}, {490,0.000075829}, {491,0.000037915}, {492,0.000170616}, {493,0.000075829}, {494,0.000000000}, {495,0.000037915}, {496,0.000018957}, {497,0.000037915}, {498,0.000056872}, {499,0.000037915}, {500,0.000037915}, {505,0.000018957}, {510,0.000056872}, {515,0.000056872}, {520,0.000018957}, {525,0.000094787}, {530,0.000037915}, {535,0.000037915}, {540,0.000056872}, {545,0.000066351}, {550,0.000113744}, {555,0.000075829}, {560,0.000071090}, {565,0.000113744}, {570,0.000052133}, {575,0.000075829}, {580,0.000075829}, {585,0.000037915}, {590,0.000075829}, {595,0.000075829}, {600,0.000056872}, {605,0.000094787}, {610,0.000075829}, {615,0.000037915}, {620,0.000094787}, {625,0.000056872}, {630,0.000075829}, {635,0.000113744}, {640,0.000104265}, {645,0.000056872}, {650,0.000090047}, {655,0.000056872}, {660,0.000075829}, {665,0.000075829}, {670,0.000033175}, {675,0.000132701}, {680,0.000014218}, {685,0.000037915}, {690,0.000075829}, {695,0.000113744}, {700,0.000109005}, {705,0.000132701}, {710,0.000151659}, {715,0.000037915}, {720,0.000094787}, {725,0.000075829}, {730,0.000090047}, {735,0.000094787}, {740,0.000033175}, {745,0.000071090}, {750,0.000037915}, {755,0.000090047}, {760,0.000090047}, {765,0.000056872}, {770,0.000047393}, {775,0.000056872}, {780,0.000151659}, {785,0.000189573}, {790,0.000094787}, {795,0.000000000}, {800,0.000113744}, {805,0.000071090}, {810,0.000037915}, {815,0.000056872}, {820,0.000113744}, {825,0.000052133}, {830,0.000056872}, {835,0.000052133}, {840,0.000052133}, {845,0.000113744}, {850,0.000075829}, {855,0.000037915}, {860,0.000018957}, {865,0.000113744}, {870,0.000056872}, {875,0.000018957}, {880,0.000094787}, {885,0.000075829}, {890,0.000094787}, {895,0.000056872}, {900,0.000037915}, {905,0.000109005}, {910,0.000052133}, {915,0.000066351}, {920,0.000109005}, {925,0.000033175}, {930,0.000109005}, {935,0.000000000}, {940,0.000056872}, {945,0.000018957}, {950,0.000018957}, {955,0.000037915}, {960,0.000075829}, {965,0.000000000}, {970,0.000075829}, {975,0.000113744}, {980,0.000113744}, {985,0.000094787}, {990,0.000014218}, {995,0.000113744}, {1000,0.000109005}, {1010,0.000075829}, {1020,0.000037915}, {1030,0.000056872}, {1040,0.000056872}, {1050,0.000037915}, {1060,0.000113744}, {1070,0.000109005}, {1080,0.000075829}, {1090,0.000056872}, {1100,0.000075829}, {1110,0.000056872}, {1120,0.000075829}, {1130,0.000056872}, {1140,0.000094787}, {1150,0.000018957}, {1160,0.000094787}, {1170,0.000037915}, {1180,0.000094787}, {1190,0.000146919}, {1200,0.000075829}, {1210,0.000151659}, {1220,0.000151659}, {1230,0.000109005}, {1240,0.000037915}, {1250,0.000014218}, {1260,0.000142180}, {1270,0.000056872}, {1280,0.000075829}, {1290,0.000056872}, {1300,0.000056872}, {1310,0.000090047}, {1320,0.000075829}, {1330,0.000071090}, {1340,0.000052133}, {1350,0.000132701}, {1360,0.000189573}, {1370,0.000056872}, {1380,0.000113744}, {1390,0.000109005}, {1400,0.000056872}, {1410,0.000075829}, {1420,0.000113744}, {1430,0.000094787}, {1440,0.000132701}, {1450,0.000056872}, {1460,0.000037915}, {1470,0.000151659}, {1480,0.000132701}, {1490,0.000151659}, {1500,0.000075829}, {1510,0.000090047}, {1520,0.000075829}, {1530,0.000018957}, {1540,0.000037915}, {1550,0.000071090}, {1560,0.000056872}, {1570,0.000146919}, {1580,0.000099526}, {1590,0.000037915}, {1600,0.000109005}, {1610,0.000018957}, {1620,0.000151659}, {1630,0.000227488}, {1640,0.000056872}, {1650,0.000184834}, {1660,0.000113744}, {1670,0.000132701}, {1680,0.000075829}, {1690,0.000151659}, {1700,0.000109005}, {1710,0.000189573}, {1720,0.000113744}, {1730,0.000109005}, {1740,0.000071090}, {1750,0.000094787}, {1760,0.000113744}, {1770,0.000075829}, {1780,0.000113744}, {1790,0.000056872}, {1800,0.000113744}, {1810,0.000127962}, {1820,0.000075829}, {1830,0.000094787}, {1840,0.000218009}, {1850,0.000037915}, {1860,0.000056872}, {1870,0.000109005}, {1880,0.000132701}, {1890,0.000113744}, {1900,0.000094787}, {1910,0.000184834}, {1920,0.000109005}, {1930,0.000151659}, {1940,0.000075829}, {1950,0.000094787}, {1960,0.000056872}, {1970,0.000146919}, {1980,0.000208531}, {1990,0.000127962}, {2000,0.000184834}, {2050,0.000033175}, {2100,0.000109005}, {2150,0.000113744}, {2200,0.000227488}, {2250,0.000113744}, {2300,0.000113744}, {2350,0.000165877}, {2400,0.000056872}, {2450,0.000109005}, {2500,0.000094787}, {2550,0.000056872}, {2600,0.000170616}, {2650,0.000071090}, {2700,0.000127962}, {2750,0.000170616}, {2800,0.000151659}, {2850,0.000260664}, {2900,0.000170616}, {2950,0.000189573}, {3000,0.000132701}, {3050,0.000052133}, {3100,0.000075829}, {3150,0.000184834}, {3200,0.000018957}, {3250,0.000094787}, {3300,0.000165877}, {3350,0.000189573}, {3400,0.000132701}, {3450,0.000132701}, {3500,0.000061611}, {3550,0.000132701}, {3600,0.000037915}, {3650,0.000090047}, {3700,0.000170616}, {3750,0.000151659}, {3800,0.000222749}, {3850,0.000170616}, {3900,0.000208531}, {3950,0.000113744}, {4000,0.000241706}, {4050,0.000189573}, {4100,0.000170616}, {4150,0.000090047}, {4200,0.000293839}, {4250,0.000222749}, {4300,0.000227488}, {4350,0.000203791}, {4400,0.000052133}, {4450,0.000113744}, {4500,0.000094787}, {4550,0.000189573}, {4600,0.000241706}, {4650,0.000165877}, {4700,0.000151659}, {4750,0.000222749}, {4800,0.000189573}, {4850,0.000127962}, {4900,0.000113744}, {4950,0.000142180}, {5000,0.000094787}, {5050,0.00057}, {5100,0.00057}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00229}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00114}, {5700,0.00057}, {5750,0.00000}, {5800,0.00057}, {5850,0.00057}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00057}, {6150,0.00057}, {6200,0.00000}, {6250,0.00100}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00057}, {6500,0.00157}, {6550,0.00114}, {6600,0.00000}, {6650,0.00057}, {6700,0.00114}, {6750,0.00000}, {6800,0.00043}, {6850,0.00057}, {6900,0.00100}, {6950,0.00057}, {7000,0.00114}, {7050,0.00114}, {7100,0.00000}, {7150,0.00114}, {7200,0.00000}, {7250,0.00057}, {7300,0.00057}, {7350,0.00214}, {7400,0.00057}, {7450,0.00000}, {7500,0.00114}, {7550,0.00057}, {7600,0.00057}, {7650,0.00100}, {7700,0.00057}, {7750,0.00171}, {7800,0.00286}, {7850,0.00100}, {7900,0.00114}, {7950,0.00057}, {8000,0.00057}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00229}, {8400,0.00057}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00043}, {8650,0.00057}, {8700,0.00057}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00100}, {9050,0.00000}, {9100,0.00114}, {9150,0.00114}, {9200,0.00057}, {9250,0.00000}, {9300,0.00057}, {9350,0.00114}, {9400,0.00000}, {9450,0.00000}, {9500,0.00057}, {9550,0.00043}, {9600,0.00000}, {9650,0.00057}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00057}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00057}, {10200,0.00000}, {10300,0.00057}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00057}, {10800,0.00057}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00057}, {11400,0.00000}, {11500,0.00000}, {11600,0.00043}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00043}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00057}, {13300,0.00000}, {13400,0.00114}, {13500,0.00000}, {13600,0.00057}, {13700,0.00057}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00057}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00057}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00057}, {16600,0.00000}, {16700,0.00043}, {16800,0.00000}, {16900,0.00057}, {17000,0.00000}, {17100,0.00000}, {17200,0.00057}, {17300,0.00057}, {17400,0.00000}, {17500,0.00057}, {17600,0.00057}, {17700,0.00000}, {17800,0.00114}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00057}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00057}, {19100,0.00000}, {19200,0.00000}, {19300,0.00171}, {19400,0.00000}, {19500,0.00000}, {19600,0.00057}, {19700,0.00000}, {19800,0.00000}, {19900,0.00057}, {20000,0.00000}};
data["big_flat"]["beta; Parametricity"]["actual reif"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000488152}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000521327}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000004739}, {101,0.000000000}, {102,0.000000000}, {103,0.000004739}, {104,0.000009479}, {105,0.000014218}, {106,0.000023697}, {107,0.000028436}, {108,0.000033175}, {109,0.000037915}, {110,0.000037915}, {111,0.000056872}, {112,0.000090047}, {113,0.000099526}, {114,0.000213270}, {115,0.000289100}, {116,0.000355450}, {117,0.000436019}, {118,0.000507109}, {119,0.000554502}, {120,0.000597156}, {121,0.000630332}, {122,0.000682464}, {123,0.000725118}, {124,0.000777251}, {125,0.001246445}, {126,0.000943128}, {127,0.000947867}, {128,0.000971564}, {129,0.000981043}, {130,0.000995261}, {131,0.000990521}, {132,0.001000000}, {133,0.001000000}, {134,0.001000000}, {135,0.001000000}, {136,0.001000000}, {137,0.001000000}, {138,0.001000000}, {139,0.001000000}, {140,0.001000000}, {141,0.001000000}, {142,0.001000000}, {143,0.001000000}, {144,0.001000000}, {145,0.001000000}, {146,0.001000000}, {147,0.001000000}, {148,0.001000000}, {149,0.001000000}, {150,0.001009479}, {151,0.001000000}, {152,0.001000000}, {153,0.001000000}, {154,0.001000000}, {155,0.001000000}, {156,0.001000000}, {157,0.001000000}, {158,0.001000000}, {159,0.001000000}, {160,0.001000000}, {161,0.001000000}, {162,0.001000000}, {163,0.001000000}, {164,0.001000000}, {165,0.001000000}, {166,0.001000000}, {167,0.001000000}, {168,0.001000000}, {169,0.001000000}, {170,0.001000000}, {171,0.001473934}, {172,0.001000000}, {173,0.001000000}, {174,0.001000000}, {175,0.001000000}, {176,0.001000000}, {177,0.001000000}, {178,0.001000000}, {179,0.001000000}, {180,0.001000000}, {181,0.001000000}, {182,0.001000000}, {183,0.001000000}, {184,0.001000000}, {185,0.001000000}, {186,0.001000000}, {187,0.001000000}, {188,0.001000000}, {189,0.001000000}, {190,0.001000000}, {191,0.001478673}, {192,0.001000000}, {193,0.001000000}, {194,0.001000000}, {195,0.001000000}, {196,0.001000000}, {197,0.001000000}, {198,0.001000000}, {199,0.001000000}, {200,0.001000000}, {201,0.001000000}, {202,0.001000000}, {203,0.001000000}, {204,0.001000000}, {205,0.001000000}, {206,0.001000000}, {207,0.001000000}, {208,0.001000000}, {209,0.001000000}, {210,0.001000000}, {211,0.001000000}, {212,0.001000000}, {213,0.001000000}, {214,0.001000000}, {215,0.001000000}, {216,0.001511848}, {217,0.001000000}, {218,0.001000000}, {219,0.001000000}, {220,0.001000000}, {221,0.001000000}, {222,0.001000000}, {223,0.001000000}, {224,0.001000000}, {225,0.001000000}, {226,0.001000000}, {227,0.001000000}, {228,0.001000000}, {229,0.001000000}, {230,0.001000000}, {231,0.001000000}, {232,0.001000000}, {233,0.001000000}, {234,0.001000000}, {235,0.001000000}, {236,0.001000000}, {237,0.001000000}, {238,0.001000000}, {239,0.001000000}, {240,0.001000000}, {241,0.001000000}, {242,0.001000000}, {243,0.001000000}, {244,0.001000000}, {245,0.001000000}, {246,0.001000000}, {247,0.001000000}, {248,0.001000000}, {249,0.001000000}, {250,0.001000000}, {251,0.001000000}, {252,0.001004739}, {253,0.001000000}, {254,0.001000000}, {255,0.001000000}, {256,0.001014218}, {257,0.001004739}, {258,0.001488152}, {259,0.001009479}, {260,0.001000000}, {261,0.001004739}, {262,0.001028436}, {263,0.001014218}, {264,0.001028436}, {265,0.001042654}, {266,0.001033175}, {267,0.001047393}, {268,0.001061611}, {269,0.001075829}, {270,0.001080569}, {271,0.001184834}, {272,0.001142180}, {273,0.001213270}, {274,0.001232227}, {275,0.001279621}, {276,0.001350711}, {277,0.001388626}, {278,0.001417062}, {279,0.001426540}, {280,0.001421801}, {281,0.001483412}, {282,0.001530806}, {283,0.001526066}, {284,0.001559242}, {285,0.001573460}, {286,0.001654028}, {287,0.001677725}, {288,0.001720379}, {289,0.001781991}, {290,0.001824645}, {291,0.001881517}, {292,0.001881517}, {293,0.001924171}, {294,0.001947867}, {295,0.001957346}, {296,0.001957346}, {297,0.001976303}, {298,0.001981043}, {299,0.001981043}, {300,0.002218009}, {301,0.001985782}, {302,0.001995261}, {303,0.002000000}, {304,0.002000000}, {305,0.002000000}, {306,0.002000000}, {307,0.002000000}, {308,0.002000000}, {309,0.002000000}, {310,0.002000000}, {311,0.002000000}, {312,0.002000000}, {313,0.002293839}, {314,0.002000000}, {315,0.002000000}, {316,0.002000000}, {317,0.002000000}, {318,0.002000000}, {319,0.002000000}, {320,0.002000000}, {321,0.002000000}, {322,0.002000000}, {323,0.002000000}, {324,0.002000000}, {325,0.002009479}, {326,0.002000000}, {327,0.002000000}, {328,0.002000000}, {329,0.002000000}, {330,0.002000000}, {331,0.002000000}, {332,0.002000000}, {333,0.002000000}, {334,0.002000000}, {335,0.002000000}, {336,0.002000000}, {337,0.002000000}, {338,0.002000000}, {339,0.002000000}, {340,0.002000000}, {341,0.002000000}, {342,0.002000000}, {343,0.002000000}, {344,0.002000000}, {345,0.002000000}, {346,0.002000000}, {347,0.002000000}, {348,0.002000000}, {349,0.002009479}, {350,0.002000000}, {351,0.002000000}, {352,0.002000000}, {353,0.002000000}, {354,0.002000000}, {355,0.002000000}, {356,0.002000000}, {357,0.002000000}, {358,0.002000000}, {359,0.002000000}, {360,0.002000000}, {361,0.002000000}, {362,0.002000000}, {363,0.002000000}, {364,0.002000000}, {365,0.002000000}, {366,0.002000000}, {367,0.002000000}, {368,0.002000000}, {369,0.002000000}, {370,0.002000000}, {371,0.002000000}, {372,0.002000000}, {373,0.002000000}, {374,0.002018957}, {375,0.002000000}, {376,0.002000000}, {377,0.002000000}, {378,0.002000000}, {379,0.002000000}, {380,0.002000000}, {381,0.002000000}, {382,0.002018957}, {383,0.002000000}, {384,0.002000000}, {385,0.002000000}, {386,0.002635071}, {387,0.002000000}, {388,0.002000000}, {389,0.002000000}, {390,0.002000000}, {391,0.002000000}, {392,0.002000000}, {393,0.002478673}, {394,0.002000000}, {395,0.002000000}, {396,0.002000000}, {397,0.002000000}, {398,0.002000000}, {399,0.002000000}, {400,0.002000000}, {401,0.002004739}, {402,0.002000000}, {403,0.002023697}, {404,0.002000000}, {405,0.002000000}, {406,0.002009479}, {407,0.002000000}, {408,0.002000000}, {409,0.002004739}, {410,0.002000000}, {411,0.002000000}, {412,0.002004739}, {413,0.002018957}, {414,0.002000000}, {415,0.002009479}, {416,0.002014218}, {417,0.002018957}, {418,0.002033175}, {419,0.002009479}, {420,0.002004739}, {421,0.002023697}, {422,0.002018957}, {423,0.002047393}, {424,0.002037915}, {425,0.002047393}, {426,0.002052133}, {427,0.002090047}, {428,0.002113744}, {429,0.002104265}, {430,0.002146919}, {431,0.002132701}, {432,0.002161137}, {433,0.003000000}, {434,0.002199052}, {435,0.002180095}, {436,0.003014218}, {437,0.002255924}, {438,0.002289100}, {439,0.002303318}, {440,0.002393365}, {441,0.002393365}, {442,0.002450237}, {443,0.002445498}, {444,0.002431280}, {445,0.002492891}, {446,0.002540284}, {447,0.002521327}, {448,0.002587678}, {449,0.002606635}, {450,0.002687204}, {451,0.002649289}, {452,0.003037915}, {453,0.002715640}, {454,0.002725118}, {455,0.002824645}, {456,0.002829384}, {457,0.002867299}, {458,0.002900474}, {459,0.002919431}, {460,0.002914692}, {461,0.003412322}, {462,0.002933649}, {463,0.002947867}, {464,0.003431280}, {465,0.002962085}, {466,0.002957346}, {467,0.002976303}, {468,0.002976303}, {469,0.002985782}, {470,0.003473934}, {471,0.002985782}, {472,0.003000000}, {473,0.003000000}, {474,0.003000000}, {475,0.003000000}, {476,0.003000000}, {477,0.003000000}, {478,0.003000000}, {479,0.003445498}, {480,0.003000000}, {481,0.003000000}, {482,0.003000000}, {483,0.003000000}, {484,0.003000000}, {485,0.003000000}, {486,0.003000000}, {487,0.003018957}, {488,0.003000000}, {489,0.003000000}, {490,0.003516588}, {491,0.003000000}, {492,0.003000000}, {493,0.003000000}, {494,0.003000000}, {495,0.003000000}, {496,0.003540284}, {497,0.003000000}, {498,0.003000000}, {499,0.003000000}, {500,0.003000000}, {505,0.003000000}, {510,0.003000000}, {515,0.003000000}, {520,0.003009479}, {525,0.003000000}, {530,0.003000000}, {535,0.003516588}, {540,0.003000000}, {545,0.003000000}, {550,0.003004739}, {555,0.003000000}, {560,0.003004739}, {565,0.003023697}, {570,0.003009479}, {575,0.003033175}, {580,0.003042654}, {585,0.003118483}, {590,0.003161137}, {595,0.003303318}, {600,0.003327014}, {605,0.003431280}, {610,0.003559242}, {615,0.003654028}, {620,0.003815166}, {625,0.003909953}, {630,0.003962085}, {635,0.003938389}, {640,0.003990521}, {645,0.004000000}, {650,0.004000000}, {655,0.004000000}, {660,0.004000000}, {665,0.004000000}, {670,0.004000000}, {675,0.004905213}, {680,0.004000000}, {685,0.004000000}, {690,0.004000000}, {695,0.004047393}, {700,0.004018957}, {705,0.004009479}, {710,0.004000000}, {715,0.004018957}, {720,0.004047393}, {725,0.004075829}, {730,0.004075829}, {735,0.004113744}, {740,0.004151659}, {745,0.004203791}, {750,0.004227488}, {755,0.004317536}, {760,0.004402844}, {765,0.005440758}, {770,0.004502370}, {775,0.004616114}, {780,0.004696682}, {785,0.005857820}, {790,0.004886256}, {795,0.004919431}, {800,0.004938389}, {805,0.004966825}, {810,0.005014218}, {815,0.005004739}, {820,0.006364929}, {825,0.005018957}, {830,0.005009479}, {835,0.005009479}, {840,0.005706161}, {845,0.005028436}, {850,0.005028436}, {855,0.005047393}, {860,0.005042654}, {865,0.005914692}, {870,0.005099526}, {875,0.005104265}, {880,0.005175355}, {885,0.005165877}, {890,0.006137441}, {895,0.005236967}, {900,0.005298578}, {905,0.005303318}, {910,0.005383886}, {915,0.006298578}, {920,0.005502370}, {925,0.005530806}, {930,0.005582938}, {935,0.005611374}, {940,0.005701422}, {945,0.006710900}, {950,0.005872038}, {955,0.005900474}, {960,0.005933649}, {965,0.005947867}, {970,0.005971564}, {975,0.005966825}, {980,0.006052133}, {985,0.006905213}, {990,0.007919431}, {995,0.006047393}, {1000,0.006075829}, {1010,0.006137441}, {1020,0.006222749}, {1030,0.006222749}, {1040,0.006274882}, {1050,0.006327014}, {1060,0.006412322}, {1070,0.006374408}, {1080,0.006530806}, {1090,0.006635071}, {1100,0.006725118}, {1110,0.007900474}, {1120,0.006962085}, {1130,0.007033175}, {1140,0.007113744}, {1150,0.007990521}, {1160,0.007260664}, {1170,0.007293839}, {1180,0.007369668}, {1190,0.007374408}, {1200,0.007478673}, {1210,0.007559242}, {1220,0.007606635}, {1230,0.007677725}, {1240,0.007696682}, {1250,0.008962085}, {1260,0.009203791}, {1270,0.008009479}, {1280,0.008161137}, {1290,0.008227488}, {1300,0.008279621}, {1310,0.008383886}, {1320,0.009312796}, {1330,0.009559242}, {1340,0.008521327}, {1350,0.008658768}, {1360,0.008663507}, {1370,0.008767773}, {1380,0.008786730}, {1390,0.008819905}, {1400,0.008947867}, {1410,0.009075829}, {1420,0.009966825}, {1430,0.009255924}, {1440,0.009360190}, {1450,0.010573460}, {1460,0.009497630}, {1470,0.009587678}, {1480,0.010767773}, {1490,0.011056872}, {1500,0.009734597}, {1510,0.011189573}, {1520,0.010772512}, {1530,0.009966825}, {1540,0.011317536}, {1550,0.010037915}, {1560,0.010199052}, {1570,0.012853081}, {1580,0.010284360}, {1590,0.010497630}, {1600,0.010611374}, {1610,0.010616114}, {1620,0.010691943}, {1630,0.010767773}, {1640,0.010872038}, {1650,0.010938389}, {1660,0.012701422}, {1670,0.011085308}, {1680,0.012398104}, {1690,0.011137441}, {1700,0.011246445}, {1710,0.011317536}, {1720,0.011383886}, {1730,0.011563981}, {1740,0.013094787}, {1750,0.011725118}, {1760,0.013331754}, {1770,0.011796209}, {1780,0.011900474}, {1790,0.013668246}, {1800,0.012042654}, {1810,0.014208531}, {1820,0.012142180}, {1830,0.012284360}, {1840,0.013938389}, {1850,0.012426540}, {1860,0.014582938}, {1870,0.012554502}, {1880,0.012739336}, {1890,0.014047393}, {1900,0.012872038}, {1910,0.012881517}, {1920,0.013018957}, {1930,0.015213270}, {1940,0.013104265}, {1950,0.013236967}, {1960,0.015909953}, {1970,0.013298578}, {1980,0.013279621}, {1990,0.013516588}, {2000,0.015341232}, {2050,0.013909953}, {2100,0.014341232}, {2150,0.016099526}, {2200,0.015180095}, {2250,0.017232227}, {2300,0.015895735}, {2350,0.017938389}, {2400,0.016682464}, {2450,0.016734597}, {2500,0.019696682}, {2550,0.017848341}, {2600,0.019687204}, {2650,0.018635071}, {2700,0.021327014}, {2750,0.019516588}, {2800,0.019748815}, {2850,0.022218009}, {2900,0.020630332}, {2950,0.023090047}, {3000,0.023777251}, {3050,0.021777251}, {3100,0.024521327}, {3150,0.026611374}, {3200,0.022938389}, {3250,0.025772512}, {3300,0.025521327}, {3350,0.024123223}, {3400,0.024450237}, {3450,0.029208531}, {3500,0.029848341}, {3550,0.025753555}, {3600,0.026023697}, {3650,0.030028436}, {3700,0.032255924}, {3750,0.030056872}, {3800,0.027710900}, {3850,0.027957346}, {3900,0.027412322}, {3950,0.030635071}, {4000,0.036810427}, {4050,0.032047393}, {4100,0.033739336}, {4150,0.030255924}, {4200,0.030777251}, {4250,0.031009479}, {4300,0.031459716}, {4350,0.031767773}, {4400,0.035772512}, {4450,0.035047393}, {4500,0.036118483}, {4550,0.036739336}, {4600,0.037000000}, {4650,0.037502370}, {4700,0.038104265}, {4750,0.037995261}, {4800,0.037763033}, {4850,0.037270142}, {4900,0.036094787}, {4950,0.036559242}, {5000,0.036981043}, {5050,0.06371}, {5100,0.04029}, {5150,0.03886}, {5200,0.03900}, {5250,0.03757}, {5300,0.04300}, {5350,0.04443}, {5400,0.04643}, {5450,0.04386}, {5500,0.04171}, {5550,0.03957}, {5600,0.04371}, {5650,0.04714}, {5700,0.04586}, {5750,0.04286}, {5800,0.04600}, {5850,0.04729}, {5900,0.04786}, {5950,0.04186}, {6000,0.04986}, {6050,0.05186}, {6100,0.04800}, {6150,0.04871}, {6200,0.05314}, {6250,0.04686}, {6300,0.04943}, {6350,0.05457}, {6400,0.04729}, {6450,0.05214}, {6500,0.05157}, {6550,0.05243}, {6600,0.05986}, {6650,0.04771}, {6700,0.06171}, {6750,0.05057}, {6800,0.05529}, {6850,0.05300}, {6900,0.05686}, {6950,0.05314}, {7000,0.05771}, {7050,0.05543}, {7100,0.05814}, {7150,0.05529}, {7200,0.06214}, {7250,0.05086}, {7300,0.06214}, {7350,0.05843}, {7400,0.05871}, {7450,0.06100}, {7500,0.05786}, {7550,0.06571}, {7600,0.06414}, {7650,0.05886}, {7700,0.06743}, {7750,0.06357}, {7800,0.06000}, {7850,0.06786}, {7900,0.06657}, {7950,0.06214}, {8000,0.06957}, {8050,0.06943}, {8100,0.06257}, {8150,0.06157}, {8200,0.07029}, {8250,0.07157}, {8300,0.06671}, {8350,0.06657}, {8400,0.06743}, {8450,0.07286}, {8500,0.07329}, {8550,0.06971}, {8600,0.07000}, {8650,0.06571}, {8700,0.07171}, {8750,0.07443}, {8800,0.07600}, {8850,0.07457}, {8900,0.07500}, {8950,0.07871}, {9000,0.07300}, {9050,0.07300}, {9100,0.07486}, {9150,0.07471}, {9200,0.07500}, {9250,0.07486}, {9300,0.07614}, {9350,0.07529}, {9400,0.07743}, {9450,0.07757}, {9500,0.07800}, {9550,0.07586}, {9600,0.08200}, {9650,0.08300}, {9700,0.08129}, {9750,0.08314}, {9800,0.08471}, {9850,0.08629}, {9900,0.07929}, {9950,0.08286}, {10000,0.08214}, {10100,0.08414}, {10200,0.08557}, {10300,0.08500}, {10400,0.08686}, {10500,0.08557}, {10600,0.08857}, {10700,0.49114}, {10800,0.09486}, {10900,0.08843}, {11000,0.09186}, {11100,0.09043}, {11200,0.09343}, {11300,0.09257}, {11400,0.09386}, {11500,0.09514}, {11600,0.09529}, {11700,0.09329}, {11800,0.09643}, {11900,0.10171}, {12000,0.09814}, {12100,0.10414}, {12200,0.10543}, {12300,0.10271}, {12400,0.10286}, {12500,0.10443}, {12600,0.10400}, {12700,0.10786}, {12800,0.11043}, {12900,0.10771}, {13000,0.10771}, {13100,0.11243}, {13200,0.11186}, {13300,0.11443}, {13400,0.11057}, {13500,0.11257}, {13600,0.10957}, {13700,0.11057}, {13800,0.10943}, {13900,0.11414}, {14000,0.11471}, {14100,0.11629}, {14200,0.11129}, {14300,0.11800}, {14400,0.11786}, {14500,0.11986}, {14600,0.12443}, {14700,0.11586}, {14800,0.12257}, {14900,0.12243}, {15000,0.12243}, {15100,0.12814}, {15200,0.12357}, {15300,0.12143}, {15400,0.13057}, {15500,0.13329}, {15600,0.13029}, {15700,0.13286}, {15800,0.13486}, {15900,0.12971}, {16000,0.13857}, {16100,0.13200}, {16200,0.13814}, {16300,0.13186}, {16400,0.14214}, {16500,0.13386}, {16600,0.14329}, {16700,0.13500}, {16800,0.14100}, {16900,0.14957}, {17000,0.13600}, {17100,0.14943}, {17200,0.15657}, {17300,0.13957}, {17400,0.14329}, {17500,0.14914}, {17600,0.14643}, {17700,0.13929}, {17800,0.13857}, {17900,0.15400}, {18000,0.15457}, {18100,0.16357}, {18200,0.15443}, {18300,0.14957}, {18400,0.14571}, {18500,0.14200}, {18600,0.14200}, {18700,0.14314}, {18800,0.14371}, {18900,0.14829}, {19000,0.15814}, {19100,0.16729}, {19200,0.17271}, {19300,0.17114}, {19400,0.16386}, {19500,0.15043}, {19600,0.15243}, {19700,0.16957}, {19800,0.17371}, {19900,0.16200}, {20000,0.15360}};
data["big_flat"]["beta; Parametricity"]["actual reif"]["user"] = {{1,0.000222749}, {2,0.000293839}, {3,0.000298578}, {4,0.000255924}, {5,0.000194313}, {6,0.000241706}, {7,0.000327014}, {8,0.000289100}, {9,0.000260664}, {10,0.000289100}, {11,0.000194313}, {12,0.000218009}, {13,0.000284360}, {14,0.000270142}, {15,0.000345972}, {16,0.000464455}, {17,0.000151659}, {18,0.000265403}, {19,0.000218009}, {20,0.000331754}, {21,0.000180095}, {22,0.000331754}, {23,0.000260664}, {24,0.000308057}, {25,0.000350711}, {26,0.000374408}, {27,0.000454976}, {28,0.000374408}, {29,0.000412322}, {30,0.000398104}, {31,0.000412322}, {32,0.000426540}, {33,0.000364929}, {34,0.000398104}, {35,0.000364929}, {36,0.000364929}, {37,0.000369668}, {38,0.000402844}, {39,0.000388626}, {40,0.000497630}, {41,0.000345972}, {42,0.000592417}, {43,0.000407583}, {44,0.000502370}, {45,0.000649289}, {46,0.000383886}, {47,0.000502370}, {48,0.000507109}, {49,0.000592417}, {50,0.000654028}, {51,0.000322275}, {52,0.000672986}, {53,0.000507109}, {54,0.000407583}, {55,0.000720379}, {56,0.000502370}, {57,0.000511848}, {58,0.000582938}, {59,0.000563981}, {60,0.000459716}, {61,0.000611374}, {62,0.001094787}, {63,0.000445498}, {64,0.000744076}, {65,0.000540284}, {66,0.000526066}, {67,0.000729858}, {68,0.000620853}, {69,0.000587678}, {70,0.000838863}, {71,0.000677725}, {72,0.000649289}, {73,0.000753555}, {74,0.000601896}, {75,0.000796209}, {76,0.000601896}, {77,0.000611374}, {78,0.000919431}, {79,0.000511848}, {80,0.001000000}, {81,0.000563981}, {82,0.000563981}, {83,0.000625592}, {84,0.000947867}, {85,0.000786730}, {86,0.000649289}, {87,0.000478673}, {88,0.000924171}, {89,0.000786730}, {90,0.000729858}, {91,0.000582938}, {92,0.000720379}, {93,0.000625592}, {94,0.000796209}, {95,0.000725118}, {96,0.000800948}, {97,0.000739336}, {98,0.000758294}, {99,0.000739336}, {100,0.000658768}, {101,0.000720379}, {102,0.000933649}, {103,0.000895735}, {104,0.000867299}, {105,0.000696682}, {106,0.000786730}, {107,0.000606635}, {108,0.000938389}, {109,0.000957346}, {110,0.000843602}, {111,0.001023697}, {112,0.000753555}, {113,0.000786730}, {114,0.000995261}, {115,0.000909953}, {116,0.000905213}, {117,0.001004739}, {118,0.000881517}, {119,0.000668246}, {120,0.000654028}, {121,0.000706161}, {122,0.000914692}, {123,0.001014218}, {124,0.001009479}, {125,0.001426540}, {126,0.000928910}, {127,0.000962085}, {128,0.000957346}, {129,0.001018957}, {130,0.001066351}, {131,0.000985782}, {132,0.000947867}, {133,0.000720379}, {134,0.000834123}, {135,0.000895735}, {136,0.000933649}, {137,0.000895735}, {138,0.001094787}, {139,0.001099526}, {140,0.001175355}, {141,0.001161137}, {142,0.001289100}, {143,0.001327014}, {144,0.001189573}, {145,0.001094787}, {146,0.001080569}, {147,0.001085308}, {148,0.001075829}, {149,0.001071090}, {150,0.000895735}, {151,0.000819905}, {152,0.000819905}, {153,0.000862559}, {154,0.000834123}, {155,0.000876777}, {156,0.001127962}, {157,0.001222749}, {158,0.001336493}, {159,0.001165877}, {160,0.001127962}, {161,0.001075829}, {162,0.001218009}, {163,0.001109005}, {164,0.001018957}, {165,0.001156398}, {166,0.001151659}, {167,0.001289100}, {168,0.001274882}, {169,0.001180095}, {170,0.000995261}, {171,0.001398104}, {172,0.001303318}, {173,0.001417062}, {174,0.001175355}, {175,0.001175355}, {176,0.001236967}, {177,0.001274882}, {178,0.001094787}, {179,0.001109005}, {180,0.001270142}, {181,0.001341232}, {182,0.001161137}, {183,0.001379147}, {184,0.001156398}, {185,0.001208531}, {186,0.001203791}, {187,0.001218009}, {188,0.001398104}, {189,0.001431280}, {190,0.001241706}, {191,0.001530806}, {192,0.001426540}, {193,0.001289100}, {194,0.001241706}, {195,0.001208531}, {196,0.001393365}, {197,0.001402844}, {198,0.001355450}, {199,0.001350711}, {200,0.001284360}, {201,0.001109005}, {202,0.001345972}, {203,0.001421801}, {204,0.001369668}, {205,0.001127962}, {206,0.001360190}, {207,0.001540284}, {208,0.001379147}, {209,0.001251185}, {210,0.001521327}, {211,0.001436019}, {212,0.001345972}, {213,0.001312796}, {214,0.001620853}, {215,0.001251185}, {216,0.001800948}, {217,0.001554502}, {218,0.001251185}, {219,0.001554502}, {220,0.001412322}, {221,0.001274882}, {222,0.001497630}, {223,0.001436019}, {224,0.001445498}, {225,0.001426540}, {226,0.001639810}, {227,0.001398104}, {228,0.001507109}, {229,0.001706161}, {230,0.001289100}, {231,0.001691943}, {232,0.001445498}, {233,0.001597156}, {234,0.001454976}, {235,0.001530806}, {236,0.001616114}, {237,0.001398104}, {238,0.001649289}, {239,0.001454976}, {240,0.001393365}, {241,0.001734597}, {242,0.001507109}, {243,0.001800948}, {244,0.001473934}, {245,0.001644550}, {246,0.001573460}, {247,0.001568720}, {248,0.001616114}, {249,0.001691943}, {250,0.001601896}, {251,0.001658768}, {252,0.001630332}, {253,0.001540284}, {254,0.001786730}, {255,0.001568720}, {256,0.001919431}, {257,0.001341232}, {258,0.002260664}, {259,0.001663507}, {260,0.001649289}, {261,0.001725118}, {262,0.001715640}, {263,0.001744076}, {264,0.001729858}, {265,0.001649289}, {266,0.001701422}, {267,0.001616114}, {268,0.001715640}, {269,0.001696682}, {270,0.001791469}, {271,0.001824645}, {272,0.001706161}, {273,0.001853081}, {274,0.001625592}, {275,0.001872038}, {276,0.001696682}, {277,0.001772512}, {278,0.001540284}, {279,0.001962085}, {280,0.001710900}, {281,0.001701422}, {282,0.001971564}, {283,0.001601896}, {284,0.001791469}, {285,0.001824645}, {286,0.001781991}, {287,0.001829384}, {288,0.001824645}, {289,0.001853081}, {290,0.001914692}, {291,0.001777251}, {292,0.001777251}, {293,0.001786730}, {294,0.001758294}, {295,0.001748815}, {296,0.001796209}, {297,0.001952607}, {298,0.001843602}, {299,0.001938389}, {300,0.002213270}, {301,0.001753555}, {302,0.001881517}, {303,0.001952607}, {304,0.001805687}, {305,0.001639810}, {306,0.002009479}, {307,0.001862559}, {308,0.001843602}, {309,0.001772512}, {310,0.002189573}, {311,0.001995261}, {312,0.001706161}, {313,0.002222749}, {314,0.001914692}, {315,0.002161137}, {316,0.001890995}, {317,0.001853081}, {318,0.001995261}, {319,0.002075829}, {320,0.001962085}, {321,0.001857820}, {322,0.002023697}, {323,0.002052133}, {324,0.002018957}, {325,0.001848341}, {326,0.001744076}, {327,0.002000000}, {328,0.002113744}, {329,0.002137441}, {330,0.002194313}, {331,0.001976303}, {332,0.002180095}, {333,0.001947867}, {334,0.001976303}, {335,0.002056872}, {336,0.002018957}, {337,0.002109005}, {338,0.002142180}, {339,0.002308057}, {340,0.002364929}, {341,0.002018957}, {342,0.001990521}, {343,0.002189573}, {344,0.002308057}, {345,0.002232227}, {346,0.002236967}, {347,0.002037915}, {348,0.002004739}, {349,0.002094787}, {350,0.002037915}, {351,0.002170616}, {352,0.002109005}, {353,0.001981043}, {354,0.002018957}, {355,0.001990521}, {356,0.002109005}, {357,0.002066351}, {358,0.002047393}, {359,0.002279621}, {360,0.002213270}, {361,0.002232227}, {362,0.002260664}, {363,0.002341232}, {364,0.002492891}, {365,0.002616114}, {366,0.002473934}, {367,0.002345972}, {368,0.002374408}, {369,0.002436019}, {370,0.002450237}, {371,0.002388626}, {372,0.002398104}, {373,0.002421801}, {374,0.002417062}, {375,0.002213270}, {376,0.002464455}, {377,0.002563981}, {378,0.002521327}, {379,0.002459716}, {380,0.002568720}, {381,0.002521327}, {382,0.002545024}, {383,0.002184834}, {384,0.002293839}, {385,0.002194313}, {386,0.002900474}, {387,0.002331754}, {388,0.002582938}, {389,0.002672986}, {390,0.002502370}, {391,0.002274882}, {392,0.002317536}, {393,0.002981043}, {394,0.002459716}, {395,0.002417062}, {396,0.002241706}, {397,0.002260664}, {398,0.002345972}, {399,0.002530806}, {400,0.002331754}, {401,0.002535545}, {402,0.002454976}, {403,0.002312796}, {404,0.002393365}, {405,0.002559242}, {406,0.002502370}, {407,0.002578199}, {408,0.002412322}, {409,0.002497630}, {410,0.002450237}, {411,0.002563981}, {412,0.002573460}, {413,0.002549763}, {414,0.002274882}, {415,0.002545024}, {416,0.002483412}, {417,0.002492891}, {418,0.002497630}, {419,0.002582938}, {420,0.002658768}, {421,0.002597156}, {422,0.002559242}, {423,0.002464455}, {424,0.002431280}, {425,0.002696682}, {426,0.002454976}, {427,0.002450237}, {428,0.002545024}, {429,0.002597156}, {430,0.002763033}, {431,0.002521327}, {432,0.002644550}, {433,0.003090047}, {434,0.002691943}, {435,0.002691943}, {436,0.003227488}, {437,0.002611374}, {438,0.002791469}, {439,0.002635071}, {440,0.002469194}, {441,0.002834123}, {442,0.002691943}, {443,0.002748815}, {444,0.002767773}, {445,0.002526066}, {446,0.002900474}, {447,0.002559242}, {448,0.002635071}, {449,0.002483412}, {450,0.002663507}, {451,0.002696682}, {452,0.003113744}, {453,0.002800948}, {454,0.002796209}, {455,0.002739336}, {456,0.002710900}, {457,0.002668246}, {458,0.002881517}, {459,0.002805687}, {460,0.002786730}, {461,0.003336493}, {462,0.002881517}, {463,0.002805687}, {464,0.003156398}, {465,0.002876777}, {466,0.002829384}, {467,0.002781991}, {468,0.002905213}, {469,0.002834123}, {470,0.003412322}, {471,0.002810427}, {472,0.002938389}, {473,0.002881517}, {474,0.002819905}, {475,0.002834123}, {476,0.002853081}, {477,0.002924171}, {478,0.002753555}, {479,0.003398104}, {480,0.002867299}, {481,0.002947867}, {482,0.002952607}, {483,0.002862559}, {484,0.002895735}, {485,0.003014218}, {486,0.002924171}, {487,0.002905213}, {488,0.002952607}, {489,0.003004739}, {490,0.003568720}, {491,0.002933649}, {492,0.002786730}, {493,0.002843602}, {494,0.002914692}, {495,0.002824645}, {496,0.003758294}, {497,0.002947867}, {498,0.002990521}, {499,0.003042654}, {500,0.003066351}, {505,0.003142180}, {510,0.002976303}, {515,0.002914692}, {520,0.003009479}, {525,0.003137441}, {530,0.003199052}, {535,0.003545024}, {540,0.003331754}, {545,0.003151659}, {550,0.003208531}, {555,0.003379147}, {560,0.003412322}, {565,0.003360190}, {570,0.003289100}, {575,0.003454976}, {580,0.003402844}, {585,0.003260664}, {590,0.003549763}, {595,0.003587678}, {600,0.003597156}, {605,0.003587678}, {610,0.003616114}, {615,0.003649289}, {620,0.003649289}, {625,0.003810427}, {630,0.003758294}, {635,0.003729858}, {640,0.003729858}, {645,0.003872038}, {650,0.003900474}, {655,0.003838863}, {660,0.003919431}, {665,0.004004739}, {670,0.003947867}, {675,0.004919431}, {680,0.004099526}, {685,0.004241706}, {690,0.004037915}, {695,0.004127962}, {700,0.004061611}, {705,0.004165877}, {710,0.004236967}, {715,0.004061611}, {720,0.004246445}, {725,0.004236967}, {730,0.004341232}, {735,0.004459716}, {740,0.004440758}, {745,0.004350711}, {750,0.004781991}, {755,0.004255924}, {760,0.004497630}, {765,0.005478673}, {770,0.004630332}, {775,0.004549763}, {780,0.004592417}, {785,0.005677725}, {790,0.004701422}, {795,0.004739336}, {800,0.004815166}, {805,0.004763033}, {810,0.004919431}, {815,0.005009479}, {820,0.006208531}, {825,0.005165877}, {830,0.005023697}, {835,0.005066351}, {840,0.005791469}, {845,0.005194313}, {850,0.005061611}, {855,0.005023697}, {860,0.005142180}, {865,0.005781991}, {870,0.005421801}, {875,0.005270142}, {880,0.005236967}, {885,0.004943128}, {890,0.005952607}, {895,0.005582938}, {900,0.005265403}, {905,0.005440758}, {910,0.005492891}, {915,0.006180095}, {920,0.005497630}, {925,0.005507109}, {930,0.005184834}, {935,0.005644550}, {940,0.005672986}, {945,0.006573460}, {950,0.005502370}, {955,0.005601896}, {960,0.005924171}, {965,0.005876777}, {970,0.005815166}, {975,0.005829384}, {980,0.005933649}, {985,0.006582938}, {990,0.007995261}, {995,0.005981043}, {1000,0.005914692}, {1010,0.006047393}, {1020,0.006127962}, {1030,0.006317536}, {1040,0.006369668}, {1050,0.006383886}, {1060,0.006270142}, {1070,0.006393365}, {1080,0.006322275}, {1090,0.006535545}, {1100,0.006706161}, {1110,0.007872038}, {1120,0.006791469}, {1130,0.006800948}, {1140,0.006890995}, {1150,0.007957346}, {1160,0.007037915}, {1170,0.006843602}, {1180,0.007146919}, {1190,0.007293839}, {1200,0.007322275}, {1210,0.007663507}, {1220,0.007417062}, {1230,0.007436019}, {1240,0.007511848}, {1250,0.008772512}, {1260,0.009213270}, {1270,0.007872038}, {1280,0.007919431}, {1290,0.008345972}, {1300,0.008322275}, {1310,0.008118483}, {1320,0.009421801}, {1330,0.009706161}, {1340,0.008672986}, {1350,0.008426540}, {1360,0.008606635}, {1370,0.008838863}, {1380,0.008620853}, {1390,0.008872038}, {1400,0.008763033}, {1410,0.009099526}, {1420,0.010189573}, {1430,0.009350711}, {1440,0.009483412}, {1450,0.010559242}, {1460,0.009905213}, {1470,0.009516588}, {1480,0.011028436}, {1490,0.010981043}, {1500,0.010028436}, {1510,0.011682464}, {1520,0.011042654}, {1530,0.010251185}, {1540,0.011872038}, {1550,0.010037915}, {1560,0.010644550}, {1570,0.012971564}, {1580,0.010649289}, {1590,0.010819905}, {1600,0.010928910}, {1610,0.010905213}, {1620,0.010909953}, {1630,0.011014218}, {1640,0.011146919}, {1650,0.011184834}, {1660,0.012881517}, {1670,0.011450237}, {1680,0.012928910}, {1690,0.011454976}, {1700,0.011758294}, {1710,0.011644550}, {1720,0.011905213}, {1730,0.011805687}, {1740,0.013336493}, {1750,0.011786730}, {1760,0.013587678}, {1770,0.012127962}, {1780,0.012317536}, {1790,0.013886256}, {1800,0.012355450}, {1810,0.014383886}, {1820,0.012469194}, {1830,0.012582938}, {1840,0.014047393}, {1850,0.012791469}, {1860,0.014521327}, {1870,0.012976303}, {1880,0.012971564}, {1890,0.014440758}, {1900,0.013066351}, {1910,0.013161137}, {1920,0.013255924}, {1930,0.015336493}, {1940,0.013459716}, {1950,0.013526066}, {1960,0.016047393}, {1970,0.013644550}, {1980,0.013554502}, {1990,0.013876777}, {2000,0.015431280}, {2050,0.014071090}, {2100,0.014639810}, {2150,0.016004739}, {2200,0.015336493}, {2250,0.017260664}, {2300,0.015753555}, {2350,0.017819905}, {2400,0.016715640}, {2450,0.016710900}, {2500,0.019535545}, {2550,0.017796209}, {2600,0.019293839}, {2650,0.018454976}, {2700,0.021374408}, {2750,0.019478673}, {2800,0.019530806}, {2850,0.022255924}, {2900,0.020578199}, {2950,0.023061611}, {3000,0.023834123}, {3050,0.021947867}, {3100,0.024635071}, {3150,0.026511848}, {3200,0.023004739}, {3250,0.025914692}, {3300,0.025682464}, {3350,0.024402844}, {3400,0.024568720}, {3450,0.029454976}, {3500,0.029843602}, {3550,0.025952607}, {3600,0.026109005}, {3650,0.030170616}, {3700,0.032317536}, {3750,0.029824645}, {3800,0.027696682}, {3850,0.028132701}, {3900,0.027492891}, {3950,0.030649289}, {4000,0.036786730}, {4050,0.031834123}, {4100,0.033687204}, {4150,0.030274882}, {4200,0.030464455}, {4250,0.030867299}, {4300,0.031246445}, {4350,0.031431280}, {4400,0.035739336}, {4450,0.035090047}, {4500,0.035976303}, {4550,0.036563981}, {4600,0.036985782}, {4650,0.037345972}, {4700,0.038085308}, {4750,0.037943128}, {4800,0.037545024}, {4850,0.037454976}, {4900,0.036350711}, {4950,0.036720379}, {5000,0.037085308}, {5050,0.06271}, {5100,0.04071}, {5150,0.03957}, {5200,0.03914}, {5250,0.03757}, {5300,0.04171}, {5350,0.04457}, {5400,0.04557}, {5450,0.04314}, {5500,0.04143}, {5550,0.04000}, {5600,0.04386}, {5650,0.04600}, {5700,0.04571}, {5750,0.04271}, {5800,0.04557}, {5850,0.04729}, {5900,0.04729}, {5950,0.04229}, {6000,0.05029}, {6050,0.05229}, {6100,0.04700}, {6150,0.04986}, {6200,0.05386}, {6250,0.04743}, {6300,0.04943}, {6350,0.05500}, {6400,0.04814}, {6450,0.05143}, {6500,0.05129}, {6550,0.05143}, {6600,0.06086}, {6650,0.04786}, {6700,0.06086}, {6750,0.04971}, {6800,0.05429}, {6850,0.05271}, {6900,0.05486}, {6950,0.05329}, {7000,0.05786}, {7050,0.05500}, {7100,0.05729}, {7150,0.05657}, {7200,0.06314}, {7250,0.05171}, {7300,0.06086}, {7350,0.05871}, {7400,0.05786}, {7450,0.06200}, {7500,0.05786}, {7550,0.06471}, {7600,0.06471}, {7650,0.05886}, {7700,0.06686}, {7750,0.06486}, {7800,0.06000}, {7850,0.06771}, {7900,0.06700}, {7950,0.06229}, {8000,0.06900}, {8050,0.06929}, {8100,0.06186}, {8150,0.06214}, {8200,0.07057}, {8250,0.07129}, {8300,0.06729}, {8350,0.06571}, {8400,0.06814}, {8450,0.07314}, {8500,0.07357}, {8550,0.06943}, {8600,0.07057}, {8650,0.06614}, {8700,0.07229}, {8750,0.07471}, {8800,0.07643}, {8850,0.07443}, {8900,0.07514}, {8950,0.07986}, {9000,0.07229}, {9050,0.07329}, {9100,0.07457}, {9150,0.07486}, {9200,0.07457}, {9250,0.07557}, {9300,0.07657}, {9350,0.07614}, {9400,0.07786}, {9450,0.07800}, {9500,0.07757}, {9550,0.07586}, {9600,0.08371}, {9650,0.08357}, {9700,0.08229}, {9750,0.08414}, {9800,0.08629}, {9850,0.08543}, {9900,0.07857}, {9950,0.08300}, {10000,0.08014}, {10100,0.08314}, {10200,0.08529}, {10300,0.08457}, {10400,0.08700}, {10500,0.08571}, {10600,0.08857}, {10700,0.49100}, {10800,0.09529}, {10900,0.08671}, {11000,0.09243}, {11100,0.09043}, {11200,0.09329}, {11300,0.09171}, {11400,0.09329}, {11500,0.09557}, {11600,0.09386}, {11700,0.09286}, {11800,0.09614}, {11900,0.10129}, {12000,0.09829}, {12100,0.10286}, {12200,0.10571}, {12300,0.10243}, {12400,0.10214}, {12500,0.10400}, {12600,0.10400}, {12700,0.10843}, {12800,0.10929}, {12900,0.10829}, {13000,0.10843}, {13100,0.11400}, {13200,0.11057}, {13300,0.11429}, {13400,0.10943}, {13500,0.11229}, {13600,0.10800}, {13700,0.11086}, {13800,0.10929}, {13900,0.11400}, {14000,0.11486}, {14100,0.11700}, {14200,0.11086}, {14300,0.11700}, {14400,0.11871}, {14500,0.11986}, {14600,0.12457}, {14700,0.11486}, {14800,0.12271}, {14900,0.12314}, {15000,0.12200}, {15100,0.12814}, {15200,0.12343}, {15300,0.12114}, {15400,0.13114}, {15500,0.13343}, {15600,0.12986}, {15700,0.13257}, {15800,0.13429}, {15900,0.13029}, {16000,0.13743}, {16100,0.13214}, {16200,0.13729}, {16300,0.13200}, {16400,0.14200}, {16500,0.13457}, {16600,0.14414}, {16700,0.13571}, {16800,0.14014}, {16900,0.14986}, {17000,0.13571}, {17100,0.14943}, {17200,0.15657}, {17300,0.14014}, {17400,0.14429}, {17500,0.14957}, {17600,0.14700}, {17700,0.13914}, {17800,0.13829}, {17900,0.15414}, {18000,0.15429}, {18100,0.16471}, {18200,0.15400}, {18300,0.14900}, {18400,0.14514}, {18500,0.14271}, {18600,0.14271}, {18700,0.14271}, {18800,0.14357}, {18900,0.14800}, {19000,0.15714}, {19100,0.16757}, {19200,0.17186}, {19300,0.17029}, {19400,0.16343}, {19500,0.14886}, {19600,0.15343}, {19700,0.16943}, {19800,0.17443}, {19900,0.16200}, {20000,0.15400}};
data["big_flat"]["beta; Parametricity"]["actual reif"]["system"] = {{1,0.000056872}, {2,0.000037915}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000018957}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000018957}, {14,0.000018957}, {15,0.000000000}, {16,0.000000000}, {17,0.000018957}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000018957}, {24,0.000000000}, {25,0.000018957}, {26,0.000018957}, {27,0.000037915}, {28,0.000018957}, {29,0.000018957}, {30,0.000000000}, {31,0.000018957}, {32,0.000018957}, {33,0.000000000}, {34,0.000018957}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000018957}, {46,0.000018957}, {47,0.000000000}, {48,0.000000000}, {49,0.000018957}, {50,0.000018957}, {51,0.000000000}, {52,0.000018957}, {53,0.000000000}, {54,0.000018957}, {55,0.000018957}, {56,0.000018957}, {57,0.000000000}, {58,0.000014218}, {59,0.000000000}, {60,0.000018957}, {61,0.000014218}, {62,0.000000000}, {63,0.000018957}, {64,0.000000000}, {65,0.000018957}, {66,0.000037915}, {67,0.000000000}, {68,0.000018957}, {69,0.000000000}, {70,0.000000000}, {71,0.000018957}, {72,0.000018957}, {73,0.000018957}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000037915}, {78,0.000037915}, {79,0.000000000}, {80,0.000000000}, {81,0.000037915}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000018957}, {87,0.000018957}, {88,0.000018957}, {89,0.000018957}, {90,0.000033175}, {91,0.000000000}, {92,0.000018957}, {93,0.000018957}, {94,0.000018957}, {95,0.000000000}, {96,0.000037915}, {97,0.000000000}, {98,0.000018957}, {99,0.000018957}, {100,0.000000000}, {101,0.000018957}, {102,0.000000000}, {103,0.000018957}, {104,0.000000000}, {105,0.000014218}, {106,0.000000000}, {107,0.000000000}, {108,0.000018957}, {109,0.000018957}, {110,0.000000000}, {111,0.000018957}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000018957}, {118,0.000014218}, {119,0.000037915}, {120,0.000018957}, {121,0.000037915}, {122,0.000018957}, {123,0.000018957}, {124,0.000018957}, {125,0.000018957}, {126,0.000018957}, {127,0.000000000}, {128,0.000018957}, {129,0.000000000}, {130,0.000000000}, {131,0.000014218}, {132,0.000018957}, {133,0.000037915}, {134,0.000000000}, {135,0.000000000}, {136,0.000018957}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000018957}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000018957}, {145,0.000018957}, {146,0.000000000}, {147,0.000018957}, {148,0.000018957}, {149,0.000033175}, {150,0.000000000}, {151,0.000018957}, {152,0.000071090}, {153,0.000000000}, {154,0.000000000}, {155,0.000018957}, {156,0.000000000}, {157,0.000000000}, {158,0.000037915}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000018957}, {164,0.000018957}, {165,0.000000000}, {166,0.000018957}, {167,0.000018957}, {168,0.000000000}, {169,0.000018957}, {170,0.000000000}, {171,0.000018957}, {172,0.000018957}, {173,0.000037915}, {174,0.000000000}, {175,0.000000000}, {176,0.000018957}, {177,0.000018957}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000018957}, {182,0.000037915}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000018957}, {187,0.000014218}, {188,0.000037915}, {189,0.000000000}, {190,0.000000000}, {191,0.000018957}, {192,0.000018957}, {193,0.000000000}, {194,0.000018957}, {195,0.000018957}, {196,0.000000000}, {197,0.000000000}, {198,0.000037915}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000018957}, {203,0.000000000}, {204,0.000000000}, {205,0.000018957}, {206,0.000056872}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000037915}, {212,0.000018957}, {213,0.000000000}, {214,0.000014218}, {215,0.000000000}, {216,0.000018957}, {217,0.000056872}, {218,0.000056872}, {219,0.000018957}, {220,0.000000000}, {221,0.000018957}, {222,0.000018957}, {223,0.000000000}, {224,0.000018957}, {225,0.000018957}, {226,0.000018957}, {227,0.000000000}, {228,0.000018957}, {229,0.000000000}, {230,0.000018957}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000037915}, {235,0.000018957}, {236,0.000000000}, {237,0.000018957}, {238,0.000000000}, {239,0.000014218}, {240,0.000018957}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000018957}, {245,0.000018957}, {246,0.000018957}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000037915}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000018957}, {257,0.000000000}, {258,0.000018957}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000018957}, {270,0.000000000}, {271,0.000000000}, {272,0.000018957}, {273,0.000000000}, {274,0.000000000}, {275,0.000018957}, {276,0.000037915}, {277,0.000014218}, {278,0.000037915}, {279,0.000000000}, {280,0.000037915}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000018957}, {288,0.000000000}, {289,0.000000000}, {290,0.000018957}, {291,0.000018957}, {292,0.000018957}, {293,0.000037915}, {294,0.000033175}, {295,0.000037915}, {296,0.000000000}, {297,0.000000000}, {298,0.000018957}, {299,0.000037915}, {300,0.000018957}, {301,0.000018957}, {302,0.000000000}, {303,0.000018957}, {304,0.000000000}, {305,0.000018957}, {306,0.000018957}, {307,0.000052133}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000018957}, {312,0.000000000}, {313,0.000037915}, {314,0.000000000}, {315,0.000000000}, {316,0.000037915}, {317,0.000000000}, {318,0.000037915}, {319,0.000014218}, {320,0.000037915}, {321,0.000000000}, {322,0.000018957}, {323,0.000018957}, {324,0.000000000}, {325,0.000000000}, {326,0.000056872}, {327,0.000000000}, {328,0.000056872}, {329,0.000000000}, {330,0.000000000}, {331,0.000018957}, {332,0.000018957}, {333,0.000018957}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000018957}, {338,0.000018957}, {339,0.000000000}, {340,0.000000000}, {341,0.000033175}, {342,0.000018957}, {343,0.000000000}, {344,0.000018957}, {345,0.000000000}, {346,0.000000000}, {347,0.000018957}, {348,0.000037915}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000018957}, {355,0.000018957}, {356,0.000018957}, {357,0.000018957}, {358,0.000018957}, {359,0.000037915}, {360,0.000018957}, {361,0.000018957}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000018957}, {366,0.000000000}, {367,0.000018957}, {368,0.000037915}, {369,0.000000000}, {370,0.000000000}, {371,0.000037915}, {372,0.000018957}, {373,0.000000000}, {374,0.000000000}, {375,0.000033175}, {376,0.000037915}, {377,0.000000000}, {378,0.000000000}, {379,0.000056872}, {380,0.000018957}, {381,0.000018957}, {382,0.000018957}, {383,0.000033175}, {384,0.000018957}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000018957}, {389,0.000018957}, {390,0.000014218}, {391,0.000018957}, {392,0.000000000}, {393,0.000037915}, {394,0.000018957}, {395,0.000018957}, {396,0.000018957}, {397,0.000018957}, {398,0.000037915}, {399,0.000018957}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000018957}, {407,0.000018957}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000018957}, {413,0.000018957}, {414,0.000014218}, {415,0.000037915}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000018957}, {420,0.000000000}, {421,0.000000000}, {422,0.000018957}, {423,0.000000000}, {424,0.000075829}, {425,0.000000000}, {426,0.000018957}, {427,0.000037915}, {428,0.000000000}, {429,0.000037915}, {430,0.000000000}, {431,0.000014218}, {432,0.000000000}, {433,0.000000000}, {434,0.000018957}, {435,0.000000000}, {436,0.000033175}, {437,0.000000000}, {438,0.000000000}, {439,0.000018957}, {440,0.000000000}, {441,0.000037915}, {442,0.000037915}, {443,0.000000000}, {444,0.000000000}, {445,0.000037915}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000018957}, {451,0.000018957}, {452,0.000000000}, {453,0.000014218}, {454,0.000018957}, {455,0.000000000}, {456,0.000000000}, {457,0.000018957}, {458,0.000000000}, {459,0.000018957}, {460,0.000000000}, {461,0.000018957}, {462,0.000037915}, {463,0.000018957}, {464,0.000018957}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000018957}, {469,0.000000000}, {470,0.000056872}, {471,0.000000000}, {472,0.000018957}, {473,0.000000000}, {474,0.000018957}, {475,0.000000000}, {476,0.000000000}, {477,0.000014218}, {478,0.000018957}, {479,0.000018957}, {480,0.000018957}, {481,0.000037915}, {482,0.000014218}, {483,0.000018957}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000037915}, {488,0.000000000}, {489,0.000000000}, {490,0.000037915}, {491,0.000018957}, {492,0.000075829}, {493,0.000018957}, {494,0.000000000}, {495,0.000000000}, {496,0.000018957}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000037915}, {505,0.000000000}, {510,0.000018957}, {515,0.000000000}, {520,0.000000000}, {525,0.000037915}, {530,0.000000000}, {535,0.000000000}, {540,0.000018957}, {545,0.000028436}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000037915}, {570,0.000018957}, {575,0.000018957}, {580,0.000018957}, {585,0.000000000}, {590,0.000000000}, {595,0.000037915}, {600,0.000000000}, {605,0.000000000}, {610,0.000037915}, {615,0.000018957}, {620,0.000018957}, {625,0.000000000}, {630,0.000037915}, {635,0.000037915}, {640,0.000037915}, {645,0.000000000}, {650,0.000000000}, {655,0.000018957}, {660,0.000018957}, {665,0.000018957}, {670,0.000014218}, {675,0.000000000}, {680,0.000014218}, {685,0.000018957}, {690,0.000000000}, {695,0.000000000}, {700,0.000018957}, {705,0.000056872}, {710,0.000018957}, {715,0.000018957}, {720,0.000037915}, {725,0.000018957}, {730,0.000000000}, {735,0.000018957}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000018957}, {760,0.000018957}, {765,0.000037915}, {770,0.000018957}, {775,0.000037915}, {780,0.000018957}, {785,0.000037915}, {790,0.000018957}, {795,0.000000000}, {800,0.000056872}, {805,0.000037915}, {810,0.000018957}, {815,0.000000000}, {820,0.000018957}, {825,0.000000000}, {830,0.000000000}, {835,0.000018957}, {840,0.000000000}, {845,0.000018957}, {850,0.000018957}, {855,0.000018957}, {860,0.000000000}, {865,0.000037915}, {870,0.000000000}, {875,0.000000000}, {880,0.000018957}, {885,0.000037915}, {890,0.000037915}, {895,0.000018957}, {900,0.000000000}, {905,0.000000000}, {910,0.000018957}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000018957}, {935,0.000000000}, {940,0.000018957}, {945,0.000000000}, {950,0.000000000}, {955,0.000018957}, {960,0.000018957}, {965,0.000000000}, {970,0.000037915}, {975,0.000018957}, {980,0.000018957}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000033175}, {1010,0.000018957}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000018957}, {1050,0.000018957}, {1060,0.000037915}, {1070,0.000000000}, {1080,0.000018957}, {1090,0.000018957}, {1100,0.000018957}, {1110,0.000000000}, {1120,0.000018957}, {1130,0.000000000}, {1140,0.000037915}, {1150,0.000000000}, {1160,0.000018957}, {1170,0.000018957}, {1180,0.000037915}, {1190,0.000037915}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000018957}, {1230,0.000056872}, {1240,0.000000000}, {1250,0.000014218}, {1260,0.000018957}, {1270,0.000018957}, {1280,0.000056872}, {1290,0.000000000}, {1300,0.000018957}, {1310,0.000018957}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000037915}, {1350,0.000018957}, {1360,0.000018957}, {1370,0.000018957}, {1380,0.000000000}, {1390,0.000018957}, {1400,0.000000000}, {1410,0.000037915}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000037915}, {1450,0.000018957}, {1460,0.000000000}, {1470,0.000075829}, {1480,0.000018957}, {1490,0.000075829}, {1500,0.000018957}, {1510,0.000018957}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000033175}, {1560,0.000000000}, {1570,0.000056872}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000018957}, {1630,0.000037915}, {1640,0.000000000}, {1650,0.000037915}, {1660,0.000056872}, {1670,0.000000000}, {1680,0.000018957}, {1690,0.000037915}, {1700,0.000037915}, {1710,0.000000000}, {1720,0.000018957}, {1730,0.000000000}, {1740,0.000018957}, {1750,0.000037915}, {1760,0.000018957}, {1770,0.000018957}, {1780,0.000018957}, {1790,0.000018957}, {1800,0.000037915}, {1810,0.000071090}, {1820,0.000018957}, {1830,0.000000000}, {1840,0.000037915}, {1850,0.000018957}, {1860,0.000018957}, {1870,0.000014218}, {1880,0.000037915}, {1890,0.000018957}, {1900,0.000037915}, {1910,0.000033175}, {1920,0.000018957}, {1930,0.000037915}, {1940,0.000037915}, {1950,0.000018957}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000037915}, {1990,0.000037915}, {2000,0.000071090}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000018957}, {2200,0.000018957}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000037915}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000018957}, {2550,0.000000000}, {2600,0.000056872}, {2650,0.000000000}, {2700,0.000018957}, {2750,0.000018957}, {2800,0.000000000}, {2850,0.000075829}, {2900,0.000018957}, {2950,0.000037915}, {3000,0.000037915}, {3050,0.000000000}, {3100,0.000018957}, {3150,0.000109005}, {3200,0.000018957}, {3250,0.000037915}, {3300,0.000075829}, {3350,0.000018957}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000061611}, {3550,0.000018957}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000056872}, {3750,0.000037915}, {3800,0.000037915}, {3850,0.000018957}, {3900,0.000018957}, {3950,0.000000000}, {4000,0.000113744}, {4050,0.000018957}, {4100,0.000056872}, {4150,0.000018957}, {4200,0.000056872}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000018957}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000018957}, {4550,0.000037915}, {4600,0.000056872}, {4650,0.000018957}, {4700,0.000000000}, {4750,0.000052133}, {4800,0.000018957}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000018957}, {5000,0.000000000}, {5050,0.00057}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00057}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00114}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00057}, {6600,0.00000}, {6650,0.00000}, {6700,0.00114}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00100}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00057}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00057}, {7550,0.00057}, {7600,0.00000}, {7650,0.00043}, {7700,0.00057}, {7750,0.00000}, {7800,0.00000}, {7850,0.00057}, {7900,0.00057}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00114}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00057}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00057}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00057}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00057}, {19100,0.00000}, {19200,0.00000}, {19300,0.00057}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["beta; Parametricity"]["cbv"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.009492891}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000464455}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000511848}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000516588}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000009479}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000004739}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000511848}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000483412}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000014218}, {394,0.000004739}, {395,0.000000000}, {396,0.000000000}, {397,0.000004739}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000009479}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000540284}, {408,0.000000000}, {409,0.000000000}, {410,0.000004739}, {411,0.000000000}, {412,0.000009479}, {413,0.000009479}, {414,0.000004739}, {415,0.000000000}, {416,0.000004739}, {417,0.000710900}, {418,0.000028436}, {419,0.000014218}, {420,0.000004739}, {421,0.000000000}, {422,0.000004739}, {423,0.000004739}, {424,0.000004739}, {425,0.000009479}, {426,0.000018957}, {427,0.000042654}, {428,0.000042654}, {429,0.000018957}, {430,0.000052133}, {431,0.000037915}, {432,0.000066351}, {433,0.000042654}, {434,0.000061611}, {435,0.000056872}, {436,0.000094787}, {437,0.000071090}, {438,0.000099526}, {439,0.000104265}, {440,0.000137441}, {441,0.000137441}, {442,0.000161137}, {443,0.000189573}, {444,0.000170616}, {445,0.000236967}, {446,0.000270142}, {447,0.000289100}, {448,0.000345972}, {449,0.000350711}, {450,0.000412322}, {451,0.000426540}, {452,0.000436019}, {453,0.000488152}, {454,0.000526066}, {455,0.001056872}, {456,0.000545024}, {457,0.000582938}, {458,0.000611374}, {459,0.000654028}, {460,0.000630332}, {461,0.000682464}, {462,0.000734597}, {463,0.000777251}, {464,0.000800948}, {465,0.000810427}, {466,0.000843602}, {467,0.000853081}, {468,0.000853081}, {469,0.000848341}, {470,0.000876777}, {471,0.000872038}, {472,0.000886256}, {473,0.001374408}, {474,0.000909953}, {475,0.000905213}, {476,0.000900474}, {477,0.000928910}, {478,0.000924171}, {479,0.000938389}, {480,0.000943128}, {481,0.000947867}, {482,0.000952607}, {483,0.000971564}, {484,0.000976303}, {485,0.000971564}, {486,0.000966825}, {487,0.000990521}, {488,0.000976303}, {489,0.000976303}, {490,0.000985782}, {491,0.001000000}, {492,0.000990521}, {493,0.000995261}, {494,0.001000000}, {495,0.001000000}, {496,0.001000000}, {497,0.001000000}, {498,0.000995261}, {499,0.001000000}, {500,0.001000000}, {505,0.001000000}, {510,0.001000000}, {515,0.001000000}, {520,0.001000000}, {525,0.001000000}, {530,0.001000000}, {535,0.001000000}, {540,0.001000000}, {545,0.001000000}, {550,0.001000000}, {555,0.001000000}, {560,0.001009479}, {565,0.001000000}, {570,0.001000000}, {575,0.001000000}, {580,0.001000000}, {585,0.001000000}, {590,0.001000000}, {595,0.001000000}, {600,0.001000000}, {605,0.001000000}, {610,0.002018957}, {615,0.001000000}, {620,0.001000000}, {625,0.001000000}, {630,0.001000000}, {635,0.001000000}, {640,0.001000000}, {645,0.001000000}, {650,0.001000000}, {655,0.001000000}, {660,0.001000000}, {665,0.001018957}, {670,0.001000000}, {675,0.001000000}, {680,0.001000000}, {685,0.001000000}, {690,0.001000000}, {695,0.001000000}, {700,0.001000000}, {705,0.001000000}, {710,0.001000000}, {715,0.001000000}, {720,0.001000000}, {725,0.001000000}, {730,0.001000000}, {735,0.001000000}, {740,0.001000000}, {745,0.001000000}, {750,0.001000000}, {755,0.001000000}, {760,0.001000000}, {765,0.001000000}, {770,0.001000000}, {775,0.001000000}, {780,0.001004739}, {785,0.001018957}, {790,0.001000000}, {795,0.002132701}, {800,0.001000000}, {805,0.001000000}, {810,0.001009479}, {815,0.001004739}, {820,0.001004739}, {825,0.001009479}, {830,0.001000000}, {835,0.001009479}, {840,0.001018957}, {845,0.001023697}, {850,0.001037915}, {855,0.001052133}, {860,0.001094787}, {865,0.001137441}, {870,0.001194313}, {875,0.001232227}, {880,0.001289100}, {885,0.001345972}, {890,0.001379147}, {895,0.001440758}, {900,0.001469194}, {905,0.001530806}, {910,0.001616114}, {915,0.001625592}, {920,0.001706161}, {925,0.001786730}, {930,0.001838863}, {935,0.001881517}, {940,0.002867299}, {945,0.001881517}, {950,0.001928910}, {955,0.001938389}, {960,0.001933649}, {965,0.001957346}, {970,0.002464455}, {975,0.001981043}, {980,0.001985782}, {985,0.001985782}, {990,0.002000000}, {995,0.002000000}, {1000,0.001995261}, {1010,0.002000000}, {1020,0.002000000}, {1030,0.002000000}, {1040,0.002000000}, {1050,0.002000000}, {1060,0.002478673}, {1070,0.002000000}, {1080,0.002000000}, {1090,0.002000000}, {1100,0.003383886}, {1110,0.002000000}, {1120,0.002000000}, {1130,0.002000000}, {1140,0.003293839}, {1150,0.002000000}, {1160,0.002000000}, {1170,0.002000000}, {1180,0.002000000}, {1190,0.002715640}, {1200,0.002000000}, {1210,0.002009479}, {1220,0.002004739}, {1230,0.002014218}, {1240,0.002014218}, {1250,0.002033175}, {1260,0.002080569}, {1270,0.002090047}, {1280,0.002146919}, {1290,0.002251185}, {1300,0.002284360}, {1310,0.002402844}, {1320,0.002436019}, {1330,0.002516588}, {1340,0.002578199}, {1350,0.002630332}, {1360,0.002753555}, {1370,0.002829384}, {1380,0.002886256}, {1390,0.002890995}, {1400,0.002900474}, {1410,0.002924171}, {1420,0.002943128}, {1430,0.003469194}, {1440,0.002981043}, {1450,0.002985782}, {1460,0.005293839}, {1470,0.003000000}, {1480,0.003028436}, {1490,0.003000000}, {1500,0.003000000}, {1510,0.003056872}, {1520,0.003000000}, {1530,0.003000000}, {1540,0.003037915}, {1550,0.004606635}, {1560,0.003000000}, {1570,0.003000000}, {1580,0.004393365}, {1590,0.003009479}, {1600,0.004772512}, {1610,0.003004739}, {1620,0.003028436}, {1630,0.003023697}, {1640,0.003018957}, {1650,0.003056872}, {1660,0.003085308}, {1670,0.003123223}, {1680,0.003227488}, {1690,0.005905213}, {1700,0.003232227}, {1710,0.005265403}, {1720,0.003312796}, {1730,0.003393365}, {1740,0.003426540}, {1750,0.003469194}, {1760,0.003511848}, {1770,0.003540284}, {1780,0.003616114}, {1790,0.003658768}, {1800,0.003772512}, {1810,0.003872038}, {1820,0.003872038}, {1830,0.003890995}, {1840,0.003909953}, {1850,0.003909953}, {1860,0.003952607}, {1870,0.003947867}, {1880,0.003947867}, {1890,0.003971564}, {1900,0.003981043}, {1910,0.005492891}, {1920,0.004000000}, {1930,0.004000000}, {1940,0.006706161}, {1950,0.004000000}, {1960,0.004000000}, {1970,0.004004739}, {1980,0.006071090}, {1990,0.004009479}, {2000,0.004042654}, {2050,0.004047393}, {2100,0.004260664}, {2150,0.004454976}, {2200,0.004625592}, {2250,0.004843602}, {2300,0.004933649}, {2350,0.004976303}, {2400,0.005047393}, {2450,0.006573460}, {2500,0.005293839}, {2550,0.005431280}, {2600,0.005654028}, {2650,0.005796209}, {2700,0.008355450}, {2750,0.005957346}, {2800,0.008483412}, {2850,0.006199052}, {2900,0.006374408}, {2950,0.006450237}, {3000,0.006616114}, {3050,0.006753555}, {3100,0.008170616}, {3150,0.007004739}, {3200,0.007056872}, {3250,0.007265403}, {3300,0.007417062}, {3350,0.007502370}, {3400,0.010090047}, {3450,0.011364929}, {3500,0.007933649}, {3550,0.008028436}, {3600,0.008194313}, {3650,0.008336493}, {3700,0.008526066}, {3750,0.008545024}, {3800,0.008725118}, {3850,0.008763033}, {3900,0.011303318}, {3950,0.013303318}, {4000,0.009341232}, {4050,0.009355450}, {4100,0.009464455}, {4150,0.009563981}, {4200,0.009687204}, {4250,0.009805687}, {4300,0.014042654}, {4350,0.017597156}, {4400,0.010298578}, {4450,0.010421801}, {4500,0.012279621}, {4550,0.016654028}, {4600,0.017526066}, {4650,0.017710900}, {4700,0.017445498}, {4750,0.016554502}, {4800,0.011355450}, {4850,0.011450237}, {4900,0.016327014}, {4950,0.018758294}, {5000,0.011872038}, {5050,0.01171}, {5100,0.01814}, {5150,0.01400}, {5200,0.01443}, {5250,0.01600}, {5300,0.01214}, {5350,0.01229}, {5400,0.01257}, {5450,0.01686}, {5500,0.01671}, {5550,0.01657}, {5600,0.01257}, {5650,0.01286}, {5700,0.01843}, {5750,0.01543}, {5800,0.01343}, {5850,0.01371}, {5900,0.01971}, {5950,0.01714}, {6000,0.01414}, {6050,0.01414}, {6100,0.01871}, {6150,0.01457}, {6200,0.01443}, {6250,0.01957}, {6300,0.01486}, {6350,0.01500}, {6400,0.01714}, {6450,0.01529}, {6500,0.02314}, {6550,0.01786}, {6600,0.01543}, {6650,0.01986}, {6700,0.01586}, {6750,0.02086}, {6800,0.01614}, {6850,0.02443}, {6900,0.01629}, {6950,0.02586}, {7000,0.01671}, {7050,0.02600}, {7100,0.01714}, {7150,0.02514}, {7200,0.01714}, {7250,0.02071}, {7300,0.01743}, {7350,0.02286}, {7400,0.02357}, {7450,0.01800}, {7500,0.02386}, {7550,0.01800}, {7600,0.02214}, {7650,0.02843}, {7700,0.01857}, {7750,0.02486}, {7800,0.02971}, {7850,0.01886}, {7900,0.02286}, {7950,0.02814}, {8000,0.01943}, {8050,0.01943}, {8100,0.02486}, {8150,0.03300}, {8200,0.02014}, {8250,0.01986}, {8300,0.02671}, {8350,0.02914}, {8400,0.03014}, {8450,0.02057}, {8500,0.02100}, {8550,0.02571}, {8600,0.02957}, {8650,0.03186}, {8700,0.03286}, {8750,0.02114}, {8800,0.02114}, {8850,0.02200}, {8900,0.02171}, {8950,0.02514}, {9000,0.02729}, {9050,0.03200}, {9100,0.03071}, {9150,0.03086}, {9200,0.03243}, {9250,0.03014}, {9300,0.03043}, {9350,0.03029}, {9400,0.03129}, {9450,0.03371}, {9500,0.03300}, {9550,0.03129}, {9600,0.03286}, {9650,0.02771}, {9700,0.02400}, {9750,0.02400}, {9800,0.02429}, {9850,0.02457}, {9900,0.03843}, {9950,0.04257}, {10000,0.03614}, {10100,0.03157}, {10200,0.02571}, {10300,0.02571}, {10400,0.04071}, {10500,0.03743}, {10600,0.02871}, {10700,0.02686}, {10800,0.04229}, {10900,0.03443}, {11000,0.02729}, {11100,0.04514}, {11200,0.02786}, {11300,0.04329}, {11400,0.03543}, {11500,0.03500}, {11600,0.04314}, {11700,0.02943}, {11800,0.03786}, {11900,0.03857}, {12000,0.03571}, {12100,0.05114}, {12200,0.03086}, {12300,0.04371}, {12400,0.04214}, {12500,0.03171}, {12600,0.04300}, {12700,0.05157}, {12800,0.03214}, {12900,0.03629}, {13000,0.04686}, {13100,0.05371}, {13200,0.04300}, {13300,0.03386}, {13400,0.03443}, {13500,0.03957}, {13600,0.04329}, {13700,0.04914}, {13800,0.04914}, {13900,0.05529}, {14000,0.05629}, {14100,0.05643}, {14200,0.05114}, {14300,0.05129}, {14400,0.04157}, {14500,0.04214}, {14600,0.03686}, {14700,0.03743}, {14800,0.05657}, {14900,0.06643}, {15000,0.05557}, {15100,0.04300}, {15200,0.04943}, {15300,0.06286}, {15400,0.05586}, {15500,0.03957}, {15600,0.06471}, {15700,0.05586}, {15800,0.04029}, {15900,0.07443}, {16000,0.04557}, {16100,0.06600}, {16200,0.04957}, {16300,0.06614}, {16400,0.05043}, {16500,0.06971}, {16600,0.04914}, {16700,0.07543}, {16800,0.04329}, {16900,0.06857}, {17000,0.06643}, {17100,0.04843}, {17200,0.07357}, {17300,0.07529}, {17400,0.04486}, {17500,0.05514}, {17600,0.08243}, {17700,0.07171}, {17800,0.05143}, {17900,0.05057}, {18000,0.05457}, {18100,0.07400}, {18200,0.08057}, {18300,0.07686}, {18400,0.08643}, {18500,0.07986}, {18600,0.08343}, {18700,0.08400}, {18800,0.08643}, {18900,0.08686}, {19000,0.08343}, {19100,0.08543}, {19200,0.08614}, {19300,0.06714}, {19400,0.05729}, {19500,0.05571}, {19600,0.07871}, {19700,0.09314}, {19800,0.06971}, {19900,0.05714}, {20000,0.08480}};
data["big_flat"]["beta; Parametricity"]["cbv"]["user"] = {{1,0.000037915}, {2,0.000018957}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000033175}, {7,0.000033175}, {8,0.000104265}, {9,0.000080569}, {10,0.000042654}, {11,0.000014218}, {12,0.000094787}, {13,0.000061611}, {14,0.000047393}, {15,0.000052133}, {16,0.000014218}, {17,0.000071090}, {18,0.000061611}, {19,0.000061611}, {20,0.000075829}, {21,0.000156398}, {22,0.000028436}, {23,0.000052133}, {24,0.000066351}, {25,0.000080569}, {26,0.000056872}, {27,0.000056872}, {28,0.000090047}, {29,0.000075829}, {30,0.000080569}, {31,0.000127962}, {32,0.000085308}, {33,0.000099526}, {34,0.000099526}, {35,0.000123223}, {36,0.000156398}, {37,0.009554502}, {38,0.000085308}, {39,0.000104265}, {40,0.000066351}, {41,0.000085308}, {42,0.000104265}, {43,0.000052133}, {44,0.000118483}, {45,0.000104265}, {46,0.000137441}, {47,0.000175355}, {48,0.000056872}, {49,0.000085308}, {50,0.000047393}, {51,0.000203791}, {52,0.000161137}, {53,0.000071090}, {54,0.000085308}, {55,0.000161137}, {56,0.000142180}, {57,0.000080569}, {58,0.000142180}, {59,0.000151659}, {60,0.000127962}, {61,0.000165877}, {62,0.000118483}, {63,0.000099526}, {64,0.000109005}, {65,0.000180095}, {66,0.000090047}, {67,0.000199052}, {68,0.000113744}, {69,0.000047393}, {70,0.000161137}, {71,0.000099526}, {72,0.000265403}, {73,0.000018957}, {74,0.000161137}, {75,0.000165877}, {76,0.000345972}, {77,0.000165877}, {78,0.000123223}, {79,0.000132701}, {80,0.000151659}, {81,0.000085308}, {82,0.000175355}, {83,0.000151659}, {84,0.000260664}, {85,0.000227488}, {86,0.000085308}, {87,0.000317536}, {88,0.000289100}, {89,0.000241706}, {90,0.000142180}, {91,0.000146919}, {92,0.000085308}, {93,0.000246445}, {94,0.000189573}, {95,0.000203791}, {96,0.000298578}, {97,0.000616114}, {98,0.000289100}, {99,0.000146919}, {100,0.000175355}, {101,0.000260664}, {102,0.000293839}, {103,0.000293839}, {104,0.000222749}, {105,0.000199052}, {106,0.000127962}, {107,0.000293839}, {108,0.000274882}, {109,0.000345972}, {110,0.000255924}, {111,0.000203791}, {112,0.000218009}, {113,0.000251185}, {114,0.000184834}, {115,0.000189573}, {116,0.000298578}, {117,0.000222749}, {118,0.000170616}, {119,0.000170616}, {120,0.000241706}, {121,0.000279621}, {122,0.000279621}, {123,0.000199052}, {124,0.000331754}, {125,0.000255924}, {126,0.000208531}, {127,0.000284360}, {128,0.000308057}, {129,0.000218009}, {130,0.000222749}, {131,0.000213270}, {132,0.000317536}, {133,0.000336493}, {134,0.000199052}, {135,0.000251185}, {136,0.000236967}, {137,0.000236967}, {138,0.000317536}, {139,0.000322275}, {140,0.000241706}, {141,0.000232227}, {142,0.000184834}, {143,0.000218009}, {144,0.000369668}, {145,0.000426540}, {146,0.000393365}, {147,0.000374408}, {148,0.000364929}, {149,0.000322275}, {150,0.000407583}, {151,0.000417062}, {152,0.000379147}, {153,0.000331754}, {154,0.000232227}, {155,0.000383886}, {156,0.000255924}, {157,0.000265403}, {158,0.000184834}, {159,0.000317536}, {160,0.000303318}, {161,0.000440758}, {162,0.000322275}, {163,0.000279621}, {164,0.000284360}, {165,0.000383886}, {166,0.000241706}, {167,0.000322275}, {168,0.000417062}, {169,0.000530806}, {170,0.000260664}, {171,0.000398104}, {172,0.000303318}, {173,0.000298578}, {174,0.000469194}, {175,0.000440758}, {176,0.000331754}, {177,0.000445498}, {178,0.000379147}, {179,0.000317536}, {180,0.000293839}, {181,0.000246445}, {182,0.000417062}, {183,0.000327014}, {184,0.000535545}, {185,0.000398104}, {186,0.000322275}, {187,0.000308057}, {188,0.000345972}, {189,0.000426540}, {190,0.000407583}, {191,0.000298578}, {192,0.000355450}, {193,0.000369668}, {194,0.000407583}, {195,0.000341232}, {196,0.000445498}, {197,0.000488152}, {198,0.000454976}, {199,0.000417062}, {200,0.000303318}, {201,0.000459716}, {202,0.000331754}, {203,0.000516588}, {204,0.000488152}, {205,0.000469194}, {206,0.000407583}, {207,0.000511848}, {208,0.000350711}, {209,0.000341232}, {210,0.000426540}, {211,0.000402844}, {212,0.000478673}, {213,0.000450237}, {214,0.000436019}, {215,0.000412322}, {216,0.000364929}, {217,0.000407583}, {218,0.000417062}, {219,0.000407583}, {220,0.000549763}, {221,0.000417062}, {222,0.000421801}, {223,0.000412322}, {224,0.000440758}, {225,0.000469194}, {226,0.000369668}, {227,0.000545024}, {228,0.000402844}, {229,0.000473934}, {230,0.000601896}, {231,0.000388626}, {232,0.000502370}, {233,0.000810427}, {234,0.000421801}, {235,0.000445498}, {236,0.000497630}, {237,0.000549763}, {238,0.000431280}, {239,0.000601896}, {240,0.000492891}, {241,0.000478673}, {242,0.000469194}, {243,0.000369668}, {244,0.000530806}, {245,0.000436019}, {246,0.000592417}, {247,0.000502370}, {248,0.000540284}, {249,0.000454976}, {250,0.000464455}, {251,0.000483412}, {252,0.000516588}, {253,0.000635071}, {254,0.000526066}, {255,0.000511848}, {256,0.000421801}, {257,0.000601896}, {258,0.000445498}, {259,0.000516588}, {260,0.000701422}, {261,0.000526066}, {262,0.000597156}, {263,0.000464455}, {264,0.000459716}, {265,0.000616114}, {266,0.000582938}, {267,0.000573460}, {268,0.000639810}, {269,0.000322275}, {270,0.000535545}, {271,0.000516588}, {272,0.000492891}, {273,0.000417062}, {274,0.000573460}, {275,0.000530806}, {276,0.000473934}, {277,0.000483412}, {278,0.001194313}, {279,0.000545024}, {280,0.000469194}, {281,0.000526066}, {282,0.000393365}, {283,0.000601896}, {284,0.000554502}, {285,0.000502370}, {286,0.000758294}, {287,0.000587678}, {288,0.000440758}, {289,0.000696682}, {290,0.000578199}, {291,0.000635071}, {292,0.000616114}, {293,0.000696682}, {294,0.000587678}, {295,0.000516588}, {296,0.000677725}, {297,0.000516588}, {298,0.000563981}, {299,0.000483412}, {300,0.000701422}, {301,0.000729858}, {302,0.000611374}, {303,0.000611374}, {304,0.000767773}, {305,0.000663507}, {306,0.000606635}, {307,0.000540284}, {308,0.000677725}, {309,0.000815166}, {310,0.000554502}, {311,0.000464455}, {312,0.000635071}, {313,0.000815166}, {314,0.000639810}, {315,0.000625592}, {316,0.000526066}, {317,0.000829384}, {318,0.000687204}, {319,0.000597156}, {320,0.000668246}, {321,0.000701422}, {322,0.000625592}, {323,0.000715640}, {324,0.000535545}, {325,0.000672986}, {326,0.000729858}, {327,0.000800948}, {328,0.000507109}, {329,0.000635071}, {330,0.000919431}, {331,0.000644550}, {332,0.000606635}, {333,0.000720379}, {334,0.000710900}, {335,0.000706161}, {336,0.000654028}, {337,0.000677725}, {338,0.000625592}, {339,0.000616114}, {340,0.000616114}, {341,0.000473934}, {342,0.000725118}, {343,0.000763033}, {344,0.000668246}, {345,0.000530806}, {346,0.000687204}, {347,0.000772512}, {348,0.000696682}, {349,0.000710900}, {350,0.000729858}, {351,0.000791469}, {352,0.000701422}, {353,0.000658768}, {354,0.000819905}, {355,0.000748815}, {356,0.000691943}, {357,0.000620853}, {358,0.000753555}, {359,0.000857820}, {360,0.000658768}, {361,0.000796209}, {362,0.000800948}, {363,0.000696682}, {364,0.000658768}, {365,0.000473934}, {366,0.000568720}, {367,0.000587678}, {368,0.000587678}, {369,0.000620853}, {370,0.000658768}, {371,0.000748815}, {372,0.000985782}, {373,0.000658768}, {374,0.000729858}, {375,0.000729858}, {376,0.000606635}, {377,0.000616114}, {378,0.000568720}, {379,0.000654028}, {380,0.000687204}, {381,0.000654028}, {382,0.000620853}, {383,0.000872038}, {384,0.000853081}, {385,0.000796209}, {386,0.000843602}, {387,0.001009479}, {388,0.000545024}, {389,0.000502370}, {390,0.000777251}, {391,0.000701422}, {392,0.000815166}, {393,0.000853081}, {394,0.000744076}, {395,0.000848341}, {396,0.000928910}, {397,0.000881517}, {398,0.000938389}, {399,0.000668246}, {400,0.000781991}, {401,0.000758294}, {402,0.000691943}, {403,0.000914692}, {404,0.000834123}, {405,0.000663507}, {406,0.000715640}, {407,0.001298578}, {408,0.000748815}, {409,0.000857820}, {410,0.000947867}, {411,0.000890995}, {412,0.000772512}, {413,0.000881517}, {414,0.001014218}, {415,0.000829384}, {416,0.000720379}, {417,0.001393365}, {418,0.000876777}, {419,0.000791469}, {420,0.000800948}, {421,0.000734597}, {422,0.000853081}, {423,0.000748815}, {424,0.000834123}, {425,0.000933649}, {426,0.000900474}, {427,0.000834123}, {428,0.000796209}, {429,0.000824645}, {430,0.000853081}, {431,0.000928910}, {432,0.000810427}, {433,0.000905213}, {434,0.000767773}, {435,0.000886256}, {436,0.000853081}, {437,0.000853081}, {438,0.000739336}, {439,0.000819905}, {440,0.001151659}, {441,0.000601896}, {442,0.000791469}, {443,0.000981043}, {444,0.000758294}, {445,0.001127962}, {446,0.000834123}, {447,0.000952607}, {448,0.000857820}, {449,0.000725118}, {450,0.000853081}, {451,0.000810427}, {452,0.000947867}, {453,0.000715640}, {454,0.000919431}, {455,0.001308057}, {456,0.000909953}, {457,0.000729858}, {458,0.000810427}, {459,0.000834123}, {460,0.000966825}, {461,0.000853081}, {462,0.001080569}, {463,0.000947867}, {464,0.000947867}, {465,0.001004739}, {466,0.000763033}, {467,0.001104265}, {468,0.000772512}, {469,0.000985782}, {470,0.000867299}, {471,0.000900474}, {472,0.000890995}, {473,0.001454976}, {474,0.000791469}, {475,0.000886256}, {476,0.000928910}, {477,0.001000000}, {478,0.001061611}, {479,0.000905213}, {480,0.001113744}, {481,0.000824645}, {482,0.000995261}, {483,0.001075829}, {484,0.001023697}, {485,0.001142180}, {486,0.000881517}, {487,0.001061611}, {488,0.001000000}, {489,0.000995261}, {490,0.000976303}, {491,0.000933649}, {492,0.001000000}, {493,0.001094787}, {494,0.001028436}, {495,0.001118483}, {496,0.000990521}, {497,0.001000000}, {498,0.001118483}, {499,0.000772512}, {500,0.000947867}, {505,0.000810427}, {510,0.000952607}, {515,0.001104265}, {520,0.001052133}, {525,0.000990521}, {530,0.000928910}, {535,0.001052133}, {540,0.001165877}, {545,0.001146919}, {550,0.001014218}, {555,0.001004739}, {560,0.001175355}, {565,0.001312796}, {570,0.001066351}, {575,0.001099526}, {580,0.001113744}, {585,0.000843602}, {590,0.000843602}, {595,0.000853081}, {600,0.001047393}, {605,0.001137441}, {610,0.002199052}, {615,0.001227488}, {620,0.001132701}, {625,0.001222749}, {630,0.001312796}, {635,0.000971564}, {640,0.001199052}, {645,0.001218009}, {650,0.001156398}, {655,0.001398104}, {660,0.001236967}, {665,0.001222749}, {670,0.001369668}, {675,0.001203791}, {680,0.001369668}, {685,0.001417062}, {690,0.001469194}, {695,0.001374408}, {700,0.001251185}, {705,0.001355450}, {710,0.001521327}, {715,0.001417062}, {720,0.001388626}, {725,0.001582938}, {730,0.001407583}, {735,0.001255924}, {740,0.001492891}, {745,0.001497630}, {750,0.001312796}, {755,0.001511848}, {760,0.001568720}, {765,0.001582938}, {770,0.001322275}, {775,0.001440758}, {780,0.001587678}, {785,0.001355450}, {790,0.001563981}, {795,0.002417062}, {800,0.001516588}, {805,0.001753555}, {810,0.001672986}, {815,0.001606635}, {820,0.001549763}, {825,0.001511848}, {830,0.001426540}, {835,0.001535545}, {840,0.001744076}, {845,0.001625592}, {850,0.001763033}, {855,0.001763033}, {860,0.001644550}, {865,0.001990521}, {870,0.001630332}, {875,0.001796209}, {880,0.001663507}, {885,0.002085308}, {890,0.002066351}, {895,0.001483412}, {900,0.001966825}, {905,0.001834123}, {910,0.001824645}, {915,0.001796209}, {920,0.001777251}, {925,0.001701422}, {930,0.002142180}, {935,0.001663507}, {940,0.002781991}, {945,0.002037915}, {950,0.002109005}, {955,0.001876777}, {960,0.001848341}, {965,0.001919431}, {970,0.002379147}, {975,0.001943128}, {980,0.001876777}, {985,0.001938389}, {990,0.001924171}, {995,0.002080569}, {1000,0.002033175}, {1010,0.002085308}, {1020,0.002260664}, {1030,0.002014218}, {1040,0.002369668}, {1050,0.002066351}, {1060,0.002715640}, {1070,0.002085308}, {1080,0.002246445}, {1090,0.002218009}, {1100,0.003431280}, {1110,0.002279621}, {1120,0.002369668}, {1130,0.002080569}, {1140,0.003341232}, {1150,0.002559242}, {1160,0.002161137}, {1170,0.002308057}, {1180,0.002270142}, {1190,0.003170616}, {1200,0.002312796}, {1210,0.002464455}, {1220,0.002369668}, {1230,0.002341232}, {1240,0.002791469}, {1250,0.002549763}, {1260,0.002620853}, {1270,0.002744076}, {1280,0.002691943}, {1290,0.002478673}, {1300,0.002478673}, {1310,0.002563981}, {1320,0.002729858}, {1330,0.002497630}, {1340,0.002876777}, {1350,0.002895735}, {1360,0.002781991}, {1370,0.002914692}, {1380,0.002900474}, {1390,0.002867299}, {1400,0.002886256}, {1410,0.002824645}, {1420,0.002829384}, {1430,0.003559242}, {1440,0.002985782}, {1450,0.003061611}, {1460,0.005199052}, {1470,0.002909953}, {1480,0.003251185}, {1490,0.003056872}, {1500,0.003061611}, {1510,0.003284360}, {1520,0.003199052}, {1530,0.003312796}, {1540,0.003251185}, {1550,0.004545024}, {1560,0.003255924}, {1570,0.003251185}, {1580,0.004473934}, {1590,0.003355450}, {1600,0.004853081}, {1610,0.003303318}, {1620,0.003298578}, {1630,0.003398104}, {1640,0.003417062}, {1650,0.003502370}, {1660,0.003454976}, {1670,0.003469194}, {1680,0.003464455}, {1690,0.005990521}, {1700,0.003502370}, {1710,0.005232227}, {1720,0.003454976}, {1730,0.003658768}, {1740,0.003800948}, {1750,0.003630332}, {1760,0.003616114}, {1770,0.003748815}, {1780,0.003672986}, {1790,0.003763033}, {1800,0.003748815}, {1810,0.003862559}, {1820,0.003758294}, {1830,0.003886256}, {1840,0.003805687}, {1850,0.003805687}, {1860,0.003928910}, {1870,0.003924171}, {1880,0.003819905}, {1890,0.003981043}, {1900,0.004009479}, {1910,0.005407583}, {1920,0.004014218}, {1930,0.004132701}, {1940,0.006791469}, {1950,0.004075829}, {1960,0.004113744}, {1970,0.004085308}, {1980,0.006066351}, {1990,0.003971564}, {2000,0.004260664}, {2050,0.004255924}, {2100,0.004478673}, {2150,0.004445498}, {2200,0.004644550}, {2250,0.004881517}, {2300,0.004952607}, {2350,0.004838863}, {2400,0.005189573}, {2450,0.006554502}, {2500,0.005156398}, {2550,0.005445498}, {2600,0.005739336}, {2650,0.005900474}, {2700,0.008412322}, {2750,0.005853081}, {2800,0.008620853}, {2850,0.006331754}, {2900,0.006289100}, {2950,0.006227488}, {3000,0.006497630}, {3050,0.006767773}, {3100,0.008260664}, {3150,0.006772512}, {3200,0.006928910}, {3250,0.007118483}, {3300,0.007218009}, {3350,0.007469194}, {3400,0.010127962}, {3450,0.011194313}, {3500,0.007872038}, {3550,0.007943128}, {3600,0.008080569}, {3650,0.008369668}, {3700,0.008445498}, {3750,0.008696682}, {3800,0.008488152}, {3850,0.008530806}, {3900,0.011483412}, {3950,0.013094787}, {4000,0.009175355}, {4050,0.008952607}, {4100,0.009331754}, {4150,0.009578199}, {4200,0.009909953}, {4250,0.010246445}, {4300,0.014085308}, {4350,0.017838863}, {4400,0.010535545}, {4450,0.010464455}, {4500,0.012412322}, {4550,0.016876777}, {4600,0.017848341}, {4650,0.017962085}, {4700,0.017649289}, {4750,0.016867299}, {4800,0.011710900}, {4850,0.011857820}, {4900,0.016417062}, {4950,0.019047393}, {5000,0.012279621}, {5050,0.01243}, {5100,0.01786}, {5150,0.01386}, {5200,0.01457}, {5250,0.01657}, {5300,0.01300}, {5350,0.01243}, {5400,0.01186}, {5450,0.01729}, {5500,0.01743}, {5550,0.01571}, {5600,0.01300}, {5650,0.01300}, {5700,0.01757}, {5750,0.01543}, {5800,0.01243}, {5850,0.01343}, {5900,0.01957}, {5950,0.01743}, {6000,0.01429}, {6050,0.01429}, {6100,0.01857}, {6150,0.01386}, {6200,0.01414}, {6250,0.01986}, {6300,0.01400}, {6350,0.01486}, {6400,0.01671}, {6450,0.01557}, {6500,0.02257}, {6550,0.01800}, {6600,0.01486}, {6650,0.02071}, {6700,0.01600}, {6750,0.02014}, {6800,0.01657}, {6850,0.02471}, {6900,0.01643}, {6950,0.02443}, {7000,0.01629}, {7050,0.02657}, {7100,0.01743}, {7150,0.02571}, {7200,0.01700}, {7250,0.02114}, {7300,0.01757}, {7350,0.02229}, {7400,0.02357}, {7450,0.01814}, {7500,0.02371}, {7550,0.01657}, {7600,0.02229}, {7650,0.02771}, {7700,0.01857}, {7750,0.02471}, {7800,0.02943}, {7850,0.01743}, {7900,0.02243}, {7950,0.02729}, {8000,0.01914}, {8050,0.01914}, {8100,0.02486}, {8150,0.03329}, {8200,0.02029}, {8250,0.02114}, {8300,0.02571}, {8350,0.02786}, {8400,0.03029}, {8450,0.02000}, {8500,0.02057}, {8550,0.02614}, {8600,0.02929}, {8650,0.03200}, {8700,0.03300}, {8750,0.02086}, {8800,0.02329}, {8850,0.02186}, {8900,0.02200}, {8950,0.02457}, {9000,0.02643}, {9050,0.03243}, {9100,0.03114}, {9150,0.03000}, {9200,0.03257}, {9250,0.03129}, {9300,0.03057}, {9350,0.02886}, {9400,0.03214}, {9450,0.03386}, {9500,0.03286}, {9550,0.02986}, {9600,0.03243}, {9650,0.02843}, {9700,0.02471}, {9750,0.02486}, {9800,0.02471}, {9850,0.02371}, {9900,0.03957}, {9950,0.04129}, {10000,0.03629}, {10100,0.03186}, {10200,0.02529}, {10300,0.02629}, {10400,0.04029}, {10500,0.03786}, {10600,0.02857}, {10700,0.02643}, {10800,0.04214}, {10900,0.03429}, {11000,0.02757}, {11100,0.04443}, {11200,0.02757}, {11300,0.04371}, {11400,0.03400}, {11500,0.03486}, {11600,0.04229}, {11700,0.02886}, {11800,0.03671}, {11900,0.03886}, {12000,0.03514}, {12100,0.05029}, {12200,0.03043}, {12300,0.04429}, {12400,0.04171}, {12500,0.03243}, {12600,0.04229}, {12700,0.05157}, {12800,0.03186}, {12900,0.03657}, {13000,0.04771}, {13100,0.05471}, {13200,0.04243}, {13300,0.03329}, {13400,0.03414}, {13500,0.04014}, {13600,0.04243}, {13700,0.04857}, {13800,0.04986}, {13900,0.05557}, {14000,0.05629}, {14100,0.05614}, {14200,0.05014}, {14300,0.05171}, {14400,0.04271}, {14500,0.04157}, {14600,0.03757}, {14700,0.03771}, {14800,0.05643}, {14900,0.06714}, {15000,0.05429}, {15100,0.04286}, {15200,0.04986}, {15300,0.06186}, {15400,0.05629}, {15500,0.03957}, {15600,0.06457}, {15700,0.05514}, {15800,0.04014}, {15900,0.07386}, {16000,0.04543}, {16100,0.06557}, {16200,0.04900}, {16300,0.06543}, {16400,0.05143}, {16500,0.06929}, {16600,0.04929}, {16700,0.07657}, {16800,0.04329}, {16900,0.06886}, {17000,0.06657}, {17100,0.04871}, {17200,0.07314}, {17300,0.07543}, {17400,0.04429}, {17500,0.05571}, {17600,0.08186}, {17700,0.07229}, {17800,0.05100}, {17900,0.05043}, {18000,0.05386}, {18100,0.07329}, {18200,0.07929}, {18300,0.07757}, {18400,0.08614}, {18500,0.07957}, {18600,0.08414}, {18700,0.08457}, {18800,0.08600}, {18900,0.08643}, {19000,0.08357}, {19100,0.08400}, {19200,0.08471}, {19300,0.06671}, {19400,0.05814}, {19500,0.05629}, {19600,0.07757}, {19700,0.09429}, {19800,0.06986}, {19900,0.05786}, {20000,0.08480}};
data["big_flat"]["beta; Parametricity"]["cbv"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000018957}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000018957}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000018957}, {52,0.000000000}, {53,0.000000000}, {54,0.000018957}, {55,0.000000000}, {56,0.000000000}, {57,0.000018957}, {58,0.000018957}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000018957}, {75,0.000014218}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000018957}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000018957}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000018957}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000018957}, {162,0.000000000}, {163,0.000018957}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000018957}, {174,0.000000000}, {175,0.000018957}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000037915}, {180,0.000018957}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000018957}, {185,0.000037915}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000018957}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000018957}, {197,0.000018957}, {198,0.000000000}, {199,0.000018957}, {200,0.000000000}, {201,0.000056872}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000018957}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000018957}, {217,0.000018957}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000018957}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000018957}, {233,0.000000000}, {234,0.000018957}, {235,0.000018957}, {236,0.000000000}, {237,0.000018957}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000037915}, {244,0.000000000}, {245,0.000018957}, {246,0.000000000}, {247,0.000000000}, {248,0.000018957}, {249,0.000018957}, {250,0.000000000}, {251,0.000000000}, {252,0.000018957}, {253,0.000018957}, {254,0.000000000}, {255,0.000037915}, {256,0.000000000}, {257,0.000018957}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000014218}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000018957}, {273,0.000000000}, {274,0.000000000}, {275,0.000018957}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000018957}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000018957}, {294,0.000037915}, {295,0.000018957}, {296,0.000000000}, {297,0.000018957}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000018957}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000018957}, {308,0.000018957}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000037915}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000052133}, {324,0.000000000}, {325,0.000018957}, {326,0.000000000}, {327,0.000000000}, {328,0.000018957}, {329,0.000018957}, {330,0.000000000}, {331,0.000000000}, {332,0.000018957}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000018957}, {337,0.000000000}, {338,0.000018957}, {339,0.000000000}, {340,0.000000000}, {341,0.000018957}, {342,0.000018957}, {343,0.000000000}, {344,0.000037915}, {345,0.000000000}, {346,0.000000000}, {347,0.000014218}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000018957}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000018957}, {361,0.000018957}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000018957}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000018957}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000018957}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000018957}, {389,0.000000000}, {390,0.000000000}, {391,0.000018957}, {392,0.000000000}, {393,0.000000000}, {394,0.000037915}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000018957}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000018957}, {415,0.000000000}, {416,0.000018957}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000018957}, {428,0.000018957}, {429,0.000000000}, {430,0.000000000}, {431,0.000018957}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000018957}, {436,0.000037915}, {437,0.000018957}, {438,0.000000000}, {439,0.000018957}, {440,0.000018957}, {441,0.000018957}, {442,0.000000000}, {443,0.000018957}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000018957}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000018957}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000018957}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000018957}, {470,0.000000000}, {471,0.000000000}, {472,0.000018957}, {473,0.000018957}, {474,0.000000000}, {475,0.000018957}, {476,0.000018957}, {477,0.000014218}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000018957}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000018957}, {488,0.000000000}, {489,0.000018957}, {490,0.000000000}, {491,0.000018957}, {492,0.000018957}, {493,0.000018957}, {494,0.000000000}, {495,0.000018957}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000018957}, {500,0.000000000}, {505,0.000018957}, {510,0.000000000}, {515,0.000018957}, {520,0.000000000}, {525,0.000018957}, {530,0.000018957}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000018957}, {560,0.000014218}, {565,0.000000000}, {570,0.000000000}, {575,0.000018957}, {580,0.000018957}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000018957}, {615,0.000000000}, {620,0.000018957}, {625,0.000000000}, {630,0.000018957}, {635,0.000037915}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000018957}, {665,0.000000000}, {670,0.000000000}, {675,0.000018957}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000018957}, {700,0.000014218}, {705,0.000037915}, {710,0.000000000}, {715,0.000018957}, {720,0.000000000}, {725,0.000018957}, {730,0.000000000}, {735,0.000000000}, {740,0.000018957}, {745,0.000037915}, {750,0.000018957}, {755,0.000018957}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000018957}, {790,0.000037915}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000018957}, {825,0.000000000}, {830,0.000018957}, {835,0.000000000}, {840,0.000018957}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000018957}, {880,0.000018957}, {885,0.000000000}, {890,0.000018957}, {895,0.000000000}, {900,0.000000000}, {905,0.000018957}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000014218}, {930,0.000033175}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000018957}, {980,0.000018957}, {985,0.000000000}, {990,0.000014218}, {995,0.000018957}, {1000,0.000018957}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000018957}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000056872}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000018957}, {1120,0.000037915}, {1130,0.000037915}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000018957}, {1190,0.000018957}, {1200,0.000000000}, {1210,0.000018957}, {1220,0.000037915}, {1230,0.000037915}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000018957}, {1300,0.000018957}, {1310,0.000018957}, {1320,0.000000000}, {1330,0.000018957}, {1340,0.000014218}, {1350,0.000000000}, {1360,0.000018957}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000018957}, {1430,0.000037915}, {1440,0.000037915}, {1450,0.000000000}, {1460,0.000037915}, {1470,0.000018957}, {1480,0.000000000}, {1490,0.000018957}, {1500,0.000000000}, {1510,0.000018957}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000018957}, {1550,0.000000000}, {1560,0.000018957}, {1570,0.000018957}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000090047}, {1610,0.000000000}, {1620,0.000018957}, {1630,0.000037915}, {1640,0.000018957}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000018957}, {1680,0.000018957}, {1690,0.000000000}, {1700,0.000014218}, {1710,0.000056872}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000014218}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000037915}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000018957}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000075829}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000018957}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000018957}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000071090}, {2750,0.000000000}, {2800,0.000037915}, {2850,0.000018957}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000018957}, {3050,0.000000000}, {3100,0.000018957}, {3150,0.000018957}, {3200,0.000000000}, {3250,0.000018957}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000018957}, {3450,0.000018957}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000018957}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000018957}, {3900,0.000056872}, {3950,0.000056872}, {4000,0.000000000}, {4050,0.000056872}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000075829}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000037915}, {4500,0.000000000}, {4550,0.000037915}, {4600,0.000094787}, {4650,0.000071090}, {4700,0.000094787}, {4750,0.000094787}, {4800,0.000000000}, {4850,0.000033175}, {4900,0.000000000}, {4950,0.000014218}, {5000,0.000037915}, {5050,0.00000}, {5100,0.00057}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00057}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00057}, {5750,0.00000}, {5800,0.00057}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00057}, {6500,0.00043}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00057}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00057}, {7400,0.00000}, {7450,0.00000}, {7500,0.00057}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00057}, {7800,0.00057}, {7850,0.00000}, {7900,0.00057}, {7950,0.00057}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00057}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00057}, {9050,0.00000}, {9100,0.00057}, {9150,0.00057}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00043}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00057}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00057}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["beta; Parametricity"]["eval lazy"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000502370}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000511848}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000009479}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000478673}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000511848}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000886256}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000004739}, {1340,0.000000000}, {1350,0.000004739}, {1360,0.001734597}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000004739}, {1400,0.000000000}, {1410,0.000004739}, {1420,0.000000000}, {1430,0.000014218}, {1440,0.000000000}, {1450,0.000004739}, {1460,0.000004739}, {1470,0.000009479}, {1480,0.000014218}, {1490,0.000000000}, {1500,0.000018957}, {1510,0.000018957}, {1520,0.000028436}, {1530,0.000028436}, {1540,0.000037915}, {1550,0.000033175}, {1560,0.000071090}, {1570,0.000066351}, {1580,0.000099526}, {1590,0.000085308}, {1600,0.000104265}, {1610,0.000109005}, {1620,0.000113744}, {1630,0.000099526}, {1640,0.000151659}, {1650,0.000170616}, {1660,0.000023697}, {1670,0.000260664}, {1680,0.000260664}, {1690,0.000383886}, {1700,0.000431280}, {1710,0.000464455}, {1720,0.000559242}, {1730,0.000644550}, {1740,0.000350711}, {1750,0.000758294}, {1760,0.000829384}, {1770,0.000848341}, {1780,0.000867299}, {1790,0.000706161}, {1800,0.000924171}, {1810,0.000691943}, {1820,0.000919431}, {1830,0.000971564}, {1840,0.000881517}, {1850,0.001000000}, {1860,0.000886256}, {1870,0.001000000}, {1880,0.001000000}, {1890,0.000990521}, {1900,0.001000000}, {1910,0.001000000}, {1920,0.001000000}, {1930,0.000990521}, {1940,0.001000000}, {1950,0.001000000}, {1960,0.001000000}, {1970,0.001000000}, {1980,0.001000000}, {1990,0.001000000}, {2000,0.001000000}, {2050,0.001000000}, {2100,0.001000000}, {2150,0.001000000}, {2200,0.001000000}, {2250,0.001000000}, {2300,0.001000000}, {2350,0.001000000}, {2400,0.001000000}, {2450,0.001000000}, {2500,0.001000000}, {2550,0.001018957}, {2600,0.001033175}, {2650,0.001037915}, {2700,0.001000000}, {2750,0.001066351}, {2800,0.001094787}, {2850,0.001071090}, {2900,0.001109005}, {2950,0.001009479}, {3000,0.001165877}, {3050,0.001246445}, {3100,0.001018957}, {3150,0.001246445}, {3200,0.001345972}, {3250,0.001407583}, {3300,0.001426540}, {3350,0.001568720}, {3400,0.001635071}, {3450,0.001255924}, {3500,0.001530806}, {3550,0.001876777}, {3600,0.001952607}, {3650,0.001966825}, {3700,0.001857820}, {3750,0.001876777}, {3800,0.002028436}, {3850,0.002047393}, {3900,0.002061611}, {3950,0.002004739}, {4000,0.002004739}, {4050,0.002109005}, {4100,0.002123223}, {4150,0.002146919}, {4200,0.002222749}, {4250,0.002213270}, {4300,0.002246445}, {4350,0.002303318}, {4400,0.002336493}, {4450,0.002331754}, {4500,0.002322275}, {4550,0.002379147}, {4600,0.002459716}, {4650,0.002492891}, {4700,0.002530806}, {4750,0.002568720}, {4800,0.002606635}, {4850,0.002620853}, {4900,0.002663507}, {4950,0.002748815}, {5000,0.002900474}, {5050,0.00214}, {5100,0.00243}, {5150,0.00257}, {5200,0.00271}, {5250,0.00286}, {5300,0.00257}, {5350,0.00271}, {5400,0.00257}, {5450,0.00271}, {5500,0.00314}, {5550,0.00314}, {5600,0.00757}, {5650,0.00586}, {5700,0.00300}, {5750,0.00329}, {5800,0.00314}, {5850,0.00657}, {5900,0.00300}, {5950,0.00329}, {6000,0.00314}, {6050,0.00300}, {6100,0.00329}, {6150,0.01000}, {6200,0.00300}, {6250,0.00343}, {6300,0.00614}, {6350,0.00300}, {6400,0.00343}, {6450,0.00329}, {6500,0.00343}, {6550,0.00357}, {6600,0.00314}, {6650,0.00386}, {6700,0.00314}, {6750,0.00414}, {6800,0.00729}, {6850,0.00414}, {6900,0.00343}, {6950,0.00414}, {7000,0.00343}, {7050,0.00414}, {7100,0.00671}, {7150,0.00429}, {7200,0.00329}, {7250,0.00886}, {7300,0.00371}, {7350,0.00729}, {7400,0.00400}, {7450,0.00714}, {7500,0.00429}, {7550,0.00371}, {7600,0.00400}, {7650,0.00443}, {7700,0.00414}, {7750,0.00429}, {7800,0.00443}, {7850,0.00429}, {7900,0.00429}, {7950,0.00471}, {8000,0.00457}, {8050,0.00400}, {8100,0.00671}, {8150,0.00514}, {8200,0.00443}, {8250,0.00400}, {8300,0.00457}, {8350,0.01100}, {8400,0.00486}, {8450,0.00457}, {8500,0.00400}, {8550,0.01029}, {8600,0.00457}, {8650,0.01114}, {8700,0.00543}, {8750,0.00500}, {8800,0.00486}, {8850,0.00457}, {8900,0.00429}, {8950,0.00414}, {9000,0.00886}, {9050,0.01186}, {9100,0.00457}, {9150,0.00486}, {9200,0.00514}, {9250,0.00500}, {9300,0.00500}, {9350,0.00514}, {9400,0.00514}, {9450,0.00557}, {9500,0.01186}, {9550,0.00971}, {9600,0.00486}, {9650,0.00500}, {9700,0.00500}, {9750,0.00543}, {9800,0.00586}, {9850,0.00571}, {9900,0.01286}, {9950,0.00914}, {10000,0.01100}, {10100,0.00500}, {10200,0.00557}, {10300,0.00600}, {10400,0.01157}, {10500,0.00843}, {10600,0.00557}, {10700,0.00671}, {10800,0.00586}, {10900,0.00529}, {11000,0.00657}, {11100,0.00814}, {11200,0.00629}, {11300,0.00786}, {11400,0.00571}, {11500,0.00686}, {11600,0.00600}, {11700,0.00686}, {11800,0.00600}, {11900,0.00857}, {12000,0.00629}, {12100,0.00929}, {12200,0.00757}, {12300,0.00614}, {12400,0.00700}, {12500,0.00786}, {12600,0.00643}, {12700,0.00829}, {12800,0.01171}, {12900,0.00743}, {13000,0.00671}, {13100,0.00671}, {13200,0.01186}, {13300,0.00971}, {13400,0.01229}, {13500,0.00786}, {13600,0.00729}, {13700,0.00700}, {13800,0.00714}, {13900,0.00700}, {14000,0.00714}, {14100,0.00714}, {14200,0.00743}, {14300,0.00757}, {14400,0.00843}, {14500,0.01086}, {14600,0.00786}, {14700,0.01071}, {14800,0.00771}, {14900,0.00771}, {15000,0.00814}, {15100,0.01014}, {15200,0.00786}, {15300,0.00786}, {15400,0.01529}, {15500,0.01214}, {15600,0.00814}, {15700,0.01329}, {15800,0.00814}, {15900,0.00829}, {16000,0.01400}, {16100,0.00843}, {16200,0.00843}, {16300,0.00857}, {16400,0.00857}, {16500,0.00857}, {16600,0.01286}, {16700,0.00886}, {16800,0.00886}, {16900,0.01200}, {17000,0.00886}, {17100,0.00914}, {17200,0.01243}, {17300,0.00914}, {17400,0.00914}, {17500,0.01300}, {17600,0.01586}, {17700,0.00943}, {17800,0.00957}, {17900,0.00957}, {18000,0.01014}, {18100,0.01614}, {18200,0.01057}, {18300,0.01400}, {18400,0.01371}, {18500,0.01643}, {18600,0.01743}, {18700,0.01700}, {18800,0.01500}, {18900,0.01757}, {19000,0.01157}, {19100,0.01029}, {19200,0.01114}, {19300,0.01029}, {19400,0.01043}, {19500,0.01029}, {19600,0.01471}, {19700,0.01843}, {19800,0.01043}, {19900,0.01057}, {20000,0.02840}};
data["big_flat"]["beta; Parametricity"]["eval lazy"]["user"] = {{1,0.000014218}, {2,0.000018957}, {3,0.000056872}, {4,0.000018957}, {5,0.000018957}, {6,0.000018957}, {7,0.000047393}, {8,0.000033175}, {9,0.000037915}, {10,0.000018957}, {11,0.000033175}, {12,0.000085308}, {13,0.000047393}, {14,0.000033175}, {15,0.000080569}, {16,0.000090047}, {17,0.000033175}, {18,0.000014218}, {19,0.000042654}, {20,0.000000000}, {21,0.000014218}, {22,0.000018957}, {23,0.000037915}, {24,0.000028436}, {25,0.000018957}, {26,0.000033175}, {27,0.000033175}, {28,0.000085308}, {29,0.000075829}, {30,0.000056872}, {31,0.000014218}, {32,0.000018957}, {33,0.000047393}, {34,0.000094787}, {35,0.000033175}, {36,0.000033175}, {37,0.000061611}, {38,0.000066351}, {39,0.000071090}, {40,0.000061611}, {41,0.000052133}, {42,0.000056872}, {43,0.000052133}, {44,0.000047393}, {45,0.000080569}, {46,0.000000000}, {47,0.000033175}, {48,0.000061611}, {49,0.000056872}, {50,0.000113744}, {51,0.000071090}, {52,0.000056872}, {53,0.000090047}, {54,0.000047393}, {55,0.000037915}, {56,0.000033175}, {57,0.000000000}, {58,0.000118483}, {59,0.000061611}, {60,0.000080569}, {61,0.000066351}, {62,0.000080569}, {63,0.000109005}, {64,0.000142180}, {65,0.000037915}, {66,0.000037915}, {67,0.000085308}, {68,0.000127962}, {69,0.000127962}, {70,0.000028436}, {71,0.000037915}, {72,0.000018957}, {73,0.000113744}, {74,0.000028436}, {75,0.000061611}, {76,0.000066351}, {77,0.000142180}, {78,0.000137441}, {79,0.000090047}, {80,0.000071090}, {81,0.000109005}, {82,0.000047393}, {83,0.000080569}, {84,0.000042654}, {85,0.000033175}, {86,0.000066351}, {87,0.000075829}, {88,0.000066351}, {89,0.000056872}, {90,0.000109005}, {91,0.000052133}, {92,0.000146919}, {93,0.000014218}, {94,0.000066351}, {95,0.000099526}, {96,0.000056872}, {97,0.000090047}, {98,0.000052133}, {99,0.000033175}, {100,0.000113744}, {101,0.000066351}, {102,0.000080569}, {103,0.000071090}, {104,0.000052133}, {105,0.000109005}, {106,0.000047393}, {107,0.000151659}, {108,0.000075829}, {109,0.000492891}, {110,0.000080569}, {111,0.000066351}, {112,0.000137441}, {113,0.000123223}, {114,0.000094787}, {115,0.000170616}, {116,0.000061611}, {117,0.000118483}, {118,0.000085308}, {119,0.000156398}, {120,0.000066351}, {121,0.000094787}, {122,0.000014218}, {123,0.000066351}, {124,0.000104265}, {125,0.000099526}, {126,0.000118483}, {127,0.000132701}, {128,0.000104265}, {129,0.000137441}, {130,0.000080569}, {131,0.000123223}, {132,0.000090047}, {133,0.000137441}, {134,0.000066351}, {135,0.000094787}, {136,0.000170616}, {137,0.000194313}, {138,0.000137441}, {139,0.000061611}, {140,0.000222749}, {141,0.000099526}, {142,0.000066351}, {143,0.000066351}, {144,0.000066351}, {145,0.000042654}, {146,0.000099526}, {147,0.000071090}, {148,0.000047393}, {149,0.000066351}, {150,0.000113744}, {151,0.000127962}, {152,0.000052133}, {153,0.000104265}, {154,0.000123223}, {155,0.000189573}, {156,0.000146919}, {157,0.000113744}, {158,0.000123223}, {159,0.000047393}, {160,0.000066351}, {161,0.000137441}, {162,0.000127962}, {163,0.000132701}, {164,0.000085308}, {165,0.000109005}, {166,0.000161137}, {167,0.000118483}, {168,0.000175355}, {169,0.000047393}, {170,0.000161137}, {171,0.000180095}, {172,0.000094787}, {173,0.000080569}, {174,0.000080569}, {175,0.000085308}, {176,0.000123223}, {177,0.000099526}, {178,0.000184834}, {179,0.000559242}, {180,0.000222749}, {181,0.000056872}, {182,0.000127962}, {183,0.000123223}, {184,0.000094787}, {185,0.000080569}, {186,0.000113744}, {187,0.000132701}, {188,0.000066351}, {189,0.000075829}, {190,0.000161137}, {191,0.000175355}, {192,0.000094787}, {193,0.000142180}, {194,0.000161137}, {195,0.000127962}, {196,0.000109005}, {197,0.000165877}, {198,0.000085308}, {199,0.000165877}, {200,0.000099526}, {201,0.000161137}, {202,0.000132701}, {203,0.000156398}, {204,0.000151659}, {205,0.000094787}, {206,0.000184834}, {207,0.000071090}, {208,0.000075829}, {209,0.000222749}, {210,0.000161137}, {211,0.000047393}, {212,0.000061611}, {213,0.000165877}, {214,0.000156398}, {215,0.000052133}, {216,0.000208531}, {217,0.000123223}, {218,0.000161137}, {219,0.000161137}, {220,0.000194313}, {221,0.000151659}, {222,0.000132701}, {223,0.000170616}, {224,0.000127962}, {225,0.000123223}, {226,0.000113744}, {227,0.000175355}, {228,0.000241706}, {229,0.000156398}, {230,0.000203791}, {231,0.000184834}, {232,0.000109005}, {233,0.000189573}, {234,0.000142180}, {235,0.000118483}, {236,0.000146919}, {237,0.000127962}, {238,0.000213270}, {239,0.000194313}, {240,0.000255924}, {241,0.000151659}, {242,0.000151659}, {243,0.000180095}, {244,0.000123223}, {245,0.000175355}, {246,0.000165877}, {247,0.000331754}, {248,0.000227488}, {249,0.000118483}, {250,0.000066351}, {251,0.000132701}, {252,0.000104265}, {253,0.000137441}, {254,0.000194313}, {255,0.000156398}, {256,0.000161137}, {257,0.000203791}, {258,0.000104265}, {259,0.000094787}, {260,0.000132701}, {261,0.000142180}, {262,0.000189573}, {263,0.000161137}, {264,0.000194313}, {265,0.000270142}, {266,0.000199052}, {267,0.000184834}, {268,0.000165877}, {269,0.000180095}, {270,0.000118483}, {271,0.000213270}, {272,0.000113744}, {273,0.000203791}, {274,0.000170616}, {275,0.000071090}, {276,0.000184834}, {277,0.000241706}, {278,0.000232227}, {279,0.000165877}, {280,0.000222749}, {281,0.000151659}, {282,0.000265403}, {283,0.000236967}, {284,0.000218009}, {285,0.000232227}, {286,0.000085308}, {287,0.000180095}, {288,0.000246445}, {289,0.000099526}, {290,0.000146919}, {291,0.000071090}, {292,0.000184834}, {293,0.000218009}, {294,0.000274882}, {295,0.000246445}, {296,0.000118483}, {297,0.000184834}, {298,0.000142180}, {299,0.000184834}, {300,0.000222749}, {301,0.000189573}, {302,0.000194313}, {303,0.000218009}, {304,0.000246445}, {305,0.000236967}, {306,0.000194313}, {307,0.000327014}, {308,0.000203791}, {309,0.000151659}, {310,0.000194313}, {311,0.000246445}, {312,0.000203791}, {313,0.000236967}, {314,0.000279621}, {315,0.000180095}, {316,0.000274882}, {317,0.000151659}, {318,0.000151659}, {319,0.000270142}, {320,0.000184834}, {321,0.000180095}, {322,0.000218009}, {323,0.000151659}, {324,0.000289100}, {325,0.000298578}, {326,0.000132701}, {327,0.000123223}, {328,0.000175355}, {329,0.000293839}, {330,0.000127962}, {331,0.000232227}, {332,0.000151659}, {333,0.000246445}, {334,0.000142180}, {335,0.000213270}, {336,0.000142180}, {337,0.000251185}, {338,0.000241706}, {339,0.000222749}, {340,0.000118483}, {341,0.000298578}, {342,0.000156398}, {343,0.000156398}, {344,0.000132701}, {345,0.000227488}, {346,0.000246445}, {347,0.000303318}, {348,0.000260664}, {349,0.000725118}, {350,0.000203791}, {351,0.000132701}, {352,0.000289100}, {353,0.000985782}, {354,0.000265403}, {355,0.000236967}, {356,0.000350711}, {357,0.000355450}, {358,0.000279621}, {359,0.000194313}, {360,0.000265403}, {361,0.000165877}, {362,0.000123223}, {363,0.000255924}, {364,0.000213270}, {365,0.000189573}, {366,0.000274882}, {367,0.000317536}, {368,0.000208531}, {369,0.000189573}, {370,0.000118483}, {371,0.000170616}, {372,0.000289100}, {373,0.000213270}, {374,0.000241706}, {375,0.000241706}, {376,0.000270142}, {377,0.000255924}, {378,0.000189573}, {379,0.000175355}, {380,0.000203791}, {381,0.000270142}, {382,0.000213270}, {383,0.000189573}, {384,0.000151659}, {385,0.000189573}, {386,0.000203791}, {387,0.000265403}, {388,0.000199052}, {389,0.000156398}, {390,0.000104265}, {391,0.000255924}, {392,0.000232227}, {393,0.000146919}, {394,0.000165877}, {395,0.000109005}, {396,0.000251185}, {397,0.000327014}, {398,0.000113744}, {399,0.000265403}, {400,0.000331754}, {401,0.000151659}, {402,0.000132701}, {403,0.000293839}, {404,0.000165877}, {405,0.000298578}, {406,0.000123223}, {407,0.000327014}, {408,0.000194313}, {409,0.000289100}, {410,0.000364929}, {411,0.000274882}, {412,0.000398104}, {413,0.000241706}, {414,0.000388626}, {415,0.000203791}, {416,0.000232227}, {417,0.000165877}, {418,0.000213270}, {419,0.000260664}, {420,0.000251185}, {421,0.000232227}, {422,0.000199052}, {423,0.000146919}, {424,0.000341232}, {425,0.000232227}, {426,0.000213270}, {427,0.000341232}, {428,0.000236967}, {429,0.000293839}, {430,0.000199052}, {431,0.000388626}, {432,0.000293839}, {433,0.000260664}, {434,0.000279621}, {435,0.000293839}, {436,0.000232227}, {437,0.000369668}, {438,0.000274882}, {439,0.000246445}, {440,0.000298578}, {441,0.000189573}, {442,0.000208531}, {443,0.000208531}, {444,0.000184834}, {445,0.000312796}, {446,0.000222749}, {447,0.000331754}, {448,0.000312796}, {449,0.000289100}, {450,0.000355450}, {451,0.000189573}, {452,0.000236967}, {453,0.000213270}, {454,0.000255924}, {455,0.000213270}, {456,0.000199052}, {457,0.000227488}, {458,0.000180095}, {459,0.000270142}, {460,0.000312796}, {461,0.000241706}, {462,0.000279621}, {463,0.000170616}, {464,0.000308057}, {465,0.000232227}, {466,0.000246445}, {467,0.000279621}, {468,0.000175355}, {469,0.000251185}, {470,0.000236967}, {471,0.000265403}, {472,0.000236967}, {473,0.000165877}, {474,0.000293839}, {475,0.000284360}, {476,0.000184834}, {477,0.000270142}, {478,0.000327014}, {479,0.000327014}, {480,0.000355450}, {481,0.000255924}, {482,0.000246445}, {483,0.000327014}, {484,0.000345972}, {485,0.000194313}, {486,0.000227488}, {487,0.000379147}, {488,0.000350711}, {489,0.000142180}, {490,0.000312796}, {491,0.000255924}, {492,0.000298578}, {493,0.000341232}, {494,0.000232227}, {495,0.000502370}, {496,0.000298578}, {497,0.000312796}, {498,0.000317536}, {499,0.000232227}, {500,0.000279621}, {505,0.000156398}, {510,0.000289100}, {515,0.000322275}, {520,0.000374408}, {525,0.000236967}, {530,0.000355450}, {535,0.000369668}, {540,0.000222749}, {545,0.000345972}, {550,0.000360190}, {555,0.000232227}, {560,0.000284360}, {565,0.000345972}, {570,0.000383886}, {575,0.000241706}, {580,0.000289100}, {585,0.000497630}, {590,0.000445498}, {595,0.000322275}, {600,0.000350711}, {605,0.000341232}, {610,0.000289100}, {615,0.000345972}, {620,0.000331754}, {625,0.000298578}, {630,0.000331754}, {635,0.000374408}, {640,0.000521327}, {645,0.000426540}, {650,0.000341232}, {655,0.000298578}, {660,0.000336493}, {665,0.001127962}, {670,0.000360190}, {675,0.000350711}, {680,0.000450237}, {685,0.000336493}, {690,0.000388626}, {695,0.000402844}, {700,0.000516588}, {705,0.000341232}, {710,0.000360190}, {715,0.000497630}, {720,0.000663507}, {725,0.000459716}, {730,0.000383886}, {735,0.000507109}, {740,0.000369668}, {745,0.000388626}, {750,0.000369668}, {755,0.000478673}, {760,0.000369668}, {765,0.000545024}, {770,0.000535545}, {775,0.000554502}, {780,0.000426540}, {785,0.000464455}, {790,0.000502370}, {795,0.000568720}, {800,0.000388626}, {805,0.000417062}, {810,0.000398104}, {815,0.000454976}, {820,0.000317536}, {825,0.000341232}, {830,0.000308057}, {835,0.000360190}, {840,0.000417062}, {845,0.000464455}, {850,0.000478673}, {855,0.000502370}, {860,0.000260664}, {865,0.000502370}, {870,0.000440758}, {875,0.000454976}, {880,0.000374408}, {885,0.000530806}, {890,0.000511848}, {895,0.000327014}, {900,0.000388626}, {905,0.000440758}, {910,0.000545024}, {915,0.000554502}, {920,0.000426540}, {925,0.000483412}, {930,0.000649289}, {935,0.000436019}, {940,0.000540284}, {945,0.000478673}, {950,0.000507109}, {955,0.000526066}, {960,0.000464455}, {965,0.000563981}, {970,0.000516588}, {975,0.000563981}, {980,0.000445498}, {985,0.000469194}, {990,0.000412322}, {995,0.000706161}, {1000,0.000516588}, {1010,0.000559242}, {1020,0.000597156}, {1030,0.000450237}, {1040,0.000483412}, {1050,0.000592417}, {1060,0.000781991}, {1070,0.000559242}, {1080,0.000715640}, {1090,0.000526066}, {1100,0.000526066}, {1110,0.000639810}, {1120,0.000473934}, {1130,0.000630332}, {1140,0.000691943}, {1150,0.000507109}, {1160,0.000701422}, {1170,0.000682464}, {1180,0.000658768}, {1190,0.000587678}, {1200,0.000715640}, {1210,0.000687204}, {1220,0.000758294}, {1230,0.000758294}, {1240,0.000710900}, {1250,0.000549763}, {1260,0.000668246}, {1270,0.000436019}, {1280,0.000720379}, {1290,0.000421801}, {1300,0.000677725}, {1310,0.000781991}, {1320,0.000744076}, {1330,0.000706161}, {1340,0.000772512}, {1350,0.000677725}, {1360,0.002189573}, {1370,0.000781991}, {1380,0.000739336}, {1390,0.000668246}, {1400,0.000848341}, {1410,0.000725118}, {1420,0.000573460}, {1430,0.000739336}, {1440,0.000933649}, {1450,0.000848341}, {1460,0.000630332}, {1470,0.000819905}, {1480,0.000691943}, {1490,0.000810427}, {1500,0.000748815}, {1510,0.000668246}, {1520,0.000786730}, {1530,0.000895735}, {1540,0.000672986}, {1550,0.001061611}, {1560,0.000668246}, {1570,0.000772512}, {1580,0.000957346}, {1590,0.000739336}, {1600,0.000739336}, {1610,0.000857820}, {1620,0.000829384}, {1630,0.000867299}, {1640,0.001075829}, {1650,0.001052133}, {1660,0.000909953}, {1670,0.000853081}, {1680,0.000834123}, {1690,0.001033175}, {1700,0.000853081}, {1710,0.000995261}, {1720,0.000919431}, {1730,0.001018957}, {1740,0.000748815}, {1750,0.000900474}, {1760,0.000758294}, {1770,0.001071090}, {1780,0.000990521}, {1790,0.000663507}, {1800,0.000886256}, {1810,0.000990521}, {1820,0.001071090}, {1830,0.001071090}, {1840,0.001094787}, {1850,0.001004739}, {1860,0.001151659}, {1870,0.000966825}, {1880,0.001085308}, {1890,0.000781991}, {1900,0.001014218}, {1910,0.001066351}, {1920,0.000985782}, {1930,0.000933649}, {1940,0.001146919}, {1950,0.001000000}, {1960,0.001260664}, {1970,0.001014218}, {1980,0.000947867}, {1990,0.001028436}, {2000,0.001071090}, {2050,0.001047393}, {2100,0.001113744}, {2150,0.001184834}, {2200,0.001222749}, {2250,0.001308057}, {2300,0.001440758}, {2350,0.001426540}, {2400,0.001303318}, {2450,0.001251185}, {2500,0.001521327}, {2550,0.001483412}, {2600,0.001345972}, {2650,0.001502370}, {2700,0.001440758}, {2750,0.001450237}, {2800,0.001464455}, {2850,0.001597156}, {2900,0.001767773}, {2950,0.001279621}, {3000,0.001763033}, {3050,0.001725118}, {3100,0.001819905}, {3150,0.001701422}, {3200,0.002028436}, {3250,0.001715640}, {3300,0.001810427}, {3350,0.001952607}, {3400,0.002094787}, {3450,0.001739336}, {3500,0.002033175}, {3550,0.002037915}, {3600,0.002199052}, {3650,0.002127962}, {3700,0.001715640}, {3750,0.002118483}, {3800,0.002203791}, {3850,0.002075829}, {3900,0.002180095}, {3950,0.002113744}, {4000,0.002085308}, {4050,0.002402844}, {4100,0.002132701}, {4150,0.002341232}, {4200,0.002663507}, {4250,0.002535545}, {4300,0.002578199}, {4350,0.002597156}, {4400,0.002417062}, {4450,0.002635071}, {4500,0.002559242}, {4550,0.002777251}, {4600,0.002796209}, {4650,0.002886256}, {4700,0.002947867}, {4750,0.002815166}, {4800,0.003061611}, {4850,0.002890995}, {4900,0.002962085}, {4950,0.003009479}, {5000,0.003251185}, {5050,0.00200}, {5100,0.00314}, {5150,0.00286}, {5200,0.00171}, {5250,0.00243}, {5300,0.00386}, {5350,0.00243}, {5400,0.00243}, {5450,0.00371}, {5500,0.00386}, {5550,0.00271}, {5600,0.00771}, {5650,0.00529}, {5700,0.00286}, {5750,0.00314}, {5800,0.00286}, {5850,0.00557}, {5900,0.00271}, {5950,0.00329}, {6000,0.00371}, {6050,0.00300}, {6100,0.00257}, {6150,0.00900}, {6200,0.00257}, {6250,0.00329}, {6300,0.00643}, {6350,0.00357}, {6400,0.00371}, {6450,0.00357}, {6500,0.00414}, {6550,0.00243}, {6600,0.00329}, {6650,0.00329}, {6700,0.00314}, {6750,0.00357}, {6800,0.00814}, {6850,0.00329}, {6900,0.00343}, {6950,0.00457}, {7000,0.00414}, {7050,0.00386}, {7100,0.00757}, {7150,0.00386}, {7200,0.00357}, {7250,0.00814}, {7300,0.00386}, {7350,0.00771}, {7400,0.00429}, {7450,0.00729}, {7500,0.00386}, {7550,0.00371}, {7600,0.00386}, {7650,0.00429}, {7700,0.00443}, {7750,0.00357}, {7800,0.00386}, {7850,0.00414}, {7900,0.00429}, {7950,0.00514}, {8000,0.00443}, {8050,0.00371}, {8100,0.00757}, {8150,0.00457}, {8200,0.00486}, {8250,0.00400}, {8300,0.00443}, {8350,0.01043}, {8400,0.00357}, {8450,0.00371}, {8500,0.00400}, {8550,0.01071}, {8600,0.00514}, {8650,0.01100}, {8700,0.00614}, {8750,0.00386}, {8800,0.00457}, {8850,0.00329}, {8900,0.00386}, {8950,0.00371}, {9000,0.01029}, {9050,0.01200}, {9100,0.00443}, {9150,0.00486}, {9200,0.00629}, {9250,0.00586}, {9300,0.00457}, {9350,0.00457}, {9400,0.00514}, {9450,0.00557}, {9500,0.01314}, {9550,0.01014}, {9600,0.00314}, {9650,0.00371}, {9700,0.00386}, {9750,0.00514}, {9800,0.00457}, {9850,0.00671}, {9900,0.01343}, {9950,0.00771}, {10000,0.01186}, {10100,0.00486}, {10200,0.00729}, {10300,0.00600}, {10400,0.01186}, {10500,0.00886}, {10600,0.00486}, {10700,0.00629}, {10800,0.00643}, {10900,0.00600}, {11000,0.00586}, {11100,0.00929}, {11200,0.00557}, {11300,0.00800}, {11400,0.00429}, {11500,0.00757}, {11600,0.00700}, {11700,0.00729}, {11800,0.00514}, {11900,0.00814}, {12000,0.00571}, {12100,0.01057}, {12200,0.00686}, {12300,0.00629}, {12400,0.00729}, {12500,0.00743}, {12600,0.00571}, {12700,0.00700}, {12800,0.01243}, {12900,0.00714}, {13000,0.00629}, {13100,0.00629}, {13200,0.01243}, {13300,0.00943}, {13400,0.01229}, {13500,0.00857}, {13600,0.00786}, {13700,0.00771}, {13800,0.00757}, {13900,0.00714}, {14000,0.00729}, {14100,0.00771}, {14200,0.00757}, {14300,0.00843}, {14400,0.00829}, {14500,0.01100}, {14600,0.00757}, {14700,0.01043}, {14800,0.00771}, {14900,0.00743}, {15000,0.00786}, {15100,0.01014}, {15200,0.00786}, {15300,0.00829}, {15400,0.01457}, {15500,0.01243}, {15600,0.00943}, {15700,0.01357}, {15800,0.00843}, {15900,0.00829}, {16000,0.01500}, {16100,0.00786}, {16200,0.00914}, {16300,0.00900}, {16400,0.00786}, {16500,0.00771}, {16600,0.01286}, {16700,0.00829}, {16800,0.00886}, {16900,0.01214}, {17000,0.00886}, {17100,0.01000}, {17200,0.01171}, {17300,0.00857}, {17400,0.00814}, {17500,0.01214}, {17600,0.01571}, {17700,0.00943}, {17800,0.00886}, {17900,0.00857}, {18000,0.01057}, {18100,0.01514}, {18200,0.01129}, {18300,0.01386}, {18400,0.01471}, {18500,0.01629}, {18600,0.01757}, {18700,0.01757}, {18800,0.01443}, {18900,0.01814}, {19000,0.01114}, {19100,0.01057}, {19200,0.01100}, {19300,0.00986}, {19400,0.01000}, {19500,0.01200}, {19600,0.01500}, {19700,0.01914}, {19800,0.01071}, {19900,0.01057}, {20000,0.02860}};
data["big_flat"]["beta; Parametricity"]["eval lazy"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000018957}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000014218}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000018957}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000018957}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000018957}, {89,0.000000000}, {90,0.000018957}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000018957}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000018957}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000018957}, {127,0.000018957}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000018957}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000018957}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000018957}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000018957}, {198,0.000000000}, {199,0.000000000}, {200,0.000018957}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000018957}, {211,0.000000000}, {212,0.000000000}, {213,0.000018957}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000018957}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000018957}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000018957}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000018957}, {276,0.000000000}, {277,0.000018957}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000018957}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000037915}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000018957}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000018957}, {361,0.000018957}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000014218}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000018957}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000018957}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000018957}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000037915}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000018957}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000018957}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000018957}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000018957}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000018957}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000018957}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000018957}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000018957}, {610,0.000018957}, {615,0.000000000}, {620,0.000018957}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000018957}, {645,0.000000000}, {650,0.000018957}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000018957}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000014218}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000018957}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000018957}, {825,0.000018957}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000014218}, {915,0.000018957}, {920,0.000018957}, {925,0.000000000}, {930,0.000018957}, {935,0.000000000}, {940,0.000000000}, {945,0.000018957}, {950,0.000000000}, {955,0.000000000}, {960,0.000018957}, {965,0.000000000}, {970,0.000000000}, {975,0.000018957}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000018957}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000018957}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000018957}, {1360,0.000018957}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000018957}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000018957}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000018957}, {1490,0.000000000}, {1500,0.000018957}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000018957}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000018957}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000018957}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000037915}, {1700,0.000018957}, {1710,0.000018957}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000018957}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000018957}, {1840,0.000018957}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000037915}, {1940,0.000000000}, {1950,0.000018957}, {1960,0.000018957}, {1970,0.000018957}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000075829}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000037915}, {2200,0.000000000}, {2250,0.000018957}, {2300,0.000000000}, {2350,0.000037915}, {2400,0.000000000}, {2450,0.000018957}, {2500,0.000018957}, {2550,0.000000000}, {2600,0.000018957}, {2650,0.000018957}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000037915}, {2850,0.000000000}, {2900,0.000018957}, {2950,0.000018957}, {3000,0.000000000}, {3050,0.000018957}, {3100,0.000000000}, {3150,0.000018957}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000033175}, {3350,0.000037915}, {3400,0.000000000}, {3450,0.000056872}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000037915}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000037915}, {3850,0.000018957}, {3900,0.000000000}, {3950,0.000018957}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000037915}, {4150,0.000000000}, {4200,0.000037915}, {4250,0.000037915}, {4300,0.000000000}, {4350,0.000056872}, {4400,0.000018957}, {4450,0.000018957}, {4500,0.000000000}, {4550,0.000018957}, {4600,0.000000000}, {4650,0.000018957}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000037915}, {4900,0.000018957}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.00000}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00057}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00057}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00057}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00057}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["beta; Parametricity"]["lazy beta iota"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000886256}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000028436}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000033175}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000004739}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000004739}, {1330,0.000000000}, {1340,0.000004739}, {1350,0.000004739}, {1360,0.000000000}, {1370,0.000004739}, {1380,0.000066351}, {1390,0.000014218}, {1400,0.000023697}, {1410,0.000014218}, {1420,0.000000000}, {1430,0.000023697}, {1440,0.000018957}, {1450,0.000033175}, {1460,0.000047393}, {1470,0.000042654}, {1480,0.000033175}, {1490,0.000004739}, {1500,0.000075829}, {1510,0.000071090}, {1520,0.000000000}, {1530,0.000075829}, {1540,0.000104265}, {1550,0.000123223}, {1560,0.000132701}, {1570,0.000127962}, {1580,0.000146919}, {1590,0.000151659}, {1600,0.000189573}, {1610,0.000151659}, {1620,0.000251185}, {1630,0.000227488}, {1640,0.000284360}, {1650,0.000308057}, {1660,0.000066351}, {1670,0.000393365}, {1680,0.000331754}, {1690,0.000478673}, {1700,0.000454976}, {1710,0.000526066}, {1720,0.000540284}, {1730,0.000578199}, {1740,0.000227488}, {1750,0.000654028}, {1760,0.000450237}, {1770,0.000748815}, {1780,0.000729858}, {1790,0.000350711}, {1800,0.000829384}, {1810,0.000478673}, {1820,0.000867299}, {1830,0.000862559}, {1840,0.000388626}, {1850,0.000867299}, {1860,0.000516588}, {1870,0.000914692}, {1880,0.000895735}, {1890,0.000398104}, {1900,0.000933649}, {1910,0.000952607}, {1920,0.000962085}, {1930,0.000511848}, {1940,0.000976303}, {1950,0.000971564}, {1960,0.000473934}, {1970,0.001000000}, {1980,0.000578199}, {1990,0.001000000}, {2000,0.000526066}, {2050,0.001000000}, {2100,0.000995261}, {2150,0.000649289}, {2200,0.001000000}, {2250,0.000838863}, {2300,0.001000000}, {2350,0.000909953}, {2400,0.001000000}, {2450,0.001000000}, {2500,0.001023697}, {2550,0.001037915}, {2600,0.001066351}, {2650,0.001090047}, {2700,0.001004739}, {2750,0.001137441}, {2800,0.001142180}, {2850,0.001175355}, {2900,0.001279621}, {2950,0.001028436}, {3000,0.001331754}, {3050,0.001454976}, {3100,0.001066351}, {3150,0.001412322}, {3200,0.001549763}, {3250,0.001113744}, {3300,0.001497630}, {3350,0.001734597}, {3400,0.001739336}, {3450,0.001270142}, {3500,0.001530806}, {3550,0.001900474}, {3600,0.001924171}, {3650,0.001436019}, {3700,0.001014218}, {3750,0.001606635}, {3800,0.002118483}, {3850,0.002132701}, {3900,0.001881517}, {3950,0.001606635}, {4000,0.001118483}, {4050,0.001777251}, {4100,0.001829384}, {4150,0.007957346}, {4200,0.002478673}, {4250,0.002483412}, {4300,0.002516588}, {4350,0.002545024}, {4400,0.001995261}, {4450,0.001995261}, {4500,0.002085308}, {4550,0.002161137}, {4600,0.002170616}, {4650,0.002246445}, {4700,0.002236967}, {4750,0.002227488}, {4800,0.002308057}, {4850,0.002298578}, {4900,0.002928910}, {4950,0.002985782}, {5000,0.003033175}, {5050,0.00200}, {5100,0.00229}, {5150,0.00257}, {5200,0.00257}, {5250,0.00300}, {5300,0.00271}, {5350,0.00243}, {5400,0.00200}, {5450,0.00229}, {5500,0.00286}, {5550,0.00343}, {5600,0.00243}, {5650,0.00200}, {5700,0.00271}, {5750,0.00300}, {5800,0.00286}, {5850,0.00200}, {5900,0.00257}, {5950,0.00329}, {6000,0.00257}, {6050,0.00214}, {6100,0.00329}, {6150,0.00257}, {6200,0.00214}, {6250,0.00357}, {6300,0.00257}, {6350,0.00243}, {6400,0.00371}, {6450,0.00700}, {6500,0.00300}, {6550,0.00700}, {6600,0.00243}, {6650,0.00957}, {6700,0.00257}, {6750,0.00357}, {6800,0.00257}, {6850,0.00371}, {6900,0.00800}, {6950,0.00371}, {7000,0.00771}, {7050,0.00386}, {7100,0.00286}, {7150,0.00386}, {7200,0.00300}, {7250,0.00329}, {7300,0.00300}, {7350,0.00357}, {7400,0.00357}, {7450,0.00300}, {7500,0.01143}, {7550,0.00300}, {7600,0.00357}, {7650,0.00414}, {7700,0.00300}, {7750,0.00371}, {7800,0.00400}, {7850,0.00314}, {7900,0.00357}, {7950,0.01229}, {8000,0.00300}, {8050,0.00300}, {8100,0.00386}, {8150,0.00457}, {8200,0.00329}, {8250,0.00329}, {8300,0.00386}, {8350,0.00386}, {8400,0.00429}, {8450,0.00329}, {8500,0.00329}, {8550,0.00343}, {8600,0.00400}, {8650,0.00414}, {8700,0.00457}, {8750,0.00357}, {8800,0.00357}, {8850,0.00371}, {8900,0.00371}, {8950,0.00371}, {9000,0.00371}, {9050,0.00386}, {9100,0.01157}, {9150,0.00486}, {9200,0.00486}, {9250,0.00443}, {9300,0.00429}, {9350,0.00457}, {9400,0.00486}, {9450,0.01157}, {9500,0.00400}, {9550,0.00400}, {9600,0.00400}, {9650,0.00400}, {9700,0.00400}, {9750,0.00400}, {9800,0.00400}, {9850,0.00414}, {9900,0.00414}, {9950,0.00414}, {10000,0.00400}, {10100,0.00429}, {10200,0.00443}, {10300,0.00429}, {10400,0.00443}, {10500,0.00443}, {10600,0.00429}, {10700,0.01229}, {10800,0.01100}, {10900,0.00457}, {11000,0.01071}, {11100,0.00471}, {11200,0.00457}, {11300,0.00500}, {11400,0.00500}, {11500,0.00814}, {11600,0.00500}, {11700,0.00814}, {11800,0.00500}, {11900,0.00514}, {12000,0.00529}, {12100,0.00514}, {12200,0.01186}, {12300,0.00529}, {12400,0.01029}, {12500,0.01414}, {12600,0.00557}, {12700,0.00557}, {12800,0.00557}, {12900,0.00557}, {13000,0.00557}, {13100,0.00557}, {13200,0.00557}, {13300,0.00586}, {13400,0.01214}, {13500,0.01471}, {13600,0.00600}, {13700,0.00586}, {13800,0.00600}, {13900,0.00614}, {14000,0.00614}, {14100,0.00614}, {14200,0.00614}, {14300,0.00643}, {14400,0.01271}, {14500,0.01000}, {14600,0.00643}, {14700,0.00657}, {14800,0.00657}, {14900,0.00657}, {15000,0.01429}, {15100,0.00657}, {15200,0.00657}, {15300,0.00657}, {15400,0.01329}, {15500,0.00671}, {15600,0.00686}, {15700,0.01071}, {15800,0.00671}, {15900,0.00729}, {16000,0.00686}, {16100,0.00729}, {16200,0.01386}, {16300,0.00743}, {16400,0.01343}, {16500,0.00757}, {16600,0.00743}, {16700,0.01886}, {16800,0.00757}, {16900,0.00757}, {17000,0.00757}, {17100,0.00771}, {17200,0.00757}, {17300,0.00757}, {17400,0.00757}, {17500,0.00757}, {17600,0.00757}, {17700,0.02300}, {17800,0.00771}, {17900,0.00771}, {18000,0.00800}, {18100,0.00829}, {18200,0.01843}, {18300,0.00814}, {18400,0.01414}, {18500,0.01614}, {18600,0.01686}, {18700,0.01657}, {18800,0.01457}, {18900,0.00857}, {19000,0.00857}, {19100,0.01386}, {19200,0.00857}, {19300,0.00857}, {19400,0.00857}, {19500,0.00857}, {19600,0.01371}, {19700,0.00871}, {19800,0.00857}, {19900,0.00871}, {20000,0.00840}};
data["big_flat"]["beta; Parametricity"]["lazy beta iota"]["user"] = {{1,0.000033175}, {2,0.000000000}, {3,0.000014218}, {4,0.000000000}, {5,0.000000000}, {6,0.000018957}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000033175}, {11,0.000033175}, {12,0.000014218}, {13,0.000000000}, {14,0.000000000}, {15,0.000052133}, {16,0.000018957}, {17,0.000033175}, {18,0.000028436}, {19,0.000000000}, {20,0.000018957}, {21,0.000000000}, {22,0.000052133}, {23,0.000014218}, {24,0.000014218}, {25,0.000014218}, {26,0.000033175}, {27,0.000018957}, {28,0.000052133}, {29,0.000033175}, {30,0.000018957}, {31,0.000000000}, {32,0.000033175}, {33,0.000018957}, {34,0.000014218}, {35,0.000042654}, {36,0.000014218}, {37,0.000033175}, {38,0.000033175}, {39,0.000014218}, {40,0.000018957}, {41,0.000033175}, {42,0.000000000}, {43,0.000104265}, {44,0.000014218}, {45,0.000066351}, {46,0.000037915}, {47,0.000018957}, {48,0.000052133}, {49,0.000042654}, {50,0.000014218}, {51,0.000018957}, {52,0.000018957}, {53,0.000033175}, {54,0.000033175}, {55,0.000000000}, {56,0.000033175}, {57,0.000071090}, {58,0.000018957}, {59,0.000014218}, {60,0.000047393}, {61,0.000056872}, {62,0.000037915}, {63,0.000014218}, {64,0.000033175}, {65,0.000037915}, {66,0.000018957}, {67,0.000066351}, {68,0.000033175}, {69,0.000056872}, {70,0.000033175}, {71,0.000018957}, {72,0.000066351}, {73,0.000061611}, {74,0.000000000}, {75,0.000018957}, {76,0.000018957}, {77,0.000033175}, {78,0.000000000}, {79,0.000037915}, {80,0.000052133}, {81,0.000104265}, {82,0.000052133}, {83,0.000066351}, {84,0.000018957}, {85,0.000090047}, {86,0.000033175}, {87,0.000000000}, {88,0.000071090}, {89,0.000014218}, {90,0.000018957}, {91,0.000033175}, {92,0.000018957}, {93,0.000090047}, {94,0.000047393}, {95,0.000047393}, {96,0.000033175}, {97,0.000085308}, {98,0.000094787}, {99,0.000085308}, {100,0.000018957}, {101,0.000028436}, {102,0.000066351}, {103,0.000123223}, {104,0.000066351}, {105,0.000075829}, {106,0.000047393}, {107,0.000090047}, {108,0.000047393}, {109,0.000018957}, {110,0.000037915}, {111,0.000033175}, {112,0.000075829}, {113,0.000018957}, {114,0.000014218}, {115,0.000052133}, {116,0.000056872}, {117,0.000047393}, {118,0.000066351}, {119,0.000170616}, {120,0.000109005}, {121,0.000014218}, {122,0.000047393}, {123,0.000071090}, {124,0.000080569}, {125,0.000052133}, {126,0.000104265}, {127,0.000047393}, {128,0.000033175}, {129,0.000047393}, {130,0.000061611}, {131,0.000066351}, {132,0.000094787}, {133,0.000137441}, {134,0.000142180}, {135,0.000085308}, {136,0.000127962}, {137,0.000056872}, {138,0.000085308}, {139,0.000090047}, {140,0.000056872}, {141,0.000071090}, {142,0.000075829}, {143,0.000033175}, {144,0.000066351}, {145,0.000056872}, {146,0.000056872}, {147,0.000075829}, {148,0.000071090}, {149,0.000099526}, {150,0.000085308}, {151,0.000066351}, {152,0.000075829}, {153,0.000137441}, {154,0.000099526}, {155,0.000109005}, {156,0.000137441}, {157,0.000066351}, {158,0.000090047}, {159,0.000085308}, {160,0.000118483}, {161,0.000071090}, {162,0.000033175}, {163,0.000123223}, {164,0.000085308}, {165,0.000109005}, {166,0.000118483}, {167,0.000047393}, {168,0.000109005}, {169,0.000037915}, {170,0.000109005}, {171,0.000132701}, {172,0.000137441}, {173,0.000099526}, {174,0.000142180}, {175,0.000075829}, {176,0.000156398}, {177,0.000113744}, {178,0.000094787}, {179,0.000094787}, {180,0.000094787}, {181,0.000061611}, {182,0.000085308}, {183,0.000109005}, {184,0.000151659}, {185,0.000033175}, {186,0.000085308}, {187,0.000123223}, {188,0.000118483}, {189,0.000028436}, {190,0.000037915}, {191,0.000099526}, {192,0.000061611}, {193,0.000071090}, {194,0.000165877}, {195,0.000104265}, {196,0.000085308}, {197,0.000123223}, {198,0.000156398}, {199,0.000127962}, {200,0.000099526}, {201,0.000156398}, {202,0.000075829}, {203,0.000085308}, {204,0.000061611}, {205,0.000137441}, {206,0.000123223}, {207,0.000146919}, {208,0.000113744}, {209,0.000104265}, {210,0.000189573}, {211,0.000123223}, {212,0.000109005}, {213,0.000151659}, {214,0.000137441}, {215,0.000090047}, {216,0.000104265}, {217,0.000080569}, {218,0.000052133}, {219,0.000071090}, {220,0.000099526}, {221,0.000071090}, {222,0.000104265}, {223,0.000208531}, {224,0.000061611}, {225,0.000109005}, {226,0.000213270}, {227,0.000132701}, {228,0.000090047}, {229,0.000137441}, {230,0.000090047}, {231,0.000085308}, {232,0.000000000}, {233,0.000104265}, {234,0.000109005}, {235,0.000180095}, {236,0.000104265}, {237,0.000161137}, {238,0.000085308}, {239,0.000085308}, {240,0.000175355}, {241,0.000156398}, {242,0.000071090}, {243,0.000099526}, {244,0.000151659}, {245,0.000222749}, {246,0.000184834}, {247,0.000123223}, {248,0.000047393}, {249,0.000165877}, {250,0.000099526}, {251,0.000066351}, {252,0.000189573}, {253,0.000161137}, {254,0.000113744}, {255,0.000184834}, {256,0.000137441}, {257,0.000274882}, {258,0.000047393}, {259,0.000156398}, {260,0.000161137}, {261,0.000151659}, {262,0.000123223}, {263,0.000213270}, {264,0.000180095}, {265,0.000099526}, {266,0.000137441}, {267,0.000180095}, {268,0.000085308}, {269,0.000113744}, {270,0.000047393}, {271,0.000127962}, {272,0.000246445}, {273,0.000161137}, {274,0.000146919}, {275,0.000146919}, {276,0.000170616}, {277,0.000170616}, {278,0.000175355}, {279,0.000109005}, {280,0.000066351}, {281,0.000137441}, {282,0.000151659}, {283,0.000156398}, {284,0.000113744}, {285,0.000203791}, {286,0.000227488}, {287,0.000099526}, {288,0.000265403}, {289,0.000090047}, {290,0.000137441}, {291,0.000175355}, {292,0.000165877}, {293,0.000146919}, {294,0.000113744}, {295,0.000146919}, {296,0.000189573}, {297,0.000222749}, {298,0.000165877}, {299,0.000180095}, {300,0.000222749}, {301,0.000165877}, {302,0.000203791}, {303,0.000085308}, {304,0.000118483}, {305,0.000189573}, {306,0.000132701}, {307,0.000227488}, {308,0.000127962}, {309,0.000203791}, {310,0.000052133}, {311,0.000180095}, {312,0.000260664}, {313,0.000165877}, {314,0.000151659}, {315,0.000118483}, {316,0.000236967}, {317,0.000203791}, {318,0.000189573}, {319,0.000236967}, {320,0.000118483}, {321,0.000109005}, {322,0.000180095}, {323,0.000184834}, {324,0.000170616}, {325,0.000180095}, {326,0.000246445}, {327,0.000104265}, {328,0.000274882}, {329,0.000170616}, {330,0.000170616}, {331,0.000260664}, {332,0.000208531}, {333,0.000236967}, {334,0.000241706}, {335,0.000199052}, {336,0.000180095}, {337,0.000123223}, {338,0.000184834}, {339,0.000127962}, {340,0.000189573}, {341,0.000218009}, {342,0.000284360}, {343,0.000104265}, {344,0.000146919}, {345,0.000175355}, {346,0.000175355}, {347,0.000189573}, {348,0.000236967}, {349,0.000284360}, {350,0.000132701}, {351,0.000232227}, {352,0.000099526}, {353,0.000270142}, {354,0.000232227}, {355,0.000222749}, {356,0.000109005}, {357,0.000227488}, {358,0.000213270}, {359,0.000156398}, {360,0.000146919}, {361,0.000208531}, {362,0.000156398}, {363,0.000208531}, {364,0.000104265}, {365,0.000175355}, {366,0.000137441}, {367,0.000156398}, {368,0.000165877}, {369,0.000265403}, {370,0.000279621}, {371,0.000236967}, {372,0.000146919}, {373,0.000255924}, {374,0.000241706}, {375,0.000317536}, {376,0.000232227}, {377,0.000118483}, {378,0.000127962}, {379,0.000194313}, {380,0.000246445}, {381,0.000146919}, {382,0.000203791}, {383,0.000274882}, {384,0.000232227}, {385,0.000246445}, {386,0.000251185}, {387,0.000270142}, {388,0.000161137}, {389,0.000127962}, {390,0.000161137}, {391,0.000161137}, {392,0.000194313}, {393,0.000246445}, {394,0.000132701}, {395,0.000218009}, {396,0.000270142}, {397,0.000208531}, {398,0.000322275}, {399,0.000232227}, {400,0.000236967}, {401,0.000208531}, {402,0.000355450}, {403,0.000265403}, {404,0.000255924}, {405,0.000109005}, {406,0.000232227}, {407,0.000104265}, {408,0.000142180}, {409,0.000298578}, {410,0.000213270}, {411,0.000203791}, {412,0.000094787}, {413,0.000303318}, {414,0.000246445}, {415,0.000227488}, {416,0.000194313}, {417,0.000303318}, {418,0.000293839}, {419,0.000184834}, {420,0.000180095}, {421,0.000203791}, {422,0.000274882}, {423,0.000308057}, {424,0.000289100}, {425,0.000218009}, {426,0.000336493}, {427,0.000236967}, {428,0.000255924}, {429,0.000161137}, {430,0.000236967}, {431,0.000222749}, {432,0.000170616}, {433,0.000175355}, {434,0.000194313}, {435,0.000175355}, {436,0.000246445}, {437,0.000180095}, {438,0.000151659}, {439,0.000218009}, {440,0.000345972}, {441,0.000180095}, {442,0.000279621}, {443,0.000360190}, {444,0.000232227}, {445,0.000369668}, {446,0.000232227}, {447,0.000236967}, {448,0.000279621}, {449,0.000227488}, {450,0.000274882}, {451,0.000203791}, {452,0.000180095}, {453,0.000170616}, {454,0.000260664}, {455,0.000199052}, {456,0.000260664}, {457,0.000336493}, {458,0.000218009}, {459,0.000184834}, {460,0.000222749}, {461,0.000255924}, {462,0.000142180}, {463,0.000317536}, {464,0.000222749}, {465,0.000270142}, {466,0.000246445}, {467,0.000274882}, {468,0.000175355}, {469,0.000284360}, {470,0.000227488}, {471,0.000255924}, {472,0.000170616}, {473,0.000279621}, {474,0.000312796}, {475,0.000293839}, {476,0.000436019}, {477,0.000274882}, {478,0.000341232}, {479,0.000132701}, {480,0.000236967}, {481,0.000180095}, {482,0.000246445}, {483,0.000274882}, {484,0.000194313}, {485,0.000222749}, {486,0.000308057}, {487,0.000227488}, {488,0.000208531}, {489,0.000298578}, {490,0.000218009}, {491,0.000312796}, {492,0.000331754}, {493,0.000336493}, {494,0.000308057}, {495,0.000298578}, {496,0.000369668}, {497,0.000241706}, {498,0.000213270}, {499,0.000364929}, {500,0.000241706}, {505,0.000421801}, {510,0.000379147}, {515,0.000331754}, {520,0.000270142}, {525,0.000289100}, {530,0.000184834}, {535,0.000232227}, {540,0.000317536}, {545,0.000398104}, {550,0.000170616}, {555,0.000284360}, {560,0.000966825}, {565,0.000137441}, {570,0.000388626}, {575,0.000317536}, {580,0.000308057}, {585,0.000341232}, {590,0.000383886}, {595,0.000393365}, {600,0.000289100}, {605,0.000289100}, {610,0.000369668}, {615,0.000364929}, {620,0.000436019}, {625,0.000232227}, {630,0.000369668}, {635,0.000454976}, {640,0.000336493}, {645,0.000421801}, {650,0.000364929}, {655,0.000388626}, {660,0.000412322}, {665,0.000379147}, {670,0.000374408}, {675,0.000142180}, {680,0.000464455}, {685,0.000440758}, {690,0.000331754}, {695,0.000355450}, {700,0.000260664}, {705,0.000293839}, {710,0.000412322}, {715,0.000322275}, {720,0.000293839}, {725,0.000374408}, {730,0.000265403}, {735,0.000431280}, {740,0.000345972}, {745,0.000407583}, {750,0.000417062}, {755,0.000431280}, {760,0.000483412}, {765,0.000170616}, {770,0.000402844}, {775,0.000478673}, {780,0.000341232}, {785,0.000374408}, {790,0.000417062}, {795,0.000388626}, {800,0.000545024}, {805,0.000417062}, {810,0.000445498}, {815,0.000383886}, {820,0.000483412}, {825,0.000369668}, {830,0.000374408}, {835,0.000464455}, {840,0.000322275}, {845,0.000398104}, {850,0.000483412}, {855,0.000502370}, {860,0.000492891}, {865,0.000417062}, {870,0.000355450}, {875,0.000417062}, {880,0.000568720}, {885,0.000502370}, {890,0.000554502}, {895,0.000374408}, {900,0.000672986}, {905,0.000559242}, {910,0.000383886}, {915,0.000284360}, {920,0.000421801}, {925,0.000360190}, {930,0.000616114}, {935,0.000388626}, {940,0.000417062}, {945,0.000445498}, {950,0.000668246}, {955,0.000587678}, {960,0.000483412}, {965,0.000511848}, {970,0.000540284}, {975,0.000445498}, {980,0.000450237}, {985,0.000587678}, {990,0.000502370}, {995,0.000412322}, {1000,0.000464455}, {1010,0.000563981}, {1020,0.000601896}, {1030,0.000492891}, {1040,0.000459716}, {1050,0.000526066}, {1060,0.000478673}, {1070,0.000582938}, {1080,0.000597156}, {1090,0.000535545}, {1100,0.000563981}, {1110,0.000587678}, {1120,0.000677725}, {1130,0.000696682}, {1140,0.000672986}, {1150,0.000502370}, {1160,0.000616114}, {1170,0.000559242}, {1180,0.000663507}, {1190,0.000691943}, {1200,0.000635071}, {1210,0.000620853}, {1220,0.000720379}, {1230,0.000706161}, {1240,0.000654028}, {1250,0.000805687}, {1260,0.000696682}, {1270,0.000815166}, {1280,0.000701422}, {1290,0.000526066}, {1300,0.000530806}, {1310,0.000549763}, {1320,0.000677725}, {1330,0.000753555}, {1340,0.000635071}, {1350,0.000881517}, {1360,0.000592417}, {1370,0.000592417}, {1380,0.000810427}, {1390,0.000810427}, {1400,0.000947867}, {1410,0.000786730}, {1420,0.000862559}, {1430,0.001042654}, {1440,0.000611374}, {1450,0.000725118}, {1460,0.000872038}, {1470,0.000691943}, {1480,0.000706161}, {1490,0.000744076}, {1500,0.000668246}, {1510,0.000739336}, {1520,0.000739336}, {1530,0.000796209}, {1540,0.000758294}, {1550,0.000791469}, {1560,0.000819905}, {1570,0.000763033}, {1580,0.000791469}, {1590,0.000938389}, {1600,0.000938389}, {1610,0.000862559}, {1620,0.000758294}, {1630,0.000786730}, {1640,0.000672986}, {1650,0.000649289}, {1660,0.000611374}, {1670,0.000886256}, {1680,0.000872038}, {1690,0.000734597}, {1700,0.000862559}, {1710,0.000876777}, {1720,0.000900474}, {1730,0.001004739}, {1740,0.000630332}, {1750,0.000976303}, {1760,0.000952607}, {1770,0.000824645}, {1780,0.000928910}, {1790,0.000872038}, {1800,0.000900474}, {1810,0.001094787}, {1820,0.000938389}, {1830,0.000947867}, {1840,0.000734597}, {1850,0.000933649}, {1860,0.001009479}, {1870,0.001028436}, {1880,0.000976303}, {1890,0.000829384}, {1900,0.000976303}, {1910,0.001066351}, {1920,0.001028436}, {1930,0.000924171}, {1940,0.000710900}, {1950,0.001099526}, {1960,0.000549763}, {1970,0.001052133}, {1980,0.001056872}, {1990,0.001165877}, {2000,0.000933649}, {2050,0.001189573}, {2100,0.001341232}, {2150,0.001014218}, {2200,0.001327014}, {2250,0.001109005}, {2300,0.001146919}, {2350,0.001018957}, {2400,0.001293839}, {2450,0.001398104}, {2500,0.000985782}, {2550,0.001364929}, {2600,0.001530806}, {2650,0.001473934}, {2700,0.001208531}, {2750,0.001682464}, {2800,0.001516588}, {2850,0.001545024}, {2900,0.001582938}, {2950,0.001606635}, {3000,0.001530806}, {3050,0.001838863}, {3100,0.001232227}, {3150,0.001691943}, {3200,0.001725118}, {3250,0.001725118}, {3300,0.001810427}, {3350,0.002094787}, {3400,0.001943128}, {3450,0.001592417}, {3500,0.001952607}, {3550,0.002213270}, {3600,0.001905213}, {3650,0.001687204}, {3700,0.001620853}, {3750,0.001933649}, {3800,0.002303318}, {3850,0.002360190}, {3900,0.002151659}, {3950,0.002037915}, {4000,0.001696682}, {4050,0.002241706}, {4100,0.002203791}, {4150,0.008042654}, {4200,0.002682464}, {4250,0.002739336}, {4300,0.002611374}, {4350,0.002748815}, {4400,0.002369668}, {4450,0.002227488}, {4500,0.002459716}, {4550,0.002189573}, {4600,0.002227488}, {4650,0.002127962}, {4700,0.002454976}, {4750,0.002431280}, {4800,0.002682464}, {4850,0.002611374}, {4900,0.003293839}, {4950,0.003265403}, {5000,0.003246445}, {5050,0.00314}, {5100,0.00214}, {5150,0.00343}, {5200,0.00371}, {5250,0.00257}, {5300,0.00286}, {5350,0.00271}, {5400,0.00143}, {5450,0.00200}, {5500,0.00357}, {5550,0.00329}, {5600,0.00243}, {5650,0.00386}, {5700,0.00257}, {5750,0.00243}, {5800,0.00300}, {5850,0.00214}, {5900,0.00343}, {5950,0.00300}, {6000,0.00257}, {6050,0.00200}, {6100,0.00314}, {6150,0.00371}, {6200,0.00257}, {6250,0.00314}, {6300,0.00314}, {6350,0.00114}, {6400,0.00414}, {6450,0.00743}, {6500,0.00186}, {6550,0.00771}, {6600,0.00329}, {6650,0.00857}, {6700,0.00300}, {6750,0.00443}, {6800,0.00257}, {6850,0.00371}, {6900,0.00829}, {6950,0.00357}, {7000,0.00700}, {7050,0.00400}, {7100,0.00257}, {7150,0.00386}, {7200,0.00314}, {7250,0.00314}, {7300,0.00314}, {7350,0.00343}, {7400,0.00271}, {7450,0.00329}, {7500,0.01100}, {7550,0.00343}, {7600,0.00386}, {7650,0.00400}, {7700,0.00300}, {7750,0.00257}, {7800,0.00429}, {7850,0.00343}, {7900,0.00400}, {7950,0.01229}, {8000,0.00329}, {8050,0.00386}, {8100,0.00357}, {8150,0.00486}, {8200,0.00343}, {8250,0.00386}, {8300,0.00414}, {8350,0.00400}, {8400,0.00529}, {8450,0.00300}, {8500,0.00343}, {8550,0.00314}, {8600,0.00343}, {8650,0.00386}, {8700,0.00471}, {8750,0.00357}, {8800,0.00357}, {8850,0.00414}, {8900,0.00371}, {8950,0.00357}, {9000,0.00414}, {9050,0.00386}, {9100,0.01071}, {9150,0.00429}, {9200,0.00386}, {9250,0.00314}, {9300,0.00471}, {9350,0.00471}, {9400,0.00471}, {9450,0.01171}, {9500,0.00400}, {9550,0.00414}, {9600,0.00314}, {9650,0.00329}, {9700,0.00343}, {9750,0.00400}, {9800,0.00457}, {9850,0.00414}, {9900,0.00529}, {9950,0.00486}, {10000,0.00343}, {10100,0.00357}, {10200,0.00371}, {10300,0.00500}, {10400,0.00371}, {10500,0.00443}, {10600,0.00500}, {10700,0.01143}, {10800,0.01029}, {10900,0.00500}, {11000,0.01157}, {11100,0.00514}, {11200,0.00600}, {11300,0.00529}, {11400,0.00529}, {11500,0.00729}, {11600,0.00400}, {11700,0.00714}, {11800,0.00657}, {11900,0.00571}, {12000,0.00729}, {12100,0.00429}, {12200,0.01229}, {12300,0.00529}, {12400,0.01014}, {12500,0.01514}, {12600,0.00571}, {12700,0.00729}, {12800,0.00629}, {12900,0.00571}, {13000,0.00529}, {13100,0.00514}, {13200,0.00571}, {13300,0.00543}, {13400,0.01243}, {13500,0.01329}, {13600,0.00557}, {13700,0.00657}, {13800,0.00557}, {13900,0.00743}, {14000,0.00629}, {14100,0.00514}, {14200,0.00571}, {14300,0.00643}, {14400,0.01100}, {14500,0.01014}, {14600,0.00729}, {14700,0.00657}, {14800,0.00657}, {14900,0.00586}, {15000,0.01457}, {15100,0.00743}, {15200,0.00757}, {15300,0.00643}, {15400,0.01243}, {15500,0.00629}, {15600,0.00571}, {15700,0.01114}, {15800,0.00757}, {15900,0.00786}, {16000,0.00743}, {16100,0.00757}, {16200,0.01229}, {16300,0.00729}, {16400,0.01286}, {16500,0.00800}, {16600,0.00743}, {16700,0.01886}, {16800,0.00814}, {16900,0.00686}, {17000,0.00786}, {17100,0.00743}, {17200,0.00757}, {17300,0.00829}, {17400,0.00800}, {17500,0.00857}, {17600,0.00786}, {17700,0.02329}, {17800,0.00800}, {17900,0.00814}, {18000,0.00871}, {18100,0.00886}, {18200,0.01757}, {18300,0.00971}, {18400,0.01343}, {18500,0.01600}, {18600,0.01643}, {18700,0.01729}, {18800,0.01443}, {18900,0.00857}, {19000,0.00929}, {19100,0.01343}, {19200,0.00843}, {19300,0.00800}, {19400,0.00886}, {19500,0.00786}, {19600,0.01257}, {19700,0.00800}, {19800,0.00857}, {19900,0.00857}, {20000,0.00820}};
data["big_flat"]["beta; Parametricity"]["lazy beta iota"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000018957}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000018957}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000018957}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000018957}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000018957}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000014218}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000018957}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000018957}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000018957}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000018957}, {251,0.000018957}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000018957}, {269,0.000018957}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000018957}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000014218}, {305,0.000000000}, {306,0.000018957}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000018957}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000018957}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000018957}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000018957}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000018957}, {376,0.000000000}, {377,0.000018957}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000018957}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000018957}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000018957}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000018957}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000018957}, {436,0.000000000}, {437,0.000000000}, {438,0.000018957}, {439,0.000000000}, {440,0.000037915}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000018957}, {464,0.000018957}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000018957}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000018957}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000018957}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000014218}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000037915}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000018957}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000014218}, {645,0.000000000}, {650,0.000000000}, {655,0.000018957}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000018957}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000018957}, {700,0.000018957}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000018957}, {730,0.000018957}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000018957}, {865,0.000000000}, {870,0.000018957}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000018957}, {900,0.000018957}, {905,0.000018957}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000056872}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000018957}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000018957}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000018957}, {1120,0.000018957}, {1130,0.000000000}, {1140,0.000037915}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000018957}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000014218}, {1320,0.000018957}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000018957}, {1360,0.000018957}, {1370,0.000000000}, {1380,0.000018957}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000037915}, {1420,0.000018957}, {1430,0.000018957}, {1440,0.000018957}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000018957}, {1550,0.000018957}, {1560,0.000000000}, {1570,0.000018957}, {1580,0.000014218}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000056872}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000018957}, {1680,0.000018957}, {1690,0.000018957}, {1700,0.000018957}, {1710,0.000037915}, {1720,0.000000000}, {1730,0.000018957}, {1740,0.000018957}, {1750,0.000018957}, {1760,0.000018957}, {1770,0.000018957}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000056872}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000018957}, {1900,0.000000000}, {1910,0.000018957}, {1920,0.000014218}, {1930,0.000000000}, {1940,0.000018957}, {1950,0.000018957}, {1960,0.000000000}, {1970,0.000018957}, {1980,0.000000000}, {1990,0.000037915}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000018957}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000018957}, {2600,0.000018957}, {2650,0.000018957}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000018957}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000018957}, {3150,0.000018957}, {3200,0.000000000}, {3250,0.000018957}, {3300,0.000018957}, {3350,0.000018957}, {3400,0.000000000}, {3450,0.000018957}, {3500,0.000000000}, {3550,0.000037915}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000037915}, {3750,0.000000000}, {3800,0.000018957}, {3850,0.000018957}, {3900,0.000056872}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000071090}, {4200,0.000018957}, {4250,0.000000000}, {4300,0.000056872}, {4350,0.000018957}, {4400,0.000014218}, {4450,0.000018957}, {4500,0.000000000}, {4550,0.000018957}, {4600,0.000014218}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000037915}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000018957}, {5050,0.00000}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00057}, {6550,0.00000}, {6600,0.00000}, {6650,0.00057}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00057}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00043}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00057}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00057}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["beta; Parametricity"]["norm reif"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000004739}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000563981}, {63,0.000000000}, {64,0.000000000}, {65,0.000009479}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000009479}, {78,0.000805687}, {79,0.000004739}, {80,0.000004739}, {81,0.000009479}, {82,0.000028436}, {83,0.000014218}, {84,0.000037915}, {85,0.000056872}, {86,0.000085308}, {87,0.000099526}, {88,0.000156398}, {89,0.000213270}, {90,0.000312796}, {91,0.000327014}, {92,0.000383886}, {93,0.000440758}, {94,0.000492891}, {95,0.000568720}, {96,0.000606635}, {97,0.000772512}, {98,0.000710900}, {99,0.000744076}, {100,0.000824645}, {101,0.000881517}, {102,0.000952607}, {103,0.000981043}, {104,0.000985782}, {105,0.000990521}, {106,0.000995261}, {107,0.001000000}, {108,0.001000000}, {109,0.001492891}, {110,0.001000000}, {111,0.001000000}, {112,0.001000000}, {113,0.001000000}, {114,0.001000000}, {115,0.001000000}, {116,0.001000000}, {117,0.001000000}, {118,0.001000000}, {119,0.001000000}, {120,0.001000000}, {121,0.001000000}, {122,0.001000000}, {123,0.001000000}, {124,0.001000000}, {125,0.001464455}, {126,0.001009479}, {127,0.001000000}, {128,0.001000000}, {129,0.001000000}, {130,0.001000000}, {131,0.001000000}, {132,0.001000000}, {133,0.001000000}, {134,0.001000000}, {135,0.001000000}, {136,0.001000000}, {137,0.001000000}, {138,0.001000000}, {139,0.001000000}, {140,0.001000000}, {141,0.001000000}, {142,0.001000000}, {143,0.001000000}, {144,0.001000000}, {145,0.001000000}, {146,0.001000000}, {147,0.001000000}, {148,0.001000000}, {149,0.001000000}, {150,0.001009479}, {151,0.001000000}, {152,0.001000000}, {153,0.001000000}, {154,0.001000000}, {155,0.001000000}, {156,0.001000000}, {157,0.001000000}, {158,0.001000000}, {159,0.001000000}, {160,0.001000000}, {161,0.001000000}, {162,0.001000000}, {163,0.001000000}, {164,0.001000000}, {165,0.001000000}, {166,0.001000000}, {167,0.001000000}, {168,0.001000000}, {169,0.001000000}, {170,0.001000000}, {171,0.001478673}, {172,0.001000000}, {173,0.001000000}, {174,0.001000000}, {175,0.001000000}, {176,0.001000000}, {177,0.001000000}, {178,0.001000000}, {179,0.001511848}, {180,0.001000000}, {181,0.001000000}, {182,0.001000000}, {183,0.001000000}, {184,0.001000000}, {185,0.001000000}, {186,0.001000000}, {187,0.001000000}, {188,0.001000000}, {189,0.001000000}, {190,0.001000000}, {191,0.001478673}, {192,0.001000000}, {193,0.001000000}, {194,0.001000000}, {195,0.001000000}, {196,0.001000000}, {197,0.001000000}, {198,0.001000000}, {199,0.001000000}, {200,0.001000000}, {201,0.001000000}, {202,0.001000000}, {203,0.001000000}, {204,0.001000000}, {205,0.001000000}, {206,0.001000000}, {207,0.001000000}, {208,0.001004739}, {209,0.001000000}, {210,0.001000000}, {211,0.001000000}, {212,0.001000000}, {213,0.001000000}, {214,0.001000000}, {215,0.001000000}, {216,0.001535545}, {217,0.001004739}, {218,0.001000000}, {219,0.001000000}, {220,0.001009479}, {221,0.001004739}, {222,0.001014218}, {223,0.001028436}, {224,0.001009479}, {225,0.001037915}, {226,0.001023697}, {227,0.001056872}, {228,0.001071090}, {229,0.001071090}, {230,0.001075829}, {231,0.001075829}, {232,0.001113744}, {233,0.001213270}, {234,0.001203791}, {235,0.001203791}, {236,0.001255924}, {237,0.001303318}, {238,0.001374408}, {239,0.001431280}, {240,0.001473934}, {241,0.001511848}, {242,0.001578199}, {243,0.001606635}, {244,0.001616114}, {245,0.001639810}, {246,0.001668246}, {247,0.001725118}, {248,0.001758294}, {249,0.001772512}, {250,0.001815166}, {251,0.001800948}, {252,0.001862559}, {253,0.001919431}, {254,0.001933649}, {255,0.001947867}, {256,0.001962085}, {257,0.001981043}, {258,0.002255924}, {259,0.001990521}, {260,0.001985782}, {261,0.001995261}, {262,0.002000000}, {263,0.001995261}, {264,0.002000000}, {265,0.002000000}, {266,0.002000000}, {267,0.002004739}, {268,0.002000000}, {269,0.002004739}, {270,0.002000000}, {271,0.002000000}, {272,0.002009479}, {273,0.002000000}, {274,0.002000000}, {275,0.002000000}, {276,0.002000000}, {277,0.002000000}, {278,0.002000000}, {279,0.002000000}, {280,0.002000000}, {281,0.002000000}, {282,0.002000000}, {283,0.002000000}, {284,0.002000000}, {285,0.002000000}, {286,0.002000000}, {287,0.002000000}, {288,0.002000000}, {289,0.002000000}, {290,0.002000000}, {291,0.002000000}, {292,0.002000000}, {293,0.002000000}, {294,0.002000000}, {295,0.002000000}, {296,0.002000000}, {297,0.002000000}, {298,0.002000000}, {299,0.002000000}, {300,0.002478673}, {301,0.002000000}, {302,0.002000000}, {303,0.002000000}, {304,0.002000000}, {305,0.002000000}, {306,0.002000000}, {307,0.002000000}, {308,0.002000000}, {309,0.002000000}, {310,0.002000000}, {311,0.002000000}, {312,0.002000000}, {313,0.002478673}, {314,0.002000000}, {315,0.002000000}, {316,0.002000000}, {317,0.002000000}, {318,0.002000000}, {319,0.002004739}, {320,0.002000000}, {321,0.002000000}, {322,0.002000000}, {323,0.002000000}, {324,0.002000000}, {325,0.002014218}, {326,0.002000000}, {327,0.002000000}, {328,0.002000000}, {329,0.002000000}, {330,0.002000000}, {331,0.002000000}, {332,0.002000000}, {333,0.002000000}, {334,0.002000000}, {335,0.002000000}, {336,0.002000000}, {337,0.002018957}, {338,0.002000000}, {339,0.002000000}, {340,0.002000000}, {341,0.002000000}, {342,0.002000000}, {343,0.002000000}, {344,0.002000000}, {345,0.002000000}, {346,0.002000000}, {347,0.002000000}, {348,0.002000000}, {349,0.002545024}, {350,0.002000000}, {351,0.002000000}, {352,0.002000000}, {353,0.002933649}, {354,0.002004739}, {355,0.002000000}, {356,0.002000000}, {357,0.002000000}, {358,0.002000000}, {359,0.002004739}, {360,0.002004739}, {361,0.002004739}, {362,0.002004739}, {363,0.002000000}, {364,0.002014218}, {365,0.002014218}, {366,0.002014218}, {367,0.002004739}, {368,0.002014218}, {369,0.002023697}, {370,0.002042654}, {371,0.002033175}, {372,0.002018957}, {373,0.002056872}, {374,0.002071090}, {375,0.002080569}, {376,0.002104265}, {377,0.002113744}, {378,0.002137441}, {379,0.002132701}, {380,0.002189573}, {381,0.002203791}, {382,0.002265403}, {383,0.002327014}, {384,0.002308057}, {385,0.002331754}, {386,0.003037915}, {387,0.002426540}, {388,0.002436019}, {389,0.002436019}, {390,0.002469194}, {391,0.002492891}, {392,0.002545024}, {393,0.003260664}, {394,0.002597156}, {395,0.002611374}, {396,0.002677725}, {397,0.002701422}, {398,0.002739336}, {399,0.002744076}, {400,0.002781991}, {401,0.002843602}, {402,0.002895735}, {403,0.002957346}, {404,0.002924171}, {405,0.002952607}, {406,0.002947867}, {407,0.002947867}, {408,0.002966825}, {409,0.002971564}, {410,0.002976303}, {411,0.002971564}, {412,0.002981043}, {413,0.002990521}, {414,0.002995261}, {415,0.002995261}, {416,0.003000000}, {417,0.003000000}, {418,0.003004739}, {419,0.003000000}, {420,0.003004739}, {421,0.003000000}, {422,0.003000000}, {423,0.003009479}, {424,0.003000000}, {425,0.003004739}, {426,0.003000000}, {427,0.003000000}, {428,0.003004739}, {429,0.003000000}, {430,0.003000000}, {431,0.003000000}, {432,0.003004739}, {433,0.003483412}, {434,0.003000000}, {435,0.003000000}, {436,0.003521327}, {437,0.003000000}, {438,0.003000000}, {439,0.003000000}, {440,0.003000000}, {441,0.003000000}, {442,0.003009479}, {443,0.003009479}, {444,0.003000000}, {445,0.003000000}, {446,0.003000000}, {447,0.003000000}, {448,0.003000000}, {449,0.003000000}, {450,0.003000000}, {451,0.003000000}, {452,0.003478673}, {453,0.003000000}, {454,0.003000000}, {455,0.003000000}, {456,0.003000000}, {457,0.003004739}, {458,0.003000000}, {459,0.003000000}, {460,0.003000000}, {461,0.003478673}, {462,0.003000000}, {463,0.003000000}, {464,0.003516588}, {465,0.003000000}, {466,0.003000000}, {467,0.003000000}, {468,0.003000000}, {469,0.003000000}, {470,0.003483412}, {471,0.003000000}, {472,0.003000000}, {473,0.003000000}, {474,0.003009479}, {475,0.003000000}, {476,0.003004739}, {477,0.003004739}, {478,0.003009479}, {479,0.003483412}, {480,0.003000000}, {481,0.003004739}, {482,0.003000000}, {483,0.003000000}, {484,0.003000000}, {485,0.003000000}, {486,0.003000000}, {487,0.003018957}, {488,0.003000000}, {489,0.003004739}, {490,0.003876777}, {491,0.003004739}, {492,0.003000000}, {493,0.003009479}, {494,0.003000000}, {495,0.003000000}, {496,0.003895735}, {497,0.003004739}, {498,0.003009479}, {499,0.003004739}, {500,0.003009479}, {505,0.003009479}, {510,0.003004739}, {515,0.003023697}, {520,0.003075829}, {525,0.003180095}, {530,0.003222749}, {535,0.003957346}, {540,0.003507109}, {545,0.003625592}, {550,0.003748815}, {555,0.003919431}, {560,0.003933649}, {565,0.003962085}, {570,0.003990521}, {575,0.004000000}, {580,0.004004739}, {585,0.004000000}, {590,0.004000000}, {595,0.004023697}, {600,0.004000000}, {605,0.004000000}, {610,0.004000000}, {615,0.004004739}, {620,0.004000000}, {625,0.004004739}, {630,0.004037915}, {635,0.004014218}, {640,0.004009479}, {645,0.004009479}, {650,0.004037915}, {655,0.004052133}, {660,0.004075829}, {665,0.005099526}, {670,0.004189573}, {675,0.005075829}, {680,0.004350711}, {685,0.004388626}, {690,0.004526066}, {695,0.004644550}, {700,0.004767773}, {705,0.004867299}, {710,0.004933649}, {715,0.004928910}, {720,0.004962085}, {725,0.005009479}, {730,0.005004739}, {735,0.005000000}, {740,0.005000000}, {745,0.005000000}, {750,0.005000000}, {755,0.005028436}, {760,0.005023697}, {765,0.006047393}, {770,0.005023697}, {775,0.005028436}, {780,0.005037915}, {785,0.006090047}, {790,0.005061611}, {795,0.005113744}, {800,0.005142180}, {805,0.005222749}, {810,0.005289100}, {815,0.005312796}, {820,0.006606635}, {825,0.005379147}, {830,0.005436019}, {835,0.005507109}, {840,0.006459716}, {845,0.005701422}, {850,0.005781991}, {855,0.005872038}, {860,0.005900474}, {865,0.006530806}, {870,0.005938389}, {875,0.005943128}, {880,0.006000000}, {885,0.006023697}, {890,0.006710900}, {895,0.006037915}, {900,0.006052133}, {905,0.006061611}, {910,0.006071090}, {915,0.006767773}, {920,0.006056872}, {925,0.006094787}, {930,0.006123223}, {935,0.006127962}, {940,0.006170616}, {945,0.007222749}, {950,0.006284360}, {955,0.006369668}, {960,0.006421801}, {965,0.006445498}, {970,0.006445498}, {975,0.006507109}, {980,0.006549763}, {985,0.007587678}, {990,0.008436019}, {995,0.006729858}, {1000,0.006815166}, {1010,0.006952607}, {1020,0.006985782}, {1030,0.007075829}, {1040,0.007109005}, {1050,0.007127962}, {1060,0.007208531}, {1070,0.008042654}, {1080,0.007298578}, {1090,0.007374408}, {1100,0.007469194}, {1110,0.008549763}, {1120,0.007563981}, {1130,0.007706161}, {1140,0.007796209}, {1150,0.008729858}, {1160,0.007990521}, {1170,0.008066351}, {1180,0.008146919}, {1190,0.008180095}, {1200,0.008322275}, {1210,0.008445498}, {1220,0.008445498}, {1230,0.008521327}, {1240,0.008549763}, {1250,0.009691943}, {1260,0.010033175}, {1270,0.008777251}, {1280,0.008919431}, {1290,0.008985782}, {1300,0.009104265}, {1310,0.009218009}, {1320,0.010213270}, {1330,0.010431280}, {1340,0.009417062}, {1350,0.009587678}, {1360,0.011151659}, {1370,0.009701422}, {1380,0.009687204}, {1390,0.009748815}, {1400,0.009843602}, {1410,0.009933649}, {1420,0.010900474}, {1430,0.010156398}, {1440,0.010222749}, {1450,0.011464455}, {1460,0.010459716}, {1470,0.010516588}, {1480,0.011672986}, {1490,0.012028436}, {1500,0.010725118}, {1510,0.012137441}, {1520,0.011763033}, {1530,0.010947867}, {1540,0.012308057}, {1550,0.011028436}, {1560,0.011222749}, {1570,0.013857820}, {1580,0.011303318}, {1590,0.011511848}, {1600,0.011620853}, {1610,0.011658768}, {1620,0.011725118}, {1630,0.011786730}, {1640,0.011890995}, {1650,0.011976303}, {1660,0.013710900}, {1670,0.012137441}, {1680,0.013478673}, {1690,0.012203791}, {1700,0.012360190}, {1710,0.012417062}, {1720,0.012516588}, {1730,0.012701422}, {1740,0.014156398}, {1750,0.012819905}, {1760,0.014412322}, {1770,0.012867299}, {1780,0.013023697}, {1790,0.014767773}, {1800,0.013203791}, {1810,0.015355450}, {1820,0.013284360}, {1830,0.013469194}, {1840,0.015047393}, {1850,0.013616114}, {1860,0.015687204}, {1870,0.013748815}, {1880,0.013914692}, {1890,0.015208531}, {1900,0.014056872}, {1910,0.014066351}, {1920,0.014227488}, {1930,0.016426540}, {1940,0.014322275}, {1950,0.014473934}, {1960,0.017094787}, {1970,0.014535545}, {1980,0.014540284}, {1990,0.014800948}, {2000,0.016635071}, {2050,0.015161137}, {2100,0.015744076}, {2150,0.017469194}, {2200,0.016545024}, {2250,0.018654028}, {2300,0.017379147}, {2350,0.019407583}, {2400,0.018222749}, {2450,0.018298578}, {2500,0.021260664}, {2550,0.019450237}, {2600,0.021279621}, {2650,0.020402844}, {2700,0.022890995}, {2750,0.021298578}, {2800,0.021563981}, {2850,0.023971564}, {2900,0.022473934}, {2950,0.024843602}, {3000,0.025611374}, {3050,0.023786730}, {3100,0.026369668}, {3150,0.028554502}, {3200,0.025009479}, {3250,0.027886256}, {3300,0.027601896}, {3350,0.026308057}, {3400,0.026649289}, {3450,0.031227488}, {3500,0.032104265}, {3550,0.028023697}, {3600,0.028379147}, {3650,0.032431280}, {3700,0.034483412}, {3750,0.032412322}, {3800,0.030236967}, {3850,0.030459716}, {3900,0.030009479}, {3950,0.033085308}, {4000,0.039151659}, {4050,0.034597156}, {4100,0.036364929}, {4150,0.033118483}, {4200,0.033559242}, {4250,0.033838863}, {4300,0.034345972}, {4350,0.034715640}, {4400,0.038744076}, {4450,0.038037915}, {4500,0.039118483}, {4550,0.039810427}, {4600,0.040080569}, {4650,0.040677725}, {4700,0.041293839}, {4750,0.041180095}, {4800,0.041056872}, {4850,0.040540284}, {4900,0.039454976}, {4950,0.040018957}, {5000,0.040507109}, {5050,0.06671}, {5100,0.04343}, {5150,0.04229}, {5200,0.04214}, {5250,0.04071}, {5300,0.04629}, {5350,0.04786}, {5400,0.04957}, {5450,0.04700}, {5500,0.04543}, {5550,0.04286}, {5600,0.05186}, {5650,0.05371}, {5700,0.04914}, {5750,0.04643}, {5800,0.04943}, {5850,0.05443}, {5900,0.05129}, {5950,0.04571}, {6000,0.05357}, {6050,0.05514}, {6100,0.05186}, {6150,0.05943}, {6200,0.05657}, {6250,0.05129}, {6300,0.05600}, {6350,0.05843}, {6400,0.05157}, {6450,0.05629}, {6500,0.05557}, {6550,0.05643}, {6600,0.06371}, {6650,0.05214}, {6700,0.06557}, {6750,0.05500}, {6800,0.06329}, {6850,0.05757}, {6900,0.06114}, {6950,0.05771}, {7000,0.06171}, {7050,0.05986}, {7100,0.06571}, {7150,0.06029}, {7200,0.06614}, {7250,0.06000}, {7300,0.06643}, {7350,0.06643}, {7400,0.06314}, {7450,0.06886}, {7500,0.06300}, {7550,0.07000}, {7600,0.06871}, {7650,0.06400}, {7700,0.07200}, {7750,0.06857}, {7800,0.06500}, {7850,0.07257}, {7900,0.07114}, {7950,0.06771}, {8000,0.07471}, {8050,0.07400}, {8100,0.06957}, {8150,0.06714}, {8200,0.07543}, {8250,0.07600}, {8300,0.07186}, {8350,0.07814}, {8400,0.07314}, {8450,0.07829}, {8500,0.07800}, {8550,0.08086}, {8600,0.07557}, {8650,0.07757}, {8700,0.07786}, {8750,0.07986}, {8800,0.08143}, {8850,0.07971}, {8900,0.08014}, {8950,0.08371}, {9000,0.08271}, {9050,0.08557}, {9100,0.08043}, {9150,0.08029}, {9200,0.08071}, {9250,0.08057}, {9300,0.08186}, {9350,0.08114}, {9400,0.08314}, {9450,0.08343}, {9500,0.09071}, {9550,0.08643}, {9600,0.08729}, {9650,0.08829}, {9700,0.08671}, {9750,0.08929}, {9800,0.09100}, {9850,0.09271}, {9900,0.09286}, {9950,0.09271}, {10000,0.09357}, {10100,0.08957}, {10200,0.09186}, {10300,0.09171}, {10400,0.09929}, {10500,0.09500}, {10600,0.09471}, {10700,0.49829}, {10800,0.10143}, {10900,0.09457}, {11000,0.09943}, {11100,0.09943}, {11200,0.10029}, {11300,0.10100}, {11400,0.10014}, {11500,0.10271}, {11600,0.10186}, {11700,0.10086}, {11800,0.10314}, {11900,0.11071}, {12000,0.10514}, {12100,0.11400}, {12200,0.11386}, {12300,0.10943}, {12400,0.11043}, {12500,0.11257}, {12600,0.11100}, {12700,0.11686}, {12800,0.12257}, {12900,0.11571}, {13000,0.11500}, {13100,0.11986}, {13200,0.12429}, {13300,0.12457}, {13400,0.12343}, {13500,0.12114}, {13600,0.11757}, {13700,0.11843}, {13800,0.11714}, {13900,0.12200}, {14000,0.12243}, {14100,0.12429}, {14200,0.11886}, {14300,0.12629}, {14400,0.12671}, {14500,0.13143}, {14600,0.13300}, {14700,0.12714}, {14800,0.13057}, {14900,0.13057}, {15000,0.13114}, {15100,0.13900}, {15200,0.13214}, {15300,0.12986}, {15400,0.14686}, {15500,0.14600}, {15600,0.13871}, {15700,0.14629}, {15800,0.14386}, {15900,0.13886}, {16000,0.15300}, {16100,0.14100}, {16200,0.14714}, {16300,0.14114}, {16400,0.15129}, {16500,0.14314}, {16600,0.15657}, {16700,0.14429}, {16800,0.15029}, {16900,0.16243}, {17000,0.14529}, {17100,0.15929}, {17200,0.16943}, {17300,0.14914}, {17400,0.15286}, {17500,0.16257}, {17600,0.16257}, {17700,0.14929}, {17800,0.14857}, {17900,0.16429}, {18000,0.16514}, {18100,0.18014}, {18200,0.16571}, {18300,0.16443}, {18400,0.16029}, {18500,0.15914}, {18600,0.16029}, {18700,0.16071}, {18800,0.15900}, {18900,0.16657}, {19000,0.17071}, {19100,0.17843}, {19200,0.18429}, {19300,0.18243}, {19400,0.17471}, {19500,0.16129}, {19600,0.16786}, {19700,0.18843}, {19800,0.18500}, {19900,0.17300}, {20000,0.18260}};
data["big_flat"]["beta; Parametricity"]["norm reif"]["user"] = {{1,0.000236967}, {2,0.000341232}, {3,0.000355450}, {4,0.000331754}, {5,0.000227488}, {6,0.000274882}, {7,0.000374408}, {8,0.000374408}, {9,0.000336493}, {10,0.000341232}, {11,0.000260664}, {12,0.000317536}, {13,0.000364929}, {14,0.000331754}, {15,0.000445498}, {16,0.000625592}, {17,0.000218009}, {18,0.000350711}, {19,0.000279621}, {20,0.000383886}, {21,0.000246445}, {22,0.000417062}, {23,0.000331754}, {24,0.000383886}, {25,0.000402844}, {26,0.000407583}, {27,0.000540284}, {28,0.000459716}, {29,0.000559242}, {30,0.000507109}, {31,0.000526066}, {32,0.000511848}, {33,0.000445498}, {34,0.000511848}, {35,0.000431280}, {36,0.000431280}, {37,0.000549763}, {38,0.000502370}, {39,0.000554502}, {40,0.000597156}, {41,0.000464455}, {42,0.000682464}, {43,0.000530806}, {44,0.000601896}, {45,0.000796209}, {46,0.000417062}, {47,0.000573460}, {48,0.000620853}, {49,0.000649289}, {50,0.000767773}, {51,0.000450237}, {52,0.000763033}, {53,0.000630332}, {54,0.000511848}, {55,0.000829384}, {56,0.000554502}, {57,0.000587678}, {58,0.000781991}, {59,0.000696682}, {60,0.000573460}, {61,0.000753555}, {62,0.001208531}, {63,0.000568720}, {64,0.000900474}, {65,0.000649289}, {66,0.000620853}, {67,0.000848341}, {68,0.000796209}, {69,0.000729858}, {70,0.000900474}, {71,0.000786730}, {72,0.000706161}, {73,0.000895735}, {74,0.000677725}, {75,0.000872038}, {76,0.000748815}, {77,0.000838863}, {78,0.001165877}, {79,0.000635071}, {80,0.001123223}, {81,0.000748815}, {82,0.000668246}, {83,0.000739336}, {84,0.001009479}, {85,0.000905213}, {86,0.000748815}, {87,0.000587678}, {88,0.001047393}, {89,0.000857820}, {90,0.000857820}, {91,0.000729858}, {92,0.000938389}, {93,0.000658768}, {94,0.000900474}, {95,0.000886256}, {96,0.000952607}, {97,0.000867299}, {98,0.000838863}, {99,0.000805687}, {100,0.000829384}, {101,0.000834123}, {102,0.001033175}, {103,0.001000000}, {104,0.001033175}, {105,0.000895735}, {106,0.000834123}, {107,0.000786730}, {108,0.001061611}, {109,0.001549763}, {110,0.001014218}, {111,0.001123223}, {112,0.000947867}, {113,0.000943128}, {114,0.001127962}, {115,0.001109005}, {116,0.001061611}, {117,0.001175355}, {118,0.001085308}, {119,0.000881517}, {120,0.000720379}, {121,0.000872038}, {122,0.001023697}, {123,0.001146919}, {124,0.001175355}, {125,0.001559242}, {126,0.001080569}, {127,0.001127962}, {128,0.001094787}, {129,0.001175355}, {130,0.001194313}, {131,0.001146919}, {132,0.001090047}, {133,0.000933649}, {134,0.000933649}, {135,0.001023697}, {136,0.001123223}, {137,0.001222749}, {138,0.001265403}, {139,0.001194313}, {140,0.001436019}, {141,0.001364929}, {142,0.001421801}, {143,0.001412322}, {144,0.001284360}, {145,0.001137441}, {146,0.001218009}, {147,0.001208531}, {148,0.001161137}, {149,0.001151659}, {150,0.001094787}, {151,0.001023697}, {152,0.000914692}, {153,0.000985782}, {154,0.001000000}, {155,0.001066351}, {156,0.001322275}, {157,0.001440758}, {158,0.001488152}, {159,0.001303318}, {160,0.001246445}, {161,0.001293839}, {162,0.001402844}, {163,0.001327014}, {164,0.001104265}, {165,0.001350711}, {166,0.001383886}, {167,0.001454976}, {168,0.001492891}, {169,0.001293839}, {170,0.001194313}, {171,0.001630332}, {172,0.001459716}, {173,0.001559242}, {174,0.001345972}, {175,0.001327014}, {176,0.001459716}, {177,0.001445498}, {178,0.001317536}, {179,0.001748815}, {180,0.001559242}, {181,0.001507109}, {182,0.001322275}, {183,0.001573460}, {184,0.001284360}, {185,0.001341232}, {186,0.001331754}, {187,0.001454976}, {188,0.001545024}, {189,0.001554502}, {190,0.001459716}, {191,0.001810427}, {192,0.001549763}, {193,0.001478673}, {194,0.001417062}, {195,0.001388626}, {196,0.001521327}, {197,0.001644550}, {198,0.001488152}, {199,0.001592417}, {200,0.001454976}, {201,0.001360190}, {202,0.001563981}, {203,0.001658768}, {204,0.001554502}, {205,0.001317536}, {206,0.001582938}, {207,0.001644550}, {208,0.001454976}, {209,0.001582938}, {210,0.001682464}, {211,0.001563981}, {212,0.001436019}, {213,0.001563981}, {214,0.001881517}, {215,0.001355450}, {216,0.002132701}, {217,0.001739336}, {218,0.001464455}, {219,0.001767773}, {220,0.001668246}, {221,0.001573460}, {222,0.001720379}, {223,0.001639810}, {224,0.001625592}, {225,0.001568720}, {226,0.001810427}, {227,0.001639810}, {228,0.001843602}, {229,0.001900474}, {230,0.001530806}, {231,0.001890995}, {232,0.001630332}, {233,0.001824645}, {234,0.001630332}, {235,0.001701422}, {236,0.001834123}, {237,0.001644550}, {238,0.001985782}, {239,0.001772512}, {240,0.001682464}, {241,0.001943128}, {242,0.001744076}, {243,0.002080569}, {244,0.001677725}, {245,0.001834123}, {246,0.001739336}, {247,0.001952607}, {248,0.001914692}, {249,0.001886256}, {250,0.001763033}, {251,0.001829384}, {252,0.001781991}, {253,0.001734597}, {254,0.002052133}, {255,0.001758294}, {256,0.002113744}, {257,0.001639810}, {258,0.002412322}, {259,0.001843602}, {260,0.001843602}, {261,0.001919431}, {262,0.001976303}, {263,0.001938389}, {264,0.001971564}, {265,0.001947867}, {266,0.001985782}, {267,0.001848341}, {268,0.002000000}, {269,0.001895735}, {270,0.001928910}, {271,0.002109005}, {272,0.001819905}, {273,0.002142180}, {274,0.001862559}, {275,0.002018957}, {276,0.001881517}, {277,0.002109005}, {278,0.001786730}, {279,0.002184834}, {280,0.001966825}, {281,0.001947867}, {282,0.002308057}, {283,0.001924171}, {284,0.002047393}, {285,0.002184834}, {286,0.001966825}, {287,0.002056872}, {288,0.002104265}, {289,0.002018957}, {290,0.002156398}, {291,0.001905213}, {292,0.002018957}, {293,0.002071090}, {294,0.002109005}, {295,0.002061611}, {296,0.002023697}, {297,0.002170616}, {298,0.002018957}, {299,0.002189573}, {300,0.002464455}, {301,0.002009479}, {302,0.002127962}, {303,0.002265403}, {304,0.002123223}, {305,0.001938389}, {306,0.002222749}, {307,0.002232227}, {308,0.002165877}, {309,0.001976303}, {310,0.002436019}, {311,0.002345972}, {312,0.001947867}, {313,0.002516588}, {314,0.002265403}, {315,0.002454976}, {316,0.002199052}, {317,0.002052133}, {318,0.002180095}, {319,0.002407583}, {320,0.002194313}, {321,0.002118483}, {322,0.002308057}, {323,0.002241706}, {324,0.002355450}, {325,0.002208531}, {326,0.001947867}, {327,0.002194313}, {328,0.002322275}, {329,0.002450237}, {330,0.002473934}, {331,0.002274882}, {332,0.002402844}, {333,0.002208531}, {334,0.002156398}, {335,0.002327014}, {336,0.002213270}, {337,0.002426540}, {338,0.002454976}, {339,0.002582938}, {340,0.002530806}, {341,0.002450237}, {342,0.002165877}, {343,0.002417062}, {344,0.002516588}, {345,0.002535545}, {346,0.002497630}, {347,0.002398104}, {348,0.002284360}, {349,0.002909953}, {350,0.002327014}, {351,0.002364929}, {352,0.002488152}, {353,0.003028436}, {354,0.002374408}, {355,0.002317536}, {356,0.002492891}, {357,0.002507109}, {358,0.002398104}, {359,0.002530806}, {360,0.002516588}, {361,0.002436019}, {362,0.002535545}, {363,0.002611374}, {364,0.002758294}, {365,0.002834123}, {366,0.002767773}, {367,0.002677725}, {368,0.002639810}, {369,0.002663507}, {370,0.002663507}, {371,0.002587678}, {372,0.002767773}, {373,0.002677725}, {374,0.002691943}, {375,0.002473934}, {376,0.002753555}, {377,0.002909953}, {378,0.002829384}, {379,0.002696682}, {380,0.002791469}, {381,0.002843602}, {382,0.002796209}, {383,0.002459716}, {384,0.002511848}, {385,0.002464455}, {386,0.003170616}, {387,0.002682464}, {388,0.002938389}, {389,0.002867299}, {390,0.002625592}, {391,0.002601896}, {392,0.002620853}, {393,0.003165877}, {394,0.002710900}, {395,0.002559242}, {396,0.002592417}, {397,0.002677725}, {398,0.002597156}, {399,0.002872038}, {400,0.002767773}, {401,0.002767773}, {402,0.002620853}, {403,0.002710900}, {404,0.002687204}, {405,0.002905213}, {406,0.002658768}, {407,0.002924171}, {408,0.002672986}, {409,0.002900474}, {410,0.002867299}, {411,0.002876777}, {412,0.002990521}, {413,0.002810427}, {414,0.002682464}, {415,0.002838863}, {416,0.002800948}, {417,0.002777251}, {418,0.002781991}, {419,0.002919431}, {420,0.002976303}, {421,0.002924171}, {422,0.002786730}, {423,0.002677725}, {424,0.002819905}, {425,0.003018957}, {426,0.002796209}, {427,0.002881517}, {428,0.002815166}, {429,0.002976303}, {430,0.003042654}, {431,0.002957346}, {432,0.003071090}, {433,0.003511848}, {434,0.003023697}, {435,0.003033175}, {436,0.003549763}, {437,0.003014218}, {438,0.003118483}, {439,0.002928910}, {440,0.002862559}, {441,0.003075829}, {442,0.002957346}, {443,0.002985782}, {444,0.003023697}, {445,0.002947867}, {446,0.003142180}, {447,0.003000000}, {448,0.003037915}, {449,0.002838863}, {450,0.003075829}, {451,0.003018957}, {452,0.003488152}, {453,0.003014218}, {454,0.003085308}, {455,0.003080569}, {456,0.002966825}, {457,0.002928910}, {458,0.003113744}, {459,0.003094787}, {460,0.003146919}, {461,0.003639810}, {462,0.003208531}, {463,0.003028436}, {464,0.003521327}, {465,0.003127962}, {466,0.003165877}, {467,0.003113744}, {468,0.003199052}, {469,0.003132701}, {470,0.003734597}, {471,0.003165877}, {472,0.003251185}, {473,0.003118483}, {474,0.003146919}, {475,0.003151659}, {476,0.003109005}, {477,0.003241706}, {478,0.003113744}, {479,0.003763033}, {480,0.003236967}, {481,0.003308057}, {482,0.003265403}, {483,0.003274882}, {484,0.003360190}, {485,0.003312796}, {486,0.003246445}, {487,0.003412322}, {488,0.003398104}, {489,0.003279621}, {490,0.003938389}, {491,0.003222749}, {492,0.003165877}, {493,0.003203791}, {494,0.003227488}, {495,0.003398104}, {496,0.004061611}, {497,0.003331754}, {498,0.003431280}, {499,0.003360190}, {500,0.003379147}, {505,0.003350711}, {510,0.003341232}, {515,0.003345972}, {520,0.003464455}, {525,0.003488152}, {530,0.003606635}, {535,0.004014218}, {540,0.003620853}, {545,0.003578199}, {550,0.003701422}, {555,0.003715640}, {560,0.003729858}, {565,0.003720379}, {570,0.003763033}, {575,0.003734597}, {580,0.003800948}, {585,0.003872038}, {590,0.004113744}, {595,0.004004739}, {600,0.003957346}, {605,0.004009479}, {610,0.004004739}, {615,0.004075829}, {620,0.004099526}, {625,0.004194313}, {630,0.004142180}, {635,0.004184834}, {640,0.004379147}, {645,0.004374408}, {650,0.004298578}, {655,0.004251185}, {660,0.004303318}, {665,0.005213270}, {670,0.004355450}, {675,0.005388626}, {680,0.004616114}, {685,0.004696682}, {690,0.004469194}, {695,0.004568720}, {700,0.004691943}, {705,0.004635071}, {710,0.004696682}, {715,0.004682464}, {720,0.005014218}, {725,0.004763033}, {730,0.004881517}, {735,0.005014218}, {740,0.004853081}, {745,0.004867299}, {750,0.005194313}, {755,0.004834123}, {760,0.004886256}, {765,0.006109005}, {770,0.005218009}, {775,0.005189573}, {780,0.005104265}, {785,0.006241706}, {790,0.005279621}, {795,0.005341232}, {800,0.005255924}, {805,0.005236967}, {810,0.005383886}, {815,0.005549763}, {820,0.006601896}, {825,0.005578199}, {830,0.005478673}, {835,0.005478673}, {840,0.006303318}, {845,0.005701422}, {850,0.005587678}, {855,0.005611374}, {860,0.005511848}, {865,0.006374408}, {870,0.005905213}, {875,0.005791469}, {880,0.005691943}, {885,0.005554502}, {890,0.006563981}, {895,0.006023697}, {900,0.005725118}, {905,0.005966825}, {910,0.006099526}, {915,0.006810427}, {920,0.006004739}, {925,0.006137441}, {930,0.005976303}, {935,0.006142180}, {940,0.006308057}, {945,0.007180095}, {950,0.006142180}, {955,0.006175355}, {960,0.006445498}, {965,0.006478673}, {970,0.006421801}, {975,0.006459716}, {980,0.006492891}, {985,0.007208531}, {990,0.008516588}, {995,0.006753555}, {1000,0.006554502}, {1010,0.006672986}, {1020,0.006753555}, {1030,0.006815166}, {1040,0.006895735}, {1050,0.007037915}, {1060,0.007085308}, {1070,0.008037915}, {1080,0.007137441}, {1090,0.007222749}, {1100,0.007407583}, {1110,0.008672986}, {1120,0.007393365}, {1130,0.007587678}, {1140,0.007725118}, {1150,0.008654028}, {1160,0.007890995}, {1170,0.007834123}, {1180,0.008066351}, {1190,0.008090047}, {1200,0.008341232}, {1210,0.008654028}, {1220,0.008450237}, {1230,0.008412322}, {1240,0.008459716}, {1250,0.009592417}, {1260,0.010061611}, {1270,0.008545024}, {1280,0.008938389}, {1290,0.009061611}, {1300,0.009279621}, {1310,0.009213270}, {1320,0.010454976}, {1330,0.010635071}, {1340,0.009701422}, {1350,0.009426540}, {1360,0.011298578}, {1370,0.009909953}, {1380,0.009616114}, {1390,0.009800948}, {1400,0.009962085}, {1410,0.010075829}, {1420,0.010995261}, {1430,0.010336493}, {1440,0.010729858}, {1450,0.011696682}, {1460,0.010815166}, {1470,0.010677725}, {1480,0.011966825}, {1490,0.012018957}, {1500,0.011028436}, {1510,0.012478673}, {1520,0.012023697}, {1530,0.011454976}, {1540,0.012696682}, {1550,0.011393365}, {1560,0.011597156}, {1570,0.013928910}, {1580,0.011862559}, {1590,0.011739336}, {1600,0.011824645}, {1610,0.011995261}, {1620,0.011966825}, {1630,0.012170616}, {1640,0.012469194}, {1650,0.012521327}, {1660,0.013995261}, {1670,0.012521327}, {1680,0.013843602}, {1690,0.012663507}, {1700,0.012767773}, {1710,0.012800948}, {1720,0.012971564}, {1730,0.013047393}, {1740,0.014293839}, {1750,0.012805687}, {1760,0.014364929}, {1770,0.013431280}, {1780,0.013454976}, {1790,0.014706161}, {1800,0.013440758}, {1810,0.015440758}, {1820,0.013672986}, {1830,0.013767773}, {1840,0.015213270}, {1850,0.013848341}, {1860,0.015734597}, {1870,0.014018957}, {1880,0.014132701}, {1890,0.015284360}, {1900,0.014232227}, {1910,0.014227488}, {1920,0.014350711}, {1930,0.016421801}, {1940,0.014658768}, {1950,0.014687204}, {1960,0.017549763}, {1970,0.014677725}, {1980,0.014563981}, {1990,0.014971564}, {2000,0.016568720}, {2050,0.015222749}, {2100,0.015834123}, {2150,0.017308057}, {2200,0.016658768}, {2250,0.018772512}, {2300,0.017308057}, {2350,0.019511848}, {2400,0.018151659}, {2450,0.018056872}, {2500,0.021436019}, {2550,0.019454976}, {2600,0.021000000}, {2650,0.020374408}, {2700,0.022952607}, {2750,0.021322275}, {2800,0.021402844}, {2850,0.024213270}, {2900,0.022777251}, {2950,0.024582938}, {3000,0.025848341}, {3050,0.024018957}, {3100,0.026767773}, {3150,0.028554502}, {3200,0.025407583}, {3250,0.027905213}, {3300,0.027554502}, {3350,0.026540284}, {3400,0.026791469}, {3450,0.031450237}, {3500,0.032109005}, {3550,0.028094787}, {3600,0.028426540}, {3650,0.032497630}, {3700,0.034383886}, {3750,0.032270142}, {3800,0.030042654}, {3850,0.030398104}, {3900,0.029805687}, {3950,0.033023697}, {4000,0.039018957}, {4050,0.034677725}, {4100,0.036033175}, {4150,0.033009479}, {4200,0.033616114}, {4250,0.033900474}, {4300,0.034502370}, {4350,0.034563981}, {4400,0.038526066}, {4450,0.038094787}, {4500,0.038957346}, {4550,0.039905213}, {4600,0.040298578}, {4650,0.040800948}, {4700,0.041592417}, {4750,0.041222749}, {4800,0.041028436}, {4850,0.040668246}, {4900,0.039507109}, {4950,0.039990521}, {5000,0.040488152}, {5050,0.06486}, {5100,0.04429}, {5150,0.04257}, {5200,0.04143}, {5250,0.04029}, {5300,0.04600}, {5350,0.04714}, {5400,0.04900}, {5450,0.04714}, {5500,0.04600}, {5550,0.04314}, {5600,0.05214}, {5650,0.05143}, {5700,0.04871}, {5750,0.04714}, {5800,0.04886}, {5850,0.05300}, {5900,0.05086}, {5950,0.04586}, {6000,0.05500}, {6050,0.05557}, {6100,0.05029}, {6150,0.05914}, {6200,0.05657}, {6250,0.05086}, {6300,0.05614}, {6350,0.05900}, {6400,0.05200}, {6450,0.05543}, {6500,0.05614}, {6550,0.05414}, {6600,0.06443}, {6650,0.05143}, {6700,0.06414}, {6750,0.05357}, {6800,0.06300}, {6850,0.05629}, {6900,0.05957}, {6950,0.05814}, {7000,0.06271}, {7050,0.05943}, {7100,0.06557}, {7150,0.06114}, {7200,0.06714}, {7250,0.06071}, {7300,0.06514}, {7350,0.06700}, {7400,0.06286}, {7450,0.06957}, {7500,0.06229}, {7550,0.06857}, {7600,0.06929}, {7650,0.06386}, {7700,0.07229}, {7750,0.06929}, {7800,0.06443}, {7850,0.07214}, {7900,0.07171}, {7950,0.06786}, {8000,0.07414}, {8050,0.07371}, {8100,0.06986}, {8150,0.06729}, {8200,0.07614}, {8250,0.07586}, {8300,0.07229}, {8350,0.07657}, {8400,0.07214}, {8450,0.07743}, {8500,0.07786}, {8550,0.08029}, {8600,0.07600}, {8650,0.07729}, {8700,0.07886}, {8750,0.07886}, {8800,0.08129}, {8850,0.07971}, {8900,0.07929}, {8950,0.08414}, {9000,0.08300}, {9050,0.08571}, {9100,0.07929}, {9150,0.08000}, {9200,0.08114}, {9250,0.08186}, {9300,0.08171}, {9350,0.08143}, {9400,0.08357}, {9450,0.08400}, {9500,0.09143}, {9550,0.08643}, {9600,0.08771}, {9650,0.08843}, {9700,0.08686}, {9750,0.08986}, {9800,0.09143}, {9850,0.09271}, {9900,0.09243}, {9950,0.09114}, {10000,0.09400}, {10100,0.08857}, {10200,0.09286}, {10300,0.09114}, {10400,0.09943}, {10500,0.09571}, {10600,0.09414}, {10700,0.49757}, {10800,0.10243}, {10900,0.09357}, {11000,0.09886}, {11100,0.10014}, {11200,0.09929}, {11300,0.10014}, {11400,0.09800}, {11500,0.10314}, {11600,0.10114}, {11700,0.10043}, {11800,0.10171}, {11900,0.10986}, {12000,0.10457}, {12100,0.11386}, {12200,0.11286}, {12300,0.10900}, {12400,0.11071}, {12500,0.11171}, {12600,0.11043}, {12700,0.11586}, {12800,0.12200}, {12900,0.11600}, {13000,0.11529}, {13100,0.12100}, {13200,0.12343}, {13300,0.12500}, {13400,0.12229}, {13500,0.12114}, {13600,0.11686}, {13700,0.11871}, {13800,0.11743}, {13900,0.12186}, {14000,0.12286}, {14100,0.12529}, {14200,0.11929}, {14300,0.12586}, {14400,0.12829}, {14500,0.13129}, {14600,0.13257}, {14700,0.12629}, {14800,0.13071}, {14900,0.13100}, {15000,0.13114}, {15100,0.13914}, {15200,0.13157}, {15300,0.13029}, {15400,0.14614}, {15500,0.14586}, {15600,0.13943}, {15700,0.14700}, {15800,0.14300}, {15900,0.13886}, {16000,0.15271}, {16100,0.14000}, {16200,0.14714}, {16300,0.14129}, {16400,0.15000}, {16500,0.14243}, {16600,0.15743}, {16700,0.14457}, {16800,0.14929}, {16900,0.16243}, {17000,0.14486}, {17100,0.15957}, {17200,0.16857}, {17300,0.14900}, {17400,0.15329}, {17500,0.16186}, {17600,0.16286}, {17700,0.14871}, {17800,0.14771}, {17900,0.16343}, {18000,0.16514}, {18100,0.18014}, {18200,0.16543}, {18300,0.16314}, {18400,0.16029}, {18500,0.15929}, {18600,0.16043}, {18700,0.16043}, {18800,0.15914}, {18900,0.16629}, {19000,0.16914}, {19100,0.17843}, {19200,0.18386}, {19300,0.18029}, {19400,0.17386}, {19500,0.16086}, {19600,0.16886}, {19700,0.18900}, {19800,0.18600}, {19900,0.17271}, {20000,0.18260}};
data["big_flat"]["beta; Parametricity"]["norm reif"]["system"] = {{1,0.000075829}, {2,0.000037915}, {3,0.000000000}, {4,0.000000000}, {5,0.000018957}, {6,0.000018957}, {7,0.000000000}, {8,0.000018957}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000037915}, {14,0.000018957}, {15,0.000018957}, {16,0.000000000}, {17,0.000018957}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000018957}, {24,0.000000000}, {25,0.000018957}, {26,0.000018957}, {27,0.000056872}, {28,0.000018957}, {29,0.000018957}, {30,0.000000000}, {31,0.000018957}, {32,0.000018957}, {33,0.000000000}, {34,0.000018957}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000018957}, {46,0.000018957}, {47,0.000000000}, {48,0.000000000}, {49,0.000018957}, {50,0.000033175}, {51,0.000000000}, {52,0.000018957}, {53,0.000000000}, {54,0.000018957}, {55,0.000018957}, {56,0.000018957}, {57,0.000000000}, {58,0.000014218}, {59,0.000000000}, {60,0.000018957}, {61,0.000014218}, {62,0.000000000}, {63,0.000018957}, {64,0.000018957}, {65,0.000018957}, {66,0.000037915}, {67,0.000000000}, {68,0.000037915}, {69,0.000000000}, {70,0.000000000}, {71,0.000018957}, {72,0.000018957}, {73,0.000018957}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000037915}, {78,0.000037915}, {79,0.000000000}, {80,0.000000000}, {81,0.000037915}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000018957}, {87,0.000018957}, {88,0.000037915}, {89,0.000018957}, {90,0.000052133}, {91,0.000000000}, {92,0.000018957}, {93,0.000018957}, {94,0.000018957}, {95,0.000000000}, {96,0.000037915}, {97,0.000000000}, {98,0.000018957}, {99,0.000018957}, {100,0.000000000}, {101,0.000018957}, {102,0.000014218}, {103,0.000018957}, {104,0.000000000}, {105,0.000014218}, {106,0.000000000}, {107,0.000000000}, {108,0.000018957}, {109,0.000018957}, {110,0.000000000}, {111,0.000018957}, {112,0.000000000}, {113,0.000018957}, {114,0.000000000}, {115,0.000000000}, {116,0.000018957}, {117,0.000018957}, {118,0.000014218}, {119,0.000037915}, {120,0.000037915}, {121,0.000037915}, {122,0.000018957}, {123,0.000018957}, {124,0.000018957}, {125,0.000018957}, {126,0.000037915}, {127,0.000018957}, {128,0.000018957}, {129,0.000000000}, {130,0.000000000}, {131,0.000014218}, {132,0.000018957}, {133,0.000056872}, {134,0.000018957}, {135,0.000000000}, {136,0.000018957}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000018957}, {141,0.000018957}, {142,0.000000000}, {143,0.000000000}, {144,0.000018957}, {145,0.000018957}, {146,0.000000000}, {147,0.000018957}, {148,0.000018957}, {149,0.000033175}, {150,0.000000000}, {151,0.000018957}, {152,0.000090047}, {153,0.000000000}, {154,0.000000000}, {155,0.000018957}, {156,0.000000000}, {157,0.000000000}, {158,0.000037915}, {159,0.000000000}, {160,0.000018957}, {161,0.000000000}, {162,0.000000000}, {163,0.000018957}, {164,0.000018957}, {165,0.000000000}, {166,0.000018957}, {167,0.000018957}, {168,0.000018957}, {169,0.000037915}, {170,0.000000000}, {171,0.000018957}, {172,0.000018957}, {173,0.000037915}, {174,0.000000000}, {175,0.000000000}, {176,0.000018957}, {177,0.000018957}, {178,0.000018957}, {179,0.000000000}, {180,0.000000000}, {181,0.000037915}, {182,0.000037915}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000018957}, {187,0.000014218}, {188,0.000037915}, {189,0.000000000}, {190,0.000000000}, {191,0.000018957}, {192,0.000018957}, {193,0.000000000}, {194,0.000018957}, {195,0.000018957}, {196,0.000000000}, {197,0.000018957}, {198,0.000037915}, {199,0.000000000}, {200,0.000018957}, {201,0.000000000}, {202,0.000018957}, {203,0.000000000}, {204,0.000000000}, {205,0.000018957}, {206,0.000056872}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000018957}, {211,0.000037915}, {212,0.000018957}, {213,0.000018957}, {214,0.000014218}, {215,0.000000000}, {216,0.000018957}, {217,0.000056872}, {218,0.000075829}, {219,0.000018957}, {220,0.000000000}, {221,0.000018957}, {222,0.000018957}, {223,0.000000000}, {224,0.000037915}, {225,0.000018957}, {226,0.000018957}, {227,0.000000000}, {228,0.000018957}, {229,0.000000000}, {230,0.000018957}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000056872}, {235,0.000018957}, {236,0.000000000}, {237,0.000018957}, {238,0.000000000}, {239,0.000014218}, {240,0.000018957}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000018957}, {245,0.000018957}, {246,0.000018957}, {247,0.000000000}, {248,0.000018957}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000037915}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000018957}, {257,0.000000000}, {258,0.000018957}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000018957}, {267,0.000000000}, {268,0.000000000}, {269,0.000018957}, {270,0.000000000}, {271,0.000000000}, {272,0.000018957}, {273,0.000000000}, {274,0.000000000}, {275,0.000037915}, {276,0.000037915}, {277,0.000033175}, {278,0.000037915}, {279,0.000000000}, {280,0.000037915}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000018957}, {288,0.000000000}, {289,0.000000000}, {290,0.000018957}, {291,0.000018957}, {292,0.000018957}, {293,0.000037915}, {294,0.000033175}, {295,0.000056872}, {296,0.000000000}, {297,0.000000000}, {298,0.000018957}, {299,0.000037915}, {300,0.000018957}, {301,0.000018957}, {302,0.000000000}, {303,0.000018957}, {304,0.000000000}, {305,0.000018957}, {306,0.000018957}, {307,0.000052133}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000018957}, {312,0.000000000}, {313,0.000037915}, {314,0.000000000}, {315,0.000000000}, {316,0.000037915}, {317,0.000000000}, {318,0.000037915}, {319,0.000014218}, {320,0.000037915}, {321,0.000000000}, {322,0.000037915}, {323,0.000018957}, {324,0.000000000}, {325,0.000000000}, {326,0.000094787}, {327,0.000000000}, {328,0.000056872}, {329,0.000000000}, {330,0.000000000}, {331,0.000018957}, {332,0.000018957}, {333,0.000018957}, {334,0.000018957}, {335,0.000000000}, {336,0.000000000}, {337,0.000018957}, {338,0.000018957}, {339,0.000000000}, {340,0.000000000}, {341,0.000052133}, {342,0.000018957}, {343,0.000000000}, {344,0.000018957}, {345,0.000000000}, {346,0.000000000}, {347,0.000018957}, {348,0.000037915}, {349,0.000018957}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000018957}, {355,0.000018957}, {356,0.000018957}, {357,0.000018957}, {358,0.000018957}, {359,0.000037915}, {360,0.000037915}, {361,0.000037915}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000018957}, {366,0.000014218}, {367,0.000018957}, {368,0.000037915}, {369,0.000000000}, {370,0.000000000}, {371,0.000052133}, {372,0.000018957}, {373,0.000000000}, {374,0.000000000}, {375,0.000033175}, {376,0.000037915}, {377,0.000000000}, {378,0.000000000}, {379,0.000056872}, {380,0.000018957}, {381,0.000018957}, {382,0.000018957}, {383,0.000033175}, {384,0.000037915}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000018957}, {389,0.000018957}, {390,0.000033175}, {391,0.000018957}, {392,0.000000000}, {393,0.000037915}, {394,0.000018957}, {395,0.000018957}, {396,0.000018957}, {397,0.000018957}, {398,0.000037915}, {399,0.000018957}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000018957}, {405,0.000000000}, {406,0.000018957}, {407,0.000018957}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000018957}, {412,0.000018957}, {413,0.000018957}, {414,0.000014218}, {415,0.000037915}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000018957}, {420,0.000000000}, {421,0.000000000}, {422,0.000018957}, {423,0.000000000}, {424,0.000075829}, {425,0.000000000}, {426,0.000018957}, {427,0.000037915}, {428,0.000000000}, {429,0.000037915}, {430,0.000000000}, {431,0.000014218}, {432,0.000000000}, {433,0.000000000}, {434,0.000018957}, {435,0.000000000}, {436,0.000033175}, {437,0.000000000}, {438,0.000000000}, {439,0.000018957}, {440,0.000000000}, {441,0.000037915}, {442,0.000037915}, {443,0.000000000}, {444,0.000000000}, {445,0.000037915}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000018957}, {451,0.000018957}, {452,0.000000000}, {453,0.000052133}, {454,0.000018957}, {455,0.000000000}, {456,0.000000000}, {457,0.000037915}, {458,0.000000000}, {459,0.000018957}, {460,0.000000000}, {461,0.000018957}, {462,0.000037915}, {463,0.000018957}, {464,0.000018957}, {465,0.000000000}, {466,0.000000000}, {467,0.000018957}, {468,0.000018957}, {469,0.000000000}, {470,0.000056872}, {471,0.000000000}, {472,0.000018957}, {473,0.000000000}, {474,0.000037915}, {475,0.000000000}, {476,0.000000000}, {477,0.000014218}, {478,0.000018957}, {479,0.000018957}, {480,0.000018957}, {481,0.000037915}, {482,0.000014218}, {483,0.000018957}, {484,0.000018957}, {485,0.000000000}, {486,0.000000000}, {487,0.000037915}, {488,0.000000000}, {489,0.000018957}, {490,0.000037915}, {491,0.000018957}, {492,0.000075829}, {493,0.000018957}, {494,0.000000000}, {495,0.000000000}, {496,0.000018957}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000037915}, {505,0.000000000}, {510,0.000018957}, {515,0.000000000}, {520,0.000000000}, {525,0.000037915}, {530,0.000018957}, {535,0.000000000}, {540,0.000018957}, {545,0.000028436}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000056872}, {570,0.000018957}, {575,0.000018957}, {580,0.000018957}, {585,0.000000000}, {590,0.000000000}, {595,0.000037915}, {600,0.000000000}, {605,0.000018957}, {610,0.000056872}, {615,0.000018957}, {620,0.000037915}, {625,0.000000000}, {630,0.000037915}, {635,0.000056872}, {640,0.000056872}, {645,0.000000000}, {650,0.000018957}, {655,0.000018957}, {660,0.000018957}, {665,0.000018957}, {670,0.000014218}, {675,0.000000000}, {680,0.000014218}, {685,0.000018957}, {690,0.000000000}, {695,0.000000000}, {700,0.000018957}, {705,0.000075829}, {710,0.000018957}, {715,0.000018957}, {720,0.000037915}, {725,0.000018957}, {730,0.000014218}, {735,0.000018957}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000018957}, {760,0.000018957}, {765,0.000037915}, {770,0.000018957}, {775,0.000037915}, {780,0.000037915}, {785,0.000037915}, {790,0.000018957}, {795,0.000000000}, {800,0.000056872}, {805,0.000037915}, {810,0.000018957}, {815,0.000000000}, {820,0.000037915}, {825,0.000018957}, {830,0.000000000}, {835,0.000018957}, {840,0.000000000}, {845,0.000037915}, {850,0.000018957}, {855,0.000018957}, {860,0.000000000}, {865,0.000056872}, {870,0.000000000}, {875,0.000000000}, {880,0.000018957}, {885,0.000037915}, {890,0.000037915}, {895,0.000018957}, {900,0.000000000}, {905,0.000000000}, {910,0.000033175}, {915,0.000018957}, {920,0.000018957}, {925,0.000000000}, {930,0.000037915}, {935,0.000000000}, {940,0.000018957}, {945,0.000018957}, {950,0.000000000}, {955,0.000018957}, {960,0.000037915}, {965,0.000000000}, {970,0.000037915}, {975,0.000037915}, {980,0.000018957}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000052133}, {1010,0.000018957}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000037915}, {1050,0.000018957}, {1060,0.000037915}, {1070,0.000018957}, {1080,0.000018957}, {1090,0.000018957}, {1100,0.000018957}, {1110,0.000000000}, {1120,0.000018957}, {1130,0.000000000}, {1140,0.000037915}, {1150,0.000000000}, {1160,0.000018957}, {1170,0.000018957}, {1180,0.000037915}, {1190,0.000037915}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000018957}, {1230,0.000056872}, {1240,0.000000000}, {1250,0.000014218}, {1260,0.000018957}, {1270,0.000018957}, {1280,0.000056872}, {1290,0.000000000}, {1300,0.000018957}, {1310,0.000018957}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000037915}, {1350,0.000037915}, {1360,0.000037915}, {1370,0.000018957}, {1380,0.000000000}, {1390,0.000037915}, {1400,0.000000000}, {1410,0.000037915}, {1420,0.000000000}, {1430,0.000018957}, {1440,0.000037915}, {1450,0.000018957}, {1460,0.000000000}, {1470,0.000075829}, {1480,0.000037915}, {1490,0.000094787}, {1500,0.000037915}, {1510,0.000018957}, {1520,0.000000000}, {1530,0.000018957}, {1540,0.000000000}, {1550,0.000033175}, {1560,0.000018957}, {1570,0.000056872}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000018957}, {1630,0.000056872}, {1640,0.000000000}, {1650,0.000037915}, {1660,0.000056872}, {1670,0.000000000}, {1680,0.000018957}, {1690,0.000075829}, {1700,0.000056872}, {1710,0.000018957}, {1720,0.000018957}, {1730,0.000000000}, {1740,0.000018957}, {1750,0.000037915}, {1760,0.000037915}, {1770,0.000018957}, {1780,0.000018957}, {1790,0.000018957}, {1800,0.000037915}, {1810,0.000071090}, {1820,0.000018957}, {1830,0.000037915}, {1840,0.000056872}, {1850,0.000018957}, {1860,0.000018957}, {1870,0.000014218}, {1880,0.000037915}, {1890,0.000018957}, {1900,0.000037915}, {1910,0.000033175}, {1920,0.000018957}, {1930,0.000075829}, {1940,0.000037915}, {1950,0.000037915}, {1960,0.000018957}, {1970,0.000018957}, {1980,0.000037915}, {1990,0.000037915}, {2000,0.000146919}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000056872}, {2200,0.000018957}, {2250,0.000018957}, {2300,0.000000000}, {2350,0.000075829}, {2400,0.000000000}, {2450,0.000018957}, {2500,0.000037915}, {2550,0.000000000}, {2600,0.000075829}, {2650,0.000018957}, {2700,0.000018957}, {2750,0.000018957}, {2800,0.000037915}, {2850,0.000075829}, {2900,0.000037915}, {2950,0.000056872}, {3000,0.000037915}, {3050,0.000018957}, {3100,0.000018957}, {3150,0.000127962}, {3200,0.000018957}, {3250,0.000037915}, {3300,0.000109005}, {3350,0.000056872}, {3400,0.000000000}, {3450,0.000056872}, {3500,0.000061611}, {3550,0.000018957}, {3600,0.000000000}, {3650,0.000037915}, {3700,0.000056872}, {3750,0.000037915}, {3800,0.000075829}, {3850,0.000037915}, {3900,0.000018957}, {3950,0.000018957}, {4000,0.000113744}, {4050,0.000018957}, {4100,0.000113744}, {4150,0.000018957}, {4200,0.000094787}, {4250,0.000037915}, {4300,0.000000000}, {4350,0.000075829}, {4400,0.000018957}, {4450,0.000018957}, {4500,0.000018957}, {4550,0.000056872}, {4600,0.000056872}, {4650,0.000037915}, {4700,0.000000000}, {4750,0.000052133}, {4800,0.000018957}, {4850,0.000037915}, {4900,0.000018957}, {4950,0.000018957}, {5000,0.000000000}, {5050,0.00057}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00057}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00114}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00057}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00057}, {6600,0.00000}, {6650,0.00000}, {6700,0.00114}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00100}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00057}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00057}, {7550,0.00057}, {7600,0.00000}, {7650,0.00100}, {7700,0.00057}, {7750,0.00000}, {7800,0.00000}, {7850,0.00057}, {7900,0.00057}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00114}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00057}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00057}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00057}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00057}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00057}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00057}, {19100,0.00000}, {19200,0.00000}, {19300,0.00057}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["beta; Parametricity"]["post"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000004739}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.00000}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["beta; Parametricity"]["post"]["user"] = {{1,0.000037915}, {2,0.000052133}, {3,0.000000000}, {4,0.000042654}, {5,0.000052133}, {6,0.000033175}, {7,0.000000000}, {8,0.000014218}, {9,0.000000000}, {10,0.000047393}, {11,0.000090047}, {12,0.000033175}, {13,0.000033175}, {14,0.000018957}, {15,0.000052133}, {16,0.000000000}, {17,0.000042654}, {18,0.000018957}, {19,0.000000000}, {20,0.000000000}, {21,0.000037915}, {22,0.000000000}, {23,0.000028436}, {24,0.000066351}, {25,0.000061611}, {26,0.000033175}, {27,0.000033175}, {28,0.000066351}, {29,0.000000000}, {30,0.000014218}, {31,0.000014218}, {32,0.000018957}, {33,0.000018957}, {34,0.000033175}, {35,0.000018957}, {36,0.000075829}, {37,0.000071090}, {38,0.000033175}, {39,0.000000000}, {40,0.000042654}, {41,0.000000000}, {42,0.000000000}, {43,0.000071090}, {44,0.000033175}, {45,0.000014218}, {46,0.000018957}, {47,0.000061611}, {48,0.000033175}, {49,0.000014218}, {50,0.000014218}, {51,0.000037915}, {52,0.000014218}, {53,0.000037915}, {54,0.000018957}, {55,0.000018957}, {56,0.000014218}, {57,0.000018957}, {58,0.000056872}, {59,0.000018957}, {60,0.000066351}, {61,0.000014218}, {62,0.000018957}, {63,0.000047393}, {64,0.000000000}, {65,0.000000000}, {66,0.000056872}, {67,0.000014218}, {68,0.000028436}, {69,0.000028436}, {70,0.000018957}, {71,0.000042654}, {72,0.000033175}, {73,0.000000000}, {74,0.000018957}, {75,0.000047393}, {76,0.000000000}, {77,0.000047393}, {78,0.000014218}, {79,0.000047393}, {80,0.000018957}, {81,0.000028436}, {82,0.000014218}, {83,0.000000000}, {84,0.000028436}, {85,0.000014218}, {86,0.000014218}, {87,0.000061611}, {88,0.000018957}, {89,0.000033175}, {90,0.000028436}, {91,0.000047393}, {92,0.000000000}, {93,0.000028436}, {94,0.000104265}, {95,0.000052133}, {96,0.000056872}, {97,0.000033175}, {98,0.000000000}, {99,0.000014218}, {100,0.000056872}, {101,0.000018957}, {102,0.000028436}, {103,0.000047393}, {104,0.000018957}, {105,0.000037915}, {106,0.000018957}, {107,0.000037915}, {108,0.000018957}, {109,0.000052133}, {110,0.000018957}, {111,0.000000000}, {112,0.000071090}, {113,0.000037915}, {114,0.000000000}, {115,0.000071090}, {116,0.000028436}, {117,0.000000000}, {118,0.000018957}, {119,0.000033175}, {120,0.000018957}, {121,0.000071090}, {122,0.000033175}, {123,0.000014218}, {124,0.000033175}, {125,0.000014218}, {126,0.000037915}, {127,0.000018957}, {128,0.000014218}, {129,0.000018957}, {130,0.000014218}, {131,0.000018957}, {132,0.000047393}, {133,0.000000000}, {134,0.000033175}, {135,0.000052133}, {136,0.000033175}, {137,0.000000000}, {138,0.000014218}, {139,0.000018957}, {140,0.000052133}, {141,0.000052133}, {142,0.000061611}, {143,0.000018957}, {144,0.000052133}, {145,0.000028436}, {146,0.000071090}, {147,0.000000000}, {148,0.000018957}, {149,0.000042654}, {150,0.000000000}, {151,0.000018957}, {152,0.000033175}, {153,0.000037915}, {154,0.000037915}, {155,0.000052133}, {156,0.000047393}, {157,0.000000000}, {158,0.000052133}, {159,0.000066351}, {160,0.000018957}, {161,0.000014218}, {162,0.000018957}, {163,0.000018957}, {164,0.000018957}, {165,0.000000000}, {166,0.000018957}, {167,0.000047393}, {168,0.000056872}, {169,0.000000000}, {170,0.000014218}, {171,0.000000000}, {172,0.000000000}, {173,0.000037915}, {174,0.000037915}, {175,0.000066351}, {176,0.000014218}, {177,0.000014218}, {178,0.000056872}, {179,0.000014218}, {180,0.000000000}, {181,0.000047393}, {182,0.000066351}, {183,0.000014218}, {184,0.000018957}, {185,0.000033175}, {186,0.000037915}, {187,0.000071090}, {188,0.000000000}, {189,0.000052133}, {190,0.000014218}, {191,0.000047393}, {192,0.000047393}, {193,0.000000000}, {194,0.000018957}, {195,0.000033175}, {196,0.000061611}, {197,0.000000000}, {198,0.000037915}, {199,0.000014218}, {200,0.000018957}, {201,0.000000000}, {202,0.000056872}, {203,0.000000000}, {204,0.000047393}, {205,0.000047393}, {206,0.000033175}, {207,0.000000000}, {208,0.000047393}, {209,0.000478673}, {210,0.000052133}, {211,0.000028436}, {212,0.000066351}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000014218}, {218,0.000018957}, {219,0.000037915}, {220,0.000018957}, {221,0.000014218}, {222,0.000018957}, {223,0.000018957}, {224,0.000075829}, {225,0.000047393}, {226,0.000018957}, {227,0.000014218}, {228,0.000052133}, {229,0.000037915}, {230,0.000090047}, {231,0.000014218}, {232,0.000052133}, {233,0.000061611}, {234,0.000033175}, {235,0.000037915}, {236,0.000018957}, {237,0.000066351}, {238,0.000033175}, {239,0.000033175}, {240,0.000042654}, {241,0.000033175}, {242,0.000033175}, {243,0.000047393}, {244,0.000066351}, {245,0.000000000}, {246,0.000000000}, {247,0.000014218}, {248,0.000018957}, {249,0.000052133}, {250,0.000018957}, {251,0.000018957}, {252,0.000033175}, {253,0.000052133}, {254,0.000033175}, {255,0.000028436}, {256,0.000052133}, {257,0.000033175}, {258,0.000042654}, {259,0.000028436}, {260,0.000018957}, {261,0.000052133}, {262,0.000033175}, {263,0.000056872}, {264,0.000000000}, {265,0.000000000}, {266,0.000052133}, {267,0.000052133}, {268,0.000037915}, {269,0.000099526}, {270,0.000014218}, {271,0.000047393}, {272,0.000014218}, {273,0.000028436}, {274,0.000014218}, {275,0.000018957}, {276,0.000033175}, {277,0.000085308}, {278,0.000014218}, {279,0.000052133}, {280,0.000014218}, {281,0.000000000}, {282,0.000052133}, {283,0.000018957}, {284,0.000042654}, {285,0.000014218}, {286,0.000052133}, {287,0.000047393}, {288,0.000028436}, {289,0.000000000}, {290,0.000037915}, {291,0.000014218}, {292,0.000018957}, {293,0.000028436}, {294,0.000018957}, {295,0.000052133}, {296,0.000047393}, {297,0.000033175}, {298,0.000047393}, {299,0.000042654}, {300,0.000033175}, {301,0.000000000}, {302,0.000066351}, {303,0.000014218}, {304,0.000037915}, {305,0.000033175}, {306,0.000033175}, {307,0.000000000}, {308,0.000033175}, {309,0.000056872}, {310,0.000014218}, {311,0.000071090}, {312,0.000056872}, {313,0.000090047}, {314,0.000047393}, {315,0.000018957}, {316,0.000014218}, {317,0.000018957}, {318,0.000000000}, {319,0.000014218}, {320,0.000080569}, {321,0.000085308}, {322,0.000000000}, {323,0.000000000}, {324,0.000047393}, {325,0.000028436}, {326,0.000033175}, {327,0.000037915}, {328,0.000000000}, {329,0.000033175}, {330,0.000037915}, {331,0.000014218}, {332,0.000000000}, {333,0.000066351}, {334,0.000052133}, {335,0.000014218}, {336,0.000033175}, {337,0.000000000}, {338,0.000000000}, {339,0.000066351}, {340,0.000018957}, {341,0.000018957}, {342,0.000052133}, {343,0.000056872}, {344,0.000056872}, {345,0.000014218}, {346,0.000042654}, {347,0.000047393}, {348,0.000071090}, {349,0.000000000}, {350,0.000018957}, {351,0.000014218}, {352,0.000033175}, {353,0.000018957}, {354,0.000094787}, {355,0.000047393}, {356,0.000000000}, {357,0.000014218}, {358,0.000018957}, {359,0.000094787}, {360,0.000014218}, {361,0.000052133}, {362,0.000037915}, {363,0.000033175}, {364,0.000033175}, {365,0.000033175}, {366,0.000018957}, {367,0.000052133}, {368,0.000014218}, {369,0.000000000}, {370,0.000037915}, {371,0.000018957}, {372,0.000000000}, {373,0.000099526}, {374,0.000033175}, {375,0.000052133}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000033175}, {380,0.000037915}, {381,0.000052133}, {382,0.000052133}, {383,0.000000000}, {384,0.000052133}, {385,0.000037915}, {386,0.000052133}, {387,0.000033175}, {388,0.000037915}, {389,0.000018957}, {390,0.000052133}, {391,0.000000000}, {392,0.000014218}, {393,0.000037915}, {394,0.000000000}, {395,0.000047393}, {396,0.000000000}, {397,0.000000000}, {398,0.000014218}, {399,0.000000000}, {400,0.000042654}, {401,0.000033175}, {402,0.000014218}, {403,0.000028436}, {404,0.000037915}, {405,0.000080569}, {406,0.000014218}, {407,0.000014218}, {408,0.000104265}, {409,0.000056872}, {410,0.000071090}, {411,0.000061611}, {412,0.000014218}, {413,0.000033175}, {414,0.000033175}, {415,0.000028436}, {416,0.000014218}, {417,0.000052133}, {418,0.000033175}, {419,0.000028436}, {420,0.000066351}, {421,0.000018957}, {422,0.000014218}, {423,0.000066351}, {424,0.000052133}, {425,0.000018957}, {426,0.000018957}, {427,0.000018957}, {428,0.000028436}, {429,0.000018957}, {430,0.000014218}, {431,0.000066351}, {432,0.000014218}, {433,0.000037915}, {434,0.000018957}, {435,0.000109005}, {436,0.000018957}, {437,0.000085308}, {438,0.000033175}, {439,0.000047393}, {440,0.000037915}, {441,0.000061611}, {442,0.000056872}, {443,0.000000000}, {444,0.000018957}, {445,0.000047393}, {446,0.000037915}, {447,0.000061611}, {448,0.000047393}, {449,0.000066351}, {450,0.000037915}, {451,0.000071090}, {452,0.000033175}, {453,0.000037915}, {454,0.000052133}, {455,0.000000000}, {456,0.000033175}, {457,0.000066351}, {458,0.000066351}, {459,0.000066351}, {460,0.000018957}, {461,0.000018957}, {462,0.000000000}, {463,0.000028436}, {464,0.000033175}, {465,0.000042654}, {466,0.000000000}, {467,0.000018957}, {468,0.000052133}, {469,0.000085308}, {470,0.000014218}, {471,0.000018957}, {472,0.000033175}, {473,0.000047393}, {474,0.000018957}, {475,0.000018957}, {476,0.000047393}, {477,0.000000000}, {478,0.000000000}, {479,0.000052133}, {480,0.000014218}, {481,0.000028436}, {482,0.000018957}, {483,0.000018957}, {484,0.000018957}, {485,0.000056872}, {486,0.000037915}, {487,0.000014218}, {488,0.000018957}, {489,0.000056872}, {490,0.000018957}, {491,0.000071090}, {492,0.000000000}, {493,0.000037915}, {494,0.000018957}, {495,0.000052133}, {496,0.000000000}, {497,0.000037915}, {498,0.000000000}, {499,0.000018957}, {500,0.000014218}, {505,0.000071090}, {510,0.000071090}, {515,0.000033175}, {520,0.000018957}, {525,0.000052133}, {530,0.000018957}, {535,0.000047393}, {540,0.000014218}, {545,0.000028436}, {550,0.000028436}, {555,0.000042654}, {560,0.000033175}, {565,0.000014218}, {570,0.000033175}, {575,0.000018957}, {580,0.000014218}, {585,0.000000000}, {590,0.000014218}, {595,0.000000000}, {600,0.000018957}, {605,0.000014218}, {610,0.000033175}, {615,0.000014218}, {620,0.000000000}, {625,0.000042654}, {630,0.000033175}, {635,0.000028436}, {640,0.000033175}, {645,0.000037915}, {650,0.000018957}, {655,0.000033175}, {660,0.000018957}, {665,0.000000000}, {670,0.000037915}, {675,0.000037915}, {680,0.000042654}, {685,0.000037915}, {690,0.000066351}, {695,0.000014218}, {700,0.000033175}, {705,0.000052133}, {710,0.000018957}, {715,0.000018957}, {720,0.000018957}, {725,0.000052133}, {730,0.000071090}, {735,0.000033175}, {740,0.000104265}, {745,0.000037915}, {750,0.000033175}, {755,0.000033175}, {760,0.000047393}, {765,0.000033175}, {770,0.000018957}, {775,0.000037915}, {780,0.000018957}, {785,0.000033175}, {790,0.000000000}, {795,0.000014218}, {800,0.000066351}, {805,0.000033175}, {810,0.000056872}, {815,0.000000000}, {820,0.000000000}, {825,0.000033175}, {830,0.000018957}, {835,0.000052133}, {840,0.000071090}, {845,0.000047393}, {850,0.000042654}, {855,0.000000000}, {860,0.000033175}, {865,0.000000000}, {870,0.000018957}, {875,0.000033175}, {880,0.000037915}, {885,0.000037915}, {890,0.000047393}, {895,0.000018957}, {900,0.000014218}, {905,0.000018957}, {910,0.000033175}, {915,0.000042654}, {920,0.000000000}, {925,0.000000000}, {930,0.000118483}, {935,0.000123223}, {940,0.000018957}, {945,0.000109005}, {950,0.000028436}, {955,0.000042654}, {960,0.000000000}, {965,0.000109005}, {970,0.000018957}, {975,0.000018957}, {980,0.000042654}, {985,0.000018957}, {990,0.000000000}, {995,0.000000000}, {1000,0.000056872}, {1010,0.000052133}, {1020,0.000066351}, {1030,0.000033175}, {1040,0.000085308}, {1050,0.000018957}, {1060,0.000056872}, {1070,0.000052133}, {1080,0.000037915}, {1090,0.000033175}, {1100,0.000037915}, {1110,0.000018957}, {1120,0.000052133}, {1130,0.000037915}, {1140,0.000000000}, {1150,0.000018957}, {1160,0.000033175}, {1170,0.000037915}, {1180,0.000000000}, {1190,0.000080569}, {1200,0.000014218}, {1210,0.000033175}, {1220,0.000018957}, {1230,0.000033175}, {1240,0.000113744}, {1250,0.000033175}, {1260,0.000018957}, {1270,0.000037915}, {1280,0.000018957}, {1290,0.000033175}, {1300,0.000037915}, {1310,0.000042654}, {1320,0.000000000}, {1330,0.000094787}, {1340,0.000018957}, {1350,0.000014218}, {1360,0.000052133}, {1370,0.000047393}, {1380,0.000047393}, {1390,0.000033175}, {1400,0.000052133}, {1410,0.000052133}, {1420,0.000018957}, {1430,0.000033175}, {1440,0.000000000}, {1450,0.000037915}, {1460,0.000033175}, {1470,0.000033175}, {1480,0.000104265}, {1490,0.000066351}, {1500,0.000033175}, {1510,0.000075829}, {1520,0.000047393}, {1530,0.000037915}, {1540,0.000018957}, {1550,0.000056872}, {1560,0.000052133}, {1570,0.000071090}, {1580,0.000056872}, {1590,0.000037915}, {1600,0.000018957}, {1610,0.000037915}, {1620,0.000033175}, {1630,0.000037915}, {1640,0.000033175}, {1650,0.000033175}, {1660,0.000018957}, {1670,0.000014218}, {1680,0.000000000}, {1690,0.000037915}, {1700,0.000066351}, {1710,0.000037915}, {1720,0.000033175}, {1730,0.000000000}, {1740,0.000018957}, {1750,0.000037915}, {1760,0.000018957}, {1770,0.000033175}, {1780,0.000018957}, {1790,0.000000000}, {1800,0.000071090}, {1810,0.000000000}, {1820,0.000018957}, {1830,0.000000000}, {1840,0.000071090}, {1850,0.000000000}, {1860,0.000014218}, {1870,0.000014218}, {1880,0.000052133}, {1890,0.000037915}, {1900,0.000028436}, {1910,0.000037915}, {1920,0.000018957}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000018957}, {1960,0.000018957}, {1970,0.000037915}, {1980,0.000018957}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000052133}, {2100,0.000000000}, {2150,0.000018957}, {2200,0.000000000}, {2250,0.000018957}, {2300,0.000000000}, {2350,0.000033175}, {2400,0.000018957}, {2450,0.000052133}, {2500,0.000000000}, {2550,0.000018957}, {2600,0.000071090}, {2650,0.000037915}, {2700,0.000000000}, {2750,0.000052133}, {2800,0.000018957}, {2850,0.000014218}, {2900,0.000052133}, {2950,0.000047393}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000047393}, {3150,0.000018957}, {3200,0.000071090}, {3250,0.000052133}, {3300,0.000028436}, {3350,0.000014218}, {3400,0.000033175}, {3450,0.000052133}, {3500,0.000033175}, {3550,0.000014218}, {3600,0.000018957}, {3650,0.000018957}, {3700,0.000056872}, {3750,0.000052133}, {3800,0.000056872}, {3850,0.000018957}, {3900,0.000014218}, {3950,0.000052133}, {4000,0.000052133}, {4050,0.000000000}, {4100,0.000037915}, {4150,0.000037915}, {4200,0.000037915}, {4250,0.000037915}, {4300,0.000052133}, {4350,0.000014218}, {4400,0.000052133}, {4450,0.000000000}, {4500,0.000052133}, {4550,0.000047393}, {4600,0.000075829}, {4650,0.000037915}, {4700,0.000018957}, {4750,0.000099526}, {4800,0.000033175}, {4850,0.000014218}, {4900,0.000018957}, {4950,0.000066351}, {5000,0.000066351}, {5050,0.00000}, {5100,0.00000}, {5150,0.00043}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00057}, {5600,0.00000}, {5650,0.00000}, {5700,0.00057}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00043}, {6350,0.00114}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00043}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00057}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00086}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00043}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00043}, {10000,0.00000}, {10100,0.00043}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00043}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00043}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00057}, {18700,0.00057}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["beta; Parametricity"]["post"]["system"] = {{1,0.000000000}, {2,0.000018957}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000018957}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000018957}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000018957}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000018957}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000018957}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000018957}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000018957}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000018957}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000018957}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000018957}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000018957}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000018957}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000018957}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000018957}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.00000}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["beta; Parametricity"]["pre"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.00000}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["beta; Parametricity"]["pre"]["user"] = {{1,0.000014218}, {2,0.000000000}, {3,0.000000000}, {4,0.000014218}, {5,0.000000000}, {6,0.000014218}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000018957}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000018957}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000018957}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000018957}, {34,0.000018957}, {35,0.000000000}, {36,0.000018957}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000014218}, {41,0.000000000}, {42,0.000014218}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000033175}, {58,0.000018957}, {59,0.000000000}, {60,0.000000000}, {61,0.000014218}, {62,0.000000000}, {63,0.000000000}, {64,0.000014218}, {65,0.000014218}, {66,0.000000000}, {67,0.000000000}, {68,0.000033175}, {69,0.000014218}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000014218}, {81,0.000014218}, {82,0.000033175}, {83,0.000014218}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000018957}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000014218}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000028436}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000018957}, {115,0.000000000}, {116,0.000028436}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000014218}, {125,0.000000000}, {126,0.000014218}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000018957}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000018957}, {142,0.000000000}, {143,0.000018957}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000018957}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000018957}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000014218}, {171,0.000028436}, {172,0.000000000}, {173,0.000018957}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000014218}, {179,0.000000000}, {180,0.000000000}, {181,0.000018957}, {182,0.000000000}, {183,0.000018957}, {184,0.000018957}, {185,0.000037915}, {186,0.000018957}, {187,0.000014218}, {188,0.000000000}, {189,0.000018957}, {190,0.000000000}, {191,0.000000000}, {192,0.000018957}, {193,0.000000000}, {194,0.000000000}, {195,0.000018957}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000018957}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000018957}, {213,0.000018957}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000014218}, {221,0.000033175}, {222,0.000014218}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000014218}, {233,0.000000000}, {234,0.000037915}, {235,0.000000000}, {236,0.000018957}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000018957}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000014218}, {246,0.000014218}, {247,0.000000000}, {248,0.000018957}, {249,0.000000000}, {250,0.000000000}, {251,0.000018957}, {252,0.000014218}, {253,0.000000000}, {254,0.000018957}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000014218}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000018957}, {265,0.000000000}, {266,0.000000000}, {267,0.000014218}, {268,0.000018957}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000018957}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000018957}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000018957}, {292,0.000000000}, {293,0.000000000}, {294,0.000014218}, {295,0.000014218}, {296,0.000000000}, {297,0.000000000}, {298,0.000018957}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000018957}, {304,0.000000000}, {305,0.000000000}, {306,0.000018957}, {307,0.000014218}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000014218}, {313,0.000000000}, {314,0.000000000}, {315,0.000018957}, {316,0.000018957}, {317,0.000000000}, {318,0.000000000}, {319,0.000037915}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000018957}, {325,0.000000000}, {326,0.000000000}, {327,0.000014218}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000014218}, {335,0.000000000}, {336,0.000018957}, {337,0.000018957}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000018957}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000014218}, {346,0.000018957}, {347,0.000000000}, {348,0.000000000}, {349,0.000018957}, {350,0.000000000}, {351,0.000000000}, {352,0.000033175}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000018957}, {360,0.000000000}, {361,0.000000000}, {362,0.000014218}, {363,0.000000000}, {364,0.000018957}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000014218}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000018957}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000014218}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000014218}, {389,0.000018957}, {390,0.000033175}, {391,0.000052133}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000014218}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000014218}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000018957}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000014218}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000018957}, {412,0.000014218}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000018957}, {417,0.000000000}, {418,0.000000000}, {419,0.000014218}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000014218}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000028436}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000018957}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000014218}, {447,0.000000000}, {448,0.000000000}, {449,0.000018957}, {450,0.000000000}, {451,0.000014218}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000018957}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000014218}, {465,0.000000000}, {466,0.000000000}, {467,0.000014218}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000018957}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000018957}, {492,0.000000000}, {493,0.000014218}, {494,0.000000000}, {495,0.000000000}, {496,0.000014218}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000018957}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000018957}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000018957}, {585,0.000018957}, {590,0.000028436}, {595,0.000000000}, {600,0.000018957}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000018957}, {715,0.000014218}, {720,0.000000000}, {725,0.000000000}, {730,0.000018957}, {735,0.000000000}, {740,0.000018957}, {745,0.000052133}, {750,0.000018957}, {755,0.000000000}, {760,0.000033175}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000014218}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000014218}, {805,0.000000000}, {810,0.000014218}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000033175}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000018957}, {865,0.000000000}, {870,0.000018957}, {875,0.000014218}, {880,0.000014218}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000018957}, {910,0.000000000}, {915,0.000018957}, {920,0.000000000}, {925,0.000014218}, {930,0.000014218}, {935,0.000000000}, {940,0.000000000}, {945,0.000018957}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000033175}, {975,0.000000000}, {980,0.000000000}, {985,0.000014218}, {990,0.000000000}, {995,0.000018957}, {1000,0.000033175}, {1010,0.000037915}, {1020,0.000014218}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000014218}, {1100,0.000000000}, {1110,0.000033175}, {1120,0.000000000}, {1130,0.000018957}, {1140,0.000014218}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000018957}, {1210,0.000000000}, {1220,0.000014218}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000014218}, {1260,0.000014218}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000014218}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000018957}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000018957}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000033175}, {1490,0.000037915}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000014218}, {1560,0.000018957}, {1570,0.000000000}, {1580,0.000014218}, {1590,0.000014218}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000018957}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000018957}, {1660,0.000018957}, {1670,0.000014218}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000033175}, {1730,0.000018957}, {1740,0.000000000}, {1750,0.000018957}, {1760,0.000047393}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000014218}, {1810,0.000018957}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000037915}, {1870,0.000000000}, {1880,0.000018957}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000018957}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000014218}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000014218}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000014218}, {2750,0.000033175}, {2800,0.000018957}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000014218}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000018957}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000018957}, {3900,0.000000000}, {3950,0.000018957}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000037915}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000018957}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000014218}, {4550,0.000018957}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000014218}, {4750,0.000018957}, {4800,0.000037915}, {4850,0.000014218}, {4900,0.000000000}, {4950,0.000014218}, {5000,0.000000000}, {5050,0.00000}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["beta; Parametricity"]["pre"]["system"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000000000}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000000000}, {53,0.000000000}, {54,0.000000000}, {55,0.000000000}, {56,0.000000000}, {57,0.000000000}, {58,0.000000000}, {59,0.000000000}, {60,0.000000000}, {61,0.000000000}, {62,0.000000000}, {63,0.000000000}, {64,0.000000000}, {65,0.000000000}, {66,0.000000000}, {67,0.000000000}, {68,0.000000000}, {69,0.000000000}, {70,0.000000000}, {71,0.000000000}, {72,0.000000000}, {73,0.000000000}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000000000}, {78,0.000000000}, {79,0.000000000}, {80,0.000000000}, {81,0.000000000}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000000000}, {87,0.000000000}, {88,0.000000000}, {89,0.000000000}, {90,0.000000000}, {91,0.000000000}, {92,0.000000000}, {93,0.000000000}, {94,0.000000000}, {95,0.000000000}, {96,0.000000000}, {97,0.000000000}, {98,0.000000000}, {99,0.000000000}, {100,0.000000000}, {101,0.000000000}, {102,0.000000000}, {103,0.000000000}, {104,0.000000000}, {105,0.000000000}, {106,0.000000000}, {107,0.000000000}, {108,0.000000000}, {109,0.000000000}, {110,0.000000000}, {111,0.000000000}, {112,0.000000000}, {113,0.000000000}, {114,0.000000000}, {115,0.000000000}, {116,0.000000000}, {117,0.000000000}, {118,0.000000000}, {119,0.000000000}, {120,0.000000000}, {121,0.000000000}, {122,0.000000000}, {123,0.000000000}, {124,0.000000000}, {125,0.000000000}, {126,0.000000000}, {127,0.000000000}, {128,0.000000000}, {129,0.000000000}, {130,0.000000000}, {131,0.000000000}, {132,0.000000000}, {133,0.000000000}, {134,0.000000000}, {135,0.000000000}, {136,0.000000000}, {137,0.000000000}, {138,0.000000000}, {139,0.000000000}, {140,0.000000000}, {141,0.000000000}, {142,0.000000000}, {143,0.000000000}, {144,0.000000000}, {145,0.000000000}, {146,0.000000000}, {147,0.000000000}, {148,0.000000000}, {149,0.000000000}, {150,0.000000000}, {151,0.000000000}, {152,0.000000000}, {153,0.000000000}, {154,0.000000000}, {155,0.000000000}, {156,0.000000000}, {157,0.000000000}, {158,0.000000000}, {159,0.000000000}, {160,0.000000000}, {161,0.000000000}, {162,0.000000000}, {163,0.000000000}, {164,0.000000000}, {165,0.000000000}, {166,0.000000000}, {167,0.000000000}, {168,0.000000000}, {169,0.000000000}, {170,0.000000000}, {171,0.000000000}, {172,0.000000000}, {173,0.000000000}, {174,0.000000000}, {175,0.000000000}, {176,0.000000000}, {177,0.000000000}, {178,0.000000000}, {179,0.000000000}, {180,0.000000000}, {181,0.000000000}, {182,0.000000000}, {183,0.000000000}, {184,0.000000000}, {185,0.000000000}, {186,0.000000000}, {187,0.000000000}, {188,0.000000000}, {189,0.000000000}, {190,0.000000000}, {191,0.000000000}, {192,0.000000000}, {193,0.000000000}, {194,0.000000000}, {195,0.000000000}, {196,0.000000000}, {197,0.000000000}, {198,0.000000000}, {199,0.000000000}, {200,0.000000000}, {201,0.000000000}, {202,0.000000000}, {203,0.000000000}, {204,0.000000000}, {205,0.000000000}, {206,0.000000000}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000000000}, {211,0.000000000}, {212,0.000000000}, {213,0.000000000}, {214,0.000000000}, {215,0.000000000}, {216,0.000000000}, {217,0.000000000}, {218,0.000000000}, {219,0.000000000}, {220,0.000000000}, {221,0.000000000}, {222,0.000000000}, {223,0.000000000}, {224,0.000000000}, {225,0.000000000}, {226,0.000000000}, {227,0.000000000}, {228,0.000000000}, {229,0.000000000}, {230,0.000000000}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000000000}, {235,0.000000000}, {236,0.000000000}, {237,0.000000000}, {238,0.000000000}, {239,0.000000000}, {240,0.000000000}, {241,0.000000000}, {242,0.000000000}, {243,0.000000000}, {244,0.000000000}, {245,0.000000000}, {246,0.000000000}, {247,0.000000000}, {248,0.000000000}, {249,0.000000000}, {250,0.000000000}, {251,0.000000000}, {252,0.000000000}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000000000}, {257,0.000000000}, {258,0.000000000}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000000000}, {267,0.000000000}, {268,0.000000000}, {269,0.000000000}, {270,0.000000000}, {271,0.000000000}, {272,0.000000000}, {273,0.000000000}, {274,0.000000000}, {275,0.000000000}, {276,0.000000000}, {277,0.000000000}, {278,0.000000000}, {279,0.000000000}, {280,0.000000000}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000000000}, {288,0.000000000}, {289,0.000000000}, {290,0.000000000}, {291,0.000000000}, {292,0.000000000}, {293,0.000000000}, {294,0.000000000}, {295,0.000000000}, {296,0.000000000}, {297,0.000000000}, {298,0.000000000}, {299,0.000000000}, {300,0.000000000}, {301,0.000000000}, {302,0.000000000}, {303,0.000000000}, {304,0.000000000}, {305,0.000000000}, {306,0.000000000}, {307,0.000000000}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000000000}, {312,0.000000000}, {313,0.000000000}, {314,0.000000000}, {315,0.000000000}, {316,0.000000000}, {317,0.000000000}, {318,0.000000000}, {319,0.000000000}, {320,0.000000000}, {321,0.000000000}, {322,0.000000000}, {323,0.000000000}, {324,0.000000000}, {325,0.000000000}, {326,0.000000000}, {327,0.000000000}, {328,0.000000000}, {329,0.000000000}, {330,0.000000000}, {331,0.000000000}, {332,0.000000000}, {333,0.000000000}, {334,0.000000000}, {335,0.000000000}, {336,0.000000000}, {337,0.000000000}, {338,0.000000000}, {339,0.000000000}, {340,0.000000000}, {341,0.000000000}, {342,0.000000000}, {343,0.000000000}, {344,0.000000000}, {345,0.000000000}, {346,0.000000000}, {347,0.000000000}, {348,0.000000000}, {349,0.000000000}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000000000}, {355,0.000000000}, {356,0.000000000}, {357,0.000000000}, {358,0.000000000}, {359,0.000000000}, {360,0.000000000}, {361,0.000000000}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000000000}, {366,0.000000000}, {367,0.000000000}, {368,0.000000000}, {369,0.000000000}, {370,0.000000000}, {371,0.000000000}, {372,0.000000000}, {373,0.000000000}, {374,0.000000000}, {375,0.000000000}, {376,0.000000000}, {377,0.000000000}, {378,0.000000000}, {379,0.000000000}, {380,0.000000000}, {381,0.000000000}, {382,0.000000000}, {383,0.000000000}, {384,0.000000000}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000000000}, {389,0.000000000}, {390,0.000000000}, {391,0.000000000}, {392,0.000000000}, {393,0.000000000}, {394,0.000000000}, {395,0.000000000}, {396,0.000000000}, {397,0.000000000}, {398,0.000000000}, {399,0.000000000}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000000000}, {405,0.000000000}, {406,0.000000000}, {407,0.000000000}, {408,0.000000000}, {409,0.000000000}, {410,0.000000000}, {411,0.000000000}, {412,0.000000000}, {413,0.000000000}, {414,0.000000000}, {415,0.000000000}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000000000}, {420,0.000000000}, {421,0.000000000}, {422,0.000000000}, {423,0.000000000}, {424,0.000000000}, {425,0.000000000}, {426,0.000000000}, {427,0.000000000}, {428,0.000000000}, {429,0.000000000}, {430,0.000000000}, {431,0.000000000}, {432,0.000000000}, {433,0.000000000}, {434,0.000000000}, {435,0.000000000}, {436,0.000000000}, {437,0.000000000}, {438,0.000000000}, {439,0.000000000}, {440,0.000000000}, {441,0.000000000}, {442,0.000000000}, {443,0.000000000}, {444,0.000000000}, {445,0.000000000}, {446,0.000000000}, {447,0.000000000}, {448,0.000000000}, {449,0.000000000}, {450,0.000000000}, {451,0.000000000}, {452,0.000000000}, {453,0.000000000}, {454,0.000000000}, {455,0.000000000}, {456,0.000000000}, {457,0.000000000}, {458,0.000000000}, {459,0.000000000}, {460,0.000000000}, {461,0.000000000}, {462,0.000000000}, {463,0.000000000}, {464,0.000000000}, {465,0.000000000}, {466,0.000000000}, {467,0.000000000}, {468,0.000000000}, {469,0.000000000}, {470,0.000000000}, {471,0.000000000}, {472,0.000000000}, {473,0.000000000}, {474,0.000000000}, {475,0.000000000}, {476,0.000000000}, {477,0.000000000}, {478,0.000000000}, {479,0.000000000}, {480,0.000000000}, {481,0.000000000}, {482,0.000000000}, {483,0.000000000}, {484,0.000000000}, {485,0.000000000}, {486,0.000000000}, {487,0.000000000}, {488,0.000000000}, {489,0.000000000}, {490,0.000000000}, {491,0.000000000}, {492,0.000000000}, {493,0.000000000}, {494,0.000000000}, {495,0.000000000}, {496,0.000000000}, {497,0.000000000}, {498,0.000000000}, {499,0.000000000}, {500,0.000000000}, {505,0.000000000}, {510,0.000000000}, {515,0.000000000}, {520,0.000000000}, {525,0.000000000}, {530,0.000000000}, {535,0.000000000}, {540,0.000000000}, {545,0.000000000}, {550,0.000000000}, {555,0.000000000}, {560,0.000000000}, {565,0.000000000}, {570,0.000000000}, {575,0.000000000}, {580,0.000000000}, {585,0.000000000}, {590,0.000000000}, {595,0.000000000}, {600,0.000000000}, {605,0.000000000}, {610,0.000000000}, {615,0.000000000}, {620,0.000000000}, {625,0.000000000}, {630,0.000000000}, {635,0.000000000}, {640,0.000000000}, {645,0.000000000}, {650,0.000000000}, {655,0.000000000}, {660,0.000000000}, {665,0.000000000}, {670,0.000000000}, {675,0.000000000}, {680,0.000000000}, {685,0.000000000}, {690,0.000000000}, {695,0.000000000}, {700,0.000000000}, {705,0.000000000}, {710,0.000000000}, {715,0.000000000}, {720,0.000000000}, {725,0.000000000}, {730,0.000000000}, {735,0.000000000}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000000000}, {760,0.000000000}, {765,0.000000000}, {770,0.000000000}, {775,0.000000000}, {780,0.000000000}, {785,0.000000000}, {790,0.000000000}, {795,0.000000000}, {800,0.000000000}, {805,0.000000000}, {810,0.000000000}, {815,0.000000000}, {820,0.000000000}, {825,0.000000000}, {830,0.000000000}, {835,0.000000000}, {840,0.000000000}, {845,0.000000000}, {850,0.000000000}, {855,0.000000000}, {860,0.000000000}, {865,0.000000000}, {870,0.000000000}, {875,0.000000000}, {880,0.000000000}, {885,0.000000000}, {890,0.000000000}, {895,0.000000000}, {900,0.000000000}, {905,0.000000000}, {910,0.000000000}, {915,0.000000000}, {920,0.000000000}, {925,0.000000000}, {930,0.000000000}, {935,0.000000000}, {940,0.000000000}, {945,0.000000000}, {950,0.000000000}, {955,0.000000000}, {960,0.000000000}, {965,0.000000000}, {970,0.000000000}, {975,0.000000000}, {980,0.000000000}, {985,0.000000000}, {990,0.000000000}, {995,0.000000000}, {1000,0.000000000}, {1010,0.000000000}, {1020,0.000000000}, {1030,0.000000000}, {1040,0.000000000}, {1050,0.000000000}, {1060,0.000000000}, {1070,0.000000000}, {1080,0.000000000}, {1090,0.000000000}, {1100,0.000000000}, {1110,0.000000000}, {1120,0.000000000}, {1130,0.000000000}, {1140,0.000000000}, {1150,0.000000000}, {1160,0.000000000}, {1170,0.000000000}, {1180,0.000000000}, {1190,0.000000000}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000000000}, {1230,0.000000000}, {1240,0.000000000}, {1250,0.000000000}, {1260,0.000000000}, {1270,0.000000000}, {1280,0.000000000}, {1290,0.000000000}, {1300,0.000000000}, {1310,0.000000000}, {1320,0.000000000}, {1330,0.000000000}, {1340,0.000000000}, {1350,0.000000000}, {1360,0.000000000}, {1370,0.000000000}, {1380,0.000000000}, {1390,0.000000000}, {1400,0.000000000}, {1410,0.000000000}, {1420,0.000000000}, {1430,0.000000000}, {1440,0.000000000}, {1450,0.000000000}, {1460,0.000000000}, {1470,0.000000000}, {1480,0.000000000}, {1490,0.000000000}, {1500,0.000000000}, {1510,0.000000000}, {1520,0.000000000}, {1530,0.000000000}, {1540,0.000000000}, {1550,0.000000000}, {1560,0.000000000}, {1570,0.000000000}, {1580,0.000000000}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000000000}, {1630,0.000000000}, {1640,0.000000000}, {1650,0.000000000}, {1660,0.000000000}, {1670,0.000000000}, {1680,0.000000000}, {1690,0.000000000}, {1700,0.000000000}, {1710,0.000000000}, {1720,0.000000000}, {1730,0.000000000}, {1740,0.000000000}, {1750,0.000000000}, {1760,0.000000000}, {1770,0.000000000}, {1780,0.000000000}, {1790,0.000000000}, {1800,0.000000000}, {1810,0.000000000}, {1820,0.000000000}, {1830,0.000000000}, {1840,0.000000000}, {1850,0.000000000}, {1860,0.000000000}, {1870,0.000000000}, {1880,0.000000000}, {1890,0.000000000}, {1900,0.000000000}, {1910,0.000000000}, {1920,0.000000000}, {1930,0.000000000}, {1940,0.000000000}, {1950,0.000000000}, {1960,0.000000000}, {1970,0.000000000}, {1980,0.000000000}, {1990,0.000000000}, {2000,0.000000000}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000000000}, {2200,0.000000000}, {2250,0.000000000}, {2300,0.000000000}, {2350,0.000000000}, {2400,0.000000000}, {2450,0.000000000}, {2500,0.000000000}, {2550,0.000000000}, {2600,0.000000000}, {2650,0.000000000}, {2700,0.000000000}, {2750,0.000000000}, {2800,0.000000000}, {2850,0.000000000}, {2900,0.000000000}, {2950,0.000000000}, {3000,0.000000000}, {3050,0.000000000}, {3100,0.000000000}, {3150,0.000000000}, {3200,0.000000000}, {3250,0.000000000}, {3300,0.000000000}, {3350,0.000000000}, {3400,0.000000000}, {3450,0.000000000}, {3500,0.000000000}, {3550,0.000000000}, {3600,0.000000000}, {3650,0.000000000}, {3700,0.000000000}, {3750,0.000000000}, {3800,0.000000000}, {3850,0.000000000}, {3900,0.000000000}, {3950,0.000000000}, {4000,0.000000000}, {4050,0.000000000}, {4100,0.000000000}, {4150,0.000000000}, {4200,0.000000000}, {4250,0.000000000}, {4300,0.000000000}, {4350,0.000000000}, {4400,0.000000000}, {4450,0.000000000}, {4500,0.000000000}, {4550,0.000000000}, {4600,0.000000000}, {4650,0.000000000}, {4700,0.000000000}, {4750,0.000000000}, {4800,0.000000000}, {4850,0.000000000}, {4900,0.000000000}, {4950,0.000000000}, {5000,0.000000000}, {5050,0.00000}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00000}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00000}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00000}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00000}, {6550,0.00000}, {6600,0.00000}, {6650,0.00000}, {6700,0.00000}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00000}, {6950,0.00000}, {7000,0.00000}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00000}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00000}, {7550,0.00000}, {7600,0.00000}, {7650,0.00000}, {7700,0.00000}, {7750,0.00000}, {7800,0.00000}, {7850,0.00000}, {7900,0.00000}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00000}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00000}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00000}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00000}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00000}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00000}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["beta; Parametricity"]["reif"]["real"] = {{1,0.000000000}, {2,0.000000000}, {3,0.000000000}, {4,0.000000000}, {5,0.000000000}, {6,0.000000000}, {7,0.000000000}, {8,0.000000000}, {9,0.000000000}, {10,0.000000000}, {11,0.000009479}, {12,0.000000000}, {13,0.000000000}, {14,0.000000000}, {15,0.000000000}, {16,0.000000000}, {17,0.000000000}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000000000}, {24,0.000000000}, {25,0.000000000}, {26,0.000000000}, {27,0.000000000}, {28,0.000000000}, {29,0.000000000}, {30,0.000000000}, {31,0.000000000}, {32,0.000000000}, {33,0.000000000}, {34,0.000000000}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000000000}, {46,0.000000000}, {47,0.000000000}, {48,0.000004739}, {49,0.000000000}, {50,0.000000000}, {51,0.000000000}, {52,0.000004739}, {53,0.000004739}, {54,0.000000000}, {55,0.000004739}, {56,0.000000000}, {57,0.000009479}, {58,0.000000000}, {59,0.000014218}, {60,0.000023697}, {61,0.000061611}, {62,0.000895735}, {63,0.000071090}, {64,0.000165877}, {65,0.000165877}, {66,0.000222749}, {67,0.000331754}, {68,0.000350711}, {69,0.000407583}, {70,0.000511848}, {71,0.000573460}, {72,0.000592417}, {73,0.000663507}, {74,0.000701422}, {75,0.000720379}, {76,0.000800948}, {77,0.000815166}, {78,0.001336493}, {79,0.000933649}, {80,0.000966825}, {81,0.000981043}, {82,0.001000000}, {83,0.001000000}, {84,0.001000000}, {85,0.001000000}, {86,0.001000000}, {87,0.001000000}, {88,0.001000000}, {89,0.001000000}, {90,0.001004739}, {91,0.001000000}, {92,0.001000000}, {93,0.001000000}, {94,0.001000000}, {95,0.001000000}, {96,0.001000000}, {97,0.001000000}, {98,0.001009479}, {99,0.001000000}, {100,0.001000000}, {101,0.001000000}, {102,0.001000000}, {103,0.001000000}, {104,0.001000000}, {105,0.001000000}, {106,0.001000000}, {107,0.001000000}, {108,0.001000000}, {109,0.001511848}, {110,0.001000000}, {111,0.001000000}, {112,0.001000000}, {113,0.001000000}, {114,0.001000000}, {115,0.001000000}, {116,0.001000000}, {117,0.001000000}, {118,0.001000000}, {119,0.001000000}, {120,0.001000000}, {121,0.001000000}, {122,0.001000000}, {123,0.001000000}, {124,0.001000000}, {125,0.001478673}, {126,0.001009479}, {127,0.001000000}, {128,0.001000000}, {129,0.001000000}, {130,0.001000000}, {131,0.001000000}, {132,0.001000000}, {133,0.001000000}, {134,0.001000000}, {135,0.001000000}, {136,0.001000000}, {137,0.001000000}, {138,0.001000000}, {139,0.001000000}, {140,0.001000000}, {141,0.001000000}, {142,0.001000000}, {143,0.001000000}, {144,0.001000000}, {145,0.001000000}, {146,0.001000000}, {147,0.001000000}, {148,0.001000000}, {149,0.001000000}, {150,0.001009479}, {151,0.001000000}, {152,0.001000000}, {153,0.001000000}, {154,0.001000000}, {155,0.001000000}, {156,0.001000000}, {157,0.001000000}, {158,0.001000000}, {159,0.001000000}, {160,0.001000000}, {161,0.001000000}, {162,0.001000000}, {163,0.001000000}, {164,0.001000000}, {165,0.001000000}, {166,0.001000000}, {167,0.001000000}, {168,0.001000000}, {169,0.001000000}, {170,0.001000000}, {171,0.001478673}, {172,0.001000000}, {173,0.001000000}, {174,0.001000000}, {175,0.001000000}, {176,0.001004739}, {177,0.001000000}, {178,0.001000000}, {179,0.001748815}, {180,0.001004739}, {181,0.001009479}, {182,0.001004739}, {183,0.001004739}, {184,0.001009479}, {185,0.001004739}, {186,0.001023697}, {187,0.001037915}, {188,0.001037915}, {189,0.001028436}, {190,0.001033175}, {191,0.001559242}, {192,0.001094787}, {193,0.001099526}, {194,0.001118483}, {195,0.001184834}, {196,0.001208531}, {197,0.001227488}, {198,0.001251185}, {199,0.001312796}, {200,0.001293839}, {201,0.001345972}, {202,0.001388626}, {203,0.001402844}, {204,0.001450237}, {205,0.001483412}, {206,0.001511848}, {207,0.001549763}, {208,0.001578199}, {209,0.001601896}, {210,0.001601896}, {211,0.001639810}, {212,0.001649289}, {213,0.001715640}, {214,0.001739336}, {215,0.001744076}, {216,0.002170616}, {217,0.001834123}, {218,0.001857820}, {219,0.001914692}, {220,0.001914692}, {221,0.001966825}, {222,0.001962085}, {223,0.001981043}, {224,0.001971564}, {225,0.002000000}, {226,0.001985782}, {227,0.001995261}, {228,0.001995261}, {229,0.002000000}, {230,0.002000000}, {231,0.002000000}, {232,0.002000000}, {233,0.002000000}, {234,0.002000000}, {235,0.002004739}, {236,0.002000000}, {237,0.002000000}, {238,0.002000000}, {239,0.002000000}, {240,0.002000000}, {241,0.002000000}, {242,0.002000000}, {243,0.002004739}, {244,0.002000000}, {245,0.002000000}, {246,0.002000000}, {247,0.002000000}, {248,0.002004739}, {249,0.002000000}, {250,0.002000000}, {251,0.002000000}, {252,0.002000000}, {253,0.002000000}, {254,0.002000000}, {255,0.002000000}, {256,0.002000000}, {257,0.002000000}, {258,0.002469194}, {259,0.002000000}, {260,0.002000000}, {261,0.002000000}, {262,0.002000000}, {263,0.002000000}, {264,0.002000000}, {265,0.002000000}, {266,0.002000000}, {267,0.002004739}, {268,0.002000000}, {269,0.002004739}, {270,0.002000000}, {271,0.002000000}, {272,0.002014218}, {273,0.002000000}, {274,0.002000000}, {275,0.002000000}, {276,0.002000000}, {277,0.002000000}, {278,0.002000000}, {279,0.002000000}, {280,0.002000000}, {281,0.002000000}, {282,0.002000000}, {283,0.002000000}, {284,0.002000000}, {285,0.002000000}, {286,0.002000000}, {287,0.002000000}, {288,0.002000000}, {289,0.002000000}, {290,0.002004739}, {291,0.002000000}, {292,0.002000000}, {293,0.002000000}, {294,0.002000000}, {295,0.002000000}, {296,0.002000000}, {297,0.002000000}, {298,0.002000000}, {299,0.002000000}, {300,0.002478673}, {301,0.002000000}, {302,0.002000000}, {303,0.002000000}, {304,0.002000000}, {305,0.002004739}, {306,0.002000000}, {307,0.002000000}, {308,0.002004739}, {309,0.002009479}, {310,0.002000000}, {311,0.002009479}, {312,0.002000000}, {313,0.002483412}, {314,0.002000000}, {315,0.002004739}, {316,0.002009479}, {317,0.002014218}, {318,0.002028436}, {319,0.002033175}, {320,0.002052133}, {321,0.002075829}, {322,0.002071090}, {323,0.002071090}, {324,0.002099526}, {325,0.002109005}, {326,0.002113744}, {327,0.002127962}, {328,0.002180095}, {329,0.002156398}, {330,0.002227488}, {331,0.002246445}, {332,0.002251185}, {333,0.002293839}, {334,0.002345972}, {335,0.002350711}, {336,0.002417062}, {337,0.002421801}, {338,0.002464455}, {339,0.002492891}, {340,0.002478673}, {341,0.002521327}, {342,0.002535545}, {343,0.002606635}, {344,0.002606635}, {345,0.002592417}, {346,0.002658768}, {347,0.002649289}, {348,0.002677725}, {349,0.003407583}, {350,0.002734597}, {351,0.002815166}, {352,0.002791469}, {353,0.003284360}, {354,0.002848341}, {355,0.002895735}, {356,0.002857820}, {357,0.002900474}, {358,0.002928910}, {359,0.002971564}, {360,0.002947867}, {361,0.002962085}, {362,0.002971564}, {363,0.002981043}, {364,0.002981043}, {365,0.002976303}, {366,0.002976303}, {367,0.002995261}, {368,0.002981043}, {369,0.002985782}, {370,0.003004739}, {371,0.003000000}, {372,0.003000000}, {373,0.003000000}, {374,0.003018957}, {375,0.003000000}, {376,0.002995261}, {377,0.003004739}, {378,0.003000000}, {379,0.003000000}, {380,0.003000000}, {381,0.003000000}, {382,0.003009479}, {383,0.003000000}, {384,0.003000000}, {385,0.003000000}, {386,0.003511848}, {387,0.003000000}, {388,0.003000000}, {389,0.003000000}, {390,0.003000000}, {391,0.003000000}, {392,0.003000000}, {393,0.003478673}, {394,0.003000000}, {395,0.003000000}, {396,0.003000000}, {397,0.003000000}, {398,0.003000000}, {399,0.003009479}, {400,0.003000000}, {401,0.003000000}, {402,0.003000000}, {403,0.003018957}, {404,0.003000000}, {405,0.003000000}, {406,0.003000000}, {407,0.003000000}, {408,0.003000000}, {409,0.003000000}, {410,0.003000000}, {411,0.003000000}, {412,0.003000000}, {413,0.003014218}, {414,0.003000000}, {415,0.003000000}, {416,0.003000000}, {417,0.003000000}, {418,0.003004739}, {419,0.003000000}, {420,0.003004739}, {421,0.003000000}, {422,0.003000000}, {423,0.003009479}, {424,0.003000000}, {425,0.003004739}, {426,0.003000000}, {427,0.003000000}, {428,0.003009479}, {429,0.003000000}, {430,0.003000000}, {431,0.003004739}, {432,0.003009479}, {433,0.003502370}, {434,0.003000000}, {435,0.003009479}, {436,0.003800948}, {437,0.003000000}, {438,0.003000000}, {439,0.003000000}, {440,0.003004739}, {441,0.003009479}, {442,0.003018957}, {443,0.003023697}, {444,0.003014218}, {445,0.003004739}, {446,0.003014218}, {447,0.003004739}, {448,0.003018957}, {449,0.003028436}, {450,0.003028436}, {451,0.003028436}, {452,0.003521327}, {453,0.003066351}, {454,0.003033175}, {455,0.003023697}, {456,0.003047393}, {457,0.003066351}, {458,0.003042654}, {459,0.003066351}, {460,0.003094787}, {461,0.003616114}, {462,0.003099526}, {463,0.003146919}, {464,0.003810427}, {465,0.003175355}, {466,0.003218009}, {467,0.003218009}, {468,0.003270142}, {469,0.003255924}, {470,0.004033175}, {471,0.003308057}, {472,0.003312796}, {473,0.003388626}, {474,0.003388626}, {475,0.003417062}, {476,0.003440758}, {477,0.003492891}, {478,0.003497630}, {479,0.004056872}, {480,0.003563981}, {481,0.003582938}, {482,0.003616114}, {483,0.003635071}, {484,0.003658768}, {485,0.003639810}, {486,0.003696682}, {487,0.003744076}, {488,0.003739336}, {489,0.003744076}, {490,0.004393365}, {491,0.003805687}, {492,0.003900474}, {493,0.003895735}, {494,0.003905213}, {495,0.003914692}, {496,0.004488152}, {497,0.003947867}, {498,0.003962085}, {499,0.003947867}, {500,0.003952607}, {505,0.003962085}, {510,0.003985782}, {515,0.004000000}, {520,0.004014218}, {525,0.004000000}, {530,0.004000000}, {535,0.004511848}, {540,0.004000000}, {545,0.004000000}, {550,0.004014218}, {555,0.004004739}, {560,0.004919431}, {565,0.004009479}, {570,0.004004739}, {575,0.004023697}, {580,0.004047393}, {585,0.004037915}, {590,0.004099526}, {595,0.004194313}, {600,0.004213270}, {605,0.004303318}, {610,0.004421801}, {615,0.004492891}, {620,0.004568720}, {625,0.004710900}, {630,0.004862559}, {635,0.004909953}, {640,0.004933649}, {645,0.004952607}, {650,0.004985782}, {655,0.004995261}, {660,0.005004739}, {665,0.005819905}, {670,0.005000000}, {675,0.005895735}, {680,0.005004739}, {685,0.005000000}, {690,0.005009479}, {695,0.005052133}, {700,0.005023697}, {705,0.005033175}, {710,0.005033175}, {715,0.005099526}, {720,0.005146919}, {725,0.005165877}, {730,0.005236967}, {735,0.005317536}, {740,0.005355450}, {745,0.005412322}, {750,0.005469194}, {755,0.005582938}, {760,0.005658768}, {765,0.006696682}, {770,0.005890995}, {775,0.005905213}, {780,0.005909953}, {785,0.006876777}, {790,0.005976303}, {795,0.005995261}, {800,0.005985782}, {805,0.006009479}, {810,0.006056872}, {815,0.006042654}, {820,0.007393365}, {825,0.006056872}, {830,0.006066351}, {835,0.006056872}, {840,0.006890995}, {845,0.006161137}, {850,0.006184834}, {855,0.006194313}, {860,0.006241706}, {865,0.007161137}, {870,0.006345972}, {875,0.006402844}, {880,0.006445498}, {885,0.006516588}, {890,0.007417062}, {895,0.006644550}, {900,0.006720379}, {905,0.006848341}, {910,0.006914692}, {915,0.007488152}, {920,0.006914692}, {925,0.006909953}, {930,0.006990521}, {935,0.006990521}, {940,0.007014218}, {945,0.008004739}, {950,0.007052133}, {955,0.007104265}, {960,0.007132701}, {965,0.007161137}, {970,0.007151659}, {975,0.007189573}, {980,0.007260664}, {985,0.008203791}, {990,0.009000000}, {995,0.007360190}, {1000,0.007388626}, {1010,0.007492891}, {1020,0.007559242}, {1030,0.007706161}, {1040,0.007838863}, {1050,0.007971564}, {1060,0.008004739}, {1070,0.008767773}, {1080,0.008123223}, {1090,0.008227488}, {1100,0.008270142}, {1110,0.009341232}, {1120,0.008445498}, {1130,0.008464455}, {1140,0.008545024}, {1150,0.009345972}, {1160,0.008682464}, {1170,0.008876777}, {1180,0.008943128}, {1190,0.009056872}, {1200,0.009151659}, {1210,0.009274882}, {1220,0.009317536}, {1230,0.009417062}, {1240,0.009473934}, {1250,0.010445498}, {1260,0.010890995}, {1270,0.009677725}, {1280,0.009800948}, {1290,0.009834123}, {1300,0.009914692}, {1310,0.010023697}, {1320,0.011009479}, {1330,0.011274882}, {1340,0.010331754}, {1350,0.010483412}, {1360,0.012004739}, {1370,0.010649289}, {1380,0.010720379}, {1390,0.010734597}, {1400,0.010829384}, {1410,0.010909953}, {1420,0.011786730}, {1430,0.011109005}, {1440,0.011199052}, {1450,0.012407583}, {1460,0.011464455}, {1470,0.011530806}, {1480,0.012587678}, {1490,0.012890995}, {1500,0.011715640}, {1510,0.013118483}, {1520,0.012654028}, {1530,0.011995261}, {1540,0.013293839}, {1550,0.012123223}, {1560,0.012298578}, {1570,0.014815166}, {1580,0.012426540}, {1590,0.012601896}, {1600,0.012687204}, {1610,0.012753555}, {1620,0.012843602}, {1630,0.012895735}, {1640,0.012990521}, {1650,0.013132701}, {1660,0.014701422}, {1670,0.013255924}, {1680,0.014545024}, {1690,0.013421801}, {1700,0.013568720}, {1710,0.013597156}, {1720,0.013720379}, {1730,0.013881517}, {1740,0.015184834}, {1750,0.013952607}, {1760,0.015473934}, {1770,0.014028436}, {1780,0.014189573}, {1790,0.015810427}, {1800,0.014355450}, {1810,0.016407583}, {1820,0.014559242}, {1830,0.014767773}, {1840,0.016127962}, {1850,0.014834123}, {1860,0.016838863}, {1870,0.015037915}, {1880,0.015132701}, {1890,0.016279621}, {1900,0.015236967}, {1910,0.015322275}, {1920,0.015507109}, {1930,0.017601896}, {1940,0.015630332}, {1950,0.015786730}, {1960,0.018265403}, {1970,0.015876777}, {1980,0.015810427}, {1990,0.016118483}, {2000,0.017829384}, {2050,0.016582938}, {2100,0.017118483}, {2150,0.018663507}, {2200,0.018080569}, {2250,0.019995261}, {2300,0.018909953}, {2350,0.020753555}, {2400,0.019843602}, {2450,0.019848341}, {2500,0.022829384}, {2550,0.021161137}, {2600,0.022905213}, {2650,0.022156398}, {2700,0.024502370}, {2750,0.023175355}, {2800,0.023436019}, {2850,0.025739336}, {2900,0.024488152}, {2950,0.026530806}, {3000,0.027497630}, {3050,0.025943128}, {3100,0.028146919}, {3150,0.030483412}, {3200,0.027203791}, {3250,0.029739336}, {3300,0.029644550}, {3350,0.028725118}, {3400,0.029090047}, {3450,0.033251185}, {3500,0.034289100}, {3550,0.030568720}, {3600,0.030919431}, {3650,0.034549763}, {3700,0.036331754}, {3750,0.034791469}, {3800,0.032933649}, {3850,0.033236967}, {3900,0.032417062}, {3950,0.035364929}, {4000,0.041151659}, {4050,0.037194313}, {4100,0.038947867}, {4150,0.041644550}, {4200,0.036725118}, {4250,0.036957346}, {4300,0.037559242}, {4350,0.037914692}, {4400,0.041383886}, {4450,0.040696682}, {4500,0.041744076}, {4550,0.042516588}, {4600,0.042862559}, {4650,0.043488152}, {4700,0.044104265}, {4750,0.044028436}, {4800,0.043928910}, {4850,0.043488152}, {4900,0.043123223}, {4950,0.043677725}, {5000,0.044218009}, {5050,0.06914}, {5100,0.04600}, {5150,0.04529}, {5200,0.04557}, {5250,0.04457}, {5300,0.04943}, {5350,0.05071}, {5400,0.05214}, {5450,0.05000}, {5500,0.04871}, {5550,0.04700}, {5600,0.05486}, {5650,0.05643}, {5700,0.05243}, {5750,0.05000}, {5800,0.05314}, {5850,0.05729}, {5900,0.05457}, {5950,0.04943}, {6000,0.05686}, {6050,0.05829}, {6100,0.05571}, {6150,0.06271}, {6200,0.05971}, {6250,0.05500}, {6300,0.05943}, {6350,0.06143}, {6400,0.05557}, {6450,0.06414}, {6500,0.05943}, {6550,0.06414}, {6600,0.06700}, {6650,0.06214}, {6700,0.06857}, {6750,0.05929}, {6800,0.06671}, {6850,0.06200}, {6900,0.06957}, {6950,0.06171}, {7000,0.07000}, {7050,0.06471}, {7100,0.06900}, {7150,0.06486}, {7200,0.06971}, {7250,0.06386}, {7300,0.07000}, {7350,0.07029}, {7400,0.06714}, {7450,0.07243}, {7500,0.07486}, {7550,0.07329}, {7600,0.07286}, {7650,0.06886}, {7700,0.07557}, {7750,0.07271}, {7800,0.06971}, {7850,0.07614}, {7900,0.07557}, {7950,0.08071}, {8000,0.07886}, {8050,0.07786}, {8100,0.07429}, {8150,0.07257}, {8200,0.07943}, {8250,0.07986}, {8300,0.07629}, {8350,0.08271}, {8400,0.07800}, {8450,0.08229}, {8500,0.08214}, {8550,0.08486}, {8600,0.08043}, {8650,0.08200}, {8700,0.08286}, {8750,0.08400}, {8800,0.08543}, {8850,0.08400}, {8900,0.08429}, {8950,0.08800}, {9000,0.08729}, {9050,0.08986}, {9100,0.09243}, {9150,0.08543}, {9200,0.08557}, {9250,0.08543}, {9300,0.08657}, {9350,0.08614}, {9400,0.08829}, {9450,0.09557}, {9500,0.09543}, {9550,0.09100}, {9600,0.09186}, {9650,0.09286}, {9700,0.09143}, {9750,0.09400}, {9800,0.09571}, {9850,0.09771}, {9900,0.09743}, {9950,0.09771}, {10000,0.09843}, {10100,0.09457}, {10200,0.09700}, {10300,0.09671}, {10400,0.10429}, {10500,0.10000}, {10600,0.09943}, {10700,0.51100}, {10800,0.11329}, {10900,0.09957}, {11000,0.11057}, {11100,0.10471}, {11200,0.10557}, {11300,0.10643}, {11400,0.10571}, {11500,0.11157}, {11600,0.10757}, {11700,0.10971}, {11800,0.10886}, {11900,0.11629}, {12000,0.11114}, {12100,0.12014}, {12200,0.12629}, {12300,0.11557}, {12400,0.12143}, {12500,0.12729}, {12600,0.11700}, {12700,0.12300}, {12800,0.12871}, {12900,0.12186}, {13000,0.12143}, {13100,0.12629}, {13200,0.13071}, {13300,0.13129}, {13400,0.13643}, {13500,0.13657}, {13600,0.12414}, {13700,0.12514}, {13800,0.12357}, {13900,0.12871}, {14000,0.12914}, {14100,0.13100}, {14200,0.12586}, {14300,0.13314}, {14400,0.14014}, {14500,0.14186}, {14600,0.14000}, {14700,0.13457}, {14800,0.13786}, {14900,0.13800}, {15000,0.14629}, {15100,0.14600}, {15200,0.13943}, {15300,0.13714}, {15400,0.16043}, {15500,0.15357}, {15600,0.14643}, {15700,0.15786}, {15800,0.15143}, {15900,0.14657}, {16000,0.16086}, {16100,0.14886}, {16200,0.16143}, {16300,0.14900}, {16400,0.16557}, {16500,0.15114}, {16600,0.16500}, {16700,0.16400}, {16800,0.15857}, {16900,0.17057}, {17000,0.15371}, {17100,0.16743}, {17200,0.17771}, {17300,0.15757}, {17400,0.16143}, {17500,0.17129}, {17600,0.17114}, {17700,0.17314}, {17800,0.15729}, {17900,0.17300}, {18000,0.17371}, {18100,0.18886}, {18200,0.18486}, {18300,0.17300}, {18400,0.17500}, {18500,0.17600}, {18600,0.17786}, {18700,0.17786}, {18800,0.17414}, {18900,0.17543}, {19000,0.17957}, {19100,0.19243}, {19200,0.19371}, {19300,0.19186}, {19400,0.18429}, {19500,0.17057}, {19600,0.18229}, {19700,0.19829}, {19800,0.19457}, {19900,0.18257}, {20000,0.19200}};
data["big_flat"]["beta; Parametricity"]["reif"]["user"] = {{1,0.000336493}, {2,0.000426540}, {3,0.000440758}, {4,0.000383886}, {5,0.000345972}, {6,0.000402844}, {7,0.000492891}, {8,0.000436019}, {9,0.000450237}, {10,0.000431280}, {11,0.000417062}, {12,0.000440758}, {13,0.000402844}, {14,0.000426540}, {15,0.000545024}, {16,0.000710900}, {17,0.000388626}, {18,0.000454976}, {19,0.000398104}, {20,0.000473934}, {21,0.000312796}, {22,0.000554502}, {23,0.000445498}, {24,0.000483412}, {25,0.000483412}, {26,0.000530806}, {27,0.000606635}, {28,0.000616114}, {29,0.000663507}, {30,0.000625592}, {31,0.000630332}, {32,0.000559242}, {33,0.000545024}, {34,0.000559242}, {35,0.000563981}, {36,0.000530806}, {37,0.000663507}, {38,0.000601896}, {39,0.000597156}, {40,0.000791469}, {41,0.000630332}, {42,0.000763033}, {43,0.000729858}, {44,0.000682464}, {45,0.000919431}, {46,0.000545024}, {47,0.000663507}, {48,0.000729858}, {49,0.000815166}, {50,0.000909953}, {51,0.000521327}, {52,0.000834123}, {53,0.000772512}, {54,0.000677725}, {55,0.000890995}, {56,0.000672986}, {57,0.000687204}, {58,0.000853081}, {59,0.000872038}, {60,0.000729858}, {61,0.000843602}, {62,0.001331754}, {63,0.000668246}, {64,0.001085308}, {65,0.000890995}, {66,0.000772512}, {67,0.001000000}, {68,0.000881517}, {69,0.000838863}, {70,0.000933649}, {71,0.000895735}, {72,0.000909953}, {73,0.001042654}, {74,0.000781991}, {75,0.000995261}, {76,0.000834123}, {77,0.001042654}, {78,0.001251185}, {79,0.000838863}, {80,0.001222749}, {81,0.000957346}, {82,0.000796209}, {83,0.000909953}, {84,0.001094787}, {85,0.001075829}, {86,0.000905213}, {87,0.000654028}, {88,0.001161137}, {89,0.001018957}, {90,0.001056872}, {91,0.000848341}, {92,0.001061611}, {93,0.000886256}, {94,0.001018957}, {95,0.001018957}, {96,0.001085308}, {97,0.001023697}, {98,0.001004739}, {99,0.000985782}, {100,0.000909953}, {101,0.000962085}, {102,0.001151659}, {103,0.001184834}, {104,0.001175355}, {105,0.001099526}, {106,0.001009479}, {107,0.000962085}, {108,0.001180095}, {109,0.001611374}, {110,0.001199052}, {111,0.001199052}, {112,0.001161137}, {113,0.001004739}, {114,0.001322275}, {115,0.001227488}, {116,0.001218009}, {117,0.001284360}, {118,0.001236967}, {119,0.001199052}, {120,0.000895735}, {121,0.000933649}, {122,0.001104265}, {123,0.001270142}, {124,0.001322275}, {125,0.001715640}, {126,0.001303318}, {127,0.001355450}, {128,0.001241706}, {129,0.001308057}, {130,0.001293839}, {131,0.001265403}, {132,0.001265403}, {133,0.001218009}, {134,0.001199052}, {135,0.001170616}, {136,0.001303318}, {137,0.001331754}, {138,0.001431280}, {139,0.001393365}, {140,0.001545024}, {141,0.001521327}, {142,0.001568720}, {143,0.001516588}, {144,0.001402844}, {145,0.001312796}, {146,0.001369668}, {147,0.001312796}, {148,0.001274882}, {149,0.001336493}, {150,0.001289100}, {151,0.001175355}, {152,0.001037915}, {153,0.001241706}, {154,0.001222749}, {155,0.001265403}, {156,0.001559242}, {157,0.001663507}, {158,0.001668246}, {159,0.001454976}, {160,0.001473934}, {161,0.001436019}, {162,0.001578199}, {163,0.001502370}, {164,0.001364929}, {165,0.001559242}, {166,0.001540284}, {167,0.001578199}, {168,0.001649289}, {169,0.001417062}, {170,0.001469194}, {171,0.001933649}, {172,0.001772512}, {173,0.001725118}, {174,0.001715640}, {175,0.001450237}, {176,0.001635071}, {177,0.001578199}, {178,0.001445498}, {179,0.002018957}, {180,0.001691943}, {181,0.001644550}, {182,0.001549763}, {183,0.001758294}, {184,0.001540284}, {185,0.001440758}, {186,0.001549763}, {187,0.001644550}, {188,0.001748815}, {189,0.001691943}, {190,0.001597156}, {191,0.001962085}, {192,0.001763033}, {193,0.001616114}, {194,0.001649289}, {195,0.001625592}, {196,0.001672986}, {197,0.001800948}, {198,0.001691943}, {199,0.001824645}, {200,0.001654028}, {201,0.001668246}, {202,0.001725118}, {203,0.001829384}, {204,0.001710900}, {205,0.001568720}, {206,0.001800948}, {207,0.001914692}, {208,0.001710900}, {209,0.001772512}, {210,0.001952607}, {211,0.001777251}, {212,0.001630332}, {213,0.001753555}, {214,0.002213270}, {215,0.001592417}, {216,0.002345972}, {217,0.001886256}, {218,0.001620853}, {219,0.001905213}, {220,0.001819905}, {221,0.001734597}, {222,0.001909953}, {223,0.001976303}, {224,0.001796209}, {225,0.001800948}, {226,0.002066351}, {227,0.001943128}, {228,0.002014218}, {229,0.002113744}, {230,0.001753555}, {231,0.002094787}, {232,0.001729858}, {233,0.002071090}, {234,0.001791469}, {235,0.001928910}, {236,0.002009479}, {237,0.001881517}, {238,0.002194313}, {239,0.001971564}, {240,0.001947867}, {241,0.002227488}, {242,0.001924171}, {243,0.002227488}, {244,0.001881517}, {245,0.002222749}, {246,0.002028436}, {247,0.002161137}, {248,0.002018957}, {249,0.002118483}, {250,0.001938389}, {251,0.002018957}, {252,0.002056872}, {253,0.001957346}, {254,0.002284360}, {255,0.002037915}, {256,0.002336493}, {257,0.002047393}, {258,0.002587678}, {259,0.002232227}, {260,0.002094787}, {261,0.002170616}, {262,0.002146919}, {263,0.002180095}, {264,0.002270142}, {265,0.002127962}, {266,0.002251185}, {267,0.002113744}, {268,0.002142180}, {269,0.002090047}, {270,0.002137441}, {271,0.002360190}, {272,0.002161137}, {273,0.002383886}, {274,0.002151659}, {275,0.002364929}, {276,0.002213270}, {277,0.002360190}, {278,0.002018957}, {279,0.002345972}, {280,0.002099526}, {281,0.002241706}, {282,0.002507109}, {283,0.002241706}, {284,0.002232227}, {285,0.002464455}, {286,0.002308057}, {287,0.002246445}, {288,0.002521327}, {289,0.002260664}, {290,0.002308057}, {291,0.002218009}, {292,0.002345972}, {293,0.002388626}, {294,0.002360190}, {295,0.002336493}, {296,0.002265403}, {297,0.002530806}, {298,0.002303318}, {299,0.002464455}, {300,0.002748815}, {301,0.002312796}, {302,0.002402844}, {303,0.002540284}, {304,0.002360190}, {305,0.002251185}, {306,0.002526066}, {307,0.002559242}, {308,0.002454976}, {309,0.002218009}, {310,0.002535545}, {311,0.002611374}, {312,0.002331754}, {313,0.002734597}, {314,0.002545024}, {315,0.002630332}, {316,0.002601896}, {317,0.002360190}, {318,0.002483412}, {319,0.002701422}, {320,0.002431280}, {321,0.002345972}, {322,0.002587678}, {323,0.002530806}, {324,0.002715640}, {325,0.002478673}, {326,0.002402844}, {327,0.002383886}, {328,0.002682464}, {329,0.002687204}, {330,0.002753555}, {331,0.002658768}, {332,0.002715640}, {333,0.002549763}, {334,0.002507109}, {335,0.002639810}, {336,0.002473934}, {337,0.002635071}, {338,0.002701422}, {339,0.002829384}, {340,0.002800948}, {341,0.002753555}, {342,0.002535545}, {343,0.002668246}, {344,0.002796209}, {345,0.002876777}, {346,0.002753555}, {347,0.002625592}, {348,0.002592417}, {349,0.003312796}, {350,0.002635071}, {351,0.002701422}, {352,0.002696682}, {353,0.003464455}, {354,0.002753555}, {355,0.002630332}, {356,0.002725118}, {357,0.002862559}, {358,0.002805687}, {359,0.002824645}, {360,0.002744076}, {361,0.002786730}, {362,0.002725118}, {363,0.002933649}, {364,0.003018957}, {365,0.003042654}, {366,0.002971564}, {367,0.002909953}, {368,0.002900474}, {369,0.003094787}, {370,0.003080569}, {371,0.002971564}, {372,0.003004739}, {373,0.003014218}, {374,0.002995261}, {375,0.002881517}, {376,0.003127962}, {377,0.003113744}, {378,0.003056872}, {379,0.002985782}, {380,0.003161137}, {381,0.003071090}, {382,0.003075829}, {383,0.002819905}, {384,0.002791469}, {385,0.002843602}, {386,0.003559242}, {387,0.003094787}, {388,0.003227488}, {389,0.003085308}, {390,0.003056872}, {391,0.002905213}, {392,0.002900474}, {393,0.003436019}, {394,0.002995261}, {395,0.002962085}, {396,0.002957346}, {397,0.003004739}, {398,0.003042654}, {399,0.003170616}, {400,0.003127962}, {401,0.003094787}, {402,0.003052133}, {403,0.003080569}, {404,0.003099526}, {405,0.003170616}, {406,0.003000000}, {407,0.003132701}, {408,0.002895735}, {409,0.003260664}, {410,0.003232227}, {411,0.003161137}, {412,0.003156398}, {413,0.003265403}, {414,0.003023697}, {415,0.003175355}, {416,0.003099526}, {417,0.003199052}, {418,0.003180095}, {419,0.003208531}, {420,0.003246445}, {421,0.003161137}, {422,0.003255924}, {423,0.003123223}, {424,0.003194313}, {425,0.003350711}, {426,0.003161137}, {427,0.003222749}, {428,0.003175355}, {429,0.003241706}, {430,0.003407583}, {431,0.003270142}, {432,0.003341232}, {433,0.003791469}, {434,0.003308057}, {435,0.003289100}, {436,0.003938389}, {437,0.003303318}, {438,0.003331754}, {439,0.003265403}, {440,0.003383886}, {441,0.003327014}, {442,0.003308057}, {443,0.003426540}, {444,0.003355450}, {445,0.003407583}, {446,0.003445498}, {447,0.003303318}, {448,0.003379147}, {449,0.003218009}, {450,0.003421801}, {451,0.003336493}, {452,0.003810427}, {453,0.003322275}, {454,0.003483412}, {455,0.003388626}, {456,0.003388626}, {457,0.003355450}, {458,0.003454976}, {459,0.003417062}, {460,0.003459716}, {461,0.004033175}, {462,0.003502370}, {463,0.003483412}, {464,0.003900474}, {465,0.003507109}, {466,0.003492891}, {467,0.003483412}, {468,0.003450237}, {469,0.003545024}, {470,0.004056872}, {471,0.003578199}, {472,0.003601896}, {473,0.003530806}, {474,0.003511848}, {475,0.003535545}, {476,0.003658768}, {477,0.003587678}, {478,0.003630332}, {479,0.004028436}, {480,0.003545024}, {481,0.003606635}, {482,0.003592417}, {483,0.003587678}, {484,0.003587678}, {485,0.003672986}, {486,0.003649289}, {487,0.003691943}, {488,0.003672986}, {489,0.003706161}, {490,0.004189573}, {491,0.003639810}, {492,0.003616114}, {493,0.003587678}, {494,0.003587678}, {495,0.003786730}, {496,0.004450237}, {497,0.003710900}, {498,0.003682464}, {499,0.003867299}, {500,0.003767773}, {505,0.003890995}, {510,0.003848341}, {515,0.003767773}, {520,0.003853081}, {525,0.003862559}, {530,0.003848341}, {535,0.004450237}, {540,0.003971564}, {545,0.004113744}, {550,0.004094787}, {555,0.004142180}, {560,0.004853081}, {565,0.003985782}, {570,0.004260664}, {575,0.004151659}, {580,0.004260664}, {585,0.004407583}, {590,0.004639810}, {595,0.004497630}, {600,0.004364929}, {605,0.004398104}, {610,0.004454976}, {615,0.004630332}, {620,0.004630332}, {625,0.004540284}, {630,0.004701422}, {635,0.004739336}, {640,0.004872038}, {645,0.004995261}, {650,0.004739336}, {655,0.004796209}, {660,0.004848341}, {665,0.005758294}, {670,0.004791469}, {675,0.005649289}, {680,0.005184834}, {685,0.005265403}, {690,0.004895735}, {695,0.005047393}, {700,0.005104265}, {705,0.005085308}, {710,0.005232227}, {715,0.005075829}, {720,0.005388626}, {725,0.005308057}, {730,0.005308057}, {735,0.005549763}, {740,0.005322275}, {745,0.005426540}, {750,0.005663507}, {755,0.005535545}, {760,0.005473934}, {765,0.006393365}, {770,0.005729858}, {775,0.005734597}, {780,0.005620853}, {785,0.006744076}, {790,0.005819905}, {795,0.005791469}, {800,0.005886256}, {805,0.005758294}, {810,0.005995261}, {815,0.006037915}, {820,0.007241706}, {825,0.006018957}, {830,0.005919431}, {835,0.006052133}, {840,0.006781991}, {845,0.006241706}, {850,0.006184834}, {855,0.006208531}, {860,0.006066351}, {865,0.006933649}, {870,0.006417062}, {875,0.006350711}, {880,0.006379147}, {885,0.006360190}, {890,0.007284360}, {895,0.006549763}, {900,0.006530806}, {905,0.006639810}, {910,0.006620853}, {915,0.007246445}, {920,0.006573460}, {925,0.006573460}, {930,0.006748815}, {935,0.006573460}, {940,0.006829384}, {945,0.007819905}, {950,0.006862559}, {955,0.006900474}, {960,0.006995261}, {965,0.007080569}, {970,0.007137441}, {975,0.007109005}, {980,0.007052133}, {985,0.007976303}, {990,0.009350711}, {995,0.007369668}, {1000,0.007199052}, {1010,0.007393365}, {1020,0.007568720}, {1030,0.007398104}, {1040,0.007507109}, {1050,0.007867299}, {1060,0.007729858}, {1070,0.008824645}, {1080,0.007957346}, {1090,0.007990521}, {1100,0.008355450}, {1110,0.009436019}, {1120,0.008364929}, {1130,0.008639810}, {1140,0.008805687}, {1150,0.009393365}, {1160,0.008725118}, {1170,0.008616114}, {1180,0.009052133}, {1190,0.009104265}, {1200,0.009308057}, {1210,0.009488152}, {1220,0.009402844}, {1230,0.009511848}, {1240,0.009483412}, {1250,0.010706161}, {1260,0.011004739}, {1270,0.009715640}, {1280,0.009943128}, {1290,0.009919431}, {1300,0.010066351}, {1310,0.010047393}, {1320,0.011417062}, {1330,0.011672986}, {1340,0.010668246}, {1350,0.010767773}, {1360,0.012199052}, {1370,0.010834123}, {1380,0.010834123}, {1390,0.010928910}, {1400,0.011383886}, {1410,0.011312796}, {1420,0.012232227}, {1430,0.011710900}, {1440,0.011639810}, {1450,0.012611374}, {1460,0.012014218}, {1470,0.011601896}, {1480,0.012800948}, {1490,0.012990521}, {1500,0.011981043}, {1510,0.013402844}, {1520,0.012966825}, {1530,0.012421801}, {1540,0.013706161}, {1550,0.012516588}, {1560,0.012701422}, {1570,0.014890995}, {1580,0.012867299}, {1590,0.013061611}, {1600,0.012924171}, {1610,0.013075829}, {1620,0.012881517}, {1630,0.013094787}, {1640,0.013341232}, {1650,0.013407583}, {1660,0.014668246}, {1670,0.013492891}, {1680,0.014786730}, {1690,0.013549763}, {1700,0.013781991}, {1710,0.013853081}, {1720,0.013919431}, {1730,0.014260664}, {1740,0.015047393}, {1750,0.013862559}, {1760,0.015407583}, {1770,0.014336493}, {1780,0.014450237}, {1790,0.015668246}, {1800,0.014454976}, {1810,0.016582938}, {1820,0.014772512}, {1830,0.014824645}, {1840,0.016056872}, {1850,0.014914692}, {1860,0.016838863}, {1870,0.015180095}, {1880,0.015123223}, {1890,0.016218009}, {1900,0.015322275}, {1910,0.015459716}, {1920,0.015526066}, {1930,0.017483412}, {1940,0.015573460}, {1950,0.015895735}, {1960,0.018398104}, {1970,0.015876777}, {1980,0.015824645}, {1990,0.016284360}, {2000,0.017606635}, {2050,0.016530806}, {2100,0.017279621}, {2150,0.018469194}, {2200,0.018071090}, {2250,0.020113744}, {2300,0.018639810}, {2350,0.020800948}, {2400,0.019725118}, {2450,0.019810427}, {2500,0.022800948}, {2550,0.021127962}, {2600,0.022971564}, {2650,0.022374408}, {2700,0.024436019}, {2750,0.023469194}, {2800,0.023393365}, {2850,0.025976303}, {2900,0.024682464}, {2950,0.026540284}, {3000,0.027587678}, {3050,0.026151659}, {3100,0.028123223}, {3150,0.030445498}, {3200,0.027341232}, {3250,0.029843602}, {3300,0.029530806}, {3350,0.028772512}, {3400,0.028914692}, {3450,0.033232227}, {3500,0.034255924}, {3550,0.030440758}, {3600,0.030545024}, {3650,0.034383886}, {3700,0.036436019}, {3750,0.034616114}, {3800,0.032734597}, {3850,0.033265403}, {3900,0.032336493}, {3950,0.035393365}, {4000,0.040943128}, {4050,0.037393365}, {4100,0.038701422}, {4150,0.041592417}, {4200,0.036777251}, {4250,0.037109005}, {4300,0.037573460}, {4350,0.037853081}, {4400,0.041336493}, {4450,0.040625592}, {4500,0.041857820}, {4550,0.042450237}, {4600,0.042853081}, {4650,0.043388626}, {4700,0.044345972}, {4750,0.043909953}, {4800,0.044071090}, {4850,0.043620853}, {4900,0.043085308}, {4950,0.043715640}, {5000,0.044075829}, {5050,0.06843}, {5100,0.04714}, {5150,0.04657}, {5200,0.04586}, {5250,0.04386}, {5300,0.04929}, {5350,0.05057}, {5400,0.05129}, {5450,0.04943}, {5500,0.04986}, {5550,0.04700}, {5600,0.05471}, {5650,0.05543}, {5700,0.05214}, {5750,0.04971}, {5800,0.05186}, {5850,0.05614}, {5900,0.05457}, {5950,0.04986}, {6000,0.05786}, {6050,0.05786}, {6100,0.05457}, {6150,0.06314}, {6200,0.05986}, {6250,0.05429}, {6300,0.05971}, {6350,0.06029}, {6400,0.05671}, {6450,0.06329}, {6500,0.05814}, {6550,0.06271}, {6600,0.06800}, {6650,0.06114}, {6700,0.06757}, {6750,0.05857}, {6800,0.06614}, {6850,0.06100}, {6900,0.06829}, {6950,0.06243}, {7000,0.07000}, {7050,0.06400}, {7100,0.06900}, {7150,0.06600}, {7200,0.07100}, {7250,0.06386}, {7300,0.06857}, {7350,0.07071}, {7400,0.06600}, {7450,0.07314}, {7500,0.07386}, {7550,0.07243}, {7600,0.07314}, {7650,0.06829}, {7700,0.07543}, {7750,0.07343}, {7800,0.06957}, {7850,0.07571}, {7900,0.07586}, {7950,0.08043}, {8000,0.07757}, {8050,0.07771}, {8100,0.07371}, {8150,0.07243}, {8200,0.08029}, {8250,0.07971}, {8300,0.07743}, {8350,0.08114}, {8400,0.07786}, {8450,0.08143}, {8500,0.08214}, {8550,0.08429}, {8600,0.07986}, {8650,0.08186}, {8700,0.08429}, {8750,0.08300}, {8800,0.08543}, {8850,0.08400}, {8900,0.08371}, {8950,0.08800}, {9000,0.08771}, {9050,0.09071}, {9100,0.09129}, {9150,0.08514}, {9200,0.08571}, {9250,0.08571}, {9300,0.08743}, {9350,0.08671}, {9400,0.08886}, {9450,0.09629}, {9500,0.09643}, {9550,0.09157}, {9600,0.09157}, {9650,0.09229}, {9700,0.09100}, {9750,0.09429}, {9800,0.09657}, {9850,0.09729}, {9900,0.09829}, {9950,0.09657}, {10000,0.09800}, {10100,0.09357}, {10200,0.09786}, {10300,0.09657}, {10400,0.10371}, {10500,0.10057}, {10600,0.09971}, {10700,0.51000}, {10800,0.11386}, {10900,0.09871}, {11000,0.11071}, {11100,0.10586}, {11200,0.10571}, {11300,0.10586}, {11400,0.10514}, {11500,0.11143}, {11600,0.10700}, {11700,0.10829}, {11800,0.10886}, {11900,0.11614}, {12000,0.11214}, {12100,0.11871}, {12200,0.12571}, {12300,0.11500}, {12400,0.12114}, {12500,0.12729}, {12600,0.11643}, {12700,0.12357}, {12800,0.12900}, {12900,0.12286}, {13000,0.12114}, {13100,0.12671}, {13200,0.13043}, {13300,0.13057}, {13400,0.13529}, {13500,0.13514}, {13600,0.12286}, {13700,0.12600}, {13800,0.12343}, {13900,0.12971}, {14000,0.13029}, {14100,0.13100}, {14200,0.12586}, {14300,0.13300}, {14400,0.13957}, {14500,0.14171}, {14600,0.14043}, {14700,0.13300}, {14800,0.13829}, {14900,0.13714}, {15000,0.14571}, {15100,0.14700}, {15200,0.13971}, {15300,0.13686}, {15400,0.15929}, {15500,0.15243}, {15600,0.14586}, {15700,0.15857}, {15800,0.15071}, {15900,0.14714}, {16000,0.16043}, {16100,0.14814}, {16200,0.16014}, {16300,0.14914}, {16400,0.16457}, {16500,0.15043}, {16600,0.16514}, {16700,0.16386}, {16800,0.15786}, {16900,0.16986}, {17000,0.15271}, {17100,0.16786}, {17200,0.17729}, {17300,0.15771}, {17400,0.16171}, {17500,0.17057}, {17600,0.17157}, {17700,0.17271}, {17800,0.15686}, {17900,0.17186}, {18000,0.17400}, {18100,0.18914}, {18200,0.18443}, {18300,0.17314}, {18400,0.17386}, {18500,0.17557}, {18600,0.17743}, {18700,0.17814}, {18800,0.17386}, {18900,0.17600}, {19000,0.17886}, {19100,0.19243}, {19200,0.19286}, {19300,0.19014}, {19400,0.18314}, {19500,0.17014}, {19600,0.18200}, {19700,0.19729}, {19800,0.19486}, {19900,0.18200}, {20000,0.19120}};
data["big_flat"]["beta; Parametricity"]["reif"]["system"] = {{1,0.000075829}, {2,0.000037915}, {3,0.000000000}, {4,0.000000000}, {5,0.000037915}, {6,0.000018957}, {7,0.000000000}, {8,0.000018957}, {9,0.000000000}, {10,0.000000000}, {11,0.000000000}, {12,0.000000000}, {13,0.000056872}, {14,0.000018957}, {15,0.000018957}, {16,0.000000000}, {17,0.000018957}, {18,0.000000000}, {19,0.000000000}, {20,0.000000000}, {21,0.000000000}, {22,0.000000000}, {23,0.000018957}, {24,0.000000000}, {25,0.000018957}, {26,0.000018957}, {27,0.000056872}, {28,0.000018957}, {29,0.000037915}, {30,0.000000000}, {31,0.000018957}, {32,0.000037915}, {33,0.000000000}, {34,0.000018957}, {35,0.000000000}, {36,0.000000000}, {37,0.000000000}, {38,0.000000000}, {39,0.000000000}, {40,0.000000000}, {41,0.000000000}, {42,0.000000000}, {43,0.000000000}, {44,0.000000000}, {45,0.000018957}, {46,0.000018957}, {47,0.000000000}, {48,0.000000000}, {49,0.000018957}, {50,0.000052133}, {51,0.000000000}, {52,0.000018957}, {53,0.000000000}, {54,0.000018957}, {55,0.000018957}, {56,0.000037915}, {57,0.000000000}, {58,0.000014218}, {59,0.000000000}, {60,0.000037915}, {61,0.000014218}, {62,0.000000000}, {63,0.000018957}, {64,0.000018957}, {65,0.000018957}, {66,0.000037915}, {67,0.000018957}, {68,0.000037915}, {69,0.000000000}, {70,0.000000000}, {71,0.000018957}, {72,0.000018957}, {73,0.000018957}, {74,0.000000000}, {75,0.000000000}, {76,0.000000000}, {77,0.000056872}, {78,0.000037915}, {79,0.000000000}, {80,0.000000000}, {81,0.000037915}, {82,0.000000000}, {83,0.000000000}, {84,0.000000000}, {85,0.000000000}, {86,0.000018957}, {87,0.000018957}, {88,0.000037915}, {89,0.000037915}, {90,0.000052133}, {91,0.000000000}, {92,0.000018957}, {93,0.000018957}, {94,0.000018957}, {95,0.000000000}, {96,0.000037915}, {97,0.000000000}, {98,0.000018957}, {99,0.000018957}, {100,0.000000000}, {101,0.000037915}, {102,0.000014218}, {103,0.000018957}, {104,0.000018957}, {105,0.000033175}, {106,0.000000000}, {107,0.000000000}, {108,0.000018957}, {109,0.000018957}, {110,0.000000000}, {111,0.000018957}, {112,0.000000000}, {113,0.000018957}, {114,0.000000000}, {115,0.000000000}, {116,0.000018957}, {117,0.000037915}, {118,0.000033175}, {119,0.000037915}, {120,0.000037915}, {121,0.000037915}, {122,0.000018957}, {123,0.000018957}, {124,0.000018957}, {125,0.000037915}, {126,0.000037915}, {127,0.000018957}, {128,0.000018957}, {129,0.000000000}, {130,0.000000000}, {131,0.000014218}, {132,0.000018957}, {133,0.000056872}, {134,0.000018957}, {135,0.000000000}, {136,0.000018957}, {137,0.000000000}, {138,0.000000000}, {139,0.000018957}, {140,0.000018957}, {141,0.000018957}, {142,0.000000000}, {143,0.000000000}, {144,0.000018957}, {145,0.000037915}, {146,0.000000000}, {147,0.000037915}, {148,0.000018957}, {149,0.000033175}, {150,0.000000000}, {151,0.000037915}, {152,0.000090047}, {153,0.000000000}, {154,0.000018957}, {155,0.000018957}, {156,0.000037915}, {157,0.000000000}, {158,0.000037915}, {159,0.000000000}, {160,0.000018957}, {161,0.000000000}, {162,0.000000000}, {163,0.000018957}, {164,0.000018957}, {165,0.000000000}, {166,0.000018957}, {167,0.000018957}, {168,0.000018957}, {169,0.000037915}, {170,0.000000000}, {171,0.000018957}, {172,0.000018957}, {173,0.000037915}, {174,0.000000000}, {175,0.000000000}, {176,0.000018957}, {177,0.000018957}, {178,0.000033175}, {179,0.000000000}, {180,0.000000000}, {181,0.000037915}, {182,0.000037915}, {183,0.000018957}, {184,0.000000000}, {185,0.000000000}, {186,0.000018957}, {187,0.000014218}, {188,0.000037915}, {189,0.000000000}, {190,0.000000000}, {191,0.000018957}, {192,0.000018957}, {193,0.000000000}, {194,0.000018957}, {195,0.000018957}, {196,0.000000000}, {197,0.000018957}, {198,0.000037915}, {199,0.000037915}, {200,0.000018957}, {201,0.000000000}, {202,0.000018957}, {203,0.000000000}, {204,0.000018957}, {205,0.000018957}, {206,0.000056872}, {207,0.000000000}, {208,0.000000000}, {209,0.000000000}, {210,0.000018957}, {211,0.000056872}, {212,0.000018957}, {213,0.000037915}, {214,0.000014218}, {215,0.000000000}, {216,0.000018957}, {217,0.000056872}, {218,0.000075829}, {219,0.000018957}, {220,0.000000000}, {221,0.000018957}, {222,0.000018957}, {223,0.000000000}, {224,0.000037915}, {225,0.000018957}, {226,0.000018957}, {227,0.000000000}, {228,0.000018957}, {229,0.000000000}, {230,0.000018957}, {231,0.000000000}, {232,0.000000000}, {233,0.000000000}, {234,0.000056872}, {235,0.000018957}, {236,0.000018957}, {237,0.000018957}, {238,0.000000000}, {239,0.000014218}, {240,0.000018957}, {241,0.000000000}, {242,0.000000000}, {243,0.000018957}, {244,0.000018957}, {245,0.000018957}, {246,0.000018957}, {247,0.000000000}, {248,0.000018957}, {249,0.000000000}, {250,0.000018957}, {251,0.000037915}, {252,0.000037915}, {253,0.000000000}, {254,0.000000000}, {255,0.000000000}, {256,0.000018957}, {257,0.000000000}, {258,0.000018957}, {259,0.000000000}, {260,0.000000000}, {261,0.000000000}, {262,0.000000000}, {263,0.000000000}, {264,0.000000000}, {265,0.000000000}, {266,0.000018957}, {267,0.000018957}, {268,0.000018957}, {269,0.000037915}, {270,0.000000000}, {271,0.000000000}, {272,0.000056872}, {273,0.000000000}, {274,0.000000000}, {275,0.000037915}, {276,0.000037915}, {277,0.000033175}, {278,0.000037915}, {279,0.000000000}, {280,0.000037915}, {281,0.000000000}, {282,0.000000000}, {283,0.000000000}, {284,0.000000000}, {285,0.000000000}, {286,0.000000000}, {287,0.000018957}, {288,0.000000000}, {289,0.000000000}, {290,0.000018957}, {291,0.000018957}, {292,0.000018957}, {293,0.000037915}, {294,0.000033175}, {295,0.000075829}, {296,0.000000000}, {297,0.000000000}, {298,0.000018957}, {299,0.000037915}, {300,0.000037915}, {301,0.000018957}, {302,0.000018957}, {303,0.000018957}, {304,0.000014218}, {305,0.000018957}, {306,0.000037915}, {307,0.000052133}, {308,0.000000000}, {309,0.000000000}, {310,0.000000000}, {311,0.000018957}, {312,0.000018957}, {313,0.000037915}, {314,0.000000000}, {315,0.000000000}, {316,0.000037915}, {317,0.000000000}, {318,0.000056872}, {319,0.000014218}, {320,0.000037915}, {321,0.000000000}, {322,0.000037915}, {323,0.000018957}, {324,0.000000000}, {325,0.000000000}, {326,0.000094787}, {327,0.000000000}, {328,0.000075829}, {329,0.000000000}, {330,0.000000000}, {331,0.000018957}, {332,0.000018957}, {333,0.000018957}, {334,0.000018957}, {335,0.000000000}, {336,0.000000000}, {337,0.000018957}, {338,0.000018957}, {339,0.000000000}, {340,0.000018957}, {341,0.000052133}, {342,0.000018957}, {343,0.000000000}, {344,0.000037915}, {345,0.000000000}, {346,0.000000000}, {347,0.000018957}, {348,0.000037915}, {349,0.000018957}, {350,0.000000000}, {351,0.000000000}, {352,0.000000000}, {353,0.000000000}, {354,0.000018957}, {355,0.000018957}, {356,0.000018957}, {357,0.000018957}, {358,0.000018957}, {359,0.000037915}, {360,0.000037915}, {361,0.000037915}, {362,0.000000000}, {363,0.000000000}, {364,0.000000000}, {365,0.000018957}, {366,0.000014218}, {367,0.000018957}, {368,0.000037915}, {369,0.000000000}, {370,0.000000000}, {371,0.000052133}, {372,0.000018957}, {373,0.000000000}, {374,0.000000000}, {375,0.000052133}, {376,0.000037915}, {377,0.000018957}, {378,0.000000000}, {379,0.000056872}, {380,0.000018957}, {381,0.000018957}, {382,0.000018957}, {383,0.000052133}, {384,0.000037915}, {385,0.000000000}, {386,0.000000000}, {387,0.000000000}, {388,0.000018957}, {389,0.000018957}, {390,0.000052133}, {391,0.000018957}, {392,0.000000000}, {393,0.000037915}, {394,0.000018957}, {395,0.000018957}, {396,0.000018957}, {397,0.000018957}, {398,0.000056872}, {399,0.000018957}, {400,0.000000000}, {401,0.000000000}, {402,0.000000000}, {403,0.000000000}, {404,0.000037915}, {405,0.000000000}, {406,0.000018957}, {407,0.000018957}, {408,0.000000000}, {409,0.000018957}, {410,0.000000000}, {411,0.000037915}, {412,0.000018957}, {413,0.000018957}, {414,0.000014218}, {415,0.000056872}, {416,0.000000000}, {417,0.000000000}, {418,0.000000000}, {419,0.000018957}, {420,0.000000000}, {421,0.000000000}, {422,0.000018957}, {423,0.000000000}, {424,0.000075829}, {425,0.000018957}, {426,0.000018957}, {427,0.000037915}, {428,0.000000000}, {429,0.000037915}, {430,0.000000000}, {431,0.000014218}, {432,0.000000000}, {433,0.000000000}, {434,0.000018957}, {435,0.000018957}, {436,0.000033175}, {437,0.000000000}, {438,0.000018957}, {439,0.000018957}, {440,0.000037915}, {441,0.000037915}, {442,0.000037915}, {443,0.000000000}, {444,0.000000000}, {445,0.000037915}, {446,0.000000000}, {447,0.000018957}, {448,0.000000000}, {449,0.000000000}, {450,0.000018957}, {451,0.000018957}, {452,0.000000000}, {453,0.000052133}, {454,0.000018957}, {455,0.000000000}, {456,0.000000000}, {457,0.000037915}, {458,0.000000000}, {459,0.000018957}, {460,0.000000000}, {461,0.000018957}, {462,0.000037915}, {463,0.000037915}, {464,0.000037915}, {465,0.000000000}, {466,0.000000000}, {467,0.000018957}, {468,0.000018957}, {469,0.000000000}, {470,0.000056872}, {471,0.000018957}, {472,0.000018957}, {473,0.000000000}, {474,0.000037915}, {475,0.000000000}, {476,0.000000000}, {477,0.000014218}, {478,0.000018957}, {479,0.000018957}, {480,0.000037915}, {481,0.000037915}, {482,0.000014218}, {483,0.000018957}, {484,0.000018957}, {485,0.000000000}, {486,0.000000000}, {487,0.000037915}, {488,0.000000000}, {489,0.000018957}, {490,0.000037915}, {491,0.000018957}, {492,0.000075829}, {493,0.000037915}, {494,0.000000000}, {495,0.000000000}, {496,0.000018957}, {497,0.000018957}, {498,0.000000000}, {499,0.000000000}, {500,0.000037915}, {505,0.000000000}, {510,0.000018957}, {515,0.000000000}, {520,0.000000000}, {525,0.000037915}, {530,0.000018957}, {535,0.000000000}, {540,0.000018957}, {545,0.000028436}, {550,0.000018957}, {555,0.000000000}, {560,0.000000000}, {565,0.000056872}, {570,0.000033175}, {575,0.000018957}, {580,0.000018957}, {585,0.000000000}, {590,0.000037915}, {595,0.000037915}, {600,0.000000000}, {605,0.000018957}, {610,0.000056872}, {615,0.000037915}, {620,0.000037915}, {625,0.000000000}, {630,0.000037915}, {635,0.000056872}, {640,0.000071090}, {645,0.000000000}, {650,0.000018957}, {655,0.000037915}, {660,0.000018957}, {665,0.000037915}, {670,0.000014218}, {675,0.000018957}, {680,0.000014218}, {685,0.000018957}, {690,0.000000000}, {695,0.000018957}, {700,0.000037915}, {705,0.000075829}, {710,0.000018957}, {715,0.000018957}, {720,0.000037915}, {725,0.000037915}, {730,0.000033175}, {735,0.000018957}, {740,0.000000000}, {745,0.000000000}, {750,0.000000000}, {755,0.000018957}, {760,0.000018957}, {765,0.000037915}, {770,0.000018957}, {775,0.000037915}, {780,0.000037915}, {785,0.000037915}, {790,0.000018957}, {795,0.000000000}, {800,0.000056872}, {805,0.000037915}, {810,0.000018957}, {815,0.000000000}, {820,0.000037915}, {825,0.000018957}, {830,0.000000000}, {835,0.000033175}, {840,0.000000000}, {845,0.000037915}, {850,0.000018957}, {855,0.000018957}, {860,0.000018957}, {865,0.000075829}, {870,0.000018957}, {875,0.000000000}, {880,0.000018957}, {885,0.000037915}, {890,0.000037915}, {895,0.000037915}, {900,0.000018957}, {905,0.000018957}, {910,0.000033175}, {915,0.000018957}, {920,0.000018957}, {925,0.000000000}, {930,0.000037915}, {935,0.000000000}, {940,0.000018957}, {945,0.000018957}, {950,0.000000000}, {955,0.000018957}, {960,0.000037915}, {965,0.000000000}, {970,0.000037915}, {975,0.000037915}, {980,0.000075829}, {985,0.000000000}, {990,0.000000000}, {995,0.000018957}, {1000,0.000052133}, {1010,0.000018957}, {1020,0.000000000}, {1030,0.000018957}, {1040,0.000037915}, {1050,0.000018957}, {1060,0.000037915}, {1070,0.000018957}, {1080,0.000037915}, {1090,0.000018957}, {1100,0.000018957}, {1110,0.000018957}, {1120,0.000037915}, {1130,0.000000000}, {1140,0.000075829}, {1150,0.000000000}, {1160,0.000018957}, {1170,0.000037915}, {1180,0.000037915}, {1190,0.000056872}, {1200,0.000000000}, {1210,0.000000000}, {1220,0.000018957}, {1230,0.000071090}, {1240,0.000000000}, {1250,0.000014218}, {1260,0.000037915}, {1270,0.000018957}, {1280,0.000056872}, {1290,0.000000000}, {1300,0.000018957}, {1310,0.000033175}, {1320,0.000018957}, {1330,0.000000000}, {1340,0.000037915}, {1350,0.000056872}, {1360,0.000094787}, {1370,0.000018957}, {1380,0.000018957}, {1390,0.000037915}, {1400,0.000000000}, {1410,0.000075829}, {1420,0.000018957}, {1430,0.000037915}, {1440,0.000056872}, {1450,0.000018957}, {1460,0.000000000}, {1470,0.000094787}, {1480,0.000037915}, {1490,0.000094787}, {1500,0.000037915}, {1510,0.000018957}, {1520,0.000000000}, {1530,0.000018957}, {1540,0.000018957}, {1550,0.000052133}, {1560,0.000018957}, {1570,0.000075829}, {1580,0.000014218}, {1590,0.000000000}, {1600,0.000000000}, {1610,0.000000000}, {1620,0.000094787}, {1630,0.000056872}, {1640,0.000000000}, {1650,0.000037915}, {1660,0.000056872}, {1670,0.000018957}, {1680,0.000037915}, {1690,0.000094787}, {1700,0.000075829}, {1710,0.000075829}, {1720,0.000018957}, {1730,0.000018957}, {1740,0.000037915}, {1750,0.000056872}, {1760,0.000056872}, {1770,0.000037915}, {1780,0.000018957}, {1790,0.000018957}, {1800,0.000037915}, {1810,0.000071090}, {1820,0.000018957}, {1830,0.000037915}, {1840,0.000113744}, {1850,0.000018957}, {1860,0.000018957}, {1870,0.000014218}, {1880,0.000037915}, {1890,0.000037915}, {1900,0.000037915}, {1910,0.000052133}, {1920,0.000033175}, {1930,0.000075829}, {1940,0.000056872}, {1950,0.000056872}, {1960,0.000018957}, {1970,0.000056872}, {1980,0.000037915}, {1990,0.000075829}, {2000,0.000146919}, {2050,0.000000000}, {2100,0.000000000}, {2150,0.000075829}, {2200,0.000018957}, {2250,0.000018957}, {2300,0.000000000}, {2350,0.000075829}, {2400,0.000000000}, {2450,0.000018957}, {2500,0.000037915}, {2550,0.000018957}, {2600,0.000094787}, {2650,0.000037915}, {2700,0.000037915}, {2750,0.000018957}, {2800,0.000037915}, {2850,0.000094787}, {2900,0.000056872}, {2950,0.000056872}, {3000,0.000037915}, {3050,0.000018957}, {3100,0.000037915}, {3150,0.000146919}, {3200,0.000018957}, {3250,0.000056872}, {3300,0.000127962}, {3350,0.000075829}, {3400,0.000018957}, {3450,0.000075829}, {3500,0.000061611}, {3550,0.000056872}, {3600,0.000000000}, {3650,0.000037915}, {3700,0.000094787}, {3750,0.000037915}, {3800,0.000094787}, {3850,0.000056872}, {3900,0.000094787}, {3950,0.000018957}, {4000,0.000113744}, {4050,0.000018957}, {4100,0.000113744}, {4150,0.000090047}, {4200,0.000113744}, {4250,0.000037915}, {4300,0.000056872}, {4350,0.000094787}, {4400,0.000033175}, {4450,0.000037915}, {4500,0.000018957}, {4550,0.000075829}, {4600,0.000071090}, {4650,0.000037915}, {4700,0.000000000}, {4750,0.000052133}, {4800,0.000056872}, {4850,0.000037915}, {4900,0.000018957}, {4950,0.000018957}, {5000,0.000018957}, {5050,0.00057}, {5100,0.00000}, {5150,0.00000}, {5200,0.00000}, {5250,0.00000}, {5300,0.00057}, {5350,0.00000}, {5400,0.00000}, {5450,0.00000}, {5500,0.00000}, {5550,0.00000}, {5600,0.00000}, {5650,0.00114}, {5700,0.00000}, {5750,0.00000}, {5800,0.00000}, {5850,0.00057}, {5900,0.00000}, {5950,0.00000}, {6000,0.00000}, {6050,0.00000}, {6100,0.00000}, {6150,0.00000}, {6200,0.00000}, {6250,0.00000}, {6300,0.00000}, {6350,0.00000}, {6400,0.00000}, {6450,0.00000}, {6500,0.00057}, {6550,0.00057}, {6600,0.00000}, {6650,0.00057}, {6700,0.00114}, {6750,0.00000}, {6800,0.00000}, {6850,0.00000}, {6900,0.00100}, {6950,0.00000}, {7000,0.00057}, {7050,0.00000}, {7100,0.00000}, {7150,0.00000}, {7200,0.00000}, {7250,0.00000}, {7300,0.00057}, {7350,0.00000}, {7400,0.00000}, {7450,0.00000}, {7500,0.00057}, {7550,0.00057}, {7600,0.00000}, {7650,0.00100}, {7700,0.00057}, {7750,0.00000}, {7800,0.00057}, {7850,0.00057}, {7900,0.00057}, {7950,0.00000}, {8000,0.00000}, {8050,0.00000}, {8100,0.00000}, {8150,0.00000}, {8200,0.00000}, {8250,0.00000}, {8300,0.00000}, {8350,0.00114}, {8400,0.00000}, {8450,0.00000}, {8500,0.00000}, {8550,0.00000}, {8600,0.00000}, {8650,0.00057}, {8700,0.00000}, {8750,0.00000}, {8800,0.00000}, {8850,0.00000}, {8900,0.00000}, {8950,0.00000}, {9000,0.00043}, {9050,0.00000}, {9100,0.00000}, {9150,0.00000}, {9200,0.00057}, {9250,0.00000}, {9300,0.00000}, {9350,0.00000}, {9400,0.00000}, {9450,0.00000}, {9500,0.00000}, {9550,0.00000}, {9600,0.00000}, {9650,0.00057}, {9700,0.00000}, {9750,0.00000}, {9800,0.00000}, {9850,0.00000}, {9900,0.00000}, {9950,0.00000}, {10000,0.00000}, {10100,0.00000}, {10200,0.00000}, {10300,0.00000}, {10400,0.00000}, {10500,0.00000}, {10600,0.00000}, {10700,0.00057}, {10800,0.00000}, {10900,0.00000}, {11000,0.00000}, {11100,0.00000}, {11200,0.00000}, {11300,0.00000}, {11400,0.00000}, {11500,0.00000}, {11600,0.00000}, {11700,0.00000}, {11800,0.00000}, {11900,0.00000}, {12000,0.00000}, {12100,0.00000}, {12200,0.00000}, {12300,0.00000}, {12400,0.00000}, {12500,0.00000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00057}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00057}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00057}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00114}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00057}, {19100,0.00000}, {19200,0.00000}, {19300,0.00057}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.00000}};
data["big_flat"]["cbn Denote"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000885}, {51,0.00003540}, {52,0.00002655}, {53,0.00000885}, {54,0.00000885}, {55,0.00001770}, {56,0.00000885}, {57,0.00001770}, {58,0.00001770}, {59,0.00039823}, {60,0.00085841}, {61,0.00100000}, {62,0.00100000}, {63,0.00100000}, {64,0.00100000}, {65,0.00100000}, {66,0.00100000}, {67,0.00100000}, {68,0.00100000}, {69,0.00100000}, {70,0.00100000}, {71,0.00100000}, {72,0.00100000}, {73,0.00100000}, {74,0.00100000}, {75,0.00100000}, {76,0.00100000}, {77,0.00100000}, {78,0.00100000}, {79,0.00100000}, {80,0.00100000}, {81,0.00100000}, {82,0.00100000}, {83,0.00100000}, {84,0.00100000}, {85,0.00100000}, {86,0.00100000}, {87,0.00100000}, {88,0.00100000}, {89,0.00100000}, {90,0.00100000}, {91,0.00100000}, {92,0.00100000}, {93,0.00100000}, {94,0.00100000}, {95,0.00100000}, {96,0.00100000}, {97,0.00100000}, {98,0.00100000}, {99,0.00100000}, {100,0.00100000}, {101,0.00100000}, {102,0.00100000}, {103,0.00100000}, {104,0.00100885}, {105,0.00100885}, {106,0.00100000}, {107,0.00100885}, {108,0.00100000}, {109,0.00100885}, {110,0.00100885}, {111,0.00100000}, {112,0.00100885}, {113,0.00103540}, {114,0.00100885}, {115,0.00101770}, {116,0.00101770}, {117,0.00103540}, {118,0.00100885}, {119,0.00169027}, {120,0.00117699}, {121,0.00189381}, {122,0.00200000}, {123,0.00200000}, {124,0.00200000}, {125,0.00200000}, {126,0.00200000}, {127,0.00200000}, {128,0.00200000}, {129,0.00200000}, {130,0.00200000}, {131,0.00200000}, {132,0.00200000}, {133,0.00200000}, {134,0.00200000}, {135,0.00200000}, {136,0.00200000}, {137,0.00200000}, {138,0.00200000}, {139,0.00200000}, {140,0.00200000}, {141,0.00200000}, {142,0.00200000}, {143,0.00200000}, {144,0.00200000}, {145,0.00200000}, {146,0.00200000}, {147,0.00200000}, {148,0.00200000}, {149,0.00200000}, {150,0.00200000}, {151,0.00200000}, {152,0.00200000}, {153,0.00200000}, {154,0.00200000}, {155,0.00200000}, {156,0.00200000}, {157,0.00200000}, {158,0.00200000}, {159,0.00200000}, {160,0.00200000}, {161,0.00200000}, {162,0.00200885}, {163,0.00200885}, {164,0.00200000}, {165,0.00200000}, {166,0.00200000}, {167,0.00200000}, {168,0.00200000}, {169,0.00200885}, {170,0.00200000}, {171,0.00200000}, {172,0.00201770}, {173,0.00200000}, {174,0.00200885}, {175,0.00201770}, {176,0.00200000}, {177,0.00200000}, {178,0.00203540}, {179,0.00226549}, {180,0.00212389}, {181,0.00312389}, {182,0.00291150}, {183,0.00300000}, {184,0.00299115}, {185,0.00300000}, {186,0.00300000}, {187,0.00300000}, {188,0.00300000}, {189,0.00300000}, {190,0.00300000}, {191,0.00300000}, {192,0.00300000}, {193,0.00300000}, {194,0.00300000}, {195,0.00300000}, {196,0.00300000}, {197,0.00300000}, {198,0.00300000}, {199,0.00300000}, {200,0.00300000}, {201,0.00300000}, {202,0.00301770}, {203,0.00300000}, {204,0.00300000}, {205,0.00300000}, {206,0.00300000}, {207,0.00300000}, {208,0.00300000}, {209,0.00300000}, {210,0.00301770}, {211,0.00300000}, {212,0.00300000}, {213,0.00300000}, {214,0.00300000}, {215,0.00300000}, {216,0.00300000}, {217,0.00300000}, {218,0.00300000}, {219,0.00300000}, {220,0.00300000}, {221,0.00300000}, {222,0.00300000}, {223,0.00300885}, {224,0.00300000}, {225,0.00300000}, {226,0.00300000}, {227,0.00300000}, {228,0.00300000}, {229,0.00300000}, {230,0.00300000}, {231,0.00300885}, {232,0.00301770}, {233,0.00300885}, {234,0.00300000}, {235,0.00303540}, {236,0.00302655}, {237,0.00303540}, {238,0.00310619}, {239,0.00340708}, {240,0.00306195}, {241,0.00340708}, {242,0.00364602}, {243,0.00400000}, {244,0.00397345}, {245,0.00400000}, {246,0.00400885}, {247,0.00400000}, {248,0.00400000}, {249,0.00400000}, {250,0.00400000}, {251,0.00400000}, {252,0.00400000}, {253,0.00400000}, {254,0.00400000}, {255,0.00400000}, {256,0.00400000}, {257,0.00400000}, {258,0.00498230}, {259,0.00400000}, {260,0.00400000}, {261,0.00400000}, {262,0.00400000}, {263,0.00400000}, {264,0.00400000}, {265,0.00400000}, {266,0.00400000}, {267,0.00400000}, {268,0.00400000}, {269,0.00400000}, {270,0.00400000}, {271,0.00400000}, {272,0.00400000}, {273,0.00400000}, {274,0.00400000}, {275,0.00400000}, {276,0.00400000}, {277,0.00400000}, {278,0.00400000}, {279,0.00498230}, {280,0.00400000}, {281,0.00400000}, {282,0.00400000}, {283,0.00400000}, {284,0.00400000}, {285,0.00400000}, {286,0.00400000}, {287,0.00400000}, {288,0.00400000}, {289,0.00498230}, {290,0.00400000}, {291,0.00400000}, {292,0.00400885}, {293,0.00400000}, {294,0.00400885}, {295,0.00403540}, {296,0.00400000}, {297,0.00402655}, {298,0.00405310}, {299,0.00433628}, {300,0.00427434}, {301,0.00476106}, {302,0.00487611}, {303,0.00499115}, {304,0.00473451}, {305,0.00497345}, {306,0.00500000}, {307,0.00500000}, {308,0.00500000}, {309,0.00500000}, {310,0.00500000}, {311,0.00500000}, {312,0.00500000}, {313,0.00500000}, {314,0.00588496}, {315,0.00500000}, {316,0.00500000}, {317,0.00598230}, {318,0.00500000}, {319,0.00500000}, {320,0.00500000}, {321,0.00500000}, {322,0.00500000}, {323,0.00500000}, {324,0.00500000}, {325,0.00500000}, {326,0.00500000}, {327,0.00500000}, {328,0.00500000}, {329,0.00500000}, {330,0.00500000}, {331,0.00500000}, {332,0.00500000}, {333,0.00500000}, {334,0.00500000}, {335,0.00500000}, {336,0.00500000}, {337,0.00500000}, {338,0.00501770}, {339,0.00500000}, {340,0.00500000}, {341,0.00500000}, {342,0.00500885}, {343,0.00500885}, {344,0.00500000}, {345,0.00500000}, {346,0.00500000}, {347,0.00500000}, {348,0.00500000}, {349,0.00501770}, {350,0.00500000}, {351,0.00501770}, {352,0.00500000}, {353,0.00500885}, {354,0.00500000}, {355,0.00505310}, {356,0.00503540}, {357,0.00508850}, {358,0.00513274}, {359,0.00548673}, {360,0.00513274}, {361,0.00559292}, {362,0.00571681}, {363,0.00596460}, {364,0.00593805}, {365,0.00599115}, {366,0.00600000}, {367,0.00600000}, {368,0.00599115}, {369,0.00600000}, {370,0.00600000}, {371,0.00600000}, {372,0.00600000}, {373,0.00600000}, {374,0.00600000}, {375,0.00600000}, {376,0.00600000}, {377,0.00600000}, {378,0.00600000}, {379,0.00600000}, {380,0.00600000}, {381,0.00600000}, {382,0.00600000}, {383,0.00600000}, {384,0.00600000}, {385,0.00600000}, {386,0.00600000}, {387,0.00600000}, {388,0.00600000}, {389,0.00600000}, {390,0.00600000}, {391,0.00600000}, {392,0.00600000}, {393,0.00600000}, {394,0.00600000}, {395,0.00600000}, {396,0.00600000}, {397,0.00600000}, {398,0.00600000}, {399,0.00600000}, {400,0.00600000}, {401,0.00600000}, {402,0.00600000}, {403,0.00600000}, {404,0.00600000}, {405,0.00600000}, {406,0.00600885}, {407,0.00600885}, {408,0.00600000}, {409,0.00601770}, {410,0.00600000}, {411,0.00602655}, {412,0.00601770}, {413,0.00606195}, {414,0.00608850}, {415,0.00647788}, {416,0.00600885}, {417,0.00604425}, {418,0.00612389}, {419,0.00632743}, {420,0.00623894}, {421,0.00659292}, {422,0.00680531}, {423,0.00698230}, {424,0.00677876}, {425,0.00697345}, {426,0.00698230}, {427,0.00700000}, {428,0.00700000}, {429,0.00700000}, {430,0.00700000}, {431,0.00700000}, {432,0.00700000}, {433,0.00700000}, {434,0.00700000}, {435,0.00700000}, {436,0.00700000}, {437,0.00700000}, {438,0.00700000}, {439,0.00700000}, {440,0.00700000}, {441,0.00700000}, {442,0.00700000}, {443,0.00700000}, {444,0.00700000}, {445,0.00700000}, {446,0.00700000}, {447,0.00700000}, {448,0.00700000}, {449,0.00700000}, {450,0.00700000}, {451,0.00700000}, {452,0.00700000}, {453,0.00700000}, {454,0.00700000}, {455,0.00700000}, {456,0.00700000}, {457,0.00700885}, {458,0.00700000}, {459,0.00701770}, {460,0.00700000}, {461,0.00700000}, {462,0.00700000}, {463,0.00700000}, {464,0.00700000}, {465,0.00702655}, {466,0.00700000}, {467,0.00701770}, {468,0.00700885}, {469,0.00702655}, {470,0.00704425}, {471,0.00712389}, {472,0.00705310}, {473,0.00711504}, {474,0.00721239}, {475,0.00757522}, {476,0.00748673}, {477,0.00776991}, {478,0.00781416}, {479,0.00796460}, {480,0.00730973}, {481,0.00753982}, {482,0.00761062}, {483,0.00794690}, {484,0.00786726}, {485,0.00800000}, {486,0.00800000}, {487,0.00800000}, {488,0.00800000}, {489,0.00800000}, {490,0.00800000}, {491,0.00800000}, {492,0.00800885}, {493,0.00800000}, {494,0.00800000}, {495,0.00800000}, {496,0.00800000}, {497,0.00800000}, {498,0.00899115}, {499,0.00800000}, {500,0.00800000}, {505,0.00800000}, {510,0.00800000}, {515,0.00800000}, {520,0.00800000}, {525,0.00800000}, {530,0.00804425}, {535,0.00858407}, {540,0.00883186}, {545,0.00997345}, {550,0.00900000}, {555,0.00900000}, {560,0.00900000}, {565,0.00900000}, {570,0.00900000}, {575,0.00901770}, {580,0.00900000}, {585,0.00900000}, {590,0.00923009}, {595,0.01097345}, {600,0.00974336}, {605,0.01000000}, {610,0.01000000}, {615,0.01000000}, {620,0.01000000}, {625,0.01000000}, {630,0.01000000}, {635,0.01003540}, {640,0.01000000}, {645,0.01003540}, {650,0.01011504}, {655,0.01093805}, {660,0.01084956}, {665,0.01100000}, {670,0.01100000}, {675,0.01100000}, {680,0.01100000}, {685,0.01100000}, {690,0.01101770}, {695,0.01103540}, {700,0.01120354}, {705,0.01108850}, {710,0.01151327}, {715,0.01197345}, {720,0.01183186}, {725,0.01200000}, {730,0.01200000}, {735,0.01200885}, {740,0.01200000}, {745,0.01200000}, {750,0.01205310}, {755,0.01215929}, {760,0.01210619}, {765,0.01295575}, {770,0.01207080}, {775,0.01292035}, {780,0.01290265}, {785,0.01299115}, {790,0.01300000}, {795,0.01300000}, {800,0.01300893}, {805,0.01300893}, {810,0.01301786}, {815,0.01327679}, {820,0.01312500}, {825,0.01352679}, {830,0.01397321}, {835,0.01379464}, {840,0.01382143}, {845,0.01400893}, {850,0.01400000}, {855,0.01400893}, {860,0.01400000}, {865,0.01400000}, {870,0.01413393}, {875,0.01465179}, {880,0.01419643}, {885,0.01486607}, {890,0.01679464}, {895,0.01500000}, {900,0.01497321}, {905,0.01500000}, {910,0.01501786}, {915,0.01501786}, {920,0.01503571}, {925,0.01538393}, {930,0.01512500}, {935,0.01582143}, {940,0.01578571}, {945,0.01591071}, {950,0.01601786}, {955,0.01603571}, {960,0.01598214}, {965,0.01601786}, {970,0.01607143}, {975,0.01649107}, {980,0.01616964}, {985,0.01665179}, {990,0.01690179}, {995,0.01691964}, {1000,0.01687500}, {1010,0.01698214}, {1020,0.01713393}, {1030,0.01700893}, {1040,0.01700000}, {1050,0.01733036}, {1060,0.01756250}, {1070,0.01800893}, {1080,0.01799107}, {1090,0.01801786}, {1100,0.01819643}, {1110,0.01875893}, {1120,0.01837500}, {1130,0.01902679}, {1140,0.01900893}, {1150,0.01938393}, {1160,0.01907143}, {1170,0.01924107}, {1180,0.01999107}, {1190,0.02000000}, {1200,0.01999107}, {1210,0.02021429}, {1220,0.02015179}, {1230,0.02095536}, {1240,0.02096429}, {1250,0.02099107}, {1260,0.02114286}, {1270,0.02166071}, {1280,0.02100000}, {1290,0.02155357}, {1300,0.02176786}, {1310,0.02201786}, {1320,0.02199107}, {1330,0.02436607}, {1340,0.02276786}, {1350,0.02281250}, {1360,0.02282143}, {1370,0.02300893}, {1380,0.02301786}, {1390,0.02372321}, {1400,0.02581250}, {1410,0.02375000}, {1420,0.02662500}, {1430,0.02418750}, {1440,0.02679464}, {1450,0.02465179}, {1460,0.02711607}, {1470,0.02510714}, {1480,0.02499107}, {1490,0.02520536}, {1500,0.02558036}, {1510,0.02588393}, {1520,0.02592857}, {1530,0.02609821}, {1540,0.02565179}, {1550,0.02600000}, {1560,0.02600000}, {1570,0.02606250}, {1580,0.02652679}, {1590,0.02700000}, {1600,0.02668750}, {1610,0.02700000}, {1620,0.02712500}, {1630,0.02790179}, {1640,0.02750000}, {1650,0.02800893}, {1660,0.02817857}, {1670,0.02802679}, {1680,0.02801786}, {1690,0.02882143}, {1700,0.02881250}, {1710,0.02906250}, {1720,0.02908036}, {1730,0.02904464}, {1740,0.02970536}, {1750,0.03001786}, {1760,0.02985714}, {1770,0.03021429}, {1780,0.03030357}, {1790,0.03102679}, {1800,0.03279464}, {1810,0.03061607}, {1820,0.03097321}, {1830,0.03105357}, {1840,0.03102679}, {1850,0.03170536}, {1860,0.03141964}, {1870,0.03200000}, {1880,0.03200000}, {1890,0.03206250}, {1900,0.03263393}, {1910,0.03298214}, {1920,0.03228571}, {1930,0.03299107}, {1940,0.03307143}, {1950,0.03376786}, {1960,0.03350000}, {1970,0.03388393}, {1980,0.03411607}, {1990,0.03408929}, {2000,0.03412500}, {2050,0.03410714}, {2100,0.03805357}, {2150,0.03658929}, {2200,0.03728571}, {2250,0.03864286}, {2300,0.03981250}, {2350,0.04041964}, {2400,0.04331250}, {2450,0.04212500}, {2500,0.04291071}, {2550,0.04466964}, {2600,0.04408929}, {2650,0.04554464}, {2700,0.04976786}, {2750,0.04814286}, {2800,0.04852679}, {2850,0.04885714}, {2900,0.05013393}, {2950,0.05119643}, {3000,0.05229464}, {3050,0.05365179}, {3100,0.05294643}, {3150,0.05421429}, {3200,0.05434821}, {3250,0.05983036}, {3300,0.05722321}, {3350,0.05803571}, {3400,0.05861607}, {3450,0.06466071}, {3500,0.06126786}, {3550,0.06286607}, {3600,0.06555357}, {3650,0.06290179}, {3700,0.06472321}, {3750,0.06525893}, {3800,0.06633036}, {3850,0.06676786}, {3900,0.06836607}, {3950,0.07000000}, {4000,0.06983929}, {4050,0.07191071}, {4100,0.07336607}, {4150,0.07169643}, {4200,0.07258929}, {4250,0.07391964}, {4300,0.07516964}, {4350,0.08158929}, {4400,0.07622321}, {4450,0.07751786}, {4500,0.08518750}, {4550,0.08047321}, {4600,0.08196429}, {4650,0.08075000}, {4700,0.08708036}, {4750,0.08950000}, {4800,0.09017857}, {4850,0.09142857}, {4900,0.09060714}, {4950,0.08770536}, {5000,0.08771429}, {5050,0.09075000}, {5100,0.09851786}, {5150,0.08986607}, {5200,0.09033929}, {5250,0.09555357}, {5300,0.09362500}, {5350,0.09534821}, {5400,0.09451786}, {5450,0.09636607}, {5500,0.10538393}, {5550,0.10946429}, {5600,0.10013393}, {5650,0.09883929}, {5700,0.09989286}, {5750,0.10327679}, {5800,0.10335714}, {5850,0.10543750}, {5900,0.10457143}, {5950,0.11383036}, {6000,0.11492857}, {6050,0.10890179}, {6100,0.11159821}, {6150,0.12242857}, {6200,0.10840179}, {6250,0.12266071}, {6300,0.11147321}, {6350,0.11399107}, {6400,0.12095536}, {6450,0.11457143}, {6500,0.11617857}, {6550,0.12337500}, {6600,0.13418750}, {6650,0.13690179}, {6700,0.13535714}, {6750,0.13087500}, {6800,0.12531250}, {6850,0.13145536}, {6900,0.12673214}, {6950,0.12567857}, {7000,0.12733036}, {7050,0.14491071}, {7100,0.13155357}, {7150,0.14064286}, {7200,0.12688393}, {7250,0.13658036}, {7300,0.13040179}, {7350,0.14111607}, {7400,0.13553571}, {7450,0.13522321}, {7500,0.13768750}, {7550,0.14699107}, {7600,0.14909821}, {7650,0.14611607}, {7700,0.14337500}, {7750,0.15357143}, {7800,0.14618750}, {7850,0.14641071}, {7900,0.14937500}, {7950,0.15549107}, {8000,0.14908929}, {8050,0.15205357}, {8100,0.16024107}, {8150,0.15746429}, {8200,0.15138393}, {8250,0.15134821}, {8300,0.16930357}, {8350,0.16337500}, {8400,0.15300000}, {8450,0.15141071}, {8500,0.15704464}, {8550,0.16446429}, {8600,0.16219643}, {8650,0.16548214}, {8700,0.17319643}, {8750,0.16489286}, {8800,0.16012500}, {8850,0.16319643}, {8900,0.17376786}, {8950,0.17302679}, {9000,0.16684821}, {9050,0.17935714}, {9100,0.17060714}, {9150,0.18503571}, {9200,0.17527679}, {9250,0.16897321}, {9300,0.17832143}, {9350,0.17287500}, {9400,0.17650000}, {9450,0.18041071}, {9500,0.18888393}, {9550,0.18921429}, {9600,0.18075893}, {9650,0.19006250}, {9700,0.18501786}, {9750,0.18251786}, {9800,0.19053571}, {9850,0.19974107}, {9900,0.18878571}, {9950,0.19577679}, {10000,0.19022321}, {10100,0.19586607}, {10200,0.20405357}, {10300,0.20009821}, {10400,0.18938393}, {10500,0.19165179}, {10600,0.20011607}, {10700,0.20441071}, {10800,0.20560714}, {10900,0.20840179}, {11000,0.21302679}, {11100,0.22202679}, {11200,0.20958036}, {11300,0.20842857}, {11400,0.21089286}, {11500,0.22649107}, {11600,0.22336607}, {11700,0.22658929}, {11800,0.23343750}, {11900,0.24085714}, {12000,0.22899107}, {12100,0.23758036}, {12200,0.24800893}, {12300,0.22383036}, {12400,0.22860714}, {12500,0.23475000}, {12600,0.24500}, {12700,0.24925}, {12800,0.23600}, {12900,0.23775}, {13000,0.24675}, {13100,0.28875}, {13200,0.24375}, {13300,0.26500}, {13400,0.25425}, {13500,0.26250}, {13600,0.25475}, {13700,0.25275}, {13800,0.27675}, {13900,0.26775}, {14000,0.29475}, {14100,0.26600}, {14200,0.28175}, {14300,0.29450}, {14400,0.26800}, {14500,0.28450}, {14600,0.27475}, {14700,0.29775}, {14800,0.31575}, {14900,0.28675}, {15000,0.28975}, {15100,0.31900}, {15200,0.30400}, {15300,0.29575}, {15400,0.30050}, {15500,0.31600}, {15600,0.32275}, {15700,0.31450}, {15800,0.33200}, {15900,0.31650}, {16000,0.32025}, {16100,0.33275}, {16200,0.32175}, {16300,1.36000}, {16400,0.30575}, {16500,0.33250}, {16600,0.33250}, {16700,0.32975}, {16800,0.33725}, {16900,0.31525}, {17000,0.33950}, {17100,0.35550}, {17200,0.35075}, {17300,0.35225}, {17400,0.38525}, {17500,0.35925}, {17600,0.36100}, {17700,0.35775}, {17800,0.35950}, {17900,0.36525}, {18000,0.36775}, {18100,0.37475}, {18200,0.36700}, {18300,0.39050}, {18400,0.39550}, {18500,0.35750}, {18600,0.38225}, {18700,0.36775}, {18800,0.40125}, {18900,0.38700}, {19000,0.36850}, {19100,0.38600}, {19200,0.36825}, {19300,0.39200}, {19400,0.38875}, {19500,0.41650}, {19600,0.38125}, {19700,0.42725}, {19800,0.39425}, {19900,0.40750}, {20000,0.3840}};
data["big_flat"]["cbn Denote"]["Stats"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00002655}, {4,0.00003540}, {5,0.00007965}, {6,0.00014159}, {7,0.00015929}, {8,0.00015929}, {9,0.00002655}, {10,0.00015044}, {11,0.00014159}, {12,0.00030088}, {13,0.00016814}, {14,0.00025664}, {15,0.00015044}, {16,0.00038053}, {17,0.00026549}, {18,0.00017699}, {19,0.00012389}, {20,0.00053982}, {21,0.00046018}, {22,0.00028319}, {23,0.00033628}, {24,0.00020354}, {25,0.00025664}, {26,0.00059292}, {27,0.00055752}, {28,0.00061947}, {29,0.00061062}, {30,0.00049558}, {31,0.00046018}, {32,0.00033628}, {33,0.00013274}, {34,0.00038938}, {35,0.00036283}, {36,0.00064602}, {37,0.00052212}, {38,0.00046903}, {39,0.00090265}, {40,0.00059292}, {41,0.00038053}, {42,0.00078761}, {43,0.00047788}, {44,0.00063717}, {45,0.00052212}, {46,0.00061062}, {47,0.00076991}, {48,0.00073451}, {49,0.00050442}, {50,0.00070796}, {51,0.00071681}, {52,0.00069912}, {53,0.00079646}, {54,0.00074336}, {55,0.00075221}, {56,0.00093805}, {57,0.00084956}, {58,0.00081416}, {59,0.00087611}, {60,0.00060177}, {61,0.00075221}, {62,0.00066372}, {63,0.00079646}, {64,0.00069912}, {65,0.00082301}, {66,0.00079646}, {67,0.00087611}, {68,0.00089381}, {69,0.00099115}, {70,0.00101770}, {71,0.00113274}, {72,0.00076991}, {73,0.00094690}, {74,0.00118584}, {75,0.00120354}, {76,0.00084071}, {77,0.00092035}, {78,0.00131858}, {79,0.00092920}, {80,0.00091150}, {81,0.00139823}, {82,0.00111504}, {83,0.00128319}, {84,0.00111504}, {85,0.00119469}, {86,0.00104425}, {87,0.00133628}, {88,0.00116814}, {89,0.00121239}, {90,0.00143363}, {91,0.00104425}, {92,0.00127434}, {93,0.00127434}, {94,0.00139823}, {95,0.00118584}, {96,0.00107080}, {97,0.00125664}, {98,0.00143363}, {99,0.00142478}, {100,0.00147788}, {101,0.00146018}, {102,0.00139823}, {103,0.00119469}, {104,0.00123009}, {105,0.00135398}, {106,0.00134513}, {107,0.00134513}, {108,0.00165487}, {109,0.00176991}, {110,0.00146018}, {111,0.00135398}, {112,0.00157522}, {113,0.00153982}, {114,0.00140708}, {115,0.00176991}, {116,0.00127434}, {117,0.00168142}, {118,0.00169027}, {119,0.00174336}, {120,0.00156637}, {121,0.00169912}, {122,0.00152212}, {123,0.00179646}, {124,0.00155752}, {125,0.00175221}, {126,0.00161062}, {127,0.00166372}, {128,0.00161062}, {129,0.00177876}, {130,0.00187611}, {131,0.00165487}, {132,0.00187611}, {133,0.00169912}, {134,0.00188496}, {135,0.00177876}, {136,0.00184071}, {137,0.00163717}, {138,0.00165487}, {139,0.00183186}, {140,0.00181416}, {141,0.00186726}, {142,0.00198230}, {143,0.00186726}, {144,0.00188496}, {145,0.00184071}, {146,0.00175221}, {147,0.00214159}, {148,0.00222124}, {149,0.00159292}, {150,0.00188496}, {151,0.00217699}, {152,0.00189381}, {153,0.00194690}, {154,0.00197345}, {155,0.00225664}, {156,0.00200000}, {157,0.00227434}, {158,0.00211504}, {159,0.00222124}, {160,0.00198230}, {161,0.00217699}, {162,0.00211504}, {163,0.00228319}, {164,0.00244248}, {165,0.00223894}, {166,0.00214159}, {167,0.00210619}, {168,0.00234513}, {169,0.00243363}, {170,0.00233628}, {171,0.00223894}, {172,0.00250442}, {173,0.00229204}, {174,0.00227434}, {175,0.00233628}, {176,0.00230088}, {177,0.00246903}, {178,0.00246903}, {179,0.00240708}, {180,0.00249558}, {181,0.00309735}, {182,0.00245133}, {183,0.00223894}, {184,0.00232743}, {185,0.00238938}, {186,0.00267257}, {187,0.00263717}, {188,0.00262832}, {189,0.00262832}, {190,0.00254867}, {191,0.00265487}, {192,0.00274336}, {193,0.00263717}, {194,0.00267257}, {195,0.00258407}, {196,0.00270796}, {197,0.00255752}, {198,0.00256637}, {199,0.00248673}, {200,0.00286726}, {201,0.00284956}, {202,0.00276106}, {203,0.00254867}, {204,0.00284956}, {205,0.00282301}, {206,0.00284956}, {207,0.00293805}, {208,0.00284956}, {209,0.00271681}, {210,0.00266372}, {211,0.00269912}, {212,0.00278761}, {213,0.00287611}, {214,0.00280531}, {215,0.00315044}, {216,0.00303540}, {217,0.00290265}, {218,0.00283186}, {219,0.00292035}, {220,0.00287611}, {221,0.00284071}, {222,0.00287611}, {223,0.00315929}, {224,0.00292920}, {225,0.00300885}, {226,0.00307080}, {227,0.00302655}, {228,0.00298230}, {229,0.00304425}, {230,0.00320354}, {231,0.00314159}, {232,0.00315929}, {233,0.00311504}, {234,0.00311504}, {235,0.00322124}, {236,0.00324779}, {237,0.00318584}, {238,0.00318584}, {239,0.00329204}, {240,0.00321239}, {241,0.00322124}, {242,0.00334513}, {243,0.00333628}, {244,0.00337168}, {245,0.00311504}, {246,0.00331858}, {247,0.00353097}, {248,0.00348673}, {249,0.00344248}, {250,0.00355752}, {251,0.00341593}, {252,0.00339823}, {253,0.00346018}, {254,0.00338053}, {255,0.00357522}, {256,0.00359292}, {257,0.00346018}, {258,0.00448673}, {259,0.00352212}, {260,0.00359292}, {261,0.00367257}, {262,0.00354867}, {263,0.00361947}, {264,0.00372566}, {265,0.00391150}, {266,0.00352212}, {267,0.00380531}, {268,0.00384956}, {269,0.00364602}, {270,0.00389381}, {271,0.00385841}, {272,0.00369912}, {273,0.00364602}, {274,0.00376991}, {275,0.00365487}, {276,0.00370796}, {277,0.00400885}, {278,0.00391150}, {279,0.00500885}, {280,0.00381416}, {281,0.00421239}, {282,0.00392920}, {283,0.00384071}, {284,0.00376106}, {285,0.00394690}, {286,0.00421239}, {287,0.00423009}, {288,0.00432743}, {289,0.00470796}, {290,0.00376991}, {291,0.00398230}, {292,0.00419469}, {293,0.00428319}, {294,0.00411504}, {295,0.00424779}, {296,0.00439823}, {297,0.00443363}, {298,0.00407965}, {299,0.00426549}, {300,0.00403540}, {301,0.00464602}, {302,0.00438053}, {303,0.00436283}, {304,0.00442478}, {305,0.00432743}, {306,0.00457522}, {307,0.00402655}, {308,0.00474336}, {309,0.00461062}, {310,0.00430088}, {311,0.00422124}, {312,0.00440708}, {313,0.00467257}, {314,0.00567257}, {315,0.00457522}, {316,0.00435398}, {317,0.00538053}, {318,0.00464602}, {319,0.00457522}, {320,0.00445133}, {321,0.00472566}, {322,0.00484071}, {323,0.00478761}, {324,0.00461947}, {325,0.00463717}, {326,0.00469027}, {327,0.00514159}, {328,0.00508850}, {329,0.00456637}, {330,0.00476991}, {331,0.00507965}, {332,0.00470796}, {333,0.00502655}, {334,0.00519469}, {335,0.00500885}, {336,0.00512389}, {337,0.00475221}, {338,0.00521239}, {339,0.00505310}, {340,0.00530088}, {341,0.00506195}, {342,0.00513274}, {343,0.00518584}, {344,0.00507965}, {345,0.00527434}, {346,0.00514159}, {347,0.00534513}, {348,0.00522124}, {349,0.00506195}, {350,0.00566372}, {351,0.00520354}, {352,0.00545133}, {353,0.00575221}, {354,0.00579646}, {355,0.00526549}, {356,0.00546903}, {357,0.00512389}, {358,0.00515929}, {359,0.00562832}, {360,0.00541593}, {361,0.00536283}, {362,0.00547788}, {363,0.00559292}, {364,0.00538938}, {365,0.00550442}, {366,0.00567257}, {367,0.00545133}, {368,0.00565487}, {369,0.00546903}, {370,0.00559292}, {371,0.00530088}, {372,0.00584956}, {373,0.00522124}, {374,0.00596460}, {375,0.00531858}, {376,0.00592035}, {377,0.00548673}, {378,0.00553982}, {379,0.00602655}, {380,0.00535398}, {381,0.00586726}, {382,0.00571681}, {383,0.00605310}, {384,0.00576106}, {385,0.00584956}, {386,0.00579646}, {387,0.00568142}, {388,0.00584071}, {389,0.00593805}, {390,0.00568142}, {391,0.00600000}, {392,0.00602655}, {393,0.00623009}, {394,0.00609735}, {395,0.00615044}, {396,0.00605310}, {397,0.00594690}, {398,0.00589381}, {399,0.00598230}, {400,0.00581416}, {401,0.00592920}, {402,0.00609735}, {403,0.00602655}, {404,0.00573451}, {405,0.00618584}, {406,0.00610619}, {407,0.00587611}, {408,0.00625664}, {409,0.00598230}, {410,0.00607965}, {411,0.00603540}, {412,0.00644248}, {413,0.00636283}, {414,0.00628319}, {415,0.00624779}, {416,0.00614159}, {417,0.00638053}, {418,0.00632743}, {419,0.00633628}, {420,0.00638053}, {421,0.00629204}, {422,0.00665487}, {423,0.00627434}, {424,0.00625664}, {425,0.00646903}, {426,0.00626549}, {427,0.00648673}, {428,0.00632743}, {429,0.00666372}, {430,0.00684071}, {431,0.00682301}, {432,0.00653982}, {433,0.00635398}, {434,0.00645133}, {435,0.00661062}, {436,0.00641593}, {437,0.00652212}, {438,0.00678761}, {439,0.00666372}, {440,0.00671681}, {441,0.00672566}, {442,0.00667257}, {443,0.00662832}, {444,0.00673451}, {445,0.00691150}, {446,0.00672566}, {447,0.00678761}, {448,0.00658407}, {449,0.00687611}, {450,0.00684956}, {451,0.00666372}, {452,0.00676991}, {453,0.00676106}, {454,0.00674336}, {455,0.00693805}, {456,0.00701770}, {457,0.00692035}, {458,0.00688496}, {459,0.00687611}, {460,0.00682301}, {461,0.00697345}, {462,0.00696460}, {463,0.00710619}, {464,0.00718584}, {465,0.00691150}, {466,0.00693805}, {467,0.00705310}, {468,0.00702655}, {469,0.00711504}, {470,0.00715929}, {471,0.00711504}, {472,0.00706195}, {473,0.00710619}, {474,0.00710619}, {475,0.00723894}, {476,0.00731858}, {477,0.00731858}, {478,0.00745133}, {479,0.00738053}, {480,0.00722124}, {481,0.00734513}, {482,0.00724779}, {483,0.00729204}, {484,0.00736283}, {485,0.00739823}, {486,0.00749558}, {487,0.00747788}, {488,0.00725664}, {489,0.00727434}, {490,0.00771681}, {491,0.00758407}, {492,0.00738053}, {493,0.00738938}, {494,0.00748673}, {495,0.00792920}, {496,0.00738938}, {497,0.00755752}, {498,0.00902655}, {499,0.00758407}, {500,0.00767257}, {505,0.00764602}, {510,0.00767257}, {515,0.00778761}, {520,0.00788496}, {525,0.00846903}, {530,0.00849558}, {535,0.00803540}, {540,0.00835398}, {545,0.01002655}, {550,0.00853097}, {555,0.00869912}, {560,0.00836283}, {565,0.00881416}, {570,0.00951327}, {575,0.00954867}, {580,0.00907080}, {585,0.00908850}, {590,0.00931858}, {595,0.01077876}, {600,0.00989381}, {605,0.00961062}, {610,0.00941593}, {615,0.00965487}, {620,0.00959292}, {625,0.00959292}, {630,0.01043363}, {635,0.01069027}, {640,0.01006195}, {645,0.01043363}, {650,0.01075221}, {655,0.01086726}, {660,0.01042478}, {665,0.01140708}, {670,0.01120354}, {675,0.01141593}, {680,0.01120354}, {685,0.01152212}, {690,0.01117699}, {695,0.01165487}, {700,0.01172566}, {705,0.01166372}, {710,0.01191150}, {715,0.01201770}, {720,0.01186726}, {725,0.01203540}, {730,0.01203540}, {735,0.01250442}, {740,0.01248673}, {745,0.01220354}, {750,0.01261947}, {755,0.01292035}, {760,0.01236283}, {765,0.01307080}, {770,0.01253097}, {775,0.01273451}, {780,0.01287611}, {785,0.01322124}, {790,0.01341593}, {795,0.01333929}, {800,0.01293750}, {805,0.01341071}, {810,0.01341071}, {815,0.01346429}, {820,0.01335714}, {825,0.01358929}, {830,0.01393750}, {835,0.01381250}, {840,0.01360714}, {845,0.01433036}, {850,0.01423214}, {855,0.01422321}, {860,0.01444643}, {865,0.01412500}, {870,0.01468750}, {875,0.01439286}, {880,0.01446429}, {885,0.01514286}, {890,0.01651786}, {895,0.01508036}, {900,0.01470536}, {905,0.01490179}, {910,0.01522321}, {915,0.01540179}, {920,0.01511607}, {925,0.01547321}, {930,0.01526786}, {935,0.01559821}, {940,0.01562500}, {945,0.01558036}, {950,0.01583036}, {955,0.01602679}, {960,0.01573214}, {965,0.01612500}, {970,0.01616964}, {975,0.01626786}, {980,0.01620536}, {985,0.01642857}, {990,0.01678571}, {995,0.01701786}, {1000,0.01620536}, {1010,0.01694643}, {1020,0.01692857}, {1030,0.01664286}, {1040,0.01734821}, {1050,0.01758036}, {1060,0.01708929}, {1070,0.01800893}, {1080,0.01785714}, {1090,0.01772321}, {1100,0.01815179}, {1110,0.01864286}, {1120,0.01856250}, {1130,0.01876786}, {1140,0.01897321}, {1150,0.01953571}, {1160,0.01924107}, {1170,0.01926786}, {1180,0.01968750}, {1190,0.01991964}, {1200,0.02024107}, {1210,0.02039286}, {1220,0.02042857}, {1230,0.02090179}, {1240,0.02120536}, {1250,0.02100893}, {1260,0.02117857}, {1270,0.02211607}, {1280,0.02076786}, {1290,0.02188393}, {1300,0.02194643}, {1310,0.02244643}, {1320,0.02225000}, {1330,0.02425000}, {1340,0.02314286}, {1350,0.02301786}, {1360,0.02289286}, {1370,0.02342857}, {1380,0.02334821}, {1390,0.02385714}, {1400,0.02558929}, {1410,0.02407143}, {1420,0.02640179}, {1430,0.02461607}, {1440,0.02656250}, {1450,0.02489286}, {1460,0.02698214}, {1470,0.02523214}, {1480,0.02498214}, {1490,0.02542857}, {1500,0.02538393}, {1510,0.02583929}, {1520,0.02595536}, {1530,0.02633929}, {1540,0.02575000}, {1550,0.02589286}, {1560,0.02591964}, {1570,0.02612500}, {1580,0.02657143}, {1590,0.02672321}, {1600,0.02641071}, {1610,0.02656250}, {1620,0.02689286}, {1630,0.02749107}, {1640,0.02727679}, {1650,0.02765179}, {1660,0.02799107}, {1670,0.02781250}, {1680,0.02797321}, {1690,0.02838393}, {1700,0.02845536}, {1710,0.02901786}, {1720,0.02918750}, {1730,0.02893750}, {1740,0.02958036}, {1750,0.02999107}, {1760,0.02941964}, {1770,0.03033929}, {1780,0.03028571}, {1790,0.03089286}, {1800,0.03298214}, {1810,0.03066964}, {1820,0.03083036}, {1830,0.03112500}, {1840,0.03113393}, {1850,0.03151786}, {1860,0.03150000}, {1870,0.03216964}, {1880,0.03192857}, {1890,0.03221429}, {1900,0.03284821}, {1910,0.03316964}, {1920,0.03241964}, {1930,0.03302679}, {1940,0.03297321}, {1950,0.03402679}, {1960,0.03318750}, {1970,0.03405357}, {1980,0.03419643}, {1990,0.03466964}, {2000,0.03409821}, {2050,0.03443750}, {2100,0.03800893}, {2150,0.03675000}, {2200,0.03722321}, {2250,0.03818750}, {2300,0.03933036}, {2350,0.04008036}, {2400,0.04321429}, {2450,0.04203571}, {2500,0.04258929}, {2550,0.04500893}, {2600,0.04390179}, {2650,0.04540179}, {2700,0.04972321}, {2750,0.04821429}, {2800,0.04860714}, {2850,0.04875000}, {2900,0.04974107}, {2950,0.05088393}, {3000,0.05200000}, {3050,0.05307143}, {3100,0.05284821}, {3150,0.05408929}, {3200,0.05428571}, {3250,0.05966071}, {3300,0.05740179}, {3350,0.05809821}, {3400,0.05873214}, {3450,0.06472321}, {3500,0.06171429}, {3550,0.06342857}, {3600,0.06515179}, {3650,0.06324107}, {3700,0.06507143}, {3750,0.06552679}, {3800,0.06655357}, {3850,0.06657143}, {3900,0.06823214}, {3950,0.07007143}, {4000,0.06991071}, {4050,0.07203571}, {4100,0.07355357}, {4150,0.07190179}, {4200,0.07263393}, {4250,0.07437500}, {4300,0.07515179}, {4350,0.08151786}, {4400,0.07620536}, {4450,0.07730357}, {4500,0.08535714}, {4550,0.08024107}, {4600,0.08225000}, {4650,0.08062500}, {4700,0.08707143}, {4750,0.08930357}, {4800,0.08992857}, {4850,0.09085714}, {4900,0.08985714}, {4950,0.08785714}, {5000,0.08756250}, {5050,0.09043750}, {5100,0.09798214}, {5150,0.08933036}, {5200,0.09000893}, {5250,0.09566964}, {5300,0.09367857}, {5350,0.09535714}, {5400,0.09479464}, {5450,0.09628571}, {5500,0.10464286}, {5550,0.10914286}, {5600,0.10009821}, {5650,0.09866964}, {5700,0.09993750}, {5750,0.10265179}, {5800,0.10308929}, {5850,0.10516964}, {5900,0.10451786}, {5950,0.11341964}, {6000,0.11449107}, {6050,0.10894643}, {6100,0.11137500}, {6150,0.12218750}, {6200,0.10853571}, {6250,0.12246429}, {6300,0.11108036}, {6350,0.11390179}, {6400,0.12108036}, {6450,0.11425000}, {6500,0.11594643}, {6550,0.12328571}, {6600,0.13422321}, {6650,0.13708036}, {6700,0.13516964}, {6750,0.13102679}, {6800,0.12507143}, {6850,0.13134821}, {6900,0.12656250}, {6950,0.12574107}, {7000,0.12766964}, {7050,0.14421429}, {7100,0.13184821}, {7150,0.14049107}, {7200,0.12727679}, {7250,0.13643750}, {7300,0.13058036}, {7350,0.14128571}, {7400,0.13556250}, {7450,0.13520536}, {7500,0.13782143}, {7550,0.14699107}, {7600,0.14888393}, {7650,0.14596429}, {7700,0.14331250}, {7750,0.15345536}, {7800,0.14631250}, {7850,0.14608036}, {7900,0.14933036}, {7950,0.15560714}, {8000,0.14917857}, {8050,0.15225893}, {8100,0.16058929}, {8150,0.15750000}, {8200,0.15154464}, {8250,0.15132143}, {8300,0.16911607}, {8350,0.16317857}, {8400,0.15308929}, {8450,0.15145536}, {8500,0.15714286}, {8550,0.16455357}, {8600,0.16233929}, {8650,0.16524107}, {8700,0.17293750}, {8750,0.16498214}, {8800,0.15990179}, {8850,0.16320536}, {8900,0.17343750}, {8950,0.17286607}, {9000,0.16675000}, {9050,0.17943750}, {9100,0.17050893}, {9150,0.18463393}, {9200,0.17498214}, {9250,0.16868750}, {9300,0.17800893}, {9350,0.17258036}, {9400,0.17633929}, {9450,0.18007143}, {9500,0.18896429}, {9550,0.18894643}, {9600,0.18052679}, {9650,0.19031250}, {9700,0.18462500}, {9750,0.18256250}, {9800,0.19046429}, {9850,0.19943750}, {9900,0.18862500}, {9950,0.19535714}, {10000,0.19018750}, {10100,0.19571429}, {10200,0.20407143}, {10300,0.20016964}, {10400,0.18939286}, {10500,0.19176786}, {10600,0.20013393}, {10700,0.20438393}, {10800,0.20548214}, {10900,0.20814286}, {11000,0.21279464}, {11100,0.22187500}, {11200,0.20888393}, {11300,0.20804464}, {11400,0.21078571}, {11500,0.22628571}, {11600,0.22309821}, {11700,0.22632143}, {11800,0.23312500}, {11900,0.24065179}, {12000,0.22877679}, {12100,0.23757143}, {12200,0.24812500}, {12300,0.22376786}, {12400,0.22851786}, {12500,0.23433036}, {12600,0.24550}, {12700,0.24950}, {12800,0.23650}, {12900,0.23650}, {13000,0.24625}, {13100,0.28850}, {13200,0.24350}, {13300,0.26425}, {13400,0.25175}, {13500,0.26175}, {13600,0.25400}, {13700,0.25350}, {13800,0.27525}, {13900,0.27000}, {14000,0.29450}, {14100,0.26600}, {14200,0.28150}, {14300,0.29325}, {14400,0.26900}, {14500,0.28425}, {14600,0.27150}, {14700,0.29625}, {14800,0.31350}, {14900,0.28250}, {15000,0.29000}, {15100,0.31800}, {15200,0.30025}, {15300,0.29675}, {15400,0.29975}, {15500,0.31575}, {15600,0.32350}, {15700,0.31275}, {15800,0.33075}, {15900,0.31675}, {16000,0.31675}, {16100,0.33250}, {16200,0.32225}, {16300,1.35250}, {16400,0.30450}, {16500,0.33075}, {16600,0.32450}, {16700,0.32525}, {16800,0.33725}, {16900,0.31325}, {17000,0.33750}, {17100,0.35350}, {17200,0.34975}, {17300,0.35075}, {17400,0.36850}, {17500,0.35450}, {17600,0.35175}, {17700,0.35550}, {17800,0.35775}, {17900,0.36625}, {18000,0.36800}, {18100,0.37500}, {18200,0.36775}, {18300,0.39075}, {18400,0.39650}, {18500,0.35625}, {18600,0.38150}, {18700,0.36725}, {18800,0.40025}, {18900,0.38650}, {19000,0.36825}, {19100,0.38525}, {19200,0.36875}, {19300,0.39100}, {19400,0.38925}, {19500,0.41650}, {19600,0.38150}, {19700,0.42725}, {19800,0.39350}, {19900,0.40625}, {20000,0.3855}};
data["big_flat"]["cbn Denote"]["Stats"]["system"] = {{1,0.00003540}, {2,0.00003540}, {3,0.00000000}, {4,0.00003540}, {5,0.00000000}, {6,0.00003540}, {7,0.00000000}, {8,0.00003540}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00002655}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00007080}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00003540}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00007080}, {37,0.00003540}, {38,0.00000000}, {39,0.00000000}, {40,0.00003540}, {41,0.00000000}, {42,0.00003540}, {43,0.00003540}, {44,0.00000000}, {45,0.00003540}, {46,0.00003540}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00002655}, {51,0.00000000}, {52,0.00000000}, {53,0.00003540}, {54,0.00000000}, {55,0.00000000}, {56,0.00007080}, {57,0.00000000}, {58,0.00003540}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00003540}, {69,0.00003540}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00007080}, {77,0.00003540}, {78,0.00000000}, {79,0.00000000}, {80,0.00003540}, {81,0.00000000}, {82,0.00003540}, {83,0.00000000}, {84,0.00000000}, {85,0.00003540}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00003540}, {90,0.00003540}, {91,0.00000000}, {92,0.00000000}, {93,0.00007080}, {94,0.00003540}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00003540}, {101,0.00000000}, {102,0.00003540}, {103,0.00000000}, {104,0.00000000}, {105,0.00002655}, {106,0.00000000}, {107,0.00010619}, {108,0.00003540}, {109,0.00002655}, {110,0.00003540}, {111,0.00000000}, {112,0.00006195}, {113,0.00000000}, {114,0.00000000}, {115,0.00003540}, {116,0.00006195}, {117,0.00000000}, {118,0.00000000}, {119,0.00003540}, {120,0.00000000}, {121,0.00000000}, {122,0.00003540}, {123,0.00000000}, {124,0.00003540}, {125,0.00007080}, {126,0.00003540}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00003540}, {133,0.00002655}, {134,0.00000000}, {135,0.00003540}, {136,0.00000000}, {137,0.00007080}, {138,0.00003540}, {139,0.00003540}, {140,0.00003540}, {141,0.00003540}, {142,0.00000000}, {143,0.00003540}, {144,0.00003540}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00003540}, {149,0.00000000}, {150,0.00003540}, {151,0.00003540}, {152,0.00003540}, {153,0.00003540}, {154,0.00000000}, {155,0.00003540}, {156,0.00000000}, {157,0.00003540}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00003540}, {162,0.00000000}, {163,0.00000000}, {164,0.00003540}, {165,0.00003540}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00003540}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00002655}, {178,0.00007080}, {179,0.00003540}, {180,0.00003540}, {181,0.00010619}, {182,0.00000000}, {183,0.00007080}, {184,0.00007080}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00002655}, {189,0.00000000}, {190,0.00003540}, {191,0.00003540}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00003540}, {198,0.00000000}, {199,0.00003540}, {200,0.00000000}, {201,0.00003540}, {202,0.00000000}, {203,0.00003540}, {204,0.00000000}, {205,0.00003540}, {206,0.00000000}, {207,0.00003540}, {208,0.00003540}, {209,0.00003540}, {210,0.00000000}, {211,0.00002655}, {212,0.00003540}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00003540}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00003540}, {221,0.00007080}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00008850}, {226,0.00003540}, {227,0.00000000}, {228,0.00002655}, {229,0.00003540}, {230,0.00003540}, {231,0.00003540}, {232,0.00000000}, {233,0.00003540}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00003540}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00002655}, {245,0.00007080}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00003540}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00003540}, {259,0.00003540}, {260,0.00000000}, {261,0.00003540}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003540}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00003540}, {275,0.00003540}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003540}, {282,0.00000000}, {283,0.00003540}, {284,0.00000000}, {285,0.00007080}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00010619}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00003540}, {300,0.00000000}, {301,0.00003540}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00003540}, {307,0.00003540}, {308,0.00003540}, {309,0.00000000}, {310,0.00003540}, {311,0.00003540}, {312,0.00000000}, {313,0.00006195}, {314,0.00003540}, {315,0.00007080}, {316,0.00003540}, {317,0.00003540}, {318,0.00000000}, {319,0.00000000}, {320,0.00007080}, {321,0.00003540}, {322,0.00003540}, {323,0.00003540}, {324,0.00000000}, {325,0.00000000}, {326,0.00007080}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00003540}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00003540}, {336,0.00000000}, {337,0.00003540}, {338,0.00000000}, {339,0.00003540}, {340,0.00000000}, {341,0.00000000}, {342,0.00003540}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00006195}, {348,0.00000000}, {349,0.00003540}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00003540}, {354,0.00000000}, {355,0.00003540}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00010619}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00003540}, {364,0.00000000}, {365,0.00003540}, {366,0.00000000}, {367,0.00000000}, {368,0.00003540}, {369,0.00000000}, {370,0.00000000}, {371,0.00003540}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00003540}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00003540}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00003540}, {389,0.00000000}, {390,0.00003540}, {391,0.00003540}, {392,0.00002655}, {393,0.00000000}, {394,0.00000000}, {395,0.00003540}, {396,0.00000000}, {397,0.00003540}, {398,0.00003540}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00007080}, {405,0.00000000}, {406,0.00000000}, {407,0.00003540}, {408,0.00006195}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00003540}, {413,0.00000000}, {414,0.00000000}, {415,0.00003540}, {416,0.00003540}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00003540}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00002655}, {434,0.00000000}, {435,0.00000000}, {436,0.00003540}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00009735}, {442,0.00000000}, {443,0.00003540}, {444,0.00003540}, {445,0.00002655}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00002655}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00003540}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00003540}, {483,0.00000000}, {484,0.00003540}, {485,0.00000000}, {486,0.00003540}, {487,0.00000000}, {488,0.00002655}, {489,0.00006195}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00003540}, {498,0.00000000}, {499,0.00000000}, {500,0.00003540}, {505,0.00003540}, {510,0.00002655}, {515,0.00000000}, {520,0.00003540}, {525,0.00003540}, {530,0.00000000}, {535,0.00003540}, {540,0.00000000}, {545,0.00000000}, {550,0.00003540}, {555,0.00003540}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00003540}, {580,0.00000000}, {585,0.00000000}, {590,0.00003540}, {595,0.00003540}, {600,0.00003540}, {605,0.00000000}, {610,0.00000000}, {615,0.00006195}, {620,0.00000000}, {625,0.00000000}, {630,0.00003540}, {635,0.00000000}, {640,0.00000000}, {645,0.00006195}, {650,0.00000000}, {655,0.00000000}, {660,0.00008850}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00003540}, {700,0.00003540}, {705,0.00003540}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00003540}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00003571}, {805,0.00000000}, {810,0.00000000}, {815,0.00010714}, {820,0.00000000}, {825,0.00006250}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00003571}, {850,0.00003571}, {855,0.00000000}, {860,0.00000000}, {865,0.00007143}, {870,0.00000000}, {875,0.00000000}, {880,0.00007143}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00003571}, {950,0.00003571}, {955,0.00003571}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00003571}, {980,0.00003571}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00009821}, {1010,0.00003571}, {1020,0.00014286}, {1030,0.00000000}, {1040,0.00003571}, {1050,0.00000000}, {1060,0.00003571}, {1070,0.00002679}, {1080,0.00003571}, {1090,0.00003571}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00010714}, {1180,0.00003571}, {1190,0.00003571}, {1200,0.00000000}, {1210,0.00003571}, {1220,0.00000000}, {1230,0.00003571}, {1240,0.00000000}, {1250,0.00003571}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00002679}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00006250}, {1380,0.00003571}, {1390,0.00003571}, {1400,0.00003571}, {1410,0.00000000}, {1420,0.00007143}, {1430,0.00006250}, {1440,0.00002679}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00003571}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00003571}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00003571}, {1570,0.00003571}, {1580,0.00003571}, {1590,0.00000000}, {1600,0.00003571}, {1610,0.00006250}, {1620,0.00003571}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003571}, {1670,0.00003571}, {1680,0.00000000}, {1690,0.00003571}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00002679}, {1770,0.00007143}, {1780,0.00007143}, {1790,0.00003571}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00009821}, {1930,0.00000000}, {1940,0.00009821}, {1950,0.00000000}, {1960,0.00007143}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00003571}, {2000,0.00003571}, {2050,0.00000000}, {2100,0.00016964}, {2150,0.00003571}, {2200,0.00000000}, {2250,0.00007143}, {2300,0.00003571}, {2350,0.00002679}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00003571}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00002679}, {2850,0.00007143}, {2900,0.00003571}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00003571}, {3250,0.00014286}, {3300,0.00003571}, {3350,0.00000000}, {3400,0.00003571}, {3450,0.00016964}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00014286}, {3650,0.00006250}, {3700,0.00000000}, {3750,0.00003571}, {3800,0.00000000}, {3850,0.00007143}, {3900,0.00007143}, {3950,0.00003571}, {4000,0.00000000}, {4050,0.00003571}, {4100,0.00010714}, {4150,0.00000000}, {4200,0.00003571}, {4250,0.00007143}, {4300,0.00000000}, {4350,0.00008929}, {4400,0.00003571}, {4450,0.00007143}, {4500,0.00003571}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00003571}, {4700,0.00010714}, {4750,0.00003571}, {4800,0.00007143}, {4850,0.00031250}, {4900,0.00021429}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00017857}, {5150,0.00003571}, {5200,0.00002679}, {5250,0.00010714}, {5300,0.00000000}, {5350,0.00007143}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00028571}, {5550,0.00021429}, {5600,0.00003571}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00013393}, {5800,0.00009821}, {5850,0.00003571}, {5900,0.00000000}, {5950,0.00014286}, {6000,0.00016964}, {6050,0.00003571}, {6100,0.00007143}, {6150,0.00016964}, {6200,0.00003571}, {6250,0.00027679}, {6300,0.00003571}, {6350,0.00000000}, {6400,0.00003571}, {6450,0.00003571}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00010714}, {6650,0.00000000}, {6700,0.00028571}, {6750,0.00010714}, {6800,0.00017857}, {6850,0.00021429}, {6900,0.00002679}, {6950,0.00003571}, {7000,0.00000000}, {7050,0.00050000}, {7100,0.00000000}, {7150,0.00017857}, {7200,0.00003571}, {7250,0.00020536}, {7300,0.00006250}, {7350,0.00020536}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00021429}, {7600,0.00017857}, {7650,0.00014286}, {7700,0.00010714}, {7750,0.00016964}, {7800,0.00006250}, {7850,0.00003571}, {7900,0.00003571}, {7950,0.00003571}, {8000,0.00010714}, {8050,0.00003571}, {8100,0.00007143}, {8150,0.00000000}, {8200,0.00013393}, {8250,0.00007143}, {8300,0.00039286}, {8350,0.00021429}, {8400,0.00000000}, {8450,0.00007143}, {8500,0.00003571}, {8550,0.00009821}, {8600,0.00003571}, {8650,0.00010714}, {8700,0.00014286}, {8750,0.00003571}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00024107}, {8950,0.00003571}, {9000,0.00003571}, {9050,0.00007143}, {9100,0.00000000}, {9150,0.00017857}, {9200,0.00000000}, {9250,0.00003571}, {9300,0.00020536}, {9350,0.00002679}, {9400,0.00003571}, {9450,0.00000000}, {9500,0.00006250}, {9550,0.00003571}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00003571}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00003571}, {9950,0.00006250}, {10000,0.00003571}, {10100,0.00003571}, {10200,0.00003571}, {10300,0.00000000}, {10400,0.00007143}, {10500,0.00003571}, {10600,0.00009821}, {10700,0.00000000}, {10800,0.00003571}, {10900,0.00007143}, {11000,0.00000000}, {11100,0.00003571}, {11200,0.00003571}, {11300,0.00003571}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00003571}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00007143}, {12000,0.00000000}, {12100,0.00002679}, {12200,0.00000000}, {12300,0.00003571}, {12400,0.00000000}, {12500,0.00007143}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00200}, {13200,0.00000}, {13300,0.00100}, {13400,0.00100}, {13500,0.00100}, {13600,0.00100}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00100}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00100}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00200}, {16400,0.00000}, {16500,0.00100}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00100}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00100}, {18600,0.00000}, {18700,0.00100}, {18800,0.00100}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["cbv Denote"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00485841}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000885}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00001770}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000885}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00001770}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00003540}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00002655}, {570,0.00000885}, {575,0.00000000}, {580,0.00000885}, {585,0.00001770}, {590,0.00000885}, {595,0.00001770}, {600,0.00001770}, {605,0.00002655}, {610,0.00005310}, {615,0.00011504}, {620,0.00025664}, {625,0.00030088}, {630,0.00050442}, {635,0.00065487}, {640,0.00068142}, {645,0.00075221}, {650,0.00076991}, {655,0.00077876}, {660,0.00079646}, {665,0.00081416}, {670,0.00084071}, {675,0.00085841}, {680,0.00091150}, {685,0.00092035}, {690,0.00099115}, {695,0.00100000}, {700,0.00100000}, {705,0.00100000}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00100000}, {730,0.00100000}, {735,0.00100000}, {740,0.00100000}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100000}, {790,0.00100000}, {795,0.00100000}, {800,0.00100000}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00100000}, {830,0.00100000}, {835,0.00100000}, {840,0.00100000}, {845,0.00100000}, {850,0.00100000}, {855,0.00100000}, {860,0.00100000}, {865,0.00100000}, {870,0.00100000}, {875,0.00100000}, {880,0.00100000}, {885,0.00286607}, {890,0.00100000}, {895,0.00100000}, {900,0.00100000}, {905,0.00100000}, {910,0.00100000}, {915,0.00100000}, {920,0.00100000}, {925,0.00100000}, {930,0.00100000}, {935,0.00100000}, {940,0.00100000}, {945,0.00100000}, {950,0.00100000}, {955,0.00100000}, {960,0.00100000}, {965,0.00100000}, {970,0.00100000}, {975,0.00100000}, {980,0.00100000}, {985,0.00100000}, {990,0.00100000}, {995,0.00100000}, {1000,0.00100000}, {1010,0.00100000}, {1020,0.00100000}, {1030,0.00100000}, {1040,0.00100000}, {1050,0.00100893}, {1060,0.00100893}, {1070,0.00108929}, {1080,0.00102679}, {1090,0.00106250}, {1100,0.00107143}, {1110,0.00108929}, {1120,0.00107143}, {1130,0.00116964}, {1140,0.00116964}, {1150,0.00126786}, {1160,0.00132143}, {1170,0.00133036}, {1180,0.00143750}, {1190,0.00151786}, {1200,0.00148214}, {1210,0.00427679}, {1220,0.00165179}, {1230,0.00171429}, {1240,0.00172321}, {1250,0.00177679}, {1260,0.00180357}, {1270,0.00180357}, {1280,0.00183929}, {1290,0.00188393}, {1300,0.00188393}, {1310,0.00191964}, {1320,0.00196429}, {1330,0.00197321}, {1340,0.00199107}, {1350,0.00200000}, {1360,0.00199107}, {1370,0.00200000}, {1380,0.00200000}, {1390,0.00200000}, {1400,0.00200000}, {1410,0.00200000}, {1420,0.00200000}, {1430,0.00200000}, {1440,0.00200000}, {1450,0.00200000}, {1460,0.00200000}, {1470,0.00200000}, {1480,0.00200893}, {1490,0.00200000}, {1500,0.00200000}, {1510,0.00200000}, {1520,0.00200000}, {1530,0.00200893}, {1540,0.00200000}, {1550,0.00200000}, {1560,0.00205357}, {1570,0.00203571}, {1580,0.00208929}, {1590,0.00212500}, {1600,0.00216964}, {1610,0.00212500}, {1620,0.00223214}, {1630,0.00234821}, {1640,0.00226786}, {1650,0.00250893}, {1660,0.00258036}, {1670,0.00265179}, {1680,0.00263393}, {1690,0.00271429}, {1700,0.00270536}, {1710,0.00268750}, {1720,0.00271429}, {1730,0.00273214}, {1740,0.00273214}, {1750,0.00276786}, {1760,0.00277679}, {1770,0.00279464}, {1780,0.00276786}, {1790,0.00568750}, {1800,0.00280357}, {1810,0.00289286}, {1820,0.00287500}, {1830,0.00295536}, {1840,0.00293750}, {1850,0.00297321}, {1860,0.00299107}, {1870,0.00305357}, {1880,0.00299107}, {1890,0.00299107}, {1900,0.00300000}, {1910,0.00299107}, {1920,0.00300000}, {1930,0.00299107}, {1940,0.00300000}, {1950,0.00305357}, {1960,0.00300893}, {1970,0.00300893}, {1980,0.00302679}, {1990,0.00302679}, {2000,0.00302679}, {2050,0.00318750}, {2100,0.00355357}, {2150,0.00362500}, {2200,0.00374107}, {2250,0.00374107}, {2300,0.00667857}, {2350,0.00391964}, {2400,0.00404464}, {2450,0.00408036}, {2500,0.00775893}, {2550,0.00459821}, {2600,0.00477679}, {2650,0.00855357}, {2700,0.00475000}, {2750,0.00478571}, {2800,0.00488393}, {2850,0.00503571}, {2900,0.00519643}, {2950,0.00543750}, {3000,0.00570536}, {3050,0.00575893}, {3100,0.00575893}, {3150,0.00575893}, {3200,0.00580357}, {3250,0.00586607}, {3300,0.00578571}, {3350,0.00621429}, {3400,0.00612500}, {3450,0.00670536}, {3500,0.00674107}, {3550,0.00940179}, {3600,0.00675893}, {3650,0.00682143}, {3700,0.00681250}, {3750,0.00677679}, {3800,0.00693750}, {3850,0.00706250}, {3900,0.00723214}, {3950,0.00747321}, {4000,0.00775893}, {4050,0.00783929}, {4100,0.00782143}, {4150,0.00777679}, {4200,0.00814286}, {4250,0.00842857}, {4300,0.00804464}, {4350,0.00868750}, {4400,0.00852679}, {4450,0.01477679}, {4500,0.00880357}, {4550,0.00873214}, {4600,0.00876786}, {4650,0.00921429}, {4700,0.00942857}, {4750,0.00964286}, {4800,0.00966964}, {4850,0.00974107}, {4900,0.00975893}, {4950,0.00983929}, {5000,0.00968750}, {5050,0.00971429}, {5100,0.01018750}, {5150,0.01043750}, {5200,0.00998214}, {5250,0.01053571}, {5300,0.01028571}, {5350,0.01063393}, {5400,0.01054464}, {5450,0.01054464}, {5500,0.01113393}, {5550,0.01108036}, {5600,0.01082143}, {5650,0.01100893}, {5700,0.01099107}, {5750,0.01127679}, {5800,0.01146429}, {5850,0.01149107}, {5900,0.01156250}, {5950,0.01157143}, {6000,0.01225893}, {6050,0.02136607}, {6100,0.01204464}, {6150,0.01249107}, {6200,0.01229464}, {6250,0.01264286}, {6300,0.01244643}, {6350,0.01273214}, {6400,0.01250893}, {6450,0.01250893}, {6500,0.01330357}, {6550,0.01335714}, {6600,0.01307143}, {6650,0.01304464}, {6700,0.01336607}, {6750,0.01339286}, {6800,0.01341071}, {6850,0.01352679}, {6900,0.01411607}, {6950,0.02428571}, {7000,0.01358929}, {7050,0.01388393}, {7100,0.02591071}, {7150,0.01422321}, {7200,0.01443750}, {7250,0.01438393}, {7300,0.02963393}, {7350,0.01445536}, {7400,0.01445536}, {7450,0.02136607}, {7500,0.01535714}, {7550,0.01476786}, {7600,0.01525893}, {7650,0.01510714}, {7700,0.01533929}, {7750,0.01534821}, {7800,0.01548214}, {7850,0.01610714}, {7900,0.01552679}, {7950,0.01580357}, {8000,0.01575000}, {8050,0.02395536}, {8100,0.01621429}, {8150,0.04480357}, {8200,0.01647321}, {8250,0.02748214}, {8300,0.01649107}, {8350,0.01650893}, {8400,0.01656250}, {8450,0.01733036}, {8500,0.01680357}, {8550,0.01692857}, {8600,0.01716964}, {8650,0.01725893}, {8700,0.01727679}, {8750,0.01738393}, {8800,0.03546429}, {8850,0.01778571}, {8900,0.01751786}, {8950,0.01750000}, {9000,0.02386607}, {9050,0.01795536}, {9100,0.04398214}, {9150,0.01793750}, {9200,0.04653571}, {9250,0.01827679}, {9300,0.01820536}, {9350,0.01882143}, {9400,0.01890179}, {9450,0.01878571}, {9500,0.01865179}, {9550,0.01886607}, {9600,0.01900893}, {9650,0.01893750}, {9700,0.01900000}, {9750,0.01903571}, {9800,0.04988393}, {9850,0.01910714}, {9900,0.01920536}, {9950,0.03725893}, {10000,0.01947321}, {10100,0.01985714}, {10200,0.02030357}, {10300,0.02008929}, {10400,0.02023214}, {10500,0.02040179}, {10600,0.02077679}, {10700,0.02082143}, {10800,0.03849107}, {10900,0.02125893}, {11000,0.02135714}, {11100,0.02166964}, {11200,0.03360714}, {11300,0.02189286}, {11400,0.02260714}, {11500,0.02243750}, {11600,0.02274107}, {11700,0.02328571}, {11800,0.04651786}, {11900,0.02317857}, {12000,0.02383036}, {12100,0.02364286}, {12200,0.04490179}, {12300,0.02449107}, {12400,0.02408036}, {12500,0.02440179}, {12600,0.04600}, {12700,0.03025}, {12800,0.02600}, {12900,0.02575}, {13000,0.02625}, {13100,0.02675}, {13200,0.02625}, {13300,0.02675}, {13400,0.02675}, {13500,0.02775}, {13600,0.02775}, {13700,0.02775}, {13800,0.04625}, {13900,0.02725}, {14000,0.03275}, {14100,0.02875}, {14200,0.02875}, {14300,0.03475}, {14400,0.05075}, {14500,0.03725}, {14600,0.02875}, {14700,0.02875}, {14800,0.03325}, {14900,0.02950}, {15000,0.04250}, {15100,0.02950}, {15200,0.03000}, {15300,0.03000}, {15400,0.03000}, {15500,0.03050}, {15600,0.04175}, {15700,0.04275}, {15800,0.03200}, {15900,0.03950}, {16000,0.04300}, {16100,0.03300}, {16200,0.04575}, {16300,0.04350}, {16400,0.04375}, {16500,0.03325}, {16600,0.03900}, {16700,0.03375}, {16800,0.03425}, {16900,0.03450}, {17000,0.04275}, {17100,0.03325}, {17200,0.03400}, {17300,0.03350}, {17400,0.03375}, {17500,0.04475}, {17600,0.03500}, {17700,0.03425}, {17800,0.03500}, {17900,0.04250}, {18000,0.04475}, {18100,0.04350}, {18200,0.04375}, {18300,0.04350}, {18400,0.04575}, {18500,0.04475}, {18600,0.03825}, {18700,0.06000}, {18800,0.03825}, {18900,0.04400}, {19000,0.04325}, {19100,0.05675}, {19200,0.05200}, {19300,0.05050}, {19400,0.04700}, {19500,0.03850}, {19600,0.05200}, {19700,0.03850}, {19800,0.04550}, {19900,0.06125}, {20000,0.0410}};
data["big_flat"]["cbv Denote"]["Stats"]["user"] = {{1,0.00000000}, {2,0.00008850}, {3,0.00005310}, {4,0.00006195}, {5,0.00006195}, {6,0.00007965}, {7,0.00002655}, {8,0.00002655}, {9,0.00003540}, {10,0.00005310}, {11,0.00007080}, {12,0.00008850}, {13,0.00003540}, {14,0.00002655}, {15,0.00003540}, {16,0.00008850}, {17,0.00020354}, {18,0.00000000}, {19,0.00010619}, {20,0.00005310}, {21,0.00003540}, {22,0.00000000}, {23,0.00000000}, {24,0.00005310}, {25,0.00012389}, {26,0.00005310}, {27,0.00008850}, {28,0.00003540}, {29,0.00008850}, {30,0.00018584}, {31,0.00012389}, {32,0.00015044}, {33,0.00015044}, {34,0.00000000}, {35,0.00005310}, {36,0.00006195}, {37,0.00018584}, {38,0.00434513}, {39,0.00008850}, {40,0.00005310}, {41,0.00006195}, {42,0.00011504}, {43,0.00008850}, {44,0.00006195}, {45,0.00011504}, {46,0.00009735}, {47,0.00014159}, {48,0.00010619}, {49,0.00021239}, {50,0.00006195}, {51,0.00002655}, {52,0.00019469}, {53,0.00014159}, {54,0.00005310}, {55,0.00006195}, {56,0.00023894}, {57,0.00011504}, {58,0.00015929}, {59,0.00002655}, {60,0.00013274}, {61,0.00000000}, {62,0.00015044}, {63,0.00014159}, {64,0.00026549}, {65,0.00011504}, {66,0.00009735}, {67,0.00008850}, {68,0.00007965}, {69,0.00012389}, {70,0.00007965}, {71,0.00017699}, {72,0.00011504}, {73,0.00016814}, {74,0.00008850}, {75,0.00013274}, {76,0.00005310}, {77,0.00003540}, {78,0.00020354}, {79,0.00022124}, {80,0.00025664}, {81,0.00014159}, {82,0.00008850}, {83,0.00007965}, {84,0.00015044}, {85,0.00013274}, {86,0.00017699}, {87,0.00010619}, {88,0.00015929}, {89,0.00017699}, {90,0.00014159}, {91,0.00018584}, {92,0.00029204}, {93,0.00014159}, {94,0.00011504}, {95,0.00008850}, {96,0.00019469}, {97,0.00025664}, {98,0.00022124}, {99,0.00006195}, {100,0.00017699}, {101,0.00022124}, {102,0.00025664}, {103,0.00021239}, {104,0.00014159}, {105,0.00010619}, {106,0.00018584}, {107,0.00016814}, {108,0.00010619}, {109,0.00014159}, {110,0.00025664}, {111,0.00019469}, {112,0.00013274}, {113,0.00016814}, {114,0.00013274}, {115,0.00016814}, {116,0.00021239}, {117,0.00020354}, {118,0.00014159}, {119,0.00019469}, {120,0.00028319}, {121,0.00005310}, {122,0.00029204}, {123,0.00011504}, {124,0.00017699}, {125,0.00016814}, {126,0.00021239}, {127,0.00011504}, {128,0.00017699}, {129,0.00023894}, {130,0.00025664}, {131,0.00025664}, {132,0.00016814}, {133,0.00020354}, {134,0.00015044}, {135,0.00021239}, {136,0.00025664}, {137,0.00016814}, {138,0.00009735}, {139,0.00010619}, {140,0.00014159}, {141,0.00026549}, {142,0.00023009}, {143,0.00017699}, {144,0.00015929}, {145,0.00038938}, {146,0.00023009}, {147,0.00011504}, {148,0.00019469}, {149,0.00017699}, {150,0.00028319}, {151,0.00011504}, {152,0.00012389}, {153,0.00021239}, {154,0.00019469}, {155,0.00021239}, {156,0.00023009}, {157,0.00024779}, {158,0.00033628}, {159,0.00017699}, {160,0.00030088}, {161,0.00034513}, {162,0.00022124}, {163,0.00021239}, {164,0.00020354}, {165,0.00023009}, {166,0.00023009}, {167,0.00040708}, {168,0.00015044}, {169,0.00017699}, {170,0.00030973}, {171,0.00016814}, {172,0.00013274}, {173,0.00030088}, {174,0.00029204}, {175,0.00022124}, {176,0.00014159}, {177,0.00016814}, {178,0.00025664}, {179,0.00025664}, {180,0.00038938}, {181,0.00012389}, {182,0.00035398}, {183,0.00020354}, {184,0.00036283}, {185,0.00025664}, {186,0.00010619}, {187,0.00036283}, {188,0.00013274}, {189,0.00032743}, {190,0.00030088}, {191,0.00025664}, {192,0.00022124}, {193,0.00028319}, {194,0.00034513}, {195,0.00029204}, {196,0.00027434}, {197,0.00024779}, {198,0.00033628}, {199,0.00038053}, {200,0.00023894}, {201,0.00031858}, {202,0.00035398}, {203,0.00040708}, {204,0.00024779}, {205,0.00016814}, {206,0.00022124}, {207,0.00031858}, {208,0.00030088}, {209,0.00043363}, {210,0.00033628}, {211,0.00029204}, {212,0.00044248}, {213,0.00047788}, {214,0.00030973}, {215,0.00022124}, {216,0.00010619}, {217,0.00015044}, {218,0.00033628}, {219,0.00024779}, {220,0.00046018}, {221,0.00024779}, {222,0.00029204}, {223,0.00046903}, {224,0.00058407}, {225,0.00044248}, {226,0.00036283}, {227,0.00039823}, {228,0.00023894}, {229,0.00031858}, {230,0.00036283}, {231,0.00017699}, {232,0.00047788}, {233,0.00021239}, {234,0.00028319}, {235,0.00044248}, {236,0.00049558}, {237,0.00023009}, {238,0.00007965}, {239,0.00026549}, {240,0.00029204}, {241,0.00053982}, {242,0.00030973}, {243,0.00019469}, {244,0.00018584}, {245,0.00021239}, {246,0.00032743}, {247,0.00022124}, {248,0.00027434}, {249,0.00020354}, {250,0.00027434}, {251,0.00036283}, {252,0.00049558}, {253,0.00039823}, {254,0.00043363}, {255,0.00051327}, {256,0.00034513}, {257,0.00026549}, {258,0.00034513}, {259,0.00033628}, {260,0.00049558}, {261,0.00050442}, {262,0.00042478}, {263,0.00037168}, {264,0.00055752}, {265,0.00024779}, {266,0.00038053}, {267,0.00041593}, {268,0.00030088}, {269,0.00035398}, {270,0.00028319}, {271,0.00035398}, {272,0.00054867}, {273,0.00042478}, {274,0.00038938}, {275,0.00025664}, {276,0.00038053}, {277,0.00033628}, {278,0.00040708}, {279,0.00041593}, {280,0.00042478}, {281,0.00035398}, {282,0.00041593}, {283,0.00039823}, {284,0.00015929}, {285,0.00044248}, {286,0.00039823}, {287,0.00045133}, {288,0.00029204}, {289,0.00029204}, {290,0.00042478}, {291,0.00039823}, {292,0.00030973}, {293,0.00053097}, {294,0.00042478}, {295,0.00035398}, {296,0.00038938}, {297,0.00037168}, {298,0.00036283}, {299,0.00048673}, {300,0.00046018}, {301,0.00034513}, {302,0.00045133}, {303,0.00037168}, {304,0.00048673}, {305,0.00044248}, {306,0.00038053}, {307,0.00042478}, {308,0.00054867}, {309,0.00025664}, {310,0.00043363}, {311,0.00074336}, {312,0.00049558}, {313,0.00035398}, {314,0.00051327}, {315,0.00042478}, {316,0.00037168}, {317,0.00053097}, {318,0.00039823}, {319,0.00053097}, {320,0.00049558}, {321,0.00021239}, {322,0.00024779}, {323,0.00046018}, {324,0.00041593}, {325,0.00059292}, {326,0.00009735}, {327,0.00058407}, {328,0.00030088}, {329,0.00049558}, {330,0.00032743}, {331,0.00046018}, {332,0.00057522}, {333,0.00051327}, {334,0.00034513}, {335,0.00080531}, {336,0.00046903}, {337,0.00046018}, {338,0.00039823}, {339,0.00069027}, {340,0.00061062}, {341,0.00052212}, {342,0.00051327}, {343,0.00038053}, {344,0.00060177}, {345,0.00057522}, {346,0.00058407}, {347,0.00066372}, {348,0.00076106}, {349,0.00066372}, {350,0.00048673}, {351,0.00042478}, {352,0.00055752}, {353,0.00034513}, {354,0.00038938}, {355,0.00039823}, {356,0.00056637}, {357,0.00052212}, {358,0.00055752}, {359,0.00038938}, {360,0.00038053}, {361,0.00048673}, {362,0.00054867}, {363,0.00060177}, {364,0.00046903}, {365,0.00063717}, {366,0.00047788}, {367,0.00024779}, {368,0.00044248}, {369,0.00056637}, {370,0.00054867}, {371,0.00070796}, {372,0.00037168}, {373,0.00061062}, {374,0.00053097}, {375,0.00068142}, {376,0.00038938}, {377,0.00076106}, {378,0.00053982}, {379,0.00067257}, {380,0.00076106}, {381,0.00065487}, {382,0.00056637}, {383,0.00045133}, {384,0.00062832}, {385,0.00051327}, {386,0.00060177}, {387,0.00075221}, {388,0.00045133}, {389,0.00053982}, {390,0.00080531}, {391,0.00055752}, {392,0.00043363}, {393,0.00043363}, {394,0.00068142}, {395,0.00048673}, {396,0.00053097}, {397,0.00070796}, {398,0.00080531}, {399,0.00048673}, {400,0.00058407}, {401,0.00086726}, {402,0.00050442}, {403,0.00040708}, {404,0.00065487}, {405,0.00078761}, {406,0.00073451}, {407,0.00059292}, {408,0.00053097}, {409,0.00065487}, {410,0.00069912}, {411,0.00070796}, {412,0.00052212}, {413,0.00063717}, {414,0.00046018}, {415,0.00057522}, {416,0.00050442}, {417,0.00073451}, {418,0.00098230}, {419,0.00044248}, {420,0.00042478}, {421,0.00048673}, {422,0.00071681}, {423,0.00058407}, {424,0.00045133}, {425,0.00067257}, {426,0.00061062}, {427,0.00073451}, {428,0.00061062}, {429,0.00056637}, {430,0.00068142}, {431,0.00051327}, {432,0.00071681}, {433,0.00066372}, {434,0.00057522}, {435,0.00066372}, {436,0.00058407}, {437,0.00062832}, {438,0.00054867}, {439,0.00045133}, {440,0.00061947}, {441,0.00068142}, {442,0.00062832}, {443,0.00057522}, {444,0.00072566}, {445,0.00077876}, {446,0.00043363}, {447,0.00079646}, {448,0.00069027}, {449,0.00074336}, {450,0.00058407}, {451,0.00041593}, {452,0.00079646}, {453,0.00089381}, {454,0.00079646}, {455,0.00069912}, {456,0.00053982}, {457,0.00079646}, {458,0.00042478}, {459,0.00055752}, {460,0.00057522}, {461,0.00039823}, {462,0.00075221}, {463,0.00058407}, {464,0.00062832}, {465,0.00033628}, {466,0.00059292}, {467,0.00089381}, {468,0.00046018}, {469,0.00065487}, {470,0.00074336}, {471,0.00069027}, {472,0.00061947}, {473,0.00091150}, {474,0.00072566}, {475,0.00055752}, {476,0.00055752}, {477,0.00091150}, {478,0.00080531}, {479,0.00042478}, {480,0.00081416}, {481,0.00076991}, {482,0.00076991}, {483,0.00061062}, {484,0.00046018}, {485,0.00089381}, {486,0.00098230}, {487,0.00078761}, {488,0.00076106}, {489,0.00071681}, {490,0.00095575}, {491,0.00075221}, {492,0.00047788}, {493,0.00051327}, {494,0.00080531}, {495,0.00071681}, {496,0.00124779}, {497,0.00082301}, {498,0.00073451}, {499,0.00089381}, {500,0.00096460}, {505,0.00065487}, {510,0.00081416}, {515,0.00076991}, {520,0.00108850}, {525,0.00080531}, {530,0.00067257}, {535,0.00113274}, {540,0.00077876}, {545,0.00078761}, {550,0.00076991}, {555,0.00092920}, {560,0.00103540}, {565,0.00094690}, {570,0.00082301}, {575,0.00055752}, {580,0.00069912}, {585,0.00070796}, {590,0.00094690}, {595,0.00081416}, {600,0.00100885}, {605,0.00096460}, {610,0.00084956}, {615,0.00120354}, {620,0.00092035}, {625,0.00077876}, {630,0.00073451}, {635,0.00077876}, {640,0.00093805}, {645,0.00102655}, {650,0.00111504}, {655,0.00098230}, {660,0.00081416}, {665,0.00122124}, {670,0.00086726}, {675,0.00093805}, {680,0.00100000}, {685,0.00076106}, {690,0.00101770}, {695,0.00076106}, {700,0.00107080}, {705,0.00097345}, {710,0.00085841}, {715,0.00079646}, {720,0.00123009}, {725,0.00100885}, {730,0.00092920}, {735,0.00124779}, {740,0.00117699}, {745,0.00074336}, {750,0.00101770}, {755,0.00065487}, {760,0.00076991}, {765,0.00112389}, {770,0.00107965}, {775,0.00103540}, {780,0.00103540}, {785,0.00082301}, {790,0.00098230}, {795,0.00116964}, {800,0.00103571}, {805,0.00073214}, {810,0.00096429}, {815,0.00107143}, {820,0.00108036}, {825,0.00094643}, {830,0.00120536}, {835,0.00143750}, {840,0.00116071}, {845,0.00130357}, {850,0.00105357}, {855,0.00114286}, {860,0.00139286}, {865,0.00099107}, {870,0.00125893}, {875,0.00123214}, {880,0.00101786}, {885,0.00310714}, {890,0.00096429}, {895,0.00127679}, {900,0.00122321}, {905,0.00135714}, {910,0.00099107}, {915,0.00123214}, {920,0.00133929}, {925,0.00143750}, {930,0.00135714}, {935,0.00152679}, {940,0.00093750}, {945,0.00140179}, {950,0.00109821}, {955,0.00121429}, {960,0.00151786}, {965,0.00177679}, {970,0.00139286}, {975,0.00143750}, {980,0.00130357}, {985,0.00139286}, {990,0.00157143}, {995,0.00158036}, {1000,0.00093750}, {1010,0.00139286}, {1020,0.00142857}, {1030,0.00121429}, {1040,0.00141071}, {1050,0.00148214}, {1060,0.00116071}, {1070,0.00143750}, {1080,0.00121429}, {1090,0.00136607}, {1100,0.00167857}, {1110,0.00154464}, {1120,0.00158929}, {1130,0.00164286}, {1140,0.00178571}, {1150,0.00172321}, {1160,0.00171429}, {1170,0.00144643}, {1180,0.00172321}, {1190,0.00166071}, {1200,0.00154464}, {1210,0.00400000}, {1220,0.00187500}, {1230,0.00173214}, {1240,0.00178571}, {1250,0.00158929}, {1260,0.00131250}, {1270,0.00190179}, {1280,0.00149107}, {1290,0.00171429}, {1300,0.00184821}, {1310,0.00200000}, {1320,0.00183036}, {1330,0.00168750}, {1340,0.00160714}, {1350,0.00166964}, {1360,0.00200893}, {1370,0.00206250}, {1380,0.00212500}, {1390,0.00208036}, {1400,0.00180357}, {1410,0.00186607}, {1420,0.00200893}, {1430,0.00191964}, {1440,0.00208036}, {1450,0.00183929}, {1460,0.00216964}, {1470,0.00225893}, {1480,0.00211607}, {1490,0.00202679}, {1500,0.00232143}, {1510,0.00210714}, {1520,0.00192857}, {1530,0.00205357}, {1540,0.00209821}, {1550,0.00216964}, {1560,0.00201786}, {1570,0.00224107}, {1580,0.00226786}, {1590,0.00237500}, {1600,0.00228571}, {1610,0.00229464}, {1620,0.00244643}, {1630,0.00220536}, {1640,0.00233036}, {1650,0.00237500}, {1660,0.00244643}, {1670,0.00273214}, {1680,0.00215179}, {1690,0.00253571}, {1700,0.00261607}, {1710,0.00255357}, {1720,0.00240179}, {1730,0.00270536}, {1740,0.00232143}, {1750,0.00268750}, {1760,0.00278571}, {1770,0.00256250}, {1780,0.00267857}, {1790,0.00585714}, {1800,0.00266964}, {1810,0.00270536}, {1820,0.00294643}, {1830,0.00279464}, {1840,0.00282143}, {1850,0.00303571}, {1860,0.00296429}, {1870,0.00285714}, {1880,0.00277679}, {1890,0.00275000}, {1900,0.00279464}, {1910,0.00300000}, {1920,0.00284821}, {1930,0.00297321}, {1940,0.00288393}, {1950,0.00309821}, {1960,0.00293750}, {1970,0.00320536}, {1980,0.00302679}, {1990,0.00315179}, {2000,0.00302679}, {2050,0.00315179}, {2100,0.00328571}, {2150,0.00322321}, {2200,0.00341071}, {2250,0.00357143}, {2300,0.00644643}, {2350,0.00385714}, {2400,0.00385714}, {2450,0.00408036}, {2500,0.00811607}, {2550,0.00408036}, {2600,0.00467857}, {2650,0.00852679}, {2700,0.00477679}, {2750,0.00450893}, {2800,0.00501786}, {2850,0.00517857}, {2900,0.00494643}, {2950,0.00518750}, {3000,0.00541071}, {3050,0.00527679}, {3100,0.00561607}, {3150,0.00575893}, {3200,0.00595536}, {3250,0.00620536}, {3300,0.00585714}, {3350,0.00652679}, {3400,0.00633929}, {3450,0.00675893}, {3500,0.00664286}, {3550,0.00952679}, {3600,0.00691071}, {3650,0.00687500}, {3700,0.00696429}, {3750,0.00676786}, {3800,0.00715179}, {3850,0.00731250}, {3900,0.00750000}, {3950,0.00734821}, {4000,0.00753571}, {4050,0.00807143}, {4100,0.00792857}, {4150,0.00780357}, {4200,0.00826786}, {4250,0.00872321}, {4300,0.00825000}, {4350,0.00859821}, {4400,0.00839286}, {4450,0.01496429}, {4500,0.00869643}, {4550,0.00860714}, {4600,0.00900000}, {4650,0.00963393}, {4700,0.00950893}, {4750,0.00980357}, {4800,0.00971429}, {4850,0.00990179}, {4900,0.00965179}, {4950,0.01000893}, {5000,0.00949107}, {5050,0.00954464}, {5100,0.01058929}, {5150,0.01050893}, {5200,0.01032143}, {5250,0.01077679}, {5300,0.01033036}, {5350,0.01108929}, {5400,0.01126786}, {5450,0.01100000}, {5500,0.01159821}, {5550,0.01143750}, {5600,0.01077679}, {5650,0.01160714}, {5700,0.01142857}, {5750,0.01154464}, {5800,0.01171429}, {5850,0.01158036}, {5900,0.01200000}, {5950,0.01180357}, {6000,0.01221429}, {6050,0.02124107}, {6100,0.01250893}, {6150,0.01251786}, {6200,0.01241964}, {6250,0.01324107}, {6300,0.01267857}, {6350,0.01322321}, {6400,0.01270536}, {6450,0.01272321}, {6500,0.01341964}, {6550,0.01303571}, {6600,0.01341964}, {6650,0.01376786}, {6700,0.01368750}, {6750,0.01362500}, {6800,0.01358929}, {6850,0.01390179}, {6900,0.01414286}, {6950,0.02451786}, {7000,0.01363393}, {7050,0.01419643}, {7100,0.02609821}, {7150,0.01425893}, {7200,0.01480357}, {7250,0.01439286}, {7300,0.02936607}, {7350,0.01497321}, {7400,0.01461607}, {7450,0.02178571}, {7500,0.01508036}, {7550,0.01511607}, {7600,0.01534821}, {7650,0.01531250}, {7700,0.01541964}, {7750,0.01541071}, {7800,0.01565179}, {7850,0.01562500}, {7900,0.01600000}, {7950,0.01608929}, {8000,0.01592857}, {8050,0.02389286}, {8100,0.01634821}, {8150,0.04458929}, {8200,0.01665179}, {8250,0.02742857}, {8300,0.01635714}, {8350,0.01680357}, {8400,0.01661607}, {8450,0.01726786}, {8500,0.01725000}, {8550,0.01708036}, {8600,0.01752679}, {8650,0.01679464}, {8700,0.01724107}, {8750,0.01743750}, {8800,0.03512500}, {8850,0.01769643}, {8900,0.01770536}, {8950,0.01754464}, {9000,0.02381250}, {9050,0.01804464}, {9100,0.04316964}, {9150,0.01785714}, {9200,0.04626786}, {9250,0.01817857}, {9300,0.01821429}, {9350,0.01905357}, {9400,0.01912500}, {9450,0.01866964}, {9500,0.01886607}, {9550,0.01875893}, {9600,0.01867857}, {9650,0.01900893}, {9700,0.01881250}, {9750,0.01900893}, {9800,0.04989286}, {9850,0.01927679}, {9900,0.01917857}, {9950,0.03772321}, {10000,0.01973214}, {10100,0.01977679}, {10200,0.02033036}, {10300,0.02016071}, {10400,0.02057143}, {10500,0.02057143}, {10600,0.02065179}, {10700,0.02120536}, {10800,0.03877679}, {10900,0.02149107}, {11000,0.02145536}, {11100,0.02169643}, {11200,0.03371429}, {11300,0.02204464}, {11400,0.02291964}, {11500,0.02263393}, {11600,0.02291071}, {11700,0.02333929}, {11800,0.04672321}, {11900,0.02331250}, {12000,0.02414286}, {12100,0.02395536}, {12200,0.04469643}, {12300,0.02483036}, {12400,0.02441071}, {12500,0.02453571}, {12600,0.04475}, {12700,0.03075}, {12800,0.02750}, {12900,0.02725}, {13000,0.02600}, {13100,0.02675}, {13200,0.02625}, {13300,0.02650}, {13400,0.02625}, {13500,0.02750}, {13600,0.02750}, {13700,0.02825}, {13800,0.04675}, {13900,0.02750}, {14000,0.03150}, {14100,0.02825}, {14200,0.02950}, {14300,0.03500}, {14400,0.04950}, {14500,0.03875}, {14600,0.02825}, {14700,0.02950}, {14800,0.03350}, {14900,0.03050}, {15000,0.04175}, {15100,0.02975}, {15200,0.02950}, {15300,0.02825}, {15400,0.03050}, {15500,0.03050}, {15600,0.04125}, {15700,0.04325}, {15800,0.03225}, {15900,0.04075}, {16000,0.04225}, {16100,0.03250}, {16200,0.04425}, {16300,0.04200}, {16400,0.04350}, {16500,0.03350}, {16600,0.03600}, {16700,0.03350}, {16800,0.03500}, {16900,0.03250}, {17000,0.04275}, {17100,0.03500}, {17200,0.03600}, {17300,0.03250}, {17400,0.03500}, {17500,0.04375}, {17600,0.03450}, {17700,0.03450}, {17800,0.03500}, {17900,0.04300}, {18000,0.04550}, {18100,0.04350}, {18200,0.04475}, {18300,0.04425}, {18400,0.04550}, {18500,0.04575}, {18600,0.03750}, {18700,0.05850}, {18800,0.03750}, {18900,0.04375}, {19000,0.04425}, {19100,0.05675}, {19200,0.05175}, {19300,0.05175}, {19400,0.04675}, {19500,0.03750}, {19600,0.05150}, {19700,0.03850}, {19800,0.04450}, {19900,0.06150}, {20000,0.0390}};
data["big_flat"]["cbv Denote"]["Stats"]["system"] = {{1,0.00009735}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00003540}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00007080}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00003540}, {45,0.00002655}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00003540}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00003540}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00003540}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003540}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00002655}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00002655}, {115,0.00003540}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00003540}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00003540}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00003540}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00003540}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00007080}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00003540}, {169,0.00007080}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00003540}, {181,0.00000000}, {182,0.00002655}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00003540}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00003540}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00003540}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00002655}, {242,0.00003540}, {243,0.00000000}, {244,0.00003540}, {245,0.00000000}, {246,0.00000000}, {247,0.00003540}, {248,0.00000000}, {249,0.00000000}, {250,0.00003540}, {251,0.00000000}, {252,0.00000000}, {253,0.00002655}, {254,0.00003540}, {255,0.00000000}, {256,0.00000000}, {257,0.00006195}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00003540}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00003540}, {271,0.00000000}, {272,0.00007080}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00003540}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00003540}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00003540}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00003540}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00003540}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00003540}, {308,0.00000000}, {309,0.00002655}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00003540}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00003540}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00003540}, {339,0.00003540}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00003540}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00003540}, {350,0.00000000}, {351,0.00003540}, {352,0.00000000}, {353,0.00003540}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00003540}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00003540}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00003540}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00002655}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00002655}, {395,0.00000000}, {396,0.00003540}, {397,0.00003540}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00003540}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00003540}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00003540}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00002655}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00003540}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00002655}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00002655}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00003540}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00003540}, {575,0.00003540}, {580,0.00000000}, {585,0.00000000}, {590,0.00003540}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00003540}, {615,0.00000000}, {620,0.00003540}, {625,0.00000000}, {630,0.00000000}, {635,0.00002655}, {640,0.00003540}, {645,0.00000000}, {650,0.00007080}, {655,0.00003540}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00003540}, {695,0.00003540}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00003540}, {720,0.00003540}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00003540}, {765,0.00003540}, {770,0.00003540}, {775,0.00003540}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00007143}, {845,0.00003571}, {850,0.00003571}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00007143}, {890,0.00000000}, {895,0.00000000}, {900,0.00003571}, {905,0.00000000}, {910,0.00006250}, {915,0.00003571}, {920,0.00000000}, {925,0.00003571}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00007143}, {950,0.00000000}, {955,0.00000000}, {960,0.00003571}, {965,0.00000000}, {970,0.00003571}, {975,0.00003571}, {980,0.00002679}, {985,0.00000000}, {990,0.00003571}, {995,0.00000000}, {1000,0.00003571}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00003571}, {1080,0.00003571}, {1090,0.00002679}, {1100,0.00000000}, {1110,0.00003571}, {1120,0.00003571}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00003571}, {1180,0.00007143}, {1190,0.00003571}, {1200,0.00000000}, {1210,0.00007143}, {1220,0.00003571}, {1230,0.00002679}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00007143}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00003571}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00009821}, {1390,0.00003571}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00003571}, {1480,0.00006250}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00003571}, {1540,0.00006250}, {1550,0.00003571}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00003571}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00003571}, {1640,0.00000000}, {1650,0.00003571}, {1660,0.00003571}, {1670,0.00007143}, {1680,0.00003571}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00003571}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00003571}, {1780,0.00000000}, {1790,0.00003571}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00003571}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00003571}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00003571}, {1950,0.00000000}, {1960,0.00003571}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00003571}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00007143}, {2350,0.00003571}, {2400,0.00003571}, {2450,0.00003571}, {2500,0.00007143}, {2550,0.00007143}, {2600,0.00000000}, {2650,0.00007143}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00003571}, {2850,0.00002679}, {2900,0.00000000}, {2950,0.00003571}, {3000,0.00000000}, {3050,0.00003571}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00003571}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00003571}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00003571}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00003571}, {3900,0.00000000}, {3950,0.00003571}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00003571}, {4200,0.00003571}, {4250,0.00000000}, {4300,0.00006250}, {4350,0.00007143}, {4400,0.00000000}, {4450,0.00007143}, {4500,0.00003571}, {4550,0.00000000}, {4600,0.00003571}, {4650,0.00000000}, {4700,0.00003571}, {4750,0.00000000}, {4800,0.00006250}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00003571}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00003571}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00003571}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00009821}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00002679}, {5800,0.00003571}, {5850,0.00010714}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00014286}, {6100,0.00002679}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00003571}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00010714}, {6800,0.00002679}, {6850,0.00007143}, {6900,0.00000000}, {6950,0.00021429}, {7000,0.00003571}, {7050,0.00000000}, {7100,0.00007143}, {7150,0.00000000}, {7200,0.00002679}, {7250,0.00003571}, {7300,0.00016071}, {7350,0.00003571}, {7400,0.00007143}, {7450,0.00007143}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00000000}, {7750,0.00010714}, {7800,0.00003571}, {7850,0.00003571}, {7900,0.00006250}, {7950,0.00003571}, {8000,0.00000000}, {8050,0.00021429}, {8100,0.00000000}, {8150,0.00053571}, {8200,0.00000000}, {8250,0.00025000}, {8300,0.00000000}, {8350,0.00003571}, {8400,0.00003571}, {8450,0.00000000}, {8500,0.00007143}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00041964}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00000000}, {9000,0.00003571}, {9050,0.00000000}, {9100,0.00064286}, {9150,0.00003571}, {9200,0.00044643}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00007143}, {9450,0.00012500}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00007143}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00007143}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00003571}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00007143}, {10400,0.00000000}, {10500,0.00003571}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00007143}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00003571}, {11300,0.00003571}, {11400,0.00003571}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00003571}, {11800,0.00003571}, {11900,0.00003571}, {12000,0.00000000}, {12100,0.00003571}, {12200,0.00007143}, {12300,0.00007143}, {12400,0.00006250}, {12500,0.00003571}, {12600,0.00075}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00100}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00100}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00075}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00100}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["identity cbn"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00014159}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00083186}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00001770}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00098230}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00098230}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00001770}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00098230}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00001770}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00001770}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000885}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000885}, {720,0.00000000}, {725,0.00000000}, {730,0.00001770}, {735,0.00001770}, {740,0.00001770}, {745,0.00000885}, {750,0.00007080}, {755,0.00013274}, {760,0.00014159}, {765,0.00012389}, {770,0.00052212}, {775,0.00016814}, {780,0.00017699}, {785,0.00030088}, {790,0.00046903}, {795,0.00046429}, {800,0.00061607}, {805,0.00058929}, {810,0.00063393}, {815,0.00064286}, {820,0.00069643}, {825,0.00076786}, {830,0.00081250}, {835,0.00087500}, {840,0.00089286}, {845,0.00091964}, {850,0.00094643}, {855,0.00099107}, {860,0.00098214}, {865,0.00099107}, {870,0.00099107}, {875,0.00099107}, {880,0.00099107}, {885,0.00100000}, {890,0.00098214}, {895,0.00100000}, {900,0.00100000}, {905,0.00100000}, {910,0.00100000}, {915,0.00100000}, {920,0.00100000}, {925,0.00100000}, {930,0.00100000}, {935,0.00100000}, {940,0.00100000}, {945,0.00100000}, {950,0.00100000}, {955,0.00100000}, {960,0.00100000}, {965,0.00100000}, {970,0.00100000}, {975,0.00100000}, {980,0.00100000}, {985,0.00100000}, {990,0.00100000}, {995,0.00100000}, {1000,0.00100000}, {1010,0.00100000}, {1020,0.00100000}, {1030,0.00100000}, {1040,0.00100000}, {1050,0.00100000}, {1060,0.00100000}, {1070,0.00100000}, {1080,0.00100000}, {1090,0.00100000}, {1100,0.00100000}, {1110,0.00100000}, {1120,0.00337500}, {1130,0.00100000}, {1140,0.00100000}, {1150,0.00100000}, {1160,0.00100000}, {1170,0.00100000}, {1180,0.00100000}, {1190,0.00100000}, {1200,0.00100000}, {1210,0.00100000}, {1220,0.00100000}, {1230,0.00100000}, {1240,0.00100000}, {1250,0.00100000}, {1260,0.00100000}, {1270,0.00100000}, {1280,0.00100000}, {1290,0.00100000}, {1300,0.00100000}, {1310,0.00100000}, {1320,0.00100000}, {1330,0.00100000}, {1340,0.00105357}, {1350,0.00100000}, {1360,0.00100000}, {1370,0.00100893}, {1380,0.00101786}, {1390,0.00101786}, {1400,0.00102679}, {1410,0.00102679}, {1420,0.00107143}, {1430,0.00120536}, {1440,0.00143750}, {1450,0.00123214}, {1460,0.00134821}, {1470,0.00140179}, {1480,0.00150893}, {1490,0.00166071}, {1500,0.00118750}, {1510,0.00167857}, {1520,0.00172321}, {1530,0.00177679}, {1540,0.00175000}, {1550,0.00312500}, {1560,0.00178571}, {1570,0.00191964}, {1580,0.00192857}, {1590,0.00194643}, {1600,0.00196429}, {1610,0.00196429}, {1620,0.00198214}, {1630,0.00199107}, {1640,0.00193750}, {1650,0.00199107}, {1660,0.00200000}, {1670,0.00200000}, {1680,0.00443750}, {1690,0.00200000}, {1700,0.00200000}, {1710,0.00203571}, {1720,0.00200000}, {1730,0.00200000}, {1740,0.00200000}, {1750,0.00200893}, {1760,0.00200000}, {1770,0.00200000}, {1780,0.00200000}, {1790,0.00200000}, {1800,0.00200000}, {1810,0.00200000}, {1820,0.00200000}, {1830,0.00200000}, {1840,0.00200000}, {1850,0.00200000}, {1860,0.00204464}, {1870,0.00200000}, {1880,0.00200000}, {1890,0.00200000}, {1900,0.00200000}, {1910,0.00200000}, {1920,0.00200000}, {1930,0.00200000}, {1940,0.00200000}, {1950,0.00200000}, {1960,0.00204464}, {1970,0.00200000}, {1980,0.00200000}, {1990,0.00200000}, {2000,0.00200000}, {2050,0.00200000}, {2100,0.00204464}, {2150,0.00200000}, {2200,0.00246429}, {2250,0.00271429}, {2300,0.00275893}, {2350,0.00290179}, {2400,0.00299107}, {2450,0.00299107}, {2500,0.00300000}, {2550,0.00300000}, {2600,0.00300000}, {2650,0.00300000}, {2700,0.00300000}, {2750,0.00300000}, {2800,0.00301786}, {2850,0.00305357}, {2900,0.00325000}, {2950,0.00354464}, {3000,0.00374107}, {3050,0.00379464}, {3100,0.00382143}, {3150,0.00376786}, {3200,0.00399107}, {3250,0.00400000}, {3300,0.00400000}, {3350,0.00406250}, {3400,0.00400000}, {3450,0.00400000}, {3500,0.00400893}, {3550,0.00401786}, {3600,0.00416964}, {3650,0.00434821}, {3700,0.00417857}, {3750,0.00404464}, {3800,0.00425893}, {3850,0.00754464}, {3900,0.00469643}, {3950,0.00477679}, {4000,0.00487500}, {4050,0.00497321}, {4100,0.00506250}, {4150,0.00873214}, {4200,0.00500000}, {4250,0.00502679}, {4300,0.00500000}, {4350,0.00524107}, {4400,0.00500893}, {4450,0.00557143}, {4500,0.00575000}, {4550,0.00510714}, {4600,0.00981250}, {4650,0.00575893}, {4700,0.00595536}, {4750,0.00591071}, {4800,0.00597321}, {4850,0.00599107}, {4900,0.00605357}, {4950,0.00600000}, {5000,0.01089286}, {5050,0.00600000}, {5100,0.00610714}, {5150,0.00637500}, {5200,0.00601786}, {5250,0.00684821}, {5300,0.00604464}, {5350,0.00680357}, {5400,0.00654464}, {5450,0.01262500}, {5500,0.00686607}, {5550,0.00680357}, {5600,0.00679464}, {5650,0.00677679}, {5700,0.01199107}, {5750,0.01310714}, {5800,0.01268750}, {5850,0.01112500}, {5900,0.00700000}, {5950,0.00700000}, {6000,0.00786607}, {6050,0.00775000}, {6100,0.00723214}, {6150,0.00792857}, {6200,0.01365179}, {6250,0.00782143}, {6300,0.01271429}, {6350,0.00797321}, {6400,0.00775893}, {6450,0.01562500}, {6500,0.00806250}, {6550,0.00841071}, {6600,0.00791964}, {6650,0.00798214}, {6700,0.00802679}, {6750,0.00801786}, {6800,0.00804464}, {6850,0.00812500}, {6900,0.00878571}, {6950,0.00871429}, {7000,0.01300893}, {7050,0.00863393}, {7100,0.00885714}, {7150,0.00871429}, {7200,0.00900893}, {7250,0.00873214}, {7300,0.00925893}, {7350,0.00900000}, {7400,0.00891964}, {7450,0.00959821}, {7500,0.00967857}, {7550,0.00916071}, {7600,0.00928571}, {7650,0.00928571}, {7700,0.00945536}, {7750,0.00948214}, {7800,0.00969643}, {7850,0.00982143}, {7900,0.00995536}, {7950,0.00974107}, {8000,0.00975000}, {8050,0.01024107}, {8100,0.00995536}, {8150,0.01056250}, {8200,0.01009821}, {8250,0.01073214}, {8300,0.00998214}, {8350,0.00999107}, {8400,0.02149107}, {8450,0.01073214}, {8500,0.01034821}, {8550,0.01046429}, {8600,0.01058036}, {8650,0.01065179}, {8700,0.01071429}, {8750,0.01068750}, {8800,0.01141071}, {8850,0.02491964}, {8900,0.01092857}, {8950,0.01073214}, {9000,0.01168750}, {9050,0.01095536}, {9100,0.01161607}, {9150,0.01094643}, {9200,0.01165179}, {9250,0.01131250}, {9300,0.01139286}, {9350,0.01183929}, {9400,0.01164286}, {9450,0.01162500}, {9500,0.01163393}, {9550,0.01166964}, {9600,0.01167857}, {9650,0.01172321}, {9700,0.01168750}, {9750,0.01174107}, {9800,0.01266071}, {9850,0.02301786}, {9900,0.01194643}, {9950,0.01266964}, {10000,0.01218750}, {10100,0.01243750}, {10200,0.01262500}, {10300,0.01339286}, {10400,0.01266964}, {10500,0.01268750}, {10600,0.01303571}, {10700,0.01306250}, {10800,0.01373214}, {10900,0.01345536}, {11000,0.01373214}, {11100,0.02200893}, {11200,0.01363393}, {11300,0.01368750}, {11400,0.01399107}, {11500,0.01425893}, {11600,0.01445536}, {11700,0.01450893}, {11800,0.01507143}, {11900,0.04508036}, {12000,0.01468750}, {12100,0.03714286}, {12200,0.01526786}, {12300,0.01522321}, {12400,0.01539286}, {12500,0.01555357}, {12600,0.01550}, {12700,0.01550}, {12800,0.03900}, {12900,0.01575}, {13000,0.03175}, {13100,0.01600}, {13200,0.01600}, {13300,0.03025}, {13400,0.02900}, {13500,0.03225}, {13600,0.03825}, {13700,0.01700}, {13800,0.01675}, {13900,0.03150}, {14000,0.01675}, {14100,0.02925}, {14200,0.03625}, {14300,0.01775}, {14400,0.01725}, {14500,0.03750}, {14600,0.03200}, {14700,0.02950}, {14800,0.01825}, {14900,0.03675}, {15000,0.01800}, {15100,0.01850}, {15200,0.02300}, {15300,0.03450}, {15400,0.03675}, {15500,0.02350}, {15600,0.01875}, {15700,0.03600}, {15800,0.03125}, {15900,0.02925}, {16000,0.02650}, {16100,0.03450}, {16200,0.02500}, {16300,0.03275}, {16400,0.02500}, {16500,0.02025}, {16600,0.03225}, {16700,0.02900}, {16800,0.03475}, {16900,0.03250}, {17000,0.03500}, {17100,0.03050}, {17200,0.02100}, {17300,0.02125}, {17400,0.02875}, {17500,0.02750}, {17600,0.03125}, {17700,0.02175}, {17800,0.02825}, {17900,0.03300}, {18000,0.02225}, {18100,0.03075}, {18200,0.02650}, {18300,0.03050}, {18400,0.02275}, {18500,0.02925}, {18600,0.04025}, {18700,0.02350}, {18800,0.03325}, {18900,0.03025}, {19000,0.02325}, {19100,0.02350}, {19200,0.02350}, {19300,0.02400}, {19400,0.02875}, {19500,0.04075}, {19600,0.02400}, {19700,0.03800}, {19800,0.04025}, {19900,0.02450}, {20000,0.0250}};
data["big_flat"]["identity cbn"]["Stats"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00005310}, {4,0.00003540}, {5,0.00005310}, {6,0.00002655}, {7,0.00005310}, {8,0.00007965}, {9,0.00002655}, {10,0.00003540}, {11,0.00002655}, {12,0.00000000}, {13,0.00006195}, {14,0.00000000}, {15,0.00002655}, {16,0.00009735}, {17,0.00003540}, {18,0.00005310}, {19,0.00002655}, {20,0.00002655}, {21,0.00003540}, {22,0.00002655}, {23,0.00008850}, {24,0.00002655}, {25,0.00006195}, {26,0.00007965}, {27,0.00007965}, {28,0.00008850}, {29,0.00006195}, {30,0.00005310}, {31,0.00013274}, {32,0.00003540}, {33,0.00005310}, {34,0.00002655}, {35,0.00002655}, {36,0.00005310}, {37,0.00014159}, {38,0.00003540}, {39,0.00008850}, {40,0.00013274}, {41,0.00002655}, {42,0.00015044}, {43,0.00006195}, {44,0.00005310}, {45,0.00010619}, {46,0.00007965}, {47,0.00005310}, {48,0.00008850}, {49,0.00000000}, {50,0.00009735}, {51,0.00003540}, {52,0.00005310}, {53,0.00008850}, {54,0.00012389}, {55,0.00011504}, {56,0.00007965}, {57,0.00011504}, {58,0.00015044}, {59,0.00008850}, {60,0.00005310}, {61,0.00016814}, {62,0.00014159}, {63,0.00020354}, {64,0.00007965}, {65,0.00012389}, {66,0.00011504}, {67,0.00010619}, {68,0.00013274}, {69,0.00002655}, {70,0.00006195}, {71,0.00008850}, {72,0.00014159}, {73,0.00008850}, {74,0.00005310}, {75,0.00020354}, {76,0.00015929}, {77,0.00007965}, {78,0.00009735}, {79,0.00010619}, {80,0.00006195}, {81,0.00000000}, {82,0.00009735}, {83,0.00023009}, {84,0.00007965}, {85,0.00016814}, {86,0.00007965}, {87,0.00008850}, {88,0.00007965}, {89,0.00013274}, {90,0.00000000}, {91,0.00008850}, {92,0.00016814}, {93,0.00068142}, {94,0.00008850}, {95,0.00008850}, {96,0.00014159}, {97,0.00010619}, {98,0.00005310}, {99,0.00015044}, {100,0.00007965}, {101,0.00005310}, {102,0.00010619}, {103,0.00010619}, {104,0.00018584}, {105,0.00028319}, {106,0.00013274}, {107,0.00008850}, {108,0.00007965}, {109,0.00005310}, {110,0.00024779}, {111,0.00025664}, {112,0.00009735}, {113,0.00007965}, {114,0.00003540}, {115,0.00008850}, {116,0.00015929}, {117,0.00002655}, {118,0.00007965}, {119,0.00010619}, {120,0.00015044}, {121,0.00013274}, {122,0.00011504}, {123,0.00008850}, {124,0.00023009}, {125,0.00014159}, {126,0.00008850}, {127,0.00021239}, {128,0.00019469}, {129,0.00013274}, {130,0.00012389}, {131,0.00026549}, {132,0.00023894}, {133,0.00016814}, {134,0.00023894}, {135,0.00007965}, {136,0.00011504}, {137,0.00021239}, {138,0.00024779}, {139,0.00023894}, {140,0.00015044}, {141,0.00017699}, {142,0.00005310}, {143,0.00019469}, {144,0.00024779}, {145,0.00014159}, {146,0.00029204}, {147,0.00022124}, {148,0.00007080}, {149,0.00035398}, {150,0.00030973}, {151,0.00013274}, {152,0.00041593}, {153,0.00016814}, {154,0.00010619}, {155,0.00011504}, {156,0.00015929}, {157,0.00017699}, {158,0.00035398}, {159,0.00012389}, {160,0.00023009}, {161,0.00020354}, {162,0.00014159}, {163,0.00024779}, {164,0.00019469}, {165,0.00021239}, {166,0.00024779}, {167,0.00007965}, {168,0.00011504}, {169,0.00017699}, {170,0.00025664}, {171,0.00014159}, {172,0.00021239}, {173,0.00028319}, {174,0.00019469}, {175,0.00015929}, {176,0.00016814}, {177,0.00016814}, {178,0.00019469}, {179,0.00020354}, {180,0.00015929}, {181,0.00031858}, {182,0.00010619}, {183,0.00017699}, {184,0.00030973}, {185,0.00013274}, {186,0.00027434}, {187,0.00022124}, {188,0.00017699}, {189,0.00029204}, {190,0.00027434}, {191,0.00010619}, {192,0.00025664}, {193,0.00020354}, {194,0.00015044}, {195,0.00019469}, {196,0.00099115}, {197,0.00011504}, {198,0.00027434}, {199,0.00008850}, {200,0.00017699}, {201,0.00015044}, {202,0.00032743}, {203,0.00023009}, {204,0.00022124}, {205,0.00025664}, {206,0.00023009}, {207,0.00013274}, {208,0.00043363}, {209,0.00030088}, {210,0.00023894}, {211,0.00030973}, {212,0.00035398}, {213,0.00047788}, {214,0.00038053}, {215,0.00027434}, {216,0.00022124}, {217,0.00024779}, {218,0.00015044}, {219,0.00015929}, {220,0.00022124}, {221,0.00023894}, {222,0.00033628}, {223,0.00029204}, {224,0.00009735}, {225,0.00027434}, {226,0.00007965}, {227,0.00013274}, {228,0.00014159}, {229,0.00033628}, {230,0.00020354}, {231,0.00036283}, {232,0.00019469}, {233,0.00021239}, {234,0.00023009}, {235,0.00026549}, {236,0.00026549}, {237,0.00044248}, {238,0.00030088}, {239,0.00034513}, {240,0.00043363}, {241,0.00024779}, {242,0.00011504}, {243,0.00028319}, {244,0.00020354}, {245,0.00026549}, {246,0.00019469}, {247,0.00030088}, {248,0.00019469}, {249,0.00024779}, {250,0.00024779}, {251,0.00029204}, {252,0.00015929}, {253,0.00028319}, {254,0.00041593}, {255,0.00014159}, {256,0.00025664}, {257,0.00016814}, {258,0.00020354}, {259,0.00026549}, {260,0.00013274}, {261,0.00017699}, {262,0.00021239}, {263,0.00029204}, {264,0.00025664}, {265,0.00039823}, {266,0.00018584}, {267,0.00018584}, {268,0.00027434}, {269,0.00032743}, {270,0.00028319}, {271,0.00023009}, {272,0.00018584}, {273,0.00027434}, {274,0.00036283}, {275,0.00036283}, {276,0.00034513}, {277,0.00023894}, {278,0.00024779}, {279,0.00032743}, {280,0.00039823}, {281,0.00041593}, {282,0.00025664}, {283,0.00041593}, {284,0.00047788}, {285,0.00033628}, {286,0.00033628}, {287,0.00033628}, {288,0.00019469}, {289,0.00028319}, {290,0.00037168}, {291,0.00033628}, {292,0.00029204}, {293,0.00037168}, {294,0.00032743}, {295,0.00030088}, {296,0.00025664}, {297,0.00019469}, {298,0.00036283}, {299,0.00032743}, {300,0.00031858}, {301,0.00022124}, {302,0.00036283}, {303,0.00020354}, {304,0.00040708}, {305,0.00041593}, {306,0.00037168}, {307,0.00030973}, {308,0.00070796}, {309,0.00030973}, {310,0.00040708}, {311,0.00028319}, {312,0.00041593}, {313,0.00026549}, {314,0.00032743}, {315,0.00036283}, {316,0.00046903}, {317,0.00035398}, {318,0.00061947}, {319,0.00030973}, {320,0.00024779}, {321,0.00043363}, {322,0.00046018}, {323,0.00029204}, {324,0.00061947}, {325,0.00049558}, {326,0.00053097}, {327,0.00044248}, {328,0.00045133}, {329,0.00056637}, {330,0.00057522}, {331,0.00049558}, {332,0.00023894}, {333,0.00041593}, {334,0.00034513}, {335,0.00031858}, {336,0.00027434}, {337,0.00032743}, {338,0.00042478}, {339,0.00025664}, {340,0.00038053}, {341,0.00046903}, {342,0.00042478}, {343,0.00048673}, {344,0.00038053}, {345,0.00053097}, {346,0.00024779}, {347,0.00038053}, {348,0.00033628}, {349,0.00045133}, {350,0.00028319}, {351,0.00109735}, {352,0.00029204}, {353,0.00032743}, {354,0.00027434}, {355,0.00039823}, {356,0.00030088}, {357,0.00048673}, {358,0.00042478}, {359,0.00042478}, {360,0.00040708}, {361,0.00057522}, {362,0.00046903}, {363,0.00055752}, {364,0.00048673}, {365,0.00037168}, {366,0.00048673}, {367,0.00038938}, {368,0.00060177}, {369,0.00036283}, {370,0.00036283}, {371,0.00040708}, {372,0.00027434}, {373,0.00033628}, {374,0.00049558}, {375,0.00048673}, {376,0.00055752}, {377,0.00023894}, {378,0.00040708}, {379,0.00052212}, {380,0.00047788}, {381,0.00032743}, {382,0.00037168}, {383,0.00050442}, {384,0.00046018}, {385,0.00063717}, {386,0.00047788}, {387,0.00023894}, {388,0.00030088}, {389,0.00048673}, {390,0.00038938}, {391,0.00051327}, {392,0.00055752}, {393,0.00032743}, {394,0.00041593}, {395,0.00053982}, {396,0.00043363}, {397,0.00040708}, {398,0.00046018}, {399,0.00042478}, {400,0.00013274}, {401,0.00028319}, {402,0.00034513}, {403,0.00031858}, {404,0.00052212}, {405,0.00050442}, {406,0.00030088}, {407,0.00044248}, {408,0.00063717}, {409,0.00041593}, {410,0.00076991}, {411,0.00046903}, {412,0.00043363}, {413,0.00049558}, {414,0.00047788}, {415,0.00053982}, {416,0.00034513}, {417,0.00053982}, {418,0.00030088}, {419,0.00058407}, {420,0.00062832}, {421,0.00054867}, {422,0.00035398}, {423,0.00037168}, {424,0.00028319}, {425,0.00059292}, {426,0.00041593}, {427,0.00055752}, {428,0.00041593}, {429,0.00056637}, {430,0.00055752}, {431,0.00074336}, {432,0.00062832}, {433,0.00117699}, {434,0.00025664}, {435,0.00044248}, {436,0.00038938}, {437,0.00044248}, {438,0.00046018}, {439,0.00053982}, {440,0.00060177}, {441,0.00044248}, {442,0.00033628}, {443,0.00042478}, {444,0.00046018}, {445,0.00055752}, {446,0.00050442}, {447,0.00043363}, {448,0.00058407}, {449,0.00059292}, {450,0.00033628}, {451,0.00052212}, {452,0.00082301}, {453,0.00045133}, {454,0.00050442}, {455,0.00041593}, {456,0.00060177}, {457,0.00039823}, {458,0.00050442}, {459,0.00061947}, {460,0.00052212}, {461,0.00042478}, {462,0.00050442}, {463,0.00046018}, {464,0.00061947}, {465,0.00084071}, {466,0.00073451}, {467,0.00059292}, {468,0.00057522}, {469,0.00067257}, {470,0.00061062}, {471,0.00029204}, {472,0.00047788}, {473,0.00053982}, {474,0.00050442}, {475,0.00081416}, {476,0.00042478}, {477,0.00042478}, {478,0.00043363}, {479,0.00058407}, {480,0.00046903}, {481,0.00031858}, {482,0.00046018}, {483,0.00066372}, {484,0.00073451}, {485,0.00068142}, {486,0.00039823}, {487,0.00054867}, {488,0.00050442}, {489,0.00068142}, {490,0.00030088}, {491,0.00053097}, {492,0.00058407}, {493,0.00076106}, {494,0.00050442}, {495,0.00065487}, {496,0.00043363}, {497,0.00069912}, {498,0.00052212}, {499,0.00053982}, {500,0.00042478}, {505,0.00040708}, {510,0.00059292}, {515,0.00089381}, {520,0.00046903}, {525,0.00039823}, {530,0.00072566}, {535,0.00057522}, {540,0.00061947}, {545,0.00045133}, {550,0.00053982}, {555,0.00062832}, {560,0.00069912}, {565,0.00057522}, {570,0.00063717}, {575,0.00073451}, {580,0.00060177}, {585,0.00057522}, {590,0.00092920}, {595,0.00076106}, {600,0.00084956}, {605,0.00075221}, {610,0.00076991}, {615,0.00054867}, {620,0.00052212}, {625,0.00061062}, {630,0.00082301}, {635,0.00082301}, {640,0.00056637}, {645,0.00071681}, {650,0.00076991}, {655,0.00050442}, {660,0.00084956}, {665,0.00090265}, {670,0.00082301}, {675,0.00101770}, {680,0.00090265}, {685,0.00110619}, {690,0.00077876}, {695,0.00084071}, {700,0.00063717}, {705,0.00081416}, {710,0.00091150}, {715,0.00080531}, {720,0.00086726}, {725,0.00068142}, {730,0.00066372}, {735,0.00075221}, {740,0.00104425}, {745,0.00054867}, {750,0.00080531}, {755,0.00130088}, {760,0.00057522}, {765,0.00074336}, {770,0.00092920}, {775,0.00069912}, {780,0.00099115}, {785,0.00107965}, {790,0.00119469}, {795,0.00087500}, {800,0.00101786}, {805,0.00096429}, {810,0.00081250}, {815,0.00076786}, {820,0.00127679}, {825,0.00081250}, {830,0.00092857}, {835,0.00089286}, {840,0.00089286}, {845,0.00072321}, {850,0.00075893}, {855,0.00111607}, {860,0.00091964}, {865,0.00126786}, {870,0.00096429}, {875,0.00121429}, {880,0.00117857}, {885,0.00101786}, {890,0.00141071}, {895,0.00069643}, {900,0.00101786}, {905,0.00103571}, {910,0.00130357}, {915,0.00124107}, {920,0.00108036}, {925,0.00110714}, {930,0.00103571}, {935,0.00101786}, {940,0.00128571}, {945,0.00129464}, {950,0.00145536}, {955,0.00144643}, {960,0.00108929}, {965,0.00081250}, {970,0.00130357}, {975,0.00089286}, {980,0.00100000}, {985,0.00115179}, {990,0.00109821}, {995,0.00092857}, {1000,0.00140179}, {1010,0.00104464}, {1020,0.00113393}, {1030,0.00134821}, {1040,0.00114286}, {1050,0.00121429}, {1060,0.00130357}, {1070,0.00121429}, {1080,0.00148214}, {1090,0.00133929}, {1100,0.00100893}, {1110,0.00125000}, {1120,0.00324107}, {1130,0.00132143}, {1140,0.00124107}, {1150,0.00105357}, {1160,0.00133036}, {1170,0.00123214}, {1180,0.00139286}, {1190,0.00134821}, {1200,0.00128571}, {1210,0.00147321}, {1220,0.00114286}, {1230,0.00152679}, {1240,0.00141071}, {1250,0.00135714}, {1260,0.00144643}, {1270,0.00156250}, {1280,0.00135714}, {1290,0.00154464}, {1300,0.00162500}, {1310,0.00130357}, {1320,0.00125893}, {1330,0.00146429}, {1340,0.00144643}, {1350,0.00144643}, {1360,0.00165179}, {1370,0.00150893}, {1380,0.00165179}, {1390,0.00129464}, {1400,0.00156250}, {1410,0.00158036}, {1420,0.00154464}, {1430,0.00170536}, {1440,0.00175000}, {1450,0.00175000}, {1460,0.00158036}, {1470,0.00140179}, {1480,0.00176786}, {1490,0.00186607}, {1500,0.00142857}, {1510,0.00150893}, {1520,0.00157143}, {1530,0.00191964}, {1540,0.00185714}, {1550,0.00312500}, {1560,0.00195536}, {1570,0.00160714}, {1580,0.00201786}, {1590,0.00194643}, {1600,0.00172321}, {1610,0.00177679}, {1620,0.00155357}, {1630,0.00192857}, {1640,0.00155357}, {1650,0.00173214}, {1660,0.00177679}, {1670,0.00187500}, {1680,0.00407143}, {1690,0.00198214}, {1700,0.00189286}, {1710,0.00191071}, {1720,0.00198214}, {1730,0.00194643}, {1740,0.00175893}, {1750,0.00204464}, {1760,0.00191964}, {1770,0.00206250}, {1780,0.00209821}, {1790,0.00211607}, {1800,0.00186607}, {1810,0.00225000}, {1820,0.00211607}, {1830,0.00177679}, {1840,0.00211607}, {1850,0.00205357}, {1860,0.00215179}, {1870,0.00212500}, {1880,0.00210714}, {1890,0.00216964}, {1900,0.00211607}, {1910,0.00216071}, {1920,0.00200000}, {1930,0.00186607}, {1940,0.00214286}, {1950,0.00207143}, {1960,0.00209821}, {1970,0.00236607}, {1980,0.00213393}, {1990,0.00253571}, {2000,0.00213393}, {2050,0.00209821}, {2100,0.00239286}, {2150,0.00233929}, {2200,0.00232143}, {2250,0.00236607}, {2300,0.00244643}, {2350,0.00266071}, {2400,0.00272321}, {2450,0.00281250}, {2500,0.00280357}, {2550,0.00268750}, {2600,0.00297321}, {2650,0.00295536}, {2700,0.00293750}, {2750,0.00301786}, {2800,0.00312500}, {2850,0.00310714}, {2900,0.00323214}, {2950,0.00332143}, {3000,0.00329464}, {3050,0.00358036}, {3100,0.00357143}, {3150,0.00338393}, {3200,0.00351786}, {3250,0.00344643}, {3300,0.00375893}, {3350,0.00387500}, {3400,0.00367857}, {3450,0.00424107}, {3500,0.00391964}, {3550,0.00410714}, {3600,0.00438393}, {3650,0.00426786}, {3700,0.00433036}, {3750,0.00400893}, {3800,0.00425000}, {3850,0.00744643}, {3900,0.00440179}, {3950,0.00475000}, {4000,0.00476786}, {4050,0.00500893}, {4100,0.00496429}, {4150,0.00881250}, {4200,0.00525000}, {4250,0.00539286}, {4300,0.00497321}, {4350,0.00544643}, {4400,0.00495536}, {4450,0.00541964}, {4500,0.00537500}, {4550,0.00542857}, {4600,0.01008036}, {4650,0.00604464}, {4700,0.00574107}, {4750,0.00600000}, {4800,0.00571429}, {4850,0.00589286}, {4900,0.00609821}, {4950,0.00609821}, {5000,0.01123214}, {5050,0.00567857}, {5100,0.00619643}, {5150,0.00658929}, {5200,0.00640179}, {5250,0.00657143}, {5300,0.00614286}, {5350,0.00653571}, {5400,0.00646429}, {5450,0.01302679}, {5500,0.00700893}, {5550,0.00672321}, {5600,0.00651786}, {5650,0.00668750}, {5700,0.01231250}, {5750,0.01333036}, {5800,0.01281250}, {5850,0.01162500}, {5900,0.00700893}, {5950,0.00700893}, {6000,0.00754464}, {6050,0.00773214}, {6100,0.00710714}, {6150,0.00783036}, {6200,0.01386607}, {6250,0.00781250}, {6300,0.01317857}, {6350,0.00775893}, {6400,0.00741071}, {6450,0.01568750}, {6500,0.00788393}, {6550,0.00822321}, {6600,0.00792857}, {6650,0.00764286}, {6700,0.00787500}, {6750,0.00804464}, {6800,0.00800000}, {6850,0.00830357}, {6900,0.00847321}, {6950,0.00868750}, {7000,0.01316071}, {7050,0.00875893}, {7100,0.00897321}, {7150,0.00855357}, {7200,0.00935714}, {7250,0.00839286}, {7300,0.00950000}, {7350,0.00933036}, {7400,0.00883929}, {7450,0.00936607}, {7500,0.00965179}, {7550,0.00941964}, {7600,0.00927679}, {7650,0.00959821}, {7700,0.00938393}, {7750,0.00956250}, {7800,0.00988393}, {7850,0.01033929}, {7900,0.01009821}, {7950,0.00968750}, {8000,0.00977679}, {8050,0.01039286}, {8100,0.01041071}, {8150,0.01056250}, {8200,0.01041071}, {8250,0.01096429}, {8300,0.01028571}, {8350,0.00972321}, {8400,0.02141071}, {8450,0.01099107}, {8500,0.01063393}, {8550,0.01062500}, {8600,0.01044643}, {8650,0.01132143}, {8700,0.01123214}, {8750,0.01102679}, {8800,0.01150000}, {8850,0.02515179}, {8900,0.01098214}, {8950,0.01139286}, {9000,0.01190179}, {9050,0.01160714}, {9100,0.01207143}, {9150,0.01163393}, {9200,0.01234821}, {9250,0.01174107}, {9300,0.01185714}, {9350,0.01221429}, {9400,0.01183036}, {9450,0.01200893}, {9500,0.01192857}, {9550,0.01208929}, {9600,0.01207143}, {9650,0.01216964}, {9700,0.01207143}, {9750,0.01215179}, {9800,0.01293750}, {9850,0.02352679}, {9900,0.01234821}, {9950,0.01282143}, {10000,0.01246429}, {10100,0.01272321}, {10200,0.01278571}, {10300,0.01365179}, {10400,0.01302679}, {10500,0.01283929}, {10600,0.01343750}, {10700,0.01334821}, {10800,0.01376786}, {10900,0.01367857}, {11000,0.01359821}, {11100,0.02270536}, {11200,0.01385714}, {11300,0.01404464}, {11400,0.01408036}, {11500,0.01413393}, {11600,0.01438393}, {11700,0.01455357}, {11800,0.01512500}, {11900,0.04525000}, {12000,0.01480357}, {12100,0.03724107}, {12200,0.01536607}, {12300,0.01508036}, {12400,0.01531250}, {12500,0.01531250}, {12600,0.01575}, {12700,0.01575}, {12800,0.03750}, {12900,0.01550}, {13000,0.03075}, {13100,0.01800}, {13200,0.01500}, {13300,0.03050}, {13400,0.02725}, {13500,0.03300}, {13600,0.03875}, {13700,0.01675}, {13800,0.01550}, {13900,0.03075}, {14000,0.01650}, {14100,0.02725}, {14200,0.03675}, {14300,0.01800}, {14400,0.01750}, {14500,0.03825}, {14600,0.03100}, {14700,0.03025}, {14800,0.01825}, {14900,0.03700}, {15000,0.01750}, {15100,0.01800}, {15200,0.02225}, {15300,0.03475}, {15400,0.03650}, {15500,0.02550}, {15600,0.01975}, {15700,0.03325}, {15800,0.03200}, {15900,0.02900}, {16000,0.02500}, {16100,0.03425}, {16200,0.02375}, {16300,0.03275}, {16400,0.02500}, {16500,0.01950}, {16600,0.03225}, {16700,0.02825}, {16800,0.03350}, {16900,0.03150}, {17000,0.03575}, {17100,0.03050}, {17200,0.02050}, {17300,0.02025}, {17400,0.02900}, {17500,0.02675}, {17600,0.03150}, {17700,0.02075}, {17800,0.02875}, {17900,0.03475}, {18000,0.02275}, {18100,0.03075}, {18200,0.02775}, {18300,0.02975}, {18400,0.02275}, {18500,0.02775}, {18600,0.03975}, {18700,0.02475}, {18800,0.03250}, {18900,0.03075}, {19000,0.02400}, {19100,0.02275}, {19200,0.02400}, {19300,0.02375}, {19400,0.02975}, {19500,0.04075}, {19600,0.02400}, {19700,0.03675}, {19800,0.04100}, {19900,0.02400}, {20000,0.0255}};
data["big_flat"]["identity cbn"]["Stats"]["system"] = {{1,0.00007080}, {2,0.00000000}, {3,0.00003540}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00003540}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00003540}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00003540}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00002655}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00003540}, {91,0.00003540}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00003540}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00003540}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00003540}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00003540}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00003540}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00003540}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00003540}, {192,0.00000000}, {193,0.00000000}, {194,0.00003540}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00003540}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00003540}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00003540}, {210,0.00000000}, {211,0.00000000}, {212,0.00003540}, {213,0.00003540}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00006195}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00003540}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00003540}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00002655}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00003540}, {279,0.00007080}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00003540}, {287,0.00000000}, {288,0.00000000}, {289,0.00003540}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00003540}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00003540}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00003540}, {318,0.00000000}, {319,0.00000000}, {320,0.00002655}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00009735}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00003540}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00003540}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00003540}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00003540}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00007080}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00003540}, {372,0.00000000}, {373,0.00003540}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00003540}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00003540}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00003540}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00003540}, {406,0.00003540}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00003540}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00002655}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00003540}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00003540}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00003540}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00002655}, {455,0.00003540}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00003540}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00003540}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00003540}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00003540}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00003540}, {490,0.00000000}, {491,0.00000000}, {492,0.00007080}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00003540}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00006195}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00003540}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00003540}, {680,0.00003540}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00003540}, {710,0.00003540}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00002655}, {735,0.00000000}, {740,0.00000000}, {745,0.00003540}, {750,0.00003540}, {755,0.00003540}, {760,0.00003540}, {765,0.00003540}, {770,0.00002655}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00002655}, {795,0.00003571}, {800,0.00003571}, {805,0.00000000}, {810,0.00000000}, {815,0.00006250}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00003571}, {845,0.00003571}, {850,0.00000000}, {855,0.00007143}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00003571}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00003571}, {945,0.00000000}, {950,0.00009821}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00003571}, {995,0.00003571}, {1000,0.00003571}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00003571}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00002679}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00002679}, {1120,0.00007143}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00003571}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00003571}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00003571}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003571}, {1490,0.00000000}, {1500,0.00003571}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00003571}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00003571}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00003571}, {1680,0.00003571}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00003571}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00007143}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00003571}, {1910,0.00003571}, {1920,0.00002679}, {1930,0.00003571}, {1940,0.00002679}, {1950,0.00007143}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00003571}, {2150,0.00000000}, {2200,0.00003571}, {2250,0.00000000}, {2300,0.00003571}, {2350,0.00003571}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00003571}, {2850,0.00007143}, {2900,0.00003571}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00002679}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00003571}, {3450,0.00000000}, {3500,0.00000000}, {3550,0.00007143}, {3600,0.00003571}, {3650,0.00003571}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00007143}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00003571}, {4150,0.00003571}, {4200,0.00000000}, {4250,0.00003571}, {4300,0.00003571}, {4350,0.00007143}, {4400,0.00000000}, {4450,0.00003571}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00013393}, {4650,0.00003571}, {4700,0.00003571}, {4750,0.00003571}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00003571}, {5000,0.00014286}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00005357}, {5400,0.00000000}, {5450,0.00014286}, {5500,0.00000000}, {5550,0.00002679}, {5600,0.00007143}, {5650,0.00000000}, {5700,0.00017857}, {5750,0.00021429}, {5800,0.00021429}, {5850,0.00017857}, {5900,0.00003571}, {5950,0.00000000}, {6000,0.00003571}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00006250}, {6250,0.00003571}, {6300,0.00007143}, {6350,0.00010714}, {6400,0.00000000}, {6450,0.00003571}, {6500,0.00000000}, {6550,0.00003571}, {6600,0.00000000}, {6650,0.00003571}, {6700,0.00000000}, {6750,0.00002679}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00003571}, {6950,0.00002679}, {7000,0.00017857}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00003571}, {7200,0.00000000}, {7250,0.00003571}, {7300,0.00003571}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00003571}, {7550,0.00003571}, {7600,0.00007143}, {7650,0.00007143}, {7700,0.00007143}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00002679}, {7950,0.00000000}, {8000,0.00010714}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00007143}, {8350,0.00010714}, {8400,0.00020536}, {8450,0.00000000}, {8500,0.00003571}, {8550,0.00003571}, {8600,0.00003571}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00007143}, {8800,0.00007143}, {8850,0.00021429}, {8900,0.00006250}, {8950,0.00000000}, {9000,0.00003571}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00006250}, {9300,0.00010714}, {9350,0.00003571}, {9400,0.00007143}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00003571}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00006250}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00003571}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00003571}, {10300,0.00003571}, {10400,0.00000000}, {10500,0.00007143}, {10600,0.00000000}, {10700,0.00003571}, {10800,0.00006250}, {10900,0.00000000}, {11000,0.00000000}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00003571}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00003571}, {11900,0.00003571}, {12000,0.00003571}, {12100,0.00000000}, {12200,0.00007143}, {12300,0.00000000}, {12400,0.00007143}, {12500,0.00000000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00075}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00100}, {15000,0.00000}, {15100,0.00100}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00100}, {15800,0.00000}, {15900,0.00000}, {16000,0.00100}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00100}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00100}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["identity cbv"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00008850}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00079646}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000885}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00098230}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00193750}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000893}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000893}, {1380,0.00000000}, {1390,0.00001786}, {1400,0.00004464}, {1410,0.00000000}, {1420,0.00010714}, {1430,0.00012500}, {1440,0.00057143}, {1450,0.00023214}, {1460,0.00064286}, {1470,0.00040179}, {1480,0.00059821}, {1490,0.00069643}, {1500,0.00063393}, {1510,0.00070536}, {1520,0.00070536}, {1530,0.00071429}, {1540,0.00073214}, {1550,0.00072321}, {1560,0.00072321}, {1570,0.00071429}, {1580,0.00071429}, {1590,0.00071429}, {1600,0.00072321}, {1610,0.00071429}, {1620,0.00074107}, {1630,0.00075000}, {1640,0.00076786}, {1650,0.00083036}, {1660,0.00083929}, {1670,0.00095536}, {1680,0.00096429}, {1690,0.00096429}, {1700,0.00100000}, {1710,0.00100000}, {1720,0.00100000}, {1730,0.00100000}, {1740,0.00100000}, {1750,0.00100000}, {1760,0.00100000}, {1770,0.00100000}, {1780,0.00100000}, {1790,0.00100000}, {1800,0.00100000}, {1810,0.00100000}, {1820,0.00100000}, {1830,0.00100000}, {1840,0.00100000}, {1850,0.00100000}, {1860,0.00100000}, {1870,0.00100000}, {1880,0.00100000}, {1890,0.00100000}, {1900,0.00100000}, {1910,0.00100000}, {1920,0.00100000}, {1930,0.00100000}, {1940,0.00100000}, {1950,0.00100000}, {1960,0.00100000}, {1970,0.00100000}, {1980,0.00100000}, {1990,0.00100000}, {2000,0.00100000}, {2050,0.00100000}, {2100,0.00100000}, {2150,0.00100000}, {2200,0.00100000}, {2250,0.00100000}, {2300,0.00100000}, {2350,0.00100000}, {2400,0.00100000}, {2450,0.00100000}, {2500,0.00100000}, {2550,0.00100000}, {2600,0.00100000}, {2650,0.00100893}, {2700,0.00102679}, {2750,0.00101786}, {2800,0.00106250}, {2850,0.00118750}, {2900,0.00135714}, {2950,0.00149107}, {3000,0.00165179}, {3050,0.00177679}, {3100,0.00178571}, {3150,0.00177679}, {3200,0.00185714}, {3250,0.00187500}, {3300,0.00192857}, {3350,0.00197321}, {3400,0.00208036}, {3450,0.00209821}, {3500,0.00211607}, {3550,0.00215179}, {3600,0.00223214}, {3650,0.00232143}, {3700,0.00239286}, {3750,0.00236607}, {3800,0.00256250}, {3850,0.00266071}, {3900,0.00262500}, {3950,0.00280357}, {4000,0.00283036}, {4050,0.00290179}, {4100,0.00291071}, {4150,0.00305357}, {4200,0.00311607}, {4250,0.00329464}, {4300,0.00342857}, {4350,0.00349107}, {4400,0.00361607}, {4450,0.00366964}, {4500,0.00366964}, {4550,0.00375000}, {4600,0.00374107}, {4650,0.00378571}, {4700,0.00382143}, {4750,0.00383929}, {4800,0.00388393}, {4850,0.00388393}, {4900,0.00404464}, {4950,0.00410714}, {5000,0.00416071}, {5050,0.00428571}, {5100,0.00425000}, {5150,0.00433929}, {5200,0.00446429}, {5250,0.00471429}, {5300,0.00460714}, {5350,0.00470536}, {5400,0.00472321}, {5450,0.00473214}, {5500,0.00471429}, {5550,0.00472321}, {5600,0.00473214}, {5650,0.00475000}, {5700,0.00486607}, {5750,0.00475893}, {5800,0.00492857}, {5850,0.00485714}, {5900,0.00500893}, {5950,0.00504464}, {6000,0.00516964}, {6050,0.00558036}, {6100,0.00549107}, {6150,0.00564286}, {6200,0.00577679}, {6250,0.00571429}, {6300,0.00566071}, {6350,0.00571429}, {6400,0.00572321}, {6450,0.00572321}, {6500,0.00570536}, {6550,0.00568750}, {6600,0.00568750}, {6650,0.00571429}, {6700,0.00576786}, {6750,0.00573214}, {6800,0.00577679}, {6850,0.01051786}, {6900,0.00590179}, {6950,0.00608036}, {7000,0.00610714}, {7050,0.00644643}, {7100,0.00637500}, {7150,0.00658929}, {7200,0.00666071}, {7250,0.00667857}, {7300,0.00668750}, {7350,0.00668750}, {7400,0.00668750}, {7450,0.00669643}, {7500,0.00669643}, {7550,0.00669643}, {7600,0.00679464}, {7650,0.00672321}, {7700,0.00684821}, {7750,0.00673214}, {7800,0.00670536}, {7850,0.00697321}, {7900,0.00699107}, {7950,0.00701786}, {8000,0.00726786}, {8050,0.00740179}, {8100,0.00760714}, {8150,0.00757143}, {8200,0.00771429}, {8250,0.00780357}, {8300,0.00774107}, {8350,0.00774107}, {8400,0.00772321}, {8450,0.00772321}, {8500,0.01291071}, {8550,0.00775893}, {8600,0.00777679}, {8650,0.00783929}, {8700,0.00781250}, {8750,0.01380357}, {8800,0.00794643}, {8850,0.00800893}, {8900,0.00816964}, {8950,0.00810714}, {9000,0.00838393}, {9050,0.00841071}, {9100,0.00830357}, {9150,0.00833929}, {9200,0.00852679}, {9250,0.00864286}, {9300,0.00861607}, {9350,0.00866071}, {9400,0.00848214}, {9450,0.00888393}, {9500,0.00866071}, {9550,0.00872321}, {9600,0.00884821}, {9650,0.00900893}, {9700,0.00905357}, {9750,0.01337500}, {9800,0.00915179}, {9850,0.00906250}, {9900,0.00923214}, {9950,0.00922321}, {10000,0.00932143}, {10100,0.01359821}, {10200,0.00956250}, {10300,0.00965179}, {10400,0.01790179}, {10500,0.00986607}, {10600,0.01005357}, {10700,0.01008929}, {10800,0.00998214}, {10900,0.01051786}, {11000,0.01022321}, {11100,0.01036607}, {11200,0.01048214}, {11300,0.01057143}, {11400,0.01087500}, {11500,0.01101786}, {11600,0.01104464}, {11700,0.01125893}, {11800,0.01119643}, {11900,0.01122321}, {12000,0.01154464}, {12100,0.01154464}, {12200,0.01165179}, {12300,0.01167857}, {12400,0.01184821}, {12500,0.01205357}, {12600,0.01225}, {12700,0.02050}, {12800,0.01225}, {12900,0.01200}, {13000,0.01200}, {13100,0.01275}, {13200,0.01250}, {13300,0.01275}, {13400,0.01200}, {13500,0.01200}, {13600,0.01275}, {13700,0.01325}, {13800,0.01275}, {13900,0.01275}, {14000,0.01300}, {14100,0.01325}, {14200,0.02450}, {14300,0.01400}, {14400,0.01375}, {14500,0.01400}, {14600,0.01375}, {14700,0.01450}, {14800,0.01375}, {14900,0.01925}, {15000,0.01400}, {15100,0.01425}, {15200,0.02075}, {15300,0.01550}, {15400,0.01450}, {15500,0.02175}, {15600,0.01475}, {15700,0.01500}, {15800,0.02125}, {15900,0.01625}, {16000,0.01575}, {16100,0.01575}, {16200,0.01975}, {16300,0.01950}, {16400,0.01850}, {16500,0.01600}, {16600,0.02300}, {16700,0.01600}, {16800,0.01700}, {16900,0.01700}, {17000,0.02250}, {17100,0.01675}, {17200,0.01675}, {17300,0.01625}, {17400,0.01650}, {17500,0.02900}, {17600,0.01675}, {17700,0.01650}, {17800,0.01650}, {17900,0.01725}, {18000,0.01725}, {18100,0.02350}, {18200,0.01800}, {18300,0.02300}, {18400,0.01750}, {18500,0.01825}, {18600,0.02450}, {18700,0.01825}, {18800,0.01825}, {18900,0.01800}, {19000,0.01800}, {19100,0.01775}, {19200,0.01825}, {19300,0.01875}, {19400,0.01875}, {19500,0.03275}, {19600,0.01875}, {19700,0.01875}, {19800,0.01950}, {19900,0.01850}, {20000,0.0365}};
data["big_flat"]["identity cbv"]["Stats"]["user"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00006195}, {4,0.00005310}, {5,0.00000000}, {6,0.00002655}, {7,0.00007965}, {8,0.00002655}, {9,0.00003540}, {10,0.00000000}, {11,0.00008850}, {12,0.00002655}, {13,0.00002655}, {14,0.00006195}, {15,0.00006195}, {16,0.00002655}, {17,0.00002655}, {18,0.00012389}, {19,0.00013274}, {20,0.00011504}, {21,0.00003540}, {22,0.00002655}, {23,0.00002655}, {24,0.00002655}, {25,0.00002655}, {26,0.00005310}, {27,0.00000000}, {28,0.00000000}, {29,0.00005310}, {30,0.00008850}, {31,0.00002655}, {32,0.00005310}, {33,0.00000000}, {34,0.00008850}, {35,0.00000000}, {36,0.00000000}, {37,0.00011504}, {38,0.00006195}, {39,0.00002655}, {40,0.00006195}, {41,0.00007965}, {42,0.00002655}, {43,0.00014159}, {44,0.00007965}, {45,0.00007965}, {46,0.00000000}, {47,0.00000000}, {48,0.00002655}, {49,0.00005310}, {50,0.00005310}, {51,0.00010619}, {52,0.00005310}, {53,0.00007965}, {54,0.00003540}, {55,0.00002655}, {56,0.00006195}, {57,0.00008850}, {58,0.00002655}, {59,0.00000000}, {60,0.00007080}, {61,0.00011504}, {62,0.00005310}, {63,0.00008850}, {64,0.00011504}, {65,0.00011504}, {66,0.00009735}, {67,0.00005310}, {68,0.00005310}, {69,0.00000000}, {70,0.00007965}, {71,0.00005310}, {72,0.00006195}, {73,0.00008850}, {74,0.00008850}, {75,0.00002655}, {76,0.00009735}, {77,0.00014159}, {78,0.00014159}, {79,0.00005310}, {80,0.00006195}, {81,0.00010619}, {82,0.00018584}, {83,0.00002655}, {84,0.00006195}, {85,0.00002655}, {86,0.00002655}, {87,0.00003540}, {88,0.00009735}, {89,0.00002655}, {90,0.00006195}, {91,0.00013274}, {92,0.00006195}, {93,0.00008850}, {94,0.00015044}, {95,0.00005310}, {96,0.00014159}, {97,0.00007965}, {98,0.00023009}, {99,0.00005310}, {100,0.00009735}, {101,0.00008850}, {102,0.00006195}, {103,0.00008850}, {104,0.00017699}, {105,0.00007965}, {106,0.00006195}, {107,0.00015044}, {108,0.00008850}, {109,0.00000000}, {110,0.00007965}, {111,0.00014159}, {112,0.00006195}, {113,0.00002655}, {114,0.00006195}, {115,0.00002655}, {116,0.00007965}, {117,0.00009735}, {118,0.00002655}, {119,0.00027434}, {120,0.00007965}, {121,0.00010619}, {122,0.00008850}, {123,0.00013274}, {124,0.00005310}, {125,0.00007965}, {126,0.00010619}, {127,0.00015929}, {128,0.00008850}, {129,0.00007965}, {130,0.00023009}, {131,0.00003540}, {132,0.00023894}, {133,0.00002655}, {134,0.00021239}, {135,0.00007965}, {136,0.00021239}, {137,0.00006195}, {138,0.00007965}, {139,0.00002655}, {140,0.00007965}, {141,0.00006195}, {142,0.00005310}, {143,0.00002655}, {144,0.00007965}, {145,0.00016814}, {146,0.00011504}, {147,0.00033628}, {148,0.00017699}, {149,0.00002655}, {150,0.00023009}, {151,0.00023009}, {152,0.00008850}, {153,0.00007965}, {154,0.00010619}, {155,0.00008850}, {156,0.00017699}, {157,0.00010619}, {158,0.00012389}, {159,0.00009735}, {160,0.00008850}, {161,0.00014159}, {162,0.00006195}, {163,0.00002655}, {164,0.00020354}, {165,0.00017699}, {166,0.00008850}, {167,0.00006195}, {168,0.00002655}, {169,0.00005310}, {170,0.00011504}, {171,0.00008850}, {172,0.00012389}, {173,0.00022124}, {174,0.00018584}, {175,0.00014159}, {176,0.00007965}, {177,0.00017699}, {178,0.00006195}, {179,0.00011504}, {180,0.00026549}, {181,0.00016814}, {182,0.00016814}, {183,0.00017699}, {184,0.00006195}, {185,0.00024779}, {186,0.00015929}, {187,0.00019469}, {188,0.00021239}, {189,0.00005310}, {190,0.00011504}, {191,0.00008850}, {192,0.00017699}, {193,0.00010619}, {194,0.00007965}, {195,0.00015044}, {196,0.00011504}, {197,0.00019469}, {198,0.00011504}, {199,0.00014159}, {200,0.00020354}, {201,0.00005310}, {202,0.00007965}, {203,0.00010619}, {204,0.00011504}, {205,0.00017699}, {206,0.00014159}, {207,0.00016814}, {208,0.00021239}, {209,0.00010619}, {210,0.00011504}, {211,0.00013274}, {212,0.00008850}, {213,0.00010619}, {214,0.00006195}, {215,0.00021239}, {216,0.00019469}, {217,0.00015044}, {218,0.00023009}, {219,0.00013274}, {220,0.00021239}, {221,0.00016814}, {222,0.00003540}, {223,0.00010619}, {224,0.00010619}, {225,0.00013274}, {226,0.00017699}, {227,0.00007965}, {228,0.00011504}, {229,0.00023009}, {230,0.00014159}, {231,0.00011504}, {232,0.00023894}, {233,0.00006195}, {234,0.00018584}, {235,0.00011504}, {236,0.00020354}, {237,0.00014159}, {238,0.00015929}, {239,0.00009735}, {240,0.00011504}, {241,0.00029204}, {242,0.00017699}, {243,0.00014159}, {244,0.00025664}, {245,0.00017699}, {246,0.00010619}, {247,0.00014159}, {248,0.00017699}, {249,0.00017699}, {250,0.00020354}, {251,0.00022124}, {252,0.00025664}, {253,0.00011504}, {254,0.00032743}, {255,0.00016814}, {256,0.00021239}, {257,0.00017699}, {258,0.00025664}, {259,0.00005310}, {260,0.00021239}, {261,0.00013274}, {262,0.00014159}, {263,0.00022124}, {264,0.00005310}, {265,0.00012389}, {266,0.00002655}, {267,0.00016814}, {268,0.00011504}, {269,0.00024779}, {270,0.00019469}, {271,0.00019469}, {272,0.00015044}, {273,0.00009735}, {274,0.00019469}, {275,0.00015929}, {276,0.00015929}, {277,0.00015044}, {278,0.00027434}, {279,0.00016814}, {280,0.00026549}, {281,0.00027434}, {282,0.00019469}, {283,0.00016814}, {284,0.00006195}, {285,0.00016814}, {286,0.00036283}, {287,0.00029204}, {288,0.00018584}, {289,0.00022124}, {290,0.00017699}, {291,0.00022124}, {292,0.00038938}, {293,0.00030088}, {294,0.00018584}, {295,0.00021239}, {296,0.00016814}, {297,0.00033628}, {298,0.00017699}, {299,0.00011504}, {300,0.00006195}, {301,0.00013274}, {302,0.00015044}, {303,0.00020354}, {304,0.00028319}, {305,0.00064602}, {306,0.00015044}, {307,0.00015929}, {308,0.00005310}, {309,0.00026549}, {310,0.00013274}, {311,0.00010619}, {312,0.00016814}, {313,0.00027434}, {314,0.00015929}, {315,0.00012389}, {316,0.00008850}, {317,0.00013274}, {318,0.00029204}, {319,0.00020354}, {320,0.00029204}, {321,0.00023894}, {322,0.00012389}, {323,0.00023894}, {324,0.00036283}, {325,0.00017699}, {326,0.00019469}, {327,0.00009735}, {328,0.00041593}, {329,0.00012389}, {330,0.00015044}, {331,0.00018584}, {332,0.00029204}, {333,0.00008850}, {334,0.00026549}, {335,0.00018584}, {336,0.00015044}, {337,0.00042478}, {338,0.00014159}, {339,0.00023009}, {340,0.00012389}, {341,0.00028319}, {342,0.00046903}, {343,0.00023009}, {344,0.00027434}, {345,0.00015929}, {346,0.00014159}, {347,0.00014159}, {348,0.00026549}, {349,0.00015044}, {350,0.00034513}, {351,0.00026549}, {352,0.00036283}, {353,0.00024779}, {354,0.00018584}, {355,0.00018584}, {356,0.00028319}, {357,0.00050442}, {358,0.00041593}, {359,0.00027434}, {360,0.00015929}, {361,0.00022124}, {362,0.00023009}, {363,0.00017699}, {364,0.00015044}, {365,0.00023009}, {366,0.00029204}, {367,0.00033628}, {368,0.00015044}, {369,0.00019469}, {370,0.00017699}, {371,0.00025664}, {372,0.00043363}, {373,0.00044248}, {374,0.00012389}, {375,0.00031858}, {376,0.00016814}, {377,0.00015929}, {378,0.00044248}, {379,0.00007080}, {380,0.00014159}, {381,0.00024779}, {382,0.00016814}, {383,0.00024779}, {384,0.00034513}, {385,0.00024779}, {386,0.00035398}, {387,0.00019469}, {388,0.00041593}, {389,0.00028319}, {390,0.00023009}, {391,0.00027434}, {392,0.00017699}, {393,0.00023894}, {394,0.00019469}, {395,0.00023894}, {396,0.00017699}, {397,0.00013274}, {398,0.00035398}, {399,0.00028319}, {400,0.00035398}, {401,0.00030973}, {402,0.00016814}, {403,0.00016814}, {404,0.00028319}, {405,0.00033628}, {406,0.00041593}, {407,0.00037168}, {408,0.00023894}, {409,0.00029204}, {410,0.00030973}, {411,0.00035398}, {412,0.00024779}, {413,0.00040708}, {414,0.00036283}, {415,0.00023009}, {416,0.00030973}, {417,0.00027434}, {418,0.00059292}, {419,0.00022124}, {420,0.00028319}, {421,0.00025664}, {422,0.00087611}, {423,0.00023894}, {424,0.00034513}, {425,0.00050442}, {426,0.00043363}, {427,0.00049558}, {428,0.00038053}, {429,0.00024779}, {430,0.00031858}, {431,0.00022124}, {432,0.00018584}, {433,0.00014159}, {434,0.00032743}, {435,0.00030088}, {436,0.00036283}, {437,0.00030088}, {438,0.00020354}, {439,0.00021239}, {440,0.00030088}, {441,0.00040708}, {442,0.00017699}, {443,0.00030973}, {444,0.00031858}, {445,0.00039823}, {446,0.00015044}, {447,0.00028319}, {448,0.00018584}, {449,0.00027434}, {450,0.00031858}, {451,0.00009735}, {452,0.00033628}, {453,0.00049558}, {454,0.00035398}, {455,0.00027434}, {456,0.00016814}, {457,0.00042478}, {458,0.00020354}, {459,0.00018584}, {460,0.00025664}, {461,0.00007965}, {462,0.00033628}, {463,0.00026549}, {464,0.00038053}, {465,0.00017699}, {466,0.00043363}, {467,0.00037168}, {468,0.00006195}, {469,0.00027434}, {470,0.00030088}, {471,0.00027434}, {472,0.00029204}, {473,0.00041593}, {474,0.00036283}, {475,0.00027434}, {476,0.00032743}, {477,0.00031858}, {478,0.00049558}, {479,0.00017699}, {480,0.00038053}, {481,0.00037168}, {482,0.00045133}, {483,0.00037168}, {484,0.00015929}, {485,0.00059292}, {486,0.00040708}, {487,0.00020354}, {488,0.00030088}, {489,0.00024779}, {490,0.00053097}, {491,0.00046018}, {492,0.00020354}, {493,0.00020354}, {494,0.00044248}, {495,0.00041593}, {496,0.00053097}, {497,0.00042478}, {498,0.00035398}, {499,0.00030973}, {500,0.00051327}, {505,0.00022124}, {510,0.00046903}, {515,0.00029204}, {520,0.00032743}, {525,0.00015044}, {530,0.00034513}, {535,0.00049558}, {540,0.00047788}, {545,0.00042478}, {550,0.00034513}, {555,0.00032743}, {560,0.00038938}, {565,0.00018584}, {570,0.00032743}, {575,0.00038053}, {580,0.00037168}, {585,0.00045133}, {590,0.00053097}, {595,0.00041593}, {600,0.00035398}, {605,0.00031858}, {610,0.00055752}, {615,0.00039823}, {620,0.00030088}, {625,0.00049558}, {630,0.00051327}, {635,0.00038053}, {640,0.00029204}, {645,0.00031858}, {650,0.00040708}, {655,0.00016814}, {660,0.00057522}, {665,0.00050442}, {670,0.00046018}, {675,0.00027434}, {680,0.00028319}, {685,0.00103540}, {690,0.00056637}, {695,0.00061062}, {700,0.00057522}, {705,0.00057522}, {710,0.00041593}, {715,0.00046018}, {720,0.00031858}, {725,0.00051327}, {730,0.00042478}, {735,0.00029204}, {740,0.00038053}, {745,0.00053097}, {750,0.00061947}, {755,0.00061947}, {760,0.00044248}, {765,0.00052212}, {770,0.00041593}, {775,0.00047788}, {780,0.00047788}, {785,0.00066372}, {790,0.00035398}, {795,0.00061947}, {800,0.00038393}, {805,0.00067857}, {810,0.00035714}, {815,0.00068750}, {820,0.00060714}, {825,0.00053571}, {830,0.00046429}, {835,0.00058929}, {840,0.00025893}, {845,0.00058036}, {850,0.00056250}, {855,0.00050893}, {860,0.00049107}, {865,0.00034821}, {870,0.00056250}, {875,0.00062500}, {880,0.00206250}, {885,0.00023214}, {890,0.00049107}, {895,0.00070536}, {900,0.00051786}, {905,0.00074107}, {910,0.00059821}, {915,0.00034821}, {920,0.00052679}, {925,0.00069643}, {930,0.00067857}, {935,0.00059821}, {940,0.00034821}, {945,0.00046429}, {950,0.00050893}, {955,0.00047321}, {960,0.00049107}, {965,0.00072321}, {970,0.00066964}, {975,0.00062500}, {980,0.00044643}, {985,0.00066071}, {990,0.00097321}, {995,0.00075000}, {1000,0.00041964}, {1010,0.00048214}, {1020,0.00041964}, {1030,0.00061607}, {1040,0.00051786}, {1050,0.00042857}, {1060,0.00071429}, {1070,0.00055357}, {1080,0.00066071}, {1090,0.00063393}, {1100,0.00077679}, {1110,0.00058036}, {1120,0.00079464}, {1130,0.00057143}, {1140,0.00034821}, {1150,0.00065179}, {1160,0.00055357}, {1170,0.00053571}, {1180,0.00070536}, {1190,0.00072321}, {1200,0.00060714}, {1210,0.00108929}, {1220,0.00061607}, {1230,0.00075000}, {1240,0.00065179}, {1250,0.00062500}, {1260,0.00061607}, {1270,0.00090179}, {1280,0.00070536}, {1290,0.00069643}, {1300,0.00076786}, {1310,0.00085714}, {1320,0.00058929}, {1330,0.00042857}, {1340,0.00055357}, {1350,0.00057143}, {1360,0.00067857}, {1370,0.00104464}, {1380,0.00091071}, {1390,0.00092857}, {1400,0.00061607}, {1410,0.00089286}, {1420,0.00085714}, {1430,0.00064286}, {1440,0.00080357}, {1450,0.00075000}, {1460,0.00068750}, {1470,0.00113393}, {1480,0.00081250}, {1490,0.00070536}, {1500,0.00097321}, {1510,0.00085714}, {1520,0.00085714}, {1530,0.00060714}, {1540,0.00058929}, {1550,0.00073214}, {1560,0.00068750}, {1570,0.00094643}, {1580,0.00090179}, {1590,0.00057143}, {1600,0.00080357}, {1610,0.00087500}, {1620,0.00107143}, {1630,0.00093750}, {1640,0.00084821}, {1650,0.00107143}, {1660,0.00090179}, {1670,0.00085714}, {1680,0.00093750}, {1690,0.00120536}, {1700,0.00078571}, {1710,0.00066964}, {1720,0.00098214}, {1730,0.00096429}, {1740,0.00080357}, {1750,0.00095536}, {1760,0.00062500}, {1770,0.00091071}, {1780,0.00105357}, {1790,0.00108929}, {1800,0.00076786}, {1810,0.00135714}, {1820,0.00101786}, {1830,0.00076786}, {1840,0.00118750}, {1850,0.00097321}, {1860,0.00110714}, {1870,0.00109821}, {1880,0.00118750}, {1890,0.00107143}, {1900,0.00117857}, {1910,0.00123214}, {1920,0.00114286}, {1930,0.00097321}, {1940,0.00112500}, {1950,0.00118750}, {1960,0.00128571}, {1970,0.00119643}, {1980,0.00095536}, {1990,0.00114286}, {2000,0.00136607}, {2050,0.00100000}, {2100,0.00107143}, {2150,0.00132143}, {2200,0.00133929}, {2250,0.00135714}, {2300,0.00104464}, {2350,0.00107143}, {2400,0.00155357}, {2450,0.00132143}, {2500,0.00118750}, {2550,0.00112500}, {2600,0.00141964}, {2650,0.00162500}, {2700,0.00133929}, {2750,0.00175000}, {2800,0.00150000}, {2850,0.00136607}, {2900,0.00162500}, {2950,0.00125000}, {3000,0.00166071}, {3050,0.00179464}, {3100,0.00183929}, {3150,0.00174107}, {3200,0.00202679}, {3250,0.00177679}, {3300,0.00141964}, {3350,0.00197321}, {3400,0.00190179}, {3450,0.00214286}, {3500,0.00212500}, {3550,0.00225893}, {3600,0.00264286}, {3650,0.00232143}, {3700,0.00233036}, {3750,0.00248214}, {3800,0.00264286}, {3850,0.00260714}, {3900,0.00256250}, {3950,0.00273214}, {4000,0.00258036}, {4050,0.00303571}, {4100,0.00307143}, {4150,0.00326786}, {4200,0.00318750}, {4250,0.00346429}, {4300,0.00357143}, {4350,0.00346429}, {4400,0.00362500}, {4450,0.00378571}, {4500,0.00364286}, {4550,0.00362500}, {4600,0.00390179}, {4650,0.00385714}, {4700,0.00398214}, {4750,0.00407143}, {4800,0.00416071}, {4850,0.00407143}, {4900,0.00411607}, {4950,0.00410714}, {5000,0.00415179}, {5050,0.00452679}, {5100,0.00442857}, {5150,0.00436607}, {5200,0.00448214}, {5250,0.00453571}, {5300,0.00458929}, {5350,0.00453571}, {5400,0.00458929}, {5450,0.00458929}, {5500,0.00472321}, {5550,0.00482143}, {5600,0.00490179}, {5650,0.00491071}, {5700,0.00475000}, {5750,0.00520536}, {5800,0.00516071}, {5850,0.00500893}, {5900,0.00519643}, {5950,0.00527679}, {6000,0.00547321}, {6050,0.00536607}, {6100,0.00530357}, {6150,0.00522321}, {6200,0.00529464}, {6250,0.00553571}, {6300,0.00559821}, {6350,0.00541071}, {6400,0.00548214}, {6450,0.00585714}, {6500,0.00541964}, {6550,0.00559821}, {6600,0.00583929}, {6650,0.00536607}, {6700,0.00575893}, {6750,0.00587500}, {6800,0.00596429}, {6850,0.01065179}, {6900,0.00624107}, {6950,0.00602679}, {7000,0.00597321}, {7050,0.00651786}, {7100,0.00625893}, {7150,0.00649107}, {7200,0.00638393}, {7250,0.00612500}, {7300,0.00652679}, {7350,0.00635714}, {7400,0.00630357}, {7450,0.00655357}, {7500,0.00668750}, {7550,0.00642857}, {7600,0.00670536}, {7650,0.00685714}, {7700,0.00689286}, {7750,0.00664286}, {7800,0.00675000}, {7850,0.00693750}, {7900,0.00687500}, {7950,0.00698214}, {8000,0.00702679}, {8050,0.00717857}, {8100,0.00721429}, {8150,0.00728571}, {8200,0.00728571}, {8250,0.00733929}, {8300,0.00730357}, {8350,0.00723214}, {8400,0.00761607}, {8450,0.00785714}, {8500,0.01298214}, {8550,0.00801786}, {8600,0.00790179}, {8650,0.00800000}, {8700,0.00797321}, {8750,0.01358036}, {8800,0.00811607}, {8850,0.00821429}, {8900,0.00874107}, {8950,0.00827679}, {9000,0.00852679}, {9050,0.00880357}, {9100,0.00849107}, {9150,0.00869643}, {9200,0.00881250}, {9250,0.00875893}, {9300,0.00859821}, {9350,0.00891964}, {9400,0.00866964}, {9450,0.00902679}, {9500,0.00890179}, {9550,0.00883929}, {9600,0.00915179}, {9650,0.00912500}, {9700,0.00942857}, {9750,0.01325893}, {9800,0.00925893}, {9850,0.00929464}, {9900,0.00943750}, {9950,0.00979464}, {10000,0.00943750}, {10100,0.01367857}, {10200,0.00962500}, {10300,0.01009821}, {10400,0.01778571}, {10500,0.01038393}, {10600,0.00986607}, {10700,0.01025000}, {10800,0.01040179}, {10900,0.01087500}, {11000,0.01047321}, {11100,0.01084821}, {11200,0.01057143}, {11300,0.01083929}, {11400,0.01129464}, {11500,0.01096429}, {11600,0.01115179}, {11700,0.01150000}, {11800,0.01150000}, {11900,0.01175000}, {12000,0.01211607}, {12100,0.01195536}, {12200,0.01212500}, {12300,0.01225000}, {12400,0.01182143}, {12500,0.01213393}, {12600,0.01175}, {12700,0.02150}, {12800,0.01300}, {12900,0.01300}, {13000,0.01175}, {13100,0.01275}, {13200,0.01200}, {13300,0.01350}, {13400,0.01275}, {13500,0.01300}, {13600,0.01200}, {13700,0.01475}, {13800,0.01300}, {13900,0.01275}, {14000,0.01275}, {14100,0.01300}, {14200,0.02400}, {14300,0.01275}, {14400,0.01375}, {14500,0.01575}, {14600,0.01500}, {14700,0.01375}, {14800,0.01450}, {14900,0.01875}, {15000,0.01375}, {15100,0.01375}, {15200,0.02125}, {15300,0.01475}, {15400,0.01350}, {15500,0.02350}, {15600,0.01450}, {15700,0.01475}, {15800,0.02175}, {15900,0.01750}, {16000,0.01575}, {16100,0.01650}, {16200,0.01925}, {16300,0.01850}, {16400,0.01750}, {16500,0.01450}, {16600,0.02250}, {16700,0.01525}, {16800,0.01625}, {16900,0.01675}, {17000,0.02250}, {17100,0.01575}, {17200,0.01575}, {17300,0.01800}, {17400,0.01775}, {17500,0.02925}, {17600,0.01600}, {17700,0.01550}, {17800,0.01625}, {17900,0.01600}, {18000,0.01725}, {18100,0.02325}, {18200,0.01700}, {18300,0.02225}, {18400,0.01850}, {18500,0.01700}, {18600,0.02525}, {18700,0.01650}, {18800,0.01625}, {18900,0.01750}, {19000,0.01725}, {19100,0.01850}, {19200,0.01950}, {19300,0.01950}, {19400,0.01875}, {19500,0.03250}, {19600,0.01975}, {19700,0.01850}, {19800,0.01950}, {19900,0.01975}, {20000,0.0355}};
data["big_flat"]["identity cbv"]["Stats"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00002655}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00003540}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00002655}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00003540}, {240,0.00003540}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00002655}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00003540}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00002655}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00006195}, {306,0.00000000}, {307,0.00003540}, {308,0.00000000}, {309,0.00003540}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00003540}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00003540}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00003540}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00003540}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00003540}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00003540}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00003540}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00003540}, {461,0.00003540}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00003540}, {475,0.00000000}, {476,0.00000000}, {477,0.00003540}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00003540}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00003540}, {491,0.00003540}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00003540}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00007080}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00003540}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00003540}, {590,0.00003540}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00003540}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00003540}, {690,0.00003540}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00003540}, {730,0.00003540}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00003540}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00002679}, {855,0.00000000}, {860,0.00003571}, {865,0.00000000}, {870,0.00003571}, {875,0.00003571}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00003571}, {900,0.00000000}, {905,0.00003571}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00002679}, {940,0.00000000}, {945,0.00003571}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00003571}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00003571}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00003571}, {1130,0.00000000}, {1140,0.00003571}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00003571}, {1240,0.00000000}, {1250,0.00007143}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00003571}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00003571}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00003571}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00003571}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00003571}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00007143}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00003571}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00003571}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00003571}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00003571}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00003571}, {1860,0.00000000}, {1870,0.00003571}, {1880,0.00000000}, {1890,0.00010714}, {1900,0.00000000}, {1910,0.00006250}, {1920,0.00003571}, {1930,0.00002679}, {1940,0.00002679}, {1950,0.00000000}, {1960,0.00003571}, {1970,0.00000000}, {1980,0.00003571}, {1990,0.00000000}, {2000,0.00002679}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00003571}, {2300,0.00000000}, {2350,0.00003571}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00010714}, {3100,0.00006250}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00003571}, {3450,0.00003571}, {3500,0.00006250}, {3550,0.00002679}, {3600,0.00003571}, {3650,0.00000000}, {3700,0.00003571}, {3750,0.00007143}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00003571}, {4000,0.00002679}, {4050,0.00000000}, {4100,0.00007143}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00000000}, {4900,0.00003571}, {4950,0.00000000}, {5000,0.00003571}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00003571}, {5200,0.00000000}, {5250,0.00002679}, {5300,0.00003571}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00003571}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00003571}, {5650,0.00000000}, {5700,0.00006250}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00003571}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00002679}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00002679}, {6300,0.00003571}, {6350,0.00003571}, {6400,0.00007143}, {6450,0.00000000}, {6500,0.00007143}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00003571}, {6700,0.00003571}, {6750,0.00000000}, {6800,0.00003571}, {6850,0.00014286}, {6900,0.00003571}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00000000}, {7150,0.00003571}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00003571}, {7500,0.00000000}, {7550,0.00000000}, {7600,0.00002679}, {7650,0.00007143}, {7700,0.00007143}, {7750,0.00003571}, {7800,0.00006250}, {7850,0.00003571}, {7900,0.00000000}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00000000}, {8100,0.00000000}, {8150,0.00003571}, {8200,0.00007143}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00003571}, {8400,0.00003571}, {8450,0.00000000}, {8500,0.00010714}, {8550,0.00000000}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00016964}, {8800,0.00000000}, {8850,0.00003571}, {8900,0.00002679}, {8950,0.00000000}, {9000,0.00003571}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00000000}, {9200,0.00003571}, {9250,0.00003571}, {9300,0.00003571}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00000000}, {10000,0.00007143}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00003571}, {10400,0.00000000}, {10500,0.00000000}, {10600,0.00003571}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00003571}, {11000,0.00000000}, {11100,0.00003571}, {11200,0.00003571}, {11300,0.00003571}, {11400,0.00000000}, {11500,0.00007143}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00000000}, {12200,0.00000000}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00075}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["identity lazy"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000885}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00098230}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00098230}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00002679}, {1150,0.00000893}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000893}, {1210,0.00000893}, {1220,0.00000000}, {1230,0.00000893}, {1240,0.00000893}, {1250,0.00008036}, {1260,0.00013393}, {1270,0.00011607}, {1280,0.00237500}, {1290,0.00025893}, {1300,0.00028571}, {1310,0.00028571}, {1320,0.00041071}, {1330,0.00054464}, {1340,0.00058036}, {1350,0.00068750}, {1360,0.00066964}, {1370,0.00072321}, {1380,0.00072321}, {1390,0.00074107}, {1400,0.00080357}, {1410,0.00081250}, {1420,0.00088393}, {1430,0.00095536}, {1440,0.00100000}, {1450,0.00098214}, {1460,0.00100000}, {1470,0.00100893}, {1480,0.00100000}, {1490,0.00100000}, {1500,0.00100000}, {1510,0.00100000}, {1520,0.00100000}, {1530,0.00100000}, {1540,0.00100000}, {1550,0.00100000}, {1560,0.00100000}, {1570,0.00100000}, {1580,0.00100000}, {1590,0.00100000}, {1600,0.00100000}, {1610,0.00100000}, {1620,0.00100000}, {1630,0.00100000}, {1640,0.00100000}, {1650,0.00100000}, {1660,0.00100000}, {1670,0.00100000}, {1680,0.00100000}, {1690,0.00100000}, {1700,0.00100000}, {1710,0.00100000}, {1720,0.00286607}, {1730,0.00100000}, {1740,0.00100000}, {1750,0.00100893}, {1760,0.00100000}, {1770,0.00100000}, {1780,0.00100000}, {1790,0.00100000}, {1800,0.00100000}, {1810,0.00100000}, {1820,0.00100000}, {1830,0.00100000}, {1840,0.00100000}, {1850,0.00100000}, {1860,0.00100000}, {1870,0.00100000}, {1880,0.00100000}, {1890,0.00100000}, {1900,0.00100000}, {1910,0.00100000}, {1920,0.00100000}, {1930,0.00100000}, {1940,0.00100000}, {1950,0.00100000}, {1960,0.00100000}, {1970,0.00100000}, {1980,0.00104464}, {1990,0.00100000}, {2000,0.00100000}, {2050,0.00100000}, {2100,0.00100000}, {2150,0.00100000}, {2200,0.00100893}, {2250,0.00100893}, {2300,0.00111607}, {2350,0.00141071}, {2400,0.00171429}, {2450,0.00173214}, {2500,0.00174107}, {2550,0.00175893}, {2600,0.00191071}, {2650,0.00198214}, {2700,0.00199107}, {2750,0.00199107}, {2800,0.00216964}, {2850,0.00200000}, {2900,0.00200000}, {2950,0.00200000}, {3000,0.00200000}, {3050,0.00200000}, {3100,0.00200000}, {3150,0.00200000}, {3200,0.00200000}, {3250,0.00200000}, {3300,0.00200000}, {3350,0.00200000}, {3400,0.00213393}, {3450,0.00221429}, {3500,0.00235714}, {3550,0.00274107}, {3600,0.00274107}, {3650,0.00275000}, {3700,0.00274107}, {3750,0.00275893}, {3800,0.00283036}, {3850,0.00290179}, {3900,0.00295536}, {3950,0.00299107}, {4000,0.00298214}, {4050,0.00300000}, {4100,0.00300000}, {4150,0.00300000}, {4200,0.00300000}, {4250,0.00300000}, {4300,0.00300000}, {4350,0.00300000}, {4400,0.00475000}, {4450,0.00300893}, {4500,0.00300893}, {4550,0.00991071}, {4600,0.00341071}, {4650,0.00343750}, {4700,0.00355357}, {4750,0.00372321}, {4800,0.00375893}, {4850,0.00375893}, {4900,0.00375893}, {4950,0.00378571}, {5000,0.00378571}, {5050,0.00383036}, {5100,0.00386607}, {5150,0.00393750}, {5200,0.00399107}, {5250,0.00400000}, {5300,0.00399107}, {5350,0.00400000}, {5400,0.00729464}, {5450,0.00411607}, {5500,0.00400893}, {5550,0.00400000}, {5600,0.00400893}, {5650,0.00405357}, {5700,0.00406250}, {5750,0.00423214}, {5800,0.00456250}, {5850,0.00467857}, {5900,0.00460714}, {5950,0.00609821}, {6000,0.00475893}, {6050,0.00475893}, {6100,0.00476786}, {6150,0.00475000}, {6200,0.00475000}, {6250,0.00476786}, {6300,0.00478571}, {6350,0.00483036}, {6400,0.00486607}, {6450,0.00504464}, {6500,0.00499107}, {6550,0.00499107}, {6600,0.01157143}, {6650,0.00500000}, {6700,0.00501786}, {6750,0.00511607}, {6800,0.00505357}, {6850,0.00498214}, {6900,0.00544643}, {6950,0.00562500}, {7000,0.00568750}, {7050,0.01027679}, {7100,0.00549107}, {7150,0.00570536}, {7200,0.00568750}, {7250,0.00569643}, {7300,0.00569643}, {7350,0.00766964}, {7400,0.00571429}, {7450,0.00583929}, {7500,0.00571429}, {7550,0.00533929}, {7600,0.01934821}, {7650,0.00579464}, {7700,0.00587500}, {7750,0.01663393}, {7800,0.00571429}, {7850,0.00605357}, {7900,0.00600000}, {7950,0.00607143}, {8000,0.00771429}, {8050,0.00633036}, {8100,0.00644643}, {8150,0.00683036}, {8200,0.00673214}, {8250,0.00673214}, {8300,0.01163393}, {8350,0.00673214}, {8400,0.00673214}, {8450,0.00705357}, {8500,0.00610714}, {8550,0.02502679}, {8600,0.00673214}, {8650,0.00673214}, {8700,0.02257143}, {8750,0.00650893}, {8800,0.00688393}, {8850,0.00681250}, {8900,0.00684821}, {8950,0.01194643}, {9000,0.00701786}, {9050,0.00738393}, {9100,0.00710714}, {9150,0.00733929}, {9200,0.00747321}, {9250,0.00749107}, {9300,0.00746429}, {9350,0.00764286}, {9400,0.00698214}, {9450,0.02291071}, {9500,0.00760714}, {9550,0.00766964}, {9600,0.00766964}, {9650,0.00766964}, {9700,0.00766964}, {9750,0.00700000}, {9800,0.00766964}, {9850,0.00766071}, {9900,0.00766964}, {9950,0.00766071}, {10000,0.00774107}, {10100,0.00746429}, {10200,0.00807143}, {10300,0.00875000}, {10400,0.00766071}, {10500,0.03121429}, {10600,0.00860714}, {10700,0.01509821}, {10800,0.00858036}, {10900,0.00856250}, {11000,0.03488393}, {11100,0.00869643}, {11200,0.01403571}, {11300,0.00885714}, {11400,0.00943750}, {11500,0.00992857}, {11600,0.00991964}, {11700,0.00956250}, {11800,0.02555357}, {11900,0.00958036}, {12000,0.00957143}, {12100,0.00958929}, {12200,0.02617857}, {12300,0.00985714}, {12400,0.00983036}, {12500,0.01004464}, {12600,0.02950}, {12700,0.00950}, {12800,0.01050}, {12900,0.01050}, {13000,0.01000}, {13100,0.01075}, {13200,0.01075}, {13300,0.01075}, {13400,0.01000}, {13500,0.01025}, {13600,0.01100}, {13700,0.01100}, {13800,0.01075}, {13900,0.01075}, {14000,0.01100}, {14100,0.01125}, {14200,0.01100}, {14300,0.03900}, {14400,0.01875}, {14500,0.01450}, {14600,0.01425}, {14700,0.01225}, {14800,0.01175}, {14900,0.01125}, {15000,0.01200}, {15100,0.01225}, {15200,0.01175}, {15300,0.01150}, {15400,0.01400}, {15500,0.01225}, {15600,0.01275}, {15700,0.02125}, {15800,0.01250}, {15900,0.03250}, {16000,0.01300}, {16100,0.02475}, {16200,0.01250}, {16300,0.01300}, {16400,0.01275}, {16500,0.01350}, {16600,0.01350}, {16700,0.03300}, {16800,0.03025}, {16900,0.03100}, {17000,0.01375}, {17100,0.03250}, {17200,0.01400}, {17300,0.01425}, {17400,0.03350}, {17500,0.01325}, {17600,0.02925}, {17700,0.01400}, {17800,0.01450}, {17900,0.03200}, {18000,0.01475}, {18100,0.01425}, {18200,0.02025}, {18300,0.01475}, {18400,0.01500}, {18500,0.01550}, {18600,0.01475}, {18700,0.01525}, {18800,0.03075}, {18900,0.01525}, {19000,0.01550}, {19100,0.01525}, {19200,0.01525}, {19300,0.01625}, {19400,0.01625}, {19500,0.03450}, {19600,0.01600}, {19700,0.04150}, {19800,0.01625}, {19900,0.01575}, {20000,0.0150}};
data["big_flat"]["identity lazy"]["Stats"]["user"] = {{1,0.00000000}, {2,0.00002655}, {3,0.00000000}, {4,0.00000000}, {5,0.00005310}, {6,0.00000000}, {7,0.00002655}, {8,0.00002655}, {9,0.00000000}, {10,0.00006195}, {11,0.00002655}, {12,0.00002655}, {13,0.00002655}, {14,0.00002655}, {15,0.00007965}, {16,0.00005310}, {17,0.00003540}, {18,0.00006195}, {19,0.00006195}, {20,0.00002655}, {21,0.00000000}, {22,0.00006195}, {23,0.00006195}, {24,0.00006195}, {25,0.00002655}, {26,0.00011504}, {27,0.00008850}, {28,0.00005310}, {29,0.00002655}, {30,0.00008850}, {31,0.00007965}, {32,0.00013274}, {33,0.00005310}, {34,0.00005310}, {35,0.00000000}, {36,0.00007080}, {37,0.00006195}, {38,0.00008850}, {39,0.00005310}, {40,0.00015929}, {41,0.00002655}, {42,0.00005310}, {43,0.00002655}, {44,0.00000000}, {45,0.00005310}, {46,0.00000000}, {47,0.00005310}, {48,0.00000000}, {49,0.00006195}, {50,0.00006195}, {51,0.00011504}, {52,0.00007965}, {53,0.00002655}, {54,0.00005310}, {55,0.00009735}, {56,0.00002655}, {57,0.00012389}, {58,0.00002655}, {59,0.00005310}, {60,0.00005310}, {61,0.00010619}, {62,0.00002655}, {63,0.00009735}, {64,0.00007080}, {65,0.00011504}, {66,0.00009735}, {67,0.00009735}, {68,0.00014159}, {69,0.00007965}, {70,0.00009735}, {71,0.00003540}, {72,0.00000000}, {73,0.00002655}, {74,0.00002655}, {75,0.00007965}, {76,0.00006195}, {77,0.00007965}, {78,0.00009735}, {79,0.00000000}, {80,0.00002655}, {81,0.00015044}, {82,0.00011504}, {83,0.00005310}, {84,0.00002655}, {85,0.00007965}, {86,0.00011504}, {87,0.00005310}, {88,0.00015044}, {89,0.00000000}, {90,0.00005310}, {91,0.00014159}, {92,0.00008850}, {93,0.00002655}, {94,0.00008850}, {95,0.00015044}, {96,0.00006195}, {97,0.00007965}, {98,0.00003540}, {99,0.00005310}, {100,0.00002655}, {101,0.00007965}, {102,0.00006195}, {103,0.00022124}, {104,0.00015044}, {105,0.00014159}, {106,0.00015929}, {107,0.00019469}, {108,0.00005310}, {109,0.00007965}, {110,0.00006195}, {111,0.00017699}, {112,0.00005310}, {113,0.00011504}, {114,0.00014159}, {115,0.00006195}, {116,0.00002655}, {117,0.00017699}, {118,0.00005310}, {119,0.00017699}, {120,0.00002655}, {121,0.00025664}, {122,0.00015044}, {123,0.00011504}, {124,0.00000000}, {125,0.00015044}, {126,0.00011504}, {127,0.00012389}, {128,0.00002655}, {129,0.00005310}, {130,0.00014159}, {131,0.00016814}, {132,0.00014159}, {133,0.00013274}, {134,0.00016814}, {135,0.00007965}, {136,0.00019469}, {137,0.00014159}, {138,0.00006195}, {139,0.00016814}, {140,0.00014159}, {141,0.00005310}, {142,0.00014159}, {143,0.00012389}, {144,0.00011504}, {145,0.00002655}, {146,0.00010619}, {147,0.00015044}, {148,0.00020354}, {149,0.00000000}, {150,0.00032743}, {151,0.00007965}, {152,0.00014159}, {153,0.00011504}, {154,0.00014159}, {155,0.00007965}, {156,0.00009735}, {157,0.00021239}, {158,0.00015929}, {159,0.00016814}, {160,0.00011504}, {161,0.00007965}, {162,0.00015044}, {163,0.00018584}, {164,0.00008850}, {165,0.00021239}, {166,0.00005310}, {167,0.00017699}, {168,0.00011504}, {169,0.00012389}, {170,0.00009735}, {171,0.00007965}, {172,0.00005310}, {173,0.00017699}, {174,0.00007080}, {175,0.00008850}, {176,0.00020354}, {177,0.00015929}, {178,0.00010619}, {179,0.00016814}, {180,0.00022124}, {181,0.00024779}, {182,0.00010619}, {183,0.00008850}, {184,0.00025664}, {185,0.00019469}, {186,0.00016814}, {187,0.00015044}, {188,0.00021239}, {189,0.00015929}, {190,0.00013274}, {191,0.00015929}, {192,0.00011504}, {193,0.00008850}, {194,0.00016814}, {195,0.00026549}, {196,0.00015044}, {197,0.00014159}, {198,0.00023009}, {199,0.00002655}, {200,0.00017699}, {201,0.00015929}, {202,0.00015929}, {203,0.00014159}, {204,0.00015929}, {205,0.00011504}, {206,0.00023009}, {207,0.00023894}, {208,0.00005310}, {209,0.00015929}, {210,0.00021239}, {211,0.00012389}, {212,0.00018584}, {213,0.00008850}, {214,0.00002655}, {215,0.00020354}, {216,0.00032743}, {217,0.00015929}, {218,0.00007965}, {219,0.00018584}, {220,0.00010619}, {221,0.00019469}, {222,0.00019469}, {223,0.00015929}, {224,0.00019469}, {225,0.00016814}, {226,0.00014159}, {227,0.00012389}, {228,0.00016814}, {229,0.00013274}, {230,0.00008850}, {231,0.00023009}, {232,0.00007965}, {233,0.00039823}, {234,0.00011504}, {235,0.00012389}, {236,0.00021239}, {237,0.00015044}, {238,0.00023894}, {239,0.00019469}, {240,0.00007965}, {241,0.00018584}, {242,0.00007965}, {243,0.00023894}, {244,0.00007965}, {245,0.00011504}, {246,0.00019469}, {247,0.00024779}, {248,0.00022124}, {249,0.00029204}, {250,0.00021239}, {251,0.00015929}, {252,0.00011504}, {253,0.00023894}, {254,0.00023009}, {255,0.00018584}, {256,0.00009735}, {257,0.00027434}, {258,0.00007965}, {259,0.00013274}, {260,0.00023009}, {261,0.00028319}, {262,0.00025664}, {263,0.00015044}, {264,0.00007965}, {265,0.00018584}, {266,0.00026549}, {267,0.00021239}, {268,0.00015044}, {269,0.00014159}, {270,0.00013274}, {271,0.00019469}, {272,0.00011504}, {273,0.00011504}, {274,0.00024779}, {275,0.00017699}, {276,0.00012389}, {277,0.00015929}, {278,0.00014159}, {279,0.00030973}, {280,0.00007965}, {281,0.00007965}, {282,0.00015929}, {283,0.00006195}, {284,0.00022124}, {285,0.00007965}, {286,0.00014159}, {287,0.00015929}, {288,0.00016814}, {289,0.00023894}, {290,0.00008850}, {291,0.00019469}, {292,0.00015929}, {293,0.00025664}, {294,0.00018584}, {295,0.00007965}, {296,0.00025664}, {297,0.00015044}, {298,0.00012389}, {299,0.00030088}, {300,0.00008850}, {301,0.00040708}, {302,0.00020354}, {303,0.00011504}, {304,0.00015929}, {305,0.00038938}, {306,0.00030088}, {307,0.00011504}, {308,0.00031858}, {309,0.00025664}, {310,0.00007965}, {311,0.00031858}, {312,0.00023894}, {313,0.00015929}, {314,0.00030973}, {315,0.00041593}, {316,0.00023009}, {317,0.00042478}, {318,0.00016814}, {319,0.00027434}, {320,0.00023894}, {321,0.00016814}, {322,0.00036283}, {323,0.00027434}, {324,0.00011504}, {325,0.00006195}, {326,0.00015044}, {327,0.00020354}, {328,0.00038053}, {329,0.00030088}, {330,0.00020354}, {331,0.00030088}, {332,0.00015929}, {333,0.00020354}, {334,0.00025664}, {335,0.00023009}, {336,0.00031858}, {337,0.00017699}, {338,0.00013274}, {339,0.00032743}, {340,0.00019469}, {341,0.00023009}, {342,0.00023894}, {343,0.00030973}, {344,0.00015929}, {345,0.00026549}, {346,0.00038938}, {347,0.00026549}, {348,0.00036283}, {349,0.00018584}, {350,0.00042478}, {351,0.00023894}, {352,0.00040708}, {353,0.00014159}, {354,0.00053097}, {355,0.00020354}, {356,0.00022124}, {357,0.00025664}, {358,0.00028319}, {359,0.00042478}, {360,0.00032743}, {361,0.00041593}, {362,0.00025664}, {363,0.00025664}, {364,0.00036283}, {365,0.00019469}, {366,0.00012389}, {367,0.00036283}, {368,0.00029204}, {369,0.00044248}, {370,0.00025664}, {371,0.00029204}, {372,0.00010619}, {373,0.00050442}, {374,0.00022124}, {375,0.00033628}, {376,0.00018584}, {377,0.00047788}, {378,0.00031858}, {379,0.00022124}, {380,0.00036283}, {381,0.00021239}, {382,0.00034513}, {383,0.00028319}, {384,0.00027434}, {385,0.00032743}, {386,0.00025664}, {387,0.00038053}, {388,0.00022124}, {389,0.00009735}, {390,0.00021239}, {391,0.00027434}, {392,0.00031858}, {393,0.00005310}, {394,0.00015044}, {395,0.00025664}, {396,0.00026549}, {397,0.00044248}, {398,0.00024779}, {399,0.00021239}, {400,0.00029204}, {401,0.00017699}, {402,0.00046018}, {403,0.00039823}, {404,0.00044248}, {405,0.00036283}, {406,0.00117699}, {407,0.00038053}, {408,0.00025664}, {409,0.00046018}, {410,0.00025664}, {411,0.00032743}, {412,0.00025664}, {413,0.00012389}, {414,0.00020354}, {415,0.00034513}, {416,0.00027434}, {417,0.00032743}, {418,0.00024779}, {419,0.00024779}, {420,0.00025664}, {421,0.00018584}, {422,0.00030973}, {423,0.00052212}, {424,0.00028319}, {425,0.00031858}, {426,0.00036283}, {427,0.00013274}, {428,0.00034513}, {429,0.00043363}, {430,0.00026549}, {431,0.00038053}, {432,0.00015044}, {433,0.00024779}, {434,0.00023009}, {435,0.00023894}, {436,0.00023009}, {437,0.00039823}, {438,0.00043363}, {439,0.00031858}, {440,0.00038053}, {441,0.00028319}, {442,0.00050442}, {443,0.00035398}, {444,0.00019469}, {445,0.00050442}, {446,0.00032743}, {447,0.00040708}, {448,0.00041593}, {449,0.00030973}, {450,0.00032743}, {451,0.00029204}, {452,0.00032743}, {453,0.00032743}, {454,0.00041593}, {455,0.00046018}, {456,0.00036283}, {457,0.00028319}, {458,0.00013274}, {459,0.00034513}, {460,0.00030088}, {461,0.00030088}, {462,0.00033628}, {463,0.00048673}, {464,0.00025664}, {465,0.00023894}, {466,0.00019469}, {467,0.00027434}, {468,0.00043363}, {469,0.00031858}, {470,0.00044248}, {471,0.00039823}, {472,0.00023894}, {473,0.00038938}, {474,0.00022124}, {475,0.00026549}, {476,0.00014159}, {477,0.00046018}, {478,0.00025664}, {479,0.00038053}, {480,0.00031858}, {481,0.00044248}, {482,0.00038053}, {483,0.00030088}, {484,0.00025664}, {485,0.00046018}, {486,0.00048673}, {487,0.00038938}, {488,0.00030088}, {489,0.00038938}, {490,0.00031858}, {491,0.00026549}, {492,0.00024779}, {493,0.00030973}, {494,0.00050442}, {495,0.00030973}, {496,0.00063717}, {497,0.00059292}, {498,0.00040708}, {499,0.00056637}, {500,0.00017699}, {505,0.00038938}, {510,0.00036283}, {515,0.00052212}, {520,0.00048673}, {525,0.00040708}, {530,0.00018584}, {535,0.00066372}, {540,0.00047788}, {545,0.00035398}, {550,0.00038053}, {555,0.00043363}, {560,0.00049558}, {565,0.00037168}, {570,0.00035398}, {575,0.00038938}, {580,0.00016814}, {585,0.00030088}, {590,0.00046018}, {595,0.00037168}, {600,0.00052212}, {605,0.00049558}, {610,0.00035398}, {615,0.00022124}, {620,0.00047788}, {625,0.00020354}, {630,0.00063717}, {635,0.00068142}, {640,0.00036283}, {645,0.00059292}, {650,0.00038938}, {655,0.00038053}, {660,0.00049558}, {665,0.00044248}, {670,0.00054867}, {675,0.00063717}, {680,0.00063717}, {685,0.00079646}, {690,0.00045133}, {695,0.00047788}, {700,0.00035398}, {705,0.00034513}, {710,0.00064602}, {715,0.00057522}, {720,0.00064602}, {725,0.00032743}, {730,0.00027434}, {735,0.00053097}, {740,0.00056637}, {745,0.00162832}, {750,0.00031858}, {755,0.00060177}, {760,0.00038053}, {765,0.00036283}, {770,0.00046903}, {775,0.00058407}, {780,0.00043363}, {785,0.00046903}, {790,0.00070796}, {795,0.00027434}, {800,0.00052679}, {805,0.00049107}, {810,0.00072321}, {815,0.00055357}, {820,0.00069643}, {825,0.00066071}, {830,0.00056250}, {835,0.00050000}, {840,0.00058929}, {845,0.00028571}, {850,0.00066071}, {855,0.00033036}, {860,0.00058929}, {865,0.00067857}, {870,0.00047321}, {875,0.00052679}, {880,0.00058036}, {885,0.00080357}, {890,0.00062500}, {895,0.00070536}, {900,0.00043750}, {905,0.00066071}, {910,0.00076786}, {915,0.00052679}, {920,0.00058929}, {925,0.00042857}, {930,0.00058929}, {935,0.00071429}, {940,0.00053571}, {945,0.00079464}, {950,0.00058036}, {955,0.00078571}, {960,0.00093750}, {965,0.00050893}, {970,0.00041071}, {975,0.00063393}, {980,0.00065179}, {985,0.00064286}, {990,0.00054464}, {995,0.00083929}, {1000,0.00062500}, {1010,0.00068750}, {1020,0.00076786}, {1030,0.00065179}, {1040,0.00058929}, {1050,0.00062500}, {1060,0.00053571}, {1070,0.00073214}, {1080,0.00055357}, {1090,0.00082143}, {1100,0.00071429}, {1110,0.00062500}, {1120,0.00083036}, {1130,0.00077679}, {1140,0.00057143}, {1150,0.00083036}, {1160,0.00058929}, {1170,0.00068750}, {1180,0.00082143}, {1190,0.00054464}, {1200,0.00075000}, {1210,0.00039286}, {1220,0.00066964}, {1230,0.00060714}, {1240,0.00086607}, {1250,0.00083929}, {1260,0.00100893}, {1270,0.00057143}, {1280,0.00239286}, {1290,0.00085714}, {1300,0.00079464}, {1310,0.00062500}, {1320,0.00069643}, {1330,0.00103571}, {1340,0.00092857}, {1350,0.00081250}, {1360,0.00087500}, {1370,0.00075893}, {1380,0.00098214}, {1390,0.00060714}, {1400,0.00103571}, {1410,0.00089286}, {1420,0.00091071}, {1430,0.00080357}, {1440,0.00096429}, {1450,0.00100893}, {1460,0.00115179}, {1470,0.00070536}, {1480,0.00108929}, {1490,0.00102679}, {1500,0.00084821}, {1510,0.00082143}, {1520,0.00070536}, {1530,0.00093750}, {1540,0.00077679}, {1550,0.00108929}, {1560,0.00093750}, {1570,0.00094643}, {1580,0.00095536}, {1590,0.00096429}, {1600,0.00109821}, {1610,0.00100000}, {1620,0.00098214}, {1630,0.00096429}, {1640,0.00094643}, {1650,0.00100000}, {1660,0.00110714}, {1670,0.00084821}, {1680,0.00115179}, {1690,0.00086607}, {1700,0.00124107}, {1710,0.00116964}, {1720,0.00258929}, {1730,0.00089286}, {1740,0.00125000}, {1750,0.00103571}, {1760,0.00149107}, {1770,0.00098214}, {1780,0.00107143}, {1790,0.00092857}, {1800,0.00135714}, {1810,0.00091071}, {1820,0.00105357}, {1830,0.00136607}, {1840,0.00108036}, {1850,0.00112500}, {1860,0.00117857}, {1870,0.00117857}, {1880,0.00115179}, {1890,0.00106250}, {1900,0.00125000}, {1910,0.00113393}, {1920,0.00110714}, {1930,0.00116071}, {1940,0.00104464}, {1950,0.00116071}, {1960,0.00104464}, {1970,0.00119643}, {1980,0.00111607}, {1990,0.00148214}, {2000,0.00149107}, {2050,0.00127679}, {2100,0.00137500}, {2150,0.00141964}, {2200,0.00147321}, {2250,0.00132143}, {2300,0.00190179}, {2350,0.00179464}, {2400,0.00127679}, {2450,0.00186607}, {2500,0.00190179}, {2550,0.00197321}, {2600,0.00168750}, {2650,0.00175000}, {2700,0.00197321}, {2750,0.00160714}, {2800,0.00216964}, {2850,0.00223214}, {2900,0.00209821}, {2950,0.00241071}, {3000,0.00215179}, {3050,0.00216071}, {3100,0.00218750}, {3150,0.00203571}, {3200,0.00212500}, {3250,0.00229464}, {3300,0.00265179}, {3350,0.00228571}, {3400,0.00222321}, {3450,0.00225893}, {3500,0.00249107}, {3550,0.00275000}, {3600,0.00233036}, {3650,0.00246429}, {3700,0.00260714}, {3750,0.00258036}, {3800,0.00266071}, {3850,0.00288393}, {3900,0.00274107}, {3950,0.00270536}, {4000,0.00279464}, {4050,0.00301786}, {4100,0.00301786}, {4150,0.00320536}, {4200,0.00316071}, {4250,0.00303571}, {4300,0.00337500}, {4350,0.00350893}, {4400,0.00456250}, {4450,0.00342857}, {4500,0.00345536}, {4550,0.01048214}, {4600,0.00350893}, {4650,0.00354464}, {4700,0.00364286}, {4750,0.00368750}, {4800,0.00363393}, {4850,0.00372321}, {4900,0.00359821}, {4950,0.00380357}, {5000,0.00389286}, {5050,0.00381250}, {5100,0.00374107}, {5150,0.00385714}, {5200,0.00397321}, {5250,0.00416964}, {5300,0.00400893}, {5350,0.00431250}, {5400,0.00724107}, {5450,0.00438393}, {5500,0.00462500}, {5550,0.00408929}, {5600,0.00391964}, {5650,0.00427679}, {5700,0.00456250}, {5750,0.00447321}, {5800,0.00434821}, {5850,0.00444643}, {5900,0.00450000}, {5950,0.00622321}, {6000,0.00466964}, {6050,0.00469643}, {6100,0.00480357}, {6150,0.00483929}, {6200,0.00496429}, {6250,0.00450893}, {6300,0.00462500}, {6350,0.00514286}, {6400,0.00500893}, {6450,0.00495536}, {6500,0.00521429}, {6550,0.00513393}, {6600,0.01208036}, {6650,0.00516071}, {6700,0.00540179}, {6750,0.00498214}, {6800,0.00523214}, {6850,0.00475893}, {6900,0.00500893}, {6950,0.00516071}, {7000,0.00550000}, {7050,0.01016071}, {7100,0.00527679}, {7150,0.00533036}, {7200,0.00538393}, {7250,0.00566964}, {7300,0.00564286}, {7350,0.00775000}, {7400,0.00552679}, {7450,0.00584821}, {7500,0.00559821}, {7550,0.00538393}, {7600,0.01893750}, {7650,0.00549107}, {7700,0.00603571}, {7750,0.01644643}, {7800,0.00560714}, {7850,0.00604464}, {7900,0.00603571}, {7950,0.00601786}, {8000,0.00750000}, {8050,0.00647321}, {8100,0.00635714}, {8150,0.00638393}, {8200,0.00646429}, {8250,0.00658929}, {8300,0.01190179}, {8350,0.00658036}, {8400,0.00669643}, {8450,0.00707143}, {8500,0.00597321}, {8550,0.02466964}, {8600,0.00706250}, {8650,0.00685714}, {8700,0.02265179}, {8750,0.00621429}, {8800,0.00683036}, {8850,0.00700000}, {8900,0.00705357}, {8950,0.01207143}, {9000,0.00715179}, {9050,0.00725000}, {9100,0.00710714}, {9150,0.00740179}, {9200,0.00750893}, {9250,0.00741071}, {9300,0.00744643}, {9350,0.00736607}, {9400,0.00704464}, {9450,0.02341964}, {9500,0.00760714}, {9550,0.00764286}, {9600,0.00775893}, {9650,0.00782143}, {9700,0.00787500}, {9750,0.00721429}, {9800,0.00771429}, {9850,0.00798214}, {9900,0.00798214}, {9950,0.00757143}, {10000,0.00811607}, {10100,0.00748214}, {10200,0.00835714}, {10300,0.00853571}, {10400,0.00767857}, {10500,0.03109821}, {10600,0.00889286}, {10700,0.01508036}, {10800,0.00891964}, {10900,0.00866071}, {11000,0.03516964}, {11100,0.00905357}, {11200,0.01414286}, {11300,0.00942857}, {11400,0.00940179}, {11500,0.01009821}, {11600,0.01017857}, {11700,0.01001786}, {11800,0.02560714}, {11900,0.00976786}, {12000,0.00990179}, {12100,0.01009821}, {12200,0.02620536}, {12300,0.00990179}, {12400,0.01032143}, {12500,0.01043750}, {12600,0.03075}, {12700,0.00950}, {12800,0.01075}, {12900,0.01075}, {13000,0.00950}, {13100,0.01200}, {13200,0.01200}, {13300,0.01100}, {13400,0.00975}, {13500,0.00975}, {13600,0.01200}, {13700,0.01175}, {13800,0.01075}, {13900,0.01200}, {14000,0.01200}, {14100,0.01200}, {14200,0.01100}, {14300,0.03875}, {14400,0.01875}, {14500,0.01450}, {14600,0.01375}, {14700,0.01200}, {14800,0.01200}, {14900,0.01200}, {15000,0.01275}, {15100,0.01375}, {15200,0.01100}, {15300,0.01275}, {15400,0.01600}, {15500,0.01300}, {15600,0.01275}, {15700,0.02100}, {15800,0.01400}, {15900,0.03250}, {16000,0.01375}, {16100,0.02500}, {16200,0.01300}, {16300,0.01500}, {16400,0.01375}, {16500,0.01450}, {16600,0.01350}, {16700,0.03375}, {16800,0.03050}, {16900,0.02750}, {17000,0.01175}, {17100,0.03250}, {17200,0.01350}, {17300,0.01300}, {17400,0.03250}, {17500,0.01375}, {17600,0.02975}, {17700,0.01475}, {17800,0.01475}, {17900,0.03200}, {18000,0.01450}, {18100,0.01375}, {18200,0.02125}, {18300,0.01550}, {18400,0.01450}, {18500,0.01700}, {18600,0.01450}, {18700,0.01500}, {18800,0.03175}, {18900,0.01550}, {19000,0.01650}, {19100,0.01550}, {19200,0.01450}, {19300,0.01650}, {19400,0.01725}, {19500,0.03550}, {19600,0.01675}, {19700,0.04250}, {19800,0.01550}, {19900,0.01425}, {20000,0.0155}};
data["big_flat"]["identity lazy"]["Stats"]["system"] = {{1,0.00010619}, {2,0.00000000}, {3,0.00003540}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00003540}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00007080}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00003540}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00002655}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00003540}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00002655}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00003540}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00003540}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00006195}, {256,0.00003540}, {257,0.00000000}, {258,0.00000000}, {259,0.00003540}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00003540}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00003540}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00002655}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00003540}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00003540}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00002655}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00002655}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00003540}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00003540}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00003540}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00003540}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00003540}, {423,0.00000000}, {424,0.00003540}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00003540}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00003540}, {455,0.00003540}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00003540}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00003540}, {477,0.00003540}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00003540}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00003540}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00003540}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00007080}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00003540}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00003540}, {695,0.00000000}, {700,0.00000000}, {705,0.00002655}, {710,0.00003540}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00007080}, {735,0.00003540}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00003540}, {760,0.00003540}, {765,0.00000000}, {770,0.00003540}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00003540}, {800,0.00002679}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00002679}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00003571}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00003571}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00003571}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00007143}, {1020,0.00003571}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00003571}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00007143}, {1120,0.00002679}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00003571}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00003571}, {1270,0.00000000}, {1280,0.00003571}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00003571}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00002679}, {1410,0.00002679}, {1420,0.00000000}, {1430,0.00003571}, {1440,0.00000000}, {1450,0.00003571}, {1460,0.00000000}, {1470,0.00003571}, {1480,0.00000000}, {1490,0.00003571}, {1500,0.00002679}, {1510,0.00003571}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00010714}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00003571}, {1600,0.00000000}, {1610,0.00003571}, {1620,0.00007143}, {1630,0.00003571}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003571}, {1670,0.00000000}, {1680,0.00003571}, {1690,0.00003571}, {1700,0.00000000}, {1710,0.00002679}, {1720,0.00003571}, {1730,0.00000000}, {1740,0.00003571}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00003571}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00003571}, {1910,0.00000000}, {1920,0.00003571}, {1930,0.00000000}, {1940,0.00003571}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00007143}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00003571}, {2350,0.00000000}, {2400,0.00007143}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00003571}, {2650,0.00000000}, {2700,0.00003571}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00002679}, {3000,0.00000000}, {3050,0.00006250}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00003571}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00003571}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00003571}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00007143}, {4100,0.00002679}, {4150,0.00000000}, {4200,0.00003571}, {4250,0.00003571}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00003571}, {4550,0.00013393}, {4600,0.00003571}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00002679}, {4850,0.00003571}, {4900,0.00003571}, {4950,0.00000000}, {5000,0.00003571}, {5050,0.00000000}, {5100,0.00003571}, {5150,0.00000000}, {5200,0.00003571}, {5250,0.00007143}, {5300,0.00003571}, {5350,0.00003571}, {5400,0.00000000}, {5450,0.00003571}, {5500,0.00000000}, {5550,0.00003571}, {5600,0.00006250}, {5650,0.00003571}, {5700,0.00003571}, {5750,0.00000000}, {5800,0.00007143}, {5850,0.00003571}, {5900,0.00000000}, {5950,0.00003571}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00006250}, {6150,0.00000000}, {6200,0.00007143}, {6250,0.00003571}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00003571}, {6500,0.00000000}, {6550,0.00003571}, {6600,0.00000000}, {6650,0.00003571}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00003571}, {6850,0.00000000}, {6900,0.00007143}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00003571}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00003571}, {7250,0.00003571}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00003571}, {7600,0.00039286}, {7650,0.00003571}, {7700,0.00000000}, {7750,0.00030357}, {7800,0.00007143}, {7850,0.00003571}, {7900,0.00003571}, {7950,0.00000000}, {8000,0.00003571}, {8050,0.00003571}, {8100,0.00003571}, {8150,0.00000000}, {8200,0.00003571}, {8250,0.00007143}, {8300,0.00010714}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00000000}, {8500,0.00003571}, {8550,0.00045536}, {8600,0.00000000}, {8650,0.00000000}, {8700,0.00035714}, {8750,0.00000000}, {8800,0.00006250}, {8850,0.00000000}, {8900,0.00003571}, {8950,0.00007143}, {9000,0.00003571}, {9050,0.00000000}, {9100,0.00007143}, {9150,0.00003571}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00000000}, {9350,0.00003571}, {9400,0.00000000}, {9450,0.00003571}, {9500,0.00000000}, {9550,0.00007143}, {9600,0.00002679}, {9650,0.00003571}, {9700,0.00007143}, {9750,0.00000000}, {9800,0.00003571}, {9850,0.00000000}, {9900,0.00003571}, {9950,0.00003571}, {10000,0.00000000}, {10100,0.00000000}, {10200,0.00003571}, {10300,0.00003571}, {10400,0.00000000}, {10500,0.00003571}, {10600,0.00000000}, {10700,0.00003571}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00003571}, {11100,0.00000000}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00003571}, {12100,0.00003571}, {12200,0.00003571}, {12300,0.00003571}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00100}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00175}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["identity native_compute"]["Stats"]["real"] = {{1,0.34916071}, {2,0.34515179}, {3,0.34360714}, {4,0.34312500}, {5,0.34356250}, {6,0.34251786}, {7,0.34156250}, {8,0.34078571}, {9,0.34203571}, {10,0.34117857}, {11,0.34217857}, {12,0.34331250}, {13,0.33909821}, {14,0.33972321}, {15,0.34248214}, {16,0.34056250}, {17,0.33999107}, {18,0.34227679}, {19,0.34395536}, {20,0.34147321}, {21,0.34503571}, {22,0.34148214}, {23,0.34268750}, {24,0.34404464}, {25,0.34295536}, {26,0.34264286}, {27,0.34336607}, {28,0.34296429}, {29,0.34222321}, {30,0.34172321}, {31,0.34482143}, {32,0.34308036}, {33,0.34367857}, {34,0.34407143}, {35,0.34189286}, {36,0.34416071}, {37,0.34316964}, {38,0.34450893}, {39,0.34567857}, {40,0.34621429}, {41,0.34441964}, {42,0.34121429}, {43,0.34325000}, {44,0.34489286}, {45,0.34303571}, {46,0.34414286}, {47,0.34587500}, {48,0.34418750}, {49,0.34389286}, {50,0.34389286}, {51,0.34452679}, {52,0.34528571}, {53,0.34504464}, {54,0.34376786}, {55,0.34521429}, {56,0.34328571}, {57,0.34195536}, {58,0.34490179}, {59,0.34237500}, {60,0.34579464}, {61,0.34524107}, {62,0.34660714}, {63,0.34316964}, {64,0.34466071}, {65,0.34549107}, {66,0.34663393}, {67,0.41991964}, {68,0.34774107}, {69,0.34661607}, {70,0.34877679}, {71,0.34737500}, {72,0.34605357}, {73,0.34895536}, {74,0.34825893}, {75,0.34720536}, {76,0.34725893}, {77,0.34768750}, {78,0.34924107}, {79,0.34877679}, {80,0.34749107}, {81,0.34912500}, {82,0.34830357}, {83,0.34978571}, {84,0.34857143}, {85,0.34884821}, {86,0.35007143}, {87,0.34890179}, {88,0.34942857}, {89,0.34942857}, {90,0.34973214}, {91,0.34814286}, {92,0.34962500}, {93,0.34904464}, {94,0.35130357}, {95,0.35222321}, {96,0.35011607}, {97,0.35071429}, {98,0.34816964}, {99,0.34892857}, {100,0.34983036}, {101,0.35208036}, {102,0.35083929}, {103,0.35066964}, {104,0.35023214}, {105,0.35115179}, {106,0.35066964}, {107,0.35145536}, {108,0.35143750}, {109,0.35062500}, {110,0.35275893}, {111,0.35105357}, {112,0.35190179}, {113,0.35296429}, {114,0.35268750}, {115,0.35221429}, {116,0.35049107}, {117,0.35345536}, {118,0.35273214}, {119,0.35333036}, {120,0.35057143}, {121,0.35352679}, {122,0.35294643}, {123,0.35278571}, {124,0.35158036}, {125,0.35237500}, {126,0.35266071}, {127,0.35217857}, {128,0.35144643}, {129,0.35181250}, {130,0.35510714}, {131,0.35336607}, {132,0.35286607}, {133,0.35317857}, {134,0.41968750}, {135,0.35160714}, {136,0.35257143}, {137,0.35162500}, {138,0.35199107}, {139,0.35236607}, {140,0.35306250}, {141,0.35371429}, {142,0.35208036}, {143,0.35356250}, {144,0.35168750}, {145,0.35353571}, {146,0.34954054}, {147,0.35089189}, {148,0.34924324}, {149,0.34972973}, {150,0.34889189}, {151,0.34966667}, {152,0.34936937}, {153,0.35245946}, {154,0.35089189}, {155,0.34829730}, {156,0.34984685}, {157,0.35218018}, {158,0.34984685}, {159,0.35030631}, {160,0.35045045}, {161,0.34906306}, {162,0.35043243}, {163,0.34972072}, {164,0.35001802}, {165,0.35096396}, {166,0.35245946}, {167,0.35176577}, {168,0.34931532}, {169,0.35204505}, {170,0.35337838}, {171,0.35045045}, {172,0.35132432}, {173,0.35033333}, {174,0.35361261}, {175,0.35121622}, {176,0.35126126}, {177,0.34939640}, {178,0.35240541}, {179,0.35214414}, {180,0.35318919}, {181,0.35365766}, {182,0.35354054}, {183,0.35172072}, {184,0.35303604}, {185,0.35255856}, {186,0.35309910}, {187,0.35295495}, {188,0.35374775}, {189,0.35174775}, {190,0.35323423}, {191,0.35289189}, {192,0.35200901}, {193,0.35091892}, {194,0.35243243}, {195,0.35153153}, {196,0.35070270}, {197,0.35151351}, {198,0.35082883}, {199,0.35220721}, {200,0.35197297}, {201,0.41603604}, {202,0.35339640}, {203,0.35393694}, {204,0.35309910}, {205,0.35312613}, {206,0.35159459}, {207,0.35062162}, {208,0.35135135}, {209,0.35268468}, {210,0.35292793}, {211,0.35402703}, {212,0.35232432}, {213,0.35263063}, {214,0.35318919}, {215,0.35036937}, {216,0.35135135}, {217,0.35380180}, {218,0.35312613}, {219,0.35260360}, {220,0.35345045}, {221,0.35163964}, {222,0.35353153}, {223,0.35275676}, {224,0.35375676}, {225,0.35396396}, {226,0.35344144}, {227,0.35197297}, {228,0.35310811}, {229,0.35376577}, {230,0.35140541}, {231,0.35139640}, {232,0.35056757}, {233,0.35200000}, {234,0.35304505}, {235,0.35335135}, {236,0.35380180}, {237,0.35288288}, {238,0.35237838}, {239,0.35305405}, {240,0.35281081}, {241,0.35184685}, {242,0.35147748}, {243,0.35099099}, {244,0.35152252}, {245,0.35454955}, {246,0.35264865}, {247,0.35187387}, {248,0.35441441}, {249,0.35237838}, {250,0.35262162}, {251,0.35290991}, {252,0.35227027}, {253,0.35107207}, {254,0.35219820}, {255,0.35154054}, {256,0.35272072}, {257,0.35230631}, {258,0.35232432}, {259,0.35391892}, {260,0.35400000}, {261,0.35014414}, {262,0.35325225}, {263,0.35417117}, {264,0.35479279}, {265,0.35456757}, {266,0.35260360}, {267,0.35234234}, {268,0.41489189}, {269,0.35127027}, {270,0.35258559}, {271,0.35326126}, {272,0.35119820}, {273,0.35468468}, {274,0.35277477}, {275,0.35359459}, {276,0.35434234}, {277,0.35320721}, {278,0.35319820}, {279,0.35436036}, {280,0.35413514}, {281,0.35316216}, {282,0.35204505}, {283,0.35327928}, {284,0.35199099}, {285,0.35350450}, {286,0.35381982}, {287,0.35280180}, {288,0.35501802}, {289,0.35319820}, {290,0.35379279}, {291,0.35355856}, {292,0.35420721}, {293,0.35262162}, {294,0.35402703}, {295,0.35432432}, {296,0.35300901}, {297,0.35533333}, {298,0.35376577}, {299,0.34920909}, {300,0.34944545}, {301,0.35111818}, {302,0.35131818}, {303,0.35009091}, {304,0.35191818}, {305,0.35040000}, {306,0.35188182}, {307,0.35141818}, {308,0.35040000}, {309,0.35096364}, {310,0.35038182}, {311,0.35140000}, {312,0.35165455}, {313,0.35103636}, {314,0.35188182}, {315,0.35181818}, {316,0.35107273}, {317,0.35173636}, {318,0.35110000}, {319,0.35162727}, {320,0.35237273}, {321,0.35044545}, {322,0.34940909}, {323,0.35186364}, {324,0.35046364}, {325,0.35175455}, {326,0.35160909}, {327,0.35232727}, {328,0.34951818}, {329,0.35116364}, {330,0.35238182}, {331,0.35123636}, {332,0.35090909}, {333,0.35075455}, {334,0.35065455}, {335,0.42100000}, {336,0.35085455}, {337,0.35224545}, {338,0.35075455}, {339,0.35009091}, {340,0.35079091}, {341,0.35195455}, {342,0.35248182}, {343,0.35026364}, {344,0.35178182}, {345,0.35160909}, {346,0.35192727}, {347,0.35175455}, {348,0.35111818}, {349,0.35250000}, {350,0.35171818}, {351,0.35256364}, {352,0.35120909}, {353,0.35091818}, {354,0.35330000}, {355,0.35070909}, {356,0.35283636}, {357,0.35151818}, {358,0.35206364}, {359,0.35059091}, {360,0.35104545}, {361,0.35152727}, {362,0.35164545}, {363,0.35185455}, {364,0.35229091}, {365,0.35345455}, {366,0.35307273}, {367,0.35249091}, {368,0.35338182}, {369,0.35346364}, {370,0.35300909}, {371,0.35206364}, {372,0.35310909}, {373,0.35251818}, {374,0.35387273}, {375,0.35191818}, {376,0.35277273}, {377,0.35171818}, {378,0.35342727}, {379,0.35407273}, {380,0.35340000}, {381,0.35430000}, {382,0.35334545}, {383,0.35332727}, {384,0.35485455}, {385,0.35386364}, {386,0.35352727}, {387,0.35220909}, {388,0.35240909}, {389,0.35412727}, {390,0.35256364}, {391,0.35230909}, {392,0.35148182}, {393,0.35287273}, {394,0.35234545}, {395,0.35373636}, {396,0.35330000}, {397,0.35323636}, {398,0.35315455}, {399,0.35271818}, {400,0.35365455}, {401,0.35439091}, {402,0.42245455}, {403,0.35344545}, {404,0.35394545}, {405,0.35350909}, {406,0.35370909}, {407,0.35485455}, {408,0.35273636}, {409,0.35372727}, {410,0.35323636}, {411,0.35296364}, {412,0.35402727}, {413,0.35268182}, {414,0.35248182}, {415,0.35388182}, {416,0.35501818}, {417,0.35390909}, {418,0.35533636}, {419,0.35316364}, {420,0.35525455}, {421,0.35405455}, {422,0.35378182}, {423,0.35473636}, {424,0.35361818}, {425,0.35544545}, {426,0.35513636}, {427,0.35624545}, {428,0.35567273}, {429,0.35476364}, {430,0.35491818}, {431,0.35426364}, {432,0.35600909}, {433,0.35523636}, {434,0.35600000}, {435,0.35481818}, {436,0.35533636}, {437,0.35530909}, {438,0.35667273}, {439,0.35567273}, {440,0.35454545}, {441,0.35524545}, {442,0.35584545}, {443,0.35694545}, {444,0.35539091}, {445,0.35611818}, {446,0.35564545}, {447,0.35499091}, {448,0.35490000}, {449,0.35666364}, {450,0.35550909}, {451,0.35518182}, {452,0.35520000}, {453,0.35452727}, {454,0.35462727}, {455,0.35483636}, {456,0.35481818}, {457,0.35510909}, {458,0.35606364}, {459,0.35630000}, {460,0.35738182}, {461,0.35527273}, {462,0.41117273}, {463,0.35620000}, {464,0.35727273}, {465,0.35635455}, {466,0.35719091}, {467,0.35590909}, {468,0.35669091}, {469,0.35670909}, {470,0.35783636}, {471,0.35777273}, {472,0.35815455}, {473,0.35682727}, {474,0.35718182}, {475,0.35863636}, {476,0.35801818}, {477,0.35831818}, {478,0.35683636}, {479,0.35577273}, {480,0.35819091}, {481,0.35789091}, {482,0.35721818}, {483,0.35670000}, {484,0.35746364}, {485,0.35815455}, {486,0.35810909}, {487,0.35737273}, {488,0.35754545}, {489,0.35716364}, {490,0.35760909}, {491,0.35746364}, {492,0.35632727}, {493,0.35697273}, {494,0.35708182}, {495,0.35598182}, {496,0.35586364}, {497,0.35598182}, {498,0.35720909}, {499,0.35695455}, {500,0.35830000}, {505,0.35674545}, {510,0.35703636}, {515,0.35896364}, {520,0.35804545}, {525,0.35777273}, {530,0.35888182}, {535,0.35681818}, {540,0.35875455}, {545,0.35650000}, {550,0.35759091}, {555,0.35719091}, {560,0.35831818}, {565,0.35835455}, {570,0.35857273}, {575,0.40891818}, {580,0.35851818}, {585,0.35860909}, {590,0.35748182}, {595,0.35883636}, {600,0.35824545}, {605,0.35837273}, {610,0.35870909}, {615,0.35888182}, {620,0.35775455}, {625,0.35686364}, {630,0.35924545}, {635,0.35853636}, {640,0.36038182}, {645,0.35971818}, {650,0.35944545}, {655,0.35980909}, {660,0.35897273}, {665,0.35925455}, {670,0.35953636}, {675,0.35858182}, {680,0.35895455}, {685,0.35846364}, {690,0.36027273}, {695,0.35802727}, {700,0.35898182}, {705,0.35936364}, {710,0.36014545}, {715,0.35990000}, {720,0.36100909}, {725,0.35991818}, {730,0.35908182}, {735,0.36001818}, {740,0.35933636}, {745,0.35902727}, {750,0.35886364}, {755,0.36070909}, {760,0.36091818}, {765,0.36116364}, {770,0.36055455}, {775,0.39571818}, {780,0.36089091}, {785,0.36046364}, {790,0.35942727}, {795,0.36090000}, {800,0.36113636}, {805,0.36068182}, {810,0.36022727}, {815,0.36092727}, {820,0.36102727}, {825,0.36044545}, {830,0.35995455}, {835,0.36050909}, {840,0.36188182}, {845,0.36121818}, {850,0.36045455}, {855,0.36056364}, {860,0.36260000}, {865,0.36159091}, {870,0.36119091}, {875,0.36075455}, {880,0.36154545}, {885,0.36051818}, {890,0.36074545}, {895,0.36128182}, {900,0.36248182}, {905,0.36190909}, {910,0.36059091}, {915,0.36101818}, {920,0.36137273}, {925,0.36133636}, {930,0.36213636}, {935,0.36115455}, {940,0.36157273}, {945,0.36165455}, {950,0.36145455}, {955,0.36204545}, {960,0.36119091}, {965,0.36130909}, {970,0.36129091}, {975,0.36190000}, {980,0.36255455}, {985,0.36253636}, {990,0.36238182}, {995,0.36176364}, {1000,0.36251818}, {1010,0.36237273}, {1020,0.36225455}, {1030,0.36177273}, {1040,0.36102727}, {1050,0.36183636}, {1060,0.36160000}, {1070,0.36235455}, {1080,0.36222727}, {1090,0.36234545}, {1100,0.35993636}, {1110,0.36320000}, {1120,0.36233636}, {1130,0.39485455}, {1140,0.36320909}, {1150,0.36190909}, {1160,0.36173636}, {1170,0.36274545}, {1180,0.36255455}, {1190,0.36340000}, {1200,0.36265455}, {1210,0.36236364}, {1220,0.36215455}, {1230,0.36276364}, {1240,0.36301818}, {1250,0.36324545}, {1260,0.36409091}, {1270,0.36492727}, {1280,0.36436364}, {1290,0.36410000}, {1300,0.36500000}, {1310,0.36652727}, {1320,0.36603636}, {1330,0.36661818}, {1340,0.36589091}, {1350,0.39384545}, {1360,0.36380000}, {1370,0.36480000}, {1380,0.36287273}, {1390,0.36345455}, {1400,0.36458182}, {1410,0.36613636}, {1420,0.36430909}, {1430,0.36480000}, {1440,0.36489091}, {1450,0.36468182}, {1460,0.36532727}, {1470,0.36424545}, {1480,0.36490000}, {1490,0.36549091}, {1500,0.36578182}, {1510,0.36510000}, {1520,0.36465455}, {1530,0.36583636}, {1540,0.39124545}, {1550,0.36510000}, {1560,0.36726364}, {1570,0.36569091}, {1580,0.36576364}, {1590,0.36566364}, {1600,0.36550000}, {1610,0.36590000}, {1620,0.36588182}, {1630,0.36530909}, {1640,0.36491818}, {1650,0.36568182}, {1660,0.36678182}, {1670,0.36720909}, {1680,0.36574545}, {1690,0.36537273}, {1700,0.36591818}, {1710,0.38847273}, {1720,0.36513636}, {1730,0.36496364}, {1740,0.36402727}, {1750,0.36477273}, {1760,0.36400000}, {1770,0.36483636}, {1780,0.36534545}, {1790,0.36359091}, {1800,0.36587273}, {1810,0.36515455}, {1820,0.36627273}, {1830,0.36538182}, {1840,0.36516364}, {1850,0.36588182}, {1860,0.36690000}, {1870,0.36744545}, {1880,0.36665455}, {1890,0.36683636}, {1900,0.36791818}, {1910,0.36632727}, {1920,0.36705455}, {1930,0.36692727}, {1940,0.36620909}, {1950,0.36798182}, {1960,0.36742727}, {1970,0.36673636}, {1980,0.36414545}, {1990,0.36337273}, {2000,0.36426364}, {2050,0.38482727}, {2100,0.36535455}, {2150,0.36505455}, {2200,0.36447273}, {2250,0.36397273}, {2300,0.36509091}, {2350,0.36664545}, {2400,0.36583636}, {2450,0.36650000}, {2500,0.36864545}, {2550,0.36776364}, {2600,0.36931818}, {2650,0.38887273}, {2700,0.37073636}, {2750,0.37126364}, {2800,0.37140909}, {2850,0.37110000}, {2900,0.37197273}, {2950,0.37168182}, {3000,0.37093636}, {3050,0.36961818}, {3100,0.38865455}, {3150,0.37049091}, {3200,0.37040000}, {3250,0.37079091}, {3300,0.36893636}, {3350,0.36759091}, {3400,0.37040909}, {3450,0.37013636}, {3500,0.37091818}, {3550,0.38453636}, {3600,0.37058182}, {3650,0.37116364}, {3700,0.37040000}, {3750,0.36983636}, {3800,0.37154545}, {3850,0.37219091}, {3900,0.38800000}, {3950,0.37133636}, {4000,0.37172727}, {4050,0.37131818}, {4100,0.37244545}, {4150,0.37220000}, {4200,0.37188182}, {4250,0.38820000}, {4300,0.37409091}, {4350,0.37251818}, {4400,0.37357273}, {4450,0.37324545}, {4500,0.37326364}, {4550,0.39234545}, {4600,0.37359091}, {4650,0.37454545}, {4700,0.37335455}, {4750,0.37450909}, {4800,0.37469091}, {4850,0.39076364}, {4900,0.37430000}, {4950,0.37494545}, {5000,0.37553636}, {5050,0.38145370}, {5100,0.38063889}, {5150,0.39515741}, {5200,0.38240741}, {5250,0.38224074}, {5300,0.38306481}, {5350,0.38242593}, {5400,0.40199074}, {5450,0.38396296}, {5500,0.38106481}, {5550,0.38324074}, {5600,0.38180556}, {5650,0.39944444}, {5700,0.38307407}, {5750,0.38281481}, {5800,0.38413889}, {5850,0.38307407}, {5900,0.39797222}, {5950,0.38383333}, {6000,0.38350000}, {6050,0.38374074}, {6100,0.38401852}, {6150,0.38450000}, {6200,0.38520370}, {6250,0.38440741}, {6300,0.38497222}, {6350,0.39887963}, {6400,0.38614815}, {6450,0.38653704}, {6500,0.38646296}, {6550,0.38623148}, {6600,0.38579630}, {6650,0.38678704}, {6700,0.38570370}, {6750,0.38425926}, {6800,0.38598148}, {6850,0.38681481}, {6900,0.38648148}, {6950,0.38664815}, {7000,0.39706481}, {7050,0.38533333}, {7100,0.38576852}, {7150,0.38674074}, {7200,0.38757407}, {7250,0.38760185}, {7300,0.38877778}, {7350,0.38831481}, {7400,0.38768519}, {7450,0.38737037}, {7500,0.38772222}, {7550,0.40923148}, {7600,0.38848148}, {7650,0.38718519}, {7700,0.38789815}, {7750,0.40090741}, {7800,0.38902778}, {7850,0.38815741}, {7900,0.38838889}, {7950,0.38838889}, {8000,0.38918519}, {8050,0.38851852}, {8100,0.40540741}, {8150,0.38875000}, {8200,0.38831481}, {8250,0.39110185}, {8300,0.39002778}, {8350,0.39080556}, {8400,0.39077778}, {8450,0.40859259}, {8500,0.39073148}, {8550,0.39147222}, {8600,0.40485185}, {8650,0.39178704}, {8700,0.39100926}, {8750,0.41798148}, {8800,0.39174074}, {8850,0.39160185}, {8900,0.39070370}, {8950,0.39066667}, {9000,0.39127778}, {9050,0.39152778}, {9100,0.39249074}, {9150,0.39237037}, {9200,0.39365741}, {9250,0.39314815}, {9300,0.39305556}, {9350,0.39405556}, {9400,0.39319444}, {9450,0.39388889}, {9500,0.39361111}, {9550,0.39273148}, {9600,0.39447222}, {9650,0.39431481}, {9700,0.39447222}, {9750,0.39411111}, {9800,0.42345370}, {9850,0.39531481}, {9900,0.39492593}, {9950,0.41332407}, {10000,0.39487963}, {10100,0.39550000}, {10200,0.41273148}, {10300,0.39595370}, {10400,0.39500000}, {10500,0.41638889}, {10600,0.39637037}, {10700,0.41847222}, {10800,0.39640741}, {10900,0.39721296}, {11000,0.41025000}, {11100,0.39771296}, {11200,0.39795370}, {11300,0.39776852}, {11400,0.39866667}, {11500,0.42118519}, {11600,0.39939815}, {11700,0.43602778}, {11800,0.40087963}, {11900,0.39936111}, {12000,0.39987037}, {12100,0.40055556}, {12200,0.41668519}, {12300,0.40159259}, {12400,0.43236111}, {12500,0.40282407}, {12600,0.2020}, {12700,0.2020}, {12800,0.2330}, {12900,0.2015}, {13000,0.2180}, {13100,0.2025}, {13200,0.2310}, {13300,0.2040}, {13400,0.2390}, {13500,0.2040}, {13600,0.2360}, {13700,0.2045}, {13800,0.2495}, {13900,0.2115}, {14000,0.2455}, {14100,0.2175}, {14200,0.2445}, {14300,0.2075}, {14400,0.2265}, {14500,0.2020}, {14600,0.2305}, {14700,0.2075}, {14800,0.2325}, {14900,0.2140}, {15000,0.2390}, {15100,0.2180}, {15200,0.2340}, {15300,0.2170}, {15400,0.2115}, {15500,0.2125}, {15600,0.2145}, {15700,0.2615}, {15800,0.2185}, {15900,0.2360}, {16000,0.2095}, {16100,0.2395}, {16200,0.2170}, {16300,0.2155}, {16400,0.2660}, {16500,0.2220}, {16600,0.2395}, {16700,0.2175}, {16800,0.2230}, {16900,0.2585}, {17000,0.2190}, {17100,0.2435}, {17200,0.2245}, {17300,0.2255}, {17400,0.2550}, {17500,0.2205}, {17600,0.2390}, {17700,0.2590}, {17800,0.2245}, {17900,0.2435}, {18000,0.2270}, {18100,0.2305}, {18200,0.2590}, {18300,0.2285}, {18400,0.2305}, {18500,0.2595}, {18600,0.2250}, {18700,0.2295}, {18800,0.2575}, {18900,0.2265}, {19000,0.2300}, {19100,0.2560}, {19200,0.2320}, {19300,0.2270}, {19400,0.2665}, {19500,0.2350}, {19600,0.2265}, {19700,0.2695}, {19800,0.2980}, {19900,0.2345}, {20000,0.2330}};
data["big_flat"]["identity native_compute"]["Stats"]["user"] = {{1,0.00087500}, {2,0.00061607}, {3,0.00058036}, {4,0.00056250}, {5,0.00053571}, {6,0.00071429}, {7,0.00074107}, {8,0.00067857}, {9,0.00053571}, {10,0.00051786}, {11,0.00043750}, {12,0.00062500}, {13,0.00074107}, {14,0.00033929}, {15,0.00059821}, {16,0.00050893}, {17,0.00051786}, {18,0.00050000}, {19,0.00054464}, {20,0.00068750}, {21,0.00036607}, {22,0.00058929}, {23,0.00044643}, {24,0.00061607}, {25,0.00049107}, {26,0.00059821}, {27,0.00045536}, {28,0.00058929}, {29,0.00073214}, {30,0.00049107}, {31,0.00044643}, {32,0.00063393}, {33,0.00076786}, {34,0.00066964}, {35,0.00049107}, {36,0.00058036}, {37,0.00046429}, {38,0.00048214}, {39,0.00044643}, {40,0.00055357}, {41,0.00073214}, {42,0.00047321}, {43,0.00061607}, {44,0.00084821}, {45,0.00055357}, {46,0.00075893}, {47,0.00073214}, {48,0.00081250}, {49,0.00060714}, {50,0.00047321}, {51,0.00060714}, {52,0.00066964}, {53,0.00064286}, {54,0.00066071}, {55,0.00075000}, {56,0.00067857}, {57,0.00078571}, {58,0.00074107}, {59,0.00072321}, {60,0.00061607}, {61,0.00070536}, {62,0.00085714}, {63,0.00045536}, {64,0.00045536}, {65,0.00081250}, {66,0.00087500}, {67,0.07100893}, {68,0.00076786}, {69,0.00087500}, {70,0.00088393}, {71,0.00086607}, {72,0.00074107}, {73,0.00064286}, {74,0.00089286}, {75,0.00080357}, {76,0.00079464}, {77,0.00081250}, {78,0.00080357}, {79,0.00075893}, {80,0.00048214}, {81,0.00079464}, {82,0.00090179}, {83,0.00084821}, {84,0.00083929}, {85,0.00075893}, {86,0.00083929}, {87,0.00091964}, {88,0.00082143}, {89,0.00101786}, {90,0.00090179}, {91,0.00103571}, {92,0.00087500}, {93,0.00083929}, {94,0.00092857}, {95,0.00103571}, {96,0.00091071}, {97,0.00076786}, {98,0.00098214}, {99,0.00092857}, {100,0.00066964}, {101,0.00124107}, {102,0.00093750}, {103,0.00090179}, {104,0.00090179}, {105,0.00105357}, {106,0.00095536}, {107,0.00098214}, {108,0.00091071}, {109,0.00079464}, {110,0.00095536}, {111,0.00111607}, {112,0.00100893}, {113,0.00082143}, {114,0.00112500}, {115,0.00084821}, {116,0.00096429}, {117,0.00101786}, {118,0.00088393}, {119,0.00065179}, {120,0.00095536}, {121,0.00096429}, {122,0.00096429}, {123,0.00076786}, {124,0.00116071}, {125,0.00098214}, {126,0.00101786}, {127,0.00087500}, {128,0.00075893}, {129,0.00089286}, {130,0.00080357}, {131,0.00092857}, {132,0.00091964}, {133,0.00104464}, {134,0.06584821}, {135,0.00107143}, {136,0.00131250}, {137,0.00106250}, {138,0.00106250}, {139,0.00110714}, {140,0.00109821}, {141,0.00133036}, {142,0.00099107}, {143,0.00111607}, {144,0.00095536}, {145,0.00112500}, {146,0.00125225}, {147,0.00090991}, {148,0.00154955}, {149,0.00119820}, {150,0.00116216}, {151,0.00096396}, {152,0.00126126}, {153,0.00091892}, {154,0.00112613}, {155,0.00082883}, {156,0.00115315}, {157,0.00123423}, {158,0.00093694}, {159,0.00122523}, {160,0.00113514}, {161,0.00110811}, {162,0.00125225}, {163,0.00101802}, {164,0.00100000}, {165,0.00107207}, {166,0.00129730}, {167,0.00093694}, {168,0.00103604}, {169,0.00134234}, {170,0.00101802}, {171,0.00133333}, {172,0.00097297}, {173,0.00096396}, {174,0.00256757}, {175,0.00116216}, {176,0.00131532}, {177,0.00113514}, {178,0.00113514}, {179,0.00105405}, {180,0.00121622}, {181,0.00132432}, {182,0.00112613}, {183,0.00118018}, {184,0.00107207}, {185,0.00147748}, {186,0.00091892}, {187,0.00136036}, {188,0.00114414}, {189,0.00115315}, {190,0.00130631}, {191,0.00123423}, {192,0.00126126}, {193,0.00127027}, {194,0.00129730}, {195,0.00115315}, {196,0.00118919}, {197,0.00102703}, {198,0.00135135}, {199,0.00117117}, {200,0.00137838}, {201,0.06332432}, {202,0.00101802}, {203,0.00116216}, {204,0.00137838}, {205,0.00123423}, {206,0.00132432}, {207,0.00118018}, {208,0.00135135}, {209,0.00132432}, {210,0.00128829}, {211,0.00098198}, {212,0.00127027}, {213,0.00105405}, {214,0.00114414}, {215,0.00155856}, {216,0.00125225}, {217,0.00110811}, {218,0.00141441}, {219,0.00135135}, {220,0.00097297}, {221,0.00128829}, {222,0.00123423}, {223,0.00128829}, {224,0.00164865}, {225,0.00113514}, {226,0.00119820}, {227,0.00124324}, {228,0.00151351}, {229,0.00130631}, {230,0.00143243}, {231,0.00135135}, {232,0.00155856}, {233,0.00128829}, {234,0.00113514}, {235,0.00142342}, {236,0.00107207}, {237,0.00145045}, {238,0.00139640}, {239,0.00143243}, {240,0.00126126}, {241,0.00140541}, {242,0.00171171}, {243,0.00135135}, {244,0.00121622}, {245,0.00145946}, {246,0.00150450}, {247,0.00154054}, {248,0.00146847}, {249,0.00154054}, {250,0.00138739}, {251,0.00146847}, {252,0.00138739}, {253,0.00143243}, {254,0.00147748}, {255,0.00126126}, {256,0.00157658}, {257,0.00156757}, {258,0.00143243}, {259,0.00146847}, {260,0.00176577}, {261,0.00130631}, {262,0.00137838}, {263,0.00144144}, {264,0.00134234}, {265,0.00106306}, {266,0.00143243}, {267,0.00176577}, {268,0.06268468}, {269,0.00179279}, {270,0.00135135}, {271,0.00156757}, {272,0.00139640}, {273,0.00162162}, {274,0.00168468}, {275,0.00184685}, {276,0.00164865}, {277,0.00179279}, {278,0.00153153}, {279,0.00140541}, {280,0.00181081}, {281,0.00178378}, {282,0.00125225}, {283,0.00171171}, {284,0.00175676}, {285,0.00176577}, {286,0.00181081}, {287,0.00126126}, {288,0.00164865}, {289,0.00186486}, {290,0.00150450}, {291,0.00148649}, {292,0.00172973}, {293,0.00163964}, {294,0.00161261}, {295,0.00151351}, {296,0.00158559}, {297,0.00173874}, {298,0.00171171}, {299,0.00140000}, {300,0.00140000}, {301,0.00199091}, {302,0.00142727}, {303,0.00176364}, {304,0.00150000}, {305,0.00149091}, {306,0.00118182}, {307,0.00140909}, {308,0.00147273}, {309,0.00138182}, {310,0.00163636}, {311,0.00170000}, {312,0.00140000}, {313,0.00160000}, {314,0.00170000}, {315,0.00179091}, {316,0.00165455}, {317,0.00187273}, {318,0.00158182}, {319,0.00177273}, {320,0.00150909}, {321,0.00195455}, {322,0.00141818}, {323,0.00172727}, {324,0.00172727}, {325,0.00168182}, {326,0.00169091}, {327,0.00151818}, {328,0.00196364}, {329,0.00121818}, {330,0.00187273}, {331,0.00177273}, {332,0.00150909}, {333,0.00175455}, {334,0.00177273}, {335,0.06895455}, {336,0.00169091}, {337,0.00216364}, {338,0.00128182}, {339,0.00172727}, {340,0.00170909}, {341,0.00145455}, {342,0.00200000}, {343,0.00160000}, {344,0.00200909}, {345,0.00160909}, {346,0.00212727}, {347,0.00190000}, {348,0.00206364}, {349,0.00167273}, {350,0.00181818}, {351,0.00166364}, {352,0.00163636}, {353,0.00170000}, {354,0.00174545}, {355,0.00177273}, {356,0.00197273}, {357,0.00185455}, {358,0.00183636}, {359,0.00152727}, {360,0.00150909}, {361,0.00227273}, {362,0.00173636}, {363,0.00205455}, {364,0.00171818}, {365,0.00222727}, {366,0.00190909}, {367,0.00200909}, {368,0.00149091}, {369,0.00207273}, {370,0.00173636}, {371,0.00194545}, {372,0.00213636}, {373,0.00200000}, {374,0.00161818}, {375,0.00159091}, {376,0.00182727}, {377,0.00199091}, {378,0.00166364}, {379,0.00203636}, {380,0.00191818}, {381,0.00201818}, {382,0.00162727}, {383,0.00184545}, {384,0.00205455}, {385,0.00202727}, {386,0.00210909}, {387,0.00194545}, {388,0.00200909}, {389,0.00191818}, {390,0.00179091}, {391,0.00187273}, {392,0.00149091}, {393,0.00210909}, {394,0.00175455}, {395,0.00198182}, {396,0.00231818}, {397,0.00167273}, {398,0.00184545}, {399,0.00179091}, {400,0.00187273}, {401,0.00206364}, {402,0.07022727}, {403,0.00203636}, {404,0.00208182}, {405,0.00224545}, {406,0.00157273}, {407,0.00188182}, {408,0.00214545}, {409,0.00203636}, {410,0.00183636}, {411,0.00186364}, {412,0.00193636}, {413,0.00173636}, {414,0.00174545}, {415,0.00160909}, {416,0.00195455}, {417,0.00259091}, {418,0.00173636}, {419,0.00201818}, {420,0.00245455}, {421,0.00170000}, {422,0.00247273}, {423,0.00214545}, {424,0.00257273}, {425,0.00208182}, {426,0.00212727}, {427,0.00280000}, {428,0.00178182}, {429,0.00200909}, {430,0.00180000}, {431,0.00239091}, {432,0.00229091}, {433,0.00170000}, {434,0.00220000}, {435,0.00194545}, {436,0.00196364}, {437,0.00216364}, {438,0.00223636}, {439,0.00212727}, {440,0.00249091}, {441,0.00168182}, {442,0.00242727}, {443,0.00188182}, {444,0.00216364}, {445,0.00218182}, {446,0.00194545}, {447,0.00196364}, {448,0.00233636}, {449,0.00221818}, {450,0.00245455}, {451,0.00180000}, {452,0.00169091}, {453,0.00223636}, {454,0.00205455}, {455,0.00219091}, {456,0.00175455}, {457,0.00200000}, {458,0.00251818}, {459,0.00212727}, {460,0.00214545}, {461,0.00235455}, {462,0.05837273}, {463,0.00230000}, {464,0.00187273}, {465,0.00208182}, {466,0.00224545}, {467,0.00220000}, {468,0.00231818}, {469,0.00230000}, {470,0.00271818}, {471,0.00218182}, {472,0.00206364}, {473,0.00236364}, {474,0.00203636}, {475,0.00204545}, {476,0.00204545}, {477,0.00237273}, {478,0.00238182}, {479,0.00220909}, {480,0.00240909}, {481,0.00231818}, {482,0.00216364}, {483,0.00229091}, {484,0.00285455}, {485,0.00201818}, {486,0.00218182}, {487,0.00183636}, {488,0.00235455}, {489,0.00210000}, {490,0.00225455}, {491,0.00234545}, {492,0.00223636}, {493,0.00225455}, {494,0.00248182}, {495,0.00204545}, {496,0.00233636}, {497,0.00238182}, {498,0.00231818}, {499,0.00237273}, {500,0.00224545}, {505,0.00224545}, {510,0.00223636}, {515,0.00230909}, {520,0.00260000}, {525,0.00267273}, {530,0.00222727}, {535,0.00233636}, {540,0.00256364}, {545,0.00230000}, {550,0.00231818}, {555,0.00256364}, {560,0.00266364}, {565,0.00254545}, {570,0.00250909}, {575,0.05064545}, {580,0.00273636}, {585,0.00292727}, {590,0.00259091}, {595,0.00246364}, {600,0.00260909}, {605,0.00250909}, {610,0.00268182}, {615,0.00250000}, {620,0.00261818}, {625,0.00248182}, {630,0.00283636}, {635,0.00240909}, {640,0.00253636}, {645,0.00283636}, {650,0.00278182}, {655,0.00326364}, {660,0.00321818}, {665,0.00283636}, {670,0.00266364}, {675,0.00240000}, {680,0.00286364}, {685,0.00314545}, {690,0.00278182}, {695,0.00290909}, {700,0.00311818}, {705,0.00302727}, {710,0.00272727}, {715,0.00336364}, {720,0.00307273}, {725,0.00334545}, {730,0.00291818}, {735,0.00330909}, {740,0.00299091}, {745,0.00311818}, {750,0.00316364}, {755,0.00337273}, {760,0.00312727}, {765,0.00335455}, {770,0.00340909}, {775,0.03626364}, {780,0.00300000}, {785,0.00331818}, {790,0.00330000}, {795,0.00301818}, {800,0.00338182}, {805,0.00350909}, {810,0.00345455}, {815,0.00341818}, {820,0.00328182}, {825,0.00347273}, {830,0.00340000}, {835,0.00339091}, {840,0.00373636}, {845,0.00367273}, {850,0.00350000}, {855,0.00319091}, {860,0.00346364}, {865,0.00350000}, {870,0.00341818}, {875,0.00379091}, {880,0.00386364}, {885,0.00387273}, {890,0.00374545}, {895,0.00391818}, {900,0.00367273}, {905,0.00354545}, {910,0.00385455}, {915,0.00373636}, {920,0.00434545}, {925,0.00362727}, {930,0.00417273}, {935,0.00380909}, {940,0.00396364}, {945,0.00386364}, {950,0.00405455}, {955,0.00381818}, {960,0.00380000}, {965,0.00389091}, {970,0.00420909}, {975,0.00404545}, {980,0.00378182}, {985,0.00390909}, {990,0.00420000}, {995,0.00455455}, {1000,0.00387273}, {1010,0.00429091}, {1020,0.00429091}, {1030,0.00455455}, {1040,0.00421818}, {1050,0.00445455}, {1060,0.00422727}, {1070,0.00406364}, {1080,0.00469091}, {1090,0.00419091}, {1100,0.00466364}, {1110,0.00473636}, {1120,0.00403636}, {1130,0.03556364}, {1140,0.00488182}, {1150,0.00412727}, {1160,0.00484545}, {1170,0.00514545}, {1180,0.00455455}, {1190,0.00520909}, {1200,0.00491818}, {1210,0.00494545}, {1220,0.00465455}, {1230,0.00476364}, {1240,0.00538182}, {1250,0.00542727}, {1260,0.00502727}, {1270,0.00537273}, {1280,0.00539091}, {1290,0.00551818}, {1300,0.00530000}, {1310,0.00563636}, {1320,0.00513636}, {1330,0.00531818}, {1340,0.00550000}, {1350,0.03227273}, {1360,0.00574545}, {1370,0.00561818}, {1380,0.00553636}, {1390,0.00558182}, {1400,0.00567273}, {1410,0.00518182}, {1420,0.00541818}, {1430,0.00626364}, {1440,0.00598182}, {1450,0.00629091}, {1460,0.00607273}, {1470,0.00610909}, {1480,0.00638182}, {1490,0.00610909}, {1500,0.00581818}, {1510,0.00620909}, {1520,0.00645455}, {1530,0.00673636}, {1540,0.03020000}, {1550,0.00627273}, {1560,0.00634545}, {1570,0.00622727}, {1580,0.00652727}, {1590,0.00650909}, {1600,0.00674545}, {1610,0.00690000}, {1620,0.00690909}, {1630,0.00693636}, {1640,0.00713636}, {1650,0.00693636}, {1660,0.00710909}, {1670,0.00688182}, {1680,0.00690909}, {1690,0.00714545}, {1700,0.00706364}, {1710,0.02955455}, {1720,0.00712727}, {1730,0.00723636}, {1740,0.00733636}, {1750,0.00692727}, {1760,0.00727273}, {1770,0.00732727}, {1780,0.00726364}, {1790,0.00763636}, {1800,0.00755455}, {1810,0.00717273}, {1820,0.00736364}, {1830,0.00762727}, {1840,0.00763636}, {1850,0.00840909}, {1860,0.00793636}, {1870,0.00787273}, {1880,0.00761818}, {1890,0.00791818}, {1900,0.00841818}, {1910,0.00755455}, {1920,0.00831818}, {1930,0.00793636}, {1940,0.00780000}, {1950,0.00853636}, {1960,0.00814545}, {1970,0.00791818}, {1980,0.00836364}, {1990,0.00817273}, {2000,0.00861818}, {2050,0.02731818}, {2100,0.00875455}, {2150,0.00910909}, {2200,0.00920909}, {2250,0.00924545}, {2300,0.00964545}, {2350,0.00938182}, {2400,0.00976364}, {2450,0.01032727}, {2500,0.01023636}, {2550,0.01083636}, {2600,0.01092727}, {2650,0.02805455}, {2700,0.01102727}, {2750,0.01182727}, {2800,0.01144545}, {2850,0.01153636}, {2900,0.01211818}, {2950,0.01234545}, {3000,0.01267273}, {3050,0.01297273}, {3100,0.03045455}, {3150,0.01293636}, {3200,0.01285455}, {3250,0.01318182}, {3300,0.01324545}, {3350,0.01362727}, {3400,0.01367273}, {3450,0.01403636}, {3500,0.01381818}, {3550,0.02724545}, {3600,0.01453636}, {3650,0.01424545}, {3700,0.01485455}, {3750,0.01496364}, {3800,0.01558182}, {3850,0.01529091}, {3900,0.03130909}, {3950,0.01540909}, {4000,0.01565455}, {4050,0.01612727}, {4100,0.01695455}, {4150,0.01658182}, {4200,0.01683636}, {4250,0.03148182}, {4300,0.01785455}, {4350,0.01703636}, {4400,0.01776364}, {4450,0.01774545}, {4500,0.01765455}, {4550,0.03563636}, {4600,0.01854545}, {4650,0.01870909}, {4700,0.01892727}, {4750,0.01915455}, {4800,0.01915455}, {4850,0.03408182}, {4900,0.01951818}, {4950,0.01985455}, {5000,0.02037273}, {5050,0.02065741}, {5100,0.02024074}, {5150,0.03361111}, {5200,0.02078704}, {5250,0.02078704}, {5300,0.02166667}, {5350,0.02191667}, {5400,0.03991667}, {5450,0.02193519}, {5500,0.02244444}, {5550,0.02256481}, {5600,0.02284259}, {5650,0.03900000}, {5700,0.02295370}, {5750,0.02325926}, {5800,0.02325926}, {5850,0.02407407}, {5900,0.03758333}, {5950,0.02353704}, {6000,0.02416667}, {6050,0.02392593}, {6100,0.02475926}, {6150,0.02450000}, {6200,0.02487963}, {6250,0.02480556}, {6300,0.02547222}, {6350,0.03975000}, {6400,0.02565741}, {6450,0.02607407}, {6500,0.02587037}, {6550,0.02596296}, {6600,0.02620370}, {6650,0.02637963}, {6700,0.02592593}, {6750,0.02664815}, {6800,0.02615741}, {6850,0.02738889}, {6900,0.02725926}, {6950,0.02744444}, {7000,0.03803704}, {7050,0.02770370}, {7100,0.02789815}, {7150,0.02860185}, {7200,0.02856481}, {7250,0.02893519}, {7300,0.02899074}, {7350,0.02918519}, {7400,0.02886111}, {7450,0.02920370}, {7500,0.02974074}, {7550,0.05115741}, {7600,0.02975926}, {7650,0.03042593}, {7700,0.03030556}, {7750,0.04283333}, {7800,0.03104630}, {7850,0.03119444}, {7900,0.03141667}, {7950,0.03199074}, {8000,0.03187037}, {8050,0.03212037}, {8100,0.04913889}, {8150,0.03232407}, {8200,0.03259259}, {8250,0.03261111}, {8300,0.03306481}, {8350,0.03368519}, {8400,0.03318519}, {8450,0.05142593}, {8500,0.03425926}, {8550,0.03377778}, {8600,0.04737963}, {8650,0.03448148}, {8700,0.03509259}, {8750,0.05936111}, {8800,0.03491667}, {8850,0.03562037}, {8900,0.03565741}, {8950,0.03562963}, {9000,0.03615741}, {9050,0.03617593}, {9100,0.03583333}, {9150,0.03658333}, {9200,0.03625000}, {9250,0.03656481}, {9300,0.03679630}, {9350,0.03700926}, {9400,0.03687037}, {9450,0.03770370}, {9500,0.03781481}, {9550,0.03783333}, {9600,0.03806481}, {9650,0.03835185}, {9700,0.03807407}, {9750,0.03861111}, {9800,0.06740741}, {9850,0.03911111}, {9900,0.03892593}, {9950,0.05777778}, {10000,0.03972222}, {10100,0.03997222}, {10200,0.05720370}, {10300,0.04118519}, {10400,0.04140741}, {10500,0.06080556}, {10600,0.04258333}, {10700,0.06452778}, {10800,0.04245370}, {10900,0.04296296}, {11000,0.05645370}, {11100,0.04439815}, {11200,0.04428704}, {11300,0.04482407}, {11400,0.04541667}, {11500,0.06755556}, {11600,0.04603704}, {11700,0.08150000}, {11800,0.04688889}, {11900,0.04762963}, {12000,0.04723148}, {12100,0.04763889}, {12200,0.06307407}, {12300,0.04908333}, {12400,0.07861111}, {12500,0.04928704}, {12600,0.0495}, {12700,0.0555}, {12800,0.0760}, {12900,0.0510}, {13000,0.0635}, {13100,0.0555}, {13200,0.0795}, {13300,0.0515}, {13400,0.0855}, {13500,0.0530}, {13600,0.0840}, {13700,0.0560}, {13800,0.0935}, {13900,0.0580}, {14000,0.0910}, {14100,0.0555}, {14200,0.0940}, {14300,0.0580}, {14400,0.0835}, {14500,0.0580}, {14600,0.0795}, {14700,0.0600}, {14800,0.0840}, {14900,0.0600}, {15000,0.0870}, {15100,0.0655}, {15200,0.0815}, {15300,0.0615}, {15400,0.0595}, {15500,0.0615}, {15600,0.0620}, {15700,0.1070}, {15800,0.0615}, {15900,0.0870}, {16000,0.0660}, {16100,0.0850}, {16200,0.0675}, {16300,0.0660}, {16400,0.1060}, {16500,0.0650}, {16600,0.0855}, {16700,0.0640}, {16800,0.0695}, {16900,0.1035}, {17000,0.0715}, {17100,0.0870}, {17200,0.0680}, {17300,0.0700}, {17400,0.1020}, {17500,0.0715}, {17600,0.0895}, {17700,0.1050}, {17800,0.0720}, {17900,0.0855}, {18000,0.0720}, {18100,0.0700}, {18200,0.1095}, {18300,0.0740}, {18400,0.0750}, {18500,0.1035}, {18600,0.0775}, {18700,0.0775}, {18800,0.1075}, {18900,0.0795}, {19000,0.0735}, {19100,0.1055}, {19200,0.0775}, {19300,0.0800}, {19400,0.1095}, {19500,0.0780}, {19600,0.0800}, {19700,0.1130}, {19800,0.1370}, {19900,0.0795}, {20000,0.0775}};
data["big_flat"]["identity native_compute"]["Stats"]["system"] = {{1,0.00188393}, {2,0.00191964}, {3,0.00209821}, {4,0.00216071}, {5,0.00196429}, {6,0.00193750}, {7,0.00187500}, {8,0.00214286}, {9,0.00232143}, {10,0.00206250}, {11,0.00213393}, {12,0.00219643}, {13,0.00216071}, {14,0.00224107}, {15,0.00210714}, {16,0.00244643}, {17,0.00193750}, {18,0.00226786}, {19,0.00253571}, {20,0.00198214}, {21,0.00248214}, {22,0.00225893}, {23,0.00248214}, {24,0.00204464}, {25,0.00234821}, {26,0.00219643}, {27,0.00252679}, {28,0.00225000}, {29,0.00202679}, {30,0.00234821}, {31,0.00240179}, {32,0.00213393}, {33,0.00225893}, {34,0.00225893}, {35,0.00233036}, {36,0.00221429}, {37,0.00243750}, {38,0.00252679}, {39,0.00250000}, {40,0.00266964}, {41,0.00228571}, {42,0.00215179}, {43,0.00214286}, {44,0.00225000}, {45,0.00234821}, {46,0.00215179}, {47,0.00233036}, {48,0.00240179}, {49,0.00203571}, {50,0.00259821}, {51,0.00224107}, {52,0.00227679}, {53,0.00242857}, {54,0.00211607}, {55,0.00259821}, {56,0.00240179}, {57,0.00217857}, {58,0.00234821}, {59,0.00225893}, {60,0.00271429}, {61,0.00237500}, {62,0.00193750}, {63,0.00257143}, {64,0.00259821}, {65,0.00273214}, {66,0.00185714}, {67,0.00451786}, {68,0.00236607}, {69,0.00210714}, {70,0.00221429}, {71,0.00218750}, {72,0.00258929}, {73,0.00257143}, {74,0.00227679}, {75,0.00224107}, {76,0.00225893}, {77,0.00237500}, {78,0.00234821}, {79,0.00238393}, {80,0.00254464}, {81,0.00212500}, {82,0.00224107}, {83,0.00241071}, {84,0.00247321}, {85,0.00246429}, {86,0.00252679}, {87,0.00223214}, {88,0.00244643}, {89,0.00210714}, {90,0.00260714}, {91,0.00223214}, {92,0.00238393}, {93,0.00237500}, {94,0.00235714}, {95,0.00233036}, {96,0.00244643}, {97,0.00266964}, {98,0.00241964}, {99,0.00235714}, {100,0.00264286}, {101,0.00176786}, {102,0.00254464}, {103,0.00241964}, {104,0.00253571}, {105,0.00218750}, {106,0.00233929}, {107,0.00256250}, {108,0.00250893}, {109,0.00241071}, {110,0.00245536}, {111,0.00215179}, {112,0.00228571}, {113,0.00256250}, {114,0.00233036}, {115,0.00262500}, {116,0.00225000}, {117,0.00231250}, {118,0.00271429}, {119,0.00288393}, {120,0.00262500}, {121,0.00274107}, {122,0.00266071}, {123,0.00271429}, {124,0.00210714}, {125,0.00246429}, {126,0.00250000}, {127,0.00270536}, {128,0.00278571}, {129,0.00250893}, {130,0.00274107}, {131,0.00268750}, {132,0.00270536}, {133,0.00253571}, {134,0.00368750}, {135,0.00233929}, {136,0.00231250}, {137,0.00251786}, {138,0.00245536}, {139,0.00254464}, {140,0.00251786}, {141,0.00232143}, {142,0.00261607}, {143,0.00244643}, {144,0.00275000}, {145,0.00248214}, {146,0.00245946}, {147,0.00269369}, {148,0.00203604}, {149,0.00254054}, {150,0.00251351}, {151,0.00262162}, {152,0.00236937}, {153,0.00270270}, {154,0.00249550}, {155,0.00279279}, {156,0.00245946}, {157,0.00236937}, {158,0.00273874}, {159,0.00223423}, {160,0.00240541}, {161,0.00251351}, {162,0.00244144}, {163,0.00261261}, {164,0.00264865}, {165,0.00283784}, {166,0.00234234}, {167,0.00266667}, {168,0.00283784}, {169,0.00254054}, {170,0.00263063}, {171,0.00227928}, {172,0.00278378}, {173,0.00281081}, {174,0.00254054}, {175,0.00267568}, {176,0.00264865}, {177,0.00259459}, {178,0.00270270}, {179,0.00293694}, {180,0.00261261}, {181,0.00258559}, {182,0.00268468}, {183,0.00265766}, {184,0.00272072}, {185,0.00255856}, {186,0.00296396}, {187,0.00246847}, {188,0.00270270}, {189,0.00277477}, {190,0.00261261}, {191,0.00253153}, {192,0.00273874}, {193,0.00280180}, {194,0.00252252}, {195,0.00296396}, {196,0.00281982}, {197,0.00277477}, {198,0.00254955}, {199,0.00280180}, {200,0.00265766}, {201,0.00424324}, {202,0.00283784}, {203,0.00272973}, {204,0.00237838}, {205,0.00285586}, {206,0.00280180}, {207,0.00284685}, {208,0.00273874}, {209,0.00264865}, {210,0.00268468}, {211,0.00315315}, {212,0.00284685}, {213,0.00299099}, {214,0.00288288}, {215,0.00273874}, {216,0.00288288}, {217,0.00288288}, {218,0.00265766}, {219,0.00254955}, {220,0.00316216}, {221,0.00281982}, {222,0.00288288}, {223,0.00290090}, {224,0.00249550}, {225,0.00304505}, {226,0.00301802}, {227,0.00302703}, {228,0.00273874}, {229,0.00263964}, {230,0.00287387}, {231,0.00276577}, {232,0.00272072}, {233,0.00286486}, {234,0.00300901}, {235,0.00302703}, {236,0.00315315}, {237,0.00272072}, {238,0.00316216}, {239,0.00283784}, {240,0.00298198}, {241,0.00284685}, {242,0.00283784}, {243,0.00296396}, {244,0.00290991}, {245,0.00288288}, {246,0.00280180}, {247,0.00262162}, {248,0.00276577}, {249,0.00302703}, {250,0.00287387}, {251,0.00282883}, {252,0.00292793}, {253,0.00273874}, {254,0.00290991}, {255,0.00305405}, {256,0.00272072}, {257,0.00277477}, {258,0.00296396}, {259,0.00278378}, {260,0.00262162}, {261,0.00298198}, {262,0.00303604}, {263,0.00311712}, {264,0.00316216}, {265,0.00318919}, {266,0.00309009}, {267,0.00269369}, {268,0.00356757}, {269,0.00277477}, {270,0.00299099}, {271,0.00295495}, {272,0.00304505}, {273,0.00293694}, {274,0.00276577}, {275,0.00281081}, {276,0.00294595}, {277,0.00271171}, {278,0.00301802}, {279,0.00309910}, {280,0.00275676}, {281,0.00299099}, {282,0.00312613}, {283,0.00266667}, {284,0.00290991}, {285,0.00283784}, {286,0.00269369}, {287,0.00301802}, {288,0.00289189}, {289,0.00284685}, {290,0.00313514}, {291,0.00333333}, {292,0.00281081}, {293,0.00302703}, {294,0.00302703}, {295,0.00305405}, {296,0.00334234}, {297,0.00290090}, {298,0.00289189}, {299,0.00327273}, {300,0.00311818}, {301,0.00290909}, {302,0.00294545}, {303,0.00295455}, {304,0.00320909}, {305,0.00330000}, {306,0.00356364}, {307,0.00336364}, {308,0.00308182}, {309,0.00320000}, {310,0.00320000}, {311,0.00298182}, {312,0.00340909}, {313,0.00297273}, {314,0.00307273}, {315,0.00289091}, {316,0.00320909}, {317,0.00315455}, {318,0.00298182}, {319,0.00328182}, {320,0.00304545}, {321,0.00315455}, {322,0.00312727}, {323,0.00314545}, {324,0.00322727}, {325,0.00297273}, {326,0.00317273}, {327,0.00319091}, {328,0.00326364}, {329,0.00332727}, {330,0.00314545}, {331,0.00303636}, {332,0.00325455}, {333,0.00321818}, {334,0.00312727}, {335,0.00439091}, {336,0.00302727}, {337,0.00290909}, {338,0.00344545}, {339,0.00318182}, {340,0.00323636}, {341,0.00326364}, {342,0.00304545}, {343,0.00325455}, {344,0.00279091}, {345,0.00323636}, {346,0.00300000}, {347,0.00287273}, {348,0.00319091}, {349,0.00311818}, {350,0.00331818}, {351,0.00316364}, {352,0.00331818}, {353,0.00320909}, {354,0.00307273}, {355,0.00325455}, {356,0.00315455}, {357,0.00320000}, {358,0.00326364}, {359,0.00340000}, {360,0.00363636}, {361,0.00355455}, {362,0.00338182}, {363,0.00326364}, {364,0.00334545}, {365,0.00293636}, {366,0.00330909}, {367,0.00312727}, {368,0.00356364}, {369,0.00300909}, {370,0.00340909}, {371,0.00323636}, {372,0.00323636}, {373,0.00333636}, {374,0.00336364}, {375,0.00360909}, {376,0.00326364}, {377,0.00345455}, {378,0.00341818}, {379,0.00313636}, {380,0.00334545}, {381,0.00322727}, {382,0.00351818}, {383,0.00337273}, {384,0.00328182}, {385,0.00330000}, {386,0.00319091}, {387,0.00323636}, {388,0.00338182}, {389,0.00325455}, {390,0.00319091}, {391,0.00370000}, {392,0.00350909}, {393,0.00333636}, {394,0.00336364}, {395,0.00337273}, {396,0.00312727}, {397,0.00340000}, {398,0.00372727}, {399,0.00344545}, {400,0.00336364}, {401,0.00338182}, {402,0.00412727}, {403,0.00358182}, {404,0.00333636}, {405,0.00316364}, {406,0.00369091}, {407,0.00344545}, {408,0.00327273}, {409,0.00354545}, {410,0.00344545}, {411,0.00368182}, {412,0.00330000}, {413,0.00370000}, {414,0.00350000}, {415,0.00390909}, {416,0.00338182}, {417,0.00312727}, {418,0.00366364}, {419,0.00345455}, {420,0.00338182}, {421,0.00340909}, {422,0.00337273}, {423,0.00319091}, {424,0.00289091}, {425,0.00336364}, {426,0.00353636}, {427,0.00340000}, {428,0.00365455}, {429,0.00381818}, {430,0.00338182}, {431,0.00336364}, {432,0.00316364}, {433,0.00374545}, {434,0.00365455}, {435,0.00361818}, {436,0.00365455}, {437,0.00340909}, {438,0.00354545}, {439,0.00323636}, {440,0.00329091}, {441,0.00350000}, {442,0.00322727}, {443,0.00356364}, {444,0.00334545}, {445,0.00360000}, {446,0.00355455}, {447,0.00382727}, {448,0.00334545}, {449,0.00340909}, {450,0.00354545}, {451,0.00363636}, {452,0.00383636}, {453,0.00360909}, {454,0.00365455}, {455,0.00367273}, {456,0.00378182}, {457,0.00348182}, {458,0.00347273}, {459,0.00344545}, {460,0.00350909}, {461,0.00343636}, {462,0.00460000}, {463,0.00368182}, {464,0.00378182}, {465,0.00369091}, {466,0.00340909}, {467,0.00364545}, {468,0.00362727}, {469,0.00335455}, {470,0.00332727}, {471,0.00354545}, {472,0.00359091}, {473,0.00354545}, {474,0.00380909}, {475,0.00356364}, {476,0.00383636}, {477,0.00356364}, {478,0.00340909}, {479,0.00355455}, {480,0.00357273}, {481,0.00344545}, {482,0.00370909}, {483,0.00356364}, {484,0.00370000}, {485,0.00395455}, {486,0.00370909}, {487,0.00401818}, {488,0.00379091}, {489,0.00382727}, {490,0.00341818}, {491,0.00374545}, {492,0.00377273}, {493,0.00385455}, {494,0.00369091}, {495,0.00374545}, {496,0.00350909}, {497,0.00375455}, {498,0.00379091}, {499,0.00370909}, {500,0.00368182}, {505,0.00384545}, {510,0.00373636}, {515,0.00384545}, {520,0.00381818}, {525,0.00367273}, {530,0.00370000}, {535,0.00377273}, {540,0.00366364}, {545,0.00384545}, {550,0.00375455}, {555,0.00381818}, {560,0.00354545}, {565,0.00384545}, {570,0.00384545}, {575,0.00491818}, {580,0.00377273}, {585,0.00361818}, {590,0.00369091}, {595,0.00377273}, {600,0.00345455}, {605,0.00390909}, {610,0.00377273}, {615,0.00388182}, {620,0.00384545}, {625,0.00380909}, {630,0.00357273}, {635,0.00394545}, {640,0.00378182}, {645,0.00384545}, {650,0.00376364}, {655,0.00358182}, {660,0.00372727}, {665,0.00389091}, {670,0.00396364}, {675,0.00409091}, {680,0.00370000}, {685,0.00336364}, {690,0.00401818}, {695,0.00380000}, {700,0.00371818}, {705,0.00377273}, {710,0.00405455}, {715,0.00355455}, {720,0.00376364}, {725,0.00370000}, {730,0.00398182}, {735,0.00378182}, {740,0.00405455}, {745,0.00391818}, {750,0.00393636}, {755,0.00375455}, {760,0.00391818}, {765,0.00378182}, {770,0.00376364}, {775,0.00498182}, {780,0.00417273}, {785,0.00395455}, {790,0.00382727}, {795,0.00428182}, {800,0.00391818}, {805,0.00381818}, {810,0.00381818}, {815,0.00388182}, {820,0.00390909}, {825,0.00378182}, {830,0.00398182}, {835,0.00371818}, {840,0.00380909}, {845,0.00369091}, {850,0.00400000}, {855,0.00401818}, {860,0.00402727}, {865,0.00400000}, {870,0.00403636}, {875,0.00380909}, {880,0.00376364}, {885,0.00398182}, {890,0.00389091}, {895,0.00379091}, {900,0.00390000}, {905,0.00399091}, {910,0.00380909}, {915,0.00390000}, {920,0.00395455}, {925,0.00405455}, {930,0.00376364}, {935,0.00405455}, {940,0.00371818}, {945,0.00414545}, {950,0.00403636}, {955,0.00400909}, {960,0.00419091}, {965,0.00396364}, {970,0.00386364}, {975,0.00398182}, {980,0.00426364}, {985,0.00414545}, {990,0.00388182}, {995,0.00389091}, {1000,0.00421818}, {1010,0.00410000}, {1020,0.00390909}, {1030,0.00417273}, {1040,0.00408182}, {1050,0.00402727}, {1060,0.00415455}, {1070,0.00420909}, {1080,0.00400909}, {1090,0.00431818}, {1100,0.00395455}, {1110,0.00414545}, {1120,0.00420909}, {1130,0.00491818}, {1140,0.00421818}, {1150,0.00413636}, {1160,0.00415455}, {1170,0.00405455}, {1180,0.00425455}, {1190,0.00375455}, {1200,0.00400909}, {1210,0.00423636}, {1220,0.00419091}, {1230,0.00429091}, {1240,0.00421818}, {1250,0.00415455}, {1260,0.00434545}, {1270,0.00414545}, {1280,0.00415455}, {1290,0.00388182}, {1300,0.00429091}, {1310,0.00420909}, {1320,0.00389091}, {1330,0.00415455}, {1340,0.00405455}, {1350,0.00526364}, {1360,0.00419091}, {1370,0.00420000}, {1380,0.00418182}, {1390,0.00428182}, {1400,0.00410000}, {1410,0.00426364}, {1420,0.00428182}, {1430,0.00393636}, {1440,0.00411818}, {1450,0.00416364}, {1460,0.00428182}, {1470,0.00421818}, {1480,0.00410909}, {1490,0.00416364}, {1500,0.00441818}, {1510,0.00410909}, {1520,0.00408182}, {1530,0.00407273}, {1540,0.00520909}, {1550,0.00410909}, {1560,0.00420909}, {1570,0.00416364}, {1580,0.00420000}, {1590,0.00433636}, {1600,0.00430909}, {1610,0.00409091}, {1620,0.00406364}, {1630,0.00406364}, {1640,0.00376364}, {1650,0.00384545}, {1660,0.00398182}, {1670,0.00412727}, {1680,0.00429091}, {1690,0.00392727}, {1700,0.00427273}, {1710,0.00475455}, {1720,0.00428182}, {1730,0.00420000}, {1740,0.00405455}, {1750,0.00436364}, {1760,0.00430909}, {1770,0.00422727}, {1780,0.00436364}, {1790,0.00410909}, {1800,0.00411818}, {1810,0.00443636}, {1820,0.00436364}, {1830,0.00426364}, {1840,0.00414545}, {1850,0.00426364}, {1860,0.00411818}, {1870,0.00420000}, {1880,0.00423636}, {1890,0.00425455}, {1900,0.00399091}, {1910,0.00451818}, {1920,0.00414545}, {1930,0.00432727}, {1940,0.00424545}, {1950,0.00430909}, {1960,0.00433636}, {1970,0.00425455}, {1980,0.00434545}, {1990,0.00450000}, {2000,0.00404545}, {2050,0.00505455}, {2100,0.00439091}, {2150,0.00431818}, {2200,0.00439091}, {2250,0.00462727}, {2300,0.00440000}, {2350,0.00455455}, {2400,0.00470909}, {2450,0.00431818}, {2500,0.00444545}, {2550,0.00432727}, {2600,0.00461818}, {2650,0.00508182}, {2700,0.00460000}, {2750,0.00433636}, {2800,0.00467273}, {2850,0.00487273}, {2900,0.00436364}, {2950,0.00444545}, {3000,0.00443636}, {3050,0.00438182}, {3100,0.00482727}, {3150,0.00436364}, {3200,0.00480000}, {3250,0.00431818}, {3300,0.00466364}, {3350,0.00454545}, {3400,0.00422727}, {3450,0.00440909}, {3500,0.00490000}, {3550,0.00497273}, {3600,0.00433636}, {3650,0.00449091}, {3700,0.00456364}, {3750,0.00466364}, {3800,0.00440000}, {3850,0.00468182}, {3900,0.00497273}, {3950,0.00470000}, {4000,0.00461818}, {4050,0.00448182}, {4100,0.00424545}, {4150,0.00455455}, {4200,0.00433636}, {4250,0.00535455}, {4300,0.00418182}, {4350,0.00450000}, {4400,0.00455455}, {4450,0.00441818}, {4500,0.00449091}, {4550,0.00504545}, {4600,0.00446364}, {4650,0.00436364}, {4700,0.00432727}, {4750,0.00437273}, {4800,0.00470000}, {4850,0.00544545}, {4900,0.00473636}, {4950,0.00445455}, {5000,0.00454545}, {5050,0.00442593}, {5100,0.00452778}, {5150,0.00496296}, {5200,0.00467593}, {5250,0.00497222}, {5300,0.00427778}, {5350,0.00446296}, {5400,0.00505556}, {5450,0.00454630}, {5500,0.00451852}, {5550,0.00439815}, {5600,0.00445370}, {5650,0.00527778}, {5700,0.00445370}, {5750,0.00440741}, {5800,0.00474074}, {5850,0.00425000}, {5900,0.00526852}, {5950,0.00476852}, {6000,0.00442593}, {6050,0.00485185}, {6100,0.00433333}, {6150,0.00438889}, {6200,0.00475000}, {6250,0.00514815}, {6300,0.00457407}, {6350,0.00486111}, {6400,0.00459259}, {6450,0.00455556}, {6500,0.00450000}, {6550,0.00475926}, {6600,0.00486111}, {6650,0.00470370}, {6700,0.00521296}, {6750,0.00471296}, {6800,0.00534259}, {6850,0.00475926}, {6900,0.00473148}, {6950,0.00468519}, {7000,0.00575000}, {7050,0.00461111}, {7100,0.00453704}, {7150,0.00460185}, {7200,0.00462963}, {7250,0.00453704}, {7300,0.00466667}, {7350,0.00475000}, {7400,0.00474074}, {7450,0.00486111}, {7500,0.00494444}, {7550,0.00536111}, {7600,0.00498148}, {7650,0.00454630}, {7700,0.00507407}, {7750,0.00555556}, {7800,0.00470370}, {7850,0.00507407}, {7900,0.00496296}, {7950,0.00440741}, {8000,0.00480556}, {8050,0.00473148}, {8100,0.00550000}, {8150,0.00492593}, {8200,0.00474074}, {8250,0.00500000}, {8300,0.00469444}, {8350,0.00472222}, {8400,0.00488889}, {8450,0.00500926}, {8500,0.00464815}, {8550,0.00503704}, {8600,0.00543519}, {8650,0.00510185}, {8700,0.00476852}, {8750,0.00601852}, {8800,0.00487963}, {8850,0.00473148}, {8900,0.00455556}, {8950,0.00473148}, {9000,0.00478704}, {9050,0.00452778}, {9100,0.00493519}, {9150,0.00493519}, {9200,0.00487963}, {9250,0.00500926}, {9300,0.00479630}, {9350,0.00480556}, {9400,0.00505556}, {9450,0.00461111}, {9500,0.00489815}, {9550,0.00468519}, {9600,0.00500000}, {9650,0.00483333}, {9700,0.00494444}, {9750,0.00450926}, {9800,0.00548148}, {9850,0.00497222}, {9900,0.00478704}, {9950,0.00531481}, {10000,0.00463889}, {10100,0.00489815}, {10200,0.00548148}, {10300,0.00445370}, {10400,0.00458333}, {10500,0.00556481}, {10600,0.00502778}, {10700,0.00547222}, {10800,0.00488889}, {10900,0.00510185}, {11000,0.00504630}, {11100,0.00470370}, {11200,0.00500000}, {11300,0.00490741}, {11400,0.00489815}, {11500,0.00506481}, {11600,0.00485185}, {11700,0.00577778}, {11800,0.00465741}, {11900,0.00462037}, {12000,0.00469444}, {12100,0.00529630}, {12200,0.00510185}, {12300,0.00453704}, {12400,0.00565741}, {12500,0.00504630}, {12600,0.0020}, {12700,0.0000}, {12800,0.0035}, {12900,0.0040}, {13000,0.0020}, {13100,0.0000}, {13200,0.0020}, {13300,0.0040}, {13400,0.0020}, {13500,0.0020}, {13600,0.0020}, {13700,0.0015}, {13800,0.0060}, {13900,0.0020}, {14000,0.0020}, {14100,0.0040}, {14200,0.0020}, {14300,0.0040}, {14400,0.0020}, {14500,0.0020}, {14600,0.0040}, {14700,0.0040}, {14800,0.0040}, {14900,0.0040}, {15000,0.0000}, {15100,0.0000}, {15200,0.0035}, {15300,0.0040}, {15400,0.0040}, {15500,0.0035}, {15600,0.0020}, {15700,0.0020}, {15800,0.0040}, {15900,0.0020}, {16000,0.0020}, {16100,0.0060}, {16200,0.0020}, {16300,0.0020}, {16400,0.0020}, {16500,0.0040}, {16600,0.0020}, {16700,0.0060}, {16800,0.0020}, {16900,0.0040}, {17000,0.0000}, {17100,0.0035}, {17200,0.0040}, {17300,0.0020}, {17400,0.0040}, {17500,0.0015}, {17600,0.0020}, {17700,0.0020}, {17800,0.0040}, {17900,0.0060}, {18000,0.0040}, {18100,0.0040}, {18200,0.0020}, {18300,0.0040}, {18400,0.0020}, {18500,0.0040}, {18600,0.0000}, {18700,0.0020}, {18800,0.0020}, {18900,0.0020}, {19000,0.0020}, {19100,0.0040}, {19200,0.0015}, {19300,0.0000}, {19400,0.0015}, {19500,0.0040}, {19600,0.0020}, {19700,0.0040}, {19800,0.0020}, {19900,0.0020}, {20000,0.0040}};
data["big_flat"]["identity simpl"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00001770}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00001770}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000885}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000885}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000885}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00001770}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00098230}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00001770}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000885}, {765,0.00000000}, {770,0.00178761}, {775,0.00000000}, {780,0.00000000}, {785,0.00000885}, {790,0.00000885}, {795,0.00000893}, {800,0.00000893}, {805,0.00003571}, {810,0.00007143}, {815,0.00006250}, {820,0.00008929}, {825,0.00015179}, {830,0.00023214}, {835,0.00027679}, {840,0.00306250}, {845,0.00060714}, {850,0.00064286}, {855,0.00068750}, {860,0.00070536}, {865,0.00076786}, {870,0.00075000}, {875,0.00078571}, {880,0.00068750}, {885,0.00077679}, {890,0.00082143}, {895,0.00083036}, {900,0.00089286}, {905,0.00092857}, {910,0.00091071}, {915,0.00098214}, {920,0.00099107}, {925,0.00097321}, {930,0.00099107}, {935,0.00099107}, {940,0.00100000}, {945,0.00100000}, {950,0.00100000}, {955,0.00100000}, {960,0.00100000}, {965,0.00100000}, {970,0.00100000}, {975,0.00100000}, {980,0.00100000}, {985,0.00100000}, {990,0.00100000}, {995,0.00100000}, {1000,0.00100000}, {1010,0.00100000}, {1020,0.00100000}, {1030,0.00100893}, {1040,0.00100000}, {1050,0.00100000}, {1060,0.00100000}, {1070,0.00100000}, {1080,0.00100000}, {1090,0.00100000}, {1100,0.00100000}, {1110,0.00100000}, {1120,0.00100000}, {1130,0.00100000}, {1140,0.00100000}, {1150,0.00100000}, {1160,0.00100000}, {1170,0.00100000}, {1180,0.00100000}, {1190,0.00100000}, {1200,0.00100000}, {1210,0.00100000}, {1220,0.00100000}, {1230,0.00100000}, {1240,0.00100000}, {1250,0.00100000}, {1260,0.00100000}, {1270,0.00100000}, {1280,0.00100000}, {1290,0.00100000}, {1300,0.00100000}, {1310,0.00100000}, {1320,0.00100000}, {1330,0.00100000}, {1340,0.00100000}, {1350,0.00100000}, {1360,0.00100000}, {1370,0.00100000}, {1380,0.00100000}, {1390,0.00100000}, {1400,0.00100000}, {1410,0.00100000}, {1420,0.00100000}, {1430,0.00103571}, {1440,0.00100000}, {1450,0.00100000}, {1460,0.00100000}, {1470,0.00100000}, {1480,0.00100000}, {1490,0.00100000}, {1500,0.00100000}, {1510,0.00100000}, {1520,0.00100000}, {1530,0.00100000}, {1540,0.00100000}, {1550,0.00100000}, {1560,0.00100000}, {1570,0.00100000}, {1580,0.00100000}, {1590,0.00100000}, {1600,0.00100000}, {1610,0.00100000}, {1620,0.00104464}, {1630,0.00105357}, {1640,0.00299107}, {1650,0.00104464}, {1660,0.00113393}, {1670,0.00110714}, {1680,0.00133036}, {1690,0.00149107}, {1700,0.00149107}, {1710,0.00149107}, {1720,0.00104464}, {1730,0.00172321}, {1740,0.00173214}, {1750,0.00173214}, {1760,0.00172321}, {1770,0.00174107}, {1780,0.00153571}, {1790,0.00174107}, {1800,0.00174107}, {1810,0.00175000}, {1820,0.00175893}, {1830,0.00179464}, {1840,0.00175893}, {1850,0.00177679}, {1860,0.00191964}, {1870,0.00196429}, {1880,0.00193750}, {1890,0.00197321}, {1900,0.00200893}, {1910,0.00199107}, {1920,0.00200000}, {1930,0.00199107}, {1940,0.00200893}, {1950,0.00200000}, {1960,0.00200000}, {1970,0.00203571}, {1980,0.00199107}, {1990,0.00200000}, {2000,0.00200000}, {2050,0.00200000}, {2100,0.00200000}, {2150,0.00491071}, {2200,0.00200000}, {2250,0.00200000}, {2300,0.00200000}, {2350,0.00200000}, {2400,0.00200000}, {2450,0.00204464}, {2500,0.00218750}, {2550,0.00233036}, {2600,0.00273214}, {2650,0.00276786}, {2700,0.00276786}, {2750,0.00275893}, {2800,0.00287500}, {2850,0.00299107}, {2900,0.00304464}, {2950,0.00299107}, {3000,0.00300000}, {3050,0.00356250}, {3100,0.00300000}, {3150,0.00572321}, {3200,0.00300000}, {3250,0.00300893}, {3300,0.00300000}, {3350,0.00315179}, {3400,0.00300893}, {3450,0.00359821}, {3500,0.00376786}, {3550,0.00376786}, {3600,0.00375893}, {3650,0.00375000}, {3700,0.00375893}, {3750,0.00375000}, {3800,0.00817857}, {3850,0.00398214}, {3900,0.00771429}, {3950,0.00400000}, {4000,0.00400893}, {4050,0.00400000}, {4100,0.00400000}, {4150,0.00400893}, {4200,0.00405357}, {4250,0.00429464}, {4300,0.00400893}, {4350,0.00478571}, {4400,0.00404464}, {4450,0.00476786}, {4500,0.00476786}, {4550,0.00471429}, {4600,0.00475893}, {4650,0.00475893}, {4700,0.00486607}, {4750,0.00497321}, {4800,0.00499107}, {4850,0.00499107}, {4900,0.00500000}, {4950,0.00505357}, {5000,0.00500893}, {5050,0.00500000}, {5100,0.00523214}, {5150,0.00542857}, {5200,0.00500893}, {5250,0.00572321}, {5300,0.00503571}, {5350,0.00574107}, {5400,0.00564286}, {5450,0.00573214}, {5500,0.00573214}, {5550,0.00575000}, {5600,0.00573214}, {5650,0.01225893}, {5700,0.00583036}, {5750,0.00595536}, {5800,0.00600000}, {5850,0.00604464}, {5900,0.00585714}, {5950,0.00595536}, {6000,0.00650000}, {6050,0.00666964}, {6100,0.00600893}, {6150,0.00675000}, {6200,0.00675000}, {6250,0.00675000}, {6300,0.00674107}, {6350,0.00673214}, {6400,0.00666964}, {6450,0.00671429}, {6500,0.00680357}, {6550,0.00672321}, {6600,0.00671429}, {6650,0.00669643}, {6700,0.00670536}, {6750,0.00673214}, {6800,0.00671429}, {6850,0.00675893}, {6900,0.00765179}, {6950,0.00768750}, {7000,0.00770536}, {7050,0.00696429}, {7100,0.00768750}, {7150,0.00713393}, {7200,0.00776786}, {7250,0.00738393}, {7300,0.00769643}, {7350,0.00768750}, {7400,0.01835714}, {7450,0.00772321}, {7500,0.00779464}, {7550,0.00771429}, {7600,0.00770536}, {7650,0.00769643}, {7700,0.00769643}, {7750,0.00770536}, {7800,0.00787500}, {7850,0.00869643}, {7900,0.00870536}, {7950,0.01534821}, {8000,0.00804464}, {8050,0.00873214}, {8100,0.00825000}, {8150,0.00873214}, {8200,0.00874107}, {8250,0.00875000}, {8300,0.00889286}, {8350,0.01809821}, {8400,0.00886607}, {8450,0.00902679}, {8500,0.00872321}, {8550,0.00887500}, {8600,0.00891964}, {8650,0.00888393}, {8700,0.00889286}, {8750,0.00869643}, {8800,0.00966964}, {8850,0.00968750}, {8900,0.01946429}, {8950,0.00875893}, {9000,0.00969643}, {9050,0.00966964}, {9100,0.00964286}, {9150,0.00965179}, {9200,0.00972321}, {9250,0.00962500}, {9300,0.02257143}, {9350,0.01009821}, {9400,0.00964286}, {9450,0.00963393}, {9500,0.00965179}, {9550,0.00966964}, {9600,0.00967857}, {9650,0.00968750}, {9700,0.00967857}, {9750,0.00967857}, {9800,0.01068750}, {9850,0.01066964}, {9900,0.00980357}, {9950,0.01064286}, {10000,0.02022321}, {10100,0.01057143}, {10200,0.02118750}, {10300,0.01119643}, {10400,0.01064286}, {10500,0.01091071}, {10600,0.01064286}, {10700,0.01092857}, {10800,0.01158036}, {10900,0.02392857}, {11000,0.01144643}, {11100,0.01213393}, {11200,0.01189286}, {11300,0.01157143}, {11400,0.02142857}, {11500,0.02249107}, {11600,0.02151786}, {11700,0.01175000}, {11800,0.01196429}, {11900,0.01333036}, {12000,0.01250893}, {12100,0.01333036}, {12200,0.01259821}, {12300,0.01256250}, {12400,0.01257143}, {12500,0.02683036}, {12600,0.01325}, {12700,0.01300}, {12800,0.01400}, {12900,0.01325}, {13000,0.01400}, {13100,0.01400}, {13200,0.05075}, {13300,0.01475}, {13400,0.01450}, {13500,0.01450}, {13600,0.01500}, {13700,0.04150}, {13800,0.01450}, {13900,0.01500}, {14000,0.01475}, {14100,0.03325}, {14200,0.01500}, {14300,0.01500}, {14400,0.01475}, {14500,0.01500}, {14600,0.01550}, {14700,0.03125}, {14800,0.01550}, {14900,0.01600}, {15000,0.01575}, {15100,0.03275}, {15200,0.02875}, {15300,0.01625}, {15400,0.01625}, {15500,0.03425}, {15600,0.03050}, {15700,0.01625}, {15800,0.03500}, {15900,0.01700}, {16000,0.01700}, {16100,0.03450}, {16200,0.01750}, {16300,0.01700}, {16400,0.01725}, {16500,0.03025}, {16600,0.01800}, {16700,0.03100}, {16800,0.03450}, {16900,0.02925}, {17000,0.01775}, {17100,0.02900}, {17200,0.03025}, {17300,0.03025}, {17400,0.03100}, {17500,0.01825}, {17600,0.02725}, {17700,0.03025}, {17800,0.02975}, {17900,0.01850}, {18000,0.02675}, {18100,0.01900}, {18200,0.02725}, {18300,0.03575}, {18400,0.02850}, {18500,0.01950}, {18600,0.01975}, {18700,0.03050}, {18800,0.02800}, {18900,0.01950}, {19000,0.01975}, {19100,0.02925}, {19200,0.03050}, {19300,0.02025}, {19400,0.02000}, {19500,0.02025}, {19600,0.02025}, {19700,0.02050}, {19800,0.02075}, {19900,0.04300}, {20000,0.0580}};
data["big_flat"]["identity simpl"]["Stats"]["user"] = {{1,0.00002655}, {2,0.00000000}, {3,0.00002655}, {4,0.00000000}, {5,0.00003540}, {6,0.00003540}, {7,0.00000000}, {8,0.00007965}, {9,0.00000000}, {10,0.00005310}, {11,0.00005310}, {12,0.00000000}, {13,0.00005310}, {14,0.00002655}, {15,0.00002655}, {16,0.00007965}, {17,0.00006195}, {18,0.00009735}, {19,0.00000000}, {20,0.00008850}, {21,0.00007965}, {22,0.00006195}, {23,0.00000000}, {24,0.00003540}, {25,0.00002655}, {26,0.00003540}, {27,0.00005310}, {28,0.00008850}, {29,0.00005310}, {30,0.00010619}, {31,0.00002655}, {32,0.00008850}, {33,0.00002655}, {34,0.00000000}, {35,0.00005310}, {36,0.00006195}, {37,0.00013274}, {38,0.00008850}, {39,0.00011504}, {40,0.00005310}, {41,0.00000000}, {42,0.00000000}, {43,0.00011504}, {44,0.00008850}, {45,0.00016814}, {46,0.00002655}, {47,0.00007965}, {48,0.00011504}, {49,0.00006195}, {50,0.00003540}, {51,0.00013274}, {52,0.00015929}, {53,0.00009735}, {54,0.00005310}, {55,0.00015044}, {56,0.00000000}, {57,0.00010619}, {58,0.00005310}, {59,0.00008850}, {60,0.00013274}, {61,0.00002655}, {62,0.00018584}, {63,0.00012389}, {64,0.00000000}, {65,0.00006195}, {66,0.00000000}, {67,0.00021239}, {68,0.00006195}, {69,0.00012389}, {70,0.00008850}, {71,0.00012389}, {72,0.00002655}, {73,0.00016814}, {74,0.00015044}, {75,0.00008850}, {76,0.00007965}, {77,0.00008850}, {78,0.00012389}, {79,0.00011504}, {80,0.00003540}, {81,0.00015929}, {82,0.00012389}, {83,0.00012389}, {84,0.00002655}, {85,0.00014159}, {86,0.00008850}, {87,0.00007965}, {88,0.00006195}, {89,0.00005310}, {90,0.00009735}, {91,0.00015044}, {92,0.00002655}, {93,0.00006195}, {94,0.00018584}, {95,0.00008850}, {96,0.00014159}, {97,0.00014159}, {98,0.00011504}, {99,0.00006195}, {100,0.00020354}, {101,0.00019469}, {102,0.00013274}, {103,0.00000000}, {104,0.00016814}, {105,0.00012389}, {106,0.00005310}, {107,0.00008850}, {108,0.00015929}, {109,0.00003540}, {110,0.00012389}, {111,0.00005310}, {112,0.00002655}, {113,0.00014159}, {114,0.00024779}, {115,0.00006195}, {116,0.00014159}, {117,0.00023894}, {118,0.00015044}, {119,0.00016814}, {120,0.00012389}, {121,0.00012389}, {122,0.00009735}, {123,0.00011504}, {124,0.00022124}, {125,0.00008850}, {126,0.00018584}, {127,0.00011504}, {128,0.00015929}, {129,0.00012389}, {130,0.00010619}, {131,0.00007965}, {132,0.00016814}, {133,0.00011504}, {134,0.00024779}, {135,0.00010619}, {136,0.00015044}, {137,0.00022124}, {138,0.00010619}, {139,0.00022124}, {140,0.00020354}, {141,0.00019469}, {142,0.00028319}, {143,0.00022124}, {144,0.00009735}, {145,0.00016814}, {146,0.00027434}, {147,0.00016814}, {148,0.00007965}, {149,0.00017699}, {150,0.00012389}, {151,0.00019469}, {152,0.00011504}, {153,0.00007965}, {154,0.00033628}, {155,0.00016814}, {156,0.00026549}, {157,0.00029204}, {158,0.00011504}, {159,0.00017699}, {160,0.00011504}, {161,0.00007965}, {162,0.00023894}, {163,0.00015929}, {164,0.00010619}, {165,0.00021239}, {166,0.00029204}, {167,0.00020354}, {168,0.00020354}, {169,0.00014159}, {170,0.00022124}, {171,0.00010619}, {172,0.00031858}, {173,0.00021239}, {174,0.00008850}, {175,0.00014159}, {176,0.00035398}, {177,0.00023894}, {178,0.00013274}, {179,0.00008850}, {180,0.00031858}, {181,0.00008850}, {182,0.00014159}, {183,0.00027434}, {184,0.00016814}, {185,0.00021239}, {186,0.00015044}, {187,0.00022124}, {188,0.00018584}, {189,0.00019469}, {190,0.00027434}, {191,0.00017699}, {192,0.00023894}, {193,0.00035398}, {194,0.00028319}, {195,0.00016814}, {196,0.00018584}, {197,0.00017699}, {198,0.00023009}, {199,0.00021239}, {200,0.00022124}, {201,0.00030973}, {202,0.00014159}, {203,0.00016814}, {204,0.00011504}, {205,0.00020354}, {206,0.00032743}, {207,0.00023894}, {208,0.00030088}, {209,0.00017699}, {210,0.00023894}, {211,0.00026549}, {212,0.00029204}, {213,0.00011504}, {214,0.00038938}, {215,0.00022124}, {216,0.00037168}, {217,0.00020354}, {218,0.00013274}, {219,0.00018584}, {220,0.00024779}, {221,0.00043363}, {222,0.00019469}, {223,0.00023009}, {224,0.00025664}, {225,0.00022124}, {226,0.00029204}, {227,0.00030973}, {228,0.00026549}, {229,0.00023894}, {230,0.00031858}, {231,0.00027434}, {232,0.00019469}, {233,0.00023894}, {234,0.00026549}, {235,0.00020354}, {236,0.00026549}, {237,0.00015044}, {238,0.00015929}, {239,0.00026549}, {240,0.00033628}, {241,0.00021239}, {242,0.00015044}, {243,0.00030088}, {244,0.00018584}, {245,0.00027434}, {246,0.00037168}, {247,0.00022124}, {248,0.00033628}, {249,0.00040708}, {250,0.00023009}, {251,0.00029204}, {252,0.00038938}, {253,0.00016814}, {254,0.00025664}, {255,0.00025664}, {256,0.00020354}, {257,0.00023009}, {258,0.00016814}, {259,0.00032743}, {260,0.00031858}, {261,0.00017699}, {262,0.00020354}, {263,0.00016814}, {264,0.00028319}, {265,0.00025664}, {266,0.00037168}, {267,0.00031858}, {268,0.00026549}, {269,0.00051327}, {270,0.00020354}, {271,0.00030973}, {272,0.00023894}, {273,0.00033628}, {274,0.00017699}, {275,0.00025664}, {276,0.00030088}, {277,0.00039823}, {278,0.00015929}, {279,0.00023894}, {280,0.00026549}, {281,0.00028319}, {282,0.00022124}, {283,0.00030088}, {284,0.00034513}, {285,0.00020354}, {286,0.00024779}, {287,0.00034513}, {288,0.00028319}, {289,0.00014159}, {290,0.00036283}, {291,0.00029204}, {292,0.00045133}, {293,0.00014159}, {294,0.00022124}, {295,0.00034513}, {296,0.00038938}, {297,0.00032743}, {298,0.00017699}, {299,0.00022124}, {300,0.00034513}, {301,0.00027434}, {302,0.00018584}, {303,0.00028319}, {304,0.00025664}, {305,0.00029204}, {306,0.00041593}, {307,0.00030088}, {308,0.00012389}, {309,0.00041593}, {310,0.00033628}, {311,0.00032743}, {312,0.00027434}, {313,0.00045133}, {314,0.00039823}, {315,0.00024779}, {316,0.00036283}, {317,0.00031858}, {318,0.00023009}, {319,0.00016814}, {320,0.00039823}, {321,0.00031858}, {322,0.00038053}, {323,0.00040708}, {324,0.00039823}, {325,0.00046018}, {326,0.00051327}, {327,0.00031858}, {328,0.00023009}, {329,0.00040708}, {330,0.00056637}, {331,0.00038938}, {332,0.00042478}, {333,0.00038938}, {334,0.00045133}, {335,0.00024779}, {336,0.00044248}, {337,0.00044248}, {338,0.00030088}, {339,0.00030973}, {340,0.00053982}, {341,0.00039823}, {342,0.00041593}, {343,0.00041593}, {344,0.00043363}, {345,0.00016814}, {346,0.00045133}, {347,0.00049558}, {348,0.00033628}, {349,0.00017699}, {350,0.00036283}, {351,0.00027434}, {352,0.00019469}, {353,0.00039823}, {354,0.00042478}, {355,0.00035398}, {356,0.00053097}, {357,0.00028319}, {358,0.00038938}, {359,0.00045133}, {360,0.00038938}, {361,0.00023009}, {362,0.00040708}, {363,0.00023894}, {364,0.00043363}, {365,0.00050442}, {366,0.00053982}, {367,0.00031858}, {368,0.00029204}, {369,0.00046018}, {370,0.00036283}, {371,0.00035398}, {372,0.00043363}, {373,0.00030088}, {374,0.00061947}, {375,0.00032743}, {376,0.00049558}, {377,0.00058407}, {378,0.00036283}, {379,0.00057522}, {380,0.00044248}, {381,0.00045133}, {382,0.00021239}, {383,0.00059292}, {384,0.00028319}, {385,0.00039823}, {386,0.00037168}, {387,0.00024779}, {388,0.00053982}, {389,0.00055752}, {390,0.00051327}, {391,0.00048673}, {392,0.00035398}, {393,0.00053097}, {394,0.00063717}, {395,0.00046903}, {396,0.00049558}, {397,0.00041593}, {398,0.00041593}, {399,0.00065487}, {400,0.00035398}, {401,0.00021239}, {402,0.00055752}, {403,0.00052212}, {404,0.00030973}, {405,0.00035398}, {406,0.00032743}, {407,0.00046018}, {408,0.00051327}, {409,0.00038938}, {410,0.00033628}, {411,0.00046903}, {412,0.00047788}, {413,0.00045133}, {414,0.00037168}, {415,0.00037168}, {416,0.00050442}, {417,0.00068142}, {418,0.00050442}, {419,0.00033628}, {420,0.00033628}, {421,0.00053982}, {422,0.00058407}, {423,0.00051327}, {424,0.00063717}, {425,0.00039823}, {426,0.00042478}, {427,0.00050442}, {428,0.00046018}, {429,0.00044248}, {430,0.00059292}, {431,0.00065487}, {432,0.00058407}, {433,0.00061062}, {434,0.00050442}, {435,0.00052212}, {436,0.00054867}, {437,0.00051327}, {438,0.00046018}, {439,0.00046018}, {440,0.00058407}, {441,0.00054867}, {442,0.00038938}, {443,0.00049558}, {444,0.00047788}, {445,0.00037168}, {446,0.00036283}, {447,0.00021239}, {448,0.00061947}, {449,0.00062832}, {450,0.00064602}, {451,0.00033628}, {452,0.00052212}, {453,0.00048673}, {454,0.00038053}, {455,0.00040708}, {456,0.00053097}, {457,0.00059292}, {458,0.00051327}, {459,0.00044248}, {460,0.00038053}, {461,0.00055752}, {462,0.00056637}, {463,0.00055752}, {464,0.00059292}, {465,0.00054867}, {466,0.00031858}, {467,0.00024779}, {468,0.00030973}, {469,0.00026549}, {470,0.00058407}, {471,0.00056637}, {472,0.00036283}, {473,0.00029204}, {474,0.00055752}, {475,0.00054867}, {476,0.00052212}, {477,0.00056637}, {478,0.00064602}, {479,0.00067257}, {480,0.00050442}, {481,0.00053097}, {482,0.00056637}, {483,0.00053097}, {484,0.00055752}, {485,0.00076991}, {486,0.00041593}, {487,0.00039823}, {488,0.00061947}, {489,0.00077876}, {490,0.00042478}, {491,0.00023894}, {492,0.00063717}, {493,0.00069027}, {494,0.00056637}, {495,0.00038053}, {496,0.00047788}, {497,0.00049558}, {498,0.00044248}, {499,0.00042478}, {500,0.00117699}, {505,0.00062832}, {510,0.00040708}, {515,0.00062832}, {520,0.00055752}, {525,0.00084956}, {530,0.00074336}, {535,0.00050442}, {540,0.00038053}, {545,0.00076991}, {550,0.00060177}, {555,0.00051327}, {560,0.00051327}, {565,0.00054867}, {570,0.00091150}, {575,0.00080531}, {580,0.00068142}, {585,0.00051327}, {590,0.00034513}, {595,0.00079646}, {600,0.00059292}, {605,0.00054867}, {610,0.00044248}, {615,0.00051327}, {620,0.00076991}, {625,0.00071681}, {630,0.00070796}, {635,0.00068142}, {640,0.00057522}, {645,0.00069912}, {650,0.00061062}, {655,0.00074336}, {660,0.00087611}, {665,0.00055752}, {670,0.00070796}, {675,0.00061947}, {680,0.00059292}, {685,0.00063717}, {690,0.00087611}, {695,0.00074336}, {700,0.00067257}, {705,0.00097345}, {710,0.00070796}, {715,0.00069027}, {720,0.00059292}, {725,0.00080531}, {730,0.00072566}, {735,0.00065487}, {740,0.00069027}, {745,0.00124779}, {750,0.00089381}, {755,0.00105310}, {760,0.00098230}, {765,0.00067257}, {770,0.00196460}, {775,0.00089381}, {780,0.00064602}, {785,0.00092035}, {790,0.00077876}, {795,0.00089286}, {800,0.00066964}, {805,0.00093750}, {810,0.00093750}, {815,0.00108929}, {820,0.00083929}, {825,0.00111607}, {830,0.00090179}, {835,0.00083929}, {840,0.00087500}, {845,0.00066071}, {850,0.00099107}, {855,0.00073214}, {860,0.00081250}, {865,0.00100893}, {870,0.00068750}, {875,0.00086607}, {880,0.00075893}, {885,0.00094643}, {890,0.00090179}, {895,0.00111607}, {900,0.00091964}, {905,0.00104464}, {910,0.00117857}, {915,0.00095536}, {920,0.00078571}, {925,0.00094643}, {930,0.00083036}, {935,0.00099107}, {940,0.00097321}, {945,0.00105357}, {950,0.00093750}, {955,0.00101786}, {960,0.00086607}, {965,0.00124107}, {970,0.00066964}, {975,0.00119643}, {980,0.00108929}, {985,0.00091071}, {990,0.00088393}, {995,0.00104464}, {1000,0.00068750}, {1010,0.00118750}, {1020,0.00118750}, {1030,0.00085714}, {1040,0.00109821}, {1050,0.00100893}, {1060,0.00093750}, {1070,0.00109821}, {1080,0.00083036}, {1090,0.00083929}, {1100,0.00112500}, {1110,0.00114286}, {1120,0.00091071}, {1130,0.00091964}, {1140,0.00141071}, {1150,0.00123214}, {1160,0.00139286}, {1170,0.00122321}, {1180,0.00086607}, {1190,0.00120536}, {1200,0.00122321}, {1210,0.00134821}, {1220,0.00140179}, {1230,0.00130357}, {1240,0.00136607}, {1250,0.00109821}, {1260,0.00098214}, {1270,0.00128571}, {1280,0.00103571}, {1290,0.00106250}, {1300,0.00120536}, {1310,0.00124107}, {1320,0.00132143}, {1330,0.00114286}, {1340,0.00121429}, {1350,0.00133929}, {1360,0.00132143}, {1370,0.00133036}, {1380,0.00119643}, {1390,0.00162500}, {1400,0.00130357}, {1410,0.00133036}, {1420,0.00161607}, {1430,0.00128571}, {1440,0.00129464}, {1450,0.00110714}, {1460,0.00142857}, {1470,0.00166071}, {1480,0.00125000}, {1490,0.00140179}, {1500,0.00157143}, {1510,0.00153571}, {1520,0.00148214}, {1530,0.00122321}, {1540,0.00113393}, {1550,0.00150000}, {1560,0.00113393}, {1570,0.00165179}, {1580,0.00130357}, {1590,0.00141071}, {1600,0.00151786}, {1610,0.00152679}, {1620,0.00164286}, {1630,0.00148214}, {1640,0.00299107}, {1650,0.00168750}, {1660,0.00155357}, {1670,0.00133036}, {1680,0.00163393}, {1690,0.00167857}, {1700,0.00162500}, {1710,0.00172321}, {1720,0.00132143}, {1730,0.00156250}, {1740,0.00179464}, {1750,0.00161607}, {1760,0.00179464}, {1770,0.00149107}, {1780,0.00143750}, {1790,0.00166964}, {1800,0.00204464}, {1810,0.00158036}, {1820,0.00158929}, {1830,0.00197321}, {1840,0.00173214}, {1850,0.00181250}, {1860,0.00184821}, {1870,0.00164286}, {1880,0.00166071}, {1890,0.00167857}, {1900,0.00186607}, {1910,0.00172321}, {1920,0.00186607}, {1930,0.00196429}, {1940,0.00182143}, {1950,0.00174107}, {1960,0.00185714}, {1970,0.00165179}, {1980,0.00185714}, {1990,0.00166964}, {2000,0.00204464}, {2050,0.00209821}, {2100,0.00213393}, {2150,0.00463393}, {2200,0.00219643}, {2250,0.00220536}, {2300,0.00205357}, {2350,0.00195536}, {2400,0.00246429}, {2450,0.00244643}, {2500,0.00245536}, {2550,0.00261607}, {2600,0.00247321}, {2650,0.00242857}, {2700,0.00260714}, {2750,0.00263393}, {2800,0.00253571}, {2850,0.00258929}, {2900,0.00277679}, {2950,0.00271429}, {3000,0.00282143}, {3050,0.00339286}, {3100,0.00298214}, {3150,0.00554464}, {3200,0.00316964}, {3250,0.00320536}, {3300,0.00292857}, {3350,0.00315179}, {3400,0.00301786}, {3450,0.00338393}, {3500,0.00333036}, {3550,0.00339286}, {3600,0.00338393}, {3650,0.00343750}, {3700,0.00345536}, {3750,0.00342857}, {3800,0.00836607}, {3850,0.00357143}, {3900,0.00774107}, {3950,0.00358036}, {4000,0.00355357}, {4050,0.00400000}, {4100,0.00433036}, {4150,0.00446429}, {4200,0.00437500}, {4250,0.00454464}, {4300,0.00415179}, {4350,0.00448214}, {4400,0.00435714}, {4450,0.00483036}, {4500,0.00495536}, {4550,0.00453571}, {4600,0.00477679}, {4650,0.00458036}, {4700,0.00483929}, {4750,0.00483036}, {4800,0.00502679}, {4850,0.00518750}, {4900,0.00525000}, {4950,0.00516071}, {5000,0.00538393}, {5050,0.00525893}, {5100,0.00526786}, {5150,0.00495536}, {5200,0.00472321}, {5250,0.00563393}, {5300,0.00518750}, {5350,0.00575000}, {5400,0.00530357}, {5450,0.00544643}, {5500,0.00559821}, {5550,0.00528571}, {5600,0.00543750}, {5650,0.01236607}, {5700,0.00581250}, {5750,0.00586607}, {5800,0.00636607}, {5850,0.00565179}, {5900,0.00555357}, {5950,0.00540179}, {6000,0.00603571}, {6050,0.00615179}, {6100,0.00592857}, {6150,0.00639286}, {6200,0.00633036}, {6250,0.00634821}, {6300,0.00616964}, {6350,0.00649107}, {6400,0.00647321}, {6450,0.00666964}, {6500,0.00673214}, {6550,0.00679464}, {6600,0.00628571}, {6650,0.00675893}, {6700,0.00666071}, {6750,0.00662500}, {6800,0.00670536}, {6850,0.00667857}, {6900,0.00741071}, {6950,0.00717857}, {7000,0.00741071}, {7050,0.00670536}, {7100,0.00769643}, {7150,0.00718750}, {7200,0.00743750}, {7250,0.00716964}, {7300,0.00767857}, {7350,0.00717857}, {7400,0.01820536}, {7450,0.00792857}, {7500,0.00798214}, {7550,0.00739286}, {7600,0.00768750}, {7650,0.00760714}, {7700,0.00766964}, {7750,0.00764286}, {7800,0.00787500}, {7850,0.00835714}, {7900,0.00847321}, {7950,0.01513393}, {8000,0.00824107}, {8050,0.00865179}, {8100,0.00826786}, {8150,0.00867857}, {8200,0.00844643}, {8250,0.00847321}, {8300,0.00834821}, {8350,0.01781250}, {8400,0.00931250}, {8450,0.00959821}, {8500,0.00906250}, {8550,0.00925893}, {8600,0.00957143}, {8650,0.00908036}, {8700,0.00916071}, {8750,0.00928571}, {8800,0.00991964}, {8850,0.00960714}, {8900,0.01994643}, {8950,0.00934821}, {9000,0.01039286}, {9050,0.00975000}, {9100,0.00972321}, {9150,0.00945536}, {9200,0.01036607}, {9250,0.00968750}, {9300,0.02242857}, {9350,0.01058036}, {9400,0.01031250}, {9450,0.01055357}, {9500,0.01021429}, {9550,0.01007143}, {9600,0.01007143}, {9650,0.00980357}, {9700,0.01007143}, {9750,0.01040179}, {9800,0.01097321}, {9850,0.01096429}, {9900,0.01054464}, {9950,0.01085714}, {10000,0.02027679}, {10100,0.01050000}, {10200,0.02164286}, {10300,0.01136607}, {10400,0.01107143}, {10500,0.01151786}, {10600,0.01133929}, {10700,0.01176786}, {10800,0.01201786}, {10900,0.02398214}, {11000,0.01175000}, {11100,0.01238393}, {11200,0.01213393}, {11300,0.01178571}, {11400,0.02173214}, {11500,0.02278571}, {11600,0.02179464}, {11700,0.01217857}, {11800,0.01238393}, {11900,0.01350893}, {12000,0.01264286}, {12100,0.01350893}, {12200,0.01283929}, {12300,0.01287500}, {12400,0.01273214}, {12500,0.02681250}, {12600,0.01375}, {12700,0.01300}, {12800,0.01550}, {12900,0.01375}, {13000,0.01475}, {13100,0.01200}, {13200,0.05100}, {13300,0.01450}, {13400,0.01450}, {13500,0.01475}, {13600,0.01375}, {13700,0.04125}, {13800,0.01450}, {13900,0.01525}, {14000,0.01450}, {14100,0.03425}, {14200,0.01425}, {14300,0.01550}, {14400,0.01450}, {14500,0.01375}, {14600,0.01450}, {14700,0.03050}, {14800,0.01550}, {14900,0.01500}, {15000,0.01525}, {15100,0.03250}, {15200,0.02800}, {15300,0.01525}, {15400,0.01650}, {15500,0.03325}, {15600,0.03150}, {15700,0.01750}, {15800,0.03400}, {15900,0.01700}, {16000,0.01675}, {16100,0.03450}, {16200,0.01800}, {16300,0.01725}, {16400,0.01675}, {16500,0.03050}, {16600,0.01650}, {16700,0.03050}, {16800,0.03525}, {16900,0.02850}, {17000,0.01750}, {17100,0.02650}, {17200,0.03150}, {17300,0.03075}, {17400,0.03050}, {17500,0.01800}, {17600,0.02550}, {17700,0.03250}, {17800,0.02825}, {17900,0.01650}, {18000,0.02650}, {18100,0.01775}, {18200,0.02850}, {18300,0.03650}, {18400,0.02850}, {18500,0.01950}, {18600,0.02050}, {18700,0.02950}, {18800,0.02850}, {18900,0.01975}, {19000,0.01925}, {19100,0.02975}, {19200,0.03100}, {19300,0.01975}, {19400,0.02075}, {19500,0.02050}, {19600,0.01975}, {19700,0.02075}, {19800,0.02025}, {19900,0.04375}, {20000,0.0580}};
data["big_flat"]["identity simpl"]["Stats"]["system"] = {{1,0.00003540}, {2,0.00003540}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00003540}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00003540}, {40,0.00003540}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00003540}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00003540}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00003540}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00003540}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00003540}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00002655}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00002655}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00003540}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00003540}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00003540}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00003540}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00003540}, {255,0.00000000}, {256,0.00002655}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00003540}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00003540}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00003540}, {302,0.00003540}, {303,0.00000000}, {304,0.00003540}, {305,0.00000000}, {306,0.00000000}, {307,0.00003540}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00003540}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00003540}, {329,0.00003540}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00003540}, {365,0.00000000}, {366,0.00000000}, {367,0.00003540}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00003540}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00003540}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00003540}, {384,0.00000000}, {385,0.00000000}, {386,0.00006195}, {387,0.00003540}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00003540}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00003540}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00007080}, {413,0.00000000}, {414,0.00003540}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00003540}, {439,0.00000000}, {440,0.00000000}, {441,0.00003540}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00003540}, {448,0.00003540}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00003540}, {456,0.00002655}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00003540}, {462,0.00000000}, {463,0.00007080}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003540}, {469,0.00003540}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00003540}, {480,0.00003540}, {481,0.00000000}, {482,0.00003540}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00002655}, {487,0.00003540}, {488,0.00000000}, {489,0.00002655}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00003540}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00003540}, {499,0.00000000}, {500,0.00003540}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00003540}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00003540}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00003540}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00003540}, {770,0.00000000}, {775,0.00000000}, {780,0.00003540}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00002679}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00003571}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00003571}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00003571}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00003571}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00003571}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00003571}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00003571}, {1250,0.00003571}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00003571}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00003571}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00003571}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00003571}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00003571}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00007143}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00003571}, {1770,0.00000000}, {1780,0.00003571}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00003571}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00002679}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00003571}, {1930,0.00003571}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00003571}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00002679}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00003571}, {2400,0.00000000}, {2450,0.00002679}, {2500,0.00003571}, {2550,0.00000000}, {2600,0.00003571}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00003571}, {2800,0.00000000}, {2850,0.00003571}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00003571}, {3050,0.00003571}, {3100,0.00000000}, {3150,0.00003571}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00003571}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00003571}, {3650,0.00000000}, {3700,0.00003571}, {3750,0.00003571}, {3800,0.00009821}, {3850,0.00000000}, {3900,0.00003571}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00009821}, {4350,0.00003571}, {4400,0.00000000}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00003571}, {4700,0.00007143}, {4750,0.00000000}, {4800,0.00003571}, {4850,0.00000000}, {4900,0.00000000}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00003571}, {5100,0.00003571}, {5150,0.00010714}, {5200,0.00000000}, {5250,0.00007143}, {5300,0.00010714}, {5350,0.00003571}, {5400,0.00003571}, {5450,0.00007143}, {5500,0.00003571}, {5550,0.00003571}, {5600,0.00006250}, {5650,0.00010714}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00003571}, {5850,0.00003571}, {5900,0.00010714}, {5950,0.00003571}, {6000,0.00003571}, {6050,0.00000000}, {6100,0.00003571}, {6150,0.00000000}, {6200,0.00007143}, {6250,0.00003571}, {6300,0.00007143}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00003571}, {6550,0.00003571}, {6600,0.00003571}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00006250}, {6800,0.00000000}, {6850,0.00000000}, {6900,0.00007143}, {6950,0.00003571}, {7000,0.00007143}, {7050,0.00003571}, {7100,0.00003571}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00028571}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00003571}, {7600,0.00000000}, {7650,0.00000000}, {7700,0.00007143}, {7750,0.00000000}, {7800,0.00007143}, {7850,0.00000000}, {7900,0.00000000}, {7950,0.00009821}, {8000,0.00003571}, {8050,0.00007143}, {8100,0.00000000}, {8150,0.00002679}, {8200,0.00003571}, {8250,0.00000000}, {8300,0.00003571}, {8350,0.00034821}, {8400,0.00002679}, {8450,0.00000000}, {8500,0.00000000}, {8550,0.00003571}, {8600,0.00003571}, {8650,0.00000000}, {8700,0.00000000}, {8750,0.00000000}, {8800,0.00000000}, {8850,0.00007143}, {8900,0.00021429}, {8950,0.00000000}, {9000,0.00007143}, {9050,0.00003571}, {9100,0.00000000}, {9150,0.00007143}, {9200,0.00003571}, {9250,0.00000000}, {9300,0.00020536}, {9350,0.00003571}, {9400,0.00000000}, {9450,0.00003571}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00003571}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00014286}, {9900,0.00000000}, {9950,0.00003571}, {10000,0.00002679}, {10100,0.00000000}, {10200,0.00000000}, {10300,0.00003571}, {10400,0.00000000}, {10500,0.00003571}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00000000}, {11000,0.00002679}, {11100,0.00000000}, {11200,0.00003571}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00003571}, {11600,0.00000000}, {11700,0.00010714}, {11800,0.00000000}, {11900,0.00007143}, {12000,0.00003571}, {12100,0.00003571}, {12200,0.00002679}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00003571}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00100}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00100}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00100}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["identity vm_compute"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00034513}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00098230}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00001770}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00001770}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000885}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000885}, {250,0.00000000}, {251,0.00000000}, {252,0.00000885}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00002655}, {257,0.00214159}, {258,0.00000885}, {259,0.00002655}, {260,0.00006195}, {261,0.00015929}, {262,0.00024779}, {263,0.00033628}, {264,0.00041593}, {265,0.00061062}, {266,0.00076106}, {267,0.00080531}, {268,0.00060177}, {269,0.00081416}, {270,0.00078761}, {271,0.00085841}, {272,0.00098230}, {273,0.00100000}, {274,0.00100000}, {275,0.00100000}, {276,0.00094690}, {277,0.00100000}, {278,0.00100000}, {279,0.00100000}, {280,0.00100000}, {281,0.00100000}, {282,0.00100000}, {283,0.00100000}, {284,0.00094690}, {285,0.00098230}, {286,0.00100000}, {287,0.00099115}, {288,0.00100000}, {289,0.00100000}, {290,0.00100000}, {291,0.00100000}, {292,0.00100000}, {293,0.00100000}, {294,0.00100000}, {295,0.00100000}, {296,0.00100000}, {297,0.00100000}, {298,0.00100000}, {299,0.00100000}, {300,0.00100000}, {301,0.00100000}, {302,0.00100000}, {303,0.00100000}, {304,0.00100000}, {305,0.00100000}, {306,0.00100000}, {307,0.00100000}, {308,0.00100000}, {309,0.00100000}, {310,0.00100000}, {311,0.00100000}, {312,0.00101770}, {313,0.00100000}, {314,0.00100000}, {315,0.00100000}, {316,0.00100000}, {317,0.00100000}, {318,0.00101770}, {319,0.00100000}, {320,0.00100000}, {321,0.00100000}, {322,0.00100000}, {323,0.00226549}, {324,0.00100000}, {325,0.00100000}, {326,0.00100000}, {327,0.00100000}, {328,0.00100000}, {329,0.00100000}, {330,0.00100000}, {331,0.00100000}, {332,0.00100000}, {333,0.00100000}, {334,0.00100000}, {335,0.00100000}, {336,0.00100000}, {337,0.00100000}, {338,0.00100000}, {339,0.00100000}, {340,0.00100000}, {341,0.00100000}, {342,0.00100000}, {343,0.00100000}, {344,0.00100000}, {345,0.00100000}, {346,0.00100000}, {347,0.00100000}, {348,0.00100000}, {349,0.00100000}, {350,0.00100000}, {351,0.00100000}, {352,0.00100000}, {353,0.00100000}, {354,0.00100000}, {355,0.00100000}, {356,0.00100000}, {357,0.00100000}, {358,0.00100000}, {359,0.00198230}, {360,0.00100000}, {361,0.00100000}, {362,0.00100000}, {363,0.00100000}, {364,0.00100000}, {365,0.00100000}, {366,0.00100000}, {367,0.00100000}, {368,0.00100000}, {369,0.00100000}, {370,0.00100000}, {371,0.00100000}, {372,0.00100000}, {373,0.00100000}, {374,0.00100000}, {375,0.00100000}, {376,0.00100000}, {377,0.00198230}, {378,0.00100000}, {379,0.00100000}, {380,0.00100000}, {381,0.00100000}, {382,0.00197345}, {383,0.00100000}, {384,0.00100000}, {385,0.00100000}, {386,0.00100000}, {387,0.00100000}, {388,0.00100000}, {389,0.00100000}, {390,0.00100000}, {391,0.00100000}, {392,0.00100000}, {393,0.00100000}, {394,0.00100000}, {395,0.00100000}, {396,0.00100000}, {397,0.00100000}, {398,0.00100000}, {399,0.00100000}, {400,0.00100000}, {401,0.00100000}, {402,0.00101770}, {403,0.00100000}, {404,0.00100000}, {405,0.00100000}, {406,0.00100000}, {407,0.00100000}, {408,0.00100000}, {409,0.00101770}, {410,0.00100000}, {411,0.00100000}, {412,0.00100000}, {413,0.00100000}, {414,0.00100000}, {415,0.00100000}, {416,0.00100000}, {417,0.00100000}, {418,0.00100000}, {419,0.00100000}, {420,0.00100000}, {421,0.00100000}, {422,0.00100000}, {423,0.00100000}, {424,0.00100000}, {425,0.00100000}, {426,0.00100000}, {427,0.00100000}, {428,0.00100000}, {429,0.00100000}, {430,0.00100000}, {431,0.00100000}, {432,0.00100000}, {433,0.00100000}, {434,0.00100000}, {435,0.00100000}, {436,0.00100000}, {437,0.00100000}, {438,0.00100000}, {439,0.00100000}, {440,0.00100000}, {441,0.00100000}, {442,0.00100000}, {443,0.00100000}, {444,0.00100000}, {445,0.00100000}, {446,0.00100000}, {447,0.00100000}, {448,0.00100000}, {449,0.00100000}, {450,0.00100000}, {451,0.00100000}, {452,0.00100000}, {453,0.00100000}, {454,0.00101770}, {455,0.00101770}, {456,0.00100000}, {457,0.00100000}, {458,0.00100000}, {459,0.00100000}, {460,0.00100000}, {461,0.00100000}, {462,0.00100000}, {463,0.00100000}, {464,0.00100000}, {465,0.00100000}, {466,0.00100000}, {467,0.00100000}, {468,0.00100000}, {469,0.00100000}, {470,0.00100000}, {471,0.00100000}, {472,0.00100000}, {473,0.00100000}, {474,0.00100000}, {475,0.00100000}, {476,0.00100000}, {477,0.00100000}, {478,0.00100000}, {479,0.00100000}, {480,0.00100885}, {481,0.00100000}, {482,0.00100000}, {483,0.00100000}, {484,0.00100000}, {485,0.00100000}, {486,0.00100000}, {487,0.00100000}, {488,0.00101770}, {489,0.00100000}, {490,0.00100885}, {491,0.00100000}, {492,0.00100000}, {493,0.00100000}, {494,0.00100000}, {495,0.00100000}, {496,0.00100000}, {497,0.00100000}, {498,0.00100000}, {499,0.00100000}, {500,0.00100000}, {505,0.00100000}, {510,0.00100000}, {515,0.00100000}, {520,0.00103540}, {525,0.00126549}, {530,0.00130973}, {535,0.00176106}, {540,0.00115929}, {545,0.00183186}, {550,0.00200000}, {555,0.00200000}, {560,0.00200000}, {565,0.00938053}, {570,0.00197345}, {575,0.00125664}, {580,0.00200000}, {585,0.00200000}, {590,0.00200885}, {595,0.00200000}, {600,0.00200000}, {605,0.00200000}, {610,0.00200000}, {615,0.00200000}, {620,0.00200000}, {625,0.00200000}, {630,0.00200000}, {635,0.00200000}, {640,0.00200000}, {645,0.00200000}, {650,0.00200000}, {655,0.00200000}, {660,0.00200000}, {665,0.00200000}, {670,0.00200000}, {675,0.00200000}, {680,0.00201770}, {685,0.00200000}, {690,0.00200000}, {695,0.00200000}, {700,0.00200000}, {705,0.00200000}, {710,0.00200000}, {715,0.00200000}, {720,0.00200000}, {725,0.00200000}, {730,0.00200000}, {735,0.00200000}, {740,0.00200000}, {745,0.00200000}, {750,0.00200000}, {755,0.00200000}, {760,0.00200000}, {765,0.00200000}, {770,0.00200000}, {775,0.00200000}, {780,0.00200000}, {785,0.00200885}, {790,0.00200000}, {795,0.00200000}, {800,0.00201786}, {805,0.00200893}, {810,0.00206250}, {815,0.00200000}, {820,0.00200000}, {825,0.00200893}, {830,0.00200000}, {835,0.00286607}, {840,0.00279464}, {845,0.00224107}, {850,0.00293750}, {855,0.00237500}, {860,0.00201786}, {865,0.00299107}, {870,0.00243750}, {875,0.00296429}, {880,0.00275893}, {885,0.00215179}, {890,0.00281250}, {895,0.00257143}, {900,0.00300000}, {905,0.00300000}, {910,0.00300000}, {915,0.00300000}, {920,0.00300000}, {925,0.00300000}, {930,0.00300000}, {935,0.00300000}, {940,0.00300000}, {945,0.00300000}, {950,0.00300000}, {955,0.00300000}, {960,0.00300000}, {965,0.00300000}, {970,0.00300000}, {975,0.00300000}, {980,0.00300000}, {985,0.00300000}, {990,0.00300000}, {995,0.00300000}, {1000,0.00300000}, {1010,0.00300000}, {1020,0.00300000}, {1030,0.00300000}, {1040,0.00300000}, {1050,0.00667857}, {1060,0.00301786}, {1070,0.00300000}, {1080,0.00300000}, {1090,0.00327679}, {1100,0.00305357}, {1110,0.00310714}, {1120,0.00382143}, {1130,0.00357143}, {1140,0.00312500}, {1150,0.00303571}, {1160,0.00400000}, {1170,0.00400000}, {1180,0.00385714}, {1190,0.00400000}, {1200,0.00400000}, {1210,0.00399107}, {1220,0.00400000}, {1230,0.00400000}, {1240,0.00400000}, {1250,0.00400000}, {1260,0.00400000}, {1270,0.00400000}, {1280,0.00400000}, {1290,0.00400000}, {1300,0.00400000}, {1310,0.00400000}, {1320,0.00400000}, {1330,0.00400000}, {1340,0.00400000}, {1350,0.00410714}, {1360,0.00415179}, {1370,0.00400893}, {1380,0.00402679}, {1390,0.00400000}, {1400,0.00400000}, {1410,0.00485714}, {1420,0.00463393}, {1430,0.00471429}, {1440,0.00500000}, {1450,0.00502679}, {1460,0.00468750}, {1470,0.00422321}, {1480,0.00500000}, {1490,0.00500000}, {1500,0.00772321}, {1510,0.00499107}, {1520,0.00500000}, {1530,0.00499107}, {1540,0.00500000}, {1550,0.00500000}, {1560,0.00500000}, {1570,0.00500000}, {1580,0.00500000}, {1590,0.00500000}, {1600,0.00502679}, {1610,0.00516071}, {1620,0.00502679}, {1630,0.00500000}, {1640,0.00537500}, {1650,0.00545536}, {1660,0.00500000}, {1670,0.00578571}, {1680,0.00580357}, {1690,0.00579464}, {1700,0.00591964}, {1710,0.00536607}, {1720,0.00533036}, {1730,0.00600000}, {1740,0.00576786}, {1750,0.00586607}, {1760,0.00602679}, {1770,0.00600000}, {1780,0.00726786}, {1790,0.00574107}, {1800,0.00600000}, {1810,0.00601786}, {1820,0.00600000}, {1830,0.00600000}, {1840,0.00608929}, {1850,0.00606250}, {1860,0.00628571}, {1870,0.00600000}, {1880,0.00600000}, {1890,0.00650893}, {1900,0.00600000}, {1910,0.00600000}, {1920,0.00673214}, {1930,0.00678571}, {1940,0.00647321}, {1950,0.00600000}, {1960,0.00675000}, {1970,0.00681250}, {1980,0.00600000}, {1990,0.00698214}, {2000,0.00698214}, {2050,0.00697321}, {2100,0.00703571}, {2150,0.00721429}, {2200,0.00773214}, {2250,0.00787500}, {2300,0.00704464}, {2350,0.00806250}, {2400,0.00823214}, {2450,0.00869643}, {2500,0.00844643}, {2550,0.00801786}, {2600,0.00900000}, {2650,0.00900000}, {2700,0.00901786}, {2750,0.00899107}, {2800,0.00900000}, {2850,0.01010714}, {2900,0.00976786}, {2950,0.01011607}, {3000,0.00985714}, {3050,0.01000000}, {3100,0.01076786}, {3150,0.01095536}, {3200,0.01100000}, {3250,0.01141071}, {3300,0.01371429}, {3350,0.01180357}, {3400,0.01675893}, {3450,0.01162500}, {3500,0.01178571}, {3550,0.01176786}, {3600,0.01275893}, {3650,0.01284821}, {3700,0.01235714}, {3750,0.01763393}, {3800,0.01285714}, {3850,0.01378571}, {3900,0.01285714}, {3950,0.01992857}, {4000,0.01369643}, {4050,0.01380357}, {4100,0.01420536}, {4150,0.01478571}, {4200,0.01481250}, {4250,0.01530357}, {4300,0.01655357}, {4350,0.01474107}, {4400,0.01536607}, {4450,0.01618750}, {4500,0.01569643}, {4550,0.01525000}, {4600,0.01554464}, {4650,0.01711607}, {4700,0.01614286}, {4750,0.01625000}, {4800,0.01714286}, {4850,0.01679464}, {4900,0.01725893}, {4950,0.01723214}, {5000,0.01778571}, {5050,0.02126786}, {5100,0.01705357}, {5150,0.01803571}, {5200,0.02265179}, {5250,0.01888393}, {5300,0.02709821}, {5350,0.01880357}, {5400,0.01915179}, {5450,0.01914286}, {5500,0.01884821}, {5550,0.01910714}, {5600,0.02550000}, {5650,0.02084821}, {5700,0.02072321}, {5750,0.02005357}, {5800,0.02076786}, {5850,0.02075000}, {5900,0.03089286}, {5950,0.01993750}, {6000,0.02075893}, {6050,0.02194643}, {6100,0.03183929}, {6150,0.02242857}, {6200,0.02266071}, {6250,0.02248214}, {6300,0.02269643}, {6350,0.02283036}, {6400,0.02882143}, {6450,0.02308036}, {6500,0.02365179}, {6550,0.02385714}, {6600,0.02382143}, {6650,0.03103571}, {6700,0.03767857}, {6750,0.03186607}, {6800,0.02793750}, {6850,0.02452679}, {6900,0.02436607}, {6950,0.02560714}, {7000,0.02458036}, {7050,0.02580357}, {7100,0.02448214}, {7150,0.03883929}, {7200,0.02631250}, {7250,0.03845536}, {7300,0.02717857}, {7350,0.02635714}, {7400,0.02623214}, {7450,0.02776786}, {7500,0.02694643}, {7550,0.02595536}, {7600,0.02709821}, {7650,0.03145536}, {7700,0.03255357}, {7750,0.02875000}, {7800,0.02760714}, {7850,0.02919643}, {7900,0.02763393}, {7950,0.02958036}, {8000,0.02975893}, {8050,0.02854464}, {8100,0.04010714}, {8150,0.02880357}, {8200,0.04266071}, {8250,0.03054464}, {8300,0.03075000}, {8350,0.03117857}, {8400,0.03134821}, {8450,0.03118750}, {8500,0.03207143}, {8550,0.03175893}, {8600,0.03669643}, {8650,0.03652679}, {8700,0.03038393}, {8750,0.03348214}, {8800,0.03322321}, {8850,0.03290179}, {8900,0.03441071}, {8950,0.03159821}, {9000,0.03515179}, {9050,0.05085714}, {9100,0.03305357}, {9150,0.05042857}, {9200,0.03350893}, {9250,0.03694643}, {9300,0.03633036}, {9350,0.03523214}, {9400,0.03424107}, {9450,0.03573214}, {9500,0.04410714}, {9550,0.05033929}, {9600,0.04993750}, {9650,0.04854464}, {9700,0.04081250}, {9750,0.03651786}, {9800,0.03803571}, {9850,0.03500893}, {9900,0.04725000}, {9950,0.03521429}, {10000,0.03922321}, {10100,0.03577679}, {10200,0.03650000}, {10300,0.03777679}, {10400,0.03894643}, {10500,0.03920536}, {10600,0.04382143}, {10700,0.03850893}, {10800,0.04233929}, {10900,0.04075893}, {11000,0.03866964}, {11100,0.04054464}, {11200,0.04152679}, {11300,0.05528571}, {11400,0.04544643}, {11500,0.04240179}, {11600,0.04433036}, {11700,0.06076786}, {11800,0.04463393}, {11900,0.04238393}, {12000,0.06137500}, {12100,0.04555357}, {12200,0.04496429}, {12300,0.06147321}, {12400,0.07034821}, {12500,0.04797321}, {12600,0.04850}, {12700,0.04475}, {12800,0.04475}, {12900,0.06450}, {13000,0.04675}, {13100,0.06100}, {13200,0.04825}, {13300,0.04725}, {13400,0.04950}, {13500,0.04825}, {13600,0.04825}, {13700,0.05175}, {13800,0.06250}, {13900,0.04975}, {14000,0.06425}, {14100,0.05175}, {14200,0.05000}, {14300,0.05025}, {14400,0.05550}, {14500,0.05750}, {14600,0.05300}, {14700,0.05425}, {14800,0.07550}, {14900,0.05525}, {15000,0.07100}, {15100,0.06475}, {15200,0.05700}, {15300,0.05500}, {15400,0.05750}, {15500,0.05975}, {15600,0.06875}, {15700,0.07050}, {15800,0.05725}, {15900,0.08450}, {16000,0.09325}, {16100,0.05925}, {16200,0.07375}, {16300,0.06900}, {16400,0.06825}, {16500,0.09250}, {16600,0.08000}, {16700,0.06400}, {16800,0.06150}, {16900,0.06175}, {17000,0.09325}, {17100,0.06375}, {17200,0.07325}, {17300,0.07175}, {17400,0.06275}, {17500,0.09275}, {17600,0.06250}, {17700,0.07350}, {17800,0.07100}, {17900,0.08550}, {18000,0.10925}, {18100,0.10075}, {18200,0.06950}, {18300,0.06525}, {18400,0.09275}, {18500,0.10050}, {18600,0.08050}, {18700,0.10275}, {18800,0.07250}, {18900,0.09800}, {19000,0.15125}, {19100,0.09150}, {19200,0.09950}, {19300,0.12000}, {19400,0.10200}, {19500,0.07575}, {19600,0.12900}, {19700,0.07150}, {19800,0.12325}, {19900,0.07175}, {20000,0.0815}};
data["big_flat"]["identity vm_compute"]["Stats"]["user"] = {{1,0.00005310}, {2,0.00000000}, {3,0.00002655}, {4,0.00002655}, {5,0.00000000}, {6,0.00006195}, {7,0.00002655}, {8,0.00000000}, {9,0.00010619}, {10,0.00003540}, {11,0.00002655}, {12,0.00005310}, {13,0.00008850}, {14,0.00014159}, {15,0.00015044}, {16,0.00011504}, {17,0.00002655}, {18,0.00005310}, {19,0.00005310}, {20,0.00015044}, {21,0.00011504}, {22,0.00005310}, {23,0.00002655}, {24,0.00023009}, {25,0.00020354}, {26,0.00016814}, {27,0.00027434}, {28,0.00021239}, {29,0.00023894}, {30,0.00024779}, {31,0.00014159}, {32,0.00023894}, {33,0.00017699}, {34,0.00022124}, {35,0.00015929}, {36,0.00012389}, {37,0.00015929}, {38,0.00016814}, {39,0.00012389}, {40,0.00033628}, {41,0.00014159}, {42,0.00014159}, {43,0.00022124}, {44,0.00010619}, {45,0.00017699}, {46,0.00030973}, {47,0.00021239}, {48,0.00031858}, {49,0.00028319}, {50,0.00026549}, {51,0.00015929}, {52,0.00014159}, {53,0.00028319}, {54,0.00018584}, {55,0.00026549}, {56,0.00028319}, {57,0.00017699}, {58,0.00012389}, {59,0.00041593}, {60,0.00017699}, {61,0.00024779}, {62,0.00023894}, {63,0.00016814}, {64,0.00034513}, {65,0.00039823}, {66,0.00015929}, {67,0.00023009}, {68,0.00031858}, {69,0.00014159}, {70,0.00011504}, {71,0.00036283}, {72,0.00034513}, {73,0.00030088}, {74,0.00007965}, {75,0.00032743}, {76,0.00026549}, {77,0.00027434}, {78,0.00022124}, {79,0.00029204}, {80,0.00022124}, {81,0.00029204}, {82,0.00040708}, {83,0.00005310}, {84,0.00044248}, {85,0.00013274}, {86,0.00026549}, {87,0.00028319}, {88,0.00039823}, {89,0.00055752}, {90,0.00029204}, {91,0.00035398}, {92,0.00034513}, {93,0.00032743}, {94,0.00023894}, {95,0.00035398}, {96,0.00034513}, {97,0.00030088}, {98,0.00025664}, {99,0.00040708}, {100,0.00041593}, {101,0.00044248}, {102,0.00049558}, {103,0.00035398}, {104,0.00028319}, {105,0.00041593}, {106,0.00047788}, {107,0.00023009}, {108,0.00023009}, {109,0.00038053}, {110,0.00034513}, {111,0.00034513}, {112,0.00058407}, {113,0.00041593}, {114,0.00042478}, {115,0.00038938}, {116,0.00056637}, {117,0.00032743}, {118,0.00041593}, {119,0.00050442}, {120,0.00042478}, {121,0.00033628}, {122,0.00039823}, {123,0.00046018}, {124,0.00051327}, {125,0.00034513}, {126,0.00041593}, {127,0.00047788}, {128,0.00048673}, {129,0.00074336}, {130,0.00036283}, {131,0.00044248}, {132,0.00025664}, {133,0.00050442}, {134,0.00014159}, {135,0.00044248}, {136,0.00041593}, {137,0.00058407}, {138,0.00064602}, {139,0.00043363}, {140,0.00060177}, {141,0.00024779}, {142,0.00030973}, {143,0.00033628}, {144,0.00049558}, {145,0.00040708}, {146,0.00045133}, {147,0.00101770}, {148,0.00041593}, {149,0.00030973}, {150,0.00038053}, {151,0.00050442}, {152,0.00042478}, {153,0.00043363}, {154,0.00037168}, {155,0.00061947}, {156,0.00061062}, {157,0.00037168}, {158,0.00043363}, {159,0.00046018}, {160,0.00046903}, {161,0.00046903}, {162,0.00056637}, {163,0.00046018}, {164,0.00053982}, {165,0.00043363}, {166,0.00052212}, {167,0.00036283}, {168,0.00046903}, {169,0.00063717}, {170,0.00056637}, {171,0.00068142}, {172,0.00047788}, {173,0.00031858}, {174,0.00056637}, {175,0.00052212}, {176,0.00036283}, {177,0.00055752}, {178,0.00076991}, {179,0.00088496}, {180,0.00044248}, {181,0.00055752}, {182,0.00038938}, {183,0.00034513}, {184,0.00044248}, {185,0.00065487}, {186,0.00046903}, {187,0.00053097}, {188,0.00054867}, {189,0.00033628}, {190,0.00055752}, {191,0.00055752}, {192,0.00061947}, {193,0.00042478}, {194,0.00045133}, {195,0.00052212}, {196,0.00053097}, {197,0.00061947}, {198,0.00069912}, {199,0.00038938}, {200,0.00081416}, {201,0.00078761}, {202,0.00069027}, {203,0.00046018}, {204,0.00064602}, {205,0.00086726}, {206,0.00061062}, {207,0.00061947}, {208,0.00075221}, {209,0.00071681}, {210,0.00078761}, {211,0.00073451}, {212,0.00057522}, {213,0.00052212}, {214,0.00056637}, {215,0.00082301}, {216,0.00063717}, {217,0.00077876}, {218,0.00075221}, {219,0.00067257}, {220,0.00057522}, {221,0.00042478}, {222,0.00059292}, {223,0.00066372}, {224,0.00057522}, {225,0.00080531}, {226,0.00075221}, {227,0.00061947}, {228,0.00092920}, {229,0.00052212}, {230,0.00067257}, {231,0.00050442}, {232,0.00076991}, {233,0.00045133}, {234,0.00078761}, {235,0.00072566}, {236,0.00064602}, {237,0.00047788}, {238,0.00094690}, {239,0.00075221}, {240,0.00081416}, {241,0.00051327}, {242,0.00087611}, {243,0.00076106}, {244,0.00092920}, {245,0.00091150}, {246,0.00073451}, {247,0.00083186}, {248,0.00068142}, {249,0.00061947}, {250,0.00069027}, {251,0.00068142}, {252,0.00074336}, {253,0.00074336}, {254,0.00055752}, {255,0.00079646}, {256,0.00068142}, {257,0.00232743}, {258,0.00077876}, {259,0.00091150}, {260,0.00082301}, {261,0.00072566}, {262,0.00090265}, {263,0.00084956}, {264,0.00083186}, {265,0.00087611}, {266,0.00088496}, {267,0.00071681}, {268,0.00093805}, {269,0.00073451}, {270,0.00072566}, {271,0.00094690}, {272,0.00096460}, {273,0.00077876}, {274,0.00092920}, {275,0.00107080}, {276,0.00096460}, {277,0.00063717}, {278,0.00099115}, {279,0.00071681}, {280,0.00075221}, {281,0.00068142}, {282,0.00098230}, {283,0.00094690}, {284,0.00076106}, {285,0.00086726}, {286,0.00085841}, {287,0.00072566}, {288,0.00077876}, {289,0.00077876}, {290,0.00076991}, {291,0.00085841}, {292,0.00092035}, {293,0.00077876}, {294,0.00076106}, {295,0.00091150}, {296,0.00075221}, {297,0.00084071}, {298,0.00107965}, {299,0.00083186}, {300,0.00100885}, {301,0.00101770}, {302,0.00089381}, {303,0.00109735}, {304,0.00087611}, {305,0.00069912}, {306,0.00102655}, {307,0.00079646}, {308,0.00118584}, {309,0.00101770}, {310,0.00103540}, {311,0.00071681}, {312,0.00070796}, {313,0.00087611}, {314,0.00099115}, {315,0.00096460}, {316,0.00089381}, {317,0.00052212}, {318,0.00066372}, {319,0.00080531}, {320,0.00097345}, {321,0.00118584}, {322,0.00093805}, {323,0.00237168}, {324,0.00088496}, {325,0.00092920}, {326,0.00102655}, {327,0.00130973}, {328,0.00113274}, {329,0.00072566}, {330,0.00089381}, {331,0.00124779}, {332,0.00089381}, {333,0.00111504}, {334,0.00121239}, {335,0.00110619}, {336,0.00115044}, {337,0.00113274}, {338,0.00138938}, {339,0.00111504}, {340,0.00103540}, {341,0.00101770}, {342,0.00106195}, {343,0.00122124}, {344,0.00119469}, {345,0.00125664}, {346,0.00101770}, {347,0.00107080}, {348,0.00102655}, {349,0.00123009}, {350,0.00125664}, {351,0.00155752}, {352,0.00167257}, {353,0.00176106}, {354,0.00128319}, {355,0.00147788}, {356,0.00128319}, {357,0.00111504}, {358,0.00107080}, {359,0.00208850}, {360,0.00138053}, {361,0.00122124}, {362,0.00122124}, {363,0.00138938}, {364,0.00107965}, {365,0.00110619}, {366,0.00123894}, {367,0.00121239}, {368,0.00135398}, {369,0.00117699}, {370,0.00136283}, {371,0.00122124}, {372,0.00160177}, {373,0.00083186}, {374,0.00127434}, {375,0.00089381}, {376,0.00131858}, {377,0.00184956}, {378,0.00111504}, {379,0.00115929}, {380,0.00078761}, {381,0.00131858}, {382,0.00222124}, {383,0.00108850}, {384,0.00123009}, {385,0.00117699}, {386,0.00123894}, {387,0.00138938}, {388,0.00144248}, {389,0.00125664}, {390,0.00125664}, {391,0.00130088}, {392,0.00156637}, {393,0.00148673}, {394,0.00130088}, {395,0.00146018}, {396,0.00146018}, {397,0.00118584}, {398,0.00119469}, {399,0.00138053}, {400,0.00183186}, {401,0.00177876}, {402,0.00131858}, {403,0.00154867}, {404,0.00113274}, {405,0.00117699}, {406,0.00139823}, {407,0.00111504}, {408,0.00122124}, {409,0.00129204}, {410,0.00121239}, {411,0.00143363}, {412,0.00130973}, {413,0.00117699}, {414,0.00151327}, {415,0.00131858}, {416,0.00146903}, {417,0.00101770}, {418,0.00126549}, {419,0.00157522}, {420,0.00153097}, {421,0.00154867}, {422,0.00130973}, {423,0.00122124}, {424,0.00147788}, {425,0.00142478}, {426,0.00141593}, {427,0.00138938}, {428,0.00126549}, {429,0.00131858}, {430,0.00107965}, {431,0.00115044}, {432,0.00148673}, {433,0.00145133}, {434,0.00184956}, {435,0.00164602}, {436,0.00158407}, {437,0.00150442}, {438,0.00138053}, {439,0.00169027}, {440,0.00124779}, {441,0.00138938}, {442,0.00148673}, {443,0.00142478}, {444,0.00160177}, {445,0.00118584}, {446,0.00180531}, {447,0.00141593}, {448,0.00144248}, {449,0.00122124}, {450,0.00182301}, {451,0.00181416}, {452,0.00115044}, {453,0.00147788}, {454,0.00153982}, {455,0.00164602}, {456,0.00153097}, {457,0.00157522}, {458,0.00197345}, {459,0.00162832}, {460,0.00171681}, {461,0.00179646}, {462,0.00148673}, {463,0.00138938}, {464,0.00156637}, {465,0.00172566}, {466,0.00169912}, {467,0.00176991}, {468,0.00198230}, {469,0.00165487}, {470,0.00131858}, {471,0.00167257}, {472,0.00176106}, {473,0.00160177}, {474,0.00168142}, {475,0.00146903}, {476,0.00170796}, {477,0.00127434}, {478,0.00138938}, {479,0.00150442}, {480,0.00169027}, {481,0.00184956}, {482,0.00152212}, {483,0.00176106}, {484,0.00175221}, {485,0.00099115}, {486,0.00168142}, {487,0.00179646}, {488,0.00181416}, {489,0.00141593}, {490,0.00192035}, {491,0.00196460}, {492,0.00158407}, {493,0.00127434}, {494,0.00137168}, {495,0.00132743}, {496,0.00143363}, {497,0.00138053}, {498,0.00182301}, {499,0.00164602}, {500,0.00186726}, {505,0.00179646}, {510,0.00150442}, {515,0.00132743}, {520,0.00179646}, {525,0.00169027}, {530,0.00170796}, {535,0.00154867}, {540,0.00178761}, {545,0.00169912}, {550,0.00189381}, {555,0.00202655}, {560,0.00177876}, {565,0.00945133}, {570,0.00166372}, {575,0.00153982}, {580,0.00216814}, {585,0.00212389}, {590,0.00196460}, {595,0.00186726}, {600,0.00186726}, {605,0.00197345}, {610,0.00217699}, {615,0.00240708}, {620,0.00184071}, {625,0.00223009}, {630,0.00166372}, {635,0.00161947}, {640,0.00239823}, {645,0.00207080}, {650,0.00238938}, {655,0.00223009}, {660,0.00189381}, {665,0.00226549}, {670,0.00199115}, {675,0.00220354}, {680,0.00224779}, {685,0.00184071}, {690,0.00210619}, {695,0.00204425}, {700,0.00221239}, {705,0.00227434}, {710,0.00218584}, {715,0.00233628}, {720,0.00243363}, {725,0.00239823}, {730,0.00238938}, {735,0.00232743}, {740,0.00226549}, {745,0.00206195}, {750,0.00241593}, {755,0.00196460}, {760,0.00225664}, {765,0.00250442}, {770,0.00256637}, {775,0.00253097}, {780,0.00271681}, {785,0.00252212}, {790,0.00256637}, {795,0.00261607}, {800,0.00266071}, {805,0.00232143}, {810,0.00270536}, {815,0.00240179}, {820,0.00237500}, {825,0.00241071}, {830,0.00258929}, {835,0.00287500}, {840,0.00278571}, {845,0.00285714}, {850,0.00273214}, {855,0.00281250}, {860,0.00256250}, {865,0.00265179}, {870,0.00287500}, {875,0.00267857}, {880,0.00279464}, {885,0.00259821}, {890,0.00277679}, {895,0.00260714}, {900,0.00306250}, {905,0.00285714}, {910,0.00270536}, {915,0.00301786}, {920,0.00298214}, {925,0.00293750}, {930,0.00301786}, {935,0.00291964}, {940,0.00297321}, {945,0.00286607}, {950,0.00291964}, {955,0.00280357}, {960,0.00320536}, {965,0.00328571}, {970,0.00316071}, {975,0.00283036}, {980,0.00285714}, {985,0.00284821}, {990,0.00287500}, {995,0.00283036}, {1000,0.00302679}, {1010,0.00296429}, {1020,0.00258036}, {1030,0.00325000}, {1040,0.00322321}, {1050,0.00673214}, {1060,0.00323214}, {1070,0.00307143}, {1080,0.00302679}, {1090,0.00329464}, {1100,0.00312500}, {1110,0.00315179}, {1120,0.00339286}, {1130,0.00334821}, {1140,0.00322321}, {1150,0.00312500}, {1160,0.00336607}, {1170,0.00373214}, {1180,0.00339286}, {1190,0.00365179}, {1200,0.00353571}, {1210,0.00337500}, {1220,0.00355357}, {1230,0.00357143}, {1240,0.00348214}, {1250,0.00384821}, {1260,0.00366071}, {1270,0.00359821}, {1280,0.00407143}, {1290,0.00414286}, {1300,0.00391071}, {1310,0.00394643}, {1320,0.00419643}, {1330,0.00438393}, {1340,0.00402679}, {1350,0.00434821}, {1360,0.00415179}, {1370,0.00404464}, {1380,0.00410714}, {1390,0.00403571}, {1400,0.00423214}, {1410,0.00434821}, {1420,0.00411607}, {1430,0.00475000}, {1440,0.00468750}, {1450,0.00491071}, {1460,0.00416964}, {1470,0.00419643}, {1480,0.00459821}, {1490,0.00485714}, {1500,0.00757143}, {1510,0.00455357}, {1520,0.00481250}, {1530,0.00491071}, {1540,0.00545536}, {1550,0.00504464}, {1560,0.00539286}, {1570,0.00518750}, {1580,0.00522321}, {1590,0.00539286}, {1600,0.00516964}, {1610,0.00531250}, {1620,0.00510714}, {1630,0.00499107}, {1640,0.00556250}, {1650,0.00529464}, {1660,0.00504464}, {1670,0.00598214}, {1680,0.00557143}, {1690,0.00557143}, {1700,0.00578571}, {1710,0.00519643}, {1720,0.00551786}, {1730,0.00618750}, {1740,0.00526786}, {1750,0.00563393}, {1760,0.00573214}, {1770,0.00618750}, {1780,0.00741071}, {1790,0.00555357}, {1800,0.00581250}, {1810,0.00641964}, {1820,0.00612500}, {1830,0.00600000}, {1840,0.00637500}, {1850,0.00632143}, {1860,0.00640179}, {1870,0.00621429}, {1880,0.00617857}, {1890,0.00668750}, {1900,0.00599107}, {1910,0.00604464}, {1920,0.00669643}, {1930,0.00676786}, {1940,0.00665179}, {1950,0.00641071}, {1960,0.00680357}, {1970,0.00688393}, {1980,0.00625893}, {1990,0.00671429}, {2000,0.00655357}, {2050,0.00694643}, {2100,0.00734821}, {2150,0.00750000}, {2200,0.00759821}, {2250,0.00789286}, {2300,0.00744643}, {2350,0.00810714}, {2400,0.00839286}, {2450,0.00844643}, {2500,0.00846429}, {2550,0.00818750}, {2600,0.00939286}, {2650,0.00936607}, {2700,0.00918750}, {2750,0.00956250}, {2800,0.00941071}, {2850,0.01017857}, {2900,0.00975000}, {2950,0.01054464}, {3000,0.01008929}, {3050,0.01024107}, {3100,0.01092857}, {3150,0.01166071}, {3200,0.01125000}, {3250,0.01194643}, {3300,0.01369643}, {3350,0.01221429}, {3400,0.01714286}, {3450,0.01177679}, {3500,0.01189286}, {3550,0.01193750}, {3600,0.01281250}, {3650,0.01321429}, {3700,0.01261607}, {3750,0.01717857}, {3800,0.01291071}, {3850,0.01387500}, {3900,0.01305357}, {3950,0.01980357}, {4000,0.01391964}, {4050,0.01376786}, {4100,0.01435714}, {4150,0.01486607}, {4200,0.01511607}, {4250,0.01538393}, {4300,0.01654464}, {4350,0.01483036}, {4400,0.01569643}, {4450,0.01610714}, {4500,0.01583036}, {4550,0.01535714}, {4600,0.01565179}, {4650,0.01728571}, {4700,0.01614286}, {4750,0.01640179}, {4800,0.01709821}, {4850,0.01675893}, {4900,0.01744643}, {4950,0.01742857}, {5000,0.01765179}, {5050,0.02094643}, {5100,0.01723214}, {5150,0.01808036}, {5200,0.02303571}, {5250,0.01858929}, {5300,0.02693750}, {5350,0.01842857}, {5400,0.01897321}, {5450,0.01908929}, {5500,0.01863393}, {5550,0.01919643}, {5600,0.02571429}, {5650,0.02052679}, {5700,0.02074107}, {5750,0.01997321}, {5800,0.02035714}, {5850,0.02109821}, {5900,0.03060714}, {5950,0.01996429}, {6000,0.02051786}, {6050,0.02193750}, {6100,0.03166964}, {6150,0.02283036}, {6200,0.02273214}, {6250,0.02299107}, {6300,0.02305357}, {6350,0.02284821}, {6400,0.02855357}, {6450,0.02335714}, {6500,0.02388393}, {6550,0.02412500}, {6600,0.02417857}, {6650,0.03087500}, {6700,0.03754464}, {6750,0.03169643}, {6800,0.02793750}, {6850,0.02493750}, {6900,0.02467857}, {6950,0.02600000}, {7000,0.02475893}, {7050,0.02602679}, {7100,0.02464286}, {7150,0.03872321}, {7200,0.02661607}, {7250,0.03833929}, {7300,0.02727679}, {7350,0.02648214}, {7400,0.02647321}, {7450,0.02773214}, {7500,0.02724107}, {7550,0.02615179}, {7600,0.02710714}, {7650,0.03137500}, {7700,0.03236607}, {7750,0.02867857}, {7800,0.02765179}, {7850,0.02920536}, {7900,0.02772321}, {7950,0.02954464}, {8000,0.02940179}, {8050,0.02815179}, {8100,0.03964286}, {8150,0.02875893}, {8200,0.04216071}, {8250,0.03042857}, {8300,0.03068750}, {8350,0.03100893}, {8400,0.03137500}, {8450,0.03112500}, {8500,0.03225000}, {8550,0.03160714}, {8600,0.03663393}, {8650,0.03683929}, {8700,0.03041071}, {8750,0.03368750}, {8800,0.03354464}, {8850,0.03320536}, {8900,0.03443750}, {8950,0.03175000}, {9000,0.03516071}, {9050,0.05049107}, {9100,0.03361607}, {9150,0.04990179}, {9200,0.03352679}, {9250,0.03716964}, {9300,0.03670536}, {9350,0.03558929}, {9400,0.03437500}, {9450,0.03570536}, {9500,0.04414286}, {9550,0.05022321}, {9600,0.04995536}, {9650,0.04888393}, {9700,0.04076786}, {9750,0.03687500}, {9800,0.03825000}, {9850,0.03554464}, {9900,0.04747321}, {9950,0.03583036}, {10000,0.03920536}, {10100,0.03611607}, {10200,0.03683036}, {10300,0.03813393}, {10400,0.03884821}, {10500,0.03906250}, {10600,0.04395536}, {10700,0.03833929}, {10800,0.04213393}, {10900,0.04088393}, {11000,0.03849107}, {11100,0.04034821}, {11200,0.04138393}, {11300,0.05531250}, {11400,0.04563393}, {11500,0.04225000}, {11600,0.04430357}, {11700,0.06064286}, {11800,0.04500893}, {11900,0.04235714}, {12000,0.06125000}, {12100,0.04585714}, {12200,0.04505357}, {12300,0.06162500}, {12400,0.07064286}, {12500,0.04834821}, {12600,0.04750}, {12700,0.04475}, {12800,0.04575}, {12900,0.06450}, {13000,0.04750}, {13100,0.06075}, {13200,0.04800}, {13300,0.04650}, {13400,0.05050}, {13500,0.04750}, {13600,0.04925}, {13700,0.05025}, {13800,0.06275}, {13900,0.04975}, {14000,0.06475}, {14100,0.05250}, {14200,0.05050}, {14300,0.04950}, {14400,0.05575}, {14500,0.05675}, {14600,0.05250}, {14700,0.05425}, {14800,0.07225}, {14900,0.05575}, {15000,0.06800}, {15100,0.06425}, {15200,0.05800}, {15300,0.05525}, {15400,0.05500}, {15500,0.05850}, {15600,0.06725}, {15700,0.07075}, {15800,0.05625}, {15900,0.08450}, {16000,0.09250}, {16100,0.05875}, {16200,0.07150}, {16300,0.06700}, {16400,0.06850}, {16500,0.09150}, {16600,0.08000}, {16700,0.06250}, {16800,0.06000}, {16900,0.06150}, {17000,0.09375}, {17100,0.06350}, {17200,0.07375}, {17300,0.07250}, {17400,0.06175}, {17500,0.09200}, {17600,0.06350}, {17700,0.07200}, {17800,0.07025}, {17900,0.08625}, {18000,0.11000}, {18100,0.09900}, {18200,0.06750}, {18300,0.06450}, {18400,0.09125}, {18500,0.10000}, {18600,0.08075}, {18700,0.10175}, {18800,0.07200}, {18900,0.09850}, {19000,0.15050}, {19100,0.08925}, {19200,0.09950}, {19300,0.12050}, {19400,0.09875}, {19500,0.07475}, {19600,0.12800}, {19700,0.07100}, {19800,0.12375}, {19900,0.07175}, {20000,0.0815}};
data["big_flat"]["identity vm_compute"]["Stats"]["system"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00003540}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00003540}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00003540}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00003540}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00003540}, {41,0.00000000}, {42,0.00000000}, {43,0.00002655}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00003540}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00003540}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00003540}, {72,0.00000000}, {73,0.00000000}, {74,0.00003540}, {75,0.00000000}, {76,0.00002655}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00003540}, {82,0.00000000}, {83,0.00003540}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00002655}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00003540}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00003540}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00003540}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00003540}, {112,0.00000000}, {113,0.00000000}, {114,0.00003540}, {115,0.00003540}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00003540}, {127,0.00000000}, {128,0.00003540}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00003540}, {135,0.00006195}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00003540}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00003540}, {151,0.00000000}, {152,0.00000000}, {153,0.00002655}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00003540}, {159,0.00000000}, {160,0.00007080}, {161,0.00000000}, {162,0.00007080}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00003540}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00003540}, {176,0.00000000}, {177,0.00002655}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00007080}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00007080}, {188,0.00000000}, {189,0.00000000}, {190,0.00003540}, {191,0.00000000}, {192,0.00000000}, {193,0.00003540}, {194,0.00003540}, {195,0.00000000}, {196,0.00000000}, {197,0.00003540}, {198,0.00000000}, {199,0.00000000}, {200,0.00003540}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00003540}, {207,0.00003540}, {208,0.00000000}, {209,0.00000000}, {210,0.00002655}, {211,0.00003540}, {212,0.00003540}, {213,0.00000000}, {214,0.00003540}, {215,0.00000000}, {216,0.00000000}, {217,0.00002655}, {218,0.00000000}, {219,0.00003540}, {220,0.00000000}, {221,0.00002655}, {222,0.00002655}, {223,0.00003540}, {224,0.00003540}, {225,0.00003540}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00003540}, {230,0.00003540}, {231,0.00003540}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00003540}, {237,0.00000000}, {238,0.00003540}, {239,0.00000000}, {240,0.00003540}, {241,0.00000000}, {242,0.00003540}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00003540}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00003540}, {252,0.00003540}, {253,0.00003540}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00003540}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00003540}, {263,0.00000000}, {264,0.00007080}, {265,0.00000000}, {266,0.00000000}, {267,0.00003540}, {268,0.00000000}, {269,0.00006195}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00003540}, {281,0.00000000}, {282,0.00000000}, {283,0.00003540}, {284,0.00007080}, {285,0.00003540}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00002655}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00002655}, {295,0.00003540}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00007080}, {305,0.00000000}, {306,0.00000000}, {307,0.00003540}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00002655}, {318,0.00003540}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00002655}, {324,0.00000000}, {325,0.00000000}, {326,0.00007080}, {327,0.00003540}, {328,0.00000000}, {329,0.00003540}, {330,0.00002655}, {331,0.00007080}, {332,0.00003540}, {333,0.00003540}, {334,0.00000000}, {335,0.00000000}, {336,0.00007080}, {337,0.00000000}, {338,0.00003540}, {339,0.00003540}, {340,0.00000000}, {341,0.00003540}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00003540}, {351,0.00000000}, {352,0.00000000}, {353,0.00003540}, {354,0.00014159}, {355,0.00003540}, {356,0.00000000}, {357,0.00007080}, {358,0.00000000}, {359,0.00003540}, {360,0.00003540}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00003540}, {367,0.00000000}, {368,0.00003540}, {369,0.00003540}, {370,0.00002655}, {371,0.00000000}, {372,0.00000000}, {373,0.00003540}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00003540}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00003540}, {386,0.00000000}, {387,0.00003540}, {388,0.00000000}, {389,0.00000000}, {390,0.00002655}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00003540}, {395,0.00003540}, {396,0.00000000}, {397,0.00003540}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00003540}, {402,0.00000000}, {403,0.00002655}, {404,0.00003540}, {405,0.00003540}, {406,0.00003540}, {407,0.00000000}, {408,0.00000000}, {409,0.00003540}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00003540}, {416,0.00003540}, {417,0.00003540}, {418,0.00003540}, {419,0.00007080}, {420,0.00000000}, {421,0.00000000}, {422,0.00007080}, {423,0.00003540}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00003540}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00006195}, {435,0.00003540}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00002655}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00002655}, {454,0.00000000}, {455,0.00003540}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00003540}, {464,0.00003540}, {465,0.00003540}, {466,0.00000000}, {467,0.00003540}, {468,0.00000000}, {469,0.00010619}, {470,0.00000000}, {471,0.00002655}, {472,0.00003540}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00003540}, {481,0.00003540}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00007080}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00003540}, {492,0.00003540}, {493,0.00003540}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00003540}, {499,0.00003540}, {500,0.00000000}, {505,0.00000000}, {510,0.00003540}, {515,0.00000000}, {520,0.00000000}, {525,0.00003540}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00003540}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00003540}, {575,0.00006195}, {580,0.00000000}, {585,0.00000000}, {590,0.00003540}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00003540}, {615,0.00003540}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00009735}, {640,0.00000000}, {645,0.00003540}, {650,0.00000000}, {655,0.00000000}, {660,0.00003540}, {665,0.00000000}, {670,0.00003540}, {675,0.00000000}, {680,0.00000000}, {685,0.00003540}, {690,0.00003540}, {695,0.00003540}, {700,0.00003540}, {705,0.00000000}, {710,0.00002655}, {715,0.00000000}, {720,0.00000000}, {725,0.00003540}, {730,0.00002655}, {735,0.00000000}, {740,0.00000000}, {745,0.00007080}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00003540}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00002655}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00003571}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00002679}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00003571}, {850,0.00002679}, {855,0.00003571}, {860,0.00000000}, {865,0.00000000}, {870,0.00003571}, {875,0.00003571}, {880,0.00000000}, {885,0.00000000}, {890,0.00003571}, {895,0.00000000}, {900,0.00002679}, {905,0.00003571}, {910,0.00000000}, {915,0.00000000}, {920,0.00003571}, {925,0.00003571}, {930,0.00002679}, {935,0.00000000}, {940,0.00002679}, {945,0.00003571}, {950,0.00003571}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00007143}, {980,0.00000000}, {985,0.00003571}, {990,0.00000000}, {995,0.00000000}, {1000,0.00007143}, {1010,0.00000000}, {1020,0.00003571}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00009821}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00003571}, {1090,0.00003571}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00003571}, {1160,0.00003571}, {1170,0.00000000}, {1180,0.00003571}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00007143}, {1260,0.00003571}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00003571}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00003571}, {1390,0.00003571}, {1400,0.00000000}, {1410,0.00007143}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00007143}, {1450,0.00007143}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00003571}, {1490,0.00000000}, {1500,0.00002679}, {1510,0.00000000}, {1520,0.00003571}, {1530,0.00000000}, {1540,0.00002679}, {1550,0.00007143}, {1560,0.00000000}, {1570,0.00003571}, {1580,0.00000000}, {1590,0.00002679}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00003571}, {1630,0.00000000}, {1640,0.00003571}, {1650,0.00003571}, {1660,0.00000000}, {1670,0.00003571}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00007143}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00003571}, {1790,0.00000000}, {1800,0.00003571}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00003571}, {1840,0.00000000}, {1850,0.00003571}, {1860,0.00000000}, {1870,0.00003571}, {1880,0.00000000}, {1890,0.00003571}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00003571}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00003571}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00003571}, {2200,0.00000000}, {2250,0.00003571}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00003571}, {2450,0.00000000}, {2500,0.00003571}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00000000}, {2700,0.00003571}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00007143}, {2900,0.00003571}, {2950,0.00003571}, {3000,0.00000000}, {3050,0.00003571}, {3100,0.00000000}, {3150,0.00003571}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00002679}, {3350,0.00003571}, {3400,0.00000000}, {3450,0.00009821}, {3500,0.00003571}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00003571}, {3700,0.00000000}, {3750,0.00003571}, {3800,0.00003571}, {3850,0.00000000}, {3900,0.00000000}, {3950,0.00021429}, {4000,0.00000000}, {4050,0.00003571}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00003571}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00003571}, {4400,0.00003571}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00007143}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00003571}, {4800,0.00007143}, {4850,0.00000000}, {4900,0.00002679}, {4950,0.00000000}, {5000,0.00000000}, {5050,0.00016071}, {5100,0.00003571}, {5150,0.00007143}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00014286}, {5350,0.00000000}, {5400,0.00003571}, {5450,0.00002679}, {5500,0.00000000}, {5550,0.00007143}, {5600,0.00014286}, {5650,0.00003571}, {5700,0.00003571}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00000000}, {5900,0.00020536}, {5950,0.00003571}, {6000,0.00000000}, {6050,0.00007143}, {6100,0.00025000}, {6150,0.00000000}, {6200,0.00007143}, {6250,0.00006250}, {6300,0.00003571}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00003571}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00003571}, {6700,0.00007143}, {6750,0.00017857}, {6800,0.00006250}, {6850,0.00007143}, {6900,0.00000000}, {6950,0.00003571}, {7000,0.00000000}, {7050,0.00003571}, {7100,0.00006250}, {7150,0.00020536}, {7200,0.00000000}, {7250,0.00032143}, {7300,0.00003571}, {7350,0.00003571}, {7400,0.00003571}, {7450,0.00003571}, {7500,0.00003571}, {7550,0.00003571}, {7600,0.00000000}, {7650,0.00006250}, {7700,0.00007143}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00003571}, {7950,0.00003571}, {8000,0.00007143}, {8050,0.00000000}, {8100,0.00020536}, {8150,0.00003571}, {8200,0.00016071}, {8250,0.00000000}, {8300,0.00000000}, {8350,0.00007143}, {8400,0.00003571}, {8450,0.00002679}, {8500,0.00003571}, {8550,0.00007143}, {8600,0.00007143}, {8650,0.00010714}, {8700,0.00007143}, {8750,0.00003571}, {8800,0.00010714}, {8850,0.00003571}, {8900,0.00000000}, {8950,0.00003571}, {9000,0.00006250}, {9050,0.00033929}, {9100,0.00000000}, {9150,0.00032143}, {9200,0.00007143}, {9250,0.00000000}, {9300,0.00003571}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00000000}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00010714}, {9650,0.00000000}, {9700,0.00000000}, {9750,0.00003571}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00000000}, {9950,0.00003571}, {10000,0.00000000}, {10100,0.00003571}, {10200,0.00003571}, {10300,0.00003571}, {10400,0.00007143}, {10500,0.00003571}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00003571}, {10900,0.00003571}, {11000,0.00007143}, {11100,0.00000000}, {11200,0.00007143}, {11300,0.00007143}, {11400,0.00007143}, {11500,0.00002679}, {11600,0.00000000}, {11700,0.00003571}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00007143}, {12100,0.00010714}, {12200,0.00003571}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00100}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00100}, {18800,0.00000}, {18900,0.00000}, {19000,0.00100}, {19100,0.00100}, {19200,0.00000}, {19300,0.00000}, {19400,0.00200}, {19500,0.00000}, {19600,0.00100}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["lazy Denote"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00001770}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00038938}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00001770}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000885}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00098230}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00098230}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00001770}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00001770}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00098230}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00098230}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00001770}, {339,0.00000000}, {340,0.00122124}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00001770}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00001770}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000885}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00002655}, {428,0.00000000}, {429,0.00000000}, {430,0.00000885}, {431,0.00000885}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000885}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000885}, {444,0.00000000}, {445,0.00000885}, {446,0.00000000}, {447,0.00000885}, {448,0.00196460}, {449,0.00003540}, {450,0.00001770}, {451,0.00000885}, {452,0.00000885}, {453,0.00002655}, {454,0.00001770}, {455,0.00004425}, {456,0.00004425}, {457,0.00010619}, {458,0.00005310}, {459,0.00009735}, {460,0.00008850}, {461,0.00009735}, {462,0.00010619}, {463,0.00011504}, {464,0.00019469}, {465,0.00024779}, {466,0.00027434}, {467,0.00023894}, {468,0.00025664}, {469,0.00029204}, {470,0.00033628}, {471,0.00038053}, {472,0.00033628}, {473,0.00035398}, {474,0.00042478}, {475,0.00055752}, {476,0.00060177}, {477,0.00063717}, {478,0.00066372}, {479,0.00066372}, {480,0.00068142}, {481,0.00075221}, {482,0.00072566}, {483,0.00072566}, {484,0.00079646}, {485,0.00079646}, {486,0.00079646}, {487,0.00080531}, {488,0.00079646}, {489,0.00087611}, {490,0.00087611}, {491,0.00083186}, {492,0.00082301}, {493,0.00081416}, {494,0.00087611}, {495,0.00090265}, {496,0.00090265}, {497,0.00090265}, {498,0.00090265}, {499,0.00090265}, {500,0.00087611}, {505,0.00094690}, {510,0.00100000}, {515,0.00100000}, {520,0.00100000}, {525,0.00100000}, {530,0.00100000}, {535,0.00100000}, {540,0.00100000}, {545,0.00100000}, {550,0.00100000}, {555,0.00100000}, {560,0.00100000}, {565,0.00100000}, {570,0.00100000}, {575,0.00100000}, {580,0.00100000}, {585,0.00100000}, {590,0.00100000}, {595,0.00100000}, {600,0.00100000}, {605,0.00100000}, {610,0.00100000}, {615,0.00100000}, {620,0.00100885}, {625,0.00100000}, {630,0.00100000}, {635,0.00100000}, {640,0.00100000}, {645,0.00100000}, {650,0.00100000}, {655,0.00100000}, {660,0.00100000}, {665,0.00100000}, {670,0.00100000}, {675,0.00100000}, {680,0.00100000}, {685,0.00100000}, {690,0.00100000}, {695,0.00100000}, {700,0.00100000}, {705,0.00281416}, {710,0.00100000}, {715,0.00100000}, {720,0.00100000}, {725,0.00278761}, {730,0.00100000}, {735,0.00100000}, {740,0.00102655}, {745,0.00100000}, {750,0.00100000}, {755,0.00100000}, {760,0.00100000}, {765,0.00100000}, {770,0.00100000}, {775,0.00100000}, {780,0.00100000}, {785,0.00100885}, {790,0.00100000}, {795,0.00101786}, {800,0.00466964}, {805,0.00100000}, {810,0.00100000}, {815,0.00100000}, {820,0.00100000}, {825,0.00100000}, {830,0.00100000}, {835,0.00324107}, {840,0.00100000}, {845,0.00100000}, {850,0.00100000}, {855,0.00100893}, {860,0.00100000}, {865,0.00100893}, {870,0.00100893}, {875,0.00106250}, {880,0.00100000}, {885,0.00103571}, {890,0.00121429}, {895,0.00125893}, {900,0.00143750}, {905,0.00144643}, {910,0.00150893}, {915,0.00156250}, {920,0.00162500}, {925,0.00162500}, {930,0.00160714}, {935,0.00169643}, {940,0.00174107}, {945,0.00178571}, {950,0.00186607}, {955,0.00183929}, {960,0.00191071}, {965,0.00192857}, {970,0.00195536}, {975,0.00196429}, {980,0.00196429}, {985,0.00197321}, {990,0.00196429}, {995,0.00198214}, {1000,0.00198214}, {1010,0.00198214}, {1020,0.00200000}, {1030,0.00200000}, {1040,0.00296429}, {1050,0.00200000}, {1060,0.00200000}, {1070,0.00200000}, {1080,0.00200000}, {1090,0.00200000}, {1100,0.00200893}, {1110,0.00200000}, {1120,0.00200000}, {1130,0.00200000}, {1140,0.00200000}, {1150,0.00200000}, {1160,0.00200000}, {1170,0.00200000}, {1180,0.00200000}, {1190,0.00200000}, {1200,0.00200000}, {1210,0.00200000}, {1220,0.00205357}, {1230,0.00200000}, {1240,0.00200000}, {1250,0.00200000}, {1260,0.00200000}, {1270,0.00200000}, {1280,0.00200000}, {1290,0.00200000}, {1300,0.00200000}, {1310,0.00200893}, {1320,0.00203571}, {1330,0.00206250}, {1340,0.00210714}, {1350,0.00225000}, {1360,0.00243750}, {1370,0.00260714}, {1380,0.00222321}, {1390,0.00270536}, {1400,0.00270536}, {1410,0.00269643}, {1420,0.00271429}, {1430,0.00274107}, {1440,0.00291964}, {1450,0.00290179}, {1460,0.00299107}, {1470,0.00299107}, {1480,0.00510714}, {1490,0.00300000}, {1500,0.00298214}, {1510,0.00300000}, {1520,0.00300000}, {1530,0.00300000}, {1540,0.00300000}, {1550,0.00300000}, {1560,0.00300000}, {1570,0.00300000}, {1580,0.00576786}, {1590,0.00300000}, {1600,0.00300000}, {1610,0.00496429}, {1620,0.00300000}, {1630,0.00300000}, {1640,0.00300000}, {1650,0.00300000}, {1660,0.00300000}, {1670,0.00302679}, {1680,0.00300000}, {1690,0.00300000}, {1700,0.00300000}, {1710,0.00300000}, {1720,0.00300000}, {1730,0.00730357}, {1740,0.00300893}, {1750,0.00300893}, {1760,0.00300893}, {1770,0.00308036}, {1780,0.00300000}, {1790,0.00303571}, {1800,0.00316071}, {1810,0.00323214}, {1820,0.00340179}, {1830,0.00360714}, {1840,0.00372321}, {1850,0.00372321}, {1860,0.00372321}, {1870,0.00373214}, {1880,0.00378571}, {1890,0.00382143}, {1900,0.00374107}, {1910,0.00376786}, {1920,0.00376786}, {1930,0.00387500}, {1940,0.00391071}, {1950,0.00385714}, {1960,0.00393750}, {1970,0.00399107}, {1980,0.00399107}, {1990,0.00399107}, {2000,0.00400000}, {2050,0.00400000}, {2100,0.00400000}, {2150,0.00400000}, {2200,0.00400000}, {2250,0.00402679}, {2300,0.00407143}, {2350,0.00474107}, {2400,0.00475000}, {2450,0.00491071}, {2500,0.00495536}, {2550,0.00500000}, {2600,0.00500000}, {2650,0.00500000}, {2700,0.00503571}, {2750,0.00546429}, {2800,0.00572321}, {2850,0.00576786}, {2900,0.00579464}, {2950,0.00594643}, {3000,0.00599107}, {3050,0.00600000}, {3100,0.01191964}, {3150,0.00600000}, {3200,0.00620536}, {3250,0.00670536}, {3300,0.00647321}, {3350,0.00676786}, {3400,0.00675893}, {3450,0.00697321}, {3500,0.00700000}, {3550,0.00699107}, {3600,0.00705357}, {3650,0.00730357}, {3700,0.00723214}, {3750,0.00713393}, {3800,0.00742857}, {3850,0.00776786}, {3900,0.00778571}, {3950,0.00780357}, {4000,0.00794643}, {4050,0.00815179}, {4100,0.00813393}, {4150,0.00801786}, {4200,0.00874107}, {4250,0.01720536}, {4300,0.00875893}, {4350,0.00878571}, {4400,0.00877679}, {4450,0.00879464}, {4500,0.00909821}, {4550,0.00896429}, {4600,0.00900893}, {4650,0.01367857}, {4700,0.00975893}, {4750,0.00975000}, {4800,0.00976786}, {4850,0.00979464}, {4900,0.00982143}, {4950,0.01459821}, {5000,0.00982143}, {5050,0.00990179}, {5100,0.01065179}, {5150,0.01367857}, {5200,0.01021429}, {5250,0.01075000}, {5300,0.01073214}, {5350,0.02317857}, {5400,0.01074107}, {5450,0.01075000}, {5500,0.01128571}, {5550,0.01142857}, {5600,0.01105357}, {5650,0.01118750}, {5700,0.01135714}, {5750,0.01165179}, {5800,0.01174107}, {5850,0.01174107}, {5900,0.01176786}, {5950,0.01197321}, {6000,0.01241964}, {6050,0.01197321}, {6100,0.01212500}, {6150,0.01274107}, {6200,0.01259821}, {6250,0.01276786}, {6300,0.01273214}, {6350,0.02614286}, {6400,0.01294643}, {6450,0.01273214}, {6500,0.02178571}, {6550,0.01367857}, {6600,0.01310714}, {6650,0.01349107}, {6700,0.01383929}, {6750,0.01387500}, {6800,0.01380357}, {6850,0.01370536}, {6900,0.03275893}, {6950,0.01371429}, {7000,0.01416071}, {7050,0.01391964}, {7100,0.01406250}, {7150,0.01465179}, {7200,0.03549107}, {7250,0.01482143}, {7300,0.01470536}, {7350,0.01471429}, {7400,0.01507143}, {7450,0.01474107}, {7500,0.03774107}, {7550,0.01504464}, {7600,0.01542857}, {7650,0.01544643}, {7700,0.01566071}, {7750,0.01567857}, {7800,0.03167857}, {7850,0.02902679}, {7900,0.01613393}, {7950,0.01576786}, {8000,0.01593750}, {8050,0.01635714}, {8100,0.01640179}, {8150,0.01667857}, {8200,0.01675000}, {8250,0.01725893}, {8300,0.01675893}, {8350,0.01678571}, {8400,0.01708036}, {8450,0.03319643}, {8500,0.03833036}, {8550,0.01710714}, {8600,0.01750893}, {8650,0.01764286}, {8700,0.01766964}, {8750,0.03514286}, {8800,0.01838393}, {8850,0.01770536}, {8900,0.01777679}, {8950,0.04713393}, {9000,0.01808036}, {9050,0.01824107}, {9100,0.01851786}, {9150,0.01850000}, {9200,0.01859821}, {9250,0.03544643}, {9300,0.01864286}, {9350,0.01873214}, {9400,0.02696429}, {9450,0.03754464}, {9500,0.01892857}, {9550,0.01918750}, {9600,0.01942857}, {9650,0.01886607}, {9700,0.03530357}, {9750,0.03227679}, {9800,0.01924107}, {9850,0.01941964}, {9900,0.04285714}, {9950,0.01960714}, {10000,0.01965179}, {10100,0.03466964}, {10200,0.01996429}, {10300,0.02064286}, {10400,0.02870536}, {10500,0.03109821}, {10600,0.03158929}, {10700,0.02504464}, {10800,0.02151786}, {10900,0.02141071}, {11000,0.03217857}, {11100,0.02202679}, {11200,0.02193750}, {11300,0.04566964}, {11400,0.02241964}, {11500,0.02274107}, {11600,0.02301786}, {11700,0.04508036}, {11800,0.02320536}, {11900,0.02370536}, {12000,0.04302679}, {12100,0.02427679}, {12200,0.02401786}, {12300,0.04097321}, {12400,0.03923214}, {12500,0.03946429}, {12600,0.02600}, {12700,0.02600}, {12800,0.02600}, {12900,0.04175}, {13000,0.02675}, {13100,0.04125}, {13200,0.04925}, {13300,0.02725}, {13400,0.02700}, {13500,0.02775}, {13600,0.02775}, {13700,0.05050}, {13800,0.02800}, {13900,0.02775}, {14000,0.03325}, {14100,0.05475}, {14200,0.02900}, {14300,0.02900}, {14400,0.02900}, {14500,0.02925}, {14600,0.02950}, {14700,0.05375}, {14800,0.03375}, {14900,0.03950}, {15000,0.03025}, {15100,0.04275}, {15200,0.03775}, {15300,0.04825}, {15400,0.04025}, {15500,0.03925}, {15600,0.03900}, {15700,0.03175}, {15800,0.04050}, {15900,0.03225}, {16000,0.04900}, {16100,0.04250}, {16200,0.04725}, {16300,0.04750}, {16400,0.04925}, {16500,0.04325}, {16600,0.04675}, {16700,0.03350}, {16800,0.04350}, {16900,0.03400}, {17000,0.04400}, {17100,0.03900}, {17200,0.04100}, {17300,0.04000}, {17400,0.03850}, {17500,0.04975}, {17600,0.03975}, {17700,0.03975}, {17800,0.05350}, {17900,0.05050}, {18000,0.04000}, {18100,0.04900}, {18200,0.04725}, {18300,0.05150}, {18400,0.04175}, {18500,0.03750}, {18600,0.05900}, {18700,0.03800}, {18800,0.05425}, {18900,0.05400}, {19000,0.03750}, {19100,0.03800}, {19200,0.03800}, {19300,0.03850}, {19400,0.05350}, {19500,0.05600}, {19600,0.03850}, {19700,0.06600}, {19800,0.05550}, {19900,0.03925}, {20000,0.0480}};
data["big_flat"]["lazy Denote"]["Stats"]["user"] = {{1,0.00002655}, {2,0.00005310}, {3,0.00005310}, {4,0.00007965}, {5,0.00000000}, {6,0.00007965}, {7,0.00003540}, {8,0.00000000}, {9,0.00002655}, {10,0.00009735}, {11,0.00007965}, {12,0.00000000}, {13,0.00007965}, {14,0.00007965}, {15,0.00002655}, {16,0.00003540}, {17,0.00007965}, {18,0.00007965}, {19,0.00002655}, {20,0.00009735}, {21,0.00006195}, {22,0.00002655}, {23,0.00006195}, {24,0.00006195}, {25,0.00011504}, {26,0.00005310}, {27,0.00012389}, {28,0.00006195}, {29,0.00010619}, {30,0.00015929}, {31,0.00005310}, {32,0.00005310}, {33,0.00011504}, {34,0.00005310}, {35,0.00014159}, {36,0.00023009}, {37,0.00011504}, {38,0.00000000}, {39,0.00014159}, {40,0.00003540}, {41,0.00016814}, {42,0.00014159}, {43,0.00012389}, {44,0.00005310}, {45,0.00014159}, {46,0.00013274}, {47,0.00010619}, {48,0.00007965}, {49,0.00011504}, {50,0.00010619}, {51,0.00017699}, {52,0.00018584}, {53,0.00011504}, {54,0.00008850}, {55,0.00019469}, {56,0.00000000}, {57,0.00016814}, {58,0.00018584}, {59,0.00007965}, {60,0.00019469}, {61,0.00025664}, {62,0.00015044}, {63,0.00016814}, {64,0.00009735}, {65,0.00014159}, {66,0.00014159}, {67,0.00020354}, {68,0.00011504}, {69,0.00019469}, {70,0.00016814}, {71,0.00010619}, {72,0.00023009}, {73,0.00005310}, {74,0.00010619}, {75,0.00010619}, {76,0.00027434}, {77,0.00026549}, {78,0.00007965}, {79,0.00035398}, {80,0.00007965}, {81,0.00008850}, {82,0.00014159}, {83,0.00031858}, {84,0.00007965}, {85,0.00033628}, {86,0.00019469}, {87,0.00025664}, {88,0.00007965}, {89,0.00026549}, {90,0.00007080}, {91,0.00013274}, {92,0.00022124}, {93,0.00038938}, {94,0.00016814}, {95,0.00017699}, {96,0.00014159}, {97,0.00021239}, {98,0.00013274}, {99,0.00019469}, {100,0.00007965}, {101,0.00005310}, {102,0.00015044}, {103,0.00019469}, {104,0.00019469}, {105,0.00020354}, {106,0.00020354}, {107,0.00019469}, {108,0.00015044}, {109,0.00022124}, {110,0.00019469}, {111,0.00025664}, {112,0.00033628}, {113,0.00028319}, {114,0.00018584}, {115,0.00027434}, {116,0.00030088}, {117,0.00015929}, {118,0.00030973}, {119,0.00056637}, {120,0.00032743}, {121,0.00023894}, {122,0.00020354}, {123,0.00013274}, {124,0.00024779}, {125,0.00024779}, {126,0.00023009}, {127,0.00027434}, {128,0.00034513}, {129,0.00025664}, {130,0.00021239}, {131,0.00015929}, {132,0.00024779}, {133,0.00035398}, {134,0.00024779}, {135,0.00034513}, {136,0.00026549}, {137,0.00024779}, {138,0.00031858}, {139,0.00030973}, {140,0.00027434}, {141,0.00025664}, {142,0.00023009}, {143,0.00031858}, {144,0.00027434}, {145,0.00023894}, {146,0.00023009}, {147,0.00017699}, {148,0.00030973}, {149,0.00034513}, {150,0.00019469}, {151,0.00021239}, {152,0.00020354}, {153,0.00024779}, {154,0.00034513}, {155,0.00030973}, {156,0.00030088}, {157,0.00018584}, {158,0.00020354}, {159,0.00034513}, {160,0.00023009}, {161,0.00023894}, {162,0.00032743}, {163,0.00036283}, {164,0.00015929}, {165,0.00023894}, {166,0.00028319}, {167,0.00042478}, {168,0.00030973}, {169,0.00026549}, {170,0.00023009}, {171,0.00036283}, {172,0.00029204}, {173,0.00025664}, {174,0.00043363}, {175,0.00038053}, {176,0.00052212}, {177,0.00029204}, {178,0.00030973}, {179,0.00038938}, {180,0.00021239}, {181,0.00030973}, {182,0.00023894}, {183,0.00054867}, {184,0.00042478}, {185,0.00034513}, {186,0.00040708}, {187,0.00023894}, {188,0.00035398}, {189,0.00023894}, {190,0.00031858}, {191,0.00032743}, {192,0.00029204}, {193,0.00034513}, {194,0.00025664}, {195,0.00042478}, {196,0.00035398}, {197,0.00038053}, {198,0.00039823}, {199,0.00046903}, {200,0.00022124}, {201,0.00019469}, {202,0.00031858}, {203,0.00041593}, {204,0.00032743}, {205,0.00033628}, {206,0.00032743}, {207,0.00024779}, {208,0.00035398}, {209,0.00038053}, {210,0.00057522}, {211,0.00043363}, {212,0.00041593}, {213,0.00030973}, {214,0.00045133}, {215,0.00023009}, {216,0.00021239}, {217,0.00048673}, {218,0.00045133}, {219,0.00045133}, {220,0.00040708}, {221,0.00047788}, {222,0.00049558}, {223,0.00023894}, {224,0.00042478}, {225,0.00032743}, {226,0.00040708}, {227,0.00123894}, {228,0.00045133}, {229,0.00043363}, {230,0.00029204}, {231,0.00053097}, {232,0.00020354}, {233,0.00035398}, {234,0.00035398}, {235,0.00032743}, {236,0.00034513}, {237,0.00048673}, {238,0.00034513}, {239,0.00046018}, {240,0.00051327}, {241,0.00035398}, {242,0.00061062}, {243,0.00121239}, {244,0.00047788}, {245,0.00034513}, {246,0.00039823}, {247,0.00041593}, {248,0.00036283}, {249,0.00061947}, {250,0.00050442}, {251,0.00045133}, {252,0.00036283}, {253,0.00037168}, {254,0.00027434}, {255,0.00049558}, {256,0.00058407}, {257,0.00045133}, {258,0.00036283}, {259,0.00039823}, {260,0.00028319}, {261,0.00049558}, {262,0.00050442}, {263,0.00051327}, {264,0.00035398}, {265,0.00046903}, {266,0.00046903}, {267,0.00047788}, {268,0.00055752}, {269,0.00040708}, {270,0.00053097}, {271,0.00036283}, {272,0.00050442}, {273,0.00065487}, {274,0.00046903}, {275,0.00044248}, {276,0.00052212}, {277,0.00058407}, {278,0.00053982}, {279,0.00044248}, {280,0.00055752}, {281,0.00043363}, {282,0.00053097}, {283,0.00053097}, {284,0.00059292}, {285,0.00038053}, {286,0.00033628}, {287,0.00047788}, {288,0.00058407}, {289,0.00075221}, {290,0.00063717}, {291,0.00045133}, {292,0.00045133}, {293,0.00049558}, {294,0.00046018}, {295,0.00046903}, {296,0.00058407}, {297,0.00053097}, {298,0.00055752}, {299,0.00063717}, {300,0.00043363}, {301,0.00038053}, {302,0.00036283}, {303,0.00070796}, {304,0.00036283}, {305,0.00057522}, {306,0.00055752}, {307,0.00072566}, {308,0.00054867}, {309,0.00049558}, {310,0.00057522}, {311,0.00123894}, {312,0.00064602}, {313,0.00060177}, {314,0.00038053}, {315,0.00040708}, {316,0.00073451}, {317,0.00047788}, {318,0.00054867}, {319,0.00063717}, {320,0.00140708}, {321,0.00072566}, {322,0.00067257}, {323,0.00063717}, {324,0.00075221}, {325,0.00060177}, {326,0.00076106}, {327,0.00028319}, {328,0.00052212}, {329,0.00068142}, {330,0.00056637}, {331,0.00045133}, {332,0.00082301}, {333,0.00050442}, {334,0.00062832}, {335,0.00048673}, {336,0.00054867}, {337,0.00088496}, {338,0.00062832}, {339,0.00062832}, {340,0.00138938}, {341,0.00068142}, {342,0.00072566}, {343,0.00061947}, {344,0.00075221}, {345,0.00061947}, {346,0.00061947}, {347,0.00050442}, {348,0.00063717}, {349,0.00076106}, {350,0.00071681}, {351,0.00103540}, {352,0.00066372}, {353,0.00048673}, {354,0.00068142}, {355,0.00075221}, {356,0.00060177}, {357,0.00083186}, {358,0.00076106}, {359,0.00047788}, {360,0.00053097}, {361,0.00066372}, {362,0.00053097}, {363,0.00047788}, {364,0.00081416}, {365,0.00051327}, {366,0.00064602}, {367,0.00091150}, {368,0.00053982}, {369,0.00082301}, {370,0.00065487}, {371,0.00079646}, {372,0.00072566}, {373,0.00119469}, {374,0.00045133}, {375,0.00089381}, {376,0.00054867}, {377,0.00076106}, {378,0.00092920}, {379,0.00044248}, {380,0.00069027}, {381,0.00067257}, {382,0.00085841}, {383,0.00069912}, {384,0.00076106}, {385,0.00077876}, {386,0.00078761}, {387,0.00063717}, {388,0.00080531}, {389,0.00061947}, {390,0.00058407}, {391,0.00071681}, {392,0.00075221}, {393,0.00052212}, {394,0.00053097}, {395,0.00071681}, {396,0.00066372}, {397,0.00074336}, {398,0.00072566}, {399,0.00081416}, {400,0.00087611}, {401,0.00069027}, {402,0.00076991}, {403,0.00085841}, {404,0.00091150}, {405,0.00068142}, {406,0.00068142}, {407,0.00102655}, {408,0.00060177}, {409,0.00098230}, {410,0.00074336}, {411,0.00092920}, {412,0.00077876}, {413,0.00064602}, {414,0.00076106}, {415,0.00074336}, {416,0.00076991}, {417,0.00074336}, {418,0.00057522}, {419,0.00073451}, {420,0.00080531}, {421,0.00088496}, {422,0.00056637}, {423,0.00099115}, {424,0.00097345}, {425,0.00077876}, {426,0.00093805}, {427,0.00086726}, {428,0.00102655}, {429,0.00071681}, {430,0.00048673}, {431,0.00059292}, {432,0.00068142}, {433,0.00080531}, {434,0.00095575}, {435,0.00070796}, {436,0.00093805}, {437,0.00090265}, {438,0.00074336}, {439,0.00095575}, {440,0.00093805}, {441,0.00067257}, {442,0.00098230}, {443,0.00112389}, {444,0.00075221}, {445,0.00083186}, {446,0.00080531}, {447,0.00092920}, {448,0.00202655}, {449,0.00067257}, {450,0.00110619}, {451,0.00093805}, {452,0.00063717}, {453,0.00084071}, {454,0.00080531}, {455,0.00105310}, {456,0.00083186}, {457,0.00097345}, {458,0.00100000}, {459,0.00083186}, {460,0.00096460}, {461,0.00088496}, {462,0.00073451}, {463,0.00078761}, {464,0.00061062}, {465,0.00105310}, {466,0.00095575}, {467,0.00081416}, {468,0.00094690}, {469,0.00085841}, {470,0.00069027}, {471,0.00087611}, {472,0.00077876}, {473,0.00100000}, {474,0.00084956}, {475,0.00086726}, {476,0.00099115}, {477,0.00086726}, {478,0.00076991}, {479,0.00104425}, {480,0.00093805}, {481,0.00101770}, {482,0.00089381}, {483,0.00090265}, {484,0.00091150}, {485,0.00057522}, {486,0.00088496}, {487,0.00101770}, {488,0.00117699}, {489,0.00071681}, {490,0.00106195}, {491,0.00110619}, {492,0.00108850}, {493,0.00100885}, {494,0.00076991}, {495,0.00061062}, {496,0.00081416}, {497,0.00074336}, {498,0.00087611}, {499,0.00105310}, {500,0.00098230}, {505,0.00111504}, {510,0.00100885}, {515,0.00081416}, {520,0.00072566}, {525,0.00089381}, {530,0.00076106}, {535,0.00080531}, {540,0.00086726}, {545,0.00100000}, {550,0.00106195}, {555,0.00116814}, {560,0.00101770}, {565,0.00105310}, {570,0.00084956}, {575,0.00114159}, {580,0.00131858}, {585,0.00121239}, {590,0.00106195}, {595,0.00104425}, {600,0.00079646}, {605,0.00126549}, {610,0.00133628}, {615,0.00119469}, {620,0.00140708}, {625,0.00152212}, {630,0.00100885}, {635,0.00101770}, {640,0.00136283}, {645,0.00120354}, {650,0.00107080}, {655,0.00123894}, {660,0.00125664}, {665,0.00100000}, {670,0.00133628}, {675,0.00108850}, {680,0.00118584}, {685,0.00112389}, {690,0.00116814}, {695,0.00143363}, {700,0.00116814}, {705,0.00293805}, {710,0.00147788}, {715,0.00163717}, {720,0.00113274}, {725,0.00274336}, {730,0.00151327}, {735,0.00132743}, {740,0.00111504}, {745,0.00183186}, {750,0.00131858}, {755,0.00154867}, {760,0.00184071}, {765,0.00131858}, {770,0.00164602}, {775,0.00159292}, {780,0.00153097}, {785,0.00147788}, {790,0.00135398}, {795,0.00133929}, {800,0.00324107}, {805,0.00181250}, {810,0.00171429}, {815,0.00165179}, {820,0.00161607}, {825,0.00173214}, {830,0.00153571}, {835,0.00325893}, {840,0.00167857}, {845,0.00130357}, {850,0.00158929}, {855,0.00165179}, {860,0.00155357}, {865,0.00188393}, {870,0.00154464}, {875,0.00175000}, {880,0.00163393}, {885,0.00141964}, {890,0.00191964}, {895,0.00163393}, {900,0.00187500}, {905,0.00184821}, {910,0.00205357}, {915,0.00186607}, {920,0.00160714}, {925,0.00168750}, {930,0.00168750}, {935,0.00169643}, {940,0.00191964}, {945,0.00194643}, {950,0.00216071}, {955,0.00215179}, {960,0.00168750}, {965,0.00156250}, {970,0.00182143}, {975,0.00171429}, {980,0.00170536}, {985,0.00186607}, {990,0.00175000}, {995,0.00172321}, {1000,0.00215179}, {1010,0.00183036}, {1020,0.00197321}, {1030,0.00218750}, {1040,0.00263393}, {1050,0.00186607}, {1060,0.00221429}, {1070,0.00201786}, {1080,0.00224107}, {1090,0.00208036}, {1100,0.00183036}, {1110,0.00208929}, {1120,0.00186607}, {1130,0.00209821}, {1140,0.00191964}, {1150,0.00189286}, {1160,0.00206250}, {1170,0.00225893}, {1180,0.00240179}, {1190,0.00213393}, {1200,0.00199107}, {1210,0.00234821}, {1220,0.00210714}, {1230,0.00225000}, {1240,0.00203571}, {1250,0.00232143}, {1260,0.00273214}, {1270,0.00215179}, {1280,0.00251786}, {1290,0.00215179}, {1300,0.00216071}, {1310,0.00217857}, {1320,0.00237500}, {1330,0.00255357}, {1340,0.00251786}, {1350,0.00275893}, {1360,0.00231250}, {1370,0.00236607}, {1380,0.00245536}, {1390,0.00243750}, {1400,0.00271429}, {1410,0.00237500}, {1420,0.00253571}, {1430,0.00241071}, {1440,0.00261607}, {1450,0.00257143}, {1460,0.00241071}, {1470,0.00263393}, {1480,0.00501786}, {1490,0.00267857}, {1500,0.00272321}, {1510,0.00264286}, {1520,0.00284821}, {1530,0.00262500}, {1540,0.00265179}, {1550,0.00252679}, {1560,0.00284821}, {1570,0.00278571}, {1580,0.00566071}, {1590,0.00268750}, {1600,0.00297321}, {1610,0.00508036}, {1620,0.00314286}, {1630,0.00297321}, {1640,0.00298214}, {1650,0.00294643}, {1660,0.00300000}, {1670,0.00308929}, {1680,0.00299107}, {1690,0.00300000}, {1700,0.00293750}, {1710,0.00300893}, {1720,0.00296429}, {1730,0.00739286}, {1740,0.00316071}, {1750,0.00310714}, {1760,0.00312500}, {1770,0.00318750}, {1780,0.00318750}, {1790,0.00316071}, {1800,0.00331250}, {1810,0.00323214}, {1820,0.00335714}, {1830,0.00324107}, {1840,0.00330357}, {1850,0.00333929}, {1860,0.00322321}, {1870,0.00328571}, {1880,0.00349107}, {1890,0.00363393}, {1900,0.00347321}, {1910,0.00344643}, {1920,0.00337500}, {1930,0.00357143}, {1940,0.00374107}, {1950,0.00351786}, {1960,0.00368750}, {1970,0.00350000}, {1980,0.00377679}, {1990,0.00350893}, {2000,0.00370536}, {2050,0.00366964}, {2100,0.00361607}, {2150,0.00394643}, {2200,0.00425000}, {2250,0.00414286}, {2300,0.00445536}, {2350,0.00439286}, {2400,0.00437500}, {2450,0.00489286}, {2500,0.00468750}, {2550,0.00480357}, {2600,0.00492857}, {2650,0.00487500}, {2700,0.00511607}, {2750,0.00556250}, {2800,0.00546429}, {2850,0.00548214}, {2900,0.00609821}, {2950,0.00571429}, {3000,0.00600893}, {3050,0.00634821}, {3100,0.01225893}, {3150,0.00591964}, {3200,0.00626786}, {3250,0.00671429}, {3300,0.00620536}, {3350,0.00668750}, {3400,0.00653571}, {3450,0.00699107}, {3500,0.00708036}, {3550,0.00705357}, {3600,0.00734821}, {3650,0.00762500}, {3700,0.00725000}, {3750,0.00733036}, {3800,0.00745536}, {3850,0.00770536}, {3900,0.00766964}, {3950,0.00770536}, {4000,0.00794643}, {4050,0.00849107}, {4100,0.00809821}, {4150,0.00800000}, {4200,0.00842857}, {4250,0.01658929}, {4300,0.00810714}, {4350,0.00875000}, {4400,0.00854464}, {4450,0.00871429}, {4500,0.00955357}, {4550,0.00910714}, {4600,0.00881250}, {4650,0.01369643}, {4700,0.00941071}, {4750,0.00952679}, {4800,0.00983929}, {4850,0.00990179}, {4900,0.01050893}, {4950,0.01445536}, {5000,0.01005357}, {5050,0.01064286}, {5100,0.01080357}, {5150,0.01394643}, {5200,0.01070536}, {5250,0.01100000}, {5300,0.01077679}, {5350,0.02341071}, {5400,0.01093750}, {5450,0.01133036}, {5500,0.01171429}, {5550,0.01186607}, {5600,0.01132143}, {5650,0.01158929}, {5700,0.01172321}, {5750,0.01191071}, {5800,0.01202679}, {5850,0.01200893}, {5900,0.01201786}, {5950,0.01249107}, {6000,0.01271429}, {6050,0.01253571}, {6100,0.01275000}, {6150,0.01314286}, {6200,0.01278571}, {6250,0.01288393}, {6300,0.01291964}, {6350,0.02638393}, {6400,0.01321429}, {6450,0.01323214}, {6500,0.02158929}, {6550,0.01409821}, {6600,0.01351786}, {6650,0.01345536}, {6700,0.01375893}, {6750,0.01375893}, {6800,0.01411607}, {6850,0.01380357}, {6900,0.03272321}, {6950,0.01413393}, {7000,0.01462500}, {7050,0.01446429}, {7100,0.01423214}, {7150,0.01474107}, {7200,0.03540179}, {7250,0.01475893}, {7300,0.01460714}, {7350,0.01442857}, {7400,0.01542857}, {7450,0.01494643}, {7500,0.03764286}, {7550,0.01527679}, {7600,0.01536607}, {7650,0.01535714}, {7700,0.01558929}, {7750,0.01563393}, {7800,0.03125000}, {7850,0.02894643}, {7900,0.01625000}, {7950,0.01583929}, {8000,0.01591071}, {8050,0.01649107}, {8100,0.01604464}, {8150,0.01625000}, {8200,0.01638393}, {8250,0.01714286}, {8300,0.01648214}, {8350,0.01666071}, {8400,0.01725000}, {8450,0.03283036}, {8500,0.03769643}, {8550,0.01695536}, {8600,0.01666071}, {8650,0.01772321}, {8700,0.01730357}, {8750,0.03503571}, {8800,0.01823214}, {8850,0.01775893}, {8900,0.01787500}, {8950,0.04614286}, {9000,0.01847321}, {9050,0.01795536}, {9100,0.01811607}, {9150,0.01835714}, {9200,0.01848214}, {9250,0.03557143}, {9300,0.01887500}, {9350,0.01890179}, {9400,0.02663393}, {9450,0.03758036}, {9500,0.01916071}, {9550,0.01948214}, {9600,0.01967857}, {9650,0.01885714}, {9700,0.03584821}, {9750,0.03236607}, {9800,0.01941964}, {9850,0.01964286}, {9900,0.04266071}, {9950,0.01954464}, {10000,0.01966071}, {10100,0.03487500}, {10200,0.02016071}, {10300,0.02079464}, {10400,0.02860714}, {10500,0.03121429}, {10600,0.03199107}, {10700,0.02505357}, {10800,0.02159821}, {10900,0.02151786}, {11000,0.03266964}, {11100,0.02245536}, {11200,0.02262500}, {11300,0.04597321}, {11400,0.02253571}, {11500,0.02332143}, {11600,0.02350000}, {11700,0.04547321}, {11800,0.02361607}, {11900,0.02434821}, {12000,0.04308036}, {12100,0.02453571}, {12200,0.02433929}, {12300,0.04099107}, {12400,0.03898214}, {12500,0.03955357}, {12600,0.02550}, {12700,0.02550}, {12800,0.02375}, {12900,0.04150}, {13000,0.02700}, {13100,0.03825}, {13200,0.04925}, {13300,0.02750}, {13400,0.02700}, {13500,0.02700}, {13600,0.02800}, {13700,0.05025}, {13800,0.02750}, {13900,0.02750}, {14000,0.03450}, {14100,0.05450}, {14200,0.02850}, {14300,0.02950}, {14400,0.02900}, {14500,0.03000}, {14600,0.02850}, {14700,0.05575}, {14800,0.03425}, {14900,0.03850}, {15000,0.03100}, {15100,0.04250}, {15200,0.03875}, {15300,0.04575}, {15400,0.03950}, {15500,0.03850}, {15600,0.03975}, {15700,0.03150}, {15800,0.04050}, {15900,0.03250}, {16000,0.04700}, {16100,0.04250}, {16200,0.04700}, {16300,0.05000}, {16400,0.04900}, {16500,0.04125}, {16600,0.04550}, {16700,0.03475}, {16800,0.04275}, {16900,0.03475}, {17000,0.04450}, {17100,0.03600}, {17200,0.04075}, {17300,0.04075}, {17400,0.03725}, {17500,0.04725}, {17600,0.04200}, {17700,0.03975}, {17800,0.05300}, {17900,0.05025}, {18000,0.03950}, {18100,0.04875}, {18200,0.04650}, {18300,0.05075}, {18400,0.04150}, {18500,0.03675}, {18600,0.05975}, {18700,0.03775}, {18800,0.05500}, {18900,0.05450}, {19000,0.03700}, {19100,0.03850}, {19200,0.03825}, {19300,0.03850}, {19400,0.05175}, {19500,0.05475}, {19600,0.03850}, {19700,0.06650}, {19800,0.05550}, {19900,0.03950}, {20000,0.0480}};
data["big_flat"]["lazy Denote"]["Stats"]["system"] = {{1,0.00003540}, {2,0.00003540}, {3,0.00007080}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00003540}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00003540}, {25,0.00003540}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00003540}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00003540}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00003540}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00003540}, {74,0.00000000}, {75,0.00000000}, {76,0.00003540}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00002655}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00003540}, {105,0.00000000}, {106,0.00003540}, {107,0.00003540}, {108,0.00000000}, {109,0.00000000}, {110,0.00003540}, {111,0.00000000}, {112,0.00000000}, {113,0.00003540}, {114,0.00003540}, {115,0.00000000}, {116,0.00002655}, {117,0.00000000}, {118,0.00000000}, {119,0.00003540}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00002655}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00003540}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00003540}, {145,0.00000000}, {146,0.00006195}, {147,0.00003540}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00003540}, {152,0.00003540}, {153,0.00003540}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00002655}, {165,0.00000000}, {166,0.00002655}, {167,0.00000000}, {168,0.00000000}, {169,0.00003540}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00003540}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00007080}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00003540}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00003540}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00003540}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00003540}, {218,0.00002655}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00003540}, {225,0.00003540}, {226,0.00000000}, {227,0.00000000}, {228,0.00003540}, {229,0.00003540}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00009735}, {241,0.00007080}, {242,0.00003540}, {243,0.00003540}, {244,0.00003540}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00002655}, {265,0.00000000}, {266,0.00002655}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00003540}, {272,0.00000000}, {273,0.00000000}, {274,0.00003540}, {275,0.00003540}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00003540}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00003540}, {289,0.00000000}, {290,0.00003540}, {291,0.00000000}, {292,0.00003540}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00002655}, {301,0.00003540}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00003540}, {315,0.00003540}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00007080}, {321,0.00000000}, {322,0.00000000}, {323,0.00003540}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00003540}, {338,0.00003540}, {339,0.00000000}, {340,0.00013274}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00003540}, {358,0.00003540}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00003540}, {363,0.00000000}, {364,0.00003540}, {365,0.00003540}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00003540}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00003540}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00003540}, {388,0.00003540}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00003540}, {407,0.00000000}, {408,0.00003540}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00007080}, {420,0.00003540}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00003540}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00003540}, {449,0.00000000}, {450,0.00003540}, {451,0.00003540}, {452,0.00002655}, {453,0.00000000}, {454,0.00000000}, {455,0.00003540}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00002655}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00003540}, {469,0.00000000}, {470,0.00003540}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00003540}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00003540}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00002655}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00003540}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00002655}, {585,0.00003540}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00002655}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00002655}, {650,0.00003540}, {655,0.00000000}, {660,0.00003540}, {665,0.00003540}, {670,0.00007080}, {675,0.00000000}, {680,0.00000000}, {685,0.00003540}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00003540}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00003540}, {765,0.00000000}, {770,0.00003540}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00003540}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00003571}, {820,0.00007143}, {825,0.00000000}, {830,0.00000000}, {835,0.00007143}, {840,0.00000000}, {845,0.00009821}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00003571}, {885,0.00003571}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00003571}, {930,0.00000000}, {935,0.00003571}, {940,0.00003571}, {945,0.00003571}, {950,0.00003571}, {955,0.00000000}, {960,0.00003571}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00003571}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00003571}, {1010,0.00003571}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00003571}, {1100,0.00003571}, {1110,0.00000000}, {1120,0.00003571}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00002679}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00006250}, {1300,0.00003571}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00003571}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00003571}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00003571}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00003571}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00003571}, {1480,0.00003571}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00003571}, {1550,0.00000000}, {1560,0.00003571}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00003571}, {1620,0.00000000}, {1630,0.00003571}, {1640,0.00000000}, {1650,0.00007143}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00003571}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00007143}, {1740,0.00003571}, {1750,0.00003571}, {1760,0.00003571}, {1770,0.00003571}, {1780,0.00000000}, {1790,0.00003571}, {1800,0.00000000}, {1810,0.00003571}, {1820,0.00000000}, {1830,0.00002679}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00003571}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00003571}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00002679}, {2700,0.00000000}, {2750,0.00003571}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00003571}, {3100,0.00009821}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00003571}, {3300,0.00000000}, {3350,0.00003571}, {3400,0.00000000}, {3450,0.00000000}, {3500,0.00002679}, {3550,0.00000000}, {3600,0.00000000}, {3650,0.00007143}, {3700,0.00002679}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00003571}, {3950,0.00002679}, {4000,0.00006250}, {4050,0.00003571}, {4100,0.00003571}, {4150,0.00000000}, {4200,0.00000000}, {4250,0.00017857}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00003571}, {4500,0.00000000}, {4550,0.00002679}, {4600,0.00002679}, {4650,0.00000000}, {4700,0.00003571}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00007143}, {4900,0.00003571}, {4950,0.00014286}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00002679}, {5150,0.00007143}, {5200,0.00003571}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00014286}, {5400,0.00000000}, {5450,0.00000000}, {5500,0.00000000}, {5550,0.00002679}, {5600,0.00000000}, {5650,0.00000000}, {5700,0.00003571}, {5750,0.00003571}, {5800,0.00000000}, {5850,0.00006250}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00000000}, {6150,0.00000000}, {6200,0.00000000}, {6250,0.00007143}, {6300,0.00003571}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00003571}, {6550,0.00003571}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00000000}, {6850,0.00003571}, {6900,0.00031250}, {6950,0.00003571}, {7000,0.00003571}, {7050,0.00003571}, {7100,0.00000000}, {7150,0.00000000}, {7200,0.00020536}, {7250,0.00000000}, {7300,0.00000000}, {7350,0.00000000}, {7400,0.00000000}, {7450,0.00003571}, {7500,0.00031250}, {7550,0.00003571}, {7600,0.00000000}, {7650,0.00006250}, {7700,0.00000000}, {7750,0.00000000}, {7800,0.00025000}, {7850,0.00039286}, {7900,0.00003571}, {7950,0.00003571}, {8000,0.00000000}, {8050,0.00003571}, {8100,0.00003571}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00000000}, {8300,0.00007143}, {8350,0.00000000}, {8400,0.00002679}, {8450,0.00048214}, {8500,0.00039286}, {8550,0.00000000}, {8600,0.00006250}, {8650,0.00007143}, {8700,0.00000000}, {8750,0.00035714}, {8800,0.00007143}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00094643}, {9000,0.00003571}, {9050,0.00000000}, {9100,0.00014286}, {9150,0.00000000}, {9200,0.00000000}, {9250,0.00027679}, {9300,0.00000000}, {9350,0.00000000}, {9400,0.00000000}, {9450,0.00003571}, {9500,0.00000000}, {9550,0.00000000}, {9600,0.00003571}, {9650,0.00000000}, {9700,0.00007143}, {9750,0.00000000}, {9800,0.00000000}, {9850,0.00000000}, {9900,0.00009821}, {9950,0.00000000}, {10000,0.00000000}, {10100,0.00003571}, {10200,0.00003571}, {10300,0.00003571}, {10400,0.00003571}, {10500,0.00000000}, {10600,0.00007143}, {10700,0.00000000}, {10800,0.00000000}, {10900,0.00007143}, {11000,0.00000000}, {11100,0.00003571}, {11200,0.00000000}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00000000}, {11700,0.00003571}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00003571}, {12200,0.00003571}, {12300,0.00000000}, {12400,0.00002679}, {12500,0.00003571}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00100}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00100}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00100}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00100}, {18800,0.00000}, {18900,0.00000}, {19000,0.00000}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00000}, {19500,0.00175}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["parsing"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00001724}, {12,0.00000862}, {13,0.00029310}, {14,0.00062931}, {15,0.00093966}, {16,0.00098276}, {17,0.00100000}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00100000}, {23,0.00100000}, {24,0.00100000}, {25,0.00100000}, {26,0.00100862}, {27,0.00100000}, {28,0.00112069}, {29,0.00108621}, {30,0.00137069}, {31,0.00137069}, {32,0.00162069}, {33,0.00300000}, {34,0.00188793}, {35,0.00200000}, {36,0.05306897}, {37,0.00200000}, {38,0.00200000}, {39,0.00200000}, {40,0.00200000}, {41,0.00200000}, {42,0.00200000}, {43,0.00200000}, {44,0.00200000}, {45,0.00200000}, {46,0.00200000}, {47,0.00200000}, {48,0.00200000}, {49,0.00200862}, {50,0.00200862}, {51,0.00202586}, {52,0.00212931}, {53,0.00254310}, {54,0.00283621}, {55,0.00298276}, {56,0.00300000}, {57,0.00300000}, {58,0.00300000}, {59,0.00300000}, {60,0.00300000}, {61,0.00300000}, {62,0.00300000}, {63,0.00300000}, {64,0.05392241}, {65,0.00300000}, {66,0.00300862}, {67,0.00304310}, {68,0.00302586}, {69,0.00318103}, {70,0.00347414}, {71,0.00353448}, {72,0.00393966}, {73,0.00398276}, {74,0.00400000}, {75,0.00400000}, {76,0.00400000}, {77,0.00400000}, {78,0.00400000}, {79,0.00400000}, {80,0.00400000}, {81,0.00400000}, {82,0.00400000}, {83,0.00400000}, {84,0.00403448}, {85,0.00413793}, {86,0.00421552}, {87,0.00475862}, {88,0.00488793}, {89,0.00486207}, {90,0.00498276}, {91,0.00500000}, {92,0.00500000}, {93,0.00500000}, {94,0.00500000}, {95,0.00500000}, {96,0.00500000}, {97,0.00500000}, {98,0.01676724}, {99,0.05568103}, {100,0.00500862}, {101,0.00518103}, {102,0.00540517}, {103,0.00569828}, {104,0.00549138}, {105,0.00535345}, {106,0.00566379}, {107,0.00595690}, {108,0.00599138}, {109,0.00600000}, {110,0.00599138}, {111,0.00600000}, {112,0.00600000}, {113,0.00600000}, {114,0.00600000}, {115,0.00600000}, {116,0.00600862}, {117,0.00600862}, {118,0.00601724}, {119,0.00606897}, {120,0.00646552}, {121,0.00668966}, {122,0.00685345}, {123,0.00689655}, {124,0.00684483}, {125,0.03764655}, {126,0.00698276}, {127,0.00698276}, {128,0.00699138}, {129,0.00700000}, {130,0.00700000}, {131,0.00700000}, {132,0.00700000}, {133,0.00702586}, {134,0.00702586}, {135,0.00709483}, {136,0.03979310}, {137,0.00726724}, {138,0.00777586}, {139,0.00787931}, {140,0.00737931}, {141,0.00725000}, {142,0.00756034}, {143,0.00799138}, {144,0.00795690}, {145,0.00797414}, {146,0.04404310}, {147,0.00799138}, {148,0.00799138}, {149,0.00800000}, {150,0.00800000}, {151,0.00800000}, {152,0.00800000}, {153,0.00800000}, {154,0.00801724}, {155,0.00801724}, {156,0.03825862}, {157,0.00800000}, {158,0.00804310}, {159,0.00819828}, {160,0.00866379}, {161,0.00870690}, {162,0.00887069}, {163,0.00878448}, {164,0.00893966}, {165,0.03956034}, {166,0.00900000}, {167,0.00900000}, {168,0.00900000}, {169,0.00900000}, {170,0.00900862}, {171,0.00901724}, {172,0.00900862}, {173,0.00900000}, {174,0.00903448}, {175,0.00907759}, {176,0.00905172}, {177,0.00934483}, {178,0.00932759}, {179,0.00931897}, {180,0.00981034}, {181,0.00994828}, {182,0.04349138}, {183,0.00993966}, {184,0.00999138}, {185,0.01000000}, {186,0.01000000}, {187,0.00999138}, {188,0.01000000}, {189,0.01000000}, {190,0.04440517}, {191,0.01000862}, {192,0.01000000}, {193,0.01013793}, {194,0.01050000}, {195,0.01060345}, {196,0.01063793}, {197,0.01027586}, {198,0.01081897}, {199,0.01070690}, {200,0.01081897}, {201,0.01093966}, {202,0.01099138}, {203,0.01100000}, {204,0.01100000}, {205,0.01100000}, {206,0.01100000}, {207,0.01100000}, {208,0.01100862}, {209,0.01100000}, {210,0.01101724}, {211,0.01102586}, {212,0.01186207}, {213,0.01189655}, {214,0.01197414}, {215,0.01199138}, {216,0.01199138}, {217,0.01198276}, {218,0.01200862}, {219,0.01200000}, {220,0.01200000}, {221,0.01200000}, {222,0.01200000}, {223,0.01201724}, {224,0.01207759}, {225,0.05762931}, {226,0.01240517}, {227,0.01256034}, {228,0.01244828}, {229,0.01264655}, {230,0.01282759}, {231,0.01293966}, {232,0.01292241}, {233,0.01298276}, {234,0.01299138}, {235,0.01300000}, {236,0.01300000}, {237,0.01301724}, {238,0.04280172}, {239,0.01300000}, {240,0.01304310}, {241,0.01302586}, {242,0.01306897}, {243,0.01312931}, {244,0.04774138}, {245,0.01316379}, {246,0.01362069}, {247,0.01390517}, {248,0.01378448}, {249,0.01362931}, {250,0.04441379}, {251,0.01391379}, {252,0.01394828}, {253,0.01397414}, {254,0.01399138}, {255,0.01400000}, {256,0.05812931}, {257,0.01401724}, {258,0.01403448}, {259,0.01401724}, {260,0.01402586}, {261,0.01421552}, {262,0.01443103}, {263,0.01465517}, {264,0.01469828}, {265,0.01476724}, {266,0.01478448}, {267,0.05667241}, {268,0.01495690}, {269,0.01499138}, {270,0.01498276}, {271,0.01500000}, {272,0.01500000}, {273,0.01500000}, {274,0.01501724}, {275,0.01507759}, {276,0.01509483}, {277,0.01531897}, {278,0.04813793}, {279,0.01528448}, {280,0.01543103}, {281,0.01547414}, {282,0.01503448}, {283,0.01503448}, {284,0.01501724}, {285,0.01506034}, {286,0.01512931}, {287,0.01524138}, {288,0.04181034}, {289,0.01561207}, {290,0.01566379}, {291,0.01576724}, {292,0.01586207}, {293,0.04589655}, {294,0.01597414}, {295,0.01599138}, {296,0.01600000}, {297,0.01600862}, {298,0.04493103}, {299,0.01600000}, {300,0.01601724}, {301,0.01600862}, {302,0.01602586}, {303,0.04791379}, {304,0.01603448}, {305,0.01622414}, {306,0.01633621}, {307,0.01639655}, {308,0.01661207}, {309,0.01666379}, {310,0.01674138}, {311,0.01691379}, {312,0.01690517}, {313,0.01696552}, {314,0.01698276}, {315,0.01697414}, {316,0.01700000}, {317,0.04734483}, {318,0.01700000}, {319,0.01700862}, {320,0.01700862}, {321,0.01706034}, {322,0.04856897}, {323,0.01713793}, {324,0.01735345}, {325,0.01734483}, {326,0.01758621}, {327,0.01756034}, {328,0.01775862}, {329,0.01789655}, {330,0.01791379}, {331,0.05019828}, {332,0.01796552}, {333,0.01799138}, {334,0.01800000}, {335,0.01800862}, {336,0.01800862}, {337,0.01800000}, {338,0.01800862}, {339,0.01802586}, {340,0.05068966}, {341,0.01812931}, {342,0.01814655}, {343,0.01828448}, {344,0.05074138}, {345,0.01841379}, {346,0.01860345}, {347,0.01878448}, {348,0.01884483}, {349,0.01885345}, {350,0.01891379}, {351,0.01893103}, {352,0.01899138}, {353,0.01937931}, {354,0.01948276}, {355,0.01960345}, {356,0.01979310}, {357,0.06564655}, {358,0.01986207}, {359,0.01990517}, {360,0.01994828}, {361,0.07725862}, {362,0.01997414}, {363,0.01998276}, {364,0.02002586}, {365,0.05318966}, {366,0.02007759}, {367,0.02012069}, {368,0.02017241}, {369,0.05262931}, {370,0.02019828}, {371,0.02043966}, {372,0.02046552}, {373,0.05270690}, {374,0.02078448}, {375,0.02079310}, {376,0.02080172}, {377,0.05561207}, {378,0.02093103}, {379,0.02093103}, {380,0.02097414}, {381,0.07463793}, {382,0.02100862}, {383,0.02099138}, {384,0.02100862}, {385,0.08168966}, {386,0.02112931}, {387,0.02125862}, {388,0.02141379}, {389,0.02149138}, {390,0.02150000}, {391,0.02175000}, {392,0.02179310}, {393,0.02174138}, {394,0.02185345}, {395,0.02187069}, {396,0.02193966}, {397,0.02193103}, {398,0.02200000}, {399,0.43366379}, {400,0.02121552}, {401,0.02136207}, {402,0.02159483}, {403,0.04964655}, {404,0.02172414}, {405,0.02180172}, {406,0.02189655}, {407,0.02190517}, {408,0.02194828}, {409,0.02197414}, {410,0.04852586}, {411,0.02200862}, {412,0.02201724}, {413,0.02203448}, {414,0.05203448}, {415,0.02206034}, {416,0.02206034}, {417,0.02208621}, {418,0.02234483}, {419,0.02235345}, {420,0.02247414}, {421,0.05406034}, {422,0.02268966}, {423,0.02275000}, {424,0.02285345}, {425,0.02283621}, {426,0.02287931}, {427,0.02296552}, {428,0.05279310}, {429,0.02299138}, {430,0.02299138}, {431,0.02301724}, {432,0.02300862}, {433,0.02303448}, {434,0.02307759}, {435,0.05302586}, {436,0.02321552}, {437,0.02318966}, {438,0.05401724}, {439,0.02337069}, {440,0.02354310}, {441,0.02370690}, {442,0.02375862}, {443,0.02379310}, {444,0.02390517}, {445,0.05327586}, {446,0.02393966}, {447,0.02397414}, {448,0.05415517}, {449,0.02400862}, {450,0.02401724}, {451,0.02402586}, {452,0.02406034}, {453,0.02412069}, {454,0.02412931}, {455,0.05460345}, {456,0.02437069}, {457,0.02428448}, {458,0.05762931}, {459,0.02456034}, {460,0.02469828}, {461,0.02479310}, {462,0.02484483}, {463,0.02487931}, {464,0.02491379}, {465,0.02495690}, {466,0.02497414}, {467,0.02500000}, {468,0.05435345}, {469,0.02500862}, {470,0.02501724}, {471,0.05183621}, {472,0.02508621}, {473,0.02518103}, {474,0.10650862}, {475,0.02604310}, {476,0.02600862}, {477,0.09671552}, {478,0.02620690}, {479,0.02619828}, {480,0.02638793}, {481,0.02639655}, {482,0.02648276}, {483,0.02670690}, {484,0.02666379}, {485,0.02677586}, {486,0.02680172}, {487,0.02681034}, {488,0.02687931}, {489,0.02687931}, {490,0.02693103}, {491,0.02694828}, {492,0.02698276}, {493,0.02702586}, {494,0.02702586}, {495,0.02706034}, {496,0.02716379}, {497,0.02707759}, {498,0.02723276}, {499,0.02743966}, {500,0.027445887}, {505,0.02782609}, {510,0.02797391}, {515,0.02855652}, {520,0.02886957}, {525,0.02902609}, {530,0.02924348}, {535,0.02969565}, {540,0.02988696}, {545,0.09566087}, {550,0.03046087}, {555,0.03085217}, {560,0.08988696}, {565,0.03118421}, {570,0.03164912}, {575,0.03181579}, {580,0.03201754}, {585,0.09185088}, {590,0.03270175}, {595,0.03288596}, {600,0.03307826}, {605,0.03350877}, {610,0.09338596}, {615,0.03396491}, {620,0.03414035}, {625,0.03458772}, {630,0.03487719}, {635,0.06452632}, {640,0.03559649}, {645,0.07037719}, {650,0.03593860}, {655,0.03625439}, {660,0.03658772}, {665,0.03683333}, {670,0.03702632}, {675,0.03731579}, {680,0.06914035}, {685,0.03787719}, {690,0.06946491}, {695,0.03856140}, {700,0.07136522}, {705,0.03895614}, {710,0.07475439}, {715,0.03964035}, {720,0.03982456}, {725,0.04003509}, {730,0.04032456}, {735,0.04072807}, {740,0.04094737}, {745,0.04108772}, {750,0.04153509}, {755,0.04179825}, {760,0.04195614}, {765,0.04100877}, {770,0.59543860}, {775,0.16792982}, {780,0.04222807}, {785,0.07750877}, {790,0.04269298}, {795,0.07768421}, {800,0.04308696}, {805,0.07581579}, {810,0.04373684}, {815,0.04392105}, {820,0.04412281}, {825,0.04441228}, {830,0.04478947}, {835,0.04497368}, {840,0.08016667}, {845,0.04549123}, {850,0.07754386}, {855,0.04595614}, {860,0.04626316}, {865,0.07644737}, {870,0.04683333}, {875,0.08291228}, {880,0.04733333}, {885,0.04771930}, {890,0.04792982}, {895,0.04814912}, {900,0.08585217}, {905,0.04875439}, {910,0.04891228}, {915,0.08199123}, {920,0.04949123}, {925,0.08450000}, {930,0.05004386}, {935,0.05166667}, {940,0.09599123}, {945,0.05203509}, {950,0.05246491}, {955,0.08544737}, {960,0.05300000}, {965,0.05327193}, {970,0.08724561}, {975,0.05383333}, {980,0.05400877}, {985,0.11636842}, {990,0.05470175}, {995,0.05484211}, {1000,0.12188696}, {1010,0.10900}, {1020,0.05425}, {1030,0.05675}, {1040,0.09975}, {1050,0.06850}, {1060,0.05850}, {1070,0.08550}, {1080,0.09100}, {1090,0.06025}, {1100,0.05925}, {1110,0.08350}, {1120,0.08625}, {1130,0.06075}, {1140,0.06175}, {1150,0.09000}, {1160,0.09750}, {1170,0.06300}, {1180,0.06375}, {1190,0.06375}, {1200,0.12000}, {1210,0.10925}, {1220,0.11125}, {1230,0.06800}, {1240,0.06850}, {1250,0.06925}, {1260,0.10300}, {1270,0.11250}, {1280,0.10600}, {1290,0.07150}, {1300,0.07200}, {1310,0.07250}, {1320,0.07100}, {1330,0.10025}, {1340,0.10375}, {1350,0.16300}, {1360,0.10725}, {1370,0.10925}, {1380,0.11125}, {1390,0.10775}, {1400,0.07575}, {1410,0.07775}, {1420,0.07850}, {1430,0.07900}, {1440,0.07950}, {1450,0.08025}, {1460,0.08025}, {1470,0.08150}, {1480,0.08200}, {1490,0.08250}, {1500,0.09380}, {1510,0.08350}, {1520,0.08475}, {1530,0.08500}, {1540,0.08475}, {1550,0.08625}, {1560,0.08400}, {1570,0.08450}, {1580,0.08550}, {1590,0.12150}, {1600,0.12725}, {1610,0.13275}, {1620,0.24900}, {1630,0.10900}, {1640,0.08850}, {1650,0.09075}, {1660,0.09125}, {1670,0.12825}, {1680,0.13250}, {1690,0.14875}, {1700,0.15325}, {1710,0.14450}, {1720,0.09500}, {1730,0.09450}, {1740,0.15350}, {1750,0.17900}, {1760,0.16700}, {1770,0.13025}, {1780,0.09800}, {1790,0.09825}, {1800,0.15000}, {1810,0.14600}, {1820,0.13300}, {1830,0.09800}, {1840,0.12900}, {1850,0.14550}, {1860,0.14000}, {1870,0.10050}, {1880,0.12925}, {1890,0.14950}, {1900,0.14225}, {1910,0.10250}, {1920,0.12875}, {1930,0.14150}, {1940,0.12525}, {1950,0.13275}, {1960,0.14725}, {1970,0.13600}, {1980,0.10575}, {1990,0.17025}, {2000,0.13620}, {2050,0.16225}, {2100,0.18000}, {2150,0.11950}, {2200,0.16175}, {2250,1.35075}, {2300,0.12750}, {2350,0.17200}, {2400,0.17175}, {2450,0.18450}, {2500,0.17780}, {2550,0.17375}, {2600,0.18175}, {2650,0.18400}, {2700,0.18075}, {2750,0.18800}, {2800,0.19425}, {2850,0.19800}, {2900,0.20275}, {2950,0.23800}, {3000,0.20660}, {3050,0.20575}, {3100,0.21075}, {3150,0.21225}, {3200,0.22125}, {3250,0.29525}, {3300,0.22975}, {3350,0.28025}, {3400,0.28450}, {3450,0.26450}, {3500,0.32400}, {3550,0.29300}, {3600,0.32125}, {3650,0.30525}, {3700,0.27550}, {3750,0.26325}, {3800,0.27150}, {3850,0.26725}, {3900,0.27700}, {3950,0.26200}, {4000,0.27520}, {4050,0.27225}, {4100,0.28000}, {4150,0.27150}, {4200,0.28550}, {4250,0.28875}, {4300,0.29950}, {4350,0.29325}, {4400,0.29925}, {4450,0.30250}, {4500,0.31220}, {4550,0.30600}, {4600,1.78550}, {4650,0.31950}, {4700,0.39275}, {4750,0.38575}, {4800,0.41000}, {4850,0.38325}, {4900,0.41100}, {4950,0.39525}, {5000,0.34240}};
data["big_flat"]["parsing"]["Stats"]["user"] = {{1,0.00000000}, {2,0.00002586}, {3,0.00032759}, {4,0.00031897}, {5,0.00024138}, {6,0.00046552}, {7,0.00050862}, {8,0.00078448}, {9,0.00062069}, {10,0.00077586}, {11,0.00066379}, {12,0.00088793}, {13,0.00080172}, {14,0.00093103}, {15,0.00125000}, {16,0.00089655}, {17,0.00100000}, {18,0.00118966}, {19,0.00120690}, {20,0.00131034}, {21,0.00141379}, {22,0.00157759}, {23,0.00155172}, {24,0.00150000}, {25,0.00160345}, {26,0.00183621}, {27,0.00185345}, {28,0.00169828}, {29,0.00162069}, {30,0.00133621}, {31,0.00166379}, {32,0.00178448}, {33,0.00323276}, {34,0.00170690}, {35,0.00218103}, {36,0.05109483}, {37,0.00212069}, {38,0.00206897}, {39,0.00209483}, {40,0.00233621}, {41,0.00224138}, {42,0.00224138}, {43,0.00250000}, {44,0.00236207}, {45,0.00255172}, {46,0.00268103}, {47,0.00247414}, {48,0.00243966}, {49,0.00253448}, {50,0.00277586}, {51,0.00302586}, {52,0.00300000}, {53,0.00286207}, {54,0.00324138}, {55,0.00292241}, {56,0.00312069}, {57,0.00319828}, {58,0.00327586}, {59,0.00324138}, {60,0.00327586}, {61,0.00330172}, {62,0.00331034}, {63,0.00330172}, {64,0.05393966}, {65,0.00377586}, {66,0.00384483}, {67,0.00373276}, {68,0.00364655}, {69,0.00389655}, {70,0.00381897}, {71,0.00394828}, {72,0.00406897}, {73,0.00417241}, {74,0.00419828}, {75,0.00423276}, {76,0.00431034}, {77,0.00434483}, {78,0.00437931}, {79,0.00443966}, {80,0.00450000}, {81,0.00444828}, {82,0.00436207}, {83,0.00483621}, {84,0.00475862}, {85,0.00451724}, {86,0.00509483}, {87,0.00473276}, {88,0.00492241}, {89,0.00516379}, {90,0.00524138}, {91,0.00510345}, {92,0.00520690}, {93,0.00529310}, {94,0.00519828}, {95,0.00537931}, {96,0.00548276}, {97,0.00562069}, {98,0.01737931}, {99,0.05550862}, {100,0.00558621}, {101,0.00559483}, {102,0.00556034}, {103,0.00600000}, {104,0.00629310}, {105,0.00615517}, {106,0.00611207}, {107,0.00616379}, {108,0.00568966}, {109,0.00606897}, {110,0.00648276}, {111,0.00613793}, {112,0.00634483}, {113,0.00639655}, {114,0.00650000}, {115,0.00651724}, {116,0.00643103}, {117,0.00658621}, {118,0.00663793}, {119,0.00659483}, {120,0.00677586}, {121,0.00688793}, {122,0.00703448}, {123,0.00710345}, {124,0.00706897}, {125,0.03755172}, {126,0.00706897}, {127,0.00748276}, {128,0.00734483}, {129,0.00744828}, {130,0.00737931}, {131,0.00758621}, {132,0.00751724}, {133,0.00779310}, {134,0.00771552}, {135,0.00766379}, {136,0.03905172}, {137,0.00773276}, {138,0.00812069}, {139,0.00798276}, {140,0.00772414}, {141,0.00782759}, {142,0.00795690}, {143,0.00816379}, {144,0.00823276}, {145,0.00811207}, {146,0.04338793}, {147,0.00817241}, {148,0.00848276}, {149,0.00824138}, {150,0.00827586}, {151,0.00848276}, {152,0.00844828}, {153,0.00813793}, {154,0.00865517}, {155,0.00872414}, {156,0.03834483}, {157,0.00865517}, {158,0.00879310}, {159,0.00888793}, {160,0.00906897}, {161,0.00898276}, {162,0.00888793}, {163,0.00877586}, {164,0.00893966}, {165,0.03937069}, {166,0.00928448}, {167,0.00931034}, {168,0.00935345}, {169,0.00926724}, {170,0.00910345}, {171,0.00968966}, {172,0.00979310}, {173,0.00993103}, {174,0.00968966}, {175,0.00993103}, {176,0.01006897}, {177,0.01006897}, {178,0.00979310}, {179,0.00965517}, {180,0.00974138}, {181,0.01002586}, {182,0.04305172}, {183,0.00974138}, {184,0.00989655}, {185,0.01018966}, {186,0.01016379}, {187,0.01030172}, {188,0.01031897}, {189,0.01029310}, {190,0.04461207}, {191,0.01043966}, {192,0.01057759}, {193,0.01089655}, {194,0.01096552}, {195,0.01106897}, {196,0.01082759}, {197,0.01086207}, {198,0.01082759}, {199,0.01083621}, {200,0.01085345}, {201,0.01096552}, {202,0.01098276}, {203,0.01140517}, {204,0.01120690}, {205,0.01112069}, {206,0.01108621}, {207,0.01151724}, {208,0.01171552}, {209,0.01148276}, {210,0.01168966}, {211,0.01165517}, {212,0.01196552}, {213,0.01190517}, {214,0.01191379}, {215,0.01200000}, {216,0.01177586}, {217,0.01194828}, {218,0.01193966}, {219,0.01214655}, {220,0.01267241}, {221,0.01245690}, {222,0.01240517}, {223,0.01270690}, {224,0.01278448}, {225,0.05731897}, {226,0.01217241}, {227,0.01261207}, {228,0.01244828}, {229,0.01242241}, {230,0.01263793}, {231,0.01253448}, {232,0.01265517}, {233,0.01292241}, {234,0.01299138}, {235,0.01283621}, {236,0.01300000}, {237,0.01306897}, {238,0.04261207}, {239,0.01295690}, {240,0.01330172}, {241,0.01324138}, {242,0.01331897}, {243,0.01337931}, {244,0.04741379}, {245,0.01364655}, {246,0.01358621}, {247,0.01390517}, {248,0.01388793}, {249,0.01372414}, {250,0.04443103}, {251,0.01409483}, {252,0.01357759}, {253,0.01394828}, {254,0.01389655}, {255,0.01408621}, {256,0.05778448}, {257,0.01427586}, {258,0.01447414}, {259,0.01453448}, {260,0.01460345}, {261,0.01459483}, {262,0.01506897}, {263,0.01439655}, {264,0.01486207}, {265,0.01487069}, {266,0.01478448}, {267,0.05624138}, {268,0.01467241}, {269,0.01527586}, {270,0.01502586}, {271,0.01507759}, {272,0.01537931}, {273,0.01537069}, {274,0.01527586}, {275,0.01538793}, {276,0.01549138}, {277,0.01579310}, {278,0.04821552}, {279,0.01573276}, {280,0.01581034}, {281,0.01590517}, {282,0.01550000}, {283,0.01548276}, {284,0.01559483}, {285,0.01564655}, {286,0.01580172}, {287,0.01583621}, {288,0.04157759}, {289,0.01574138}, {290,0.01593103}, {291,0.01587931}, {292,0.01608621}, {293,0.04550862}, {294,0.01610345}, {295,0.01631897}, {296,0.01629310}, {297,0.01628448}, {298,0.04433621}, {299,0.01637931}, {300,0.01643966}, {301,0.01635345}, {302,0.01625862}, {303,0.04697414}, {304,0.01647414}, {305,0.01662931}, {306,0.01673276}, {307,0.01635345}, {308,0.01662069}, {309,0.01680172}, {310,0.01660345}, {311,0.01710345}, {312,0.01698276}, {313,0.01689655}, {314,0.01689655}, {315,0.01694828}, {316,0.01707759}, {317,0.04696552}, {318,0.01710345}, {319,0.01733621}, {320,0.01706034}, {321,0.01726724}, {322,0.04831034}, {323,0.01747414}, {324,0.01731034}, {325,0.01735345}, {326,0.01763793}, {327,0.01748276}, {328,0.01752586}, {329,0.01775862}, {330,0.01778448}, {331,0.04980172}, {332,0.01773276}, {333,0.01787069}, {334,0.01797414}, {335,0.01820690}, {336,0.01808621}, {337,0.01806034}, {338,0.01790517}, {339,0.01801724}, {340,0.05003448}, {341,0.01809483}, {342,0.01831034}, {343,0.01814655}, {344,0.05012069}, {345,0.01816379}, {346,0.01831034}, {347,0.01850862}, {348,0.01844828}, {349,0.01840517}, {350,0.01850862}, {351,0.01854310}, {352,0.01844828}, {353,0.01906897}, {354,0.01919828}, {355,0.01924138}, {356,0.01950862}, {357,0.06552586}, {358,0.01932759}, {359,0.01930172}, {360,0.01943966}, {361,0.07721552}, {362,0.01946552}, {363,0.01943966}, {364,0.01984483}, {365,0.05230172}, {366,0.01983621}, {367,0.02000000}, {368,0.01981034}, {369,0.05194828}, {370,0.01981034}, {371,0.02008621}, {372,0.02000000}, {373,0.05219828}, {374,0.01995690}, {375,0.02000000}, {376,0.02079310}, {377,0.05468966}, {378,0.02034483}, {379,0.02051724}, {380,0.02057759}, {381,0.07412069}, {382,0.02027586}, {383,0.02111207}, {384,0.02106034}, {385,0.08083621}, {386,0.02112931}, {387,0.02069828}, {388,0.02075862}, {389,0.02121552}, {390,0.02143103}, {391,0.02153448}, {392,0.02158621}, {393,0.02126724}, {394,0.02123276}, {395,0.02141379}, {396,0.02150862}, {397,0.02168966}, {398,0.02173276}, {399,0.42562069}, {400,0.02039655}, {401,0.02089655}, {402,0.02129310}, {403,0.04884483}, {404,0.02165517}, {405,0.02191379}, {406,0.02144828}, {407,0.02119828}, {408,0.02150000}, {409,0.02150000}, {410,0.04782759}, {411,0.02159483}, {412,0.02187931}, {413,0.02184483}, {414,0.05107759}, {415,0.02143966}, {416,0.02200000}, {417,0.02181897}, {418,0.02208621}, {419,0.02212931}, {420,0.02211207}, {421,0.05366379}, {422,0.02237069}, {423,0.02250862}, {424,0.02205172}, {425,0.02235345}, {426,0.02225000}, {427,0.02281897}, {428,0.05218103}, {429,0.02248276}, {430,0.02278448}, {431,0.02294828}, {432,0.02290517}, {433,0.02310345}, {434,0.02278448}, {435,0.05265517}, {436,0.02328448}, {437,0.02289655}, {438,0.05333621}, {439,0.02328448}, {440,0.02332759}, {441,0.02343966}, {442,0.02337069}, {443,0.02360345}, {444,0.02404310}, {445,0.05246552}, {446,0.02368103}, {447,0.02366379}, {448,0.05356034}, {449,0.02376724}, {450,0.02376724}, {451,0.02381897}, {452,0.02425000}, {453,0.02444828}, {454,0.02429310}, {455,0.05402586}, {456,0.02416379}, {457,0.02430172}, {458,0.05695690}, {459,0.02445690}, {460,0.02468966}, {461,0.02450000}, {462,0.02442241}, {463,0.02464655}, {464,0.02468966}, {465,0.02477586}, {466,0.02463793}, {467,0.02503448}, {468,0.05444828}, {469,0.02463793}, {470,0.02530172}, {471,0.05144828}, {472,0.02519828}, {473,0.02500862}, {474,0.10595690}, {475,0.02590517}, {476,0.02600862}, {477,0.09630172}, {478,0.02612931}, {479,0.02622414}, {480,0.02634483}, {481,0.02630172}, {482,0.02656034}, {483,0.02647414}, {484,0.02646552}, {485,0.02643966}, {486,0.02653448}, {487,0.02668966}, {488,0.02675000}, {489,0.02665517}, {490,0.02681897}, {491,0.02687931}, {492,0.02672414}, {493,0.02668966}, {494,0.02687931}, {495,0.02693103}, {496,0.02699138}, {497,0.02710345}, {498,0.02715517}, {499,0.02734483}, {500,0.027030303}, {505,0.02737391}, {510,0.02774783}, {515,0.02837391}, {520,0.02875652}, {525,0.02893043}, {530,0.02913913}, {535,0.02936522}, {540,0.02982609}, {545,0.09458261}, {550,0.03043478}, {555,0.03086957}, {560,0.08890435}, {565,0.03133333}, {570,0.03180702}, {575,0.03200877}, {580,0.03202632}, {585,0.09111404}, {590,0.03292105}, {595,0.03306140}, {600,0.03321739}, {605,0.03350000}, {610,0.09278947}, {615,0.03406140}, {620,0.03424561}, {625,0.03446491}, {630,0.03487719}, {635,0.06383333}, {640,0.03541228}, {645,0.06981579}, {650,0.03571053}, {655,0.03600000}, {660,0.03634211}, {665,0.03663158}, {670,0.03671930}, {675,0.03717544}, {680,0.06853509}, {685,0.03726316}, {690,0.06852632}, {695,0.03830702}, {700,0.07066957}, {705,0.03848246}, {710,0.07433333}, {715,0.03907895}, {720,0.03939474}, {725,0.03969298}, {730,0.04014035}, {735,0.04013158}, {740,0.04067544}, {745,0.04104386}, {750,0.04144737}, {755,0.04157018}, {760,0.04191228}, {765,0.04074561}, {770,0.58740351}, {775,0.16233333}, {780,0.04177193}, {785,0.07628947}, {790,0.04264912}, {795,0.07656140}, {800,0.04300870}, {805,0.07492105}, {810,0.04373684}, {815,0.04402632}, {820,0.04440351}, {825,0.04436842}, {830,0.04446491}, {835,0.04493860}, {840,0.07882456}, {845,0.04539474}, {850,0.07685965}, {855,0.04597368}, {860,0.04604386}, {865,0.07623684}, {870,0.04669298}, {875,0.08211404}, {880,0.04722807}, {885,0.04751754}, {890,0.04764912}, {895,0.04803509}, {900,0.08586087}, {905,0.04797368}, {910,0.04861404}, {915,0.08122807}, {920,0.04931579}, {925,0.08376316}, {930,0.04944737}, {935,0.05089474}, {940,0.09518421}, {945,0.05152632}, {950,0.05185088}, {955,0.08456140}, {960,0.05225439}, {965,0.05284211}, {970,0.08638596}, {975,0.05343860}, {980,0.05333333}, {985,0.11570175}, {990,0.05424561}, {995,0.05453509}, {1000,0.12090435}, {1010,0.10250}, {1020,0.05475}, {1030,0.05725}, {1040,0.09625}, {1050,0.06750}, {1060,0.05975}, {1070,0.08475}, {1080,0.08850}, {1090,0.06100}, {1100,0.05950}, {1110,0.08250}, {1120,0.08600}, {1130,0.06100}, {1140,0.06200}, {1150,0.09000}, {1160,0.09575}, {1170,0.06250}, {1180,0.06400}, {1190,0.06400}, {1200,0.11650}, {1210,0.10875}, {1220,0.10900}, {1230,0.06800}, {1240,0.06750}, {1250,0.06775}, {1260,0.10275}, {1270,0.11200}, {1280,0.10425}, {1290,0.07075}, {1300,0.07175}, {1310,0.07300}, {1320,0.07175}, {1330,0.09900}, {1340,0.10175}, {1350,0.16050}, {1360,0.10550}, {1370,0.10950}, {1380,0.10975}, {1390,0.10700}, {1400,0.07575}, {1410,0.07775}, {1420,0.07825}, {1430,0.08000}, {1440,0.08075}, {1450,0.07950}, {1460,0.08000}, {1470,0.08100}, {1480,0.08150}, {1490,0.08150}, {1500,0.09320}, {1510,0.08150}, {1520,0.08400}, {1530,0.08550}, {1540,0.08400}, {1550,0.08750}, {1560,0.08350}, {1570,0.08400}, {1580,0.08700}, {1590,0.12075}, {1600,0.12550}, {1610,0.12925}, {1620,0.24425}, {1630,0.10650}, {1640,0.08750}, {1650,0.08750}, {1660,0.09250}, {1670,0.12700}, {1680,0.13100}, {1690,0.14450}, {1700,0.14525}, {1710,0.14025}, {1720,0.09600}, {1730,0.09375}, {1740,0.14975}, {1750,0.17400}, {1760,0.15875}, {1770,0.12575}, {1780,0.10025}, {1790,0.09850}, {1800,0.14550}, {1810,0.13875}, {1820,0.12600}, {1830,0.09925}, {1840,0.12050}, {1850,0.13850}, {1860,0.13150}, {1870,0.09950}, {1880,0.12550}, {1890,0.14225}, {1900,0.13775}, {1910,0.09950}, {1920,0.12850}, {1930,0.14125}, {1940,0.12450}, {1950,0.13050}, {1960,0.14600}, {1970,0.13500}, {1980,0.10575}, {1990,0.16500}, {2000,0.13180}, {2050,0.15750}, {2100,0.17225}, {2150,0.11875}, {2200,0.15550}, {2250,1.25775}, {2300,0.12675}, {2350,0.16550}, {2400,0.16625}, {2450,0.17825}, {2500,0.17520}, {2550,0.16775}, {2600,0.17625}, {2650,0.17575}, {2700,0.17725}, {2750,0.18075}, {2800,0.18950}, {2850,0.18700}, {2900,0.19650}, {2950,0.22575}, {3000,0.20020}, {3050,0.20300}, {3100,0.20975}, {3150,0.21350}, {3200,0.21025}, {3250,0.28475}, {3300,0.22225}, {3350,0.26650}, {3400,0.27750}, {3450,0.25525}, {3500,0.31020}, {3550,0.28425}, {3600,0.30250}, {3650,0.29925}, {3700,0.26875}, {3750,0.25350}, {3800,0.26575}, {3850,0.25925}, {3900,0.26725}, {3950,0.25200}, {4000,0.26760}, {4050,0.26175}, {4100,0.26725}, {4150,0.26250}, {4200,0.26675}, {4250,0.28100}, {4300,0.28625}, {4350,0.28200}, {4400,0.28850}, {4450,0.28850}, {4500,0.30020}, {4550,0.29700}, {4600,1.59275}, {4650,0.31150}, {4700,0.38650}, {4750,0.38450}, {4800,0.38125}, {4850,0.38350}, {4900,0.40825}, {4950,0.39050}, {5000,0.34100}};
data["big_flat"]["parsing"]["Stats"]["system"] = {{1,0.00023276}, {2,0.00006897}, {3,0.00000000}, {4,0.00003448}, {5,0.00000000}, {6,0.00006034}, {7,0.00006897}, {8,0.00008621}, {9,0.00003448}, {10,0.00003448}, {11,0.00012069}, {12,0.00009483}, {13,0.00006034}, {14,0.00008621}, {15,0.00003448}, {16,0.00010345}, {17,0.00010345}, {18,0.00006034}, {19,0.00012931}, {20,0.00013793}, {21,0.00005172}, {22,0.00019828}, {23,0.00017241}, {24,0.00012931}, {25,0.00023276}, {26,0.00017241}, {27,0.00006034}, {28,0.00021552}, {29,0.00006897}, {30,0.00020690}, {31,0.00017241}, {32,0.00018966}, {33,0.00022414}, {34,0.00022414}, {35,0.00011207}, {36,0.00178448}, {37,0.00009483}, {38,0.00000000}, {39,0.00003448}, {40,0.00000000}, {41,0.00000000}, {42,0.00003448}, {43,0.00003448}, {44,0.00006897}, {45,0.00003448}, {46,0.00003448}, {47,0.00002586}, {48,0.00000000}, {49,0.00000000}, {50,0.00003448}, {51,0.00000000}, {52,0.00003448}, {53,0.00000000}, {54,0.00003448}, {55,0.00000000}, {56,0.00003448}, {57,0.00000000}, {58,0.00000000}, {59,0.00003448}, {60,0.00003448}, {61,0.00006034}, {62,0.00000000}, {63,0.00013793}, {64,0.00038793}, {65,0.00000000}, {66,0.00006034}, {67,0.00000000}, {68,0.00003448}, {69,0.00000000}, {70,0.00010345}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00006034}, {75,0.00003448}, {76,0.00003448}, {77,0.00003448}, {78,0.00006897}, {79,0.00002586}, {80,0.00002586}, {81,0.00006034}, {82,0.00006034}, {83,0.00000000}, {84,0.00022414}, {85,0.00017241}, {86,0.00000000}, {87,0.00006897}, {88,0.00002586}, {89,0.00000000}, {90,0.00003448}, {91,0.00002586}, {92,0.00000000}, {93,0.00003448}, {94,0.00006897}, {95,0.00010345}, {96,0.00002586}, {97,0.00000000}, {98,0.00010345}, {99,0.00059483}, {100,0.00006897}, {101,0.00009483}, {102,0.00006034}, {103,0.00012931}, {104,0.00000000}, {105,0.00003448}, {106,0.00006034}, {107,0.00006897}, {108,0.00011207}, {109,0.00006034}, {110,0.00005172}, {111,0.00006034}, {112,0.00003448}, {113,0.00015517}, {114,0.00002586}, {115,0.00003448}, {116,0.00003448}, {117,0.00006034}, {118,0.00003448}, {119,0.00002586}, {120,0.00006897}, {121,0.00006897}, {122,0.00006897}, {123,0.00003448}, {124,0.00000000}, {125,0.00053448}, {126,0.00015517}, {127,0.00003448}, {128,0.00003448}, {129,0.00000000}, {130,0.00002586}, {131,0.00012931}, {132,0.00000000}, {133,0.00006897}, {134,0.00003448}, {135,0.00000000}, {136,0.00062069}, {137,0.00007759}, {138,0.00000000}, {139,0.00006897}, {140,0.00007759}, {141,0.00000000}, {142,0.00002586}, {143,0.00006034}, {144,0.00002586}, {145,0.00002586}, {146,0.00102586}, {147,0.00009483}, {148,0.00015517}, {149,0.00006897}, {150,0.00002586}, {151,0.00006034}, {152,0.00006897}, {153,0.00010345}, {154,0.00003448}, {155,0.00009483}, {156,0.00050000}, {157,0.00012931}, {158,0.00003448}, {159,0.00003448}, {160,0.00003448}, {161,0.00003448}, {162,0.00003448}, {163,0.00006034}, {164,0.00010345}, {165,0.00050000}, {166,0.00013793}, {167,0.00005172}, {168,0.00000000}, {169,0.00000000}, {170,0.00006897}, {171,0.00003448}, {172,0.00015517}, {173,0.00003448}, {174,0.00022414}, {175,0.00003448}, {176,0.00000000}, {177,0.00002586}, {178,0.00008621}, {179,0.00022414}, {180,0.00017241}, {181,0.00006034}, {182,0.00052586}, {183,0.00010345}, {184,0.00010345}, {185,0.00005172}, {186,0.00003448}, {187,0.00006897}, {188,0.00000000}, {189,0.00000000}, {190,0.00046552}, {191,0.00009483}, {192,0.00006897}, {193,0.00000000}, {194,0.00006897}, {195,0.00003448}, {196,0.00010345}, {197,0.00000000}, {198,0.00022414}, {199,0.00016379}, {200,0.00010345}, {201,0.00013793}, {202,0.00000000}, {203,0.00003448}, {204,0.00006034}, {205,0.00010345}, {206,0.00023276}, {207,0.00002586}, {208,0.00006897}, {209,0.00003448}, {210,0.00012931}, {211,0.00003448}, {212,0.00006897}, {213,0.00003448}, {214,0.00006034}, {215,0.00010345}, {216,0.00009483}, {217,0.00010345}, {218,0.00017241}, {219,0.00006034}, {220,0.00010345}, {221,0.00013793}, {222,0.00006897}, {223,0.00013793}, {224,0.00010345}, {225,0.00039655}, {226,0.00019828}, {227,0.00006034}, {228,0.00009483}, {229,0.00003448}, {230,0.00009483}, {231,0.00012931}, {232,0.00003448}, {233,0.00006897}, {234,0.00006897}, {235,0.00012931}, {236,0.00009483}, {237,0.00006897}, {238,0.00043966}, {239,0.00013793}, {240,0.00016379}, {241,0.00006897}, {242,0.00010345}, {243,0.00012931}, {244,0.00050000}, {245,0.00002586}, {246,0.00019828}, {247,0.00013793}, {248,0.00006897}, {249,0.00012931}, {250,0.00039655}, {251,0.00000000}, {252,0.00006897}, {253,0.00006897}, {254,0.00003448}, {255,0.00003448}, {256,0.00024138}, {257,0.00018966}, {258,0.00003448}, {259,0.00003448}, {260,0.00000000}, {261,0.00003448}, {262,0.00016379}, {263,0.00026724}, {264,0.00017241}, {265,0.00010345}, {266,0.00003448}, {267,0.00067241}, {268,0.00010345}, {269,0.00010345}, {270,0.00006034}, {271,0.00020690}, {272,0.00016379}, {273,0.00006897}, {274,0.00009483}, {275,0.00010345}, {276,0.00010345}, {277,0.00012931}, {278,0.00037931}, {279,0.00016379}, {280,0.00006897}, {281,0.00017241}, {282,0.00017241}, {283,0.00018966}, {284,0.00000000}, {285,0.00003448}, {286,0.00003448}, {287,0.00006897}, {288,0.00034483}, {289,0.00017241}, {290,0.00005172}, {291,0.00013793}, {292,0.00000000}, {293,0.00052586}, {294,0.00012931}, {295,0.00006897}, {296,0.00003448}, {297,0.00013793}, {298,0.00074138}, {299,0.00013793}, {300,0.00002586}, {301,0.00013793}, {302,0.00019828}, {303,0.00095690}, {304,0.00012069}, {305,0.00023276}, {306,0.00013793}, {307,0.00022414}, {308,0.00039655}, {309,0.00016379}, {310,0.00022414}, {311,0.00014655}, {312,0.00015517}, {313,0.00009483}, {314,0.00025862}, {315,0.00012931}, {316,0.00018966}, {317,0.00061207}, {318,0.00019828}, {319,0.00013793}, {320,0.00018103}, {321,0.00017241}, {322,0.00057759}, {323,0.00009483}, {324,0.00024138}, {325,0.00020690}, {326,0.00012931}, {327,0.00012931}, {328,0.00020690}, {329,0.00017241}, {330,0.00003448}, {331,0.00051724}, {332,0.00017241}, {333,0.00017241}, {334,0.00013793}, {335,0.00012069}, {336,0.00017241}, {337,0.00009483}, {338,0.00019828}, {339,0.00009483}, {340,0.00064655}, {341,0.00019828}, {342,0.00003448}, {343,0.00012931}, {344,0.00062069}, {345,0.00006034}, {346,0.00024138}, {347,0.00009483}, {348,0.00017241}, {349,0.00010345}, {350,0.00010345}, {351,0.00016379}, {352,0.00012931}, {353,0.00010345}, {354,0.00006897}, {355,0.00003448}, {356,0.00006897}, {357,0.00013793}, {358,0.00006034}, {359,0.00010345}, {360,0.00006034}, {361,0.00034483}, {362,0.00025862}, {363,0.00000000}, {364,0.00012931}, {365,0.00081034}, {366,0.00017241}, {367,0.00018966}, {368,0.00017241}, {369,0.00081034}, {370,0.00006897}, {371,0.00013793}, {372,0.00006897}, {373,0.00074138}, {374,0.00017241}, {375,0.00024138}, {376,0.00006897}, {377,0.00097414}, {378,0.00038793}, {379,0.00013793}, {380,0.00010345}, {381,0.00060345}, {382,0.00026724}, {383,0.00003448}, {384,0.00006034}, {385,0.00074138}, {386,0.00029310}, {387,0.00012931}, {388,0.00010345}, {389,0.00010345}, {390,0.00006897}, {391,0.00020690}, {392,0.00009483}, {393,0.00020690}, {394,0.00013793}, {395,0.00017241}, {396,0.00020690}, {397,0.00010345}, {398,0.00013793}, {399,0.00765517}, {400,0.00070690}, {401,0.00016379}, {402,0.00027586}, {403,0.00080172}, {404,0.00017241}, {405,0.00010345}, {406,0.00017241}, {407,0.00017241}, {408,0.00010345}, {409,0.00006034}, {410,0.00068103}, {411,0.00023276}, {412,0.00012931}, {413,0.00020690}, {414,0.00083621}, {415,0.00011207}, {416,0.00017241}, {417,0.00018966}, {418,0.00026724}, {419,0.00024138}, {420,0.00016379}, {421,0.00043966}, {422,0.00017241}, {423,0.00010345}, {424,0.00013793}, {425,0.00021552}, {426,0.00008621}, {427,0.00006897}, {428,0.00081897}, {429,0.00025000}, {430,0.00020690}, {431,0.00010345}, {432,0.00017241}, {433,0.00003448}, {434,0.00013793}, {435,0.00062069}, {436,0.00009483}, {437,0.00027586}, {438,0.00047414}, {439,0.00017241}, {440,0.00010345}, {441,0.00008621}, {442,0.00017241}, {443,0.00017241}, {444,0.00012931}, {445,0.00077586}, {446,0.00009483}, {447,0.00006034}, {448,0.00054310}, {449,0.00013793}, {450,0.00010345}, {451,0.00009483}, {452,0.00017241}, {453,0.00003448}, {454,0.00009483}, {455,0.00061207}, {456,0.00020690}, {457,0.00017241}, {458,0.00067241}, {459,0.00017241}, {460,0.00013793}, {461,0.00020690}, {462,0.00037931}, {463,0.00006897}, {464,0.00016379}, {465,0.00019828}, {466,0.00027586}, {467,0.00009483}, {468,0.00003448}, {469,0.00022414}, {470,0.00017241}, {471,0.00010345}, {472,0.00006897}, {473,0.00031034}, {474,0.00055172}, {475,0.00023276}, {476,0.00012931}, {477,0.00058621}, {478,0.00012931}, {479,0.00010345}, {480,0.00010345}, {481,0.00023276}, {482,0.00010345}, {483,0.00022414}, {484,0.00013793}, {485,0.00027586}, {486,0.00017241}, {487,0.00006897}, {488,0.00016379}, {489,0.00010345}, {490,0.00006897}, {491,0.00020690}, {492,0.00024138}, {493,0.00006897}, {494,0.00025862}, {495,0.00016379}, {496,0.00017241}, {497,0.00010345}, {498,0.00024138}, {499,0.00013793}, {500,0.000212121}, {505,0.00023478}, {510,0.00020870}, {515,0.00006957}, {520,0.00020000}, {525,0.00017391}, {530,0.00031304}, {535,0.00026957}, {540,0.00030435}, {545,0.00082609}, {550,0.00010435}, {555,0.00013043}, {560,0.00072174}, {565,0.00017544}, {570,0.00017544}, {575,0.00014035}, {580,0.00025439}, {585,0.00083333}, {590,0.00014035}, {595,0.00026316}, {600,0.00031304}, {605,0.00014035}, {610,0.00080702}, {615,0.00015789}, {620,0.00024561}, {625,0.00014035}, {630,0.00021053}, {635,0.00111404}, {640,0.00024561}, {645,0.00041228}, {650,0.00010526}, {655,0.00030702}, {660,0.00027193}, {665,0.00007018}, {670,0.00023684}, {675,0.00016667}, {680,0.00065789}, {685,0.00043860}, {690,0.00097368}, {695,0.00028070}, {700,0.00071304}, {705,0.00023684}, {710,0.00076316}, {715,0.00021053}, {720,0.00021053}, {725,0.00010526}, {730,0.00006140}, {735,0.00023684}, {740,0.00016667}, {745,0.00041228}, {750,0.00021053}, {755,0.00023684}, {760,0.00024561}, {765,0.00031579}, {770,0.00759649}, {775,0.00560526}, {780,0.00041228}, {785,0.00093860}, {790,0.00034211}, {795,0.00126316}, {800,0.00045217}, {805,0.00089474}, {810,0.00031579}, {815,0.00022807}, {820,0.00021053}, {825,0.00028070}, {830,0.00041228}, {835,0.00030702}, {840,0.00128070}, {845,0.00031579}, {850,0.00063158}, {855,0.00021053}, {860,0.00028070}, {865,0.00016667}, {870,0.00017544}, {875,0.00030702}, {880,0.00023684}, {885,0.00017544}, {890,0.00014035}, {895,0.00013158}, {900,0.00033043}, {905,0.00056140}, {910,0.00024561}, {915,0.00035088}, {920,0.00016667}, {925,0.00085088}, {930,0.00048246}, {935,0.00038596}, {940,0.00093860}, {945,0.00013158}, {950,0.00038596}, {955,0.00093860}, {960,0.00034211}, {965,0.00021053}, {970,0.00099123}, {975,0.00028070}, {980,0.00063158}, {985,0.00080702}, {990,0.00035088}, {995,0.00028070}, {1000,0.00093913}, {1010,0.00550}, {1020,0.00000}, {1030,0.00000}, {1040,0.00300}, {1050,0.00000}, {1060,0.00000}, {1070,0.00000}, {1080,0.00300}, {1090,0.00000}, {1100,0.00075}, {1110,0.00000}, {1120,0.00100}, {1130,0.00100}, {1140,0.00000}, {1150,0.00100}, {1160,0.00200}, {1170,0.00000}, {1180,0.00000}, {1190,0.00000}, {1200,0.00200}, {1210,0.00100}, {1220,0.00275}, {1230,0.00100}, {1240,0.00000}, {1250,0.00000}, {1260,0.00100}, {1270,0.00100}, {1280,0.00200}, {1290,0.00100}, {1300,0.00075}, {1310,0.00000}, {1320,0.00000}, {1330,0.00175}, {1340,0.00300}, {1350,0.00400}, {1360,0.00000}, {1370,0.00100}, {1380,0.00100}, {1390,0.00000}, {1400,0.00000}, {1410,0.00000}, {1420,0.00000}, {1430,0.00000}, {1440,0.00000}, {1450,0.00000}, {1460,0.00100}, {1470,0.00000}, {1480,0.00000}, {1490,0.00000}, {1500,0.00000}, {1510,0.00200}, {1520,0.00000}, {1530,0.00000}, {1540,0.00000}, {1550,0.00000}, {1560,0.00100}, {1570,0.00000}, {1580,0.00000}, {1590,0.00000}, {1600,0.00100}, {1610,0.00375}, {1620,0.00375}, {1630,0.00100}, {1640,0.00100}, {1650,0.00100}, {1660,0.00000}, {1670,0.00000}, {1680,0.00100}, {1690,0.00400}, {1700,0.00775}, {1710,0.00400}, {1720,0.00000}, {1730,0.00000}, {1740,0.00375}, {1750,0.00400}, {1760,0.00875}, {1770,0.00600}, {1780,0.00000}, {1790,0.00000}, {1800,0.00500}, {1810,0.00700}, {1820,0.00575}, {1830,0.00000}, {1840,0.00700}, {1850,0.00775}, {1860,0.00800}, {1870,0.00100}, {1880,0.00400}, {1890,0.00600}, {1900,0.00500}, {1910,0.00200}, {1920,0.00000}, {1930,0.00000}, {1940,0.00000}, {1950,0.00200}, {1960,0.00100}, {1970,0.00000}, {1980,0.00000}, {1990,0.00700}, {2000,0.00460}, {2050,0.00400}, {2100,0.00675}, {2150,0.00000}, {2200,0.00600}, {2250,0.09375}, {2300,0.00100}, {2350,0.00700}, {2400,0.00600}, {2450,0.00575}, {2500,0.00160}, {2550,0.00700}, {2600,0.00600}, {2650,0.01000}, {2700,0.00500}, {2750,0.00700}, {2800,0.00500}, {2850,0.00975}, {2900,0.00700}, {2950,0.01200}, {3000,0.00640}, {3050,0.00200}, {3100,0.00075}, {3150,0.00000}, {3200,0.01000}, {3250,0.00900}, {3300,0.00700}, {3350,0.01400}, {3400,0.00675}, {3450,0.00900}, {3500,0.01280}, {3550,0.00775}, {3600,0.00800}, {3650,0.00500}, {3700,0.00800}, {3750,0.01100}, {3800,0.00600}, {3850,0.00800}, {3900,0.00900}, {3950,0.00900}, {4000,0.00640}, {4050,0.01000}, {4100,0.01200}, {4150,0.01100}, {4200,0.01400}, {4250,0.00900}, {4300,0.01200}, {4350,0.01075}, {4400,0.01000}, {4450,0.01100}, {4500,0.01280}, {4550,0.00900}, {4600,0.18125}, {4650,0.00800}, {4700,0.00375}, {4750,0.00000}, {4800,0.00200}, {4850,0.00000}, {4900,0.00100}, {4950,0.00300}, {5000,0.00080}};
data["big_flat"]["parsing elaborated"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00013793}, {12,0.00000000}, {13,0.00000000}, {14,0.00003448}, {15,0.00054310}, {16,0.00100000}, {17,0.00062931}, {18,0.00098276}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00100000}, {23,0.00199138}, {24,0.00100000}, {25,0.00100000}, {26,0.00100000}, {27,0.00100000}, {28,0.00100000}, {29,0.00100000}, {30,0.00100862}, {31,0.00100000}, {32,0.00105172}, {33,0.00101724}, {34,0.00139655}, {35,0.00138793}, {36,0.00136207}, {37,0.00145690}, {38,0.00135345}, {39,0.00181897}, {40,0.00200000}, {41,0.00200000}, {42,0.00200000}, {43,0.00200000}, {44,0.00200000}, {45,0.00200000}, {46,0.00200000}, {47,0.00200000}, {48,0.00500862}, {49,0.00200000}, {50,0.00200000}, {51,0.00200000}, {52,0.00200862}, {53,0.00203448}, {54,0.00205172}, {55,0.00204310}, {56,0.00206034}, {57,0.00233621}, {58,0.00243966}, {59,0.00281034}, {60,0.00289655}, {61,0.00280172}, {62,0.00294828}, {63,0.00300000}, {64,0.00300000}, {65,0.00300000}, {66,0.00300000}, {67,0.00300000}, {68,0.00300000}, {69,0.00857759}, {70,0.00300000}, {71,0.00300000}, {72,0.00300862}, {73,0.00300862}, {74,0.00304310}, {75,0.00309483}, {76,0.00312931}, {77,0.00339655}, {78,0.00317241}, {79,0.00347414}, {80,0.00357759}, {81,0.00396552}, {82,0.00394828}, {83,0.00400000}, {84,0.06087069}, {85,0.00400000}, {86,0.00400000}, {87,0.00400000}, {88,0.00400000}, {89,0.00400000}, {90,0.00400862}, {91,0.00400862}, {92,0.00404310}, {93,0.00402586}, {94,0.00405172}, {95,0.00420690}, {96,0.00443966}, {97,0.00474138}, {98,0.00491379}, {99,0.00488793}, {100,0.00499138}, {101,0.00500000}, {102,0.00500000}, {103,0.00500000}, {104,0.00500000}, {105,0.00500000}, {106,0.00500000}, {107,0.00500000}, {108,0.00500000}, {109,0.00501724}, {110,0.00500862}, {111,0.00506034}, {112,0.00512069}, {113,0.03656034}, {114,0.00581897}, {115,0.00589655}, {116,0.00588793}, {117,0.00593966}, {118,0.00592241}, {119,0.00598276}, {120,0.00600000}, {121,0.00600000}, {122,0.00600000}, {123,0.00600000}, {124,0.00600000}, {125,0.00600000}, {126,0.00600000}, {127,0.00600862}, {128,0.00602586}, {129,0.00616379}, {130,0.00606897}, {131,0.00608621}, {132,0.00636207}, {133,0.00680172}, {134,0.00689655}, {135,0.00690517}, {136,0.00692241}, {137,0.00698276}, {138,0.00700000}, {139,0.00700862}, {140,0.03193103}, {141,0.00690517}, {142,0.00698276}, {143,0.00699138}, {144,0.00699138}, {145,0.00699138}, {146,0.00700000}, {147,0.00699138}, {148,0.00700000}, {149,0.00700000}, {150,0.00700000}, {151,0.00700000}, {152,0.00701724}, {153,0.00700862}, {154,0.00711207}, {155,0.00736207}, {156,0.00748276}, {157,0.00722414}, {158,0.00731034}, {159,0.00762069}, {160,0.00793103}, {161,0.00799138}, {162,0.00797414}, {163,0.00800000}, {164,0.00800000}, {165,0.00800000}, {166,0.00800000}, {167,0.00800000}, {168,0.00800000}, {169,0.00800000}, {170,0.00800862}, {171,0.00800000}, {172,0.00800000}, {173,0.00802586}, {174,0.03996552}, {175,0.00829310}, {176,0.00840517}, {177,0.00861207}, {178,0.00851724}, {179,0.00846552}, {180,0.00857759}, {181,0.00893103}, {182,0.00897414}, {183,0.00899138}, {184,0.00898276}, {185,0.00900000}, {186,0.00900000}, {187,0.00900000}, {188,0.00900000}, {189,0.00900000}, {190,0.00900862}, {191,0.00900000}, {192,0.00901724}, {193,0.00902586}, {194,0.00932759}, {195,0.00926724}, {196,0.00968103}, {197,0.00935345}, {198,0.04266379}, {199,0.05896552}, {200,0.00965517}, {201,0.00990517}, {202,0.00994828}, {203,0.00999138}, {204,0.01000000}, {205,0.06245690}, {206,0.01000000}, {207,0.01000000}, {208,0.01000000}, {209,0.01000000}, {210,0.01000862}, {211,0.01000862}, {212,0.07080172}, {213,0.01092241}, {214,0.01093103}, {215,0.01099138}, {216,0.01098276}, {217,0.01098276}, {218,0.01099138}, {219,0.05416379}, {220,0.01100000}, {221,0.01100862}, {222,0.01100862}, {223,0.01100862}, {224,0.01103448}, {225,0.01120690}, {226,0.01118103}, {227,0.01157759}, {228,0.01149138}, {229,0.01135345}, {230,0.01162931}, {231,0.01174138}, {232,0.04485345}, {233,0.01195690}, {234,0.01193966}, {235,0.01199138}, {236,0.01195690}, {237,0.01199138}, {238,0.01200000}, {239,0.01200862}, {240,0.01200862}, {241,0.01203448}, {242,0.01200000}, {243,0.01200862}, {244,0.01223276}, {245,0.01209483}, {246,0.01218966}, {247,0.01254310}, {248,0.01262069}, {249,0.01243966}, {250,0.01236207}, {251,0.01287069}, {252,0.01285345}, {253,0.01283621}, {254,0.01293966}, {255,0.01295690}, {256,0.01299138}, {257,0.01295690}, {258,0.01300000}, {259,0.01300000}, {260,0.01300862}, {261,0.01301724}, {262,0.07289655}, {263,0.01304310}, {264,0.01302586}, {265,0.01304310}, {266,0.01312931}, {267,0.01325000}, {268,0.01337069}, {269,0.01332759}, {270,0.01370690}, {271,0.01381034}, {272,0.01374138}, {273,0.04712069}, {274,0.01393966}, {275,0.01394828}, {276,0.01397414}, {277,0.01399138}, {278,0.01400000}, {279,0.01400000}, {280,0.01400000}, {281,0.01400862}, {282,0.11437069}, {283,0.06771552}, {284,0.01388793}, {285,0.01396552}, {286,0.01399138}, {287,0.01400000}, {288,0.01400000}, {289,0.01400000}, {290,0.01400862}, {291,0.01400862}, {292,0.01400000}, {293,0.01400862}, {294,0.01401724}, {295,0.01406034}, {296,0.01406034}, {297,0.01408621}, {298,0.01423276}, {299,0.01439655}, {300,0.01455172}, {301,0.01465517}, {302,0.01475000}, {303,0.01482759}, {304,0.01483621}, {305,0.01493103}, {306,0.01496552}, {307,0.01494828}, {308,0.04481897}, {309,0.01500000}, {310,0.01500000}, {311,0.01500000}, {312,0.01504310}, {313,0.04541379}, {314,0.01501724}, {315,0.01504310}, {316,0.01506034}, {317,0.01524138}, {318,0.01519828}, {319,0.01528448}, {320,0.01544828}, {321,0.01564655}, {322,0.01574138}, {323,0.01583621}, {324,0.01587931}, {325,0.01593103}, {326,0.01593103}, {327,0.04510345}, {328,0.01598276}, {329,0.01599138}, {330,0.01599138}, {331,0.01600862}, {332,0.01600862}, {333,0.01600862}, {334,0.01601724}, {335,0.01602586}, {336,0.04802586}, {337,0.01614655}, {338,0.01618966}, {339,0.01636207}, {340,0.01626724}, {341,0.01661207}, {342,0.01675862}, {343,0.01668966}, {344,0.01683621}, {345,0.01678448}, {346,0.01688793}, {347,0.01693966}, {348,0.01693966}, {349,0.04654310}, {350,0.01698276}, {351,0.01701724}, {352,0.01700862}, {353,0.08748276}, {354,0.01794828}, {355,0.01796552}, {356,0.01798276}, {357,0.01798276}, {358,0.01800862}, {359,0.01801724}, {360,0.01803448}, {361,0.01806897}, {362,0.01817241}, {363,0.01815517}, {364,0.01825000}, {365,0.01843966}, {366,0.01848276}, {367,0.01862931}, {368,0.01863793}, {369,0.01874138}, {370,0.01881034}, {371,0.01886207}, {372,0.01887069}, {373,0.01890517}, {374,0.01898276}, {375,0.01895690}, {376,0.01898276}, {377,0.01900000}, {378,0.01901724}, {379,0.01902586}, {380,0.01906034}, {381,0.01903448}, {382,0.01917241}, {383,0.01925862}, {384,0.01925000}, {385,0.01925862}, {386,0.01944828}, {387,0.01958621}, {388,0.01968103}, {389,0.07831897}, {390,0.01981034}, {391,0.01987069}, {392,0.01991379}, {393,0.08237069}, {394,0.01996552}, {395,0.01996552}, {396,0.02000000}, {397,0.07309483}, {398,0.02019828}, {399,0.02016379}, {400,0.01915517}, {401,0.01929310}, {402,0.01946552}, {403,0.01942241}, {404,0.01958621}, {405,0.01966379}, {406,0.01985345}, {407,0.04967241}, {408,0.01986207}, {409,0.01987069}, {410,0.01987931}, {411,0.01999138}, {412,0.01999138}, {413,0.01999138}, {414,0.02002586}, {415,0.02004310}, {416,0.02002586}, {417,0.02004310}, {418,0.06037069}, {419,0.02013793}, {420,0.02018103}, {421,0.02027586}, {422,0.02035345}, {423,0.02040517}, {424,0.02060345}, {425,0.04904310}, {426,0.02078448}, {427,0.02080172}, {428,0.02086207}, {429,0.02085345}, {430,0.02093103}, {431,0.02098276}, {432,0.04781897}, {433,0.02097414}, {434,0.02098276}, {435,0.02102586}, {436,0.02105172}, {437,0.02100862}, {438,0.02111207}, {439,0.02109483}, {440,0.02119828}, {441,0.02123276}, {442,0.05396552}, {443,0.02153448}, {444,0.02139655}, {445,0.02144828}, {446,0.02175862}, {447,0.02177586}, {448,0.02182759}, {449,0.02183621}, {450,0.02192241}, {451,0.02190517}, {452,0.05483621}, {453,0.02196552}, {454,0.02197414}, {455,0.02198276}, {456,0.02199138}, {457,0.02206897}, {458,0.02205172}, {459,0.02207759}, {460,0.02217241}, {461,0.02222414}, {462,0.05517241}, {463,0.02237931}, {464,0.02244828}, {465,0.05657759}, {466,0.02262069}, {467,0.02271552}, {468,0.02282759}, {469,0.02289655}, {470,0.02286207}, {471,0.02288793}, {472,0.02291379}, {473,0.02295690}, {474,0.02295690}, {475,0.02392241}, {476,0.02400000}, {477,0.02398276}, {478,0.02405172}, {479,0.02405172}, {480,0.02408621}, {481,0.06633621}, {482,0.02430172}, {483,0.02426724}, {484,0.05740517}, {485,0.02452586}, {486,0.02463793}, {487,0.05401724}, {488,0.02468966}, {489,0.02475862}, {490,0.05493103}, {491,0.02487069}, {492,0.02486207}, {493,0.05651724}, {494,0.02486207}, {495,0.02495690}, {496,0.07406034}, {497,0.02497414}, {498,0.02496552}, {499,0.08568966}, {500,0.025129870}, {505,0.08590435}, {510,0.02581739}, {515,0.02595652}, {520,0.08586087}, {525,0.02665217}, {530,0.02680870}, {535,0.07754783}, {540,0.02714783}, {545,0.02766957}, {550,0.02782609}, {555,0.02793043}, {560,0.02819130}, {565,0.02864348}, {570,0.02881579}, {575,0.08823684}, {580,0.02936842}, {585,0.02971930}, {590,0.02986842}, {595,0.03000000}, {600,0.09078261}, {605,0.03073684}, {610,0.03081579}, {615,0.03102632}, {620,0.03130702}, {625,0.08928947}, {630,0.03183333}, {635,0.03211404}, {640,0.03247368}, {645,0.03280702}, {650,0.03285965}, {655,0.03307895}, {660,0.06481579}, {665,0.03381579}, {670,0.06727193}, {675,0.03404386}, {680,0.03453509}, {685,0.03479825}, {690,0.03491228}, {695,0.03527193}, {700,0.03613043}, {705,0.03581579}, {710,0.03600000}, {715,0.03627193}, {720,0.03661404}, {725,0.06826316}, {730,0.03695614}, {735,0.06871053}, {740,0.03765789}, {745,0.06759649}, {750,0.03801754}, {755,0.06711404}, {760,0.03875439}, {765,0.06206140}, {770,0.03731579}, {775,0.03808772}, {780,0.03828947}, {785,0.03850877}, {790,0.03879825}, {795,0.03894737}, {800,0.03920000}, {805,0.03957018}, {810,0.03977193}, {815,0.06935965}, {820,0.04010526}, {825,0.07260526}, {830,0.04074561}, {835,0.06498246}, {840,0.04106140}, {845,0.04142105}, {850,0.04173684}, {855,0.04185965}, {860,0.07108772}, {865,0.04221930}, {870,0.04257895}, {875,0.04286842}, {880,0.04306140}, {885,0.07531579}, {890,0.04359649}, {895,0.07329825}, {900,0.04453913}, {905,0.04427193}, {910,0.08035088}, {915,0.04481579}, {920,0.04504386}, {925,0.04522807}, {930,0.04557895}, {935,0.13868421}, {940,0.04772807}, {945,0.04790351}, {950,0.09597368}, {955,0.04859649}, {960,0.04878947}, {965,0.08433333}, {970,0.04926316}, {975,0.04964912}, {980,0.09338596}, {985,0.05007018}, {990,0.05030702}, {995,0.11947368}, {1000,0.05083478}, {1010,0.05350}, {1020,0.05200}, {1030,0.11350}, {1040,0.05150}, {1050,0.05275}, {1060,0.09350}, {1070,0.05400}, {1080,0.05475}, {1090,0.05475}, {1100,0.12825}, {1110,0.05350}, {1120,0.05450}, {1130,0.05500}, {1140,0.08925}, {1150,0.05575}, {1160,0.05650}, {1170,0.05725}, {1180,0.09000}, {1190,0.15575}, {1200,0.05850}, {1210,0.06125}, {1220,0.06125}, {1230,0.06200}, {1240,0.10050}, {1250,0.09150}, {1260,0.06350}, {1270,0.06425}, {1280,0.06500}, {1290,0.06525}, {1300,0.10275}, {1310,0.12100}, {1320,0.10125}, {1330,0.06525}, {1340,0.06500}, {1350,0.16100}, {1360,0.06625}, {1370,0.06675}, {1380,0.06750}, {1390,0.06800}, {1400,0.06800}, {1410,0.13125}, {1420,0.11925}, {1430,0.11650}, {1440,0.10000}, {1450,0.10300}, {1460,0.10575}, {1470,0.11225}, {1480,0.11300}, {1490,0.10975}, {1500,0.10380}, {1510,0.11975}, {1520,0.11725}, {1530,0.13800}, {1540,0.13850}, {1550,0.13550}, {1560,0.12675}, {1570,0.09600}, {1580,0.09700}, {1590,0.09800}, {1600,0.07800}, {1610,0.07825}, {1620,0.26900}, {1630,0.07950}, {1640,0.11175}, {1650,0.14850}, {1660,0.12750}, {1670,0.11425}, {1680,0.08450}, {1690,0.08550}, {1700,0.08525}, {1710,0.08575}, {1720,0.14900}, {1730,0.15825}, {1740,0.14150}, {1750,0.08825}, {1760,0.08850}, {1770,0.08900}, {1780,0.12475}, {1790,0.12925}, {1800,0.11150}, {1810,0.09100}, {1820,0.09175}, {1830,0.12825}, {1840,0.11825}, {1850,0.08975}, {1860,0.09050}, {1870,0.12400}, {1880,0.12925}, {1890,0.09150}, {1900,0.09225}, {1910,0.12800}, {1920,0.12150}, {1930,0.09325}, {1940,0.09425}, {1950,0.12925}, {1960,0.09450}, {1970,0.09550}, {1980,0.13175}, {1990,0.12375}, {2000,0.10920}, {2050,0.18950}, {2100,0.10575}, {2150,0.14700}, {2200,0.14825}, {2250,0.11375}, {2300,0.16125}, {2350,0.15525}, {2400,0.16075}, {2450,0.12375}, {2500,0.16380}, {2550,0.17875}, {2600,0.12725}, {2650,0.15425}, {2700,0.16400}, {2750,0.17500}, {2800,0.18625}, {2850,0.19025}, {2900,0.19275}, {2950,0.14400}, {3000,0.17020}, {3050,0.19825}, {3100,0.19725}, {3150,0.20275}, {3200,0.23175}, {3250,0.21325}, {3300,0.21850}, {3350,0.18125}, {3400,0.25375}, {3450,0.27925}, {3500,0.22340}, {3550,0.29900}, {3600,0.29750}, {3650,0.30400}, {3700,0.29500}, {3750,0.28375}, {3800,0.24800}, {3850,0.26375}, {3900,0.24475}, {3950,0.26525}, {4000,0.26940}, {4050,0.25350}, {4100,0.25875}, {4150,0.27450}, {4200,0.27725}, {4250,0.28200}, {4300,0.25300}, {4350,0.26475}, {4400,0.27900}, {4450,0.27425}, {4500,0.29660}, {4550,0.27550}, {4600,0.27550}, {4650,0.34525}, {4700,0.32350}, {4750,0.37675}, {4800,0.36250}, {4850,0.40400}, {4900,0.39925}, {4950,0.38275}, {5000,0.33440}};
data["big_flat"]["parsing elaborated"]["Stats"]["user"] = {{1,0.00000000}, {2,0.00017241}, {3,0.00016379}, {4,0.00031034}, {5,0.00048276}, {6,0.00045690}, {7,0.00050862}, {8,0.00055172}, {9,0.00064655}, {10,0.00044828}, {11,0.00071552}, {12,0.00065517}, {13,0.00084483}, {14,0.00097414}, {15,0.00081897}, {16,0.00128448}, {17,0.00110345}, {18,0.00114655}, {19,0.00103448}, {20,0.00081897}, {21,0.00096552}, {22,0.00096552}, {23,0.00171552}, {24,0.00109483}, {25,0.00109483}, {26,0.00113793}, {27,0.00112069}, {28,0.00140517}, {29,0.00138793}, {30,0.00173276}, {31,0.00193966}, {32,0.00168966}, {33,0.00156034}, {34,0.00166379}, {35,0.00191379}, {36,0.00179310}, {37,0.00154310}, {38,0.00212931}, {39,0.00220690}, {40,0.00195690}, {41,0.00185345}, {42,0.00222414}, {43,0.00223276}, {44,0.00220690}, {45,0.00234483}, {46,0.00217241}, {47,0.00225000}, {48,0.00533621}, {49,0.00238793}, {50,0.00281034}, {51,0.00251724}, {52,0.00271552}, {53,0.00286207}, {54,0.00279310}, {55,0.00275000}, {56,0.00267241}, {57,0.00268966}, {58,0.00326724}, {59,0.00312069}, {60,0.00298276}, {61,0.00302586}, {62,0.00293103}, {63,0.00297414}, {64,0.00322414}, {65,0.00358621}, {66,0.00350000}, {67,0.00343103}, {68,0.00334483}, {69,0.00887931}, {70,0.00346552}, {71,0.00379310}, {72,0.00374138}, {73,0.00366379}, {74,0.00372414}, {75,0.00382759}, {76,0.00375862}, {77,0.00396552}, {78,0.00386207}, {79,0.00403448}, {80,0.00400862}, {81,0.00409483}, {82,0.00406897}, {83,0.00420690}, {84,0.06047414}, {85,0.00458621}, {86,0.00440517}, {87,0.00453448}, {88,0.00458621}, {89,0.00465517}, {90,0.00444828}, {91,0.00473276}, {92,0.00492241}, {93,0.00464655}, {94,0.00472414}, {95,0.00462931}, {96,0.00489655}, {97,0.00489655}, {98,0.00506897}, {99,0.00524138}, {100,0.00533621}, {101,0.00542241}, {102,0.00549138}, {103,0.00546552}, {104,0.00546552}, {105,0.00511207}, {106,0.00525862}, {107,0.00540517}, {108,0.00584483}, {109,0.00596552}, {110,0.00544828}, {111,0.00586207}, {112,0.00606897}, {113,0.03618966}, {114,0.00594828}, {115,0.00588793}, {116,0.00596552}, {117,0.00616379}, {118,0.00583621}, {119,0.00650862}, {120,0.00633621}, {121,0.00654310}, {122,0.00648276}, {123,0.00627586}, {124,0.00662069}, {125,0.00655172}, {126,0.00634483}, {127,0.00665517}, {128,0.00693103}, {129,0.00665517}, {130,0.00672414}, {131,0.00682759}, {132,0.00672414}, {133,0.00686207}, {134,0.00684483}, {135,0.00692241}, {136,0.00681034}, {137,0.00678448}, {138,0.00681897}, {139,0.00723276}, {140,0.03175000}, {141,0.00673276}, {142,0.00698276}, {143,0.00715517}, {144,0.00728448}, {145,0.00740517}, {146,0.00745690}, {147,0.00748276}, {148,0.00748276}, {149,0.00782759}, {150,0.00755172}, {151,0.00758621}, {152,0.00737931}, {153,0.00762069}, {154,0.00772414}, {155,0.00779310}, {156,0.00796552}, {157,0.00782759}, {158,0.00779310}, {159,0.00791379}, {160,0.00807759}, {161,0.00818966}, {162,0.00818966}, {163,0.00810345}, {164,0.00801724}, {165,0.00818103}, {166,0.00841379}, {167,0.00825862}, {168,0.00843103}, {169,0.00850862}, {170,0.00879310}, {171,0.00865517}, {172,0.00858621}, {173,0.00858621}, {174,0.03934483}, {175,0.00879310}, {176,0.00882759}, {177,0.00882759}, {178,0.00879310}, {179,0.00882759}, {180,0.00884483}, {181,0.00883621}, {182,0.00893103}, {183,0.00905172}, {184,0.00915517}, {185,0.00919828}, {186,0.00900000}, {187,0.00905172}, {188,0.00923276}, {189,0.00931897}, {190,0.00956034}, {191,0.00933621}, {192,0.00950862}, {193,0.00940517}, {194,0.00968966}, {195,0.01003448}, {196,0.00968966}, {197,0.00986207}, {198,0.04234483}, {199,0.05916379}, {200,0.00976724}, {201,0.00987931}, {202,0.01007759}, {203,0.01018966}, {204,0.00995690}, {205,0.06127586}, {206,0.00985345}, {207,0.01022414}, {208,0.01075862}, {209,0.01030172}, {210,0.01041379}, {211,0.01058621}, {212,0.07031034}, {213,0.01122414}, {214,0.01124138}, {215,0.01073276}, {216,0.01075000}, {217,0.01071552}, {218,0.01104310}, {219,0.05394828}, {220,0.01150862}, {221,0.01160345}, {222,0.01165517}, {223,0.01133621}, {224,0.01150000}, {225,0.01173276}, {226,0.01139655}, {227,0.01149138}, {228,0.01137069}, {229,0.01129310}, {230,0.01162931}, {231,0.01168103}, {232,0.04463793}, {233,0.01163793}, {234,0.01170690}, {235,0.01168966}, {236,0.01175862}, {237,0.01213793}, {238,0.01211207}, {239,0.01184483}, {240,0.01198276}, {241,0.01241379}, {242,0.01213793}, {243,0.01205172}, {244,0.01221552}, {245,0.01226724}, {246,0.01242241}, {247,0.01262069}, {248,0.01261207}, {249,0.01244828}, {250,0.01266379}, {251,0.01265517}, {252,0.01267241}, {253,0.01287931}, {254,0.01265517}, {255,0.01284483}, {256,0.01294828}, {257,0.01321552}, {258,0.01293103}, {259,0.01314655}, {260,0.01303448}, {261,0.01261207}, {262,0.07254310}, {263,0.01320690}, {264,0.01346552}, {265,0.01312069}, {266,0.01395690}, {267,0.01307759}, {268,0.01343103}, {269,0.01363793}, {270,0.01373276}, {271,0.01344828}, {272,0.01370690}, {273,0.04710345}, {274,0.01377586}, {275,0.01353448}, {276,0.01365517}, {277,0.01404310}, {278,0.01426724}, {279,0.01403448}, {280,0.01381034}, {281,0.01401724}, {282,0.11393966}, {283,0.06504310}, {284,0.01350000}, {285,0.01384483}, {286,0.01362931}, {287,0.01373276}, {288,0.01415517}, {289,0.01463793}, {290,0.01443103}, {291,0.01450000}, {292,0.01398276}, {293,0.01414655}, {294,0.01369828}, {295,0.01424138}, {296,0.01424138}, {297,0.01459483}, {298,0.01460345}, {299,0.01475000}, {300,0.01490517}, {301,0.01480172}, {302,0.01514655}, {303,0.01502586}, {304,0.01494828}, {305,0.01497414}, {306,0.01518966}, {307,0.01510345}, {308,0.04442241}, {309,0.01513793}, {310,0.01548276}, {311,0.01556034}, {312,0.01534483}, {313,0.04517241}, {314,0.01535345}, {315,0.01559483}, {316,0.01578448}, {317,0.01555172}, {318,0.01575000}, {319,0.01573276}, {320,0.01575862}, {321,0.01575000}, {322,0.01588793}, {323,0.01602586}, {324,0.01618966}, {325,0.01599138}, {326,0.01625862}, {327,0.04525862}, {328,0.01631897}, {329,0.01623276}, {330,0.01606034}, {331,0.01636207}, {332,0.01613793}, {333,0.01631034}, {334,0.01631034}, {335,0.01654310}, {336,0.04764655}, {337,0.01625862}, {338,0.01660345}, {339,0.01679310}, {340,0.01678448}, {341,0.01643966}, {342,0.01664655}, {343,0.01684483}, {344,0.01677586}, {345,0.01647414}, {346,0.01706034}, {347,0.01697414}, {348,0.01695690}, {349,0.04662069}, {350,0.01696552}, {351,0.01692241}, {352,0.01716379}, {353,0.08692241}, {354,0.01770690}, {355,0.01786207}, {356,0.01785345}, {357,0.01779310}, {358,0.01802586}, {359,0.01834483}, {360,0.01808621}, {361,0.01821552}, {362,0.01815517}, {363,0.01818966}, {364,0.01821552}, {365,0.01842241}, {366,0.01785345}, {367,0.01811207}, {368,0.01839655}, {369,0.01823276}, {370,0.01840517}, {371,0.01862931}, {372,0.01837931}, {373,0.01854310}, {374,0.01833621}, {375,0.01896552}, {376,0.01873276}, {377,0.01867241}, {378,0.01886207}, {379,0.01874138}, {380,0.01878448}, {381,0.01912069}, {382,0.01905172}, {383,0.01898276}, {384,0.01928448}, {385,0.01896552}, {386,0.01907759}, {387,0.01926724}, {388,0.01918966}, {389,0.07823276}, {390,0.01942241}, {391,0.01944828}, {392,0.01929310}, {393,0.08115517}, {394,0.01957759}, {395,0.01961207}, {396,0.01963793}, {397,0.07279310}, {398,0.01962069}, {399,0.01988793}, {400,0.01896552}, {401,0.01912069}, {402,0.01912069}, {403,0.01911207}, {404,0.01909483}, {405,0.01918966}, {406,0.01918966}, {407,0.04914655}, {408,0.01931897}, {409,0.01959483}, {410,0.01963793}, {411,0.01944828}, {412,0.01976724}, {413,0.01963793}, {414,0.01969828}, {415,0.02002586}, {416,0.01982759}, {417,0.01991379}, {418,0.05940517}, {419,0.01999138}, {420,0.02011207}, {421,0.02007759}, {422,0.02044828}, {423,0.01965517}, {424,0.02001724}, {425,0.04850000}, {426,0.02048276}, {427,0.02022414}, {428,0.02029310}, {429,0.02040517}, {430,0.02058621}, {431,0.02025862}, {432,0.04736207}, {433,0.02053448}, {434,0.02080172}, {435,0.02043966}, {436,0.02101724}, {437,0.02049138}, {438,0.02102586}, {439,0.02112069}, {440,0.02075000}, {441,0.02093966}, {442,0.05327586}, {443,0.02106897}, {444,0.02104310}, {445,0.02090517}, {446,0.02163793}, {447,0.02137931}, {448,0.02150000}, {449,0.02148276}, {450,0.02182759}, {451,0.02177586}, {452,0.05398276}, {453,0.02149138}, {454,0.02153448}, {455,0.02172414}, {456,0.02167241}, {457,0.02195690}, {458,0.02162931}, {459,0.02190517}, {460,0.02179310}, {461,0.02188793}, {462,0.05434483}, {463,0.02237931}, {464,0.02220690}, {465,0.05633621}, {466,0.02226724}, {467,0.02253448}, {468,0.02249138}, {469,0.02256897}, {470,0.02261207}, {471,0.02235345}, {472,0.02256034}, {473,0.02279310}, {474,0.02277586}, {475,0.02362069}, {476,0.02402586}, {477,0.02429310}, {478,0.02412069}, {479,0.02417241}, {480,0.02410345}, {481,0.06601724}, {482,0.02395690}, {483,0.02446552}, {484,0.05692241}, {485,0.02450862}, {486,0.02424138}, {487,0.05365517}, {488,0.02456034}, {489,0.02427586}, {490,0.05431034}, {491,0.02471552}, {492,0.02479310}, {493,0.05581034}, {494,0.02485345}, {495,0.02462069}, {496,0.07351724}, {497,0.02479310}, {498,0.02489655}, {499,0.08530172}, {500,0.025147186}, {505,0.08482609}, {510,0.02567826}, {515,0.02582609}, {520,0.08553913}, {525,0.02636522}, {530,0.02624348}, {535,0.07726087}, {540,0.02719130}, {545,0.02754783}, {550,0.02758261}, {555,0.02813913}, {560,0.02786087}, {565,0.02817391}, {570,0.02843860}, {575,0.08783333}, {580,0.02921930}, {585,0.02959649}, {590,0.02954386}, {595,0.03000877}, {600,0.09014783}, {605,0.03085088}, {610,0.03090351}, {615,0.03128947}, {620,0.03147368}, {625,0.08807018}, {630,0.03236842}, {635,0.03237719}, {640,0.03228947}, {645,0.03268421}, {650,0.03314035}, {655,0.03331579}, {660,0.06428947}, {665,0.03380702}, {670,0.06690351}, {675,0.03422807}, {680,0.03449123}, {685,0.03457018}, {690,0.03506140}, {695,0.03530702}, {700,0.03565217}, {705,0.03570175}, {710,0.03571053}, {715,0.03578947}, {720,0.03630702}, {725,0.06759649}, {730,0.03682456}, {735,0.06813158}, {740,0.03772807}, {745,0.06682456}, {750,0.03796491}, {755,0.06679825}, {760,0.03835965}, {765,0.06165789}, {770,0.03703509}, {775,0.03739474}, {780,0.03749123}, {785,0.03819298}, {790,0.03832456}, {795,0.03868421}, {800,0.03898261}, {805,0.03898246}, {810,0.03930702}, {815,0.06850000}, {820,0.03964035}, {825,0.07171930}, {830,0.04009649}, {835,0.06417544}, {840,0.04094737}, {845,0.04107018}, {850,0.04140351}, {855,0.04173684}, {860,0.07078070}, {865,0.04185965}, {870,0.04245614}, {875,0.04291228}, {880,0.04277193}, {885,0.07486842}, {890,0.04379825}, {895,0.07310526}, {900,0.04459130}, {905,0.04439474}, {910,0.07741228}, {915,0.04466667}, {920,0.04459649}, {925,0.04534211}, {930,0.04525439}, {935,0.13683333}, {940,0.04738596}, {945,0.04771930}, {950,0.09521053}, {955,0.04832456}, {960,0.04809649}, {965,0.08342105}, {970,0.04872807}, {975,0.04904386}, {980,0.09258772}, {985,0.04943860}, {990,0.04998246}, {995,0.11824561}, {1000,0.04995652}, {1010,0.05000}, {1020,0.05125}, {1030,0.11125}, {1040,0.05175}, {1050,0.05350}, {1060,0.09175}, {1070,0.05350}, {1080,0.05475}, {1090,0.05500}, {1100,0.12650}, {1110,0.05450}, {1120,0.05300}, {1130,0.05500}, {1140,0.08775}, {1150,0.05650}, {1160,0.05500}, {1170,0.05700}, {1180,0.08675}, {1190,0.15375}, {1200,0.05900}, {1210,0.06175}, {1220,0.06200}, {1230,0.06050}, {1240,0.10050}, {1250,0.09175}, {1260,0.06375}, {1270,0.06400}, {1280,0.06475}, {1290,0.06575}, {1300,0.10250}, {1310,0.12050}, {1320,0.09950}, {1330,0.06300}, {1340,0.06350}, {1350,0.15975}, {1360,0.06650}, {1370,0.06675}, {1380,0.06825}, {1390,0.06625}, {1400,0.06850}, {1410,0.12875}, {1420,0.11850}, {1430,0.11475}, {1440,0.09875}, {1450,0.10175}, {1460,0.10375}, {1470,0.11150}, {1480,0.11450}, {1490,0.10600}, {1500,0.10240}, {1510,0.11850}, {1520,0.11600}, {1530,0.13750}, {1540,0.13750}, {1550,0.13475}, {1560,0.12350}, {1570,0.09575}, {1580,0.09675}, {1590,0.09825}, {1600,0.07700}, {1610,0.07775}, {1620,0.26700}, {1630,0.07900}, {1640,0.11250}, {1650,0.14775}, {1660,0.12750}, {1670,0.11300}, {1680,0.08550}, {1690,0.08625}, {1700,0.08675}, {1710,0.08500}, {1720,0.14600}, {1730,0.15400}, {1740,0.13850}, {1750,0.08725}, {1760,0.08675}, {1770,0.08725}, {1780,0.11975}, {1790,0.12250}, {1800,0.10750}, {1810,0.09050}, {1820,0.09275}, {1830,0.12450}, {1840,0.11150}, {1850,0.09075}, {1860,0.08925}, {1870,0.11950}, {1880,0.12300}, {1890,0.09175}, {1900,0.09250}, {1910,0.11900}, {1920,0.11925}, {1930,0.09300}, {1940,0.09600}, {1950,0.12950}, {1960,0.09275}, {1970,0.09700}, {1980,0.13050}, {1990,0.12325}, {2000,0.10840}, {2050,0.18350}, {2100,0.10550}, {2150,0.14125}, {2200,0.14050}, {2250,0.11300}, {2300,0.15350}, {2350,0.15025}, {2400,0.15575}, {2450,0.12350}, {2500,0.15900}, {2550,0.16850}, {2600,0.12675}, {2650,0.15125}, {2700,0.15450}, {2750,0.16650}, {2800,0.17850}, {2850,0.18425}, {2900,0.18250}, {2950,0.14325}, {3000,0.16360}, {3050,0.19425}, {3100,0.19450}, {3150,0.20075}, {3200,0.22175}, {3250,0.19950}, {3300,0.21250}, {3350,0.18075}, {3400,0.24200}, {3450,0.27175}, {3500,0.21920}, {3550,0.29000}, {3600,0.27550}, {3650,0.29350}, {3700,0.28550}, {3750,0.27250}, {3800,0.23600}, {3850,0.25500}, {3900,0.23650}, {3950,0.25575}, {4000,0.26000}, {4050,0.24425}, {4100,0.25150}, {4150,0.26375}, {4200,0.25975}, {4250,0.27050}, {4300,0.23925}, {4350,0.25300}, {4400,0.25625}, {4450,0.26550}, {4500,0.26440}, {4550,0.26250}, {4600,0.26475}, {4650,0.32550}, {4700,0.31825}, {4750,0.36475}, {4800,0.36025}, {4850,0.38525}, {4900,0.39775}, {4950,0.38275}, {5000,0.33360}};
data["big_flat"]["parsing elaborated"]["Stats"]["system"] = {{1,0.00018103}, {2,0.00024138}, {3,0.00019828}, {4,0.00006897}, {5,0.00009483}, {6,0.00000000}, {7,0.00003448}, {8,0.00000000}, {9,0.00006897}, {10,0.00014655}, {11,0.00016379}, {12,0.00003448}, {13,0.00006897}, {14,0.00009483}, {15,0.00012931}, {16,0.00006897}, {17,0.00006897}, {18,0.00006897}, {19,0.00010345}, {20,0.00018966}, {21,0.00017241}, {22,0.00023276}, {23,0.00019828}, {24,0.00012931}, {25,0.00010345}, {26,0.00012931}, {27,0.00008621}, {28,0.00010345}, {29,0.00026724}, {30,0.00023276}, {31,0.00012931}, {32,0.00002586}, {33,0.00009483}, {34,0.00041379}, {35,0.00013793}, {36,0.00007759}, {37,0.00030172}, {38,0.00006897}, {39,0.00000000}, {40,0.00009483}, {41,0.00008621}, {42,0.00006897}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00003448}, {47,0.00003448}, {48,0.00000000}, {49,0.00003448}, {50,0.00003448}, {51,0.00003448}, {52,0.00006897}, {53,0.00000000}, {54,0.00006897}, {55,0.00006034}, {56,0.00015517}, {57,0.00003448}, {58,0.00000000}, {59,0.00003448}, {60,0.00003448}, {61,0.00000000}, {62,0.00003448}, {63,0.00006034}, {64,0.00010345}, {65,0.00000000}, {66,0.00003448}, {67,0.00000000}, {68,0.00003448}, {69,0.00023276}, {70,0.00000000}, {71,0.00006897}, {72,0.00002586}, {73,0.00002586}, {74,0.00006034}, {75,0.00006897}, {76,0.00006897}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00003448}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00044828}, {85,0.00006897}, {86,0.00006034}, {87,0.00006897}, {88,0.00006897}, {89,0.00003448}, {90,0.00003448}, {91,0.00003448}, {92,0.00000000}, {93,0.00006034}, {94,0.00003448}, {95,0.00012069}, {96,0.00013793}, {97,0.00003448}, {98,0.00003448}, {99,0.00000000}, {100,0.00020690}, {101,0.00003448}, {102,0.00006897}, {103,0.00006897}, {104,0.00000000}, {105,0.00003448}, {106,0.00003448}, {107,0.00000000}, {108,0.00006034}, {109,0.00003448}, {110,0.00006897}, {111,0.00010345}, {112,0.00002586}, {113,0.00060345}, {114,0.00006897}, {115,0.00003448}, {116,0.00010345}, {117,0.00003448}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00003448}, {122,0.00002586}, {123,0.00009483}, {124,0.00003448}, {125,0.00000000}, {126,0.00019828}, {127,0.00013793}, {128,0.00009483}, {129,0.00012931}, {130,0.00017241}, {131,0.00013793}, {132,0.00002586}, {133,0.00010345}, {134,0.00013793}, {135,0.00006897}, {136,0.00006897}, {137,0.00010345}, {138,0.00013793}, {139,0.00012931}, {140,0.00015517}, {141,0.00012069}, {142,0.00002586}, {143,0.00000000}, {144,0.00003448}, {145,0.00009483}, {146,0.00009483}, {147,0.00006034}, {148,0.00006897}, {149,0.00003448}, {150,0.00006034}, {151,0.00003448}, {152,0.00000000}, {153,0.00006897}, {154,0.00003448}, {155,0.00006897}, {156,0.00003448}, {157,0.00010345}, {158,0.00003448}, {159,0.00003448}, {160,0.00003448}, {161,0.00006897}, {162,0.00010345}, {163,0.00010345}, {164,0.00003448}, {165,0.00000000}, {166,0.00006897}, {167,0.00003448}, {168,0.00000000}, {169,0.00003448}, {170,0.00000000}, {171,0.00006034}, {172,0.00000000}, {173,0.00006897}, {174,0.00088793}, {175,0.00003448}, {176,0.00009483}, {177,0.00006034}, {178,0.00010345}, {179,0.00003448}, {180,0.00003448}, {181,0.00012931}, {182,0.00003448}, {183,0.00020690}, {184,0.00006897}, {185,0.00010345}, {186,0.00016379}, {187,0.00000000}, {188,0.00013793}, {189,0.00000000}, {190,0.00012931}, {191,0.00013793}, {192,0.00008621}, {193,0.00006897}, {194,0.00002586}, {195,0.00010345}, {196,0.00010345}, {197,0.00018966}, {198,0.00071552}, {199,0.00030172}, {200,0.00003448}, {201,0.00016379}, {202,0.00006897}, {203,0.00011207}, {204,0.00013793}, {205,0.00158621}, {206,0.00019828}, {207,0.00020690}, {208,0.00020690}, {209,0.00012931}, {210,0.00002586}, {211,0.00006897}, {212,0.00097414}, {213,0.00016379}, {214,0.00003448}, {215,0.00009483}, {216,0.00010345}, {217,0.00017241}, {218,0.00006897}, {219,0.00043103}, {220,0.00006897}, {221,0.00000000}, {222,0.00003448}, {223,0.00010345}, {224,0.00006897}, {225,0.00010345}, {226,0.00002586}, {227,0.00018966}, {228,0.00003448}, {229,0.00006897}, {230,0.00010345}, {231,0.00006897}, {232,0.00056034}, {233,0.00018966}, {234,0.00012069}, {235,0.00016379}, {236,0.00016379}, {237,0.00002586}, {238,0.00006897}, {239,0.00013793}, {240,0.00020690}, {241,0.00006034}, {242,0.00006034}, {243,0.00009483}, {244,0.00013793}, {245,0.00006897}, {246,0.00006897}, {247,0.00003448}, {248,0.00003448}, {249,0.00012069}, {250,0.00006897}, {251,0.00003448}, {252,0.00013793}, {253,0.00006897}, {254,0.00003448}, {255,0.00005172}, {256,0.00013793}, {257,0.00030172}, {258,0.00013793}, {259,0.00022414}, {260,0.00010345}, {261,0.00029310}, {262,0.00068966}, {263,0.00020690}, {264,0.00010345}, {265,0.00006897}, {266,0.00003448}, {267,0.00003448}, {268,0.00030172}, {269,0.00000000}, {270,0.00013793}, {271,0.00030172}, {272,0.00006034}, {273,0.00048276}, {274,0.00026724}, {275,0.00021552}, {276,0.00022414}, {277,0.00006034}, {278,0.00012931}, {279,0.00016379}, {280,0.00013793}, {281,0.00016379}, {282,0.00065517}, {283,0.00234483}, {284,0.00057759}, {285,0.00044828}, {286,0.00003448}, {287,0.00006897}, {288,0.00003448}, {289,0.00018966}, {290,0.00027586}, {291,0.00013793}, {292,0.00012931}, {293,0.00006034}, {294,0.00016379}, {295,0.00010345}, {296,0.00016379}, {297,0.00000000}, {298,0.00006897}, {299,0.00019828}, {300,0.00009483}, {301,0.00010345}, {302,0.00002586}, {303,0.00006897}, {304,0.00006897}, {305,0.00002586}, {306,0.00010345}, {307,0.00010345}, {308,0.00070690}, {309,0.00013793}, {310,0.00003448}, {311,0.00003448}, {312,0.00017241}, {313,0.00075000}, {314,0.00010345}, {315,0.00006897}, {316,0.00006034}, {317,0.00017241}, {318,0.00006897}, {319,0.00010345}, {320,0.00003448}, {321,0.00019828}, {322,0.00017241}, {323,0.00010345}, {324,0.00016379}, {325,0.00020690}, {326,0.00006897}, {327,0.00050862}, {328,0.00000000}, {329,0.00006897}, {330,0.00006897}, {331,0.00000000}, {332,0.00026724}, {333,0.00003448}, {334,0.00017241}, {335,0.00003448}, {336,0.00039655}, {337,0.00027586}, {338,0.00010345}, {339,0.00006897}, {340,0.00006897}, {341,0.00016379}, {342,0.00023276}, {343,0.00013793}, {344,0.00012931}, {345,0.00024138}, {346,0.00015517}, {347,0.00010345}, {348,0.00017241}, {349,0.00016379}, {350,0.00012931}, {351,0.00020690}, {352,0.00010345}, {353,0.00063793}, {354,0.00020690}, {355,0.00010345}, {356,0.00012931}, {357,0.00006034}, {358,0.00013793}, {359,0.00003448}, {360,0.00016379}, {361,0.00006897}, {362,0.00006897}, {363,0.00016379}, {364,0.00024138}, {365,0.00010345}, {366,0.00022414}, {367,0.00025862}, {368,0.00016379}, {369,0.00012931}, {370,0.00019828}, {371,0.00010345}, {372,0.00012931}, {373,0.00013793}, {374,0.00010345}, {375,0.00002586}, {376,0.00006897}, {377,0.00009483}, {378,0.00023276}, {379,0.00013793}, {380,0.00020690}, {381,0.00000000}, {382,0.00017241}, {383,0.00017241}, {384,0.00003448}, {385,0.00010345}, {386,0.00010345}, {387,0.00015517}, {388,0.00003448}, {389,0.00050862}, {390,0.00010345}, {391,0.00003448}, {392,0.00012931}, {393,0.00087069}, {394,0.00012069}, {395,0.00009483}, {396,0.00012931}, {397,0.00054310}, {398,0.00020690}, {399,0.00012931}, {400,0.00013793}, {401,0.00003448}, {402,0.00017241}, {403,0.00010345}, {404,0.00003448}, {405,0.00006897}, {406,0.00020690}, {407,0.00057759}, {408,0.00010345}, {409,0.00010345}, {410,0.00006897}, {411,0.00026724}, {412,0.00012931}, {413,0.00025862}, {414,0.00010345}, {415,0.00023276}, {416,0.00012069}, {417,0.00013793}, {418,0.00109483}, {419,0.00010345}, {420,0.00017241}, {421,0.00020690}, {422,0.00020690}, {423,0.00020690}, {424,0.00017241}, {425,0.00067241}, {426,0.00012069}, {427,0.00023276}, {428,0.00000000}, {429,0.00006897}, {430,0.00019828}, {431,0.00029310}, {432,0.00070690}, {433,0.00016379}, {434,0.00013793}, {435,0.00012931}, {436,0.00027586}, {437,0.00018966}, {438,0.00020690}, {439,0.00020690}, {440,0.00012931}, {441,0.00016379}, {442,0.00079310}, {443,0.00027586}, {444,0.00019828}, {445,0.00006897}, {446,0.00013793}, {447,0.00020690}, {448,0.00010345}, {449,0.00017241}, {450,0.00013793}, {451,0.00013793}, {452,0.00054310}, {453,0.00010345}, {454,0.00013793}, {455,0.00017241}, {456,0.00003448}, {457,0.00013793}, {458,0.00026724}, {459,0.00016379}, {460,0.00006897}, {461,0.00017241}, {462,0.00083621}, {463,0.00003448}, {464,0.00006897}, {465,0.00026724}, {466,0.00026724}, {467,0.00012931}, {468,0.00006897}, {469,0.00017241}, {470,0.00012931}, {471,0.00030172}, {472,0.00027586}, {473,0.00017241}, {474,0.00017241}, {475,0.00031034}, {476,0.00009483}, {477,0.00013793}, {478,0.00010345}, {479,0.00010345}, {480,0.00017241}, {481,0.00047414}, {482,0.00017241}, {483,0.00006897}, {484,0.00041379}, {485,0.00017241}, {486,0.00033621}, {487,0.00062069}, {488,0.00019828}, {489,0.00020690}, {490,0.00076724}, {491,0.00023276}, {492,0.00013793}, {493,0.00058621}, {494,0.00017241}, {495,0.00016379}, {496,0.00081897}, {497,0.00034483}, {498,0.00020690}, {499,0.00068966}, {500,0.000212121}, {505,0.00088696}, {510,0.00020870}, {515,0.00012174}, {520,0.00059130}, {525,0.00027826}, {530,0.00017391}, {535,0.00046957}, {540,0.00006957}, {545,0.00002609}, {550,0.00013913}, {555,0.00010435}, {560,0.00006087}, {565,0.00024348}, {570,0.00028070}, {575,0.00057018}, {580,0.00031579}, {585,0.00017544}, {590,0.00059649}, {595,0.00014035}, {600,0.00066087}, {605,0.00020175}, {610,0.00014035}, {615,0.00020175}, {620,0.00023684}, {625,0.00092982}, {630,0.00010526}, {635,0.00030702}, {640,0.00038596}, {645,0.00048246}, {650,0.00013158}, {655,0.00031579}, {660,0.00071930}, {665,0.00017544}, {670,0.00056140}, {675,0.00031579}, {680,0.00009649}, {685,0.00017544}, {690,0.00014035}, {695,0.00016667}, {700,0.00029565}, {705,0.00024561}, {710,0.00028070}, {715,0.00030702}, {720,0.00035088}, {725,0.00073684}, {730,0.00031579}, {735,0.00071930}, {740,0.00021053}, {745,0.00072807}, {750,0.00006140}, {755,0.00056140}, {760,0.00009649}, {765,0.00088596}, {770,0.00045614}, {775,0.00056140}, {780,0.00054386}, {785,0.00017544}, {790,0.00030702}, {795,0.00016667}, {800,0.00013913}, {805,0.00027193}, {810,0.00020175}, {815,0.00061404}, {820,0.00034211}, {825,0.00092105}, {830,0.00038596}, {835,0.00086842}, {840,0.00017544}, {845,0.00017544}, {850,0.00031579}, {855,0.00020175}, {860,0.00010526}, {865,0.00021053}, {870,0.00021053}, {875,0.00023684}, {880,0.00035088}, {885,0.00049123}, {890,0.00024561}, {895,0.00035088}, {900,0.00020870}, {905,0.00021053}, {910,0.00049123}, {915,0.00024561}, {920,0.00048246}, {925,0.00003509}, {930,0.00021053}, {935,0.00190351}, {940,0.00030702}, {945,0.00029825}, {950,0.00106140}, {955,0.00038596}, {960,0.00042105}, {965,0.00086842}, {970,0.00059649}, {975,0.00024561}, {980,0.00094737}, {985,0.00024561}, {990,0.00030702}, {995,0.00106140}, {1000,0.00041739}, {1010,0.00300}, {1020,0.00100}, {1030,0.00175}, {1040,0.00000}, {1050,0.00100}, {1060,0.00175}, {1070,0.00000}, {1080,0.00000}, {1090,0.00000}, {1100,0.00100}, {1110,0.00000}, {1120,0.00100}, {1130,0.00000}, {1140,0.00000}, {1150,0.00000}, {1160,0.00075}, {1170,0.00000}, {1180,0.00275}, {1190,0.00275}, {1200,0.00000}, {1210,0.00000}, {1220,0.00000}, {1230,0.00100}, {1240,0.00075}, {1250,0.00100}, {1260,0.00000}, {1270,0.00000}, {1280,0.00000}, {1290,0.00000}, {1300,0.00000}, {1310,0.00000}, {1320,0.00200}, {1330,0.00250}, {1340,0.00200}, {1350,0.00000}, {1360,0.00000}, {1370,0.00000}, {1380,0.00000}, {1390,0.00000}, {1400,0.00100}, {1410,0.00200}, {1420,0.00100}, {1430,0.00000}, {1440,0.00100}, {1450,0.00175}, {1460,0.00175}, {1470,0.00000}, {1480,0.00000}, {1490,0.00375}, {1500,0.00240}, {1510,0.00100}, {1520,0.00100}, {1530,0.00000}, {1540,0.00000}, {1550,0.00000}, {1560,0.00200}, {1570,0.00000}, {1580,0.00000}, {1590,0.00000}, {1600,0.00000}, {1610,0.00000}, {1620,0.00200}, {1630,0.00075}, {1640,0.00000}, {1650,0.00000}, {1660,0.00000}, {1670,0.00100}, {1680,0.00000}, {1690,0.00000}, {1700,0.00100}, {1710,0.00000}, {1720,0.00375}, {1730,0.00500}, {1740,0.00475}, {1750,0.00000}, {1760,0.00200}, {1770,0.00100}, {1780,0.00500}, {1790,0.00500}, {1800,0.00500}, {1810,0.00000}, {1820,0.00000}, {1830,0.00500}, {1840,0.00600}, {1850,0.00100}, {1860,0.00000}, {1870,0.00400}, {1880,0.00775}, {1890,0.00175}, {1900,0.00000}, {1910,0.00700}, {1920,0.00200}, {1930,0.00100}, {1940,0.00100}, {1950,0.00000}, {1960,0.00200}, {1970,0.00000}, {1980,0.00200}, {1990,0.00000}, {2000,0.00000}, {2050,0.00500}, {2100,0.00100}, {2150,0.00600}, {2200,0.00875}, {2250,0.00000}, {2300,0.00800}, {2350,0.00400}, {2400,0.00400}, {2450,0.00000}, {2500,0.00480}, {2550,0.00875}, {2600,0.00000}, {2650,0.00400}, {2700,0.00900}, {2750,0.00800}, {2800,0.00875}, {2850,0.00500}, {2900,0.00975}, {2950,0.00000}, {3000,0.00560}, {3050,0.00400}, {3100,0.00300}, {3150,0.00200}, {3200,0.01100}, {3250,0.01100}, {3300,0.00600}, {3350,0.00000}, {3400,0.01175}, {3450,0.00775}, {3500,0.00320}, {3550,0.01100}, {3600,0.00800}, {3650,0.01000}, {3700,0.00800}, {3750,0.01100}, {3800,0.01200}, {3850,0.01000}, {3900,0.00800}, {3950,0.01175}, {4000,0.01080}, {4050,0.00775}, {4100,0.00800}, {4150,0.00975}, {4200,0.01400}, {4250,0.01000}, {4300,0.01175}, {4350,0.00400}, {4400,0.00800}, {4450,0.00900}, {4500,0.00720}, {4550,0.01100}, {4600,0.01000}, {4650,0.01600}, {4700,0.00400}, {4750,0.00300}, {4800,0.00100}, {4850,0.00200}, {4900,0.00100}, {4950,0.00000}, {5000,0.00060}};
data["big_flat"]["printing"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00038532}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000917}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00001835}, {224,0.00000917}, {225,0.00000917}, {226,0.00002752}, {227,0.00001835}, {228,0.00001835}, {229,0.00000917}, {230,0.00000917}, {231,0.00000000}, {232,0.00002752}, {233,0.00002752}, {234,0.00002752}, {235,0.00004587}, {236,0.00004587}, {237,0.00003670}, {238,0.00005505}, {239,0.00006422}, {240,0.00006422}, {241,0.00008257}, {242,0.00007339}, {243,0.00006422}, {244,0.00005505}, {245,0.00004587}, {246,0.00001835}, {247,0.00004587}, {248,0.00006422}, {249,0.00007339}, {250,0.00014679}, {251,0.00010092}, {252,0.00015596}, {253,0.00019266}, {254,0.00028440}, {255,0.00038532}, {256,0.00033945}, {257,0.00047706}, {258,0.00066972}, {259,0.00066055}, {260,0.00082569}, {261,0.00080734}, {262,0.00086239}, {263,0.00086239}, {264,0.00089908}, {265,0.00093578}, {266,0.00098165}, {267,0.00098165}, {268,0.00100000}, {269,0.00100000}, {270,0.00100000}, {271,0.00100000}, {272,0.00100000}, {273,0.00100000}, {274,0.00100000}, {275,0.00100000}, {276,0.00100000}, {277,0.00100000}, {278,0.00100000}, {279,0.00100000}, {280,0.00100000}, {281,0.00100000}, {282,0.00100000}, {283,0.00100000}, {284,0.00100000}, {285,0.00100000}, {286,0.00100000}, {287,0.00100000}, {288,0.00100000}, {289,0.00100000}, {290,0.00100000}, {291,0.00100000}, {292,0.00100000}, {293,0.00100000}, {294,0.00100000}, {295,0.00100000}, {296,0.00100000}, {297,0.00100000}, {298,0.00100000}, {299,0.00100000}, {300,0.00100000}, {301,0.00266055}, {302,0.00100000}, {303,0.00100000}, {304,0.00100000}, {305,0.00100000}, {306,0.00100000}, {307,0.00100000}, {308,0.00100000}, {309,0.00100000}, {310,0.00100000}, {311,0.00100000}, {312,0.00100000}, {313,0.00100000}, {314,0.00100000}, {315,0.00100000}, {316,0.00100000}, {317,0.00100000}, {318,0.00100000}, {319,0.00100000}, {320,0.00100000}, {321,0.00100000}, {322,0.00100000}, {323,0.00100000}, {324,0.00100000}, {325,0.00100000}, {326,0.00100000}, {327,0.00100000}, {328,0.00100000}, {329,0.00100000}, {330,0.00100000}, {331,0.00100000}, {332,0.00100000}, {333,0.00100000}, {334,0.00100000}, {335,0.00100000}, {336,0.00100000}, {337,0.00100000}, {338,0.00100000}, {339,0.00100000}, {340,0.00100000}, {341,0.00100000}, {342,0.00100000}, {343,0.00100000}, {344,0.00100000}, {345,0.00100000}, {346,0.00100000}, {347,0.00100000}, {348,0.00100000}, {349,0.00100000}, {350,0.00100000}, {351,0.00100000}, {352,0.00100000}, {353,0.00100000}, {354,0.00100000}, {355,0.00100000}, {356,0.00100000}, {357,0.00100000}, {358,0.00100000}, {359,0.00100000}, {360,0.00100000}, {361,0.00100000}, {362,0.00103670}, {363,0.00100000}, {364,0.00100000}, {365,0.00100000}, {366,0.00300000}, {367,0.00100000}, {368,0.00100000}, {369,0.00100000}, {370,0.00100000}, {371,0.00100000}, {372,0.00100000}, {373,0.00100000}, {374,0.00100000}, {375,0.00100000}, {376,0.00100000}, {377,0.00100000}, {378,0.00100000}, {379,0.00100000}, {380,0.00100000}, {381,0.00100000}, {382,0.00100000}, {383,0.00100000}, {384,0.00100000}, {385,0.00100000}, {386,0.00100000}, {387,0.00100000}, {388,0.00100000}, {389,0.00100000}, {390,0.00100000}, {391,0.00100000}, {392,0.00100000}, {393,0.00100000}, {394,0.00100000}, {395,0.00100000}, {396,0.00100000}, {397,0.00100000}, {398,0.00100000}, {399,0.00100000}, {400,0.00100000}, {401,0.00100000}, {402,0.00100000}, {403,0.00100000}, {404,0.00100000}, {405,0.00100000}, {406,0.00100000}, {407,0.00100000}, {408,0.00100000}, {409,0.00100000}, {410,0.00100000}, {411,0.00100000}, {412,0.00100000}, {413,0.00100000}, {414,0.00100000}, {415,0.00100000}, {416,0.00100000}, {417,0.00100000}, {418,0.00100000}, {419,0.00103670}, {420,0.00100000}, {421,0.00100000}, {422,0.00100000}, {423,0.00100000}, {424,0.00100000}, {425,0.00100000}, {426,0.00100000}, {427,0.00100000}, {428,0.00100000}, {429,0.00100000}, {430,0.00100000}, {431,0.00100000}, {432,0.00100000}, {433,0.00100000}, {434,0.00100000}, {435,0.00100000}, {436,0.00100000}, {437,0.00100000}, {438,0.00100000}, {439,0.00100000}, {440,0.00100000}, {441,0.00100000}, {442,0.00100000}, {443,0.00100000}, {444,0.00100000}, {445,0.00100000}, {446,0.00100000}, {447,0.00100000}, {448,0.00100000}, {449,0.00100000}, {450,0.00100000}, {451,0.00100000}, {452,0.00100000}, {453,0.00100000}, {454,0.00100000}, {455,0.00100000}, {456,0.00100000}, {457,0.00100000}, {458,0.00100000}, {459,0.00100000}, {460,0.00100000}, {461,0.00100917}, {462,0.00100917}, {463,0.00100000}, {464,0.00100000}, {465,0.00100000}, {466,0.00101835}, {467,0.00100000}, {468,0.00100917}, {469,0.00100000}, {470,0.00101835}, {471,0.00101835}, {472,0.00100917}, {473,0.00294495}, {474,0.00100000}, {475,0.00101835}, {476,0.00100917}, {477,0.00101835}, {478,0.00102752}, {479,0.00100917}, {480,0.00102752}, {481,0.00102752}, {482,0.00101835}, {483,0.00102752}, {484,0.00100917}, {485,0.00102752}, {486,0.00102752}, {487,0.00107339}, {488,0.00105505}, {489,0.00103670}, {490,0.00105505}, {491,0.00106422}, {492,0.00107339}, {493,0.00108257}, {494,0.00110092}, {495,0.00110092}, {496,0.00111009}, {497,0.00107339}, {498,0.00116514}, {499,0.00111927}, {500,0.00118349}, {505,0.00128440}, {510,0.00146789}, {515,0.00170642}, {520,0.00174312}, {525,0.00184404}, {530,0.00196330}, {535,0.00197248}, {540,0.00199083}, {545,0.00200000}, {550,0.00200000}, {555,0.00200000}, {560,0.00200000}, {565,0.00200000}, {570,0.00200000}, {575,0.00203670}, {580,0.00200000}, {585,0.00200000}, {590,0.00200000}, {595,0.00200000}, {600,0.00200000}, {605,0.00200000}, {610,0.00200000}, {615,0.00200000}, {620,0.00200000}, {625,0.00200000}, {630,0.00200000}, {635,0.00200000}, {640,0.00200000}, {645,0.00200000}, {650,0.00200000}, {655,0.00200000}, {660,0.00200000}, {665,0.00200000}, {670,0.00200000}, {675,0.00200000}, {680,0.00200000}, {685,0.00200000}, {690,0.00200000}, {695,0.00200917}, {700,0.00200917}, {705,0.00202752}, {710,0.00201835}, {715,0.00200917}, {720,0.00204587}, {725,0.00208257}, {730,0.00217431}, {735,0.00221101}, {740,0.00222936}, {745,0.00232110}, {750,0.00242202}, {755,0.00263303}, {760,0.00275229}, {765,0.00280734}, {770,0.00285321}, {775,0.00289908}, {780,0.00291743}, {785,0.00297248}, {790,0.00300000}, {795,0.00299083}, {800,0.00299083}, {805,0.00299083}, {810,0.00299083}, {815,0.00299083}, {820,0.00299083}, {825,0.00300000}, {830,0.00300000}, {835,0.00300000}, {840,0.00300000}, {845,0.00300000}, {850,0.00300000}, {855,0.00300000}, {860,0.00300000}, {865,0.00300000}, {870,0.00300000}, {875,0.00300000}, {880,0.00300000}, {885,0.00300000}, {890,0.00300000}, {895,0.00303670}, {900,0.00300000}, {905,0.00540367}, {910,0.00300000}, {915,0.00300000}, {920,0.00300000}, {925,0.00300000}, {930,0.00301835}, {935,0.00302752}, {940,0.00304587}, {945,0.00301835}, {950,0.00304587}, {955,0.00306422}, {960,0.00309174}, {965,0.00315596}, {970,0.00322936}, {975,0.00340367}, {980,0.00348624}, {985,0.00353211}, {990,0.00357798}, {995,0.00365138}, {1000,0.00376147}, {1010,0.00391743}, {1020,0.00397248}, {1030,0.00400000}, {1040,0.00403670}, {1050,0.00399083}, {1060,0.00719266}, {1070,0.00400000}, {1080,0.00400000}, {1090,0.00400000}, {1100,0.00400000}, {1110,0.00400000}, {1120,0.00400000}, {1130,0.00400917}, {1140,0.00400000}, {1150,0.00402752}, {1160,0.00403670}, {1170,0.00406422}, {1180,0.00409174}, {1190,0.00421101}, {1200,0.00421101}, {1210,0.00432110}, {1220,0.00449541}, {1230,0.00466055}, {1240,0.00479817}, {1250,0.00483486}, {1260,0.00490826}, {1270,0.00759633}, {1280,0.00497248}, {1290,0.00497248}, {1300,0.00500000}, {1310,0.00500000}, {1320,0.00500000}, {1330,0.00500000}, {1340,0.00501835}, {1350,0.00501835}, {1360,0.00500917}, {1370,0.00501835}, {1380,0.00504587}, {1390,0.00505505}, {1400,0.00511927}, {1410,0.00509174}, {1420,0.00515596}, {1430,0.00528440}, {1440,0.00533945}, {1450,0.01014679}, {1460,0.00577982}, {1470,0.00577982}, {1480,0.00584404}, {1490,0.00590826}, {1500,0.00595413}, {1510,0.00596330}, {1520,0.00599083}, {1530,0.00600000}, {1540,0.00600000}, {1550,0.00601835}, {1560,0.00600000}, {1570,0.00600000}, {1580,0.00601835}, {1590,0.00603670}, {1600,0.00614679}, {1610,0.01218349}, {1620,0.00613761}, {1630,0.00611927}, {1640,0.00619266}, {1650,0.00633945}, {1660,0.00634862}, {1670,0.00646789}, {1680,0.00656881}, {1690,0.00672477}, {1700,0.00678899}, {1710,0.00681651}, {1720,0.00690826}, {1730,0.00690826}, {1740,0.00693578}, {1750,0.00693578}, {1760,0.00697248}, {1770,0.00701835}, {1780,0.00701835}, {1790,0.00701835}, {1800,0.00704587}, {1810,0.00703670}, {1820,0.00708257}, {1830,0.00709174}, {1840,0.00708257}, {1850,0.00714679}, {1860,0.00720183}, {1870,0.00731193}, {1880,0.00737615}, {1890,0.01264220}, {1900,0.00749541}, {1910,0.00755963}, {1920,0.00765138}, {1930,0.00768807}, {1940,0.00778899}, {1950,0.00788991}, {1960,0.00793578}, {1970,0.00797248}, {1980,0.00794495}, {1990,0.00796330}, {2000,0.00797248}, {2050,0.00821101}, {2100,0.01184404}, {2150,0.00864220}, {2200,0.00896330}, {2250,0.00908257}, {2300,0.00923853}, {2350,0.00947706}, {2400,0.00978899}, {2450,0.01000000}, {2500,0.01021101}, {2550,0.01046789}, {2600,0.01683486}, {2650,0.01091743}, {2700,0.01112844}, {2750,0.01144037}, {2800,0.01164220}, {2850,0.01186239}, {2900,0.01206422}, {2950,0.01228440}, {3000,0.01252294}, {3050,0.02139450}, {3100,0.01299083}, {3150,0.01324771}, {3200,0.01346789}, {3250,0.01363303}, {3300,0.01388991}, {3350,0.01413761}, {3400,0.01455046}, {3450,0.02375229}, {3500,0.01481651}, {3550,0.01508257}, {3600,0.01530275}, {3650,0.01546789}, {3700,0.01570642}, {3750,0.01600917}, {3800,0.02656881}, {3850,0.01638532}, {3900,0.01666055}, {3950,0.01688073}, {4000,0.01705505}, {4050,0.01729358}, {4100,0.03100000}, {4150,0.01776147}, {4200,0.01789908}, {4250,0.01824771}, {4300,0.01855046}, {4350,0.01869725}, {4400,0.03169725}, {4450,0.01911009}, {4500,0.01939450}, {4550,0.01962385}, {4600,0.01975229}, {4650,0.02007339}, {4700,0.02018349}, {4750,0.02061468}, {4800,0.02075229}, {4850,0.02083486}, {4900,0.02103670}, {4950,0.03039450}, {5000,0.02164220}, {5050,0.02172477}, {5100,0.02196330}, {5150,0.02239450}, {5200,0.03879817}, {5250,0.02270642}, {5300,0.02287156}, {5350,0.02324771}, {5400,0.02349541}, {5450,0.02369725}, {5500,0.02388073}, {5550,0.02400917}, {5600,0.02422018}, {5650,0.03744037}, {5700,0.02476147}, {5750,0.02488073}, {5800,0.02506422}, {5850,0.02564220}, {5900,0.02569725}, {5950,0.02581651}, {6000,0.02603670}, {6050,0.02626606}, {6100,0.03478899}, {6150,0.02672477}, {6200,0.02696330}, {6250,0.02705505}, {6300,0.04975229}, {6350,0.02760550}, {6400,0.02787156}, {6450,0.02801835}, {6500,0.04779817}, {6550,0.02857798}, {6600,0.02875229}, {6650,0.02918349}, {6700,0.02907339}, {6750,0.02932110}, {6800,0.02959633}, {6850,0.04038532}, {6900,0.02999083}, {6950,0.03018349}, {7000,0.03040367}, {7050,0.04689908}, {7100,0.03092661}, {7150,0.03106422}, {7200,0.03168807}, {7250,0.03162385}, {7300,0.03184404}, {7350,0.03206422}, {7400,0.05678899}, {7450,0.03250459}, {7500,0.03269725}, {7550,0.06907339}, {7600,0.03311927}, {7650,0.03342202}, {7700,0.03366055}, {7750,0.03717431}, {7800,0.03399083}, {7850,0.03418349}, {7900,0.05966055}, {7950,0.03467890}, {8000,0.03492661}, {8050,0.06556881}, {8100,0.03533945}, {8150,0.03559633}, {8200,0.05497248}, {8250,0.03607339}, {8300,0.03622936}, {8350,0.05822018}, {8400,0.03666972}, {8450,0.03693578}, {8500,0.05955963}, {8550,0.03723853}, {8600,0.03763303}, {8650,0.05745872}, {8700,0.03800000}, {8750,0.03838532}, {8800,0.06765138}, {8850,0.03863303}, {8900,0.03891743}, {8950,0.06807339}, {9000,0.03935780}, {9050,0.03956881}, {9100,0.06862385}, {9150,0.03989908}, {9200,0.04015596}, {9250,0.04050459}, {9300,0.04055963}, {9350,0.05907339}, {9400,0.04119266}, {9450,0.04130275}, {9500,0.07133028}, {9550,0.04170642}, {9600,0.04195413}, {9650,0.04224771}, {9700,0.04239450}, {9750,0.05567890}, {9800,0.04279817}, {9850,0.04317431}, {9900,0.07214679}, {9950,0.04357798}, {10000,0.04422936}, {10100,0.04425688}, {10200,0.04466972}, {10300,0.06318349}, {10400,0.04552294}, {10500,0.07744037}, {10600,0.04633028}, {10700,0.04689908}, {10800,0.06480734}, {10900,0.04777982}, {11000,0.08604587}, {11100,0.04848624}, {11200,0.06602752}, {11300,0.04940367}, {11400,0.04972477}, {11500,0.05023853}, {11600,0.05068807}, {11700,0.07200917}, {11800,0.05166972}, {11900,0.08749541}, {12000,0.05251376}, {12100,0.09827523}, {12200,0.05326606}, {12300,0.09489908}, {12400,0.05406422}, {12500,0.09566055}, {12600,0.05523853}, {12700,0.09725688}, {12800,0.05608257}, {12900,0.09875229}, {13000,0.05673394}, {13100,0.09955046}, {13200,0.05788073}, {13300,0.10114679}, {13400,0.05877064}, {13500,0.10281651}, {13600,0.05947706}, {13700,0.10429358}, {13800,0.06047706}, {13900,0.06099083}, {14000,0.06187156}, {14100,0.06195413}, {14200,0.09231193}, {14300,0.06274312}, {14400,0.10796330}, {14500,0.06361468}, {14600,0.10853211}, {14700,0.06444954}, {14800,0.06488073}, {14900,0.08995413}, {15000,0.06566055}, {15100,0.11157798}, {15200,0.06659633}, {15300,0.06700917}, {15400,0.09081651}, {15500,0.06799083}, {15600,0.11481651}, {15700,0.06868807}, {15800,0.06915596}, {15900,0.10948624}, {16000,0.06998165}, {16100,0.10356881}, {16200,0.12548624}, {16300,0.07139450}, {16400,0.11305505}, {16500,0.07296330}, {16600,0.07267890}, {16700,0.10723853}, {16800,0.07522936}, {16900,0.07426606}, {17000,0.11618349}, {17100,0.07649541}, {17200,0.07540367}, {17300,0.12522936}, {17400,0.13277982}, {17500,0.07665138}, {17600,0.10843119}, {17700,0.13733945}, {17800,0.07788991}, {17900,0.11419266}, {18000,0.15922936}, {18100,0.07955046}, {18200,0.07972477}, {18300,0.12525688}, {18400,0.13423853}, {18500,0.08136697}, {18600,0.11155046}, {18700,0.17294495}, {18800,0.08370642}, {18900,0.08288991}, {19000,0.11798165}, {19100,0.16196330}, {19200,0.08476147}, {19300,0.08458716}, {19400,0.13166055}, {19500,0.16413761}, {19600,0.14955046}, {19700,0.08633945}, {19800,0.08702752}, {19900,0.12312844}, {20000,0.13653271}};
data["big_flat"]["printing"]["Stats"]["user"] = {{1,0.00003670}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00005505}, {8,0.00012844}, {9,0.00009174}, {10,0.00000000}, {11,0.00012844}, {12,0.00000000}, {13,0.00011927}, {14,0.00015596}, {15,0.00003670}, {16,0.00000000}, {17,0.00010092}, {18,0.00009174}, {19,0.00010092}, {20,0.00015596}, {21,0.00013761}, {22,0.00000000}, {23,0.00020183}, {24,0.00006422}, {25,0.00022018}, {26,0.00003670}, {27,0.00006422}, {28,0.00010092}, {29,0.00015596}, {30,0.00020183}, {31,0.00011927}, {32,0.00014679}, {33,0.00006422}, {34,0.00006422}, {35,0.00015596}, {36,0.00006422}, {37,0.00005505}, {38,0.00010092}, {39,0.00010092}, {40,0.00006422}, {41,0.00019266}, {42,0.00021101}, {43,0.00025688}, {44,0.00011927}, {45,0.00014679}, {46,0.00007339}, {47,0.00022936}, {48,0.00015596}, {49,0.00017431}, {50,0.00013761}, {51,0.00022936}, {52,0.00009174}, {53,0.00020183}, {54,0.00019266}, {55,0.00035780}, {56,0.00026606}, {57,0.00024771}, {58,0.00014679}, {59,0.00026606}, {60,0.00011927}, {61,0.00019266}, {62,0.00028440}, {63,0.00020183}, {64,0.00025688}, {65,0.00021101}, {66,0.00038532}, {67,0.00022936}, {68,0.00022018}, {69,0.00018349}, {70,0.00025688}, {71,0.00015596}, {72,0.00023853}, {73,0.00031193}, {74,0.00016514}, {75,0.00026606}, {76,0.00023853}, {77,0.00022936}, {78,0.00017431}, {79,0.00031193}, {80,0.00024771}, {81,0.00031193}, {82,0.00041284}, {83,0.00027523}, {84,0.00032110}, {85,0.00037615}, {86,0.00036697}, {87,0.00040367}, {88,0.00041284}, {89,0.00033028}, {90,0.00024771}, {91,0.00030275}, {92,0.00052294}, {93,0.00032110}, {94,0.00035780}, {95,0.00044037}, {96,0.00039450}, {97,0.00076147}, {98,0.00050459}, {99,0.00020183}, {100,0.00044954}, {101,0.00032110}, {102,0.00015596}, {103,0.00065138}, {104,0.00035780}, {105,0.00044037}, {106,0.00029358}, {107,0.00029358}, {108,0.00038532}, {109,0.00045872}, {110,0.00039450}, {111,0.00043119}, {112,0.00028440}, {113,0.00045872}, {114,0.00046789}, {115,0.00036697}, {116,0.00040367}, {117,0.00045872}, {118,0.00041284}, {119,0.00042202}, {120,0.00035780}, {121,0.00048624}, {122,0.00046789}, {123,0.00044954}, {124,0.00038532}, {125,0.00033945}, {126,0.00042202}, {127,0.00031193}, {128,0.00051376}, {129,0.00048624}, {130,0.00048624}, {131,0.00049541}, {132,0.00038532}, {133,0.00039450}, {134,0.00051376}, {135,0.00066972}, {136,0.00040367}, {137,0.00050459}, {138,0.00038532}, {139,0.00041284}, {140,0.00049541}, {141,0.00032110}, {142,0.00053211}, {143,0.00047706}, {144,0.00077064}, {145,0.00040367}, {146,0.00055963}, {147,0.00033028}, {148,0.00055046}, {149,0.00052294}, {150,0.00077064}, {151,0.00035780}, {152,0.00066055}, {153,0.00044954}, {154,0.00066055}, {155,0.00037615}, {156,0.00064220}, {157,0.00048624}, {158,0.00051376}, {159,0.00035780}, {160,0.00063303}, {161,0.00054128}, {162,0.00053211}, {163,0.00041284}, {164,0.00066972}, {165,0.00054128}, {166,0.00038532}, {167,0.00055046}, {168,0.00076147}, {169,0.00055046}, {170,0.00043119}, {171,0.00073394}, {172,0.00057798}, {173,0.00064220}, {174,0.00045872}, {175,0.00080734}, {176,0.00050459}, {177,0.00067890}, {178,0.00066055}, {179,0.00077982}, {180,0.00054128}, {181,0.00044037}, {182,0.00073394}, {183,0.00077064}, {184,0.00070642}, {185,0.00053211}, {186,0.00079817}, {187,0.00047706}, {188,0.00056881}, {189,0.00071560}, {190,0.00077064}, {191,0.00060550}, {192,0.00066055}, {193,0.00086239}, {194,0.00050459}, {195,0.00073394}, {196,0.00079817}, {197,0.00066972}, {198,0.00058716}, {199,0.00068807}, {200,0.00081651}, {201,0.00061468}, {202,0.00097248}, {203,0.00064220}, {204,0.00064220}, {205,0.00068807}, {206,0.00052294}, {207,0.00073394}, {208,0.00059633}, {209,0.00073394}, {210,0.00076147}, {211,0.00066055}, {212,0.00092661}, {213,0.00066972}, {214,0.00067890}, {215,0.00092661}, {216,0.00057798}, {217,0.00066972}, {218,0.00094495}, {219,0.00053211}, {220,0.00086239}, {221,0.00106422}, {222,0.00083486}, {223,0.00077982}, {224,0.00064220}, {225,0.00077064}, {226,0.00081651}, {227,0.00064220}, {228,0.00094495}, {229,0.00088073}, {230,0.00061468}, {231,0.00103670}, {232,0.00089908}, {233,0.00059633}, {234,0.00108257}, {235,0.00086239}, {236,0.00049541}, {237,0.00101835}, {238,0.00072477}, {239,0.00075229}, {240,0.00101835}, {241,0.00062385}, {242,0.00077064}, {243,0.00122018}, {244,0.00062385}, {245,0.00073394}, {246,0.00113761}, {247,0.00064220}, {248,0.00095413}, {249,0.00106422}, {250,0.00071560}, {251,0.00086239}, {252,0.00083486}, {253,0.00082569}, {254,0.00111927}, {255,0.00066055}, {256,0.00078899}, {257,0.00113761}, {258,0.00070642}, {259,0.00096330}, {260,0.00088073}, {261,0.00101835}, {262,0.00103670}, {263,0.00061468}, {264,0.00099083}, {265,0.00101835}, {266,0.00070642}, {267,0.00067890}, {268,0.00096330}, {269,0.00100000}, {270,0.00094495}, {271,0.00076147}, {272,0.00097248}, {273,0.00107339}, {274,0.00093578}, {275,0.00096330}, {276,0.00081651}, {277,0.00102752}, {278,0.00112844}, {279,0.00094495}, {280,0.00082569}, {281,0.00073394}, {282,0.00080734}, {283,0.00101835}, {284,0.00102752}, {285,0.00088073}, {286,0.00096330}, {287,0.00085321}, {288,0.00116514}, {289,0.00091743}, {290,0.00103670}, {291,0.00107339}, {292,0.00070642}, {293,0.00125688}, {294,0.00102752}, {295,0.00102752}, {296,0.00090826}, {297,0.00069725}, {298,0.00135780}, {299,0.00100917}, {300,0.00133028}, {301,0.00260550}, {302,0.00095413}, {303,0.00097248}, {304,0.00112844}, {305,0.00087156}, {306,0.00112844}, {307,0.00094495}, {308,0.00112844}, {309,0.00106422}, {310,0.00085321}, {311,0.00133028}, {312,0.00099083}, {313,0.00127523}, {314,0.00092661}, {315,0.00118349}, {316,0.00106422}, {317,0.00104587}, {318,0.00113761}, {319,0.00095413}, {320,0.00122018}, {321,0.00083486}, {322,0.00130275}, {323,0.00105505}, {324,0.00109174}, {325,0.00117431}, {326,0.00097248}, {327,0.00112844}, {328,0.00095413}, {329,0.00133945}, {330,0.00115596}, {331,0.00133028}, {332,0.00092661}, {333,0.00124771}, {334,0.00108257}, {335,0.00100917}, {336,0.00099083}, {337,0.00106422}, {338,0.00121101}, {339,0.00098165}, {340,0.00121101}, {341,0.00103670}, {342,0.00125688}, {343,0.00121101}, {344,0.00144954}, {345,0.00112844}, {346,0.00129358}, {347,0.00114679}, {348,0.00137615}, {349,0.00086239}, {350,0.00133945}, {351,0.00107339}, {352,0.00125688}, {353,0.00104587}, {354,0.00136697}, {355,0.00122018}, {356,0.00144954}, {357,0.00125688}, {358,0.00125688}, {359,0.00119266}, {360,0.00129358}, {361,0.00127523}, {362,0.00120183}, {363,0.00108257}, {364,0.00124771}, {365,0.00118349}, {366,0.00329358}, {367,0.00122936}, {368,0.00124771}, {369,0.00131193}, {370,0.00122936}, {371,0.00126606}, {372,0.00127523}, {373,0.00132110}, {374,0.00120183}, {375,0.00150459}, {376,0.00125688}, {377,0.00136697}, {378,0.00133028}, {379,0.00131193}, {380,0.00128440}, {381,0.00136697}, {382,0.00152294}, {383,0.00133945}, {384,0.00143119}, {385,0.00124771}, {386,0.00153211}, {387,0.00115596}, {388,0.00148624}, {389,0.00125688}, {390,0.00147706}, {391,0.00108257}, {392,0.00134862}, {393,0.00109174}, {394,0.00139450}, {395,0.00130275}, {396,0.00148624}, {397,0.00146789}, {398,0.00138532}, {399,0.00152294}, {400,0.00144954}, {401,0.00139450}, {402,0.00141284}, {403,0.00137615}, {404,0.00103670}, {405,0.00141284}, {406,0.00130275}, {407,0.00141284}, {408,0.00137615}, {409,0.00145872}, {410,0.00142202}, {411,0.00141284}, {412,0.00139450}, {413,0.00147706}, {414,0.00144954}, {415,0.00144954}, {416,0.00143119}, {417,0.00153211}, {418,0.00127523}, {419,0.00140367}, {420,0.00155963}, {421,0.00129358}, {422,0.00142202}, {423,0.00138532}, {424,0.00150459}, {425,0.00155963}, {426,0.00129358}, {427,0.00173394}, {428,0.00139450}, {429,0.00151376}, {430,0.00149541}, {431,0.00133028}, {432,0.00168807}, {433,0.00126606}, {434,0.00151376}, {435,0.00144954}, {436,0.00169725}, {437,0.00153211}, {438,0.00143119}, {439,0.00161468}, {440,0.00128440}, {441,0.00174312}, {442,0.00152294}, {443,0.00151376}, {444,0.00177064}, {445,0.00122936}, {446,0.00163303}, {447,0.00154128}, {448,0.00161468}, {449,0.00150459}, {450,0.00121101}, {451,0.00171560}, {452,0.00161468}, {453,0.00140367}, {454,0.00165138}, {455,0.00135780}, {456,0.00163303}, {457,0.00144037}, {458,0.00177982}, {459,0.00163303}, {460,0.00144037}, {461,0.00166972}, {462,0.00135780}, {463,0.00163303}, {464,0.00172477}, {465,0.00147706}, {466,0.00172477}, {467,0.00150459}, {468,0.00151376}, {469,0.00187156}, {470,0.00150459}, {471,0.00184404}, {472,0.00147706}, {473,0.00268807}, {474,0.00144954}, {475,0.00184404}, {476,0.00143119}, {477,0.00174312}, {478,0.00154128}, {479,0.00153211}, {480,0.00191743}, {481,0.00160550}, {482,0.00165138}, {483,0.00187156}, {484,0.00135780}, {485,0.00180734}, {486,0.00174312}, {487,0.00157798}, {488,0.00200000}, {489,0.00163303}, {490,0.00190826}, {491,0.00177064}, {492,0.00160550}, {493,0.00186239}, {494,0.00179817}, {495,0.00159633}, {496,0.00176147}, {497,0.00172477}, {498,0.00169725}, {499,0.00188073}, {500,0.00167890}, {505,0.00178899}, {510,0.00178899}, {515,0.00155046}, {520,0.00193578}, {525,0.00196330}, {530,0.00164220}, {535,0.00201835}, {540,0.00213761}, {545,0.00177982}, {550,0.00183486}, {555,0.00216514}, {560,0.00207339}, {565,0.00167890}, {570,0.00191743}, {575,0.00233028}, {580,0.00219266}, {585,0.00177982}, {590,0.00200917}, {595,0.00170642}, {600,0.00195413}, {605,0.00223853}, {610,0.00245872}, {615,0.00204587}, {620,0.00179817}, {625,0.00212844}, {630,0.00251376}, {635,0.00259633}, {640,0.00244037}, {645,0.00194495}, {650,0.00197248}, {655,0.00233028}, {660,0.00243119}, {665,0.00245872}, {670,0.00253211}, {675,0.00251376}, {680,0.00238532}, {685,0.00233028}, {690,0.00242202}, {695,0.00235780}, {700,0.00247706}, {705,0.00251376}, {710,0.00254128}, {715,0.00275229}, {720,0.00271560}, {725,0.00288073}, {730,0.00276147}, {735,0.00285321}, {740,0.00283486}, {745,0.00275229}, {750,0.00283486}, {755,0.00275229}, {760,0.00292661}, {765,0.00279817}, {770,0.00273394}, {775,0.00295413}, {780,0.00311927}, {785,0.00309174}, {790,0.00294495}, {795,0.00282569}, {800,0.00284404}, {805,0.00289908}, {810,0.00288073}, {815,0.00288991}, {820,0.00297248}, {825,0.00307339}, {830,0.00318349}, {835,0.00300917}, {840,0.00313761}, {845,0.00302752}, {850,0.00305505}, {855,0.00322018}, {860,0.00305505}, {865,0.00302752}, {870,0.00313761}, {875,0.00342202}, {880,0.00311927}, {885,0.00336697}, {890,0.00322936}, {895,0.00326606}, {900,0.00331193}, {905,0.00534862}, {910,0.00338532}, {915,0.00325688}, {920,0.00342202}, {925,0.00333945}, {930,0.00349541}, {935,0.00338532}, {940,0.00356881}, {945,0.00345872}, {950,0.00345872}, {955,0.00352294}, {960,0.00361468}, {965,0.00346789}, {970,0.00363303}, {975,0.00366972}, {980,0.00358716}, {985,0.00366055}, {990,0.00367890}, {995,0.00373394}, {1000,0.00368807}, {1010,0.00370642}, {1020,0.00364220}, {1030,0.00384404}, {1040,0.00386239}, {1050,0.00390826}, {1060,0.00688073}, {1070,0.00383486}, {1080,0.00404587}, {1090,0.00415596}, {1100,0.00408257}, {1110,0.00409174}, {1120,0.00440367}, {1130,0.00394495}, {1140,0.00428440}, {1150,0.00411927}, {1160,0.00425688}, {1170,0.00413761}, {1180,0.00435780}, {1190,0.00424771}, {1200,0.00413761}, {1210,0.00447706}, {1220,0.00450459}, {1230,0.00463303}, {1240,0.00466055}, {1250,0.00466055}, {1260,0.00488073}, {1270,0.00736697}, {1280,0.00457798}, {1290,0.00460550}, {1300,0.00513761}, {1310,0.00479817}, {1320,0.00479817}, {1330,0.00497248}, {1340,0.00517431}, {1350,0.00490826}, {1360,0.00498165}, {1370,0.00531193}, {1380,0.00541284}, {1390,0.00515596}, {1400,0.00513761}, {1410,0.00528440}, {1420,0.00543119}, {1430,0.00527523}, {1440,0.00515596}, {1450,0.01014679}, {1460,0.00541284}, {1470,0.00567890}, {1480,0.00576147}, {1490,0.00578899}, {1500,0.00559633}, {1510,0.00581651}, {1520,0.00557798}, {1530,0.00563303}, {1540,0.00573394}, {1550,0.00555963}, {1560,0.00564220}, {1570,0.00547706}, {1580,0.00575229}, {1590,0.00601835}, {1600,0.00601835}, {1610,0.01218349}, {1620,0.00579817}, {1630,0.00603670}, {1640,0.00616514}, {1650,0.00609174}, {1660,0.00611009}, {1670,0.00667890}, {1680,0.00633028}, {1690,0.00630275}, {1700,0.00648624}, {1710,0.00645872}, {1720,0.00650459}, {1730,0.00650459}, {1740,0.00666972}, {1750,0.00667890}, {1760,0.00642202}, {1770,0.00677982}, {1780,0.00679817}, {1790,0.00667890}, {1800,0.00686239}, {1810,0.00696330}, {1820,0.00711927}, {1830,0.00695413}, {1840,0.00701835}, {1850,0.00709174}, {1860,0.00707339}, {1870,0.00713761}, {1880,0.00733028}, {1890,0.01257798}, {1900,0.00731193}, {1910,0.00724771}, {1920,0.00749541}, {1930,0.00744037}, {1940,0.00747706}, {1950,0.00735780}, {1960,0.00744954}, {1970,0.00777982}, {1980,0.00754128}, {1990,0.00774312}, {2000,0.00787156}, {2050,0.00819266}, {2100,0.01200917}, {2150,0.00840367}, {2200,0.00914679}, {2250,0.00914679}, {2300,0.00932110}, {2350,0.00949541}, {2400,0.00937615}, {2450,0.00985321}, {2500,0.01061468}, {2550,0.01069725}, {2600,0.01677982}, {2650,0.01143119}, {2700,0.01113761}, {2750,0.01159633}, {2800,0.01182569}, {2850,0.01216514}, {2900,0.01227523}, {2950,0.01257798}, {3000,0.01266972}, {3050,0.02074312}, {3100,0.01326606}, {3150,0.01354128}, {3200,0.01340367}, {3250,0.01382569}, {3300,0.01432110}, {3350,0.01419266}, {3400,0.01483486}, {3450,0.02355046}, {3500,0.01477982}, {3550,0.01503670}, {3600,0.01523853}, {3650,0.01541284}, {3700,0.01565138}, {3750,0.01585321}, {3800,0.02632110}, {3850,0.01611927}, {3900,0.01648624}, {3950,0.01688991}, {4000,0.01688991}, {4050,0.01709174}, {4100,0.03077064}, {4150,0.01775229}, {4200,0.01748624}, {4250,0.01762385}, {4300,0.01845872}, {4350,0.01831193}, {4400,0.03169725}, {4450,0.01848624}, {4500,0.01900917}, {4550,0.01903670}, {4600,0.01943119}, {4650,0.01955963}, {4700,0.01976147}, {4750,0.02021101}, {4800,0.02066055}, {4850,0.02048624}, {4900,0.02088991}, {4950,0.03077064}, {5000,0.02147706}, {5050,0.02170642}, {5100,0.02175229}, {5150,0.02243119}, {5200,0.03844037}, {5250,0.02275229}, {5300,0.02288991}, {5350,0.02339450}, {5400,0.02376147}, {5450,0.02384404}, {5500,0.02415596}, {5550,0.02420183}, {5600,0.02437615}, {5650,0.03690826}, {5700,0.02488991}, {5750,0.02515596}, {5800,0.02525688}, {5850,0.02583486}, {5900,0.02569725}, {5950,0.02593578}, {6000,0.02606422}, {6050,0.02626606}, {6100,0.03488991}, {6150,0.02674312}, {6200,0.02668807}, {6250,0.02698165}, {6300,0.04882569}, {6350,0.02763303}, {6400,0.02751376}, {6450,0.02762385}, {6500,0.04729358}, {6550,0.02916514}, {6600,0.02865138}, {6650,0.02940367}, {6700,0.02909174}, {6750,0.02947706}, {6800,0.02993578}, {6850,0.04015596}, {6900,0.03047706}, {6950,0.02983486}, {7000,0.03066972}, {7050,0.04650459}, {7100,0.03154128}, {7150,0.03174312}, {7200,0.03228440}, {7250,0.03200917}, {7300,0.03221101}, {7350,0.03233945}, {7400,0.05620183}, {7450,0.03242202}, {7500,0.03292661}, {7550,0.06650459}, {7600,0.03361468}, {7650,0.03393578}, {7700,0.03371560}, {7750,0.03696330}, {7800,0.03411009}, {7850,0.03440367}, {7900,0.05913761}, {7950,0.03507339}, {8000,0.03521101}, {8050,0.06514679}, {8100,0.03537615}, {8150,0.03562385}, {8200,0.05415596}, {8250,0.03601835}, {8300,0.03651376}, {8350,0.05757798}, {8400,0.03657798}, {8450,0.03701835}, {8500,0.05896330}, {8550,0.03712844}, {8600,0.03742202}, {8650,0.05700000}, {8700,0.03782569}, {8750,0.03798165}, {8800,0.06708257}, {8850,0.03842202}, {8900,0.03861468}, {8950,0.06754128}, {9000,0.03911927}, {9050,0.03904587}, {9100,0.06836697}, {9150,0.03955963}, {9200,0.03964220}, {9250,0.04024771}, {9300,0.04034862}, {9350,0.05868807}, {9400,0.04100917}, {9450,0.04102752}, {9500,0.07070642}, {9550,0.04154128}, {9600,0.04207339}, {9650,0.04211009}, {9700,0.04225688}, {9750,0.05519266}, {9800,0.04321101}, {9850,0.04327523}, {9900,0.07133945}, {9950,0.04360550}, {10000,0.04444954}, {10100,0.04423853}, {10200,0.04491743}, {10300,0.06275229}, {10400,0.04544954}, {10500,0.07691743}, {10600,0.04617431}, {10700,0.04675229}, {10800,0.06452294}, {10900,0.04769725}, {11000,0.08499083}, {11100,0.04822018}, {11200,0.06529358}, {11300,0.04922936}, {11400,0.04931193}, {11500,0.05021101}, {11600,0.05044954}, {11700,0.07149541}, {11800,0.05172477}, {11900,0.08654128}, {12000,0.05219266}, {12100,0.09605505}, {12200,0.05294495}, {12300,0.09426606}, {12400,0.05368807}, {12500,0.09477064}, {12600,0.05546789}, {12700,0.09601835}, {12800,0.05631193}, {12900,0.09797248}, {13000,0.05647706}, {13100,0.09894495}, {13200,0.05772477}, {13300,0.10006422}, {13400,0.05875229}, {13500,0.10149541}, {13600,0.05912844}, {13700,0.10350459}, {13800,0.06020183}, {13900,0.06077064}, {14000,0.06189908}, {14100,0.06158716}, {14200,0.09096330}, {14300,0.06309174}, {14400,0.10592661}, {14500,0.06373394}, {14600,0.10699083}, {14700,0.06440367}, {14800,0.06492661}, {14900,0.08877064}, {15000,0.06579817}, {15100,0.10888991}, {15200,0.06688991}, {15300,0.06719266}, {15400,0.08989908}, {15500,0.06796330}, {15600,0.11202752}, {15700,0.06872477}, {15800,0.06906422}, {15900,0.10931193}, {16000,0.06956881}, {16100,0.10382569}, {16200,0.12591743}, {16300,0.07140367}, {16400,0.11290826}, {16500,0.07272477}, {16600,0.07241284}, {16700,0.10754128}, {16800,0.07489908}, {16900,0.07443119}, {17000,0.11625688}, {17100,0.07644037}, {17200,0.07535780}, {17300,0.12288991}, {17400,0.12912844}, {17500,0.07664220}, {17600,0.10658716}, {17700,0.13347706}, {17800,0.07787156}, {17900,0.11110092}, {18000,0.15350459}, {18100,0.07952294}, {18200,0.07949541}, {18300,0.12273394}, {18400,0.13029358}, {18500,0.08098165}, {18600,0.10899083}, {18700,0.16519266}, {18800,0.08353211}, {18900,0.08294495}, {19000,0.11316514}, {19100,0.15333945}, {19200,0.08470642}, {19300,0.08447706}, {19400,0.12669725}, {19500,0.15390826}, {19600,0.14799083}, {19700,0.08630275}, {19800,0.08738532}, {19900,0.12296330}, {20000,0.13695327}};
data["big_flat"]["printing"]["Stats"]["system"] = {{1,0.00002752}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00006422}, {11,0.00007339}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00003670}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00003670}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00002752}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00003670}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00003670}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00002752}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00006422}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00003670}, {109,0.00003670}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00003670}, {119,0.00000000}, {120,0.00003670}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00002752}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00002752}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00003670}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00003670}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00003670}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00003670}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00003670}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00003670}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00003670}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00003670}, {214,0.00000000}, {215,0.00003670}, {216,0.00000000}, {217,0.00000000}, {218,0.00003670}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00003670}, {229,0.00000000}, {230,0.00000000}, {231,0.00003670}, {232,0.00000000}, {233,0.00000000}, {234,0.00003670}, {235,0.00000000}, {236,0.00000000}, {237,0.00003670}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00003670}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00003670}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00007339}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00003670}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00003670}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00003670}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00003670}, {322,0.00000000}, {323,0.00000000}, {324,0.00003670}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00003670}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00003670}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00003670}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00014679}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00003670}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00003670}, {392,0.00003670}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00003670}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00006422}, {422,0.00000000}, {423,0.00003670}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00003670}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00003670}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00003670}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00003670}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00003670}, {463,0.00003670}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00003670}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00007339}, {477,0.00000000}, {478,0.00000000}, {479,0.00002752}, {480,0.00003670}, {481,0.00003670}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00002752}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00003670}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00003670}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00003670}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00003670}, {600,0.00003670}, {605,0.00003670}, {610,0.00000000}, {615,0.00003670}, {620,0.00000000}, {625,0.00000000}, {630,0.00003670}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00003670}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00003670}, {740,0.00000000}, {745,0.00003670}, {750,0.00000000}, {755,0.00000000}, {760,0.00003670}, {765,0.00003670}, {770,0.00003670}, {775,0.00007339}, {780,0.00000000}, {785,0.00000000}, {790,0.00003670}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00003670}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00003670}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00003670}, {1010,0.00000000}, {1020,0.00003670}, {1030,0.00000000}, {1040,0.00003670}, {1050,0.00003670}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00007339}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00003670}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00007339}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00003670}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00003670}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00007339}, {1280,0.00003670}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00000000}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00003670}, {1430,0.00000000}, {1440,0.00002752}, {1450,0.00010092}, {1460,0.00003670}, {1470,0.00002752}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00003670}, {1510,0.00003670}, {1520,0.00003670}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00003670}, {1570,0.00000000}, {1580,0.00003670}, {1590,0.00002752}, {1600,0.00000000}, {1610,0.00014679}, {1620,0.00003670}, {1630,0.00003670}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00006422}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00003670}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00003670}, {1740,0.00003670}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00003670}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00003670}, {1860,0.00000000}, {1870,0.00003670}, {1880,0.00000000}, {1890,0.00018349}, {1900,0.00000000}, {1910,0.00007339}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00002752}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00003670}, {2000,0.00003670}, {2050,0.00000000}, {2100,0.00018349}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00003670}, {2350,0.00000000}, {2400,0.00002752}, {2450,0.00007339}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00011009}, {2650,0.00003670}, {2700,0.00003670}, {2750,0.00003670}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00025688}, {3100,0.00007339}, {3150,0.00007339}, {3200,0.00000000}, {3250,0.00003670}, {3300,0.00002752}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00014679}, {3500,0.00000000}, {3550,0.00000000}, {3600,0.00006422}, {3650,0.00003670}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00031193}, {3850,0.00003670}, {3900,0.00011009}, {3950,0.00010092}, {4000,0.00003670}, {4050,0.00003670}, {4100,0.00028440}, {4150,0.00000000}, {4200,0.00003670}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00003670}, {4400,0.00028440}, {4450,0.00003670}, {4500,0.00003670}, {4550,0.00000000}, {4600,0.00000000}, {4650,0.00003670}, {4700,0.00003670}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00010092}, {4900,0.00011009}, {4950,0.00018349}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00003670}, {5150,0.00003670}, {5200,0.00017431}, {5250,0.00007339}, {5300,0.00006422}, {5350,0.00000000}, {5400,0.00003670}, {5450,0.00007339}, {5500,0.00006422}, {5550,0.00000000}, {5600,0.00000000}, {5650,0.00029358}, {5700,0.00000000}, {5750,0.00000000}, {5800,0.00003670}, {5850,0.00005505}, {5900,0.00000000}, {5950,0.00007339}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00013761}, {6150,0.00000000}, {6200,0.00011009}, {6250,0.00003670}, {6300,0.00078899}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00002752}, {6500,0.00046789}, {6550,0.00000000}, {6600,0.00003670}, {6650,0.00007339}, {6700,0.00003670}, {6750,0.00003670}, {6800,0.00003670}, {6850,0.00034862}, {6900,0.00003670}, {6950,0.00003670}, {7000,0.00000000}, {7050,0.00056881}, {7100,0.00000000}, {7150,0.00003670}, {7200,0.00000000}, {7250,0.00013761}, {7300,0.00000000}, {7350,0.00003670}, {7400,0.00031193}, {7450,0.00000000}, {7500,0.00000000}, {7550,0.00243119}, {7600,0.00011009}, {7650,0.00007339}, {7700,0.00003670}, {7750,0.00013761}, {7800,0.00003670}, {7850,0.00000000}, {7900,0.00066972}, {7950,0.00003670}, {8000,0.00003670}, {8050,0.00052294}, {8100,0.00011009}, {8150,0.00000000}, {8200,0.00079817}, {8250,0.00014679}, {8300,0.00003670}, {8350,0.00071560}, {8400,0.00003670}, {8450,0.00000000}, {8500,0.00039450}, {8550,0.00007339}, {8600,0.00007339}, {8650,0.00042202}, {8700,0.00003670}, {8750,0.00014679}, {8800,0.00072477}, {8850,0.00010092}, {8900,0.00000000}, {8950,0.00077982}, {9000,0.00003670}, {9050,0.00018349}, {9100,0.00055046}, {9150,0.00011009}, {9200,0.00007339}, {9250,0.00007339}, {9300,0.00006422}, {9350,0.00046789}, {9400,0.00007339}, {9450,0.00003670}, {9500,0.00099083}, {9550,0.00018349}, {9600,0.00007339}, {9650,0.00009174}, {9700,0.00003670}, {9750,0.00039450}, {9800,0.00003670}, {9850,0.00003670}, {9900,0.00088991}, {9950,0.00003670}, {10000,0.00006422}, {10100,0.00007339}, {10200,0.00003670}, {10300,0.00060550}, {10400,0.00014679}, {10500,0.00043119}, {10600,0.00000000}, {10700,0.00000000}, {10800,0.00046789}, {10900,0.00000000}, {11000,0.00098165}, {11100,0.00007339}, {11200,0.00093578}, {11300,0.00000000}, {11400,0.00003670}, {11500,0.00007339}, {11600,0.00000000}, {11700,0.00059633}, {11800,0.00003670}, {11900,0.00119266}, {12000,0.00002752}, {12100,0.00192661}, {12200,0.00025688}, {12300,0.00086239}, {12400,0.00000000}, {12500,0.00112844}, {12600,0.00006422}, {12700,0.00122018}, {12800,0.00007339}, {12900,0.00080734}, {13000,0.00011009}, {13100,0.00084404}, {13200,0.00011009}, {13300,0.00106422}, {13400,0.00007339}, {13500,0.00122936}, {13600,0.00043119}, {13700,0.00102752}, {13800,0.00017431}, {13900,0.00003670}, {14000,0.00003670}, {14100,0.00007339}, {14200,0.00090826}, {14300,0.00000000}, {14400,0.00220183}, {14500,0.00010092}, {14600,0.00137615}, {14700,0.00024771}, {14800,0.00022018}, {14900,0.00093578}, {15000,0.00000000}, {15100,0.00252294}, {15200,0.00000000}, {15300,0.00011009}, {15400,0.00070642}, {15500,0.00007339}, {15600,0.00236697}, {15700,0.00000000}, {15800,0.00014679}, {15900,0.00007339}, {16000,0.00000000}, {16100,0.00007339}, {16200,0.00003670}, {16300,0.00000000}, {16400,0.00003670}, {16500,0.00000000}, {16600,0.00000000}, {16700,0.00003670}, {16800,0.00003670}, {16900,0.00000000}, {17000,0.00014679}, {17100,0.00003670}, {17200,0.00010092}, {17300,0.00240367}, {17400,0.00376147}, {17500,0.00022018}, {17600,0.00201835}, {17700,0.00349541}, {17800,0.00007339}, {17900,0.00268807}, {18000,0.00555046}, {18100,0.00017431}, {18200,0.00010092}, {18300,0.00268807}, {18400,0.00389908}, {18500,0.00024771}, {18600,0.00259633}, {18700,0.00735780}, {18800,0.00014679}, {18900,0.00007339}, {19000,0.00462385}, {19100,0.00837615}, {19200,0.00007339}, {19300,0.00028440}, {19400,0.00477064}, {19500,0.00997248}, {19600,0.00167890}, {19700,0.00003670}, {19800,0.00007339}, {19900,0.00007339}, {20000,0.00003738}};
data["big_flat"]["refine let"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00005310}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00000000}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00000000}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00000000}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000885}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000885}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00000000}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00000000}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00000000}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00000000}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00000000}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000885}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00000000}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00000000}, {850,0.00000000}, {855,0.00000000}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00000000}, {935,0.00000000}, {940,0.00000000}, {945,0.00000000}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00000000}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00000000}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00000000}, {1160,0.00000000}, {1170,0.00196429}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00000000}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00000000}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00000000}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00196429}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00001786}, {1660,0.00000000}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00000000}, {1780,0.00001786}, {1790,0.00000000}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00000000}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000893}, {2250,0.00003571}, {2300,0.00033929}, {2350,0.00053571}, {2400,0.00068750}, {2450,0.00072321}, {2500,0.00074107}, {2550,0.00075000}, {2600,0.00075893}, {2650,0.00081250}, {2700,0.00084821}, {2750,0.00085714}, {2800,0.00098214}, {2850,0.00100000}, {2900,0.00099107}, {2950,0.00099107}, {3000,0.00099107}, {3050,0.00099107}, {3100,0.00100000}, {3150,0.00097321}, {3200,0.00100000}, {3250,0.00100000}, {3300,0.00100000}, {3350,0.00100000}, {3400,0.00100000}, {3450,0.00100000}, {3500,0.00100000}, {3550,0.00100000}, {3600,0.00100000}, {3650,0.00100893}, {3700,0.00100000}, {3750,0.00100000}, {3800,0.00100000}, {3850,0.00100000}, {3900,0.00100000}, {3950,0.00100000}, {4000,0.00100000}, {4050,0.00100000}, {4100,0.00100000}, {4150,0.00100000}, {4200,0.00100000}, {4250,0.00100000}, {4300,0.00100000}, {4350,0.00105357}, {4400,0.00100000}, {4450,0.00103571}, {4500,0.00106250}, {4550,0.00100893}, {4600,0.00100000}, {4650,0.00117857}, {4700,0.00128571}, {4750,0.00136607}, {4800,0.00136607}, {4850,0.00164286}, {4900,0.00168750}, {4950,0.00174107}, {5000,0.00100000}, {5050,0.00101786}, {5100,0.00175000}, {5150,0.00175893}, {5200,0.00105357}, {5250,0.00179464}, {5300,0.00106250}, {5350,0.00175893}, {5400,0.00149107}, {5450,0.00136607}, {5500,0.00181250}, {5550,0.00179464}, {5600,0.00144643}, {5650,0.00161607}, {5700,0.00143750}, {5750,0.00155357}, {5800,0.00170536}, {5850,0.00174107}, {5900,0.00175000}, {5950,0.00176786}, {6000,0.00198214}, {6050,0.00199107}, {6100,0.00182143}, {6150,0.00199107}, {6200,0.00178571}, {6250,0.00200000}, {6300,0.00179464}, {6350,0.00199107}, {6400,0.00188393}, {6450,0.00197321}, {6500,0.00207143}, {6550,0.00216964}, {6600,0.00194643}, {6650,0.00200000}, {6700,0.00200000}, {6750,0.00200000}, {6800,0.00200000}, {6850,0.00200000}, {6900,0.00239286}, {6950,0.00242857}, {7000,0.00200000}, {7050,0.00200000}, {7100,0.00250000}, {7150,0.00200893}, {7200,0.00261607}, {7250,0.00200000}, {7300,0.00266964}, {7350,0.00201786}, {7400,0.00200000}, {7450,0.00270536}, {7500,0.00269643}, {7550,0.00207143}, {7600,0.00217857}, {7650,0.00204464}, {7700,0.00232143}, {7750,0.00208929}, {7800,0.00253571}, {7850,0.00275000}, {7900,0.01110714}, {7950,0.00208036}, {8000,0.00216964}, {8050,0.00283036}, {8100,0.00256250}, {8150,0.00283929}, {8200,0.00272321}, {8250,0.00297321}, {8300,0.00270536}, {8350,0.00265179}, {8400,0.00269643}, {8450,0.00298214}, {8500,0.00271429}, {8550,0.00271429}, {8600,0.00273214}, {8650,0.00273214}, {8700,0.00272321}, {8750,0.00270536}, {8800,0.00330357}, {8850,0.00269643}, {8900,0.00269643}, {8950,0.00268750}, {9000,0.00354464}, {9050,0.00282143}, {9100,0.00348214}, {9150,0.00264286}, {9200,0.00360714}, {9250,0.00284821}, {9300,0.00282143}, {9350,0.02047321}, {9400,0.00303571}, {9450,0.00298214}, {9500,0.00297321}, {9550,0.00292857}, {9600,0.00294643}, {9650,0.00295536}, {9700,0.00294643}, {9750,0.00295536}, {9800,0.00366964}, {9850,0.00300000}, {9900,0.00299107}, {9950,0.00364286}, {10000,0.00300000}, {10100,0.00306250}, {10200,0.00311607}, {10300,0.02538393}, {10400,0.00320536}, {10500,0.00333036}, {10600,0.00353571}, {10700,0.00350000}, {10800,0.00396429}, {10900,0.00355357}, {11000,0.00357143}, {11100,0.00356250}, {11200,0.00356250}, {11300,0.00387500}, {11400,0.00355357}, {11500,0.00357143}, {11600,0.00359821}, {11700,0.00362500}, {11800,0.00366964}, {11900,0.00363393}, {12000,0.00374107}, {12100,0.00378571}, {12200,0.00388393}, {12300,0.00390179}, {12400,0.00393750}, {12500,0.00401786}, {12600,0.00400}, {12700,0.00650}, {12800,0.00400}, {12900,0.00400}, {13000,0.00400}, {13100,0.00400}, {13200,0.00400}, {13300,0.00425}, {13400,0.00450}, {13500,0.00475}, {13600,0.00450}, {13700,0.00450}, {13800,0.00450}, {13900,0.00450}, {14000,0.00450}, {14100,0.00500}, {14200,0.00500}, {14300,0.00900}, {14400,0.00425}, {14500,0.00475}, {14600,0.00475}, {14700,0.00475}, {14800,0.00475}, {14900,0.00475}, {15000,0.00475}, {15100,0.00475}, {15200,0.00475}, {15300,0.00475}, {15400,0.00475}, {15500,0.00500}, {15600,0.00475}, {15700,0.00500}, {15800,0.00525}, {15900,0.00550}, {16000,0.00525}, {16100,0.00550}, {16200,0.00500}, {16300,0.00525}, {16400,0.00575}, {16500,0.01300}, {16600,0.00575}, {16700,0.00575}, {16800,0.00550}, {16900,0.00600}, {17000,0.00575}, {17100,0.00575}, {17200,0.00675}, {17300,0.00675}, {17400,0.00575}, {17500,0.00575}, {17600,0.00575}, {17700,0.00875}, {17800,0.00575}, {17900,0.00575}, {18000,0.00625}, {18100,0.00575}, {18200,0.00575}, {18300,0.00575}, {18400,0.00600}, {18500,0.00625}, {18600,0.00625}, {18700,0.00650}, {18800,0.00625}, {18900,0.00650}, {19000,0.01575}, {19100,0.00600}, {19200,0.00650}, {19300,0.00650}, {19400,0.00625}, {19500,0.00650}, {19600,0.00650}, {19700,0.00675}, {19800,0.00650}, {19900,0.00675}, {20000,0.0070}};
data["big_flat"]["refine let"]["Stats"]["user"] = {{1,0.00003540}, {2,0.00005310}, {3,0.00009735}, {4,0.00002655}, {5,0.00002655}, {6,0.00005310}, {7,0.00005310}, {8,0.00012389}, {9,0.00005310}, {10,0.00002655}, {11,0.00005310}, {12,0.00008850}, {13,0.00005310}, {14,0.00015044}, {15,0.00000000}, {16,0.00005310}, {17,0.00007965}, {18,0.00000000}, {19,0.00017699}, {20,0.00002655}, {21,0.00002655}, {22,0.00010619}, {23,0.00007965}, {24,0.00005310}, {25,0.00019469}, {26,0.00010619}, {27,0.00006195}, {28,0.00020354}, {29,0.00015044}, {30,0.00009735}, {31,0.00016814}, {32,0.00015044}, {33,0.00003540}, {34,0.00002655}, {35,0.00006195}, {36,0.00002655}, {37,0.00019469}, {38,0.00002655}, {39,0.00003540}, {40,0.00006195}, {41,0.00008850}, {42,0.00009735}, {43,0.00002655}, {44,0.00006195}, {45,0.00015044}, {46,0.00002655}, {47,0.00007965}, {48,0.00002655}, {49,0.00019469}, {50,0.00000000}, {51,0.00000000}, {52,0.00002655}, {53,0.00007965}, {54,0.00008850}, {55,0.00008850}, {56,0.00016814}, {57,0.00012389}, {58,0.00005310}, {59,0.00003540}, {60,0.00009735}, {61,0.00005310}, {62,0.00008850}, {63,0.00009735}, {64,0.00020354}, {65,0.00025664}, {66,0.00023009}, {67,0.00006195}, {68,0.00005310}, {69,0.00005310}, {70,0.00013274}, {71,0.00003540}, {72,0.00021239}, {73,0.00007080}, {74,0.00005310}, {75,0.00011504}, {76,0.00016814}, {77,0.00002655}, {78,0.00010619}, {79,0.00019469}, {80,0.00006195}, {81,0.00002655}, {82,0.00014159}, {83,0.00006195}, {84,0.00013274}, {85,0.00008850}, {86,0.00013274}, {87,0.00012389}, {88,0.00006195}, {89,0.00012389}, {90,0.00012389}, {91,0.00003540}, {92,0.00008850}, {93,0.00002655}, {94,0.00000000}, {95,0.00016814}, {96,0.00015929}, {97,0.00006195}, {98,0.00012389}, {99,0.00015044}, {100,0.00015929}, {101,0.00012389}, {102,0.00010619}, {103,0.00023894}, {104,0.00010619}, {105,0.00009735}, {106,0.00007965}, {107,0.00002655}, {108,0.00011504}, {109,0.00021239}, {110,0.00011504}, {111,0.00069912}, {112,0.00003540}, {113,0.00019469}, {114,0.00015044}, {115,0.00005310}, {116,0.00008850}, {117,0.00006195}, {118,0.00009735}, {119,0.00002655}, {120,0.00012389}, {121,0.00009735}, {122,0.00018584}, {123,0.00015929}, {124,0.00006195}, {125,0.00005310}, {126,0.00007965}, {127,0.00013274}, {128,0.00010619}, {129,0.00011504}, {130,0.00005310}, {131,0.00013274}, {132,0.00012389}, {133,0.00005310}, {134,0.00012389}, {135,0.00012389}, {136,0.00006195}, {137,0.00007965}, {138,0.00010619}, {139,0.00010619}, {140,0.00006195}, {141,0.00011504}, {142,0.00020354}, {143,0.00008850}, {144,0.00010619}, {145,0.00013274}, {146,0.00008850}, {147,0.00023009}, {148,0.00005310}, {149,0.00025664}, {150,0.00005310}, {151,0.00016814}, {152,0.00005310}, {153,0.00016814}, {154,0.00014159}, {155,0.00003540}, {156,0.00008850}, {157,0.00002655}, {158,0.00008850}, {159,0.00017699}, {160,0.00018584}, {161,0.00010619}, {162,0.00014159}, {163,0.00002655}, {164,0.00014159}, {165,0.00015929}, {166,0.00005310}, {167,0.00006195}, {168,0.00014159}, {169,0.00010619}, {170,0.00006195}, {171,0.00016814}, {172,0.00011504}, {173,0.00022124}, {174,0.00014159}, {175,0.00011504}, {176,0.00011504}, {177,0.00015929}, {178,0.00015044}, {179,0.00008850}, {180,0.00010619}, {181,0.00014159}, {182,0.00017699}, {183,0.00014159}, {184,0.00008850}, {185,0.00016814}, {186,0.00008850}, {187,0.00029204}, {188,0.00014159}, {189,0.00015929}, {190,0.00012389}, {191,0.00015929}, {192,0.00007965}, {193,0.00020354}, {194,0.00020354}, {195,0.00014159}, {196,0.00007965}, {197,0.00009735}, {198,0.00008850}, {199,0.00015044}, {200,0.00006195}, {201,0.00016814}, {202,0.00018584}, {203,0.00011504}, {204,0.00010619}, {205,0.00012389}, {206,0.00011504}, {207,0.00014159}, {208,0.00000000}, {209,0.00015929}, {210,0.00007965}, {211,0.00018584}, {212,0.00010619}, {213,0.00019469}, {214,0.00023894}, {215,0.00023894}, {216,0.00016814}, {217,0.00008850}, {218,0.00006195}, {219,0.00019469}, {220,0.00007965}, {221,0.00015929}, {222,0.00015044}, {223,0.00011504}, {224,0.00008850}, {225,0.00007965}, {226,0.00007965}, {227,0.00023894}, {228,0.00019469}, {229,0.00008850}, {230,0.00015929}, {231,0.00005310}, {232,0.00026549}, {233,0.00026549}, {234,0.00013274}, {235,0.00013274}, {236,0.00010619}, {237,0.00016814}, {238,0.00013274}, {239,0.00023009}, {240,0.00005310}, {241,0.00019469}, {242,0.00007965}, {243,0.00013274}, {244,0.00005310}, {245,0.00017699}, {246,0.00027434}, {247,0.00000000}, {248,0.00008850}, {249,0.00014159}, {250,0.00018584}, {251,0.00007965}, {252,0.00014159}, {253,0.00016814}, {254,0.00016814}, {255,0.00014159}, {256,0.00017699}, {257,0.00025664}, {258,0.00018584}, {259,0.00011504}, {260,0.00011504}, {261,0.00015929}, {262,0.00014159}, {263,0.00009735}, {264,0.00011504}, {265,0.00005310}, {266,0.00022124}, {267,0.00023009}, {268,0.00008850}, {269,0.00010619}, {270,0.00020354}, {271,0.00013274}, {272,0.00010619}, {273,0.00019469}, {274,0.00003540}, {275,0.00024779}, {276,0.00030088}, {277,0.00015929}, {278,0.00009735}, {279,0.00013274}, {280,0.00014159}, {281,0.00010619}, {282,0.00015044}, {283,0.00005310}, {284,0.00029204}, {285,0.00023894}, {286,0.00010619}, {287,0.00006195}, {288,0.00016814}, {289,0.00027434}, {290,0.00017699}, {291,0.00028319}, {292,0.00010619}, {293,0.00008850}, {294,0.00016814}, {295,0.00016814}, {296,0.00018584}, {297,0.00025664}, {298,0.00017699}, {299,0.00018584}, {300,0.00021239}, {301,0.00015044}, {302,0.00028319}, {303,0.00013274}, {304,0.00018584}, {305,0.00021239}, {306,0.00005310}, {307,0.00016814}, {308,0.00016814}, {309,0.00010619}, {310,0.00015044}, {311,0.00009735}, {312,0.00015929}, {313,0.00019469}, {314,0.00011504}, {315,0.00016814}, {316,0.00005310}, {317,0.00023009}, {318,0.00024779}, {319,0.00024779}, {320,0.00016814}, {321,0.00021239}, {322,0.00022124}, {323,0.00022124}, {324,0.00012389}, {325,0.00018584}, {326,0.00023894}, {327,0.00013274}, {328,0.00026549}, {329,0.00028319}, {330,0.00019469}, {331,0.00011504}, {332,0.00017699}, {333,0.00028319}, {334,0.00008850}, {335,0.00013274}, {336,0.00013274}, {337,0.00018584}, {338,0.00009735}, {339,0.00015929}, {340,0.00019469}, {341,0.00009735}, {342,0.00014159}, {343,0.00019469}, {344,0.00007080}, {345,0.00025664}, {346,0.00023894}, {347,0.00013274}, {348,0.00008850}, {349,0.00009735}, {350,0.00003540}, {351,0.00013274}, {352,0.00006195}, {353,0.00013274}, {354,0.00012389}, {355,0.00017699}, {356,0.00013274}, {357,0.00015929}, {358,0.00026549}, {359,0.00028319}, {360,0.00023009}, {361,0.00030088}, {362,0.00026549}, {363,0.00021239}, {364,0.00012389}, {365,0.00022124}, {366,0.00017699}, {367,0.00031858}, {368,0.00012389}, {369,0.00006195}, {370,0.00015929}, {371,0.00021239}, {372,0.00023894}, {373,0.00023009}, {374,0.00022124}, {375,0.00023894}, {376,0.00027434}, {377,0.00015044}, {378,0.00009735}, {379,0.00016814}, {380,0.00037168}, {381,0.00012389}, {382,0.00013274}, {383,0.00020354}, {384,0.00017699}, {385,0.00007080}, {386,0.00017699}, {387,0.00025664}, {388,0.00020354}, {389,0.00034513}, {390,0.00013274}, {391,0.00014159}, {392,0.00015929}, {393,0.00039823}, {394,0.00014159}, {395,0.00012389}, {396,0.00024779}, {397,0.00019469}, {398,0.00010619}, {399,0.00019469}, {400,0.00012389}, {401,0.00012389}, {402,0.00018584}, {403,0.00019469}, {404,0.00027434}, {405,0.00012389}, {406,0.00026549}, {407,0.00032743}, {408,0.00020354}, {409,0.00021239}, {410,0.00019469}, {411,0.00013274}, {412,0.00015929}, {413,0.00027434}, {414,0.00029204}, {415,0.00023894}, {416,0.00035398}, {417,0.00020354}, {418,0.00010619}, {419,0.00025664}, {420,0.00026549}, {421,0.00024779}, {422,0.00026549}, {423,0.00025664}, {424,0.00027434}, {425,0.00013274}, {426,0.00025664}, {427,0.00018584}, {428,0.00024779}, {429,0.00026549}, {430,0.00033628}, {431,0.00013274}, {432,0.00010619}, {433,0.00019469}, {434,0.00011504}, {435,0.00018584}, {436,0.00018584}, {437,0.00019469}, {438,0.00027434}, {439,0.00007965}, {440,0.00018584}, {441,0.00021239}, {442,0.00037168}, {443,0.00025664}, {444,0.00012389}, {445,0.00023009}, {446,0.00013274}, {447,0.00026549}, {448,0.00009735}, {449,0.00028319}, {450,0.00006195}, {451,0.00031858}, {452,0.00019469}, {453,0.00022124}, {454,0.00015044}, {455,0.00015929}, {456,0.00025664}, {457,0.00023009}, {458,0.00024779}, {459,0.00031858}, {460,0.00017699}, {461,0.00018584}, {462,0.00015929}, {463,0.00025664}, {464,0.00012389}, {465,0.00013274}, {466,0.00020354}, {467,0.00018584}, {468,0.00023009}, {469,0.00021239}, {470,0.00026549}, {471,0.00028319}, {472,0.00028319}, {473,0.00023009}, {474,0.00017699}, {475,0.00013274}, {476,0.00034513}, {477,0.00025664}, {478,0.00033628}, {479,0.00021239}, {480,0.00022124}, {481,0.00027434}, {482,0.00037168}, {483,0.00027434}, {484,0.00013274}, {485,0.00023009}, {486,0.00018584}, {487,0.00023894}, {488,0.00013274}, {489,0.00007080}, {490,0.00020354}, {491,0.00024779}, {492,0.00019469}, {493,0.00030088}, {494,0.00038938}, {495,0.00045133}, {496,0.00015929}, {497,0.00028319}, {498,0.00027434}, {499,0.00013274}, {500,0.00027434}, {505,0.00022124}, {510,0.00030973}, {515,0.00019469}, {520,0.00029204}, {525,0.00015929}, {530,0.00017699}, {535,0.00036283}, {540,0.00048673}, {545,0.00037168}, {550,0.00040708}, {555,0.00013274}, {560,0.00031858}, {565,0.00038938}, {570,0.00018584}, {575,0.00015929}, {580,0.00009735}, {585,0.00027434}, {590,0.00026549}, {595,0.00024779}, {600,0.00033628}, {605,0.00014159}, {610,0.00014159}, {615,0.00025664}, {620,0.00030973}, {625,0.00015929}, {630,0.00046018}, {635,0.00043363}, {640,0.00023894}, {645,0.00019469}, {650,0.00019469}, {655,0.00031858}, {660,0.00023894}, {665,0.00011504}, {670,0.00018584}, {675,0.00030973}, {680,0.00027434}, {685,0.00027434}, {690,0.00038938}, {695,0.00022124}, {700,0.00056637}, {705,0.00009735}, {710,0.00030088}, {715,0.00019469}, {720,0.00021239}, {725,0.00028319}, {730,0.00042478}, {735,0.00031858}, {740,0.00027434}, {745,0.00029204}, {750,0.00043363}, {755,0.00031858}, {760,0.00036283}, {765,0.00046018}, {770,0.00014159}, {775,0.00039823}, {780,0.00028319}, {785,0.00039823}, {790,0.00029204}, {795,0.00034821}, {800,0.00052679}, {805,0.00057143}, {810,0.00034821}, {815,0.00030357}, {820,0.00019643}, {825,0.00037500}, {830,0.00033036}, {835,0.00016964}, {840,0.00045536}, {845,0.00041964}, {850,0.00045536}, {855,0.00048214}, {860,0.00032143}, {865,0.00032143}, {870,0.00047321}, {875,0.00042857}, {880,0.00043750}, {885,0.00032143}, {890,0.00035714}, {895,0.00042857}, {900,0.00035714}, {905,0.00025000}, {910,0.00026786}, {915,0.00025893}, {920,0.00037500}, {925,0.00027679}, {930,0.00047321}, {935,0.00032143}, {940,0.00052679}, {945,0.00016071}, {950,0.00035714}, {955,0.00036607}, {960,0.00048214}, {965,0.00026786}, {970,0.00042857}, {975,0.00043750}, {980,0.00058929}, {985,0.00027679}, {990,0.00025000}, {995,0.00041071}, {1000,0.00059821}, {1010,0.00039286}, {1020,0.00043750}, {1030,0.00039286}, {1040,0.00042857}, {1050,0.00025000}, {1060,0.00056250}, {1070,0.00033929}, {1080,0.00032143}, {1090,0.00043750}, {1100,0.00055357}, {1110,0.00033929}, {1120,0.00043750}, {1130,0.00023214}, {1140,0.00024107}, {1150,0.00049107}, {1160,0.00027679}, {1170,0.00200893}, {1180,0.00038393}, {1190,0.00040179}, {1200,0.00050893}, {1210,0.00028571}, {1220,0.00049107}, {1230,0.00025893}, {1240,0.00034821}, {1250,0.00066071}, {1260,0.00062500}, {1270,0.00024107}, {1280,0.00057143}, {1290,0.00050893}, {1300,0.00035714}, {1310,0.00048214}, {1320,0.00064286}, {1330,0.00066071}, {1340,0.00069643}, {1350,0.00056250}, {1360,0.00039286}, {1370,0.00035714}, {1380,0.00175893}, {1390,0.00063393}, {1400,0.00048214}, {1410,0.00055357}, {1420,0.00046429}, {1430,0.00051786}, {1440,0.00063393}, {1450,0.00058036}, {1460,0.00062500}, {1470,0.00052679}, {1480,0.00050893}, {1490,0.00042857}, {1500,0.00037500}, {1510,0.00068750}, {1520,0.00066964}, {1530,0.00059821}, {1540,0.00060714}, {1550,0.00042857}, {1560,0.00071429}, {1570,0.00073214}, {1580,0.00053571}, {1590,0.00034821}, {1600,0.00058929}, {1610,0.00057143}, {1620,0.00055357}, {1630,0.00070536}, {1640,0.00071429}, {1650,0.00061607}, {1660,0.00058036}, {1670,0.00031250}, {1680,0.00065179}, {1690,0.00063393}, {1700,0.00048214}, {1710,0.00062500}, {1720,0.00066071}, {1730,0.00050893}, {1740,0.00084821}, {1750,0.00047321}, {1760,0.00058929}, {1770,0.00055357}, {1780,0.00042857}, {1790,0.00036607}, {1800,0.00072321}, {1810,0.00054464}, {1820,0.00046429}, {1830,0.00073214}, {1840,0.00069643}, {1850,0.00036607}, {1860,0.00057143}, {1870,0.00075893}, {1880,0.00066071}, {1890,0.00078571}, {1900,0.00070536}, {1910,0.00049107}, {1920,0.00075893}, {1930,0.00079464}, {1940,0.00062500}, {1950,0.00060714}, {1960,0.00080357}, {1970,0.00058929}, {1980,0.00072321}, {1990,0.00042857}, {2000,0.00090179}, {2050,0.00081250}, {2100,0.00056250}, {2150,0.00066964}, {2200,0.00081250}, {2250,0.00084821}, {2300,0.00101786}, {2350,0.00092857}, {2400,0.00095536}, {2450,0.00069643}, {2500,0.00079464}, {2550,0.00084821}, {2600,0.00081250}, {2650,0.00097321}, {2700,0.00089286}, {2750,0.00094643}, {2800,0.00099107}, {2850,0.00108036}, {2900,0.00103571}, {2950,0.00100893}, {3000,0.00091071}, {3050,0.00116071}, {3100,0.00113393}, {3150,0.00082143}, {3200,0.00108929}, {3250,0.00097321}, {3300,0.00102679}, {3350,0.00101786}, {3400,0.00079464}, {3450,0.00091964}, {3500,0.00119643}, {3550,0.00109821}, {3600,0.00140179}, {3650,0.00119643}, {3700,0.00120536}, {3750,0.00129464}, {3800,0.00093750}, {3850,0.00097321}, {3900,0.00108929}, {3950,0.00117857}, {4000,0.00139286}, {4050,0.00130357}, {4100,0.00144643}, {4150,0.00134821}, {4200,0.00139286}, {4250,0.00129464}, {4300,0.00146429}, {4350,0.00151786}, {4400,0.00160714}, {4450,0.00151786}, {4500,0.00185714}, {4550,0.00141071}, {4600,0.00144643}, {4650,0.00132143}, {4700,0.00176786}, {4750,0.00166964}, {4800,0.00188393}, {4850,0.00191071}, {4900,0.00183929}, {4950,0.00205357}, {5000,0.00158036}, {5050,0.00207143}, {5100,0.00187500}, {5150,0.00163393}, {5200,0.00150000}, {5250,0.00192857}, {5300,0.00165179}, {5350,0.00178571}, {5400,0.00157143}, {5450,0.00133929}, {5500,0.00195536}, {5550,0.00215179}, {5600,0.00209821}, {5650,0.00205357}, {5700,0.00141071}, {5750,0.00176786}, {5800,0.00177679}, {5850,0.00206250}, {5900,0.00173214}, {5950,0.00205357}, {6000,0.00271429}, {6050,0.00235714}, {6100,0.00172321}, {6150,0.00236607}, {6200,0.00176786}, {6250,0.00214286}, {6300,0.00216071}, {6350,0.00234821}, {6400,0.00231250}, {6450,0.00228571}, {6500,0.00272321}, {6550,0.00270536}, {6600,0.00200893}, {6650,0.00190179}, {6700,0.00224107}, {6750,0.00222321}, {6800,0.00216071}, {6850,0.00228571}, {6900,0.00271429}, {6950,0.00259821}, {7000,0.00259821}, {7050,0.00211607}, {7100,0.00261607}, {7150,0.00233036}, {7200,0.00250000}, {7250,0.00265179}, {7300,0.00261607}, {7350,0.00222321}, {7400,0.00253571}, {7450,0.00263393}, {7500,0.00300893}, {7550,0.00231250}, {7600,0.00260714}, {7650,0.00228571}, {7700,0.00255357}, {7750,0.00242857}, {7800,0.00272321}, {7850,0.00313393}, {7900,0.01122321}, {7950,0.00267857}, {8000,0.00250893}, {8050,0.00323214}, {8100,0.00243750}, {8150,0.00333036}, {8200,0.00283036}, {8250,0.00325893}, {8300,0.00287500}, {8350,0.00275000}, {8400,0.00276786}, {8450,0.00290179}, {8500,0.00233036}, {8550,0.00254464}, {8600,0.00241964}, {8650,0.00246429}, {8700,0.00256250}, {8750,0.00255357}, {8800,0.00316071}, {8850,0.00263393}, {8900,0.00258036}, {8950,0.00239286}, {9000,0.00326786}, {9050,0.00274107}, {9100,0.00330357}, {9150,0.00269643}, {9200,0.00334821}, {9250,0.00284821}, {9300,0.00283036}, {9350,0.02053571}, {9400,0.00302679}, {9450,0.00269643}, {9500,0.00259821}, {9550,0.00289286}, {9600,0.00299107}, {9650,0.00285714}, {9700,0.00324107}, {9750,0.00303571}, {9800,0.00365179}, {9850,0.00270536}, {9900,0.00301786}, {9950,0.00336607}, {10000,0.00290179}, {10100,0.00310714}, {10200,0.00300893}, {10300,0.02534821}, {10400,0.00305357}, {10500,0.00314286}, {10600,0.00329464}, {10700,0.00315179}, {10800,0.00386607}, {10900,0.00327679}, {11000,0.00342857}, {11100,0.00336607}, {11200,0.00333036}, {11300,0.00365179}, {11400,0.00354464}, {11500,0.00338393}, {11600,0.00368750}, {11700,0.00344643}, {11800,0.00331250}, {11900,0.00360714}, {12000,0.00377679}, {12100,0.00354464}, {12200,0.00371429}, {12300,0.00369643}, {12400,0.00376786}, {12500,0.00401786}, {12600,0.00300}, {12700,0.00525}, {12800,0.00325}, {12900,0.00325}, {13000,0.00525}, {13100,0.00425}, {13200,0.00400}, {13300,0.00450}, {13400,0.00700}, {13500,0.00300}, {13600,0.00425}, {13700,0.00425}, {13800,0.00425}, {13900,0.00475}, {14000,0.00550}, {14100,0.00575}, {14200,0.00450}, {14300,0.00800}, {14400,0.00450}, {14500,0.00325}, {14600,0.00575}, {14700,0.00350}, {14800,0.00475}, {14900,0.00425}, {15000,0.00350}, {15100,0.00425}, {15200,0.00675}, {15300,0.00550}, {15400,0.00650}, {15500,0.00350}, {15600,0.00425}, {15700,0.00475}, {15800,0.00525}, {15900,0.00550}, {16000,0.00700}, {16100,0.00650}, {16200,0.00525}, {16300,0.00525}, {16400,0.00575}, {16500,0.01325}, {16600,0.00675}, {16700,0.00575}, {16800,0.00550}, {16900,0.00700}, {17000,0.00525}, {17100,0.00675}, {17200,0.00625}, {17300,0.00775}, {17400,0.00500}, {17500,0.00675}, {17600,0.00475}, {17700,0.00900}, {17800,0.00550}, {17900,0.00550}, {18000,0.00575}, {18100,0.00550}, {18200,0.00325}, {18300,0.00625}, {18400,0.00650}, {18500,0.00750}, {18600,0.00650}, {18700,0.00675}, {18800,0.00775}, {18900,0.00675}, {19000,0.01400}, {19100,0.00775}, {19200,0.00650}, {19300,0.00600}, {19400,0.00550}, {19500,0.00650}, {19600,0.00675}, {19700,0.00650}, {19800,0.00775}, {19900,0.00750}, {20000,0.0080}};
data["big_flat"]["refine let"]["Stats"]["system"] = {{1,0.00000000}, {2,0.00003540}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00002655}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00003540}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00000000}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00003540}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00000000}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00000000}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00000000}, {146,0.00000000}, {147,0.00000000}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00003540}, {152,0.00003540}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00000000}, {173,0.00000000}, {174,0.00000000}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00000000}, {179,0.00000000}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00000000}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00003540}, {199,0.00000000}, {200,0.00000000}, {201,0.00000000}, {202,0.00000000}, {203,0.00000000}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00000000}, {208,0.00000000}, {209,0.00003540}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00000000}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00000000}, {232,0.00000000}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00000000}, {242,0.00000000}, {243,0.00003540}, {244,0.00000000}, {245,0.00000000}, {246,0.00000000}, {247,0.00000000}, {248,0.00003540}, {249,0.00000000}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00000000}, {255,0.00000000}, {256,0.00000000}, {257,0.00000000}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00000000}, {289,0.00000000}, {290,0.00002655}, {291,0.00000000}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00003540}, {296,0.00000000}, {297,0.00000000}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00000000}, {302,0.00003540}, {303,0.00000000}, {304,0.00000000}, {305,0.00000000}, {306,0.00000000}, {307,0.00000000}, {308,0.00000000}, {309,0.00000000}, {310,0.00000000}, {311,0.00000000}, {312,0.00000000}, {313,0.00000000}, {314,0.00000000}, {315,0.00000000}, {316,0.00003540}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00000000}, {322,0.00000000}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00000000}, {334,0.00000000}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00000000}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00000000}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00003540}, {362,0.00000000}, {363,0.00000000}, {364,0.00000000}, {365,0.00000000}, {366,0.00000000}, {367,0.00003540}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00000000}, {374,0.00003540}, {375,0.00000000}, {376,0.00000000}, {377,0.00000000}, {378,0.00003540}, {379,0.00000000}, {380,0.00000000}, {381,0.00000000}, {382,0.00002655}, {383,0.00000000}, {384,0.00000000}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00000000}, {399,0.00000000}, {400,0.00000000}, {401,0.00000000}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00000000}, {408,0.00000000}, {409,0.00000000}, {410,0.00002655}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00003540}, {419,0.00000000}, {420,0.00000000}, {421,0.00000000}, {422,0.00000000}, {423,0.00000000}, {424,0.00002655}, {425,0.00000000}, {426,0.00000000}, {427,0.00000000}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00000000}, {440,0.00000000}, {441,0.00000000}, {442,0.00000000}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00000000}, {449,0.00000000}, {450,0.00000000}, {451,0.00000000}, {452,0.00000000}, {453,0.00000000}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00000000}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00000000}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00000000}, {475,0.00000000}, {476,0.00000000}, {477,0.00000000}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00000000}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00000000}, {489,0.00000000}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00000000}, {494,0.00000000}, {495,0.00000000}, {496,0.00000000}, {497,0.00000000}, {498,0.00000000}, {499,0.00003540}, {500,0.00000000}, {505,0.00000000}, {510,0.00003540}, {515,0.00000000}, {520,0.00000000}, {525,0.00000000}, {530,0.00000000}, {535,0.00000000}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00000000}, {605,0.00000000}, {610,0.00000000}, {615,0.00000000}, {620,0.00000000}, {625,0.00000000}, {630,0.00000000}, {635,0.00000000}, {640,0.00000000}, {645,0.00000000}, {650,0.00000000}, {655,0.00000000}, {660,0.00000000}, {665,0.00000000}, {670,0.00000000}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00000000}, {695,0.00000000}, {700,0.00000000}, {705,0.00000000}, {710,0.00000000}, {715,0.00003540}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00000000}, {755,0.00003540}, {760,0.00000000}, {765,0.00000000}, {770,0.00000000}, {775,0.00000000}, {780,0.00000000}, {785,0.00000000}, {790,0.00000000}, {795,0.00000000}, {800,0.00000000}, {805,0.00000000}, {810,0.00000000}, {815,0.00000000}, {820,0.00000000}, {825,0.00000000}, {830,0.00000000}, {835,0.00000000}, {840,0.00000000}, {845,0.00003571}, {850,0.00000000}, {855,0.00003571}, {860,0.00000000}, {865,0.00000000}, {870,0.00000000}, {875,0.00000000}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00000000}, {905,0.00000000}, {910,0.00000000}, {915,0.00000000}, {920,0.00000000}, {925,0.00000000}, {930,0.00003571}, {935,0.00003571}, {940,0.00000000}, {945,0.00003571}, {950,0.00000000}, {955,0.00000000}, {960,0.00000000}, {965,0.00000000}, {970,0.00003571}, {975,0.00000000}, {980,0.00000000}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00000000}, {1020,0.00003571}, {1030,0.00000000}, {1040,0.00000000}, {1050,0.00000000}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00000000}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00000000}, {1130,0.00000000}, {1140,0.00000000}, {1150,0.00003571}, {1160,0.00000000}, {1170,0.00000000}, {1180,0.00000000}, {1190,0.00000000}, {1200,0.00007143}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00003571}, {1240,0.00000000}, {1250,0.00000000}, {1260,0.00000000}, {1270,0.00000000}, {1280,0.00000000}, {1290,0.00000000}, {1300,0.00000000}, {1310,0.00003571}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00000000}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00000000}, {1380,0.00007143}, {1390,0.00000000}, {1400,0.00002679}, {1410,0.00000000}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00000000}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00000000}, {1500,0.00000000}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00007143}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00000000}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00000000}, {1640,0.00000000}, {1650,0.00000000}, {1660,0.00003571}, {1670,0.00000000}, {1680,0.00003571}, {1690,0.00000000}, {1700,0.00000000}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00000000}, {1750,0.00000000}, {1760,0.00000000}, {1770,0.00003571}, {1780,0.00000000}, {1790,0.00003571}, {1800,0.00000000}, {1810,0.00000000}, {1820,0.00000000}, {1830,0.00000000}, {1840,0.00003571}, {1850,0.00000000}, {1860,0.00000000}, {1870,0.00000000}, {1880,0.00000000}, {1890,0.00000000}, {1900,0.00000000}, {1910,0.00000000}, {1920,0.00000000}, {1930,0.00000000}, {1940,0.00000000}, {1950,0.00000000}, {1960,0.00000000}, {1970,0.00000000}, {1980,0.00000000}, {1990,0.00000000}, {2000,0.00003571}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00000000}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00000000}, {2450,0.00000000}, {2500,0.00000000}, {2550,0.00000000}, {2600,0.00000000}, {2650,0.00003571}, {2700,0.00000000}, {2750,0.00000000}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00000000}, {2950,0.00000000}, {3000,0.00003571}, {3050,0.00000000}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00000000}, {3250,0.00000000}, {3300,0.00000000}, {3350,0.00000000}, {3400,0.00000000}, {3450,0.00003571}, {3500,0.00003571}, {3550,0.00003571}, {3600,0.00003571}, {3650,0.00000000}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00000000}, {3900,0.00003571}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00000000}, {4100,0.00000000}, {4150,0.00000000}, {4200,0.00003571}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00003571}, {4450,0.00000000}, {4500,0.00000000}, {4550,0.00000000}, {4600,0.00003571}, {4650,0.00000000}, {4700,0.00000000}, {4750,0.00000000}, {4800,0.00000000}, {4850,0.00003571}, {4900,0.00003571}, {4950,0.00003571}, {5000,0.00000000}, {5050,0.00000000}, {5100,0.00000000}, {5150,0.00000000}, {5200,0.00000000}, {5250,0.00000000}, {5300,0.00003571}, {5350,0.00000000}, {5400,0.00000000}, {5450,0.00003571}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00003571}, {5650,0.00000000}, {5700,0.00000000}, {5750,0.00003571}, {5800,0.00003571}, {5850,0.00007143}, {5900,0.00000000}, {5950,0.00000000}, {6000,0.00000000}, {6050,0.00000000}, {6100,0.00002679}, {6150,0.00003571}, {6200,0.00000000}, {6250,0.00000000}, {6300,0.00000000}, {6350,0.00000000}, {6400,0.00000000}, {6450,0.00000000}, {6500,0.00007143}, {6550,0.00000000}, {6600,0.00000000}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00000000}, {6800,0.00003571}, {6850,0.00003571}, {6900,0.00000000}, {6950,0.00000000}, {7000,0.00000000}, {7050,0.00000000}, {7100,0.00006250}, {7150,0.00000000}, {7200,0.00000000}, {7250,0.00003571}, {7300,0.00003571}, {7350,0.00002679}, {7400,0.00000000}, {7450,0.00000000}, {7500,0.00003571}, {7550,0.00000000}, {7600,0.00003571}, {7650,0.00002679}, {7700,0.00003571}, {7750,0.00000000}, {7800,0.00000000}, {7850,0.00000000}, {7900,0.00014286}, {7950,0.00000000}, {8000,0.00000000}, {8050,0.00003571}, {8100,0.00003571}, {8150,0.00000000}, {8200,0.00000000}, {8250,0.00003571}, {8300,0.00007143}, {8350,0.00000000}, {8400,0.00000000}, {8450,0.00007143}, {8500,0.00000000}, {8550,0.00007143}, {8600,0.00000000}, {8650,0.00003571}, {8700,0.00000000}, {8750,0.00003571}, {8800,0.00000000}, {8850,0.00000000}, {8900,0.00000000}, {8950,0.00007143}, {9000,0.00000000}, {9050,0.00000000}, {9100,0.00000000}, {9150,0.00003571}, {9200,0.00000000}, {9250,0.00000000}, {9300,0.00003571}, {9350,0.00003571}, {9400,0.00000000}, {9450,0.00003571}, {9500,0.00003571}, {9550,0.00000000}, {9600,0.00003571}, {9650,0.00002679}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00003571}, {9850,0.00003571}, {9900,0.00000000}, {9950,0.00003571}, {10000,0.00003571}, {10100,0.00000000}, {10200,0.00003571}, {10300,0.00000000}, {10400,0.00007143}, {10500,0.00007143}, {10600,0.00000000}, {10700,0.00003571}, {10800,0.00000000}, {10900,0.00003571}, {11000,0.00003571}, {11100,0.00003571}, {11200,0.00010714}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00003571}, {11600,0.00000000}, {11700,0.00000000}, {11800,0.00000000}, {11900,0.00000000}, {12000,0.00000000}, {12100,0.00007143}, {12200,0.00003571}, {12300,0.00000000}, {12400,0.00000000}, {12500,0.00003571}, {12600,0.00000}, {12700,0.00100}, {12800,0.00000}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00100}, {13600,0.00000}, {13700,0.00000}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00000}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00200}, {19100,0.00000}, {19200,0.00000}, {19300,0.00100}, {19400,0.00000}, {19500,0.00100}, {19600,0.00100}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["simpl Denote"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00011504}, {13,0.00057522}, {14,0.00100000}, {15,0.00100000}, {16,0.00100000}, {17,0.00100000}, {18,0.00100000}, {19,0.00100000}, {20,0.00100000}, {21,0.00100000}, {22,0.00100000}, {23,0.00100000}, {24,0.00101770}, {25,0.00100000}, {26,0.00111504}, {27,0.00191150}, {28,0.00200885}, {29,0.00200000}, {30,0.00200000}, {31,0.00200000}, {32,0.00200000}, {33,0.00200000}, {34,0.00200000}, {35,0.00200885}, {36,0.00200000}, {37,0.00201770}, {38,0.00200885}, {39,0.00203540}, {40,0.00243363}, {41,0.00298230}, {42,0.00300000}, {43,0.00300000}, {44,0.00301770}, {45,0.00300000}, {46,0.00300885}, {47,0.00300885}, {48,0.00300000}, {49,0.00300000}, {50,0.00300000}, {51,0.00300885}, {52,0.00303540}, {53,0.00321239}, {54,0.00380531}, {55,0.00398230}, {56,0.00484071}, {57,0.00400000}, {58,0.00400000}, {59,0.00400000}, {60,0.00400000}, {61,0.00401770}, {62,0.00400000}, {63,0.00400000}, {64,0.00401770}, {65,0.00400000}, {66,0.00407965}, {67,0.00446018}, {68,0.00482301}, {69,0.00499115}, {70,0.00590265}, {71,0.00500000}, {72,0.00500000}, {73,0.00500000}, {74,0.00501770}, {75,0.00500885}, {76,0.00500000}, {77,0.00500000}, {78,0.00500000}, {79,0.00500885}, {80,0.00514159}, {81,0.00566372}, {82,0.00648673}, {83,0.00600000}, {84,0.00600000}, {85,0.00600885}, {86,0.00600000}, {87,0.00600000}, {88,0.00600000}, {89,0.00600000}, {90,0.00600000}, {91,0.00600885}, {92,0.00600885}, {93,0.00621239}, {94,0.00648673}, {95,0.00685841}, {96,0.00694690}, {97,0.00700000}, {98,0.00700000}, {99,0.00700000}, {100,0.00700000}, {101,0.00700000}, {102,0.00798230}, {103,0.00700885}, {104,0.00700000}, {105,0.00700000}, {106,0.00703540}, {107,0.00735398}, {108,0.00763717}, {109,0.00792035}, {110,0.00797345}, {111,0.00800000}, {112,0.00800000}, {113,0.00801770}, {114,0.00800000}, {115,0.00800000}, {116,0.00800000}, {117,0.00800000}, {118,0.00801770}, {119,0.00810619}, {120,0.00815044}, {121,0.00854867}, {122,0.00882301}, {123,0.00895575}, {124,0.00900000}, {125,0.00900000}, {126,0.00994690}, {127,0.00900000}, {128,0.00901770}, {129,0.00900000}, {130,0.00900885}, {131,0.00900000}, {132,0.00901770}, {133,0.01008850}, {134,0.00932743}, {135,0.00969912}, {136,0.00978761}, {137,0.01000000}, {138,0.00999115}, {139,0.01000000}, {140,0.01094690}, {141,0.01000885}, {142,0.01001770}, {143,0.01000885}, {144,0.01000000}, {145,0.01001770}, {146,0.01007080}, {147,0.01029204}, {148,0.01054867}, {149,0.01078761}, {150,0.01093805}, {151,0.01098230}, {152,0.01100000}, {153,0.01186726}, {154,0.01100000}, {155,0.01100000}, {156,0.01100885}, {157,0.01100885}, {158,0.01102655}, {159,0.01200885}, {160,0.01117699}, {161,0.01146903}, {162,0.01160177}, {163,0.01186726}, {164,0.01189381}, {165,0.01197345}, {166,0.01200885}, {167,0.01200000}, {168,0.01200000}, {169,0.01206195}, {170,0.01298230}, {171,0.01201770}, {172,0.01205310}, {173,0.01216814}, {174,0.01238938}, {175,0.01265487}, {176,0.01277876}, {177,0.01292035}, {178,0.01293805}, {179,0.01299115}, {180,0.01300000}, {181,0.01300000}, {182,0.01301770}, {183,0.01300000}, {184,0.01303540}, {185,0.01307080}, {186,0.01401770}, {187,0.01334513}, {188,0.01355752}, {189,0.01375221}, {190,0.01390265}, {191,0.01479646}, {192,0.01396460}, {193,0.01397345}, {194,0.01399115}, {195,0.01400000}, {196,0.01400000}, {197,0.01402655}, {198,0.01404425}, {199,0.01409735}, {200,0.01511504}, {201,0.01446018}, {202,0.01449558}, {203,0.01478761}, {204,0.01485841}, {205,0.01579646}, {206,0.01498230}, {207,0.01500000}, {208,0.01499115}, {209,0.01500000}, {210,0.01500885}, {211,0.01506195}, {212,0.01507080}, {213,0.01526549}, {214,0.01638053}, {215,0.01564602}, {216,0.01570796}, {217,0.01585841}, {218,0.01681416}, {219,0.01597345}, {220,0.01596460}, {221,0.01599115}, {222,0.01600885}, {223,0.01602655}, {224,0.01604425}, {225,0.01606195}, {226,0.01614159}, {227,0.01634513}, {228,0.01641593}, {229,0.01663717}, {230,0.01677876}, {231,0.01790265}, {232,0.01693805}, {233,0.01695575}, {234,0.01697345}, {235,0.01796460}, {236,0.01701770}, {237,0.01704425}, {238,0.01706195}, {239,0.01815929}, {240,0.01721239}, {241,0.01737168}, {242,0.01757522}, {243,0.01780531}, {244,0.01783186}, {245,0.01785841}, {246,0.01794690}, {247,0.01799115}, {248,0.01798230}, {249,0.01800885}, {250,0.01908850}, {251,0.01804425}, {252,0.01807965}, {253,0.01829204}, {254,0.01930973}, {255,0.01869912}, {256,0.01847788}, {257,0.01874336}, {258,0.01877876}, {259,0.01888496}, {260,0.01891150}, {261,0.01991150}, {262,0.01900000}, {263,0.01900885}, {264,0.01900000}, {265,0.02000000}, {266,0.01908850}, {267,0.01930973}, {268,0.02044248}, {269,0.01951327}, {270,0.01967257}, {271,0.01983186}, {272,0.02067257}, {273,0.01991150}, {274,0.01992920}, {275,0.02094690}, {276,0.02001770}, {277,0.02000885}, {278,0.02008850}, {279,0.02016814}, {280,0.02022124}, {281,0.02035398}, {282,0.02126549}, {283,0.02068142}, {284,0.02070796}, {285,0.02181416}, {286,0.02089381}, {287,0.02096460}, {288,0.02091150}, {289,0.02098230}, {290,0.02100885}, {291,0.02103540}, {292,0.02192920}, {293,0.02121239}, {294,0.02130088}, {295,0.02257522}, {296,0.02150442}, {297,0.02168142}, {298,0.02276991}, {299,0.02189381}, {300,0.02189381}, {301,0.02288496}, {302,0.02197345}, {303,0.02199115}, {304,0.02202655}, {305,0.02205310}, {306,0.02218584}, {307,0.02227434}, {308,0.02237168}, {309,0.02257522}, {310,0.02271681}, {311,0.02282301}, {312,0.02282301}, {313,0.02290265}, {314,0.02293805}, {315,0.02298230}, {316,0.02298230}, {317,0.02303540}, {318,0.02314159}, {319,0.02315929}, {320,0.02313274}, {321,0.02326549}, {322,0.02338938}, {323,0.02358407}, {324,0.02363717}, {325,0.02376991}, {326,0.02383186}, {327,0.02386726}, {328,0.02486726}, {329,0.02389381}, {330,0.02393805}, {331,0.02507965}, {332,0.02412389}, {333,0.02418584}, {334,0.02543363}, {335,0.02446903}, {336,0.02443363}, {337,0.02569027}, {338,0.02466372}, {339,0.02477876}, {340,0.02483186}, {341,0.02489381}, {342,0.02650442}, {343,0.02505310}, {344,0.02508850}, {345,0.02627434}, {346,0.02523009}, {347,0.02538053}, {348,0.02656637}, {349,0.02560177}, {350,0.02575221}, {351,0.02584956}, {352,0.02579646}, {353,0.02690265}, {354,0.02587611}, {355,0.02593805}, {356,0.02701770}, {357,0.02607080}, {358,0.02613274}, {359,0.02621239}, {360,0.02626549}, {361,0.02747788}, {362,0.02663717}, {363,0.02673451}, {364,0.02777876}, {365,0.02679646}, {366,0.02796460}, {367,0.02693805}, {368,0.02689381}, {369,0.02802655}, {370,0.02707080}, {371,0.02711504}, {372,0.02719469}, {373,0.02736283}, {374,0.02864602}, {375,0.02762832}, {376,0.02759292}, {377,0.02780531}, {378,0.02780531}, {379,0.02902655}, {380,0.02794690}, {381,0.02795575}, {382,0.02800000}, {383,0.02811504}, {384,0.02902655}, {385,0.02805310}, {386,0.02808850}, {387,0.02830973}, {388,0.02827434}, {389,0.02969027}, {390,0.02865487}, {391,0.02984956}, {392,0.02875221}, {393,0.02883186}, {394,0.02982301}, {395,0.02891150}, {396,0.03008850}, {397,0.02900000}, {398,0.02902655}, {399,0.02920354}, {400,0.02921239}, {401,0.03064602}, {402,0.02938938}, {403,0.03076991}, {404,0.02969027}, {405,0.02981416}, {406,0.02984071}, {407,0.02987611}, {408,0.03162832}, {409,0.02992035}, {410,0.03125664}, {411,0.03009735}, {412,0.03007965}, {413,0.03026549}, {414,0.03030973}, {415,0.03174336}, {416,0.03047788}, {417,0.03180531}, {418,0.03065487}, {419,0.03189381}, {420,0.03084956}, {421,0.03092035}, {422,0.03092920}, {423,0.03105310}, {424,0.03267257}, {425,0.03114159}, {426,0.03249558}, {427,0.03134513}, {428,0.03271681}, {429,0.03160177}, {430,0.03286726}, {431,0.03184956}, {432,0.03169912}, {433,0.03186726}, {434,0.03192920}, {435,0.03300000}, {436,0.03199115}, {437,0.03334513}, {438,0.03219469}, {439,0.03370796}, {440,0.03230088}, {441,0.03381416}, {442,0.03247788}, {443,0.03392920}, {444,0.03275221}, {445,0.03283186}, {446,0.03286726}, {447,0.03300000}, {448,0.03287611}, {449,0.03293805}, {450,0.03451327}, {451,0.03312389}, {452,0.03441593}, {453,0.03323009}, {454,0.03466372}, {455,0.03353097}, {456,0.03476106}, {457,0.03363717}, {458,0.03489381}, {459,0.03384071}, {460,0.03497345}, {461,0.03400000}, {462,0.03523894}, {463,0.03409735}, {464,0.03533628}, {465,0.03410619}, {466,0.03564602}, {467,0.03440708}, {468,0.03573451}, {469,0.03454867}, {470,0.03589381}, {471,0.03477876}, {472,0.03597345}, {473,0.03485841}, {474,0.03624779}, {475,0.03504425}, {476,0.03650442}, {477,0.03531858}, {478,0.03659292}, {479,0.03542478}, {480,0.03651327}, {481,0.03531858}, {482,0.03674336}, {483,0.03562832}, {484,0.03699115}, {485,0.03589381}, {486,0.03728319}, {487,0.03606195}, {488,0.03720354}, {489,0.03607080}, {490,0.03746903}, {491,0.03623894}, {492,0.03752212}, {493,0.03637168}, {494,0.03776106}, {495,0.03661947}, {496,0.03777876}, {497,0.03671681}, {498,0.03681416}, {499,0.03686726}, {500,0.03688496}, {505,0.03730973}, {510,0.03777876}, {515,0.03938053}, {520,0.03820354}, {525,0.03993805}, {530,0.03899115}, {535,0.04074336}, {540,0.03980531}, {545,0.04011504}, {550,0.04188496}, {555,0.04096460}, {560,0.04246903}, {565,0.04171681}, {570,0.04332743}, {575,0.04254867}, {580,0.04266372}, {585,0.04441593}, {590,0.04351327}, {595,0.04394690}, {600,0.04559292}, {605,0.04473451}, {610,0.04634513}, {615,0.04711504}, {620,0.04582301}, {625,0.04745133}, {630,0.04816814}, {635,0.04705310}, {640,0.04833628}, {645,0.04909735}, {650,0.04799115}, {655,0.04976106}, {660,0.05021239}, {665,0.04922124}, {670,0.05078761}, {675,0.05149558}, {680,0.05015929}, {685,0.05069027}, {690,0.05303540}, {695,0.05313274}, {700,0.05189381}, {705,0.05204425}, {710,0.05425664}, {715,0.05459292}, {720,0.05313274}, {725,0.05369027}, {730,0.05622124}, {735,0.05627434}, {740,0.05471681}, {745,0.05520354}, {750,0.05693805}, {755,0.05764602}, {760,0.05796460}, {765,0.05685841}, {770,0.05666372}, {775,0.05851327}, {780,0.05919469}, {785,0.05957522}, {790,0.05838053}, {795,0.05883929}, {800,0.05900000}, {805,0.06176786}, {810,0.06154464}, {815,0.06212500}, {820,0.06233036}, {825,0.06117857}, {830,0.06170536}, {835,0.06266071}, {840,0.06474107}, {845,0.06439286}, {850,0.06579464}, {855,0.06521429}, {860,0.06556250}, {865,0.06592857}, {870,0.06467857}, {875,0.06517857}, {880,0.06570536}, {885,0.06597321}, {890,0.06636607}, {895,0.06803571}, {900,0.06833929}, {905,0.06899107}, {910,0.06941964}, {915,0.06981250}, {920,0.07006250}, {925,0.07066071}, {930,0.07086607}, {935,0.07154464}, {940,0.07194643}, {945,0.07233929}, {950,0.07284821}, {955,0.07349107}, {960,0.07333929}, {965,0.07396429}, {970,0.07429464}, {975,0.07492857}, {980,0.07509821}, {985,0.07560714}, {990,0.07616071}, {995,0.07651786}, {1000,0.07669643}, {1010,0.07770536}, {1020,0.07853571}, {1030,0.07861607}, {1040,0.07746429}, {1050,0.07851786}, {1060,0.08126786}, {1070,0.08208929}, {1080,0.08275000}, {1090,0.08320536}, {1100,0.08408929}, {1110,0.08611607}, {1120,0.08365179}, {1130,0.08661607}, {1140,0.08731250}, {1150,0.08828571}, {1160,0.08820536}, {1170,0.08868750}, {1180,0.09010714}, {1190,0.09080357}, {1200,0.09152679}, {1210,0.09250893}, {1220,0.09311607}, {1230,0.09400893}, {1240,0.09448214}, {1250,0.09750893}, {1260,0.09641964}, {1270,0.09722321}, {1280,0.09845536}, {1290,0.09809821}, {1300,0.09866964}, {1310,0.10048214}, {1320,0.10031250}, {1330,0.10122321}, {1340,0.10230357}, {1350,0.10269643}, {1360,0.10614286}, {1370,0.10442857}, {1380,0.10442857}, {1390,0.10626786}, {1400,0.10680357}, {1410,0.10729464}, {1420,0.10761607}, {1430,0.10931250}, {1440,0.10912500}, {1450,0.11057143}, {1460,0.11111607}, {1470,0.11259821}, {1480,0.11509821}, {1490,0.11362500}, {1500,0.11459821}, {1510,0.11533036}, {1520,0.11688393}, {1530,0.11793750}, {1540,0.11673214}, {1550,0.11708929}, {1560,0.11939286}, {1570,0.11927679}, {1580,0.12277679}, {1590,0.12216964}, {1600,0.12133929}, {1610,0.12610714}, {1620,0.12429464}, {1630,0.12433036}, {1640,0.12486607}, {1650,0.12659821}, {1660,0.12673214}, {1670,0.12725000}, {1680,0.12675000}, {1690,0.12955357}, {1700,0.13030357}, {1710,0.13033036}, {1720,0.13334821}, {1730,0.13201786}, {1740,0.13325893}, {1750,0.13443750}, {1760,0.13385714}, {1770,0.13528571}, {1780,0.13722321}, {1790,0.13656250}, {1800,0.13584821}, {1810,0.13835714}, {1820,0.13916071}, {1830,0.14038393}, {1840,0.14093750}, {1850,0.14233929}, {1860,0.14142857}, {1870,0.14319643}, {1880,0.14364286}, {1890,0.14472321}, {1900,0.14748214}, {1910,0.14833036}, {1920,0.14764286}, {1930,0.14706250}, {1940,0.14810714}, {1950,0.14900000}, {1960,0.15038393}, {1970,0.15144643}, {1980,0.15226786}, {1990,0.15275893}, {2000,0.15335714}, {2050,0.15609821}, {2100,0.15942857}, {2150,0.16276786}, {2200,0.16874107}, {2250,0.17208929}, {2300,0.17668750}, {2350,0.18013393}, {2400,0.18234821}, {2450,0.18767857}, {2500,0.19125000}, {2550,0.19599107}, {2600,0.20369643}, {2650,0.20272321}, {2700,0.20564286}, {2750,0.21167857}, {2800,0.21482143}, {2850,0.21887500}, {2900,0.22239286}, {2950,0.22709821}, {3000,0.23123214}, {3050,0.23616071}, {3100,0.23787500}, {3150,0.23916071}, {3200,0.24533036}, {3250,0.24861607}, {3300,0.25619643}, {3350,0.25786607}, {3400,0.26087500}, {3450,0.26433929}, {3500,0.27360714}, {3550,0.27250000}, {3600,0.27324107}, {3650,0.28016964}, {3700,0.28575893}, {3750,0.28872321}, {3800,0.29095536}, {3850,0.29306250}, {3900,0.29936607}, {3950,0.30628571}, {4000,0.30819643}, {4050,0.31354464}, {4100,0.31221429}, {4150,0.31809821}, {4200,0.33056250}, {4250,0.32646429}, {4300,0.33041964}, {4350,0.33623214}, {4400,0.33753571}, {4450,0.34188393}, {4500,0.34396429}, {4550,0.35317857}, {4600,0.35549107}, {4650,0.36563393}, {4700,0.36086607}, {4750,0.36383929}, {4800,0.36641964}, {4850,0.37383036}, {4900,0.37656250}, {4950,0.39150000}, {5000,0.38300893}, {5050,0.39491964}, {5100,0.39367857}, {5150,0.39342857}, {5200,0.40245536}, {5250,0.39952679}, {5300,0.40746429}, {5350,0.41454464}, {5400,0.42297321}, {5450,0.41721429}, {5500,0.42348214}, {5550,0.42751786}, {5600,0.43448214}, {5650,0.43202679}, {5700,0.43706250}, {5750,0.44388393}, {5800,0.44647321}, {5850,0.45343750}, {5900,0.45283036}, {5950,0.45999107}, {6000,0.46358929}, {6050,0.46839286}, {6100,0.47055357}, {6150,0.47105357}, {6200,0.47652679}, {6250,0.48129464}, {6300,0.48508929}, {6350,0.48840179}, {6400,0.48618750}, {6450,0.49511607}, {6500,0.50930357}, {6550,0.50526786}, {6600,0.51032143}, {6650,0.51810714}, {6700,0.51429464}, {6750,0.52116071}, {6800,0.52170536}, {6850,0.52651786}, {6900,0.53461607}, {6950,0.53811607}, {7000,0.54346429}, {7050,0.54451786}, {7100,0.55202679}, {7150,0.55780357}, {7200,0.56182143}, {7250,0.55995536}, {7300,0.56601786}, {7350,0.56968750}, {7400,0.57356250}, {7450,0.57820536}, {7500,0.59185714}, {7550,0.59179464}, {7600,0.58921429}, {7650,0.59356250}, {7700,0.59437500}, {7750,0.60020536}, {7800,0.60542857}, {7850,0.62092857}, {7900,0.61339286}, {7950,0.61632143}, {8000,0.61394643}, {8050,0.63292857}, {8100,0.64113393}, {8150,0.63627679}, {8200,0.62822321}, {8250,0.64590179}, {8300,0.64096429}, {8350,0.64866964}, {8400,0.64622321}, {8450,0.67166071}, {8500,0.66436607}, {8550,0.66576786}, {8600,0.66733036}, {8650,0.67410714}, {8700,0.68198214}, {8750,0.68858929}, {8800,0.67747321}, {8850,0.68072321}, {8900,0.68940179}, {8950,0.70287500}, {9000,0.69300000}, {9050,0.70469643}, {9100,0.70800000}, {9150,0.71830357}, {9200,0.72174107}, {9250,0.71278571}, {9300,0.71833036}, {9350,0.72234821}, {9400,0.75387500}, {9450,0.74098214}, {9500,0.73852679}, {9550,0.74375893}, {9600,3.30153571}, {9650,0.74954464}, {9700,0.75607143}, {9750,0.77363393}, {9800,0.75450893}, {9850,0.76553571}, {9900,0.76462500}, {9950,0.77867857}, {10000,0.76993750}, {10100,0.81841964}, {10200,0.79509821}, {10300,0.79603571}, {10400,0.79541071}, {10500,0.82279464}, {10600,0.83766071}, {10700,0.82700000}, {10800,0.82951786}, {10900,0.84280357}, {11000,0.87783929}, {11100,0.86458036}, {11200,0.86808929}, {11300,0.87965179}, {11400,0.87597321}, {11500,0.89845536}, {11600,0.89686607}, {11700,0.91974107}, {11800,0.90897321}, {11900,0.92933929}, {12000,0.94516071}, {12100,0.93625000}, {12200,0.94582143}, {12300,0.96075000}, {12400,0.96303571}, {12500,0.97447321}, {12600,0.99675}, {12700,0.96975}, {12800,0.97100}, {12900,1.00225}, {13000,0.98925}, {13100,0.99975}, {13200,1.00250}, {13300,1.02525}, {13400,1.02175}, {13500,1.03600}, {13600,1.03250}, {13700,1.05675}, {13800,1.05800}, {13900,1.06150}, {14000,1.06525}, {14100,1.08450}, {14200,1.10000}, {14300,1.10900}, {14400,1.09125}, {14500,1.13250}, {14600,1.11600}, {14700,1.12950}, {14800,1.13525}, {14900,1.14100}, {15000,2.23925}, {15100,1.17450}, {15200,1.16225}, {15300,1.17775}, {15400,1.18350}, {15500,1.18875}, {15600,1.20250}, {15700,1.22575}, {15800,1.24175}, {15900,1.23425}, {16000,1.22225}, {16100,1.26650}, {16200,1.25350}, {16300,1.26400}, {16400,1.25625}, {16500,1.27225}, {16600,1.27825}, {16700,1.30225}, {16800,1.29300}, {16900,1.29450}, {17000,1.30550}, {17100,1.31400}, {17200,1.32375}, {17300,1.33725}, {17400,1.35600}, {17500,1.36125}, {17600,1.33925}, {17700,1.35875}, {17800,1.36300}, {17900,1.38625}, {18000,1.37925}, {18100,1.39725}, {18200,1.39700}, {18300,1.42975}, {18400,1.41925}, {18500,1.41775}, {18600,1.42850}, {18700,1.43925}, {18800,1.44100}, {18900,1.45300}, {19000,1.45425}, {19100,1.46950}, {19200,1.46625}, {19300,1.48825}, {19400,1.49250}, {19500,1.49650}, {19600,1.49825}, {19700,1.52400}, {19800,1.52500}, {19900,1.54125}, {20000,1.5350}};
data["big_flat"]["simpl Denote"]["Stats"]["user"] = {{1,0.00002655}, {2,0.00015044}, {3,0.00021239}, {4,0.00018584}, {5,0.00038053}, {6,0.00046903}, {7,0.00045133}, {8,0.00061947}, {9,0.00054867}, {10,0.00074336}, {11,0.00061947}, {12,0.00094690}, {13,0.00061062}, {14,0.00115044}, {15,0.00088496}, {16,0.00064602}, {17,0.00130088}, {18,0.00123894}, {19,0.00090265}, {20,0.00104425}, {21,0.00153097}, {22,0.00175221}, {23,0.00149558}, {24,0.00123009}, {25,0.00119469}, {26,0.00107080}, {27,0.00107080}, {28,0.00112389}, {29,0.00124779}, {30,0.00126549}, {31,0.00152212}, {32,0.00182301}, {33,0.00222124}, {34,0.00246018}, {35,0.00235398}, {36,0.00194690}, {37,0.00182301}, {38,0.00261947}, {39,0.00192920}, {40,0.00255752}, {41,0.00259292}, {42,0.00227434}, {43,0.00279646}, {44,0.00265487}, {45,0.00268142}, {46,0.00280531}, {47,0.00280531}, {48,0.00284956}, {49,0.00287611}, {50,0.00295575}, {51,0.00309735}, {52,0.00320354}, {53,0.00315929}, {54,0.00327434}, {55,0.00323894}, {56,0.00441593}, {57,0.00344248}, {58,0.00367257}, {59,0.00368142}, {60,0.00372566}, {61,0.00375221}, {62,0.00382301}, {63,0.00385841}, {64,0.00411504}, {65,0.00413274}, {66,0.00424779}, {67,0.00424779}, {68,0.00433628}, {69,0.00438938}, {70,0.00537168}, {71,0.00439823}, {72,0.00471681}, {73,0.00483186}, {74,0.00516814}, {75,0.00447788}, {76,0.00492920}, {77,0.00540708}, {78,0.00491150}, {79,0.00493805}, {80,0.00555752}, {81,0.00527434}, {82,0.00633628}, {83,0.00532743}, {84,0.00574336}, {85,0.00551327}, {86,0.00598230}, {87,0.00575221}, {88,0.00607080}, {89,0.00609735}, {90,0.00573451}, {91,0.00657522}, {92,0.00634513}, {93,0.00638938}, {94,0.00627434}, {95,0.00664602}, {96,0.00667257}, {97,0.00679646}, {98,0.00692035}, {99,0.00682301}, {100,0.00684071}, {101,0.00709735}, {102,0.00780531}, {103,0.00716814}, {104,0.00711504}, {105,0.00721239}, {106,0.00742478}, {107,0.00753982}, {108,0.00740708}, {109,0.00762832}, {110,0.00771681}, {111,0.00791150}, {112,0.00770796}, {113,0.00774336}, {114,0.00801770}, {115,0.00793805}, {116,0.00811504}, {117,0.00847788}, {118,0.00813274}, {119,0.00840708}, {120,0.00836283}, {121,0.00864602}, {122,0.00856637}, {123,0.00877876}, {124,0.00885841}, {125,0.00877876}, {126,0.00974336}, {127,0.00915929}, {128,0.00912389}, {129,0.00910619}, {130,0.00915929}, {131,0.00953097}, {132,0.00930973}, {133,0.01038053}, {134,0.00936283}, {135,0.00961947}, {136,0.00970796}, {137,0.01019469}, {138,0.01019469}, {139,0.01021239}, {140,0.01092920}, {141,0.00992035}, {142,0.01003540}, {143,0.01046903}, {144,0.01059292}, {145,0.01060177}, {146,0.01065487}, {147,0.01072566}, {148,0.01061062}, {149,0.01098230}, {150,0.01071681}, {151,0.01080531}, {152,0.01111504}, {153,0.01203540}, {154,0.01125664}, {155,0.01101770}, {156,0.01141593}, {157,0.01138938}, {158,0.01146018}, {159,0.01241593}, {160,0.01179646}, {161,0.01180531}, {162,0.01193805}, {163,0.01183186}, {164,0.01180531}, {165,0.01207080}, {166,0.01215044}, {167,0.01219469}, {168,0.01211504}, {169,0.01223894}, {170,0.01337168}, {171,0.01259292}, {172,0.01240708}, {173,0.01289381}, {174,0.01273451}, {175,0.01284071}, {176,0.01282301}, {177,0.01281416}, {178,0.01283186}, {179,0.01300885}, {180,0.01297345}, {181,0.01330973}, {182,0.01346018}, {183,0.01369027}, {184,0.01361947}, {185,0.01354867}, {186,0.01471681}, {187,0.01347788}, {188,0.01362832}, {189,0.01417699}, {190,0.01385841}, {191,0.01488496}, {192,0.01407965}, {193,0.01408850}, {194,0.01431858}, {195,0.01470796}, {196,0.01409735}, {197,0.01484956}, {198,0.01436283}, {199,0.01479646}, {200,0.01566372}, {201,0.01485841}, {202,0.01454867}, {203,0.01497345}, {204,0.01513274}, {205,0.01601770}, {206,0.01548673}, {207,0.01534513}, {208,0.01560177}, {209,0.01520354}, {210,0.01562832}, {211,0.01570796}, {212,0.01579646}, {213,0.01580531}, {214,0.01684071}, {215,0.01603540}, {216,0.01609735}, {217,0.01615929}, {218,0.01685841}, {219,0.01629204}, {220,0.01618584}, {221,0.01640708}, {222,0.01646903}, {223,0.01634513}, {224,0.01640708}, {225,0.01632743}, {226,0.01669912}, {227,0.01676106}, {228,0.01681416}, {229,0.01690265}, {230,0.01694690}, {231,0.01801770}, {232,0.01707965}, {233,0.01730973}, {234,0.01715044}, {235,0.01790265}, {236,0.01712389}, {237,0.01747788}, {238,0.01774336}, {239,0.01818584}, {240,0.01715929}, {241,0.01724779}, {242,0.01756637}, {243,0.01765487}, {244,0.01785841}, {245,0.01808850}, {246,0.01803540}, {247,0.01807080}, {248,0.01800000}, {249,0.01800000}, {250,0.01892035}, {251,0.01806195}, {252,0.01822124}, {253,0.01833628}, {254,0.01918584}, {255,0.01838053}, {256,0.01800000}, {257,0.01850442}, {258,0.01861947}, {259,0.01859292}, {260,0.01861062}, {261,0.01963717}, {262,0.01889381}, {263,0.01892035}, {264,0.01888496}, {265,0.01966372}, {266,0.01906195}, {267,0.01917699}, {268,0.02040708}, {269,0.01922124}, {270,0.01939823}, {271,0.01938053}, {272,0.02023009}, {273,0.01932743}, {274,0.01971681}, {275,0.02109735}, {276,0.01972566}, {277,0.01984956}, {278,0.01990265}, {279,0.02007080}, {280,0.01995575}, {281,0.02013274}, {282,0.02123009}, {283,0.02053097}, {284,0.02060177}, {285,0.02165487}, {286,0.02056637}, {287,0.02068142}, {288,0.02040708}, {289,0.02069912}, {290,0.02084071}, {291,0.02114159}, {292,0.02189381}, {293,0.02104425}, {294,0.02130973}, {295,0.02244248}, {296,0.02118584}, {297,0.02131858}, {298,0.02268142}, {299,0.02148673}, {300,0.02204425}, {301,0.02265487}, {302,0.02201770}, {303,0.02182301}, {304,0.02195575}, {305,0.02197345}, {306,0.02184956}, {307,0.02275221}, {308,0.02200885}, {309,0.02231858}, {310,0.02238938}, {311,0.02277876}, {312,0.02269027}, {313,0.02249558}, {314,0.02276106}, {315,0.02303540}, {316,0.02285841}, {317,0.02312389}, {318,0.02324779}, {319,0.02338938}, {320,0.02330088}, {321,0.02342478}, {322,0.02344248}, {323,0.02356637}, {324,0.02360177}, {325,0.02380531}, {326,0.02407965}, {327,0.02404425}, {328,0.02478761}, {329,0.02409735}, {330,0.02412389}, {331,0.02515044}, {332,0.02438053}, {333,0.02438053}, {334,0.02528319}, {335,0.02451327}, {336,0.02458407}, {337,0.02570796}, {338,0.02466372}, {339,0.02480531}, {340,0.02479646}, {341,0.02500885}, {342,0.02641593}, {343,0.02530973}, {344,0.02502655}, {345,0.02625664}, {346,0.02548673}, {347,0.02538938}, {348,0.02673451}, {349,0.02591150}, {350,0.02561062}, {351,0.02605310}, {352,0.02555752}, {353,0.02676991}, {354,0.02576991}, {355,0.02623894}, {356,0.02692035}, {357,0.02637168}, {358,0.02616814}, {359,0.02621239}, {360,0.02620354}, {361,0.02735398}, {362,0.02640708}, {363,0.02664602}, {364,0.02754867}, {365,0.02643363}, {366,0.02798230}, {367,0.02703540}, {368,0.02684071}, {369,0.02797345}, {370,0.02716814}, {371,0.02701770}, {372,0.02721239}, {373,0.02721239}, {374,0.02839823}, {375,0.02769912}, {376,0.02748673}, {377,0.02778761}, {378,0.02741593}, {379,0.02902655}, {380,0.02834513}, {381,0.02804425}, {382,0.02792035}, {383,0.02797345}, {384,0.02907080}, {385,0.02788496}, {386,0.02823894}, {387,0.02853097}, {388,0.02810619}, {389,0.02959292}, {390,0.02861062}, {391,0.02985841}, {392,0.02827434}, {393,0.02842478}, {394,0.02996460}, {395,0.02899115}, {396,0.03046903}, {397,0.02924779}, {398,0.02919469}, {399,0.02953982}, {400,0.02964602}, {401,0.03104425}, {402,0.02941593}, {403,0.03125664}, {404,0.02992035}, {405,0.02997345}, {406,0.03028319}, {407,0.02999115}, {408,0.03185841}, {409,0.03023009}, {410,0.03158407}, {411,0.03027434}, {412,0.03046903}, {413,0.03036283}, {414,0.03065487}, {415,0.03201770}, {416,0.03079646}, {417,0.03201770}, {418,0.03059292}, {419,0.03223009}, {420,0.03115044}, {421,0.03130088}, {422,0.03146018}, {423,0.03140708}, {424,0.03310619}, {425,0.03167257}, {426,0.03307965}, {427,0.03181416}, {428,0.03309735}, {429,0.03197345}, {430,0.03300000}, {431,0.03206195}, {432,0.03189381}, {433,0.03227434}, {434,0.03236283}, {435,0.03330088}, {436,0.03260177}, {437,0.03361062}, {438,0.03242478}, {439,0.03407080}, {440,0.03255752}, {441,0.03406195}, {442,0.03274336}, {443,0.03401770}, {444,0.03326549}, {445,0.03295575}, {446,0.03347788}, {447,0.03327434}, {448,0.03323894}, {449,0.03308850}, {450,0.03448673}, {451,0.03382301}, {452,0.03453097}, {453,0.03361947}, {454,0.03492920}, {455,0.03361947}, {456,0.03482301}, {457,0.03350442}, {458,0.03515044}, {459,0.03407965}, {460,0.03518584}, {461,0.03458407}, {462,0.03538938}, {463,0.03455752}, {464,0.03538053}, {465,0.03452212}, {466,0.03567257}, {467,0.03448673}, {468,0.03576106}, {469,0.03485841}, {470,0.03598230}, {471,0.03503540}, {472,0.03630088}, {473,0.03484071}, {474,0.03644248}, {475,0.03521239}, {476,0.03643363}, {477,0.03555752}, {478,0.03646903}, {479,0.03554867}, {480,0.03657522}, {481,0.03547788}, {482,0.03667257}, {483,0.03567257}, {484,0.03715044}, {485,0.03607965}, {486,0.03700000}, {487,0.03606195}, {488,0.03723894}, {489,0.03612389}, {490,0.03692920}, {491,0.03607080}, {492,0.03760177}, {493,0.03661062}, {494,0.03788496}, {495,0.03651327}, {496,0.03774336}, {497,0.03667257}, {498,0.03673451}, {499,0.03681416}, {500,0.03669912}, {505,0.03707080}, {510,0.03788496}, {515,0.03910619}, {520,0.03813274}, {525,0.03976106}, {530,0.03844248}, {535,0.04071681}, {540,0.03963717}, {545,0.04003540}, {550,0.04191150}, {555,0.04052212}, {560,0.04301770}, {565,0.04202655}, {570,0.04358407}, {575,0.04258407}, {580,0.04274336}, {585,0.04466372}, {590,0.04384071}, {595,0.04438053}, {600,0.04561062}, {605,0.04504425}, {610,0.04649558}, {615,0.04713274}, {620,0.04627434}, {625,0.04753097}, {630,0.04798230}, {635,0.04696460}, {640,0.04817699}, {645,0.04892920}, {650,0.04773451}, {655,0.04907080}, {660,0.05017699}, {665,0.04880531}, {670,0.05023894}, {675,0.05110619}, {680,0.04997345}, {685,0.05033628}, {690,0.05284071}, {695,0.05316814}, {700,0.05162832}, {705,0.05161947}, {710,0.05407965}, {715,0.05439823}, {720,0.05315044}, {725,0.05374336}, {730,0.05651327}, {735,0.05625664}, {740,0.05476991}, {745,0.05561062}, {750,0.05696460}, {755,0.05711504}, {760,0.05801770}, {765,0.05695575}, {770,0.05674336}, {775,0.05833628}, {780,0.05919469}, {785,0.05930973}, {790,0.05803540}, {795,0.05891071}, {800,0.05911607}, {805,0.06185714}, {810,0.06153571}, {815,0.06241964}, {820,0.06270536}, {825,0.06140179}, {830,0.06152679}, {835,0.06184821}, {840,0.06473214}, {845,0.06430357}, {850,0.06484821}, {855,0.06532143}, {860,0.06575893}, {865,0.06620536}, {870,0.06496429}, {875,0.06551786}, {880,0.06553571}, {885,0.06599107}, {890,0.06650893}, {895,0.06819643}, {900,0.06867857}, {905,0.06911607}, {910,0.06917857}, {915,0.06937500}, {920,0.07019643}, {925,0.07043750}, {930,0.07083036}, {935,0.07109821}, {940,0.07166071}, {945,0.07183929}, {950,0.07239286}, {955,0.07321429}, {960,0.07342857}, {965,0.07407143}, {970,0.07430357}, {975,0.07525893}, {980,0.07527679}, {985,0.07601786}, {990,0.07656250}, {995,0.07615179}, {1000,0.07675893}, {1010,0.07756250}, {1020,0.07856250}, {1030,0.07844643}, {1040,0.07728571}, {1050,0.07837500}, {1060,0.08093750}, {1070,0.08194643}, {1080,0.08281250}, {1090,0.08316071}, {1100,0.08400893}, {1110,0.08601786}, {1120,0.08386607}, {1130,0.08661607}, {1140,0.08752679}, {1150,0.08850893}, {1160,0.08857143}, {1170,0.08880357}, {1180,0.08977679}, {1190,0.09070536}, {1200,0.09126786}, {1210,0.09235714}, {1220,0.09273214}, {1230,0.09388393}, {1240,0.09415179}, {1250,0.09770536}, {1260,0.09647321}, {1270,0.09731250}, {1280,0.09880357}, {1290,0.09805357}, {1300,0.09882143}, {1310,0.10066964}, {1320,0.10049107}, {1330,0.10130357}, {1340,0.10202679}, {1350,0.10234821}, {1360,0.10599107}, {1370,0.10420536}, {1380,0.10386607}, {1390,0.10613393}, {1400,0.10683929}, {1410,0.10716964}, {1420,0.10744643}, {1430,0.10928571}, {1440,0.10899107}, {1450,0.11063393}, {1460,0.11133036}, {1470,0.11263393}, {1480,0.11485714}, {1490,0.11345536}, {1500,0.11433036}, {1510,0.11481250}, {1520,0.11628571}, {1530,0.11732143}, {1540,0.11619643}, {1550,0.11704464}, {1560,0.11930357}, {1570,0.11894643}, {1580,0.12254464}, {1590,0.12212500}, {1600,0.12129464}, {1610,0.12651786}, {1620,0.12409821}, {1630,0.12438393}, {1640,0.12514286}, {1650,0.12684821}, {1660,0.12696429}, {1670,0.12723214}, {1680,0.12736607}, {1690,0.12945536}, {1700,0.13023214}, {1710,0.13028571}, {1720,0.13299107}, {1730,0.13185714}, {1740,0.13325000}, {1750,0.13439286}, {1760,0.13378571}, {1770,0.13558929}, {1780,0.13715179}, {1790,0.13673214}, {1800,0.13591071}, {1810,0.13825000}, {1820,0.13908929}, {1830,0.14052679}, {1840,0.14098214}, {1850,0.14219643}, {1860,0.14128571}, {1870,0.14295536}, {1880,0.14340179}, {1890,0.14454464}, {1900,0.14705357}, {1910,0.14846429}, {1920,0.14723214}, {1930,0.14683929}, {1940,0.14812500}, {1950,0.14897321}, {1960,0.15065179}, {1970,0.15171429}, {1980,0.15225893}, {1990,0.15274107}, {2000,0.15330357}, {2050,0.15601786}, {2100,0.15924107}, {2150,0.16250893}, {2200,0.16858036}, {2250,0.17215179}, {2300,0.17637500}, {2350,0.17981250}, {2400,0.18225000}, {2450,0.18755357}, {2500,0.19164286}, {2550,0.19568750}, {2600,0.20392857}, {2650,0.20300000}, {2700,0.20561607}, {2750,0.21166071}, {2800,0.21490179}, {2850,0.21883036}, {2900,0.22219643}, {2950,0.22705357}, {3000,0.23082143}, {3050,0.23588393}, {3100,0.23781250}, {3150,0.23877679}, {3200,0.24494643}, {3250,0.24821429}, {3300,0.25621429}, {3350,0.25783929}, {3400,0.26061607}, {3450,0.26453571}, {3500,0.27341964}, {3550,0.27258036}, {3600,0.27340179}, {3650,0.27997321}, {3700,0.28533929}, {3750,0.28854464}, {3800,0.29090179}, {3850,0.29283036}, {3900,0.29928571}, {3950,0.30576786}, {4000,0.30798214}, {4050,0.31346429}, {4100,0.31208929}, {4150,0.31812500}, {4200,0.33027679}, {4250,0.32597321}, {4300,0.33015179}, {4350,0.33617857}, {4400,0.33725893}, {4450,0.34175000}, {4500,0.34343750}, {4550,0.35268750}, {4600,0.35521429}, {4650,0.36520536}, {4700,0.36043750}, {4750,0.36334821}, {4800,0.36611607}, {4850,0.37350893}, {4900,0.37628571}, {4950,0.39116071}, {5000,0.38302679}, {5050,0.39473214}, {5100,0.39387500}, {5150,0.39345536}, {5200,0.40217857}, {5250,0.39933036}, {5300,0.40749107}, {5350,0.41450000}, {5400,0.42244643}, {5450,0.41716964}, {5500,0.42317857}, {5550,0.42720536}, {5600,0.43403571}, {5650,0.43175893}, {5700,0.43691964}, {5750,0.44374107}, {5800,0.44639286}, {5850,0.45334821}, {5900,0.45235714}, {5950,0.45997321}, {6000,0.46327679}, {6050,0.46816964}, {6100,0.47004464}, {6150,0.47083036}, {6200,0.47625893}, {6250,0.48095536}, {6300,0.48502679}, {6350,0.48816071}, {6400,0.48578571}, {6450,0.49511607}, {6500,0.50935714}, {6550,0.50508036}, {6600,0.51010714}, {6650,0.51804464}, {6700,0.51400893}, {6750,0.52110714}, {6800,0.52140179}, {6850,0.52625893}, {6900,0.53441964}, {6950,0.53782143}, {7000,0.54300893}, {7050,0.54450893}, {7100,0.55167857}, {7150,0.55751786}, {7200,0.56083036}, {7250,0.55970536}, {7300,0.56565179}, {7350,0.56944643}, {7400,0.57322321}, {7450,0.57794643}, {7500,0.59088393}, {7550,0.59137500}, {7600,0.58889286}, {7650,0.59311607}, {7700,0.59432143}, {7750,0.59982143}, {7800,0.60520536}, {7850,0.62063393}, {7900,0.61317857}, {7950,0.61603571}, {8000,0.61382143}, {8050,0.63250000}, {8100,0.63841071}, {8150,0.63600000}, {8200,0.62816071}, {8250,0.64529464}, {8300,0.64043750}, {8350,0.64843750}, {8400,0.64599107}, {8450,0.67086607}, {8500,0.66355357}, {8550,0.66539286}, {8600,0.66660714}, {8650,0.67369643}, {8700,0.68166071}, {8750,0.68782143}, {8800,0.67716071}, {8850,0.68024107}, {8900,0.68873214}, {8950,0.70225893}, {9000,0.69266071}, {9050,0.70418750}, {9100,0.70733036}, {9150,0.71800000}, {9200,0.72091071}, {9250,0.71240179}, {9300,0.71802679}, {9350,0.72216964}, {9400,0.75395536}, {9450,0.74066964}, {9500,0.73805357}, {9550,0.74365179}, {9600,3.29956250}, {9650,0.74977679}, {9700,0.75606250}, {9750,0.77334821}, {9800,0.75451786}, {9850,0.76567857}, {9900,0.76457143}, {9950,0.77866964}, {10000,0.76983929}, {10100,0.81837500}, {10200,0.79492857}, {10300,0.79551786}, {10400,0.79528571}, {10500,0.82234821}, {10600,0.83723214}, {10700,0.82683929}, {10800,0.82926786}, {10900,0.84245536}, {11000,0.87748214}, {11100,0.86431250}, {11200,0.86778571}, {11300,0.87947321}, {11400,0.87588393}, {11500,0.89833929}, {11600,0.89664286}, {11700,0.91951786}, {11800,0.90860714}, {11900,0.92877679}, {12000,0.94504464}, {12100,0.93583929}, {12200,0.94580357}, {12300,0.96025893}, {12400,0.96264286}, {12500,0.97383929}, {12600,0.95750}, {12700,0.96950}, {12800,0.96975}, {12900,1.00250}, {13000,0.98775}, {13100,0.99750}, {13200,1.00075}, {13300,1.02550}, {13400,1.02150}, {13500,1.03450}, {13600,1.03125}, {13700,1.05550}, {13800,1.06000}, {13900,1.05925}, {14000,1.06450}, {14100,1.08400}, {14200,1.09825}, {14300,1.10775}, {14400,1.08425}, {14500,1.11050}, {14600,1.11125}, {14700,1.12525}, {14800,1.13025}, {14900,1.14100}, {15000,2.22900}, {15100,1.16950}, {15200,1.16025}, {15300,1.17625}, {15400,1.17475}, {15500,1.18550}, {15600,1.19775}, {15700,1.20825}, {15800,1.22500}, {15900,1.22825}, {16000,1.22150}, {16100,1.24725}, {16200,1.24950}, {16300,1.25975}, {16400,1.24900}, {16500,1.26450}, {16600,1.27275}, {16700,1.28675}, {16800,1.28275}, {16900,1.28475}, {17000,1.30050}, {17100,1.31325}, {17200,1.31550}, {17300,1.32575}, {17400,1.34250}, {17500,1.34225}, {17600,1.33375}, {17700,1.35275}, {17800,1.35800}, {17900,1.38350}, {18000,1.37625}, {18100,1.39600}, {18200,1.39350}, {18300,1.42950}, {18400,1.41875}, {18500,1.41775}, {18600,1.43000}, {18700,1.43850}, {18800,1.44200}, {18900,1.45225}, {19000,1.45175}, {19100,1.46925}, {19200,1.46550}, {19300,1.48700}, {19400,1.49175}, {19500,1.49575}, {19600,1.49650}, {19700,1.52375}, {19800,1.52475}, {19900,1.54125}, {20000,1.5355}};
data["big_flat"]["simpl Denote"]["Stats"]["system"] = {{1,0.00005310}, {2,0.00003540}, {3,0.00007080}, {4,0.00007080}, {5,0.00006195}, {6,0.00003540}, {7,0.00000000}, {8,0.00000000}, {9,0.00003540}, {10,0.00000000}, {11,0.00003540}, {12,0.00008850}, {13,0.00003540}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00009735}, {18,0.00000000}, {19,0.00003540}, {20,0.00003540}, {21,0.00000000}, {22,0.00000000}, {23,0.00003540}, {24,0.00000000}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00003540}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00003540}, {36,0.00000000}, {37,0.00007080}, {38,0.00000000}, {39,0.00002655}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00003540}, {45,0.00006195}, {46,0.00000000}, {47,0.00003540}, {48,0.00000000}, {49,0.00003540}, {50,0.00003540}, {51,0.00002655}, {52,0.00000000}, {53,0.00003540}, {54,0.00003540}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00003540}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00002655}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00003540}, {71,0.00000000}, {72,0.00002655}, {73,0.00000000}, {74,0.00003540}, {75,0.00002655}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00007080}, {83,0.00002655}, {84,0.00003540}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00002655}, {96,0.00003540}, {97,0.00000000}, {98,0.00000000}, {99,0.00003540}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00003540}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00003540}, {118,0.00003540}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00003540}, {125,0.00000000}, {126,0.00009735}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00007080}, {134,0.00003540}, {135,0.00002655}, {136,0.00007080}, {137,0.00000000}, {138,0.00003540}, {139,0.00000000}, {140,0.00002655}, {141,0.00003540}, {142,0.00000000}, {143,0.00000000}, {144,0.00000000}, {145,0.00002655}, {146,0.00000000}, {147,0.00000000}, {148,0.00003540}, {149,0.00003540}, {150,0.00000000}, {151,0.00000000}, {152,0.00003540}, {153,0.00000000}, {154,0.00003540}, {155,0.00007080}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00000000}, {160,0.00000000}, {161,0.00000000}, {162,0.00000000}, {163,0.00000000}, {164,0.00000000}, {165,0.00000000}, {166,0.00003540}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00003540}, {173,0.00000000}, {174,0.00000000}, {175,0.00003540}, {176,0.00000000}, {177,0.00000000}, {178,0.00002655}, {179,0.00003540}, {180,0.00003540}, {181,0.00000000}, {182,0.00003540}, {183,0.00007080}, {184,0.00000000}, {185,0.00002655}, {186,0.00000000}, {187,0.00000000}, {188,0.00000000}, {189,0.00003540}, {190,0.00003540}, {191,0.00007080}, {192,0.00000000}, {193,0.00003540}, {194,0.00000000}, {195,0.00000000}, {196,0.00000000}, {197,0.00000000}, {198,0.00002655}, {199,0.00000000}, {200,0.00006195}, {201,0.00000000}, {202,0.00000000}, {203,0.00003540}, {204,0.00003540}, {205,0.00000000}, {206,0.00003540}, {207,0.00003540}, {208,0.00000000}, {209,0.00002655}, {210,0.00000000}, {211,0.00000000}, {212,0.00000000}, {213,0.00000000}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00007080}, {219,0.00000000}, {220,0.00000000}, {221,0.00000000}, {222,0.00003540}, {223,0.00000000}, {224,0.00000000}, {225,0.00003540}, {226,0.00000000}, {227,0.00000000}, {228,0.00000000}, {229,0.00000000}, {230,0.00000000}, {231,0.00003540}, {232,0.00007080}, {233,0.00000000}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00003540}, {241,0.00000000}, {242,0.00000000}, {243,0.00007080}, {244,0.00000000}, {245,0.00002655}, {246,0.00007080}, {247,0.00000000}, {248,0.00003540}, {249,0.00000000}, {250,0.00006195}, {251,0.00006195}, {252,0.00003540}, {253,0.00000000}, {254,0.00003540}, {255,0.00000000}, {256,0.00002655}, {257,0.00003540}, {258,0.00000000}, {259,0.00000000}, {260,0.00003540}, {261,0.00000000}, {262,0.00000000}, {263,0.00000000}, {264,0.00000000}, {265,0.00003540}, {266,0.00000000}, {267,0.00000000}, {268,0.00000000}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00003540}, {273,0.00000000}, {274,0.00000000}, {275,0.00000000}, {276,0.00003540}, {277,0.00005310}, {278,0.00003540}, {279,0.00000000}, {280,0.00000000}, {281,0.00000000}, {282,0.00000000}, {283,0.00000000}, {284,0.00000000}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00003540}, {289,0.00000000}, {290,0.00003540}, {291,0.00003540}, {292,0.00000000}, {293,0.00000000}, {294,0.00000000}, {295,0.00003540}, {296,0.00003540}, {297,0.00003540}, {298,0.00000000}, {299,0.00000000}, {300,0.00000000}, {301,0.00003540}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00007080}, {306,0.00000000}, {307,0.00003540}, {308,0.00000000}, {309,0.00000000}, {310,0.00003540}, {311,0.00000000}, {312,0.00003540}, {313,0.00003540}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00003540}, {318,0.00000000}, {319,0.00000000}, {320,0.00006195}, {321,0.00003540}, {322,0.00007080}, {323,0.00000000}, {324,0.00000000}, {325,0.00000000}, {326,0.00000000}, {327,0.00000000}, {328,0.00003540}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00003540}, {334,0.00003540}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00000000}, {339,0.00000000}, {340,0.00003540}, {341,0.00000000}, {342,0.00000000}, {343,0.00000000}, {344,0.00000000}, {345,0.00000000}, {346,0.00000000}, {347,0.00003540}, {348,0.00000000}, {349,0.00000000}, {350,0.00003540}, {351,0.00000000}, {352,0.00000000}, {353,0.00003540}, {354,0.00000000}, {355,0.00003540}, {356,0.00003540}, {357,0.00000000}, {358,0.00000000}, {359,0.00000000}, {360,0.00000000}, {361,0.00003540}, {362,0.00003540}, {363,0.00000000}, {364,0.00000000}, {365,0.00007080}, {366,0.00000000}, {367,0.00003540}, {368,0.00000000}, {369,0.00000000}, {370,0.00000000}, {371,0.00000000}, {372,0.00000000}, {373,0.00003540}, {374,0.00007080}, {375,0.00003540}, {376,0.00000000}, {377,0.00003540}, {378,0.00000000}, {379,0.00000000}, {380,0.00003540}, {381,0.00000000}, {382,0.00000000}, {383,0.00003540}, {384,0.00003540}, {385,0.00000000}, {386,0.00000000}, {387,0.00000000}, {388,0.00000000}, {389,0.00000000}, {390,0.00000000}, {391,0.00000000}, {392,0.00003540}, {393,0.00000000}, {394,0.00000000}, {395,0.00000000}, {396,0.00000000}, {397,0.00000000}, {398,0.00003540}, {399,0.00000000}, {400,0.00003540}, {401,0.00002655}, {402,0.00003540}, {403,0.00002655}, {404,0.00000000}, {405,0.00000000}, {406,0.00007080}, {407,0.00000000}, {408,0.00003540}, {409,0.00003540}, {410,0.00007080}, {411,0.00000000}, {412,0.00003540}, {413,0.00000000}, {414,0.00000000}, {415,0.00000000}, {416,0.00000000}, {417,0.00000000}, {418,0.00000000}, {419,0.00003540}, {420,0.00000000}, {421,0.00003540}, {422,0.00000000}, {423,0.00000000}, {424,0.00003540}, {425,0.00000000}, {426,0.00000000}, {427,0.00003540}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00000000}, {432,0.00000000}, {433,0.00000000}, {434,0.00000000}, {435,0.00003540}, {436,0.00000000}, {437,0.00000000}, {438,0.00000000}, {439,0.00009735}, {440,0.00000000}, {441,0.00007080}, {442,0.00003540}, {443,0.00008850}, {444,0.00007080}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00003540}, {449,0.00000000}, {450,0.00000000}, {451,0.00003540}, {452,0.00003540}, {453,0.00003540}, {454,0.00000000}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00010619}, {459,0.00000000}, {460,0.00000000}, {461,0.00000000}, {462,0.00013274}, {463,0.00000000}, {464,0.00007080}, {465,0.00000000}, {466,0.00007080}, {467,0.00000000}, {468,0.00000000}, {469,0.00009735}, {470,0.00007080}, {471,0.00000000}, {472,0.00000000}, {473,0.00003540}, {474,0.00000000}, {475,0.00000000}, {476,0.00006195}, {477,0.00003540}, {478,0.00003540}, {479,0.00000000}, {480,0.00000000}, {481,0.00000000}, {482,0.00000000}, {483,0.00000000}, {484,0.00003540}, {485,0.00000000}, {486,0.00006195}, {487,0.00000000}, {488,0.00003540}, {489,0.00000000}, {490,0.00006195}, {491,0.00003540}, {492,0.00006195}, {493,0.00003540}, {494,0.00006195}, {495,0.00000000}, {496,0.00003540}, {497,0.00000000}, {498,0.00003540}, {499,0.00003540}, {500,0.00003540}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00007080}, {525,0.00000000}, {530,0.00003540}, {535,0.00000000}, {540,0.00003540}, {545,0.00000000}, {550,0.00003540}, {555,0.00003540}, {560,0.00007080}, {565,0.00000000}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00007080}, {600,0.00000000}, {605,0.00000000}, {610,0.00003540}, {615,0.00003540}, {620,0.00003540}, {625,0.00003540}, {630,0.00010619}, {635,0.00009735}, {640,0.00010619}, {645,0.00003540}, {650,0.00003540}, {655,0.00006195}, {660,0.00007080}, {665,0.00003540}, {670,0.00003540}, {675,0.00003540}, {680,0.00000000}, {685,0.00000000}, {690,0.00007080}, {695,0.00003540}, {700,0.00000000}, {705,0.00003540}, {710,0.00000000}, {715,0.00000000}, {720,0.00000000}, {725,0.00000000}, {730,0.00000000}, {735,0.00003540}, {740,0.00002655}, {745,0.00000000}, {750,0.00003540}, {755,0.00003540}, {760,0.00003540}, {765,0.00000000}, {770,0.00000000}, {775,0.00007080}, {780,0.00000000}, {785,0.00003540}, {790,0.00003540}, {795,0.00009821}, {800,0.00003571}, {805,0.00000000}, {810,0.00007143}, {815,0.00007143}, {820,0.00003571}, {825,0.00007143}, {830,0.00007143}, {835,0.00014286}, {840,0.00009821}, {845,0.00012500}, {850,0.00000000}, {855,0.00007143}, {860,0.00007143}, {865,0.00003571}, {870,0.00000000}, {875,0.00009821}, {880,0.00000000}, {885,0.00000000}, {890,0.00010714}, {895,0.00003571}, {900,0.00000000}, {905,0.00000000}, {910,0.00003571}, {915,0.00007143}, {920,0.00007143}, {925,0.00009821}, {930,0.00007143}, {935,0.00007143}, {940,0.00003571}, {945,0.00017857}, {950,0.00010714}, {955,0.00025000}, {960,0.00003571}, {965,0.00006250}, {970,0.00003571}, {975,0.00010714}, {980,0.00010714}, {985,0.00000000}, {990,0.00003571}, {995,0.00027679}, {1000,0.00009821}, {1010,0.00009821}, {1020,0.00007143}, {1030,0.00006250}, {1040,0.00006250}, {1050,0.00000000}, {1060,0.00013393}, {1070,0.00003571}, {1080,0.00000000}, {1090,0.00010714}, {1100,0.00007143}, {1110,0.00010714}, {1120,0.00000000}, {1130,0.00025893}, {1140,0.00020536}, {1150,0.00000000}, {1160,0.00007143}, {1170,0.00003571}, {1180,0.00003571}, {1190,0.00003571}, {1200,0.00006250}, {1210,0.00000000}, {1220,0.00010714}, {1230,0.00007143}, {1240,0.00000000}, {1250,0.00003571}, {1260,0.00000000}, {1270,0.00003571}, {1280,0.00007143}, {1290,0.00010714}, {1300,0.00003571}, {1310,0.00003571}, {1320,0.00007143}, {1330,0.00000000}, {1340,0.00003571}, {1350,0.00002679}, {1360,0.00007143}, {1370,0.00003571}, {1380,0.00007143}, {1390,0.00007143}, {1400,0.00000000}, {1410,0.00000000}, {1420,0.00005357}, {1430,0.00006250}, {1440,0.00007143}, {1450,0.00003571}, {1460,0.00000000}, {1470,0.00007143}, {1480,0.00005357}, {1490,0.00002679}, {1500,0.00002679}, {1510,0.00000000}, {1520,0.00017857}, {1530,0.00010714}, {1540,0.00007143}, {1550,0.00000000}, {1560,0.00007143}, {1570,0.00003571}, {1580,0.00010714}, {1590,0.00007143}, {1600,0.00007143}, {1610,0.00007143}, {1620,0.00010714}, {1630,0.00000000}, {1640,0.00003571}, {1650,0.00010714}, {1660,0.00007143}, {1670,0.00006250}, {1680,0.00000000}, {1690,0.00007143}, {1700,0.00017857}, {1710,0.00007143}, {1720,0.00017857}, {1730,0.00003571}, {1740,0.00010714}, {1750,0.00014286}, {1760,0.00003571}, {1770,0.00003571}, {1780,0.00014286}, {1790,0.00003571}, {1800,0.00000000}, {1810,0.00010714}, {1820,0.00010714}, {1830,0.00010714}, {1840,0.00003571}, {1850,0.00009821}, {1860,0.00007143}, {1870,0.00007143}, {1880,0.00010714}, {1890,0.00010714}, {1900,0.00010714}, {1910,0.00007143}, {1920,0.00016964}, {1930,0.00009821}, {1940,0.00000000}, {1950,0.00002679}, {1960,0.00007143}, {1970,0.00000000}, {1980,0.00003571}, {1990,0.00019643}, {2000,0.00003571}, {2050,0.00003571}, {2100,0.00007143}, {2150,0.00014286}, {2200,0.00003571}, {2250,0.00010714}, {2300,0.00007143}, {2350,0.00014286}, {2400,0.00007143}, {2450,0.00003571}, {2500,0.00003571}, {2550,0.00003571}, {2600,0.00017857}, {2650,0.00007143}, {2700,0.00007143}, {2750,0.00013393}, {2800,0.00021429}, {2850,0.00003571}, {2900,0.00014286}, {2950,0.00007143}, {3000,0.00016964}, {3050,0.00007143}, {3100,0.00009821}, {3150,0.00016964}, {3200,0.00009821}, {3250,0.00020536}, {3300,0.00020536}, {3350,0.00017857}, {3400,0.00007143}, {3450,0.00003571}, {3500,0.00014286}, {3550,0.00000000}, {3600,0.00007143}, {3650,0.00023214}, {3700,0.00013393}, {3750,0.00014286}, {3800,0.00007143}, {3850,0.00025000}, {3900,0.00007143}, {3950,0.00032143}, {4000,0.00027679}, {4050,0.00014286}, {4100,0.00013393}, {4150,0.00003571}, {4200,0.00014286}, {4250,0.00020536}, {4300,0.00010714}, {4350,0.00007143}, {4400,0.00014286}, {4450,0.00013393}, {4500,0.00017857}, {4550,0.00014286}, {4600,0.00007143}, {4650,0.00025000}, {4700,0.00014286}, {4750,0.00027679}, {4800,0.00026786}, {4850,0.00016964}, {4900,0.00007143}, {4950,0.00017857}, {5000,0.00013393}, {5050,0.00025000}, {5100,0.00006250}, {5150,0.00013393}, {5200,0.00031250}, {5250,0.00017857}, {5300,0.00003571}, {5350,0.00027679}, {5400,0.00035714}, {5450,0.00014286}, {5500,0.00017857}, {5550,0.00014286}, {5600,0.00031250}, {5650,0.00017857}, {5700,0.00010714}, {5750,0.00014286}, {5800,0.00014286}, {5850,0.00027679}, {5900,0.00025000}, {5950,0.00014286}, {6000,0.00010714}, {6050,0.00025000}, {6100,0.00014286}, {6150,0.00017857}, {6200,0.00013393}, {6250,0.00000000}, {6300,0.00007143}, {6350,0.00003571}, {6400,0.00003571}, {6450,0.00003571}, {6500,0.00010714}, {6550,0.00007143}, {6600,0.00000000}, {6650,0.00003571}, {6700,0.00027679}, {6750,0.00020536}, {6800,0.00033036}, {6850,0.00028571}, {6900,0.00016964}, {6950,0.00018750}, {7000,0.00016964}, {7050,0.00028571}, {7100,0.00017857}, {7150,0.00014286}, {7200,0.00061607}, {7250,0.00027679}, {7300,0.00024107}, {7350,0.00034821}, {7400,0.00017857}, {7450,0.00028571}, {7500,0.00066071}, {7550,0.00017857}, {7600,0.00009821}, {7650,0.00028571}, {7700,0.00007143}, {7750,0.00021429}, {7800,0.00014286}, {7850,0.00051786}, {7900,0.00016964}, {7950,0.00010714}, {8000,0.00034821}, {8050,0.00038393}, {8100,0.00245536}, {8150,0.00032143}, {8200,0.00014286}, {8250,0.00051786}, {8300,0.00039286}, {8350,0.00016964}, {8400,0.00021429}, {8450,0.00074107}, {8500,0.00049107}, {8550,0.00017857}, {8600,0.00042857}, {8650,0.00024107}, {8700,0.00021429}, {8750,0.00046429}, {8800,0.00010714}, {8850,0.00032143}, {8900,0.00016964}, {8950,0.00042857}, {9000,0.00017857}, {9050,0.00017857}, {9100,0.00042857}, {9150,0.00010714}, {9200,0.00039286}, {9250,0.00027679}, {9300,0.00003571}, {9350,0.00003571}, {9400,0.00003571}, {9450,0.00007143}, {9500,0.00014286}, {9550,0.00009821}, {9600,0.00157143}, {9650,0.00010714}, {9700,0.00000000}, {9750,0.00003571}, {9800,0.00009821}, {9850,0.00003571}, {9900,0.00014286}, {9950,0.00007143}, {10000,0.00000000}, {10100,0.00007143}, {10200,0.00003571}, {10300,0.00021429}, {10400,0.00010714}, {10500,0.00010714}, {10600,0.00003571}, {10700,0.00003571}, {10800,0.00010714}, {10900,0.00009821}, {11000,0.00010714}, {11100,0.00003571}, {11200,0.00014286}, {11300,0.00007143}, {11400,0.00007143}, {11500,0.00003571}, {11600,0.00007143}, {11700,0.00010714}, {11800,0.00010714}, {11900,0.00021429}, {12000,0.00013393}, {12100,0.00007143}, {12200,0.00000000}, {12300,0.00014286}, {12400,0.00009821}, {12500,0.00003571}, {12600,0.00000}, {12700,0.00000}, {12800,0.00000}, {12900,0.00100}, {13000,0.00100}, {13100,0.00100}, {13200,0.00100}, {13300,0.00000}, {13400,0.00000}, {13500,0.00075}, {13600,0.00000}, {13700,0.00100}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00100}, {14300,0.00100}, {14400,0.00100}, {14500,0.00000}, {14600,0.00000}, {14700,0.00000}, {14800,0.00100}, {14900,0.00100}, {15000,0.00000}, {15100,0.00000}, {15200,0.00000}, {15300,0.00075}, {15400,0.00000}, {15500,0.00000}, {15600,0.00000}, {15700,0.00100}, {15800,0.00075}, {15900,0.00000}, {16000,0.00100}, {16100,0.00000}, {16200,0.00000}, {16300,0.00100}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00075}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00100}, {18000,0.00000}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00000}, {18700,0.00000}, {18800,0.00000}, {18900,0.00000}, {19000,0.00100}, {19100,0.00000}, {19200,0.00000}, {19300,0.00100}, {19400,0.00000}, {19500,0.00000}, {19600,0.00100}, {19700,0.00000}, {19800,0.00100}, {19900,0.00000}, {20000,0.0000}};
data["big_flat"]["transitivity"]["Stats"]["real"] = {{1,0.00000000}, {2,0.00000000}, {3,0.00000000}, {4,0.00000000}, {5,0.00000000}, {6,0.00000000}, {7,0.00000000}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00000000}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00060177}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00000000}, {24,0.00001770}, {25,0.00000000}, {26,0.00000000}, {27,0.00000000}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00000000}, {34,0.00000000}, {35,0.00000000}, {36,0.00000000}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00000000}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00000000}, {61,0.00000000}, {62,0.00000000}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00000000}, {69,0.00000000}, {70,0.00000000}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00000000}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000885}, {86,0.00000000}, {87,0.00000000}, {88,0.00000000}, {89,0.00000000}, {90,0.00000000}, {91,0.00000000}, {92,0.00000000}, {93,0.00000000}, {94,0.00000000}, {95,0.00001770}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00001770}, {107,0.00000000}, {108,0.00000000}, {109,0.00000000}, {110,0.00000000}, {111,0.00000000}, {112,0.00000000}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000885}, {121,0.00000885}, {122,0.00001770}, {123,0.00002655}, {124,0.00005310}, {125,0.00004425}, {126,0.00014159}, {127,0.00012389}, {128,0.00014159}, {129,0.00019469}, {130,0.00024779}, {131,0.00024779}, {132,0.00044248}, {133,0.00064602}, {134,0.00063717}, {135,0.00074336}, {136,0.00076106}, {137,0.00089381}, {138,0.00086726}, {139,0.00094690}, {140,0.00094690}, {141,0.00098230}, {142,0.00098230}, {143,0.00100000}, {144,0.00100000}, {145,0.00100000}, {146,0.00100000}, {147,0.00100000}, {148,0.00100000}, {149,0.00100000}, {150,0.00100000}, {151,0.00100000}, {152,0.00100000}, {153,0.00100000}, {154,0.00100000}, {155,0.00100000}, {156,0.00100000}, {157,0.00100000}, {158,0.00100000}, {159,0.00100000}, {160,0.00100885}, {161,0.00100000}, {162,0.00100000}, {163,0.00100000}, {164,0.00168142}, {165,0.00100000}, {166,0.00100000}, {167,0.00100000}, {168,0.00100885}, {169,0.00100000}, {170,0.00100000}, {171,0.00100000}, {172,0.00100000}, {173,0.00100000}, {174,0.00100000}, {175,0.00179646}, {176,0.00100885}, {177,0.00100000}, {178,0.00100885}, {179,0.00100000}, {180,0.00100885}, {181,0.00100000}, {182,0.00100000}, {183,0.00100000}, {184,0.00100000}, {185,0.00100000}, {186,0.00100000}, {187,0.00100000}, {188,0.00100885}, {189,0.00100000}, {190,0.00100000}, {191,0.00100000}, {192,0.00100000}, {193,0.00100000}, {194,0.00100000}, {195,0.00100000}, {196,0.00100000}, {197,0.00100000}, {198,0.00100000}, {199,0.00100000}, {200,0.00100000}, {201,0.00100000}, {202,0.00100000}, {203,0.00100000}, {204,0.00100000}, {205,0.00100000}, {206,0.00100000}, {207,0.00100000}, {208,0.00100000}, {209,0.00198230}, {210,0.00100000}, {211,0.00100000}, {212,0.00100885}, {213,0.00100000}, {214,0.00100000}, {215,0.00100000}, {216,0.00100000}, {217,0.00100000}, {218,0.00100000}, {219,0.00101770}, {220,0.00100000}, {221,0.00100000}, {222,0.00198230}, {223,0.00100000}, {224,0.00100000}, {225,0.00100000}, {226,0.00100000}, {227,0.00100000}, {228,0.00100000}, {229,0.00100000}, {230,0.00100000}, {231,0.00100000}, {232,0.00100000}, {233,0.00100000}, {234,0.00100000}, {235,0.00100000}, {236,0.00100000}, {237,0.00100000}, {238,0.00101770}, {239,0.00100000}, {240,0.00100000}, {241,0.00100000}, {242,0.00100000}, {243,0.00101770}, {244,0.00100000}, {245,0.00100000}, {246,0.00207965}, {247,0.00100000}, {248,0.00101770}, {249,0.00100000}, {250,0.00100000}, {251,0.00100000}, {252,0.00100000}, {253,0.00101770}, {254,0.00100000}, {255,0.00101770}, {256,0.00100000}, {257,0.00100000}, {258,0.00100000}, {259,0.00100000}, {260,0.00100000}, {261,0.00100000}, {262,0.00100000}, {263,0.00100000}, {264,0.00100000}, {265,0.00100000}, {266,0.00100000}, {267,0.00100000}, {268,0.00100000}, {269,0.00101770}, {270,0.00100000}, {271,0.00101770}, {272,0.00100000}, {273,0.00100000}, {274,0.00100000}, {275,0.00101770}, {276,0.00100000}, {277,0.00100000}, {278,0.00100000}, {279,0.00100000}, {280,0.00100000}, {281,0.00100000}, {282,0.00100000}, {283,0.00100000}, {284,0.00100000}, {285,0.00100000}, {286,0.00100000}, {287,0.00100000}, {288,0.00100000}, {289,0.00100000}, {290,0.00100885}, {291,0.00100000}, {292,0.00100000}, {293,0.00101770}, {294,0.00100000}, {295,0.00101770}, {296,0.00100885}, {297,0.00100000}, {298,0.00100885}, {299,0.00100000}, {300,0.00100000}, {301,0.00100000}, {302,0.00100000}, {303,0.00101770}, {304,0.00100885}, {305,0.00104425}, {306,0.00106195}, {307,0.00104425}, {308,0.00103540}, {309,0.00109735}, {310,0.00109735}, {311,0.00118584}, {312,0.00119469}, {313,0.00116814}, {314,0.00117699}, {315,0.00126549}, {316,0.00135398}, {317,0.00133628}, {318,0.00154867}, {319,0.00161947}, {320,0.00145133}, {321,0.00165487}, {322,0.00174336}, {323,0.00173451}, {324,0.00176991}, {325,0.00203540}, {326,0.00181416}, {327,0.00188496}, {328,0.00181416}, {329,0.00186726}, {330,0.00186726}, {331,0.00187611}, {332,0.00187611}, {333,0.00190265}, {334,0.00190265}, {335,0.00195575}, {336,0.00194690}, {337,0.00194690}, {338,0.00197345}, {339,0.00200000}, {340,0.00197345}, {341,0.00200000}, {342,0.00198230}, {343,0.00199115}, {344,0.00200000}, {345,0.00200000}, {346,0.00200000}, {347,0.00200000}, {348,0.00200000}, {349,0.00200000}, {350,0.00200000}, {351,0.00200000}, {352,0.00200000}, {353,0.00200000}, {354,0.00200000}, {355,0.00200000}, {356,0.00200000}, {357,0.00200000}, {358,0.00200000}, {359,0.00200000}, {360,0.00200000}, {361,0.00200000}, {362,0.00200000}, {363,0.00200000}, {364,0.00200000}, {365,0.00200000}, {366,0.00200000}, {367,0.00200000}, {368,0.00200000}, {369,0.00200000}, {370,0.00200000}, {371,0.00298230}, {372,0.00200000}, {373,0.00200000}, {374,0.00200000}, {375,0.00200000}, {376,0.00200000}, {377,0.00200000}, {378,0.00200000}, {379,0.00200000}, {380,0.00200000}, {381,0.00200885}, {382,0.00200885}, {383,0.00200000}, {384,0.00200885}, {385,0.00200000}, {386,0.00298230}, {387,0.00200000}, {388,0.00200000}, {389,0.00200000}, {390,0.00200000}, {391,0.00200000}, {392,0.00200000}, {393,0.00200000}, {394,0.00200885}, {395,0.00200000}, {396,0.00200000}, {397,0.00200000}, {398,0.00298230}, {399,0.00200000}, {400,0.00200000}, {401,0.00200000}, {402,0.00200000}, {403,0.00200000}, {404,0.00200000}, {405,0.00200000}, {406,0.00200000}, {407,0.00200000}, {408,0.00200000}, {409,0.00200000}, {410,0.00200000}, {411,0.00200000}, {412,0.00298230}, {413,0.00200000}, {414,0.00200000}, {415,0.00200000}, {416,0.00200000}, {417,0.00200000}, {418,0.00200000}, {419,0.00200000}, {420,0.00200000}, {421,0.00200000}, {422,0.00200000}, {423,0.00200000}, {424,0.00200000}, {425,0.00201770}, {426,0.00200000}, {427,0.00200000}, {428,0.00200000}, {429,0.00200000}, {430,0.00200000}, {431,0.00200000}, {432,0.00200000}, {433,0.00200000}, {434,0.00200000}, {435,0.00200000}, {436,0.00200000}, {437,0.00201770}, {438,0.00200000}, {439,0.00200000}, {440,0.00200000}, {441,0.00200000}, {442,0.00200000}, {443,0.00200000}, {444,0.00200000}, {445,0.00200000}, {446,0.00200000}, {447,0.00200000}, {448,0.00200000}, {449,0.00200000}, {450,0.00200000}, {451,0.00200000}, {452,0.00201770}, {453,0.00200000}, {454,0.00200000}, {455,0.00201770}, {456,0.00200000}, {457,0.00200000}, {458,0.00200000}, {459,0.00200000}, {460,0.00200000}, {461,0.00200000}, {462,0.00200000}, {463,0.00200000}, {464,0.00200885}, {465,0.00200000}, {466,0.00200000}, {467,0.00200000}, {468,0.00200000}, {469,0.00200000}, {470,0.00200000}, {471,0.00200000}, {472,0.00201770}, {473,0.00204425}, {474,0.00201770}, {475,0.00202655}, {476,0.00200885}, {477,0.00203540}, {478,0.00201770}, {479,0.00202655}, {480,0.00200885}, {481,0.00200885}, {482,0.00202655}, {483,0.00201770}, {484,0.00209735}, {485,0.00212389}, {486,0.00212389}, {487,0.00212389}, {488,0.00206195}, {489,0.00209735}, {490,0.00202655}, {491,0.00208850}, {492,0.00207080}, {493,0.00207965}, {494,0.00203540}, {495,0.00219469}, {496,0.00207965}, {497,0.00216814}, {498,0.00223009}, {499,0.00227434}, {500,0.00223894}, {505,0.00304425}, {510,0.00269912}, {515,0.00276991}, {520,0.00285841}, {525,0.00284956}, {530,0.00291150}, {535,0.00293805}, {540,0.00300000}, {545,0.00300000}, {550,0.00300000}, {555,0.00300000}, {560,0.00300000}, {565,0.00300000}, {570,0.00300000}, {575,0.00398230}, {580,0.00300000}, {585,0.00300000}, {590,0.00300000}, {595,0.00300000}, {600,0.00300000}, {605,0.00300000}, {610,0.00300000}, {615,0.00300000}, {620,0.00300000}, {625,0.00300000}, {630,0.00300000}, {635,0.00300000}, {640,0.00300000}, {645,0.00300000}, {650,0.00300000}, {655,0.00300000}, {660,0.00300000}, {665,0.00300885}, {670,0.00301770}, {675,0.00301770}, {680,0.00311504}, {685,0.00314159}, {690,0.00330088}, {695,0.00361062}, {700,0.00377876}, {705,0.00376991}, {710,0.00376991}, {715,0.00376106}, {720,0.00382301}, {725,0.00385841}, {730,0.00386726}, {735,0.00398230}, {740,0.00400000}, {745,0.00400885}, {750,0.00400885}, {755,0.00400885}, {760,0.00400000}, {765,0.00400885}, {770,0.00400000}, {775,0.00400000}, {780,0.00400000}, {785,0.00400000}, {790,0.00498230}, {795,0.00400000}, {800,0.00400000}, {805,0.00400893}, {810,0.00400000}, {815,0.00400000}, {820,0.00400000}, {825,0.00534821}, {830,0.00577679}, {835,0.00402679}, {840,0.00402679}, {845,0.00400893}, {850,0.00402679}, {855,0.00407143}, {860,0.00412500}, {865,0.00420536}, {870,0.00550000}, {875,0.00467857}, {880,0.00461607}, {885,0.00468750}, {890,0.00471429}, {895,0.00474107}, {900,0.00476786}, {905,0.00482143}, {910,0.00482143}, {915,0.00491964}, {920,0.00487500}, {925,0.00517857}, {930,0.00502679}, {935,0.00499107}, {940,0.00500000}, {945,0.00500000}, {950,0.00500000}, {955,0.00500893}, {960,0.00500893}, {965,0.00589286}, {970,0.00500000}, {975,0.00500893}, {980,0.00501786}, {985,0.00500893}, {990,0.00500893}, {995,0.00502679}, {1000,0.00508036}, {1010,0.00509821}, {1020,0.00516964}, {1030,0.00538393}, {1040,0.00536607}, {1050,0.00653571}, {1060,0.00565179}, {1070,0.00573214}, {1080,0.00572321}, {1090,0.00578571}, {1100,0.00587500}, {1110,0.00591071}, {1120,0.00656250}, {1130,0.00599107}, {1140,0.00600893}, {1150,0.00600893}, {1160,0.00600893}, {1170,0.00601786}, {1180,0.00607143}, {1190,0.00606250}, {1200,0.00619643}, {1210,0.00632143}, {1220,0.00641964}, {1230,0.00655357}, {1240,0.00919643}, {1250,0.00672321}, {1260,0.00673214}, {1270,0.00680357}, {1280,0.00691964}, {1290,0.00685714}, {1300,0.00864286}, {1310,0.00699107}, {1320,0.00703571}, {1330,0.00708036}, {1340,0.00714286}, {1350,0.00966071}, {1360,0.00722321}, {1370,0.00733036}, {1380,0.00755357}, {1390,0.00761607}, {1400,0.00771429}, {1410,0.00780357}, {1420,0.00784821}, {1430,0.00787500}, {1440,0.00809821}, {1450,0.00794643}, {1460,0.00814286}, {1470,0.00816964}, {1480,0.00836607}, {1490,0.00830357}, {1500,0.00839286}, {1510,0.00964286}, {1520,0.00855357}, {1530,0.00870536}, {1540,0.00875893}, {1550,0.00882143}, {1560,0.00884821}, {1570,0.00886607}, {1580,0.00895536}, {1590,0.00904464}, {1600,0.00920536}, {1610,0.00926786}, {1620,0.00944643}, {1630,0.00950893}, {1640,0.00959821}, {1650,0.00969643}, {1660,0.01200000}, {1670,0.00979464}, {1680,0.00981250}, {1690,0.00995536}, {1700,0.01001786}, {1710,0.01003571}, {1720,0.01016964}, {1730,0.01034821}, {1740,0.01058929}, {1750,0.01068750}, {1760,0.01216071}, {1770,0.01074107}, {1780,0.01071429}, {1790,0.01082143}, {1800,0.01093750}, {1810,0.01085714}, {1820,0.01099107}, {1830,0.01117857}, {1840,0.01126786}, {1850,0.01140179}, {1860,0.01348214}, {1870,0.01372321}, {1880,0.01325000}, {1890,0.01316071}, {1900,0.01559821}, {1910,0.01583036}, {1920,0.01412500}, {1930,0.01350000}, {1940,0.01366964}, {1950,0.01374107}, {1960,0.01216964}, {1970,0.01230357}, {1980,0.01250000}, {1990,0.01260714}, {2000,0.01267857}, {2050,0.01303571}, {2100,0.01333036}, {2150,0.01491071}, {2200,0.01408036}, {2250,0.01461607}, {2300,0.01491071}, {2350,0.01550893}, {2400,0.01745536}, {2450,0.01632143}, {2500,0.01670536}, {2550,0.02024107}, {2600,0.01750893}, {2650,0.01780357}, {2700,0.01822321}, {2750,0.01875000}, {2800,0.02027679}, {2850,0.02125893}, {2900,0.02277679}, {2950,0.02030357}, {3000,0.02069643}, {3050,0.02118750}, {3100,0.02144643}, {3150,0.02442857}, {3200,0.02225893}, {3250,0.02271429}, {3300,0.02316071}, {3350,0.02357143}, {3400,0.02400000}, {3450,0.03027679}, {3500,0.02469643}, {3550,0.02502679}, {3600,0.02818750}, {3650,0.02570536}, {3700,0.02623214}, {3750,0.02645536}, {3800,0.02696429}, {3850,0.02752679}, {3900,0.02785714}, {3950,0.02836607}, {4000,0.03239286}, {4050,0.02916071}, {4100,0.02941071}, {4150,0.03518750}, {4200,0.03025893}, {4250,0.03087500}, {4300,0.03119643}, {4350,0.03178571}, {4400,0.03217857}, {4450,0.03607143}, {4500,0.03266071}, {4550,0.03338393}, {4600,0.03385714}, {4650,0.03621429}, {4700,0.03657143}, {4750,0.03852679}, {4800,0.03789286}, {4850,0.03989286}, {4900,0.03608036}, {4950,0.03651786}, {5000,0.03696429}, {5050,0.04173214}, {5100,0.03755357}, {5150,0.03824107}, {5200,0.04097321}, {5250,0.03925000}, {5300,0.04055357}, {5350,0.04011607}, {5400,0.04048214}, {5450,0.04434821}, {5500,0.04139286}, {5550,0.04152679}, {5600,0.04217857}, {5650,0.04277679}, {5700,0.04287500}, {5750,0.04330357}, {5800,0.04425000}, {5850,0.04446429}, {5900,0.04503571}, {5950,0.04806250}, {6000,0.05025000}, {6050,0.04646429}, {6100,0.05422321}, {6150,0.04724107}, {6200,0.04743750}, {6250,0.04781250}, {6300,0.05322321}, {6350,0.04869643}, {6400,0.05141964}, {6450,0.05155357}, {6500,0.04979464}, {6550,0.05024107}, {6600,0.05044643}, {6650,0.05100000}, {6700,0.05158929}, {6750,0.05189286}, {6800,0.05285714}, {6850,0.06558036}, {6900,0.05947321}, {6950,0.05508036}, {7000,0.05434821}, {7050,0.05658036}, {7100,0.05504464}, {7150,0.05600893}, {7200,0.05584821}, {7250,0.05975000}, {7300,0.05707143}, {7350,0.05907143}, {7400,0.06433036}, {7450,0.06796429}, {7500,0.05886607}, {7550,0.05950893}, {7600,0.06000000}, {7650,0.05959821}, {7700,0.06068750}, {7750,0.06079464}, {7800,0.07588393}, {7850,0.06245536}, {7900,0.06529464}, {7950,0.06238393}, {8000,0.06608036}, {8050,0.06347321}, {8100,0.06914286}, {8150,0.06600000}, {8200,0.07032143}, {8250,0.06522321}, {8300,0.07168750}, {8350,0.06900893}, {8400,0.08149107}, {8450,0.06700000}, {8500,0.06721429}, {8550,0.06749107}, {8600,0.06811607}, {8650,0.06831250}, {8700,0.06858036}, {8750,0.08783929}, {8800,0.07385714}, {8850,0.07068750}, {8900,0.07053571}, {8950,0.07861607}, {9000,0.07572321}, {9050,0.08283929}, {9100,0.07766964}, {9150,0.07864286}, {9200,0.07219643}, {9250,0.07863393}, {9300,0.07275893}, {9350,0.07375893}, {9400,0.07390179}, {9450,0.07779464}, {9500,0.08175893}, {9550,0.08219643}, {9600,0.08101786}, {9650,0.07763393}, {9700,0.07677679}, {9750,0.09140179}, {9800,0.07992857}, {9850,0.08320536}, {9900,0.07781250}, {9950,0.08741964}, {10000,0.07923214}, {10100,0.08788393}, {10200,0.09378571}, {10300,0.08122321}, {10400,0.08641071}, {10500,0.08768750}, {10600,0.08551786}, {10700,0.08442857}, {10800,0.08884821}, {10900,0.09200893}, {11000,0.09703571}, {11100,0.09067857}, {11200,0.09264286}, {11300,0.09133036}, {11400,0.09519643}, {11500,0.09480357}, {11600,0.09968750}, {11700,0.10027679}, {11800,0.10614286}, {11900,0.10113393}, {12000,0.11632143}, {12100,0.10583036}, {12200,0.10595536}, {12300,0.10196429}, {12400,0.10250893}, {12500,0.10133036}, {12600,0.10875}, {12700,0.12175}, {12800,0.10700}, {12900,0.10525}, {13000,0.11375}, {13100,0.10450}, {13200,0.14925}, {13300,0.11125}, {13400,0.11300}, {13500,0.12775}, {13600,0.11525}, {13700,0.11575}, {13800,0.13275}, {13900,0.11525}, {14000,0.13275}, {14100,0.11750}, {14200,0.12075}, {14300,0.12400}, {14400,0.12025}, {14500,0.12125}, {14600,0.12825}, {14700,0.12125}, {14800,0.13850}, {14900,0.12525}, {15000,0.13925}, {15100,0.14000}, {15200,0.12675}, {15300,0.13100}, {15400,0.13750}, {15500,0.14800}, {15600,0.13325}, {15700,0.14950}, {15800,0.13000}, {15900,0.13375}, {16000,0.14575}, {16100,0.13875}, {16200,0.13975}, {16300,0.14300}, {16400,0.13625}, {16500,0.14375}, {16600,0.16075}, {16700,0.16525}, {16800,0.16000}, {16900,0.14600}, {17000,0.16075}, {17100,0.14400}, {17200,0.14125}, {17300,0.16150}, {17400,0.15300}, {17500,0.16875}, {17600,0.14450}, {17700,0.14375}, {17800,0.16825}, {17900,0.15550}, {18000,0.16875}, {18100,0.17125}, {18200,0.17550}, {18300,0.17800}, {18400,0.17800}, {18500,0.16900}, {18600,0.17400}, {18700,0.16025}, {18800,0.17050}, {18900,0.16675}, {19000,0.17750}, {19100,0.17275}, {19200,0.18700}, {19300,0.19250}, {19400,0.15925}, {19500,0.17850}, {19600,0.16025}, {19700,0.19825}, {19800,0.16750}, {19900,0.15975}, {20000,0.1660}};
data["big_flat"]["transitivity"]["Stats"]["user"] = {{1,0.00011504}, {2,0.00008850}, {3,0.00023009}, {4,0.00019469}, {5,0.00014159}, {6,0.00011504}, {7,0.00011504}, {8,0.00028319}, {9,0.00007965}, {10,0.00031858}, {11,0.00016814}, {12,0.00025664}, {13,0.00016814}, {14,0.00010619}, {15,0.00028319}, {16,0.00079646}, {17,0.00011504}, {18,0.00040708}, {19,0.00024779}, {20,0.00015929}, {21,0.00023894}, {22,0.00033628}, {23,0.00031858}, {24,0.00057522}, {25,0.00032743}, {26,0.00036283}, {27,0.00034513}, {28,0.00041593}, {29,0.00038938}, {30,0.00049558}, {31,0.00053982}, {32,0.00049558}, {33,0.00044248}, {34,0.00023894}, {35,0.00026549}, {36,0.00030973}, {37,0.00083186}, {38,0.00012389}, {39,0.00041593}, {40,0.00030973}, {41,0.00041593}, {42,0.00043363}, {43,0.00036283}, {44,0.00032743}, {45,0.00046903}, {46,0.00038938}, {47,0.00046903}, {48,0.00050442}, {49,0.00043363}, {50,0.00050442}, {51,0.00037168}, {52,0.00030973}, {53,0.00047788}, {54,0.00048673}, {55,0.00032743}, {56,0.00039823}, {57,0.00054867}, {58,0.00031858}, {59,0.00068142}, {60,0.00045133}, {61,0.00056637}, {62,0.00035398}, {63,0.00047788}, {64,0.00047788}, {65,0.00032743}, {66,0.00045133}, {67,0.00060177}, {68,0.00062832}, {69,0.00071681}, {70,0.00053097}, {71,0.00066372}, {72,0.00057522}, {73,0.00069027}, {74,0.00031858}, {75,0.00063717}, {76,0.00074336}, {77,0.00036283}, {78,0.00064602}, {79,0.00093805}, {80,0.00044248}, {81,0.00048673}, {82,0.00057522}, {83,0.00074336}, {84,0.00066372}, {85,0.00073451}, {86,0.00058407}, {87,0.00067257}, {88,0.00041593}, {89,0.00063717}, {90,0.00067257}, {91,0.00040708}, {92,0.00054867}, {93,0.00065487}, {94,0.00078761}, {95,0.00059292}, {96,0.00058407}, {97,0.00060177}, {98,0.00053097}, {99,0.00059292}, {100,0.00063717}, {101,0.00055752}, {102,0.00073451}, {103,0.00070796}, {104,0.00080531}, {105,0.00065487}, {106,0.00069027}, {107,0.00085841}, {108,0.00076106}, {109,0.00048673}, {110,0.00061947}, {111,0.00087611}, {112,0.00072566}, {113,0.00069912}, {114,0.00097345}, {115,0.00067257}, {116,0.00091150}, {117,0.00063717}, {118,0.00068142}, {119,0.00070796}, {120,0.00090265}, {121,0.00071681}, {122,0.00100885}, {123,0.00061947}, {124,0.00076106}, {125,0.00095575}, {126,0.00074336}, {127,0.00071681}, {128,0.00085841}, {129,0.00087611}, {130,0.00080531}, {131,0.00068142}, {132,0.00089381}, {133,0.00084956}, {134,0.00076991}, {135,0.00075221}, {136,0.00070796}, {137,0.00071681}, {138,0.00082301}, {139,0.00076106}, {140,0.00088496}, {141,0.00119469}, {142,0.00111504}, {143,0.00077876}, {144,0.00069027}, {145,0.00070796}, {146,0.00074336}, {147,0.00078761}, {148,0.00094690}, {149,0.00072566}, {150,0.00107080}, {151,0.00100885}, {152,0.00094690}, {153,0.00086726}, {154,0.00103540}, {155,0.00081416}, {156,0.00104425}, {157,0.00094690}, {158,0.00105310}, {159,0.00087611}, {160,0.00107080}, {161,0.00086726}, {162,0.00091150}, {163,0.00100000}, {164,0.00154867}, {165,0.00093805}, {166,0.00107080}, {167,0.00107965}, {168,0.00107965}, {169,0.00093805}, {170,0.00097345}, {171,0.00105310}, {172,0.00102655}, {173,0.00095575}, {174,0.00106195}, {175,0.00163717}, {176,0.00100885}, {177,0.00105310}, {178,0.00093805}, {179,0.00077876}, {180,0.00100000}, {181,0.00123894}, {182,0.00116814}, {183,0.00094690}, {184,0.00084956}, {185,0.00111504}, {186,0.00078761}, {187,0.00107080}, {188,0.00128319}, {189,0.00074336}, {190,0.00116814}, {191,0.00128319}, {192,0.00100885}, {193,0.00095575}, {194,0.00107080}, {195,0.00085841}, {196,0.00132743}, {197,0.00086726}, {198,0.00138053}, {199,0.00103540}, {200,0.00077876}, {201,0.00107080}, {202,0.00142478}, {203,0.00126549}, {204,0.00106195}, {205,0.00121239}, {206,0.00092920}, {207,0.00082301}, {208,0.00090265}, {209,0.00173451}, {210,0.00101770}, {211,0.00104425}, {212,0.00095575}, {213,0.00111504}, {214,0.00076991}, {215,0.00099115}, {216,0.00114159}, {217,0.00122124}, {218,0.00125664}, {219,0.00101770}, {220,0.00120354}, {221,0.00130973}, {222,0.00175221}, {223,0.00147788}, {224,0.00108850}, {225,0.00131858}, {226,0.00134513}, {227,0.00101770}, {228,0.00130973}, {229,0.00119469}, {230,0.00123894}, {231,0.00109735}, {232,0.00115929}, {233,0.00101770}, {234,0.00128319}, {235,0.00125664}, {236,0.00139823}, {237,0.00107965}, {238,0.00107965}, {239,0.00114159}, {240,0.00150442}, {241,0.00165487}, {242,0.00107965}, {243,0.00126549}, {244,0.00111504}, {245,0.00097345}, {246,0.00211504}, {247,0.00129204}, {248,0.00133628}, {249,0.00130973}, {250,0.00123009}, {251,0.00133628}, {252,0.00130973}, {253,0.00120354}, {254,0.00138053}, {255,0.00142478}, {256,0.00161947}, {257,0.00131858}, {258,0.00147788}, {259,0.00129204}, {260,0.00139823}, {261,0.00120354}, {262,0.00142478}, {263,0.00153097}, {264,0.00142478}, {265,0.00153982}, {266,0.00144248}, {267,0.00129204}, {268,0.00122124}, {269,0.00164602}, {270,0.00127434}, {271,0.00156637}, {272,0.00153097}, {273,0.00146018}, {274,0.00138053}, {275,0.00142478}, {276,0.00148673}, {277,0.00138938}, {278,0.00153097}, {279,0.00153982}, {280,0.00149558}, {281,0.00143363}, {282,0.00149558}, {283,0.00153097}, {284,0.00157522}, {285,0.00132743}, {286,0.00148673}, {287,0.00144248}, {288,0.00164602}, {289,0.00168142}, {290,0.00164602}, {291,0.00137168}, {292,0.00159292}, {293,0.00162832}, {294,0.00152212}, {295,0.00153097}, {296,0.00155752}, {297,0.00153982}, {298,0.00158407}, {299,0.00165487}, {300,0.00115929}, {301,0.00153097}, {302,0.00140708}, {303,0.00164602}, {304,0.00146903}, {305,0.00138938}, {306,0.00177876}, {307,0.00114159}, {308,0.00162832}, {309,0.00174336}, {310,0.00184956}, {311,0.00170796}, {312,0.00138053}, {313,0.00159292}, {314,0.00160177}, {315,0.00169027}, {316,0.00179646}, {317,0.00171681}, {318,0.00162832}, {319,0.00170796}, {320,0.00160177}, {321,0.00161947}, {322,0.00169027}, {323,0.00191150}, {324,0.00207965}, {325,0.00261062}, {326,0.00184956}, {327,0.00152212}, {328,0.00215044}, {329,0.00198230}, {330,0.00194690}, {331,0.00178761}, {332,0.00202655}, {333,0.00180531}, {334,0.00200885}, {335,0.00199115}, {336,0.00175221}, {337,0.00174336}, {338,0.00173451}, {339,0.00200000}, {340,0.00179646}, {341,0.00176106}, {342,0.00177876}, {343,0.00189381}, {344,0.00207965}, {345,0.00189381}, {346,0.00197345}, {347,0.00206195}, {348,0.00174336}, {349,0.00158407}, {350,0.00174336}, {351,0.00160177}, {352,0.00202655}, {353,0.00173451}, {354,0.00179646}, {355,0.00151327}, {356,0.00180531}, {357,0.00200885}, {358,0.00225664}, {359,0.00193805}, {360,0.00216814}, {361,0.00204425}, {362,0.00211504}, {363,0.00184071}, {364,0.00235398}, {365,0.00212389}, {366,0.00171681}, {367,0.00201770}, {368,0.00184956}, {369,0.00206195}, {370,0.00193805}, {371,0.00305310}, {372,0.00183186}, {373,0.00243363}, {374,0.00192920}, {375,0.00216814}, {376,0.00200000}, {377,0.00181416}, {378,0.00258407}, {379,0.00235398}, {380,0.00179646}, {381,0.00207965}, {382,0.00228319}, {383,0.00202655}, {384,0.00215044}, {385,0.00215929}, {386,0.00292920}, {387,0.00206195}, {388,0.00225664}, {389,0.00223009}, {390,0.00219469}, {391,0.00222124}, {392,0.00254867}, {393,0.00215929}, {394,0.00211504}, {395,0.00214159}, {396,0.00204425}, {397,0.00210619}, {398,0.00322124}, {399,0.00200885}, {400,0.00191150}, {401,0.00211504}, {402,0.00225664}, {403,0.00203540}, {404,0.00214159}, {405,0.00209735}, {406,0.00200885}, {407,0.00253982}, {408,0.00200885}, {409,0.00230088}, {410,0.00212389}, {411,0.00245133}, {412,0.00305310}, {413,0.00239823}, {414,0.00232743}, {415,0.00230088}, {416,0.00230973}, {417,0.00206195}, {418,0.00256637}, {419,0.00254867}, {420,0.00251327}, {421,0.00231858}, {422,0.00211504}, {423,0.00245133}, {424,0.00226549}, {425,0.00215044}, {426,0.00204425}, {427,0.00211504}, {428,0.00220354}, {429,0.00255752}, {430,0.00268142}, {431,0.00253982}, {432,0.00278761}, {433,0.00245133}, {434,0.00241593}, {435,0.00239823}, {436,0.00221239}, {437,0.00241593}, {438,0.00269912}, {439,0.00223894}, {440,0.00238053}, {441,0.00218584}, {442,0.00230088}, {443,0.00241593}, {444,0.00218584}, {445,0.00269027}, {446,0.00228319}, {447,0.00259292}, {448,0.00221239}, {449,0.00256637}, {450,0.00246018}, {451,0.00240708}, {452,0.00219469}, {453,0.00237168}, {454,0.00227434}, {455,0.00258407}, {456,0.00229204}, {457,0.00281416}, {458,0.00233628}, {459,0.00260177}, {460,0.00275221}, {461,0.00241593}, {462,0.00240708}, {463,0.00252212}, {464,0.00268142}, {465,0.00261062}, {466,0.00238053}, {467,0.00253982}, {468,0.00242478}, {469,0.00231858}, {470,0.00252212}, {471,0.00245133}, {472,0.00243363}, {473,0.00254867}, {474,0.00247788}, {475,0.00265487}, {476,0.00240708}, {477,0.00215929}, {478,0.00269027}, {479,0.00250442}, {480,0.00246018}, {481,0.00239823}, {482,0.00255752}, {483,0.00269912}, {484,0.00220354}, {485,0.00252212}, {486,0.00269027}, {487,0.00269912}, {488,0.00252212}, {489,0.00286726}, {490,0.00269027}, {491,0.00300000}, {492,0.00269912}, {493,0.00239823}, {494,0.00219469}, {495,0.00273451}, {496,0.00224779}, {497,0.00257522}, {498,0.00259292}, {499,0.00271681}, {500,0.00282301}, {505,0.00340708}, {510,0.00247788}, {515,0.00292035}, {520,0.00293805}, {525,0.00263717}, {530,0.00279646}, {535,0.00281416}, {540,0.00299115}, {545,0.00276106}, {550,0.00292035}, {555,0.00309735}, {560,0.00300000}, {565,0.00295575}, {570,0.00310619}, {575,0.00413274}, {580,0.00323009}, {585,0.00299115}, {590,0.00287611}, {595,0.00280531}, {600,0.00315929}, {605,0.00329204}, {610,0.00337168}, {615,0.00318584}, {620,0.00318584}, {625,0.00345133}, {630,0.00312389}, {635,0.00335398}, {640,0.00324779}, {645,0.00346903}, {650,0.00353982}, {655,0.00345133}, {660,0.00353982}, {665,0.00343363}, {670,0.00353982}, {675,0.00361062}, {680,0.00355752}, {685,0.00352212}, {690,0.00345133}, {695,0.00361062}, {700,0.00361062}, {705,0.00362832}, {710,0.00361062}, {715,0.00376106}, {720,0.00354867}, {725,0.00384071}, {730,0.00381416}, {735,0.00384956}, {740,0.00371681}, {745,0.00361947}, {750,0.00374336}, {755,0.00399115}, {760,0.00383186}, {765,0.00391150}, {770,0.00403540}, {775,0.00423009}, {780,0.00390265}, {785,0.00413274}, {790,0.00529204}, {795,0.00398214}, {800,0.00391964}, {805,0.00414286}, {810,0.00423214}, {815,0.00415179}, {820,0.00400893}, {825,0.00519643}, {830,0.00436607}, {835,0.00414286}, {840,0.00441071}, {845,0.00450000}, {850,0.00450893}, {855,0.00457143}, {860,0.00441071}, {865,0.00449107}, {870,0.00558929}, {875,0.00452679}, {880,0.00458036}, {885,0.00470536}, {890,0.00451786}, {895,0.00448214}, {900,0.00428571}, {905,0.00461607}, {910,0.00468750}, {915,0.00461607}, {920,0.00457143}, {925,0.00474107}, {930,0.00470536}, {935,0.00498214}, {940,0.00475000}, {945,0.00518750}, {950,0.00511607}, {955,0.00477679}, {960,0.00488393}, {965,0.00465179}, {970,0.00507143}, {975,0.00493750}, {980,0.00491964}, {985,0.00492857}, {990,0.00461607}, {995,0.00525000}, {1000,0.00539286}, {1010,0.00542857}, {1020,0.00515179}, {1030,0.00541071}, {1040,0.00578571}, {1050,0.00641964}, {1060,0.00590179}, {1070,0.00529464}, {1080,0.00516071}, {1090,0.00589286}, {1100,0.00608036}, {1110,0.00573214}, {1120,0.00610714}, {1130,0.00598214}, {1140,0.00608929}, {1150,0.00583036}, {1160,0.00569643}, {1170,0.00596429}, {1180,0.00615179}, {1190,0.00615179}, {1200,0.00614286}, {1210,0.00634821}, {1220,0.00655357}, {1230,0.00649107}, {1240,0.00957143}, {1250,0.00669643}, {1260,0.00660714}, {1270,0.00661607}, {1280,0.00686607}, {1290,0.00675893}, {1300,0.00873214}, {1310,0.00665179}, {1320,0.00719643}, {1330,0.00719643}, {1340,0.00712500}, {1350,0.00988393}, {1360,0.00739286}, {1370,0.00748214}, {1380,0.00764286}, {1390,0.00762500}, {1400,0.00775893}, {1410,0.00791071}, {1420,0.00783036}, {1430,0.00819643}, {1440,0.00831250}, {1450,0.00806250}, {1460,0.00827679}, {1470,0.00843750}, {1480,0.00867857}, {1490,0.00842857}, {1500,0.00849107}, {1510,0.01008929}, {1520,0.00859821}, {1530,0.00873214}, {1540,0.00909821}, {1550,0.00875893}, {1560,0.00891964}, {1570,0.00906250}, {1580,0.00921429}, {1590,0.00951786}, {1600,0.00948214}, {1610,0.00948214}, {1620,0.00990179}, {1630,0.00978571}, {1640,0.00979464}, {1650,0.01006250}, {1660,0.01226786}, {1670,0.01044643}, {1680,0.01008929}, {1690,0.01053571}, {1700,0.01049107}, {1710,0.01044643}, {1720,0.01056250}, {1730,0.01065179}, {1740,0.01070536}, {1750,0.01083036}, {1760,0.01243750}, {1770,0.01088393}, {1780,0.01082143}, {1790,0.01112500}, {1800,0.01127679}, {1810,0.01130357}, {1820,0.01150893}, {1830,0.01150000}, {1840,0.01141071}, {1850,0.01175000}, {1860,0.01351786}, {1870,0.01379464}, {1880,0.01339286}, {1890,0.01335714}, {1900,0.01556250}, {1910,0.01529464}, {1920,0.01408929}, {1930,0.01344643}, {1940,0.01379464}, {1950,0.01383929}, {1960,0.01247321}, {1970,0.01251786}, {1980,0.01287500}, {1990,0.01266964}, {2000,0.01283929}, {2050,0.01304464}, {2100,0.01333929}, {2150,0.01487500}, {2200,0.01419643}, {2250,0.01434821}, {2300,0.01477679}, {2350,0.01527679}, {2400,0.01717857}, {2450,0.01586607}, {2500,0.01628571}, {2550,0.02022321}, {2600,0.01717857}, {2650,0.01762500}, {2700,0.01833036}, {2750,0.01853571}, {2800,0.02005357}, {2850,0.02124107}, {2900,0.02278571}, {2950,0.02049107}, {3000,0.02099107}, {3050,0.02176786}, {3100,0.02122321}, {3150,0.02468750}, {3200,0.02238393}, {3250,0.02299107}, {3300,0.02311607}, {3350,0.02366964}, {3400,0.02400000}, {3450,0.03017857}, {3500,0.02491964}, {3550,0.02484821}, {3600,0.02781250}, {3650,0.02571429}, {3700,0.02609821}, {3750,0.02615179}, {3800,0.02667857}, {3850,0.02723214}, {3900,0.02753571}, {3950,0.02819643}, {4000,0.03217857}, {4050,0.02884821}, {4100,0.02932143}, {4150,0.03521429}, {4200,0.03016071}, {4250,0.03057143}, {4300,0.03126786}, {4350,0.03166071}, {4400,0.03216964}, {4450,0.03598214}, {4500,0.03257143}, {4550,0.03347321}, {4600,0.03396429}, {4650,0.03631250}, {4700,0.03671429}, {4750,0.03844643}, {4800,0.03775000}, {4850,0.03966964}, {4900,0.03635714}, {4950,0.03667857}, {5000,0.03714286}, {5050,0.04154464}, {5100,0.03765179}, {5150,0.03836607}, {5200,0.04071429}, {5250,0.03925000}, {5300,0.04045536}, {5350,0.04001786}, {5400,0.04034821}, {5450,0.04455357}, {5500,0.04133036}, {5550,0.04149107}, {5600,0.04214286}, {5650,0.04294643}, {5700,0.04266964}, {5750,0.04335714}, {5800,0.04387500}, {5850,0.04432143}, {5900,0.04520536}, {5950,0.04820536}, {6000,0.05034821}, {6050,0.04633036}, {6100,0.05408929}, {6150,0.04728571}, {6200,0.04759821}, {6250,0.04800000}, {6300,0.05291071}, {6350,0.04848214}, {6400,0.05137500}, {6450,0.05170536}, {6500,0.04987500}, {6550,0.05040179}, {6600,0.05033929}, {6650,0.05108929}, {6700,0.05160714}, {6750,0.05177679}, {6800,0.05272321}, {6850,0.06514286}, {6900,0.05958929}, {6950,0.05485714}, {7000,0.05451786}, {7050,0.05651786}, {7100,0.05513393}, {7150,0.05605357}, {7200,0.05581250}, {7250,0.05975000}, {7300,0.05719643}, {7350,0.05875893}, {7400,0.06436607}, {7450,0.06777679}, {7500,0.05883929}, {7550,0.05936607}, {7600,0.06005357}, {7650,0.05955357}, {7700,0.06085714}, {7750,0.06074107}, {7800,0.07514286}, {7850,0.06223214}, {7900,0.06483036}, {7950,0.06220536}, {8000,0.06550893}, {8050,0.06341964}, {8100,0.06925893}, {8150,0.06582143}, {8200,0.07024107}, {8250,0.06527679}, {8300,0.07168750}, {8350,0.06926786}, {8400,0.08133929}, {8450,0.06710714}, {8500,0.06733929}, {8550,0.06744643}, {8600,0.06841071}, {8650,0.06834821}, {8700,0.06885714}, {8750,0.08718750}, {8800,0.07350893}, {8850,0.07031250}, {8900,0.07095536}, {8950,0.07865179}, {9000,0.07604464}, {9050,0.08250000}, {9100,0.07766071}, {9150,0.07879464}, {9200,0.07221429}, {9250,0.07872321}, {9300,0.07273214}, {9350,0.07358036}, {9400,0.07389286}, {9450,0.07812500}, {9500,0.08169643}, {9550,0.08197321}, {9600,0.08103571}, {9650,0.07742857}, {9700,0.07723214}, {9750,0.09173214}, {9800,0.07994643}, {9850,0.08298214}, {9900,0.07833036}, {9950,0.08737500}, {10000,0.07970536}, {10100,0.08789286}, {10200,0.09386607}, {10300,0.08142857}, {10400,0.08641071}, {10500,0.08796429}, {10600,0.08578571}, {10700,0.08447321}, {10800,0.08912500}, {10900,0.09200000}, {11000,0.09727679}, {11100,0.09091964}, {11200,0.09269643}, {11300,0.09148214}, {11400,0.09479464}, {11500,0.09450893}, {11600,0.09962500}, {11700,0.10047321}, {11800,0.10600893}, {11900,0.10131250}, {12000,0.11596429}, {12100,0.10568750}, {12200,0.10575000}, {12300,0.10204464}, {12400,0.10292857}, {12500,0.10175893}, {12600,0.10975}, {12700,0.12275}, {12800,0.10650}, {12900,0.10450}, {13000,0.11300}, {13100,0.10450}, {13200,0.14950}, {13300,0.11050}, {13400,0.11250}, {13500,0.12750}, {13600,0.11550}, {13700,0.11375}, {13800,0.13225}, {13900,0.11500}, {14000,0.13225}, {14100,0.11750}, {14200,0.12075}, {14300,0.12575}, {14400,0.11975}, {14500,0.12150}, {14600,0.12550}, {14700,0.12175}, {14800,0.13775}, {14900,0.12650}, {15000,0.13525}, {15100,0.14100}, {15200,0.12775}, {15300,0.12650}, {15400,0.13775}, {15500,0.14775}, {15600,0.13350}, {15700,0.14375}, {15800,0.13100}, {15900,0.13325}, {16000,0.14100}, {16100,0.13550}, {16200,0.13750}, {16300,0.13975}, {16400,0.13525}, {16500,0.14475}, {16600,0.15900}, {16700,0.16275}, {16800,0.15750}, {16900,0.14525}, {17000,0.15950}, {17100,0.13950}, {17200,0.14175}, {17300,0.15900}, {17400,0.15275}, {17500,0.16750}, {17600,0.14375}, {17700,0.14325}, {17800,0.16750}, {17900,0.15575}, {18000,0.16875}, {18100,0.17150}, {18200,0.17450}, {18300,0.17875}, {18400,0.17875}, {18500,0.16825}, {18600,0.17125}, {18700,0.16025}, {18800,0.17075}, {18900,0.16625}, {19000,0.17775}, {19100,0.17350}, {19200,0.18750}, {19300,0.19300}, {19400,0.15875}, {19500,0.17925}, {19600,0.15925}, {19700,0.19750}, {19800,0.16725}, {19900,0.15975}, {20000,0.1655}};
data["big_flat"]["transitivity"]["Stats"]["system"] = {{1,0.00003540}, {2,0.00002655}, {3,0.00000000}, {4,0.00000000}, {5,0.00003540}, {6,0.00000000}, {7,0.00003540}, {8,0.00000000}, {9,0.00000000}, {10,0.00000000}, {11,0.00003540}, {12,0.00000000}, {13,0.00000000}, {14,0.00000000}, {15,0.00000000}, {16,0.00000000}, {17,0.00000000}, {18,0.00000000}, {19,0.00000000}, {20,0.00000000}, {21,0.00000000}, {22,0.00000000}, {23,0.00003540}, {24,0.00003540}, {25,0.00000000}, {26,0.00000000}, {27,0.00006195}, {28,0.00000000}, {29,0.00000000}, {30,0.00000000}, {31,0.00000000}, {32,0.00000000}, {33,0.00003540}, {34,0.00000000}, {35,0.00000000}, {36,0.00003540}, {37,0.00000000}, {38,0.00000000}, {39,0.00000000}, {40,0.00000000}, {41,0.00000000}, {42,0.00000000}, {43,0.00000000}, {44,0.00000000}, {45,0.00000000}, {46,0.00000000}, {47,0.00000000}, {48,0.00000000}, {49,0.00000000}, {50,0.00000000}, {51,0.00000000}, {52,0.00000000}, {53,0.00000000}, {54,0.00003540}, {55,0.00000000}, {56,0.00000000}, {57,0.00000000}, {58,0.00000000}, {59,0.00000000}, {60,0.00003540}, {61,0.00000000}, {62,0.00003540}, {63,0.00000000}, {64,0.00000000}, {65,0.00000000}, {66,0.00000000}, {67,0.00000000}, {68,0.00003540}, {69,0.00000000}, {70,0.00003540}, {71,0.00000000}, {72,0.00000000}, {73,0.00000000}, {74,0.00002655}, {75,0.00000000}, {76,0.00000000}, {77,0.00000000}, {78,0.00000000}, {79,0.00000000}, {80,0.00000000}, {81,0.00000000}, {82,0.00000000}, {83,0.00000000}, {84,0.00000000}, {85,0.00000000}, {86,0.00000000}, {87,0.00000000}, {88,0.00002655}, {89,0.00000000}, {90,0.00003540}, {91,0.00000000}, {92,0.00003540}, {93,0.00000000}, {94,0.00000000}, {95,0.00003540}, {96,0.00000000}, {97,0.00000000}, {98,0.00000000}, {99,0.00000000}, {100,0.00000000}, {101,0.00000000}, {102,0.00000000}, {103,0.00000000}, {104,0.00000000}, {105,0.00000000}, {106,0.00000000}, {107,0.00000000}, {108,0.00000000}, {109,0.00007080}, {110,0.00000000}, {111,0.00000000}, {112,0.00006195}, {113,0.00000000}, {114,0.00000000}, {115,0.00000000}, {116,0.00000000}, {117,0.00000000}, {118,0.00000000}, {119,0.00000000}, {120,0.00000000}, {121,0.00000000}, {122,0.00000000}, {123,0.00000000}, {124,0.00000000}, {125,0.00000000}, {126,0.00000000}, {127,0.00000000}, {128,0.00000000}, {129,0.00000000}, {130,0.00000000}, {131,0.00000000}, {132,0.00000000}, {133,0.00000000}, {134,0.00003540}, {135,0.00000000}, {136,0.00000000}, {137,0.00000000}, {138,0.00000000}, {139,0.00000000}, {140,0.00003540}, {141,0.00000000}, {142,0.00000000}, {143,0.00000000}, {144,0.00003540}, {145,0.00000000}, {146,0.00000000}, {147,0.00002655}, {148,0.00000000}, {149,0.00000000}, {150,0.00000000}, {151,0.00000000}, {152,0.00002655}, {153,0.00000000}, {154,0.00000000}, {155,0.00000000}, {156,0.00000000}, {157,0.00000000}, {158,0.00000000}, {159,0.00003540}, {160,0.00000000}, {161,0.00003540}, {162,0.00000000}, {163,0.00000000}, {164,0.00003540}, {165,0.00000000}, {166,0.00000000}, {167,0.00000000}, {168,0.00000000}, {169,0.00000000}, {170,0.00000000}, {171,0.00000000}, {172,0.00003540}, {173,0.00000000}, {174,0.00003540}, {175,0.00000000}, {176,0.00000000}, {177,0.00000000}, {178,0.00003540}, {179,0.00003540}, {180,0.00000000}, {181,0.00000000}, {182,0.00000000}, {183,0.00000000}, {184,0.00000000}, {185,0.00000000}, {186,0.00000000}, {187,0.00007080}, {188,0.00000000}, {189,0.00000000}, {190,0.00000000}, {191,0.00000000}, {192,0.00007080}, {193,0.00000000}, {194,0.00000000}, {195,0.00000000}, {196,0.00003540}, {197,0.00000000}, {198,0.00000000}, {199,0.00000000}, {200,0.00003540}, {201,0.00000000}, {202,0.00000000}, {203,0.00003540}, {204,0.00000000}, {205,0.00000000}, {206,0.00000000}, {207,0.00003540}, {208,0.00003540}, {209,0.00003540}, {210,0.00000000}, {211,0.00000000}, {212,0.00007080}, {213,0.00007080}, {214,0.00000000}, {215,0.00000000}, {216,0.00000000}, {217,0.00000000}, {218,0.00000000}, {219,0.00003540}, {220,0.00000000}, {221,0.00000000}, {222,0.00003540}, {223,0.00000000}, {224,0.00000000}, {225,0.00000000}, {226,0.00003540}, {227,0.00002655}, {228,0.00000000}, {229,0.00000000}, {230,0.00003540}, {231,0.00000000}, {232,0.00003540}, {233,0.00003540}, {234,0.00000000}, {235,0.00000000}, {236,0.00000000}, {237,0.00000000}, {238,0.00000000}, {239,0.00000000}, {240,0.00000000}, {241,0.00003540}, {242,0.00000000}, {243,0.00000000}, {244,0.00000000}, {245,0.00000000}, {246,0.00006195}, {247,0.00000000}, {248,0.00000000}, {249,0.00003540}, {250,0.00000000}, {251,0.00000000}, {252,0.00000000}, {253,0.00000000}, {254,0.00007080}, {255,0.00000000}, {256,0.00000000}, {257,0.00003540}, {258,0.00000000}, {259,0.00000000}, {260,0.00000000}, {261,0.00009735}, {262,0.00000000}, {263,0.00003540}, {264,0.00000000}, {265,0.00000000}, {266,0.00000000}, {267,0.00000000}, {268,0.00002655}, {269,0.00000000}, {270,0.00000000}, {271,0.00000000}, {272,0.00000000}, {273,0.00000000}, {274,0.00003540}, {275,0.00003540}, {276,0.00000000}, {277,0.00000000}, {278,0.00000000}, {279,0.00003540}, {280,0.00000000}, {281,0.00000000}, {282,0.00002655}, {283,0.00000000}, {284,0.00003540}, {285,0.00000000}, {286,0.00000000}, {287,0.00000000}, {288,0.00003540}, {289,0.00000000}, {290,0.00000000}, {291,0.00000000}, {292,0.00000000}, {293,0.00003540}, {294,0.00000000}, {295,0.00000000}, {296,0.00000000}, {297,0.00000000}, {298,0.00002655}, {299,0.00000000}, {300,0.00003540}, {301,0.00003540}, {302,0.00000000}, {303,0.00000000}, {304,0.00000000}, {305,0.00003540}, {306,0.00003540}, {307,0.00003540}, {308,0.00000000}, {309,0.00003540}, {310,0.00003540}, {311,0.00000000}, {312,0.00000000}, {313,0.00003540}, {314,0.00000000}, {315,0.00000000}, {316,0.00000000}, {317,0.00000000}, {318,0.00000000}, {319,0.00000000}, {320,0.00000000}, {321,0.00003540}, {322,0.00000000}, {323,0.00000000}, {324,0.00003540}, {325,0.00003540}, {326,0.00000000}, {327,0.00000000}, {328,0.00000000}, {329,0.00000000}, {330,0.00000000}, {331,0.00000000}, {332,0.00000000}, {333,0.00003540}, {334,0.00003540}, {335,0.00000000}, {336,0.00000000}, {337,0.00000000}, {338,0.00003540}, {339,0.00000000}, {340,0.00000000}, {341,0.00013274}, {342,0.00000000}, {343,0.00000000}, {344,0.00003540}, {345,0.00003540}, {346,0.00000000}, {347,0.00000000}, {348,0.00000000}, {349,0.00000000}, {350,0.00000000}, {351,0.00000000}, {352,0.00000000}, {353,0.00000000}, {354,0.00002655}, {355,0.00000000}, {356,0.00000000}, {357,0.00000000}, {358,0.00000000}, {359,0.00003540}, {360,0.00000000}, {361,0.00003540}, {362,0.00000000}, {363,0.00003540}, {364,0.00003540}, {365,0.00000000}, {366,0.00000000}, {367,0.00000000}, {368,0.00000000}, {369,0.00000000}, {370,0.00003540}, {371,0.00000000}, {372,0.00000000}, {373,0.00003540}, {374,0.00003540}, {375,0.00000000}, {376,0.00000000}, {377,0.00003540}, {378,0.00000000}, {379,0.00003540}, {380,0.00000000}, {381,0.00000000}, {382,0.00000000}, {383,0.00003540}, {384,0.00000000}, {385,0.00000000}, {386,0.00003540}, {387,0.00000000}, {388,0.00000000}, {389,0.00003540}, {390,0.00007080}, {391,0.00000000}, {392,0.00000000}, {393,0.00000000}, {394,0.00003540}, {395,0.00000000}, {396,0.00000000}, {397,0.00003540}, {398,0.00000000}, {399,0.00000000}, {400,0.00003540}, {401,0.00003540}, {402,0.00000000}, {403,0.00000000}, {404,0.00000000}, {405,0.00000000}, {406,0.00000000}, {407,0.00003540}, {408,0.00000000}, {409,0.00000000}, {410,0.00000000}, {411,0.00000000}, {412,0.00000000}, {413,0.00000000}, {414,0.00003540}, {415,0.00003540}, {416,0.00000000}, {417,0.00007080}, {418,0.00000000}, {419,0.00000000}, {420,0.00000000}, {421,0.00007080}, {422,0.00000000}, {423,0.00003540}, {424,0.00003540}, {425,0.00003540}, {426,0.00000000}, {427,0.00002655}, {428,0.00000000}, {429,0.00000000}, {430,0.00000000}, {431,0.00003540}, {432,0.00000000}, {433,0.00003540}, {434,0.00000000}, {435,0.00000000}, {436,0.00000000}, {437,0.00000000}, {438,0.00003540}, {439,0.00000000}, {440,0.00003540}, {441,0.00003540}, {442,0.00003540}, {443,0.00000000}, {444,0.00000000}, {445,0.00000000}, {446,0.00000000}, {447,0.00000000}, {448,0.00003540}, {449,0.00003540}, {450,0.00000000}, {451,0.00000000}, {452,0.00003540}, {453,0.00000000}, {454,0.00003540}, {455,0.00000000}, {456,0.00000000}, {457,0.00000000}, {458,0.00000000}, {459,0.00000000}, {460,0.00002655}, {461,0.00000000}, {462,0.00000000}, {463,0.00000000}, {464,0.00003540}, {465,0.00000000}, {466,0.00000000}, {467,0.00000000}, {468,0.00002655}, {469,0.00000000}, {470,0.00000000}, {471,0.00000000}, {472,0.00000000}, {473,0.00000000}, {474,0.00003540}, {475,0.00000000}, {476,0.00000000}, {477,0.00007080}, {478,0.00000000}, {479,0.00000000}, {480,0.00000000}, {481,0.00003540}, {482,0.00000000}, {483,0.00000000}, {484,0.00003540}, {485,0.00000000}, {486,0.00000000}, {487,0.00000000}, {488,0.00003540}, {489,0.00003540}, {490,0.00000000}, {491,0.00000000}, {492,0.00000000}, {493,0.00003540}, {494,0.00002655}, {495,0.00003540}, {496,0.00003540}, {497,0.00000000}, {498,0.00000000}, {499,0.00000000}, {500,0.00003540}, {505,0.00000000}, {510,0.00000000}, {515,0.00000000}, {520,0.00000000}, {525,0.00003540}, {530,0.00003540}, {535,0.00003540}, {540,0.00000000}, {545,0.00000000}, {550,0.00000000}, {555,0.00000000}, {560,0.00000000}, {565,0.00003540}, {570,0.00000000}, {575,0.00000000}, {580,0.00000000}, {585,0.00000000}, {590,0.00000000}, {595,0.00000000}, {600,0.00002655}, {605,0.00000000}, {610,0.00003540}, {615,0.00003540}, {620,0.00007080}, {625,0.00000000}, {630,0.00000000}, {635,0.00003540}, {640,0.00002655}, {645,0.00000000}, {650,0.00000000}, {655,0.00003540}, {660,0.00000000}, {665,0.00003540}, {670,0.00003540}, {675,0.00000000}, {680,0.00000000}, {685,0.00000000}, {690,0.00006195}, {695,0.00003540}, {700,0.00000000}, {705,0.00006195}, {710,0.00000000}, {715,0.00000000}, {720,0.00003540}, {725,0.00000000}, {730,0.00000000}, {735,0.00000000}, {740,0.00000000}, {745,0.00000000}, {750,0.00003540}, {755,0.00000000}, {760,0.00000000}, {765,0.00003540}, {770,0.00000000}, {775,0.00000000}, {780,0.00003540}, {785,0.00003540}, {790,0.00000000}, {795,0.00000000}, {800,0.00003571}, {805,0.00003571}, {810,0.00003571}, {815,0.00000000}, {820,0.00007143}, {825,0.00003571}, {830,0.00000000}, {835,0.00007143}, {840,0.00003571}, {845,0.00000000}, {850,0.00000000}, {855,0.00003571}, {860,0.00003571}, {865,0.00000000}, {870,0.00003571}, {875,0.00003571}, {880,0.00000000}, {885,0.00000000}, {890,0.00000000}, {895,0.00000000}, {900,0.00007143}, {905,0.00000000}, {910,0.00000000}, {915,0.00007143}, {920,0.00003571}, {925,0.00000000}, {930,0.00000000}, {935,0.00014286}, {940,0.00003571}, {945,0.00002679}, {950,0.00007143}, {955,0.00003571}, {960,0.00007143}, {965,0.00010714}, {970,0.00002679}, {975,0.00003571}, {980,0.00003571}, {985,0.00000000}, {990,0.00000000}, {995,0.00000000}, {1000,0.00000000}, {1010,0.00003571}, {1020,0.00000000}, {1030,0.00003571}, {1040,0.00003571}, {1050,0.00006250}, {1060,0.00000000}, {1070,0.00000000}, {1080,0.00006250}, {1090,0.00000000}, {1100,0.00000000}, {1110,0.00000000}, {1120,0.00007143}, {1130,0.00000000}, {1140,0.00007143}, {1150,0.00000000}, {1160,0.00007143}, {1170,0.00000000}, {1180,0.00003571}, {1190,0.00000000}, {1200,0.00003571}, {1210,0.00000000}, {1220,0.00000000}, {1230,0.00003571}, {1240,0.00010714}, {1250,0.00007143}, {1260,0.00000000}, {1270,0.00007143}, {1280,0.00006250}, {1290,0.00010714}, {1300,0.00000000}, {1310,0.00003571}, {1320,0.00000000}, {1330,0.00000000}, {1340,0.00002679}, {1350,0.00000000}, {1360,0.00000000}, {1370,0.00002679}, {1380,0.00003571}, {1390,0.00000000}, {1400,0.00000000}, {1410,0.00003571}, {1420,0.00000000}, {1430,0.00000000}, {1440,0.00000000}, {1450,0.00000000}, {1460,0.00002679}, {1470,0.00000000}, {1480,0.00000000}, {1490,0.00007143}, {1500,0.00003571}, {1510,0.00000000}, {1520,0.00000000}, {1530,0.00000000}, {1540,0.00000000}, {1550,0.00000000}, {1560,0.00000000}, {1570,0.00000000}, {1580,0.00003571}, {1590,0.00000000}, {1600,0.00000000}, {1610,0.00000000}, {1620,0.00000000}, {1630,0.00003571}, {1640,0.00000000}, {1650,0.00003571}, {1660,0.00003571}, {1670,0.00000000}, {1680,0.00000000}, {1690,0.00000000}, {1700,0.00003571}, {1710,0.00000000}, {1720,0.00000000}, {1730,0.00000000}, {1740,0.00002679}, {1750,0.00000000}, {1760,0.00003571}, {1770,0.00000000}, {1780,0.00000000}, {1790,0.00003571}, {1800,0.00003571}, {1810,0.00002679}, {1820,0.00003571}, {1830,0.00000000}, {1840,0.00000000}, {1850,0.00000000}, {1860,0.00007143}, {1870,0.00002679}, {1880,0.00003571}, {1890,0.00000000}, {1900,0.00010714}, {1910,0.00016964}, {1920,0.00007143}, {1930,0.00003571}, {1940,0.00003571}, {1950,0.00007143}, {1960,0.00003571}, {1970,0.00000000}, {1980,0.00003571}, {1990,0.00003571}, {2000,0.00003571}, {2050,0.00000000}, {2100,0.00000000}, {2150,0.00007143}, {2200,0.00000000}, {2250,0.00000000}, {2300,0.00000000}, {2350,0.00000000}, {2400,0.00007143}, {2450,0.00000000}, {2500,0.00008929}, {2550,0.00010714}, {2600,0.00010714}, {2650,0.00000000}, {2700,0.00000000}, {2750,0.00003571}, {2800,0.00000000}, {2850,0.00000000}, {2900,0.00013393}, {2950,0.00000000}, {3000,0.00000000}, {3050,0.00003571}, {3100,0.00000000}, {3150,0.00000000}, {3200,0.00003571}, {3250,0.00003571}, {3300,0.00002679}, {3350,0.00000000}, {3400,0.00007143}, {3450,0.00003571}, {3500,0.00003571}, {3550,0.00000000}, {3600,0.00010714}, {3650,0.00003571}, {3700,0.00000000}, {3750,0.00000000}, {3800,0.00000000}, {3850,0.00007143}, {3900,0.00000000}, {3950,0.00000000}, {4000,0.00000000}, {4050,0.00003571}, {4100,0.00000000}, {4150,0.00013393}, {4200,0.00000000}, {4250,0.00000000}, {4300,0.00000000}, {4350,0.00000000}, {4400,0.00000000}, {4450,0.00003571}, {4500,0.00003571}, {4550,0.00007143}, {4600,0.00000000}, {4650,0.00014286}, {4700,0.00000000}, {4750,0.00007143}, {4800,0.00000000}, {4850,0.00010714}, {4900,0.00003571}, {4950,0.00003571}, {5000,0.00007143}, {5050,0.00003571}, {5100,0.00000000}, {5150,0.00007143}, {5200,0.00007143}, {5250,0.00000000}, {5300,0.00000000}, {5350,0.00006250}, {5400,0.00003571}, {5450,0.00009821}, {5500,0.00000000}, {5550,0.00000000}, {5600,0.00003571}, {5650,0.00003571}, {5700,0.00003571}, {5750,0.00000000}, {5800,0.00000000}, {5850,0.00003571}, {5900,0.00000000}, {5950,0.00006250}, {6000,0.00007143}, {6050,0.00002679}, {6100,0.00016964}, {6150,0.00003571}, {6200,0.00003571}, {6250,0.00000000}, {6300,0.00003571}, {6350,0.00000000}, {6400,0.00003571}, {6450,0.00003571}, {6500,0.00000000}, {6550,0.00000000}, {6600,0.00003571}, {6650,0.00000000}, {6700,0.00000000}, {6750,0.00014286}, {6800,0.00000000}, {6850,0.00045536}, {6900,0.00007143}, {6950,0.00007143}, {7000,0.00009821}, {7050,0.00003571}, {7100,0.00003571}, {7150,0.00007143}, {7200,0.00003571}, {7250,0.00007143}, {7300,0.00000000}, {7350,0.00007143}, {7400,0.00002679}, {7450,0.00025000}, {7500,0.00007143}, {7550,0.00000000}, {7600,0.00003571}, {7650,0.00003571}, {7700,0.00000000}, {7750,0.00003571}, {7800,0.00027679}, {7850,0.00003571}, {7900,0.00016964}, {7950,0.00000000}, {8000,0.00007143}, {8050,0.00000000}, {8100,0.00017857}, {8150,0.00003571}, {8200,0.00017857}, {8250,0.00003571}, {8300,0.00021429}, {8350,0.00010714}, {8400,0.00026786}, {8450,0.00003571}, {8500,0.00003571}, {8550,0.00000000}, {8600,0.00003571}, {8650,0.00010714}, {8700,0.00003571}, {8750,0.00061607}, {8800,0.00017857}, {8850,0.00010714}, {8900,0.00007143}, {8950,0.00031250}, {9000,0.00007143}, {9050,0.00030357}, {9100,0.00003571}, {9150,0.00014286}, {9200,0.00000000}, {9250,0.00025000}, {9300,0.00007143}, {9350,0.00003571}, {9400,0.00000000}, {9450,0.00003571}, {9500,0.00003571}, {9550,0.00000000}, {9600,0.00000000}, {9650,0.00002679}, {9700,0.00000000}, {9750,0.00000000}, {9800,0.00007143}, {9850,0.00000000}, {9900,0.00003571}, {9950,0.00003571}, {10000,0.00000000}, {10100,0.00003571}, {10200,0.00002679}, {10300,0.00003571}, {10400,0.00003571}, {10500,0.00000000}, {10600,0.00000000}, {10700,0.00003571}, {10800,0.00003571}, {10900,0.00007143}, {11000,0.00000000}, {11100,0.00003571}, {11200,0.00003571}, {11300,0.00000000}, {11400,0.00000000}, {11500,0.00000000}, {11600,0.00003571}, {11700,0.00000000}, {11800,0.00002679}, {11900,0.00000000}, {12000,0.00007143}, {12100,0.00002679}, {12200,0.00000000}, {12300,0.00003571}, {12400,0.00000000}, {12500,0.00000000}, {12600,0.00000}, {12700,0.00000}, {12800,0.00100}, {12900,0.00000}, {13000,0.00000}, {13100,0.00000}, {13200,0.00000}, {13300,0.00000}, {13400,0.00000}, {13500,0.00000}, {13600,0.00000}, {13700,0.00100}, {13800,0.00000}, {13900,0.00000}, {14000,0.00000}, {14100,0.00000}, {14200,0.00000}, {14300,0.00000}, {14400,0.00000}, {14500,0.00000}, {14600,0.00100}, {14700,0.00000}, {14800,0.00000}, {14900,0.00000}, {15000,0.00200}, {15100,0.00000}, {15200,0.00000}, {15300,0.00000}, {15400,0.00000}, {15500,0.00200}, {15600,0.00000}, {15700,0.00100}, {15800,0.00000}, {15900,0.00000}, {16000,0.00000}, {16100,0.00000}, {16200,0.00000}, {16300,0.00000}, {16400,0.00000}, {16500,0.00000}, {16600,0.00000}, {16700,0.00000}, {16800,0.00000}, {16900,0.00000}, {17000,0.00000}, {17100,0.00000}, {17200,0.00000}, {17300,0.00000}, {17400,0.00000}, {17500,0.00000}, {17600,0.00000}, {17700,0.00000}, {17800,0.00000}, {17900,0.00000}, {18000,0.00075}, {18100,0.00000}, {18200,0.00000}, {18300,0.00000}, {18400,0.00000}, {18500,0.00000}, {18600,0.00100}, {18700,0.00000}, {18800,0.00000}, {18900,0.00100}, {19000,0.00075}, {19100,0.00000}, {19200,0.00000}, {19300,0.00000}, {19400,0.00100}, {19500,0.00000}, {19600,0.00000}, {19700,0.00000}, {19800,0.00000}, {19900,0.00000}, {20000,0.0000}};

